var Module = {};
var preloadComplete = false;

Module['noInitialRun'] = true;
Module['OpenModelica_readFile'] = function(fname) {
  return intArrayToString(FS.findObject(fname).contents);
};
Module['OpenModelica_readFileBuffer'] = function(fname) {
  return FS.findObject(fname).contents;
};

try { // Try to add an event listener like a webworker thread
  self.addEventListener('message', function(e) {
    var data = e.data;
    if (!data) return;
    if (data.preload) {
      var error = function() {console.log('error...'); /* self.postError({message: "Preload failed"}); */ };
      if (!preloadComplete) {
        FS.createPreloadedFile('/', data.basename + "_init.xml", data.basename + "_init.xml", true, false, function() {
        FS.createLazyFile('/', data.basename + "_info.xml", data.basename + "_info.xml", true, false);
        preloadComplete = true;
        self.postMessage({preloaded:true});
      }, error);
      } else {
        self.postMessage({preloaded:true});
      }
      return;
    }
    var result = {};
    result.status = "Simulation failed"
    try {
      shouldRunNow = true;
      var args = ['-override','outputFormat=csv,stopTime=' +  data.stopTime +',tolerance=' + data.tolerance + ',stepSize=' + data.stepSize];
      Module.callMain(args);
      result.csv = intArrayToString(FS.findObject(data.basename + "_res.csv").contents);
      result.status = "Simulation finished";

  } catch(e) {
  }
  self.postMessage(result);
  }, false);
} catch (e) {
}

// The Module object: Our interface to the outside world. We import
// and export values on it, and do the work to get that through
// closure compiler if necessary. There are various ways Module can be used:
// 1. Not defined. We create it here
// 2. A function parameter, function(Module) { ..generated code.. }
// 3. pre-run appended it, var Module = {}; ..generated code..
// 4. External script tag defines var Module.
// We need to do an eval in order to handle the closure compiler
// case, where this code here is minified but Module was defined
// elsewhere (e.g. case 4 above). We also need to check if Module
// already exists (e.g. case 3 above).
// Note that if you want to run closure, and also to use Module
// after the generated code, you will need to define   var Module = {};
// before the code. Then that object will be used in the code, and you
// can continue to use Module afterwards as well.
var Module;
if (!Module) Module = eval('(function() { try { return Module || {} } catch(e) { return {} } })()');

// Sometimes an existing Module object exists with properties
// meant to overwrite the default module functionality. Here
// we collect those properties and reapply _after_ we configure
// the current environment's defaults to avoid having to be so
// defensive during initialization.
var moduleOverrides = {};
for (var key in Module) {
  if (Module.hasOwnProperty(key)) {
    moduleOverrides[key] = Module[key];
  }
}

// The environment setup code below is customized to use Module.
// *** Environment setup code ***
var ENVIRONMENT_IS_NODE = typeof process === 'object' && typeof require === 'function';
var ENVIRONMENT_IS_WEB = typeof window === 'object';
var ENVIRONMENT_IS_WORKER = typeof importScripts === 'function';
var ENVIRONMENT_IS_SHELL = !ENVIRONMENT_IS_WEB && !ENVIRONMENT_IS_NODE && !ENVIRONMENT_IS_WORKER;

if (ENVIRONMENT_IS_NODE) {
  // Expose functionality in the same simple way that the shells work
  // Note that we pollute the global namespace here, otherwise we break in node
  if (!Module['print']) Module['print'] = function print(x) {
    process['stdout'].write(x + '\n');
  };
  if (!Module['printErr']) Module['printErr'] = function printErr(x) {
    process['stderr'].write(x + '\n');
  };

  var nodeFS = require('fs');
  var nodePath = require('path');

  Module['read'] = function read(filename, binary) {
    filename = nodePath['normalize'](filename);
    var ret = nodeFS['readFileSync'](filename);
    // The path is absolute if the normalized version is the same as the resolved.
    if (!ret && filename != nodePath['resolve'](filename)) {
      filename = path.join(__dirname, '..', 'src', filename);
      ret = nodeFS['readFileSync'](filename);
    }
    if (ret && !binary) ret = ret.toString();
    return ret;
  };

  Module['readBinary'] = function readBinary(filename) { return Module['read'](filename, true) };

  Module['load'] = function load(f) {
    globalEval(read(f));
  };

  Module['arguments'] = process['argv'].slice(2);

  module['exports'] = Module;
}
else if (ENVIRONMENT_IS_SHELL) {
  if (!Module['print']) Module['print'] = print;
  if (typeof printErr != 'undefined') Module['printErr'] = printErr; // not present in v8 or older sm

  if (typeof read != 'undefined') {
    Module['read'] = read;
  } else {
    Module['read'] = function read() { throw 'no read() available (jsc?)' };
  }

  Module['readBinary'] = function readBinary(f) {
    return read(f, 'binary');
  };

  if (typeof scriptArgs != 'undefined') {
    Module['arguments'] = scriptArgs;
  } else if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  this['Module'] = Module;

  eval("if (typeof gc === 'function' && gc.toString().indexOf('[native code]') > 0) var gc = undefined"); // wipe out the SpiderMonkey shell 'gc' function, which can confuse closure (uses it as a minified name, and it is then initted to a non-falsey value unexpectedly)
}
else if (ENVIRONMENT_IS_WEB || ENVIRONMENT_IS_WORKER) {
  Module['read'] = function read(url) {
    var xhr = new XMLHttpRequest();
    xhr.open('GET', url, false);
    xhr.send(null);
    return xhr.responseText;
  };

  if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  if (typeof console !== 'undefined') {
    if (!Module['print']) Module['print'] = function print(x) {
      console.log(x);
    };
    if (!Module['printErr']) Module['printErr'] = function printErr(x) {
      console.log(x);
    };
  } else {
    // Probably a worker, and without console.log. We can do very little here...
    var TRY_USE_DUMP = false;
    if (!Module['print']) Module['print'] = (TRY_USE_DUMP && (typeof(dump) !== "undefined") ? (function(x) {
      dump(x);
    }) : (function(x) {
      // self.postMessage(x); // enable this if you want stdout to be sent as messages
    }));
  }

  if (ENVIRONMENT_IS_WEB) {
    this['Module'] = Module;
  } else {
    Module['load'] = importScripts;
  }
}
else {
  // Unreachable because SHELL is dependant on the others
  throw 'Unknown runtime environment. Where are we?';
}

function globalEval(x) {
  eval.call(null, x);
}
if (!Module['load'] == 'undefined' && Module['read']) {
  Module['load'] = function load(f) {
    globalEval(Module['read'](f));
  };
}
if (!Module['print']) {
  Module['print'] = function(){};
}
if (!Module['printErr']) {
  Module['printErr'] = Module['print'];
}
if (!Module['arguments']) {
  Module['arguments'] = [];
}
// *** Environment setup code ***

// Closure helpers
Module.print = Module['print'];
Module.printErr = Module['printErr'];

// Callbacks
Module['preRun'] = [];
Module['postRun'] = [];

// Merge back in the overrides
for (var key in moduleOverrides) {
  if (moduleOverrides.hasOwnProperty(key)) {
    Module[key] = moduleOverrides[key];
  }
}



// === Auto-generated preamble library stuff ===

//========================================
// Runtime code shared with compiler
//========================================

var Runtime = {
  stackSave: function () {
    return STACKTOP;
  },
  stackRestore: function (stackTop) {
    STACKTOP = stackTop;
  },
  forceAlign: function (target, quantum) {
    quantum = quantum || 4;
    if (quantum == 1) return target;
    if (isNumber(target) && isNumber(quantum)) {
      return Math.ceil(target/quantum)*quantum;
    } else if (isNumber(quantum) && isPowerOfTwo(quantum)) {
      return '(((' +target + ')+' + (quantum-1) + ')&' + -quantum + ')';
    }
    return 'Math.ceil((' + target + ')/' + quantum + ')*' + quantum;
  },
  isNumberType: function (type) {
    return type in Runtime.INT_TYPES || type in Runtime.FLOAT_TYPES;
  },
  isPointerType: function isPointerType(type) {
  return type[type.length-1] == '*';
},
  isStructType: function isStructType(type) {
  if (isPointerType(type)) return false;
  if (isArrayType(type)) return true;
  if (/<?\{ ?[^}]* ?\}>?/.test(type)) return true; // { i32, i8 } etc. - anonymous struct types
  // See comment in isStructPointerType()
  return type[0] == '%';
},
  INT_TYPES: {"i1":0,"i8":0,"i16":0,"i32":0,"i64":0},
  FLOAT_TYPES: {"float":0,"double":0},
  or64: function (x, y) {
    var l = (x | 0) | (y | 0);
    var h = (Math.round(x / 4294967296) | Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  and64: function (x, y) {
    var l = (x | 0) & (y | 0);
    var h = (Math.round(x / 4294967296) & Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  xor64: function (x, y) {
    var l = (x | 0) ^ (y | 0);
    var h = (Math.round(x / 4294967296) ^ Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  getNativeTypeSize: function (type) {
    switch (type) {
      case 'i1': case 'i8': return 1;
      case 'i16': return 2;
      case 'i32': return 4;
      case 'i64': return 8;
      case 'float': return 4;
      case 'double': return 8;
      default: {
        if (type[type.length-1] === '*') {
          return Runtime.QUANTUM_SIZE; // A pointer
        } else if (type[0] === 'i') {
          var bits = parseInt(type.substr(1));
          assert(bits % 8 === 0);
          return bits/8;
        } else {
          return 0;
        }
      }
    }
  },
  getNativeFieldSize: function (type) {
    return Math.max(Runtime.getNativeTypeSize(type), Runtime.QUANTUM_SIZE);
  },
  dedup: function dedup(items, ident) {
  var seen = {};
  if (ident) {
    return items.filter(function(item) {
      if (seen[item[ident]]) return false;
      seen[item[ident]] = true;
      return true;
    });
  } else {
    return items.filter(function(item) {
      if (seen[item]) return false;
      seen[item] = true;
      return true;
    });
  }
},
  set: function set() {
  var args = typeof arguments[0] === 'object' ? arguments[0] : arguments;
  var ret = {};
  for (var i = 0; i < args.length; i++) {
    ret[args[i]] = 0;
  }
  return ret;
},
  STACK_ALIGN: 8,
  getAlignSize: function (type, size, vararg) {
    // we align i64s and doubles on 64-bit boundaries, unlike x86
    if (!vararg && (type == 'i64' || type == 'double')) return 8;
    if (!type) return Math.min(size, 8); // align structures internally to 64 bits
    return Math.min(size || (type ? Runtime.getNativeFieldSize(type) : 0), Runtime.QUANTUM_SIZE);
  },
  calculateStructAlignment: function calculateStructAlignment(type) {
    type.flatSize = 0;
    type.alignSize = 0;
    var diffs = [];
    var prev = -1;
    var index = 0;
    type.flatIndexes = type.fields.map(function(field) {
      index++;
      var size, alignSize;
      if (Runtime.isNumberType(field) || Runtime.isPointerType(field)) {
        size = Runtime.getNativeTypeSize(field); // pack char; char; in structs, also char[X]s.
        alignSize = Runtime.getAlignSize(field, size);
      } else if (Runtime.isStructType(field)) {
        if (field[1] === '0') {
          // this is [0 x something]. When inside another structure like here, it must be at the end,
          // and it adds no size
          // XXX this happens in java-nbody for example... assert(index === type.fields.length, 'zero-length in the middle!');
          size = 0;
          if (Types.types[field]) {
            alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
          } else {
            alignSize = type.alignSize || QUANTUM_SIZE;
          }
        } else {
          size = Types.types[field].flatSize;
          alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
        }
      } else if (field[0] == 'b') {
        // bN, large number field, like a [N x i8]
        size = field.substr(1)|0;
        alignSize = 1;
      } else if (field[0] === '<') {
        // vector type
        size = alignSize = Types.types[field].flatSize; // fully aligned
      } else if (field[0] === 'i') {
        // illegal integer field, that could not be legalized because it is an internal structure field
        // it is ok to have such fields, if we just use them as markers of field size and nothing more complex
        size = alignSize = parseInt(field.substr(1))/8;
        assert(size % 1 === 0, 'cannot handle non-byte-size field ' + field);
      } else {
        assert(false, 'invalid type for calculateStructAlignment');
      }
      if (type.packed) alignSize = 1;
      type.alignSize = Math.max(type.alignSize, alignSize);
      var curr = Runtime.alignMemory(type.flatSize, alignSize); // if necessary, place this on aligned memory
      type.flatSize = curr + size;
      if (prev >= 0) {
        diffs.push(curr-prev);
      }
      prev = curr;
      return curr;
    });
    if (type.name_ && type.name_[0] === '[') {
      // arrays have 2 elements, so we get the proper difference. then we scale here. that way we avoid
      // allocating a potentially huge array for [999999 x i8] etc.
      type.flatSize = parseInt(type.name_.substr(1))*type.flatSize/2;
    }
    type.flatSize = Runtime.alignMemory(type.flatSize, type.alignSize);
    if (diffs.length == 0) {
      type.flatFactor = type.flatSize;
    } else if (Runtime.dedup(diffs).length == 1) {
      type.flatFactor = diffs[0];
    }
    type.needsFlattening = (type.flatFactor != 1);
    return type.flatIndexes;
  },
  generateStructInfo: function (struct, typeName, offset) {
    var type, alignment;
    if (typeName) {
      offset = offset || 0;
      type = (typeof Types === 'undefined' ? Runtime.typeInfo : Types.types)[typeName];
      if (!type) return null;
      if (type.fields.length != struct.length) {
        printErr('Number of named fields must match the type for ' + typeName + ': possibly duplicate struct names. Cannot return structInfo');
        return null;
      }
      alignment = type.flatIndexes;
    } else {
      var type = { fields: struct.map(function(item) { return item[0] }) };
      alignment = Runtime.calculateStructAlignment(type);
    }
    var ret = {
      __size__: type.flatSize
    };
    if (typeName) {
      struct.forEach(function(item, i) {
        if (typeof item === 'string') {
          ret[item] = alignment[i] + offset;
        } else {
          // embedded struct
          var key;
          for (var k in item) key = k;
          ret[key] = Runtime.generateStructInfo(item[key], type.fields[i], alignment[i]);
        }
      });
    } else {
      struct.forEach(function(item, i) {
        ret[item[1]] = alignment[i];
      });
    }
    return ret;
  },
  dynCall: function (sig, ptr, args) {
    if (args && args.length) {
      if (!args.splice) args = Array.prototype.slice.call(args);
      args.splice(0, 0, ptr);
      return Module['dynCall_' + sig].apply(null, args);
    } else {
      return Module['dynCall_' + sig].call(null, ptr);
    }
  },
  functionPointers: [],
  addFunction: function (func) {
    for (var i = 0; i < Runtime.functionPointers.length; i++) {
      if (!Runtime.functionPointers[i]) {
        Runtime.functionPointers[i] = func;
        return 2*(1 + i);
      }
    }
    throw 'Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS.';
  },
  removeFunction: function (index) {
    Runtime.functionPointers[(index-2)/2] = null;
  },
  getAsmConst: function (code, numArgs) {
    // code is a constant string on the heap, so we can cache these
    if (!Runtime.asmConstCache) Runtime.asmConstCache = {};
    var func = Runtime.asmConstCache[code];
    if (func) return func;
    var args = [];
    for (var i = 0; i < numArgs; i++) {
      args.push(String.fromCharCode(36) + i); // $0, $1 etc
    }
    code = Pointer_stringify(code);
    if (code[0] === '"') {
      // tolerate EM_ASM("..code..") even though EM_ASM(..code..) is correct
      if (code.indexOf('"', 1) === code.length-1) {
        code = code.substr(1, code.length-2);
      } else {
        // something invalid happened, e.g. EM_ASM("..code($0)..", input)
        abort('invalid EM_ASM input |' + code + '|. Please use EM_ASM(..code..) (no quotes) or EM_ASM({ ..code($0).. }, input) (to input values)');
      }
    }
    return Runtime.asmConstCache[code] = eval('(function(' + args.join(',') + '){ ' + code + ' })'); // new Function does not allow upvars in node
  },
  warnOnce: function (text) {
    if (!Runtime.warnOnce.shown) Runtime.warnOnce.shown = {};
    if (!Runtime.warnOnce.shown[text]) {
      Runtime.warnOnce.shown[text] = 1;
      Module.printErr(text);
    }
  },
  funcWrappers: {},
  getFuncWrapper: function (func, sig) {
    assert(sig);
    if (!Runtime.funcWrappers[func]) {
      Runtime.funcWrappers[func] = function dynCall_wrapper() {
        return Runtime.dynCall(sig, func, arguments);
      };
    }
    return Runtime.funcWrappers[func];
  },
  UTF8Processor: function () {
    var buffer = [];
    var needed = 0;
    this.processCChar = function (code) {
      code = code & 0xFF;

      if (buffer.length == 0) {
        if ((code & 0x80) == 0x00) {        // 0xxxxxxx
          return String.fromCharCode(code);
        }
        buffer.push(code);
        if ((code & 0xE0) == 0xC0) {        // 110xxxxx
          needed = 1;
        } else if ((code & 0xF0) == 0xE0) { // 1110xxxx
          needed = 2;
        } else {                            // 11110xxx
          needed = 3;
        }
        return '';
      }

      if (needed) {
        buffer.push(code);
        needed--;
        if (needed > 0) return '';
      }

      var c1 = buffer[0];
      var c2 = buffer[1];
      var c3 = buffer[2];
      var c4 = buffer[3];
      var ret;
      if (buffer.length == 2) {
        ret = String.fromCharCode(((c1 & 0x1F) << 6)  | (c2 & 0x3F));
      } else if (buffer.length == 3) {
        ret = String.fromCharCode(((c1 & 0x0F) << 12) | ((c2 & 0x3F) << 6)  | (c3 & 0x3F));
      } else {
        // http://mathiasbynens.be/notes/javascript-encoding#surrogate-formulae
        var codePoint = ((c1 & 0x07) << 18) | ((c2 & 0x3F) << 12) |
                        ((c3 & 0x3F) << 6)  | (c4 & 0x3F);
        ret = String.fromCharCode(
          Math.floor((codePoint - 0x10000) / 0x400) + 0xD800,
          (codePoint - 0x10000) % 0x400 + 0xDC00);
      }
      buffer.length = 0;
      return ret;
    }
    this.processJSString = function processJSString(string) {
      string = unescape(encodeURIComponent(string));
      var ret = [];
      for (var i = 0; i < string.length; i++) {
        ret.push(string.charCodeAt(i));
      }
      return ret;
    }
  },
  getCompilerSetting: function (name) {
    throw 'You must build with -s RETAIN_COMPILER_SETTINGS=1 for Runtime.getCompilerSetting or emscripten_get_compiler_setting to work';
  },
  stackAlloc: function (size) { var ret = STACKTOP;STACKTOP = (STACKTOP + size)|0;STACKTOP = (((STACKTOP)+7)&-8); return ret; },
  staticAlloc: function (size) { var ret = STATICTOP;STATICTOP = (STATICTOP + size)|0;STATICTOP = (((STATICTOP)+7)&-8); return ret; },
  dynamicAlloc: function (size) { var ret = DYNAMICTOP;DYNAMICTOP = (DYNAMICTOP + size)|0;DYNAMICTOP = (((DYNAMICTOP)+7)&-8); if (DYNAMICTOP >= TOTAL_MEMORY) enlargeMemory();; return ret; },
  alignMemory: function (size,quantum) { var ret = size = Math.ceil((size)/(quantum ? quantum : 8))*(quantum ? quantum : 8); return ret; },
  makeBigInt: function (low,high,unsigned) { var ret = (unsigned ? ((+((low>>>0)))+((+((high>>>0)))*(+4294967296))) : ((+((low>>>0)))+((+((high|0)))*(+4294967296)))); return ret; },
  GLOBAL_BASE: 8,
  QUANTUM_SIZE: 4,
  __dummy__: 0
}


Module['Runtime'] = Runtime;









//========================================
// Runtime essentials
//========================================

var __THREW__ = 0; // Used in checking for thrown exceptions.

var ABORT = false; // whether we are quitting the application. no code should run after this. set in exit() and abort()
var EXITSTATUS = 0;

var undef = 0;
// tempInt is used for 32-bit signed values or smaller. tempBigInt is used
// for 32-bit unsigned values or more than 32 bits. TODO: audit all uses of tempInt
var tempValue, tempInt, tempBigInt, tempInt2, tempBigInt2, tempPair, tempBigIntI, tempBigIntR, tempBigIntS, tempBigIntP, tempBigIntD, tempDouble, tempFloat;
var tempI64, tempI64b;
var tempRet0, tempRet1, tempRet2, tempRet3, tempRet4, tempRet5, tempRet6, tempRet7, tempRet8, tempRet9;

function assert(condition, text) {
  if (!condition) {
    abort('Assertion failed: ' + text);
  }
}

var globalScope = this;

// C calling interface. A convenient way to call C functions (in C files, or
// defined with extern "C").
//
// Note: LLVM optimizations can inline and remove functions, after which you will not be
//       able to call them. Closure can also do so. To avoid that, add your function to
//       the exports using something like
//
//         -s EXPORTED_FUNCTIONS='["_main", "_myfunc"]'
//
// @param ident      The name of the C function (note that C++ functions will be name-mangled - use extern "C")
// @param returnType The return type of the function, one of the JS types 'number', 'string' or 'array' (use 'number' for any C pointer, and
//                   'array' for JavaScript arrays and typed arrays; note that arrays are 8-bit).
// @param argTypes   An array of the types of arguments for the function (if there are no arguments, this can be ommitted). Types are as in returnType,
//                   except that 'array' is not possible (there is no way for us to know the length of the array)
// @param args       An array of the arguments to the function, as native JS values (as in returnType)
//                   Note that string arguments will be stored on the stack (the JS string will become a C string on the stack).
// @return           The return value, as a native JS value (as in returnType)
function ccall(ident, returnType, argTypes, args) {
  return ccallFunc(getCFunc(ident), returnType, argTypes, args);
}
Module["ccall"] = ccall;

// Returns the C function with a specified identifier (for C++, you need to do manual name mangling)
function getCFunc(ident) {
  try {
    var func = Module['_' + ident]; // closure exported function
    if (!func) func = eval('_' + ident); // explicit lookup
  } catch(e) {
  }
  assert(func, 'Cannot call unknown function ' + ident + ' (perhaps LLVM optimizations or closure removed it?)');
  return func;
}

// Internal function that does a C call using a function, not an identifier
function ccallFunc(func, returnType, argTypes, args) {
  var stack = 0;
  function toC(value, type) {
    if (type == 'string') {
      if (value === null || value === undefined || value === 0) return 0; // null string
      value = intArrayFromString(value);
      type = 'array';
    }
    if (type == 'array') {
      if (!stack) stack = Runtime.stackSave();
      var ret = Runtime.stackAlloc(value.length);
      writeArrayToMemory(value, ret);
      return ret;
    }
    return value;
  }
  function fromC(value, type) {
    if (type == 'string') {
      return Pointer_stringify(value);
    }
    assert(type != 'array');
    return value;
  }
  var i = 0;
  var cArgs = args ? args.map(function(arg) {
    return toC(arg, argTypes[i++]);
  }) : [];
  var ret = fromC(func.apply(null, cArgs), returnType);
  if (stack) Runtime.stackRestore(stack);
  return ret;
}

// Returns a native JS wrapper for a C function. This is similar to ccall, but
// returns a function you can call repeatedly in a normal way. For example:
//
//   var my_function = cwrap('my_c_function', 'number', ['number', 'number']);
//   alert(my_function(5, 22));
//   alert(my_function(99, 12));
//
function cwrap(ident, returnType, argTypes) {
  var func = getCFunc(ident);
  return function() {
    return ccallFunc(func, returnType, argTypes, Array.prototype.slice.call(arguments));
  }
}
Module["cwrap"] = cwrap;

// Sets a value in memory in a dynamic way at run-time. Uses the
// type data. This is the same as makeSetValue, except that
// makeSetValue is done at compile-time and generates the needed
// code then, whereas this function picks the right code at
// run-time.
// Note that setValue and getValue only do *aligned* writes and reads!
// Note that ccall uses JS types as for defining types, while setValue and
// getValue need LLVM types ('i8', 'i32') - this is a lower-level operation
function setValue(ptr, value, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': HEAP8[(ptr)]=value; break;
      case 'i8': HEAP8[(ptr)]=value; break;
      case 'i16': HEAP16[((ptr)>>1)]=value; break;
      case 'i32': HEAP32[((ptr)>>2)]=value; break;
      case 'i64': (tempI64 = [value>>>0,(tempDouble=value,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((ptr)>>2)]=tempI64[0],HEAP32[(((ptr)+(4))>>2)]=tempI64[1]); break;
      case 'float': HEAPF32[((ptr)>>2)]=value; break;
      case 'double': HEAPF64[((ptr)>>3)]=value; break;
      default: abort('invalid type for setValue: ' + type);
    }
}
Module['setValue'] = setValue;

// Parallel to setValue.
function getValue(ptr, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': return HEAP8[(ptr)];
      case 'i8': return HEAP8[(ptr)];
      case 'i16': return HEAP16[((ptr)>>1)];
      case 'i32': return HEAP32[((ptr)>>2)];
      case 'i64': return HEAP32[((ptr)>>2)];
      case 'float': return HEAPF32[((ptr)>>2)];
      case 'double': return HEAPF64[((ptr)>>3)];
      default: abort('invalid type for setValue: ' + type);
    }
  return null;
}
Module['getValue'] = getValue;

var ALLOC_NORMAL = 0; // Tries to use _malloc()
var ALLOC_STACK = 1; // Lives for the duration of the current function call
var ALLOC_STATIC = 2; // Cannot be freed
var ALLOC_DYNAMIC = 3; // Cannot be freed except through sbrk
var ALLOC_NONE = 4; // Do not allocate
Module['ALLOC_NORMAL'] = ALLOC_NORMAL;
Module['ALLOC_STACK'] = ALLOC_STACK;
Module['ALLOC_STATIC'] = ALLOC_STATIC;
Module['ALLOC_DYNAMIC'] = ALLOC_DYNAMIC;
Module['ALLOC_NONE'] = ALLOC_NONE;

// allocate(): This is for internal use. You can use it yourself as well, but the interface
//             is a little tricky (see docs right below). The reason is that it is optimized
//             for multiple syntaxes to save space in generated code. So you should
//             normally not use allocate(), and instead allocate memory using _malloc(),
//             initialize it with setValue(), and so forth.
// @slab: An array of data, or a number. If a number, then the size of the block to allocate,
//        in *bytes* (note that this is sometimes confusing: the next parameter does not
//        affect this!)
// @types: Either an array of types, one for each byte (or 0 if no type at that position),
//         or a single type which is used for the entire block. This only matters if there
//         is initial data - if @slab is a number, then this does not matter at all and is
//         ignored.
// @allocator: How to allocate memory, see ALLOC_*
function allocate(slab, types, allocator, ptr) {
  var zeroinit, size;
  if (typeof slab === 'number') {
    zeroinit = true;
    size = slab;
  } else {
    zeroinit = false;
    size = slab.length;
  }

  var singleType = typeof types === 'string' ? types : null;

  var ret;
  if (allocator == ALLOC_NONE) {
    ret = ptr;
  } else {
    ret = [_malloc, Runtime.stackAlloc, Runtime.staticAlloc, Runtime.dynamicAlloc][allocator === undefined ? ALLOC_STATIC : allocator](Math.max(size, singleType ? 1 : types.length));
  }

  if (zeroinit) {
    var ptr = ret, stop;
    assert((ret & 3) == 0);
    stop = ret + (size & ~3);
    for (; ptr < stop; ptr += 4) {
      HEAP32[((ptr)>>2)]=0;
    }
    stop = ret + size;
    while (ptr < stop) {
      HEAP8[((ptr++)|0)]=0;
    }
    return ret;
  }

  if (singleType === 'i8') {
    if (slab.subarray || slab.slice) {
      HEAPU8.set(slab, ret);
    } else {
      HEAPU8.set(new Uint8Array(slab), ret);
    }
    return ret;
  }

  var i = 0, type, typeSize, previousType;
  while (i < size) {
    var curr = slab[i];

    if (typeof curr === 'function') {
      curr = Runtime.getFunctionIndex(curr);
    }

    type = singleType || types[i];
    if (type === 0) {
      i++;
      continue;
    }

    if (type == 'i64') type = 'i32'; // special case: we have one i32 here, and one i32 later

    setValue(ret+i, curr, type);

    // no need to look up size unless type changes, so cache it
    if (previousType !== type) {
      typeSize = Runtime.getNativeTypeSize(type);
      previousType = type;
    }
    i += typeSize;
  }

  return ret;
}
Module['allocate'] = allocate;

function Pointer_stringify(ptr, /* optional */ length) {
  // TODO: use TextDecoder
  // Find the length, and check for UTF while doing so
  var hasUtf = false;
  var t;
  var i = 0;
  while (1) {
    t = HEAPU8[(((ptr)+(i))|0)];
    if (t >= 128) hasUtf = true;
    else if (t == 0 && !length) break;
    i++;
    if (length && i == length) break;
  }
  if (!length) length = i;

  var ret = '';

  if (!hasUtf) {
    var MAX_CHUNK = 1024; // split up into chunks, because .apply on a huge string can overflow the stack
    var curr;
    while (length > 0) {
      curr = String.fromCharCode.apply(String, HEAPU8.subarray(ptr, ptr + Math.min(length, MAX_CHUNK)));
      ret = ret ? ret + curr : curr;
      ptr += MAX_CHUNK;
      length -= MAX_CHUNK;
    }
    return ret;
  }

  var utf8 = new Runtime.UTF8Processor();
  for (i = 0; i < length; i++) {
    t = HEAPU8[(((ptr)+(i))|0)];
    ret += utf8.processCChar(t);
  }
  return ret;
}
Module['Pointer_stringify'] = Pointer_stringify;

// Given a pointer 'ptr' to a null-terminated UTF16LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF16ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var codeUnit = HEAP16[(((ptr)+(i*2))>>1)];
    if (codeUnit == 0)
      return str;
    ++i;
    // fromCharCode constructs a character from a UTF-16 code unit, so we can pass the UTF16 string right through.
    str += String.fromCharCode(codeUnit);
  }
}
Module['UTF16ToString'] = UTF16ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF16LE form. The copy will require at most (str.length*2+1)*2 bytes of space in the HEAP.
function stringToUTF16(str, outPtr) {
  for(var i = 0; i < str.length; ++i) {
    // charCodeAt returns a UTF-16 encoded code unit, so it can be directly written to the HEAP.
    var codeUnit = str.charCodeAt(i); // possibly a lead surrogate
    HEAP16[(((outPtr)+(i*2))>>1)]=codeUnit;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP16[(((outPtr)+(str.length*2))>>1)]=0;
}
Module['stringToUTF16'] = stringToUTF16;

// Given a pointer 'ptr' to a null-terminated UTF32LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF32ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var utf32 = HEAP32[(((ptr)+(i*4))>>2)];
    if (utf32 == 0)
      return str;
    ++i;
    // Gotcha: fromCharCode constructs a character from a UTF-16 encoded code (pair), not from a Unicode code point! So encode the code point to UTF-16 for constructing.
    if (utf32 >= 0x10000) {
      var ch = utf32 - 0x10000;
      str += String.fromCharCode(0xD800 | (ch >> 10), 0xDC00 | (ch & 0x3FF));
    } else {
      str += String.fromCharCode(utf32);
    }
  }
}
Module['UTF32ToString'] = UTF32ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF32LE form. The copy will require at most (str.length+1)*4 bytes of space in the HEAP,
// but can use less, since str.length does not return the number of characters in the string, but the number of UTF-16 code units in the string.
function stringToUTF32(str, outPtr) {
  var iChar = 0;
  for(var iCodeUnit = 0; iCodeUnit < str.length; ++iCodeUnit) {
    // Gotcha: charCodeAt returns a 16-bit word that is a UTF-16 encoded code unit, not a Unicode code point of the character! We must decode the string to UTF-32 to the heap.
    var codeUnit = str.charCodeAt(iCodeUnit); // possibly a lead surrogate
    if (codeUnit >= 0xD800 && codeUnit <= 0xDFFF) {
      var trailSurrogate = str.charCodeAt(++iCodeUnit);
      codeUnit = 0x10000 + ((codeUnit & 0x3FF) << 10) | (trailSurrogate & 0x3FF);
    }
    HEAP32[(((outPtr)+(iChar*4))>>2)]=codeUnit;
    ++iChar;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP32[(((outPtr)+(iChar*4))>>2)]=0;
}
Module['stringToUTF32'] = stringToUTF32;

function demangle(func) {
  var i = 3;
  // params, etc.
  var basicTypes = {
    'v': 'void',
    'b': 'bool',
    'c': 'char',
    's': 'short',
    'i': 'int',
    'l': 'long',
    'f': 'float',
    'd': 'double',
    'w': 'wchar_t',
    'a': 'signed char',
    'h': 'unsigned char',
    't': 'unsigned short',
    'j': 'unsigned int',
    'm': 'unsigned long',
    'x': 'long long',
    'y': 'unsigned long long',
    'z': '...'
  };
  var subs = [];
  var first = true;
  function dump(x) {
    //return;
    if (x) Module.print(x);
    Module.print(func);
    var pre = '';
    for (var a = 0; a < i; a++) pre += ' ';
    Module.print (pre + '^');
  }
  function parseNested() {
    i++;
    if (func[i] === 'K') i++; // ignore const
    var parts = [];
    while (func[i] !== 'E') {
      if (func[i] === 'S') { // substitution
        i++;
        var next = func.indexOf('_', i);
        var num = func.substring(i, next) || 0;
        parts.push(subs[num] || '?');
        i = next+1;
        continue;
      }
      if (func[i] === 'C') { // constructor
        parts.push(parts[parts.length-1]);
        i += 2;
        continue;
      }
      var size = parseInt(func.substr(i));
      var pre = size.toString().length;
      if (!size || !pre) { i--; break; } // counter i++ below us
      var curr = func.substr(i + pre, size);
      parts.push(curr);
      subs.push(curr);
      i += pre + size;
    }
    i++; // skip E
    return parts;
  }
  function parse(rawList, limit, allowVoid) { // main parser
    limit = limit || Infinity;
    var ret = '', list = [];
    function flushList() {
      return '(' + list.join(', ') + ')';
    }
    var name;
    if (func[i] === 'N') {
      // namespaced N-E
      name = parseNested().join('::');
      limit--;
      if (limit === 0) return rawList ? [name] : name;
    } else {
      // not namespaced
      if (func[i] === 'K' || (first && func[i] === 'L')) i++; // ignore const and first 'L'
      var size = parseInt(func.substr(i));
      if (size) {
        var pre = size.toString().length;
        name = func.substr(i + pre, size);
        i += pre + size;
      }
    }
    first = false;
    if (func[i] === 'I') {
      i++;
      var iList = parse(true);
      var iRet = parse(true, 1, true);
      ret += iRet[0] + ' ' + name + '<' + iList.join(', ') + '>';
    } else {
      ret = name;
    }
    paramLoop: while (i < func.length && limit-- > 0) {
      //dump('paramLoop');
      var c = func[i++];
      if (c in basicTypes) {
        list.push(basicTypes[c]);
      } else {
        switch (c) {
          case 'P': list.push(parse(true, 1, true)[0] + '*'); break; // pointer
          case 'R': list.push(parse(true, 1, true)[0] + '&'); break; // reference
          case 'L': { // literal
            i++; // skip basic type
            var end = func.indexOf('E', i);
            var size = end - i;
            list.push(func.substr(i, size));
            i += size + 2; // size + 'EE'
            break;
          }
          case 'A': { // array
            var size = parseInt(func.substr(i));
            i += size.toString().length;
            if (func[i] !== '_') throw '?';
            i++; // skip _
            list.push(parse(true, 1, true)[0] + ' [' + size + ']');
            break;
          }
          case 'E': break paramLoop;
          default: ret += '?' + c; break paramLoop;
        }
      }
    }
    if (!allowVoid && list.length === 1 && list[0] === 'void') list = []; // avoid (void)
    return rawList ? list : ret + flushList();
  }
  try {
    // Special-case the entry point, since its name differs from other name mangling.
    if (func == 'Object._main' || func == '_main') {
      return 'main()';
    }
    if (typeof func === 'number') func = Pointer_stringify(func);
    if (func[0] !== '_') return func;
    if (func[1] !== '_') return func; // C function
    if (func[2] !== 'Z') return func;
    switch (func[3]) {
      case 'n': return 'operator new()';
      case 'd': return 'operator delete()';
    }
    return parse();
  } catch(e) {
    return func;
  }
}

function demangleAll(text) {
  return text.replace(/__Z[\w\d_]+/g, function(x) { var y = demangle(x); return x === y ? x : (x + ' [' + y + ']') });
}

function stackTrace() {
  var stack = new Error().stack;
  return stack ? demangleAll(stack) : '(no stack trace available)'; // Stack trace is not available at least on IE10 and Safari 6.
}

// Memory management

var PAGE_SIZE = 4096;
function alignMemoryPage(x) {
  return (x+4095)&-4096;
}

var HEAP;
var HEAP8, HEAPU8, HEAP16, HEAPU16, HEAP32, HEAPU32, HEAPF32, HEAPF64;

var STATIC_BASE = 0, STATICTOP = 0, staticSealed = false; // static area
var STACK_BASE = 0, STACKTOP = 0, STACK_MAX = 0; // stack area
var DYNAMIC_BASE = 0, DYNAMICTOP = 0; // dynamic area handled by sbrk

function enlargeMemory() {
  abort('Cannot enlarge memory arrays. Either (1) compile with -s TOTAL_MEMORY=X with X higher than the current value ' + TOTAL_MEMORY + ', (2) compile with ALLOW_MEMORY_GROWTH which adjusts the size at runtime but prevents some optimizations, or (3) set Module.TOTAL_MEMORY before the program runs.');
}

var TOTAL_STACK = Module['TOTAL_STACK'] || 5242880;
var TOTAL_MEMORY = Module['TOTAL_MEMORY'] || 536870912;
var FAST_MEMORY = Module['FAST_MEMORY'] || 2097152;

var totalMemory = 4096;
while (totalMemory < TOTAL_MEMORY || totalMemory < 2*TOTAL_STACK) {
  if (totalMemory < 16*1024*1024) {
    totalMemory *= 2;
  } else {
    totalMemory += 16*1024*1024
  }
}
if (totalMemory !== TOTAL_MEMORY) {
  Module.printErr('increasing TOTAL_MEMORY to ' + totalMemory + ' to be more reasonable');
  TOTAL_MEMORY = totalMemory;
}

// Initialize the runtime's memory
// check for full engine support (use string 'subarray' to avoid closure compiler confusion)
assert(typeof Int32Array !== 'undefined' && typeof Float64Array !== 'undefined' && !!(new Int32Array(1)['subarray']) && !!(new Int32Array(1)['set']),
       'JS engine does not provide full typed array support');

var buffer = new ArrayBuffer(TOTAL_MEMORY);
HEAP8 = new Int8Array(buffer);
HEAP16 = new Int16Array(buffer);
HEAP32 = new Int32Array(buffer);
HEAPU8 = new Uint8Array(buffer);
HEAPU16 = new Uint16Array(buffer);
HEAPU32 = new Uint32Array(buffer);
HEAPF32 = new Float32Array(buffer);
HEAPF64 = new Float64Array(buffer);

// Endianness check (note: assumes compiler arch was little-endian)
HEAP32[0] = 255;
assert(HEAPU8[0] === 255 && HEAPU8[3] === 0, 'Typed arrays 2 must be run on a little-endian system');

Module['HEAP'] = HEAP;
Module['HEAP8'] = HEAP8;
Module['HEAP16'] = HEAP16;
Module['HEAP32'] = HEAP32;
Module['HEAPU8'] = HEAPU8;
Module['HEAPU16'] = HEAPU16;
Module['HEAPU32'] = HEAPU32;
Module['HEAPF32'] = HEAPF32;
Module['HEAPF64'] = HEAPF64;

function callRuntimeCallbacks(callbacks) {
  while(callbacks.length > 0) {
    var callback = callbacks.shift();
    if (typeof callback == 'function') {
      callback();
      continue;
    }
    var func = callback.func;
    if (typeof func === 'number') {
      if (callback.arg === undefined) {
        Runtime.dynCall('v', func);
      } else {
        Runtime.dynCall('vi', func, [callback.arg]);
      }
    } else {
      func(callback.arg === undefined ? null : callback.arg);
    }
  }
}

var __ATPRERUN__  = []; // functions called before the runtime is initialized
var __ATINIT__    = []; // functions called during startup
var __ATMAIN__    = []; // functions called when main() is to be run
var __ATEXIT__    = []; // functions called during shutdown
var __ATPOSTRUN__ = []; // functions called after the runtime has exited

var runtimeInitialized = false;

function preRun() {
  // compatibility - merge in anything from Module['preRun'] at this time
  if (Module['preRun']) {
    if (typeof Module['preRun'] == 'function') Module['preRun'] = [Module['preRun']];
    while (Module['preRun'].length) {
      addOnPreRun(Module['preRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPRERUN__);
}

function ensureInitRuntime() {
  if (runtimeInitialized) return;
  runtimeInitialized = true;
  callRuntimeCallbacks(__ATINIT__);
}

function preMain() {
  callRuntimeCallbacks(__ATMAIN__);
}

function exitRuntime() {
  callRuntimeCallbacks(__ATEXIT__);
}

function postRun() {
  // compatibility - merge in anything from Module['postRun'] at this time
  if (Module['postRun']) {
    if (typeof Module['postRun'] == 'function') Module['postRun'] = [Module['postRun']];
    while (Module['postRun'].length) {
      addOnPostRun(Module['postRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPOSTRUN__);
}

function addOnPreRun(cb) {
  __ATPRERUN__.unshift(cb);
}
Module['addOnPreRun'] = Module.addOnPreRun = addOnPreRun;

function addOnInit(cb) {
  __ATINIT__.unshift(cb);
}
Module['addOnInit'] = Module.addOnInit = addOnInit;

function addOnPreMain(cb) {
  __ATMAIN__.unshift(cb);
}
Module['addOnPreMain'] = Module.addOnPreMain = addOnPreMain;

function addOnExit(cb) {
  __ATEXIT__.unshift(cb);
}
Module['addOnExit'] = Module.addOnExit = addOnExit;

function addOnPostRun(cb) {
  __ATPOSTRUN__.unshift(cb);
}
Module['addOnPostRun'] = Module.addOnPostRun = addOnPostRun;

// Tools

// This processes a JS string into a C-line array of numbers, 0-terminated.
// For LLVM-originating strings, see parser.js:parseLLVMString function
function intArrayFromString(stringy, dontAddNull, length /* optional */) {
  var ret = (new Runtime.UTF8Processor()).processJSString(stringy);
  if (length) {
    ret.length = length;
  }
  if (!dontAddNull) {
    ret.push(0);
  }
  return ret;
}
Module['intArrayFromString'] = intArrayFromString;

function intArrayToString(array) {
  var ret = [];
  for (var i = 0; i < array.length; i++) {
    var chr = array[i];
    if (chr > 0xFF) {
      chr &= 0xFF;
    }
    ret.push(String.fromCharCode(chr));
  }
  return ret.join('');
}
Module['intArrayToString'] = intArrayToString;

// Write a Javascript array to somewhere in the heap
function writeStringToMemory(string, buffer, dontAddNull) {
  var array = intArrayFromString(string, dontAddNull);
  var i = 0;
  while (i < array.length) {
    var chr = array[i];
    HEAP8[(((buffer)+(i))|0)]=chr;
    i = i + 1;
  }
}
Module['writeStringToMemory'] = writeStringToMemory;

function writeArrayToMemory(array, buffer) {
  for (var i = 0; i < array.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=array[i];
  }
}
Module['writeArrayToMemory'] = writeArrayToMemory;

function writeAsciiToMemory(str, buffer, dontAddNull) {
  for (var i = 0; i < str.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=str.charCodeAt(i);
  }
  if (!dontAddNull) HEAP8[(((buffer)+(str.length))|0)]=0;
}
Module['writeAsciiToMemory'] = writeAsciiToMemory;

function unSign(value, bits, ignore) {
  if (value >= 0) {
    return value;
  }
  return bits <= 32 ? 2*Math.abs(1 << (bits-1)) + value // Need some trickery, since if bits == 32, we are right at the limit of the bits JS uses in bitshifts
                    : Math.pow(2, bits)         + value;
}
function reSign(value, bits, ignore) {
  if (value <= 0) {
    return value;
  }
  var half = bits <= 32 ? Math.abs(1 << (bits-1)) // abs is needed if bits == 32
                        : Math.pow(2, bits-1);
  if (value >= half && (bits <= 32 || value > half)) { // for huge values, we can hit the precision limit and always get true here. so don't do that
                                                       // but, in general there is no perfect solution here. With 64-bit ints, we get rounding and errors
                                                       // TODO: In i64 mode 1, resign the two parts separately and safely
    value = -2*half + value; // Cannot bitshift half, as it may be at the limit of the bits JS uses in bitshifts
  }
  return value;
}

// check for imul support, and also for correctness ( https://bugs.webkit.org/show_bug.cgi?id=126345 )
if (!Math['imul'] || Math['imul'](0xffffffff, 5) !== -5) Math['imul'] = function imul(a, b) {
  var ah  = a >>> 16;
  var al = a & 0xffff;
  var bh  = b >>> 16;
  var bl = b & 0xffff;
  return (al*bl + ((ah*bl + al*bh) << 16))|0;
};
Math.imul = Math['imul'];


var Math_abs = Math.abs;
var Math_cos = Math.cos;
var Math_sin = Math.sin;
var Math_tan = Math.tan;
var Math_acos = Math.acos;
var Math_asin = Math.asin;
var Math_atan = Math.atan;
var Math_atan2 = Math.atan2;
var Math_exp = Math.exp;
var Math_log = Math.log;
var Math_sqrt = Math.sqrt;
var Math_ceil = Math.ceil;
var Math_floor = Math.floor;
var Math_pow = Math.pow;
var Math_imul = Math.imul;
var Math_fround = Math.fround;
var Math_min = Math.min;

// A counter of dependencies for calling run(). If we need to
// do asynchronous work before running, increment this and
// decrement it. Incrementing must happen in a place like
// PRE_RUN_ADDITIONS (used by emcc to add file preloading).
// Note that you can add dependencies in preRun, even though
// it happens right before run - run will be postponed until
// the dependencies are met.
var runDependencies = 0;
var runDependencyWatcher = null;
var dependenciesFulfilled = null; // overridden to take different actions when all run dependencies are fulfilled

function addRunDependency(id) {
  runDependencies++;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
}
Module['addRunDependency'] = addRunDependency;
function removeRunDependency(id) {
  runDependencies--;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
  if (runDependencies == 0) {
    if (runDependencyWatcher !== null) {
      clearInterval(runDependencyWatcher);
      runDependencyWatcher = null;
    }
    if (dependenciesFulfilled) {
      var callback = dependenciesFulfilled;
      dependenciesFulfilled = null;
      callback(); // can add another dependenciesFulfilled
    }
  }
}
Module['removeRunDependency'] = removeRunDependency;

Module["preloadedImages"] = {}; // maps url to image data
Module["preloadedAudios"] = {}; // maps url to audio data


var memoryInitializer = null;

// === Body ===
var __ZTVN10__cxxabiv117__class_type_infoE = 296136;
var __ZTVN10__cxxabiv120__si_class_type_infoE = 296176;




STATIC_BASE = 8;

STATICTOP = STATIC_BASE + Runtime.alignMemory(297003);
/* global initializers */ __ATINIT__.push({ func: function() { __GLOBAL__I_a() } });


/* memory initializer */ allocate([0,0,0,0,0,0,0,0,95,112,114,111,102,46,100,97,116,97,0,0,0,0,0,0,119,98,0,0,0,0,0,0,84,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,111,117,116,112,117,116,32,102,105,108,101,32,37,115,32,99,111,117,108,100,32,110,111,116,32,98,101,32,111,112,101,110,101,100,58,32,37,115,0,0,0,0,0,0,0,0,111,102,102,115,101,116,32,118,97,108,117,101,32,102,111,114,32,116,104,101,32,110,101,120,116,32,115,116,101,112,58,32,37,46,49,48,102,0,0,0,99,97,108,108,32,115,111,108,118,101,114,32,102,114,111,109,32,37,103,32,116,111,32,37,103,32,40,115,116,101,112,83,105,122,101,58,32,37,103,41,0,0,0,0,0,0,0,0,82,117,110,110,105,110,103,0,37,115,32,101,118,101,110,116,32,97,116,32,116,105,109,101,32,37,46,49,50,103,0,0,116,105,109,101,0,0,0,0,115,116,97,116,101,0,0,0,68,105,115,97,98,108,101,100,32,116,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,98,101,99,97,117,115,101,32,116,104,101,32,111,117,116,112,117,116,32,102,105,108,101,32,99,111,117,108,100,32,110,111,116,32,98,101,32,103,101,110,101,114,97,116,101,100,58,32,37,115,0,0,0,83,105,109,117,108,97,116,105,111,110,32,99,97,108,108,32,116,101,114,109,105,110,97,116,101,40,41,32,97,116,32,116,105,109,101,32,37,102,10,77,101,115,115,97,103,101,32,58,32,37,115,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,73,110,116,101,103,114,97,116,111,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,110,111,110,45,108,105,110,101,97,114,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,109,105,120,101,100,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,112,114,111,98,97,98,108,121,32,97,32,115,116,114,111,110,103,32,99,111,109,112,111,110,101,110,116,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,70,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,117,115,101,32,102,108,97,103,115,32,45,108,118,32,76,79,71,95,78,76,83,44,32,76,79,71,95,76,83,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,108,6,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,1,0,0,0,109,6,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,1,0,0,0,110,6,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,1,0,0,0,111,6,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,1,0,0,0,112,6,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,1,0,0,0,114,6,0,0,112,105,112,101,49,46,102,108,117,105,100,86,111,108,117,109,101,115,91,49,93,0,0,0,1,0,0,0,116,6,0,0,112,105,112,101,49,46,102,108,117,105,100,86,111,108,117,109,101,115,91,50,93,0,0,0,1,0,0,0,118,6,0,0,112,105,112,101,49,46,102,108,117,105,100,86,111,108,117,109,101,115,91,51,93,0,0,0,1,0,0,0,120,6,0,0,112,105,112,101,49,46,102,108,117,105,100,86,111,108,117,109,101,115,91,52,93,0,0,0,1,0,0,0,122,6,0,0,112,105,112,101,49,46,102,108,117,105,100,86,111,108,117,109,101,115,91,53,93,0,0,0,1,0,0,0,132,6,0,0,1,0,0,0,8,72,0,0,16,72,0,0,0,0,0,0,112,105,112,101,49,46,110,80,97,114,97,108,108,101,108,32,42,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,100,101,110,115,105,116,121,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,84,104,101,114,109,111,100,121,110,97,109,105,99,83,116,97,116,101,40,49,53,48,48,48,48,46,48,44,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,49,93,46,84,44,32,35,83,72,65,82,69,68,95,76,73,84,69,82,65,76,95,54,48,40,82,101,97,108,91,50,93,41,35,41,41,32,42,32,112,105,112,101,49,46,99,114,111,115,115,65,114,101,97,115,91,49,93,0,0,0,0,0,0,0,0,1,0,0,0,133,6,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,1,0,0,0,134,6,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,1,0,0,0,135,6,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,1,0,0,0,136,6,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,1,0,0,0,137,6,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,1,0,0,0,139,6,0,0,112,105,112,101,50,46,102,108,117,105,100,86,111,108,117,109,101,115,91,50,93,0,0,0,1,0,0,0,141,6,0,0,112,105,112,101,50,46,102,108,117,105,100,86,111,108,117,109,101,115,91,51,93,0,0,0,1,0,0,0,143,6,0,0,112,105,112,101,50,46,102,108,117,105,100,86,111,108,117,109,101,115,91,52,93,0,0,0,1,0,0,0,151,6,0,0,109,97,120,40,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,54,93,44,32,49,101,45,49,53,41,32,43,32,109,97,120,40,45,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,44,32,49,101,45,49,53,41,0,0,0,0,0,0,0,0,1,0,0,0,152,6,0,0,1,0,0,0,153,6,0,0,109,97,120,40,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,54,93,44,32,49,101,45,49,53,41,32,43,32,109,97,120,40,45,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,44,32,49,101,45,49,53,41,0,0,0,0,0,0,0,0,1,0,0,0,154,6,0,0,1,0,0,0,155,6,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,1,0,0,0,156,6,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,1,0,0,0,157,6,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,1,0,0,0,158,6,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,1,0,0,0,159,6,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,1,0,0,0,161,6,0,0,112,105,112,101,51,46,102,108,117,105,100,86,111,108,117,109,101,115,91,49,93,0,0,0,1,0,0,0,163,6,0,0,112,105,112,101,51,46,102,108,117,105,100,86,111,108,117,109,101,115,91,50,93,0,0,0,1,0,0,0,165,6,0,0,112,105,112,101,51,46,102,108,117,105,100,86,111,108,117,109,101,115,91,51,93,0,0,0,1,0,0,0,167,6,0,0,112,105,112,101,51,46,102,108,117,105,100,86,111,108,117,109,101,115,91,52,93,0,0,0,1,0,0,0,169,6,0,0,112,105,112,101,51,46,102,108,117,105,100,86,111,108,117,109,101,115,91,53,93,0,0,0,1,0,0,0,177,6,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,1,0,0,0,178,6,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,1,0,0,0,179,6,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,1,0,0,0,180,6,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,1,0,0,0,181,6,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,1,0,0,0,183,6,0,0,112,105,112,101,52,46,102,108,117,105,100,86,111,108,117,109,101,115,91,49,93,0,0,0,1,0,0,0,185,6,0,0,112,105,112,101,52,46,102,108,117,105,100,86,111,108,117,109,101,115,91,50,93,0,0,0,1,0,0,0,187,6,0,0,112,105,112,101,52,46,102,108,117,105,100,86,111,108,117,109,101,115,91,51,93,0,0,0,1,0,0,0,189,6,0,0,112,105,112,101,52,46,102,108,117,105,100,86,111,108,117,109,101,115,91,52,93,0,0,0,1,0,0,0,191,6,0,0,112,105,112,101,52,46,102,108,117,105,100,86,111,108,117,109,101,115,91,53,93,0,0,0,1,0,0,0,201,6,0,0,114,97,109,112,49,46,100,117,114,97,116,105,111,110,0,0,1,0,0,0,248,71,0,0,0,72,0,0,0,0,0,0,1,0,0,0,204,6,0,0,109,97,120,40,49,101,45,49,51,44,32,98,111,117,110,100,97,114,121,52,46,112,95,105,110,32,45,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,0,0,0,0,1,0,0,0,207,6,0,0,49,46,48,32,45,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,0,1,0,0,0,209,6,0,0,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,82,32,42,32,50,57,51,46,49,53,0,0,0,0,0,1,0,0,0,210,6,0,0,1,0,0,0,211,6,0,0,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,0,0,0,0,72,50,79,0,0,0,0,0,1,0,0,0,184,71,0,0,192,71,0,0,0,0,0,0,1,0,0,0,160,71,0,0,168,71,0,0,0,0,0,0,1,0,0,0,96,71,0,0,104,71,0,0,0,0,0,0,1,0,0,0,72,71,0,0,80,71,0,0,0,0,0,0,1,0,0,0,213,6,0,0,112,105,112,101,52,46,110,80,97,114,97,108,108,101,108,32,42,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,100,101,110,115,105,116,121,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,84,104,101,114,109,111,100,121,110,97,109,105,99,83,116,97,116,101,40,98,111,117,110,100,97,114,121,52,46,112,95,105,110,44,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,55,93,46,84,44,32,35,83,72,65,82,69,68,95,76,73,84,69,82,65,76,95,54,48,40,82,101,97,108,91,50,93,41,35,41,41,32,42,32,112,105,112,101,52,46,99,114,111,115,115,65,114,101,97,115,91,53,93,0,0,1,0,0,0,218,6,0,0,109,97,120,40,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,54,93,44,32,49,101,45,49,53,41,32,43,32,109,97,120,40,45,112,105,112,101,50,46,109,95,102,108,111,119,115,91,49,93,44,32,49,101,45,49,53,41,0,0,1,0,0,0,219,6,0,0,1,0,0,0,220,6,0,0,1,0,0,0,222,6,0,0,1,0,0,0,225,6,0,0,112,105,112,101,50,46,102,108,117,105,100,86,111,108,117,109,101,115,91,49,93,0,0,0,1,0,0,0,226,6,0,0,109,97,120,40,45,112,105,112,101,50,46,109,95,102,108,111,119,115,91,49,93,44,32,49,101,45,49,53,41,32,43,32,109,97,120,40,45,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,44,32,49,101,45,49,53,41,0,1,0,0,0,227,6,0,0,1,0,0,0,228,6,0,0,1,0,0,0,231,6,0,0,109,97,120,40,112,105,112,101,50,46,109,95,102,108,111,119,115,91,54,93,44,32,49,101,45,49,53,41,32,43,32,109,97,120,40,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,54,93,44,32,49,101,45,49,53,41,0,0,0,1,0,0,0,232,6,0,0,1,0,0,0,233,6,0,0,1,0,0,0,235,6,0,0,109,97,120,40,112,105,112,101,50,46,109,95,102,108,111,119,115,91,54,93,44,32,49,101,45,49,53,41,32,43,32,109,97,120,40,45,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,44,32,49,101,45,49,53,41,0,0,1,0,0,0,236,6,0,0,1,0,0,0,237,6,0,0,1,0,0,0,239,6,0,0,1,0,0,0,242,6,0,0,112,105,112,101,50,46,102,108,117,105,100,86,111,108,117,109,101,115,91,53,93,0,0,0,1,0,0,0,247,6,0,0,109,97,120,40,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,54,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,1,0,0,0,1,7,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,112,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,4,7,0,0,49,46,48,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,88,95,108,105,113,117,105,100,0,1,0,0,0,6,7,0,0,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,84,32,42,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,82,0,1,0,0,0,10,7,0,0,112,105,112,101,52,46,109,115,91,53,93,0,0,0,0,0,1,0,0,0,12,7,0,0,112,105,112,101,52,46,99,114,111,115,115,65,114,101,97,115,91,53,93,32,42,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,100,32,42,32,112,105,112,101,52,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,1,0,0,0,15,7,0,0,112,105,112,101,52,46,112,97,116,104,76,101,110,103,116,104,115,91,54,93,0,0,0,0,1,0,0,0,16,7,0,0,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,54,93,46,88,91,50,93,41,0,0,0,1,0,0,0,17,7,0,0,1,0,0,0,23,7,0,0,109,97,120,40,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,53,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,1,0,0,0,33,7,0,0,1,0,0,0,45,7,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,112,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,48,7,0,0,49,46,48,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,88,95,108,105,113,117,105,100,0,1,0,0,0,50,7,0,0,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,84,32,42,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,82,0,1,0,0,0,54,7,0,0,112,105,112,101,52,46,109,115,91,52,93,0,0,0,0,0,1,0,0,0,56,7,0,0,112,105,112,101,52,46,99,114,111,115,115,65,114,101,97,115,91,52,93,32,42,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,100,32,42,32,112,105,112,101,52,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,1,0,0,0,59,7,0,0,112,105,112,101,52,46,112,97,116,104,76,101,110,103,116,104,115,91,53,93,0,0,0,0,1,0,0,0,60,7,0,0,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,53,93,46,88,91,50,93,41,0,0,0,1,0,0,0,61,7,0,0,1,0,0,0,67,7,0,0,109,97,120,40,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,52,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,1,0,0,0,77,7,0,0,1,0,0,0,89,7,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,112,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,92,7,0,0,49,46,48,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,88,95,108,105,113,117,105,100,0,1,0,0,0,94,7,0,0,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,84,32,42,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,82,0,1,0,0,0,98,7,0,0,112,105,112,101,52,46,109,115,91,51,93,0,0,0,0,0,1,0,0,0,100,7,0,0,112,105,112,101,52,46,99,114,111,115,115,65,114,101,97,115,91,51,93,32,42,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,100,32,42,32,112,105,112,101,52,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,1,0,0,0,103,7,0,0,112,105,112,101,52,46,112,97,116,104,76,101,110,103,116,104,115,91,52,93,0,0,0,0,1,0,0,0,104,7,0,0,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,52,93,46,88,91,50,93,41,0,0,0,1,0,0,0,105,7,0,0,1,0,0,0,111,7,0,0,109,97,120,40,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,51,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,1,0,0,0,121,7,0,0,1,0,0,0,133,7,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,136,7,0,0,49,46,48,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,88,95,108,105,113,117,105,100,0,1,0,0,0,138,7,0,0,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,84,32,42,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,82,0,1,0,0,0,142,7,0,0,112,105,112,101,52,46,109,115,91,50,93,0,0,0,0,0,1,0,0,0,144,7,0,0,112,105,112,101,52,46,99,114,111,115,115,65,114,101,97,115,91,50,93,32,42,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,100,32,42,32,112,105,112,101,52,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,1,0,0,0,147,7,0,0,112,105,112,101,52,46,112,97,116,104,76,101,110,103,116,104,115,91,51,93,0,0,0,0,1,0,0,0,148,7,0,0,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,51,93,46,88,91,50,93,41,0,0,0,1,0,0,0,149,7,0,0,1,0,0,0,155,7,0,0,109,97,120,40,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,50,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,1,0,0,0,165,7,0,0,1,0,0,0,177,7,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,180,7,0,0,49,46,48,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,88,95,108,105,113,117,105,100,0,1,0,0,0,182,7,0,0,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,84,32,42,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,82,0,1,0,0,0,186,7,0,0,112,105,112,101,52,46,109,115,91,49,93,0,0,0,0,0,1,0,0,0,188,7,0,0,112,105,112,101,52,46,99,114,111,115,115,65,114,101,97,115,91,49,93,32,42,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,100,32,42,32,112,105,112,101,52,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,1,0,0,0,191,7,0,0,112,105,112,101,52,46,112,97,116,104,76,101,110,103,116,104,115,91,50,93,0,0,0,0,1,0,0,0,192,7,0,0,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,50,93,46,88,91,50,93,41,0,0,0,1,0,0,0,193,7,0,0,1,0,0,0,201,7,0,0,1,0,0,0,204,7,0,0,109,97,120,40,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,54,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,1,0,0,0,208,7,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,112,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,211,7,0,0,49,46,48,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,88,95,108,105,113,117,105,100,0,1,0,0,0,213,7,0,0,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,84,32,42,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,82,0,1,0,0,0,217,7,0,0,112,105,112,101,51,46,109,115,91,53,93,0,0,0,0,0,1,0,0,0,219,7,0,0,112,105,112,101,51,46,99,114,111,115,115,65,114,101,97,115,91,53,93,32,42,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,100,32,42,32,112,105,112,101,51,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,1,0,0,0,220,7,0,0,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,54,93,46,88,91,50,93,41,0,0,0,1,0,0,0,221,7,0,0,1,0,0,0,226,7,0,0,109,97,120,40,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,53,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,1,0,0,0,236,7,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,112,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,239,7,0,0,49,46,48,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,88,95,108,105,113,117,105,100,0,1,0,0,0,241,7,0,0,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,84,32,42,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,82,0,1,0,0,0,245,7,0,0,112,105,112,101,51,46,109,115,91,52,93,0,0,0,0,0,1,0,0,0,247,7,0,0,112,105,112,101,51,46,99,114,111,115,115,65,114,101,97,115,91,52,93,32,42,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,100,32,42,32,112,105,112,101,51,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,1,0,0,0,250,7,0,0,112,105,112,101,51,46,112,97,116,104,76,101,110,103,116,104,115,91,53,93,0,0,0,0,1,0,0,0,251,7,0,0,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,53,93,46,88,91,50,93,41,0,0,0,1,0,0,0,252,7,0,0,1,0,0,0,2,8,0,0,109,97,120,40,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,52,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,1,0,0,0,12,8,0,0,1,0,0,0,24,8,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,112,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,27,8,0,0,49,46,48,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,88,95,108,105,113,117,105,100,0,1,0,0,0,29,8,0,0,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,84,32,42,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,82,0,1,0,0,0,33,8,0,0,112,105,112,101,51,46,109,115,91,51,93,0,0,0,0,0,1,0,0,0,35,8,0,0,112,105,112,101,51,46,99,114,111,115,115,65,114,101,97,115,91,51,93,32,42,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,100,32,42,32,112,105,112,101,51,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,1,0,0,0,38,8,0,0,112,105,112,101,51,46,112,97,116,104,76,101,110,103,116,104,115,91,52,93,0,0,0,0,1,0,0,0,39,8,0,0,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,52,93,46,88,91,50,93,41,0,0,0,1,0,0,0,40,8,0,0,1,0,0,0,46,8,0,0,109,97,120,40,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,51,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,1,0,0,0,56,8,0,0,1,0,0,0,68,8,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,71,8,0,0,49,46,48,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,88,95,108,105,113,117,105,100,0,1,0,0,0,73,8,0,0,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,84,32,42,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,82,0,1,0,0,0,77,8,0,0,112,105,112,101,51,46,109,115,91,50,93,0,0,0,0,0,1,0,0,0,79,8,0,0,112,105,112,101,51,46,99,114,111,115,115,65,114,101,97,115,91,50,93,32,42,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,100,32,42,32,112,105,112,101,51,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,1,0,0,0,82,8,0,0,112,105,112,101,51,46,112,97,116,104,76,101,110,103,116,104,115,91,51,93,0,0,0,0,1,0,0,0,83,8,0,0,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,51,93,46,88,91,50,93,41,0,0,0,1,0,0,0,84,8,0,0,1,0,0,0,90,8,0,0,109,97,120,40,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,50,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,1,0,0,0,100,8,0,0,1,0,0,0,112,8,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,115,8,0,0,49,46,48,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,88,95,108,105,113,117,105,100,0,1,0,0,0,117,8,0,0,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,84,32,42,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,82,0,1,0,0,0,121,8,0,0,112,105,112,101,51,46,109,115,91,49,93,0,0,0,0,0,1,0,0,0,123,8,0,0,112,105,112,101,51,46,99,114,111,115,115,65,114,101,97,115,91,49,93,32,42,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,100,32,42,32,112,105,112,101,51,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,1,0,0,0,126,8,0,0,112,105,112,101,51,46,112,97,116,104,76,101,110,103,116,104,115,91,50,93,0,0,0,0,1,0,0,0,127,8,0,0,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,50,93,46,88,91,50,93,41,0,0,0,1,0,0,0,128,8,0,0,1,0,0,0,136,8,0,0,1,0,0,0,137,8,0,0,112,105,112,101,52,46,99,114,111,115,115,65,114,101,97,115,91,49,93,32,42,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,100,101,110,115,105,116,121,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,84,104,101,114,109,111,100,121,110,97,109,105,99,83,116,97,116,101,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,112,44,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,49,93,46,84,44,32,123,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,49,93,46,88,91,49,93,44,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,49,93,46,88,91,50,93,125,41,41,32,42,32,112,105,112,101,52,46,110,80,97,114,97,108,108,101,108,0,0,1,0,0,0,149,8,0,0,112,105,112,101,52,46,112,97,116,104,76,101,110,103,116,104,115,91,49,93,0,0,0,0,1,0,0,0,150,8,0,0,1,0,0,0,153,8,0,0,1,0,0,0,163,8,0,0,1,0,0,0,164,8,0,0,112,105,112,101,51,46,99,114,111,115,115,65,114,101,97,115,91,53,93,32,42,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,100,101,110,115,105,116,121,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,84,104,101,114,109,111,100,121,110,97,109,105,99,83,116,97,116,101,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,112,44,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,55,93,46,84,44,32,123,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,55,93,46,88,91,49,93,44,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,55,93,46,88,91,50,93,125,41,41,32,42,32,112,105,112,101,51,46,110,80,97,114,97,108,108,101,108,0,0,1,0,0,0,176,8,0,0,112,105,112,101,51,46,112,97,116,104,76,101,110,103,116,104,115,91,54,93,0,0,0,0,1,0,0,0,177,8,0,0,1,0,0,0,180,8,0,0,1,0,0,0,190,8,0,0,1,0,0,0,197,8,0,0,109,97,120,40,112,105,112,101,50,46,115,116,97,116,101,115,70,77,91,53,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,1,0,0,0,201,8,0,0,109,97,120,40,49,101,45,49], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE);
/* memory initializer */ allocate([51,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,112,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,204,8,0,0,49,46,48,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,88,95,108,105,113,117,105,100,0,1,0,0,0,206,8,0,0,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,84,32,42,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,82,0,1,0,0,0,210,8,0,0,112,105,112,101,50,46,109,115,91,53,93,0,0,0,0,0,1,0,0,0,212,8,0,0,112,105,112,101,50,46,99,114,111,115,115,65,114,101,97,115,91,53,93,32,42,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,100,32,42,32,112,105,112,101,50,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,53,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,1,0,0,0,215,8,0,0,40,105,102,32,112,105,112,101,50,46,118,115,91,53,93,32,62,61,32,48,46,48,32,116,104,101,110,32,52,46,53,32,101,108,115,101,32,48,46,53,41,32,42,32,112,105,112,101,50,46,108,101,110,103,116,104,115,91,53,93,0,0,0,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,53,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,53,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,0,0,0,0,1,0,0,0,216,8,0,0,1,0,0,0,222,8,0,0,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,112,105,112,101,50,46,115,116,97,116,101,115,70,77,91,53,93,46,88,91,50,93,41,0,0,0,1,0,0,0,223,8,0,0,1,0,0,0,233,8,0,0,109,97,120,40,112,105,112,101,50,46,115,116,97,116,101,115,70,77,91,52,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,1,0,0,0,243,8,0,0,1,0,0,0,255,8,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,112,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,2,9,0,0,49,46,48,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,88,95,108,105,113,117,105,100,0,1,0,0,0,4,9,0,0,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,84,32,42,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,82,0,1,0,0,0,8,9,0,0,112,105,112,101,50,46,109,115,91,52,93,0,0,0,0,0,1,0,0,0,10,9,0,0,112,105,112,101,50,46,99,114,111,115,115,65,114,101,97,115,91,52,93,32,42,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,100,32,42,32,112,105,112,101,50,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,52,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,1,0,0,0,13,9,0,0,40,105,102,32,112,105,112,101,50,46,118,115,91,52,93,32,62,61,32,48,46,48,32,116,104,101,110,32,51,46,53,32,101,108,115,101,32,49,46,53,41,32,42,32,112,105,112,101,50,46,108,101,110,103,116,104,115,91,52,93,0,0,0,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,52,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,52,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,0,0,0,0,1,0,0,0,14,9,0,0,1,0,0,0,22,9,0,0,112,105,112,101,50,46,112,97,116,104,76,101,110,103,116,104,115,91,52,93,0,0,0,0,1,0,0,0,23,9,0,0,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,112,105,112,101,50,46,115,116,97,116,101,115,70,77,91,52,93,46,88,91,50,93,41,0,0,0,1,0,0,0,24,9,0,0,1,0,0,0,34,9,0,0,109,97,120,40,112,105,112,101,50,46,115,116,97,116,101,115,70,77,91,51,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,1,0,0,0,44,9,0,0,1,0,0,0,56,9,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,112,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,59,9,0,0,49,46,48,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,88,95,108,105,113,117,105,100,0,1,0,0,0,61,9,0,0,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,84,32,42,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,82,0,1,0,0,0,65,9,0,0,112,105,112,101,50,46,109,115,91,51,93,0,0,0,0,0,1,0,0,0,67,9,0,0,112,105,112,101,50,46,99,114,111,115,115,65,114,101,97,115,91,51,93,32,42,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,100,32,42,32,112,105,112,101,50,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,51,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,1,0,0,0,70,9,0,0,112,105,112,101,50,46,108,101,110,103,116,104,115,91,51,93,0,0,0,0,0,0,0,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,51,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,51,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,0,0,0,0,1,0,0,0,71,9,0,0,1,0,0,0,79,9,0,0,112,105,112,101,50,46,112,97,116,104,76,101,110,103,116,104,115,91,51,93,0,0,0,0,1,0,0,0,80,9,0,0,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,112,105,112,101,50,46,115,116,97,116,101,115,70,77,91,51,93,46,88,91,50,93,41,0,0,0,1,0,0,0,81,9,0,0,1,0,0,0,91,9,0,0,109,97,120,40,112,105,112,101,50,46,115,116,97,116,101,115,70,77,91,50,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,1,0,0,0,101,9,0,0,1,0,0,0,113,9,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,116,9,0,0,49,46,48,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,88,95,108,105,113,117,105,100,0,1,0,0,0,118,9,0,0,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,84,32,42,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,82,0,1,0,0,0,122,9,0,0,112,105,112,101,50,46,109,115,91,50,93,0,0,0,0,0,1,0,0,0,124,9,0,0,112,105,112,101,50,46,99,114,111,115,115,65,114,101,97,115,91,50,93,32,42,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,100,32,42,32,112,105,112,101,50,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,50,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,1,0,0,0,127,9,0,0,40,105,102,32,112,105,112,101,50,46,118,115,91,50,93,32,62,61,32,48,46,48,32,116,104,101,110,32,49,46,53,32,101,108,115,101,32,51,46,53,41,32,42,32,112,105,112,101,50,46,108,101,110,103,116,104,115,91,50,93,0,0,0,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,50,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,50,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,0,0,0,0,1,0,0,0,128,9,0,0,1,0,0,0,136,9,0,0,112,105,112,101,50,46,112,97,116,104,76,101,110,103,116,104,115,91,50,93,0,0,0,0,1,0,0,0,137,9,0,0,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,112,105,112,101,50,46,115,116,97,116,101,115,70,77,91,50,93,46,88,91,50,93,41,0,0,0,1,0,0,0,138,9,0,0,1,0,0,0,142,9,0,0,1,0,0,0,143,9,0,0,112,105,112,101,49,46,99,114,111,115,115,65,114,101,97,115,91,53,93,32,42,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,100,101,110,115,105,116,121,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,84,104,101,114,109,111,100,121,110,97,109,105,99,83,116,97,116,101,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,112,44,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,55,93,46,84,44,32,123,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,55,93,46,88,91,49,93,44,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,55,93,46,88,91,50,93,125,41,41,32,42,32,112,105,112,101,49,46,110,80,97,114,97,108,108,101,108,0,0,1,0,0,0,152,9,0,0,109,97,120,40,112,105,112,101,50,46,115,116,97,116,101,115,70,77,91,49,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,1,0,0,0,162,9,0,0,1,0,0,0,174,9,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,177,9,0,0,49,46,48,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,88,95,108,105,113,117,105,100,0,1,0,0,0,179,9,0,0,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,84,32,42,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,82,0,1,0,0,0,183,9,0,0,112,105,112,101,50,46,109,115,91,49,93,0,0,0,0,0,1,0,0,0,185,9,0,0,112,105,112,101,50,46,99,114,111,115,115,65,114,101,97,115,91,49,93,32,42,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,100,32,42,32,112,105,112,101,50,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,96,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,49,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,1,0,0,0,188,9,0,0,40,105,102,32,112,105,112,101,50,46,118,115,91,49,93,32,62,61,32,48,46,48,32,116,104,101,110,32,48,46,53,32,101,108,115,101,32,52,46,53,41,32,42,32,112,105,112,101,50,46,108,101,110,103,116,104,115,91,49,93,0,0,0,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,49,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,49,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,0,0,0,0,1,0,0,0,189,9,0,0,1,0,0,0,197,9,0,0,112,105,112,101,50,46,112,97,116,104,76,101,110,103,116,104,115,91,49,93,0,0,0,0,1,0,0,0,199,9,0,0,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,112,105,112,101,50,46,115,116,97,116,101,115,70,77,91,49,93,46,88,91,50,93,41,0,0,0,1,0,0,0,200,9,0,0,1,0,0,0,206,9,0,0,1,0,0,0,207,9,0,0,112,105,112,101,51,46,99,114,111,115,115,65,114,101,97,115,91,49,93,32,42,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,100,101,110,115,105,116,121,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,84,104,101,114,109,111,100,121,110,97,109,105,99,83,116,97,116,101,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,112,44,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,49,93,46,84,44,32,123,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,49,93,46,88,91,49,93,44,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,49,93,46,88,91,50,93,125,41,41,32,42,32,112,105,112,101,51,46,110,80,97,114,97,108,108,101,108,0,0,1,0,0,0,219,9,0,0,112,105,112,101,51,46,112,97,116,104,76,101,110,103,116,104,115,91,49,93,0,0,0,0,1,0,0,0,220,9,0,0,1,0,0,0,223,9,0,0,1,0,0,0,233,9,0,0,1,0,0,0,234,9,0,0,1,0,0,0,237,9,0,0,1,0,0,0,247,9,0,0,1,0,0,0,250,9,0,0,109,97,120,40,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,54,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,1,0,0,0,4,10,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,112,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,7,10,0,0,49,46,48,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,88,95,108,105,113,117,105,100,0,1,0,0,0,9,10,0,0,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,84,32,42,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,82,0,1,0,0,0,13,10,0,0,112,105,112,101,49,46,109,115,91,53,93,0,0,0,0,0,1,0,0,0,15,10,0,0,112,105,112,101,49,46,99,114,111,115,115,65,114,101,97,115,91,53,93,32,42,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,100,32,42,32,112,105,112,101,49,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,1,0,0,0,18,10,0,0,112,105,112,101,49,46,112,97,116,104,76,101,110,103,116,104,115,91,54,93,0,0,0,0,1,0,0,0,19,10,0,0,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,54,93,46,88,91,50,93,41,0,0,0,1,0,0,0,20,10,0,0,1,0,0,0,26,10,0,0,109,97,120,40,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,53,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,1,0,0,0,36,10,0,0,1,0,0,0,48,10,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,112,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,51,10,0,0,49,46,48,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,88,95,108,105,113,117,105,100,0,1,0,0,0,53,10,0,0,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,84,32,42,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,82,0,1,0,0,0,57,10,0,0,112,105,112,101,49,46,109,115,91,52,93,0,0,0,0,0,1,0,0,0,59,10,0,0,112,105,112,101,49,46,99,114,111,115,115,65,114,101,97,115,91,52,93,32,42,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,100,32,42,32,112,105,112,101,49,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,1,0,0,0,62,10,0,0,112,105,112,101,49,46,112,97,116,104,76,101,110,103,116,104,115,91,53,93,0,0,0,0,1,0,0,0,63,10,0,0,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,53,93,46,88,91,50,93,41,0,0,0,1,0,0,0,64,10,0,0,1,0,0,0,70,10,0,0,109,97,120,40,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,52,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,1,0,0,0,80,10,0,0,1,0,0,0,92,10,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,112,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,95,10,0,0,49,46,48,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,88,95,108,105,113,117,105,100,0,1,0,0,0,97,10,0,0,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,84,32,42,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,82,0,1,0,0,0,101,10,0,0,112,105,112,101,49,46,109,115,91,51,93,0,0,0,0,0,1,0,0,0,103,10,0,0,112,105,112,101,49,46,99,114,111,115,115,65,114,101,97,115,91,51,93,32,42,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,100,32,42,32,112,105,112,101,49,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,1,0,0,0,106,10,0,0,112,105,112,101,49,46,112,97,116,104,76,101,110,103,116,104,115,91,52,93,0,0,0,0,1,0,0,0,107,10,0,0,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,52,93,46,88,91,50,93,41,0,0,0,1,0,0,0,108,10,0,0,1,0,0,0,114,10,0,0,109,97,120,40,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,51,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,1,0,0,0,124,10,0,0,1,0,0,0,136,10,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,139,10,0,0,49,46,48,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,88,95,108,105,113,117,105,100,0,1,0,0,0,141,10,0,0,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,84,32,42,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,82,0,1,0,0,0,145,10,0,0,112,105,112,101,49,46,109,115,91,50,93,0,0,0,0,0,1,0,0,0,147,10,0,0,112,105,112,101,49,46,99,114,111,115,115,65,114,101,97,115,91,50,93,32,42,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,100,32,42,32,112,105,112,101,49,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,1,0,0,0,150,10,0,0,112,105,112,101,49,46,112,97,116,104,76,101,110,103,116,104,115,91,51,93,0,0,0,0,1,0,0,0,151,10,0,0,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,51,93,46,88,91,50,93,41,0,0,0,1,0,0,0,152,10,0,0,1,0,0,0,160,10,0,0,109,97,120,40,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,50,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,1,0,0,0,172,10,0,0,1,0,0,0,188,10,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,191,10,0,0,49,46,48,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,88,95,108,105,113,117,105,100,0,1,0,0,0,193,10,0,0,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,84,32,42,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,82,0,1,0,0,0,197,10,0,0,112,105,112,101,49,46,109,115,91,49,93,0,0,0,0,0,1,0,0,0,199,10,0,0,112,105,112,101,49,46,99,114,111,115,115,65,114,101,97,115,91,49,93,32,42,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,100,32,42,32,112,105,112,101,49,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,1,0,0,0,202,10,0,0,112,105,112,101,49,46,112,97,116,104,76,101,110,103,116,104,115,91,50,93,0,0,0,0,1,0,0,0,205,10,0,0,112,105,112,101,49,46,112,97,116,104,76,101,110,103,116,104,115,91,49,93,0,0,0,0,1,0,0,0,208,10,0,0,1,0,0,0,209,10,0,0,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,50,93,46,88,91,50,93,41,0,0,0,1,0,0,0,210,10,0,0,119,97,116,101,114,0,0,0,97,105,114,0,0,0,0,0,77,111,105,115,116,32,97,105,114,0,0,0,0,0,0,0,66,111,117,110,100,97,114,121,95,112,84,0,0,0,0,0,10,84,101,109,112,101,114,97,116,117,114,101,32,84,32,105,115,32,110,111,116,32,105,110,32,116,104,101,32,97,108,108,111,119,101,100,32,114,97,110,103,101,10,49,57,48,46,48,32,75,32,60,61,32,40,84,32,61,0,0,0,0,0,0,32,75,41,32,60,61,32,54,52,55,46,48,32,75,10,114,101,113,117,105,114,101,100,32,102,114,111,109,32,109,101,100,105,117,109,32,109,111,100,101,108,32,34,0,0,0,0,0,34,46,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,65,105,114,47,77,111,105,115,116,65,105,114,46,109,111,0,0,0,0,0,0,77,97,115,115,32,102,114,97,99,116,105,111,110,32,88,91,49,93,32,61,32,0,0,0,111,102,32,115,117,98,115,116,97,110,99,101,32,0,0,0,10,111,102,32,109,101,100,105,117,109,32,0,0,0,0,0,32,105,115,32,110,111,116,32,105,110,32,116,104,101,32,114,97,110,103,101,32,48,46,46,49,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,112,97,99,107,97,103,101,46,109,111,0,0,0,77,97,115,115,32,102,114,97,99,116,105,111,110,32,88,91,50,93,32,61,32,0,0,0,80,114,101,115,115,117,114,101,32,40,61,32,0,0,0,0,32,80,97,41,32,111,102,32,109,101,100,105,117,109,32,34,0,0,0,0,0,0,0,0,34,32,105,115,32,110,101,103,97,116,105,118,101,10,40,84,101,109,112,101,114,97,116,117,114,101,32,61,32,0,0,0,32,75,41,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,80,105,112,101,115,46,109,111,0,0,0,0,0,80,97,114,97,109,101,116,101,114,32,108,101,110,103,116,104,32,109,117,115,116,32,98,101,32,103,114,101,97,116,101,114,32,111,114,32,101,113,117,97,108,32,104,101,105,103,104,116,95,97,98,46,0,0,0,0,144,66,0,0,64,0,0,0,7,0,0,0,67,0,0,0,53,0,0,0,0,0,0,0,56,67,0,0,74,17,0,0,11,0,0,0,77,17,0,0,41,0,0,0,0,0,0,0,232,67,0,0,25,1,0,0,7,0,0,0,25,1,0,0,90,0,0,0,0,0,0,0,56,67,0,0,82,17,0,0,7,0,0,0,83,17,0,0,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,1,0,0,0,8,0,0,0,9,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,1,0,0,0,3,0,0,0,13,0,0,0,4,0,0,0,14,0,0,0,6,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,1,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,69,114,114,111,114,32,119,104,105,108,101,32,105,110,105,116,105,97,108,105,122,101,32,68,97,116,97,0,0,0,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,69,120,97,109,112,108,101,115,46,66,114,97,110,99,104,105,110,103,68,121,110,97,109,105,99,80,105,112,101,115,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,69,120,97,109,112,108,101,115,0,0,0,0,0,123,56,99,52,101,56,49,48,102,45,51,100,102,51,45,52,97,48,48,45,56,50,55,54,45,49,55,54,102,97,51,99,57,102,57,101,48,125,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,69,120,97,109,112,108,101,115,46,66,114,97,110,99,104,105,110,103,68,121,110,97,109,105,99,80,105,112,101,115,95,105,110,102,111,46,120,109,108,0,0,83,116,97,99,107,32,111,118,101,114,102,108,111,119,32,100,101,116,101,99,116,101,100,32,97,110,100,32,119,97,115,32,110,111,116,32,99,97,117,103,104,116,46,10,83,101,110,100,32,117,115,32,97,32,98,117,103,32,114,101,112,111,114,116,32,97,116,32,104,116,116,112,115,58,47,47,116,114,97,99,46,111,112,101,110,109,111,100,101,108,105,99,97,46,111,114,103,47,79,112,101,110,77,111,100,101,108,105,99,97,47,110,101,119,116,105,99,107,101,116,10,32,32,32,32,73,110,99,108,117,100,101,32,116,104,101,32,102,111,108,108,111,119,105,110,103,32,116,114,97,99,101,58,10,0,0,0,0,0,0,69,120,101,99,117,116,105,111,110,32,102,97,105,108,101,100,33,10,0,0,0,0,0,0,2,0,0,0,0,0,0,0,12,229,68,187,110,9,203,192,19,83,84,195,159,233,31,192,7,0,0,0,0,0,0,0,121,233,38,49,184,149,47,65,117,32,235,169,101,217,162,192,175,197,118,16,158,149,18,64,4,118,172,56,171,198,98,63,93,203,6,236,202,240,166,190,56,28,173,173,73,233,217,61,3,149,235,130,211,183,245,188,2,0,0,0,0,0,0,0,181,166,121,199,247,33,224,192,76,254,39,127,247,61,49,64,7,0,0,0,0,0,0,0,197,143,49,119,243,70,227,192,45,90,128,182,149,252,129,64,8,175,179,218,41,209,237,63,23,132,90,56,144,149,125,63,249,233,45,205,2,204,222,190,111,33,62,192,32,72,53,62,140,233,235,22,3,133,119,189,1,0,0,0,0,0,0,0,123,20,174,71,225,122,132,63,2,0,0,0,0,0,0,0,123,20,174,71,225,122,132,63,174,71,225,122,20,174,239,63,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,54,52,46,48,32,42,32,82,101,49,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,82,101,49,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,97,117,120,50,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,76,50,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,97,117,120,52,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,76,50,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,97,117,120,53,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,108,97,109,98,100,97,50,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,1,0,0,0,88,85,0,0,96,85,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,108,97,109,98,100,97,50,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,50,46,53,49,32,47,32,115,113,114,116,40,108,97,109,98,100,97,50,41,32,43,32,48,46,50,55,32,42,32,68,101,108,116,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,97,117,120,49,32,42,32,97,98,115,40,100,112,95,102,114,105,99,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,50,46,53,49,32,47,32,97,117,120,50,32,43,32,48,46,50,55,32,42,32,68,101,108,116,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,68,101,108,116,97,32,47,32,51,46,55,32,43,32,53,46,55,52,32,47,32,82,101,32,94,32,48,46,57,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,82,101,50,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,82,101,32,47,32,82,101,49,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,1,0,0,0,32,85,0,0,40,85,0,0,0,0,0,0,1,0,0,0,232,84,0,0,240,84,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,101,120,112,40,52,46,48,32,42,32,40,120,49,32,45,32,109,97,120,40,120,49,44,32,120,50,41,41,32,47,32,100,120,41,32,43,32,101,120,112,40,52,46,48,32,42,32,40,120,50,32,45,32,109,97,120,40,120,49,44,32,120,50,41,41,32,47,32,100,120,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,72,50,79,0,0,0,0,0,1,0,0,0,168,84,0,0,176,84,0,0,0,0,0,0,1,0,0,0,144,84,0,0,152,84,0,0,0,0,0,0,1,0,0,0,80,84,0,0,88,84,0,0,0,0,0,0,1,0,0,0,56,84,0,0,64,84,0,0,0,0,0,0,65,105,114,0,0,0,0,0,1,0,0,0,248,83,0,0,0,84,0,0,0,0,0,0,1,0,0,0,224,83,0,0,232,83,0,0,0,0,0,0,1,0,0,0,160,83,0,0,168,83,0,0,0,0,0,0,1,0,0,0,136,83,0,0,144,83,0,0,0,0,0,0,1,0,0,0,112,83,0,0,120,83,0,0,0,0,0,0,1,0,0,0,88,83,0,0,96,83,0,0,0,0,0,0,1,0,0,0,64,83,0,0,72,83,0,0,0,0,0,0,1,0,0,0,8,83,0,0,16,83,0,0,0,0,0,0,84,104,101,32,97,114,103,117,109,101,110,116,115,32,120,95,109,105,110,32,97,110,100,32,120,95,109,97,120,32,116,111,32,79,110,101,78,111,110,76,105,110,101,97,114,69,113,117,97,116,105,111,110,46,115,111,108,118,101,40,46,46,41,10,100,111,32,110,111,116,32,98,114,97,99,107,101,116,32,116,104,101,32,114,111,111,116,32,111,102,32,116,104,101,32,115,105,110,103,108,101,32,110,111,110,45,108,105,110,101,97,114,32,101,113,117,97,116,105,111,110,58,10,32,32,120,95,109,105,110,32,32,61,32,0,0,10,0,0,0,0,0,0,0,32,32,120,95,109,97,120,32,32,61,32,0,0,0,0,0,32,32,121,95,122,101,114,111,32,61,32,0,0,0,0,0,32,32,102,97,32,61,32,102,40,120,95,109,105,110,41,32,45,32,121,95,122,101,114,111,32,61,32,0,0,0,0,0,32,32,102,98,32,61,32,102,40,120,95,109,97,120,41,32,45,32,121,95,122,101,114,111,32,61,32,0,0,0,0,0,102,97,32,97,110,100,32,102,98,32,109,117,115,116,32,104,97,118,101,32,111,112,112,111,115,105,116,101,32,115,105,103,110,32,119,104,105,99,104,32,105,115,32,110,111,116,32,116,104,101,32,99,97,115,101,0,32,72,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,84,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,10,87,114,111,110,103,32,118,97,108,117,101,32,111,102,32,112,97,114,97,109,101,116,101,114,32,100,101,102,105,110,101,95,112,32,40,61,32,102,97,108,115,101,41,32,105,110,32,109,111,100,101,108,32,34,0,34,58,10,84,104,101,32,115,101,108,101,99,116,101,100,32,109,101,100,105,117,109,32,34,0,0,0,0,0,0,0,0,34,32,104,97,115,32,77,101,100,105,117,109,46,115,105,110,103,108,101,83,116,97,116,101,61,116,114,117,101,46,10,84,104,101,114,101,102,111,114,101,44,32,97,110,32,98,111,117,110,100,97,114,121,32,100,101,110,115,105,116,121,32,99,97,110,110,111,116,32,98,101,32,100,101,102,105,110,101,100,32,97,110,100,10,100,101,102,105,110,101,95,112,32,61,32,116,114,117,101,32,105,115,32,114,101,113,117,105,114,101,100,46,10,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+10240);
/* memory initializer */ allocate([107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,85,116,105,108,105,116,105,101,115,46,109,111,0,248,79,0,0,18,0,0,0,5,0,0,0,23,0,0,0,3,0,0,0,0,0,0,0,10,87,114,111,110,103,32,98,111,117,110,100,97,114,121,32,109,97,115,115,32,102,114,97,99,116,105,111,110,115,32,105,110,32,109,101,100,105,117,109,32,34,0,0,0,0,0,0,34,32,105,110,32,109,111,100,101,108,32,34,0,0,0,0,34,58,10,84,104,101,32,98,111,117,110,100,97,114,121,32,118,97,108,117,101,32,88,95,98,111,117,110,100,97,114,121,40,0,0,0,0,0,0,0,41,32,61,32,0,0,0,0,10,105,115,32,110,101,103,97,116,105,118,101,46,32,73,116,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,46,10,0,0,0,0,0,248,79,0,0,26,0,0,0,7,0,0,0,33,0,0,0,3,0,0,0,0,0,0,0,32,32,32,88,95,98,111,117,110,100,97,114,121,91,0,0,93,32,61,32,0,0,0,0,32,34,0,0,0,0,0,0,34,10,0,0,0,0,0,0,84,104,101,32,98,111,117,110,100,97,114,121,32,109,97,115,115,32,102,114,97,99,116,105,111,110,115,32,105,110,32,109,101,100,105,117,109,32,34,0,100,111,32,110,111,116,32,115,117,109,32,117,112,32,116,111,32,49,46,32,73,110,115,116,101,97,100,44,32,115,117,109,40,88,95,98,111,117,110,100,97,114,121,41,32,61,32,0,58,10,0,0,0,0,0,0,114,101,103,70,117,110,51,40,41,58,32,68,97,116,97,32,112,111,105,110,116,115,32,110,111,116,32,115,111,114,116,101,100,32,97,112,112,114,111,112,114,105,97,116,101,108,121,32,40,120,48,32,61,32,0,0,32,62,32,120,49,32,61,32,0,0,0,0,0,0,0,0,41,46,32,80,108,101,97,115,101,32,102,108,105,112,32,97,114,103,117,109,101,110,116,115,46,0,0,0,0,0,0,0,248,79,0,0,94,2,0,0,5,0,0,0,95,2,0,0,74,0,0,0,0,0,0,0,114,101,103,70,117,110,51,40,41,58,32,68,101,114,105,118,97,116,105,118,101,115,32,97,116,32,100,97,116,97,32,112,111,105,110,116,115,32,100,111,32,110,111,116,32,97,108,108,111,119,32,99,111,45,109,111,110,111,116,111,110,101,32,105,110,116,101,114,112,111,108,97,116,105,111,110,44,32,97,115,32,98,111,116,104,32,97,114,101,32,110,111,110,45,122,101,114,111,44,32,111,102,32,111,112,112,111,115,105,116,101,32,115,105,103,110,32,97,110,100,32,104,97,118,101,32,97,110,32,97,98,115,111,108,117,116,101,32,118,97,108,117,101,32,108,97,114,103,101,114,32,116,104,97,110,32,109,97,99,104,105,110,101,32,101,112,115,32,40,121,48,100,32,61,32,0,44,32,121,49,100,32,61,32,0,0,0,0,0,0,0,0,41,46,32,80,108,101,97,115,101,32,99,111,114,114,101,99,116,32,97,114,103,117,109,101,110,116,115,46,0,0,0,0,248,79,0,0,101,2,0,0,7,0,0,0,102,2,0,0,79,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,182,149,253,60,0,104,186,121,186,180,194,189,212,192,194,46,166,154,108,62,20,204,23,96,139,197,7,191,46,25,181,1,60,125,179,63,214,170,210,28,99,43,56,64,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,248,191,0,0,0,0,0,0,244,191,2,0,0,0,0,0,0,0,114,82,152,247,56,219,43,192,76,42,100,248,153,90,65,64,2,0,0,0,0,0,0,0,162,122,107,96,67,62,185,64,57,8,190,146,121,75,32,192,7,0,0,0,0,0,0,0,129,149,67,139,139,123,13,65,84,116,36,151,127,167,147,192,86,3,32,48,7,148,20,64,191,0,235,104,193,7,44,191,112,212,172,6,48,247,114,62,222,123,98,114,234,143,167,189,158,71,225,37,243,178,199,60,2,0,0,0,0,0,0,0,179,150,2,210,126,25,102,192,177,1,108,155,61,95,15,192,7,0,0,0,0,0,0,0,214,197,109,52,192,185,195,64,62,206,52,97,123,154,104,192,70,42,8,245,95,9,20,64,80,152,254,88,220,152,119,191,28,23,112,31,169,95,230,62,241,202,212,151,57,13,65,190,85,166,72,110,180,56,131,61,2,0,0,0,0,0,0,0,12,229,68,187,110,9,203,192,19,83,84,195,159,233,31,192,7,0,0,0,0,0,0,0,121,233,38,49,184,149,47,65,117,32,235,169,101,217,162,192,175,197,118,16,158,149,18,64,4,118,172,56,171,198,98,63,93,203,6,236,202,240,166,190,56,28,173,173,73,233,217,61,3,149,235,130,211,183,245,188,2,0,0,0,0,0,0,0,181,166,121,199,247,33,224,192,76,254,39,127,247,61,49,64,7,0,0,0,0,0,0,0,197,143,49,119,243,70,227,192,45,90,128,182,149,252,129,64,8,175,179,218,41,209,237,63,23,132,90,56,144,149,125,63,249,233,45,205,2,204,222,190,111,33,62,192,32,72,53,62,140,233,235,22,3,133,119,189,6,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,248,63,0,0,0,0,0,0,8,64,0,0,0,0,0,0,12,64,0,0,0,0,0,0,16,64,0,0,0,0,0,0,30,64,6,0,0,0,0,0,0,0,46,183,40,113,37,112,31,192,131,196,242,190,92,129,253,63,1,209,221,191,195,146,39,192,6,139,121,12,69,174,54,64,253,225,66,121,122,236,47,192,238,48,154,83,209,209,252,63,6,0,0,0,0,0,0,0,0,0,0,0,55,238,5,61,1,100,56,253,164,60,193,189,194,40,108,148,139,22,103,62,124,86,91,163,224,10,4,191,47,124,109,174,174,209,169,63,119,72,9,39,64,61,49,64,99,97,108,108,32,101,120,116,101,114,110,97,108,32,79,98,106,101,99,116,32,67,111,110,115,116,114,117,99,116,111,114,115,0,0,0,0,0,0,0,99,97,108,108,32,101,120,116,101,114,110,97,108,32,79,98,106,101,99,116,32,67,111,110,115,116,114,117,99,116,111,114,115,32,102,105,110,105,115,104,101,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,96,1,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,84,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,84,41,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,84,41,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,84,41,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,84,0,0,0,0,0,0,1,0,0,0,97,1,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,84,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,84,41,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,84,41,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,84,41,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,84,0,0,0,0,0,0,1,0,0,0,100,1,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,84,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,84,41,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,84,41,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,84,41,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,84,0,0,0,0,0,0,1,0,0,0,102,1,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,84,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,84,41,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,84,41,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,84,41,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,84,0,0,0,0,0,0,1,0,0,0,107,1,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,84,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,84,41,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,84,41,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,84,41,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,84,0,0,0,0,0,0,1,0,0,0,110,1,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,84,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,84,41,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,84,41,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,84,41,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,84,0,0,0,0,0,0,1,0,0,0,117,1,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,112,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,112,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,112,95,115,116,101,97,109,95,115,97,116,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,112,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,118,1,0,0,1,0,0,0,123,1,0,0,40,49,46,48,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,88,95,108,105,113,117,105,100,41,32,94,32,50,46,48,0,1,0,0,0,124,1,0,0,49,46,48,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,88,95,108,105,113,117,105,100,0,1,0,0,0,126,1,0,0,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,84,32,42,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,82,0,1,0,0,0,131,1,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,134,1,0,0,49,46,48,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,88,95,108,105,113,117,105,100,0,1,0,0,0,136,1,0,0,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,84,32,42,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,82,0,1,0,0,0,138,1,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,141,1,0,0,40,49,46,48,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,88,95,108,105,113,117,105,100,41,32,94,32,50,46,48,0,1,0,0,0,142,1,0,0,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,82,32,42,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,84,41,32,94,32,50,46,48,0,1,0,0,0,148,1,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,151,1,0,0,49,46,48,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,88,95,108,105,113,117,105,100,0,1,0,0,0,153,1,0,0,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,84,32,42,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,82,0,1,0,0,0,156,1,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,159,1,0,0,40,49,46,48,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,88,95,108,105,113,117,105,100,41,32,94,32,50,46,48,0,1,0,0,0,160,1,0,0,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,82,32,42,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,84,41,32,94,32,50,46,48,0,1,0,0,0,168,1,0,0,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,82,32,42,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,84,41,32,94,32,50,46,48,0,1,0,0,0,174,1,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,84,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,84,41,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,84,41,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,84,41,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,84,0,0,0,0,0,0,1,0,0,0,178,1,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,84,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,84,41,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,112,32,45,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+20480);
/* memory initializer */ allocate([77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,84,41,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,84,41,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,84,0,0,0,0,0,0,1,0,0,0,180,1,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,84,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,84,41,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,84,41,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,84,41,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,84,0,0,0,0,0,0,1,0,0,0,182,1,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,84,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,84,41,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,84,41,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,84,41,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,84,0,0,0,0,0,0,1,0,0,0,196,1,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,112,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,199,1,0,0,49,46,48,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,88,95,108,105,113,117,105,100,0,1,0,0,0,201,1,0,0,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,84,32,42,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,82,0,1,0,0,0,203,1,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,112,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,112,95,115,116,101,97,109,95,115,97,116,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,112,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,206,1,0,0,40,49,46,48,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,88,95,108,105,113,117,105,100,41,32,94,32,50,46,48,0,1,0,0,0,207,1,0,0,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,82,32,42,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,84,41,32,94,32,50,46,48,0,1,0,0,0,210,1,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,84,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,84,41,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,84,41,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,84,41,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,84,0,0,0,0,0,0,1,0,0,0,216,1,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,112,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,112,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,112,95,115,116,101,97,109,95,115,97,116,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,112,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,225,1,0,0,1,0,0,0,230,1,0,0,40,49,46,48,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,88,95,108,105,113,117,105,100,41,32,94,32,50,46,48,0,1,0,0,0,231,1,0,0,49,46,48,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,88,95,108,105,113,117,105,100,0,1,0,0,0,234,1,0,0,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,82,32,42,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,84,41,32,94,32,50,46,48,0,1,0,0,0,236,1,0,0,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,84,32,42,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,82,0,1,0,0,0,243,1,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,112,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,246,1,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,112,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,112,95,115,116,101,97,109,95,115,97,116,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,112,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,249,1,0,0,40,49,46,48,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,88,95,108,105,113,117,105,100,41,32,94,32,50,46,48,0,1,0,0,0,251,1,0,0,49,46,48,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,88,95,108,105,113,117,105,100,0,1,0,0,0,253,1,0,0,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,84,32,42,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,82,0,1,0,0,0,0,2,0,0,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,82,32,42,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,84,41,32,94,32,50,46,48,0,1,0,0,0,12,2,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,84,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,84,41,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,84,41,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,84,41,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,84,0,0,0,0,0,0,1,0,0,0,15,2,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,84,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,84,41,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,84,41,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,84,41,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,84,0,0,0,0,0,0,1,0,0,0,18,2,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,84,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,84,41,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,84,41,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,84,41,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,84,0,0,0,0,0,0,1,0,0,0,21,2,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,84,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,84,41,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,84,41,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,84,41,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,84,0,0,0,0,0,0,1,0,0,0,23,2,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,84,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,84,41,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,84,41,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,84,41,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,84,0,0,0,0,0,0,1,0,0,0,24,2,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,84,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+30720);
/* memory initializer */ allocate([111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,84,41,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,84,41,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,84,41,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,84,0,0,0,0,0,0,1,0,0,0,26,2,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,84,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,84,41,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,84,41,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,84,41,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,84,0,0,0,0,0,0,1,0,0,0,32,2,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,84,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,84,41,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,84,41,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,84,41,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,84,0,0,0,0,0,0,1,0,0,0,40,2,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,112,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,112,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,112,95,115,116,101,97,109,95,115,97,116,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,112,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,41,2,0,0,1,0,0,0,46,2,0,0,40,49,46,48,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,88,95,108,105,113,117,105,100,41,32,94,32,50,46,48,0,1,0,0,0,47,2,0,0,49,46,48,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,88,95,108,105,113,117,105,100,0,1,0,0,0,49,2,0,0,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,82,32,42,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,84,41,32,94,32,50,46,48,0,1,0,0,0,52,2,0,0,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,84,32,42,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,82,0,1,0,0,0,60,2,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,112,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,63,2,0,0,49,46,48,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,88,95,108,105,113,117,105,100,0,1,0,0,0,65,2,0,0,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,84,32,42,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,82,0,1,0,0,0,67,2,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,112,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,112,95,115,116,101,97,109,95,115,97,116,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,112,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,70,2,0,0,40,49,46,48,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,88,95,108,105,113,117,105,100,41,32,94,32,50,46,48,0,1,0,0,0,71,2,0,0,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,82,32,42,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,84,41,32,94,32,50,46,48,0,1,0,0,0,83,2,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,112,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,112,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,112,95,115,116,101,97,109,95,115,97,116,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,112,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,84,2,0,0,1,0,0,0,89,2,0,0,40,49,46,48,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,88,95,108,105,113,117,105,100,41,32,94,32,50,46,48,0,1,0,0,0,90,2,0,0,49,46,48,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,88,95,108,105,113,117,105,100,0,1,0,0,0,92,2,0,0,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,84,32,42,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,82,0,1,0,0,0,94,2,0,0,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,82,32,42,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,84,41,32,94,32,50,46,48,0,1,0,0,0,102,2,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,103,2,0,0,1,0,0,0,108,2,0,0,40,49,46,48,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,88,95,108,105,113,117,105,100,41,32,94,32,50,46,48,0,1,0,0,0,109,2,0,0,49,46,48,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,88,95,108,105,113,117,105,100,0,1,0,0,0,110,2,0,0,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,82,32,42,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,84,41,32,94,32,50,46,48,0,1,0,0,0,113,2,0,0,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,84,32,42,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,82,0,1,0,0,0,123,2,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,126,2,0,0,49,46,48,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,88,95,108,105,113,117,105,100,0,1,0,0,0,127,2,0,0,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,84,32,42,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,82,0,1,0,0,0,129,2,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,132,2,0,0,40,49,46,48,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,88,95,108,105,113,117,105,100,41,32,94,32,50,46,48,0,1,0,0,0,134,2,0,0,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,82,32,42,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,84,41,32,94,32,50,46,48,0,1,0,0,0,145,2,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,112,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,148,2,0,0,49,46,48,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,88,95,108,105,113,117,105,100,0,1,0,0,0,149,2,0,0,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,84,32,42,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,82,0,1,0,0,0,151,2,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,112,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,112,95,115,116,101,97,109,95,115,97,116,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,112,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,154,2,0,0,40,49,46,48,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,88,95,108,105,113,117,105,100,41,32,94,32,50,46,48,0,1,0,0,0,156,2,0,0,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,82,32,42,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,84,41,32,94,32,50,46,48,0,1,0,0,0,160,2,0,0,112,105,112,101,51,46,99,114,111,115,115,65,114,101,97,115,91,53,93,32,42,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,100,32,42,32,112,105,112,101,51,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,1,0,0,0,172,2,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,112,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,175,2,0,0,49,46,48,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,88,95,108,105,113,117,105,100,0,1,0,0,0,176,2,0,0,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,84,32,42,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,82,0,1,0,0,0,178,2,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,112,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,112,95,115,116,101,97,109,95,115,97,116,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,112,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,181,2,0,0,40,49,46,48,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,88,95,108,105,113,117,105,100,41,32,94,32,50,46,48,0,1,0,0,0,182,2,0,0,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,82,32,42,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,84,41,32,94,32,50,46,48,0,1,0,0,0,185,2,0,0,112,105,112,101,51,46,99,114,111,115,115,65,114,101,97,115,91,52,93,32,42,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,100,32,42,32,112,105,112,101,51,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,1,0,0,0,188,2,0,0,40,112,105,112,101,51,46,99,114,111,115,115,65,114,101,97,115,91,52,93,32,43,32,112,105,112,101,51,46,99,114,111,115,115,65,114,101,97,115,91,53,93,41,32,42,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,1,0,0,0,199,2,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,112,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,202,2,0,0,49,46,48,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,88,95,108,105,113,117,105,100,0,1,0,0,0,204,2,0,0,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,84,32,42,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,82,0,1,0,0,0,206,2,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,112,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,112,95,115,116,101,97,109,95,115,97,116,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,112,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,209,2,0,0,40,49,46,48,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,88,95,108,105,113,117,105,100,41,32,94,32,50,46,48,0,1,0,0,0,210,2,0,0,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,82,32,42,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,84,41,32,94,32,50,46,48,0,1,0,0,0,213,2,0,0,112,105,112,101,51,46,99,114,111,115,115,65,114,101,97,115,91,51,93,32,42,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,100,32,42,32,112,105,112,101,51,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,1,0,0,0,221,2,0,0,40,112,105,112,101,51,46,99,114,111,115,115,65,114,101,97,115,91,51,93,32,43,32,112,105,112,101,51,46,99,114,111,115,115,65,114,101,97,115,91,52,93,41,32,42,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,1,0,0,0,229,2,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,230,2,0,0,1,0,0,0,235,2,0,0,40,49,46,48,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,88,95,108,105,113,117,105,100,41,32,94,32,50,46,48,0,1,0,0,0,236,2,0,0,49,46,48,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,88,95,108,105,113,117,105,100,0,1,0,0,0,238,2,0,0,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,82,32,42,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,84,41,32,94,32,50,46,48,0,1,0,0,0,242,2,0,0,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,84,32,42,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,82,0,1,0,0,0,247,2,0,0,112,105,112,101,51,46,99,114,111,115,115,65,114,101,97,115,91,50,93,32,42,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,100,32,42,32,112,105,112,101,51,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,1,0,0,0,250,2,0,0,40,112,105,112,101,51,46,99,114,111,115,115,65,114,101,97,115,91,50,93,32,43,32,112,105,112,101,51,46,99,114,111,115,115,65,114,101,97,115,91,51,93,41,32,42,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,1,0,0,0,2,3,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,84,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,84,41,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,84,41,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,84,41,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,84,0,0,0,0,0,0,1,0,0,0,12,3,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,112,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,15,3,0,0,49,46,48,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,88,95,108,105,113,117,105,100,0,1,0,0,0,16,3,0,0,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,84,32,42,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,82,0,1,0,0,0,18,3,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,112,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,112,95,115,116,101,97,109,95,115,97,116,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,112,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,21,3,0,0,40,49,46,48,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,88,95,108,105,113,117,105,100,41,32,94,32,50,46,48,0,1,0,0,0,23,3,0,0,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,82,32,42,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,84,41,32,94,32,50,46,48,0,1,0,0,0,30,3,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,112,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,33,3,0,0,49,46,48,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,88,95,108,105,113,117,105,100,0,1,0,0,0,35,3,0,0,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,84,32,42,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,82,0,1,0,0,0,37,3,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,112,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,112,95,115,116,101,97,109,95,115,97,116,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,112,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,40,3,0,0,40,49,46,48,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,88,95,108,105,113,117,105,100,41,32,94,32,50,46,48,0,1,0,0,0,41,3,0,0,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,82,32,42,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,84,41,32,94,32,50,46,48,0,1,0,0,0,50,3,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,53,3,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,56,3,0,0,40,49,46,48,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,88,95,108,105,113,117,105,100,41,32,94,32,50,46,48,0,1,0,0,0,57,3,0,0,49,46,48,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,88,95,108,105,113,117,105,100,0,1,0,0,0,59,3,0,0,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,84,32,42,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,82,0,1,0,0,0,61,3,0,0,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,82,32,42,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,84,41,32,94,32,50,46,48,0,1,0,0,0,77,3,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,80,3,0,0,49,46,48,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,88,95,108,105,113,117,105,100,0,1,0,0,0,82,3,0,0,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,84,32,42,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,82,0,1,0,0,0,84,3,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,87,3,0,0,40,49,46,48,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,88,95,108,105,113,117,105,100,41,32,94,32,50,46,48,0,1,0,0,0,89,3,0,0,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,82,32,42,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,84,41,32,94,32,50,46,48,0,1,0,0,0,106,3,0,0,109,97,120,40,112,105,112,101,50,46,109,95,102,108,111,119,115,91,54,93,44,32,49,101,45,49,53,41,32,43,32,109,97,120,40,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,54,93,44,32,49,101,45,49,53,41,0,0,0,72,50,79,0,0,0,0,0,1,0,0,0,107,3,0,0,1,0,0,0,109,3,0,0,109,97,120,40,112,105,112,101,50,46,109,95,102,108,111,119,115,91,54,93,44,32,49,101,45,49,53,41,32,43,32,109,97,120,40,45,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,44,32,49,101,45,49,53,41,0,0,1,0,0,0,122,3,0,0,112,105,112,101,52,46,99,114,111,115,115,65,114,101,97,115,91,53,93,32,42,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,100,32,42,32,112,105,112,101,52,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,1,0,0,0,123,3,0,0,112,105,112,101,52,46,110,80,97,114,97,108,108,101,108,32,42,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,100,101,110,115,105,116,121,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,84,104,101,114,109,111,100,121,110,97,109,105,99,83,116,97,116,101,40,98,111,117,110,100,97,114,121,52,46,112,95,105,110,44,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,55,93,46,84,44,32,123,48,46,48,49,44,32,48,46,57,57,125,41,41,32,42,32,112,105,112,101,52,46,99,114,111,115,115,65,114,101,97,115,91,53,93,0,0,1,0,0,0,126,3,0,0,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,112,105,112,101,52,46,99,114,111,115,115,65,114,101,97,115,91,53,93,0,1,0,0,0,130,3,0,0,112,105,112,101,52,46,99,114,111,115,115,65,114,101,97,115,91,52,93,32,42,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,100,32,42,32,112,105,112,101,52,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,1,0,0,0,133,3,0,0,40,112,105,112,101,52,46,99,114,111,115,115,65,114,101,97,115,91,52,93,32,43,32,112,105,112,101,52,46,99,114,111,115,115,65,114,101,97,115,91,53,93,41,32,42,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,1,0,0,0,134,3,0,0,112,105,112,101,52,46,99,114,111,115,115,65,114,101,97,115,91,51,93,32,42,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,100,32,42,32,112,105,112,101,52,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,1,0,0,0,137,3,0,0,40,112,105,112,101,52,46,99,114,111,115,115,65,114,101,97], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+40960);
/* memory initializer */ allocate([115,91,51,93,32,43,32,112,105,112,101,52,46,99,114,111,115,115,65,114,101,97,115,91,52,93,41,32,42,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,1,0,0,0,138,3,0,0,112,105,112,101,52,46,99,114,111,115,115,65,114,101,97,115,91,50,93,32,42,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,100,32,42,32,112,105,112,101,52,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,1,0,0,0,141,3,0,0,40,112,105,112,101,52,46,99,114,111,115,115,65,114,101,97,115,91,50,93,32,43,32,112,105,112,101,52,46,99,114,111,115,115,65,114,101,97,115,91,51,93,41,32,42,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,1,0,0,0,145,3,0,0,112,105,112,101,52,46,99,114,111,115,115,65,114,101,97,115,91,49,93,32,42,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,100,32,42,32,112,105,112,101,52,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,1,0,0,0,148,3,0,0,40,112,105,112,101,52,46,99,114,111,115,115,65,114,101,97,115,91,49,93,32,43,32,112,105,112,101,52,46,99,114,111,115,115,65,114,101,97,115,91,50,93,41,32,42,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,1,0,0,0,149,3,0,0,1,0,0,0,150,3,0,0,112,105,112,101,52,46,99,114,111,115,115,65,114,101,97,115,91,49,93,32,42,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,100,101,110,115,105,116,121,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,84,104,101,114,109,111,100,121,110,97,109,105,99,83,116,97,116,101,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,112,44,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,49,93,46,84,44,32,123,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,49,93,46,88,91,49,93,44,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,49,93,46,88,91,50,93,125,41,41,32,42,32,112,105,112,101,52,46,110,80,97,114,97,108,108,101,108,0,0,1,0,0,0,155,3,0,0,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,112,105,112,101,52,46,99,114,111,115,115,65,114,101,97,115,91,49,93,0,1,0,0,0,157,3,0,0,1,0,0,0,163,3,0,0,1,0,0,0,164,3,0,0,1,0,0,0,167,3,0,0,112,105,112,101,51,46,99,114,111,115,115,65,114,101,97,115,91,53,93,32,42,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,100,101,110,115,105,116,121,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,84,104,101,114,109,111,100,121,110,97,109,105,99,83,116,97,116,101,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,112,44,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,55,93,46,84,44,32,123,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,55,93,46,88,91,49,93,44,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,55,93,46,88,91,50,93,125,41,41,32,42,32,112,105,112,101,51,46,110,80,97,114,97,108,108,101,108,0,0,1,0,0,0,170,3,0,0,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,112,105,112,101,51,46,99,114,111,115,115,65,114,101,97,115,91,53,93,0,1,0,0,0,172,3,0,0,1,0,0,0,173,3,0,0,1,0,0,0,176,3,0,0,1,0,0,0,179,3,0,0,109,97,120,40,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,54,93,44,32,49,101,45,49,53,41,32,43,32,109,97,120,40,45,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,44,32,49,101,45,49,53,41,0,0,0,0,0,0,0,0,1,0,0,0,181,3,0,0,112,105,112,101,50,46,99,114,111,115,115,65,114,101,97,115,91,53,93,32,42,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,100,32,42,32,112,105,112,101,50,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,53,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,1,0,0,0,184,3,0,0,40,105,102,32,112,105,112,101,50,46,118,115,91,53,93,32,62,61,32,48,46,48,32,116,104,101,110,32,52,46,53,32,101,108,115,101,32,48,46,53,41,32,42,32,112,105,112,101,50,46,108,101,110,103,116,104,115,91,53,93,0,0,0,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,53,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,53,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,0,0,0,0,1,0,0,0,185,3,0,0,1,0,0,0,187,3,0,0,112,105,112,101,50,46,99,114,111,115,115,65,114,101,97,115,91,52,93,32,42,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,100,32,42,32,112,105,112,101,50,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,1,0,0,0,189,3,0,0,40,105,102,32,112,105,112,101,50,46,118,115,91,52,93,32,62,61,32,48,46,48,32,116,104,101,110,32,51,46,53,32,101,108,115,101,32,49,46,53,41,32,42,32,112,105,112,101,50,46,108,101,110,103,116,104,115,91,52,93,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,52,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,1,0,0,0,192,3,0,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,52,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,52,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,0,0,0,0,1,0,0,0,195,3,0,0,40,112,105,112,101,50,46,99,114,111,115,115,65,114,101,97,115,91,52,93,32,43,32,112,105,112,101,50,46,99,114,111,115,115,65,114,101,97,115,91,53,93,41,32,42,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,1,0,0,0,198,3,0,0,52,48,46,48,32,42,32,104,101,97,116,50,91,53,93,46,97,108,112,104,97,0,0,0,1,0,0,0,202,3,0,0,112,105,112,101,50,46,99,114,111,115,115,65,114,101,97,115,91,51,93,32,42,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,100,32,42,32,112,105,112,101,50,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,1,0,0,0,204,3,0,0,112,105,112,101,50,46,108,101,110,103,116,104,115,91,51,93,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,51,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,1,0,0,0,207,3,0,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,51,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,51,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,0,0,0,0,1,0,0,0,210,3,0,0,40,112,105,112,101,50,46,99,114,111,115,115,65,114,101,97,115,91,51,93,32,43,32,112,105,112,101,50,46,99,114,111,115,115,65,114,101,97,115,91,52,93,41,32,42,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,1,0,0,0,213,3,0,0,52,48,46,48,32,42,32,104,101,97,116,50,91,52,93,46,97,108,112,104,97,0,0,0,1,0,0,0,214,3,0,0,112,105,112,101,50,46,99,114,111,115,115,65,114,101,97,115,91,50,93,32,42,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,100,32,42,32,112,105,112,101,50,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,1,0,0,0,217,3,0,0,40,112,105,112,101,50,46,99,114,111,115,115,65,114,101,97,115,91,50,93,32,43,32,112,105,112,101,50,46,99,114,111,115,115,65,114,101,97,115,91,51,93,41,32,42,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,1,0,0,0,220,3,0,0,52,48,46,48,32,42,32,104,101,97,116,50,91,51,93,46,97,108,112,104,97,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,50,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,1,0,0,0,223,3,0,0,40,105,102,32,112,105,112,101,50,46,118,115,91,50,93,32,62,61,32,48,46,48,32,116,104,101,110,32,49,46,53,32,101,108,115,101,32,51,46,53,41,32,42,32,112,105,112,101,50,46,108,101,110,103,116,104,115,91,50,93,0,0,0,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,50,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,50,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,0,0,0,0,1,0,0,0,224,3,0,0,1,0,0,0,226,3,0,0,112,105,112,101,50,46,99,114,111,115,115,65,114,101,97,115,91,49,93,32,42,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,100,32,42,32,112,105,112,101,50,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,49,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,1,0,0,0,236,3,0,0,40,105,102,32,112,105,112,101,50,46,118,115,91,49,93,32,62,61,32,48,46,48,32,116,104,101,110,32,48,46,53,32,101,108,115,101,32,52,46,53,41,32,42,32,112,105,112,101,50,46,108,101,110,103,116,104,115,91,49,93,0,0,0,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,49,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,49,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,0,0,0,0,1,0,0,0,237,3,0,0,1,0,0,0,245,3,0,0,40,112,105,112,101,50,46,99,114,111,115,115,65,114,101,97,115,91,49,93,32,43,32,112,105,112,101,50,46,99,114,111,115,115,65,114,101,97,115,91,50,93,41,32,42,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,1,0,0,0,248,3,0,0,52,48,46,48,32,42,32,104,101,97,116,50,91,50,93,46,97,108,112,104,97,0,0,0,1,0,0,0,251,3,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,254,3,0,0,49,46,48,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,88,95,108,105,113,117,105,100,0,1,0,0,0,0,4,0,0,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,84,32,42,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,82,0,1,0,0,0,2,4,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,8,4,0,0,40,49,46,48,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,88,95,108,105,113,117,105,100,41,32,94,32,50,46,48,0,1,0,0,0,9,4,0,0,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,82,32,42,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,84,41,32,94,32,50,46,48,0,1,0,0,0,15,4,0,0,109,97,120,40,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,54,93,44,32,49,101,45,49,53,41,32,43,32,109,97,120,40,45,112,105,112,101,50,46,109,95,102,108,111,119,115,91,49,93,44,32,49,101,45,49,53,41,0,0,1,0,0,0,17,4,0,0,1,0,0,0,18,4,0,0,1,0,0,0,19,4,0,0,1,0,0,0,30,4,0,0,112,105,112,101,49,46,99,114,111,115,115,65,114,101,97,115,91,51,93,32,42,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,100,32,42,32,112,105,112,101,49,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,1,0,0,0,42,4,0,0,112,105,112,101,49,46,110,80,97,114,97,108,108,101,108,32,42,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,100,101,110,115,105,116,121,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,84,104,101,114,109,111,100,121,110,97,109,105,99,83,116,97,116,101,40,49,53,48,48,48,48,46,48,44,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,49,93,46,84,44,32,123,48,46,48,49,44,32,48,46,57,57,125,41,41,32,42,32,112,105,112,101,49,46,99,114,111,115,115,65,114,101,97,115,91,49,93,0,0,0,0,0,0,0,0,1,0,0,0,43,4,0,0,112,105,112,101,49,46,99,114,111,115,115,65,114,101,97,115,91,49,93,32,42,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,100,32,42,32,112,105,112,101,49,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,1,0,0,0,46,4,0,0,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,112,105,112,101,49,46,99,114,111,115,115,65,114,101,97,115,91,49,93,0,1,0,0,0,47,4,0,0,112,105,112,101,49,46,99,114,111,115,115,65,114,101,97,115,91,50,93,32,42,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,100,32,42,32,112,105,112,101,49,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,1,0,0,0,50,4,0,0,40,112,105,112,101,49,46,99,114,111,115,115,65,114,101,97,115,91,50,93,32,43,32,112,105,112,101,49,46,99,114,111,115,115,65,114,101,97,115,91,51,93,41,32,42,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,1,0,0,0,53,4,0,0,40,112,105,112,101,49,46,99,114,111,115,115,65,114,101,97,115,91,49,93,32,43,32,112,105,112,101,49,46,99,114,111,115,115,65,114,101,97,115,91,50,93,41,32,42,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,1,0,0,0,54,4,0,0,112,105,112,101,49,46,99,114,111,115,115,65,114,101,97,115,91,52,93,32,42,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,100,32,42,32,112,105,112,101,49,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,1,0,0,0,57,4,0,0,40,112,105,112,101,49,46,99,114,111,115,115,65,114,101,97,115,91,51,93,32,43,32,112,105,112,101,49,46,99,114,111,115,115,65,114,101,97,115,91,52,93,41,32,42,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,1,0,0,0,58,4,0,0,112,105,112,101,49,46,99,114,111,115,115,65,114,101,97,115,91,53,93,32,42,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,100,32,42,32,112,105,112,101,49,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,1,0,0,0,61,4,0,0,40,112,105,112,101,49,46,99,114,111,115,115,65,114,101,97,115,91,52,93,32,43,32,112,105,112,101,49,46,99,114,111,115,115,65,114,101,97,115,91,53,93,41,32,42,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,1,0,0,0,62,4,0,0,112,105,112,101,51,46,99,114,111,115,115,65,114,101,97,115,91,49,93,32,42,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,100,101,110,115,105,116,121,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,84,104,101,114,109,111,100,121,110,97,109,105,99,83,116,97,116,101,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,112,44,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,49,93,46,84,44,32,123,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,49,93,46,88,91,49,93,44,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,49,93,46,88,91,50,93,125,41,41,32,42,32,112,105,112,101,51,46,110,80,97,114,97,108,108,101,108,0,0,1,0,0,0,63,4,0,0,109,97,120,40,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,54,93,44,32,49,101,45,49,53,41,32,43,32,109,97,120,40,45,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,44,32,49,101,45,49,53,41,0,0,0,0,0,0,0,0,1,0,0,0,66,4,0,0,52,48,46,48,32,42,32,104,101,97,116,50,91,49,93,46,97,108,112,104,97,0,0,0,1,0,0,0,67,4,0,0,109,97,120,40,45,112,105,112,101,50,46,109,95,102,108,111,119,115,91,49,93,44,32,49,101,45,49,53,41,32,43,32,109,97,120,40,45,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,44,32,49,101,45,49,53,41,0,1,0,0,0,70,4,0,0,112,105,112,101,51,46,99,114,111,115,115,65,114,101,97,115,91,49,93,32,42,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,100,32,42,32,112,105,112,101,51,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,1,0,0,0,73,4,0,0,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,112,105,112,101,51,46,99,114,111,115,115,65,114,101,97,115,91,49,93,0,1,0,0,0,76,4,0,0,40,112,105,112,101,51,46,99,114,111,115,115,65,114,101,97,115,91,49,93,32,43,32,112,105,112,101,51,46,99,114,111,115,115,65,114,101,97,115,91,50,93,41,32,42,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,1,0,0,0,77,4,0,0,1,0,0,0,78,4,0,0,1,0,0,0,79,4,0,0,1,0,0,0,88,4,0,0,1,0,0,0,92,4,0,0,112,105,112,101,49,46,99,114,111,115,115,65,114,101,97,115,91,53,93,32,42,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,100,101,110,115,105,116,121,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,84,104,101,114,109,111,100,121,110,97,109,105,99,83,116,97,116,101,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,112,44,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,55,93,46,84,44,32,123,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,55,93,46,88,91,49,93,44,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,55,93,46,88,91,50,93,125,41,41,32,42,32,112,105,112,101,49,46,110,80,97,114,97,108,108,101,108,0,0,1,0,0,0,95,4,0,0,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,112,105,112,101,49,46,99,114,111,115,115,65,114,101,97,115,91,53,93,0,1,0,0,0,163,4,0,0,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,0,0,0,0,0,0,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,0,0,0,0,0,0,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,0,0,0,0,0,0,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,0,0,0,0,0,0,1,0,0,0,34,7,0,0,1,0,0,0,36,7,0,0,1,0,0,0,39,7,0,0,1,0,0,0,78,7,0,0,1,0,0,0,80,7,0,0,1,0,0,0,83,7,0,0,1,0,0,0,122,7,0,0,1,0,0,0,124,7,0,0,1,0,0,0,127,7,0,0,1,0,0,0,167,7,0,0,1,0,0,0,170,7,0,0,1,0,0,0,171,7,0,0,1,0,0,0,14,8,0,0,1,0,0,0,17,8,0,0,1,0,0,0,18,8,0,0,1,0,0,0,58,8,0,0,1,0,0,0,61,8,0,0,1,0,0,0,62,8,0,0,1,0,0,0,101,8,0,0,1,0,0,0,103,8,0,0,1,0,0,0,106,8,0,0,1,0,0,0,155,8,0,0,1,0,0,0,158,8,0,0,1,0,0,0,159,8,0,0,1,0,0,0,181,8,0,0,1,0,0,0,183,8,0,0,1,0,0,0,186,8,0,0,1,0,0,0,245,8,0,0,1,0,0,0,248,8,0,0,1,0,0,0,249,8,0,0,1,0,0,0,45,9,0,0,1,0,0,0,47,9,0,0,1,0,0,0,50,9,0,0,1,0,0,0,103,9,0,0,1,0,0,0,106,9,0,0,1,0,0,0,107,9,0,0,1,0,0,0,163,9,0,0,1,0,0,0,165,9,0,0,1,0,0,0,168,9,0,0,1,0,0,0,225,9,0,0,1,0,0,0,228,9,0,0,1,0,0,0,229,9,0,0,1,0,0,0,239,9,0,0,1,0,0,0,242,9,0,0,1,0,0,0,243,9,0,0,1,0,0,0,37,10,0,0,1,0,0,0,39,10,0,0,1,0,0,0,42,10,0,0,1,0,0,0,82,10,0,0,1,0,0,0,85,10,0,0,1,0,0,0,86,10,0,0,1,0,0,0,126,10,0,0,1,0,0,0,129,10,0,0,1,0,0,0,130,10,0,0,1,0,0,0,173,10,0,0,1,0,0,0,175,10,0,0,1,0,0,0,178,10,0,0,1,0,0,0,211,10,0,0,232,85,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,213,10,0,0,1,0,0,0,216,10,0,0,116,105,109,101,32,60,32,114,97,109,112,49,46,115,116,97,114,116,84,105,109,101,0,0,116,105,109,101,32,60,32,114,97,109,112,49,46,115,116,97,114,116,84,105,109,101,32,43,32,114,97,109,112,49,46,100,117,114,97,116,105,111,110,0,1,0,0,0,201,6,0,0,1,0,0,0,201,6,0,0,128,225,0,0,136,225,0,0,64,225,0,0,88,225,0,0,99,104,101,99,107,32,102,111,114,32,100,105,115,99,114,101,116,101,32,99,104,97,110,103,101,115,0,0,0,0,0,0,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,43,32,45,49,48,48,48,46,48,32,42,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,0,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,45,32,115,121,115,116,101,109,46,100,112,95,115,109,97,108,108,0,0,0,0,0,0,36,68,69,82,46,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,0,36,68,69,82,46,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,50,93,0,36,68,69,82,46,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,51,93,0,36,68,69,82,46,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,52,93,0,36,68,69,82,46,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,53,93,0,36,68,69,82,46,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,54,93,0,36,68,69,82,46,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,84,0,36,68,69,82,46,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,84,0,36,68,69,82,46,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,84,0,36,68,69,82,46,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,84,0,36,68,69,82,46,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,84,0,36,68,69,82,46,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,112,0,36,68,69,82,46,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,112,0,36,68,69,82,46,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,112,0,36,68,69,82,46,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,112,0,36,68,69,82,46,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,112,0,36,68,69,82,46,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,0,0,0,0,0,36,68,69,82,46,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,0,0,0,0,0,36,68,69,82,46,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,88,105,91,49,93,0,0,0,0,0,36,68,69,82,46,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,88,105,91,49,93,0,0,0,0,0,36,68,69,82,46,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,88,105,91,49,93,0,0,0,0,0,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,43,32,45,49,48,48,48,46,48,32,42,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,0,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,45,32,115,121,115,116,101,109,46,100,112,95,115,109,97,108,108,0,0,0,0,0,0,36,68,69,82,46,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,0,36,68,69,82,46,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,50,93,0,36,68,69,82,46,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,51,93,0,36,68,69,82,46,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,52,93,0,36,68,69,82,46,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,84,0,36,68,69,82,46,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,84,0,36,68,69,82,46,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,84,0,36,68,69,82,46,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,84,0,36,68,69,82,46,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,84,0,36,68,69,82,46,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,112,0,36,68,69,82,46,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,112,0,36,68,69,82,46,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,112,0,36,68,69,82,46,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,112,0,36,68,69,82,46,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,112,0,36,68,69,82,46,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,0,0,0,0,0,36,68,69,82,46,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,0,0,0,0,0,36,68,69,82,46,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,88,105,91,49,93,0,0,0,0,0,36,68,69,82,46,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,88,105,91,49,93,0,0,0,0,0,36,68,69,82,46,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,88,105,91,49,93,0,0,0,0,0,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,43,32,45,49,48,48,48,46,48,32,42,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,0,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,45,32,115,121,115,116,101,109,46,100,112,95,115,109,97,108,108,0,0,0,0,0,0,36,68,69,82,46,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,0,36,68,69,82,46,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,50,93,0,36,68,69,82,46,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,51,93,0,36,68,69,82,46,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,52,93,0,36,68,69,82,46,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,53,93,0,36,68,69,82,46,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,54,93,0,36,68,69,82,46,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,84,0,36,68,69,82,46,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,84,0,36,68,69,82,46,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,84,0,36,68,69,82,46,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,84,0,36,68,69,82,46,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,84,0,36,68,69,82,46,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,112,0,36,68,69,82,46,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,112,0,36,68,69,82,46,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,112,0,36,68,69,82,46,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,112,0,36,68,69,82,46,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,112,0,36,68,69,82,46,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,0,0,0,0,0,36,68,69,82,46,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,0,0,0,0,0,36,68,69,82,46,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,88,105,91,49,93,0,0,0,0,0,36,68,69,82,46,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,88,105,91,49,93,0,0,0,0,0,36,68,69,82,46,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,88,105,91,49,93,0,0,0,0,0,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,43,32,45,49,48,48,48,46,48,32,42,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,0,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,45,32,115,121,115,116,101,109,46,100,112,95,115,109,97,108,108,0,0,0,0,0,0,36,68,69,82,46,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,0,36,68,69,82,46,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,50,93,0,36,68,69,82,46,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,51,93,0,36,68,69,82,46,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,52,93,0,36,68,69,82,46,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,53,93,0,36,68,69,82,46,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,54,93,0,36,68,69,82,46,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,84,0,36,68,69,82,46,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,84,0,36,68,69,82,46,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,84,0,36,68,69,82,46,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,84,0,36,68,69,82,46,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,84,0,36,68,69,82,46,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,112,0,36,68,69,82,46,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,112,0,36,68,69,82,46,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,112,0,36,68,69,82,46,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,112,0,36,68,69,82,46,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,112,0,36,68,69,82,46,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,0,0,0,0,0,36,68,69,82,46,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,0,0,0,0,0,36,68,69,82,46,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,88,105,91,49,93,0,0,0,0,0,36,68,69,82,46,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,88,105,91,49,93,0,0,0,0,0,36,68,69,82,46,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,88,105,91,49,93,0,0,0,0,0,192,225,0,0,0,226,0,0,48,226,0,0,80,226,0,0,112,226,0,0,144,226,0,0,176,226,0,0,208,226,0,0,240,226,0,0,8,227,0,0,32,227,0,0,56,227,0,0,80,227,0,0,104,227,0,0,128,227,0,0,152,227,0,0,176,227,0,0,200,227,0,0,224,227,0,0,0,228,0,0,32,228,0,0,64,228,0,0,96,228,0,0,128,228,0,0,192,228,0,0,240,228,0,0,16,229,0,0,48,229,0,0,80,229,0,0,112,229,0,0,136,229,0,0,160,229,0,0,184,229,0,0,208,229,0,0,232,229,0,0,0,230,0,0,24,230,0,0,48,230,0,0,72,230,0,0,96,230,0,0,128,230,0,0,160,230,0,0,192,230,0,0,224,230,0,0,0,231,0,0,64,231,0,0,112,231,0,0,144,231,0,0,176,231,0,0,208,231,0,0,240,231,0,0,16,232,0,0,48,232,0,0,72,232,0,0,96,232,0,0,120,232,0,0,144,232,0,0,168,232,0,0,192,232,0,0,216,232,0,0,240,232,0,0,8,233,0,0,32,233,0,0,64,233,0,0,96,233,0,0,128,233,0,0,160,233,0,0,192,233,0,0,0,234,0,0,48,234,0,0,80,234,0,0,112,234,0,0,144,234,0,0,176,234,0,0,208,234,0,0,240,234,0,0,8,235,0,0,32,235,0,0,56,235,0,0,80,235,0,0,104,235,0,0,128,235,0,0,152,235,0,0,176,235,0,0,200,235,0,0,224,235,0,0,0,236,0,0,32,236,0,0,64,236,0,0,96,236,0,0,117,112,100,97,116,105,110,103,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,91,37,100,93,58,32,37,115,32,61,32,37,103,0,0,0,1,0,0,0,25,0,0,0,112,105,112,101,52,46,112,101,114,105,109,101,116,101,114,0,1,0,0,0,26,0,0,0,1,0,0,0,27,0,0,0,1,0,0,0,28,0,0,0,1,0,0,0,29,0,0,0,1,0,0,0,51,0,0,0,112,105,112,101,51,46,112,101,114,105,109,101,116,101,114,0,1,0,0,0,52,0,0,0,1,0,0,0,53,0,0,0,1,0,0,0,54,0,0,0,1,0,0,0,55,0,0,0,1,0,0,0,78,0,0,0,112,105,112,101,50,46,112,101,114,105,109,101,116,101,114,0,1,0,0,0,79,0,0,0,1,0,0,0,80,0,0,0,1,0,0,0,81,0,0,0,1,0,0,0,82,0,0,0,1,0,0,0,104,0,0,0,112,105,112,101,49,46,112,101,114,105,109,101,116,101,114,0,1,0,0,0,105,0,0,0,1,0,0,0,106,0,0,0,1,0,0,0,107,0,0,0,1,0,0,0,108,0,0,0,1,0,0,0,160,13,1,0,168,13,1,0,0,0,0,0,72,50,79,0,0,0,0,0,1,0,0,0,96,13,1,0,104,13,1,0,0,0,0,0,1,0,0,0,72,13,1,0,80,13,1,0,0,0,0,0,1,0,0,0,8,13,1,0,16,13,1,0,0,0,0,0,1,0,0,0,240,12,1,0,248,12,1,0,0,0,0,0,1,0,0,0,175,0,0,0,98,111,117,110,100,97,114,121,49,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,48,46,54,50,53,55,52,53,48,54,53,57,52,54,55,50,52,0,0,0,0,0,0,0,0,1,0,0,0,176,0,0,0,109,97,120,40,49,101,45,49,51,44,32,49,53,48,48,48,48,46,48,32,45,32,98,111,117,110,100,97,114,121,49,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,0,0,1,0,0,0,177,0,0,0,1,0,0,0,178,0,0,0,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,1,0,0,0,179], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+51200);
/* memory initializer */ allocate([112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,1,0,0,0,180,0,0,0,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,1,0,0,0,181,0,0,0,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,1,0,0,0,216,12,1,0,224,12,1,0,0,0,0,0,1,0,0,0,201,0,0,0,49,46,48,32,45,32,98,111,117,110,100,97,114,121,49,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,0,1,0,0,0,203,0,0,0,98,111,117,110,100,97,114,121,49,46,109,101,100,105,117,109,46,82,32,42,32,50,57,51,46,49,53,0,0,0,0,0,1,0,0,0,204,0,0,0,114,97,109,112,49,46,100,117,114,97,116,105,111,110,0,0,1,0,0,0,207,0,0,0,109,97,120,40,49,101,45,49,51,44,32,98,111,117,110,100,97,114,121,52,46,112,95,105,110,32,45,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,0,0,0,0,1,0,0,0,210,0,0,0,49,46,48,32,45,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,0,1,0,0,0,212,0,0,0,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,82,32,42,32,50,57,51,46,49,53,0,0,0,0,0,1,0,0,0,213,0,0,0,1,0,0,0,214,0,0,0,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,0,0,0,0,1,0,0,0,164,4,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,1,0,0,0,165,4,0,0,109,97,120,40,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,50,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,1,0,0,0,166,4,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,1,0,0,0,167,4,0,0,109,97,120,40,112,105,112,101,50,46,115,116,97,116,101,115,70,77,91,49,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,1,0,0,0,169,4,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,1,0,0,0,170,4,0,0,109,97,120,40,112,105,112,101,50,46,115,116,97,116,101,115,70,77,91,50,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,1,0,0,0,178,4,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,112,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,181,4,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,112,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,182,4,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,1,0,0,0,183,4,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,1,0,0,0,184,4,0,0,109,97,120,40,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,51,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,1,0,0,0,186,4,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,188,4,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,1,0,0,0,189,4,0,0,109,97,120,40,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,50,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,1,0,0,0,190,4,0,0,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,50,93,46,88,91,50,93,41,0,0,0,1,0,0,0,201,4,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,202,4,0,0,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,51,93,46,88,91,50,93,41,0,0,0,1,0,0,0,207,4,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,1,0,0,0,211,4,0,0,109,97,120,40,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,52,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,1,0,0,0,214,4,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,112,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,215,4,0,0,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,52,93,46,88,91,50,93,41,0,0,0,1,0,0,0,224,4,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,1,0,0,0,225,4,0,0,109,97,120,40,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,54,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,1,0,0,0,226,4,0,0,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,54,93,46,88,91,50,93,41,0,0,0,1,0,0,0,227,4,0,0,109,97,120,40,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,54,93,44,32,49,101,45,49,53,41,32,43,32,109,97,120,40,45,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,44,32,49,101,45,49,53,41,0,0,0,0,0,0,0,0,1,0,0,0,228,4,0,0,1,0,0,0,234,4,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,239,4,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,112,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,241,4,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,1,0,0,0,242,4,0,0,109,97,120,40,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,53,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,1,0,0,0,245,4,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,112,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,246,4,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,1,0,0,0,250,4,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,1,0,0,0,251,4,0,0,109,97,120,40,112,105,112,101,50,46,115,116,97,116,101,115,70,77,91,53,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,1,0,0,0,255,4,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,1,0,0,0,0,5,0,0,109,97,120,40,112,105,112,101,50,46,115,116,97,116,101,115,70,77,91,52,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,1,0,0,0,3,5,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,1,0,0,0,14,5,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,112,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,18,5,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,112,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,19,5,0,0,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,112,105,112,101,50,46,115,116,97,116,101,115,70,77,91,52,93,46,88,91,50,93,41,0,0,0,1,0,0,0,20,5,0,0,109,97,120,40,112,105,112,101,50,46,115,116,97,116,101,115,70,77,91,51,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,1,0,0,0,21,5,0,0,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,112,105,112,101,50,46,115,116,97,116,101,115,70,77,91,51,93,46,88,91,50,93,41,0,0,0,1,0,0,0,26,5,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,112,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,27,5,0,0,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,112,105,112,101,50,46,115,116,97,116,101,115,70,77,91,53,93,46,88,91,50,93,41,0,0,0,1,0,0,0,28,5,0,0,109,97,120,40,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,54,93,44,32,49,101,45,49,53,41,32,43,32,109,97,120,40,45,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,44,32,49,101,45,49,53,41,0,0,0,0,0,0,0,0,1,0,0,0,29,5,0,0,1,0,0,0,30,5,0,0,1,0,0,0,33,5,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,1,0,0,0,36,5,0,0,109,97,120,40,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,51,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,1,0,0,0,37,5,0,0,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,51,93,46,88,91,50,93,41,0,0,0,1,0,0,0,40,5,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,1,0,0,0,42,5,0,0,109,97,120,40,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,52,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,1,0,0,0,43,5,0,0,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,52,93,46,88,91,50,93,41,0,0,0,1,0,0,0,51,5,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,112,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,52,5,0,0,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,53,93,46,88,91,50,93,41,0,0,0,1,0,0,0,59,5,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,1,0,0,0,66,5,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,1,0,0,0,67,5,0,0,109,97,120,40,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,52,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,1,0,0,0,69,5,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,1,0,0,0,71,5,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,112,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,73,5,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,1,0,0,0,82,5,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,112,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,83,5,0,0,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,52,93,46,88,91,50,93,41,0,0,0,1,0,0,0,86,5,0,0,109,97,120,40,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,51,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,1,0,0,0,90,5,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,112,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,91,5,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,1,0,0,0,99,5,0,0,109,97,120,40,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,54,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,1,0,0,0,100,5,0,0,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,54,93,46,88,91,50,93,41,0,0,0,1,0,0,0,104,5,0,0,109,97,120,40,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,53,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,1,0,0,0,105,5,0,0,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,53,93,46,88,91,50,93,41,0,0,0,1,0,0,0,110,5,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,111,5,0,0,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,51,93,46,88,91,50,93,41,0,0,0,1,0,0,0,113,5,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,114,5,0,0,109,97,120,40,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,50,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,1,0,0,0,115,5,0,0,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,50,93,46,88,91,50,93,41,0,0,0,1,0,0,0,121,5,0,0,109,97,120,40,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,54,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,1,0,0,0,122,5,0,0,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,54,93,46,88,91,50,93,41,0,0,0,1,0,0,0,128,5,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,129,5,0,0,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,50,93,46,88,91,50,93,41,0,0,0,1,0,0,0,135,5,0,0,1,0,0,0,136,5,0,0,109,97,120,40,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,53,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,1,0,0,0,137,5,0,0,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,53,93,46,88,91,50,93,41,0,0,0,1,0,0,0,146,5,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,147,5,0,0,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,112,105,112,101,50,46,115,116,97,116,101,115,70,77,91,50,93,46,88,91,50,93,41,0,0,0,1,0,0,0,150,5,0,0,109,97,120,40,49,101,45,49,51,44,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,151,5,0,0,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,112,105,112,101,50,46,115,116,97,116,101,115,70,77,91,49,93,46,88,91,50,93,41,0,0,0,2,0,0,0,0,0,0,0,123,20,174,71,225,122,132,63,174,71,225,122,20,174,239,63,2,0,0,0,0,0,0,0,12,229,68,187,110,9,203,192,19,83,84,195,159,233,31,192,7,0,0,0,0,0,0,0,121,233,38,49,184,149,47,65,117,32,235,169,101,217,162,192,175,197,118,16,158,149,18,64,4,118,172,56,171,198,98,63,93,203,6,236,202,240,166,190,56,28,173,173,73,233,217,61,3,149,235,130,211,183,245,188,2,0,0,0,0,0,0,0,181,166,121,199,247,33,224,192,76,254,39,127,247,61,49,64,7,0,0,0,0,0,0,0,197,143,49,119,243,70,227,192,45,90,128,182,149,252,129,64,8,175,179,218,41,209,237,63,23,132,90,56,144,149,125,63,249,233,45,205,2,204,222,190,111,33,62,192,32,72,53,62,140,233,235,22,3,133,119,189,1,0,0,0,0,0,0,0,123,20,174,71,225,122,132,63,117,112,100,97,116,105,110,103,32,109,105,110,45,118,97,108,117,101,115,0,0,0,0,0,117,112,100,97,116,105,110,103,32,109,97,120,45,118,97,108,117,101,115,0,0,0,0,0,117,112,100,97,116,105,110,103,32,110,111,109,105,110,97,108,45,118,97,108,117,101,115,0,117,112,100,97,116,105,110,103,32,115,116,97,114,116,45,118,97,108,117,101,115,0,0,0,37,115,40,115,116,97,114,116,61,37,103,41,0,0,0,0,1,0,0,0,232,137,1,0,240,137,1,0,0,0,0,0,72,50,79,0,0,0,0,0,1,0,0,0,168,137,1,0,176,137,1,0,0,0,0,0,1,0,0,0,144,137,1,0,152,137,1,0,0,0,0,0,1,0,0,0,80,137,1,0,88,137,1,0,0,0,0,0,1,0,0,0,56,137,1,0,64,137,1,0,0,0,0,0,1,0,0,0,32,137,1,0,40,137,1,0,0,0,0,0,1,0,0,0,118,11,0,0,98,111,117,110,100,97,114,121,49,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,48,46,54,50,53,55,52,53,48,54,53,57,52,54,55,50,52,0,0,0,0,0,0,0,0,1,0,0,0,119,11,0,0,109,97,120,40,49,101,45,49,51,44,32,49,53,48,48,48,48,46,48,32,45,32,98,111,117,110,100,97,114,121,49,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,0,0,1,0,0,0,120,11,0,0,1,0,0,0,123,11,0,0,49,46,48,32,45,32,98,111,117,110,100,97,114,121,49,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,0,1,0,0,0,125,11,0,0,98,111,117,110,100,97,114,121,49,46,109,101,100,105,117,109,46,82,32,42,32,50,57,51,46,49,53,0,0,0,0,0,1,0,0,0,211,11,0,0,112,105,112,101,49,46,112,101,114,105,109,101,116,101,114,0,1,0,0,0,212,11,0,0,1,0,0,0,214,11,0,0,1,0,0,0,216,11,0,0,1,0,0,0,218,11,0,0,1,0,0,0,225,11,0,0,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,1,0,0,0,6,12,0,0,112,105,112,101,50,46,112,101,114,105,109,101,116,101,114,0,1,0,0,0,7,12,0,0,1,0,0,0,9,12,0,0,1,0,0,0,11,12,0,0,1,0,0,0,13,12,0,0,1,0,0,0,20,12,0,0,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,1,0,0,0,59,12,0,0,112,105,112,101,51,46,112,101,114,105,109,101,116,101,114,0,1,0,0,0,60,12,0,0,1,0,0,0,62,12,0,0,1,0,0,0,64,12,0,0,1,0,0,0,66,12,0,0,1,0,0,0,73,12,0,0,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,1,0,0,0,112,12,0,0,112,105,112,101,52,46,112,101,114,105,109,101,116,101,114,0,1,0,0,0,113,12,0,0,1,0,0,0,115,12,0,0,1,0,0,0,117,12,0,0,1,0,0,0,119,12,0,0,1,0,0,0,126,12,0,0,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,103,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,104,101,97,116,50,91,53,93,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,104,101,97,116,50,91,53,93,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,84,104,101,114,109,97,108,47,72,101,97,116,84,114,97,110,115,102,101,114,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,104,101,97,116,50,91,52,93,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,104,101,97,116,50,91,52,93,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,104,101,97,116,50,91,51,93,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,104,101,97,116,50,91,51,93,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,104,101,97,116,50,91,50,93,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,104,101,97,116,50,91,50,93,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,104,101,97,116,50,91,49,93,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,104,101,97,116,50,91,49,93,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,72,17,1,0,240,5,0,0,7,0,0,0,241,5,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,97,109,112,49,46,100,117,114,97,116,105,111,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,97,109,112,49,46,100,117,114,97,116,105,111,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,66,108,111,99,107,115,47,83,111,117,114,99,101,115,46,109,111,0,0,144,19,1,0,162,1,0,0,5,0,0,0,163,1,0,0,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,52,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,52,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,52,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,83,111,117,114,99,101,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,52,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,52,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,52,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,52,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,52,46,84,32,62,61,32,49,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,52,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,52,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,52,46,112,32,62,61,32,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,52,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,100,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,52,46,102,108,111,119,68,105,114,101,99,116,105,111,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,52,46,102,108,111,119,68,105,114,101,99,116,105,111,110,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,69,110,116,101,114,105,110,103,32,97,110,100,32,98,111,117,110,100,97,114,121,52,46,102,108,111,119,68,105,114,101,99,116,105,111,110,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,66,105,100,105,114,101,99,116,105,111,110,97,108,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,73,110,116,101,114,102,97,99,101,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,114,111,117,103,104,110,101,115,115,101,115,91,53,93,32,111,117], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+61440);
/* memory initializer */ allocate([116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,114,111,117,103,104,110,101,115,115,101,115,91,53,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,80,105,112,101,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,114,111,117,103,104,110,101,115,115,101,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,114,111,117,103,104,110,101,115,115,101,115,91,52,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,114,111,117,103,104,110,101,115,115,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,114,111,117,103,104,110,101,115,115,101,115,91,51,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,114,111,117,103,104,110,101,115,115,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,114,111,117,103,104,110,101,115,115,101,115,91,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,114,111,117,103,104,110,101,115,115,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,114,111,117,103,104,110,101,115,115,101,115,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,117,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,117,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,114,104,111,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,114,104,111,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,112,115,95,115,116,97,114,116,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,112,115,95,115,116,97,114,116,91,53,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,112,115,95,115,116,97,114,116,91,53,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,112,115,95,115,116,97,114,116,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,112,115,95,115,116,97,114,116,91,52,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,112,115,95,115,116,97,114,116,91,52,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,112,115,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,112,115,95,115,116,97,114,116,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,112,115,95,115,116,97,114,116,91,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,112,115,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,112,115,95,115,116,97,114,116,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,112,115,95,115,116,97,114,116,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,112,115,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,112,115,95,115,116,97,114,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,112,115,95,115,116,97,114,116,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,112,95,98,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,112,95,98,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,112,95,98,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,52,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,52,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,88,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,88,95,115,116,97,114,116,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,88,95,115,116,97,114,116,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,88,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,88,95,115,116,97,114,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,88,95,115,116,97,114,116,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,52,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,112,95,97,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,112,95,97,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,112,95,97,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,97,115,115,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,97,115,115,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,52,46,109,97,115,115,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,52,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,111,100,101,108,83,116,114,117,99,116,117,114,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,111,100,101,108,83,116,114,117,99,116,117,114,101,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,77,111,100,101,108,83,116,114,117,99,116,117,114,101,46,97,118,95,118,98,32,97,110,100,32,112,105,112,101,52,46,109,111,100,101,108,83,116,114,117,99,116,117,114,101,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,77,111,100,101,108,83,116,114,117,99,116,117,114,101,46,97,95,118,98,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,110,78,111,100,101,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,110,78,111,100,101,115,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,104,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,104,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,52,46,104,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,84,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,84,95,115,116,97,114,116,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,52,46,84,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,114,111,117,103,104,110,101,115,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,114,111,117,103,104,110,101,115,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,110,80,97,114,97,108,108,101,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,110,80,97,114,97,108,108,101,108,32,62,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,114,111,117,103,104,110,101,115,115,101,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,114,111,117,103,104,110,101,115,115,101,115,91,53,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,114,111,117,103,104,110,101,115,115,101,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,114,111,117,103,104,110,101,115,115,101,115,91,52,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,114,111,117,103,104,110,101,115,115,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,114,111,117,103,104,110,101,115,115,101,115,91,51,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,114,111,117,103,104,110,101,115,115,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,114,111,117,103,104,110,101,115,115,101,115,91,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,114,111,117,103,104,110,101,115,115,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,114,111,117,103,104,110,101,115,115,101,115,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,117,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,117,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,112,115,95,115,116,97,114,116,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,112,115,95,115,116,97,114,116,91,53,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,112,115,95,115,116,97,114,116,91,53,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,112,115,95,115,116,97,114,116,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,112,115,95,115,116,97,114,116,91,52,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,112,115,95,115,116,97,114,116,91,52,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,112,115,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,112,115,95,115,116,97,114,116,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,112,115,95,115,116,97,114,116,91,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,112,115,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,112,115,95,115,116,97,114,116,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,112,115,95,115,116,97,114,116,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,112,115,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,112,115,95,115,116,97,114,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,112,115,95,115,116,97,114,116,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,112,95,98,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,112,95,98,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,112,95,98,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,51,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,51,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,88,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,88,95,115,116,97,114,116,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,88,95,115,116,97,114,116,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,88,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,88,95,115,116,97,114,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,88,95,115,116,97,114,116,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,51,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,112,95,97,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,112,95,97,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,112,95,97,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,97,115,115,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,97,115,115,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,51,46,109,97,115,115,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,51,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,111,100,101,108,83,116,114,117,99,116,117,114,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,111,100,101,108,83,116,114,117,99,116,117,114,101,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,77,111,100,101,108,83,116,114,117,99,116,117,114,101,46,97,118,95,118,98,32,97,110,100,32,112,105,112,101,51,46,109,111,100,101,108,83,116,114,117,99,116,117,114,101,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,77,111,100,101,108,83,116,114,117,99,116,117,114,101,46,97,95,118,98,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,110,78,111,100,101,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,110,78,111,100,101,115,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,104,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,104,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,51,46,104,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,84,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,84,95,115,116,97,114,116,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,51,46,84,95,115,116,97,114], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+71680);
/* memory initializer */ allocate([116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,114,111,117,103,104,110,101,115,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,114,111,117,103,104,110,101,115,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,110,80,97,114,97,108,108,101,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,110,80,97,114,97,108,108,101,108,32,62,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,114,111,117,103,104,110,101,115,115,101,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,114,111,117,103,104,110,101,115,115,101,115,91,53,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,114,111,117,103,104,110,101,115,115,101,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,114,111,117,103,104,110,101,115,115,101,115,91,52,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,114,111,117,103,104,110,101,115,115,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,114,111,117,103,104,110,101,115,115,101,115,91,51,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,114,111,117,103,104,110,101,115,115,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,114,111,117,103,104,110,101,115,115,101,115,91,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,114,111,117,103,104,110,101,115,115,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,114,111,117,103,104,110,101,115,115,101,115,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,117,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,117,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,112,115,95,115,116,97,114,116,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,112,115,95,115,116,97,114,116,91,53,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,112,115,95,115,116,97,114,116,91,53,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,112,115,95,115,116,97,114,116,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,112,115,95,115,116,97,114,116,91,52,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,112,115,95,115,116,97,114,116,91,52,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,112,115,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,112,115,95,115,116,97,114,116,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,112,115,95,115,116,97,114,116,91,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,112,115,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,112,115,95,115,116,97,114,116,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,112,115,95,115,116,97,114,116,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,112,115,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,112,115,95,115,116,97,114,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,112,115,95,115,116,97,114,116,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,112,95,98,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,112,95,98,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,112,95,98,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,50,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,50,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,88,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,88,95,115,116,97,114,116,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,88,95,115,116,97,114,116,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,88,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,88,95,115,116,97,114,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,88,95,115,116,97,114,116,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,50,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,112,95,97,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,112,95,97,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,112,95,97,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,97,115,115,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,97,115,115,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,50,46,109,97,115,115,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,50,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,111,100,101,108,83,116,114,117,99,116,117,114,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,111,100,101,108,83,116,114,117,99,116,117,114,101,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,77,111,100,101,108,83,116,114,117,99,116,117,114,101,46,97,118,95,118,98,32,97,110,100,32,112,105,112,101,50,46,109,111,100,101,108,83,116,114,117,99,116,117,114,101,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,77,111,100,101,108,83,116,114,117,99,116,117,114,101,46,97,95,118,98,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,110,78,111,100,101,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,110,78,111,100,101,115,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,104,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,104,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,50,46,104,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,84,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,84,95,115,116,97,114,116,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,50,46,84,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,114,111,117,103,104,110,101,115,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,114,111,117,103,104,110,101,115,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,110,80,97,114,97,108,108,101,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,110,80,97,114,97,108,108,101,108,32,62,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,144,23,1,0,236,1,0,0,5,0,0,0,237,1,0,0,42,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,114,111,117,103,104,110,101,115,115,101,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,114,111,117,103,104,110,101,115,115,101,115,91,53,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,114,111,117,103,104,110,101,115,115,101,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,114,111,117,103,104,110,101,115,115,101,115,91,52,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,114,111,117,103,104,110,101,115,115,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,114,111,117,103,104,110,101,115,115,101,115,91,51,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,114,111,117,103,104,110,101,115,115,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,114,111,117,103,104,110,101,115,115,101,115,91,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,114,111,117,103,104,110,101,115,115,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,114,111,117,103,104,110,101,115,115,101,115,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,80,24,1,0,68,1,0,0,7,0,0,0,70,1,0,0,45,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,117,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,117,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,80,24,1,0,87,4,0,0,13,0,0,0,91,4,0,0,74,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,80,24,1,0,80,4,0,0,13,0,0,0,82,4,0,0,75,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,80,24,1,0,26,4,0,0,13,0,0,0,28,4,0,0,97,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,80,24,1,0,21,4,0,0,13,0,0,0,23,4,0,0,109,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,80,24,1,0,229,4,0,0,13,0,0,0,231,4,0,0,79,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,80,24,1,0,221,4,0,0,13,0,0,0,222,4,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,80,24,1,0,32,4,0,0,13,0,0,0,34,4,0,0,97,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,80,24,1,0,29,4,0,0,13,0,0,0,31,4,0,0,97,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,112,115,95,115,116,97,114,116,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,112,115,95,115,116,97,114,116,91,53,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,112,115,95,115,116,97,114,116,91,53,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,112,115,95,115,116,97,114,116,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,112,115,95,115,116,97,114,116,91,52,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,112,115,95,115,116,97,114,116,91,52,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,112,115,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,112,115,95,115,116,97,114,116,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,112,115,95,115,116,97,114,116,91,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,112,115,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,112,115,95,115,116,97,114,116,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,112,115,95,115,116,97,114,116,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,112,115,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,112,115,95,115,116,97,114,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,112,115,95,115,116,97,114,116,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,144,23,1,0,73,3,0,0,3,0,0,0,75,3,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,112,95,98,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,112,95,98,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,112,95,98,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,144,23,1,0,70,3,0,0,3,0,0,0,72,3,0,0,47,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,49,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,144,23,1,0,62,3,0,0,3,0,0,0,64,3,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,49,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,144,23,1,0,59,3,0,0,3,0,0,0,61,3,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,88,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,88,95,115,116,97,114,116,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,88,95,115,116,97,114,116,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,88,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,88,95,115,116,97,114,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,88,95,115,116,97,114,116,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,144,23,1,0,92,3,0,0,3,0,0,0,94,3,0,0,69,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,80,24,1,0,83,1,0,0,7,0,0,0,85,1,0,0,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,49,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,80,24,1,0,78,1,0,0,7,0,0,0,80,1,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,112,95,97,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,112,95,97,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,112,95,97,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,144,23,1,0,67,3,0,0,3,0,0,0,69,3,0,0,47,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,97,115,115,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,97,115,115,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+81920);
/* memory initializer */ allocate([110,100,32,112,105,112,101,49,46,109,97,115,115,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,144,23,1,0,56,3,0,0,3,0,0,0,58,3,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,49,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,144,23,1,0,53,3,0,0,3,0,0,0,55,3,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,111,100,101,108,83,116,114,117,99,116,117,114,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,111,100,101,108,83,116,114,117,99,116,117,114,101,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,77,111,100,101,108,83,116,114,117,99,116,117,114,101,46,97,118,95,118,98,32,97,110,100,32,112,105,112,101,49,46,109,111,100,101,108,83,116,114,117,99,116,117,114,101,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,77,111,100,101,108,83,116,114,117,99,116,117,114,101,46,97,95,118,98,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,80,24,1,0,91,1,0,0,7,0,0,0,93,1,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,110,78,111,100,101,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,110,78,111,100,101,115,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,80,24,1,0,88,1,0,0,7,0,0,0,89,1,0,0,57,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,104,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,104,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,49,46,104,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,144,23,1,0,86,3,0,0,3,0,0,0,91,3,0,0,88,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,84,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,84,95,115,116,97,114,116,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,49,46,84,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,144,23,1,0,80,3,0,0,3,0,0,0,85,3,0,0,84,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,114,111,117,103,104,110,101,115,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,114,111,117,103,104,110,101,115,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,80,24,1,0,7,1,0,0,7,0,0,0,9,1,0,0,47,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,80,24,1,0,255,0,0,0,7,0,0,0,0,1,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,110,80,97,114,97,108,108,101,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,110,80,97,114,97,108,108,101,108,32,62,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,80,24,1,0,248,0,0,0,7,0,0,0,249,0,0,0,45,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,49,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,49,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,49,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,49,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,49,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,49,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,104,20,1,0,150,0,0,0,5,0,0,0,153,0,0,0,70,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,49,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,49,46,84,32,62,61,32,49,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,49,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,104,20,1,0,146,0,0,0,5,0,0,0,149,0,0,0,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,49,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,49,46,112,32,62,61,32,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,49,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,104,20,1,0,142,0,0,0,5,0,0,0,145,0,0,0,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,49,46,102,108,111,119,68,105,114,101,99,116,105,111,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,49,46,102,108,111,119,68,105,114,101,99,116,105,111,110,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,69,110,116,101,114,105,110,103,32,97,110,100,32,98,111,117,110,100,97,114,121,49,46,102,108,111,119,68,105,114,101,99,116,105,111,110,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,66,105,100,105,114,101,99,116,105,111,110,97,108,32,104,97,115,32,118,97,108,117,101,58,32,0,104,20,1,0,20,3,0,0,5,0,0,0,22,3,0,0,95,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,115,121,115,116,101,109,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,83,121,115,116,101,109,46,109,111,0,0,0,0,128,113,1,0,32,0,0,0,3,0,0,0,34,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,115,121,115,116,101,109,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,128,113,1,0,29,0,0,0,3,0,0,0,31,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,109,97,115,115,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,109,97,115,115,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,115,121,115,116,101,109,46,109,97,115,115,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,128,113,1,0,26,0,0,0,3,0,0,0,28,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,84,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,84,95,115,116,97,114,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,128,113,1,0,47,0,0,0,3,0,0,0,49,0,0,0,47,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,128,113,1,0,44,0,0,0,3,0,0,0,46,0,0,0,47,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,109,95,102,108,111,119,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,109,95,102,108,111,119,95,115,109,97,108,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,128,113,1,0,63,0,0,0,3,0,0,0,65,0,0,0,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,100,112,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,100,112,95,115,109,97,108,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,128,113,1,0,60,0,0,0,3,0,0,0,62,0,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,101,112,115,95,109,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,101,112,115,95,109,95,102,108,111,119,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,128,113,1,0,57,0,0,0,3,0,0,0,59,0,0,0,62,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,115,121,115,116,101,109,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,128,113,1,0,35,0,0,0,3,0,0,0,38,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,115,121,115,116,101,109,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,128,113,1,0,22,0,0,0,3,0,0,0,25,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,84,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,128,113,1,0,11,0,0,0,3,0,0,0,13,0,0,0,44,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,112,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,112,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,128,113,1,0,8,0,0,0,3,0,0,0,10,0,0,0,44,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,49,46,109,101,100,105,117,109,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,49,46,109,101,100,105,117,109,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,98,111,117,110,100,97,114,121,49,46,109,101,100,105,117,109,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,112,97,99,107,97,103,101,46,109,111,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,49,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,49,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,49,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,65,105,114,47,77,111,105,115,116,65,105,114,46,109,111,0,0,0,0,0,0,200,122,1,0,62,0,0,0,7,0,0,0,62,0,0,0,74,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,49,46,109,101,100,105,117,109,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,49,46,109,101,100,105,117,109,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,49,46,109,101,100,105,117,109,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,49,46,109,101,100,105,117,109,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,49,46,109,101,100,105,117,109,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,49,46,109,101,100,105,117,109,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,208,121,1,0,33,17,0,0,7,0,0,0,33,17,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,49,93,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,49,93,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,49,93,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,55,93,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,55,93,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,55,93,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,208,121,1,0,126,21,0,0,7,0,0,0,127,21,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,208,121,1,0,40,17,0,0,7,0,0,0,40,17,0,0,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,208,121,1,0,36,17,0,0,7,0,0,0,37,17,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,120,95,119,97,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,120,95,119,97,116,101,114,32,62,61,32,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,120,95,119,97,116,101,114,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,49,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,49,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,49,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,208,121,1,0,125,21,0,0,7,0,0,0,125,21,0,0,44,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,49,46,109,101,100,105,117,109,46,120,95,119,97,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,49,46,109,101,100,105,117,109,46,120,95,119,97,116,101,114,32,62,61,32,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,49,46,109,101,100,105,117,109,46,120,95,119,97,116,101,114,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,200,122,1,0,51,0,0,0,7,0,0,0,51,0,0,0,65,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,49,46,109,101,100,105,117,109,46,120,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,49,46,109,101,100,105,117,109,46,120,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,49,46,109,101,100,105,117,109,46,120,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,200,122,1,0,60,0,0,0,7,0,0,0,61,0,0,0,80,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,49,46,109,101,100,105,117,109,46,88,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,49,46,109,101,100,105,117,109,46,88,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,49,46,109,101,100,105,117,109,46,88,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,200,122,1,0,58,0,0,0,7,0,0,0,59,0,0,0,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,80,24,1,0,245,4,0,0,13,0,0,0,1,5,0,0,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,80,24,1,0,55,4,0,0,13,0,0,0,55,4,0,0,125,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,80,24,1,0,52,4,0,0,13,0,0,0,52,4,0,0,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,49,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,49,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,32,62,61,32,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,49,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,200,122,1,0,55,0,0,0,7,0,0,0,55,0,0,0,69,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,49,46,109,101,100,105,117,109,46,88,95,115,116,101,97,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,49,46,109,101,100,105,117,109,46,88,95,115,116,101,97,109,32,62,61,32,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,49,46,109,101,100,105,117,109,46,88,95,115,116,101,97,109,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,200,122,1,0,56,0,0,0,7,0,0,0,56,0,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,49,46,109,101,100,105,117,109,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,49,46,109,101,100,105,117,109,46,82,32,62,61,32,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,49,46,109,101,100,105,117,109,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,208,121,1,0,39,17,0,0,7,0,0,0,39,17,0,0,71,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,49,46,109,101,100,105,117,109,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,49,46,109,101,100,105,117,109,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,49,46,109,101,100,105,117,109,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,208,121,1,0,38,17,0,0,7,0,0,0,38,17,0,0,68,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,49,46,109,101,100,105,117,109,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,49,46,109,101,100,105,117,109,46,100,32,62,61,32,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,49,46,109,101,100,105,117,109,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,208,121,1,0,34,17,0,0,7,0,0,0,34,17,0,0,36,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,123,20,174,71,225,122,132,63,174,71,225,122,20,174,239,63,2,0,0,0,0,0,0,0,12,229,68,187,110,9,203,192,19,83,84,195,159,233,31,192,7,0,0,0,0,0,0,0,121,233,38,49,184,149,47,65,117,32,235,169,101,217,162,192,175,197,118,16,158,149,18,64,4,118,172,56,171,198,98,63,93,203,6,236,202,240,166,190,56,28,173,173,73,233,217,61,3,149,235,130,211,183,245,188,2,0,0,0,0,0,0,0,181,166,121,199,247,33,224,192,76,254,39,127,247,61,49,64,7,0,0,0,0,0,0,0,197,143,49,119,243,70,227,192,45,90,128,182,149,252,129,64,8,175,179,218,41,209,237,63,23,132,90,56,144,149,125,63,249,233,45,205,2,204,222,190,111,33,62,192,32,72,53,62,140,233,235,22,3,133,119,189,1,0,0,0,0,0,0,0,123,20,174,71,225,122,132,63,0,0,0,0,0,0,0,0,103,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,50,93,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,50,93,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,50,93,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,112,97,99,107,97,103,101,46,109,111,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,51,93,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,51,93,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,51,93,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,52,93,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,52,93,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,52,93,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,53,93,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,53,93,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,53,93,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,54,93,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,54,93,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,54,93,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,55,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,55,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,55,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,55,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,55,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,55,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,55,93,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,55,93,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,115,116,97,116,101,115,70,77,91,55,93,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,115,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,73,110,116,101,114,102,97,99,101,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,115,91,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+92160);
/* memory initializer */ allocate([115,91,51,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,115,91,52,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,115,91,53,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,88,105,115,91,49,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,88,105,115,91,49,44,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,88,105,115,91,50,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,88,105,115,91,50,44,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,88,105,115,91,51,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,88,105,115,91,51,44,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,88,105,115,91,52,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,88,105,115,91,52,44,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,88,105,115,91,53,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,88,105,115,91,53,44,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,98,95,102,108,111,119,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,98,95,102,108,111,119,115,91,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,98,95,102,108,111,119,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,98,95,102,108,111,119,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,98,95,102,108,111,119,115,91,50,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,98,95,102,108,111,119,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,98,95,102,108,111,119,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,98,95,102,108,111,119,115,91,51,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,98,95,102,108,111,119,115,91,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,98,95,102,108,111,119,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,98,95,102,108,111,119,115,91,52,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,98,95,102,108,111,119,115,91,52,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,98,95,102,108,111,119,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,98,95,102,108,111,119,115,91,53,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,98,95,102,108,111,119,115,91,53,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,98,88,105,95,102,108,111,119,115,91,49,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,98,88,105,95,102,108,111,119,115,91,49,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,98,88,105,95,102,108,111,119,115,91,49,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,98,88,105,95,102,108,111,119,115,91,50,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,98,88,105,95,102,108,111,119,115,91,50,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,98,88,105,95,102,108,111,119,115,91,50,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,98,88,105,95,102,108,111,119,115,91,51,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,98,88,105,95,102,108,111,119,115,91,51,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,98,88,105,95,102,108,111,119,115,91,51,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,98,88,105,95,102,108,111,119,115,91,52,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,98,88,105,95,102,108,111,119,115,91,52,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,98,88,105,95,102,108,111,119,115,91,52,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,98,88,105,95,102,108,111,119,115,91,53,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,98,88,105,95,102,108,111,119,115,91,53,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,98,88,105,95,102,108,111,119,115,91,53,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,88,105,95,102,108,111,119,115,91,49,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,88,105,95,102,108,111,119,115,91,49,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,88,105,95,102,108,111,119,115,91,49,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,80,105,112,101,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,88,105,95,102,108,111,119,115,91,50,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,88,105,95,102,108,111,119,115,91,50,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,88,105,95,102,108,111,119,115,91,50,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,88,105,95,102,108,111,119,115,91,51,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,88,105,95,102,108,111,119,115,91,51,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,88,105,95,102,108,111,119,115,91,51,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,88,105,95,102,108,111,119,115,91,52,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,88,105,95,102,108,111,119,115,91,52,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,88,105,95,102,108,111,119,115,91,52,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,88,105,95,102,108,111,119,115,91,53,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,88,105,95,102,108,111,119,115,91,53,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,88,105,95,102,108,111,119,115,91,53,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,88,105,95,102,108,111,119,115,91,54,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,88,105,95,102,108,111,119,115,91,54,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,88,105,95,102,108,111,119,115,91,54,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,72,95,102,108,111,119,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,72,95,102,108,111,119,115,91,49,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,49,46,72,95,102,108,111,119,115,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,72,95,102,108,111,119,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,72,95,102,108,111,119,115,91,50,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,49,46,72,95,102,108,111,119,115,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,72,95,102,108,111,119,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,72,95,102,108,111,119,115,91,51,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,49,46,72,95,102,108,111,119,115,91,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,72,95,102,108,111,119,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,72,95,102,108,111,119,115,91,52,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,49,46,72,95,102,108,111,119,115,91,52,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,72,95,102,108,111,119,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,72,95,102,108,111,119,115,91,53,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,49,46,72,95,102,108,111,119,115,91,53,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,72,95,102,108,111,119,115,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,72,95,102,108,111,119,115,91,54,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,49,46,72,95,102,108,111,119,115,91,54,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,52,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,52,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,53,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,53,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,54,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,54,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,55,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,55,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,52,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,52,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,53,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,53,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,54,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,54,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,52,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,52,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,53,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,53,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,54,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,54,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,55,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,55,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,52,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,52,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,53,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,53,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,54,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,54,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,50,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,51,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,52,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,52,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,53,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,53,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,54,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,112,105,112,101,49,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,54,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,120,95,119,97,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,120,95,119,97,116,101,114,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+102400);
/* memory initializer */ allocate([49,93,46,120,95,119,97,116,101,114,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,65,105,114,47,77,111,105,115,116,65,105,114,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,88,95,108,105,113,117,105,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,88,95,108,105,113,117,105,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,88,95,108,105,113,117,105,100,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,88,95,115,116,101,97,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,88,95,115,116,101,97,109,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,88,95,115,116,101,97,109,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,88,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,88,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,88,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,120,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,120,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,120,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,120,95,119,97,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,120,95,119,97,116,101,114,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,120,95,119,97,116,101,114,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,88,95,108,105,113,117,105,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,88,95,108,105,113,117,105,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,88,95,108,105,113,117,105,100,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,88,95,115,116,101,97,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,88,95,115,116,101,97,109,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,88,95,115,116,101,97,109,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,88,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,88,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,88,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,120,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,120,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,120,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,88,105,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,88,105,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,88,105,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,120,95,119,97,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,120,95,119,97,116,101,114,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,120,95,119,97,116,101,114,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,88,95,108,105,113,117,105,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,88,95,108,105,113,117,105,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,88,95,108,105,113,117,105,100,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,88,95,115,116,101,97,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,88,95,115,116,101,97,109,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,88,95,115,116,101,97,109,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,88,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,88,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,88,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,120,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,120,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,120,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,112,95,115,116,101,97,109,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,112,95,115,116,101,97,109,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,51,93,46,112,95,115,116,101,97,109,95,115,97,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,88,105,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,88,105,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,88,105,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,120,95,119,97,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,120,95,119,97,116,101,114,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,120,95,119,97,116,101,114,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,88,95,108,105,113,117,105,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,88,95,108,105,113,117,105,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,88,95,108,105,113,117,105,100,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,88,95,115,116,101,97,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,88,95,115,116,101,97,109,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,88,95,115,116,101,97,109,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,88,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,88,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,88,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,120,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,120,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,120,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,112,95,115,116,101,97,109,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,112,95,115,116,101,97,109,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,52,93,46,112,95,115,116,101,97,109,95,115,97,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,88,105,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,88,105,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,88,105,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,120,95,119,97,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,120,95,119,97,116,101,114,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,120,95,119,97,116,101,114,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,88,95,108,105,113,117,105,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,88,95,108,105,113,117,105,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,88,95,108,105,113,117,105,100,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,88,95,115,116,101,97,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,88,95,115,116,101,97,109,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,88,95,115,116,101,97,109,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,88,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,88,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,88,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,120,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,120,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,120,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,112,95,115,116,101,97,109,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,112,95,115,116,101,97,109,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,49,46,109,101,100,105,117,109,115,91,53,93,46,112,95,115,116,101,97,109,95,115,97,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,51,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,52,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,53,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,115,116,97,116,101,95,97,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,115,116,97,116,101,95,97,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,50,46,115,116,97,116,101,95,97,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,115,116,97,116,101,95,97,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,115,116,97,116,101,95,97,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,115,116,97,116,101,95,97,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,115,116,97,116,101,95,97,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,115,116,97,116,101,95,97,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,115,116,97,116,101,95,97,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,115,116,97,116,101,95,98,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,115,116,97,116,101,95,98,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,50,46,115,116,97,116,101,95,98,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,115,116,97,116,101,95,98,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,115,116,97,116,101,95,98,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,115,116,97,116,101,95,98,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,115,116,97,116,101,95,98,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,115,116,97,116,101,95,98,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,115,116,97,116,101,95,98,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,115,116,97,116,101,115,70,77,91,49,93,46,88,91,50,93,32,111,117,116,32,111,102,32,91], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+112640);
/* memory initializer */ allocate([109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,115,116,97,116,101,115,70,77,91,49,93,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,115,116,97,116,101,115,70,77,91,49,93,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,115,116,97,116,101,115,70,77,91,50,93,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,115,116,97,116,101,115,70,77,91,50,93,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,115,116,97,116,101,115,70,77,91,50,93,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,115,116,97,116,101,115,70,77,91,51,93,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,115,116,97,116,101,115,70,77,91,51,93,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,115,116,97,116,101,115,70,77,91,51,93,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,115,116,97,116,101,115,70,77,91,52,93,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,115,116,97,116,101,115,70,77,91,52,93,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,115,116,97,116,101,115,70,77,91,52,93,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,115,116,97,116,101,115,70,77,91,53,93,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,115,116,97,116,101,115,70,77,91,53,93,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,115,116,97,116,101,115,70,77,91,53,93,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,115,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,115,91,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,115,91,51,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,115,91,52,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,115,91,53,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,88,105,115,91,49,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,88,105,115,91,49,44,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,88,105,115,91,50,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,88,105,115,91,50,44,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,88,105,115,91,51,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,88,105,115,91,51,44,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,88,105,115,91,52,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,88,105,115,91,52,44,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,88,105,115,91,53,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,88,105,115,91,53,44,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,98,95,102,108,111,119,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,98,95,102,108,111,119,115,91,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,98,95,102,108,111,119,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,98,95,102,108,111,119,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,98,95,102,108,111,119,115,91,50,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,98,95,102,108,111,119,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,98,95,102,108,111,119,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,98,95,102,108,111,119,115,91,51,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,98,95,102,108,111,119,115,91,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,98,95,102,108,111,119,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,98,95,102,108,111,119,115,91,52,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,98,95,102,108,111,119,115,91,52,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,98,95,102,108,111,119,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,98,95,102,108,111,119,115,91,53,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,98,95,102,108,111,119,115,91,53,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,98,88,105,95,102,108,111,119,115,91,49,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,98,88,105,95,102,108,111,119,115,91,49,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,98,88,105,95,102,108,111,119,115,91,49,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,98,88,105,95,102,108,111,119,115,91,50,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,98,88,105,95,102,108,111,119,115,91,50,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,98,88,105,95,102,108,111,119,115,91,50,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,98,88,105,95,102,108,111,119,115,91,51,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,98,88,105,95,102,108,111,119,115,91,51,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,98,88,105,95,102,108,111,119,115,91,51,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,98,88,105,95,102,108,111,119,115,91,52,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,98,88,105,95,102,108,111,119,115,91,52,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,98,88,105,95,102,108,111,119,115,91,52,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,98,88,105,95,102,108,111,119,115,91,53,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,98,88,105,95,102,108,111,119,115,91,53,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,98,88,105,95,102,108,111,119,115,91,53,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,95,102,108,111,119,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,95,102,108,111,119,115,91,49,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,112,105,112,101,50,46,109,95,102,108,111,119,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,95,102,108,111,119,115,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,95,102,108,111,119,115,91,54,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,112,105,112,101,50,46,109,95,102,108,111,119,115,91,54,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,16,153,1,0,144,1,0,0,7,0,0,0,147,1,0,0,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,88,105,95,102,108,111,119,115,91,49,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,88,105,95,102,108,111,119,115,91,49,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,88,105,95,102,108,111,119,115,91,49,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,88,105,95,102,108,111,119,115,91,50,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,88,105,95,102,108,111,119,115,91,50,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,88,105,95,102,108,111,119,115,91,50,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,88,105,95,102,108,111,119,115,91,51,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,88,105,95,102,108,111,119,115,91,51,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,88,105,95,102,108,111,119,115,91,51,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,88,105,95,102,108,111,119,115,91,52,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,88,105,95,102,108,111,119,115,91,52,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,88,105,95,102,108,111,119,115,91,52,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,88,105,95,102,108,111,119,115,91,53,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,88,105,95,102,108,111,119,115,91,53,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,88,105,95,102,108,111,119,115,91,53,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,88,105,95,102,108,111,119,115,91,54,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,88,105,95,102,108,111,119,115,91,54,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,88,105,95,102,108,111,119,115,91,54,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,72,95,102,108,111,119,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,72,95,102,108,111,119,115,91,49,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,50,46,72,95,102,108,111,119,115,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,72,95,102,108,111,119,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,72,95,102,108,111,119,115,91,50,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,50,46,72,95,102,108,111,119,115,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,72,95,102,108,111,119,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,72,95,102,108,111,119,115,91,51,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,50,46,72,95,102,108,111,119,115,91,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,72,95,102,108,111,119,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,72,95,102,108,111,119,115,91,52,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,50,46,72,95,102,108,111,119,115,91,52,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,72,95,102,108,111,119,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,72,95,102,108,111,119,115,91,53,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,50,46,72,95,102,108,111,119,115,91,53,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,72,95,102,108,111,119,115,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,72,95,102,108,111,119,115,91,54,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,50,46,72,95,102,108,111,119,115,91,54,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,52,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,52,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,53,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,53,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,52,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,52,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,52,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,52,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,53,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,53,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,52,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,52,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,50,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,51,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,52,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,112,105,112,101,50,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,52,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,120,95,119,97,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,120,95,119,97,116,101,114,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,120,95,119,97,116,101,114,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,88,95,108,105,113,117,105,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,88,95,108,105,113,117,105,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,88,95,108,105,113,117,105,100,32,60,61,32,49,46,48,32,104,97,115], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+122880);
/* memory initializer */ allocate([32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,88,95,115,116,101,97,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,88,95,115,116,101,97,109,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,88,95,115,116,101,97,109,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,88,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,88,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,88,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,120,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,120,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,120,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,120,95,119,97,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,120,95,119,97,116,101,114,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,120,95,119,97,116,101,114,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,88,95,108,105,113,117,105,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,88,95,108,105,113,117,105,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,88,95,108,105,113,117,105,100,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,88,95,115,116,101,97,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,88,95,115,116,101,97,109,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,88,95,115,116,101,97,109,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,88,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,88,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,88,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,120,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,120,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,120,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,88,105,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,88,105,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,88,105,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,120,95,119,97,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,120,95,119,97,116,101,114,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,120,95,119,97,116,101,114,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,88,95,108,105,113,117,105,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,88,95,108,105,113,117,105,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,88,95,108,105,113,117,105,100,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,88,95,115,116,101,97,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,88,95,115,116,101,97,109,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,88,95,115,116,101,97,109,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,88,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,88,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,88,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,120,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,120,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,120,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,112,95,115,116,101,97,109,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,112,95,115,116,101,97,109,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,51,93,46,112,95,115,116,101,97,109,95,115,97,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,88,105,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,88,105,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,88,105,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,120,95,119,97,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,120,95,119,97,116,101,114,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,120,95,119,97,116,101,114,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,88,95,108,105,113,117,105,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,88,95,108,105,113,117,105,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,88,95,108,105,113,117,105,100,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,88,95,115,116,101,97,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,88,95,115,116,101,97,109,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,88,95,115,116,101,97,109,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,88,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,88,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,88,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,120,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,120,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,120,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,112,95,115,116,101,97,109,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,112,95,115,116,101,97,109,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,52,93,46,112,95,115,116,101,97,109,95,115,97,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,88,105,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,88,105,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,88,105,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,120,95,119,97,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,120,95,119,97,116,101,114,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,120,95,119,97,116,101,114,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,88,95,108,105,113,117,105,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,88,95,108,105,113,117,105,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,88,95,108,105,113,117,105,100,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,88,95,115,116,101,97,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,88,95,115,116,101,97,109,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,88,95,115,116,101,97,109,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,88,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,88,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,88,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,120,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,120,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,120,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,112,95,115,116,101,97,109,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,112,95,115,116,101,97,109,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,109,101,100,105,117,109,115,91,53,93,46,112,95,115,116,101,97,109,95,115,97,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,100,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,100,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,100,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,100,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,100,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,100,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,100,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,100,115,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,100,115,91,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,100,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,100,115,91,52,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,100,115,91,52,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,100,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,100,115,91,53,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,100,115,91,53,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,16,153,1,0,159,6,0,0,7,0,0,0,159,6,0,0,39,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,52,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,52,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,53,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,53,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,16,153,1,0,160,6,0,0,7,0,0,0,160,6,0,0,59,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+133120);
/* memory initializer */ allocate([32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,49,93,32,60,61,32,53,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,50,93,32,60,61,32,53,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,51,93,32,60,61,32,53,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,52,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,52,93,32,60,61,32,53,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,53,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,53,93,32,60,61,32,53,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,16,153,1,0,161,6,0,0,7,0,0,0,161,6,0,0,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,51,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,52,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,53,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,49,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,49,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,49,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,49,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,49,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,49,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,49,93,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,49,93,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,49,93,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,50,93,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,50,93,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,50,93,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,51,93,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,51,93,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,51,93,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,52,93,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,52,93,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,52,93,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,53,93,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,53,93,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,53,93,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,54,93,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,54,93,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,54,93,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,55,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,55,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,55,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,55,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,55,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,55,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,55,93,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,55,93,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,115,116,97,116,101,115,70,77,91,55,93,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,115,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,115,91,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,115,91,51,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,115,91,52,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,115,91,53,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,88,105,115,91,49,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,88,105,115,91,49,44,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,88,105,115,91,50,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,88,105,115,91,50,44,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,88,105,115,91,51,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,88,105,115,91,51,44,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,88,105,115,91,52,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,88,105,115,91,52,44,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,88,105,115,91,53,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,88,105,115,91,53,44,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,98,95,102,108,111,119,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,98,95,102,108,111,119,115,91,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,98,95,102,108,111,119,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,98,95,102,108,111,119,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,98,95,102,108,111,119,115,91,50,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,98,95,102,108,111,119,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,98,95,102,108,111,119,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,98,95,102,108,111,119,115,91,51,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,98,95,102,108,111,119,115,91,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,98,95,102,108,111,119,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,98,95,102,108,111,119,115,91,52,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,98,95,102,108,111,119,115,91,52,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,98,95,102,108,111,119,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,98,95,102,108,111,119,115,91,53,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,98,95,102,108,111,119,115,91,53,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,98,88,105,95,102,108,111,119,115,91,49,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,98,88,105,95,102,108,111,119,115,91,49,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,98,88,105,95,102,108,111,119,115,91,49,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,98,88,105,95,102,108,111,119,115,91,50,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,98,88,105,95,102,108,111,119,115,91,50,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,98,88,105,95,102,108,111,119,115,91,50,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,98,88,105,95,102,108,111,119,115,91,51,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,98,88,105,95,102,108,111,119,115,91,51,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,98,88,105,95,102,108,111,119,115,91,51,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,98,88,105,95,102,108,111,119,115,91,52,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,98,88,105,95,102,108,111,119,115,91,52,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,98,88,105,95,102,108,111,119,115,91,52,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,98,88,105,95,102,108,111,119,115,91,53,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,98,88,105,95,102,108,111,119,115,91,53,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,98,88,105,95,102,108,111,119,115,91,53,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,88,105,95,102,108,111,119,115,91,49,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,88,105,95,102,108,111,119,115,91,49,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,88,105,95,102,108,111,119,115,91,49,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,88,105,95,102,108,111,119,115,91,50,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,88,105,95,102,108,111,119,115,91,50,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,88,105,95,102,108,111,119,115,91,50,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,88,105,95,102,108,111,119,115,91,51,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,88,105,95,102,108,111,119,115,91,51,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,88,105,95,102,108,111,119,115,91,51,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,88,105,95,102,108,111,119,115,91,52,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,88,105,95,102,108,111,119,115,91,52,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,88,105,95,102,108,111,119,115,91,52,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,88,105,95,102,108,111,119,115,91,53,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,88,105,95,102,108,111,119,115,91,53,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,88,105,95,102,108,111,119,115,91,53,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,88,105,95,102,108,111,119,115,91,54,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,88,105,95,102,108,111,119,115,91,54,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,88,105,95,102,108,111,119,115,91,54,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,72,95,102,108,111,119,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,72,95,102,108,111,119,115,91,49,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,51,46,72,95,102,108,111,119,115,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,72,95,102,108,111,119,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,72,95,102,108,111,119,115,91,50,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,51,46,72,95,102,108,111,119,115,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,72,95,102,108,111,119,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,72,95,102,108,111,119,115,91,51,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,51,46,72,95,102,108,111,119,115,91,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,72,95,102,108,111,119,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,72,95,102,108,111,119,115,91,52,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,51,46,72,95,102,108,111,119,115,91,52,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,72,95,102,108,111,119,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,72,95,102,108,111,119,115,91,53,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,51,46,72,95,102,108,111,119,115,91,53,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,72,95,102,108,111,119,115,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,72,95,102,108,111,119,115,91,54,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,51,46,72,95,102,108,111,119,115,91,54,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,52,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,52,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,53,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,53,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,54,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,54,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,55,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,55,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,52,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,52,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,53,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,53,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,54,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,54,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,52,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,52,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,53,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,53,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,54,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,54,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,55,93,32,111,117,116,32,111,102,32,91], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+143360);
/* memory initializer */ allocate([109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,55,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,55,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,52,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,52,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,53,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,53,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,54,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,54,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,50,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,51,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,52,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,52,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,53,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,53,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,54,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,112,105,112,101,51,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,54,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,120,95,119,97,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,120,95,119,97,116,101,114,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,120,95,119,97,116,101,114,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,88,95,108,105,113,117,105,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,88,95,108,105,113,117,105,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,88,95,108,105,113,117,105,100,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,88,95,115,116,101,97,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,88,95,115,116,101,97,109,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,88,95,115,116,101,97,109,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,88,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,88,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,88,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,120,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,120,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,120,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,120,95,119,97,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,120,95,119,97,116,101,114,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,120,95,119,97,116,101,114,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,88,95,108,105,113,117,105,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,88,95,108,105,113,117,105,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,88,95,108,105,113,117,105,100,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,88,95,115,116,101,97,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,88,95,115,116,101,97,109,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,88,95,115,116,101,97,109,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,88,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,88,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,88,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,120,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,120,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,120,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,88,105,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,88,105,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,88,105,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,120,95,119,97,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,120,95,119,97,116,101,114,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,120,95,119,97,116,101,114,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,88,95,108,105,113,117,105,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,88,95,108,105,113,117,105,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,88,95,108,105,113,117,105,100,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,88,95,115,116,101,97,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,88,95,115,116,101,97,109,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,88,95,115,116,101,97,109,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,88,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,88,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,88,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,120,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,120,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,120,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,112,95,115,116,101,97,109,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,112,95,115,116,101,97,109,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,51,93,46,112,95,115,116,101,97,109,95,115,97,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,88,105,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,88,105,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,88,105,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,120,95,119,97,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,120,95,119,97,116,101,114,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,120,95,119,97,116,101,114,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,88,95,108,105,113,117,105,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,88,95,108,105,113,117,105,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,88,95,108,105,113,117,105,100,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,88,95,115,116,101,97,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,88,95,115,116,101,97,109,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,88,95,115,116,101,97,109,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,88,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,88,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,88,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,120,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,120,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,120,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,112,95,115,116,101,97,109,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,112,95,115,116,101,97,109,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,52,93,46,112,95,115,116,101,97,109,95,115,97,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,112,32,60,61,32,49,48,48,48], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+153600);
/* memory initializer */ allocate([48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,88,105,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,88,105,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,88,105,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,120,95,119,97,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,120,95,119,97,116,101,114,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,120,95,119,97,116,101,114,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,88,95,108,105,113,117,105,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,88,95,108,105,113,117,105,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,88,95,108,105,113,117,105,100,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,88,95,115,116,101,97,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,88,95,115,116,101,97,109,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,88,95,115,116,101,97,109,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,88,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,88,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,88,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,120,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,120,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,120,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,112,95,115,116,101,97,109,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,112,95,115,116,101,97,109,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,51,46,109,101,100,105,117,109,115,91,53,93,46,112,95,115,116,101,97,109,95,115,97,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,51,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,52,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,51,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,51,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,53,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,49,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,49,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,49,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,49,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,49,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,49,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,49,93,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,49,93,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,49,93,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,50,93,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,50,93,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,50,93,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,51,93,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,51,93,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,51,93,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,52,93,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,52,93,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,52,93,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,53,93,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,53,93,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,53,93,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,54,93,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,54,93,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,54,93,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,144,138,1,0,126,21,0,0,7,0,0,0,127,21,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,55,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,55,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,52,46,115,116,97,116,101,115,70,77,91,55,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,144,138,1,0,125,21,0,0,7,0,0,0,125,21,0,0,44,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,115,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,115,91,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,115,91,51,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,115,91,52,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,115,91,53,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,32,143,1,0,102,3,0,0,3,0,0,0,102,3,0,0,29,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,88,105,115,91,49,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,88,105,115,91,49,44,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,88,105,115,91,50,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,88,105,115,91,50,44,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,88,105,115,91,51,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,88,105,115,91,51,44,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,88,105,115,91,52,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,88,105,115,91,52,44,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,88,105,115,91,53,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,88,105,115,91,53,44,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,32,143,1,0,103,3,0,0,3,0,0,0,103,3,0,0,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,98,95,102,108,111,119,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,98,95,102,108,111,119,115,91,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,98,95,102,108,111,119,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,98,95,102,108,111,119,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,98,95,102,108,111,119,115,91,50,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,98,95,102,108,111,119,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,98,95,102,108,111,119,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,98,95,102,108,111,119,115,91,51,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,98,95,102,108,111,119,115,91,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,98,95,102,108,111,119,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,98,95,102,108,111,119,115,91,52,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,98,95,102,108,111,119,115,91,52,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,98,95,102,108,111,119,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,98,95,102,108,111,119,115,91,53,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,98,95,102,108,111,119,115,91,53,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,32,143,1,0,118,3,0,0,3,0,0,0,118,3,0,0,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,98,88,105,95,102,108,111,119,115,91,49,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,98,88,105,95,102,108,111,119,115,91,49,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,98,88,105,95,102,108,111,119,115,91,49,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,98,88,105,95,102,108,111,119,115,91,50,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,98,88,105,95,102,108,111,119,115,91,50,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,98,88,105,95,102,108,111,119,115,91,50,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,98,88,105,95,102,108,111,119,115,91,51,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,98,88,105,95,102,108,111,119,115,91,51,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,98,88,105,95,102,108,111,119,115,91,51,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,98,88,105,95,102,108,111,119,115,91,52,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,98,88,105,95,102,108,111,119,115,91,52,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,98,88,105,95,102,108,111,119,115,91,52,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,98,88,105,95,102,108,111,119,115,91,53,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,98,88,105,95,102,108,111,119,115,91,53,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,98,88,105,95,102,108,111,119,115,91,53,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,32,143,1,0,119,3,0,0,3,0,0,0,120,3,0,0,52,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,88,105,95,102,108,111,119,115,91,49,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,88,105,95,102,108,111,119,115,91,49,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,88,105,95,102,108,111,119,115,91,49,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,88,105,95,102,108,111,119,115,91,50,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,88,105,95,102,108,111,119,115,91,50,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,88,105,95,102,108,111,119,115,91,50,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,88,105,95,102,108,111,119,115,91,51,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,88,105,95,102,108,111,119,115,91,51,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,88,105,95,102,108,111,119,115,91,51,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,88,105,95,102,108,111,119,115,91,52,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,88,105,95,102,108,111,119,115,91,52,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,88,105,95,102,108,111,119,115,91,52,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,88,105,95,102,108,111,119,115,91,53,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,88,105,95,102,108,111,119,115,91,53,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,88,105,95,102,108,111,119,115,91,53,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,88,105,95,102,108,111,119,115,91,54,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,88,105,95,102,108,111,119,115,91,54,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,88,105,95,102,108,111,119,115,91,54,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,16,153,1,0,148,1,0,0,7,0,0,0,149,1,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,72,95,102,108,111,119,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,72,95,102,108,111,119,115,91,49,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,52,46,72,95,102,108,111,119,115,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,72,95,102,108,111,119,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,72,95,102,108,111,119,115,91,50,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,52,46,72,95,102,108,111,119,115,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,72,95,102,108,111,119,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,72,95,102,108,111,119,115,91,51,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,52,46,72,95,102,108,111,119,115,91,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,72,95,102,108,111,119,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,72,95,102,108,111,119,115,91,52,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,52,46,72,95,102,108,111,119,115,91,52,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,72,95,102,108,111,119,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,72,95,102,108,111,119,115,91,53,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,52,46,72,95,102,108,111,119,115,91,53,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,72,95,102,108,111,119,115,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,72,95,102,108,111,119,115,91,54,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,52,46,72,95,102,108,111,119,115,91,54,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,16,153,1,0,152,1,0,0,7,0,0,0,153,1,0,0,65,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,52,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,52,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,53,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,53,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,54,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,54,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,55,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,55,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,16,153,1,0,52,4,0,0,13,0,0,0,52,4,0,0,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,52,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,52,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,53,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,53,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+163840);
/* memory initializer */ allocate([32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,54,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,54,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,16,153,1,0,53,4,0,0,13,0,0,0,53,4,0,0,70,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,52,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,52,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,53,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,53,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,54,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,54,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,55,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,55,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,16,153,1,0,55,4,0,0,13,0,0,0,55,4,0,0,125,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,52,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,52,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,53,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,53,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,54,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,54,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,16,153,1,0,56,4,0,0,13,0,0,0,56,4,0,0,80,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,50,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,51,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,52,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,52,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,53,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,53,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,54,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,112,105,112,101,52,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,54,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,32,143,1,0,29,4,0,0,9,0,0,0,34,4,0,0,39,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,120,95,119,97,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,120,95,119,97,116,101,114,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,120,95,119,97,116,101,114,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,88,95,108,105,113,117,105,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,88,95,108,105,113,117,105,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,88,95,108,105,113,117,105,100,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,88,95,115,116,101,97,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,88,95,115,116,101,97,109,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,88,95,115,116,101,97,109,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,88,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,88,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,88,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,120,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,120,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,120,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,120,95,119,97,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,120,95,119,97,116,101,114,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,120,95,119,97,116,101,114,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,88,95,108,105,113,117,105,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,88,95,108,105,113,117,105,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,88,95,108,105,113,117,105,100,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,88,95,115,116,101,97,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,88,95,115,116,101,97,109,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,88,95,115,116,101,97,109,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,88,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,88,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,88,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,120,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,120,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,120,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,88,105,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,88,105,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,88,105,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,120,95,119,97,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,120,95,119,97,116,101,114,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,120,95,119,97,116,101,114,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,88,95,108,105,113,117,105,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,88,95,108,105,113,117,105,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,88,95,108,105,113,117,105,100,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,88,95,115,116,101,97,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,88,95,115,116,101,97,109,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,88,95,115,116,101,97,109,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,88,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,88,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,88,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,120,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,120,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,120,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,112,95,115,116,101,97,109,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,112,95,115,116,101,97,109,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,51,93,46,112,95,115,116,101,97,109,95,115,97,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,88,105,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,88,105,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,88,105,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,77,77,32,111,117,116], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+174080);
/* memory initializer */ allocate([32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,120,95,119,97,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,120,95,119,97,116,101,114,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,120,95,119,97,116,101,114,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,88,95,108,105,113,117,105,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,88,95,108,105,113,117,105,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,88,95,108,105,113,117,105,100,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,88,95,115,116,101,97,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,88,95,115,116,101,97,109,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,88,95,115,116,101,97,109,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,88,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,88,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,88,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,120,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,120,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,120,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,112,95,115,116,101,97,109,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,112,95,115,116,101,97,109,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,52,93,46,112,95,115,116,101,97,109,95,115,97,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,144,138,1,0,30,17,0,0,7,0,0,0,30,17,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,88,105,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,88,105,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,88,105,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,144,138,1,0,31,17,0,0,7,0,0,0,32,17,0,0,50,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,144,138,1,0,35,17,0,0,7,0,0,0,35,17,0,0,44,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,144,138,1,0,40,17,0,0,7,0,0,0,40,17,0,0,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,120,95,119,97,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,120,95,119,97,116,101,114,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,120,95,119,97,116,101,114,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,40,184,1,0,51,0,0,0,7,0,0,0,51,0,0,0,65,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,88,95,108,105,113,117,105,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,88,95,108,105,113,117,105,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,88,95,108,105,113,117,105,100,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,88,95,115,116,101,97,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,88,95,115,116,101,97,109,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,88,95,115,116,101,97,109,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,88,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,88,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,88,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,120,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,120,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,120,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,112,95,115,116,101,97,109,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,112,95,115,116,101,97,109,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,52,46,109,101,100,105,117,109,115,91,53,93,46,112,95,115,116,101,97,109,95,115,97,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,51,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,52,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,52,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,52,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,53,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,32,143,1,0,247,1,0,0,5,0,0,0,248,1,0,0,45,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,144,138,1,0,33,17,0,0,7,0,0,0,33,17,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,100,32,62,61,32,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,144,138,1,0,34,17,0,0,7,0,0,0,34,17,0,0,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,144,138,1,0,38,17,0,0,7,0,0,0,38,17,0,0,68,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,82,32,62,61,32,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,144,138,1,0,39,17,0,0,7,0,0,0,39,17,0,0,71,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,32,62,61,32,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,40,184,1,0,55,0,0,0,7,0,0,0,55,0,0,0,69,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,88,95,115,116,101,97,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,88,95,115,116,101,97,109,32,62,61,32,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,88,95,115,116,101,97,109,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,40,184,1,0,56,0,0,0,7,0,0,0,56,0,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,88,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,88,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,88,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,40,184,1,0,58,0,0,0,7,0,0,0,59,0,0,0,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,120,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,120,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,120,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,40,184,1,0,60,0,0,0,7,0,0,0,61,0,0,0,80,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,40,184,1,0,62,0,0,0,7,0,0,0,62,0,0,0,74,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,52,46,112,95,105,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,52,46,112,95,105,110,32,62,61,32,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,52,46,112,95,105,110,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,83,111,117,114,99,101,115,46,109,111,0,0,0,224,229,2,0,159,0,0,0,5,0,0,0,162,0,0,0,26,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,104,101,97,116,50,91,49,93,46,112,111,114,116,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,104,101,97,116,50,91,49,93,46,112,111,114,116,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,84,104,101,114,109,97,108,47,72,101,97,116,84,114,97,110,115,102,101,114,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,104,101,97,116,50,91,50,93,46,112,111,114,116,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,104,101,97,116,50,91,50,93,46,112,111,114,116,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,104,101,97,116,50,91,51,93,46,112,111,114,116,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,104,101,97,116,50,91,51,93,46,112,111,114,116,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,104,101,97,116,50,91,52,93,46,112,111,114,116,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,104,101,97,116,50,91,52,93,46,112,111,114,116,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,104,101,97,116,50,91,53,93,46,112,111,114,116,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,104,101,97,116,50,91,53,93,46,112,111,114,116,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,160,230,2,0,27,11,0,0,7,0,0,0,27,11,0,0,56,0,0,0,0,0,0,0,109,111,100,101,108,32,108,105,110,101,97,114,95,77,111,100,101,108,105,99,97,95,70,108,117,105,100,95,69,120,97,109,112,108,101,115,95,66,114,97,110,99,104,105,110,103,68,121,110,97,109,105,99,80,105,112,101,115,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,110,32,61,32,56,50,59,32,47,47,32,115,116,97,116,101,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,107,32,61,32,48,59,32,47,47,32,116,111,112,45,108,101,118,101,108,32,105,110,112,117,116,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,108,32,61,32,48,59,32,47,47,32,116,111,112,45,108,101,118,101,108,32,111,117,116,112,117,116,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,120,48,91,56,50,93,32,61,32,123,37,115,125,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,117,48,91,48,93,32,61,32,123,37,115,125,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,65,91,56,50,44,56,50,93,32,61,32,91,37,115,93,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,66,91,56,50,44,48,93,32,61,32,122,101,114,111,115,40,56,50,44,48,41,59,37,115,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,67,91,48,44,56,50,93,32,61,32,122,101,114,111,115,40,48,44,56,50,41,59,37,115,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,68,91,48,44,48,93,32,61,32,122,101,114,111,115,40,48,44,48,41,59,37,115,10,32,32,82,101,97,108,32,120,91,56,50,93,40,115,116,97,114,116,61,120,48,41,59,10,32,32,105,110,112,117,116,32,82,101,97,108,32,117,91,48,93,59,10,32,32,111,117,116,112,117,116,32,82,101,97,108,32,121,91,48,93,59,10,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,52,80,109,101,100,105,117,109,115,108,66,53,114,66,80,84,32,61,32,120,91,49,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,52,80,109,101,100,105,117,109,115,108,66,53,114,66,80,88,105,108,66,49,114,66,32,61,32,120,91,50,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,52,80,109,101,100,105,117,109,115,108,66,53,114,66,80,112,32,61,32,120,91,51,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,52,80,109,101,100,105,117,109,115,108,66,52,114,66,80,84,32,61,32,120,91,52,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,52,80,109,101,100,105,117,109,115,108,66,52,114,66,80,88,105,108,66,49,114,66,32,61,32,120,91,53,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,52,80,109,101,100,105,117,109,115,108,66,52,114,66,80,112,32,61,32,120,91,54,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,52,80,109,101,100,105,117,109,115,108,66,51,114,66,80,84,32,61,32,120,91,55,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,52,80,109,101,100,105,117,109,115,108,66,51,114,66,80,88,105,108,66,49,114,66,32,61,32,120,91,56,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,52,80,109,101,100,105,117,109,115,108,66,51,114,66,80,112,32,61,32,120,91,57,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,52,80,109,101,100,105,117,109,115,108,66,50,114,66,80,84,32,61,32,120,91,49,48,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,52,80,109,101,100,105,117,109,115,108,66,50,114,66,80,88,105,108,66,49,114,66,32,61,32,120,91,49,49,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,52,80,109,101,100,105,117,109,115,108,66,50,114,66,80,112,32,61,32,120,91,49,50,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,52,80,109,101,100,105,117,109,115,108,66,49,114,66,80,84,32,61,32,120,91,49,51,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,52,80,109,101,100,105,117,109,115,108,66,49,114,66,80,88,105,108,66,49,114,66,32,61,32,120,91,49,52,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,52,80,109,101,100,105,117,109,115,108,66,49,114,66,80,112,32,61,32,120,91,49,53,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,52,80,102,108,111,119,77,111,100,101,108,80,109,95,102,108,111,119,115,108,66,49,114,66,32,61,32,120,91,49,54,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,52,80,102,108,111,119,77,111,100,101,108,80,109,95,102,108,111,119,115,108,66,50,114,66,32,61,32,120,91,49,55,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,52,80,102,108,111,119,77,111,100,101,108,80,109,95,102,108,111,119,115,108,66,51,114,66,32,61,32,120,91,49,56,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,52,80,102,108,111,119,77,111,100,101,108,80,109,95,102,108,111,119,115,108,66,52,114,66,32,61,32,120,91,49,57,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,52,80,102,108,111,119,77,111,100,101,108,80,109,95,102,108,111,119,115,108,66,53,114,66,32,61,32,120,91,50,48,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,52,80,102,108,111,119,77,111,100,101,108,80,109,95,102,108,111,119,115,108,66,54,114,66,32,61,32,120,91,50,49,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,51,80,109,101,100,105,117,109,115,108,66,53,114,66,80,84,32,61,32,120,91,50,50,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,51,80,109,101,100,105,117,109,115,108,66,53,114,66,80,88,105,108,66,49,114,66,32,61,32,120,91,50,51,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,51,80,109,101,100,105,117,109,115,108,66,53,114,66,80,112,32,61,32,120,91,50,52,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,51,80,109,101,100,105,117,109,115,108,66,52,114,66,80,84,32,61,32,120,91,50,53,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,51,80,109,101,100,105,117,109,115,108,66,52,114,66,80,88,105,108,66,49,114,66,32,61,32,120,91,50,54,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,51,80,109,101,100,105,117,109,115,108,66,52,114,66,80,112,32,61,32,120,91,50,55,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,51,80,109,101,100,105,117,109,115,108,66,51,114,66,80,84,32,61,32,120,91,50,56,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,51,80,109,101,100,105,117,109,115,108,66,51,114,66,80,88,105,108,66,49,114,66,32,61,32,120,91,50,57,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,51,80,109,101,100,105,117,109,115,108,66,51,114,66,80,112,32,61,32,120,91,51,48,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,51,80,109,101,100,105,117,109,115,108,66,50,114,66,80,84,32,61,32,120,91,51,49,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,51,80,109,101,100,105,117,109,115,108,66,50,114,66,80,88,105,108,66,49,114,66,32,61,32,120,91,51,50,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,51,80,109,101,100,105,117,109,115,108,66,50,114,66,80,112,32,61,32,120,91,51,51,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,51,80,109,101,100,105,117,109,115,108,66,49,114,66,80,84,32,61,32,120,91,51,52,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,51,80,109,101,100,105,117,109,115,108,66,49,114,66,80,88,105,108,66,49,114,66,32,61,32,120,91,51,53,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,51,80,109,101,100,105,117,109,115,108,66,49,114,66,80,112,32,61,32,120,91,51,54,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,51,80,102,108,111,119,77,111,100,101,108,80,109,95,102,108,111,119,115,108,66,49,114,66,32,61,32,120,91,51,55,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,51,80,102,108,111,119,77,111,100,101,108,80,109,95,102,108,111,119,115,108,66,50,114,66,32,61,32,120,91,51,56,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,51,80,102,108,111,119,77,111,100,101,108,80,109,95,102,108,111,119,115,108,66,51,114,66,32,61,32,120,91,51,57,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,51,80,102,108,111,119,77,111,100,101,108,80,109,95,102,108,111,119,115,108,66,52,114,66,32,61,32,120,91,52,48,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,51,80,102,108,111,119,77,111,100,101,108,80,109,95,102,108,111,119,115,108,66,53,114,66,32,61,32,120,91,52,49,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,51,80,102,108,111,119,77,111,100,101,108,80,109,95,102,108,111,119,115,108,66,54,114,66,32,61,32,120,91,52,50,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,50,80,109,101,100,105,117,109,115,108,66,53,114,66,80,84,32,61,32,120,91,52,51,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,50,80,109,101,100,105,117,109,115,108,66,53,114,66,80,88,105,108,66,49,114,66,32,61,32,120,91,52,52,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,50,80,109,101,100,105,117,109,115,108,66,53,114,66,80,112,32,61,32,120,91,52,53,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,50,80,109,101,100,105,117,109,115,108,66,52,114,66,80,84,32,61,32,120,91,52,54,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,50,80,109,101,100,105,117,109,115,108,66,52,114,66,80,88,105,108,66,49,114,66,32,61,32,120,91,52,55,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,50,80,109,101,100,105,117,109,115,108,66,52,114,66,80,112,32,61,32,120,91,52,56,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,50,80,109,101,100,105,117,109,115,108,66,51,114,66,80,84,32,61,32,120,91,52,57,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,50,80,109,101,100,105,117,109,115,108,66,51,114,66,80,88,105,108,66,49,114,66,32,61,32,120,91,53,48,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,50,80,109,101,100,105,117,109,115,108,66,51,114,66,80,112,32,61,32,120,91,53,49,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,50,80,109,101,100,105,117,109,115,108,66,50,114,66,80,84,32,61,32,120,91,53,50,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,50,80,109,101,100,105,117,109,115,108,66,50,114,66,80,88,105,108,66,49,114,66,32,61,32,120,91,53,51,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,50,80,109,101,100,105,117,109,115,108,66,50,114,66,80,112,32,61,32,120,91,53,52,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,50,80,109,101,100,105,117,109,115,108,66,49,114,66,80,84,32,61,32,120,91,53,53,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,50,80,109,101,100,105,117,109,115,108,66,49,114,66,80,88,105,108,66,49,114,66,32,61,32,120,91,53,54,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,50,80,109,101,100,105,117,109,115,108,66,49,114,66,80,112,32,61,32,120,91,53,55,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,50,80,102,108,111,119,77,111,100,101,108,80,109,95,102,108,111,119,115,108,66,49,114,66,32,61,32,120,91,53,56,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,50,80,102,108,111,119,77,111,100,101,108,80,109,95,102,108,111,119,115,108,66,50,114,66,32,61,32,120,91,53,57,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,50,80,102,108,111,119,77,111,100,101,108,80,109,95,102,108,111,119,115,108,66,51,114,66,32,61,32,120,91,54,48,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,50,80,102,108,111,119,77,111,100,101,108,80,109,95,102,108,111,119,115,108,66,52,114,66,32,61,32,120,91,54,49,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,49,80,109,101,100,105,117,109,115,108,66,53,114,66,80,84,32,61,32,120,91,54,50,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,49,80,109,101,100,105,117,109,115,108,66,53,114,66,80,88,105,108,66,49,114,66,32,61,32,120,91,54,51,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,49,80,109,101,100,105,117,109,115,108,66,53,114,66,80,112,32,61,32,120,91,54,52,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,49,80,109,101,100,105,117,109,115,108,66,52,114,66,80,84,32,61,32,120,91,54,53,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,49,80,109,101,100,105,117,109,115,108,66,52,114,66,80,88,105,108,66,49,114,66,32,61,32,120,91,54,54,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,49,80,109,101,100,105,117,109,115,108,66,52,114,66,80,112,32,61,32,120,91,54,55,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,49,80,109,101,100,105,117,109,115,108,66,51,114,66,80,84,32,61,32,120,91,54,56,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,49,80,109,101,100,105,117,109,115,108,66,51,114,66,80,88,105,108,66,49,114,66,32,61,32,120,91,54,57,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,49,80,109,101,100,105,117,109,115,108,66,51,114,66,80,112,32,61,32,120,91,55,48,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,49,80,109,101,100,105,117,109,115,108,66,50,114,66,80,84,32,61,32,120,91,55,49,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,49,80,109,101,100,105,117,109,115,108,66,50,114,66,80,88,105,108,66,49,114,66,32,61,32,120,91,55,50,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,49,80,109,101,100,105,117,109,115,108,66,50,114,66,80,112,32,61,32,120,91,55,51,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,49,80,109,101,100,105,117,109,115,108,66,49,114,66,80,84,32,61,32,120,91,55,52,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,49,80,109,101,100,105,117,109,115,108,66,49,114,66,80,88,105,108,66,49,114,66,32,61,32,120,91,55,53,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,49,80,109,101,100,105,117,109,115,108,66,49,114,66,80,112,32,61,32,120,91,55,54,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,49,80,102,108,111,119,77,111,100,101,108,80,109,95,102,108,111,119,115,108,66,49,114,66,32,61,32,120,91,55,55,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,49,80,102,108,111,119,77,111,100,101,108,80,109,95,102,108,111,119,115,108,66,50,114,66,32,61,32,120,91,55,56,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,49,80,102,108,111,119,77,111,100,101,108,80,109,95,102,108,111,119,115,108,66,51,114,66,32,61,32,120,91,55,57,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,49,80,102,108,111,119,77,111,100,101,108,80,109,95,102,108,111,119,115,108,66,52,114,66,32,61,32,120,91,56,48,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,49,80,102], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+184320);
/* memory initializer */ allocate([108,111,119,77,111,100,101,108,80,109,95,102,108,111,119,115,108,66,53,114,66,32,61,32,120,91,56,49,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,49,80,102,108,111,119,77,111,100,101,108,80,109,95,102,108,111,119,115,108,66,54,114,66,32,61,32,120,91,56,50,93,59,10,32,32,32,32,32,32,10,101,113,117,97,116,105,111,110,10,32,32,100,101,114,40,120,41,32,61,32,65,32,42,32,120,32,43,32,66,32,42,32,117,59,10,32,32,121,32,61,32,67,32,42,32,120,32,43,32,68,32,42,32,117,59,10,101,110,100,32,108,105,110,101,97,114,95,77,111,100,101,108,105,99,97,95,70,108,117,105,100,95,69,120,97,109,112,108,101,115,95,66,114,97,110,99,104,105,110,103,68,121,110,97,109,105,99,80,105,112,101,115,59,10,0,0,0,0,0,0,0,0,68,71,69,82,32,32,0,0,78,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,68,71,69,77,77,32,0,0,76,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,85,0,0,0,0,0,0,0,82,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,68,84,82,83,77,32,0,0,68,71,69,83,86,32,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,68,71,69,84,70,50,0,0,83,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,240,191,68,71,69,84,82,70,0,0,1,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,76,101,102,116,0,0,0,0,76,111,119,101,114,0,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,85,110,105,116,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,191,78,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,68,71,69,84,82,83,0,0,1,0,0,0,0,0,0,0,76,101,102,116,0,0,0,0,76,111,119,101,114,0,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,85,110,105,116,0,0,0,0,0,0,0,0,0,0,240,63,85,112,112,101,114,0,0,0,78,111,110,45,117,110,105,116,0,0,0,0,0,0,0,0,84,114,97,110,115,112,111,115,101,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,71,69,0,0,0,0,0,0,84,82,70,0,0,0,0,0,81,82,70,0,0,0,0,0,82,81,70,0,0,0,0,0,76,81,70,0,0,0,0,0,81,76,70,0,0,0,0,0,72,82,68,0,0,0,0,0,66,82,68,0,0,0,0,0,84,82,73,0,0,0,0,0,80,79,0,0,0,0,0,0,83,89,0,0,0,0,0,0,84,82,68,0,0,0,0,0,71,83,84,0,0,0,0,0,72,69,0,0,0,0,0,0,79,82,0,0,0,0,0,0,81,82,0,0,0,0,0,0,82,81,0,0,0,0,0,0,76,81,0,0,0,0,0,0,81,76,0,0,0,0,0,0,72,82,0,0,0,0,0,0,84,82,0,0,0,0,0,0,66,82,0,0,0,0,0,0,85,78,0,0,0,0,0,0,71,66,0,0,0,0,0,0,80,66,0,0,0,0,0,0,76,65,0,0,0,0,0,0,85,85,77,0,0,0,0,0,83,84,0,0,0,0,0,0,69,66,90,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,2,0,16,252,2,0,32,252,2,0,56,252,2,0,88,252,2,0,104,252,2,0,128,252,2,0,144,252,2,0,168,252,2,0,200,252,2,0,240,252,2,0,8,253,2,0,40,253,2,0,64,253,2,0,104,253,2,0,136,253,2,0,184,253,2,0,232,253,2,0,0,254,2,0,56,254,2,0,80,254,2,0,128,254,2,0,160,254,2,0,216,254,2,0,0,255,2,0,56,255,2,0,104,255,2,0,120,255,2,0,152,255,2,0,192,255,2,0,224,255,2,0,8,0,3,0,48,0,3,0,72,0,3,0,96,0,3,0,112,0,3,0,136,0,3,0,184,0,3,0,8,1,3,0,72,1,3,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,115,121,110,116,97,120,32,101,114,114,111,114,0,0,0,0,110,111,32,101,108,101,109,101,110,116,32,102,111,117,110,100,0,0,0,0,0,0,0,0,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,32,40,105,110,118,97,108,105,100,32,116,111,107,101,110,41,0,117,110,99,108,111,115,101,100,32,116,111,107,101,110,0,0,112,97,114,116,105,97,108,32,99,104,97,114,97,99,116,101,114,0,0,0,0,0,0,0,109,105,115,109,97,116,99,104,101,100,32,116,97,103,0,0,100,117,112,108,105,99,97,116,101,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,106,117,110,107,32,97,102,116,101,114,32,100,111,99,117,109,101,110,116,32,101,108,101,109,101,110,116,0,0,0,0,0,105,108,108,101,103,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,117,110,100,101,102,105,110,101,100,32,101,110,116,105,116,121,0,0,0,0,0,0,0,0,114,101,99,117,114,115,105,118,101,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,97,115,121,110,99,104,114,111,110,111,117,115,32,101,110,116,105,116,121,0,0,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,105,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,110,117,109,98,101,114,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,98,105,110,97,114,121,32,101,110,116,105,116,121,0,0,0,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,105,110,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,0,0,88,77,76,32,111,114,32,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,97,116,32,115,116,97,114,116,32,111,102,32,101,110,116,105,116,121,0,0,117,110,107,110,111,119,110,32,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,101,110,99,111,100,105,110,103,32,115,112,101,99,105,102,105,101,100,32,105,110,32,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,105,115,32,105,110,99,111,114,114,101,99,116,0,0,0,0,0,0,117,110,99,108,111,115,101,100,32,67,68,65,84,65,32,115,101,99,116,105,111,110,0,0,101,114,114,111,114,32,105,110,32,112,114,111,99,101,115,115,105,110,103,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,100,111,99,117,109,101,110,116,32,105,115,32,110,111,116,32,115,116,97,110,100,97,108,111,110,101,0,0,0,0,0,0,117,110,101,120,112,101,99,116,101,100,32,112,97,114,115,101,114,32,115,116,97,116,101,32,45,32,112,108,101,97,115,101,32,115,101,110,100,32,97,32,98,117,103,32,114,101,112,111,114,116,0,0,0,0,0,0,101,110,116,105,116,121,32,100,101,99,108,97,114,101,100,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,0,0,114,101,113,117,101,115,116,101,100,32,102,101,97,116,117,114,101,32,114,101,113,117,105,114,101,115,32,88,77,76,95,68,84,68,32,115,117,112,112,111,114,116,32,105,110,32,69,120,112,97,116,0,0,0,0,0,99,97,110,110,111,116,32,99,104,97,110,103,101,32,115,101,116,116,105,110,103,32,111,110,99,101,32,112,97,114,115,105,110,103,32,104,97,115,32,98,101,103,117,110,0,0,0,0,117,110,98,111,117,110,100,32,112,114,101,102,105,120,0,0,109,117,115,116,32,110,111,116,32,117,110,100,101,99,108,97,114,101,32,112,114,101,102,105,120,0,0,0,0,0,0,0,105,110,99,111,109,112,108,101,116,101,32,109,97,114,107,117,112,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,0,0,0,0,0,0,0,105,108,108,101,103,97,108,32,99,104,97,114,97,99,116,101,114,40,115,41,32,105,110,32,112,117,98,108,105,99,32,105,100,0,0,0,0,0,0,0,112,97,114,115,101,114,32,115,117,115,112,101,110,100,101,100,0,0,0,0,0,0,0,0,112,97,114,115,101,114,32,110,111,116,32,115,117,115,112,101,110,100,101,100,0,0,0,0,112,97,114,115,105,110,103,32,97,98,111,114,116,101,100,0,112,97,114,115,105,110,103,32,102,105,110,105,115,104,101,100,0,0,0,0,0,0,0,0,99,97,110,110,111,116,32,115,117,115,112,101,110,100,32,105,110,32,101,120,116,101,114,110,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,0,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,41,32,109,117,115,116,32,110,111,116,32,98,101,32,117,110,100,101,99,108,97,114,101,100,32,111,114,32,98,111,117,110,100,32,116,111,32,97,110,111,116,104,101,114,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,110,115,41,32,109,117,115,116,32,110,111,116,32,98,101,32,100,101,99,108,97,114,101,100,32,111,114,32,117,110,100,101,99,108,97,114,101,100,0,0,0,0,0,0,112,114,101,102,105,120,32,109,117,115,116,32,110,111,116,32,98,101,32,98,111,117,110,100,32,116,111,32,111,110,101,32,111,102,32,116,104,101,32,114,101,115,101,114,118,101,100,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,115,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,48,47,120,109,108,110,115,47,0,0,0,35,0,0,0,0,0,0,0,67,68,65,84,65,0,0,0,73,68,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,69,78,84,73,84,89,0,0,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,0,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,0,78,79,84,65,84,73,79,78,40,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,120,109,108,61,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,0,0,0,0,2,3,4,5,6,7,8,0,0,9,10,11,12,13,14,15,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,4,254,255,255,135,254,255,255,7,0,0,0,0,0,0,0,0,255,255,127,255,255,255,127,255,255,255,255,255,255,255,243,127,254,253,255,255,255,255,255,127,255,255,255,255,255,255,255,255,15,224,255,255,255,255,49,252,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,3,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,0,0,0,0,0,0,0,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,254,7,0,0,0,0,254,255,255,255,255,255,255,255,255,124,255,127,47,0,96,0,0,0,224,255,255,255,255,255,255,35,0,0,0,255,3,0,0,0,224,159,249,255,255,253,197,3,0,0,0,176,3,0,3,0,224,135,249,255,255,253,109,3,0,0,0,94,0,0,28,0,224,175,251,255,255,253,237,35,0,0,0,0,1,0,0,0,224,159,249,255,255,253,205,35,0,0,0,176,3,0,0,0,224,199,61,214,24,199,191,3,0,0,0,0,0,0,0,0,224,223,253,255,255,253,239,3,0,0,0,0,3,0,0,0,224,223,253,255,255,253,239,3,0,0,0,64,3,0,0,0,224,223,253,255,255,253,255,3,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,13,0,63,0,0,0,0,0,0,0,150,37,240,254,174,108,13,32,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,254,255,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,63,0,255,255,255,255,127,0,237,218,7,0,0,0,0,80,1,80,49,130,171,98,44,0,0,0,0,64,0,201,128,245,7,0,0,0,0,8,1,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,3,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,64,76,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,254,3,0,0,254,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,7,224,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,255,7,254,255,255,135,254,255,255,7,0,0,0,0,0,0,128,0,255,255,127,255,255,255,127,255,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,3,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,3,0,0,0,192,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,123,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,254,255,251,255,255,187,22,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,255,255,7,0,255,3,255,255,255,255,255,255,255,255,255,124,255,127,239,255,255,61,255,3,238,255,255,255,255,255,255,243,255,63,30,255,207,255,0,0,238,159,249,255,255,253,197,211,159,57,128,176,207,255,3,0,228,135,249,255,255,253,109,211,135,57,0,94,192,255,31,0,238,175,251,255,255,253,237,243,191,59,0,0,193,255,0,0,238,159,249,255,255,253,205,243,143,57,192,176,195,255,0,0,236,199,61,214,24,199,191,195,199,61,128,0,128,255,0,0,238,223,253,255,255,253,239,195,223,61,96,0,195,255,0,0,236,223,253,255,255,253,239,195,223,61,96,64,195,255,0,0,236,223,253,255,255,253,255,195,207,61,128,0,195,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,255,7,255,127,255,3,0,0,0,0,150,37,240,254,174,108,255,59,95,63,255,3,0,0,0,0,0,0,0,3,255,3,160,194,255,254,255,255,255,3,254,255,223,15,191,254,255,63,254,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,31,2,0,0,0,160,0,0,0,254,255,62,0,254,255,255,255,255,255,255,255,255,255,31,102,254,255,255,255,255,255,255,255,255,255,255,119,25,3,26,27,28,29,30,0,0,31,32,33,34,35,36,37,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,38,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,39,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,85,84,70,45,49,54,0,0,120,15,3,0,8,14,3,0,144,12,3,0,24,11,3,0,24,11,3,0,160,9,3,0,144,12,3,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,68,65,84,65,91,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,4,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,12,0,0,0,5,0,0,0,2,0,0,0,18,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,68,65,84,65,91,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,67,68,65,84,65,91,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,9,0,0,0,8,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,64,26,3,0,200,22,3,0,88,21,3,0,232,19,3,0,232,19,3,0,120,18,3,0,88,21,3,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,4,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,12,0,0,0,5,0,0,0,2,0,0,0,18,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,118,101,114,115,105,111,110,0,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,115,116,97,110,100,97,108,111,110,101,0,0,0,0,0,0,121,101,115,0,0,0,0,0,110,111,0,0,0,0,0,0,136,24,3,0,152,24,3,0,168,24,3,0,120,9,3,0,176,24,3,0,192,24,3,0,73,83,79,45,56,56,53,57,45,49,0,0,0,0,0,0,85,83,45,65,83,67,73,73,0,0,0,0,0,0,0,0,85,84,70,45,56,0,0,0,85,84,70,45,49,54,66,69,0,0,0,0,0,0,0,0,85,84,70,45,49,54,76,69,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,9,0,0,0,8,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,78,84,73,84,89,0,0,65,84,84,76,73,83,84,0,69,76,69,77,69,78,84,0,78,79,84,65,84,73,79,78,0,0,0,0,0,0,0,0,83,89,83,84,69,77,0,0,80,85,66,76,73,67,0,0,69,77,80,84,89,0,0,0,65,78,89,0,0,0,0,0,80,67,68,65,84,65,0,0,32,28,3,0,40,28,3,0,48,28,3,0,56,28,3,0,176,27,3,0,64,28,3,0,80,28,3,0,88,28,3,0,67,68,65,84,65,0,0,0,73,68,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,0,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,0,73,77,80,76,73,69,68,0,82,69,81,85,73,82,69,68,0,0,0,0,0,0,0,0,70,73,88,69,68,0,0,0,78,68,65,84,65,0,0,0,73,78,67,76,85,68,69,0,73,71,78,79,82,69,0,0,68,79,67,84,89,80,69,0,0,0,0,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,105,115,32,78,85,76,76,33,10,0,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,115,32,97,114,101,32,60,32,48,33,10,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,115,32,115,105,122,101,115,32,97,114,101,32,78,85,76,76,33,10,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,32,115,105,122,101,32,102,111,114,32,100,105,109,101,110,115,105,111,110,32,37,100,32,105,115,32,37,100,32,60,32,48,33,10,0,117,116,105,108,47,98,97,115,101,95,97,114,114,97,121,46,99,0,0,0,0,0,0,0,97,45,62,110,100,105,109,115,32,33,61,32,98,45,62,110,100,105,109,115,44,32,37,100,32,33,61,32,37,100,10,0,97,45,62,100,105,109,95,115,105,122,101,91,37,100,93,32,33,61,32,98,45,62,100,105,109,95,115,105,122,101,91,37,100,93,44,32,37,100,32,33,61,32,37,100,10,0,0,0,0,0,0,0,0,0,0,0,224,29,3,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,1,0,0,0,68,105,109,101,110,115,105,111,110,32,37,100,32,104,97,115,32,98,111,117,110,100,115,32,49,46,46,37,100,44,32,103,111,116,32,97,114,114,97,121,32,115,117,98,115,99,114,105,112,116,32,37,100,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,97,41,0,0,0,0,0,0,0,0,115,105,122,101,95,111,102,95,100,105,109,101,110,115,105,111,110,95,98,97,115,101,95,97,114,114,97,121,0,0,0,0,40,105,32,62,32,48,41,32,38,38,32,40,105,32,60,61,32,97,45,62,110,100,105,109,115,41,0,0,0,0,0,0,3,0,0,0,0,0,0,0,76,79,71,95,85,78,75,78,79,87,78,0,0,0,0,0,115,116,100,111,117,116,0,0,97,115,115,101,114,116,0,0,76,79,71,95,68,68,65,83,82,84,0,0,0,0,0,0,76,79,71,95,68,69,66,85,71,0,0,0,0,0,0,0,76,79,71,95,68,83,83,0,76,79,71,95,68,83,83,95,74,65,67,0,0,0,0,0,76,79,71,95,69,86,69,78,84,83,0,0,0,0,0,0,76,79,71,95,69,86,69,78,84,83,95,86,0,0,0,0,76,79,71,95,73,78,73,84,0,0,0,0,0,0,0,0,76,79,71,95,73,80,79,80,84,0,0,0,0,0,0,0,76,79,71,95,73,80,79,80,84,95,70,85,76,76,0,0,76,79,71,95,73,80,79,80,84,95,74,65,67,0,0,0,76,79,71,95,73,80,79,80,84,95,72,69,83,83,69,0,76,79,71,95,74,65,67,0,76,79,71,95,76,83,0,0,76,79,71,95,76,83,95,86,0,0,0,0,0,0,0,0,76,79,71,95,78,76,83,0,76,79,71,95,78,76,83,95,86,0,0,0,0,0,0,0,76,79,71,95,78,76,83,95,74,65,67,0,0,0,0,0,76,79,71,95,78,76,83,95,82,69,83,0,0,0,0,0,76,79,71,95,82,69,83,95,73,78,73,84,0,0,0,0,76,79,71,95,83,73,77,85,76,65,84,73,79,78,0,0,76,79,71,95,83,79,76,86,69,82,0,0,0,0,0,0,76,79,71,95,83,79,84,73,0,0,0,0,0,0,0,0,76,79,71,95,83,84,65,84,83], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+194560);
/* memory initializer */ allocate([76,79,71,95,85,84,73,76,0,0,0,0,0,0,0,0,76,79,71,95,90,69,82,79,67,82,79,83,83,73,78,71,83,0,0,0,0,0,0,0,152,30,3,0,168,30,3,0,176,30,3,0,184,30,3,0,200,30,3,0,216,30,3,0,224,30,3,0,240,30,3,0,0,31,3,0,16,31,3,0,32,31,3,0,48,31,3,0,64,31,3,0,80,31,3,0,96,31,3,0,104,31,3,0,112,31,3,0,128,31,3,0,136,31,3,0,152,31,3,0,168,31,3,0,184,31,3,0,200,31,3,0,216,31,3,0,232,31,3,0,248,31,3,0,8,32,3,0,24,32,3,0,117,110,107,110,111,119,110,0,116,104,105,115,32,115,116,114,101,97,109,32,105,115,32,97,108,119,97,121,115,32,97,99,116,105,118,101,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,100,97,115,115,108,32,115,111,108,118,101,114,0,0,0,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,100,101,98,117,103,32,105,110,102,111,114,109,97,116,105,111,110,0,0,0,0,111,117,116,112,117,116,115,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,106,97,99,111,98,105,97,110,32,111,102,32,116,104,101,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,100,117,114,105,110,103,32,101,118,101,110,116,32,105,116,101,114,97,116,105,111,110,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,101,118,101,110,116,32,115,121,115,116,101,109,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,100,117,114,105,110,103,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,105,110,102,111,114,109,97,116,105,111,110,32,102,114,111,109,32,73,112,111,112,116,0,0,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,102,114,111,109,32,73,112,111,112,116,0,0,0,0,0,99,104,101,99,107,32,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,119,105,116,104,32,73,112,111,112,116,0,0,0,0,0,0,0,0,99,104,101,99,107,32,104,101,115,115,105,97,110,32,109,97,116,114,105,120,32,119,105,116,104,32,73,112,111,112,116,0,111,117,116,112,117,116,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,117,115,101,100,32,98,121,32,100,97,115,115,108,0,0,0,0,0,0,0,108,111,103,103,105,110,103,32,102,111,114,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,0,108,111,103,103,105,110,103,32,102,111,114,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,111,117,116,112,117,116,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,111,102,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,101,118,101,114,121,32,101,118,97,108,117,97,116,105,111,110,32,111,102,32,116,104,101,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,114,101,115,105,100,117,97,108,115,32,111,102,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,115,105,109,117,108,97,116,105,111,110,32,112,114,111,99,101,115,115,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,115,111,108,118,101,114,32,112,114,111,99,101,115,115,0,0,0,0,0,102,105,110,97,108,32,115,111,108,117,116,105,111,110,32,111,102,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,115,116,97,116,105,115,116,105,99,115,32,97,98,111,117,116,32,116,105,109,101,114,47,101,118,101,110,116,115,47,115,111,108,118,101,114,0,63,63,63,0,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,116,104,101,32,122,101,114,111,99,114,111,115,115,105,110,103,115,0,0,160,32,3,0,168,32,3,0,168,32,3,0,200,32,3,0,248,32,3,0,24,33,3,0,80,33,3,0,128,33,3,0,176,33,3,0,208,33,3,0,0,34,3,0,24,34,3,0,56,34,3,0,96,34,3,0,128,34,3,0,176,34,3,0,208,34,3,0,248,34,3,0,24,35,3,0,64,35,3,0,112,35,3,0,168,35,3,0,208,35,3,0,0,36,3,0,48,36,3,0,88,36,3,0,136,36,3,0,144,36,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,91,37,115,58,37,100,58,37,100,45,37,100,58,37,100,58,37,115,93,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,119,114,105,116,97,98,108,101,0,0,0,0,0,0,0,0,37,45,49,55,115,32,124,32,0,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,37,45,55,115,32,124,32,0,160,32,3,0,144,39,3,0,152,39,3,0,160,39,3,0,176,30,3,0,168,39,3,0,124,32,0,0,0,0,0,0,60,109,101,115,115,97,103,101,32,115,116,114,101,97,109,61,34,37,115,34,32,116,121,112,101,61,34,37,115,34,32,116,101,120,116,61,34,0,0,0,34,62,10,0,0,0,0,0,60,117,115,101,100,32,105,110,100,101,120,61,34,37,100,34,32,47,62,10,0,0,0,0,60,47,109,101,115,115,97,103,101,62,10,0,0,0,0,0,34,32,47,62,10,0,0,0,7,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,38,97,109,112,59,0,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,105,110,102,111,0,0,0,0,119,97,114,110,105,110,103,0,101,114,114,111,114,0,0,0,100,101,98,117,103,0,0,0,34,62,0,0,0,0,0,0,115,111,108,118,101,114,32,119,105,108,108,32,116,114,121,32,116,111,32,104,97,110,100,108,101,32,100,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,32,97,116,32,116,105,109,101,32,37,46,49,54,103,58,32,37,115,0,0,0,0,100,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,32,97,116,32,116,105,109,101,32,37,46,49,54,103,44,32,100,105,118,105,115,111,114,58,32,37,115,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,105,110,118,97,108,105,100,32,108,105,115,116,45,112,111,105,110,116,101,114,0,0,0,0,101,109,112,116,121,32,108,105,115,116,0,0,0,0,0,0,105,110,118,97,108,105,100,32,102,105,115,116,32,108,105,115,116,45,112,111,105,110,116,101,114,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,108,105,115,116,45,110,111,100,101,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,100,97,116,97,32,110,111,100,101,0,0,0,0,0,0,0,1,0,0,0,25,0,0,0,26,0,0,0,26,0,0,0,27,0,0,0,2,0,0,0,2,0,0,0,28,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,37,100,100,0,0,0,0,37,100,100,0,0,0,0,0,45,37,100,46,37,100,103,0,37,100,46,37,100,103,0,0,98,105,110,84,114,97,110,115,0,0,0,0,0,0,0,0,32,41,3,0,0,0,0,0,98,105,110,78,111,114,109,97,108,0,0,0,0,0,0,0,56,41,3,0,0,0,0,0,65,99,108,97,115,115,0,0,110,97,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,100,97,116,97,73,110,102,111,0,0,0,0,0,0,0,0,100,97,116,97,95,49,0,0,100,97,116,97,95,50,0,0,80,41,3,0,88,41,3,0,96,41,3,0,112,41,3,0,128,41,3,0,136,41,3,0,51,0,0,0,51,0,0,0,51,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,49,41,0,0,0,0,0,0,77,97,116,114,105,120,32,116,121,112,101,32,109,105,115,109,97,116,99,104,0,0,0,0,77,97,116,114,105,120,32,117,115,101,115,32,105,109,97,103,105,110,97,114,121,32,110,117,109,98,101,114,115,0,0,0,67,111,117,108,100,32,110,111,116,32,100,101,116,101,114,109,105,110,101,32,115,105,122,101,32,111,102,32,109,97,116,114,105,120,32,101,108,101,109,101,110,116,115,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,50,41,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,51,41,0,0,0,0,0,0,77,97,116,114,105,120,32,110,97,109,101,32,109,105,115,109,97,116,99,104,0,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,52,32,114,111,119,115,0,0,0,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,49,32,99,111,108,115,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,65,99,108,97,115,115,32,109,97,116,114,105,120,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,98,105,110,84,114,97,110,115,32,111,114,32,98,105,110,78,111,114,109,97,108,32,102,111,114,109,97,116,0,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,110,97,109,101,115,32,109,97,116,114,105,120,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,73,110,102,111,32,109,97,116,114,105,120,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,99,111,110,116,97,105,110,32,97,116,32,108,101,97,115,116,32,49,32,118,97,114,105,97,98,108,101,0,0,0,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,32,111,114,32,50,32,99,111,108,115,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,95,49,32,109,97,116,114,105,120,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,99,111,110,116,97,105,110,101,100,32,112,97,114,97,109,101,116,101,114,32,116,104,97,116,32,99,104,97,110,103,101,100,32,98,101,116,119,101,101,110,32,115,116,97,114,116,32,97,110,100,32,115,116,111,112,45,116,105,109,101,0,0,0,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,32,111,114,32,50,32,114,111,119,115,0,84,111,111,32,102,101,119,32,114,111,119,115,32,105,110,32,100,97,116,97,95,50,32,109,97,116,114,105,120,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,95,50,32,109,97,116,114,105,120,0,0,0,73,109,112,108,101,109,101,110,116,97,116,105,111,110,32,101,114,114,111,114,58,32,85,110,107,110,111,119,110,32,99,97,115,101,0,0,0,0,0,0,97,98,115,86,97,114,73,110,100,101,120,32,62,32,48,32,38,38,32,97,98,115,86,97,114,73,110,100,101,120,32,60,61,32,114,101,97,100,101,114,45,62,110,118,97,114,0,0,117,116,105,108,47,114,101,97,100,95,109,97,116,108,97,98,52,46,99,0,0,0,0,0,111,109,99,95,109,97,116,108,97,98,52,95,114,101,97,100,95,118,97,108,115,0,0,0,111,109,99,95,109,97,116,108,97,98,52,95,114,101,97,100,95,115,105,110,103,108,101,95,118,97,108,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,115,111,117,114,99,101,41,0,0,0,117,116,105,108,47,114,101,97,108,95,97,114,114,97,121,46,99,0,0,0,0,0,0,0,99,111,112,121,95,114,101,97,108,95,97,114,114,97,121,95,100,97,116,97,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,100,101,115,116,41,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,115,104,97,112,101,95,101,113,40,115,111,117,114,99,101,44,32,100,101,115,116,41,0,0,0,0,0,0,0,101,108,116,115,0,0,0,0,101,108,116,115,91,48,93,45,62,110,100,105,109,115,32,62,61,32,107,0,0,0,0,0,99,97,116,95,97,108,108,111,99,95,114,101,97,108,95,97,114,114,97,121,0,0,0,0,101,108,116,115,91,48,93,45,62,110,100,105,109,115,32,61,61,32,101,108,116,115,91,105,93,45,62,110,100,105,109,115,0,0,0,0,0,0,0,0,101,108,116,115,91,48,93,45,62,100,105,109,95,115,105,122,101,91,106,93,32,61,61,32,101,108,116,115,91,105,93,45,62,100,105,109,95,115,105,122,101,91,106,93,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,97,41,0,0,0,0,0,0,0,0,115,117,109,95,114,101,97,108,95,97,114,114,97,121,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,101,109,112,116,121,32,82,105,110,103,66,117,102,102,101,114,0,0,0,0,0,0,0,0,105,110,100,101,120,32,91,37,100,93,32,111,117,116,32,111,102,32,114,97,110,103,101,32,91,37,100,58,37,100,93,0,160,53,3,0,0,0,0,0,24,53,3,0,0,0,0,0,144,52,3,0,0,0,0,0,8,52,3,0,0,0,0,0,0,51,3,0,0,0,0,0,248,49,3,0,0,0,0,0,240,48,3,0,0,0,0,0,232,47,3,0,0,0,0,0,97,99,99,95,116,112,32,33,61,32,48,0,0,0,0,0,117,116,105,108,47,114,116,99,108,111,99,107,46,99,0,0,114,116,95,105,110,105,116,0,109,97,120,95,116,112,32,33,61,32,48,0,0,0,0,0,116,111,116,97,108,95,116,112,32,33,61,32,48,0,0,0,116,105,99,107,95,116,112,32,33,61,32,48,0,0,0,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,32,33,61,32,48,0,0,0,0,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,109,105,110,32,33,61,32,48,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,109,97,120,32,33,61,32,48,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,116,111,116,97,108,32,33,61,32,48], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+204800);
/* memory initializer */ allocate([69,114,114,111,114,32,115,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,83,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,58,32,105,116,101,114,97,116,105,111,110,32,110,111,116,32,109,97,107,105,110,103,32,112,114,111,103,114,101,115,115,44,32,116,114,121,105,110,103,32,119,105,116,104,32,100,105,102,102,101,114,101,110,116,32,115,116,97,114,116,105,110,103,32,112,111,105,110,116,115,32,40,43,37,103,41,0,83,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,58,32,105,116,101,114,97,116,105,111,110,32,110,111,116,32,109,97,107,105,110,103,32,112,114,111,103,114,101,115,115,44,32,116,114,121,105,110,103,32,116,111,32,100,101,99,114,101,97,115,101,32,102,97,99,116,111,114,32,116,111,32,37,103,0,0,0,0,0,105,109,112,114,111,112,101,114,32,105,110,112,117,116,32,112,97,114,97,109,101,116,101,114,115,32,116,111,32,110,111,110,108,105,110,101,97,114,32,101,113,46,32,115,121,115,116,58,32,37,115,32,97,116,32,116,105,109,101,32,37,103,0,0,85,110,107,110,111,119,110,32,101,113,117,97,116,105,111,110,32,115,121,115,116,101,109,32,101,114,114,111,114,58,32,37,100,32,37,115,32,37,103,0,70,76,65,71,95,85,78,75,78,79,87,78,0,0,0,0,99,108,111,99,107,0,0,0,99,112,117,0,0,0,0,0,101,109,105,116,95,112,114,111,116,101,99,116,101,100,0,0,102,0,0,0,0,0,0,0,104,101,108,112,0,0,0,0,105,105,102,0,0,0,0,0,105,105,109,0,0,0,0,0,105,105,116,0,0,0,0,0,105,108,115,0,0,0,0,0,105,110,116,101,114,97,99,116,105,118,101,0,0,0,0,0,105,111,109,0,0,0,0,0,105,112,111,112,116,95,104,101,115,115,101,0,0,0,0,0,105,112,111,112,116,95,106,97,99,0,0,0,0,0,0,0,105,112,111,112,116,95,105,110,105,116,0,0,0,0,0,0,108,0,0,0,0,0,0,0,108,111,103,70,111,114,109,97,116,0,0,0,0,0,0,0,108,115,0,0,0,0,0,0,108,115,95,105,112,111,112,116,0,0,0,0,0,0,0,0,108,118,0,0,0,0,0,0,109,101,97,115,117,114,101,84,105,109,101,80,108,111,116,70,111,114,109,97,116,0,0,0,110,108,115,0,0,0,0,0,110,111,101,109,105,116,0,0,110,111,69,118,101,110,116,69,109,105,116,0,0,0,0,0,111,117,116,112,117,116,0,0,111,118,101,114,114,105,100,101,0,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,70,105,108,101,0,0,0,0,112,111,114,116,0,0,0,0,114,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,70,76,65,71,95,77,65,88,0,0,0,0,0,0,0,0,136,55,3,0,152,55,3,0,160,55,3,0,168,55,3,0,184,55,3,0,192,55,3,0,200,55,3,0,208,55,3,0,216,55,3,0,224,55,3,0,232,55,3,0,248,55,3,0,0,56,3,0,16,56,3,0,32,56,3,0,48,56,3,0,56,56,3,0,72,56,3,0,80,56,3,0,96,56,3,0,104,56,3,0,128,56,3,0,136,56,3,0,144,56,3,0,160,56,3,0,168,56,3,0,184,56,3,0,200,56,3,0,208,56,3,0,216,56,3,0,224,56,3,0,232,56,3,0,117,110,107,110,111,119,110,0,115,101,108,101,99,116,115,32,116,104,101,32,116,121,112,101,32,111,102,32,99,108,111,99,107,32,116,111,32,117,115,101,32,45,99,108,111,99,107,61,82,84,44,32,45,99,108,111,99,107,61,67,89,67,32,111,114,32,45,99,108,111,99,107,61,67,80,85,0,0,0,0,100,117,109,112,115,32,116,104,101,32,99,112,117,45,116,105,109,101,32,105,110,116,111,32,116,104,101,32,114,101,115,117,108,116,115,45,102,105,108,101,0,0,0,0,0,0,0,0,101,109,105,116,115,32,112,114,111,116,101,99,116,101,100,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,110,101,119,32,115,101,116,117,112,32,88,77,76,32,102,105,108,101,32,116,111,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,99,111,100,101,0,0,0,103,101,116,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,116,104,97,116,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,110,32,101,120,116,101,114,110,97,108,32,102,105,108,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,109,101,116,104,111,100,0,0,0,0,0,0,0,91,100,111,117,98,108,101,93,32,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,0,91,105,110,116,93,32,100,101,102,97,117,108,116,58,32,49,0,0,0,0,0,0,0,0,115,112,101,99,105,102,121,32,105,110,116,101,114,97,99,116,105,118,101,32,115,105,109,117,108,97,116,105,111,110,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,112,116,105,109,105,122,97,116,105,111,110,32,109,101,116,104,111,100,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,104,101,115,115,105,97,110,32,102,111,114,32,73,112,111,112,116,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,102,111,114,32,73,112,111,112,116,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,111,114,32,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,119,104,101,114,101,32,116,104,101,32,108,105,110,101,97,114,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,32,115,104,111,117,108,100,32,98,101,32,112,101,114,102,111,114,109,101,100,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,46,32,45,108,111,103,70,111,114,109,97,116,61,116,101,120,116,32,40,100,101,102,97,117,108,116,41,32,111,114,32,45,108,111,103,70,111,114,109,97,116,61,120,109,108,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,102,111,114,32,105,112,111,112,116,0,0,0,0,0,0,91,115,116,114,105,110,103,32,108,105,115,116,93,32,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,103,105,110,103,32,108,101,118,101,108,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,111,117,116,112,117,116,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,109,101,97,115,117,114,101,32,116,105,109,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,110,111,110,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,0,100,111,32,110,111,116,32,101,109,105,116,32,97,110,121,32,114,101,115,117,108,116,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,32,102,105,108,101,0,0,0,0,0,0,100,111,32,110,111,116,32,101,109,105,116,32,101,118,101,110,116,32,112,111,105,110,116,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,32,102,105,108,101,0,0,0,0,0,111,117,116,112,117,116,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,97,44,32,98,32,97,110,100,32,99,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,116,111,32,116,104,101,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,0,0,0,0,0,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,0,119,105,108,108,32,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,32,119,105,116,104,32,116,104,101,32,118,97,108,117,101,115,32,102,114,111,109,32,116,104,101,32,102,105,108,101,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,105,110,116,101,114,97,99,116,105,118,101,32,115,105,109,117,108,97,116,105,111,110,32,112,111,114,116,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,110,101,119,32,114,101,115,117,108,116,32,102,105,108,101,32,116,104,97,110,32,116,104,101,32,100,101,102,97,117,108,116,32,77,111,100,101,108,95,114,101,115,46,109,97,116,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,115,111,108,118,101,114,0,0,0,0,0,0,115,104,111,119,115,32,97,108,108,32,119,97,114,110,105,110,103,115,32,101,118,101,110,32,105,102,32,97,32,114,101,108,97,116,101,100,32,108,111,103,45,115,116,114,101,97,109,32,105,115,32,105,110,97,99,116,105,118,101,0,0,0,0,0,120,57,3,0,128,57,3,0,200,57,3,0,248,57,3,0,40,58,3,0,112,58,3,0,176,58,3,0,248,58,3,0,40,59,3,0,112,59,3,0,136,59,3,0,168,59,3,0,224,59,3,0,8,60,3,0,48,60,3,0,104,60,3,0,184,60,3,0,24,61,3,0,72,61,3,0,128,61,3,0,176,61,3,0,248,61,3,0,32,62,3,0,80,62,3,0,128,62,3,0,216,62,3,0,32,63,3,0,144,63,3,0,192,63,3,0,8,64,3,0,40,64,3,0,232,56,3,0,115,101,108,101,99,116,115,32,116,104,101,32,116,121,112,101,32,111,102,32,99,108,111,99,107,32,116,111,32,117,115,101,32,45,99,108,111,99,107,61,82,84,44,32,45,99,108,111,99,107,61,67,89,67,32,111,114,32,45,99,108,111,99,107,61,67,80,85,10,32,32,82,84,61,109,111,110,111,116,111,110,105,99,32,114,101,97,108,45,116,105,109,101,32,99,108,111,99,107,44,32,67,80,85,61,112,114,111,99,101,115,115,45,98,97,115,101,100,32,67,80,85,45,116,105,109,101,44,32,67,89,67,61,99,112,117,32,99,121,99,108,101,115,32,109,101,97,115,117,114,101,100,32,119,105,116,104,32,82,68,84,83,67,0,0,0,0,0,32,32,45,32,100,117,109,112,115,32,116,104,101,32,99,112,117,45,116,105,109,101,32,105,110,116,111,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,10,32,32,45,32,36,99,112,117,84,105,109,101,32,105,115,32,116,104,101,32,118,97,114,105,97,98,108,101,32,110,97,109,101,32,105,110,115,105,100,101,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,0,0,0,0,103,101,116,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,116,104,97,116,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,10,32,32,101,46,103,46,32,45,104,101,108,112,61,102,32,112,114,105,110,116,115,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,102,111,114,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,32,102,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,115,116,101,112,115,32,102,111,114,32,104,111,109,111,116,111,112,121,32,109,101,116,104,111,100,32,40,114,101,113,117,105,114,101,100,58,32,45,105,105,109,61,115,121,109,98,111,108,105,99,41,32,111,114,10,39,115,116,97,114,116,32,118,97,108,117,101,32,104,111,109,111,116,111,112,121,39,32,109,101,116,104,111,100,32,40,114,101,113,117,105,114,101,100,58,32,45,105,105,109,61,110,117,109,101,114,105,99,32,45,105,111,109,61,110,101,108,100,101,114,95,109,101,97,100,95,101,120,41,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,104,101,115,115,101,109,97,116,114,105,120,32,102,111,114,32,73,112,111,112,116,40,79,77,67,44,32,66,70,71,83,44,32,99,111,110,115,116,41,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,102,111,114,32,73,112,111,112,116,40,83,89,77,44,32,78,85,77,44,32,78,85,77,68,69,78,83,69,41,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,111,114,32,111,112,116,105,109,105,122,97,116,105,111,110,32,40,115,105,109,44,32,99,111,110,115,116,41,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,10,32,32,108,97,112,97,99,107,44,32,108,105,115,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,102,111,114,32,73,112,111,112,116,44,32,100,101,102,97,117,108,116,32,109,117,109,112,115,46,10,32,78,111,116,101,58,32,85,115,101,32,105,102,32,121,111,117,32,98,117,105,108,100,32,105,112,111,112,116,32,119,105,116,104,32,111,116,104,101,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,108,105,107,101,32,109,97,50,55,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,103,105,110,103,32,108,101,118,101,108,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,111,117,116,112,117,116,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,109,101,97,115,117,114,101,32,116,105,109,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,10,32,32,115,118,103,10,32,32,106,112,103,10,32,32,112,115,10,32,32,103,105,102,10,32,32,46,46,46,0,0,0,0,0,0,0,0,111,117,116,112,117,116,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,97,44,32,98,32,97,110,100,32,99,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,116,111,32,116,104,101,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,10,32,32,116,105,109,101,32,61,32,118,97,108,117,101,44,32,97,32,61,32,118,97,108,117,101,44,32,98,32,61,32,118,97,108,117,101,44,32,99,32,61,32,118,97,108,117,101,0,0,0,0,0,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,10,32,32,101,46,103,46,32,118,97,114,49,61,115,116,97,114,116,49,44,118,97,114,50,61,115,116,97,114,116,50,44,112,97,114,51,61,115,116,97,114,116,51,44,115,116,97,114,116,84,105,109,101,61,118,97,108,49,44,115,116,111,112,84,105,109,101,61,118,97,108,50,44,115,116,101,112,83,105,122,101,61,118,97,108,51,44,10,32,32,32,32,32,32,32,116,111,108,101,114,97,110,99,101,61,118,97,108,52,44,115,111,108,118,101,114,61,34,115,101,101,32,45,115,34,44,111,117,116,112,117,116,70,111,114,109,97,116,61,34,109,97,116,124,112,108,116,124,99,115,118,124,101,109,112,116,121,34,44,118,97,114,105,97,98,108,101,70,105,108,116,101,114,61,34,102,105,108,116,101,114,34,0,0,0,119,105,108,108,32,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,32,119,105,116,104,32,116,104,101,32,118,97,108,117,101,115,32,102,114,111,109,32,116,104,101,32,102,105,108,101,10,32,32,110,111,116,101,32,116,104,97,116,58,32,45,111,118,101,114,114,105,100,101,70,105,108,101,32,67,65,78,78,79,84,32,98,101,32,117,115,101,100,32,119,105,116,104,32,45,111,118,101,114,114,105,100,101,10,32,32,117,115,101,32,119,104,101,110,32,118,97,114,105,97,98,108,101,115,32,102,111,114,32,45,111,118,101,114,114,105,100,101,32,97,114,101,32,116,111,111,32,109,97,110,121,32,97,110,100,32,100,111,32,110,111,116,32,102,105,116,32,105,110,32,99,111,109,109,97,110,100,32,108,105,110,101,32,115,105,122,101,10,32,32,111,118,101,114,114,105,100,101,70,105,108,101,78,97,109,101,32,99,111,110,116,97,105,110,115,32,108,105,110,101,115,32,111,102,32,116,104,101,32,102,111,114,109,58,32,118,97,114,49,61,115,116,97,114,116,49,0,0,0,0,0,0,120,57,3,0,232,64,3,0,144,65,3,0,248,57,3,0,40,58,3,0,248,65,3,0,176,58,3,0,248,58,3,0,128,66,3,0,192,66,3,0,136,59,3,0,168,59,3,0,96,67,3,0,160,67,3,0,224,67,3,0,104,60,3,0,184,60,3,0,32,68,3,0,88,68,3,0,224,68,3,0,8,69,3,0,248,61,3,0,32,62,3,0,80,62,3,0,112,69,3,0,248,69,3,0,248,70,3,0,144,63,3,0,192,63,3,0,8,64,3,0,40,64,3,0,232,56,3,0,0,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,49,120,44,56,48,97,49,41,0,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,73,49,32,61,2,44,105,49,48,41,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,73,49,32,61,2,44,105,49,48,44,51,120,44,2,73,50,32,61,2,44,105,49,48,41,0,0,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,82,49,32,61,2,44,101,50,49,46,49,51,41,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,44,32,32,82,49,32,61,2,44,101,50,49,46,49,51,44,51,120,44,2,82,50,32,61,2,44,101,50,49,46,49,51,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,76,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,76,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,76,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,76,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,76,3,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,72,69,32,76,65,83,84,32,83,84,69,80,32,84,69,82,77,73,78,65,84,69,68,32,87,73,84,72,32,65,32,78,69,71,65,84,73,86,69,0,0,0,0,0,0,0,49,0,0,0,0,0,0,0,201,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,86,65,76,85,69,32,40,61,73,49,41,32,79,70,32,73,68,73,68,32,65,78,68,32,78,79,32,65,80,80,82,79,80,82,73,65,84,69,0,47,0,0,0,0,0,0,0,202,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,67,84,73,79,78,32,87,65,83,32,84,65,75,69,78,46,32,82,85,78,32,84,69,82,77,73,78,65,84,69,68,0,0,0,0,0,0,0,41,0,0,0,0,0,0,0,203,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,67,85,82,82,69,78,84,32,84,32,40,61,82,49,41,32,32,53,48,48,32,83,84,69,80,83,0,0,38,0,0,0,0,0,0,0,98,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,65,75,69,78,32,79,78,32,84,72,73,83,32,67,65,76,76,32,66,69,70,79,82,69,32,82,69,65,67,72,73,78,71,32,84,79,85,84,0,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,99,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,84,79,79,32,77,85,67,72,32,65,67,67,85,82,65,67,89,32,82,69,81,85,69,83,84,69,68,0,108,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,70,79,82,32,80,82,69,67,73,83,73,79,78,32,79,70,32,77,65,67,72,73,78,69,46,32,82,84,79,76,32,65,78,68,32,65,84,79,76,0,0,0,0,0,0,0,0,109,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,87,69,82,69,32,73,78,67,82,69,65,83,69,68,32,84,79,32,65,80,80,82,79,80,82,73,65,84,69,32,86,65,76,85,69,83,0,0,0,45,0,0,0,0,0,0,0,110,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,87,84,0,0,118,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,72,65,83,32,66,69,67,79,77,69,32,46,76,69,46,32,48,46,48,0,0,0,0,28,0,0,0,0,0,0,0,119,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,65,78,68,32,83,84,69,80,83,73,90,69,32,72,32,40,61,82,50,41,32,84,72,69,0,0,0,0,44,0,0,0,0,0,0,0,128,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,69,82,82,79,82,32,84,69,83,84,32,70,65,73,76,69,68,32,82,69,80,69,65,84,69,68,76,89,32,79,82,32,87,73,84,72,32,65,66,83,40,72,41,61,72,77,73,78,0,0,0,0,0,0,0,57,0,0,0,0,0,0,0,129,2,0,0,0,0,0,0,138,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,70,65,73,76,69,68,32,84,79,32,67,79,78,86,69,82,71,69,32,82,69,80,69,65,84,69,68,76,89,0,0,0,0,0,0,0,0,139,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,79,82,32,87,73,84,72,32,65,66,83,40,72,41,61,72,77,73,78,0,0,0,0,140,2,0,0,0,0,0,0,148,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,84,69,82,65,84,73,79,78,32,77,65,84,82,73,88,32,73,83,32,83,73,78,71,85,76,65,82,0,0,0,37,0,0,0,0,0,0,0,149,2,0,0,0,0,0,0,158,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,67,79,85,76,68,32,78,79,84,32,67,79,78,86,69,82,71,69,46,32,32,65,76,83,79,44,32,84,72,69,0,0,0,0,0,0,0,159,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,69,82,82,79,82,32,84,69,83,84,32,70,65,73,76,69,68,32,82,69,80,69,65,84,69,68,76,89,46,0,0,160,2,0,0,0,0,0,0,163,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,67,79,85,76,68,32,78,79,84,32,67,79,78,86,69,82,71,69,32,66,69,67,65,85,83,69,0,0,0,164,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,82,69,83,32,87,65,83,32,69,81,85,65,76,32,84,79,32,77,73,78,85,83,32,79,78,69,0,0,0,0,36,0,0,0,0,0,0,0,165,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,65,78,68,32,83,84,69,80,83,73,90,69,32,72,32,40,61,82,50,41,0,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,168,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,82,69,83,32,87,65,83,32,69,81,85,65,76,32,84,79,32,77,73,78,85,83,32,84,87,79,0,0,0,0,169,2,0,0,0,0,0,0,173,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,73,84,73,65,76,32,89,80,82,73,77,69,32,67,79,85,76,68,32,78,79,84,32,66,69,32,67,79,77,80,85,84,69,68,0,0,0,174,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,73,78,70,79,32,86,69,67,84,79,82,32,73,83,32,78,79,84,32,90,69,82,79,32,79,82,32,79,78,69,0,55,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,78,69,81,32,40,61,73,49,41,32,46,76,69,46,32,48,0,0,0,0,0,0,0,25,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,65,88,79,82,68,32,40,61,73,49,41,32,78,79,84,32,73,78,32,82,65,78,71,69,0,0,0,0,0,0,34,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,82,87,79,82,75,32,76,69,78,71,84,72,32,78,69,69,68,69,68,44,32,76,69,78,82,87,32,40,61,73,49,41,44,32,69,88,67,69,69,68,83,32,76,82,87,32,40,61,73,50,41,0,0,0,0,60,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,87,79,82,75,32,76,69,78,71,84,72,32,78,69,69,68,69,68,44,32,76,69,78,73,87,32,40,61,73,49,41,44,32,69,88,67,69,69,68,83,32,76,73,87,32,40,61,73,50,41,0,0,0,0,5,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,82,84,79,76,32,73,83,32,46,76,84,46,32,48,0,39,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,65,84,79,76,32,73,83,32,46,76,84,46,32,48,0,7,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,76,76,32,69,76,69,77,69,78,84,83,32,79,70,32,82,84,79,76,32,65,78,68,32,65,84,79,76,32,65,82,69,32,90,69,82,79,0,8,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,52,41,32,61,32,49,32,65,78,68,32,84,83,84,79,80,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,79,85,84,32,40,61,82,50,41,0,0,54,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,72,77,65,88,32,40,61,82,49,41,32,46,76,84,46,32,48,46,48,0,0,0,0,10,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,79,85,84,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,32,40,61,82,50,41,0,0,0,0,0,0,11,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,56,41,61,49,32,65,78,68,32,72,48,61,48,46,48,0,0,0,29,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,87,84,32,73,83,32,46,76,69,46,32,48,46,48,0,13,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,84,79,85,84,32,40,61,82,49,41,32,84,79,79,32,67,76,79,83,69,32,84,79,32,84,32,40,61,82,50,41,32,84,79,32,83,84,65,82,84,32,73,78,84,69,71,82,65,84,73,79,78,0,0,0,0,14,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,52,41,61,49,32,65,78,68,32,84,83,84,79,80,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,32,40,61,82,50,41,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,76,32,40,61,73,49,41,32,73,76,76,69,71,65,76,46,32,69,73,84,72,69,82,32,46,76,84,46,32,48,32,79,82,32,46,71,84,46,32,78,69,81,0,0,0,0,52,0,0,0,0,0,0,0,17,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,85,32,40,61,73,49,41,32,73,76,76,69,71,65,76,46,32,69,73,84,72,69,82,32,46,76,84,46,32,48,32,79,82,32,46,71,84,46,32,78,69,81,0,0,0,0,18,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,79,85,84,32,40,61,82,49,41,32,73,83,32,69,81,85,65,76,32,84,79,32,84,32,40,61,82,50,41,0,19,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,78,71,32,40,61,73,49,41,32,46,76,84,46,32,48,0,0,0,0,0,0,0,0,24,0,0,0,0,0,0,0,30,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,79,78,69,32,79,82,32,77,79,82,69,32,67,79,77,80,79,78,69,78,84,83,32,79,70,32,71,32,72,65,83,32,65,32,82,79,79,84,0,32,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,32,84,79,79,32,78,69,65,82,32,84,79,32,84,72,69,32,73,78,73,84,73,65,76,32,80,79,73,78,84,0,0,68,65,83,83,76,45,45,32,32,82,69,80,69,65,84,69,68,32,79,67,67,85,82,82,69,78,67,69,83,32,79,70,32,73,76,76,69,71,65,76,32,73,78,80,85,84,0,0,46,0,0,0,0,0,0,0,33,3,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,82,85,78,32,84,69,82,77,73,78,65,84,69,68,46,32,65,80,80,65,82,69,78,84,32,73,78,70,73,78,73,84,69,32,76,79,79,80,0,34,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,97,116,32,112,111,105,110,116,32,105,110,32,116,105,109,101,58,32,37,103,0,0,0,0,99,106,58,32,37,103,0,0,115,116,97,116,101,115,0,0,91,37,108,100,93,32,37,103,0,0,0,0,0,0,0,0,97,110,97,108,121,116,105,99,97,108,32,74,97,99,111,98,105,97,110,0,0,0,0,0,37,115,37,103,32,0,0,0,37,115,0,0,0,0,0,0,110,117,109,101,114,105,99,97,108,32,74,97,99,111,98,105,97,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,0,0,0,0,0,0,0,83,0,0,0,0,0,0,0,66,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,82,0,0,0,0,0,0,0,77,0,0,0,0,0,0,0,85,0,0,0,0,0,0,0,76,0,0,0,0,0,0,0,79], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+210464);
/* memory initializer */ allocate([40,47,47,2,32,87,65,82,78,73,78,71,46,32,84,104,101,32,118,97,108,117,101,32,69,77,73,78,32,109,97,121,32,98,101,32,105,110,99,111,114,114,101,99,116,58,45,2,44,2,32,32,69,77,73,78,32,61,32,2,44,105,56,44,47,2,32,73,102,44,32,97,102,116,101,114,32,105,110,115,112,101,99,116,105,111,110,44,32,116,104,101,32,118,97,108,117,101,32,69,77,73,78,32,108,111,111,107,115,2,44,2,32,97,99,99,101,112,116,97,98,108,101,32,112,108,101,97,115,101,32,99,111,109,109,101,110,116,32,111,117,116,32,2,44,47,2,32,116,104,101,32,73,70,32,98,108,111,99,107,32,97,115,32,109,97,114,107,101,100,32,119,105,116,104,105,110,32,116,104,101,32,99,111,100,101,32,111,102,32,114,111,117,116,105,110,101,2,44,2,32,68,76,65,77,67,50,44,2,44,47,2,32,111,116,104,101,114,119,105,115,101,32,115,117,112,112,108,121,32,69,77,73,78,32,101,120,112,108,105,99,105,116,108,121,46,2,44,47,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,144,94,3,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,191,76,0,0,0,0,176,60,49,101,0,0,0,0,16,0,244,14,255,255,255,255,239,127,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,2,32,80,114,111,103,114,101,115,115,32,82,101,112,111,114,116,32,101,118,101,114,121,2,44,105,52,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,2,47,44,2,32,69,86,65,76,46,32,32,32,70,85,78,67,46,86,65,76,85,69,46,2,44,49,48,120,44,2,80,65,82,65,77,69,84,69,82,32,86,65,76,85,69,83,2,41,0,0,0,0,40,47,49,120,44,105,52,44,50,120,44,103,49,50,46,53,44,50,120,44,53,103,49,49,46,52,44,51,40,47,50,49,120,44,53,103,49,49,46,52,41,41,0,0,0,0,0,0,40,2,32,78,111,46,32,111,102,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,32,62,32,2,44,105,53,41,0,0,40,2,32,82,77,83,32,111,102,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,111,102,32,108,97,115,116,32,115,105,109,112,108,101,120,32,61,2,44,103,49,52,46,54,41,0,0,0,0,0,40,2,32,67,101,110,116,114,111,105,100,32,111,102,32,108,97,115,116,32,115,105,109,112,108,101,120,32,61,2,44,52,40,47,49,120,44,54,103,49,51,46,53,41,41,0,0,0,40,2,32,70,117,110,99,116,105,111,110,32,118,97,108,117,101,32,97,116,32,99,101,110,116,114,111,105,100,32,61,2,44,103,49,52,46,54,41,0,40,47,2,32,69,86,73,68,69,78,67,69,32,79,70,32,67,79,78,86,69,82,71,69,78,67,69,2,41,0,0,0,40,47,47,2,32,77,105,110,105,109,117,109,32,102,111,117,110,100,32,97,102,116,101,114,2,44,105,53,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,2,41,0,0,0,40,2,32,77,105,110,105,109,117,109,32,97,116,2,44,52,40,47,49,120,44,54,103,49,51,46,54,41,41,0,0,0,40,2,32,70,117,110,99,116,105,111,110,32,118,97,108,117,101,32,97,116,32,109,105,110,105,109,117,109,32,61,2,44,103,49,52,46,54,41,0,0,40,47,2,32,70,105,116,116,105,110,103,32,113,117,97,100,114,97,116,105,99,32,115,117,114,102,97,99,101,32,97,98,111,117,116,32,115,117,112,112,111,115,101,100,32,109,105,110,105,109,117,109,2,47,41,0,40,47,2,32,77,65,84,82,73,88,32,79,70,32,69,83,84,73,77,65,84,69,68,32,83,69,67,79,78,68,32,68,69,82,73,86,65,84,73,86,69,83,32,78,79,84,32,43,86,69,32,68,69,70,78,46,2,47,2,32,77,73,78,73,77,85,77,32,80,82,79,66,65,66,76,89,32,78,79,84,32,70,79,85,78,68,2,47,41,0,0,0,0,0,0,0,40,47,49,48,120,44,2,83,101,97,114,99,104,32,114,101,115,116,97,114,116,105,110,103,2,47,41,0,0,0,0,0,40,2,32,77,105,110,105,109,117,109,32,111,102,32,113,117,97,100,114,97,116,105,99,32,115,117,114,102,97,99,101,32,61,2,44,103,49,52,46,54,44,2,32,97,116,2,44,52,40,47,49,120,44,54,103,49,51,46,53,41,41,0,0,0,40,2,32,73,70,32,84,72,73,83,32,68,73,70,70,69,82,83,32,66,89,32,77,85,67,72,32,70,82,79,77,32,84,72,69,32,77,73,78,73,77,85,77,32,69,83,84,73,77,65,84,69,68,2,44,49,120,44,2,70,82,79,77,32,84,72,69,32,77,73,78,73,77,73,90,65,84,73,79,78,44,2,47,2,32,84,72,69,32,77,73,78,73,77,85,77,32,77,65,89,32,66,69,32,70,65,76,83,69,32,38,47,79,82,32,84,72,69,32,73,78,70,79,82,77,65,84,73,79,78,32,77,65,84,82,73,88,32,77,65,89,32,66,69,2,44,49,120,44,2,73,78,65,67,67,85,82,65,84,69,2,47,41,0,0,0,0,0,40,2,32,82,97,110,107,32,111,102,32,105,110,102,111,114,109,97,116,105,111,110,32,109,97,116,114,105,120,32,61,2,44,105,51,47,2,32,73,110,118,101,114,115,101,32,111,102,32,105,110,102,111,114,109,97,116,105,111,110,32,109,97,116,114,105,120,58,45,2,41,0,40,47,2,32,73,102,32,116,104,101,32,102,117,110,99,116,105,111,110,32,109,105,110,105,109,105,122,101,100,32,119,97,115,32,45,76,79,71,40,76,73,75,69,76,73,72,79,79,68,41,44,2,47,2,32,116,104,105,115,32,105,115,32,116,104,101,32,99,111,118,97,114,105,97,110,99,101,32,109,97,116,114,105,120,32,111,102,32,116,104,101,32,112,97,114,97,109,101,116,101,114,115,46,2,47,2,32,73,102,32,116,104,101,32,102,117,110,99,116,105,111,110,32,119,97,115,32,97,32,115,117,109,32,111,102,32,115,113,117,97,114,101,115,32,111,102,32,114,101,115,105,100,117,97,108,115,44,2,47,2,32,116,104,105,115,32,109,97,116,114,105,120,32,109,117,115,116,32,98,101,32,109,117,108,116,105,112,108,105,101,100,32,98,121,32,116,119,105,99,101,32,116,104,101,32,101,115,116,105,109,97,116,101,100,2,44,49,120,44,2,114,101,115,105,100,117,97,108,32,118,97,114,105,97,110,99,101,2,47,2,32,116,111,32,111,98,116,97,105,110,32,116,104,101,32,99,111,118,97,114,105,97,110,99,101,32,109,97,116,114,105,120,46,2,47,41,0,0,0,0,40,2,32,73,78,70,79,82,77,65,84,73,79,78,32,77,65,84,82,73,88,58,45,2,47,41,0,0,0,0,0,0,40,47,47,2,32,67,79,82,82,69,76,65,84,73,79,78,32,77,65,84,82,73,88,58,45,2,41,0,0,0,0,0,40,47,2,32,65,32,102,117,114,116,104,101,114,2,44,105,52,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,32,104,97,118,101,32,98,101,101,110,32,117,115,101,100,2,47,41,0,0,0,0,0,0,40,49,120,44,54,103,49,51,46,53,41,0,0,0,0,0,40,47,41], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+220808);
/* memory initializer */ allocate([16,99,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,99,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,99,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,99,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,99,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,99,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,99,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,99,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,99,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,100,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,100,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,100,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,100,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,100,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,100,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,100,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,100,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,99,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,101,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,101,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,101,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,101,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,102,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,102,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,104,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,104,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,104,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,104,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,104,3,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,78,80,84,32,105,115,32,110,111,116,32,105,110,2,44,2,32,116,104,101,32,114,101,113,117,105,114,101,100,32,105,110,116,101,114,118,97,108,2,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,224,139,3,0,0,0,0,0,0,0,0,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,67,65,76,70,85,78,32,104,97,115,32,98,101,101,110,2,44,2,32,99,97,108,108,101,100,32,77,65,88,70,85,78,32,116,105,109,101,115,46,2,41,0,0,0,0,0,0,40,47,52,120,44,2,70,117,110,99,116,105,111,110,32,110,117,109,98,101,114,2,44,105,54,44,2,32,32,32,32,70,32,61,2,44,49,112,100,49,56,46,49,48,44,2,32,32,32,32,84,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,88,32,105,115,58,2,47,40,50,120,44,53,100,49,53,46,54,41,41,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,97,32,116,114,117,115,116,2,44,2,32,114,101,103,105,111,110,32,115,116,101,112,32,104,97,115,32,102,97,105,108,101,100,32,116,111,32,114,101,100,117,99,101,32,81,46,2,41,0,0,0,0,0,0,0,40,53,120,41,0,0,0,0,40,47,52,120,44,2,78,101,119,32,82,72,79,32,61,2,44,49,112,100,49,49,46,52,44,53,120,44,2,78,117,109,98,101,114,32,111,102,2,44,2,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,61,2,44,105,54,41,0,0,0,0,0,0,0,0,40,52,120,44,2,76,101,97,115,116,32,118,97,108,117,101,32,111,102,32,70,32,61,2,44,49,112,100,50,51,46,49,53,44,57,120,44,2,84,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,88,32,105,115,58,2,47,40,50,120,44,53,100,49,53,46,54,41,41,0,0,0,0,0,40,47,52,120,44,2,65,116,32,116,104,101,32,114,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,2,44,53,120,44,2,78,117,109,98,101,114,32,111,102,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,61,2,44,105,54,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,192,140,3,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,16,141,3,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,104,141,3,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,192,141,3,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,200,141,3,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,16,142,3,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,96,142,3,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,16,142,3,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,105,118,111,116,32,33,61,32,48,0,0,0,0,0,0,109,97,116,104,45,115,117,112,112,111,114,116,47,112,105,118,111,116,46,99,0,0,0,0,112,105,118,111,116,0,0,0,152,154,3,0,184,155,3,0,192,155,3,0,208,155,3,0,224,155,3,0,240,155,3,0,8,156,3,0,32,156,3,0,117,110,114,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,32,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,152,154,3,0,160,154,3,0,232,154,3,0,16,155,3,0,48,155,3,0,80,155,3,0,120,155,3,0,160,155,3,0,117,110,114,101,99,111,103,110,105,122,101,100,32,100,97,115,115,108,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,37,115,0,0,0,0,0,124,32,115,111,108,118,101,114,32,124,32,85,115,101,32,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,9,37,115,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,78,111,32,83,112,97,114,115,101,80,97,116,116,101,114,110,44,32,115,105,110,99,101,32,116,104,101,114,101,32,97,114,101,32,110,111,32,115,116,97,116,101,115,33,32,83,119,105,116,99,104,32,98,97,99,107,32,116,111,32,110,111,114,109,97,108,46,0,0,0,0,0,74,97,99,111,98,105,97,110,32,111,114,32,83,112,97,114,115,101,80,97,116,116,101,114,110,32,105,115,32,110,111,116,32,103,101,110,101,114,97,116,101,100,32,111,114,32,102,97,105,108,101,100,32,116,111,32,105,110,105,116,105,97,108,105,122,101,33,32,83,119,105,116,99,104,32,98,97,99,107,32,116,111,32,110,111,114,109,97,108,46,0,0,0,0,0,0,99,111,117,108,100,32,110,111,116,32,112,97,115,115,101,100,32,116,111,32,68,68,65,83,82,84,0,0,0,0,0,0,68,101,115,105,114,101,100,32,115,116,101,112,32,116,111,32,115,109,97,108,108,32,116,114,121,32,110,101,120,116,32,111,110,101,0,0,0,0,0,0,73,110,116,101,114,112,111,108,97,116,101,32,108,105,110,101,97,114,0,0,0,0,0,0,67,97,108,108,105,110,103,32,68,68,65,83,82,84,32,102,114,111,109,32,37,46,49,53,103,32,116,111,32,37,46,49,53,103,0,0,0,0,0,0,83,116,97,114,116,32,115,116,101,112,32,37,46,49,53,103,32,116,111,32,37,46,49,53,103,0,0,0,0,0,0,0,65,32,108,97,114,103,101,32,97,109,111,117,110,116,32,111,102,32,119,111,114,107,32,104,97,115,32,98,101,101,110,32,101,120,112,101,110,100,101,100,46,40,65,98,111,117,116,32,53,48,48,32,115,116,101,112,115,41,46,32,84,114,121,105,110,103,32,116,111,32,99,111,110,116,105,110,117,101,32,46,46,46,0,0,0,0,0,0,68,65,83,83,76,32,119,105,108,108,32,116,114,121,32,97,103,97,105,110,46,46,46,0,99,97,110,39,116,32,99,111,110,116,105,110,117,101,46,32,116,105,109,101,32,61,32,37,102,0,0,0,0,0,0,0,100,97,115,115,108,32,99,97,108,108,32,115,116,97,105,115,116,105,99,115,58,32,0,0,118,97,108,117,101,32,111,102,32,105,100,105,100,58,32,37,100,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,116,105,109,101,32,118,97,108,117,101,58,32,37,48,46,52,103,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,105,110,116,101,103,114,97,116,105,111,110,32,116,105,109,101,32,118,97,108,117,101,58,32,37,48,46,52,103,0,0,0,115,116,101,112,32,115,105,122,101,32,72,32,116,111,32,98,101,32,97,116,116,101,109,112,116,101,100,32,111,110,32,110,101,120,116,32,115,116,101,112,58,32,37,48,46,52,103,0,115,116,101,112,32,115,105,122,101,32,117,115,101,100,32,111,110,32,108,97,115,116,32,115,117,99,99,101,115,115,102,117,108,32,115,116,101,112,58,32,37,48,46,52,103,0,0,0,110,117,109,98,101,114,32,111,102,32,115,116,101,112,115,32,116,97,107,101,110,32,115,111,32,102,97,114,58,32,37,100,0,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,99,97,108,108,115,32,111,102,32,102,117,110,99,116,105,111,110,79,68,69,40,41,32,58,32,37,100,0,0,0,110,117,109,98,101,114,32,111,102,32,99,97,108,99,117,108,97,116,105,111,110,32,111,102,32,106,97,99,111,98,105,97,110,32,58,32,37,100,0,0,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,99,111,110,118,101,114,103,101,110,99,101,32,116,101,115,116,32,102,97,105,108,117,114,101,115,58,32,37,100,0,0,0,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,58,32,37,100,0,49,48,32,43,32,117,105,32,60,32,100,97,115,115,108,68,97,116,97,45,62,108,105,119,0,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,111,108,118,101,114,47,100,97,115,115,108,46,99,0,0,0,0,0,0,0,100,97,115,114,116,95,115,116,101,112,0,0,0,0,0,0,70,105,110,105,115,104,101,100,32,68,68,65,83,82,84,32,115,116,101,112,46,0,0,0,84,104,101,32,101,114,114,111,114,32,116,111,108,101,114,97,110,99,101,115,32,97,114,101,32,116,111,111,32,115,116,114,105,110,103,101,110,116,0,0,68,68,65,83,83,76,32,104,97,100,32,114,101,112,101,97,116,101,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,32,111,110,32,116,104,101,32,108,97,115,116,32,97,116,116,101,109,112,116,101,100,32,115,116,101,112,46,0,0,0,0,0,84,104,101,32,99,111,114,114,101,99,116,111,114,32,99,111,117,108,100,32,110,111,116,32,99,111,110,118,101,114,103,101,46,0,0,0,0,0,0,0,84,104,101,32,109,97,116,114,105,120,32,111,102,32,112,97,114,116,105,97,108,32,100,101,114,105,118,97,116,105,118,101,115,32,105,115,32,115,105,110,103,117,108,97,114,46,0,0,84,104,101,32,99,111,114,114,101,99,116,111,114,32,99,111,117,108,100,32,110,111,116,32,99,111,110,118,101,114,103,101,46,32,84,104,101,114,101,32,119,101,114,101,32,114,101,112,101,97,116,101,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,32,105,110,32,116,104,105,115,32,115,116,101,112,46,0,65,32,77,111,100,101,108,105,99,97,32,97,115,115,101,114,116,32,112,114,101,118,101,110,116,115,32,116,104,101,32,105,110,116,101,103,114,97,116,111,114,32,116,111,32,99,111,110,116,105,110,117,101,46,32,70,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,117,115,101,32,45,108,118,32,76,79,71,95,68,68,65,83,82,84,0,0,73,82,69,83,32,101,113,117,97,108,32,116,111,32,45,50,32,119,97,115,32,101,110,99,111,117,110,116,101,114,101,100,32,97,110,100,32,99,111,110,116,114,111,108,32,105,115,32,98,101,105,110,103,32,114,101,116,117,114,110,101,100,32,116,111,32,116,104,101,32,99,97,108,108,105,110,103,32,112,114,111,103,114,97,109,46,0,0,68,68,65,83,83,76,32,102,97,105,108,101,100,32,116,111,32,99,111,109,112,117,116,101,32,116,104,101,32,105,110,105,116,105,97,108,32,89,80,82,73,77,69,46,0,0,0,0,84,104,101,32,99,111,100,101,32,104,97,115,32,101,110,99,111,117,110,116,101,114,101,100,32,116,114,111,117,98,108,101,32,102,114,111,109,32,119,104,105,99,104,32,105,116,32,99,97,110,110,111,116,32,114,101,99,111,118,101,114,46,0,0,117,110,107,110,111,119,110,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,44,32,119,105,116,104,32,105,110,116,101,114,118,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,105,110,116,101,114,110,97,108,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,100,97,115,115,108,32,102,111,114,32,100,101,98,117,103,32,112,114,111,112,111,115,101,0,100,97,115,115,108,0,0,0,100,97,115,115,108,119,111,114,116,0,0,0,0,0,0,0,100,97,115,115,108,83,121,109,74,97,99,0,0,0,0,0,100,97,115,115,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,67,111,108,111,114,83,121,109,74,97,99,0,0,0,0,0,0,0,0,100,97,115,115,108,73,110,116,101,114,110,97,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,116,101,115,116,0,0,0,0,0,0,0,84,82,85,69,0,0,0,0,70,65,76,83,69,0,0,0,91,37,108,100,93,32,115,97,109,112,108,101,40,37,103,44,32,37,103,41,0,0,0,0,91,37,108,100,93,32,37,115,0,0,0,0,0,0,0,0,67,104,97,116,116,101,114,105,110,103,32,100,101,116,101,99,116,101,100,32,97,114,111,117,110,100,32,116,105,109,101,32,37,46,49,50,103,46,46,37,46,49,50,103,32,40,37,100,32,115,116,97,116,101,32,101,118,101,110,116,115,32,105,110,32,97,32,114,111,119,32,119,105,116,104,32,97,32,116,111,116,97,108,32,116,105,109,101,32,100,101,108,116,97,32,108,101,115,115,32,116,104,97,110,32,116,104,101,32,115,116,101,112,32,115,105,122,101,32,37,46,49,50,103,41,46,32,84,104,105,115,32,99,97,110,32,98,101,32,97,32,112,101,114,102,111,114,109,97,110,99,101,32,98,111,116,116,108,101,110,101,99,107,46,32,85,115,101,32,45,108,118,32,76,79,71,95,69,86,69,78,84,83,32,102,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,46,32,84,104,101,32,122,101,114,111,45,99,114,111,115,115,105,110,103,32,119,97,115,58,32,37,115,0,0,0,0,0,0,0,0,0,115,116,97,116,101,115,95,114,105,103,104,116,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,111,108,118,101,114,47,101,118,101,110,116,115,46,99,0,0,0,0,0,0,102,105,110,100,82,111,111,116,0,0,0,0,0,0,0,0,115,116,97,116,101,115,95,108,101,102,116,0,0,0,0,0,115,101,97,114,99,104,32,102,111,114,32,99,117,114,114,101,110,116,32,101,118,101,110,116,46,32,69,118,101,110,116,115,32,105,110,32,108,105,115,116,58,32,37,108,100,0,0,0,77,105,110,105,109,117,109,32,118,97,108,117,101,58,32,37,101,0,0,0,0,0,0,0,97,100,100,101,100,32,116,109,112,32,101,118,101,110,116,32,58,32,37,108,100,0,0,0,37,108,100,32,0,0,0,0,98,97,99,107,117,112,95,103,111,117,116,0,0,0,0,0,98,105,115,101,99,116,105,111,110,0,0,0,0,0,0,0,98,105,115,101,99,116,105,111,110,32,109,101,116,104,111,100,32,115,116,97,114,116,115,32,105,110,32,105,110,116,101,114,118,97,108,32,91,37,101,44,32,37,101,93,0,0,0,0,84,84,79,76,32,105,115,32,115,101,116,32,116,111,58,32,37,101,0,0,0,0,0,0,98,105,115,101,99,116,105,111,110,32,99,104,101,99,107,115,32,102,111,114,32,99,111,110,100,105,116,105,111,110,32,99,104,97,110,103,101,115,0,0,37,108,100,32,99,104,97,110,103,101,100,32,102,114,111,109,32,37,115,32,116,111,32,99,117,114,114,101,110,116,32,37,115,0,0,0,0,0,0,0,115,97,118,101,32,97,108,108,32,122,101,114,111,99,114,111,115,115,105,110,103,115,32,97,102,116,101,114,32,97,110,32,101,118,101,110,116,0,0,0,69,82,82,79,82,58,32,84,111,111,32,109,97,110,121,32,101,118,101,110,116,32,105,116,101,114,97,116,105,111,110,115,46,32,83,121,115,116,101,109,32,105,115,32,105,110,99,111,110,115,105,115,116,101,110,116,46,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,46,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,112,97,114,97,109,101,116,101,114,32,118,97,108,117,101,115,0,0,0,0,0,0,0,0,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,103,0,0,0,0,0,0,0,0,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,37,115,40,115,116,97,114,116,61,37,108,100,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,108,100,0,0,0,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,66,111,111,108,101,97,110,32,37,115,40,115,116,97,114,116,61,37,115,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,115,0,0,0,0,0,115,116,114,105,110,103,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,83,116,114,105,110,103,32,37,115,40,115,116,97,114,116,61,34,37,115,34,41,32,61,32,34,37,115,34,0,0,0,0,115,116,97,116,117,115,32,111,102,32,114,101,108,97,116,105,111,110,115,0,0,0,0,0,91,37,108,100,93,32,37,115,32,61,32,37,99,32,124,32,112,114,101,40,37,115,41,32,61,32,37,99,0,0,0,0,89,111,117,114,32,109,101,109,111,114,121,32,105,115,32,110,111,116,32,115,116,114,111,110,103,32,101,110,111,117,103,104,32,102,111,114,32,111,117,114,32,82,105,110,103,98,117,102,102,101,114,33,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,101,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,101,120,116,101,114,110,97,108,32,111,98,106,101,99,116,115,0,0,0,0,0,0,0,187,189,215,217,223,124,219,61,83,101,116,32,116,111,108,101,114,97,110,99,101,32,102,111,114,32,122,101,114,111,45,99,114,111,115,115,105,110,103,32,104,121,115,116,101,114,101,115,105,115,32,116,111,58,32,37,101,0,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,109,105,120,101,100,32,115,111,108,118,101,114,0,0,0,0,0,0,0,109,105,120,101,100,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,0,91,37,100,93,32,37,115,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,0,97,108,108,111,99,97,116,101,77,105,120,101,100,83,101,97,114,99,104,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,0,0,0,0,110,111,32,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,0,0,0,108,105,110,101,97,114,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,91,37,100,93,32,37,115,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,100,97,116,97,32,102,111,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,108,97,112,97,99,107,46,0,0,0,0,0,0,0,65,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,0,0,0,0,0,0,0,37,115,37,50,48,46,49,50,103,32,0,0,0,0,0,0,37,115,0,0,0,0,0,0,98,32,118,101,99,116,111,114,32,91,37,100,93,0,0,0,69,114,114,111,114,32,115,111,108,118,105,110,103,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,111,102,32,101,113,117,97,116,105,111,110,115,32,40,110,111,46,32,37,100,41,32,97,116,32,116,105,109,101,32,37,102,46,32,65,114,103,117,109,101,110,116,32,37,100,32,105,108,108,101,103,97,108,46,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,115,111,108,118,101,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,111,102,32,101,113,117,97,116,105,111,110,115,32,40,110,111,46,32,37,100,41,32,97,116,32,116,105,109,101,32,37,102,44,32,115,121,115,116,101,109,32,105,115,32,115,105,110,103,117,108,97,114,32,102,111,114,32,85,91,37,100,44,32,37,100,93,46,0,0,0,0,0,0,0,37,115,37,49,48,103,32,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,100,97,116,97,32,102,111,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,76,105,115,46,0,0,45,105,32,102,103,109,114,101,115,32,0,0,0,0,0,0,78,76,83,95,85,78,75,78,79,87,78,0,0,0,0,0,104,121,98,114,105,100,0,0,107,105,110,115,111,108,0,0,110,101,119,116,111,110,0,0,78,76,83,95,77,65,88,0,8,164,3,0,24,164,3,0,32,164,3,0,40,164,3,0,48,164,3,0,0,0,0,0,117,110,107,110,111,119,110,0,100,101,102,97,117,108,116,32,109,101,116,104,111,100,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,78,101,119,116,111,110,32,82,97,112,104,115,111,110,0,0,80,164,3,0,88,164,3,0,104,164,3,0,120,164,3,0,48,164,3,0,0,0,0,0,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,105,110,118,97,108,105,100,0,0,0,0,106,97,99,111,98,105,97,110,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,105,110,118,97,108,105,100,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,110,111,110,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,0,0,0,0,0,112,114,111,112,101,114,32,115,116,97,114,116,45,118,97,108,117,101,115,32,102,111,114,32,115,111,109,101,32,111,102,32,116,104,101,32,102,111,108,108,111,119,105,110,103,32,105,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,115,32,109,105,103,104,116,32,104,101,108,112,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,63,44,32,110,111,109,105,110,97,108,61,63,41,0,0,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,0,0,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,115,116,97,114,116,32,115,111,108,118,105,110,103,32,110,111,110,45,108,105,110,101,97,114,32,115,121,115,116,101,109,32,62,62,37,115,60,60,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,102,0,0,0,0,0,0,115,99,97,108,105,110,103,32,61,32,37,102,10,111,108,100,32,61,32,37,102,10,101,120,116,114,97,112,111,108,97,116,101,100,32,61,32,37,102,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,32,120,32,118,101,99,116,111,114,0,0,0,0,0,0,0,0,73,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,32,118,97,108,117,101,115,0,0,0,0,0,0,0,73,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,32,118,97,108,117,101,115,32,40,115,99,97,108,101,100,41,0,0,0,0,0,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,32,102,111,114,32,114,101,115,105,100,117,97,108,32,118,101,99,116,111,114,0,0,0,0,0,115,99,97,108,101,100,32,114,101,115,105,100,117,97,108,32,91,37,100,93,32,58,32,37,46,50,48,101,0,0,0,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,91,37,100,93,32,58,32,37,46,50,48,101,0,0,0,0,0,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,37,115,37,49,48,103,32,0,37,115,0,0,0,0,0,0,115,121,115,116,101,109,32,115,111,108,118,101,100,0,0,0,37,100,32,114,101,116,114,105,101,115,10,37,100,32,114,101,115,116,97,114,116,115,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,100,101,99,114,101,97,115,105,110,103,32,105,110,105,116,105,97,108,32,115,116,101,112,32,98,111,117,110,100,32,116,111,32,37,102,46,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,115,111,108,117,116,105,111,110,32,112,111,105,110,116,32,98,121,32,49,37,37,46,0,0,0,0,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,111,108,100,32,118,97,108,117,101,115,32,97,115,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,46,0,0,0,0,0,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,119,105,116,104,111,117,116,32,115,99,97,108,105,110,103,32,97,116,32,97,108,108,46,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,116,111,32,115,111,108,118,101,32,97,32,100,105,115,99,111,110,116,105,110,117,111,117,115,32,115,121,115,116,101,109,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,117,115,101,32,111,108,100,32,118,97,108,117,101,115,32,105,110,115,116,101,97,100,32,101,120,116,114,97,112,111,108,97,116,101,100,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,105,110,105,116,105,97,108,32,112,111,105,110,116,32,98,121,32,97,100,100,105,110,103,32,49,37,37,46,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,105,110,105,116,105,97,108,32,112,111,105,110,116,32,98,121,32,45,49,37,37,46,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,97,115,32,105,110,105,116,105,97,108,32,112,111,105,110,116,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,119,105,116,104,32,111,119,110,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,46,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,100,105,115,97,98,108,101,32,115,111,108,118,101,114,32,105,110,116,101,114,110,97,108,32,115,99,97,108,105,110,103,46,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,114,101,100,117,99,101,32,116,104,101,32,116,111,108,101,114,97,110,99,101,32,115,108,105,103,104,116,108,121,32,116,111,32,37,101,46,0,0,35,35,35,32,78,111,32,83,111,108,117,116,105,111,110,33,32,35,35,35,10,32,97,102,116,101,114,32,37,100,32,114,101,115,116,97,114,116,115,0,110,108,115,32,115,116,97,116,117,115,0,0,0,0,0,0,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,46,50,48,101,32,91,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,61,32,37,49,54,101,93,0,0,0,102,117,110,99,116,105,111,110,115,0,0,0,0,0,0,0,114,101,115,91,37,100,93,32,61,32,37,46,50,48,101,32,91,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,61,32,37,49,54,101,93,0,115,116,97,116,105,115,116,105,99,115,0,0,0,0,0,0,110,102,117,110,99,32,61,32,37,100,10,101,114,114,111,114,32,61,32,37,46,50,48,101,10,101,114,114,111,114,95,115,99,97,108,101,100,32,61,32,37,46,50,48,101,0,0,0,91,37,50,100,93,32,37,50,48,46,49,50,103,0,0,0,45,45,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,99,97,108,108,32,37,100,32,45,45,0,120,32,118,101,99,116,111,114,0,0,0,0,0,0,0,0,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,0,45,45,32,101,110,100,32,111,102,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,99,97,108,108,32,37,100,32,45,45,0,0,45,45,32,98,101,103,105,110,32,99,97,108,99,117,108,97,116,105,110,103,32,106,97,99,111,98,105,97,110,32,45,45,0,0,0,0,0,0,0,0,45,45,32,101,110,100,32,99,97,108,99,117,108,97,116,105,110,103,32,106,97,99,111,98,105,97,110,32,45,45,0,0,37,115,37,50,48,46,49,50,103,32,0,0,0,0,0,0,87,101,108,108,44,32,116,104,105,115,32,105,115,32,101,109,98,97,114,114,97,115,105,110,103,46,32,84,104,101,32,110,111,110,45,108,105,110,101,97,114,32,115,111,108,118,101,114,32,115,104,111,117,108,100,32,110,101,118,101,114,32,99,97,108,108,32,116,104,105,115,32,99,97,115,101,46,37,100,0,97,108,108,111,99,97,116,105,111,110,78,101,119,116,111,110,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,97,108,108,111,99,97,116,105,111,110,78,101,119,116,111,110,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,83,116,97,114,116,32,115,111,108,118,105,110,103,32,78,111,110,45,76,105,110,101,97,114,32,83,121,115,116,101,109,32,37,115,32,97,116,32,116,105,109,101,32,37,103,32,119,105,116,104,32,78,101,119,116,111,110,32,83,111,108,118,101,114,0,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,46,49,53,101,0,0,0,115,99,97,108,105,110,103,32,61,32,37,102,32,43,43,43,32,111,108,100,32,61,32,37,101,32,43,43,43,32,101,120,116,114,97,112,111,108,97,116,101,100,32,61,32,37,101,0,42,42,42,32,83,121,115,116,101,109,32,115,111,108,118,101,100,32,42,42,42,10,37,100,32,114,101,115,116,97,114,116,115,0,0,0,0,0,0,0,110,102,117,110,99,32,61,32,37,100,32,43,43,43,32,101,114,114,111,114,32,61,32,37,46,49,53,101,32,43,43,43,32,101,114,114,111,114,95,115,99,97,108,101,100,32,61,32,37,46,49,53,101,0,0,0,120,91,37,100,93,32,61,32,37,46,49,53,101,10,9,114,101,115,105,100,117,97,108,32,61,32,37,101,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,111,108,100,32,118,97,108,117,101,115,46,0,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,115,111,108,117,116,105,111,110,32,112,111,105,110,116,32,98,121,32,49,37,37,46,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,110,111,109,105,110,97,108,32,118,97,108,117,101,115,32,97,115,32,105,110,105,116,105,97,108,32,115,111,108,117,116,105,111,110,46,0,0,0,0,0,0,0,35,35,35,32,78,111,32,83,111,108,117,116,105,111,110,33,32,35,35,35,10,32,97,102,116,101,114,32,37,100,32,114,101,115,116,97,114,116,115,0,35,35,35,35,35,35,35,35,35,32,83,116,97,114,116,32,78,101,119,116,111,110,32,109,97,120,102,101,118,58,32,37,100,32,35,35,35,35,35,35,35,35,35,0,0,0,0,0,120,91,37,100,93,58,32,37,101,32,0,0,0,0,0,0,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,37,115,37,49,48,103,32,0,37,115,0,0,0,0,0,0,74,97,99,111,98,105,97,110,32,77,97,116,114,105,120,32,115,105,110,103,117,108,97,114,33,0,0,0,0,0,0,0,105,108,108,101,103,97,108,32,32,105,110,112,117,116,32,105,110,32,97,114,103,117,109,101,110,116,32,37,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,240,63,73,110,105,116,105,97,108,105,122,105,110,103,32,68,65,83,83,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,116,111], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+231492);
/* memory initializer */ allocate([114,105,110,103,32,114,101,115,117,108,116,115,32,97,110,100,32,101,120,105,116,105,110,103,46,10,85,115,101,32,45,108,118,61,76,79,71,95,73,78,73,84,32,45,119,32,102,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,46,0,115,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,98,121,32,97,110,32,97,115,115,101,114,116,105,111,110,32,97,116,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,87,114,111,116,101,32,112,97,114,97,109,101,116,101,114,115,32,116,111,32,116,104,101,32,102,105,108,101,32,97,102,116,101,114,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,40,102,111,114,32,111,117,116,112,117,116,32,102,111,114,109,97,116,115,32,116,104,97,116,32,115,117,112,112,111,114,116,32,116,104,105,115,41,0,0,0,0,0,0,0,0,116,101,114,109,105,110,97,108,32,101,118,101,110,116,32,97,116,32,115,116,111,112,32,116,105,109,101,32,37,103,0,0,70,105,110,105,115,104,101,100,0,0,0,0,0,0,0,0,35,35,35,32,83,84,65,84,73,83,84,73,67,83,32,35,35,35,0,0,0,0,0,0,116,105,109,101,114,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,112,114,101,45,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,115,116,101,112,115,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,99,114,101,97,116,105,110,103,32,111,117,116,112,117,116,45,102,105,108,101,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,101,118,101,110,116,45,104,97,110,100,108,105,110,103,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,111,118,101,114,104,101,97,100,0,0,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,115,105,109,117,108,97,116,105,111,110,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,116,111,116,97,108,0,0,0,101,118,101,110,116,115,0,0,37,53,108,100,32,115,116,97,116,101,32,101,118,101,110,116,115,0,0,0,0,0,0,0,37,53,108,100,32,116,105,109,101,32,101,118,101,110,116,115,0,0,0,0,0,0,0,0,115,111,108,118,101,114,58,32,68,65,83,83,76,0,0,0,37,53,100,32,115,116,101,112,115,32,116,97,107,101,110,0,37,53,100,32,99,97,108,108,115,32,111,102,32,102,117,110,99,116,105,111,110,79,68,69,0,0,0,0,0,0,0,0,37,53,100,32,101,118,97,108,117,97,116,105,111,110,115,32,111,102,32,106,97,99,111,98,105,97,110,0,0,0,0,0,37,53,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,0,37,53,100,32,99,111,110,118,101,114,103,101,110,99,101,32,116,101,115,116,32,102,97,105,108,117,114,101,115,0,0,0,115,111,108,118,101,114,0,0,115,111,114,114,121,32,45,32,110,111,32,115,111,108,118,101,114,32,115,116,97,116,105,115,116,105,99,115,32,97,118,97,105,108,97,98,108,101,46,32,91,110,111,116,32,121,101,116,32,105,109,112,108,101,109,101,110,116,101,100,93,0,0,0,35,35,35,32,69,78,68,32,83,84,65,84,73,83,84,73,67,83,32,35,35,35,0,0,83,117,110,100,105,97,108,47,107,105,110,115,111,108,32,105,115,32,110,101,101,100,101,100,32,98,117,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,46,32,80,108,101,97,115,101,32,99,104,111,111,115,101,32,111,116,104,101,114,32,115,111,108,118,101,114,46,0,73,112,111,112,116,32,105,115,32,110,101,101,100,101,100,32,98,117,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,46,0,0,0,0,0,0,105,110,108,105,110,101,45,101,117,108,101,114,0,0,0,0,82,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,105,110,108,105,110,101,45,101,117,108,101,114,44,32,98,117,116,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,32,119,97,115,32,110,111,116,32,99,111,109,112,105,108,101,100,32,119,105,116,104,32,115,117,112,112,111,114,116,32,102,111,114,32,105,116,46,32,67,111,109,112,105,108,101,32,119,105,116,104,32,45,68,95,79,77,67,95,73,78,76,73,78,69,95,69,85,76,69,82,46,0,0,0,0,0,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,0,82,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,44,32,98,117,116,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,32,119,97,115,32,110,111,116,32,99,111,109,112,105,108,101,100,32,119,105,116,104,32,115,117,112,112,111,114,116,32,102,111,114,32,105,116,46,32,67,111,109,112,105,108,101,32,119,105,116,104,32,45,68,95,79,77,67,95,73,78,76,73,78,69,95,82,75,46,0,0,0,83,116,97,114,116,32,110,117,109,101,114,105,99,97,108,32,115,111,108,118,101,114,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,0,0,44,0,0,0,0,0,0,0,116,105,109,101,61,37,46,50,48,103,0,0,0,0,0,0,44,37,115,61,37,46,50,48,103,0,0,0,0,0,0,0,44,37,115,61,37,108,105,0,44,37,115,61,37,105,0,0,44,37,115,61,34,37,115,34,0,0,0,0,0,0,0,0,99,97,110,32,110,111,116,32,105,110,105,116,105,97,108,122,101,32,74,97,99,111,98,105,97,110,115,32,102,111,114,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,106,97,99,111,98,105,97,110,32,37,100,120,37,100,32,91,105,100,58,32,37,108,100,93,0,0,0,0,0,0,0,0,37,115,37,46,53,101,32,0,37,115,0,0,0,0,0,0,69,114,114,111,114,44,32,115,105,110,103,117,108,97,114,32,74,97,99,111,98,105,97,110,32,102,111,114,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,32,97,116,32,116,105,109,101,32,37,102,10,85,115,101,32,45,108,118,32,76,79,71,95,68,83,83,95,74,65,67,32,116,111,32,103,101,116,32,116,104,101,32,74,97,99,111,98,105,97,110,0,115,101,108,101,99,116,32,110,101,119,32,115,116,97,116,101,115,32,97,116,32,116,105,109,101,32,37,102,0,0,0,0,115,101,108,101,99,116,32,37,115,0,0,0,0,0,0,0,101,120,116,101,114,110,97,108,73,110,112,117,116,46,99,115,118,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,37,108,102,0,0,0,0,0,10,69,120,116,101,114,110,97,108,32,73,110,112,117,116,0,10,73,110,112,117,116,58,32,116,61,37,102,32,32,32,9,0,0,0,0,0,0,0,0,117,37,100,40,116,41,61,32,37,102,32,9,0,0,0,0,10,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,0,0,0,0,0,0,0,101,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,121,115,116,101,109,32,111,102,32,105,110,105,116,105,97,108,32,101,113,117,97,116,105,111,110,115,32,97,114,101,32,110,111,116,32,99,111,110,115,105,115,116,101,110,116,10,40,108,101,97,115,116,32,115,113,117,97,114,101,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,32,105,115,32,37,103,41,0,0,0,0,0,114,101,115,105,100,117,97,108,91,37,108,100,93,32,61,32,37,103,0,0,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,115,116,97,116,117,115,0,0,0,108,101,97,115,116,32,115,113,117,97,114,101,32,118,97,108,117,101,58,32,37,103,32,91,115,99,97,108,101,100,58,32,37,103,93,0,0,0,0,0,108,101,97,115,116,32,115,113,117,97,114,101,32,118,97,108,117,101,58,32,37,103,0,0,117,110,102,105,120,101,100,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,112,97,114,97,109,101,116,101,114,41,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,0,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,112,97,114,97,109,101,116,101,114,41,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,100,105,115,99,114,101,116,101,41,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,100,105,115,99,114,101,116,101,41,0,0,0,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,0,35,35,35,32,83,79,76,85,84,73,79,78,32,79,70,32,84,72,69,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,115,116,97,116,101,115,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,32,40,112,114,101,58,32,37,103,41,0,0,0,0,0,0,100,101,114,105,118,97,116,105,118,101,115,32,118,97,114,105,97,98,108,101,115,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,32,61,32,37,103,32,40,112,114,101,58,32,37,103,41,0,0,0,0,111,116,104,101,114,32,114,101,97,108,32,118,97,114,105,97,98,108,101,115,0,0,0,0,105,110,116,101,103,101,114,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,73,110,116,101,103,101,114,32,37,115,40,115,116,97,114,116,61,37,108,100,41,32,61,32,37,108,100,32,40,112,114,101,58,32,37,108,100,41,0,0,0,0,98,111,111,108,101,97,110,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,66,111,111,108,101,97,110,32,37,115,40,115,116,97,114,116,61,37,115,41,32,61,32,37,115,32,40,112,114,101,58,32,37,115,41,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,115,116,114,105,110,103,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,91,37,108,100,93,32,83,116,114,105,110,103,32,37,115,40,115,116,97,114,116,61,34,37,115,34,41,32,61,32,34,37,115,34,32,40,112,114,101,58,32,34,37,115,34,41,0,0,35,35,35,32,83,84,65,82,84,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,0,0,56,191,3,0,0,193,3,0,8,193,3,0,16,193,3,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,105,105,109,32,37,115,0,0,0,0,0,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,124,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,56,191,3,0,64,192,3,0,144,192,3,0,192,192,3,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,56,191,3,0,0,192,3,0,8,192,3,0,16,192,3,0,32,192,3,0,40,192,3,0,56,192,3,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,105,111,109,32,37,115,0,0,0,0,0,56,191,3,0,64,191,3,0,88,191,3,0,104,191,3,0,176,191,3,0,192,191,3,0,224,191,3,0,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,109,101,116,104,111,100,58,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,32,109,101,116,104,111,100,58,32,32,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,111,112,116,105,111,110,32,45,105,105,109,0,35,35,35,32,69,78,68,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,37,115,95,104,111,109,111,116,111,112,121,46,99,115,118,0,119,116,0,0,0,0,0,0,37,115,44,0,0,0,0,0,108,97,109,98,100,97,0,0,104,111,109,111,116,111,112,121,32,112,114,111,99,101,115,115,0,0,0,0,0,0,0,0,108,97,109,98,100,97,32,61,32,37,103,32,100,111,110,101,0,0,0,0,0,0,0,0,37,46,49,54,103,44,0,0,67,97,110,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,117,110,105,113,117,101,32,116,104,101,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,46,32,85,115,101,32,45,108,118,32,76,79,71,95,68,83,83,32,116,111,32,115,101,101,32,116,104,101,32,115,119,105,116,99,104,105,110,103,32,115,116,97,116,101,32,115,101,116,46,0,0,0,110,111,32,118,97,114,105,97,98,108,101,115,32,116,111,32,105,110,105,116,105,97,108,105,122,101,0,0,0,0,0,0,110,111,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,32,40,110,101,105,116,104,101,114,32,105,110,105,116,105,97,108,32,101,113,117,97,116,105,111,110,115,32,110,111,114,32,105,110,105,116,105,97,108,32,97,108,103,111,114,105,116,104,109,115,41,0,117,110,100,101,114,45,100,101,116,101,114,109,105,110,101,100,0,0,0,0,0,0,0,0,115,101,116,116,105,110,103,32,102,105,120,101,100,61,116,114,117,101,32,102,111,114,58,0,37,115,40,102,105,120,101,100,61,116,114,117,101,41,32,61,32,37,103,0,0,0,0,0,110,111,32,105,110,105,116,105,97,108,32,118,97,108,117,101,115,32,116,111,32,99,97,108,99,117,108,97,116,101,0,0,111,118,101,114,45,100,101,116,101,114,109,105,110,101,100,0,115,116,97,114,116,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,0,0,115,107,105,112,32,119,47,111,32,115,99,97,108,105,110,103,0,0,0,0,0,0,0,0,35,35,35,32,70,73,78,65,76,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,82,69,83,85,76,84,83,32,35,35,35,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,45,110,114,46,32,37,108,100,0,0,117,110,115,117,112,112,111,114,116,101,100,32,111,112,116,105,111,110,32,45,105,111,109,0,117,112,100,97,116,105,110,103,32,98,101,115,116,90,0,0,110,111,116,32,117,112,100,97,116,105,110,103,32,98,101,115,116,90,0,0,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,45,99,97,108,108,115,58,32,37,108,100,0,117,110,107,110,111,119,110,0,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,0,0,0,0,0,0,66,114,101,110,116,39,115,32,109,101,116,104,111,100,0,0,69,120,116,101,110,100,101,100,32,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,32,40,115,101,101,32,45,105,108,115,32,102,111,114,32,103,108,111,98,97,108,32,104,111,109,111,116,111,112,121,41,32,45,32,100,101,102,97,117,108,116,0,0,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,73,110,116,101,114,105,111,114,32,80,111,105,110,116,32,79,80,84,105,109,105,122,101,114,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,0,110,101,119,117,111,97,0,0,110,101,108,100,101,114,95,109,101,97,100,95,101,120,0,0,107,105,110,115,111,108,0,0,107,105,110,115,111,108,95,115,99,97,108,101,100,0,0,0,105,112,111,112,116,0,0,0,115,101,116,115,32,97,108,108,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,105,114,32,115,116,97,114,116,32,118,97,108,117,101,115,32,97,110,100,32,115,107,105,112,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,99,101,115,115,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,110,117,109,101,114,105,99,97,108,108,121,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,115,121,109,98,111,108,105,99,97,108,108,121,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,110,117,109,101,114,105,99,0,115,121,109,98,111,108,105,99,0,0,0,0,0,0,0,0,105,109,112,111,114,116,32,115,116,97,114,116,32,118,97,108,117,101,115,10,102,105,108,101,58,32,37,115,10,116,105,109,101,58,32,37,103,0,0,0,117,110,97,98,108,101,32,116,111,32,114,101,97,100,32,105,110,112,117,116,45,102,105,108,101,32,60,37,115,62,32,91,37,115,93,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,118,97,114,105,97,98,108,101,115,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,103,41,0,0,36,90,69,82,79,46,0,0,36,112,68,69,82,46,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,114,101,97,108,32,118,97,114,105,97,98,108,101,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,114,101,97,108,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,100,105,115,99,114,101,116,101,0,0,0,0,105,109,112,111,114,116,32,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,108,100,41,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,105,109,112,111,114,116,32,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,115,41,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,100,101,114,40,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,105,110,105,116,105,97,108,32,112,114,111,98,108,101,109,58,0,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,117,110,102,105,120,101,100,32,118,97,114,105,97,98,108,101,115,58,32,32,37,108,100,32,40,37,108,100,32,115,116,97,116,101,115,32,43,32,37,108,100,32,112,97,114,97,109,101,116,101,114,115,32,43,32,37,108,100,32,100,105,115,99,114,101,116,101,32,114,101,97,108,115,41,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,91,37,108,100,93,32,100,105,115,99,114,101,116,101,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,58,32,32,37,108,100,32,40,37,108,100,32,101,113,117,97,116,105,111,110,115,32,43,32,37,108,100,32,97,108,103,111,114,105,116,104,109,115,41,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,115,116,97,114,116,32,118,97,108,117,101,32,114,101,115,105,100,117,97,108,115,58,32,37,108,100,0,0,0,0,91,37,108,100,93,32,114,101,115,105,100,117,97,108,32,105,115,32,105,110,101,102,102,101,99,116,105,118,101,32,40,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,32,105,115,32,115,101,116,32,116,111,32,49,46,48,41,0,0,0,0,0,0,0,110,111,32,105,112,111,112,116,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,0,0,110,111,32,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,95,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,124,32,82,101,115,117,108,116,32,111,102,32,108,101,97,115,116,83,113,117,97,114,101,32,109,101,116,104,111,100,32,61,32,37,103,46,32,84,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,105,116,115,32,116,111,32,116,104,101,32,115,121,115,116,101,109,0,0,0,0,0,0,0,0,108,101,97,115,116,83,113,117,97,114,101,61,37,103,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,111,108,118,101,114,32,105,116,101,114,97,116,101,100,32,37,100,32,116,105,109,101,115,32,119,105,116,104,111,117,116,32,102,105,110,100,105,110,103,32,97,32,115,111,108,117,116,105,111,110,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,73,110,99,111,110,115,105,115,116,101,110,116,32,105,110,105,116,105,97,108,32,99,111,110,100,105,116,105,111,110,115,46,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,78,117,109,98,101,114,32,111,102,32,105,110,105,116,105,97,108,32,118,97,108,117,101,115,32,116,111,32,99,97,108,99,117,108,97,116,101,32,60,32,49,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,73,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,78,76,79,79,80,32,60,32,49,46,0,0,0,0,0,78,101,108,100,101,114,77,101,97,100,79,112,116,105,109,105,122,97,116,105,111,110,0,0,105,116,101,114,97,116,105,111,110,115,58,32,37,108,100,0,116,114,121,32,45,105,108,115,32,116,111,32,97,99,116,105,118,97,116,101,32,115,116,97,114,116,32,118,97,108,117,101,32,104,111,109,111,116,111,112,121,0,0,0,0,0,0,0,37,115,95,105,110,105,116,80,97,116,104,46,99,115,118,0,119,116,0,0,0,0,0,0,37,115,44,0,0,0,0,0,105,116,101,114,97,116,105,111,110,0,0,0,0,0,0,0,108,97,109,98,100,97,0,0,37,108,100,44,0,0,0,0,37,46,49,54,103,44,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,108,97,109,98,100,97,32,105,115,32,37,45,51,103,32,105,110,32,115,116,101,112,61,37,54,100,32,97,116,32,102,61,37,103,32,91,37,103,93,0,105,110,99,114,101,97,115,105,110,103,32,108,97,109,98,100,97,32,116,111,32,37,45,51,103,32,105,110,32,115,116,101,112,32,37,54,100,32,97,116,32,102,61,37,103,0,0,0,102,120,114,32,61,32,37,103,0,0,0,0,0,0,0,0,102,120,107,32,61,32,37,103,0,0,0,0,0,0,0,0,117,110,100,101,102,105,110,101,100,32,101,114,114,111,114,32,105,110,32,78,101,108,100,101,114,77,101,97,100,79,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,37,46,49,54,103,44,0,0,37,105,44,0,0,0,0,0,34,37,115,34,44,0,0,0,119,0,0,0,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,99,114,101,97,116,101,32,111,117,116,112,117,116,32,102,105,108,101,58,32,91,37,115,93,32,98,101,99,97,117,115,101,32,111,102,32,37,115,0,0,116,105,109,101,0,0,0,0,36,99,112,117,84,105,109,101,0,0,0,0,0,0,0,0,100,97,116,97,95,49,0,0,65,49,32,98,116,46,32,105,114,49,32,110,97,32,32,84,106,32,32,114,101,32,32,97,99,32,32,110,116,32,32,115,111,32,32,32,114,32,32,32,121,32,32,32,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,0,65,99,108,97,115,115,0,0,110,97,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,100,97,116,97,73,110,102,111,0,0,0,0,0,0,0,0,100,97,116,97,95,50,0,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,109,97,116,32,102,105,108,101,32,37,115,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,102,105,108,101,32,37,115,0,0,0,0,0,67,97,110,110,111,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,0,0,67,97,110,110,111,116,32,119,114,105,116,101,32,116,111,32,102,105,108,101,32,37,115,0,67,97,110,110,111,116,32,97,108,108,111,99,32,109,101,109,111,114,121,0,0,0,0,0,77,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,119,0,0,0,0,0,0,0,97,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,114,43,0,0,0,0,0,0,119,43,0,0,0,0,0,0,97,43,0,0,0,0,0,0,119,98,0,0,0,0,0,0,97,98,0,0,0,0,0,0,114,98,0,0,0,0,0,0,114,43,98,0,0,0,0,0,119,43,98,0,0,0,0,0,97,43,98,0,0,0,0,0,100,101,114,40,0,0,0,0,104,0,0,0,0,0,0,0,232,202,3,0,8,0,0,0,9,0,0,0,152,255,255,255,152,255,255,255,232,202,3,0,10,0,0,0,11,0,0,0,140,202,3,0,4,203,3,0,24,203,3,0,160,202,3,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,111,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,248,132,4,0,184,202,3,0,128,64,4,0,0,0,0,0,104,0,0,0,0,0,0,0,128,64,4,0,12,0,0,0,13,0,0,0,152,255,255,255,152,255,255,255,128,64,4,0,14,0,0,0,15,0,0,0,0,0,0,0,144,203,3,0,16,0,0,0,17,0,0,0,3,0,0,0,8,0,0,0,2,0,0,0,4,0,0,0,31,0,0,0,32,0,0,0,9,0,0,0,33,0,0,0,34,0,0,0,24,0,0,0,10,0,0,0,25,0,0,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,102,105,108,101,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,248,132,4,0,96,203,3,0,120,63,4,0,0,0,0,0,0,0,0,0,24,204,3,0,32,204,3,0,16,204,3,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,240,203,3,0,0,204,3,0,16,204,3,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,36,99,112,117,84,105,109,101,0,0,0,0,0,0,0,0,99,112,117,32,116,105,109,101,32,91,115,93,0,0,0,0,0,0,0,0,0,0,0,0,116,105,109,101,0,0,0,0,83,105,109,117,108,97,116,105,111,110,32,116,105,109,101,32,91,115,93,0,0,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,111,102,32,115,105,122,101,32,37,108,100,0,0,0,0,0,65,117,116,111,109,97,116,105,99,32,111,117,116,112,117,116,32,115,116,101,112,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,105,110,32,79,112,101,110,77,111,100,101,108,105,99,97,32,121,101,116,46,32,83,101,116,32,110,117,109,112,111,105,110,116,115,32,62,61,32,48,46,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,111,102,32,115,105,122,101,32,37,108,100,32,102,97,105,108,101,100,0,0,0,0,0,0,119,0,0,0,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,99,114,101,97,116,101,32,111,117,116,112,117,116,32,102,105,108,101,58,32,91,37,115,93,32,98,101,99,97,117,115,101,32,111,102,32,37,115,0,0,35,80,116,111,108,101,109,121,32,80,108,111,116,32,102,105,108,101,44,32,103,101,110,101,114,97,116,101,100,32,98,121,32,79,112,101,110,77,111,100,101,108,105,99,97,10,0,0,35,78,117,109,98,101,114,111,102,86,97,114,105,97,98,108,101,115,61,37,100,10,0,0,35,73,110,116,101,114,118,97,108,83,105,122,101,61,37,108,100,10,0,0,0,0,0,0,84,105,116,108,101,84,101,120,116,58,32,79,112,101,110,77,111,100,101,108,105,99,97,32,115,105,109,117,108,97,116,105,111,110,32,112,108,111,116,10,0,0,0,0,0,0,0,0,88,76,97,98,101,108,58,32,116,10,10,0,0,0,0,0,68,97,116,97,83,101,116,58,32,116,105,109,101,10,0,0,68,97,116,97,83,101,116,58,32,36,99,112,117,84,105,109,101,10,0,0,0,0,0,0,68,97,116,97,83,101,116,58,32,37,115,10,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,119,114,105,116,101,32,116,111,32,111,117,116,112,117,116,32,102,105,108,101,32,37,115,10,0,0,0,0,0,0,0,0,37,46,49,54,103,44,32,37,46,49,54,103,10,0,0,0,114,101,99,111,110,58,119,97,108,108,58,118,48,49,0,0,0,0,0,0,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,109,97,116,32,102,105,108,101,32,37,115,0,112,97,114,97,109,115,0,0,99,111,110,116,105,110,117,111,117,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,109,101,116,97,0,0,0,116,97,98,115,0,0,0,0,111,98,106,115,0,0,0,0,116,109,101,116,97,0,0,0,115,105,103,115,0,0,0,0,116,105,109,101,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,118,109,101,116,97,0,0,0,84,105,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,97,108,115,0,0,0,0,0,115,0,0,0,0,0,0,0,116,0,0,0,0,0,0,0,105,110,118,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,110,97,109,101,0,0,0,0,118,97,108,117,101,82,101,102,101,114,101,110,99,101,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,102,105,108,101,78,97,109,101,0,0,0,0,0,0,0,0,115,116,97,114,116,76,105,110,101,0,0,0,0,0,0,0,115,116,97,114,116,67,111,108,117,109,110,0,0,0,0,0,101,110,100,76,105,110,101,0,101,110,100,67,111,108,117,109,110,0,0,0,0,0,0,0,102,105,108,101,87,114,105,116,97,98,108,101,0,0,0,0,117,115,101,83,116,97,114,116,0,0,0,0,0,0,0,0,115,116,97,114,116,0,0,0,102,105,120,101,100,0,0,0,117,115,101,78,111,109,105,110,97,108,0,0,0,0,0,0,110,111,109,105,110,97,108,0,109,105,110,0,0,0,0,0,109,97,120,0,0,0,0,0,82,101,97,108,32,37,115,40,37,115,115,116,97,114,116,61,37,103,37,115,44,32,102,105,120,101,100,61,37,115,44,32,37,115,110,111,109,105,110,97,108,61,37,103,37,115,44,32,109,105,110,61,37,103,44,32,109,97,120,61,37,103,41,0,0,0,0,0,0,0,0,0,123,0,0,0,0,0,0,0,125,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,73,110,116,101,103,101,114,32,37,115,40,37,115,115,116,97,114,116,61,37,108,100,37,115,44,32,102,105,120,101,100,61,37,115,44,32,109,105,110,61,37,108,100,44,32,109,97,120,61,37,108,100,41,0,0,0,66,111,111,108,101,97,110,32,37,115,40,37,115,115,116,97,114,116,61,37,115,37,115,44,32,102,105,120,101,100,61,37,115,41,0,0,0,0,0,0,83,116,114,105,110,103,32,37,115,40,37,115,115,116,97,114,116,61,37,115,37,115,41,0,95,105,110,105,116,46,120,109,108,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,99,97,110,32,110,111,116,32,114,101,97,100,32,102,105,108,101,32,37,115,32,97,115,32,115,101,116,117,112,32,102,105,108,101,32,116,111,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,99,111,100,101,46,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,99,111,117,108,100,110,39,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,32,102,111,114,32,116,104,101,32,88,77,76,32,112,97,114,115,101,114,33,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,102,105,108,101,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,10,0,0,0,0,0,0,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,37,115,44,32,37,115,32,37,108,117,10,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,100,97,116,97,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,10,0,0,0,0,0,0,0,0,103,117,105,100,0,0,0,0,84,104,101,32,77,111,100,101,108,32,71,85,73,68,58,32,37,115,32,105,115,32,110,111,116,32,115,101,116,32,105,110,32,102,105,108,101,58,32,37,115,0,0,0,0,0,0,0,69,114,114,111,114,44,32,116,104,101,32,71,85,73,68,58,32,37,115,32,102,114,111,109,32,105,110,112,117,116,32,100,97,116,97,32,102,105,108,101,58,32,37,115,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,104,101,32,71,85,73,68,32,99,111,109,112,105,108,101,100,32,105,110,32,116,104,101,32,109,111,100,101,108,58,32,37,115,0,0,114,101,97,100,32,97,108,108,32,116,104,101,32,68,101,102,97,117,108,116,69,120,112,101,114,105,109,101,110,116,32,118,97,108,117,101,115,58,0,0,115,116,97,114,116,84,105,109,101,0,0,0,0,0,0,0,115,116,97,114,116,84,105,109,101,32,61,32,37,103,0,0,115,116,111,112,84,105,109,101,0,0,0,0,0,0,0,0,115,116,111,112,84,105,109,101,32,61,32,37,103,0,0,0,115,116,101,112,83,105,122,101,0,0,0,0,0,0,0,0,115,116,101,112,83,105,122,101,32,61,32,37,103,0,0,0,116,111,108,101,114,97,110,99,101,0,0,0,0,0,0,0,116,111,108,101,114,97,110,99,101,32,61,32,37,103,0,0,115,111,108,118,101,114,0,0,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,0,0,0,0,0,0,0,111,117,116,112,117,116,70,111,114,109,97,116,0,0,0,0,111,117,116,112,117,116,32,102,111,114,109,97,116,58,32,37,115,0,0,0,0,0,0,0,118,97,114,105,97,98,108,101,70,105,108,116,101,114,0,0,118,97,114,105,97,98,108,101,32,102,105,108,116,101,114,58,32,37,115,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,0,0,0,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,58,32,37,115,0,0,0,0,110,117,109,98,101,114,79,102,67,111,110,116,105,110,117,111,117,115,83,116,97,116,101,115,0,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,82,101,97,108,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,110,117,109,98,101,114,79,102,82,101,97,108,80,97,114,97,109,101,116,101,114,115,0,0,110,117,109,98,101,114,79,102,73,110,116,101,103,101,114,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,73,110,116,101,103,101,114,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,66,111,111,108,101,97,110,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,66,111,111,108,101,97,110,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,83,116,114,105,110,103,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,83,116,114,105,110,103,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,69,114,114,111,114,44,32,105,110,112,117,116,32,100,97,116,97,32,102,105,108,101,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,109,111,100,101,108,46,0,0,0,0,110,120,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,100,0,0,0,0,0,0,0,110,121,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,0,0,0,110,112,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,0,0,0,110,112,105,110,116,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,121,105,110,116,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,112,98,111,111,108,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,110,121,98,111,111,108,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,110,112,115,116,114,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,121,115,116,114,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,37,115,0,0,0,0,114,101,97,108,32,115,116,97,116,101,115,0,0,0,0,0,105,115,80,114,111,116,101,99,116,101,100,0,0,0,0,0,102,105,108,116,101,114,105,110,103,32,112,114,111,116,101,99,116,101,100,32,118,97,114,105,97,98,108,101,32,37,115,0,114,101,97,108], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+241732);
/* memory initializer */ allocate([32,115,116,97,116,101,32,100,101,114,105,118,97,116,105,118,101,115,0,0,114,101,97,108,32,97,108,103,101,98,114,97,105,99,115,0,105,110,116,101,103,101,114,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,98,111,111,108,101,97,110,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,115,116,114,105,110,103,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,115,116,114,105,110,103,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,114,101,97,108,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,0,0,0,97,108,105,97,115,0,0,0,110,101,103,97,116,101,100,65,108,105,97,115,0,0,0,0,114,101,97,100,32,102,111,114,32,37,115,32,110,101,103,97,116,101,100,32,37,100,32,102,114,111,109,32,115,101,116,117,112,32,102,105,108,101,0,0,97,108,105,97,115,86,97,114,105,97,98,108,101,0,0,0,116,105,109,101,0,0,0,0,82,101,97,108,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,0,0,0,32,110,111,116,32,102,111,117,110,100,46,0,0,0,0,0,37,115,0,0,0,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,105,110,116,101,103,101,114,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,73,110,116,101,103,101,114,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,98,111,111,108,101,97,110,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,66,111,111,108,101,97,110,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,115,116,114,105,110,103,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,0,83,116,114,105,110,103,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,117,115,97,103,101,32,101,114,114,111,114,32,121,111,117,32,99,97,110,110,111,116,32,104,97,118,101,32,98,111,116,104,32,45,111,118,101,114,114,105,100,101,32,97,110,100,32,45,111,118,101,114,114,105,100,101,70,105,108,101,32,97,99,116,105,118,101,32,97,116,32,116,104,101,32,115,97,109,101,32,116,105,109,101,46,32,115,101,101,32,77,111,100,101,108,32,45,63,32,102,111,114,32,109,111,114,101,32,105,110,102,111,33,0,0,0,0,0,114,101,97,100,32,111,118,101,114,114,105,100,101,32,118,97,108,117,101,115,32,102,114,111,109,32,102,105,108,101,58,32,37,115,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,99,111,117,108,100,32,110,111,116,32,111,112,101,110,32,116,104,101,32,102,105,108,101,32,103,105,118,101,110,32,116,111,32,45,111,118,101,114,114,105,100,101,70,105,108,101,61,37,115,0,0,0,0,0,44,0,0,0,0,0,0,0,114,101,97,100,32,111,118,101,114,114,105,100,101,32,118,97,108,117,101,115,58,32,37,115,0,0,0,0,0,0,0,0,61,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,32,37,115,32,61,32,37,115,0,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,32,100,111,110,101,33,0,0,78,79,32,111,118,101,114,114,105,100,101,32,103,105,118,101,110,32,111,110,32,116,104,101,32,99,111,109,109,97,110,100,32,108,105,110,101,46,0,0,108,0,0,0,0,0,0,0,112,220,3,0,18,0,0,0,19,0,0,0,148,255,255,255,148,255,255,255,112,220,3,0,20,0,0,0,21,0,0,0,20,220,3,0,140,220,3,0,160,220,3,0,40,220,3,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,105,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,248,132,4,0,64,220,3,0,240,63,4,0,0,0,0,0,108,0,0,0,0,0,0,0,240,63,4,0,22,0,0,0,23,0,0,0,148,255,255,255,148,255,255,255,240,63,4,0,24,0,0,0,25,0,0,0,101,114,114,111,114,32,114,101,97,100,95,118,97,108,117,101,44,32,110,111,32,100,97,116,97,32,97,108,108,111,99,97,116,101,100,32,102,111,114,32,115,116,111,114,105,110,103,32,115,116,114,105,110,103,0,0,102,109,105,77,111,100,101,108,68,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,68,101,102,97,117,108,116,69,120,112,101,114,105,109,101,110,116,0,0,0,0,0,0,0,83,99,97,108,97,114,86,97,114,105,97,98,108,101,0,0,99,108,97,115,115,73,110,100,101,120,0,0,0,0,0,0,99,108,97,115,115,84,121,112,101,0,0,0,0,0,0,0,114,83,116,97,0,0,0,0,114,68,101,114,0,0,0,0,114,65,108,103,0,0,0,0,114,80,97,114,0,0,0,0,114,65,108,105,0,0,0,0,105,65,108,103,0,0,0,0,105,80,97,114,0,0,0,0,105,65,108,105,0,0,0,0,98,65,108,103,0,0,0,0,98,80,97,114,0,0,0,0,98,65,108,105,0,0,0,0,115,65,108,103,0,0,0,0,115,80,97,114,0,0,0,0,115,65,108,105,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,101,114,114,111,114,32,114,101,97,100,105,110,103,32,116,104,101,32,120,109,108,32,102,105,108,101,44,32,102,111,117,110,100,32,117,110,107,110,111,119,110,32,99,108,97,115,115,58,32,37,115,32,32,102,111,114,32,118,97,114,105,97,98,108,101,58,32,37,115,0,82,101,97,108,0,0,0,0,73,110,116,101,103,101,114,0,66,111,111,108,101,97,110,0,83,116,114,105,110,103,0,0,118,97,114,105,97,98,108,101,84,121,112,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,76,79,71,95,65,76,76,0,44,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,37,45,49,56,115,32,91,37,115,93,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,108,118,32,37,115,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,110,108,115,61,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,108,97,112,97,99,107,0,0,108,105,115,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,108,115,32,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,0,0,0,100,101,102,97,117,108,116,32,109,101,116,104,111,100,0,0,76,105,115,0,0,0,0,0,94,40,0,0,0,0,0,0,41,36,0,0,0,0,0,0,36,100,117,109,109,121,0,0,46,42,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,111,109,112,105,108,101,32,114,101,103,117,108,97,114,32,101,120,112,114,101,115,115,105,111,110,58,32,0,0,32,119,105,116,104,32,101,114,114,111,114,58,32,0,0,0,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,111,117,116,112,117,116,116,105,110,103,32,97,108,108,32,118,97,114,105,97,98,108,101,115,46,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,73,110,116,101,114,118,97,108,115,32,61,32,37,108,100,0,67,80,85,0,0,0,0,0,82,84,0,0,0,0,0,0,67,89,67,0,0,0,0,0,91,117,110,107,110,111,119,110,32,99,108,111,99,107,45,116,121,112,101,93,32,103,111,116,32,37,115,44,32,101,120,112,101,99,116,101,100,32,67,80,85,124,82,84,124,67,89,67,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,82,84,46,0,0,0,0,0,67,104,111,115,101,110,32,99,108,111,99,107,45,116,121,112,101,58,32,37,115,32,110,111,116,32,97,118,97,105,108,97,98,108,101,32,102,111,114,32,116,104,101,32,99,117,114,114,101,110,116,32,112,108,97,116,102,111,114,109,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,114,101,97,108,45,116,105,109,101,46,0,0,76,105,110,101,97,114,105,122,97,116,105,111,110,32,119,105,108,108,32,112,101,114,102,111,114,109,101,100,32,97,116,32,112,111,105,110,116,32,111,102,32,116,105,109,101,58,32,37,102,0,0,0,0,0,0,0,111,118,101,114,119,114,105,116,101,32,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,32,91,102,114,111,109,32,99,111,109,109,97,110,100,32,108,105,110,101,93,0,95,114,101,115,46,0,0,0,0,0,0,0,0,0,0,0,76,105,110,101,97,114,32,109,111,100,101,108,32,105,115,32,99,114,101,97,116,101,100,33,0,0,0,0,0,0,0,0,95,112,114,111,102,46,120,109,108,0,0,0,0,0,0,0,95,112,114,111,102,46,112,108,116,0,0,0,0,0,0,0,115,118,103,0,0,0,0,0,101,109,112,116,121,0,0,0,99,115,118,0,0,0,0,0,109,97,116,0,0,0,0,0,119,97,108,108,0,0,0,0,112,108,116,0,0,0,0,0,85,110,107,110,111,119,110,32,111,117,116,112,117,116,32,102,111,114,109,97,116,58,32,0,65,108,108,111,99,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,115,116,111,114,97,103,101,32,102,111,114,32,109,101,116,104,111,100,32,39,37,115,39,32,97,110,100,32,102,105,108,101,61,39,37,115,39,0,0,168,230,3,0,144,232,3,0,152,232,3,0,224,234,3,0,248,232,3,0,8,233,3,0,232,234,3,0,240,234,3,0,248,234,3,0,0,235,3,0,16,235,3,0,32,235,3,0,48,235,3,0,64,235,3,0,80,235,3,0,96,235,3,0,112,235,3,0,136,235,3,0,192,234,3,0,216,234,3,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,115,32,37,115,0,0,0,0,0,0,0,168,230,3,0,144,232,3,0,152,232,3,0,168,232,3,0,248,232,3,0,8,233,3,0,24,233,3,0,56,233,3,0,88,233,3,0,120,233,3,0,160,233,3,0,200,233,3,0,240,233,3,0,24,234,3,0,48,234,3,0,80,234,3,0,112,234,3,0,152,234,3,0,192,234,3,0,216,234,3,0,114,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,37,115,0,0,0,117,115,97,103,101,58,32,37,115,0,0,0,0,0,0,0,60,45,37,115,62,10,32,32,37,115,0,0,0,0,0,0,60,45,37,115,61,118,97,108,117,101,62,32,111,114,32,60,45,37,115,32,118,97,108,117,101,62,10,32,32,37,115,0,91,117,110,107,110,111,119,110,32,102,108,97,103,45,116,121,112,101,93,32,60,45,37,115,62,0,0,0,0,0,0,0,120,109,108,0,0,0,0,0,116,101,120,116,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,45,108,111,103,70,111,114,109,97,116,61,37,115,44,32,101,120,112,101,99,116,101,100,32,116,101,120,116,32,111,114,32,120,109,108,0,0,0,0,0,0,0,0,100,101,116,97,105,108,101,100,32,102,108,97,103,45,100,101,115,99,114,105,112,116,105,111,110,32,102,111,114,58,32,60,45,37,115,62,10,37,115,0,100,101,116,97,105,108,101,100,32,102,108,97,103,45,100,101,115,99,114,105,112,116,105,111,110,32,102,111,114,58,32,60,45,37,115,61,118,97,108,117,101,62,32,111,114,32,60,45,37,115,32,118,97,108,117,101,62,10,37,115,0,0,0,0,168,230,3,0,112,232,3,0,120,232,3,0,128,232,3,0,168,230,3,0,176,231,3,0,0,232,3,0,48,232,3,0,168,230,3,0,112,231,3,0,120,231,3,0,128,231,3,0,144,231,3,0,152,231,3,0,168,231,3,0,0,0,0,0,168,230,3,0,176,230,3,0,200,230,3,0,216,230,3,0,32,231,3,0,48,231,3,0,80,231,3,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,45,104,101,108,112,61,37,115,0,0,0,117,115,101,32,37,115,32,45,104,101,108,112,32,102,111,114,32,97,32,108,105,115,116,32,111,102,32,97,108,108,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,115,0,0,0,0,0,0,0,69,114,114,111,114,58,32,67,111,117,108,100,32,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,116,104,101,32,103,108,111,98,97,108,32,100,97,116,97,32,115,116,114,117,99,116,117,114,101,32,102,105,108,101,0,0,0,0,0,0,78,111,32,118,97,114,105,97,98,108,101,115,32,105,110,32,116,104,101,32,109,111,100,101,108,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,109,111,100,101,108,62,37,115,60,47,109,111,100,101,108,62,10,0,0,0,0,0,0,60,99,117,114,114,101,110,116,83,116,101,112,83,105,122,101,62,37,103,60,47,99,117,114,114,101,110,116,83,116,101,112,83,105,122,101,62,10,0,0,60,111,108,100,84,105,109,101,62,37,46,49,50,103,60,47,111,108,100,84,105,109,101,62,10,0,0,0,0,0,0,0,60,111,108,100,84,105,109,101,50,62,37,46,49,50,103,60,47,111,108,100,84,105,109,101,50,62,10,0,0,0,0,0,60,100,105,102,102,79,108,100,84,105,109,101,62,37,103,60,47,100,105,102,102,79,108,100,84,105,109,101,62,10,0,0,60,99,117,114,114,101,110,116,84,105,109,101,62,37,103,60,47,99,117,114,114,101,110,116,84,105,109,101,62,10,0,0,60,100,105,102,102,67,117,114,114,101,110,116,84,105,109,101,62,37,103,60,47,100,105,102,102,67,117,114,114,101,110,116,84,105,109,101,62,10,0,0,5,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,26,0,0,0,0,0,0,0,65,115,115,101,114,116,105,111,110,32,116,114,105,103,103,101,114,101,100,32,98,121,32,101,120,116,101,114,110,97,108,32,67,32,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,87,97,114,110,105,110,103,58,32,0,0,0,0,0,0,0,69,114,114,111,114,58,32,0,85,110,104,97,110,100,108,101,100,32,65,115,115,101,114,116,105,111,110,45,69,114,114,111,114,0,0,0,0,0,0,0,117,110,107,110,111,119,110,0,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,0,0,0,0,0,0,66,114,101,110,116,39,115,32,109,101,116,104,111,100,0,0,69,120,116,101,110,100,101,100,32,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,32,40,115,101,101,32,45,105,108,115,32,102,111,114,32,103,108,111,98,97,108,32,104,111,109,111,116,111,112,121,41,32,45,32,100,101,102,97,117,108,116,0,0,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,73,110,116,101,114,105,111,114,32,80,111,105,110,116,32,79,80,84,105,109,105,122,101,114,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,0,110,101,119,117,111,97,0,0,110,101,108,100,101,114,95,109,101,97,100,95,101,120,0,0,107,105,110,115,111,108,0,0,107,105,110,115,111,108,95,115,99,97,108,101,100,0,0,0,105,112,111,112,116,0,0,0,115,101,116,115,32,97,108,108,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,105,114,32,115,116,97,114,116,32,118,97,108,117,101,115,32,97,110,100,32,115,107,105,112,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,99,101,115,115,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,110,117,109,101,114,105,99,97,108,108,121,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,115,121,109,98,111,108,105,99,97,108,108,121,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,110,117,109,101,114,105,99,0,115,121,109,98,111,108,105,99,0,0,0,0,0,0,0,0,101,117,108,101,114,0,0,0,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,44,32,119,105,116,104,32,105,110,116,101,114,118,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,105,110,108,105,110,101,45,101,117,108,101,114,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,114,97,100,97,117,53,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,114,97,100,97,117,51,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,114,97,100,97,117,49,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,108,111,98,97,116,116,111,50,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,52,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,54,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,100,97,115,115,108,32,102,111,114,32,100,101,98,117,103,32,112,114,111,112,111,115,101,0,100,97,115,115,108,32,119,105,116,104,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,105,110,116,101,114,110,97,108,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,0,113,115,115,0,0,0,0,0,100,97,115,115,108,0,0,0,114,97,100,97,117,53,0,0,114,97,100,97,117,51,0,0,114,97,100,97,117,49,0,0,108,111,98,97,116,116,111,50,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,52,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,54,0,0,0,0,0,0,0,0,100,97,115,115,108,119,111,114,116,0,0,0,0,0,0,0,100,97,115,115,108,116,101,115,116,0,0,0,0,0,0,0,100,97,115,115,108,83,121,109,74,97,99,0,0,0,0,0,100,97,115,115,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,67,111,108,111,114,83,121,109,74,97,99,0,0,0,0,0,0,0,0,100,97,115,115,108,73,110,116,101,114,110,97,108,78,117,109,74,97,99,0,0,0,0,0,60,115,116,97,116,117,115,62,0,0,0,0,0,0,0,0,60,112,104,97,115,101,62,85,78,75,78,79,87,78,60,47,112,104,97,115,101,62,0,0,60,47,115,116,97,116,117,115,62,0,0,0,0,0,0,0,44,0,0,0,0,0,0,0,59,0,0,0,0,0,0,0,115,101,101,100,58,32,100,97,116,97,45,62,115,105,109,117,108,97,116,105,111,110,73,110,102,111,46,97,110,97,108,121,116,105,99,74,97,99,111,98,105,97,110,115,91,105,110,100,101,120,93,46,115,101,101,100,86,97,114,115,91,37,100,93,61,32,37,102,0,0,0,0,119,114,105,116,101,32,105,110,32,106,97,99,91,37,100,93,45,91,37,100,44,37,100,93,61,37,103,32,102,114,111,109,32,114,111,119,91,37,100,93,61,37,103,0,0,0,0,0,80,114,105,110,116,32,106,97,99,58,0,0,0,0,0,0,37,32,46,53,101,32,0,0,99,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,65,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,66,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,67,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,68,32,0,0,0,0,105,32,102,111,114,32,105,32,105,110,32,49,58,48,0,0,108,105,110,101,97,114,95,0,46,109,111,0,0,0,0,0,119,98,0,0,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,0,0,0,0,0,56,0,0,0,0,0,0,0,200,237,3,0,27,0,0,0,28,0,0,0,200,255,255,255,200,255,255,255,200,237,3,0,29,0,0,0,30,0,0,0,84,237,3,0,228,237,3,0,248,237,3,0,104,237,3,0,78,83,116,51,95,95,49,49,57,98,97,115,105,99,95,111,115,116,114,105,110,103,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,248,132,4,0,128,237,3,0,128,64,4,0,0,0,0,0,56,0,0,0,0,0,0,0,128,64,4,0,12,0,0,0,13,0,0,0,200,255,255,255,200,255,255,255,128,64,4,0,14,0,0,0,15,0,0,0,0,0,0,0,136,238,3,0,31,0,0,0,32,0,0,0,4,0,0,0,11,0,0,0,3,0,0,0,6,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,36,0,0,0,34,0,0,0,26,0,0,0,10,0,0,0,27,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,105,110,103,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,0,0,0,0,248,132,4,0,64,238,3,0,120,63,4,0,0,0,0,0,67,97,108,117,99,117,108,97,116,101,32,111,110,101,32,99,111,108,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,103,110,117,112,108,111,116,0,80,108,111,116,115,32,111,102,32,112,114,111,102,105,108,105,110,103,32,100,97,116,97,32,119,101,114,101,32,100,105,115,97,98,108,101,100,58,32,37,115,10,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,37,115,58,32,37,115,10,0,0,115,101,116,32,116,101,114,109,105,110,97,108,32,115,118,103,10,0,0,0,0,0,0,0,115,101,116,32,110,111,107,101,121,10,0,0,0,0,0,0,115,101,116,32,102,111,114,109,97,116,32,121,32,34,37,103,34,10,0,0,0,0,0,0,69,120,101,99,117,116,105,111,110,32,116,105,109,101,32,111,102,32,103,108,111,98,97,108,32,115,116,101,112,115,0,0,0,0,0,0,0,0,0,0,60,33,68,79,67,84,89,80,69,32,100,111,99,32,91,32,32,60,33,69,76,69,77,69,78,84,32,115,105,109,117,108,97,116,105,111,110,32,40,109,111,100,101,108,105,110,102,111,44,32,118,97,114,105,97,98,108,101,115,44,32,102,117,110,99,116,105,111,110,115,44,32,101,113,117,97,116,105,111,110,115,41,62,32,32,60,33,65,84,84,76,73,83,84,32,118,97,114,105,97,98,108,101,32,105,100,32,73,68,32,35,82,69,81,85,73,82,69,68,62,32,32,60,33,69,76,69,77,69,78,84,32,101,113,117,97,116,105,111,110,32,40,114,101,102,115,41,62,32,32,60,33,65,84,84,76,73,83,84,32,101,113,117,97,116,105,111,110,32,105,100,32,73,68,32,35,82,69,81,85,73,82,69,68,62,32,32,60,33,69,76,69,77,69,78,84,32,112,114,111,102,105,108,101,98,108,111,99,107,115,32,40,112,114,111,102,105,108,101,98,108,111,99,107,42,41,62,32,32,60,33,69,76,69,77,69,78,84,32,112,114,111,102,105,108,101,98,108,111,99,107,32,40,114,101,102,115,44,32,110,99,97,108,108,44,32,116,105,109,101,44,32,109,97,120,84,105,109,101,41,62,32,32,60,33,69,76,69,77,69,78,84,32,114,101,102,115,32,40,114,101,102,42,41,62,32,32,60,33,65,84,84,76,73,83,84,32,114,101,102,32,114,101,102,105,100,32,73,68,82,69,70,32,35,82,69,81,85,73,82,69,68,62,32,32,93,62,10,0,0,0,0,116,105,109,101,40,41,32,102,97,105,108,101,100,58,32,37,115,0,0,0,0,0,0,0,37,89,45,37,109,45,37,100,32,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,115,116,114,102,116,105,109,101,40,41,32,102,97,105,108,101,100,0,0,0,0,0,0,0,60,115,105,109,117,108,97,116,105,111,110,62,10,0,0,0,60,109,111,100,101,108,105,110,102,111,62,10,0,0,0,0,60,110,97,109,101,62,0,0,60,47,110,97,109,101,62,10,0,0,0,0,0,0,0,0,60,112,114,101,102,105,120,62,0,0,0,0,0,0,0,0,60,47,112,114,101,102,105,120,62,10,0,0,0,0,0,0,60,100,97,116,101,62,0,0,60,47,100,97,116,101,62,10,0,0,0,0,0,0,0,0,60,109,101,116,104,111,100,62,0,0,0,0,0,0,0,0,60,47,109,101,116,104,111,100,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,70,111,114,109,97,116,62,0,0,60,47,111,117,116,112,117,116,70,111,114,109,97,116,62,10,0,0,0,0,0,0,0,0,60,111,117,116,112,117,116,70,105,108,101,110,97,109,101,62,0,0,0,0,0,0,0,0,60,47,111,117,116,112,117,116,70,105,108,101,110,97,109,101,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,70,105,108,101,115,105,122,101,62,37,108,100,60,47,111,117,116,112,117,116,70,105,108,101,115,105,122,101,62,10,0,0,0,60,111,118,101,114,104,101,97,100,84,105,109,101,62,37,102,60,47,111,118,101,114,104,101,97,100,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,112,114,101,105,110,105,116,84,105,109,101,62,37,102,60,47,112,114,101,105,110,105,116,84,105,109,101,62,10,0,0,60,105,110,105,116,84,105,109,101,62,37,102,60,47,105,110,105,116,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,101,118,101,110,116,84,105,109,101,62,37,102,60,47,101,118,101,110,116,84,105,109,101,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,84,105,109,101,62,37,102,60,47,111,117,116,112,117,116,84,105,109,101,62,10,0,0,0,0,60,108,105,110,101,97,114,105,122,101,84,105,109,101,62,37,102,60,47,108,105,110,101,97,114,105,122,101,84,105,109,101,62,10,0,0,0,0,0,0,60,116,111,116,97,108,84,105,109,101,62,37,102,60,47,116,111,116,97,108,84,105,109,101,62,10,0,0,0,0,0,0,60,116,111,116,97,108,83,116,101,112,115,84,105,109,101,62,37,102,60,47,116,111,116,97,108,83,116,101,112,115,84,105,109,101,62,10,0,0,0,0,60,110,117,109,83,116,101,112,62,37,100,60,47,110,117,109,83,116,101,112,62,10,0,0,60,109,97,120,84,105,109,101,62,37,46,57,102,60,47,109,97,120,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,47,109,111,100,101,108,105,110,102,111,62,10,0,0,0,60,109,111,100,101,108,105,110,102,111,95,101,120,116,62,10,0,0,0,0,0,0,0,0,60,111,100,101,84,105,109,101,62,37,102,60,47,111,100,101,84,105,109,101,62,10,0,0,60,111,100,101,84,105,109,101,84,105,99,107,115,62,37,108,117,60,47,111,100,101,84,105,109,101,84,105,99,107,115,62,10,0,0,0,0,0,0,0,60,47,109,111,100,101,108,105,110,102,111,95,101,120,116,62,10,0,0,0,0,0,0,0,60,112,114,111,102,105,108,105,110,103,100,97,116,97,104,101,97,100,101,114,62,10,0,0,60,47,112,114,111,102,105,108,105,110,103,100,97,116,97,104,101,97,100,101,114,62,10,0,60,118,97,114,105,97,98,108,101,115,62,10,0,0,0,0,60,47,118,97,114,105,97,98,108,101,115,62,10,0,0,0,60,102,117,110,99,116,105,111,110,115,62,10,0,0,0,0,60,47,102,117,110,99,116,105,111,110,115,62,10,0,0,0,60,101,113,117,97,116,105,111,110,115,62,10,0,0,0,0,60,47,101,113,117,97,116,105,111,110,115,62,10,0,0,0,60,112,114,111,102,105,108,101,98,108,111,99,107,115,62,10,0,0,0,0,0,0,0,0,60,47,112,114,111,102,105,108,101,98,108,111,99,107,115,62,10,0,0,0,0,0,0,0,60,47,115,105,109,117,108,97,116,105,111,110,62,10,0,0,98,117,102,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,109,111,100,101,108,105,110,102,111,46,99,0,0,112,114,105,110,116,77,111,100,101,108,73,110,102,111,0,0,87,97,114,110,105,110,103,58,32,80,108,111,116,32,99,111,109,109,97,110,100,32,102,97,105,108,101,100,10,0,0,0,120,115,108,116,112,114,111,99,0,0,0,0,0,0,0,0,37,115,32,45,111,32,37,115,95,112,114,111,102,46,104,116,109,108,32,37,115,47,115,104,97,114,101,47,111,109,99,47,115,99,114,105,112,116,115,47,100,101,102,97,117,108,116,95,112,114,111,102,105,108,105,110,103,46,120,115,108,32,37,115,95,112,114,111,102,46,120,109,108,0,0,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,32,109,105,115,115,105,110,103,0,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,103,101,110,101,114,97,116,101,32,104,116,109,108,32,118,101,114,115,105,111,110,32,111,102,32,112,114,111,102,105,108,105,110,103,32,114,101,115,117,108,116,115,58,32,37,115,10,0,0,0,0,0,0,0,84,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,97,114,101,32,115,116,111,114,101,100,32,105,110,32,37,115,95,112,114,111,102,46,104,116,109,108,32,40,104,117,109,97,110,45,114,101,97,100,97,98,108,101,41,32,97,110,100,32,37,115,95,112,114,111,102,46,120,109,108,32,40,102,111,114,32,88,83,76,32,116,114,97,110,115,102,111,114,109,115,32,111,114,32,109,111,114,101,32,100,101,116,97,105,108,115,41,0,0,0,0,0,0,101,113,0,0,0,0,0,0,60,112,114,111,102,105,108,101,98,108,111,99,107,62,10,0,60,114,101,102,32,114,101,102,105,100,61,34,101,113,37,100,34,47,62,10,0,0,0,0,60,110,99,97,108,108,62,37,100,60,47,110,99,97,108,108,62,10,0,0,0,0,0,0,60,116,105,109,101,62,37,46,57,102,60,47,116,105,109,101,62,10,0,0,0,0,0,0,60,47,112,114,111,102,105,108,101,98,108,111,99,107,62,10,0,0,0,0,0,0,0,0,60,101,113,117,97,116,105,111,110,32,105,100,61,34,101,113,37,100,34,32,110,97,109,101,61,34,0,0,0,0,0,0,34,62,10,0,0,0,0,0,60,114,101,102,115,62,10,0,60,114,101,102,32,114,101,102,105,100,61,34,118,97,114,37,100,34,32,47,62,10,0,0,60,47,114,101,102,115,62,10,0,0,0,0,0,0,0,0,60,99,97,108,99,105,110,102,111,32,116,105,109,101,61,34,37,102,34,32,99,111,117,110,116,61,34,37,108,117,34,47,62,10,0,0,0,0,0,0,60,47,101,113,117,97,116,105,111,110,62,10,0,0,0,0,102,117,110,0,0,0,0,0,60,102,117,110,99,116,105,111,110,32,105,100,61,34,102,117,110,37,100,34,62,10,0,0,60,47,102,117,110,99,116,105,111,110,62,10,0,0,0,0,60,105,110,102,111,32,102,105,108,101,110,97,109,101,61,34,0,0,0,0,0,0,0,0,34,32,115,116,97,114,116,108,105,110,101,61,34,37,100,34,32,115,116,97,114,116,99,111,108,61,34,37,100,34,32,101,110,100,108,105,110,101,61,34,37,100,34,32,101,110,100,99,111,108,61,34,37,100,34,32,114,101,97,100,111,110,108,121,61,34,37,115,34,32,47,62,10,0,0,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,119,114,105,116,97,98,108,101,0,0,0,0,0,0,0,0,60,118,97,114,105,97,98,108,101,32,105,100,61,34,118,97,114,37,100,34,32,110,97,109,101,61,34,0,0,0,0,0,34,32,99,111,109,109,101,110,116,61,34,0,0,0,0,0,60,47,118,97,114,105,97,98,108,101,62,10,0,0,0,0,37,115,95,112,114,111,102,46,100,97,116,97,0,0,0,0,60,102,105,108,101,110,97,109,101,62,0,0,0,0,0,0,60,47,102,105,108,101,110,97,109,101,62,10,0,0,0,0,60,102,105,108,101,115,105,122,101,62,37,108,100,60,47,102,105,108,101,115,105,122,101,62,10,0,0,0,0,0,0,0,60,102,111,114,109,97,116,62,10,0,0,0,0,0,0,0,60,117,105,110,116,51,50,62,115,116,101,112,60,47,117,105,110,116,51,50,62,10,0,0,60,100,111,117,98,108,101,62,116,105,109,101,60,47,100,111,117,98,108,101,62,10,0,0,60,100,111,117,98,108,101,62,99,112,117,32,116,105,109,101,60,47,100,111,117,98,108,101,62,10,0,0,0,0,0,0,60,117,105,110,116,51,50,62,0,0,0,0,0,0,0,0,32,40,99,97,108,108,115,41,60,47,117,105,110,116,51,50,62,10,0,0,0,0,0,0,60,100,111,117,98,108,101,62,0,0,0,0,0,0,0,0,32,40,99,112,117,32,116,105,109,101,41,60,47,100,111,117,98,108,101,62,10,0,0,0,60,47,102,111,114,109,97,116,62,10,0,0,0,0,0,0,114,98,0,0,0,0,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,38,97,112,111,115,59,0,0,38,113,117,111,116,59,0,0,112,108,111,116,32,34,37,115,95,112,114,111,102,46,100,97,116,97,34,32,98,105,110,97,114,121,32,102,111,114,109,97,116,61,34,37,37,42,117,105,110,116,51,50,37,37,50,100,111,117,98,108,101,37,37,42,37,100,117,105,110,116,51,50,37,37,37,100,100,111,117,98,108,101,34,32,117,115,105,110,103,32,49,58,40,36,37,100,62,49,101,45,57,32,63,32,36,37,100,32,58,32,49,101,45,51,48,41,32,119,32,108,32,108,119,32,37,100,10,0,112,108,111,116,32,34,37,115,95,112,114,111,102,46,100,97,116,97,34,32,98,105,110,97,114,121,32,102,111,114,109,97,116,61,34,37,37,42,117,105,110,116,51,50,37,37,42,50,100,111,117,98,108,101,37,37,37,100,117,105,110,116,51,50,37,37,42,37,100,100,111,117,98,108,101,34,32,117,115,105,110,103,32,37,100,32,119,32,108,32,108,119,32,37,100,10,0,0,0,0,0,0,0,0,117,110,115,101,116,32,120,116,105,99,115,10,0,0,0,0,117,110,115,101,116,32,121,116,105,99,115,10,0,0,0,0,117,110,115,101,116,32,98,111,114,100,101,114,10,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,46,116,104,117,109,98,46,115,118,103,34,10,0,0,0,0,115,101,116,32,116,105,116,108,101,10,0,0,0,0,0,0,115,101,116,32,120,108,97,98,101,108,10,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,10,0,0,0,0,0,115,101,116,32,108,111,103,32,121,10,0,0,0,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,42,58,37,103,93,10,0,0,0,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,42,58,42,93,10,0,0,0,0,0,0,0,115,101,116,32,110,111,108,111,103,32,120,121,10,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,37,103,58,37,103,93,10,0,0,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,95,99,111,117,110,116,46,116,104,117,109,98,46,115,118,103,34,10,0,0,0,0,0,0,115,101,116,32,121,116,105,99,115,10,0,0,0,0,0,0,115,101,116,32,120,116,105,99,115,10,0,0,0,0,0,0,115,101,116,32,98,111,114,100,101,114,10,0,0,0,0,0,115,101,116,32,116,101,114,109,105,110,97,108,32,37,115,10,0,0,0,0,0,0,0,0,115,101,116,32,116,105,116,108,101,32,34,37,115,34,10,0,115,101,116,32,120,108,97,98,101,108,32,34,71,108,111,98,97,108,32,115,116,101,112,32,97,116,32,116,105,109,101,34,10,0,0,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,32,34,69,120,101,99,117,116,105,111,110,32,116,105,109,101,32,91,115,93,34,10,0,0,0,0,0,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,46,37,115,34,10,0,0,0,115,101,116,32,120,108,97,98,101,108,32,34,71,108,111,98,97,108,32,115,116,101,112,32,110,117,109,98,101,114,34,10,0,0,0,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,32,34,69,120,101,99,117,116,105,111,110,32,99,111,117,110,116,34,10,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,95,99,111,117,110,116,46,37,115,34,10,0,0,0,0,0,114,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,102,105,108,101,32,37,115,58,32,37,115,10,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,114,101,97,116,101,32,101,120,112,97,116,32,111,98,106,101,99,116,0,0,0,68,117,109,109,121,32,101,113,117,97,116,105,111,110,32,115,111,32,119,101,32,99,97,110,32,105,110,100,101,120,32,102,114,111,109,32,49,0,0,0,37,115,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,102,105,108,101,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,105,109,117,108,97,116,105,111,110,95,105,110,102,111,95,120,109,108,46,99,0,0,0,0,0,0,0,0,37,115,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,100,97,116,97,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,0,0,0,0,0,0,0,120,109,108,45,62,110,69,113,117,97,116,105,111,110,115,32,61,61,32,40,108,111,110,103,41,32,117,115,101,114,68,97,116,97,91,49,93,0,0,0,109,111,100,101,108,73,110,102,111,88,109,108,73,110,105,116,0,0,0,0,0,0,0,0,120,109,108,45,62,110,70,117,110,99,116,105,111,110,115,32,61,61,32,40,108,111,110,103,41,32,117,115,101,114,68,97,116,97,91,51,93,0,0,0,82,101,113,117,101,115,116,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,112,114,111,102,105,108,101,114,32,105,110,100,101,120,32,37,108,100,44,32,98,117,116,32,119,101,32,111,110,108,121,32,104,97,118,101,32,37,108,100,32,115,117,99,104,32,98,108,111,99,107,115,0,0,0,0,82,101,113,117,101,115,116,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,112,114,111,102,105,108,101,114,32,105,110,100,101,120,32,37,108,100,44,32,98,117,116,32,99,111,117,108,100,32,110,111,116,32,102,105,110,100,32,105,116,33,0,0,0,0,0,0,118,97,114,105,97,98,108,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,113,117,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,108,105,110,101,97,114,0,0,76,105,110,101,97,114,32,102,117,110,99,116,105,111,110,32,40,105,110,100,101,120,32,37,108,100,44,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+251972);
/* memory initializer */ allocate([115,105,122,101,32,37,100,41,0,0,0,0,110,111,110,108,105,110,101,97,114,0,0,0,0,0,0,0,78,111,110,108,105,110,101,97,114,32,102,117,110,99,116,105,111,110,32,40,114,101,115,105,100,117,97,108,70,117,110,99,37,108,100,44,32,115,105,122,101,32,37,100,41,0,0,0,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,100,101,102,105,110,101,115,0,110,97,109,101,0,0,0,0,60,100,101,102,105,110,101,115,62,32,110,101,101,100,115,32,116,111,32,104,97,118,101,32,101,120,97,99,116,108,121,32,111,110,101,32,97,116,116,114,105,98,117,116,101,58,32,110,97,109,101,0,0,0,0,0,0,0,0,0,0,0,0,0,105,110,102,111,0,0,0,0,102,105,108,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,108,105,110,101,83,116,97,114,116,0,0,0,0,0,0,0,108,105,110,101,69,110,100,0,99,111,108,83,116,97,114,116,0,0,0,0,0,0,0,0,99,111,108,69,110,100,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,37,115,58,32,85,110,107,110,111,119,110,32,97,116,116,114,105,98,117,116,101,32,105,110,32,60,105,110,102,111,62,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,99,111,110,116,97,105,110,101,100,32,109,111,114,101,32,101,113,117,97,116,105,111,110,115,32,116,104,97,110,32,101,120,112,101,99,116,101,100,32,40,37,108,100,41,0,0,0,0,105,110,100,101,120,0,0,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,99,111,110,116,97,105,110,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,111,117,116,32,105,110,100,101,120,0,0,0,0,0,0,0,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,103,111,116,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,105,110,100,101,120,32,37,108,100,44,32,101,120,112,101,99,116,101,100,32,37,108,100,0,0,0,0,0,0,0,83,79,77,69,32,78,73,67,69,32,69,81,85,65,84,73,79,78,32,78,65,77,69,32,40,116,111,32,98,101,32,115,101,116,32,97,32,108,105,116,116,108,101,32,108,97,116,101,114,41,0,0,0,0,0,0,99,111,109,109,101,110,116,0,60,118,97,114,62,45,116,97,103,32,100,105,100,32,110,111,116,32,115,101,116,32,110,97,109,101,32,97,110,100,32,99,111,109,109,101,110,116,0,0,35,70,73,88,77,69,35,0,84,79,68,79,58,32,83,101,116,32,109,101,32,117,112,33,33,33,0,0,0,0,0,0,100,117,109,109,121,86,97,114,83,116,97,116,101,83,101,116,74,97,99,0,0,0,0,0,255,255,255,255,24,3,4,0,24,3,4,0,24,3,4,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,82,101,102,101,114,101,110,99,101,100,32,39,37,115,39,32,116,104,97,116,32,119,97,115,32,110,111,116,32,100,101,99,108,97,114,101,100,32,97,115,32,60,118,97,114,105,97,98,108,101,62,0,0,0,0,0,63,0,0,0,0,0,0,0,104,101,108,112,0,0,0,0,70,76,65,71,95,77,65,88,0,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,78,65,77,69,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,68,69,83,67,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,68,69,84,65,73,76,69,68,95,68,69,83,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,97,99,104,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,32,99,97,110,32,111,110,108,121,32,98,101,32,117,115,101,100,32,111,110,99,101,58,32,37,115,0,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,37,115,0,83,84,79,80,32,0,0,0,32,115,116,97,116,101,109,101,110,116,32,101,120,101,99,117,116,101,100,10,0,0,0,0,37,115,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,110,100,102,105,108,101,0,101,114,114,111,114,32,105,110,32,102,111,114,109,97,116,0,105,108,108,101,103,97,108,32,117,110,105,116,32,110,117,109,98,101,114,0,0,0,0,0,102,111,114,109,97,116,116,101,100,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,0,117,110,102,111,114,109,97,116,116,101,100,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,100,105,114,101,99,116,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,115,101,113,117,101,110,116,105,97,108,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,99,97,110,39,116,32,98,97,99,107,115,112,97,99,101,32,102,105,108,101,0,0,0,0,110,117,108,108,32,102,105,108,101,32,110,97,109,101,0,0,99,97,110,39,116,32,115,116,97,116,32,102,105,108,101,0,117,110,105,116,32,110,111,116,32,99,111,110,110,101,99,116,101,100,0,0,0,0,0,0,111,102,102,32,101,110,100,32,111,102,32,114,101,99,111,114,100,0,0,0,0,0,0,0,116,114,117,110,99,97,116,105,111,110,32,102,97,105,108,101,100,32,105,110,32,101,110,100,102,105,108,101,0,0,0,0,105,110,99,111,109,112,114,101,104,101,110,115,105,98,108,101,32,108,105,115,116,32,105,110,112,117,116,0,0,0,0,0,111,117,116,32,111,102,32,102,114,101,101,32,115,112,97,99,101,0,0,0,0,0,0,0,114,101,97,100,32,117,110,101,120,112,101,99,116,101,100,32,99,104,97,114,97,99,116,101,114,0,0,0,0,0,0,0,98,97,100,32,108,111,103,105,99,97,108,32,105,110,112,117,116,32,102,105,101,108,100,0,98,97,100,32,118,97,114,105,97,98,108,101,32,116,121,112,101,0,0,0,0,0,0,0,98,97,100,32,110,97,109,101,108,105,115,116,32,110,97,109,101,0,0,0,0,0,0,0,118,97,114,105,97,98,108,101,32,110,111,116,32,105,110,32,110,97,109,101,108,105,115,116,0,0,0,0,0,0,0,0,110,111,32,101,110,100,32,114,101,99,111,114,100,0,0,0,118,97,114,105,97,98,108,101,32,99,111,117,110,116,32,105,110,99,111,114,114,101,99,116,0,0,0,0,0,0,0,0,115,117,98,115,99,114,105,112,116,32,102,111,114,32,115,99,97,108,97,114,32,118,97,114,105,97,98,108,101,0,0,0,105,110,118,97,108,105,100,32,97,114,114,97,121,32,115,101,99,116,105,111,110,0,0,0,115,117,98,115,116,114,105,110,103,32,111,117,116,32,111,102,32,98,111,117,110,100,115,0,115,117,98,115,99,114,105,112,116,32,111,117,116,32,111,102,32,98,111,117,110,100,115,0,99,97,110,39,116,32,114,101,97,100,32,102,105,108,101,0,99,97,110,39,116,32,119,114,105,116,101,32,102,105,108,101,0,0,0,0,0,0,0,0,39,110,101,119,39,32,102,105,108,101,32,101,120,105,115,116,115,0,0,0,0,0,0,0,99,97,110,39,116,32,97,112,112,101,110,100,32,116,111,32,102,105,108,101,0,0,0,0,110,111,110,45,112,111,115,105,116,105,118,101,32,114,101,99,111,114,100,32,110,117,109,98,101,114,0,0,0,0,0,0,110,109,76,98,117,102,32,111,118,101,114,102,108,111,119,0,192,5,4,0,208,5,4,0,232,5,4,0,8,6,4,0,40,6,4,0,64,6,4,0,96,6,4,0,120,6,4,0,136,6,4,0,152,6,4,0,176,6,4,0,200,6,4,0,232,6,4,0,8,7,4,0,152,6,4,0,32,7,4,0,64,7,4,0,88,7,4,0,112,7,4,0,136,7,4,0,168,7,4,0,184,7,4,0,216,7,4,0,248,7,4,0,16,8,4,0,40,8,4,0,64,8,4,0,80,8,4,0,104,8,4,0,128,8,4,0,152,8,4,0,184,8,4,0,37,115,58,32,105,108,108,101,103,97,108,32,101,114,114,111,114,32,110,117,109,98,101,114,32,37,100,10,0,0,0,0,37,115,58,32,101,110,100,32,111,102,32,102,105,108,101,10,0,0,0,0,0,0,0,0,37,115,58,32,37,115,10,0,0,0,0,0,0,0,0,0,97,112,112,97,114,101,110,116,32,115,116,97,116,101,58,32,117,110,105,116,32,37,100,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+262212);
/* memory initializer */ allocate([110,97,109,101,100,32,37,115,10,0,0,0,0,0,0,0,40,117,110,110,97,109,101,100,41,10,0,0,0,0,0,0,97,112,112,97,114,101,110,116,32,115,116,97,116,101,58,32,105,110,116,101,114,110,97,108,32,73,47,79,10,0,0,0,0,0,0,0,0,0,0,0,108,97,115,116,32,102,111,114,109,97,116,58,32,37,115,10,0,0,0,0,0,0,0,0,108,97,116,101,108,121,32,37,115,32,37,115,32,37,115,32,37,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,114,101,97,100,105,110,103,0,119,114,105,116,105,110,103,0,0,0,0,0,0,0,0,0,115,101,113,117,101,110,116,105,97,108,0,0,0,0,0,0,100,105,114,101,99,116,0,0,0,0,0,0,0,0,0,0,102,111,114,109,97,116,116,101,100,0,0,0,0,0,0,0,117,110,102,111,114,109,97,116,116,101,100,0,0,0,0,0,0,0,0,0,0,0,0,0,101,120,116,101,114,110,97,108,0,0,0,0,0,0,0,0,105,110,116,101,114,110,97,108,0,0,0,0,0,0,0,0,32,73,79], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+269416);
/* memory initializer */ allocate([117,110,107,110,111,119,110,32,99,111,100,101,32,105,110,32,100,111,95,102,105,111,58,32,37,100,10,37,115,10,0,0,100,111,95,102,105,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,109,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,100,32,115,116,114,105,110,103,0,0,0,0,0,0,102,111,114,109,97,116,32,116,111,111,32,99,111,109,112,108,105,99,97,116,101,100,58,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,114,0,0,0,0,0,0,0,192,49,4,0,200,49,4,0,119,98,0,0,0,0,0,0,119,0,0,0,0,0,0,0,114,43,98,0,0,0,0,0,114,43,0,0,0,0,0,0,216,49,4,0,224,49,4,0,232,49,4,0,240,49,4,0,144,1,0,0,0,0,0,0,96,50,4,0,0,0,0,0,111,112,101,110,0,0,0,0,102,111,114,116,46,37,108,100,0,0,0,0,0,0,0,0,110,111,32,115,112,97,99,101,0,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,100,0,0,0,0,0,0,0,102,0,0,0,0,0,0,0,117,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,109,97,108,108,111,99,32,102,97,105,108,117,114,101,0,0,115,116,97,114,116,105,111,0,115,102,101,0,0,0,0,0,37,35,46,42,69,0,0,0,37,43,46,50,100,0,0,0,37,35,46,42,102,0,0,0,119,95,101,100,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,100,101,58,32,37,100,10,0,0,0,0,0,0,119,95,110,101,100,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,100,101,58,32,37,100,10,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,0,0,0,0,0,0,0,0,108,101,102,116,32,111,102,102,0,0,0,0,0,0,0,0,114,101,99,101,110,100,0,0,115,116,97,114,116,105,111,0,119,114,105,116,101,32,115,116,97,114,116], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+274640);
/* memory initializer */ allocate([56,57,4,0,33,0,0,0,34,0,0,0,5,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,37,0,0,0,38,0,0,0,13,0,0,0,39,0,0,0,40,0,0,0,28,0,0,0,14,0,0,0,29,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,119,69,69,0,0,0,0,0,0,0,0,248,132,4,0,24,57,4,0,184,63,4,0,0,0,0,0,0,0,0,0,160,57,4,0,35,0,0,0,36,0,0,0,6,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,41,0,0,0,38,0,0,0,13,0,0,0,42,0,0,0,43,0,0,0,30,0,0,0,15,0,0,0,31,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,119,69,69,0,248,132,4,0,136,57,4,0,184,63,4,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,108,111,99,97,108,101,32,102,111,114,32,115,116,97,110,100,97,114,100,32,105,110,112,117,116,0,0,0,0,0,0,0,56,58,4,0,37,0,0,0,38,0,0,0,7,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,44,0,0,0,32,0,0,0,9,0,0,0,45,0,0,0,34,0,0,0,32,0,0,0,16,0,0,0,33,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,99,69,69,0,0,0,0,0,0,0,0,248,132,4,0,24,58,4,0,120,63,4,0,0,0,0,0,0,0,0,0,160,58,4,0,39,0,0,0,40,0,0,0,8,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,46,0,0,0,47,0,0,0,34,0,0,0,10,0,0,0,35,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,99,69,69,0,248,132,4,0,136,58,4,0,120,63,4,0,0,0,0,0,78,83,116,51,95,95,49,49,52,95,95,115,104,97,114,101,100,95,99,111,117,110,116,69,0,0,0,0,0,0,0,0,208,132,4,0,176,58,4,0,0,0,0,0,24,59,4,0,41,0,0,0,42,0,0,0,48,0,0,0,0,0,0,0,0,0,0,0,192,59,4,0,43,0,0,0,44,0,0,0,49,0,0,0,0,0,0,0,83,116,49,49,108,111,103,105,99,95,101,114,114,111,114,0,248,132,4,0,8,59,4,0,0,0,0,0,0,0,0,0,0,0,0,0,88,59,4,0,41,0,0,0,45,0,0,0,48,0,0,0,0,0,0,0,83,116,49,50,108,101,110,103,116,104,95,101,114,114,111,114,0,0,0,0,0,0,0,0,248,132,4,0,64,59,4,0,24,59,4,0,0,0,0,0,0,0,0,0,152,59,4,0,41,0,0,0,46,0,0,0,48,0,0,0,0,0,0,0,83,116,49,50,111,117,116,95,111,102,95,114,97,110,103,101,0,0,0,0,0,0,0,0,248,132,4,0,128,59,4,0,24,59,4,0,0,0,0,0,83,116,49,51,114,117,110,116,105,109,101,95,101,114,114,111,114,0,0,0,0,0,0,0,248,132,4,0,168,59,4,0,0,0,0,0,0,0,0,0,58,32,0,0,0,0,0,0,0,0,0,0,8,60,4,0,47,0,0,0,48,0,0,0,49,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,115,121,115,116,101,109,95,101,114,114,111,114,69,0,0,248,132,4,0,240,59,4,0,192,59,4,0,0,0,0,0,78,83,116,51,95,95,49,49,52,101,114,114,111,114,95,99,97,116,101,103,111,114,121,69,0,0,0,0,0,0,0,0,208,132,4,0,24,60,4,0,78,83,116,51,95,95,49,49,50,95,95,100,111,95,109,101,115,115,97,103,101,69,0,0,248,132,4,0,64,60,4,0,56,60,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,115,105,99,95,115,116,114,105,110,103,0,0,0,0,0,0,0,0,240,62,4,0,49,0,0,0,50,0,0,0,0,0,0,0,120,63,4,0,51,0,0,0,52,0,0,0,4,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,45,0,0,0,34,0,0,0,32,0,0,0,10,0,0,0,35,0,0,0,0,0,0,0,184,63,4,0,53,0,0,0,54,0,0,0,9,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,41,0,0,0,38,0,0,0,13,0,0,0,39,0,0,0,40,0,0,0,28,0,0,0,15,0,0,0,31,0,0,0,8,0,0,0,0,0,0,0,240,63,4,0,22,0,0,0,23,0,0,0,248,255,255,255,248,255,255,255,240,63,4,0,24,0,0,0,25,0,0,0,8,0,0,0,0,0,0,0,56,64,4,0,55,0,0,0,56,0,0,0,248,255,255,255,248,255,255,255,56,64,4,0,57,0,0,0,58,0,0,0,4,0,0,0,0,0,0,0,128,64,4,0,12,0,0,0,13,0,0,0,252,255,255,255,252,255,255,255,128,64,4,0,14,0,0,0,15,0,0,0,4,0,0,0,0,0,0,0,200,64,4,0,59,0,0,0,60,0,0,0,252,255,255,255,252,255,255,255,200,64,4,0,61,0,0,0,62,0,0,0,105,111,115,116,114,101,97,109,0,0,0,0,0,0,0,0,117,110,115,112,101,99,105,102,105,101,100,32,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,32,101,114,114,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,62,4,0,63,0,0,0,64,0,0,0,49,0,0,0,0,0,0,0,0,0,0,0,184,62,4,0,65,0,0,0,66,0,0,0,105,111,115,95,98,97,115,101,58,58,99,108,101,97,114,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,55,102,97,105,108,117,114,101,69,0,0,0,0,0,0,0,248,132,4,0,112,62,4,0,8,60,4,0,0,0,0,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,69,0,0,0,0,0,0,0,208,132,4,0,160,62,4,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,248,132,4,0,192,62,4,0,184,62,4,0,0,0,0,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,248,132,4,0,0,63,4,0,184,62,4,0,0,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,0,208,132,4,0,64,63,4,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,0,208,132,4,0,128,63,4,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,88,133,4,0,192,63,4,0,0,0,0,0,1,0,0,0,240,62,4,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,88,133,4,0,8,64,4,0,0,0,0,0,1,0,0,0,48,63,4,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,88,133,4,0,80,64,4,0,0,0,0,0,1,0,0,0,240,62,4,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,88,133,4,0,152,64,4,0,0,0,0,0,1,0,0,0,48,63,4,0,3,244,255,255,0,0,0,0,40,65,4,0,67,0,0,0,68,0,0,0,50,0,0,0,2,0,0,0,17,0,0,0,18,0,0,0,3,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,57,95,95,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,69,0,0,0,248,132,4,0,8,65,4,0,88,60,4,0,0,0,0,0,0,0,0,0,80,79,4,0,69,0,0,0,70,0,0,0,71,0,0,0,1,0,0,0,9,0,0,0,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,79,4,0,72,0,0,0,73,0,0,0,71,0,0,0,2,0,0,0,10,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,84,4,0,74,0,0,0,75,0,0,0,71,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,65,66,67,68,69,70,120,88,43,45,112,80,105,73,110,78,0,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,192,84,4,0,76,0,0,0,77,0,0,0,71,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,85,4,0,78,0,0,0,79,0,0,0,71,0,0,0,6,0,0,0,7,0,0,0,23,0,0,0,8,0,0,0,24,0,0,0,1,0,0,0,2,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,86,4,0,80,0,0,0,81,0,0,0,71,0,0,0,10,0,0,0,11,0,0,0,25,0,0,0,12,0,0,0,26,0,0,0,3,0,0,0,4,0,0,0,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,64,81,4,0,82,0,0,0,83,0,0,0,71,0,0,0,51,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,1,0,0,0,248,255,255,255,64,81,4,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,37,109,47,37,100,47,37,121,37,89,45,37,109,45,37,100,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,37,72,58,37,77,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,224,81,4,0,84,0,0,0,85,0,0,0,71,0,0,0,59,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,2,0,0,0,248,255,255,255,224,81,4,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,37,0,0,0,89,0,0,0,45,0,0,0,37,0,0,0,109,0,0,0,45,0,0,0,37,0,0,0,100,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,112,82,4,0,86,0,0,0,87,0,0,0,71,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,82,4,0,88,0,0,0,89,0,0,0,71,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,79,4,0,90,0,0,0,91,0,0,0,71,0,0,0,67,0,0,0,68,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,69,0,0,0,14,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,80,4,0,92,0,0,0,93,0,0,0,71,0,0,0,70,0,0,0,71,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,72,0,0,0,20,0,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,80,4,0,94,0,0,0,95,0,0,0,71,0,0,0,73,0,0,0,74,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,75,0,0,0,26,0,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,80,4,0,96,0,0,0,97,0,0,0,71,0,0,0,76,0,0,0,77,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,78,0,0,0,32,0,0,0,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,86,4,0,98,0,0,0,99,0,0,0,71,0,0,0,3,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,37,76,102,0,0,0,0,0,109,111,110,101,121,95,103,101,116,32,101,114,114,111,114,0,0,0,0,0,56,87,4,0,100,0,0,0,101,0,0,0,71,0,0,0,5,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,0,0,0,0,200,87,4,0,102,0,0,0,103,0,0,0,71,0,0,0,1,0,0,0,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,46,48,76,102,0,0,0,0,0,0,0,88,88,4,0,104,0,0,0,105,0,0,0,71,0,0,0,2,0,0,0,38,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,83,4,0,106,0,0,0,107,0,0,0,71,0,0,0,21,0,0,0,14,0,0,0,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,83,4,0,108,0,0,0,109,0,0,0,71,0,0,0,22,0,0,0,15,0,0,0,35,0,0,0,0,0,0,0,0,0,0,0,118,101,99,116,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,0,0,0,0,40,79,4,0,110,0,0,0,111,0,0,0,71,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,76,4,0,112,0,0,0,113,0,0,0,71,0,0,0,36,0,0,0,23,0,0,0,37,0,0,0,24,0,0,0,38,0,0,0,28,0,0,0,25,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,76,4,0,114,0,0,0,115,0,0,0,71,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,79,0,0,0,80,0,0,0,5,0,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,78,4,0,116,0,0,0,117,0,0,0,71,0,0,0,82,0,0,0,83,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,0,0,0,0,0,79,4,0,118,0,0,0,119,0,0,0,71,0,0,0,84,0,0,0,85,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,116,114,117,101,0,0,0,0,116,0,0,0,114,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,102,97,108,115,101,0,0,0,102,0,0,0,97,0,0,0,108,0,0,0,115,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,109,47,37,100,47,37,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,97,32,37,98,32,37,100,32,37,72,58,37,77,58,37,83,32,37,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,97,0,0,0,32,0,0,0,37,0,0,0,98,0,0,0,32,0,0,0,37,0,0,0,100,0,0,0,32,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,108,111,99,97,108,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,0,0,0,0,0,0,0,56,75,4,0,120,0,0,0,121,0,0,0,71,0,0,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,102,97,99,101,116,69,0,0,0,248,132,4,0,32,75,4,0,208,58,4,0,0,0,0,0,0,0,0,0,200,75,4,0,120,0,0,0,122,0,0,0,71,0,0,0,26,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,39,0,0,0,27,0,0,0,40,0,0,0,28,0,0,0,41,0,0,0,32,0,0,0,29,0,0,0,6,0,0,0,0,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,119,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,48,99,116,121,112,101,95,98,97,115,101,69,0,0,0,0,208,132,4,0,168,75,4,0,88,133,4,0,144,75,4,0,0,0,0,0,2,0,0,0,56,75,4,0,2,0,0,0,192,75,4,0,2,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,99,69,69,0,0,0,0,0,0,0,88,133,4,0,232,75,4,0,0,0,0,0,2,0,0,0,56,75,4,0,2,0,0,0,192,75,4,0,2,0,0,0,0,0,0,0,152,76,4,0,120,0,0,0,123,0,0,0,71,0,0,0,4,0,0,0,5,0,0,0,7,0,0,0,86,0,0,0,87,0,0,0,8,0,0,0,88,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,99,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,99,111,100,101,99,118,116,95,98,97,115,101,69,0,0,208,132,4,0,120,76,4,0,88,133,4,0,80,76,4,0,0,0,0,0,2,0,0,0,56,75,4,0,2,0,0,0,144,76,4,0,2,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,119,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,88,133,4,0,184,76,4,0,0,0,0,0,2,0,0,0,56,75,4,0,2,0,0,0,144,76,4,0,2,0,0,0,0,0,0,0,88,77,4,0,120,0,0,0,124,0,0,0,71,0,0,0,6,0,0,0,7,0,0,0,9,0,0,0,89,0,0,0,90,0,0,0,10,0,0,0,91,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,115,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,88,133,4,0,48,77,4,0,0,0,0,0,2,0,0,0,56,75,4,0,2,0,0,0,144,76,4,0,2,0,0,0,0,0,0,0,208,77,4,0,120,0,0,0,125,0,0,0,71,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,105,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,88,133,4,0,168,77,4,0,0,0,0,0,2,0,0,0,56,75,4,0,2,0,0,0,144,76,4,0,2,0,0,0,0,0,0,0,72,78,4,0,120,0,0,0,126,0,0,0,71,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,49,54,95,95,110,97,114,114,111,119,95,116,111,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,0,248,132,4,0,32,78,4,0,208,77,4,0,0,0,0,0,0,0,0,0,176,78,4,0,120,0,0,0,127,0,0,0,71,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,49,55,95,95,119,105,100,101,110,95,102,114,111,109,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,248,132,4,0,136,78,4,0,208,77,4,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,99,69,69,0,0,0,0,248,132,4,0,192,78,4,0,56,75,4,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,119,69,69,0,0,0,0,248,132,4,0,232,78,4,0,56,75,4,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,95,95,105,109,112,69,0,0,0,248,132,4,0,16,79,4,0,56,75,4,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,99,69,69,0,0,0,0,0,248,132,4,0,56,79,4,0,56,75,4,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,119,69,69,0,0,0,0,0,248,132,4,0,96,79,4,0,56,75,4,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,48,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,95,98,97,115,101,69,0,0,0,0,208,132,4,0,168,79,4,0,88,133,4,0,136,79,4,0,0,0,0,0,2,0,0,0,56,75,4,0,2,0,0,0,192,79,4,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,49,69,69,69,0,0,0,0,0,88,133,4,0,232,79,4,0,0,0,0,0,2,0,0,0,56,75,4,0,2,0,0,0,192,79,4,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,48,69,69,69,0,0,0,0,0,88,133,4,0,40,80,4,0,0,0,0,0,2,0,0,0,56,75,4,0,2,0,0,0,192,79,4,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,49,69,69,69,0,0,0,0,0,88,133,4,0,104,80,4,0,0,0,0,0,2,0,0,0,56,75,4,0,2,0,0,0,192,79,4,0,2,0,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,57,116,105,109,101,95,98,97,115,101,69,0,0,0,0,0,0,208,132,4,0,240,80,4,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,99,69,69,0,0,0,0,0,0,0,208,132,4,0,16,81,4,0,88,133,4,0,168,80,4,0,0,0,0,0,3,0,0,0,56,75,4,0,2,0,0,0,8,81,4,0,2,0,0,0,56,81,4,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,119,69,69,0,0,0,0,0,0,0,208,132,4,0,176,81,4,0,88,133,4,0,104,81,4,0,0,0,0,0,3,0,0,0,56,75,4,0,2,0,0,0,8,81,4,0,2,0,0,0,216,81,4,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,49,48,95,95,116,105,109,101,95,112,117,116,69,0,0,0,0,208,132,4,0,80,82,4,0,88,133,4,0,8,82,4,0,0,0,0,0,2,0,0,0,56,75,4,0,2,0,0,0,104,82,4,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,88,133,4,0,144,82,4,0,0,0,0,0,2,0,0,0,56,75,4,0,2,0,0,0,104,82,4,0,0,8,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,99,69,69,0,0,0,0,78,83,116,51,95,95,49,49,51,109,101,115,115,97,103,101,115,95,98,97,115,101,69,0,208,132,4,0,16,83,4,0,88,133,4,0,248,82,4,0,0,0,0,0,2,0,0,0,56,75,4,0,2,0,0,0,40,83,4,0,2,0,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,119,69,69,0,0,0,0,88,133,4,0,80,83,4,0,0,0,0,0,2,0,0,0,56,75,4,0,2,0,0,0,40,83,4,0,2,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,103,101,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,208,132,4,0,232,83,4,0,88,133,4,0,208,83,4,0,0,0,0,0,1,0,0,0,8,84,4,0,0,0,0,0,88,133,4,0,136,83,4,0,0,0,0,0,2,0,0,0,56,75,4,0,2,0,0,0,16,84,4,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,119,69,69,0,0,0,88,133,4,0,144,84,4,0,0,0,0,0,1,0,0,0,8,84,4,0,0,0,0,0,88,133,4,0,72,84,4,0,0,0,0,0,2,0,0,0,56,75,4,0,2,0,0,0,168,84,4,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,112,117,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,208,132,4,0,64,85,4,0,88,133,4,0,40,85,4,0,0,0,0,0,1,0,0,0,96,85,4,0,0,0,0,0,88,133,4,0,224,84,4,0,0,0,0,0,2,0,0,0,56,75,4,0,2,0,0,0,104,85,4,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,119,69,69,0,0,0,88,133,4,0,232,85,4,0,0,0,0,0,1,0,0,0,96,85,4,0,0,0,0,0,88,133,4,0,160,85,4,0,0,0,0,0,2,0,0,0,56,75,4,0,2,0,0,0,0,86,4,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,99,69,69,0,0,0,0,0,0,0,0,208,132,4,0,128,86,4,0,88,133,4,0,56,86,4,0,0,0,0,0,2,0,0,0,56,75,4,0,2,0,0,0,160,86,4,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,119,69,69,0,0,0,0,0,0,0,0,208,132,4,0,16,87,4,0,88,133,4,0,200,86,4,0,0,0,0,0,2,0,0,0,56,75,4,0,2,0,0,0,48,87,4,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,99,69,69,0,0,0,0,0,0,0,0,208,132,4,0,160,87,4,0,88,133,4,0,88,87,4,0,0,0,0,0,2,0,0,0,56,75,4,0,2,0,0,0,192,87,4,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,119,69,69,0,0,0,0,0,0,0,0,208,132,4,0,48,88,4,0,88,133,4,0,232,87,4,0,0,0,0,0,2,0,0,0,56,75,4,0,2,0,0,0,80,88,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,80,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,77,0,0,0,0,0,0,80,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,114,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,99,0,0,0,104,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,105,0,0,0,108,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,117,0,0,0,115,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,116,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,111,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+276692);
/* memory initializer */ allocate([74,97,110,117,97,114,121,0,70,101,98,114,117,97,114,121,0,0,0,0,0,0,0,0,77,97,114,99,104,0,0,0,65,112,114,105,108,0,0,0,77,97,121,0,0,0,0,0,74,117,110,101,0,0,0,0,74,117,108,121,0,0,0,0,65,117,103,117,115,116,0,0,83,101,112,116,101,109,98,101,114,0,0,0,0,0,0,0,79,99,116,111,98,101,114,0,78,111,118,101,109,98,101,114,0,0,0,0,0,0,0,0,68,101,99,101,109,98,101,114,0,0,0,0,0,0,0,0,74,97,110,0,0,0,0,0,70,101,98,0,0,0,0,0,77,97,114,0,0,0,0,0,65,112,114,0,0,0,0,0,74,117,110,0,0,0,0,0,74,117,108,0,0,0,0,0,65,117,103,0,0,0,0,0,83,101,112,0,0,0,0,0,79,99,116,0,0,0,0,0,78,111,118,0,0,0,0,0,68,101,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,114,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,117,0,0,0,114,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,117,110,100,97,121,0,0,77,111,110,100,97,121,0,0,84,117,101,115,100,97,121,0,87,101,100,110,101,115,100,97,121,0,0,0,0,0,0,0,84,104,117,114,115,100,97,121,0,0,0,0,0,0,0,0,70,114,105,100,97,121,0,0,83,97,116,117,114,100,97,121,0,0,0,0,0,0,0,0,83,117,110,0,0,0,0,0,77,111,110,0,0,0,0,0,84,117,101,0,0,0,0,0,87,101,100,0,0,0,0,0,84,104,117,0,0,0,0,0,70,114,105,0,0,0,0,0,83,97,116,0,0,0,0,0,18,17,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,17,34,35,36,17,37,38,39,40,41,42,43,44,17,45,46,47,16,16,48,16,16,16,16,16,16,16,49,50,51,16,52,53,16,16,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,54,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,55,17,17,17,17,56,17,57,58,59,60,61,62,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,63,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,64,65,17,66,67,68,69,70,71,72,73,16,16,16,74,75,76,77,78,16,16,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,17,17,17,82,83,16,16,16,16,16,16,16,16,16,16,16,17,17,17,17,84,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,17,85,16,16,16,16,86,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,87,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,88,89,90,91,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,92,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,254,255,255,7,254,255,255,7,0,0,0,0,0,4,32,4,255,255,127,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,195,255,3,0,31,80,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,223,60,64,215,255,255,251,255,255,255,255,255,255,255,255,255,191,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,3,252,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,254,255,255,255,127,2,254,255,255,255,255,0,0,0,0,0,255,191,182,0,255,255,255,7,7,0,0,0,255,7,255,255,255,255,255,255,255,254,255,195,255,255,255,255,255,255,255,255,255,255,255,255,239,31,254,225,255,159,0,0,255,255,255,255,255,255,0,224,255,255,255,255,255,255,255,255,255,255,255,255,3,0,255,255,255,255,255,7,48,4,255,255,255,252,255,31,0,0,255,255,255,1,0,0,0,0,0,0,0,0,253,31,0,0,0,0,0,0,240,3,255,127,255,255,255,255,255,255,255,239,255,223,225,255,207,255,254,254,238,159,249,255,255,253,197,227,159,89,128,176,207,255,3,0,238,135,249,255,255,253,109,195,135,25,2,94,192,255,63,0,238,191,251,255,255,253,237,227,191,27,1,0,207,255,0,0,238,159,249,255,255,253,237,227,159,25,192,176,207,255,2,0,236,199,61,214,24,199,255,195,199,29,129,0,192,255,0,0,238,223,253,255,255,253,239,227,223,29,96,3,207,255,0,0,236,223,253,255,255,253,239,227,223,29,96,64,207,255,6,0,236,223,253,255,255,255,255,231,223,93,128,0,207,255,0,252,236,255,127,252,255,255,251,47,127,128,95,255,0,0,12,0,254,255,255,255,255,127,255,7,63,32,255,3,0,0,0,0,150,37,240,254,174,236,255,59,95,32,255,243,0,0,0,0,1,0,0,0,255,3,0,0,255,254,255,255,255,31,254,255,3,255,255,254,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,249,255,3,255,255,231,193,255,255,127,64,255,51,255,255,255,255,191,32,255,255,255,255,255,247,255,255,255,255,255,255,255,255,255,61,127,61,255,255,255,255,255,61,255,255,255,255,61,127,61,255,127,255,255,255,255,255,255,255,61,255,255,255,255,255,255,255,255,135,0,0,0,0,255,255,0,0,255,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,159,255,255,254,255,255,7,255,255,255,255,255,255,255,255,255,199,1,0,255,223,15,0,255,255,15,0,255,255,15,0,255,223,13,0,255,255,255,255,255,255,207,255,255,1,128,16,255,3,0,0,0,0,255,3,255,255,255,255,255,255,255,255,255,255,255,0,255,255,255,255,255,7,255,255,255,255,255,255,255,255,63,0,255,255,255,31,255,15,255,1,192,255,255,255,255,63,31,0,255,255,255,255,255,15,255,255,255,3,255,3,0,0,0,0,255,255,255,15,255,255,255,255,255,255,255,127,254,255,31,0,255,3,255,3,128,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,239,255,239,15,255,3,0,0,0,0,255,255,255,255,255,243,255,255,255,255,255,255,191,255,3,0,255,255,255,255,255,255,63,0,255,227,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,222,111,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,128,0,0,255,31,0,0,0,0,0,0,0,0,0,0,0,0,132,252,47,62,80,189,255,243,224,67,0,0,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,255,255,255,255,255,255,3,0,0,255,255,255,255,255,127,255,255,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,120,12,0,255,255,255,255,191,32,255,255,255,255,255,255,255,128,0,0,255,255,127,0,127,127,127,127,127,127,127,127,255,255,255,255,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,0,0,0,254,3,62,31,254,255,255,255,255,255,255,255,255,255,127,224,254,255,255,255,255,255,255,255,255,255,255,247,224,255,255,255,255,63,254,255,255,255,255,255,255,255,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,63,255,31,255,255,255,15,0,0,255,255,255,255,255,127,240,143,255,255,255,128,255,255,255,255,255,255,255,255,255,255,0,0,0,0,128,255,252,255,255,255,255,255,255,255,255,255,255,255,255,121,15,0,255,7,0,0,0,0,0,0,0,0,0,255,187,247,255,255,255,0,0,0,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,15,0,255,3,0,0,252,8,255,255,255,255,255,7,255,255,255,255,7,0,255,255,255,31,255,255,255,255,255,255,247,255,0,128,255,3,0,0,0,0,255,255,255,255,255,255,127,0,255,63,255,3,255,255,127,4,255,255,255,255,255,255,255,127,5,0,0,56,255,255,60,0,126,126,126,0,127,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,7,255,3,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,127,248,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,0,127,0,248,224,255,253,127,95,219,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,248,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,255,255,255,255,255,255,255,255,252,255,255,255,255,255,255,0,0,0,0,0,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,223,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,255,3,254,255,255,7,254,255,255,7,192,255,255,255,255,255,255,255,255,255,255,127,252,252,252,28,0,0,0,0,255,239,255,255,127,255,255,183,255,63,255,63,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,31,255,255,255,255,255,255,1,0,0,0,0,0,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,63,255,255,255,255,15,255,62,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,3,0,0,0,0,0,0,0,0,0,0,63,253,255,255,255,255,191,145,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,63,0,255,255,255,3,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,192,0,0,0,0,0,0,0,0,111,240,239,254,255,255,15,0,0,0,0,0,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,255,63,0,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,192,255,0,0,252,255,255,255,255,255,255,1,0,0,255,255,255,1,255,3,255,255,255,255,255,255,199,255,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,30,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,3,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,31,0,255,255,255,255,255,127,0,0,248,255,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,255,255,255,223,100,222,255,235,239,255,255,255,255,255,255,255,191,231,223,223,255,255,255,123,95,252,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,253,255,255,247,255,255,255,247,255,255,223,255,255,255,223,255,255,127,255,255,255,127,255,255,255,253,255,255,255,253,255,255,247,207,255,255,255,255,255,255,239,255,255,255,150,254,247,10,132,234,150,170,150,247,247,94,255,251,255,15,238,251,255,15,0,0,0,0,0,0,0,0,97,108,110,117,109,0,97,108,112,104,97,0,98,108,97,110,107,0,99,110,116,114,108,0,100,105,103,105,116,0,103,114,97,112,104,0,108,111,119,101,114,0,112,114,105,110,116,0,112,117,110,99,116,0,115,112,97,99,101,0,117,112,112,101,114,0,120,100,105,103,105,116,0,0,0,0,0,0,0,0,18,16,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,16,16,34,35,16,36,37,38,39,40,41,42,43,16,44,45,46,17,47,48,17,17,49,17,17,17,50,51,52,53,54,55,56,57,17,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,58,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,59,16,60,61,62,63,64,65,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,66,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,67,16,16,68,16,69,70,71,16,72,16,73,16,16,16,16,74,75,76,77,16,16,78,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,16,16,16,16,82,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,83,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,84,85,86,87,16,16,88,89,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,90,16,91,92,93,94,95,96,97,98,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,254,255,0,252,1,0,0,248,1,0,0,120,0,0,0,0,255,251,223,251,0,0,128,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,0,252,255,224,175,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,32,64,176,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,134,254,255,255,255,0,64,73,0,0,0,0,0,24,0,223,255,0,200,0,0,0,0,0,0,0,1,0,60,0,0,0,0,0,0,0,0,0,0,0,0,16,224,1,30,0,96,255,191,0,0,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,207,3,0,0,0,3,0,32,255,127,0,0,0,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,0,0,0,16,0,32,30,0,48,0,1,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,252,15,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,3,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,253,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,255,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,63,2,0,0,0,0,0,0,0,0,0,4,0,0,0,0,16,0,0,0,0,0,0,128,0,128,192,223,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,31,0,0,0,0,0,0,254,255,255,255,0,252,255,255,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,192,255,223,255,7,0,0,0,0,0,0,0,0,0,0,128,6,0,252,0,0,24,62,0,0,128,191,0,204,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,96,255,255,255,31,0,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,0,0,1,0,0,24,0,0,0,0,0,0,0,0,0,56,0,0,0,0,16,0,0,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,0,254,127,47,0,0,255,3,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,196,255,255,255,255,0,0,0,192,0,0,0,0,0,0,0,0,1,0,224,159,0,0,0,0,127,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,16,0,0,252,255,255,255,31,0,0,0,0,0,12,0,0,0,0,0,0,64,0,12,240,0,0,0,0,0,0,192,248,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,255,0,255,255,255,33,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,127,0,0,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,3,224,0,224,0,224,0,96,128,248,255,255,255,252,255,255,255,255,255,127,31,252,241,127,255,127,0,0,255,255,255,3,0,0,255,255,255,255,1,0,123,3,208,193,175,66,0,12,31,188,255,255,0,0,0,0,0,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,127,0,0,0,255,7,0,0,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,252,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,135,3,254,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,255,15,0,0,0,0,0,0,0,0,255,255,255,251,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,255,15,30,255,255,255,1,252,193,224,0,0,0,0,0,0,0,0,0,0,0,30,1,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,0,0,0,0,255,255,255,255,15,0,0,0,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,0,0,0,0,0,0,192,0,224,0,0,0,0,0,0,0,0,0,0,0,128,15,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,255,255,127,0,3,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,8,0,0,0,15,255,3,0,0,0,0,0,0,240,0,0,0,0,0,0,0,0,0,16,192,0,0,255,255,3,7,0,0,0,0,0,248,0,0,0,0,8,128,0,0,0,0,0,0,0,0,0,0,8,0,255,63,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,0,0,128,11,0,0,0,0,0,0,0,128,2,0,0,192,0,0,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,255,255,255,3,127,0,255,255,255,255,247,255,127,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,254,255,0,252,1,0,0,248,1,0,0,248,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,127,127,0,48,135,255,255,255,255,255,143,255,0,0,0,0,0,0,224,255,255,7,255,15,0,0,0,0,0,0,255,255,255,255,255,63,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,143,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,135,255,0,255,1,0,0,0,224,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,0,0,0,255,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,63,252,255,63,0,0,0,3,0,0,0,0,0,0,254,3,0,0,0,0,0,0,0,0,0,0,0,0,0,24,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,225,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,7,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,255,255,255,255,127,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,127,0,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,8,0,0,0,8,0,0,32,0,0,0,32,0,0,128,0,0,0,128,0,0,0,2,0,0,0,2,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,127,254,127,254,255,254,255,0,0,0,0,255,7,255,255,255,127,255,255,255,255,255,255,255,15,255,255,255,255,255,7,0,0,0,0,0,0,0,0,192,255,255,255,7,0,255,255,255,255,255,7,255,1,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,1,0,191,255,255,255,255,255,255,255,255,31,255,255,15,0,255,255,255,255,223,7,0,0,255,255,1,0,255,255,255,255,255,255,255,127,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,30,255,255,255,255,255,255,255,63,15,0,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,255,255,255,255,255,255,255,255,225,255,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,9,0,0,0,10,0,0,0,13,0,0,0,11,0,0,0,12,0,0,0,133,0,0,0,0,32,0,0,1,32,0,0,2,32,0,0,3,32,0,0,4,32,0,0,5,32,0,0,6,32,0,0,8,32,0,0,9,32,0,0,10,32,0,0,40,32,0,0,41,32,0,0,95,32,0,0,0,48,0,0,0,0,0,0,65,0,32,26,192,0,32,31,0,1,1,47,50,1,1,5,57,1,1,15,74,1,1,45,121,1,1,5,112,3,1,3,145,3,32,17,163,3,32,9,0,4,80,16,16,4,32,32,96,4,1,33,138,4,1,53,193,4,1,13,208,4,1,63,20,5,1,19,49,5,48,38,160,1,1,5,179,1,1,3,205,1,1,15,222,1,1,17,248,1,1,39,34,2,1,17,216,3,1,23,0,30,1,149,160,30,1,95,8,31,248,8,24,31,248,6,40,31,248,8,56,31,248,8,72,31,248,6,104,31,248,8,136,31,248,8,152,31,248,8,168,31,248,8,184,31,248,2,186,31,182,2,200,31,170,4,216,31,248,2,218,31,156,2,232,31,248,2,234,31,144,2,248,31,128,2,250,31,130,2,70,2,1,9,16,5,1,3,96,33,16,16,0,44,48,47,103,44,1,5,128,44,1,99,235,44,1,3,64,166,1,45,128,166,1,23,34,167,1,13,50,167,1,61,121,167,1,3,126,167,1,9,144,167,1,3,160,167,1,9,33,255,32,26,0,0,0,0,73,0,49,1,83,0,127,1,48,1,105,0,120,1,255,0,129,1,83,2,130,1,131,1,132,1,133,1,134,1,84,2,135,1,136,1,137,1,86,2,138,1,87,2,139,1,140,1,142,1,221,1,143,1,89,2,144,1,91,2,145,1,146,1,147,1,96,2,148,1,99,2,150,1,105,2,151,1,104,2,152,1,153,1,156,1,111,2,157,1,114,2,159,1,117,2,166,1,128,2,167,1,168,1,169,1,131,2,172,1,173,1,174,1,136,2,175,1,176,1,177,1,138,2,178,1,139,2,183,1,146,2,184,1,185,1,188,1,189,1,196,1,198,1,196,1,197,1,197,1,198,1,199,1,201,1,199,1,200,1,200,1,201,1,202,1,204,1,202,1,203,1,203,1,204,1,241,1,243,1,241,1,242,1,242,1,243,1,244,1,245,1,246,1,149,1,247,1,191,1,32,2,158,1,134,3,172,3,136,3,173,3,137,3,174,3,138,3,175,3,140,3,204,3,142,3,205,3,143,3,206,3,153,3,69,3,153,3,190,31,163,3,194,3,247,3,248,3,250,3,251,3,96,30,155,30,223,0,223,0,158,30,223,0,89,31,81,31,91,31,83,31,93,31,85,31,95,31,87,31,188,31,179,31,204,31,195,31,236,31,229,31,252,31,243,31,58,2,101,44,59,2,60,2,61,2,154,1,62,2,102,44,65,2,66,2,67,2,128,1,68,2,137,2,69,2,140,2,244,3,184,3,249,3,242,3,253,3,123,3,254,3,124,3,255,3,125,3,192,4,207,4,38,33,201,3,42,33,107,0,43,33,229,0,50,33,78,33,131,33,132,33,96,44,97,44,98,44,107,2,99,44,125,29,100,44,125,2,109,44,81,2,110,44,113,2,111,44,80,2,112,44,82,2,114,44,115,44,117,44,118,44,126,44,63,2,127,44,64,2,242,44,243,44,125,167,121,29,139,167,140,167,141,167,101,2,170,167,102,2,199,16,39,45,205,16,45,45,118,3,119,3,156,3,181,0,146,3,208,3,152,3,209,3,166,3,213,3,160,3,214,3,154,3,240,3,161,3,241,3,149,3,245,3,207,3,215,3,0,0,0,0,0,0,0,0,2,0,0,192,3,0,0,192,4,0,0,192,5,0,0,192,6,0,0,192,7,0,0,192,8,0,0,192,9,0,0,192,10,0,0,192,11,0,0,192,12,0,0,192,13,0,0,192,14,0,0,192,15,0,0,192,16,0,0,192,17,0,0,192,18,0,0,192,19,0,0,192,20,0,0,192,21,0,0,192,22,0,0,192,23,0,0,192,24,0,0,192,25,0,0,192,26,0,0,192,27,0,0,192,28,0,0,192,29,0,0,192,30,0,0,192,31,0,0,192,0,0,0,179,1,0,0,195,2,0,0,195,3,0,0,195,4,0,0,195,5,0,0,195,6,0,0,195,7,0,0,195,8,0,0,195,9,0,0,195,10,0,0,195,11,0,0,195,12,0,0,195,13,0,0,211,14,0,0,195,15,0,0,195,0,0,12,187,1,0,12,195,2,0,12,195,3,0,12,195,4,0,12,211,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,116,0,0,0,64,130,4,0,110,0,0,0,72,130,4,0,114,0,0,0,80,130,4,0,102,0,0,0,88,130,4,0,97,0,0,0,96,130,4,0,101,0,0,0,104,130,4,0,119,0,0,0,112,130,4,0,87,0,0,0,128,130,4,0,115,0,0,0,144,130,4,0,83,0,0,0,160,130,4,0,100,0,0,0,176,130,4,0,68,0,0,0,192,130,4,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,13,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,27,0,0,0,0,0,0,0,91,91,58,97,108,110,117,109,58,93,95,93,0,0,0,0,91,94,91,58,97,108,110,117,109,58,93,95,93,0,0,0,91,91,58,115,112,97,99,101,58,93,93,0,0,0,0,0,91,94,91,58,115,112,97,99,101,58,93,93,0,0,0,0,91,91,58,100,105,103,105,116,58,93,93,0,0,0,0,0,91,94,91,58,100,105,103,105,116,58,93,93,0,0,0,0,78,111,32,101,114,114,111,114,0,78,111,32,109,97,116,99,104,0,73,110,118,97,108,105,100,32,114,101,103,101,120,112,0,85,110,107,110,111,119,110,32,99,111,108,108,97,116,105,110,103,32,101,108,101,109,101,110,116,0,85,110,107,110,111,119,110,32,99,104,97,114,97,99,116,101,114,32,99,108,97,115,115,32,110,97,109,101,0,84,114,97,105,108,105,110,103,32,98,97,99,107,115,108,97,115,104,0,73,110,118,97,108,105,100,32,98,97,99,107,32,114,101,102,101,114,101,110,99,101,0,77,105,115,115,105,110,103,32,39,93,39,0,77,105,115,115,105,110,103,32,39,41,39,0,77,105,115,115,105,110,103,32,39,125,39,0,73,110,118,97,108,105,100,32,99,111,110,116,101,110,116,115,32,111,102,32,123,125,0,73,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,114,97,110,103,101,0,79,117,116,32,111,102,32,109,101,109,111,114,121,0,82,101,112,101,116,105,116,105,111,110,32,110,111,116,32,112,114,101,99,101,100,101,100,32,98,121,32,118,97,108,105,100,32,101,120,112,114,101,115,115,105,111,110,0,0,85,110,107,110,111,119,110,32,101,114,114,111,114,0,0,0,37,115,0,0,0,0,0,0,0,0,0,0,72,132,4,0,128,0,0,0,129,0,0,0,95,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,99,97,115,116,0,0,0,83,116,57,116,121,112,101,95,105,110,102,111,0,0,0,0,208,132,4,0,32,132,4,0,83,116,56,98,97,100,95,99,97,115,116,0,0,0,0,0,248,132,4,0,56,132,4,0,0,0,0,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,54,95,95,115,104,105,109,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,0,248,132,4,0,88,132,4,0,48,132,4,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,55,95,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,248,132,4,0,144,132,4,0,128,132,4,0,0,0,0,0,0,0,0,0,184,132,4,0,130,0,0,0,131,0,0,0,132,0,0,0,133,0,0,0,30,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,64,133,4,0,130,0,0,0,134,0,0,0,132,0,0,0,133,0,0,0,30,0,0,0,17,0,0,0,11,0,0,0,12,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,48,95,95,115,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,248,132,4,0,24,133,4,0,184,132,4,0,0,0,0,0,0,0,0,0,160,133,4,0,130,0,0,0,135,0,0,0,132,0,0,0,133,0,0,0,30,0,0,0,18,0,0,0,12,0,0,0,13,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,49,95,95,118,109,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,248,132,4,0,120,133,4,0,184,132,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,135,4,0,136,0,0,0,137,0,0,0,96,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,97,108,108,111,99,0,0,83,116,57,98,97,100,95,97,108,108,111,99,0,0,0,0,248,132,4,0,208,135,4,0,0,0,0,0,0,0,0,0,105,110,102,105,110,105,116,121,0,0,0,0,0,0,0,0,110,97,110,0,0,0,0,0,95,112,137,0,255,9,47,15,10,0,0,0,100,0,0,0,232,3,0,0,16,39,0,0,160,134,1,0,64,66,15,0,128,150,152,0,0,225,245,5], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+287032);




var tempDoublePtr = Runtime.alignMemory(allocate(12, "i8", ALLOC_STATIC), 8);

assert(tempDoublePtr % 8 == 0);

function copyTempFloat(ptr) { // functions, because inlining this code increases code size too much

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

}

function copyTempDouble(ptr) {

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

  HEAP8[tempDoublePtr+4] = HEAP8[ptr+4];

  HEAP8[tempDoublePtr+5] = HEAP8[ptr+5];

  HEAP8[tempDoublePtr+6] = HEAP8[ptr+6];

  HEAP8[tempDoublePtr+7] = HEAP8[ptr+7];

}


  function _llvm_lifetime_end() {}

  
  
  var ERRNO_CODES={EPERM:1,ENOENT:2,ESRCH:3,EINTR:4,EIO:5,ENXIO:6,E2BIG:7,ENOEXEC:8,EBADF:9,ECHILD:10,EAGAIN:11,EWOULDBLOCK:11,ENOMEM:12,EACCES:13,EFAULT:14,ENOTBLK:15,EBUSY:16,EEXIST:17,EXDEV:18,ENODEV:19,ENOTDIR:20,EISDIR:21,EINVAL:22,ENFILE:23,EMFILE:24,ENOTTY:25,ETXTBSY:26,EFBIG:27,ENOSPC:28,ESPIPE:29,EROFS:30,EMLINK:31,EPIPE:32,EDOM:33,ERANGE:34,ENOMSG:42,EIDRM:43,ECHRNG:44,EL2NSYNC:45,EL3HLT:46,EL3RST:47,ELNRNG:48,EUNATCH:49,ENOCSI:50,EL2HLT:51,EDEADLK:35,ENOLCK:37,EBADE:52,EBADR:53,EXFULL:54,ENOANO:55,EBADRQC:56,EBADSLT:57,EDEADLOCK:35,EBFONT:59,ENOSTR:60,ENODATA:61,ETIME:62,ENOSR:63,ENONET:64,ENOPKG:65,EREMOTE:66,ENOLINK:67,EADV:68,ESRMNT:69,ECOMM:70,EPROTO:71,EMULTIHOP:72,EDOTDOT:73,EBADMSG:74,ENOTUNIQ:76,EBADFD:77,EREMCHG:78,ELIBACC:79,ELIBBAD:80,ELIBSCN:81,ELIBMAX:82,ELIBEXEC:83,ENOSYS:38,ENOTEMPTY:39,ENAMETOOLONG:36,ELOOP:40,EOPNOTSUPP:95,EPFNOSUPPORT:96,ECONNRESET:104,ENOBUFS:105,EAFNOSUPPORT:97,EPROTOTYPE:91,ENOTSOCK:88,ENOPROTOOPT:92,ESHUTDOWN:108,ECONNREFUSED:111,EADDRINUSE:98,ECONNABORTED:103,ENETUNREACH:101,ENETDOWN:100,ETIMEDOUT:110,EHOSTDOWN:112,EHOSTUNREACH:113,EINPROGRESS:115,EALREADY:114,EDESTADDRREQ:89,EMSGSIZE:90,EPROTONOSUPPORT:93,ESOCKTNOSUPPORT:94,EADDRNOTAVAIL:99,ENETRESET:102,EISCONN:106,ENOTCONN:107,ETOOMANYREFS:109,EUSERS:87,EDQUOT:122,ESTALE:116,ENOTSUP:95,ENOMEDIUM:123,EILSEQ:84,EOVERFLOW:75,ECANCELED:125,ENOTRECOVERABLE:131,EOWNERDEAD:130,ESTRPIPE:86};
  
  var ERRNO_MESSAGES={0:"Success",1:"Not super-user",2:"No such file or directory",3:"No such process",4:"Interrupted system call",5:"I/O error",6:"No such device or address",7:"Arg list too long",8:"Exec format error",9:"Bad file number",10:"No children",11:"No more processes",12:"Not enough core",13:"Permission denied",14:"Bad address",15:"Block device required",16:"Mount device busy",17:"File exists",18:"Cross-device link",19:"No such device",20:"Not a directory",21:"Is a directory",22:"Invalid argument",23:"Too many open files in system",24:"Too many open files",25:"Not a typewriter",26:"Text file busy",27:"File too large",28:"No space left on device",29:"Illegal seek",30:"Read only file system",31:"Too many links",32:"Broken pipe",33:"Math arg out of domain of func",34:"Math result not representable",35:"File locking deadlock error",36:"File or path name too long",37:"No record locks available",38:"Function not implemented",39:"Directory not empty",40:"Too many symbolic links",42:"No message of desired type",43:"Identifier removed",44:"Channel number out of range",45:"Level 2 not synchronized",46:"Level 3 halted",47:"Level 3 reset",48:"Link number out of range",49:"Protocol driver not attached",50:"No CSI structure available",51:"Level 2 halted",52:"Invalid exchange",53:"Invalid request descriptor",54:"Exchange full",55:"No anode",56:"Invalid request code",57:"Invalid slot",59:"Bad font file fmt",60:"Device not a stream",61:"No data (for no delay io)",62:"Timer expired",63:"Out of streams resources",64:"Machine is not on the network",65:"Package not installed",66:"The object is remote",67:"The link has been severed",68:"Advertise error",69:"Srmount error",70:"Communication error on send",71:"Protocol error",72:"Multihop attempted",73:"Cross mount point (not really error)",74:"Trying to read unreadable message",75:"Value too large for defined data type",76:"Given log. name not unique",77:"f.d. invalid for this operation",78:"Remote address changed",79:"Can   access a needed shared lib",80:"Accessing a corrupted shared lib",81:".lib section in a.out corrupted",82:"Attempting to link in too many libs",83:"Attempting to exec a shared library",84:"Illegal byte sequence",86:"Streams pipe error",87:"Too many users",88:"Socket operation on non-socket",89:"Destination address required",90:"Message too long",91:"Protocol wrong type for socket",92:"Protocol not available",93:"Unknown protocol",94:"Socket type not supported",95:"Not supported",96:"Protocol family not supported",97:"Address family not supported by protocol family",98:"Address already in use",99:"Address not available",100:"Network interface is not configured",101:"Network is unreachable",102:"Connection reset by network",103:"Connection aborted",104:"Connection reset by peer",105:"No buffer space available",106:"Socket is already connected",107:"Socket is not connected",108:"Can't send after socket shutdown",109:"Too many references",110:"Connection timed out",111:"Connection refused",112:"Host is down",113:"Host is unreachable",114:"Socket already connected",115:"Connection already in progress",116:"Stale file handle",122:"Quota exceeded",123:"No medium (in tape drive)",125:"Operation canceled",130:"Previous owner died",131:"State not recoverable"};
  
  
  var ___errno_state=0;function ___setErrNo(value) {
      // For convenient setting and returning of errno.
      HEAP32[((___errno_state)>>2)]=value;
      return value;
    }
  
  var PATH={splitPath:function (filename) {
        var splitPathRe = /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;
        return splitPathRe.exec(filename).slice(1);
      },normalizeArray:function (parts, allowAboveRoot) {
        // if the path tries to go above the root, `up` ends up > 0
        var up = 0;
        for (var i = parts.length - 1; i >= 0; i--) {
          var last = parts[i];
          if (last === '.') {
            parts.splice(i, 1);
          } else if (last === '..') {
            parts.splice(i, 1);
            up++;
          } else if (up) {
            parts.splice(i, 1);
            up--;
          }
        }
        // if the path is allowed to go above the root, restore leading ..s
        if (allowAboveRoot) {
          for (; up--; up) {
            parts.unshift('..');
          }
        }
        return parts;
      },normalize:function (path) {
        var isAbsolute = path.charAt(0) === '/',
            trailingSlash = path.substr(-1) === '/';
        // Normalize the path
        path = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), !isAbsolute).join('/');
        if (!path && !isAbsolute) {
          path = '.';
        }
        if (path && trailingSlash) {
          path += '/';
        }
        return (isAbsolute ? '/' : '') + path;
      },dirname:function (path) {
        var result = PATH.splitPath(path),
            root = result[0],
            dir = result[1];
        if (!root && !dir) {
          // No dirname whatsoever
          return '.';
        }
        if (dir) {
          // It has a dirname, strip trailing slash
          dir = dir.substr(0, dir.length - 1);
        }
        return root + dir;
      },basename:function (path) {
        // EMSCRIPTEN return '/'' for '/', not an empty string
        if (path === '/') return '/';
        var lastSlash = path.lastIndexOf('/');
        if (lastSlash === -1) return path;
        return path.substr(lastSlash+1);
      },extname:function (path) {
        return PATH.splitPath(path)[3];
      },join:function () {
        var paths = Array.prototype.slice.call(arguments, 0);
        return PATH.normalize(paths.join('/'));
      },join2:function (l, r) {
        return PATH.normalize(l + '/' + r);
      },resolve:function () {
        var resolvedPath = '',
          resolvedAbsolute = false;
        for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
          var path = (i >= 0) ? arguments[i] : FS.cwd();
          // Skip empty and invalid entries
          if (typeof path !== 'string') {
            throw new TypeError('Arguments to path.resolve must be strings');
          } else if (!path) {
            continue;
          }
          resolvedPath = path + '/' + resolvedPath;
          resolvedAbsolute = path.charAt(0) === '/';
        }
        // At this point the path should be resolved to a full absolute path, but
        // handle relative paths to be safe (might happen when process.cwd() fails)
        resolvedPath = PATH.normalizeArray(resolvedPath.split('/').filter(function(p) {
          return !!p;
        }), !resolvedAbsolute).join('/');
        return ((resolvedAbsolute ? '/' : '') + resolvedPath) || '.';
      },relative:function (from, to) {
        from = PATH.resolve(from).substr(1);
        to = PATH.resolve(to).substr(1);
        function trim(arr) {
          var start = 0;
          for (; start < arr.length; start++) {
            if (arr[start] !== '') break;
          }
          var end = arr.length - 1;
          for (; end >= 0; end--) {
            if (arr[end] !== '') break;
          }
          if (start > end) return [];
          return arr.slice(start, end - start + 1);
        }
        var fromParts = trim(from.split('/'));
        var toParts = trim(to.split('/'));
        var length = Math.min(fromParts.length, toParts.length);
        var samePartsLength = length;
        for (var i = 0; i < length; i++) {
          if (fromParts[i] !== toParts[i]) {
            samePartsLength = i;
            break;
          }
        }
        var outputParts = [];
        for (var i = samePartsLength; i < fromParts.length; i++) {
          outputParts.push('..');
        }
        outputParts = outputParts.concat(toParts.slice(samePartsLength));
        return outputParts.join('/');
      }};
  
  var TTY={ttys:[],init:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // currently, FS.init does not distinguish if process.stdin is a file or TTY
        //   // device, it always assumes it's a TTY device. because of this, we're forcing
        //   // process.stdin to UTF8 encoding to at least make stdin reading compatible
        //   // with text files until FS.init can be refactored.
        //   process['stdin']['setEncoding']('utf8');
        // }
      },shutdown:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // inolen: any idea as to why node -e 'process.stdin.read()' wouldn't exit immediately (with process.stdin being a tty)?
        //   // isaacs: because now it's reading from the stream, you've expressed interest in it, so that read() kicks off a _read() which creates a ReadReq operation
        //   // inolen: I thought read() in that case was a synchronous operation that just grabbed some amount of buffered data if it exists?
        //   // isaacs: it is. but it also triggers a _read() call, which calls readStart() on the handle
        //   // isaacs: do process.stdin.pause() and i'd think it'd probably close the pending call
        //   process['stdin']['pause']();
        // }
      },register:function (dev, ops) {
        TTY.ttys[dev] = { input: [], output: [], ops: ops };
        FS.registerDevice(dev, TTY.stream_ops);
      },stream_ops:{open:function (stream) {
          var tty = TTY.ttys[stream.node.rdev];
          if (!tty) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          stream.tty = tty;
          stream.seekable = false;
        },close:function (stream) {
          // flush any pending line data
          if (stream.tty.output.length) {
            stream.tty.ops.put_char(stream.tty, 10);
          }
        },read:function (stream, buffer, offset, length, pos /* ignored */) {
          if (!stream.tty || !stream.tty.ops.get_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          var bytesRead = 0;
          for (var i = 0; i < length; i++) {
            var result;
            try {
              result = stream.tty.ops.get_char(stream.tty);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            if (result === undefined && bytesRead === 0) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
            if (result === null || result === undefined) break;
            bytesRead++;
            buffer[offset+i] = result;
          }
          if (bytesRead) {
            stream.node.timestamp = Date.now();
          }
          return bytesRead;
        },write:function (stream, buffer, offset, length, pos) {
          if (!stream.tty || !stream.tty.ops.put_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          for (var i = 0; i < length; i++) {
            try {
              stream.tty.ops.put_char(stream.tty, buffer[offset+i]);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
          }
          if (length) {
            stream.node.timestamp = Date.now();
          }
          return i;
        }},default_tty_ops:{get_char:function (tty) {
          if (!tty.input.length) {
            var result = null;
            if (ENVIRONMENT_IS_NODE) {
              result = process['stdin']['read']();
              if (!result) {
                if (process['stdin']['_readableState'] && process['stdin']['_readableState']['ended']) {
                  return null;  // EOF
                }
                return undefined;  // no data available
              }
            } else if (typeof window != 'undefined' &&
              typeof window.prompt == 'function') {
              // Browser.
              result = window.prompt('Input: ');  // returns null on cancel
              if (result !== null) {
                result += '\n';
              }
            } else if (typeof readline == 'function') {
              // Command line.
              result = readline();
              if (result !== null) {
                result += '\n';
              }
            }
            if (!result) {
              return null;
            }
            tty.input = intArrayFromString(result, true);
          }
          return tty.input.shift();
        },put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['print'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }},default_tty1_ops:{put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['printErr'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }}};
  
  var MEMFS={ops_table:null,CONTENT_OWNING:1,CONTENT_FLEXIBLE:2,CONTENT_FIXED:3,mount:function (mount) {
        return MEMFS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createNode:function (parent, name, mode, dev) {
        if (FS.isBlkdev(mode) || FS.isFIFO(mode)) {
          // no supported
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (!MEMFS.ops_table) {
          MEMFS.ops_table = {
            dir: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                lookup: MEMFS.node_ops.lookup,
                mknod: MEMFS.node_ops.mknod,
                rename: MEMFS.node_ops.rename,
                unlink: MEMFS.node_ops.unlink,
                rmdir: MEMFS.node_ops.rmdir,
                readdir: MEMFS.node_ops.readdir,
                symlink: MEMFS.node_ops.symlink
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek
              }
            },
            file: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek,
                read: MEMFS.stream_ops.read,
                write: MEMFS.stream_ops.write,
                allocate: MEMFS.stream_ops.allocate,
                mmap: MEMFS.stream_ops.mmap
              }
            },
            link: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                readlink: MEMFS.node_ops.readlink
              },
              stream: {}
            },
            chrdev: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: FS.chrdev_stream_ops
            },
          };
        }
        var node = FS.createNode(parent, name, mode, dev);
        if (FS.isDir(node.mode)) {
          node.node_ops = MEMFS.ops_table.dir.node;
          node.stream_ops = MEMFS.ops_table.dir.stream;
          node.contents = {};
        } else if (FS.isFile(node.mode)) {
          node.node_ops = MEMFS.ops_table.file.node;
          node.stream_ops = MEMFS.ops_table.file.stream;
          node.contents = [];
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        } else if (FS.isLink(node.mode)) {
          node.node_ops = MEMFS.ops_table.link.node;
          node.stream_ops = MEMFS.ops_table.link.stream;
        } else if (FS.isChrdev(node.mode)) {
          node.node_ops = MEMFS.ops_table.chrdev.node;
          node.stream_ops = MEMFS.ops_table.chrdev.stream;
        }
        node.timestamp = Date.now();
        // add the new node to the parent
        if (parent) {
          parent.contents[name] = node;
        }
        return node;
      },ensureFlexible:function (node) {
        if (node.contentMode !== MEMFS.CONTENT_FLEXIBLE) {
          var contents = node.contents;
          node.contents = Array.prototype.slice.call(contents);
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        }
      },node_ops:{getattr:function (node) {
          var attr = {};
          // device numbers reuse inode numbers.
          attr.dev = FS.isChrdev(node.mode) ? node.id : 1;
          attr.ino = node.id;
          attr.mode = node.mode;
          attr.nlink = 1;
          attr.uid = 0;
          attr.gid = 0;
          attr.rdev = node.rdev;
          if (FS.isDir(node.mode)) {
            attr.size = 4096;
          } else if (FS.isFile(node.mode)) {
            attr.size = node.contents.length;
          } else if (FS.isLink(node.mode)) {
            attr.size = node.link.length;
          } else {
            attr.size = 0;
          }
          attr.atime = new Date(node.timestamp);
          attr.mtime = new Date(node.timestamp);
          attr.ctime = new Date(node.timestamp);
          // NOTE: In our implementation, st_blocks = Math.ceil(st_size/st_blksize),
          //       but this is not required by the standard.
          attr.blksize = 4096;
          attr.blocks = Math.ceil(attr.size / attr.blksize);
          return attr;
        },setattr:function (node, attr) {
          if (attr.mode !== undefined) {
            node.mode = attr.mode;
          }
          if (attr.timestamp !== undefined) {
            node.timestamp = attr.timestamp;
          }
          if (attr.size !== undefined) {
            MEMFS.ensureFlexible(node);
            var contents = node.contents;
            if (attr.size < contents.length) contents.length = attr.size;
            else while (attr.size > contents.length) contents.push(0);
          }
        },lookup:function (parent, name) {
          throw FS.genericErrors[ERRNO_CODES.ENOENT];
        },mknod:function (parent, name, mode, dev) {
          return MEMFS.createNode(parent, name, mode, dev);
        },rename:function (old_node, new_dir, new_name) {
          // if we're overwriting a directory at new_name, make sure it's empty.
          if (FS.isDir(old_node.mode)) {
            var new_node;
            try {
              new_node = FS.lookupNode(new_dir, new_name);
            } catch (e) {
            }
            if (new_node) {
              for (var i in new_node.contents) {
                throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
              }
            }
          }
          // do the internal rewiring
          delete old_node.parent.contents[old_node.name];
          old_node.name = new_name;
          new_dir.contents[new_name] = old_node;
          old_node.parent = new_dir;
        },unlink:function (parent, name) {
          delete parent.contents[name];
        },rmdir:function (parent, name) {
          var node = FS.lookupNode(parent, name);
          for (var i in node.contents) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
          }
          delete parent.contents[name];
        },readdir:function (node) {
          var entries = ['.', '..']
          for (var key in node.contents) {
            if (!node.contents.hasOwnProperty(key)) {
              continue;
            }
            entries.push(key);
          }
          return entries;
        },symlink:function (parent, newname, oldpath) {
          var node = MEMFS.createNode(parent, newname, 511 /* 0777 */ | 40960, 0);
          node.link = oldpath;
          return node;
        },readlink:function (node) {
          if (!FS.isLink(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          return node.link;
        }},stream_ops:{read:function (stream, buffer, offset, length, position) {
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (size > 8 && contents.subarray) { // non-trivial, and typed array
            buffer.set(contents.subarray(position, position + size), offset);
          } else
          {
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          }
          return size;
        },write:function (stream, buffer, offset, length, position, canOwn) {
          var node = stream.node;
          node.timestamp = Date.now();
          var contents = node.contents;
          if (length && contents.length === 0 && position === 0 && buffer.subarray) {
            // just replace it with the new data
            if (canOwn && offset === 0) {
              node.contents = buffer; // this could be a subarray of Emscripten HEAP, or allocated from some other source.
              node.contentMode = (buffer.buffer === HEAP8.buffer) ? MEMFS.CONTENT_OWNING : MEMFS.CONTENT_FIXED;
            } else {
              node.contents = new Uint8Array(buffer.subarray(offset, offset+length));
              node.contentMode = MEMFS.CONTENT_FIXED;
            }
            return length;
          }
          MEMFS.ensureFlexible(node);
          var contents = node.contents;
          while (contents.length < position) contents.push(0);
          for (var i = 0; i < length; i++) {
            contents[position + i] = buffer[offset + i];
          }
          return length;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              position += stream.node.contents.length;
            }
          }
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          stream.ungotten = [];
          stream.position = position;
          return position;
        },allocate:function (stream, offset, length) {
          MEMFS.ensureFlexible(stream.node);
          var contents = stream.node.contents;
          var limit = offset + length;
          while (limit > contents.length) contents.push(0);
        },mmap:function (stream, buffer, offset, length, position, prot, flags) {
          if (!FS.isFile(stream.node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          var ptr;
          var allocated;
          var contents = stream.node.contents;
          // Only make a new copy when MAP_PRIVATE is specified.
          if ( !(flags & 2) &&
                (contents.buffer === buffer || contents.buffer === buffer.buffer) ) {
            // We can't emulate MAP_SHARED when the file is not backed by the buffer
            // we're mapping to (e.g. the HEAP buffer).
            allocated = false;
            ptr = contents.byteOffset;
          } else {
            // Try to avoid unnecessary slices.
            if (position > 0 || position + length < contents.length) {
              if (contents.subarray) {
                contents = contents.subarray(position, position + length);
              } else {
                contents = Array.prototype.slice.call(contents, position, position + length);
              }
            }
            allocated = true;
            ptr = _malloc(length);
            if (!ptr) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOMEM);
            }
            buffer.set(contents, ptr);
          }
          return { ptr: ptr, allocated: allocated };
        }}};
  
  var IDBFS={dbs:{},indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_VERSION:21,DB_STORE_NAME:"FILE_DATA",mount:function (mount) {
        // reuse all of the core MEMFS functionality
        return MEMFS.mount.apply(null, arguments);
      },syncfs:function (mount, populate, callback) {
        IDBFS.getLocalSet(mount, function(err, local) {
          if (err) return callback(err);
  
          IDBFS.getRemoteSet(mount, function(err, remote) {
            if (err) return callback(err);
  
            var src = populate ? remote : local;
            var dst = populate ? local : remote;
  
            IDBFS.reconcile(src, dst, callback);
          });
        });
      },getDB:function (name, callback) {
        // check the cache first
        var db = IDBFS.dbs[name];
        if (db) {
          return callback(null, db);
        }
  
        var req;
        try {
          req = IDBFS.indexedDB().open(name, IDBFS.DB_VERSION);
        } catch (e) {
          return callback(e);
        }
        req.onupgradeneeded = function(e) {
          var db = e.target.result;
          var transaction = e.target.transaction;
  
          var fileStore;
  
          if (db.objectStoreNames.contains(IDBFS.DB_STORE_NAME)) {
            fileStore = transaction.objectStore(IDBFS.DB_STORE_NAME);
          } else {
            fileStore = db.createObjectStore(IDBFS.DB_STORE_NAME);
          }
  
          fileStore.createIndex('timestamp', 'timestamp', { unique: false });
        };
        req.onsuccess = function() {
          db = req.result;
  
          // add to the cache
          IDBFS.dbs[name] = db;
          callback(null, db);
        };
        req.onerror = function() {
          callback(this.error);
        };
      },getLocalSet:function (mount, callback) {
        var entries = {};
  
        function isRealDir(p) {
          return p !== '.' && p !== '..';
        };
        function toAbsolute(root) {
          return function(p) {
            return PATH.join2(root, p);
          }
        };
  
        var check = FS.readdir(mount.mountpoint).filter(isRealDir).map(toAbsolute(mount.mountpoint));
  
        while (check.length) {
          var path = check.pop();
          var stat;
  
          try {
            stat = FS.stat(path);
          } catch (e) {
            return callback(e);
          }
  
          if (FS.isDir(stat.mode)) {
            check.push.apply(check, FS.readdir(path).filter(isRealDir).map(toAbsolute(path)));
          }
  
          entries[path] = { timestamp: stat.mtime };
        }
  
        return callback(null, { type: 'local', entries: entries });
      },getRemoteSet:function (mount, callback) {
        var entries = {};
  
        IDBFS.getDB(mount.mountpoint, function(err, db) {
          if (err) return callback(err);
  
          var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readonly');
          transaction.onerror = function() { callback(this.error); };
  
          var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
          var index = store.index('timestamp');
  
          index.openKeyCursor().onsuccess = function(event) {
            var cursor = event.target.result;
  
            if (!cursor) {
              return callback(null, { type: 'remote', db: db, entries: entries });
            }
  
            entries[cursor.primaryKey] = { timestamp: cursor.key };
  
            cursor.continue();
          };
        });
      },loadLocalEntry:function (path, callback) {
        var stat, node;
  
        try {
          var lookup = FS.lookupPath(path);
          node = lookup.node;
          stat = FS.stat(path);
        } catch (e) {
          return callback(e);
        }
  
        if (FS.isDir(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode });
        } else if (FS.isFile(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode, contents: node.contents });
        } else {
          return callback(new Error('node type not supported'));
        }
      },storeLocalEntry:function (path, entry, callback) {
        try {
          if (FS.isDir(entry.mode)) {
            FS.mkdir(path, entry.mode);
          } else if (FS.isFile(entry.mode)) {
            FS.writeFile(path, entry.contents, { encoding: 'binary', canOwn: true });
          } else {
            return callback(new Error('node type not supported'));
          }
  
          FS.utime(path, entry.timestamp, entry.timestamp);
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },removeLocalEntry:function (path, callback) {
        try {
          var lookup = FS.lookupPath(path);
          var stat = FS.stat(path);
  
          if (FS.isDir(stat.mode)) {
            FS.rmdir(path);
          } else if (FS.isFile(stat.mode)) {
            FS.unlink(path);
          }
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },loadRemoteEntry:function (store, path, callback) {
        var req = store.get(path);
        req.onsuccess = function(event) { callback(null, event.target.result); };
        req.onerror = function() { callback(this.error); };
      },storeRemoteEntry:function (store, path, entry, callback) {
        var req = store.put(entry, path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },removeRemoteEntry:function (store, path, callback) {
        var req = store.delete(path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },reconcile:function (src, dst, callback) {
        var total = 0;
  
        var create = [];
        Object.keys(src.entries).forEach(function (key) {
          var e = src.entries[key];
          var e2 = dst.entries[key];
          if (!e2 || e.timestamp > e2.timestamp) {
            create.push(key);
            total++;
          }
        });
  
        var remove = [];
        Object.keys(dst.entries).forEach(function (key) {
          var e = dst.entries[key];
          var e2 = src.entries[key];
          if (!e2) {
            remove.push(key);
            total++;
          }
        });
  
        if (!total) {
          return callback(null);
        }
  
        var errored = false;
        var completed = 0;
        var db = src.type === 'remote' ? src.db : dst.db;
        var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readwrite');
        var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= total) {
            return callback(null);
          }
        };
  
        transaction.onerror = function() { done(this.error); };
  
        // sort paths in ascending order so directory entries are created
        // before the files inside them
        create.sort().forEach(function (path) {
          if (dst.type === 'local') {
            IDBFS.loadRemoteEntry(store, path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeLocalEntry(path, entry, done);
            });
          } else {
            IDBFS.loadLocalEntry(path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeRemoteEntry(store, path, entry, done);
            });
          }
        });
  
        // sort paths in descending order so files are deleted before their
        // parent directories
        remove.sort().reverse().forEach(function(path) {
          if (dst.type === 'local') {
            IDBFS.removeLocalEntry(path, done);
          } else {
            IDBFS.removeRemoteEntry(store, path, done);
          }
        });
      }};
  
  var NODEFS={isWindows:false,staticInit:function () {
        NODEFS.isWindows = !!process.platform.match(/^win/);
      },mount:function (mount) {
        assert(ENVIRONMENT_IS_NODE);
        return NODEFS.createNode(null, '/', NODEFS.getMode(mount.opts.root), 0);
      },createNode:function (parent, name, mode, dev) {
        if (!FS.isDir(mode) && !FS.isFile(mode) && !FS.isLink(mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node = FS.createNode(parent, name, mode);
        node.node_ops = NODEFS.node_ops;
        node.stream_ops = NODEFS.stream_ops;
        return node;
      },getMode:function (path) {
        var stat;
        try {
          stat = fs.lstatSync(path);
          if (NODEFS.isWindows) {
            // On Windows, directories return permission bits 'rw-rw-rw-', even though they have 'rwxrwxrwx', so 
            // propagate write bits to execute bits.
            stat.mode = stat.mode | ((stat.mode & 146) >> 1);
          }
        } catch (e) {
          if (!e.code) throw e;
          throw new FS.ErrnoError(ERRNO_CODES[e.code]);
        }
        return stat.mode;
      },realPath:function (node) {
        var parts = [];
        while (node.parent !== node) {
          parts.push(node.name);
          node = node.parent;
        }
        parts.push(node.mount.opts.root);
        parts.reverse();
        return PATH.join.apply(null, parts);
      },flagsToPermissionStringMap:{0:"r",1:"r+",2:"r+",64:"r",65:"r+",66:"r+",129:"rx+",193:"rx+",514:"w+",577:"w",578:"w+",705:"wx",706:"wx+",1024:"a",1025:"a",1026:"a+",1089:"a",1090:"a+",1153:"ax",1154:"ax+",1217:"ax",1218:"ax+",4096:"rs",4098:"rs+"},flagsToPermissionString:function (flags) {
        if (flags in NODEFS.flagsToPermissionStringMap) {
          return NODEFS.flagsToPermissionStringMap[flags];
        } else {
          return flags;
        }
      },node_ops:{getattr:function (node) {
          var path = NODEFS.realPath(node);
          var stat;
          try {
            stat = fs.lstatSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          // node.js v0.10.20 doesn't report blksize and blocks on Windows. Fake them with default blksize of 4096.
          // See http://support.microsoft.com/kb/140365
          if (NODEFS.isWindows && !stat.blksize) {
            stat.blksize = 4096;
          }
          if (NODEFS.isWindows && !stat.blocks) {
            stat.blocks = (stat.size+stat.blksize-1)/stat.blksize|0;
          }
          return {
            dev: stat.dev,
            ino: stat.ino,
            mode: stat.mode,
            nlink: stat.nlink,
            uid: stat.uid,
            gid: stat.gid,
            rdev: stat.rdev,
            size: stat.size,
            atime: stat.atime,
            mtime: stat.mtime,
            ctime: stat.ctime,
            blksize: stat.blksize,
            blocks: stat.blocks
          };
        },setattr:function (node, attr) {
          var path = NODEFS.realPath(node);
          try {
            if (attr.mode !== undefined) {
              fs.chmodSync(path, attr.mode);
              // update the common node structure mode as well
              node.mode = attr.mode;
            }
            if (attr.timestamp !== undefined) {
              var date = new Date(attr.timestamp);
              fs.utimesSync(path, date, date);
            }
            if (attr.size !== undefined) {
              fs.truncateSync(path, attr.size);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },lookup:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          var mode = NODEFS.getMode(path);
          return NODEFS.createNode(parent, name, mode);
        },mknod:function (parent, name, mode, dev) {
          var node = NODEFS.createNode(parent, name, mode, dev);
          // create the backing node for this in the fs root as well
          var path = NODEFS.realPath(node);
          try {
            if (FS.isDir(node.mode)) {
              fs.mkdirSync(path, node.mode);
            } else {
              fs.writeFileSync(path, '', { mode: node.mode });
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return node;
        },rename:function (oldNode, newDir, newName) {
          var oldPath = NODEFS.realPath(oldNode);
          var newPath = PATH.join2(NODEFS.realPath(newDir), newName);
          try {
            fs.renameSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },unlink:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.unlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },rmdir:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.rmdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readdir:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },symlink:function (parent, newName, oldPath) {
          var newPath = PATH.join2(NODEFS.realPath(parent), newName);
          try {
            fs.symlinkSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readlink:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        }},stream_ops:{open:function (stream) {
          var path = NODEFS.realPath(stream.node);
          try {
            if (FS.isFile(stream.node.mode)) {
              stream.nfd = fs.openSync(path, NODEFS.flagsToPermissionString(stream.flags));
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },close:function (stream) {
          try {
            if (FS.isFile(stream.node.mode) && stream.nfd) {
              fs.closeSync(stream.nfd);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },read:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(length);
          var res;
          try {
            res = fs.readSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          if (res > 0) {
            for (var i = 0; i < res; i++) {
              buffer[offset + i] = nbuffer[i];
            }
          }
          return res;
        },write:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(buffer.subarray(offset, offset + length));
          var res;
          try {
            res = fs.writeSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return res;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              try {
                var stat = fs.fstatSync(stream.nfd);
                position += stat.size;
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES[e.code]);
              }
            }
          }
  
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
  
          stream.position = position;
          return position;
        }}};
  
  var _stdin=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stdout=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stderr=allocate(1, "i32*", ALLOC_STATIC);
  
  function _fflush(stream) {
      // int fflush(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fflush.html
      // we don't currently perform any user-space buffering of data
    }var FS={root:null,mounts:[],devices:[null],streams:[],nextInode:1,nameTable:null,currentPath:"/",initialized:false,ignorePermissions:true,ErrnoError:null,genericErrors:{},handleFSError:function (e) {
        if (!(e instanceof FS.ErrnoError)) throw e + ' : ' + stackTrace();
        return ___setErrNo(e.errno);
      },lookupPath:function (path, opts) {
        path = PATH.resolve(FS.cwd(), path);
        opts = opts || {};
  
        var defaults = {
          follow_mount: true,
          recurse_count: 0
        };
        for (var key in defaults) {
          if (opts[key] === undefined) {
            opts[key] = defaults[key];
          }
        }
  
        if (opts.recurse_count > 8) {  // max recursive lookup of 8
          throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
        }
  
        // split the path
        var parts = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), false);
  
        // start at the root
        var current = FS.root;
        var current_path = '/';
  
        for (var i = 0; i < parts.length; i++) {
          var islast = (i === parts.length-1);
          if (islast && opts.parent) {
            // stop resolving
            break;
          }
  
          current = FS.lookupNode(current, parts[i]);
          current_path = PATH.join2(current_path, parts[i]);
  
          // jump to the mount's root node if this is a mountpoint
          if (FS.isMountpoint(current)) {
            if (!islast || (islast && opts.follow_mount)) {
              current = current.mounted.root;
            }
          }
  
          // by default, lookupPath will not follow a symlink if it is the final path component.
          // setting opts.follow = true will override this behavior.
          if (!islast || opts.follow) {
            var count = 0;
            while (FS.isLink(current.mode)) {
              var link = FS.readlink(current_path);
              current_path = PATH.resolve(PATH.dirname(current_path), link);
              
              var lookup = FS.lookupPath(current_path, { recurse_count: opts.recurse_count });
              current = lookup.node;
  
              if (count++ > 40) {  // limit max consecutive symlinks to 40 (SYMLOOP_MAX).
                throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
              }
            }
          }
        }
  
        return { path: current_path, node: current };
      },getPath:function (node) {
        var path;
        while (true) {
          if (FS.isRoot(node)) {
            var mount = node.mount.mountpoint;
            if (!path) return mount;
            return mount[mount.length-1] !== '/' ? mount + '/' + path : mount + path;
          }
          path = path ? node.name + '/' + path : node.name;
          node = node.parent;
        }
      },hashName:function (parentid, name) {
        var hash = 0;
  
  
        for (var i = 0; i < name.length; i++) {
          hash = ((hash << 5) - hash + name.charCodeAt(i)) | 0;
        }
        return ((parentid + hash) >>> 0) % FS.nameTable.length;
      },hashAddNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        node.name_next = FS.nameTable[hash];
        FS.nameTable[hash] = node;
      },hashRemoveNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        if (FS.nameTable[hash] === node) {
          FS.nameTable[hash] = node.name_next;
        } else {
          var current = FS.nameTable[hash];
          while (current) {
            if (current.name_next === node) {
              current.name_next = node.name_next;
              break;
            }
            current = current.name_next;
          }
        }
      },lookupNode:function (parent, name) {
        var err = FS.mayLookup(parent);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        var hash = FS.hashName(parent.id, name);
        for (var node = FS.nameTable[hash]; node; node = node.name_next) {
          var nodeName = node.name;
          if (node.parent.id === parent.id && nodeName === name) {
            return node;
          }
        }
        // if we failed to find it in the cache, call into the VFS
        return FS.lookup(parent, name);
      },createNode:function (parent, name, mode, rdev) {
        if (!FS.FSNode) {
          FS.FSNode = function(parent, name, mode, rdev) {
            if (!parent) {
              parent = this;  // root node sets parent to itself
            }
            this.parent = parent;
            this.mount = parent.mount;
            this.mounted = null;
            this.id = FS.nextInode++;
            this.name = name;
            this.mode = mode;
            this.node_ops = {};
            this.stream_ops = {};
            this.rdev = rdev;
          };
  
          FS.FSNode.prototype = {};
  
          // compatibility
          var readMode = 292 | 73;
          var writeMode = 146;
  
          // NOTE we must use Object.defineProperties instead of individual calls to
          // Object.defineProperty in order to make closure compiler happy
          Object.defineProperties(FS.FSNode.prototype, {
            read: {
              get: function() { return (this.mode & readMode) === readMode; },
              set: function(val) { val ? this.mode |= readMode : this.mode &= ~readMode; }
            },
            write: {
              get: function() { return (this.mode & writeMode) === writeMode; },
              set: function(val) { val ? this.mode |= writeMode : this.mode &= ~writeMode; }
            },
            isFolder: {
              get: function() { return FS.isDir(this.mode); },
            },
            isDevice: {
              get: function() { return FS.isChrdev(this.mode); },
            },
          });
        }
  
        var node = new FS.FSNode(parent, name, mode, rdev);
  
        FS.hashAddNode(node);
  
        return node;
      },destroyNode:function (node) {
        FS.hashRemoveNode(node);
      },isRoot:function (node) {
        return node === node.parent;
      },isMountpoint:function (node) {
        return !!node.mounted;
      },isFile:function (mode) {
        return (mode & 61440) === 32768;
      },isDir:function (mode) {
        return (mode & 61440) === 16384;
      },isLink:function (mode) {
        return (mode & 61440) === 40960;
      },isChrdev:function (mode) {
        return (mode & 61440) === 8192;
      },isBlkdev:function (mode) {
        return (mode & 61440) === 24576;
      },isFIFO:function (mode) {
        return (mode & 61440) === 4096;
      },isSocket:function (mode) {
        return (mode & 49152) === 49152;
      },flagModes:{"r":0,"rs":1052672,"r+":2,"w":577,"wx":705,"xw":705,"w+":578,"wx+":706,"xw+":706,"a":1089,"ax":1217,"xa":1217,"a+":1090,"ax+":1218,"xa+":1218},modeStringToFlags:function (str) {
        var flags = FS.flagModes[str];
        if (typeof flags === 'undefined') {
          throw new Error('Unknown file open mode: ' + str);
        }
        return flags;
      },flagsToPermissionString:function (flag) {
        var accmode = flag & 2097155;
        var perms = ['r', 'w', 'rw'][accmode];
        if ((flag & 512)) {
          perms += 'w';
        }
        return perms;
      },nodePermissions:function (node, perms) {
        if (FS.ignorePermissions) {
          return 0;
        }
        // return 0 if any user, group or owner bits are set.
        if (perms.indexOf('r') !== -1 && !(node.mode & 292)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('w') !== -1 && !(node.mode & 146)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('x') !== -1 && !(node.mode & 73)) {
          return ERRNO_CODES.EACCES;
        }
        return 0;
      },mayLookup:function (dir) {
        return FS.nodePermissions(dir, 'x');
      },mayCreate:function (dir, name) {
        try {
          var node = FS.lookupNode(dir, name);
          return ERRNO_CODES.EEXIST;
        } catch (e) {
        }
        return FS.nodePermissions(dir, 'wx');
      },mayDelete:function (dir, name, isdir) {
        var node;
        try {
          node = FS.lookupNode(dir, name);
        } catch (e) {
          return e.errno;
        }
        var err = FS.nodePermissions(dir, 'wx');
        if (err) {
          return err;
        }
        if (isdir) {
          if (!FS.isDir(node.mode)) {
            return ERRNO_CODES.ENOTDIR;
          }
          if (FS.isRoot(node) || FS.getPath(node) === FS.cwd()) {
            return ERRNO_CODES.EBUSY;
          }
        } else {
          if (FS.isDir(node.mode)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return 0;
      },mayOpen:function (node, flags) {
        if (!node) {
          return ERRNO_CODES.ENOENT;
        }
        if (FS.isLink(node.mode)) {
          return ERRNO_CODES.ELOOP;
        } else if (FS.isDir(node.mode)) {
          if ((flags & 2097155) !== 0 ||  // opening for write
              (flags & 512)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return FS.nodePermissions(node, FS.flagsToPermissionString(flags));
      },MAX_OPEN_FDS:4096,nextfd:function (fd_start, fd_end) {
        fd_start = fd_start || 0;
        fd_end = fd_end || FS.MAX_OPEN_FDS;
        for (var fd = fd_start; fd <= fd_end; fd++) {
          if (!FS.streams[fd]) {
            return fd;
          }
        }
        throw new FS.ErrnoError(ERRNO_CODES.EMFILE);
      },getStream:function (fd) {
        return FS.streams[fd];
      },createStream:function (stream, fd_start, fd_end) {
        if (!FS.FSStream) {
          FS.FSStream = function(){};
          FS.FSStream.prototype = {};
          // compatibility
          Object.defineProperties(FS.FSStream.prototype, {
            object: {
              get: function() { return this.node; },
              set: function(val) { this.node = val; }
            },
            isRead: {
              get: function() { return (this.flags & 2097155) !== 1; }
            },
            isWrite: {
              get: function() { return (this.flags & 2097155) !== 0; }
            },
            isAppend: {
              get: function() { return (this.flags & 1024); }
            }
          });
        }
        if (stream.__proto__) {
          // reuse the object
          stream.__proto__ = FS.FSStream.prototype;
        } else {
          var newStream = new FS.FSStream();
          for (var p in stream) {
            newStream[p] = stream[p];
          }
          stream = newStream;
        }
        var fd = FS.nextfd(fd_start, fd_end);
        stream.fd = fd;
        FS.streams[fd] = stream;
        return stream;
      },closeStream:function (fd) {
        FS.streams[fd] = null;
      },getStreamFromPtr:function (ptr) {
        return FS.streams[ptr - 1];
      },getPtrForStream:function (stream) {
        return stream ? stream.fd + 1 : 0;
      },chrdev_stream_ops:{open:function (stream) {
          var device = FS.getDevice(stream.node.rdev);
          // override node's stream ops with the device's
          stream.stream_ops = device.stream_ops;
          // forward the open call
          if (stream.stream_ops.open) {
            stream.stream_ops.open(stream);
          }
        },llseek:function () {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }},major:function (dev) {
        return ((dev) >> 8);
      },minor:function (dev) {
        return ((dev) & 0xff);
      },makedev:function (ma, mi) {
        return ((ma) << 8 | (mi));
      },registerDevice:function (dev, ops) {
        FS.devices[dev] = { stream_ops: ops };
      },getDevice:function (dev) {
        return FS.devices[dev];
      },getMounts:function (mount) {
        var mounts = [];
        var check = [mount];
  
        while (check.length) {
          var m = check.pop();
  
          mounts.push(m);
  
          check.push.apply(check, m.mounts);
        }
  
        return mounts;
      },syncfs:function (populate, callback) {
        if (typeof(populate) === 'function') {
          callback = populate;
          populate = false;
        }
  
        var mounts = FS.getMounts(FS.root.mount);
        var completed = 0;
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= mounts.length) {
            callback(null);
          }
        };
  
        // sync all mounts
        mounts.forEach(function (mount) {
          if (!mount.type.syncfs) {
            return done(null);
          }
          mount.type.syncfs(mount, populate, done);
        });
      },mount:function (type, opts, mountpoint) {
        var root = mountpoint === '/';
        var pseudo = !mountpoint;
        var node;
  
        if (root && FS.root) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        } else if (!root && !pseudo) {
          var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
          mountpoint = lookup.path;  // use the absolute path
          node = lookup.node;
  
          if (FS.isMountpoint(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
          }
  
          if (!FS.isDir(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
          }
        }
  
        var mount = {
          type: type,
          opts: opts,
          mountpoint: mountpoint,
          mounts: []
        };
  
        // create a root node for the fs
        var mountRoot = type.mount(mount);
        mountRoot.mount = mount;
        mount.root = mountRoot;
  
        if (root) {
          FS.root = mountRoot;
        } else if (node) {
          // set as a mountpoint
          node.mounted = mount;
  
          // add the new mount to the current mount's children
          if (node.mount) {
            node.mount.mounts.push(mount);
          }
        }
  
        return mountRoot;
      },unmount:function (mountpoint) {
        var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
        if (!FS.isMountpoint(lookup.node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
  
        // destroy the nodes for this mount, and all its child mounts
        var node = lookup.node;
        var mount = node.mounted;
        var mounts = FS.getMounts(mount);
  
        Object.keys(FS.nameTable).forEach(function (hash) {
          var current = FS.nameTable[hash];
  
          while (current) {
            var next = current.name_next;
  
            if (mounts.indexOf(current.mount) !== -1) {
              FS.destroyNode(current);
            }
  
            current = next;
          }
        });
  
        // no longer a mountpoint
        node.mounted = null;
  
        // remove this mount from the child mounts
        var idx = node.mount.mounts.indexOf(mount);
        assert(idx !== -1);
        node.mount.mounts.splice(idx, 1);
      },lookup:function (parent, name) {
        return parent.node_ops.lookup(parent, name);
      },mknod:function (path, mode, dev) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var err = FS.mayCreate(parent, name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.mknod) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.mknod(parent, name, mode, dev);
      },create:function (path, mode) {
        mode = mode !== undefined ? mode : 438 /* 0666 */;
        mode &= 4095;
        mode |= 32768;
        return FS.mknod(path, mode, 0);
      },mkdir:function (path, mode) {
        mode = mode !== undefined ? mode : 511 /* 0777 */;
        mode &= 511 | 512;
        mode |= 16384;
        return FS.mknod(path, mode, 0);
      },mkdev:function (path, mode, dev) {
        if (typeof(dev) === 'undefined') {
          dev = mode;
          mode = 438 /* 0666 */;
        }
        mode |= 8192;
        return FS.mknod(path, mode, dev);
      },symlink:function (oldpath, newpath) {
        var lookup = FS.lookupPath(newpath, { parent: true });
        var parent = lookup.node;
        var newname = PATH.basename(newpath);
        var err = FS.mayCreate(parent, newname);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.symlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.symlink(parent, newname, oldpath);
      },rename:function (old_path, new_path) {
        var old_dirname = PATH.dirname(old_path);
        var new_dirname = PATH.dirname(new_path);
        var old_name = PATH.basename(old_path);
        var new_name = PATH.basename(new_path);
        // parents must exist
        var lookup, old_dir, new_dir;
        try {
          lookup = FS.lookupPath(old_path, { parent: true });
          old_dir = lookup.node;
          lookup = FS.lookupPath(new_path, { parent: true });
          new_dir = lookup.node;
        } catch (e) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // need to be part of the same mount
        if (old_dir.mount !== new_dir.mount) {
          throw new FS.ErrnoError(ERRNO_CODES.EXDEV);
        }
        // source must exist
        var old_node = FS.lookupNode(old_dir, old_name);
        // old path should not be an ancestor of the new path
        var relative = PATH.relative(old_path, new_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        // new path should not be an ancestor of the old path
        relative = PATH.relative(new_path, old_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
        }
        // see if the new path already exists
        var new_node;
        try {
          new_node = FS.lookupNode(new_dir, new_name);
        } catch (e) {
          // not fatal
        }
        // early out if nothing needs to change
        if (old_node === new_node) {
          return;
        }
        // we'll need to delete the old entry
        var isdir = FS.isDir(old_node.mode);
        var err = FS.mayDelete(old_dir, old_name, isdir);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // need delete permissions if we'll be overwriting.
        // need create permissions if new doesn't already exist.
        err = new_node ?
          FS.mayDelete(new_dir, new_name, isdir) :
          FS.mayCreate(new_dir, new_name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!old_dir.node_ops.rename) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(old_node) || (new_node && FS.isMountpoint(new_node))) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // if we are going to change the parent, check write permissions
        if (new_dir !== old_dir) {
          err = FS.nodePermissions(old_dir, 'w');
          if (err) {
            throw new FS.ErrnoError(err);
          }
        }
        // remove the node from the lookup hash
        FS.hashRemoveNode(old_node);
        // do the underlying fs rename
        try {
          old_dir.node_ops.rename(old_node, new_dir, new_name);
        } catch (e) {
          throw e;
        } finally {
          // add the node back to the hash (in case node_ops.rename
          // changed its name)
          FS.hashAddNode(old_node);
        }
      },rmdir:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, true);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.rmdir) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.rmdir(parent, name);
        FS.destroyNode(node);
      },readdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        if (!node.node_ops.readdir) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        return node.node_ops.readdir(node);
      },unlink:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, false);
        if (err) {
          // POSIX says unlink should set EPERM, not EISDIR
          if (err === ERRNO_CODES.EISDIR) err = ERRNO_CODES.EPERM;
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.unlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.unlink(parent, name);
        FS.destroyNode(node);
      },readlink:function (path) {
        var lookup = FS.lookupPath(path);
        var link = lookup.node;
        if (!link.node_ops.readlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        return link.node_ops.readlink(link);
      },stat:function (path, dontFollow) {
        var lookup = FS.lookupPath(path, { follow: !dontFollow });
        var node = lookup.node;
        if (!node.node_ops.getattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return node.node_ops.getattr(node);
      },lstat:function (path) {
        return FS.stat(path, true);
      },chmod:function (path, mode, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          mode: (mode & 4095) | (node.mode & ~4095),
          timestamp: Date.now()
        });
      },lchmod:function (path, mode) {
        FS.chmod(path, mode, true);
      },fchmod:function (fd, mode) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chmod(stream.node, mode);
      },chown:function (path, uid, gid, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          timestamp: Date.now()
          // we ignore the uid / gid for now
        });
      },lchown:function (path, uid, gid) {
        FS.chown(path, uid, gid, true);
      },fchown:function (fd, uid, gid) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chown(stream.node, uid, gid);
      },truncate:function (path, len) {
        if (len < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: true });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!FS.isFile(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var err = FS.nodePermissions(node, 'w');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        node.node_ops.setattr(node, {
          size: len,
          timestamp: Date.now()
        });
      },ftruncate:function (fd, len) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        FS.truncate(stream.node, len);
      },utime:function (path, atime, mtime) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        node.node_ops.setattr(node, {
          timestamp: Math.max(atime, mtime)
        });
      },open:function (path, flags, mode, fd_start, fd_end) {
        flags = typeof flags === 'string' ? FS.modeStringToFlags(flags) : flags;
        mode = typeof mode === 'undefined' ? 438 /* 0666 */ : mode;
        if ((flags & 64)) {
          mode = (mode & 4095) | 32768;
        } else {
          mode = 0;
        }
        var node;
        if (typeof path === 'object') {
          node = path;
        } else {
          path = PATH.normalize(path);
          try {
            var lookup = FS.lookupPath(path, {
              follow: !(flags & 131072)
            });
            node = lookup.node;
          } catch (e) {
            // ignore
          }
        }
        // perhaps we need to create the node
        if ((flags & 64)) {
          if (node) {
            // if O_CREAT and O_EXCL are set, error out if the node already exists
            if ((flags & 128)) {
              throw new FS.ErrnoError(ERRNO_CODES.EEXIST);
            }
          } else {
            // node doesn't exist, try to create it
            node = FS.mknod(path, mode, 0);
          }
        }
        if (!node) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
        }
        // can't truncate a device
        if (FS.isChrdev(node.mode)) {
          flags &= ~512;
        }
        // check permissions
        var err = FS.mayOpen(node, flags);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // do truncation if necessary
        if ((flags & 512)) {
          FS.truncate(node, 0);
        }
        // we've already handled these, don't pass down to the underlying vfs
        flags &= ~(128 | 512);
  
        // register the stream with the filesystem
        var stream = FS.createStream({
          node: node,
          path: FS.getPath(node),  // we want the absolute path to the node
          flags: flags,
          seekable: true,
          position: 0,
          stream_ops: node.stream_ops,
          // used by the file family libc calls (fopen, fwrite, ferror, etc.)
          ungotten: [],
          error: false
        }, fd_start, fd_end);
        // call the new stream's open function
        if (stream.stream_ops.open) {
          stream.stream_ops.open(stream);
        }
        if (Module['logReadFiles'] && !(flags & 1)) {
          if (!FS.readFiles) FS.readFiles = {};
          if (!(path in FS.readFiles)) {
            FS.readFiles[path] = 1;
            Module['printErr']('read file: ' + path);
          }
        }
        return stream;
      },close:function (stream) {
        try {
          if (stream.stream_ops.close) {
            stream.stream_ops.close(stream);
          }
        } catch (e) {
          throw e;
        } finally {
          FS.closeStream(stream.fd);
        }
      },llseek:function (stream, offset, whence) {
        if (!stream.seekable || !stream.stream_ops.llseek) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        return stream.stream_ops.llseek(stream, offset, whence);
      },read:function (stream, buffer, offset, length, position) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.read) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        var bytesRead = stream.stream_ops.read(stream, buffer, offset, length, position);
        if (!seeking) stream.position += bytesRead;
        return bytesRead;
      },write:function (stream, buffer, offset, length, position, canOwn) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.write) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        if (stream.flags & 1024) {
          // seek to the end before writing in append mode
          FS.llseek(stream, 0, 2);
        }
        var bytesWritten = stream.stream_ops.write(stream, buffer, offset, length, position, canOwn);
        if (!seeking) stream.position += bytesWritten;
        return bytesWritten;
      },allocate:function (stream, offset, length) {
        if (offset < 0 || length <= 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (!FS.isFile(stream.node.mode) && !FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        if (!stream.stream_ops.allocate) {
          throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
        }
        stream.stream_ops.allocate(stream, offset, length);
      },mmap:function (stream, buffer, offset, length, position, prot, flags) {
        // TODO if PROT is PROT_WRITE, make sure we have write access
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EACCES);
        }
        if (!stream.stream_ops.mmap) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        return stream.stream_ops.mmap(stream, buffer, offset, length, position, prot, flags);
      },ioctl:function (stream, cmd, arg) {
        if (!stream.stream_ops.ioctl) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTTY);
        }
        return stream.stream_ops.ioctl(stream, cmd, arg);
      },readFile:function (path, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'r';
        opts.encoding = opts.encoding || 'binary';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var ret;
        var stream = FS.open(path, opts.flags);
        var stat = FS.stat(path);
        var length = stat.size;
        var buf = new Uint8Array(length);
        FS.read(stream, buf, 0, length, 0);
        if (opts.encoding === 'utf8') {
          ret = '';
          var utf8 = new Runtime.UTF8Processor();
          for (var i = 0; i < length; i++) {
            ret += utf8.processCChar(buf[i]);
          }
        } else if (opts.encoding === 'binary') {
          ret = buf;
        }
        FS.close(stream);
        return ret;
      },writeFile:function (path, data, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'w';
        opts.encoding = opts.encoding || 'utf8';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var stream = FS.open(path, opts.flags, opts.mode);
        if (opts.encoding === 'utf8') {
          var utf8 = new Runtime.UTF8Processor();
          var buf = new Uint8Array(utf8.processJSString(data));
          FS.write(stream, buf, 0, buf.length, 0, opts.canOwn);
        } else if (opts.encoding === 'binary') {
          FS.write(stream, data, 0, data.length, 0, opts.canOwn);
        }
        FS.close(stream);
      },cwd:function () {
        return FS.currentPath;
      },chdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        if (!FS.isDir(lookup.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        var err = FS.nodePermissions(lookup.node, 'x');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        FS.currentPath = lookup.path;
      },createDefaultDirectories:function () {
        FS.mkdir('/tmp');
      },createDefaultDevices:function () {
        // create /dev
        FS.mkdir('/dev');
        // setup /dev/null
        FS.registerDevice(FS.makedev(1, 3), {
          read: function() { return 0; },
          write: function() { return 0; }
        });
        FS.mkdev('/dev/null', FS.makedev(1, 3));
        // setup /dev/tty and /dev/tty1
        // stderr needs to print output using Module['printErr']
        // so we register a second tty just for it.
        TTY.register(FS.makedev(5, 0), TTY.default_tty_ops);
        TTY.register(FS.makedev(6, 0), TTY.default_tty1_ops);
        FS.mkdev('/dev/tty', FS.makedev(5, 0));
        FS.mkdev('/dev/tty1', FS.makedev(6, 0));
        // we're not going to emulate the actual shm device,
        // just create the tmp dirs that reside in it commonly
        FS.mkdir('/dev/shm');
        FS.mkdir('/dev/shm/tmp');
      },createStandardStreams:function () {
        // TODO deprecate the old functionality of a single
        // input / output callback and that utilizes FS.createDevice
        // and instead require a unique set of stream ops
  
        // by default, we symlink the standard streams to the
        // default tty devices. however, if the standard streams
        // have been overwritten we create a unique device for
        // them instead.
        if (Module['stdin']) {
          FS.createDevice('/dev', 'stdin', Module['stdin']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdin');
        }
        if (Module['stdout']) {
          FS.createDevice('/dev', 'stdout', null, Module['stdout']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdout');
        }
        if (Module['stderr']) {
          FS.createDevice('/dev', 'stderr', null, Module['stderr']);
        } else {
          FS.symlink('/dev/tty1', '/dev/stderr');
        }
  
        // open default streams for the stdin, stdout and stderr devices
        var stdin = FS.open('/dev/stdin', 'r');
        HEAP32[((_stdin)>>2)]=FS.getPtrForStream(stdin);
        assert(stdin.fd === 0, 'invalid handle for stdin (' + stdin.fd + ')');
  
        var stdout = FS.open('/dev/stdout', 'w');
        HEAP32[((_stdout)>>2)]=FS.getPtrForStream(stdout);
        assert(stdout.fd === 1, 'invalid handle for stdout (' + stdout.fd + ')');
  
        var stderr = FS.open('/dev/stderr', 'w');
        HEAP32[((_stderr)>>2)]=FS.getPtrForStream(stderr);
        assert(stderr.fd === 2, 'invalid handle for stderr (' + stderr.fd + ')');
      },ensureErrnoError:function () {
        if (FS.ErrnoError) return;
        FS.ErrnoError = function ErrnoError(errno) {
          this.errno = errno;
          for (var key in ERRNO_CODES) {
            if (ERRNO_CODES[key] === errno) {
              this.code = key;
              break;
            }
          }
          this.message = ERRNO_MESSAGES[errno];
        };
        FS.ErrnoError.prototype = new Error();
        FS.ErrnoError.prototype.constructor = FS.ErrnoError;
        // Some errors may happen quite a bit, to avoid overhead we reuse them (and suffer a lack of stack info)
        [ERRNO_CODES.ENOENT].forEach(function(code) {
          FS.genericErrors[code] = new FS.ErrnoError(code);
          FS.genericErrors[code].stack = '<generic error, no stack>';
        });
      },staticInit:function () {
        FS.ensureErrnoError();
  
        FS.nameTable = new Array(4096);
  
        FS.mount(MEMFS, {}, '/');
  
        FS.createDefaultDirectories();
        FS.createDefaultDevices();
      },init:function (input, output, error) {
        assert(!FS.init.initialized, 'FS.init was previously called. If you want to initialize later with custom parameters, remove any earlier calls (note that one is automatically added to the generated code)');
        FS.init.initialized = true;
  
        FS.ensureErrnoError();
  
        // Allow Module.stdin etc. to provide defaults, if none explicitly passed to us here
        Module['stdin'] = input || Module['stdin'];
        Module['stdout'] = output || Module['stdout'];
        Module['stderr'] = error || Module['stderr'];
  
        FS.createStandardStreams();
      },quit:function () {
        FS.init.initialized = false;
        for (var i = 0; i < FS.streams.length; i++) {
          var stream = FS.streams[i];
          if (!stream) {
            continue;
          }
          FS.close(stream);
        }
      },getMode:function (canRead, canWrite) {
        var mode = 0;
        if (canRead) mode |= 292 | 73;
        if (canWrite) mode |= 146;
        return mode;
      },joinPath:function (parts, forceRelative) {
        var path = PATH.join.apply(null, parts);
        if (forceRelative && path[0] == '/') path = path.substr(1);
        return path;
      },absolutePath:function (relative, base) {
        return PATH.resolve(base, relative);
      },standardizePath:function (path) {
        return PATH.normalize(path);
      },findObject:function (path, dontResolveLastLink) {
        var ret = FS.analyzePath(path, dontResolveLastLink);
        if (ret.exists) {
          return ret.object;
        } else {
          ___setErrNo(ret.error);
          return null;
        }
      },analyzePath:function (path, dontResolveLastLink) {
        // operate from within the context of the symlink's target
        try {
          var lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          path = lookup.path;
        } catch (e) {
        }
        var ret = {
          isRoot: false, exists: false, error: 0, name: null, path: null, object: null,
          parentExists: false, parentPath: null, parentObject: null
        };
        try {
          var lookup = FS.lookupPath(path, { parent: true });
          ret.parentExists = true;
          ret.parentPath = lookup.path;
          ret.parentObject = lookup.node;
          ret.name = PATH.basename(path);
          lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          ret.exists = true;
          ret.path = lookup.path;
          ret.object = lookup.node;
          ret.name = lookup.node.name;
          ret.isRoot = lookup.path === '/';
        } catch (e) {
          ret.error = e.errno;
        };
        return ret;
      },createFolder:function (parent, name, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.mkdir(path, mode);
      },createPath:function (parent, path, canRead, canWrite) {
        parent = typeof parent === 'string' ? parent : FS.getPath(parent);
        var parts = path.split('/').reverse();
        while (parts.length) {
          var part = parts.pop();
          if (!part) continue;
          var current = PATH.join2(parent, part);
          try {
            FS.mkdir(current);
          } catch (e) {
            // ignore EEXIST
          }
          parent = current;
        }
        return current;
      },createFile:function (parent, name, properties, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.create(path, mode);
      },createDataFile:function (parent, name, data, canRead, canWrite, canOwn) {
        var path = name ? PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name) : parent;
        var mode = FS.getMode(canRead, canWrite);
        var node = FS.create(path, mode);
        if (data) {
          if (typeof data === 'string') {
            var arr = new Array(data.length);
            for (var i = 0, len = data.length; i < len; ++i) arr[i] = data.charCodeAt(i);
            data = arr;
          }
          // make sure we can write to the file
          FS.chmod(node, mode | 146);
          var stream = FS.open(node, 'w');
          FS.write(stream, data, 0, data.length, 0, canOwn);
          FS.close(stream);
          FS.chmod(node, mode);
        }
        return node;
      },createDevice:function (parent, name, input, output) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(!!input, !!output);
        if (!FS.createDevice.major) FS.createDevice.major = 64;
        var dev = FS.makedev(FS.createDevice.major++, 0);
        // Create a fake device that a set of stream ops to emulate
        // the old behavior.
        FS.registerDevice(dev, {
          open: function(stream) {
            stream.seekable = false;
          },
          close: function(stream) {
            // flush any pending line data
            if (output && output.buffer && output.buffer.length) {
              output(10);
            }
          },
          read: function(stream, buffer, offset, length, pos /* ignored */) {
            var bytesRead = 0;
            for (var i = 0; i < length; i++) {
              var result;
              try {
                result = input();
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
              if (result === undefined && bytesRead === 0) {
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
              if (result === null || result === undefined) break;
              bytesRead++;
              buffer[offset+i] = result;
            }
            if (bytesRead) {
              stream.node.timestamp = Date.now();
            }
            return bytesRead;
          },
          write: function(stream, buffer, offset, length, pos) {
            for (var i = 0; i < length; i++) {
              try {
                output(buffer[offset+i]);
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
            }
            if (length) {
              stream.node.timestamp = Date.now();
            }
            return i;
          }
        });
        return FS.mkdev(path, mode, dev);
      },createLink:function (parent, name, target, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        return FS.symlink(target, path);
      },forceLoadFile:function (obj) {
        if (obj.isDevice || obj.isFolder || obj.link || obj.contents) return true;
        var success = true;
        if (typeof XMLHttpRequest !== 'undefined') {
          throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.");
        } else if (Module['read']) {
          // Command-line.
          try {
            // WARNING: Can't read binary files in V8's d8 or tracemonkey's js, as
            //          read() will try to parse UTF8.
            obj.contents = intArrayFromString(Module['read'](obj.url), true);
          } catch (e) {
            success = false;
          }
        } else {
          throw new Error('Cannot load without read() or XMLHttpRequest.');
        }
        if (!success) ___setErrNo(ERRNO_CODES.EIO);
        return success;
      },createLazyFile:function (parent, name, url, canRead, canWrite) {
        if (typeof XMLHttpRequest !== 'undefined') {
          if (!ENVIRONMENT_IS_WORKER) throw 'Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc';
          // Lazy chunked Uint8Array (implements get and length from Uint8Array). Actual getting is abstracted away for eventual reuse.
          function LazyUint8Array() {
            this.lengthKnown = false;
            this.chunks = []; // Loaded chunks. Index is the chunk number
          }
          LazyUint8Array.prototype.get = function LazyUint8Array_get(idx) {
            if (idx > this.length-1 || idx < 0) {
              return undefined;
            }
            var chunkOffset = idx % this.chunkSize;
            var chunkNum = Math.floor(idx / this.chunkSize);
            return this.getter(chunkNum)[chunkOffset];
          }
          LazyUint8Array.prototype.setDataGetter = function LazyUint8Array_setDataGetter(getter) {
            this.getter = getter;
          }
          LazyUint8Array.prototype.cacheLength = function LazyUint8Array_cacheLength() {
              // Find length
              var xhr = new XMLHttpRequest();
              xhr.open('HEAD', url, false);
              xhr.send(null);
              if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
              var datalength = Number(xhr.getResponseHeader("Content-length"));
              var header;
              var hasByteServing = (header = xhr.getResponseHeader("Accept-Ranges")) && header === "bytes";
              var chunkSize = 1024*1024; // Chunk size in bytes
  
              if (!hasByteServing) chunkSize = datalength;
  
              // Function to get a range from the remote URL.
              var doXHR = (function(from, to) {
                if (from > to) throw new Error("invalid range (" + from + ", " + to + ") or no bytes requested!");
                if (to > datalength-1) throw new Error("only " + datalength + " bytes available! programmer error!");
  
                // TODO: Use mozResponseArrayBuffer, responseStream, etc. if available.
                var xhr = new XMLHttpRequest();
                xhr.open('GET', url, false);
                if (datalength !== chunkSize) xhr.setRequestHeader("Range", "bytes=" + from + "-" + to);
  
                // Some hints to the browser that we want binary data.
                if (typeof Uint8Array != 'undefined') xhr.responseType = 'arraybuffer';
                if (xhr.overrideMimeType) {
                  xhr.overrideMimeType('text/plain; charset=x-user-defined');
                }
  
                xhr.send(null);
                if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
                if (xhr.response !== undefined) {
                  return new Uint8Array(xhr.response || []);
                } else {
                  return intArrayFromString(xhr.responseText || '', true);
                }
              });
              var lazyArray = this;
              lazyArray.setDataGetter(function(chunkNum) {
                var start = chunkNum * chunkSize;
                var end = (chunkNum+1) * chunkSize - 1; // including this byte
                end = Math.min(end, datalength-1); // if datalength-1 is selected, this is the last block
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") {
                  lazyArray.chunks[chunkNum] = doXHR(start, end);
                }
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") throw new Error("doXHR failed!");
                return lazyArray.chunks[chunkNum];
              });
  
              this._length = datalength;
              this._chunkSize = chunkSize;
              this.lengthKnown = true;
          }
  
          var lazyArray = new LazyUint8Array();
          Object.defineProperty(lazyArray, "length", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._length;
              }
          });
          Object.defineProperty(lazyArray, "chunkSize", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._chunkSize;
              }
          });
  
          var properties = { isDevice: false, contents: lazyArray };
        } else {
          var properties = { isDevice: false, url: url };
        }
  
        var node = FS.createFile(parent, name, properties, canRead, canWrite);
        // This is a total hack, but I want to get this lazy file code out of the
        // core of MEMFS. If we want to keep this lazy file concept I feel it should
        // be its own thin LAZYFS proxying calls to MEMFS.
        if (properties.contents) {
          node.contents = properties.contents;
        } else if (properties.url) {
          node.contents = null;
          node.url = properties.url;
        }
        // override each stream op with one that tries to force load the lazy file first
        var stream_ops = {};
        var keys = Object.keys(node.stream_ops);
        keys.forEach(function(key) {
          var fn = node.stream_ops[key];
          stream_ops[key] = function forceLoadLazyFile() {
            if (!FS.forceLoadFile(node)) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            return fn.apply(null, arguments);
          };
        });
        // use a custom read function
        stream_ops.read = function stream_ops_read(stream, buffer, offset, length, position) {
          if (!FS.forceLoadFile(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EIO);
          }
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (contents.slice) { // normal array
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          } else {
            for (var i = 0; i < size; i++) { // LazyUint8Array from sync binary XHR
              buffer[offset + i] = contents.get(position + i);
            }
          }
          return size;
        };
        node.stream_ops = stream_ops;
        return node;
      },createPreloadedFile:function (parent, name, url, canRead, canWrite, onload, onerror, dontCreateFile, canOwn) {
        Browser.init();
        // TODO we should allow people to just pass in a complete filename instead
        // of parent and name being that we just join them anyways
        var fullname = name ? PATH.resolve(PATH.join2(parent, name)) : parent;
        function processData(byteArray) {
          function finish(byteArray) {
            if (!dontCreateFile) {
              FS.createDataFile(parent, name, byteArray, canRead, canWrite, canOwn);
            }
            if (onload) onload();
            removeRunDependency('cp ' + fullname);
          }
          var handled = false;
          Module['preloadPlugins'].forEach(function(plugin) {
            if (handled) return;
            if (plugin['canHandle'](fullname)) {
              plugin['handle'](byteArray, fullname, finish, function() {
                if (onerror) onerror();
                removeRunDependency('cp ' + fullname);
              });
              handled = true;
            }
          });
          if (!handled) finish(byteArray);
        }
        addRunDependency('cp ' + fullname);
        if (typeof url == 'string') {
          Browser.asyncLoad(url, function(byteArray) {
            processData(byteArray);
          }, onerror);
        } else {
          processData(url);
        }
      },indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_NAME:function () {
        return 'EM_FS_' + window.location.pathname;
      },DB_VERSION:20,DB_STORE_NAME:"FILE_DATA",saveFilesToDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = function openRequest_onupgradeneeded() {
          console.log('creating db');
          var db = openRequest.result;
          db.createObjectStore(FS.DB_STORE_NAME);
        };
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          var transaction = db.transaction([FS.DB_STORE_NAME], 'readwrite');
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var putRequest = files.put(FS.analyzePath(path).object.contents, path);
            putRequest.onsuccess = function putRequest_onsuccess() { ok++; if (ok + fail == total) finish() };
            putRequest.onerror = function putRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      },loadFilesFromDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = onerror; // no database to load from
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          try {
            var transaction = db.transaction([FS.DB_STORE_NAME], 'readonly');
          } catch(e) {
            onerror(e);
            return;
          }
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var getRequest = files.get(path);
            getRequest.onsuccess = function getRequest_onsuccess() {
              if (FS.analyzePath(path).exists) {
                FS.unlink(path);
              }
              FS.createDataFile(PATH.dirname(path), PATH.basename(path), getRequest.result, true, true, true);
              ok++;
              if (ok + fail == total) finish();
            };
            getRequest.onerror = function getRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      }};
  
  function _lseek(fildes, offset, whence) {
      // off_t lseek(int fildes, off_t offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/lseek.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        return FS.llseek(stream, offset, whence);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fileno(stream) {
      // int fileno(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fileno.html
      return FS.getStreamFromPtr(stream).fd;
    }function _fseek(stream, offset, whence) {
      // int fseek(FILE *stream, long offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fseek.html
      var fd = _fileno(stream);
      var ret = _lseek(fd, offset, whence);
      if (ret == -1) {
        return -1;
      }
      stream = FS.getStreamFromPtr(stream);
      stream.eof = false;
      return 0;
    }

  
  function _close(fildes) {
      // int close(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/close.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        FS.close(stream);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fsync(fildes) {
      // int fsync(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fsync.html
      var stream = FS.getStream(fildes);
      if (stream) {
        // We write directly to the file system, so there's nothing to do here.
        return 0;
      } else {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
    }function _fclose(stream) {
      // int fclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fclose.html
      var fd = _fileno(stream);
      _fsync(fd);
      return _close(fd);
    }

  function _pthread_mutex_lock() {}

  
  
  function _isspace(chr) {
      return (chr == 32) || (chr >= 9 && chr <= 13);
    }
  function __parseInt64(str, endptr, base, min, max, unsign) {
      var isNegative = false;
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      if (HEAP8[(str)] == 45) {
        str++;
        isNegative = true;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var ok = false;
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            ok = true; // we saw an initial zero, perhaps the entire thing is just "0"
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
      var start = str;
  
      // Get digits.
      var chr;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          str++;
          ok = true;
        }
      }
  
      if (!ok) {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return ((asm["setTempRet0"](0),0)|0);
      }
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      try {
        var numberString = isNegative ? '-'+Pointer_stringify(start, str - start) : Pointer_stringify(start, str - start);
        i64Math.fromString(numberString, finalBase, min, max, unsign);
      } catch(e) {
        ___setErrNo(ERRNO_CODES.ERANGE); // not quite correct
      }
  
      return ((asm["setTempRet0"](((HEAP32[(((tempDoublePtr)+(4))>>2)])|0)),((HEAP32[((tempDoublePtr)>>2)])|0))|0);
    }function _strtoull(str, endptr, base) {
      return __parseInt64(str, endptr, base, 0, '18446744073709551615', true);  // ULONG_MAX.
    }


  function _lis_solver_create() {
  Module['printErr']('missing function: lis_solver_create'); abort(-1);
  }

  var _emscripten_check_longjmp=true;

  
  function __parseInt(str, endptr, base, min, max, bits, unsign) {
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      var multiplier = 1;
      if (HEAP8[(str)] == 45) {
        multiplier = -1;
        str++;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            str++;
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
  
      // Get digits.
      var chr;
      var ret = 0;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          ret = ret * finalBase + digit;
          str++;
        }
      }
  
      // Apply sign.
      ret *= multiplier;
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      // Unsign if needed.
      if (unsign) {
        if (Math.abs(ret) > max) {
          ret = max;
          ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          ret = unSign(ret, bits);
        }
      }
  
      // Validate range.
      if (ret > max || ret < min) {
        ret = ret > max ? max : min;
        ___setErrNo(ERRNO_CODES.ERANGE);
      }
  
      if (bits == 64) {
        return ((asm["setTempRet0"]((tempDouble=ret,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)),ret>>>0)|0);
      }
  
      return ret;
    }function _strtol(str, endptr, base) {
      return __parseInt(str, endptr, base, -2147483648, 2147483647, 32);  // LONG_MIN, LONG_MAX.
    }

  
  
  
  
  function _mkport() { throw 'TODO' }var SOCKFS={mount:function (mount) {
        return FS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createSocket:function (family, type, protocol) {
        var streaming = type == 1;
        if (protocol) {
          assert(streaming == (protocol == 6)); // if SOCK_STREAM, must be tcp
        }
  
        // create our internal socket structure
        var sock = {
          family: family,
          type: type,
          protocol: protocol,
          server: null,
          peers: {},
          pending: [],
          recv_queue: [],
          sock_ops: SOCKFS.websocket_sock_ops
        };
  
        // create the filesystem node to store the socket structure
        var name = SOCKFS.nextname();
        var node = FS.createNode(SOCKFS.root, name, 49152, 0);
        node.sock = sock;
  
        // and the wrapping stream that enables library functions such
        // as read and write to indirectly interact with the socket
        var stream = FS.createStream({
          path: name,
          node: node,
          flags: FS.modeStringToFlags('r+'),
          seekable: false,
          stream_ops: SOCKFS.stream_ops
        });
  
        // map the new stream to the socket structure (sockets have a 1:1
        // relationship with a stream)
        sock.stream = stream;
  
        return sock;
      },getSocket:function (fd) {
        var stream = FS.getStream(fd);
        if (!stream || !FS.isSocket(stream.node.mode)) {
          return null;
        }
        return stream.node.sock;
      },stream_ops:{poll:function (stream) {
          var sock = stream.node.sock;
          return sock.sock_ops.poll(sock);
        },ioctl:function (stream, request, varargs) {
          var sock = stream.node.sock;
          return sock.sock_ops.ioctl(sock, request, varargs);
        },read:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          var msg = sock.sock_ops.recvmsg(sock, length);
          if (!msg) {
            // socket is closed
            return 0;
          }
          buffer.set(msg.buffer, offset);
          return msg.buffer.length;
        },write:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          return sock.sock_ops.sendmsg(sock, buffer, offset, length);
        },close:function (stream) {
          var sock = stream.node.sock;
          sock.sock_ops.close(sock);
        }},nextname:function () {
        if (!SOCKFS.nextname.current) {
          SOCKFS.nextname.current = 0;
        }
        return 'socket[' + (SOCKFS.nextname.current++) + ']';
      },websocket_sock_ops:{createPeer:function (sock, addr, port) {
          var ws;
  
          if (typeof addr === 'object') {
            ws = addr;
            addr = null;
            port = null;
          }
  
          if (ws) {
            // for sockets that've already connected (e.g. we're the server)
            // we can inspect the _socket property for the address
            if (ws._socket) {
              addr = ws._socket.remoteAddress;
              port = ws._socket.remotePort;
            }
            // if we're just now initializing a connection to the remote,
            // inspect the url property
            else {
              var result = /ws[s]?:\/\/([^:]+):(\d+)/.exec(ws.url);
              if (!result) {
                throw new Error('WebSocket URL must be in the format ws(s)://address:port');
              }
              addr = result[1];
              port = parseInt(result[2], 10);
            }
          } else {
            // create the actual websocket object and connect
            try {
              var url = 'ws://' + addr + ':' + port;
              // the node ws library API is slightly different than the browser's
              var opts = ENVIRONMENT_IS_NODE ? {headers: {'websocket-protocol': ['binary']}} : ['binary'];
              // If node we use the ws library.
              var WebSocket = ENVIRONMENT_IS_NODE ? require('ws') : window['WebSocket'];
              ws = new WebSocket(url, opts);
              ws.binaryType = 'arraybuffer';
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EHOSTUNREACH);
            }
          }
  
  
          var peer = {
            addr: addr,
            port: port,
            socket: ws,
            dgram_send_queue: []
          };
  
          SOCKFS.websocket_sock_ops.addPeer(sock, peer);
          SOCKFS.websocket_sock_ops.handlePeerEvents(sock, peer);
  
          // if this is a bound dgram socket, send the port number first to allow
          // us to override the ephemeral port reported to us by remotePort on the
          // remote end.
          if (sock.type === 2 && typeof sock.sport !== 'undefined') {
            peer.dgram_send_queue.push(new Uint8Array([
                255, 255, 255, 255,
                'p'.charCodeAt(0), 'o'.charCodeAt(0), 'r'.charCodeAt(0), 't'.charCodeAt(0),
                ((sock.sport & 0xff00) >> 8) , (sock.sport & 0xff)
            ]));
          }
  
          return peer;
        },getPeer:function (sock, addr, port) {
          return sock.peers[addr + ':' + port];
        },addPeer:function (sock, peer) {
          sock.peers[peer.addr + ':' + peer.port] = peer;
        },removePeer:function (sock, peer) {
          delete sock.peers[peer.addr + ':' + peer.port];
        },handlePeerEvents:function (sock, peer) {
          var first = true;
  
          var handleOpen = function () {
            try {
              var queued = peer.dgram_send_queue.shift();
              while (queued) {
                peer.socket.send(queued);
                queued = peer.dgram_send_queue.shift();
              }
            } catch (e) {
              // not much we can do here in the way of proper error handling as we've already
              // lied and said this data was sent. shut it down.
              peer.socket.close();
            }
          };
  
          function handleMessage(data) {
            assert(typeof data !== 'string' && data.byteLength !== undefined);  // must receive an ArrayBuffer
            data = new Uint8Array(data);  // make a typed array view on the array buffer
  
  
            // if this is the port message, override the peer's port with it
            var wasfirst = first;
            first = false;
            if (wasfirst &&
                data.length === 10 &&
                data[0] === 255 && data[1] === 255 && data[2] === 255 && data[3] === 255 &&
                data[4] === 'p'.charCodeAt(0) && data[5] === 'o'.charCodeAt(0) && data[6] === 'r'.charCodeAt(0) && data[7] === 't'.charCodeAt(0)) {
              // update the peer's port and it's key in the peer map
              var newport = ((data[8] << 8) | data[9]);
              SOCKFS.websocket_sock_ops.removePeer(sock, peer);
              peer.port = newport;
              SOCKFS.websocket_sock_ops.addPeer(sock, peer);
              return;
            }
  
            sock.recv_queue.push({ addr: peer.addr, port: peer.port, data: data });
          };
  
          if (ENVIRONMENT_IS_NODE) {
            peer.socket.on('open', handleOpen);
            peer.socket.on('message', function(data, flags) {
              if (!flags.binary) {
                return;
              }
              handleMessage((new Uint8Array(data)).buffer);  // copy from node Buffer -> ArrayBuffer
            });
            peer.socket.on('error', function() {
              // don't throw
            });
          } else {
            peer.socket.onopen = handleOpen;
            peer.socket.onmessage = function peer_socket_onmessage(event) {
              handleMessage(event.data);
            };
          }
        },poll:function (sock) {
          if (sock.type === 1 && sock.server) {
            // listen sockets should only say they're available for reading
            // if there are pending clients.
            return sock.pending.length ? (64 | 1) : 0;
          }
  
          var mask = 0;
          var dest = sock.type === 1 ?  // we only care about the socket state for connection-based sockets
            SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport) :
            null;
  
          if (sock.recv_queue.length ||
              !dest ||  // connection-less sockets are always ready to read
              (dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {  // let recv return 0 once closed
            mask |= (64 | 1);
          }
  
          if (!dest ||  // connection-less sockets are always ready to write
              (dest && dest.socket.readyState === dest.socket.OPEN)) {
            mask |= 4;
          }
  
          if ((dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {
            mask |= 16;
          }
  
          return mask;
        },ioctl:function (sock, request, arg) {
          switch (request) {
            case 21531:
              var bytes = 0;
              if (sock.recv_queue.length) {
                bytes = sock.recv_queue[0].data.length;
              }
              HEAP32[((arg)>>2)]=bytes;
              return 0;
            default:
              return ERRNO_CODES.EINVAL;
          }
        },close:function (sock) {
          // if we've spawned a listen server, close it
          if (sock.server) {
            try {
              sock.server.close();
            } catch (e) {
            }
            sock.server = null;
          }
          // close any peer connections
          var peers = Object.keys(sock.peers);
          for (var i = 0; i < peers.length; i++) {
            var peer = sock.peers[peers[i]];
            try {
              peer.socket.close();
            } catch (e) {
            }
            SOCKFS.websocket_sock_ops.removePeer(sock, peer);
          }
          return 0;
        },bind:function (sock, addr, port) {
          if (typeof sock.saddr !== 'undefined' || typeof sock.sport !== 'undefined') {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already bound
          }
          sock.saddr = addr;
          sock.sport = port || _mkport();
          // in order to emulate dgram sockets, we need to launch a listen server when
          // binding on a connection-less socket
          // note: this is only required on the server side
          if (sock.type === 2) {
            // close the existing server if it exists
            if (sock.server) {
              sock.server.close();
              sock.server = null;
            }
            // swallow error operation not supported error that occurs when binding in the
            // browser where this isn't supported
            try {
              sock.sock_ops.listen(sock, 0);
            } catch (e) {
              if (!(e instanceof FS.ErrnoError)) throw e;
              if (e.errno !== ERRNO_CODES.EOPNOTSUPP) throw e;
            }
          }
        },connect:function (sock, addr, port) {
          if (sock.server) {
            throw new FS.ErrnoError(ERRNO_CODS.EOPNOTSUPP);
          }
  
          // TODO autobind
          // if (!sock.addr && sock.type == 2) {
          // }
  
          // early out if we're already connected / in the middle of connecting
          if (typeof sock.daddr !== 'undefined' && typeof sock.dport !== 'undefined') {
            var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
            if (dest) {
              if (dest.socket.readyState === dest.socket.CONNECTING) {
                throw new FS.ErrnoError(ERRNO_CODES.EALREADY);
              } else {
                throw new FS.ErrnoError(ERRNO_CODES.EISCONN);
              }
            }
          }
  
          // add the socket to our peer list and set our
          // destination address / port to match
          var peer = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
          sock.daddr = peer.addr;
          sock.dport = peer.port;
  
          // always "fail" in non-blocking mode
          throw new FS.ErrnoError(ERRNO_CODES.EINPROGRESS);
        },listen:function (sock, backlog) {
          if (!ENVIRONMENT_IS_NODE) {
            throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
          }
          if (sock.server) {
             throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already listening
          }
          var WebSocketServer = require('ws').Server;
          var host = sock.saddr;
          sock.server = new WebSocketServer({
            host: host,
            port: sock.sport
            // TODO support backlog
          });
  
          sock.server.on('connection', function(ws) {
            if (sock.type === 1) {
              var newsock = SOCKFS.createSocket(sock.family, sock.type, sock.protocol);
  
              // create a peer on the new socket
              var peer = SOCKFS.websocket_sock_ops.createPeer(newsock, ws);
              newsock.daddr = peer.addr;
              newsock.dport = peer.port;
  
              // push to queue for accept to pick up
              sock.pending.push(newsock);
            } else {
              // create a peer on the listen socket so calling sendto
              // with the listen socket and an address will resolve
              // to the correct client
              SOCKFS.websocket_sock_ops.createPeer(sock, ws);
            }
          });
          sock.server.on('closed', function() {
            sock.server = null;
          });
          sock.server.on('error', function() {
            // don't throw
          });
        },accept:function (listensock) {
          if (!listensock.server) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          var newsock = listensock.pending.shift();
          newsock.stream.flags = listensock.stream.flags;
          return newsock;
        },getname:function (sock, peer) {
          var addr, port;
          if (peer) {
            if (sock.daddr === undefined || sock.dport === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            }
            addr = sock.daddr;
            port = sock.dport;
          } else {
            // TODO saddr and sport will be set for bind()'d UDP sockets, but what
            // should we be returning for TCP sockets that've been connect()'d?
            addr = sock.saddr || 0;
            port = sock.sport || 0;
          }
          return { addr: addr, port: port };
        },sendmsg:function (sock, buffer, offset, length, addr, port) {
          if (sock.type === 2) {
            // connection-less sockets will honor the message address,
            // and otherwise fall back to the bound destination address
            if (addr === undefined || port === undefined) {
              addr = sock.daddr;
              port = sock.dport;
            }
            // if there was no address to fall back to, error out
            if (addr === undefined || port === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.EDESTADDRREQ);
            }
          } else {
            // connection-based sockets will only use the bound
            addr = sock.daddr;
            port = sock.dport;
          }
  
          // find the peer for the destination address
          var dest = SOCKFS.websocket_sock_ops.getPeer(sock, addr, port);
  
          // early out if not connected with a connection-based socket
          if (sock.type === 1) {
            if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            } else if (dest.socket.readyState === dest.socket.CONNECTING) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // create a copy of the incoming data to send, as the WebSocket API
          // doesn't work entirely with an ArrayBufferView, it'll just send
          // the entire underlying buffer
          var data;
          if (buffer instanceof Array || buffer instanceof ArrayBuffer) {
            data = buffer.slice(offset, offset + length);
          } else {  // ArrayBufferView
            data = buffer.buffer.slice(buffer.byteOffset + offset, buffer.byteOffset + offset + length);
          }
  
          // if we're emulating a connection-less dgram socket and don't have
          // a cached connection, queue the buffer to send upon connect and
          // lie, saying the data was sent now.
          if (sock.type === 2) {
            if (!dest || dest.socket.readyState !== dest.socket.OPEN) {
              // if we're not connected, open a new connection
              if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                dest = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
              }
              dest.dgram_send_queue.push(data);
              return length;
            }
          }
  
          try {
            // send the actual data
            dest.socket.send(data);
            return length;
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
        },recvmsg:function (sock, length) {
          // http://pubs.opengroup.org/onlinepubs/7908799/xns/recvmsg.html
          if (sock.type === 1 && sock.server) {
            // tcp servers should not be recv()'ing on the listen socket
            throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
          }
  
          var queued = sock.recv_queue.shift();
          if (!queued) {
            if (sock.type === 1) {
              var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
  
              if (!dest) {
                // if we have a destination address but are not connected, error out
                throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
              }
              else if (dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                // return null if the socket has closed
                return null;
              }
              else {
                // else, our socket is in a valid state but truly has nothing available
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
            } else {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // queued.data will be an ArrayBuffer if it's unadulterated, but if it's
          // requeued TCP data it'll be an ArrayBufferView
          var queuedLength = queued.data.byteLength || queued.data.length;
          var queuedOffset = queued.data.byteOffset || 0;
          var queuedBuffer = queued.data.buffer || queued.data;
          var bytesRead = Math.min(length, queuedLength);
          var res = {
            buffer: new Uint8Array(queuedBuffer, queuedOffset, bytesRead),
            addr: queued.addr,
            port: queued.port
          };
  
  
          // push back any unread data for TCP connections
          if (sock.type === 1 && bytesRead < queuedLength) {
            var bytesRemaining = queuedLength - bytesRead;
            queued.data = new Uint8Array(queuedBuffer, queuedOffset + bytesRead, bytesRemaining);
            sock.recv_queue.unshift(queued);
          }
  
          return res;
        }}};function _send(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _write(fd, buf, len);
    }
  
  function _pwrite(fildes, buf, nbyte, offset) {
      // ssize_t pwrite(int fildes, const void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _write(fildes, buf, nbyte) {
      // ssize_t write(int fildes, const void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fputc(c, stream) {
      // int fputc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputc.html
      var chr = unSign(c & 0xFF);
      HEAP8[((_fputc.ret)|0)]=chr;
      var fd = _fileno(stream);
      var ret = _write(fd, _fputc.ret, 1);
      if (ret == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return -1;
      } else {
        return chr;
      }
    }

  
  var ___strtok_state=0;
  
  function _strtok_r(s, delim, lasts) {
      var skip_leading_delim = 1;
      var spanp;
      var c, sc;
      var tok;
  
  
      if (s == 0 && (s = getValue(lasts, 'i8*')) == 0) {
        return 0;
      }
  
      cont: while (1) {
        c = getValue(s++, 'i8');
        for (spanp = delim; (sc = getValue(spanp++, 'i8')) != 0;) {
          if (c == sc) {
            if (skip_leading_delim) {
              continue cont;
            } else {
              setValue(lasts, s, 'i8*');
              setValue(s - 1, 0, 'i8');
              return s - 1;
            }
          }
        }
        break;
      }
  
      if (c == 0) {
        setValue(lasts, 0, 'i8*');
        return 0;
      }
      tok = s - 1;
  
      for (;;) {
        c = getValue(s++, 'i8');
        spanp = delim;
        do {
          if ((sc = getValue(spanp++, 'i8')) == c) {
            if (c == 0) {
              s = 0;
            } else {
              setValue(s - 1, 0, 'i8');
            }
            setValue(lasts, s, 'i8*');
            return tok;
          }
        } while (sc != 0);
      }
      abort('strtok_r error!');
    }function _strtok(s, delim) {
      return _strtok_r(s, delim, ___strtok_state);
    }

  function _fwrite(ptr, size, nitems, stream) {
      // size_t fwrite(const void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fwrite.html
      var bytesToWrite = nitems * size;
      if (bytesToWrite == 0) return 0;
      var fd = _fileno(stream);
      var bytesWritten = _write(fd, ptr, bytesToWrite);
      if (bytesWritten == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return 0;
      } else {
        return Math.floor(bytesWritten / size);
      }
    }

  
  function _putchar(c) {
      // int putchar(int c);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/putchar.html
      return _fputc(c, HEAP32[((_stdout)>>2)]);
    } 
  Module["_saveSetjmp"] = _saveSetjmp;

  
   
  Module["_strlen"] = _strlen;function _fputs(s, stream) {
      // int fputs(const char *restrict s, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputs.html
      var fd = _fileno(stream);
      return _write(fd, s, _strlen(s));
    }

  var Browser={mainLoop:{scheduler:null,method:"",shouldPause:false,paused:false,queue:[],pause:function () {
          Browser.mainLoop.shouldPause = true;
        },resume:function () {
          if (Browser.mainLoop.paused) {
            Browser.mainLoop.paused = false;
            Browser.mainLoop.scheduler();
          }
          Browser.mainLoop.shouldPause = false;
        },updateStatus:function () {
          if (Module['setStatus']) {
            var message = Module['statusMessage'] || 'Please wait...';
            var remaining = Browser.mainLoop.remainingBlockers;
            var expected = Browser.mainLoop.expectedBlockers;
            if (remaining) {
              if (remaining < expected) {
                Module['setStatus'](message + ' (' + (expected - remaining) + '/' + expected + ')');
              } else {
                Module['setStatus'](message);
              }
            } else {
              Module['setStatus']('');
            }
          }
        }},isFullScreen:false,pointerLock:false,moduleContextCreatedCallbacks:[],workers:[],init:function () {
        if (!Module["preloadPlugins"]) Module["preloadPlugins"] = []; // needs to exist even in workers
  
        if (Browser.initted || ENVIRONMENT_IS_WORKER) return;
        Browser.initted = true;
  
        try {
          new Blob();
          Browser.hasBlobConstructor = true;
        } catch(e) {
          Browser.hasBlobConstructor = false;
          console.log("warning: no blob constructor, cannot create blobs with mimetypes");
        }
        Browser.BlobBuilder = typeof MozBlobBuilder != "undefined" ? MozBlobBuilder : (typeof WebKitBlobBuilder != "undefined" ? WebKitBlobBuilder : (!Browser.hasBlobConstructor ? console.log("warning: no BlobBuilder") : null));
        Browser.URLObject = typeof window != "undefined" ? (window.URL ? window.URL : window.webkitURL) : undefined;
        if (!Module.noImageDecoding && typeof Browser.URLObject === 'undefined') {
          console.log("warning: Browser does not support creating object URLs. Built-in browser image decoding will not be available.");
          Module.noImageDecoding = true;
        }
  
        // Support for plugins that can process preloaded files. You can add more of these to
        // your app by creating and appending to Module.preloadPlugins.
        //
        // Each plugin is asked if it can handle a file based on the file's name. If it can,
        // it is given the file's raw data. When it is done, it calls a callback with the file's
        // (possibly modified) data. For example, a plugin might decompress a file, or it
        // might create some side data structure for use later (like an Image element, etc.).
  
        var imagePlugin = {};
        imagePlugin['canHandle'] = function imagePlugin_canHandle(name) {
          return !Module.noImageDecoding && /\.(jpg|jpeg|png|bmp)$/i.test(name);
        };
        imagePlugin['handle'] = function imagePlugin_handle(byteArray, name, onload, onerror) {
          var b = null;
          if (Browser.hasBlobConstructor) {
            try {
              b = new Blob([byteArray], { type: Browser.getMimetype(name) });
              if (b.size !== byteArray.length) { // Safari bug #118630
                // Safari's Blob can only take an ArrayBuffer
                b = new Blob([(new Uint8Array(byteArray)).buffer], { type: Browser.getMimetype(name) });
              }
            } catch(e) {
              Runtime.warnOnce('Blob constructor present but fails: ' + e + '; falling back to blob builder');
            }
          }
          if (!b) {
            var bb = new Browser.BlobBuilder();
            bb.append((new Uint8Array(byteArray)).buffer); // we need to pass a buffer, and must copy the array to get the right data range
            b = bb.getBlob();
          }
          var url = Browser.URLObject.createObjectURL(b);
          var img = new Image();
          img.onload = function img_onload() {
            assert(img.complete, 'Image ' + name + ' could not be decoded');
            var canvas = document.createElement('canvas');
            canvas.width = img.width;
            canvas.height = img.height;
            var ctx = canvas.getContext('2d');
            ctx.drawImage(img, 0, 0);
            Module["preloadedImages"][name] = canvas;
            Browser.URLObject.revokeObjectURL(url);
            if (onload) onload(byteArray);
          };
          img.onerror = function img_onerror(event) {
            console.log('Image ' + url + ' could not be decoded');
            if (onerror) onerror();
          };
          img.src = url;
        };
        Module['preloadPlugins'].push(imagePlugin);
  
        var audioPlugin = {};
        audioPlugin['canHandle'] = function audioPlugin_canHandle(name) {
          return !Module.noAudioDecoding && name.substr(-4) in { '.ogg': 1, '.wav': 1, '.mp3': 1 };
        };
        audioPlugin['handle'] = function audioPlugin_handle(byteArray, name, onload, onerror) {
          var done = false;
          function finish(audio) {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = audio;
            if (onload) onload(byteArray);
          }
          function fail() {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = new Audio(); // empty shim
            if (onerror) onerror();
          }
          if (Browser.hasBlobConstructor) {
            try {
              var b = new Blob([byteArray], { type: Browser.getMimetype(name) });
            } catch(e) {
              return fail();
            }
            var url = Browser.URLObject.createObjectURL(b); // XXX we never revoke this!
            var audio = new Audio();
            audio.addEventListener('canplaythrough', function() { finish(audio) }, false); // use addEventListener due to chromium bug 124926
            audio.onerror = function audio_onerror(event) {
              if (done) return;
              console.log('warning: browser could not fully decode audio ' + name + ', trying slower base64 approach');
              function encode64(data) {
                var BASE = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
                var PAD = '=';
                var ret = '';
                var leftchar = 0;
                var leftbits = 0;
                for (var i = 0; i < data.length; i++) {
                  leftchar = (leftchar << 8) | data[i];
                  leftbits += 8;
                  while (leftbits >= 6) {
                    var curr = (leftchar >> (leftbits-6)) & 0x3f;
                    leftbits -= 6;
                    ret += BASE[curr];
                  }
                }
                if (leftbits == 2) {
                  ret += BASE[(leftchar&3) << 4];
                  ret += PAD + PAD;
                } else if (leftbits == 4) {
                  ret += BASE[(leftchar&0xf) << 2];
                  ret += PAD;
                }
                return ret;
              }
              audio.src = 'data:audio/x-' + name.substr(-3) + ';base64,' + encode64(byteArray);
              finish(audio); // we don't wait for confirmation this worked - but it's worth trying
            };
            audio.src = url;
            // workaround for chrome bug 124926 - we do not always get oncanplaythrough or onerror
            Browser.safeSetTimeout(function() {
              finish(audio); // try to use it even though it is not necessarily ready to play
            }, 10000);
          } else {
            return fail();
          }
        };
        Module['preloadPlugins'].push(audioPlugin);
  
        // Canvas event setup
  
        var canvas = Module['canvas'];
        canvas.requestPointerLock = canvas['requestPointerLock'] ||
                                    canvas['mozRequestPointerLock'] ||
                                    canvas['webkitRequestPointerLock'];
        canvas.exitPointerLock = document['exitPointerLock'] ||
                                 document['mozExitPointerLock'] ||
                                 document['webkitExitPointerLock'] ||
                                 function(){}; // no-op if function does not exist
        canvas.exitPointerLock = canvas.exitPointerLock.bind(document);
  
        function pointerLockChange() {
          Browser.pointerLock = document['pointerLockElement'] === canvas ||
                                document['mozPointerLockElement'] === canvas ||
                                document['webkitPointerLockElement'] === canvas;
        }
  
        document.addEventListener('pointerlockchange', pointerLockChange, false);
        document.addEventListener('mozpointerlockchange', pointerLockChange, false);
        document.addEventListener('webkitpointerlockchange', pointerLockChange, false);
  
        if (Module['elementPointerLock']) {
          canvas.addEventListener("click", function(ev) {
            if (!Browser.pointerLock && canvas.requestPointerLock) {
              canvas.requestPointerLock();
              ev.preventDefault();
            }
          }, false);
        }
      },createContext:function (canvas, useWebGL, setInModule, webGLContextAttributes) {
        var ctx;
        var errorInfo = '?';
        function onContextCreationError(event) {
          errorInfo = event.statusMessage || errorInfo;
        }
        try {
          if (useWebGL) {
            var contextAttributes = {
              antialias: false,
              alpha: false
            };
  
            if (webGLContextAttributes) {
              for (var attribute in webGLContextAttributes) {
                contextAttributes[attribute] = webGLContextAttributes[attribute];
              }
            }
  
  
            canvas.addEventListener('webglcontextcreationerror', onContextCreationError, false);
            try {
              ['experimental-webgl', 'webgl'].some(function(webglId) {
                return ctx = canvas.getContext(webglId, contextAttributes);
              });
            } finally {
              canvas.removeEventListener('webglcontextcreationerror', onContextCreationError, false);
            }
          } else {
            ctx = canvas.getContext('2d');
          }
          if (!ctx) throw ':(';
        } catch (e) {
          Module.print('Could not create canvas: ' + [errorInfo, e]);
          return null;
        }
        if (useWebGL) {
          // Set the background of the WebGL canvas to black
          canvas.style.backgroundColor = "black";
  
          // Warn on context loss
          canvas.addEventListener('webglcontextlost', function(event) {
            alert('WebGL context lost. You will need to reload the page.');
          }, false);
        }
        if (setInModule) {
          GLctx = Module.ctx = ctx;
          Module.useWebGL = useWebGL;
          Browser.moduleContextCreatedCallbacks.forEach(function(callback) { callback() });
          Browser.init();
        }
        return ctx;
      },destroyContext:function (canvas, useWebGL, setInModule) {},fullScreenHandlersInstalled:false,lockPointer:undefined,resizeCanvas:undefined,requestFullScreen:function (lockPointer, resizeCanvas) {
        Browser.lockPointer = lockPointer;
        Browser.resizeCanvas = resizeCanvas;
        if (typeof Browser.lockPointer === 'undefined') Browser.lockPointer = true;
        if (typeof Browser.resizeCanvas === 'undefined') Browser.resizeCanvas = false;
  
        var canvas = Module['canvas'];
        function fullScreenChange() {
          Browser.isFullScreen = false;
          if ((document['webkitFullScreenElement'] || document['webkitFullscreenElement'] ||
               document['mozFullScreenElement'] || document['mozFullscreenElement'] ||
               document['fullScreenElement'] || document['fullscreenElement']) === canvas) {
            canvas.cancelFullScreen = document['cancelFullScreen'] ||
                                      document['mozCancelFullScreen'] ||
                                      document['webkitCancelFullScreen'];
            canvas.cancelFullScreen = canvas.cancelFullScreen.bind(document);
            if (Browser.lockPointer) canvas.requestPointerLock();
            Browser.isFullScreen = true;
            if (Browser.resizeCanvas) Browser.setFullScreenCanvasSize();
          } else if (Browser.resizeCanvas){
            Browser.setWindowedCanvasSize();
          }
          if (Module['onFullScreen']) Module['onFullScreen'](Browser.isFullScreen);
        }
  
        if (!Browser.fullScreenHandlersInstalled) {
          Browser.fullScreenHandlersInstalled = true;
          document.addEventListener('fullscreenchange', fullScreenChange, false);
          document.addEventListener('mozfullscreenchange', fullScreenChange, false);
          document.addEventListener('webkitfullscreenchange', fullScreenChange, false);
        }
  
        canvas.requestFullScreen = canvas['requestFullScreen'] ||
                                   canvas['mozRequestFullScreen'] ||
                                   (canvas['webkitRequestFullScreen'] ? function() { canvas['webkitRequestFullScreen'](Element['ALLOW_KEYBOARD_INPUT']) } : null);
        canvas.requestFullScreen();
      },requestAnimationFrame:function requestAnimationFrame(func) {
        if (typeof window === 'undefined') { // Provide fallback to setTimeout if window is undefined (e.g. in Node.js)
          setTimeout(func, 1000/60);
        } else {
          if (!window.requestAnimationFrame) {
            window.requestAnimationFrame = window['requestAnimationFrame'] ||
                                           window['mozRequestAnimationFrame'] ||
                                           window['webkitRequestAnimationFrame'] ||
                                           window['msRequestAnimationFrame'] ||
                                           window['oRequestAnimationFrame'] ||
                                           window['setTimeout'];
          }
          window.requestAnimationFrame(func);
        }
      },safeCallback:function (func) {
        return function() {
          if (!ABORT) return func.apply(null, arguments);
        };
      },safeRequestAnimationFrame:function (func) {
        return Browser.requestAnimationFrame(function() {
          if (!ABORT) func();
        });
      },safeSetTimeout:function (func, timeout) {
        return setTimeout(function() {
          if (!ABORT) func();
        }, timeout);
      },safeSetInterval:function (func, timeout) {
        return setInterval(function() {
          if (!ABORT) func();
        }, timeout);
      },getMimetype:function (name) {
        return {
          'jpg': 'image/jpeg',
          'jpeg': 'image/jpeg',
          'png': 'image/png',
          'bmp': 'image/bmp',
          'ogg': 'audio/ogg',
          'wav': 'audio/wav',
          'mp3': 'audio/mpeg'
        }[name.substr(name.lastIndexOf('.')+1)];
      },getUserMedia:function (func) {
        if(!window.getUserMedia) {
          window.getUserMedia = navigator['getUserMedia'] ||
                                navigator['mozGetUserMedia'];
        }
        window.getUserMedia(func);
      },getMovementX:function (event) {
        return event['movementX'] ||
               event['mozMovementX'] ||
               event['webkitMovementX'] ||
               0;
      },getMovementY:function (event) {
        return event['movementY'] ||
               event['mozMovementY'] ||
               event['webkitMovementY'] ||
               0;
      },getMouseWheelDelta:function (event) {
        return Math.max(-1, Math.min(1, event.type === 'DOMMouseScroll' ? event.detail : -event.wheelDelta));
      },mouseX:0,mouseY:0,mouseMovementX:0,mouseMovementY:0,calculateMouseEvent:function (event) { // event should be mousemove, mousedown or mouseup
        if (Browser.pointerLock) {
          // When the pointer is locked, calculate the coordinates
          // based on the movement of the mouse.
          // Workaround for Firefox bug 764498
          if (event.type != 'mousemove' &&
              ('mozMovementX' in event)) {
            Browser.mouseMovementX = Browser.mouseMovementY = 0;
          } else {
            Browser.mouseMovementX = Browser.getMovementX(event);
            Browser.mouseMovementY = Browser.getMovementY(event);
          }
          
          // check if SDL is available
          if (typeof SDL != "undefined") {
          	Browser.mouseX = SDL.mouseX + Browser.mouseMovementX;
          	Browser.mouseY = SDL.mouseY + Browser.mouseMovementY;
          } else {
          	// just add the mouse delta to the current absolut mouse position
          	// FIXME: ideally this should be clamped against the canvas size and zero
          	Browser.mouseX += Browser.mouseMovementX;
          	Browser.mouseY += Browser.mouseMovementY;
          }        
        } else {
          // Otherwise, calculate the movement based on the changes
          // in the coordinates.
          var rect = Module["canvas"].getBoundingClientRect();
          var x, y;
          
          // Neither .scrollX or .pageXOffset are defined in a spec, but
          // we prefer .scrollX because it is currently in a spec draft.
          // (see: http://www.w3.org/TR/2013/WD-cssom-view-20131217/)
          var scrollX = ((typeof window.scrollX !== 'undefined') ? window.scrollX : window.pageXOffset);
          var scrollY = ((typeof window.scrollY !== 'undefined') ? window.scrollY : window.pageYOffset);
          if (event.type == 'touchstart' ||
              event.type == 'touchend' ||
              event.type == 'touchmove') {
            var t = event.touches.item(0);
            if (t) {
              x = t.pageX - (scrollX + rect.left);
              y = t.pageY - (scrollY + rect.top);
            } else {
              return;
            }
          } else {
            x = event.pageX - (scrollX + rect.left);
            y = event.pageY - (scrollY + rect.top);
          }
  
          // the canvas might be CSS-scaled compared to its backbuffer;
          // SDL-using content will want mouse coordinates in terms
          // of backbuffer units.
          var cw = Module["canvas"].width;
          var ch = Module["canvas"].height;
          x = x * (cw / rect.width);
          y = y * (ch / rect.height);
  
          Browser.mouseMovementX = x - Browser.mouseX;
          Browser.mouseMovementY = y - Browser.mouseY;
          Browser.mouseX = x;
          Browser.mouseY = y;
        }
      },xhrLoad:function (url, onload, onerror) {
        var xhr = new XMLHttpRequest();
        xhr.open('GET', url, true);
        xhr.responseType = 'arraybuffer';
        xhr.onload = function xhr_onload() {
          if (xhr.status == 200 || (xhr.status == 0 && xhr.response)) { // file URLs can return 0
            onload(xhr.response);
          } else {
            onerror();
          }
        };
        xhr.onerror = onerror;
        xhr.send(null);
      },asyncLoad:function (url, onload, onerror, noRunDep) {
        Browser.xhrLoad(url, function(arrayBuffer) {
          assert(arrayBuffer, 'Loading data file "' + url + '" failed (no arrayBuffer).');
          onload(new Uint8Array(arrayBuffer));
          if (!noRunDep) removeRunDependency('al ' + url);
        }, function(event) {
          if (onerror) {
            onerror();
          } else {
            throw 'Loading data file "' + url + '" failed.';
          }
        });
        if (!noRunDep) addRunDependency('al ' + url);
      },resizeListeners:[],updateResizeListeners:function () {
        var canvas = Module['canvas'];
        Browser.resizeListeners.forEach(function(listener) {
          listener(canvas.width, canvas.height);
        });
      },setCanvasSize:function (width, height, noUpdates) {
        var canvas = Module['canvas'];
        canvas.width = width;
        canvas.height = height;
        if (!noUpdates) Browser.updateResizeListeners();
      },windowedWidth:0,windowedHeight:0,setFullScreenCanvasSize:function () {
        var canvas = Module['canvas'];
        this.windowedWidth = canvas.width;
        this.windowedHeight = canvas.height;
        canvas.width = screen.width;
        canvas.height = screen.height;
        // check if SDL is available   
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags | 0x00800000; // set SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      },setWindowedCanvasSize:function () {
        var canvas = Module['canvas'];
        canvas.width = this.windowedWidth;
        canvas.height = this.windowedHeight;
        // check if SDL is available       
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags & ~0x00800000; // clear SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      }};


  
  function _malloc(bytes) {
      /* Over-allocate to make sure it is byte-aligned by 8.
       * This will leak memory, but this is only the dummy
       * implementation (replaced by dlmalloc normally) so
       * not an issue.
       */
      var ptr = Runtime.dynamicAlloc(bytes + 8);
      return (ptr+8) & 0xFFFFFFF8;
    }
  Module["_malloc"] = _malloc;
  
  var ___tm_current=allocate(44, "i8", ALLOC_STATIC);
  
  
  var ___tm_timezone=allocate(intArrayFromString("GMT"), "i8", ALLOC_STATIC);
  
  
  var _tzname=allocate(8, "i32*", ALLOC_STATIC);
  
  var _daylight=allocate(1, "i32*", ALLOC_STATIC);
  
  var _timezone=allocate(1, "i32*", ALLOC_STATIC);function _tzset() {
      // TODO: Use (malleable) environment variables instead of system settings.
      if (_tzset.called) return;
      _tzset.called = true;
  
      HEAP32[((_timezone)>>2)]=-(new Date()).getTimezoneOffset() * 60;
  
      var winter = new Date(2000, 0, 1);
      var summer = new Date(2000, 6, 1);
      HEAP32[((_daylight)>>2)]=Number(winter.getTimezoneOffset() != summer.getTimezoneOffset());
  
      var winterName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | winter.toString().match(/\(([A-Z]+)\)/)[1];
      var summerName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | summer.toString().match(/\(([A-Z]+)\)/)[1];
      var winterNamePtr = allocate(intArrayFromString(winterName), 'i8', ALLOC_NORMAL);
      var summerNamePtr = allocate(intArrayFromString(summerName), 'i8', ALLOC_NORMAL);
      HEAP32[((_tzname)>>2)]=winterNamePtr;
      HEAP32[(((_tzname)+(4))>>2)]=summerNamePtr;
    }function _localtime_r(time, tmPtr) {
      _tzset();
      var date = new Date(HEAP32[((time)>>2)]*1000);
      HEAP32[((tmPtr)>>2)]=date.getSeconds();
      HEAP32[(((tmPtr)+(4))>>2)]=date.getMinutes();
      HEAP32[(((tmPtr)+(8))>>2)]=date.getHours();
      HEAP32[(((tmPtr)+(12))>>2)]=date.getDate();
      HEAP32[(((tmPtr)+(16))>>2)]=date.getMonth();
      HEAP32[(((tmPtr)+(20))>>2)]=date.getFullYear()-1900;
      HEAP32[(((tmPtr)+(24))>>2)]=date.getDay();
  
      var start = new Date(date.getFullYear(), 0, 1);
      var yday = Math.floor((date.getTime() - start.getTime()) / (1000 * 60 * 60 * 24));
      HEAP32[(((tmPtr)+(28))>>2)]=yday;
      HEAP32[(((tmPtr)+(36))>>2)]=start.getTimezoneOffset() * 60;
  
      var dst = Number(start.getTimezoneOffset() != date.getTimezoneOffset());
      HEAP32[(((tmPtr)+(32))>>2)]=dst;
  
      HEAP32[(((tmPtr)+(40))>>2)]=___tm_timezone;
  
      return tmPtr;
    }function _localtime(time) {
      return _localtime_r(time, ___tm_current);
    }

   
  Module["_bitshift64Ashr"] = _bitshift64Ashr;

  
  var PTHREAD_SPECIFIC={};function _pthread_setspecific(key, value) {
      if (!(key in PTHREAD_SPECIFIC)) {
        return ERRNO_CODES.EINVAL;
      }
      PTHREAD_SPECIFIC[key] = value;
      return 0;
    }

  function _GC_init() {
  Module['printErr']('missing function: GC_init'); abort(-1);
  }

  var _ceil=Math_ceil;

  function _GC_strdup() {
  Module['printErr']('missing function: GC_strdup'); abort(-1);
  }

  function _GC_malloc_atomic() {
  Module['printErr']('missing function: GC_malloc_atomic'); abort(-1);
  }

  
  function _isxdigit(chr) {
      return (chr >= 48 && chr <= 57) ||
             (chr >= 97 && chr <= 102) ||
             (chr >= 65 && chr <= 70);
    }function _isxdigit_l(chr) {
      return _isxdigit(chr); // no locale support yet
    }

  
  function _puts(s) {
      // int puts(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/puts.html
      // NOTE: puts() always writes an extra newline.
      var stdout = HEAP32[((_stdout)>>2)];
      var ret = _fputs(s, stdout);
      if (ret < 0) {
        return ret;
      } else {
        var newlineRet = _fputc(10, stdout);
        return (newlineRet < 0) ? -1 : ret + 1;
      }
    }
  
  
  function _strerror_r(errnum, strerrbuf, buflen) {
      if (errnum in ERRNO_MESSAGES) {
        if (ERRNO_MESSAGES[errnum].length > buflen - 1) {
          return ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          var msg = ERRNO_MESSAGES[errnum];
          writeAsciiToMemory(msg, strerrbuf);
          return 0;
        }
      } else {
        return ___setErrNo(ERRNO_CODES.EINVAL);
      }
    }function _strerror(errnum) {
      if (!_strerror.buffer) _strerror.buffer = _malloc(256);
      _strerror_r(errnum, _strerror.buffer, 256);
      return _strerror.buffer;
    }
  
  function ___errno_location() {
      return ___errno_state;
    }function _perror(s) {
      // void perror(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/perror.html
      var stdout = HEAP32[((_stdout)>>2)];
      if (s) {
        _fputs(s, stdout);
        _fputc(58, stdout);
        _fputc(32, stdout);
      }
      var errnum = HEAP32[((___errno_location())>>2)];
      _puts(_strerror(errnum));
    }

  
  function _emscripten_memcpy_big(dest, src, num) {
      HEAPU8.set(HEAPU8.subarray(src, src+num), dest);
      return dest;
    } 
  Module["_memcpy"] = _memcpy;


  function _strstr(ptr1, ptr2) {
      var check = 0, start;
      do {
        if (!check) {
          start = ptr1;
          check = ptr2;
        }
        var curr1 = HEAP8[((ptr1++)|0)];
        var curr2 = HEAP8[((check++)|0)];
        if (curr2 == 0) return start;
        if (curr2 != curr1) {
          // rewind to one character after start, to find ez in eeez
          ptr1 = start + 1;
          check = 0;
        }
      } while (curr1);
      return 0;
    }

   
  Module["_memmove"] = _memmove;

  function _newlocale(mask, locale, base) {
      return _malloc(4);
    }

  function _signal(sig, func) {
      // TODO
      return 0;
    }

  
  function _sinh(x) {
      var p = Math.pow(Math.E, x);
      return (p - (1 / p)) / 2;
    }
  
  function _cosh(x) {
      var p = Math.pow(Math.E, x);
      return (p + (1 / p)) / 2;
    }function _tanh(x) {
      return _sinh(x) / _cosh(x);
    }

  var _emscripten_preinvoke=true;

  function _pthread_cond_wait() {
      return 0;
    }

  
  
  
  var ___cxa_exception_header_size=8;
  
  function _free() {
  }
  Module["_free"] = _free;function ___cxa_free_exception(ptr) {
      try {
        return _free(ptr - ___cxa_exception_header_size);
      } catch(e) { // XXX FIXME
      }
    }
  
  var ___cxa_last_thrown_exception=0;
  
  var ___cxa_caught_exceptions=[];function ___cxa_end_catch() {
      if (___cxa_end_catch.rethrown) {
        ___cxa_end_catch.rethrown = false;
        return;
      }
      // Clear state flag.
      asm['setThrew'](0);
      // Call destructor if one is registered then clear it.
      var ptr = ___cxa_caught_exceptions.pop();
      if (ptr) {
        header = ptr - ___cxa_exception_header_size;
        var destructor = HEAP32[(((header)+(4))>>2)];
        if (destructor) {
          Runtime.dynCall('vi', destructor, [ptr]);
          HEAP32[(((header)+(4))>>2)]=0;
        }
        ___cxa_free_exception(ptr);
        ___cxa_last_thrown_exception = 0;
      }
    }function ___cxa_rethrow() {
      ___cxa_end_catch.rethrown = true;
      var ptr = ___cxa_caught_exceptions.pop();
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }

  
  
  function _open(path, oflag, varargs) {
      // int open(const char *path, int oflag, ...);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/open.html
      var mode = HEAP32[((varargs)>>2)];
      path = Pointer_stringify(path);
      try {
        var stream = FS.open(path, oflag, mode);
        return stream.fd;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fopen(filename, mode) {
      // FILE *fopen(const char *restrict filename, const char *restrict mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fopen.html
      var flags;
      mode = Pointer_stringify(mode);
      if (mode[0] == 'r') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 0;
        }
      } else if (mode[0] == 'w') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 512;
      } else if (mode[0] == 'a') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 1024;
      } else {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return 0;
      }
      var fd = _open(filename, flags, allocate([0x1FF, 0, 0, 0], 'i32', ALLOC_STACK));  // All creation permissions.
      return fd === -1 ? 0 : FS.getPtrForStream(FS.getStream(fd));
    }function _freopen(filename, mode, stream) {
      // FILE *freopen(const char *restrict filename, const char *restrict mode, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/freopen.html
      if (!filename) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (!streamObj) {
          ___setErrNo(ERRNO_CODES.EBADF);
          return 0;
        }
        if (_freopen.buffer) _free(_freopen.buffer);
        filename = intArrayFromString(streamObj.path);
        filename = allocate(filename, 'i8', ALLOC_NORMAL);
      }
      _fclose(stream);
      return _fopen(filename, mode);
    }

  function _round(x) {
      return (x < 0) ? -Math.round(-x) : Math.round(x);
    }

  
  function _emscripten_get_now() {
      if (!_emscripten_get_now.actual) {
        if (ENVIRONMENT_IS_NODE) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() {
            var t = process['hrtime']();
            return t[0] * 1e3 + t[1] / 1e6;
          }
        } else if (typeof dateNow !== 'undefined') {
          _emscripten_get_now.actual = dateNow;
        } else if (ENVIRONMENT_IS_WEB && window['performance'] && window['performance']['now']) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() { return window['performance']['now'](); };
        } else {
          _emscripten_get_now.actual = Date.now;
        }
      }
      return _emscripten_get_now.actual();
    }function _clock_gettime(clk_id, tp) {
      // int clock_gettime(clockid_t clk_id, struct timespec *tp);
      var now;
      if (clk_id === 0) {
        now = Date.now();
      } else {
        now = _emscripten_get_now();
      }
      HEAP32[((tp)>>2)]=Math.floor(now/1000); // seconds
      HEAP32[(((tp)+(4))>>2)]=Math.floor((now % 1000)*1000*1000); // nanoseconds
      return 0;
    }

  
  function _tmpnam(s, dir, prefix) {
      // char *tmpnam(char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/tmpnam.html
      // NOTE: The dir and prefix arguments are for internal use only.
      var folder = FS.findObject(dir || '/tmp');
      if (!folder || !folder.isFolder) {
        dir = '/tmp';
        folder = FS.findObject(dir);
        if (!folder || !folder.isFolder) return 0;
      }
      var name = prefix || 'file';
      do {
        name += String.fromCharCode(65 + Math.floor(Math.random() * 25));
      } while (name in folder.contents);
      var result = dir + '/' + name;
      if (!_tmpnam.buffer) _tmpnam.buffer = _malloc(256);
      if (!s) s = _tmpnam.buffer;
      writeAsciiToMemory(result, s);
      return s;
    }function _tmpfile() {
      // FILE *tmpfile(void);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/tmpfile.html
      // TODO: Delete the created file on closing.
      if (_tmpfile.mode) {
        _tmpfile.mode = allocate(intArrayFromString('w+'), 'i8', ALLOC_NORMAL);
      }
      return _fopen(_tmpnam(0), _tmpfile.mode);
    }

  
  
  
  function __getFloat(text) {
      return /^[+-]?[0-9]*\.?[0-9]+([eE][+-]?[0-9]+)?/.exec(text);
    }function __scanString(format, get, unget, varargs) {
      if (!__scanString.whiteSpace) {
        __scanString.whiteSpace = {};
        __scanString.whiteSpace[32] = 1;
        __scanString.whiteSpace[9] = 1;
        __scanString.whiteSpace[10] = 1;
        __scanString.whiteSpace[11] = 1;
        __scanString.whiteSpace[12] = 1;
        __scanString.whiteSpace[13] = 1;
      }
      // Supports %x, %4x, %d.%d, %lld, %s, %f, %lf.
      // TODO: Support all format specifiers.
      format = Pointer_stringify(format);
      var soFar = 0;
      if (format.indexOf('%n') >= 0) {
        // need to track soFar
        var _get = get;
        get = function get() {
          soFar++;
          return _get();
        }
        var _unget = unget;
        unget = function unget() {
          soFar--;
          return _unget();
        }
      }
      var formatIndex = 0;
      var argsi = 0;
      var fields = 0;
      var argIndex = 0;
      var next;
  
      mainLoop:
      for (var formatIndex = 0; formatIndex < format.length;) {
        if (format[formatIndex] === '%' && format[formatIndex+1] == 'n') {
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          HEAP32[((argPtr)>>2)]=soFar;
          formatIndex += 2;
          continue;
        }
  
        if (format[formatIndex] === '%') {
          var nextC = format.indexOf('c', formatIndex+1);
          if (nextC > 0) {
            var maxx = 1;
            if (nextC > formatIndex+1) {
              var sub = format.substring(formatIndex+1, nextC);
              maxx = parseInt(sub);
              if (maxx != sub) maxx = 0;
            }
            if (maxx) {
              var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
              argIndex += Runtime.getAlignSize('void*', null, true);
              fields++;
              for (var i = 0; i < maxx; i++) {
                next = get();
                HEAP8[((argPtr++)|0)]=next;
                if (next === 0) return i > 0 ? fields : fields-1; // we failed to read the full length of this field
              }
              formatIndex += nextC - formatIndex + 1;
              continue;
            }
          }
        }
  
        // handle %[...]
        if (format[formatIndex] === '%' && format.indexOf('[', formatIndex+1) > 0) {
          var match = /\%([0-9]*)\[(\^)?(\]?[^\]]*)\]/.exec(format.substring(formatIndex));
          if (match) {
            var maxNumCharacters = parseInt(match[1]) || Infinity;
            var negateScanList = (match[2] === '^');
            var scanList = match[3];
  
            // expand "middle" dashs into character sets
            var middleDashMatch;
            while ((middleDashMatch = /([^\-])\-([^\-])/.exec(scanList))) {
              var rangeStartCharCode = middleDashMatch[1].charCodeAt(0);
              var rangeEndCharCode = middleDashMatch[2].charCodeAt(0);
              for (var expanded = ''; rangeStartCharCode <= rangeEndCharCode; expanded += String.fromCharCode(rangeStartCharCode++));
              scanList = scanList.replace(middleDashMatch[1] + '-' + middleDashMatch[2], expanded);
            }
  
            var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
            argIndex += Runtime.getAlignSize('void*', null, true);
            fields++;
  
            for (var i = 0; i < maxNumCharacters; i++) {
              next = get();
              if (negateScanList) {
                if (scanList.indexOf(String.fromCharCode(next)) < 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              } else {
                if (scanList.indexOf(String.fromCharCode(next)) >= 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              }
            }
  
            // write out null-terminating character
            HEAP8[((argPtr++)|0)]=0;
            formatIndex += match[0].length;
            
            continue;
          }
        }      
        // remove whitespace
        while (1) {
          next = get();
          if (next == 0) return fields;
          if (!(next in __scanString.whiteSpace)) break;
        }
        unget();
  
        if (format[formatIndex] === '%') {
          formatIndex++;
          var suppressAssignment = false;
          if (format[formatIndex] == '*') {
            suppressAssignment = true;
            formatIndex++;
          }
          var maxSpecifierStart = formatIndex;
          while (format[formatIndex].charCodeAt(0) >= 48 &&
                 format[formatIndex].charCodeAt(0) <= 57) {
            formatIndex++;
          }
          var max_;
          if (formatIndex != maxSpecifierStart) {
            max_ = parseInt(format.slice(maxSpecifierStart, formatIndex), 10);
          }
          var long_ = false;
          var half = false;
          var longLong = false;
          if (format[formatIndex] == 'l') {
            long_ = true;
            formatIndex++;
            if (format[formatIndex] == 'l') {
              longLong = true;
              formatIndex++;
            }
          } else if (format[formatIndex] == 'h') {
            half = true;
            formatIndex++;
          }
          var type = format[formatIndex];
          formatIndex++;
          var curr = 0;
          var buffer = [];
          // Read characters according to the format. floats are trickier, they may be in an unfloat state in the middle, then be a valid float later
          if (type == 'f' || type == 'e' || type == 'g' ||
              type == 'F' || type == 'E' || type == 'G') {
            next = get();
            while (next > 0 && (!(next in __scanString.whiteSpace)))  {
              buffer.push(String.fromCharCode(next));
              next = get();
            }
            var m = __getFloat(buffer.join(''));
            var last = m ? m[0].length : 0;
            for (var i = 0; i < buffer.length - last + 1; i++) {
              unget();
            }
            buffer.length = last;
          } else {
            next = get();
            var first = true;
            
            // Strip the optional 0x prefix for %x.
            if ((type == 'x' || type == 'X') && (next == 48)) {
              var peek = get();
              if (peek == 120 || peek == 88) {
                next = get();
              } else {
                unget();
              }
            }
            
            while ((curr < max_ || isNaN(max_)) && next > 0) {
              if (!(next in __scanString.whiteSpace) && // stop on whitespace
                  (type == 's' ||
                   ((type === 'd' || type == 'u' || type == 'i') && ((next >= 48 && next <= 57) ||
                                                                     (first && next == 45))) ||
                   ((type === 'x' || type === 'X') && (next >= 48 && next <= 57 ||
                                     next >= 97 && next <= 102 ||
                                     next >= 65 && next <= 70))) &&
                  (formatIndex >= format.length || next !== format[formatIndex].charCodeAt(0))) { // Stop when we read something that is coming up
                buffer.push(String.fromCharCode(next));
                next = get();
                curr++;
                first = false;
              } else {
                break;
              }
            }
            unget();
          }
          if (buffer.length === 0) return 0;  // Failure.
          if (suppressAssignment) continue;
  
          var text = buffer.join('');
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          switch (type) {
            case 'd': case 'u': case 'i':
              if (half) {
                HEAP16[((argPtr)>>1)]=parseInt(text, 10);
              } else if (longLong) {
                (tempI64 = [parseInt(text, 10)>>>0,(tempDouble=parseInt(text, 10),(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((argPtr)>>2)]=tempI64[0],HEAP32[(((argPtr)+(4))>>2)]=tempI64[1]);
              } else {
                HEAP32[((argPtr)>>2)]=parseInt(text, 10);
              }
              break;
            case 'X':
            case 'x':
              HEAP32[((argPtr)>>2)]=parseInt(text, 16);
              break;
            case 'F':
            case 'f':
            case 'E':
            case 'e':
            case 'G':
            case 'g':
            case 'E':
              // fallthrough intended
              if (long_) {
                HEAPF64[((argPtr)>>3)]=parseFloat(text);
              } else {
                HEAPF32[((argPtr)>>2)]=parseFloat(text);
              }
              break;
            case 's':
              var array = intArrayFromString(text);
              for (var j = 0; j < array.length; j++) {
                HEAP8[(((argPtr)+(j))|0)]=array[j];
              }
              break;
          }
          fields++;
        } else if (format[formatIndex].charCodeAt(0) in __scanString.whiteSpace) {
          next = get();
          while (next in __scanString.whiteSpace) {
            if (next <= 0) break mainLoop;  // End of input.
            next = get();
          }
          unget(next);
          formatIndex++;
        } else {
          // Not a specifier.
          next = get();
          if (format[formatIndex].charCodeAt(0) !== next) {
            unget(next);
            break mainLoop;
          }
          formatIndex++;
        }
      }
      return fields;
    }function _sscanf(s, format, varargs) {
      // int sscanf(const char *restrict s, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var index = 0;
      function get() { return HEAP8[(((s)+(index++))|0)]; };
      function unget() { index--; };
      return __scanString(format, get, unget, varargs);
    }function _vsscanf(s, format, va_arg) {
      return _sscanf(s, format, HEAP32[((va_arg)>>2)]);
    }

  
  
  function __reallyNegative(x) {
      return x < 0 || (x === 0 && (1/x) === -Infinity);
    }function __formatString(format, varargs) {
      var textIndex = format;
      var argIndex = 0;
      function getNextArg(type) {
        // NOTE: Explicitly ignoring type safety. Otherwise this fails:
        //       int x = 4; printf("%c\n", (char)x);
        var ret;
        if (type === 'double') {
          ret = (HEAP32[((tempDoublePtr)>>2)]=HEAP32[(((varargs)+(argIndex))>>2)],HEAP32[(((tempDoublePtr)+(4))>>2)]=HEAP32[(((varargs)+((argIndex)+(4)))>>2)],(+(HEAPF64[(tempDoublePtr)>>3])));
        } else if (type == 'i64') {
          ret = [HEAP32[(((varargs)+(argIndex))>>2)],
                 HEAP32[(((varargs)+(argIndex+4))>>2)]];
  
        } else {
          type = 'i32'; // varargs are always i32, i64, or double
          ret = HEAP32[(((varargs)+(argIndex))>>2)];
        }
        argIndex += Runtime.getNativeFieldSize(type);
        return ret;
      }
  
      var ret = [];
      var curr, next, currArg;
      while(1) {
        var startTextIndex = textIndex;
        curr = HEAP8[(textIndex)];
        if (curr === 0) break;
        next = HEAP8[((textIndex+1)|0)];
        if (curr == 37) {
          // Handle flags.
          var flagAlwaysSigned = false;
          var flagLeftAlign = false;
          var flagAlternative = false;
          var flagZeroPad = false;
          var flagPadSign = false;
          flagsLoop: while (1) {
            switch (next) {
              case 43:
                flagAlwaysSigned = true;
                break;
              case 45:
                flagLeftAlign = true;
                break;
              case 35:
                flagAlternative = true;
                break;
              case 48:
                if (flagZeroPad) {
                  break flagsLoop;
                } else {
                  flagZeroPad = true;
                  break;
                }
              case 32:
                flagPadSign = true;
                break;
              default:
                break flagsLoop;
            }
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          }
  
          // Handle width.
          var width = 0;
          if (next == 42) {
            width = getNextArg('i32');
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          } else {
            while (next >= 48 && next <= 57) {
              width = width * 10 + (next - 48);
              textIndex++;
              next = HEAP8[((textIndex+1)|0)];
            }
          }
  
          // Handle precision.
          var precisionSet = false, precision = -1;
          if (next == 46) {
            precision = 0;
            precisionSet = true;
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
            if (next == 42) {
              precision = getNextArg('i32');
              textIndex++;
            } else {
              while(1) {
                var precisionChr = HEAP8[((textIndex+1)|0)];
                if (precisionChr < 48 ||
                    precisionChr > 57) break;
                precision = precision * 10 + (precisionChr - 48);
                textIndex++;
              }
            }
            next = HEAP8[((textIndex+1)|0)];
          }
          if (precision < 0) {
            precision = 6; // Standard default.
            precisionSet = false;
          }
  
          // Handle integer sizes. WARNING: These assume a 32-bit architecture!
          var argSize;
          switch (String.fromCharCode(next)) {
            case 'h':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 104) {
                textIndex++;
                argSize = 1; // char (actually i32 in varargs)
              } else {
                argSize = 2; // short (actually i32 in varargs)
              }
              break;
            case 'l':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 108) {
                textIndex++;
                argSize = 8; // long long
              } else {
                argSize = 4; // long
              }
              break;
            case 'L': // long long
            case 'q': // int64_t
            case 'j': // intmax_t
              argSize = 8;
              break;
            case 'z': // size_t
            case 't': // ptrdiff_t
            case 'I': // signed ptrdiff_t or unsigned size_t
              argSize = 4;
              break;
            default:
              argSize = null;
          }
          if (argSize) textIndex++;
          next = HEAP8[((textIndex+1)|0)];
  
          // Handle type specifier.
          switch (String.fromCharCode(next)) {
            case 'd': case 'i': case 'u': case 'o': case 'x': case 'X': case 'p': {
              // Integer.
              var signed = next == 100 || next == 105;
              argSize = argSize || 4;
              var currArg = getNextArg('i' + (argSize * 8));
              var origArg = currArg;
              var argText;
              // Flatten i64-1 [low, high] into a (slightly rounded) double
              if (argSize == 8) {
                currArg = Runtime.makeBigInt(currArg[0], currArg[1], next == 117);
              }
              // Truncate to requested size.
              if (argSize <= 4) {
                var limit = Math.pow(256, argSize) - 1;
                currArg = (signed ? reSign : unSign)(currArg & limit, argSize * 8);
              }
              // Format the number.
              var currAbsArg = Math.abs(currArg);
              var prefix = '';
              if (next == 100 || next == 105) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], null); else
                argText = reSign(currArg, 8 * argSize, 1).toString(10);
              } else if (next == 117) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], true); else
                argText = unSign(currArg, 8 * argSize, 1).toString(10);
                currArg = Math.abs(currArg);
              } else if (next == 111) {
                argText = (flagAlternative ? '0' : '') + currAbsArg.toString(8);
              } else if (next == 120 || next == 88) {
                prefix = (flagAlternative && currArg != 0) ? '0x' : '';
                if (argSize == 8 && i64Math) {
                  if (origArg[1]) {
                    argText = (origArg[1]>>>0).toString(16);
                    var lower = (origArg[0]>>>0).toString(16);
                    while (lower.length < 8) lower = '0' + lower;
                    argText += lower;
                  } else {
                    argText = (origArg[0]>>>0).toString(16);
                  }
                } else
                if (currArg < 0) {
                  // Represent negative numbers in hex as 2's complement.
                  currArg = -currArg;
                  argText = (currAbsArg - 1).toString(16);
                  var buffer = [];
                  for (var i = 0; i < argText.length; i++) {
                    buffer.push((0xF - parseInt(argText[i], 16)).toString(16));
                  }
                  argText = buffer.join('');
                  while (argText.length < argSize * 2) argText = 'f' + argText;
                } else {
                  argText = currAbsArg.toString(16);
                }
                if (next == 88) {
                  prefix = prefix.toUpperCase();
                  argText = argText.toUpperCase();
                }
              } else if (next == 112) {
                if (currAbsArg === 0) {
                  argText = '(nil)';
                } else {
                  prefix = '0x';
                  argText = currAbsArg.toString(16);
                }
              }
              if (precisionSet) {
                while (argText.length < precision) {
                  argText = '0' + argText;
                }
              }
  
              // Add sign if needed
              if (currArg >= 0) {
                if (flagAlwaysSigned) {
                  prefix = '+' + prefix;
                } else if (flagPadSign) {
                  prefix = ' ' + prefix;
                }
              }
  
              // Move sign to prefix so we zero-pad after the sign
              if (argText.charAt(0) == '-') {
                prefix = '-' + prefix;
                argText = argText.substr(1);
              }
  
              // Add padding.
              while (prefix.length + argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad) {
                    argText = '0' + argText;
                  } else {
                    prefix = ' ' + prefix;
                  }
                }
              }
  
              // Insert the result into the buffer.
              argText = prefix + argText;
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 'f': case 'F': case 'e': case 'E': case 'g': case 'G': {
              // Float.
              var currArg = getNextArg('double');
              var argText;
              if (isNaN(currArg)) {
                argText = 'nan';
                flagZeroPad = false;
              } else if (!isFinite(currArg)) {
                argText = (currArg < 0 ? '-' : '') + 'inf';
                flagZeroPad = false;
              } else {
                var isGeneral = false;
                var effectivePrecision = Math.min(precision, 20);
  
                // Convert g/G to f/F or e/E, as per:
                // http://pubs.opengroup.org/onlinepubs/9699919799/functions/printf.html
                if (next == 103 || next == 71) {
                  isGeneral = true;
                  precision = precision || 1;
                  var exponent = parseInt(currArg.toExponential(effectivePrecision).split('e')[1], 10);
                  if (precision > exponent && exponent >= -4) {
                    next = ((next == 103) ? 'f' : 'F').charCodeAt(0);
                    precision -= exponent + 1;
                  } else {
                    next = ((next == 103) ? 'e' : 'E').charCodeAt(0);
                    precision--;
                  }
                  effectivePrecision = Math.min(precision, 20);
                }
  
                if (next == 101 || next == 69) {
                  argText = currArg.toExponential(effectivePrecision);
                  // Make sure the exponent has at least 2 digits.
                  if (/[eE][-+]\d$/.test(argText)) {
                    argText = argText.slice(0, -1) + '0' + argText.slice(-1);
                  }
                } else if (next == 102 || next == 70) {
                  argText = currArg.toFixed(effectivePrecision);
                  if (currArg === 0 && __reallyNegative(currArg)) {
                    argText = '-' + argText;
                  }
                }
  
                var parts = argText.split('e');
                if (isGeneral && !flagAlternative) {
                  // Discard trailing zeros and periods.
                  while (parts[0].length > 1 && parts[0].indexOf('.') != -1 &&
                         (parts[0].slice(-1) == '0' || parts[0].slice(-1) == '.')) {
                    parts[0] = parts[0].slice(0, -1);
                  }
                } else {
                  // Make sure we have a period in alternative mode.
                  if (flagAlternative && argText.indexOf('.') == -1) parts[0] += '.';
                  // Zero pad until required precision.
                  while (precision > effectivePrecision++) parts[0] += '0';
                }
                argText = parts[0] + (parts.length > 1 ? 'e' + parts[1] : '');
  
                // Capitalize 'E' if needed.
                if (next == 69) argText = argText.toUpperCase();
  
                // Add sign.
                if (currArg >= 0) {
                  if (flagAlwaysSigned) {
                    argText = '+' + argText;
                  } else if (flagPadSign) {
                    argText = ' ' + argText;
                  }
                }
              }
  
              // Add padding.
              while (argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad && (argText[0] == '-' || argText[0] == '+')) {
                    argText = argText[0] + '0' + argText.slice(1);
                  } else {
                    argText = (flagZeroPad ? '0' : ' ') + argText;
                  }
                }
              }
  
              // Adjust case.
              if (next < 97) argText = argText.toUpperCase();
  
              // Insert the result into the buffer.
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 's': {
              // String.
              var arg = getNextArg('i8*');
              var argLength = arg ? _strlen(arg) : '(null)'.length;
              if (precisionSet) argLength = Math.min(argLength, precision);
              if (!flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              if (arg) {
                for (var i = 0; i < argLength; i++) {
                  ret.push(HEAPU8[((arg++)|0)]);
                }
              } else {
                ret = ret.concat(intArrayFromString('(null)'.substr(0, argLength), true));
              }
              if (flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              break;
            }
            case 'c': {
              // Character.
              if (flagLeftAlign) ret.push(getNextArg('i8'));
              while (--width > 0) {
                ret.push(32);
              }
              if (!flagLeftAlign) ret.push(getNextArg('i8'));
              break;
            }
            case 'n': {
              // Write the length written so far to the next parameter.
              var ptr = getNextArg('i32*');
              HEAP32[((ptr)>>2)]=ret.length;
              break;
            }
            case '%': {
              // Literal percent sign.
              ret.push(curr);
              break;
            }
            default: {
              // Unknown specifiers remain untouched.
              for (var i = startTextIndex; i < textIndex + 2; i++) {
                ret.push(HEAP8[(i)]);
              }
            }
          }
          textIndex += 2;
          // TODO: Support a/A (hex float) and m (last error) specifiers.
          // TODO: Support %1${specifier} for arg selection.
        } else {
          ret.push(curr);
          textIndex += 1;
        }
      }
      return ret;
    }function _snprintf(s, n, format, varargs) {
      // int snprintf(char *restrict s, size_t n, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var limit = (n === undefined) ? result.length
                                    : Math.min(result.length, Math.max(n - 1, 0));
      if (s < 0) {
        s = -s;
        var buf = _malloc(limit+1);
        HEAP32[((s)>>2)]=buf;
        s = buf;
      }
      for (var i = 0; i < limit; i++) {
        HEAP8[(((s)+(i))|0)]=result[i];
      }
      if (limit < n || (n === undefined)) HEAP8[(((s)+(i))|0)]=0;
      return result.length;
    }

  
  
  
  function _recv(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _read(fd, buf, len);
    }
  
  function _pread(fildes, buf, nbyte, offset) {
      // ssize_t pread(int fildes, void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _read(fildes, buf, nbyte) {
      // ssize_t read(int fildes, void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fread(ptr, size, nitems, stream) {
      // size_t fread(void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fread.html
      var bytesToRead = nitems * size;
      if (bytesToRead == 0) {
        return 0;
      }
      var bytesRead = 0;
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      while (streamObj.ungotten.length && bytesToRead > 0) {
        HEAP8[((ptr++)|0)]=streamObj.ungotten.pop();
        bytesToRead--;
        bytesRead++;
      }
      var err = _read(streamObj.fd, ptr, bytesToRead);
      if (err == -1) {
        if (streamObj) streamObj.error = true;
        return 0;
      }
      bytesRead += err;
      if (bytesRead < bytesToRead) streamObj.eof = true;
      return Math.floor(bytesRead / size);
    }function _fgetc(stream) {
      // int fgetc(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fgetc.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) return -1;
      if (streamObj.eof || streamObj.error) return -1;
      var ret = _fread(_fgetc.ret, 1, 1, stream);
      if (ret == 0) {
        return -1;
      } else if (ret == -1) {
        streamObj.error = true;
        return -1;
      } else {
        return HEAPU8[((_fgetc.ret)|0)];
      }
    }

  function _pclose(stream) {
      // int pclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/pclose.html
      // We allow only one process, so no pipes.
      ___setErrNo(ERRNO_CODES.ECHILD);
      return -1;
    }

   
  Module["_memset"] = _memset;

  var _BDtoILow=true;


   
  Module["_bitshift64Shl"] = _bitshift64Shl;

  var _llvm_memcpy_p0i8_p0i8_i32=_memcpy;

  function ___assert_fail(condition, filename, line, func) {
      ABORT = true;
      throw 'Assertion failed: ' + Pointer_stringify(condition) + ', at: ' + [filename ? Pointer_stringify(filename) : 'unknown filename', line, func ? Pointer_stringify(func) : 'unknown function'] + ' at ' + stackTrace();
    }

  function _lis_matrix_assemble() {
  Module['printErr']('missing function: lis_matrix_assemble'); abort(-1);
  }

  
  function _isdigit(chr) {
      return chr >= 48 && chr <= 57;
    }function _isdigit_l(chr) {
      return _isdigit(chr); // no locale support yet
    }

  function _atexit(func, arg) {
      __ATEXIT__.unshift({ func: func, arg: arg });
    }


  function _access(path, amode) {
      // int access(const char *path, int amode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/access.html
      path = Pointer_stringify(path);
      if (amode & ~7) {
        // need a valid mode
        ___setErrNo(ERRNO_CODES.EINVAL);
        return -1;
      }
      var node;
      try {
        var lookup = FS.lookupPath(path, { follow: true });
        node = lookup.node;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
      var perms = '';
      if (amode & 4) perms += 'r';
      if (amode & 2) perms += 'w';
      if (amode & 1) perms += 'x';
      if (perms /* otherwise, they've just passed F_OK */ && FS.nodePermissions(node, perms)) {
        ___setErrNo(ERRNO_CODES.EACCES);
        return -1;
      }
      return 0;
    }

  function _ftell(stream) {
      // long ftell(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftell.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      if (FS.isChrdev(stream.node.mode)) {
        ___setErrNo(ERRNO_CODES.ESPIPE);
        return -1;
      } else {
        return stream.position;
      }
    }

  
  function __exit(status) {
      // void _exit(int status);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/exit.html
      Module['exit'](status);
    }function _exit(status) {
      __exit(status);
    }

  function _sprintf(s, format, varargs) {
      // int sprintf(char *restrict s, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      return _snprintf(s, undefined, format, varargs);
    }

  var _emscripten_get_longjmp_result=true;

  function ___ctype_b_loc() {
      // http://refspecs.freestandards.org/LSB_3.0.0/LSB-Core-generic/LSB-Core-generic/baselib---ctype-b-loc.html
      var me = ___ctype_b_loc;
      if (!me.ret) {
        var values = [
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,8195,8194,8194,8194,8194,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,24577,49156,49156,49156,
          49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,55304,55304,55304,55304,55304,55304,55304,55304,
          55304,55304,49156,49156,49156,49156,49156,49156,49156,54536,54536,54536,54536,54536,54536,50440,50440,50440,50440,50440,
          50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,49156,49156,49156,49156,49156,
          49156,54792,54792,54792,54792,54792,54792,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,
          50696,50696,50696,50696,50696,50696,50696,49156,49156,49156,49156,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        ];
        var i16size = 2;
        var arr = _malloc(values.length * i16size);
        for (var i = 0; i < values.length; i++) {
          HEAP16[(((arr)+(i * i16size))>>1)]=values[i];
        }
        me.ret = allocate([arr + 128 * i16size], 'i16*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _strrchr(ptr, chr) {
      var ptr2 = ptr + _strlen(ptr);
      do {
        if (HEAP8[(ptr2)] == chr) return ptr2;
        ptr2--;
      } while (ptr2 >= ptr);
      return 0;
    }

  function _freelocale(locale) {
      _free(locale);
    }

  function _catgets(catd, set_id, msg_id, s) {
      // char *catgets (nl_catd catd, int set_id, int msg_id, const char *s)
      return s;
    }

  function _fmod(x, y) {
      return x % y;
    }

  function _fmax(x, y) {
      return isNaN(x) ? y : isNaN(y) ? x : Math.max(x, y);
    }

  function _asprintf(s, format, varargs) {
      return _sprintf(-s, format, varargs);
    }

  function _GC_malloc() {
  Module['printErr']('missing function: GC_malloc'); abort(-1);
  }

  function ___cxa_guard_acquire(variable) {
      if (!HEAP8[(variable)]) { // ignore SAFE_HEAP stuff because llvm mixes i64 and i8 here
        HEAP8[(variable)]=1;
        return 1;
      }
      return 0;
    }

  function _lis_vector_destroy() {
  Module['printErr']('missing function: lis_vector_destroy'); abort(-1);
  }

  
  function __ZSt18uncaught_exceptionv() { // std::uncaught_exception()
      return !!__ZSt18uncaught_exceptionv.uncaught_exception;
    }function ___cxa_begin_catch(ptr) {
      __ZSt18uncaught_exceptionv.uncaught_exception--;
      ___cxa_caught_exceptions.push(___cxa_last_thrown_exception);
      return ptr;
    }

  function _lis_vector_create() {
  Module['printErr']('missing function: lis_vector_create'); abort(-1);
  }

  function _lis_matrix_set_type() {
  Module['printErr']('missing function: lis_matrix_set_type'); abort(-1);
  }


  var _cos=Math_cos;

  function _lis_matrix_set_value() {
  Module['printErr']('missing function: lis_matrix_set_value'); abort(-1);
  }



  function __ZNSt9exceptionD2Ev() {}

  function _lis_solver_destroy() {
  Module['printErr']('missing function: lis_solver_destroy'); abort(-1);
  }

  function _popen(command, mode) {
      // FILE *popen(const char *command, const char *mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/popen.html
      // We allow only one process, so no pipes.
      ___setErrNo(ERRNO_CODES.EMFILE);
      return 0;
    }

  function _isblank(chr) {
      return chr == 32 || chr == 9;
    }

   
  Module["_strcpy"] = _strcpy;

  function _copysign(a, b) {
      return __reallyNegative(a) === __reallyNegative(b) ? a : -a;
    }

  function _bsearch(key, base, num, size, compar) {
      function cmp(x, y) {
        return Module['dynCall_iii'](compar, x, y);
      };
      var left = 0;
      var right = num;
      var mid, test, addr;
  
      while (left < right) {
        mid = (left + right) >>> 1;
        addr = base + (mid * size);
        test = cmp(key, addr);
        if (test < 0) {
          right = mid;
        } else if (test > 0) {
          left = mid + 1;
        } else {
          return addr;
        }
      }
  
      return 0;
    }

  function _fmin(x, y) {
      return isNaN(x) ? y : isNaN(y) ? x : Math.min(x, y);
    }

  
  var PTHREAD_SPECIFIC_NEXT_KEY=1;function _pthread_key_create(key, destructor) {
      if (key == 0) {
        return ERRNO_CODES.EINVAL;
      }
      HEAP32[((key)>>2)]=PTHREAD_SPECIFIC_NEXT_KEY;
      // values start at 0
      PTHREAD_SPECIFIC[PTHREAD_SPECIFIC_NEXT_KEY] = 0;
      PTHREAD_SPECIFIC_NEXT_KEY++;
      return 0;
    }

  function _lis_vector_get_values() {
  Module['printErr']('missing function: lis_vector_get_values'); abort(-1);
  }


  
  function __isLeapYear(year) {
        return year%4 === 0 && (year%100 !== 0 || year%400 === 0);
    }
  
  function __arraySum(array, index) {
      var sum = 0;
      for (var i = 0; i <= index; sum += array[i++]);
      return sum;
    }
  
  
  var __MONTH_DAYS_LEAP=[31,29,31,30,31,30,31,31,30,31,30,31];
  
  var __MONTH_DAYS_REGULAR=[31,28,31,30,31,30,31,31,30,31,30,31];function __addDays(date, days) {
      var newDate = new Date(date.getTime());
      while(days > 0) {
        var leap = __isLeapYear(newDate.getFullYear());
        var currentMonth = newDate.getMonth();
        var daysInCurrentMonth = (leap ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR)[currentMonth];
  
        if (days > daysInCurrentMonth-newDate.getDate()) {
          // we spill over to next month
          days -= (daysInCurrentMonth-newDate.getDate()+1);
          newDate.setDate(1);
          if (currentMonth < 11) {
            newDate.setMonth(currentMonth+1)
          } else {
            newDate.setMonth(0);
            newDate.setFullYear(newDate.getFullYear()+1);
          }
        } else {
          // we stay in current month 
          newDate.setDate(newDate.getDate()+days);
          return newDate;
        }
      }
  
      return newDate;
    }function _strftime(s, maxsize, format, tm) {
      // size_t strftime(char *restrict s, size_t maxsize, const char *restrict format, const struct tm *restrict timeptr);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/strftime.html
      
      var date = {
        tm_sec: HEAP32[((tm)>>2)],
        tm_min: HEAP32[(((tm)+(4))>>2)],
        tm_hour: HEAP32[(((tm)+(8))>>2)],
        tm_mday: HEAP32[(((tm)+(12))>>2)],
        tm_mon: HEAP32[(((tm)+(16))>>2)],
        tm_year: HEAP32[(((tm)+(20))>>2)],
        tm_wday: HEAP32[(((tm)+(24))>>2)],
        tm_yday: HEAP32[(((tm)+(28))>>2)],
        tm_isdst: HEAP32[(((tm)+(32))>>2)]
      };
  
      var pattern = Pointer_stringify(format);
  
      // expand format
      var EXPANSION_RULES_1 = {
        '%c': '%a %b %d %H:%M:%S %Y',     // Replaced by the locale's appropriate date and time representation - e.g., Mon Aug  3 14:02:01 2013
        '%D': '%m/%d/%y',                 // Equivalent to %m / %d / %y
        '%F': '%Y-%m-%d',                 // Equivalent to %Y - %m - %d
        '%h': '%b',                       // Equivalent to %b
        '%r': '%I:%M:%S %p',              // Replaced by the time in a.m. and p.m. notation
        '%R': '%H:%M',                    // Replaced by the time in 24-hour notation
        '%T': '%H:%M:%S',                 // Replaced by the time
        '%x': '%m/%d/%y',                 // Replaced by the locale's appropriate date representation
        '%X': '%H:%M:%S',                 // Replaced by the locale's appropriate date representation
      };
      for (var rule in EXPANSION_RULES_1) {
        pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_1[rule]);
      }
  
      var WEEKDAYS = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
      var MONTHS = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
  
      function leadingSomething(value, digits, character) {
        var str = typeof value === 'number' ? value.toString() : (value || '');
        while (str.length < digits) {
          str = character[0]+str;
        }
        return str;
      };
  
      function leadingNulls(value, digits) {
        return leadingSomething(value, digits, '0');
      };
  
      function compareByDay(date1, date2) {
        function sgn(value) {
          return value < 0 ? -1 : (value > 0 ? 1 : 0);
        };
  
        var compare;
        if ((compare = sgn(date1.getFullYear()-date2.getFullYear())) === 0) {
          if ((compare = sgn(date1.getMonth()-date2.getMonth())) === 0) {
            compare = sgn(date1.getDate()-date2.getDate());
          }
        }
        return compare;
      };
  
      function getFirstWeekStartDate(janFourth) {
          switch (janFourth.getDay()) {
            case 0: // Sunday
              return new Date(janFourth.getFullYear()-1, 11, 29);
            case 1: // Monday
              return janFourth;
            case 2: // Tuesday
              return new Date(janFourth.getFullYear(), 0, 3);
            case 3: // Wednesday
              return new Date(janFourth.getFullYear(), 0, 2);
            case 4: // Thursday
              return new Date(janFourth.getFullYear(), 0, 1);
            case 5: // Friday
              return new Date(janFourth.getFullYear()-1, 11, 31);
            case 6: // Saturday
              return new Date(janFourth.getFullYear()-1, 11, 30);
          }
      };
  
      function getWeekBasedYear(date) {
          var thisDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          var janFourthThisYear = new Date(thisDate.getFullYear(), 0, 4);
          var janFourthNextYear = new Date(thisDate.getFullYear()+1, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          if (compareByDay(firstWeekStartThisYear, thisDate) <= 0) {
            // this date is after the start of the first week of this year
            if (compareByDay(firstWeekStartNextYear, thisDate) <= 0) {
              return thisDate.getFullYear()+1;
            } else {
              return thisDate.getFullYear();
            }
          } else { 
            return thisDate.getFullYear()-1;
          }
      };
  
      var EXPANSION_RULES_2 = {
        '%a': function(date) {
          return WEEKDAYS[date.tm_wday].substring(0,3);
        },
        '%A': function(date) {
          return WEEKDAYS[date.tm_wday];
        },
        '%b': function(date) {
          return MONTHS[date.tm_mon].substring(0,3);
        },
        '%B': function(date) {
          return MONTHS[date.tm_mon];
        },
        '%C': function(date) {
          var year = date.tm_year+1900;
          return leadingNulls(Math.floor(year/100),2);
        },
        '%d': function(date) {
          return leadingNulls(date.tm_mday, 2);
        },
        '%e': function(date) {
          return leadingSomething(date.tm_mday, 2, ' ');
        },
        '%g': function(date) {
          // %g, %G, and %V give values according to the ISO 8601:2000 standard week-based year. 
          // In this system, weeks begin on a Monday and week 1 of the year is the week that includes 
          // January 4th, which is also the week that includes the first Thursday of the year, and 
          // is also the first week that contains at least four days in the year. 
          // If the first Monday of January is the 2nd, 3rd, or 4th, the preceding days are part of 
          // the last week of the preceding year; thus, for Saturday 2nd January 1999, 
          // %G is replaced by 1998 and %V is replaced by 53. If December 29th, 30th, 
          // or 31st is a Monday, it and any following days are part of week 1 of the following year. 
          // Thus, for Tuesday 30th December 1997, %G is replaced by 1998 and %V is replaced by 01.
          
          return getWeekBasedYear(date).toString().substring(2);
        },
        '%G': function(date) {
          return getWeekBasedYear(date);
        },
        '%H': function(date) {
          return leadingNulls(date.tm_hour, 2);
        },
        '%I': function(date) {
          return leadingNulls(date.tm_hour < 13 ? date.tm_hour : date.tm_hour-12, 2);
        },
        '%j': function(date) {
          // Day of the year (001-366)
          return leadingNulls(date.tm_mday+__arraySum(__isLeapYear(date.tm_year+1900) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, date.tm_mon-1), 3);
        },
        '%m': function(date) {
          return leadingNulls(date.tm_mon+1, 2);
        },
        '%M': function(date) {
          return leadingNulls(date.tm_min, 2);
        },
        '%n': function() {
          return '\n';
        },
        '%p': function(date) {
          if (date.tm_hour > 0 && date.tm_hour < 13) {
            return 'AM';
          } else {
            return 'PM';
          }
        },
        '%S': function(date) {
          return leadingNulls(date.tm_sec, 2);
        },
        '%t': function() {
          return '\t';
        },
        '%u': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay() || 7;
        },
        '%U': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Sunday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year+1900, 0, 1);
          var firstSunday = janFirst.getDay() === 0 ? janFirst : __addDays(janFirst, 7-janFirst.getDay());
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
          
          // is target date after the first Sunday?
          if (compareByDay(firstSunday, endDate) < 0) {
            // calculate difference in days between first Sunday and endDate
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstSundayUntilEndJanuary = 31-firstSunday.getDate();
            var days = firstSundayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
  
          return compareByDay(firstSunday, janFirst) === 0 ? '01': '00';
        },
        '%V': function(date) {
          // Replaced by the week number of the year (Monday as the first day of the week) 
          // as a decimal number [01,53]. If the week containing 1 January has four 
          // or more days in the new year, then it is considered week 1. 
          // Otherwise, it is the last week of the previous year, and the next week is week 1. 
          // Both January 4th and the first Thursday of January are always in week 1. [ tm_year, tm_wday, tm_yday]
          var janFourthThisYear = new Date(date.tm_year+1900, 0, 4);
          var janFourthNextYear = new Date(date.tm_year+1901, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          var endDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          if (compareByDay(endDate, firstWeekStartThisYear) < 0) {
            // if given date is before this years first week, then it belongs to the 53rd week of last year
            return '53';
          } 
  
          if (compareByDay(firstWeekStartNextYear, endDate) <= 0) {
            // if given date is after next years first week, then it belongs to the 01th week of next year
            return '01';
          }
  
          // given date is in between CW 01..53 of this calendar year
          var daysDifference;
          if (firstWeekStartThisYear.getFullYear() < date.tm_year+1900) {
            // first CW of this year starts last year
            daysDifference = date.tm_yday+32-firstWeekStartThisYear.getDate()
          } else {
            // first CW of this year starts this year
            daysDifference = date.tm_yday+1-firstWeekStartThisYear.getDate();
          }
          return leadingNulls(Math.ceil(daysDifference/7), 2);
        },
        '%w': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay();
        },
        '%W': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Monday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year, 0, 1);
          var firstMonday = janFirst.getDay() === 1 ? janFirst : __addDays(janFirst, janFirst.getDay() === 0 ? 1 : 7-janFirst.getDay()+1);
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
  
          // is target date after the first Monday?
          if (compareByDay(firstMonday, endDate) < 0) {
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstMondayUntilEndJanuary = 31-firstMonday.getDate();
            var days = firstMondayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
          return compareByDay(firstMonday, janFirst) === 0 ? '01': '00';
        },
        '%y': function(date) {
          // Replaced by the last two digits of the year as a decimal number [00,99]. [ tm_year]
          return (date.tm_year+1900).toString().substring(2);
        },
        '%Y': function(date) {
          // Replaced by the year as a decimal number (for example, 1997). [ tm_year]
          return date.tm_year+1900;
        },
        '%z': function(date) {
          // Replaced by the offset from UTC in the ISO 8601:2000 standard format ( +hhmm or -hhmm ),
          // or by no characters if no timezone is determinable. 
          // For example, "-0430" means 4 hours 30 minutes behind UTC (west of Greenwich). 
          // If tm_isdst is zero, the standard time offset is used. 
          // If tm_isdst is greater than zero, the daylight savings time offset is used. 
          // If tm_isdst is negative, no characters are returned. 
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%Z': function(date) {
          // Replaced by the timezone name or abbreviation, or by no bytes if no timezone information exists. [ tm_isdst]
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%%': function() {
          return '%';
        }
      };
      for (var rule in EXPANSION_RULES_2) {
        if (pattern.indexOf(rule) >= 0) {
          pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_2[rule](date));
        }
      }
  
      var bytes = intArrayFromString(pattern, false);
      if (bytes.length > maxsize) {
        return 0;
      } 
  
      writeArrayToMemory(bytes, s);
      return bytes.length-1;
    }

  var ___cxa_atexit=_atexit;

  
   
  Module["_rand_r"] = _rand_r;
  
  var ___rand_seed=allocate([0x0273459b, 0, 0, 0], "i32", ALLOC_STATIC); 
  Module["_rand"] = _rand;

  var _llvm_memset_p0i8_i32=_memset;

   
  Module["_i64Subtract"] = _i64Subtract;

   
  Module["_i64Add"] = _i64Add;

  var _pow=Math_pow;

  
  
  
  function ___cxa_is_number_type(type) {
      var isNumber = false;
      try { if (type == __ZTIi) isNumber = true } catch(e){}
      try { if (type == __ZTIj) isNumber = true } catch(e){}
      try { if (type == __ZTIl) isNumber = true } catch(e){}
      try { if (type == __ZTIm) isNumber = true } catch(e){}
      try { if (type == __ZTIx) isNumber = true } catch(e){}
      try { if (type == __ZTIy) isNumber = true } catch(e){}
      try { if (type == __ZTIf) isNumber = true } catch(e){}
      try { if (type == __ZTId) isNumber = true } catch(e){}
      try { if (type == __ZTIe) isNumber = true } catch(e){}
      try { if (type == __ZTIc) isNumber = true } catch(e){}
      try { if (type == __ZTIa) isNumber = true } catch(e){}
      try { if (type == __ZTIh) isNumber = true } catch(e){}
      try { if (type == __ZTIs) isNumber = true } catch(e){}
      try { if (type == __ZTIt) isNumber = true } catch(e){}
      return isNumber;
    }function ___cxa_does_inherit(definiteType, possibilityType, possibility) {
      if (possibility == 0) return false;
      if (possibilityType == 0 || possibilityType == definiteType)
        return true;
      var possibility_type_info;
      if (___cxa_is_number_type(possibilityType)) {
        possibility_type_info = possibilityType;
      } else {
        var possibility_type_infoAddr = HEAP32[((possibilityType)>>2)] - 8;
        possibility_type_info = HEAP32[((possibility_type_infoAddr)>>2)];
      }
      switch (possibility_type_info) {
      case 0: // possibility is a pointer
        // See if definite type is a pointer
        var definite_type_infoAddr = HEAP32[((definiteType)>>2)] - 8;
        var definite_type_info = HEAP32[((definite_type_infoAddr)>>2)];
        if (definite_type_info == 0) {
          // Also a pointer; compare base types of pointers
          var defPointerBaseAddr = definiteType+8;
          var defPointerBaseType = HEAP32[((defPointerBaseAddr)>>2)];
          var possPointerBaseAddr = possibilityType+8;
          var possPointerBaseType = HEAP32[((possPointerBaseAddr)>>2)];
          return ___cxa_does_inherit(defPointerBaseType, possPointerBaseType, possibility);
        } else
          return false; // one pointer and one non-pointer
      case 1: // class with no base class
        return false;
      case 2: // class with base class
        var parentTypeAddr = possibilityType + 8;
        var parentType = HEAP32[((parentTypeAddr)>>2)];
        return ___cxa_does_inherit(definiteType, parentType, possibility);
      default:
        return false; // some unencountered type
      }
    }
  
  function ___resumeException(ptr) {
      if (!___cxa_last_thrown_exception) { ___cxa_last_thrown_exception = ptr; }
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }function ___cxa_find_matching_catch(thrown, throwntype) {
      if (thrown == -1) thrown = ___cxa_last_thrown_exception;
      header = thrown - ___cxa_exception_header_size;
      if (throwntype == -1) throwntype = HEAP32[((header)>>2)];
      var typeArray = Array.prototype.slice.call(arguments, 2);
  
      // If throwntype is a pointer, this means a pointer has been
      // thrown. When a pointer is thrown, actually what's thrown
      // is a pointer to the pointer. We'll dereference it.
      if (throwntype != 0 && !___cxa_is_number_type(throwntype)) {
        var throwntypeInfoAddr= HEAP32[((throwntype)>>2)] - 8;
        var throwntypeInfo= HEAP32[((throwntypeInfoAddr)>>2)];
        if (throwntypeInfo == 0)
          thrown = HEAP32[((thrown)>>2)];
      }
      // The different catch blocks are denoted by different types.
      // Due to inheritance, those types may not precisely match the
      // type of the thrown object. Find one which matches, and
      // return the type of the catch block which should be called.
      for (var i = 0; i < typeArray.length; i++) {
        if (___cxa_does_inherit(typeArray[i], throwntype, thrown))
          return ((asm["setTempRet0"](typeArray[i]),thrown)|0);
      }
      // Shouldn't happen unless we have bogus data in typeArray
      // or encounter a type for which emscripten doesn't have suitable
      // typeinfo defined. Best-efforts match just in case.
      return ((asm["setTempRet0"](throwntype),thrown)|0);
    }function ___cxa_throw(ptr, type, destructor) {
      if (!___cxa_throw.initialized) {
        try {
          HEAP32[((__ZTVN10__cxxabiv119__pointer_type_infoE)>>2)]=0; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv117__class_type_infoE)>>2)]=1; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv120__si_class_type_infoE)>>2)]=2; // Workaround for libcxxabi integration bug
        } catch(e){}
        ___cxa_throw.initialized = true;
      }
      var header = ptr - ___cxa_exception_header_size;
      HEAP32[((header)>>2)]=type;
      HEAP32[(((header)+(4))>>2)]=destructor;
      ___cxa_last_thrown_exception = ptr;
      if (!("uncaught_exception" in __ZSt18uncaught_exceptionv)) {
        __ZSt18uncaught_exceptionv.uncaught_exception = 1;
      } else {
        __ZSt18uncaught_exceptionv.uncaught_exception++;
      }
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }

  function _lis_vector_set_value() {
  Module['printErr']('missing function: lis_vector_set_value'); abort(-1);
  }

  
  function _fprintf(stream, format, varargs) {
      // int fprintf(FILE *restrict stream, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var stack = Runtime.stackSave();
      var ret = _fwrite(allocate(result, 'i8', ALLOC_STACK), 1, result.length, stream);
      Runtime.stackRestore(stack);
      return ret;
    }function _printf(format, varargs) {
      // int printf(const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var stdout = HEAP32[((_stdout)>>2)];
      return _fprintf(stdout, format, varargs);
    }

  function _htonl(value) {
      return ((value & 0xff) << 24) + ((value & 0xff00) << 8) +
             ((value & 0xff0000) >>> 8) + ((value & 0xff000000) >>> 24);
    }


  function _lis_solve() {
  Module['printErr']('missing function: lis_solve'); abort(-1);
  }

   
  Module["_strncpy"] = _strncpy;

  function _strtoull_l(str, endptr, base) {
      return _strtoull(str, endptr, base); // no locale support yet
    }

  var _log=Math_log;

  var _emscripten_postinvoke=true;

  function _xerbla_() {
  Module['printErr']('missing function: xerbla_'); abort(-1);
  }

  var _copysignl=_copysign;

  
  function _strtoll(str, endptr, base) {
      return __parseInt64(str, endptr, base, '-9223372036854775808', '9223372036854775807');  // LLONG_MIN, LLONG_MAX.
    }function _strtoll_l(str, endptr, base) {
      return _strtoll(str, endptr, base); // no locale support yet
    }

  function _qsort(base, num, size, cmp) {
      if (num == 0 || size == 0) return;
      // forward calls to the JavaScript sort method
      // first, sort the items logically
      var keys = [];
      for (var i = 0; i < num; i++) keys.push(i);
      keys.sort(function(a, b) {
        return Module['dynCall_iii'](cmp, base+a*size, base+b*size);
      });
      // apply the sort
      var temp = _malloc(num*size);
      _memcpy(temp, base, num*size);
      for (var i = 0; i < num; i++) {
        if (keys[i] == i) continue; // already in place
        _memcpy(base+i*size, temp+keys[i]*size, size);
      }
      _free(temp);
    }

  function _system(command) {
      // int system(const char *command);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/system.html
      // Can't call external programs.
      ___setErrNo(ERRNO_CODES.EAGAIN);
      return -1;
    }

  function _lis_matrix_create() {
  Module['printErr']('missing function: lis_matrix_create'); abort(-1);
  }

  function _strdup(ptr) {
      var len = _strlen(ptr);
      var newStr = _malloc(len + 1);
      (_memcpy(newStr, ptr, len)|0);
      HEAP8[(((newStr)+(len))|0)]=0;
      return newStr;
    }

  function _log10(x) {
      return Math.log(x) / Math.LN10;
    }

   
  Module["_bitshift64Lshr"] = _bitshift64Lshr;

  function _srand(seed) {
      HEAP32[((___rand_seed)>>2)]=seed
    }

  function _isatty(fildes) {
      // int isatty(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/isatty.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      // HACK - implement tcgetattr
      if (!stream.tty) {
        ___setErrNo(ERRNO_CODES.ENOTTY);
        return 0;
      }
      return 1;
    }

  var _putc=_fputc;

  var _BDtoIHigh=true;

  function _pthread_cond_broadcast() {
      return 0;
    }

  
  
   
  Module["_testSetjmp"] = _testSetjmp;function _longjmp(env, value) {
      asm['setThrew'](env, value || 1);
      throw 'longjmp';
    }function _emscripten_longjmp(env, value) {
      _longjmp(env, value);
    }

  function __ZSt9terminatev() {
      _exit(-1234);
    }

  var _fseeko=_fseek;

  function _lis_matrix_set_size() {
  Module['printErr']('missing function: lis_matrix_set_size'); abort(-1);
  }

  function _vfprintf(s, f, va_arg) {
      return _fprintf(s, f, HEAP32[((va_arg)>>2)]);
    }

  
  function _atoi(ptr) {
      return _strtol(ptr, null, 10);
    }var _atol=_atoi;

  function _pthread_mutex_unlock() {}

  function _sbrk(bytes) {
      // Implement a Linux-like 'memory area' for our 'process'.
      // Changes the size of the memory area by |bytes|; returns the
      // address of the previous top ('break') of the memory area
      // We control the "dynamic" memory - DYNAMIC_BASE to DYNAMICTOP
      var self = _sbrk;
      if (!self.called) {
        DYNAMICTOP = alignMemoryPage(DYNAMICTOP); // make sure we start out aligned
        self.called = true;
        assert(Runtime.dynamicAlloc);
        self.alloc = Runtime.dynamicAlloc;
        Runtime.dynamicAlloc = function() { abort('cannot dynamically allocate, sbrk now has control') };
      }
      var ret = DYNAMICTOP;
      if (bytes != 0) self.alloc(bytes);
      return ret;  // Previous break location.
    }

  
  function _ungetc(c, stream) {
      // int ungetc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ungetc.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        return -1;
      }
      if (c === -1) {
        // do nothing for EOF character
        return c;
      }
      c = unSign(c & 0xFF);
      stream.ungotten.push(c);
      stream.eof = false;
      return c;
    }function _fscanf(stream, format, varargs) {
      // int fscanf(FILE *restrict stream, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        return -1;
      }
      var buffer = [];
      function get() {
        var c = _fgetc(stream);
        buffer.push(c);
        return c;
      };
      function unget() {
        _ungetc(buffer.pop(), stream);
      };
      return __scanString(format, get, unget, varargs);
    }



  
  function _stat(path, buf, dontResolveLastLink) {
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/stat.html
      // int stat(const char *path, struct stat *buf);
      // NOTE: dontResolveLastLink is a shortcut for lstat(). It should never be
      //       used in client code.
      path = typeof path !== 'string' ? Pointer_stringify(path) : path;
      try {
        var stat = dontResolveLastLink ? FS.lstat(path) : FS.stat(path);
        HEAP32[((buf)>>2)]=stat.dev;
        HEAP32[(((buf)+(4))>>2)]=0;
        HEAP32[(((buf)+(8))>>2)]=stat.ino;
        HEAP32[(((buf)+(12))>>2)]=stat.mode;
        HEAP32[(((buf)+(16))>>2)]=stat.nlink;
        HEAP32[(((buf)+(20))>>2)]=stat.uid;
        HEAP32[(((buf)+(24))>>2)]=stat.gid;
        HEAP32[(((buf)+(28))>>2)]=stat.rdev;
        HEAP32[(((buf)+(32))>>2)]=0;
        HEAP32[(((buf)+(36))>>2)]=stat.size;
        HEAP32[(((buf)+(40))>>2)]=4096;
        HEAP32[(((buf)+(44))>>2)]=stat.blocks;
        HEAP32[(((buf)+(48))>>2)]=Math.floor(stat.atime.getTime() / 1000);
        HEAP32[(((buf)+(52))>>2)]=0;
        HEAP32[(((buf)+(56))>>2)]=Math.floor(stat.mtime.getTime() / 1000);
        HEAP32[(((buf)+(60))>>2)]=0;
        HEAP32[(((buf)+(64))>>2)]=Math.floor(stat.ctime.getTime() / 1000);
        HEAP32[(((buf)+(68))>>2)]=0;
        HEAP32[(((buf)+(72))>>2)]=stat.ino;
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fstat(fildes, buf) {
      // int fstat(int fildes, struct stat *buf);
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/fstat.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      return _stat(stream.path, buf);
    }

  function _catclose(catd) {
      // int catclose (nl_catd catd)
      return 0;
    }

  function _llvm_lifetime_start() {}

  function ___cxa_guard_release() {}


  
  function _truncate(path, length) {
      // int truncate(const char *path, off_t length);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/truncate.html
      // NOTE: The path argument may be a string, to simplify ftruncate().
      if (typeof path !== 'string') path = Pointer_stringify(path);
      try {
        FS.truncate(path, length);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _ftruncate(fildes, length) {
      // int ftruncate(int fildes, off_t length);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftruncate.html
      try {
        FS.ftruncate(fildes, length);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }

  function _uselocale(locale) {
      return 0;
    }

  function _vsnprintf(s, n, format, va_arg) {
      return _snprintf(s, n, format, HEAP32[((va_arg)>>2)]);
    }


  function _sysconf(name) {
      // long sysconf(int name);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/sysconf.html
      switch(name) {
        case 30: return PAGE_SIZE;
        case 132:
        case 133:
        case 12:
        case 137:
        case 138:
        case 15:
        case 235:
        case 16:
        case 17:
        case 18:
        case 19:
        case 20:
        case 149:
        case 13:
        case 10:
        case 236:
        case 153:
        case 9:
        case 21:
        case 22:
        case 159:
        case 154:
        case 14:
        case 77:
        case 78:
        case 139:
        case 80:
        case 81:
        case 79:
        case 82:
        case 68:
        case 67:
        case 164:
        case 11:
        case 29:
        case 47:
        case 48:
        case 95:
        case 52:
        case 51:
        case 46:
          return 200809;
        case 27:
        case 246:
        case 127:
        case 128:
        case 23:
        case 24:
        case 160:
        case 161:
        case 181:
        case 182:
        case 242:
        case 183:
        case 184:
        case 243:
        case 244:
        case 245:
        case 165:
        case 178:
        case 179:
        case 49:
        case 50:
        case 168:
        case 169:
        case 175:
        case 170:
        case 171:
        case 172:
        case 97:
        case 76:
        case 32:
        case 173:
        case 35:
          return -1;
        case 176:
        case 177:
        case 7:
        case 155:
        case 8:
        case 157:
        case 125:
        case 126:
        case 92:
        case 93:
        case 129:
        case 130:
        case 131:
        case 94:
        case 91:
          return 1;
        case 74:
        case 60:
        case 69:
        case 70:
        case 4:
          return 1024;
        case 31:
        case 42:
        case 72:
          return 32;
        case 87:
        case 26:
        case 33:
          return 2147483647;
        case 34:
        case 1:
          return 47839;
        case 38:
        case 36:
          return 99;
        case 43:
        case 37:
          return 2048;
        case 0: return 2097152;
        case 3: return 65536;
        case 28: return 32768;
        case 44: return 32767;
        case 75: return 16384;
        case 39: return 1000;
        case 89: return 700;
        case 71: return 256;
        case 40: return 255;
        case 2: return 100;
        case 180: return 64;
        case 25: return 20;
        case 5: return 16;
        case 6: return 6;
        case 73: return 4;
        case 84: return 1;
      }
      ___setErrNo(ERRNO_CODES.EINVAL);
      return -1;
    }


  var _ftello=_ftell;

  function _strftime_l(s, maxsize, format, tm) {
      return _strftime(s, maxsize, format, tm); // no locale support yet
    }

  function _abort() {
      Module['abort']();
    }




  var _tan=Math_tan;


  function _pthread_getspecific(key) {
      return PTHREAD_SPECIFIC[key] || 0;
    }

  var _fabs=Math_abs;

  var _floor=Math_floor;

  var _getc=_fgetc;

  var _sqrt=Math_sqrt;

  var _llvm_memmove_p0i8_p0i8_i32=_memmove;

  function _rewind(stream) {
      // void rewind(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/rewind.html
      _fseek(stream, 0, 0);  // SEEK_SET.
      var streamObj = FS.getStreamFromPtr(stream);
      if (streamObj) streamObj.error = false;
    }

  function ___cxa_allocate_exception(size) {
      var ptr = _malloc(size + ___cxa_exception_header_size);
      return ptr + ___cxa_exception_header_size;
    }

  var _sin=Math_sin;

  var _fmodl=_fmod;



  function _vasprintf(s, format, va_arg) {
      return _asprintf(s, format, HEAP32[((va_arg)>>2)]);
    }

  function _catopen(name, oflag) {
      // nl_catd catopen (const char *name, int oflag)
      return -1;
    }

  function ___ctype_toupper_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-toupper-loc.html
      var me = ___ctype_toupper_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,
          73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,
          81,82,83,84,85,86,87,88,89,90,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,
          145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,
          175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,
          205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,
          235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _lis_matrix_destroy() {
  Module['printErr']('missing function: lis_matrix_destroy'); abort(-1);
  }

  function ___ctype_tolower_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-tolower-loc.html
      var me = ___ctype_tolower_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,91,92,93,94,95,96,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,
          134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,
          164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,
          194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,
          224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,
          254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _lis_vector_set_size() {
  Module['printErr']('missing function: lis_vector_set_size'); abort(-1);
  }

  function _unlink(path) {
      // int unlink(const char *path);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/unlink.html
      path = Pointer_stringify(path);
      try {
        FS.unlink(path);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }

  var _emscripten_prep_setjmp=true;

  var _emscripten_setjmp=true;

  var _BItoD=true;

  function _GC_collect_a_little() {
  Module['printErr']('missing function: GC_collect_a_little'); abort(-1);
  }


  function _lis_solver_set_option() {
  Module['printErr']('missing function: lis_solver_set_option'); abort(-1);
  }

  var _exp=Math_exp;

  function _time(ptr) {
      var ret = Math.floor(Date.now()/1000);
      if (ptr) {
        HEAP32[((ptr)>>2)]=ret;
      }
      return ret;
    }

  var __ZTISt9exception=allocate([allocate([1,0,0,0,0,0,0], "i8", ALLOC_STATIC)+8, 0], "i32", ALLOC_STATIC);

  var ___dso_handle=allocate(1, "i32*", ALLOC_STATIC);



FS.staticInit();__ATINIT__.unshift({ func: function() { if (!Module["noFSInit"] && !FS.init.initialized) FS.init() } });__ATMAIN__.push({ func: function() { FS.ignorePermissions = false } });__ATEXIT__.push({ func: function() { FS.quit() } });Module["FS_createFolder"] = FS.createFolder;Module["FS_createPath"] = FS.createPath;Module["FS_createDataFile"] = FS.createDataFile;Module["FS_createPreloadedFile"] = FS.createPreloadedFile;Module["FS_createLazyFile"] = FS.createLazyFile;Module["FS_createLink"] = FS.createLink;Module["FS_createDevice"] = FS.createDevice;
___errno_state = Runtime.staticAlloc(4); HEAP32[((___errno_state)>>2)]=0;
__ATINIT__.unshift({ func: function() { TTY.init() } });__ATEXIT__.push({ func: function() { TTY.shutdown() } });TTY.utf8 = new Runtime.UTF8Processor();
if (ENVIRONMENT_IS_NODE) { var fs = require("fs"); NODEFS.staticInit(); }
_fputc.ret = allocate([0], "i8", ALLOC_STATIC);
__ATINIT__.push({ func: function() { SOCKFS.root = FS.mount(SOCKFS, {}, null); } });
___strtok_state = Runtime.staticAlloc(4);
Module["requestFullScreen"] = function Module_requestFullScreen(lockPointer, resizeCanvas) { Browser.requestFullScreen(lockPointer, resizeCanvas) };
  Module["requestAnimationFrame"] = function Module_requestAnimationFrame(func) { Browser.requestAnimationFrame(func) };
  Module["setCanvasSize"] = function Module_setCanvasSize(width, height, noUpdates) { Browser.setCanvasSize(width, height, noUpdates) };
  Module["pauseMainLoop"] = function Module_pauseMainLoop() { Browser.mainLoop.pause() };
  Module["resumeMainLoop"] = function Module_resumeMainLoop() { Browser.mainLoop.resume() };
  Module["getUserMedia"] = function Module_getUserMedia() { Browser.getUserMedia() }
_fgetc.ret = allocate([0], "i8", ALLOC_STATIC);
STACK_BASE = STACKTOP = Runtime.alignMemory(STATICTOP);

staticSealed = true; // seal the static portion of memory

STACK_MAX = STACK_BASE + 5242880;

DYNAMIC_BASE = DYNAMICTOP = Runtime.alignMemory(STACK_MAX);

assert(DYNAMIC_BASE < TOTAL_MEMORY, "TOTAL_MEMORY not big enough for stack");

 var ctlz_i8 = allocate([8,7,6,6,5,5,5,5,4,4,4,4,4,4,4,4,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0], "i8", ALLOC_DYNAMIC);
 var cttz_i8 = allocate([8,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,7,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0], "i8", ALLOC_DYNAMIC);

var Math_min = Math.min;
function invoke_iiiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    return Module["dynCall_iiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiidiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vd(index,a1) {
  try {
    Module["dynCall_vd"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vi(index,a1) {
  try {
    Module["dynCall_vi"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vii(index,a1,a2) {
  try {
    Module["dynCall_vii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10) {
  try {
    return Module["dynCall_iiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_ii(index,a1) {
  try {
    return Module["dynCall_ii"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viidi(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_viidi"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13) {
  try {
    return Module["dynCall_iiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiii(index,a1,a2,a3) {
  try {
    return Module["dynCall_iiii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiid(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiid"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    Module["dynCall_viiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiii(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiii"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viidii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viidii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iid(index,a1,a2) {
  try {
    return Module["dynCall_iid"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiid(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiid"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    Module["dynCall_viiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iii(index,a1,a2) {
  try {
    return Module["dynCall_iii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiii(index,a1,a2,a3,a4,a5) {
  try {
    return Module["dynCall_iiiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiidi(index,a1,a2,a3,a4,a5,a6) {
  try {
    return Module["dynCall_iiiiidi"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_didd(index,a1,a2,a3) {
  try {
    return Module["dynCall_didd"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_dii(index,a1,a2) {
  try {
    return Module["dynCall_dii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_i(index) {
  try {
    return Module["dynCall_i"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    return Module["dynCall_iiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viii(index,a1,a2,a3) {
  try {
    Module["dynCall_viii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_v(index) {
  try {
    Module["dynCall_v"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiii(index,a1,a2,a3,a4) {
  try {
    return Module["dynCall_iiiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiii(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_viiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function asmPrintInt(x, y) {
  Module.print('int ' + x + ',' + y);// + ' ' + new Error().stack);
}
function asmPrintFloat(x, y) {
  Module.print('float ' + x + ',' + y);// + ' ' + new Error().stack);
}
// EMSCRIPTEN_START_ASM
var asm=(function(global,env,buffer){"use asm";var a=new global.Int8Array(buffer);var b=new global.Int16Array(buffer);var c=new global.Int32Array(buffer);var d=new global.Uint8Array(buffer);var e=new global.Uint16Array(buffer);var f=new global.Uint32Array(buffer);var g=new global.Float32Array(buffer);var h=new global.Float64Array(buffer);var i=env.STACKTOP|0;var j=env.STACK_MAX|0;var k=env.tempDoublePtr|0;var l=env.ABORT|0;var m=env.cttz_i8|0;var n=env.ctlz_i8|0;var o=env.___rand_seed|0;var p=env.__ZTISt9exception|0;var q=env.___dso_handle|0;var r=env._stderr|0;var s=env._stdin|0;var t=env._stdout|0;var u=0;var v=0;var w=0;var x=0;var y=+env.NaN,z=+env.Infinity;var A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0.0;var J=0;var K=0;var L=0;var M=0;var N=0;var O=0;var P=0;var Q=0;var R=0;var S=0;var T=global.Math.floor;var U=global.Math.abs;var V=global.Math.sqrt;var W=global.Math.pow;var X=global.Math.cos;var Y=global.Math.sin;var Z=global.Math.tan;var _=global.Math.acos;var $=global.Math.asin;var aa=global.Math.atan;var ba=global.Math.atan2;var ca=global.Math.exp;var da=global.Math.log;var ea=global.Math.ceil;var fa=global.Math.imul;var ga=env.abort;var ha=env.assert;var ia=env.asmPrintInt;var ja=env.asmPrintFloat;var ka=env.min;var la=env.invoke_iiiiiiii;var ma=env.invoke_viiiii;var na=env.invoke_iiiiidiii;var oa=env.invoke_vd;var pa=env.invoke_vi;var qa=env.invoke_vii;var ra=env.invoke_iiiiiiiiiii;var sa=env.invoke_ii;var ta=env.invoke_viidi;var ua=env.invoke_iiiiiiiiiiiiii;var va=env.invoke_iiii;var wa=env.invoke_iiiiiiiiiiiiiiiiiiiiiii;var xa=env.invoke_iiiiiiiiiiiiiiiiiiiii;var ya=env.invoke_viiiiid;var za=env.invoke_viiiiiiii;var Aa=env.invoke_iiiiiiiiiiiiiiiiiiiiiiiii;var Ba=env.invoke_viiiiii;var Ca=env.invoke_viidii;var Da=env.invoke_iid;var Ea=env.invoke_viiiiiii;var Fa=env.invoke_viiiiiid;var Ga=env.invoke_viiiiiiiii;var Ha=env.invoke_iii;var Ia=env.invoke_iiiiii;var Ja=env.invoke_iiiiidi;var Ka=env.invoke_didd;var La=env.invoke_dii;var Ma=env.invoke_i;var Na=env.invoke_iiiiiiiiii;var Oa=env.invoke_viii;var Pa=env.invoke_v;var Qa=env.invoke_iiiiiiiii;var Ra=env.invoke_iiiii;var Sa=env.invoke_viiii;var Ta=env._fabs;var Ua=env._exp;var Va=env._lis_matrix_assemble;var Wa=env._strrchr;var Xa=env._pthread_key_create;var Ya=env._vsscanf;var Za=env._fscanf;var _a=env.___cxa_guard_acquire;var $a=env._log10;var ab=env._fstat;var bb=env._pclose;var cb=env._lis_solver_create;var db=env.___assert_fail;var eb=env.__ZSt18uncaught_exceptionv;var fb=env._longjmp;var gb=env.__isLeapYear;var hb=env._clock_gettime;var ib=env._fsync;var jb=env._signal;var kb=env._GC_collect_a_little;var lb=env._sbrk;var mb=env._strtoull;var nb=env._emscripten_memcpy_big;var ob=env._sinh;var pb=env._sysconf;var qb=env._close;var rb=env._rewind;var sb=env._cos;var tb=env._fileno;var ub=env._tanh;var vb=env._fread;var wb=env._puts;var xb=env._isatty;var yb=env._lis_matrix_set_value;var zb=env._write;var Ab=env._isblank;var Bb=env._ftell;var Cb=env.__ZNSt9exceptionD2Ev;var Db=env._xerbla_;var Eb=env._round;var Fb=env.___cxa_does_inherit;var Gb=env._strtoll_l;var Hb=env._strstr;var Ib=env.___cxa_rethrow;var Jb=env._llvm_lifetime_end;var Kb=env._catclose;var Lb=env._tmpnam;var Mb=env._lis_vector_get_values;var Nb=env._lis_vector_destroy;var Ob=env._lis_solver_set_option;var Pb=env._tmpfile;var Qb=env._send;var Rb=env._pow;var Sb=env._lis_matrix_set_size;var Tb=env.___cxa_free_exception;var Ub=env.___cxa_find_matching_catch;var Vb=env._isxdigit_l;var Wb=env.___cxa_guard_release;var Xb=env._truncate;var Yb=env._strtol;var Zb=env.__reallyNegative;var _b=env._sin;var $b=env._strtok;var ac=env.___setErrNo;var bc=env._newlocale;var cc=env._isdigit_l;var dc=env.___resumeException;var ec=env._freelocale;var fc=env._srand;var gc=env._qsort;var hc=env._putchar;var ic=env._floor;var jc=env._pthread_mutex_unlock;var kc=env._printf;var lc=env._sprintf;var mc=env._fopen;var nc=env._vasprintf;var oc=env._emscripten_get_now;var pc=env._stat;var qc=env._lis_solve;var rc=env._strtoull_l;var sc=env._read;var tc=env.__addDays;var uc=env._fwrite;var vc=env._time;var wc=env._pthread_mutex_lock;var xc=env._catopen;var yc=env._exit;var zc=env._GC_strdup;var Ac=env._freopen;var Bc=env.___ctype_b_loc;var Cc=env._fmod;var Dc=env._strtok_r;var Ec=env._lseek;var Fc=env._access;var Gc=env._vfprintf;var Hc=env.___cxa_allocate_exception;var Ic=env._atoi;var Jc=env._strtoll;var Kc=env._pwrite;var Lc=env._localtime_r;var Mc=env._tzset;var Nc=env._open;var Oc=env._uselocale;var Pc=env._snprintf;var Qc=env.___errno_location;var Rc=env._GC_malloc;var Sc=env.___cxa_end_catch;var Tc=env._perror;var Uc=env.___cxa_begin_catch;var Vc=env._strftime;var Wc=env._ftruncate;var Xc=env._GC_init;var Yc=env._lis_matrix_set_type;var Zc=env._fseek;var _c=env.__ZSt9terminatev;var $c=env._isxdigit;var ad=env._fclose;var bd=env._vsnprintf;var cd=env.__parseInt;var dd=env._log;var ed=env._pthread_cond_broadcast;var fd=env._popen;var gd=env._recv;var hd=env._tan;var id=env._copysign;var jd=env.__parseInt64;var kd=env.__getFloat;var ld=env._lis_vector_set_value;var md=env._abort;var nd=env._ceil;var od=env._isspace;var pd=env._localtime;var qd=env._lis_matrix_destroy;var rd=env._pthread_getspecific;var sd=env._pthread_cond_wait;var td=env._llvm_lifetime_start;var ud=env.___cxa_is_number_type;var vd=env._cosh;var wd=env._ungetc;var xd=env._system;var yd=env._fmin;var zd=env._fmax;var Ad=env._fflush;var Bd=env._strftime_l;var Cd=env._fprintf;var Dd=env._sscanf;var Ed=env._catgets;var Fd=env._lis_solver_destroy;var Gd=env._strdup;var Hd=env._asprintf;var Id=env.__exit;var Jd=env.___ctype_toupper_loc;var Kd=env._bsearch;var Ld=env.__arraySum;var Md=env.__formatString;var Nd=env._htonl;var Od=env.___ctype_tolower_loc;var Pd=env._unlink;var Qd=env._fputs;var Rd=env._GC_malloc_atomic;var Sd=env._pread;var Td=env._lis_vector_set_size;var Ud=env._mkport;var Vd=env.__scanString;var Wd=env._pthread_setspecific;var Xd=env._fgetc;var Yd=env._fputc;var Zd=env.___cxa_throw;var _d=env._lis_matrix_create;var $d=env._isdigit;var ae=env._strerror;var be=env._emscripten_longjmp;var ce=env._lis_vector_create;var de=env._atexit;var ee=env._sqrt;var fe=env._strerror_r;var ge=0.0;
// EMSCRIPTEN_START_FUNCS
function oPa(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+16|0;j=h;k=h+8|0;if((f|0)==4){l=c[d>>2]|0}else if((f|0)==1){l=a[d]|0}else{l=b[d>>1]|0}d=_Oa(l,j,k,g)|0;g=c[k>>2]|0;l=(((c[67432]|g|0)!=0)<<31>>31)+(e-(c[j>>2]|0))|0;if((l|0)<0){if((e|0)>0){m=0}else{i=h;return}do{le[c[67436]&2047](42);m=m+1|0;}while((m|0)<(e|0));i=h;return}if((l|0)>0){e=0;do{le[c[67436]&2047](32);e=e+1|0;}while((e|0)<(l|0));n=c[k>>2]|0}else{n=g}do{if((n|0)==0){if((c[67432]|0)==0){break}le[c[67436]&2047](43)}else{le[c[67436]&2047](45)}}while(0);if((c[j>>2]|0)>0){o=d;p=0}else{i=h;return}while(1){le[c[67436]&2047](a[o]|0);d=p+1|0;if((d|0)<(c[j>>2]|0)){p=d;o=o+1|0}else{break}}i=h;return}function pPa(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;j=i;i=i+16|0;k=j;l=j+8|0;if((g|0)==4){m=c[d>>2]|0}else if((g|0)==1){m=a[d]|0}else{m=b[d>>1]|0}d=_Oa(m,k,l,h)|0;h=c[l>>2]|0;g=(c[67432]|h|0)!=0;n=g&1;o=c[k>>2]|0;do{if((n+o|0)<=(e|0)){if((n+f|0)>(e|0)){break}if((m|f|0)==0){if((e|0)>0){p=0}else{i=j;return}do{le[c[67436]&2047](32);p=p+1|0;}while((p|0)<(e|0));i=j;return}q=e-((o|0)<(f|0)?f:o)+(g<<31>>31)|0;if((q|0)>0){r=0;do{le[c[67436]&2047](32);r=r+1|0;}while((r|0)<(q|0));s=c[l>>2]|0}else{s=h}do{if((s|0)==0){if((c[67432]|0)==0){break}le[c[67436]&2047](43)}else{le[c[67436]&2047](45)}}while(0);q=c[k>>2]|0;if((f-q|0)>0){r=0;while(1){le[c[67436]&2047](48);t=r+1|0;u=c[k>>2]|0;if((t|0)<(f-u|0)){r=t}else{v=u;break}}}else{v=q}if((v|0)>0){w=d;x=0}else{i=j;return}while(1){le[c[67436]&2047](a[w]|0);r=x+1|0;if((r|0)<(c[k>>2]|0)){x=r;w=w+1|0}else{break}}i=j;return}}while(0);if((e|0)>0){y=0}else{i=j;return}do{le[c[67436]&2047](42);y=y+1|0;}while((y|0)<(e|0));i=j;return}function qPa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((d|0)>0){f=b;g=d}else{i=e;return}while(1){d=g+ -1|0;le[c[67436]&2047](a[f]|0);if((d|0)>0){g=d;f=f+1|0}else{break}}i=e;return}function rPa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;if((d|0)>(e|0)){g=d;while(1){h=g+ -1|0;le[c[67436]&2047](32);if((h|0)>(e|0)){g=h}else{j=e;break}}}else{j=d}if((j|0)>0){k=b;l=j}else{i=f;return}while(1){j=l+ -1|0;le[c[67436]&2047](a[k]|0);if((j|0)>0){l=j;k=k+1|0}else{break}}i=f;return}function sPa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0.0,l=0.0,m=0,n=0,o=0,p=0;j=i;if((f|0)==4){k=+g[a>>2]}else{k=+h[a>>3]}if(k<0.0){l=-k}else{l=k}a:do{if(l<.1){if(!(l!=0.0)){m=1;break}n=jPa(a,b,d,e,f)|0;i=j;return n|0}else{if((d|0)>=0){o=0;k=1.0;while(1){if(!(l>=k)){m=o;break a}if((o|0)<(d|0)){o=o+1|0;k=k*10.0}else{break}}}n=jPa(a,b,d,e,f)|0;i=j;return n|0}}while(0);o=c[67452]|0;c[67452]=0;p=(e|0)==0?4:e+2|0;e=kPa(a,b-p|0,d-m|0,f)|0;if((p|0)>0){f=0;do{le[c[67436]&2047](32);f=f+1|0;}while((f|0)<(p|0))}c[67452]=o;n=e;i=j;return n|0}function tPa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b;k=b+(g+ -1)|0;a:do{if((k|0)==(j|0)){l=1;m=j}else{g=k;while(1){n=g+ -1|0;if((a[g]|0)!=0){l=0;m=g;break a}if((n|0)==(j|0)){l=1;m=j;break}else{g=n}}}}while(0);k=((d[m]|0)>15)+(m-b<<1|1)|0;if((k|0)>(e|0)){if((e|0)>0){o=0}else{i=h;return}do{le[c[67436]&2047](42);o=o+1|0;}while((o|0)<(e|0));i=h;return}o=f-k|0;b=(o|0)>0;g=b?f:k;if((g|0)<(e|0)){k=e;do{k=k+ -1|0;le[c[67436]&2047](32);}while((k|0)>(g|0))}if(b){b=o;do{b=b+ -1|0;le[c[67436]&2047](48);}while((b|0)>0)}b=a[m]|0;do{if((b&240|0)==0){le[c[67436]&2047](a[275560+(b&15)|0]|0);if(l){i=h;return}else{p=m+ -1|0;break}}else{p=m}}while(0);while(1){le[c[67436]&2047](a[275560+((d[p]|0)>>>4)|0]|0);le[c[67436]&2047](a[275560+(a[p]&15)|0]|0);if((p|0)==(j|0)){break}p=p+ -1|0}i=h;return}function uPa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=c[a>>2]|0;switch(e|0){case 4:case 14:{c[67448]=(c[67448]|0)+(c[a+4>>2]|0);f=1;i=b;return f|0};case 13:{g=(c[67448]|0)-(c[a+4>>2]|0)|0;h=0-(c[67446]|0)|0;c[67448]=(g|0)<(h|0)?h:g;f=1;i=b;return f|0};case 15:{c[67448]=(c[a+4>>2]|0)+ -1-(c[67446]|0);f=1;i=b;return f|0};case 5:{f=Ie[c[67444]&7]()|0;i=b;return f|0};case 12:{f=wPa(c[a+4>>2]|0,c[a+8>>2]|0)|0;i=b;return f|0};case 11:{f=vPa(c[a+8>>2]|0)|0;i=b;return f|0};default:{f=c[r>>2]|0;c[d>>2]=e;Cd(f|0,275528,d|0)|0;yOa(c[67372]|0,1)}}return 0}function vPa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;do{if((c[67448]|0)!=0){e=nPa()|0;if((e|0)==0){break}else{f=e}i=d;return f|0}}while(0);e=a[b]|0;g=b+1|0;h=a[g]|0;if(h<<24>>24==0){f=1;i=d;return f|0}else{j=g;k=h;l=b}while(1){if(k<<24>>24==e<<24>>24){b=l+2|0;if(!((a[b]|0)==e<<24>>24)){f=1;m=9;break}le[c[67436]&2047](e<<24>>24);n=b}else{le[c[67436]&2047](k<<24>>24);n=j}b=n+1|0;h=a[b]|0;if(h<<24>>24==0){f=1;m=9;break}else{j=b;k=h;l=n}}if((m|0)==9){i=d;return f|0}return 0}function wPa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;do{if((c[67448]|0)!=0){f=nPa()|0;if((f|0)==0){break}else{g=f}i=e;return g|0}}while(0);if((b|0)==0){g=1;i=e;return g|0}else{h=d;j=b}while(1){b=j+ -1|0;le[c[67436]&2047](a[h]|0);if((b|0)==0){g=1;break}else{j=b;h=h+1|0}}i=e;return g|0}function xPa(){var a=0,b=0;a=i;b=$Oa(10)|0;c[67448]=0;c[67446]=0;c[67450]=0;i=a;return(b|0)==0|0}function yPa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((c[67422]|0)==0){KOa()}c[67386]=0;c[67392]=1;c[67400]=1;c[67410]=1;d=fPa(a)|0;if((d|0)!=0){e=d;i=b;return e|0}c[67428]=a;c[67446]=0;c[67448]=0;c[67450]=0;c[68700]=0;c[67452]=0;d=c[a+12>>2]|0;c[67372]=d;c[67424]=c[c[66146]>>2];if((NOa(d)|0)<0){if((c[a>>2]|0)==0){JOa(100,275608);e=100;i=b;return e|0}else{c[(Qc()|0)>>2]=100;e=100;i=b;return e|0}}c[67436]=1274;c[67438]=45;c[67440]=111;c[67426]=4;c[67442]=5;c[67444]=6;SOa();c[67432]=0;d=c[66146]|0;c[67434]=c[d+32>>2];if((c[d+40>>2]|0)==1){e=0;i=b;return e|0}if((LOa(d)|0)==0){e=0;i=b;return e|0}d=(c[a>>2]|0)==0;a=Qc()|0;f=c[a>>2]|0;if(d){JOa(f,275616);e=c[a>>2]|0;i=b;return e|0}else{c[a>>2]=f;e=f;i=b;return e|0}return 0}function zPa(){var a=0,b=0;a=i;if((c[68700]|0)==0){b=$Oa(10)|0}else{$Oa(0)|0;Ad(c[67424]|0)|0;b=0}c[67448]=0;c[67446]=0;c[67450]=0;i=a;return b|0}function APa(){var a=0,b=0,d=0;a=i;if((c[68684]|0)==0){b=0}else{d=$Oa(10)|0;c[68684]=0;b=d}c[67448]=0;c[67446]=0;c[67450]=0;i=a;return b|0}function BPa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+32|0;d=b;e=b+8|0;f=b+16|0;g=b+24|0;h=c[s>>2]|0;XPa(276344,h,276400);c[68908]=277852;c[275640>>2]=277872;c[275636>>2]=0;ORa(275640|0,276344);c[275712>>2]=0;c[275716>>2]=-1;j=c[t>>2]|0;c[69112]=277720;wXa(276452|0);k=276456|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[69112]=276960;c[276480>>2]=j;xXa(g,276452|0);k=AXa(g,280512)|0;l=k;yXa(g);c[276484>>2]=l;c[276488>>2]=276408;a[276492|0]=(oe[c[(c[k>>2]|0)+28>>2]&127](l)|0)&1;c[68930]=277932;c[275724>>2]=277952;ORa(275724|0,276448);c[275796>>2]=0;c[275800>>2]=-1;l=c[r>>2]|0;c[69124]=277720;wXa(276500|0);k=276504|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[69124]=276960;c[276528>>2]=l;xXa(f,276500|0);k=AXa(f,280512)|0;g=k;yXa(f);c[276532>>2]=g;c[276536>>2]=276416;a[276540|0]=(oe[c[(c[k>>2]|0)+28>>2]&127](g)|0)&1;c[68952]=277932;c[275812>>2]=277952;ORa(275812|0,276496);c[275884>>2]=0;c[275888>>2]=-1;g=c[(c[(c[68952]|0)+ -12>>2]|0)+275832>>2]|0;c[68974]=277932;c[275900>>2]=277952;ORa(275900|0,g);c[275972>>2]=0;c[275976>>2]=-1;c[(c[(c[68908]|0)+ -12>>2]|0)+275704>>2]=275720;g=(c[(c[68952]|0)+ -12>>2]|0)+275812|0;c[g>>2]=c[g>>2]|8192;c[(c[(c[68952]|0)+ -12>>2]|0)+275880>>2]=275720;JPa(276544,h,276424|0);c[68996]=277892;c[275992>>2]=277912;c[275988>>2]=0;ORa(275992|0,276544);c[276064>>2]=0;c[276068>>2]=-1;c[69150]=277784;wXa(276604|0);h=276608|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[69150]=276704;c[276632>>2]=j;xXa(e,276604|0);j=AXa(e,280520)|0;h=j;yXa(e);c[276636>>2]=h;c[276640>>2]=276432;a[276644|0]=(oe[c[(c[j>>2]|0)+28>>2]&127](h)|0)&1;c[69018]=277972;c[276076>>2]=277992;ORa(276076|0,276600);c[276148>>2]=0;c[276152>>2]=-1;c[69162]=277784;wXa(276652|0);h=276656|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[69162]=276704;c[276680>>2]=l;xXa(d,276652|0);l=AXa(d,280520)|0;h=l;yXa(d);c[276684>>2]=h;c[276688>>2]=276440;a[276692|0]=(oe[c[(c[l>>2]|0)+28>>2]&127](h)|0)&1;c[69040]=277972;c[276164>>2]=277992;ORa(276164|0,276648);c[276236>>2]=0;c[276240>>2]=-1;h=c[(c[(c[69040]|0)+ -12>>2]|0)+276184>>2]|0;c[69062]=277972;c[276252>>2]=277992;ORa(276252|0,h);c[276324>>2]=0;c[276328>>2]=-1;c[(c[(c[68996]|0)+ -12>>2]|0)+276056>>2]=276072;h=(c[(c[69040]|0)+ -12>>2]|0)+276164|0;c[h>>2]=c[h>>2]|8192;c[(c[(c[69040]|0)+ -12>>2]|0)+276232>>2]=276072;i=b;return}function CPa(a){a=a|0;a=i;MSa(275720)|0;MSa(275896)|0;TSa(276072)|0;TSa(276248)|0;i=a;return}function DPa(a){a=a|0;var b=0;b=i;c[a>>2]=277784;yXa(a+4|0);i=b;return}function EPa(a){a=a|0;var b=0;b=i;c[a>>2]=277784;yXa(a+4|0);b$a(a);i=b;return}function FPa(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;oe[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=AXa(d,280520)|0;d=f;c[b+36>>2]=d;a[b+44|0]=(oe[c[(c[f>>2]|0)+28>>2]&127](d)|0)&1;i=e;return}function GPa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+36|0;g=a+40|0;h=d;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=Ee[c[(c[a>>2]|0)+20>>2]&63](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((uc(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((Ad(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}function HPa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((a[b+44|0]|0)!=0){g=uc(d|0,4,e|0,c[b+32>>2]|0)|0;i=f;return g|0}if((e|0)>0){h=d;j=0}else{g=0;i=f;return g|0}while(1){if((De[c[(c[b>>2]|0)+52>>2]&63](b,c[h>>2]|0)|0)==-1){g=j;k=6;break}d=j+1|0;if((d|0)<(e|0)){h=h+4|0;j=d}else{g=d;k=6;break}}if((k|0)==6){i=f;return g|0}return 0}function IPa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;a:do{if(!k){c[g>>2]=d;if((a[b+44|0]|0)!=0){if((uc(g|0,4,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f;c[h>>2]=m;n=g+4|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=Me[c[(c[u>>2]|0)+12>>2]&15](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=12;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(!(v>>>0<2)){l=-1;w=12;break}v=(c[h>>2]|0)-r|0;if((uc(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=12;break}if(u){t=u?c[j>>2]|0:t}else{break a}}if((w|0)==7){if((uc(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==12){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function JPa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=b;c[h>>2]=277784;j=b+4|0;wXa(j);k=b+8|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[h>>2]=276816;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;xXa(g,j);j=AXa(g,280520)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=oe[c[(c[j>>2]|0)+24>>2]&127](e)|0;e=c[d>>2]|0;a[b+53|0]=(oe[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[h>>2]|0)>8){IWa(276912)}else{yXa(g);i=f;return}}function KPa(a){a=a|0;var b=0;b=i;c[a>>2]=277784;yXa(a+4|0);i=b;return}function LPa(a){a=a|0;var b=0;b=i;c[a>>2]=277784;yXa(a+4|0);b$a(a);i=b;return}function MPa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=AXa(d,280520)|0;d=f;g=b+36|0;c[g>>2]=d;h=b+44|0;c[h>>2]=oe[c[(c[f>>2]|0)+24>>2]&127](d)|0;d=c[g>>2]|0;a[b+53|0]=(oe[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[h>>2]|0)>8){IWa(276912)}else{i=e;return}}function NPa(a){a=a|0;var b=0,c=0;b=i;c=QPa(a,0)|0;i=b;return c|0}function OPa(a){a=a|0;var b=0,c=0;b=i;c=QPa(a,1)|0;i=b;return c|0}function PPa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;a:do{if(l){c[h>>2]=c[n>>2];o=c[b+36>>2]|0;p=f;q=Me[c[(c[o>>2]|0)+12>>2]&15](o,c[b+40>>2]|0,h,h+4|0,j,p,f+8|0,g)|0;if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}else if((q|0)==1|(q|0)==2){m=-1;i=e;return m|0}q=b+32|0;while(1){o=c[g>>2]|0;if(!(o>>>0>p>>>0)){break a}r=o+ -1|0;c[g>>2]=r;if((wd(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}function QPa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;if((a[k]|0)!=0){l=b+48|0;m=c[l>>2]|0;if(!d){n=m;i=e;return n|0}c[l>>2]=-1;a[k]=0;n=m;i=e;return n|0}m=c[b+44>>2]|0;k=(m|0)>1?m:1;a:do{if((k|0)>0){m=b+32|0;l=0;while(1){o=Xd(c[m>>2]|0)|0;if((o|0)==-1){n=-1;break}a[f+l|0]=o;l=l+1|0;if((l|0)>=(k|0)){break a}}i=e;return n|0}}while(0);b:do{if((a[b+53|0]|0)==0){l=b+40|0;m=b+36|0;o=f;p=g+4|0;q=b+32|0;r=k;while(1){s=c[l>>2]|0;t=s;u=c[t>>2]|0;v=c[t+4>>2]|0;t=c[m>>2]|0;w=f+r|0;x=Me[c[(c[t>>2]|0)+16>>2]&15](t,s,o,w,h,g,p,j)|0;if((x|0)==2){n=-1;y=22;break}else if((x|0)==3){y=14;break}else if((x|0)!=1){z=r;break b}x=c[l>>2]|0;c[x>>2]=u;c[x+4>>2]=v;if((r|0)==8){n=-1;y=22;break}v=Xd(c[q>>2]|0)|0;if((v|0)==-1){n=-1;y=22;break}a[w]=v;r=r+1|0}if((y|0)==14){c[g>>2]=a[o]|0;z=r;break}else if((y|0)==22){i=e;return n|0}}else{c[g>>2]=a[f]|0;z=k}}while(0);if(d){d=c[g>>2]|0;c[b+48>>2]=d;n=d;i=e;return n|0}d=b+32|0;b=z;while(1){if((b|0)<=0){break}z=b+ -1|0;if((wd(a[f+z|0]|0,c[d>>2]|0)|0)==-1){n=-1;y=22;break}else{b=z}}if((y|0)==22){i=e;return n|0}n=c[g>>2]|0;i=e;return n|0}function RPa(a){a=a|0;var b=0;b=i;c[a>>2]=277720;yXa(a+4|0);i=b;return}function SPa(a){a=a|0;var b=0;b=i;c[a>>2]=277720;yXa(a+4|0);b$a(a);i=b;return}function TPa(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;oe[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=AXa(d,280512)|0;d=f;c[b+36>>2]=d;a[b+44|0]=(oe[c[(c[f>>2]|0)+28>>2]&127](d)|0)&1;i=e;return}function UPa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+36|0;g=a+40|0;h=d;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=Ee[c[(c[a>>2]|0)+20>>2]&63](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((uc(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((Ad(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}function VPa(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;if((a[b+44|0]|0)!=0){h=uc(e|0,1,f|0,c[b+32>>2]|0)|0;i=g;return h|0}if((f|0)>0){j=e;k=0}else{h=0;i=g;return h|0}while(1){if((De[c[(c[b>>2]|0)+52>>2]&63](b,d[j]|0)|0)==-1){h=k;l=6;break}e=k+1|0;if((e|0)<(f|0)){j=j+1|0;k=e}else{h=e;l=6;break}}if((l|0)==6){i=g;return h|0}return 0}function WPa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;a:do{if(!k){a[g]=d;if((a[b+44|0]|0)!=0){if((uc(g|0,1,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f;c[h>>2]=m;n=g+1|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=Me[c[(c[u>>2]|0)+12>>2]&15](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=12;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(!(v>>>0<2)){l=-1;w=12;break}v=(c[h>>2]|0)-r|0;if((uc(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=12;break}if(u){t=u?c[j>>2]|0:t}else{break a}}if((w|0)==7){if((uc(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==12){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function XPa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=b;c[h>>2]=277720;j=b+4|0;wXa(j);k=b+8|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[h>>2]=277072;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;xXa(g,j);j=AXa(g,280512)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=oe[c[(c[j>>2]|0)+24>>2]&127](e)|0;e=c[d>>2]|0;a[b+53|0]=(oe[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[h>>2]|0)>8){IWa(276912)}else{yXa(g);i=f;return}}function YPa(a){a=a|0;var b=0;b=i;c[a>>2]=277720;yXa(a+4|0);i=b;return}function ZPa(a){a=a|0;var b=0;b=i;c[a>>2]=277720;yXa(a+4|0);b$a(a);i=b;return}function _Pa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=AXa(d,280512)|0;d=f;g=b+36|0;c[g>>2]=d;h=b+44|0;c[h>>2]=oe[c[(c[f>>2]|0)+24>>2]&127](d)|0;d=c[g>>2]|0;a[b+53|0]=(oe[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[h>>2]|0)>8){IWa(276912)}else{i=e;return}}function $Pa(a){a=a|0;var b=0,c=0;b=i;c=cQa(a,0)|0;i=b;return c|0}function aQa(a){a=a|0;var b=0,c=0;b=i;c=cQa(a,1)|0;i=b;return c|0}function bQa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;a:do{if(l){a[h]=c[n>>2];o=c[b+36>>2]|0;p=f;q=Me[c[(c[o>>2]|0)+12>>2]&15](o,c[b+40>>2]|0,h,h+1|0,j,p,f+8|0,g)|0;if((q|0)==1|(q|0)==2){m=-1;i=e;return m|0}else if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}q=b+32|0;while(1){o=c[g>>2]|0;if(!(o>>>0>p>>>0)){break a}r=o+ -1|0;c[g>>2]=r;if((wd(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}function cQa(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+32|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=b+52|0;if((a[l]|0)!=0){m=b+48|0;n=c[m>>2]|0;if(!e){o=n;i=f;return o|0}c[m>>2]=-1;a[l]=0;o=n;i=f;return o|0}n=c[b+44>>2]|0;l=(n|0)>1?n:1;a:do{if((l|0)>0){n=b+32|0;m=0;while(1){p=Xd(c[n>>2]|0)|0;if((p|0)==-1){o=-1;break}a[g+m|0]=p;m=m+1|0;if((m|0)>=(l|0)){break a}}i=f;return o|0}}while(0);b:do{if((a[b+53|0]|0)==0){m=b+40|0;n=b+36|0;p=g;q=h+1|0;r=b+32|0;s=l;while(1){t=c[m>>2]|0;u=t;v=c[u>>2]|0;w=c[u+4>>2]|0;u=c[n>>2]|0;x=g+s|0;y=Me[c[(c[u>>2]|0)+16>>2]&15](u,t,p,x,j,h,q,k)|0;if((y|0)==2){o=-1;z=23;break}else if((y|0)==3){z=14;break}else if((y|0)!=1){A=s;break b}y=c[m>>2]|0;c[y>>2]=v;c[y+4>>2]=w;if((s|0)==8){o=-1;z=23;break}w=Xd(c[r>>2]|0)|0;if((w|0)==-1){o=-1;z=23;break}a[x]=w;s=s+1|0}if((z|0)==14){a[h]=a[p]|0;A=s;break}else if((z|0)==23){i=f;return o|0}}else{a[h]=a[g]|0;A=l}}while(0);do{if(e){l=a[h]|0;c[b+48>>2]=l&255;B=l}else{l=b+32|0;k=A;while(1){if((k|0)<=0){z=21;break}j=k+ -1|0;if((wd(d[g+j|0]|0,c[l>>2]|0)|0)==-1){o=-1;z=23;break}else{k=j}}if((z|0)==21){B=a[h]|0;break}else if((z|0)==23){i=f;return o|0}}}while(0);o=B&255;i=f;return o|0}function dQa(){var a=0;a=i;BPa(0);de(1275,276336,q|0)|0;i=a;return}function eQa(a){a=a|0;i=i;return}function fQa(a){a=a|0;var b=0;b=a+4|0;c[b>>2]=1+(c[b>>2]|0);i=i;return}function gQa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+4|0;e=c[d>>2]|0;c[d>>2]=-1+e;if((e|0)!=0){f=0;i=b;return f|0}le[c[(c[a>>2]|0)+8>>2]&2047](a);f=1;i=b;return f|0}function hQa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=277216;e=x$a(b|0)|0;f=a$a(e+13|0)|0;c[f+4>>2]=e;c[f>>2]=e;g=f+12|0;c[a+4>>2]=g;c[f+8>>2]=0;z$a(g|0,b|0,e+1|0)|0;i=d;return}function iQa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=277216;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;Cb(h|0);j=a;b$a(j);i=b;return}c$a((c[d>>2]|0)+ -12|0);g=a;h=g;Cb(h|0);j=a;b$a(j);i=b;return}function jQa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=277216;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;Cb(h|0);i=b;return}c$a((c[d>>2]|0)+ -12|0);g=a;h=g;Cb(h|0);i=b;return}function kQa(a){a=a|0;i=i;return c[a+4>>2]|0}function lQa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;c[b>>2]=277240;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=x$a(f|0)|0;g=a$a(d+13|0)|0;c[g+4>>2]=d;c[g>>2]=d;h=g+12|0;c[b+4>>2]=h;c[g+8>>2]=0;z$a(h|0,f|0,d+1|0)|0;i=e;return}function mQa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=277240;e=x$a(b|0)|0;f=a$a(e+13|0)|0;c[f+4>>2]=e;c[f>>2]=e;g=f+12|0;c[a+4>>2]=g;c[f+8>>2]=0;z$a(g|0,b|0,e+1|0)|0;i=d;return}function nQa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=277240;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;Cb(h|0);j=a;b$a(j);i=b;return}c$a((c[d>>2]|0)+ -12|0);g=a;h=g;Cb(h|0);j=a;b$a(j);i=b;return}function oQa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=277240;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;Cb(h|0);i=b;return}c$a((c[d>>2]|0)+ -12|0);g=a;h=g;Cb(h|0);i=b;return}function pQa(a){a=a|0;i=i;return c[a+4>>2]|0}function qQa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=277216;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;Cb(h|0);j=a;b$a(j);i=b;return}c$a((c[d>>2]|0)+ -12|0);g=a;h=g;Cb(h|0);j=a;b$a(j);i=b;return}function rQa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=277216;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;Cb(h|0);j=a;b$a(j);i=b;return}c$a((c[d>>2]|0)+ -12|0);g=a;h=g;Cb(h|0);j=a;b$a(j);i=b;return}function sQa(a){a=a|0;i=i;return}function tQa(a,b,d){a=a|0;b=b|0;d=d|0;c[a>>2]=d;c[a+4>>2]=b;i=i;return}function uQa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e;Ke[c[(c[a>>2]|0)+12>>2]&15](f,a,b);if((c[f+4>>2]|0)!=(c[d+4>>2]|0)){g=0;i=e;return g|0}g=(c[f>>2]|0)==(c[d>>2]|0);i=e;return g|0}function vQa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((c[b+4>>2]|0)!=(a|0)){f=0;i=e;return f|0}f=(c[b>>2]|0)==(d|0);i=e;return f|0}function wQa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;f=ae(e|0)|0;e=x$a(f|0)|0;if(e>>>0>4294967279){CQa(0)}if(e>>>0<11){a[b]=e<<1;g=b+1|0;z$a(g|0,f|0,e|0)|0;h=g;j=h+e|0;k=j;a[k]=0;i=d;return}else{l=e+16&-16;m=$_a(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=e;g=m;z$a(g|0,f|0,e|0)|0;h=g;j=h+e|0;k=j;a[k]=0;i=d;return}}function xQa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;g=f;h=d;j=c[h>>2]|0;k=e;do{if((j|0)!=0){l=a[e]|0;if((l&1)==0){m=(l&255)>>>1}else{m=c[e+4>>2]|0}if((m|0)==0){n=j}else{hRa(e,277456,2)|0;n=c[h>>2]|0}l=c[d+4>>2]|0;Ke[c[(c[l>>2]|0)+24>>2]&15](g,l,n);l=a[g]|0;if((l&1)==0){o=g+1|0;p=(l&255)>>>1}else{o=c[g+8>>2]|0;p=c[g+4>>2]|0}hRa(e,o,p)|0;if((a[g]&1)==0){break}b$a(c[g+8>>2]|0)}}while(0);g=b;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;i=f;return}function yQa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f;h=f+16|0;j=x$a(e|0)|0;if(j>>>0>4294967279){CQa(0)}if(j>>>0<11){a[h]=j<<1;k=h+1|0}else{l=j+16&-16;m=$_a(l)|0;c[h+8>>2]=m;c[h>>2]=l|1;c[h+4>>2]=j;k=m}z$a(k|0,e|0,j|0)|0;a[k+j|0]=0;xQa(g,d,h);lQa(b,g);if(!((a[g]&1)==0)){b$a(c[g+8>>2]|0)}if(!((a[h]&1)==0)){b$a(c[h+8>>2]|0)}c[b>>2]=277472;h=d;d=c[h+4>>2]|0;g=b+8|0;c[g>>2]=c[h>>2];c[g+4>>2]=d;i=f;return}function zQa(a){a=a|0;var b=0;b=i;oQa(a);b$a(a);i=b;return}function AQa(a){a=a|0;var b=0;b=i;oQa(a);i=b;return}function BQa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;wc(277608)|0;if((c[a>>2]|0)==1){do{sd(277632,277608)|0;}while((c[a>>2]|0)==1)}if((c[a>>2]|0)==0){c[a>>2]=1;jc(277608)|0;le[d&2047](b);wc(277608)|0;c[a>>2]=-1;jc(277608)|0;ed(277632)|0;i=e;return}else{jc(277608)|0;i=e;return}}function CQa(a){a=a|0;a=Hc(8)|0;hQa(a,277680);c[a>>2]=277296;Zd(a|0,277336,41)}function DQa(a){a=a|0;a=Hc(8)|0;hQa(a,277680);c[a>>2]=277360;Zd(a|0,277400,41)}function EQa(a){a=a|0;var b=0,d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function FQa(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function GQa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=d;if((a[d]&1)==0){g=b;c[g+0>>2]=c[f+0>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];i=e;return}f=c[d+8>>2]|0;g=c[d+4>>2]|0;if(g>>>0>4294967279){CQa(0)}if(g>>>0<11){a[b]=g<<1;h=b+1|0}else{d=g+16&-16;j=$_a(d)|0;c[b+8>>2]=j;c[b>>2]=d|1;c[b+4>>2]=g;h=j}z$a(h|0,f|0,g|0)|0;a[h+g|0]=0;i=e;return}function HQa(b){b=b|0;i=i;return(a[b]&1)!=0|0}function IQa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>4294967279){CQa(0)}if(e>>>0<11){a[b]=e<<1;g=b+1|0}else{h=e+16&-16;j=$_a(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}z$a(g|0,d|0,e|0)|0;a[g+e|0]=0;i=f;return}function JQa(a){a=a|0;i=i;return a|0}function KQa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=x$a(d|0)|0;if(f>>>0>4294967279){CQa(0)}if(f>>>0<11){a[b]=f<<1;g=b+1|0;z$a(g|0,d|0,f|0)|0;h=g;j=h+f|0;k=j;a[k]=0;i=e;return}else{l=f+16&-16;m=$_a(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=f;g=m;z$a(g|0,d|0,f|0)|0;h=g;j=h+f|0;k=j;a[k]=0;i=e;return}}function LQa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>4294967279){CQa(0)}if(d>>>0<11){a[b]=d<<1;g=b+1|0}else{h=d+16&-16;j=$_a(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}B$a(g|0,e|0,d|0)|0;a[g+d|0]=0;i=f;return}function MQa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if(d>>>0>4294967279){CQa(0)}if(d>>>0<11){a[b]=d<<1;g=b+1|0;B$a(g|0,e|0,d|0)|0;h=g;j=h+d|0;k=j;a[k]=0;i=f;return}else{l=d+16&-16;m=$_a(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=d;g=m;B$a(g|0,e|0,d|0)|0;h=g;j=h+d|0;k=j;a[k]=0;i=f;return}}function NQa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;h=a[d]|0;j=(h&1)==0;if(j){k=(h&255)>>>1}else{k=c[d+4>>2]|0}if(k>>>0<e>>>0){DQa(0)}if(j){l=d+1|0}else{l=c[d+8>>2]|0}d=l+e|0;l=k-e|0;e=l>>>0<f>>>0?l:f;if(e>>>0>4294967279){CQa(0)}if(e>>>0<11){a[b]=e<<1;m=b+1|0;z$a(m|0,d|0,e|0)|0;n=m;o=n+e|0;p=o;a[p]=0;i=g;return}else{f=e+16&-16;l=$_a(f)|0;c[b+8>>2]=l;c[b>>2]=f|1;c[b+4>>2]=e;m=l;z$a(m|0,d|0,e|0)|0;n=m;o=n+e|0;p=o;a[p]=0;i=g;return}}function OQa(b){b=b|0;var d=0,e=0,f=0;d=i;e=a[b]|0;if((e&1)==0){f=(e&255)>>>1;i=d;return f|0}else{f=c[b+4>>2]|0;i=d;return f|0}return 0}function PQa(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=b+1|0;i=d;return e|0}else{e=c[b+8>>2]|0;i=d;return e|0}return 0}function QQa(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){i=d;return}b$a(c[b+8>>2]|0);i=d;return}function RQa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((b|0)==(d|0)){i=e;return b|0}f=a[d]|0;if((f&1)==0){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}d=a[b]|0;if((d&1)==0){j=d;k=10}else{d=c[b>>2]|0;j=d&255;k=(d&-2)+ -1|0}d=(j&1)==0;if(k>>>0<h>>>0){if(d){l=(j&255)>>>1}else{l=c[b+4>>2]|0}iRa(b,k,h-k|0,l,0,l,h,g);i=e;return b|0}if(d){m=b+1|0}else{m=c[b+8>>2]|0}A$a(m|0,g|0,h|0)|0;a[m+h|0]=0;if((a[b]&1)==0){a[b]=h<<1;i=e;return b|0}else{c[b+4>>2]=h;i=e;return b|0}return 0}function SQa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=TQa(a,b)|0;i=c;return d|0}function TQa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=x$a(d|0)|0;g=a[b]|0;if((g&1)==0){h=g;j=10}else{g=c[b>>2]|0;h=g&255;j=(g&-2)+ -1|0}g=(h&1)==0;if(j>>>0<f>>>0){if(g){k=(h&255)>>>1}else{k=c[b+4>>2]|0}iRa(b,j,f-j|0,k,0,k,f,d);i=e;return b|0}if(g){l=b+1|0}else{l=c[b+8>>2]|0}A$a(l|0,d|0,f|0)|0;a[l+f|0]=0;if((a[b]&1)==0){a[b]=f<<1;i=e;return b|0}else{c[b+4>>2]=f;i=e;return b|0}return 0}function UQa(a,b){a=a|0;b=b|0;c[a+4>>2]=b;i=i;return}function VQa(a){a=a|0;i=i;return a+1|0}function WQa(b,c){b=b|0;c=c|0;a[b]=c<<1;i=i;return}function XQa(b){b=b|0;var d=0,e=0,f=0;d=i;e=a[b]|0;if((e&1)==0){f=(e&255)>>>1;i=d;return f|0}else{f=c[b+4>>2]|0;i=d;return f|0}return 0}function YQa(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=10;i=d;return e|0}e=(c[b>>2]&-2)+ -1|0;i=d;return e|0}function ZQa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=a[b]|0;h=(g&1)==0;if(h){j=(g&255)>>>1}else{j=c[b+4>>2]|0}if(j>>>0<d>>>0){_Qa(b,d-j|0,e)|0;i=f;return}if(h){a[b+1+d|0]=0;a[b]=d<<1;i=f;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;i=f;return}}function _Qa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if((d|0)==0){i=f;return b|0}g=a[b]|0;if((g&1)==0){h=g;j=10}else{g=c[b>>2]|0;h=g&255;j=(g&-2)+ -1|0}if((h&1)==0){k=(h&255)>>>1}else{k=c[b+4>>2]|0}if((j-k|0)>>>0<d>>>0){jRa(b,j,d-j+k|0,k,k,0,0);l=a[b]|0}else{l=h}if((l&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}B$a(m+k|0,e|0,d|0)|0;e=k+d|0;if((a[b]&1)==0){a[b]=e<<1}else{c[b+4>>2]=e}a[m+e|0]=0;i=f;return b|0}function $Qa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a[b]|0;g=(f&1)==0;if(g){h=(f&255)>>>1}else{h=c[b+4>>2]|0}if(h>>>0<d>>>0){_Qa(b,d-h|0,0)|0;i=e;return}if(g){a[b+1+d|0]=0;a[b]=d<<1;i=e;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;i=e;return}}function aRa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>4294967279){CQa(0)}f=a[b]|0;if((f&1)==0){g=f;h=10}else{f=c[b>>2]|0;g=f&255;h=(f&-2)+ -1|0}if((g&1)==0){j=(g&255)>>>1}else{j=c[b+4>>2]|0}f=j>>>0>d>>>0?j:d;if(f>>>0<11){k=10}else{k=(f+16&-16)+ -1|0}if((k|0)==(h|0)){i=e;return}do{if((k|0)==10){l=b+1|0;m=0;n=c[b+8>>2]|0;o=1}else{f=k+1|0;if(k>>>0>h>>>0){p=$_a(f)|0}else{p=$_a(f)|0}if((g&1)==0){l=p;m=1;n=b+1|0;o=0;break}else{l=p;m=1;n=c[b+8>>2]|0;o=1;break}}}while(0);if((g&1)==0){q=(g&255)>>>1}else{q=c[b+4>>2]|0}z$a(l|0,n|0,q+1|0)|0;if(o){b$a(n)}if(m){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=l;i=e;return}else{a[b]=j<<1;i=e;return}}function bRa(a){a=a|0;var b=0;if(a>>>0<11){b=10}else{b=(a+16&-16)+ -1|0}i=i;return b|0}function cRa(a,b){a=a|0;b=b|0;c[a>>2]=b|1;i=i;return}function dRa(a,b){a=a|0;b=b|0;c[a+8>>2]=b;i=i;return}function eRa(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){a[b+1|0]=0;a[b]=0;i=d;return}else{a[c[b+8>>2]|0]=0;c[b+4>>2]=0;i=d;return}}function fRa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a[d]|0;if((f&1)==0){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}d=hRa(b,g,h)|0;i=e;return d|0}function gRa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+ -1|0;j=c[b+4>>2]|0}else{h=10;j=(f&255)>>>1}if((j|0)==(h|0)){jRa(b,h,1,h,h,0,0);if((a[b]&1)==0){k=7}else{k=8}}else{if(g){k=8}else{k=7}}if((k|0)==7){a[b]=(j<<1)+2;l=b+1|0;m=j+1|0}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g}a[l+j|0]=d;a[l+m|0]=0;i=e;return}function hRa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b]|0;if((g&1)==0){h=10;j=g}else{g=c[b>>2]|0;h=(g&-2)+ -1|0;j=g&255}if((j&1)==0){k=(j&255)>>>1}else{k=c[b+4>>2]|0}if((h-k|0)>>>0<e>>>0){iRa(b,h,e-h+k|0,k,k,0,e,d);i=f;return b|0}if((e|0)==0){i=f;return b|0}if((j&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}z$a(l+k|0,d|0,e|0)|0;d=k+e|0;if((a[b]&1)==0){a[b]=d<<1}else{c[b+4>>2]=d}a[l+d|0]=0;i=f;return b|0}function iRa(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;if((-18-d|0)>>>0<e>>>0){CQa(0)}if((a[b]&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}do{if(d>>>0<2147483623){n=e+d|0;o=d<<1;p=n>>>0<o>>>0?o:n;if(p>>>0<11){q=11;break}q=p+16&-16}else{q=-17}}while(0);e=$_a(q)|0;if((g|0)!=0){z$a(e|0,m|0,g|0)|0}if((j|0)!=0){z$a(e+g|0,k|0,j|0)|0}k=f-h|0;if((k|0)!=(g|0)){z$a(e+(j+g)|0,m+(h+g)|0,k-g|0)|0}if((d|0)!=10){b$a(m)}c[b+8>>2]=e;c[b>>2]=q|1;q=k+j|0;c[b+4>>2]=q;a[e+q|0]=0;i=l;return}function jRa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;if((-17-d|0)>>>0<e>>>0){CQa(0)}if((a[b]&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}do{if(d>>>0<2147483623){m=e+d|0;n=d<<1;o=m>>>0<n>>>0?n:m;if(o>>>0<11){p=11;break}p=o+16&-16}else{p=-17}}while(0);e=$_a(p)|0;if((g|0)!=0){z$a(e|0,l|0,g|0)|0}o=f-h|0;if((o|0)!=(g|0)){z$a(e+(j+g)|0,l+(h+g)|0,o-g|0)|0}if((d|0)==10){q=b;r=q+8|0;s=r;c[s>>2]=e;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}b$a(l);q=b;r=q+8|0;s=r;c[s>>2]=e;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}function kRa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;NQa(a,b,c,d,0);i=e;return}function lRa(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=b+1|0;i=d;return e|0}else{e=c[b+8>>2]|0;i=d;return e|0}return 0}function mRa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=x$a(d|0)|0;h=a[b]|0;j=(h&1)==0;if(j){k=(h&255)>>>1}else{k=c[b+4>>2]|0}if(k>>>0<e>>>0|(k-e|0)>>>0<g>>>0){l=-1;i=f;return l|0}if((g|0)==0){l=e;i=f;return l|0}if(j){m=b+1|0}else{m=c[b+8>>2]|0}b=m+e|0;j=m+k|0;h=d+g|0;if((j-b|0)<(g|0)){l=-1;i=f;return l|0}n=k+(1-g)|0;g=m+n|0;if((n|0)==(e|0)){l=-1;i=f;return l|0}e=a[d]|0;n=b;a:while(1){if((a[n]|0)==e<<24>>24){b=n;k=d;do{k=k+1|0;if((k|0)==(h|0)){break a}b=b+1|0;}while((a[b]|0)==(a[k]|0))}k=n+1|0;if((k|0)==(g|0)){l=-1;o=18;break}else{n=k}}if((o|0)==18){i=f;return l|0}if((n|0)==(j|0)){l=-1;i=f;return l|0}l=n-m|0;i=f;return l|0}function nRa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)==0;if(g){h=(f&255)>>>1}else{h=c[b+4>>2]|0}f=a[d]|0;j=(f&1)==0;if(j){k=(f&255)>>>1}else{k=c[d+4>>2]|0}if(g){l=b+1|0}else{l=c[b+8>>2]|0}if(j){m=d+1|0}else{m=c[d+8>>2]|0}d=k>>>0<h>>>0;j=s$a(l,m,d?k:h)|0;if((j|0)==0){i=e;return(h>>>0<k>>>0?-1:d&1)|0}else{i=e;return j|0}return 0}function oRa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=x$a(d|0)|0;g=a[b]|0;h=(g&1)==0;if(h){j=(g&255)>>>1}else{j=c[b+4>>2]|0}if((f|0)==-1){DQa(0)}if(h){k=b+1|0}else{k=c[b+8>>2]|0}b=j>>>0>f>>>0;h=s$a(k,d,b?f:j)|0;if((h|0)==0){i=e;return(j>>>0<f>>>0?-1:b&1)|0}else{i=e;return h|0}return 0}function pRa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;if(f>>>0>4294967279){CQa(0)}if(f>>>0<11){a[b]=e<<1;h=b+1|0;z$a(h|0,d|0,e|0)|0;j=h;k=j+e|0;l=k;a[l]=0;i=g;return}else{m=f+16&-16;f=$_a(m)|0;c[b+8>>2]=f;c[b>>2]=m|1;c[b+4>>2]=e;h=f;z$a(h|0,d|0,e|0)|0;j=h;k=j+e|0;l=k;a[l]=0;i=g;return}}function qRa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>1073741807){CQa(0)}if(e>>>0<2){a[b]=e<<1;g=b+4|0}else{h=e+4&-4;j=$_a(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}w_a(g,d,e)|0;c[g+(e<<2)>>2]=0;i=f;return}function rRa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>1073741807){CQa(0)}if(d>>>0<2){a[b]=d<<1;g=b+4|0}else{h=d+4&-4;j=$_a(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}y_a(g,e,d)|0;c[g+(d<<2)>>2]=0;i=f;return}function sRa(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){i=d;return}b$a(c[b+8>>2]|0);i=d;return}function tRa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=uRa(a,b,v_a(b)|0)|0;i=c;return d|0}function uRa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b]|0;if((g&1)==0){h=1;j=g}else{g=c[b>>2]|0;h=(g&-2)+ -1|0;j=g&255}g=(j&1)==0;if(h>>>0<e>>>0){if(g){k=(j&255)>>>1}else{k=c[b+4>>2]|0}xRa(b,h,e-h|0,k,0,k,e,d);i=f;return b|0}if(g){l=b+4|0}else{l=c[b+8>>2]|0}x_a(l,d,e)|0;c[l+(e<<2)>>2]=0;if((a[b]&1)==0){a[b]=e<<1;i=f;return b|0}else{c[b+4>>2]=e;i=f;return b|0}return 0}function vRa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>1073741807){CQa(0)}f=a[b]|0;if((f&1)==0){g=f;h=1}else{f=c[b>>2]|0;g=f&255;h=(f&-2)+ -1|0}if((g&1)==0){j=(g&255)>>>1}else{j=c[b+4>>2]|0}f=j>>>0>d>>>0?j:d;if(f>>>0<2){k=1}else{k=(f+4&-4)+ -1|0}if((k|0)==(h|0)){i=e;return}do{if((k|0)==1){l=b+4|0;m=0;n=c[b+8>>2]|0;o=1}else{f=(k<<2)+4|0;if(k>>>0>h>>>0){p=$_a(f)|0}else{p=$_a(f)|0}f=p;if((g&1)==0){l=f;m=1;n=b+4|0;o=0;break}else{l=f;m=1;n=c[b+8>>2]|0;o=1;break}}}while(0);if((g&1)==0){q=(g&255)>>>1}else{q=c[b+4>>2]|0}w_a(l,n,q+1|0)|0;if(o){b$a(n)}if(m){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=l;i=e;return}else{a[b]=j<<1;i=e;return}}function wRa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+ -1|0;j=c[b+4>>2]|0}else{h=1;j=(f&255)>>>1}if((j|0)==(h|0)){yRa(b,h,1,h,h,0,0);if((a[b]&1)==0){k=7}else{k=8}}else{if(g){k=8}else{k=7}}if((k|0)==7){a[b]=(j<<1)+2;l=b+4|0;m=j+1|0}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g}c[l+(j<<2)>>2]=d;c[l+(m<<2)>>2]=0;i=e;return}function xRa(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;if((1073741806-d|0)>>>0<e>>>0){CQa(0)}if((a[b]&1)==0){m=b+4|0}else{m=c[b+8>>2]|0}do{if(d>>>0<536870887){n=e+d|0;o=d<<1;p=n>>>0<o>>>0?o:n;if(p>>>0<2){q=2;break}q=p+4&-4}else{q=1073741807}}while(0);e=$_a(q<<2)|0;p=e;if((g|0)!=0){w_a(p,m,g)|0}if((j|0)!=0){w_a(e+(g<<2)|0,k,j)|0}k=f-h|0;if((k|0)!=(g|0)){w_a(e+(j+g<<2)|0,m+(h+g<<2)|0,k-g|0)|0}if((d|0)!=1){b$a(m)}c[b+8>>2]=p;c[b>>2]=q|1;q=k+j|0;c[b+4>>2]=q;c[e+(q<<2)>>2]=0;i=l;return}function yRa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;if((1073741807-d|0)>>>0<e>>>0){CQa(0)}if((a[b]&1)==0){l=b+4|0}else{l=c[b+8>>2]|0}do{if(d>>>0<536870887){m=e+d|0;n=d<<1;o=m>>>0<n>>>0?n:m;if(o>>>0<2){p=2;break}p=o+4&-4}else{p=1073741807}}while(0);e=$_a(p<<2)|0;o=e;if((g|0)!=0){w_a(o,l,g)|0}m=f-h|0;if((m|0)!=(g|0)){w_a(e+(j+g<<2)|0,l+(h+g<<2)|0,m-g|0)|0}if((d|0)==1){q=b;r=q+8|0;s=r;c[s>>2]=o;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}b$a(l);q=b;r=q+8|0;s=r;c[s>>2]=o;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}function zRa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=b;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;g=x$a(d|0)|0;h=a[e]|0;if((h&1)==0){j=(h&255)>>>1}else{j=c[e+4>>2]|0}h=j+g|0;if(h>>>0>4294967279){CQa(0)}if(h>>>0<11){a[b]=g<<1;k=b+1|0}else{l=h+16&-16;h=$_a(l)|0;c[b+8>>2]=h;c[b>>2]=l|1;c[b+4>>2]=g;k=h}z$a(k|0,d|0,g|0)|0;a[k+g|0]=0;if((a[e]&1)==0){m=e+1|0;n=hRa(b,m,j)|0;i=f;return}else{m=c[e+8>>2]|0;n=hRa(b,m,j)|0;i=f;return}}function ARa(a){a=a|0;i=i;return(c[a+16>>2]&5|0)==0|0}function BRa(a){a=a|0;i=i;return(c[a+16>>2]&5|0)!=0|0}function CRa(a,b){a=a|0;b=b|0;var c=0;c=i;DRa(a,b);i=c;return}function DRa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=(c[b+24>>2]|0)==0;if(h){c[b+16>>2]=d|1}else{c[b+16>>2]=d}if(((h&1|d)&c[b+20>>2]|0)==0){i=e;return}e=Hc(16)|0;do{if((a[278064]|0)==0){if((_a(278064)|0)==0){break}c[69514]=278760;de(67,278056,q|0)|0;Wb(278064)}}while(0);b=e;d=g;c[d>>2]=1;c[d+4>>2]=278056;d=f;h=g;c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];yQa(b,f,278112);c[e>>2]=278080;Zd(e|0,278160,63)}function ERa(a,b){a=a|0;b=b|0;var d=0;d=i;DRa(a,c[a+16>>2]|b);i=d;return}function FRa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;c[a>>2]=278104;d=c[a+40>>2]|0;e=a+32|0;f=a+36|0;if((d|0)!=0){g=d;do{g=g+ -1|0;Ke[c[(c[e>>2]|0)+(g<<2)>>2]&15](0,a,c[(c[f>>2]|0)+(g<<2)>>2]|0);}while((g|0)!=0)}yXa(a+28|0);W_a(c[e>>2]|0);W_a(c[f>>2]|0);W_a(c[a+48>>2]|0);W_a(c[a+60>>2]|0);i=b;return}function GRa(a){a=a|0;var b=0;b=i;FRa(a);b$a(a);i=b;return}function HRa(a){a=a|0;var b=0;b=i;FRa(a);i=b;return}function IRa(a){a=a|0;var b=0;b=i;FRa(a);i=b;return}function JRa(a){a=a|0;i=i;return c[a+24>>2]|0}function KRa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=b;e=a+76|0;f=c[e>>2]|0;if(!((f|0)==-1)){g=f&255;i=b;return g|0}xXa(d,a+28|0);a=AXa(d,280448)|0;f=De[c[(c[a>>2]|0)+28>>2]&63](a,32)|0;yXa(d);c[e>>2]=f<<24>>24;g=f;i=b;return g|0}function LRa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=d;xXa(e,a+28|0);a=AXa(e,280448)|0;f=De[c[(c[a>>2]|0)+28>>2]&63](a,b)|0;yXa(e);i=d;return f|0}function MRa(a,b){a=a|0;b=b|0;var c=0;c=i;xXa(a,b+28|0);i=c;return}function NRa(a){a=a|0;c[a>>2]=277704;i=i;return}function ORa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;c[a+24>>2]=b;c[a+16>>2]=(b|0)==0;c[a+20>>2]=0;c[a+4>>2]=4098;c[a+12>>2]=0;c[a+8>>2]=6;b=a+28|0;e=a+32|0;a=e+40|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(a|0));wXa(b);i=d;return}function PRa(a){a=a|0;var b=0;b=i;c[a>>2]=277720;yXa(a+4|0);b$a(a);i=b;return}function QRa(a){a=a|0;var b=0;b=i;c[a>>2]=277720;yXa(a+4|0);i=b;return}function RRa(a){a=a|0;var b=0;b=i;c[a>>2]=277720;yXa(a+4|0);i=b;return}function SRa(a,b){a=a|0;b=b|0;var c=0;c=i;xXa(a,b+4|0);i=c;return}function TRa(a){a=a|0;var b=0,e=0,f=0,g=0;b=i;e=a+12|0;f=c[e>>2]|0;if((f|0)==(c[a+16>>2]|0)){g=oe[c[(c[a>>2]|0)+40>>2]&127](a)|0;i=b;return g|0}else{c[e>>2]=f+1;g=d[f]|0;i=b;return g|0}return 0}function URa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b+24|0;g=c[f>>2]|0;if((g|0)==(c[b+28>>2]|0)){h=De[c[(c[b>>2]|0)+52>>2]&63](b,d&255)|0;i=e;return h|0}else{c[f>>2]=g+1;a[g]=d;h=d&255;i=e;return h|0}return 0}function VRa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=re[c[(c[a>>2]|0)+48>>2]&63](a,b,d)|0;i=e;return f|0}function WRa(a){a=a|0;var b=0,d=0;b=i;c[a>>2]=277720;wXa(a+4|0);d=a+8|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;i=b;return}function XRa(a){a=a|0;i=i;return c[a+8>>2]|0}function YRa(a){a=a|0;i=i;return c[a+12>>2]|0}function ZRa(a){a=a|0;i=i;return c[a+16>>2]|0}function _Ra(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;c[d>>2]=(c[d>>2]|0)+b;i=i;return}function $Ra(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a+8>>2]=b;c[a+12>>2]=d;c[a+16>>2]=e;i=i;return}function aSa(a){a=a|0;i=i;return c[a+20>>2]|0}function bSa(a){a=a|0;i=i;return c[a+24>>2]|0}function cSa(a){a=a|0;i=i;return c[a+28>>2]|0}function dSa(a,b){a=a|0;b=b|0;var d=0;d=a+24|0;c[d>>2]=(c[d>>2]|0)+b;i=i;return}function eSa(a,b,d){a=a|0;b=b|0;d=d|0;c[a+24>>2]=b;c[a+20>>2]=b;c[a+28>>2]=d;i=i;return}function fSa(a,b){a=a|0;b=b|0;i=i;return}function gSa(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return a|0}function hSa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;i=i;return}function iSa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;i=i;return}function jSa(a){a=a|0;i=i;return 0}function kSa(a){a=a|0;i=i;return 0}function lSa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;if((e|0)<=0){g=0;i=f;return g|0}h=b+12|0;j=b+16|0;k=d;d=0;while(1){l=c[h>>2]|0;if(l>>>0<(c[j>>2]|0)>>>0){c[h>>2]=l+1;m=a[l]|0}else{l=oe[c[(c[b>>2]|0)+40>>2]&127](b)|0;if((l|0)==-1){g=d;n=8;break}m=l&255}a[k]=m;l=d+1|0;if((l|0)<(e|0)){k=k+1|0;d=l}else{g=l;n=8;break}}if((n|0)==8){i=f;return g|0}return 0}function mSa(a){a=a|0;i=i;return-1}function nSa(a){a=a|0;var b=0,e=0,f=0;b=i;if((oe[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){e=-1;i=b;return e|0}f=a+12|0;a=c[f>>2]|0;c[f>>2]=a+1;e=d[a]|0;i=b;return e|0}function oSa(a,b){a=a|0;b=b|0;i=i;return-1}function pSa(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((f|0)<=0){h=0;i=g;return h|0}j=b+24|0;k=b+28|0;l=e;e=0;while(1){m=c[j>>2]|0;if(m>>>0<(c[k>>2]|0)>>>0){n=a[l]|0;c[j>>2]=m+1;a[m]=n}else{if((De[c[(c[b>>2]|0)+52>>2]&63](b,d[l]|0)|0)==-1){h=e;o=7;break}}n=e+1|0;if((n|0)<(f|0)){l=l+1|0;e=n}else{h=n;o=7;break}}if((o|0)==7){i=g;return h|0}return 0}function qSa(a,b){a=a|0;b=b|0;i=i;return-1}function rSa(a){a=a|0;var b=0;b=i;c[a>>2]=277784;yXa(a+4|0);b$a(a);i=b;return}function sSa(a){a=a|0;var b=0;b=i;c[a>>2]=277784;yXa(a+4|0);i=b;return}function tSa(a,b){a=a|0;b=b|0;i=i;return}function uSa(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return a|0}function vSa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;i=i;return}function wSa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;i=i;return}function xSa(a){a=a|0;i=i;return 0}function ySa(a){a=a|0;i=i;return 0}function zSa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+12|0;h=a+16|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){c[g>>2]=k+4;l=c[k>>2]|0}else{k=oe[c[(c[a>>2]|0)+40>>2]&127](a)|0;if((k|0)==-1){f=b;m=8;break}else{l=k}}c[j>>2]=l;k=b+1|0;if((k|0)>=(d|0)){f=k;m=8;break}j=j+4|0;b=k}if((m|0)==8){i=e;return f|0}return 0}function ASa(a){a=a|0;i=i;return-1}function BSa(a){a=a|0;var b=0,d=0,e=0;b=i;if((oe[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){d=-1;i=b;return d|0}e=a+12|0;a=c[e>>2]|0;c[e>>2]=a+4;d=c[a>>2]|0;i=b;return d|0}function CSa(a,b){a=a|0;b=b|0;i=i;return-1}function DSa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+24|0;h=a+28|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){l=c[j>>2]|0;c[g>>2]=k+4;c[k>>2]=l}else{if((De[c[(c[a>>2]|0)+52>>2]&63](a,c[j>>2]|0)|0)==-1){f=b;m=8;break}}l=b+1|0;if((l|0)>=(d|0)){f=l;m=8;break}j=j+4|0;b=l}if((m|0)==8){i=e;return f|0}return 0}function ESa(a,b){a=a|0;b=b|0;i=i;return-1}function FSa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b>>2]|0;c[a>>2]=f;c[a+(c[f+ -12>>2]|0)>>2]=c[b+4>>2];c[a+4>>2]=0;b=c[(c[a>>2]|0)+ -12>>2]|0;c[a+(b+24)>>2]=d;c[a+(b+16)>>2]=(d|0)==0;c[a+(b+20)>>2]=0;c[a+(b+4)>>2]=4098;c[a+(b+12)>>2]=0;c[a+(b+8)>>2]=6;d=a+(b+28)|0;f=a+(b+32)+0|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));wXa(d);c[a+(b+72)>>2]=0;c[a+(b+76)>>2]=-1;i=e;return}function GSa(a){a=a|0;var b=0;b=i;FRa(a+8|0);b$a(a);i=b;return}function HSa(a){a=a|0;var b=0;b=i;FRa(a+8|0);i=b;return}function ISa(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;FRa(a+(d+8)|0);b$a(a+d|0);i=b;return}function JSa(a){a=a|0;var b=0;b=i;FRa(a+((c[(c[a>>2]|0)+ -12>>2]|0)+8)|0);i=b;return}function KSa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;LSa(a,b,c);i=d;return}function LSa(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+8|0;h=g;j=d;a[j]=0;d=c[(c[e>>2]|0)+ -12>>2]|0;k=c[e+(d+16)>>2]|0;if((k|0)!=0){DRa(e+d|0,k|4);i=g;return}k=c[e+(d+72)>>2]|0;if((k|0)!=0){MSa(k)|0}a:do{if(!f){k=c[(c[e>>2]|0)+ -12>>2]|0;if((c[e+(k+4)>>2]&4096|0)==0){break}xXa(h,e+(k+28)|0);k=AXa(h,280448)|0;yXa(h);d=k+8|0;k=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;while(1){if((k|0)==0){break}if((c[k+12>>2]|0)==(c[k+16>>2]|0)){l=(oe[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1;m=l?0:k;if((m|0)==0){break}else{n=m}}else{n=k}m=n+12|0;l=c[m>>2]|0;o=n+16|0;if((l|0)==(c[o>>2]|0)){p=(oe[c[(c[n>>2]|0)+36>>2]&127](n)|0)&255}else{p=a[l]|0}if(!(p<<24>>24>-1)){q=18;break}if((b[(c[d>>2]|0)+(p<<24>>24<<1)>>1]&8192)==0){q=18;break}l=c[m>>2]|0;if((l|0)==(c[o>>2]|0)){oe[c[(c[n>>2]|0)+40>>2]&127](n)|0;k=n;continue}else{c[m>>2]=l+1;k=n;continue}}do{if((q|0)==18){if((n|0)==0){break}if((c[n+12>>2]|0)!=(c[n+16>>2]|0)){break a}if(!((oe[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1|(n|0)==0)){break a}}}while(0);k=c[(c[e>>2]|0)+ -12>>2]|0;DRa(e+k|0,c[e+(k+16)>>2]|6)}}while(0);a[j]=(c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+16)>>2]|0)==0|0;i=g;return}function MSa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+8|0;e=d;f=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(f+24)>>2]|0)==0){i=d;return b|0}g=e;a[g]=0;c[e+4>>2]=b;do{if((c[b+(f+16)>>2]|0)==0){h=c[b+(f+72)>>2]|0;if((h|0)==0){j=f}else{MSa(h)|0;j=c[(c[b>>2]|0)+ -12>>2]|0}a[g]=1;h=c[b+(j+24)>>2]|0;if(!((oe[c[(c[h>>2]|0)+24>>2]&127](h)|0)==-1)){break}h=c[(c[b>>2]|0)+ -12>>2]|0;DRa(b+h|0,c[b+(h+16)>>2]|1)}}while(0);$Sa(e);i=d;return b|0}function NSa(b){b=b|0;i=i;return(a[b]|0)!=0|0}function OSa(a){a=a|0;var b=0;b=a+16|0;c[b>>2]=c[b>>2]|1;if((c[a+20>>2]&1|0)==0){i=i;return}else{Ib()}}function PSa(a){a=a|0;var b=0;b=i;FRa(a+8|0);b$a(a);i=b;return}function QSa(a){a=a|0;var b=0;b=i;FRa(a+8|0);i=b;return}function RSa(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;FRa(a+(d+8)|0);b$a(a+d|0);i=b;return}function SSa(a){a=a|0;var b=0;b=i;FRa(a+((c[(c[a>>2]|0)+ -12>>2]|0)+8)|0);i=b;return}function TSa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+8|0;e=d;f=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(f+24)>>2]|0)==0){i=d;return b|0}g=e;a[g]=0;c[e+4>>2]=b;do{if((c[b+(f+16)>>2]|0)==0){h=c[b+(f+72)>>2]|0;if((h|0)==0){j=f}else{TSa(h)|0;j=c[(c[b>>2]|0)+ -12>>2]|0}a[g]=1;h=c[b+(j+24)>>2]|0;if(!((oe[c[(c[h>>2]|0)+24>>2]&127](h)|0)==-1)){break}h=c[(c[b>>2]|0)+ -12>>2]|0;DRa(b+h|0,c[b+(h+16)>>2]|1)}}while(0);lTa(e);i=d;return b|0}function USa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b>>2]|0;c[a>>2]=f;c[a+(c[f+ -12>>2]|0)>>2]=c[b+4>>2];b=c[(c[a>>2]|0)+ -12>>2]|0;c[a+(b+24)>>2]=d;c[a+(b+16)>>2]=(d|0)==0;c[a+(b+20)>>2]=0;c[a+(b+4)>>2]=4098;c[a+(b+12)>>2]=0;c[a+(b+8)>>2]=6;d=a+(b+28)|0;f=a+(b+32)+0|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));wXa(d);c[a+(b+72)>>2]=0;c[a+(b+76)>>2]=-1;i=e;return}function VSa(a){a=a|0;var b=0;b=i;FRa(a+4|0);b$a(a);i=b;return}function WSa(a){a=a|0;var b=0;b=i;FRa(a+4|0);i=b;return}function XSa(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;FRa(a+(d+4)|0);b$a(a+d|0);i=b;return}function YSa(a){a=a|0;var b=0;b=i;FRa(a+((c[(c[a>>2]|0)+ -12>>2]|0)+4)|0);i=b;return}function ZSa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=b;a[f]=0;c[b+4>>2]=d;b=c[(c[d>>2]|0)+ -12>>2]|0;if((c[d+(b+16)>>2]|0)!=0){i=e;return}g=c[d+(b+72)>>2]|0;if((g|0)!=0){MSa(g)|0}a[f]=1;i=e;return}function _Sa(a){a=a|0;var b=0;b=i;$Sa(a);i=b;return}function $Sa(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[d>>2]|0;e=c[(c[a>>2]|0)+ -12>>2]|0;if((c[a+(e+24)>>2]|0)==0){i=b;return}if((c[a+(e+16)>>2]|0)!=0){i=b;return}if((c[a+(e+4)>>2]&8192|0)==0){i=b;return}if(eb()|0){i=b;return}e=c[d>>2]|0;a=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(!((oe[c[(c[a>>2]|0)+24>>2]&127](a)|0)==-1)){i=b;return}a=c[d>>2]|0;d=c[(c[a>>2]|0)+ -12>>2]|0;DRa(a+d|0,c[a+(d+16)>>2]|1);i=b;return}function aTa(b){b=b|0;i=i;return(a[b]|0)!=0|0}function bTa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=oe[b&127](a)|0;i=c;return d|0}function cTa(b,d){b=b|0;d=+d;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+48|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;m=j;a[m]=0;c[j+4>>2]=b;n=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(n+16)>>2]|0)!=0){$Sa(j);i=e;return b|0}o=c[b+(n+72)>>2]|0;if((o|0)==0){p=n}else{MSa(o)|0;p=c[(c[b>>2]|0)+ -12>>2]|0}a[m]=1;xXa(k,b+(p+28)|0);p=AXa(k,279168)|0;m=p;yXa(k);k=c[(c[b>>2]|0)+ -12>>2]|0;o=c[b+(k+24)>>2]|0;n=b+(k+76)|0;q=c[n>>2]|0;if((q|0)==-1){xXa(h,b+(k+28)|0);r=AXa(h,280448)|0;s=De[c[(c[r>>2]|0)+28>>2]&63](r,32)|0;yXa(h);c[n>>2]=s<<24>>24;t=s}else{t=q&255}q=b+k|0;k=c[(c[p>>2]|0)+32>>2]|0;c[g>>2]=o;o=f;p=g;c[o+0>>2]=c[p+0>>2];ue[k&7](l,m,f,q,t,d);if((c[l>>2]|0)!=0){$Sa(j);i=e;return b|0}l=c[(c[b>>2]|0)+ -12>>2]|0;DRa(b+l|0,c[b+(l+16)>>2]|5);$Sa(j);i=e;return b|0}function dTa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+8|0;f=e;g=f;a[g]=0;c[f+4>>2]=b;h=c[b>>2]|0;j=c[h+ -12>>2]|0;if((c[b+(j+16)>>2]|0)!=0){$Sa(f);i=e;return b|0}k=c[b+(j+72)>>2]|0;if((k|0)==0){l=h;m=j}else{MSa(k)|0;k=c[b>>2]|0;l=k;m=c[k+ -12>>2]|0}a[g]=1;g=c[b+(m+24)>>2]|0;m=g;do{if((g|0)==0){n=l}else{k=g+24|0;j=c[k>>2]|0;if((j|0)!=(c[g+28>>2]|0)){c[k>>2]=j+1;a[j]=d;$Sa(f);i=e;return b|0}if((De[c[(c[g>>2]|0)+52>>2]&63](m,d&255)|0)==-1){n=c[b>>2]|0;break}else{$Sa(f);i=e;return b|0}}}while(0);d=c[n+ -12>>2]|0;DRa(b+d|0,c[b+(d+16)>>2]|1);$Sa(f);i=e;return b|0}function eTa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=g;a[h]=0;c[g+4>>2]=b;j=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(j+16)>>2]|0)!=0){$Sa(g);i=f;return b|0}k=c[b+(j+72)>>2]|0;if((k|0)!=0){MSa(k)|0}a[h]=1;if((e|0)==0){$Sa(g);i=f;return b|0}h=c[b+((c[(c[b>>2]|0)+ -12>>2]|0)+24)>>2]|0;if((re[c[(c[h>>2]|0)+48>>2]&63](h,d,e)|0)==(e|0)){$Sa(g);i=f;return b|0}e=c[(c[b>>2]|0)+ -12>>2]|0;DRa(b+e|0,c[b+(e+16)>>2]|1);$Sa(g);i=f;return b|0}function fTa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(e+16)>>2]&5|0)==0){f=c[b+(e+24)>>2]|0;xe[c[(c[f>>2]|0)+16>>2]&31](a,f,0,0,1,16);i=d;return}else{f=a;c[f>>2]=0;c[f+4>>2]=0;f=a+8|0;c[f>>2]=-1;c[f+4>>2]=-1;i=d;return}}function gTa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+56|0;f=e;g=e+16|0;h=e+32|0;j=e+40|0;k=h;a[k]=0;c[h+4>>2]=b;l=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(l+16)>>2]|0)!=0){$Sa(h);i=e;return b|0}m=c[b+(l+72)>>2]|0;if((m|0)==0){n=l}else{MSa(m)|0;n=c[(c[b>>2]|0)+ -12>>2]|0}a[k]=1;k=c[b+(n+24)>>2]|0;n=k;m=d;d=g;l=c[(c[k>>2]|0)+20>>2]|0;c[d+0>>2]=c[m+0>>2];c[d+4>>2]=c[m+4>>2];c[d+8>>2]=c[m+8>>2];c[d+12>>2]=c[m+12>>2];m=f;d=g;c[m+0>>2]=c[d+0>>2];c[m+4>>2]=c[d+4>>2];c[m+8>>2]=c[d+8>>2];c[m+12>>2]=c[d+12>>2];Oe[l&127](j,n,f,16);f=j+8|0;if(!((c[f>>2]|0)==-1&(c[f+4>>2]|0)==-1)){$Sa(h);i=e;return b|0}f=c[(c[b>>2]|0)+ -12>>2]|0;DRa(b+f|0,c[b+(f+16)>>2]|4);$Sa(h);i=e;return b|0}function hTa(a){a=a|0;var b=0;b=i;FRa(a+4|0);b$a(a);i=b;return}function iTa(a){a=a|0;var b=0;b=i;FRa(a+4|0);i=b;return}function jTa(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;FRa(a+(d+4)|0);b$a(a+d|0);i=b;return}function kTa(a){a=a|0;var b=0;b=i;FRa(a+((c[(c[a>>2]|0)+ -12>>2]|0)+4)|0);i=b;return}function lTa(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[d>>2]|0;e=c[(c[a>>2]|0)+ -12>>2]|0;if((c[a+(e+24)>>2]|0)==0){i=b;return}if((c[a+(e+16)>>2]|0)!=0){i=b;return}if((c[a+(e+4)>>2]&8192|0)==0){i=b;return}if(eb()|0){i=b;return}e=c[d>>2]|0;a=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(!((oe[c[(c[a>>2]|0)+24>>2]&127](a)|0)==-1)){i=b;return}a=c[d>>2]|0;d=c[(c[a>>2]|0)+ -12>>2]|0;DRa(a+d|0,c[a+(d+16)>>2]|1);i=b;return}function mTa(a){a=a|0;i=i;return 278e3}function nTa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;if((c|0)==1){IQa(a,278016,35);i=d;return}else{wQa(a,b,c);i=d;return}}function oTa(a){a=a|0;i=i;return}function pTa(a){a=a|0;var b=0;b=i;AQa(a);b$a(a);i=b;return}function qTa(a){a=a|0;var b=0;b=i;AQa(a);i=b;return}function rTa(a){a=a|0;var b=0;b=i;FRa(a);b$a(a);i=b;return}function sTa(a){a=a|0;var b=0;b=i;b$a(a);i=b;return}function tTa(a){a=a|0;var b=0;b=i;b$a(a);i=b;return}function uTa(a){a=a|0;i=i;return}function vTa(a){a=a|0;i=i;return}function wTa(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;a:do{if((e|0)==(f|0)){g=c;h=6}else{j=e;k=c;while(1){if((k|0)==(d|0)){l=-1;break a}m=a[k]|0;n=a[j]|0;if(m<<24>>24<n<<24>>24){l=-1;break a}if(n<<24>>24<m<<24>>24){l=1;break a}m=k+1|0;n=j+1|0;if((n|0)==(f|0)){g=m;h=6;break}else{j=n;k=m}}}}while(0);if((h|0)==6){l=(g|0)!=(d|0)|0}i=b;return l|0}function xTa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;g=e;h=f-g|0;if(h>>>0>4294967279){CQa(b)}if(h>>>0<11){a[b]=h<<1;j=b+1|0}else{k=h+16&-16;l=$_a(k)|0;c[b+8>>2]=l;c[b>>2]=k|1;c[b+4>>2]=h;j=l}if((e|0)==(f|0)){m=j;a[m]=0;i=d;return}else{n=e;o=j}while(1){a[o]=a[n]|0;e=n+1|0;if((e|0)==(f|0)){break}else{o=o+1|0;n=e}}m=j+(f+(0-g))|0;a[m]=0;i=d;return}function yTa(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;if((c|0)==(d|0)){e=0;i=b;return e|0}else{f=0;g=c}while(1){c=(a[g]|0)+(f<<4)|0;h=c&-268435456;j=(h>>>24|h)^c;c=g+1|0;if((c|0)==(d|0)){e=j;break}else{g=c;f=j}}i=b;return e|0}function zTa(a){a=a|0;var b=0;b=i;b$a(a);i=b;return}function ATa(a){a=a|0;i=i;return}function BTa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;a=i;a:do{if((e|0)==(f|0)){g=b;h=6}else{j=e;k=b;while(1){if((k|0)==(d|0)){l=-1;break a}m=c[k>>2]|0;n=c[j>>2]|0;if((m|0)<(n|0)){l=-1;break a}if((n|0)<(m|0)){l=1;break a}m=k+4|0;n=j+4|0;if((n|0)==(f|0)){g=m;h=6;break}else{j=n;k=m}}}}while(0);if((h|0)==6){l=(g|0)!=(d|0)|0}i=a;return l|0}function CTa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;d=i;g=e;h=f-g|0;j=h>>2;if(j>>>0>1073741807){CQa(b)}if(j>>>0<2){a[b]=h>>>1;k=b+4|0}else{h=j+4&-4;l=$_a(h<<2)|0;c[b+8>>2]=l;c[b>>2]=h|1;c[b+4>>2]=j;k=l}if((e|0)==(f|0)){m=k;c[m>>2]=0;i=d;return}l=f+ -4+(0-g)|0;g=e;e=k;while(1){c[e>>2]=c[g>>2];j=g+4|0;if((j|0)==(f|0)){break}else{e=e+4|0;g=j}}m=k+((l>>>2)+1<<2)|0;c[m>>2]=0;i=d;return}function DTa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;a=i;if((b|0)==(d|0)){e=0;i=a;return e|0}else{f=0;g=b}while(1){b=(c[g>>2]|0)+(f<<4)|0;h=b&-268435456;j=(h>>>24|h)^b;b=g+4|0;if((b|0)==(d|0)){e=j;break}else{g=b;f=j}}i=a;return e|0}function ETa(a){a=a|0;var b=0;b=i;b$a(a);i=b;return}function FTa(a){a=a|0;i=i;return}function GTa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+136|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=k+40|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+88|0;v=k+96|0;w=k+104|0;x=k+128|0;if((c[g+4>>2]&1|0)==0){c[q>>2]=-1;y=c[(c[d>>2]|0)+16>>2]|0;z=e;c[s>>2]=c[z>>2];c[t>>2]=c[f>>2];A=n;B=s;c[A+0>>2]=c[B+0>>2];B=m;A=t;c[B+0>>2]=c[A+0>>2];Ae[y&63](r,d,n,m,g,h,q);m=c[r>>2]|0;c[z>>2]=m;z=c[q>>2]|0;if((z|0)==0){a[j]=0}else if((z|0)==1){a[j]=1}else{a[j]=1;c[h>>2]=4}c[b>>2]=m;i=k;return}MRa(u,g);m=u;u=c[m>>2]|0;if(!((c[70112]|0)==-1)){c[p>>2]=280448;c[p+4>>2]=1276;c[p+8>>2]=0;BQa(280448,p,1277)}p=(c[280452>>2]|0)+ -1|0;z=c[u+8>>2]|0;if(!((c[u+12>>2]|0)-z>>2>>>0>p>>>0)){C=Hc(4)|0;D=C;A_a(D);E=296008;F=128;Zd(C|0,E|0,F|0)}u=c[z+(p<<2)>>2]|0;if((u|0)==0){C=Hc(4)|0;D=C;A_a(D);E=296008;F=128;Zd(C|0,E|0,F|0)}F=u;gQa(c[m>>2]|0)|0;MRa(v,g);g=v;v=c[g>>2]|0;if(!((c[70148]|0)==-1)){c[o>>2]=280592;c[o+4>>2]=1276;c[o+8>>2]=0;BQa(280592,o,1277)}o=(c[280596>>2]|0)+ -1|0;m=c[v+8>>2]|0;if(!((c[v+12>>2]|0)-m>>2>>>0>o>>>0)){G=Hc(4)|0;H=G;A_a(H);I=296008;J=128;Zd(G|0,I|0,J|0)}v=c[m+(o<<2)>>2]|0;if((v|0)==0){G=Hc(4)|0;H=G;A_a(H);I=296008;J=128;Zd(G|0,I|0,J|0)}J=v;gQa(c[g>>2]|0)|0;g=w;me[c[(c[v>>2]|0)+24>>2]&127](g,J);me[c[(c[v>>2]|0)+28>>2]&127](w+12|0,J);c[x>>2]=c[f>>2];f=w+24|0;J=l;v=x;c[J+0>>2]=c[v+0>>2];v=HTa(e,l,g,f,F,h,1)|0;a[j]=(v|0)==(g|0)|0;c[b>>2]=c[e>>2];QQa(w+12|0);QQa(w);i=k;return}function HTa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;k=i;i=i+104|0;l=(f-e|0)/12|0;m=k;do{if(l>>>0>100){n=V_a(l)|0;if((n|0)!=0){o=n;p=n;break}g$a()}else{o=0;p=m}}while(0);m=(e|0)==(f|0);if(m){q=0;r=l}else{n=e;s=0;t=l;l=p;while(1){u=a[n]|0;if((u&1)==0){v=(u&255)>>>1}else{v=c[n+4>>2]|0}if((v|0)==0){a[l]=2;w=s+1|0;x=t+ -1|0}else{a[l]=1;w=s;x=t}u=n+12|0;if((u|0)==(f|0)){q=w;r=x;break}else{n=u;s=w;t=x;l=l+1|0}}}l=b;b=d;d=0;x=q;q=r;a:while(1){r=c[l>>2]|0;do{if((r|0)==0){y=0}else{if((c[r+12>>2]|0)!=(c[r+16>>2]|0)){y=r;break}if((oe[c[(c[r>>2]|0)+36>>2]&127](r)|0)==-1){c[l>>2]=0;y=0;break}else{y=c[l>>2]|0;break}}}while(0);r=(y|0)==0;t=c[b>>2]|0;do{if((t|0)==0){z=0}else{if((c[t+12>>2]|0)!=(c[t+16>>2]|0)){z=t;break}if(!((oe[c[(c[t>>2]|0)+36>>2]&127](t)|0)==-1)){z=t;break}c[b>>2]=0;z=0}}while(0);A=(z|0)==0;B=c[l>>2]|0;if(!((r^A)&(q|0)!=0)){break}t=c[B+12>>2]|0;if((t|0)==(c[B+16>>2]|0)){C=(oe[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{C=a[t]|0}if(j){D=C}else{D=De[c[(c[g>>2]|0)+12>>2]&63](g,C)|0}t=d+1|0;if(m){d=t;q=q;x=x;continue}b:do{if(j){w=0;s=e;n=x;v=q;u=p;while(1){do{if((a[u]|0)==1){E=a[s]|0;F=(E&1)==0;if(F){G=s+1|0}else{G=c[s+8>>2]|0}if(!(D<<24>>24==(a[G+d|0]|0))){a[u]=0;H=w;I=n;J=v+ -1|0;break}if(F){K=(E&255)>>>1}else{K=c[s+4>>2]|0}if((K|0)!=(t|0)){H=1;I=n;J=v;break}a[u]=2;H=1;I=n+1|0;J=v+ -1|0}else{H=w;I=n;J=v}}while(0);E=s+12|0;if((E|0)==(f|0)){L=H;M=I;N=J;break b}w=H;s=E;n=I;v=J;u=u+1|0}}else{u=0;v=e;n=x;s=q;w=p;while(1){do{if((a[w]|0)==1){if((a[v]&1)==0){O=v+1|0}else{O=c[v+8>>2]|0}if(!(D<<24>>24==(De[c[(c[g>>2]|0)+12>>2]&63](g,a[O+d|0]|0)|0)<<24>>24)){a[w]=0;P=u;Q=n;R=s+ -1|0;break}E=a[v]|0;if((E&1)==0){S=(E&255)>>>1}else{S=c[v+4>>2]|0}if((S|0)!=(t|0)){P=1;Q=n;R=s;break}a[w]=2;P=1;Q=n+1|0;R=s+ -1|0}else{P=u;Q=n;R=s}}while(0);E=v+12|0;if((E|0)==(f|0)){L=P;M=Q;N=R;break b}u=P;v=E;n=Q;s=R;w=w+1|0}}}while(0);if(!L){d=t;x=M;q=N;continue}r=c[l>>2]|0;w=r+12|0;s=c[w>>2]|0;if((s|0)==(c[r+16>>2]|0)){oe[c[(c[r>>2]|0)+40>>2]&127](r)|0}else{c[w>>2]=s+1}if((N+M|0)>>>0<2){d=t;x=M;q=N;continue}else{T=e;U=M;V=p}while(1){do{if((a[V]|0)==2){s=a[T]|0;if((s&1)==0){W=(s&255)>>>1}else{W=c[T+4>>2]|0}if((W|0)==(t|0)){X=U;break}a[V]=0;X=U+ -1|0}else{X=U}}while(0);s=T+12|0;if((s|0)==(f|0)){d=t;x=X;q=N;continue a}else{T=s;U=X;V=V+1|0}}}do{if((B|0)==0){Y=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){Y=B;break}if((oe[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[l>>2]=0;Y=0;break}else{Y=c[l>>2]|0;break}}}while(0);l=(Y|0)==0;do{if(A){Z=78}else{if((c[z+12>>2]|0)!=(c[z+16>>2]|0)){if(l){break}else{Z=80;break}}if((oe[c[(c[z>>2]|0)+36>>2]&127](z)|0)==-1){c[b>>2]=0;Z=78;break}else{if(l){break}else{Z=80;break}}}}while(0);if((Z|0)==78){if(l){Z=80}}if((Z|0)==80){c[h>>2]=c[h>>2]|2}c:do{if(m){Z=85}else{if((a[p]|0)==2){_=e;break}else{$=e;aa=p}while(1){l=$+12|0;b=aa+1|0;if((l|0)==(f|0)){Z=85;break c}if((a[b]|0)==2){_=l;break}else{aa=b;$=l}}}}while(0);if((Z|0)==85){c[h>>2]=c[h>>2]|4;_=f}if((o|0)==0){i=k;return _|0}W_a(o);i=k;return _|0}function ITa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];JTa(a,0,k,j,f,g,h);i=b;return}function JTa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==8){t=16}else if((s|0)==0){t=0}else{t=10}s=k;zUa(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZQa(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((oe[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((oe[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}ZQa(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}ZQa(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(oe[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if(($Ta(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){oe[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=vZa(F,c[o>>2]|0,h,t)|0;MWa(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((oe[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;QQa(n);QQa(m);i=d;return}if((oe[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;QQa(n);QQa(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;QQa(n);QQa(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;QQa(n);QQa(m);i=d;return}function KTa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];LTa(a,0,k,j,f,g,h);i=b;return}function LTa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==64){t=8}else if((s|0)==8){t=16}else{t=10}s=k;zUa(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZQa(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((oe[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((oe[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;K=(B&255)>>>1}else{B=c[x>>2]|0;I=B;K=B}ZQa(n,K<<1,0);if((a[n]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}ZQa(n,L,0);if((a[n]&1)==0){M=u}else{M=c[v>>2]|0}c[o>>2]=M+I;N=M}else{N=z}B=A+12|0;G=c[B>>2]|0;O=A+16|0;if((G|0)==(c[O>>2]|0)){P=(oe[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{P=a[G]|0}if(($Ta(P,t,N,o,r,y,m,g,q,s)|0)!=0){E=D;F=N;break}G=c[B>>2]|0;if((G|0)==(c[O>>2]|0)){oe[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=N;continue}else{c[B>>2]=G+1;l=A;z=N;continue}}N=a[m]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[m+4>>2]|0}do{if((Q|0)!=0){N=c[q>>2]|0;if((N-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=N+4;c[N>>2]=z}}while(0);r=uZa(F,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;MWa(m,g,c[q>>2]|0,h);do{if((A|0)==0){R=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){R=A;break}if(!((oe[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){R=A;break}c[k>>2]=0;R=0}}while(0);k=(R|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}S=b;T=S;c[T>>2]=R;QQa(n);QQa(m);i=d;return}if((oe[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}S=b;T=S;c[T>>2]=R;QQa(n);QQa(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}S=b;T=S;c[T>>2]=R;QQa(n);QQa(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;S=b;T=S;c[T>>2]=R;QQa(n);QQa(m);i=d;return}function MTa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];NTa(a,0,k,j,f,g,h);i=b;return}function NTa(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+256|0;l=e;m=e+32|0;n=e+40|0;o=e+56|0;p=e+72|0;q=e+80|0;r=e+240|0;s=e+248|0;t=c[h+4>>2]&74;if((t|0)==0){u=0}else if((t|0)==8){u=16}else if((t|0)==64){u=8}else{u=10}t=l;zUa(n,h,t,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;ZQa(o,10,0);if((a[o]&1)==0){h=o+1|0;v=h;w=o+8|0;x=h}else{h=o+8|0;v=o+1|0;w=h;x=c[h>>2]|0}c[p>>2]=x;h=q;c[r>>2]=h;c[s>>2]=0;l=f;f=g;g=o;y=o+4|0;z=a[m]|0;m=c[l>>2]|0;A=x;a:while(1){do{if((m|0)==0){B=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){B=m;break}if(!((oe[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){B=m;break}c[l>>2]=0;B=0}}while(0);x=(B|0)==0;C=c[f>>2]|0;do{if((C|0)==0){D=18}else{if((c[C+12>>2]|0)!=(c[C+16>>2]|0)){if(x){E=C;break}else{F=C;G=A;break a}}if((oe[c[(c[C>>2]|0)+36>>2]&127](C)|0)==-1){c[f>>2]=0;D=18;break}else{if(x){E=C;break}else{F=C;G=A;break a}}}}while(0);if((D|0)==18){D=0;if(x){F=0;G=A;break}else{E=0}}C=a[o]|0;H=(C&1)==0;if(H){I=(C&255)>>>1}else{I=c[y>>2]|0}if(((c[p>>2]|0)-A|0)==(I|0)){if(H){J=(C&255)>>>1;K=(C&255)>>>1}else{C=c[y>>2]|0;J=C;K=C}ZQa(o,K<<1,0);if((a[o]&1)==0){L=10}else{L=(c[g>>2]&-2)+ -1|0}ZQa(o,L,0);if((a[o]&1)==0){M=v}else{M=c[w>>2]|0}c[p>>2]=M+J;N=M}else{N=A}C=B+12|0;H=c[C>>2]|0;O=B+16|0;if((H|0)==(c[O>>2]|0)){P=(oe[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{P=a[H]|0}if(($Ta(P,u,N,p,s,z,n,h,r,t)|0)!=0){F=E;G=N;break}H=c[C>>2]|0;if((H|0)==(c[O>>2]|0)){oe[c[(c[B>>2]|0)+40>>2]&127](B)|0;m=B;A=N;continue}else{c[C>>2]=H+1;m=B;A=N;continue}}N=a[n]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[n+4>>2]|0}do{if((Q|0)!=0){N=c[r>>2]|0;if((N-q|0)>=160){break}A=c[s>>2]|0;c[r>>2]=N+4;c[N>>2]=A}}while(0);b[k>>1]=tZa(G,c[p>>2]|0,j,u)|0;MWa(n,h,c[r>>2]|0,j);do{if((B|0)==0){R=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){R=B;break}if(!((oe[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1)){R=B;break}c[l>>2]=0;R=0}}while(0);l=(R|0)==0;do{if((F|0)==0){D=54}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){if(!l){break}S=d;T=S;c[T>>2]=R;QQa(o);QQa(n);i=e;return}if((oe[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1){c[f>>2]=0;D=54;break}if(!(l^(F|0)==0)){break}S=d;T=S;c[T>>2]=R;QQa(o);QQa(n);i=e;return}}while(0);do{if((D|0)==54){if(l){break}S=d;T=S;c[T>>2]=R;QQa(o);QQa(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;S=d;T=S;c[T>>2]=R;QQa(o);QQa(n);i=e;return}function OTa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];PTa(a,0,k,j,f,g,h);i=b;return}function PTa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==0){t=0}else if((s|0)==64){t=8}else{t=10}s=k;zUa(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZQa(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((oe[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((oe[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}ZQa(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}ZQa(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(oe[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if(($Ta(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){oe[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=sZa(F,c[o>>2]|0,h,t)|0;MWa(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((oe[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;QQa(n);QQa(m);i=d;return}if((oe[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;QQa(n);QQa(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;QQa(n);QQa(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;QQa(n);QQa(m);i=d;return}function QTa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];RTa(a,0,k,j,f,g,h);i=b;return}function RTa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;zUa(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZQa(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((oe[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((oe[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}ZQa(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}ZQa(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(oe[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if(($Ta(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){oe[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=rZa(F,c[o>>2]|0,h,t)|0;MWa(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((oe[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;QQa(n);QQa(m);i=d;return}if((oe[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;QQa(n);QQa(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;QQa(n);QQa(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;QQa(n);QQa(m);i=d;return}function STa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];TTa(a,0,k,j,f,g,h);i=b;return}function TTa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==0){t=0}else if((s|0)==64){t=8}else{t=10}s=k;zUa(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZQa(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((oe[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((oe[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;K=(B&255)>>>1}else{B=c[x>>2]|0;I=B;K=B}ZQa(n,K<<1,0);if((a[n]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}ZQa(n,L,0);if((a[n]&1)==0){M=u}else{M=c[v>>2]|0}c[o>>2]=M+I;N=M}else{N=z}B=A+12|0;G=c[B>>2]|0;O=A+16|0;if((G|0)==(c[O>>2]|0)){P=(oe[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{P=a[G]|0}if(($Ta(P,t,N,o,r,y,m,g,q,s)|0)!=0){E=D;F=N;break}G=c[B>>2]|0;if((G|0)==(c[O>>2]|0)){oe[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=N;continue}else{c[B>>2]=G+1;l=A;z=N;continue}}N=a[m]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[m+4>>2]|0}do{if((Q|0)!=0){N=c[q>>2]|0;if((N-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=N+4;c[N>>2]=z}}while(0);r=qZa(F,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;MWa(m,g,c[q>>2]|0,h);do{if((A|0)==0){R=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){R=A;break}if(!((oe[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){R=A;break}c[k>>2]=0;R=0}}while(0);k=(R|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}S=b;T=S;c[T>>2]=R;QQa(n);QQa(m);i=d;return}if((oe[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}S=b;T=S;c[T>>2]=R;QQa(n);QQa(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}S=b;T=S;c[T>>2]=R;QQa(n);QQa(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;S=b;T=S;c[T>>2]=R;QQa(n);QQa(m);i=d;return}function UTa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];VTa(a,0,k,j,f,g,h);i=b;return}function VTa(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;AUa(n,h,v,l,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;ZQa(o,10,0);if((a[o]&1)==0){h=o+1|0;w=h;x=o+8|0;y=h}else{h=o+8|0;w=o+1|0;x=h;y=c[h>>2]|0}c[p>>2]=y;h=q;c[r>>2]=h;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((oe[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((oe[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}ZQa(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}ZQa(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(oe[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((BUa(R,t,u,P,p,B,l,n,h,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){oe[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);g[k>>2]=+pZa(I,c[p>>2]|0,j);MWa(n,h,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((oe[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;QQa(o);QQa(n);i=d;return}if((oe[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;QQa(o);QQa(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;QQa(o);QQa(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;QQa(o);QQa(n);i=d;return}function WTa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];XTa(a,0,k,j,f,g,h);i=b;return}function XTa(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;AUa(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZQa(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((oe[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((oe[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}ZQa(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}ZQa(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(oe[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((BUa(R,t,u,P,p,B,l,n,g,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){oe[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);h[k>>3]=+oZa(I,c[p>>2]|0,j);MWa(n,g,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((oe[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;QQa(o);QQa(n);i=d;return}if((oe[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;QQa(o);QQa(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;QQa(o);QQa(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;QQa(o);QQa(n);i=d;return}function YTa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];ZTa(a,0,k,j,f,g,h);i=b;return}function ZTa(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;AUa(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZQa(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((oe[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((oe[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}ZQa(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}ZQa(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(oe[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((BUa(R,t,u,P,p,B,l,n,g,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){oe[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);h[k>>3]=+nZa(I,c[p>>2]|0,j);MWa(n,g,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((oe[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;QQa(o);QQa(n);i=d;return}if((oe[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;QQa(o);QQa(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;QQa(o);QQa(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;QQa(o);QQa(n);i=d;return}function _Ta(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;d=i;i=i+8|0;k=d;l=i;i=i+16|0;m=i;i=i+32|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+160|0;s=i;i=i+8|0;t=i;i=i+8|0;u=n;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;MRa(o,g);g=o;o=c[g>>2]|0;if(!((c[70112]|0)==-1)){c[l>>2]=280448;c[l+4>>2]=1276;c[l+8>>2]=0;BQa(280448,l,1277)}l=(c[280452>>2]|0)+ -1|0;u=c[o+8>>2]|0;if(!((c[o+12>>2]|0)-u>>2>>>0>l>>>0)){v=Hc(4)|0;w=v;A_a(w);x=296008;y=128;Zd(v|0,x|0,y|0)}o=c[u+(l<<2)>>2]|0;if((o|0)==0){v=Hc(4)|0;w=v;A_a(w);x=296008;y=128;Zd(v|0,x|0,y|0)}y=m;Ne[c[(c[o>>2]|0)+32>>2]&63](o,278992,279018|0,y)|0;gQa(c[g>>2]|0)|0;g=p;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZQa(p,10,0);if((a[p]&1)==0){g=p+1|0;z=g;A=p+8|0;B=g}else{g=p+8|0;z=p+1|0;A=g;B=c[g>>2]|0}c[q>>2]=B;g=r;c[s>>2]=g;c[t>>2]=0;r=e;e=f;f=p;o=p+4|0;m=c[r>>2]|0;x=B;a:while(1){do{if((m|0)==0){C=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){C=m;break}if(!((oe[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){C=m;break}c[r>>2]=0;C=0}}while(0);B=(C|0)==0;v=c[e>>2]|0;do{if((v|0)==0){D=19}else{if((c[v+12>>2]|0)!=(c[v+16>>2]|0)){if(B){break}else{E=x;break a}}if((oe[c[(c[v>>2]|0)+36>>2]&127](v)|0)==-1){c[e>>2]=0;D=19;break}else{if(B){break}else{E=x;break a}}}}while(0);if((D|0)==19){D=0;if(B){E=x;break}}v=a[p]|0;w=(v&1)==0;if(w){F=(v&255)>>>1}else{F=c[o>>2]|0}if(((c[q>>2]|0)-x|0)==(F|0)){if(w){G=(v&255)>>>1;H=(v&255)>>>1}else{v=c[o>>2]|0;G=v;H=v}ZQa(p,H<<1,0);if((a[p]&1)==0){I=10}else{I=(c[f>>2]&-2)+ -1|0}ZQa(p,I,0);if((a[p]&1)==0){J=z}else{J=c[A>>2]|0}c[q>>2]=J+G;K=J}else{K=x}v=C+12|0;w=c[v>>2]|0;l=C+16|0;if((w|0)==(c[l>>2]|0)){L=(oe[c[(c[C>>2]|0)+36>>2]&127](C)|0)&255}else{L=a[w]|0}if(($Ta(L,16,K,q,t,0,n,g,s,y)|0)!=0){E=K;break}w=c[v>>2]|0;if((w|0)==(c[l>>2]|0)){oe[c[(c[C>>2]|0)+40>>2]&127](C)|0;m=C;x=K;continue}else{c[v>>2]=w+1;m=C;x=K;continue}}a[E+3|0]=0;do{if((a[280344]|0)==0){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);K=c[70084]|0;c[k>>2]=j;if((aUa(E,K,279032,k)|0)!=1){c[h>>2]=4}k=c[r>>2]|0;do{if((k|0)==0){M=0}else{if((c[k+12>>2]|0)!=(c[k+16>>2]|0)){M=k;break}if(!((oe[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1)){M=k;break}c[r>>2]=0;M=0}}while(0);r=(M|0)==0;k=c[e>>2]|0;do{if((k|0)==0){D=54}else{if((c[k+12>>2]|0)!=(c[k+16>>2]|0)){if(!r){break}N=b;O=N;c[O>>2]=M;QQa(p);QQa(n);i=d;return}if((oe[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1){c[e>>2]=0;D=54;break}if(!(r^(k|0)==0)){break}N=b;O=N;c[O>>2]=M;QQa(p);QQa(n);i=d;return}}while(0);do{if((D|0)==54){if(r){break}N=b;O=N;c[O>>2]=M;QQa(p);QQa(n);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;N=b;O=N;c[O>>2]=M;QQa(p);QQa(n);i=d;return}function $Ta(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do{if(p){q=(a[m+24|0]|0)==b<<24>>24;if(!q){if(!((a[m+25|0]|0)==b<<24>>24)){break}}c[f>>2]=e+1;a[e]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}}while(0);q=a[j]|0;if((q&1)==0){s=(q&255)>>>1}else{s=c[j+4>>2]|0}if((s|0)!=0&b<<24>>24==h<<24>>24){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+26|0;h=m;while(1){l=h+1|0;if((a[h]|0)==b<<24>>24){t=h;break}if((l|0)==(k|0)){t=k;break}else{h=l}}h=t-m|0;if((h|0)>23){r=-1;i=n;return r|0}do{if((d|0)==16){if((h|0)<22){break}if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+ -1|0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;m=a[278992+h|0]|0;c[f>>2]=o+1;a[o]=m;r=0;i=n;return r|0}else if((d|0)==10|(d|0)==8){if((h|0)<(d|0)){break}else{r=-1}i=n;return r|0}}while(0);d=a[278992+h|0]|0;c[f>>2]=o+1;a[o]=d;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function aUa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Oc(b|0)|0;b=Ya(a|0,d|0,g|0)|0;if((e|0)==0){i=f;return b|0}Oc(e|0)|0;i=f;return b|0}function bUa(a){a=a|0;var b=0;b=i;b$a(a);i=b;return}function cUa(a){a=a|0;i=i;return}function dUa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+136|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=k+40|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+88|0;v=k+96|0;w=k+104|0;x=k+128|0;if((c[g+4>>2]&1|0)==0){c[q>>2]=-1;y=c[(c[d>>2]|0)+16>>2]|0;z=e;c[s>>2]=c[z>>2];c[t>>2]=c[f>>2];A=n;B=s;c[A+0>>2]=c[B+0>>2];B=m;A=t;c[B+0>>2]=c[A+0>>2];Ae[y&63](r,d,n,m,g,h,q);m=c[r>>2]|0;c[z>>2]=m;z=c[q>>2]|0;if((z|0)==1){a[j]=1}else if((z|0)==0){a[j]=0}else{a[j]=1;c[h>>2]=4}c[b>>2]=m;i=k;return}MRa(u,g);m=u;u=c[m>>2]|0;if(!((c[70110]|0)==-1)){c[p>>2]=280440;c[p+4>>2]=1276;c[p+8>>2]=0;BQa(280440,p,1277)}p=(c[280444>>2]|0)+ -1|0;z=c[u+8>>2]|0;if(!((c[u+12>>2]|0)-z>>2>>>0>p>>>0)){C=Hc(4)|0;D=C;A_a(D);E=296008;F=128;Zd(C|0,E|0,F|0)}u=c[z+(p<<2)>>2]|0;if((u|0)==0){C=Hc(4)|0;D=C;A_a(D);E=296008;F=128;Zd(C|0,E|0,F|0)}F=u;gQa(c[m>>2]|0)|0;MRa(v,g);g=v;v=c[g>>2]|0;if(!((c[70150]|0)==-1)){c[o>>2]=280600;c[o+4>>2]=1276;c[o+8>>2]=0;BQa(280600,o,1277)}o=(c[280604>>2]|0)+ -1|0;m=c[v+8>>2]|0;if(!((c[v+12>>2]|0)-m>>2>>>0>o>>>0)){G=Hc(4)|0;H=G;A_a(H);I=296008;J=128;Zd(G|0,I|0,J|0)}v=c[m+(o<<2)>>2]|0;if((v|0)==0){G=Hc(4)|0;H=G;A_a(H);I=296008;J=128;Zd(G|0,I|0,J|0)}J=v;gQa(c[g>>2]|0)|0;g=w;me[c[(c[v>>2]|0)+24>>2]&127](g,J);me[c[(c[v>>2]|0)+28>>2]&127](w+12|0,J);c[x>>2]=c[f>>2];f=w+24|0;J=l;v=x;c[J+0>>2]=c[v+0>>2];v=eUa(e,l,g,f,F,h,1)|0;a[j]=(v|0)==(g|0)|0;c[b>>2]=c[e>>2];sRa(w+12|0);sRa(w);i=k;return}function eUa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;k=i;i=i+104|0;l=(f-e|0)/12|0;m=k;do{if(l>>>0>100){n=V_a(l)|0;if((n|0)!=0){o=n;p=n;break}g$a()}else{o=0;p=m}}while(0);m=(e|0)==(f|0);if(m){q=0;r=l}else{n=e;s=0;t=l;l=p;while(1){u=a[n]|0;if((u&1)==0){v=(u&255)>>>1}else{v=c[n+4>>2]|0}if((v|0)==0){a[l]=2;w=s+1|0;x=t+ -1|0}else{a[l]=1;w=s;x=t}u=n+12|0;if((u|0)==(f|0)){q=w;r=x;break}else{n=u;s=w;t=x;l=l+1|0}}}l=b;b=d;d=0;x=q;q=r;a:while(1){r=c[l>>2]|0;do{if((r|0)==0){y=1}else{t=c[r+12>>2]|0;if((t|0)==(c[r+16>>2]|0)){z=oe[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{z=c[t>>2]|0}if((z|0)==-1){c[l>>2]=0;y=1;break}else{y=(c[l>>2]|0)==0;break}}}while(0);r=c[b>>2]|0;do{if((r|0)==0){A=0;B=1}else{t=c[r+12>>2]|0;if((t|0)==(c[r+16>>2]|0)){C=oe[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{C=c[t>>2]|0}if(!((C|0)==-1)){A=r;B=0;break}c[b>>2]=0;A=0;B=1}}while(0);D=c[l>>2]|0;if(!((y^B)&(q|0)!=0)){break}r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){E=oe[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{E=c[r>>2]|0}if(j){F=E}else{F=De[c[(c[g>>2]|0)+28>>2]&63](g,E)|0}r=d+1|0;if(m){d=r;q=q;x=x;continue}b:do{if(j){t=0;w=e;s=x;n=q;v=p;while(1){do{if((a[v]|0)==1){u=a[w]|0;G=(u&1)==0;if(G){H=w+4|0}else{H=c[w+8>>2]|0}if((F|0)!=(c[H+(d<<2)>>2]|0)){a[v]=0;I=t;J=s;K=n+ -1|0;break}if(G){L=(u&255)>>>1}else{L=c[w+4>>2]|0}if((L|0)!=(r|0)){I=1;J=s;K=n;break}a[v]=2;I=1;J=s+1|0;K=n+ -1|0}else{I=t;J=s;K=n}}while(0);u=w+12|0;if((u|0)==(f|0)){M=I;N=J;O=K;break b}t=I;w=u;s=J;n=K;v=v+1|0}}else{v=0;n=e;s=x;w=q;t=p;while(1){do{if((a[t]|0)==1){if((a[n]&1)==0){P=n+4|0}else{P=c[n+8>>2]|0}if((F|0)!=(De[c[(c[g>>2]|0)+28>>2]&63](g,c[P+(d<<2)>>2]|0)|0)){a[t]=0;Q=v;R=s;S=w+ -1|0;break}u=a[n]|0;if((u&1)==0){T=(u&255)>>>1}else{T=c[n+4>>2]|0}if((T|0)!=(r|0)){Q=1;R=s;S=w;break}a[t]=2;Q=1;R=s+1|0;S=w+ -1|0}else{Q=v;R=s;S=w}}while(0);u=n+12|0;if((u|0)==(f|0)){M=Q;N=R;O=S;break b}v=Q;n=u;s=R;w=S;t=t+1|0}}}while(0);if(!M){d=r;x=N;q=O;continue}t=c[l>>2]|0;w=t+12|0;s=c[w>>2]|0;if((s|0)==(c[t+16>>2]|0)){oe[c[(c[t>>2]|0)+40>>2]&127](t)|0}else{c[w>>2]=s+4}if((O+N|0)>>>0<2){d=r;x=N;q=O;continue}else{U=e;V=N;W=p}while(1){do{if((a[W]|0)==2){s=a[U]|0;if((s&1)==0){X=(s&255)>>>1}else{X=c[U+4>>2]|0}if((X|0)==(r|0)){Y=V;break}a[W]=0;Y=V+ -1|0}else{Y=V}}while(0);s=U+12|0;if((s|0)==(f|0)){d=r;x=Y;q=O;continue a}else{U=s;V=Y;W=W+1|0}}}do{if((D|0)==0){Z=1}else{W=c[D+12>>2]|0;if((W|0)==(c[D+16>>2]|0)){_=oe[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{_=c[W>>2]|0}if((_|0)==-1){c[l>>2]=0;Z=1;break}else{Z=(c[l>>2]|0)==0;break}}}while(0);do{if((A|0)==0){$=85}else{l=c[A+12>>2]|0;if((l|0)==(c[A+16>>2]|0)){aa=oe[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{aa=c[l>>2]|0}if((aa|0)==-1){c[b>>2]=0;$=85;break}else{if(Z){break}else{$=87;break}}}}while(0);if(($|0)==85){if(Z){$=87}}if(($|0)==87){c[h>>2]=c[h>>2]|2}c:do{if(m){$=92}else{if((a[p]|0)==2){ba=e;break}else{ca=e;da=p}while(1){Z=ca+12|0;b=da+1|0;if((Z|0)==(f|0)){$=92;break c}if((a[b]|0)==2){ba=Z;break}else{da=b;ca=Z}}}}while(0);if(($|0)==92){c[h>>2]=c[h>>2]|4;ba=f}if((o|0)==0){i=k;return ba|0}W_a(o);i=k;return ba|0}function fUa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];gUa(a,0,k,j,f,g,h);i=b;return}function gUa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==64){t=8}else if((s|0)==8){t=16}else{t=10}s=k;CUa(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZQa(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=oe[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=oe[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}ZQa(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}ZQa(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=oe[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((yUa(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){oe[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=vZa(I,c[o>>2]|0,h,t)|0;MWa(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=oe[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=oe[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;QQa(n);QQa(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;QQa(n);QQa(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;QQa(n);QQa(m);i=d;return}function hUa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];iUa(a,0,k,j,f,g,h);i=b;return}function iUa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;CUa(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZQa(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=oe[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=oe[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){K=(w&255)>>>1}else{K=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(K|0)){if(E){L=(w&255)>>>1;M=(w&255)>>>1}else{w=c[x>>2]|0;L=w;M=w}ZQa(n,M<<1,0);if((a[n]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}ZQa(n,N,0);if((a[n]&1)==0){O=u}else{O=c[v>>2]|0}c[o>>2]=O+L;P=O}else{P=z}w=A+12|0;E=c[w>>2]|0;Q=A+16|0;if((E|0)==(c[Q>>2]|0)){R=oe[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{R=c[E>>2]|0}if((yUa(R,t,P,o,r,y,m,g,q,s)|0)!=0){H=G;I=P;break}E=c[w>>2]|0;if((E|0)==(c[Q>>2]|0)){oe[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=P;continue}else{c[w>>2]=E+4;l=A;z=P;continue}}P=a[m]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[m+4>>2]|0}do{if((S|0)!=0){P=c[q>>2]|0;if((P-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=P+4;c[P>>2]=z}}while(0);r=uZa(I,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;MWa(m,g,c[q>>2]|0,h);do{if((A|0)==0){T=0;U=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){V=oe[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{V=c[q>>2]|0}if(!((V|0)==-1)){T=A;U=0;break}c[k>>2]=0;T=0;U=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){W=oe[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{W=c[k>>2]|0}if((W|0)==-1){c[e>>2]=0;D=60;break}if(!U){break}X=b;Y=X;c[Y>>2]=T;QQa(n);QQa(m);i=d;return}}while(0);do{if((D|0)==60){if(U){break}X=b;Y=X;c[Y>>2]=T;QQa(n);QQa(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;X=b;Y=X;c[Y>>2]=T;QQa(n);QQa(m);i=d;return}function jUa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];kUa(a,0,k,j,f,g,h);i=b;return}function kUa(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+328|0;l=e;m=e+104|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+152|0;r=e+312|0;s=e+320|0;t=c[h+4>>2]&74;if((t|0)==8){u=16}else if((t|0)==0){u=0}else if((t|0)==64){u=8}else{u=10}t=l;CUa(n,h,t,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;ZQa(o,10,0);if((a[o]&1)==0){h=o+1|0;v=h;w=o+8|0;x=h}else{h=o+8|0;v=o+1|0;w=h;x=c[h>>2]|0}c[p>>2]=x;h=q;c[r>>2]=h;c[s>>2]=0;l=f;f=g;g=o;y=o+4|0;z=c[m>>2]|0;m=c[l>>2]|0;A=x;a:while(1){do{if((m|0)==0){B=0;C=1}else{x=c[m+12>>2]|0;if((x|0)==(c[m+16>>2]|0)){D=oe[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{D=c[x>>2]|0}if(!((D|0)==-1)){B=m;C=0;break}c[l>>2]=0;B=0;C=1}}while(0);x=c[f>>2]|0;do{if((x|0)==0){E=21}else{F=c[x+12>>2]|0;if((F|0)==(c[x+16>>2]|0)){G=oe[c[(c[x>>2]|0)+36>>2]&127](x)|0}else{G=c[F>>2]|0}if((G|0)==-1){c[f>>2]=0;E=21;break}else{if(C){H=x;break}else{I=x;J=A;break a}}}}while(0);if((E|0)==21){E=0;if(C){I=0;J=A;break}else{H=0}}x=a[o]|0;F=(x&1)==0;if(F){K=(x&255)>>>1}else{K=c[y>>2]|0}if(((c[p>>2]|0)-A|0)==(K|0)){if(F){L=(x&255)>>>1;M=(x&255)>>>1}else{x=c[y>>2]|0;L=x;M=x}ZQa(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[g>>2]&-2)+ -1|0}ZQa(o,N,0);if((a[o]&1)==0){O=v}else{O=c[w>>2]|0}c[p>>2]=O+L;P=O}else{P=A}x=B+12|0;F=c[x>>2]|0;Q=B+16|0;if((F|0)==(c[Q>>2]|0)){R=oe[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{R=c[F>>2]|0}if((yUa(R,u,P,p,s,z,n,h,r,t)|0)!=0){I=H;J=P;break}F=c[x>>2]|0;if((F|0)==(c[Q>>2]|0)){oe[c[(c[B>>2]|0)+40>>2]&127](B)|0;m=B;A=P;continue}else{c[x>>2]=F+4;m=B;A=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){P=c[r>>2]|0;if((P-q|0)>=160){break}A=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=A}}while(0);b[k>>1]=tZa(J,c[p>>2]|0,j,u)|0;MWa(n,h,c[r>>2]|0,j);do{if((B|0)==0){T=0;U=1}else{r=c[B+12>>2]|0;if((r|0)==(c[B+16>>2]|0)){V=oe[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{V=c[r>>2]|0}if(!((V|0)==-1)){T=B;U=0;break}c[l>>2]=0;T=0;U=1}}while(0);do{if((I|0)==0){E=60}else{l=c[I+12>>2]|0;if((l|0)==(c[I+16>>2]|0)){W=oe[c[(c[I>>2]|0)+36>>2]&127](I)|0}else{W=c[l>>2]|0}if((W|0)==-1){c[f>>2]=0;E=60;break}if(!U){break}X=d;Y=X;c[Y>>2]=T;QQa(o);QQa(n);i=e;return}}while(0);do{if((E|0)==60){if(U){break}X=d;Y=X;c[Y>>2]=T;QQa(o);QQa(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;X=d;Y=X;c[Y>>2]=T;QQa(o);QQa(n);i=e;return}function lUa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];mUa(a,0,k,j,f,g,h);i=b;return}function mUa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==0){t=0}else if((s|0)==64){t=8}else{t=10}s=k;CUa(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZQa(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=oe[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=oe[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}ZQa(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}ZQa(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=oe[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((yUa(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){oe[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=sZa(I,c[o>>2]|0,h,t)|0;MWa(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=oe[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=oe[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;QQa(n);QQa(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;QQa(n);QQa(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;QQa(n);QQa(m);i=d;return}function nUa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];oUa(a,0,k,j,f,g,h);i=b;return}function oUa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==8){t=16}else if((s|0)==0){t=0}else{t=10}s=k;CUa(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZQa(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=oe[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=oe[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}ZQa(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}ZQa(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=oe[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((yUa(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){oe[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=rZa(I,c[o>>2]|0,h,t)|0;MWa(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=oe[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=oe[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;QQa(n);QQa(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;QQa(n);QQa(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;QQa(n);QQa(m);i=d;return}function pUa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];qUa(a,0,k,j,f,g,h);i=b;return}function qUa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==64){t=8}else if((s|0)==0){t=0}else{t=10}s=k;CUa(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZQa(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=oe[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=oe[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){K=(w&255)>>>1}else{K=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(K|0)){if(E){L=(w&255)>>>1;M=(w&255)>>>1}else{w=c[x>>2]|0;L=w;M=w}ZQa(n,M<<1,0);if((a[n]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}ZQa(n,N,0);if((a[n]&1)==0){O=u}else{O=c[v>>2]|0}c[o>>2]=O+L;P=O}else{P=z}w=A+12|0;E=c[w>>2]|0;Q=A+16|0;if((E|0)==(c[Q>>2]|0)){R=oe[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{R=c[E>>2]|0}if((yUa(R,t,P,o,r,y,m,g,q,s)|0)!=0){H=G;I=P;break}E=c[w>>2]|0;if((E|0)==(c[Q>>2]|0)){oe[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=P;continue}else{c[w>>2]=E+4;l=A;z=P;continue}}P=a[m]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[m+4>>2]|0}do{if((S|0)!=0){P=c[q>>2]|0;if((P-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=P+4;c[P>>2]=z}}while(0);r=qZa(I,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;MWa(m,g,c[q>>2]|0,h);do{if((A|0)==0){T=0;U=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){V=oe[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{V=c[q>>2]|0}if(!((V|0)==-1)){T=A;U=0;break}c[k>>2]=0;T=0;U=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){W=oe[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{W=c[k>>2]|0}if((W|0)==-1){c[e>>2]=0;D=60;break}if(!U){break}X=b;Y=X;c[Y>>2]=T;QQa(n);QQa(m);i=d;return}}while(0);do{if((D|0)==60){if(U){break}X=b;Y=X;c[Y>>2]=T;QQa(n);QQa(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;X=b;Y=X;c[Y>>2]=T;QQa(n);QQa(m);i=d;return}function rUa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];sUa(a,0,k,j,f,g,h);i=b;return}function sUa(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;DUa(n,h,v,l,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;ZQa(o,10,0);if((a[o]&1)==0){h=o+1|0;w=h;x=o+8|0;y=h}else{h=o+8|0;w=o+1|0;x=h;y=c[h>>2]|0}c[p>>2]=y;h=q;c[r>>2]=h;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=oe[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=oe[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}ZQa(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}ZQa(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=oe[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((EUa(T,t,u,R,p,B,l,n,h,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){oe[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);g[k>>2]=+pZa(L,c[p>>2]|0,j);MWa(n,h,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=oe[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=oe[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;QQa(o);QQa(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;QQa(o);QQa(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;QQa(o);QQa(n);i=d;return}function tUa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];uUa(a,0,k,j,f,g,h);i=b;return}function uUa(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;DUa(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZQa(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=oe[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=oe[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}ZQa(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}ZQa(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=oe[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((EUa(T,t,u,R,p,B,l,n,g,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){oe[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);h[k>>3]=+oZa(L,c[p>>2]|0,j);MWa(n,g,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=oe[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=oe[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;QQa(o);QQa(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;QQa(o);QQa(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;QQa(o);QQa(n);i=d;return}function vUa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];wUa(a,0,k,j,f,g,h);i=b;return}function wUa(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;DUa(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZQa(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=oe[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=oe[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}ZQa(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}ZQa(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=oe[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((EUa(T,t,u,R,p,B,l,n,g,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){oe[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);h[k>>3]=+nZa(L,c[p>>2]|0,j);MWa(n,g,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=oe[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=oe[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;QQa(o);QQa(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;QQa(o);QQa(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;QQa(o);QQa(n);i=d;return}function xUa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=i;i=i+8|0;k=d;l=i;i=i+16|0;m=i;i=i+104|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+160|0;s=i;i=i+8|0;t=i;i=i+8|0;u=n;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;MRa(o,g);g=o;o=c[g>>2]|0;if(!((c[70110]|0)==-1)){c[l>>2]=280440;c[l+4>>2]=1276;c[l+8>>2]=0;BQa(280440,l,1277)}l=(c[280444>>2]|0)+ -1|0;u=c[o+8>>2]|0;if(!((c[o+12>>2]|0)-u>>2>>>0>l>>>0)){v=Hc(4)|0;w=v;A_a(w);x=296008;y=128;Zd(v|0,x|0,y|0)}o=c[u+(l<<2)>>2]|0;if((o|0)==0){v=Hc(4)|0;w=v;A_a(w);x=296008;y=128;Zd(v|0,x|0,y|0)}y=m;Ne[c[(c[o>>2]|0)+48>>2]&63](o,278992,279018|0,y)|0;gQa(c[g>>2]|0)|0;g=p;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZQa(p,10,0);if((a[p]&1)==0){g=p+1|0;z=g;A=p+8|0;B=g}else{g=p+8|0;z=p+1|0;A=g;B=c[g>>2]|0}c[q>>2]=B;g=r;c[s>>2]=g;c[t>>2]=0;r=e;e=f;f=p;o=p+4|0;m=c[r>>2]|0;x=B;a:while(1){do{if((m|0)==0){C=0;D=1}else{B=c[m+12>>2]|0;if((B|0)==(c[m+16>>2]|0)){E=oe[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{E=c[B>>2]|0}if(!((E|0)==-1)){C=m;D=0;break}c[r>>2]=0;C=0;D=1}}while(0);B=c[e>>2]|0;do{if((B|0)==0){F=22}else{v=c[B+12>>2]|0;if((v|0)==(c[B+16>>2]|0)){G=oe[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{G=c[v>>2]|0}if((G|0)==-1){c[e>>2]=0;F=22;break}else{if(D){break}else{H=x;break a}}}}while(0);if((F|0)==22){F=0;if(D){H=x;break}}B=a[p]|0;v=(B&1)==0;if(v){I=(B&255)>>>1}else{I=c[o>>2]|0}if(((c[q>>2]|0)-x|0)==(I|0)){if(v){J=(B&255)>>>1;K=(B&255)>>>1}else{B=c[o>>2]|0;J=B;K=B}ZQa(p,K<<1,0);if((a[p]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}ZQa(p,L,0);if((a[p]&1)==0){M=z}else{M=c[A>>2]|0}c[q>>2]=M+J;N=M}else{N=x}B=C+12|0;v=c[B>>2]|0;w=C+16|0;if((v|0)==(c[w>>2]|0)){O=oe[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{O=c[v>>2]|0}if((yUa(O,16,N,q,t,0,n,g,s,y)|0)!=0){H=N;break}v=c[B>>2]|0;if((v|0)==(c[w>>2]|0)){oe[c[(c[C>>2]|0)+40>>2]&127](C)|0;m=C;x=N;continue}else{c[B>>2]=v+4;m=C;x=N;continue}}a[H+3|0]=0;do{if((a[280344]|0)==0){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);N=c[70084]|0;c[k>>2]=j;if((aUa(H,N,279032,k)|0)!=1){c[h>>2]=4}k=c[r>>2]|0;do{if((k|0)==0){P=0;Q=1}else{N=c[k+12>>2]|0;if((N|0)==(c[k+16>>2]|0)){R=oe[c[(c[k>>2]|0)+36>>2]&127](k)|0}else{R=c[N>>2]|0}if(!((R|0)==-1)){P=k;Q=0;break}c[r>>2]=0;P=0;Q=1}}while(0);r=c[e>>2]|0;do{if((r|0)==0){F=60}else{k=c[r+12>>2]|0;if((k|0)==(c[r+16>>2]|0)){S=oe[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{S=c[k>>2]|0}if((S|0)==-1){c[e>>2]=0;F=60;break}if(!Q){break}T=b;U=T;c[U>>2]=P;QQa(p);QQa(n);i=d;return}}while(0);do{if((F|0)==60){if(Q){break}T=b;U=T;c[U>>2]=P;QQa(p);QQa(n);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;T=b;U=T;c[U>>2]=P;QQa(p);QQa(n);i=d;return}function yUa(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do{if(p){q=(c[m+96>>2]|0)==(b|0);if(!q){if((c[m+100>>2]|0)!=(b|0)){break}}c[f>>2]=e+1;a[e]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}}while(0);q=a[j]|0;if((q&1)==0){s=(q&255)>>>1}else{s=c[j+4>>2]|0}if((s|0)!=0&(b|0)==(h|0)){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+104|0;h=m;while(1){l=h+4|0;if((c[h>>2]|0)==(b|0)){t=h;break}if((l|0)==(k|0)){t=k;break}else{h=l}}h=t-m|0;m=h>>2;if((h|0)>92){r=-1;i=n;return r|0}do{if((d|0)==16){if((h|0)<88){break}if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+ -1|0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;t=a[278992+m|0]|0;c[f>>2]=o+1;a[o]=t;r=0;i=n;return r|0}else if((d|0)==10|(d|0)==8){if((m|0)<(d|0)){break}else{r=-1}i=n;return r|0}}while(0);d=a[278992+m|0]|0;c[f>>2]=o+1;a[o]=d;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function zUa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g;j=g+16|0;k=g+32|0;MRa(k,d);d=k;k=c[d>>2]|0;if(!((c[70112]|0)==-1)){c[j>>2]=280448;c[j+4>>2]=1276;c[j+8>>2]=0;BQa(280448,j,1277)}j=(c[280452>>2]|0)+ -1|0;l=c[k+8>>2]|0;if(!((c[k+12>>2]|0)-l>>2>>>0>j>>>0)){m=Hc(4)|0;n=m;A_a(n);o=296008;p=128;Zd(m|0,o|0,p|0)}k=c[l+(j<<2)>>2]|0;if((k|0)==0){m=Hc(4)|0;n=m;A_a(n);o=296008;p=128;Zd(m|0,o|0,p|0)}Ne[c[(c[k>>2]|0)+32>>2]&63](k,278992,279018|0,e)|0;e=c[d>>2]|0;if(!((c[70148]|0)==-1)){c[h>>2]=280592;c[h+4>>2]=1276;c[h+8>>2]=0;BQa(280592,h,1277)}h=(c[280596>>2]|0)+ -1|0;k=c[e+8>>2]|0;if(!((c[e+12>>2]|0)-k>>2>>>0>h>>>0)){q=Hc(4)|0;r=q;A_a(r);s=296008;t=128;Zd(q|0,s|0,t|0)}e=c[k+(h<<2)>>2]|0;if((e|0)==0){q=Hc(4)|0;r=q;A_a(r);s=296008;t=128;Zd(q|0,s|0,t|0)}else{t=e;a[f]=oe[c[(c[e>>2]|0)+16>>2]&127](t)|0;me[c[(c[e>>2]|0)+20>>2]&127](b,t);gQa(c[d>>2]|0)|0;i=g;return}}



function Usa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=0;k=e-b|0;if((k&1|0)!=0){k=k&-2;e=b+k|0}a:while(1){if((b|0)==(e|0)){l=39;break}k=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[k]|0)|0]|0}else{m=gta(a[k+1|0]|0,a[b]|0)|0}switch(m|0){case 2:{k=b+2|0;b=k;if((k|0)==(e|0)){l=19;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=33){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=23;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=91){continue a}g=g+1|0;b=b+2|0;continue a;break};case 7:{if((e-b|0)<4){l=15;break a}b=b+4|0;continue a;break};case 4:{k=b+2|0;b=k;if((k|0)==(e|0)){l=28;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=93){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=32;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=62){continue a}b=b+2|0;if((g|0)==0){l=36;break a}g=g+ -1|0;continue a;break};case 8:case 1:case 0:{l=17;break a;break};case 5:{if((e-b|0)<2){l=9;break a}b=b+2|0;continue a;break};case 6:{if((e-b|0)<3){l=12;break a}b=b+3|0;continue a;break};default:{b=b+2|0;continue a}}}if((l|0)==9){n=-2;o=n;i=h;return o|0}else if((l|0)==12){n=-2;o=n;i=h;return o|0}else if((l|0)==15){n=-2;o=n;i=h;return o|0}else if((l|0)==17){c[f>>2]=b;n=0;o=n;i=h;return o|0}else if((l|0)==19){n=-1;o=n;i=h;return o|0}else if((l|0)==23){n=-1;o=n;i=h;return o|0}else if((l|0)==28){n=-1;o=n;i=h;return o|0}else if((l|0)==32){n=-1;o=n;i=h;return o|0}else if((l|0)==36){c[f>>2]=b;n=42;o=n;i=h;return o|0}else if((l|0)==39){n=-1;o=n;i=h;return o|0}return 0}function Vsa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=33;break}o=b;if((a[m+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=gta(a[o+1|0]|0,a[b]|0)|0}switch(p|0){case 6:{b=b+3|0;continue a;break};case 7:{b=b+4|0;continue a;break};case 3:{n=12;break a;break};case 21:{n=29;break a;break};case 10:{n=16;break a;break};case 5:{b=b+2|0;continue a;break};case 9:{n=19;break a;break};case 2:{n=15;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=hta(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==16){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==19){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[e]|0)|0]|0}else{q=gta(a[e+1|0]|0,a[b]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==29){q=b;if((b|0)==(g|0)){c[f>>2]=q+2;k=39;l=k;i=h;return l|0}else{c[f>>2]=q;k=6;l=k;i=h;return l|0}}else if((n|0)==33){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function Wsa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=32;break}o=b;if((a[m+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=gta(a[o+1|0]|0,a[b]|0)|0}switch(p|0){case 30:{n=15;break a;break};case 7:{b=b+4|0;continue a;break};case 10:{n=18;break a;break};case 9:{n=21;break a;break};case 6:{b=b+3|0;continue a;break};case 5:{b=b+2|0;continue a;break};case 3:{n=12;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=hta(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){if((b|0)==(g|0)){p=ita(j,b+2|0,e,f)|0;k=(p|0)==22?0:p;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==18){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==21){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[e]|0)|0]|0}else{q=gta(a[e+1|0]|0,a[b]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function Xsa(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){e=b;if((a[b+1|0]|0)==0){h=d[g+76+(d[e]|0)|0]|0}else{h=gta(a[e+1|0]|0,a[b]|0)|0}switch(h|0){case 6:{j=8;break};case 5:{break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{e=c;c=e+1|0;k=b;b=k+1|0;if((a[e]|0)!=(a[k]|0)){j=15;break a}k=c;c=k+1|0;e=b;b=e+1|0;if((a[k]|0)!=(a[e]|0)){j=17;break a}else{continue a}break};case 7:{e=b;b=e+1|0;k=c;c=k+1|0;if((a[e]|0)!=(a[k]|0)){j=7;break a}else{j=8}break};default:{j=18;break a}}if((j|0)==8){j=0;k=b;b=k+1|0;e=c;c=e+1|0;if((a[k]|0)!=(a[e]|0)){j=9;break}}e=b;b=e+1|0;k=c;c=k+1|0;if((a[e]|0)!=(a[k]|0)){j=11;break}k=b;b=k+1|0;e=c;c=e+1|0;if((a[k]|0)!=(a[e]|0)){j=13;break}}if((j|0)==7){l=0;m=l;i=f;return m|0}else if((j|0)==9){l=0;m=l;i=f;return m|0}else if((j|0)==11){l=0;m=l;i=f;return m|0}else if((j|0)==13){l=0;m=l;i=f;return m|0}else if((j|0)==15){l=0;m=l;i=f;return m|0}else if((j|0)==17){l=0;m=l;i=f;return m|0}else if((j|0)==18){j=c;if((a[c+1|0]|0)==0){n=d[g+76+(d[j]|0)|0]|0}else{n=gta(a[j+1|0]|0,a[c]|0)|0}switch(n|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{l=0;m=l;i=f;return m|0};default:{l=1;m=l;i=f;return m|0}}}return 0}function Ysa(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=9;break}if(g){h=4;break}if((a[f+1|0]|0)!=0){h=7;break}if((a[f]|0)!=(a[d]|0)){h=7;break}f=f+2|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==7){j=0;k=j;i=b;return k|0}else if((h|0)==9){j=g&1;k=j;i=b;return k|0}return 0}function Zsa(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;e=i;i=i+24|0;f=b;b=c;c=b;a:while(1){g=b;if((a[b+1|0]|0)==0){h=d[f+76+(d[g]|0)|0]|0}else{h=gta(a[g+1|0]|0,a[b]|0)|0}switch(h|0){case 7:{b=b+4|0;continue a;break};case 6:{b=b+3|0;continue a;break};case 5:{b=b+2|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{b=b+2|0;continue a;break};default:{break a}}}i=e;return b-c|0}function _sa(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=c;while(1){c=b;if((a[b+1|0]|0)==0){g=d[f+76+(d[c]|0)|0]|0}else{g=gta(a[c+1|0]|0,a[b]|0)|0}if(!((g|0)==21|(g|0)==9|(g|0)==10)){break}b=b+2|0}i=e;return b|0}function $sa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+2|0;a:while(1){m=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[m]|0)|0]|0}else{n=gta(a[m+1|0]|0,a[b]|0)|0}b:do{switch(n|0){case 17:case 11:{if((g|0)!=2){break a}break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b+1|0]|0)==0){o=a[b]|0}else{o=-1}if((o|0)!=32){break}if((a[b+3|0]|0)==0){p=a[b+2|0]|0}else{p=-1}if((p|0)==32){break}m=b+2|0;if((a[b+3|0]|0)==0){q=d[j+76+(d[m]|0)|0]|0}else{q=gta(a[m+1|0]|0,a[b+2|0]|0)|0}if((q|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};default:{}}}while(0);b=b+2|0}i=h;return k|0}function ata(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=c;c=0;d=d+4|0;a:do{if((a[d+1|0]|0)==0){if((a[d]|0)!=120){e=16;break}d=d+2|0;while(1){if((a[d+1|0]|0)==0){f=(a[d]|0)==59}else{f=0}if(!(f^1)){break a}if((a[d+1|0]|0)==0){g=a[d]|0}else{g=-1}h=g;switch(h|0){case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|h-48;break};case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(h-97))|0;break};case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(h-65))|0;break};default:{}}if((c|0)>=1114112){break}d=d+2|0}j=-1;k=j;i=b;return k|0}else{e=16}}while(0);b:do{if((e|0)==16){while(1){e=0;if((a[d+1|0]|0)==0){l=(a[d]|0)==59}else{l=0}if(!(l^1)){break b}if((a[d+1|0]|0)==0){m=a[d]|0}else{m=-1}c=c*10|0;c=c+(m-48)|0;if((c|0)>=1114112){break}d=d+2|0;e=16}j=-1;k=j;i=b;return k|0}}while(0);j=usa(c)|0;k=j;i=b;return k|0}function bta(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;e=c;c=(d-e|0)/2|0;do{if((c|0)==2){if((a[e+3|0]|0)!=0){break}if((a[e+2|0]|0)!=116){break}if((a[e+1|0]|0)==0){f=a[e]|0}else{f=-1}if((f|0)==108){g=60;h=g;i=b;return h|0}else if((f|0)==103){g=62;h=g;i=b;return h|0}else{break}}else if((c|0)==4){if((a[e+1|0]|0)==0){j=a[e]|0}else{j=-1}if((j|0)==113){e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=117){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=111){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=116){break}g=34;h=g;i=b;return h|0}else if((j|0)==97){e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=112){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=111){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=115){break}g=39;h=g;i=b;return h|0}else{break}}else if((c|0)==3){if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=97){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=109){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=112){break}g=38;h=g;i=b;return h|0}}while(0);g=0;h=g;i=b;return h|0}function cta(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=b;b=e;e=f;f=g;while(1){if(!(b>>>0<e>>>0)){break}g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=gta(a[g+1|0]|0,a[b]|0)|0}switch(k|0){case 7:{b=b+4|0;break};case 9:{g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;do{if((b|0)!=(e|0)){g=b;if((a[b+1|0]|0)==0){l=d[j+76+(d[g]|0)|0]|0}else{l=gta(a[g+1|0]|0,a[b]|0)|0}if((l|0)!=10){break}b=b+2|0}}while(0);c[f+4>>2]=-1;break};case 6:{b=b+3|0;break};case 10:{c[f+4>>2]=-1;g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;break};case 5:{b=b+2|0;break};default:{b=b+2|0}}g=f+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}function dta(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+2|0;e=e+ -2|0;a:while(1){if((b|0)==(e|0)){k=18;break}g=b;if((a[b+1|0]|0)==0){l=d[j+76+(d[g]|0)|0]|0}else{l=gta(a[g+1|0]|0,a[b]|0)|0}b:do{switch(l|0){case 21:{if((a[b+1|0]|0)!=0){break b}if((a[b]|0)==9){k=9;break a}break};case 22:case 26:{if((a[b+1|0]|0)==0){m=a[b]|0}else{m=-1}if((m&-128|0)!=0){k=13}break};case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};default:{k=13}}}while(0);if((k|0)==13){k=0;if((a[b+1|0]|0)==0){n=a[b]|0}else{n=-1}if(!((n|0)==64|(n|0)==36)){k=16;break}}b=b+2|0}if((k|0)==9){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==16){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==18){o=1;p=o;i=h;return p|0}return 0}function eta(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+80|0;h=d;d=e;e=f;f=g;g=c[h>>2]|0;a:while(1){j=g;if((g|0)==(d|0)){k=18;break}l=a[j]|0;m=a[g+1|0]|0;b:do{switch(m&255|0){case 7:case 6:case 5:case 4:case 3:case 2:case 1:{k=8;break};case 0:{if((l&255|0)>=128){k=8;break b}if((c[e>>2]|0)==(f|0)){k=6;break a}n=e;o=c[n>>2]|0;c[n>>2]=o+1;a[o]=l;break};case 219:case 218:case 217:case 216:{if((f-(c[e>>2]|0)|0)<4){k=15;break a}o=((m&3)<<2|(l&255)>>6&3)+1|0;n=e;p=c[n>>2]|0;c[n>>2]=p+1;a[p]=o>>2|240;p=e;n=c[p>>2]|0;c[p>>2]=n+1;a[n]=(l&255)>>2&15|(o&3)<<4|128;g=g+2|0;o=a[g]|0;n=((l&3)<<4|(a[g+1|0]&3)<<2|(o&255)>>6|128)&255;p=e;q=c[p>>2]|0;c[p>>2]=q+1;a[q]=n;n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=o&63|128;break};default:{if((f-(c[e>>2]|0)|0)<3){k=12;break a}o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=(m&255)>>4|224;q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(m&15)<<2|(l&255)>>6|128;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}}}while(0);if((k|0)==8){k=0;if((f-(c[e>>2]|0)|0)<2){k=9;break}q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(l&255)>>6|(m&255)<<2|192;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}g=g+2|0}if((k|0)==6){c[h>>2]=g;i=b;return}else if((k|0)==9){c[h>>2]=g;i=b;return}else if((k|0)==12){c[h>>2]=g;i=b;return}else if((k|0)==15){c[h>>2]=g;i=b;return}else if((k|0)==18){c[h>>2]=j;i=b;return}}function fta(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;e=i;i=i+40|0;k=f;f=g;g=h;h=j;do{if((f-(c[k>>2]|0)|0)>(((h-(c[g>>2]|0)|0)/2|0)<<1|0)){if((a[f+ -2+1|0]&248|0)!=216){break}f=f+ -2|0}}while(0);while(1){if((c[k>>2]|0)==(f|0)){l=7;break}if((c[g>>2]|0)==(h|0)){l=7;break}j=((d[(c[k>>2]|0)+1|0]|0)<<8|(d[c[k>>2]|0]|0))&65535;m=g;n=c[m>>2]|0;c[m>>2]=n+2;b[n>>1]=j;j=k;c[j>>2]=(c[j>>2]|0)+2}if((l|0)==7){i=e;return}}function gta(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;i=i+24|0;a:do{switch(a&255|0){case 219:case 218:case 217:case 216:{d=7;break};case 255:{if(!(((b&255)+ -254|0)>>>0<2)){e=6;break a}d=0;break};case 223:case 222:case 221:case 220:{d=8;break};default:{e=6}}}while(0);if((e|0)==6){d=29}i=c;return d|0}function hta(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=gta(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 19:{k=jta(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[197496+((d[197240+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=gta(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 6:{n=32;break b;break};case 29:{if((c[197496+((d[198776+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=27;break b}break};case 7:{n=35;break b;break};case 5:{n=29;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 18:{n=38;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=9;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function ita(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=gta(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 30:case 9:case 10:case 21:{c[f>>2]=b;k=22;l=k;i=h;return l|0};case 29:{if((c[197496+((d[197240+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=gta(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 29:{if((c[197496+((d[198776+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=27;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 18:{n=38;break b;break};case 7:{n=35;break b;break};case 6:{n=32;break b;break};case 5:{n=29;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=28;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function jta(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b+1|0]|0)==0){if((a[b]|0)!=120){break}k=kta(j,b+2|0,e,f)|0;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=gta(a[g+1|0]|0,a[b]|0)|0}g=b;if((m|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=gta(a[g+1|0]|0,a[b]|0)|0}if((n|0)==18){o=16;break}else if((n|0)!=25){o=17;break}b=b+2|0}if((o|0)==16){c[f>>2]=b+2;k=10;l=k;i=h;return l|0}else if((o|0)==17){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function kta(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=gta(a[g+1|0]|0,a[b]|0)|0}g=b;if(!((k+ -24|0)>>>0<2)){c[f>>2]=g;l=0;m=l;i=h;return m|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=gta(a[g+1|0]|0,a[b]|0)|0}if((n|0)==18){o=13;break}else if(!((n|0)==24|(n|0)==25)){o=14;break}b=b+2|0}if((o|0)==13){c[f>>2]=b+2;l=10;m=l;i=h;return m|0}else if((o|0)==14){c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);l=-1;m=l;i=h;return m|0}function lta(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=gta(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 24:case 22:{break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[197496+((d[197240+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 15:{k=ota(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 17:{k=pta(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 16:{g=b+2|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=gta(a[g+1|0]|0,a[b]|0)|0}if((n|0)==27){k=mta(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((n|0)==20){k=nta(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;n=0;b:while(1){if((b|0)==(e|0)){o=98;break}m=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[m]|0)|0]|0}else{p=gta(a[m+1|0]|0,a[b]|0)|0}switch(p|0){case 10:case 9:case 21:{o=69;break b;break};case 11:{o=90;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 17:{break b;break};case 5:{o=39;break b;break};case 6:{o=42;break b;break};case 29:{if((c[197496+((d[198776+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=37;break b}break};case 7:{o=45;break b;break};case 23:{if((n|0)!=0){o=49;break b}n=1;b=b+2|0;if((b|0)==(e|0)){o=51;break b}m=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[m]|0)|0]|0}else{q=gta(a[m+1|0]|0,a[b]|0)|0}switch(q|0){case 29:{if((c[197496+((d[197240+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=57;break b}break};case 24:case 22:{break};case 5:{o=59;break b;break};case 7:{o=65;break b;break};case 6:{o=62;break b;break};default:{o=68;break b}}b=b+2|0;continue b;break};default:{o=97;break b}}b=b+2|0}c:do{if((o|0)==37){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==39){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==42){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==45){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==51){k=-1;l=k;i=h;return l|0}else if((o|0)==57){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==59){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==62){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==65){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==68){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==69){b=b+2|0;d:while(1){if((b|0)==(e|0)){o=89;break}q=b;if((a[b+1|0]|0)==0){r=d[j+76+(d[q]|0)|0]|0}else{r=gta(a[q+1|0]|0,a[b]|0)|0}switch(r|0){case 11:{o=90;break c;break};case 24:case 22:{break d;break};case 7:{o=84;break d;break};case 5:{o=78;break d;break};case 29:{o=75;break d;break};case 10:case 9:case 21:{break};case 17:{break c;break};case 6:{o=81;break d;break};default:{o=88;break d}}b=b+2|0}do{if((o|0)==75){if((c[197496+((d[197240+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==81){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==84){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==89){k=-1;l=k;i=h;return l|0}}while(0);b=b+2|0;k=qta(j,b,e,f)|0;l=k;i=h;return l|0}else if((o|0)==97){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==98){k=-1;l=k;i=h;return l|0}}while(0);if((o|0)==90){c[f>>2]=b+2;k=2;l=k;i=h;return l|0}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;k=4;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=0;l=k;i=h;return l|0}function mta(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b+1|0]|0)==0){if((a[b]|0)!=45){break}b=b+2|0;b:while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=gta(a[g+1|0]|0,a[b]|0)|0}switch(k|0){case 7:{if((e-b|0)<4){l=18;break b}b=b+4|0;continue b;break};case 27:{g=b+2|0;b=g;if((g|0)==(e|0)){l=22;break b}if((a[b+1|0]|0)!=0){continue b}if((a[b]|0)==45){l=25;break b}else{continue b}break};case 6:{if((e-b|0)<3){l=15;break b}b=b+3|0;continue b;break};case 5:{if((e-b|0)<2){l=12;break b}b=b+2|0;continue b;break};case 8:case 1:case 0:{l=20;break b;break};default:{b=b+2|0;continue b}}}if((l|0)==12){m=-2;n=m;i=h;return n|0}else if((l|0)==15){m=-2;n=m;i=h;return n|0}else if((l|0)==18){m=-2;n=m;i=h;return n|0}else if((l|0)==20){c[f>>2]=b;m=0;n=m;i=h;return n|0}else if((l|0)==22){m=-1;n=m;i=h;return n|0}else if((l|0)==25){g=b+2|0;b=g;if((g|0)==(e|0)){m=-1;n=m;i=h;return n|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;m=13;n=m;i=h;return n|0}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}while(0);m=-1;n=m;i=h;return n|0}function nta(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<12){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=9;break}if((a[k+1|0]|0)!=0){l=7;break}if((a[g]|0)!=(a[199440+e|0]|0)){l=7;break}e=e+1|0;g=g+2|0}if((l|0)==7){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==9){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function ota(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}n=b;if((a[b+1|0]|0)==0){o=d[k+76+(d[n]|0)|0]|0}else{o=gta(a[n+1|0]|0,a[b]|0)|0}a:do{switch(o|0){case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 29:{if((c[197496+((d[197240+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;l=0;m=l;i=h;return m|0};case 24:case 22:{break};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){p=70;break}o=b;if((a[b+1|0]|0)==0){q=d[k+76+(d[o]|0)|0]|0}else{q=gta(a[o+1|0]|0,a[b]|0)|0}switch(q|0){case 29:{if((c[197496+((d[198776+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){p=26;break b}break};case 15:{p=62;break b;break};case 10:case 9:case 21:{p=37;break b;break};case 6:{p=31;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{p=34;break b;break};case 5:{p=28;break b;break};default:{break b}}b=b+2|0}do{if((p|0)==26){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==28){if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==31){if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==34){if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==37){q=b;if((rta(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;c:while(1){if((b|0)==(e|0)){p=61;break}q=b;if((a[b+1|0]|0)==0){r=d[k+76+(d[q]|0)|0]|0}else{r=gta(a[q+1|0]|0,a[b]|0)|0}switch(r|0){case 15:{b=b+2|0;if((b|0)==(e|0)){p=56;break c}if((a[b+1|0]|0)!=0){continue c}if((a[b]|0)==62){p=59;break c}else{continue c}break};case 8:case 1:case 0:{p=54;break c;break};case 5:{if((e-b|0)<2){p=46;break c}b=b+2|0;continue c;break};case 6:{if((e-b|0)<3){p=49;break c}b=b+3|0;continue c;break};case 7:{if((e-b|0)<4){p=52;break c}b=b+4|0;continue c;break};default:{b=b+2|0;continue c}}}if((p|0)==46){l=-2;m=l;i=h;return m|0}else if((p|0)==49){l=-2;m=l;i=h;return m|0}else if((p|0)==52){l=-2;m=l;i=h;return m|0}else if((p|0)==54){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==56){l=-1;m=l;i=h;return m|0}else if((p|0)==59){c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==61){l=-1;m=l;i=h;return m|0}}else if((p|0)==62){q=b;if((rta(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b+1|0]|0)!=0){break}if((a[b]|0)!=62){break}c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==70){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function pta(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=gta(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[197496+((d[197240+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 24:case 22:{break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=50;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=gta(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 7:{n=34;break b;break};case 23:{b=b+2|0;continue b;break};case 11:{n=48;break b;break};case 10:case 9:case 21:{n=37;break b;break};case 5:{n=28;break b;break};case 6:{n=31;break b;break};case 29:{if((c[197496+((d[198776+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=26;break b}break};case 27:case 26:case 25:case 24:case 22:{break};default:{n=49;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){b=b+2|0;while(1){if((b|0)==(e|0)){n=46;break}o=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=gta(a[o+1|0]|0,a[b]|0)|0}if((p|0)==11){n=43;break}else if(!((p|0)==10|(p|0)==9|(p|0)==21)){n=44;break}b=b+2|0}if((n|0)==43){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==44){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==46){k=-1;l=k;i=h;return l|0}}else if((n|0)==48){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==50){k=-1;l=k;i=h;return l|0}return 0}function qta(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=115;break}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){m=d[k+76+(d[b]|0)|0]|0}else{m=gta(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}b:do{switch(m|0){case 5:{l=10;break a;break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=41;break a}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){n=d[k+76+(d[b]|0)|0]|0}else{n=gta(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}b=n;if((b|0)==14){break b}o=b;if(!((o|0)==9|(o|0)==10|(o|0)==21)){l=47;break a}}break};case 7:{l=16;break a;break};case 27:case 26:case 25:case 24:case 22:{l=9;break};case 23:{if((g|0)!=0){l=20;break a}g=1;c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=22;break a}o=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){p=d[k+76+(d[o]|0)|0]|0}else{p=gta(a[o+1|0]|0,a[c[j>>2]|0]|0)|0}switch(p|0){case 6:{l=33;break a;break};case 24:case 22:{break};case 7:{l=36;break a;break};case 29:{if((c[197496+((d[197240+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)==0){l=28;break a}break};case 5:{l=30;break a;break};default:{l=39;break a}}c[j>>2]=(c[j>>2]|0)+2;continue a;break};case 6:{l=13;break a;break};case 14:{break};case 29:{if((c[197496+((d[198776+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)!=0){l=9}else{l=8;break a}break};default:{l=114;break a}}}while(0);if((l|0)==9){l=0;c[j>>2]=(c[j>>2]|0)+2;continue}g=0;while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=50;break a}o=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){q=d[k+76+(d[o]|0)|0]|0}else{q=gta(a[o+1|0]|0,a[c[j>>2]|0]|0)|0}r=q;if((r|0)==12|(r|0)==13){break}o=r;if(!((o|0)==9|(o|0)==10|(o|0)==21)){l=56;break a}}c[j>>2]=(c[j>>2]|0)+2;c:while(1){if((c[j>>2]|0)==(e|0)){l=59;break a}o=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){s=d[k+76+(d[o]|0)|0]|0}else{s=gta(a[o+1|0]|0,a[c[j>>2]|0]|0)|0}o=s;if((o|0)==(r|0)){break}switch(o|0){case 6:{if((e-(c[j>>2]|0)|0)<3){l=69;break a}c[j>>2]=(c[j>>2]|0)+3;continue c;break};case 3:{t=hta(k,(c[j>>2]|0)+2|0,e,j)|0;if((t|0)<=0){l=76;break a}else{continue c}break};case 8:case 1:case 0:{l=74;break a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=72;break a}c[j>>2]=(c[j>>2]|0)+4;continue c;break};case 2:{l=79;break a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=66;break a}c[j>>2]=(c[j>>2]|0)+2;continue c;break};default:{c[j>>2]=(c[j>>2]|0)+2;continue c}}}c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=82;break}o=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){u=d[k+76+(d[o]|0)|0]|0}else{u=gta(a[o+1|0]|0,a[c[j>>2]|0]|0)|0}switch(u|0){case 17:{l=107;break a;break};case 10:case 9:case 21:{break};case 11:{l=106;break a;break};default:{l=87;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=89;break a}o=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){v=d[k+76+(d[o]|0)|0]|0}else{v=gta(a[o+1|0]|0,a[c[j>>2]|0]|0)|0}switch(v|0){case 17:{l=107;break a;break};case 10:case 9:case 21:{break};case 24:case 22:{break d;break};case 6:{l=100;break a;break};case 5:{l=97;break a;break};case 29:{l=94;break d;break};case 7:{l=103;break a;break};case 11:{l=106;break a;break};default:{l=113;break a}}}if((l|0)==94){l=0;if((c[197496+((d[197240+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)==0){l=95;break}}c[j>>2]=(c[j>>2]|0)+2}if((l|0)==8){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==10){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==13){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==16){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==20){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==22){w=-1;x=w;i=h;return x|0}else if((l|0)==28){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==30){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==33){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==36){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==39){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==41){w=-1;x=w;i=h;return x|0}else if((l|0)==47){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==50){w=-1;x=w;i=h;return x|0}else if((l|0)==56){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==59){w=-1;x=w;i=h;return x|0}else if((l|0)==66){w=-2;x=w;i=h;return x|0}else if((l|0)==69){w=-2;x=w;i=h;return x|0}else if((l|0)==72){w=-2;x=w;i=h;return x|0}else if((l|0)==74){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==76){if((t|0)==0){c[f>>2]=c[j>>2]}w=t;x=w;i=h;return x|0}else if((l|0)==79){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==82){w=-1;x=w;i=h;return x|0}else if((l|0)==87){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==89){w=-1;x=w;i=h;return x|0}else if((l|0)==95){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==97){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==100){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==103){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+2;w=1;x=w;i=h;return x|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){w=-1;x=w;i=h;return x|0}do{if((a[(c[j>>2]|0)+1|0]|0)==0){if((a[c[j>>2]|0]|0)!=62){break}c[f>>2]=(c[j>>2]|0)+2;w=3;x=w;i=h;return x|0}}while(0);c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==113){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==114){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==115){w=-1;x=w;i=h;return x|0}return 0}function rta(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;if((e-g|0)!=6){h=1;j=h;i=b;return j|0}if((a[g+1|0]|0)==0){k=a[g]|0}else{k=-1}if((k|0)==88){f=1}else if((k|0)!=120){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g+1|0]|0)==0){l=a[g]|0}else{l=-1}if((l|0)==77){f=1}else if((l|0)!=109){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g+1|0]|0)==0){m=a[g]|0}else{m=-1}if((m|0)==76){f=1}else if((m|0)!=108){h=1;j=h;i=b;return j|0}if((f|0)!=0){h=0;j=h;i=b;return j|0}else{c[d>>2]=12;h=1;j=h;i=b;return j|0}return 0}function sta(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+56|0;k=b;b=e;e=f;f=g;g=h;a:while(1){if((e|0)==(f|0)){l=27;break}h=e;if((a[e+1|0]|0)==0){m=d[b+76+(d[h]|0)|0]|0}else{m=gta(a[h+1|0]|0,a[e]|0)|0}h=m;switch(h|0){case 5:{if((f-e|0)<2){l=8;break a}e=e+2|0;continue a;break};case 6:{if((f-e|0)<3){l=11;break a}e=e+3|0;continue a;break};case 8:case 1:case 0:{l=16;break a;break};case 13:case 12:{e=e+2|0;if((h|0)!=(k|0)){continue a}else{l=18;break a}break};case 7:{if((f-e|0)<4){l=14;break a}e=e+4|0;continue a;break};default:{e=e+2|0;continue a}}}if((l|0)==8){n=-2;o=n;i=j;return o|0}else if((l|0)==11){n=-2;o=n;i=j;return o|0}else if((l|0)==14){n=-2;o=n;i=j;return o|0}else if((l|0)==16){c[g>>2]=e;n=0;o=n;i=j;return o|0}else if((l|0)==18){if((e|0)==(f|0)){n=-27;o=n;i=j;return o|0}c[g>>2]=e;g=e;if((a[e+1|0]|0)==0){p=d[b+76+(d[g]|0)|0]|0}else{p=gta(a[g+1|0]|0,a[e]|0)|0}switch(p|0){case 20:case 30:case 11:case 10:case 9:case 21:{n=27;o=n;i=j;return o|0};default:{n=0;o=n;i=j;return o|0}}}else if((l|0)==27){n=-1;o=n;i=j;return o|0}return 0}function tta(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=gta(a[g+1|0]|0,a[b]|0)|0}if((m|0)==24|(m|0)==22){b=b+2|0;a:while(1){if((b|0)==(e|0)){n=26;break}g=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[g]|0)|0]|0}else{o=gta(a[g+1|0]|0,a[b]|0)|0}switch(o|0){case 24:case 22:{break};case 10:case 9:case 21:{break a;break};case 30:{n=16;break a;break};default:{n=25;break a}}b=b+2|0}do{if((n|0)==16){if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}o=b+2|0;if((a[b+3|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=gta(a[o+1|0]|0,a[b+2|0]|0)|0}if(!((p|0)==30|(p|0)==10|(p|0)==9|(p|0)==21)){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==25){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==26){k=-1;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=16;l=k;i=h;return l|0}else if((m|0)==27){k=mta(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=b+2;k=33;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}return 0}function uta(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=gta(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 29:{if((c[197496+((d[197240+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=39;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=gta(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 27:case 26:case 25:case 24:case 22:{break};case 7:{n=34;break b;break};case 29:{if((c[197496+((d[198776+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=26;break b}break};case 6:{n=31;break b;break};case 5:{n=28;break b;break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{n=37;break b;break};default:{n=38;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){c[f>>2]=b;k=20;l=k;i=h;return l|0}else if((n|0)==38){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==39){k=-20;l=k;i=h;return l|0}return 0}function vta(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=gta(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 35:{c[f>>2]=b+2;k=38;l=k;i=h;return l|0};case 19:{k=Zta(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 32:{b=b+2|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=gta(a[g]|0,a[b+1|0]|0)|0}switch(n|0){case 33:{c[f>>2]=b+2;k=36;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 15:{c[f>>2]=b+2;k=35;l=k;i=h;return l|0};case 34:{c[f>>2]=b+2;k=37;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 36:{c[f>>2]=b+2;k=21;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 13:{k=Xta(13,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 23:case 27:case 26:case 25:{o=19;b=b+2|0;p=77;break};case 10:case 21:{p=25;break};case 11:{c[f>>2]=b+2;k=17;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{o=18;b=b+2|0;p=77;break};case 29:{g=b;if((c[197496+((d[197240+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){b=g+2|0;o=18;p=77;break a}if((c[197496+((d[198776+(d[g]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){p=76;break a}b=b+2|0;o=19;p=77;break};case 30:{k=Nta(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 20:{c[f>>2]=b+2;k=25;l=k;i=h;return l|0};case 31:{c[f>>2]=b+2;k=23;l=k;i=h;return l|0};case 2:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){q=d[j+76+(d[g+1|0]|0)|0]|0}else{q=gta(a[g]|0,a[b+1|0]|0)|0}switch(q|0){case 15:{k=Tta(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -2;k=29;l=k;i=h;return l|0};case 16:{k=Yta(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=93){break}if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+2|0]|0)!=0){break}if((a[b+3|0]|0)!=62){break}c[f>>2]=b+4;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 12:{k=Xta(12,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 9:{if((b+2|0)!=(e|0)){p=25;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};default:{p=76}}}while(0);if((p|0)==25){while(1){p=0;b=b+2|0;r=b;if((b|0)==(e|0)){p=32;break}q=b;if((a[r]|0)==0){s=d[j+76+(d[q+1|0]|0)|0]|0}else{s=gta(a[q]|0,a[b+1|0]|0)|0}if((s|0)==10|(s|0)==21){p=25;continue}else if((s|0)!=9){p=31;break}if((b+2|0)!=(e|0)){p=25}else{p=31;break}}if((p|0)==31){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((p|0)==32){c[f>>2]=r;k=15;l=k;i=h;return l|0}}else if((p|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((p|0)==77){b:while(1){p=0;if((b|0)==(e|0)){p=126;break}r=b;if((a[b]|0)==0){t=d[j+76+(d[r+1|0]|0)|0]|0}else{t=gta(a[r]|0,a[b+1|0]|0)|0}switch(t|0){case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{p=94;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 33:{p=119;break b;break};case 34:{p=116;break b;break};case 5:{p=85;break b;break};case 6:{p=88;break b;break};case 15:{p=122;break b;break};case 29:{if((c[197496+((d[198776+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){p=83;break b}break};case 23:{b=b+2|0;r=o;if((r|0)==41){o=19;p=77;continue b}else if((r|0)!=18){p=77;continue b}if((b|0)==(e|0)){p=97;break b}o=41;r=b;if((a[b]|0)==0){u=d[j+76+(d[r+1|0]|0)|0]|0}else{u=gta(a[r]|0,a[b+1|0]|0)|0}switch(u|0){case 6:{p=108;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{p=111;break b;break};case 29:{if((c[197496+((d[198776+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){p=103;break b}break};case 5:{p=105;break b;break};default:{o=19;p=77;continue b}}b=b+2|0;p=77;continue b;break};case 7:{p=91;break b;break};default:{p=125;break b}}b=b+2|0;p=77}if((p|0)==83){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((p|0)==85){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==88){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==91){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==94){c[f>>2]=b;k=o;l=k;i=h;return l|0}else if((p|0)==97){k=-1;l=k;i=h;return l|0}else if((p|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((p|0)==105){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==108){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==111){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==116){e=b;if((o|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=32;l=k;i=h;return l|0}}else if((p|0)==119){e=b;if((o|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=31;l=k;i=h;return l|0}}else if((p|0)==122){e=b;if((o|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=30;l=k;i=h;return l|0}}else if((p|0)==125){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((p|0)==126){k=0-o|0;l=k;i=h;return l|0}}return 0}function wta(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=gta(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 4:{b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b]|0)!=0){break a}if((a[b+1|0]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 3:{k=Mta(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=gta(a[g]|0,a[b+1|0]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 2:{k=Qta(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=68;break}n=b;if((a[o]|0)==0){q=d[j+76+(d[n+1|0]|0)|0]|0}else{q=gta(a[n]|0,a[b+1|0]|0)|0}switch(q|0){case 7:{r=b;if((e-b|0)<4){p=55;break b}b=r+4|0;continue b;break};case 4:{if((b+2|0)==(e|0)){p=66;break b}do{if((a[b+2|0]|0)==0){if((a[b+3|0]|0)!=93){break}if((b+4|0)==(e|0)){p=66;break b}if((a[b+4|0]|0)==0){if((a[b+5|0]|0)==62){p=65;break b}}b=b+2|0;continue b}}while(0);b=b+2|0;continue b;break};case 5:{s=b;if((e-b|0)<2){p=49;break b}b=s+2|0;continue b;break};case 6:{t=b;if((e-b|0)<3){p=52;break b}b=t+3|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{p=66;break b;break};default:{b=b+2|0;continue b}}}if((p|0)==49){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==52){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==65){c[f>>2]=b+4;k=0;l=k;i=h;return l|0}else if((p|0)==66){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==68){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function xta(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=gta(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=gta(a[g]|0,a[b+1|0]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b]|0)!=0){break a}if((a[b+1|0]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=40;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=57;break}n=b;if((a[o]|0)==0){q=d[j+76+(d[n+1|0]|0)|0]|0}else{q=gta(a[n]|0,a[b+1|0]|0)|0}switch(q|0){case 7:{r=b;if((e-b|0)<4){p=53;break b}b=r+4|0;continue b;break};case 4:case 10:case 9:case 8:case 1:case 0:{p=55;break b;break};case 5:{s=b;if((e-b|0)<2){p=47;break b}b=s+2|0;continue b;break};case 6:{t=b;if((e-b|0)<3){p=50;break b}b=t+3|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==47){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==50){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==53){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==57){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function yta(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=0;k=e-b|0;if((k&1|0)!=0){k=k&-2;e=b+k|0}a:while(1){if((b|0)==(e|0)){l=39;break}k=b;if((a[b]|0)==0){m=d[j+76+(d[k+1|0]|0)|0]|0}else{m=gta(a[k]|0,a[b+1|0]|0)|0}switch(m|0){case 8:case 1:case 0:{l=17;break a;break};case 7:{if((e-b|0)<4){l=15;break a}b=b+4|0;continue a;break};case 2:{k=b+2|0;b=k;if((k|0)==(e|0)){l=19;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=33){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=23;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=91){continue a}g=g+1|0;b=b+2|0;continue a;break};case 4:{k=b+2|0;b=k;if((k|0)==(e|0)){l=28;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=93){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=32;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=62){continue a}b=b+2|0;if((g|0)==0){l=36;break a}g=g+ -1|0;continue a;break};case 5:{if((e-b|0)<2){l=9;break a}b=b+2|0;continue a;break};case 6:{if((e-b|0)<3){l=12;break a}b=b+3|0;continue a;break};default:{b=b+2|0;continue a}}}if((l|0)==9){n=-2;o=n;i=h;return o|0}else if((l|0)==12){n=-2;o=n;i=h;return o|0}else if((l|0)==15){n=-2;o=n;i=h;return o|0}else if((l|0)==17){c[f>>2]=b;n=0;o=n;i=h;return o|0}else if((l|0)==19){n=-1;o=n;i=h;return o|0}else if((l|0)==23){n=-1;o=n;i=h;return o|0}else if((l|0)==28){n=-1;o=n;i=h;return o|0}else if((l|0)==32){n=-1;o=n;i=h;return o|0}else if((l|0)==36){c[f>>2]=b;n=42;o=n;i=h;return o|0}else if((l|0)==39){n=-1;o=n;i=h;return o|0}return 0}function zta(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=33;break}o=b;if((a[m]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=gta(a[o]|0,a[b+1|0]|0)|0}switch(p|0){case 2:{n=15;break a;break};case 9:{n=19;break a;break};case 7:{b=b+4|0;continue a;break};case 10:{n=16;break a;break};case 6:{b=b+3|0;continue a;break};case 21:{n=29;break a;break};case 5:{b=b+2|0;continue a;break};case 3:{n=12;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=Mta(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==16){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==19){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b]|0)==0){q=d[j+76+(d[e+1|0]|0)|0]|0}else{q=gta(a[e]|0,a[b+1|0]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==29){q=b;if((b|0)==(g|0)){c[f>>2]=q+2;k=39;l=k;i=h;return l|0}else{c[f>>2]=q;k=6;l=k;i=h;return l|0}}else if((n|0)==33){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function Ata(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=32;break}o=b;if((a[m]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=gta(a[o]|0,a[b+1|0]|0)|0}switch(p|0){case 3:{n=12;break a;break};case 30:{n=15;break a;break};case 6:{b=b+3|0;continue a;break};case 7:{b=b+4|0;continue a;break};case 5:{b=b+2|0;continue a;break};case 10:{n=18;break a;break};case 9:{n=21;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=Mta(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){if((b|0)==(g|0)){p=Nta(j,b+2|0,e,f)|0;k=(p|0)==22?0:p;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==18){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==21){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b]|0)==0){q=d[j+76+(d[e+1|0]|0)|0]|0}else{q=gta(a[e]|0,a[b+1|0]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function Bta(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){e=b;if((a[b]|0)==0){h=d[g+76+(d[e+1|0]|0)|0]|0}else{h=gta(a[e]|0,a[b+1|0]|0)|0}switch(h|0){case 7:{e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=7;break a}else{k=8}break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{j=c;c=j+1|0;e=b;b=e+1|0;if((a[j]|0)!=(a[e]|0)){k=15;break a}e=c;c=e+1|0;j=b;b=j+1|0;if((a[e]|0)!=(a[j]|0)){k=17;break a}else{continue a}break};case 5:{break};case 6:{k=8;break};default:{k=18;break a}}if((k|0)==8){k=0;j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=9;break}}e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=11;break}j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=13;break}}if((k|0)==7){l=0;m=l;i=f;return m|0}else if((k|0)==9){l=0;m=l;i=f;return m|0}else if((k|0)==11){l=0;m=l;i=f;return m|0}else if((k|0)==13){l=0;m=l;i=f;return m|0}else if((k|0)==15){l=0;m=l;i=f;return m|0}else if((k|0)==17){l=0;m=l;i=f;return m|0}else if((k|0)==18){k=c;if((a[c]|0)==0){n=d[g+76+(d[k+1|0]|0)|0]|0}else{n=gta(a[k]|0,a[c+1|0]|0)|0}switch(n|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{l=0;m=l;i=f;return m|0};default:{l=1;m=l;i=f;return m|0}}}return 0}function Cta(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=9;break}if(g){h=4;break}if((a[f]|0)!=0){h=7;break}if((a[f+1|0]|0)!=(a[d]|0)){h=7;break}f=f+2|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==7){j=0;k=j;i=b;return k|0}else if((h|0)==9){j=g&1;k=j;i=b;return k|0}return 0}function Dta(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;e=i;i=i+24|0;f=b;b=c;c=b;a:while(1){g=b;if((a[b]|0)==0){h=d[f+76+(d[g+1|0]|0)|0]|0}else{h=gta(a[g]|0,a[b+1|0]|0)|0}switch(h|0){case 5:{b=b+2|0;continue a;break};case 7:{b=b+4|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{b=b+2|0;continue a;break};case 6:{b=b+3|0;continue a;break};default:{break a}}}i=e;return b-c|0}function Eta(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=c;while(1){c=b;if((a[b]|0)==0){g=d[f+76+(d[c+1|0]|0)|0]|0}else{g=gta(a[c]|0,a[b+1|0]|0)|0}if(!((g|0)==21|(g|0)==9|(g|0)==10)){break}b=b+2|0}i=e;return b|0}function Fta(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+2|0;a:while(1){m=b;if((a[b]|0)==0){n=d[j+76+(d[m+1|0]|0)|0]|0}else{n=gta(a[m]|0,a[b+1|0]|0)|0}b:do{switch(n|0){case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b]|0)==0){o=a[b+1|0]|0}else{o=-1}if((o|0)!=32){break}if((a[b+2|0]|0)==0){p=a[b+3|0]|0}else{p=-1}if((p|0)==32){break}m=b+2|0;if((a[b+2|0]|0)==0){q=d[j+76+(d[m+1|0]|0)|0]|0}else{q=gta(a[m]|0,a[b+3|0]|0)|0}if((q|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};default:{}}}while(0);b=b+2|0}i=h;return k|0}function Gta(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=c;c=0;d=d+4|0;a:do{if((a[d]|0)==0){if((a[d+1|0]|0)!=120){e=16;break}d=d+2|0;while(1){if((a[d]|0)==0){f=(a[d+1|0]|0)==59}else{f=0}if(!(f^1)){break a}if((a[d]|0)==0){g=a[d+1|0]|0}else{g=-1}h=g;switch(h|0){case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|h-48;break};case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(h-97))|0;break};case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(h-65))|0;break};default:{}}if((c|0)>=1114112){break}d=d+2|0}j=-1;k=j;i=b;return k|0}else{e=16}}while(0);b:do{if((e|0)==16){while(1){e=0;if((a[d]|0)==0){l=(a[d+1|0]|0)==59}else{l=0}if(!(l^1)){break b}if((a[d]|0)==0){m=a[d+1|0]|0}else{m=-1}c=c*10|0;c=c+(m-48)|0;if((c|0)>=1114112){break}d=d+2|0;e=16}j=-1;k=j;i=b;return k|0}}while(0);j=usa(c)|0;k=j;i=b;return k|0}function Hta(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;e=c;c=(d-e|0)/2|0;do{if((c|0)==2){if((a[e+2|0]|0)!=0){break}if((a[e+3|0]|0)!=116){break}if((a[e]|0)==0){f=a[e+1|0]|0}else{f=-1}if((f|0)==108){g=60;h=g;i=b;return h|0}else if((f|0)==103){g=62;h=g;i=b;return h|0}else{break}}else if((c|0)==3){if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=97){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=109){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=112){break}g=38;h=g;i=b;return h|0}else if((c|0)==4){if((a[e]|0)==0){j=a[e+1|0]|0}else{j=-1}if((j|0)==113){e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=117){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=111){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=116){break}g=34;h=g;i=b;return h|0}else if((j|0)==97){e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=112){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=111){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=115){break}g=39;h=g;i=b;return h|0}else{break}}}while(0);g=0;h=g;i=b;return h|0}function Ita(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=b;b=e;e=f;f=g;while(1){if(!(b>>>0<e>>>0)){break}g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=gta(a[g]|0,a[b+1|0]|0)|0}switch(k|0){case 5:{b=b+2|0;break};case 7:{b=b+4|0;break};case 10:{c[f+4>>2]=-1;g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;break};case 6:{b=b+3|0;break};case 9:{g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;do{if((b|0)!=(e|0)){g=b;if((a[b]|0)==0){l=d[j+76+(d[g+1|0]|0)|0]|0}else{l=gta(a[g]|0,a[b+1|0]|0)|0}if((l|0)!=10){break}b=b+2|0}}while(0);c[f+4>>2]=-1;break};default:{b=b+2|0}}g=f+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}function Jta(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+2|0;e=e+ -2|0;a:while(1){if((b|0)==(e|0)){k=18;break}g=b;if((a[b]|0)==0){l=d[j+76+(d[g+1|0]|0)|0]|0}else{l=gta(a[g]|0,a[b+1|0]|0)|0}b:do{switch(l|0){case 22:case 26:{if((a[b]|0)==0){m=a[b+1|0]|0}else{m=-1}if((m&-128|0)!=0){k=13}break};case 21:{if((a[b]|0)!=0){break b}if((a[b+1|0]|0)==9){k=9;break a}break};case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};default:{k=13}}}while(0);if((k|0)==13){k=0;if((a[b]|0)==0){n=a[b+1|0]|0}else{n=-1}if(!((n|0)==64|(n|0)==36)){k=16;break}}b=b+2|0}if((k|0)==9){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==16){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==18){o=1;p=o;i=h;return p|0}return 0}function Kta(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+80|0;h=d;d=e;e=f;f=g;g=c[h>>2]|0;a:while(1){j=g;if((g|0)==(d|0)){k=18;break}l=a[j+1|0]|0;m=a[g]|0;b:do{switch(m&255|0){case 219:case 218:case 217:case 216:{if((f-(c[e>>2]|0)|0)<4){k=15;break a}n=((m&3)<<2|(l&255)>>6&3)+1|0;o=e;p=c[o>>2]|0;c[o>>2]=p+1;a[p]=n>>2|240;p=e;o=c[p>>2]|0;c[p>>2]=o+1;a[o]=(l&255)>>2&15|(n&3)<<4|128;g=g+2|0;n=a[g+1|0]|0;o=((l&3)<<4|(a[g]&3)<<2|(n&255)>>6|128)&255;p=e;q=c[p>>2]|0;c[p>>2]=q+1;a[q]=o;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=n&63|128;break};case 0:{if((l&255|0)>=128){k=8;break b}if((c[e>>2]|0)==(f|0)){k=6;break a}n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=l;break};case 7:case 6:case 5:case 4:case 3:case 2:case 1:{k=8;break};default:{if((f-(c[e>>2]|0)|0)<3){k=12;break a}q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=(m&255)>>4|224;n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=(m&15)<<2|(l&255)>>6|128;q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=l&63|128}}}while(0);if((k|0)==8){k=0;if((f-(c[e>>2]|0)|0)<2){k=9;break}n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=(l&255)>>6|(m&255)<<2|192;q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=l&63|128}g=g+2|0}if((k|0)==6){c[h>>2]=g;i=b;return}else if((k|0)==9){c[h>>2]=g;i=b;return}else if((k|0)==12){c[h>>2]=g;i=b;return}else if((k|0)==15){c[h>>2]=g;i=b;return}else if((k|0)==18){c[h>>2]=j;i=b;return}}function Lta(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;e=i;i=i+40|0;k=f;f=g;g=h;h=j;do{if((f-(c[k>>2]|0)|0)>(((h-(c[g>>2]|0)|0)/2|0)<<1|0)){if((a[f+ -2|0]&248|0)!=216){break}f=f+ -2|0}}while(0);while(1){if((c[k>>2]|0)==(f|0)){l=7;break}if((c[g>>2]|0)==(h|0)){l=7;break}j=((d[c[k>>2]|0]|0)<<8|(d[(c[k>>2]|0)+1|0]|0))&65535;m=g;n=c[m>>2]|0;c[m>>2]=n+2;b[n>>1]=j;j=k;c[j>>2]=(c[j>>2]|0)+2}if((l|0)==7){i=e;return}}function Mta(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=gta(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[197496+((d[197240+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 19:{k=Ota(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 24:case 22:{break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=gta(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 7:{n=35;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 6:{n=32;break b;break};case 18:{n=38;break b;break};case 29:{if((c[197496+((d[198776+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=27;break b}break};case 5:{n=29;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=9;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function Nta(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=gta(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 30:case 9:case 10:case 21:{c[f>>2]=b;k=22;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[197496+((d[197240+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 24:case 22:{break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=gta(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 5:{n=29;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[197496+((d[198776+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=27;break b}break};case 7:{n=35;break b;break};case 18:{n=38;break b;break};case 6:{n=32;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=28;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function Ota(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b]|0)==0){if((a[b+1|0]|0)!=120){break}k=Pta(j,b+2|0,e,f)|0;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=gta(a[g]|0,a[b+1|0]|0)|0}g=b;if((m|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=gta(a[g]|0,a[b+1|0]|0)|0}if((n|0)==18){o=16;break}else if((n|0)!=25){o=17;break}b=b+2|0}if((o|0)==16){c[f>>2]=b+2;k=10;l=k;i=h;return l|0}else if((o|0)==17){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function Pta(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=gta(a[g]|0,a[b+1|0]|0)|0}g=b;if(!((k+ -24|0)>>>0<2)){c[f>>2]=g;l=0;m=l;i=h;return m|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=gta(a[g]|0,a[b+1|0]|0)|0}if((n|0)==18){o=13;break}else if(!((n|0)==24|(n|0)==25)){o=14;break}b=b+2|0}if((o|0)==13){c[f>>2]=b+2;l=10;m=l;i=h;return m|0}else if((o|0)==14){c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);l=-1;m=l;i=h;return m|0}function Qta(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=gta(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[197496+((d[197240+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 16:{g=b+2|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=gta(a[g]|0,a[b+1|0]|0)|0}if((n|0)==27){k=Rta(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((n|0)==20){k=Sta(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 15:{k=Tta(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 17:{k=Uta(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;n=0;b:while(1){if((b|0)==(e|0)){o=98;break}m=b;if((a[b]|0)==0){p=d[j+76+(d[m+1|0]|0)|0]|0}else{p=gta(a[m]|0,a[b+1|0]|0)|0}switch(p|0){case 10:case 9:case 21:{o=69;break b;break};case 17:{break b;break};case 11:{o=90;break b;break};case 29:{if((c[197496+((d[198776+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=37;break b}break};case 5:{o=39;break b;break};case 6:{o=42;break b;break};case 7:{o=45;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 23:{if((n|0)!=0){o=49;break b}n=1;b=b+2|0;if((b|0)==(e|0)){o=51;break b}m=b;if((a[b]|0)==0){q=d[j+76+(d[m+1|0]|0)|0]|0}else{q=gta(a[m]|0,a[b+1|0]|0)|0}switch(q|0){case 24:case 22:{break};case 6:{o=62;break b;break};case 5:{o=59;break b;break};case 7:{o=65;break b;break};case 29:{if((c[197496+((d[197240+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=57;break b}break};default:{o=68;break b}}b=b+2|0;continue b;break};default:{o=97;break b}}b=b+2|0}c:do{if((o|0)==37){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==39){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==42){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==45){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==51){k=-1;l=k;i=h;return l|0}else if((o|0)==57){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==59){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==62){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==65){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==68){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==69){b=b+2|0;d:while(1){if((b|0)==(e|0)){o=89;break}q=b;if((a[b]|0)==0){r=d[j+76+(d[q+1|0]|0)|0]|0}else{r=gta(a[q]|0,a[b+1|0]|0)|0}switch(r|0){case 17:{break c;break};case 5:{o=78;break d;break};case 7:{o=84;break d;break};case 11:{o=90;break c;break};case 6:{o=81;break d;break};case 10:case 9:case 21:{break};case 29:{o=75;break d;break};case 24:case 22:{break d;break};default:{o=88;break d}}b=b+2|0}do{if((o|0)==75){if((c[197496+((d[197240+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==81){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==84){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==89){k=-1;l=k;i=h;return l|0}}while(0);b=b+2|0;k=Vta(j,b,e,f)|0;l=k;i=h;return l|0}else if((o|0)==97){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==98){k=-1;l=k;i=h;return l|0}}while(0);if((o|0)==90){c[f>>2]=b+2;k=2;l=k;i=h;return l|0}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=4;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=0;l=k;i=h;return l|0}function Rta(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b]|0)==0){if((a[b+1|0]|0)!=45){break}b=b+2|0;b:while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=gta(a[g]|0,a[b+1|0]|0)|0}switch(k|0){case 8:case 1:case 0:{l=20;break b;break};case 6:{if((e-b|0)<3){l=15;break b}b=b+3|0;continue b;break};case 7:{if((e-b|0)<4){l=18;break b}b=b+4|0;continue b;break};case 5:{if((e-b|0)<2){l=12;break b}b=b+2|0;continue b;break};case 27:{g=b+2|0;b=g;if((g|0)==(e|0)){l=22;break b}if((a[b]|0)!=0){continue b}if((a[b+1|0]|0)==45){l=25;break b}else{continue b}break};default:{b=b+2|0;continue b}}}if((l|0)==12){m=-2;n=m;i=h;return n|0}else if((l|0)==15){m=-2;n=m;i=h;return n|0}else if((l|0)==18){m=-2;n=m;i=h;return n|0}else if((l|0)==20){c[f>>2]=b;m=0;n=m;i=h;return n|0}else if((l|0)==22){m=-1;n=m;i=h;return n|0}else if((l|0)==25){g=b+2|0;b=g;if((g|0)==(e|0)){m=-1;n=m;i=h;return n|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;m=13;n=m;i=h;return n|0}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}while(0);m=-1;n=m;i=h;return n|0}function Sta(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<12){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=9;break}if((a[k]|0)!=0){l=7;break}if((a[g+1|0]|0)!=(a[199816+e|0]|0)){l=7;break}e=e+1|0;g=g+2|0}if((l|0)==7){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==9){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function Tta(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}n=b;if((a[b]|0)==0){o=d[k+76+(d[n+1|0]|0)|0]|0}else{o=gta(a[n]|0,a[b+1|0]|0)|0}a:do{switch(o|0){case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 29:{if((c[197496+((d[197240+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;l=0;m=l;i=h;return m|0};case 24:case 22:{break};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){p=70;break}o=b;if((a[b]|0)==0){q=d[k+76+(d[o+1|0]|0)|0]|0}else{q=gta(a[o]|0,a[b+1|0]|0)|0}switch(q|0){case 7:{p=34;break b;break};case 10:case 9:case 21:{p=37;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[197496+((d[198776+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){p=26;break b}break};case 5:{p=28;break b;break};case 6:{p=31;break b;break};case 15:{p=62;break b;break};default:{break b}}b=b+2|0}do{if((p|0)==26){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==28){if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==31){if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==34){if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==37){q=b;if((Wta(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;c:while(1){if((b|0)==(e|0)){p=61;break}q=b;if((a[b]|0)==0){r=d[k+76+(d[q+1|0]|0)|0]|0}else{r=gta(a[q]|0,a[b+1|0]|0)|0}switch(r|0){case 15:{b=b+2|0;if((b|0)==(e|0)){p=56;break c}if((a[b]|0)!=0){continue c}if((a[b+1|0]|0)==62){p=59;break c}else{continue c}break};case 7:{if((e-b|0)<4){p=52;break c}b=b+4|0;continue c;break};case 5:{if((e-b|0)<2){p=46;break c}b=b+2|0;continue c;break};case 6:{if((e-b|0)<3){p=49;break c}b=b+3|0;continue c;break};case 8:case 1:case 0:{p=54;break c;break};default:{b=b+2|0;continue c}}}if((p|0)==46){l=-2;m=l;i=h;return m|0}else if((p|0)==49){l=-2;m=l;i=h;return m|0}else if((p|0)==52){l=-2;m=l;i=h;return m|0}else if((p|0)==54){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==56){l=-1;m=l;i=h;return m|0}else if((p|0)==59){c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==61){l=-1;m=l;i=h;return m|0}}else if((p|0)==62){q=b;if((Wta(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b]|0)!=0){break}if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==70){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function Uta(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=gta(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[197496+((d[197240+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 24:case 22:{break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=50;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=gta(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 11:{n=48;break b;break};case 5:{n=28;break b;break};case 23:{b=b+2|0;continue b;break};case 29:{if((c[197496+((d[198776+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=26;break b}break};case 6:{n=31;break b;break};case 7:{n=34;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 10:case 9:case 21:{n=37;break b;break};default:{n=49;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){b=b+2|0;while(1){if((b|0)==(e|0)){n=46;break}o=b;if((a[b]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=gta(a[o]|0,a[b+1|0]|0)|0}if((p|0)==11){n=43;break}else if(!((p|0)==10|(p|0)==9|(p|0)==21)){n=44;break}b=b+2|0}if((n|0)==43){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==44){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==46){k=-1;l=k;i=h;return l|0}}else if((n|0)==48){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==50){k=-1;l=k;i=h;return l|0}return 0}function Vta(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=115;break}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){m=d[k+76+(d[b+1|0]|0)|0]|0}else{m=gta(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}b:do{switch(m|0){case 27:case 26:case 25:case 24:case 22:{l=9;break};case 29:{if((c[197496+((d[198776+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)!=0){l=9}else{l=8;break a}break};case 14:{break};case 5:{l=10;break a;break};case 23:{if((g|0)!=0){l=20;break a}g=1;c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=22;break a}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){n=d[k+76+(d[b+1|0]|0)|0]|0}else{n=gta(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(n|0){case 29:{if((c[197496+((d[197240+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)==0){l=28;break a}break};case 5:{l=30;break a;break};case 6:{l=33;break a;break};case 7:{l=36;break a;break};case 24:case 22:{break};default:{l=39;break a}}c[j>>2]=(c[j>>2]|0)+2;continue a;break};case 6:{l=13;break a;break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=41;break a}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){o=d[k+76+(d[b+1|0]|0)|0]|0}else{o=gta(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}b=o;if((b|0)==14){break b}p=b;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=47;break a}}break};case 7:{l=16;break a;break};default:{l=114;break a}}}while(0);if((l|0)==9){l=0;c[j>>2]=(c[j>>2]|0)+2;continue}g=0;while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=50;break a}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){q=d[k+76+(d[p+1|0]|0)|0]|0}else{q=gta(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}r=q;if((r|0)==12|(r|0)==13){break}p=r;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=56;break a}}c[j>>2]=(c[j>>2]|0)+2;c:while(1){if((c[j>>2]|0)==(e|0)){l=59;break a}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){s=d[k+76+(d[p+1|0]|0)|0]|0}else{s=gta(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}p=s;if((p|0)==(r|0)){break}switch(p|0){case 3:{t=Mta(k,(c[j>>2]|0)+2|0,e,j)|0;if((t|0)<=0){l=76;break a}else{continue c}break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=69;break a}c[j>>2]=(c[j>>2]|0)+3;continue c;break};case 8:case 1:case 0:{l=74;break a;break};case 2:{l=79;break a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=66;break a}c[j>>2]=(c[j>>2]|0)+2;continue c;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=72;break a}c[j>>2]=(c[j>>2]|0)+4;continue c;break};default:{c[j>>2]=(c[j>>2]|0)+2;continue c}}}c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=82;break}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){u=d[k+76+(d[p+1|0]|0)|0]|0}else{u=gta(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(u|0){case 10:case 9:case 21:{break};case 17:{l=107;break a;break};case 11:{l=106;break a;break};default:{l=87;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=89;break a}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){v=d[k+76+(d[p+1|0]|0)|0]|0}else{v=gta(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(v|0){case 6:{l=100;break a;break};case 10:case 9:case 21:{break};case 7:{l=103;break a;break};case 5:{l=97;break a;break};case 17:{l=107;break a;break};case 24:case 22:{break d;break};case 11:{l=106;break a;break};case 29:{l=94;break d;break};default:{l=113;break a}}}if((l|0)==94){l=0;if((c[197496+((d[197240+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)==0){l=95;break}}c[j>>2]=(c[j>>2]|0)+2}if((l|0)==8){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==10){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==13){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==16){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==20){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==22){w=-1;x=w;i=h;return x|0}else if((l|0)==28){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==30){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==33){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==36){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==39){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==41){w=-1;x=w;i=h;return x|0}else if((l|0)==47){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==50){w=-1;x=w;i=h;return x|0}else if((l|0)==56){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==59){w=-1;x=w;i=h;return x|0}else if((l|0)==66){w=-2;x=w;i=h;return x|0}else if((l|0)==69){w=-2;x=w;i=h;return x|0}else if((l|0)==72){w=-2;x=w;i=h;return x|0}else if((l|0)==74){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==76){if((t|0)==0){c[f>>2]=c[j>>2]}w=t;x=w;i=h;return x|0}else if((l|0)==79){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==82){w=-1;x=w;i=h;return x|0}else if((l|0)==87){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==89){w=-1;x=w;i=h;return x|0}else if((l|0)==95){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==97){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==100){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==103){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+2;w=1;x=w;i=h;return x|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){w=-1;x=w;i=h;return x|0}do{if((a[c[j>>2]|0]|0)==0){if((a[(c[j>>2]|0)+1|0]|0)!=62){break}c[f>>2]=(c[j>>2]|0)+2;w=3;x=w;i=h;return x|0}}while(0);c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==113){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==114){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==115){w=-1;x=w;i=h;return x|0}return 0}function Wta(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;if((e-g|0)!=6){h=1;j=h;i=b;return j|0}if((a[g]|0)==0){k=a[g+1|0]|0}else{k=-1}if((k|0)==88){f=1}else if((k|0)!=120){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g]|0)==0){l=a[g+1|0]|0}else{l=-1}if((l|0)==77){f=1}else if((l|0)!=109){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g]|0)==0){m=a[g+1|0]|0}else{m=-1}if((m|0)==76){f=1}else if((m|0)!=108){h=1;j=h;i=b;return j|0}if((f|0)!=0){h=0;j=h;i=b;return j|0}else{c[d>>2]=12;h=1;j=h;i=b;return j|0}return 0}function Xta(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+56|0;k=b;b=e;e=f;f=g;g=h;a:while(1){if((e|0)==(f|0)){l=27;break}h=e;if((a[e]|0)==0){m=d[b+76+(d[h+1|0]|0)|0]|0}else{m=gta(a[h]|0,a[e+1|0]|0)|0}h=m;switch(h|0){case 6:{if((f-e|0)<3){l=11;break a}e=e+3|0;continue a;break};case 13:case 12:{e=e+2|0;if((h|0)!=(k|0)){continue a}else{l=18;break a}break};case 8:case 1:case 0:{l=16;break a;break};case 7:{if((f-e|0)<4){l=14;break a}e=e+4|0;continue a;break};case 5:{if((f-e|0)<2){l=8;break a}e=e+2|0;continue a;break};default:{e=e+2|0;continue a}}}if((l|0)==8){n=-2;o=n;i=j;return o|0}else if((l|0)==11){n=-2;o=n;i=j;return o|0}else if((l|0)==14){n=-2;o=n;i=j;return o|0}else if((l|0)==16){c[g>>2]=e;n=0;o=n;i=j;return o|0}else if((l|0)==18){if((e|0)==(f|0)){n=-27;o=n;i=j;return o|0}c[g>>2]=e;g=e;if((a[e]|0)==0){p=d[b+76+(d[g+1|0]|0)|0]|0}else{p=gta(a[g]|0,a[e+1|0]|0)|0}switch(p|0){case 20:case 30:case 11:case 10:case 9:case 21:{n=27;o=n;i=j;return o|0};default:{n=0;o=n;i=j;return o|0}}}else if((l|0)==27){n=-1;o=n;i=j;return o|0}return 0}function Yta(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=gta(a[g]|0,a[b+1|0]|0)|0}if((m|0)==27){k=Rta(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=b+2;k=33;l=k;i=h;return l|0}else if((m|0)==24|(m|0)==22){b=b+2|0;a:while(1){if((b|0)==(e|0)){n=26;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=gta(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 30:{n=16;break a;break};case 10:case 9:case 21:{break a;break};case 24:case 22:{break};default:{n=25;break a}}b=b+2|0}do{if((n|0)==16){if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}o=b+2|0;if((a[b+2|0]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=gta(a[o]|0,a[b+3|0]|0)|0}if(!((p|0)==30|(p|0)==10|(p|0)==9|(p|0)==21)){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==25){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==26){k=-1;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=16;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}return 0}function Zta(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=gta(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 24:case 22:{break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[197496+((d[197240+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=39;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=gta(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 36:case 30:case 11:case 32:case 21:case 10:case 9:{n=37;break b;break};case 29:{if((c[197496+((d[198776+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=26;break b}break};case 6:{n=31;break b;break};case 5:{n=28;break b;break};case 7:{n=34;break b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{n=38;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){c[f>>2]=b;k=20;l=k;i=h;return l|0}else if((n|0)==38){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==39){k=-20;l=k;i=h;return l|0}return 0}function _ta(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 20:{c[f>>2]=b+1;k=25;l=k;i=h;return l|0};case 35:{c[f>>2]=b+1;k=38;l=k;i=h;return l|0};case 23:case 27:case 26:case 25:{m=19;b=b+1|0;break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}if((De[c[j+352>>2]&63](j,b)|0)!=0){b=b+4|0;m=18;break a}g=b;if((De[c[j+340>>2]&63](j,b)|0)!=0){b=g+4|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 24:case 22:{m=18;b=b+1|0;break};case 19:{k=Kua(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}if((De[c[j+348>>2]&63](j,b)|0)!=0){b=b+3|0;m=18;break a}g=b;if((De[c[j+336>>2]&63](j,b)|0)!=0){b=g+3|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 31:{c[f>>2]=b+1;k=23;l=k;i=h;return l|0};case 9:{if((b+1|0)!=(e|0)){n=15;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 32:{b=b+1|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}switch(d[j+76+(d[b]|0)|0]|0){case 34:{c[f>>2]=b+1;k=37;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 33:{c[f>>2]=b+1;k=36;l=k;i=h;return l|0};case 15:{c[f>>2]=b+1;k=35;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 10:case 21:{n=15;break};case 36:{c[f>>2]=b+1;k=21;l=k;i=h;return l|0};case 30:{k=yua(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}if((De[c[j+344>>2]&63](j,b)|0)!=0){b=b+2|0;m=18;break a}g=b;if((De[c[j+332>>2]&63](j,b)|0)!=0){b=g+2|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 2:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}switch(d[j+76+(d[b]|0)|0]|0){case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -1;k=29;l=k;i=h;return l|0};case 16:{k=Jua(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 15:{k=Eua(j,b+1|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 11:{c[f>>2]=b+1;k=17;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b]|0)==93){if((b+1|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 12:{k=Iua(12,j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 13:{k=Iua(13,j,b+1|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);if((n|0)==15){while(1){n=0;b=b+1|0;o=b;if((b|0)==(e|0)){n=19;break}g=d[j+76+(d[o]|0)|0]|0;if((g|0)==10|(g|0)==21){n=15;continue}else if((g|0)!=9){n=18;break}if((b+1|0)!=(e|0)){n=15}else{n=18;break}}if((n|0)==18){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((n|0)==19){c[f>>2]=o;k=15;l=k;i=h;return l|0}}b:while(1){if((b|0)==(e|0)){n=120;break}switch(d[j+76+(d[b]|0)|0]|0){case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 23:{b=b+1|0;o=m;if((o|0)==41){m=19;continue b}else if((o|0)!=18){continue b}if((b|0)==(e|0)){n=89;break b}m=41;switch(d[j+76+(d[b]|0)|0]|0){case 5:{if((e-b|0)<2){n=94;break b}p=b;if((De[c[j+332>>2]&63](j,b)|0)==0){n=96;break b}b=p+2|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 6:{if((e-b|0)<3){n=99;break b}q=b;if((De[c[j+336>>2]&63](j,b)|0)==0){n=101;break b}b=q+3|0;continue b;break};case 7:{if((e-b|0)<4){n=104;break b}r=b;if((De[c[j+340>>2]&63](j,b)|0)==0){n=106;break b}b=r+4|0;continue b;break};case 29:{n=91;break b;break};default:{m=19;continue b}}break};case 5:{if((e-b|0)<2){n=72;break b}s=b;if((De[c[j+332>>2]&63](j,b)|0)==0){n=74;break b}b=s+2|0;continue b;break};case 7:{if((e-b|0)<4){n=82;break b}t=b;if((De[c[j+340>>2]&63](j,b)|0)==0){n=84;break b}b=t+4|0;continue b;break};case 29:{n=69;break b;break};case 33:{n=113;break b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{n=86;break b;break};case 15:{n=116;break b;break};case 34:{n=110;break b;break};case 6:{if((e-b|0)<3){n=77;break b}u=b;if((De[c[j+336>>2]&63](j,b)|0)==0){n=79;break b}b=u+3|0;continue b;break};default:{n=119;break b}}}if((n|0)==69){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==72){k=-2;l=k;i=h;return l|0}else if((n|0)==74){c[f>>2]=s;k=0;l=k;i=h;return l|0}else if((n|0)==77){k=-2;l=k;i=h;return l|0}else if((n|0)==79){c[f>>2]=u;k=0;l=k;i=h;return l|0}else if((n|0)==82){k=-2;l=k;i=h;return l|0}else if((n|0)==84){c[f>>2]=t;k=0;l=k;i=h;return l|0}else if((n|0)==86){c[f>>2]=b;k=m;l=k;i=h;return l|0}else if((n|0)==89){k=-1;l=k;i=h;return l|0}else if((n|0)==91){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==94){k=-2;l=k;i=h;return l|0}else if((n|0)==96){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((n|0)==99){k=-2;l=k;i=h;return l|0}else if((n|0)==101){c[f>>2]=q;k=0;l=k;i=h;return l|0}else if((n|0)==104){k=-2;l=k;i=h;return l|0}else if((n|0)==106){c[f>>2]=r;k=0;l=k;i=h;return l|0}else if((n|0)==110){r=b;if((m|0)==19){c[f>>2]=r;k=0;l=k;i=h;return l|0}else{c[f>>2]=r+1;k=32;l=k;i=h;return l|0}}else if((n|0)==113){r=b;if((m|0)==19){c[f>>2]=r;k=0;l=k;i=h;return l|0}else{c[f>>2]=r+1;k=31;l=k;i=h;return l|0}}else if((n|0)==116){r=b;if((m|0)==19){c[f>>2]=r;k=0;l=k;i=h;return l|0}else{c[f>>2]=r+1;k=30;l=k;i=h;return l|0}}else if((n|0)==119){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==120){k=0-m|0;l=k;i=h;return l|0}return 0}function $ta(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((De[c[j+356>>2]&63](j,b)|0)==0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b]|0)!=93){break a}b=b+1|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}g=b;if((a[b]|0)!=62){b=g+ -1|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((De[c[j+364>>2]&63](j,b)|0)==0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 9:{b=b+1|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}if((d[j+76+(d[b]|0)|0]|0)==10){b=b+1|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((De[c[j+360>>2]&63](j,b)|0)==0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 2:{k=Bua(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+1;k=7;l=k;i=h;return l|0};case 3:{k=xua(j,b+1|0,e,f)|0;l=k;i=h;return l|0};default:{b=b+1|0}}}while(0);b:while(1){m=b;if((b|0)==(e|0)){n=60;break}switch(d[j+76+(d[m]|0)|0]|0){case 6:{if((e-b|0)<3){n=45;break b}if((De[c[j+360>>2]&63](j,b)|0)!=0){n=45;break b}b=b+3|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{n=58;break b;break};case 5:{if((e-b|0)<2){n=41;break b}if((De[c[j+356>>2]&63](j,b)|0)!=0){n=41;break b}b=b+2|0;continue b;break};case 7:{if((e-b|0)<4){n=49;break b}if((De[c[j+364>>2]&63](j,b)|0)!=0){n=49;break b}b=b+4|0;continue b;break};case 4:{if((b+1|0)==(e|0)){n=58;break b}g=b;if((a[b+1|0]|0)!=93){b=g+1|0;continue b}if((g+2|0)==(e|0)){n=58;break b}o=b;if((a[b+2|0]|0)==62){n=57;break b}b=o+1|0;continue b;break};default:{b=b+1|0;continue b}}}if((n|0)==41){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==45){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==57){c[f>>2]=o+2;k=0;l=k;i=h;return l|0}else if((n|0)==58){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==60){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function aua(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((De[c[j+360>>2]&63](j,b)|0)==0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((De[c[j+356>>2]&63](j,b)|0)==0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+1;k=7;l=k;i=h;return l|0};case 9:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((d[j+76+(d[b]|0)|0]|0)==10){b=b+1|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b]|0)!=93){break a}b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)!=62){b=g+ -1|0;break a}c[f>>2]=g+1;k=40;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((De[c[j+364>>2]&63](j,b)|0)==0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};default:{b=b+1|0}}}while(0);b:while(1){m=b;if((b|0)==(e|0)){n=51;break}switch(d[j+76+(d[m]|0)|0]|0){case 4:case 10:case 9:case 8:case 1:case 0:{n=49;break b;break};case 6:{if((e-b|0)<3){n=43;break b}if((De[c[j+360>>2]&63](j,b)|0)!=0){n=43;break b}b=b+3|0;continue b;break};case 7:{if((e-b|0)<4){n=47;break b}if((De[c[j+364>>2]&63](j,b)|0)!=0){n=47;break b}b=b+4|0;continue b;break};case 5:{if((e-b|0)<2){n=39;break b}if((De[c[j+356>>2]&63](j,b)|0)!=0){n=39;break b}b=b+2|0;continue b;break};default:{b=b+1|0;continue b}}}if((n|0)==39){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==43){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==47){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==51){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function bua(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;g=0;a:while(1){if((b|0)==(e|0)){k=37;break}switch(d[j+76+(d[b]|0)|0]|0){case 4:{l=b+1|0;b=l;if((l|0)==(e|0)){k=28;break a}if((a[b]|0)!=93){continue a}l=b+1|0;b=l;if((l|0)==(e|0)){k=31;break a}if((a[b]|0)!=62){continue a}b=b+1|0;if((g|0)==0){k=34;break a}g=g+ -1|0;continue a;break};case 5:{if((e-b|0)<2){k=5;break a}m=b;if((De[c[j+356>>2]&63](j,b)|0)!=0){k=7;break a}b=m+2|0;continue a;break};case 6:{if((e-b|0)<3){k=10;break a}n=b;if((De[c[j+360>>2]&63](j,b)|0)!=0){k=12;break a}b=n+3|0;continue a;break};case 8:case 1:case 0:{k=19;break a;break};case 2:{l=b+1|0;b=l;if((l|0)==(e|0)){k=21;break a}if((a[b]|0)!=33){continue a}l=b+1|0;b=l;if((l|0)==(e|0)){k=24;break a}if((a[b]|0)!=91){continue a}g=g+1|0;b=b+1|0;continue a;break};case 7:{if((e-b|0)<4){k=15;break a}o=b;if((De[c[j+364>>2]&63](j,b)|0)!=0){k=17;break a}b=o+4|0;continue a;break};default:{b=b+1|0;continue a}}}if((k|0)==5){p=-2;q=p;i=h;return q|0}else if((k|0)==7){c[f>>2]=m;p=0;q=p;i=h;return q|0}else if((k|0)==10){p=-2;q=p;i=h;return q|0}else if((k|0)==12){c[f>>2]=n;p=0;q=p;i=h;return q|0}else if((k|0)==15){p=-2;q=p;i=h;return q|0}else if((k|0)==17){c[f>>2]=o;p=0;q=p;i=h;return q|0}else if((k|0)==19){c[f>>2]=b;p=0;q=p;i=h;return q|0}else if((k|0)==21){p=-1;q=p;i=h;return q|0}else if((k|0)==24){p=-1;q=p;i=h;return q|0}else if((k|0)==28){p=-1;q=p;i=h;return q|0}else if((k|0)==31){p=-1;q=p;i=h;return q|0}else if((k|0)==34){c[f>>2]=b;p=42;q=p;i=h;return q|0}else if((k|0)==37){p=-1;q=p;i=h;return q|0}return 0}function cua(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+48|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-4;k=j;i=g;return k|0}f=a;a:while(1){l=a;if((a|0)==(b|0)){m=27;break}switch(d[h+76+(d[l]|0)|0]|0|0){case 7:{a=a+4|0;continue a;break};case 10:{m=13;break a;break};case 3:{m=9;break a;break};case 9:{m=16;break a;break};case 2:{m=12;break a;break};case 6:{a=a+3|0;continue a;break};case 5:{a=a+2|0;continue a;break};case 21:{m=23;break a;break};default:{a=a+1|0;continue a}}}if((m|0)==9){if((a|0)==(f|0)){j=xua(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==12){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((m|0)==13){n=a;if((a|0)==(f|0)){c[e>>2]=n+1;j=7;k=j;i=g;return k|0}else{c[e>>2]=n;j=6;k=j;i=g;return k|0}}else if((m|0)==16){n=a;if((a|0)!=(f|0)){c[e>>2]=n;j=6;k=j;i=g;return k|0}a=n+1|0;if((a|0)==(b|0)){j=-3;k=j;i=g;return k|0}if((d[h+76+(d[a]|0)|0]|0|0)==10){a=a+1|0}c[e>>2]=a;j=7;k=j;i=g;return k|0}else if((m|0)==23){h=a;if((a|0)==(f|0)){c[e>>2]=h+1;j=39;k=j;i=g;return k|0}else{c[e>>2]=h;j=6;k=j;i=g;return k|0}}else if((m|0)==27){c[e>>2]=l;j=6;k=j;i=g;return k|0}return 0}function dua(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+56|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-4;k=j;i=g;return k|0}f=a;a:while(1){l=a;if((a|0)==(b|0)){m=26;break}switch(d[h+76+(d[l]|0)|0]|0|0){case 9:{m=18;break a;break};case 10:{m=15;break a;break};case 30:{m=12;break a;break};case 5:{a=a+2|0;continue a;break};case 3:{m=9;break a;break};case 6:{a=a+3|0;continue a;break};case 7:{a=a+4|0;continue a;break};default:{a=a+1|0;continue a}}}if((m|0)==9){if((a|0)==(f|0)){j=xua(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==12){if((a|0)==(f|0)){n=yua(h,a+1|0,b,e)|0;j=(n|0)==22?0:n;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==15){n=a;if((a|0)==(f|0)){c[e>>2]=n+1;j=7;k=j;i=g;return k|0}else{c[e>>2]=n;j=6;k=j;i=g;return k|0}}else if((m|0)==18){n=a;if((a|0)!=(f|0)){c[e>>2]=n;j=6;k=j;i=g;return k|0}a=n+1|0;if((a|0)==(b|0)){j=-3;k=j;i=g;return k|0}if((d[h+76+(d[a]|0)|0]|0|0)==10){a=a+1|0}c[e>>2]=a;j=7;k=j;i=g;return k|0}else if((m|0)==26){c[e>>2]=l;j=6;k=j;i=g;return k|0}return 0}function eua(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){switch(d[g+76+(d[b]|0)|0]|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:{e=c;c=e+1|0;h=b;b=h+1|0;if((a[e]|0)!=(a[h]|0)){j=12;break a}else{continue a}break};case 6:{j=5;break};case 5:{break};case 7:{h=b;b=h+1|0;e=c;c=e+1|0;if((a[h]|0)!=(a[e]|0)){j=4;break a}else{j=5}break};default:{j=13;break a}}if((j|0)==5){j=0;e=b;b=e+1|0;h=c;c=h+1|0;if((a[e]|0)!=(a[h]|0)){j=6;break}}h=b;b=h+1|0;e=c;c=e+1|0;if((a[h]|0)!=(a[e]|0)){j=8;break}e=b;b=e+1|0;h=c;c=h+1|0;if((a[e]|0)!=(a[h]|0)){j=10;break}}if((j|0)==4){k=0;l=k;i=f;return l|0}else if((j|0)==6){k=0;l=k;i=f;return l|0}else if((j|0)==8){k=0;l=k;i=f;return l|0}else if((j|0)==10){k=0;l=k;i=f;return l|0}else if((j|0)==12){k=0;l=k;i=f;return l|0}else if((j|0)==13){if((a[b]|0)==(a[c]|0)){k=1;l=k;i=f;return l|0}switch(d[g+76+(d[c]|0)|0]|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{k=0;l=k;i=f;return l|0};default:{k=1;l=k;i=f;return l|0}}}return 0}function fua(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=8;break}if(g){h=4;break}if((a[f]|0)!=(a[d]|0)){h=6;break}f=f+1|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==6){j=0;k=j;i=b;return k|0}else if((h|0)==8){j=g&1;k=j;i=b;return k|0}return 0}function gua(a,b){a=a|0;b=b|0;var c=0,e=0;c=i;i=i+24|0;e=a;a=b;b=a;a:while(1){switch(d[e+76+(d[a]|0)|0]|0|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:{a=a+1|0;continue a;break};case 6:{a=a+3|0;continue a;break};case 5:{a=a+2|0;continue a;break};case 7:{a=a+4|0;continue a;break};default:{break a}}}i=c;return a-b|0}function hua(a,b){a=a|0;b=b|0;var c=0,e=0;c=i;i=i+16|0;e=a;a=b;while(1){b=d[e+76+(d[a]|0)|0]|0;if(!((b|0)==21|(b|0)==9|(b|0)==10)){break}a=a+1|0}i=c;return a|0}function iua(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+1|0;a:while(1){b:do{switch(d[j+76+(d[b]|0)|0]|0){case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+1}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+3|0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+1}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b]|0)!=32){break}if((a[b+1|0]|0)==32){break}if((d[j+76+(d[b+1|0]|0)|0]|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};default:{}}}while(0);b=b+1|0}i=h;return k|0}function jua(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;b=i;i=i+48|0;d=c;c=0;d=d+2|0;a:do{if((a[d]|0)==120){d=d+1|0;while(1){if(!((a[d]|0)==59^1)){break a}e=a[d]|0;switch(e|0){case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(e-97))|0;break};case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(e-65))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|e-48;break};default:{}}if((c|0)>=1114112){break}d=d+1|0}f=-1;g=f;i=b;return g|0}else{while(1){if(!((a[d]|0)==59^1)){break a}c=c*10|0;c=c+((a[d]|0)-48)|0;if((c|0)>=1114112){break}d=d+1|0}f=-1;g=f;i=b;return g|0}}while(0);f=usa(c)|0;g=f;i=b;return g|0}function kua(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;b=i;i=i+32|0;e=c;c=(d-e|0)/1|0;do{if((c|0)==4){d=a[e]|0;if((d|0)==113){e=e+1|0;if((a[e]|0)!=117){break}e=e+1|0;if((a[e]|0)!=111){break}e=e+1|0;if((a[e]|0)!=116){break}f=34;g=f;i=b;return g|0}else if((d|0)==97){e=e+1|0;if((a[e]|0)!=112){break}e=e+1|0;if((a[e]|0)!=111){break}e=e+1|0;if((a[e]|0)!=115){break}f=39;g=f;i=b;return g|0}else{break}}else if((c|0)==2){if((a[e+1|0]|0)!=116){break}d=a[e]|0;if((d|0)==103){f=62;g=f;i=b;return g|0}else if((d|0)==108){f=60;g=f;i=b;return g|0}else{break}}else if((c|0)==3){if((a[e]|0)!=97){break}e=e+1|0;if((a[e]|0)!=109){break}e=e+1|0;if((a[e]|0)!=112){break}f=38;g=f;i=b;return g|0}}while(0);f=0;g=f;i=b;return g|0}function lua(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+32|0;h=a;a=b;b=e;e=f;while(1){if(!(a>>>0<b>>>0)){break}switch(d[h+76+(d[a]|0)|0]|0|0){case 5:{a=a+2|0;break};case 10:{c[e+4>>2]=-1;f=e;c[f>>2]=(c[f>>2]|0)+1;a=a+1|0;break};case 6:{a=a+3|0;break};case 7:{a=a+4|0;break};case 9:{f=e;c[f>>2]=(c[f>>2]|0)+1;a=a+1|0;do{if((a|0)!=(b|0)){if((d[h+76+(d[a]|0)|0]|0|0)!=10){break}a=a+1|0}}while(0);c[e+4>>2]=-1;break};default:{a=a+1|0}}f=e+4|0;c[f>>2]=(c[f>>2]|0)+1}i=g;return}function mua(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+1|0;e=e+ -1|0;a:while(1){if((b|0)==(e|0)){k=10;break}switch(d[j+76+(d[b]|0)|0]|0){case 22:case 26:{if((a[b]&-128|0)!=0){k=7}break};case 21:{if((a[b]|0)==9){k=5;break a}break};case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};default:{k=7}}if((k|0)==7){k=0;g=a[b]|0;if(!((g|0)==64|(g|0)==36)){k=8;break}}b=b+1|0}if((k|0)==5){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((k|0)==8){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((k|0)==10){l=1;m=l;i=h;return m|0}return 0}function nua(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;b=i;i=i+56|0;h=d;d=e;e=f;f=g;a:do{if((d-(c[h>>2]|0)|0)>(f-(c[e>>2]|0)|0)){d=(c[h>>2]|0)+(f-(c[e>>2]|0))|0;while(1){if(!(d>>>0>(c[h>>2]|0)>>>0)){break a}if((a[d+ -1|0]&192|0)!=128){break a}d=d+ -1|0}}}while(0);f=c[e>>2]|0;g=c[h>>2]|0;while(1){j=g;if((g|0)==(d|0)){break}a[f]=a[j]|0;g=g+1|0;f=f+1|0}c[h>>2]=j;c[e>>2]=f;i=b;return}function oua(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+64|0;l=e;e=f;f=g;g=h;h=j;j=c[g>>2]|0;m=c[e>>2]|0;while(1){if((m|0)==(f|0)){n=10;break}if((j|0)==(h|0)){n=10;break}o=d[l+76+(d[m]|0)|0]|0;if((o|0)==6){p=j;j=p+2|0;b[p>>1]=(a[m]&15)<<12|(a[m+1|0]&63)<<6|a[m+2|0]&63;m=m+3|0;continue}else if((o|0)==7){if((j+2|0)==(h|0)){n=10;break}p=(a[m]&7)<<18|(a[m+1|0]&63)<<12|(a[m+2|0]&63)<<6|a[m+3|0]&63;p=p-65536|0;b[j>>1]=p>>>10|55296;b[j+2>>1]=p&1023|56320;j=j+4|0;m=m+4|0;continue}else if((o|0)==5){o=j;j=o+2|0;b[o>>1]=(a[m]&31)<<6|a[m+1|0]&63;m=m+2|0;continue}else{o=m;m=o+1|0;p=j;j=p+2|0;b[p>>1]=a[o]|0;continue}}if((n|0)==10){c[e>>2]=m;c[g>>2]=j;i=k;return}}function pua(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[197496+(((d[198776+((d[f]|0)>>2&7)|0]|0)<<3)+((a[f]&3)<<1)+((d[f+1|0]|0)>>5&1)<<2)>>2]&1<<(a[f+1|0]&31)|0}function qua(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[197496+(((d[198776+(((a[f]&15)<<4)+((d[f+1|0]|0)>>2&15))|0]|0)<<3)+((a[f+1|0]&3)<<1)+((d[f+2|0]|0)>>5&1)<<2)>>2]&1<<(a[f+2|0]&31)|0}function rua(a,b){a=a|0;b=b|0;b=i;i=i+16|0;i=b;return 0}function sua(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[197496+(((d[197240+((d[f]|0)>>2&7)|0]|0)<<3)+((a[f]&3)<<1)+((d[f+1|0]|0)>>5&1)<<2)>>2]&1<<(a[f+1|0]&31)|0}function tua(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[197496+(((d[197240+(((a[f]&15)<<4)+((d[f+1|0]|0)>>2&15))|0]|0)<<3)+((a[f+1|0]&3)<<1)+((d[f+2|0]|0)>>5&1)<<2)>>2]&1<<(a[f+2|0]&31)|0}function uua(b,c){b=b|0;c=c|0;var e=0,f=0;b=i;i=i+16|0;e=c;do{if((d[e]|0|0)<194){f=1}else{if((a[e+1|0]&128|0)==0){f=1;break}f=(a[e+1|0]&192|0)==192}}while(0);i=b;return f&1|0}function vua(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=c;if((a[e+2|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}do{if((d[e]|0|0)==239){if((d[e+1|0]|0|0)!=191){h=5;break}if((d[e+2|0]|0|0)>189){f=1}else{break}g=f&1;i=b;return g|0}else{h=5}}while(0);do{if((h|0)==5){if((a[e+2|0]&192|0)==192){f=1}else{break}g=f&1;i=b;return g|0}}while(0);h=d[e+1|0]|0;do{if((d[e]|0|0)==224){if((h|0)<160){j=1;break}j=(a[e+1|0]&192|0)==192}else{if((h&128|0)==0){j=1;break}c=d[e+1|0]|0;if((d[e]|0|0)==237){k=(c|0)>159}else{k=(c&192|0)==192}j=(k&1|0)!=0}}while(0);f=(j&1|0)!=0;g=f&1;i=b;return g|0}function wua(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=c;if((a[e+3|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}if((a[e+3|0]&192|0)==192){f=1;g=f&1;i=b;return g|0}if((a[e+2|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}if((a[e+2|0]&192|0)==192){f=1;g=f&1;i=b;return g|0}c=d[e+1|0]|0;do{if((d[e]|0|0)==240){if((c|0)<144){h=1;break}h=(a[e+1|0]&192|0)==192}else{if((c&128|0)==0){h=1;break}j=d[e+1|0]|0;if((d[e]|0|0)==244){k=(j|0)>143}else{k=(j&192|0)==192}h=(k&1|0)!=0}}while(0);f=(h&1|0)!=0;g=f&1;i=b;return g|0}function xua(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 19:{j=zua(h,a+1|0,b,e)|0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((De[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((De[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((De[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=44;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 18:{l=42;break b;break};case 7:{if((b-a|0)<4){l=38;break b}m=a;if((De[c[h+340>>2]&63](h,a)|0)==0){l=40;break b}a=m+4|0;continue b;break};case 5:{if((b-a|0)<2){l=28;break b}n=a;if((De[c[h+332>>2]&63](h,a)|0)==0){l=30;break b}a=n+2|0;continue b;break};case 6:{if((b-a|0)<3){l=33;break b}o=a;if((De[c[h+336>>2]&63](h,a)|0)==0){l=35;break b}a=o+3|0;continue b;break};case 29:{l=25;break b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};default:{l=43;break b}}}if((l|0)==25){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==28){j=-2;k=j;i=g;return k|0}else if((l|0)==30){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==33){j=-2;k=j;i=g;return k|0}else if((l|0)==35){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==38){j=-2;k=j;i=g;return k|0}else if((l|0)==40){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a+1;j=9;k=j;i=g;return k|0}else if((l|0)==43){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==44){j=-1;k=j;i=g;return k|0}return 0}function yua(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 30:case 9:case 10:case 21:{c[e>>2]=a;j=22;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((De[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((De[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((De[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=44;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 5:{if((b-a|0)<2){l=28;break b}m=a;if((De[c[h+332>>2]&63](h,a)|0)==0){l=30;break b}a=m+2|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 6:{if((b-a|0)<3){l=33;break b}n=a;if((De[c[h+336>>2]&63](h,a)|0)==0){l=35;break b}a=n+3|0;continue b;break};case 18:{l=42;break b;break};case 29:{l=25;break b;break};case 7:{if((b-a|0)<4){l=38;break b}o=a;if((De[c[h+340>>2]&63](h,a)|0)==0){l=40;break b}a=o+4|0;continue b;break};default:{l=43;break b}}}if((l|0)==25){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==28){j=-2;k=j;i=g;return k|0}else if((l|0)==30){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==33){j=-2;k=j;i=g;return k|0}else if((l|0)==35){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==38){j=-2;k=j;i=g;return k|0}else if((l|0)==40){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a+1;j=28;k=j;i=g;return k|0}else if((l|0)==43){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==44){j=-1;k=j;i=g;return k|0}return 0}function zua(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){if((a[b]|0)==120){k=Aua(j,b+1|0,e,f)|0;l=k;i=h;return l|0}g=b;if((d[j+76+(d[b]|0)|0]|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+1|0;while(1){if((b|0)==(e|0)){break a}g=d[j+76+(d[b]|0)|0]|0;if((g|0)==18){m=9;break}else if((g|0)!=25){m=10;break}b=b+1|0}if((m|0)==9){c[f>>2]=b+1;k=10;l=k;i=h;return l|0}else if((m|0)==10){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function Aua(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;a:do{if((a|0)!=(b|0)){f=a;if(!(((d[h+76+(d[a]|0)|0]|0)+ -24|0)>>>0<2)){c[e>>2]=f;j=0;k=j;i=g;return k|0}a=f+1|0;while(1){if((a|0)==(b|0)){break a}f=d[h+76+(d[a]|0)|0]|0;if((f|0)==18){l=7;break}else if(!((f|0)==24|(f|0)==25)){l=8;break}a=a+1|0}if((l|0)==7){c[e>>2]=a+1;j=10;k=j;i=g;return k|0}else if((l|0)==8){c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);j=-1;k=j;i=g;return k|0}



function _q(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+392>>3];p=f;h[k>>3]=+h[n+6304>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+400>>3];q=+h[p+384>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Nz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4888>>3]=+h[l>>3];i=b;return}function $q(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+392>>3];p=f;h[k>>3]=+h[n+6304>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+400>>3];q=+h[p+384>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Qz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4728>>3]=+h[l>>3];i=b;return}function ar(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+392>>3];p=f;h[k>>3]=+h[n+6304>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+400>>3];q=+h[p+384>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Oz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4768>>3]=+h[l>>3];i=b;return}function br(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+392>>3];p=f;h[k>>3]=+h[n+6304>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+400>>3];q=+h[p+384>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Vz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4808>>3]=+h[l>>3];i=b;return}function cr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+392>>3];p=f;h[k>>3]=+h[n+6304>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+400>>3];q=+h[p+384>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];fA(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4488>>3]=+h[l>>3];i=b;return}function dr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+6304>>3]),1.0e-13);k=+h[g+392>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+5280|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+5280|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,11672,11664,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+5280|0;p=o;h[p>>3]=m;i=d;return}function er(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+368>>3];v=l;h[k>>3]=+h[t+6296>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];gxa(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+376>>3];w=+h[t+360>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];vz(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Bz(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+392>>3];f=j;h[k>>3]=+h[q+6304>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];gxa(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+400>>3];y=+h[f+384>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];vz(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Bz(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+5632>>3]=(+h[d+424>>3]+ +h[d+432>>3])*(w- +h[r>>3])*+h[d+1760>>3]*.5;i=b;return}function fr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+392>>3];p=f;h[k>>3]=+h[n+6304>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+400>>3];q=+h[p+384>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+5760>>3]=+h[l>>3];i=b;return}function gr(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+472>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+5728>>3]=+h[(a?e+5768|0:e+5760|0)>>3];i=b;return}function hr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+392>>3];p=f;h[k>>3]=+h[n+6304>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+400>>3];q=+h[p+384>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+5832>>3]=+h[l>>3];i=b;return}function ir(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+2044>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+5568>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+5568|0;h[c[g+2048>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+5568>>3]);h[c[(c[f>>2]|0)+2052>>2]>>3]=k;_za(a,25)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+5568>>3]=+h[c[(c[f>>2]|0)+2044>>2]>>3];i=b;return}function jr(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+5600>>3]=+h[b+5568>>3]*(+h[d+424>>3]+ +h[d+432>>3])*+h[d+1760>>3]*.5;i=i;return}function kr(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+5992>>3]=+h[b+4976>>3]*+h[d+432>>3]*+h[d+1656>>3]*(+h[b+352>>3]*.5+(+h[b+400>>3]*-.5+((+h[b+5568>>3]+ +h[b+5576>>3])*.5+ +h[d+1352>>3]*+h[b+5200>>3]*-5.0)));i=i;return}function lr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8512>>3]=+h[b+6072>>3]+(+h[b+5992>>3]+ +h[b+6032>>3]);i=i;return}function mr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6232>>3];k=+h[g+8512>>3]- +h[g+6152>>3]*+h[g+5192>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+8064|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+8064|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,11128,11712,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+8064|0;p=o;h[p>>3]=m;i=d;return}function nr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+2124>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1032>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1032|0;h[c[g+2128>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1032>>3]);e=c[f>>2]|0;h[c[e+2132>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+2124>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+1016>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+1016|0;h[(c[e+2128>>2]|0)+8>>3]=+h[g>>3];k=+aAa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+1016>>3]);h[(c[(c[f>>2]|0)+2132>>2]|0)+8>>3]=k;_za(a,26)|0;j=c[(c[f>>2]|0)+2124>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1032>>3]=+h[j>>3];h[f+1016>>3]=+h[j+8>>3];fR(a);gR(a);hR(a);iR(a);jR(a);kR(a);i=b;return}function or(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+472>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+5800>>3]=+h[(a?e+5840|0:e+5832|0)>>3];i=b;return}function pr(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;iA(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+384>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+5232>>3]=+yd(+(+h[d>>3]),+(+h[a+400>>3]*.999));i=b;return}function qr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5232>>3];k=+zd(1.0e-13,+(+h[g+400>>3]-j));l=+h[g+6304>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+nwa(c[b+536>>2]|0,k,11728,11720,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+5248>>3]=+yd(+(j*n*.6219647130774989),1.0);i=d;return}function rr(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+5264>>3]=+zd(+(+h[d+392>>3]- +h[d+5248>>3]),0.0);i=b;return}function sr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5256>>3]=+h[b+392>>3]- +h[b+5264>>3];i=i;return}function tr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5264>>3];k=1.0-j;l=+h[g+6304>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+nwa(c[b+536>>2]|0,k,11800,11792,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+5264>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+5256>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+5296|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+5296|0;z=y;h[z>>3]=w;i=d;return}l=m/+nwa(c[b+536>>2]|0,p,11800,11792,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+5296|0;z=y;h[z>>3]=w;i=d;return}function ur(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5304>>3]=+h[b+5320>>3]- +h[b+5296>>3]*+h[b+384>>3];i=i;return}function vr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+384>>3]*+h[g+5296>>3];k=+h[g+400>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+5312|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+5312|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,11840,11832,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+5312|0;p=o;h[p>>3]=m;i=d;return}function wr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6224>>3]=+h[b+10136>>3]*+h[b+5312>>3];i=i;return}function xr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6184>>3]=+h[b+392>>3]*+h[b+6224>>3];i=i;return}function yr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6264>>3]=+h[b+6224>>3]*+h[b+5304>>3];i=i;return}function zr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6224>>3];k=+h[g+6104>>3]- +h[g+392>>3]*+h[g+6144>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1048|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1048|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,11888,11880,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1048|0;p=o;h[p>>3]=m;i=d;return}function Ar(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8784>>3]=-+h[b+1048>>3];i=i;return}function Br(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+424>>3]*+h[j+5312>>3]*+h[e+1656>>3];l=+h[j+464>>3]+ +h[j+472>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+4968|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+4968|0;r=q;h[r>>3]=o;i=d;return}s=l/+nwa(c[b+536>>2]|0,k,11912,11904,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+4968|0;r=q;h[r>>3]=o;i=d;return}function Cr(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;wz(d,c[a+536>>2]|0,+h[f+4968>>3],+h[f+4808>>3],+h[f+4768>>3],+h[(c[a+416>>2]|0)+464>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4928>>3]=+h[d>>3];i=b;return}function Dr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+zd(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+4928>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+Nxa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4568|0;w=v;h[w>>3]=n;i=b;return}x=c[63880]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=13712;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Oe[a&127](y,d,11976,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+Nxa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4568|0;w=v;h[w>>3]=n;i=b;return}function Er(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0,O=0,P=0.0,Q=0,R=0.0,S=0.0,T=0,X=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4568>>3];k=+U(+(+h[g+4928>>3]));l=+V(+(j*.125));m=+h[g+4888>>3];n=l*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;o=b+416|0;p=c[o>>2]|0;l=+h[p+464>>3];q=+W(+l,.6666666666666666);r=+h[p+384>>3];p=r!=0.0;if(n){if(p){s=r;t=m;u=j}else{v=+nwa(c[b+536>>2]|0,r,12080,12072,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;s=v;t=+h[n+4888>>3];u=+h[n+4568>>3]}w=m*(q*+W(+(1.0/s),.6666666666666666)*.5428835233189814*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);x=k*w;y=j*x;z=y*.125;A=c[e>>2]|0;B=c[A>>2]|0;C=B;D=C+8|0;E=D;F=c[E>>2]|0;G=F;H=G+4688|0;I=H;h[I>>3]=z;i=d;return}if(p){J=r;K=r;L=l;M=m;N=g;O=f}else{l=+nwa(c[b+536>>2]|0,r,12080,12072,+h[f>>3],(a[b+319|0]|0)!=0|0);f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;p=c[o>>2]|0;J=l;K=+h[p+384>>3];L=+h[p+464>>3];M=+h[g+4888>>3];N=g;O=f}l=+W(+L,.6666666666666666);f=K!=0.0;if(m*(q*+W(+(1.0/J),.6666666666666666)*.5428835233189814*.3333333333333333+1.0)==0.0){if(f){P=K}else{P=+nwa(c[b+536>>2]|0,K,12080,12072,+h[O>>3],(a[b+319|0]|0)!=0|0)}w=M*(l*+W(+(1.0/P),.6666666666666666)*.5428835233189814*.3333333333333333+1.0);x=k*w;y=j*x;z=y*.125;A=c[e>>2]|0;B=c[A>>2]|0;C=B;D=C+8|0;E=D;F=c[E>>2]|0;G=F;H=G+4688|0;I=H;h[I>>3]=z;i=d;return}g=b+536|0;if(f){Q=b+319|0;R=K;S=M;T=N;X=O}else{N=b+319|0;P=+nwa(c[g>>2]|0,K,12080,12072,+h[O>>3],(a[N]|0)!=0|0);O=c[c[e>>2]>>2]|0;b=c[O+8>>2]|0;Q=N;R=P;S=+h[b+4888>>3];T=b;X=O}P=M*(l*+W(+(1.0/R),.6666666666666666)*.5428835233189814*.3333333333333333+1.0);R=+V(+(+h[T+4568>>3]*.125))*(+W(+S,.6666666666666666)+-1.0)*12.7+1.0;w=P/+nwa(c[g>>2]|0,R,12104,12072,+h[X>>3],(a[Q]|0)!=0|0);x=k*w;y=j*x;z=y*.125;A=c[e>>2]|0;B=c[A>>2]|0;C=B;D=C+8|0;E=D;F=c[E>>2]|0;G=F;H=G+4688|0;I=H;h[I>>3]=z;i=d;return}function Fr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0,o=0.0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+W(+(+U(+(+h[g+4928>>3]))),.3333333333333333);k=+W(+(+h[g+4888>>3]),.3333333333333333);l=c[b+416>>2]|0;m=+W(+(+h[l+464>>3]),.3333333333333333);n=+h[l+384>>3];if(n!=0.0){o=n;p=g;q=1.0/o;r=+W(+q,.3333333333333333);s=r*.7368062997280773;t=m*s;u=k*t;v=j*u;w=v*1.077;x=p;y=x+4608|0;z=y;h[z>>3]=w;i=d;return}A=+nwa(c[b+536>>2]|0,n,12080,12224,+h[f>>3],(a[b+319|0]|0)!=0|0);o=A;p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=1.0/o;r=+W(+q,.3333333333333333);s=r*.7368062997280773;t=m*s;u=k*t;v=j*u;w=v*1.077;x=p;y=x+4608|0;z=y;h[z>>3]=w;i=d;return}function Gr(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+4608>>3]+-.7;h[b+4648>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function Hr(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;KA(d,c[a+536>>2]|0,+h[f+4688>>3],+h[f+4648>>3],+h[f+4928>>3]+-6150.0,3850.0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4848>>3]=+h[d>>3];i=b;return}function Ir(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+2204>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4528>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+4528|0;h[c[g+2208>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4528>>3]);h[c[(c[f>>2]|0)+2212>>2]>>3]=k;_za(a,27)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+4528>>3]=+h[c[(c[f>>2]|0)+2204>>2]>>3];i=b;return}function Jr(a){a=a|0;var b=0,d=0,e=0;b=i;Qza(a,2)|0;d=c[(c[a+476>>2]|0)+156>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6024>>3]=+h[d>>3];h[e+1328>>3]=+h[d+8>>3];i=b;return}function Kr(a){a=a|0;var b=0,d=0.0,e=0.0,f=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+4968>>3];e=+h[b+4976>>3];f=c[a+416>>2]|0;h[b+5664>>3]=+h[f+1760>>3]*(+h[b+5832>>3]*d*d*+h[f+424>>3]- +h[b+5840>>3]*e*e*+h[f+432>>3]);i=i;return}function Lr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7976>>3]=+h[b+5664>>3]+(-+h[b+5632>>3]- +h[b+5600>>3]);i=i;return}function Mr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10216>>3];k=+h[g+7976>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1128|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1128|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,12240,12232,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1128|0;p=o;h[p>>3]=m;i=d;return}function Nr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+400>>3];k=+h[g+392>>3];l=+h[g+5232>>3]*(k+ +h[g+6304>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+5272|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+5272|0;r=q;h[r>>3]=o;i=d;return}s=k/+nwa(c[b+536>>2]|0,l,12272,12264,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+5272|0;r=q;h[r>>3]=o;i=d;return}function Or(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5232>>3];k=+zd(1.0e-13,+(+h[g+400>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+nwa(c[b+536>>2]|0,k,11728,12376,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+5240>>3]=m*.6219647130774989;i=d;return}function Pr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;gxa(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+416>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+424>>3];l=+h[a+408>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];tA(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5432>>3]=+h[f>>3];i=b;return}function Qr(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+464>>3];h[b+5872>>3]=d*+h[(!(d>=0.0)?b+5320|0:b+5432|0)>>3];i=i;return}function Rr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6064>>3]=+h[b+5872>>3]- +h[b+5880>>3];i=i;return}function Sr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6312>>3]=1.0- +h[b+416>>3];i=i;return}function Tr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+416>>3];p=f;h[k>>3]=+h[n+6312>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+424>>3];q=+h[p+408>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Nz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4880>>3]=+h[l>>3];i=b;return}function Ur(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+416>>3];p=f;h[k>>3]=+h[n+6312>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+424>>3];q=+h[p+408>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Qz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4720>>3]=+h[l>>3];i=b;return}function Vr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+416>>3];p=f;h[k>>3]=+h[n+6312>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+424>>3];q=+h[p+408>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Oz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4760>>3]=+h[l>>3];i=b;return}function Wr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+416>>3];p=f;h[k>>3]=+h[n+6312>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+424>>3];q=+h[p+408>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Vz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4800>>3]=+h[l>>3];i=b;return}function Xr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+416>>3];p=f;h[k>>3]=+h[n+6312>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+424>>3];q=+h[p+408>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];fA(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4480>>3]=+h[l>>3];i=b;return}function Yr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+6312>>3]),1.0e-13);k=+h[g+416>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+5392|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+5392|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,12392,12384,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+5392|0;p=o;h[p>>3]=m;i=d;return}function Zr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+392>>3];v=l;h[k>>3]=+h[t+6304>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];gxa(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+400>>3];w=+h[t+384>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];vz(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Bz(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+416>>3];f=j;h[k>>3]=+h[q+6312>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];gxa(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+424>>3];y=+h[f+408>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];vz(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Bz(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+5624>>3]=(+h[d+416>>3]+ +h[d+424>>3])*(w- +h[r>>3])*+h[d+1760>>3]*.5;i=b;return}function _r(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+416>>3];p=f;h[k>>3]=+h[n+6312>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+424>>3];q=+h[p+408>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+5752>>3]=+h[l>>3];i=b;return}function $r(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+464>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+5720>>3]=+h[(a?e+5760|0:e+5752|0)>>3];i=b;return}function as(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+416>>3];p=f;h[k>>3]=+h[n+6312>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+424>>3];q=+h[p+408>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+5824>>3]=+h[l>>3];i=b;return}function bs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+2284>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+5560>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+5560|0;h[c[g+2288>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+5560>>3]);h[c[(c[f>>2]|0)+2292>>2]>>3]=k;_za(a,28)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+5560>>3]=+h[c[(c[f>>2]|0)+2284>>2]>>3];i=b;return}function cs(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+5592>>3]=+h[b+5560>>3]*(+h[d+416>>3]+ +h[d+424>>3])*+h[d+1760>>3]*.5;i=i;return}function ds(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+5984>>3]=+h[b+4968>>3]*+h[d+424>>3]*+h[d+1656>>3]*(+h[b+376>>3]*.5+(+h[b+424>>3]*-.5+((+h[b+5560>>3]+ +h[b+5568>>3])*.5+ +h[d+1352>>3]*+h[b+5312>>3]*-5.0)));i=i;return}function es(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8504>>3]=+h[b+6064>>3]+(+h[b+5984>>3]+ +h[b+6024>>3]);i=i;return}function fs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6224>>3];k=+h[g+8504>>3]- +h[g+6144>>3]*+h[g+5304>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+8040|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+8040|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,11888,12432,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+8040|0;p=o;h[p>>3]=m;i=d;return}function gs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+2364>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1056>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1056|0;h[c[g+2368>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1056>>3]);e=c[f>>2]|0;h[c[e+2372>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+2364>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+1040>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+1040|0;h[(c[e+2368>>2]|0)+8>>3]=+h[g>>3];k=+aAa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+1040>>3]);h[(c[(c[f>>2]|0)+2372>>2]|0)+8>>3]=k;_za(a,29)|0;j=c[(c[f>>2]|0)+2364>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1056>>3]=+h[j>>3];h[f+1040>>3]=+h[j+8>>3];rR(a);sR(a);tR(a);uR(a);vR(a);wR(a);i=b;return}function hs(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+464>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+5792>>3]=+h[(a?e+5832|0:e+5824|0)>>3];i=b;return}function is(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;iA(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+408>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+5344>>3]=+yd(+(+h[d>>3]),+(+h[a+424>>3]*.999));i=b;return}function js(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5344>>3];k=+zd(1.0e-13,+(+h[g+424>>3]-j));l=+h[g+6312>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+nwa(c[b+536>>2]|0,k,12448,12440,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+5360>>3]=+yd(+(j*n*.6219647130774989),1.0);i=d;return}function ks(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+5376>>3]=+zd(+(+h[d+416>>3]- +h[d+5360>>3]),0.0);i=b;return}function ls(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5368>>3]=+h[b+416>>3]- +h[b+5376>>3];i=i;return}function ms(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5376>>3];k=1.0-j;l=+h[g+6312>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+nwa(c[b+536>>2]|0,k,12520,12512,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+5376>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+5368>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+5408|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+5408|0;z=y;h[z>>3]=w;i=d;return}l=m/+nwa(c[b+536>>2]|0,p,12520,12512,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+5408|0;z=y;h[z>>3]=w;i=d;return}function ns(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5416>>3]=+h[b+5432>>3]- +h[b+5408>>3]*+h[b+408>>3];i=i;return}function os(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+408>>3]*+h[g+5408>>3];k=+h[g+424>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+5424|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+5424|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,12560,12552,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+5424|0;p=o;h[p>>3]=m;i=d;return}function ps(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6216>>3]=+h[b+10128>>3]*+h[b+5424>>3];i=i;return}function qs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6176>>3]=+h[b+416>>3]*+h[b+6216>>3];i=i;return}function rs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6256>>3]=+h[b+6216>>3]*+h[b+5416>>3];i=i;return}function ss(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6216>>3];k=+h[g+6096>>3]- +h[g+416>>3]*+h[g+6136>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1072|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1072|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,12608,12600,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1072|0;p=o;h[p>>3]=m;i=d;return}function ts(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8776>>3]=-+h[b+1072>>3];i=i;return}function us(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+416>>3]*+h[j+5424>>3]*+h[e+1656>>3];l=+h[j+456>>3]+ +h[j+464>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+4960|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+4960|0;r=q;h[r>>3]=o;i=d;return}s=l/+nwa(c[b+536>>2]|0,k,12632,12624,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+4960|0;r=q;h[r>>3]=o;i=d;return}function vs(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;wz(d,c[a+536>>2]|0,+h[f+4960>>3],+h[f+4800>>3],+h[f+4760>>3],+h[(c[a+416>>2]|0)+456>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4920>>3]=+h[d>>3];i=b;return}function ws(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+zd(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+4920>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+Nxa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4560|0;w=v;h[w>>3]=n;i=b;return}x=c[63880]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=13712;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Oe[a&127](y,d,12696,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+Nxa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4560|0;w=v;h[w>>3]=n;i=b;return}function xs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=Dza(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4960>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4560>>3];l=+U(+(+h[j+4920>>3]));m=+h[j+4880>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?1.5:3.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+376>>3];q=n*p;r=q!=0.0;s=+h[o+456>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+nwa(c[b+536>>2]|0,q,12800,12792,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+4880>>3];u=+h[j+4560>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+4680|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+nwa(c[b+536>>2]|0,q,12800,12792,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+456>>3];M=+h[j+376>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+nwa(c[b+536>>2]|0,q,12800,12792,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+4680|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+nwa(c[b+536>>2]|0,q,12800,12792,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4560>>3]*.125));L=P*(+W(+(+h[g+4880>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+nwa(c[b+536>>2]|0,L,12864,12792,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+4680|0;K=J;h[K>>3]=B;i=d;return}}function ys(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=Dza(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4960>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+4920>>3]));l=+h[j+4880>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?1.5:3.5)*+h[m+376>>3];o=+h[m+456>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+nwa(c[b+536>>2]|0,n,12800,12984,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+4600>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function zs(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+4600>>3]+-.7;h[b+4640>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function As(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;KA(d,c[a+536>>2]|0,+h[f+4680>>3],+h[f+4640>>3],+h[f+4920>>3]+-6150.0,3850.0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4840>>3]=+h[d>>3];i=b;return}function Bs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+2444>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4520>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+4520|0;h[c[g+2448>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4520>>3]);h[c[(c[f>>2]|0)+2452>>2]>>3]=k;_za(a,30)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+4520>>3]=+h[c[(c[f>>2]|0)+2444>>2]>>3];i=b;return}function Cs(a){a=a|0;var b=0,d=0,e=0;b=i;Qza(a,3)|0;d=c[(c[a+476>>2]|0)+220>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6016>>3]=+h[d>>3];h[e+1336>>3]=+h[d+8>>3];i=b;return}function Ds(a){a=a|0;var b=0,d=0.0,e=0.0,f=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+4960>>3];e=+h[b+4968>>3];f=c[a+416>>2]|0;h[b+5656>>3]=+h[f+1760>>3]*(+h[b+5824>>3]*d*d*+h[f+416>>3]- +h[b+5832>>3]*e*e*+h[f+424>>3]);i=i;return}function Es(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7968>>3]=+h[b+5656>>3]+(-+h[b+5624>>3]- +h[b+5592>>3]);i=i;return}function Fs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10208>>3];k=+h[g+7968>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1120|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1120|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,13e3,12992,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1120|0;p=o;h[p>>3]=m;i=d;return}function Gs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+424>>3];k=+h[g+416>>3];l=+h[g+5344>>3]*(k+ +h[g+6312>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+5384|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+5384|0;r=q;h[r>>3]=o;i=d;return}s=k/+nwa(c[b+536>>2]|0,l,13032,13024,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+5384|0;r=q;h[r>>3]=o;i=d;return}function Hs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5344>>3];k=+zd(1.0e-13,+(+h[g+424>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+nwa(c[b+536>>2]|0,k,12448,13136,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+5352>>3]=m*.6219647130774989;i=d;return}function Is(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;gxa(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+440>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+448>>3];l=+h[a+432>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];tA(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5544>>3]=+h[f>>3];i=b;return}function Js(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+456>>3];h[b+5864>>3]=d*+h[(!(d>=0.0)?b+5432|0:b+5544|0)>>3];i=i;return}function Ks(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6056>>3]=+h[b+5864>>3]- +h[b+5872>>3];i=i;return}function Ls(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0.0;d=i;i=i+120|0;e=d;f=d+96|0;g=d+112|0;j=i;i=i+16|0;k=i;i=i+96|0;l=i;i=i+8|0;m=b+4|0;n=c[c[m>>2]>>2]|0;o=c[n+8>>2]|0;p=+zd(+-+h[o+5960>>3],1.0e-15);q=+zd(+-+h[o+288>>3],1.0e-15);r=p+q;s=p*+h[o+440>>3]+q*+h[o+272>>3];do{if(r!=0.0){t=s/r}else{if(s==0.0){t=s;break}t=s/+nwa(c[b+536>>2]|0,r,4656,13144,+h[n>>3],(a[b+319|0]|0)!=0|0)}}while(0);gxa(j,1,t,g);c[k>>2]=4216;h[k+8>>3]=.01801528;h[k+16>>3]=-13423382.81725291;h[k+24>>3]=549760.6476280135;h[k+32>>3]=1.0e3;g=k+40|0;n=4224;c[g+0>>2]=c[n+0>>2];c[g+4>>2]=c[n+4>>2];c[g+8>>2]=c[n+8>>2];n=k+52|0;g=4240;c[n+0>>2]=c[g+0>>2];c[n+4>>2]=c[g+4>>2];c[n+8>>2]=c[g+8>>2];g=k+64|0;n=4256;c[g+0>>2]=c[n+0>>2];c[g+4>>2]=c[n+4>>2];c[g+8>>2]=c[n+8>>2];n=k+76|0;g=4272;c[n+0>>2]=c[g+0>>2];c[n+4>>2]=c[g+4>>2];c[n+8>>2]=c[g+8>>2];h[k+88>>3]=461.5233290850878;g=c[b+536>>2]|0;n=c[c[m>>2]>>2]|0;o=c[n+8>>2]|0;t=+zd(+-+h[o+5960>>3],1.0e-15);r=+zd(+-+h[o+288>>3],1.0e-15);s=t+r;q=t*+h[o+5544>>3]+r*+h[o+3536>>3];do{if(s!=0.0){u=o;v=q/s}else{if(q==0.0){u=o;v=q;break}r=q/+nwa(g,s,4656,13144,+h[n>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[m>>2]>>2]|0)+8>>2]|0;v=r}}while(0);s=+h[u+448>>3];u=f;b=j;c[u+0>>2]=c[b+0>>2];c[u+4>>2]=c[b+4>>2];c[u+8>>2]=c[b+8>>2];b=e+0|0;u=k+0|0;k=b+96|0;do{c[b>>2]=c[u>>2];b=b+4|0;u=u+4|0}while((b|0)<(k|0));nA(l,g,v,190.0,647.0,s,f,e,1.0e-13);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+7744>>3]=+h[l>>3];i=d;return}function Ms(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0.0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0.0;d=i;i=i+56|0;e=d;f=d+32|0;g=d+48|0;j=i;i=i+16|0;l=i;i=i+32|0;m=i;i=i+32|0;n=i;i=i+8|0;o=b+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[p+7728>>3];r=g;h[k>>3]=+h[p+7736>>3];c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];gxa(j,2,q,g);g=b+536|0;r=c[g>>2]|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[p+448>>3];s=+h[p+7744>>3];p=f;t=j;c[p+0>>2]=c[t+0>>2];c[p+4>>2]=c[t+4>>2];c[p+8>>2]=c[t+8>>2];mA(m,r,q,s,f);f=l;r=m;c[f+0>>2]=c[r+0>>2];c[f+4>>2]=c[r+4>>2];c[f+8>>2]=c[r+8>>2];c[f+12>>2]=c[r+12>>2];c[f+16>>2]=c[r+16>>2];c[f+20>>2]=c[r+20>>2];c[f+24>>2]=c[r+24>>2];c[f+28>>2]=c[r+28>>2];r=c[g>>2]|0;f=e;m=l;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];c[f+12>>2]=c[m+12>>2];c[f+16>>2]=c[m+16>>2];c[f+20>>2]=c[m+20>>2];c[f+24>>2]=c[m+24>>2];c[f+28>>2]=c[m+28>>2];qA(n,r,e);e=c[b+416>>2]|0;s=+h[n>>3]*+h[e+144>>3]*+h[e+1432>>3];e=c[c[o>>2]>>2]|0;n=c[e+8>>2]|0;q=+h[n+648>>3];if(s!=0.0){u=n;v=q/s;w=u;x=w+7336|0;y=x;h[y>>3]=v;i=d;return}if(q==0.0){u=n;v=q;w=u;x=w+7336|0;y=x;h[y>>3]=v;i=d;return}z=q/+nwa(c[g>>2]|0,s,13160,13152,+h[e>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[o>>2]>>2]|0)+8>>2]|0;v=z;w=u;x=w+7336|0;y=x;h[y>>3]=v;i=d;return}function Ns(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+7728>>3];p=f;h[k>>3]=+h[n+7736>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+448>>3];q=+h[p+7744>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+9672>>3]=+h[l>>3];i=b;return}function Os(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+7728>>3];p=f;h[k>>3]=+h[n+7736>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+448>>3];q=+h[p+7744>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+9616>>3]=+h[l>>3];i=b;return}function Ps(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6320>>3]=1.0- +h[b+440>>3];i=i;return}function Qs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+440>>3];p=f;h[k>>3]=+h[n+6320>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+448>>3];q=+h[p+432>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Nz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4872>>3]=+h[l>>3];i=b;return}function Rs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+440>>3];p=f;h[k>>3]=+h[n+6320>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+448>>3];q=+h[p+432>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Qz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4712>>3]=+h[l>>3];i=b;return}function Ss(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+440>>3];p=f;h[k>>3]=+h[n+6320>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+448>>3];q=+h[p+432>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Oz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4752>>3]=+h[l>>3];i=b;return}function Ts(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+440>>3];p=f;h[k>>3]=+h[n+6320>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+448>>3];q=+h[p+432>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Vz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4792>>3]=+h[l>>3];i=b;return}function Us(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+440>>3];p=f;h[k>>3]=+h[n+6320>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+448>>3];q=+h[p+432>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];fA(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4472>>3]=+h[l>>3];i=b;return}function Vs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+6320>>3]),1.0e-13);k=+h[g+440>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+5504|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+5504|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,13408,13400,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+5504|0;p=o;h[p>>3]=m;i=d;return}function Ws(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+416>>3];v=l;h[k>>3]=+h[t+6312>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];gxa(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+424>>3];w=+h[t+408>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];vz(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Bz(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+440>>3];f=j;h[k>>3]=+h[q+6320>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];gxa(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+448>>3];y=+h[f+432>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];vz(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Bz(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+5616>>3]=(+h[d+408>>3]+ +h[d+416>>3])*(w- +h[r>>3])*+h[d+1760>>3]*.5;i=b;return}function Xs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+440>>3];p=f;h[k>>3]=+h[n+6320>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+448>>3];q=+h[p+432>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+5744>>3]=+h[l>>3];i=b;return}function Ys(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+456>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+5712>>3]=+h[(a?e+5752|0:e+5744|0)>>3];i=b;return}function Zs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+440>>3];p=f;h[k>>3]=+h[n+6320>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+448>>3];q=+h[p+432>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+5816>>3]=+h[l>>3];i=b;return}function _s(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+2524>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+5552>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+5552|0;h[c[g+2528>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+5552>>3]);h[c[(c[f>>2]|0)+2532>>2]>>3]=k;_za(a,31)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+5552>>3]=+h[c[(c[f>>2]|0)+2524>>2]>>3];i=b;return}function $s(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+5584>>3]=+h[b+5552>>3]*(+h[d+408>>3]+ +h[d+416>>3])*+h[d+1760>>3]*.5;i=i;return}function at(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+5976>>3]=+h[b+4960>>3]*+h[d+416>>3]*+h[d+1656>>3]*(+h[b+400>>3]*.5+(+h[b+448>>3]*-.5+((+h[b+5552>>3]+ +h[b+5560>>3])*.5+ +h[d+1352>>3]*+h[b+5424>>3]*-5.0)));i=i;return}function bt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8496>>3]=+h[b+6056>>3]+(+h[b+5976>>3]+ +h[b+6016>>3]);i=i;return}function ct(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6216>>3];k=+h[g+8496>>3]- +h[g+6136>>3]*+h[g+5416>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+8016|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+8016|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,12608,13448,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+8016|0;p=o;h[p>>3]=m;i=d;return}function dt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+2604>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1064>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1064|0;h[c[g+2608>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1064>>3]);e=c[f>>2]|0;h[c[e+2612>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+2604>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+1080>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+1080|0;h[(c[e+2608>>2]|0)+8>>3]=+h[g>>3];k=+aAa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+1080>>3]);h[(c[(c[f>>2]|0)+2612>>2]|0)+8>>3]=k;_za(a,32)|0;j=c[(c[f>>2]|0)+2604>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1064>>3]=+h[j>>3];h[f+1080>>3]=+h[j+8>>3];DR(a);ER(a);FR(a);GR(a);HR(a);IR(a);i=b;return}function et(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+456>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+5784>>3]=+h[(a?e+5824|0:e+5816|0)>>3];i=b;return}function ft(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;iA(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+432>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+5456>>3]=+yd(+(+h[d>>3]),+(+h[a+448>>3]*.999));i=b;return}function gt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5456>>3];k=+zd(1.0e-13,+(+h[g+448>>3]-j));l=+h[g+6320>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+nwa(c[b+536>>2]|0,k,13464,13456,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+5472>>3]=+yd(+(j*n*.6219647130774989),1.0);i=d;return}function ht(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+5488>>3]=+zd(+(+h[d+440>>3]- +h[d+5472>>3]),0.0);i=b;return}function it(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5480>>3]=+h[b+440>>3]- +h[b+5488>>3];i=i;return}function jt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5488>>3];k=1.0-j;l=+h[g+6320>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+nwa(c[b+536>>2]|0,k,13536,13528,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+5488>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+5480>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+5520|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+5520|0;z=y;h[z>>3]=w;i=d;return}l=m/+nwa(c[b+536>>2]|0,p,13536,13528,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+5520|0;z=y;h[z>>3]=w;i=d;return}function kt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5528>>3]=+h[b+5544>>3]- +h[b+5520>>3]*+h[b+432>>3];i=i;return}function lt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+432>>3]*+h[g+5520>>3];k=+h[g+448>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+5536|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+5536|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,13576,13568,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+5536|0;p=o;h[p>>3]=m;i=d;return}function mt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6208>>3]=+h[b+10120>>3]*+h[b+5536>>3];i=i;return}function nt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6168>>3]=+h[b+440>>3]*+h[b+6208>>3];i=i;return}function ot(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6248>>3]=+h[b+6208>>3]*+h[b+5528>>3];i=i;return}function pt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6208>>3];k=+h[g+6088>>3]- +h[g+440>>3]*+h[g+6128>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1096|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1096|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,13624,13616,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1096|0;p=o;h[p>>3]=m;i=d;return}function qt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8768>>3]=-+h[b+1096>>3];i=i;return}function rt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+408>>3]*+h[j+5536>>3]*+h[e+1656>>3];l=+h[j+5960>>3]+ +h[j+456>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+4952|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+4952|0;r=q;h[r>>3]=o;i=d;return}s=l/+nwa(c[b+536>>2]|0,k,13648,13640,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+4952|0;r=q;h[r>>3]=o;i=d;return}function st(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;wz(d,c[a+536>>2]|0,+h[f+4952>>3],+h[f+4792>>3],+h[f+4752>>3],+h[(c[a+416>>2]|0)+448>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4912>>3]=+h[d>>3];i=b;return}function tt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+zd(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+4912>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+Nxa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4552|0;w=v;h[w>>3]=n;i=b;return}x=c[63880]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=13712;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Oe[a&127](y,d,13736,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+Nxa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4552|0;w=v;h[w>>3]=n;i=b;return}function ut(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=Dza(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4952>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4552>>3];l=+U(+(+h[j+4912>>3]));m=+h[j+4872>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?.5:4.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+368>>3];q=n*p;r=q!=0.0;s=+h[o+448>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+nwa(c[b+536>>2]|0,q,13840,13832,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+4872>>3];u=+h[j+4552>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+4672|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+nwa(c[b+536>>2]|0,q,13840,13832,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+448>>3];M=+h[j+368>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+nwa(c[b+536>>2]|0,q,13840,13832,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+4672|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+nwa(c[b+536>>2]|0,q,13840,13832,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4552>>3]*.125));L=P*(+W(+(+h[g+4872>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+nwa(c[b+536>>2]|0,L,13904,13832,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+4672|0;K=J;h[K>>3]=B;i=d;return}}function vt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=Dza(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4952>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+4912>>3]));l=+h[j+4872>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?.5:4.5)*+h[m+368>>3];o=+h[m+448>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+nwa(c[b+536>>2]|0,n,13840,14024,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+4592>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function wt(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+4592>>3]+-.7;h[b+4632>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function xt(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;KA(d,c[a+536>>2]|0,+h[f+4672>>3],+h[f+4632>>3],+h[f+4912>>3]+-6150.0,3850.0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4832>>3]=+h[d>>3];i=b;return}function yt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+2684>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4512>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+4512|0;h[c[g+2688>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4512>>3]);h[c[(c[f>>2]|0)+2692>>2]>>3]=k;_za(a,33)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+4512>>3]=+h[c[(c[f>>2]|0)+2684>>2]>>3];i=b;return}function zt(a){a=a|0;var b=0,d=0,e=0;b=i;Qza(a,4)|0;d=c[(c[a+476>>2]|0)+284>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6008>>3]=+h[d>>3];h[e+1344>>3]=+h[d+8>>3];i=b;return}function At(a){a=a|0;var b=0,d=0.0,e=0.0,f=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+4952>>3];e=+h[b+4960>>3];f=c[a+416>>2]|0;h[b+5648>>3]=+h[f+1760>>3]*(+h[b+5816>>3]*d*d*+h[f+408>>3]- +h[b+5824>>3]*e*e*+h[f+416>>3]);i=i;return}function Bt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7960>>3]=+h[b+5648>>3]+(-+h[b+5616>>3]- +h[b+5584>>3]);i=i;return}function Ct(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10200>>3];k=+h[g+7960>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1112|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1112|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,14040,14032,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1112|0;p=o;h[p>>3]=m;i=d;return}function Dt(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+5968>>3]=+h[b+4952>>3]*+h[d+408>>3]*+h[d+1656>>3]*(+h[b+424>>3]*.5+(+h[b+448>>3]*-.5+(+h[b+5552>>3]*.5+ +h[d+1352>>3]*+h[b+5536>>3]*-5.0)));i=i;return}function Et(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+448>>3];k=+h[g+440>>3];l=+h[g+5456>>3]*(k+ +h[g+6320>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+5496|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+5496|0;r=q;h[r>>3]=o;i=d;return}s=k/+nwa(c[b+536>>2]|0,l,14072,14064,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+5496|0;r=q;h[r>>3]=o;i=d;return}function Ft(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5456>>3];k=+zd(1.0e-13,+(+h[g+448>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+nwa(c[b+536>>2]|0,k,13464,14176,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+5464>>3]=m*.6219647130774989;i=d;return}function Gt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5704>>3]=+h[b+480>>3]*+h[b+10224>>3];i=i;return}function Ht(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5696>>3]=+h[b+472>>3]*+h[b+10216>>3];i=i;return}function It(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5688>>3]=+h[b+464>>3]*+h[b+10208>>3];i=i;return}function Jt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5680>>3]=+h[b+456>>3]*+h[b+10200>>3];i=i;return}function Kt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;gxa(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+496>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+504>>3];l=+h[a+488>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];tA(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6544>>3]=+h[f>>3];i=b;return}function Lt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0.0;d=i;i=i+120|0;e=d;f=d+96|0;g=d+112|0;j=i;i=i+16|0;k=i;i=i+96|0;l=i;i=i+8|0;m=b+4|0;n=c[c[m>>2]>>2]|0;o=c[n+8>>2]|0;p=+zd(+(+h[o+648>>3]),1.0e-15);q=+zd(+-+h[o+5960>>3],1.0e-15);r=p+q;s=p*+h[o+496>>3]+q*+h[o+440>>3];do{if(r!=0.0){t=s/r}else{if(s==0.0){t=s;break}t=s/+nwa(c[b+536>>2]|0,r,4520,14184,+h[n>>3],(a[b+319|0]|0)!=0|0)}}while(0);gxa(j,1,t,g);c[k>>2]=4216;h[k+8>>3]=.01801528;h[k+16>>3]=-13423382.81725291;h[k+24>>3]=549760.6476280135;h[k+32>>3]=1.0e3;g=k+40|0;n=4224;c[g+0>>2]=c[n+0>>2];c[g+4>>2]=c[n+4>>2];c[g+8>>2]=c[n+8>>2];n=k+52|0;g=4240;c[n+0>>2]=c[g+0>>2];c[n+4>>2]=c[g+4>>2];c[n+8>>2]=c[g+8>>2];g=k+64|0;n=4256;c[g+0>>2]=c[n+0>>2];c[g+4>>2]=c[n+4>>2];c[g+8>>2]=c[n+8>>2];n=k+76|0;g=4272;c[n+0>>2]=c[g+0>>2];c[n+4>>2]=c[g+4>>2];c[n+8>>2]=c[g+8>>2];h[k+88>>3]=461.5233290850878;g=c[b+536>>2]|0;n=c[c[m>>2]>>2]|0;o=c[n+8>>2]|0;t=+zd(+(+h[o+648>>3]),1.0e-15);r=+zd(+-+h[o+5960>>3],1.0e-15);s=t+r;q=t*+h[o+6544>>3]+r*+h[o+5544>>3];do{if(s!=0.0){u=o;v=q/s}else{if(q==0.0){u=o;v=q;break}r=q/+nwa(g,s,4520,14184,+h[n>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[m>>2]>>2]|0)+8>>2]|0;v=r}}while(0);s=+h[u+448>>3];u=f;b=j;c[u+0>>2]=c[b+0>>2];c[u+4>>2]=c[b+4>>2];c[u+8>>2]=c[b+8>>2];b=e+0|0;u=k+0|0;k=b+96|0;do{c[b>>2]=c[u>>2];b=b+4|0;u=u+4|0}while((b|0)<(k|0));nA(l,g,v,190.0,647.0,s,f,e,1.0e-13);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4464>>3]=+h[l>>3];i=d;return}function Mt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0.0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0.0;d=i;i=i+56|0;e=d;f=d+32|0;g=d+48|0;j=i;i=i+16|0;l=i;i=i+32|0;m=i;i=i+32|0;n=i;i=i+8|0;o=b+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[p+4448>>3];r=g;h[k>>3]=+h[p+4456>>3];c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];gxa(j,2,q,g);g=b+536|0;r=c[g>>2]|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[p+448>>3];s=+h[p+4464>>3];p=f;t=j;c[p+0>>2]=c[t+0>>2];c[p+4>>2]=c[t+4>>2];c[p+8>>2]=c[t+8>>2];mA(m,r,q,s,f);f=l;r=m;c[f+0>>2]=c[r+0>>2];c[f+4>>2]=c[r+4>>2];c[f+8>>2]=c[r+8>>2];c[f+12>>2]=c[r+12>>2];c[f+16>>2]=c[r+16>>2];c[f+20>>2]=c[r+20>>2];c[f+24>>2]=c[r+24>>2];c[f+28>>2]=c[r+28>>2];r=c[g>>2]|0;f=e;m=l;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];c[f+12>>2]=c[m+12>>2];c[f+16>>2]=c[m+16>>2];c[f+20>>2]=c[m+20>>2];c[f+24>>2]=c[m+24>>2];c[f+28>>2]=c[m+28>>2];qA(n,r,e);e=c[b+416>>2]|0;s=+h[n>>3]*+h[e+704>>3]*+h[e+1888>>3];e=c[c[o>>2]>>2]|0;n=c[e+8>>2]|0;q=+h[n+288>>3];if(s!=0.0){u=n;v=q/s;w=u;x=w+4e3|0;y=x;h[y>>3]=v;i=d;return}if(q==0.0){u=n;v=q;w=u;x=w+4e3|0;y=x;h[y>>3]=v;i=d;return}z=q/+nwa(c[g>>2]|0,s,14200,14192,+h[e>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[o>>2]>>2]|0)+8>>2]|0;v=z;w=u;x=w+4e3|0;y=x;h[y>>3]=v;i=d;return}function Nt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+272>>3];v=l;h[k>>3]=+h[t+4440>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];gxa(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+280>>3];w=+h[t+264>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];vz(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Bz(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+4448>>3];f=j;h[k>>3]=+h[q+4456>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];gxa(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+448>>3];y=+h[f+4464>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];vz(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Bz(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+3640>>3]=+h[d+704>>3]*(w- +h[r>>3])*+h[d+1992>>3];i=b;return}function Ot(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+4448>>3];p=f;h[k>>3]=+h[n+4456>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+448>>3];q=+h[p+4464>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+3832>>3]=+h[l>>3];i=b;return}function Pt(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+288>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3784>>3]=+h[(a?e+3840|0:e+3832|0)>>3];i=b;return}function Qt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+4448>>3];p=f;h[k>>3]=+h[n+4456>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+448>>3];q=+h[p+4464>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+3936>>3]=+h[l>>3];i=b;return}function Rt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+2764>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+3544>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+3544|0;h[c[g+2768>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+3544>>3]);h[c[(c[f>>2]|0)+2772>>2]>>3]=k;_za(a,34)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3544>>3]=+h[c[(c[f>>2]|0)+2764>>2]>>3];i=b;return}function St(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3592>>3]=+h[b+3544>>3]*+h[d+1992>>3]*+h[d+704>>3];i=i;return}function Tt(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+4104>>3]=+h[b+2944>>3]*+h[d+704>>3]*+h[d+1888>>3]*((+h[b+256>>3]- +h[b+448>>3])/1.5+(+h[b+3544>>3]+(+h[b+3552>>3]*.5+ +h[d+1352>>3]*+h[b+3528>>3]*-5.0)));i=i;return}function Ut(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+288>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3888>>3]=+h[(a?e+3944|0:e+3936|0)>>3];i=b;return}function Vt(a){a=a|0;var b=0,d=0.0,e=0.0,f=0,g=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+4e3>>3];e=+h[b+2944>>3];f=c[a+416>>2]|0;g=+h[f+704>>3];h[b+3688>>3]=+h[f+1992>>3]*(+h[b+3936>>3]*d*d*g- +h[b+3944>>3]*e*e*g);i=i;return}function Wt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8112>>3]=+h[b+3688>>3]+(-+h[b+3640>>3]- +h[b+3592>>3]);i=i;return}function Xt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10304>>3];k=+h[g+8112>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+944|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+944|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,14448,14440,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+944|0;p=o;h[p>>3]=m;i=d;return}function Yt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+288>>3];if(!(j>=0.0)){k=g;l=j*+h[g+3536>>3];m=k;n=m+4008|0;o=n;h[o>>3]=l;i=d;return}p=+zd(+(+h[g+648>>3]),1.0e-15);q=+zd(+-+h[g+5960>>3],1.0e-15);r=p+q;s=p*+h[g+6544>>3]+q*+h[g+5544>>3];do{if(r!=0.0){t=j;u=g;v=s/r}else{if(s==0.0){t=j;u=g;v=s;break}q=s/+nwa(c[b+536>>2]|0,r,4520,14472,+h[f>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[w+288>>3];u=w;v=q}}while(0);k=u;l=v*t;m=k;n=m+4008|0;o=n;h[o>>3]=l;i=d;return}function Zt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4144>>3]=+h[b+4008>>3]- +h[b+4016>>3];i=i;return}function _t(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8528>>3]=+h[b+4144>>3]+ +h[b+4104>>3];i=i;return}function $t(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4304>>3];k=+h[g+8528>>3]- +h[g+4224>>3]*+h[g+3520>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+8160|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+8160|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,9328,14480,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+8160|0;p=o;h[p>>3]=m;i=d;return}function au(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+2844>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+920>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+920|0;h[c[g+2848>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+920>>3]);e=c[f>>2]|0;h[c[e+2852>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+2844>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+936>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+936|0;h[(c[e+2848>>2]|0)+8>>3]=+h[g>>3];k=+aAa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+936>>3]);h[(c[(c[f>>2]|0)+2852>>2]|0)+8>>3]=k;_za(a,35)|0;j=c[(c[f>>2]|0)+2844>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+920>>3]=+h[j>>3];h[f+936>>3]=+h[j+8>>3];PR(a);QR(a);RR(a);SR(a);TR(a);UR(a);i=b;return}function bu(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0.0;d=i;i=i+120|0;e=d;f=d+96|0;g=d+112|0;j=i;i=i+16|0;k=i;i=i+96|0;l=i;i=i+8|0;m=b+4|0;n=c[c[m>>2]>>2]|0;o=c[n+8>>2]|0;p=+zd(+(+h[o+648>>3]),1.0e-15);q=+zd(+-+h[o+288>>3],1.0e-15);r=p+q;s=p*+h[o+496>>3]+q*+h[o+272>>3];do{if(r!=0.0){t=s/r}else{if(s==0.0){t=s;break}t=s/+nwa(c[b+536>>2]|0,r,2416,14488,+h[n>>3],(a[b+319|0]|0)!=0|0)}}while(0);gxa(j,1,t,g);c[k>>2]=4216;h[k+8>>3]=.01801528;h[k+16>>3]=-13423382.81725291;h[k+24>>3]=549760.6476280135;h[k+32>>3]=1.0e3;g=k+40|0;n=4224;c[g+0>>2]=c[n+0>>2];c[g+4>>2]=c[n+4>>2];c[g+8>>2]=c[n+8>>2];n=k+52|0;g=4240;c[n+0>>2]=c[g+0>>2];c[n+4>>2]=c[g+4>>2];c[n+8>>2]=c[g+8>>2];g=k+64|0;n=4256;c[g+0>>2]=c[n+0>>2];c[g+4>>2]=c[n+4>>2];c[g+8>>2]=c[n+8>>2];n=k+76|0;g=4272;c[n+0>>2]=c[g+0>>2];c[n+4>>2]=c[g+4>>2];c[n+8>>2]=c[g+8>>2];h[k+88>>3]=461.5233290850878;g=c[b+536>>2]|0;n=c[c[m>>2]>>2]|0;o=c[n+8>>2]|0;t=+zd(+(+h[o+648>>3]),1.0e-15);r=+zd(+-+h[o+288>>3],1.0e-15);s=t+r;q=t*+h[o+6544>>3]+r*+h[o+3536>>3];do{if(s!=0.0){u=o;v=q/s}else{if(q==0.0){u=o;v=q;break}r=q/+nwa(g,s,2416,14488,+h[n>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[m>>2]>>2]|0)+8>>2]|0;v=r}}while(0);s=+h[u+448>>3];u=f;b=j;c[u+0>>2]=c[b+0>>2];c[u+4>>2]=c[b+4>>2];c[u+8>>2]=c[b+8>>2];b=e+0|0;u=k+0|0;k=b+96|0;do{c[b>>2]=c[u>>2];b=b+4|0;u=u+4|0}while((b|0)<(k|0));nA(l,g,v,190.0,647.0,s,f,e,1.0e-13);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+10776>>3]=+h[l>>3];i=d;return}function cu(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5960>>3];if(!(j>=0.0)){k=g;l=j*+h[g+5544>>3];m=k;n=m+5856|0;o=n;h[o>>3]=l;i=d;return}p=+zd(+(+h[g+648>>3]),1.0e-15);q=+zd(+-+h[g+288>>3],1.0e-15);r=p+q;s=p*+h[g+6544>>3]+q*+h[g+3536>>3];do{if(r!=0.0){t=j;u=g;v=s/r}else{if(s==0.0){t=j;u=g;v=s;break}q=s/+nwa(c[b+536>>2]|0,r,2416,14496,+h[f>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[w+5960>>3];u=w;v=q}}while(0);k=u;l=v*t;m=k;n=m+5856|0;o=n;h[o>>3]=l;i=d;return}function du(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6048>>3]=+h[b+5856>>3]- +h[b+5864>>3];i=i;return}function eu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8488>>3]=+h[b+6048>>3]+(+h[b+5968>>3]+ +h[b+6008>>3]);i=i;return}function fu(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6208>>3];k=+h[g+8488>>3]- +h[g+6128>>3]*+h[g+5528>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+7992|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+7992|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,13624,14504,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7992|0;p=o;h[p>>3]=m;i=d;return}function gu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+2924>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1088>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1088|0;h[c[g+2928>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1088>>3]);e=c[f>>2]|0;h[c[e+2932>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+2924>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+1104>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+1104|0;h[(c[e+2928>>2]|0)+8>>3]=+h[g>>3];k=+aAa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+1104>>3]);h[(c[(c[f>>2]|0)+2932>>2]|0)+8>>3]=k;_za(a,36)|0;j=c[(c[f>>2]|0)+2924>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1088>>3]=+h[j>>3];h[f+1104>>3]=+h[j+8>>3];XR(a);YR(a);ZR(a);_R(a);$R(a);aS(a);i=b;return}function hu(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+648>>3];if(j>=0.0){k=g;l=j*+h[g+6544>>3];m=k;n=m+7392|0;o=n;h[o>>3]=l;i=d;return}p=+zd(+-+h[g+5960>>3],1.0e-15);q=+zd(+-+h[g+288>>3],1.0e-15);r=p+q;s=p*+h[g+5544>>3]+q*+h[g+3536>>3];do{if(r!=0.0){t=j;u=g;v=s/r}else{if(s==0.0){t=j;u=g;v=s;break}q=s/+nwa(c[b+536>>2]|0,r,4656,14512,+h[f>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[w+648>>3];u=w;v=q}}while(0);k=u;l=v*t;m=k;n=m+7392|0;o=n;h[o>>3]=l;i=d;return}function iu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7752>>3]=1.0- +h[b+496>>3];i=i;return}function ju(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+496>>3];p=f;h[k>>3]=+h[n+7752>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+504>>3];q=+h[p+488>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];fA(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+6392>>3]=+h[l>>3];i=b;return}function ku(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+7752>>3]),1.0e-13);k=+h[g+496>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+6504|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+6504|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,14528,14520,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6504|0;p=o;h[p>>3]=m;i=d;return}function lu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+7728>>3];v=l;h[k>>3]=+h[t+7736>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];gxa(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+448>>3];w=+h[t+7744>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];vz(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Bz(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+496>>3];f=j;h[k>>3]=+h[q+7752>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];gxa(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+504>>3];y=+h[f+488>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];vz(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Bz(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+7136>>3]=+h[d+144>>3]*(w- +h[r>>3])*+h[d+1536>>3];i=b;return}function mu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+496>>3];p=f;h[k>>3]=+h[n+7752>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+504>>3];q=+h[p+488>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+9664>>3]=+h[l>>3];i=b;return}function nu(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+648>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7280>>3]=+h[(a?e+9672|0:e+9664|0)>>3];i=b;return}function ou(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+496>>3];p=f;h[k>>3]=+h[n+7752>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+504>>3];q=+h[p+488>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+9608>>3]=+h[l>>3];i=b;return}function pu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+3004>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+7040>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+7040|0;h[c[g+3008>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+7040>>3]);h[c[(c[f>>2]|0)+3012>>2]>>3]=k;_za(a,37)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+7040>>3]=+h[c[(c[f>>2]|0)+3004>>2]>>3];i=b;return}function qu(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+7088>>3]=+h[b+7040>>3]*+h[d+1536>>3]*+h[d+144>>3];i=i;return}function ru(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+648>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7328>>3]=+h[(a?e+9616|0:e+9608|0)>>3];i=b;return}function su(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;iA(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+488>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+6456>>3]=+yd(+(+h[d>>3]),+(+h[a+504>>3]*.999));i=b;return}function tu(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6456>>3];k=+zd(1.0e-13,+(+h[g+504>>3]-j));l=+h[g+7752>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+nwa(c[b+536>>2]|0,k,14576,14568,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6472>>3]=+yd(+(j*n*.6219647130774989),1.0);i=d;return}function uu(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+6488>>3]=+zd(+(+h[d+496>>3]- +h[d+6472>>3]),0.0);i=b;return}function vu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6480>>3]=+h[b+496>>3]- +h[b+6488>>3];i=i;return}function wu(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6488>>3];k=1.0-j;l=+h[g+7752>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+nwa(c[b+536>>2]|0,k,14648,14640,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+6488>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+6480>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+6520|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+6520|0;z=y;h[z>>3]=w;i=d;return}l=m/+nwa(c[b+536>>2]|0,p,14648,14640,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+6520|0;z=y;h[z>>3]=w;i=d;return}function xu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6528>>3]=+h[b+6544>>3]- +h[b+6520>>3]*+h[b+488>>3];i=i;return}function yu(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+488>>3]*+h[g+6520>>3];k=+h[g+504>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+6536|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+6536|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,14688,14680,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6536|0;p=o;h[p>>3]=m;i=d;return}function zu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7680>>3]=+h[b+1e4>>3]*+h[b+6536>>3];i=i;return}function Au(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7640>>3]=+h[b+496>>3]*+h[b+7680>>3];i=i;return}function Bu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7720>>3]=+h[b+7680>>3]*+h[b+6528>>3];i=i;return}function Cu(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+7680>>3];k=+h[g+7560>>3]- +h[g+496>>3]*+h[g+7600>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1152|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1152|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,14736,14728,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1152|0;p=o;h[p>>3]=m;i=d;return}function Du(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8640>>3]=-+h[b+1152>>3];i=i;return}function Eu(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+144>>3]*+h[j+6536>>3]*+h[e+1432>>3];l=+h[j+640>>3]+ +h[j+648>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6432|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6432|0;r=q;h[r>>3]=o;i=d;return}s=l/+nwa(c[b+536>>2]|0,k,14760,14752,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6432|0;r=q;h[r>>3]=o;i=d;return}function Fu(a){a=a|0;var b=0,d=0.0,e=0.0,f=0,g=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+6432>>3];e=+h[b+7336>>3];f=c[a+416>>2]|0;g=+h[f+144>>3];h[b+7184>>3]=+h[f+1536>>3]*(+h[b+9608>>3]*d*d*g- +h[b+9616>>3]*e*e*g);i=i;return}function Gu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7832>>3]=+h[b+7184>>3]+(-+h[b+7136>>3]- +h[b+7088>>3]);i=i;return}function Hu(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10048>>3];k=+h[g+7832>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1304|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1304|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,14832,14824,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1304|0;p=o;h[p>>3]=m;i=d;return}function Iu(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+504>>3];k=+h[g+496>>3];l=+h[g+6456>>3]*(k+ +h[g+7752>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+6496|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+6496|0;r=q;h[r>>3]=o;i=d;return}s=k/+nwa(c[b+536>>2]|0,l,14864,14856,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+6496|0;r=q;h[r>>3]=o;i=d;return}function Ju(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6456>>3];k=+zd(1.0e-13,+(+h[g+504>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+nwa(c[b+536>>2]|0,k,14576,14968,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+6464>>3]=m*.6219647130774989;i=d;return}function Ku(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;gxa(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+520>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+528>>3];l=+h[a+512>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];tA(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6656>>3]=+h[f>>3];i=b;return}function Lu(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+640>>3];h[b+7384>>3]=d*+h[(!(d>=0.0)?b+6544|0:b+6656|0)>>3];i=i;return}function Mu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7520>>3]=+h[b+7384>>3]- +h[b+7392>>3];i=i;return}function Nu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7760>>3]=1.0- +h[b+520>>3];i=i;return}function Ou(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+520>>3];p=f;h[k>>3]=+h[n+7760>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+528>>3];q=+h[p+512>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];fA(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+6384>>3]=+h[l>>3];i=b;return}function Pu(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+7760>>3]),1.0e-13);k=+h[g+520>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+6616|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+6616|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,14984,14976,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6616|0;p=o;h[p>>3]=m;i=d;return}function Qu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+496>>3];v=l;h[k>>3]=+h[t+7752>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];gxa(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+504>>3];w=+h[t+488>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];vz(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Bz(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+520>>3];f=j;h[k>>3]=+h[q+7760>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];gxa(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+528>>3];y=+h[f+512>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];vz(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Bz(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+7128>>3]=(+h[d+136>>3]+ +h[d+144>>3])*(w- +h[r>>3])*+h[d+1536>>3]*.5;i=b;return}function Ru(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+520>>3];p=f;h[k>>3]=+h[n+7760>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+528>>3];q=+h[p+512>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+9656>>3]=+h[l>>3];i=b;return}function Su(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+640>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7272>>3]=+h[(a?e+9664|0:e+9656|0)>>3];i=b;return}function Tu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+520>>3];p=f;h[k>>3]=+h[n+7760>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+528>>3];q=+h[p+512>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+9600>>3]=+h[l>>3];i=b;return}function Uu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+3084>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+7032>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+7032|0;h[c[g+3088>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+7032>>3]);h[c[(c[f>>2]|0)+3092>>2]>>3]=k;_za(a,38)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+7032>>3]=+h[c[(c[f>>2]|0)+3084>>2]>>3];i=b;return}function Vu(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+7080>>3]=+h[b+7032>>3]*(+h[d+136>>3]+ +h[d+144>>3])*+h[d+1536>>3]*.5;i=i;return}function Wu(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+7480>>3]=+h[b+6432>>3]*+h[d+144>>3]*+h[d+1432>>3]*((+h[b+448>>3]- +h[b+528>>3])/1.5+(+h[b+7032>>3]*.5+(+h[b+7040>>3]+ +h[d+1352>>3]*+h[b+6536>>3]*-10.0)));i=i;return}function Xu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8480>>3]=+h[b+7520>>3]+ +h[b+7480>>3];i=i;return}function Yu(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+7680>>3];k=+h[g+8480>>3]- +h[g+7600>>3]*+h[g+6528>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+7936|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+7936|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,14736,15024,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7936|0;p=o;h[p>>3]=m;i=d;return}function Zu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+3164>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1160>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1160|0;h[c[g+3168>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1160>>3]);e=c[f>>2]|0;h[c[e+3172>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+3164>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+1144>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+1144|0;h[(c[e+3168>>2]|0)+8>>3]=+h[g>>3];k=+aAa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+1144>>3]);h[(c[(c[f>>2]|0)+3172>>2]|0)+8>>3]=k;_za(a,39)|0;j=c[(c[f>>2]|0)+3164>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1160>>3]=+h[j>>3];h[f+1144>>3]=+h[j+8>>3];hS(a);iS(a);jS(a);kS(a);lS(a);mS(a);i=b;return}function _u(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+640>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7320>>3]=+h[(a?e+9608|0:e+9600|0)>>3];i=b;return}function $u(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;iA(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+512>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+6568>>3]=+yd(+(+h[d>>3]),+(+h[a+528>>3]*.999));i=b;return}function av(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6568>>3];k=+zd(1.0e-13,+(+h[g+528>>3]-j));l=+h[g+7760>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+nwa(c[b+536>>2]|0,k,15040,15032,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6584>>3]=+yd(+(j*n*.6219647130774989),1.0);i=d;return}function bv(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+6600>>3]=+zd(+(+h[d+520>>3]- +h[d+6584>>3]),0.0);i=b;return}function cv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6592>>3]=+h[b+520>>3]- +h[b+6600>>3];i=i;return}function dv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6600>>3];k=1.0-j;l=+h[g+7760>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+nwa(c[b+536>>2]|0,k,15112,15104,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+6600>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+6592>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+6632|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+6632|0;z=y;h[z>>3]=w;i=d;return}l=m/+nwa(c[b+536>>2]|0,p,15112,15104,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+6632|0;z=y;h[z>>3]=w;i=d;return}function ev(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6640>>3]=+h[b+6656>>3]- +h[b+6632>>3]*+h[b+512>>3];i=i;return}function fv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+512>>3]*+h[g+6632>>3];k=+h[g+528>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+6648|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+6648|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,15152,15144,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6648|0;p=o;h[p>>3]=m;i=d;return}function gv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7672>>3]=+h[b+9992>>3]*+h[b+6648>>3];i=i;return}function hv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7632>>3]=+h[b+520>>3]*+h[b+7672>>3];i=i;return}function iv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7712>>3]=+h[b+7672>>3]*+h[b+6640>>3];i=i;return}function jv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+7672>>3];k=+h[g+7552>>3]- +h[g+520>>3]*+h[g+7592>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1176|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1176|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,15200,15192,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1176|0;p=o;h[p>>3]=m;i=d;return}function kv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8632>>3]=-+h[b+1176>>3];i=i;return}function lv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+136>>3]*+h[j+6648>>3]*+h[e+1432>>3];l=+h[j+632>>3]+ +h[j+640>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6424|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6424|0;r=q;h[r>>3]=o;i=d;return}s=l/+nwa(c[b+536>>2]|0,k,15224,15216,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6424|0;r=q;h[r>>3]=o;i=d;return}function mv(a){a=a|0;var b=0,d=0.0,e=0.0,f=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+6424>>3];e=+h[b+6432>>3];f=c[a+416>>2]|0;h[b+7176>>3]=+h[f+1536>>3]*(+h[b+9600>>3]*d*d*+h[f+136>>3]- +h[b+9608>>3]*e*e*+h[f+144>>3]);i=i;return}function nv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7824>>3]=+h[b+7176>>3]+(-+h[b+7128>>3]- +h[b+7080>>3]);i=i;return}function ov(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10040>>3];k=+h[g+7824>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1296|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1296|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,15296,15288,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1296|0;p=o;h[p>>3]=m;i=d;return}function pv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+528>>3];k=+h[g+520>>3];l=+h[g+6568>>3]*(k+ +h[g+7760>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+6608|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+6608|0;r=q;h[r>>3]=o;i=d;return}s=k/+nwa(c[b+536>>2]|0,l,15328,15320,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+6608|0;r=q;h[r>>3]=o;i=d;return}function qv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6568>>3];k=+zd(1.0e-13,+(+h[g+528>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+nwa(c[b+536>>2]|0,k,15040,15432,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+6576>>3]=m*.6219647130774989;i=d;return}function rv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;gxa(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+544>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+552>>3];l=+h[a+536>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];tA(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6768>>3]=+h[f>>3];i=b;return}function sv(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+632>>3];h[b+7376>>3]=d*+h[(!(d>=0.0)?b+6656|0:b+6768|0)>>3];i=i;return}function tv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7512>>3]=+h[b+7376>>3]- +h[b+7384>>3];i=i;return}function uv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7768>>3]=1.0- +h[b+544>>3];i=i;return}function vv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+544>>3];p=f;h[k>>3]=+h[n+7768>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+552>>3];q=+h[p+536>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];fA(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+6376>>3]=+h[l>>3];i=b;return}function wv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+7768>>3]),1.0e-13);k=+h[g+544>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+6728|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+6728|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,15448,15440,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6728|0;p=o;h[p>>3]=m;i=d;return}function xv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+520>>3];v=l;h[k>>3]=+h[t+7760>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];gxa(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+528>>3];w=+h[t+512>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];vz(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Bz(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+544>>3];f=j;h[k>>3]=+h[q+7768>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];gxa(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+552>>3];y=+h[f+536>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];vz(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Bz(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+7120>>3]=(+h[d+128>>3]+ +h[d+136>>3])*(w- +h[r>>3])*+h[d+1536>>3]*.5;i=b;return}function yv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+544>>3];p=f;h[k>>3]=+h[n+7768>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+552>>3];q=+h[p+536>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+9648>>3]=+h[l>>3];i=b;return}function zv(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+632>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7264>>3]=+h[(a?e+9656|0:e+9648|0)>>3];i=b;return}function Av(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+544>>3];p=f;h[k>>3]=+h[n+7768>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+552>>3];q=+h[p+536>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+9592>>3]=+h[l>>3];i=b;return}function Bv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+3244>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+7024>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+7024|0;h[c[g+3248>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+7024>>3]);h[c[(c[f>>2]|0)+3252>>2]>>3]=k;_za(a,40)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+7024>>3]=+h[c[(c[f>>2]|0)+3244>>2]>>3];i=b;return}function Cv(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+7072>>3]=+h[b+7024>>3]*(+h[d+128>>3]+ +h[d+136>>3])*+h[d+1536>>3]*.5;i=i;return}function Dv(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+7472>>3]=+h[b+6424>>3]*+h[d+136>>3]*+h[d+1432>>3]*(+h[b+504>>3]*.5+(+h[b+552>>3]*-.5+((+h[b+7024>>3]+ +h[b+7032>>3])*.5+ +h[d+1352>>3]*+h[b+6648>>3]*-10.0)));i=i;return}function Ev(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8472>>3]=+h[b+7512>>3]+ +h[b+7472>>3];i=i;return}function Fv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+7672>>3];k=+h[g+8472>>3]- +h[g+7592>>3]*+h[g+6640>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+7912|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+7912|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,15200,15488,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7912|0;p=o;h[p>>3]=m;i=d;return}function Gv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+3324>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1168>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1168|0;h[c[g+3328>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1168>>3]);e=c[f>>2]|0;h[c[e+3332>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+3324>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+1184>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+1184|0;h[(c[e+3328>>2]|0)+8>>3]=+h[g>>3];k=+aAa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+1184>>3]);h[(c[(c[f>>2]|0)+3332>>2]|0)+8>>3]=k;_za(a,41)|0;j=c[(c[f>>2]|0)+3324>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1168>>3]=+h[j>>3];h[f+1184>>3]=+h[j+8>>3];rS(a);sS(a);tS(a);uS(a);vS(a);wS(a);i=b;return}function Hv(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+632>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7312>>3]=+h[(a?e+9600|0:e+9592|0)>>3];i=b;return}function Iv(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;iA(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+536>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+6680>>3]=+yd(+(+h[d>>3]),+(+h[a+552>>3]*.999));i=b;return}function Jv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6680>>3];k=+zd(1.0e-13,+(+h[g+552>>3]-j));l=+h[g+7768>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+nwa(c[b+536>>2]|0,k,15504,15496,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6696>>3]=+yd(+(j*n*.6219647130774989),1.0);i=d;return}function Kv(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+6712>>3]=+zd(+(+h[d+544>>3]- +h[d+6696>>3]),0.0);i=b;return}function Lv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6704>>3]=+h[b+544>>3]- +h[b+6712>>3];i=i;return}function Mv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6712>>3];k=1.0-j;l=+h[g+7768>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+nwa(c[b+536>>2]|0,k,15576,15568,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+6712>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+6704>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+6744|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+6744|0;z=y;h[z>>3]=w;i=d;return}l=m/+nwa(c[b+536>>2]|0,p,15576,15568,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+6744|0;z=y;h[z>>3]=w;i=d;return}function Nv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6752>>3]=+h[b+6768>>3]- +h[b+6744>>3]*+h[b+536>>3];i=i;return}function Ov(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+536>>3]*+h[g+6744>>3];k=+h[g+552>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+6760|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+6760|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,15616,15608,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6760|0;p=o;h[p>>3]=m;i=d;return}function Pv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7664>>3]=+h[b+9984>>3]*+h[b+6760>>3];i=i;return}function Qv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7624>>3]=+h[b+544>>3]*+h[b+7664>>3];i=i;return}function Rv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7704>>3]=+h[b+7664>>3]*+h[b+6752>>3];i=i;return}function Sv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+7664>>3];k=+h[g+7544>>3]- +h[g+544>>3]*+h[g+7584>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1200|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1200|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,15664,15656,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1200|0;p=o;h[p>>3]=m;i=d;return}function Tv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8624>>3]=-+h[b+1200>>3];i=i;return}function Uv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+128>>3]*+h[j+6760>>3]*+h[e+1432>>3];l=+h[j+624>>3]+ +h[j+632>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6416|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6416|0;r=q;h[r>>3]=o;i=d;return}s=l/+nwa(c[b+536>>2]|0,k,15688,15680,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6416|0;r=q;h[r>>3]=o;i=d;return}function Vv(a){a=a|0;var b=0,d=0.0,e=0.0,f=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+6416>>3];e=+h[b+6424>>3];f=c[a+416>>2]|0;h[b+7168>>3]=+h[f+1536>>3]*(+h[b+9592>>3]*d*d*+h[f+128>>3]- +h[b+9600>>3]*e*e*+h[f+136>>3]);i=i;return}function Wv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7816>>3]=+h[b+7168>>3]+(-+h[b+7120>>3]- +h[b+7072>>3]);i=i;return}function Xv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10032>>3];k=+h[g+7816>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1288|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1288|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,15760,15752,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1288|0;p=o;h[p>>3]=m;i=d;return}function Yv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+552>>3];k=+h[g+544>>3];l=+h[g+6680>>3]*(k+ +h[g+7768>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+6720|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+6720|0;r=q;h[r>>3]=o;i=d;return}s=k/+nwa(c[b+536>>2]|0,l,15792,15784,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+6720|0;r=q;h[r>>3]=o;i=d;return}function Zv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6680>>3];k=+zd(1.0e-13,+(+h[g+552>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+nwa(c[b+536>>2]|0,k,15504,15896,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+6688>>3]=m*.6219647130774989;i=d;return}function _v(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;gxa(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+568>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+576>>3];l=+h[a+560>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];tA(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6880>>3]=+h[f>>3];i=b;return}function $v(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+624>>3];h[b+7368>>3]=d*+h[(!(d>=0.0)?b+6768|0:b+6880|0)>>3];i=i;return}function aw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7504>>3]=+h[b+7368>>3]- +h[b+7376>>3];i=i;return}function bw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7776>>3]=1.0- +h[b+568>>3];i=i;return}function cw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+568>>3];p=f;h[k>>3]=+h[n+7776>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+576>>3];q=+h[p+560>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];fA(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+6368>>3]=+h[l>>3];i=b;return}



function Dl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1896>>3];k=+zd(1.0e-13,+(+h[g+112>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+nwa(c[b+536>>2]|0,k,6888,7280,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+1904>>3]=m*.6219647130774989;i=d;return}function El(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2224>>3]=+h[b+160>>3]*+h[b+10480>>3];i=i;return}function Fl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2216>>3]=+h[b+152>>3]*+h[b+10472>>3];i=i;return}function Gl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2208>>3]=+h[b+144>>3]*+h[b+10464>>3];i=i;return}function Hl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2200>>3]=+h[b+136>>3]*+h[b+10456>>3];i=i;return}function Il(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2192>>3]=+h[b+128>>3]*+h[b+10448>>3];i=i;return}function Jl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2184>>3]=+h[b+120>>3]*+h[b+10440>>3];i=i;return}function Kl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;gxa(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+176>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+184>>3];l=+h[a+168>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];tA(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3088>>3]=+h[f>>3];i=b;return}function Ll(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0.0;d=i;i=i+120|0;e=d;f=d+96|0;g=d+112|0;j=i;i=i+16|0;k=i;i=i+96|0;l=i;i=i+8|0;m=b+4|0;n=c[c[m>>2]>>2]|0;o=c[n+8>>2]|0;p=+zd(+(+h[o+328>>3]),1.0e-15);q=+zd(+-+h[o+120>>3],1.0e-15);r=p+q;s=p*+h[o+176>>3]+q*+h[o+104>>3];do{if(r!=0.0){t=s/r}else{if(s==0.0){t=s;break}t=s/+nwa(c[b+536>>2]|0,r,2520,7288,+h[n>>3],(a[b+319|0]|0)!=0|0)}}while(0);gxa(j,1,t,g);c[k>>2]=4216;h[k+8>>3]=.01801528;h[k+16>>3]=-13423382.81725291;h[k+24>>3]=549760.6476280135;h[k+32>>3]=1.0e3;g=k+40|0;n=4224;c[g+0>>2]=c[n+0>>2];c[g+4>>2]=c[n+4>>2];c[g+8>>2]=c[n+8>>2];n=k+52|0;g=4240;c[n+0>>2]=c[g+0>>2];c[n+4>>2]=c[g+4>>2];c[n+8>>2]=c[g+8>>2];g=k+64|0;n=4256;c[g+0>>2]=c[n+0>>2];c[g+4>>2]=c[n+4>>2];c[g+8>>2]=c[n+8>>2];n=k+76|0;g=4272;c[n+0>>2]=c[g+0>>2];c[n+4>>2]=c[g+4>>2];c[n+8>>2]=c[g+8>>2];h[k+88>>3]=461.5233290850878;g=c[b+536>>2]|0;n=c[c[m>>2]>>2]|0;o=c[n+8>>2]|0;t=+zd(+(+h[o+328>>3]),1.0e-15);r=+zd(+-+h[o+120>>3],1.0e-15);s=t+r;q=t*+h[o+3088>>3]+r*+h[o+1984>>3];do{if(s!=0.0){u=o;v=q/s}else{if(q==0.0){u=o;v=q;break}r=q/+nwa(g,s,2520,7288,+h[n>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[m>>2]>>2]|0)+8>>2]|0;v=r}}while(0);s=+h[u+352>>3];u=f;b=j;c[u+0>>2]=c[b+0>>2];c[u+4>>2]=c[b+4>>2];c[u+8>>2]=c[b+8>>2];b=e+0|0;u=k+0|0;k=b+96|0;do{c[b>>2]=c[u>>2];b=b+4|0;u=u+4|0}while((b|0)<(k|0));nA(l,g,v,190.0,647.0,s,f,e,1.0e-13);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+10768>>3]=+h[l>>3];i=d;return}function Ml(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4408>>3]=1.0- +h[b+176>>3];i=i;return}function Nl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+176>>3];p=f;h[k>>3]=+h[n+4408>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+184>>3];q=+h[p+168>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];fA(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2936>>3]=+h[l>>3];i=b;return}function Ol(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+4408>>3]),1.0e-13);k=+h[g+176>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+3048|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+3048|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,7304,7296,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+3048|0;p=o;h[p>>3]=m;i=d;return}function Pl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+176>>3];p=f;h[k>>3]=+h[n+4408>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+184>>3];q=+h[p+168>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+3872>>3]=+h[l>>3];i=b;return}function Ql(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+176>>3];p=f;h[k>>3]=+h[n+4408>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+184>>3];q=+h[p+168>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+3976>>3]=+h[l>>3];i=b;return}function Rl(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;iA(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+168>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+3e3>>3]=+yd(+(+h[d>>3]),+(+h[a+184>>3]*.999));i=b;return}function Sl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3e3>>3];k=+zd(1.0e-13,+(+h[g+184>>3]-j));l=+h[g+4408>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+nwa(c[b+536>>2]|0,k,7352,7344,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+3016>>3]=+yd(+(j*n*.6219647130774989),1.0);i=d;return}function Tl(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3032>>3]=+zd(+(+h[d+176>>3]- +h[d+3016>>3]),0.0);i=b;return}function Ul(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3024>>3]=+h[b+176>>3]- +h[b+3032>>3];i=i;return}function Vl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3032>>3];k=1.0-j;l=+h[g+4408>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+nwa(c[b+536>>2]|0,k,7424,7416,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+3032>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+3024>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+3064|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+3064|0;z=y;h[z>>3]=w;i=d;return}l=m/+nwa(c[b+536>>2]|0,p,7424,7416,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+3064|0;z=y;h[z>>3]=w;i=d;return}function Wl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3072>>3]=+h[b+3088>>3]- +h[b+3064>>3]*+h[b+168>>3];i=i;return}function Xl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+168>>3]*+h[g+3064>>3];k=+h[g+184>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+3080|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+3080|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,7464,7456,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+3080|0;p=o;h[p>>3]=m;i=d;return}function Yl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4336>>3]=+h[b+10296>>3]*+h[b+3080>>3];i=i;return}function Zl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4296>>3]=+h[b+176>>3]*+h[b+4336>>3];i=i;return}function _l(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4376>>3]=+h[b+4336>>3]*+h[b+3072>>3];i=i;return}function $l(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4336>>3];k=+h[g+4216>>3]- +h[g+176>>3]*+h[g+4256>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+832|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+832|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,7512,7504,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+832|0;p=o;h[p>>3]=m;i=d;return}function am(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8960>>3]=-+h[b+832>>3];i=i;return}function bm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+736>>3]*+h[j+3080>>3]*+h[e+1888>>3];l=+h[j+320>>3]+ +h[j+328>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+2976|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+2976|0;r=q;h[r>>3]=o;i=d;return}s=l/+nwa(c[b+536>>2]|0,k,7536,7528,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+2976|0;r=q;h[r>>3]=o;i=d;return}function cm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+184>>3];k=+h[g+176>>3];l=+h[g+3e3>>3]*(k+ +h[g+4408>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+3040|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+3040|0;r=q;h[r>>3]=o;i=d;return}s=k/+nwa(c[b+536>>2]|0,l,7608,7600,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+3040|0;r=q;h[r>>3]=o;i=d;return}function dm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3e3>>3];k=+zd(1.0e-13,+(+h[g+184>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+nwa(c[b+536>>2]|0,k,7352,7712,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+3008>>3]=m*.6219647130774989;i=d;return}function em(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;gxa(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+200>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+208>>3];l=+h[a+192>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];tA(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3200>>3]=+h[f>>3];i=b;return}function fm(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+320>>3];h[b+4040>>3]=d*+h[(!(d>=0.0)?b+3088|0:b+3200|0)>>3];i=i;return}function gm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4416>>3]=1.0- +h[b+200>>3];i=i;return}function hm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+200>>3];p=f;h[k>>3]=+h[n+4416>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+208>>3];q=+h[p+192>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];fA(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2928>>3]=+h[l>>3];i=b;return}function im(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+4416>>3]),1.0e-13);k=+h[g+200>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+3160|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+3160|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,7728,7720,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+3160|0;p=o;h[p>>3]=m;i=d;return}function jm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+176>>3];v=l;h[k>>3]=+h[t+4408>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];gxa(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+184>>3];w=+h[t+168>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];vz(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Bz(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+200>>3];f=j;h[k>>3]=+h[q+4416>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];gxa(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+208>>3];y=+h[f+192>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];vz(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Bz(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+3672>>3]=(+h[d+728>>3]+ +h[d+736>>3])*(w- +h[r>>3])*+h[d+1992>>3]*.5;i=b;return}function km(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+200>>3];p=f;h[k>>3]=+h[n+4416>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+208>>3];q=+h[p+192>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+3864>>3]=+h[l>>3];i=b;return}function lm(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+320>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3816>>3]=+h[(a?e+3872|0:e+3864|0)>>3];i=b;return}function mm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+200>>3];p=f;h[k>>3]=+h[n+4416>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+208>>3];q=+h[p+192>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+3968>>3]=+h[l>>3];i=b;return}function nm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+844>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+3576>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+3576|0;h[c[g+848>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+3576>>3]);h[c[(c[f>>2]|0)+852>>2]>>3]=k;_za(a,10)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3576>>3]=+h[c[(c[f>>2]|0)+844>>2]>>3];i=b;return}function om(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3624>>3]=+h[b+3576>>3]*(+h[d+728>>3]+ +h[d+736>>3])*+h[d+1992>>3]*.5;i=i;return}function pm(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+320>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3920>>3]=+h[(a?e+3976|0:e+3968|0)>>3];i=b;return}function qm(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;iA(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+192>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+3112>>3]=+yd(+(+h[d>>3]),+(+h[a+208>>3]*.999));i=b;return}function rm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3112>>3];k=+zd(1.0e-13,+(+h[g+208>>3]-j));l=+h[g+4416>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+nwa(c[b+536>>2]|0,k,7776,7768,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+3128>>3]=+yd(+(j*n*.6219647130774989),1.0);i=d;return}function sm(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3144>>3]=+zd(+(+h[d+200>>3]- +h[d+3128>>3]),0.0);i=b;return}function tm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3136>>3]=+h[b+200>>3]- +h[b+3144>>3];i=i;return}function um(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3144>>3];k=1.0-j;l=+h[g+4416>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+nwa(c[b+536>>2]|0,k,7848,7840,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+3144>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+3136>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+3176|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+3176|0;z=y;h[z>>3]=w;i=d;return}l=m/+nwa(c[b+536>>2]|0,p,7848,7840,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+3176|0;z=y;h[z>>3]=w;i=d;return}function vm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3184>>3]=+h[b+3200>>3]- +h[b+3176>>3]*+h[b+192>>3];i=i;return}function wm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+192>>3]*+h[g+3176>>3];k=+h[g+208>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+3192|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+3192|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,7888,7880,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+3192|0;p=o;h[p>>3]=m;i=d;return}function xm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4328>>3]=+h[b+10288>>3]*+h[b+3192>>3];i=i;return}function ym(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4288>>3]=+h[b+200>>3]*+h[b+4328>>3];i=i;return}function zm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4368>>3]=+h[b+4328>>3]*+h[b+3184>>3];i=i;return}function Am(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4328>>3];k=+h[g+4208>>3]- +h[g+200>>3]*+h[g+4248>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+856|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+856|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,7936,7928,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+856|0;p=o;h[p>>3]=m;i=d;return}function Bm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8952>>3]=-+h[b+856>>3];i=i;return}function Cm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+728>>3]*+h[j+3192>>3]*+h[e+1888>>3];l=+h[j+312>>3]+ +h[j+320>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+2968|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+2968|0;r=q;h[r>>3]=o;i=d;return}s=l/+nwa(c[b+536>>2]|0,k,7960,7952,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+2968|0;r=q;h[r>>3]=o;i=d;return}function Dm(a){a=a|0;var b=0,d=0.0,e=0.0,f=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+2968>>3];e=+h[b+2976>>3];f=c[a+416>>2]|0;h[b+3720>>3]=+h[f+1992>>3]*(+h[b+3968>>3]*d*d*+h[f+728>>3]- +h[b+3976>>3]*e*e*+h[f+736>>3]);i=i;return}function Em(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8144>>3]=+h[b+3720>>3]+(-+h[b+3672>>3]- +h[b+3624>>3]);i=i;return}function Fm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10336>>3];k=+h[g+8144>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+976|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+976|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,8032,8024,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+976|0;p=o;h[p>>3]=m;i=d;return}function Gm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+208>>3];k=+h[g+200>>3];l=+h[g+3112>>3]*(k+ +h[g+4416>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+3152|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+3152|0;r=q;h[r>>3]=o;i=d;return}s=k/+nwa(c[b+536>>2]|0,l,8064,8056,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+3152|0;r=q;h[r>>3]=o;i=d;return}function Hm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3112>>3];k=+zd(1.0e-13,+(+h[g+208>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+nwa(c[b+536>>2]|0,k,7776,8168,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+3120>>3]=m*.6219647130774989;i=d;return}function Im(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;gxa(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+224>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+232>>3];l=+h[a+216>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];tA(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3312>>3]=+h[f>>3];i=b;return}function Jm(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+312>>3];h[b+4032>>3]=d*+h[(!(d>=0.0)?b+3200|0:b+3312|0)>>3];i=i;return}function Km(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4168>>3]=+h[b+4032>>3]- +h[b+4040>>3];i=i;return}function Lm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4424>>3]=1.0- +h[b+224>>3];i=i;return}function Mm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+224>>3];p=f;h[k>>3]=+h[n+4424>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+232>>3];q=+h[p+216>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];fA(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2920>>3]=+h[l>>3];i=b;return}function Nm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+4424>>3]),1.0e-13);k=+h[g+224>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+3272|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+3272|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,8184,8176,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+3272|0;p=o;h[p>>3]=m;i=d;return}function Om(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+200>>3];v=l;h[k>>3]=+h[t+4416>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];gxa(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+208>>3];w=+h[t+192>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];vz(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Bz(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+224>>3];f=j;h[k>>3]=+h[q+4424>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];gxa(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+232>>3];y=+h[f+216>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];vz(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Bz(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+3664>>3]=(+h[d+720>>3]+ +h[d+728>>3])*(w- +h[r>>3])*+h[d+1992>>3]*.5;i=b;return}function Pm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+224>>3];p=f;h[k>>3]=+h[n+4424>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+232>>3];q=+h[p+216>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+3856>>3]=+h[l>>3];i=b;return}function Qm(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+312>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3808>>3]=+h[(a?e+3864|0:e+3856|0)>>3];i=b;return}function Rm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+224>>3];p=f;h[k>>3]=+h[n+4424>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+232>>3];q=+h[p+216>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+3960>>3]=+h[l>>3];i=b;return}function Sm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+924>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+3568>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+3568|0;h[c[g+928>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+3568>>3]);h[c[(c[f>>2]|0)+932>>2]>>3]=k;_za(a,11)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3568>>3]=+h[c[(c[f>>2]|0)+924>>2]>>3];i=b;return}function Tm(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3616>>3]=+h[b+3568>>3]*(+h[d+720>>3]+ +h[d+728>>3])*+h[d+1992>>3]*.5;i=i;return}function Um(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+4128>>3]=+h[b+2968>>3]*+h[d+728>>3]*+h[d+1888>>3]*(+h[b+184>>3]*.5+(+h[b+232>>3]*-.5+((+h[b+3568>>3]+ +h[b+3576>>3])*.5+ +h[d+1352>>3]*+h[b+3192>>3]*-5.0)));i=i;return}function Vm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8552>>3]=+h[b+4168>>3]+ +h[b+4128>>3];i=i;return}function Wm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4328>>3];k=+h[g+8552>>3]- +h[g+4248>>3]*+h[g+3184>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+8232|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+8232|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,7936,8224,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+8232|0;p=o;h[p>>3]=m;i=d;return}function Xm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1004>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+864>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+864|0;h[c[g+1008>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+864>>3]);e=c[f>>2]|0;h[c[e+1012>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+1004>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+848>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+848|0;h[(c[e+1008>>2]|0)+8>>3]=+h[g>>3];k=+aAa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+848>>3]);h[(c[(c[f>>2]|0)+1012>>2]|0)+8>>3]=k;_za(a,12)|0;j=c[(c[f>>2]|0)+1004>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+864>>3]=+h[j>>3];h[f+848>>3]=+h[j+8>>3];XP(a);YP(a);ZP(a);_P(a);$P(a);aQ(a);i=b;return}function Ym(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+312>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3912>>3]=+h[(a?e+3968|0:e+3960|0)>>3];i=b;return}function Zm(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;iA(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+216>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+3224>>3]=+yd(+(+h[d>>3]),+(+h[a+232>>3]*.999));i=b;return}function _m(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3224>>3];k=+zd(1.0e-13,+(+h[g+232>>3]-j));l=+h[g+4424>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+nwa(c[b+536>>2]|0,k,8240,8232,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+3240>>3]=+yd(+(j*n*.6219647130774989),1.0);i=d;return}function $m(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3256>>3]=+zd(+(+h[d+224>>3]- +h[d+3240>>3]),0.0);i=b;return}function an(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3248>>3]=+h[b+224>>3]- +h[b+3256>>3];i=i;return}function bn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3256>>3];k=1.0-j;l=+h[g+4424>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+nwa(c[b+536>>2]|0,k,8312,8304,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+3256>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+3248>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+3288|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+3288|0;z=y;h[z>>3]=w;i=d;return}l=m/+nwa(c[b+536>>2]|0,p,8312,8304,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+3288|0;z=y;h[z>>3]=w;i=d;return}function cn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3296>>3]=+h[b+3312>>3]- +h[b+3288>>3]*+h[b+216>>3];i=i;return}function dn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+216>>3]*+h[g+3288>>3];k=+h[g+232>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+3304|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+3304|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,8352,8344,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+3304|0;p=o;h[p>>3]=m;i=d;return}function en(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4320>>3]=+h[b+10280>>3]*+h[b+3304>>3];i=i;return}function fn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4280>>3]=+h[b+224>>3]*+h[b+4320>>3];i=i;return}function gn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4360>>3]=+h[b+4320>>3]*+h[b+3296>>3];i=i;return}function hn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4320>>3];k=+h[g+4200>>3]- +h[g+224>>3]*+h[g+4240>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+880|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+880|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,8400,8392,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+880|0;p=o;h[p>>3]=m;i=d;return}function jn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8944>>3]=-+h[b+880>>3];i=i;return}function kn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+720>>3]*+h[j+3304>>3]*+h[e+1888>>3];l=+h[j+304>>3]+ +h[j+312>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+2960|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+2960|0;r=q;h[r>>3]=o;i=d;return}s=l/+nwa(c[b+536>>2]|0,k,8424,8416,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+2960|0;r=q;h[r>>3]=o;i=d;return}function ln(a){a=a|0;var b=0,d=0.0,e=0.0,f=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+2960>>3];e=+h[b+2968>>3];f=c[a+416>>2]|0;h[b+3712>>3]=+h[f+1992>>3]*(+h[b+3960>>3]*d*d*+h[f+720>>3]- +h[b+3968>>3]*e*e*+h[f+728>>3]);i=i;return}function mn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8136>>3]=+h[b+3712>>3]+(-+h[b+3664>>3]- +h[b+3616>>3]);i=i;return}function nn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10328>>3];k=+h[g+8136>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+968|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+968|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,8496,8488,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+968|0;p=o;h[p>>3]=m;i=d;return}function on(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+232>>3];k=+h[g+224>>3];l=+h[g+3224>>3]*(k+ +h[g+4424>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+3264|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+3264|0;r=q;h[r>>3]=o;i=d;return}s=k/+nwa(c[b+536>>2]|0,l,8528,8520,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+3264|0;r=q;h[r>>3]=o;i=d;return}function pn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3224>>3];k=+zd(1.0e-13,+(+h[g+232>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+nwa(c[b+536>>2]|0,k,8240,8632,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+3232>>3]=m*.6219647130774989;i=d;return}function qn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;gxa(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+248>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+256>>3];l=+h[a+240>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];tA(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3424>>3]=+h[f>>3];i=b;return}function rn(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+304>>3];h[b+4024>>3]=d*+h[(!(d>=0.0)?b+3312|0:b+3424|0)>>3];i=i;return}function sn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4160>>3]=+h[b+4024>>3]- +h[b+4032>>3];i=i;return}function tn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4432>>3]=1.0- +h[b+248>>3];i=i;return}function un(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+248>>3];p=f;h[k>>3]=+h[n+4432>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+256>>3];q=+h[p+240>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];fA(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2912>>3]=+h[l>>3];i=b;return}function vn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+4432>>3]),1.0e-13);k=+h[g+248>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+3384|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+3384|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,8648,8640,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+3384|0;p=o;h[p>>3]=m;i=d;return}function wn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+224>>3];v=l;h[k>>3]=+h[t+4424>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];gxa(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+232>>3];w=+h[t+216>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];vz(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Bz(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+248>>3];f=j;h[k>>3]=+h[q+4432>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];gxa(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+256>>3];y=+h[f+240>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];vz(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Bz(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+3656>>3]=(+h[d+712>>3]+ +h[d+720>>3])*(w- +h[r>>3])*+h[d+1992>>3]*.5;i=b;return}function xn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+248>>3];p=f;h[k>>3]=+h[n+4432>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+256>>3];q=+h[p+240>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+3848>>3]=+h[l>>3];i=b;return}function yn(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+304>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3800>>3]=+h[(a?e+3856|0:e+3848|0)>>3];i=b;return}function zn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+248>>3];p=f;h[k>>3]=+h[n+4432>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+256>>3];q=+h[p+240>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+3952>>3]=+h[l>>3];i=b;return}function An(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1084>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+3560>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+3560|0;h[c[g+1088>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+3560>>3]);h[c[(c[f>>2]|0)+1092>>2]>>3]=k;_za(a,13)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3560>>3]=+h[c[(c[f>>2]|0)+1084>>2]>>3];i=b;return}function Bn(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3608>>3]=+h[b+3560>>3]*(+h[d+712>>3]+ +h[d+720>>3])*+h[d+1992>>3]*.5;i=i;return}function Cn(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+4120>>3]=+h[b+2960>>3]*+h[d+720>>3]*+h[d+1888>>3]*(+h[b+208>>3]*.5+(+h[b+256>>3]*-.5+((+h[b+3560>>3]+ +h[b+3568>>3])*.5+ +h[d+1352>>3]*+h[b+3304>>3]*-5.0)));i=i;return}function Dn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8544>>3]=+h[b+4160>>3]+ +h[b+4120>>3];i=i;return}function En(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4320>>3];k=+h[g+8544>>3]- +h[g+4240>>3]*+h[g+3296>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+8208|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+8208|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,8400,8688,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+8208|0;p=o;h[p>>3]=m;i=d;return}function Fn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1164>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+872>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+872|0;h[c[g+1168>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+872>>3]);e=c[f>>2]|0;h[c[e+1172>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+1164>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+888>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+888|0;h[(c[e+1168>>2]|0)+8>>3]=+h[g>>3];k=+aAa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+888>>3]);h[(c[(c[f>>2]|0)+1172>>2]|0)+8>>3]=k;_za(a,14)|0;j=c[(c[f>>2]|0)+1164>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+872>>3]=+h[j>>3];h[f+888>>3]=+h[j+8>>3];fQ(a);gQ(a);hQ(a);iQ(a);jQ(a);kQ(a);i=b;return}function Gn(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+304>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3904>>3]=+h[(a?e+3960|0:e+3952|0)>>3];i=b;return}function Hn(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;iA(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+240>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+3336>>3]=+yd(+(+h[d>>3]),+(+h[a+256>>3]*.999));i=b;return}function In(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3336>>3];k=+zd(1.0e-13,+(+h[g+256>>3]-j));l=+h[g+4432>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+nwa(c[b+536>>2]|0,k,8704,8696,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+3352>>3]=+yd(+(j*n*.6219647130774989),1.0);i=d;return}function Jn(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3368>>3]=+zd(+(+h[d+248>>3]- +h[d+3352>>3]),0.0);i=b;return}function Kn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3360>>3]=+h[b+248>>3]- +h[b+3368>>3];i=i;return}function Ln(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3368>>3];k=1.0-j;l=+h[g+4432>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+nwa(c[b+536>>2]|0,k,8776,8768,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+3368>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+3360>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+3400|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+3400|0;z=y;h[z>>3]=w;i=d;return}l=m/+nwa(c[b+536>>2]|0,p,8776,8768,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+3400|0;z=y;h[z>>3]=w;i=d;return}function Mn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3408>>3]=+h[b+3424>>3]- +h[b+3400>>3]*+h[b+240>>3];i=i;return}function Nn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+240>>3]*+h[g+3400>>3];k=+h[g+256>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+3416|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+3416|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,8816,8808,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+3416|0;p=o;h[p>>3]=m;i=d;return}function On(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4312>>3]=+h[b+10272>>3]*+h[b+3416>>3];i=i;return}function Pn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4272>>3]=+h[b+248>>3]*+h[b+4312>>3];i=i;return}function Qn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4352>>3]=+h[b+4312>>3]*+h[b+3408>>3];i=i;return}function Rn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4312>>3];k=+h[g+4192>>3]- +h[g+248>>3]*+h[g+4232>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+904|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+904|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,8864,8856,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+904|0;p=o;h[p>>3]=m;i=d;return}function Sn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8936>>3]=-+h[b+904>>3];i=i;return}function Tn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+712>>3]*+h[j+3416>>3]*+h[e+1888>>3];l=+h[j+296>>3]+ +h[j+304>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+2952|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+2952|0;r=q;h[r>>3]=o;i=d;return}s=l/+nwa(c[b+536>>2]|0,k,8888,8880,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+2952|0;r=q;h[r>>3]=o;i=d;return}function Un(a){a=a|0;var b=0,d=0.0,e=0.0,f=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+2952>>3];e=+h[b+2960>>3];f=c[a+416>>2]|0;h[b+3704>>3]=+h[f+1992>>3]*(+h[b+3952>>3]*d*d*+h[f+712>>3]- +h[b+3960>>3]*e*e*+h[f+720>>3]);i=i;return}function Vn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8128>>3]=+h[b+3704>>3]+(-+h[b+3656>>3]- +h[b+3608>>3]);i=i;return}function Wn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10320>>3];k=+h[g+8128>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+960|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+960|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,8960,8952,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+960|0;p=o;h[p>>3]=m;i=d;return}function Xn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+256>>3];k=+h[g+248>>3];l=+h[g+3336>>3]*(k+ +h[g+4432>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+3376|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+3376|0;r=q;h[r>>3]=o;i=d;return}s=k/+nwa(c[b+536>>2]|0,l,8992,8984,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+3376|0;r=q;h[r>>3]=o;i=d;return}function Yn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3336>>3];k=+zd(1.0e-13,+(+h[g+256>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+nwa(c[b+536>>2]|0,k,8704,9096,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+3344>>3]=m*.6219647130774989;i=d;return}function Zn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;gxa(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+272>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+280>>3];l=+h[a+264>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];tA(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3536>>3]=+h[f>>3];i=b;return}function _n(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+296>>3];h[b+4016>>3]=d*+h[(!(d>=0.0)?b+3424|0:b+3536|0)>>3];i=i;return}function $n(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4152>>3]=+h[b+4016>>3]- +h[b+4024>>3];i=i;return}function ao(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4440>>3]=1.0- +h[b+272>>3];i=i;return}function bo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+272>>3];p=f;h[k>>3]=+h[n+4440>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+280>>3];q=+h[p+264>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];fA(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2904>>3]=+h[l>>3];i=b;return}function co(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+4440>>3]),1.0e-13);k=+h[g+272>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+3496|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+3496|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,9112,9104,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+3496|0;p=o;h[p>>3]=m;i=d;return}function eo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+248>>3];v=l;h[k>>3]=+h[t+4432>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];gxa(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+256>>3];w=+h[t+240>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];vz(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Bz(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+272>>3];f=j;h[k>>3]=+h[q+4440>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];gxa(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+280>>3];y=+h[f+264>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];vz(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Bz(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+3648>>3]=(+h[d+704>>3]+ +h[d+712>>3])*(w- +h[r>>3])*+h[d+1992>>3]*.5;i=b;return}function fo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+272>>3];p=f;h[k>>3]=+h[n+4440>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+280>>3];q=+h[p+264>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+3840>>3]=+h[l>>3];i=b;return}function go(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+296>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3792>>3]=+h[(a?e+3848|0:e+3840|0)>>3];i=b;return}function ho(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+272>>3];p=f;h[k>>3]=+h[n+4440>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+280>>3];q=+h[p+264>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+3944>>3]=+h[l>>3];i=b;return}function io(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1244>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+3552>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+3552|0;h[c[g+1248>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+3552>>3]);h[c[(c[f>>2]|0)+1252>>2]>>3]=k;_za(a,15)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3552>>3]=+h[c[(c[f>>2]|0)+1244>>2]>>3];i=b;return}function jo(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3600>>3]=+h[b+3552>>3]*(+h[d+704>>3]+ +h[d+712>>3])*+h[d+1992>>3]*.5;i=i;return}function ko(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+4112>>3]=+h[b+2952>>3]*+h[d+712>>3]*+h[d+1888>>3]*(+h[b+232>>3]*.5+(+h[b+280>>3]*-.5+((+h[b+3552>>3]+ +h[b+3560>>3])*.5+ +h[d+1352>>3]*+h[b+3416>>3]*-5.0)));i=i;return}function lo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8536>>3]=+h[b+4152>>3]+ +h[b+4112>>3];i=i;return}function mo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4312>>3];k=+h[g+8536>>3]- +h[g+4232>>3]*+h[g+3408>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+8184|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+8184|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,8864,9152,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+8184|0;p=o;h[p>>3]=m;i=d;return}function no(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1324>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+912>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+912|0;h[c[g+1328>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+912>>3]);e=c[f>>2]|0;h[c[e+1332>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+1324>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+896>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+896|0;h[(c[e+1328>>2]|0)+8>>3]=+h[g>>3];k=+aAa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+896>>3]);h[(c[(c[f>>2]|0)+1332>>2]|0)+8>>3]=k;_za(a,16)|0;j=c[(c[f>>2]|0)+1324>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+912>>3]=+h[j>>3];h[f+896>>3]=+h[j+8>>3];pQ(a);qQ(a);rQ(a);sQ(a);tQ(a);uQ(a);i=b;return}function oo(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+296>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3896>>3]=+h[(a?e+3952|0:e+3944|0)>>3];i=b;return}function po(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;iA(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+264>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+3448>>3]=+yd(+(+h[d>>3]),+(+h[a+280>>3]*.999));i=b;return}function qo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3448>>3];k=+zd(1.0e-13,+(+h[g+280>>3]-j));l=+h[g+4440>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+nwa(c[b+536>>2]|0,k,9168,9160,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+3464>>3]=+yd(+(j*n*.6219647130774989),1.0);i=d;return}function ro(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3480>>3]=+zd(+(+h[d+272>>3]- +h[d+3464>>3]),0.0);i=b;return}function so(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3472>>3]=+h[b+272>>3]- +h[b+3480>>3];i=i;return}function to(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3480>>3];k=1.0-j;l=+h[g+4440>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+nwa(c[b+536>>2]|0,k,9240,9232,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+3480>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+3472>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+3512|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+3512|0;z=y;h[z>>3]=w;i=d;return}l=m/+nwa(c[b+536>>2]|0,p,9240,9232,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+3512|0;z=y;h[z>>3]=w;i=d;return}function uo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3520>>3]=+h[b+3536>>3]- +h[b+3512>>3]*+h[b+264>>3];i=i;return}function vo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+264>>3]*+h[g+3512>>3];k=+h[g+280>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+3528|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+3528|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,9280,9272,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+3528|0;p=o;h[p>>3]=m;i=d;return}function wo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4304>>3]=+h[b+10264>>3]*+h[b+3528>>3];i=i;return}function xo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4264>>3]=+h[b+272>>3]*+h[b+4304>>3];i=i;return}function yo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4344>>3]=+h[b+4304>>3]*+h[b+3520>>3];i=i;return}function zo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4304>>3];k=+h[g+4184>>3]- +h[g+272>>3]*+h[g+4224>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+928|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+928|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,9328,9320,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+928|0;p=o;h[p>>3]=m;i=d;return}function Ao(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8928>>3]=-+h[b+928>>3];i=i;return}function Bo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+704>>3]*+h[j+3528>>3]*+h[e+1888>>3];l=+h[j+288>>3]+ +h[j+296>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+2944|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+2944|0;r=q;h[r>>3]=o;i=d;return}s=l/+nwa(c[b+536>>2]|0,k,9352,9344,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+2944|0;r=q;h[r>>3]=o;i=d;return}function Co(a){a=a|0;var b=0,d=0.0,e=0.0,f=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+2944>>3];e=+h[b+2952>>3];f=c[a+416>>2]|0;h[b+3696>>3]=+h[f+1992>>3]*(+h[b+3944>>3]*d*d*+h[f+704>>3]- +h[b+3952>>3]*e*e*+h[f+712>>3]);i=i;return}function Do(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8120>>3]=+h[b+3696>>3]+(-+h[b+3648>>3]- +h[b+3600>>3]);i=i;return}function Eo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10312>>3];k=+h[g+8120>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+952|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+952|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,9424,9416,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+952|0;p=o;h[p>>3]=m;i=d;return}function Fo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+280>>3];k=+h[g+272>>3];l=+h[g+3448>>3]*(k+ +h[g+4440>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+3488|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+3488|0;r=q;h[r>>3]=o;i=d;return}s=k/+nwa(c[b+536>>2]|0,l,9456,9448,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+3488|0;r=q;h[r>>3]=o;i=d;return}function Go(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3448>>3];k=+zd(1.0e-13,+(+h[g+280>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+nwa(c[b+536>>2]|0,k,9168,9560,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+3456>>3]=m*.6219647130774989;i=d;return}function Ho(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3776>>3]=+h[b+328>>3]*+h[b+10344>>3];i=i;return}function Io(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3768>>3]=+h[b+320>>3]*+h[b+10336>>3];i=i;return}function Jo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3760>>3]=+h[b+312>>3]*+h[b+10328>>3];i=i;return}function Ko(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3752>>3]=+h[b+304>>3]*+h[b+10320>>3];i=i;return}function Lo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3744>>3]=+h[b+296>>3]*+h[b+10312>>3];i=i;return}function Mo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3736>>3]=+h[b+288>>3]*+h[b+10304>>3];i=i;return}function No(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;gxa(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+344>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+352>>3];l=+h[a+336>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];tA(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5096>>3]=+h[f>>3];i=b;return}function Oo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0.0;d=i;i=i+120|0;e=d;f=d+96|0;g=d+112|0;j=i;i=i+16|0;k=i;i=i+96|0;l=i;i=i+8|0;m=b+4|0;n=c[c[m>>2]>>2]|0;o=c[n+8>>2]|0;p=+zd(+(+h[o+5952>>3]),1.0e-15);q=+zd(+(+h[o+328>>3]),1.0e-15);r=p+q;s=p*+h[o+344>>3]+q*+h[o+176>>3];do{if(r!=0.0){t=s/r}else{if(s==0.0){t=s;break}t=s/+nwa(c[b+536>>2]|0,r,4752,9568,+h[n>>3],(a[b+319|0]|0)!=0|0)}}while(0);gxa(j,1,t,g);c[k>>2]=4216;h[k+8>>3]=.01801528;h[k+16>>3]=-13423382.81725291;h[k+24>>3]=549760.6476280135;h[k+32>>3]=1.0e3;g=k+40|0;n=4224;c[g+0>>2]=c[n+0>>2];c[g+4>>2]=c[n+4>>2];c[g+8>>2]=c[n+8>>2];n=k+52|0;g=4240;c[n+0>>2]=c[g+0>>2];c[n+4>>2]=c[g+4>>2];c[n+8>>2]=c[g+8>>2];g=k+64|0;n=4256;c[g+0>>2]=c[n+0>>2];c[g+4>>2]=c[n+4>>2];c[g+8>>2]=c[n+8>>2];n=k+76|0;g=4272;c[n+0>>2]=c[g+0>>2];c[n+4>>2]=c[g+4>>2];c[n+8>>2]=c[g+8>>2];h[k+88>>3]=461.5233290850878;g=c[b+536>>2]|0;n=c[c[m>>2]>>2]|0;o=c[n+8>>2]|0;t=+zd(+(+h[o+5952>>3]),1.0e-15);r=+zd(+(+h[o+328>>3]),1.0e-15);s=t+r;q=t*+h[o+5096>>3]+r*+h[o+3088>>3];do{if(s!=0.0){u=o;v=q/s}else{if(q==0.0){u=o;v=q;break}r=q/+nwa(g,s,4752,9568,+h[n>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[m>>2]>>2]|0)+8>>2]|0;v=r}}while(0);s=+h[u+352>>3];u=f;b=j;c[u+0>>2]=c[b+0>>2];c[u+4>>2]=c[b+4>>2];c[u+8>>2]=c[b+8>>2];b=e+0|0;u=k+0|0;k=b+96|0;do{c[b>>2]=c[u>>2];b=b+4|0;u=u+4|0}while((b|0)<(k|0));nA(l,g,v,190.0,647.0,s,f,e,1.0e-13);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2896>>3]=+h[l>>3];i=d;return}function Po(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0.0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0.0;d=i;i=i+56|0;e=d;f=d+32|0;g=d+48|0;j=i;i=i+16|0;l=i;i=i+32|0;m=i;i=i+32|0;n=i;i=i+8|0;o=b+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[p+2880>>3];r=g;h[k>>3]=+h[p+2888>>3];c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];gxa(j,2,q,g);g=b+536|0;r=c[g>>2]|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[p+352>>3];s=+h[p+2896>>3];p=f;t=j;c[p+0>>2]=c[t+0>>2];c[p+4>>2]=c[t+4>>2];c[p+8>>2]=c[t+8>>2];mA(m,r,q,s,f);f=l;r=m;c[f+0>>2]=c[r+0>>2];c[f+4>>2]=c[r+4>>2];c[f+8>>2]=c[r+8>>2];c[f+12>>2]=c[r+12>>2];c[f+16>>2]=c[r+16>>2];c[f+20>>2]=c[r+20>>2];c[f+24>>2]=c[r+24>>2];c[f+28>>2]=c[r+28>>2];r=c[g>>2]|0;f=e;m=l;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];c[f+12>>2]=c[m+12>>2];c[f+16>>2]=c[m+16>>2];c[f+20>>2]=c[m+20>>2];c[f+24>>2]=c[m+24>>2];c[f+28>>2]=c[m+28>>2];qA(n,r,e);e=c[b+416>>2]|0;s=+h[n>>3]*+h[e+1e3>>3]*+h[e+2112>>3];e=c[c[o>>2]>>2]|0;n=c[e+8>>2]|0;q=+h[n+120>>3];if(s!=0.0){u=n;v=q/s;w=u;x=w+2448|0;y=x;h[y>>3]=v;i=d;return}if(q==0.0){u=n;v=q;w=u;x=w+2448|0;y=x;h[y>>3]=v;i=d;return}z=q/+nwa(c[g>>2]|0,s,9584,9576,+h[e>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[o>>2]>>2]|0)+8>>2]|0;v=z;w=u;x=w+2448|0;y=x;h[y>>3]=v;i=d;return}function Qo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+104>>3];v=l;h[k>>3]=+h[t+2872>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];gxa(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+112>>3];w=+h[t+96>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];vz(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Bz(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+2880>>3];f=j;h[k>>3]=+h[q+2888>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];gxa(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+352>>3];y=+h[f+2896>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];vz(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Bz(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+2088>>3]=+h[d+1e3>>3]*(w- +h[r>>3])*+h[d+2216>>3];i=b;return}function Ro(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+2880>>3];p=f;h[k>>3]=+h[n+2888>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+352>>3];q=+h[p+2896>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2280>>3]=+h[l>>3];i=b;return}function So(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+120>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2232>>3]=+h[(a?e+2288|0:e+2280|0)>>3];i=b;return}function To(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+2880>>3];p=f;h[k>>3]=+h[n+2888>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+352>>3];q=+h[p+2896>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2384>>3]=+h[l>>3];i=b;return}function Uo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1404>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1992>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1992|0;h[c[g+1408>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1992>>3]);h[c[(c[f>>2]|0)+1412>>2]>>3]=k;_za(a,17)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+1992>>3]=+h[c[(c[f>>2]|0)+1404>>2]>>3];i=b;return}function Vo(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+2040>>3]=+h[b+1992>>3]*+h[d+2216>>3]*+h[d+1e3>>3];i=i;return}function Wo(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+2552>>3]=+h[b+1392>>3]*+h[d+1e3>>3]*+h[d+2112>>3]*((+h[b+88>>3]- +h[b+352>>3])/1.5+(+h[b+1992>>3]+(+h[b+2e3>>3]*.5+ +h[d+1352>>3]*+h[b+1976>>3]*-10.0)));i=i;return}function Xo(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+120>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2336>>3]=+h[(a?e+2392|0:e+2384|0)>>3];i=b;return}function Yo(a){a=a|0;var b=0,d=0.0,e=0.0,f=0,g=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+2448>>3];e=+h[b+1392>>3];f=c[a+416>>2]|0;g=+h[f+1e3>>3];h[b+2136>>3]=+h[f+2216>>3]*(+h[b+2384>>3]*d*d*g- +h[b+2392>>3]*e*e*g);i=i;return}function Zo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8280>>3]=+h[b+2136>>3]+(-+h[b+2088>>3]- +h[b+2040>>3]);i=i;return}function _o(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10440>>3];k=+h[g+8280>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+776|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+776|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,9832,9824,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+776|0;p=o;h[p>>3]=m;i=d;return}function $o(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+120>>3];if(!(j>=0.0)){k=g;l=j*+h[g+1984>>3];m=k;n=m+2456|0;o=n;h[o>>3]=l;i=d;return}p=+zd(+(+h[g+5952>>3]),1.0e-15);q=+zd(+(+h[g+328>>3]),1.0e-15);r=p+q;s=p*+h[g+5096>>3]+q*+h[g+3088>>3];do{if(r!=0.0){t=j;u=g;v=s/r}else{if(s==0.0){t=j;u=g;v=s;break}q=s/+nwa(c[b+536>>2]|0,r,4752,9856,+h[f>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[w+120>>3];u=w;v=q}}while(0);k=u;l=v*t;m=k;n=m+2456|0;o=n;h[o>>3]=l;i=d;return}function ap(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2592>>3]=+h[b+2456>>3]- +h[b+2464>>3];i=i;return}function bp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8568>>3]=+h[b+2592>>3]+ +h[b+2552>>3];i=i;return}function cp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2752>>3];k=+h[g+8568>>3]- +h[g+2672>>3]*+h[g+1968>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+8328|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+8328|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,7048,9864,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+8328|0;p=o;h[p>>3]=m;i=d;return}function dp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1484>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+752>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+752|0;h[c[g+1488>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+752>>3]);e=c[f>>2]|0;h[c[e+1492>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+1484>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+768>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+768|0;h[(c[e+1488>>2]|0)+8>>3]=+h[g>>3];k=+aAa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+768>>3]);h[(c[(c[f>>2]|0)+1492>>2]|0)+8>>3]=k;_za(a,18)|0;j=c[(c[f>>2]|0)+1484>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+752>>3]=+h[j>>3];h[f+768>>3]=+h[j+8>>3];zQ(a);AQ(a);BQ(a);CQ(a);DQ(a);EQ(a);i=b;return}function ep(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0.0;d=i;i=i+120|0;e=d;f=d+96|0;g=d+112|0;j=i;i=i+16|0;k=i;i=i+96|0;l=i;i=i+8|0;m=b+4|0;n=c[c[m>>2]>>2]|0;o=c[n+8>>2]|0;p=+zd(+(+h[o+5952>>3]),1.0e-15);q=+zd(+-+h[o+120>>3],1.0e-15);r=p+q;s=p*+h[o+344>>3]+q*+h[o+104>>3];do{if(r!=0.0){t=s/r}else{if(s==0.0){t=s;break}t=s/+nwa(c[b+536>>2]|0,r,4848,9872,+h[n>>3],(a[b+319|0]|0)!=0|0)}}while(0);gxa(j,1,t,g);c[k>>2]=4216;h[k+8>>3]=.01801528;h[k+16>>3]=-13423382.81725291;h[k+24>>3]=549760.6476280135;h[k+32>>3]=1.0e3;g=k+40|0;n=4224;c[g+0>>2]=c[n+0>>2];c[g+4>>2]=c[n+4>>2];c[g+8>>2]=c[n+8>>2];n=k+52|0;g=4240;c[n+0>>2]=c[g+0>>2];c[n+4>>2]=c[g+4>>2];c[n+8>>2]=c[g+8>>2];g=k+64|0;n=4256;c[g+0>>2]=c[n+0>>2];c[g+4>>2]=c[n+4>>2];c[g+8>>2]=c[n+8>>2];n=k+76|0;g=4272;c[n+0>>2]=c[g+0>>2];c[n+4>>2]=c[g+4>>2];c[n+8>>2]=c[g+8>>2];h[k+88>>3]=461.5233290850878;g=c[b+536>>2]|0;n=c[c[m>>2]>>2]|0;o=c[n+8>>2]|0;t=+zd(+(+h[o+5952>>3]),1.0e-15);r=+zd(+-+h[o+120>>3],1.0e-15);s=t+r;q=t*+h[o+5096>>3]+r*+h[o+1984>>3];do{if(s!=0.0){u=o;v=q/s}else{if(q==0.0){u=o;v=q;break}r=q/+nwa(g,s,4848,9872,+h[n>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[m>>2]>>2]|0)+8>>2]|0;v=r}}while(0);s=+h[u+352>>3];u=f;b=j;c[u+0>>2]=c[b+0>>2];c[u+4>>2]=c[b+4>>2];c[u+8>>2]=c[b+8>>2];b=e+0|0;u=k+0|0;k=b+96|0;do{c[b>>2]=c[u>>2];b=b+4|0;u=u+4|0}while((b|0)<(k|0));nA(l,g,v,190.0,647.0,s,f,e,1.0e-13);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4400>>3]=+h[l>>3];i=d;return}function fp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0.0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0.0;d=i;i=i+56|0;e=d;f=d+32|0;g=d+48|0;j=i;i=i+16|0;l=i;i=i+32|0;m=i;i=i+32|0;n=i;i=i+8|0;o=b+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[p+4384>>3];r=g;h[k>>3]=+h[p+4392>>3];c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];gxa(j,2,q,g);g=b+536|0;r=c[g>>2]|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[p+352>>3];s=+h[p+4400>>3];p=f;t=j;c[p+0>>2]=c[t+0>>2];c[p+4>>2]=c[t+4>>2];c[p+8>>2]=c[t+8>>2];mA(m,r,q,s,f);f=l;r=m;c[f+0>>2]=c[r+0>>2];c[f+4>>2]=c[r+4>>2];c[f+8>>2]=c[r+8>>2];c[f+12>>2]=c[r+12>>2];c[f+16>>2]=c[r+16>>2];c[f+20>>2]=c[r+20>>2];c[f+24>>2]=c[r+24>>2];c[f+28>>2]=c[r+28>>2];r=c[g>>2]|0;f=e;m=l;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];c[f+12>>2]=c[m+12>>2];c[f+16>>2]=c[m+16>>2];c[f+20>>2]=c[m+20>>2];c[f+24>>2]=c[m+24>>2];c[f+28>>2]=c[m+28>>2];qA(n,r,e);e=c[b+416>>2]|0;s=+h[n>>3]*+h[e+736>>3]*+h[e+1888>>3];e=c[c[o>>2]>>2]|0;n=c[e+8>>2]|0;q=+h[n+328>>3];if(s!=0.0){u=n;v=q/s;w=u;x=w+3992|0;y=x;h[y>>3]=v;i=d;return}if(q==0.0){u=n;v=q;w=u;x=w+3992|0;y=x;h[y>>3]=v;i=d;return}z=q/+nwa(c[g>>2]|0,s,9888,9880,+h[e>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[o>>2]>>2]|0)+8>>2]|0;v=z;w=u;x=w+3992|0;y=x;h[y>>3]=v;i=d;return}function gp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+4384>>3];v=l;h[k>>3]=+h[t+4392>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];gxa(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+352>>3];w=+h[t+4400>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];vz(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Bz(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+176>>3];f=j;h[k>>3]=+h[q+4408>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];gxa(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+184>>3];y=+h[f+168>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];vz(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Bz(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+3680>>3]=+h[d+736>>3]*(w- +h[r>>3])*+h[d+1992>>3];i=b;return}function hp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+4384>>3];p=f;h[k>>3]=+h[n+4392>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+352>>3];q=+h[p+4400>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+3880>>3]=+h[l>>3];i=b;return}function ip(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+328>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3824>>3]=+h[(a?e+3880|0:e+3872|0)>>3];i=b;return}function jp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+4384>>3];p=f;h[k>>3]=+h[n+4392>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+352>>3];q=+h[p+4400>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+3984>>3]=+h[l>>3];i=b;return}function kp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1564>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+3584>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+3584|0;h[c[g+1568>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+3584>>3]);h[c[(c[f>>2]|0)+1572>>2]>>3]=k;_za(a,19)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3584>>3]=+h[c[(c[f>>2]|0)+1564>>2]>>3];i=b;return}function lp(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3632>>3]=+h[b+3584>>3]*+h[d+1992>>3]*+h[d+736>>3];i=i;return}function mp(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+4136>>3]=+h[b+2976>>3]*+h[d+736>>3]*+h[d+1888>>3]*((+h[b+352>>3]- +h[b+208>>3])/1.5+(+h[b+3576>>3]*.5+(+h[b+3584>>3]+ +h[d+1352>>3]*+h[b+3080>>3]*-5.0)));i=i;return}function np(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+328>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3928>>3]=+h[(a?e+3984|0:e+3976|0)>>3];i=b;return}function op(a){a=a|0;var b=0,d=0.0,e=0.0,f=0,g=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+2976>>3];e=+h[b+3992>>3];f=c[a+416>>2]|0;g=+h[f+736>>3];h[b+3728>>3]=+h[f+1992>>3]*(+h[b+3976>>3]*d*d*g- +h[b+3984>>3]*e*e*g);i=i;return}function pp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8152>>3]=+h[b+3728>>3]+(-+h[b+3680>>3]- +h[b+3632>>3]);i=i;return}function qp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10344>>3];k=+h[g+8152>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+984|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+984|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,10136,10128,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+984|0;p=o;h[p>>3]=m;i=d;return}function rp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+328>>3];if(j>=0.0){k=g;l=j*+h[g+3088>>3];m=k;n=m+4048|0;o=n;h[o>>3]=l;i=d;return}p=+zd(+(+h[g+5952>>3]),1.0e-15);q=+zd(+-+h[g+120>>3],1.0e-15);r=p+q;s=p*+h[g+5096>>3]+q*+h[g+1984>>3];do{if(r!=0.0){t=j;u=g;v=s/r}else{if(s==0.0){t=j;u=g;v=s;break}q=s/+nwa(c[b+536>>2]|0,r,4848,10160,+h[f>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[w+328>>3];u=w;v=q}}while(0);k=u;l=v*t;m=k;n=m+4048|0;o=n;h[o>>3]=l;i=d;return}function sp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4176>>3]=+h[b+4040>>3]- +h[b+4048>>3];i=i;return}function tp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8560>>3]=+h[b+4176>>3]+ +h[b+4136>>3];i=i;return}function up(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4336>>3];k=+h[g+8560>>3]- +h[g+4256>>3]*+h[g+3072>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+8256|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+8256|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,7512,10168,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+8256|0;p=o;h[p>>3]=m;i=d;return}function vp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1644>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+840>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+840|0;h[c[g+1648>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+840>>3]);e=c[f>>2]|0;h[c[e+1652>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+1644>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+824>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+824|0;h[(c[e+1648>>2]|0)+8>>3]=+h[g>>3];k=+aAa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+824>>3]);h[(c[(c[f>>2]|0)+1652>>2]|0)+8>>3]=k;_za(a,20)|0;j=c[(c[f>>2]|0)+1644>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+840>>3]=+h[j>>3];h[f+824>>3]=+h[j+8>>3];JQ(a);KQ(a);LQ(a);MQ(a);NQ(a);OQ(a);i=b;return}function wp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5952>>3];if(j>=0.0){k=g;l=j*+h[g+5096>>3];m=k;n=m+5896|0;o=n;h[o>>3]=l;i=d;return}p=+zd(+(+h[g+328>>3]),1.0e-15);q=+zd(+-+h[g+120>>3],1.0e-15);r=p+q;s=p*+h[g+3088>>3]+q*+h[g+1984>>3];do{if(r!=0.0){t=j;u=g;v=s/r}else{if(s==0.0){t=j;u=g;v=s;break}q=s/+nwa(c[b+536>>2]|0,r,2520,10176,+h[f>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[w+5952>>3];u=w;v=q}}while(0);k=u;l=v*t;m=k;n=m+5896|0;o=n;h[o>>3]=l;i=d;return}function xp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6288>>3]=1.0- +h[b+344>>3];i=i;return}function yp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+344>>3];p=f;h[k>>3]=+h[n+6288>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+352>>3];q=+h[p+336>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Nz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4904>>3]=+h[l>>3];i=b;return}function zp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+344>>3];p=f;h[k>>3]=+h[n+6288>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+352>>3];q=+h[p+336>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Qz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4744>>3]=+h[l>>3];i=b;return}function Ap(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+344>>3];p=f;h[k>>3]=+h[n+6288>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+352>>3];q=+h[p+336>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Oz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4784>>3]=+h[l>>3];i=b;return}function Bp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+344>>3];p=f;h[k>>3]=+h[n+6288>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+352>>3];q=+h[p+336>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Vz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4824>>3]=+h[l>>3];i=b;return}function Cp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+344>>3];p=f;h[k>>3]=+h[n+6288>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+352>>3];q=+h[p+336>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];fA(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4504>>3]=+h[l>>3];i=b;return}function Dp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+6288>>3]),1.0e-13);k=+h[g+344>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+5056|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+5056|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,10192,10184,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+5056|0;p=o;h[p>>3]=m;i=d;return}function Ep(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+344>>3];p=f;h[k>>3]=+h[n+6288>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+352>>3];q=+h[p+336>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+5776>>3]=+h[l>>3];i=b;return}function Fp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+344>>3];p=f;h[k>>3]=+h[n+6288>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+352>>3];q=+h[p+336>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+5848>>3]=+h[l>>3];i=b;return}function Gp(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;iA(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+336>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+5008>>3]=+yd(+(+h[d>>3]),+(+h[a+352>>3]*.999));i=b;return}function Hp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5008>>3];k=+zd(1.0e-13,+(+h[g+352>>3]-j));l=+h[g+6288>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+nwa(c[b+536>>2]|0,k,10240,10232,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+5024>>3]=+yd(+(j*n*.6219647130774989),1.0);i=d;return}function Ip(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+5040>>3]=+zd(+(+h[d+344>>3]- +h[d+5024>>3]),0.0);i=b;return}function Jp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5032>>3]=+h[b+344>>3]- +h[b+5040>>3];i=i;return}function Kp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5040>>3];k=1.0-j;l=+h[g+6288>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+nwa(c[b+536>>2]|0,k,10312,10304,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+5040>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+5032>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+5072|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+5072|0;z=y;h[z>>3]=w;i=d;return}l=m/+nwa(c[b+536>>2]|0,p,10312,10304,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+5072|0;z=y;h[z>>3]=w;i=d;return}function Lp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5080>>3]=+h[b+5096>>3]- +h[b+5072>>3]*+h[b+336>>3];i=i;return}function Mp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+336>>3]*+h[g+5072>>3];k=+h[g+352>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+5088|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+5088|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,10352,10344,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+5088|0;p=o;h[p>>3]=m;i=d;return}function Np(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6240>>3]=+h[b+10152>>3]*+h[b+5088>>3];i=i;return}function Op(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6200>>3]=+h[b+344>>3]*+h[b+6240>>3];i=i;return}function Pp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6280>>3]=+h[b+6240>>3]*+h[b+5080>>3];i=i;return}function Qp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6240>>3];k=+h[g+6120>>3]- +h[g+344>>3]*+h[g+6160>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1e3|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1e3|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,10400,10392,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1e3|0;p=o;h[p>>3]=m;i=d;return}function Rp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8800>>3]=-+h[b+1e3>>3];i=i;return}function Sp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+440>>3]*+h[j+5088>>3]*+h[e+1656>>3];l=+h[j+480>>3]+ +h[j+5952>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+4984|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+4984|0;r=q;h[r>>3]=o;i=d;return}s=l/+nwa(c[b+536>>2]|0,k,10424,10416,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+4984|0;r=q;h[r>>3]=o;i=d;return}function Tp(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;wz(d,c[a+536>>2]|0,+h[f+4984>>3],+h[f+4824>>3],+h[f+4784>>3],+h[(c[a+416>>2]|0)+480>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4944>>3]=+h[d>>3];i=b;return}function Up(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+zd(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+4944>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+Nxa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4584|0;w=v;h[w>>3]=n;i=b;return}x=c[63880]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=13712;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Oe[a&127](y,d,10488,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+Nxa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4584|0;w=v;h[w>>3]=n;i=b;return}function Vp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=Dza(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4984>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4584>>3];l=+U(+(+h[j+4944>>3]));m=+h[j+4904>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?4.5:.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+400>>3];q=n*p;r=q!=0.0;s=+h[o+480>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+nwa(c[b+536>>2]|0,q,10592,10584,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+4904>>3];u=+h[j+4584>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+4704|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+nwa(c[b+536>>2]|0,q,10592,10584,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+480>>3];M=+h[j+400>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+nwa(c[b+536>>2]|0,q,10592,10584,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+4704|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+nwa(c[b+536>>2]|0,q,10592,10584,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4584>>3]*.125));L=P*(+W(+(+h[g+4904>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+nwa(c[b+536>>2]|0,L,10656,10584,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+4704|0;K=J;h[K>>3]=B;i=d;return}}function Wp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=Dza(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4984>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+4944>>3]));l=+h[j+4904>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?4.5:.5)*+h[m+400>>3];o=+h[m+480>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+nwa(c[b+536>>2]|0,n,10592,10776,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+4624>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function Xp(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+4624>>3]+-.7;h[b+4664>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function Yp(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;KA(d,c[a+536>>2]|0,+h[f+4704>>3],+h[f+4664>>3],+h[f+4944>>3]+-6150.0,3850.0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4864>>3]=+h[d>>3];i=b;return}function Zp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1724>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4544>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+4544|0;h[c[g+1728>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4544>>3]);h[c[(c[f>>2]|0)+1732>>2]>>3]=k;_za(a,21)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+4544>>3]=+h[c[(c[f>>2]|0)+1724>>2]>>3];i=b;return}function _p(a){a=a|0;var b=0,d=0,e=0;b=i;Qza(a,0)|0;d=c[(c[a+476>>2]|0)+28>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1312>>3]=+h[d>>3];h[e+6040>>3]=+h[d+8>>3];i=b;return}function $p(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+352>>3];k=+h[g+344>>3];l=+h[g+5008>>3]*(k+ +h[g+6288>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+5048|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+5048|0;r=q;h[r>>3]=o;i=d;return}s=k/+nwa(c[b+536>>2]|0,l,10792,10784,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+5048|0;r=q;h[r>>3]=o;i=d;return}function aq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5008>>3];k=+zd(1.0e-13,+(+h[g+352>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+nwa(c[b+536>>2]|0,k,10240,10896,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+5016>>3]=m*.6219647130774989;i=d;return}function bq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;gxa(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+368>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+376>>3];l=+h[a+360>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];tA(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5208>>3]=+h[f>>3];i=b;return}function cq(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+480>>3];h[b+5888>>3]=d*+h[(!(d>=0.0)?b+5096|0:b+5208|0)>>3];i=i;return}function dq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6080>>3]=+h[b+5888>>3]- +h[b+5896>>3];i=i;return}function eq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6296>>3]=1.0- +h[b+368>>3];i=i;return}function fq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+368>>3];p=f;h[k>>3]=+h[n+6296>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+376>>3];q=+h[p+360>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Nz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4896>>3]=+h[l>>3];i=b;return}function gq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+368>>3];p=f;h[k>>3]=+h[n+6296>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+376>>3];q=+h[p+360>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Qz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4736>>3]=+h[l>>3];i=b;return}function hq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+368>>3];p=f;h[k>>3]=+h[n+6296>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+376>>3];q=+h[p+360>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Oz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4776>>3]=+h[l>>3];i=b;return}function iq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+368>>3];p=f;h[k>>3]=+h[n+6296>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+376>>3];q=+h[p+360>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Vz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4816>>3]=+h[l>>3];i=b;return}function jq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+368>>3];p=f;h[k>>3]=+h[n+6296>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+376>>3];q=+h[p+360>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];fA(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4496>>3]=+h[l>>3];i=b;return}function kq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+6296>>3]),1.0e-13);k=+h[g+368>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+5168|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+5168|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,10912,10904,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+5168|0;p=o;h[p>>3]=m;i=d;return}function lq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+344>>3];v=l;h[k>>3]=+h[t+6288>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];gxa(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+352>>3];w=+h[t+336>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];vz(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Bz(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+368>>3];f=j;h[k>>3]=+h[q+6296>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];gxa(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+376>>3];y=+h[f+360>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];vz(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Bz(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+5640>>3]=(+h[d+432>>3]+ +h[d+440>>3])*(w- +h[r>>3])*+h[d+1760>>3]*.5;i=b;return}function mq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+368>>3];p=f;h[k>>3]=+h[n+6296>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+376>>3];q=+h[p+360>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+5768>>3]=+h[l>>3];i=b;return}function nq(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+480>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+5736>>3]=+h[(a?e+5776|0:e+5768|0)>>3];i=b;return}function oq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+368>>3];p=f;h[k>>3]=+h[n+6296>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+376>>3];q=+h[p+360>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+5840>>3]=+h[l>>3];i=b;return}function pq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1804>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+5576>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+5576|0;h[c[g+1808>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+5576>>3]);h[c[(c[f>>2]|0)+1812>>2]>>3]=k;_za(a,22)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+5576>>3]=+h[c[(c[f>>2]|0)+1804>>2]>>3];i=b;return}function qq(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+5608>>3]=+h[b+5576>>3]*(+h[d+432>>3]+ +h[d+440>>3])*+h[d+1760>>3]*.5;i=i;return}function rq(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+6e3>>3]=+h[b+4984>>3]*+h[d+440>>3]*+h[d+1656>>3]*(+h[b+352>>3]*.5+(+h[b+376>>3]*-.5+(+h[b+5576>>3]*.5+ +h[d+1352>>3]*+h[b+5088>>3]*-5.0)));i=i;return}function sq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8520>>3]=+h[b+6080>>3]+(+h[b+6e3>>3]+ +h[b+6040>>3]);i=i;return}function tq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6240>>3];k=+h[g+8520>>3]- +h[g+6160>>3]*+h[g+5080>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+8088|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+8088|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,10400,10952,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+8088|0;p=o;h[p>>3]=m;i=d;return}function uq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1884>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+992>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+992|0;h[c[g+1888>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+992>>3]);e=c[f>>2]|0;h[c[e+1892>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+1884>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+1008>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+1008|0;h[(c[e+1888>>2]|0)+8>>3]=+h[g>>3];k=+aAa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+1008>>3]);h[(c[(c[f>>2]|0)+1892>>2]|0)+8>>3]=k;_za(a,23)|0;j=c[(c[f>>2]|0)+1884>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+992>>3]=+h[j>>3];h[f+1008>>3]=+h[j+8>>3];VQ(a);WQ(a);XQ(a);YQ(a);ZQ(a);_Q(a);i=b;return}function vq(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+480>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+5808>>3]=+h[(a?e+5848|0:e+5840|0)>>3];i=b;return}function wq(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;iA(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+360>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+5120>>3]=+yd(+(+h[d>>3]),+(+h[a+376>>3]*.999));i=b;return}function xq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5120>>3];k=+zd(1.0e-13,+(+h[g+376>>3]-j));l=+h[g+6296>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+nwa(c[b+536>>2]|0,k,10968,10960,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+5136>>3]=+yd(+(j*n*.6219647130774989),1.0);i=d;return}function yq(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+5152>>3]=+zd(+(+h[d+368>>3]- +h[d+5136>>3]),0.0);i=b;return}function zq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5144>>3]=+h[b+368>>3]- +h[b+5152>>3];i=i;return}function Aq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5152>>3];k=1.0-j;l=+h[g+6296>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+nwa(c[b+536>>2]|0,k,11040,11032,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+5152>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+5144>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+5184|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+5184|0;z=y;h[z>>3]=w;i=d;return}l=m/+nwa(c[b+536>>2]|0,p,11040,11032,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+5184|0;z=y;h[z>>3]=w;i=d;return}function Bq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5192>>3]=+h[b+5208>>3]- +h[b+5184>>3]*+h[b+360>>3];i=i;return}function Cq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+360>>3]*+h[g+5184>>3];k=+h[g+376>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+5200|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+5200|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,11080,11072,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+5200|0;p=o;h[p>>3]=m;i=d;return}function Dq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6232>>3]=+h[b+10144>>3]*+h[b+5200>>3];i=i;return}function Eq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6192>>3]=+h[b+368>>3]*+h[b+6232>>3];i=i;return}function Fq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6272>>3]=+h[b+6232>>3]*+h[b+5192>>3];i=i;return}function Gq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6232>>3];k=+h[g+6112>>3]- +h[g+368>>3]*+h[g+6152>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1024|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1024|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,11128,11120,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1024|0;p=o;h[p>>3]=m;i=d;return}function Hq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8792>>3]=-+h[b+1024>>3];i=i;return}function Iq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+432>>3]*+h[j+5200>>3]*+h[e+1656>>3];l=+h[j+472>>3]+ +h[j+480>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+4976|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+4976|0;r=q;h[r>>3]=o;i=d;return}s=l/+nwa(c[b+536>>2]|0,k,11152,11144,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+4976|0;r=q;h[r>>3]=o;i=d;return}function Jq(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;wz(d,c[a+536>>2]|0,+h[f+4976>>3],+h[f+4816>>3],+h[f+4776>>3],+h[(c[a+416>>2]|0)+472>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4936>>3]=+h[d>>3];i=b;return}function Kq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+zd(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+4936>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+Nxa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4576|0;w=v;h[w>>3]=n;i=b;return}x=c[63880]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=13712;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Oe[a&127](y,d,11216,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+Nxa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4576|0;w=v;h[w>>3]=n;i=b;return}function Lq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=Dza(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4976>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4576>>3];l=+U(+(+h[j+4936>>3]));m=+h[j+4896>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?3.5:1.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+392>>3];q=n*p;r=q!=0.0;s=+h[o+472>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+nwa(c[b+536>>2]|0,q,11320,11312,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+4896>>3];u=+h[j+4576>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+4696|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+nwa(c[b+536>>2]|0,q,11320,11312,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+472>>3];M=+h[j+392>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+nwa(c[b+536>>2]|0,q,11320,11312,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+4696|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+nwa(c[b+536>>2]|0,q,11320,11312,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4576>>3]*.125));L=P*(+W(+(+h[g+4896>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+nwa(c[b+536>>2]|0,L,11384,11312,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+4696|0;K=J;h[K>>3]=B;i=d;return}}function Mq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=Dza(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4976>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+4936>>3]));l=+h[j+4896>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?3.5:1.5)*+h[m+392>>3];o=+h[m+472>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+nwa(c[b+536>>2]|0,n,11320,11504,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+4616>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function Nq(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+4616>>3]+-.7;h[b+4656>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function Oq(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;KA(d,c[a+536>>2]|0,+h[f+4696>>3],+h[f+4656>>3],+h[f+4936>>3]+-6150.0,3850.0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4856>>3]=+h[d>>3];i=b;return}function Pq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1964>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4536>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+4536|0;h[c[g+1968>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4536>>3]);h[c[(c[f>>2]|0)+1972>>2]>>3]=k;_za(a,24)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+4536>>3]=+h[c[(c[f>>2]|0)+1964>>2]>>3];i=b;return}function Qq(a){a=a|0;var b=0,d=0,e=0;b=i;Qza(a,1)|0;d=c[(c[a+476>>2]|0)+92>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1320>>3]=+h[d>>3];h[e+6032>>3]=+h[d+8>>3];i=b;return}function Rq(a){a=a|0;var b=0,d=0.0,e=0.0,f=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+4976>>3];e=+h[b+4984>>3];f=c[a+416>>2]|0;h[b+5672>>3]=+h[f+1760>>3]*(+h[b+5840>>3]*d*d*+h[f+432>>3]- +h[b+5848>>3]*e*e*+h[f+440>>3]);i=i;return}function Sq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7984>>3]=+h[b+5672>>3]+(-+h[b+5640>>3]- +h[b+5608>>3]);i=i;return}function Tq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10224>>3];k=+h[g+7984>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1136|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1136|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,11520,11512,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1136|0;p=o;h[p>>3]=m;i=d;return}function Uq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+376>>3];k=+h[g+368>>3];l=+h[g+5120>>3]*(k+ +h[g+6296>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+5160|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+5160|0;r=q;h[r>>3]=o;i=d;return}s=k/+nwa(c[b+536>>2]|0,l,11552,11544,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+5160|0;r=q;h[r>>3]=o;i=d;return}function Vq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5120>>3];k=+zd(1.0e-13,+(+h[g+376>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+nwa(c[b+536>>2]|0,k,10968,11656,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+5128>>3]=m*.6219647130774989;i=d;return}function Wq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;gxa(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+392>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+400>>3];l=+h[a+384>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];tA(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5320>>3]=+h[f>>3];i=b;return}function Xq(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+472>>3];h[b+5880>>3]=d*+h[(!(d>=0.0)?b+5208|0:b+5320|0)>>3];i=i;return}function Yq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6072>>3]=+h[b+5880>>3]- +h[b+5888>>3];i=i;return}function Zq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6304>>3]=1.0- +h[b+392>>3];i=i;return}



function TI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6568>>3];k=+zd(1.0e-13,+(+h[g+528>>3]-j));l=+h[g+7760>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+nwa(c[b+536>>2]|0,k,48856,49008,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+7928|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=Cza(1.0e-13,+h[f+528>>3]- +h[f+6568>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+6568>>3];j=+h[x+528>>3];k=+zd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+8632>>3];k=+h[x+7760>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+1184>>3]- +h[x+8736>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+1184>>3]- +h[x+8736>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+1184>>3]- +h[x+8736>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+1184>>3]- +h[x+8736>>3]}K=(y-k*J)/+nwa(c[b+536>>2]|0,l,49016,49008,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+7760>>3];C=+h[L+6568>>3];D=+h[L+528>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+8736>>3];m=+zd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+nwa(c[b+536>>2]|0,m,48856,49008,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+7928|0;w=v;h[w>>3]=n;i=d;return}function UI(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(Cza(+h[a+520>>3]- +h[a+6584>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+8728|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+1176>>3]- +h[a+7928>>3];g=a;j=g+8728|0;k=j;h[k>>3]=f;i=b;return}function VI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7920>>3]=+h[b+1176>>3]- +h[b+8728>>3];i=i;return}function WI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6600>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+8728>>3];o=+h[g+8632>>3]*k+ +h[g+7760>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+nwa(c[b+536>>2]|0,l,49152,49144,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+8728>>3];q=+h[v+6600>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+7920>>3]*(1.0-q)+ +h[r+6592>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+8720|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+8720|0;C=B;h[C>>3]=z;i=d;return}p=t/+nwa(c[b+536>>2]|0,l,49152,49144,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+8720|0;C=B;h[C>>3]=z;i=d;return}function XI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7912>>3]=+h[b+9296>>3]+(-(+h[b+6632>>3]*+h[b+1168>>3])- +h[b+8720>>3]*+h[b+512>>3]);i=i;return}function YI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6632>>3];k=+h[g+512>>3];l=j*k;m=l*l;n=+h[g+1184>>3]*l- +h[g+528>>3]*(j*+h[g+1168>>3]+k*+h[g+8720>>3]);if(m!=0.0){o=g;p=n/m;q=o;r=q+9304|0;s=r;h[s>>3]=p;i=d;return}if(n==0.0){o=g;p=n;q=o;r=q+9304|0;s=r;h[s>>3]=p;i=d;return}k=n/+nwa(c[b+536>>2]|0,m,49200,49192,+h[f>>3],(a[b+319|0]|0)!=0|0);o=c[(c[c[e>>2]>>2]|0)+8>>2]|0;p=k;q=o;r=q+9304|0;s=r;h[s>>3]=p;i=d;return}function ZI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7592>>3]=+h[b+9992>>3]*+h[b+9304>>3];i=i;return}function _I(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7552>>3]=+h[b+520>>3]*+h[b+7592>>3]+ +h[b+1176>>3]*+h[b+7672>>3];i=i;return}function $I(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;gxa(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+520>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+528>>3];l=+h[a+512>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];tA(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6656>>3]=+h[f>>3];i=b;return}function aJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6640>>3]=+h[b+6656>>3]- +h[b+6632>>3]*+h[b+512>>3];i=i;return}function bJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8472>>3]=+h[b+7672>>3]*+h[b+7912>>3]+ +h[b+7592>>3]*+h[b+6640>>3];i=i;return}function cJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;iA(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+488>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+6456>>3]=+yd(+(+h[d>>3]),+(+h[a+504>>3]*.999));i=b;return}function dJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6456>>3];k=+zd(1.0e-13,+(+h[g+504>>3]-j));l=+h[g+7752>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+nwa(c[b+536>>2]|0,k,49256,49248,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6472>>3]=+yd(+(j*n*.6219647130774989),1.0);i=d;return}function eJ(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+6488>>3]=+zd(+(+h[d+496>>3]- +h[d+6472>>3]),0.0);i=b;return}function fJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6480>>3]=+h[b+496>>3]- +h[b+6488>>3];i=i;return}function gJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6488>>3];k=1.0-j;l=+h[g+7752>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+nwa(c[b+536>>2]|0,k,49328,49320,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+6488>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+6480>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+6520|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+6520|0;z=y;h[z>>3]=w;i=d;return}l=m/+nwa(c[b+536>>2]|0,p,49328,49320,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+6520|0;z=y;h[z>>3]=w;i=d;return}function hJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6528>>3]=+h[b+6544>>3]- +h[b+6520>>3]*+h[b+488>>3];i=i;return}function iJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+488>>3]*+h[g+6520>>3];k=+h[g+504>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+6536|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+6536|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,49368,49360,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6536|0;p=o;h[p>>3]=m;i=d;return}function jJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7680>>3]=+h[b+1e4>>3]*+h[b+6536>>3];i=i;return}function kJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6456>>3];k=+zd(1.0e-13,+(+h[g+504>>3]-j));l=+h[g+7752>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+nwa(c[b+536>>2]|0,k,49256,49408,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+7952|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=Cza(1.0e-13,+h[f+504>>3]- +h[f+6456>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+6456>>3];j=+h[x+504>>3];k=+zd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+8640>>3];k=+h[x+7752>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+1160>>3]- +h[x+8760>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+1160>>3]- +h[x+8760>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+1160>>3]- +h[x+8760>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+1160>>3]- +h[x+8760>>3]}K=(y-k*J)/+nwa(c[b+536>>2]|0,l,49416,49408,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+7752>>3];C=+h[L+6456>>3];D=+h[L+504>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+8760>>3];m=+zd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+nwa(c[b+536>>2]|0,m,49256,49408,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+7952|0;w=v;h[w>>3]=n;i=d;return}function lJ(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(Cza(+h[a+496>>3]- +h[a+6472>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+8752|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+1152>>3]- +h[a+7952>>3];g=a;j=g+8752|0;k=j;h[k>>3]=f;i=b;return}function mJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7944>>3]=+h[b+1152>>3]- +h[b+8752>>3];i=i;return}function nJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6488>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+8752>>3];o=+h[g+8640>>3]*k+ +h[g+7752>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+nwa(c[b+536>>2]|0,l,49552,49544,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+8752>>3];q=+h[v+6488>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+7944>>3]*(1.0-q)+ +h[r+6480>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+8744|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+8744|0;C=B;h[C>>3]=z;i=d;return}p=t/+nwa(c[b+536>>2]|0,l,49552,49544,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+8744|0;C=B;h[C>>3]=z;i=d;return}function oJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6520>>3];k=+h[g+488>>3];l=j*k;m=l*l;n=+h[g+1160>>3]*l- +h[g+504>>3]*(j*+h[g+1144>>3]+k*+h[g+8744>>3]);if(m!=0.0){o=g;p=n/m;q=o;r=q+9320|0;s=r;h[s>>3]=p;i=d;return}if(n==0.0){o=g;p=n;q=o;r=q+9320|0;s=r;h[s>>3]=p;i=d;return}k=n/+nwa(c[b+536>>2]|0,m,49600,49592,+h[f>>3],(a[b+319|0]|0)!=0|0);o=c[(c[c[e>>2]>>2]|0)+8>>2]|0;p=k;q=o;r=q+9320|0;s=r;h[s>>3]=p;i=d;return}function pJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7600>>3]=+h[b+1e4>>3]*+h[b+9320>>3];i=i;return}function qJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7560>>3]=+h[b+496>>3]*+h[b+7600>>3]+ +h[b+1152>>3]*+h[b+7680>>3];i=i;return}function rJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7936>>3]=+h[b+9312>>3]+(-(+h[b+6520>>3]*+h[b+1144>>3])- +h[b+8744>>3]*+h[b+488>>3]);i=i;return}function sJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8480>>3]=+h[b+7680>>3]*+h[b+7936>>3]+ +h[b+7600>>3]*+h[b+6528>>3];i=i;return}function tJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;gxa(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+440>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+448>>3];l=+h[a+432>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];tA(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5544>>3]=+h[f>>3];i=b;return}function uJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;gxa(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+416>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+424>>3];l=+h[a+408>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];tA(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5432>>3]=+h[f>>3];i=b;return}function vJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;iA(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+408>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+5344>>3]=+yd(+(+h[d>>3]),+(+h[a+424>>3]*.999));i=b;return}function wJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6312>>3]=1.0- +h[b+416>>3];i=i;return}function xJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5344>>3];k=+zd(1.0e-13,+(+h[g+424>>3]-j));l=+h[g+6312>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+nwa(c[b+536>>2]|0,k,49656,49648,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+5360>>3]=+yd(+(j*n*.6219647130774989),1.0);i=d;return}function yJ(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+5376>>3]=+zd(+(+h[d+416>>3]- +h[d+5360>>3]),0.0);i=b;return}function zJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5368>>3]=+h[b+416>>3]- +h[b+5376>>3];i=i;return}function AJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5344>>3];k=+zd(1.0e-13,+(+h[g+424>>3]-j));l=+h[g+6312>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+nwa(c[b+536>>2]|0,k,49656,49720,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8032|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=Cza(1.0e-13,+h[f+424>>3]- +h[f+5344>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+5344>>3];j=+h[x+424>>3];k=+zd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+8776>>3];k=+h[x+6312>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+1080>>3]- +h[x+8848>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+1080>>3]- +h[x+8848>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+1080>>3]- +h[x+8848>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+1080>>3]- +h[x+8848>>3]}K=(y-k*J)/+nwa(c[b+536>>2]|0,l,49728,49720,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+6312>>3];C=+h[L+5344>>3];D=+h[L+424>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+8848>>3];m=+zd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+nwa(c[b+536>>2]|0,m,49656,49720,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8032|0;w=v;h[w>>3]=n;i=d;return}function BJ(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(Cza(+h[a+416>>3]- +h[a+5360>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+8840|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+1072>>3]- +h[a+8032>>3];g=a;j=g+8840|0;k=j;h[k>>3]=f;i=b;return}function CJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8024>>3]=+h[b+1072>>3]- +h[b+8840>>3];i=i;return}function DJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5376>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+8840>>3];o=+h[g+8776>>3]*k+ +h[g+6312>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+nwa(c[b+536>>2]|0,l,49864,49856,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+8840>>3];q=+h[v+5376>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+8024>>3]*(1.0-q)+ +h[r+5368>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+8832|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+8832|0;C=B;h[C>>3]=z;i=d;return}p=t/+nwa(c[b+536>>2]|0,l,49864,49856,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+8832|0;C=B;h[C>>3]=z;i=d;return}function EJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5376>>3];k=1.0-j;l=+h[g+6312>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+nwa(c[b+536>>2]|0,k,49912,49904,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+5376>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+5368>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+5408|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+5408|0;z=y;h[z>>3]=w;i=d;return}l=m/+nwa(c[b+536>>2]|0,p,49912,49904,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+5408|0;z=y;h[z>>3]=w;i=d;return}function FJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5416>>3]=+h[b+5432>>3]- +h[b+5408>>3]*+h[b+408>>3];i=i;return}function GJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+408>>3]*+h[g+5408>>3];k=+h[g+424>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+5424|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+5424|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,49952,49944,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+5424|0;p=o;h[p>>3]=m;i=d;return}function HJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6216>>3]=+h[b+10128>>3]*+h[b+5424>>3];i=i;return}function IJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5408>>3];k=+h[g+408>>3];l=j*k;m=l*l;n=+h[g+1080>>3]*l- +h[g+424>>3]*(j*+h[g+1064>>3]+k*+h[g+8832>>3]);if(m!=0.0){o=g;p=n/m;q=o;r=q+9352|0;s=r;h[s>>3]=p;i=d;return}if(n==0.0){o=g;p=n;q=o;r=q+9352|0;s=r;h[s>>3]=p;i=d;return}k=n/+nwa(c[b+536>>2]|0,m,5e4,49992,+h[f>>3],(a[b+319|0]|0)!=0|0);o=c[(c[c[e>>2]>>2]|0)+8>>2]|0;p=k;q=o;r=q+9352|0;s=r;h[s>>3]=p;i=d;return}function JJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6136>>3]=+h[b+10128>>3]*+h[b+9352>>3];i=i;return}function KJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6096>>3]=+h[b+416>>3]*+h[b+6136>>3]+ +h[b+1072>>3]*+h[b+6216>>3];i=i;return}function LJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8016>>3]=+h[b+9344>>3]+(-(+h[b+5408>>3]*+h[b+1064>>3])- +h[b+8832>>3]*+h[b+408>>3]);i=i;return}function MJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8496>>3]=+h[b+6216>>3]*+h[b+8016>>3]+ +h[b+6136>>3]*+h[b+5416>>3];i=i;return}function NJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+392>>3];v=l;h[k>>3]=+h[t+6304>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];gxa(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+400>>3];w=+h[t+384>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];vz(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Bz(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+416>>3];f=j;h[k>>3]=+h[q+6312>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];gxa(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+424>>3];y=+h[f+408>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];vz(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Bz(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+5624>>3]=(+h[d+416>>3]+ +h[d+424>>3])*(w- +h[r>>3])*+h[d+1760>>3]*.5;i=b;return}function OJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+416>>3];p=f;h[k>>3]=+h[n+6312>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+424>>3];q=+h[p+408>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Nz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4880>>3]=+h[l>>3];i=b;return}function PJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+416>>3];p=f;h[k>>3]=+h[n+6312>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+424>>3];q=+h[p+408>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Qz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4720>>3]=+h[l>>3];i=b;return}function QJ(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;xz(d,c[a+536>>2]|0,+h[f+4520>>3],+h[(c[a+416>>2]|0)+456>>3],+h[f+4720>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4840>>3]=+h[d>>3];i=b;return}function RJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+416>>3];p=f;h[k>>3]=+h[n+6312>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+424>>3];q=+h[p+408>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Oz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4760>>3]=+h[l>>3];i=b;return}function SJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+416>>3];p=f;h[k>>3]=+h[n+6312>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+424>>3];q=+h[p+408>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Vz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4800>>3]=+h[l>>3];i=b;return}function TJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+416>>3];p=f;h[k>>3]=+h[n+6312>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+424>>3];q=+h[p+408>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];fA(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4480>>3]=+h[l>>3];i=b;return}function UJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+416>>3];p=f;h[k>>3]=+h[n+6312>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+424>>3];q=+h[p+408>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+5752>>3]=+h[l>>3];i=b;return}function VJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+416>>3];p=f;h[k>>3]=+h[n+6312>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+424>>3];q=+h[p+408>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+5824>>3]=+h[l>>3];i=b;return}function WJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;iA(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+432>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+5456>>3]=+yd(+(+h[d>>3]),+(+h[a+448>>3]*.999));i=b;return}function XJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6320>>3]=1.0- +h[b+440>>3];i=i;return}function YJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5456>>3];k=+zd(1.0e-13,+(+h[g+448>>3]-j));l=+h[g+6320>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+nwa(c[b+536>>2]|0,k,50056,50048,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+5472>>3]=+yd(+(j*n*.6219647130774989),1.0);i=d;return}function ZJ(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+5488>>3]=+zd(+(+h[d+440>>3]- +h[d+5472>>3]),0.0);i=b;return}function _J(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5480>>3]=+h[b+440>>3]- +h[b+5488>>3];i=i;return}function $J(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5488>>3];k=1.0-j;l=+h[g+6320>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+nwa(c[b+536>>2]|0,k,50128,50120,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+5488>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+5480>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+5520|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+5520|0;z=y;h[z>>3]=w;i=d;return}l=m/+nwa(c[b+536>>2]|0,p,50128,50120,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+5520|0;z=y;h[z>>3]=w;i=d;return}function aK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5528>>3]=+h[b+5544>>3]- +h[b+5520>>3]*+h[b+432>>3];i=i;return}function bK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+432>>3]*+h[g+5520>>3];k=+h[g+448>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+5536|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+5536|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,50168,50160,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+5536|0;p=o;h[p>>3]=m;i=d;return}function cK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6208>>3]=+h[b+10120>>3]*+h[b+5536>>3];i=i;return}function dK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5456>>3];k=+zd(1.0e-13,+(+h[g+448>>3]-j));l=+h[g+6320>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+nwa(c[b+536>>2]|0,k,50056,50208,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8008|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=Cza(1.0e-13,+h[f+448>>3]- +h[f+5456>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+5456>>3];j=+h[x+448>>3];k=+zd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+8768>>3];k=+h[x+6320>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+1104>>3]- +h[x+8824>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+1104>>3]- +h[x+8824>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+1104>>3]- +h[x+8824>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+1104>>3]- +h[x+8824>>3]}K=(y-k*J)/+nwa(c[b+536>>2]|0,l,50216,50208,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+6320>>3];C=+h[L+5456>>3];D=+h[L+448>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+8824>>3];m=+zd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+nwa(c[b+536>>2]|0,m,50056,50208,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8008|0;w=v;h[w>>3]=n;i=d;return}function eK(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(Cza(+h[a+440>>3]- +h[a+5472>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+8816|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+1096>>3]- +h[a+8008>>3];g=a;j=g+8816|0;k=j;h[k>>3]=f;i=b;return}function fK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8e3>>3]=+h[b+1096>>3]- +h[b+8816>>3];i=i;return}function gK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5488>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+8816>>3];o=+h[g+8768>>3]*k+ +h[g+6320>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+nwa(c[b+536>>2]|0,l,50352,50344,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+8816>>3];q=+h[v+5488>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+8e3>>3]*(1.0-q)+ +h[r+5480>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+8808|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+8808|0;C=B;h[C>>3]=z;i=d;return}p=t/+nwa(c[b+536>>2]|0,l,50352,50344,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+8808|0;C=B;h[C>>3]=z;i=d;return}function hK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7992>>3]=+h[b+9328>>3]+(-(+h[b+5520>>3]*+h[b+1088>>3])- +h[b+8808>>3]*+h[b+432>>3]);i=i;return}function iK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5520>>3];k=+h[g+432>>3];l=j*k;m=l*l;n=+h[g+1104>>3]*l- +h[g+448>>3]*(j*+h[g+1088>>3]+k*+h[g+8808>>3]);if(m!=0.0){o=g;p=n/m;q=o;r=q+9336|0;s=r;h[s>>3]=p;i=d;return}if(n==0.0){o=g;p=n;q=o;r=q+9336|0;s=r;h[s>>3]=p;i=d;return}k=n/+nwa(c[b+536>>2]|0,m,50400,50392,+h[f>>3],(a[b+319|0]|0)!=0|0);o=c[(c[c[e>>2]>>2]|0)+8>>2]|0;p=k;q=o;r=q+9336|0;s=r;h[s>>3]=p;i=d;return}function jK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6128>>3]=+h[b+10120>>3]*+h[b+9336>>3];i=i;return}function kK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8488>>3]=+h[b+6208>>3]*+h[b+7992>>3]+ +h[b+6128>>3]*+h[b+5528>>3];i=i;return}function lK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+456>>3]=+h[b+5960>>3]- +h[b+6128>>3];i=i;return}function mK(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+456>>3];h[b+5912>>3]=d*+h[(!(d>=0.0)?b+416|0:b+440|0)>>3];i=i;return}function nK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5920>>3]=+h[b+5912>>3]- +h[b+6096>>3];i=i;return}function oK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5928>>3]=+h[b+5920>>3]- +h[b+6104>>3];i=i;return}function pK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5936>>3]=+h[b+5928>>3]- +h[b+6112>>3];i=i;return}function qK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5944>>3]=+h[b+5936>>3]- +h[b+6120>>3];i=i;return}function rK(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+456>>3];h[b+5864>>3]=d*+h[(!(d>=0.0)?b+5432|0:b+5544|0)>>3];i=i;return}function sK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+464>>3]=+h[b+456>>3]- +h[b+6136>>3];i=i;return}function tK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+472>>3]=+h[b+464>>3]- +h[b+6144>>3];i=i;return}function uK(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+472>>3];h[b+5880>>3]=d*+h[(!(d>=0.0)?b+5208|0:b+5320|0)>>3];i=i;return}function vK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+480>>3]=+h[b+472>>3]- +h[b+6152>>3];i=i;return}function wK(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+480>>3];h[b+5888>>3]=d*+h[(!(d>=0.0)?b+5096|0:b+5208|0)>>3];i=i;return}function xK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6072>>3]=+h[b+5880>>3]- +h[b+5888>>3];i=i;return}function yK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5952>>3]=+h[b+480>>3]- +h[b+6160>>3];i=i;return}function zK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0.0;d=i;i=i+120|0;e=d;f=d+96|0;g=d+112|0;j=i;i=i+48|0;l=i;i=i+8|0;m=i;i=i+48|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+96|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=b+4|0;w=c[c[v>>2]>>2]|0;x=c[w+8>>2]|0;y=+zd(+(+h[x+5952>>3]),1.0e-15);z=+zd(+(+h[x+328>>3]),1.0e-15);A=y+z;B=y*+h[x+344>>3]+z*+h[x+176>>3];do{if(A!=0.0){C=B/A}else{if(B==0.0){C=B;break}C=B/+nwa(c[b+536>>2]|0,A,50456,50448,+h[w>>3],(a[b+319|0]|0)!=0|0)}}while(0);gxa(o,1,C,n);n=m;h[k>>3]=575.573102;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=m+8|0;h[k>>3]=.931782653;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=m+16|0;h[k>>3]=.00722271286;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=m+24|0;h[k>>3]=-734255737.0e-14;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=m+32|0;h[k>>3]=4.95504349e-9;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=m+40|0;h[k>>3]=-1.336933246e-12;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];gxa(q,7,-39479.6083,m);m=l;h[k>>3]=17.24205775;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];gxa(r,2,-33039.7431,l);l=j;h[k>>3]=-2412.698562;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];l=j+8|0;h[k>>3]=4.64611078;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];l=j+16|0;h[k>>3]=.002291998307;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];l=j+24|0;h[k>>3]=-6.836830479999999e-7;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];l=j+32|0;h[k>>3]=9.426468930000001e-11;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];l=j+40|0;h[k>>3]=-4.82238053e-15;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];gxa(s,7,1034972.096,j);j=g;h[k>>3]=-7.97814851;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];gxa(t,2,-13842.86509,g);c[p>>2]=50528;h[p+8>>3]=.01801528;h[p+16>>3]=-13423382.81725291;h[p+24>>3]=549760.6476280135;h[p+32>>3]=1.0e3;g=p+40|0;j=q;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];j=p+52|0;g=r;c[j+0>>2]=c[g+0>>2];c[j+4>>2]=c[g+4>>2];c[j+8>>2]=c[g+8>>2];g=p+64|0;j=s;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];j=p+76|0;g=t;c[j+0>>2]=c[g+0>>2];c[j+4>>2]=c[g+4>>2];c[j+8>>2]=c[g+8>>2];h[p+88>>3]=461.5233290850878;g=c[b+536>>2]|0;j=c[c[v>>2]>>2]|0;t=c[j+8>>2]|0;C=+zd(+(+h[t+5952>>3]),1.0e-15);A=+zd(+(+h[t+328>>3]),1.0e-15);B=C+A;z=C*+h[t+5096>>3]+A*+h[t+3088>>3];do{if(B!=0.0){D=t;E=z/B}else{if(z==0.0){D=t;E=z;break}A=z/+nwa(g,B,50456,50448,+h[j>>3],(a[b+319|0]|0)!=0|0);D=c[(c[c[v>>2]>>2]|0)+8>>2]|0;E=A}}while(0);B=+h[D+352>>3];D=f;b=o;c[D+0>>2]=c[b+0>>2];c[D+4>>2]=c[b+4>>2];c[D+8>>2]=c[b+8>>2];b=e+0|0;D=p+0|0;p=b+96|0;do{c[b>>2]=c[D>>2];b=b+4|0;D=D+4|0}while((b|0)<(p|0));nA(u,g,E,190.0,647.0,B,f,e,1.0e-13);h[(c[(c[c[v>>2]>>2]|0)+8>>2]|0)+2896>>3]=+h[u>>3];i=d;return}function AK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+5952>>3]),1.0e-15);k=+zd(+(+h[g+328>>3]),1.0e-15);l=j+k;m=j*+h[g+344>>3]+k*+h[g+176>>3];if(l!=0.0){n=g;o=m/l;p=n;q=p+2880|0;r=q;h[r>>3]=o;i=d;return}if(m==0.0){n=g;o=m;p=n;q=p+2880|0;r=q;h[r>>3]=o;i=d;return}k=m/+nwa(c[b+536>>2]|0,l,50456,50536,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=k;p=n;q=p+2880|0;r=q;h[r>>3]=o;i=d;return}function BK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+120>>3]=+h[b+5952>>3]+ +h[b+328>>3];i=i;return}function CK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+5952>>3]),1.0e-15);k=+zd(+-+h[g+120>>3],1.0e-15);l=j+k;m=j*+h[g+344>>3]+k*+h[g+104>>3];if(l!=0.0){n=g;o=m/l;p=n;q=p+4384|0;r=q;h[r>>3]=o;i=d;return}if(m==0.0){n=g;o=m;p=n;q=p+4384|0;r=q;h[r>>3]=o;i=d;return}k=m/+nwa(c[b+536>>2]|0,l,50552,50544,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=k;p=n;q=p+4384|0;r=q;h[r>>3]=o;i=d;return}function DK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+128>>3]=+h[b+120>>3]- +h[b+2672>>3];i=i;return}function EK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+136>>3]=+h[b+128>>3]- +h[b+2680>>3];i=i;return}function FK(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+136>>3];h[b+2472>>3]=d*+h[(!(d>=0.0)?b+1760|0:b+1872|0)>>3];i=i;return}function GK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+144>>3]=+h[b+136>>3]- +h[b+2688>>3];i=i;return}function HK(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+144>>3];h[b+2480>>3]=d*+h[(!(d>=0.0)?b+1648|0:b+1760|0)>>3];i=i;return}function IK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2608>>3]=+h[b+2472>>3]- +h[b+2480>>3];i=i;return}function JK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2568>>3]=+h[b+8584>>3]- +h[b+2608>>3];i=i;return}function KK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+152>>3]=+h[b+144>>3]- +h[b+2696>>3];i=i;return}function LK(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+152>>3];h[b+2488>>3]=d*+h[(!(d>=0.0)?b+1536|0:b+1648|0)>>3];i=i;return}function MK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2616>>3]=+h[b+2480>>3]- +h[b+2488>>3];i=i;return}function NK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2576>>3]=+h[b+8592>>3]- +h[b+2616>>3];i=i;return}function OK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+160>>3]=+h[b+152>>3]- +h[b+2704>>3];i=i;return}function PK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1032>>3]*+h[j+1528>>3]*+h[e+2112>>3];l=+h[j+152>>3]+ +h[j+160>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1424|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1424|0;r=q;h[r>>3]=o;i=d;return}s=l/+nwa(c[b+536>>2]|0,k,50632,50624,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1424|0;r=q;h[r>>3]=o;i=d;return}function QK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0.0;d=i;i=i+56|0;e=d;f=d+32|0;g=d+48|0;j=i;i=i+16|0;l=i;i=i+32|0;m=i;i=i+32|0;n=i;i=i+8|0;o=g;h[k>>3]=.99;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];gxa(j,2,.01,g);g=b+536|0;o=c[g>>2]|0;p=b+4|0;q=c[(c[c[p>>2]>>2]|0)+8>>2]|0;r=+h[q+10672>>3];s=+h[q+2832>>3];q=f;t=j;c[q+0>>2]=c[t+0>>2];c[q+4>>2]=c[t+4>>2];c[q+8>>2]=c[t+8>>2];mA(m,o,r,s,f);f=l;o=m;c[f+0>>2]=c[o+0>>2];c[f+4>>2]=c[o+4>>2];c[f+8>>2]=c[o+8>>2];c[f+12>>2]=c[o+12>>2];c[f+16>>2]=c[o+16>>2];c[f+20>>2]=c[o+20>>2];c[f+24>>2]=c[o+24>>2];c[f+28>>2]=c[o+28>>2];o=c[g>>2]|0;f=e;m=l;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];c[f+12>>2]=c[m+12>>2];c[f+16>>2]=c[m+16>>2];c[f+20>>2]=c[m+20>>2];c[f+24>>2]=c[m+24>>2];c[f+28>>2]=c[m+28>>2];qA(n,o,e);e=c[b+416>>2]|0;s=+h[n>>3]*+h[e+2112>>3]*+h[e+1032>>3];e=c[c[p>>2]>>2]|0;n=c[e+8>>2]|0;r=+h[n+160>>3];if(s!=0.0){u=n;v=r/s;w=u;x=w+2440|0;y=x;h[y>>3]=v;i=d;return}if(r==0.0){u=n;v=r;w=u;x=w+2440|0;y=x;h[y>>3]=v;i=d;return}z=r/+nwa(c[g>>2]|0,s,50704,50696,+h[e>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[p>>2]>>2]|0)+8>>2]|0;v=z;w=u;x=w+2440|0;y=x;h[y>>3]=v;i=d;return}function RK(a){a=a|0;var b=0,d=0.0,e=0.0,f=0,g=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1424>>3];e=+h[b+2440>>3];f=c[a+416>>2]|0;g=+h[f+1032>>3];h[b+2176>>3]=+h[f+2216>>3]*(+h[b+2424>>3]*d*d*g- +h[b+2432>>3]*e*e*g);i=i;return}function SK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2080>>3]=+h[b+2176>>3]- +h[b+2128>>3]- +h[b+8320>>3];i=i;return}function TK(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2216>>3]*+h[e+1032>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2080>>3];if(f!=0.0){l=j;m=k/f;n=l;o=n+2032|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+2032|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,f,50912,50904,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2032|0;p=o;h[p>>3]=m;i=d;return}function UK(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+160>>3];h[b+2496>>3]=d*+h[(!(d>=0.0)?b+10760|0:b+1536|0)>>3];i=i;return}function VK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2624>>3]=+h[b+2488>>3]- +h[b+2496>>3];i=i;return}function WK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2584>>3]=+h[b+8600>>3]- +h[b+2624>>3];i=i;return}function XK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1024>>3]*+h[j+1640>>3]*+h[e+2112>>3];l=+h[j+144>>3]+ +h[j+152>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1416|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1416|0;r=q;h[r>>3]=o;i=d;return}s=l/+nwa(c[b+536>>2]|0,k,50968,50960,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1416|0;r=q;h[r>>3]=o;i=d;return}function YK(a){a=a|0;var b=0,d=0.0,e=0.0,f=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1416>>3];e=+h[b+1424>>3];f=c[a+416>>2]|0;h[b+2168>>3]=+h[f+2216>>3]*(+h[b+2416>>3]*d*d*+h[f+1024>>3]- +h[b+2424>>3]*e*e*+h[f+1032>>3]);i=i;return}function ZK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2072>>3]=+h[b+2168>>3]- +h[b+2120>>3]- +h[b+8312>>3];i=i;return}function _K(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=(+h[e+1024>>3]+ +h[e+1032>>3])*+h[e+2216>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2072>>3];if(f!=0.0){l=j;m=k/f;n=m*2.0;o=l;p=o+2024|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*2.0;o=l;p=o+2024|0;q=p;h[q>>3]=n;i=d;return}r=k/+nwa(c[b+536>>2]|0,f,51040,51032,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*2.0;o=l;p=o+2024|0;q=p;h[q>>3]=n;i=d;return}function $K(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1016>>3]*+h[j+1752>>3]*+h[e+2112>>3];l=+h[j+136>>3]+ +h[j+144>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1408|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1408|0;r=q;h[r>>3]=o;i=d;return}s=l/+nwa(c[b+536>>2]|0,k,51120,51112,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1408|0;r=q;h[r>>3]=o;i=d;return}function aL(a){a=a|0;var b=0,d=0.0,e=0.0,f=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1408>>3];e=+h[b+1416>>3];f=c[a+416>>2]|0;h[b+2160>>3]=+h[f+2216>>3]*(+h[b+2408>>3]*d*d*+h[f+1016>>3]- +h[b+2416>>3]*e*e*+h[f+1024>>3]);i=i;return}function bL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2064>>3]=+h[b+2160>>3]- +h[b+2112>>3]- +h[b+8304>>3];i=i;return}function cL(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=(+h[e+1016>>3]+ +h[e+1024>>3])*+h[e+2216>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2064>>3];if(f!=0.0){l=j;m=k/f;n=m*2.0;o=l;p=o+2016|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*2.0;o=l;p=o+2016|0;q=p;h[q>>3]=n;i=d;return}r=k/+nwa(c[b+536>>2]|0,f,51192,51184,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*2.0;o=l;p=o+2016|0;q=p;h[q>>3]=n;i=d;return}function dL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1008>>3]*+h[j+1864>>3]*+h[e+2112>>3];l=+h[j+128>>3]+ +h[j+136>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1400|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1400|0;r=q;h[r>>3]=o;i=d;return}s=l/+nwa(c[b+536>>2]|0,k,51272,51264,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1400|0;r=q;h[r>>3]=o;i=d;return}function eL(a){a=a|0;var b=0,d=0.0,e=0.0,f=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1400>>3];e=+h[b+1408>>3];f=c[a+416>>2]|0;h[b+2152>>3]=+h[f+2216>>3]*(+h[b+2400>>3]*d*d*+h[f+1008>>3]- +h[b+2408>>3]*e*e*+h[f+1016>>3]);i=i;return}function fL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2056>>3]=+h[b+2152>>3]- +h[b+2104>>3]- +h[b+8296>>3];i=i;return}function gL(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=(+h[e+1008>>3]+ +h[e+1016>>3])*+h[e+2216>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2056>>3];if(f!=0.0){l=j;m=k/f;n=m*2.0;o=l;p=o+2008|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*2.0;o=l;p=o+2008|0;q=p;h[q>>3]=n;i=d;return}r=k/+nwa(c[b+536>>2]|0,f,51344,51336,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*2.0;o=l;p=o+2008|0;q=p;h[q>>3]=n;i=d;return}function hL(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+128>>3];h[b+2464>>3]=d*+h[(!(d>=0.0)?b+1872|0:b+1984|0)>>3];i=i;return}function iL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2600>>3]=+h[b+2464>>3]- +h[b+2472>>3];i=i;return}function jL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2560>>3]=+h[b+8576>>3]- +h[b+2600>>3];i=i;return}function kL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1e3>>3]*+h[j+1976>>3]*+h[e+2112>>3];l=+h[j+120>>3]+ +h[j+128>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1392|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1392|0;r=q;h[r>>3]=o;i=d;return}s=l/+nwa(c[b+536>>2]|0,k,51424,51416,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1392|0;r=q;h[r>>3]=o;i=d;return}function lL(a){a=a|0;var b=0,d=0.0,e=0.0,f=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1392>>3];e=+h[b+1400>>3];f=c[a+416>>2]|0;h[b+2144>>3]=+h[f+2216>>3]*(+h[b+2392>>3]*d*d*+h[f+1e3>>3]- +h[b+2400>>3]*e*e*+h[f+1008>>3]);i=i;return}function mL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2048>>3]=+h[b+2144>>3]- +h[b+2096>>3]- +h[b+8288>>3];i=i;return}function nL(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=(+h[e+1e3>>3]+ +h[e+1008>>3])*+h[e+2216>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2048>>3];if(f!=0.0){l=j;m=k/f;n=m*2.0;o=l;p=o+2e3|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*2.0;o=l;p=o+2e3|0;q=p;h[q>>3]=n;i=d;return}r=k/+nwa(c[b+536>>2]|0,f,51496,51488,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*2.0;o=l;p=o+2e3|0;q=p;h[q>>3]=n;i=d;return}function oL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+5952>>3]),1.0e-15);k=+zd(+(+h[g+328>>3]),1.0e-15);l=j+k;m=-(k*+h[g+176>>3])-j*+h[g+344>>3];if(l!=0.0){n=g;o=m/l;p=o+1.0;q=n;r=q+2888|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=o+1.0;q=n;r=q+2888|0;s=r;h[s>>3]=p;i=d;return}j=m/+nwa(c[b+536>>2]|0,l,50456,51568,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=o+1.0;q=n;r=q+2888|0;s=r;h[s>>3]=p;i=d;return}function pL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0.0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0.0;d=i;i=i+56|0;e=d;f=d+32|0;g=d+48|0;j=i;i=i+16|0;l=i;i=i+32|0;m=i;i=i+32|0;n=i;i=i+8|0;o=b+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[p+2880>>3];r=g;h[k>>3]=+h[p+2888>>3];c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];gxa(j,2,q,g);g=b+536|0;r=c[g>>2]|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[p+352>>3];s=+h[p+2896>>3];p=f;t=j;c[p+0>>2]=c[t+0>>2];c[p+4>>2]=c[t+4>>2];c[p+8>>2]=c[t+8>>2];mA(m,r,q,s,f);f=l;r=m;c[f+0>>2]=c[r+0>>2];c[f+4>>2]=c[r+4>>2];c[f+8>>2]=c[r+8>>2];c[f+12>>2]=c[r+12>>2];c[f+16>>2]=c[r+16>>2];c[f+20>>2]=c[r+20>>2];c[f+24>>2]=c[r+24>>2];c[f+28>>2]=c[r+28>>2];r=c[g>>2]|0;f=e;m=l;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];c[f+12>>2]=c[m+12>>2];c[f+16>>2]=c[m+16>>2];c[f+20>>2]=c[m+20>>2];c[f+24>>2]=c[m+24>>2];c[f+28>>2]=c[m+28>>2];qA(n,r,e);e=c[b+416>>2]|0;s=+h[n>>3]*+h[e+1e3>>3]*+h[e+2112>>3];e=c[c[o>>2]>>2]|0;n=c[e+8>>2]|0;q=+h[n+120>>3];if(s!=0.0){u=n;v=q/s;w=u;x=w+2448|0;y=x;h[y>>3]=v;i=d;return}if(q==0.0){u=n;v=q;w=u;x=w+2448|0;y=x;h[y>>3]=v;i=d;return}z=q/+nwa(c[g>>2]|0,s,51584,51576,+h[e>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[o>>2]>>2]|0)+8>>2]|0;v=z;w=u;x=w+2448|0;y=x;h[y>>3]=v;i=d;return}function qL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+2880>>3];p=f;h[k>>3]=+h[n+2888>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+352>>3];q=+h[p+2896>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2384>>3]=+h[l>>3];i=b;return}function rL(a){a=a|0;var b=0,d=0.0,e=0.0,f=0,g=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+2448>>3];e=+h[b+1392>>3];f=c[a+416>>2]|0;g=+h[f+1e3>>3];h[b+2136>>3]=+h[f+2216>>3]*(+h[b+2384>>3]*d*d*g- +h[b+2392>>3]*e*e*g);i=i;return}function sL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+104>>3];v=l;h[k>>3]=+h[t+2872>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];gxa(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+112>>3];w=+h[t+96>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];vz(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Bz(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+2880>>3];f=j;h[k>>3]=+h[q+2888>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];gxa(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+352>>3];y=+h[f+2896>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];vz(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Bz(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+2088>>3]=+h[d+1e3>>3]*(w- +h[r>>3])*+h[d+2216>>3];i=b;return}function tL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2040>>3]=+h[b+2136>>3]- +h[b+2088>>3]- +h[b+8280>>3];i=i;return}function uL(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2216>>3]*+h[e+1e3>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2040>>3];if(f!=0.0){l=j;m=k/f;n=l;o=n+1992|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+1992|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,f,51832,51824,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1992|0;p=o;h[p>>3]=m;i=d;return}function vL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+2880>>3];p=f;h[k>>3]=+h[n+2888>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+352>>3];q=+h[p+2896>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2280>>3]=+h[l>>3];i=b;return}function wL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+120>>3];if(!(j>=0.0)){k=g;l=j*+h[g+104>>3];m=k;n=m+2504|0;o=n;h[o>>3]=l;i=d;return}p=+zd(+(+h[g+5952>>3]),1.0e-15);q=+zd(+(+h[g+328>>3]),1.0e-15);r=p+q;s=p*+h[g+344>>3]+q*+h[g+176>>3];do{if(r!=0.0){t=j;u=g;v=s/r}else{if(s==0.0){t=j;u=g;v=s;break}q=s/+nwa(c[b+536>>2]|0,r,50456,51880,+h[f>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[w+120>>3];u=w;v=q}}while(0);k=u;l=v*t;m=k;n=m+2504|0;o=n;h[o>>3]=l;i=d;return}function xL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2512>>3]=+h[b+2504>>3]- +h[b+2632>>3];i=i;return}function yL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2520>>3]=+h[b+2512>>3]- +h[b+2640>>3];i=i;return}function zL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2528>>3]=+h[b+2520>>3]- +h[b+2648>>3];i=i;return}function AL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2536>>3]=+h[b+2528>>3]- +h[b+2656>>3];i=i;return}function BL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2544>>3]=+h[b+2536>>3]- +h[b+2664>>3];i=i;return}function CL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0.0;d=i;i=i+120|0;e=d;f=d+96|0;g=d+112|0;j=i;i=i+48|0;l=i;i=i+8|0;m=i;i=i+48|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+96|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=b+4|0;w=c[c[v>>2]>>2]|0;x=c[w+8>>2]|0;y=+zd(+(+h[x+5952>>3]),1.0e-15);z=+zd(+-+h[x+120>>3],1.0e-15);A=y+z;B=y*+h[x+344>>3]+z*+h[x+104>>3];do{if(A!=0.0){C=B/A}else{if(B==0.0){C=B;break}C=B/+nwa(c[b+536>>2]|0,A,50552,51888,+h[w>>3],(a[b+319|0]|0)!=0|0)}}while(0);gxa(o,1,C,n);n=m;h[k>>3]=575.573102;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=m+8|0;h[k>>3]=.931782653;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=m+16|0;h[k>>3]=.00722271286;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=m+24|0;h[k>>3]=-734255737.0e-14;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=m+32|0;h[k>>3]=4.95504349e-9;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=m+40|0;h[k>>3]=-1.336933246e-12;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];gxa(q,7,-39479.6083,m);m=l;h[k>>3]=17.24205775;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];gxa(r,2,-33039.7431,l);l=j;h[k>>3]=-2412.698562;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];l=j+8|0;h[k>>3]=4.64611078;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];l=j+16|0;h[k>>3]=.002291998307;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];l=j+24|0;h[k>>3]=-6.836830479999999e-7;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];l=j+32|0;h[k>>3]=9.426468930000001e-11;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];l=j+40|0;h[k>>3]=-4.82238053e-15;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];gxa(s,7,1034972.096,j);j=g;h[k>>3]=-7.97814851;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];gxa(t,2,-13842.86509,g);c[p>>2]=50528;h[p+8>>3]=.01801528;h[p+16>>3]=-13423382.81725291;h[p+24>>3]=549760.6476280135;h[p+32>>3]=1.0e3;g=p+40|0;j=q;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];j=p+52|0;g=r;c[j+0>>2]=c[g+0>>2];c[j+4>>2]=c[g+4>>2];c[j+8>>2]=c[g+8>>2];g=p+64|0;j=s;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];j=p+76|0;g=t;c[j+0>>2]=c[g+0>>2];c[j+4>>2]=c[g+4>>2];c[j+8>>2]=c[g+8>>2];h[p+88>>3]=461.5233290850878;g=c[b+536>>2]|0;j=c[c[v>>2]>>2]|0;t=c[j+8>>2]|0;C=+zd(+(+h[t+5952>>3]),1.0e-15);A=+zd(+-+h[t+120>>3],1.0e-15);B=C+A;z=C*+h[t+5096>>3]+A*+h[t+1984>>3];do{if(B!=0.0){D=t;E=z/B}else{if(z==0.0){D=t;E=z;break}A=z/+nwa(g,B,50552,51888,+h[j>>3],(a[b+319|0]|0)!=0|0);D=c[(c[c[v>>2]>>2]|0)+8>>2]|0;E=A}}while(0);B=+h[D+352>>3];D=f;b=o;c[D+0>>2]=c[b+0>>2];c[D+4>>2]=c[b+4>>2];c[D+8>>2]=c[b+8>>2];b=e+0|0;D=p+0|0;p=b+96|0;do{c[b>>2]=c[D>>2];b=b+4|0;D=D+4|0}while((b|0)<(p|0));nA(u,g,E,190.0,647.0,B,f,e,1.0e-13);h[(c[(c[c[v>>2]>>2]|0)+8>>2]|0)+4400>>3]=+h[u>>3];i=d;return}function DL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+5952>>3]),1.0e-15);k=+zd(+-+h[g+120>>3],1.0e-15);l=j+k;m=-(k*+h[g+104>>3])-j*+h[g+344>>3];if(l!=0.0){n=g;o=m/l;p=o+1.0;q=n;r=q+4392|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=o+1.0;q=n;r=q+4392|0;s=r;h[s>>3]=p;i=d;return}j=m/+nwa(c[b+536>>2]|0,l,50552,51896,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=o+1.0;q=n;r=q+4392|0;s=r;h[s>>3]=p;i=d;return}function EL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+4384>>3];v=l;h[k>>3]=+h[t+4392>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];gxa(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+352>>3];w=+h[t+4400>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];vz(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Bz(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+176>>3];f=j;h[k>>3]=+h[q+4408>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];gxa(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+184>>3];y=+h[f+168>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];vz(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Bz(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+3680>>3]=+h[d+736>>3]*(w- +h[r>>3])*+h[d+1992>>3];i=b;return}function FL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+4384>>3];p=f;h[k>>3]=+h[n+4392>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+352>>3];q=+h[p+4400>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+3984>>3]=+h[l>>3];i=b;return}function GL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0.0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0.0;d=i;i=i+56|0;e=d;f=d+32|0;g=d+48|0;j=i;i=i+16|0;l=i;i=i+32|0;m=i;i=i+32|0;n=i;i=i+8|0;o=b+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[p+4384>>3];r=g;h[k>>3]=+h[p+4392>>3];c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];gxa(j,2,q,g);g=b+536|0;r=c[g>>2]|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[p+352>>3];s=+h[p+4400>>3];p=f;t=j;c[p+0>>2]=c[t+0>>2];c[p+4>>2]=c[t+4>>2];c[p+8>>2]=c[t+8>>2];mA(m,r,q,s,f);f=l;r=m;c[f+0>>2]=c[r+0>>2];c[f+4>>2]=c[r+4>>2];c[f+8>>2]=c[r+8>>2];c[f+12>>2]=c[r+12>>2];c[f+16>>2]=c[r+16>>2];c[f+20>>2]=c[r+20>>2];c[f+24>>2]=c[r+24>>2];c[f+28>>2]=c[r+28>>2];r=c[g>>2]|0;f=e;m=l;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];c[f+12>>2]=c[m+12>>2];c[f+16>>2]=c[m+16>>2];c[f+20>>2]=c[m+20>>2];c[f+24>>2]=c[m+24>>2];c[f+28>>2]=c[m+28>>2];qA(n,r,e);e=c[b+416>>2]|0;s=+h[n>>3]*+h[e+736>>3]*+h[e+1888>>3];e=c[c[o>>2]>>2]|0;n=c[e+8>>2]|0;q=+h[n+328>>3];if(s!=0.0){u=n;v=q/s;w=u;x=w+3992|0;y=x;h[y>>3]=v;i=d;return}if(q==0.0){u=n;v=q;w=u;x=w+3992|0;y=x;h[y>>3]=v;i=d;return}z=q/+nwa(c[g>>2]|0,s,51912,51904,+h[e>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[o>>2]>>2]|0)+8>>2]|0;v=z;w=u;x=w+3992|0;y=x;h[y>>3]=v;i=d;return}function HL(a){a=a|0;var b=0,d=0.0,e=0.0,f=0,g=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+2976>>3];e=+h[b+3992>>3];f=c[a+416>>2]|0;g=+h[f+736>>3];h[b+3728>>3]=+h[f+1992>>3]*(+h[b+3976>>3]*d*d*g- +h[b+3984>>3]*e*e*g);i=i;return}function IL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3632>>3]=+h[b+3728>>3]- +h[b+3680>>3]- +h[b+8152>>3];i=i;return}function JL(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+1992>>3]*+h[e+736>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+3632>>3];if(f!=0.0){l=j;m=k/f;n=l;o=n+3584|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+3584|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,f,52160,52152,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+3584|0;p=o;h[p>>3]=m;i=d;return}function KL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+4384>>3];p=f;h[k>>3]=+h[n+4392>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+352>>3];q=+h[p+4400>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+3880>>3]=+h[l>>3];i=b;return}function LL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+328>>3];if(j>=0.0){k=g;l=j*+h[g+176>>3];m=k;n=m+4096|0;o=n;h[o>>3]=l;i=d;return}p=+zd(+(+h[g+5952>>3]),1.0e-15);q=+zd(+-+h[g+120>>3],1.0e-15);r=p+q;s=p*+h[g+344>>3]+q*+h[g+104>>3];do{if(r!=0.0){t=j;u=g;v=s/r}else{if(s==0.0){t=j;u=g;v=s;break}q=s/+nwa(c[b+536>>2]|0,r,50552,52208,+h[f>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[w+328>>3];u=w;v=q}}while(0);k=u;l=v*t;m=k;n=m+4096|0;o=n;h[o>>3]=l;i=d;return}function ML(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+120>>3];if(!(j>=0.0)){k=g;l=j*+h[g+1984>>3];m=k;n=m+2456|0;o=n;h[o>>3]=l;i=d;return}p=+zd(+(+h[g+5952>>3]),1.0e-15);q=+zd(+(+h[g+328>>3]),1.0e-15);r=p+q;s=p*+h[g+5096>>3]+q*+h[g+3088>>3];do{if(r!=0.0){t=j;u=g;v=s/r}else{if(s==0.0){t=j;u=g;v=s;break}q=s/+nwa(c[b+536>>2]|0,r,50456,52216,+h[f>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[w+120>>3];u=w;v=q}}while(0);k=u;l=v*t;m=k;n=m+2456|0;o=n;h[o>>3]=l;i=d;return}function NL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2592>>3]=+h[b+2456>>3]- +h[b+2464>>3];i=i;return}function OL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2552>>3]=+h[b+8568>>3]- +h[b+2592>>3];i=i;return}function PL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+328>>3];if(j>=0.0){k=g;l=j*+h[g+3088>>3];m=k;n=m+4048|0;o=n;h[o>>3]=l;i=d;return}p=+zd(+(+h[g+5952>>3]),1.0e-15);q=+zd(+-+h[g+120>>3],1.0e-15);r=p+q;s=p*+h[g+5096>>3]+q*+h[g+1984>>3];do{if(r!=0.0){t=j;u=g;v=s/r}else{if(s==0.0){t=j;u=g;v=s;break}q=s/+nwa(c[b+536>>2]|0,r,50552,52224,+h[f>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[w+328>>3];u=w;v=q}}while(0);k=u;l=v*t;m=k;n=m+4048|0;o=n;h[o>>3]=l;i=d;return}function QL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4176>>3]=+h[b+4040>>3]- +h[b+4048>>3];i=i;return}function RL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4136>>3]=+h[b+8560>>3]- +h[b+4176>>3];i=i;return}function SL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5952>>3];if(j>=0.0){k=g;l=j*+h[g+5096>>3];m=k;n=m+5896|0;o=n;h[o>>3]=l;i=d;return}p=+zd(+(+h[g+328>>3]),1.0e-15);q=+zd(+-+h[g+120>>3],1.0e-15);r=p+q;s=p*+h[g+3088>>3]+q*+h[g+1984>>3];do{if(r!=0.0){t=j;u=g;v=s/r}else{if(s==0.0){t=j;u=g;v=s;break}q=s/+nwa(c[b+536>>2]|0,r,52240,52232,+h[f>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[w+5952>>3];u=w;v=q}}while(0);k=u;l=v*t;m=k;n=m+5896|0;o=n;h[o>>3]=l;i=d;return}function TL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6080>>3]=+h[b+5888>>3]- +h[b+5896>>3];i=i;return}function UL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+440>>3]*+h[j+5088>>3]*+h[e+1656>>3];l=+h[j+480>>3]+ +h[j+5952>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+4984|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+4984|0;r=q;h[r>>3]=o;i=d;return}s=l/+nwa(c[b+536>>2]|0,k,52336,52328,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+4984|0;r=q;h[r>>3]=o;i=d;return}function VL(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;wz(d,c[a+536>>2]|0,+h[f+4984>>3],+h[f+4824>>3],+h[f+4784>>3],+h[(c[a+416>>2]|0)+480>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4944>>3]=+h[d>>3];i=b;return}function WL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+zd(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+4944>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+Nxa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4584|0;w=v;h[w>>3]=n;i=b;return}x=c[63880]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=57624;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Oe[a&127](y,d,52400,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+Nxa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4584|0;w=v;h[w>>3]=n;i=b;return}function XL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=Dza(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4984>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4584>>3];l=+U(+(+h[j+4944>>3]));m=+h[j+4904>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?4.5:.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+400>>3];q=n*p;r=q!=0.0;s=+h[o+480>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+nwa(c[b+536>>2]|0,q,52504,52496,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+4904>>3];u=+h[j+4584>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+4704|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+nwa(c[b+536>>2]|0,q,52504,52496,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+480>>3];M=+h[j+400>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+nwa(c[b+536>>2]|0,q,52504,52496,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+4704|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+nwa(c[b+536>>2]|0,q,52504,52496,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4584>>3]*.125));L=P*(+W(+(+h[g+4904>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+nwa(c[b+536>>2]|0,L,52568,52496,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+4704|0;K=J;h[K>>3]=B;i=d;return}}function YL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=Dza(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4984>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+4944>>3]));l=+h[j+4904>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?4.5:.5)*+h[m+400>>3];o=+h[m+480>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+nwa(c[b+536>>2]|0,n,52504,52688,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+4624>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function ZL(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+4624>>3]+-.7;h[b+4664>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function _L(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+432>>3]*+h[j+5200>>3]*+h[e+1656>>3];l=+h[j+472>>3]+ +h[j+480>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+4976|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+4976|0;r=q;h[r>>3]=o;i=d;return}s=l/+nwa(c[b+536>>2]|0,k,52704,52696,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+4976|0;r=q;h[r>>3]=o;i=d;return}function $L(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;wz(d,c[a+536>>2]|0,+h[f+4976>>3],+h[f+4816>>3],+h[f+4776>>3],+h[(c[a+416>>2]|0)+472>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4936>>3]=+h[d>>3];i=b;return}function aM(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=Dza(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4976>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+4936>>3]));l=+h[j+4896>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?3.5:1.5)*+h[m+392>>3];o=+h[m+472>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+nwa(c[b+536>>2]|0,n,52776,52768,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+4616>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function bM(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+4616>>3]+-.7;h[b+4656>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function cM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+zd(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+4936>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+Nxa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4576|0;w=v;h[w>>3]=n;i=b;return}x=c[63880]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=57624;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Oe[a&127](y,d,52840,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+Nxa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4576|0;w=v;h[w>>3]=n;i=b;return}function dM(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=Dza(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4976>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4576>>3];l=+U(+(+h[j+4936>>3]));m=+h[j+4896>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?3.5:1.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+392>>3];q=n*p;r=q!=0.0;s=+h[o+472>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+nwa(c[b+536>>2]|0,q,52776,52936,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+4896>>3];u=+h[j+4576>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+4696|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+nwa(c[b+536>>2]|0,q,52776,52936,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+472>>3];M=+h[j+392>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+nwa(c[b+536>>2]|0,q,52776,52936,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+4696|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+nwa(c[b+536>>2]|0,q,52776,52936,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4576>>3]*.125));L=P*(+W(+(+h[g+4896>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+nwa(c[b+536>>2]|0,L,52944,52936,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+4696|0;K=J;h[K>>3]=B;i=d;return}}function eM(a){a=a|0;var b=0,d=0.0,e=0.0,f=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+4976>>3];e=+h[b+4984>>3];f=c[a+416>>2]|0;h[b+5672>>3]=+h[f+1760>>3]*(+h[b+5840>>3]*d*d*+h[f+432>>3]- +h[b+5848>>3]*e*e*+h[f+440>>3]);i=i;return}function fM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5608>>3]=+h[b+5672>>3]- +h[b+5640>>3]- +h[b+7984>>3];i=i;return}function gM(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=(+h[e+432>>3]+ +h[e+440>>3])*+h[e+1760>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+5608>>3];if(f!=0.0){l=j;m=k/f;n=m*2.0;o=l;p=o+5576|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*2.0;o=l;p=o+5576|0;q=p;h[q>>3]=n;i=d;return}r=k/+nwa(c[b+536>>2]|0,f,53072,53064,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*2.0;o=l;p=o+5576|0;q=p;h[q>>3]=n;i=d;return}function hM(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+6e3>>3]=+h[b+4984>>3]*+h[d+440>>3]*+h[d+1656>>3]*(+h[b+352>>3]*.5+(+h[b+376>>3]*-.5+(+h[b+5576>>3]*.5+ +h[d+1352>>3]*+h[b+5088>>3]*-5.0)));i=i;return}function iM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6040>>3]=+h[b+8520>>3]+(-+h[b+6080>>3]- +h[b+6e3>>3]);i=i;return}function jM(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0,k=0,l=0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;e=c[b+416>>2]|0;f=+h[e+1328>>3];g=f*40.0;j=b+4|0;k=c[c[j>>2]>>2]|0;l=c[k+8>>2]|0;m=+h[l+6040>>3]-(1.0-f*+h[e+1320>>3])*40.0;if(g!=0.0){n=l;o=m/g;p=n;q=p+1312|0;r=q;h[r>>3]=o;i=d;return}if(m==0.0){n=l;o=m;p=n;q=p+1312|0;r=q;h[r>>3]=o;i=d;return}f=m/+nwa(c[b+536>>2]|0,g,53152,53144,+h[k>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[j>>2]>>2]|0)+8>>2]|0;o=f;p=n;q=p+1312|0;r=q;h[r>>3]=o;i=d;return}function kM(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+464>>3];h[b+5872>>3]=d*+h[(!(d>=0.0)?b+5320|0:b+5432|0)>>3];i=i;return}function lM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6056>>3]=+h[b+5864>>3]- +h[b+5872>>3];i=i;return}function mM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6064>>3]=+h[b+5872>>3]- +h[b+5880>>3];i=i;return}function nM(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+424>>3]*+h[j+5312>>3]*+h[e+1656>>3];l=+h[j+464>>3]+ +h[j+472>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+4968|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+4968|0;r=q;h[r>>3]=o;i=d;return}s=l/+nwa(c[b+536>>2]|0,k,53184,53176,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+4968|0;r=q;h[r>>3]=o;i=d;return}function oM(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;wz(d,c[a+536>>2]|0,+h[f+4968>>3],+h[f+4808>>3],+h[f+4768>>3],+h[(c[a+416>>2]|0)+464>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4928>>3]=+h[d>>3];i=b;return}function pM(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0,o=0.0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+W(+(+U(+(+h[g+4928>>3]))),.3333333333333333);k=+W(+(+h[g+4888>>3]),.3333333333333333);l=c[b+416>>2]|0;m=+W(+(+h[l+464>>3]),.3333333333333333);n=+h[l+384>>3];if(n!=0.0){o=n;p=g;q=1.0/o;r=+W(+q,.3333333333333333);s=r*.7368062997280773;t=m*s;u=k*t;v=j*u;w=v*1.077;x=p;y=x+4608|0;z=y;h[z>>3]=w;i=d;return}A=+nwa(c[b+536>>2]|0,n,53256,53248,+h[f>>3],(a[b+319|0]|0)!=0|0);o=A;p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=1.0/o;r=+W(+q,.3333333333333333);s=r*.7368062997280773;t=m*s;u=k*t;v=j*u;w=v*1.077;x=p;y=x+4608|0;z=y;h[z>>3]=w;i=d;return}function qM(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+4608>>3]+-.7;h[b+4648>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function rM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+zd(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+4928>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+Nxa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4568|0;w=v;h[w>>3]=n;i=b;return}x=c[63880]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=57624;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Oe[a&127](y,d,53280,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+Nxa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4568|0;w=v;h[w>>3]=n;i=b;return}function sM(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0,O=0,P=0.0,Q=0,R=0.0,S=0.0,T=0,X=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4568>>3];k=+U(+(+h[g+4928>>3]));l=+V(+(j*.125));m=+h[g+4888>>3];n=l*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;o=b+416|0;p=c[o>>2]|0;l=+h[p+464>>3];q=+W(+l,.6666666666666666);r=+h[p+384>>3];p=r!=0.0;if(n){if(p){s=r;t=m;u=j}else{v=+nwa(c[b+536>>2]|0,r,53256,53376,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;s=v;t=+h[n+4888>>3];u=+h[n+4568>>3]}w=m*(q*+W(+(1.0/s),.6666666666666666)*.5428835233189814*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);x=k*w;y=j*x;z=y*.125;A=c[e>>2]|0;B=c[A>>2]|0;C=B;D=C+8|0;E=D;F=c[E>>2]|0;G=F;H=G+4688|0;I=H;h[I>>3]=z;i=d;return}if(p){J=r;K=r;L=l;M=m;N=g;O=f}else{l=+nwa(c[b+536>>2]|0,r,53256,53376,+h[f>>3],(a[b+319|0]|0)!=0|0);f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;p=c[o>>2]|0;J=l;K=+h[p+384>>3];L=+h[p+464>>3];M=+h[g+4888>>3];N=g;O=f}l=+W(+L,.6666666666666666);f=K!=0.0;if(m*(q*+W(+(1.0/J),.6666666666666666)*.5428835233189814*.3333333333333333+1.0)==0.0){if(f){P=K}else{P=+nwa(c[b+536>>2]|0,K,53256,53376,+h[O>>3],(a[b+319|0]|0)!=0|0)}w=M*(l*+W(+(1.0/P),.6666666666666666)*.5428835233189814*.3333333333333333+1.0);x=k*w;y=j*x;z=y*.125;A=c[e>>2]|0;B=c[A>>2]|0;C=B;D=C+8|0;E=D;F=c[E>>2]|0;G=F;H=G+4688|0;I=H;h[I>>3]=z;i=d;return}g=b+536|0;if(f){Q=b+319|0;R=K;S=M;T=N;X=O}else{N=b+319|0;P=+nwa(c[g>>2]|0,K,53256,53376,+h[O>>3],(a[N]|0)!=0|0);O=c[c[e>>2]>>2]|0;b=c[O+8>>2]|0;Q=N;R=P;S=+h[b+4888>>3];T=b;X=O}P=M*(l*+W(+(1.0/R),.6666666666666666)*.5428835233189814*.3333333333333333+1.0);R=+V(+(+h[T+4568>>3]*.125))*(+W(+S,.6666666666666666)+-1.0)*12.7+1.0;w=P/+nwa(c[g>>2]|0,R,53384,53376,+h[X>>3],(a[Q]|0)!=0|0);x=k*w;y=j*x;z=y*.125;A=c[e>>2]|0;B=c[A>>2]|0;C=B;D=C+8|0;E=D;F=c[E>>2]|0;G=F;H=G+4688|0;I=H;h[I>>3]=z;i=d;return}function tM(a){a=a|0;var b=0,d=0.0,e=0.0,f=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+4968>>3];e=+h[b+4976>>3];f=c[a+416>>2]|0;h[b+5664>>3]=+h[f+1760>>3]*(+h[b+5832>>3]*d*d*+h[f+424>>3]- +h[b+5840>>3]*e*e*+h[f+432>>3]);i=i;return}function uM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5600>>3]=+h[b+5664>>3]- +h[b+5632>>3]- +h[b+7976>>3];i=i;return}function vM(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=(+h[e+424>>3]+ +h[e+432>>3])*+h[e+1760>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+5600>>3];if(f!=0.0){l=j;m=k/f;n=m*2.0;o=l;p=o+5568|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*2.0;o=l;p=o+5568|0;q=p;h[q>>3]=n;i=d;return}r=k/+nwa(c[b+536>>2]|0,f,53512,53504,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*2.0;o=l;p=o+5568|0;q=p;h[q>>3]=n;i=d;return}function wM(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+5992>>3]=+h[b+4976>>3]*+h[d+432>>3]*+h[d+1656>>3]*(+h[b+352>>3]*.5+(+h[b+400>>3]*-.5+((+h[b+5568>>3]+ +h[b+5576>>3])*.5+ +h[d+1352>>3]*+h[b+5200>>3]*-5.0)));i=i;return}function xM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6032>>3]=+h[b+8512>>3]+(-+h[b+6072>>3]- +h[b+5992>>3]);i=i;return}function yM(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0,k=0,l=0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;e=c[b+416>>2]|0;f=+h[e+1304>>3];g=f*40.0;j=b+4|0;k=c[c[j>>2]>>2]|0;l=c[k+8>>2]|0;m=+h[l+6032>>3]-(1.0-f*+h[e+1296>>3])*40.0;if(g!=0.0){n=l;o=m/g;p=n;q=p+1320|0;r=q;h[r>>3]=o;i=d;return}if(m==0.0){n=l;o=m;p=n;q=p+1320|0;r=q;h[r>>3]=o;i=d;return}f=m/+nwa(c[b+536>>2]|0,g,53592,53584,+h[k>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[j>>2]>>2]|0)+8>>2]|0;o=f;p=n;q=p+1320|0;r=q;h[r>>3]=o;i=d;return}function zM(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+416>>3]*+h[j+5424>>3]*+h[e+1656>>3];l=+h[j+456>>3]+ +h[j+464>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+4960|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+4960|0;r=q;h[r>>3]=o;i=d;return}s=l/+nwa(c[b+536>>2]|0,k,53624,53616,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+4960|0;r=q;h[r>>3]=o;i=d;return}function AM(a){a=a|0;var b=0,d=0.0,e=0.0,f=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+4960>>3];e=+h[b+4968>>3];f=c[a+416>>2]|0;h[b+5656>>3]=+h[f+1760>>3]*(+h[b+5824>>3]*d*d*+h[f+416>>3]- +h[b+5832>>3]*e*e*+h[f+424>>3]);i=i;return}function BM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5592>>3]=+h[b+5656>>3]- +h[b+5624>>3]- +h[b+7968>>3];i=i;return}function CM(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=(+h[e+416>>3]+ +h[e+424>>3])*+h[e+1760>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+5592>>3];if(f!=0.0){l=j;m=k/f;n=m*2.0;o=l;p=o+5560|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*2.0;o=l;p=o+5560|0;q=p;h[q>>3]=n;i=d;return}r=k/+nwa(c[b+536>>2]|0,f,53696,53688,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*2.0;o=l;p=o+5560|0;q=p;h[q>>3]=n;i=d;return}function DM(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+5984>>3]=+h[b+4968>>3]*+h[d+424>>3]*+h[d+1656>>3]*(+h[b+376>>3]*.5+(+h[b+424>>3]*-.5+((+h[b+5560>>3]+ +h[b+5568>>3])*.5+ +h[d+1352>>3]*+h[b+5312>>3]*-5.0)));i=i;return}function EM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6024>>3]=+h[b+8504>>3]+(-+h[b+6064>>3]- +h[b+5984>>3]);i=i;return}function FM(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0,k=0,l=0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;e=c[b+416>>2]|0;f=+h[e+1280>>3];g=f*40.0;j=b+4|0;k=c[c[j>>2]>>2]|0;l=c[k+8>>2]|0;m=+h[l+6024>>3]-(1.0-f*+h[e+1272>>3])*40.0;if(g!=0.0){n=l;o=m/g;p=n;q=p+1328|0;r=q;h[r>>3]=o;i=d;return}if(m==0.0){n=l;o=m;p=n;q=p+1328|0;r=q;h[r>>3]=o;i=d;return}f=m/+nwa(c[b+536>>2]|0,g,53776,53768,+h[k>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[j>>2]>>2]|0)+8>>2]|0;o=f;p=n;q=p+1328|0;r=q;h[r>>3]=o;i=d;return}function GM(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;wz(d,c[a+536>>2]|0,+h[f+4960>>3],+h[f+4800>>3],+h[f+4760>>3],+h[(c[a+416>>2]|0)+456>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4920>>3]=+h[d>>3];i=b;return}function HM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+zd(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+4920>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+Nxa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4560|0;w=v;h[w>>3]=n;i=b;return}x=c[63880]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=57624;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Oe[a&127](y,d,53800,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+Nxa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4560|0;w=v;h[w>>3]=n;i=b;return}function IM(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=Dza(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4960>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4560>>3];l=+U(+(+h[j+4920>>3]));m=+h[j+4880>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?1.5:3.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+376>>3];q=n*p;r=q!=0.0;s=+h[o+456>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+nwa(c[b+536>>2]|0,q,53904,53896,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+4880>>3];u=+h[j+4560>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+4680|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+nwa(c[b+536>>2]|0,q,53904,53896,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+456>>3];M=+h[j+376>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+nwa(c[b+536>>2]|0,q,53904,53896,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+4680|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+nwa(c[b+536>>2]|0,q,53904,53896,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4560>>3]*.125));L=P*(+W(+(+h[g+4880>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+nwa(c[b+536>>2]|0,L,53968,53896,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+4680|0;K=J;h[K>>3]=B;i=d;return}}function JM(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=Dza(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4960>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+4920>>3]));l=+h[j+4880>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?1.5:3.5)*+h[m+376>>3];o=+h[m+456>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+nwa(c[b+536>>2]|0,n,53904,54088,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+4600>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function KM(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+4600>>3]+-.7;h[b+4640>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function LM(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+408>>3]*+h[j+5536>>3]*+h[e+1656>>3];l=+h[j+5960>>3]+ +h[j+456>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+4952|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+4952|0;r=q;h[r>>3]=o;i=d;return}s=l/+nwa(c[b+536>>2]|0,k,54104,54096,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+4952|0;r=q;h[r>>3]=o;i=d;return}function MM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6088>>3]=+h[b+440>>3]*+h[b+6128>>3]+ +h[b+1096>>3]*+h[b+6208>>3];i=i;return}function NM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5904>>3]=+h[b+6088>>3]+ +h[b+5912>>3];i=i;return}function OM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+440>>3];p=f;h[k>>3]=+h[n+6320>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+448>>3];q=+h[p+432>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Nz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4872>>3]=+h[l>>3];i=b;return}function PM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+440>>3];p=f;h[k>>3]=+h[n+6320>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+448>>3];q=+h[p+432>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Qz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4712>>3]=+h[l>>3];i=b;return}function QM(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;xz(d,c[a+536>>2]|0,+h[f+4512>>3],+h[(c[a+416>>2]|0)+448>>3],+h[f+4712>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4832>>3]=+h[d>>3];i=b;return}function RM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+440>>3];p=f;h[k>>3]=+h[n+6320>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+448>>3];q=+h[p+432>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Oz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4752>>3]=+h[l>>3];i=b;return}function SM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+440>>3];p=f;h[k>>3]=+h[n+6320>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+448>>3];q=+h[p+432>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Vz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4792>>3]=+h[l>>3];i=b;return}function TM(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;wz(d,c[a+536>>2]|0,+h[f+4952>>3],+h[f+4792>>3],+h[f+4752>>3],+h[(c[a+416>>2]|0)+448>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4912>>3]=+h[d>>3];i=b;return}function UM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+zd(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+4912>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+Nxa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4552|0;w=v;h[w>>3]=n;i=b;return}x=c[63880]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=57624;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Oe[a&127](y,d,54168,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+Nxa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4552|0;w=v;h[w>>3]=n;i=b;return}function VM(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=Dza(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4952>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4552>>3];l=+U(+(+h[j+4912>>3]));m=+h[j+4872>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?.5:4.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+368>>3];q=n*p;r=q!=0.0;s=+h[o+448>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+nwa(c[b+536>>2]|0,q,54272,54264,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+4872>>3];u=+h[j+4552>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+4672|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+nwa(c[b+536>>2]|0,q,54272,54264,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+448>>3];M=+h[j+368>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+nwa(c[b+536>>2]|0,q,54272,54264,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+4672|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+nwa(c[b+536>>2]|0,q,54272,54264,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4552>>3]*.125));L=P*(+W(+(+h[g+4872>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+nwa(c[b+536>>2]|0,L,54336,54264,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+4672|0;K=J;h[K>>3]=B;i=d;return}}function WM(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=Dza(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4952>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+4912>>3]));l=+h[j+4872>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?.5:4.5)*+h[m+368>>3];o=+h[m+448>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+nwa(c[b+536>>2]|0,n,54272,54456,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+4592>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function XM(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+4592>>3]+-.7;h[b+4632>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function YM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+440>>3];p=f;h[k>>3]=+h[n+6320>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+448>>3];q=+h[p+432>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];fA(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4472>>3]=+h[l>>3];i=b;return}function ZM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+416>>3];v=l;h[k>>3]=+h[t+6312>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];gxa(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+424>>3];w=+h[t+408>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];vz(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Bz(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+440>>3];f=j;h[k>>3]=+h[q+6320>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];gxa(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+448>>3];y=+h[f+432>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];vz(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Bz(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+5616>>3]=(+h[d+408>>3]+ +h[d+416>>3])*(w- +h[r>>3])*+h[d+1760>>3]*.5;i=b;return}function _M(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+440>>3];p=f;h[k>>3]=+h[n+6320>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+448>>3];q=+h[p+432>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+5744>>3]=+h[l>>3];i=b;return}function $M(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+440>>3];p=f;h[k>>3]=+h[n+6320>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+448>>3];q=+h[p+432>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+5816>>3]=+h[l>>3];i=b;return}function aN(a){a=a|0;var b=0,d=0.0,e=0.0,f=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+4952>>3];e=+h[b+4960>>3];f=c[a+416>>2]|0;h[b+5648>>3]=+h[f+1760>>3]*(+h[b+5816>>3]*d*d*+h[f+408>>3]- +h[b+5824>>3]*e*e*+h[f+416>>3]);i=i;return}function bN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5584>>3]=+h[b+5648>>3]- +h[b+5616>>3]- +h[b+7960>>3];i=i;return}function cN(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=(+h[e+408>>3]+ +h[e+416>>3])*+h[e+1760>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+5584>>3];if(f!=0.0){l=j;m=k/f;n=m*2.0;o=l;p=o+5552|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*2.0;o=l;p=o+5552|0;q=p;h[q>>3]=n;i=d;return}r=k/+nwa(c[b+536>>2]|0,f,54472,54464,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*2.0;o=l;p=o+5552|0;q=p;h[q>>3]=n;i=d;return}function dN(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+5976>>3]=+h[b+4960>>3]*+h[d+416>>3]*+h[d+1656>>3]*(+h[b+400>>3]*.5+(+h[b+448>>3]*-.5+((+h[b+5552>>3]+ +h[b+5560>>3])*.5+ +h[d+1352>>3]*+h[b+5424>>3]*-5.0)));i=i;return}function eN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6016>>3]=+h[b+8496>>3]+(-+h[b+6056>>3]- +h[b+5976>>3]);i=i;return}function fN(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0,k=0,l=0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;e=c[b+416>>2]|0;f=+h[e+1256>>3];g=f*40.0;j=b+4|0;k=c[c[j>>2]>>2]|0;l=c[k+8>>2]|0;m=+h[l+6016>>3]-(1.0-f*+h[e+1248>>3])*40.0;if(g!=0.0){n=l;o=m/g;p=n;q=p+1336|0;r=q;h[r>>3]=o;i=d;return}if(m==0.0){n=l;o=m;p=n;q=p+1336|0;r=q;h[r>>3]=o;i=d;return}f=m/+nwa(c[b+536>>2]|0,g,54552,54544,+h[k>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[j>>2]>>2]|0)+8>>2]|0;o=f;p=n;q=p+1336|0;r=q;h[r>>3]=o;i=d;return}function gN(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+5968>>3]=+h[b+4952>>3]*+h[d+408>>3]*+h[d+1656>>3]*(+h[b+424>>3]*.5+(+h[b+448>>3]*-.5+(+h[b+5552>>3]*.5+ +h[d+1352>>3]*+h[b+5536>>3]*-5.0)));i=i;return}function hN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4440>>3]=1.0- +h[b+272>>3];i=i;return}function iN(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3448>>3];k=+zd(1.0e-13,+(+h[g+280>>3]-j));l=+h[g+4440>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+nwa(c[b+536>>2]|0,k,54584,54576,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+3464>>3]=+yd(+(j*n*.6219647130774989),1.0);i=d;return}function jN(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3480>>3]=+zd(+(+h[d+272>>3]- +h[d+3464>>3]),0.0);i=b;return}function kN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3472>>3]=+h[b+272>>3]- +h[b+3480>>3];i=i;return}function lN(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3480>>3];k=1.0-j;l=+h[g+4440>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+nwa(c[b+536>>2]|0,k,54656,54648,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+3480>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+3472>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+3512|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+3512|0;z=y;h[z>>3]=w;i=d;return}l=m/+nwa(c[b+536>>2]|0,p,54656,54648,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+3512|0;z=y;h[z>>3]=w;i=d;return}function mN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3520>>3]=+h[b+3536>>3]- +h[b+3512>>3]*+h[b+264>>3];i=i;return}function nN(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+264>>3]*+h[g+3512>>3];k=+h[g+280>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+3528|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+3528|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,54696,54688,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+3528|0;p=o;h[p>>3]=m;i=d;return}function oN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4304>>3]=+h[b+10264>>3]*+h[b+3528>>3];i=i;return}function pN(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3448>>3];k=+zd(1.0e-13,+(+h[g+280>>3]-j));l=+h[g+4440>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+nwa(c[b+536>>2]|0,k,54584,54736,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8176|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=Cza(1.0e-13,+h[f+280>>3]- +h[f+3448>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+3448>>3];j=+h[x+280>>3];k=+zd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+8928>>3];k=+h[x+4440>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+936>>3]- +h[x+8984>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+936>>3]- +h[x+8984>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+936>>3]- +h[x+8984>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+936>>3]- +h[x+8984>>3]}K=(y-k*J)/+nwa(c[b+536>>2]|0,l,54744,54736,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+4440>>3];C=+h[L+3448>>3];D=+h[L+280>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+8984>>3];m=+zd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+nwa(c[b+536>>2]|0,m,54584,54736,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8176|0;w=v;h[w>>3]=n;i=d;return}function qN(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(Cza(+h[a+272>>3]- +h[a+3464>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+8976|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+928>>3]- +h[a+8176>>3];g=a;j=g+8976|0;k=j;h[k>>3]=f;i=b;return}function rN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8168>>3]=+h[b+928>>3]- +h[b+8976>>3];i=i;return}function sN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+248>>3];v=l;h[k>>3]=+h[t+4432>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];gxa(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+256>>3];w=+h[t+240>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];vz(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Bz(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+272>>3];f=j;h[k>>3]=+h[q+4440>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];gxa(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+280>>3];y=+h[f+264>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];vz(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Bz(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+3648>>3]=(+h[d+704>>3]+ +h[d+712>>3])*(w- +h[r>>3])*+h[d+1992>>3]*.5;i=b;return}function tN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+272>>3];p=f;h[k>>3]=+h[n+4440>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+280>>3];q=+h[p+264>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+3840>>3]=+h[l>>3];i=b;return}function uN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+272>>3];p=f;h[k>>3]=+h[n+4440>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+280>>3];q=+h[p+264>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+3944>>3]=+h[l>>3];i=b;return}function vN(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3480>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+8976>>3];o=+h[g+8928>>3]*k+ +h[g+4440>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+nwa(c[b+536>>2]|0,l,54880,54872,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+8976>>3];q=+h[v+3480>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+8168>>3]*(1.0-q)+ +h[r+3472>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+8968|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+8968|0;C=B;h[C>>3]=z;i=d;return}p=t/+nwa(c[b+536>>2]|0,l,54880,54872,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+8968|0;C=B;h[C>>3]=z;i=d;return}function wN(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3512>>3];k=+h[g+264>>3];l=j*k;m=l*l;n=+h[g+936>>3]*l- +h[g+280>>3]*(j*+h[g+920>>3]+k*+h[g+8968>>3]);if(m!=0.0){o=g;p=n/m;q=o;r=q+9416|0;s=r;h[s>>3]=p;i=d;return}if(n==0.0){o=g;p=n;q=o;r=q+9416|0;s=r;h[s>>3]=p;i=d;return}k=n/+nwa(c[b+536>>2]|0,m,54928,54920,+h[f>>3],(a[b+319|0]|0)!=0|0);o=c[(c[c[e>>2]>>2]|0)+8>>2]|0;p=k;q=o;r=q+9416|0;s=r;h[s>>3]=p;i=d;return}function xN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4224>>3]=+h[b+10264>>3]*+h[b+9416>>3];i=i;return}function yN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4184>>3]=+h[b+272>>3]*+h[b+4224>>3]+ +h[b+928>>3]*+h[b+4304>>3];i=i;return}function zN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4056>>3]=+h[b+4184>>3]+ +h[b+4064>>3];i=i;return}function AN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+288>>3]=+h[b+4224>>3]+ +h[b+296>>3];i=i;return}function BN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+648>>3]=+h[b+5960>>3]+ +h[b+288>>3];i=i;return}function CN(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+288>>3];if(!(j>=0.0)){k=g;l=j*+h[g+3536>>3];m=k;n=m+4008|0;o=n;h[o>>3]=l;i=d;return}p=+zd(+(+h[g+648>>3]),1.0e-15);q=+zd(+-+h[g+5960>>3],1.0e-15);r=p+q;s=p*+h[g+6544>>3]+q*+h[g+5544>>3];do{if(r!=0.0){t=j;u=g;v=s/r}else{if(s==0.0){t=j;u=g;v=s;break}q=s/+nwa(c[b+536>>2]|0,r,54984,54976,+h[f>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[w+288>>3];u=w;v=q}}while(0);k=u;l=v*t;m=k;n=m+4008|0;o=n;h[o>>3]=l;i=d;return}function DN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4144>>3]=+h[b+4008>>3]- +h[b+4016>>3];i=i;return}function EN(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0.0;d=i;i=i+120|0;e=d;f=d+96|0;g=d+112|0;j=i;i=i+48|0;l=i;i=i+8|0;m=i;i=i+48|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+96|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=b+4|0;w=c[c[v>>2]>>2]|0;x=c[w+8>>2]|0;y=+zd(+(+h[x+648>>3]),1.0e-15);z=+zd(+-+h[x+5960>>3],1.0e-15);A=y+z;B=y*+h[x+496>>3]+z*+h[x+440>>3];do{if(A!=0.0){C=B/A}else{if(B==0.0){C=B;break}C=B/+nwa(c[b+536>>2]|0,A,54984,55056,+h[w>>3],(a[b+319|0]|0)!=0|0)}}while(0);gxa(o,1,C,n);n=m;h[k>>3]=575.573102;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=m+8|0;h[k>>3]=.931782653;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=m+16|0;h[k>>3]=.00722271286;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=m+24|0;h[k>>3]=-734255737.0e-14;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=m+32|0;h[k>>3]=4.95504349e-9;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=m+40|0;h[k>>3]=-1.336933246e-12;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];gxa(q,7,-39479.6083,m);m=l;h[k>>3]=17.24205775;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];gxa(r,2,-33039.7431,l);l=j;h[k>>3]=-2412.698562;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];l=j+8|0;h[k>>3]=4.64611078;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];l=j+16|0;h[k>>3]=.002291998307;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];l=j+24|0;h[k>>3]=-6.836830479999999e-7;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];l=j+32|0;h[k>>3]=9.426468930000001e-11;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];l=j+40|0;h[k>>3]=-4.82238053e-15;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];gxa(s,7,1034972.096,j);j=g;h[k>>3]=-7.97814851;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];gxa(t,2,-13842.86509,g);c[p>>2]=50528;h[p+8>>3]=.01801528;h[p+16>>3]=-13423382.81725291;h[p+24>>3]=549760.6476280135;h[p+32>>3]=1.0e3;g=p+40|0;j=q;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];j=p+52|0;g=r;c[j+0>>2]=c[g+0>>2];c[j+4>>2]=c[g+4>>2];c[j+8>>2]=c[g+8>>2];g=p+64|0;j=s;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];j=p+76|0;g=t;c[j+0>>2]=c[g+0>>2];c[j+4>>2]=c[g+4>>2];c[j+8>>2]=c[g+8>>2];h[p+88>>3]=461.5233290850878;g=c[b+536>>2]|0;j=c[c[v>>2]>>2]|0;t=c[j+8>>2]|0;C=+zd(+(+h[t+648>>3]),1.0e-15);A=+zd(+-+h[t+5960>>3],1.0e-15);B=C+A;z=C*+h[t+6544>>3]+A*+h[t+5544>>3];do{if(B!=0.0){D=t;E=z/B}else{if(z==0.0){D=t;E=z;break}A=z/+nwa(g,B,54984,55056,+h[j>>3],(a[b+319|0]|0)!=0|0);D=c[(c[c[v>>2]>>2]|0)+8>>2]|0;E=A}}while(0);B=+h[D+448>>3];D=f;b=o;c[D+0>>2]=c[b+0>>2];c[D+4>>2]=c[b+4>>2];c[D+8>>2]=c[b+8>>2];b=e+0|0;D=p+0|0;p=b+96|0;do{c[b>>2]=c[D>>2];b=b+4|0;D=D+4|0}while((b|0)<(p|0));nA(u,g,E,190.0,647.0,B,f,e,1.0e-13);h[(c[(c[c[v>>2]>>2]|0)+8>>2]|0)+4464>>3]=+h[u>>3];i=d;return}function FN(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+648>>3]),1.0e-15);k=+zd(+-+h[g+5960>>3],1.0e-15);l=j+k;m=-(k*+h[g+440>>3])-j*+h[g+496>>3];if(l!=0.0){n=g;o=m/l;p=o+1.0;q=n;r=q+4456|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=o+1.0;q=n;r=q+4456|0;s=r;h[s>>3]=p;i=d;return}j=m/+nwa(c[b+536>>2]|0,l,54984,55064,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=o+1.0;q=n;r=q+4456|0;s=r;h[s>>3]=p;i=d;return}function GN(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+648>>3]),1.0e-15);k=+zd(+-+h[g+5960>>3],1.0e-15);l=j+k;m=j*+h[g+496>>3]+k*+h[g+440>>3];if(l!=0.0){n=g;o=m/l;p=n;q=p+4448|0;r=q;h[r>>3]=o;i=d;return}if(m==0.0){n=g;o=m;p=n;q=p+4448|0;r=q;h[r>>3]=o;i=d;return}k=m/+nwa(c[b+536>>2]|0,l,54984,55072,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=k;p=n;q=p+4448|0;r=q;h[r>>3]=o;i=d;return}function HN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+4448>>3];p=f;h[k>>3]=+h[n+4456>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+448>>3];q=+h[p+4464>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+3832>>3]=+h[l>>3];i=b;return}



function Pe(a){a=a|0;var b=0;b=i;i=i+a|0;i=i+7&-8;return b|0}function Qe(){return i|0}function Re(a){a=a|0;i=a}function Se(a,b){a=a|0;b=b|0;if((u|0)==0){u=a;v=b}}function Te(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0]}function Ue(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0];a[k+4|0]=a[b+4|0];a[k+5|0]=a[b+5|0];a[k+6|0]=a[b+6|0];a[k+7|0]=a[b+7|0]}function Ve(a){a=a|0;J=a}function We(a){a=a|0;K=a}function Xe(a){a=a|0;L=a}function Ye(a){a=a|0;M=a}function Ze(a){a=a|0;N=a}function _e(a){a=a|0;O=a}function $e(a){a=a|0;P=a}function af(a){a=a|0;Q=a}function bf(a){a=a|0;R=a}function cf(a){a=a|0;S=a}function df(a){a=a|0;var b=0,d=0;b=i;IAa(a)|0;d=a+540|0;oe[c[(c[d>>2]|0)+40>>2]&127](a)|0;oe[c[(c[d>>2]|0)+28>>2]&127](a)|0;oe[c[(c[d>>2]|0)+32>>2]&127](a)|0;oe[c[(c[d>>2]|0)+48>>2]&127](a)|0;oe[c[(c[d>>2]|0)+52>>2]&127](a)|0;mza(a);i=b;return}function ef(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+24|0;s=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;c[v>>2]=0;y=b+240|0;z=d;h[z>>3]=+h[y>>3];if((c[2]|0)==0){A=0}else{B=c[b+88>>2]|0;C=x$a(B|0)|0;D=V_a(C+11|0)|0;I$a(D|0,B|0,C|0)|0;B=D+C+0|0;C=16|0;E=B+11|0;do{a[B]=a[C]|0;B=B+1|0;C=C+1|0}while((B|0)<(E|0));C=mc(D|0,32)|0;if((C|0)==0){B=ae(c[(Qc()|0)>>2]|0)|0;c[u>>2]=D;c[u+4>>2]=B;jwa(23,0,40,u);ad(0)|0;F=0}else{F=C}W_a(D);A=F}F=b+248|0;D=b+536|0;C=b;u=b+4|0;B=d+36|0;E=d+16|0;G=b+256|0;H=d+8|0;I=d+24|0;J=d+32|0;K=b+540|0;L=d+48|0;M=c[t>>2]|0;N=v;O=w;P=b+64|0;Q=b+72|0;R=x;S=0;T=A;while(1){if(!(+h[z>>3]<+h[F>>3])){U=T;V=0;break}Ie[c[207044>>2]&7]()|0;c[(c[D>>2]|0)+84>>2]=1;if((c[2]|0)!=0){if(((c[Q>>2]|0)+(c[P>>2]|0)|0)>0){A=0;do{Cxa(A+9|0);A=A+1|0;}while((A|0)<((c[Q>>2]|0)+(c[P>>2]|0)|0))}Cxa(2);Bxa(2)}qxa(c[C>>2]|0,1,c[u>>2]|0);if((c[B>>2]|0)==1){A=s;h[k>>3]=+h[z>>3]- +h[E>>3];c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];hwa(23,0,104,s);W=S}else{W=S+1|0}X=+h[y>>3];h[H>>3]=X+ +(W>>>0)*(+h[F>>3]-X)/+(c[G>>2]|0)- +h[z>>3];$ya(b,d);X=+h[z>>3];Y=+h[H>>3];A=r;h[k>>3]=X;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r+8|0;h[k>>3]=X+Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r+16|0;h[k>>3]=Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];hwa(23,1,144,r);Z=qAa(b,d)|0;if((c[I>>2]|0)==5){U=T;V=0;break}df(b);nza(b);if((c[206236>>2]|0)!=0){le[c[51674]&2047](23)}if((c[2]|0)!=0){Bxa(4)}A=bza(b,c[J>>2]|0,z,d)|0;if((A|0)>0){c[(c[D>>2]|0)+84>>2]=4;Y=+h[z>>3];c[q>>2]=(A|0)==1?224:232;A=q+4|0;h[k>>3]=Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];hwa(7,1,200,q);if((c[263300>>2]|0)==0){me[c[247924>>2]&127](247904,b)}dza(b,c[J>>2]|0,z,d);if((c[206172>>2]|0)!=0){le[c[51674]&2047](7)}c[(c[D>>2]|0)+84>>2]=1;c[B>>2]=1;rza(b)}else{h[E>>3]=+h[z>>3];c[B>>2]=0}if((c[2]|0)!=0){Exa(4)}if((CAa(b,1,1)|0)!=0){c[B>>2]=1;rza(b)}oe[c[(c[K>>2]|0)+88>>2]&127](b)|0;mza(b);vza(b);nza(b);do{if((T|0)==0){_=0}else{Bxa(7);Exa(2);A=(uc(N|0,4,1,T|0)|0)==1;c[v>>2]=(c[v>>2]|0)+1;do{if(A){$=(uc(c[c[u>>2]>>2]|0,8,1,T|0)|0)==1;h[w>>3]=+wxa(2);if(!$){aa=0;break}aa=(uc(O|0,8,1,T|0)|0)==1|0}else{h[w>>3]=+wxa(2);aa=0}}while(0);A=c[P>>2]|0;$=c[Q>>2]|0;if(($+A|0)>0){ba=aa;ca=0;while(1){c[x>>2]=rxa(ca+9|0)|0;if((ba|0)==0){da=0}else{da=(uc(R|0,4,1,T|0)|0)==1|0}ea=ca+1|0;fa=c[P>>2]|0;ga=c[Q>>2]|0;if((ea|0)<(ga+fa|0)){ba=da;ca=ea}else{ha=ga;ia=fa;ja=da;break}}}else{ha=$;ia=A;ja=aa}if((ha+ia|0)>0){ca=ja;ba=0;while(1){h[w>>3]=+wxa(ba+9|0);if((ca|0)==0){ka=0}else{ka=(uc(O|0,8,1,T|0)|0)==1|0}fa=ba+1|0;if((fa|0)<((c[Q>>2]|0)+(c[P>>2]|0)|0)){ca=ka;ba=fa}else{la=ka;break}}}else{la=ja}Exa(7);if((la|0)!=0){_=T;break}c[p>>2]=ae(c[(Qc()|0)>>2]|0)|0;jwa(23,0,240,p);ad(T|0)|0;_=0}}while(0);if((c[263300>>2]|0)==0){ma=47}else{ba=c[B>>2]|0;if((ba|0)==0){ma=47}else{na=ba}}if((ma|0)==47){ma=0;me[c[247924>>2]&127](247904,b);na=c[B>>2]|0}do{if((na|0)==1){if((c[I>>2]|0)!=3){break}ba=c[L>>2]|0;ca=c[ba+8>>2]|0;A=c[ba+4>>2]|0;c[A>>2]=(c[A>>2]|0)+(c[ca>>2]|0);ba=A+4|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+4>>2]|0);ba=A+8|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+8>>2]|0);ba=A+12|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+12>>2]|0);ba=A+16|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+16>>2]|0)}}while(0);if((c[63376]|0)!=0){ca=f;ba=253512;c[ca+0>>2]=c[ba+0>>2];c[ca+4>>2]=c[ba+4>>2];c[ca+8>>2]=c[ba+8>>2];c[ca+12>>2]=c[ba+12>>2];c[ca+16>>2]=c[ba+16>>2];c[ca+20>>2]=c[ba+20>>2];$va(M,f);Yd(10,M|0)|0;ba=c[63384]|0;ca=o;h[k>>3]=+h[c[c[u>>2]>>2]>>3];c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];c[o+8>>2]=ba;hwa(1,0,320,o);h[F>>3]=+h[z>>3]}if((Z|0)!=0){ma=57;break}if(($za(b,0)|0)!=0){ma=58;break}if((Rza(b,0)|0)!=0){ma=58;break}if((Gza(b,0)|0)==0){S=W;T=_}else{ma=58;break}}do{if((ma|0)==57){T=n;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];hwa(1,0,376,n);U=_;V=Z+ -1|0}else if((ma|0)==58){if(($za(b,0)|0)!=0){T=m;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];hwa(1,0,448,m);U=_;V=-2;break}if((Rza(b,0)|0)!=0){T=l;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];hwa(1,0,536,l);U=_;V=-3;break}T=(Gza(b,0)|0)==0;Y=+h[z>>3];if(T){T=g;h[k>>3]=Y;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];hwa(1,0,712,g);U=_;V=-1;break}else{T=j;h[k>>3]=Y;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];hwa(1,0,624,j);U=_;V=-3;break}}}while(0);if((U|0)==0){i=e;return V|0}ad(U|0)|0;i=e;return V|0}function ff(a){a=a|0;i=i;return 0}function gf(a){a=a|0;i=i;return 0}function hf(a){a=a|0;i=i;return 0}function jf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6896>>3]=+h[b+600>>3]*1.0e-5;i=i;return}function kf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6888>>3]=+h[b+584>>3]+-273.15;i=i;return}function lf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6784>>3]=+h[b+576>>3]*1.0e-5;i=i;return}function mf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6776>>3]=+h[b+560>>3]+-273.15;i=i;return}function nf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6672>>3]=+h[b+552>>3]*1.0e-5;i=i;return}function of(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6664>>3]=+h[b+536>>3]+-273.15;i=i;return}function pf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6560>>3]=+h[b+528>>3]*1.0e-5;i=i;return}function qf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6552>>3]=+h[b+512>>3]+-273.15;i=i;return}function rf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6448>>3]=+h[b+504>>3]*1.0e-5;i=i;return}function sf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6440>>3]=+h[b+488>>3]+-273.15;i=i;return}function tf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5448>>3]=+h[b+448>>3]*1.0e-5;i=i;return}function uf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5440>>3]=+h[b+432>>3]+-273.15;i=i;return}function vf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5336>>3]=+h[b+424>>3]*1.0e-5;i=i;return}function wf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5328>>3]=+h[b+408>>3]+-273.15;i=i;return}function xf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5224>>3]=+h[b+400>>3]*1.0e-5;i=i;return}function yf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5216>>3]=+h[b+384>>3]+-273.15;i=i;return}function zf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5112>>3]=+h[b+376>>3]*1.0e-5;i=i;return}function Af(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5104>>3]=+h[b+360>>3]+-273.15;i=i;return}function Bf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5e3>>3]=+h[b+352>>3]*1.0e-5;i=i;return}function Cf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4992>>3]=+h[b+336>>3]+-273.15;i=i;return}function Df(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3440>>3]=+h[b+280>>3]*1.0e-5;i=i;return}function Ef(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3432>>3]=+h[b+264>>3]+-273.15;i=i;return}function Ff(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3328>>3]=+h[b+256>>3]*1.0e-5;i=i;return}function Gf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3320>>3]=+h[b+240>>3]+-273.15;i=i;return}function Hf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3216>>3]=+h[b+232>>3]*1.0e-5;i=i;return}function If(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3208>>3]=+h[b+216>>3]+-273.15;i=i;return}function Jf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3104>>3]=+h[b+208>>3]*1.0e-5;i=i;return}function Kf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3096>>3]=+h[b+192>>3]+-273.15;i=i;return}function Lf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2992>>3]=+h[b+184>>3]*1.0e-5;i=i;return}function Mf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2984>>3]=+h[b+168>>3]+-273.15;i=i;return}function Nf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1888>>3]=+h[b+112>>3]*1.0e-5;i=i;return}function Of(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1880>>3]=+h[b+96>>3]+-273.15;i=i;return}function Pf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1776>>3]=+h[b+88>>3]*1.0e-5;i=i;return}function Qf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1768>>3]=+h[b+72>>3]+-273.15;i=i;return}function Rf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1664>>3]=+h[b+64>>3]*1.0e-5;i=i;return}function Sf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1656>>3]=+h[b+48>>3]+-273.15;i=i;return}function Tf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1552>>3]=+h[b+40>>3]*1.0e-5;i=i;return}function Uf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1544>>3]=+h[b+24>>3]+-273.15;i=i;return}function Vf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1440>>3]=+h[b+16>>3]*1.0e-5;i=i;return}function Wf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1432>>3]=+h[b>>3]+-273.15;i=i;return}function Xf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+592>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+6960|0;q=p;h[q>>3]=n;i=d;return}j=+nwa(c[b+536>>2]|0,k,880,872,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+6960|0;q=p;h[q>>3]=n;i=d;return}function Yf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+568>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+6848|0;q=p;h[q>>3]=n;i=d;return}j=+nwa(c[b+536>>2]|0,k,984,976,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+6848|0;q=p;h[q>>3]=n;i=d;return}function Zf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+544>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+6736|0;q=p;h[q>>3]=n;i=d;return}j=+nwa(c[b+536>>2]|0,k,1088,1080,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+6736|0;q=p;h[q>>3]=n;i=d;return}function _f(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+520>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+6624|0;q=p;h[q>>3]=n;i=d;return}j=+nwa(c[b+536>>2]|0,k,1192,1184,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+6624|0;q=p;h[q>>3]=n;i=d;return}function $f(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+496>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+6512|0;q=p;h[q>>3]=n;i=d;return}j=+nwa(c[b+536>>2]|0,k,1296,1288,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+6512|0;q=p;h[q>>3]=n;i=d;return}function ag(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7568>>3]=+h[b+608>>3]- +h[b+616>>3];i=i;return}function bg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9968>>3];k=+h[g+7568>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9256|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9256|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,1400,1392,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9256|0;p=o;h[p>>3]=m;i=d;return}function cg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7576>>3]=+h[b+616>>3]- +h[b+624>>3];i=i;return}function dg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9976>>3];k=+h[g+7576>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9272|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9272|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,1432,1424,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9272|0;p=o;h[p>>3]=m;i=d;return}function eg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7584>>3]=+h[b+624>>3]- +h[b+632>>3];i=i;return}function fg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9984>>3];k=+h[g+7584>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9288|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9288|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,1464,1456,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9288|0;p=o;h[p>>3]=m;i=d;return}function gg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7592>>3]=+h[b+632>>3]- +h[b+640>>3];i=i;return}function hg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9992>>3];k=+h[g+7592>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9304|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9304|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,1496,1488,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9304|0;p=o;h[p>>3]=m;i=d;return}function ig(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7600>>3]=+h[b+640>>3]- +h[b+648>>3];i=i;return}function jg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1e4>>3];k=+h[g+7600>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9320|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9320|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,1528,1520,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9320|0;p=o;h[p>>3]=m;i=d;return}function kg(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+616>>3];h[b+7408>>3]=d*+h[(!(d>=0.0)?b+568|0:b+592|0)>>3];i=i;return}function lg(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+624>>3];h[b+7416>>3]=d*+h[(!(d>=0.0)?b+544|0:b+568|0)>>3];i=i;return}function mg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7536>>3]=+h[b+7408>>3]- +h[b+7416>>3];i=i;return}function ng(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+632>>3];h[b+7424>>3]=d*+h[(!(d>=0.0)?b+520|0:b+544|0)>>3];i=i;return}function og(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7544>>3]=+h[b+7416>>3]- +h[b+7424>>3];i=i;return}function pg(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+640>>3];h[b+7432>>3]=d*+h[(!(d>=0.0)?b+496|0:b+520|0)>>3];i=i;return}function qg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7552>>3]=+h[b+7424>>3]- +h[b+7432>>3];i=i;return}function rg(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+608>>3];if(!(d>=0.0)){e=+h[b+592>>3]}else{e=.01}h[b+7400>>3]=d*e;i=i;return}function sg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7528>>3]=+h[b+7400>>3]- +h[b+7408>>3];i=i;return}function tg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0,t=0.0,u=0,v=0,w=0,x=0.0;d=i;i=i+120|0;e=d;f=d+32|0;g=d+48|0;j=d+80|0;k=d+112|0;l=b+536|0;m=c[l>>2]|0;n=b+4|0;o=+h[(c[(c[c[n>>2]>>2]|0)+8>>2]|0)+9800>>3];p=f;q=1560;c[p+0>>2]=c[q+0>>2];c[p+4>>2]=c[q+4>>2];c[p+8>>2]=c[q+8>>2];mA(j,m,15.0e4,o,f);f=g;m=j;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];c[f+12>>2]=c[m+12>>2];c[f+16>>2]=c[m+16>>2];c[f+20>>2]=c[m+20>>2];c[f+24>>2]=c[m+24>>2];c[f+28>>2]=c[m+28>>2];m=c[l>>2]|0;f=e;j=g;c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];c[f+16>>2]=c[j+16>>2];c[f+20>>2]=c[j+20>>2];c[f+24>>2]=c[j+24>>2];c[f+28>>2]=c[j+28>>2];qA(k,m,e);e=c[b+416>>2]|0;o=+h[k>>3]*+h[e+1432>>3]*+h[e+112>>3];e=c[c[n>>2]>>2]|0;k=c[e+8>>2]|0;r=+h[k+608>>3];if(o!=0.0){s=k;t=r/o;u=s;v=u+7344|0;w=v;h[w>>3]=t;i=d;return}if(r==0.0){s=k;t=r;u=s;v=u+7344|0;w=v;h[w>>3]=t;i=d;return}x=r/+nwa(c[l>>2]|0,o,1576,1552,+h[e>>3],(a[b+319|0]|0)!=0|0);s=c[(c[c[n>>2]>>2]|0)+8>>2]|0;t=x;u=s;v=u+7344|0;w=v;h[w>>3]=t;i=d;return}function ug(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+440>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+5512|0;q=p;h[q>>3]=n;i=d;return}j=+nwa(c[b+536>>2]|0,k,1800,1792,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+5512|0;q=p;h[q>>3]=n;i=d;return}function vg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+416>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+5400|0;q=p;h[q>>3]=n;i=d;return}j=+nwa(c[b+536>>2]|0,k,1904,1896,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+5400|0;q=p;h[q>>3]=n;i=d;return}function wg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+392>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+5288|0;q=p;h[q>>3]=n;i=d;return}j=+nwa(c[b+536>>2]|0,k,2008,2e3,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+5288|0;q=p;h[q>>3]=n;i=d;return}function xg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+368>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+5176|0;q=p;h[q>>3]=n;i=d;return}j=+nwa(c[b+536>>2]|0,k,2112,2104,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+5176|0;q=p;h[q>>3]=n;i=d;return}function yg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+344>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+5064|0;q=p;h[q>>3]=n;i=d;return}j=+nwa(c[b+536>>2]|0,k,2216,2208,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+5064|0;q=p;h[q>>3]=n;i=d;return}function zg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6136>>3]=+h[b+456>>3]- +h[b+464>>3];i=i;return}function Ag(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10128>>3];k=+h[g+6136>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9352|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9352|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,2320,2312,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9352|0;p=o;h[p>>3]=m;i=d;return}function Bg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6144>>3]=+h[b+464>>3]- +h[b+472>>3];i=i;return}function Cg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10136>>3];k=+h[g+6144>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9368|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9368|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,2352,2344,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9368|0;p=o;h[p>>3]=m;i=d;return}function Dg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6152>>3]=+h[b+472>>3]- +h[b+480>>3];i=i;return}function Eg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10144>>3];k=+h[g+6152>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9384|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9384|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,2384,2376,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9384|0;p=o;h[p>>3]=m;i=d;return}function Fg(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+456>>3];h[b+5912>>3]=d*+h[(!(d>=0.0)?b+416|0:b+440|0)>>3];i=i;return}function Gg(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+464>>3];h[b+5920>>3]=d*+h[(!(d>=0.0)?b+392|0:b+416|0)>>3];i=i;return}function Hg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6096>>3]=+h[b+5912>>3]- +h[b+5920>>3];i=i;return}function Ig(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+472>>3];h[b+5928>>3]=d*+h[(!(d>=0.0)?b+368|0:b+392|0)>>3];i=i;return}function Jg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6104>>3]=+h[b+5920>>3]- +h[b+5928>>3];i=i;return}function Kg(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+480>>3];h[b+5936>>3]=d*+h[(!(d>=0.0)?b+344|0:b+368|0)>>3];i=i;return}function Lg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6112>>3]=+h[b+5928>>3]- +h[b+5936>>3];i=i;return}function Mg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+648>>3]),1.0e-15);k=+zd(+-+h[g+288>>3],1.0e-15);l=j+k;m=j*+h[g+496>>3]+k*+h[g+272>>3];if(l!=0.0){n=g;o=m/l;p=n;q=p+6344|0;r=q;h[r>>3]=o;i=d;return}if(m==0.0){n=g;o=m;p=n;q=p+6344|0;r=q;h[r>>3]=o;i=d;return}k=m/+nwa(c[b+536>>2]|0,l,2416,2408,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=k;p=n;q=p+6344|0;r=q;h[r>>3]=o;i=d;return}function Ng(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+648>>3]),1.0e-15);k=+zd(+-+h[g+288>>3],1.0e-15);l=j+k;m=-(k*+h[g+272>>3])-j*+h[g+496>>3];if(l!=0.0){n=g;o=m/l;p=o+1.0;q=n;r=q+6352|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=o+1.0;q=n;r=q+6352|0;s=r;h[s>>3]=p;i=d;return}j=m/+nwa(c[b+536>>2]|0,l,2416,2504,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=o+1.0;q=n;r=q+6352|0;s=r;h[s>>3]=p;i=d;return}function Og(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+328>>3]),1.0e-15);k=+zd(+-+h[g+120>>3],1.0e-15);l=j+k;m=j*+h[g+176>>3]+k*+h[g+104>>3];if(l!=0.0){n=g;o=m/l;p=n;q=p+6328|0;r=q;h[r>>3]=o;i=d;return}if(m==0.0){n=g;o=m;p=n;q=p+6328|0;r=q;h[r>>3]=o;i=d;return}k=m/+nwa(c[b+536>>2]|0,l,2520,2512,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=k;p=n;q=p+6328|0;r=q;h[r>>3]=o;i=d;return}function Pg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+328>>3]),1.0e-15);k=+zd(+-+h[g+120>>3],1.0e-15);l=j+k;m=-(k*+h[g+104>>3])-j*+h[g+176>>3];if(l!=0.0){n=g;o=m/l;p=o+1.0;q=n;r=q+6336|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=o+1.0;q=n;r=q+6336|0;s=r;h[s>>3]=p;i=d;return}j=m/+nwa(c[b+536>>2]|0,l,2520,2608,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=o+1.0;q=n;r=q+6336|0;s=r;h[s>>3]=p;i=d;return}function Qg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+272>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+3504|0;q=p;h[q>>3]=n;i=d;return}j=+nwa(c[b+536>>2]|0,k,2624,2616,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+3504|0;q=p;h[q>>3]=n;i=d;return}function Rg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+248>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+3392|0;q=p;h[q>>3]=n;i=d;return}j=+nwa(c[b+536>>2]|0,k,2728,2720,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+3392|0;q=p;h[q>>3]=n;i=d;return}function Sg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+224>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+3280|0;q=p;h[q>>3]=n;i=d;return}j=+nwa(c[b+536>>2]|0,k,2832,2824,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+3280|0;q=p;h[q>>3]=n;i=d;return}function Tg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+200>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+3168|0;q=p;h[q>>3]=n;i=d;return}j=+nwa(c[b+536>>2]|0,k,2936,2928,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+3168|0;q=p;h[q>>3]=n;i=d;return}function Ug(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+176>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+3056|0;q=p;h[q>>3]=n;i=d;return}j=+nwa(c[b+536>>2]|0,k,3040,3032,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+3056|0;q=p;h[q>>3]=n;i=d;return}function Vg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4224>>3]=+h[b+288>>3]- +h[b+296>>3];i=i;return}function Wg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10264>>3];k=+h[g+4224>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9416|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9416|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,3144,3136,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9416|0;p=o;h[p>>3]=m;i=d;return}function Xg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4232>>3]=+h[b+296>>3]- +h[b+304>>3];i=i;return}function Yg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10272>>3];k=+h[g+4232>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9432|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9432|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,3176,3168,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9432|0;p=o;h[p>>3]=m;i=d;return}function Zg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4240>>3]=+h[b+304>>3]- +h[b+312>>3];i=i;return}function _g(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10280>>3];k=+h[g+4240>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9448|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9448|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,3208,3200,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9448|0;p=o;h[p>>3]=m;i=d;return}function $g(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4248>>3]=+h[b+312>>3]- +h[b+320>>3];i=i;return}function ah(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10288>>3];k=+h[g+4248>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9464|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9464|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,3240,3232,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9464|0;p=o;h[p>>3]=m;i=d;return}function bh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4256>>3]=+h[b+320>>3]- +h[b+328>>3];i=i;return}function ch(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10296>>3];k=+h[g+4256>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9480|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9480|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,3272,3264,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9480|0;p=o;h[p>>3]=m;i=d;return}function dh(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+296>>3];h[b+4064>>3]=d*+h[(!(d>=0.0)?b+248|0:b+272|0)>>3];i=i;return}function eh(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+304>>3];h[b+4072>>3]=d*+h[(!(d>=0.0)?b+224|0:b+248|0)>>3];i=i;return}function fh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4192>>3]=+h[b+4064>>3]- +h[b+4072>>3];i=i;return}function gh(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+312>>3];h[b+4080>>3]=d*+h[(!(d>=0.0)?b+200|0:b+224|0)>>3];i=i;return}function hh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4200>>3]=+h[b+4072>>3]- +h[b+4080>>3];i=i;return}function ih(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+320>>3];h[b+4088>>3]=d*+h[(!(d>=0.0)?b+176|0:b+200|0)>>3];i=i;return}function jh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4208>>3]=+h[b+4080>>3]- +h[b+4088>>3];i=i;return}function kh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+104>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+1952|0;q=p;h[q>>3]=n;i=d;return}j=+nwa(c[b+536>>2]|0,k,3304,3296,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+1952|0;q=p;h[q>>3]=n;i=d;return}function lh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+80>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+1840|0;q=p;h[q>>3]=n;i=d;return}j=+nwa(c[b+536>>2]|0,k,3408,3400,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+1840|0;q=p;h[q>>3]=n;i=d;return}function mh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+56>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+1728|0;q=p;h[q>>3]=n;i=d;return}j=+nwa(c[b+536>>2]|0,k,3512,3504,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+1728|0;q=p;h[q>>3]=n;i=d;return}function nh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+32>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+1616|0;q=p;h[q>>3]=n;i=d;return}j=+nwa(c[b+536>>2]|0,k,3616,3608,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+1616|0;q=p;h[q>>3]=n;i=d;return}function oh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+1504|0;q=p;h[q>>3]=n;i=d;return}j=+nwa(c[b+536>>2]|0,k,3720,3712,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+1504|0;q=p;h[q>>3]=n;i=d;return}function ph(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2672>>3]=+h[b+120>>3]- +h[b+128>>3];i=i;return}function qh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10400>>3];k=+h[g+2672>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9496|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9496|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,3824,3816,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9496|0;p=o;h[p>>3]=m;i=d;return}function rh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2680>>3]=+h[b+128>>3]- +h[b+136>>3];i=i;return}function sh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10408>>3];k=+h[g+2680>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9512|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9512|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,3856,3848,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9512|0;p=o;h[p>>3]=m;i=d;return}function th(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2688>>3]=+h[b+136>>3]- +h[b+144>>3];i=i;return}function uh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10416>>3];k=+h[g+2688>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9528|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9528|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,3888,3880,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9528|0;p=o;h[p>>3]=m;i=d;return}function vh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2696>>3]=+h[b+144>>3]- +h[b+152>>3];i=i;return}function wh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10424>>3];k=+h[g+2696>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9544|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9544|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,3920,3912,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9544|0;p=o;h[p>>3]=m;i=d;return}function xh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2704>>3]=+h[b+152>>3]- +h[b+160>>3];i=i;return}function yh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10432>>3];k=+h[g+2704>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9560|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9560|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,3952,3944,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9560|0;p=o;h[p>>3]=m;i=d;return}function zh(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+128>>3];h[b+2512>>3]=d*+h[(!(d>=0.0)?b+80|0:b+104|0)>>3];i=i;return}function Ah(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+136>>3];h[b+2520>>3]=d*+h[(!(d>=0.0)?b+56|0:b+80|0)>>3];i=i;return}function Bh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2640>>3]=+h[b+2512>>3]- +h[b+2520>>3];i=i;return}function Ch(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+144>>3];h[b+2528>>3]=d*+h[(!(d>=0.0)?b+32|0:b+56|0)>>3];i=i;return}function Dh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2648>>3]=+h[b+2520>>3]- +h[b+2528>>3];i=i;return}function Eh(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+152>>3];h[b+2536>>3]=d*+h[(!(d>=0.0)?b+8|0:b+32|0)>>3];i=i;return}function Fh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2656>>3]=+h[b+2528>>3]- +h[b+2536>>3];i=i;return}function Gh(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+160>>3];if(!(d>=0.0)){e=.01}else{e=+h[b+8>>3]}h[b+2544>>3]=d*e;i=i;return}function Hh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2664>>3]=+h[b+2536>>3]- +h[b+2544>>3];i=i;return}function Ih(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[c[b+356>>2]|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[c[b+356>>2]|0]|0;k=zza(+h[c[c[b+4>>2]>>2]>>3],+h[(c[b+416>>2]|0)+2376>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=k;f=j;break}else{j=zza(+h[c[c[b+4>>2]>>2]>>3],+h[(c[b+416>>2]|0)+2376>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=j;f=j;break}}else{if(g){g=a[c[b+356>>2]|0]|0;j=Aza(+h[c[c[b+4>>2]>>2]>>3],+h[(c[b+416>>2]|0)+2376>>3])|0;a[c[b+352>>2]|0]=j;f=g;break}else{g=Aza(+h[c[c[b+4>>2]>>2]>>3],+h[(c[b+416>>2]|0)+2376>>3])|0;a[c[b+352>>2]|0]=g;f=g;break}}}}while(0);if(!(f<<24>>24==0)){l=b+416|0;m=0.0;n=c[l>>2]|0;o=n;p=o+2368|0;q=p;r=+h[q>>3];s=m+r;t=b;u=t+4|0;v=u;w=c[v>>2]|0;x=c[w>>2]|0;y=x;z=y+8|0;A=z;B=c[A>>2]|0;C=B;D=C+10672|0;E=D;h[E>>3]=s;i=d;return}do{if((a[e]|0)==0){F=a[(c[b+356>>2]|0)+1|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){g=a[(c[b+356>>2]|0)+1|0]|0;j=c[b+416>>2]|0;k=zza(+h[c[c[b+4>>2]>>2]>>3],+h[j+2376>>3]+ +h[j+2360>>3],a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=k;F=g;break}else{g=c[b+416>>2]|0;k=zza(+h[c[c[b+4>>2]>>2]>>3],+h[g+2376>>3]+ +h[g+2360>>3],a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=k;F=k;break}}else{if(f){f=a[(c[b+356>>2]|0)+1|0]|0;k=c[b+416>>2]|0;g=Aza(+h[c[c[b+4>>2]>>2]>>3],+h[k+2376>>3]+ +h[k+2360>>3])|0;a[(c[b+352>>2]|0)+1|0]=g;F=f;break}else{f=c[b+416>>2]|0;g=Aza(+h[c[c[b+4>>2]>>2]>>3],+h[f+2376>>3]+ +h[f+2360>>3])|0;a[(c[b+352>>2]|0)+1|0]=g;F=g;break}}}}while(0);if(F<<24>>24==0){F=b+416|0;l=F;m=+h[(c[F>>2]|0)+2352>>3];n=c[l>>2]|0;o=n;p=o+2368|0;q=p;r=+h[q>>3];s=m+r;t=b;u=t+4|0;v=u;w=c[v>>2]|0;x=c[w>>2]|0;y=x;z=y+8|0;A=z;B=c[A>>2]|0;C=B;D=C+10672|0;E=D;h[E>>3]=s;i=d;return}G=+h[c[c[b+4>>2]>>2]>>3];F=b+416|0;e=c[F>>2]|0;H=G- +h[e+2376>>3];I=+h[e+2360>>3];J=+h[e+2352>>3];do{if(I!=0.0){K=J/I}else{if(J==0.0){K=J;break}K=J/+nwa(c[b+536>>2]|0,I,3984,3976,G,(a[b+319|0]|0)!=0|0)}}while(0);l=F;m=H*K;n=c[l>>2]|0;o=n;p=o+2368|0;q=p;r=+h[q>>3];s=m+r;t=b;u=t+4|0;v=u;w=c[v>>2]|0;x=c[w>>2]|0;y=x;z=y+8|0;A=z;B=c[A>>2]|0;C=B;D=C+10672|0;E=D;h[E>>3]=s;i=d;return}function Jh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,k=0;b=i;i=i+24|0;d=b;e=b+16|0;f=c[a+536>>2]|0;g=a+4|0;j=+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10672>>3];a=d;k=4e3;c[a+0>>2]=c[k+0>>2];c[a+4>>2]=c[k+4>>2];c[a+8>>2]=c[k+8>>2];GA(e,f,j,293.15,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10760>>3]=+h[e>>3];i=b;return}function Kh(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;AA(d,c[a+536>>2]|0,293.15);e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+10688>>3]=+yd(+(+h[d>>3]),+(+h[e+10672>>3]*.999));i=b;return}function Lh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10688>>3];k=+zd(1.0e-13,+(+h[g+10672>>3]-j));if(k!=0.0){l=k;m=g;n=.99/l;o=j*n;p=o*.6219647130774989;q=+yd(+p,1.0);r=m;s=r+10704|0;t=s;h[t>>3]=q;i=d;return}u=+nwa(c[b+536>>2]|0,k,4024,4016,+h[f>>3],(a[b+319|0]|0)!=0|0);l=u;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=.99/l;o=j*n;p=o*.6219647130774989;q=+yd(+p,1.0);r=m;s=r+10704|0;t=s;h[t>>3]=q;i=d;return}function Mh(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+10720>>3]=+zd(+(.01- +h[d+10704>>3]),0.0);i=b;return}function Nh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10712>>3]=.01- +h[b+10720>>3];i=i;return}function Oh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0,u=0,v=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10720>>3];k=1.0-j;if(k!=0.0){l=k;m=j;n=g;o=f}else{j=+nwa(c[b+536>>2]|0,k,4096,4088,+h[f>>3],(a[b+319|0]|0)!=0|0);f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;l=j;m=+h[g+10720>>3];n=g;o=f}j=284.1807127034489/l;l=1.0-m;m=+h[n+10712>>3];if(l!=0.0){p=n;q=m/l;r=q*461.5233290850878;s=j+r;t=p;u=t+10736|0;v=u;h[v>>3]=s;i=d;return}if(m==0.0){p=n;q=m;r=q*461.5233290850878;s=j+r;t=p;u=t+10736|0;v=u;h[v>>3]=s;i=d;return}k=m/+nwa(c[b+536>>2]|0,l,4096,4088,+h[o>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=k;r=q*461.5233290850878;s=j+r;t=p;u=t+10736|0;v=u;h[v>>3]=s;i=d;return}function Ph(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10744>>3]=+h[b+10760>>3]+ +h[b+10736>>3]*-293.15;i=i;return}function Qh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10736>>3]*293.15;k=+h[g+10672>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+10752|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+10752|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,4136,4128,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+10752|0;p=o;h[p>>3]=m;i=d;return}function Rh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10688>>3];k=+zd(1.0e-13,+(+h[g+10672>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+nwa(c[b+536>>2]|0,k,4024,4168,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+10696>>3]=m*.6219647130774989;i=d;return}function Sh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10688>>3];k=+h[g+10672>>3];do{if(j!=0.0){l=g;m=k/j}else{if(k==0.0){l=g;m=k;break}n=k/+nwa(c[b+536>>2]|0,j,4184,4176,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+10728>>3]=m*.01598094902253916;i=d;return}function Th(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0;b=i;i=i+216|0;d=b;e=b+96|0;f=b+112|0;g=b+208|0;c[f>>2]=4216;h[f+8>>3]=.01801528;h[f+16>>3]=-13423382.81725291;h[f+24>>3]=549760.6476280135;h[f+32>>3]=1.0e3;j=f+40|0;k=4224;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=f+52|0;j=4240;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];j=f+64|0;k=4256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=f+76|0;j=4272;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];h[f+88>>3]=461.5233290850878;j=c[a+536>>2]|0;k=a+4|0;a=c[(c[c[k>>2]>>2]|0)+8>>2]|0;l=+h[a+10760>>3];m=+h[a+10672>>3];a=e;n=4e3;c[a+0>>2]=c[n+0>>2];c[a+4>>2]=c[n+4>>2];c[a+8>>2]=c[n+8>>2];n=d+0|0;a=f+0|0;f=n+96|0;do{c[n>>2]=c[a>>2];n=n+4|0;a=a+4|0}while((n|0)<(f|0));nA(g,j,l,190.0,647.0,m,e,d,1.0e-13);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+2832>>3]=+h[g>>3];i=b;return}function Uh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0;d=i;i=i+120|0;e=d;f=d+32|0;g=d+48|0;j=d+80|0;k=d+112|0;l=b+536|0;m=c[l>>2]|0;n=b+4|0;o=c[(c[c[n>>2]>>2]|0)+8>>2]|0;p=+h[o+10672>>3];q=+h[o+2832>>3];o=f;r=1560;c[o+0>>2]=c[r+0>>2];c[o+4>>2]=c[r+4>>2];c[o+8>>2]=c[r+8>>2];mA(j,m,p,q,f);f=g;m=j;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];c[f+12>>2]=c[m+12>>2];c[f+16>>2]=c[m+16>>2];c[f+20>>2]=c[m+20>>2];c[f+24>>2]=c[m+24>>2];c[f+28>>2]=c[m+28>>2];m=c[l>>2]|0;f=e;j=g;c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];c[f+16>>2]=c[j+16>>2];c[f+20>>2]=c[j+20>>2];c[f+24>>2]=c[j+24>>2];c[f+28>>2]=c[j+28>>2];qA(k,m,e);e=c[b+416>>2]|0;q=+h[k>>3]*+h[e+2112>>3]*+h[e+1032>>3];e=c[c[n>>2]>>2]|0;k=c[e+8>>2]|0;p=+h[k+160>>3];if(q!=0.0){s=k;t=p/q;u=s;v=u+2440|0;w=v;h[w>>3]=t;i=d;return}if(p==0.0){s=k;t=p;u=s;v=u+2440|0;w=v;h[w>>3]=t;i=d;return}x=p/+nwa(c[l>>2]|0,q,4296,4288,+h[e>>3],(a[b+319|0]|0)!=0|0);s=c[(c[c[n>>2]>>2]|0)+8>>2]|0;t=x;u=s;v=u+2440|0;w=v;h[w>>3]=t;i=d;return}function Vh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0;b=i;i=i+88|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=a+536|0;k=c[j>>2]|0;l=a+4|0;a=c[(c[c[l>>2]>>2]|0)+8>>2]|0;m=+h[a+10672>>3];n=+h[a+2832>>3];a=e;o=1560;c[a+0>>2]=c[o+0>>2];c[a+4>>2]=c[o+4>>2];c[a+8>>2]=c[o+8>>2];vz(f,k,m,n,e);e=c[j>>2]|0;j=d;k=f;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];c[j+24>>2]=c[k+24>>2];c[j+28>>2]=c[k+28>>2];Cz(g,e,d);h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+2328>>3]=+h[g>>3];i=b;return}function Wh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0;b=i;i=i+88|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=a+536|0;k=c[j>>2]|0;l=a+4|0;a=c[(c[c[l>>2]>>2]|0)+8>>2]|0;m=+h[a+10672>>3];n=+h[a+2832>>3];a=e;o=1560;c[a+0>>2]=c[o+0>>2];c[a+4>>2]=c[o+4>>2];c[a+8>>2]=c[o+8>>2];vz(f,k,m,n,e);e=c[j>>2]|0;j=d;k=f;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];c[j+24>>2]=c[k+24>>2];c[j+28>>2]=c[k+28>>2];Fz(g,e,d);h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+2432>>3]=+h[g>>3];i=b;return}function Xh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10680>>3]=+h[b+10672>>3]*1.0e-5;i=i;return}function Yh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5960>>3]=+h[b+648>>3]- +h[b+288>>3];i=i;return}function Zh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+648>>3]),1.0e-15);k=+zd(+-+h[g+5960>>3],1.0e-15);l=j+k;m=-(k*+h[g+440>>3])-j*+h[g+496>>3];if(l!=0.0){n=g;o=m/l;p=o+1.0;q=n;r=q+4456|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=o+1.0;q=n;r=q+4456|0;s=r;h[s>>3]=p;i=d;return}j=m/+nwa(c[b+536>>2]|0,l,4520,4512,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=o+1.0;q=n;r=q+4456|0;s=r;h[s>>3]=p;i=d;return}function _h(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+648>>3]),1.0e-15);k=+zd(+-+h[g+5960>>3],1.0e-15);l=j+k;m=j*+h[g+496>>3]+k*+h[g+440>>3];if(l!=0.0){n=g;o=m/l;p=n;q=p+4448|0;r=q;h[r>>3]=o;i=d;return}if(m==0.0){n=g;o=m;p=n;q=p+4448|0;r=q;h[r>>3]=o;i=d;return}k=m/+nwa(c[b+536>>2]|0,l,4520,4592,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=k;p=n;q=p+4448|0;r=q;h[r>>3]=o;i=d;return}function $h(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+288>>3];if(!(j>=0.0)){k=g;l=j*+h[g+272>>3];m=k;n=m+4056|0;o=n;h[o>>3]=l;i=d;return}p=+zd(+(+h[g+648>>3]),1.0e-15);q=+zd(+-+h[g+5960>>3],1.0e-15);r=p+q;s=p*+h[g+496>>3]+q*+h[g+440>>3];do{if(r!=0.0){t=j;u=g;v=s/r}else{if(s==0.0){t=j;u=g;v=s;break}q=s/+nwa(c[b+536>>2]|0,r,4520,4600,+h[f>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[w+288>>3];u=w;v=q}}while(0);k=u;l=v*t;m=k;n=m+4056|0;o=n;h[o>>3]=l;i=d;return}function ai(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4184>>3]=+h[b+4056>>3]- +h[b+4064>>3];i=i;return}function bi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5960>>3];if(!(j>=0.0)){k=g;l=j*+h[g+440>>3];m=k;n=m+5904|0;o=n;h[o>>3]=l;i=d;return}p=+zd(+(+h[g+648>>3]),1.0e-15);q=+zd(+-+h[g+288>>3],1.0e-15);r=p+q;s=p*+h[g+496>>3]+q*+h[g+272>>3];do{if(r!=0.0){t=j;u=g;v=s/r}else{if(s==0.0){t=j;u=g;v=s;break}q=s/+nwa(c[b+536>>2]|0,r,2416,4608,+h[f>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[w+5960>>3];u=w;v=q}}while(0);k=u;l=v*t;m=k;n=m+5904|0;o=n;h[o>>3]=l;i=d;return}function ci(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6088>>3]=+h[b+5904>>3]- +h[b+5912>>3];i=i;return}function di(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6128>>3]=+h[b+5960>>3]- +h[b+456>>3];i=i;return}function ei(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10120>>3];k=+h[g+6128>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9336|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9336|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,4624,4616,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9336|0;p=o;h[p>>3]=m;i=d;return}function fi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+-+h[g+5960>>3],1.0e-15);k=+zd(+-+h[g+288>>3],1.0e-15);l=j+k;m=-(k*+h[g+272>>3])-j*+h[g+440>>3];if(l!=0.0){n=g;o=m/l;p=o+1.0;q=n;r=q+7736|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=o+1.0;q=n;r=q+7736|0;s=r;h[s>>3]=p;i=d;return}j=m/+nwa(c[b+536>>2]|0,l,4656,4648,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=o+1.0;q=n;r=q+7736|0;s=r;h[s>>3]=p;i=d;return}function gi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+-+h[g+5960>>3],1.0e-15);k=+zd(+-+h[g+288>>3],1.0e-15);l=j+k;m=j*+h[g+440>>3]+k*+h[g+272>>3];if(l!=0.0){n=g;o=m/l;p=n;q=p+7728|0;r=q;h[r>>3]=o;i=d;return}if(m==0.0){n=g;o=m;p=n;q=p+7728|0;r=q;h[r>>3]=o;i=d;return}k=m/+nwa(c[b+536>>2]|0,l,4656,4728,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=k;p=n;q=p+7728|0;r=q;h[r>>3]=o;i=d;return}function hi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+648>>3];if(j>=0.0){k=g;l=j*+h[g+496>>3];m=k;n=m+7440|0;o=n;h[o>>3]=l;i=d;return}p=+zd(+-+h[g+5960>>3],1.0e-15);q=+zd(+-+h[g+288>>3],1.0e-15);r=p+q;s=p*+h[g+440>>3]+q*+h[g+272>>3];do{if(r!=0.0){t=j;u=g;v=s/r}else{if(s==0.0){t=j;u=g;v=s;break}q=s/+nwa(c[b+536>>2]|0,r,4656,4736,+h[f>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[w+648>>3];u=w;v=q}}while(0);k=u;l=v*t;m=k;n=m+7440|0;o=n;h[o>>3]=l;i=d;return}function ii(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7560>>3]=+h[b+7432>>3]- +h[b+7440>>3];i=i;return}function ji(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5952>>3]=+h[b+120>>3]- +h[b+328>>3];i=i;return}function ki(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+5952>>3]),1.0e-15);k=+zd(+(+h[g+328>>3]),1.0e-15);l=j+k;m=-(k*+h[g+176>>3])-j*+h[g+344>>3];if(l!=0.0){n=g;o=m/l;p=o+1.0;q=n;r=q+2888|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=o+1.0;q=n;r=q+2888|0;s=r;h[s>>3]=p;i=d;return}j=m/+nwa(c[b+536>>2]|0,l,4752,4744,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=o+1.0;q=n;r=q+2888|0;s=r;h[s>>3]=p;i=d;return}function li(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+5952>>3]),1.0e-15);k=+zd(+(+h[g+328>>3]),1.0e-15);l=j+k;m=j*+h[g+344>>3]+k*+h[g+176>>3];if(l!=0.0){n=g;o=m/l;p=n;q=p+2880|0;r=q;h[r>>3]=o;i=d;return}if(m==0.0){n=g;o=m;p=n;q=p+2880|0;r=q;h[r>>3]=o;i=d;return}k=m/+nwa(c[b+536>>2]|0,l,4752,4824,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=k;p=n;q=p+2880|0;r=q;h[r>>3]=o;i=d;return}function mi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+120>>3];if(!(j>=0.0)){k=g;l=j*+h[g+104>>3];m=k;n=m+2504|0;o=n;h[o>>3]=l;i=d;return}p=+zd(+(+h[g+5952>>3]),1.0e-15);q=+zd(+(+h[g+328>>3]),1.0e-15);r=p+q;s=p*+h[g+344>>3]+q*+h[g+176>>3];do{if(r!=0.0){t=j;u=g;v=s/r}else{if(s==0.0){t=j;u=g;v=s;break}q=s/+nwa(c[b+536>>2]|0,r,4752,4832,+h[f>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[w+120>>3];u=w;v=q}}while(0);k=u;l=v*t;m=k;n=m+2504|0;o=n;h[o>>3]=l;i=d;return}function ni(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2632>>3]=+h[b+2504>>3]- +h[b+2512>>3];i=i;return}function oi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+5952>>3]),1.0e-15);k=+zd(+-+h[g+120>>3],1.0e-15);l=j+k;m=-(k*+h[g+104>>3])-j*+h[g+344>>3];if(l!=0.0){n=g;o=m/l;p=o+1.0;q=n;r=q+4392|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=o+1.0;q=n;r=q+4392|0;s=r;h[s>>3]=p;i=d;return}j=m/+nwa(c[b+536>>2]|0,l,4848,4840,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=o+1.0;q=n;r=q+4392|0;s=r;h[s>>3]=p;i=d;return}function pi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+5952>>3]),1.0e-15);k=+zd(+-+h[g+120>>3],1.0e-15);l=j+k;m=j*+h[g+344>>3]+k*+h[g+104>>3];if(l!=0.0){n=g;o=m/l;p=n;q=p+4384|0;r=q;h[r>>3]=o;i=d;return}if(m==0.0){n=g;o=m;p=n;q=p+4384|0;r=q;h[r>>3]=o;i=d;return}k=m/+nwa(c[b+536>>2]|0,l,4848,4920,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=k;p=n;q=p+4384|0;r=q;h[r>>3]=o;i=d;return}function qi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+328>>3];if(j>=0.0){k=g;l=j*+h[g+176>>3];m=k;n=m+4096|0;o=n;h[o>>3]=l;i=d;return}p=+zd(+(+h[g+5952>>3]),1.0e-15);q=+zd(+-+h[g+120>>3],1.0e-15);r=p+q;s=p*+h[g+344>>3]+q*+h[g+104>>3];do{if(r!=0.0){t=j;u=g;v=s/r}else{if(s==0.0){t=j;u=g;v=s;break}q=s/+nwa(c[b+536>>2]|0,r,4848,4928,+h[f>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[w+328>>3];u=w;v=q}}while(0);k=u;l=v*t;m=k;n=m+4096|0;o=n;h[o>>3]=l;i=d;return}function ri(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4216>>3]=+h[b+4088>>3]- +h[b+4096>>3];i=i;return}function si(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5952>>3];if(j>=0.0){k=g;l=j*+h[g+344>>3];m=k;n=m+5944|0;o=n;h[o>>3]=l;i=d;return}p=+zd(+(+h[g+328>>3]),1.0e-15);q=+zd(+-+h[g+120>>3],1.0e-15);r=p+q;s=p*+h[g+176>>3]+q*+h[g+104>>3];do{if(r!=0.0){t=j;u=g;v=s/r}else{if(s==0.0){t=j;u=g;v=s;break}q=s/+nwa(c[b+536>>2]|0,r,2520,4936,+h[f>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[w+5952>>3];u=w;v=q}}while(0);k=u;l=v*t;m=k;n=m+5944|0;o=n;h[o>>3]=l;i=d;return}function ti(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6120>>3]=+h[b+5936>>3]- +h[b+5944>>3];i=i;return}function ui(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6160>>3]=+h[b+480>>3]- +h[b+5952>>3];i=i;return}function vi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10152>>3];k=+h[g+6160>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9400|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9400|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,4952,4944,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9400|0;p=o;h[p>>3]=m;i=d;return}function wi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;gxa(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+16>>3];l=+h[a>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];tA(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1536>>3]=+h[f>>3];i=b;return}function xi(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+160>>3];h[b+2496>>3]=d*+h[(!(d>=0.0)?b+10760|0:b+1536|0)>>3];i=i;return}function yi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2840>>3]=1.0- +h[b+8>>3];i=i;return}function zi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+8>>3];p=f;h[k>>3]=+h[n+2840>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+16>>3];q=+h[p>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];fA(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+1384>>3]=+h[l>>3];i=b;return}function Ai(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+2840>>3]),1.0e-13);k=+h[g+8>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1496|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1496|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,4984,4976,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1496|0;p=o;h[p>>3]=m;i=d;return}function Bi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+32|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+8|0;p=i;i=i+8|0;q=a+536|0;r=c[q>>2]|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+10672>>3];v=+h[t+2832>>3];t=g;w=1560;c[t+0>>2]=c[w+0>>2];c[t+4>>2]=c[w+4>>2];c[t+8>>2]=c[w+8>>2];vz(l,r,u,v,g);g=c[q>>2]|0;r=f;w=l;c[r+0>>2]=c[w+0>>2];c[r+4>>2]=c[w+4>>2];c[r+8>>2]=c[w+8>>2];c[r+12>>2]=c[w+12>>2];c[r+16>>2]=c[w+16>>2];c[r+20>>2]=c[w+20>>2];c[r+24>>2]=c[w+24>>2];c[r+28>>2]=c[w+28>>2];Bz(o,g,f);v=+h[o>>3];o=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[o+8>>3];f=j;h[k>>3]=+h[o+2840>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];gxa(m,2,u,j);j=c[q>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+16>>3];x=+h[f>>3];f=e;o=m;c[f+0>>2]=c[o+0>>2];c[f+4>>2]=c[o+4>>2];c[f+8>>2]=c[o+8>>2];vz(n,j,u,x,e);e=c[q>>2]|0;q=d;j=n;c[q+0>>2]=c[j+0>>2];c[q+4>>2]=c[j+4>>2];c[q+8>>2]=c[j+8>>2];c[q+12>>2]=c[j+12>>2];c[q+16>>2]=c[j+16>>2];c[q+20>>2]=c[j+20>>2];c[q+24>>2]=c[j+24>>2];c[q+28>>2]=c[j+28>>2];Bz(p,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+2128>>3]=+h[d+1032>>3]*(v- +h[p>>3])*+h[d+2216>>3];i=b;return}function Ci(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+8>>3];p=f;h[k>>3]=+h[n+2840>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+16>>3];q=+h[p>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2320>>3]=+h[l>>3];i=b;return}function Di(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+160>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2272>>3]=+h[(a?e+2328|0:e+2320|0)>>3];i=b;return}function Ei(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+8>>3];p=f;h[k>>3]=+h[n+2840>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+16>>3];q=+h[p>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2424>>3]=+h[l>>3];i=b;return}function Fi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+124>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+2032>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+2032|0;h[c[g+128>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+2032>>3]);h[c[(c[f>>2]|0)+132>>2]>>3]=k;_za(a,1)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+2032>>3]=+h[c[(c[f>>2]|0)+124>>2]>>3];i=b;return}function Gi(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+2080>>3]=+h[b+2032>>3]*+h[d+2216>>3]*+h[d+1032>>3];i=i;return}function Hi(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+160>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2376>>3]=+h[(a?e+2432|0:e+2424|0)>>3];i=b;return}function Ii(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;iA(d,c[a+536>>2]|0,+h[c[(c[c[e>>2]>>2]|0)+8>>2]>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+1448>>3]=+yd(+(+h[d>>3]),+(+h[a+16>>3]*.999));i=b;return}function Ji(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1448>>3];k=+zd(1.0e-13,+(+h[g+16>>3]-j));l=+h[g+2840>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+nwa(c[b+536>>2]|0,k,5032,5024,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+1464>>3]=+yd(+(j*n*.6219647130774989),1.0);i=d;return}function Ki(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1480>>3]=+zd(+(+h[d+8>>3]- +h[d+1464>>3]),0.0);i=b;return}function Li(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1472>>3]=+h[b+8>>3]- +h[b+1480>>3];i=i;return}function Mi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1480>>3];k=1.0-j;l=+h[g+2840>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+nwa(c[b+536>>2]|0,k,5104,5096,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+1480>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+1472>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+1512|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+1512|0;z=y;h[z>>3]=w;i=d;return}l=m/+nwa(c[b+536>>2]|0,p,5104,5096,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+1512|0;z=y;h[z>>3]=w;i=d;return}function Ni(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1520>>3]=+h[b+1536>>3]- +h[b+1512>>3]*+h[b>>3];i=i;return}function Oi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g>>3]*+h[g+1512>>3];k=+h[g+16>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1528|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1528|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,5144,5136,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1528|0;p=o;h[p>>3]=m;i=d;return}function Pi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2784>>3]=+h[b+10432>>3]*+h[b+1528>>3];i=i;return}function Qi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2744>>3]=+h[b+8>>3]*+h[b+2784>>3];i=i;return}function Ri(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2824>>3]=+h[b+2784>>3]*+h[b+1520>>3];i=i;return}function Si(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2784>>3];k=+h[g+2664>>3]- +h[g+8>>3]*+h[g+2704>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+664|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+664|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,5192,5184,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+664|0;p=o;h[p>>3]=m;i=d;return}function Ti(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9120>>3]=-+h[b+664>>3];i=i;return}function Ui(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1032>>3]*+h[j+1528>>3]*+h[e+2112>>3];l=+h[j+152>>3]+ +h[j+160>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1424|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1424|0;r=q;h[r>>3]=o;i=d;return}s=l/+nwa(c[b+536>>2]|0,k,5216,5208,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1424|0;r=q;h[r>>3]=o;i=d;return}function Vi(a){a=a|0;var b=0,d=0.0,e=0.0,f=0,g=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1424>>3];e=+h[b+2440>>3];f=c[a+416>>2]|0;g=+h[f+1032>>3];h[b+2176>>3]=+h[f+2216>>3]*(+h[b+2424>>3]*d*d*g- +h[b+2432>>3]*e*e*g);i=i;return}function Wi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8320>>3]=+h[b+2176>>3]+(-+h[b+2128>>3]- +h[b+2080>>3]);i=i;return}function Xi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10480>>3];k=+h[g+8320>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+816|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+816|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,5288,5280,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+816|0;p=o;h[p>>3]=m;i=d;return}function Yi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+16>>3];k=+h[g+8>>3];l=+h[g+1448>>3]*(k+ +h[g+2840>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+1488|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+1488|0;r=q;h[r>>3]=o;i=d;return}s=k/+nwa(c[b+536>>2]|0,l,5320,5312,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+1488|0;r=q;h[r>>3]=o;i=d;return}function Zi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1448>>3];k=+zd(1.0e-13,+(+h[g+16>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+nwa(c[b+536>>2]|0,k,5032,5424,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+1456>>3]=m*.6219647130774989;i=d;return}function _i(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;gxa(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+32>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+40>>3];l=+h[a+24>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];tA(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1648>>3]=+h[f>>3];i=b;return}function $i(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+152>>3];h[b+2488>>3]=d*+h[(!(d>=0.0)?b+1536|0:b+1648|0)>>3];i=i;return}function aj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2624>>3]=+h[b+2488>>3]- +h[b+2496>>3];i=i;return}function bj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2848>>3]=1.0- +h[b+32>>3];i=i;return}function cj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+32>>3];p=f;h[k>>3]=+h[n+2848>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+40>>3];q=+h[p+24>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];fA(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+1376>>3]=+h[l>>3];i=b;return}function dj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+2848>>3]),1.0e-13);k=+h[g+32>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1608|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1608|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,5440,5432,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1608|0;p=o;h[p>>3]=m;i=d;return}function ej(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+8>>3];v=l;h[k>>3]=+h[t+2840>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];gxa(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+16>>3];w=+h[t>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];vz(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Bz(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+32>>3];f=j;h[k>>3]=+h[q+2848>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];gxa(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+40>>3];y=+h[f+24>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];vz(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Bz(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+2120>>3]=(+h[d+1024>>3]+ +h[d+1032>>3])*(w- +h[r>>3])*+h[d+2216>>3]*.5;i=b;return}function fj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+32>>3];p=f;h[k>>3]=+h[n+2848>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+40>>3];q=+h[p+24>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2312>>3]=+h[l>>3];i=b;return}function gj(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+152>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2264>>3]=+h[(a?e+2320|0:e+2312|0)>>3];i=b;return}function hj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+32>>3];p=f;h[k>>3]=+h[n+2848>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+40>>3];q=+h[p+24>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2416>>3]=+h[l>>3];i=b;return}function ij(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+204>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+2024>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+2024|0;h[c[g+208>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+2024>>3]);h[c[(c[f>>2]|0)+212>>2]>>3]=k;_za(a,2)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+2024>>3]=+h[c[(c[f>>2]|0)+204>>2]>>3];i=b;return}function jj(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+2072>>3]=+h[b+2024>>3]*(+h[d+1024>>3]+ +h[d+1032>>3])*+h[d+2216>>3]*.5;i=i;return}function kj(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+2584>>3]=+h[b+1424>>3]*+h[d+1032>>3]*+h[d+2112>>3]*((+h[b+10672>>3]- +h[b+40>>3])/1.5+(+h[b+2024>>3]*.5+(+h[b+2032>>3]+ +h[d+1352>>3]*+h[b+1528>>3]*-10.0)));i=i;return}function lj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8600>>3]=+h[b+2624>>3]+ +h[b+2584>>3];i=i;return}function mj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2784>>3];k=+h[g+8600>>3]- +h[g+2704>>3]*+h[g+1520>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+8424|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+8424|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,5192,5480,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+8424|0;p=o;h[p>>3]=m;i=d;return}function nj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+284>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+672>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+672|0;h[c[g+288>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+672>>3]);e=c[f>>2]|0;h[c[e+292>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+284>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+656>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+656|0;h[(c[e+288>>2]|0)+8>>3]=+h[g>>3];k=+aAa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+656>>3]);h[(c[(c[f>>2]|0)+292>>2]|0)+8>>3]=k;_za(a,3)|0;j=c[(c[f>>2]|0)+284>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+672>>3]=+h[j>>3];h[f+656>>3]=+h[j+8>>3];hP(a);iP(a);jP(a);kP(a);lP(a);mP(a);i=b;return}function oj(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+152>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2368>>3]=+h[(a?e+2424|0:e+2416|0)>>3];i=b;return}function pj(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;iA(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+24>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+1560>>3]=+yd(+(+h[d>>3]),+(+h[a+40>>3]*.999));i=b;return}function qj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1560>>3];k=+zd(1.0e-13,+(+h[g+40>>3]-j));l=+h[g+2848>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+nwa(c[b+536>>2]|0,k,5496,5488,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+1576>>3]=+yd(+(j*n*.6219647130774989),1.0);i=d;return}function rj(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1592>>3]=+zd(+(+h[d+32>>3]- +h[d+1576>>3]),0.0);i=b;return}function sj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1584>>3]=+h[b+32>>3]- +h[b+1592>>3];i=i;return}function tj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1592>>3];k=1.0-j;l=+h[g+2848>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+nwa(c[b+536>>2]|0,k,5568,5560,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+1592>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+1584>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+1624|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+1624|0;z=y;h[z>>3]=w;i=d;return}l=m/+nwa(c[b+536>>2]|0,p,5568,5560,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+1624|0;z=y;h[z>>3]=w;i=d;return}function uj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1632>>3]=+h[b+1648>>3]- +h[b+1624>>3]*+h[b+24>>3];i=i;return}function vj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+24>>3]*+h[g+1624>>3];k=+h[g+40>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1640|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1640|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,5608,5600,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1640|0;p=o;h[p>>3]=m;i=d;return}function wj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2776>>3]=+h[b+10424>>3]*+h[b+1640>>3];i=i;return}function xj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2736>>3]=+h[b+32>>3]*+h[b+2776>>3];i=i;return}function yj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2816>>3]=+h[b+2776>>3]*+h[b+1632>>3];i=i;return}function zj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2776>>3];k=+h[g+2656>>3]- +h[g+32>>3]*+h[g+2696>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+688|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+688|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,5656,5648,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+688|0;p=o;h[p>>3]=m;i=d;return}function Aj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9112>>3]=-+h[b+688>>3];i=i;return}function Bj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1024>>3]*+h[j+1640>>3]*+h[e+2112>>3];l=+h[j+144>>3]+ +h[j+152>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1416|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1416|0;r=q;h[r>>3]=o;i=d;return}s=l/+nwa(c[b+536>>2]|0,k,5680,5672,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1416|0;r=q;h[r>>3]=o;i=d;return}function Cj(a){a=a|0;var b=0,d=0.0,e=0.0,f=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1416>>3];e=+h[b+1424>>3];f=c[a+416>>2]|0;h[b+2168>>3]=+h[f+2216>>3]*(+h[b+2416>>3]*d*d*+h[f+1024>>3]- +h[b+2424>>3]*e*e*+h[f+1032>>3]);i=i;return}function Dj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8312>>3]=+h[b+2168>>3]+(-+h[b+2120>>3]- +h[b+2072>>3]);i=i;return}function Ej(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10472>>3];k=+h[g+8312>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+808|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+808|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,5752,5744,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+808|0;p=o;h[p>>3]=m;i=d;return}function Fj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+40>>3];k=+h[g+32>>3];l=+h[g+1560>>3]*(k+ +h[g+2848>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+1600|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+1600|0;r=q;h[r>>3]=o;i=d;return}s=k/+nwa(c[b+536>>2]|0,l,5784,5776,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+1600|0;r=q;h[r>>3]=o;i=d;return}function Gj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1560>>3];k=+zd(1.0e-13,+(+h[g+40>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+nwa(c[b+536>>2]|0,k,5496,5888,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+1568>>3]=m*.6219647130774989;i=d;return}function Hj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;gxa(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+56>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+64>>3];l=+h[a+48>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];tA(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1760>>3]=+h[f>>3];i=b;return}function Ij(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+144>>3];h[b+2480>>3]=d*+h[(!(d>=0.0)?b+1648|0:b+1760|0)>>3];i=i;return}function Jj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2616>>3]=+h[b+2480>>3]- +h[b+2488>>3];i=i;return}function Kj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2856>>3]=1.0- +h[b+56>>3];i=i;return}function Lj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+56>>3];p=f;h[k>>3]=+h[n+2856>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+64>>3];q=+h[p+48>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];fA(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+1368>>3]=+h[l>>3];i=b;return}function Mj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+2856>>3]),1.0e-13);k=+h[g+56>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1720|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1720|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,5904,5896,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1720|0;p=o;h[p>>3]=m;i=d;return}function Nj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+32>>3];v=l;h[k>>3]=+h[t+2848>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];gxa(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+40>>3];w=+h[t+24>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];vz(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Bz(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+56>>3];f=j;h[k>>3]=+h[q+2856>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];gxa(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+64>>3];y=+h[f+48>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];vz(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Bz(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+2112>>3]=(+h[d+1016>>3]+ +h[d+1024>>3])*(w- +h[r>>3])*+h[d+2216>>3]*.5;i=b;return}function Oj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+56>>3];p=f;h[k>>3]=+h[n+2856>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+64>>3];q=+h[p+48>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2304>>3]=+h[l>>3];i=b;return}function Pj(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+144>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2256>>3]=+h[(a?e+2312|0:e+2304|0)>>3];i=b;return}function Qj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+56>>3];p=f;h[k>>3]=+h[n+2856>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+64>>3];q=+h[p+48>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2408>>3]=+h[l>>3];i=b;return}function Rj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+364>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+2016>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+2016|0;h[c[g+368>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+2016>>3]);h[c[(c[f>>2]|0)+372>>2]>>3]=k;_za(a,4)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+2016>>3]=+h[c[(c[f>>2]|0)+364>>2]>>3];i=b;return}function Sj(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+2064>>3]=+h[b+2016>>3]*(+h[d+1016>>3]+ +h[d+1024>>3])*+h[d+2216>>3]*.5;i=i;return}function Tj(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+2576>>3]=+h[b+1416>>3]*+h[d+1024>>3]*+h[d+2112>>3]*(+h[b+16>>3]*.5+(+h[b+64>>3]*-.5+((+h[b+2016>>3]+ +h[b+2024>>3])*.5+ +h[d+1352>>3]*+h[b+1640>>3]*-10.0)));i=i;return}function Uj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8592>>3]=+h[b+2616>>3]+ +h[b+2576>>3];i=i;return}function Vj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2776>>3];k=+h[g+8592>>3]- +h[g+2696>>3]*+h[g+1632>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+8400|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+8400|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,5656,5944,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+8400|0;p=o;h[p>>3]=m;i=d;return}function Wj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+444>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+696>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+696|0;h[c[g+448>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+696>>3]);e=c[f>>2]|0;h[c[e+452>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+444>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+680>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+680|0;h[(c[e+448>>2]|0)+8>>3]=+h[g>>3];k=+aAa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+680>>3]);h[(c[(c[f>>2]|0)+452>>2]|0)+8>>3]=k;_za(a,5)|0;j=c[(c[f>>2]|0)+444>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+696>>3]=+h[j>>3];h[f+680>>3]=+h[j+8>>3];rP(a);sP(a);tP(a);uP(a);vP(a);wP(a);i=b;return}function Xj(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+144>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2360>>3]=+h[(a?e+2416|0:e+2408|0)>>3];i=b;return}function Yj(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;iA(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+48>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+1672>>3]=+yd(+(+h[d>>3]),+(+h[a+64>>3]*.999));i=b;return}function Zj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1672>>3];k=+zd(1.0e-13,+(+h[g+64>>3]-j));l=+h[g+2856>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+nwa(c[b+536>>2]|0,k,5960,5952,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+1688>>3]=+yd(+(j*n*.6219647130774989),1.0);i=d;return}function _j(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1704>>3]=+zd(+(+h[d+56>>3]- +h[d+1688>>3]),0.0);i=b;return}function $j(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1696>>3]=+h[b+56>>3]- +h[b+1704>>3];i=i;return}function ak(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1704>>3];k=1.0-j;l=+h[g+2856>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+nwa(c[b+536>>2]|0,k,6032,6024,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+1704>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+1696>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+1736|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+1736|0;z=y;h[z>>3]=w;i=d;return}l=m/+nwa(c[b+536>>2]|0,p,6032,6024,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+1736|0;z=y;h[z>>3]=w;i=d;return}function bk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1744>>3]=+h[b+1760>>3]- +h[b+1736>>3]*+h[b+48>>3];i=i;return}function ck(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+48>>3]*+h[g+1736>>3];k=+h[g+64>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1752|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1752|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,6072,6064,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1752|0;p=o;h[p>>3]=m;i=d;return}function dk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2768>>3]=+h[b+10416>>3]*+h[b+1752>>3];i=i;return}function ek(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2728>>3]=+h[b+56>>3]*+h[b+2768>>3];i=i;return}function fk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2808>>3]=+h[b+2768>>3]*+h[b+1744>>3];i=i;return}function gk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2768>>3];k=+h[g+2648>>3]- +h[g+56>>3]*+h[g+2688>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+712|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+712|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,6120,6112,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+712|0;p=o;h[p>>3]=m;i=d;return}function hk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9104>>3]=-+h[b+712>>3];i=i;return}function ik(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1016>>3]*+h[j+1752>>3]*+h[e+2112>>3];l=+h[j+136>>3]+ +h[j+144>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1408|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1408|0;r=q;h[r>>3]=o;i=d;return}s=l/+nwa(c[b+536>>2]|0,k,6144,6136,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1408|0;r=q;h[r>>3]=o;i=d;return}function jk(a){a=a|0;var b=0,d=0.0,e=0.0,f=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1408>>3];e=+h[b+1416>>3];f=c[a+416>>2]|0;h[b+2160>>3]=+h[f+2216>>3]*(+h[b+2408>>3]*d*d*+h[f+1016>>3]- +h[b+2416>>3]*e*e*+h[f+1024>>3]);i=i;return}function kk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8304>>3]=+h[b+2160>>3]+(-+h[b+2112>>3]- +h[b+2064>>3]);i=i;return}function lk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10464>>3];k=+h[g+8304>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+800|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+800|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,6216,6208,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+800|0;p=o;h[p>>3]=m;i=d;return}function mk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+64>>3];k=+h[g+56>>3];l=+h[g+1672>>3]*(k+ +h[g+2856>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+1712|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+1712|0;r=q;h[r>>3]=o;i=d;return}s=k/+nwa(c[b+536>>2]|0,l,6248,6240,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+1712|0;r=q;h[r>>3]=o;i=d;return}function nk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1672>>3];k=+zd(1.0e-13,+(+h[g+64>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+nwa(c[b+536>>2]|0,k,5960,6352,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+1680>>3]=m*.6219647130774989;i=d;return}function ok(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;gxa(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+80>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+88>>3];l=+h[a+72>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];tA(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1872>>3]=+h[f>>3];i=b;return}function pk(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+136>>3];h[b+2472>>3]=d*+h[(!(d>=0.0)?b+1760|0:b+1872|0)>>3];i=i;return}function qk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2608>>3]=+h[b+2472>>3]- +h[b+2480>>3];i=i;return}function rk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2864>>3]=1.0- +h[b+80>>3];i=i;return}function sk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+80>>3];p=f;h[k>>3]=+h[n+2864>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+88>>3];q=+h[p+72>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];fA(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+1360>>3]=+h[l>>3];i=b;return}function tk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+2864>>3]),1.0e-13);k=+h[g+80>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1832|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1832|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,6368,6360,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1832|0;p=o;h[p>>3]=m;i=d;return}function uk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+56>>3];v=l;h[k>>3]=+h[t+2856>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];gxa(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+64>>3];w=+h[t+48>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];vz(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Bz(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+80>>3];f=j;h[k>>3]=+h[q+2864>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];gxa(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+88>>3];y=+h[f+72>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];vz(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Bz(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+2104>>3]=(+h[d+1008>>3]+ +h[d+1016>>3])*(w- +h[r>>3])*+h[d+2216>>3]*.5;i=b;return}function vk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+80>>3];p=f;h[k>>3]=+h[n+2864>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+88>>3];q=+h[p+72>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2296>>3]=+h[l>>3];i=b;return}function wk(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+136>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2248>>3]=+h[(a?e+2304|0:e+2296|0)>>3];i=b;return}function xk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+80>>3];p=f;h[k>>3]=+h[n+2864>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+88>>3];q=+h[p+72>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2400>>3]=+h[l>>3];i=b;return}function yk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+524>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+2008>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+2008|0;h[c[g+528>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+2008>>3]);h[c[(c[f>>2]|0)+532>>2]>>3]=k;_za(a,6)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+2008>>3]=+h[c[(c[f>>2]|0)+524>>2]>>3];i=b;return}function zk(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+2056>>3]=+h[b+2008>>3]*(+h[d+1008>>3]+ +h[d+1016>>3])*+h[d+2216>>3]*.5;i=i;return}function Ak(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+2568>>3]=+h[b+1408>>3]*+h[d+1016>>3]*+h[d+2112>>3]*(+h[b+40>>3]*.5+(+h[b+88>>3]*-.5+((+h[b+2008>>3]+ +h[b+2016>>3])*.5+ +h[d+1352>>3]*+h[b+1752>>3]*-10.0)));i=i;return}function Bk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8584>>3]=+h[b+2608>>3]+ +h[b+2568>>3];i=i;return}function Ck(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2768>>3];k=+h[g+8584>>3]- +h[g+2688>>3]*+h[g+1744>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+8376|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+8376|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,6120,6408,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+8376|0;p=o;h[p>>3]=m;i=d;return}function Dk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+604>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+720>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+720|0;h[c[g+608>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+720>>3]);e=c[f>>2]|0;h[c[e+612>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+604>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+704>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+704|0;h[(c[e+608>>2]|0)+8>>3]=+h[g>>3];k=+aAa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+704>>3]);h[(c[(c[f>>2]|0)+612>>2]|0)+8>>3]=k;_za(a,7)|0;j=c[(c[f>>2]|0)+604>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+720>>3]=+h[j>>3];h[f+704>>3]=+h[j+8>>3];BP(a);CP(a);DP(a);EP(a);FP(a);GP(a);i=b;return}function Ek(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+136>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2352>>3]=+h[(a?e+2408|0:e+2400|0)>>3];i=b;return}function Fk(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;iA(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+72>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+1784>>3]=+yd(+(+h[d>>3]),+(+h[a+88>>3]*.999));i=b;return}function Gk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1784>>3];k=+zd(1.0e-13,+(+h[g+88>>3]-j));l=+h[g+2864>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+nwa(c[b+536>>2]|0,k,6424,6416,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+1800>>3]=+yd(+(j*n*.6219647130774989),1.0);i=d;return}function Hk(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1816>>3]=+zd(+(+h[d+80>>3]- +h[d+1800>>3]),0.0);i=b;return}function Ik(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1808>>3]=+h[b+80>>3]- +h[b+1816>>3];i=i;return}function Jk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1816>>3];k=1.0-j;l=+h[g+2864>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+nwa(c[b+536>>2]|0,k,6496,6488,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+1816>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+1808>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+1848|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+1848|0;z=y;h[z>>3]=w;i=d;return}l=m/+nwa(c[b+536>>2]|0,p,6496,6488,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+1848|0;z=y;h[z>>3]=w;i=d;return}function Kk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1856>>3]=+h[b+1872>>3]- +h[b+1848>>3]*+h[b+72>>3];i=i;return}function Lk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+72>>3]*+h[g+1848>>3];k=+h[g+88>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1864|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1864|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,6536,6528,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1864|0;p=o;h[p>>3]=m;i=d;return}function Mk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2760>>3]=+h[b+10408>>3]*+h[b+1864>>3];i=i;return}function Nk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2720>>3]=+h[b+80>>3]*+h[b+2760>>3];i=i;return}function Ok(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2800>>3]=+h[b+2760>>3]*+h[b+1856>>3];i=i;return}function Pk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2760>>3];k=+h[g+2640>>3]- +h[g+80>>3]*+h[g+2680>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+736|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+736|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,6584,6576,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+736|0;p=o;h[p>>3]=m;i=d;return}function Qk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9096>>3]=-+h[b+736>>3];i=i;return}function Rk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1008>>3]*+h[j+1864>>3]*+h[e+2112>>3];l=+h[j+128>>3]+ +h[j+136>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1400|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1400|0;r=q;h[r>>3]=o;i=d;return}s=l/+nwa(c[b+536>>2]|0,k,6608,6600,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1400|0;r=q;h[r>>3]=o;i=d;return}function Sk(a){a=a|0;var b=0,d=0.0,e=0.0,f=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1400>>3];e=+h[b+1408>>3];f=c[a+416>>2]|0;h[b+2152>>3]=+h[f+2216>>3]*(+h[b+2400>>3]*d*d*+h[f+1008>>3]- +h[b+2408>>3]*e*e*+h[f+1016>>3]);i=i;return}function Tk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8296>>3]=+h[b+2152>>3]+(-+h[b+2104>>3]- +h[b+2056>>3]);i=i;return}function Uk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10456>>3];k=+h[g+8296>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+792|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+792|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,6680,6672,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+792|0;p=o;h[p>>3]=m;i=d;return}function Vk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+88>>3];k=+h[g+80>>3];l=+h[g+1784>>3]*(k+ +h[g+2864>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+1824|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+1824|0;r=q;h[r>>3]=o;i=d;return}s=k/+nwa(c[b+536>>2]|0,l,6712,6704,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+1824|0;r=q;h[r>>3]=o;i=d;return}function Wk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1784>>3];k=+zd(1.0e-13,+(+h[g+88>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+nwa(c[b+536>>2]|0,k,6424,6816,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+1792>>3]=m*.6219647130774989;i=d;return}function Xk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;gxa(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+104>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+112>>3];l=+h[a+96>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];tA(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1984>>3]=+h[f>>3];i=b;return}function Yk(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+128>>3];h[b+2464>>3]=d*+h[(!(d>=0.0)?b+1872|0:b+1984|0)>>3];i=i;return}function Zk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2600>>3]=+h[b+2464>>3]- +h[b+2472>>3];i=i;return}function _k(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2872>>3]=1.0- +h[b+104>>3];i=i;return}function $k(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+104>>3];p=f;h[k>>3]=+h[n+2872>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+112>>3];q=+h[p+96>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];fA(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+1352>>3]=+h[l>>3];i=b;return}function al(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+2872>>3]),1.0e-13);k=+h[g+104>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1944|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1944|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,6832,6824,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1944|0;p=o;h[p>>3]=m;i=d;return}function bl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+80>>3];v=l;h[k>>3]=+h[t+2864>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];gxa(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+88>>3];w=+h[t+72>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];vz(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Bz(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+104>>3];f=j;h[k>>3]=+h[q+2872>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];gxa(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+112>>3];y=+h[f+96>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];vz(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Bz(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+2096>>3]=(+h[d+1e3>>3]+ +h[d+1008>>3])*(w- +h[r>>3])*+h[d+2216>>3]*.5;i=b;return}function cl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+104>>3];p=f;h[k>>3]=+h[n+2872>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+112>>3];q=+h[p+96>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2288>>3]=+h[l>>3];i=b;return}function dl(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+128>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2240>>3]=+h[(a?e+2296|0:e+2288|0)>>3];i=b;return}function el(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+104>>3];p=f;h[k>>3]=+h[n+2872>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+112>>3];q=+h[p+96>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2392>>3]=+h[l>>3];i=b;return}function fl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+684>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+2e3>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+2e3|0;h[c[g+688>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+2e3>>3]);h[c[(c[f>>2]|0)+692>>2]>>3]=k;_za(a,8)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+2e3>>3]=+h[c[(c[f>>2]|0)+684>>2]>>3];i=b;return}function gl(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+2048>>3]=+h[b+2e3>>3]*(+h[d+1e3>>3]+ +h[d+1008>>3])*+h[d+2216>>3]*.5;i=i;return}function hl(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+2560>>3]=+h[b+1400>>3]*+h[d+1008>>3]*+h[d+2112>>3]*(+h[b+64>>3]*.5+(+h[b+112>>3]*-.5+((+h[b+2e3>>3]+ +h[b+2008>>3])*.5+ +h[d+1352>>3]*+h[b+1864>>3]*-10.0)));i=i;return}function il(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8576>>3]=+h[b+2600>>3]+ +h[b+2560>>3];i=i;return}function jl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2760>>3];k=+h[g+8576>>3]- +h[g+2680>>3]*+h[g+1856>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+8352|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+8352|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,6584,6872,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+8352|0;p=o;h[p>>3]=m;i=d;return}function kl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+764>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+744>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+744|0;h[c[g+768>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+744>>3]);e=c[f>>2]|0;h[c[e+772>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+764>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+728>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+728|0;h[(c[e+768>>2]|0)+8>>3]=+h[g>>3];k=+aAa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+728>>3]);h[(c[(c[f>>2]|0)+772>>2]|0)+8>>3]=k;_za(a,9)|0;j=c[(c[f>>2]|0)+764>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+744>>3]=+h[j>>3];h[f+728>>3]=+h[j+8>>3];LP(a);MP(a);NP(a);OP(a);PP(a);QP(a);i=b;return}function ll(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+128>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2344>>3]=+h[(a?e+2400|0:e+2392|0)>>3];i=b;return}function ml(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;iA(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+96>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+1896>>3]=+yd(+(+h[d>>3]),+(+h[a+112>>3]*.999));i=b;return}function nl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1896>>3];k=+zd(1.0e-13,+(+h[g+112>>3]-j));l=+h[g+2872>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+nwa(c[b+536>>2]|0,k,6888,6880,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+1912>>3]=+yd(+(j*n*.6219647130774989),1.0);i=d;return}function ol(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1928>>3]=+zd(+(+h[d+104>>3]- +h[d+1912>>3]),0.0);i=b;return}function pl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1920>>3]=+h[b+104>>3]- +h[b+1928>>3];i=i;return}function ql(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1928>>3];k=1.0-j;l=+h[g+2872>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+nwa(c[b+536>>2]|0,k,6960,6952,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+1928>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+1920>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+1960|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+1960|0;z=y;h[z>>3]=w;i=d;return}l=m/+nwa(c[b+536>>2]|0,p,6960,6952,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+1960|0;z=y;h[z>>3]=w;i=d;return}function rl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1968>>3]=+h[b+1984>>3]- +h[b+1960>>3]*+h[b+96>>3];i=i;return}function sl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+96>>3]*+h[g+1960>>3];k=+h[g+112>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1976|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1976|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,7e3,6992,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1976|0;p=o;h[p>>3]=m;i=d;return}function tl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2752>>3]=+h[b+10400>>3]*+h[b+1976>>3];i=i;return}function ul(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2712>>3]=+h[b+104>>3]*+h[b+2752>>3];i=i;return}function vl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2792>>3]=+h[b+2752>>3]*+h[b+1968>>3];i=i;return}function wl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2752>>3];k=+h[g+2632>>3]- +h[g+104>>3]*+h[g+2672>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+760|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+760|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,7048,7040,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+760|0;p=o;h[p>>3]=m;i=d;return}function xl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9088>>3]=-+h[b+760>>3];i=i;return}function yl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1e3>>3]*+h[j+1976>>3]*+h[e+2112>>3];l=+h[j+120>>3]+ +h[j+128>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1392|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1392|0;r=q;h[r>>3]=o;i=d;return}s=l/+nwa(c[b+536>>2]|0,k,7072,7064,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1392|0;r=q;h[r>>3]=o;i=d;return}function zl(a){a=a|0;var b=0,d=0.0,e=0.0,f=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1392>>3];e=+h[b+1400>>3];f=c[a+416>>2]|0;h[b+2144>>3]=+h[f+2216>>3]*(+h[b+2392>>3]*d*d*+h[f+1e3>>3]- +h[b+2400>>3]*e*e*+h[f+1008>>3]);i=i;return}function Al(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8288>>3]=+h[b+2144>>3]+(-+h[b+2096>>3]- +h[b+2048>>3]);i=i;return}function Bl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10448>>3];k=+h[g+8288>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+784|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+784|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,7144,7136,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+784|0;p=o;h[p>>3]=m;i=d;return}function Cl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+112>>3];k=+h[g+104>>3];l=+h[g+1896>>3]*(k+ +h[g+2872>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+1936|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+1936|0;r=q;h[r>>3]=o;i=d;return}s=k/+nwa(c[b+536>>2]|0,l,7176,7168,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+1936|0;r=q;h[r>>3]=o;i=d;return}



function Bua(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 16:{g=b+1|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=d[j+76+(d[b]|0)|0]|0;if((g|0)==27){k=Cua(j,b+1|0,e,f)|0;l=k;i=h;return l|0}else if((g|0)==20){k=Dua(j,b+1|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((De[c[j+352>>2]&63](j,b)|0)!=0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((De[c[j+344>>2]&63](j,b)|0)!=0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 24:case 22:{b=b+1|0;break};case 17:{k=Fua(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 15:{k=Eua(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 29:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((De[c[j+348>>2]&63](j,b)|0)!=0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);g=0;b:while(1){if((b|0)==(e|0)){m=104;break}switch(d[j+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){m=41;break b}n=b;if((De[c[j+336>>2]&63](j,b)|0)==0){m=43;break b}b=n+3|0;continue b;break};case 10:case 9:case 21:{m=73;break b;break};case 11:{m=97;break b;break};case 17:{break b;break};case 5:{if((e-b|0)<2){m=36;break b}o=b;if((De[c[j+332>>2]&63](j,b)|0)==0){m=38;break b}b=o+2|0;continue b;break};case 29:{m=33;break b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 23:{if((g|0)!=0){m=51;break b}g=1;b=b+1|0;if((b|0)==(e|0)){m=53;break b}switch(d[j+76+(d[b]|0)|0]|0){case 24:case 22:{b=b+1|0;continue b;break};case 7:{if((e-b|0)<4){m=68;break b}p=b;if((De[c[j+352>>2]&63](j,b)|0)==0){m=70;break b}b=p+4|0;continue b;break};case 6:{if((e-b|0)<3){m=63;break b}q=b;if((De[c[j+348>>2]&63](j,b)|0)==0){m=65;break b}b=q+3|0;continue b;break};case 5:{if((e-b|0)<2){m=58;break b}r=b;if((De[c[j+344>>2]&63](j,b)|0)==0){m=60;break b}b=r+2|0;continue b;break};case 29:{m=55;break b;break};default:{m=72;break b}}break};case 7:{if((e-b|0)<4){m=46;break b}s=b;if((De[c[j+340>>2]&63](j,b)|0)==0){m=48;break b}b=s+4|0;continue b;break};default:{m=103;break b}}}c:do{if((m|0)==33){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==36){k=-2;l=k;i=h;return l|0}else if((m|0)==38){c[f>>2]=o;k=0;l=k;i=h;return l|0}else if((m|0)==41){k=-2;l=k;i=h;return l|0}else if((m|0)==43){c[f>>2]=n;k=0;l=k;i=h;return l|0}else if((m|0)==46){k=-2;l=k;i=h;return l|0}else if((m|0)==48){c[f>>2]=s;k=0;l=k;i=h;return l|0}else if((m|0)==51){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==53){k=-1;l=k;i=h;return l|0}else if((m|0)==55){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==58){k=-2;l=k;i=h;return l|0}else if((m|0)==60){c[f>>2]=r;k=0;l=k;i=h;return l|0}else if((m|0)==63){k=-2;l=k;i=h;return l|0}else if((m|0)==65){c[f>>2]=q;k=0;l=k;i=h;return l|0}else if((m|0)==68){k=-2;l=k;i=h;return l|0}else if((m|0)==70){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==72){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==73){b=b+1|0;d:while(1){if((b|0)==(e|0)){m=96;break}switch(d[j+76+(d[b]|0)|0]|0){case 5:{m=78;break d;break};case 6:{m=83;break d;break};case 7:{m=88;break d;break};case 24:case 22:{m=77;break d;break};case 11:{m=97;break c;break};case 10:case 9:case 21:{break};case 17:{break c;break};case 29:{m=76;break d;break};default:{m=94;break d}}b=b+1|0}do{if((m|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==77){b=b+1|0}else if((m|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((De[c[j+344>>2]&63](j,b)|0)!=0){b=g+2|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==83){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((De[c[j+348>>2]&63](j,b)|0)!=0){b=g+3|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==88){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((De[c[j+352>>2]&63](j,b)|0)!=0){b=g+4|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==94){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==96){k=-1;l=k;i=h;return l|0}}while(0);k=Gua(j,b,e,f)|0;l=k;i=h;return l|0}else if((m|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==104){k=-1;l=k;i=h;return l|0}}while(0);if((m|0)==97){c[f>>2]=b+1;k=2;l=k;i=h;return l|0}b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}e=b;if((a[b]|0)==62){c[f>>2]=e+1;k=4;l=k;i=h;return l|0}else{c[f>>2]=e;k=0;l=k;i=h;return l|0}return 0}function Cua(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b]|0)!=45){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+1|0;b:while(1){if((b|0)==(e|0)){break a}switch(d[j+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){m=13;break b}n=b;if((De[c[j+360>>2]&63](j,b)|0)!=0){m=15;break b}b=n+3|0;continue b;break};case 5:{if((e-b|0)<2){m=8;break b}o=b;if((De[c[j+356>>2]&63](j,b)|0)!=0){m=10;break b}b=o+2|0;continue b;break};case 7:{if((e-b|0)<4){m=18;break b}p=b;if((De[c[j+364>>2]&63](j,b)|0)!=0){m=20;break b}b=p+4|0;continue b;break};case 27:{g=b+1|0;b=g;if((g|0)==(e|0)){m=24;break b}if((a[b]|0)==45){m=26;break b}else{continue b}break};case 8:case 1:case 0:{m=22;break b;break};default:{b=b+1|0;continue b}}}if((m|0)==8){k=-2;l=k;i=h;return l|0}else if((m|0)==10){c[f>>2]=o;k=0;l=k;i=h;return l|0}else if((m|0)==13){k=-2;l=k;i=h;return l|0}else if((m|0)==15){c[f>>2]=n;k=0;l=k;i=h;return l|0}else if((m|0)==18){k=-2;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==22){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==24){k=-1;l=k;i=h;return l|0}else if((m|0)==26){g=b+1|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==62){c[f>>2]=g+1;k=13;l=k;i=h;return l|0}else{c[f>>2]=g;k=0;l=k;i=h;return l|0}}}}while(0);k=-1;l=k;i=h;return l|0}function Dua(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<6){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=8;break}if((a[k]|0)!=(a[200192+e|0]|0)){l=6;break}e=e+1|0;g=g+1|0}if((l|0)==6){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==8){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function Eua(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}a:do{switch(d[k+76+(d[b]|0)|0]|0){case 24:case 22:{b=b+1|0;break};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}n=b;if((De[c[k+344>>2]&63](k,b)|0)!=0){b=n+2|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}n=b;if((De[c[k+352>>2]&63](k,b)|0)!=0){b=n+4|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}n=b;if((De[c[k+348>>2]&63](k,b)|0)!=0){b=n+3|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 29:{c[f>>2]=b;l=0;m=l;i=h;return m|0};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b:while(1){if((b|0)==(e|0)){o=75;break}switch(d[k+76+(d[b]|0)|0]|0){case 29:{o=24;break b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 10:case 9:case 21:{o=41;break b;break};case 6:{if((e-b|0)<3){o=32;break b}p=b;if((De[c[k+336>>2]&63](k,b)|0)==0){o=34;break b}b=p+3|0;continue b;break};case 5:{if((e-b|0)<2){o=27;break b}q=b;if((De[c[k+332>>2]&63](k,b)|0)==0){o=29;break b}b=q+2|0;continue b;break};case 15:{o=68;break b;break};case 7:{if((e-b|0)<4){o=37;break b}r=b;if((De[c[k+340>>2]&63](k,b)|0)==0){o=39;break b}b=r+4|0;continue b;break};default:{break b}}}do{if((o|0)==24){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((o|0)==27){l=-2;m=l;i=h;return m|0}else if((o|0)==29){c[f>>2]=q;l=0;m=l;i=h;return m|0}else if((o|0)==32){l=-2;m=l;i=h;return m|0}else if((o|0)==34){c[f>>2]=p;l=0;m=l;i=h;return m|0}else if((o|0)==37){l=-2;m=l;i=h;return m|0}else if((o|0)==39){c[f>>2]=r;l=0;m=l;i=h;return m|0}else if((o|0)==41){n=b;if((Hua(k,g,b,j)|0)==0){c[f>>2]=n;l=0;m=l;i=h;return m|0}b=n+1|0;c:while(1){if((b|0)==(e|0)){o=67;break}switch(d[k+76+(d[b]|0)|0]|0){case 15:{b=b+1|0;if((b|0)==(e|0)){o=63;break c}if((a[b]|0)==62){o=65;break c}else{continue c}break};case 7:{if((e-b|0)<4){o=57;break c}s=b;if((De[c[k+364>>2]&63](k,b)|0)!=0){o=59;break c}b=s+4|0;continue c;break};case 8:case 1:case 0:{o=61;break c;break};case 6:{if((e-b|0)<3){o=52;break c}t=b;if((De[c[k+360>>2]&63](k,b)|0)!=0){o=54;break c}b=t+3|0;continue c;break};case 5:{if((e-b|0)<2){o=47;break c}u=b;if((De[c[k+356>>2]&63](k,b)|0)!=0){o=49;break c}b=u+2|0;continue c;break};default:{b=b+1|0;continue c}}}if((o|0)==47){l=-2;m=l;i=h;return m|0}else if((o|0)==49){c[f>>2]=u;l=0;m=l;i=h;return m|0}else if((o|0)==52){l=-2;m=l;i=h;return m|0}else if((o|0)==54){c[f>>2]=t;l=0;m=l;i=h;return m|0}else if((o|0)==57){l=-2;m=l;i=h;return m|0}else if((o|0)==59){c[f>>2]=s;l=0;m=l;i=h;return m|0}else if((o|0)==61){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((o|0)==63){l=-1;m=l;i=h;return m|0}else if((o|0)==65){c[f>>2]=b+1;l=c[j>>2]|0;m=l;i=h;return m|0}else if((o|0)==67){l=-1;m=l;i=h;return m|0}}else if((o|0)==68){n=b;if((Hua(k,g,b,j)|0)==0){c[f>>2]=n;l=0;m=l;i=h;return m|0}b=n+1|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b]|0)!=62){break}c[f>>2]=b+1;l=c[j>>2]|0;m=l;i=h;return m|0}else if((o|0)==75){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function Fua(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 24:case 22:{a=a+1|0;break};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((De[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((De[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((De[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=51;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 29:{l=24;break b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 11:{l=49;break b;break};case 10:case 9:case 21:{l=41;break b;break};case 6:{if((b-a|0)<3){l=32;break b}m=a;if((De[c[h+336>>2]&63](h,a)|0)==0){l=34;break b}a=m+3|0;continue b;break};case 5:{if((b-a|0)<2){l=27;break b}n=a;if((De[c[h+332>>2]&63](h,a)|0)==0){l=29;break b}a=n+2|0;continue b;break};case 23:{a=a+1|0;continue b;break};case 7:{if((b-a|0)<4){l=37;break b}o=a;if((De[c[h+340>>2]&63](h,a)|0)==0){l=39;break b}a=o+4|0;continue b;break};default:{l=50;break b}}}if((l|0)==24){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==27){j=-2;k=j;i=g;return k|0}else if((l|0)==29){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==32){j=-2;k=j;i=g;return k|0}else if((l|0)==34){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==37){j=-2;k=j;i=g;return k|0}else if((l|0)==39){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==41){a=a+1|0;while(1){if((a|0)==(b|0)){l=47;break}o=d[h+76+(d[a]|0)|0]|0;if((o|0)==11){l=44;break}else if(!((o|0)==10|(o|0)==9|(o|0)==21)){l=45;break}a=a+1|0}if((l|0)==44){c[e>>2]=a+1;j=5;k=j;i=g;return k|0}else if((l|0)==45){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==47){j=-1;k=j;i=g;return k|0}}else if((l|0)==49){c[e>>2]=a+1;j=5;k=j;i=g;return k|0}else if((l|0)==50){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==51){j=-1;k=j;i=g;return k|0}return 0}function Gua(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=114;break}b:do{switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 7:{if((e-(c[j>>2]|0)|0)<4){l=17;break a}b=(De[c[k+340>>2]&63](k,c[j>>2]|0)|0)!=0;m=c[j>>2]|0;if(!b){l=19;break a}c[j>>2]=m+4;continue a;break};case 29:{l=4;break a;break};case 23:{if((g|0)!=0){l=22;break a}g=1;c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=24;break a}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 29:{l=26;break a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=29;break a}b=(De[c[k+344>>2]&63](k,c[j>>2]|0)|0)!=0;n=c[j>>2]|0;if(!b){l=31;break a}c[j>>2]=n+2;continue a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=34;break a}b=(De[c[k+348>>2]&63](k,c[j>>2]|0)|0)!=0;o=c[j>>2]|0;if(!b){l=36;break a}c[j>>2]=o+3;continue a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=39;break a}b=(De[c[k+352>>2]&63](k,c[j>>2]|0)|0)!=0;p=c[j>>2]|0;if(!b){l=41;break a}c[j>>2]=p+4;continue a;break};case 24:case 22:{c[j>>2]=(c[j>>2]|0)+1;continue a;break};default:{l=43;break a}}break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=7;break a}b=(De[c[k+332>>2]&63](k,c[j>>2]|0)|0)!=0;q=c[j>>2]|0;if(!b){l=9;break a}c[j>>2]=q+2;continue a;break};case 27:case 26:case 25:case 24:case 22:{c[j>>2]=(c[j>>2]|0)+1;continue a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=12;break a}b=(De[c[k+336>>2]&63](k,c[j>>2]|0)|0)!=0;r=c[j>>2]|0;if(!b){l=14;break a}c[j>>2]=r+3;continue a;break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=45;break a}b=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((b|0)==14){break b}s=b;if(!((s|0)==9|(s|0)==10|(s|0)==21)){l=48;break a}}break};case 14:{break};default:{l=113;break a}}}while(0);g=0;while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=51;break a}t=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((t|0)==12|(t|0)==13){break}s=t;if(!((s|0)==9|(s|0)==10|(s|0)==21)){l=54;break a}}c[j>>2]=(c[j>>2]|0)+1;c:while(1){if((c[j>>2]|0)==(e|0)){l=57;break a}s=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((s|0)==(t|0)){break}switch(s|0){case 7:{if((e-(c[j>>2]|0)|0)<4){l=71;break a}s=(De[c[k+364>>2]&63](k,c[j>>2]|0)|0)!=0;u=c[j>>2]|0;if(s){l=73;break a}c[j>>2]=u+4;continue c;break};case 2:{l=80;break a;break};case 3:{v=xua(k,(c[j>>2]|0)+1|0,e,j)|0;if((v|0)<=0){l=77;break a}else{continue c}break};case 8:case 1:case 0:{l=75;break a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=66;break a}s=(De[c[k+360>>2]&63](k,c[j>>2]|0)|0)!=0;w=c[j>>2]|0;if(s){l=68;break a}c[j>>2]=w+3;continue c;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=61;break a}s=(De[c[k+356>>2]&63](k,c[j>>2]|0)|0)!=0;x=c[j>>2]|0;if(s){l=63;break a}c[j>>2]=x+2;continue c;break};default:{c[j>>2]=(c[j>>2]|0)+1;continue c}}}c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=83;break}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 17:{l=107;break a;break};case 10:case 9:case 21:{break};case 11:{l=106;break a;break};default:{l=85;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=87;break a}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 5:{l=91;break d;break};case 17:{l=107;break a;break};case 6:{l=96;break d;break};case 7:{l=101;break d;break};case 10:case 9:case 21:{break};case 24:case 22:{l=90;break d;break};case 11:{l=106;break a;break};case 29:{l=89;break a;break};default:{l=112;break a}}}if((l|0)==90){l=0;c[j>>2]=(c[j>>2]|0)+1;continue}else if((l|0)==91){l=0;if((e-(c[j>>2]|0)|0)<2){l=92;break}s=(De[c[k+344>>2]&63](k,c[j>>2]|0)|0)!=0;y=c[j>>2]|0;if(!s){l=94;break}c[j>>2]=y+2;continue}else if((l|0)==96){l=0;if((e-(c[j>>2]|0)|0)<3){l=97;break}s=(De[c[k+348>>2]&63](k,c[j>>2]|0)|0)!=0;z=c[j>>2]|0;if(!s){l=99;break}c[j>>2]=z+3;continue}else if((l|0)==101){l=0;if((e-(c[j>>2]|0)|0)<4){l=102;break}s=(De[c[k+352>>2]&63](k,c[j>>2]|0)|0)!=0;A=c[j>>2]|0;if(!s){l=104;break}c[j>>2]=A+4;continue}}if((l|0)==4){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==7){B=-2;C=B;i=h;return C|0}else if((l|0)==9){c[f>>2]=q;B=0;C=B;i=h;return C|0}else if((l|0)==12){B=-2;C=B;i=h;return C|0}else if((l|0)==14){c[f>>2]=r;B=0;C=B;i=h;return C|0}else if((l|0)==17){B=-2;C=B;i=h;return C|0}else if((l|0)==19){c[f>>2]=m;B=0;C=B;i=h;return C|0}else if((l|0)==22){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==24){B=-1;C=B;i=h;return C|0}else if((l|0)==26){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==29){B=-2;C=B;i=h;return C|0}else if((l|0)==31){c[f>>2]=n;B=0;C=B;i=h;return C|0}else if((l|0)==34){B=-2;C=B;i=h;return C|0}else if((l|0)==36){c[f>>2]=o;B=0;C=B;i=h;return C|0}else if((l|0)==39){B=-2;C=B;i=h;return C|0}else if((l|0)==41){c[f>>2]=p;B=0;C=B;i=h;return C|0}else if((l|0)==43){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==45){B=-1;C=B;i=h;return C|0}else if((l|0)==48){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==51){B=-1;C=B;i=h;return C|0}else if((l|0)==54){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==57){B=-1;C=B;i=h;return C|0}else if((l|0)==61){B=-2;C=B;i=h;return C|0}else if((l|0)==63){c[f>>2]=x;B=0;C=B;i=h;return C|0}else if((l|0)==66){B=-2;C=B;i=h;return C|0}else if((l|0)==68){c[f>>2]=w;B=0;C=B;i=h;return C|0}else if((l|0)==71){B=-2;C=B;i=h;return C|0}else if((l|0)==73){c[f>>2]=u;B=0;C=B;i=h;return C|0}else if((l|0)==75){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==77){if((v|0)==0){c[f>>2]=c[j>>2]}B=v;C=B;i=h;return C|0}else if((l|0)==80){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==83){B=-1;C=B;i=h;return C|0}else if((l|0)==85){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==87){B=-1;C=B;i=h;return C|0}else if((l|0)==89){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==92){B=-2;C=B;i=h;return C|0}else if((l|0)==94){c[f>>2]=y;B=0;C=B;i=h;return C|0}else if((l|0)==97){B=-2;C=B;i=h;return C|0}else if((l|0)==99){c[f>>2]=z;B=0;C=B;i=h;return C|0}else if((l|0)==102){B=-2;C=B;i=h;return C|0}else if((l|0)==104){c[f>>2]=A;B=0;C=B;i=h;return C|0}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+1;B=1;C=B;i=h;return C|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){B=-1;C=B;i=h;return C|0}e=c[j>>2]|0;if((a[c[j>>2]|0]|0)==62){c[f>>2]=e+1;B=3;C=B;i=h;return C|0}else{c[f>>2]=e;B=0;C=B;i=h;return C|0}}else if((l|0)==112){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==113){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==114){B=-1;C=B;i=h;return C|0}return 0}function Hua(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;do{if((e-g|0)!=3){h=1}else{j=a[g]|0;if((j|0)==88){f=1}else if((j|0)!=120){h=1;break}g=g+1|0;j=a[g]|0;if((j|0)==77){f=1}else if((j|0)!=109){h=1;break}g=g+1|0;j=a[g]|0;if((j|0)==76){f=1}else if((j|0)!=108){h=1;break}if((f|0)!=0){h=0;break}else{c[d>>2]=12;h=1;break}}}while(0);i=b;return h|0}function Iua(a,b,e,f,g){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+56|0;j=a;a=b;b=e;e=f;f=g;a:while(1){if((b|0)==(e|0)){k=27;break}g=d[a+76+(d[b]|0)|0]|0;switch(g|0){case 13:case 12:{b=b+1|0;if((g|0)!=(j|0)){continue a}else{k=21;break a}break};case 6:{if((e-b|0)<3){k=10;break a}l=b;if((De[c[a+360>>2]&63](a,b)|0)!=0){k=12;break a}b=l+3|0;continue a;break};case 8:case 1:case 0:{k=19;break a;break};case 7:{if((e-b|0)<4){k=15;break a}m=b;if((De[c[a+364>>2]&63](a,b)|0)!=0){k=17;break a}b=m+4|0;continue a;break};case 5:{if((e-b|0)<2){k=5;break a}n=b;if((De[c[a+356>>2]&63](a,b)|0)!=0){k=7;break a}b=n+2|0;continue a;break};default:{b=b+1|0;continue a}}}if((k|0)==5){o=-2;p=o;i=h;return p|0}else if((k|0)==7){c[f>>2]=n;o=0;p=o;i=h;return p|0}else if((k|0)==10){o=-2;p=o;i=h;return p|0}else if((k|0)==12){c[f>>2]=l;o=0;p=o;i=h;return p|0}else if((k|0)==15){o=-2;p=o;i=h;return p|0}else if((k|0)==17){c[f>>2]=m;o=0;p=o;i=h;return p|0}else if((k|0)==19){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==21){if((b|0)==(e|0)){o=-27;p=o;i=h;return p|0}c[f>>2]=b;switch(d[a+76+(d[b]|0)|0]|0|0){case 20:case 30:case 11:case 10:case 9:case 21:{o=27;p=o;i=h;return p|0};default:{o=0;p=o;i=h;return p|0}}}else if((k|0)==27){o=-1;p=o;i=h;return p|0}return 0}function Jua(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}f=d[h+76+(d[a]|0)|0]|0;if((f|0)==27){j=Cua(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else if((f|0)==20){c[e>>2]=a+1;j=33;k=j;i=g;return k|0}else if((f|0)==24|(f|0)==22){a=a+1|0;a:while(1){if((a|0)==(b|0)){l=17;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 10:case 9:case 21:{break a;break};case 30:{l=10;break a;break};case 24:case 22:{break};default:{l=16;break a}}a=a+1|0}do{if((l|0)==10){if((a+1|0)==(b|0)){j=-1;k=j;i=g;return k|0}f=d[h+76+(d[a+1|0]|0)|0]|0;if(!((f|0)==30|(f|0)==10|(f|0)==9|(f|0)==21)){break}c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==16){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==17){j=-1;k=j;i=g;return k|0}}while(0);c[e>>2]=a;j=16;k=j;i=g;return k|0}else{c[e>>2]=a;j=0;k=j;i=g;return k|0}return 0}function Kua(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((De[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((De[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((De[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=43;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 36:case 30:case 11:case 32:case 21:case 10:case 9:{l=41;break b;break};case 5:{if((b-a|0)<2){l=27;break b}m=a;if((De[c[h+332>>2]&63](h,a)|0)==0){l=29;break b}a=m+2|0;continue b;break};case 6:{if((b-a|0)<3){l=32;break b}n=a;if((De[c[h+336>>2]&63](h,a)|0)==0){l=34;break b}a=n+3|0;continue b;break};case 7:{if((b-a|0)<4){l=37;break b}o=a;if((De[c[h+340>>2]&63](h,a)|0)==0){l=39;break b}a=o+4|0;continue b;break};case 29:{l=24;break b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};default:{l=42;break b}}}if((l|0)==24){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==27){j=-2;k=j;i=g;return k|0}else if((l|0)==29){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==32){j=-2;k=j;i=g;return k|0}else if((l|0)==34){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==37){j=-2;k=j;i=g;return k|0}else if((l|0)==39){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==41){c[e>>2]=a;j=20;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==43){j=-20;k=j;i=g;return k|0}return 0}function Lua(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;i=i+40|0;h=d;d=e;e=f;f=g;while(1){if((c[h>>2]|0)==(d|0)){j=5;break}if((c[e>>2]|0)==(f|0)){j=5;break}g=h;k=c[g>>2]|0;c[g>>2]=k+1;g=a[k]|0;k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=g}if((j|0)==5){i=b;return}}function Mua(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;a=i;i=i+40|0;j=e;e=f;f=g;g=h;while(1){if((c[j>>2]|0)==(e|0)){k=5;break}if((c[f>>2]|0)==(g|0)){k=5;break}h=j;l=c[h>>2]|0;c[h>>2]=l+1;h=d[l]|0;l=f;m=c[l>>2]|0;c[l>>2]=m+2;b[m>>1]=h}if((k|0)==5){i=a;return}}function Nua(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;i=i+48|0;h=d;d=e;e=f;f=g;while(1){if((c[h>>2]|0)==(d|0)){j=8;break}g=a[c[h>>2]|0]|0;if((g&128|0)!=0){if((f-(c[e>>2]|0)|0)<2){j=8;break}k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=(g&255)>>6|192;l=e;k=c[l>>2]|0;c[l>>2]=k+1;a[k]=g&63|128;g=h;c[g>>2]=(c[g>>2]|0)+1;continue}else{if((c[e>>2]|0)==(f|0)){j=8;break}g=h;k=c[g>>2]|0;c[g>>2]=k+1;g=a[k]|0;k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=g;continue}}if((j|0)==8){i=b;return}}function Oua(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+72|0;l=b;b=e;e=f;f=g;g=h;h=j;if((f|0)==(g|0)){m=-4;n=m;i=k;return n|0}j=c[b+76>>2]|0;a:do{if((f+1|0)==(g|0)){if(((a[b+73|0]|0)+ -3|0)>>>0<3){m=-1;n=m;i=k;return n|0}b:do{switch(d[f]|0){case 239:case 255:case 254:{if((a[b+73|0]|0)!=0){break b}if((e|0)==1){break a}break};case 60:case 0:{break};default:{break a}}}while(0);m=-1;n=m;i=k;return n|0}else{o=d[f]<<8|d[f+1|0];if((o|0)==65534){if((a[b+73|0]|0)==0){if((e|0)==1){break}}c[h>>2]=f+2;c[j>>2]=c[l+20>>2];m=14;n=m;i=k;return n|0}else if((o|0)==15360){if((a[b+73|0]|0)==4){p=16}else{if((a[b+73|0]|0)==3){p=16}}if((p|0)==16){if((e|0)==1){break}}c[j>>2]=c[l+20>>2];m=Ne[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}else if((o|0)==65279){if((a[b+73|0]|0)==0){if((e|0)==1){break}}c[h>>2]=f+2;c[j>>2]=c[l+16>>2];m=14;n=m;i=k;return n|0}else if((o|0)==61371){if((e|0)==1){o=a[b+73|0]|0;if((o|0)==0|(o|0)==4|(o|0)==5|(o|0)==3){break}}if((f+2|0)==(g|0)){m=-1;n=m;i=k;return n|0}if((d[f+2|0]|0)!=191){break}c[h>>2]=f+3;c[j>>2]=c[l+8>>2];m=14;n=m;i=k;return n|0}else{if((a[f]|0)==0){if((e|0)==1){if((a[b+73|0]|0)==5){break}}c[j>>2]=c[l+16>>2];m=Ne[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}else{if((a[f+1|0]|0)!=0){break}if((e|0)==1){break}c[j>>2]=c[l+20>>2];m=Ne[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}}}}while(0);c[j>>2]=c[l+(a[b+73|0]<<2)>>2];m=Ne[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}function Pua(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+80|0;k=a;a=b;b=d;d=e;e=f;f=g;g=h;if((a|0)==(b|0)){c[d>>2]=0;l=1;m=l;i=j;return m|0}if((Rua(Qua(k,a,b)|0)|0)==0){c[g>>2]=a;l=0;m=l;i=j;return m|0}do{a=a+(c[k+68>>2]|0)|0;}while((Rua(Qua(k,a,b)|0)|0)!=0);if((a|0)==(b|0)){c[d>>2]=0;l=1;m=l;i=j;return m|0}c[d>>2]=a;while(1){n=Qua(k,a,b)|0;if((n|0)==-1){o=10;break}if((n|0)==61){o=12;break}if((Rua(n)|0)!=0){o=14;break}a=a+(c[k+68>>2]|0)|0}do{if((o|0)==10){c[g>>2]=a;l=0;m=l;i=j;return m|0}else if((o|0)==12){c[e>>2]=a}else if((o|0)==14){c[e>>2]=a;do{a=a+(c[k+68>>2]|0)|0;h=Qua(k,a,b)|0;n=h;}while((Rua(h)|0)!=0);if((n|0)==61){break}c[g>>2]=a;l=0;m=l;i=j;return m|0}}while(0);if((a|0)==(c[d>>2]|0)){c[g>>2]=a;l=0;m=l;i=j;return m|0}a=a+(c[k+68>>2]|0)|0;n=Qua(k,a,b)|0;while(1){if((Rua(n)|0)==0){break}a=a+(c[k+68>>2]|0)|0;n=Qua(k,a,b)|0}if((n|0)!=34&(n|0)!=39){c[g>>2]=a;l=0;m=l;i=j;return m|0}d=n&255;a=a+(c[k+68>>2]|0)|0;c[f>>2]=a;a:while(1){n=Qua(k,a,b)|0;if((n|0)==(d<<24>>24|0)){o=33;break}do{if(!(97<=(n|0)&(n|0)<=122)){if(65<=(n|0)&(n|0)<=90){break}if((48<=(n|0)&(n|0)<=57^1)&(n|0)!=46&(n|0)!=45&(n|0)!=95){o=31;break a}}}while(0);a=a+(c[k+68>>2]|0)|0}if((o|0)==31){c[g>>2]=a;l=0;m=l;i=j;return m|0}else if((o|0)==33){c[g>>2]=a+(c[k+68>>2]|0);l=1;m=l;i=j;return m|0}return 0}function Qua(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+48|0;g=f+16|0;h=f+32|0;j=f+40|0;k=b;c[g>>2]=d;c[j>>2]=h;ie[c[k+60>>2]&31](k,g,e,j,(c[j>>2]|0)+1|0);if((c[j>>2]|0)==(h|0)){l=-1;m=l;i=f;return m|0}else{l=a[h]|0;m=l;i=f;return m|0}return 0}function Rua(a){a=a|0;var b=0,c=0,d=0;b=i;i=i+16|0;c=a;if((c|0)==9|(c|0)==10|(c|0)==13|(c|0)==32){d=1}else{d=0}i=b;return d|0}function Sua(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;c[d>>2]=13;c[d+16>>2]=1;c[d+12>>2]=0;c[d+20>>2]=0;i=b;return}function Tua(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 15:{c[h>>2]=14;j=0;break};case 16:{if((Ne[c[b+28>>2]&63](b,d+(c[b+68>>2]<<1)|0,e,203936)|0)==0){k=10;break a}c[h>>2]=15;j=3;break};case 14:{j=0;break};case 29:{c[h>>2]=16;j=2;break};case 12:{c[h>>2]=14;j=1;break};case 13:{c[h>>2]=14;j=56;break};case 11:{c[h>>2]=14;j=55;break};default:{k=10}}}while(0);if((k|0)==10){j=Xua(h,a)|0}i=g;return j|0}function Uua(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;a:do{switch(a|0){case-4:{if((c[h+12>>2]|0)!=0){j=9;break a}k=0;break};case 33:{c[h>>2]=17;k=0;break};case 15:{k=0;break};case 26:{j=9;break};case 34:{if((c[h+12>>2]|0)==0){j=9;break a}b=h+12|0;c[b>>2]=(c[b>>2]|0)-1;k=0;break};default:{k=Wua(h,a,d,e,f)|0}}}while(0);if((j|0)==9){k=Xua(h,a)|0}i=g;return k|0}function Vua(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;if((f|0)==18){j=3}else if((f|0)==15){k=0;l=k;i=g;return l|0}do{if((j|0)==3){if((Ne[c[e+28>>2]&63](e,b,d,203920)|0)!=0){c[h>>2]=18;k=0;l=k;i=g;return l|0}if((Ne[c[e+28>>2]&63](e,b,d,203928)|0)==0){break}c[h>>2]=19;k=0;l=k;i=g;return l|0}}while(0);k=Xua(h,a)|0;l=k;i=g;return l|0}function Wua(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;a:do{switch(a|0){case 26:{c[h>>2]=24;j=3;k=j;i=g;return k|0};case 16:{if((Ne[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,203696)|0)!=0){c[h>>2]=20;j=11;k=j;i=g;return k|0}if((Ne[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,203704)|0)!=0){c[h>>2]=21;j=33;k=j;i=g;return k|0}if((Ne[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,203712)|0)!=0){c[h>>2]=22;j=39;k=j;i=g;return k|0}if((Ne[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,203720)|0)==0){break a}c[h>>2]=23;j=17;k=j;i=g;return k|0};case 28:{j=60;k=j;i=g;return k|0};case 11:{j=55;k=j;i=g;return k|0};case 13:{j=56;k=j;i=g;return k|0};case-4:{j=0;k=j;i=g;return k|0};case 15:{j=0;k=j;i=g;return k|0};default:{}}}while(0);j=Xua(h,a)|0;k=j;i=g;return k|0}function Xua(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+24|0;e=a;do{if((c[e+16>>2]|0)==0){if((b|0)!=28){break}f=59;g=f;i=d;return g|0}}while(0);c[e>>2]=16;f=-1;g=f;i=d;return g|0}function Yua(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;e=i;i=i+40|0;i=e;return 0}function Zua(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=26;g=9}else if((b|0)==15){g=11}else if((b|0)==22){c[e>>2]=25;g=11}else{g=Xua(e,a)|0}i=f;return g|0}function _ua(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=27;g=34}else if((b|0)==15){g=33}else{g=Xua(e,a)|0}i=f;return g|0}function $ua(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=39}else if((b|0)==41|(b|0)==18){c[e>>2]=28;g=40}else{g=Xua(e,a)|0}i=f;return g|0}function ava(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=17}else if((b|0)==18){c[e>>2]=29;g=18}else{g=Xua(e,a)|0}i=f;return g|0}function bva(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==17){c[e>>2]=30;g=8}else{g=Xua(e,a)|0}i=f;return g|0}function cva(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==11){g=55}else if((b|0)==15){g=0}else if((b|0)==29){c[e>>2]=16;g=2}else if((b|0)==13){g=56}else{g=Xua(e,a)|0}i=f;return g|0}function dva(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;if((f|0)==15){j=17;k=j;i=g;return k|0}else if((f|0)==18){l=3}do{if((l|0)==3){if((Ne[c[e+28>>2]&63](e,b,d,203736)|0)!=0){c[h>>2]=31;j=17;k=j;i=g;return k|0}if((Ne[c[e+28>>2]&63](e,b,d,203744)|0)==0){break}c[h>>2]=32;j=17;k=j;i=g;return k|0}}while(0);j=Xua(h,a)|0;k=j;i=g;return k|0}function eva(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=33;c[e+8>>2]=17;g=19}else if((b|0)==15){g=17}else{g=Xua(e,a)|0}i=f;return g|0}function fva(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=17}else if((b|0)==27){c[e>>2]=34;g=21}else{g=Xua(e,a)|0}i=f;return g|0}function gva(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=33;c[e+8>>2]=17;g=19}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=20}else if((b|0)==15){g=17}else{g=Xua(e,a)|0}i=f;return g|0}function hva(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=c[e+8>>2]|0;h=g;i=f;return h|0}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=c[e+8>>2]|0;h=g;i=f;return h|0}else{g=Xua(e,a)|0;h=g;i=f;return h|0}return 0}function iva(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==18){if((Ne[c[e+28>>2]&63](e,b,d,203752)|0)!=0){c[h>>2]=33;c[h+8>>2]=39;j=42;k=j;i=g;return k|0}if((Ne[c[e+28>>2]&63](e,b,d,203760)|0)==0){break}c[h>>2]=33;c[h+8>>2]=39;j=41;k=j;i=g;return k|0}else if((f|0)==23){c[h>>2]=37;c[h+4>>2]=1;j=44;k=j;i=g;return k|0}else if((f|0)==15){j=39;k=j;i=g;return k|0}}while(0);j=Xua(h,a)|0;k=j;i=g;return k|0}function jva(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 41:case 18:{c[h>>2]=40;j=51;break};case 15:{j=39;break};case 30:{c[h>>2]=40;j=53;break};case 31:{c[h>>2]=40;j=52;break};case 23:{c[h+4>>2]=2;c[h>>2]=39;j=44;break};case 32:{c[h>>2]=40;j=54;break};case 20:{if((Ne[c[b+28>>2]&63](b,d+(c[b+68>>2]|0)|0,e,203768)|0)==0){k=10;break a}c[h>>2]=38;j=43;break};default:{k=10}}}while(0);if((k|0)==10){j=Xua(h,a)|0}i=g;return j|0}function kva(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==24){c[e>>2]=33;c[e+8>>2]=39;g=45}else if((b|0)==36){c[e>>2]=33;c[e+8>>2]=39;g=46}else if((b|0)==21){c[e>>2]=41;g=39}else if((b|0)==15){g=39}else{g=Xua(e,a)|0}i=f;return g|0}function lva(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;switch(a|0){case 15:{g=39;break};case 32:{c[e>>2]=40;g=54;break};case 31:{c[e>>2]=40;g=52;break};case 23:{b=e+4|0;c[b>>2]=(c[b>>2]|0)+1;g=44;break};case 30:{c[e>>2]=40;g=53;break};case 41:case 18:{c[e>>2]=40;g=51;break};default:{g=Xua(e,a)|0}}i=f;return g|0}function mva(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;switch(a|0){case 35:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=47;h=g;i=f;return h|0};case 38:{c[e>>2]=39;g=50;h=g;i=f;return h|0};case 24:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=45;h=g;i=f;return h|0};case 15:{g=39;h=g;i=f;return h|0};case 36:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=46;h=g;i=f;return h|0};case 21:{c[e>>2]=39;g=49;h=g;i=f;return h|0};case 37:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=48;h=g;i=f;return h|0};default:{g=Xua(e,a)|0;h=g;i=f;return h|0}}return 0}function nva(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=39}else if((b|0)==41|(b|0)==18){c[e>>2]=42;g=51}else{g=Xua(e,a)|0}i=f;return g|0}function ova(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=39}else if((b|0)==36){c[e>>2]=33;c[e+8>>2]=39;g=46}else if((b|0)==21){c[e>>2]=41;g=39}else{g=Xua(e,a)|0}i=f;return g|0}function pva(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=33}else if((b|0)==15){g=33}else if((b|0)==41|(b|0)==18){c[e>>2]=43;g=22}else{g=Xua(e,a)|0}i=f;return g|0}function qva(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+56|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==18){j=0;while(1){k=c[e+28>>2]|0;l=e;m=b;n=d;if((j|0)>=8){break}if((Ne[k&63](l,m,n,c[203776+(j<<2)>>2]|0)|0)!=0){o=6;break}j=j+1|0}if((o|0)==6){c[h>>2]=44;p=23+j|0;q=p;i=g;return q|0}if((Ne[k&63](l,m,n,203720)|0)==0){break}c[h>>2]=45;p=33;q=p;i=g;return q|0}else if((f|0)==23){c[h>>2]=46;p=33;q=p;i=g;return q|0}else if((f|0)==15){p=33;q=p;i=g;return q|0}}while(0);p=Xua(h,a)|0;q=p;i=g;return q|0}function rva(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==20){if((Ne[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,203880)|0)!=0){c[h>>2]=27;j=35;k=j;i=g;return k|0}if((Ne[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,203888)|0)!=0){c[h>>2]=27;j=36;k=j;i=g;return k|0}if((Ne[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,203904)|0)==0){break}c[h>>2]=47;j=33;k=j;i=g;return k|0}else if((f|0)==27){c[h>>2]=27;j=37;k=j;i=g;return k|0}else if((f|0)==15){j=33;k=j;i=g;return k|0}}while(0);j=Xua(h,a)|0;k=j;i=g;return k|0}function sva(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==23){c[e>>2]=48;g=33}else if((b|0)==15){g=33}else{g=Xua(e,a)|0}i=f;return g|0}function tva(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==41|(b|0)==18|(b|0)==19){c[e>>2]=49;g=31}else{g=Xua(e,a)|0}i=f;return g|0}function uva(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==21){c[e>>2]=46;g=33}else if((b|0)==24){c[e>>2]=44;g=33}else if((b|0)==15){g=33}else{g=Xua(e,a)|0}i=f;return g|0}function vva(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==18){c[e>>2]=50;g=32}else{g=Xua(e,a)|0}i=f;return g|0}function wva(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==21){c[e>>2]=48;g=33}else if((b|0)==24){c[e>>2]=44;g=33}else if((b|0)==15){g=33}else{g=Xua(e,a)|0}i=f;return g|0}function xva(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=27;g=38}else if((b|0)==15){g=33}else{g=Xua(e,a)|0}i=f;return g|0}function yva(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==18){c[e>>2]=51;g=10}else{g=Xua(e,a)|0}i=f;return g|0}function zva(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==18){if((Ne[c[e+28>>2]&63](e,b,d,203736)|0)!=0){c[h>>2]=52;j=11;k=j;i=g;return k|0}if((Ne[c[e+28>>2]&63](e,b,d,203744)|0)==0){break}c[h>>2]=53;j=11;k=j;i=g;return k|0}else if((f|0)==27){c[h>>2]=33;c[h+8>>2]=11;j=12;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}}while(0);j=Xua(h,a)|0;k=j;i=g;return k|0}function Ava(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=54;g=13}else if((b|0)==15){g=11}else{g=Xua(e,a)|0}i=f;return g|0}function Bva(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==27){c[e>>2]=52;g=14}else{g=Xua(e,a)|0}i=f;return g|0}function Cva(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=11;k=j;i=g;return k|0}else if((f|0)==18){if((Ne[c[e+28>>2]&63](e,b,d,203912)|0)==0){break}c[h>>2]=55;j=11;k=j;i=g;return k|0}else if((f|0)==17){c[h>>2]=(c[h+16>>2]|0)!=0?35:36;j=15;k=j;i=g;return k|0}}while(0);j=Xua(h,a)|0;k=j;i=g;return k|0}function Dva(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=33;c[e+8>>2]=11;g=16}else if((b|0)==15){g=11}else{g=Xua(e,a)|0}i=f;return g|0}function Eva(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==27){c[h>>2]=33;c[h+8>>2]=11;j=12;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}else if((f|0)==18){if((Ne[c[e+28>>2]&63](e,b,d,203736)|0)!=0){c[h>>2]=56;j=11;k=j;i=g;return k|0}if((Ne[c[e+28>>2]&63](e,b,d,203744)|0)==0){break}c[h>>2]=57;j=11;k=j;i=g;return k|0}}while(0);j=Xua(h,a)|0;k=j;i=g;return k|0}function Fva(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=58;g=13}else if((b|0)==15){g=11}else{g=Xua(e,a)|0}i=f;return g|0}function Gva(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=56;g=14}else if((b|0)==15){g=11}else{g=Xua(e,a)|0}i=f;return g|0}function Hva(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11;h=g;i=f;return h|0}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=15;h=g;i=f;return h|0}else{g=Xua(e,a)|0;h=g;i=f;return h|0}return 0}function Iva(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=0;h=g;i=f;return h|0}else if((b|0)==25){c[e>>2]=36;b=e+12|0;c[b>>2]=(c[b>>2]|0)+1;g=0;h=g;i=f;return h|0}else{g=Xua(e,a)|0;h=g;i=f;return h|0}return 0}function Jva(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=0}else if((b|0)==25){c[e>>2]=36;g=58}else{g=Xua(e,a)|0}i=f;return g|0}function Kva(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 16:{if((Ne[c[b+28>>2]&63](b,d+(c[b+68>>2]<<1)|0,e,203936)|0)==0){j=9;break a}c[h>>2]=15;k=3;break};case 14:{k=0;break};case 29:{c[h>>2]=16;k=2;break};case 13:{k=56;break};case 15:{k=0;break};case 11:{k=55;break};default:{j=9}}}while(0);if((j|0)==9){k=Xua(h,a)|0}i=g;return k|0}function Lva(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==41|(b|0)==18){c[e>>2]=59;g=4}else{g=Xua(e,a)|0}i=f;return g|0}function Mva(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=3;k=j;i=g;return k|0}else if((f|0)==25){c[h>>2]=35;j=7;k=j;i=g;return k|0}else if((f|0)==18){if((Ne[c[e+28>>2]&63](e,b,d,203736)|0)!=0){c[h>>2]=60;j=3;k=j;i=g;return k|0}if((Ne[c[e+28>>2]&63](e,b,d,203744)|0)==0){break}c[h>>2]=61;j=3;k=j;i=g;return k|0}else if((f|0)==17){c[h>>2]=30;j=8;k=j;i=g;return k|0}}while(0);j=Xua(h,a)|0;k=j;i=g;return k|0}function Nva(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==27){c[e>>2]=62;g=5}else{g=Xua(e,a)|0}i=f;return g|0}function Ova(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=60;g=6}else if((b|0)==15){g=3}else{g=Xua(e,a)|0}i=f;return g|0}function Pva(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=30;g=8}else if((b|0)==25){c[e>>2]=35;g=7}else if((b|0)==15){g=3}else{g=Xua(e,a)|0}i=f;return g|0}function Qva(){i=i;return}function Rva(){i=i;return}function Sva(){var a=0;a=i;Xa(203944,0)|0;i=a;return}function Tva(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;if((a|0)==0){e=c[r>>2]|0;uc(203952,29,1,e|0)|0;Ad(e|0)|0;f=0;i=b;return f|0}e=c[a>>2]|0;if((e|0)<0){g=c[r>>2]|0;uc(203984,54,1,g|0)|0;Ad(g|0)|0;f=0;i=b;return f|0}g=c[a+4>>2]|0;if((g|0)==0){a=c[r>>2]|0;uc(204040,47,1,a|0)|0;Ad(a|0)|0;f=0;i=b;return f|0}if((e|0)>0){h=0}else{f=1;i=b;return f|0}while(1){j=c[g+(h<<2)>>2]|0;a=h+1|0;if((j|0)<0){break}if((a|0)<(e|0)){h=a}else{f=1;k=11;break}}if((k|0)==11){i=b;return f|0}k=c[r>>2]|0;c[d>>2]=h;c[d+4>>2]=j;Cd(k|0,204088,d|0)|0;Ad(k|0)|0;f=0;i=b;return f|0}function Uva(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;f=i;i=i+8|0;g=c[a>>2]|0;h=c[b>>2]|0;if((g|0)!=(h|0)){j=c[r>>2]|0;c[f>>2]=g;c[f+4>>2]=h;Cd(j|0,204176,f|0)|0;k=0;i=d;return k|0}if((g|0)<=0){k=1;i=d;return k|0}f=c[a+4>>2]|0;a=c[b+4>>2]|0;b=0;while(1){l=c[f+(b<<2)>>2]|0;m=c[a+(b<<2)>>2]|0;j=b+1|0;if((l|0)!=(m|0)){break}if((j|0)<(g|0)){b=j}else{k=1;n=8;break}}if((n|0)==8){i=d;return k|0}n=c[r>>2]|0;c[e>>2]=b;c[e+4>>2]=b;c[e+8>>2]=l;c[e+12>>2]=m;Cd(n|0,204208,e|0)|0;k=0;i=d;return k|0}function Vva(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;d=c[a>>2]|0;if((d|0)<=0){e=1;i=b;return e|0}f=c[a+4>>2]|0;a=0;g=1;while(1){h=fa(c[f+(a<<2)>>2]|0,g)|0;j=a+1|0;if((j|0)<(d|0)){g=h;a=j}else{e=h;break}}i=b;return e|0}function Wva(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;c[a>>2]=1;f=Dwa(1)|0;c[a+4>>2]=f;c[f>>2]=b;c[a+8>>2]=d;i=e;return}function Xva(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;c[a>>2]=b;f=a+4|0;c[f>>2]=Dwa(b)|0;if((b|0)>0){g=0;h=1}else{j=1;i=e;return j|0}while(1){a=c[d>>2]|0;k=c[a>>2]|0;c[d>>2]=a+4;c[(c[f>>2]|0)+(g<<2)>>2]=k;a=fa(k,h)|0;k=g+1|0;if((k|0)<(b|0)){h=a;g=k}else{j=a;break}}i=e;return j|0}function Yva(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+40|0;f=e;g=e+24|0;if((b|0)<=0){h=0;i=e;return h|0}j=a+4|0;a=0;k=0;while(1){l=c[d>>2]|0;m=c[l>>2]|0;c[d>>2]=l+4;l=c[(c[j>>2]|0)+(a<<2)>>2]|0;if((m|0)<1|(m|0)>(l|0)){n=c[63880]|0;o=a+1|0;c[g>>2]=o;c[g+4>>2]=l;c[g+8>>2]=m;p=n;n=f;q=204264;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];Oe[p&127](0,f,204288,g);r=o;s=c[(c[j>>2]|0)+(a<<2)>>2]|0}else{r=a+1|0;s=l}l=m+ -1+(fa(s,k)|0)|0;if((r|0)<(b|0)){a=r;k=l}else{h=l;break}}i=e;return h|0}function Zva(a,b){a=a|0;b=b|0;var d=0;d=i;if((Tva(a)|0)==0){db(204344,204152,347,204368)}do{if((b|0)>0){if((c[a>>2]|0)<(b|0)){break}i=d;return c[(c[a+4>>2]|0)+(b+ -1<<2)>>2]|0}}while(0);db(204400,204152,348,204368);return 0}function _va(){var a=0,b=0,d=0;a=i;b=206144|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));b=206256|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));b=206368|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));c[206148>>2]=1;c[206152>>2]=1;i=a;return}function $va(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+24|0;e=d;f=c[b+4>>2]|0;g=c[b+8>>2]|0;h=c[b+12>>2]|0;j=c[b+16>>2]|0;k=(c[b+20>>2]|0)!=0?206504:206520;c[e>>2]=c[b>>2];c[e+4>>2]=f;c[e+8>>2]=g;c[e+12>>2]=h;c[e+16>>2]=j;c[e+20>>2]=k;Cd(a|0,206480,e|0)|0;i=d;return}function awa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=206368+(d<<2)|0;o=206256+(d<<2)|0;p=206568+(b<<2)|0;q=204848+(d<<2)|0;r=e;e=f;f=(g|0)!=0;a:while(1){b:do{if(f){c[l>>2]=206552;kc(206536,l|0)|0;s=206552}else{if((c[51532]|0)==(d|0)){if((c[o>>2]|0)>0){t=206552}else{u=5}}else{u=5}if((u|0)==5){u=0;t=c[q>>2]|0}c[m>>2]=t;kc(206536,m|0)|0;do{if((c[51532]|0)==(d|0)){if((c[n>>2]|0)!=(b|0)){break}if((c[o>>2]|0)>0){s=206552;break b}}}while(0);s=c[p>>2]|0}}while(0);c[k>>2]=s;kc(206560,k|0)|0;c[n>>2]=b;c[51532]=d;if((c[o>>2]|0)>0){g=0;while(1){kc(206592,j|0)|0;v=g+1|0;if((v|0)<(c[o>>2]|0)){g=v}else{w=0;break}}}else{w=0}while(1){x=e+w|0;g=a[x]|0;if(g<<24>>24==10){break}else if(g<<24>>24==0){break a}w=w+1|0}a[x]=0;wb(e|0)|0;r=0;e=e+(w+1)|0;f=1}wb(e|0)|0;Ad(0)|0;if((r|0)==0){i=h;return}c[o>>2]=(c[o>>2]|0)+1;i=h;return}function bwa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+8|0;h=f;j=i;i=i+8|0;k=c[206568+(a<<2)>>2]|0;c[j>>2]=c[204848+(b<<2)>>2];c[j+4>>2]=k;kc(206600,j|0)|0;cwa(e);if((g|0)==0){Qd(((d|0)!=0?206640:206688)|0,c[t>>2]|0)|0;l=t;m=c[t>>2]|0;n=Ad(m|0)|0;i=f;return}wb(206768)|0;if((c[g>>2]|0)>=1){e=1;while(1){c[h>>2]=c[g+(e<<2)>>2];kc(206648,h|0)|0;if((e|0)<(c[g>>2]|0)){e=e+1|0}else{break}}}if((d|0)!=0){l=t;m=c[t>>2]|0;n=Ad(m|0)|0;i=f;return}uc(206672,11,1,c[t>>2]|0)|0;l=t;m=c[t>>2]|0;n=Ad(m|0)|0;i=f;return}function cwa(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[t>>2]|0;f=b;while(1){b=a[f]|0;if(b<<24>>24==62){uc(206728,4,1,e|0)|0}else if(b<<24>>24==60){uc(206720,4,1,e|0)|0}else if(b<<24>>24==38){uc(206712,5,1,e|0)|0}else if(b<<24>>24==0){break}else{Yd(b<<24>>24|0,e|0)|0}f=f+1|0}i=d;return}function dwa(a){a=a|0;var b=0;b=206256+(a<<2)|0;c[b>>2]=(c[b>>2]|0)+ -1;i=i;return}function ewa(a){a=a|0;var b=0;b=(a|0)==0;c[51676]=b?1:19;c[51674]=b?7:1254;i=i;return}function fwa(a){a=a|0;var b=0;a=i;b=c[t>>2]|0;uc(206672,11,1,b|0)|0;Ad(b|0)|0;i=a;return}function gwa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;i=i+2064|0;h=g+2048|0;if((c[206144+(a<<2)>>2]|0)==0){i=g;return}j=g;c[h>>2]=f;bd(j|0,2048,e|0,h|0)|0;xe[c[51676]&31](1,a,b,j,0,d);i=g;return}function hwa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+2064|0;g=f+2048|0;if((c[206144+(a<<2)>>2]|0)==0){i=f;return}h=f;c[g>>2]=e;bd(h|0,2048,d|0,g|0)|0;xe[c[51676]&31](1,a,b,h,0,0);i=f;return}function iwa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+2064|0;h=g;j=g+2048|0;do{if((c[51534]|0)==0){if((c[206144+(a<<2)>>2]|0)!=0){break}i=g;return}}while(0);k=h;c[j>>2]=f;bd(k|0,2048,e|0,j|0)|0;xe[c[51676]&31](2,a,b,k,0,d);i=g;return}function jwa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+2064|0;g=f;h=f+2048|0;do{if((c[51534]|0)==0){if((c[206144+(a<<2)>>2]|0)!=0){break}i=f;return}}while(0);j=g;c[h>>2]=e;bd(j|0,2048,d|0,h|0)|0;xe[c[51676]&31](2,a,b,j,0,0);i=f;return}function kwa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+2064|0;g=f+2048|0;if((b|0)!=0){i=f;return}b=f;c[g>>2]=e;bd(b|0,2048,d|0,g|0)|0;xe[c[51676]&31](4,2,0,b,0,0);if((a|0)==0){h=rd(c[50986]|0)|0}else{h=a}fb(c[h+76>>2]|0,1)}function lwa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+2064|0;f=e+2048|0;g=e;c[f>>2]=d;bd(g|0,2048,b|0,f|0)|0;xe[c[51676]&31](5,2,0,g,0,0);if((a|0)==0){h=rd(c[50986]|0)|0}else{h=a}fb(c[h+76>>2]|0,1)}function mwa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+2064|0;g=f+2048|0;h=f;c[g>>2]=e;bd(h|0,2048,d|0,g|0)|0;xe[c[51676]&31](5,2,0,h,0,b);if((a|0)==0){j=rd(c[50986]|0)|0}else{j=a}fb(c[j+76>>2]|0,1)}function nwa(a,b,d,e,f,g){a=a|0;b=+b;d=d|0;e=e|0;f=+f;g=g|0;var j=0,l=0,m=0;j=i;i=i+16|0;l=j;m=i;i=i+16|0;if(g<<24>>24==0){g=l;h[k>>3]=f;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[l+8>>2]=d;mwa(a,e,206840,l)}else{l=m;h[k>>3]=f;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];c[m+8>>2]=d;iwa(26,0,e,206776,m);i=j;return+b}return 0.0}function owa(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=V_a(16)|0;kwa(0,(d|0)!=0|0,206888,b);c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=a;c[d+12>>2]=0;i=b;return d|0}function pwa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((a|0)==0){i=b;return}d=a;e=c[d>>2]|0;if((e|0)!=0){f=e;while(1){e=c[f+4>>2]|0;W_a(c[f>>2]|0);W_a(f);if((e|0)==0){break}else{f=e}}}c[a+12>>2]=0;c[d>>2]=0;c[a+4>>2]=0;i=b;return}function qwa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;kwa(0,(a|0)!=0|0,206904,f);f=V_a(8)|0;g=f;kwa(0,(f|0)!=0|0,206888,e);e=a+8|0;h=V_a(c[e>>2]|0)|0;c[f>>2]=h;kwa(0,(h|0)!=0|0,206888,d);z$a(c[f>>2]|0,b|0,c[e>>2]|0)|0;e=a;c[f+4>>2]=c[e>>2];f=a+12|0;c[f>>2]=(c[f>>2]|0)+1;c[e>>2]=g;e=a+4|0;if((c[e>>2]|0)!=0){i=d;return}c[e>>2]=g;i=d;return}function rwa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;kwa(0,(a|0)!=0|0,206904,f);f=V_a(8)|0;g=f;kwa(0,(f|0)!=0|0,206888,e);e=a+8|0;h=V_a(c[e>>2]|0)|0;c[f>>2]=h;kwa(0,(h|0)!=0|0,206888,d);z$a(c[f>>2]|0,b|0,c[e>>2]|0)|0;c[f+4>>2]=0;f=a+12|0;c[f>>2]=(c[f>>2]|0)+1;f=a+4|0;e=c[f>>2]|0;if((e|0)!=0){c[e+4>>2]=g}c[f>>2]=g;f=a;if((c[f>>2]|0)!=0){i=d;return}c[f>>2]=g;i=d;return}function swa(a){a=a|0;var b=0;b=i;i=i+8|0;kwa(0,(a|0)!=0|0,206904,b);i=b;return c[a+12>>2]|0}function twa(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;kwa(0,(a|0)!=0|0,206904,d);d=a;kwa(0,(c[d>>2]|0)!=0|0,206928,b);i=b;return c[c[d>>2]>>2]|0}function uwa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((a|0)==0){i=b;return}d=a;e=c[d>>2]|0;if((e|0)==0){i=b;return}f=c[e+4>>2]|0;W_a(c[e>>2]|0);W_a(c[d>>2]|0);c[d>>2]=f;d=a+12|0;c[d>>2]=(c[d>>2]|0)+ -1;if((f|0)!=0){i=b;return}c[a+4>>2]=0;i=b;return}function vwa(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;kwa(0,(a|0)!=0|0,206904,d);d=a;kwa(0,(c[d>>2]|0)!=0|0,206944,b);i=b;return c[d>>2]|0}function wwa(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=(a|0)!=0;kwa(0,d&1,206976,b);if(!d){e=0;i=b;return e|0}e=c[a+4>>2]|0;i=b;return e|0}function xwa(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;kwa(0,(a|0)!=0|0,206976,d);d=a;kwa(0,(c[d>>2]|0)!=0|0,207e3,b);i=b;return c[d>>2]|0}function ywa(){var a=0,b=0,d=0;a=i;b=V_a(16)|0;c[51768]=b;c[b+4>>2]=0;c[b+8>>2]=2097152;d=V_a(2097152)|0;c[b>>2]=d;c[b+12>>2]=0;i=a;return}function zwa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=Ewa(a)|0;wc(207080)|0;Fwa(d);a=c[51768]|0;e=a+4|0;f=c[e>>2]|0;g=(c[a>>2]|0)+f|0;c[e>>2]=f+d;jc(207080)|0;B$a(g|0,0,d|0)|0;i=b;return g|0}function Awa(){var a=0,b=0,d=0,e=0;a=i;b=c[51768]|0;d=c[b+12>>2]|0;if((d|0)==0){e=b}else{b=d;while(1){d=c[b+12>>2]|0;W_a(c[b>>2]|0);W_a(b);if((d|0)==0){break}else{b=d}}e=c[51768]|0}c[e+4>>2]=0;c[e+12>>2]=0;i=a;return 0}function Bwa(a){a=a|0;var b=0,d=0;b=i;d=oe[c[207032>>2]&127](a<<3)|0;i=b;return d|0}function Cwa(a){a=a|0;var b=0,d=0;b=i;d=oe[c[207032>>2]&127](a<<2)|0;i=b;return d|0}function Dwa(a){a=a|0;var b=0,d=0;b=i;d=oe[c[207032>>2]&127](a<<2)|0;i=b;return d|0}function Ewa(a){a=a|0;i=i;return a+7&-8|0}function Fwa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[51768]|0;e=d+8|0;if(!(((c[e>>2]|0)-(c[d+4>>2]|0)|0)>>>0<a>>>0)){i=b;return}f=V_a(16)|0;c[f+12>>2]=d;c[51768]=f;c[f+4>>2]=0;d=Gwa((((c[e>>2]|0)*3|0)>>>1)+a|0)|0;c[f+8>>2]=d;a=V_a(d)|0;c[f>>2]=a;i=b;return}function Gwa(a){a=a|0;var b=0;b=a+ -1|0;a=b>>>1|b;b=a>>>2|a;a=b>>>4|b;b=a>>>8|a;i=i;return(b>>>16|b)+1|0}function Hwa(a){a=a|0;var b=0,c=0;b=i;c=x$a(a|0)|0;i=b;return c|0}function Iwa(b,d){b=+b;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0;e=i;i=i+8|0;f=e;g=i;i=i+40|0;j=i;i=i+400|0;l=g;m=j;a[l]=37;D$a(g+1|0,d|0)|0;d=f;h[k>>3]=b;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];lc(m|0,l|0,f|0)|0;f=Jwa(m)|0;i=e;return f|0}function Jwa(a){a=a|0;var b=0,c=0,d=0;b=i;c=x$a(a|0)|0;d=Nwa(c)|0;z$a(d|0,a|0,c|0)|0;i=b;return d|0}function Kwa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+8|0;f=e;g=i;i=i+40|0;h=i;i=i+400|0;j=g;k=h;a[j]=37;D$a(g+1|0,d|0)|0;c[f>>2]=b;lc(k|0,j|0,f|0)|0;f=Jwa(k)|0;i=e;return f|0}function Lwa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+8|0;g=f;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+40|0;l=i;i=i+400|0;m=k;n=l;a[m]=37;l=k+1|0;if(e<<24>>24==0){c[h>>2]=d;lc(l|0,207112,h|0)|0;o=g;p=o;c[p>>2]=b;q=39;r=q;s=lc(n|0,m|0,g|0)|0;t=Jwa(n)|0;i=f;return t|0}else{c[j>>2]=d;lc(l|0,207104,j|0)|0;o=g;p=o;c[p>>2]=b;q=39;r=q;s=lc(n|0,m|0,g|0)|0;t=Jwa(n)|0;i=f;return t|0}return 0}function Mwa(b,d,e,f){b=+b;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+8|0;j=g;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+40|0;o=i;i=i+400|0;p=n;q=o;a[p]=37;o=n+1|0;if(e<<24>>24==0){c[l>>2]=d;c[l+4>>2]=f;lc(o|0,207128,l|0)|0}else{c[m>>2]=d;c[m+4>>2]=f;lc(o|0,207120,m|0)|0}m=j;h[k>>3]=b;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];lc(q|0,p|0,j|0)|0;j=Jwa(q)|0;i=g;return j|0}function Nwa(b){b=b|0;var d=0,e=0;d=i;e=oe[c[207036>>2]&127](b+1|0)|0;if((e|0)==0){i=d;return e|0}a[e+b|0]=0;i=d;return e|0}function Owa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=i;d=Hwa(a)|0;e=Hwa(b)|0;f=Nwa(e+d|0)|0;z$a(f|0,a|0,d|0)|0;z$a(f+d|0,b|0,e|0)|0;i=c;return f|0}function Pwa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=t$a(c[a>>2]|0,c[b>>2]|0)|0;i=d;return e|0}function Qwa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;b=i;c=(a|0)%100|0;d=(c|0)/10|0;e=(a|0)%10|0;a:do{if((a+999|0)>>>0>1998){f=-1}else{if((((a|0)%1e3|0)+99|0)>>>0>198){f=-1;break}if((e|0)==2){f=-1;break}else if((e|0)==1){if((c+ -50|0)>>>0>9){f=-1;break}}switch(d|0){case 0:{f=8;break a;break};case 4:{f=2;break a;break};case 3:{f=2;break a;break};case 5:{f=1;break a;break};case 1:{f=4;break a;break};case 2:{f=4;break a;break};default:{f=-1;break a}}}}while(0);i=b;return f|0}function Rwa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a;e=c[d>>2]|0;if((e|0)!=0){ad(e|0)|0;c[d>>2]=0}e=a+4|0;f=c[e>>2]|0;if((f|0)!=0){W_a(f);c[e>>2]=0}e=a+8|0;if((c[e>>2]|0)!=0){f=a+12|0;g=0;do{W_a(c[(c[f>>2]|0)+(g<<4)>>2]|0);W_a(c[(c[f>>2]|0)+(g<<4)+4>>2]|0);g=g+1|0;}while(g>>>0<(c[e>>2]|0)>>>0)}c[e>>2]=0;if((c[d>>2]|0)!=0){d=a+12|0;W_a(c[d>>2]|0);c[d>>2]=0}d=a+20|0;e=c[d>>2]|0;if((e|0)!=0){W_a(e);c[d>>2]=0}d=a+24|0;e=c[d>>2]|0;g=a+40|0;if((e&2147483647|0)!=0){a=e;e=0;while(1){f=c[(c[g>>2]|0)+(e<<2)>>2]|0;if((f|0)==0){h=a}else{W_a(f);h=c[d>>2]|0}f=e+1|0;if(f>>>0<h<<1>>>0){a=h;e=f}else{break}}}c[d>>2]=0;d=c[g>>2]|0;if((d|0)==0){i=b;return}W_a(d);c[g>>2]=0;i=b;return}function Swa(b){b=b|0;var c=0,d=0,e=0,f=0,g=0;c=i;d=0;e=0;while(1){f=a[b+d|0]|0;if(f<<24>>24==32){g=e}else{a[b+e|0]=f;g=e+1|0}f=d+1|0;if(f>>>0>(x$a(b|0)|0)>>>0){break}else{d=f;e=g}}i=c;return}function Twa(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+88|0;f=e;j=e+24|0;k=e+72|0;l=d+0|0;m=l+48|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(m|0));l=mc(b|0,207296)|0;m=d;c[m>>2]=l;if((l|0)==0){n=ae(c[(Qc()|0)>>2]|0)|0;i=e;return n|0}c[d+4>>2]=Gd(b|0)|0;c[d+36>>2]=0;b=f;l=d+44|0;o=f;p=f+12|0;q=f+16|0;r=f+4|0;s=f+8|0;f=j;t=k;u=d+8|0;v=d+12|0;w=d+16|0;x=d+20|0;y=d+28|0;z=d+24|0;A=d+32|0;B=d+40|0;d=1;C=0;a:while(1){D=vb(b|0,20,1,c[m>>2]|0)|0;a[l]=1;if((D|0)!=1){n=207304;E=131;break}D=c[o>>2]|0;if((D|0)!=(c[207272+(C<<2)>>2]|0)){if(!((C|0)>3&(D|0)==10)){n=207328;E=131;break}a[l]=0}F=c[p>>2]|0;if(F>>>0>1){n=207352;E=131;break}G=Qwa(D)|0;if((G|0)==-1){n=207384;E=131;break}D=c[q>>2]|0;H=V_a(D)|0;if((vb(H|0,D|0,1,c[m>>2]|0)|0)!=1){n=207432;E=131;break}if((a[H+(D+ -1)|0]|0)!=0){n=207456;E=131;break}D=c[r>>2]|0;I=c[s>>2]|0;J=fa(fa(fa(D,G)|0,I)|0,F+1|0)|0;if((t$a(H,c[207248+(C<<2)>>2]|0)|0)!=0){n=207480;E=131;break}W_a(H);H=208056;b:do{switch(C|0){case 4:{if(d<<24>>24==1){if((D|0)==0){n=207744;E=131;break a}if(!((I+ -1|0)>>>0<2)){n=207800;E=131;break a}c[w>>2]=D;F=fa(I,D)|0;if((a[l]|0)==1){G=V_a(F<<3)|0;c[x>>2]=G;if((vb(G|0,J|0,1,c[m>>2]|0)|0)!=1){n=207840;E=131;break a}}else{G=V_a(F<<2)|0;c[x>>2]=V_a(fa(D<<3,I)|0)|0;if((vb(G|0,J|0,1,c[m>>2]|0)|0)!=1){n=207840;E=131;break a}if((F|0)!=0){K=c[x>>2]|0;L=0;do{h[K+(L<<3)>>3]=+g[G+(L<<2)>>2];L=L+1|0;}while(L>>>0<F>>>0)}W_a(G)}F=c[w>>2]|0;if(!(F>>>0>1)){M=1;E=130;break b}L=(I|0)==2;K=1;while(1){if(L){N=c[x>>2]|0;if(+h[N+(K<<3)>>3]!=+h[N+(F+K<<3)>>3]){n=207872;E=131;break a}}N=K+1|0;if(N>>>0<F>>>0){K=N}else{M=1;E=130;break b}}}else if(!(d<<24>>24==0)){O=d;E=129;break b}if((I|0)==0){n=207744;E=131;break a}if(!((D+ -1|0)>>>0<2)){n=207952;E=131;break a}c[w>>2]=I;K=fa(I,D)|0;if((a[l]|0)==1){F=V_a(K<<3)|0;c[x>>2]=V_a(fa(D<<3,I)|0)|0;if((vb(F|0,J|0,1,c[m>>2]|0)|0)!=1){n=207840;E=131;break a}if((D|0)!=0){L=0;do{G=c[x>>2]|0;N=0;do{h[G+((fa(I,L)|0)+N<<3)>>3]=+h[F+((fa(D,N)|0)+L<<3)>>3];N=N+1|0;}while(N>>>0<I>>>0);L=L+1|0;}while(L>>>0<D>>>0)}W_a(F)}else{L=V_a(K<<2)|0;c[x>>2]=V_a(fa(D<<3,I)|0)|0;if((vb(L|0,J|0,1,c[m>>2]|0)|0)!=1){n=207840;E=131;break a}if((D|0)!=0){N=0;do{G=c[x>>2]|0;P=0;do{h[G+((fa(I,N)|0)+P<<3)>>3]=+g[L+((fa(D,P)|0)+N<<2)>>2];P=P+1|0;}while(P>>>0<I>>>0);N=N+1|0;}while(N>>>0<D>>>0)}W_a(L)}N=c[w>>2]|0;if(!(N>>>0>1)){M=d;E=130;break b}K=(D|0)==2;F=1;while(1){if(K){P=c[x>>2]|0;if(+h[P+(F<<3)>>3]!=+h[P+(N+F<<3)>>3]){n=207872;E=131;break a}}P=F+1|0;if(P>>>0<N>>>0){F=P}else{M=d;E=130;break}}break};case 2:{if(d<<24>>24==1){if((I|0)==0){O=1;E=129;break b}F=D+1|0;N=0;while(1){K=V_a(F)|0;c[(c[v>>2]|0)+(N<<4)+4>>2]=K;if((vb(c[(c[v>>2]|0)+(N<<4)+4>>2]|0,D|0,1,c[m>>2]|0)|0)!=1){n=207680;E=131;break a}a[(c[(c[v>>2]|0)+(N<<4)+4>>2]|0)+D|0]=0;K=N+1|0;if(K>>>0<I>>>0){N=K}else{M=1;E=130;break b}}}else if(!(d<<24>>24==0)){O=d;E=129;break b}N=fa(D,I)|0;Q=V_a(N+1|0)|0;if((vb(Q|0,N|0,1,c[m>>2]|0)|0)!=1){E=46;break a}if((D|0)!=0){N=I+1|0;F=(I|0)==0;K=0;do{L=V_a(N)|0;c[(c[v>>2]|0)+(K<<4)+4>>2]=L;if(!F){L=0;do{P=a[Q+((fa(D,L)|0)+K)|0]|0;a[(c[(c[v>>2]|0)+(K<<4)+4>>2]|0)+L|0]=P;L=L+1|0;}while(L>>>0<I>>>0)}a[(c[(c[v>>2]|0)+(K<<4)+4>>2]|0)+I|0]=0;K=K+1|0;}while(K>>>0<D>>>0)}W_a(Q);M=0;E=130;break};case 5:{if(d<<24>>24==1){c[y>>2]=I;if(I>>>0<2){n=207992;E=131;break a}c[z>>2]=D;c[A>>2]=Bb(c[m>>2]|0)|0;c[B>>2]=X_a(c[z>>2]<<1,4)|0;if((Zc(c[m>>2]|0,J|0,1)|0)==-1){n=208024;E=131;break a}else{M=1;E=130;break b}}else if(!(d<<24>>24==0)){n=0;E=131;break a}c[y>>2]=D;if(D>>>0<2){n=207992;E=131;break a}c[z>>2]=I;c[A>>2]=Bb(c[m>>2]|0)|0;c[B>>2]=X_a(c[z>>2]<<1,4)|0;K=fa(I,D)|0;if((a[l]|0)==1){F=V_a(K<<3)|0;if((vb(F|0,J|0,1,c[m>>2]|0)|0)!=1){n=208024;E=131;break a}if((I|0)!=0){N=D<<3;L=(D|0)==0;P=D<<3;G=0;do{R=V_a(N)|0;c[(c[B>>2]|0)+(G<<2)>>2]=R;if(!L){R=F+(fa(P,G)|0)|0;z$a(c[(c[B>>2]|0)+(G<<2)>>2]|0,R|0,P|0)|0}G=G+1|0;}while(G>>>0<I>>>0)}G=c[z>>2]|0;P=G<<1;if(G>>>0<P>>>0){L=D<<3;N=(D|0)==0;R=G;do{S=V_a(L)|0;c[(c[B>>2]|0)+(R<<2)>>2]=S;if(!N){S=c[B>>2]|0;T=c[S+(R-G<<2)>>2]|0;U=c[S+(R<<2)>>2]|0;S=0;do{h[U+(S<<3)>>3]=-+h[T+(S<<3)>>3];S=S+1|0;}while(S>>>0<D>>>0)}R=R+1|0;}while(R>>>0<P>>>0)}W_a(F)}else{P=V_a(K<<2)|0;if((vb(P|0,J|0,1,c[m>>2]|0)|0)!=1){n=208024;E=131;break a}if((I|0)!=0){R=D<<3;G=(D|0)==0;N=0;do{L=V_a(R)|0;c[(c[B>>2]|0)+(N<<2)>>2]=L;if(!G){L=c[(c[B>>2]|0)+(N<<2)>>2]|0;S=0;do{h[L+(S<<3)>>3]=+g[P+((fa(D,N)|0)+S<<2)>>2];S=S+1|0;}while(S>>>0<D>>>0)}N=N+1|0;}while(N>>>0<I>>>0)}N=c[z>>2]|0;G=N<<1;if(N>>>0<G>>>0){R=D<<3;K=(D|0)==0;F=N;do{S=V_a(R)|0;c[(c[B>>2]|0)+(F<<2)>>2]=S;if(!K){S=c[B>>2]|0;L=c[S+(F-N<<2)>>2]|0;T=c[S+(F<<2)>>2]|0;S=0;do{h[T+(S<<3)>>3]=-+h[L+(S<<3)>>3];S=S+1|0;}while(S>>>0<D>>>0)}F=F+1|0;}while(F>>>0<G>>>0)}W_a(P)}if((Zc(c[m>>2]|0,J|0,1)|0)==-1){n=208024;E=131;break a}else{M=d;E=130}break};case 3:{G=fa(I<<2,D)|0;V=V_a(G)|0;if((vb(V|0,G|0,1,c[m>>2]|0)|0)!=1){E=52;break a}do{if(d<<24>>24==1){if((I|0)==0){break}G=c[v>>2]|0;F=0;do{N=fa(D,F)|0;c[G+(F<<4)+8>>2]=(c[V+(N<<2)>>2]|0)==1;c[G+(F<<4)+12>>2]=c[V+(N+1<<2)>>2];F=F+1|0;}while(F>>>0<I>>>0)}else if(d<<24>>24==0){if((D|0)==0){break}F=c[v>>2]|0;G=0;do{c[F+(G<<4)+8>>2]=(c[V+(G<<2)>>2]|0)==1;c[F+(G<<4)+12>>2]=c[V+(D+G<<2)>>2];G=G+1|0;}while(G>>>0<D>>>0)}}while(0);W_a(V);gc(c[v>>2]|0,c[u>>2]|0,16,54);M=d;E=130;break};case 0:{if((D|0)!=4){n=207504;E=131;break a}if((I|0)!=11){n=207544;E=131;break a}if((vb(f|0,44,1,c[m>>2]|0)|0)==1){W=0}else{n=207584;E=131;break a}while(1){P=0;do{a[k+P|0]=a[j+((P<<2)+W)|0]|0;P=P+1|0;}while(P>>>0<11);a[k+11|0]=0;if((W|0)==3){break}P=W+1|0;if(P>>>0<4){W=P}else{M=d;E=130;break b}}if((u$a(t,c[51788]|0,8)|0)==0){M=1;E=130;break b}if((u$a(t,c[51794]|0,9)|0)==0){M=0;E=130}else{n=207616;E=131;break a}break};case 1:{P=d<<24>>24==0;c[u>>2]=P?D:I;G=V_a((P?D:I)<<4)|0;c[v>>2]=G;c:do{if(d<<24>>24==1){if((I|0)==0){X=0;break}F=D+1|0;N=G;K=0;while(1){c[N+(K<<4)>>2]=V_a(F)|0;if((vb(c[(c[v>>2]|0)+(K<<4)>>2]|0,D|0,1,c[m>>2]|0)|0)!=1){n=207680;E=131;break a}a[(c[(c[v>>2]|0)+(K<<4)>>2]|0)+D|0]=0;R=c[v>>2]|0;c[R+(K<<4)+8>>2]=-1;c[R+(K<<4)+12>>2]=-1;Swa(c[R+(K<<4)>>2]|0);R=K+1|0;if(!(R>>>0<I>>>0)){X=I;break c}N=c[v>>2]|0;K=R}}else{X=I}}while(0);if(!P){M=d;E=130;break b}G=fa(D,X)|0;Y=V_a(G+1|0)|0;if((vb(Y|0,G|0,1,c[m>>2]|0)|0)!=1){E=33;break a}if((D|0)!=0){G=X+1|0;K=(X|0)==0;N=0;do{F=V_a(G)|0;c[(c[v>>2]|0)+(N<<4)>>2]=F;if(!K){F=0;do{R=a[Y+((fa(D,F)|0)+N)|0]|0;a[(c[(c[v>>2]|0)+(N<<4)>>2]|0)+F|0]=R;F=F+1|0;}while(F>>>0<X>>>0)}a[(c[(c[v>>2]|0)+(N<<4)>>2]|0)+X|0]=0;F=c[v>>2]|0;c[F+(N<<4)+8>>2]=-1;c[F+(N<<4)+12>>2]=-1;Swa(c[F+(N<<4)>>2]|0);N=N+1|0;}while(N>>>0<D>>>0)}W_a(Y);M=0;E=130;break};default:{n=H;E=131;break a}}}while(0);if((E|0)==129){E=0;d=O;C=C+1|0;continue}else if((E|0)==130){E=0;H=C+1|0;if((H|0)<6){d=M;C=H;continue}else{n=0;E=131;break}}}if((E|0)==33){W_a(Y);n=207680;i=e;return n|0}else if((E|0)==46){W_a(Q);n=207680;i=e;return n|0}else if((E|0)==52){W_a(V);n=207712;i=e;return n|0}else if((E|0)==131){i=e;return n|0}return 0}function Uwa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;b=Kd(e|0,c[a+12>>2]|0,c[a+8>>2]|0,16,54)|0;i=d;return b|0}function Vwa(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;f=(d|0)>-1?d:0-d|0;j=(d|0)<0;do{if(j){k=c[b+24>>2]|0;l=k+f|0;m=k}else{if((d|0)==0){n=208096;o=n;p=208144;q=p;r=208168;s=r;db(o|0,q|0,399,s|0)}else{l=f;m=c[b+24>>2]|0;break}}}while(0);d=l+ -1|0;l=b+24|0;if(f>>>0>m>>>0){n=208096;o=n;p=208144;q=p;r=208168;s=r;db(o|0,q|0,399,s|0)}s=b+40|0;q=c[(c[s>>2]|0)+(d<<2)>>2]|0;if((q|0)!=0){t=q;i=e;return t|0}q=b+28|0;o=c[q>>2]|0;r=V_a(o<<3)|0;p=r;a:do{if((a[b+44|0]|0)==1){if((o|0)==0){break}n=b;m=b+32|0;k=0;while(1){Zc(c[n>>2]|0,(c[m>>2]|0)+ -8+((fa(c[l>>2]|0,k)|0)+f<<3)|0,0)|0;u=r+(k<<3)|0;if((vb(u|0,8,1,c[n>>2]|0)|0)!=1){break}if(j){h[u>>3]=-+h[u>>3]}k=k+1|0;if(!(k>>>0<(c[q>>2]|0)>>>0)){break a}}W_a(r);t=0;i=e;return t|0}else{k=V_a(o<<2)|0;b:do{if((o|0)==0){v=0}else{n=b;m=b+32|0;u=0;while(1){Zc(c[n>>2]|0,(c[m>>2]|0)+ -4+((fa(c[l>>2]|0,u)|0)+f<<2)|0,0)|0;w=u+1|0;if((vb(k+(u<<2)|0,4,1,c[n>>2]|0)|0)!=1){break}x=c[q>>2]|0;if(w>>>0<x>>>0){u=w}else{v=x;break b}}W_a(k);W_a(r);t=0;i=e;return t|0}}while(0);u=(v|0)==0;do{if(j){if(u){break}else{y=0}do{h[r+(y<<3)>>3]=-+g[k+(y<<2)>>2];y=y+1|0;}while(y>>>0<v>>>0)}else{if(u){break}else{z=0}do{h[r+(z<<3)>>3]=+g[k+(z<<2)>>2];z=z+1|0;}while(z>>>0<v>>>0)}}while(0);W_a(k)}}while(0);c[(c[s>>2]|0)+(d<<2)>>2]=p;t=c[(c[s>>2]|0)+(d<<2)>>2]|0;i=e;return t|0}function Wwa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0;j=i;i=i+8|0;k=j;l=(e|0)>-1?e:0-e|0;m=(e|0)<0;do{if(m){n=c[d+24>>2]|0;o=n+l|0;p=n}else{if((e|0)==0){q=208096;r=q;s=208144;t=s;u=208192;v=u;db(r|0,t|0,519,v|0)}else{o=l;p=c[d+24>>2]|0;break}}}while(0);if(l>>>0>p>>>0){q=208096;r=q;s=208144;t=s;u=208192;v=u;db(r|0,t|0,519,v|0)}v=c[(c[d+40>>2]|0)+(o+ -1<<2)>>2]|0;if((v|0)!=0){h[b>>3]=+h[v+(f<<3)>>3];w=0.0;i=j;return+w}v=d;o=c[v>>2]|0;t=c[d+32>>2]|0;r=l+ -1+(fa(p,f)|0)|0;do{if((a[d+44|0]|0)==1){Zc(o|0,t+(r<<3)|0,0)|0;f=(vb(b|0,8,1,c[v>>2]|0)|0)!=1;if(f|m^1){w=f?1.0:0.0;i=j;return+w}else{x=+h[b>>3];break}}else{Zc(o|0,t+(r<<2)|0,0)|0;if((vb(k|0,4,1,c[v>>2]|0)|0)!=1){w=1.0;i=j;return+w}y=+g[k>>2];h[b>>3]=y;if(m){x=y;break}else{w=0.0}i=j;return+w}}while(0);h[b>>3]=-x;w=0.0;i=j;return+w}function Xwa(a,b,d,e,f,g,j){a=+a;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0;k=i;l=d+ -1|0;d=0;while(1){m=((l-d|0)/2|0)+d|0;n=+h[b+(m<<3)>>3];if(n==a){o=n;p=m;q=3;break}r=n<a;s=r?m+1|0:d;t=r?l:m+ -1|0;if((t|0)>(s|0)){l=t;d=s}else{break}}if((q|0)==3){while(1){q=0;if((p|0)>=(l|0)){break}d=p+1|0;n=+h[b+(d<<3)>>3];if(o==n){o=n;p=d;q=3}else{break}}c[e>>2]=p;h[f>>3]=1.0;c[g>>2]=-1;u=0.0;h[j>>3]=u;i=k;return}do{if((t|0)==(s|0)){if(+h[b+(s<<3)>>3]<a){v=s+1|0;w=s;break}else{v=s;w=s+ -1|0;break}}else{v=t;w=s}}while(0);c[e>>2]=v;c[g>>2]=w;o=+h[b+(w<<3)>>3];n=(a-o)/(+h[b+(v<<3)>>3]-o);h[f>>3]=n;u=1.0-n;h[j>>3]=u;i=k;return}function Ywa(a){a=a|0;i=i;return+(+h[c[a+20>>2]>>3])}function Zwa(a){a=a|0;i=i;return+(+h[(c[a+20>>2]|0)+(c[a+16>>2]<<3)>>3])}function _wa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0;f=i;i=i+48|0;g=f;j=f+8|0;k=f+16|0;l=f+24|0;m=f+32|0;n=f+40|0;if((c[d+8>>2]|0)!=0){o=c[d+12>>2]|0;if((o|0)<0){p=-+h[(c[b+20>>2]|0)+(~o<<3)>>3]}else{p=+h[(c[b+20>>2]|0)+(o+ -1<<3)>>3]}h[a>>3]=p;q=0;i=f;return q|0}if(+Zwa(b)<e){q=1;i=f;return q|0}if(+Ywa(b)>e){q=1;i=f;return q|0}if((Vwa(b,1)|0)==0){q=1;i=f;return q|0}Xwa(e,c[c[b+40>>2]>>2]|0,c[b+28>>2]|0,m,g,n,j);o=c[n>>2]|0;if((o|0)==-1){q=~~+Wwa(a,b,c[d+12>>2]|0,c[m>>2]|0);i=f;return q|0}n=c[m>>2]|0;m=d+12|0;d=c[m>>2]|0;if((n|0)==-1){q=~~+Wwa(a,b,d,o);i=f;return q|0}if(+Wwa(k,b,d,n)!=0.0){q=1;i=f;return q|0}if(+Wwa(l,b,c[m>>2]|0,o)!=0.0){q=1;i=f;return q|0}h[a>>3]=+h[g>>3]*+h[k>>3]+ +h[j>>3]*+h[l>>3];q=0;i=f;return q|0}function $wa(a,b){a=a|0;b=b|0;i=i;return+(+h[(c[a+8>>2]|0)+(b<<3)>>3])}function axa(a,b){a=a|0;b=b|0;var c=0;c=i;Wva(a,b,Bwa(b)|0);i=c;return}function bxa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;c[a+8>>2]=Bwa(Xva(a,b,f)|0)|0;i=e;return}function cxa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0.0;d=i;if((Tva(a)|0)==0){db(208224,208248,127,208272)}if((Tva(b)|0)==0){db(208296,208248,128,208272)}if((Uva(a,b)|0)==0){db(208320,208248,129,208272)}e=Vva(a)|0;if((e|0)==0){i=d;return}f=b+8|0;b=0;do{g=+$wa(a,b);dxa(c[f>>2]|0,b,g);b=b+1|0;}while(b>>>0<e>>>0);i=d;return}function dxa(a,b,c){a=a|0;b=b|0;c=+c;h[a+(b<<3)>>3]=c;i=i;return}function exa(a,b){a=a|0;b=b|0;i=i;return a+(b<<3)|0}function fxa(a,b,d){a=+a;b=b|0;d=d|0;var e=0;e=i;dxa(c[d+8>>2]|0,b,a);i=e;return}function gxa(a,b,d,e){a=a|0;b=b|0;d=+d;e=e|0;var f=0,g=0,j=0,k=0;f=i;i=i+16|0;g=f;axa(a,b);j=g;c[g>>2]=e;fxa(d,0,a);if((b|0)>1){k=1}else{i=f;return}do{e=c[j>>2]|0;d=+h[e>>3];c[j>>2]=e+8;fxa(d,k,a);k=k+1|0;}while((k|0)<(b|0));i=f;return}function hxa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;d=Yva(a,b,f)|0;f=exa(c[a+8>>2]|0,d)|0;i=e;return f|0}function ixa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0;g=i;i=i+16|0;h=g;j=V_a(d<<2)|0;if((j|0)==0){db(208360,208248,784,208392)}k=h;c[h>>2]=f;c[j>>2]=e;f=(d|0)>1;if(f){h=1;do{l=c[k>>2]|0;m=c[l>>2]|0;c[k>>2]=l+4;c[j+(h<<2)>>2]=m;h=h+1|0;}while((h|0)<(d|0));n=c[j>>2]|0}else{n=e}e=c[n>>2]|0;if((e|0)<(a|0)){db(208368,208248,795,208392)}h=a+ -1|0;k=c[n+4>>2]|0;m=c[k+(h<<2)>>2]|0;a:do{if(f){l=(h|0)>0;o=n;p=1;q=m;b:while(1){r=c[j+(p<<2)>>2]|0;if((e|0)!=(c[r>>2]|0)){s=14;break}t=c[r+4>>2]|0;if(l){r=0;while(1){u=r+1|0;if((c[k+(r<<2)>>2]|0)!=(c[t+(r<<2)>>2]|0)){s=17;break b}if((u|0)<(h|0)){r=u}else{v=n;break}}}else{v=o}r=(c[t+(h<<2)>>2]|0)+q|0;u=c[v>>2]|0;if((u|0)>(a|0)){w=c[v+4>>2]|0;x=a;while(1){y=x+1|0;if((c[w+(x<<2)>>2]|0)!=(c[t+(x<<2)>>2]|0)){s=22;break b}if((y|0)<(u|0)){x=y}else{break}}}x=p+1|0;if((x|0)<(d|0)){o=v;p=x;q=r}else{z=u;A=v;B=r;break a}}if((s|0)==14){db(208416,208248,798,208392)}else if((s|0)==17){db(208456,208248,800,208392)}else if((s|0)==22){db(208456,208248,804,208392)}}else{z=e;A=n;B=m}}while(0);if((h|0)>0){m=c[A+4>>2]|0;n=0;e=1;while(1){s=fa(c[m+(n<<2)>>2]|0,e)|0;v=n+1|0;if((v|0)<(h|0)){e=s;n=v}else{C=s;break}}}else{C=1}n=A;if((z|0)>(a|0)){e=c[A+4>>2]|0;m=a;a=1;while(1){s=fa(c[e+(m<<2)>>2]|0,a)|0;v=m+1|0;if((v|0)<(z|0)){a=s;m=v}else{D=s;break}}}else{D=1}m=b+8|0;c[m>>2]=Bwa(fa(fa(C,B)|0,D)|0)|0;a=c[n>>2]|0;n=b;c[n>>2]=a;z=Dwa(a)|0;c[b+4>>2]=z;b=c[n>>2]|0;if((b|0)>0){n=c[A+4>>2]|0;A=0;do{c[z+(A<<2)>>2]=c[n+(A<<2)>>2];A=A+1|0;}while((A|0)<(b|0))}c[z+(h<<2)>>2]=B;if((C|0)<=0){W_a(j);i=g;return}B=(d|0)>0;z=0;b=0;while(1){if(B){A=0;n=b;while(1){a=c[j+(A<<2)>>2]|0;e=fa(c[(c[a+4>>2]|0)+(h<<2)>>2]|0,D)|0;if((e|0)>0){s=fa(e,z)|0;v=n;k=0;while(1){E=+$wa(a,k+s|0);dxa(c[m>>2]|0,v,E);f=k+1|0;if((f|0)<(e|0)){k=f;v=v+1|0}else{break}}F=n+e|0}else{F=n}v=A+1|0;if((v|0)<(d|0)){A=v;n=F}else{G=F;break}}}else{G=b}n=z+1|0;if((n|0)<(C|0)){z=n;b=G}else{break}}W_a(j);i=g;return}function jxa(a){a=a|0;var b=0,c=0,d=0.0,e=0,f=0.0,g=0.0,h=0;b=i;if((Tva(a)|0)==0){db(208504,208248,1547,208528)}c=Vva(a)|0;if((c|0)==0){d=0.0;i=b;return+d}else{e=0;f=0.0}while(1){g=f+ +$wa(a,e);h=e+1|0;if(h>>>0<c>>>0){f=g;e=h}else{d=g;break}}i=b;return+d}function kxa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=i;i=i+8|0;f=V_a(20)|0;kwa(0,(f|0)!=0|0,208544,e);c[f+8>>2]=0;c[f+12>>2]=0;e=(a|0)<1?1:a;c[f+16>>2]=e;c[f+4>>2]=b;a=X_a(e,b)|0;c[f>>2]=a;kwa(0,(a|0)!=0|0,208544,d);i=d;return f|0}function lxa(a){a=a|0;var b=0;b=i;W_a(c[a>>2]|0);W_a(a);i=b;return}function mxa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=i;i=i+16|0;g=i;i=i+8|0;h=a+12|0;kwa(0,(c[h>>2]|0)>0|0,208560,g);g=c[h>>2]|0;c[f>>2]=b;c[f+4>>2]=1-g;c[f+8>>2]=g+ -1;kwa(0,(g|0)>(b|0)|0,208584,f);f=c[h>>2]|0;c[e>>2]=b;c[e+4>>2]=1-f;c[e+8>>2]=f+ -1;kwa(0,(0-f|0)<(b|0)|0,208584,e);e=(c[a>>2]|0)+(fa(c[a+4>>2]|0,((c[a+8>>2]|0)+b|0)%(c[a+16>>2]|0)|0)|0)|0;i=d;return e|0}function nxa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;d=a+16|0;e=a+4|0;f=X_a(c[d>>2]<<1,c[e>>2]|0)|0;kwa(0,(f|0)!=0|0,208544,b);g=a+12|0;if((c[g>>2]|0)>0){h=c[e>>2]|0;j=0;do{k=f+(fa(h,j)|0)|0;l=mxa(a,j)|0;h=c[e>>2]|0;z$a(k|0,l|0,h|0)|0;j=j+1|0;}while((j|0)<(c[g>>2]|0))}g=a;W_a(c[g>>2]|0);c[g>>2]=f;c[d>>2]=c[d>>2]<<1;c[a+8>>2]=0;i=b;return}function oxa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=a+16|0;f=c[e>>2]|0;g=a+12|0;h=c[g>>2]|0;if((f|0)<(h+1|0)){nxa(a);j=c[e>>2]|0;k=c[g>>2]|0}else{j=f;k=h}h=c[a+4>>2]|0;z$a((c[a>>2]|0)+(fa(h,(k+(c[a+8>>2]|0)|0)%(j|0)|0)|0)|0,b|0,h|0)|0;c[g>>2]=(c[g>>2]|0)+1;i=d;return}function pxa(a){a=a|0;i=i;return c[a+12>>2]|0}function qxa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;h=i;i=i+8|0;j=a+12|0;kwa(0,(c[j>>2]|0)>0|0,208560,h);h=c[j>>2]|0;c[g>>2]=b;c[g+4>>2]=0;c[g+8>>2]=h+ -1;kwa(0,(h|0)>(b|0)|0,208584,g);g=(c[j>>2]|0)+ -1|0;c[f>>2]=b;c[f+4>>2]=0;c[f+8>>2]=g;kwa(0,b>>>31^1,208584,f);f=a+8|0;g=c[a+16>>2]|0;c[f>>2]=((fa(g+ -1|0,b)|0)+(c[f>>2]|0)|0)%(g|0)|0;if((d|0)==0){i=e;return}if((c[j>>2]|0)>0){k=0}else{i=e;return}do{c[d+(k<<2)>>2]=mxa(a,k)|0;k=k+1|0;}while((k|0)<(c[j>>2]|0));i=e;return}function rxa(a){a=a|0;i=i;return c[(c[52154]|0)+(a<<2)>>2]|0}function sxa(a){a=a|0;i=i;return c[(c[52156]|0)+(a<<2)>>2]|0}function txa(a){a=a|0;i=i;return c[(c[52158]|0)+(a<<2)>>2]|0}function uxa(a){a=a|0;i=i;return c[(c[52160]|0)+(a<<2)>>2]|0}function vxa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=(c[52156]|0)+(a<<2)|0;e=c[d>>2]|0;f=(c[52158]|0)+(a<<2)|0;g=c[f>>2]|0;h=c[(c[52154]|0)+(a<<2)>>2]|0;if((h|0)==0){i=b;return}c[d>>2]=(e|0)!=0&e>>>0<h>>>0?e:h;c[f>>2]=g>>>0>h>>>0?g:h;i=b;return}function wxa(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[52162]|0;e=+xxa(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function xxa(a,b){a=a|0;b=b|0;i=i;return+(+(a|0)+ +(b|0)*1.0e-9)}function yxa(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[52164]|0;e=+xxa(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function zxa(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[52166]|0;e=+xxa(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function Axa(a){a=a|0;i=i;return 0}function Bxa(a){a=a|0;var b=0,d=0;b=i;hb(4,(c[52168]|0)+(a<<3)|0)|0;d=(c[52154]|0)+(a<<2)|0;c[d>>2]=(c[d>>2]|0)+1;i=b;return}function Cxa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=c[52162]|0;f=e+(a<<3)|0;g=c[52166]|0;h=g+(a<<3)|0;c[h>>2]=(c[h>>2]|0)+(c[f>>2]|0);h=e+(a<<3)+4|0;e=g+(a<<3)+4|0;c[e>>2]=(c[e>>2]|0)+(c[h>>2]|0);e=(c[52160]|0)+(a<<2)|0;c[e>>2]=(c[e>>2]|0)+(c[(c[52154]|0)+(a<<2)>>2]|0);e=c[52164]|0;g=e+(a<<3)|0;Dxa(d,c[g>>2]|0,c[e+(a<<3)+4>>2]|0,c[f>>2]|0,c[h>>2]|0);h=d;d=c[h+4>>2]|0;f=g;c[f>>2]=c[h>>2];c[f+4>>2]=d;vxa(a);d=c[52162]|0;c[d+(a<<3)>>2]=0;c[d+(a<<3)+4>>2]=0;c[(c[52154]|0)+(a<<2)>>2]=0;i=b;return}function Dxa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;h=(Gxa(b,d,e,f)|0)<0;if(h){j=e;k=f}else{j=b;k=d}d=a;c[d>>2]=j;c[d+4>>2]=k;i=g;return}function Exa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+8|0;d=b;e=d;c[e>>2]=0;c[e+4>>2]=0;hb(4,d|0)|0;e=c[52168]|0;f=c[52162]|0;g=f+(a<<3)|0;h=(c[d>>2]|0)-(c[e+(a<<3)>>2]|0)+(c[g>>2]|0)|0;c[g>>2]=h;j=f+(a<<3)+4|0;f=(c[d+4>>2]|0)-(c[e+(a<<3)+4>>2]|0)+(c[j>>2]|0)|0;c[j>>2]=f;if((f|0)<=999999999){i=b;return}c[g>>2]=h+1;c[j>>2]=~~(+(f|0)+-1.0e9);i=b;return}function Fxa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;if((a|0)<33){i=b;return}d=X_a(a,8)|0;c[52162]=d;e=X_a(a,8)|0;c[52164]=e;f=X_a(a,8)|0;c[52166]=f;g=X_a(a,8)|0;c[52168]=g;h=X_a(a,4)|0;c[52154]=h;j=X_a(a,4)|0;c[52160]=j;k=a<<2;l=V_a(k)|0;c[52156]=l;m=X_a(a,4)|0;c[52158]=m;B$a(l|0,-1,k|0)|0;if((d|0)==0){db(208680,208696,393,208712)}if((e|0)==0){db(208720,208696,394,208712)}if((f|0)==0){db(208736,208696,395,208712)}if((g|0)==0){db(208752,208696,396,208712)}if((h|0)==0){db(208768,208696,397,208712)}if((l|0)==0){db(208792,208696,398,208712)}if((m|0)==0){db(208816,208696,399,208712)}if((j|0)==0){db(208840,208696,400,208712)}else{i=b;return}}function Gxa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;i=i;return((a|0)==(c|0)?b-d|0:a-c|0)|0}function Hxa(a,b){a=a|0;b=b|0;var c=0;c=i;Wva(a,b,Cwa(b)|0);i=c;return}function Ixa(a,b,d){a=a|0;b=b|0;d=d|0;c[a+(b<<2)>>2]=d;i=i;return}function Jxa(a,b){a=a|0;b=b|0;i=i;return a+(b<<2)|0}function Kxa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;Ixa(c[d+8>>2]|0,b,a);i=e;return}function Lxa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f;Hxa(a,b);h=g;c[g>>2]=e;Kxa(d,0,a);if((b|0)>1){j=1}else{i=f;return}do{d=c[h>>2]|0;e=c[d>>2]|0;c[h>>2]=d+4;Kxa(e,j,a);j=j+1|0;}while((j|0)<(b|0));i=f;return}function Mxa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;d=Yva(a,b,f)|0;f=Jxa(c[a+8>>2]|0,d)|0;i=e;return f|0}function Nxa(a,b){a=+a;b=b|0;var c=0,d=0,e=0,f=0.0,g=0.0,h=0,j=0.0,k=0.0;c=i;d=(b|0)<0;e=d?0-b|0:b;if((e|0)==0){f=1.0}else{b=e;g=a;a=1.0;while(1){if((b&1|0)==0){h=b;j=a}else{h=b+ -1|0;j=a*g}if((h+1|0)>>>0<3){f=j;break}else{b=(h|0)/2|0;g=g*g;a=j}}}if(!d){k=f;i=c;return+k}k=1.0/f;i=c;return+k}function Oxa(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+8|0;o=n;c[o>>2]=1;c[n+4>>2]=c[b>>2];if((a|0)==0){c[m>>2]=c[b+8>>2];n=m+4|0;h[k>>3]=d;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];iwa(17,0,o,210472,m);i=e;return}else if((a|0)==2){c[j>>2]=c[b+8>>2];m=j+4|0;h[k>>3]=d;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];iwa(17,0,o,210624,j);i=e;return}else if((a|0)==3){c[g>>2]=c[b+8>>2];j=g+4|0;h[k>>3]=d;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];iwa(17,0,o,210720,g);i=e;return}else if((a|0)==1){c[l>>2]=c[b+8>>2];g=l+4|0;h[k>>3]=d;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];iwa(17,0,o,210520,l);i=e;return}else{l=c[b+8>>2]|0;c[f>>2]=a;c[f+4>>2]=l;l=f+8|0;h[k>>3]=d;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];iwa(17,0,o,210784,f);i=e;return}}function Pxa(a){a=a|0;var b=0;b=i;W_a(c[a+12>>2]|0);W_a(c[a+4>>2]|0);W_a(c[a+8>>2]|0);i=b;return}function Qxa(a){a=a|0;var b=0,d=0;b=i;d=c[r>>2]|0;Qd(a|0,d|0)|0;Ad(d|0)|0;le[c[63884]&2047](0);i=b;return}function Rxa(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0,W=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0.0,Ha=0,Ia=0.0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0.0,ib=0.0,jb=0.0,kb=0.0,lb=0,mb=0.0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0.0,ub=0.0,vb=0;v=i;w=c[d>>2]|0;x=~w;y=c[l>>2]|0;z=~y;h[26951]=.5;h[26937]=1.0;h[26974]=.25;h[26949]=2.0;h[26976]=6.283185307179586;A=w+ -1-(c[b>>2]|0)|0;c[53910]=A;B=c[d>>2]|0;c[53840]=1;if((B|0)>=1){C=1;while(1){h[p+(C+ -1+(c[b>>2]|0)<<3)>>3]=0.0;D=C+1|0;c[53840]=D;if((C|0)<(B|0)){C=D}else{break}}}c[53838]=1;if((A|0)>=1){C=1;while(1){B=fa(C,w)|0;E=+h[j+(B+x+(c[n>>2]|0)<<3)>>3];h[26952]=E;if((C|0)<(c[k>>2]|0)){F=-E;h[26952]=F;G=F}else{G=E}D=c[d>>2]|0;c[53840]=1;a:do{if((D|0)>=1){E=G;H=1;while(1){I=p+(H+ -1+(c[b>>2]|0)<<3)|0;h[I>>3]=E*+h[j+(H+x+B<<3)>>3]+ +h[I>>3];I=H+1|0;c[53840]=I;if((H|0)>=(D|0)){break a}E=+h[26952];H=I}}}while(0);D=C+1|0;c[53838]=D;if((C|0)<(A|0)){C=D}else{break}}}C=c[b>>2]|0;h[26956]=+h[p+(C+ -1+(c[n>>2]|0)<<3)>>3];h[26921]=0.0;h[26923]=0.0;h[26927]=0.0;h[26984]=0.0;c[53836]=1;if((C|0)<1){J=0.0;K=0.0;L=0.0}else{G=0.0;A=1;while(1){D=A+ -1|0;B=o+(D<<3)|0;E=+h[B>>3];h[26921]=G+E*E;E=+h[f+((c[n>>2]|0)+x+(fa(A,w)|0)<<3)>>3];H=e+(D<<3)|0;F=E- +h[H>>3];I=s+(D<<3)|0;h[I>>3]=F;E=+h[26923]+ +h[B>>3]*F;h[26923]=E;F=+h[I>>3];M=+h[26927]+F*F;h[26927]=M;F=+h[H>>3];h[26984]=+h[26984]+F*F;H=A+1|0;c[53836]=H;F=+h[26921];if((A|0)<(C|0)){A=H;G=F}else{J=M;K=F;L=E;break}}}G=L*L;do{if(G>K*.99*J){A=c[n>>2]|0;c[53906]=A;E=G/J;h[26973]=E;C=c[d>>2]|0;c[53840]=1;if((C|0)<1){N=J;O=L;P=A}else{F=J;M=L;Q=E;H=A;A=1;while(1){do{if((A|0)==(c[m>>2]|0)){R=F;S=M;T=Q;U=H}else{h[26981]=0.0;h[26983]=0.0;I=c[b>>2]|0;c[53836]=1;if((I|0)<1){W=0.0;Z=0.0}else{E=0.0;_=0.0;B=1;while(1){$=+h[f+((fa(B,w)|0)+x+A<<3)>>3];aa=$- +h[e+(B+ -1<<3)>>3];h[26950]=aa;ba=_+aa*+h[o+(B+ -1<<3)>>3];h[26981]=ba;ca=E+aa*aa;h[26983]=ca;if((B|0)<(I|0)){B=B+1|0;_=ba;E=ca}else{break}}c[53836]=I+1;W=ca;Z=ba}E=Z*Z/W;if(!(E<Q)){R=F;S=M;T=Q;U=H;break}c[53906]=A;h[26973]=E;h[26923]=Z;h[26927]=W;R=W;S=Z;T=E;U=A}}while(0);B=A+1|0;c[53840]=B;if((A|0)<(C|0)){F=R;M=S;Q=T;H=U;A=B}else{N=R;O=S;P=U;break}}}A=c[b>>2]|0;c[53836]=1;if((A|0)<1){da=O;ea=N;ga=K;break}else{ha=1}while(1){Q=+h[f+((fa(ha,w)|0)+x+P<<3)>>3];H=ha+ -1|0;h[s+(H<<3)>>3]=Q- +h[e+(H<<3)>>3];if((ha|0)<(A|0)){ha=ha+1|0}else{break}}c[53836]=A+1;da=+h[26923];ea=+h[26927];ga=+h[26921]}else{da=L;ea=J;ga=K}}while(0);K=ga*ea-da*da;h[26972]=K;c[53934]=0;h[26980]=0.0;ha=(y<<1)+z|0;P=(y<<2)+z|0;U=(y*3|0)+z|0;H=(y*5|0)+z|0;ea=da;da=ga;ga=K;C=1;while(1){c[53934]=C;K=+h[26937]/+V(+ga);h[26952]=K;h[26975]=0.0;h[26977]=0.0;B=c[b>>2]|0;c[53836]=1;if((B|0)<1){ia=da;ja=0.0;ka=0.0}else{J=ea;L=da;N=K;D=1;la=0;while(1){ma=s+(la<<3)|0;h[ma>>3]=N*(L*+h[ma>>3]-J*+h[o+(la<<3)>>3]);ma=D+ -1|0;na=e+(ma<<3)|0;oa=+h[26975]+ +h[na>>3]*+h[o+(ma<<3)>>3];h[26975]=oa;pa=+h[26977]+ +h[na>>3]*+h[s+(ma<<3)>>3];h[26977]=pa;if((D|0)>=(B|0)){break}ma=D;J=+h[26923];L=+h[26921];N=+h[26952];D=D+1|0;la=ma}c[53836]=B+1;ia=+h[26921];ja=pa;ka=oa}N=+h[26951];L=ka*N*ka;h[26968]=L;J=ja*N*ja;h[26969]=J;h[26928]=J+(L+ia*(+h[26984]+ia*N));N=+h[26949];h[215432>>3]=N*ka*ia;h[215440>>3]=N*ja*ia;h[215448>>3]=L-J;h[215456>>3]=ka*ja;la=215464|0;c[la+0>>2]=0;c[la+4>>2]=0;c[la+8>>2]=0;c[la+12>>2]=0;c[la+16>>2]=0;c[la+20>>2]=0;c[la+24>>2]=0;c[la+28>>2]=0;c[53836]=10;la=c[d>>2]|0;c[53840]=1;if((la|0)>=1){D=1;while(1){h[26968]=0.0;h[26969]=0.0;h[26970]=0.0;A=c[b>>2]|0;c[53836]=1;if((A|0)<1){qa=0.0;ra=0.0}else{ma=D+x|0;J=0.0;L=0.0;N=0.0;na=1;while(1){K=+h[f+((fa(na,w)|0)+x+D<<3)>>3];sa=N+K*+h[o+(na+ -1<<3)>>3];h[26968]=sa;ta=f+(ma+(fa(na,w)|0)<<3)|0;ua=na+ -1|0;va=L+ +h[ta>>3]*+h[s+(ua<<3)>>3];h[26969]=va;K=J+ +h[ta>>3]*+h[e+(ua<<3)>>3];h[26970]=K;if((na|0)<(A|0)){na=na+1|0;N=sa;L=va;J=K}else{break}}c[53836]=A+1;qa=va;ra=sa}h[t+(D+ -1<<3)>>3]=+h[26974]*(ra*ra+qa*qa);h[t+(ha+D<<3)>>3]=+h[26968]*+h[26970];h[t+(U+D<<3)>>3]=+h[26969]*+h[26970];J=+h[26968];L=+h[26969];h[t+(P+D<<3)>>3]=+h[26974]*(J*J-L*L);h[t+(H+D<<3)>>3]=+h[26951]*+h[26968]*+h[26969];na=D+1|0;c[53840]=na;if((D|0)<(la|0)){D=na}else{break}}}D=c[b>>2]|0;c[53836]=1;if((D|0)>=1){la=1;while(1){B=(c[d>>2]|0)+la|0;c[53848]=B;h[t+(B+ -1<<3)>>3]=0.0;na=la+ -1|0;h[t+(ha+B<<3)>>3]=+h[o+(na<<3)>>3];h[t+(U+B<<3)>>3]=+h[s+(na<<3)>>3];h[t+(P+B<<3)>>3]=0.0;h[t+(H+B<<3)>>3]=0.0;B=la+1|0;c[53836]=B;if((la|0)<(D|0)){la=B}else{break}}}c[53844]=1;la=1;do{D=c[d>>2]|0;c[53852]=D;if((la&-2|0)==2){B=c[l>>2]|0;c[53852]=B;wa=B}else{wa=D}D=c[d>>2]|0;c[53840]=1;if((D|0)>=1){B=fa(la,y)|0;na=1;while(1){h[u+(na+z+B<<3)>>3]=0.0;if((na|0)<(D|0)){na=na+1|0}else{break}}c[53840]=D+1}na=c[53910]|0;c[53838]=1;if((na|0)<1){xa=la}else{B=1;A=la;while(1){h[26948]=0.0;ma=c[d>>2]|0;c[53840]=1;if((ma|0)<1){ya=0.0;za=A}else{ua=fa(la,y)|0;L=0.0;ta=1;while(1){J=+h[j+(ta+x+(fa(B,w)|0)<<3)>>3];Aa=L+J*+h[t+(ta+z+ua<<3)>>3];h[26948]=Aa;if((ta|0)<(ma|0)){ta=ta+1|0;L=Aa}else{break}}c[53840]=ma+1;ya=Aa;za=la}if((B|0)<(c[k>>2]|0)){L=-ya;h[26948]=L;Ba=L}else{Ba=ya}ta=c[d>>2]|0;c[53840]=1;if((ta|0)>=1){ua=fa(B,w)|0;I=fa(za,y)|0;L=Ba;Ca=1;while(1){Da=u+(Ca+z+I<<3)|0;h[Da>>3]=L*+h[j+(Ca+x+ua<<3)>>3]+ +h[Da>>3];if((Ca|0)>=(ta|0)){break}L=+h[26948];Ca=Ca+1|0}c[53840]=ta+1}Ca=B+1|0;c[53838]=Ca;if((B|0)<(na|0)){B=Ca;A=za}else{xa=za;break}}}do{if((wa|0)==(c[l>>2]|0)){A=c[d>>2]|0;c[53840]=1;if((A|0)<1){break}else{Ea=1}while(1){h[26948]=0.0;B=c[b>>2]|0;c[53838]=1;if((B|0)<1){Fa=fa(xa,y)|0;Ga=0.0}else{L=0.0;na=1;while(1){J=+h[g+((fa(na,y)|0)+z+Ea<<3)>>3];D=fa(xa,y)|0;N=L+J*+h[t+(na+z+(c[d>>2]|0)+D<<3)>>3];h[26948]=N;Ca=na+1|0;c[53838]=Ca;if((na|0)<(B|0)){na=Ca;L=N}else{Fa=D;Ga=N;break}}}na=u+(Ea+z+Fa<<3)|0;h[na>>3]=Ga+ +h[na>>3];na=Ea+1|0;c[53840]=na;if((Ea|0)<(A|0)){Ea=na}else{break}}}}while(0);A=c[b>>2]|0;c[53838]=1;if((A|0)>=1){ta=1;while(1){h[26948]=0.0;c[53836]=1;if((wa|0)<1){Ha=fa(xa,y)|0;Ia=0.0}else{na=fa(ta,y)|0;B=fa(xa,y)|0;L=0.0;D=1;while(1){Ca=D+z|0;Ja=L+ +h[g+(Ca+na<<3)>>3]*+h[t+(Ca+B<<3)>>3];h[26948]=Ja;if((D|0)<(wa|0)){D=D+1|0;L=Ja}else{break}}c[53836]=wa+1;Ha=B;Ia=Ja}h[u+((c[d>>2]|0)+z+ta+Ha<<3)>>3]=Ia;D=ta+1|0;c[53838]=D;if((ta|0)<(A|0)){ta=D}else{break}}}la=xa+1|0;c[53844]=la;}while((la|0)<6);la=c[l>>2]|0;c[53840]=1;h[26948]=0.0;c[53836]=1;L=+h[26951];if((la|0)<1){Ka=L}else{N=L;ta=1;while(1){L=0.0;A=1;do{D=(fa(A,y)|0)+z+ta|0;h[215504+(A+ -1<<3)>>3]=N*+h[u+(D<<3)>>3]*+h[t+(D<<3)>>3];L=+h[215504+(A+ -1<<3)>>3]+L;h[26948]=L;A=A+1|0;}while((A|0)<6);h[26928]=+h[26928]- +h[26938]-L;A=ta+ -1|0;D=u+(A<<3)|0;na=ha+ta|0;Ca=t+(na<<3)|0;ua=u+(na<<3)|0;na=t+(A<<3)|0;J=+h[D>>3]*+h[Ca>>3]+ +h[ua>>3]*+h[na>>3];h[26968]=J;A=P+ta|0;I=t+(A<<3)|0;ma=u+(A<<3)|0;K=+h[ua>>3]*+h[I>>3]+ +h[ma>>3]*+h[Ca>>3];h[26969]=K;A=U+ta|0;Da=u+(A<<3)|0;La=H+ta|0;Ma=t+(La<<3)|0;Na=u+(La<<3)|0;La=t+(A<<3)|0;O=+h[Da>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[La>>3];h[26970]=O;h[215432>>3]=+h[215432>>3]-J-N*(O+K);h[215464>>3]=+h[215464>>3]-N*(K-O);O=+h[D>>3]*+h[La>>3]+ +h[Da>>3]*+h[na>>3];h[26968]=O;K=+h[ua>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[Ca>>3];h[26969]=K;J=+h[Da>>3]*+h[I>>3]+ +h[ma>>3]*+h[La>>3];h[26970]=J;h[215440>>3]=+h[215440>>3]-O-N*(K-J);h[215472>>3]=+h[215472>>3]-N*(K+J);J=+h[D>>3]*+h[I>>3]+ +h[ma>>3]*+h[na>>3];h[26968]=J;h[215448>>3]=+h[215520>>3]+(+h[215448>>3]-J- +h[215512>>3]);J=+h[D>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[na>>3];h[26968]=J;K=+h[ua>>3]*+h[La>>3]+ +h[Da>>3]*+h[Ca>>3];h[26969]=K;Oa=+h[26951];h[215456>>3]=+h[215456>>3]-J-K*Oa;h[215480>>3]=+h[215480>>3]- +h[215528>>3]+ +h[215536>>3];K=+h[ma>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[I>>3];h[26968]=K;h[215488>>3]=+h[215488>>3]-Oa*K;h[26948]=0.0;if((ta|0)<(la|0)){N=Oa;ta=ta+1|0}else{break}}c[53840]=la+1;c[53836]=1;Ka=Oa}N=0.0;ta=1;do{K=+h[u+((fa(ta,y)|0)+z+(c[n>>2]|0)<<3)>>3];h[215504+(ta+ -1<<3)>>3]=Ka*K*K;N=+h[215504+(ta+ -1<<3)>>3]+N;h[26948]=N;ta=ta+1|0;c[53836]=ta;}while((ta|0)<6);K=+h[26956];h[26958]=K*+h[26928]+ +h[26938]+N;J=+h[26949];ta=c[n>>2]|0;la=u+(ta+ -1<<3)|0;I=u+(ha+ta<<3)|0;O=J*+h[la>>3]*+h[I>>3];h[26968]=O;Na=u+(P+ta<<3)|0;S=+h[I>>3]*+h[Na>>3];h[26969]=S;Ma=u+(U+ta<<3)|0;ma=u+(H+ta<<3)|0;R=+h[Ma>>3]*+h[ma>>3];h[26970]=R;T=R+(K*+h[215432>>3]+O+S);h[215672>>3]=T;O=K*+h[215464>>3]+S-R;h[215704>>3]=O;R=J*+h[la>>3]*+h[Ma>>3];h[26968]=R;S=+h[I>>3]*+h[ma>>3];h[26969]=S;Z=+h[Ma>>3]*+h[Na>>3];h[26970]=Z;h[215680>>3]=K*+h[215440>>3]+R+S-Z;h[215712>>3]=K*+h[215472>>3]+S+Z;Z=J*+h[la>>3]*+h[Na>>3];h[26968]=Z;R=+h[215512>>3]+(Z+K*+h[215448>>3])- +h[215520>>3];h[215688>>3]=R;Z=J*+h[la>>3]*+h[ma>>3];h[26968]=Z;h[215696>>3]=Z+K*+h[215456>>3]+ +h[I>>3]*+h[Ma>>3];J=K*+h[215480>>3]+ +h[215528>>3]- +h[215536>>3];h[215720>>3]=J;h[215728>>3]=+h[26956]*+h[215488>>3]+ +h[Na>>3]*+h[ma>>3];K=+h[26958]+T+R+O+J;h[26948]=K;h[26978]=K;h[26979]=K;c[53942]=0;J=+h[26976]/50.0;h[26952]=J;h[26938]=+h[26937];c[53836]=1;O=K;ma=0;R=K;T=S;S=Z;Na=1;while(1){Pa=+(Na|0)*J;Z=+X(+Pa);h[215512>>3]=Z;W=+Y(+Pa);h[215520>>3]=W;ba=W;ca=Z;G=W;W=Z;Ma=4;while(1){Z=ca*W-ba*G;h[215504+(Ma+ -1<<3)>>3]=Z;Q=+h[215512>>3]*G+ +h[215520>>3]*W;h[215504+(Ma<<3)>>3]=Q;I=Ma+2|0;if((I|0)>=9){Qa=1;Ra=0.0;break}ba=+h[215520>>3];ca=+h[215512>>3];Ma=I;W=Z;G=Q}do{Ma=Qa+ -1|0;Ra=Ra+ +h[215664+(Ma<<3)>>3]*+h[215504+(Ma<<3)>>3];Qa=Qa+1|0;}while((Qa|0)<10);if(!(Ra>=0.0)){Sa=-Ra}else{Sa=Ra}if(!(R>=0.0)){Ta=-R}else{Ta=R}do{if(Sa>Ta){h[26979]=Ra;c[53942]=Na;h[26968]=O;Ua=Ra;Va=T;Wa=O;Xa=Na}else{if((Na|0)!=(ma+1|0)){Ua=R;Va=T;Wa=S;Xa=ma;break}h[26969]=Ra;Ua=R;Va=Ra;Wa=S;Xa=ma}}while(0);if((Na|0)>48){break}else{O=Ra;ma=Xa;R=Ua;T=Va;S=Wa;Na=Na+1|0}}c[53838]=10;h[26948]=Ra;h[26957]=Pa;h[26982]=O;c[53836]=50;if((Xa|0)==0){h[26968]=Ra;Ya=Ra;Za=Va}else if((Xa|0)==49){h[26969]=K;Ya=Wa;Za=K}else{Ya=Wa;Za=Va}h[26954]=0.0;if(Ya!=Za){S=Ya-Ua;h[26968]=S;T=Za-Ua;h[26969]=T;R=+h[26951]*(S-T)/(S+T);h[26954]=R;_a=R}else{_a=0.0}R=J*(+(Xa|0)+_a);h[26957]=R;T=+X(+R);h[215512>>3]=T;S=+Y(+R);h[215520>>3]=S;c[53838]=4;R=S;N=T;G=S;S=T;Na=4;while(1){T=N*S-R*G;h[215504+(Na+ -1<<3)>>3]=T;W=+h[215512>>3]*G+ +h[215520>>3]*S;h[215504+(Na<<3)>>3]=W;ma=Na+2|0;if((ma|0)>=9){break}R=+h[215520>>3];N=+h[215512>>3];Na=ma;S=T;G=W}h[r>>3]=0.0;h[26979]=0.0;c[53838]=1;Na=1;do{ma=Na+ -1|0;Ma=215504+(ma<<3)|0;h[r>>3]=+h[r>>3]+ +h[215424+(ma<<3)>>3]*+h[Ma>>3];h[26979]=+h[26979]+ +h[215664+(ma<<3)>>3]*+h[Ma>>3];Na=Na+1|0;}while((Na|0)<10);c[53838]=10;Na=c[l>>2]|0;c[53840]=1;if((Na|0)>=1){Ma=1;while(1){h[q+(Ma+ -1<<3)>>3]=0.0;ma=1;do{G=+h[u+((fa(ma,y)|0)+z+Ma<<3)>>3];I=q+(Ma+ -1<<3)|0;h[I>>3]=+h[I>>3]+G*+h[215504+(ma+ -1<<3)>>3];ma=ma+1|0;}while((ma|0)<6);if((Ma|0)<(Na|0)){Ma=Ma+1|0}else{break}}c[53838]=6;c[53840]=Na+1}h[26947]=+h[q+((c[n>>2]|0)+ -1<<3)>>3];h[26921]=0.0;h[26968]=0.0;h[26969]=0.0;Ma=c[b>>2]|0;c[53836]=1;if((Ma|0)<1){$a=0.0;ab=0.0}else{ma=1;while(1){I=ma+ -1|0;la=o+(I<<3)|0;h[la>>3]=+h[215512>>3]*+h[la>>3]+ +h[215520>>3]*+h[s+(I<<3)>>3];I=ma+ -1|0;la=o+(I<<3)|0;ta=p+(I<<3)|0;h[ta>>3]=+h[e+(I<<3)>>3]+ +h[la>>3];G=+h[la>>3];h[26921]=+h[26921]+G*G;bb=+h[26968]+ +h[la>>3]*+h[ta>>3];h[26968]=bb;G=+h[ta>>3];cb=+h[26969]+G*G;h[26969]=cb;if((ma|0)<(Ma|0)){ma=ma+1|0}else{break}}c[53836]=Ma+1;$a=cb;ab=bb}ma=c[53934]|0;Na=c[b>>2]|0;if((ma|0)>=(Na|0)){break}if((ma|0)>1){G=+h[26980];S=+h[26978];h[26980]=G>=S?G:S}S=+h[26979];if(!(S>=0.0)){db=-S}else{db=S}G=+h[26980];if(!(G>=0.0)){eb=-G}else{eb=G}if(db<=eb*1.1){break}h[26980]=S;c[53836]=1;b:do{if((Na|0)>=1){S=$a;G=ab;ta=1;while(1){la=ta+ -1|0;N=G*+h[e+(la<<3)>>3]+S*+h[o+(la<<3)>>3]- +h[q+(la+(c[d>>2]|0)<<3)>>3];h[26952]=N;R=+h[26947]*+h[g+((c[n>>2]|0)+z+(fa(ta,y)|0)<<3)>>3];h[s+(la<<3)>>3]=R+N*+h[26956];la=ta+1|0;c[53836]=la;if((ta|0)>=(Na|0)){break b}S=+h[26969];G=+h[26968];ta=la}}}while(0);Na=c[d>>2]|0;c[53840]=1;if((Na|0)>=1){Ma=1;while(1){h[26948]=0.0;ta=c[b>>2]|0;c[53838]=1;if((ta|0)<1){fb=0.0}else{G=0.0;la=1;while(1){S=+h[f+((fa(la,w)|0)+x+Ma<<3)>>3];gb=G+S*+h[p+(la+ -1<<3)>>3];h[26948]=gb;if((la|0)<(ta|0)){la=la+1|0;G=gb}else{break}}c[53838]=ta+1;fb=gb}la=c[b>>2]|0;G=fb*(+h[26947]*+h[p+(la+ -1+Ma<<3)>>3]- +h[26956]*+h[q+(Ma+ -1<<3)>>3]);h[26952]=G;c[53836]=1;if((la|0)>=1){S=G;I=1;while(1){G=S*+h[f+((fa(I,w)|0)+x+Ma<<3)>>3];Ca=s+(I+ -1<<3)|0;h[Ca>>3]=+h[Ca>>3]+G;if((I|0)>=(la|0)){break}S=+h[26952];I=I+1|0}c[53836]=la+1}I=Ma+1|0;c[53840]=I;if((Ma|0)<(Na|0)){Ma=I}else{break}}}h[26927]=0.0;h[26923]=0.0;Ma=c[b>>2]|0;c[53836]=1;if((Ma|0)<1){hb=0.0;ib=0.0}else{S=0.0;G=0.0;Na=1;while(1){N=+h[s+(Na+ -1<<3)>>3];jb=G+N*N;h[26927]=jb;I=Na+ -1|0;kb=S+ +h[o+(I<<3)>>3]*+h[s+(I<<3)>>3];h[26923]=kb;if((Na|0)<(Ma|0)){Na=Na+1|0;G=jb;S=kb}else{break}}c[53836]=Ma+1;hb=kb;ib=jb}S=+h[26921];G=S*ib-hb*hb;h[26972]=G;if(!(G>=S*1.0e-8*ib)){break}ea=hb;da=S;ga=G;C=ma+1|0}a[215400]=1;C=c[l>>2]|0;c[53840]=1;if((C|0)<1){lb=215496;mb=+h[26937];nb=c[m>>2]|0;ob=nb+ -1|0;pb=q;qb=ob<<3;rb=pb+qb|0;sb=rb;tb=+h[sb>>3];ub=mb+tb;h[sb>>3]=ub;i=v;return 0}else{vb=1}while(1){h[p+(vb+ -1<<3)>>3]=0.0;l=1;do{ga=+h[t+((fa(l,y)|0)+z+vb<<3)>>3];s=p+(vb+ -1<<3)|0;h[s>>3]=+h[s>>3]+ga*+h[215504+(l+ -1<<3)>>3];l=l+1|0;}while((l|0)<6);if((vb|0)<(C|0)){vb=vb+1|0}else{break}}c[53838]=6;c[53840]=C+1;lb=215496;mb=+h[26937];nb=c[m>>2]|0;ob=nb+ -1|0;pb=q;qb=ob<<3;rb=pb+qb|0;sb=rb;tb=+h[sb>>3];ub=mb+tb;h[sb>>3]=ub;i=v;return 0}function Sxa(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,W=0.0,Z=0.0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0;v=i;w=c[d>>2]|0;x=~w;y=c[l>>2]|0;l=~y;h[27004]=.5;h[27e3]=1.0;h[27016]=6.283185307179586;z=+h[n>>3];h[27013]=z*z;A=w+ -1-(c[b>>2]|0)|0;c[54014]=A;c[54022]=0;B=c[d>>2]|0;c[53974]=1;if((B|0)>=1){C=1;while(1){h[q+(C+ -1<<3)>>3]=0.0;if((C|0)<(B|0)){C=C+1|0}else{break}}c[53974]=B+1}c[53972]=1;B=c[m>>2]|0;if((A|0)<1){D=B}else{C=B;B=1;while(1){E=fa(B,w)|0;z=+h[j+(E+x+C<<3)>>3];h[27005]=z;if((B|0)<(c[k>>2]|0)){F=-z;h[27005]=F;G=F}else{G=z}H=c[d>>2]|0;c[53974]=1;if((H|0)>=1){z=G;I=1;while(1){J=q+(I+ -1<<3)|0;h[J>>3]=+h[J>>3]+z*+h[j+(I+x+E<<3)>>3];if((I|0)>=(H|0)){break}z=+h[27005];I=I+1|0}c[53974]=H+1}I=B+1|0;c[53972]=I;E=c[m>>2]|0;if((B|0)<(A|0)){C=E;B=I}else{D=E;break}}}h[p>>3]=+h[q+(D+ -1<<3)>>3];h[26988]=0.0;D=c[b>>2]|0;c[53970]=1;if((D|0)>=1){p=1;while(1){B=c[m>>2]|0;G=+h[f+((fa(p,w)|0)+x+B<<3)>>3];C=p+ -1|0;A=o+(C<<3)|0;h[A>>3]=G- +h[e+(C<<3)>>3];h[r+(C<<3)>>3]=+h[g+(B+l+(fa(p,y)|0)<<3)>>3];h[s+(C<<3)>>3]=0.0;G=+h[A>>3];h[26988]=+h[26988]+G*G;A=p+1|0;c[53970]=A;if((p|0)<(D|0)){p=A}else{break}}}p=c[d>>2]|0;c[53974]=1;if((p|0)>=1){D=1;while(1){h[27005]=0.0;h[27003]=0.0;y=c[b>>2]|0;c[53972]=1;if((y|0)<1){K=0.0;L=0.0}else{l=D+x|0;G=0.0;z=0.0;g=1;while(1){F=+h[f+((fa(g,w)|0)+x+D<<3)>>3];M=z+F*+h[e+(g+ -1<<3)>>3];h[27005]=M;F=+h[f+(l+(fa(g,w)|0)<<3)>>3];N=G+F*+h[o+(g+ -1<<3)>>3];h[27003]=N;if((g|0)<(y|0)){g=g+1|0;z=M;G=N}else{break}}c[53972]=y+1;K=M;L=N}g=q+(D+ -1<<3)|0;G=+h[g>>3]*K;h[27005]=G;h[27003]=+h[g>>3]*L;g=c[b>>2]|0;c[53970]=1;if((g|0)>=1){l=D+x|0;z=G;H=1;while(1){G=z*+h[f+((fa(H,w)|0)+x+D<<3)>>3];m=r+(H+ -1<<3)|0;h[m>>3]=+h[m>>3]+G;G=+h[27003]*+h[f+(l+(fa(H,w)|0)<<3)>>3];m=s+(H+ -1<<3)|0;h[m>>3]=+h[m>>3]+G;if((H|0)>=(g|0)){break}z=+h[27005];H=H+1|0}c[53970]=g+1}H=D+1|0;c[53974]=H;if((D|0)<(p|0)){D=H}else{break}}}h[26989]=0.0;h[26991]=0.0;h[26998]=0.0;D=c[b>>2]|0;c[53970]=1;if((D|0)<1){O=0.0;P=0.0;Q=0.0}else{L=0.0;K=0.0;N=0.0;p=1;while(1){M=+h[r+(p+ -1<<3)>>3];R=N+M*M;h[26989]=R;e=p+ -1|0;H=o+(e<<3)|0;S=K+ +h[H>>3]*+h[r+(e<<3)>>3];h[26991]=S;T=L+ +h[H>>3]*+h[s+(e<<3)>>3];h[26998]=T;if((p|0)<(D|0)){p=p+1|0;N=R;K=S;L=T}else{break}}c[53970]=D+1;O=R;P=T;Q=S}S=+h[26988];T=+h[n>>3]/+V(+S);if(Q*P<0.0){U=-T}else{U=T}h[27009]=U;h[27005]=0.0;if(Q*Q>S*.99*O){h[27005]=+h[27e3]}if(!(Q>=0.0)){W=-Q}else{W=Q}if(!(P>=0.0)){Z=-P}else{Z=P}P=U*(W+ +h[27004]*U*Z);h[27001]=P;if(O*+h[27013]<P*P*.01){h[27005]=+h[27e3]}n=c[b>>2]|0;c[53970]=1;if((n|0)<1){_=0}else{P=U;D=1;p=0;while(1){e=o+(p<<3)|0;h[e>>3]=P*+h[e>>3];e=D+ -1|0;H=s+(e<<3)|0;U=+h[27009]*+h[H>>3];h[H>>3]=U;h[t+(e<<3)>>3]=+h[r+(e<<3)>>3]+ +h[27005]*U;if((D|0)>=(n|0)){break}e=D;P=+h[27009];D=D+1|0;p=e}c[53970]=n+1;_=0}while(1){n=_+1|0;c[54022]=n;h[26988]=0.0;h[26991]=0.0;h[26992]=0.0;p=c[b>>2]|0;c[53970]=1;if((p|0)<1){$=0.0;aa=0.0;ba=0.0}else{P=0.0;U=0.0;O=0.0;D=1;while(1){Z=+h[o+(D+ -1<<3)>>3];ca=O+Z*Z;h[26988]=ca;e=D+ -1|0;H=t+(e<<3)|0;da=U+ +h[o+(e<<3)>>3]*+h[H>>3];h[26991]=da;Z=+h[H>>3];ea=P+Z*Z;h[26992]=ea;if((D|0)<(p|0)){D=D+1|0;O=ca;U=da;P=ea}else{break}}c[53970]=p+1;$=da;aa=ea;ba=ca}P=ba*aa-$*$;h[27005]=P;if(P<=ba*1.0e-8*aa){ga=88;break}U=+V(+P);h[27010]=U;D=c[b>>2]|0;c[53970]=1;if((D|0)>=1){P=U;U=$;O=ba;g=1;H=0;while(1){e=t+(H<<3)|0;h[e>>3]=(O*+h[e>>3]-U*+h[o+(H<<3)>>3])/P;h[u+(g+ -1<<3)>>3]=0.0;if((g|0)>=(D|0)){break}e=g;P=+h[27010];U=+h[26991];O=+h[26988];g=g+1|0;H=e}c[53970]=D+1}H=c[d>>2]|0;c[53974]=1;if((H|0)>=1){g=1;while(1){h[27003]=0.0;p=c[b>>2]|0;c[53972]=1;if((p|0)<1){ha=0.0}else{O=0.0;e=1;while(1){U=+h[f+((fa(e,w)|0)+x+g<<3)>>3];ia=O+U*+h[t+(e+ -1<<3)>>3];h[27003]=ia;if((e|0)<(p|0)){e=e+1|0;O=ia}else{break}}c[53972]=p+1;ha=ia}O=+h[q+(g+ -1<<3)>>3]*ha;h[27003]=O;e=c[b>>2]|0;c[53970]=1;if((e|0)>=1){U=O;l=1;while(1){O=U*+h[f+((fa(l,w)|0)+x+g<<3)>>3];y=u+(l+ -1<<3)|0;h[y>>3]=+h[y>>3]+O;if((l|0)>=(e|0)){break}U=+h[27003];l=l+1|0}c[53970]=e+1}l=g+1|0;c[53974]=l;if((g|0)<(H|0)){g=l}else{break}}}h[26993]=0.0;h[26994]=0.0;h[26995]=0.0;h[26996]=0.0;h[26997]=0.0;g=c[b>>2]|0;c[53970]=1;if((g|0)<1){ja=0.0;ka=0.0;la=0.0;ma=0.0;na=0.0}else{U=0.0;O=0.0;P=0.0;Z=0.0;W=0.0;H=1;while(1){D=H+ -1|0;oa=W+ +h[t+(D<<3)>>3]*+h[u+(D<<3)>>3];h[26993]=oa;D=H+ -1|0;l=o+(D<<3)|0;p=r+(D<<3)|0;pa=Z+ +h[l>>3]*+h[p>>3];h[26994]=pa;y=t+(D<<3)|0;qa=P+ +h[y>>3]*+h[p>>3];h[26995]=qa;p=s+(D<<3)|0;ra=O+ +h[l>>3]*+h[p>>3];h[26996]=ra;sa=U+ +h[y>>3]*+h[p>>3];h[26997]=sa;if((H|0)<(g|0)){H=H+1|0;W=oa;Z=pa;P=qa;O=ra;U=sa}else{break}}c[53970]=g+1;ja=sa;ka=qa;la=pa;ma=ra;na=oa}U=+h[27004];O=U*na;h[26993]=O;P=U*ma-O;h[26996]=P;Z=O+la+P;h[27017]=Z;h[27019]=Z;h[27018]=Z;c[54024]=0;a[215920]=1;W=+h[27016]/50.0;h[27005]=W;c[53970]=1;H=0;Q=Z;S=Z;p=1;while(1){ta=+(p|0)*W;ua=+X(+ta);va=+Y(+ta);wa=O+ua*(la+ua*P)+va*(ka+ua*ja);if(!(wa>=0.0)){xa=-wa}else{xa=wa}if(!(Q>=0.0)){ya=-Q}else{ya=Q}do{if(xa>ya){h[27019]=wa;c[54024]=p;h[27014]=S;za=p;Aa=wa}else{if((p|0)!=(H+1|0)){za=H;Aa=Q;break}h[27015]=wa;za=H;Aa=Q}}while(0);e=p+1|0;if((e|0)<50){H=za;Q=Aa;p=e;S=wa}else{break}}h[27008]=ta;h[26999]=ua;h[27002]=va;h[27001]=wa;c[53970]=50;h[27018]=wa;if((za|0)==49){h[27015]=Z;Ba=Z}else if((za|0)==0){h[27014]=wa;ga=74}else{ga=74}if((ga|0)==74){ga=0;Ba=+h[27015]}h[27006]=0.0;S=+h[27014];if(S!=Ba){Q=S-Aa;h[27014]=Q;S=Ba-Aa;h[27015]=S;T=U*(Q-S)/(Q+S);h[27006]=T;Ca=T}else{Ca=0.0}T=W*(+(za|0)+Ca);h[27008]=T;S=+X(+T);h[26999]=S;Q=+Y(+T);h[27002]=Q;T=O+S*(la+S*P)+Q*(ka+S*ja);h[27001]=T;p=c[b>>2]|0;c[53970]=1;if((p|0)<1){Da=T}else{T=Q;Q=S;H=1;g=0;while(1){e=o+(g<<3)|0;h[e>>3]=Q*+h[e>>3]+T*+h[t+(g<<3)>>3];e=H+ -1|0;y=s+(e<<3)|0;S=+h[26999]*+h[y>>3]+ +h[27002]*+h[u+(e<<3)>>3];h[y>>3]=S;h[t+(e<<3)>>3]=+h[r+(e<<3)>>3]+S;if((H|0)>=(p|0)){break}e=H;T=+h[27002];Q=+h[26999];H=H+1|0;g=e}c[53970]=p+1;Da=+h[27001]}if(!(Da>=0.0)){Ea=-Da}else{Ea=Da}Q=+h[27017];if(!(Q>=0.0)){Fa=-Q}else{Fa=Q}if(Ea<=Fa*1.1){ga=88;break}if((n|0)<(c[b>>2]|0)){_=n}else{ga=88;break}}if((ga|0)==88){i=v;return 0}return 0}function Txa(b,d,e,f,g,h,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0;n=i;a[216376]=1;a[216368]=1;c[216388>>2]=6;yPa(216384)|0;e=c[d>>2]|0;c[54090]=1;if((e|0)>=1){d=1;do{POa(216504,b+(d+ -1)|0,1)|0;o=c[54090]|0;d=o+1|0;c[54090]=d;}while((o|0)<(e|0))}gPa()|0;e=c[g>>2]|0;if((e|0)==1){c[216412>>2]=a[216368]&1?6:0;yPa(216408)|0;POa(216504,h,4)|0;gPa()|0;p=c[g>>2]|0}else{p=e}if((p|0)==2){c[216436>>2]=a[216368]&1?6:0;yPa(216432)|0;POa(216504,h,4)|0;POa(216504,j,4)|0;gPa()|0}j=c[k>>2]|0;if((j|0)==1){c[216460>>2]=a[216368]&1?6:0;yPa(216456)|0;POa(216504,l,8)|0;gPa()|0;q=c[k>>2]|0}else{q=j}if((q|0)==2){c[216484>>2]=a[216368]&1?6:0;yPa(216480)|0;POa(216504,l,8)|0;POa(216504,m,8)|0;gPa()|0}if((c[f>>2]|0)==2){xOa(216512,0)|0}else{i=n;return 0}return 0}function Uxa(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0.0,U=0.0,V=0.0,W=0.0,X=0,Y=0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0;y=i;i=i+8|0;z=y;A=c[k>>2]|0;a:do{if((A|0)==1){c[q+36>>2]=c[q+40>>2];B=27}else if((A|0)==0){c[54132]=2;C=2;while(1){D=C+1|0;if(!((c[k+(C+ -1<<2)>>2]|0)>>>0<2)){B=210;break a}c[54132]=D;if((D|0)<12){C=D}else{break}}if((c[d>>2]|0)<1){EOa(216584,218280,80,25);C=216888;D=216896;Txa(216584,218312,217064,C,216968,d,C,C,D,D,80)|0;break}c[54196]=5;D=q+8|0;do{if((c[k+32>>2]|0)==0){E=5}else{C=c[D>>2]|0;c[54196]=C;if(!((C+ -1|0)>>>0>4)){E=C;break}EOa(216584,218320,80,34);C=216888;F=216896;Txa(216584,218360,217056,C,216968,216784,C,C,F,F,80)|0;break a}}while(0);c[D>>2]=E;b:do{if((c[k+20>>2]|0)==0){F=c[d>>2]|0;C=fa(F,F)|0;c[54182]=C;c[54194]=C+50+(fa((c[D>>2]|0)+4|0,c[d>>2]|0)|0);C=q+12|0;if((c[k+16>>2]|0)==0){c[C>>2]=2;break}else{c[C>>2]=1;break}}else{C=c[q>>2]|0;do{if((C|0)>=0){F=c[d>>2]|0;if((C|0)>=(F|0)){break}G=q+4|0;H=c[G>>2]|0;if(!((H|0)>-1&(H|0)<(F|0))){EOa(216584,219144,80,52);I=216888;J=216896;Txa(216584,219128,219200,I,216968,G,I,I,J,J,80)|0;break a}c[54182]=fa((C<<1|1)+H|0,F)|0;F=q+12|0;if((c[k+16>>2]|0)==0){c[F>>2]=5;H=c[d>>2]|0;J=fa((c[D>>2]|0)+4|0,H)|0;c[54194]=(((H|0)/((c[q>>2]|0)+1+(c[G>>2]|0)|0)|0)<<1)+52+(c[54182]|0)+J;break b}else{c[F>>2]=4;F=(fa((c[D>>2]|0)+4|0,c[d>>2]|0)|0)+50|0;c[54194]=F+(c[54182]|0);break b}}}while(0);EOa(216584,219072,80,52);C=216888;F=216896;Txa(216584,219128,219136,C,216968,q,C,C,F,F,80)|0;break a}}while(0);c[54186]=(c[d>>2]|0)+20;c[q+64>>2]=c[54182];if((c[p>>2]|0)<(c[54194]|0)){EOa(216584,218368,80,60);D=216888;F=216896;Txa(216584,218432,218440,D,217064,216776,p,D,F,F,80)|0;break}if((c[r>>2]|0)<(c[54186]|0)){EOa(216584,218448,80,60);F=216888;D=216896;Txa(216584,218432,218512,F,217064,216744,r,F,D,D,80)|0;break}if(+h[j>>3]==+h[e>>3]){B=227;break}if((c[w>>2]|0)<0){EOa(216584,219256,80,24);D=216968;F=216888;C=216896;Txa(216584,219288,219296,D,D,w,F,F,C,C,80)|0;break}do{if((c[k+24>>2]|0)!=0){K=+h[o+8>>3];h[27088]=K;if(!(K<=0.0)){break}EOa(216584,218752,80,28);C=216888;Txa(216584,217464,218784,C,C,C,C,216968,216704,216896,80)|0;break a}}while(0);c[q+60>>2]=0;C=q+36|0;c[C+0>>2]=0;c[C+4>>2]=0;c[C+8>>2]=0;c[C+12>>2]=0;c[n>>2]=1;B=27}else if((A|0)==-1){EOa(216584,216816,80,49);C=216888;F=216896;Txa(216584,216872,216880,C,C,C,C,C,F,F,80)|0;EOa(216584,216904,80,47);F=216888;C=216896;Txa(216584,216952,216960,F,216968,n,F,F,C,C,80)|0;EOa(216584,216976,80,41);C=216888;F=216896;Txa(216584,217024,217032,216968,C,C,C,C,F,F,80)|0;i=y;return 0}else{B=210}}while(0);c:do{if((B|0)==27){a[216760]=0;K=+h[l>>3];h[27099]=K;L=+h[m>>3];h[27092]=L;A=c[d>>2]|0;c[54132]=1;do{if((A|0)>=1){r=k+4|0;p=0;E=1;M=L;N=K;while(1){if((c[r>>2]|0)==1){F=E+ -1|0;O=+h[l+(F<<3)>>3];h[27099]=O;P=+h[m+(F<<3)>>3];h[27092]=P;Q=O;R=P}else{Q=N;R=M}if(Q>0.0|R>0.0){a[216760]=1;S=1}else{S=p}if(Q<0.0){B=215;break}if(R<0.0){B=216;break}F=E+1|0;c[54132]=F;if((E|0)<(A|0)){p=S;E=F;M=R;N=Q}else{B=36;break}}if((B|0)==36){if(!S){break}E=c[d>>2]|0;p=E+51|0;c[54142]=p;r=p+(c[w>>2]|0)|0;c[54144]=r;p=r+(c[w>>2]|0)|0;c[54166]=p;F=p+(c[w>>2]|0)|0;c[54136]=F;C=F+(c[d>>2]|0)|0;c[54172]=C;D=C+(c[d>>2]|0)|0;c[54178]=D;c[54168]=(fa((c[q+8>>2]|0)+1|0,c[d>>2]|0)|0)+D;c[54192]=(c[q+64>>2]|0)+1;d:do{if((c[k>>2]|0)==1){C=o+64|0;h[27101]=+h[C>>3];a[216696]=0;h[27070]=+h[o+24>>3];J=o+16|0;h[27065]=+h[J>>3];do{if((c[w>>2]|0)!=0){Vxa(217064,v,w,d,216560,j,f,o+(F+ -1<<3)|0,o+(D+ -1<<3)|0,o+224|0,q+28|0,o+(E+50<<3)|0,o+(r+ -1<<3)|0,o+(p+ -1<<3)|0,x,216680,C,0,o,q,s,t)|0;if((c[54262]|0)>0){i=y;return 0}if((c[54170]|0)!=1){break}c[q+68>>2]=1;c[n>>2]=4;h[e>>3]=+h[o+320>>3];G=216968;qya(d,o+((c[54136]|0)+ -1<<3)|0,G,g,G)|0;a[216696]=1;B=197;break d}}while(0);do{if((c[k+24>>2]|0)!=0){N=+h[27065];if(!(N>=0.0)){T=-N}else{T=N}M=T/+h[o+8>>3];if(!(M>1.0)){break}h[27065]=N/M}}while(0);M=+h[e>>3];N=+h[j>>3];if(M==N){B=227;break c}P=+h[27065];if((M-N)*P>0.0){B=220;break}C=(c[k+8>>2]|0)==1;do{if((c[k+12>>2]|0)==1){O=+h[o>>3];h[27100]=O;U=+h[27070];V=U-O;G=V*P>0.0;do{if(C){if(G){B=224;break d}W=+h[j>>3];if(P*(O-W)<0.0){B=218;break d}if(P*(U- +h[e>>3])<=0.0){break}H=q+28|0;I=o+((c[54178]|0)+ -1<<3)|0;X=o+224|0;if(P*(U-W)>0.0){_xa(216560,j,f,g,d,H,I,X)|0;if((c[54262]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[216696]=1;B=197;break d}}else{Y=216560;_xa(Y,Y,f,g,d,H,I,X)|0;if((c[54262]|0)>0){i=y;return 0}else{h[e>>3]=+h[27070];c[n>>2]=1;a[216696]=1;B=197;break d}}}else{if(G){B=224;break d}W=+h[j>>3];if(P*(O-W)<0.0){B=218;break d}if(P*(U-W)<0.0){break}_xa(216560,j,f,g,d,q+28|0,o+((c[54178]|0)+ -1<<3)|0,o+224|0)|0;if((c[54262]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[216696]=1;B=197;break d}}}while(0);h[z>>3]=V;if(!(V>=0.0)){Z=-V}else{Z=V}if(!(U>=0.0)){_=-U}else{_=U}if(!(P>=0.0)){$=-P}else{$=P}if(Z>+h[27101]*100.0*(_+$)){if(P*(U+P-O)<=0.0){break}W=O-U;h[27065]=W;h[J>>3]=W;break}_xa(216560,216800,f,g,d,q+28|0,o+((c[54178]|0)+ -1<<3)|0,o+224|0)|0;if((c[54262]|0)>0){i=y;return 0}else{c[n>>2]=2;h[e>>3]=+h[27100];a[216696]=1;B=197;break d}}else{W=+h[27070];if(!C){if(P*(W-N)<0.0){break}_xa(216560,j,f,g,d,q+28|0,o+((c[54178]|0)+ -1<<3)|0,o+224|0)|0;if((c[54262]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[216696]=1;B=197;break d}}if(P*(W-M)<=0.0){break}G=q+28|0;X=o+((c[54178]|0)+ -1<<3)|0;I=o+224|0;if(P*(W-N)>0.0){_xa(216560,j,f,g,d,G,X,I)|0;if((c[54262]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[216696]=1;B=197;break d}}else{H=216560;_xa(H,H,f,g,d,G,X,I)|0;if((c[54262]|0)>0){i=y;return 0}else{h[e>>3]=+h[27070];c[n>>2]=1;a[216696]=1;B=197;break d}}}}while(0);if(a[216696]&1){B=197}else{B=128}}else{h[27070]=+h[e>>3];c[n>>2]=1;Xxa(d,k+4|0,l,m,f,o+((c[54172]|0)+ -1<<3)|0,s,t)|0;C=c[d>>2]|0;c[54132]=1;e:do{if((C|0)>=1){J=c[54172]|0;I=1;while(1){X=I+1|0;if(+h[o+(I+ -2+J<<3)>>3]<=0.0){break}c[54132]=X;if((I|0)<(C|0)){I=X}else{break e}}EOa(216584,218888,80,39);I=216888;J=216896;Txa(216584,218560,218928,I,I,I,I,I,J,J,80)|0;break c}}while(0);U=+cya(217040,1);h[27101]=U;C=o+64|0;h[C>>3]=U;U=+h[e>>3];if(!(U>=0.0)){aa=-U}else{aa=U}h[z>>3]=aa;U=+h[j>>3];if(!(U>=0.0)){ba=-U}else{ba=U}U=+h[27101]*4.0*(aa>=ba?aa:ba);h[27090]=U;O=+h[j>>3]- +h[e>>3];h[z>>3]=O;if(!(O>=0.0)){ca=-O}else{ca=O}if(ca<U){EOa(216584,218936,80,60);J=216888;Txa(216584,218432,219e3,J,J,J,J,217064,j,e,80)|0;break c}do{if((c[k+28>>2]|0)==0){h[27069]=ca*.001;U=+Yxa(d,g,o+((c[54172]|0)+ -1<<3)|0,s,t);if(U>.5/+h[27069]){h[27069]=.5/U}h[z>>3]=+h[j>>3]- +h[e>>3];U=+BOa(216552,z);h[27069]=U;da=U}else{U=+h[o+16>>3];h[27069]=U;if(U*(+h[j>>3]- +h[e>>3])<0.0){B=220;break d}if(!(U==0.0)){da=U;break}EOa(216584,218840,80,29);J=216888;I=216896;Txa(216584,218872,218880,J,J,J,J,J,I,I,80)|0;break c}}while(0);do{if((c[k+24>>2]|0)==0){ea=da}else{if(!(da>=0.0)){ga=-da}else{ga=da}U=ga/+h[o+8>>3];if(!(U>1.0)){ea=da;break}O=da/U;h[27069]=O;ea=O}}while(0);if((c[k+12>>2]|0)==0){ha=ea}else{O=+h[o>>3];h[27100]=O;U=+h[e>>3];V=O-U;if(V*ea<0.0){B=224;break}if(ea*(U+ea-O)>0.0){h[27069]=V;ia=V}else{ia=ea}if((O- +h[j>>3])*ia<0.0){B=218;break}else{ha=ia}}I=k+40|0;if((c[I>>2]|0)==0){ja=ha}else{Zxa(216560,f,g,d,b,u,216552,o+((c[54172]|0)+ -1<<3)|0,n,s,t,o+((c[54178]|0)+ -1<<3)|0,o+400|0,o+((c[54136]|0)+ -1<<3)|0,o+((c[54168]|0)+ -1<<3)|0,q,216720,C,k+36|0,216768)|0;if((c[54262]|0)>0){i=y;return 0}J=c[n>>2]|0;if((J|0)<0){ka=J;B=129;break}ja=+h[27069]}h[27065]=ja;h[o+16>>3]=ja;J=c[54178]|0;X=(c[d>>2]|0)+J|0;c[54188]=X;G=c[d>>2]|0;c[54132]=1;if((G|0)>=1){H=1;while(1){h[o+(H+ -2+J<<3)>>3]=+h[f+(H+ -1<<3)>>3];h[o+(H+ -2+X<<3)>>3]=+h[27065]*+h[g+(H+ -1<<3)>>3];if((H|0)<(G|0)){H=H+1|0}else{break}}c[54132]=G+1}H=o+320|0;h[H>>3]=+h[e>>3];X=q+68|0;c[X>>2]=0;J=o+224|0;h[J>>3]=+h[27065];h[o+232>>3]=+h[27065]*2.0;Y=q+28|0;c[Y>>2]=1;if((c[w>>2]|0)==0){B=128;break}Vxa(216968,v,w,d,e,j,f,o+((c[54136]|0)+ -1<<3)|0,o+((c[54178]|0)+ -1<<3)|0,J,Y,o+((c[54142]|0)+ -1<<3)|0,o+((c[54144]|0)+ -1<<3)|0,o+((c[54166]|0)+ -1<<3)|0,x,216680,C,0,o,q,s,t)|0;if((c[54262]|0)>0){i=y;return 0}if((c[54170]|0)!=0){EOa(216584,219304,80,47);la=216888;ma=216896;Txa(216584,216952,219352,216968,la,la,la,la,ma,ma,80)|0;EOa(216584,219360,80,38);ma=216888;la=216896;Txa(216584,217112,219352,216968,ma,ma,ma,ma,la,la,80)|0;break c}if((c[w>>2]|0)==0){B=128;break}if((c[I>>2]|0)==0){B=128;break}Vxa(217056,v,w,d,216560,j,f,o+((c[54136]|0)+ -1<<3)|0,o+((c[54178]|0)+ -1<<3)|0,J,Y,o+((c[54142]|0)+ -1<<3)|0,o+((c[54144]|0)+ -1<<3)|0,o+((c[54166]|0)+ -1<<3)|0,x,216680,C,0,o,q,s,t)|0;if((c[54262]|0)>0){i=y;return 0}if((c[54170]|0)!=1){B=128;break}c[X>>2]=1;c[n>>2]=4;h[e>>3]=+h[H>>3];H=216968;qya(d,o+((c[54136]|0)+ -1<<3)|0,H,g,H)|0;B=197}}while(0);if((B|0)==218){EOa(216584,218680,80,54);p=216888;Txa(216584,218736,218744,p,p,p,p,217064,216800,j,80)|0;break c}else if((B|0)==220){EOa(216584,218792,80,34);p=216888;Txa(216584,218360,218832,p,p,p,p,217064,j,e,80)|0;break c}else if((B|0)==224){EOa(216584,219008,80,49);p=216888;Txa(216584,216872,219064,p,p,p,p,217064,216800,e,80)|0;break c}f:while(1){if((B|0)==128){B=0;ka=c[n>>2]|0;B=129;continue}else if((B|0)==129){B=0;if((ka|0)==-12){na=-12;break}if(((c[q+40>>2]|0)-(c[q+36>>2]|0)|0)>=500){B=131;break}oa=k+4|0;Xxa(d,oa,l,m,o+((c[54178]|0)+ -1<<3)|0,o+((c[54172]|0)+ -1<<3)|0,s,t)|0;if((c[54262]|0)>0){B=233;break}p=c[d>>2]|0;c[54132]=1;r=c[54172]|0;if((p|0)>=1){E=1;while(1){D=E+1|0;if(!(+h[o+(E+ -2+r<<3)>>3]>0.0)){B=136;break f}c[54132]=D;if((E|0)<(p|0)){E=D}else{break}}}O=+Yxa(d,o+((c[54178]|0)+ -1<<3)|0,o+(r+ -1<<3)|0,s,t)*100.0;V=+h[27101];pa=O*V;h[27067]=pa;if(!(pa<=1.0)){B=138;break}O=+h[27070];if(!(O>=0.0)){qa=-O}else{qa=O}h[z>>3]=qa;O=+h[j>>3];if(!(O>=0.0)){ra=-O}else{ra=O}h[27090]=V*4.0*(qa>=ra?qa:ra);do{if((c[k+24>>2]|0)!=0){V=+h[27065];if(!(V>=0.0)){sa=-V}else{sa=V}O=sa/+h[o+8>>3];if(!(O>1.0)){break}h[27065]=V/O}}while(0);$xa(216560,f,g,d,b,u,216520,o+((c[54172]|0)+ -1<<3)|0,k,n,s,t,o+((c[54178]|0)+ -1<<3)|0,o+400|0,o+((c[54136]|0)+ -1<<3)|0,o+((c[54168]|0)+ -1<<3)|0,q,o+80|0,o+128|0,o+176|0,o+224|0,o+272|0,o+32|0,o+40|0,o+48|0,o+56|0,216720,o+64|0,q+20|0,q+16|0,q+24|0,q+28|0,q+32|0,k+36|0,216768)|0;if((c[54262]|0)>0){B=233;break}r=c[n>>2]|0;if((r|0)<0){na=r;break}do{if((c[w>>2]|0)!=0){Vxa(217056,v,w,d,216560,j,f,o+((c[54136]|0)+ -1<<3)|0,o+((c[54178]|0)+ -1<<3)|0,o+224|0,q+28|0,o+((c[54142]|0)+ -1<<3)|0,o+((c[54144]|0)+ -1<<3)|0,o+((c[54166]|0)+ -1<<3)|0,x,216680,o+64|0,0,o,q,s,t)|0;if((c[54262]|0)>0){B=233;break f}if((c[54170]|0)!=1){break}c[q+68>>2]=1;c[n>>2]=4;h[e>>3]=+h[o+320>>3];r=216968;qya(d,o+((c[54136]|0)+ -1<<3)|0,r,g,r)|0;B=197;continue f}}while(0);r=(c[k+8>>2]|0)!=0;O=+h[27070];V=+h[27065];U=(O- +h[j>>3])*V;if((c[k+12>>2]|0)==0){if(!r){if(U<0.0){B=128;continue}_xa(216560,j,f,g,d,q+28|0,o+((c[54178]|0)+ -1<<3)|0,o+224|0)|0;if((c[54262]|0)>0){B=233;break}c[n>>2]=3;h[e>>3]=+h[j>>3];B=197;continue}if(!(U>=0.0)){h[e>>3]=O;c[n>>2]=1;B=197;continue}_xa(216560,j,f,g,d,q+28|0,o+((c[54178]|0)+ -1<<3)|0,o+224|0)|0;if((c[54262]|0)>0){B=233;break}c[n>>2]=3;h[e>>3]=+h[j>>3];B=197;continue}if(r){if(U>=0.0){_xa(216560,j,f,g,d,q+28|0,o+((c[54178]|0)+ -1<<3)|0,o+224|0)|0;if((c[54262]|0)>0){B=233;break}h[e>>3]=+h[j>>3];c[n>>2]=3;B=197;continue}N=O- +h[27100];h[z>>3]=N;if(!(N>=0.0)){ta=-N}else{ta=N}if(!(O>=0.0)){ua=-O}else{ua=O}if(!(V>=0.0)){va=-V}else{va=V}if(!(ta<=+h[27101]*100.0*(ua+va))){h[e>>3]=O;c[n>>2]=1;B=197;continue}_xa(216560,216800,f,g,d,q+28|0,o+((c[54178]|0)+ -1<<3)|0,o+224|0)|0;if((c[54262]|0)>0){B=233;break}c[n>>2]=2;h[e>>3]=+h[27100];B=197;continue}if(!(U<0.0)){_xa(216560,j,f,g,d,q+28|0,o+((c[54178]|0)+ -1<<3)|0,o+224|0)|0;if((c[54262]|0)>0){B=233;break}h[e>>3]=+h[j>>3];c[n>>2]=3;B=197;continue}U=+h[27100];N=O-U;h[z>>3]=N;if(!(N>=0.0)){wa=-N}else{wa=N}if(!(O>=0.0)){xa=-O}else{xa=O}if(!(V>=0.0)){ya=-V}else{ya=V}if(!(wa<=+h[27101]*100.0*(xa+ya))){if(V*(O+V-U)<=0.0){B=128;continue}h[27065]=U-O;B=128;continue}else{_xa(216560,216800,f,g,d,q+28|0,o+((c[54178]|0)+ -1<<3)|0,o+224|0)|0;if((c[54262]|0)>0){B=233;break}c[n>>2]=2;h[e>>3]=+h[27100];B=197;continue}}else if((B|0)==197){B=0;h[o+24>>3]=+h[27070];h[o+16>>3]=+h[27065];h[o+328>>3]=+h[e>>3];B=233;break}}do{if((B|0)==131){c[n>>2]=-1;na=-1}else if((B|0)==136){c[n>>2]=-3;na=-3}else if((B|0)==138){if((c[oa>>2]|0)!=1){h[l>>3]=pa*+h[l>>3];h[m>>3]=+h[27067]*+h[m>>3];c[n>>2]=-2;na=-2;break}r=c[d>>2]|0;c[54132]=1;if((r|0)>=1){O=pa;E=1;p=0;while(1){C=l+(p<<3)|0;h[C>>3]=O*+h[C>>3];C=m+(E+ -1<<3)|0;h[C>>3]=+h[27067]*+h[C>>3];if((E|0)>=(r|0)){break}C=E;O=+h[27067];E=E+1|0;p=C}c[54132]=r+1}c[n>>2]=-2;na=-2}else if((B|0)==233){i=y;return 0}}while(0);p=0-na|0;c[54188]=p;switch(p|0){case 8:{EOa(216584,217480,80,44);p=216888;Txa(216584,217528,217736,p,p,p,p,217064,216560,216520,80)|0;EOa(216584,217744,80,37);p=216888;E=216896;Txa(216584,217784,217792,p,p,p,p,p,E,E,80)|0;break};case 9:{EOa(216584,217480,80,44);E=216888;Txa(216584,217528,217800,E,E,E,E,217064,216560,216520,80)|0;EOa(216584,217808,80,49);E=216888;p=216896;Txa(216584,216872,217864,E,E,E,E,E,p,p,80)|0;EOa(216584,217872,80,38);p=216888;E=216896;Txa(216584,217112,217912,p,p,p,p,p,E,E,80)|0;break};case 2:{EOa(216584,217200,80,47);E=216888;Txa(216584,216952,217248,E,E,E,E,216968,216560,216896,80)|0;EOa(216584,217256,80,48);E=216888;p=216896;Txa(216584,217184,217312,E,E,E,E,E,p,p,80)|0;EOa(216584,217320,80,45);p=216888;E=216896;Txa(216584,217368,217376,p,p,p,p,p,E,E,80)|0;break};case 3:{EOa(216584,217384,80,38);E=216888;Txa(216584,217112,217424,E,E,E,E,216968,216560,216896,80)|0;EOa(216584,217432,80,28);E=216888;p=216896;Txa(216584,217464,217472,E,E,E,E,E,p,p,80)|0;break};case 6:{EOa(216584,217480,80,44);p=216888;Txa(216584,217528,217536,p,p,p,p,217064,216560,216520,80)|0;EOa(216584,217544,80,57);p=216888;E=216896;Txa(216584,217608,217616,p,p,p,p,p,E,E,80)|0;break};case 7:{EOa(216584,217480,80,44);E=216888;Txa(216584,217528,217624,E,E,E,E,217064,216560,216520,80)|0;EOa(216584,217632,80,48);E=216888;p=216896;Txa(216584,217184,217688,E,E,E,E,E,p,p,80)|0;EOa(216584,217696,80,28);p=216888;E=216896;Txa(216584,217464,217728,p,p,p,p,p,E,E,80)|0;break};case 10:{EOa(216584,217480,80,44);E=216888;Txa(216584,217528,217920,E,E,E,E,217064,216560,216520,80)|0;EOa(216584,217928,80,45);E=216888;p=216896;Txa(216584,217368,217976,E,E,E,E,E,p,p,80)|0;EOa(216584,217984,80,36);p=216888;E=216896;Txa(216584,218024,218032,p,p,p,p,p,E,E,80)|0;break};case 11:{EOa(216584,218040,80,40);E=216888;Txa(216584,218088,218096,E,E,E,E,217064,216560,216520,80)|0;EOa(216584,218104,80,36);E=216888;p=216896;Txa(216584,218024,218144,E,E,E,E,E,p,p,80)|0;break};case 12:{EOa(216584,217480,80,44);p=216888;Txa(216584,217528,218152,p,p,p,p,217064,216560,216552,80)|0;EOa(216584,218160,80,45);p=216888;E=216896;Txa(216584,217368,218208,p,p,p,p,p,E,E,80)|0;break};case 5:case 4:{break};default:{EOa(216584,217072,80,38);E=216888;Txa(216584,217112,217120,E,E,E,E,216968,216560,216896,80)|0;EOa(216584,217128,80,48);E=216888;p=216896;Txa(216584,217184,217192,E,E,E,E,E,p,p,80)|0}}c[k>>2]=-1;h[e>>3]=+h[27070];h[o+24>>3]=+h[27070];h[o+16>>3]=+h[27065];i=y;return 0}else if((B|0)==215){EOa(216584,218520,80,39);p=216888;E=216896;Txa(216584,218560,218568,p,p,p,p,p,E,E,80)|0;break c}else if((B|0)==216){EOa(216584,218576,80,39);E=216888;p=216896;Txa(216584,218560,218616,E,E,E,E,E,p,p,80)|0;break c}}}while(0);EOa(216584,218624,80,47);A=216888;p=216896;Txa(216584,216952,218672,A,A,A,A,A,p,p,80)|0}else if((B|0)==210){EOa(216584,218216,80,55);p=216888;A=216896;Txa(216584,218272,216968,p,p,p,p,p,A,A,80)|0}}while(0);if((B|0)==227){EOa(216584,219208,80,39);B=216888;Txa(216584,218560,219248,B,B,B,B,217064,j,e,80)|0}if((c[k>>2]|0)==-1){EOa(216584,219400,80,46);e=216888;j=216896;Txa(216584,219448,219456,e,e,e,e,e,j,j,80)|0;EOa(216584,219464,80,47);j=216888;e=216896;Txa(216584,216952,219512,216968,j,j,j,j,e,e,80)|0;i=y;return 0}else{c[k>>2]=-1;c[n>>2]=-33;i=y;return 0}return 0}



function QWa(b,e,f,g,h,j,k,l,m,n,o){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0;p=i;i=i+416|0;q=p;r=p+8|0;s=p+408|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;c[q>>2]=o;o=r;c[s>>2]=0;D=w;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=x;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=y;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=z;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=A;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;TWa(f,g,t,u,v,w,x,y,z,B);t=m;c[n>>2]=c[t>>2];g=b;b=e;e=z+4|0;f=z+8|0;D=y+4|0;E=y+8|0;F=(h&512|0)!=0;h=x+4|0;G=x+8|0;H=A+4|0;I=A+8|0;J=s+3|0;K=w+4|0;L=r+400|0;r=o;M=o;o=0;N=0;O=1278;a:while(1){P=c[g>>2]|0;do{if((P|0)==0){Q=1}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){S=oe[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{S=c[R>>2]|0}if((S|0)==-1){c[g>>2]=0;Q=1;break}else{Q=(c[g>>2]|0)==0;break}}}while(0);P=c[b>>2]|0;do{if((P|0)==0){T=15}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){U=oe[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{U=c[R>>2]|0}if((U|0)==-1){c[b>>2]=0;T=15;break}else{if(Q){V=P;break}else{W=M;X=r;Y=N;Z=O;T=276;break a}}}}while(0);if((T|0)==15){T=0;if(Q){W=M;X=r;Y=N;Z=O;T=276;break}else{V=0}}b:do{switch(a[s+o|0]|0){case 2:{if(!((N|0)!=0|o>>>0<2)){if((o|0)==2){_=(a[J]|0)!=0}else{_=0}if(!(F|_)){$=M;aa=r;ba=L;ca=0;da=O;break b}}P=a[x]|0;R=(P&1)==0?h:c[G>>2]|0;c:do{if((o|0)==0){ea=V;fa=V;ga=P;ha=R}else{if((d[s+(o+ -1)|0]|0)<2){ia=P;ja=R}else{ea=V;fa=V;ga=P;ha=R;break}while(1){if((ia&1)==0){ka=h;la=(ia&255)>>>1}else{ka=c[G>>2]|0;la=c[h>>2]|0}if((ja|0)==(ka+(la<<2)|0)){ma=ia;break}if(!(re[c[(c[l>>2]|0)+12>>2]&63](l,8192,c[ja>>2]|0)|0)){T=129;break}ia=a[x]|0;ja=ja+4|0}if((T|0)==129){T=0;ma=a[x]|0}na=(ma&1)==0;oa=ja-(na?h:c[G>>2]|0)>>2;pa=a[A]|0;qa=(pa&1)==0;if(qa){ra=(pa&255)>>>1}else{ra=c[H>>2]|0}d:do{if(!(oa>>>0>ra>>>0)){if(qa){sa=H+(((pa&255)>>>1)-oa<<2)|0;ta=H;ua=(pa&255)>>>1}else{va=c[I>>2]|0;wa=c[H>>2]|0;sa=va+(wa-oa<<2)|0;ta=va;ua=wa}wa=ta+(ua<<2)|0;if((sa|0)==(wa|0)){ea=V;fa=V;ga=ma;ha=ja;break c}else{xa=na?h:c[G>>2]|0;ya=sa}while(1){if((c[ya>>2]|0)!=(c[xa>>2]|0)){break d}va=ya+4|0;if((va|0)==(wa|0)){ea=V;fa=V;ga=ma;ha=ja;break c}xa=xa+4|0;ya=va}}}while(0);ea=V;fa=V;ga=ma;ha=na?h:c[G>>2]|0}}while(0);e:while(1){if((ga&1)==0){za=h;Aa=(ga&255)>>>1}else{za=c[G>>2]|0;Aa=c[h>>2]|0}if((ha|0)==(za+(Aa<<2)|0)){break}R=c[g>>2]|0;do{if((R|0)==0){Ba=1}else{P=c[R+12>>2]|0;if((P|0)==(c[R+16>>2]|0)){Ca=oe[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{Ca=c[P>>2]|0}if((Ca|0)==-1){c[g>>2]=0;Ba=1;break}else{Ba=(c[g>>2]|0)==0;break}}}while(0);do{if((fa|0)==0){Da=ea;T=159}else{R=c[fa+12>>2]|0;if((R|0)==(c[fa+16>>2]|0)){Ea=oe[c[(c[fa>>2]|0)+36>>2]&127](fa)|0}else{Ea=c[R>>2]|0}if((Ea|0)==-1){c[b>>2]=0;Da=0;T=159;break}else{if(Ba^(ea|0)==0){Fa=ea;Ga=ea;break}else{break e}}}}while(0);if((T|0)==159){T=0;if(Ba){break}else{Fa=Da;Ga=0}}R=c[g>>2]|0;na=c[R+12>>2]|0;if((na|0)==(c[R+16>>2]|0)){Ha=oe[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{Ha=c[na>>2]|0}if((Ha|0)!=(c[ha>>2]|0)){break}na=c[g>>2]|0;R=na+12|0;P=c[R>>2]|0;if((P|0)==(c[na+16>>2]|0)){oe[c[(c[na>>2]|0)+40>>2]&127](na)|0}else{c[R>>2]=P+4}ea=Fa;fa=Ga;ga=a[x]|0;ha=ha+4|0}if(!F){$=M;aa=r;ba=L;ca=N;da=O;break b}P=a[x]|0;if((P&1)==0){Ia=h;Ja=(P&255)>>>1}else{Ia=c[G>>2]|0;Ja=c[h>>2]|0}if((ha|0)==(Ia+(Ja<<2)|0)){$=M;aa=r;ba=L;ca=N;da=O}else{T=174;break a}break};case 3:{P=a[y]|0;R=(P&1)==0;if(R){Ka=(P&255)>>>1}else{Ka=c[D>>2]|0}na=a[z]|0;oa=(na&1)==0;if(oa){La=(na&255)>>>1}else{La=c[e>>2]|0}if((Ka|0)==(0-La|0)){$=M;aa=r;ba=L;ca=N;da=O;break b}if(R){Ma=(P&255)>>>1}else{Ma=c[D>>2]|0}do{if((Ma|0)!=0){if(oa){Na=(na&255)>>>1}else{Na=c[e>>2]|0}if((Na|0)==0){break}pa=c[g>>2]|0;qa=c[pa+12>>2]|0;if((qa|0)==(c[pa+16>>2]|0)){wa=oe[c[(c[pa>>2]|0)+36>>2]&127](pa)|0;Oa=wa;Pa=a[y]|0}else{Oa=c[qa>>2]|0;Pa=P}qa=c[g>>2]|0;wa=qa+12|0;pa=c[wa>>2]|0;va=(pa|0)==(c[qa+16>>2]|0);if((Oa|0)==(c[((Pa&1)==0?D:c[E>>2]|0)>>2]|0)){if(va){oe[c[(c[qa>>2]|0)+40>>2]&127](qa)|0}else{c[wa>>2]=pa+4}wa=a[y]|0;if((wa&1)==0){Qa=(wa&255)>>>1}else{Qa=c[D>>2]|0}$=M;aa=r;ba=L;ca=Qa>>>0>1?y:N;da=O;break b}if(va){Ra=oe[c[(c[qa>>2]|0)+36>>2]&127](qa)|0}else{Ra=c[pa>>2]|0}if((Ra|0)!=(c[((a[z]&1)==0?e:c[f>>2]|0)>>2]|0)){T=116;break a}pa=c[g>>2]|0;qa=pa+12|0;va=c[qa>>2]|0;if((va|0)==(c[pa+16>>2]|0)){oe[c[(c[pa>>2]|0)+40>>2]&127](pa)|0}else{c[qa>>2]=va+4}a[k]=1;va=a[z]|0;if((va&1)==0){Sa=(va&255)>>>1}else{Sa=c[e>>2]|0}$=M;aa=r;ba=L;ca=Sa>>>0>1?z:N;da=O;break b}}while(0);if(R){Ta=(P&255)>>>1}else{Ta=c[D>>2]|0}oa=c[g>>2]|0;va=c[oa+12>>2]|0;qa=(va|0)==(c[oa+16>>2]|0);if((Ta|0)==0){if(qa){pa=oe[c[(c[oa>>2]|0)+36>>2]&127](oa)|0;Ua=pa;Va=a[z]|0}else{Ua=c[va>>2]|0;Va=na}if((Ua|0)!=(c[((Va&1)==0?e:c[f>>2]|0)>>2]|0)){$=M;aa=r;ba=L;ca=N;da=O;break b}pa=c[g>>2]|0;wa=pa+12|0;Wa=c[wa>>2]|0;if((Wa|0)==(c[pa+16>>2]|0)){oe[c[(c[pa>>2]|0)+40>>2]&127](pa)|0}else{c[wa>>2]=Wa+4}a[k]=1;Wa=a[z]|0;if((Wa&1)==0){Xa=(Wa&255)>>>1}else{Xa=c[e>>2]|0}$=M;aa=r;ba=L;ca=Xa>>>0>1?z:N;da=O;break b}if(qa){qa=oe[c[(c[oa>>2]|0)+36>>2]&127](oa)|0;Ya=qa;Za=a[y]|0}else{Ya=c[va>>2]|0;Za=P}if((Ya|0)!=(c[((Za&1)==0?D:c[E>>2]|0)>>2]|0)){a[k]=1;$=M;aa=r;ba=L;ca=N;da=O;break b}va=c[g>>2]|0;qa=va+12|0;oa=c[qa>>2]|0;if((oa|0)==(c[va+16>>2]|0)){oe[c[(c[va>>2]|0)+40>>2]&127](va)|0}else{c[qa>>2]=oa+4}oa=a[y]|0;if((oa&1)==0){_a=(oa&255)>>>1}else{_a=c[D>>2]|0}$=M;aa=r;ba=L;ca=_a>>>0>1?y:N;da=O;break};case 0:{T=28;break};case 4:{oa=M;qa=r;va=L;Wa=0;wa=O;f:while(1){pa=c[g>>2]|0;do{if((pa|0)==0){$a=1}else{ab=c[pa+12>>2]|0;if((ab|0)==(c[pa+16>>2]|0)){bb=oe[c[(c[pa>>2]|0)+36>>2]&127](pa)|0}else{bb=c[ab>>2]|0}if((bb|0)==-1){c[g>>2]=0;$a=1;break}else{$a=(c[g>>2]|0)==0;break}}}while(0);pa=c[b>>2]|0;do{if((pa|0)==0){T=188}else{ab=c[pa+12>>2]|0;if((ab|0)==(c[pa+16>>2]|0)){cb=oe[c[(c[pa>>2]|0)+36>>2]&127](pa)|0}else{cb=c[ab>>2]|0}if((cb|0)==-1){c[b>>2]=0;T=188;break}else{if($a){break}else{break f}}}}while(0);if((T|0)==188){T=0;if($a){break}}pa=c[g>>2]|0;ab=c[pa+12>>2]|0;if((ab|0)==(c[pa+16>>2]|0)){db=oe[c[(c[pa>>2]|0)+36>>2]&127](pa)|0}else{db=c[ab>>2]|0}if(re[c[(c[l>>2]|0)+12>>2]&63](l,2048,db)|0){ab=c[n>>2]|0;if((ab|0)==(c[q>>2]|0)){UWa(m,n,q);eb=c[n>>2]|0}else{eb=ab}c[n>>2]=eb+4;c[eb>>2]=db;fb=oa;gb=qa;hb=va;ib=Wa+1|0;jb=wa}else{ab=a[w]|0;if((ab&1)==0){kb=(ab&255)>>>1}else{kb=c[K>>2]|0}if((kb|0)==0|(Wa|0)==0){break}if((db|0)!=(c[v>>2]|0)){break}if((qa|0)==(va|0)){ab=qa-oa|0;pa=ab>>>0<2147483647?ab<<1:-1;if((wa|0)!=1278){lb=oa}else{lb=0}mb=Y_a(lb,pa)|0;if((mb|0)==0){T=206;break a}nb=mb;ob=mb+(ab>>2<<2)|0;pb=mb+(pa>>>2<<2)|0;qb=1253}else{nb=oa;ob=qa;pb=va;qb=wa}c[ob>>2]=Wa;fb=nb;gb=ob+4|0;hb=pb;ib=0;jb=qb}pa=c[g>>2]|0;mb=pa+12|0;ab=c[mb>>2]|0;if((ab|0)==(c[pa+16>>2]|0)){oe[c[(c[pa>>2]|0)+40>>2]&127](pa)|0;oa=fb;qa=gb;va=hb;Wa=ib;wa=jb;continue}else{c[mb>>2]=ab+4;oa=fb;qa=gb;va=hb;Wa=ib;wa=jb;continue}}if((oa|0)==(qa|0)|(Wa|0)==0){rb=oa;sb=qa;tb=va;ub=wa}else{if((qa|0)==(va|0)){P=qa-oa|0;na=P>>>0<2147483647?P<<1:-1;if((wa|0)!=1278){vb=oa}else{vb=0}R=Y_a(vb,na)|0;if((R|0)==0){T=217;break a}wb=R;xb=R+(P>>2<<2)|0;yb=R+(na>>>2<<2)|0;zb=1253}else{wb=oa;xb=qa;yb=va;zb=wa}c[xb>>2]=Wa;rb=wb;sb=xb+4|0;tb=yb;ub=zb}na=c[B>>2]|0;if((na|0)>0){R=c[g>>2]|0;do{if((R|0)==0){Ab=1}else{P=c[R+12>>2]|0;if((P|0)==(c[R+16>>2]|0)){Bb=oe[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{Bb=c[P>>2]|0}if((Bb|0)==-1){c[g>>2]=0;Ab=1;break}else{Ab=(c[g>>2]|0)==0;break}}}while(0);R=c[b>>2]|0;do{if((R|0)==0){T=234}else{Wa=c[R+12>>2]|0;if((Wa|0)==(c[R+16>>2]|0)){Cb=oe[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{Cb=c[Wa>>2]|0}if((Cb|0)==-1){c[b>>2]=0;T=234;break}else{if(Ab){Db=R;break}else{T=240;break a}}}}while(0);if((T|0)==234){T=0;if(Ab){T=240;break a}else{Db=0}}R=c[g>>2]|0;Wa=c[R+12>>2]|0;if((Wa|0)==(c[R+16>>2]|0)){Eb=oe[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{Eb=c[Wa>>2]|0}if((Eb|0)!=(c[u>>2]|0)){T=240;break a}Wa=c[g>>2]|0;R=Wa+12|0;wa=c[R>>2]|0;if((wa|0)==(c[Wa+16>>2]|0)){oe[c[(c[Wa>>2]|0)+40>>2]&127](Wa)|0;Fb=Db;Gb=na;Hb=Db}else{c[R>>2]=wa+4;Fb=Db;Gb=na;Hb=Db}while(1){wa=c[g>>2]|0;do{if((wa|0)==0){Ib=1}else{R=c[wa+12>>2]|0;if((R|0)==(c[wa+16>>2]|0)){Jb=oe[c[(c[wa>>2]|0)+36>>2]&127](wa)|0}else{Jb=c[R>>2]|0}if((Jb|0)==-1){c[g>>2]=0;Ib=1;break}else{Ib=(c[g>>2]|0)==0;break}}}while(0);do{if((Hb|0)==0){Kb=Fb;T=257}else{wa=c[Hb+12>>2]|0;if((wa|0)==(c[Hb+16>>2]|0)){Lb=oe[c[(c[Hb>>2]|0)+36>>2]&127](Hb)|0}else{Lb=c[wa>>2]|0}if((Lb|0)==-1){c[b>>2]=0;Kb=0;T=257;break}else{if(Ib^(Fb|0)==0){Mb=Fb;Nb=Fb;break}else{T=263;break a}}}}while(0);if((T|0)==257){T=0;if(Ib){T=263;break a}else{Mb=Kb;Nb=0}}wa=c[g>>2]|0;R=c[wa+12>>2]|0;if((R|0)==(c[wa+16>>2]|0)){Ob=oe[c[(c[wa>>2]|0)+36>>2]&127](wa)|0}else{Ob=c[R>>2]|0}if(!(re[c[(c[l>>2]|0)+12>>2]&63](l,2048,Ob)|0)){T=263;break a}if((c[n>>2]|0)==(c[q>>2]|0)){UWa(m,n,q)}R=c[g>>2]|0;wa=c[R+12>>2]|0;if((wa|0)==(c[R+16>>2]|0)){Pb=oe[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{Pb=c[wa>>2]|0}wa=c[n>>2]|0;c[n>>2]=wa+4;c[wa>>2]=Pb;wa=Gb+ -1|0;c[B>>2]=wa;R=c[g>>2]|0;Wa=R+12|0;va=c[Wa>>2]|0;if((va|0)==(c[R+16>>2]|0)){oe[c[(c[R>>2]|0)+40>>2]&127](R)|0}else{c[Wa>>2]=va+4}if((wa|0)>0){Fb=Mb;Gb=wa;Hb=Nb}else{break}}}if((c[n>>2]|0)==(c[t>>2]|0)){T=274;break a}else{$=rb;aa=sb;ba=tb;ca=N;da=ub}break};case 1:{if((o|0)==3){W=M;X=r;Y=N;Z=O;T=276;break a}na=c[g>>2]|0;wa=c[na+12>>2]|0;if((wa|0)==(c[na+16>>2]|0)){Qb=oe[c[(c[na>>2]|0)+36>>2]&127](na)|0}else{Qb=c[wa>>2]|0}if(!(re[c[(c[l>>2]|0)+12>>2]&63](l,8192,Qb)|0)){T=27;break a}wa=c[g>>2]|0;na=wa+12|0;va=c[na>>2]|0;if((va|0)==(c[wa+16>>2]|0)){Rb=oe[c[(c[wa>>2]|0)+40>>2]&127](wa)|0}else{c[na>>2]=va+4;Rb=c[va>>2]|0}wRa(A,Rb);T=28;break};default:{$=M;aa=r;ba=L;ca=N;da=O}}}while(0);g:do{if((T|0)==28){T=0;if((o|0)==3){W=M;X=r;Y=N;Z=O;T=276;break a}else{Sb=V;Tb=V}while(1){va=c[g>>2]|0;do{if((va|0)==0){Ub=1}else{na=c[va+12>>2]|0;if((na|0)==(c[va+16>>2]|0)){Vb=oe[c[(c[va>>2]|0)+36>>2]&127](va)|0}else{Vb=c[na>>2]|0}if((Vb|0)==-1){c[g>>2]=0;Ub=1;break}else{Ub=(c[g>>2]|0)==0;break}}}while(0);do{if((Tb|0)==0){Wb=Sb;T=42}else{va=c[Tb+12>>2]|0;if((va|0)==(c[Tb+16>>2]|0)){Xb=oe[c[(c[Tb>>2]|0)+36>>2]&127](Tb)|0}else{Xb=c[va>>2]|0}if((Xb|0)==-1){c[b>>2]=0;Wb=0;T=42;break}else{if(Ub^(Sb|0)==0){Yb=Sb;Zb=Sb;break}else{$=M;aa=r;ba=L;ca=N;da=O;break g}}}}while(0);if((T|0)==42){T=0;if(Ub){$=M;aa=r;ba=L;ca=N;da=O;break g}else{Yb=Wb;Zb=0}}va=c[g>>2]|0;na=c[va+12>>2]|0;if((na|0)==(c[va+16>>2]|0)){_b=oe[c[(c[va>>2]|0)+36>>2]&127](va)|0}else{_b=c[na>>2]|0}if(!(re[c[(c[l>>2]|0)+12>>2]&63](l,8192,_b)|0)){$=M;aa=r;ba=L;ca=N;da=O;break g}na=c[g>>2]|0;va=na+12|0;wa=c[va>>2]|0;if((wa|0)==(c[na+16>>2]|0)){$b=oe[c[(c[na>>2]|0)+40>>2]&127](na)|0}else{c[va>>2]=wa+4;$b=c[wa>>2]|0}wRa(A,$b);Sb=Yb;Tb=Zb}}}while(0);wa=o+1|0;if(wa>>>0<4){L=ba;r=aa;M=$;o=wa;N=ca;O=da}else{W=$;X=aa;Y=ca;Z=da;T=276;break}}h:do{if((T|0)==27){c[j>>2]=c[j>>2]|4;ac=0;bc=M;cc=O}else if((T|0)==116){c[j>>2]=c[j>>2]|4;ac=0;bc=M;cc=O}else if((T|0)==174){c[j>>2]=c[j>>2]|4;ac=0;bc=M;cc=O}else if((T|0)==206){g$a()}else if((T|0)==217){g$a()}else if((T|0)==240){c[j>>2]=c[j>>2]|4;ac=0;bc=rb;cc=ub}else if((T|0)==263){c[j>>2]=c[j>>2]|4;ac=0;bc=rb;cc=ub}else if((T|0)==274){c[j>>2]=c[j>>2]|4;ac=0;bc=rb;cc=ub}else if((T|0)==276){i:do{if((Y|0)!=0){da=Y+4|0;ca=Y+8|0;aa=1;j:while(1){$=a[Y]|0;if(($&1)==0){dc=($&255)>>>1}else{dc=c[da>>2]|0}if(!(aa>>>0<dc>>>0)){break i}$=c[g>>2]|0;do{if(($|0)==0){ec=1}else{N=c[$+12>>2]|0;if((N|0)==(c[$+16>>2]|0)){fc=oe[c[(c[$>>2]|0)+36>>2]&127]($)|0}else{fc=c[N>>2]|0}if((fc|0)==-1){c[g>>2]=0;ec=1;break}else{ec=(c[g>>2]|0)==0;break}}}while(0);$=c[b>>2]|0;do{if(($|0)==0){T=295}else{N=c[$+12>>2]|0;if((N|0)==(c[$+16>>2]|0)){gc=oe[c[(c[$>>2]|0)+36>>2]&127]($)|0}else{gc=c[N>>2]|0}if((gc|0)==-1){c[b>>2]=0;T=295;break}else{if(ec){break}else{break j}}}}while(0);if((T|0)==295){T=0;if(ec){break}}$=c[g>>2]|0;N=c[$+12>>2]|0;if((N|0)==(c[$+16>>2]|0)){hc=oe[c[(c[$>>2]|0)+36>>2]&127]($)|0}else{hc=c[N>>2]|0}if((a[Y]&1)==0){ic=da}else{ic=c[ca>>2]|0}if((hc|0)!=(c[ic+(aa<<2)>>2]|0)){break}N=aa+1|0;$=c[g>>2]|0;o=$+12|0;r=c[o>>2]|0;if((r|0)==(c[$+16>>2]|0)){oe[c[(c[$>>2]|0)+40>>2]&127]($)|0;aa=N;continue}else{c[o>>2]=r+4;aa=N;continue}}c[j>>2]=c[j>>2]|4;ac=0;bc=W;cc=Z;break h}}while(0);if((W|0)==(X|0)){ac=1;bc=X;cc=Z;break}c[C>>2]=0;MWa(w,W,X,C);if((c[C>>2]|0)==0){ac=1;bc=W;cc=Z;break}c[j>>2]=c[j>>2]|4;ac=0;bc=W;cc=Z}}while(0);sRa(A);sRa(z);sRa(y);sRa(x);QQa(w);if((bc|0)==0){i=p;return ac|0}le[cc&2047](bc);i=p;return ac|0}function RWa(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=i;i=i+464|0;l=d;m=d+8|0;n=d+24|0;o=d+424|0;p=d+432|0;q=d+440|0;r=d+448|0;s=d+456|0;t=o;c[t>>2]=n;u=o+4|0;c[u>>2]=1278;v=n+400|0;MRa(q,h);n=q;w=c[n>>2]|0;if(!((c[70110]|0)==-1)){c[m>>2]=280440;c[m+4>>2]=1276;c[m+8>>2]=0;BQa(280440,m,1277)}m=(c[280444>>2]|0)+ -1|0;x=c[w+8>>2]|0;if(!((c[w+12>>2]|0)-x>>2>>>0>m>>>0)){y=Hc(4)|0;z=y;A_a(z);A=296008;B=128;Zd(y|0,A|0,B|0)}w=c[x+(m<<2)>>2]|0;if((w|0)==0){y=Hc(4)|0;z=y;A_a(z);A=296008;B=128;Zd(y|0,A|0,B|0)}B=w;a[r]=0;A=f;f=c[A>>2]|0;c[s>>2]=f;y=c[h+4>>2]|0;h=l;z=s;c[h+0>>2]=c[z+0>>2];z=QWa(e,l,g,q,y,j,r,B,o,p,v)|0;if(z){if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}if((a[r]|0)!=0){wRa(k,De[c[(c[w>>2]|0)+44>>2]&63](B,45)|0)}r=De[c[(c[w>>2]|0)+44>>2]&63](B,48)|0;B=c[t>>2]|0;w=c[p>>2]|0;p=w+ -4|0;a:do{if(B>>>0<p>>>0){z=B;while(1){v=z+4|0;if((c[z>>2]|0)!=(r|0)){C=z;break a}if(v>>>0<p>>>0){z=v}else{C=v;break}}}else{C=B}}while(0);SWa(k,C,w)|0}w=e;e=c[w>>2]|0;do{if((e|0)==0){D=1}else{C=c[e+12>>2]|0;if((C|0)==(c[e+16>>2]|0)){E=oe[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{E=c[C>>2]|0}if((E|0)==-1){c[w>>2]=0;D=1;break}else{D=(c[w>>2]|0)==0;break}}}while(0);do{if((f|0)==0){F=29}else{E=c[f+12>>2]|0;if((E|0)==(c[f+16>>2]|0)){G=oe[c[(c[f>>2]|0)+36>>2]&127](f)|0}else{G=c[E>>2]|0}if((G|0)==-1){c[A>>2]=0;F=29;break}else{if(D){break}else{F=31;break}}}}while(0);if((F|0)==29){if(D){F=31}}if((F|0)==31){c[j>>2]=c[j>>2]|2}c[b>>2]=c[w>>2];gQa(c[n>>2]|0)|0;n=c[t>>2]|0;c[t>>2]=0;if((n|0)==0){i=d;return}le[c[u>>2]&2047](n);i=d;return}function SWa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=d;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1;k=h;l=1}else{h=c[b>>2]|0;j=c[b+4>>2]|0;k=h&255;l=(h&-2)+ -1|0}h=e-g>>2;if((h|0)==0){i=f;return b|0}if((l-j|0)>>>0<h>>>0){yRa(b,l,j+h-l|0,j,j,0,0);m=a[b]|0}else{m=k}if((m&1)==0){n=b+4|0}else{n=c[b+8>>2]|0}m=n+(j<<2)|0;if((d|0)==(e|0)){o=m}else{k=j+((e+ -4+(0-g)|0)>>>2)+1|0;g=d;d=m;while(1){c[d>>2]=c[g>>2];m=g+4|0;if((m|0)==(e|0)){break}else{d=d+4|0;g=m}}o=n+(k<<2)|0}c[o>>2]=0;o=j+h|0;if((a[b]&1)==0){a[b]=o<<1;i=f;return b|0}else{c[b+4>>2]=o;i=f;return b|0}return 0}function TWa(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;n=i;i=i+176|0;o=n;p=n+16|0;q=n+32|0;r=n+40|0;s=n+56|0;t=n+72|0;u=n+88|0;v=n+104|0;w=n+112|0;x=n+128|0;y=n+144|0;z=n+160|0;if(b){b=c[d>>2]|0;if(!((c[70004]|0)==-1)){c[p>>2]=280016;c[p+4>>2]=1276;c[p+8>>2]=0;BQa(280016,p,1277)}p=(c[280020>>2]|0)+ -1|0;A=c[b+8>>2]|0;if(!((c[b+12>>2]|0)-A>>2>>>0>p>>>0)){B=Hc(4)|0;C=B;A_a(C);D=296008;E=128;Zd(B|0,D|0,E|0)}b=c[A+(p<<2)>>2]|0;if((b|0)==0){B=Hc(4)|0;C=B;A_a(C);D=296008;E=128;Zd(B|0,D|0,E|0)}E=b;me[c[(c[b>>2]|0)+44>>2]&127](q,E);D=e;B=c[q>>2]|0;a[D]=B;a[D+1|0]=B>>8;a[D+2|0]=B>>16;a[D+3|0]=B>>24;me[c[(c[b>>2]|0)+32>>2]&127](r,E);B=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}vRa(l,0);D=r;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;sRa(r);me[c[(c[b>>2]|0)+28>>2]&127](s,E);r=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}vRa(k,0);D=s;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;sRa(s);c[f>>2]=oe[c[(c[b>>2]|0)+12>>2]&127](E)|0;c[g>>2]=oe[c[(c[b>>2]|0)+16>>2]&127](E)|0;me[c[(c[b>>2]|0)+20>>2]&127](t,E);s=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}aRa(h,0);D=t;c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;QQa(t);me[c[(c[b>>2]|0)+24>>2]&127](u,E);t=j;if((a[j]&1)==0){c[j+4>>2]=0;a[j]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}vRa(j,0);D=u;c[t+0>>2]=c[D+0>>2];c[t+4>>2]=c[D+4>>2];c[t+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;sRa(u);F=oe[c[(c[b>>2]|0)+36>>2]&127](E)|0;c[m>>2]=F;i=n;return}else{E=c[d>>2]|0;if(!((c[69988]|0)==-1)){c[o>>2]=279952;c[o+4>>2]=1276;c[o+8>>2]=0;BQa(279952,o,1277)}o=(c[279956>>2]|0)+ -1|0;d=c[E+8>>2]|0;if(!((c[E+12>>2]|0)-d>>2>>>0>o>>>0)){G=Hc(4)|0;H=G;A_a(H);I=296008;J=128;Zd(G|0,I|0,J|0)}E=c[d+(o<<2)>>2]|0;if((E|0)==0){G=Hc(4)|0;H=G;A_a(H);I=296008;J=128;Zd(G|0,I|0,J|0)}J=E;me[c[(c[E>>2]|0)+44>>2]&127](v,J);I=e;e=c[v>>2]|0;a[I]=e;a[I+1|0]=e>>8;a[I+2|0]=e>>16;a[I+3|0]=e>>24;me[c[(c[E>>2]|0)+32>>2]&127](w,J);e=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}vRa(l,0);l=w;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;sRa(w);me[c[(c[E>>2]|0)+28>>2]&127](x,J);w=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}vRa(k,0);k=x;c[w+0>>2]=c[k+0>>2];c[w+4>>2]=c[k+4>>2];c[w+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;sRa(x);c[f>>2]=oe[c[(c[E>>2]|0)+12>>2]&127](J)|0;c[g>>2]=oe[c[(c[E>>2]|0)+16>>2]&127](J)|0;me[c[(c[E>>2]|0)+20>>2]&127](y,J);g=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}aRa(h,0);h=y;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;QQa(y);me[c[(c[E>>2]|0)+24>>2]&127](z,J);y=j;if((a[j]&1)==0){c[j+4>>2]=0;a[j]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}vRa(j,0);j=z;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;sRa(z);F=oe[c[(c[E>>2]|0)+36>>2]&127](J)|0;c[m>>2]=F;i=n;return}}function UWa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=a+4|0;g=(c[f>>2]|0)!=1278;h=a;a=c[h>>2]|0;j=a;k=(c[d>>2]|0)-j|0;l=k>>>0<2147483647?k<<1:-1;k=(c[b>>2]|0)-j>>2;if(g){m=a}else{m=0}a=Y_a(m,l)|0;m=a;if((a|0)==0){g$a()}do{if(g){c[h>>2]=m;n=m}else{a=c[h>>2]|0;c[h>>2]=m;if((a|0)==0){n=m;break}le[c[f>>2]&2047](a);n=c[h>>2]|0}}while(0);c[f>>2]=1253;c[b>>2]=n+(k<<2);c[d>>2]=(c[h>>2]|0)+(l>>>2<<2);i=e;return}function VWa(a){a=a|0;var b=0;b=i;b$a(a);i=b;return}function WWa(a){a=a|0;i=i;return}function XWa(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+16|0;m=d;n=d+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+104|0;r=i;i=i+8|0;s=i;i=i+104|0;t=i;i=i+8|0;u=i;i=i+8|0;v=u;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+104|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=q;c[r>>2]=G;q=s;s=o;h[k>>3]=l;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=Pc(G|0,100,280200,o|0)|0;do{if(s>>>0>99){do{if((a[280344]|0)==0){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);o=c[70084]|0;G=n;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=PUa(r,o,280200,n)|0;o=c[r>>2]|0;if((o|0)==0){g$a()}H=V_a(G)|0;if((H|0)!=0){I=o;J=H;K=H;L=G;break}g$a()}else{I=0;J=0;K=q;L=s}}while(0);MRa(t,g);s=t;q=c[s>>2]|0;if(!((c[70112]|0)==-1)){c[p>>2]=280448;c[p+4>>2]=1276;c[p+8>>2]=0;BQa(280448,p,1277)}p=(c[280452>>2]|0)+ -1|0;n=c[q+8>>2]|0;if(!((c[q+12>>2]|0)-n>>2>>>0>p>>>0)){M=Hc(4)|0;N=M;A_a(N);O=296008;P=128;Zd(M|0,O|0,P|0)}q=c[n+(p<<2)>>2]|0;if((q|0)==0){M=Hc(4)|0;N=M;A_a(N);O=296008;P=128;Zd(M|0,O|0,P|0)}P=q;O=c[r>>2]|0;Ne[c[(c[q>>2]|0)+32>>2]&63](P,O,O+L|0,K)|0;if((L|0)==0){Q=0}else{Q=(a[c[r>>2]|0]|0)==45}c[u>>2]=0;u=y;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=z;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=A;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;YWa(f,Q,t,v,w,x,y,z,A,B);t=C;C=c[B>>2]|0;if((L|0)>(C|0)){B=a[A]|0;if((B&1)==0){R=(B&255)>>>1}else{R=c[A+4>>2]|0}B=a[z]|0;if((B&1)==0){S=(B&255)>>>1}else{S=c[z+4>>2]|0}T=R+(L-C<<1|1)+S|0}else{S=a[A]|0;if((S&1)==0){U=(S&255)>>>1}else{U=c[A+4>>2]|0}S=a[z]|0;if((S&1)==0){V=(S&255)>>>1}else{V=c[z+4>>2]|0}T=U+2+V|0}V=T+C|0;do{if(V>>>0>100){T=V_a(V)|0;if((T|0)!=0){W=T;X=T;break}g$a()}else{W=0;X=t}}while(0);ZWa(X,D,E,c[g+4>>2]|0,K,K+L|0,P,Q,v,a[w]|0,a[x]|0,y,z,A,C);c[F>>2]=c[e>>2];e=c[D>>2]|0;D=c[E>>2]|0;E=m;C=F;c[E+0>>2]=c[C+0>>2];mNa(b,m,X,e,D,g,j);if((W|0)!=0){W_a(W)}QQa(A);QQa(z);QQa(y);gQa(c[s>>2]|0)|0;if((J|0)!=0){W_a(J)}if((I|0)==0){i=d;return}W_a(I);i=d;return}function YWa(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+40|0;o=n;p=n+16|0;q=n+32|0;r=q;s=i;i=i+16|0;t=i;i=i+8|0;u=t;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=B;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[e>>2]|0;if(b){if(!((c[69972]|0)==-1)){c[p>>2]=279888;c[p+4>>2]=1276;c[p+8>>2]=0;BQa(279888,p,1277)}p=(c[279892>>2]|0)+ -1|0;b=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-b>>2>>>0>p>>>0)){H=Hc(4)|0;I=H;A_a(I);J=296008;K=128;Zd(H|0,J|0,K|0)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){H=Hc(4)|0;I=H;A_a(I);J=296008;K=128;Zd(H|0,J|0,K|0)}K=e;J=c[e>>2]|0;if(d){me[c[J+44>>2]&127](r,K);r=f;H=c[q>>2]|0;a[r]=H;a[r+1|0]=H>>8;a[r+2|0]=H>>16;a[r+3|0]=H>>24;me[c[(c[e>>2]|0)+32>>2]&127](s,K);H=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}aRa(l,0);r=s;c[H+0>>2]=c[r+0>>2];c[H+4>>2]=c[r+4>>2];c[H+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;QQa(s)}else{me[c[J+40>>2]&127](u,K);u=f;J=c[t>>2]|0;a[u]=J;a[u+1|0]=J>>8;a[u+2|0]=J>>16;a[u+3|0]=J>>24;me[c[(c[e>>2]|0)+28>>2]&127](v,K);J=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}aRa(l,0);u=v;c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;QQa(v)}a[g]=oe[c[(c[e>>2]|0)+12>>2]&127](K)|0;a[h]=oe[c[(c[e>>2]|0)+16>>2]&127](K)|0;me[c[(c[e>>2]|0)+20>>2]&127](w,K);v=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}aRa(j,0);u=w;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;QQa(w);me[c[(c[e>>2]|0)+24>>2]&127](x,K);w=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}aRa(k,0);u=x;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;QQa(x);L=oe[c[(c[e>>2]|0)+36>>2]&127](K)|0;c[m>>2]=L;i=n;return}else{if(!((c[69956]|0)==-1)){c[o>>2]=279824;c[o+4>>2]=1276;c[o+8>>2]=0;BQa(279824,o,1277)}o=(c[279828>>2]|0)+ -1|0;K=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-K>>2>>>0>o>>>0)){M=Hc(4)|0;N=M;A_a(N);O=296008;P=128;Zd(M|0,O|0,P|0)}G=c[K+(o<<2)>>2]|0;if((G|0)==0){M=Hc(4)|0;N=M;A_a(N);O=296008;P=128;Zd(M|0,O|0,P|0)}P=G;O=c[G>>2]|0;if(d){me[c[O+44>>2]&127](z,P);z=f;d=c[y>>2]|0;a[z]=d;a[z+1|0]=d>>8;a[z+2|0]=d>>16;a[z+3|0]=d>>24;me[c[(c[G>>2]|0)+32>>2]&127](A,P);d=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}aRa(l,0);z=A;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;QQa(A)}else{me[c[O+40>>2]&127](C,P);C=f;f=c[B>>2]|0;a[C]=f;a[C+1|0]=f>>8;a[C+2|0]=f>>16;a[C+3|0]=f>>24;me[c[(c[G>>2]|0)+28>>2]&127](D,P);f=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}aRa(l,0);l=D;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;QQa(D)}a[g]=oe[c[(c[G>>2]|0)+12>>2]&127](P)|0;a[h]=oe[c[(c[G>>2]|0)+16>>2]&127](P)|0;me[c[(c[G>>2]|0)+20>>2]&127](E,P);h=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}aRa(j,0);j=E;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;QQa(E);me[c[(c[G>>2]|0)+24>>2]&127](F,P);E=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}aRa(k,0);k=F;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;QQa(F);L=oe[c[(c[G>>2]|0)+36>>2]&127](P)|0;c[m>>2]=L;i=n;return}}function ZWa(d,e,f,g,h,j,k,l,m,n,o,p,q,r,s){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;var t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;t=i;c[f>>2]=d;u=r+1|0;v=r+8|0;w=r+4|0;x=(g&512|0)==0;y=q+1|0;z=q+8|0;A=q+4|0;B=(s|0)>0;C=p+1|0;D=p+8|0;E=p+4|0;F=k+8|0;G=0-s|0;H=h;h=0;while(1){a:do{switch(a[m+h|0]|0){case 4:{I=c[f>>2]|0;J=l?H+1|0:H;b:do{if(J>>>0<j>>>0){K=J;while(1){L=a[K]|0;if(!(L<<24>>24>-1)){M=K;break b}N=K+1|0;if((b[(c[F>>2]|0)+(L<<24>>24<<1)>>1]&2048)==0){M=K;break b}if(N>>>0<j>>>0){K=N}else{M=N;break}}}else{M=J}}while(0);K=M;if(B){if(M>>>0>J>>>0){N=J+(0-K)|0;K=N>>>0<G>>>0?G:N;N=K+s|0;L=I;O=M;P=s;while(1){Q=O+ -1|0;R=a[Q]|0;c[f>>2]=L+1;a[L]=R;R=P+ -1|0;S=(R|0)>0;if(!(Q>>>0>J>>>0&S)){break}L=c[f>>2]|0;P=R;O=Q}O=M+K|0;if(S){T=O;U=N;V=32}else{W=0;X=O;Y=N}}else{T=M;U=s;V=32}if((V|0)==32){V=0;W=De[c[(c[k>>2]|0)+28>>2]&63](k,48)|0;X=T;Y=U}O=c[f>>2]|0;c[f>>2]=O+1;if((Y|0)>0){P=O;L=Y;while(1){a[P]=W;Q=L+ -1|0;R=c[f>>2]|0;c[f>>2]=R+1;if((Q|0)>0){L=Q;P=R}else{Z=R;break}}}else{Z=O}a[Z]=n;_=X}else{_=M}if((_|0)==(J|0)){P=De[c[(c[k>>2]|0)+28>>2]&63](k,48)|0;L=c[f>>2]|0;c[f>>2]=L+1;a[L]=P}else{P=a[p]|0;L=(P&1)==0;if(L){$=(P&255)>>>1}else{$=c[E>>2]|0}if(($|0)==0){aa=_;ba=-1;ca=0;da=0}else{if(L){ea=C}else{ea=c[D>>2]|0}aa=_;ba=a[ea]|0;ca=0;da=0}while(1){do{if((da|0)==(ba|0)){L=c[f>>2]|0;c[f>>2]=L+1;a[L]=o;L=ca+1|0;P=a[p]|0;N=(P&1)==0;if(N){fa=(P&255)>>>1}else{fa=c[E>>2]|0}if(!(L>>>0<fa>>>0)){ga=ba;ha=L;ia=0;break}if(N){ja=C}else{ja=c[D>>2]|0}if((a[ja+L|0]|0)==127){ga=-1;ha=L;ia=0;break}if(N){ka=C}else{ka=c[D>>2]|0}ga=a[ka+L|0]|0;ha=L;ia=0}else{ga=ba;ha=ca;ia=da}}while(0);L=aa+ -1|0;N=a[L]|0;P=c[f>>2]|0;c[f>>2]=P+1;a[P]=N;if((L|0)==(J|0)){break}else{aa=L;ba=ga;ca=ha;da=ia+1|0}}}O=c[f>>2]|0;if((I|0)==(O|0)){la=J;break a}L=O+ -1|0;if(L>>>0>I>>>0){ma=I;na=L}else{la=J;break a}while(1){L=a[ma]|0;a[ma]=a[na]|0;a[na]=L;L=ma+1|0;O=na+ -1|0;if(L>>>0<O>>>0){na=O;ma=L}else{la=J;break}}break};case 1:{c[e>>2]=c[f>>2];J=De[c[(c[k>>2]|0)+28>>2]&63](k,32)|0;I=c[f>>2]|0;c[f>>2]=I+1;a[I]=J;la=H;break};case 0:{c[e>>2]=c[f>>2];la=H;break};case 3:{J=a[r]|0;I=(J&1)==0;if(I){oa=(J&255)>>>1}else{oa=c[w>>2]|0}if((oa|0)==0){la=H;break a}if(I){pa=u}else{pa=c[v>>2]|0}I=a[pa]|0;J=c[f>>2]|0;c[f>>2]=J+1;a[J]=I;la=H;break};case 2:{I=a[q]|0;J=(I&1)==0;if(J){qa=(I&255)>>>1}else{qa=c[A>>2]|0}if((qa|0)==0|x){la=H;break a}if(J){ra=y;sa=(I&255)>>>1}else{ra=c[z>>2]|0;sa=c[A>>2]|0}I=ra+sa|0;J=c[f>>2]|0;if((ra|0)==(I|0)){ta=J}else{L=J;J=ra;while(1){a[L]=a[J]|0;O=J+1|0;N=L+1|0;if((O|0)==(I|0)){ta=N;break}else{J=O;L=N}}}c[f>>2]=ta;la=H;break};default:{la=H}}}while(0);L=h+1|0;if(L>>>0<4){H=la;h=L}else{break}}h=a[r]|0;r=(h&1)==0;if(r){ua=(h&255)>>>1}else{ua=c[w>>2]|0}if(ua>>>0>1){if(r){va=u;wa=(h&255)>>>1}else{va=c[v>>2]|0;wa=c[w>>2]|0}w=va+1|0;v=va+wa|0;wa=c[f>>2]|0;if((w|0)==(v|0)){xa=wa}else{va=wa;wa=w;while(1){a[va]=a[wa]|0;w=wa+1|0;h=va+1|0;if((w|0)==(v|0)){xa=h;break}else{wa=w;va=h}}}c[f>>2]=xa}xa=g&176;if((xa|0)==32){c[e>>2]=c[f>>2];i=t;return}else if((xa|0)==16){i=t;return}else{c[e>>2]=d;i=t;return}}function _Wa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;k=d;l=d+8|0;m=d+24|0;n=d+32|0;o=n;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+104|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;MRa(m,g);z=m;A=c[z>>2]|0;if(!((c[70112]|0)==-1)){c[l>>2]=280448;c[l+4>>2]=1276;c[l+8>>2]=0;BQa(280448,l,1277)}l=(c[280452>>2]|0)+ -1|0;B=c[A+8>>2]|0;if(!((c[A+12>>2]|0)-B>>2>>>0>l>>>0)){C=Hc(4)|0;D=C;A_a(D);E=296008;F=128;Zd(C|0,E|0,F|0)}A=c[B+(l<<2)>>2]|0;if((A|0)==0){C=Hc(4)|0;D=C;A_a(D);E=296008;F=128;Zd(C|0,E|0,F|0)}F=A;E=a[j]|0;C=(E&1)==0;if(C){G=(E&255)>>>1}else{G=c[j+4>>2]|0}if((G|0)==0){H=0}else{if(C){I=j+1|0}else{I=c[j+8>>2]|0}C=a[I]|0;H=C<<24>>24==(De[c[(c[A>>2]|0)+28>>2]&63](F,45)|0)<<24>>24}c[n>>2]=0;n=r;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=s;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=t;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;YWa(f,H,m,o,p,q,r,s,t,u);m=v;v=a[j]|0;f=(v&1)==0;if(f){J=(v&255)>>>1}else{J=c[j+4>>2]|0}n=c[u>>2]|0;if((J|0)>(n|0)){if(f){K=(v&255)>>>1}else{K=c[j+4>>2]|0}f=a[t]|0;if((f&1)==0){L=(f&255)>>>1}else{L=c[t+4>>2]|0}f=a[s]|0;if((f&1)==0){M=(f&255)>>>1}else{M=c[s+4>>2]|0}N=L+(K-n<<1|1)+M|0}else{M=a[t]|0;if((M&1)==0){O=(M&255)>>>1}else{O=c[t+4>>2]|0}M=a[s]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[s+4>>2]|0}N=O+2+P|0}P=N+n|0;do{if(P>>>0>100){N=V_a(P)|0;if((N|0)!=0){Q=N;R=N;break}g$a()}else{Q=0;R=m}}while(0);if((v&1)==0){S=j+1|0;T=(v&255)>>>1}else{S=c[j+8>>2]|0;T=c[j+4>>2]|0}ZWa(R,w,x,c[g+4>>2]|0,S,S+T|0,F,H,o,a[p]|0,a[q]|0,r,s,t,n);c[y>>2]=c[e>>2];e=c[w>>2]|0;w=c[x>>2]|0;x=k;n=y;c[x+0>>2]=c[n+0>>2];mNa(b,k,R,e,w,g,h);if((Q|0)==0){QQa(t);QQa(s);QQa(r);U=c[z>>2]|0;V=U;W=V;X=gQa(W)|0;i=d;return}W_a(Q);QQa(t);QQa(s);QQa(r);U=c[z>>2]|0;V=U;W=V;X=gQa(W)|0;i=d;return}function $Wa(a){a=a|0;var b=0;b=i;b$a(a);i=b;return}function aXa(a){a=a|0;i=i;return}function bXa(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+16|0;m=d;n=d+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+104|0;r=i;i=i+8|0;s=i;i=i+400|0;t=i;i=i+8|0;u=i;i=i+8|0;v=u;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+400|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=q;c[r>>2]=G;q=s;s=o;h[k>>3]=l;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=Pc(G|0,100,280200,o|0)|0;do{if(s>>>0>99){do{if((a[280344]|0)==0){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);o=c[70084]|0;G=n;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=PUa(r,o,280200,n)|0;o=c[r>>2]|0;if((o|0)==0){g$a()}H=V_a(G<<2)|0;I=H;if((H|0)!=0){J=o;K=I;L=I;M=G;break}g$a()}else{J=0;K=0;L=q;M=s}}while(0);MRa(t,g);s=t;q=c[s>>2]|0;if(!((c[70110]|0)==-1)){c[p>>2]=280440;c[p+4>>2]=1276;c[p+8>>2]=0;BQa(280440,p,1277)}p=(c[280444>>2]|0)+ -1|0;n=c[q+8>>2]|0;if(!((c[q+12>>2]|0)-n>>2>>>0>p>>>0)){N=Hc(4)|0;O=N;A_a(O);P=296008;Q=128;Zd(N|0,P|0,Q|0)}q=c[n+(p<<2)>>2]|0;if((q|0)==0){N=Hc(4)|0;O=N;A_a(O);P=296008;Q=128;Zd(N|0,P|0,Q|0)}Q=q;P=c[r>>2]|0;Ne[c[(c[q>>2]|0)+48>>2]&63](Q,P,P+M|0,L)|0;if((M|0)==0){R=0}else{R=(a[c[r>>2]|0]|0)==45}c[u>>2]=0;u=y;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=z;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=A;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;cXa(f,R,t,v,w,x,y,z,A,B);t=C;C=c[B>>2]|0;if((M|0)>(C|0)){B=a[A]|0;if((B&1)==0){S=(B&255)>>>1}else{S=c[A+4>>2]|0}B=a[z]|0;if((B&1)==0){T=(B&255)>>>1}else{T=c[z+4>>2]|0}U=S+(M-C<<1|1)+T|0}else{T=a[A]|0;if((T&1)==0){V=(T&255)>>>1}else{V=c[A+4>>2]|0}T=a[z]|0;if((T&1)==0){W=(T&255)>>>1}else{W=c[z+4>>2]|0}U=V+2+W|0}W=U+C|0;do{if(W>>>0>100){U=V_a(W<<2)|0;V=U;if((U|0)!=0){X=V;Y=V;break}g$a()}else{X=0;Y=t}}while(0);dXa(Y,D,E,c[g+4>>2]|0,L,L+(M<<2)|0,Q,R,v,c[w>>2]|0,c[x>>2]|0,y,z,A,C);c[F>>2]=c[e>>2];e=c[D>>2]|0;D=c[E>>2]|0;E=m;C=F;c[E+0>>2]=c[C+0>>2];YUa(b,m,Y,e,D,g,j);if((X|0)!=0){W_a(X)}sRa(A);sRa(z);QQa(y);gQa(c[s>>2]|0)|0;if((K|0)!=0){W_a(K)}if((J|0)==0){i=d;return}W_a(J);i=d;return}function cXa(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+40|0;o=n;p=n+16|0;q=n+32|0;r=q;s=i;i=i+16|0;t=i;i=i+8|0;u=t;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=B;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[e>>2]|0;if(b){if(!((c[70004]|0)==-1)){c[p>>2]=280016;c[p+4>>2]=1276;c[p+8>>2]=0;BQa(280016,p,1277)}p=(c[280020>>2]|0)+ -1|0;b=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-b>>2>>>0>p>>>0)){H=Hc(4)|0;I=H;A_a(I);J=296008;K=128;Zd(H|0,J|0,K|0)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){H=Hc(4)|0;I=H;A_a(I);J=296008;K=128;Zd(H|0,J|0,K|0)}K=e;J=c[e>>2]|0;if(d){me[c[J+44>>2]&127](r,K);r=f;H=c[q>>2]|0;a[r]=H;a[r+1|0]=H>>8;a[r+2|0]=H>>16;a[r+3|0]=H>>24;me[c[(c[e>>2]|0)+32>>2]&127](s,K);H=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}vRa(l,0);r=s;c[H+0>>2]=c[r+0>>2];c[H+4>>2]=c[r+4>>2];c[H+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;sRa(s)}else{me[c[J+40>>2]&127](u,K);u=f;J=c[t>>2]|0;a[u]=J;a[u+1|0]=J>>8;a[u+2|0]=J>>16;a[u+3|0]=J>>24;me[c[(c[e>>2]|0)+28>>2]&127](v,K);J=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}vRa(l,0);u=v;c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;sRa(v)}c[g>>2]=oe[c[(c[e>>2]|0)+12>>2]&127](K)|0;c[h>>2]=oe[c[(c[e>>2]|0)+16>>2]&127](K)|0;me[c[(c[e>>2]|0)+20>>2]&127](w,K);v=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}aRa(j,0);u=w;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;QQa(w);me[c[(c[e>>2]|0)+24>>2]&127](x,K);w=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}vRa(k,0);u=x;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;sRa(x);L=oe[c[(c[e>>2]|0)+36>>2]&127](K)|0;c[m>>2]=L;i=n;return}else{if(!((c[69988]|0)==-1)){c[o>>2]=279952;c[o+4>>2]=1276;c[o+8>>2]=0;BQa(279952,o,1277)}o=(c[279956>>2]|0)+ -1|0;K=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-K>>2>>>0>o>>>0)){M=Hc(4)|0;N=M;A_a(N);O=296008;P=128;Zd(M|0,O|0,P|0)}G=c[K+(o<<2)>>2]|0;if((G|0)==0){M=Hc(4)|0;N=M;A_a(N);O=296008;P=128;Zd(M|0,O|0,P|0)}P=G;O=c[G>>2]|0;if(d){me[c[O+44>>2]&127](z,P);z=f;d=c[y>>2]|0;a[z]=d;a[z+1|0]=d>>8;a[z+2|0]=d>>16;a[z+3|0]=d>>24;me[c[(c[G>>2]|0)+32>>2]&127](A,P);d=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}vRa(l,0);z=A;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;sRa(A)}else{me[c[O+40>>2]&127](C,P);C=f;f=c[B>>2]|0;a[C]=f;a[C+1|0]=f>>8;a[C+2|0]=f>>16;a[C+3|0]=f>>24;me[c[(c[G>>2]|0)+28>>2]&127](D,P);f=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}vRa(l,0);l=D;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;sRa(D)}c[g>>2]=oe[c[(c[G>>2]|0)+12>>2]&127](P)|0;c[h>>2]=oe[c[(c[G>>2]|0)+16>>2]&127](P)|0;me[c[(c[G>>2]|0)+20>>2]&127](E,P);h=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}aRa(j,0);j=E;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;QQa(E);me[c[(c[G>>2]|0)+24>>2]&127](F,P);E=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}vRa(k,0);k=F;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;sRa(F);L=oe[c[(c[G>>2]|0)+36>>2]&127](P)|0;c[m>>2]=L;i=n;return}}function dXa(b,d,e,f,g,h,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;s=i;c[e>>2]=b;t=q+4|0;u=q+8|0;v=(f&512|0)==0;w=p+4|0;x=p+8|0;y=(r|0)>0;z=o+1|0;A=o+8|0;B=o+4|0;C=g;g=0;while(1){a:do{switch(a[l+g|0]|0){case 2:{D=a[p]|0;E=(D&1)==0;if(E){F=(D&255)>>>1}else{F=c[w>>2]|0}if((F|0)==0|v){G=C;break a}if(E){H=w;I=(D&255)>>>1}else{H=c[x>>2]|0;I=c[w>>2]|0}D=H+(I<<2)|0;E=c[e>>2]|0;if((H|0)==(D|0)){J=E}else{K=(H+(I+ -1<<2)+(0-H)|0)>>>2;L=E;M=H;while(1){c[L>>2]=c[M>>2];N=M+4|0;if((N|0)==(D|0)){break}L=L+4|0;M=N}J=E+(K+1<<2)|0}c[e>>2]=J;G=C;break};case 3:{M=a[q]|0;L=(M&1)==0;if(L){O=(M&255)>>>1}else{O=c[t>>2]|0}if((O|0)==0){G=C;break a}if(L){P=t}else{P=c[u>>2]|0}L=c[P>>2]|0;M=c[e>>2]|0;c[e>>2]=M+4;c[M>>2]=L;G=C;break};case 0:{c[d>>2]=c[e>>2];G=C;break};case 1:{c[d>>2]=c[e>>2];L=De[c[(c[j>>2]|0)+44>>2]&63](j,32)|0;M=c[e>>2]|0;c[e>>2]=M+4;c[M>>2]=L;G=C;break};case 4:{L=c[e>>2]|0;M=k?C+4|0:C;b:do{if(M>>>0<h>>>0){D=M;while(1){N=D+4|0;if(!(re[c[(c[j>>2]|0)+12>>2]&63](j,2048,c[D>>2]|0)|0)){Q=D;break b}if(N>>>0<h>>>0){D=N}else{Q=N;break}}}else{Q=M}}while(0);if(y){do{if(Q>>>0>M>>>0){K=c[e>>2]|0;E=Q;D=r;while(1){R=E+ -4|0;S=K+4|0;c[K>>2]=c[R>>2];T=D+ -1|0;U=(T|0)>0;if(R>>>0>M>>>0&U){D=T;E=R;K=S}else{break}}c[e>>2]=S;if(U){V=R;W=T;X=34;break}K=c[e>>2]|0;c[e>>2]=K+4;Y=K;Z=R}else{V=Q;W=r;X=34}}while(0);do{if((X|0)==34){X=0;K=De[c[(c[j>>2]|0)+44>>2]&63](j,48)|0;E=c[e>>2]|0;D=E+4|0;c[e>>2]=D;if((W|0)>0){_=D;$=E;aa=W}else{Y=E;Z=V;break}while(1){c[$>>2]=K;D=aa+ -1|0;if((D|0)>0){aa=D;$=_;_=_+4|0}else{break}}c[e>>2]=E+(W+1<<2);Y=E+(W<<2)|0;Z=V}}while(0);c[Y>>2]=m;ba=Z}else{ba=Q}if((ba|0)==(M|0)){K=De[c[(c[j>>2]|0)+44>>2]&63](j,48)|0;D=c[e>>2]|0;N=D+4|0;c[e>>2]=N;c[D>>2]=K;ca=N}else{N=a[o]|0;K=(N&1)==0;if(K){da=(N&255)>>>1}else{da=c[B>>2]|0}if((da|0)==0){ea=ba;fa=-1;ga=0;ha=0}else{if(K){ia=z}else{ia=c[A>>2]|0}ea=ba;fa=a[ia]|0;ga=0;ha=0}while(1){K=c[e>>2]|0;do{if((ha|0)==(fa|0)){N=K+4|0;c[e>>2]=N;c[K>>2]=n;D=ga+1|0;ja=a[o]|0;ka=(ja&1)==0;if(ka){la=(ja&255)>>>1}else{la=c[B>>2]|0}if(!(D>>>0<la>>>0)){ma=N;na=fa;oa=D;pa=0;break}if(ka){qa=z}else{qa=c[A>>2]|0}if((a[qa+D|0]|0)==127){ma=N;na=-1;oa=D;pa=0;break}if(ka){ra=z}else{ra=c[A>>2]|0}ma=N;na=a[ra+D|0]|0;oa=D;pa=0}else{ma=K;na=fa;oa=ga;pa=ha}}while(0);K=ea+ -4|0;E=c[K>>2]|0;D=ma+4|0;c[e>>2]=D;c[ma>>2]=E;if((K|0)==(M|0)){ca=D;break}else{ea=K;fa=na;ga=oa;ha=pa+1|0}}}if((L|0)==(ca|0)){G=M;break a}K=ca+ -4|0;if(K>>>0>L>>>0){sa=L;ta=K}else{G=M;break a}while(1){K=c[sa>>2]|0;c[sa>>2]=c[ta>>2];c[ta>>2]=K;K=sa+4|0;D=ta+ -4|0;if(K>>>0<D>>>0){ta=D;sa=K}else{G=M;break}}break};default:{G=C}}}while(0);M=g+1|0;if(M>>>0<4){C=G;g=M}else{break}}g=a[q]|0;q=(g&1)==0;if(q){ua=(g&255)>>>1}else{ua=c[t>>2]|0}if(ua>>>0>1){if(q){va=t;wa=(g&255)>>>1}else{va=c[u>>2]|0;wa=c[t>>2]|0}t=va+4|0;u=va+(wa<<2)|0;g=c[e>>2]|0;if((t|0)==(u|0)){xa=g}else{q=(va+(wa+ -1<<2)+(0-t)|0)>>>2;wa=g;va=t;while(1){c[wa>>2]=c[va>>2];t=va+4|0;if((t|0)==(u|0)){break}else{va=t;wa=wa+4|0}}xa=g+(q+1<<2)|0}c[e>>2]=xa}xa=f&176;if((xa|0)==16){i=s;return}else if((xa|0)==32){c[d>>2]=c[e>>2];i=s;return}else{c[d>>2]=b;i=s;return}}function eXa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;k=d;l=d+8|0;m=d+24|0;n=d+32|0;o=n;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+400|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;MRa(m,g);z=m;A=c[z>>2]|0;if(!((c[70110]|0)==-1)){c[l>>2]=280440;c[l+4>>2]=1276;c[l+8>>2]=0;BQa(280440,l,1277)}l=(c[280444>>2]|0)+ -1|0;B=c[A+8>>2]|0;if(!((c[A+12>>2]|0)-B>>2>>>0>l>>>0)){C=Hc(4)|0;D=C;A_a(D);E=296008;F=128;Zd(C|0,E|0,F|0)}A=c[B+(l<<2)>>2]|0;if((A|0)==0){C=Hc(4)|0;D=C;A_a(D);E=296008;F=128;Zd(C|0,E|0,F|0)}F=A;E=a[j]|0;C=(E&1)==0;if(C){G=(E&255)>>>1}else{G=c[j+4>>2]|0}if((G|0)==0){H=0}else{if(C){I=j+4|0}else{I=c[j+8>>2]|0}C=c[I>>2]|0;H=(C|0)==(De[c[(c[A>>2]|0)+44>>2]&63](F,45)|0)}c[n>>2]=0;n=r;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=s;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=t;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;cXa(f,H,m,o,p,q,r,s,t,u);m=v;v=a[j]|0;f=(v&1)==0;if(f){J=(v&255)>>>1}else{J=c[j+4>>2]|0}n=c[u>>2]|0;if((J|0)>(n|0)){if(f){K=(v&255)>>>1}else{K=c[j+4>>2]|0}f=a[t]|0;if((f&1)==0){L=(f&255)>>>1}else{L=c[t+4>>2]|0}f=a[s]|0;if((f&1)==0){M=(f&255)>>>1}else{M=c[s+4>>2]|0}N=L+(K-n<<1|1)+M|0}else{M=a[t]|0;if((M&1)==0){O=(M&255)>>>1}else{O=c[t+4>>2]|0}M=a[s]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[s+4>>2]|0}N=O+2+P|0}P=N+n|0;do{if(P>>>0>100){N=V_a(P<<2)|0;O=N;if((N|0)!=0){Q=O;R=O;break}g$a()}else{Q=0;R=m}}while(0);if((v&1)==0){S=j+4|0;T=(v&255)>>>1}else{S=c[j+8>>2]|0;T=c[j+4>>2]|0}dXa(R,w,x,c[g+4>>2]|0,S,S+(T<<2)|0,F,H,o,c[p>>2]|0,c[q>>2]|0,r,s,t,n);c[y>>2]=c[e>>2];e=c[w>>2]|0;w=c[x>>2]|0;x=k;n=y;c[x+0>>2]=c[n+0>>2];YUa(b,k,R,e,w,g,h);if((Q|0)==0){sRa(t);sRa(s);QQa(r);U=c[z>>2]|0;V=U;W=V;X=gQa(W)|0;i=d;return}W_a(Q);sRa(t);sRa(s);QQa(r);U=c[z>>2]|0;V=U;W=V;X=gQa(W)|0;i=d;return}function fXa(a){a=a|0;var b=0;b=i;b$a(a);i=b;return}function gXa(a){a=a|0;i=i;return}function hXa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=xc(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)|0)|0}function iXa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;j=d;k=j;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;k=a[h]|0;if((k&1)==0){l=h+1|0;m=h+1|0;n=(k&255)>>>1}else{k=c[h+8>>2]|0;l=k;m=k;n=c[h+4>>2]|0}h=l+n|0;do{if(m>>>0<h>>>0){n=m;do{gRa(j,a[n]|0);n=n+1|0;}while(n>>>0<h>>>0);n=(e|0)==-1?-1:e<<1;if((a[j]&1)==0){o=n;p=9;break}q=n;r=c[j+8>>2]|0}else{o=(e|0)==-1?-1:e<<1;p=9}}while(0);if((p|0)==9){q=o;r=j+1|0}o=Ed(q|0,f|0,g|0,r|0)|0;r=b;c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;r=x$a(o|0)|0;g=o+r|0;if((r|0)>0){s=o}else{QQa(j);i=d;return}do{gRa(b,a[s]|0);s=s+1|0;}while(s>>>0<g>>>0);QQa(j);i=d;return}function jXa(a,b){a=a|0;b=b|0;a=i;Kb(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function kXa(a){a=a|0;var b=0;b=i;b$a(a);i=b;return}function lXa(a){a=a|0;i=i;return}function mXa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=xc(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)|0)|0}function nXa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=i;i=i+240|0;j=d;k=d+8|0;l=d+40|0;m=d+48|0;n=d+56|0;o=d+64|0;p=d+192|0;q=d+200|0;r=d+208|0;s=d+224|0;t=d+232|0;u=r;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[s+4>>2]=0;c[s>>2]=282104;u=a[h]|0;if((u&1)==0){v=h+4|0;w=h+4|0;x=(u&255)>>>1}else{u=c[h+8>>2]|0;v=u;w=u;x=c[h+4>>2]|0}h=v+(x<<2)|0;x=k;v=j;u=j;c[u>>2]=0;c[u+4>>2]=0;a:do{if(w>>>0<h>>>0){u=s;j=k+32|0;y=w;z=282104|0;while(1){c[m>>2]=y;A=(Me[c[z+12>>2]&15](u,v,y,h,m,x,j,l)|0)==2;B=c[m>>2]|0;if(A|(B|0)==(y|0)){break}if(x>>>0<(c[l>>2]|0)>>>0){A=x;do{gRa(r,a[A]|0);A=A+1|0;}while(A>>>0<(c[l>>2]|0)>>>0);C=c[m>>2]|0}else{C=B}if(!(C>>>0<h>>>0)){break a}y=C;z=c[s>>2]|0}IWa(281328)}}while(0);if((a[r]&1)==0){D=r+1|0}else{D=c[r+8>>2]|0}s=Ed(((e|0)==-1?-1:e<<1)|0,f|0,g|0,D|0)|0;D=b;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;c[t+4>>2]=0;c[t>>2]=282208;D=x$a(s|0)|0;g=s+D|0;f=n;e=n;c[e>>2]=0;c[e+4>>2]=0;if((D|0)<=0){QQa(r);i=d;return}D=t;e=g;n=o;C=o+128|0;o=s;s=282208|0;while(1){c[q>>2]=o;h=(Me[c[s+16>>2]&15](D,f,o,(e-o|0)>32?o+32|0:g,q,n,C,p)|0)==2;m=c[q>>2]|0;if(h|(m|0)==(o|0)){E=20;break}if(n>>>0<(c[p>>2]|0)>>>0){h=n;do{wRa(b,c[h>>2]|0);h=h+4|0;}while(h>>>0<(c[p>>2]|0)>>>0);F=c[q>>2]|0}else{F=m}if(!(F>>>0<g>>>0)){E=25;break}o=F;s=c[t>>2]|0}if((E|0)==20){IWa(281328)}else if((E|0)==25){QQa(r);i=d;return}}function oXa(a,b){a=a|0;b=b|0;a=i;Kb(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function pXa(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=280536;e=b+8|0;b=c[e>>2]|0;do{if((a[280344]|0)==0){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);if((b|0)==(c[70084]|0)){i=d;return}ec(c[e>>2]|0);i=d;return}function qXa(a){a=a|0;a=Hc(8)|0;hQa(a,280328);c[a>>2]=277296;Zd(a|0,277336,41)}function rXa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+448|0;f=e;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=e+80|0;m=e+96|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+160|0;r=e+176|0;s=e+192|0;t=e+208|0;u=e+224|0;v=e+240|0;w=e+256|0;x=e+272|0;y=e+288|0;z=e+304|0;A=e+320|0;B=e+336|0;C=e+352|0;D=e+368|0;E=e+384|0;F=e+400|0;G=e+416|0;H=e+432|0;c[b+4>>2]=d+ -1;c[b>>2]=280368;d=b+8|0;I=b+12|0;J=b+136|0;a[J]=1;K=b+24|0;c[I>>2]=K;c[d>>2]=K;c[b+16>>2]=J;J=28;L=K;do{if((L|0)==0){M=0}else{c[L>>2]=0;M=c[I>>2]|0}L=M+4|0;c[I>>2]=L;J=J+ -1|0;}while((J|0)!=0);IQa(b+144|0,280352,1);J=c[d>>2]|0;d=c[I>>2]|0;if((d|0)!=(J|0)){c[I>>2]=d+(~((d+ -4+(0-J)|0)>>>2)<<2)}c[285260>>2]=0;c[71314]=278848;if(!((c[69718]|0)==-1)){c[G>>2]=278872;c[G+4>>2]=1276;c[G+8>>2]=0;BQa(278872,G,1277)}sXa(b,285256,(c[278876>>2]|0)+ -1|0);c[285252>>2]=0;c[71312]=278888;if(!((c[69728]|0)==-1)){c[F>>2]=278912;c[F+4>>2]=1276;c[F+8>>2]=0;BQa(278912,F,1277)}sXa(b,285248,(c[278916>>2]|0)+ -1|0);c[285236>>2]=0;c[71308]=280464;c[285240>>2]=0;a[285244|0]=0;F=c[(Bc()|0)>>2]|0;c[285240>>2]=F;if(!((c[70112]|0)==-1)){c[E>>2]=280448;c[E+4>>2]=1276;c[E+8>>2]=0;BQa(280448,E,1277)}sXa(b,285232,(c[280452>>2]|0)+ -1|0);c[285228>>2]=0;c[71306]=281424;if(!((c[70110]|0)==-1)){c[D>>2]=280440;c[D+4>>2]=1276;c[D+8>>2]=0;BQa(280440,D,1277)}sXa(b,285224,(c[280444>>2]|0)+ -1|0);c[285220>>2]=0;c[71304]=281640;if(!((c[70128]|0)==-1)){c[C>>2]=280512;c[C+4>>2]=1276;c[C+8>>2]=0;BQa(280512,C,1277)}sXa(b,285216,(c[280516>>2]|0)+ -1|0);c[285204>>2]=0;c[71300]=280536;do{if((a[280344]|0)==0){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);c[285208>>2]=c[70084];if(!((c[70130]|0)==-1)){c[B>>2]=280520;c[B+4>>2]=1276;c[B+8>>2]=0;BQa(280520,B,1277)}sXa(b,285200,(c[280524>>2]|0)+ -1|0);c[285196>>2]=0;c[71298]=281864;if(!((c[70144]|0)==-1)){c[A>>2]=280576;c[A+4>>2]=1276;c[A+8>>2]=0;BQa(280576,A,1277)}sXa(b,285192,(c[280580>>2]|0)+ -1|0);c[285188>>2]=0;c[71296]=281984;if(!((c[70146]|0)==-1)){c[z>>2]=280584;c[z+4>>2]=1276;c[z+8>>2]=0;BQa(280584,z,1277)}sXa(b,285184,(c[280588>>2]|0)+ -1|0);c[285164>>2]=0;c[71290]=280616;a[285168|0]=46;a[285169|0]=44;z=285172|0;c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;if(!((c[70148]|0)==-1)){c[y>>2]=280592;c[y+4>>2]=1276;c[y+8>>2]=0;BQa(280592,y,1277)}sXa(b,285160,(c[280596>>2]|0)+ -1|0);c[285132>>2]=0;c[71282]=280656;c[285136>>2]=46;c[285140>>2]=44;y=285144|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;if(!((c[70150]|0)==-1)){c[x>>2]=280600;c[x+4>>2]=1276;c[x+8>>2]=0;BQa(280600,x,1277)}sXa(b,285128,(c[280604>>2]|0)+ -1|0);c[285124>>2]=0;c[71280]=278928;if(!((c[69746]|0)==-1)){c[w>>2]=278984;c[w+4>>2]=1276;c[w+8>>2]=0;BQa(278984,w,1277)}sXa(b,285120,(c[278988>>2]|0)+ -1|0);c[285116>>2]=0;c[71278]=279048;if(!((c[69776]|0)==-1)){c[v>>2]=279104;c[v+4>>2]=1276;c[v+8>>2]=0;BQa(279104,v,1277)}sXa(b,285112,(c[279108>>2]|0)+ -1|0);c[285108>>2]=0;c[71276]=279120;if(!((c[69792]|0)==-1)){c[u>>2]=279168;c[u+4>>2]=1276;c[u+8>>2]=0;BQa(279168,u,1277)}sXa(b,285104,(c[279172>>2]|0)+ -1|0);c[285100>>2]=0;c[71274]=279184;if(!((c[69808]|0)==-1)){c[t>>2]=279232;c[t+4>>2]=1276;c[t+8>>2]=0;BQa(279232,t,1277)}sXa(b,285096,(c[279236>>2]|0)+ -1|0);c[285092>>2]=0;c[71272]=279776;if(!((c[69956]|0)==-1)){c[s>>2]=279824;c[s+4>>2]=1276;c[s+8>>2]=0;BQa(279824,s,1277)}sXa(b,285088,(c[279828>>2]|0)+ -1|0);c[285084>>2]=0;c[71270]=279840;if(!((c[69972]|0)==-1)){c[r>>2]=279888;c[r+4>>2]=1276;c[r+8>>2]=0;BQa(279888,r,1277)}sXa(b,285080,(c[279892>>2]|0)+ -1|0);c[285076>>2]=0;c[71268]=279904;if(!((c[69988]|0)==-1)){c[q>>2]=279952;c[q+4>>2]=1276;c[q+8>>2]=0;BQa(279952,q,1277)}sXa(b,285072,(c[279956>>2]|0)+ -1|0);c[285068>>2]=0;c[71266]=279968;if(!((c[70004]|0)==-1)){c[p>>2]=280016;c[p+4>>2]=1276;c[p+8>>2]=0;BQa(280016,p,1277)}sXa(b,285064,(c[280020>>2]|0)+ -1|0);c[285060>>2]=0;c[71264]=280032;if(!((c[70014]|0)==-1)){c[o>>2]=280056;c[o+4>>2]=1276;c[o+8>>2]=0;BQa(280056,o,1277)}sXa(b,285056,(c[280060>>2]|0)+ -1|0);c[285052>>2]=0;c[71262]=280112;if(!((c[70034]|0)==-1)){c[n>>2]=280136;c[n+4>>2]=1276;c[n+8>>2]=0;BQa(280136,n,1277)}sXa(b,285048,(c[280140>>2]|0)+ -1|0);c[285044>>2]=0;c[71260]=280168;if(!((c[70048]|0)==-1)){c[m>>2]=280192;c[m+4>>2]=1276;c[m+8>>2]=0;BQa(280192,m,1277)}sXa(b,285040,(c[280196>>2]|0)+ -1|0);c[285036>>2]=0;c[71258]=280216;if(!((c[70060]|0)==-1)){c[l>>2]=280240;c[l+4>>2]=1276;c[l+8>>2]=0;BQa(280240,l,1277)}sXa(b,285032,(c[280244>>2]|0)+ -1|0);c[285020>>2]=0;c[71254]=279264;c[285024>>2]=279312;if(!((c[69836]|0)==-1)){c[k>>2]=279344;c[k+4>>2]=1276;c[k+8>>2]=0;BQa(279344,k,1277)}sXa(b,285016,(c[279348>>2]|0)+ -1|0);c[285004>>2]=0;c[71250]=279416;c[285008>>2]=279464;if(!((c[69874]|0)==-1)){c[j>>2]=279496;c[j+4>>2]=1276;c[j+8>>2]=0;BQa(279496,j,1277)}sXa(b,285e3,(c[279500>>2]|0)+ -1|0);c[284988>>2]=0;c[71246]=281360;do{if((a[280344]|0)==0){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);c[284992>>2]=c[70084];c[71246]=279712;if(!((c[69932]|0)==-1)){c[h>>2]=279728;c[h+4>>2]=1276;c[h+8>>2]=0;BQa(279728,h,1277)}sXa(b,284984,(c[279732>>2]|0)+ -1|0);c[284972>>2]=0;c[71242]=281360;do{if((a[280344]|0)==0){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);c[284976>>2]=c[70084];c[71242]=279744;if(!((c[69940]|0)==-1)){c[g>>2]=279760;c[g+4>>2]=1276;c[g+8>>2]=0;BQa(279760,g,1277)}sXa(b,284968,(c[279764>>2]|0)+ -1|0);c[284964>>2]=0;c[71240]=280256;if(!((c[70070]|0)==-1)){c[f>>2]=280280;c[f+4>>2]=1276;c[f+8>>2]=0;BQa(280280,f,1277)}sXa(b,284960,(c[280284>>2]|0)+ -1|0);c[284956>>2]=0;c[71238]=280296;if((c[70080]|0)==-1){N=280320;O=280320;P=O+4|0;Q=P;R=c[Q>>2]|0;S=R+ -1|0;T=284952;sXa(b,T,S);i=e;return}c[H>>2]=280320;c[H+4>>2]=1276;c[H+8>>2]=0;BQa(280320,H,1277);N=280320;O=280320;P=O+4|0;Q=P;R=c[Q>>2]|0;S=R+ -1|0;T=284952;sXa(b,T,S);i=e;return}function sXa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;fQa(b);f=a+8|0;g=a+12|0;a=c[g>>2]|0;h=f;j=c[h>>2]|0;k=a-j>>2;do{if(k>>>0>d>>>0){l=j}else{m=d+1|0;if(k>>>0<m>>>0){xZa(f,m-k|0);l=c[h>>2]|0;break}if(!(k>>>0>m>>>0)){l=j;break}n=j+(m<<2)|0;if((a|0)==(n|0)){l=j;break}c[g>>2]=a+(~((a+ -4+(0-n)|0)>>>2)<<2);l=j}}while(0);j=c[l+(d<<2)>>2]|0;if((j|0)==0){o=l;p=o;q=d<<2;r=p+q|0;s=r;c[s>>2]=b;i=e;return}gQa(j)|0;o=c[h>>2]|0;p=o;q=d<<2;r=p+q|0;s=r;c[s>>2]=b;i=e;return}function tXa(a){a=a|0;var b=0;b=i;uXa(a);b$a(a);i=b;return}function uXa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;c[b>>2]=280368;e=b+12|0;f=c[e>>2]|0;g=b+8|0;h=c[g>>2]|0;if((f|0)!=(h|0)){j=f;f=h;h=0;while(1){k=c[f+(h<<2)>>2]|0;if((k|0)==0){l=f;m=j}else{gQa(k)|0;l=c[g>>2]|0;m=c[e>>2]|0}k=h+1|0;if(k>>>0<m-l>>2>>>0){j=m;f=l;h=k}else{break}}}QQa(b+144|0);h=c[g>>2]|0;if((h|0)==0){i=d;return}g=c[e>>2]|0;if((g|0)!=(h|0)){c[e>>2]=g+(~((g+ -4+(0-h)|0)>>>2)<<2)}if((b+24|0)==(h|0)){a[b+136|0]=0;i=d;return}else{b$a(h);i=d;return}}function vXa(){var b=0,d=0,e=0,f=0;b=i;if((a[280424]|0)!=0){d=280416;e=c[70104]|0;i=b;return e|0}if((_a(280424)|0)==0){d=280416;e=c[70104]|0;i=b;return e|0}do{if((a[280400]|0)==0){if((_a(280400)|0)==0){break}rXa(284792,1);c[70096]=284792;c[70098]=280384;Wb(280400)}}while(0);f=c[c[70098]>>2]|0;c[70102]=f;fQa(f);c[70104]=280408;Wb(280424);d=280416;e=c[70104]|0;i=b;return e|0}function wXa(a){a=a|0;var b=0,d=0;b=i;d=c[(vXa()|0)>>2]|0;c[a>>2]=d;fQa(d);i=b;return}function xXa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;fQa(e);i=d;return}function yXa(a){a=a|0;var b=0;b=i;gQa(c[a>>2]|0)|0;i=b;return}function zXa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;a=b;if(!((c[a>>2]|0)==-1)){c[e>>2]=b;c[e+4>>2]=1276;c[e+8>>2]=0;BQa(a,e,1277)}e=(c[b+4>>2]|0)+ -1|0;b=c[f+8>>2]|0;if(!((c[f+12>>2]|0)-b>>2>>>0>e>>>0)){g=0;i=d;return g|0}g=(c[b+(e<<2)>>2]|0)!=0;i=d;return g|0}function AXa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;a=b;if(!((c[a>>2]|0)==-1)){c[e>>2]=b;c[e+4>>2]=1276;c[e+8>>2]=0;BQa(a,e,1277)}e=(c[b+4>>2]|0)+ -1|0;b=c[f+8>>2]|0;if(!((c[f+12>>2]|0)-b>>2>>>0>e>>>0)){g=Hc(4)|0;h=g;A_a(h);j=296008;k=128;Zd(g|0,j|0,k|0)}f=c[b+(e<<2)>>2]|0;if((f|0)==0){g=Hc(4)|0;h=g;A_a(h);j=296008;k=128;Zd(g|0,j|0,k|0)}else{i=d;return f|0}return 0}function BXa(a){a=a|0;var b=0;b=i;b$a(a);i=b;return}function CXa(a){a=a|0;var b=0;b=i;if((a|0)==0){i=b;return}le[c[(c[a>>2]|0)+4>>2]&2047](a);i=b;return}function DXa(a){a=a|0;var b=0;b=c[70108]|0;c[70108]=1+b;c[a+4>>2]=b+1;i=i;return}function EXa(a){a=a|0;var b=0;b=i;b$a(a);i=b;return}function FXa(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;a=i;if(!(e>>>0<128)){f=0;i=a;return f|0}f=(b[(c[(Bc()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16!=0;i=a;return f|0}function GXa(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;if((d|0)==(e|0)){g=d;i=a;return g|0}else{h=d;j=f}while(1){f=c[h>>2]|0;if(f>>>0<128){k=b[(c[(Bc()|0)>>2]|0)+(f<<1)>>1]|0}else{k=0}b[j>>1]=k;f=h+4|0;if((f|0)==(e|0)){g=e;break}else{h=f;j=j+2|0}}i=a;return g|0}function HXa(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;a=i;if((e|0)==(f|0)){g=e;i=a;return g|0}else{h=e}while(1){e=c[h>>2]|0;if(e>>>0<128){if(!((b[(c[(Bc()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16==0)){g=h;j=5;break}}e=h+4|0;if((e|0)==(f|0)){g=f;j=5;break}else{h=e}}if((j|0)==5){i=a;return g|0}return 0}function IXa(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;a:do{if((e|0)==(f|0)){g=e}else{h=e;while(1){j=c[h>>2]|0;if(!(j>>>0<128)){g=h;break a}k=h+4|0;if((b[(c[(Bc()|0)>>2]|0)+(j<<1)>>1]&d)<<16>>16==0){g=h;break a}if((k|0)==(f|0)){g=f;break}else{h=k}}}}while(0);i=a;return g|0}function JXa(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b>>>0<128)){d=b;i=a;return d|0}d=c[(c[(Jd()|0)>>2]|0)+(b<<2)>>2]|0;i=a;return d|0}function KXa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128){g=c[(c[(Jd()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}i=a;return e|0}function LXa(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b>>>0<128)){d=b;i=a;return d|0}d=c[(c[(Od()|0)>>2]|0)+(b<<2)>>2]|0;i=a;return d|0}function MXa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128){g=c[(c[(Od()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}i=a;return e|0}function NXa(a,b){a=a|0;b=b|0;i=i;return b<<24>>24|0}function OXa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((d|0)==(e|0)){g=d;i=b;return g|0}else{h=d;j=f}while(1){c[j>>2]=a[h]|0;f=h+1|0;if((f|0)==(e|0)){g=e;break}else{j=j+4|0;h=f}}i=b;return g|0}function PXa(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return(b>>>0<128?b&255:c)|0}function QXa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;if((d|0)==(e|0)){h=d;i=b;return h|0}j=((e+ -4+(0-d)|0)>>>2)+1|0;k=d;l=g;while(1){g=c[k>>2]|0;a[l]=g>>>0<128?g&255:f;g=k+4|0;if((g|0)==(e|0)){break}else{l=l+1|0;k=g}}h=d+(j<<2)|0;i=b;return h|0}function RXa(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=280464;e=c[b+8>>2]|0;do{if((e|0)!=0){if((a[b+12|0]|0)==0){break}c$a(e)}}while(0);b$a(b);i=d;return}function SXa(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=280464;e=c[b+8>>2]|0;if((e|0)==0){i=d;return}if((a[b+12|0]|0)==0){i=d;return}c$a(e);i=d;return}function TXa(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b<<24>>24>-1)){d=b;i=a;return d|0}d=c[(c[(Jd()|0)>>2]|0)+((b&255)<<2)>>2]&255;i=a;return d|0}function UXa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(Jd()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}i=b;return f|0}function VXa(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b<<24>>24>-1)){d=b;i=a;return d|0}d=c[(c[(Od()|0)>>2]|0)+(b<<24>>24<<2)>>2]&255;i=a;return d|0}function WXa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(Od()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}i=b;return f|0}function XXa(a,b){a=a|0;b=b|0;i=i;return b|0}function YXa(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((c|0)==(d|0)){f=c;i=b;return f|0}else{g=c;h=e}while(1){a[h]=a[g]|0;e=g+1|0;if((e|0)==(d|0)){f=d;break}else{h=h+1|0;g=e}}i=b;return f|0}function ZXa(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return(b<<24>>24>-1?b:c)|0}function _Xa(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((c|0)==(d|0)){g=c;i=b;return g|0}else{h=c;j=f}while(1){f=a[h]|0;a[j]=f<<24>>24>-1?f:e;f=h+1|0;if((f|0)==(d|0)){g=d;break}else{j=j+1|0;h=f}}i=b;return g|0}function $Xa(a){a=a|0;var b=0;b=i;b$a(a);i=b;return}function aYa(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;c[f>>2]=d;c[j>>2]=g;i=i;return 3}function bYa(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;c[f>>2]=d;c[j>>2]=g;i=i;return 3}function cYa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function dYa(a){a=a|0;i=i;return 1}function eYa(a){a=a|0;i=i;return 1}function fYa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=d-c|0;i=i;return(b>>>0<e>>>0?b:e)|0}function gYa(a){a=a|0;i=i;return 1}function hYa(a){a=a|0;var b=0;b=i;pXa(a);b$a(a);i=b;return}function iYa(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;l=i;i=i+8|0;m=l;n=m;o=i;i=i+8|0;p=(e|0)==(f|0);a:do{if(p){c[k>>2]=h;c[g>>2]=e;q=e}else{r=e;while(1){s=r+4|0;if((c[r>>2]|0)==0){t=r;break}if((s|0)==(f|0)){t=f;break}else{r=s}}c[k>>2]=h;c[g>>2]=e;if(p|(h|0)==(j|0)){q=e;break}r=j;s=b+8|0;u=o;v=e;w=h;x=t;while(1){y=d;z=c[y+4>>2]|0;A=m;c[A>>2]=c[y>>2];c[A+4>>2]=z;z=Oc(c[s>>2]|0)|0;A=$Za(w,g,x-v>>2,r-w|0,d)|0;if((z|0)!=0){Oc(z|0)|0}if((A|0)==0){B=1;C=33;break}else if((A|0)==-1){C=10;break}z=(c[k>>2]|0)+A|0;c[k>>2]=z;if((z|0)==(j|0)){C=31;break}if((x|0)==(f|0)){D=c[g>>2]|0;E=z;F=f}else{z=Oc(c[s>>2]|0)|0;A=_Za(u,0,d)|0;if((z|0)!=0){Oc(z|0)|0}if((A|0)==-1){B=2;C=33;break}z=c[k>>2]|0;if(A>>>0>(r-z|0)>>>0){B=1;C=33;break}b:do{if((A|0)!=0){y=z;G=A;H=u;while(1){I=a[H]|0;c[k>>2]=y+1;a[y]=I;I=G+ -1|0;if((I|0)==0){break b}y=c[k>>2]|0;H=H+1|0;G=I}}}while(0);A=(c[g>>2]|0)+4|0;c[g>>2]=A;c:do{if((A|0)==(f|0)){J=f}else{z=A;while(1){G=z+4|0;if((c[z>>2]|0)==0){J=z;break c}if((G|0)==(f|0)){J=f;break}else{z=G}}}}while(0);D=A;E=c[k>>2]|0;F=J}if((D|0)==(f|0)|(E|0)==(j|0)){q=D;break a}else{v=D;w=E;x=F}}if((C|0)==10){c[k>>2]=w;d:do{if((v|0)==(c[g>>2]|0)){K=v}else{x=v;u=w;while(1){r=c[x>>2]|0;z=Oc(c[s>>2]|0)|0;G=_Za(u,r,n)|0;if((z|0)!=0){Oc(z|0)|0}if((G|0)==-1){K=x;break d}z=(c[k>>2]|0)+G|0;c[k>>2]=z;G=x+4|0;if((G|0)==(c[g>>2]|0)){K=G;break}else{x=G;u=z}}}}while(0);c[g>>2]=K;B=2;i=l;return B|0}else if((C|0)==31){q=c[g>>2]|0;break}else if((C|0)==33){i=l;return B|0}}}while(0);B=(q|0)!=(f|0)|0;i=l;return B|0}function jYa(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;l=i;i=i+8|0;m=l;n=m;o=(e|0)==(f|0);a:do{if(o){c[k>>2]=h;c[g>>2]=e;p=e}else{q=e;while(1){r=q+1|0;if((a[q]|0)==0){s=q;break}if((r|0)==(f|0)){s=f;break}else{q=r}}c[k>>2]=h;c[g>>2]=e;if(o|(h|0)==(j|0)){p=e;break}q=j;r=b+8|0;t=e;u=h;v=s;while(1){w=d;x=c[w+4>>2]|0;y=m;c[y>>2]=c[w>>2];c[y+4>>2]=x;z=v;x=Oc(c[r>>2]|0)|0;y=XZa(u,g,z-t|0,q-u>>2,d)|0;if((x|0)!=0){Oc(x|0)|0}if((y|0)==-1){A=10;break}else if((y|0)==0){B=2;A=32;break}x=(c[k>>2]|0)+(y<<2)|0;c[k>>2]=x;if((x|0)==(j|0)){A=30;break}y=c[g>>2]|0;if((v|0)==(f|0)){C=y;D=x;E=f}else{w=Oc(c[r>>2]|0)|0;F=WZa(x,y,1,d)|0;if((w|0)!=0){Oc(w|0)|0}if((F|0)!=0){B=2;A=32;break}c[k>>2]=(c[k>>2]|0)+4;F=(c[g>>2]|0)+1|0;c[g>>2]=F;b:do{if((F|0)==(f|0)){G=f}else{w=F;while(1){y=w+1|0;if((a[w]|0)==0){G=w;break b}if((y|0)==(f|0)){G=f;break}else{w=y}}}}while(0);C=F;D=c[k>>2]|0;E=G}if((C|0)==(f|0)|(D|0)==(j|0)){p=C;break a}else{t=C;u=D;v=E}}if((A|0)==10){c[k>>2]=u;c:do{if((t|0)==(c[g>>2]|0)){H=t}else{v=t;q=u;while(1){w=Oc(c[r>>2]|0)|0;y=WZa(q,v,z-v|0,n)|0;if((w|0)!=0){Oc(w|0)|0}if((y|0)==-2){A=16;break}else if((y|0)==-1){A=15;break}else if((y|0)==0){I=v+1|0}else{I=v+y|0}y=(c[k>>2]|0)+4|0;c[k>>2]=y;if((I|0)==(c[g>>2]|0)){H=I;break c}else{v=I;q=y}}if((A|0)==15){c[g>>2]=v;B=2;i=l;return B|0}else if((A|0)==16){c[g>>2]=v;B=1;i=l;return B|0}}}while(0);c[g>>2]=H;B=(H|0)!=(f|0)|0;i=l;return B|0}else if((A|0)==30){p=c[g>>2]|0;break}else if((A|0)==32){i=l;return B|0}}}while(0);B=(p|0)!=(f|0)|0;i=l;return B|0}function kYa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+8|0;c[g>>2]=e;e=h;j=Oc(c[b+8>>2]|0)|0;b=_Za(e,0,d)|0;if((j|0)!=0){Oc(j|0)|0}if((b|0)==0|(b|0)==-1){k=2;i=h;return k|0}j=b+ -1|0;b=c[g>>2]|0;if(j>>>0>(f-b|0)>>>0){k=1;i=h;return k|0}if((j|0)==0){k=0;i=h;return k|0}else{l=b;m=j;n=e}while(1){e=a[n]|0;c[g>>2]=l+1;a[l]=e;e=m+ -1|0;if((e|0)==0){k=0;break}l=c[g>>2]|0;n=n+1|0;m=e}i=h;return k|0}function lYa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=a+8|0;a=Oc(c[d>>2]|0)|0;e=ZZa(0,0,4)|0;if((a|0)!=0){Oc(a|0)|0}do{if((e|0)==0){a=c[d>>2]|0;if((a|0)==0){f=1;break}g=Oc(a|0)|0;if((g|0)==0){f=0;break}Oc(g|0)|0;f=0}else{f=-1}}while(0);i=b;return f|0}function mYa(a){a=a|0;i=i;return 0}function nYa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;if((f|0)==0|(d|0)==(e|0)){h=0;i=g;return h|0}j=e;k=a+8|0;a=d;d=0;l=0;while(1){m=Oc(c[k>>2]|0)|0;n=VZa(a,j-a|0,b)|0;if((m|0)!=0){Oc(m|0)|0}if((n|0)==0){o=a+1|0;p=1}else if((n|0)==-2|(n|0)==-1){h=d;q=9;break}else{o=a+n|0;p=n}n=p+d|0;m=l+1|0;if(m>>>0>=f>>>0|(o|0)==(e|0)){h=n;q=9;break}else{a=o;d=n;l=m}}if((q|0)==9){i=g;return h|0}return 0}function oYa(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+8>>2]|0;do{if((d|0)==0){e=1}else{a=Oc(d|0)|0;if((a|0)==0){e=4;break}Oc(a|0)|0;e=4}}while(0);i=b;return e|0}function pYa(a){a=a|0;var b=0;b=i;b$a(a);i=b;return}function qYa(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=rYa(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>1<<1);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function rYa(d,f,g,h,j,k,l,m){d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;c[g>>2]=d;c[k>>2]=h;do{if((m&2|0)!=0){if((j-h|0)<3){o=1;i=n;return o|0}else{c[k>>2]=h+1;a[h]=-17;d=c[k>>2]|0;c[k>>2]=d+1;a[d]=-69;d=c[k>>2]|0;c[k>>2]=d+1;a[d]=-65;break}}}while(0);h=f;m=c[g>>2]|0;if(!(m>>>0<f>>>0)){o=0;i=n;return o|0}d=j;j=m;a:while(1){m=b[j>>1]|0;p=m&65535;if(p>>>0>l>>>0){o=2;q=26;break}do{if((m&65535)<128){r=c[k>>2]|0;if((d-r|0)<1){o=1;q=26;break a}c[k>>2]=r+1;a[r]=m}else{if((m&65535)<2048){r=c[k>>2]|0;if((d-r|0)<2){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>6|192;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if((m&65535)<55296){r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if(!((m&65535)<56320)){if((m&65535)<57344){o=2;q=26;break a}r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if((h-j|0)<4){o=1;q=26;break a}r=j+2|0;s=e[r>>1]|0;if((s&64512|0)!=56320){o=2;q=26;break a}if((d-(c[k>>2]|0)|0)<4){o=1;q=26;break a}t=p&960;if(((t<<10)+65536|p<<10&64512|s&1023)>>>0>l>>>0){o=2;q=26;break a}c[g>>2]=r;r=(t>>>6)+1|0;t=c[k>>2]|0;c[k>>2]=t+1;a[t]=r>>>2|240;t=c[k>>2]|0;c[k>>2]=t+1;a[t]=p>>>2&15|r<<4&48|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p<<4&48|s>>>6&15|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=s&63|128}}while(0);p=(c[g>>2]|0)+2|0;c[g>>2]=p;if(p>>>0<f>>>0){j=p}else{o=0;q=26;break}}if((q|0)==26){i=n;return o|0}return 0}function sYa(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=tYa(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>1<<1);i=b;return l|0}function tYa(e,f,g,h,j,k,l,m){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;n=i;c[g>>2]=e;c[k>>2]=h;h=c[g>>2]|0;do{if((m&4|0)==0){o=h}else{if((f-h|0)<=2){o=h;break}if(!((a[h]|0)==-17)){o=h;break}if(!((a[h+1|0]|0)==-69)){o=h;break}if(!((a[h+2|0]|0)==-65)){o=h;break}e=h+3|0;c[g>>2]=e;o=e}}while(0);a:do{if(o>>>0<f>>>0){h=f;m=j;e=o;p=c[k>>2]|0;b:while(1){if(!(p>>>0<j>>>0)){q=e;break a}r=a[e]|0;s=r&255;if(s>>>0>l>>>0){t=2;u=41;break}do{if(r<<24>>24>-1){b[p>>1]=r&255;c[g>>2]=e+1}else{if((r&255)<194){t=2;u=41;break b}if((r&255)<224){if((h-e|0)<2){t=1;u=41;break b}v=d[e+1|0]|0;if((v&192|0)!=128){t=2;u=41;break b}w=v&63|s<<6&1984;if(w>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=w;c[g>>2]=e+2;break}if((r&255)<240){if((h-e|0)<3){t=1;u=41;break b}w=a[e+1|0]|0;v=a[e+2|0]|0;if((s|0)==237){if(!((w&-32)<<24>>24==-128)){t=2;u=41;break b}}else if((s|0)==224){if(!((w&-32)<<24>>24==-96)){t=2;u=41;break b}}else{if(!((w&-64)<<24>>24==-128)){t=2;u=41;break b}}x=v&255;if((x&192|0)!=128){t=2;u=41;break b}v=(w&255)<<6&4032|s<<12|x&63;if((v&65535)>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=v;c[g>>2]=e+3;break}if(!((r&255)<245)){t=2;u=41;break b}if((h-e|0)<4){t=1;u=41;break b}v=a[e+1|0]|0;x=a[e+2|0]|0;w=a[e+3|0]|0;if((s|0)==240){if(!((v+112<<24>>24&255)<48)){t=2;u=41;break b}}else if((s|0)==244){if(!((v&-16)<<24>>24==-128)){t=2;u=41;break b}}else{if(!((v&-64)<<24>>24==-128)){t=2;u=41;break b}}y=x&255;if((y&192|0)!=128){t=2;u=41;break b}x=w&255;if((x&192|0)!=128){t=2;u=41;break b}if((m-p|0)<4){t=1;u=41;break b}w=s&7;z=v&255;v=y<<6;A=x&63;if((z<<12&258048|w<<18|v&4032|A)>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=z<<2&60|y>>>4&3|((z>>>4&3|w<<2)<<6)+16320|55296;w=p+2|0;c[k>>2]=w;b[w>>1]=A|v&960|56320;c[g>>2]=(c[g>>2]|0)+4}}while(0);s=(c[k>>2]|0)+2|0;c[k>>2]=s;r=c[g>>2]|0;if(r>>>0<f>>>0){e=r;p=s}else{q=r;break a}}if((u|0)==41){i=n;return t|0}}else{q=o}}while(0);t=q>>>0<f>>>0|0;i=n;return t|0}function uYa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function vYa(a){a=a|0;i=i;return 0}function wYa(a){a=a|0;i=i;return 0}function xYa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=yYa(c,d,e,1114111,0)|0;i=b;return a|0}function yYa(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;h=i;do{if((g&4|0)==0){j=b}else{if((c-b|0)<=2){j=b;break}if(!((a[b]|0)==-17)){j=b;break}if(!((a[b+1|0]|0)==-69)){j=b;break}j=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);a:do{if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=0;b:while(1){m=a[k]|0;n=m&255;if(n>>>0>f>>>0){o=k;break a}do{if(m<<24>>24>-1){p=k+1|0;q=l}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}r=d[k+1|0]|0;if((r&192|0)!=128){o=k;break a}if((r&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;q=l;break}if((m&255)<240){s=k;if((g-s|0)<3){o=k;break a}r=a[k+1|0]|0;t=a[k+2|0]|0;if((n|0)==237){if(!((r&-32)<<24>>24==-128)){u=23;break b}}else if((n|0)==224){if(!((r&-32)<<24>>24==-96)){u=21;break b}}else{if(!((r&-64)<<24>>24==-128)){u=25;break b}}v=t&255;if((v&192|0)!=128){o=k;break a}if(((r&255)<<6&4032|n<<12&61440|v&63)>>>0>f>>>0){o=k;break a}p=k+3|0;q=l;break}if(!((m&255)<245)){o=k;break a}w=k;if((g-w|0)<4){o=k;break a}if((e-l|0)>>>0<2){o=k;break a}v=a[k+1|0]|0;r=a[k+2|0]|0;t=a[k+3|0]|0;if((n|0)==244){if(!((v&-16)<<24>>24==-128)){u=36;break b}}else if((n|0)==240){if(!((v+112<<24>>24&255)<48)){u=34;break b}}else{if(!((v&-64)<<24>>24==-128)){u=38;break b}}x=r&255;if((x&192|0)!=128){o=k;break a}r=t&255;if((r&192|0)!=128){o=k;break a}if(((v&255)<<12&258048|n<<18&1835008|x<<6&4032|r&63)>>>0>f>>>0){o=k;break a}p=k+4|0;q=l+1|0}}while(0);n=q+1|0;if(p>>>0<c>>>0&n>>>0<e>>>0){k=p;l=n}else{o=p;break a}}if((u|0)==21){y=s-b|0;i=h;return y|0}else if((u|0)==23){y=s-b|0;i=h;return y|0}else if((u|0)==25){y=s-b|0;i=h;return y|0}else if((u|0)==34){y=w-b|0;i=h;return y|0}else if((u|0)==36){y=w-b|0;i=h;return y|0}else if((u|0)==38){y=w-b|0;i=h;return y|0}}else{o=j}}while(0);y=o-b|0;i=h;return y|0}function zYa(a){a=a|0;i=i;return 4}function AYa(a){a=a|0;var b=0;b=i;b$a(a);i=b;return}function BYa(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=CYa(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>2<<2);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function CYa(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;l=i;c[e>>2]=b;c[h>>2]=f;do{if((k&2|0)!=0){if((g-f|0)<3){m=1;i=l;return m|0}else{c[h>>2]=f+1;a[f]=-17;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-69;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-65;break}}}while(0);f=c[e>>2]|0;if(!(f>>>0<d>>>0)){m=0;i=l;return m|0}k=g;g=f;a:while(1){f=c[g>>2]|0;if((f&-2048|0)==55296|f>>>0>j>>>0){m=2;n=19;break}do{if(f>>>0<128){b=c[h>>2]|0;if((k-b|0)<1){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f}else{if(f>>>0<2048){b=c[h>>2]|0;if((k-b|0)<2){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>6|192;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}b=c[h>>2]|0;o=k-b|0;if(f>>>0<65536){if((o|0)<3){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>12|224;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=f>>>6&63|128;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=f&63|128;break}else{if((o|0)<4){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>18|240;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>12&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>6&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}}}while(0);f=(c[e>>2]|0)+4|0;c[e>>2]=f;if(f>>>0<d>>>0){g=f}else{m=0;n=19;break}}if((n|0)==19){i=l;return m|0}return 0}function DYa(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=EYa(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>2<<2);i=b;return l|0}function EYa(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;m=i;c[f>>2]=b;c[j>>2]=g;g=c[f>>2]|0;do{if((l&4|0)==0){n=g}else{if((e-g|0)<=2){n=g;break}if(!((a[g]|0)==-17)){n=g;break}if(!((a[g+1|0]|0)==-69)){n=g;break}if(!((a[g+2|0]|0)==-65)){n=g;break}b=g+3|0;c[f>>2]=b;n=b}}while(0);a:do{if(n>>>0<e>>>0){g=e;l=n;b=c[j>>2]|0;b:while(1){if(!(b>>>0<h>>>0)){o=l;break a}p=a[l]|0;q=p&255;do{if(p<<24>>24>-1){if(q>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=q;c[f>>2]=l+1}else{if((p&255)<194){r=2;s=40;break b}if((p&255)<224){if((g-l|0)<2){r=1;s=40;break b}t=d[l+1|0]|0;if((t&192|0)!=128){r=2;s=40;break b}u=t&63|q<<6&1984;if(u>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=u;c[f>>2]=l+2;break}if((p&255)<240){if((g-l|0)<3){r=1;s=40;break b}u=a[l+1|0]|0;t=a[l+2|0]|0;if((q|0)==224){if(!((u&-32)<<24>>24==-96)){r=2;s=40;break b}}else if((q|0)==237){if(!((u&-32)<<24>>24==-128)){r=2;s=40;break b}}else{if(!((u&-64)<<24>>24==-128)){r=2;s=40;break b}}v=t&255;if((v&192|0)!=128){r=2;s=40;break b}t=(u&255)<<6&4032|q<<12&61440|v&63;if(t>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=t;c[f>>2]=l+3;break}if(!((p&255)<245)){r=2;s=40;break b}if((g-l|0)<4){r=1;s=40;break b}t=a[l+1|0]|0;v=a[l+2|0]|0;u=a[l+3|0]|0;if((q|0)==240){if(!((t+112<<24>>24&255)<48)){r=2;s=40;break b}}else if((q|0)==244){if(!((t&-16)<<24>>24==-128)){r=2;s=40;break b}}else{if(!((t&-64)<<24>>24==-128)){r=2;s=40;break b}}w=v&255;if((w&192|0)!=128){r=2;s=40;break b}v=u&255;if((v&192|0)!=128){r=2;s=40;break b}u=(t&255)<<12&258048|q<<18&1835008|w<<6&4032|v&63;if(u>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=u;c[f>>2]=l+4}}while(0);q=(c[j>>2]|0)+4|0;c[j>>2]=q;p=c[f>>2]|0;if(p>>>0<e>>>0){l=p;b=q}else{o=p;break a}}if((s|0)==40){i=m;return r|0}}else{o=n}}while(0);r=o>>>0<e>>>0|0;i=m;return r|0}function FYa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function GYa(a){a=a|0;i=i;return 0}function HYa(a){a=a|0;i=i;return 0}function IYa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=JYa(c,d,e,1114111,0)|0;i=b;return a|0}function JYa(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;do{if((g&4|0)==0){j=b}else{if((c-b|0)<=2){j=b;break}if(!((a[b]|0)==-17)){j=b;break}if(!((a[b+1|0]|0)==-69)){j=b;break}j=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);a:do{if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=1;b:while(1){m=a[k]|0;n=m&255;do{if(m<<24>>24>-1){if(n>>>0>f>>>0){o=k;break a}p=k+1|0}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}q=d[k+1|0]|0;if((q&192|0)!=128){o=k;break a}if((q&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;break}if((m&255)<240){r=k;if((g-r|0)<3){o=k;break a}q=a[k+1|0]|0;s=a[k+2|0]|0;if((n|0)==224){if(!((q&-32)<<24>>24==-96)){t=21;break b}}else if((n|0)==237){if(!((q&-32)<<24>>24==-128)){t=23;break b}}else{if(!((q&-64)<<24>>24==-128)){t=25;break b}}u=s&255;if((u&192|0)!=128){o=k;break a}if(((q&255)<<6&4032|n<<12&61440|u&63)>>>0>f>>>0){o=k;break a}p=k+3|0;break}if(!((m&255)<245)){o=k;break a}v=k;if((g-v|0)<4){o=k;break a}u=a[k+1|0]|0;q=a[k+2|0]|0;s=a[k+3|0]|0;if((n|0)==244){if(!((u&-16)<<24>>24==-128)){t=35;break b}}else if((n|0)==240){if(!((u+112<<24>>24&255)<48)){t=33;break b}}else{if(!((u&-64)<<24>>24==-128)){t=37;break b}}w=q&255;if((w&192|0)!=128){o=k;break a}q=s&255;if((q&192|0)!=128){o=k;break a}if(((u&255)<<12&258048|n<<18&1835008|w<<6&4032|q&63)>>>0>f>>>0){o=k;break a}p=k+4|0}}while(0);if(!(p>>>0<c>>>0&l>>>0<e>>>0)){o=p;break a}k=p;l=l+1|0}if((t|0)==21){x=r-b|0;i=h;return x|0}else if((t|0)==23){x=r-b|0;i=h;return x|0}else if((t|0)==25){x=r-b|0;i=h;return x|0}else if((t|0)==33){x=v-b|0;i=h;return x|0}else if((t|0)==35){x=v-b|0;i=h;return x|0}else if((t|0)==37){x=v-b|0;i=h;return x|0}}else{o=j}}while(0);x=o-b|0;i=h;return x|0}function KYa(a){a=a|0;i=i;return 4}function LYa(a){a=a|0;var b=0;b=i;b$a(a);i=b;return}function MYa(a){a=a|0;var b=0;b=i;b$a(a);i=b;return}function NYa(a){a=a|0;var b=0;b=i;c[a>>2]=280616;QQa(a+12|0);b$a(a);i=b;return}function OYa(a){a=a|0;var b=0;b=i;c[a>>2]=280616;QQa(a+12|0);i=b;return}function PYa(a){a=a|0;var b=0;b=i;c[a>>2]=280656;QQa(a+16|0);b$a(a);i=b;return}function QYa(a){a=a|0;var b=0;b=i;c[a>>2]=280656;QQa(a+16|0);i=b;return}function RYa(b){b=b|0;i=i;return a[b+8|0]|0}function SYa(a){a=a|0;i=i;return c[a+8>>2]|0}function TYa(b){b=b|0;i=i;return a[b+9|0]|0}function UYa(a){a=a|0;i=i;return c[a+12>>2]|0}function VYa(a,b){a=a|0;b=b|0;var c=0;c=i;GQa(a,b+12|0);i=c;return}function WYa(a,b){a=a|0;b=b|0;var c=0;c=i;GQa(a,b+16|0);i=c;return}function XYa(a,b){a=a|0;b=b|0;b=i;IQa(a,280688,4);i=b;return}function YYa(a,b){a=a|0;b=b|0;b=i;qRa(a,280696,v_a(280696)|0);i=b;return}function ZYa(a,b){a=a|0;b=b|0;b=i;IQa(a,280720,5);i=b;return}function _Ya(a,b){a=a|0;b=b|0;b=i;qRa(a,280728,v_a(280728)|0);i=b;return}function $Ya(b){b=b|0;var d=0,e=0;b=i;if((a[280760]|0)!=0){d=280752;e=c[70188]|0;i=b;return e|0}if((_a(280760)|0)==0){d=280752;e=c[70188]|0;i=b;return e|0}do{if((a[287960]|0)==0){if((_a(287960)|0)==0){break}B$a(287792,0,168)|0;de(1279,0,q|0)|0;Wb(287960)}}while(0);TQa(287792,287968)|0;TQa(287804|0,287976)|0;TQa(287816|0,287984)|0;TQa(287828|0,287992)|0;TQa(287840|0,288008)|0;TQa(287852|0,288024)|0;TQa(287864|0,288032)|0;TQa(287876|0,288048)|0;TQa(287888|0,288056)|0;TQa(287900|0,288064)|0;TQa(287912|0,288072)|0;TQa(287924|0,288080)|0;TQa(287936|0,288088)|0;TQa(287948|0,288096)|0;c[70188]=287792;Wb(280760);d=280752;e=c[70188]|0;i=b;return e|0}function aZa(b){b=b|0;var d=0,e=0;b=i;if((a[280776]|0)!=0){d=280768;e=c[70192]|0;i=b;return e|0}if((_a(280776)|0)==0){d=280768;e=c[70192]|0;i=b;return e|0}do{if((a[287424]|0)==0){if((_a(287424)|0)==0){break}B$a(287256,0,168)|0;de(1280,0,q|0)|0;Wb(287424)}}while(0);tRa(287256,287432)|0;tRa(287268|0,287464)|0;tRa(287280|0,287496)|0;tRa(287292|0,287528)|0;tRa(287304|0,287568)|0;tRa(287316|0,287608)|0;tRa(287328|0,287640)|0;tRa(287340|0,287680)|0;tRa(287352|0,287696)|0;tRa(287364|0,287712)|0;tRa(287376|0,287728)|0;tRa(287388|0,287744)|0;tRa(287400|0,287760)|0;tRa(287412|0,287776)|0;c[70192]=287256;Wb(280776);d=280768;e=c[70192]|0;i=b;return e|0}function bZa(b){b=b|0;var d=0,e=0;b=i;if((a[280792]|0)!=0){d=280784;e=c[70196]|0;i=b;return e|0}if((_a(280792)|0)==0){d=280784;e=c[70196]|0;i=b;return e|0}do{if((a[287032]|0)==0){if((_a(287032)|0)==0){break}B$a(286744,0,288)|0;de(1281,0,q|0)|0;Wb(287032)}}while(0);TQa(286744,287040)|0;TQa(286756|0,287048)|0;TQa(286768|0,287064)|0;TQa(286780|0,287072)|0;TQa(286792|0,287080)|0;TQa(286804|0,287088)|0;TQa(286816|0,287096)|0;TQa(286828|0,287104)|0;TQa(286840|0,287112)|0;TQa(286852|0,287128)|0;TQa(286864|0,287136)|0;TQa(286876|0,287152)|0;TQa(286888|0,287168)|0;TQa(286900|0,287176)|0;TQa(286912|0,287184)|0;TQa(286924|0,287192)|0;TQa(286936|0,287080)|0;TQa(286948|0,287200)|0;TQa(286960|0,287208)|0;TQa(286972|0,287216)|0;TQa(286984|0,287224)|0;TQa(286996|0,287232)|0;TQa(287008|0,287240)|0;TQa(287020|0,287248)|0;c[70196]=286744;Wb(280792);d=280784;e=c[70196]|0;i=b;return e|0}function cZa(b){b=b|0;var d=0,e=0;b=i;if((a[280808]|0)!=0){d=280800;e=c[70200]|0;i=b;return e|0}if((_a(280808)|0)==0){d=280800;e=c[70200]|0;i=b;return e|0}do{if((a[286192]|0)==0){if((_a(286192)|0)==0){break}B$a(285904,0,288)|0;de(1282,0,q|0)|0;Wb(286192)}}while(0);tRa(285904,286200)|0;tRa(285916|0,286232)|0;tRa(285928|0,286272)|0;tRa(285940|0,286296)|0;tRa(285952|0,286616)|0;tRa(285964|0,286320)|0;tRa(285976|0,286344)|0;tRa(285988|0,286368)|0;tRa(286e3|0,286400)|0;tRa(286012|0,286440)|0;tRa(286024|0,286472)|0;tRa(286036|0,286512)|0;tRa(286048|0,286552)|0;tRa(286060|0,286568)|0;tRa(286072|0,286584)|0;tRa(286084|0,286600)|0;tRa(286096|0,286616)|0;tRa(286108|0,286632)|0;tRa(286120|0,286648)|0;tRa(286132|0,286664)|0;tRa(286144|0,286680)|0;tRa(286156|0,286696)|0;tRa(286168|0,286712)|0;tRa(286180|0,286728)|0;c[70200]=285904;Wb(280808);d=280800;e=c[70200]|0;i=b;return e|0}function dZa(b){b=b|0;var d=0,e=0;b=i;if((a[280824]|0)!=0){d=280816;e=c[70204]|0;i=b;return e|0}if((_a(280824)|0)==0){d=280816;e=c[70204]|0;i=b;return e|0}do{if((a[285880]|0)==0){if((_a(285880)|0)==0){break}B$a(285592,0,288)|0;de(1283,0,q|0)|0;Wb(285880)}}while(0);TQa(285592,285888)|0;TQa(285604|0,285896)|0;c[70204]=285592;Wb(280824);d=280816;e=c[70204]|0;i=b;return e|0}function eZa(b){b=b|0;var d=0,e=0;b=i;if((a[280840]|0)!=0){d=280832;e=c[70208]|0;i=b;return e|0}if((_a(280840)|0)==0){d=280832;e=c[70208]|0;i=b;return e|0}do{if((a[285552]|0)==0){if((_a(285552)|0)==0){break}B$a(285264,0,288)|0;de(1284,0,q|0)|0;Wb(285552)}}while(0);tRa(285264,285560)|0;tRa(285276|0,285576)|0;c[70208]=285264;Wb(280840);d=280832;e=c[70208]|0;i=b;return e|0}function fZa(b){b=b|0;var c=0;b=i;if((a[280864]|0)!=0){c=280848;i=b;return c|0}if((_a(280864)|0)==0){c=280848;i=b;return c|0}IQa(280848,280872,8);de(1285,280848,q|0)|0;Wb(280864);c=280848;i=b;return c|0}function gZa(b){b=b|0;var c=0;b=i;if((a[280904]|0)!=0){c=280888;i=b;return c|0}if((_a(280904)|0)==0){c=280888;i=b;return c|0}qRa(280888,280912,v_a(280912)|0);de(1286,280888,q|0)|0;Wb(280904);c=280888;i=b;return c|0}function hZa(b){b=b|0;var c=0;b=i;if((a[280968]|0)!=0){c=280952;i=b;return c|0}if((_a(280968)|0)==0){c=280952;i=b;return c|0}IQa(280952,280976,8);de(1285,280952,q|0)|0;Wb(280968);c=280952;i=b;return c|0}function iZa(b){b=b|0;var c=0;b=i;if((a[281008]|0)!=0){c=280992;i=b;return c|0}if((_a(281008)|0)==0){c=280992;i=b;return c|0}qRa(280992,281016,v_a(281016)|0);de(1286,280992,q|0)|0;Wb(281008);c=280992;i=b;return c|0}function jZa(b){b=b|0;var c=0;b=i;if((a[281072]|0)!=0){c=281056;i=b;return c|0}if((_a(281072)|0)==0){c=281056;i=b;return c|0}IQa(281056,281080,20);de(1285,281056,q|0)|0;Wb(281072);c=281056;i=b;return c|0}function kZa(b){b=b|0;var c=0;b=i;if((a[281120]|0)!=0){c=281104;i=b;return c|0}if((_a(281120)|0)==0){c=281104;i=b;return c|0}qRa(281104,281128,v_a(281128)|0);de(1286,281104,q|0)|0;Wb(281120);c=281104;i=b;return c|0}function lZa(b){b=b|0;var c=0;b=i;if((a[281232]|0)!=0){c=281216;i=b;return c|0}if((_a(281232)|0)==0){c=281216;i=b;return c|0}IQa(281216,281240,11);de(1285,281216,q|0)|0;Wb(281232);c=281216;i=b;return c|0}function mZa(b){b=b|0;var c=0;b=i;if((a[281272]|0)!=0){c=281256;i=b;return c|0}if((_a(281272)|0)==0){c=281256;i=b;return c|0}qRa(281256,281280,v_a(281280)|0);de(1286,281256,q|0)|0;Wb(281272);c=281256;i=b;return c|0}function nZa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Qc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[280344]|0)==0){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);l=+r$a(b,g,c[70084]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function oZa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Qc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[280344]|0)==0){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);l=+r$a(b,g,c[70084]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function pZa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Qc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[280344]|0)==0){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);l=+r$a(b,g,c[70084]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)==34){c[e>>2]=4}h=l;i=f;return+h}function qZa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}l=Qc()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[280344]|0)==0){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);n=mb(b|0,h|0,f|0,c[70084]|0)|0;f=J;b=c[l>>2]|0;if((b|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((b|0)!=34){j=n;k=f;J=k;i=g;return j|0}c[e>>2]=4;j=-1;k=-1;J=k;i=g;return j|0}function rZa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Qc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[280344]|0)==0){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);m=mb(b|0,h|0,f|0,c[70084]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function sZa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Qc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[280344]|0)==0){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);m=mb(b|0,h|0,f|0,c[70084]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function tZa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Qc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[280344]|0)==0){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);m=mb(b|0,h|0,f|0,c[70084]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>65535)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m&65535;i=g;return j|0}return 0}function uZa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}l=Qc()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[280344]|0)==0){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);n=Jc(b|0,h|0,f|0,c[70084]|0)|0;f=J;b=c[l>>2]|0;if((b|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((b|0)==34){c[e>>2]=4;e=(f|0)>0|(f|0)==0&n>>>0>0;J=e?2147483647:-2147483648;i=g;return(e?-1:0)|0}else{j=n;k=f;J=k;i=g;return j|0}return 0}function vZa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}k=Qc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[280344]|0)==0){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);m=Jc(b|0,h|0,f|0,c[70084]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}do{if((b|0)==34){c[e>>2]=4;if((f|0)>0|(f|0)==0&m>>>0>0){j=2147483647}else{break}i=g;return j|0}else{if((f|0)<-1|(f|0)==-1&m>>>0<2147483648){c[e>>2]=4;break}if((f|0)>0|(f|0)==0&m>>>0>2147483647){c[e>>2]=4;j=2147483647;i=g;return j|0}else{j=m;i=g;return j|0}}}while(0);j=-2147483648;i=g;return j|0}function wZa(a){a=a|0;var b=0,e=0,f=0,g=0,h=0;b=i;e=a+4|0;f=e;g=d[f]|d[f+1|0]<<8|d[f+2|0]<<16|d[f+3|0]<<24;f=e+4|0;e=d[f]|d[f+1|0]<<8|d[f+2|0]<<16|d[f+3|0]<<24;f=(c[a>>2]|0)+(e>>1)|0;a=f;if((e&1|0)==0){h=g;le[h&2047](a);i=b;return}else{h=c[(c[f>>2]|0)+g>>2]|0;le[h&2047](a);i=b;return}}function xZa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;f=b+8|0;g=b+4|0;h=c[g>>2]|0;j=c[f>>2]|0;k=h;if(!(j-k>>2>>>0<d>>>0)){l=d;m=h;do{if((m|0)==0){n=0}else{c[m>>2]=0;n=c[g>>2]|0}m=n+4|0;c[g>>2]=m;l=l+ -1|0;}while((l|0)!=0);i=e;return}l=b+16|0;m=b;n=c[m>>2]|0;h=k-n>>2;k=h+d|0;if(k>>>0>1073741823){qXa(0)}o=j-n|0;do{if(o>>2>>>0<536870911){n=o>>1;j=n>>>0<k>>>0?k:n;if((j|0)==0){p=0;q=0;break}n=b+128|0;if(!((a[n]|0)==0&j>>>0<29)){r=j;s=11;break}a[n]=1;p=j;q=l}else{r=1073741823;s=11}}while(0);if((s|0)==11){p=r;q=$_a(r<<2)|0}r=d;d=q+(h<<2)|0;do{if((d|0)==0){t=0}else{c[d>>2]=0;t=d}d=t+4|0;r=r+ -1|0;}while((r|0)!=0);r=c[m>>2]|0;t=(c[g>>2]|0)-r|0;s=q+(h-(t>>2)<<2)|0;h=r;z$a(s|0,h|0,t|0)|0;c[m>>2]=s;c[g>>2]=d;c[f>>2]=q+(p<<2);if((r|0)==0){i=e;return}if((l|0)==(r|0)){a[b+128|0]=0;i=e;return}else{b$a(h);i=e;return}}function yZa(a){a=a|0;a=i;sRa(285540|0);sRa(285528|0);sRa(285516|0);sRa(285504|0);sRa(285492|0);sRa(285480|0);sRa(285468|0);sRa(285456|0);sRa(285444|0);sRa(285432|0);sRa(285420|0);sRa(285408|0);sRa(285396|0);sRa(285384|0);sRa(285372|0);sRa(285360|0);sRa(285348|0);sRa(285336|0);sRa(285324|0);sRa(285312|0);sRa(285300|0);sRa(285288|0);sRa(285276|0);sRa(285264);i=a;return}function zZa(a){a=a|0;a=i;QQa(285868|0);QQa(285856|0);QQa(285844|0);QQa(285832|0);QQa(285820|0);QQa(285808|0);QQa(285796|0);QQa(285784|0);QQa(285772|0);QQa(285760|0);QQa(285748|0);QQa(285736|0);QQa(285724|0);QQa(285712|0);QQa(285700|0);QQa(285688|0);QQa(285676|0);QQa(285664|0);QQa(285652|0);QQa(285640|0);QQa(285628|0);QQa(285616|0);QQa(285604|0);QQa(285592);i=a;return}function AZa(a){a=a|0;a=i;sRa(286180|0);sRa(286168|0);sRa(286156|0);sRa(286144|0);sRa(286132|0);sRa(286120|0);sRa(286108|0);sRa(286096|0);sRa(286084|0);sRa(286072|0);sRa(286060|0);sRa(286048|0);sRa(286036|0);sRa(286024|0);sRa(286012|0);sRa(286e3|0);sRa(285988|0);sRa(285976|0);sRa(285964|0);sRa(285952|0);sRa(285940|0);sRa(285928|0);sRa(285916|0);sRa(285904);i=a;return}function BZa(a){a=a|0;a=i;QQa(287020|0);QQa(287008|0);QQa(286996|0);QQa(286984|0);QQa(286972|0);QQa(286960|0);QQa(286948|0);QQa(286936|0);QQa(286924|0);QQa(286912|0);QQa(286900|0);QQa(286888|0);QQa(286876|0);QQa(286864|0);QQa(286852|0);QQa(286840|0);QQa(286828|0);QQa(286816|0);QQa(286804|0);QQa(286792|0);QQa(286780|0);QQa(286768|0);QQa(286756|0);QQa(286744);i=a;return}function CZa(a){a=a|0;a=i;sRa(287412|0);sRa(287400|0);sRa(287388|0);sRa(287376|0);sRa(287364|0);sRa(287352|0);sRa(287340|0);sRa(287328|0);sRa(287316|0);sRa(287304|0);sRa(287292|0);sRa(287280|0);sRa(287268|0);sRa(287256);i=a;return}function DZa(a){a=a|0;a=i;QQa(287948|0);QQa(287936|0);QQa(287924|0);QQa(287912|0);QQa(287900|0);QQa(287888|0);QQa(287876|0);QQa(287864|0);QQa(287852|0);QQa(287840|0);QQa(287828|0);QQa(287816|0);QQa(287804|0);QQa(287792);i=a;return}function EZa(a){a=a|0;var b=0,c=0;b=i;if((KZa(a)|0)==0){c=(FZa(a)|0)!=0|0}else{c=1}i=b;return c|0}function FZa(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<131072){c=(d[288104+((d[288104+(a>>>8)|0]|0)<<5|a>>>3&31)|0]|0)>>>(a&7)&1;i=b;return c|0}else{c=a>>>0<196606|0;i=b;return c|0}return 0}function GZa(a){a=a|0;var b=0,c=0;b=i;c=Ab(a|0)|0;i=b;return c|0}function HZa(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<32|(a+ -127|0)>>>0<33|(a+ -8232|0)>>>0<2){c=1;i=b;return c|0}c=(a+ -65529|0)>>>0<3|0;i=b;return c|0}function IZa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;switch(b|0){case 6:{d=LZa(a)|0;break};case 8:{d=NZa(a)|0;break};case 5:{d=KZa(a)|0;break};case 11:{d=QZa(a)|0;break};case 4:{d=HZa(a)|0;break};case 9:{d=OZa(a)|0;break};case 1:{d=EZa(a)|0;break};case 7:{d=MZa(a)|0;break};case 10:{d=PZa(a)|0;break};case 2:{d=FZa(a)|0;break};case 3:{d=GZa(a)|0;break};case 12:{d=RZa(a)|0;break};default:{d=0}}i=c;return d|0}function JZa(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;c=i;d=a[b]|0;e=97;f=1;g=291080;while(1){if(d<<24>>24==e<<24>>24){if((t$a(b,g)|0)==0){h=f;j=5;break}}k=g+6|0;l=a[k]|0;if(l<<24>>24==0){h=0;j=5;break}else{e=l;f=f+1|0;g=k}}if((j|0)==5){i=c;return h|0}return 0}function KZa(a){a=a|0;i=i;return(a+ -48|0)>>>0<10|0}function LZa(a){a=a|0;var b=0,c=0;b=i;if((PZa(a)|0)==0){c=(NZa(a)|0)!=0|0}else{c=0}i=b;return c|0}function MZa(a){a=a|0;var b=0,c=0;b=i;if((SZa(a)|0)==(a|0)){c=(a|0)==223|0}else{c=1}i=b;return c|0}function NZa(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<255){c=(a+1&127)>>>0>32|0;i=b;return c|0}if(a>>>0<8232|(a+ -8234|0)>>>0<47062|(a+ -57344|0)>>>0<8185){c=1;i=b;return c|0}else{i=b;return((a+ -65532|0)>>>0>1048579|(a&65534|0)==65534)&1^1|0}return 0}function OZa(a){a=a|0;var b=0,c=0;b=i;if(!(a>>>0<131072)){c=0;i=b;return c|0}c=(d[291160+((d[291160+(a>>>8)|0]|0)<<5|a>>>3&31)|0]|0)>>>(a&7)&1;i=b;return c|0}function PZa(a){a=a|0;var b=0,c=0;b=i;c=(u_a(294328,a)|0)!=0|0;i=b;return c|0}function QZa(a){a=a|0;var b=0,c=0;b=i;c=(UZa(a)|0)!=(a|0)|0;i=b;return c|0}function RZa(a){a=a|0;var b=0,c=0;b=i;if((a+ -48|0)>>>0<10){c=1;i=b;return c|0}c=((a|32)+ -97|0)>>>0<6|0;i=b;return c|0}function SZa(a){a=a|0;var b=0,c=0;b=i;c=TZa(a,0)|0;i=b;return c|0}function TZa(c,f){c=c|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;h=(f<<1)+ -1|0;j=f+ -1|0;if((FZa(c)|0)==0|(c+ -1536|0)>>>0<2560|(c+ -11776|0)>>>0<30784|(c+ -43008|0)>>>0<22272){k=c;i=g;return k|0}do{if((f|0)==0){if(!((c+ -11520|0)>>>0<38)){l=0;break}k=c+ -7264|0;i=g;return k|0}else{if(!((c+ -4256|0)>>>0<46)){l=0;break}do{if((c|0)>4293){if((c|0)==4295|(c|0)==4301){break}else{k=c}i=g;return k|0}}while(0);k=c+7264|0;i=g;return k|0}}while(0);while(1){m=a[294418+(l<<2)|0]|0;n=m<<24>>24;o=c-(e[294416+(l<<2)>>1]|0)|0;p=l+1|0;if((o-(n&j)|0)>>>0<(d[294419+(l<<2)|0]|0)>>>0){q=12;break}if((p|0)==61){break}else{l=p}}if((q|0)==12){if(m<<24>>24==1){k=f+c-(o&1)|0;i=g;return k|0}else{k=(fa(n,h)|0)+c|0;i=g;return k|0}}h=1-f|0;n=b[294664+(h<<1)>>1]|0;a:do{if(!(n<<16>>16==0)){o=n;m=0;while(1){q=m+1|0;if((o&65535|0)==(c|0)){break}l=b[294664+(q<<2)+(h<<1)>>1]|0;if(l<<16>>16==0){break a}else{o=l;m=q}}k=e[294664+(m<<2)+(f<<1)>>1]|0;i=g;return k|0}}while(0);if(!((c+ -66600+(f*40|0)|0)>>>0<40)){k=c;i=g;return k|0}k=c+ -40+(f*80|0)|0;i=g;return k|0}function UZa(a){a=a|0;var b=0,c=0;b=i;c=TZa(a,1)|0;i=b;return c|0}function VZa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=WZa(0,a,b,(c|0)!=0?c:295368)|0;i=d;return e|0}function WZa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+8|0;h=g;c[h>>2]=b;j=(f|0)==0?295376:f;f=c[j>>2]|0;a:do{if((d|0)==0){if((f|0)==0){k=0}else{break}i=g;return k|0}else{if((b|0)==0){l=h;c[h>>2]=l;m=l}else{m=b}if((e|0)==0){k=-2;i=g;return k|0}do{if((f|0)==0){l=a[d]|0;n=l&255;if(l<<24>>24>-1){c[m>>2]=n;k=l<<24>>24!=0|0;i=g;return k|0}else{l=n+ -194|0;if(l>>>0>50){break a}o=e+ -1|0;p=c[295160+(l<<2)>>2]|0;q=d+1|0;break}}else{o=e;p=f;q=d}}while(0);b:do{if((o|0)==0){r=p}else{l=a[q]|0;n=(l&255)>>>3;if((n+ -16|n+(p>>26))>>>0>7){break a}else{s=o;t=l;u=p;v=q}while(1){v=v+1|0;u=(t&255)+ -128|u<<6;s=s+ -1|0;if((u|0)>=0){break}if((s|0)==0){r=u;break b}t=a[v]|0;if(((t&255)+ -128|0)>>>0>63){break a}}c[j>>2]=0;c[m>>2]=u;k=e-s|0;i=g;return k|0}}while(0);c[j>>2]=r;k=-2;i=g;return k|0}}while(0);c[j>>2]=0;c[(Qc()|0)>>2]=84;k=-1;i=g;return k|0}function XZa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=i;i=i+1032|0;h=g+1024|0;j=c[b>>2]|0;c[h>>2]=j;k=(a|0)!=0;l=g;m=k?e:256;e=k?a:l;a:do{if((j|0)==0|(m|0)==0){n=d;o=m;p=j;q=0;r=e}else{a=d;s=m;t=j;u=0;v=e;while(1){w=a>>>2;x=w>>>0>=s>>>0;if(!(x|a>>>0>131)){n=a;o=s;p=t;q=u;r=v;break a}y=x?s:w;z=a-y|0;w=YZa(v,h,y,f)|0;if((w|0)==-1){break}if((v|0)==(l|0)){A=s;B=l}else{A=s-w|0;B=v+(w<<2)|0}y=w+u|0;w=c[h>>2]|0;if((w|0)==0|(A|0)==0){n=z;o=A;p=w;q=y;r=B;break a}else{a=z;s=A;t=w;u=y;v=B}}n=z;o=0;p=c[h>>2]|0;q=-1;r=v}}while(0);b:do{if((p|0)==0){C=q}else{if((o|0)==0|(n|0)==0){C=q;break}else{D=n;E=o;F=p;G=q;H=r}while(1){I=WZa(H,F,D,f)|0;if((I+2|0)>>>0<3){break}z=(c[h>>2]|0)+I|0;c[h>>2]=z;B=E+ -1|0;A=G+1|0;if((B|0)==0|(D|0)==(I|0)){C=A;break b}else{D=D-I|0;E=B;F=z;G=A;H=H+4|0}}if((I|0)==-1){C=-1;break}else if((I|0)==0){c[h>>2]=0;C=G;break}else{c[f>>2]=0;C=G;break}}}while(0);if(!k){i=g;return C|0}c[b>>2]=c[h>>2];i=g;return C|0}function YZa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;h=i;j=c[e>>2]|0;do{if((g|0)==0){k=5}else{l=g;m=c[l>>2]|0;if((m|0)==0){k=5;break}if((b|0)==0){n=f;o=m;p=j;k=16;break}c[l>>2]=0;q=b;r=f;s=m;t=j;k=36}}while(0);if((k|0)==5){if((b|0)==0){u=f;v=j;k=7}else{w=b;x=f;y=j;k=6}}a:while(1){if((k|0)==6){k=0;if((x|0)==0){z=f;k=53;break}else{A=w;B=x;C=y}while(1){j=a[C]|0;do{if(((j&255)+ -1|0)>>>0<127){if((C&3|0)==0&B>>>0>3){D=A;E=B;F=C}else{G=A;H=B;I=j;J=C;break}while(1){K=c[F>>2]|0;if(((K+ -16843009|K)&-2139062144|0)!=0){k=30;break}c[D>>2]=K&255;c[D+4>>2]=d[F+1|0]|0;c[D+8>>2]=d[F+2|0]|0;L=F+4|0;M=D+16|0;c[D+12>>2]=d[F+3|0]|0;N=E+ -4|0;if(N>>>0>3){D=M;E=N;F=L}else{k=31;break}}if((k|0)==30){k=0;G=D;H=E;I=K&255;J=F;break}else if((k|0)==31){k=0;G=M;H=N;I=a[L]|0;J=L;break}}else{G=A;H=B;I=j;J=C}}while(0);O=I&255;if(!((O+ -1|0)>>>0<127)){break}c[G>>2]=O;j=H+ -1|0;if((j|0)==0){z=f;k=53;break a}else{A=G+4|0;B=j;C=J+1|0}}j=O+ -194|0;if(j>>>0>50){P=G;Q=H;R=J;k=47;break}q=G;r=H;s=c[295160+(j<<2)>>2]|0;t=J+1|0;k=36;continue}else if((k|0)==7){k=0;j=a[v]|0;do{if(((j&255)+ -1|0)>>>0<127){if((v&3|0)!=0){S=u;T=j;U=v;break}g=c[v>>2]|0;if(((g+ -16843009|g)&-2139062144|0)==0){V=u;W=v}else{S=u;T=g&255;U=v;break}do{W=W+4|0;V=V+ -4|0;X=c[W>>2]|0;}while(((X+ -16843009|X)&-2139062144|0)==0);S=V;T=X&255;U=W}else{S=u;T=j;U=v}}while(0);j=T&255;if((j+ -1|0)>>>0<127){u=S+ -1|0;v=U+1|0;k=7;continue}g=j+ -194|0;if(g>>>0>50){P=b;Q=S;R=U;k=47;break}n=S;o=c[295160+(g<<2)>>2]|0;p=U+1|0;k=16;continue}else if((k|0)==16){k=0;g=(d[p]|0)>>>3;if((g+ -16|g+(o>>26))>>>0>7){k=17;break}g=p+1|0;do{if((o&33554432|0)==0){Y=g}else{if(((d[g]|0)+ -128|0)>>>0>63){k=20;break a}j=p+2|0;if((o&524288|0)==0){Y=j;break}if(((d[j]|0)+ -128|0)>>>0>63){k=23;break a}Y=p+3|0}}while(0);u=n+ -1|0;v=Y;k=7;continue}else if((k|0)==36){k=0;g=d[t]|0;j=g>>>3;if((j+ -16|j+(s>>26))>>>0>7){k=37;break}j=t+1|0;Z=g+ -128|s<<6;do{if((Z|0)<0){g=(d[j]|0)+ -128|0;if(g>>>0>63){k=40;break a}m=t+2|0;_=g|Z<<6;if((_|0)>=0){$=_;aa=m;break}g=(d[m]|0)+ -128|0;if(g>>>0>63){k=43;break a}$=g|_<<6;aa=t+3|0}else{$=Z;aa=j}}while(0);c[q>>2]=$;w=q+4|0;x=r+ -1|0;y=aa;k=6;continue}}if((k|0)==17){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==20){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==23){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==37){ba=q;ca=r;da=s;ea=t+ -1|0;k=46}else if((k|0)==40){ba=q;ca=r;da=Z;ea=t+ -1|0;k=46}else if((k|0)==43){ba=q;ca=r;da=_;ea=t+ -1|0;k=46}else if((k|0)==53){i=h;return z|0}if((k|0)==46){if((da|0)==0){P=ba;Q=ca;R=ea;k=47}else{fa=ba;ga=ea}}do{if((k|0)==47){if((a[R]|0)!=0){fa=P;ga=R;break}if((P|0)!=0){c[P>>2]=0;c[e>>2]=0}z=f-Q|0;i=h;return z|0}}while(0);c[(Qc()|0)>>2]=84;if((fa|0)==0){z=-1;i=h;return z|0}c[e>>2]=ga;z=-1;i=h;return z|0}function ZZa(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;c[h>>2]=b;if((e|0)==0){j=0;i=g;return j|0}do{if((f|0)!=0){if((b|0)==0){k=h;c[h>>2]=k;l=k}else{l=b}k=a[e]|0;m=k&255;if(k<<24>>24>-1){c[l>>2]=m;j=k<<24>>24!=0|0;i=g;return j|0}k=m+ -194|0;if(k>>>0>50){break}m=e+1|0;n=c[295160+(k<<2)>>2]|0;if(f>>>0<4){if((n&-2147483648>>>((f*6|0)+ -6|0)|0)!=0){break}}k=d[m]|0;m=k>>>3;if((m+ -16|m+(n>>26))>>>0>7){break}m=k+ -128|n<<6;if((m|0)>=0){c[l>>2]=m;j=2;i=g;return j|0}n=(d[e+2|0]|0)+ -128|0;if(n>>>0>63){break}k=n|m<<6;if((k|0)>=0){c[l>>2]=k;j=3;i=g;return j|0}m=(d[e+3|0]|0)+ -128|0;if(m>>>0>63){break}c[l>>2]=m|k<<6;j=4;i=g;return j|0}}while(0);c[(Qc()|0)>>2]=84;j=-1;i=g;return j|0}function _Za(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((b|0)==0){f=1;i=e;return f|0}if(d>>>0<128){a[b]=d;f=1;i=e;return f|0}if(d>>>0<2048){a[b]=d>>>6|192;a[b+1|0]=d&63|128;f=2;i=e;return f|0}if(d>>>0<55296|(d+ -57344|0)>>>0<8192){a[b]=d>>>12|224;a[b+1|0]=d>>>6&63|128;a[b+2|0]=d&63|128;f=3;i=e;return f|0}if((d+ -65536|0)>>>0<1048576){a[b]=d>>>18|240;a[b+1|0]=d>>>12&63|128;a[b+2|0]=d>>>6&63|128;a[b+3|0]=d&63|128;f=4;i=e;return f|0}else{c[(Qc()|0)>>2]=84;f=-1;i=e;return f|0}return 0}function $Za(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+264|0;g=f+256|0;h=f;j=c[b>>2]|0;c[g>>2]=j;k=(a|0)!=0;l=k?e:256;e=k?a:h;a:do{if((j|0)==0|(l|0)==0){m=d;n=l;o=j;p=0;q=e}else{a=d;r=l;s=j;t=0;u=e;while(1){v=a>>>0>=r>>>0;if(!(v|a>>>0>32)){m=a;n=r;o=s;p=t;q=u;break a}w=v?r:a;x=a-w|0;v=a_a(u,g,w,0)|0;if((v|0)==-1){break}if((u|0)==(h|0)){y=r;z=h}else{y=r-v|0;z=u+v|0}w=v+t|0;v=c[g>>2]|0;if((v|0)==0|(y|0)==0){m=x;n=y;o=v;p=w;q=z;break a}else{a=x;r=y;s=v;t=w;u=z}}m=x;n=0;o=c[g>>2]|0;p=-1;q=u}}while(0);b:do{if((o|0)==0){A=p}else{if((n|0)==0|(m|0)==0){A=p;break}else{B=m;C=n;D=o;E=p;F=q}while(1){G=_Za(F,c[D>>2]|0,0)|0;if((G+1|0)>>>0<2){break}x=(c[g>>2]|0)+4|0;c[g>>2]=x;z=B+ -1|0;y=E+1|0;if((C|0)==(G|0)|(z|0)==0){A=y;break b}else{B=z;C=C-G|0;D=x;E=y;F=F+G|0}}if((G|0)!=0){A=-1;break}c[g>>2]=0;A=E}}while(0);if(!k){i=f;return A|0}c[b>>2]=c[g>>2];i=f;return A|0}function a_a(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;i=i+8|0;g=f;if((b|0)==0){h=c[d>>2]|0;j=g;k=c[h>>2]|0;if((k|0)==0){l=0;i=f;return l|0}else{m=0;n=k;o=h}while(1){if(n>>>0>127){h=_Za(j,n,0)|0;if((h|0)==-1){l=-1;p=26;break}else{q=h}}else{q=1}h=q+m|0;k=o+4|0;r=c[k>>2]|0;if((r|0)==0){l=h;p=26;break}else{m=h;n=r;o=k}}if((p|0)==26){i=f;return l|0}}a:do{if(e>>>0>3){o=b;n=e;m=c[d>>2]|0;while(1){q=c[m>>2]|0;if((q|0)==0){s=o;t=n;break a}if(q>>>0>127){j=_Za(o,q,0)|0;if((j|0)==-1){l=-1;break}u=o+j|0;v=n-j|0;w=m}else{a[o]=q;u=o+1|0;v=n+ -1|0;w=c[d>>2]|0}q=w+4|0;c[d>>2]=q;if(v>>>0>3){o=u;n=v;m=q}else{s=u;t=v;break a}}i=f;return l|0}else{s=b;t=e}}while(0);b:do{if((t|0)==0){x=0}else{b=g;v=s;u=t;w=c[d>>2]|0;while(1){m=c[w>>2]|0;if((m|0)==0){p=24;break}if(m>>>0>127){n=_Za(b,m,0)|0;if((n|0)==-1){l=-1;p=26;break}if(n>>>0>u>>>0){p=20;break}_Za(v,c[w>>2]|0,0)|0;y=v+n|0;z=u-n|0;A=w}else{a[v]=m;y=v+1|0;z=u+ -1|0;A=c[d>>2]|0}m=A+4|0;c[d>>2]=m;if((z|0)==0){x=0;break b}else{v=y;u=z;w=m}}if((p|0)==20){l=e-u|0;i=f;return l|0}else if((p|0)==24){a[v]=0;x=u;break}else if((p|0)==26){i=f;return l|0}}}while(0);c[d>>2]=0;l=e-x|0;i=f;return l|0}function b_a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0;f=i;i=i+104|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+48|0;o=f+56|0;p=V_a(20)|0;q=p;if((p|0)==0){r=12;i=f;return r|0}s=V_a(2048)|0;c[p+16>>2]=s;if((s|0)==0){W_a(p);r=12;i=f;return r|0}c[p>>2]=512;c[p+4>>2]=10240;c[p+8>>2]=128;c[p+12>>2]=0;s=r_a(0,0)|0;if((s|0)==0){W_a(c[p+16>>2]|0);W_a(p);r=12;i=f;return r|0}t=o+0|0;u=t+44|0;do{c[t>>2]=0;t=t+4|0}while((t|0)<(u|0));c[o>>2]=s;c[o+4>>2]=q;c[o+12>>2]=d;c[o+36>>2]=e;d=o+28|0;c[d>>2]=-1;t=c_a(o)|0;a:do{if((t|0)==0){u=o+20|0;v=c[u>>2]|0;w=v+ -1|0;c[b>>2]=w;x=c[o+8>>2]|0;y=c[d>>2]|0;if((y|0)>-1){if((c[o+32>>2]|0)!=0){z=0;A=2;B=0;C=0;break}}if((y|0)>(w|0)){z=0;A=6;B=0;C=0;break}w=X_a(1,68)|0;D=w;if((w|0)==0){z=0;A=12;B=0;C=D;break}E=y>>>31;c[w+60>>2]=E^1;c[w+64>>2]=c[o+32>>2];c[w+28>>2]=v;if((E|0)==1){if((e&8|0)==0){F=13}else{G=0}}else{F=13}if((F|0)==13){E=d_a(0,q,x,D)|0;if((E|0)!=0){z=0;A=E;B=0;C=D;break}E=c[w+40>>2]|0;if((E|0)>0){v=(E<<2)+4|0;y=V_a(v)|0;H=y;if((y|0)==0){z=0;A=12;B=0;C=D;break}c[w+32>>2]=H;B$a(y|0,-1,v|0)|0;I=H}else{I=0}H=X_a(E<<1|1,4)|0;c[w+36>>2]=H;if((H|0)==0){z=0;A=12;B=0;C=D;break}H=X_a(c[u>>2]|0,12)|0;if((H|0)==0){z=0;A=12;B=0;C=D;break}c[w+16>>2]=H;H=d_a(s,q,x,D)|0;if((H|0)==0){G=I}else{z=0;A=H;B=0;C=D;break}}H=o+24|0;u=p+12|0;E=c[u>>2]|0;c[j>>2]=0;c[k>>2]=0;v=j_a(q,x)|0;b:do{if((v|0)==0){y=j_a(q,0)|0;if((y|0)!=0){J=y;break}y=p+16|0;K=c[u>>2]|0;c:do{if((K|0)>(E|0)){L=0;M=0;N=0;O=K;d:while(1){P=O+ -1|0;c[u>>2]=P;Q=c[y>>2]|0;R=c[Q+(P<<2)>>2]|0;P=O+ -2|0;c[u>>2]=P;S=c[Q+(P<<2)>>2]|0;do{if((R|0)==0){P=c[S>>2]|0;if((P|0)==3){T=c[S+4>>2]|0;U=j_a(q,c[T+4>>2]|0)|0;if((U|0)!=0){V=N;W=U;break c}U=j_a(q,0)|0;if((U|0)!=0){V=N;W=U;break c}U=j_a(q,c[T>>2]|0)|0;if((U|0)!=0){V=N;W=U;break c}X=j_a(q,0)|0}else if((P|0)==0){U=c[S+4>>2]|0;T=c[U>>2]|0;if(!((T|0)>-1|(T|0)==-4)){Y=L;Z=M;_=N;break}T=U+8|0;U=(c[T>>2]|0)+L|0;c[T>>2]=U;if((U|0)<=(c[k>>2]|0)){Y=L;Z=M;_=N;break}c[k>>2]=U;Y=L;Z=M;_=N;break}else if((P|0)==1){U=c[S+4>>2]|0;T=j_a(q,c[U+4>>2]|0)|0;if((T|0)!=0){V=N;W=T;break c}T=j_a(q,0)|0;if((T|0)!=0){V=N;W=T;break c}T=j_a(q,c[U>>2]|0)|0;if((T|0)!=0){V=N;W=T;break c}X=j_a(q,0)|0}else if((P|0)==2){P=c[S+4>>2]|0;T=j_a(q,L)|0;if((T|0)!=0){V=N;W=T;break c}T=j_a(q,S)|0;if((T|0)!=0){V=N;W=T;break c}T=j_a(q,1)|0;if((T|0)!=0){V=N;W=T;break c}T=j_a(q,c[P>>2]|0)|0;if((T|0)!=0){V=N;W=T;break c}T=j_a(q,0)|0;if((T|0)!=0){V=N;W=T;break c}if((c[P+4>>2]|0)>1){F=45}else{if((c[P+8>>2]|0)>1){F=45}else{$=L}}if((F|0)==45){F=0;c[j>>2]=0;$=0}Y=$;Z=M+1|0;_=N;break}else{Y=L;Z=M;_=N;break}if((X|0)==0){Y=L;Z=M;_=N}else{V=N;W=X;break c}}else if((R|0)==1){P=S+4|0;T=c[P>>2]|0;U=O+ -3|0;c[u>>2]=U;aa=c[Q+(U<<2)>>2]|0;c[j>>2]=aa;U=T+4|0;ba=c[U>>2]|0;do{if((ba|0)>1){c[l>>2]=0;ca=T;F=51}else{if((c[T+8>>2]|0)<=1){da=aa;break}c[l>>2]=0;ea=T;if((ba|0)>0){ca=ea;F=51}else{fa=ba;ga=ea;ha=aa;ia=0;F=60}}}while(0);e:do{if((F|0)==51){F=0;ea=aa;ja=ba;ka=1;la=0;while(1){ma=k_a(s,q,c[ca>>2]|0,(ka|0)<(ja|0)?1:2,j,G,m,k)|0;if((ma|0)!=0){J=ma;break b}ma=c[m>>2]|0;if((la|0)==0){na=ma}else{oa=t_a(s,0,0,1,32)|0;if((oa|0)==0){J=12;break b}pa=t_a(s,0,0,1,8)|0;qa=oa+4|0;c[qa>>2]=pa;if((pa|0)==0){J=12;break b}c[oa>>2]=1;c[oa+8>>2]=-1;c[oa+12>>2]=-1;c[pa>>2]=la;c[(c[qa>>2]|0)+4>>2]=ma;c[oa+16>>2]=(c[ma+16>>2]|0)+(c[la+16>>2]|0);na=oa}if((na|0)==0){J=12;break b}oa=c[U>>2]|0;if((ka|0)>=(oa|0)){fa=oa;ga=ca;ha=ea;ia=na;F=60;break e}ea=c[j>>2]|0;ja=oa;ka=ka+1|0;la=na}}}while(0);if((F|0)==60){F=0;U=T+8|0;ba=c[U>>2]|0;do{if((ba|0)==-1){la=c[j>>2]|0;ka=k_a(s,q,c[ga>>2]|0,0,j,0,l,k)|0;if((ka|0)!=0){J=ka;break b}ka=c[l>>2]|0;ja=t_a(s,0,0,1,32)|0;ea=ja;if((ja|0)==0){F=65;break d}oa=t_a(s,0,0,1,16)|0;c[ja+4>>2]=oa;if((oa|0)==0){F=65;break d}c[ja>>2]=2;c[ja+8>>2]=-1;c[ja+12>>2]=-1;c[oa>>2]=ka;c[oa+4>>2]=0;c[oa+8>>2]=-1;ma=oa+12|0;a[ma]=a[ma]&-2;c[ja+16>>2]=c[ka+16>>2];c[l>>2]=ea;ra=ea;sa=la}else{if((fa|0)<(ba|0)){ta=0;ua=fa}else{ra=0;sa=ha;break}while(1){la=c[j>>2]|0;ea=k_a(s,q,c[ga>>2]|0,0,j,0,n,k)|0;if((ea|0)!=0){J=ea;break b}ea=c[n>>2]|0;if((ta|0)==0){va=ea}else{ka=t_a(s,0,0,1,32)|0;if((ka|0)==0){F=73;break d}ja=t_a(s,0,0,1,8)|0;ma=ka+4|0;c[ma>>2]=ja;if((ja|0)==0){F=73;break d}c[ka>>2]=1;c[ka+8>>2]=-1;c[ka+12>>2]=-1;c[ja>>2]=ea;c[(c[ma>>2]|0)+4>>2]=ta;c[ka+16>>2]=(c[ta+16>>2]|0)+(c[ea+16>>2]|0);va=ka}c[l>>2]=va;if((va|0)==0){J=12;break b}ka=t_a(s,0,0,1,32)|0;if((ka|0)==0){J=12;break b}ea=t_a(s,0,0,1,20)|0;c[ka+4>>2]=ea;if((ea|0)==0){J=12;break b}c[ka>>2]=0;c[ka+8>>2]=-1;c[ka+12>>2]=-1;c[ea>>2]=-1;c[ea+4>>2]=-1;c[ea+8>>2]=-1;ea=t_a(s,0,0,1,32)|0;ma=ea;if((ea|0)==0){F=79;break d}ja=t_a(s,0,0,1,8)|0;oa=ea+4|0;c[oa>>2]=ja;if((ja|0)==0){F=79;break d}c[ea>>2]=3;c[ea+8>>2]=-1;c[ea+12>>2]=-1;c[ja>>2]=ka;c[(c[oa>>2]|0)+4>>2]=va;c[ea+16>>2]=(c[va+16>>2]|0)+(c[ka+16>>2]|0);c[l>>2]=ma;ka=ua+1|0;if((ka|0)<(c[U>>2]|0)){ta=ma;ua=ka}else{ra=ma;sa=la;break}}}}while(0);c[j>>2]=sa;do{if((ia|0)==0){wa=ra;F=85}else{if((ra|0)==0){xa=ia;break}U=t_a(s,0,0,1,32)|0;if((U|0)==0){J=12;break b}ba=t_a(s,0,0,1,8)|0;T=U+4|0;c[T>>2]=ba;if((ba|0)==0){J=12;break b}c[U>>2]=1;c[U+8>>2]=-1;c[U+12>>2]=-1;c[ba>>2]=ia;c[(c[T>>2]|0)+4>>2]=ra;c[U+16>>2]=(c[ra+16>>2]|0)+(c[ia+16>>2]|0);wa=U;F=85}}while(0);if((F|0)==85){F=0;if((wa|0)==0){J=12;break b}else{xa=wa}}c[P>>2]=c[xa+4>>2];c[S>>2]=c[xa>>2];da=sa}U=M+ -1|0;T=da-aa+N|0;if((U|0)!=0){Y=da;Z=U;_=T;break}c[j>>2]=T;Y=T;Z=0;_=T}else{Y=L;Z=M;_=N}}while(0);S=c[u>>2]|0;if((S|0)>(E|0)){L=Y;M=Z;N=_;O=S}else{V=_;W=0;break c}}if((F|0)==65){c[l>>2]=0;J=12;break b}else if((F|0)==73){c[l>>2]=0;J=12;break b}else if((F|0)==79){c[l>>2]=0;J=12;break b}}else{V=0;W=0}}while(0);y=(c[H>>2]|0)+V|0;K=c[k>>2]|0;c[H>>2]=(K|0)>(y|0)?K:y;J=W}else{J=v}}while(0);if((J|0)!=0){z=0;A=J;B=0;C=D;break}v=c[H>>2]|0;c[H>>2]=v+1;E=t_a(s,0,0,1,32)|0;if((E|0)==0){z=0;A=12;B=0;C=D;break}y=t_a(s,0,0,1,20)|0;c[E+4>>2]=y;if((y|0)==0){z=0;A=12;B=0;C=D;break}c[E>>2]=0;c[E+8>>2]=-1;c[E+12>>2]=-1;c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=v;v=t_a(s,0,0,1,32)|0;y=v;if((v|0)==0){z=0;A=12;B=0;C=D;break}K=t_a(s,0,0,1,8)|0;O=v+4|0;c[O>>2]=K;if((K|0)==0){z=0;A=12;B=0;C=D;break}c[v>>2]=1;c[v+8>>2]=-1;c[v+12>>2]=-1;c[K>>2]=x;c[(c[O>>2]|0)+4>>2]=E;c[v+16>>2]=(c[E+16>>2]|0)+(c[x+16>>2]|0);E=c[u>>2]|0;O=j_a(q,v)|0;if((O|0)!=0){z=0;A=O;B=0;C=D;break}O=j_a(q,0)|0;if((O|0)!=0){z=0;A=O;B=0;C=D;break}O=c[u>>2]|0;f:do{if((O|0)>(E|0)){K=p+16|0;N=O;g:while(1){M=N+ -1|0;c[u>>2]=M;L=c[K>>2]|0;S=c[L+(M<<2)>>2]|0;M=N+ -2|0;c[u>>2]=M;ya=c[L+(M<<2)>>2]|0;do{if((S|0)==0){M=c[ya>>2]|0;if((M|0)==0){L=c[ya+4>>2]|0;Q=c[L>>2]|0;if((Q|0)==-4){c[ya+8>>2]=0;R=L+8|0;T=c[R>>2]|0;U=t_a(s,0,0,1,64)|0;if((U|0)==0){F=104;break g}ba=U;c[U>>2]=T;c[U+4>>2]=0;c[U+8>>2]=1114111;c[U+20>>2]=0;c[U+24>>2]=0;T=U+28|0;U=ya+24|0;c[T+0>>2]=-1;c[T+4>>2]=-1;c[T+8>>2]=-1;c[T+12>>2]=-1;c[U>>2]=ba;ba=c[R>>2]|0;R=c[L+4>>2]|0;U=t_a(s,0,0,1,64)|0;if((U|0)==0){F=106;break g}c[U>>2]=ba;c[U+4>>2]=0;c[U+8>>2]=1114111;c[U+20>>2]=0;c[U+24>>2]=0;c[U+28>>2]=R;c[U+32>>2]=-1;c[U+36>>2]=-1;c[U+40>>2]=-1;c[ya+28>>2]=U;break}U=ya+8|0;if((Q|0)<0){c[U>>2]=1;R=t_a(s,0,0,1,32)|0;if((R|0)==0){F=110;break g}c[R>>2]=-1;c[R+4>>2]=-1;c[R+8>>2]=-1;c[ya+24>>2]=R;R=t_a(s,0,0,1,32)|0;if((R|0)==0){F=112;break g}c[R>>2]=-1;c[R+4>>2]=-1;c[R+8>>2]=-1;c[ya+28>>2]=R;break}else{c[U>>2]=0;U=L+8|0;R=c[U>>2]|0;ba=L+4|0;T=c[ba>>2]|0;la=t_a(s,0,0,1,64)|0;if((la|0)==0){F=115;break g}ma=la;c[la>>2]=R;c[la+4>>2]=Q;c[la+8>>2]=T;c[la+20>>2]=0;c[la+24>>2]=0;T=la+28|0;la=ya+24|0;c[T+0>>2]=-1;c[T+4>>2]=-1;c[T+8>>2]=-1;c[T+12>>2]=-1;c[la>>2]=ma;ma=c[U>>2]|0;U=c[L>>2]|0;la=c[ba>>2]|0;ba=c[L+12>>2]|0;T=c[L+16>>2]|0;L=t_a(s,0,0,1,64)|0;if((L|0)==0){F=117;break g}Q=L;c[L>>2]=ma;c[L+4>>2]=U;c[L+8>>2]=la;c[L+20>>2]=ba;c[L+24>>2]=T;T=L+28|0;L=ya+28|0;c[T+0>>2]=-1;c[T+4>>2]=-1;c[T+8>>2]=-1;c[T+12>>2]=-1;c[L>>2]=Q;break}}else if((M|0)==3){Q=j_a(q,ya)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Q=j_a(q,1)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Q=ya+4|0;L=j_a(q,c[(c[Q>>2]|0)+4>>2]|0)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=j_a(q,0)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=j_a(q,c[c[Q>>2]>>2]|0)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=j_a(q,0)|0;if((L|0)==0){break}else{z=0;A=L;B=0;C=D;break a}}else if((M|0)==1){L=j_a(q,ya)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=j_a(q,2)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=ya+4|0;Q=j_a(q,c[(c[L>>2]|0)+4>>2]|0)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Q=j_a(q,0)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Q=j_a(q,c[c[L>>2]>>2]|0)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Q=j_a(q,0)|0;if((Q|0)==0){break}else{z=0;A=Q;B=0;C=D;break a}}else if((M|0)==2){M=j_a(q,ya)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=j_a(q,3)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=j_a(q,c[c[ya+4>>2]>>2]|0)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=j_a(q,0)|0;if((M|0)==0){break}else{z=0;A=M;B=0;C=D;break a}}else{break}}else if((S|0)==1){M=c[ya+4>>2]|0;Q=c[M>>2]|0;L=M+4|0;T=c[L>>2]|0;if((c[Q+8>>2]|0)==0){za=(c[T+8>>2]|0)!=0|0}else{za=1}c[ya+8>>2]=za;ba=h_a(s,c[Q+24>>2]|0,c[T+24>>2]|0,0,0)|0;c[ya+24>>2]=ba;if((ba|0)==0){z=0;A=12;B=0;C=D;break a}ba=h_a(s,c[(c[M>>2]|0)+28>>2]|0,c[(c[L>>2]|0)+28>>2]|0,0,0)|0;c[ya+28>>2]=ba;if((ba|0)==0){z=0;A=12;B=0;C=D;break a}}else if((S|0)==2){ba=c[ya+4>>2]|0;L=c[ba>>2]|0;M=L+8|0;if((c[M>>2]|0)==0){Aa=0}else{Aa=(c[(c[ba+4>>2]|0)+8>>2]|0)!=0|0}c[ya+8>>2]=Aa;if((c[M>>2]|0)==0){c[ya+24>>2]=c[L+24>>2];Ba=ba+4|0}else{M=i_a(q,L,0,0,g)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}Ca=V_a((c[g>>2]<<2)+4|0)|0;M=Ca;if((Ca|0)==0){z=0;A=12;B=0;C=D;break a}c[Ca>>2]=-1;c[h>>2]=0;Da=i_a(q,c[ba>>2]|0,M,h,0)|0;if((Da|0)!=0){F=150;break g}L=ba+4|0;T=h_a(s,c[(c[L>>2]|0)+24>>2]|0,c[(c[ba>>2]|0)+24>>2]|0,M,c[h>>2]|0)|0;M=ya+24|0;c[M>>2]=T;W_a(Ca);if((c[M>>2]|0)==0){z=0;A=12;B=0;C=D;break a}else{Ba=L}}L=c[Ba>>2]|0;if((c[L+8>>2]|0)==0){c[ya+28>>2]=c[L+28>>2];break}M=i_a(q,L,0,0,g)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}Ea=V_a((c[g>>2]<<2)+4|0)|0;M=Ea;if((Ea|0)==0){z=0;A=12;B=0;C=D;break a}c[Ea>>2]=-1;c[h>>2]=0;Fa=i_a(q,c[Ba>>2]|0,M,h,0)|0;if((Fa|0)!=0){F=157;break g}L=h_a(s,c[(c[ba>>2]|0)+28>>2]|0,c[(c[Ba>>2]|0)+28>>2]|0,M,c[h>>2]|0)|0;M=ya+28|0;c[M>>2]=L;W_a(Ea);if((c[M>>2]|0)==0){z=0;A=12;B=0;C=D;break a}}else if((S|0)==3){M=c[ya+4>>2]|0;L=c[M>>2]|0;do{if((c[M+4>>2]|0)==0){F=141}else{if((c[L+8>>2]|0)!=0){F=141;break}c[ya+8>>2]=0}}while(0);if((F|0)==141){F=0;c[ya+8>>2]=1}c[ya+24>>2]=c[L+24>>2];c[ya+28>>2]=c[(c[M>>2]|0)+28>>2]}}while(0);N=c[u>>2]|0;if((N|0)<=(E|0)){break f}}if((F|0)==104){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==106){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==110){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==112){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==115){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==117){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==150){W_a(Ca);z=0;A=Da;B=0;C=D;break a}else if((F|0)==157){W_a(Ea);z=0;A=Fa;B=0;C=D;break a}}}while(0);E=c[H>>2]|0;u=E<<2;O=V_a(u)|0;x=O;if((O|0)==0){z=x;A=12;B=0;C=D;break}N=V_a(u)|0;u=N;if((N|0)==0){z=x;A=12;B=u;C=D;break}if((E|0)>0){B$a(O|0,0,((E|0)>1?E<<2:4)|0)|0}e_a(y,0,x,0)|0;E=c[H>>2]|0;if((E|0)>0){K=0;S=0;while(1){c[N+(S<<2)>>2]=K;ba=O+(S<<2)|0;T=K+1+(c[ba>>2]|0)|0;c[ba>>2]=0;ba=S+1|0;if((ba|0)<(E|0)){S=ba;K=T}else{Ga=T;break}}}else{Ga=0}K=X_a(Ga+1|0,32)|0;S=K;if((K|0)==0){z=x;A=12;B=u;C=D;break}c[w>>2]=S;E=w+4|0;c[E>>2]=Ga;T=e_a(y,S,x,u)|0;if((T|0)!=0){z=x;A=T;B=u;C=D;break}c[w+20>>2]=0;T=v+24|0;S=c[T>>2]|0;if((c[S>>2]|0)>-1){ba=1;Q=S;while(1){S=Q+32|0;la=ba+1|0;if((c[S>>2]|0)>-1){Q=S;ba=la}else{Ha=la;break}}}else{Ha=1}ba=X_a(Ha,32)|0;if((ba|0)==0){z=x;A=12;B=u;C=D;break}c[w+8>>2]=ba;Q=c[T>>2]|0;y=c[Q>>2]|0;if((y|0)>-1){la=y;y=Q;Q=0;while(1){c[ba+(Q<<5)+8>>2]=K+(c[N+(la<<2)>>2]<<5);c[ba+(Q<<5)+12>>2]=la;S=ba+(Q<<5)+16|0;c[S>>2]=0;U=y+12|0;ma=c[U>>2]|0;if((ma|0)!=0){R=0;while(1){Ia=R+1|0;if((c[ma+(R<<2)>>2]|0)>-1){R=Ia}else{break}}R=Ia<<2;ma=V_a(R)|0;c[S>>2]=ma;if((ma|0)==0){z=x;A=12;B=u;C=D;break a}z$a(ma|0,c[U>>2]|0,R|0)|0}c[ba+(Q<<5)+20>>2]=c[y+16>>2];R=Q+1|0;ma=y+32|0;ka=c[ma>>2]|0;if((ka|0)>-1){la=ka;y=ma;Q=R}else{Ja=R;break}}}else{Ja=0}c[ba+(Ja<<5)+8>>2]=0;c[E>>2]=Ga;c[w+12>>2]=K+(c[N+(c[c[v+28>>2]>>2]<<2)>>2]<<5);c[w+52>>2]=c[H>>2];c[w+56>>2]=e;s_a(s);W_a(c[p+16>>2]|0);W_a(p);W_a(O);W_a(N);c[b+4>>2]=w;r=0;i=f;return r|0}else{z=0;A=t;B=0;C=0}}while(0);s_a(s);W_a(c[p+16>>2]|0);W_a(p);if((z|0)!=0){W_a(z)}if((B|0)!=0){W_a(B)}c[b+4>>2]=C;f_a(b);r=A;i=f;return r|0}



function AUa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+40|0;j=h;k=h+16|0;l=h+32|0;MRa(l,d);d=l;l=c[d>>2]|0;if(!((c[70112]|0)==-1)){c[k>>2]=280448;c[k+4>>2]=1276;c[k+8>>2]=0;BQa(280448,k,1277)}k=(c[280452>>2]|0)+ -1|0;m=c[l+8>>2]|0;if(!((c[l+12>>2]|0)-m>>2>>>0>k>>>0)){n=Hc(4)|0;o=n;A_a(o);p=296008;q=128;Zd(n|0,p|0,q|0)}l=c[m+(k<<2)>>2]|0;if((l|0)==0){n=Hc(4)|0;o=n;A_a(o);p=296008;q=128;Zd(n|0,p|0,q|0)}Ne[c[(c[l>>2]|0)+32>>2]&63](l,278992,279024|0,e)|0;e=c[d>>2]|0;if(!((c[70148]|0)==-1)){c[j>>2]=280592;c[j+4>>2]=1276;c[j+8>>2]=0;BQa(280592,j,1277)}j=(c[280596>>2]|0)+ -1|0;l=c[e+8>>2]|0;if(!((c[e+12>>2]|0)-l>>2>>>0>j>>>0)){r=Hc(4)|0;s=r;A_a(s);t=296008;u=128;Zd(r|0,t|0,u|0)}e=c[l+(j<<2)>>2]|0;if((e|0)==0){r=Hc(4)|0;s=r;A_a(s);t=296008;u=128;Zd(r|0,t|0,u|0)}else{u=e;a[f]=oe[c[(c[e>>2]|0)+12>>2]&127](u)|0;a[g]=oe[c[(c[e>>2]|0)+16>>2]&127](u)|0;me[c[(c[e>>2]|0)+20>>2]&127](b,u);gQa(c[d>>2]|0)|0;i=h;return}}function BUa(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;if(b<<24>>24==h<<24>>24){if((a[d]|0)==0){q=-1;i=p;return q|0}a[d]=0;h=c[g>>2]|0;c[g>>2]=h+1;a[h]=46;h=a[k]|0;if((h&1)==0){r=(h&255)>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){q=0;i=p;return q|0}r=c[m>>2]|0;if((r-l|0)>=160){q=0;i=p;return q|0}h=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=h;q=0;i=p;return q|0}do{if(b<<24>>24==j<<24>>24){h=a[k]|0;if((h&1)==0){s=(h&255)>>>1}else{s=c[k+4>>2]|0}if((s|0)==0){break}if((a[d]|0)==0){q=-1;i=p;return q|0}h=c[m>>2]|0;if((h-l|0)>=160){q=0;i=p;return q|0}r=c[n>>2]|0;c[m>>2]=h+4;c[h>>2]=r;c[n>>2]=0;q=0;i=p;return q|0}}while(0);s=o+32|0;j=o;while(1){r=j+1|0;if((a[j]|0)==b<<24>>24){t=j;break}if((r|0)==(s|0)){t=s;break}else{j=r}}j=t-o|0;if((j|0)>31){q=-1;i=p;return q|0}o=a[278992+j|0]|0;if((j|0)==23|(j|0)==22){a[e]=80;t=c[g>>2]|0;c[g>>2]=t+1;a[t]=o;q=0;i=p;return q|0}else if((j|0)==24|(j|0)==25){t=c[g>>2]|0;do{if((t|0)!=(f|0)){if((a[t+ -1|0]&95|0)==(a[e]&127|0)){break}else{q=-1}i=p;return q|0}}while(0);c[g>>2]=t+1;a[t]=o;q=0;i=p;return q|0}else{t=a[e]|0;do{if((o&95|0)==(t<<24>>24|0)){a[e]=t|-128;if((a[d]|0)==0){break}a[d]=0;f=a[k]|0;if((f&1)==0){u=(f&255)>>>1}else{u=c[k+4>>2]|0}if((u|0)==0){break}f=c[m>>2]|0;if((f-l|0)>=160){break}s=c[n>>2]|0;c[m>>2]=f+4;c[f>>2]=s}}while(0);m=c[g>>2]|0;c[g>>2]=m+1;a[m]=o;if((j|0)>21){q=0;i=p;return q|0}c[n>>2]=(c[n>>2]|0)+1;q=0;i=p;return q|0}return 0}function CUa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+40|0;g=f;h=f+16|0;j=f+32|0;MRa(j,b);b=j;j=c[b>>2]|0;if(!((c[70110]|0)==-1)){c[h>>2]=280440;c[h+4>>2]=1276;c[h+8>>2]=0;BQa(280440,h,1277)}h=(c[280444>>2]|0)+ -1|0;k=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-k>>2>>>0>h>>>0)){l=Hc(4)|0;m=l;A_a(m);n=296008;o=128;Zd(l|0,n|0,o|0)}j=c[k+(h<<2)>>2]|0;if((j|0)==0){l=Hc(4)|0;m=l;A_a(m);n=296008;o=128;Zd(l|0,n|0,o|0)}Ne[c[(c[j>>2]|0)+48>>2]&63](j,278992,279018|0,d)|0;d=c[b>>2]|0;if(!((c[70150]|0)==-1)){c[g>>2]=280600;c[g+4>>2]=1276;c[g+8>>2]=0;BQa(280600,g,1277)}g=(c[280604>>2]|0)+ -1|0;j=c[d+8>>2]|0;if(!((c[d+12>>2]|0)-j>>2>>>0>g>>>0)){p=Hc(4)|0;q=p;A_a(q);r=296008;s=128;Zd(p|0,r|0,s|0)}d=c[j+(g<<2)>>2]|0;if((d|0)==0){p=Hc(4)|0;q=p;A_a(q);r=296008;s=128;Zd(p|0,r|0,s|0)}else{s=d;c[e>>2]=oe[c[(c[d>>2]|0)+16>>2]&127](s)|0;me[c[(c[d>>2]|0)+20>>2]&127](a,s);gQa(c[b>>2]|0)|0;i=f;return}}function DUa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g;j=g+16|0;k=g+32|0;MRa(k,b);b=k;k=c[b>>2]|0;if(!((c[70110]|0)==-1)){c[j>>2]=280440;c[j+4>>2]=1276;c[j+8>>2]=0;BQa(280440,j,1277)}j=(c[280444>>2]|0)+ -1|0;l=c[k+8>>2]|0;if(!((c[k+12>>2]|0)-l>>2>>>0>j>>>0)){m=Hc(4)|0;n=m;A_a(n);o=296008;p=128;Zd(m|0,o|0,p|0)}k=c[l+(j<<2)>>2]|0;if((k|0)==0){m=Hc(4)|0;n=m;A_a(n);o=296008;p=128;Zd(m|0,o|0,p|0)}Ne[c[(c[k>>2]|0)+48>>2]&63](k,278992,279024|0,d)|0;d=c[b>>2]|0;if(!((c[70150]|0)==-1)){c[h>>2]=280600;c[h+4>>2]=1276;c[h+8>>2]=0;BQa(280600,h,1277)}h=(c[280604>>2]|0)+ -1|0;k=c[d+8>>2]|0;if(!((c[d+12>>2]|0)-k>>2>>>0>h>>>0)){q=Hc(4)|0;r=q;A_a(r);s=296008;t=128;Zd(q|0,s|0,t|0)}d=c[k+(h<<2)>>2]|0;if((d|0)==0){q=Hc(4)|0;r=q;A_a(r);s=296008;t=128;Zd(q|0,s|0,t|0)}else{t=d;c[e>>2]=oe[c[(c[d>>2]|0)+12>>2]&127](t)|0;c[f>>2]=oe[c[(c[d>>2]|0)+16>>2]&127](t)|0;me[c[(c[d>>2]|0)+20>>2]&127](a,t);gQa(c[b>>2]|0)|0;i=g;return}}function EUa(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;if((b|0)==(h|0)){if((a[d]|0)==0){q=-1;i=p;return q|0}a[d]=0;h=c[g>>2]|0;c[g>>2]=h+1;a[h]=46;h=a[k]|0;if((h&1)==0){r=(h&255)>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){q=0;i=p;return q|0}r=c[m>>2]|0;if((r-l|0)>=160){q=0;i=p;return q|0}h=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=h;q=0;i=p;return q|0}do{if((b|0)==(j|0)){h=a[k]|0;if((h&1)==0){s=(h&255)>>>1}else{s=c[k+4>>2]|0}if((s|0)==0){break}if((a[d]|0)==0){q=-1;i=p;return q|0}h=c[m>>2]|0;if((h-l|0)>=160){q=0;i=p;return q|0}r=c[n>>2]|0;c[m>>2]=h+4;c[h>>2]=r;c[n>>2]=0;q=0;i=p;return q|0}}while(0);s=o+128|0;j=o;while(1){r=j+4|0;if((c[j>>2]|0)==(b|0)){t=j;break}if((r|0)==(s|0)){t=s;break}else{j=r}}j=t-o|0;o=j>>2;if((j|0)>124){q=-1;i=p;return q|0}t=a[278992+o|0]|0;do{if((o|0)==23|(o|0)==22){a[e]=80}else if((o|0)==24|(o|0)==25){s=c[g>>2]|0;do{if((s|0)!=(f|0)){if((a[s+ -1|0]&95|0)==(a[e]&127|0)){break}else{q=-1}i=p;return q|0}}while(0);c[g>>2]=s+1;a[s]=t;q=0;i=p;return q|0}else{b=a[e]|0;if((t&95|0)!=(b<<24>>24|0)){break}a[e]=b|-128;if((a[d]|0)==0){break}a[d]=0;b=a[k]|0;if((b&1)==0){u=(b&255)>>>1}else{u=c[k+4>>2]|0}if((u|0)==0){break}b=c[m>>2]|0;if((b-l|0)>=160){break}r=c[n>>2]|0;c[m>>2]=b+4;c[b>>2]=r}}while(0);m=c[g>>2]|0;c[g>>2]=m+1;a[m]=t;if((j|0)>84){q=0;i=p;return q|0}c[n>>2]=(c[n>>2]|0)+1;q=0;i=p;return q|0}function FUa(a){a=a|0;var b=0;b=i;b$a(a);i=b;return}function GUa(a){a=a|0;i=i;return}function HUa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;j=i;i=i+56|0;k=j;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;if((c[f+4>>2]&1|0)==0){p=c[(c[d>>2]|0)+24>>2]|0;c[m>>2]=c[e>>2];q=h&1;r=k;s=m;c[r+0>>2]=c[s+0>>2];xe[p&31](b,d,k,f,g,q);i=j;return}MRa(n,f);f=n;n=c[f>>2]|0;if(!((c[70148]|0)==-1)){c[l>>2]=280592;c[l+4>>2]=1276;c[l+8>>2]=0;BQa(280592,l,1277)}l=(c[280596>>2]|0)+ -1|0;q=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-q>>2>>>0>l>>>0)){t=Hc(4)|0;u=t;A_a(u);v=296008;w=128;Zd(t|0,v|0,w|0)}n=c[q+(l<<2)>>2]|0;if((n|0)==0){t=Hc(4)|0;u=t;A_a(u);v=296008;w=128;Zd(t|0,v|0,w|0)}w=n;gQa(c[f>>2]|0)|0;f=c[n>>2]|0;if(h){me[c[f+24>>2]&127](o,w)}else{me[c[f+28>>2]&127](o,w)}w=a[o]|0;if((w&1)==0){f=o+1|0;x=f;y=f;z=o+8|0}else{f=o+8|0;x=c[f>>2]|0;y=o+1|0;z=f}f=e;e=o+4|0;h=w;w=x;while(1){if((h&1)==0){A=y;B=(h&255)>>>1}else{A=c[z>>2]|0;B=c[e>>2]|0}if((w|0)==(A+B|0)){break}x=a[w]|0;n=c[f>>2]|0;do{if((n|0)!=0){v=n+24|0;t=c[v>>2]|0;if((t|0)!=(c[n+28>>2]|0)){c[v>>2]=t+1;a[t]=x;break}if(!((De[c[(c[n>>2]|0)+52>>2]&63](n,x&255)|0)==-1)){break}c[f>>2]=0}}while(0);h=a[o]|0;w=w+1|0}c[b>>2]=c[f>>2];QQa(o);i=j;return}function IUa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=279240;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else if((x|0)==64){a[w]=111}else{a[w]=100}}while(0);w=m;do{if((a[280344]|0)==0){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);x=c[70084]|0;c[k>>2]=h;h=JUa(w,12,x,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else if((s|0)==32){y=k}else{z=20}}while(0);if((z|0)==20){y=w}z=n;MRa(q,f);KUa(w,y,k,z,o,p,q);gQa(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];mNa(b,j,z,e,o,f,g);i=d;return}function JUa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;c[h>>2]=f;f=Oc(d|0)|0;d=bd(a|0,b|0,e|0,h|0)|0;if((f|0)==0){i=g;return d|0}Oc(f|0)|0;i=g;return d|0}function KUa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[70112]|0)==-1)){c[m>>2]=280448;c[m+4>>2]=1276;c[m+8>>2]=0;BQa(280448,m,1277)}m=(c[280452>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Hc(4)|0;r=q;A_a(r);s=296008;t=128;Zd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Hc(4)|0;r=q;A_a(r);s=296008;t=128;Zd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[70148]|0)==-1)){c[l>>2]=280592;c[l+4>>2]=1276;c[l+8>>2]=0;BQa(280592,l,1277)}l=(c[280596>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Hc(4)|0;v=u;A_a(v);w=296008;x=128;Zd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Hc(4)|0;v=u;A_a(v);w=296008;x=128;Zd(u|0,w|0,x|0)}x=s;me[c[(c[s>>2]|0)+20>>2]&127](n,x);w=a[n]|0;if((w&1)==0){y=(w&255)>>>1}else{y=c[n+4>>2]|0}do{if((y|0)==0){Ne[c[(c[j>>2]|0)+32>>2]&63](t,b,e,f)|0;c[h>>2]=f+(e-b)}else{c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=De[c[(c[j>>2]|0)+28>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=u;z=b+1|0}else{z=b}do{if((e-z|0)>1){if((a[z]|0)!=48){A=z;break}u=z+1|0;w=a[u]|0;if(!(w<<24>>24==88|w<<24>>24==120)){A=z;break}w=De[c[(c[j>>2]|0)+28>>2]&63](t,48)|0;v=c[h>>2]|0;c[h>>2]=v+1;a[v]=w;w=De[c[(c[j>>2]|0)+28>>2]&63](t,a[u]|0)|0;u=c[h>>2]|0;c[h>>2]=u+1;a[u]=w;A=z+2|0}else{A=z}}while(0);do{if((A|0)!=(e|0)){w=e+ -1|0;if(w>>>0>A>>>0){B=A;C=w}else{break}do{w=a[B]|0;a[B]=a[C]|0;a[C]=w;B=B+1|0;C=C+ -1|0;}while(B>>>0<C>>>0)}}while(0);w=oe[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(A>>>0<e>>>0){u=n+1|0;v=n+4|0;l=n+8|0;o=0;q=0;r=A;while(1){m=(a[n]&1)==0;do{if((a[(m?u:c[l>>2]|0)+q|0]|0)==0){D=o;E=q}else{if((o|0)!=(a[(m?u:c[l>>2]|0)+q|0]|0)){D=o;E=q;break}p=c[h>>2]|0;c[h>>2]=p+1;a[p]=w;p=a[n]|0;if((p&1)==0){F=(p&255)>>>1}else{F=c[v>>2]|0}D=0;E=(q>>>0<(F+ -1|0)>>>0)+q|0}}while(0);m=De[c[(c[j>>2]|0)+28>>2]&63](t,a[r]|0)|0;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=m;m=r+1|0;if(m>>>0<e>>>0){o=D+1|0;q=E;r=m}else{break}}}r=f+(A-b)|0;q=c[h>>2]|0;if((r|0)==(q|0)){break}o=q+ -1|0;if(o>>>0>r>>>0){G=r;H=o}else{break}do{o=a[G]|0;a[G]=a[H]|0;a[H]=o;G=G+1|0;H=H+ -1|0;}while(G>>>0<H>>>0)}}while(0);if((d|0)==(e|0)){I=c[h>>2]|0;c[g>>2]=I;QQa(n);i=k;return}else{I=f+(d-b)|0;c[g>>2]=I;QQa(n);i=k;return}}function LUa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==64){a[x]=111}else if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else{a[x]=100}}while(0);x=n;do{if((a[280344]|0)==0){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);w=c[70084]|0;y=l;c[y>>2]=h;c[y+4>>2]=j;j=JUa(x,22,w,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==32){z=l}else if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else{A=20}}while(0);if((A|0)==20){z=x}A=o;MRa(r,f);KUa(x,z,l,A,p,q,r);gQa(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];mNa(b,k,A,e,p,f,g);i=d;return}function MUa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=279240;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=117}}while(0);w=m;do{if((a[280344]|0)==0){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);v=c[70084]|0;c[k>>2]=h;h=JUa(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else if((s|0)==32){y=k}else{z=20}}while(0);if((z|0)==20){y=w}z=n;MRa(q,f);KUa(w,y,k,z,o,p,q);gQa(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];mNa(b,j,z,e,o,f,g);i=d;return}function NUa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==64){a[x]=111}else if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else{a[x]=117}}while(0);x=n;do{if((a[280344]|0)==0){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);w=c[70084]|0;y=l;c[y>>2]=h;c[y+4>>2]=j;j=JUa(x,23,w,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==32){z=l}else if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else{A=20}}while(0);if((A|0)==20){z=x}A=o;MRa(r,f);KUa(x,z,l,A,p,q,r);gQa(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];mNa(b,k,A,e,p,f,g);i=d;return}function OUa(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+24|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+64|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){if((q&1|0)==0){a[E]=97;F=0;break}else{a[E]=65;F=0;break}}else{a[E]=46;C=E+2|0;a[E+1|0]=42;if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[280344]|0)==0){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);r=c[70084]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=JUa(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=JUa(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[280344]|0)==0;if(F){do{if(o){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);r=c[70084]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=PUa(s,r,z,n)|0}else{do{if(o){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);o=c[70084]|0;c[m>>2]=c[f+8>>2];r=m+4|0;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=PUa(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}g$a()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=V_a(K<<1)|0;if((M|0)!=0){N=I;O=M;P=M;break}g$a()}}while(0);MRa(w,f);QUa(N,L,G,P,u,v,w);gQa(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];mNa(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){W_a(O)}if((J|0)==0){i=d;return}W_a(J);i=d;return}function PUa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Oc(b|0)|0;b=nc(a|0,d|0,g|0)|0;if((e|0)==0){i=f;return b|0}Oc(e|0)|0;i=f;return b|0}function QUa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[70112]|0)==-1)){c[m>>2]=280448;c[m+4>>2]=1276;c[m+8>>2]=0;BQa(280448,m,1277)}m=(c[280452>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Hc(4)|0;r=q;A_a(r);s=296008;t=128;Zd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Hc(4)|0;r=q;A_a(r);s=296008;t=128;Zd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[70148]|0)==-1)){c[l>>2]=280592;c[l+4>>2]=1276;c[l+8>>2]=0;BQa(280592,l,1277)}l=(c[280596>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Hc(4)|0;v=u;A_a(v);w=296008;x=128;Zd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Hc(4)|0;v=u;A_a(v);w=296008;x=128;Zd(u|0,w|0,x|0)}x=s;me[c[(c[s>>2]|0)+20>>2]&127](n,x);c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=De[c[(c[j>>2]|0)+28>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=u;y=b+1|0}else{y=b}u=e;a:do{if((u-y|0)>1){if((a[y]|0)!=48){z=14;break}w=y+1|0;v=a[w]|0;if(!(v<<24>>24==88|v<<24>>24==120)){z=14;break}v=De[c[(c[j>>2]|0)+28>>2]&63](t,48)|0;l=c[h>>2]|0;c[h>>2]=l+1;a[l]=v;v=y+2|0;l=De[c[(c[j>>2]|0)+28>>2]&63](t,a[w]|0)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=l;if(v>>>0<e>>>0){A=v}else{B=v;C=v;break}while(1){l=a[A]|0;do{if((a[280344]|0)==0){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);w=A+1|0;if(($c(l<<24>>24|0,c[70084]|0)|0)==0){B=v;C=A;break a}if(w>>>0<e>>>0){A=w}else{B=v;C=w;break}}}else{z=14}}while(0);b:do{if((z|0)==14){if(y>>>0<e>>>0){D=y}else{B=y;C=y;break}while(1){A=a[D]|0;do{if((a[280344]|0)==0){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);l=D+1|0;if(($d(A<<24>>24|0,c[70084]|0)|0)==0){B=y;C=D;break b}if(l>>>0<e>>>0){D=l}else{B=y;C=l;break}}}}while(0);y=a[n]|0;if((y&1)==0){E=(y&255)>>>1}else{E=c[n+4>>2]|0}do{if((E|0)==0){Ne[c[(c[j>>2]|0)+32>>2]&63](t,B,C,c[h>>2]|0)|0;c[h>>2]=(c[h>>2]|0)+(C-B)}else{do{if((B|0)!=(C|0)){y=C+ -1|0;if(y>>>0>B>>>0){F=B;G=y}else{break}do{y=a[F]|0;a[F]=a[G]|0;a[G]=y;F=F+1|0;G=G+ -1|0;}while(F>>>0<G>>>0)}}while(0);A=oe[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<C>>>0){y=n+1|0;D=n+4|0;z=n+8|0;l=0;v=0;w=B;while(1){o=(a[n]&1)==0;do{if((a[(o?y:c[z>>2]|0)+v|0]|0)>0){if((l|0)!=(a[(o?y:c[z>>2]|0)+v|0]|0)){H=l;I=v;break}q=c[h>>2]|0;c[h>>2]=q+1;a[q]=A;q=a[n]|0;if((q&1)==0){J=(q&255)>>>1}else{J=c[D>>2]|0}H=0;I=(v>>>0<(J+ -1|0)>>>0)+v|0}else{H=l;I=v}}while(0);o=De[c[(c[j>>2]|0)+28>>2]&63](t,a[w]|0)|0;q=c[h>>2]|0;c[h>>2]=q+1;a[q]=o;o=w+1|0;if(o>>>0<C>>>0){l=H+1|0;v=I;w=o}else{break}}}w=f+(B-b)|0;v=c[h>>2]|0;if((w|0)==(v|0)){break}l=v+ -1|0;if(l>>>0>w>>>0){K=w;L=l}else{break}do{l=a[K]|0;a[K]=a[L]|0;a[L]=l;K=K+1|0;L=L+ -1|0;}while(K>>>0<L>>>0)}}while(0);c:do{if(C>>>0<e>>>0){L=C;while(1){K=a[L]|0;if(K<<24>>24==46){break}B=De[c[(c[j>>2]|0)+28>>2]&63](t,K)|0;K=c[h>>2]|0;c[h>>2]=K+1;a[K]=B;B=L+1|0;if(B>>>0<e>>>0){L=B}else{M=B;break c}}B=oe[c[(c[s>>2]|0)+12>>2]&127](x)|0;K=c[h>>2]|0;c[h>>2]=K+1;a[K]=B;M=L+1|0}else{M=C}}while(0);Ne[c[(c[j>>2]|0)+32>>2]&63](t,M,e,c[h>>2]|0)|0;t=(c[h>>2]|0)+(u-M)|0;c[h>>2]=t;if((d|0)==(e|0)){N=t;c[g>>2]=N;QQa(n);i=k;return}N=f+(d-b)|0;c[g>>2]=N;QQa(n);i=k;return}function RUa(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+64|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){a[E]=76;C=E+1|0;if((q&1|0)==0){a[C]=97;F=0;break}else{a[C]=65;F=0;break}}else{a[E]=46;a[E+1|0]=42;a[E+2|0]=76;C=E+3|0;if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[280344]|0)==0){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);r=c[70084]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=JUa(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=JUa(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[280344]|0)==0;if(F){do{if(o){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);r=c[70084]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=PUa(s,r,z,n)|0}else{do{if(o){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);o=c[70084]|0;r=m;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=PUa(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}g$a()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==32){L=G}else if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=V_a(K<<1)|0;if((M|0)!=0){N=I;O=M;P=M;break}g$a()}}while(0);MRa(w,f);QUa(N,L,G,P,u,v,w);gQa(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];mNa(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){W_a(O)}if((J|0)==0){i=d;return}W_a(J);i=d;return}function SUa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+40|0;p=i;i=i+8|0;q=i;i=i+8|0;r=m;m=279248;a[r+0|0]=a[m+0|0]|0;a[r+1|0]=a[m+1|0]|0;a[r+2|0]=a[m+2|0]|0;a[r+3|0]=a[m+3|0]|0;a[r+4|0]=a[m+4|0]|0;a[r+5|0]=a[m+5|0]|0;m=n;do{if((a[280344]|0)==0){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);s=c[70084]|0;c[k>>2]=h;h=JUa(m,20,s,r,k)|0;k=n+h|0;r=c[f+4>>2]&176;do{if((r|0)==32){t=k}else if((r|0)==16){s=a[m]|0;if(s<<24>>24==43|s<<24>>24==45){t=n+1|0;break}if(!((h|0)>1&s<<24>>24==48)){u=10;break}s=a[n+1|0]|0;if(!(s<<24>>24==88|s<<24>>24==120)){u=10;break}t=n+2|0}else{u=10}}while(0);if((u|0)==10){t=m}u=o;MRa(p,f);r=p;p=c[r>>2]|0;if(!((c[70112]|0)==-1)){c[l>>2]=280448;c[l+4>>2]=1276;c[l+8>>2]=0;BQa(280448,l,1277)}l=(c[280452>>2]|0)+ -1|0;s=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-s>>2>>>0>l>>>0)){v=Hc(4)|0;w=v;A_a(w);x=296008;y=128;Zd(v|0,x|0,y|0)}p=c[s+(l<<2)>>2]|0;if((p|0)==0){v=Hc(4)|0;w=v;A_a(w);x=296008;y=128;Zd(v|0,x|0,y|0)}gQa(c[r>>2]|0)|0;Ne[c[(c[p>>2]|0)+32>>2]&63](p,m,k,u)|0;m=o+h|0;if((t|0)==(k|0)){z=m;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];mNa(b,j,u,z,m,f,g);I=j;i=d;return}z=o+(t-n)|0;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];mNa(b,j,u,z,m,f,g);I=j;i=d;return}function TUa(a){a=a|0;var b=0;b=i;b$a(a);i=b;return}function UUa(a){a=a|0;i=i;return}function VUa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;j=i;i=i+56|0;k=j;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;if((c[f+4>>2]&1|0)==0){p=c[(c[d>>2]|0)+24>>2]|0;c[m>>2]=c[e>>2];q=h&1;r=k;s=m;c[r+0>>2]=c[s+0>>2];xe[p&31](b,d,k,f,g,q);i=j;return}MRa(n,f);f=n;n=c[f>>2]|0;if(!((c[70150]|0)==-1)){c[l>>2]=280600;c[l+4>>2]=1276;c[l+8>>2]=0;BQa(280600,l,1277)}l=(c[280604>>2]|0)+ -1|0;q=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-q>>2>>>0>l>>>0)){t=Hc(4)|0;u=t;A_a(u);v=296008;w=128;Zd(t|0,v|0,w|0)}n=c[q+(l<<2)>>2]|0;if((n|0)==0){t=Hc(4)|0;u=t;A_a(u);v=296008;w=128;Zd(t|0,v|0,w|0)}w=n;gQa(c[f>>2]|0)|0;f=c[n>>2]|0;if(h){me[c[f+24>>2]&127](o,w)}else{me[c[f+28>>2]&127](o,w)}w=a[o]|0;if((w&1)==0){f=o+4|0;x=f;y=o+8|0;z=f}else{f=o+8|0;x=c[f>>2]|0;y=f;z=o+4|0}f=e;e=w;w=x;while(1){if((e&1)==0){A=z;B=(e&255)>>>1}else{A=c[y>>2]|0;B=c[z>>2]|0}if((w|0)==(A+(B<<2)|0)){break}x=c[w>>2]|0;h=c[f>>2]|0;do{if((h|0)!=0){n=h+24|0;v=c[n>>2]|0;if((v|0)==(c[h+28>>2]|0)){C=De[c[(c[h>>2]|0)+52>>2]&63](h,x)|0}else{c[n>>2]=v+4;c[v>>2]=x;C=x}if(!((C|0)==-1)){break}c[f>>2]=0}}while(0);e=a[o]|0;w=w+4|0}c[b>>2]=c[f>>2];sRa(o);i=j;return}function WUa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+88|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=279240;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else if((x|0)==64){a[w]=111}else{a[w]=100}}while(0);w=m;do{if((a[280344]|0)==0){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);x=c[70084]|0;c[k>>2]=h;h=JUa(w,12,x,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else if((s|0)==32){y=k}else{z=20}}while(0);if((z|0)==20){y=w}z=n;MRa(q,f);XUa(w,y,k,z,o,p,q);gQa(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];YUa(b,j,z,e,o,f,g);i=d;return}function XUa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[70110]|0)==-1)){c[m>>2]=280440;c[m+4>>2]=1276;c[m+8>>2]=0;BQa(280440,m,1277)}m=(c[280444>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Hc(4)|0;r=q;A_a(r);s=296008;t=128;Zd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Hc(4)|0;r=q;A_a(r);s=296008;t=128;Zd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[70150]|0)==-1)){c[l>>2]=280600;c[l+4>>2]=1276;c[l+8>>2]=0;BQa(280600,l,1277)}l=(c[280604>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Hc(4)|0;v=u;A_a(v);w=296008;x=128;Zd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Hc(4)|0;v=u;A_a(v);w=296008;x=128;Zd(u|0,w|0,x|0)}x=s;me[c[(c[s>>2]|0)+20>>2]&127](n,x);w=a[n]|0;if((w&1)==0){y=(w&255)>>>1}else{y=c[n+4>>2]|0}do{if((y|0)==0){Ne[c[(c[j>>2]|0)+48>>2]&63](t,b,e,f)|0;w=f+(e-b<<2)|0;c[h>>2]=w;z=w}else{c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=De[c[(c[j>>2]|0)+44>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=u;A=b+1|0}else{A=b}do{if((e-A|0)>1){if((a[A]|0)!=48){B=A;break}u=A+1|0;w=a[u]|0;if(!(w<<24>>24==88|w<<24>>24==120)){B=A;break}w=De[c[(c[j>>2]|0)+44>>2]&63](t,48)|0;v=c[h>>2]|0;c[h>>2]=v+4;c[v>>2]=w;w=De[c[(c[j>>2]|0)+44>>2]&63](t,a[u]|0)|0;u=c[h>>2]|0;c[h>>2]=u+4;c[u>>2]=w;B=A+2|0}else{B=A}}while(0);do{if((B|0)!=(e|0)){w=e+ -1|0;if(w>>>0>B>>>0){C=B;D=w}else{break}do{w=a[C]|0;a[C]=a[D]|0;a[D]=w;C=C+1|0;D=D+ -1|0;}while(C>>>0<D>>>0)}}while(0);w=oe[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<e>>>0){u=n+1|0;v=n+4|0;l=n+8|0;o=0;q=0;r=B;while(1){m=(a[n]&1)==0;do{if((a[(m?u:c[l>>2]|0)+q|0]|0)==0){E=o;F=q}else{if((o|0)!=(a[(m?u:c[l>>2]|0)+q|0]|0)){E=o;F=q;break}p=c[h>>2]|0;c[h>>2]=p+4;c[p>>2]=w;p=a[n]|0;if((p&1)==0){G=(p&255)>>>1}else{G=c[v>>2]|0}E=0;F=(q>>>0<(G+ -1|0)>>>0)+q|0}}while(0);m=De[c[(c[j>>2]|0)+44>>2]&63](t,a[r]|0)|0;p=c[h>>2]|0;H=p+4|0;c[h>>2]=H;c[p>>2]=m;m=r+1|0;if(m>>>0<e>>>0){o=E+1|0;q=F;r=m}else{I=H;break}}}else{I=c[h>>2]|0}r=f+(B-b<<2)|0;if((r|0)==(I|0)){z=I;break}q=I+ -4|0;if(q>>>0>r>>>0){J=r;K=q}else{z=I;break}while(1){q=c[J>>2]|0;c[J>>2]=c[K>>2];c[K>>2]=q;q=J+4|0;r=K+ -4|0;if(q>>>0<r>>>0){K=r;J=q}else{z=I;break}}}}while(0);if((d|0)==(e|0)){L=z;c[g>>2]=L;QQa(n);i=k;return}L=f+(d-b<<2)|0;c[g>>2]=L;QQa(n);i=k;return}function YUa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i;i=i+16|0;l=k;m=d;d=c[m>>2]|0;if((d|0)==0){c[b>>2]=0;i=k;return}n=g;g=e;o=n-g>>2;p=h+12|0;h=c[p>>2]|0;q=(h|0)>(o|0)?h-o|0:0;o=f;h=o-g|0;g=h>>2;do{if((h|0)>0){if((re[c[(c[d>>2]|0)+48>>2]&63](d,e,g)|0)==(g|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);do{if((q|0)>0){rRa(l,q,j);if((a[l]&1)==0){r=l+4|0}else{r=c[l+8>>2]|0}if((re[c[(c[d>>2]|0)+48>>2]&63](d,r,q)|0)==(q|0)){sRa(l);break}c[m>>2]=0;c[b>>2]=0;sRa(l);i=k;return}}while(0);l=n-o|0;o=l>>2;do{if((l|0)>0){if((re[c[(c[d>>2]|0)+48>>2]&63](d,f,o)|0)==(o|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);c[p>>2]=0;c[b>>2]=d;i=k;return}function ZUa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+168|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==64){a[x]=111}else if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else{a[x]=100}}while(0);x=n;do{if((a[280344]|0)==0){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);w=c[70084]|0;y=l;c[y>>2]=h;c[y+4>>2]=j;j=JUa(x,22,w,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==32){z=l}else if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else{A=20}}while(0);if((A|0)==20){z=x}A=o;MRa(r,f);XUa(x,z,l,A,p,q,r);gQa(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];YUa(b,k,A,e,p,f,g);i=d;return}function _Ua(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+88|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=279240;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=117}}while(0);w=m;do{if((a[280344]|0)==0){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);v=c[70084]|0;c[k>>2]=h;h=JUa(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;MRa(q,f);XUa(w,y,k,z,o,p,q);gQa(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];YUa(b,j,z,e,o,f,g);i=d;return}function $Ua(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+176|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=117}}while(0);x=n;do{if((a[280344]|0)==0){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);y=c[70084]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=JUa(x,23,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;MRa(r,f);XUa(x,z,l,A,p,q,r);gQa(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];YUa(b,k,A,e,p,f,g);i=d;return}function aVa(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+24|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+232|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){if((q&1|0)==0){a[E]=97;F=0;break}else{a[E]=65;F=0;break}}else{a[E]=46;C=E+2|0;a[E+1|0]=42;if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[280344]|0)==0){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);r=c[70084]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=JUa(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=JUa(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[280344]|0)==0;if(F){do{if(o){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);r=c[70084]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=PUa(s,r,z,n)|0}else{do{if(o){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);o=c[70084]|0;c[m>>2]=c[f+8>>2];r=m+4|0;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=PUa(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}g$a()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==32){L=G}else if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=V_a(K<<3)|0;s=M;if((M|0)!=0){N=I;O=s;P=s;break}g$a()}}while(0);MRa(w,f);bVa(N,L,G,P,u,v,w);gQa(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];YUa(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){W_a(O)}if((J|0)==0){i=d;return}W_a(J);i=d;return}function bVa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[70110]|0)==-1)){c[m>>2]=280440;c[m+4>>2]=1276;c[m+8>>2]=0;BQa(280440,m,1277)}m=(c[280444>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Hc(4)|0;r=q;A_a(r);s=296008;t=128;Zd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Hc(4)|0;r=q;A_a(r);s=296008;t=128;Zd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[70150]|0)==-1)){c[l>>2]=280600;c[l+4>>2]=1276;c[l+8>>2]=0;BQa(280600,l,1277)}l=(c[280604>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Hc(4)|0;v=u;A_a(v);w=296008;x=128;Zd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Hc(4)|0;v=u;A_a(v);w=296008;x=128;Zd(u|0,w|0,x|0)}x=s;me[c[(c[s>>2]|0)+20>>2]&127](n,x);c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=De[c[(c[j>>2]|0)+44>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=u;y=b+1|0}else{y=b}u=e;a:do{if((u-y|0)>1){if((a[y]|0)!=48){z=14;break}w=y+1|0;v=a[w]|0;if(!(v<<24>>24==88|v<<24>>24==120)){z=14;break}v=De[c[(c[j>>2]|0)+44>>2]&63](t,48)|0;l=c[h>>2]|0;c[h>>2]=l+4;c[l>>2]=v;v=y+2|0;l=De[c[(c[j>>2]|0)+44>>2]&63](t,a[w]|0)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=l;if(v>>>0<e>>>0){A=v}else{B=v;C=v;break}while(1){l=a[A]|0;do{if((a[280344]|0)==0){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);w=A+1|0;if(($c(l<<24>>24|0,c[70084]|0)|0)==0){B=v;C=A;break a}if(w>>>0<e>>>0){A=w}else{B=v;C=w;break}}}else{z=14}}while(0);b:do{if((z|0)==14){if(y>>>0<e>>>0){D=y}else{B=y;C=y;break}while(1){A=a[D]|0;do{if((a[280344]|0)==0){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);l=D+1|0;if(($d(A<<24>>24|0,c[70084]|0)|0)==0){B=y;C=D;break b}if(l>>>0<e>>>0){D=l}else{B=y;C=l;break}}}}while(0);y=a[n]|0;if((y&1)==0){E=(y&255)>>>1}else{E=c[n+4>>2]|0}do{if((E|0)==0){Ne[c[(c[j>>2]|0)+48>>2]&63](t,B,C,c[h>>2]|0)|0;y=(c[h>>2]|0)+(C-B<<2)|0;c[h>>2]=y;F=y}else{do{if((B|0)!=(C|0)){y=C+ -1|0;if(y>>>0>B>>>0){G=B;H=y}else{break}do{y=a[G]|0;a[G]=a[H]|0;a[H]=y;G=G+1|0;H=H+ -1|0;}while(G>>>0<H>>>0)}}while(0);A=oe[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<C>>>0){y=n+1|0;D=n+4|0;z=n+8|0;l=0;v=0;w=B;while(1){o=(a[n]&1)==0;do{if((a[(o?y:c[z>>2]|0)+v|0]|0)>0){if((l|0)!=(a[(o?y:c[z>>2]|0)+v|0]|0)){I=l;J=v;break}q=c[h>>2]|0;c[h>>2]=q+4;c[q>>2]=A;q=a[n]|0;if((q&1)==0){K=(q&255)>>>1}else{K=c[D>>2]|0}I=0;J=(v>>>0<(K+ -1|0)>>>0)+v|0}else{I=l;J=v}}while(0);o=De[c[(c[j>>2]|0)+44>>2]&63](t,a[w]|0)|0;q=c[h>>2]|0;r=q+4|0;c[h>>2]=r;c[q>>2]=o;o=w+1|0;if(o>>>0<C>>>0){l=I+1|0;v=J;w=o}else{L=r;break}}}else{L=c[h>>2]|0}w=f+(B-b<<2)|0;if((w|0)==(L|0)){F=L;break}v=L+ -4|0;if(v>>>0>w>>>0){M=w;N=v}else{F=L;break}while(1){v=c[M>>2]|0;c[M>>2]=c[N>>2];c[N>>2]=v;v=M+4|0;w=N+ -4|0;if(v>>>0<w>>>0){N=w;M=v}else{F=L;break}}}}while(0);c:do{if(C>>>0<e>>>0){L=C;while(1){M=a[L]|0;if(M<<24>>24==46){break}N=De[c[(c[j>>2]|0)+44>>2]&63](t,M)|0;M=c[h>>2]|0;B=M+4|0;c[h>>2]=B;c[M>>2]=N;N=L+1|0;if(N>>>0<e>>>0){L=N}else{O=B;P=N;break c}}N=oe[c[(c[s>>2]|0)+12>>2]&127](x)|0;B=c[h>>2]|0;M=B+4|0;c[h>>2]=M;c[B>>2]=N;O=M;P=L+1|0}else{O=F;P=C}}while(0);Ne[c[(c[j>>2]|0)+48>>2]&63](t,P,e,O)|0;O=(c[h>>2]|0)+(u-P<<2)|0;c[h>>2]=O;if((d|0)==(e|0)){Q=O;c[g>>2]=Q;QQa(n);i=k;return}Q=f+(d-b<<2)|0;c[g>>2]=Q;QQa(n);i=k;return}function cVa(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+232|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){a[E]=76;C=E+1|0;if((q&1|0)==0){a[C]=97;F=0;break}else{a[C]=65;F=0;break}}else{a[E]=46;a[E+1|0]=42;a[E+2|0]=76;C=E+3|0;if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[280344]|0)==0){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);r=c[70084]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=JUa(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=JUa(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[280344]|0)==0;if(F){do{if(o){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);r=c[70084]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=PUa(s,r,z,n)|0}else{do{if(o){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);o=c[70084]|0;r=m;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=PUa(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}g$a()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==32){L=G}else if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=V_a(K<<3)|0;s=M;if((M|0)!=0){N=I;O=s;P=s;break}g$a()}}while(0);MRa(w,f);bVa(N,L,G,P,u,v,w);gQa(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];YUa(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){W_a(O)}if((J|0)==0){i=d;return}W_a(J);i=d;return}function dVa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+152|0;p=i;i=i+8|0;q=i;i=i+8|0;r=m;m=279248;a[r+0|0]=a[m+0|0]|0;a[r+1|0]=a[m+1|0]|0;a[r+2|0]=a[m+2|0]|0;a[r+3|0]=a[m+3|0]|0;a[r+4|0]=a[m+4|0]|0;a[r+5|0]=a[m+5|0]|0;m=n;do{if((a[280344]|0)==0){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);s=c[70084]|0;c[k>>2]=h;h=JUa(m,20,s,r,k)|0;k=n+h|0;r=c[f+4>>2]&176;do{if((r|0)==32){t=k}else if((r|0)==16){s=a[m]|0;if(s<<24>>24==43|s<<24>>24==45){t=n+1|0;break}if(!((h|0)>1&s<<24>>24==48)){u=10;break}s=a[n+1|0]|0;if(!(s<<24>>24==88|s<<24>>24==120)){u=10;break}t=n+2|0}else{u=10}}while(0);if((u|0)==10){t=m}MRa(p,f);u=p;p=c[u>>2]|0;if(!((c[70110]|0)==-1)){c[l>>2]=280440;c[l+4>>2]=1276;c[l+8>>2]=0;BQa(280440,l,1277)}l=(c[280444>>2]|0)+ -1|0;r=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-r>>2>>>0>l>>>0)){v=Hc(4)|0;w=v;A_a(w);x=296008;y=128;Zd(v|0,x|0,y|0)}p=c[r+(l<<2)>>2]|0;if((p|0)==0){v=Hc(4)|0;w=v;A_a(w);x=296008;y=128;Zd(v|0,x|0,y|0)}gQa(c[u>>2]|0)|0;u=o;Ne[c[(c[p>>2]|0)+48>>2]&63](p,m,k,u)|0;m=o+(h<<2)|0;if((t|0)==(k|0)){z=m;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];YUa(b,j,u,z,m,f,g);I=j;i=d;return}z=o+(t-n<<2)|0;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];YUa(b,j,u,z,m,f,g);I=j;i=d;return}function eVa(d,e,f,g,h,j,k,l,m){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;n=i;i=i+64|0;o=n;p=n+8|0;q=n+16|0;r=n+32|0;s=n+40|0;t=n+48|0;u=n+56|0;MRa(r,h);v=r;r=c[v>>2]|0;if(!((c[70112]|0)==-1)){c[q>>2]=280448;c[q+4>>2]=1276;c[q+8>>2]=0;BQa(280448,q,1277)}q=(c[280452>>2]|0)+ -1|0;w=c[r+8>>2]|0;if(!((c[r+12>>2]|0)-w>>2>>>0>q>>>0)){x=Hc(4)|0;y=x;A_a(y);z=296008;A=128;Zd(x|0,z|0,A|0)}r=c[w+(q<<2)>>2]|0;if((r|0)==0){x=Hc(4)|0;y=x;A_a(y);z=296008;A=128;Zd(x|0,z|0,A|0)}A=r;gQa(c[v>>2]|0)|0;c[j>>2]=0;v=f;a:do{if((l|0)==(m|0)){B=65}else{z=g;x=r+8|0;y=t;q=u;w=s;C=l;D=0;b:while(1){E=D;while(1){if((E|0)!=0){B=65;break a}F=c[v>>2]|0;do{if((F|0)==0){G=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){G=F;break}if(!((oe[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1)){G=F;break}c[v>>2]=0;G=0}}while(0);F=(G|0)==0;H=c[z>>2]|0;c:do{if((H|0)==0){B=19}else{do{if((c[H+12>>2]|0)==(c[H+16>>2]|0)){if(!((oe[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1)){break}c[z>>2]=0;B=19;break c}}while(0);if(F){I=H}else{B=20;break b}}}while(0);if((B|0)==19){B=0;if(F){B=20;break b}else{I=0}}if((re[c[(c[r>>2]|0)+36>>2]&63](A,a[C]|0,0)|0)<<24>>24==37){B=22;break}H=a[C]|0;if(H<<24>>24>-1){J=c[x>>2]|0;if(!((b[J+(H<<24>>24<<1)>>1]&8192)==0)){K=C;B=33;break}}L=G+12|0;H=c[L>>2]|0;M=G+16|0;if((H|0)==(c[M>>2]|0)){N=(oe[c[(c[G>>2]|0)+36>>2]&127](G)|0)&255}else{N=a[H]|0}H=De[c[(c[r>>2]|0)+12>>2]&63](A,N)|0;if(H<<24>>24==(De[c[(c[r>>2]|0)+12>>2]&63](A,a[C]|0)|0)<<24>>24){B=60;break}c[j>>2]=4;E=4}d:do{if((B|0)==22){B=0;E=C+1|0;if((E|0)==(m|0)){B=23;break b}H=re[c[(c[r>>2]|0)+36>>2]&63](A,a[E]|0,0)|0;if(H<<24>>24==48|H<<24>>24==69){O=C+2|0;if((O|0)==(m|0)){B=26;break b}P=O;Q=re[c[(c[r>>2]|0)+36>>2]&63](A,a[O]|0,0)|0;R=H}else{P=E;Q=H;R=0}H=c[(c[e>>2]|0)+36>>2]|0;c[y>>2]=G;c[q>>2]=I;E=p;O=t;c[E+0>>2]=c[O+0>>2];O=o;E=u;c[O+0>>2]=c[E+0>>2];Ce[H&3](s,e,p,o,h,j,k,Q,R);c[v>>2]=c[w>>2];S=P+1|0}else if((B|0)==33){while(1){B=0;H=K+1|0;if((H|0)==(m|0)){T=m;break}E=a[H]|0;if(!(E<<24>>24>-1)){T=H;break}if((b[J+(E<<24>>24<<1)>>1]&8192)==0){T=H;break}else{K=H;B=33}}F=G;H=I;E=I;while(1){do{if((F|0)==0){U=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){U=F;break}if(!((oe[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1)){U=F;break}c[v>>2]=0;U=0}}while(0);O=(U|0)==0;do{if((E|0)==0){V=H;B=46}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(O){W=H;X=E;break}else{S=T;break d}}if((oe[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[z>>2]=0;V=0;B=46;break}else{if(O^(H|0)==0){W=H;X=H;break}else{S=T;break d}}}}while(0);if((B|0)==46){B=0;if(O){S=T;break d}else{W=V;X=0}}Y=U+12|0;Z=c[Y>>2]|0;_=U+16|0;if((Z|0)==(c[_>>2]|0)){$=(oe[c[(c[U>>2]|0)+36>>2]&127](U)|0)&255}else{$=a[Z]|0}if(!($<<24>>24>-1)){S=T;break d}if((b[(c[x>>2]|0)+($<<24>>24<<1)>>1]&8192)==0){S=T;break d}Z=c[Y>>2]|0;if((Z|0)==(c[_>>2]|0)){oe[c[(c[U>>2]|0)+40>>2]&127](U)|0;F=U;H=W;E=X;continue}else{c[Y>>2]=Z+1;F=U;H=W;E=X;continue}}}else if((B|0)==60){B=0;E=c[L>>2]|0;if((E|0)==(c[M>>2]|0)){oe[c[(c[G>>2]|0)+40>>2]&127](G)|0}else{c[L>>2]=E+1}S=C+1|0}}while(0);if((S|0)==(m|0)){B=65;break a}C=S;D=c[j>>2]|0}if((B|0)==20){c[j>>2]=4;aa=G;break}else if((B|0)==23){c[j>>2]=4;aa=G;break}else if((B|0)==26){c[j>>2]=4;aa=G;break}}}while(0);if((B|0)==65){aa=c[v>>2]|0}v=f;do{if((aa|0)==0){ba=0}else{if((c[aa+12>>2]|0)!=(c[aa+16>>2]|0)){ba=aa;break}if(!((oe[c[(c[aa>>2]|0)+36>>2]&127](aa)|0)==-1)){ba=aa;break}c[v>>2]=0;ba=0}}while(0);v=(ba|0)==0;aa=g;g=c[aa>>2]|0;e:do{if((g|0)==0){B=75}else{do{if((c[g+12>>2]|0)==(c[g+16>>2]|0)){if(!((oe[c[(c[g>>2]|0)+36>>2]&127](g)|0)==-1)){break}c[aa>>2]=0;B=75;break e}}while(0);if(!v){break}ca=d;da=ca;c[da>>2]=ba;i=n;return}}while(0);do{if((B|0)==75){if(v){break}ca=d;da=ca;c[da>>2]=ba;i=n;return}}while(0);c[j>>2]=c[j>>2]|2;ca=d;da=ca;c[da>>2]=ba;i=n;return}function fVa(a){a=a|0;var b=0;b=i;b$a(a);i=b;return}function gVa(a){a=a|0;i=i;return}function hVa(a){a=a|0;i=i;return 2}function iVa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];e=l;d=m;c[e+0>>2]=c[d+0>>2];d=k;e=n;c[d+0>>2]=c[e+0>>2];eVa(a,b,l,k,f,g,h,279352,279360|0);i=j;return}function jVa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=d+8|0;q=oe[c[(c[p>>2]|0)+20>>2]&127](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q]|0;if((f&1)==0){r=q+1|0;s=q+1|0;t=(f&255)>>>1}else{f=c[q+8>>2]|0;r=f;s=f;t=c[q+4>>2]|0}q=r+t|0;t=m;r=n;c[t+0>>2]=c[r+0>>2];r=l;t=o;c[r+0>>2]=c[t+0>>2];eVa(b,d,m,l,g,h,j,s,q);i=k;return}function kVa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;MRa(n,f);f=n;n=c[f>>2]|0;if(!((c[70112]|0)==-1)){c[m>>2]=280448;c[m+4>>2]=1276;c[m+8>>2]=0;BQa(280448,m,1277)}m=(c[280452>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Hc(4)|0;q=p;A_a(q);r=296008;s=128;Zd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Hc(4)|0;q=p;A_a(q);r=296008;s=128;Zd(p|0,r|0,s|0)}s=n;gQa(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=oe[c[c[e>>2]>>2]&127](e)|0;c[l>>2]=f;f=b+168|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=HTa(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=168){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+24>>2]=((g|0)/12|0|0)%7|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function lVa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;MRa(n,f);f=n;n=c[f>>2]|0;if(!((c[70112]|0)==-1)){c[m>>2]=280448;c[m+4>>2]=1276;c[m+8>>2]=0;BQa(280448,m,1277)}m=(c[280452>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Hc(4)|0;q=p;A_a(q);r=296008;s=128;Zd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Hc(4)|0;q=p;A_a(q);r=296008;s=128;Zd(p|0,r|0,s|0)}s=n;gQa(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=oe[c[(c[e>>2]|0)+4>>2]&127](e)|0;c[l>>2]=f;f=b+288|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=HTa(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=288){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+16>>2]=((g|0)/12|0|0)%12|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function mVa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+40|0;j=b;k=b+8|0;l=b+16|0;m=b+32|0;MRa(m,f);f=m;m=c[f>>2]|0;if(!((c[70112]|0)==-1)){c[l>>2]=280448;c[l+4>>2]=1276;c[l+8>>2]=0;BQa(280448,l,1277)}l=(c[280452>>2]|0)+ -1|0;n=c[m+8>>2]|0;if(!((c[m+12>>2]|0)-n>>2>>>0>l>>>0)){o=Hc(4)|0;p=o;A_a(p);q=296008;r=128;Zd(o|0,q|0,r|0)}m=c[n+(l<<2)>>2]|0;if((m|0)==0){o=Hc(4)|0;p=o;A_a(p);q=296008;r=128;Zd(o|0,q|0,r|0)}r=m;gQa(c[f>>2]|0)|0;f=h+20|0;c[k>>2]=c[e>>2];e=j;h=k;c[e+0>>2]=c[h+0>>2];h=rVa(d,j,g,r,4)|0;if((c[g>>2]&4|0)!=0){s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}if((h|0)<69){x=h+2e3|0}else{x=(h+ -69|0)>>>0<31?h+1900|0:h}c[f>>2]=x+ -1900;s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}function nVa(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;l=i;i=i+576|0;m=l;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+104|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;M=l+208|0;N=l+216|0;O=l+224|0;P=l+232|0;Q=l+240|0;R=l+248|0;S=l+256|0;T=l+264|0;U=l+272|0;V=l+280|0;W=l+288|0;X=l+296|0;Y=l+304|0;Z=l+312|0;_=l+320|0;$=l+328|0;aa=l+336|0;ba=l+344|0;ca=l+360|0;da=l+368|0;ea=l+376|0;fa=l+384|0;ga=l+392|0;ha=l+400|0;ia=l+408|0;ja=l+416|0;ka=l+424|0;la=l+432|0;ma=l+440|0;na=l+448|0;oa=l+456|0;pa=l+464|0;qa=l+472|0;ra=l+480|0;sa=l+488|0;ta=l+496|0;ua=l+504|0;va=l+512|0;wa=l+520|0;xa=l+528|0;ya=l+536|0;za=l+544|0;Aa=l+552|0;Ba=l+560|0;Ca=l+568|0;c[h>>2]=0;MRa(ca,g);Da=ca;ca=c[Da>>2]|0;if(!((c[70112]|0)==-1)){c[ba>>2]=280448;c[ba+4>>2]=1276;c[ba+8>>2]=0;BQa(280448,ba,1277)}ba=(c[280452>>2]|0)+ -1|0;Ea=c[ca+8>>2]|0;if(!((c[ca+12>>2]|0)-Ea>>2>>>0>ba>>>0)){Fa=Hc(4)|0;Ga=Fa;A_a(Ga);Ha=296008;Ia=128;Zd(Fa|0,Ha|0,Ia|0)}ca=c[Ea+(ba<<2)>>2]|0;if((ca|0)==0){Fa=Hc(4)|0;Ga=Fa;A_a(Ga);Ha=296008;Ia=128;Zd(Fa|0,Ha|0,Ia|0)}Ia=ca;gQa(c[Da>>2]|0)|0;a:do{switch(k<<24>>24|0){case 83:{c[U>>2]=c[f>>2];c[w+0>>2]=c[U+0>>2];Da=rVa(e,w,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<61){c[j>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 72:{c[Z>>2]=c[f>>2];c[H+0>>2]=c[Z+0>>2];ca=rVa(e,H,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<24){c[j+8>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 37:{c[Ca>>2]=c[f>>2];c[m+0>>2]=c[Ca+0>>2];qVa(0,e,m,h,Ia);break};case 112:{c[na>>2]=c[f>>2];c[B+0>>2]=c[na+0>>2];pVa(d,j+8|0,e,B,h,Ia);break};case 109:{c[W>>2]=c[f>>2];c[E+0>>2]=c[W+0>>2];Da=rVa(e,E,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<13){c[j+16>>2]=Da+ -1;break a}else{c[h>>2]=ca|4;break a}break};case 121:{c[S>>2]=c[f>>2];c[o+0>>2]=c[S+0>>2];ca=rVa(e,o,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}if((ca|0)<69){Ja=ca+2e3|0}else{Ja=(ca+ -69|0)>>>0<31?ca+1900|0:ca}c[j+20>>2]=Ja+ -1900;break};case 70:{ca=e;c[ka>>2]=c[ca>>2];c[la>>2]=c[f>>2];c[J+0>>2]=c[ka+0>>2];c[I+0>>2]=c[la+0>>2];eVa(ja,d,J,I,g,h,j,279368,279376|0);c[ca>>2]=c[ja>>2];break};case 89:{c[R>>2]=c[f>>2];c[n+0>>2]=c[R+0>>2];ca=rVa(e,n,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}c[j+20>>2]=ca+ -1900;break};case 116:case 110:{c[ma>>2]=c[f>>2];c[C+0>>2]=c[ma+0>>2];oVa(0,e,C,h,Ia);break};case 68:{ca=e;c[ha>>2]=c[ca>>2];c[ia>>2]=c[f>>2];c[L+0>>2]=c[ha+0>>2];c[K+0>>2]=c[ia+0>>2];eVa(ga,d,L,K,g,h,j,279360,279368|0);c[ca>>2]=c[ga>>2];break};case 88:{ca=d+8|0;Da=oe[c[(c[ca>>2]|0)+24>>2]&127](ca)|0;ca=e;c[Aa>>2]=c[ca>>2];c[Ba>>2]=c[f>>2];Ha=a[Da]|0;if((Ha&1)==0){Ka=Da+1|0;La=Da+1|0;Ma=(Ha&255)>>>1}else{Ha=c[Da+8>>2]|0;Ka=Ha;La=Ha;Ma=c[Da+4>>2]|0}c[q+0>>2]=c[Aa+0>>2];c[p+0>>2]=c[Ba+0>>2];eVa(za,d,q,p,g,h,j,La,Ka+Ma|0);c[ca>>2]=c[za>>2];break};case 77:{c[V>>2]=c[f>>2];c[D+0>>2]=c[V+0>>2];ca=rVa(e,D,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<60){c[j+4>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 82:{Da=e;c[sa>>2]=c[Da>>2];c[ta>>2]=c[f>>2];c[y+0>>2]=c[sa+0>>2];c[x+0>>2]=c[ta+0>>2];eVa(ra,d,y,x,g,h,j,279392,279397|0);c[Da>>2]=c[ra>>2];break};case 73:{Da=j+8|0;c[Y>>2]=c[f>>2];c[G+0>>2]=c[Y+0>>2];ca=rVa(e,G,h,Ia,2)|0;Ha=c[h>>2]|0;do{if((Ha&4|0)==0){if(!((ca+ -1|0)>>>0<12)){break}c[Da>>2]=ca;break a}}while(0);c[h>>2]=Ha|4;break};case 106:{c[X>>2]=c[f>>2];c[F+0>>2]=c[X+0>>2];ca=rVa(e,F,h,Ia,3)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<366){c[j+28>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 114:{Da=e;c[pa>>2]=c[Da>>2];c[qa>>2]=c[f>>2];c[A+0>>2]=c[pa+0>>2];c[z+0>>2]=c[qa+0>>2];eVa(oa,d,A,z,g,h,j,279376,279387|0);c[Da>>2]=c[oa>>2];break};case 119:{c[T>>2]=c[f>>2];c[t+0>>2]=c[T+0>>2];Da=rVa(e,t,h,Ia,1)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<7){c[j+24>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 99:{ca=d+8|0;Da=oe[c[(c[ca>>2]|0)+12>>2]&127](ca)|0;ca=e;c[ea>>2]=c[ca>>2];c[fa>>2]=c[f>>2];Fa=a[Da]|0;if((Fa&1)==0){Na=Da+1|0;Oa=Da+1|0;Pa=(Fa&255)>>>1}else{Fa=c[Da+8>>2]|0;Na=Fa;Oa=Fa;Pa=c[Da+4>>2]|0}c[O+0>>2]=c[ea+0>>2];c[N+0>>2]=c[fa+0>>2];eVa(da,d,O,N,g,h,j,Oa,Na+Pa|0);c[ca>>2]=c[da>>2];break};case 104:case 66:case 98:{ca=c[f>>2]|0;Da=d+8|0;Fa=oe[c[(c[Da>>2]|0)+4>>2]&127](Da)|0;c[$>>2]=ca;c[P+0>>2]=c[$+0>>2];ca=(HTa(e,P,Fa,Fa+288|0,Ia,h,0)|0)-Fa|0;if((ca|0)>=288){break a}c[j+16>>2]=((ca|0)/12|0|0)%12|0;break};case 101:case 100:{ca=j+12|0;c[_>>2]=c[f>>2];c[M+0>>2]=c[_+0>>2];Fa=rVa(e,M,h,Ia,2)|0;Da=c[h>>2]|0;do{if((Da&4|0)==0){if(!((Fa+ -1|0)>>>0<31)){break}c[ca>>2]=Fa;break a}}while(0);c[h>>2]=Da|4;break};case 84:{Fa=e;c[va>>2]=c[Fa>>2];c[wa>>2]=c[f>>2];c[v+0>>2]=c[va+0>>2];c[u+0>>2]=c[wa+0>>2];eVa(ua,d,v,u,g,h,j,279400,279408|0);c[Fa>>2]=c[ua>>2];break};case 120:{Fa=c[(c[d>>2]|0)+20>>2]|0;c[xa>>2]=c[e>>2];c[ya>>2]=c[f>>2];c[s+0>>2]=c[xa+0>>2];c[r+0>>2]=c[ya+0>>2];Ae[Fa&63](b,d,s,r,g,h,j);i=l;return};case 65:case 97:{Fa=c[f>>2]|0;ca=d+8|0;Ha=oe[c[c[ca>>2]>>2]&127](ca)|0;c[aa>>2]=Fa;c[Q+0>>2]=c[aa+0>>2];Fa=(HTa(e,Q,Ha,Ha+168|0,Ia,h,0)|0)-Ha|0;if((Fa|0)>=168){break a}c[j+24>>2]=((Fa|0)/12|0|0)%7|0;break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}function oVa(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;j=e;e=f;f=h+8|0;a:while(1){h=c[j>>2]|0;do{if((h|0)==0){k=0}else{if((c[h+12>>2]|0)!=(c[h+16>>2]|0)){k=h;break}if((oe[c[(c[h>>2]|0)+36>>2]&127](h)|0)==-1){c[j>>2]=0;k=0;break}else{k=c[j>>2]|0;break}}}while(0);h=(k|0)==0;l=c[e>>2]|0;do{if((l|0)==0){m=12}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){if(h){n=l;break}else{o=l;break a}}if((oe[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1){c[e>>2]=0;m=12;break}else{if(h){n=l;break}else{o=l;break a}}}}while(0);if((m|0)==12){m=0;if(h){o=0;break}else{n=0}}l=c[j>>2]|0;p=c[l+12>>2]|0;if((p|0)==(c[l+16>>2]|0)){q=(oe[c[(c[l>>2]|0)+36>>2]&127](l)|0)&255}else{q=a[p]|0}if(!(q<<24>>24>-1)){o=n;break}if((b[(c[f>>2]|0)+(q<<24>>24<<1)>>1]&8192)==0){o=n;break}p=c[j>>2]|0;l=p+12|0;r=c[l>>2]|0;if((r|0)==(c[p+16>>2]|0)){oe[c[(c[p>>2]|0)+40>>2]&127](p)|0;continue}else{c[l>>2]=r+1;continue}}n=c[j>>2]|0;do{if((n|0)==0){s=0}else{if((c[n+12>>2]|0)!=(c[n+16>>2]|0)){s=n;break}if((oe[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1){c[j>>2]=0;s=0;break}else{s=c[j>>2]|0;break}}}while(0);j=(s|0)==0;b:do{if((o|0)==0){m=32}else{do{if((c[o+12>>2]|0)==(c[o+16>>2]|0)){if(!((oe[c[(c[o>>2]|0)+36>>2]&127](o)|0)==-1)){break}c[e>>2]=0;m=32;break b}}while(0);if(!j){break}i=d;return}}while(0);do{if((m|0)==32){if(j){break}i=d;return}}while(0);c[g>>2]=c[g>>2]|2;i=d;return}function pVa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;l=j+8|0;m=b+8|0;b=oe[c[(c[m>>2]|0)+8>>2]&127](m)|0;m=a[b]|0;if((m&1)==0){n=(m&255)>>>1}else{n=c[b+4>>2]|0}m=a[b+12|0]|0;if((m&1)==0){o=(m&255)>>>1}else{o=c[b+16>>2]|0}if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];f=b+24|0;o=k;n=l;c[o+0>>2]=c[n+0>>2];n=HTa(e,k,b,f,h,g,0)|0;g=n-b|0;do{if((n|0)==(b|0)){if((c[d>>2]|0)!=12){break}c[d>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[d>>2]|0;if((g|0)>=12){i=j;return}c[d>>2]=g+12;i=j;return}function qVa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;b=i;h=d;d=c[h>>2]|0;do{if((d|0)==0){j=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){j=d;break}if((oe[c[(c[d>>2]|0)+36>>2]&127](d)|0)==-1){c[h>>2]=0;j=0;break}else{j=c[h>>2]|0;break}}}while(0);d=(j|0)==0;j=e;e=c[j>>2]|0;a:do{if((e|0)==0){k=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if(!((oe[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){break}c[j>>2]=0;k=11;break a}}while(0);if(d){l=e}else{k=12}}}while(0);if((k|0)==11){if(d){k=12}else{l=0}}if((k|0)==12){c[f>>2]=c[f>>2]|6;i=b;return}d=c[h>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){m=(oe[c[(c[d>>2]|0)+36>>2]&127](d)|0)&255}else{m=a[e]|0}if(!((re[c[(c[g>>2]|0)+36>>2]&63](g,m,0)|0)<<24>>24==37)){c[f>>2]=c[f>>2]|4;i=b;return}m=c[h>>2]|0;g=m+12|0;e=c[g>>2]|0;if((e|0)==(c[m+16>>2]|0)){oe[c[(c[m>>2]|0)+40>>2]&127](m)|0}else{c[g>>2]=e+1}e=c[h>>2]|0;do{if((e|0)==0){n=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){n=e;break}if((oe[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[h>>2]=0;n=0;break}else{n=c[h>>2]|0;break}}}while(0);h=(n|0)==0;b:do{if((l|0)==0){k=31}else{do{if((c[l+12>>2]|0)==(c[l+16>>2]|0)){if(!((oe[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){break}c[j>>2]=0;k=31;break b}}while(0);if(!h){break}i=b;return}}while(0);do{if((k|0)==31){if(h){break}i=b;return}}while(0);c[f>>2]=c[f>>2]|2;i=b;return}function rVa(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;j=i;k=d;d=c[k>>2]|0;do{if((d|0)==0){l=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){l=d;break}if((oe[c[(c[d>>2]|0)+36>>2]&127](d)|0)==-1){c[k>>2]=0;l=0;break}else{l=c[k>>2]|0;break}}}while(0);d=(l|0)==0;l=e;e=c[l>>2]|0;a:do{if((e|0)==0){m=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if(!((oe[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){break}c[l>>2]=0;m=11;break a}}while(0);if(d){n=e}else{m=12}}}while(0);if((m|0)==11){if(d){m=12}else{n=0}}if((m|0)==12){c[f>>2]=c[f>>2]|6;o=0;i=j;return o|0}d=c[k>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){p=(oe[c[(c[d>>2]|0)+36>>2]&127](d)|0)&255}else{p=a[e]|0}do{if(p<<24>>24>-1){e=g+8|0;if((b[(c[e>>2]|0)+(p<<24>>24<<1)>>1]&2048)==0){break}d=(re[c[(c[g>>2]|0)+36>>2]&63](g,p,0)|0)<<24>>24;q=c[k>>2]|0;r=q+12|0;s=c[r>>2]|0;if((s|0)==(c[q+16>>2]|0)){oe[c[(c[q>>2]|0)+40>>2]&127](q)|0;t=h;u=n;v=n;w=d}else{c[r>>2]=s+1;t=h;u=n;v=n;w=d}while(1){x=w+ -48|0;d=t+ -1|0;s=c[k>>2]|0;do{if((s|0)==0){y=0}else{if((c[s+12>>2]|0)!=(c[s+16>>2]|0)){y=s;break}if((oe[c[(c[s>>2]|0)+36>>2]&127](s)|0)==-1){c[k>>2]=0;y=0;break}else{y=c[k>>2]|0;break}}}while(0);s=(y|0)==0;do{if((v|0)==0){z=u;A=0}else{if((c[v+12>>2]|0)!=(c[v+16>>2]|0)){z=u;A=v;break}if(!((oe[c[(c[v>>2]|0)+36>>2]&127](v)|0)==-1)){z=u;A=u;break}c[l>>2]=0;z=0;A=0}}while(0);B=c[k>>2]|0;if(!((s^(A|0)==0)&(d|0)>0)){m=40;break}r=c[B+12>>2]|0;if((r|0)==(c[B+16>>2]|0)){C=(oe[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{C=a[r]|0}if(!(C<<24>>24>-1)){o=x;m=52;break}if((b[(c[e>>2]|0)+(C<<24>>24<<1)>>1]&2048)==0){o=x;m=52;break}r=((re[c[(c[g>>2]|0)+36>>2]&63](g,C,0)|0)<<24>>24)+(x*10|0)|0;q=c[k>>2]|0;D=q+12|0;E=c[D>>2]|0;if((E|0)==(c[q+16>>2]|0)){oe[c[(c[q>>2]|0)+40>>2]&127](q)|0;F=d;u=z;v=A;w=r;t=F;continue}else{c[D>>2]=E+1;F=d;u=z;v=A;w=r;t=F;continue}}if((m|0)==40){do{if((B|0)==0){G=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){G=B;break}if((oe[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[k>>2]=0;G=0;break}else{G=c[k>>2]|0;break}}}while(0);e=(G|0)==0;b:do{if((z|0)==0){m=50}else{do{if((c[z+12>>2]|0)==(c[z+16>>2]|0)){if(!((oe[c[(c[z>>2]|0)+36>>2]&127](z)|0)==-1)){break}c[l>>2]=0;m=50;break b}}while(0);if(e){o=x}else{break}i=j;return o|0}}while(0);do{if((m|0)==50){if(e){break}else{o=x}i=j;return o|0}}while(0);c[f>>2]=c[f>>2]|2;o=x;i=j;return o|0}else if((m|0)==52){i=j;return o|0}}}while(0);c[f>>2]=c[f>>2]|4;o=0;i=j;return o|0}function sVa(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;l=i;i=i+64|0;m=l;n=l+8|0;o=l+16|0;p=l+32|0;q=l+40|0;r=l+48|0;s=l+56|0;MRa(p,f);t=p;p=c[t>>2]|0;if(!((c[70110]|0)==-1)){c[o>>2]=280440;c[o+4>>2]=1276;c[o+8>>2]=0;BQa(280440,o,1277)}o=(c[280444>>2]|0)+ -1|0;u=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-u>>2>>>0>o>>>0)){v=Hc(4)|0;w=v;A_a(w);x=296008;y=128;Zd(v|0,x|0,y|0)}p=c[u+(o<<2)>>2]|0;if((p|0)==0){v=Hc(4)|0;w=v;A_a(w);x=296008;y=128;Zd(v|0,x|0,y|0)}y=p;gQa(c[t>>2]|0)|0;c[g>>2]=0;t=d;a:do{if((j|0)==(k|0)){z=69}else{x=e;v=r;w=s;o=q;u=j;A=0;b:while(1){B=A;while(1){if((B|0)!=0){z=69;break a}C=c[t>>2]|0;do{if((C|0)==0){D=0;E=1}else{F=c[C+12>>2]|0;if((F|0)==(c[C+16>>2]|0)){G=oe[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{G=c[F>>2]|0}if(!((G|0)==-1)){D=C;E=0;break}c[t>>2]=0;D=0;E=1}}while(0);C=c[x>>2]|0;do{if((C|0)==0){z=22}else{F=c[C+12>>2]|0;if((F|0)==(c[C+16>>2]|0)){H=oe[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{H=c[F>>2]|0}if((H|0)==-1){c[x>>2]=0;z=22;break}else{if(E){I=C;break}else{z=24;break b}}}}while(0);if((z|0)==22){z=0;if(E){z=24;break b}else{I=0}}if((re[c[(c[p>>2]|0)+52>>2]&63](y,c[u>>2]|0,0)|0)<<24>>24==37){z=26;break}if(re[c[(c[p>>2]|0)+12>>2]&63](y,8192,c[u>>2]|0)|0){J=u;z=36;break}K=D+12|0;C=c[K>>2]|0;L=D+16|0;if((C|0)==(c[L>>2]|0)){M=oe[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{M=c[C>>2]|0}C=De[c[(c[p>>2]|0)+28>>2]&63](y,M)|0;if((C|0)==(De[c[(c[p>>2]|0)+28>>2]&63](y,c[u>>2]|0)|0)){z=64;break}c[g>>2]=4;B=4}c:do{if((z|0)==26){z=0;B=u+4|0;if((B|0)==(k|0)){z=27;break b}C=re[c[(c[p>>2]|0)+52>>2]&63](y,c[B>>2]|0,0)|0;if(C<<24>>24==48|C<<24>>24==69){F=u+8|0;if((F|0)==(k|0)){z=30;break b}N=F;O=re[c[(c[p>>2]|0)+52>>2]&63](y,c[F>>2]|0,0)|0;P=C}else{N=B;O=C;P=0}C=c[(c[b>>2]|0)+36>>2]|0;c[v>>2]=D;c[w>>2]=I;B=n;F=r;c[B+0>>2]=c[F+0>>2];F=m;B=s;c[F+0>>2]=c[B+0>>2];Ce[C&3](q,b,n,m,f,g,h,O,P);c[t>>2]=c[o>>2];Q=N+4|0}else if((z|0)==36){while(1){z=0;C=J+4|0;if((C|0)==(k|0)){R=k;break}if(re[c[(c[p>>2]|0)+12>>2]&63](y,8192,c[C>>2]|0)|0){J=C;z=36}else{R=C;break}}C=D;B=I;F=I;while(1){do{if((C|0)==0){S=0;T=1}else{U=c[C+12>>2]|0;if((U|0)==(c[C+16>>2]|0)){V=oe[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{V=c[U>>2]|0}if(!((V|0)==-1)){S=C;T=0;break}c[t>>2]=0;S=0;T=1}}while(0);do{if((F|0)==0){W=B;z=51}else{U=c[F+12>>2]|0;if((U|0)==(c[F+16>>2]|0)){X=oe[c[(c[F>>2]|0)+36>>2]&127](F)|0}else{X=c[U>>2]|0}if((X|0)==-1){c[x>>2]=0;W=0;z=51;break}else{if(T^(B|0)==0){Y=B;Z=B;break}else{Q=R;break c}}}}while(0);if((z|0)==51){z=0;if(T){Q=R;break c}else{Y=W;Z=0}}U=S+12|0;_=c[U>>2]|0;$=S+16|0;if((_|0)==(c[$>>2]|0)){aa=oe[c[(c[S>>2]|0)+36>>2]&127](S)|0}else{aa=c[_>>2]|0}if(!(re[c[(c[p>>2]|0)+12>>2]&63](y,8192,aa)|0)){Q=R;break c}_=c[U>>2]|0;if((_|0)==(c[$>>2]|0)){oe[c[(c[S>>2]|0)+40>>2]&127](S)|0;C=S;B=Y;F=Z;continue}else{c[U>>2]=_+4;C=S;B=Y;F=Z;continue}}}else if((z|0)==64){z=0;F=c[K>>2]|0;if((F|0)==(c[L>>2]|0)){oe[c[(c[D>>2]|0)+40>>2]&127](D)|0}else{c[K>>2]=F+4}Q=u+4|0}}while(0);if((Q|0)==(k|0)){z=69;break a}u=Q;A=c[g>>2]|0}if((z|0)==24){c[g>>2]=4;ba=D;break}else if((z|0)==27){c[g>>2]=4;ba=D;break}else if((z|0)==30){c[g>>2]=4;ba=D;break}}}while(0);if((z|0)==69){ba=c[t>>2]|0}t=d;do{if((ba|0)==0){ca=0;da=1}else{d=c[ba+12>>2]|0;if((d|0)==(c[ba+16>>2]|0)){ea=oe[c[(c[ba>>2]|0)+36>>2]&127](ba)|0}else{ea=c[d>>2]|0}if(!((ea|0)==-1)){ca=ba;da=0;break}c[t>>2]=0;ca=0;da=1}}while(0);t=e;e=c[t>>2]|0;do{if((e|0)==0){z=82}else{ba=c[e+12>>2]|0;if((ba|0)==(c[e+16>>2]|0)){fa=oe[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{fa=c[ba>>2]|0}if((fa|0)==-1){c[t>>2]=0;z=82;break}if(!da){break}ga=a;ha=ga;c[ha>>2]=ca;i=l;return}}while(0);do{if((z|0)==82){if(da){break}ga=a;ha=ga;c[ha>>2]=ca;i=l;return}}while(0);c[g>>2]=c[g>>2]|2;ga=a;ha=ga;c[ha>>2]=ca;i=l;return}function tVa(a){a=a|0;var b=0;b=i;b$a(a);i=b;return}function uVa(a){a=a|0;i=i;return}function vVa(a){a=a|0;i=i;return 2}function wVa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];e=l;d=m;c[e+0>>2]=c[d+0>>2];d=k;e=n;c[d+0>>2]=c[e+0>>2];sVa(a,b,l,k,f,g,h,279504,279536|0);i=j;return}function xVa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=d+8|0;q=oe[c[(c[p>>2]|0)+20>>2]&127](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q]|0;if((f&1)==0){r=q+4|0;s=q+4|0;t=(f&255)>>>1}else{f=c[q+8>>2]|0;r=f;s=f;t=c[q+4>>2]|0}q=r+(t<<2)|0;t=m;r=n;c[t+0>>2]=c[r+0>>2];r=l;t=o;c[r+0>>2]=c[t+0>>2];sVa(b,d,m,l,g,h,j,s,q);i=k;return}function yVa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;MRa(n,f);f=n;n=c[f>>2]|0;if(!((c[70110]|0)==-1)){c[m>>2]=280440;c[m+4>>2]=1276;c[m+8>>2]=0;BQa(280440,m,1277)}m=(c[280444>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Hc(4)|0;q=p;A_a(q);r=296008;s=128;Zd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Hc(4)|0;q=p;A_a(q);r=296008;s=128;Zd(p|0,r|0,s|0)}s=n;gQa(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=oe[c[c[e>>2]>>2]&127](e)|0;c[l>>2]=f;f=b+168|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=eUa(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=168){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+24>>2]=((g|0)/12|0|0)%7|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function zVa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;MRa(n,f);f=n;n=c[f>>2]|0;if(!((c[70110]|0)==-1)){c[m>>2]=280440;c[m+4>>2]=1276;c[m+8>>2]=0;BQa(280440,m,1277)}m=(c[280444>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Hc(4)|0;q=p;A_a(q);r=296008;s=128;Zd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Hc(4)|0;q=p;A_a(q);r=296008;s=128;Zd(p|0,r|0,s|0)}s=n;gQa(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=oe[c[(c[e>>2]|0)+4>>2]&127](e)|0;c[l>>2]=f;f=b+288|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=eUa(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=288){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+16>>2]=((g|0)/12|0|0)%12|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function AVa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+40|0;j=b;k=b+8|0;l=b+16|0;m=b+32|0;MRa(m,f);f=m;m=c[f>>2]|0;if(!((c[70110]|0)==-1)){c[l>>2]=280440;c[l+4>>2]=1276;c[l+8>>2]=0;BQa(280440,l,1277)}l=(c[280444>>2]|0)+ -1|0;n=c[m+8>>2]|0;if(!((c[m+12>>2]|0)-n>>2>>>0>l>>>0)){o=Hc(4)|0;p=o;A_a(p);q=296008;r=128;Zd(o|0,q|0,r|0)}m=c[n+(l<<2)>>2]|0;if((m|0)==0){o=Hc(4)|0;p=o;A_a(p);q=296008;r=128;Zd(o|0,q|0,r|0)}r=m;gQa(c[f>>2]|0)|0;f=h+20|0;c[k>>2]=c[e>>2];e=j;h=k;c[e+0>>2]=c[h+0>>2];h=FVa(d,j,g,r,4)|0;if((c[g>>2]&4|0)!=0){s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}if((h|0)<69){x=h+2e3|0}else{x=(h+ -69|0)>>>0<31?h+1900|0:h}c[f>>2]=x+ -1900;s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}function BVa(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;l=i;i=i+576|0;m=l;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+104|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;M=l+208|0;N=l+216|0;O=l+224|0;P=l+232|0;Q=l+240|0;R=l+248|0;S=l+256|0;T=l+264|0;U=l+272|0;V=l+280|0;W=l+288|0;X=l+296|0;Y=l+304|0;Z=l+312|0;_=l+320|0;$=l+328|0;aa=l+336|0;ba=l+344|0;ca=l+360|0;da=l+368|0;ea=l+376|0;fa=l+384|0;ga=l+392|0;ha=l+400|0;ia=l+408|0;ja=l+416|0;ka=l+424|0;la=l+432|0;ma=l+440|0;na=l+448|0;oa=l+456|0;pa=l+464|0;qa=l+472|0;ra=l+480|0;sa=l+488|0;ta=l+496|0;ua=l+504|0;va=l+512|0;wa=l+520|0;xa=l+528|0;ya=l+536|0;za=l+544|0;Aa=l+552|0;Ba=l+560|0;Ca=l+568|0;c[h>>2]=0;MRa(ca,g);Da=ca;ca=c[Da>>2]|0;if(!((c[70110]|0)==-1)){c[ba>>2]=280440;c[ba+4>>2]=1276;c[ba+8>>2]=0;BQa(280440,ba,1277)}ba=(c[280444>>2]|0)+ -1|0;Ea=c[ca+8>>2]|0;if(!((c[ca+12>>2]|0)-Ea>>2>>>0>ba>>>0)){Fa=Hc(4)|0;Ga=Fa;A_a(Ga);Ha=296008;Ia=128;Zd(Fa|0,Ha|0,Ia|0)}ca=c[Ea+(ba<<2)>>2]|0;if((ca|0)==0){Fa=Hc(4)|0;Ga=Fa;A_a(Ga);Ha=296008;Ia=128;Zd(Fa|0,Ha|0,Ia|0)}Ia=ca;gQa(c[Da>>2]|0)|0;a:do{switch(k<<24>>24|0){case 83:{c[U>>2]=c[f>>2];c[w+0>>2]=c[U+0>>2];Da=FVa(e,w,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<61){c[j>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 104:case 66:case 98:{ca=c[f>>2]|0;Da=d+8|0;Ha=oe[c[(c[Da>>2]|0)+4>>2]&127](Da)|0;c[$>>2]=ca;c[P+0>>2]=c[$+0>>2];ca=(eUa(e,P,Ha,Ha+288|0,Ia,h,0)|0)-Ha|0;if((ca|0)>=288){break a}c[j+16>>2]=((ca|0)/12|0|0)%12|0;break};case 109:{c[W>>2]=c[f>>2];c[E+0>>2]=c[W+0>>2];ca=FVa(e,E,h,Ia,2)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(ca|0)<13){c[j+16>>2]=ca+ -1;break a}else{c[h>>2]=Ha|4;break a}break};case 77:{c[V>>2]=c[f>>2];c[D+0>>2]=c[V+0>>2];Ha=FVa(e,D,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Ha|0)<60){c[j+4>>2]=Ha;break a}else{c[h>>2]=ca|4;break a}break};case 84:{ca=e;c[va>>2]=c[ca>>2];c[wa>>2]=c[f>>2];c[v+0>>2]=c[va+0>>2];c[u+0>>2]=c[wa+0>>2];sVa(ua,d,v,u,g,h,j,279672,279704|0);c[ca>>2]=c[ua>>2];break};case 70:{ca=e;c[ka>>2]=c[ca>>2];c[la>>2]=c[f>>2];c[J+0>>2]=c[ka+0>>2];c[I+0>>2]=c[la+0>>2];sVa(ja,d,J,I,g,h,j,279568,279600|0);c[ca>>2]=c[ja>>2];break};case 101:case 100:{ca=j+12|0;c[_>>2]=c[f>>2];c[M+0>>2]=c[_+0>>2];Ha=FVa(e,M,h,Ia,2)|0;Da=c[h>>2]|0;do{if((Da&4|0)==0){if(!((Ha+ -1|0)>>>0<31)){break}c[ca>>2]=Ha;break a}}while(0);c[h>>2]=Da|4;break};case 68:{Ha=e;c[ha>>2]=c[Ha>>2];c[ia>>2]=c[f>>2];c[L+0>>2]=c[ha+0>>2];c[K+0>>2]=c[ia+0>>2];sVa(ga,d,L,K,g,h,j,279536,279568|0);c[Ha>>2]=c[ga>>2];break};case 120:{Ha=c[(c[d>>2]|0)+20>>2]|0;c[xa>>2]=c[e>>2];c[ya>>2]=c[f>>2];c[s+0>>2]=c[xa+0>>2];c[r+0>>2]=c[ya+0>>2];Ae[Ha&63](b,d,s,r,g,h,j);i=l;return};case 72:{c[Z>>2]=c[f>>2];c[H+0>>2]=c[Z+0>>2];Ha=FVa(e,H,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Ha|0)<24){c[j+8>>2]=Ha;break a}else{c[h>>2]=ca|4;break a}break};case 116:case 110:{c[ma>>2]=c[f>>2];c[C+0>>2]=c[ma+0>>2];CVa(0,e,C,h,Ia);break};case 37:{c[Ca>>2]=c[f>>2];c[m+0>>2]=c[Ca+0>>2];EVa(0,e,m,h,Ia);break};case 112:{c[na>>2]=c[f>>2];c[B+0>>2]=c[na+0>>2];DVa(d,j+8|0,e,B,h,Ia);break};case 99:{ca=d+8|0;Ha=oe[c[(c[ca>>2]|0)+12>>2]&127](ca)|0;ca=e;c[ea>>2]=c[ca>>2];c[fa>>2]=c[f>>2];Fa=a[Ha]|0;if((Fa&1)==0){Ja=Ha+4|0;Ka=Ha+4|0;La=(Fa&255)>>>1}else{Fa=c[Ha+8>>2]|0;Ja=Fa;Ka=Fa;La=c[Ha+4>>2]|0}c[O+0>>2]=c[ea+0>>2];c[N+0>>2]=c[fa+0>>2];sVa(da,d,O,N,g,h,j,Ka,Ja+(La<<2)|0);c[ca>>2]=c[da>>2];break};case 121:{c[S>>2]=c[f>>2];c[o+0>>2]=c[S+0>>2];ca=FVa(e,o,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}if((ca|0)<69){Ma=ca+2e3|0}else{Ma=(ca+ -69|0)>>>0<31?ca+1900|0:ca}c[j+20>>2]=Ma+ -1900;break};case 82:{ca=e;c[sa>>2]=c[ca>>2];c[ta>>2]=c[f>>2];c[y+0>>2]=c[sa+0>>2];c[x+0>>2]=c[ta+0>>2];sVa(ra,d,y,x,g,h,j,279648,279668|0);c[ca>>2]=c[ra>>2];break};case 89:{c[R>>2]=c[f>>2];c[n+0>>2]=c[R+0>>2];ca=FVa(e,n,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}c[j+20>>2]=ca+ -1900;break};case 73:{ca=j+8|0;c[Y>>2]=c[f>>2];c[G+0>>2]=c[Y+0>>2];Ha=FVa(e,G,h,Ia,2)|0;Fa=c[h>>2]|0;do{if((Fa&4|0)==0){if(!((Ha+ -1|0)>>>0<12)){break}c[ca>>2]=Ha;break a}}while(0);c[h>>2]=Fa|4;break};case 106:{c[X>>2]=c[f>>2];c[F+0>>2]=c[X+0>>2];Ha=FVa(e,F,h,Ia,3)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Ha|0)<366){c[j+28>>2]=Ha;break a}else{c[h>>2]=ca|4;break a}break};case 114:{ca=e;c[pa>>2]=c[ca>>2];c[qa>>2]=c[f>>2];c[A+0>>2]=c[pa+0>>2];c[z+0>>2]=c[qa+0>>2];sVa(oa,d,A,z,g,h,j,279600,279644|0);c[ca>>2]=c[oa>>2];break};case 65:case 97:{ca=c[f>>2]|0;Ha=d+8|0;Da=oe[c[c[Ha>>2]>>2]&127](Ha)|0;c[aa>>2]=ca;c[Q+0>>2]=c[aa+0>>2];ca=(eUa(e,Q,Da,Da+168|0,Ia,h,0)|0)-Da|0;if((ca|0)>=168){break a}c[j+24>>2]=((ca|0)/12|0|0)%7|0;break};case 119:{c[T>>2]=c[f>>2];c[t+0>>2]=c[T+0>>2];ca=FVa(e,t,h,Ia,1)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<7){c[j+24>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 88:{Da=d+8|0;ca=oe[c[(c[Da>>2]|0)+24>>2]&127](Da)|0;Da=e;c[Aa>>2]=c[Da>>2];c[Ba>>2]=c[f>>2];Ha=a[ca]|0;if((Ha&1)==0){Na=ca+4|0;Oa=ca+4|0;Pa=(Ha&255)>>>1}else{Ha=c[ca+8>>2]|0;Na=Ha;Oa=Ha;Pa=c[ca+4>>2]|0}c[q+0>>2]=c[Aa+0>>2];c[p+0>>2]=c[Ba+0>>2];sVa(za,d,q,p,g,h,j,Oa,Na+(Pa<<2)|0);c[Da>>2]=c[za>>2];break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}function CVa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;a=i;g=b;b=d;a:while(1){d=c[g>>2]|0;do{if((d|0)==0){h=1}else{j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){k=oe[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);d=c[b>>2]|0;do{if((d|0)==0){l=15}else{j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){m=oe[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{m=c[j>>2]|0}if((m|0)==-1){c[b>>2]=0;l=15;break}else{if(h){n=d;break}else{o=d;break a}}}}while(0);if((l|0)==15){l=0;if(h){o=0;break}else{n=0}}d=c[g>>2]|0;j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){p=oe[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{p=c[j>>2]|0}if(!(re[c[(c[f>>2]|0)+12>>2]&63](f,8192,p)|0)){o=n;break}j=c[g>>2]|0;d=j+12|0;q=c[d>>2]|0;if((q|0)==(c[j+16>>2]|0)){oe[c[(c[j>>2]|0)+40>>2]&127](j)|0;continue}else{c[d>>2]=q+4;continue}}n=c[g>>2]|0;do{if((n|0)==0){r=1}else{p=c[n+12>>2]|0;if((p|0)==(c[n+16>>2]|0)){s=oe[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{s=c[p>>2]|0}if((s|0)==-1){c[g>>2]=0;r=1;break}else{r=(c[g>>2]|0)==0;break}}}while(0);do{if((o|0)==0){l=37}else{g=c[o+12>>2]|0;if((g|0)==(c[o+16>>2]|0)){t=oe[c[(c[o>>2]|0)+36>>2]&127](o)|0}else{t=c[g>>2]|0}if((t|0)==-1){c[b>>2]=0;l=37;break}if(!r){break}i=a;return}}while(0);do{if((l|0)==37){if(r){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function DVa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;l=j+8|0;m=b+8|0;b=oe[c[(c[m>>2]|0)+8>>2]&127](m)|0;m=a[b]|0;if((m&1)==0){n=(m&255)>>>1}else{n=c[b+4>>2]|0}m=a[b+12|0]|0;if((m&1)==0){o=(m&255)>>>1}else{o=c[b+16>>2]|0}if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];f=b+24|0;o=k;n=l;c[o+0>>2]=c[n+0>>2];n=eUa(e,k,b,f,h,g,0)|0;g=n-b|0;do{if((n|0)==(b|0)){if((c[d>>2]|0)!=12){break}c[d>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[d>>2]|0;if((g|0)>=12){i=j;return}c[d>>2]=g+12;i=j;return}function EVa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a=i;g=b;b=c[g>>2]|0;do{if((b|0)==0){h=1}else{j=c[b+12>>2]|0;if((j|0)==(c[b+16>>2]|0)){k=oe[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);k=d;d=c[k>>2]|0;do{if((d|0)==0){l=14}else{b=c[d+12>>2]|0;if((b|0)==(c[d+16>>2]|0)){m=oe[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{m=c[b>>2]|0}if((m|0)==-1){c[k>>2]=0;l=14;break}else{if(h){n=d;break}else{l=16;break}}}}while(0);if((l|0)==14){if(h){l=16}else{n=0}}if((l|0)==16){c[e>>2]=c[e>>2]|6;i=a;return}h=c[g>>2]|0;d=c[h+12>>2]|0;if((d|0)==(c[h+16>>2]|0)){o=oe[c[(c[h>>2]|0)+36>>2]&127](h)|0}else{o=c[d>>2]|0}if(!((re[c[(c[f>>2]|0)+52>>2]&63](f,o,0)|0)<<24>>24==37)){c[e>>2]=c[e>>2]|4;i=a;return}o=c[g>>2]|0;f=o+12|0;d=c[f>>2]|0;if((d|0)==(c[o+16>>2]|0)){oe[c[(c[o>>2]|0)+40>>2]&127](o)|0}else{c[f>>2]=d+4}d=c[g>>2]|0;do{if((d|0)==0){p=1}else{f=c[d+12>>2]|0;if((f|0)==(c[d+16>>2]|0)){q=oe[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{q=c[f>>2]|0}if((q|0)==-1){c[g>>2]=0;p=1;break}else{p=(c[g>>2]|0)==0;break}}}while(0);do{if((n|0)==0){l=38}else{g=c[n+12>>2]|0;if((g|0)==(c[n+16>>2]|0)){r=oe[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{r=c[g>>2]|0}if((r|0)==-1){c[k>>2]=0;l=38;break}if(!p){break}i=a;return}}while(0);do{if((l|0)==38){if(p){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function FVa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=i;h=a;a=c[h>>2]|0;do{if((a|0)==0){j=1}else{k=c[a+12>>2]|0;if((k|0)==(c[a+16>>2]|0)){l=oe[c[(c[a>>2]|0)+36>>2]&127](a)|0}else{l=c[k>>2]|0}if((l|0)==-1){c[h>>2]=0;j=1;break}else{j=(c[h>>2]|0)==0;break}}}while(0);l=b;b=c[l>>2]|0;do{if((b|0)==0){m=14}else{a=c[b+12>>2]|0;if((a|0)==(c[b+16>>2]|0)){n=oe[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{n=c[a>>2]|0}if((n|0)==-1){c[l>>2]=0;m=14;break}else{if(j){o=b;break}else{m=16;break}}}}while(0);if((m|0)==14){if(j){m=16}else{o=0}}if((m|0)==16){c[d>>2]=c[d>>2]|6;p=0;i=g;return p|0}j=c[h>>2]|0;b=c[j+12>>2]|0;if((b|0)==(c[j+16>>2]|0)){q=oe[c[(c[j>>2]|0)+36>>2]&127](j)|0}else{q=c[b>>2]|0}if(!(re[c[(c[e>>2]|0)+12>>2]&63](e,2048,q)|0)){c[d>>2]=c[d>>2]|4;p=0;i=g;return p|0}b=(re[c[(c[e>>2]|0)+52>>2]&63](e,q,0)|0)<<24>>24;q=c[h>>2]|0;j=q+12|0;n=c[j>>2]|0;if((n|0)==(c[q+16>>2]|0)){oe[c[(c[q>>2]|0)+40>>2]&127](q)|0;r=f;s=o;t=o;u=b}else{c[j>>2]=n+4;r=f;s=o;t=o;u=b}while(1){v=u+ -48|0;b=r+ -1|0;o=c[h>>2]|0;do{if((o|0)==0){w=1}else{f=c[o+12>>2]|0;if((f|0)==(c[o+16>>2]|0)){x=oe[c[(c[o>>2]|0)+36>>2]&127](o)|0}else{x=c[f>>2]|0}if((x|0)==-1){c[h>>2]=0;w=1;break}else{w=(c[h>>2]|0)==0;break}}}while(0);do{if((t|0)==0){y=s;z=0;A=1}else{o=c[t+12>>2]|0;if((o|0)==(c[t+16>>2]|0)){B=oe[c[(c[t>>2]|0)+36>>2]&127](t)|0}else{B=c[o>>2]|0}if((B|0)==-1){c[l>>2]=0;y=0;z=0;A=1;break}else{y=s;z=s;A=(s|0)==0;break}}}while(0);C=c[h>>2]|0;if(!((w^A)&(b|0)>0)){break}o=c[C+12>>2]|0;if((o|0)==(c[C+16>>2]|0)){D=oe[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{D=c[o>>2]|0}if(!(re[c[(c[e>>2]|0)+12>>2]&63](e,2048,D)|0)){p=v;m=63;break}o=((re[c[(c[e>>2]|0)+52>>2]&63](e,D,0)|0)<<24>>24)+(v*10|0)|0;f=c[h>>2]|0;n=f+12|0;j=c[n>>2]|0;if((j|0)==(c[f+16>>2]|0)){oe[c[(c[f>>2]|0)+40>>2]&127](f)|0;E=b;s=y;t=z;u=o;r=E;continue}else{c[n>>2]=j+4;E=b;s=y;t=z;u=o;r=E;continue}}if((m|0)==63){i=g;return p|0}do{if((C|0)==0){F=1}else{E=c[C+12>>2]|0;if((E|0)==(c[C+16>>2]|0)){G=oe[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{G=c[E>>2]|0}if((G|0)==-1){c[h>>2]=0;F=1;break}else{F=(c[h>>2]|0)==0;break}}}while(0);do{if((y|0)==0){m=60}else{h=c[y+12>>2]|0;if((h|0)==(c[y+16>>2]|0)){H=oe[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{H=c[h>>2]|0}if((H|0)==-1){c[l>>2]=0;m=60;break}if(F){p=v}else{break}i=g;return p|0}}while(0);do{if((m|0)==60){if(F){break}else{p=v}i=g;return p|0}}while(0);c[d>>2]=c[d>>2]|2;p=v;i=g;return p|0}function GVa(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[e>>2]|0;do{if((a[280344]|0)==0){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);if((f|0)==(c[70084]|0)){g=b;b$a(g);i=d;return}ec(c[e>>2]|0);g=b;b$a(g);i=d;return}function HVa(b){b=b|0;var d=0,e=0;d=i;e=b+8|0;b=c[e>>2]|0;do{if((a[280344]|0)==0){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);if((b|0)==(c[70084]|0)){i=d;return}ec(c[e>>2]|0);i=d;return}function IVa(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=i;i=i+112|0;f=g;l=g+8|0;m=l;n=f;a[n]=37;o=f+1|0;a[o]=j;p=f+2|0;a[p]=k;a[f+3|0]=0;if(!(k<<24>>24==0)){a[o]=k;a[p]=j}j=Vc(m|0,100,n|0,h|0,c[d+8>>2]|0)|0;d=l+j|0;l=c[e>>2]|0;if((j|0)==0){q=l;r=b;s=r;c[s>>2]=q;i=g;return}else{t=m;u=l;v=l}while(1){l=a[t]|0;do{if((v|0)==0){w=u;x=0}else{m=v+24|0;j=c[m>>2]|0;if((j|0)==(c[v+28>>2]|0)){e=(De[c[(c[v>>2]|0)+52>>2]&63](v,l&255)|0)==-1;w=e?0:u;x=e?0:v;break}else{c[m>>2]=j+1;a[j]=l;w=u;x=v;break}}}while(0);l=t+1|0;if((l|0)==(d|0)){q=w;break}else{t=l;u=w;v=x}}r=b;s=r;c[s>>2]=q;i=g;return}function JVa(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[e>>2]|0;do{if((a[280344]|0)==0){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);if((f|0)==(c[70084]|0)){g=b;b$a(g);i=d;return}ec(c[e>>2]|0);g=b;b$a(g);i=d;return}function KVa(b){b=b|0;var d=0,e=0;d=i;e=b+8|0;b=c[e>>2]|0;do{if((a[280344]|0)==0){if((_a(280344)|0)==0){break}c[70084]=bc(2147483647,280352,0)|0;Wb(280344)}}while(0);if((b|0)==(c[70084]|0)){i=d;return}ec(c[e>>2]|0);i=d;return}function LVa(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+408|0;e=f;k=f+400|0;l=e;c[k>>2]=e+400;MVa(b+8|0,l,k,g,h,j);j=c[k>>2]|0;k=c[d>>2]|0;if((l|0)==(j|0)){m=k;n=a;o=n;c[o>>2]=m;i=f;return}else{p=l;q=k;r=k}while(1){k=c[p>>2]|0;if((q|0)==0){s=r;t=0}else{l=q+24|0;d=c[l>>2]|0;if((d|0)==(c[q+28>>2]|0)){u=De[c[(c[q>>2]|0)+52>>2]&63](q,k)|0}else{c[l>>2]=d+4;c[d>>2]=k;u=k}k=(u|0)==-1;s=k?0:r;t=k?0:q}k=p+4|0;if((k|0)==(j|0)){m=s;break}else{p=k;q=t;r=s}}n=a;o=n;c[o>>2]=m;i=f;return}function MVa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+120|0;k=j;l=j+112|0;m=i;i=i+8|0;n=j+8|0;o=k;a[o]=37;p=k+1|0;a[p]=g;q=k+2|0;a[q]=h;a[k+3|0]=0;if(!(h<<24>>24==0)){a[p]=h;a[q]=g}g=b;Vc(n|0,100,o|0,f|0,c[g>>2]|0)|0;f=l;c[f>>2]=0;c[f+4>>2]=0;c[m>>2]=n;n=(c[e>>2]|0)-d>>2;f=Oc(c[g>>2]|0)|0;g=YZa(d,m,n,l)|0;if((f|0)!=0){Oc(f|0)|0}if((g|0)==-1){IWa(281328)}else{c[e>>2]=d+(g<<2);i=j;return}}function NVa(a){a=a|0;var b=0;b=i;b$a(a);i=b;return}function OVa(a){a=a|0;i=i;return}function PVa(a){a=a|0;i=i;return 127}function QVa(a){a=a|0;i=i;return 127}function RVa(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function SVa(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function TVa(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function UVa(a,b){a=a|0;b=b|0;b=i;MQa(a,1,45);i=b;return}function VVa(a){a=a|0;i=i;return 0}function WVa(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function XVa(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function YVa(a){a=a|0;var b=0;b=i;b$a(a);i=b;return}function ZVa(a){a=a|0;i=i;return}function _Va(a){a=a|0;i=i;return 127}function $Va(a){a=a|0;i=i;return 127}function aWa(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function bWa(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function cWa(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function dWa(a,b){a=a|0;b=b|0;b=i;MQa(a,1,45);i=b;return}function eWa(a){a=a|0;i=i;return 0}function fWa(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function gWa(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function hWa(a){a=a|0;var b=0;b=i;b$a(a);i=b;return}function iWa(a){a=a|0;i=i;return}function jWa(a){a=a|0;i=i;return 2147483647}function kWa(a){a=a|0;i=i;return 2147483647}function lWa(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function mWa(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function nWa(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function oWa(a,b){a=a|0;b=b|0;b=i;rRa(a,1,45);i=b;return}function pWa(a){a=a|0;i=i;return 0}function qWa(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function rWa(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function sWa(a){a=a|0;var b=0;b=i;b$a(a);i=b;return}function tWa(a){a=a|0;i=i;return}function uWa(a){a=a|0;i=i;return 2147483647}function vWa(a){a=a|0;i=i;return 2147483647}function wWa(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function xWa(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function yWa(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function zWa(a,b){a=a|0;b=b|0;b=i;rRa(a,1,45);i=b;return}function AWa(a){a=a|0;i=i;return 0}function BWa(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function CWa(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function DWa(a){a=a|0;var b=0;b=i;b$a(a);i=b;return}function EWa(a){a=a|0;i=i;return}function FWa(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+104|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+104|0;w=p;c[w>>2]=o;x=p+4|0;c[x>>2]=1278;y=o+100|0;MRa(r,h);o=r;z=c[o>>2]|0;if(!((c[70112]|0)==-1)){c[n>>2]=280448;c[n+4>>2]=1276;c[n+8>>2]=0;BQa(280448,n,1277)}n=(c[280452>>2]|0)+ -1|0;A=c[z+8>>2]|0;if(!((c[z+12>>2]|0)-A>>2>>>0>n>>>0)){B=Hc(4)|0;C=B;A_a(C);D=296008;E=128;Zd(B|0,D|0,E|0)}z=c[A+(n<<2)>>2]|0;if((z|0)==0){B=Hc(4)|0;C=B;A_a(C);D=296008;E=128;Zd(B|0,D|0,E|0)}E=z;a[s]=0;D=f;c[t>>2]=c[D>>2];f=c[h+4>>2]|0;h=l;B=t;c[h+0>>2]=c[B+0>>2];B=HWa(e,l,g,r,f,j,s,E,p,q,y)|0;do{if(B){y=u;Ne[c[(c[z>>2]|0)+32>>2]&63](E,280064,280074|0,y)|0;p=v;f=c[q>>2]|0;r=c[w>>2]|0;g=f-r|0;do{if((g|0)>98){l=V_a(g+2|0)|0;if((l|0)!=0){F=l;G=l;break}g$a()}else{F=0;G=p}}while(0);if((a[s]|0)==0){H=G}else{a[G]=45;H=G+1|0}if(r>>>0<f>>>0){g=u+10|0;l=u;h=H;t=r;while(1){C=a[t]|0;n=y;while(1){A=n+1|0;if((a[n]|0)==C<<24>>24){I=n;break}if((A|0)==(g|0)){I=g;break}else{n=A}}a[h]=a[280064+(I-l)|0]|0;n=t+1|0;C=h+1|0;if(n>>>0<(c[q>>2]|0)>>>0){h=C;t=n}else{J=C;break}}}else{J=H}a[J]=0;c[m>>2]=k;if((Dd(p|0,280080,m|0)|0)!=1){t=Hc(8)|0;mQa(t,280088);Zd(t|0,277440,43)}if((F|0)==0){break}W_a(F)}}while(0);F=e;e=c[F>>2]|0;do{if((e|0)==0){K=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){K=e;break}if(!((oe[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){K=e;break}c[F>>2]=0;K=0}}while(0);F=(K|0)==0;e=c[D>>2]|0;do{if((e|0)==0){L=31}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){if(F){break}else{L=33;break}}if((oe[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[D>>2]=0;L=31;break}else{if(F){break}else{L=33;break}}}}while(0);if((L|0)==31){if(F){L=33}}if((L|0)==33){c[j>>2]=c[j>>2]|2}c[b>>2]=K;gQa(c[o>>2]|0)|0;o=c[w>>2]|0;c[w>>2]=0;if((o|0)==0){i=d;return}le[c[x>>2]&2047](o);i=d;return}function GWa(a){a=a|0;i=i;return}function HWa(e,f,g,h,j,k,l,m,n,o,p){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0;q=i;i=i+408|0;r=q;s=q+400|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;D=r;c[s>>2]=0;E=w;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=x;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=y;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=z;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=A;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;LWa(g,h,t,u,v,w,x,y,z,B);t=n;c[o>>2]=c[t>>2];h=e;e=f;f=m+8|0;m=z+1|0;g=z+4|0;E=z+8|0;F=y+1|0;G=y+4|0;H=y+8|0;I=(j&512|0)!=0;j=x+1|0;J=x+8|0;K=x+4|0;L=A+1|0;M=A+8|0;N=A+4|0;O=s+3|0;P=n+4|0;n=w+4|0;Q=r+400|0;r=D;R=D;D=p;p=0;S=0;T=1278;a:while(1){U=c[h>>2]|0;do{if((U|0)==0){V=0}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){V=U;break}if((oe[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[h>>2]=0;V=0;break}else{V=c[h>>2]|0;break}}}while(0);U=(V|0)==0;W=c[e>>2]|0;do{if((W|0)==0){X=12}else{if((c[W+12>>2]|0)!=(c[W+16>>2]|0)){if(U){Y=W;break}else{Z=R;_=r;$=S;aa=T;X=269;break a}}if((oe[c[(c[W>>2]|0)+36>>2]&127](W)|0)==-1){c[e>>2]=0;X=12;break}else{if(U){Y=W;break}else{Z=R;_=r;$=S;aa=T;X=269;break a}}}}while(0);if((X|0)==12){X=0;if(U){Z=R;_=r;$=S;aa=T;X=269;break}else{Y=0}}b:do{switch(a[s+p|0]|0){case 3:{W=a[y]|0;ba=(W&1)==0;if(ba){ca=(W&255)>>>1}else{ca=c[G>>2]|0}da=a[z]|0;ea=(da&1)==0;if(ea){fa=(da&255)>>>1}else{fa=c[g>>2]|0}if((ca|0)==(0-fa|0)){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break b}if(ba){ma=(W&255)>>>1}else{ma=c[G>>2]|0}do{if((ma|0)!=0){if(ea){na=(da&255)>>>1}else{na=c[g>>2]|0}if((na|0)==0){break}oa=c[h>>2]|0;pa=c[oa+12>>2]|0;qa=c[oa+16>>2]|0;if((pa|0)==(qa|0)){ra=(oe[c[(c[oa>>2]|0)+36>>2]&127](oa)|0)&255;sa=c[h>>2]|0;ta=ra;ua=c[sa+16>>2]|0;va=c[sa+12>>2]|0;wa=sa;xa=a[y]|0}else{ta=a[pa]|0;ua=qa;va=pa;wa=oa;xa=W}oa=wa+12|0;pa=(va|0)==(ua|0);if(ta<<24>>24==(a[(xa&1)==0?F:c[H>>2]|0]|0)){if(pa){oe[c[(c[wa>>2]|0)+40>>2]&127](wa)|0}else{c[oa>>2]=va+1}oa=a[y]|0;if((oa&1)==0){ya=(oa&255)>>>1}else{ya=c[G>>2]|0}ga=D;ha=R;ia=r;ja=Q;ka=ya>>>0>1?y:S;la=T;break b}if(pa){za=(oe[c[(c[wa>>2]|0)+36>>2]&127](wa)|0)&255}else{za=a[va]|0}if(!(za<<24>>24==(a[(a[z]&1)==0?m:c[E>>2]|0]|0))){X=112;break a}pa=c[h>>2]|0;oa=pa+12|0;qa=c[oa>>2]|0;if((qa|0)==(c[pa+16>>2]|0)){oe[c[(c[pa>>2]|0)+40>>2]&127](pa)|0}else{c[oa>>2]=qa+1}a[l]=1;qa=a[z]|0;if((qa&1)==0){Aa=(qa&255)>>>1}else{Aa=c[g>>2]|0}ga=D;ha=R;ia=r;ja=Q;ka=Aa>>>0>1?z:S;la=T;break b}}while(0);if(ba){Ba=(W&255)>>>1}else{Ba=c[G>>2]|0}ea=c[h>>2]|0;qa=c[ea+12>>2]|0;oa=(qa|0)==(c[ea+16>>2]|0);if((Ba|0)==0){if(oa){pa=(oe[c[(c[ea>>2]|0)+36>>2]&127](ea)|0)&255;Ca=pa;Da=a[z]|0}else{Ca=a[qa]|0;Da=da}if(!(Ca<<24>>24==(a[(Da&1)==0?m:c[E>>2]|0]|0))){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break b}pa=c[h>>2]|0;sa=pa+12|0;ra=c[sa>>2]|0;if((ra|0)==(c[pa+16>>2]|0)){oe[c[(c[pa>>2]|0)+40>>2]&127](pa)|0}else{c[sa>>2]=ra+1}a[l]=1;ra=a[z]|0;if((ra&1)==0){Ea=(ra&255)>>>1}else{Ea=c[g>>2]|0}ga=D;ha=R;ia=r;ja=Q;ka=Ea>>>0>1?z:S;la=T;break b}if(oa){oa=(oe[c[(c[ea>>2]|0)+36>>2]&127](ea)|0)&255;Fa=oa;Ga=a[y]|0}else{Fa=a[qa]|0;Ga=W}if(!(Fa<<24>>24==(a[(Ga&1)==0?F:c[H>>2]|0]|0))){a[l]=1;ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break b}qa=c[h>>2]|0;oa=qa+12|0;ea=c[oa>>2]|0;if((ea|0)==(c[qa+16>>2]|0)){oe[c[(c[qa>>2]|0)+40>>2]&127](qa)|0}else{c[oa>>2]=ea+1}ea=a[y]|0;if((ea&1)==0){Ha=(ea&255)>>>1}else{Ha=c[G>>2]|0}ga=D;ha=R;ia=r;ja=Q;ka=Ha>>>0>1?y:S;la=T;break};case 4:{ea=D;oa=R;qa=r;ra=Q;sa=0;pa=T;c:while(1){Ia=c[h>>2]|0;do{if((Ia|0)==0){Ja=0}else{if((c[Ia+12>>2]|0)!=(c[Ia+16>>2]|0)){Ja=Ia;break}if((oe[c[(c[Ia>>2]|0)+36>>2]&127](Ia)|0)==-1){c[h>>2]=0;Ja=0;break}else{Ja=c[h>>2]|0;break}}}while(0);Ia=(Ja|0)==0;Ka=c[e>>2]|0;do{if((Ka|0)==0){X=173}else{if((c[Ka+12>>2]|0)!=(c[Ka+16>>2]|0)){if(Ia){break}else{break c}}if((oe[c[(c[Ka>>2]|0)+36>>2]&127](Ka)|0)==-1){c[e>>2]=0;X=173;break}else{if(Ia){break}else{break c}}}}while(0);if((X|0)==173){X=0;if(Ia){break}}Ka=c[h>>2]|0;La=c[Ka+12>>2]|0;if((La|0)==(c[Ka+16>>2]|0)){Ma=(oe[c[(c[Ka>>2]|0)+36>>2]&127](Ka)|0)&255}else{Ma=a[La]|0}do{if(Ma<<24>>24>-1){if((b[(c[f>>2]|0)+(Ma<<24>>24<<1)>>1]&2048)==0){X=189;break}La=c[o>>2]|0;if((La|0)==(ea|0)){Ka=(c[P>>2]|0)!=1278;Na=c[t>>2]|0;Oa=ea-Na|0;Pa=Oa>>>0<2147483647?Oa<<1:-1;Qa=Y_a(Ka?Na:0,Pa)|0;if((Qa|0)==0){X=182;break a}do{if(Ka){c[t>>2]=Qa;Ra=Qa}else{Na=c[t>>2]|0;c[t>>2]=Qa;if((Na|0)==0){Ra=Qa;break}le[c[P>>2]&2047](Na);Ra=c[t>>2]|0}}while(0);c[P>>2]=1253;Qa=Ra+Oa|0;c[o>>2]=Qa;Sa=Qa;Ta=(c[t>>2]|0)+Pa|0}else{Sa=La;Ta=ea}c[o>>2]=Sa+1;a[Sa]=Ma;Ua=Ta;Va=oa;Wa=qa;Xa=ra;Ya=sa+1|0;Za=pa}else{X=189}}while(0);if((X|0)==189){X=0;Ia=a[w]|0;if((Ia&1)==0){_a=(Ia&255)>>>1}else{_a=c[n>>2]|0}if((_a|0)==0|(sa|0)==0){break}if(!(Ma<<24>>24==(a[v]|0))){break}if((qa|0)==(ra|0)){Ia=qa-oa|0;Qa=Ia>>>0<2147483647?Ia<<1:-1;if((pa|0)==1278){$a=0}else{$a=oa}Ka=Y_a($a,Qa)|0;if((Ka|0)==0){X=198;break a}ab=Ka;bb=Ka+(Ia>>2<<2)|0;cb=Ka+(Qa>>>2<<2)|0;db=1253}else{ab=oa;bb=qa;cb=ra;db=pa}c[bb>>2]=sa;Ua=ea;Va=ab;Wa=bb+4|0;Xa=cb;Ya=0;Za=db}Qa=c[h>>2]|0;Ka=Qa+12|0;Ia=c[Ka>>2]|0;if((Ia|0)==(c[Qa+16>>2]|0)){oe[c[(c[Qa>>2]|0)+40>>2]&127](Qa)|0;ea=Ua;oa=Va;qa=Wa;ra=Xa;sa=Ya;pa=Za;continue}else{c[Ka>>2]=Ia+1;ea=Ua;oa=Va;qa=Wa;ra=Xa;sa=Ya;pa=Za;continue}}if((oa|0)==(qa|0)|(sa|0)==0){eb=oa;fb=qa;gb=ra;hb=pa}else{if((qa|0)==(ra|0)){W=qa-oa|0;da=W>>>0<2147483647?W<<1:-1;if((pa|0)==1278){ib=0}else{ib=oa}ba=Y_a(ib,da)|0;if((ba|0)==0){X=209;break a}jb=ba;kb=ba+(W>>2<<2)|0;lb=ba+(da>>>2<<2)|0;mb=1253}else{jb=oa;kb=qa;lb=ra;mb=pa}c[kb>>2]=sa;eb=jb;fb=kb+4|0;gb=lb;hb=mb}if((c[B>>2]|0)>0){da=c[h>>2]|0;do{if((da|0)==0){nb=0}else{if((c[da+12>>2]|0)!=(c[da+16>>2]|0)){nb=da;break}if((oe[c[(c[da>>2]|0)+36>>2]&127](da)|0)==-1){c[h>>2]=0;nb=0;break}else{nb=c[h>>2]|0;break}}}while(0);da=(nb|0)==0;sa=c[e>>2]|0;do{if((sa|0)==0){X=223}else{if((c[sa+12>>2]|0)!=(c[sa+16>>2]|0)){if(da){ob=sa;break}else{X=229;break a}}if((oe[c[(c[sa>>2]|0)+36>>2]&127](sa)|0)==-1){c[e>>2]=0;X=223;break}else{if(da){ob=sa;break}else{X=229;break a}}}}while(0);if((X|0)==223){X=0;if(da){X=229;break a}else{ob=0}}sa=c[h>>2]|0;pa=c[sa+12>>2]|0;if((pa|0)==(c[sa+16>>2]|0)){pb=(oe[c[(c[sa>>2]|0)+36>>2]&127](sa)|0)&255}else{pb=a[pa]|0}if(!(pb<<24>>24==(a[u]|0))){X=229;break a}pa=c[h>>2]|0;sa=pa+12|0;ra=c[sa>>2]|0;if((ra|0)==(c[pa+16>>2]|0)){oe[c[(c[pa>>2]|0)+40>>2]&127](pa)|0;qb=ob;rb=ob;sb=ea}else{c[sa>>2]=ra+1;qb=ob;rb=ob;sb=ea}while(1){ra=c[h>>2]|0;do{if((ra|0)==0){tb=0}else{if((c[ra+12>>2]|0)!=(c[ra+16>>2]|0)){tb=ra;break}if((oe[c[(c[ra>>2]|0)+36>>2]&127](ra)|0)==-1){c[h>>2]=0;tb=0;break}else{tb=c[h>>2]|0;break}}}while(0);ra=(tb|0)==0;do{if((rb|0)==0){ub=qb;X=243}else{if((c[rb+12>>2]|0)!=(c[rb+16>>2]|0)){if(ra){vb=qb;wb=rb;break}else{X=250;break a}}if((oe[c[(c[rb>>2]|0)+36>>2]&127](rb)|0)==-1){c[e>>2]=0;ub=0;X=243;break}else{if(ra^(qb|0)==0){vb=qb;wb=qb;break}else{X=250;break a}}}}while(0);if((X|0)==243){X=0;if(ra){X=250;break a}else{vb=ub;wb=0}}sa=c[h>>2]|0;pa=c[sa+12>>2]|0;if((pa|0)==(c[sa+16>>2]|0)){xb=(oe[c[(c[sa>>2]|0)+36>>2]&127](sa)|0)&255}else{xb=a[pa]|0}if(!(xb<<24>>24>-1)){X=250;break a}if((b[(c[f>>2]|0)+(xb<<24>>24<<1)>>1]&2048)==0){X=250;break a}pa=c[o>>2]|0;if((pa|0)==(sb|0)){sa=(c[P>>2]|0)!=1278;qa=c[t>>2]|0;oa=sb-qa|0;ba=oa>>>0<2147483647?oa<<1:-1;W=Y_a(sa?qa:0,ba)|0;if((W|0)==0){X=253;break a}do{if(sa){c[t>>2]=W;yb=W}else{qa=c[t>>2]|0;c[t>>2]=W;if((qa|0)==0){yb=W;break}le[c[P>>2]&2047](qa);yb=c[t>>2]|0}}while(0);c[P>>2]=1253;W=yb+oa|0;c[o>>2]=W;zb=W;Ab=(c[t>>2]|0)+ba|0}else{zb=pa;Ab=sb}W=c[h>>2]|0;sa=c[W+12>>2]|0;if((sa|0)==(c[W+16>>2]|0)){ra=(oe[c[(c[W>>2]|0)+36>>2]&127](W)|0)&255;Bb=ra;Cb=c[o>>2]|0}else{Bb=a[sa]|0;Cb=zb}c[o>>2]=Cb+1;a[Cb]=Bb;sa=(c[B>>2]|0)+ -1|0;c[B>>2]=sa;ra=c[h>>2]|0;W=ra+12|0;qa=c[W>>2]|0;if((qa|0)==(c[ra+16>>2]|0)){oe[c[(c[ra>>2]|0)+40>>2]&127](ra)|0}else{c[W>>2]=qa+1}if((sa|0)>0){qb=vb;rb=wb;sb=Ab}else{Db=Ab;break}}}else{Db=ea}if((c[o>>2]|0)==(c[t>>2]|0)){X=267;break a}else{ga=Db;ha=eb;ia=fb;ja=gb;ka=S;la=hb}break};case 1:{if((p|0)==3){Z=R;_=r;$=S;aa=T;X=269;break a}da=c[h>>2]|0;sa=c[da+12>>2]|0;if((sa|0)==(c[da+16>>2]|0)){Eb=(oe[c[(c[da>>2]|0)+36>>2]&127](da)|0)&255}else{Eb=a[sa]|0}if(!(Eb<<24>>24>-1)){X=25;break a}if((b[(c[f>>2]|0)+(Eb<<24>>24<<1)>>1]&8192)==0){X=25;break a}sa=c[h>>2]|0;da=sa+12|0;qa=c[da>>2]|0;if((qa|0)==(c[sa+16>>2]|0)){Fb=(oe[c[(c[sa>>2]|0)+40>>2]&127](sa)|0)&255}else{c[da>>2]=qa+1;Fb=a[qa]|0}gRa(A,Fb);X=26;break};case 2:{if(!((S|0)!=0|p>>>0<2)){if((p|0)==2){Gb=(a[O]|0)!=0}else{Gb=0}if(!(I|Gb)){ga=D;ha=R;ia=r;ja=Q;ka=0;la=T;break b}}qa=a[x]|0;da=(qa&1)==0;sa=da?j:c[J>>2]|0;d:do{if((p|0)==0){Hb=Y;Ib=Y;Jb=qa;Kb=sa}else{if((d[s+(p+ -1)|0]|0)>=2){Hb=Y;Ib=Y;Jb=qa;Kb=sa;break}W=sa+(da?(qa&255)>>>1:c[K>>2]|0)|0;ra=sa;while(1){if((ra|0)==(W|0)){Lb=W;break}Ia=a[ra]|0;if(!(Ia<<24>>24>-1)){Lb=ra;break}if((b[(c[f>>2]|0)+(Ia<<24>>24<<1)>>1]&8192)==0){Lb=ra;break}else{ra=ra+1|0}}ra=Lb-sa|0;W=a[A]|0;pa=(W&1)==0;if(pa){Mb=(W&255)>>>1}else{Mb=c[N>>2]|0}if(ra>>>0>Mb>>>0){Hb=Y;Ib=Y;Jb=qa;Kb=sa;break}if(pa){pa=(W&255)>>>1;Nb=A+1+(pa-ra)|0;Ob=L;Pb=pa}else{pa=c[M>>2]|0;W=c[N>>2]|0;Nb=pa+(W-ra)|0;Ob=pa;Pb=W}W=Ob+Pb|0;if((Nb|0)==(W|0)){Hb=Y;Ib=Y;Jb=qa;Kb=Lb;break}else{Qb=sa;Rb=Nb}while(1){if((a[Rb]|0)!=(a[Qb]|0)){Hb=Y;Ib=Y;Jb=qa;Kb=sa;break d}pa=Rb+1|0;if((pa|0)==(W|0)){Hb=Y;Ib=Y;Jb=qa;Kb=Lb;break}else{Qb=Qb+1|0;Rb=pa}}}}while(0);e:while(1){if((Jb&1)==0){Sb=j;Tb=(Jb&255)>>>1}else{Sb=c[J>>2]|0;Tb=c[K>>2]|0}if((Kb|0)==(Sb+Tb|0)){break}qa=c[h>>2]|0;do{if((qa|0)==0){Ub=0}else{if((c[qa+12>>2]|0)!=(c[qa+16>>2]|0)){Ub=qa;break}if((oe[c[(c[qa>>2]|0)+36>>2]&127](qa)|0)==-1){c[h>>2]=0;Ub=0;break}else{Ub=c[h>>2]|0;break}}}while(0);qa=(Ub|0)==0;do{if((Ib|0)==0){Vb=Hb;X=147}else{if((c[Ib+12>>2]|0)!=(c[Ib+16>>2]|0)){if(qa){Wb=Hb;Xb=Ib;break}else{break e}}if((oe[c[(c[Ib>>2]|0)+36>>2]&127](Ib)|0)==-1){c[e>>2]=0;Vb=0;X=147;break}else{if(qa^(Hb|0)==0){Wb=Hb;Xb=Hb;break}else{break e}}}}while(0);if((X|0)==147){X=0;if(qa){break}else{Wb=Vb;Xb=0}}sa=c[h>>2]|0;da=c[sa+12>>2]|0;if((da|0)==(c[sa+16>>2]|0)){Yb=(oe[c[(c[sa>>2]|0)+36>>2]&127](sa)|0)&255}else{Yb=a[da]|0}if(!(Yb<<24>>24==(a[Kb]|0))){break}da=c[h>>2]|0;sa=da+12|0;ea=c[sa>>2]|0;if((ea|0)==(c[da+16>>2]|0)){oe[c[(c[da>>2]|0)+40>>2]&127](da)|0}else{c[sa>>2]=ea+1}Hb=Wb;Ib=Xb;Jb=a[x]|0;Kb=Kb+1|0}if(!I){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break b}ea=a[x]|0;if((ea&1)==0){Zb=j;_b=(ea&255)>>>1}else{Zb=c[J>>2]|0;_b=c[K>>2]|0}if((Kb|0)==(Zb+_b|0)){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T}else{X=162;break a}break};case 0:{X=26;break};default:{ga=D;ha=R;ia=r;ja=Q;ka=S;la=T}}}while(0);f:do{if((X|0)==26){X=0;if((p|0)==3){Z=R;_=r;$=S;aa=T;X=269;break a}else{$b=Y;ac=Y}while(1){U=c[h>>2]|0;do{if((U|0)==0){bc=0}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){bc=U;break}if((oe[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[h>>2]=0;bc=0;break}else{bc=c[h>>2]|0;break}}}while(0);U=(bc|0)==0;do{if((ac|0)==0){cc=$b;X=37}else{if((c[ac+12>>2]|0)!=(c[ac+16>>2]|0)){if(U){dc=$b;ec=ac;break}else{ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break f}}if((oe[c[(c[ac>>2]|0)+36>>2]&127](ac)|0)==-1){c[e>>2]=0;cc=0;X=37;break}else{if(U^($b|0)==0){dc=$b;ec=$b;break}else{ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break f}}}}while(0);if((X|0)==37){X=0;if(U){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break f}else{dc=cc;ec=0}}qa=c[h>>2]|0;ea=c[qa+12>>2]|0;if((ea|0)==(c[qa+16>>2]|0)){fc=(oe[c[(c[qa>>2]|0)+36>>2]&127](qa)|0)&255}else{fc=a[ea]|0}if(!(fc<<24>>24>-1)){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break f}if((b[(c[f>>2]|0)+(fc<<24>>24<<1)>>1]&8192)==0){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break f}ea=c[h>>2]|0;qa=ea+12|0;sa=c[qa>>2]|0;if((sa|0)==(c[ea+16>>2]|0)){gc=(oe[c[(c[ea>>2]|0)+40>>2]&127](ea)|0)&255}else{c[qa>>2]=sa+1;gc=a[sa]|0}gRa(A,gc);$b=dc;ac=ec}}}while(0);sa=p+1|0;if(sa>>>0<4){Q=ja;r=ia;R=ha;D=ga;p=sa;S=ka;T=la}else{Z=ha;_=ia;$=ka;aa=la;X=269;break}}g:do{if((X|0)==25){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==112){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==162){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==182){g$a()}else if((X|0)==198){g$a()}else if((X|0)==209){g$a()}else if((X|0)==229){c[k>>2]=c[k>>2]|4;hc=0;ic=eb;jc=hb}else if((X|0)==250){c[k>>2]=c[k>>2]|4;hc=0;ic=eb;jc=hb}else if((X|0)==253){g$a()}else if((X|0)==267){c[k>>2]=c[k>>2]|4;hc=0;ic=eb;jc=hb}else if((X|0)==269){h:do{if(($|0)!=0){la=$+1|0;ka=$+8|0;ia=$+4|0;ha=1;i:while(1){S=a[$]|0;if((S&1)==0){kc=(S&255)>>>1}else{kc=c[ia>>2]|0}if(!(ha>>>0<kc>>>0)){break h}S=c[h>>2]|0;do{if((S|0)==0){lc=0}else{if((c[S+12>>2]|0)!=(c[S+16>>2]|0)){lc=S;break}if((oe[c[(c[S>>2]|0)+36>>2]&127](S)|0)==-1){c[h>>2]=0;lc=0;break}else{lc=c[h>>2]|0;break}}}while(0);S=(lc|0)==0;U=c[e>>2]|0;do{if((U|0)==0){X=285}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){if(S){break}else{break i}}if((oe[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[e>>2]=0;X=285;break}else{if(S){break}else{break i}}}}while(0);if((X|0)==285){X=0;if(S){break}}U=c[h>>2]|0;p=c[U+12>>2]|0;if((p|0)==(c[U+16>>2]|0)){mc=(oe[c[(c[U>>2]|0)+36>>2]&127](U)|0)&255}else{mc=a[p]|0}if((a[$]&1)==0){nc=la}else{nc=c[ka>>2]|0}if(!(mc<<24>>24==(a[nc+ha|0]|0))){break}p=ha+1|0;U=c[h>>2]|0;ga=U+12|0;D=c[ga>>2]|0;if((D|0)==(c[U+16>>2]|0)){oe[c[(c[U>>2]|0)+40>>2]&127](U)|0;ha=p;continue}else{c[ga>>2]=D+1;ha=p;continue}}c[k>>2]=c[k>>2]|4;hc=0;ic=Z;jc=aa;break g}}while(0);if((Z|0)==(_|0)){hc=1;ic=_;jc=aa;break}c[C>>2]=0;MWa(w,Z,_,C);if((c[C>>2]|0)==0){hc=1;ic=Z;jc=aa;break}c[k>>2]=c[k>>2]|4;hc=0;ic=Z;jc=aa}}while(0);QQa(A);QQa(z);QQa(y);QQa(x);QQa(w);if((ic|0)==0){i=q;return hc|0}le[jc&2047](ic);i=q;return hc|0}function IWa(a){a=a|0;var b=0;b=Hc(8)|0;mQa(b,a);Zd(b|0,277440,43)}function JWa(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=i;i=i+168|0;l=d;m=d+8|0;n=d+24|0;o=d+128|0;p=d+136|0;q=d+144|0;r=d+152|0;s=d+160|0;t=o;c[t>>2]=n;u=o+4|0;c[u>>2]=1278;v=n+100|0;MRa(q,h);n=q;w=c[n>>2]|0;if(!((c[70112]|0)==-1)){c[m>>2]=280448;c[m+4>>2]=1276;c[m+8>>2]=0;BQa(280448,m,1277)}m=(c[280452>>2]|0)+ -1|0;x=c[w+8>>2]|0;if(!((c[w+12>>2]|0)-x>>2>>>0>m>>>0)){y=Hc(4)|0;z=y;A_a(z);A=296008;B=128;Zd(y|0,A|0,B|0)}w=c[x+(m<<2)>>2]|0;if((w|0)==0){y=Hc(4)|0;z=y;A_a(z);A=296008;B=128;Zd(y|0,A|0,B|0)}B=w;a[r]=0;A=f;f=c[A>>2]|0;c[s>>2]=f;y=c[h+4>>2]|0;h=l;z=s;c[h+0>>2]=c[z+0>>2];z=HWa(e,l,g,q,y,j,r,B,o,p,v)|0;if(z){if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}if((a[r]|0)!=0){gRa(k,De[c[(c[w>>2]|0)+28>>2]&63](B,45)|0)}r=De[c[(c[w>>2]|0)+28>>2]&63](B,48)|0;B=c[t>>2]|0;w=c[p>>2]|0;p=w+ -1|0;a:do{if(B>>>0<p>>>0){z=B;while(1){v=z+1|0;if(!((a[z]|0)==r<<24>>24)){C=z;break a}if(v>>>0<p>>>0){z=v}else{C=v;break}}}else{C=B}}while(0);KWa(k,C,w)|0}w=e;e=c[w>>2]|0;do{if((e|0)==0){D=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){D=e;break}if(!((oe[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){D=e;break}c[w>>2]=0;D=0}}while(0);w=(D|0)==0;do{if((f|0)==0){E=25}else{if((c[f+12>>2]|0)!=(c[f+16>>2]|0)){if(w){break}else{E=27;break}}if((oe[c[(c[f>>2]|0)+36>>2]&127](f)|0)==-1){c[A>>2]=0;E=25;break}else{if(w^(f|0)==0){break}else{E=27;break}}}}while(0);if((E|0)==25){if(w){E=27}}if((E|0)==27){c[j>>2]=c[j>>2]|2}c[b>>2]=D;gQa(c[n>>2]|0)|0;n=c[t>>2]|0;c[t>>2]=0;if((n|0)==0){i=d;return}le[c[u>>2]&2047](n);i=d;return}function KWa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=d;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1;k=h;l=10}else{h=c[b>>2]|0;j=c[b+4>>2]|0;k=h&255;l=(h&-2)+ -1|0}h=e-g|0;if((e|0)==(d|0)){i=f;return b|0}if((l-j|0)>>>0<h>>>0){jRa(b,l,j+h-l|0,j,j,0,0);m=a[b]|0}else{m=k}if((m&1)==0){n=b+1|0}else{n=c[b+8>>2]|0}m=e+(j-g)|0;g=d;d=n+j|0;while(1){a[d]=a[g]|0;k=g+1|0;if((k|0)==(e|0)){break}else{d=d+1|0;g=k}}a[n+m|0]=0;m=j+h|0;if((a[b]&1)==0){a[b]=m<<1;i=f;return b|0}else{c[b+4>>2]=m;i=f;return b|0}return 0}function LWa(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;n=i;i=i+176|0;o=n;p=n+16|0;q=n+32|0;r=n+40|0;s=n+56|0;t=n+72|0;u=n+88|0;v=n+104|0;w=n+112|0;x=n+128|0;y=n+144|0;z=n+160|0;if(b){b=c[d>>2]|0;if(!((c[69972]|0)==-1)){c[p>>2]=279888;c[p+4>>2]=1276;c[p+8>>2]=0;BQa(279888,p,1277)}p=(c[279892>>2]|0)+ -1|0;A=c[b+8>>2]|0;if(!((c[b+12>>2]|0)-A>>2>>>0>p>>>0)){B=Hc(4)|0;C=B;A_a(C);D=296008;E=128;Zd(B|0,D|0,E|0)}b=c[A+(p<<2)>>2]|0;if((b|0)==0){B=Hc(4)|0;C=B;A_a(C);D=296008;E=128;Zd(B|0,D|0,E|0)}E=b;me[c[(c[b>>2]|0)+44>>2]&127](q,E);D=e;B=c[q>>2]|0;a[D]=B;a[D+1|0]=B>>8;a[D+2|0]=B>>16;a[D+3|0]=B>>24;me[c[(c[b>>2]|0)+32>>2]&127](r,E);B=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}aRa(l,0);D=r;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;QQa(r);me[c[(c[b>>2]|0)+28>>2]&127](s,E);r=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}aRa(k,0);D=s;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;QQa(s);a[f]=oe[c[(c[b>>2]|0)+12>>2]&127](E)|0;a[g]=oe[c[(c[b>>2]|0)+16>>2]&127](E)|0;me[c[(c[b>>2]|0)+20>>2]&127](t,E);s=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}aRa(h,0);D=t;c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;QQa(t);me[c[(c[b>>2]|0)+24>>2]&127](u,E);t=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}aRa(j,0);D=u;c[t+0>>2]=c[D+0>>2];c[t+4>>2]=c[D+4>>2];c[t+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;QQa(u);F=oe[c[(c[b>>2]|0)+36>>2]&127](E)|0;c[m>>2]=F;i=n;return}else{E=c[d>>2]|0;if(!((c[69956]|0)==-1)){c[o>>2]=279824;c[o+4>>2]=1276;c[o+8>>2]=0;BQa(279824,o,1277)}o=(c[279828>>2]|0)+ -1|0;d=c[E+8>>2]|0;if(!((c[E+12>>2]|0)-d>>2>>>0>o>>>0)){G=Hc(4)|0;H=G;A_a(H);I=296008;J=128;Zd(G|0,I|0,J|0)}E=c[d+(o<<2)>>2]|0;if((E|0)==0){G=Hc(4)|0;H=G;A_a(H);I=296008;J=128;Zd(G|0,I|0,J|0)}J=E;me[c[(c[E>>2]|0)+44>>2]&127](v,J);I=e;e=c[v>>2]|0;a[I]=e;a[I+1|0]=e>>8;a[I+2|0]=e>>16;a[I+3|0]=e>>24;me[c[(c[E>>2]|0)+32>>2]&127](w,J);e=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}aRa(l,0);l=w;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;QQa(w);me[c[(c[E>>2]|0)+28>>2]&127](x,J);w=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}aRa(k,0);k=x;c[w+0>>2]=c[k+0>>2];c[w+4>>2]=c[k+4>>2];c[w+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;QQa(x);a[f]=oe[c[(c[E>>2]|0)+12>>2]&127](J)|0;a[g]=oe[c[(c[E>>2]|0)+16>>2]&127](J)|0;me[c[(c[E>>2]|0)+20>>2]&127](y,J);g=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}aRa(h,0);h=y;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;QQa(y);me[c[(c[E>>2]|0)+24>>2]&127](z,J);y=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}aRa(j,0);j=z;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;QQa(z);F=oe[c[(c[E>>2]|0)+36>>2]&127](J)|0;c[m>>2]=F;i=n;return}}function MWa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1}else{j=c[b+4>>2]|0}if((j|0)==0){i=g;return}do{if((d|0)==(e|0)){k=h}else{j=e+ -4|0;if(j>>>0>d>>>0){l=d;m=j}else{k=h;break}do{j=c[l>>2]|0;c[l>>2]=c[m>>2];c[m>>2]=j;l=l+4|0;m=m+ -4|0;}while(l>>>0<m>>>0);k=a[b]|0}}while(0);if((k&1)==0){n=b+1|0;o=(k&255)>>>1}else{n=c[b+8>>2]|0;o=c[b+4>>2]|0}b=e+ -4|0;e=a[n]|0;k=e<<24>>24<1|e<<24>>24==127;a:do{if(b>>>0>d>>>0){m=n+o|0;l=e;h=n;j=d;p=k;while(1){if(!p){if((l<<24>>24|0)!=(c[j>>2]|0)){break}}q=(m-h|0)>1?h+1|0:h;r=j+4|0;s=a[q]|0;t=s<<24>>24<1|s<<24>>24==127;if(r>>>0<b>>>0){l=s;h=q;j=r;p=t}else{u=s;v=t;break a}}c[f>>2]=4;i=g;return}else{u=e;v=k}}while(0);if(v){i=g;return}v=c[b>>2]|0;if(!(u<<24>>24>>>0<v>>>0|(v|0)==0)){i=g;return}c[f>>2]=4;i=g;return}function NWa(a){a=a|0;var b=0;b=i;b$a(a);i=b;return}function OWa(a){a=a|0;i=i;return}function PWa(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+400|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+40|0;v=i;i=i+104|0;w=p;c[w>>2]=o;x=p+4|0;c[x>>2]=1278;y=o+400|0;MRa(r,h);o=r;z=c[o>>2]|0;if(!((c[70110]|0)==-1)){c[n>>2]=280440;c[n+4>>2]=1276;c[n+8>>2]=0;BQa(280440,n,1277)}n=(c[280444>>2]|0)+ -1|0;A=c[z+8>>2]|0;if(!((c[z+12>>2]|0)-A>>2>>>0>n>>>0)){B=Hc(4)|0;C=B;A_a(C);D=296008;E=128;Zd(B|0,D|0,E|0)}z=c[A+(n<<2)>>2]|0;if((z|0)==0){B=Hc(4)|0;C=B;A_a(C);D=296008;E=128;Zd(B|0,D|0,E|0)}E=z;a[s]=0;D=f;c[t>>2]=c[D>>2];f=c[h+4>>2]|0;h=l;B=t;c[h+0>>2]=c[B+0>>2];B=QWa(e,l,g,r,f,j,s,E,p,q,y)|0;do{if(B){y=u;Ne[c[(c[z>>2]|0)+48>>2]&63](E,280144,280154|0,y)|0;p=v;f=c[q>>2]|0;r=c[w>>2]|0;g=f-r|0;do{if((g|0)>392){l=V_a((g>>2)+2|0)|0;if((l|0)!=0){F=l;G=l;break}g$a()}else{F=0;G=p}}while(0);if((a[s]|0)==0){H=G}else{a[G]=45;H=G+1|0}if(r>>>0<f>>>0){g=u+40|0;l=u;h=H;t=r;while(1){C=c[t>>2]|0;n=y;while(1){A=n+4|0;if((c[n>>2]|0)==(C|0)){I=n;break}if((A|0)==(g|0)){I=g;break}else{n=A}}a[h]=a[280144+(I-l>>2)|0]|0;n=t+4|0;C=h+1|0;if(n>>>0<(c[q>>2]|0)>>>0){h=C;t=n}else{J=C;break}}}else{J=H}a[J]=0;c[m>>2]=k;if((Dd(p|0,280080,m|0)|0)!=1){t=Hc(8)|0;mQa(t,280088);Zd(t|0,277440,43)}if((F|0)==0){break}W_a(F)}}while(0);F=e;e=c[F>>2]|0;do{if((e|0)==0){K=1}else{m=c[e+12>>2]|0;if((m|0)==(c[e+16>>2]|0)){L=oe[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{L=c[m>>2]|0}if((L|0)==-1){c[F>>2]=0;K=1;break}else{K=(c[F>>2]|0)==0;break}}}while(0);L=c[D>>2]|0;do{if((L|0)==0){M=35}else{e=c[L+12>>2]|0;if((e|0)==(c[L+16>>2]|0)){N=oe[c[(c[L>>2]|0)+36>>2]&127](L)|0}else{N=c[e>>2]|0}if((N|0)==-1){c[D>>2]=0;M=35;break}else{if(K){break}else{M=37;break}}}}while(0);if((M|0)==35){if(K){M=37}}if((M|0)==37){c[j>>2]=c[j>>2]|2}c[b>>2]=c[F>>2];gQa(c[o>>2]|0)|0;o=c[w>>2]|0;c[w>>2]=0;if((o|0)==0){i=d;return}le[c[x>>2]&2047](o);i=d;return}



function KE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1512>>3];k=+h[g>>3];l=j*k;m=l*l;n=+h[g+672>>3]*l- +h[g+16>>3]*(j*+h[g+656>>3]+k*+h[g+9224>>3]);if(m!=0.0){o=g;p=n/m;q=o;r=q+9560|0;s=r;h[s>>3]=p;i=d;return}if(n==0.0){o=g;p=n;q=o;r=q+9560|0;s=r;h[s>>3]=p;i=d;return}k=n/+nwa(c[b+536>>2]|0,m,44008,44e3,+h[f>>3],(a[b+319|0]|0)!=0|0);o=c[(c[c[e>>2]>>2]|0)+8>>2]|0;p=k;q=o;r=q+9560|0;s=r;h[s>>3]=p;i=d;return}function LE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2704>>3]=+h[b+10432>>3]*+h[b+9560>>3];i=i;return}function ME(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8424>>3]=+h[b+9552>>3]+(-(+h[b+1512>>3]*+h[b+656>>3])- +h[b+9224>>3]*+h[b>>3]);i=i;return}function NE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g>>3]*+h[g+1512>>3];k=+h[g+16>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1528|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1528|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,44064,44056,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1528|0;p=o;h[p>>3]=m;i=d;return}function OE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2784>>3]=+h[b+10432>>3]*+h[b+1528>>3];i=i;return}function PE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8600>>3]=+h[b+2784>>3]*+h[b+8424>>3]+ +h[b+2704>>3]*+h[b+1520>>3];i=i;return}function QE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2664>>3]=+h[b+8>>3]*+h[b+2704>>3]+ +h[b+664>>3]*+h[b+2784>>3];i=i;return}function RE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2848>>3]=1.0- +h[b+32>>3];i=i;return}function SE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+8>>3];v=l;h[k>>3]=+h[t+2840>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];gxa(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+16>>3];w=+h[t>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];vz(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Bz(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+32>>3];f=j;h[k>>3]=+h[q+2848>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];gxa(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+40>>3];y=+h[f+24>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];vz(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Bz(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+2120>>3]=(+h[d+1024>>3]+ +h[d+1032>>3])*(w- +h[r>>3])*+h[d+2216>>3]*.5;i=b;return}function TE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+32>>3];p=f;h[k>>3]=+h[n+2848>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+40>>3];q=+h[p+24>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2312>>3]=+h[l>>3];i=b;return}function UE(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;iA(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+24>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+1560>>3]=+yd(+(+h[d>>3]),+(+h[a+40>>3]*.999));i=b;return}function VE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1560>>3];k=+zd(1.0e-13,+(+h[g+40>>3]-j));l=+h[g+2848>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+nwa(c[b+536>>2]|0,k,44112,44104,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+1576>>3]=+yd(+(j*n*.6219647130774989),1.0);i=d;return}function WE(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1592>>3]=+zd(+(+h[d+32>>3]- +h[d+1576>>3]),0.0);i=b;return}function XE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1584>>3]=+h[b+32>>3]- +h[b+1592>>3];i=i;return}function YE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1592>>3];k=1.0-j;l=+h[g+2848>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+nwa(c[b+536>>2]|0,k,44184,44176,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+1592>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+1584>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+1624|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+1624|0;z=y;h[z>>3]=w;i=d;return}l=m/+nwa(c[b+536>>2]|0,p,44184,44176,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+1624|0;z=y;h[z>>3]=w;i=d;return}function ZE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1632>>3]=+h[b+1648>>3]- +h[b+1624>>3]*+h[b+24>>3];i=i;return}function _E(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+24>>3]*+h[g+1624>>3];k=+h[g+40>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1640|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1640|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,44224,44216,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1640|0;p=o;h[p>>3]=m;i=d;return}function $E(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2776>>3]=+h[b+10424>>3]*+h[b+1640>>3];i=i;return}function aF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1560>>3];k=+zd(1.0e-13,+(+h[g+40>>3]-j));l=+h[g+2848>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+nwa(c[b+536>>2]|0,k,44112,44264,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8416|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=Cza(1.0e-13,+h[f+40>>3]- +h[f+1560>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+1560>>3];j=+h[x+40>>3];k=+zd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+9112>>3];k=+h[x+2848>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+696>>3]- +h[x+9216>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+696>>3]- +h[x+9216>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+696>>3]- +h[x+9216>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+696>>3]- +h[x+9216>>3]}K=(y-k*J)/+nwa(c[b+536>>2]|0,l,44272,44264,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+2848>>3];C=+h[L+1560>>3];D=+h[L+40>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+9216>>3];m=+zd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+nwa(c[b+536>>2]|0,m,44112,44264,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8416|0;w=v;h[w>>3]=n;i=d;return}function bF(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(Cza(+h[a+32>>3]- +h[a+1576>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+9208|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+688>>3]- +h[a+8416>>3];g=a;j=g+9208|0;k=j;h[k>>3]=f;i=b;return}function cF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8408>>3]=+h[b+688>>3]- +h[b+9208>>3];i=i;return}function dF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1592>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+9208>>3];o=+h[g+9112>>3]*k+ +h[g+2848>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+nwa(c[b+536>>2]|0,l,44408,44400,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+9208>>3];q=+h[v+1592>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+8408>>3]*(1.0-q)+ +h[r+1584>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+9200|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+9200|0;C=B;h[C>>3]=z;i=d;return}p=t/+nwa(c[b+536>>2]|0,l,44408,44400,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+9200|0;C=B;h[C>>3]=z;i=d;return}function eF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1624>>3];k=+h[g+24>>3];l=j*k;m=l*l;n=+h[g+696>>3]*l- +h[g+40>>3]*(j*+h[g+680>>3]+k*+h[g+9200>>3]);if(m!=0.0){o=g;p=n/m;q=o;r=q+9544|0;s=r;h[s>>3]=p;i=d;return}if(n==0.0){o=g;p=n;q=o;r=q+9544|0;s=r;h[s>>3]=p;i=d;return}k=n/+nwa(c[b+536>>2]|0,m,44456,44448,+h[f>>3],(a[b+319|0]|0)!=0|0);o=c[(c[c[e>>2]>>2]|0)+8>>2]|0;p=k;q=o;r=q+9544|0;s=r;h[s>>3]=p;i=d;return}function fF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2696>>3]=+h[b+10424>>3]*+h[b+9544>>3];i=i;return}function gF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2656>>3]=+h[b+32>>3]*+h[b+2696>>3]+ +h[b+688>>3]*+h[b+2776>>3];i=i;return}function hF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8400>>3]=+h[b+9536>>3]+(-(+h[b+1624>>3]*+h[b+680>>3])- +h[b+9200>>3]*+h[b+24>>3]);i=i;return}function iF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8592>>3]=+h[b+2776>>3]*+h[b+8400>>3]+ +h[b+2696>>3]*+h[b+1632>>3];i=i;return}function jF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+32>>3];p=f;h[k>>3]=+h[n+2848>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+40>>3];q=+h[p+24>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2416>>3]=+h[l>>3];i=b;return}function kF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;gxa(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+56>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+64>>3];l=+h[a+48>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];tA(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1760>>3]=+h[f>>3];i=b;return}function lF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2856>>3]=1.0- +h[b+56>>3];i=i;return}function mF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+32>>3];v=l;h[k>>3]=+h[t+2848>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];gxa(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+40>>3];w=+h[t+24>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];vz(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Bz(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+56>>3];f=j;h[k>>3]=+h[q+2856>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];gxa(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+64>>3];y=+h[f+48>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];vz(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Bz(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+2112>>3]=(+h[d+1016>>3]+ +h[d+1024>>3])*(w- +h[r>>3])*+h[d+2216>>3]*.5;i=b;return}function nF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+56>>3];v=l;h[k>>3]=+h[t+2856>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];gxa(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+64>>3];w=+h[t+48>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];vz(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Bz(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+80>>3];f=j;h[k>>3]=+h[q+2864>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];gxa(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+88>>3];y=+h[f+72>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];vz(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Bz(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+2104>>3]=(+h[d+1008>>3]+ +h[d+1016>>3])*(w- +h[r>>3])*+h[d+2216>>3]*.5;i=b;return}function oF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+56>>3];p=f;h[k>>3]=+h[n+2856>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+64>>3];q=+h[p+48>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2304>>3]=+h[l>>3];i=b;return}function pF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+56>>3];p=f;h[k>>3]=+h[n+2856>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+64>>3];q=+h[p+48>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2408>>3]=+h[l>>3];i=b;return}function qF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1672>>3];k=+zd(1.0e-13,+(+h[g+64>>3]-j));l=+h[g+2856>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+nwa(c[b+536>>2]|0,k,44512,44504,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8392|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=Cza(1.0e-13,+h[f+64>>3]- +h[f+1672>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+1672>>3];j=+h[x+64>>3];k=+zd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+9104>>3];k=+h[x+2856>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+720>>3]- +h[x+9192>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+720>>3]- +h[x+9192>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+720>>3]- +h[x+9192>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+720>>3]- +h[x+9192>>3]}K=(y-k*J)/+nwa(c[b+536>>2]|0,l,44576,44504,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+2856>>3];C=+h[L+1672>>3];D=+h[L+64>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+9192>>3];m=+zd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+nwa(c[b+536>>2]|0,m,44512,44504,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8392|0;w=v;h[w>>3]=n;i=d;return}function rF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1672>>3];k=+zd(1.0e-13,+(+h[g+64>>3]-j));l=+h[g+2856>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+nwa(c[b+536>>2]|0,k,44512,44704,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+1688>>3]=+yd(+(j*n*.6219647130774989),1.0);i=d;return}function sF(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(Cza(+h[a+56>>3]- +h[a+1688>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+9184|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+712>>3]- +h[a+8392>>3];g=a;j=g+9184|0;k=j;h[k>>3]=f;i=b;return}function tF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8384>>3]=+h[b+712>>3]- +h[b+9184>>3];i=i;return}function uF(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1704>>3]=+zd(+(+h[d+56>>3]- +h[d+1688>>3]),0.0);i=b;return}function vF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1696>>3]=+h[b+56>>3]- +h[b+1704>>3];i=i;return}function wF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1704>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+9184>>3];o=+h[g+9104>>3]*k+ +h[g+2856>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+nwa(c[b+536>>2]|0,l,44720,44712,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+9184>>3];q=+h[v+1704>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+8384>>3]*(1.0-q)+ +h[r+1696>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+9176|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+9176|0;C=B;h[C>>3]=z;i=d;return}p=t/+nwa(c[b+536>>2]|0,l,44720,44712,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+9176|0;C=B;h[C>>3]=z;i=d;return}function xF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1704>>3];k=1.0-j;l=+h[g+2856>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+nwa(c[b+536>>2]|0,k,44768,44760,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+1704>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+1696>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+1736|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+1736|0;z=y;h[z>>3]=w;i=d;return}l=m/+nwa(c[b+536>>2]|0,p,44768,44760,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+1736|0;z=y;h[z>>3]=w;i=d;return}function yF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1744>>3]=+h[b+1760>>3]- +h[b+1736>>3]*+h[b+48>>3];i=i;return}function zF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+48>>3]*+h[g+1736>>3];k=+h[g+64>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1752|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1752|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,44808,44800,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1752|0;p=o;h[p>>3]=m;i=d;return}function AF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2768>>3]=+h[b+10416>>3]*+h[b+1752>>3];i=i;return}function BF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1736>>3];k=+h[g+48>>3];l=j*k;m=l*l;n=+h[g+720>>3]*l- +h[g+64>>3]*(j*+h[g+704>>3]+k*+h[g+9176>>3]);if(m!=0.0){o=g;p=n/m;q=o;r=q+9528|0;s=r;h[s>>3]=p;i=d;return}if(n==0.0){o=g;p=n;q=o;r=q+9528|0;s=r;h[s>>3]=p;i=d;return}k=n/+nwa(c[b+536>>2]|0,m,44856,44848,+h[f>>3],(a[b+319|0]|0)!=0|0);o=c[(c[c[e>>2]>>2]|0)+8>>2]|0;p=k;q=o;r=q+9528|0;s=r;h[s>>3]=p;i=d;return}function CF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2688>>3]=+h[b+10416>>3]*+h[b+9528>>3];i=i;return}function DF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2648>>3]=+h[b+56>>3]*+h[b+2688>>3]+ +h[b+712>>3]*+h[b+2768>>3];i=i;return}function EF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8376>>3]=+h[b+9520>>3]+(-(+h[b+1736>>3]*+h[b+704>>3])- +h[b+9176>>3]*+h[b+48>>3]);i=i;return}function FF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8584>>3]=+h[b+2768>>3]*+h[b+8376>>3]+ +h[b+2688>>3]*+h[b+1744>>3];i=i;return}function GF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;gxa(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+80>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+88>>3];l=+h[a+72>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];tA(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1872>>3]=+h[f>>3];i=b;return}function HF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;iA(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+72>>3]);if((Aza(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+88>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+744>>3]*.999;l=j;m=l+9168|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;xA(e,c[f>>2]|0,+h[d+72>>3],+h[d+728>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+9168|0;n=m;h[n>>3]=k;i=b;return}}function IF(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;iA(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+72>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+1784>>3]=+yd(+(+h[d>>3]),+(+h[a+88>>3]*.999));i=b;return}function JF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1784>>3];k=+zd(1.0e-13,+(+h[g+88>>3]-j));l=+h[g+2864>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+nwa(c[b+536>>2]|0,k,44912,44904,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8368|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=Cza(1.0e-13,+h[f+88>>3]- +h[f+1784>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+1784>>3];j=+h[x+88>>3];k=+zd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+9096>>3];k=+h[x+2864>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+744>>3]- +h[x+9168>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+744>>3]- +h[x+9168>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+744>>3]- +h[x+9168>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+744>>3]- +h[x+9168>>3]}K=(y-k*J)/+nwa(c[b+536>>2]|0,l,44976,44904,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+2864>>3];C=+h[L+1784>>3];D=+h[L+88>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+9168>>3];m=+zd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+nwa(c[b+536>>2]|0,m,44912,44904,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8368|0;w=v;h[w>>3]=n;i=d;return}function KF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1784>>3];k=+zd(1.0e-13,+(+h[g+88>>3]-j));l=+h[g+2864>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+nwa(c[b+536>>2]|0,k,44912,45104,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+1800>>3]=+yd(+(j*n*.6219647130774989),1.0);i=d;return}function LF(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(Cza(+h[a+80>>3]- +h[a+1800>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+9160|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+736>>3]- +h[a+8368>>3];g=a;j=g+9160|0;k=j;h[k>>3]=f;i=b;return}function MF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8360>>3]=+h[b+736>>3]- +h[b+9160>>3];i=i;return}function NF(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1816>>3]=+zd(+(+h[d+80>>3]- +h[d+1800>>3]),0.0);i=b;return}function OF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1808>>3]=+h[b+80>>3]- +h[b+1816>>3];i=i;return}function PF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1816>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+9160>>3];o=+h[g+9096>>3]*k+ +h[g+2864>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+nwa(c[b+536>>2]|0,l,45120,45112,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+9160>>3];q=+h[v+1816>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+8360>>3]*(1.0-q)+ +h[r+1808>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+9152|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+9152|0;C=B;h[C>>3]=z;i=d;return}p=t/+nwa(c[b+536>>2]|0,l,45120,45112,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+9152|0;C=B;h[C>>3]=z;i=d;return}function QF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1816>>3];k=1.0-j;l=+h[g+2864>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+nwa(c[b+536>>2]|0,k,45168,45160,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+1816>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+1808>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+1848|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+1848|0;z=y;h[z>>3]=w;i=d;return}l=m/+nwa(c[b+536>>2]|0,p,45168,45160,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+1848|0;z=y;h[z>>3]=w;i=d;return}function RF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1848>>3];k=+h[g+72>>3];l=j*k;m=l*l;n=+h[g+744>>3]*l- +h[g+88>>3]*(j*+h[g+728>>3]+k*+h[g+9152>>3]);if(m!=0.0){o=g;p=n/m;q=o;r=q+9512|0;s=r;h[s>>3]=p;i=d;return}if(n==0.0){o=g;p=n;q=o;r=q+9512|0;s=r;h[s>>3]=p;i=d;return}k=n/+nwa(c[b+536>>2]|0,m,45208,45200,+h[f>>3],(a[b+319|0]|0)!=0|0);o=c[(c[c[e>>2]>>2]|0)+8>>2]|0;p=k;q=o;r=q+9512|0;s=r;h[s>>3]=p;i=d;return}function SF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2680>>3]=+h[b+10408>>3]*+h[b+9512>>3];i=i;return}function TF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8352>>3]=+h[b+9504>>3]+(-(+h[b+1848>>3]*+h[b+728>>3])- +h[b+9152>>3]*+h[b+72>>3]);i=i;return}function UF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+72>>3]*+h[g+1848>>3];k=+h[g+88>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1864|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1864|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,45264,45256,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1864|0;p=o;h[p>>3]=m;i=d;return}function VF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2760>>3]=+h[b+10408>>3]*+h[b+1864>>3];i=i;return}function WF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2640>>3]=+h[b+80>>3]*+h[b+2680>>3]+ +h[b+736>>3]*+h[b+2760>>3];i=i;return}function XF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1856>>3]=+h[b+1872>>3]- +h[b+1848>>3]*+h[b+72>>3];i=i;return}function YF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8576>>3]=+h[b+2760>>3]*+h[b+8352>>3]+ +h[b+2680>>3]*+h[b+1856>>3];i=i;return}function ZF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2872>>3]=1.0- +h[b+104>>3];i=i;return}function _F(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+80>>3];v=l;h[k>>3]=+h[t+2864>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];gxa(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+88>>3];w=+h[t+72>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];vz(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Bz(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+104>>3];f=j;h[k>>3]=+h[q+2872>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];gxa(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+112>>3];y=+h[f+96>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];vz(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Bz(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+2096>>3]=(+h[d+1e3>>3]+ +h[d+1008>>3])*(w- +h[r>>3])*+h[d+2216>>3]*.5;i=b;return}function $F(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+104>>3];p=f;h[k>>3]=+h[n+2872>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+112>>3];q=+h[p+96>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2392>>3]=+h[l>>3];i=b;return}function aG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+104>>3];p=f;h[k>>3]=+h[n+2872>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+112>>3];q=+h[p+96>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2288>>3]=+h[l>>3];i=b;return}function bG(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;iA(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+96>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+1896>>3]=+yd(+(+h[d>>3]),+(+h[a+112>>3]*.999));i=b;return}function cG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1896>>3];k=+zd(1.0e-13,+(+h[g+112>>3]-j));l=+h[g+2872>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+nwa(c[b+536>>2]|0,k,45312,45304,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+1912>>3]=+yd(+(j*n*.6219647130774989),1.0);i=d;return}function dG(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1928>>3]=+zd(+(+h[d+104>>3]- +h[d+1912>>3]),0.0);i=b;return}function eG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1920>>3]=+h[b+104>>3]- +h[b+1928>>3];i=i;return}function fG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1928>>3];k=1.0-j;l=+h[g+2872>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+nwa(c[b+536>>2]|0,k,45384,45376,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+1928>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+1920>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+1960|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+1960|0;z=y;h[z>>3]=w;i=d;return}l=m/+nwa(c[b+536>>2]|0,p,45384,45376,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+1960|0;z=y;h[z>>3]=w;i=d;return}function gG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+96>>3]*+h[g+1960>>3];k=+h[g+112>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1976|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1976|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,45424,45416,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1976|0;p=o;h[p>>3]=m;i=d;return}function hG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2752>>3]=+h[b+10400>>3]*+h[b+1976>>3];i=i;return}function iG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1896>>3];k=+zd(1.0e-13,+(+h[g+112>>3]-j));l=+h[g+2872>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+nwa(c[b+536>>2]|0,k,45312,45464,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8344|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=Cza(1.0e-13,+h[f+112>>3]- +h[f+1896>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+1896>>3];j=+h[x+112>>3];k=+zd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+9088>>3];k=+h[x+2872>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+768>>3]- +h[x+9144>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+768>>3]- +h[x+9144>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+768>>3]- +h[x+9144>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+768>>3]- +h[x+9144>>3]}K=(y-k*J)/+nwa(c[b+536>>2]|0,l,45472,45464,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+2872>>3];C=+h[L+1896>>3];D=+h[L+112>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+9144>>3];m=+zd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+nwa(c[b+536>>2]|0,m,45312,45464,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8344|0;w=v;h[w>>3]=n;i=d;return}function jG(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(Cza(+h[a+104>>3]- +h[a+1912>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+9136|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+760>>3]- +h[a+8344>>3];g=a;j=g+9136|0;k=j;h[k>>3]=f;i=b;return}function kG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8336>>3]=+h[b+760>>3]- +h[b+9136>>3];i=i;return}function lG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1928>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+9136>>3];o=+h[g+9088>>3]*k+ +h[g+2872>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+nwa(c[b+536>>2]|0,l,45608,45600,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+9136>>3];q=+h[v+1928>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+8336>>3]*(1.0-q)+ +h[r+1920>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+9128|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+9128|0;C=B;h[C>>3]=z;i=d;return}p=t/+nwa(c[b+536>>2]|0,l,45608,45600,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+9128|0;C=B;h[C>>3]=z;i=d;return}function mG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8328>>3]=+h[b+9488>>3]+(-(+h[b+1960>>3]*+h[b+752>>3])- +h[b+9128>>3]*+h[b+96>>3]);i=i;return}function nG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1960>>3];k=+h[g+96>>3];l=j*k;m=l*l;n=+h[g+768>>3]*l- +h[g+112>>3]*(j*+h[g+752>>3]+k*+h[g+9128>>3]);if(m!=0.0){o=g;p=n/m;q=o;r=q+9496|0;s=r;h[s>>3]=p;i=d;return}if(n==0.0){o=g;p=n;q=o;r=q+9496|0;s=r;h[s>>3]=p;i=d;return}k=n/+nwa(c[b+536>>2]|0,m,45656,45648,+h[f>>3],(a[b+319|0]|0)!=0|0);o=c[(c[c[e>>2]>>2]|0)+8>>2]|0;p=k;q=o;r=q+9496|0;s=r;h[s>>3]=p;i=d;return}function oG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2672>>3]=+h[b+10400>>3]*+h[b+9496>>3];i=i;return}function pG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2632>>3]=+h[b+104>>3]*+h[b+2672>>3]+ +h[b+760>>3]*+h[b+2752>>3];i=i;return}function qG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;gxa(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+104>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+112>>3];l=+h[a+96>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];tA(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1984>>3]=+h[f>>3];i=b;return}function rG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1968>>3]=+h[b+1984>>3]- +h[b+1960>>3]*+h[b+96>>3];i=i;return}function sG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8568>>3]=+h[b+2752>>3]*+h[b+8328>>3]+ +h[b+2672>>3]*+h[b+1968>>3];i=i;return}function tG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4408>>3]=1.0- +h[b+176>>3];i=i;return}function uG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+176>>3];p=f;h[k>>3]=+h[n+4408>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+184>>3];q=+h[p+168>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+3872>>3]=+h[l>>3];i=b;return}function vG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+176>>3];p=f;h[k>>3]=+h[n+4408>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+184>>3];q=+h[p+168>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+3976>>3]=+h[l>>3];i=b;return}function wG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;gxa(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+176>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+184>>3];l=+h[a+168>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];tA(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3088>>3]=+h[f>>3];i=b;return}function xG(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;iA(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+168>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+3e3>>3]=+yd(+(+h[d>>3]),+(+h[a+184>>3]*.999));i=b;return}function yG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3e3>>3];k=+zd(1.0e-13,+(+h[g+184>>3]-j));l=+h[g+4408>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+nwa(c[b+536>>2]|0,k,45712,45704,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+3016>>3]=+yd(+(j*n*.6219647130774989),1.0);i=d;return}function zG(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3032>>3]=+zd(+(+h[d+176>>3]- +h[d+3016>>3]),0.0);i=b;return}function AG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3024>>3]=+h[b+176>>3]- +h[b+3032>>3];i=i;return}function BG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3032>>3];k=1.0-j;l=+h[g+4408>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+nwa(c[b+536>>2]|0,k,45784,45776,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+3032>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+3024>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+3064|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+3064|0;z=y;h[z>>3]=w;i=d;return}l=m/+nwa(c[b+536>>2]|0,p,45784,45776,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+3064|0;z=y;h[z>>3]=w;i=d;return}function CG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+168>>3]*+h[g+3064>>3];k=+h[g+184>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+3080|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+3080|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,45824,45816,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+3080|0;p=o;h[p>>3]=m;i=d;return}function DG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4336>>3]=+h[b+10296>>3]*+h[b+3080>>3];i=i;return}function EG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3e3>>3];k=+zd(1.0e-13,+(+h[g+184>>3]-j));l=+h[g+4408>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+nwa(c[b+536>>2]|0,k,45712,45864,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8272|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=Cza(1.0e-13,+h[f+184>>3]- +h[f+3e3>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+3e3>>3];j=+h[x+184>>3];k=+zd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+8960>>3];k=+h[x+4408>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+840>>3]- +h[x+9080>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+840>>3]- +h[x+9080>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+840>>3]- +h[x+9080>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+840>>3]- +h[x+9080>>3]}K=(y-k*J)/+nwa(c[b+536>>2]|0,l,45872,45864,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+4408>>3];C=+h[L+3e3>>3];D=+h[L+184>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+9080>>3];m=+zd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+nwa(c[b+536>>2]|0,m,45712,45864,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8272|0;w=v;h[w>>3]=n;i=d;return}function FG(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(Cza(+h[a+176>>3]- +h[a+3016>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+9072|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+832>>3]- +h[a+8272>>3];g=a;j=g+9072|0;k=j;h[k>>3]=f;i=b;return}function GG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8264>>3]=+h[b+832>>3]- +h[b+9072>>3];i=i;return}function HG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3032>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+9072>>3];o=+h[g+8960>>3]*k+ +h[g+4408>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+nwa(c[b+536>>2]|0,l,46008,46e3,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+9072>>3];q=+h[v+3032>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+8264>>3]*(1.0-q)+ +h[r+3024>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+9064|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+9064|0;C=B;h[C>>3]=z;i=d;return}p=t/+nwa(c[b+536>>2]|0,l,46008,46e3,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+9064|0;C=B;h[C>>3]=z;i=d;return}function IG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8256>>3]=+h[b+9472>>3]+(-(+h[b+3064>>3]*+h[b+824>>3])- +h[b+9064>>3]*+h[b+168>>3]);i=i;return}function JG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3064>>3];k=+h[g+168>>3];l=j*k;m=l*l;n=+h[g+840>>3]*l- +h[g+184>>3]*(j*+h[g+824>>3]+k*+h[g+9064>>3]);if(m!=0.0){o=g;p=n/m;q=o;r=q+9480|0;s=r;h[s>>3]=p;i=d;return}if(n==0.0){o=g;p=n;q=o;r=q+9480|0;s=r;h[s>>3]=p;i=d;return}k=n/+nwa(c[b+536>>2]|0,m,46056,46048,+h[f>>3],(a[b+319|0]|0)!=0|0);o=c[(c[c[e>>2]>>2]|0)+8>>2]|0;p=k;q=o;r=q+9480|0;s=r;h[s>>3]=p;i=d;return}function KG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4256>>3]=+h[b+10296>>3]*+h[b+9480>>3];i=i;return}function LG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4216>>3]=+h[b+176>>3]*+h[b+4256>>3]+ +h[b+832>>3]*+h[b+4336>>3];i=i;return}function MG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+320>>3]=+h[b+4256>>3]+ +h[b+328>>3];i=i;return}function NG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+736>>3]*+h[j+3080>>3]*+h[e+1888>>3];l=+h[j+320>>3]+ +h[j+328>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+2976|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+2976|0;r=q;h[r>>3]=o;i=d;return}s=l/+nwa(c[b+536>>2]|0,k,46112,46104,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+2976|0;r=q;h[r>>3]=o;i=d;return}function OG(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+320>>3];h[b+4088>>3]=d*+h[(!(d>=0.0)?b+176|0:b+200|0)>>3];i=i;return}function PG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3072>>3]=+h[b+3088>>3]- +h[b+3064>>3]*+h[b+168>>3];i=i;return}function QG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8560>>3]=+h[b+4336>>3]*+h[b+8256>>3]+ +h[b+4256>>3]*+h[b+3072>>3];i=i;return}function RG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;gxa(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+200>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+208>>3];l=+h[a+192>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];tA(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3200>>3]=+h[f>>3];i=b;return}function SG(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+320>>3];h[b+4040>>3]=d*+h[(!(d>=0.0)?b+3088|0:b+3200|0)>>3];i=i;return}function TG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4416>>3]=1.0- +h[b+200>>3];i=i;return}function UG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+200>>3];v=l;h[k>>3]=+h[t+4416>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];gxa(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+208>>3];w=+h[t+192>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];vz(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Bz(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+224>>3];f=j;h[k>>3]=+h[q+4424>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];gxa(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+232>>3];y=+h[f+216>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];vz(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Bz(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+3664>>3]=(+h[d+720>>3]+ +h[d+728>>3])*(w- +h[r>>3])*+h[d+1992>>3]*.5;i=b;return}function VG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+176>>3];v=l;h[k>>3]=+h[t+4408>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];gxa(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+184>>3];w=+h[t+168>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];vz(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Bz(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+200>>3];f=j;h[k>>3]=+h[q+4416>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];gxa(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+208>>3];y=+h[f+192>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];vz(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Bz(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+3672>>3]=(+h[d+728>>3]+ +h[d+736>>3])*(w- +h[r>>3])*+h[d+1992>>3]*.5;i=b;return}function WG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+200>>3];p=f;h[k>>3]=+h[n+4416>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+208>>3];q=+h[p+192>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+3864>>3]=+h[l>>3];i=b;return}function XG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+200>>3];p=f;h[k>>3]=+h[n+4416>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+208>>3];q=+h[p+192>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+3968>>3]=+h[l>>3];i=b;return}function YG(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;iA(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+192>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+3112>>3]=+yd(+(+h[d>>3]),+(+h[a+208>>3]*.999));i=b;return}function ZG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3112>>3];k=+zd(1.0e-13,+(+h[g+208>>3]-j));l=+h[g+4416>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+nwa(c[b+536>>2]|0,k,46184,46176,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+3128>>3]=+yd(+(j*n*.6219647130774989),1.0);i=d;return}function _G(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3144>>3]=+zd(+(+h[d+200>>3]- +h[d+3128>>3]),0.0);i=b;return}function $G(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3136>>3]=+h[b+200>>3]- +h[b+3144>>3];i=i;return}function aH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3144>>3];k=1.0-j;l=+h[g+4416>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+nwa(c[b+536>>2]|0,k,46256,46248,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+3144>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+3136>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+3176|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+3176|0;z=y;h[z>>3]=w;i=d;return}l=m/+nwa(c[b+536>>2]|0,p,46256,46248,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+3176|0;z=y;h[z>>3]=w;i=d;return}function bH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+192>>3]*+h[g+3176>>3];k=+h[g+208>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+3192|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+3192|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,46296,46288,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+3192|0;p=o;h[p>>3]=m;i=d;return}function cH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4328>>3]=+h[b+10288>>3]*+h[b+3192>>3];i=i;return}function dH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3112>>3];k=+zd(1.0e-13,+(+h[g+208>>3]-j));l=+h[g+4416>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+nwa(c[b+536>>2]|0,k,46184,46336,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8248|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=Cza(1.0e-13,+h[f+208>>3]- +h[f+3112>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+3112>>3];j=+h[x+208>>3];k=+zd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+8952>>3];k=+h[x+4416>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+864>>3]- +h[x+9056>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+864>>3]- +h[x+9056>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+864>>3]- +h[x+9056>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+864>>3]- +h[x+9056>>3]}K=(y-k*J)/+nwa(c[b+536>>2]|0,l,46344,46336,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+4416>>3];C=+h[L+3112>>3];D=+h[L+208>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+9056>>3];m=+zd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+nwa(c[b+536>>2]|0,m,46184,46336,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8248|0;w=v;h[w>>3]=n;i=d;return}function eH(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(Cza(+h[a+200>>3]- +h[a+3128>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+9048|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+856>>3]- +h[a+8248>>3];g=a;j=g+9048|0;k=j;h[k>>3]=f;i=b;return}function fH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8240>>3]=+h[b+856>>3]- +h[b+9048>>3];i=i;return}function gH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3144>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+9048>>3];o=+h[g+8952>>3]*k+ +h[g+4416>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+nwa(c[b+536>>2]|0,l,46480,46472,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+9048>>3];q=+h[v+3144>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+8240>>3]*(1.0-q)+ +h[r+3136>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+9040|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+9040|0;C=B;h[C>>3]=z;i=d;return}p=t/+nwa(c[b+536>>2]|0,l,46480,46472,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+9040|0;C=B;h[C>>3]=z;i=d;return}function hH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3176>>3];k=+h[g+192>>3];l=j*k;m=l*l;n=+h[g+864>>3]*l- +h[g+208>>3]*(j*+h[g+848>>3]+k*+h[g+9040>>3]);if(m!=0.0){o=g;p=n/m;q=o;r=q+9464|0;s=r;h[s>>3]=p;i=d;return}if(n==0.0){o=g;p=n;q=o;r=q+9464|0;s=r;h[s>>3]=p;i=d;return}k=n/+nwa(c[b+536>>2]|0,m,46528,46520,+h[f>>3],(a[b+319|0]|0)!=0|0);o=c[(c[c[e>>2]>>2]|0)+8>>2]|0;p=k;q=o;r=q+9464|0;s=r;h[s>>3]=p;i=d;return}function iH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4248>>3]=+h[b+10288>>3]*+h[b+9464>>3];i=i;return}function jH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+312>>3]=+h[b+4248>>3]+ +h[b+320>>3];i=i;return}function kH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+728>>3]*+h[j+3192>>3]*+h[e+1888>>3];l=+h[j+312>>3]+ +h[j+320>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+2968|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+2968|0;r=q;h[r>>3]=o;i=d;return}s=l/+nwa(c[b+536>>2]|0,k,46584,46576,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+2968|0;r=q;h[r>>3]=o;i=d;return}function lH(a){a=a|0;var b=0,d=0.0,e=0.0,f=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+2968>>3];e=+h[b+2976>>3];f=c[a+416>>2]|0;h[b+3720>>3]=+h[f+1992>>3]*(+h[b+3968>>3]*d*d*+h[f+728>>3]- +h[b+3976>>3]*e*e*+h[f+736>>3]);i=i;return}function mH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3624>>3]=+h[b+3720>>3]- +h[b+3672>>3]- +h[b+8144>>3];i=i;return}function nH(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=(+h[e+728>>3]+ +h[e+736>>3])*+h[e+1992>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+3624>>3];if(f!=0.0){l=j;m=k/f;n=m*2.0;o=l;p=o+3576|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*2.0;o=l;p=o+3576|0;q=p;h[q>>3]=n;i=d;return}r=k/+nwa(c[b+536>>2]|0,f,46656,46648,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*2.0;o=l;p=o+3576|0;q=p;h[q>>3]=n;i=d;return}function oH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4208>>3]=+h[b+200>>3]*+h[b+4248>>3]+ +h[b+856>>3]*+h[b+4328>>3];i=i;return}function pH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4080>>3]=+h[b+4208>>3]+ +h[b+4088>>3];i=i;return}function qH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8232>>3]=+h[b+9456>>3]+(-(+h[b+3176>>3]*+h[b+848>>3])- +h[b+9040>>3]*+h[b+192>>3]);i=i;return}function rH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3184>>3]=+h[b+3200>>3]- +h[b+3176>>3]*+h[b+192>>3];i=i;return}function sH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8552>>3]=+h[b+4328>>3]*+h[b+8232>>3]+ +h[b+4248>>3]*+h[b+3184>>3];i=i;return}function tH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;gxa(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+224>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+232>>3];l=+h[a+216>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];tA(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3312>>3]=+h[f>>3];i=b;return}function uH(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+312>>3];h[b+4032>>3]=d*+h[(!(d>=0.0)?b+3200|0:b+3312|0)>>3];i=i;return}function vH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4168>>3]=+h[b+4032>>3]- +h[b+4040>>3];i=i;return}function wH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4128>>3]=+h[b+8552>>3]- +h[b+4168>>3];i=i;return}function xH(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;iA(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+216>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+3224>>3]=+yd(+(+h[d>>3]),+(+h[a+232>>3]*.999));i=b;return}function yH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3224>>3];k=+zd(1.0e-13,+(+h[g+232>>3]-j));l=+h[g+4424>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+nwa(c[b+536>>2]|0,k,46736,46728,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+3240>>3]=+yd(+(j*n*.6219647130774989),1.0);i=d;return}function zH(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3256>>3]=+zd(+(+h[d+224>>3]- +h[d+3240>>3]),0.0);i=b;return}function AH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3248>>3]=+h[b+224>>3]- +h[b+3256>>3];i=i;return}function BH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3256>>3];k=1.0-j;l=+h[g+4424>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+nwa(c[b+536>>2]|0,k,46808,46800,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+3256>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+3248>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+3288|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+3288|0;z=y;h[z>>3]=w;i=d;return}l=m/+nwa(c[b+536>>2]|0,p,46808,46800,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+3288|0;z=y;h[z>>3]=w;i=d;return}function CH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3296>>3]=+h[b+3312>>3]- +h[b+3288>>3]*+h[b+216>>3];i=i;return}function DH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+216>>3]*+h[g+3288>>3];k=+h[g+232>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+3304|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+3304|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,46848,46840,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+3304|0;p=o;h[p>>3]=m;i=d;return}function EH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4320>>3]=+h[b+10280>>3]*+h[b+3304>>3];i=i;return}function FH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3224>>3];k=+zd(1.0e-13,+(+h[g+232>>3]-j));l=+h[g+4424>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+nwa(c[b+536>>2]|0,k,46736,46888,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8224|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=Cza(1.0e-13,+h[f+232>>3]- +h[f+3224>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+3224>>3];j=+h[x+232>>3];k=+zd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+8944>>3];k=+h[x+4424>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+888>>3]- +h[x+9032>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+888>>3]- +h[x+9032>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+888>>3]- +h[x+9032>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+888>>3]- +h[x+9032>>3]}K=(y-k*J)/+nwa(c[b+536>>2]|0,l,46896,46888,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+4424>>3];C=+h[L+3224>>3];D=+h[L+232>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+9032>>3];m=+zd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+nwa(c[b+536>>2]|0,m,46736,46888,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8224|0;w=v;h[w>>3]=n;i=d;return}function GH(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(Cza(+h[a+224>>3]- +h[a+3240>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+9024|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+880>>3]- +h[a+8224>>3];g=a;j=g+9024|0;k=j;h[k>>3]=f;i=b;return}function HH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8216>>3]=+h[b+880>>3]- +h[b+9024>>3];i=i;return}function IH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3256>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+9024>>3];o=+h[g+8944>>3]*k+ +h[g+4424>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+nwa(c[b+536>>2]|0,l,47032,47024,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+9024>>3];q=+h[v+3256>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+8216>>3]*(1.0-q)+ +h[r+3248>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+9016|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+9016|0;C=B;h[C>>3]=z;i=d;return}p=t/+nwa(c[b+536>>2]|0,l,47032,47024,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+9016|0;C=B;h[C>>3]=z;i=d;return}function JH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3288>>3];k=+h[g+216>>3];l=j*k;m=l*l;n=+h[g+888>>3]*l- +h[g+232>>3]*(j*+h[g+872>>3]+k*+h[g+9016>>3]);if(m!=0.0){o=g;p=n/m;q=o;r=q+9448|0;s=r;h[s>>3]=p;i=d;return}if(n==0.0){o=g;p=n;q=o;r=q+9448|0;s=r;h[s>>3]=p;i=d;return}k=n/+nwa(c[b+536>>2]|0,m,47080,47072,+h[f>>3],(a[b+319|0]|0)!=0|0);o=c[(c[c[e>>2]>>2]|0)+8>>2]|0;p=k;q=o;r=q+9448|0;s=r;h[s>>3]=p;i=d;return}function KH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4240>>3]=+h[b+10280>>3]*+h[b+9448>>3];i=i;return}function LH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+304>>3]=+h[b+4240>>3]+ +h[b+312>>3];i=i;return}function MH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+720>>3]*+h[j+3304>>3]*+h[e+1888>>3];l=+h[j+304>>3]+ +h[j+312>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+2960|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+2960|0;r=q;h[r>>3]=o;i=d;return}s=l/+nwa(c[b+536>>2]|0,k,47136,47128,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+2960|0;r=q;h[r>>3]=o;i=d;return}function NH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4200>>3]=+h[b+224>>3]*+h[b+4240>>3]+ +h[b+880>>3]*+h[b+4320>>3];i=i;return}function OH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4072>>3]=+h[b+4200>>3]+ +h[b+4080>>3];i=i;return}function PH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8208>>3]=+h[b+9440>>3]+(-(+h[b+3288>>3]*+h[b+872>>3])- +h[b+9016>>3]*+h[b+216>>3]);i=i;return}function QH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8544>>3]=+h[b+4320>>3]*+h[b+8208>>3]+ +h[b+4240>>3]*+h[b+3296>>3];i=i;return}function RH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+224>>3];p=f;h[k>>3]=+h[n+4424>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+232>>3];q=+h[p+216>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+3960>>3]=+h[l>>3];i=b;return}function SH(a){a=a|0;var b=0,d=0.0,e=0.0,f=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+2960>>3];e=+h[b+2968>>3];f=c[a+416>>2]|0;h[b+3712>>3]=+h[f+1992>>3]*(+h[b+3960>>3]*d*d*+h[f+720>>3]- +h[b+3968>>3]*e*e*+h[f+728>>3]);i=i;return}function TH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3616>>3]=+h[b+3712>>3]- +h[b+3664>>3]- +h[b+8136>>3];i=i;return}function UH(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=(+h[e+720>>3]+ +h[e+728>>3])*+h[e+1992>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+3616>>3];if(f!=0.0){l=j;m=k/f;n=m*2.0;o=l;p=o+3568|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*2.0;o=l;p=o+3568|0;q=p;h[q>>3]=n;i=d;return}r=k/+nwa(c[b+536>>2]|0,f,47208,47200,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*2.0;o=l;p=o+3568|0;q=p;h[q>>3]=n;i=d;return}function VH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+224>>3];v=l;h[k>>3]=+h[t+4424>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];gxa(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+232>>3];w=+h[t+216>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];vz(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Bz(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+248>>3];f=j;h[k>>3]=+h[q+4432>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];gxa(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+256>>3];y=+h[f+240>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];vz(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Bz(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+3656>>3]=(+h[d+712>>3]+ +h[d+720>>3])*(w- +h[r>>3])*+h[d+1992>>3]*.5;i=b;return}function WH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+248>>3];p=f;h[k>>3]=+h[n+4432>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+256>>3];q=+h[p+240>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+3848>>3]=+h[l>>3];i=b;return}function XH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;gxa(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+248>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+256>>3];l=+h[a+240>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];tA(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3424>>3]=+h[f>>3];i=b;return}function YH(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+304>>3];h[b+4024>>3]=d*+h[(!(d>=0.0)?b+3312|0:b+3424|0)>>3];i=i;return}function ZH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4160>>3]=+h[b+4024>>3]- +h[b+4032>>3];i=i;return}function _H(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4120>>3]=+h[b+8544>>3]- +h[b+4160>>3];i=i;return}function $H(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;iA(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+240>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+3336>>3]=+yd(+(+h[d>>3]),+(+h[a+256>>3]*.999));i=b;return}function aI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3336>>3];k=+zd(1.0e-13,+(+h[g+256>>3]-j));l=+h[g+4432>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+nwa(c[b+536>>2]|0,k,47288,47280,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8200|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=Cza(1.0e-13,+h[f+256>>3]- +h[f+3336>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+3336>>3];j=+h[x+256>>3];k=+zd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+8936>>3];k=+h[x+4432>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+912>>3]- +h[x+9008>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+912>>3]- +h[x+9008>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+912>>3]- +h[x+9008>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+912>>3]- +h[x+9008>>3]}K=(y-k*J)/+nwa(c[b+536>>2]|0,l,47352,47280,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+4432>>3];C=+h[L+3336>>3];D=+h[L+256>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+9008>>3];m=+zd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+nwa(c[b+536>>2]|0,m,47288,47280,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8200|0;w=v;h[w>>3]=n;i=d;return}function bI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3336>>3];k=+zd(1.0e-13,+(+h[g+256>>3]-j));l=+h[g+4432>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+nwa(c[b+536>>2]|0,k,47288,47480,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+3352>>3]=+yd(+(j*n*.6219647130774989),1.0);i=d;return}function cI(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(Cza(+h[a+248>>3]- +h[a+3352>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+9e3|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+904>>3]- +h[a+8200>>3];g=a;j=g+9e3|0;k=j;h[k>>3]=f;i=b;return}function dI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8192>>3]=+h[b+904>>3]- +h[b+9e3>>3];i=i;return}function eI(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3368>>3]=+zd(+(+h[d+248>>3]- +h[d+3352>>3]),0.0);i=b;return}function fI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3360>>3]=+h[b+248>>3]- +h[b+3368>>3];i=i;return}function gI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3368>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+9e3>>3];o=+h[g+8936>>3]*k+ +h[g+4432>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+nwa(c[b+536>>2]|0,l,47496,47488,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+9e3>>3];q=+h[v+3368>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+8192>>3]*(1.0-q)+ +h[r+3360>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+8992|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+8992|0;C=B;h[C>>3]=z;i=d;return}p=t/+nwa(c[b+536>>2]|0,l,47496,47488,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+8992|0;C=B;h[C>>3]=z;i=d;return}function hI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3368>>3];k=1.0-j;l=+h[g+4432>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+nwa(c[b+536>>2]|0,k,47544,47536,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+3368>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+3360>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+3400|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+3400|0;z=y;h[z>>3]=w;i=d;return}l=m/+nwa(c[b+536>>2]|0,p,47544,47536,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+3400|0;z=y;h[z>>3]=w;i=d;return}function iI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3408>>3]=+h[b+3424>>3]- +h[b+3400>>3]*+h[b+240>>3];i=i;return}function jI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3400>>3];k=+h[g+240>>3];l=j*k;m=l*l;n=+h[g+912>>3]*l- +h[g+256>>3]*(j*+h[g+896>>3]+k*+h[g+8992>>3]);if(m!=0.0){o=g;p=n/m;q=o;r=q+9432|0;s=r;h[s>>3]=p;i=d;return}if(n==0.0){o=g;p=n;q=o;r=q+9432|0;s=r;h[s>>3]=p;i=d;return}k=n/+nwa(c[b+536>>2]|0,m,47584,47576,+h[f>>3],(a[b+319|0]|0)!=0|0);o=c[(c[c[e>>2]>>2]|0)+8>>2]|0;p=k;q=o;r=q+9432|0;s=r;h[s>>3]=p;i=d;return}function kI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4232>>3]=+h[b+10272>>3]*+h[b+9432>>3];i=i;return}function lI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+296>>3]=+h[b+4232>>3]+ +h[b+304>>3];i=i;return}function mI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8184>>3]=+h[b+9424>>3]+(-(+h[b+3400>>3]*+h[b+896>>3])- +h[b+8992>>3]*+h[b+240>>3]);i=i;return}function nI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+240>>3]*+h[g+3400>>3];k=+h[g+256>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+3416|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+3416|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,47640,47632,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+3416|0;p=o;h[p>>3]=m;i=d;return}function oI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4312>>3]=+h[b+10272>>3]*+h[b+3416>>3];i=i;return}function pI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8536>>3]=+h[b+4312>>3]*+h[b+8184>>3]+ +h[b+4232>>3]*+h[b+3408>>3];i=i;return}function qI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4192>>3]=+h[b+248>>3]*+h[b+4232>>3]+ +h[b+904>>3]*+h[b+4312>>3];i=i;return}function rI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4064>>3]=+h[b+4192>>3]+ +h[b+4072>>3];i=i;return}function sI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+712>>3]*+h[j+3416>>3]*+h[e+1888>>3];l=+h[j+296>>3]+ +h[j+304>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+2952|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+2952|0;r=q;h[r>>3]=o;i=d;return}s=l/+nwa(c[b+536>>2]|0,k,47688,47680,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+2952|0;r=q;h[r>>3]=o;i=d;return}function tI(a){a=a|0;var b=0,d=0.0,e=0.0,f=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+2952>>3];e=+h[b+2960>>3];f=c[a+416>>2]|0;h[b+3704>>3]=+h[f+1992>>3]*(+h[b+3952>>3]*d*d*+h[f+712>>3]- +h[b+3960>>3]*e*e*+h[f+720>>3]);i=i;return}function uI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3608>>3]=+h[b+3704>>3]- +h[b+3656>>3]- +h[b+8128>>3];i=i;return}function vI(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=(+h[e+712>>3]+ +h[e+720>>3])*+h[e+1992>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+3608>>3];if(f!=0.0){l=j;m=k/f;n=m*2.0;o=l;p=o+3560|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*2.0;o=l;p=o+3560|0;q=p;h[q>>3]=n;i=d;return}r=k/+nwa(c[b+536>>2]|0,f,47760,47752,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*2.0;o=l;p=o+3560|0;q=p;h[q>>3]=n;i=d;return}function wI(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;iA(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+264>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+3448>>3]=+yd(+(+h[d>>3]),+(+h[a+280>>3]*.999));i=b;return}function xI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;gxa(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+272>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+280>>3];l=+h[a+264>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];tA(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3536>>3]=+h[f>>3];i=b;return}function yI(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+296>>3];h[b+4016>>3]=d*+h[(!(d>=0.0)?b+3424|0:b+3536|0)>>3];i=i;return}function zI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4152>>3]=+h[b+4016>>3]- +h[b+4024>>3];i=i;return}function AI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4112>>3]=+h[b+8536>>3]- +h[b+4152>>3];i=i;return}function BI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7752>>3]=1.0- +h[b+496>>3];i=i;return}function CI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;iA(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+488>>3]);if((Aza(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+504>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+1160>>3]*.999;l=j;m=l+8760|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;xA(e,c[f>>2]|0,+h[d+488>>3],+h[d+1144>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+8760|0;n=m;h[n>>3]=k;i=b;return}}function DI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[63880]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=57624;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&127](mb,m,47840,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]}jA(t,c[ib>>2]|0,jb);jb=+h[t>>3];kA(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);jb=+h[v>>3];jA(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);pb=+h[w>>3];kA(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+496>>3];qb=+zd(1.0e-13,+(+h[w+504>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+nwa(c[ib>>2]|0,qb,47912,47832,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(pb- +yd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{jA(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);sb=+h[z>>3];kA(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);sb=+h[B>>3];jA(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);jb=+h[C>>3];kA(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+zd(1.0e-13,+(+h[C+504>>3]- +h[E>>3]));pb=1.0- +h[C+496>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+nwa(c[ib>>2]|0,jb,47912,47832,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{jA(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);vb=+h[F>>3];kA(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);vb=+h[H>>3];jA(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);sb=+h[I>>3];kA(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);sb=+h[K>>3];jA(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);jb=+h[L>>3];kA(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+504>>3]- +h[N>>3])|0)<<24>>24==0){jA(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);jb=+h[O>>3];kA(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Q,c[ib>>2]|0,+h[P+488>>3],+h[P+1144>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(R,c[ib>>2]|0,+h[Q+488>>3],+h[Q+1144>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(S,c[ib>>2]|0,jb,pb,+h[Q+488>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+1144>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+1160>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}jA(T,c[ib>>2]|0,+h[xb+488>>3]);qb=+h[T>>3];kA(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);qb=+h[V>>3];jA(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);pb=+h[W>>3];kA(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);pb=+h[Y>>3];jA(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);jb=+h[Z>>3];kA(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA($,c[ib>>2]|0,+h[_+488>>3],+h[_+1144>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(aa,c[ib>>2]|0,+h[$+488>>3],+h[$+1144>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(ba,c[ib>>2]|0,jb,rb,+h[$+488>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+1144>>3],0.0);zb=+h[ba>>3];jA(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);rb=+h[ca>>3];kA(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+504>>3];Ab=+zd(1.0e-13,+(jb-qb));qb=Ab*+zd(1.0e-13,+(jb-pb));pb=+h[ea+1152>>3];Ab=-(pb*+zd(1.0e-13,+(jb-sb)));sb=+h[ea+496>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+nwa(c[ib>>2]|0,qb,48216,47832,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+496>>3];Cb=+h[ca+504>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+zd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+nwa(c[ib>>2]|0,Eb,47912,47832,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+1152>>3]-wb}wb=+h[tb+488>>3];if(wb>0.0){Gb=wb}else{tb=c[63880]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=57624;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&127](Db,l,47840,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]}if(Gb>0.0){Hb=Gb}else{r=c[63880]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=57624;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&127](l,j,47840,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]}jA(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];kA(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);Hb=+h[ia>>3];jA(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);Fb=+h[ja>>3];kA(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3];if(zb>0.0){Ib=zb}else{la=c[63880]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=57624;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&127](ka,g,47840,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]}if(Ib>0.0){Jb=Ib}else{p=c[63880]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=57624;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&127](g,f,47840,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]}if(Jb>0.0){Kb=Jb}else{o=c[63880]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=57624;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&127](f,e,47840,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]}qb=Kb+-273.15;lA(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];jA(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);qb=+h[na>>3];kA(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);qb=+h[pa>>3];jA(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);Eb=+h[qa>>3];kA(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+496>>3];rb=+zd(1.0e-13,+(+h[qa+504>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+nwa(c[ib>>2]|0,rb,47912,47832,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(Eb- +yd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{jA(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);Lb=+h[ta>>3];kA(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);Lb=+h[va>>3];jA(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);qb=+h[wa>>3];kA(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+zd(1.0e-13,+(+h[wa+504>>3]- +h[ya>>3]));Eb=1.0- +h[wa+496>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+nwa(c[ib>>2]|0,qb,47912,47832,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{jA(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);Ob=+h[za>>3];kA(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);Ob=+h[Ba>>3];jA(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);Lb=+h[Ca>>3];kA(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);Lb=+h[Ea>>3];jA(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);qb=+h[Fa>>3];kA(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+504>>3]- +h[Ha>>3])|0)<<24>>24==0){jA(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);qb=+h[Ia>>3];kA(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Ka,c[ib>>2]|0,+h[Ja+488>>3],+h[Ja+1144>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(La,c[ib>>2]|0,+h[Ka+488>>3],+h[Ka+1144>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+488>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+1144>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+1160>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}jA(Na,c[ib>>2]|0,+h[Qb+488>>3]);rb=+h[Na>>3];kA(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);rb=+h[Pa>>3];jA(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);Eb=+h[Qa>>3];kA(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);Eb=+h[Sa>>3];jA(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);qb=+h[Ta>>3];kA(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Va,c[ib>>2]|0,+h[Ua+488>>3],+h[Ua+1144>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(Wa,c[ib>>2]|0,+h[Va+488>>3],+h[Va+1144>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Xa,c[ib>>2]|0,qb,Bb,+h[Va+488>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+1144>>3],0.0);Cb=+h[Xa>>3];jA(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);Bb=+h[Ya>>3];kA(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+504>>3];vb=+zd(1.0e-13,+(qb-rb));rb=vb*+zd(1.0e-13,+(qb-Eb));Eb=+h[Za+1152>>3];vb=-(Eb*+zd(1.0e-13,+(qb-Lb)));Lb=+h[Za+496>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+nwa(c[ib>>2]|0,rb,48216,47832,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+496>>3];Tb=+h[Ya+504>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+zd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+nwa(c[ib>>2]|0,Vb,47912,47832,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+1152>>3]-Pb}Pb=+h[Mb+488>>3];Wb=Pb+-273.15;Cb=+h[Mb+1144>>3];sA($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];jA(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);Pb=+h[ab>>3];kA(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);Pb=+h[cb>>3];jA(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);Wb=+h[db>>3];kA(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+488>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+nwa(c[ib>>2]|0,rb,48824,47832,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+488>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+1152>>3]-ub);ub=+h[Yb+1144>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+nwa(c[ib>>2]|0,Xb,48824,47832,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+1144>>3];ac=+h[Yb+488>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+Nxa(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+496>>3];Gb=+zd(1.0e-13,+(+h[Yb+504>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+nwa(c[ib>>2]|0,Gb,47912,47832,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +zd(+(ac- +yd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+488>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+nwa(c[ib>>2]|0,ec,48824,47832,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+488>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+1152>>3];ic=+h[gc+1144>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+nwa(c[ib>>2]|0,fc,48824,47832,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+1144>>3];kc=+h[gc+488>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+Nxa(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+496>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+zd(1.0e-13,+(+h[gc+504>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9312|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9312|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+nwa(c[ib>>2]|0,Nb,47912,47832,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9312|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function EI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+496>>3];p=f;h[k>>3]=+h[n+7752>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+504>>3];q=+h[p+488>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+9608>>3]=+h[l>>3];i=b;return}function FI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;gxa(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+496>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+504>>3];l=+h[a+488>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];tA(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6544>>3]=+h[f>>3];i=b;return}function GI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+496>>3];p=f;h[k>>3]=+h[n+7752>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+504>>3];q=+h[p+488>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+9664>>3]=+h[l>>3];i=b;return}function HI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7760>>3]=1.0- +h[b+520>>3];i=i;return}function II(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+496>>3];v=l;h[k>>3]=+h[t+7752>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];gxa(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+504>>3];w=+h[t+488>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];vz(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Bz(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+520>>3];f=j;h[k>>3]=+h[q+7760>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];gxa(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+528>>3];y=+h[f+512>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];vz(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Bz(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+7128>>3]=(+h[d+136>>3]+ +h[d+144>>3])*(w- +h[r>>3])*+h[d+1536>>3]*.5;i=b;return}function JI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+520>>3];v=l;h[k>>3]=+h[t+7760>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];gxa(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+528>>3];w=+h[t+512>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];vz(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Bz(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+544>>3];f=j;h[k>>3]=+h[q+7768>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];gxa(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+552>>3];y=+h[f+536>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];vz(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Bz(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+7120>>3]=(+h[d+128>>3]+ +h[d+136>>3])*(w- +h[r>>3])*+h[d+1536>>3]*.5;i=b;return}function KI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+520>>3];p=f;h[k>>3]=+h[n+7760>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+528>>3];q=+h[p+512>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+9656>>3]=+h[l>>3];i=b;return}function LI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+520>>3];p=f;h[k>>3]=+h[n+7760>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+528>>3];q=+h[p+512>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+9600>>3]=+h[l>>3];i=b;return}function MI(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;iA(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+512>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+6568>>3]=+yd(+(+h[d>>3]),+(+h[a+528>>3]*.999));i=b;return}function NI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6568>>3];k=+zd(1.0e-13,+(+h[g+528>>3]-j));l=+h[g+7760>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+nwa(c[b+536>>2]|0,k,48856,48848,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6584>>3]=+yd(+(j*n*.6219647130774989),1.0);i=d;return}function OI(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+6600>>3]=+zd(+(+h[d+520>>3]- +h[d+6584>>3]),0.0);i=b;return}function PI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6592>>3]=+h[b+520>>3]- +h[b+6600>>3];i=i;return}function QI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6600>>3];k=1.0-j;l=+h[g+7760>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+nwa(c[b+536>>2]|0,k,48928,48920,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+6600>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+6592>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+6632|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+6632|0;z=y;h[z>>3]=w;i=d;return}l=m/+nwa(c[b+536>>2]|0,p,48928,48920,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+6632|0;z=y;h[z>>3]=w;i=d;return}function RI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+512>>3]*+h[g+6632>>3];k=+h[g+528>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+6648|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+6648|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,48968,48960,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6648|0;p=o;h[p>>3]=m;i=d;return}function SI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7672>>3]=+h[b+9992>>3]*+h[b+6648>>3];i=i;return}



function KKa(a,b,c){a=a|0;b=b|0;c=c|0;b=i;LKa(c);i=b;return}function LKa(a){a=a|0;var b=0;b=i;MKa(a);i=b;return}function MKa(a){a=a|0;var b=0;b=i;NKa(a);i=b;return}function NKa(a){a=a|0;var b=0;b=i;OKa(a);i=b;return}function OKa(a){a=a|0;var b=0;b=i;QQa(a+12|0);QQa(a);i=b;return}function PKa(a){a=a|0;var b=0;b=i;QKa(a+180|0);QKa(a+168|0);QKa(a+156|0);QKa(a+144|0);QKa(a+132|0);QKa(a+120|0);QKa(a+108|0);QKa(a+96|0);QKa(a+84|0);QKa(a+72|0);QKa(a+60|0);QKa(a+48|0);QKa(a+36|0);QKa(a+24|0);dGa(a+12|0);dGa(a);i=b;return}function QKa(a){a=a|0;var b=0;b=i;RKa(a);i=b;return}function RKa(a){a=a|0;var b=0;b=i;SKa(a);i=b;return}function SKa(a){a=a|0;var b=0;b=i;TKa(a);i=b;return}function TKa(a){a=a|0;var b=0;b=i;UKa(a,vJa(a)|0);i=b;return}function UKa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;fCa(d);if((b|0)==0){i=d;return}UKa(a,c[b>>2]|0);UKa(a,c[b+4>>2]|0);e=_Ia(a)|0;VKa(e,WKa(b+16|0)|0);UIa(e,b,1);i=d;return}function VKa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;XKa(d,0,c);i=b;return}function WKa(a){a=a|0;i=i;return a|0}function XKa(a,b,c){a=a|0;b=b|0;c=c|0;b=i;YKa(c);i=b;return}function YKa(a){a=a|0;var b=0;b=i;ZKa(a);i=b;return}function ZKa(a){a=a|0;var b=0;b=i;_Ka(a);i=b;return}function _Ka(a){a=a|0;var b=0;b=i;$Ka(a);i=b;return}function $Ka(a){a=a|0;var b=0;b=i;dGa(a+4|0);i=b;return}function aLa(a){a=a|0;var b=0;b=i;bLa(a);i=b;return}function bLa(a){a=a|0;var b=0;b=i;cLa(a);i=b;return}function cLa(a){a=a|0;var b=0;b=i;dLa(a,SGa(a)|0);i=b;return}function dLa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;fCa(d);if((b|0)==0){i=d;return}dLa(a,c[b>>2]|0);dLa(a,c[b+4>>2]|0);e=AHa(a)|0;eLa(e,FGa(b+16|0)|0);uHa(e,b,1);i=d;return}function eLa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;fLa(d,0,c);i=b;return}function fLa(a,b,c){a=a|0;b=b|0;c=c|0;b=i;gLa(c);i=b;return}function gLa(a){a=a|0;var b=0;b=i;hLa(a);i=b;return}function hLa(a){a=a|0;var b=0;b=i;iLa(a);i=b;return}function iLa(a){a=a|0;var b=0;b=i;jLa(a);i=b;return}function jLa(a){a=a|0;var b=0;b=i;QQa(a);i=b;return}function kLa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;lLa(a);nLa(g,b);oLa(h,b);b=f;j=g;c[b+0>>2]=c[j+0>>2];j=e;b=h;c[j+0>>2]=c[b+0>>2];mLa(a,f,e);i=d;return a|0}function lLa(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;HKa(a,gIa(a)|0);c[(SJa(a)|0)>>2]=0;d=$Ha(a)|0;c[(BJa(a)|0)>>2]=d;fCa(b);c[d>>2]=0;i=b;return}function mLa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+48|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;wLa(h,a);if(!(xLa(b,d)|0)){i=e;return}m=c[h>>2]|0;h=k;do{c[h>>2]=m;n=g;o=k;c[n+0>>2]=c[o+0>>2];pLa(j,g);o=zLa(b)|0;n=f;p=j;c[n+0>>2]=c[p+0>>2];yLa(l,a,f,o);ALa(b)|0;}while(xLa(b,d)|0);i=e;return}function nLa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;uLa(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];pLa(a,e);i=d;return}function oLa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;qLa(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];pLa(a,e);i=d;return}function pLa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];tLa(a,e);i=d;return}function qLa(a,b){a=a|0;b=b|0;var c=0;c=i;rLa(a,fGa(b)|0);i=c;return}function rLa(a,b){a=a|0;b=b|0;var c=0;c=i;sLa(a,b);i=c;return}function sLa(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function tLa(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function uLa(a,b){a=a|0;b=b|0;var d=0;d=i;rLa(a,c[(vLa(b)|0)>>2]|0);i=d;return}function vLa(a){a=a|0;i=i;return a|0}function wLa(a,b){a=a|0;b=b|0;var c=0;c=i;oLa(a,b);i=c;return}function xLa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=GMa(a,b)|0;i=c;return d|0}function yLa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+56|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=b;c[k>>2]=c[d>>2];ILa(l,e);e=h;d=k;c[e+0>>2]=c[d+0>>2];HLa(j,m,h,l);h=g;m=j;c[h+0>>2]=c[m+0>>2];YHa(a,g);LKa(l);i=f;return}function zLa(a){a=a|0;var b=0,c=0;b=i;c=ELa(a)|0;i=b;return c|0}function ALa(a){a=a|0;var b=0;b=i;BLa(a)|0;i=b;return a|0}function BLa(a){a=a|0;var b=0,d=0;b=i;d=a;c[d>>2]=CLa(c[d>>2]|0)|0;i=b;return a|0}function CLa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=a+4|0;e=c[d>>2]|0;fCa(b);if((e|0)==0){e=a;while(1){a=VDa(e)|0;f=c[e+8>>2]|0;if(a){g=f;break}else{e=f}}i=b;return g|0}else{g=DLa(c[d>>2]|0)|0;i=b;return g|0}return 0}function DLa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a;f=c[e>>2]|0;fCa(d);if((f|0)==0){g=a;i=b;return g|0}else{h=e}while(1){e=c[h>>2]|0;a=e;f=c[a>>2]|0;fCa(d);if((f|0)==0){g=e;break}else{h=a}}i=b;return g|0}function ELa(a){a=a|0;var b=0,d=0;b=i;d=FLa((c[a>>2]|0)+16|0)|0;i=b;return d|0}function FLa(a){a=a|0;var b=0,c=0;b=i;c=GLa(a)|0;i=b;return c|0}function GLa(a){a=a|0;i=i;return a|0}function HLa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+80|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+56|0;o=f+64|0;c[k>>2]=c[d>>2];d=h;p=k;c[d+0>>2]=c[p+0>>2];p=MLa(b,h,j,e)|0;h=c[p>>2]|0;fCa(l);if((h|0)!=0){q=h;_Ha(a,q);i=f;return}OLa(o,b,e);PLa(n,o);e=g;h=n;c[e+0>>2]=c[h+0>>2];NLa(m,g);QLa(o);o=c[j>>2]|0;LJa(b,o,p,RLa(m)|0);p=SLa(m)|0;QLa(m);q=p;_Ha(a,q);i=f;return}function ILa(a,b){a=a|0;b=b|0;var c=0;c=i;JLa(a,b);i=c;return}function JLa(a,b){a=a|0;b=b|0;var c=0;c=i;KLa(a,b);i=c;return}function KLa(a,b){a=a|0;b=b|0;var c=0;c=i;LLa(a,b);i=c;return}function LLa(a,b){a=a|0;b=b|0;var c=0;c=i;GQa(a,b);GQa(a+12|0,b+12|0);i=c;return}function MLa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+120|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+48|0;o=f+56|0;p=f+64|0;q=f+72|0;r=f+80|0;s=f+88|0;t=f+96|0;u=f+104|0;v=f+112|0;ZHa(m,a);w=k;x=m;c[w+0>>2]=c[x+0>>2];uMa(l,k);do{if(!(tMa(b,l)|0)){k=iIa(a)|0;x=wMa(b)|0;if(vMa(k,e,x)|0){break}w=vMa(k,x,e)|0;x=c[b>>2]|0;if(!w){c[d>>2]=x;y=d;i=f;return y|0}c[s>>2]=x;w=h;m=s;c[w+0>>2]=c[m+0>>2];AMa(r,h,1,0);ZHa(u,a);m=g;w=u;c[m+0>>2]=c[w+0>>2];uMa(t,g);do{if(!(tMa(r,t)|0)){if(vMa(k,e,wMa(r)|0)|0){break}y=zMa(a,d,e)|0;i=f;return y|0}}while(0);k=x+4|0;w=c[k>>2]|0;fCa(v);if((w|0)==0){c[d>>2]=x;y=k;i=f;return y|0}else{k=c[r>>2]|0;c[d>>2]=k;y=k;i=f;return y|0}}}while(0);r=c[b>>2]|0;b=n;c[b>>2]=r;xMa(p,a);v=j;t=p;c[v+0>>2]=c[t+0>>2];uMa(o,j);do{if(!(tMa(n,o)|0)){j=iIa(a)|0;if(vMa(j,wMa(yMa(n)|0)|0,e)|0){break}y=zMa(a,d,e)|0;i=f;return y|0}}while(0);e=r;a=c[e>>2]|0;fCa(q);if((a|0)==0){c[d>>2]=r;y=e;i=f;return y|0}else{e=c[b>>2]|0;c[d>>2]=e;y=e+4|0;i=f;return y|0}return 0}function NLa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];rMa(a,e);i=d;return}function OLa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=hKa(d)|0;d=jKa(n,1)|0;dMa(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];cMa(j,d,h);eMa(0,JKa((fMa(j)|0)+16|0)|0,e);a[(gMa(j)|0)+4|0]=1;hMa(m,j);PLa(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];NLa(b,g);QLa(m);QLa(j);i=f;return}function PLa(a,b){a=a|0;b=b|0;var c=0;c=i;aMa(a,b);i=c;return}function QLa(a){a=a|0;var b=0;b=i;XLa(a);i=b;return}function RLa(a){a=a|0;var b=0,d=0;b=i;d=c[(VLa(a)|0)>>2]|0;i=b;return d|0}function SLa(a){a=a|0;var b=0,d=0;b=i;d=TLa(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function TLa(a){a=a|0;var b=0,c=0;b=i;c=ULa(a)|0;i=b;return c|0}function ULa(a){a=a|0;i=i;return a|0}function VLa(a){a=a|0;var b=0,c=0;b=i;c=WLa(a)|0;i=b;return c|0}function WLa(a){a=a|0;i=i;return a|0}function XLa(a){a=a|0;var b=0;b=i;YLa(a,0);i=b;return}function YLa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=TLa(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}_La(ZLa(e)|0,f);i=d;return}function ZLa(a){a=a|0;var b=0,c=0;b=i;c=$La(a)|0;i=b;return c|0}function _La(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+4|0]|0)!=0){f=c[b>>2]|0;IKa(f,JKa(d+16|0)|0)}if((d|0)==0){i=e;return}aKa(c[b>>2]|0,d,1);i=e;return}function $La(a){a=a|0;i=i;return a+4|0}function aMa(a,b){a=a|0;b=b|0;var c=0;c=i;bMa(a,b);i=c;return}function bMa(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function cMa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];lMa(a,b,f);i=e;return}function dMa(a,b){a=a|0;b=b|0;var c=0;c=i;kMa(a,b);i=c;return}function eMa(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}iMa(b,c);i=a;return}function fMa(a){a=a|0;var b=0,d=0;b=i;d=c[(VLa(a)|0)>>2]|0;i=b;return d|0}function gMa(a){a=a|0;var b=0,c=0;b=i;c=ZLa(a)|0;i=b;return c|0}function hMa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;aMa(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];NLa(h,f);PLa(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];NLa(a,e);QLa(h);i=d;return}function iMa(a,b){a=a|0;b=b|0;var c=0;c=i;jMa(a,b);i=c;return}function jMa(a,b){a=a|0;b=b|0;var c=0;c=i;KLa(a,b);i=c;return}function kMa(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;i=i;return}function lMa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(uKa(g)|0)>>2]|0;g=nMa(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];mMa(b,a,f);i=e;return}function mMa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];oMa(a,b,f);i=e;return}function nMa(a){a=a|0;i=i;return a|0}function oMa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(yKa(g)|0)>>2]|0;g=qMa(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];pMa(b,a,f);i=e;return}function pMa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(yKa(f)|0)>>2];f=qMa(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function qMa(a){a=a|0;i=i;return a|0}function rMa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=SLa(sMa(b)|0)|0;h=qMa(gMa(sMa(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];mMa(g,a,e);i=d;return}function sMa(a){a=a|0;i=i;return c[a>>2]|0}function tMa(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function uMa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];FMa(a,e);i=d;return}function vMa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=kGa(0,b,c)|0;i=a;return d|0}function wMa(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function xMa(a,b){a=a|0;b=b|0;var d=0;d=i;_Ha(a,c[(BJa(b)|0)>>2]|0);i=d;return}function yMa(a){a=a|0;var b=0,d=0;b=i;d=a;c[d>>2]=DMa(c[d>>2]|0)|0;i=b;return a|0}function zMa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=gIa(a)|0;fCa(e);if((h|0)==0){j=$Ha(a)|0;c[b>>2]=j;k=j;i=e;return k|0}j=iIa(a)|0;a=h;while(1){h=a+16|0;if(vMa(j,d,h)|0){l=a;m=c[l>>2]|0;fCa(f);if((m|0)==0){n=5;break}else{o=l}}else{p=a;if(!(vMa(j,h,d)|0)){n=10;break}q=a+4|0;h=c[q>>2]|0;fCa(g);if((h|0)==0){n=9;break}else{o=q}}a=c[o>>2]|0}if((n|0)==5){c[b>>2]=a;k=l;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==10){c[b>>2]=p;k=b;i=e;return k|0}return 0}function AMa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;BMa(b,d);c[a>>2]=c[b>>2];i=e;return}function BMa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;CMa(b,c,e);i=d;return}function CMa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;c=i;if(!((b|0)>-1)){d=b;do{yMa(a)|0;d=d+1|0;}while((d|0)<0);i=c;return}if((b|0)>0){e=b}else{i=c;return}do{BLa(a)|0;e=e+ -1|0;}while((e|0)>0);i=c;return}function DMa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=a;e=c[d>>2]|0;fCa(b);if((e|0)==0){e=a;while(1){a=VDa(e)|0;f=c[e+8>>2]|0;if(a){e=f}else{g=f;break}}i=b;return g|0}else{g=EMa(c[d>>2]|0)|0;i=b;return g|0}return 0}function EMa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[e>>2]|0;fCa(d);if((f|0)==0){g=a;i=b;return g|0}else{h=e}while(1){e=c[h>>2]|0;a=e+4|0;f=c[a>>2]|0;fCa(d);if((f|0)==0){g=e;break}else{h=a}}i=b;return g|0}function FMa(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function GMa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(tMa(a,b)|0)^1;i=c;return d|0}function HMa(a){a=a|0;var b=0;b=i;i=i+128|0;XFa(a,b);XFa(a+12|0,b+8|0);IMa(a+24|0,b+16|0);IMa(a+36|0,b+24|0);IMa(a+48|0,b+32|0);IMa(a+60|0,b+40|0);IMa(a+72|0,b+48|0);IMa(a+84|0,b+56|0);IMa(a+96|0,b+64|0);IMa(a+108|0,b+72|0);IMa(a+120|0,b+80|0);IMa(a+132|0,b+88|0);IMa(a+144|0,b+96|0);IMa(a+156|0,b+104|0);IMa(a+168|0,b+112|0);IMa(a+180|0,b+120|0);i=b;return}function IMa(a,b){a=a|0;b=b|0;b=i;JMa(a,0);i=b;return}function JMa(a,b){a=a|0;b=b|0;b=i;i=i+8|0;KMa(a,b);i=b;return}function KMa(a,b){a=a|0;b=b|0;b=i;LMa(a,0);i=b;return}function LMa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;MMa(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;NMa(f,0,e);e=IIa(b)|0;c[(HIa(b)|0)>>2]=e;i=d;return}function MMa(a){a=a|0;var b=0;b=i;QMa(a);i=b;return}function NMa(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;OMa(b,c,f);i=e;return}function OMa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(JEa(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;PMa(d,b,f);i=e;return}function PMa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(JEa(e)|0)>>2];i=d;return}function QMa(a){a=a|0;var b=0;b=i;RMa(a);i=b;return}function RMa(a){a=a|0;var b=0;b=i;MEa(a);i=b;return}function SMa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;b=i;i=i+8|0;a=b;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=c[263412>>2]|0;if((m|0)==0){n=0}else{o=$_a(12)|0;KQa(o,m);n=o}if((c[263328>>2]|0)!=0){c[51534]=1}if((n|0)==0){c[206148>>2]=1;c[206152>>2]=1;i=b;return}do{if((mRa(n,253552,0)|0)==-1){GQa(g,n);EQa(h);o=c[51108]|0;m=(o|0)<28;while(1){p=mRa(g,253560,0)|0;q=(p|0)!=-1;if(q){kRa(j,g,0,p);RQa(h,j)|0;QQa(j);kRa(k,g,p+1|0,-1);RQa(g,k)|0;QQa(k)}else{RQa(h,g)|0}if(m){r=1;s=o}else{t=20;break}while(1){KQa(l,c[204848+(s<<2)>>2]|0);p=TMa(h,l)|0;QQa(l);if(p){c[206144+(s<<2)>>2]=1;u=0}else{u=r}p=s+1|0;if((p|0)<28){r=u;s=p}else{break}}if((u|0)!=0){t=18;break}if(!q){t=23;break}}if((t|0)==18){jwa(1,1,253568,f);if(m){v=o}else{w=206696;x=c[51674]|0;le[x&2047](1);y=lRa(n)|0;z=a;A=z;c[A>>2]=y;B=5;C=B;D=253608;E=D;lwa(0,E,a)}do{p=c[206016+(v<<2)>>2]|0;c[e>>2]=c[204848+(v<<2)>>2];c[e+4>>2]=p;jwa(1,0,253592,e);v=v+1|0;}while((v|0)<28);w=206696;x=c[51674]|0;le[x&2047](1);y=lRa(n)|0;z=a;A=z;c[A>>2]=y;B=5;C=B;D=253608;E=D;lwa(0,E,a)}else if((t|0)==20){jwa(1,1,253568,d);w=206696;x=c[51674]|0;le[x&2047](1);y=lRa(n)|0;z=a;A=z;c[A>>2]=y;B=5;C=B;D=253608;E=D;lwa(0,E,a)}else if((t|0)==23){QQa(h);QQa(g);break}}else{o=1;do{c[206144+(o<<2)>>2]=1;o=o+1|0;}while((o|0)<28)}}while(0);c[206148>>2]=1;c[206152>>2]=1;if((c[206180>>2]|0)!=0){c[206240>>2]=1}if((c[206236>>2]|0)==1){c[206244>>2]=1}if((c[206216>>2]|0)!=0){c[206212>>2]=1}if((c[206224>>2]|0)!=0){c[206212>>2]=1}if((c[206176>>2]|0)!=0){c[206172>>2]=1}if((c[206220>>2]|0)!=0){c[206212>>2]=1}if((c[206168>>2]|0)!=0){c[206164>>2]=1}QQa(n);b$a(n);i=b;return}function TMa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=OQa(b)|0;if((e|0)!=(OQa(c)|0)){f=0;i=d;return f|0}g=PQa(b)|0;h=PQa(c)|0;if(HQa(b)|0){f=(mGa(g,h,e)|0)==0;i=d;return f|0}if((e|0)==0){f=1;i=d;return f|0}else{j=e;k=g;l=h}while(1){if((a[k]|0)!=(a[l]|0)){f=0;m=7;break}h=j+ -1|0;if((h|0)==0){f=1;m=7;break}else{j=h;k=k+1|0;l=l+1|0}}if((m|0)==7){i=d;return f|0}return 0}function UMa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;a=b;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=c[263420>>2]|0;if((h|0)==0){j=1;i=b;return j|0}k=$_a(12)|0;l=k;KQa(l,h);if((k|0)==0){j=1;i=b;return j|0}else{m=1}while(1){k=m+1|0;if(VMa(l,c[238648+(m<<2)>>2]|0)|0){j=m;n=6;break}if((k|0)<4){m=k}else{n=5;break}}if((n|0)==5){c[g>>2]=lRa(l)|0;jwa(1,1,253640,g);g=c[238732>>2]|0;c[f>>2]=c[238652>>2];c[f+4>>2]=g;jwa(1,0,253592,f);f=c[238736>>2]|0;c[e>>2]=c[238656>>2];c[e+4>>2]=f;jwa(1,0,253592,e);e=c[238740>>2]|0;c[d>>2]=c[238660>>2];c[d+4>>2]=e;jwa(1,0,253592,d);le[c[51674]&2047](1);lwa(0,253696,a)}else if((n|0)==6){i=b;return j|0}return 0}function VMa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(oRa(a,b)|0)==0;i=c;return d|0}function WMa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;a=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+16|0;g=i;i=i+16|0;h=c[263404>>2]|0;if((h|0)==0){j=1;i=b;return j|0}k=$_a(12)|0;l=k;KQa(l,h);if((k|0)==0){j=1;i=b;return j|0}KQa(f,253720);k=TMa(l,f)|0;QQa(f);if(k){j=1;i=b;return j|0}KQa(g,253728);k=TMa(l,g)|0;QQa(g);if(k){j=2;i=b;return j|0}else{c[e>>2]=lRa(l)|0;jwa(1,1,253736,e);c[d>>2]=253720;c[d+4>>2]=253792;jwa(1,0,253592,d);c[a>>2]=253728;c[a+4>>2]=253808;jwa(1,0,253592,a);le[c[51674]&2047](1);lwa(0,253696,b)}return 0}function XMa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;ZSa(f,a);if(!(aTa(f)|0)){_Sa(f);i=d;return a|0}j=uGa(b)|0;jNa(g,a);k=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;l=k;if(((jCa(l)|0)&176|0)==32){m=b+j|0}else{m=b}n=KRa(k)|0;k=b+j|0;j=e;o=g;c[j+0>>2]=c[o+0>>2];mNa(h,e,b,m,k,l,n);if(!(kNa(h)|0)){_Sa(f);i=d;return a|0}ERa(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,5);_Sa(f);i=d;return a|0}function YMa(a){a=a|0;var b=0;b=i;dTa(a,LRa(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,10)|0)|0;MSa(a)|0;i=b;return a|0}function ZMa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+2128|0;g=f;h=f+32|0;j=f+48|0;k=f+64|0;l=f+80|0;KQa(h,d);zRa(k,253816,h);HFa(j,k,253824);QQa(k);k=lRa(j)|0;d=b+104|0;do{if((c[d>>2]|0)>0){m=b;n=c[m>>2]|0;if((t$a(c[n+4>>2]|0,253832)|0)!=0){break}a[n+104|0]=1;a[(c[m>>2]|0)+((c[d>>2]|0)*112|0)+104|0]=1}}while(0);if((t$a(k,253840)|0)==0){QQa(j);QQa(h);i=f;return}d=b_a(g,k,1)|0;if((d|0)!=0){m=l;B$a(m|0,0,2048)|0;o_a(d,g,m,2048)|0;bTa(XMa(XMa(XMa(XMa(XMa(275808,253848)|0,k)|0,253888)|0,m)|0,253904)|0,103)|0;QQa(j);QQa(h);i=f;return}m=b+108|0;k=c[m>>2]|0;if((k|0)>0){d=b;l=k;k=0;while(1){n=c[d>>2]|0;if((a[n+(k*112|0)+104|0]|0)==0){o=(p_a(g,c[n+(k*112|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[d>>2]|0)+(k*112|0)+104|0]=o;p=c[m>>2]|0}else{p=l}o=k+1|0;if((o|0)<(p|0)){l=p;k=o}else{break}}}k=b+208|0;if((c[k>>2]|0)>0){p=b+32|0;l=b;m=(e|0)==0;d=b+16|0;o=0;do{n=c[p>>2]|0;do{if((a[n+(o*52|0)+48|0]|0)==0){q=a[n+(o*52|0)+8|0]|0;if(q<<24>>24==1){r=(p_a(g,c[n+(o*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(o*52|0)+48|0]=r;r=c[p>>2]|0;if((a[r+(o*52|0)+48|0]|0)!=0|m){break}a[(c[d>>2]|0)+((c[r+(o*52|0)+4>>2]|0)*112|0)+104|0]=0;break}else if(q<<24>>24==0){q=(p_a(g,c[n+(o*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(o*52|0)+48|0]=q;q=c[p>>2]|0;if((a[q+(o*52|0)+48|0]|0)!=0){break}a[(c[l>>2]|0)+((c[q+(o*52|0)+4>>2]|0)*112|0)+104|0]=0;break}else{break}}}while(0);o=o+1|0;}while((o|0)<(c[k>>2]|0))}k=b+116|0;o=c[k>>2]|0;if((o|0)>0){l=b+4|0;p=o;o=0;while(1){d=c[l>>2]|0;if((a[d+(o*60|0)+56|0]|0)==0){m=(p_a(g,c[d+(o*60|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[l>>2]|0)+(o*60|0)+56|0]=m;s=c[k>>2]|0}else{s=p}m=o+1|0;if((m|0)<(s|0)){p=s;o=m}else{break}}}o=b+212|0;if((c[o>>2]|0)>0){s=b+36|0;p=b+4|0;k=(e|0)==0;l=b+20|0;m=0;do{d=c[s>>2]|0;do{if((a[d+(m*52|0)+48|0]|0)==0){n=a[d+(m*52|0)+8|0]|0;if(n<<24>>24==1){q=(p_a(g,c[d+(m*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(m*52|0)+48|0]=q;q=c[s>>2]|0;if((a[q+(m*52|0)+48|0]|0)!=0|k){break}a[(c[l>>2]|0)+((c[q+(m*52|0)+4>>2]|0)*60|0)+56|0]=0;break}else if(n<<24>>24==0){n=(p_a(g,c[d+(m*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(m*52|0)+48|0]=n;n=c[s>>2]|0;if((a[n+(m*52|0)+48|0]|0)!=0){break}a[(c[p>>2]|0)+((c[n+(m*52|0)+4>>2]|0)*60|0)+56|0]=0;break}else{break}}}while(0);m=m+1|0;}while((m|0)<(c[o>>2]|0))}o=b+120|0;m=c[o>>2]|0;if((m|0)>0){p=b+8|0;s=m;m=0;while(1){l=c[p>>2]|0;if((a[l+(m*48|0)+44|0]|0)==0){k=(p_a(g,c[l+(m*48|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(m*48|0)+44|0]=k;t=c[o>>2]|0}else{t=s}k=m+1|0;if((k|0)<(t|0)){s=t;m=k}else{break}}}m=b+216|0;if((c[m>>2]|0)>0){t=b+40|0;s=b+8|0;o=(e|0)==0;p=b+24|0;k=0;do{l=c[t>>2]|0;do{if((a[l+(k*52|0)+48|0]|0)==0){d=a[l+(k*52|0)+8|0]|0;if(d<<24>>24==1){n=(p_a(g,c[l+(k*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[t>>2]|0)+(k*52|0)+48|0]=n;n=c[t>>2]|0;if((a[n+(k*52|0)+48|0]|0)!=0|o){break}a[(c[p>>2]|0)+((c[n+(k*52|0)+4>>2]|0)*48|0)+44|0]=0;break}else if(d<<24>>24==0){d=(p_a(g,c[l+(k*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[t>>2]|0)+(k*52|0)+48|0]=d;d=c[t>>2]|0;if((a[d+(k*52|0)+48|0]|0)!=0){break}a[(c[s>>2]|0)+((c[d+(k*52|0)+4>>2]|0)*48|0)+44|0]=0;break}else{break}}}while(0);k=k+1|0;}while((k|0)<(c[m>>2]|0))}m=b+124|0;k=c[m>>2]|0;if((k|0)>0){s=b+12|0;t=k;k=0;while(1){p=c[s>>2]|0;if((a[p+(k*52|0)+48|0]|0)==0){o=(p_a(g,c[p+(k*52|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(k*52|0)+48|0]=o;u=c[m>>2]|0}else{u=t}o=k+1|0;if((o|0)<(u|0)){t=u;k=o}else{break}}}k=b+220|0;if((c[k>>2]|0)>0){u=b+44|0;t=b+12|0;m=(e|0)==0;e=b+28|0;b=0;do{s=c[u>>2]|0;do{if((a[s+(b*52|0)+48|0]|0)==0){o=a[s+(b*52|0)+8|0]|0;if(o<<24>>24==1){p=(p_a(g,c[s+(b*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[u>>2]|0)+(b*52|0)+48|0]=p;p=c[u>>2]|0;if((a[p+(b*52|0)+48|0]|0)!=0|m){break}a[(c[e>>2]|0)+((c[p+(b*52|0)+4>>2]|0)*52|0)+48|0]=0;break}else if(o<<24>>24==0){o=(p_a(g,c[s+(b*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[u>>2]|0)+(b*52|0)+48|0]=o;o=c[u>>2]|0;if((a[o+(b*52|0)+48|0]|0)!=0){break}a[(c[t>>2]|0)+((c[o+(b*52|0)+4>>2]|0)*52|0)+48|0]=0;break}else{break}}}while(0);b=b+1|0;}while((b|0)<(c[k>>2]|0))}f_a(g);QQa(j);QQa(h);i=f;return}function _Ma(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0;b=i;i=i+8|0;a=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[263268>>2]|0;H=c[263396>>2]|0;I=c[2]|0;if((c[206244>>2]|0)==0){if(!((c[263216>>2]|0)==0|(I|0)!=0)){J=3}}else{J=3}if((J|0)==3){c[2]=1}J=d+248|0;K=d+240|0;L=~~+Eb(+((+h[J>>3]- +h[K>>3])/+h[d+264>>3]));c[d+256>>2]=L;c[l>>2]=L;hwa(23,0,253952,l);l=c[263340>>2]|0;do{if((l|0)==0){M=0}else{if((t$a(l,253976)|0)==0){M=1;break}if((t$a(l,253984)|0)==0){M=0;break}if((t$a(l,253992)|0)==0){M=2;break}c[j>>2]=l;jwa(1,0,254e3,j);M=0}}while(0);if((Axa(M)|0)!=0){c[g>>2]=l;jwa(1,0,254072,g)}if((c[2]|0)!=0){iOa(d+56|0);Fxa((c[d+64>>2]|0)+13+(c[d+68>>2]|0)+(c[d+72>>2]|0)|0);Bxa(0);Bxa(6);Cxa(3);Cxa(4);Cxa(1)}g=(G|0)!=0;if(g){if((H|0)==0){N=+h[K>>3]}else{N=+p$a(H)}h[J>>3]=N;J=f;h[k>>3]=N;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];hwa(1,0,254160,f)}do{if((c[263324>>2]|0)!=0){f=$_a(12)|0;J=f;KQa(J,c[263452>>2]|0);if((f|0)==0){break}f=lRa(J)|0;c[d+280>>2]=f;c[e>>2]=f;hwa(23,0,254216,e)}}while(0);e=c[263448>>2]|0;EQa(m);if((e|0)==0){KQa(p,c[d+88>>2]|0);KQa(q,254264);$Ma(o,p,q);HFa(n,o,c[d+284>>2]|0);RQa(m,n)|0;QQa(n);QQa(o);QQa(q);QQa(p)}else{SQa(m,e)|0}KQa(r,254272);KQa(s,254272);KQa(t,254272);KQa(u,254272);KQa(v,254272);KQa(w,254272);e=c[263216>>2]|0;if((c[263236>>2]|0)!=0){SQa(r,c[263364>>2]|0)|0}if((c[263252>>2]|0)!=0){SQa(s,c[263380>>2]|0)|0}if((c[263232>>2]|0)!=0){SQa(t,c[263360>>2]|0)|0}if((c[263240>>2]|0)==0){O=0.0}else{SQa(u,c[263368>>2]|0)|0;O=+p$a(lRa(u)|0)}if((c[263244>>2]|0)==0){P=1}else{SQa(v,c[263372>>2]|0)|0;P=Ic(lRa(v)|0)|0}if((c[263304>>2]|0)!=0){SQa(w,c[263432>>2]|0)|0}GQa(x,m);GQa(y,r);GQa(z,s);GQa(A,t);GQa(B,w);p=aNa(d,x,y,z,A,O,P,B,e)|0;QQa(B);QQa(A);QQa(z);QQa(y);QQa(x);if((p|0)!=0|g^1){Q=p}else{Bxa(5);p=zNa(d)|0;Exa(5);hwa(1,0,254280,a);Q=p}c[2]=I;if(!((Q|0)==0&(I|0)!=0)){R=Q;QQa(w);QQa(v);QQa(u);QQa(t);QQa(s);QQa(r);QQa(m);i=b;return R|0}Q=d+88|0;KQa(D,c[Q>>2]|0);HFa(C,D,254312);QQa(D);KQa(F,c[Q>>2]|0);HFa(E,F,254328);QQa(F);Exa(0);F=c[263416>>2]|0;Q=lRa(C)|0;D=lRa(E)|0;I=c[d+280>>2]|0;p=c[d+284>>2]|0;YNa(d,Q,D,(F|0)!=0?F:254344,I,p,lRa(m)|0)|0;QQa(E);QQa(C);R=0;QQa(w);QQa(v);QQa(u);QQa(t);QQa(s);QQa(r);QQa(m);i=b;return R|0}function $Ma(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+8|0;FQa(a,d);e=OQa(b)|0;f=OQa(c)|0;pRa(a,PQa(b)|0,e,f+e|0);hRa(a,PQa(c)|0,f)|0;i=d;return}function aNa(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;l=i;i=i+8|0;m=l;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;if((OQa(j)|0)==0){u=0}else{u=lRa(j)|0}GQa(r,b);b=(bNa(a,r,k)|0)==0;QQa(r);if(!b){v=-1;i=l;return v|0}KQa(s,254272);b=a+280|0;r=VMa(s,c[b>>2]|0)|0;QQa(s);do{if(r){w=3}else{s=1;k=0;do{KQa(t,c[254488+(s<<2)>>2]|0);j=VMa(t,c[b>>2]|0)|0;QQa(t);k=j?s:k;s=s+1|0;}while((s|0)<20);if((k|0)!=0){w=k;break}c[q>>2]=c[b>>2];jwa(1,0,254568,q);jwa(1,0,253568,p);s=1;do{j=c[254600+(s<<2)>>2]|0;c[o>>2]=c[254488+(s<<2)>>2];c[o+4>>2]=j;jwa(1,0,253592,o);s=s+1|0;}while((s|0)<20);lwa(c[a+536>>2]|0,253696,n)}}while(0);c[m>>2]=c[254488+(w<<2)>>2];hwa(23,0,254680,m);m=lRa(d)|0;d=lRa(e)|0;e=yAa(a,m,d,lRa(f)|0,g,h,w,u)|0;me[c[247932>>2]&127](247904,a);v=e;i=l;return v|0}function bNa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=c[a+256>>2]<<2;c[61976]=Gd(lRa(b)|0)|0;c[247908>>2]=g;c[247912>>2]=d;d=a+284|0;do{if((c[63386]|0)==0){g=c[d>>2]|0;if((t$a(254352,g)|0)==0){h=0;break}if((t$a(254360,g)|0)==0){c[247920>>2]=103;c[247924>>2]=104;c[247932>>2]=105;h=0;break}if((t$a(254368,g)|0)==0){c[247920>>2]=106;c[247924>>2]=107;c[247928>>2]=108;c[247932>>2]=109;h=1;break}if((t$a(254376,g)|0)==0){c[247920>>2]=110;c[247924>>2]=111;c[247928>>2]=112;c[247932>>2]=113;h=1;break}if((t$a(254384,g)|0)==0){c[247920>>2]=114;c[247924>>2]=115;c[247932>>2]=116;h=0;break}g=XMa(275808,254392)|0;bTa(XMa(g,c[d>>2]|0)|0,103)|0;j=1;i=e;return j|0}else{h=0}}while(0);ZMa(a+8|0,c[a+288>>2]|0,h);me[c[247920>>2]&127](247904,a);a=c[61976]|0;c[f>>2]=c[d>>2];c[f+4>>2]=a;hwa(23,0,254416,f);j=0;i=e;return j|0}function cNa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+16|0;_va();do{if((qOa(a,b)|0)==0){if((sOa(a,b)|0)!=0){break}do{if((c[263272>>2]|0)!=0){w=c[263400>>2]|0;if((t$a(w,254800)|0)==0){ewa(1);break}if((t$a(w,254808)|0)==0){ewa(0);break}else{c[p>>2]=w;jwa(1,0,254816,p);Ad(0)|0;Id(0)}}}while(0);if((c[263228>>2]|0)==0){SMa(0,0);wza(d);if((d|0)==0){bTa(XMa(275808,255184)|0,103)|0}c[d+300>>2]=UMa(0,0)|0;c[d+292>>2]=WMa(0,0)|0;EFa(d+8|0,d+240|0);Eza(d)|0;Mza(d)|0;Yza(d)|0;do{if((c[d+116>>2]|0)==0){if((c[d+124>>2]|0)==0){break}if((c[d+128>>2]|0)==0){break}bTa(XMa(275808,255248)|0,103)|0;x=1;i=e;return x|0}}while(0);c[63386]=c[263296>>2];x=0;i=e;return x|0}KQa(u,c[263356>>2]|0);w=1;while(1){y=211192+(w<<2)|0;KQa(v,c[y>>2]|0);z=TMa(u,v)|0;QQa(v);A=w+1|0;if(z){break}if((A|0)<31){w=A}else{B=33;break}}if((B|0)==33){c[g>>2]=lRa(u)|0;jwa(1,0,255088,g);c[f>>2]=c[b>>2];jwa(1,0,255128,f);Ad(0)|0;Id(0)}A=c[215216+(w<<2)>>2]|0;do{if((A|0)==1){z=c[215088+(w<<2)>>2]|0;c[o>>2]=c[y>>2];c[o+4>>2]=z;hwa(1,1,254888,o)}else{z=c[y>>2]|0;if((A|0)==2){C=c[215088+(w<<2)>>2]|0;c[n>>2]=z;c[n+4>>2]=z;c[n+8>>2]=C;hwa(1,1,254928,n);break}else{c[m>>2]=z;jwa(1,1,254768,m);break}}}while(0);if((w|0)==11){A=1;do{z=c[255056+(A<<2)>>2]|0;c[j>>2]=c[255024+(A<<2)>>2];c[j+4>>2]=z;hwa(1,0,253592,j);A=A+1|0;}while((A|0)<7);D=206696;E=c[51674]|0;le[E&2047](1);F=Ad(0)|0;Id(0)}else if((w|0)==7){A=1;do{z=c[255008+(A<<2)>>2]|0;c[k>>2]=c[254992+(A<<2)>>2];c[k+4>>2]=z;hwa(1,0,253592,k);A=A+1|0;}while((A|0)<4);D=206696;E=c[51674]|0;le[E&2047](1);F=Ad(0)|0;Id(0)}else if((w|0)==29){A=1;do{z=c[254600+(A<<2)>>2]|0;c[h>>2]=c[254488+(A<<2)>>2];c[h+4>>2]=z;hwa(1,0,253592,h);A=A+1|0;}while((A|0)<20);D=206696;E=c[51674]|0;le[E&2047](1);F=Ad(0)|0;Id(0)}else if((w|0)==19){A=c[51108]|0;if((A|0)<28){G=A}else{D=206696;E=c[51674]|0;le[E&2047](1);F=Ad(0)|0;Id(0)}do{A=c[206016+(G<<2)>>2]|0;c[l>>2]=c[204848+(G<<2)>>2];c[l+4>>2]=A;hwa(1,0,253592,l);G=G+1|0;}while((G|0)<28);D=206696;E=c[51674]|0;le[E&2047](1);F=Ad(0)|0;Id(0)}else{D=206696;E=c[51674]|0;le[E&2047](1);F=Ad(0)|0;Id(0)}}}while(0);c[t>>2]=c[b>>2];hwa(1,1,254704,t);t=1;do{b=c[215216+(t<<2)>>2]|0;do{if((b|0)==1){F=c[213096+(t<<2)>>2]|0;c[s>>2]=c[211192+(t<<2)>>2];c[s+4>>2]=F;hwa(1,0,254720,s)}else{F=c[211192+(t<<2)>>2]|0;if((b|0)==2){E=c[213096+(t<<2)>>2]|0;c[r>>2]=F;c[r+4>>2]=F;c[r+8>>2]=E;hwa(1,0,254736,r);break}else{c[q>>2]=F;jwa(1,0,254768,q);break}}}while(0);t=t+1|0;}while((t|0)<31);le[c[51674]&2047](1);Ad(0)|0;Id(0);return 0}function dNa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0;a=i;i=i+8|0;b=a;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=c[63820]|0;wb(256928)|0;c[l>>2]=c[m+88>>2];kc(255288,l|0)|0;wb(256944)|0;l=j;h[k>>3]=+h[m+264>>3];c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];kc(255312,j|0)|0;j=m+4|0;m=g;h[k>>3]=+h[c[(c[j>>2]|0)+4>>2]>>3];c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];kc(255352,g|0)|0;g=f;h[k>>3]=+h[c[(c[j>>2]|0)+8>>2]>>3];c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];kc(255384,f|0)|0;f=c[j>>2]|0;g=e;h[k>>3]=+h[c[f+4>>2]>>3]- +h[c[f+8>>2]>>3];c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];kc(255416,e|0)|0;e=d;h[k>>3]=+h[c[c[j>>2]>>2]>>3];c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];kc(255448,d|0)|0;d=c[j>>2]|0;j=b;h[k>>3]=+h[c[d>>2]>>3]- +h[c[d+4>>2]>>3];c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];kc(255480,b|0)|0;wb(256968)|0;i=a;return}function eNa(a,b){a=a|0;b=+b;i=i;return}function fNa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0;e=i;f=i;i=i+168|0;c[f>>2]=0;g=i;i=i+160|0;h=(c[d+536>>2]|0)+76|0;j=c[h>>2]|0;c[h>>2]=g;w$a(g,1,f|0)|0;u=0;g=u;u=0;if((g|0)!=0&(v|0)!=0){k=K$a(c[g>>2]|0,f)|0;if((k|0)==0){fb(g|0,v|0)}J=v}else{k=-1}if((k|0)==1){l=J}else{l=0}while(1){if((l|0)==0){u=0;k=va(42,a|0,b|0,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){m=K$a(c[g>>2]|0,f)|0;if((m|0)==0){fb(g|0,v|0)}J=v}else{m=-1}if((m|0)==1){l=J;continue}if((k|0)!=0){n=1;o=17;break}c[63820]=d;u=0;Ha(61,10,1272)|0;k=u;u=0;if((k|0)!=0&(v|0)!=0){p=K$a(c[k>>2]|0,f)|0;if((p|0)==0){fb(k|0,v|0)}J=v}else{p=-1}if((p|0)==1){l=J;continue}u=0;k=va(43,0,0,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){q=K$a(c[g>>2]|0,f)|0;if((q|0)==0){fb(g|0,v|0)}J=v}else{q=-1}if((q|0)==1){l=J;continue}u=0;sa(108,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){r=K$a(c[g>>2]|0,f)|0;if((r|0)==0){fb(g|0,v|0)}J=v}else{r=-1}if((r|0)==1){l=J;continue}u=0;sa(109,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){s=K$a(c[g>>2]|0,f)|0;if((s|0)==0){fb(g|0,v|0)}J=v}else{s=-1}if((s|0)==1){l=J;continue}u=0;sa(110,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){t=K$a(c[g>>2]|0,f)|0;if((t|0)==0){fb(g|0,v|0)}J=v}else{t=-1}if((t|0)==1){l=J;continue}u=0;pa(c[(c[d+540>>2]|0)+8>>2]|0,d|0);g=u;u=0;if((g|0)!=0&(v|0)!=0){w=K$a(c[g>>2]|0,f)|0;if((w|0)==0){fb(g|0,v|0)}J=v}else{w=-1}if((w|0)==1){l=J;continue}u=0;pa(1273,d|0);g=u;u=0;if((g|0)!=0&(v|0)!=0){x=K$a(c[g>>2]|0,f)|0;if((x|0)==0){fb(g|0,v|0)}J=v}else{x=-1}if((x|0)==1){l=J;continue}u=0;sa(99,0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){y=K$a(c[g>>2]|0,f)|0;if((y|0)==0){fb(g|0,v|0)}J=v}else{y=-1}if((y|0)==1){l=J;continue}z=k}else{z=-1}c[h>>2]=j;u=0;k=u;u=0;if((k|0)!=0&(v|0)!=0){A=K$a(c[k>>2]|0,f)|0;if((A|0)==0){fb(k|0,v|0)}J=v}else{A=-1}if((A|0)==1){l=J}else{break}}if((o|0)==17){i=e;return n|0}n=z;i=e;return n|0}function gNa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;f=i;i=i+16|0;if((a|0)==0){g=rd(c[50986]|0)|0}else{g=a}switch(c[g+84>>2]|0){case 1:{c[f>>2]=e;a=c[r>>2]|0;uc(255616,7,1,a|0)|0;Gc(a|0,d|0,f|0)|0;Yd(10,a|0)|0;Ad(0)|0;fb(c[g+80>>2]|0,1);break};case 5:case 4:{i=b;return};case 2:{if((c[206156>>2]|0)==0){h=g;j=h+80|0;k=j;l=c[k>>2]|0;m=l;n=m;fb(n|0,1)}c[f>>2]=e;a=c[r>>2]|0;uc(255616,7,1,a|0)|0;Gc(a|0,d|0,f|0)|0;Yd(10,a|0)|0;Ad(0)|0;h=g;j=h+80|0;k=j;l=c[k>>2]|0;m=l;n=m;fb(n|0,1);break};case 3:{if((c[206212>>2]|0)==0){i=b;return}c[f>>2]=e;e=c[r>>2]|0;uc(255616,7,1,e|0)|0;Gc(e|0,d|0,f|0)|0;Yd(10,e|0)|0;Ad(0)|0;i=b;return};default:{lwa(g,255624,b)}}}function hNa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;i=i+16|0;e=a;c[e>>2]=d;d=c[r>>2]|0;uc(255600,9,1,d|0)|0;Gc(d|0,b|0,e|0)|0;Yd(10,d|0)|0;Ad(0)|0;i=a;return}function iNa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;pNa(255544,b);c[63378]=254272;b=253516|0;c[b+0>>2]=-1;c[b+4>>2]=-1;c[b+8>>2]=-1;c[b+12>>2]=-1;c[253532>>2]=1;if((a|0)!=0){d=a;e=d;f=e+76|0;g=f;h=c[g>>2]|0;j=h;k=j;fb(k|0,1)}d=rd(c[50986]|0)|0;e=d;f=e+76|0;g=f;h=c[g>>2]|0;j=h;k=j;fb(k|0,1)}function jNa(a,b){a=a|0;b=b|0;var c=0;c=i;lNa(a,b);i=c;return}function kNa(a){a=a|0;i=i;return(c[a>>2]|0)==0|0}function lNa(a,b){a=a|0;b=b|0;var d=0;d=i;c[a>>2]=JRa(b+(c[(c[b>>2]|0)+ -12>>2]|0)|0)|0;i=d;return}function mNa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i;i=i+48|0;k=j+8|0;l=j+16|0;m=j+32|0;n=j+40|0;o=b;b=c[o>>2]|0;fCa(j);if((b|0)==0){c[a>>2]=0;i=j;return}p=f;f=d;q=p-f|0;r=nNa(g)|0;s=(r|0)>(q|0)?r-q|0:0;q=e;r=q-f|0;do{if((r|0)>0){if((VRa(b,d,r)|0)==(r|0)){break}fCa(k);c[o>>2]=0;c[a>>2]=0;i=j;return}}while(0);do{if((s|0)>0){LQa(l,s,h);if((VRa(b,PQa(l)|0,s)|0)==(s|0)){QQa(l);break}fCa(m);c[o>>2]=0;c[a>>2]=0;QQa(l);i=j;return}}while(0);l=p-q|0;do{if((l|0)>0){if((VRa(b,e,l)|0)==(l|0)){break}fCa(n);c[o>>2]=0;c[a>>2]=0;i=j;return}}while(0);oNa(g,0)|0;c[a>>2]=b;i=j;return}function nNa(a){a=a|0;i=i;return c[a+12>>2]|0}function oNa(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;a=c[d>>2]|0;c[d>>2]=b;i=i;return a|0}function pNa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=d+8|0;g=c[63384]|0;if((g|0)==0){c[e>>2]=(x$a(a|0)|0)<<1|1;c[f>>2]=2048;h=c[(vGa(e,f)|0)>>2]|0;c[63898]=h;f=V_a(h)|0;c[63384]=f;j=h;k=f}else{j=c[63898]|0;k=g}g=bd(k|0,j|0,a|0,b|0)|0;if(g>>>0<(c[63898]|0)>>>0){i=d;return}W_a(c[63384]|0);j=g<<1|1;c[63898]=j;g=V_a(j)|0;c[63384]=g;bd(g|0,j|0,a|0,b|0)|0;i=d;return}function qNa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+136|0;g=f;rNa(g,16);sNa(g+(c[(c[g>>2]|0)+ -12>>2]|0)|0,16)|0;if((d|0)<=0){tNa(a,g);uNa(g);i=f;return}j=e+ -1|0;k=(j|0)>0;l=(e|0)>0;m=g;n=(e|0)==0;e=0;do{if(k){o=0;p=e;while(1){XMa(cTa(m,+h[b+(p<<3)>>3])|0,256984)|0;q=p+d|0;r=o+1|0;if((r|0)<(j|0)){p=q;o=r}else{s=q;break}}}else{s=e}if(l){cTa(m,+h[b+(s<<3)>>3])|0}e=e+1|0;if(!((e|0)==(d|0)|n)){XMa(m,256992)|0}}while((e|0)<(d|0));tNa(a,g);uNa(g);i=f;return}function rNa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=a+56|0;NRa(e);f=a;c[f>>2]=257364;g=e;c[g>>2]=257384;e=a+4|0;USa(a,257396|0,e);c[f>>2]=257364;c[g>>2]=257384;GNa(e,b|16);i=d;return}function sNa(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;a=c[d>>2]|0;c[d>>2]=b;i=i;return a|0}function tNa(a,b){a=a|0;b=b|0;var c=0;c=i;ANa(a,b+4|0);i=c;return}function uNa(a){a=a|0;var b=0;b=i;KNa(a,257392);IRa(a+56|0);i=b;return}function vNa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+120>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[206200>>2]|0)!=0){wb(257688)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];hwa(14,0,257e3,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);oe[c[(c[l>>2]|0)+160>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];hwa(14,0,257072,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[206200>>2]|0)==0){i=d;return 0}hwa(14,0,257120,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];kc(257136,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}hc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function wNa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+124>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[206200>>2]|0)!=0){wb(257688)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];hwa(14,0,257e3,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);oe[c[(c[l>>2]|0)+164>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];hwa(14,0,257072,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[206200>>2]|0)==0){i=d;return 0}hwa(14,0,257120,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];kc(257136,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}hc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function xNa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+128>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[206200>>2]|0)!=0){wb(257688)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];hwa(14,0,257e3,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);oe[c[(c[l>>2]|0)+168>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];hwa(14,0,257072,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[206200>>2]|0)==0){i=d;return 0}hwa(14,0,257120,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];kc(257136,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}hc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function yNa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+132>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[206200>>2]|0)!=0){wb(257688)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];hwa(14,0,257e3,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);oe[c[(c[l>>2]|0)+172>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];hwa(14,0,257072,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[206200>>2]|0)==0){i=d;return 0}hwa(14,0,257120,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];kc(257136,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}hc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function zNa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;b=i;i=i+24|0;d=b;e=i;i=i+24|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=c[a+112>>2]|0;G=c[a+152>>2]|0;H=c[a+156>>2]|0;I=X_a(fa(F,F)|0,8)|0;J=I;K=X_a(fa(G,F)|0,8)|0;L=K;M=X_a(fa(H,F)|0,8)|0;N=M;O=X_a(fa(H,G)|0,8)|0;P=O;EQa(p);EQa(q);EQa(r);EQa(s);EQa(t);EQa(u);EQa(v);Q=a+536|0;kwa(c[Q>>2]|0,(I|0)!=0|0,257144,o);kwa(c[Q>>2]|0,(K|0)!=0|0,257144,n);kwa(c[Q>>2]|0,(M|0)!=0|0,257144,m);kwa(c[Q>>2]|0,(O|0)!=0|0,257144,l);l=a+540|0;m=a;if((oe[c[(c[l>>2]|0)+140>>2]&127](m)|0)==0){n=c[Q>>2]|0;vNa(a,J)|0;kwa(n,1,257160,k)}qNa(w,J,F,F);RQa(p,w)|0;QQa(w);if((oe[c[(c[l>>2]|0)+144>>2]&127](m)|0)==0){w=c[Q>>2]|0;wNa(a,L)|0;kwa(w,1,257192,j)}qNa(x,L,F,G);RQa(q,x)|0;QQa(x);if((oe[c[(c[l>>2]|0)+148>>2]&127](m)|0)==0){x=c[Q>>2]|0;xNa(a,N)|0;kwa(x,1,257224,h)}qNa(y,N,H,F);RQa(r,y)|0;QQa(y);if((oe[c[(c[l>>2]|0)+152>>2]&127](m)|0)==0){m=c[Q>>2]|0;yNa(a,P)|0;kwa(m,1,257256,g)}qNa(z,P,H,G);RQa(s,z)|0;QQa(z);if((F|0)==0){SQa(t,257288)|0}else{qNa(A,c[(c[c[a+4>>2]>>2]|0)+8>>2]|0,1,F);RQa(t,A)|0;QQa(A)}if((G|0)==0){SQa(u,257288)|0}else{qNa(B,c[a+432>>2]|0,1,G);RQa(u,B)|0;QQa(B)}W_a(I);W_a(K);W_a(M);W_a(O);KQa(E,c[a+84>>2]|0);zRa(D,257304,E);HFa(C,D,257312);RQa(v,C)|0;QQa(C);QQa(D);QQa(E);E=mc(lRa(v)|0,257320)|0;D=c[Q>>2]|0;c[f>>2]=lRa(v)|0;kwa(D,(E|0)!=0|0,257328,f);f=Ie[c[(c[l>>2]|0)+176>>2]&7]()|0;D=lRa(t)|0;Q=lRa(u)|0;C=lRa(p)|0;a=lRa(q)|0;O=lRa(r)|0;M=lRa(s)|0;c[e>>2]=D;c[e+4>>2]=Q;c[e+8>>2]=C;c[e+12>>2]=a;c[e+16>>2]=O;c[e+20>>2]=M;Cd(E|0,f|0,e|0)|0;if((c[206244>>2]|0)==0){R=Ad(E|0)|0;S=ad(E|0)|0;QQa(v);QQa(u);QQa(t);QQa(s);QQa(r);QQa(q);QQa(p);i=b;return 0}e=Ie[c[(c[l>>2]|0)+176>>2]&7]()|0;l=lRa(t)|0;f=lRa(u)|0;M=lRa(p)|0;O=lRa(q)|0;a=lRa(r)|0;C=lRa(s)|0;c[d>>2]=l;c[d+4>>2]=f;c[d+8>>2]=M;c[d+12>>2]=O;c[d+16>>2]=a;c[d+20>>2]=C;hwa(25,0,e,d);R=Ad(E|0)|0;S=ad(E|0)|0;QQa(v);QQa(u);QQa(t);QQa(s);QQa(r);QQa(q);QQa(p);i=b;return 0}function ANa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;h=c[b+48>>2]|0;if((h&16|0)!=0){j=b+44|0;k=c[j>>2]|0;l=b;m=bSa(l)|0;if(k>>>0<m>>>0){c[j>>2]=m;n=m}else{n=k}BNa(a,aSa(l)|0,n,e);i=d;return}if((h&8|0)==0){FQa(a,g);i=d;return}else{g=b;b=XRa(g)|0;BNa(a,b,ZRa(g)|0,f);i=d;return}}function BNa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;CNa(a,b,c,0);i=d;return}function CNa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;DNa(a,b,c);i=d;return}function DNa(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=ENa(c,d)|0;if(g>>>0>4294967279){CQa(0)}if(g>>>0<11){WQa(b,g);h=VQa(b)|0}else{j=bRa(g)|0;k=j+1|0;j=rGa(JQa(b)|0,k)|0;dRa(b,j);cRa(b,k);UQa(b,g);h=j}if((c|0)==(d|0)){l=h;a[f]=0;sGa(l,f);i=e;return}j=d+(0-c)|0;g=c;c=h;while(1){sGa(c,g);b=g+1|0;if((b|0)==(d|0)){break}else{c=c+1|0;g=b}}l=h+j|0;a[f]=0;sGa(l,f);i=e;return}function ENa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=FNa(b,c,e)|0;i=d;return g|0}function FNa(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return b-a|0}function GNa(a,b){a=a|0;b=b|0;var c=0;c=i;WNa(a,b);i=c;return}function HNa(a){a=a|0;var b=0;b=i;uNa(a);b$a(a);i=b;return}function INa(a){a=a|0;var b=0;b=i;uNa(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function JNa(a){a=a|0;var b=0;b=i;HNa(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function KNa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];LNa(a+4|0);i=d;return}function LNa(a){a=a|0;var b=0;b=i;MNa(a);i=b;return}function MNa(a){a=a|0;var b=0;b=i;c[a>>2]=257544;QQa(a+32|0);RRa(a);i=b;return}function NNa(a){a=a|0;var b=0;b=i;LNa(a);b$a(a);i=b;return}function ONa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;j=b+44|0;k=c[j>>2]|0;l=b;m=bSa(l)|0;if(k>>>0<m>>>0){c[j>>2]=m;n=m}else{n=k}k=g&24;do{if((k|0)==0){tBa(a,-1,-1);i=h;return}else if((k|0)==24){if((f|0)==2){o=11;break}else if((f|0)==0){p=0;q=0;break}else if((f|0)!=1){o=12;break}tBa(a,-1,-1);i=h;return}else{if((f|0)==2){o=11;break}else if((f|0)==0){p=0;q=0;break}else if((f|0)!=1){o=12;break}if((g&8|0)==0){m=bSa(l)|0;j=m-(aSa(l)|0)|0;p=j;q=((j|0)<0)<<31>>31;break}else{j=YRa(l)|0;m=j-(XRa(l)|0)|0;p=m;q=((m|0)<0)<<31>>31;break}}}while(0);if((o|0)==11){f=n-(PQa(b+32|0)|0)|0;p=f;q=((f|0)<0)<<31>>31}else if((o|0)==12){tBa(a,-1,-1);i=h;return}o=H$a(p|0,q|0,d|0,e|0)|0;e=J;do{if(!((e|0)<0|(e|0)==0&o>>>0<0)){d=n-(PQa(b+32|0)|0)|0;q=((d|0)<0)<<31>>31;if((q|0)<(e|0)|(q|0)==(e|0)&d>>>0<o>>>0){break}d=g&8;do{if(!((o|0)==0&(e|0)==0)){do{if((d|0)!=0){if((YRa(l)|0)!=0){break}tBa(a,-1,-1);i=h;return}}while(0);if((g&16|0)==0){break}if((bSa(l)|0)!=0){break}tBa(a,-1,-1);i=h;return}}while(0);if((d|0)!=0){q=XRa(l)|0;$Ra(l,q,q+o|0,n)}if((g&16|0)!=0){q=aSa(l)|0;eSa(l,q,cSa(l)|0);dSa(l,o)}tBa(a,o,e);i=h;return}}while(0);tBa(a,-1,-1);i=h;return}function PNa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=c[(c[b>>2]|0)+16>>2]|0;h=HCa(d)|0;xe[g&31](a,b,h,J,0,e);i=f;return}function QNa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=b+44|0;f=c[e>>2]|0;g=b;h=bSa(g)|0;if(f>>>0<h>>>0){c[e>>2]=h;j=h}else{j=f}if((c[b+48>>2]&8|0)==0){k=-1;i=d;return k|0}if((ZRa(g)|0)>>>0<j>>>0){b=XRa(g)|0;$Ra(g,b,YRa(g)|0,j)}j=YRa(g)|0;if(!(j>>>0<(ZRa(g)|0)>>>0)){k=-1;i=d;return k|0}k=dDa(a[j]|0)|0;i=d;return k|0}function RNa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=b+44|0;g=c[f>>2]|0;h=b;j=bSa(h)|0;if(g>>>0<j>>>0){c[f>>2]=j;k=j}else{k=g}g=XRa(h)|0;j=YRa(h)|0;if(!(g>>>0<j>>>0)){l=-1;i=e;return l|0}if($Ca(d,-1)|0){$Ra(h,g,j+ -1|0,k);l=cDa(d)|0;i=e;return l|0}g=(c[b+48>>2]&16|0)==0;b=aDa(d)|0;do{if(g){if(eDa(b,a[j+ -1|0]|0)|0){break}else{l=-1}i=e;return l|0}}while(0);j=XRa(h)|0;$Ra(h,j,(YRa(h)|0)+ -1|0,k);a[YRa(h)|0]=b;l=d;i=e;return l|0}function SNa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+8|0;e=d;if($Ca(b,-1)|0){f=cDa(b)|0;i=d;return f|0}g=a;h=YRa(g)|0;j=h-(XRa(g)|0)|0;h=bSa(g)|0;do{if((h|0)==(cSa(g)|0)){k=a+48|0;if((c[k>>2]&16|0)==0){f=-1;i=d;return f|0}else{l=aSa(g)|0;m=a+44|0;n=(c[m>>2]|0)-l|0;o=a+32|0;gRa(o,0);$Qa(o,YQa(o)|0);p=PQa(o)|0;eSa(g,p,p+(OQa(o)|0)|0);dSa(g,h-l|0);c[m>>2]=(aSa(g)|0)+n;q=k;r=m;break}}else{q=a+48|0;r=a+44|0}}while(0);c[e>>2]=(bSa(g)|0)+1;h=c[(TNa(e,r)|0)>>2]|0;c[r>>2]=h;if((c[q>>2]&8|0)!=0){q=PQa(a+32|0)|0;$Ra(g,q,q+j|0,h)}f=URa(g,b&255)|0;i=d;return f|0}function TNa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=UNa(b,c,e)|0;i=d;return g|0}function UNa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=VNa(0,a,b)|0;i=c;return(d?b:a)|0}function VNa(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)>>>0<(c[d>>2]|0)>>>0|0}function WNa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;WRa(a);c[a>>2]=257544;EQa(a+32|0);c[a+44>>2]=0;c[a+48>>2]=b;EQa(e);XNa(a,e);QQa(e);i=d;return}function XNa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+32|0;RQa(e,b)|0;b=a+44|0;c[b>>2]=0;f=a+48|0;g=c[f>>2]|0;if((g&8|0)==0){h=g}else{g=PQa(e)|0;j=g+(OQa(e)|0)|0;c[b>>2]=j;g=PQa(e)|0;$Ra(a,g,g,j);h=c[f>>2]|0}if((h&16|0)==0){i=d;return}h=OQa(e)|0;c[b>>2]=(PQa(e)|0)+h;$Qa(e,YQa(e)|0);b=a;a=PQa(e)|0;eSa(b,a,a+(OQa(e)|0)|0);if((c[f>>2]&3|0)==0){i=d;return}dSa(b,h);i=d;return}function YNa(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0;j=i;i=i+8|0;g=j;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=mc(d|0,257968)|0;J=fd(257976,257968)|0;K=(J|0)!=0;L=Qc()|0;if(K){M=c[b+536>>2]|0;N=ae(c[L>>2]|0)|0;c[E>>2]=d;c[E+4>>2]=N;kwa(M,(I|0)!=0|0,258032,E);uc(258056,17,1,J|0)|0;uc(258080,10,1,J|0)|0;uc(258096,18,1,J|0)|0;ZNa(J,f,258120,c[b+88>>2]|0,(c[b+72>>2]|0)+(c[b+64>>2]|0)|0,-1,999,258152)}else{c[G>>2]=ae(c[L>>2]|0)|0;jwa(26,0,257984,G);G=c[b+536>>2]|0;E=ae(c[L>>2]|0)|0;c[F>>2]=d;c[F+4>>2]=E;kwa(G,(I|0)!=0|0,258032,F)}uc(258160,348,1,I|0)|0;if((vc(H|0)|0)<0){c[D>>2]=ae(c[L>>2]|0)|0;jwa(26,0,258512,D);ad(I|0)|0;bb(J|0)|0;O=1;i=j;return O|0}if((Vc(257712,250,258536,pd(H|0)|0)|0)==0){jwa(26,0,258560,C);ad(I|0)|0;O=1;i=j;return O|0}uc(258584,13,1,I|0)|0;uc(258600,12,1,I|0)|0;_Na(I,2);uc(258616,6,1,I|0)|0;$Na(I,c[b+84>>2]|0);uc(258624,8,1,I|0)|0;_Na(I,2);uc(258640,8,1,I|0)|0;C=b+88|0;$Na(I,c[C>>2]|0);uc(258656,10,1,I|0)|0;_Na(I,2);uc(258672,6,1,I|0)|0;$Na(I,257712);uc(258680,8,1,I|0)|0;_Na(I,2);uc(258696,8,1,I|0)|0;$Na(I,c[b+280>>2]|0);uc(258712,10,1,I|0)|0;_Na(I,2);uc(258728,14,1,I|0)|0;$Na(I,c[b+284>>2]|0);uc(258744,16,1,I|0)|0;_Na(I,2);uc(258768,16,1,I|0)|0;$Na(I,l);uc(258792,18,1,I|0)|0;_Na(I,2);c[B>>2]=aOa(l)|0;Cd(I|0,258816,B|0)|0;_Na(I,2);P=+wxa(7);B=A;h[k>>3]=P;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];Cd(I|0,258856,A|0)|0;_Na(I,2);P=+wxa(6);A=z;h[k>>3]=P;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];Cd(I|0,258896,z|0)|0;_Na(I,2);P=+wxa(1);z=y;h[k>>3]=P;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Cd(I|0,258928,y|0)|0;_Na(I,2);P=+wxa(4);y=x;h[k>>3]=P;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];Cd(I|0,258960,x|0)|0;_Na(I,2);P=+wxa(3);x=w;h[k>>3]=P;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];Cd(I|0,258992,w|0)|0;_Na(I,2);P=+wxa(5);w=v;h[k>>3]=P;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];Cd(I|0,259024,v|0)|0;_Na(I,2);P=+wxa(0);v=u;h[k>>3]=P;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];Cd(I|0,259064,u|0)|0;_Na(I,2);P=+zxa(2);u=t;h[k>>3]=P;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];Cd(I|0,259096,t|0)|0;_Na(I,2);c[s>>2]=uxa(2)|0;Cd(I|0,259136,s|0)|0;_Na(I,2);P=+yxa(2);s=r;h[k>>3]=P;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];Cd(I|0,259160,r|0)|0;uc(259192,13,1,I|0)|0;uc(259208,16,1,I|0)|0;_Na(I,2);P=+wxa(8);r=q;h[k>>3]=P;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];Cd(I|0,259232,q|0)|0;_Na(I,2);c[p>>2]=rxa(8)|0;Cd(I|0,259256,p|0)|0;uc(259296,17,1,I|0)|0;uc(259320,22,1,I|0)|0;bOa(I,b);uc(259344,23,1,I|0)|0;uc(259368,12,1,I|0)|0;p=b+116|0;if((c[p>>2]|0)>0){q=b+8|0;r=0;do{cOa(I,(c[q>>2]|0)+(r*112|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+136|0;if((c[p>>2]|0)>0){r=b+24|0;q=0;do{cOa(I,(c[r>>2]|0)+(q*112|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+124|0;if((c[p>>2]|0)>0){q=b+12|0;r=0;do{cOa(I,(c[q>>2]|0)+(r*60|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+140|0;if((c[p>>2]|0)>0){r=b+28|0;q=0;do{cOa(I,(c[r>>2]|0)+(q*60|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+128|0;if((c[p>>2]|0)>0){q=b+16|0;r=0;do{cOa(I,(c[q>>2]|0)+(r*48|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+144|0;if((c[p>>2]|0)>0){r=b+32|0;q=0;do{cOa(I,(c[r>>2]|0)+(q*48|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+132|0;if((c[p>>2]|0)>0){q=b+20|0;r=0;do{cOa(I,(c[q>>2]|0)+(r*52|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+148|0;if((c[p>>2]|0)>0){r=b+36|0;q=0;do{cOa(I,(c[r>>2]|0)+(q*52|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}uc(259384,13,1,I|0)|0;uc(259400,12,1,I|0)|0;dOa(I,J,f,c[C>>2]|0,b);uc(259416,13,1,I|0)|0;uc(259432,12,1,I|0)|0;eOa(I,c[b+68>>2]|0,b+56|0);uc(259448,13,1,I|0)|0;uc(259464,16,1,I|0)|0;fOa(I,J,f,b);uc(259488,17,1,I|0)|0;uc(259512,14,1,I|0)|0;ad(I|0)|0;if(!K){O=0;i=j;return O|0}K=c[b+508>>2]|0;b=((x$a(e|0)|0)<<1)+230|0;e=(K|0)!=0;if(e){Q=(x$a(K|0)|0)<<1}else{Q=0}I=V_a(b+Q|0)|0;if((I|0)==0){db(259528,259536,404,259560)}if((bb(J|0)|0)!=0){jwa(26,0,259576,o)}if(e){e=c[C>>2]|0;c[n>>2]=259608;c[n+4>>2]=e;c[n+8>>2]=K;c[n+12>>2]=e;lc(I|0,259624,n|0)|0;if((xd(I|0)|0)!=0){R=42}}else{n=I+0|0;e=259704|0;K=n+25|0;do{a[n]=a[e]|0;n=n+1|0;e=e+1|0}while((n|0)<(K|0));R=42}if((R|0)==42){c[m>>2]=I;jwa(1,0,259736,m)}m=c[C>>2]|0;c[g>>2]=m;c[g+4>>2]=m;hwa(1,0,259800,g);W_a(I);O=0;i=j;return O|0}function ZNa(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0.0,N=0.0,O=0.0;m=i;i=i+24|0;n=m;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+24|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+24|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+24|0;C=i;i=i+8|0;D=i;i=i+16|0;if((a|0)==0){i=m;return}E=(g|0)>-1;if(E){F=g+9|0;G=sxa(F)|0;H=txa(F)|0;if((G|0)==0){I=-.01}else{I=+(G>>>0)*.95}if((H|0)==0){J=.01}else{J=+(H>>>0)*1.05}K=H;L=G;M=+yxa(F)*1.01+1.0e-30;N=J;O=I}else{K=0;L=0;M=0.0;N=0.0;O=0.0}uc(258056,17,1,a|0)|0;uc(260968,12,1,a|0)|0;uc(260984,12,1,a|0)|0;uc(261e3,13,1,a|0)|0;c[D>>2]=e;c[D+4>>2]=l;c[D+8>>2]=j;Cd(a|0,261016,D|0)|0;uc(261056,10,1,a|0)|0;uc(261072,11,1,a|0)|0;uc(261088,11,1,a|0)|0;uc(261104,10,1,a|0)|0;if(E){D=C;h[k>>3]=M;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];Cd(a|0,261120,C|0)|0}else{uc(261144,17,1,a|0)|0}C=g+3|0;c[B>>2]=e;c[B+4>>2]=f;c[B+8>>2]=f;c[B+12>>2]=C;c[B+16>>2]=C;c[B+20>>2]=4;Cd(a|0,260744,B|0)|0;uc(261168,13,1,a|0)|0;if(E){uc(260984,12,1,a|0)|0;if((L|0)==(K|0)){B=A;h[k>>3]=O;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=N;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];Cd(a|0,261184,A|0)|0}else{uc(261144,17,1,a|0)|0}c[z>>2]=e;c[z+4>>2]=l;c[z+8>>2]=j;Cd(a|0,261208,z|0)|0;c[y>>2]=e;c[y+4>>2]=f;c[y+8>>2]=f;c[y+12>>2]=g+1;c[y+16>>2]=4;Cd(a|0,260864,y|0)|0;uc(261256,10,1,a|0)|0;uc(261272,10,1,a|0)|0;uc(261256,10,1,a|0)|0;uc(261288,11,1,a|0)|0;c[x>>2]=b;Cd(a|0,261304,x|0)|0;c[w>>2]=d;Cd(a|0,261328,w|0)|0;uc(261344,33,1,a|0)|0;uc(261384,32,1,a|0)|0;c[v>>2]=e;c[v+4>>2]=l;c[v+8>>2]=j;c[v+12>>2]=b;Cd(a|0,261424,v|0)|0;uc(261104,10,1,a|0)|0;v=u;h[k>>3]=M;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];Cd(a|0,261120,u|0)|0}else{uc(261272,10,1,a|0)|0;uc(261256,10,1,a|0)|0;uc(261288,11,1,a|0)|0;c[t>>2]=b;Cd(a|0,261304,t|0)|0;c[s>>2]=d;Cd(a|0,261328,s|0)|0;uc(261344,33,1,a|0)|0;uc(261384,32,1,a|0)|0;c[r>>2]=e;c[r+4>>2]=l;c[r+8>>2]=j;c[r+12>>2]=b;Cd(a|0,261424,r|0)|0;uc(261104,10,1,a|0)|0;uc(261144,17,1,a|0)|0}c[q>>2]=e;c[q+4>>2]=f;c[q+8>>2]=f;c[q+12>>2]=C;c[q+16>>2]=C;c[q+20>>2]=2;Cd(a|0,260744,q|0)|0;uc(261168,13,1,a|0)|0;if(!E){i=m;return}if((L|0)==(K|0)){K=p;h[k>>3]=O;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];K=p+8|0;h[k>>3]=N;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];Cd(a|0,261184,p|0)|0}else{uc(261144,17,1,a|0)|0}uc(261456,32,1,a|0)|0;uc(261496,29,1,a|0)|0;c[o>>2]=e;c[o+4>>2]=l;c[o+8>>2]=j;c[o+12>>2]=b;Cd(a|0,261528,o|0)|0;c[n>>2]=e;c[n+4>>2]=f;c[n+8>>2]=f;c[n+12>>2]=g+1;c[n+16>>2]=2;Cd(a|0,260864,n|0)|0;i=m;return}function _Na(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((b|0)==0){i=c;return}else{d=b}do{d=d+ -1|0;Yd(32,a|0)|0;}while((d|0)!=0);i=c;return}function $Na(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;e=a[c]|0;if(e<<24>>24==0){i=d;return}else{f=c;g=e}do{e=g<<24>>24;if((e|0)==39){uc(260728,6,1,b|0)|0}else if((e|0)==62){uc(260720,4,1,b|0)|0}else if((e|0)==60){uc(260712,4,1,b|0)|0}else if((e|0)==34){uc(260736,6,1,b|0)|0}else{Yd(e|0,b|0)|0}f=f+1|0;g=a[f]|0;}while(!(g<<24>>24==0));i=d;return}function aOa(a){a=a|0;var b=0,c=0,d=0;b=i;c=mc(a|0,260704)|0;if((c|0)==0){d=-1;i=b;return d|0}Zc(c|0,0,2)|0;a=Bb(c|0)|0;ad(c|0)|0;d=a;i=b;return d|0}function bOa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;h=i;i=i+24|0;j=i;i=i+32|0;k=i;i=i+24|0;l=c[b+88>>2]|0;m=V_a((x$a(l|0)|0)+15|0)|0;c[f>>2]=l;lc(m|0,260432,f|0)|0;_Na(a,2);uc(260448,10,1,a|0)|0;$Na(a,m);uc(260464,12,1,a|0)|0;_Na(a,2);c[e>>2]=aOa(m)|0;Cd(a|0,260480,e|0)|0;W_a(m);_Na(a,2);uc(260512,9,1,a|0)|0;_Na(a,4);uc(260528,22,1,a|0)|0;_Na(a,4);uc(260552,22,1,a|0)|0;_Na(a,4);uc(260576,26,1,a|0)|0;m=b+56|0;e=b+64|0;f=c[e>>2]|0;if((f|0)>0){l=g+4|0;n=0;while(1){hOa(g,m,n);o=c[l>>2]|0;_Na(a,4);uc(260608,8,1,a|0)|0;$Na(a,o);uc(260624,18,1,a|0)|0;o=n+1|0;p=c[e>>2]|0;if((o|0)<(p|0)){n=o}else{q=p;break}}}else{q=f}f=b+72|0;b=c[f>>2]|0;if((b|0)>0){n=h+8|0;l=0;do{mOa(h,m,l);g=c[n>>2]|0;_Na(a,4);uc(260608,8,1,a|0)|0;$Na(a,g);uc(260624,18,1,a|0)|0;l=l+1|0;r=c[f>>2]|0;}while((l|0)<(r|0));s=r;t=c[e>>2]|0}else{s=b;t=q}if((t|0)>0){t=j+4|0;q=0;do{hOa(j,m,q);b=c[t>>2]|0;_Na(a,4);uc(260648,8,1,a|0)|0;$Na(a,b);uc(260664,21,1,a|0)|0;q=q+1|0;}while((q|0)<(c[e>>2]|0));u=c[f>>2]|0}else{u=s}if((u|0)<=0){_Na(a,2);v=260688;w=v;x=uc(w|0,10,1,a|0)|0;i=d;return}u=k+8|0;s=0;do{mOa(k,m,s);e=c[u>>2]|0;_Na(a,4);uc(260648,8,1,a|0)|0;$Na(a,e);uc(260664,21,1,a|0)|0;s=s+1|0;}while((s|0)<(c[f>>2]|0));_Na(a,2);v=260688;w=v;x=uc(w|0,10,1,a|0)|0;i=d;return}function cOa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=d;f=d+24|0;_Na(a,2);c[f>>2]=c[b>>2];Cd(a|0,260368,f|0)|0;$Na(a,c[b+4>>2]|0);uc(260400,11,1,a|0)|0;$Na(a,c[b+8>>2]|0);uc(260072,3,1,a|0)|0;f=e;g=b+12|0;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[f+12>>2]=c[g+12>>2];c[f+16>>2]=c[g+16>>2];c[f+20>>2]=c[g+20>>2];gOa(a,4,e);_Na(a,2);uc(260416,12,1,a|0)|0;i=d;return}function dOa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+32|0;q=f+64|0;if((c[q>>2]|0)<=0){i=g;return}r=f+56|0;s=p+4|0;t=f+72|0;f=p;u=p+8|0;v=0;do{hOa(p,r,v);ZNa(b,d,c[s>>2]|0,e,(c[t>>2]|0)+(c[q>>2]|0)|0,v,c[f>>2]|0,260184);w=v+9|0;Cxa(w);_Na(a,2);c[o>>2]=c[f>>2];Cd(a|0,260192,o|0)|0;_Na(a,4);uc(258616,6,1,a|0)|0;$Na(a,c[s>>2]|0);uc(258624,8,1,a|0)|0;_Na(a,4);c[n>>2]=uxa(w)|0;Cd(a|0,259968,n|0)|0;_Na(a,4);x=+zxa(w);y=m;h[k>>3]=x;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];Cd(a|0,259992,m|0)|0;_Na(a,4);x=+yxa(w);w=l;h[k>>3]=x;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];Cd(a|0,259160,l|0)|0;w=j;y=u;c[w+0>>2]=c[y+0>>2];c[w+4>>2]=c[y+4>>2];c[w+8>>2]=c[y+8>>2];c[w+12>>2]=c[y+12>>2];c[w+16>>2]=c[y+16>>2];c[w+20>>2]=c[y+20>>2];gOa(a,6,j);_Na(a,2);uc(260216,12,1,a|0)|0;v=v+1|0;}while((v|0)<(c[q>>2]|0));i=g;return}function eOa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+24|0;m=i;i=i+24|0;n=i;i=i+24|0;o=i;i=i+24|0;p=i;i=i+24|0;if((b|0)<=0){i=e;return}q=l;r=m+8|0;s=n+12|0;t=d+8|0;u=d+16|0;v=o;w=p;x=0;do{_Na(a,2);lOa(l,d,x);c[j>>2]=c[q>>2];Cd(a|0,260040,j|0)|0;lOa(m,d,x);$Na(a,c[r>>2]|0);uc(260072,3,1,a|0)|0;_Na(a,4);uc(260080,7,1,a|0)|0;lOa(n,d,x);if((c[s>>2]|0)>0){y=0;do{_Na(a,6);c[g>>2]=0;Cd(a|0,260088,g|0)|0;y=y+1|0;lOa(n,d,x);}while((y|0)<(c[s>>2]|0))}_Na(a,4);uc(260112,8,1,a|0)|0;_Na(a,4);y=(c[t>>2]|0)+9+(c[u>>2]|0)|0;lOa(o,d,x);z=+wxa(y+(c[v>>2]|0)|0);y=(c[t>>2]|0)+9+(c[u>>2]|0)|0;lOa(p,d,x);A=rxa(y+(c[w>>2]|0)|0)|0;y=f;h[k>>3]=z;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];c[f+8>>2]=A;Cd(a|0,260128,f|0)|0;_Na(a,2);uc(260168,12,1,a|0)|0;x=x+1|0;}while((x|0)<(b|0));i=e;return}function fOa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=e+56|0;p=e+64|0;q=c[p>>2]|0;r=e+72|0;if((c[r>>2]|0)<=0){i=f;return}s=n+8|0;t=e+88|0;e=n;u=q;v=q;do{mOa(n,o,v-u|0);ZNa(b,d,c[s>>2]|0,c[t>>2]|0,(c[r>>2]|0)+(c[p>>2]|0)|0,v,c[e>>2]|0,259920);q=v+9|0;Cxa(q);_Na(a,2);uc(259928,15,1,a|0)|0;_Na(a,4);c[m>>2]=c[e>>2];Cd(a|0,259944,m|0)|0;_Na(a,4);c[l>>2]=uxa(q)|0;Cd(a|0,259968,l|0)|0;_Na(a,4);w=+zxa(q);x=j;h[k>>3]=w;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];Cd(a|0,259992,j|0)|0;_Na(a,4);w=+yxa(q);q=g;h[k>>3]=w;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];Cd(a|0,259160,g|0)|0;_Na(a,2);uc(260016,16,1,a|0)|0;v=v+1|0;u=c[p>>2]|0;}while((v|0)<((c[r>>2]|0)+u|0));i=f;return}function gOa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;_Na(a,b);uc(260232,16,1,a|0)|0;$Na(a,c[d>>2]|0);b=c[d+8>>2]|0;g=c[d+12>>2]|0;h=c[d+16>>2]|0;j=(c[d+20>>2]|0)!=0?260336:260352;c[f>>2]=c[d+4>>2];c[f+4>>2]=b;c[f+8>>2]=g;c[f+12>>2]=h;c[f+16>>2]=j;Cd(a|0,260256,f|0)|0;i=e;return}function hOa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((c[b+24>>2]|0)==0){iOa(b)}f=a;a=(c[b+20>>2]|0)+(d<<5)|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];i=e;return}function iOa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+16|0;j=i;i=i+1024|0;c[h>>2]=a;k=h+4|0;c[k>>2]=1;l=h+8|0;c[l>>2]=0;m=h+12|0;c[m>>2]=0;n=a+4|0;do{if((c[n>>2]|0)==0){o=a;p=mc(c[o>>2]|0,261568)|0;if((p|0)!=0){q=p;break}p=ae(c[(Qc()|0)>>2]|0)|0;c[g>>2]=c[o>>2];c[g+4>>2]=p;lwa(0,261576,g)}else{q=0}}while(0);g=bra(0)|0;if((g|0)==0){lwa(0,261608,f)}f=a+8|0;c[a+20>>2]=X_a(c[f>>2]|0,32)|0;p=a+12|0;o=X_a((c[p>>2]|0)+1|0,20)|0;c[a+24>>2]=o;c[o>>2]=0;c[o+4>>2]=-1;c[o+8>>2]=261640;c[o+12>>2]=0;c[o+16>>2]=0;mra(g,h);nra(g,9,117);h=c[n>>2]|0;do{if((h|0)==0){o=j;B$a(o|0,0,1024)|0;while(1){r=vb(o|0,1,1024,q|0)|0;s=r>>>0<1024;if((ora(g,o,r,s&1)|0)==0){t=9;break}if(s){t=11;break}}if((t|0)==9){o=wra(tra(g)|0)|0;s=ura(g)|0;ad(q|0)|0;ira(g);r=c[a>>2]|0;c[e>>2]=261744;c[e+4>>2]=r;c[e+8>>2]=o;c[e+12>>2]=s;lwa(0,261680,e)}else if((t|0)==11){ad(q|0)|0;break}}else{if((ora(g,h,x$a(h|0)|0,1)|0)!=0){break}s=wra(tra(g)|0)|0;o=ura(g)|0;ira(g);r=c[n>>2]|0;c[d>>2]=261744;c[d+4>>2]=r;c[d+8>>2]=s;c[d+12>>2]=o;lwa(0,261784,d)}}while(0);if((c[p>>2]|0)!=(c[k>>2]|0)){db(261848,261744,295,261888)}c[a+16>>2]=c[l>>2];if((c[f>>2]|0)==(c[m>>2]|0)){i=b;return}else{db(261912,261744,297,261888)}}function jOa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+8|0;m=c[a>>2]|0;n=c[a+4>>2]|0;o=c[a+12>>2]|0;if((t$a(262320,b)|0)==0){if((t$a(c[d>>2]|0,262328)|0)==0){p=(c[d+8>>2]|0)==0|0}else{p=0}kwa(0,p,262336,l);l=c[65544]|0;p=c[65598]|0;do{if((l|0)==0|(p|0)==0){c[65598]=32;a=V_a(1152)|0;c[65544]=a;q=m+24|0;r=a}else{a=m+24|0;s=a;if(((c[(c[a>>2]|0)+(n*20|0)+12>>2]|0)+2|0)<(p|0)){q=s;r=l;break}c[65598]=p<<1;a=Y_a(l,p*72|0)|0;c[65544]=a;q=s;r=a}}while(0);p=(c[q>>2]|0)+(n*20|0)+12|0;q=c[p>>2]|0;c[p>>2]=q+1;p=r+(q*36|0)+0|0;q=(pOa(c[d+4>>2]|0)|0)+0|0;r=p+36|0;do{c[p>>2]=c[q>>2];p=p+4|0;q=q+4|0}while((p|0)<(r|0));i=e;return}if((t$a(262400,b)|0)==0){q=c[d>>2]|0;if((q|0)==0){i=e;return}else{t=d;u=q}a:while(1){do{if((t$a(262408,u)|0)==0){c[65604]=Gd(c[t+4>>2]|0)|0}else{if((t$a(262440,u)|0)==0){c[262420>>2]=Yb(c[t+4>>2]|0,0,10)|0;break}if((t$a(262456,u)|0)==0){c[262428>>2]=Yb(c[t+4>>2]|0,0,10)|0;break}if((t$a(262464,u)|0)==0){c[262424>>2]=Yb(c[t+4>>2]|0,0,10)|0;break}if((t$a(262480,u)|0)==0){c[262432>>2]=Yb(c[t+4>>2]|0,0,10)|0;break}if((t$a(262488,u)|0)!=0){v=23;break a}c[262436>>2]=(t$a(c[t+4>>2]|0,262504)|0)==0}}while(0);q=t+8|0;p=c[q>>2]|0;if((p|0)==0){v=45;break}else{t=q;u=p}}if((v|0)==23){c[k>>2]=c[m>>2];lwa(0,262512,k)}else if((v|0)==45){i=e;return}}if((t$a(262160,b)|0)==0){v=c[m+12>>2]|0;if((n|0)>(v|0)){k=c[m>>2]|0;c[j>>2]=261744;c[j+4>>2]=k;c[j+8>>2]=v;lwa(0,262544,j)}if((t$a(262608,c[d>>2]|0)|0)!=0){j=c[m>>2]|0;c[h>>2]=261744;c[h+4>>2]=j;lwa(0,262616,h)}h=Yb(c[d+4>>2]|0,0,10)|0;if((n|0)!=(h|0)){j=c[m>>2]|0;c[g>>2]=261744;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=n;lwa(0,262672,g)}g=m+24|0;h=c[g>>2]|0;c[h+(n*20|0)>>2]=n;c[h+(n*20|0)+4>>2]=-1;c[h+(n*20|0)+8>>2]=262736;h=c[g>>2]|0;c[h+(n*20|0)+12>>2]=0;c[h+(n*20|0)+16>>2]=0;i=e;return}if((t$a(262104,b)|0)!=0){if((t$a(262296,b)|0)!=0){i=e;return}b=m+20|0;m=c[b>>2]|0;c[m+(o<<5)>>2]=o;c[m+(o<<5)+4>>2]=262840;m=Gd(c[d+4>>2]|0)|0;c[(c[b>>2]|0)+(o<<5)+4>>2]=m;c[(c[b>>2]|0)+(o<<5)+8>>2]=262848;i=e;return}c[262124>>2]=0;c[262128>>2]=0;o=c[d>>2]|0;do{if((o|0)==0){w=0}else{b=d;m=o;do{do{if((t$a(m,262328)|0)==0){c[262124>>2]=Gd(c[b+4>>2]|0)|0}else{if((t$a(m,262792)|0)!=0){break}c[262128>>2]=Gd(c[b+4>>2]|0)|0}}while(0);b=b+8|0;m=c[b>>2]|0;}while((m|0)!=0);if((c[262124>>2]|0)==0){w=0;break}w=(c[262128>>2]|0)!=0|0}}while(0);kwa(0,w,262800,f);c[65530]=-1;f=262132|0;w=262416;c[f+0>>2]=c[w+0>>2];c[f+4>>2]=c[w+4>>2];c[f+8>>2]=c[w+8>>2];c[f+12>>2]=c[w+12>>2];c[f+16>>2]=c[w+16>>2];c[f+20>>2]=c[w+20>>2];i=e;return}function kOa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+48|0;e=d;f=d+40|0;g=i;i=i+8|0;h=c[a>>2]|0;j=a+4|0;k=c[j>>2]|0;l=a+8|0;m=c[l>>2]|0;n=a+12|0;a=c[n>>2]|0;if((t$a(262104,b)|0)==0){o=e+0|0;p=262120|0;q=o+36|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));oOa(e);i=d;return}if((t$a(262160,b)|0)==0){e=h+24|0;r=V_a((c[(c[e>>2]|0)+(k*20|0)+12>>2]|0)*36|0)|0;c[(c[e>>2]|0)+(k*20|0)+16>>2]=r;if((c[(c[e>>2]|0)+(k*20|0)+12>>2]|0)>0){r=0;do{s=V_a(36)|0;t=s;o=s+0|0;p=(c[65544]|0)+(r*36|0)+0|0;q=o+36|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));c[(c[(c[e>>2]|0)+(k*20|0)+16>>2]|0)+(r<<2)>>2]=t;r=r+1|0;}while((r|0)<(c[(c[e>>2]|0)+(k*20|0)+12>>2]|0))}c[j>>2]=k+1;i=d;return}if((t$a(262184,b)|0)==0){j=h+24|0;e=c[j>>2]|0;r=c[e+(k*20|0)+12>>2]|0;c[g>>2]=k;c[g+4>>2]=r;Hd(e+(k*20|0)+8|0,262192,g|0)|0;c[(c[j>>2]|0)+(k*20|0)+4>>2]=m;c[l>>2]=m+1;i=d;return}if((t$a(262232,b)|0)==0){j=h+24|0;h=c[j>>2]|0;g=c[h+(k*20|0)+12>>2]|0;c[f>>2]=k;c[f+4>>2]=g;Hd(h+(k*20|0)+8|0,262248,f|0)|0;c[(c[j>>2]|0)+(k*20|0)+4>>2]=m;c[l>>2]=m+1;i=d;return}if((t$a(262296,b)|0)!=0){i=d;return}c[n>>2]=a+1;i=d;return}function lOa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b+24|0;g=c[f>>2]|0;if((g|0)==0){iOa(b);h=c[f>>2]|0}else{h=g}g=a;a=h+(d*20|0)|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];i=e;return}function mOa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=b+24|0;if((c[h>>2]|0)==0){iOa(b)}j=c[b+16>>2]|0;if(j>>>0<d>>>0){c[g>>2]=d;c[g+4>>2]=j;lwa(0,261952,g)}g=c[b+12>>2]|0;if((g|0)<=0){k=f;l=k;c[l>>2]=d;m=5;n=m;o=262032;p=o;lwa(0,p,f)}b=c[h>>2]|0;h=0;while(1){j=h+1|0;if((c[b+(h*20|0)+4>>2]|0)==(d|0)){q=9;break}if((j|0)<(g|0)){h=j}else{q=10;break}}if((q|0)==9){g=a;a=b+(h*20|0)|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];i=e;return}else if((q|0)==10){k=f;l=k;c[l>>2]=d;m=5;n=m;o=262032;p=o;lwa(0,p,f)}}function nOa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=a+20|0;e=c[d>>2]|0;if((e|0)!=0){W_a(e);c[d>>2]=0}d=a+24|0;e=c[d>>2]|0;if((e|0)==0){i=b;return}f=a+12|0;if((c[f>>2]|0)>0){a=e;g=0;while(1){W_a(c[a+(g*20|0)+16>>2]|0);c[(c[d>>2]|0)+(g*20|0)+16>>2]=0;h=g+1|0;j=c[d>>2]|0;if((h|0)<(c[f>>2]|0)){g=h;a=j}else{k=j;break}}}else{k=e}W_a(k);c[d>>2]=0;i=b;return}function oOa(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;b=i;e=V_a(72)|0;f=c[a+4>>2]|0;c[e>>2]=f;g=e+4|0;h=a+0|0;a=g+36|0;do{c[g>>2]=c[h>>2];g=g+4|0;h=h+4|0}while((g|0)<(a|0));h=e+40|0;j=h;c[e+48>>2]=0;c[e+60>>2]=f;k=x$a(f|0)|0;c[e+64>>2]=k;k=c[65578]|0;do{if((k|0)==0){c[65578]=e;c[e+44>>2]=0;l=V_a(44)|0;m=l;c[e+40>>2]=m;if((l|0)==0){yc(-1)}g=l+0|0;a=g+44|0;do{c[g>>2]=0;g=g+4|0}while((g|0)<(a|0));c[l+16>>2]=e+40;c[l+4>>2]=32;c[l+8>>2]=5;c[l+20>>2]=40;n=V_a(384)|0;c[l>>2]=n;if((n|0)==0){yc(-1)}else{B$a(n|0,0,384)|0;c[l+40>>2]=-1609490463;o=f;p=m;break}}else{c[(c[(c[k+40>>2]|0)+16>>2]|0)+8>>2]=e;n=(c[65578]|0)+40|0;q=c[n>>2]|0;c[e+44>>2]=(c[q+16>>2]|0)+(0-(c[q+20>>2]|0));c[(c[n>>2]|0)+16>>2]=j;o=c[e>>2]|0;p=c[(c[65578]|0)+40>>2]|0}}while(0);k=p+12|0;c[k>>2]=(c[k>>2]|0)+1;c[h>>2]=p;p=e+68|0;c[p>>2]=-17973521;k=x$a(o|0)|0;if(k>>>0>11){f=-17973521;g=-1640531527;a=-1640531527;n=k;q=o;do{r=((d[q+5|0]|0)<<8|(d[q+4|0]|0)|(d[q+6|0]|0)<<16|(d[q+7|0]|0)<<24)+a|0;s=((d[q+9|0]|0)<<8|(d[q+8|0]|0)|(d[q+10|0]|0)<<16|(d[q+11|0]|0)<<24)+f|0;t=((d[q+1|0]|0)<<8|(d[q]|0)|(d[q+2|0]|0)<<16|(d[q+3|0]|0)<<24)+g-r-s^s>>>13;u=r-s-t^t<<8;r=s-t-u^u>>>13;s=t-u-r^r>>>12;t=u-r-s^s<<16;u=r-s-t^t>>>5;g=s-t-u^u>>>3;a=t-u-g^g<<10;f=u-g-a^a>>>15;c[p>>2]=f;q=q+12|0;n=n+ -12|0;}while(n>>>0>11);v=f;w=c[e>>2]|0;x=g;y=a;z=n;A=q}else{v=-17973521;w=o;x=-1640531527;y=-1640531527;z=k;A=o}o=v+(x$a(w|0)|0)|0;c[p>>2]=o;switch(z|0){case 7:{B=o;C=y;D=16;break};case 4:{E=o;F=y;D=19;break};case 8:{G=o;D=15;break};case 10:{H=o;D=13;break};case 2:{I=o;J=x;K=y;D=21;break};case 1:{L=o;M=x;N=y;D=22;break};case 11:{z=((d[A+10|0]|0)<<24)+o|0;c[p>>2]=z;H=z;D=13;break};case 3:{O=o;P=x;Q=y;D=20;break};case 9:{R=o;D=14;break};case 5:{S=o;T=y;D=18;break};case 6:{U=o;V=y;D=17;break};default:{W=o;X=x;Y=y}}if((D|0)==13){o=((d[A+9|0]|0)<<16)+H|0;c[p>>2]=o;R=o;D=14}if((D|0)==14){o=((d[A+8|0]|0)<<8)+R|0;c[p>>2]=o;G=o;D=15}if((D|0)==15){B=G;C=((d[A+7|0]|0)<<24)+y|0;D=16}if((D|0)==16){U=B;V=((d[A+6|0]|0)<<16)+C|0;D=17}if((D|0)==17){S=U;T=((d[A+5|0]|0)<<8)+V|0;D=18}if((D|0)==18){E=S;F=(d[A+4|0]|0)+T|0;D=19}if((D|0)==19){O=E;P=((d[A+3|0]|0)<<24)+x|0;Q=F;D=20}if((D|0)==20){I=O;J=((d[A+2|0]|0)<<16)+P|0;K=Q;D=21}if((D|0)==21){L=I;M=((d[A+1|0]|0)<<8)+J|0;N=K;D=22}if((D|0)==22){W=L;X=(d[A]|0)+M|0;Y=N}N=X-Y-W^W>>>13;X=Y-W-N^N<<8;Y=W-N-X^X>>>13;W=N-X-Y^Y>>>12;N=X-Y-W^W<<16;X=Y-W-N^N>>>5;Y=W-N-X^X>>>3;W=N-X-Y^Y<<10;N=X-Y-W^W>>>15;c[p>>2]=N;p=(c[65578]|0)+40|0;W=c[p>>2]|0;Y=N&(c[W+4>>2]|0)+ -1;N=c[W>>2]|0;W=N+(Y*12|0)+4|0;c[W>>2]=(c[W>>2]|0)+1;c[e+56>>2]=c[N+(Y*12|0)>>2];c[e+52>>2]=0;e=c[c[p>>2]>>2]|0;p=c[e+(Y*12|0)>>2]|0;if((p|0)==0){Z=e}else{c[p+12>>2]=j;Z=c[c[(c[65578]|0)+40>>2]>>2]|0}c[Z+(Y*12|0)>>2]=j;j=c[c[(c[65578]|0)+40>>2]>>2]|0;if((c[j+(Y*12|0)+4>>2]|0)>>>0<(((c[j+(Y*12|0)+8>>2]|0)*10|0)+10|0)>>>0){i=b;return}Y=c[h>>2]|0;if((c[Y+36>>2]|0)==1){i=b;return}j=Y+4|0;Z=V_a((c[j>>2]|0)*24|0)|0;p=Z;if((Z|0)==0){yc(-1)}B$a(Z|0,0,(c[j>>2]|0)*24|0)|0;e=c[Y+12>>2]|0;N=c[j>>2]|0;c[Y+24>>2]=(((N<<1)+ -1&e|0)!=0)+(e>>>((c[Y+8>>2]|0)+1|0));c[Y+28>>2]=0;e=c[Y>>2]|0;if((N|0)==0){_=e}else{N=Y;Y=e;e=0;while(1){j=c[Y+(e*12|0)>>2]|0;if((j|0)==0){$=N}else{W=N;X=j;while(1){j=X+16|0;M=c[j>>2]|0;A=(c[W+4>>2]<<1)+ -1&c[X+28>>2];L=Z+(A*12|0)+4|0;D=(c[L>>2]|0)+1|0;c[L>>2]=D;K=c[W+24>>2]|0;if(D>>>0>K>>>0){D=W+28|0;c[D>>2]=(c[D>>2]|0)+1;c[Z+(A*12|0)+8>>2]=((c[L>>2]|0)>>>0)/(K>>>0)|0}c[X+12>>2]=0;K=Z+(A*12|0)|0;c[j>>2]=c[K>>2];j=c[K>>2]|0;if((j|0)!=0){c[j+12>>2]=X}c[K>>2]=X;K=c[h>>2]|0;if((M|0)==0){$=K;break}else{W=K;X=M}}}X=e+1|0;W=c[$>>2]|0;if(X>>>0<(c[$+4>>2]|0)>>>0){N=$;Y=W;e=X}else{_=W;break}}}W_a(_);_=c[h>>2]|0;e=_+4|0;c[e>>2]=c[e>>2]<<1;e=_+8|0;c[e>>2]=(c[e>>2]|0)+1;c[_>>2]=p;p=c[h>>2]|0;h=p+32|0;if(!((c[p+28>>2]|0)>>>0>(c[p+12>>2]|0)>>>1>>>0)){c[h>>2]=0;i=b;return}_=(c[h>>2]|0)+1|0;c[h>>2]=_;if(!(_>>>0>1)){i=b;return}c[p+36>>2]=1;i=b;return}function pOa(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;b=i;i=i+8|0;e=b;a:do{if((c[65578]|0)==0){f=24}else{g=x$a(a|0)|0;if(g>>>0>11){h=-17973521;j=-1640531527;k=-1640531527;l=g;m=a;while(1){n=((d[m+5|0]|0)<<8|(d[m+4|0]|0)|(d[m+6|0]|0)<<16|(d[m+7|0]|0)<<24)+k|0;o=((d[m+9|0]|0)<<8|(d[m+8|0]|0)|(d[m+10|0]|0)<<16|(d[m+11|0]|0)<<24)+h|0;p=((d[m+1|0]|0)<<8|(d[m]|0)|(d[m+2|0]|0)<<16|(d[m+3|0]|0)<<24)+j-n-o^o>>>13;q=n-o-p^p<<8;n=o-p-q^q>>>13;o=p-q-n^n>>>12;p=q-n-o^o<<16;q=n-o-p^p>>>5;n=o-p-q^q>>>3;o=p-q-n^n<<10;p=q-n-o^o>>>15;q=m+12|0;r=l+ -12|0;if(r>>>0>11){m=q;l=r;k=o;j=n;h=p}else{s=p;t=n;u=o;v=r;w=q;break}}}else{s=-17973521;t=-1640531527;u=-1640531527;v=g;w=a}h=(x$a(a|0)|0)+s|0;switch(v|0){case 3:{x=h;y=t;z=u;f=13;break};case 6:{A=h;B=u;f=10;break};case 11:{C=((d[w+10|0]|0)<<24)+h|0;f=6;break};case 5:{D=h;E=u;f=11;break};case 8:{F=h;f=8;break};case 9:{G=h;f=7;break};case 2:{H=h;I=t;J=u;f=14;break};case 7:{K=h;L=u;f=9;break};case 10:{C=h;f=6;break};case 1:{M=h;N=t;O=u;f=15;break};case 4:{P=h;Q=u;f=12;break};default:{R=h;S=t;T=u}}if((f|0)==6){G=((d[w+9|0]|0)<<16)+C|0;f=7}if((f|0)==7){F=((d[w+8|0]|0)<<8)+G|0;f=8}if((f|0)==8){K=F;L=((d[w+7|0]|0)<<24)+u|0;f=9}if((f|0)==9){A=K;B=((d[w+6|0]|0)<<16)+L|0;f=10}if((f|0)==10){D=A;E=((d[w+5|0]|0)<<8)+B|0;f=11}if((f|0)==11){P=D;Q=(d[w+4|0]|0)+E|0;f=12}if((f|0)==12){x=P;y=((d[w+3|0]|0)<<24)+t|0;z=Q;f=13}if((f|0)==13){H=x;I=((d[w+2|0]|0)<<16)+y|0;J=z;f=14}if((f|0)==14){M=H;N=((d[w+1|0]|0)<<8)+I|0;O=J;f=15}if((f|0)==15){R=M;S=(d[w]|0)+N|0;T=O}h=S-R-T^R>>>13;j=T-R-h^h<<8;k=R-h-j^j>>>13;l=h-j-k^k>>>12;h=j-k-l^l<<16;j=k-l-h^h>>>5;k=l-h-j^j>>>3;l=h-j-k^k<<10;h=c[(c[65578]|0)+40>>2]|0;m=c[(c[h>>2]|0)+(((j-k-l^l>>>15)&(c[h+4>>2]|0)+ -1)*12|0)>>2]|0;if((m|0)==0){f=24;break}l=m+(0-(c[h+20>>2]|0))|0;if((l|0)==0){f=24;break}m=x$a(a|0)|0;k=l;while(1){U=k;if((c[k+64>>2]|0)==(m|0)){if((s$a(c[k+60>>2]|0,a,m)|0)==0){break}}l=c[k+56>>2]|0;if((l|0)==0){f=24;break a}j=l+(0-(c[h+20>>2]|0))|0;if((j|0)==0){f=24;break a}else{k=j}}if((k|0)==0){f=24}else{V=U}}}while(0);do{if((f|0)==24){if((Hb(a|0,262872)|0)==0){V=0;break}else{W=262896}i=b;return W|0}}while(0);c[e>>2]=a;kwa(0,(V|0)!=0|0,262944,e);W=V+4|0;i=b;return W|0}function qOa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((rOa(263e3,a,b)|0)!=0){d=1;i=c;return d|0}d=(rOa(263008,a,b)|0)!=0|0;i=c;return d|0}function rOa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((d|0)>0){g=0}else{h=0;i=f;return h|0}while(1){j=c[e+(g<<2)>>2]|0;if((a[j]|0)==45){if((t$a(b,j+1|0)|0)==0){h=1;k=5;break}}j=g+1|0;if((j|0)<(d|0)){g=j}else{h=0;k=5;break}}if((k|0)==5){i=f;return h|0}return 0}function sOa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=(t$a(c[211316>>2]|0,263016)|0)==0|0;kwa(0,m,263032,l);l=(t$a(c[213220>>2]|0,263016)|0)==0|0;kwa(0,l,263088,k);k=(t$a(c[215212>>2]|0,263016)|0)==0|0;kwa(0,k,263144,j);j=263208|0;k=j+124|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));j=263336|0;k=j+124|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));if((a|0)>1){n=1}else{o=0;i=d;return o|0}a:while(1){p=b+(n<<2)|0;j=n+1|0;k=1;while(1){l=c[215216+(k<<2)>>2]|0;if((l|0)==2){q=c[211192+(k<<2)>>2]|0;if(!((rOa(q,1,p)|0)==0|(j|0)>=(a|0))){r=9;break}s=c[211192+(k<<2)>>2]|0;if((uOa(s,p)|0)!=0){r=13;break}}else if((l|0)==1){if((rOa(c[211192+(k<<2)>>2]|0,1,p)|0)!=0){r=5;break}}l=k+1|0;if((l|0)<31){k=l}else{r=17;break a}}if((r|0)==5){r=0;l=263208+(k<<2)|0;if((c[l>>2]|0)!=0){r=6;break}c[l>>2]=1;t=n}else if((r|0)==9){r=0;l=263208+(k<<2)|0;if((c[l>>2]|0)!=0){r=10;break}c[l>>2]=1;c[263336+(k<<2)>>2]=tOa(q,p)|0;t=j}else if((r|0)==13){r=0;l=263208+(k<<2)|0;if((c[l>>2]|0)!=0){r=14;break}c[l>>2]=1;c[263336+(k<<2)>>2]=vOa(s,p)|0;t=n}l=t+1|0;if((l|0)<(a|0)){n=l}else{o=0;r=19;break}}if((r|0)==6){c[h>>2]=c[p>>2];jwa(1,0,263464,h);o=1;i=d;return o|0}else if((r|0)==10){c[g>>2]=c[p>>2];jwa(1,0,263464,g);o=1;i=d;return o|0}else if((r|0)==14){c[f>>2]=c[p>>2];jwa(1,0,263464,f);o=1;i=d;return o|0}else if((r|0)==17){c[e>>2]=c[p>>2];jwa(1,0,263520,e);o=1;i=d;return o|0}else if((r|0)==19){i=d;return o|0}return 0}function tOa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[d>>2]|0;do{if((a[f]|0)==45){if((t$a(b,f+1|0)|0)!=0){g=0;break}g=c[d+4>>2]|0}else{g=0}}while(0);i=e;return g|0}function uOa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(vOa(a,b)|0)!=0|0;i=c;return d|0}function vOa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=x$a(b|0)|0;g=c[d>>2]|0;if((a[g]|0)!=45){h=0;i=e;return h|0}if((u$a(b,g+1|0,f)|0)!=0){h=0;i=e;return h|0}if((a[g+(f+1)|0]|0)!=61){h=0;i=e;return h|0}h=g+(f+2)|0;i=e;return h|0}function wOa(){i=i;return}function xOa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;if((d|0)<=0){yc(0)}e=c[r>>2]|0;uc(263552,5,1,e|0)|0;f=b;b=0;while(1){Yd(a[f]|0,e|0)|0;g=b+1|0;if((g|0)<(d|0)){b=g;f=f+1|0}else{break}}uc(263560,20,1,e|0)|0;yc(0);return 0}function yOa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;e=d;d=c[r>>2]|0;c[e>>2]=a;Cd(d|0,263584,e|0)|0;if((b|0)==0){yc(1)}else{Ad(d|0)|0;GOa();Ad(d|0)|0;jb(6,0)|0;md()}}function zOa(a,b){a=a|0;b=b|0;var c=0.0;c=+W(+(+h[a>>3]),+(+h[b>>3]));i=i;return+c}function AOa(a,b){a=a|0;b=b|0;var d=0,e=0.0,f=0.0,g=0.0,j=0,k=0.0,l=0.0;d=i;e=+h[a>>3];a=c[b>>2]|0;if((a|0)==0){f=1.0;i=d;return+f}if((a|0)<0){g=1.0;j=0-a|0;k=1.0/e}else{g=1.0;j=a;k=e}while(1){if((j&1|0)==0){l=g}else{l=g*k}a=j>>>1;if((a|0)==0){f=l;break}g=l;j=a;k=k*k}i=d;return+f}function BOa(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0.0,f=0.0;c=i;d=+h[a>>3];if(!(d>=0.0)){e=-d}else{e=d}if(+h[b>>3]>=0.0){f=e;i=c;return+f}f=-e;i=c;return+f}function COa(a){a=a|0;var b=0.0,c=0.0,d=0.0;b=+g[a>>2];c=b;if(!(b>=0.0)){d=-+T(+(.5-c))}else{d=+T(+(c+.5))}i=i;return~~d|0}function DOa(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;g=b+d|0;h=c+e|0;if((d|0)>(e|0)){a:do{if((e|0)>0){j=b;k=c;while(1){l=a[j]|0;m=a[k]|0;if(!(l<<24>>24==m<<24>>24)){break}n=j+1|0;o=k+1|0;if(o>>>0<h>>>0){j=n;k=o}else{p=n;break a}}q=(l&255)-(m&255)|0;i=f;return q|0}else{p=b}}while(0);if(p>>>0<g>>>0){r=p}else{q=0;i=f;return q|0}while(1){s=a[r]|0;p=r+1|0;if(!(s<<24>>24==32)){break}if(p>>>0<g>>>0){r=p}else{q=0;t=18;break}}if((t|0)==18){i=f;return q|0}q=(s&255)+ -32|0;i=f;return q|0}else{b:do{if((d|0)>0){s=b;r=c;while(1){u=a[s]|0;v=a[r]|0;if(!(u<<24>>24==v<<24>>24)){break}p=s+1|0;m=r+1|0;if(p>>>0<g>>>0){s=p;r=m}else{w=m;break b}}q=(u&255)-(v&255)|0;i=f;return q|0}else{w=c}}while(0);if(w>>>0<h>>>0){x=w}else{q=0;i=f;return q|0}while(1){y=a[x]|0;w=x+1|0;if(!(y<<24>>24==32)){break}if(w>>>0<h>>>0){x=w}else{q=0;t=18;break}}if((t|0)==18){i=f;return q|0}q=32-(y&255)|0;i=f;return q|0}return 0}function EOa(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;g=c;h=b+d|0;if((d|0)<=(e|0)){do{if(b>>>0>c>>>0){j=c+d|0;if(!(j>>>0>b>>>0)){break}if((d|0)>0){k=j;l=h}else{i=f;return}do{k=k+ -1|0;l=l+ -1|0;a[l]=a[k]|0;}while(l>>>0>b>>>0);i=f;return}}while(0);if((d|0)>0){m=c;n=b}else{i=f;return}while(1){l=n+1|0;a[n]=a[m]|0;if(l>>>0<h>>>0){n=l;m=m+1|0}else{break}}i=f;return}m=c+e|0;do{if(b>>>0>c>>>0&m>>>0>b>>>0){n=b+e|0;if((e|0)>0){l=0-g-e|0;k=~g;j=~(c+(l>>>0>k>>>0?l:k));k=n;l=m;do{l=l+ -1|0;k=k+ -1|0;a[k]=a[l]|0;}while(l>>>0>c>>>0);o=b+j|0}else{o=n}p=o+e|0}else{if((e|0)<=0){p=b;break}l=c+1|0;k=(m>>>0>l>>>0?m:l)+(0-g)|0;l=b;q=c;while(1){r=q+1|0;a[l]=a[q]|0;if(r>>>0<m>>>0){q=r;l=l+1|0}else{break}}p=b+k|0}}while(0);if(!(p>>>0<h>>>0)){i=f;return}B$a(p|0,32,b+(d-p)|0)|0;i=f;return}function FOa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+4>>2]|0;if((e|0)>99){i=d;return 0}f=264624+(e*48|0)|0;g=c[f>>2]|0;if((g|0)!=0){do{if((c[264668+(e*48|0)>>2]|0)==1){h=10}else{j=c[b+8>>2]|0;if((j|0)!=0){k=a[j]|0;if((k|0)==100|(k|0)==68){h=10;break}}if((c[264664+(e*48|0)>>2]|0)==1){HOa(b)|0}k=264628+(e*48|0)|0;if((c[k>>2]|0)==0){break}ad(c[f>>2]|0)|0;W_a(c[k>>2]|0)}}while(0);do{if((h|0)==10){ad(g|0)|0;b=264628+(e*48|0)|0;k=c[b>>2]|0;if((k|0)==0){break}Pd(k|0)|0;W_a(c[b>>2]|0)}}while(0);c[f>>2]=0}c[264660+(e*48|0)>>2]=0;c[264628+(e*48|0)>>2]=0;i=d;return 0}function GOa(){var a=0,b=0;a=i;if((c[65898]|0)!=0){i=a;return}c[65898]=1;c[263600>>2]=0;b=0;do{c[263596>>2]=b;FOa(263592)|0;b=b+1|0;}while((b|0)<100);i=a;return}function HOa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=c[a+4>>2]|0;if((c[264640+(d*48|0)>>2]|0)!=0){e=0;i=b;return e|0}f=264624+(d*48|0)|0;g=c[f>>2]|0;h=Bb(g|0)|0;Zc(g|0,0,2)|0;if((h|0)>=(Bb(g|0)|0)){e=0;i=b;return e|0}if((c[264644+(d*48|0)>>2]|0)==0){e=0;i=b;return e|0}if((c[264652+(d*48|0)>>2]&2|0)!=0){Ad(c[f>>2]|0)|0}d=Wc(tb(c[f>>2]|0)|0,h|0)|0;Zc(c[f>>2]|0,0,2)|0;if((d|0)==0){e=0;i=b;return e|0}if((c[a>>2]|0)==0){JOa(111,263608);e=111;i=b;return e|0}else{c[(Qc()|0)>>2]=111;e=111;i=b;return e|0}return 0}function IOa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+80|0;d=b;do{if((ab(tb(a|0)|0,d|0)|0)<0){e=0}else{f=c[d+12>>2]&61440;if((f|0)==32768|(f|0)==16384){e=(c[d+16>>2]|0)!=0|0;break}else if((f|0)==24576){e=1;break}else if((f|0)==8192){e=(xb(tb(a|0)|0)|0)==0|0;break}else{e=0;break}}}while(0);i=b;return e|0}function JOa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;d=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;do{if(a>>>0<100){Tc(b|0);l=c[r>>2]|0}else{if((a+1|0)>>>0>132){m=c[r>>2]|0;c[k>>2]=b;c[k+4>>2]=a;Cd(m|0,264520,k|0)|0;l=m;break}m=c[r>>2]|0;if((a|0)==-1){c[j>>2]=b;Cd(m|0,264552,j|0)|0;l=m;break}else{n=c[264392+(a+ -100<<2)>>2]|0;c[h>>2]=b;c[h+4>>2]=n;Cd(m|0,264576,h|0)|0;l=m;break}}}while(0);h=c[66146]|0;do{if((h|0)==0){uc(269456,29,1,l|0)|0}else{c[g>>2]=(h-264624|0)/48|0;Cd(l|0,264592,g|0)|0;b=c[(c[66146]|0)+4>>2]|0;if((b|0)==0){uc(269440,10,1,l|0)|0;break}else{c[f>>2]=b;Cd(l|0,269424,f|0)|0;break}}}while(0);f=c[67372]|0;if((f|0)!=0){c[d>>2]=f;Cd(l|0,269496,d|0)|0}d=(c[67392]|0)!=0?269576:269592;f=(c[67400]|0)!=0?269608:269624;g=(c[67410]|0)!=0?269648:269664;c[e>>2]=(c[67386]|0)!=0?269552:269560;c[e+4>>2]=d;c[e+8>>2]=f;c[e+12>>2]=g;Cd(l|0,269520,e|0)|0;yOa(269680,1)}function KOa(){var a=0,b=0;a=i;c[67422]=1;b=c[r>>2]|0;c[66156]=b;c[264644>>2]=IOa(b)|0;c[264648>>2]=1;c[264664>>2]=1;b=c[s>>2]|0;c[264864>>2]=b;c[264884>>2]=IOa(b)|0;c[264888>>2]=1;c[264904>>2]=0;b=c[t>>2]|0;c[264912>>2]=b;c[264932>>2]=IOa(b)|0;c[264936>>2]=1;c[264952>>2]=1;i=a;return}function LOa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;d=a+28|0;e=c[d>>2]|0;a:do{if((e&2|0)==0){f=a+4|0;g=c[f>>2]|0;do{if((g|0)!=0){if((c[a+16>>2]|0)==0){h=c[a+24>>2]|0}else{h=0}if((c[a+40>>2]|0)==3){j=a;k=Ac(g|0,c[274936+(h<<2)>>2]|0,c[j>>2]|0)|0;c[j>>2]=k;c[67424]=k;if((k|0)==0){break}c[d>>2]=2;break a}k=a;j=Bb(c[k>>2]|0)|0;l=Ac(c[f>>2]|0,c[274936+((h|2)<<2)>>2]|0,c[k>>2]|0)|0;c[k>>2]=l;c[67424]=l;if((l|0)==0){c[k>>2]=0;break}else{c[d>>2]=3;Zc(c[k>>2]|0,j|0,0)|0;break a}}}while(0);c[(Qc()|0)>>2]=127;m=1;i=b;return m|0}else{if((e&1|0)==0){break}Zc(c[a>>2]|0,0,1)|0}}while(0);c[a+40>>2]=1;m=0;i=b;return m|0}function MOa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if((a|0)==0){JOa(b,d)}d=c[67426]|0;if((d|0)!=0){Ie[d&7]()|0}c[(Qc()|0)>>2]=b;i=e;return b|0}function NOa(a){a=a|0;var b=0,d=0;b=i;c[67456]=0;c[67458]=0;c[67460]=0;d=((OOa(a,0)|0)==0)<<31>>31;i=b;return d|0}function OOa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b;while(1){b=a[f]|0;g=f+1|0;if(b<<24>>24==40){break}else if(b<<24>>24==32){f=g}else{h=0;j=8;break}}if((j|0)==8){i=e;return h|0}j=c[67460]|0;c[67460]=j+1;if((j|0)==1){c[67458]=d}if((TOa(1,d,0,0)|0)<0){h=0;i=e;return h|0}d=UOa(g)|0;if((d|0)==0){h=0;i=e;return h|0}else{k=d}while(1){if((a[k]|0)==32){k=k+1|0}else{h=k;break}}i=e;return h|0}function POa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;e=i;i=i+8|0;f=e;if((c[a>>2]|0)>0){g=b;h=0}else{j=0;i=e;return j|0}a:while(1){b=(g|0)==0;b:while(1){k=c[67456]|0;l=269848+(k<<4)|0;m=c[l>>2]|0;switch(QOa(m)|0){case 9:{n=(oe[c[67440]&127](l)|0)==0;c[67456]=(c[67456]|0)+1;if(n){break b}else{continue b}break};case 21:{c[67434]=0;c[67456]=k+1;continue b;break};case 8:{n=c[68672]|0;o=274696+(n<<2)|0;p=c[o>>2]|0;if((p|0)>=1){q=10;break b}c[68672]=n+ -1;c[67456]=k+1;continue b;break};case 22:{c[67434]=1;c[67456]=k+1;continue b;break};case 18:{c[67432]=1;c[67456]=k+1;continue b;break};case 6:{n=c[269852+(k<<4)>>2]|0;s=(c[68672]|0)+1|0;c[68672]=s;c[274696+(s<<2)>>2]=n;c[67456]=k+1;continue b;break};case 19:case 17:{c[67432]=0;c[67456]=k+1;continue b;break};case 33:{c[68700]=1;c[67456]=k+1;continue b;break};case 20:{c[67452]=c[269852+(k<<4)>>2];c[67456]=k+1;continue b;break};case 3:{n=c[68672]|0;s=274696+(n<<2)|0;t=c[s>>2]|0;c[s>>2]=t+ -1;if((t|0)<2){c[68672]=n+ -1;c[68688]=(c[68688]|0)+ -1;c[67456]=k+1;continue b}else{n=c[68688]|0;c[68688]=n+ -1;c[67456]=(c[274760+(n<<2)>>2]|0)+1;continue b}break};case 1:{n=c[269852+(k<<4)>>2]|0;t=(c[68688]|0)+1|0;c[68688]=t;c[274760+(t<<2)>>2]=n;c[67456]=k+1;continue b;break};case 2:{c[68672]=0;c[68688]=0;c[67456]=c[269852+(k<<4)>>2];if(b){q=24;break a}if((c[68684]|0)==0){j=0;q=37;break a}n=Ie[c[67442]&7]()|0;if((n|0)==0){continue b}else{j=n;q=37;break a}break};case 16:{if(b){q=28;break a}c[67456]=k+1;continue b;break};default:{q=4;break a}}}if((q|0)==10){q=0;if(b){q=11;break}c[o>>2]=p+ -1;c[68684]=1;k=re[c[67438]&63](l,g,d)|0;if((k|0)>0){q=13;break}if((k|0)<0){q=15;break}}k=h+1|0;if((k|0)<(c[a>>2]|0)){g=g+d|0;h=k}else{j=0;q=37;break}}if((q|0)==4){h=c[r>>2]|0;d=c[67372]|0;c[f>>2]=m;c[f+4>>2]=d;Cd(h|0,274648,f|0)|0;if((c[c[67428]>>2]|0)==0){JOa(100,274680);j=100;i=e;return j|0}else{c[(Qc()|0)>>2]=100;j=100;i=e;return j|0}}else if((q|0)==11){j=Ie[c[67426]&7]()|0;i=e;return j|0}else if((q|0)==13){f=c[c[67428]>>2]|0;j=MOa(f,c[(Qc()|0)>>2]|0,274744)|0;i=e;return j|0}else if((q|0)==15){if((c[(c[67428]|0)+8>>2]|0)==0){JOa(-1,274744);j=-1;i=e;return j|0}else{c[(Qc()|0)>>2]=-1;j=-1;i=e;return j|0}}else if((q|0)==24){j=Ie[c[67426]&7]()|0;i=e;return j|0}else if((q|0)==28){j=Ie[c[67426]&7]()|0;i=e;return j|0}else if((q|0)==37){i=e;return j|0}return 0}function QOa(a){a=a|0;var b=0;switch(a|0){case 26:case 25:case 24:case 29:case 34:case 32:case 31:case 30:case 10:case 7:case 23:case 27:case 28:case 35:case 36:{b=8;break};case 14:case 13:case 15:case 12:case 11:case 5:case 4:{b=9;break};default:{b=a}}i=i;return b|0}function ROa(){var a=0,b=0,d=0;a=i;i=i+8|0;b=a;c[b>>2]=1;d=POa(b,0,0)|0;i=a;return d|0}function SOa(){c[67448]=0;c[67456]=0;c[68688]=0;c[68672]=0;c[68684]=0;c[68690]=0;c[68674]=0;i=i;return}function TOa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=c[67456]|0;if((g|0)>299){uc(274824,24,1,c[r>>2]|0)|0;yOa(c[67372]|0,1)}else{c[269848+(g<<4)>>2]=a;c[269852+(g<<4)>>2]=b;c[269856+(g<<4)>>2]=d;c[269860+(g<<4)>>2]=e;c[67456]=g+1;i=f;return g|0}return 0}function UOa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=a[b]|0;if(e<<24>>24==0){f=0;i=d;return f|0}else{g=b;h=e}a:while(1){e=g+1|0;if(h<<24>>24==32){h=a[e]|0;g=e;continue}e=VOa(g)|0;if((e|0)==0){f=0;j=12;break}else{k=e}while(1){e=a[k]|0;if(e<<24>>24==44){j=7;break}else if(e<<24>>24==41){j=9;break a}else if(!(e<<24>>24==32)){l=k;break}k=k+1|0}if((j|0)==7){j=0;l=k+1|0}e=a[l]|0;if(e<<24>>24==0){f=0;j=12;break}else{g=l;h=e}}if((j|0)==9){h=(c[67460]|0)+ -1|0;c[67460]=h;if((h|0)==0){TOa(2,c[67458]|0,0,0)|0;f=k+1|0;i=d;return f|0}else{TOa(3,0,0,0)|0;f=k+1|0;i=d;return f|0}}else if((j|0)==12){i=d;return f|0}return 0}function VOa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;do{if((a[b]|0)==41){g=b}else{if((WOa(b,e)|0)!=0){g=c[e>>2]|0;break}if((XOa(b,e)|0)!=0){g=c[e>>2]|0;break}h=YOa(b,f,1)|0;j=TOa(6,c[f>>2]|0,0,0)|0;if((j|0)<0){g=0;break}g=OOa(h,j)|0}}while(0);i=d;return g|0}function WOa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+8|0;f=e;a:do{switch(a[b]|0){case 45:{g=1;h=13;break};case 58:{TOa(16,0,0,0)|0;j=b;h=30;break};case 98:case 66:{k=b+1|0;l=a[k]|0;if(l<<24>>24==90|l<<24>>24==122){TOa(22,0,0,0)|0;j=k;h=30;break a}else{TOa(21,0,0,0)|0;j=k;h=30;break a}break};case 112:case 80:{TOa(20,1,0,0)|0;j=b;h=30;break};case 43:{g=0;h=13;break};case 36:{TOa(33,0,0,0)|0;j=b;h=30;break};case 39:case 34:case 2:{c[269856+((TOa(11,0,0,0)|0)<<4)>>2]=b;k=ZOa(b)|0;c[d>>2]=k;m=(k|0)!=0|0;i=e;return m|0};case 47:{TOa(5,0,0,0)|0;j=b;h=30;break};case 120:case 88:{TOa(4,1,0,0)|0;j=b;h=30;break};case 116:case 84:{k=b+1|0;l=a[k]|0;if(l<<24>>24==76|l<<24>>24==108){n=k;o=13}else if(l<<24>>24==82|l<<24>>24==114){n=k;o=14}else{n=b;o=15}k=YOa(n+1|0,f,0)|0;if((k|0)==0){h=15;break a}TOa(o,c[f>>2]|0,0,0)|0;j=k+ -1|0;h=30;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{p=b;q=0;h=14;break};case 115:case 83:{k=b+1|0;l=a[k]|0;if(l<<24>>24==83|l<<24>>24==115){r=k;s=19}else if(l<<24>>24==80|l<<24>>24==112){r=k;s=18}else{r=b;s=17}TOa(s,0,0,0)|0;j=r;h=30;break};default:{m=0;i=e;return m|0}}}while(0);if((h|0)==13){p=b+1|0;q=g;h=14}b:do{if((h|0)==14){g=YOa(p,f,0)|0;if((g|0)==0){h=15;break}switch(a[g]|0){case 104:case 72:{b=c[f>>2]|0;c[269856+((TOa(12,b,0,0)|0)<<4)>>2]=g+1;j=g+b|0;h=30;break b;break};case 112:case 80:{b=c[f>>2]|0;if((q|0)==0){t=b}else{r=0-b|0;c[f>>2]=r;t=r}TOa(20,t,0,0)|0;j=g;h=30;break b;break};case 120:case 88:{TOa(4,c[f>>2]|0,0,0)|0;j=g;h=30;break b;break};default:{m=0;i=e;return m|0}}}}while(0);if((h|0)==15){c[d>>2]=0;m=1;i=e;return m|0}else if((h|0)==30){c[d>>2]=j+1;m=1;i=e;return m|0}return 0}function XOa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=YOa(b,f,1)|0;TOa(6,c[f>>2]|0,0,0)|0;f=k+1|0;a:do{switch(a[k]|0){case 97:case 65:{l=f;while(1){m=a[l]|0;if(m<<24>>24==32){l=l+1|0}else{break}}if(!((m+ -48<<24>>24&255)<10)){TOa(30,0,0,0)|0;n=l;o=45;break a}p=YOa(l,g,1)|0;q=c[g>>2]|0;if((q|0)==0){n=p;o=45;break a}TOa(31,q,0,0)|0;n=p;o=45;break};case 122:case 90:{r=35;s=36;o=38;break};case 100:case 68:{p=YOa(f,g,0)|0;if((p|0)==0){o=4;break a}q=c[g>>2]|0;if((q|0)==0){n=p;o=45;break a}if((a[p]|0)==46){t=YOa(p+1|0,h,0)|0;if((t|0)==0){o=4;break a}u=t;v=c[h>>2]|0}else{c[h>>2]=0;u=p;v=0}TOa(26,q,v,0)|0;n=u;o=45;break};case 103:case 71:{w=0;o=3;break};case 111:case 79:{r=32;s=34;o=38;break};case 101:case 69:{w=1;o=3;break};case 105:case 73:{r=7;s=10;o=38;break};case 108:case 76:{q=YOa(f,g,0)|0;if((q|0)==0){o=4;break a}p=c[g>>2]|0;if((p|0)==0){n=q;o=45;break a}TOa(29,p,0,0)|0;n=q;o=45;break};case 102:case 70:{q=YOa(f,g,0)|0;if((q|0)==0){o=4;break a}p=c[g>>2]|0;if((p|0)==0){n=q;o=45;break a}if((a[q]|0)==46){t=YOa(q+1|0,h,0)|0;if((t|0)==0){o=4;break a}x=t;y=c[h>>2]|0}else{c[h>>2]=0;x=q;y=0}TOa(23,p,y,0)|0;n=x;o=45;break};default:{c[67456]=(c[67456]|0)+ -1;c[d>>2]=b;z=0;i=e;return z|0}}}while(0);do{if((o|0)==3){b=YOa(f,g,0)|0;if((b|0)==0){o=4;break}x=c[g>>2]|0;if((x|0)==0){n=b;o=45;break}y=a[b]|0;if(y<<24>>24==46){u=YOa(b+1|0,h,0)|0;if((u|0)==0){o=4;break}A=u;B=a[u]|0}else{c[h>>2]=0;A=b;B=y}if(!(B<<24>>24==101|B<<24>>24==69)){TOa((w|0)==1?24:27,x,c[h>>2]|0,0)|0;n=A;o=45;break}y=YOa(A+1|0,j,0)|0;if((y|0)==0){o=4;break}TOa((w|0)==1?25:28,x,c[h>>2]|0,c[j>>2]|0)|0;n=y;o=45}else if((o|0)==38){y=YOa(f,g,0)|0;if((y|0)==0){o=4;break}x=c[g>>2]|0;if((x|0)==0){n=y;o=45;break}if((a[y]|0)!=46){TOa(r,x,0,0)|0;n=y;o=45;break}b=YOa(y+1|0,h,0)|0;if((b|0)==0){o=4;break}TOa(s,x,c[h>>2]|0,0)|0;n=b;o=45}}while(0);if((o|0)==4){c[d>>2]=0;z=1;i=e;return z|0}else if((o|0)==45){c[d>>2]=n;z=1;i=e;return z|0}return 0}function YOa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=b;b=0;h=0;while(1){j=a[g]|0;k=j<<24>>24;if(j<<24>>24==32){l=b;m=h}else{if((j+ -48<<24>>24&255)>9){break}l=b+1|0;m=(h*10|0)+ -48+k|0}g=g+1|0;b=l;h=m}if((b|0)!=0){n=g;o=h;c[d>>2]=o;i=f;return n|0}n=(e|0)==0?0:g;o=e;c[d>>2]=o;i=f;return n|0}function ZOa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;e=a[b]|0;f=b+1|0;g=a[f]|0;a:do{if(!(g<<24>>24==0)){h=f;j=g;k=b;while(1){if(j<<24>>24==e<<24>>24){l=k+2|0;if((a[l]|0)==e<<24>>24){m=l}else{n=l;break}}else{m=h}l=m+1|0;o=a[l]|0;if(o<<24>>24==0){break a}else{h=l;j=o;k=m}}i=d;return n|0}}while(0);if((c[c[67428]>>2]|0)==0){JOa(100,274808);n=0;i=d;return n|0}else{c[(Qc()|0)>>2]=100;n=0;i=d;return n|0}return 0}function _Oa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;do{if((b|0)>0){h=0;j=b}else{if((b|0)<0){h=1;j=0-b|0;break}c[e>>2]=0;c[d>>2]=1;a[274878|0]=48;k=274878|0;i=g;return k|0}}while(0);c[e>>2]=h;h=23;e=j;while(1){j=h+ -1|0;l=274856+j|0;a[l]=((e>>>0)%(f>>>0)|0)+48;b=(e>>>0)/(f>>>0)|0;if((b|0)==0){break}else{e=b;h=j}}c[d>>2]=24-h;k=l;i=g;return k|0}function $Oa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[67450]|0;f=c[67446]|0;if((e|0)>(f|0)){c[67446]=e;g=e}else{g=f}f=g+1|0;if((f|0)<(c[68738]|0)){h=g}else{aPa(f,g);h=c[67446]|0}g=c[68740]|0;f=g+h|0;if((b|0)==0){j=f}else{a[f]=b;j=g+(h+1)|0}a[j]=0;Qd(g|0,c[67424]|0)|0;h=x$a(g|0)|0;b=g+h|0;if(b>>>0<j>>>0){k=b;l=h;m=g}else{i=d;return 0}while(1){g=l+1|0;h=m+g|0;Yd(a[k]|0,c[67424]|0)|0;Qd(h|0,c[67424]|0)|0;b=x$a(h|0)|0;f=m+(g+b)|0;if(f>>>0<j>>>0){m=h;l=b;k=f}else{break}}i=d;return 0}function aPa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=c[68740]|0;if((f|0)==275040){c[68738]=1024;g=1024}else{g=c[68738]|0}if((g|0)>(b|0)){h=g}else{j=g;do{j=j<<1;}while((j|0)<=(b|0));c[68738]=j;h=j}j=V_a(h)|0;if((j|0)==0){JOa(113,275440);k=c[68740]|0}else{k=f}f=k+d|0;if((d|0)>0){d=j;h=k;while(1){b=h+1|0;a[d]=a[h]|0;if(b>>>0<f>>>0){h=b;d=d+1|0}else{break}}l=c[68740]|0}else{l=k}if((l|0)==275040){m=274960;c[68740]=j;i=e;return}W_a(l);m=274960;c[68740]=j;i=e;return}function bPa(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[67446]|0;f=c[68738]|0;if((e|0)<(f|0)){g=e}else{aPa(e,f);g=c[67446]|0}c[67446]=g+1;a[(c[68740]|0)+g|0]=b;i=d;return}function cPa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+8|0;e=d;f=i;i=i+256|0;g=i;i=i+16|0;h=i;i=i+8|0;j=f;c[67410]=1;f=b+4|0;k=c[f>>2]|0;if(k>>>0>99){if((c[b>>2]|0)==0){JOa(101,274968);l=101;i=d;return l|0}else{c[(Qc()|0)>>2]=101;l=101;i=d;return l|0}}if((c[67422]|0)==0){KOa();m=c[f>>2]|0}else{m=k}k=264624+(m*48|0)|0;c[66146]=k;n=k;a:do{if((c[n>>2]|0)!=0){k=c[b+8>>2]|0;do{if((k|0)!=0){hPa(k,c[b+12>>2]|0,j);o=iPa(j,h)|0;if((o|0)==(c[264632+(m*48|0)>>2]|0)){if((c[h>>2]|0)==(c[264636+(m*48|0)>>2]|0)){break}}c[g+4>>2]=c[f>>2];c[g+8>>2]=0;c[g>>2]=c[b>>2];o=FOa(g)|0;if((o|0)==0){break a}else{l=o}i=d;return l|0}}while(0);k=c[b+32>>2]|0;if((k|0)==0){l=0;i=d;return l|0}o=a[k]|0;if(o<<24>>24==122){p=1}else{p=o<<24>>24==90|0}c[264656+(m*48|0)>>2]=p;l=0;i=d;return l|0}}while(0);p=b+28|0;g=c[p>>2]|0;h=264640+(m*48|0)|0;c[h>>2]=g;o=c[b+32>>2]|0;do{if((o|0)==0){q=0}else{k=a[o]|0;if(k<<24>>24==122){q=1;break}q=k<<24>>24==90|0}}while(0);c[264656+(m*48|0)>>2]=q;q=c[b+24>>2]|0;do{if((q|0)==0){o=264648+(m*48|0)|0;if((g|0)>0){c[o>>2]=0;r=0;break}else{c[o>>2]=1;r=1;break}}else{o=a[q]|0;if(o<<24>>24==70|o<<24>>24==102){c[264648+(m*48|0)>>2]=1;r=1;break}else{c[264648+(m*48|0)>>2]=0;r=0;break}}}while(0);q=c[b+8>>2]|0;do{if((q|0)==0){c[e>>2]=c[f>>2];lc(j|0,274976,e|0)|0}else{hPa(q,c[b+12>>2]|0,j);if((a[j]|0)!=0){break}if((c[b>>2]|0)==0){dPa(107,274968,b);l=107;i=d;return l|0}else{c[(Qc()|0)>>2]=107;l=107;i=d;return l|0}}}while(0);q=264668+(m*48|0)|0;c[q>>2]=0;c[264660+(m*48|0)>>2]=0;e=264664+(m*48|0)|0;c[e>>2]=0;c[n>>2]=0;f=264652+(m*48|0)|0;c[f>>2]=3;g=c[b+16>>2]|0;b:do{if((g|0)!=0){c:do{switch(a[g]|0){case 78:case 110:{if((Fc(j|0,0)|0)!=0){break c}if((c[b>>2]|0)==0){dPa(128,274968,b);l=128;i=d;return l|0}else{c[(Qc()|0)>>2]=128;l=128;i=d;return l|0}break};case 82:case 114:{break};case 83:case 115:{c[q>>2]=1;o=Pb()|0;c[n>>2]=o;if((o|0)!=0){c[264628+(m*48|0)>>2]=0;c[264636+(m*48|0)>>2]=-1;c[264632+(m*48|0)>>2]=-1;c[264644+(m*48|0)>>2]=1;l=0;i=d;return l|0}o=(c[b>>2]|0)==0;k=Qc()|0;s=c[k>>2]|0;if(o){dPa(s,274968,b);l=c[k>>2]|0;i=d;return l|0}else{c[k>>2]=s;l=s;i=d;return l|0}break};case 79:case 111:{if((Fc(j|0,0)|0)==0){break b}s=(c[b>>2]|0)==0;k=Qc()|0;o=c[k>>2]|0;if(s){dPa(o,274968,b);l=c[k>>2]|0;i=d;return l|0}else{c[k>>2]=o;l=o;i=d;return l|0}break};default:{break b}}}while(0);o=mc(j|0,c[68734]|0)|0;if((o|0)==0){break}ad(o|0)|0}}while(0);q=V_a((x$a(j|0)|0)+1|0)|0;c[264628+(m*48|0)>>2]=q;if((q|0)==0){if((c[b>>2]|0)==0){dPa(113,274992,b);l=113;i=d;return l|0}else{c[(Qc()|0)>>2]=113;l=113;i=d;return l|0}}D$a(q|0,j|0)|0;q=b+20|0;if((c[q>>2]|0)==0){t=r}else{t=(c[h>>2]|0)==0?r:0}r=mc(j|0,c[274936+((t|2)<<2)>>2]|0)|0;do{if((r|0)==0){h=mc(j|0,c[274896+(t<<2)>>2]|0)|0;if((h|0)!=0){c[f>>2]=1;u=h;break}h=mc(j|0,c[274936+(t<<2)>>2]|0)|0;if((h|0)!=0){c[e>>2]=1;c[f>>2]=2;u=h;break}h=(c[b>>2]|0)==0;g=Qc()|0;o=c[g>>2]|0;if(h){JOa(o,274968);l=c[g>>2]|0;i=d;return l|0}else{c[g>>2]=o;l=o;i=d;return l|0}}else{u=r}}while(0);c[n>>2]=u;r=264644+(m*48|0)|0;c[r>>2]=IOa(u)|0;u=iPa(j,264636+(m*48|0)|0)|0;c[264632+(m*48|0)>>2]=u;if((u|0)==-1){if((c[b>>2]|0)==0){dPa(108,274968,b);l=108;i=d;return l|0}else{c[(Qc()|0)>>2]=108;l=108;i=d;return l|0}}if((c[r>>2]|0)==0){l=0;i=d;return l|0}if((c[p>>2]|0)!=0){rb(c[n>>2]|0);l=0;i=d;return l|0}p=c[q>>2]|0;if((p|0)==0){l=0;i=d;return l|0}q=a[p]|0;if(!(q<<24>>24==65|q<<24>>24==97)){l=0;i=d;return l|0}if((Zc(c[n>>2]|0,0,2)|0)==0){l=0;i=d;return l|0}if((c[b>>2]|0)==0){dPa(129,274968,b);l=129;i=d;return l|0}else{c[(Qc()|0)>>2]=129;l=129;i=d;return l|0}return 0}function dPa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=d+8|0;g=c[f>>2]|0;if((g|0)==0){JOa(a,b);i=e;return}h=d+12|0;d=c[h>>2]|0;if((d|0)<(c[68738]|0)){j=d;k=g}else{aPa(d,0);j=c[h>>2]|0;k=c[f>>2]|0}f=c[68740]|0;c[(c[66146]|0)+4>>2]=f;hPa(k,j,f);JOa(a,b);i=e;return}function ePa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+40|0;j=g;c[f>>2]=d;lc(j|0,274976,f|0)|0;c[h>>2]=1;c[h+4>>2]=d;c[h+8>>2]=j;c[h+12>>2]=x$a(j|0)|0;c[h+16>>2]=0;c[h+20>>2]=(a|0)==3?275008:275016;c[h+24>>2]=(b|0)==5?275024:275032;c[h+28>>2]=(a|0)==4;c[h+32>>2]=0;a=cPa(h)|0;i=e;return a|0}function fPa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a+4>>2]|0;e=264624+(d*48|0)|0;c[66146]=e;if(d>>>0>99){if((c[a>>2]|0)==0){JOa(101,275456);f=101;i=b;return f|0}else{c[(Qc()|0)>>2]=101;f=101;i=b;return f|0}}do{if((c[e>>2]|0)==0){if((ePa(3,5,d)|0)==0){break}if((c[a>>2]|0)==0){JOa(114,275464);f=114;i=b;return f|0}else{c[(Qc()|0)>>2]=114;f=114;i=b;return f|0}}}while(0);if((c[264648+(d*48|0)>>2]|0)!=0){f=0;i=b;return f|0}if((c[a>>2]|0)==0){JOa(102,275464);f=102;i=b;return f|0}else{c[(Qc()|0)>>2]=102;f=102;i=b;return f|0}return 0}function gPa(){var a=0,b=0;a=i;b=ROa()|0;c[67372]=0;i=a;return b|0}function hPa(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b+c|0;g=d+c|0;while(1){if(!(f>>>0>b>>>0)){h=3;break}j=f+ -1|0;k=g+ -1|0;if((a[j]|0)==32){f=j;g=k}else{break}}if((h|0)==3){a[d]=0;i=e;return}a[g]=0;g=j;j=k;while(1){a[j]=a[g]|0;if(g>>>0>b>>>0){j=j+ -1|0;g=g+ -1|0}else{break}}i=e;return}function iPa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+80|0;e=d;if((pc(a|0,e|0)|0)<0){f=-1;i=d;return f|0}c[b>>2]=c[e>>2];f=c[e+72>>2]|0;i=d;return f|0}function jPa(b,d,e,f,j){b=b|0;d=d|0;e=e|0;f=f|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;l=i;i=i+8|0;m=l;n=i;i=i+16|0;o=i;i=i+56|0;p=o;q=(f|0)<1?2:f;r=c[67452]|0;if((r|0)==0){s=3}else{if((r|0)<(e+2|0)&(r|0)>(0-e|0)){s=3}}a:do{if((s|0)==3){t=(((r|0)<1)<<31>>31)+e|0;if((j|0)==4){u=+g[b>>2]}else{u=+h[b>>3]}do{if(u<0.0){v=-u;w=1;x=1}else{y=c[67432]|0;if(u!=0.0){v=u;w=0;x=y;break}v=0.0;w=0;x=y}}while(0);y=d+ -4-q-t-x|0;if((y|0)<0){break}z=((r|0)<0?r:0)+t|0;A=(z|0)>40;B=A?40:z;C=A?z+ -40|0:0;c[n>>2]=B;z=n+4|0;h[k>>3]=v;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];lc(p|0,275472,n|0)|0;z=a[p]|0;if(!((z+ -48|0)>>>0<10)){if((z|0)==78|(z|0)==110){D=0}else{D=x}z=d-(x$a(p|0)|0)-D|0;if((z|0)<0){break}if((z|0)>0){A=z;do{A=A+ -1|0;le[c[67436]&2047](32);}while((A|0)>0)}if((D|0)!=0){le[c[67436]&2047]((w|0)!=0?45:43)}A=a[p]|0;if(A<<24>>24==0){i=l;return 0}else{E=A;F=p}do{le[c[67436]&2047](E<<24>>24);F=F+1|0;E=a[F]|0;}while(!(E<<24>>24==0));i=l;return 0}A=o+(B+3)|0;if(v!=0.0){t=(Ic(A|0)|0)+1|0;c[m>>2]=t-(c[67452]|0);lc(A|0,275480,m|0)|0}else{t=A;a[t]=3158059;a[t+1|0]=12336;a[t+2|0]=48;a[t+3|0]=0}t=o+(B+4)|0;A=(q|0)<2;if(A){if((a[t]|0)!=48){break}}z=o+(B+6)|0;G=(a[z]|0)==0;b:do{if(G){H=2}else{if((f|0)==0){I=o+(B+2)|0;while(1){J=I+1|0;K=a[J]|0;a[I]=K;if(K<<24>>24==0){H=2;break b}else{I=J}}}I=(f|0)<0;if(I|G){H=I?q:2;break}else{L=2;M=z}while(1){if((L|0)>=(q|0)){break a}I=L+1|0;J=M+1|0;if((a[J]|0)==0){H=I;break}else{L=I;M=J}}}}while(0);if((y|0)>0){z=y;do{z=z+ -1|0;le[c[67436]&2047](32);}while((z|0)>0)}if((x|0)!=0){le[c[67436]&2047]((w|0)!=0?45:43)}z=c[67452]|0;do{if((z|0)<1){le[c[67436]&2047](46);y=c[67436]|0;if((z|0)<0){G=y;J=z;while(1){le[G&2047](48);I=J+1|0;K=c[67436]|0;if((I|0)<0){J=I;G=K}else{N=K;break}}}else{N=y}le[N&2047](a[p]|0);O=o+2|0}else{if((z|0)<=1){O=p;break}le[c[67436]&2047](a[p]|0);G=o+2|0;J=z+ -1|0;K=c[67436]|0;if((J|0)>0){I=z+1|0;P=K;Q=J;J=G;while(1){le[P&2047](a[J]|0);R=Q+ -1|0;S=c[67436]|0;if((R|0)>0){J=J+1|0;Q=R;P=S}else{break}}T=S;U=o+I|0}else{T=K;U=G}le[T&2047](46);O=U}}while(0);if((C|0)==0){V=O}else{z=o+(B+2)|0;if(O>>>0<z>>>0){P=O;while(1){Q=P+1|0;le[c[67436]&2047](a[P]|0);if(Q>>>0<z>>>0){P=Q}else{W=Q;break}}}else{W=O}P=C;while(1){le[c[67436]&2047](48);z=P+ -1|0;if((z|0)>0){P=z}else{V=W;break}}}if(V>>>0<t>>>0){P=V;while(1){C=P+1|0;le[c[67436]&2047](a[P]|0);if(C>>>0<t>>>0){P=C}else{X=C;break}}}else{X=V}if(A){le[c[67436]&2047](a[X+1|0]|0);i=l;return 0}if((H|0)<(q|0)){P=H;do{P=P+1|0;le[c[67436]&2047](48);}while((P|0)<(q|0))}P=a[X]|0;if(P<<24>>24==0){i=l;return 0}else{Y=P;Z=X}do{Z=Z+1|0;le[c[67436]&2047](Y<<24>>24);Y=a[Z]|0;}while(!(Y<<24>>24==0));i=l;return 0}}while(0);if((d|0)>0){_=d}else{i=l;return 0}do{_=_+ -1|0;le[c[67436]&2047](42);}while((_|0)>0);i=l;return 0}function kPa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0;j=i;i=i+16|0;l=j;m=i;i=i+656|0;n=m;if((f|0)==4){o=+g[b>>2]}else{o=+h[b>>3]}b=(e|0)<344;f=b?e:344;p=b?0:e+ -344|0;do{if(o<0.0){q=1;r=-o}else{if(o!=0.0){q=0;r=o;break}q=0;r=0.0}}while(0);e=c[67452]|0;if((e|0)==0){s=r}else{if((e|0)>0){b=e;o=r;while(1){t=o*10.0;u=b+ -1|0;if((u|0)>0){o=t;b=u}else{s=t;break}}}else{b=e;o=r;while(1){r=o*.1;e=b+1|0;if((e|0)<0){o=r;b=e}else{s=r;break}}}}c[l>>2]=f;b=l+4|0;h[k>>3]=s;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=(lc(n|0,275488,l|0)|0)+p|0;if((a[n]|0)!=48|(f|0)==0){v=n;w=b}else{v=m+1|0;w=b+ -1|0}a:do{if((q|0)==1){b=v;while(1){m=a[b]|0;if(!(m<<24>>24==48)){n=m<<24>>24;if((n|0)==0){x=0;break a}else if((n|0)!=46){break}}b=b+1|0}x=1}else{x=q}}while(0);q=(x|0)==0;b=((c[67432]|x|0)!=0)+w|0;if((b|0)>(d|0)){if((d|0)>0){y=d}else{i=j;return 0}do{y=y+ -1|0;le[c[67436]&2047](42);}while((y|0)>0);i=j;return 0}y=d-b|0;if((y|0)>0){b=y;do{b=b+ -1|0;le[c[67436]&2047](32);}while((b|0)>0)}do{if(q){if((c[67432]|0)==0){break}le[c[67436]&2047](43)}else{le[c[67436]&2047](45)}}while(0);q=a[v]|0;if(!(q<<24>>24==0)){b=q;q=v;do{q=q+1|0;le[c[67436]&2047](b<<24>>24);b=a[q]|0;}while(!(b<<24>>24==0))}if((p|0)>0){z=p}else{i=j;return 0}do{z=z+ -1|0;le[c[67436]&2047](48);}while((z|0)>0);i=j;return 0}function lPa(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((f|0)==1){h=a[d]|0}else if((f|0)==4){h=c[d>>2]|0}else{h=b[d>>1]|0}d=e+ -1|0;if((d|0)>0){e=0;do{le[c[67436]&2047](32);e=e+1|0;}while((e|0)<(d|0))}d=c[67436]|0;if((h|0)==0){le[d&2047](70);i=g;return 0}else{le[d&2047](84);i=g;return 0}return 0}function mPa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;do{if((c[67448]|0)!=0){g=nPa()|0;if((g|0)==0){break}else{h=g}i=e;return h|0}}while(0);g=c[a>>2]|0;switch(g|0){case 34:{pPa(b,c[a+4>>2]|0,c[a+8>>2]|0,d,8);h=0;i=e;return h|0};case 32:{oPa(b,c[a+4>>2]|0,d,8);h=0;i=e;return h|0};case 7:{oPa(b,c[a+4>>2]|0,d,10);h=0;i=e;return h|0};case 10:{pPa(b,c[a+4>>2]|0,c[a+8>>2]|0,d,10);h=0;i=e;return h|0};case 36:{tPa(b,c[a+4>>2]|0,c[a+8>>2]|0,d);h=0;i=e;return h|0};case 23:{h=kPa(b,c[a+4>>2]|0,c[a+8>>2]|0,d)|0;i=e;return h|0};case 30:{qPa(b,d);h=0;i=e;return h|0};case 31:{rPa(b,c[a+4>>2]|0,d);h=0;i=e;return h|0};case 25:case 24:case 26:{h=jPa(b,c[a+4>>2]|0,c[a+8>>2]|0,c[a+12>>2]|0,d)|0;i=e;return h|0};case 28:case 27:{h=sPa(b,c[a+4>>2]|0,c[a+8>>2]|0,c[a+12>>2]|0,d)|0;i=e;return h|0};case 35:{tPa(b,c[a+4>>2]|0,0,d);h=0;i=e;return h|0};case 29:{lPa(b,c[a+4>>2]|0,d)|0;h=0;i=e;return h|0};default:{h=c[r>>2]|0;c[f>>2]=g;Cd(h|0,275496,f|0)|0;yOa(c[67372]|0,1)}}return 0}function nPa(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;a=i;b=c[67448]|0;c[67448]=0;if((c[67410]|0)!=0){if((b|0)>0){d=c[67450]|0;e=c[67446]|0;if((d|0)<=(e|0)){f=b;while(1){le[c[67436]&2047](32);g=f+ -1|0;if((g|0)>0){f=g}else{h=0;break}}i=a;return h|0}f=e+b|0;if((d|0)>(f|0)){c[67446]=f;h=0;i=a;return h|0}f=b-d+e|0;c[67446]=d;if((f|0)>0){j=f}else{h=0;i=a;return h|0}while(1){le[c[67436]&2047](32);f=j+ -1|0;if((f|0)>0){j=f}else{h=0;break}}i=a;return h|0}if((b|0)>=0){h=0;i=a;return h|0}j=c[67446]|0;f=j+b|0;if((f|0)>=0){if((c[67450]|0)<(j|0)){c[67450]=j}c[67446]=f;h=0;i=a;return h|0}if((c[c[67428]>>2]|0)==0){JOa(110,275584);h=110;i=a;return h|0}else{c[(Qc()|0)>>2]=110;h=110;i=a;return h|0}}if((b|0)<0){f=c[67446]|0;if((c[67450]|0)<(f|0)){c[67450]=f}j=f+b|0;c[67446]=j;c[67454]=(c[67454]|0)+b;if((j|0)>=0){h=0;i=a;return h|0}if((c[c[67428]>>2]|0)==0){JOa(110,275584);h=110;i=a;return h|0}else{c[(Qc()|0)>>2]=110;h=110;i=a;return h|0}}if((b|0)<=0){h=0;i=a;return h|0}j=c[67446]|0;f=j+b|0;if((f|0)>=(c[(c[67430]|0)+16>>2]|0)){if((c[c[67428]>>2]|0)==0){JOa(110,275600);h=110;i=a;return h|0}else{c[(Qc()|0)>>2]=110;h=110;i=a;return h|0}}d=c[67450]|0;if((d|0)<=(j|0)){e=b;while(1){le[c[67436]&2047](32);g=e+ -1|0;if((g|0)>0){e=g}else{h=0;break}}i=a;return h|0}if((d|0)>(f|0)){c[67454]=(c[67454]|0)+b;c[67446]=f;h=0;i=a;return h|0}f=d-j|0;j=b-f|0;c[67454]=(c[67454]|0)+f;c[67446]=d;if((j|0)>0){k=j}else{h=0;i=a;return h|0}while(1){le[c[67436]&2047](32);j=k+ -1|0;if((j|0)>0){k=j}else{h=0;break}}i=a;return h|0}



function Vxa(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;var A=0,B=0,C=0.0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0,N=0.0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0.0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0,ga=0,ha=0;v=i;A=c[f>>2]|0;B=~A;C=+h[n>>3];h[27440]=C;c[t>>2]=0;D=c[e>>2]|0;c[54882]=1;if((D|0)>=1){E=1;do{c[s+(E+ -1<<2)>>2]=0;F=c[54882]|0;E=F+1|0;c[54882]=E;}while((F|0)<(D|0))}G=+h[g>>3];if(!(G>=0.0)){H=-G}else{H=G}if(!(C>=0.0)){I=-C}else{I=C}h[27447]=(H+I)*+h[u>>3]*100.0;u=c[b>>2]|0;do{if((u|0)==3){J=C;K=+h[g>>3]}else if((u|0)==2){do{if((c[x+68>>2]|0)!=0){b=w+320|0;_xa(g,b,k,l,f,o,m,n)|0;if((c[54262]|0)>0){i=v;return 0}D=d;he[D&7](f,b,k,e,p,y,z)|0;if((c[54262]|0)>0){i=v;return 0}E=x+60|0;c[E>>2]=(c[E>>2]|0)+1;a[219584]=0;F=c[e>>2]|0;c[54882]=1;if((F|0)<1){break}else{L=0;M=1}while(1){I=+h[p+(M+ -1<<3)>>3];if(!(I>=0.0)){N=-I}else{N=I}if(!(N<=0.0)){O=L}else{a[219584]=1;O=1}if((M|0)<(F|0)){L=O;M=M+1|0}else{break}}c[54882]=F+1;if(!O){break}I=+BOa(219576,219520);h[27444]=I;H=I+ +h[b>>3];h[b>>3]=H;I=+h[27440];do{if((H- +h[g>>3])*I<0.0){_xa(g,b,k,l,f,o,m,n)|0;if((c[54262]|0)<=0){break}i=v;return 0}else{G=+h[27444]/I;h[27445]=G;P=c[f>>2]|0;c[54882]=1;if((P|0)<1){break}Q=(A<<1)+B|0;R=G;S=1;while(1){T=k+(S+ -1<<3)|0;h[T>>3]=+h[T>>3]+R*+h[m+(Q+S<<3)>>3];if((S|0)>=(P|0)){break}R=+h[27445];S=S+1|0}c[54882]=P+1}}while(0);he[D&7](f,b,k,e,p,y,z)|0;if((c[54262]|0)>0){i=v;return 0}c[E>>2]=(c[E>>2]|0)+1;a[219584]=0;F=c[e>>2]|0;c[54882]=1;if((F|0)<1){break}else{U=0;V=1}while(1){S=V+ -1|0;I=+h[p+(S<<3)>>3];if(!(I>=0.0)){W=-I}else{W=I}if(W>0.0){X=U;Y=V}else{c[s+(S<<2)>>2]=1;a[219584]=1;X=1;Y=c[54882]|0}S=Y+1|0;c[54882]=S;if((Y|0)<(F|0)){U=X;V=S}else{break}}if(!X){break}c[t>>2]=1;i=v;return 0}}while(0);I=+h[g>>3];if(I==+h[w+328>>3]){i=v;return 0}else{J=+h[27440];K=I;break}}else{F=w+320|0;_xa(g,F,k,l,f,o,m,n)|0;if((c[54262]|0)>0){i=v;return 0}E=d;he[E&7](f,F,k,e,p,y,z)|0;if((c[54262]|0)>0){i=v;return 0}b=x+60|0;c[b>>2]=1;a[219584]=0;D=c[e>>2]|0;c[54882]=1;if((D|0)<1){i=v;return 0}else{Z=0;_=1}while(1){I=+h[p+(_+ -1<<3)>>3];if(!(I>=0.0)){$=-I}else{$=I}if(!($<=0.0)){aa=Z}else{a[219584]=1;aa=1}if((_|0)<(D|0)){Z=aa;_=_+1|0}else{break}}c[54882]=D+1;if(!aa){i=v;return 0}I=+BOa(219576,219520);h[27444]=I;h[F>>3]=I+ +h[F>>3];I=+h[27444]/+h[27440];h[27445]=I;S=c[f>>2]|0;c[54882]=1;if((S|0)>=1){Q=(A<<1)+B|0;H=I;T=1;while(1){ba=k+(T+ -1<<3)|0;h[ba>>3]=+h[ba>>3]+H*+h[m+(Q+T<<3)>>3];if((T|0)>=(S|0)){break}H=+h[27445];T=T+1|0}c[54882]=S+1}he[E&7](f,F,k,e,p,y,z)|0;if((c[54262]|0)>0){i=v;return 0}c[b>>2]=(c[b>>2]|0)+1;a[219584]=0;T=c[e>>2]|0;c[54882]=1;if((T|0)<1){i=v;return 0}else{ca=0;da=1}while(1){H=+h[p+(da+ -1<<3)>>3];if(!(H>=0.0)){ea=-H}else{ea=H}if(!(ea<=0.0)){fa=ca}else{a[219584]=1;fa=1}if((da|0)<(T|0)){ca=fa;da=da+1|0}else{break}}c[54882]=T+1;if(!fa){i=v;return 0}c[t>>2]=-1;i=v;return 0}}while(0);ea=+h[j>>3];do{if(!((ea-K)*J>=0.0)){h[27443]=ea;if((ea- +h[w+320>>3])*J<=0.0){i=v;return 0}_xa(g,219544,k,l,f,o,m,n)|0;if((c[54262]|0)<=0){break}i=v;return 0}else{h[27443]=K;j=c[f>>2]|0;c[54882]=1;if((j|0)<1){break}else{ga=1}while(1){fa=ga+ -1|0;h[k+(fa<<3)>>3]=+h[m+(fa<<3)>>3];if((ga|0)<(j|0)){ga=ga+1|0}else{break}}c[54882]=j+1}}while(0);ga=d;he[ga&7](f,219544,k,e,q,y,z)|0;if((c[54262]|0)>0){i=v;return 0}d=x+60|0;c[d>>2]=(c[d>>2]|0)+1;c[54892]=0;T=w+320|0;fa=x+76|0;da=x+72|0;x=w+336|0;ca=w+344|0;while(1){Wxa(e,219576,219568,T,219544,p,q,r,219536,s,fa,da,x,ca)|0;if((c[54262]|0)>0){ha=76;break}if((c[54892]|0)>1){ha=73;break}_xa(g,219536,k,l,f,o,m,n)|0;if((c[54262]|0)>0){ha=76;break}he[ga&7](f,219536,k,e,r,y,z)|0;if((c[54262]|0)>0){ha=76;break}c[d>>2]=(c[d>>2]|0)+1}if((ha|0)==73){h[T>>3]=+h[27442];T=216968;qya(e,r,T,p,T)|0;if((c[54892]|0)==4){i=v;return 0}_xa(g,219536,k,l,f,o,m,n)|0;if((c[54262]|0)>0){i=v;return 0}c[t>>2]=1;i=v;return 0}else if((ha|0)==76){i=v;return 0}return 0}function Wxa(b,d,e,f,g,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,L=0.0,M=0.0,N=0.0,O=0.0;s=i;do{if((c[e>>2]|0)==1){c[54908]=c[o>>2];c[o>>2]=0;h[27450]=0.0;a[219616]=0;t=c[b>>2]|0;c[54898]=1;if((t|0)>=1){u=1;do{v=u+ -1|0;w=+h[l+(v<<3)>>3];if(!(w>=0.0)){x=-w}else{x=w}do{if(x>0.0){w=+BOa(219648,j+(v<<3)|0);if(w==+BOa(219648,l+((c[54898]|0)+ -1<<3)|0)){break}y=c[54898]|0;z=y+ -1|0;w=+h[l+(z<<3)>>3];A=w/(w- +h[j+(z<<3)>>3]);if(!(A>=0.0)){B=-A}else{B=A}if(B<=+h[27450]){break}h[27450]=B;c[o>>2]=y}else{a[219616]=1}}while(0);v=c[54898]|0;u=v+1|0;c[54898]=u;}while((v|0)<(t|0))}do{if((c[o>>2]|0)>0){a[219624]=1;c[54910]=c[p>>2];h[g>>3]=+h[r>>3];t=216968;qya(b,l,t,k,t)|0;c[p>>2]=1;a[219608]=0;C=0}else{a[219624]=0;c[o>>2]=c[54908];c[54910]=c[p>>2];if(a[219616]&1){h[g>>3]=+h[r>>3];t=216968;qya(b,l,t,k,t)|0;a[219608]=1;C=1;break}else{t=216968;qya(b,l,t,j,t)|0;h[f>>3]=+h[r>>3];c[p>>2]=0;a[219608]=0;C=0;break}}}while(0);A=+h[g>>3];w=A- +h[f>>3];if(!(w>=0.0)){D=-w}else{D=w}if(!(D<=+h[d>>3])){if(!C){break}E=+h[g>>3]}else{a[219608]=1;E=A}c[e>>2]=2;h[m>>3]=E;t=216968;qya(b,k,t,l,t)|0;t=c[b>>2]|0;c[54898]=1;if((t|0)<1){i=s;return 0}else{F=1}do{c[n+(F+ -1<<2)>>2]=0;u=(c[54898]|0)+ -1|0;A=+h[k+(u<<3)>>3];if(!(A>=0.0)){G=-A}else{G=A}do{if(G>0.0){A=+BOa(219648,j+(u<<3)|0);if(!(A!=+BOa(219648,k+((c[54898]|0)+ -1<<3)|0))){break}c[n+((c[54898]|0)+ -1<<2)>>2]=1}else{c[n+(u<<2)>>2]=1}}while(0);u=c[54898]|0;F=u+1|0;c[54898]=F;}while((u|0)<(t|0));i=s;return 0}else{c[o>>2]=0;h[27450]=0.0;a[219616]=0;t=c[b>>2]|0;c[54898]=1;if((t|0)>=1){u=1;do{v=u+ -1|0;A=+h[k+(v<<3)>>3];if(!(A>=0.0)){H=-A}else{H=A}do{if(H>0.0){A=+BOa(219648,j+(v<<3)|0);if(A==+BOa(219648,k+((c[54898]|0)+ -1<<3)|0)){break}y=c[54898]|0;z=y+ -1|0;A=+h[k+(z<<3)>>3];w=A/(A- +h[j+(z<<3)>>3]);if(!(w>=0.0)){I=-w}else{I=w}if(I<=+h[27450]){break}h[27450]=I;c[o>>2]=y}else{a[219616]=1}}while(0);v=c[54898]|0;u=v+1|0;c[54898]=u;}while((v|0)<(t|0))}t=(c[o>>2]|0)>0;a[219624]=t&1;if(t){a[219608]=0;c[54910]=0;c[p>>2]=1;break}if(!(a[219616]&1)){t=216968;qya(b,k,t,l,t)|0;h[m>>3]=+h[g>>3];c[e>>2]=4;i=s;return 0}h[m>>3]=+h[g>>3];t=216968;qya(b,k,t,l,t)|0;t=c[b>>2]|0;c[54898]=1;if((t|0)>=1){u=1;do{c[n+(u+ -1<<2)>>2]=0;v=c[54898]|0;y=v+ -1|0;w=+h[k+(y<<3)>>3];if(!(w>=0.0)){J=-w}else{J=w}if(!(J<=0.0)){K=v}else{c[n+(y<<2)>>2]=1;K=c[54898]|0}u=K+1|0;c[54898]=u;}while((K|0)<(t|0))}c[e>>2]=3;i=s;return 0}}while(0);K=c[54910]|0;do{if((K|0)==(c[p>>2]|0)){J=+h[q>>3];if((K|0)==0){I=J*2.0;h[q>>3]=I;L=I;break}else{I=J*.5;h[q>>3]=I;L=I;break}}else{h[q>>3]=1.0;L=1.0}}while(0);I=+h[g>>3];q=(c[o>>2]|0)+ -1|0;J=+h[k+(q<<3)>>3];H=I-(I- +h[f>>3])*J/(J-L*+h[j+(q<<3)>>3]);h[r>>3]=H;L=+h[f>>3];J=H-L;if(!(J>=0.0)){M=-J}else{M=J}J=+h[d>>3];do{if(M<J){I=+h[g>>3]-L;if(!(I>=0.0)){N=-I}else{N=I}if(!(N>J*10.0)){O=H;break}G=L+I*.1;h[r>>3]=G;O=G}else{O=H}}while(0);c[e>>2]=1;h[m>>3]=O;i=s;return 0}function Xxa(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0.0,o=0.0,p=0.0;k=i;h[27459]=+h[d>>3];h[27458]=+h[e>>3];j=c[a>>2]|0;c[54914]=1;if((j|0)<1){i=k;return 0}else{l=1}while(1){if((c[b>>2]|0)==0){m=l+ -1|0;n=+h[27459]}else{a=l+ -1|0;o=+h[d+(a<<3)>>3];h[27459]=o;h[27458]=+h[e+(a<<3)>>3];m=a;n=o}o=+h[f+(m<<3)>>3];if(!(o>=0.0)){p=-o}else{p=o}h[g+(m<<3)>>3]=n*p+ +h[27458];a=l+1|0;c[54914]=a;if((l|0)<(j|0)){l=a}else{break}}i=k;return 0}function Yxa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0.0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;f=i;h[27462]=0.0;e=c[a>>2]|0;c[54920]=1;if((e|0)<1){g=0.0;i=f;return+g}else{j=0.0;k=1}while(1){l=k+ -1|0;m=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3];if(!(m>=0.0)){n=-m}else{n=m}if(n>j){l=k+ -1|0;m=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3];if(!(m>=0.0)){o=-m}else{o=m}h[27462]=o;p=o}else{p=j}if((k|0)<(e|0)){j=p;k=k+1|0}else{break}}c[54920]=e+1;if(p<=0.0){g=0.0;i=f;return+g}h[27461]=0.0;e=c[a>>2]|0;c[54920]=1;if((e|0)<1){q=0.0}else{j=0.0;k=1;while(1){l=k+ -1|0;o=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3]/p;r=j+o*o;h[27461]=r;if((k|0)<(e|0)){k=k+1|0;j=r}else{break}}c[54920]=e+1;q=r}g=p*+V(+(q/+(c[a>>2]|0)));i=f;return+g}function Zxa(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,V=0.0,W=0.0;y=i;i=i+16|0;z=y;A=y+8|0;B=c[f>>2]|0;c[m>>2]=1;c[54938]=0;c[54936]=0;c[54942]=0;h[27474]=+h[b>>3];h[27476]=+Yxa(f,d,l,0,0);C=c[f>>2]|0;c[54926]=1;D=(B<<1)+~B|0;if((C|0)>=1){B=1;while(1){E=B+ -1|0;h[p+(E<<3)>>3]=+h[d+(E<<3)>>3];h[p+(D+B<<3)>>3]=+h[e+(B+ -1<<3)>>3];if((B|0)<(C|0)){B=B+1|0}else{break}}c[54926]=C+1}C=t+44|0;B=g;E=t+48|0;F=+h[k>>3];a:while(1){h[27467]=1.0/F;h[b>>3]=+h[k>>3]+ +h[b>>3];G=c[f>>2]|0;c[54926]=1;if((G|0)>=1){H=1;while(1){I=H+ -1|0;J=d+(I<<3)|0;h[J>>3]=+h[J>>3]+ +h[k>>3]*+h[e+(I<<3)>>3];if((H|0)<(G|0)){H=H+1|0}else{break}}c[54926]=G+1}a[219800]=1;c[54928]=0;a[219816]=1;c[C>>2]=(c[C>>2]|0)+1;c[54946]=0;he[B&7](b,d,e,q,219784,n,o)|0;b:do{if((c[54946]|0)<0){K=35}else{while(1){if(a[219800]&1){c[E>>2]=(c[E>>2]|0)+1;a[219800]=0;aya(f,b,d,e,q,219736,k,219760,l,r,s,t,g,219784,v,j,n,o,x)|0;h[27466]=1.0e6;if((c[54946]|0)<0|(c[54940]|0)!=0){K=35;break b}c[54942]=0}H=c[f>>2]|0;c[54926]=1;if((H|0)>=1){I=1;while(1){J=q+(I+ -1<<3)|0;h[J>>3]=+h[J>>3]*.75;if((I|0)<(H|0)){I=I+1|0}else{break}}c[54926]=H+1}bya(f,q,s,t)|0;I=c[f>>2]|0;c[54926]=1;if((I|0)>=1){J=1;while(1){L=J+ -1|0;M=d+(L<<3)|0;h[M>>3]=+h[M>>3]- +h[q+(L<<3)>>3];L=J+ -1|0;M=e+(L<<3)|0;h[M>>3]=+h[M>>3]- +h[27467]*+h[q+(L<<3)>>3];if((J|0)<(I|0)){J=J+1|0}else{break}}c[54926]=I+1}N=+Yxa(f,q,l,0,0);h[27478]=N;if(N<=+h[v>>3]*100.0*+h[27476]){break}J=c[54928]|0;if((J|0)>0){h[z>>3]=N/+h[27479];h[A>>3]=1.0/+(J|0);O=+zOa(z,A);if(O>.9){K=35;break b}P=O/(1.0-O);h[27466]=P;Q=+h[27478];R=P}else{h[27479]=N;Q=N;R=+h[27466]}if(R*Q<=.33){break}J=c[54928]|0;H=J+1|0;c[54928]=H;if((J|0)>8){K=35;break b}if(((H|0)%5|0|0)==0){a[219800]=1}c[C>>2]=(c[C>>2]|0)+1;c[54946]=0;he[B&7](b,d,e,q,219784,n,o)|0;if((c[54946]|0)<0){K=35;break b}}do{if((c[w>>2]|0)!=0){H=c[f>>2]|0;c[54926]=1;if((H|0)>=1){J=1;while(1){S=+h[d+(J+ -1<<3)>>3];h[q+(J+ -1<<3)>>3]=S<=0.0?S:0.0;if((J|0)<(H|0)){J=J+1|0}else{break}}h[z>>3]=S;c[54926]=H+1}N=+Yxa(f,q,l,0,0);h[27478]=N;if(N>.33){K=35;break b}J=c[f>>2]|0;c[54926]=1;if((J|0)<1){break}else{T=1}while(1){I=T+ -1|0;L=d+(I<<3)|0;h[L>>3]=+h[L>>3]- +h[q+(I<<3)>>3];I=T+ -1|0;L=e+(I<<3)|0;h[L>>3]=+h[L>>3]- +h[27467]*+h[q+(I<<3)>>3];if((T|0)<(J|0)){T=T+1|0}else{break}}c[54926]=J+1}}while(0);if(!(a[219816]&1)){break}H=c[f>>2]|0;c[54926]=1;if((H|0)>=1){I=1;while(1){L=I+ -1|0;h[r+(L<<3)>>3]=+h[d+(L<<3)>>3]- +h[p+(L<<3)>>3];if((I|0)<(H|0)){I=I+1|0}else{break}}c[54926]=H+1}N=+Yxa(f,r,l,0,0);h[27472]=N;if(N<=1.0){K=63;break a}}}while(0);if((K|0)==35){K=0;a[219816]=0}h[b>>3]=+h[27474];G=c[f>>2]|0;c[54926]=1;if((G|0)>=1){I=1;while(1){L=I+ -1|0;h[d+(L<<3)>>3]=+h[p+(L<<3)>>3];h[e+(I+ -1<<3)>>3]=+h[p+(D+I<<3)>>3];if((I|0)<(G|0)){I=I+1|0}else{break}}c[54926]=G+1}if(a[219816]&1){I=(c[54938]|0)+1|0;c[54938]=I;N=.9/(+h[27472]*2.0+1.0e-4);h[z>>3]=.1;P=N>=.5?.5:N;h[A>>3]=P;N=P<=.1?.1:P;h[27465]=N;P=+h[k>>3]*N;h[k>>3]=P;if(!(P>=0.0)){U=-P}else{U=P}if(U>=+h[u>>3]&(I|0)<10){F=P;continue}else{K=62;break}}if((c[54940]|0)!=0){I=(c[54942]|0)+1|0;c[54942]=I;P=+h[k>>3]*.25;h[k>>3]=P;if((I|0)>=3){K=51;break}if(!(P>=0.0)){V=-P}else{V=P}if(!(V>=+h[u>>3])){K=51;break}else{F=P;continue}}if(!((c[54946]|0)>-2)){K=53;break}I=(c[54936]|0)+1|0;c[54936]=I;P=+h[k>>3]*.25;h[k>>3]=P;if((I|0)>=10){K=58;break}if(!(P>=0.0)){W=-P}else{W=P}if(!(W>=+h[u>>3])){K=58;break}else{F=P}}if((K|0)==51){c[m>>2]=-12;i=y;return 0}else if((K|0)==53){c[m>>2]=-12;i=y;return 0}else if((K|0)==58){c[m>>2]=-12;i=y;return 0}else if((K|0)==62){c[m>>2]=-12;i=y;return 0}else if((K|0)==63){i=y;return 0}return 0}function _xa(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0;l=i;m=c[f>>2]|0;n=~m;o=(c[g>>2]|0)+1|0;c[54972]=o;p=+h[b>>3]- +h[a>>3];h[27484]=p;a=c[f>>2]|0;c[54964]=1;if((a|0)<1){q=p}else{b=1;while(1){g=b+ -1|0;h[d+(g<<3)>>3]=+h[j+(g<<3)>>3];h[e+(b+ -1<<3)>>3]=0.0;if((b|0)<(a|0)){b=b+1|0}else{break}}c[54964]=a+1;q=+h[27484]}h[27480]=1.0;h[27481]=0.0;p=q/+h[k>>3];h[27485]=p;c[54966]=2;if((o|0)<2){i=l;return 0}else{r=q;s=1.0;t=p;u=0.0;v=2}while(1){a=k+(v+ -2<<3)|0;h[27481]=u*t+s/+h[a>>3];p=t*s;h[27480]=p;h[27485]=(r+ +h[a>>3])/+h[k+(v+ -1<<3)>>3];a=c[f>>2]|0;c[54964]=1;if((a|0)>=1){b=fa(v,m)|0;q=p;g=1;while(1){w=d+(g+ -1<<3)|0;h[w>>3]=+h[w>>3]+q*+h[j+(g+n+b<<3)>>3];w=e+(g+ -1<<3)|0;h[w>>3]=+h[w>>3]+ +h[27481]*+h[j+(g+n+b<<3)>>3];if((g|0)>=(a|0)){break}q=+h[27480];g=g+1|0}c[54964]=a+1}g=v+1|0;c[54966]=g;if((v|0)>=(o|0)){break}r=+h[27484];s=+h[27480];t=+h[27485];u=+h[27481];v=g}i=l;return 0}function $xa(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A,B,C,D,E,F,G,H,I,J,K,L,M){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;B=B|0;C=C|0;D=D|0;E=E|0;F=F|0;G=G|0;H=H|0;I=I|0;J=J|0;K=K|0;L=L|0;M=M|0;var N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0,pa=0.0,qa=0,ra=0,sa=0.0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0,Ca=0,Da=0.0,Ea=0,Fa=0,Ga=0.0,Ha=0;N=i;i=i+16|0;O=N;P=N+8|0;Q=c[f>>2]|0;R=~Q;c[n>>2]=1;h[27507]=+h[b>>3];c[54992]=0;c[55e3]=0;c[54994]=0;S=u+52|0;if((c[m>>2]|0)==0){c[S>>2]=0;T=u+56|0;c[T>>2]=0;c[I>>2]=1;c[J>>2]=0;h[C>>3]=0.0;c[m>>2]=1;h[y>>3]=+h[k>>3];U=1.0/+h[k>>3];h[B>>3]=U;h[A>>3]=U;h[D>>3]=100.0;c[H>>2]=-1;h[27519]=1.0;c[G>>2]=0;c[K>>2]=0;V=T}else{V=u+56|0}T=u+44|0;m=g;W=u+48|0;while(1){c[54988]=(c[I>>2]|0)+1;c[54990]=(c[I>>2]|0)+2;c[54986]=(c[I>>2]|0)+ -1;h[27507]=+h[b>>3];do{if(+h[k>>3]!=+h[C>>3]){X=8}else{Y=c[I>>2]|0;if((Y|0)!=(c[J>>2]|0)){X=8;break}Z=(c[K>>2]|0)+1|0;_=Y}}while(0);if((X|0)==8){X=0;c[K>>2]=0;Z=1;_=c[J>>2]|0}Y=_+2|0;$=(Z|0)<=(Y|0)?Z:Y;c[K>>2]=$;c[55004]=$+1;$=c[54988]|0;if(($|0)>=(c[K>>2]|0)){h[w>>3]=1.0;h[v>>3]=1.0;h[27510]=+h[k>>3];h[x>>3]=0.0;h[z>>3]=1.0;c[54974]=2;if(($|0)>=2){Y=2;while(1){h[27511]=+h[y+(Y+ -2<<3)>>3];U=+h[27510];aa=Y+ -2|0;h[y+(aa<<3)>>3]=U;ba=Y+ -1|0;h[w+(ba<<3)>>3]=+h[w+(aa<<3)>>3]*U/+h[27511];U=+h[27511]+ +h[k>>3];h[27510]=U;ca=+h[k>>3]/U;h[v+(ba<<3)>>3]=ca;h[z+(ba<<3)>>3]=ca*+h[z+(aa<<3)>>3]*+(ba|0);h[x+(ba<<3)>>3]=+h[x+(aa<<3)>>3]+ +h[v+(aa<<3)>>3]/+h[k>>3];if((Y|0)<($|0)){Y=Y+1|0}else{break}}c[54974]=$+1}h[y+($+ -1<<3)>>3]=+h[27510]}h[27517]=0.0;h[27515]=0.0;Y=c[I>>2]|0;c[54974]=1;if((Y|0)<1){da=0.0}else{ca=0.0;U=0.0;aa=1;while(1){ea=U-1.0/+(aa|0);h[27517]=ea;ga=ca- +h[v+(aa+ -1<<3)>>3];h[27515]=ga;if((aa|0)<(Y|0)){aa=aa+1|0;U=ea;ca=ga}else{break}}c[54974]=Y+1;da=ea}h[27518]=+h[A>>3];h[A>>3]=-da/+h[k>>3];aa=v+($+ -1<<3)|0;ca=+h[aa>>3]+ +h[27517]- +h[27515];h[O>>3]=ca;if(!(ca>=0.0)){ha=-ca}else{ha=ca}h[27492]=ha;h[O>>3]=ha;ca=+h[aa>>3];h[P>>3]=ca;h[27492]=ha>=ca?ha:ca;h[27510]=.6;h[27511]=1.6666666666666667;ca=+h[A>>3];U=ca/+h[B>>3];if(U<.6|U>1.6666666666666667){c[H>>2]=-1}if(ca!=+h[27518]){h[D>>3]=100.0}aa=c[54988]|0;ba=c[55004]|0;if((aa|0)>=(ba|0)){c[54976]=ba;ia=ba;while(1){ba=c[f>>2]|0;c[54974]=1;if((ba|0)>=1){ja=1;while(1){ka=q+(ja+R+(fa(ia,Q)|0)<<3)|0;h[ka>>3]=+h[w+(ia+ -1<<3)>>3]*+h[ka>>3];if((ja|0)<(ba|0)){ja=ja+1|0}else{break}}c[54974]=ba+1}ja=ia+1|0;c[54976]=ja;if((ia|0)<(aa|0)){ia=ja}else{break}}}h[b>>3]=+h[k>>3]+ +h[b>>3];a:while(1){ia=c[f>>2]|0;c[54974]=1;if((ia|0)>=1){aa=1;while(1){$=aa+ -1|0;h[d+($<<3)>>3]=+h[q+($<<3)>>3];h[e+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ia|0)){aa=aa+1|0}else{break}}c[54974]=ia+1}aa=c[54988]|0;c[54976]=2;if((aa|0)>=2){ba=2;while(1){$=c[f>>2]|0;c[54974]=1;if(($|0)>=1){Y=x+(ba+ -1<<3)|0;ja=fa(ba,Q)|0;ka=ja+R|0;la=1;while(1){ma=d+(la+ -1<<3)|0;h[ma>>3]=+h[q+(la+R+ja<<3)>>3]+ +h[ma>>3];ma=e+(la+ -1<<3)|0;h[ma>>3]=+h[ma>>3]+ +h[Y>>3]*+h[q+(ka+la<<3)>>3];if((la|0)<($|0)){la=la+1|0}else{break}}c[54974]=$+1}la=ba+1|0;c[54976]=la;if((ba|0)<(aa|0)){ba=la}else{break}}}h[27514]=+Yxa(f,d,l,0,0);a[220160]=1;c[54978]=0;c[T>>2]=(c[T>>2]|0)+1;c[55008]=0;he[m&7](b,d,e,r,220032,o,p)|0;if((c[55008]|0)<0){X=70;break}if((c[H>>2]|0)==-1){c[W>>2]=(c[W>>2]|0)+1;c[H>>2]=0;aya(f,b,d,e,r,A,k,219984,l,s,t,u,g,220032,F,j,o,p,M)|0;h[B>>3]=+h[A>>3];h[D>>3]=100.0;if((c[55008]|0)<0|(c[54996]|0)!=0){X=70;break}c[55e3]=0}ba=c[f>>2]|0;c[54974]=1;if((ba|0)>=1){aa=1;while(1){h[s+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ba|0)){aa=aa+1|0}else{break}}c[54974]=ba+1}while(1){ca=2.0/(+h[A>>3]/+h[B>>3]+1.0);h[27510]=ca;aa=c[f>>2]|0;c[54974]=1;if((aa|0)>=1){U=ca;ia=1;la=0;while(1){ka=r+(la<<3)|0;h[ka>>3]=U*+h[ka>>3];if((ia|0)>=(aa|0)){break}ka=ia;U=+h[27510];ia=ia+1|0;la=ka}c[54974]=aa+1}bya(f,r,t,u)|0;la=c[f>>2]|0;c[54974]=1;if((la|0)>=1){ia=1;while(1){$=ia+ -1|0;ka=d+($<<3)|0;h[ka>>3]=+h[ka>>3]- +h[r+($<<3)>>3];$=ia+ -1|0;ka=r+($<<3)|0;Y=s+($<<3)|0;h[Y>>3]=+h[Y>>3]- +h[ka>>3];Y=e+($<<3)|0;h[Y>>3]=+h[Y>>3]- +h[A>>3]*+h[ka>>3];if((ia|0)<(la|0)){ia=ia+1|0}else{break}}c[54974]=la+1}U=+Yxa(f,r,l,0,0);h[27519]=U;if(U<=+h[F>>3]*100.0*+h[27514]){X=63;break a}ia=c[54978]|0;if((ia|0)>0){h[O>>3]=U/+h[27521];h[P>>3]=1.0/+(ia|0);ca=+zOa(O,P);if(ca>.9){break}ga=ca/(1.0-ca);h[D>>3]=ga;na=+h[27519];oa=ga}else{h[27521]=U;na=U;oa=+h[D>>3]}if(oa*na<=.33){X=63;break a}ia=c[54978]|0;c[54978]=ia+1;if((ia|0)>2){break}c[T>>2]=(c[T>>2]|0)+1;c[55008]=0;he[m&7](b,d,e,r,220032,o,p)|0;if((c[55008]|0)<0){X=70;break a}}if((c[H>>2]|0)==0){X=70;break}c[H>>2]=-1}do{if((X|0)==63){X=0;if((c[L>>2]|0)==0){break}ba=c[f>>2]|0;c[54974]=1;if((ba|0)>=1){ia=1;while(1){pa=+h[d+(ia+ -1<<3)>>3];h[r+(ia+ -1<<3)>>3]=pa<=0.0?pa:0.0;if((ia|0)<(ba|0)){ia=ia+1|0}else{break}}h[O>>3]=pa;c[54974]=ba+1}U=+Yxa(f,r,l,0,0);h[27519]=U;if(U>.33){X=70;break}ia=c[f>>2]|0;c[54974]=1;if((ia|0)<1){break}else{qa=1}while(1){aa=qa+ -1|0;ka=s+(aa<<3)|0;h[ka>>3]=+h[ka>>3]- +h[r+(aa<<3)>>3];if((qa|0)<(ia|0)){qa=qa+1|0}else{break}}c[54974]=ia+1}}while(0);if((X|0)==70){X=0;a[220160]=0}c[H>>2]=1;if(a[220160]&1){U=+Yxa(f,s,l,0,0);h[27513]=U;ba=c[I>>2]|0;ga=U*+h[z+(ba<<3)>>3];h[27499]=ga;h[27506]=ga*+(ba+1|0);h[27501]=ga;c[55010]=ba;do{if((c[I>>2]|0)!=1){ba=c[f>>2]|0;c[54974]=1;if((ba|0)>=1){aa=fa(c[54988]|0,Q)|0;ka=1;while(1){Y=ka+ -1|0;h[r+(Y<<3)>>3]=+h[q+(ka+R+aa<<3)>>3]+ +h[s+(Y<<3)>>3];if((ka|0)<(ba|0)){ka=ka+1|0}else{break}}c[54974]=ba+1}ga=+h[z+((c[I>>2]|0)+ -1<<3)>>3];U=ga*+Yxa(f,r,l,0,0);h[27508]=U;ka=c[I>>2]|0;ga=U*+(ka|0);h[27516]=ga;if((ka|0)>2){aa=c[f>>2]|0;c[54974]=1;ia=c[I>>2]|0;if((aa|0)<1){ra=ia}else{Y=ia;ia=1;while(1){ca=+h[q+(ia+R+(fa(Y,Q)|0)<<3)>>3];$=r+(ia+ -1<<3)|0;h[$>>3]=ca+ +h[$>>3];$=ia+1|0;c[54974]=$;ja=c[I>>2]|0;if((ia|0)<(aa|0)){ia=$;Y=ja}else{ra=ja;break}}}ca=+h[z+(ra+ -2<<3)>>3];sa=ca*+Yxa(f,r,l,0,0);Y=c[I>>2]|0;ca=sa*+(Y+ -1|0);sa=+h[27516];if((sa>=ca?sa:ca)>+h[27506]){break}ta=+h[27508];ua=Y}else{if(!(ga<=+h[27506]*.5)){break}else{ta=U;ua=ka}}c[55010]=ua+ -1;h[27501]=ta}}while(0);if(!(+h[27492]*+h[27513]>1.0)){X=86;break}}c[G>>2]=1;h[b>>3]=+h[27507];Y=c[54988]|0;ia=c[55004]|0;if((Y|0)>=(ia|0)){c[54976]=ia;aa=ia;while(1){ca=1.0/+h[w+(aa+ -1<<3)>>3];h[27510]=ca;ia=c[f>>2]|0;c[54974]=1;if((ia|0)>=1){ba=fa(aa,Q)|0;sa=ca;ja=1;while(1){$=q+(ja+R+ba<<3)|0;h[$>>3]=sa*+h[$>>3];if((ja|0)>=(ia|0)){break}sa=+h[27510];ja=ja+1|0}c[54974]=ia+1}ja=aa+1|0;c[54976]=ja;if((aa|0)<(Y|0)){aa=ja}else{break}}}c[54974]=2;if((Y|0)>=2){aa=2;while(1){h[y+(aa+ -2<<3)>>3]=+h[y+(aa+ -1<<3)>>3]- +h[k>>3];if((aa|0)<(Y|0)){aa=aa+1|0}else{break}}c[54974]=Y+1}if(!(a[220160]&1)){c[V>>2]=(c[V>>2]|0)+1;if((c[54996]|0)!=0){aa=(c[55e3]|0)+1|0;c[55e3]=aa;h[27490]=.25;sa=+h[k>>3]*.25;h[k>>3]=sa;if((aa|0)>=3){X=144;break}if(!(sa>=0.0)){va=-sa}else{va=sa}if(!(va>=+h[E>>3])){X=144;break}else{continue}}if(!((c[55008]|0)>-2)){X=146;break}aa=(c[54992]|0)+1|0;c[54992]=aa;h[27490]=.25;sa=+h[k>>3]*.25;h[k>>3]=sa;if((aa|0)>=10){X=151;break}if(!(sa>=0.0)){wa=-sa}else{wa=sa}if(!(wa>=+h[E>>3])){X=151;break}else{continue}}c[54994]=(c[54994]|0)+1;c[S>>2]=(c[S>>2]|0)+1;aa=c[54994]|0;if((aa|0)<=1){ja=c[55010]|0;c[I>>2]=ja;sa=+(ja+1|0);h[27511]=sa;h[O>>3]=+h[27501]*2.0+1.0e-4;h[P>>3]=-1.0/sa;sa=+zOa(O,P)*.9;h[O>>3]=.25;U=sa>=.9?.9:sa;h[P>>3]=U;sa=U<=.25?.25:U;h[27490]=sa;U=+h[k>>3]*sa;h[k>>3]=U;if(!(U>=0.0)){xa=-U}else{xa=U}if(!(xa>=+h[E>>3])){X=156;break}else{continue}}if((aa|0)>2){c[I>>2]=1;U=+h[k>>3]*.25;h[k>>3]=U;if(!(U>=0.0)){ya=-U}else{ya=U}if(!(ya>=+h[E>>3])){X=165;break}else{continue}}else{c[I>>2]=c[55010];U=+h[k>>3]*.25;h[k>>3]=U;if(!(U>=0.0)){za=-U}else{za=U}if(!(za>=+h[E>>3])){X=161;break}else{continue}}}if((X|0)==86){c[n>>2]=1;E=u+40|0;c[E>>2]=(c[E>>2]|0)+1;c[55024]=(c[I>>2]|0)-(c[J>>2]|0);c[J>>2]=c[I>>2];h[C>>3]=+h[k>>3];C=c[55010]|0;E=c[54986]|0;do{if((C|0)==(E|0)){X=88}else{S=u+8|0;if((c[I>>2]|0)==(c[S>>2]|0)){X=88;break}if((c[G>>2]|0)!=0){Aa=E;Ba=C;X=90;break}c[I>>2]=c[54988];za=+h[k>>3]*2.0;h[27503]=za;Ca=S;Da=za}}while(0);if((X|0)==88){c[G>>2]=1;Aa=c[54986]|0;Ba=c[55010]|0;X=90}if((X|0)==90){do{if((Ba|0)==(Aa|0)){Ea=Aa;X=104}else{G=c[I>>2]|0;C=u+8|0;if((G|0)==(c[C>>2]|0)){Fa=G;break}if((c[54988]|0)>=(c[K>>2]|0)|(c[55024]|0)==1){Fa=G;break}G=c[f>>2]|0;c[54974]=1;if((G|0)>=1){E=fa(c[54990]|0,Q)|0;S=1;while(1){V=S+ -1|0;h[r+(V<<3)>>3]=+h[s+(V<<3)>>3]- +h[q+(S+R+E<<3)>>3];if((S|0)<(G|0)){S=S+1|0}else{break}}c[54974]=G+1}za=1.0/+((c[I>>2]|0)+2|0);ya=za*+Yxa(f,r,l,0,0);h[27509]=ya;S=c[I>>2]|0;za=ya*+(S+2|0);if((S|0)>1){xa=+h[27506];E=xa<=za;if(+h[27516]<=(E?xa:za)){Ea=c[54986]|0;X=104;break}if(E){Fa=S;break}if((S|0)==(c[C>>2]|0)){Fa=S;break}}else{if(za>=+h[27506]*.5){Fa=S;break}}S=c[54988]|0;c[I>>2]=S;h[27501]=ya;Fa=S}}while(0);if((X|0)==104){c[I>>2]=Ea;h[27501]=+h[27508];Fa=Ea}h[27503]=+h[k>>3];ya=+(Fa+1|0);h[27511]=ya;h[O>>3]=+h[27501]*2.0+1.0e-4;h[P>>3]=-1.0/ya;ya=+zOa(O,P);h[27490]=ya;do{if(ya<2.0){if(ya>1.0){Ga=+h[27503];break}else{h[O>>3]=.5;za=ya>=.9?.9:ya;h[P>>3]=za;xa=za<=.5?.5:za;h[27490]=xa;za=+h[k>>3]*xa;h[27503]=za;Ga=za;break}}else{za=+h[k>>3]*2.0;h[27503]=za;Ga=za}}while(0);Ca=u+8|0;Da=Ga}h[k>>3]=Da;do{if((c[J>>2]|0)!=(c[Ca>>2]|0)){k=c[f>>2]|0;c[54974]=1;if((k|0)<1){break}u=fa(c[54990]|0,Q)|0;P=1;while(1){h[q+(P+R+u<<3)>>3]=+h[s+(P+ -1<<3)>>3];if((P|0)<(k|0)){P=P+1|0}else{break}}c[54974]=k+1}}while(0);Ca=c[f>>2]|0;c[54974]=1;if((Ca|0)>=1){J=fa(c[54988]|0,Q)|0;P=1;while(1){u=q+(P+R+J<<3)|0;h[u>>3]=+h[s+(P+ -1<<3)>>3]+ +h[u>>3];if((P|0)<(Ca|0)){P=P+1|0}else{break}}c[54974]=Ca+1}Ca=c[54988]|0;c[54982]=2;if((Ca|0)<2){i=N;return 0}else{Ha=2}while(1){P=1-Ha+Ca|0;c[54976]=P;s=c[f>>2]|0;c[54974]=1;if((s|0)>=1){J=fa(P+1|0,Q)|0;u=fa(P,Q)|0;P=1;while(1){C=P+R|0;G=q+(C+u<<3)|0;h[G>>3]=+h[q+(C+J<<3)>>3]+ +h[G>>3];if((P|0)<(s|0)){P=P+1|0}else{break}}c[54974]=s+1}P=Ha+1|0;c[54982]=P;if((Ha|0)<(Ca|0)){Ha=P}else{break}}i=N;return 0}else if((X|0)==144){c[n>>2]=-8}else if((X|0)==146){c[n>>2]=-11}else if((X|0)==151){c[n>>2]=-7;Ha=(c[55008]>>31&-3)+ -7|0;c[n>>2]=Ha;c[n>>2]=(c[54994]|0)>2?-9:Ha}else if((X|0)==156){c[n>>2]=-6}else if((X|0)==161){c[n>>2]=-6}else if((X|0)==165){c[n>>2]=-6}_xa(b,b,d,e,f,I,q,y)|0;i=N;return 0}function aya(b,d,e,f,g,j,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0.0,ta=0.0,ua=0.0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+16|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+16|0;I=i;i=i+8|0;J=i;i=i+16|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;c[m>>2]=0;O=c[q+12>>2]|0;a:do{if((O|0)==3){i=y;return 0}else if((O|0)==5){P=q+4|0;Q=(c[P>>2]|0)+(c[q>>2]|0)|0;R=Q+1|0;c[55070]=R;S=c[b>>2]|0;c[55060]=(Q|0)<(S|0)?R:S;S=c[q>>2]|0;c[55078]=R+S;c[55064]=S+Q;Q=(c[b>>2]|0)/(R|0)|0;c[55074]=Q+1;R=c[x>>2]|0;c[55072]=R+ -1;c[55082]=R+Q;c[s>>2]=0;h[27534]=+V(+(+h[t>>3]));Q=c[55060]|0;c[55046]=1;if((Q|0)<1){T=75;break}R=r;S=1;while(1){U=c[b>>2]|0;W=c[55070]|0;c[55052]=S;X=(W|0)<0;b:do{if(X?(S|0)>=(U|0):(S|0)<=(U|0)){Y=W;Z=S;_=S;while(1){$=(_-Z|0)/(Y|0)|0;c[55048]=$+1;aa=_+ -1|0;ba=e+(aa<<3)|0;h[p+((c[55072]|0)+$<<3)>>3]=+h[ba>>3];ca=f+(aa<<3)|0;h[p+((c[55082]|0)+$<<3)>>3]=+h[ca>>3];da=+h[ba>>3];h[N>>3]=da;if(!(da>=0.0)){ea=-da}else{ea=da}da=+h[l>>3]*+h[ca>>3];if(!(da>=0.0)){ga=-da}else{ga=da}da=ea>=ga?ea:ga;ha=+h[n+(aa<<3)>>3];if(!(ha>=0.0)){ia=-ha}else{ia=ha}h[27531]=+h[27534]*(da>=ia?da:ia);h[N>>3]=+h[l>>3]*+h[ca>>3];da=+BOa(220248,N);h[27531]=da;ca=c[55052]|0;aa=ca+ -1|0;ba=e+(aa<<3)|0;ha=+h[ba>>3];ja=da+ha-ha;h[27531]=ja;h[ba>>3]=+h[ba>>3]+ja;ba=f+(aa<<3)|0;h[ba>>3]=+h[j>>3]*+h[27531]+ +h[ba>>3];ba=ca+W|0;c[55052]=ba;if(!(X?(ba|0)>=(U|0):(ba|0)<=(U|0))){break b}Y=c[55070]|0;Z=c[55046]|0;_=ba}}}while(0);he[R&7](d,e,f,o,s,v,w)|0;if((c[s>>2]|0)<0){break}U=c[b>>2]|0;X=c[55070]|0;W=c[55046]|0;c[55052]=W;_=(X|0)<0;c:do{if(_?(W|0)>=(U|0):(W|0)<=(U|0)){Z=X;Y=W;ba=W;while(1){ca=(ba-Y|0)/(Z|0)|0;c[55048]=ca+1;aa=ba+ -1|0;$=e+(aa<<3)|0;h[$>>3]=+h[p+((c[55072]|0)+ca<<3)>>3];ja=+h[p+((c[55082]|0)+ca<<3)>>3];ca=f+(aa<<3)|0;h[ca>>3]=ja;ha=+h[$>>3];h[N>>3]=ha;if(!(ha>=0.0)){ka=-ha}else{ka=ha}ha=+h[l>>3]*ja;if(!(ha>=0.0)){la=-ha}else{la=ha}ha=ka>=la?ka:la;ja=+h[n+(aa<<3)>>3];if(!(ja>=0.0)){ma=-ja}else{ma=ja}h[27531]=+h[27534]*(ha>=ma?ha:ma);h[N>>3]=+h[l>>3]*+h[ca>>3];ha=+BOa(220248,N);h[27531]=ha;ca=c[55052]|0;ja=+h[e+(ca+ -1<<3)>>3];da=ha+ja-ja;h[27531]=da;ja=1.0/da;h[27540]=ja;aa=ca-(c[P>>2]|0)|0;$=(aa|0)>1?aa:1;c[55054]=$;aa=c[b>>2]|0;na=(c[q>>2]|0)+ca|0;oa=(aa|0)<=(na|0)?aa:na;c[55056]=oa;pa=fa(c[55064]|0,ca)|0;qa=pa-(c[q>>2]|0)|0;c[55058]=qa;c[55044]=$;if(($|0)<=(oa|0)){pa=~aa;aa=~na;na=~((pa|0)>(aa|0)?pa:aa);aa=($|0)>(na|0)?$:na;da=ja;na=$;while(1){$=na+ -1|0;h[p+($+qa<<3)>>3]=(+h[o+($<<3)>>3]- +h[g+($<<3)>>3])*da;if((na|0)>=(oa|0)){break}da=+h[27540];na=na+1|0}c[55044]=aa+1}na=ca+X|0;c[55052]=na;oa=c[55046]|0;if(!(_?(na|0)>=(U|0):(na|0)<=(U|0))){ra=oa;break c}Z=c[55070]|0;Y=oa;ba=na}}else{ra=W}}while(0);W=ra+1|0;c[55046]=W;if((ra|0)<(Q|0)){S=W}else{T=75;break a}}i=y;return 0}else if((O|0)==4){S=c[q>>2]|0;Q=q+4|0;P=c[Q>>2]|0;R=c[b>>2]|0;W=fa(P+1+(S<<1)|0,R)|0;c[55044]=1;if((W|0)>=1){U=fa(R,P+(S<<1)+1|0)|0;S=(U|0)<1;P=1;while(1){h[p+(P+ -1<<3)>>3]=0.0;if((P|0)<(W|0)){P=P+1|0}else{break}}c[55044]=S?2:U+1|0}ne[u&7](d,e,f,g,p,j,l,n,v,w)|0;c[55078]=(c[Q>>2]|0)+1+(c[q>>2]<<1);T=75}else if((O|0)==2){c[s>>2]=0;c[55066]=0;h[27534]=+V(+(+h[t>>3]));P=c[b>>2]|0;c[55044]=1;d:do{if((P|0)>=1){W=r;R=1;while(1){_=R+ -1|0;da=+h[e+(_<<3)>>3];h[N>>3]=da;if(!(da>=0.0)){sa=-da}else{sa=da}X=f+(_<<3)|0;da=+h[l>>3]*+h[X>>3];if(!(da>=0.0)){ta=-da}else{ta=da}da=sa>=ta?sa:ta;ja=+h[n+(_<<3)>>3];if(!(ja>=0.0)){ua=-ja}else{ua=ja}h[27531]=+h[27534]*(da>=ua?da:ua);h[N>>3]=+h[l>>3]*+h[X>>3];da=+BOa(220248,N);h[27531]=da;X=(c[55044]|0)+ -1|0;_=e+(X<<3)|0;ja=+h[_>>3];ha=da+ja-ja;h[27531]=ha;h[27538]=+h[_>>3];ba=f+(X<<3)|0;h[27542]=+h[ba>>3];h[_>>3]=ha+ +h[_>>3];h[ba>>3]=+h[j>>3]*+h[27531]+ +h[ba>>3];he[W&7](d,e,f,o,s,v,w)|0;if((c[s>>2]|0)<0){break}ha=1.0/+h[27531];h[27540]=ha;ba=c[b>>2]|0;c[55050]=1;_=c[55066]|0;if((ba|0)>=1){ja=ha;X=1;Y=0;while(1){h[p+(Y+_<<3)>>3]=(+h[o+(Y<<3)>>3]- +h[g+(Y<<3)>>3])*ja;if((X|0)>=(ba|0)){break}Z=X;ja=+h[27540];X=X+1|0;Y=Z}c[55050]=ba+1}c[55066]=_+(c[b>>2]|0);Y=c[55044]|0;X=Y+ -1|0;h[e+(X<<3)>>3]=+h[27538];h[f+(X<<3)>>3]=+h[27542];R=Y+1|0;c[55044]=R;if((Y|0)>=(P|0)){break d}}i=y;return 0}}while(0);if((c[w>>2]|0)==0){T=42;break}c[55066]=0;P=c[b>>2]|0;if((c[206200>>2]|0)==0){T=42;break}Q=V_a(P*20|0)|0;U=F;h[k>>3]=+h[d>>3];c[U>>2]=c[k>>2];c[U+4>>2]=c[k+4>>2];hwa(14,1,220344,F);U=E;h[k>>3]=+h[j>>3];c[U>>2]=c[k>>2];c[U+4>>2]=c[k+4>>2];hwa(14,0,220368,E);hwa(14,1,220376,D);c[55048]=0;if((c[b>>2]|0)>0){U=0;do{ja=+h[e+(U<<3)>>3];c[C>>2]=U+1;S=C+4|0;h[k>>3]=ja;c[S>>2]=c[k>>2];c[S+4>>2]=c[k+4>>2];hwa(14,0,220384,C);U=(c[55048]|0)+1|0;c[55048]=U;}while((U|0)<(c[b>>2]|0))}le[c[51674]&2047](14);hwa(14,1,220440,B);c[55044]=1;if((P|0)>=1){U=Q+1|0;S=c[55066]|0;R=1;do{W=p+(R+ -1+S<<3)|0;h[W>>3]=+h[j>>3]+ +h[W>>3];a[Q]=0;a[U]=0;c[55050]=1;W=S;Y=0;while(1){ja=+h[p+(Y+W<<3)>>3];c[A>>2]=Q;X=A+4|0;h[k>>3]=ja;c[X>>2]=c[k>>2];c[X+4>>2]=c[k+4>>2];lc(Q|0,220424,A|0)|0;X=c[55050]|0;c[55050]=X+1;if((X|0)>=(P|0)){break}W=c[55066]|0;Y=X}c[z>>2]=Q;hwa(14,0,220432,z);Y=c[55066]|0;W=c[55044]|0;X=p+(Y+ -1+W<<3)|0;h[X>>3]=+h[X>>3]- +h[j>>3];S=Y+(c[b>>2]|0)|0;c[55066]=S;R=W+1|0;c[55044]=R;}while((W|0)<(P|0))}le[c[51674]&2047](14);le[c[51674]&2047](14);W_a(Q);T=42}else{P=c[b>>2]|0;R=fa(P,P)|0;c[55044]=1;if((R|0)!=0){P=(R|0)<1;S=1;while(1){h[p+(S+ -1<<3)>>3]=0.0;if((S|0)<(R|0)){S=S+1|0}else{break}}c[55044]=P?2:R+1|0}ne[u&7](d,e,f,g,p,j,l,n,v,w)|0;if((c[w>>2]|0)==0){T=42;break}c[55066]=0;S=c[b>>2]|0;if((c[206200>>2]|0)==0){T=42;break}Q=V_a(S*20|0)|0;U=M;h[k>>3]=+h[d>>3];c[U>>2]=c[k>>2];c[U+4>>2]=c[k+4>>2];hwa(14,1,220344,M);U=L;h[k>>3]=+h[j>>3];c[U>>2]=c[k>>2];c[U+4>>2]=c[k+4>>2];hwa(14,0,220368,L);hwa(14,1,220376,K);c[55048]=0;if((c[b>>2]|0)>0){U=0;do{ja=+h[e+(U<<3)>>3];c[J>>2]=U+1;W=J+4|0;h[k>>3]=ja;c[W>>2]=c[k>>2];c[W+4>>2]=c[k+4>>2];hwa(14,0,220384,J);U=(c[55048]|0)+1|0;c[55048]=U;}while((U|0)<(c[b>>2]|0))}le[c[51674]&2047](14);hwa(14,1,220400,I);c[55044]=1;if((S|0)>=1){U=Q+1|0;R=c[55066]|0;P=1;do{W=p+(P+ -1+R<<3)|0;h[W>>3]=+h[j>>3]+ +h[W>>3];a[Q]=0;a[U]=0;c[55050]=1;W=R;Y=0;while(1){ja=+h[p+(Y+W<<3)>>3];c[H>>2]=Q;X=H+4|0;h[k>>3]=ja;c[X>>2]=c[k>>2];c[X+4>>2]=c[k+4>>2];lc(Q|0,220424,H|0)|0;X=c[55050]|0;c[55050]=X+1;if((X|0)>=(S|0)){break}W=c[55066]|0;Y=X}c[G>>2]=Q;hwa(14,0,220432,G);Y=c[55066]|0;W=c[55044]|0;X=p+(Y+ -1+W<<3)|0;h[X>>3]=+h[X>>3]- +h[j>>3];R=Y+(c[b>>2]|0)|0;c[55066]=R;P=W+1|0;c[55044]=P;}while((W|0)<(S|0))}le[c[51674]&2047](14);le[c[51674]&2047](14);W_a(Q);T=42}}while(0);if((T|0)==42){iya(p,b,b,q+80|0,m)|0;i=y;return 0}else if((T|0)==75){oya(p,220312,b,q,q+4|0,q+80|0,m)|0;i=y;return 0}return 0}function bya(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=c[e+12>>2]|0;if((g|0)==4|(g|0)==5){h=e+4|0;c[55116]=(c[h>>2]|0)+1+(c[e>>2]<<1);pya(d,220464,a,e,h,e+80|0,b,220472)|0;i=f;return 0}else if((g|0)==3){i=f;return 0}else{mya(d,a,a,e+80|0,b,220472)|0;i=f;return 0}return 0}function cya(b,d){b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0.0;d=i;i=i+8|0;e=d;do{if(!(a[220480]&1)){a[220480]=1;dya(220528,220496,220576,220512,220560,220584,220568,220592)|0;h[27565]=+(c[55132]|0);f=c[55124]|0;h[27561]=+(f|0);if((c[55144]|0)==0){h[27563]=0.0;c[e>>2]=1-f;g=+AOa(220520,e)}else{h[27563]=1.0;c[e>>2]=1-f;g=+AOa(220520,e)*.5}h[27564]=g;h[27568]=g*+h[27565];h[27567]=+(c[55140]|0);h[27569]=+(c[55142]|0);j=+h[27573];h[27576]=j;k=1.0/+h[27574];if(!(k>=j)){break}h[27576]=k*(g+1.0)}}while(0);if((vya(b,220616,1,1)|0)!=0){g=+h[27564];h[27575]=g;l=g;i=d;return+l}if((vya(b,220624,1,1)|0)!=0){g=+h[27576];h[27575]=g;l=g;i=d;return+l}if((vya(b,220632,1,1)|0)!=0){g=+h[27565];h[27575]=g;l=g;i=d;return+l}if((vya(b,220640,1,1)|0)!=0){g=+h[27568];h[27575]=g;l=g;i=d;return+l}if((vya(b,220648,1,1)|0)!=0){g=+h[27561];h[27575]=g;l=g;i=d;return+l}if((vya(b,220656,1,1)|0)!=0){g=+h[27563];h[27575]=g;l=g;i=d;return+l}if((vya(b,220664,1,1)|0)!=0){g=+h[27567];h[27575]=g;l=g;i=d;return+l}if((vya(b,220672,1,1)|0)!=0){g=+h[27573];h[27575]=g;l=g;i=d;return+l}if((vya(b,220680,1,1)|0)!=0){g=+h[27569];h[27575]=g;l=g;i=d;return+l}if((vya(b,220688,1,1)|0)==0){l=+h[27575];i=d;return+l}else{g=+h[27574];h[27575]=g;l=g;i=d;return+l}return 0.0}function dya(b,d,e,f,g,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;m=i;i=i+24|0;n=m;o=m+8|0;p=m+16|0;if(a[220800]&1){q=221168;r=c[55292]|0;c[b>>2]=r;s=221104;t=c[55276]|0;c[d>>2]=t;u=221144;v=c[55286]|0;c[e>>2]=v;w=221152;x=+h[27644];h[f>>3]=x;y=221184;z=c[55296]|0;c[g>>2]=z;A=221232;B=+h[27654];h[j>>3]=B;C=221192;D=c[55298]|0;c[k>>2]=D;E=221240;F=+h[27655];h[l>>3]=F;i=m;return 0}a[220800]=1;h[27645]=0.0;h[27639]=1.0;h[27640]=2.0;eya(221168,221104,221144,221256)|0;h[27635]=+(c[55292]|0);c[n>>2]=0-(c[55276]|0);G=+AOa(221080,n);h[27634]=G;h[27644]=G;H=+h[27640];h[27635]=H/3.0;I=+h[27639];J=I*.5;h[27642]=J;K=-J;h[o>>3]=K;h[27656]=+fya(221080,o);L=221248;h[27653]=+fya(L,L);h[o>>3]=K;h[27635]=+fya(221224,o);K=+fya(221080,221248);h[27635]=K;if(!(K>=0.0)){M=-K}else{M=K}K=M<G?G:M;h[27635]=K;h[27644]=1.0;M=+h[27645];if(K<1.0&K>M){N=K;while(1){h[27644]=N;h[o>>3]=N*J;K=H*H;h[p>>3]=N*N*H*K*K;K=+fya(o,p);h[27636]=K;h[o>>3]=-K;h[27636]=+fya(221136,o);K=+fya(221136,221088);h[27635]=K;h[o>>3]=-K;h[27636]=+fya(221136,o);K=+fya(221136,221088);h[27635]=K;if(N>K&K>M){N=K}else{O=N;break}}}else{O=1.0}if(G<O){h[27644]=G}G=I/+(c[55292]|0);h[27647]=G;h[27651]=I;c[55274]=1;p=1;O=I;do{h[o>>3]=O*G;O=+fya(o,221160);h[27651]=O;p=p+1|0;c[55274]=p;}while((p|0)<4);h[27634]=+fya(221112,221208);gya(221272,221112,221168)|0;h[o>>3]=-+h[27639];gya(221264,o,221168)|0;gya(221216,221072,221168)|0;h[o>>3]=-+h[27634];gya(221200,o,221168)|0;c[55282]=0;p=c[55318]|0;L=c[55316]|0;P=c[55304]|0;Q=(p|0)==(P|0);do{if((p|0)==(L|0)&(P|0)==(c[55300]|0)){if(Q){c[55296]=p;R=0;S=25;break}if((P-p|0)==3){c[55296]=p+ -1+(c[55276]|0);c[55282]=1;R=1;S=25;break}else{c[55296]=(p|0)<=(P|0)?p:P;a[220808]=1;S=26;break}}else{T=Q&(L|0)==(c[55300]|0);U=p-L|0;c[n>>2]=U;V=(((U|0)>-1?U:0-U|0)|0)==1;if(T){if(V){c[55296]=(p|0)>=(L|0)?p:L;R=0;S=25;break}else{c[55296]=(p|0)<=(L|0)?p:L;a[220808]=1;S=26;break}}T=c[55300]|0;U=(p|0)<=(L|0)?p:L;if(!(V&(P|0)==(T|0))){V=(U|0)<=(P|0)?U:P;c[n>>2]=V;c[55296]=(V|0)<=(T|0)?V:T;a[220808]=1;S=26;break}if((P-U|0)==3){c[55296]=((p|0)>=(L|0)?p:L)+ -1+(c[55276]|0);R=0;S=25;break}else{c[55296]=U;a[220808]=1;S=26;break}}}while(0);if((S|0)==25){if(a[220808]&1){S=26}else{W=R}}if((S|0)==26){a[220800]=0;yPa(221280)|0;POa(221304,221184,4)|0;gPa()|0;W=c[55282]|0}if((W|0)==0){X=(c[55314]|0)!=0|0}else{X=1}c[55282]=X;h[27654]=1.0;X=c[55296]|0;W=1-X|0;c[n>>2]=W;c[55274]=1;if((X|0)<=0){O=+h[27647];X=1;G=1.0;while(1){h[o>>3]=G*O;I=+fya(o,221160);h[27654]=I;n=X+1|0;c[55274]=n;if((X|0)<(W|0)){G=I;X=n}else{break}}}hya(221168,221104,221184,221128,221192,221240)|0;q=221168;r=c[55292]|0;c[b>>2]=r;s=221104;t=c[55276]|0;c[d>>2]=t;u=221144;v=c[55286]|0;c[e>>2]=v;w=221152;x=+h[27644];h[f>>3]=x;y=221184;z=c[55296]|0;c[g>>2]=z;A=221232;B=+h[27654];h[j>>3]=B;C=221192;D=c[55298]|0;c[k>>2]=D;E=221240;F=+h[27655];h[l>>3]=F;i=m;return 0}function eya(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0;g=i;i=i+16|0;j=g;k=g+8|0;if(a[220696]&1){l=a[220768]&1;m=c[55194]|0;c[b>>2]=m;n=220744;o=c[55186]|0;c[d>>2]=o;p=l&1;c[e>>2]=p;q=220792;r=c[55198]|0;c[f>>2]=r;i=g;return 0}a[220696]=1;h[27594]=1.0;h[27588]=1.0;h[27590]=1.0;s=1.0;do{s=s*2.0;h[27588]=s;h[27590]=+fya(220704,220752);h[j>>3]=-s;t=+fya(220720,j);h[27590]=t;}while(t==1.0);h[27589]=1.0;t=+fya(220704,220712);h[27590]=t;if(t==s){u=1.0;while(1){v=u*2.0;h[27589]=v;w=+fya(220704,220712);h[27590]=w;if(w==s){u=v}else{x=w;break}}}else{x=t}h[27595]=.25;h[27598]=x;h[j>>3]=-s;t=+fya(220720,j);h[27590]=t;y=~~(t+.25);c[55194]=y;t=+(y|0);h[27589]=t;u=t*.5;h[j>>3]=u;h[k>>3]=-t/100.0;h[27591]=+fya(j,k);w=+fya(220728,220704);h[27590]=w;z=w==s;a[220768]=z&1;h[j>>3]=u;h[k>>3]=t/100.0;h[27591]=+fya(j,k);w=+fya(220728,220704);h[27590]=w;if(z&w==s){a[220768]=0;A=0}else{A=z}h[j>>3]=u;w=+fya(j,220704);h[27592]=w;h[j>>3]=u;z=w==s&+fya(j,220784)>x;c[55198]=z?A&1:0;c[55186]=0;h[27588]=1.0;h[27590]=1.0;x=1.0;z=0;while(1){k=z+1|0;c[55186]=k;s=x*t;h[27588]=s;h[27590]=+fya(220704,220752);h[j>>3]=-s;w=+fya(220720,j);h[27590]=w;if(w==1.0){z=k;x=s}else{l=A;m=y;break}}c[b>>2]=m;n=220744;o=c[55186]|0;c[d>>2]=o;p=l&1;c[e>>2]=p;q=220792;r=c[55198]|0;c[f>>2]=r;i=g;return 0}function fya(a,b){a=a|0;b=b|0;i=i;return+(+h[a>>3]+ +h[b>>3])}function gya(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0,v=0.0;e=i;i=i+8|0;f=e;g=+h[b>>3];h[27664]=g;j=1.0/+(c[d>>2]|0);h[27673]=j;h[27672]=0.0;c[a>>2]=1;h[f>>3]=g*j;k=+fya(f,221376);h[27666]=k;h[27668]=g;h[27669]=g;h[27670]=g;h[27671]=g;if(g==g&0.0==0.0){l=0;m=k}else{i=e;return 0}while(1){c[a>>2]=l;h[27664]=m;b=c[d>>2]|0;k=+(b|0);h[f>>3]=m/k;g=+fya(f,221376);h[27666]=g;h[f>>3]=g*k;k=+fya(f,221376);h[27668]=k;h[27670]=0.0;c[55330]=1;if((b|0)<1){n=0.0}else{o=1;p=0.0;while(1){q=g+p;if((o|0)<(b|0)){p=q;o=o+1|0}else{break}}h[27670]=q;c[55330]=b+1;n=q}h[f>>3]=m*j;p=+fya(f,221376);h[27667]=p;h[f>>3]=p/j;r=+fya(f,221376);h[27669]=r;h[27671]=0.0;o=c[d>>2]|0;c[55330]=1;if((o|0)<1){s=0.0}else{t=1;u=0.0;while(1){v=p+u;if((t|0)<(o|0)){u=v;t=t+1|0}else{break}}h[27671]=v;c[55330]=o+1;s=v}if(!(k==m&r==m&n==m&s==m)){break}l=(c[a>>2]|0)+ -1|0;m=g}i=e;return 0}function hya(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0.0;j=i;i=i+8|0;k=j;c[55354]=1;c[55362]=1;l=0-(c[d>>2]|0)|0;if((l|0)<2){m=2;n=l;o=2;p=1}else{l=1;q=2;while(1){c[55354]=q;r=l+1|0;c[55362]=r;s=q<<1;t=0-(c[d>>2]|0)|0;if((s|0)>(t|0)){break}else{q=s;l=r}}m=s;n=t;o=l+2|0;p=q}if((p|0)==(n|0)){c[55358]=n;u=n}else{c[55358]=m;c[55362]=o;u=m}m=c[d>>2]|0;o=((m+u|0)>(0-(p+m)|0)?p:u)<<1;c[55364]=o;u=o+(c[d>>2]|0)|0;d=u+ -1|0;c[f>>2]=d;do{if((((c[55362]|0)+1+(c[b>>2]|0)|0)%2|0|0)==1){if((c[a>>2]|0)!=2){v=d;break}o=u+ -2|0;c[f>>2]=o;v=o}else{v=d}}while(0);if((c[e>>2]|0)!=0){c[f>>2]=v+ -1}w=+(c[a>>2]|0);x=1.0/w;h[27680]=x;y=w+-1.0;h[27676]=y;h[27675]=0.0;v=c[b>>2]|0;c[55348]=1;do{if((v|0)<1){z=0.0}else{b=1;w=0.0;A=y;while(1){B=x*A;h[27676]=B;if(w<1.0){h[27678]=w}C=+fya(221400,221408);h[27675]=C;e=b+1|0;c[55348]=e;if((b|0)<(v|0)){b=e;w=C;A=B}else{break}}if(!(C>=1.0)){z=C;break}A=+h[27678];h[27675]=A;z=A}}while(0);v=c[f>>2]|0;c[55348]=1;if((v|0)<1){D=z;h[g>>3]=D;i=j;return 0}else{E=1;F=z}while(1){h[k>>3]=F*+(c[a>>2]|0);z=+fya(k,221464);h[27675]=z;f=E+1|0;c[55348]=f;if((E|0)<(v|0)){F=z;E=f}else{D=z;break}}h[g>>3]=D;i=j;return 0}function iya(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=i;i=i+16|0;j=g;k=g+8|0;l=c[b>>2]|0;b=~l;c[f>>2]=0;m=c[d>>2]|0;n=m+ -1|0;if((m|0)<2){o=m}else{c[55370]=1;m=1;do{c[55376]=m+1;c[j>>2]=(c[d>>2]|0)+1-m;p=jya(j,a+(m+b+(fa(m,l)|0)<<3)|0,221512)|0;q=c[55370]|0;r=p+ -1+q|0;c[55372]=r;c[e+(q+ -1<<2)>>2]=r;r=c[55372]|0;q=c[55370]|0;p=fa(q,l)|0;s=+h[a+(r+b+p<<3)>>3];do{if(s==0.0){c[f>>2]=q}else{if((r|0)==(q|0)){t=r}else{h[27687]=s;u=a+(q+b+p<<3)|0;h[a+(p+b+r<<3)>>3]=+h[u>>3];h[u>>3]=+h[27687];t=q}u=fa(t,l)|0;h[27687]=-1.0/+h[a+(t+b+u<<3)>>3];c[j>>2]=(c[d>>2]|0)-t;kya(j,221496,a+(t-l+u<<3)|0,221512)|0;u=c[d>>2]|0;c[j>>2]=u;v=c[55376]|0;c[55368]=v;if((v|0)>(u|0)){break}else{w=v}do{v=c[55372]|0;x=fa(w,l)|0;h[27687]=+h[a+(x+b+v<<3)>>3];y=c[55370]|0;if((v|0)==(y|0)){z=v}else{A=a+(y+b+x<<3)|0;h[a+(v+b+x<<3)>>3]=+h[A>>3];h[A>>3]=+h[27687];z=y}c[k>>2]=(c[d>>2]|0)-z;y=z+1|0;A=221512;lya(k,221496,a+((fa(z,l)|0)+b+y<<3)|0,A,a+(y+b+x<<3)|0,A)|0;A=c[55368]|0;w=A+1|0;c[55368]=w;}while((A|0)<(u|0))}}while(0);q=c[55370]|0;m=q+1|0;c[55370]=m;}while((q|0)<(n|0));o=c[d>>2]|0}c[e+(o+ -1<<2)>>2]=o;o=c[d>>2]|0;if(!(+h[a+(o+b+(fa(o,l)|0)<<3)>>3]==0.0)){i=g;return 0}c[f>>2]=o;i=g;return 0}function jya(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0;e=i;f=c[a>>2]|0;if((f|0)<1){g=0;i=e;return g|0}if((f|0)==1){g=1;i=e;return g|0}if((c[d>>2]|0)!=1){c[55468]=1;j=+h[b>>3];if(!(j>=0.0)){k=-j}else{k=j}h[27735]=k;l=(c[d>>2]|0)+1|0;c[55468]=l;m=c[a>>2]|0;c[55466]=2;if((m|0)<2){g=1;i=e;return g|0}else{n=2;o=k;p=l;q=1}while(1){k=+h[b+(p+ -1<<3)>>3];l=!(k>=0.0);if(l){r=-k}else{r=k}if(!(r<=o)){if(l){s=-k}else{s=k}h[27735]=s;t=s;u=n}else{t=o;u=q}l=p+(c[d>>2]|0)|0;c[55468]=l;a=n+1|0;c[55466]=a;if((n|0)<(m|0)){n=a;o=t;p=l;q=u}else{g=u;break}}i=e;return g|0}t=+h[b>>3];if(!(t>=0.0)){v=-t}else{v=t}h[27735]=v;c[55466]=2;if((f|0)<2){g=1;i=e;return g|0}else{w=v;x=2;y=1}while(1){v=+h[b+(x+ -1<<3)>>3];if(!(v>=0.0)){z=-v}else{z=v}if(!(z<=w)){v=+h[b+(x+ -1<<3)>>3];if(!(v>=0.0)){A=-v}else{A=v}h[27735]=A;B=A;C=x}else{B=w;C=y}if((x|0)<(f|0)){w=B;x=x+1|0;y=C}else{break}}c[55466]=f+1;g=C;i=e;return g|0}function kya(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[a>>2]|0;if((g|0)<1){i=f;return 0}j=c[e>>2]|0;if((j|0)!=1){e=fa(j,g)|0;c[55452]=1;k=(j|0)<0;if(k?(e|0)<2:(e|0)>0){l=1}else{i=f;return 0}do{m=d+(l+ -1<<3)|0;h[m>>3]=+h[b>>3]*+h[m>>3];l=l+j|0;}while(k?(l|0)>=(e|0):(l|0)<=(e|0));c[55452]=l;i=f;return 0}l=(g|0)%5|0;c[55454]=l;do{if((l|0)==0){n=c[a>>2]|0}else{c[55452]=1;if((l|0)>=1){g=1;while(1){e=d+(g+ -1<<3)|0;h[e>>3]=+h[b>>3]*+h[e>>3];if((g|0)<(l|0)){g=g+1|0}else{break}}c[55452]=l+1}g=c[a>>2]|0;if((g|0)>=5){n=g;break}i=f;return 0}}while(0);a=l+1|0;c[55452]=a;if((l|0)<(n|0)){o=a}else{i=f;return 0}do{a=d+(o+ -1<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+1<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+2<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+3<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];o=o+5|0;}while((o|0)<=(n|0));c[55452]=o;i=f;return 0}function lya(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0.0,m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0;j=i;k=c[a>>2]|0;if((k|0)<1){i=j;return 0}l=+h[b>>3];if(l==0.0){i=j;return 0}do{if((c[e>>2]|0)==1){if((c[g>>2]|0)!=1){break}m=(k|0)%4|0;c[55438]=m;do{if((m|0)==0){n=c[a>>2]|0}else{c[55436]=1;if((m|0)>=1){o=l;p=1;q=0;while(1){r=f+(q<<3)|0;h[r>>3]=+h[r>>3]+o*+h[d+(q<<3)>>3];if((p|0)>=(m|0)){break}r=p;o=+h[b>>3];p=p+1|0;q=r}c[55436]=m+1}q=c[a>>2]|0;if((q|0)>=4){n=q;break}i=j;return 0}}while(0);q=m+1|0;c[55436]=q;if((m|0)<(n|0)){s=q}else{i=j;return 0}do{q=s+ -1|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];q=f+(s<<3)|0;h[q>>3]=+h[q>>3]+ +h[b>>3]*+h[d+(s<<3)>>3];q=s+1|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];q=s+2|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];s=s+4|0;}while((s|0)<=(n|0));c[55436]=s;i=j;return 0}}while(0);c[55440]=1;c[55442]=1;s=c[e>>2]|0;if((s|0)<0){n=(fa(1-(c[a>>2]|0)|0,s)|0)+1|0;c[55440]=n;t=n}else{t=1}n=c[g>>2]|0;if((n|0)<0){s=(fa(1-(c[a>>2]|0)|0,n)|0)+1|0;c[55442]=s;u=s}else{u=1}s=c[a>>2]|0;c[55436]=1;if((s|0)<1){i=j;return 0}else{v=l;w=1;x=u;y=t}while(1){t=f+(x+ -1<<3)|0;h[t>>3]=v*+h[d+(y+ -1<<3)>>3]+ +h[t>>3];t=y+(c[e>>2]|0)|0;c[55440]=t;u=x+(c[g>>2]|0)|0;c[55442]=u;a=w+1|0;c[55436]=a;if((w|0)>=(s|0)){break}v=+h[b>>3];y=t;x=u;w=a}i=j;return 0}function mya(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0;j=i;i=i+8|0;k=j;l=c[b>>2]|0;b=~l;m=c[d>>2]|0;n=m+ -1|0;c[55388]=n;if((c[g>>2]|0)==0){if((m|0)>=2){c[55380]=1;m=1;do{g=m+ -1|0;o=c[e+(g<<2)>>2]|0;c[55382]=o;p=f+(o+ -1<<3)|0;h[27692]=+h[p>>3];if((o|0)!=(m|0)){o=f+(g<<3)|0;h[p>>3]=+h[o>>3];h[o>>3]=+h[27692]}c[k>>2]=(c[d>>2]|0)-m;o=221512;lya(k,221536,a+(m-l+(fa(m,l)|0)<<3)|0,o,f+(m<<3)|0,o)|0;o=c[55380]|0;m=o+1|0;c[55380]=m;}while((o|0)<(n|0))}m=c[d>>2]|0;c[55386]=1;if((m|0)<1){i=j;return 0}else{q=1}do{o=1-q+(c[d>>2]|0)|0;c[55380]=o;p=fa(o,l)|0;g=o+ -1|0;r=f+(g<<3)|0;s=+h[r>>3]/+h[a+(o+b+p<<3)>>3];h[r>>3]=s;h[27692]=-s;c[k>>2]=g;g=221512;lya(k,221536,a+(p-l<<3)|0,g,f,g)|0;g=c[55386]|0;q=g+1|0;c[55386]=q;}while((g|0)<(m|0));i=j;return 0}m=c[d>>2]|0;c[55380]=1;if((m|0)<1){t=n}else{n=1;do{c[k>>2]=n+ -1;q=221512;s=+nya(k,a+((fa(n,l)|0)-l<<3)|0,q,f,q);h[27692]=s;q=c[55380]|0;g=f+(q+ -1<<3)|0;h[g>>3]=(+h[g>>3]-s)/+h[a+(q+b+(fa(q,l)|0)<<3)>>3];n=q+1|0;c[55380]=n;}while((q|0)<(m|0));t=c[55388]|0}if((t|0)<1){i=j;return 0}c[55386]=1;m=1;do{n=(c[d>>2]|0)-m|0;c[55380]=n;c[k>>2]=(c[d>>2]|0)-n;b=221512;s=+nya(k,a+(n-l+(fa(n,l)|0)<<3)|0,b,f+(n<<3)|0,b);b=c[55380]|0;n=b+ -1|0;q=f+(n<<3)|0;h[q>>3]=s+ +h[q>>3];g=c[e+(n<<2)>>2]|0;c[55382]=g;if((g|0)!=(b|0)){b=f+(g+ -1<<3)|0;h[27692]=+h[b>>3];h[b>>3]=+h[q>>3];h[q>>3]=+h[27692]}q=c[55386]|0;m=q+1|0;c[55386]=m;}while((q|0)<(t|0));i=j;return 0}function nya(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0;g=i;h[27732]=0.0;j=c[a>>2]|0;if((j|0)<1){k=0.0;i=g;return+k}do{if((c[d>>2]|0)==1){if((c[f>>2]|0)!=1){break}l=(j|0)%5|0;c[55458]=l;do{if((l|0)==0){m=c[a>>2]|0;n=0.0}else{c[55456]=1;if((l|0)<1){o=0.0}else{p=0.0;q=1;while(1){r=q+ -1|0;s=p+ +h[b+(r<<3)>>3]*+h[e+(r<<3)>>3];h[27732]=s;if((q|0)<(l|0)){q=q+1|0;p=s}else{break}}c[55456]=l+1;o=s}q=c[a>>2]|0;if((q|0)<5){k=o}else{m=q;n=o;break}i=g;return+k}}while(0);q=l+1|0;c[55456]=q;if((l|0)<(m|0)){t=n;u=q}else{k=n;i=g;return+k}do{q=u+ -1|0;r=u+1|0;v=u+2|0;w=u+3|0;t=t+ +h[b+(q<<3)>>3]*+h[e+(q<<3)>>3]+ +h[b+(u<<3)>>3]*+h[e+(u<<3)>>3]+ +h[b+(r<<3)>>3]*+h[e+(r<<3)>>3]+ +h[b+(v<<3)>>3]*+h[e+(v<<3)>>3]+ +h[b+(w<<3)>>3]*+h[e+(w<<3)>>3];h[27732]=t;u=u+5|0;}while((u|0)<=(m|0));c[55456]=u;k=t;i=g;return+k}}while(0);c[55460]=1;c[55462]=1;u=c[d>>2]|0;if((u|0)<0){m=(fa(1-(c[a>>2]|0)|0,u)|0)+1|0;c[55460]=m;x=m}else{x=1}m=c[f>>2]|0;if((m|0)<0){u=(fa(1-(c[a>>2]|0)|0,m)|0)+1|0;c[55462]=u;y=u}else{y=1}u=c[a>>2]|0;c[55456]=1;if((u|0)<1){k=0.0;i=g;return+k}else{z=1;A=0.0;B=y;C=x}while(1){t=A+ +h[b+(C+ -1<<3)>>3]*+h[e+(B+ -1<<3)>>3];h[27732]=t;x=C+(c[d>>2]|0)|0;c[55460]=x;y=B+(c[f>>2]|0)|0;c[55462]=y;a=z+1|0;c[55456]=a;if((z|0)<(u|0)){C=x;B=y;A=t;z=a}else{k=t;break}}i=g;return+k}function oya(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;k=i;i=i+8|0;l=k;m=c[b>>2]|0;b=~m;c[55398]=(c[e>>2]|0)+1+(c[f>>2]|0);c[j>>2]=0;n=(c[f>>2]|0)+2|0;c[55404]=n;o=c[d>>2]|0;p=c[55398]|0;q=(o|0)>(p|0)?p:o;o=q+ -1|0;c[55406]=o;do{if((q|0)>(n|0)){c[55414]=n;if((n|0)>(o|0)){break}else{r=n}while(1){s=1-r+p|0;c[55402]=s;t=c[e>>2]|0;c[55390]=s;if((s|0)<=(t|0)){u=s;while(1){h[a+(u+b+(fa(r,m)|0)<<3)>>3]=0.0;if((u|0)<(t|0)){u=u+1|0}else{break}}c[55390]=t+1}u=r+1|0;c[55414]=u;if((r|0)<(o|0)){r=u}else{break}}c[l>>2]=t}}while(0);c[55414]=o;c[55412]=0;t=c[d>>2]|0;r=t+ -1|0;if((t|0)<2){v=t}else{c[55394]=1;t=o;o=1;while(1){c[55416]=o+1;p=t+1|0;c[55414]=p;n=c[d>>2]|0;do{if((t|0)<(n|0)){q=c[e>>2]|0;if((q|0)<1){w=n;break}c[l>>2]=q;c[55390]=1;u=fa(p,m)|0;s=1;while(1){h[a+(s+b+u<<3)>>3]=0.0;if((s|0)<(q|0)){s=s+1|0}else{break}}c[55390]=q+1;w=c[d>>2]|0}else{w=n}}while(0);n=c[e>>2]|0;p=w-o|0;s=(n|0)<=(p|0)?n:p;c[55408]=s;c[l>>2]=s+1;s=jya(l,a+((c[55398]|0)+b+(fa(o,m)|0)<<3)|0,221512)|0;p=s+ -1|0;c[55396]=p+(c[55398]|0);s=c[55394]|0;c[g+(s+ -1<<2)>>2]=p+s;s=c[55396]|0;p=c[55394]|0;n=fa(p,m)|0;x=+h[a+(s+b+n<<3)>>3];a:do{if(x==0.0){c[j>>2]=p}else{u=c[55398]|0;if((s|0)==(u|0)){y=s}else{h[27700]=x;z=a+(u+b+n<<3)|0;h[a+(n+b+s<<3)>>3]=+h[z>>3];h[z>>3]=+h[27700];y=u}h[27700]=-1.0/+h[a+(y+b+n<<3)>>3];kya(221632,221600,a+(y-m+n<<3)|0,221512)|0;u=c[55412]|0;z=(c[g+((c[55394]|0)+ -1<<2)>>2]|0)+(c[f>>2]|0)|0;A=(u|0)>=(z|0)?u:z;c[l>>2]=A;z=c[d>>2]|0;u=(A|0)>(z|0)?z:A;c[55412]=u;A=c[55398]|0;c[55410]=A;z=c[55416]|0;if((u|0)<(z|0)){break}c[l>>2]=u;c[55392]=z;B=z;z=A;while(1){A=(c[55396]|0)+ -1|0;c[55396]=A;C=z+ -1|0;c[55410]=C;D=fa(B,m)|0;E=a+(A+b+D<<3)|0;h[27700]=+h[E>>3];if((A|0)==(C|0)){F=A}else{A=a+(C+b+D<<3)|0;h[E>>3]=+h[A>>3];h[A>>3]=+h[27700];F=C}C=221512;lya(221632,221600,a+((c[55398]|0)-m+(fa(c[55394]|0,m)|0)<<3)|0,C,a+(F-m+D<<3)|0,C)|0;C=c[55392]|0;D=C+1|0;c[55392]=D;if((C|0)>=(u|0)){break a}B=D;z=c[55410]|0}}}while(0);n=c[55394]|0;s=n+1|0;c[55394]=s;if((n|0)>=(r|0)){break}t=c[55414]|0;o=s}v=c[d>>2]|0}c[g+(v+ -1<<2)>>2]=v;v=c[d>>2]|0;if(!(+h[a+((c[55398]|0)+b+(fa(v,m)|0)<<3)>>3]==0.0)){i=k;return 0}c[j>>2]=v;i=k;return 0}function pya(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0;l=i;m=c[b>>2]|0;b=~m;n=(c[f>>2]|0)+1+(c[e>>2]|0)|0;c[55422]=n;f=c[d>>2]|0;o=f+ -1|0;c[55434]=o;if((c[k>>2]|0)==0){if(!((c[e>>2]|0)==0|(f|0)<2)){c[55418]=1;f=1;do{k=c[e>>2]|0;p=(c[d>>2]|0)-f|0;c[55432]=(k|0)<=(p|0)?k:p;p=f+ -1|0;k=c[g+(p<<2)>>2]|0;c[55420]=k;q=j+(k+ -1<<3)|0;h[27712]=+h[q>>3];if((k|0)!=(f|0)){k=j+(p<<3)|0;h[q>>3]=+h[k>>3];h[k>>3]=+h[27712]}k=221512;lya(221728,221696,a+((c[55422]|0)-m+(fa(f,m)|0)<<3)|0,k,j+(f<<3)|0,k)|0;k=c[55418]|0;f=k+1|0;c[55418]=f;}while((k|0)<(o|0))}f=c[d>>2]|0;c[55426]=1;if((f|0)<1){i=l;return 0}else{r=1}do{k=1-r+(c[d>>2]|0)|0;c[55418]=k;q=c[55422]|0;p=fa(k,m)|0;s=j+(k+ -1<<3)|0;t=+h[s>>3]/+h[a+(q+b+p<<3)>>3];h[s>>3]=t;s=((k|0)<=(q|0)?k:q)+ -1|0;c[55432]=s;u=q-s|0;c[55428]=u;q=k-s|0;c[55430]=q;h[27712]=-t;s=221512;lya(221728,221696,a+(u+b+p<<3)|0,s,j+(q+ -1<<3)|0,s)|0;s=c[55426]|0;r=s+1|0;c[55426]=r;}while((s|0)<(f|0));i=l;return 0}f=c[d>>2]|0;c[55418]=1;if((f|0)<1){v=n;w=o}else{o=n;n=1;do{r=((n|0)<=(o|0)?n:o)+ -1|0;c[55432]=r;s=o-r|0;c[55428]=s;q=n-r|0;c[55430]=q;r=221512;t=+nya(221728,a+((fa(n,m)|0)+b+s<<3)|0,r,j+(q+ -1<<3)|0,r);h[27712]=t;r=c[55418]|0;q=j+(r+ -1<<3)|0;o=c[55422]|0;h[q>>3]=(+h[q>>3]-t)/+h[a+((fa(r,m)|0)+b+o<<3)>>3];n=r+1|0;c[55418]=n;}while((r|0)<(f|0));v=o;w=c[55434]|0}if((c[e>>2]|0)==0|(w|0)<1){i=l;return 0}c[55426]=1;o=v;v=1;while(1){f=(c[d>>2]|0)-v|0;c[55418]=f;n=c[e>>2]|0;b=(c[d>>2]|0)-f|0;c[55432]=(n|0)<=(b|0)?n:b;b=221512;t=+nya(221728,a+(o-m+(fa(f,m)|0)<<3)|0,b,j+(f<<3)|0,b);b=c[55418]|0;f=b+ -1|0;n=j+(f<<3)|0;h[n>>3]=t+ +h[n>>3];r=c[g+(f<<2)>>2]|0;c[55420]=r;if((r|0)!=(b|0)){b=j+(r+ -1<<3)|0;h[27712]=+h[b>>3];h[b>>3]=+h[n>>3];h[n>>3]=+h[27712]}n=c[55426]|0;b=n+1|0;c[55426]=b;if((n|0)>=(w|0)){break}o=c[55422]|0;v=b}i=l;return 0}function qya(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;j=c[a>>2]|0;if((j|0)<1){i=g;return 0}do{if((c[d>>2]|0)==1){if((c[f>>2]|0)!=1){break}k=(j|0)%7|0;c[55446]=k;do{if((k|0)==0){l=c[a>>2]|0}else{c[55444]=1;if((k|0)>=1){m=1;while(1){n=m+ -1|0;h[e+(n<<3)>>3]=+h[b+(n<<3)>>3];if((m|0)<(k|0)){m=m+1|0}else{break}}c[55444]=k+1}m=c[a>>2]|0;if((m|0)>=7){l=m;break}i=g;return 0}}while(0);m=k+1|0;c[55444]=m;if((k|0)<(l|0)){o=m}else{i=g;return 0}do{m=o+ -1|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];h[e+(o<<3)>>3]=+h[b+(o<<3)>>3];m=o+1|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+2|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+3|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+4|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+5|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];o=o+7|0;}while((o|0)<=(l|0));c[55444]=o;i=g;return 0}}while(0);c[55448]=1;c[55450]=1;o=c[d>>2]|0;if((o|0)<0){l=(fa(1-(c[a>>2]|0)|0,o)|0)+1|0;c[55448]=l;p=l}else{p=1}l=c[f>>2]|0;if((l|0)<0){o=(fa(1-(c[a>>2]|0)|0,l)|0)+1|0;c[55450]=o;q=o}else{q=1}o=c[a>>2]|0;c[55444]=1;if((o|0)<1){i=g;return 0}else{r=1;s=q;t=p}while(1){h[e+(s+ -1<<3)>>3]=+h[b+(t+ -1<<3)>>3];p=t+(c[d>>2]|0)|0;c[55448]=p;q=s+(c[f>>2]|0)|0;c[55450]=q;a=r+1|0;c[55444]=a;if((r|0)<(o|0)){t=p;s=q;r=a}else{break}}i=g;return 0}function rya(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0;d=i;m=+sya(221888);n=c[a>>2]|0;o=(n|0)<1;do{if(!o){p=((fa(n+1|0,n)|0)/2|0)+1|0;q=1;while(1){r=n-q|0;s=r+1|0;t=r+2|0;u=p-q|0;if((n|0)<(t|0)){v=0.0}else{w=t;t=u;x=0.0;while(1){y=x+ +h[b+(t<<3)>>3]*+h[j+(w+ -1<<3)>>3];if((w|0)<(n|0)){x=y;t=t+1|0;w=w+1|0}else{v=y;break}}}x=+h[b+(u+ -1<<3)>>3];do{if(x!=0.0){z=x}else{if((r|0)<0){A=x}else{w=1;t=s;y=x;while(1){B=+h[b+(t+ -1<<3)>>3];if(!(B>=0.0)){C=-B}else{C=B}B=y>=C?y:C;D=t-w+n|0;if((w|0)<(s|0)){w=w+1|0;t=D;y=B}else{A=B;break}}}y=m*A;if(!(y==0.0)){z=y;break}z=m}}while(0);h[j+(r<<3)>>3]=(+h[f+(r<<3)>>3]-v)/z;if((q|0)<(n|0)){q=q+1|0;p=u}else{break}}if(o){break}else{E=1}while(1){p=E+ -1|0;h[k+(p<<3)>>3]=0.0;h[l+(p<<3)>>3]=+h[e+(p<<3)>>3]*+h[j+(p<<3)>>3];if((E|0)<(n|0)){E=E+1|0}else{break}}}}while(0);z=+tya(a,l);if(z<=+h[g>>3]){i=d;return 0}E=c[a>>2]|0;if((E|0)>=1){n=E;o=1;p=1;while(1){q=o+ -1|0;v=+h[f+(q<<3)>>3];if((o|0)>(E|0)){F=p}else{s=o;t=p;while(1){w=k+(s+ -1<<3)|0;h[w>>3]=+h[w>>3]+v*+h[b+(t+ -1<<3)>>3];if((s|0)<(E|0)){t=t+1|0;s=s+1|0}else{break}}F=p+n|0}s=k+(q<<3)|0;h[s>>3]=+h[s>>3]/+h[e+(q<<3)>>3];if((o|0)<(E|0)){n=n+ -1|0;o=o+1|0;p=F}else{break}}}v=+tya(a,k);m=+h[g>>3];do{if(v==0.0){G=m;H=m/z;I=0.0}else{F=c[a>>2]|0;p=(F|0)<1;do{if(!p){o=1;while(1){n=o+ -1|0;E=k+(n<<3)|0;h[E>>3]=+h[E>>3]/v/+h[e+(n<<3)>>3];if((o|0)<(F|0)){o=o+1|0}else{break}}if(p){break}else{J=F;K=1;L=1}while(1){if((K|0)>(F|0)){M=L;N=0.0}else{o=K;u=L;A=0.0;while(1){O=A+ +h[b+(u+ -1<<3)>>3]*+h[k+(o+ -1<<3)>>3];if((o|0)<(F|0)){A=O;u=u+1|0;o=o+1|0}else{break}}M=L+J|0;N=O}h[l+(K+ -1<<3)>>3]=N;if((K|0)<(F|0)){J=J+ -1|0;K=K+1|0;L=M}else{break}}}}while(0);A=+tya(a,l);C=v/A/A;A=+h[g>>3];if(C>=A){G=A;H=0.0;I=C;break}A=+tya(a,f);x=+h[g>>3];y=C/x;B=A/v*(A/z)*y;A=x/z;P=B-A;Q=y*y;y=1.0-Q;G=x;H=A*y/(+V(+(P*P+y*(1.0-A*A)))+(B-A*Q));I=C}}while(0);z=(1.0-H)*(!(I<=G)?G:I);g=c[a>>2]|0;if((g|0)<1){i=d;return 0}else{R=1}while(1){a=R+ -1|0;f=j+(a<<3)|0;h[f>>3]=z*+h[k+(a<<3)>>3]+H*+h[f>>3];if((R|0)<(g|0)){R=R+1|0}else{break}}i=d;return 0}function sya(a){a=a|0;i=i;return+(+h[221896+((((c[a>>2]<<3)+ -8|0)/8|0)<<3)>>3])}function tya(a,b){a=a|0;b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0;d=i;e=c[a>>2]|0;f=1304.0e16/+(e|0);do{if((e|0)<1){g=0.0;j=0.0}else{a=1;k=0.0;l=0.0;m=0.0;n=0.0;o=0.0;while(1){p=+h[b+(a+ -1<<3)>>3];if(!(p>=0.0)){q=-p}else{q=p}do{if(q>3.834e-20&q<f){r=k;s=l+q*q;t=m;u=n;v=o}else{if(!(q<=3.834e-20)){if(!(q<=n)){p=n/q;r=k*p*p+1.0;s=l;t=m;u=q;v=o;break}else{p=q/n;r=k+p*p;s=l;t=m;u=n;v=o;break}}if(!(q<=o)){p=o/q;r=k;s=l;t=m*p*p+1.0;u=n;v=q;break}if(!(q!=0.0)){r=k;s=l;t=m;u=n;v=o;break}p=q/o;r=k;s=l;t=m+p*p;u=n;v=o}}while(0);if((a|0)<(e|0)){a=a+1|0;k=r;l=s;m=t;n=u;o=v}else{break}}if(!(r==0.0)){w=u*+V(+(r+s/u/u));i=d;return+w}if(s==0.0){g=t;j=v;break}if(!(s>=v)){x=0.0}else{x=+V(+(s*(t*v*(v/s)+1.0)))}if(!(s<v)){w=x;i=d;return+w}w=+V(+(v*(t*v+s/v)));i=d;return+w}}while(0);w=j*+V(+g);i=d;return+w}function uya(a,b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;var B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,ga=0,ha=0,ia=0.0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0.0,wa=0,xa=0.0,ya=0,za=0.0,Aa=0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0.0,Ka=0.0,La=0,Ma=0.0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0.0;B=i;i=i+32|0;C=B;D=B+8|0;E=B+16|0;F=B+24|0;G=c[g>>2]|0;H=~G;I=+sya(221928);c[p>>2]=0;c[E>>2]=0;c[q>>2]=0;c[r>>2]=0;K=c[b>>2]|0;a:do{if((K|0)<1){L=97}else{if((c[g>>2]|0)<(K|0)){L=97;break}if(+h[j>>3]<0.0){L=97;break}if((c[k>>2]|0)<1){L=97;break}if(+h[n>>3]<=0.0){L=97;break}if((c[t>>2]|0)<((fa(K+1|0,K)|0)/2|0|0)){L=97;break}if((c[m>>2]|0)==2){M=1;while(1){if(+h[l+(M+ -1<<3)>>3]<=0.0){L=97;break a}if((M|0)<(K|0)){M=M+1|0}else{break}}}c[E>>2]=1;M=a;Me[M&15](b,d,e,f,g,E,z,A)|0;c[q>>2]=1;N=c[E>>2]|0;if((N|0)<0){O=N;L=98;break}P=+tya(b,e);c[E>>2]=2;Me[M&15](b,d,e,f,g,E,z,A)|0;c[r>>2]=(c[r>>2]|0)+1;N=c[E>>2]|0;if((N|0)<0){O=N;L=98;break}N=C;Q=P;R=1;S=0;T=0;U=0;V=0;P=0.0;b:while(1){Cya(b,b,f,g,221936,N,221928,v,w,x)|0;do{if((R|0)==1){W=c[b>>2]|0;do{if((c[m>>2]|0)==2){L=20}else{if((W|0)<1){break}else{X=1}while(1){Y=X+ -1|0;Z=w+(Y<<3)|0;_=l+(Y<<3)|0;h[_>>3]=+h[Z>>3];if(+h[Z>>3]==0.0){h[_>>3]=1.0}if((X|0)<(W|0)){X=X+1|0}else{L=20;break}}}}while(0);do{if((L|0)==20){L=0;if((W|0)<1){break}else{$=1}while(1){_=$+ -1|0;h[x+(_<<3)>>3]=+h[l+(_<<3)>>3]*+h[d+(_<<3)>>3];if(($|0)<(W|0)){$=$+1|0}else{break}}}}while(0);aa=+tya(b,x);ba=+h[n>>3];ca=aa*ba;h[F>>3]=ca;if(!(ca==0.0)){da=aa;break}h[F>>3]=ba;da=aa}else{da=P}}while(0);W=c[b>>2]|0;_=(W|0)<1;do{if(_){L=35}else{Z=1;while(1){Y=Z+ -1|0;h[u+(Y<<3)>>3]=+h[e+(Y<<3)>>3];if((Z|0)<(W|0)){Z=Z+1|0}else{break}}if(_){L=35;break}else{ea=1}while(1){Z=fa(ea,G)|0;aa=+h[f+(ea+H+Z<<3)>>3];do{if(!(aa==0.0)){Y=(ea|0)>(W|0);if(Y){break}ga=Z+H|0;ha=ea;ba=0.0;while(1){ia=ba+ +h[f+(ga+ha<<3)>>3]*+h[u+(ha+ -1<<3)>>3];if((ha|0)<(W|0)){ba=ia;ha=ha+1|0}else{break}}ba=-ia/aa;if(Y){break}ha=Z+H|0;ga=ea;while(1){ja=u+(ga+ -1<<3)|0;h[ja>>3]=+h[ja>>3]+ba*+h[f+(ha+ga<<3)>>3];if((ga|0)<(W|0)){ga=ga+1|0}else{break}}}}while(0);if((ea|0)<(W|0)){ea=ea+1|0}else{break}}c[D>>2]=0;if(_){break}else{ka=0;la=1}while(1){Z=(ka|0)>1?ka:1;ga=Z+ -1|0;ha=Q$a(ga|0,0,Z+ -2|0,0)|0;Z=J$a(ha|0,J&1|0,1)|0;ha=la+ -1|0;if((la|0)<2){ma=la}else{Y=(fa(la,G)|0)+H|0;ja=W+ka+(fa(ga,W+ -2|0)|0)|0;ga=1;na=la;while(1){h[s+(na+ -1<<3)>>3]=+h[f+(Y+ga<<3)>>3];if((ga|0)<(ha|0)){na=na-ga+W|0;ga=ga+1|0}else{break}}ma=ja-Z|0}ga=v+(ha<<3)|0;h[s+(ma+ -1<<3)>>3]=+h[ga>>3];if(+h[ga>>3]==0.0){c[D>>2]=1}if((la|0)<(W|0)){ka=ka+1|0;la=la+1|0}else{break}}}}while(0);if((L|0)==35){L=0;c[D>>2]=0}Bya(b,b,f,g,v)|0;do{if((c[m>>2]|0)==2){oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da}else{W=c[b>>2]|0;if((W|0)<1){oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da;break}else{wa=1}while(1){_=wa+ -1|0;ga=l+(_<<3)|0;aa=+h[ga>>3];ba=+h[w+(_<<3)>>3];h[ga>>3]=aa>=ba?aa:ba;if((wa|0)<(W|0)){wa=wa+1|0}else{oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da;break}}}}while(0);while(1){W=c[o>>2]|0;do{if((W|0)>=1){c[E>>2]=0;if(((pa+ -1|0)%(W|0)|0|0)!=0){break}Me[M&15](b,d,e,f,g,E,z,A)|0;ga=c[E>>2]|0;if((ga|0)<0){O=ga;L=98;break a}}}while(0);rya(b,s,t,l,u,F,v,w,x)|0;W=c[b>>2]|0;if((W|0)>=1){ga=1;while(1){_=ga+ -1|0;na=v+(_<<3)|0;ba=+h[na>>3];h[na>>3]=-ba;h[w+(_<<3)>>3]=+h[d+(_<<3)>>3]-ba;h[x+(_<<3)>>3]=+h[l+(_<<3)>>3]*+h[na>>3];if((ga|0)<(W|0)){ga=ga+1|0}else{break}}}ba=+tya(b,x);if((pa|0)==1){aa=+h[F>>3];h[F>>3]=aa<=ba?aa:ba}c[E>>2]=1;Me[M&15](b,w,y,f,g,E,z,A)|0;c[q>>2]=(c[q>>2]|0)+1;ga=c[E>>2]|0;if((ga|0)<0){O=ga;L=98;break a}aa=+tya(b,y);if(aa<oa){ca=aa/oa;xa=1.0-ca*ca}else{xa=-1.0}ga=c[b>>2]|0;if((ga|0)>=1){W=1;na=ga;_=1;while(1){if((W|0)>(ga|0)){ya=_;za=0.0}else{Y=W;Aa=_;ca=0.0;while(1){Ba=ca+ +h[s+(Aa+ -1<<3)>>3]*+h[v+(Y+ -1<<3)>>3];if((Y|0)<(ga|0)){ca=Ba;Aa=Aa+1|0;Y=Y+1|0}else{break}}ya=_+na|0;za=Ba}Y=W+ -1|0;h[x+(Y<<3)>>3]=za+ +h[u+(Y<<3)>>3];if((W|0)<(ga|0)){W=W+1|0;na=na+ -1|0;_=ya}else{break}}}ca=+tya(b,x);do{if(ca<oa){Ca=ca/oa;Da=1.0-Ca*Ca;if(!(Da>0.0)){Ea=0.0;L=65;break}Ca=xa/Da;if(!(Ca>=.1)){Ea=Ca;L=65;break}_=sa+1|0;if(Ca>=.5|(sa|0)>0){Da=+h[F>>3];Fa=ba*2.0;h[F>>3]=Da>=Fa?Da:Fa}Fa=Ca+-1.0;if(!(Fa>=0.0)){Ga=-Fa}else{Ga=Fa}if(!(Ga<=.1)){Ha=0;Ia=_;Ja=Ca;break}h[F>>3]=ba*2.0;Ha=0;Ia=_;Ja=Ca}else{Ea=0.0;L=65}}while(0);if((L|0)==65){L=0;h[F>>3]=+h[F>>3]*.5;Ha=ra+1|0;Ia=0;Ja=Ea}if(Ja<1.0e-4){Ka=oa;La=pa;Ma=va}else{_=c[b>>2]|0;if((_|0)>=1){na=1;while(1){W=na+ -1|0;ga=w+(W<<3)|0;ca=+h[ga>>3];h[d+(W<<3)>>3]=ca;h[ga>>3]=ca*+h[l+(W<<3)>>3];h[e+(W<<3)>>3]=+h[y+(W<<3)>>3];if((na|0)<(_|0)){na=na+1|0}else{break}}}Ka=aa;La=pa+1|0;Ma=+tya(b,w)}Na=!(xa>=.001)?ta+1|0:0;Oa=!(xa>=.1)?ua+qa|0:0;ca=+h[F>>3];if(ca<=Ma*+h[j>>3]|Ka==0.0){L=77;break b}if((c[p>>2]|0)!=0){L=97;break a}if((c[q>>2]|0)<(c[k>>2]|0)){Pa=0}else{c[p>>2]=2;Pa=2}Ca=ca*.1;if(!((Ca>=ba?Ca:ba)*.1<=I*Ma)){Qa=Pa}else{c[p>>2]=3;Qa=3}if((Oa|0)==5){c[p>>2]=4;Ra=4}else{Ra=Qa}if((Na|0)==10){L=86;break b}if((Ra|0)!=0){L=97;break a}if((Ha|0)==2){break}na=c[b>>2]|0;if((na|0)>=1){_=!(Ja>=1.0e-4);W=1;while(1){ga=(fa(W,G)|0)+H|0;Y=1;Ca=0.0;while(1){Sa=Ca+ +h[f+(ga+Y<<3)>>3]*+h[y+(Y+ -1<<3)>>3];if((Y|0)<(na|0)){Ca=Sa;Y=Y+1|0}else{break}}Y=W+ -1|0;h[w+(Y<<3)>>3]=(Sa- +h[x+(Y<<3)>>3])/ba;Ca=+h[l+(Y<<3)>>3];ga=v+(Y<<3)|0;h[ga>>3]=Ca*(Ca*+h[ga>>3]/ba);if(!_){h[u+(Y<<3)>>3]=Sa}if((W|0)<(na|0)){W=W+1|0}else{break}}}Eya(b,b,s,t,v,w,x,D)|0;Dya(b,b,f,g,w,x)|0;W=221928;Dya(W,b,u,W,w,x)|0;oa=Ka;pa=La;qa=0;ra=Ha;sa=Ia;ta=Na;ua=Oa;va=Ma}c[E>>2]=2;Me[M&15](b,d,e,f,g,E,z,A)|0;c[r>>2]=(c[r>>2]|0)+1;W=c[E>>2]|0;if((W|0)<0){O=W;L=98;break a}else{Q=Ka;R=La;S=2;T=Ia;U=Na;V=Oa;P=Ma}}if((L|0)==77){c[p>>2]=1;L=97;break}else if((L|0)==86){c[p>>2]=5;L=97;break}}}while(0);if((L|0)==97){Oa=c[E>>2]|0;if((Oa|0)<0){O=Oa;L=98}}if((L|0)==98){c[p>>2]=O}c[E>>2]=0;if((c[o>>2]|0)<=0){i=B;return 0}Me[a&15](b,d,e,f,g,E,z,A)|0;i=B;return 0}function vya(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;g=i;if((a[b]|0)==(a[e]|0)){h=1;i=g;return h|0}a[221960]=1;f=d[b]|0;c[55486]=f;b=d[e]|0;c[55488]=b;if((f+ -97|0)>>>0<26){e=f+ -32|0;c[55486]=e;j=e}else{j=f}if((b+ -97|0)>>>0<26){f=b+ -32|0;c[55488]=f;k=f}else{k=b}h=(j|0)==(k|0)|0;i=g;return h|0}function wya(b,d,e,f,g,j,k,l,m,n,o,p,q){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0.0,X=0.0,Y=0.0,Z=0,_=0.0,$=0.0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0,ha=0.0,ia=0,ja=0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0,ya=0.0,za=0,Aa=0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0.0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0;r=i;if((c[j>>2]|0)>0){c[231492>>2]=6;yPa(231488)|0;POa(232232,j,4)|0;gPa()|0}c[q>>2]=0;s=(c[e>>2]|0)<1?3:0;c[q>>2]=s;t=(c[l>>2]|0)<1?4:s;c[q>>2]=t;if((t|0)!=0){i=r;return 0}c[57174]=0;c[57780]=0;c[57768]=0;a[231096]=0;t=c[e>>2]|0;c[56728]=1;do{if((t|0)>=1){s=0;u=1;while(1){if(+h[d+(u+ -1<<3)>>3]!=0.0){v=s+1|0;c[57174]=v;w=v}else{w=s}if((u|0)<(t|0)){s=w;u=u+1|0}else{break}}c[56728]=t+1;if((w|0)<=0){break}u=p;s=f;a:while(1){v=c[e>>2]|0;c[56728]=1;if((v|0)>=1){x=1;while(1){h[223384+((x*21|0)+ -21<<3)>>3]=+h[b+(x+ -1<<3)>>3];if((x|0)<(v|0)){x=x+1|0}else{break}}c[56728]=v+1}c[57772]=2;x=c[e>>2]|0;c[56728]=1;if((x|0)>=1){y=2;z=1;while(1){A=z+ -1|0;B=d+(A<<3)|0;C=+h[B>>3];if(C==0.0){D=y}else{E=c[e>>2]|0;c[56730]=1;if((E|0)<1){F=C}else{G=1;while(1){h[223384+((G*21|0)+ -22+y<<3)>>3]=+h[b+(G+ -1<<3)>>3];if((G|0)<(E|0)){G=G+1|0}else{break}}c[56730]=E+1;F=+h[B>>3]}h[223384+((z*21|0)+ -22+y<<3)>>3]=+h[b+(A<<3)>>3]+F;G=y+1|0;c[57772]=G;D=G}G=z+1|0;c[56728]=G;if((z|0)<(x|0)){y=D;z=G}else{break}}}z=c[57174]|0;y=z+1|0;c[57170]=y;c[56728]=1;if((z|0)>=0){z=1;do{x=c[e>>2]|0;c[56730]=1;if((x|0)>=1){v=1;while(1){h[b+(v+ -1<<3)>>3]=+h[223384+((v*21|0)+ -22+z<<3)>>3];if((v|0)<(x|0)){v=v+1|0}else{break}}c[56730]=x+1}re[u&63](e,b,226744+(z+ -1<<3)|0)|0;c[57780]=(c[57780]|0)+1;if((c[j>>2]|0)>=1){c[231516>>2]=6;yPa(231512)|0;POa(232232,231120,4)|0;POa(232232,226744+((c[56728]|0)+ -1<<3)|0,8)|0;v=c[e>>2]|0;c[56730]=1;if((v|0)>=1){A=1;do{POa(232232,b+(A+ -1<<3)|0,8)|0;B=c[56730]|0;A=B+1|0;c[56730]=A;}while((B|0)<(v|0))}gPa()|0}v=c[56728]|0;z=v+1|0;c[56728]=z;}while((v|0)<(y|0))}y=c[57768]|0;b:while(1){c[57768]=y+1;c[57680]=1;c[57676]=1;C=+h[28343];h[28839]=C;h[28841]=C;z=c[57170]|0;c[56728]=2;if((z|0)<2){H=1}else{I=C;K=C;v=1;A=2;while(1){C=+h[226744+(A+ -1<<3)>>3];do{if(!(C<=K)){c[57680]=A;L=+h[226744+(A+ -1<<3)>>3];h[28839]=L;M=I;N=L;O=A}else{if(C>=I){M=I;N=K;O=v;break}c[57676]=A;L=+h[226744+(A+ -1<<3)>>3];h[28841]=L;M=L;N=K;O=v}}while(0);if((A|0)<(z|0)){I=M;K=N;v=O;A=A+1|0}else{break}}c[56728]=z+1;H=O}A=c[e>>2]|0;c[56728]=1;if((A|0)>=1){v=1;while(1){h[228864+(v+ -1<<3)>>3]=0.0;if((v|0)<(A|0)){v=v+1|0}else{break}}c[56728]=A+1}c[56728]=1;if((z|0)>=1){v=1;do{do{if((v|0)==(H|0)){P=H}else{x=c[e>>2]|0;c[56730]=1;if((x|0)<1){P=v;break}else{Q=1}while(1){B=228864+(Q+ -1<<3)|0;h[B>>3]=+h[223384+((Q*21|0)+ -22+v<<3)>>3]+ +h[B>>3];if((Q|0)<(x|0)){Q=Q+1|0}else{break}}c[56730]=x+1;P=v}}while(0);v=P+1|0;c[56728]=v;}while((P|0)<(z|0))}z=c[e>>2]|0;c[56730]=1;if((z|0)>=1){K=+(c[57174]|0);v=1;while(1){A=228864+(v+ -1<<3)|0;h[A>>3]=+h[A>>3]/K;if((v|0)<(z|0)){v=v+1|0}else{break}}c[56730]=z+1}v=c[e>>2]|0;c[56728]=1;if((v|0)>=1){A=1;while(1){B=A+ -1|0;K=+h[228864+(B<<3)>>3];h[231144+(B<<3)>>3]=K+(K- +h[223384+((A*21|0)+ -22+H<<3)>>3]);if((A|0)<(v|0)){A=A+1|0}else{break}}c[56728]=v+1}re[u&63](e,231144,231136)|0;A=(c[57780]|0)+1|0;c[57780]=A;z=c[j>>2]|0;do{if((z|0)>=1){if(((A|0)%(z|0)|0|0)!=0){break}c[231540>>2]=6;yPa(231536)|0;POa(232232,231120,4)|0;POa(232232,231136,8)|0;B=c[e>>2]|0;c[56730]=1;if((B|0)>=1){E=1;do{POa(232232,231144+(E+ -1<<3)|0,8)|0;G=c[56730]|0;E=G+1|0;c[56730]=E;}while((G|0)<(B|0))}gPa()|0}}while(0);K=+h[28892];c:do{if(!(K>=+h[28841])){z=c[e>>2]|0;c[56728]=1;if((z|0)>=1){A=1;while(1){v=A+ -1|0;I=+h[228864+(v<<3)>>3];h[231312+(v<<3)>>3]=I+(+h[231144+(v<<3)>>3]-I)*2.0;if((A|0)<(z|0)){A=A+1|0}else{break}}c[56728]=z+1}re[u&63](e,231312,231304)|0;A=(c[57780]|0)+1|0;c[57780]=A;v=c[j>>2]|0;do{if((v|0)>=1){if(((A|0)%(v|0)|0|0)!=0){break}c[231564>>2]=6;yPa(231560)|0;POa(232232,231120,4)|0;POa(232232,231304,8)|0;B=c[e>>2]|0;c[56730]=1;if((B|0)>=1){E=1;do{POa(232232,231312+(E+ -1<<3)|0,8)|0;G=c[56730]|0;E=G+1|0;c[56730]=E;}while((G|0)<(B|0))}gPa()|0}}while(0);I=+h[28913];if(I>=+h[28841]){R=118;break}v=c[e>>2]|0;c[56728]=1;A=c[57680]|0;if((v|0)>=1){z=1;while(1){B=z+ -1|0;if(+h[d+(B<<3)>>3]!=0.0){h[223384+((z*21|0)+ -22+A<<3)>>3]=+h[231312+(B<<3)>>3]}if((z|0)<(v|0)){z=z+1|0}else{break}}c[56728]=v+1}h[226744+(A+ -1<<3)>>3]=I}else{z=c[57170]|0;c[56728]=1;if((z|0)>=1){B=c[57680]|0;E=1;while(1){if((E|0)!=(B|0)){if(K<+h[226744+(E+ -1<<3)>>3]){R=118;break c}}x=E+1|0;c[56728]=x;if((E|0)<(z|0)){E=x}else{break}}}if(!(K>+h[28839])){E=c[e>>2]|0;c[56728]=1;z=c[57680]|0;if((E|0)>=1){B=1;while(1){A=B+ -1|0;if(+h[d+(A<<3)>>3]!=0.0){h[223384+((B*21|0)+ -22+z<<3)>>3]=+h[231144+(A<<3)>>3]}if((B|0)<(E|0)){B=B+1|0}else{break}}c[56728]=E+1}h[28839]=K;h[226744+(z+ -1<<3)>>3]=K}B=c[e>>2]|0;c[56728]=1;if((B|0)>=1){A=c[57680]|0;v=1;while(1){x=v+ -1|0;h[231312+(x<<3)>>3]=+h[223384+((v*21|0)+ -22+A<<3)>>3]*.5+ +h[228864+(x<<3)>>3]*.5;if((v|0)<(B|0)){v=v+1|0}else{break}}c[56728]=B+1}re[u&63](e,231312,231304)|0;v=(c[57780]|0)+1|0;c[57780]=v;A=c[j>>2]|0;do{if((A|0)>=1){if(((v|0)%(A|0)|0|0)!=0){break}c[231588>>2]=6;yPa(231584)|0;POa(232232,231120,4)|0;POa(232232,231304,8)|0;z=c[e>>2]|0;c[56730]=1;if((z|0)>=1){E=1;do{POa(232232,231312+(E+ -1<<3)|0,8)|0;x=c[56730]|0;E=x+1|0;c[56730]=E;}while((x|0)<(z|0))}gPa()|0}}while(0);I=+h[28913];if(!(I>+h[28839])){A=c[e>>2]|0;c[56728]=1;v=c[57680]|0;if((A|0)>=1){B=1;while(1){z=B+ -1|0;if(+h[d+(z<<3)>>3]!=0.0){h[223384+((B*21|0)+ -22+v<<3)>>3]=+h[231312+(z<<3)>>3]}if((B|0)<(A|0)){B=B+1|0}else{break}}c[56728]=A+1}h[226744+(v+ -1<<3)>>3]=I;break}B=c[57170]|0;c[56728]=1;if((B|0)<1){break}else{S=1}do{z=c[57676]|0;do{if((S|0)!=(z|0)){E=c[e>>2]|0;c[56730]=1;if((E|0)>=1){x=S+ -22|0;G=1;while(1){if(+h[d+(G+ -1<<3)>>3]!=0.0){T=(G*21|0)+ -22|0;U=223384+(T+S<<3)|0;h[U>>3]=(+h[U>>3]+ +h[223384+(T+z<<3)>>3])*.5}h[b+(G+ -1<<3)>>3]=+h[223384+(x+(G*21|0)<<3)>>3];if((G|0)<(E|0)){G=G+1|0}else{break}}c[56730]=E+1}re[u&63](e,b,226744+(S+ -1<<3)|0)|0;G=(c[57780]|0)+1|0;c[57780]=G;x=c[j>>2]|0;if((x|0)<1){break}if(((G|0)%(x|0)|0|0)!=0){break}c[231612>>2]=6;yPa(231608)|0;POa(232232,231120,4)|0;POa(232232,226744+((c[56728]|0)+ -1<<3)|0,8)|0;x=c[e>>2]|0;c[56730]=1;if((x|0)>=1){G=1;do{POa(232232,b+(G+ -1<<3)|0,8)|0;T=c[56730]|0;G=T+1|0;c[56730]=G;}while((T|0)<(x|0))}gPa()|0}}while(0);z=c[56728]|0;S=z+1|0;c[56728]=S;}while((z|0)<(B|0))}}while(0);if((R|0)==118){R=0;B=c[e>>2]|0;c[56728]=1;v=c[57680]|0;if((B|0)>=1){A=1;while(1){z=A+ -1|0;if(+h[d+(z<<3)>>3]!=0.0){h[223384+((A*21|0)+ -22+v<<3)>>3]=+h[231144+(z<<3)>>3]}if((A|0)<(B|0)){A=A+1|0}else{break}}c[56728]=B+1}h[226744+(v+ -1<<3)>>3]=+h[28892]}A=c[57768]|0;if((A|0)<(c[l>>2]|0)){y=A;continue}h[28842]=0.0;h[28888]=0.0;A=c[57170]|0;c[56728]=1;z=(A|0)<1;do{if(z){K=+(A|0);h[28888]=0.0/K;c[56728]=1;W=K;X=0.0}else{x=1;K=0.0;while(1){Y=+h[226744+(x+ -1<<3)>>3]+K;if((x|0)<(A|0)){K=Y;x=x+1|0}else{break}}K=+(A|0);I=Y/K;h[28888]=I;c[56728]=1;if(z){W=K;X=0.0;break}else{Z=1;_=0.0}while(1){C=+h[226744+(Z+ -1<<3)>>3]-I;$=_+C*C;if((Z|0)<(A|0)){_=$;Z=Z+1|0}else{break}}h[28842]=$;c[56728]=A+1;W=K;X=$}}while(0);I=+V(+(X/W));h[28842]=I;do{if(!(I<=+h[k>>3])){if((c[57780]|0)>(c[g>>2]|0)){break}a[231096]=0;c[57768]=0;y=0;continue b}}while(0);v=c[e>>2]|0;c[56728]=1;if((v|0)>=1){B=1;while(1){x=B+ -1|0;if(!(+h[d+(x<<3)>>3]==0.0)){h[b+(x<<3)>>3]=0.0;c[56730]=1;if(z){aa=b+(B+ -1<<3)|0}else{x=B*21|0;G=b+(B+ -1<<3)|0;I=+h[G>>3];E=1;while(1){C=+h[223384+(E+ -22+x<<3)>>3]+I;h[G>>3]=C;if((E|0)<(A|0)){E=E+1|0;I=C}else{break}}c[56730]=A+1;aa=G}h[aa>>3]=+h[aa>>3]/W}if((B|0)<(v|0)){B=B+1|0}else{break}}c[56728]=v+1}re[u&63](e,b,f)|0;B=(c[57780]|0)+1|0;c[57780]=B;A=c[j>>2]|0;do{if((A|0)<1){ba=B}else{if(((B|0)%(A|0)|0|0)!=0){ba=B;break}c[231636>>2]=6;yPa(231632)|0;POa(232232,231120,4)|0;POa(232232,s,8)|0;z=c[e>>2]|0;c[56730]=1;if((z|0)>=1){E=1;do{POa(232232,b+(E+ -1<<3)|0,8)|0;x=c[56730]|0;E=x+1|0;c[56730]=E;}while((x|0)<(z|0))}gPa()|0;ba=c[57780]|0}}while(0);if((ba|0)>(c[g>>2]|0)){R=150;break a}if((c[j>>2]|0)>=0){c[231756>>2]=6;yPa(231752)|0;gPa()|0;c[231780>>2]=6;yPa(231776)|0;B=c[e>>2]|0;c[56728]=1;if((B|0)>=1){A=1;do{POa(232232,b+(A+ -1<<3)|0,8)|0;v=c[56728]|0;A=v+1|0;c[56728]=A;}while((v|0)<(B|0))}gPa()|0;c[231804>>2]=6;yPa(231800)|0;POa(232232,s,8)|0;gPa()|0}if(a[231096]&1){I=+h[28888];K=+h[28934]-I;if(!(K>=0.0)){ca=-K}else{ca=K}if(!(ca>=+h[k>>3])){break}else{da=I}}else{a[231096]=1;da=+h[28888]}h[28934]=da;c[57768]=0;y=0}if((c[j>>2]|0)>=0){c[231828>>2]=6;yPa(231824)|0;POa(232232,231120,4)|0;gPa()|0;c[231852>>2]=6;yPa(231848)|0;y=c[e>>2]|0;c[56728]=1;if((y|0)>=1){B=1;do{POa(232232,b+(B+ -1<<3)|0,8)|0;A=c[56728]|0;B=A+1|0;c[56728]=B;}while((A|0)<(y|0))}gPa()|0;c[231876>>2]=6;yPa(231872)|0;POa(232232,s,8)|0;gPa()|0}if((c[m>>2]|0)<1){R=312;break}if((c[j>>2]|0)>-1){c[231900>>2]=6;yPa(231896)|0;gPa()|0}h[28841]=+h[f>>3];c[57782]=0;y=c[57170]|0;c[56728]=1;if((y|0)>=1){B=1;while(1){A=226744+(B+ -1<<3)|0;I=+h[A>>3]- +h[f>>3];if(!(I>=0.0)){ea=-I}else{ea=I}if(ea>=+h[n>>3]){v=B+1|0;c[56728]=v;if((B|0)<(y|0)){B=v;continue}else{break}}v=c[e>>2]|0;c[56730]=1;if((v|0)>=1){z=B+ -22|0;E=1;while(1){G=E+ -1|0;if(+h[d+(G<<3)>>3]!=0.0){x=223384+((E*21|0)+ -22+B<<3)|0;I=+h[x>>3];h[x>>3]=I+(I- +h[b+(G<<3)>>3])}h[231312+(E+ -1<<3)>>3]=+h[223384+(z+(E*21|0)<<3)>>3];if((E|0)<(v|0)){E=E+1|0}else{break}}c[56730]=v+1}re[u&63](e,231312,A)|0;c[57782]=(c[57782]|0)+1;c[57780]=(c[57780]|0)+1;E=c[56728]|0;I=+h[226744+(E+ -1<<3)>>3];if(I>=+h[28841]){B=E;continue}h[28841]=I;if(!((c[j>>2]|0)>-1)){B=E;continue}c[231924>>2]=6;yPa(231920)|0;POa(232232,231120,4)|0;POa(232232,230728,8)|0;E=c[e>>2]|0;c[56730]=1;if((E|0)>=1){z=1;do{POa(232232,231312+(z+ -1<<3)|0,8)|0;G=c[56730]|0;z=G+1|0;c[56730]=z;}while((G|0)<(E|0))}gPa()|0;B=c[56728]|0}}B=c[57174]|0;c[56728]=1;do{if((B|0)<1){h[28368]=+h[28343];c[56728]=1;ga=B;R=202}else{y=1;do{E=y+1|0;c[56738]=E;z=c[e>>2]|0;c[56730]=1;if((z|0)>=1){A=1;while(1){v=A*21|0;h[231144+(A+ -1<<3)>>3]=(+h[223384+(v+ -21<<3)>>3]+ +h[223384+(v+ -22+E<<3)>>3])*.5;if((A|0)<(z|0)){A=A+1|0}else{break}}c[56730]=z+1}re[u&63](e,231144,228704+(y+ -1<<3)|0)|0;c[57782]=(c[57782]|0)+1;c[57780]=(c[57780]|0)+1;A=c[56728]|0;y=A+1|0;c[56728]=y;}while((A|0)<(B|0));y=c[57174]|0;I=+h[28343];h[28368]=I;c[56728]=1;if((y|0)<1){ga=y;R=202;break}else{ha=I;ia=1}while(1){A=ia+ -1|0;c[56738]=A;c[56740]=ia+1;if((ia|0)<2){ja=ia;ka=ha}else{c[56730]=1;E=1;while(1){v=E+1|0;c[56742]=v;G=c[e>>2]|0;c[56732]=1;if((G|0)>=1){x=c[56740]|0;T=1;while(1){U=(T*21|0)+ -22|0;h[231312+(T+ -1<<3)>>3]=(+h[223384+(U+x<<3)>>3]+ +h[223384+(U+v<<3)>>3])*.5;if((T|0)<(G|0)){T=T+1|0}else{break}}c[56732]=G+1}re[u&63](e,231312,231304)|0;c[57782]=(c[57782]|0)+1;c[57780]=(c[57780]|0)+1;T=c[56728]|0;v=T+ -1|0;x=(fa(v,T)|0)/2|0;U=c[56730]|0;la=U+x|0;c[56734]=la;I=+h[28368];h[229024+(la+ -1<<3)>>3]=(+h[28913]+I- +h[228704+(v<<3)>>3]- +h[228704+(U+ -1<<3)>>3])*2.0;v=U+1|0;c[56730]=v;if((U|0)<(A|0)){E=v}else{ja=T;ka=I;break}}}E=ja+1|0;c[56728]=E;if((ja|0)<(y|0)){ha=ka;ia=E}else{break}}y=c[57174]|0;c[56734]=0;c[56728]=1;E=(y|0)<1;if(E){c[56728]=1;ma=1;na=y;break}A=y+ -1|0;z=A<<1;T=Q$a(A|0,0,y+ -2|0,0)|0;A=J$a(T|0,J&1|0,1)|0;T=0;v=1;while(1){U=T+v|0;h[229024+(U+ -1<<3)>>3]=(+h[226744+(v<<3)>>3]+ka- +h[228704+(v+ -1<<3)>>3]*2.0)*2.0;if((v|0)<(y|0)){v=v+1|0;T=U}else{break}}c[56738]=v+1;c[56734]=(z|1)+A;c[56728]=1;if(E){ma=1;na=y;break}I=ka*3.0;T=1;while(1){U=228704+(T+ -1<<3)|0;h[U>>3]=+h[U>>3]*2.0-(+h[226744+(T<<3)>>3]+I)*.5;if((T|0)<(y|0)){T=T+1|0}else{break}}c[56738]=T+1;c[56728]=y+1;ma=E;na=y}}while(0);if((R|0)==202){R=0;c[56734]=0;c[56728]=1;ma=(ga|0)<1;na=ga}B=c[e>>2]|0;c[56728]=1;if((B|0)>=1){A=1;while(1){h[230744+(A+ -1<<3)>>3]=+h[223384+((A*21|0)+ -21<<3)>>3];if((A|0)<(B|0)){A=A+1|0}else{break}}c[56728]=B+1}c[56728]=1;do{if(ma){c[56728]=1}else{A=1;while(1){z=A+1|0;c[56738]=z;v=c[e>>2]|0;c[56730]=1;if((v|0)>=1){U=1;while(1){la=U*21|0;x=223384+(la+ -22+z<<3)|0;h[x>>3]=+h[x>>3]- +h[223384+(la+ -21<<3)>>3];if((U|0)<(v|0)){U=U+1|0}else{break}}c[56730]=v+1}c[56728]=z;if((A|0)<(na|0)){A=z}else{break}}c[56728]=1;if(ma){break}else{oa=1}while(1){A=oa+1|0;c[56738]=A;y=c[e>>2]|0;c[56730]=1;if((y|0)>=1){E=1;while(1){T=(E*21|0)+ -22|0;h[223384+(T+oa<<3)>>3]=+h[223384+(T+A<<3)>>3];if((E|0)<(y|0)){E=E+1|0}else{break}}c[56730]=y+1}c[56728]=A;if((oa|0)<(na|0)){oa=A}else{break}}}}while(0);B=229024;xya(B,228696,B,230904,231480,q,231064)|0;if((c[q>>2]|0)==0){R=226;break}if((c[j>>2]|0)>-1){c[231948>>2]=6;yPa(231944)|0;gPa()|0}c[q>>2]=2;if((c[57780]|0)>(c[g>>2]|0)){R=312;break}c[231972>>2]=6;yPa(231968)|0;gPa()|0;B=c[e>>2]|0;c[56728]=1;if((B|0)<1){continue}else{pa=1}while(1){E=d+(pa+ -1<<3)|0;h[E>>3]=+h[E>>3]*.5;if((pa|0)<(B|0)){pa=pa+1|0}else{break}}c[56728]=B+1}if((R|0)==150){c[q>>2]=1;if((c[j>>2]|0)<0){i=r;return 0}c[231660>>2]=6;yPa(231656)|0;POa(232232,g,4)|0;gPa()|0;c[231684>>2]=6;yPa(231680)|0;POa(232232,230736,8)|0;gPa()|0;c[231708>>2]=6;yPa(231704)|0;u=c[e>>2]|0;c[56728]=1;if((u|0)>=1){E=1;do{POa(232232,b+(E+ -1<<3)|0,8)|0;z=c[56728]|0;E=z+1|0;c[56728]=E;}while((z|0)<(u|0))}gPa()|0;c[231732>>2]=6;yPa(231728)|0;POa(232232,s,8)|0;gPa()|0;i=r;return 0}else if((R|0)==226){u=c[57174]|0;c[57778]=u-(c[57870]|0);c[56728]=1;E=(u|0)<1;do{if(E){h[28885]=0.0;c[56728]=1;qa=0.0}else{z=u+1|0;v=1;while(1){h[226744+(v+ -1<<3)>>3]=0.0;T=v+ -1|0;U=226744+(T<<3)|0;I=+h[U>>3];la=1;while(1){if((la|0)>(v|0)){x=la+ -1|0;ra=x;sa=((fa(x,la)|0)/2|0)+v|0}else{ra=la+ -1|0;sa=((fa(T,v)|0)/2|0)+la|0}ta=+h[229024+(sa+ -1<<3)>>3]*+h[228704+(ra<<3)>>3]+I;if((la|0)<(u|0)){I=ta;la=la+1|0}else{break}}c[56734]=sa;h[U>>3]=ta;if((v|0)<(u|0)){v=v+1|0}else{break}}c[56730]=z;h[28885]=0.0;c[56728]=1;if(E){qa=0.0;break}else{ua=1;va=0.0}while(1){v=ua+ -1|0;wa=va+ +h[226744+(v<<3)>>3]*+h[228704+(v<<3)>>3];if((ua|0)<(u|0)){va=wa;ua=ua+1|0}else{break}}h[28885]=wa;c[56728]=u+1;qa=wa}}while(0);h[28885]=+h[28368]-qa;s=c[e>>2]|0;c[56728]=1;if((s|0)>=1){z=u+1|0;v=1;while(1){h[231312+(v+ -1<<3)>>3]=0.0;if(E){xa=1}else{B=v*21|0;la=231312+(v+ -1<<3)|0;T=1;I=+h[la>>3];while(1){ya=I+ +h[226744+(T+ -1<<3)>>3]*+h[223384+(T+ -22+B<<3)>>3];if((T|0)<(u|0)){I=ya;T=T+1|0}else{break}}h[la>>3]=ya;xa=z}if((v|0)<(s|0)){v=v+1|0}else{break}}c[56728]=s+1;c[56730]=xa}v=c[e>>2]|0;c[56728]=1;if((v|0)>=1){z=1;while(1){u=z+ -1|0;E=230744+(u<<3)|0;h[E>>3]=+h[E>>3]- +h[231312+(u<<3)>>3];if((z|0)<(v|0)){z=z+1|0}else{break}}c[56728]=v+1}if((c[j>>2]|0)>=0){c[231996>>2]=6;yPa(231992)|0;POa(232232,231080,8)|0;z=c[e>>2]|0;c[56728]=1;if((z|0)>=1){s=1;do{POa(232232,230744+(s+ -1<<3)|0,8)|0;u=c[56728]|0;s=u+1|0;c[56728]=s;}while((u|0)<(z|0))}gPa()|0;c[232020>>2]=6;yPa(232016)|0;gPa()|0}z=c[e>>2]|0;c[56728]=1;if((z|0)>=1){s=c[57174]|0;v=1;while(1){c[56730]=1;if((s|0)>=1){u=v*21|0;E=s+1|0;T=1;while(1){h[226744+(T+ -1<<3)>>3]=0.0;B=T+ -1|0;x=226744+(B<<3)|0;I=+h[x>>3];za=1;while(1){if((za|0)>(T|0)){Aa=((fa(za+ -1|0,za)|0)/2|0)+T|0}else{Aa=((fa(B,T)|0)/2|0)+za|0}Ba=I+ +h[229024+(Aa+ -1<<3)>>3]*+h[223384+(za+ -22+u<<3)>>3]*.5;if((za|0)<(s|0)){I=Ba;za=za+1|0}else{break}}c[56734]=Aa;h[x>>3]=Ba;if((T|0)<(s|0)){T=T+1|0}else{break}}c[56732]=E;c[56730]=s+1}T=c[e>>2]|0;c[56730]=v;if((v|0)<=(T|0)){u=(s|0)<1;la=s+1|0;za=v;while(1){Ca=v+((fa(za+ -1|0,za)|0)/2|0)|0;B=227e3+(Ca+ -1<<3)|0;h[B>>3]=0.0;if(u){Da=1}else{U=za*21|0;Ea=1;I=0.0;while(1){Fa=+h[226744+(Ea+ -1<<3)>>3]*+h[223384+(Ea+ -22+U<<3)>>3]+I;if((Ea|0)<(s|0)){I=Fa;Ea=Ea+1|0}else{break}}h[B>>3]=Fa;Da=la}if((za|0)<(T|0)){za=za+1|0}else{break}}c[56730]=T+1;c[56734]=Ca;c[56732]=Da}za=v+1|0;c[56728]=za;if((v|0)<(z|0)){v=za}else{break}}}c[56730]=0;v=c[e>>2]|0;c[56728]=1;if((v|0)>=1){z=1;s=0;while(1){Ga=s+z|0;h[o+(z+ -1<<3)>>3]=+h[227e3+(Ga+ -1<<3)>>3];if((z|0)<(v|0)){s=Ga;z=z+1|0}else{break}}c[56730]=Ga;c[56728]=v+1}if((c[j>>2]|0)<0){i=r;return 0}c[232044>>2]=6;yPa(232040)|0;POa(232232,231112,4)|0;gPa()|0;c[57172]=1;z=1;d:while(1){c[56734]=z;do{if((z|0)>(c[e>>2]|0)){s=c[57172]|0;if((s|0)==1){c[232068>>2]=6;yPa(232064)|0;gPa()|0;xya(227e3,228696,229024,230904,231480,q,231064)|0;c[232092>>2]=6;yPa(232088)|0;gPa()|0;c[57172]=3;z=1;continue d}else if((s|0)==2){break d}else if((s|0)!=3){break}c[57172]=2;c[56744]=0;c[56746]=0;s=c[e>>2]|0;c[56728]=1;if((s|0)>=1){za=0;la=1;u=0;E=0;while(1){Ea=(E|0)>1?E:1;U=Ea+1|0;x=Q$a(Ea+ -1|0,0,Ea+ -2|0,0)|0;Ha=J$a(x|0,J&1|0,1)|0;x=(Ea<<1)+ -1+Ha|0;Ia=u+la|0;Ha=227e3+(Ia+ -1<<3)|0;I=+h[Ha>>3];if(I>0.0){Ja=1.0/+V(+I)}else{Ja=0.0}h[Ha>>3]=Ja;Ka=la+ -1|0;if((la|0)<2){La=za;Ma=1;Na=0}else{I=Ja;Oa=1;Pa=za;Qa=0;while(1){Ra=Qa+Oa|0;Sa=227e3+(Pa<<3)|0;h[Sa>>3]=+h[Sa>>3]*I*+h[227e3+(Ra+ -1<<3)>>3];if((Oa|0)>=(Ka|0)){break}I=+h[Ha>>3];Oa=Oa+1|0;Pa=Pa+1|0;Qa=Ra}La=za+Ea|0;Ma=U;Na=x}Ta=La+1|0;if((la|0)<(s|0)){za=Ta;la=la+1|0;E=E+1|0;u=Ia}else{break}}c[56748]=Na;c[56746]=Ta;c[56744]=Ia;c[56730]=Ma;c[56728]=s+1}c[232116>>2]=6;yPa(232112)|0;gPa()|0;c[56744]=0;u=c[e>>2]|0;c[56728]=1;if((u|0)<1){z=1;continue d}else{Ua=1;Va=0}while(1){Wa=Va+Ua|0;E=227e3+(Wa+ -1<<3)|0;if(+h[E>>3]!=0.0){h[E>>3]=1.0}if((Ua|0)<(u|0)){Ua=Ua+1|0;Va=Wa}else{break}}c[56744]=Wa;c[56728]=u+1;z=1;continue d}}while(0);T=(fa(z+ -1|0,z)|0)/2|0;c[56744]=T;s=c[e>>2]|0;c[56728]=z;e:do{if((z|0)<=(s|0)){E=z;la=T;za=z;while(1){B=E+la|0;c[56738]=B;Qa=za+la|0;c[56744]=Qa;Pa=B+5|0;c[56740]=(Qa|0)<=(Pa|0)?Qa:Pa;if((c[57172]|0)==3){c[232188>>2]=6;yPa(232184)|0;Pa=c[56740]|0;Qa=c[56738]|0;c[56730]=Qa;if((Qa|0)<=(Pa|0)){B=Qa;do{POa(232232,229024+(B+ -1<<3)|0,8)|0;Qa=c[56730]|0;B=Qa+1|0;c[56730]=B;}while((Qa|0)<(Pa|0))}gPa()|0}else{c[232164>>2]=6;yPa(232160)|0;Pa=c[56740]|0;B=c[56738]|0;c[56730]=B;if((B|0)<=(Pa|0)){x=B;do{POa(232232,227e3+(x+ -1<<3)|0,8)|0;B=c[56730]|0;x=B+1|0;c[56730]=x;}while((B|0)<(Pa|0))}gPa()|0}Pa=c[56728]|0;x=Pa+1|0;c[56728]=x;if((Pa|0)>=(s|0)){break e}E=c[56734]|0;la=c[56744]|0;za=x}}}while(0);c[232212>>2]=6;yPa(232208)|0;gPa()|0;z=(c[56734]|0)+6|0}c[232140>>2]=6;yPa(232136)|0;POa(232232,231128,4)|0;gPa()|0;i=r;return 0}else if((R|0)==312){i=r;return 0}}}while(0);re[p&63](e,b,f)|0;i=r;return 0}function xya(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0.0,I=0;k=i;c[58078]=c[b>>2];c[g>>2]=1;if((c[58078]|0)<1){i=k;return 0}c[g>>2]=0;yya(a,232312,d,f,g,j,e)|0;if((c[g>>2]|0)!=0){i=k;return 0}g=c[58078]|0;j=g+1|0;f=(fa(j,g)|0)/2|0;c[58070]=f;c[58076]=g;c[58082]=f;a=g+ -1|0;b=f+(fa(a,1-g|0)|0)|0;l=Q$a(a|0,0,g+ -2|0,0)|0;m=J$a(l|0,J&1|0,1)|0;l=b+m|0;m=0-g|0;b=f;n=g;while(1){if(+h[d+(b+ -1<<3)>>3]==0.0){c[58062]=n;if((n|0)>(g|0)){o=b}else{p=g-n|0;q=fa(p,n+1|0)|0;r=Q$a(p|0,0,a-n|0,0)|0;p=J$a(r|0,J&1|0,1)|0;r=n;s=b;while(1){h[d+(s+ -1<<3)>>3]=0.0;if((r|0)<(g|0)){s=s+r|0;r=r+1|0}else{break}}c[58062]=j;o=n+b+q+p|0}t=o;u=n+ -1|0}else{c[58060]=n;if((n|0)<=(g|0)){r=n;s=b;while(1){h[e+(r+ -1<<3)>>3]=+h[d+(s+ -1<<3)>>3];if((r|0)>=(g|0)){break}v=s+r|0;r=r+1|0;s=v}c[58060]=j}c[58072]=g;c[58074]=f;c[58080]=f;s=n+ -1|0;r=e+(s<<3)|0;p=(g|0)==(n|0);q=f;v=g;w=f;while(1){h[29034]=0.0;x=(v|0)==(n|0);if(x){y=1.0/+h[r>>3];h[29034]=y;z=y}else{z=0.0}if(p){A=g;B=w;C=z}else{y=z;D=g;E=w;while(1){F=D+ -1|0;G=E+ -1|0;H=y- +h[e+(F<<3)>>3]*+h[d+(G<<3)>>3];h[29034]=H;if((G|0)>(q|0)){I=E+(1-D)|0}else{I=G}if((F|0)==(n|0)){A=n;B=I;C=H;break}else{E=I;D=F;y=H}}}h[d+(B+ -1<<3)>>3]=C/+h[r>>3];if(x){break}D=q-v|0;c[58080]=D;E=v+ -1|0;c[58072]=E;F=w+ -1|0;c[58074]=F;q=D;v=E;w=F}c[58064]=A;t=B;u=s}w=b+m|0;if((u|0)==0){break}else{m=m+1|0;b=w;n=u}}c[58066]=t;c[58076]=0;c[58082]=l-g;i=k;return 0}function yya(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0.0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0,O=0;k=i;h[29048]=.5;l=.5;do{l=l*.5;}while(l+1.0>1.0);m=l*2.0;h[29048]=m;c[f>>2]=1;if((c[b>>2]|0)<1){i=k;return 0}c[f>>2]=2;c[e>>2]=0;h[g>>3]=m;h[j>>3]=+h[29048];c[58086]=1;c[58088]=0;n=c[b>>2]|0;c[58100]=1;a:do{if((n|0)>=1){b=1;o=1;b:while(1){c[58090]=0;c[58102]=1;do{if((o|0)>=1){p=1;q=c[58088]|0;r=0;while(1){s=q+1|0;t=a+(q<<3)|0;m=+h[t>>3];h[29047]=m;u=(p|0)==(o|0);if(u){l=m*+h[29048];h[29049]=l*l}do{if((p|0)<1){v=m;w=r;x=b;y=1}else{l=m;z=b;A=1;B=r;while(1){C=B+1|0;if((A|0)==(p|0)){D=14;break}E=d+(B<<3)|0;F=l- +h[E>>3]*+h[d+(z+ -1<<3)>>3];h[29047]=F;if(u){G=+h[E>>3];H=G*G*+h[j+(A+ -1<<3)>>3];h[29049]=+h[29049]+H*H}I=z+1|0;J=A+1|0;if((A|0)<(p|0)){l=F;z=I;A=J;B=C}else{D=15;break}}if((D|0)==14){D=0;c[58090]=C;v=l;w=C;x=z;y=p;break}else if((D|0)==15){D=0;c[58090]=C;v=F;w=C;x=I;y=J;break}}}while(0);if(u){D=25;break}m=+h[d+(w+ -1<<3)>>3];if(m==0.0){h[d+(q<<3)>>3]=0.0;H=+h[29047];if(!(H>=0.0)){K=-H}else{K=H}H=+h[g>>3]*+h[t>>3];if(!(H>=0.0)){L=-H}else{L=H}if(K>L){break b}}else{h[d+(q<<3)>>3]=v/m}B=p+1|0;c[58102]=B;if((p|0)<(o|0)){p=B;r=w;q=s}else{D=26;break}}if((D|0)==25){D=0;c[58084]=y;c[58092]=x;c[58088]=s;break}else if((D|0)==26){D=0;c[58084]=y;c[58092]=x;c[58088]=s;break}}}while(0);m=+V(+(+h[29049]));h[29049]=m;H=+h[29047];if(!(H>=0.0)){M=-H}else{M=H}do{if(!(M<=m*5.0)){if(H<0.0){D=37;break b}G=+V(+H);h[d+((c[58088]|0)+ -1<<3)>>3]=G;G=+h[29049]/+h[29047];h[j+((c[58084]|0)+ -1<<3)>>3]=G;if(!(G>+h[g>>3])){N=b;O=o;break}h[g>>3]=G;N=b;O=o}else{h[d+((c[58088]|0)+ -1<<3)>>3]=0.0;c[e>>2]=(c[e>>2]|0)+1;N=c[58086]|0;O=c[58100]|0}}while(0);b=N+O|0;c[58086]=b;o=O+1|0;c[58100]=o;if((O|0)>=(n|0)){break a}}if((D|0)==37){i=k;return 0}c[58084]=y;c[58092]=x;c[58088]=s;i=k;return 0}}while(0);c[f>>2]=0;i=k;return 0}function zya(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;m=i;n=(c[b>>2]|0)+1|0;c[58126]=n;o=(c[d>>2]|0)-n|0;c[58148]=o;p=c[d>>2]|0;q=c[b>>2]|0;r=q+2|0;do{if((p|0)>=(r|0)){if((p|0)>((fa(n,r)|0)/2|0|0)){break}s=q+p|0;c[58146]=s;a[232528]=1;t=c[b>>2]|0;u=t+1|0;c[58142]=u;v=c[b>>2]|0;w=u+v|0;c[58140]=w;u=w+(c[b>>2]|0)|0;c[58144]=u;w=(fa(c[d>>2]|0,c[b>>2]|0)|0)+u|0;c[58134]=w;x=w+(c[d>>2]|0)|0;c[58128]=x;y=x+(c[b>>2]|0)|0;c[58130]=y;z=((fa(n,c[b>>2]|0)|0)/2|0)+y|0;c[58136]=z;A=z+(c[d>>2]|0)|0;c[58150]=A;B=(fa(c[b>>2]|0,s)|0)+A|0;c[58152]=B;C=(fa(o,c[d>>2]|0)|0)+B|0;c[58124]=C;D=C+(c[b>>2]|0)|0;c[58138]=D;Aya(b,d,e,f,g,h,j,k,k+(t<<3)|0,k+(t+v<<3)|0,k+(u+ -1<<3)|0,k+(w+ -1<<3)|0,k+(x+ -1<<3)|0,k+(y+ -1<<3)|0,k+(z+ -1<<3)|0,k+(A+ -1<<3)|0,k+(B+ -1<<3)|0,232584,k+(C+ -1<<3)|0,k+(D+ -1<<3)|0,k+(s+ -1+D<<3)|0,l)|0;i=m;return 0}}while(0);yPa(232616)|0;gPa()|0;i=m;return 0}function Aya(a,b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;var z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0.0,S=0,T=0,U=0,W=0.0,X=0,Y=0,Z=0.0,_=0,$=0,aa=0,ba=0.0,ca=0,da=0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0,Wa=0.0,Xa=0,Ya=0,Za=0,_a=0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0,gb=0.0,hb=0.0,ib=0,jb=0.0,kb=0.0,lb=0.0,mb=0.0,nb=0,ob=0.0,pb=0.0,qb=0.0,rb=0,sb=0.0,tb=0.0,ub=0.0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0.0;z=i;i=i+8|0;A=z;B=c[b>>2]|0;C=~B;D=c[u>>2]|0;E=~D;h[29162]=.5;h[29153]=1.0;h[29193]=.1;F=(c[a>>2]|0)+1|0;c[58302]=F;G=fa(c[a>>2]|0,F)|0;H=(G|0)/2|0;c[58294]=H;I=(c[b>>2]|0)-F|0;c[58348]=I;F=c[j>>2]|0;c[58402]=(F|0)<1?1:F;F=c[a>>2]|0;c[58286]=1;if((F|0)>=1){j=1;while(1){J=j+ -1|0;h[k+(J<<3)>>3]=+h[d+(J<<3)>>3];J=c[b>>2]|0;c[58288]=1;if((J|0)>=1){K=fa(j,B)|0;L=1;while(1){h[n+(L+C+K<<3)>>3]=0.0;if((L|0)<(J|0)){L=L+1|0}else{break}}c[58288]=J+1}L=c[u>>2]|0;c[58284]=1;if((L|0)>=1){K=1;while(1){h[s+(K+E+(fa(j,D)|0)<<3)>>3]=0.0;if((K|0)<(L|0)){K=K+1|0}else{break}}c[58284]=L+1}K=j+1|0;c[58286]=K;if((j|0)<(F|0)){j=K}else{break}}}c[58290]=1;if((G|0)>=2){G=1;while(1){h[q+(G+ -1<<3)>>3]=0.0;if((G|0)<(H|0)){G=G+1|0}else{break}}c[58290]=H+1}H=c[b>>2]|0;c[58288]=1;if((H|0)>=1){G=(I|0)<1;j=I+1|0;F=1;while(1){h[r+(F+ -1<<3)>>3]=0.0;if(G){M=1}else{K=1;while(1){h[t+((fa(K,B)|0)+C+F<<3)>>3]=0.0;if((K|0)<(I|0)){K=K+1|0}else{M=j;break}}}if((F|0)<(H|0)){F=F+1|0}else{break}}c[58286]=M;c[58288]=H+1}N=+h[e>>3];O=N*N;h[29198]=O;h[29184]=+h[29153]/O;h[29185]=+V(+(+h[29162]))/O;c[58292]=0;H=y;y=A;M=0;a:while(1){c[58304]=M;F=M-(c[a>>2]|0)|0;c[58328]=F;j=M+1|0;c[58292]=j;I=c[a>>2]|0;do{if((M|0)>(I<<1|0)){G=(F+ -1|0)/(I|0)|0;c[58378]=G;K=c[a>>2]|0;L=M-(fa(K,G)|0)-K|0;c[58316]=L;K=L+G|0;c[58314]=K;if((K|0)>(c[a>>2]|0)){c[58378]=L;G=K-(c[a>>2]|0)|0;c[58316]=G;c[58314]=L;P=L;Q=G}else{P=K;Q=L}O=+h[e>>3];h[29175]=O;L=c[58302]|0;if(+h[o+(P+ -1+L<<3)>>3]<+h[o+(P<<3)>>3]){N=-O;h[29175]=N;R=N}else{R=O}O=+h[e>>3];h[29176]=O;if(+h[o+(Q+ -1+L<<3)>>3]<+h[o+(Q<<3)>>3]){h[29176]=-O}L=j+C|0;h[n+(L+(fa(P,B)|0)<<3)>>3]=R;h[n+(L+(fa(Q,B)|0)<<3)>>3]=+h[29176];S=c[a>>2]|0}else{L=(M|0)>(I|0);if(!((M|0)<1|L)){h[n+((fa(M,B)|0)+C+j<<3)>>3]=+h[e>>3];S=I;break}if(!L){S=I;break}h[n+(j+C+(fa(F,B)|0)<<3)>>3]=-+h[e>>3];S=I}}while(0);c[58286]=1;if((S|0)>=1){I=1;while(1){O=+h[n+((fa(I,B)|0)+C+j<<3)>>3];F=I+ -1|0;h[d+(F<<3)>>3]=O+ +h[k+(F<<3)>>3];if((I|0)<(S|0)){I=I+1|0}else{break}}c[58286]=S+1}if((M|0)>=(c[58402]|0)){T=j;U=159;break}while(1){re[H&63](a,d,233128)|0;if((c[g>>2]|0)==3){yPa(233656)|0;POa(233824,233168,4)|0;POa(233824,233128,8)|0;I=c[a>>2]|0;c[58284]=1;if((I|0)>=1){F=1;do{POa(233824,d+(F+ -1<<3)|0,8)|0;L=c[58284]|0;F=L+1|0;c[58284]=F;}while((L|0)<(I|0))}gPa()|0}I=c[58292]|0;do{if((I|0)>(c[b>>2]|0)){F=c[58332]|0;if((F|0)==-1){break a}h[29194]=0.0;c[58290]=0;L=c[a>>2]|0;c[58286]=1;if((L|0)<1){W=0.0}else{O=0.0;K=2;G=1;J=0;while(1){X=G+ -1|0;N=O+ +h[v+(X<<3)>>3]*+h[p+(X<<3)>>3];h[29194]=N;if((G|0)<1){Y=1;Z=N;_=J}else{X=G+ -1|0;$=m+(X<<3)|0;aa=v+(X<<3)|0;ba=N;X=1;ca=J;while(1){da=X+ -1|0;N=+h[v+(da<<3)>>3]*+h[$>>3]+ +h[aa>>3]*+h[l+(da<<3)>>3];h[29167]=N;if((X|0)==(G|0)){ea=N*+h[29162];h[29167]=ea;ga=ea}else{ga=N}ha=ba+ga*+h[q+(ca<<3)>>3];h[29194]=ha;if((X|0)<(G|0)){ba=ha;X=X+1|0;ca=ca+1|0}else{break}}ca=J+G|0;c[58290]=ca;Y=K;Z=ha;_=ca}if((G|0)<(L|0)){O=Z;K=K+1|0;G=G+1|0;J=_}else{break}}c[58284]=Y;c[58286]=L+1;W=Z}J=c[b>>2]|0;c[58288]=1;if((J|0)<1){ia=W}else{O=W;G=1;while(1){K=G+ -1|0;ja=O+ +h[r+(K<<3)>>3]*+h[x+(K<<3)>>3];h[29194]=ja;if((G|0)<(J|0)){G=G+1|0;O=ja}else{break}}c[58288]=J+1;ia=ja}O=+h[29141];ba=+h[29170];N=O-ba-ia;h[29161]=N;h[29180]=+h[29179];h[29179]=+h[29178];if(!(N>=0.0)){ka=-N}else{ka=N}h[29178]=ka;if(+h[29190]>+h[29156]){c[58376]=I}h[29186]=ba;do{if(O<ba){h[29170]=O;h[29203]=0.0;G=c[a>>2]|0;c[58284]=1;if((G|0)<1){break}else{la=1}while(1){L=la+ -1|0;h[l+(L<<3)>>3]=+h[m+(L<<3)>>3];ma=+h[l+(la+ -1<<3)>>3];h[29203]=+h[29203]+ma*ma;if((la|0)<(G|0)){la=la+1|0}else{break}}c[58284]=G+1;h[A>>3]=ma}}while(0);c[58374]=F;if((F|0)<=0){O=+h[29194];if(O>=0.0){U=190;break a}ba=+h[29141];N=+h[29186];ea=(ba-N)/O;h[29191]=ea;O=+h[29193];do{if(!(ea<=O)){na=+h[29162]*+h[29183];h[A>>3]=na;oa=+h[29190];if(!(ea<=.7)){pa=oa+oa;qa=na>=pa?na:pa;h[29183]=qa;ra=qa;break}else{qa=na>=oa?na:oa;h[29183]=qa;ra=qa;break}}else{qa=+h[29162]*+h[29190];h[29183]=qa;ra=qa}}while(0);ea=+h[29156];if(!(ra<=ea*1.5)){sa=ra}else{h[29183]=ea;sa=ea}qa=O*sa;oa=qa>=ea?qa:ea;h[A>>3]=oa;ea=oa*oa;h[29198]=ea;c[58390]=0;h[29199]=0.0;if(!(ba>=N)){ta=0;ua=0.0}else{J=c[58346]|0;c[58390]=J;oa=+h[29153];h[29199]=oa;ta=J;ua=oa}J=c[b>>2]|0;c[58288]=1;if((J|0)<1){va=F}else{L=c[58348]|0;oa=ua;K=1;ca=F;while(1){h[29181]=0.0;c[58286]=1;if((L|0)<1){wa=0.0}else{X=c[58308]|0;aa=K+C|0;qa=+h[29153];na=0.0;$=1;while(1){if(($|0)<(X|0)){xa=-qa}else{xa=qa}h[29167]=xa;pa=+h[t+(aa+(fa($,B)|0)<<3)>>3];ya=na+xa*pa*pa;h[29181]=ya;if(($|0)<(L|0)){na=ya;$=$+1|0}else{break}}c[58286]=L+1;wa=ya}na=+h[w+(K+ -1<<3)>>3];qa=na*na+ +h[29163]*wa;if(!(qa>=0.0)){za=-qa}else{za=qa}h[29167]=za;h[29202]=0.0;$=c[a>>2]|0;c[58286]=1;if(($|0)<1){Aa=qa;Ba=0.0}else{qa=0.0;aa=1;while(1){na=+h[n+((fa(aa,B)|0)+C+K<<3)>>3];Ca=na- +h[l+(aa+ -1<<3)>>3];Da=qa+Ca*Ca;h[29202]=Da;if((aa|0)<($|0)){aa=aa+1|0;qa=Da}else{break}}c[58286]=$+1;Aa=Ca;Ba=Da}if(Ba>ea){qa=Ba/ea;na=za*qa*qa*qa;h[29167]=na;Ea=qa;Fa=na}else{Ea=Aa;Fa=za}if(!(Fa>oa)|(K|0)==(ta|0)){Ga=oa;Ha=ca}else{h[29199]=Fa;c[58332]=K;Ga=Fa;Ha=K}aa=K+1|0;c[58288]=aa;if((K|0)<(J|0)){oa=Ga;K=aa;ca=Ha}else{break}}h[A>>3]=Ea;va=Ha}if((va|0)==0){Ia=0;Ja=sa;Ka=O;U=286;break}}Gya(a,b,s,t,233232,u,w,233304,233328,x)|0;ca=c[58332]|0;K=ca+ -1|0;h[o+(K<<3)>>3]=+h[29141];c[58290]=0;J=c[a>>2]|0;c[58284]=1;L=r+(K<<3)|0;if((J|0)>=1){K=ca+C|0;F=2;aa=1;X=0;while(1){oa=+h[L>>3]*+h[n+((fa(aa,B)|0)+C+ca<<3)>>3];h[29167]=oa;if((aa|0)<1){La=1;Ma=X}else{ea=oa;G=1;da=X;while(1){oa=ea*+h[n+(K+(fa(G,B)|0)<<3)>>3];Na=q+(da<<3)|0;h[Na>>3]=+h[Na>>3]+oa;if((G|0)>=(aa|0)){break}ea=+h[29167];G=G+1|0;da=da+1|0}da=X+aa|0;c[58290]=da;La=F;Ma=da}if((aa|0)<(J|0)){F=F+1|0;aa=aa+1|0;X=Ma}else{break}}c[58286]=La;c[58284]=J+1}h[L>>3]=0.0;X=c[58348]|0;c[58286]=1;aa=(X|0)<1;if(!aa){F=c[58308]|0;K=1;while(1){da=fa(K,B)|0;O=+h[29161]*+h[t+(da+C+ca<<3)>>3];if((K|0)<(F|0)){Oa=-O}else{Oa=O}h[29167]=Oa;G=c[b>>2]|0;c[58288]=1;if((G|0)>=1){O=Oa;$=1;while(1){Na=r+($+ -1<<3)|0;h[Na>>3]=+h[Na>>3]+O*+h[t+($+C+da<<3)>>3];if(($|0)>=(G|0)){break}O=+h[29167];$=$+1|0}c[58288]=G+1}$=K+1|0;c[58286]=$;if((K|0)<(X|0)){K=$}else{break}}}h[29172]=0.0;K=c[a>>2]|0;c[58284]=1;if((K|0)>=1){F=1;while(1){O=+h[29161]*+h[s+((fa(F,D)|0)+E+ca<<3)>>3];L=p+(F+ -1<<3)|0;h[L>>3]=+h[L>>3]+O;L=F+ -1|0;Pa=+h[p+(L<<3)>>3];h[29172]=+h[29172]+Pa*Pa;h[n+((fa(F,B)|0)+C+ca<<3)>>3]=+h[m+(L<<3)>>3];if((F|0)<(K|0)){F=F+1|0}else{break}}c[58284]=K+1;h[A>>3]=Pa}F=c[58374]|0;do{if((F|0)==0){if(!(+h[29183]==+h[29156])){break}O=+h[29191];if(!(O>=0.0)){Qa=-O}else{Qa=O}if(Qa>.01){c[58394]=0;break}L=c[b>>2]|0;c[58288]=1;if((L|0)>=1){J=o+((c[58346]|0)+ -1<<3)|0;$=1;while(1){da=$+ -1|0;h[w+(da<<3)>>3]=+h[o+(da<<3)>>3]- +h[J>>3];if(($|0)<(L|0)){$=$+1|0}else{break}}c[58288]=L+1}h[29165]=0.0;$=c[a>>2]|0;c[58284]=1;if(($|0)<1){Ra=0.0}else{J=1;while(1){h[29159]=0.0;G=c[b>>2]|0;c[58288]=1;if((G|0)<1){Sa=0.0}else{da=fa(J,D)|0;O=0.0;Na=1;while(1){Ta=O+ +h[s+(Na+E+da<<3)>>3]*+h[w+(Na+ -1<<3)>>3];h[29159]=Ta;if((Na|0)<(G|0)){Na=Na+1|0;O=Ta}else{break}}c[58288]=G+1;Sa=Ta}h[29165]=+h[29165]+Sa*Sa;h[x+(J+ -1<<3)>>3]=Sa;Na=J+1|0;c[58284]=Na;if((J|0)<($|0)){J=Na}else{break}}Ra=+h[29165]*100.0}J=c[58394]|0;c[58394]=J+1;if(+h[29172]<Ra){c[58394]=0;break}if((J|0)<=1){break}J=c[a>>2]|0;c[58284]=1;if((J|0)>=1){$=1;while(1){L=$+ -1|0;h[p+(L<<3)>>3]=+h[x+(L<<3)>>3];if(($|0)<(J|0)){$=$+1|0}else{break}}c[58284]=J+1}$=c[58294]|0;c[58290]=1;if(($|0)>=1){L=1;while(1){h[q+(L+ -1<<3)>>3]=0.0;if((L|0)<($|0)){L=L+1|0}else{break}}c[58290]=$+1}c[58286]=1;if(!aa){L=1;while(1){J=x+(L+ -1<<3)|0;h[J>>3]=0.0;Na=c[b>>2]|0;c[58288]=1;if((Na|0)<1){Ua=0.0}else{da=fa(L,B)|0;O=0.0;Va=1;while(1){Wa=O+ +h[w+(Va+ -1<<3)>>3]*+h[t+(Va+C+da<<3)>>3];h[J>>3]=Wa;if((Va|0)<(Na|0)){Va=Va+1|0;O=Wa}else{break}}c[58288]=Na+1;Ua=Wa}if((L|0)<(c[58308]|0)){h[J>>3]=-Ua}Va=L+1|0;c[58286]=Va;if((L|0)<(X|0)){L=Va}else{break}}}L=c[b>>2]|0;c[58288]=1;if((L|0)>=1){$=X+1|0;Va=1;while(1){h[r+(Va+ -1<<3)>>3]=0.0;if(aa){Xa=1}else{da=1;while(1){O=+h[t+((fa(da,B)|0)+C+Va<<3)>>3];G=r+(Va+ -1<<3)|0;h[G>>3]=+h[G>>3]+O*+h[x+(da+ -1<<3)>>3];if((da|0)<(X|0)){da=da+1|0}else{Xa=$;break}}}if((Va|0)<(L|0)){Va=Va+1|0}else{break}}c[58286]=Xa;c[58288]=L+1}c[58394]=0}}while(0);O=+h[29141];ea=+h[29186];if(O<ea){c[58346]=ca}oa=+h[29193];if(O<=ea+oa*+h[29194]|(F|0)>0){U=54;break}c[58332]=0;Ia=0;Ja=+h[29183];Ka=oa;U=286}else{h[o+(I+ -1<<3)>>3]=+h[29141];oa=+h[29141];do{if((I|0)==1){h[29160]=oa;h[29170]=oa;c[58346]=1;Ya=1}else{if(!(oa<+h[29170])){Ya=I;break}h[29170]=oa;c[58346]=I;Ya=I}}while(0);F=c[58304]|0;ca=c[a>>2]|0;do{if((F|0)>(ca<<1|0)){X=c[58314]|0;aa=(fa(X+ -1|0,X)|0)/2|0;K=c[58316]|0;Va=K+aa|0;c[58290]=Va;if(+h[29175]<0.0){aa=X+(c[a>>2]|0)|0;c[58314]=aa;Za=aa}else{Za=X}if(+h[29176]<0.0){X=K+(c[a>>2]|0)|0;c[58316]=X;_a=X}else{_a=K}K=fa(c[58328]|0,B)|0;h[t+(K-B<<3)>>3]=+h[29184];h[t+(Ya+C+K<<3)>>3]=+h[29184];h[t+(Za-B+K<<3)>>3]=-+h[29184];h[t+(_a-B+K<<3)>>3]=-+h[29184];h[q+(Va+ -1<<3)>>3]=(+h[29160]- +h[o+(Za<<3)>>3]- +h[o+(_a<<3)>>3]+ +h[29141])/(+h[29175]*+h[29176])}else{Va=(F|0)>(ca|0);if((F|0)<1|Va){if(!Va){break}Va=c[58328]|0;K=fa(Va,D)|0;h[s+(E-ca+Ya+K<<3)>>3]=+h[29162]/+h[e>>3];h[s+(Ya+E+K<<3)>>3]=-+h[29162]/+h[e>>3];ea=+h[29185];K=fa(Va,B)|0;h[t+(K-B<<3)>>3]=-ea-ea;X=Ya+C|0;h[t+(X-ca+K<<3)>>3]=+h[29185];h[t+(X+K<<3)>>3]=+h[29185];K=(fa(Va+1|0,Va)|0)/2|0;c[58290]=K;ea=(+h[29160]- +h[29141])/+h[e>>3];h[29167]=ea;X=p+(Va+ -1<<3)|0;h[q+(K+ -1<<3)>>3]=(+h[X>>3]-ea)/+h[e>>3];h[X>>3]=+h[29162]*(+h[X>>3]+ +h[29167]);break}else{h[p+(F+ -1<<3)>>3]=(oa- +h[29160])/+h[e>>3];X=c[b>>2]|0;if((X|0)>=(ca+Ya|0)){break}K=fa(F,D)|0;h[s+(K-D<<3)>>3]=-+h[29153]/+h[e>>3];h[s+(Ya+E+K<<3)>>3]=+h[29153]/+h[e>>3];h[s+(X+E+F+K<<3)>>3]=-(+h[29162]*+h[29198]);break}}}while(0);if((Ya|0)<(c[b>>2]|0)){M=Ya;continue a}oa=+h[e>>3];h[29156]=oa;h[29183]=oa;c[58308]=1;h[29178]=0.0;h[29179]=0.0;c[58394]=0;h[29203]=0.0;F=c[a>>2]|0;c[58284]=1;if((F|0)<1){U=53;break}ca=c[58346]|0;K=1;while(1){h[l+(K+ -1<<3)>>3]=+h[n+((fa(K,B)|0)+C+ca<<3)>>3];$a=+h[l+(K+ -1<<3)>>3];h[29203]=+h[29203]+$a*$a;if((K|0)<(F|0)){K=K+1|0}else{break}}c[58284]=F+1;h[A>>3]=$a;U=53}}while(0);while(1){if((U|0)==53){U=0;c[58376]=c[58292];U=54;continue}else if((U|0)==54){U=0;c[58332]=0;I=(c[58302]|0)+ -1|0;K=c[a>>2]|0;Fya(a,b,l,n,p,q,r,233464,v,x,x+(I<<3)|0,x+(I+K<<3)|0,x+(I+(K<<1)<<3)|0,233600)|0;h[29155]=0.0;K=c[a>>2]|0;c[58284]=1;if((K|0)<1){ab=0.0}else{oa=0.0;I=1;while(1){bb=+h[v+(I+ -1<<3)>>3];cb=oa+bb*bb;h[29155]=cb;if((I|0)<(K|0)){I=I+1|0;oa=cb}else{break}}h[A>>3]=bb;c[58284]=K+1;ab=cb}oa=+h[29183];h[A>>3]=oa;ea=+V(+ab);O=oa<=ea?oa:ea;h[29190]=O;ea=+h[29156];if(!(O<+h[29162]*ea)){db=ab;U=62;break}c[58332]=-1;O=+h[29193];N=O*oa;h[29183]=N;h[29191]=-1.0;if(!(N<=ea*1.5)){eb=N}else{h[29183]=ea;eb=ea}if((c[58292]|0)<=((c[58376]|0)+2|0)){Ia=-1;Ja=eb;Ka=O;U=286;continue}N=ea*+h[29200]*.125*ea;h[29167]=N;oa=+h[29178];ba=+h[29179];na=oa>=ba?oa:ba;h[A>>3]=na;ba=+h[29180];if(!(N<=(na>=ba?na:ba))){fb=-1;gb=O;hb=ea}else{Ia=-1;Ja=eb;Ka=O;U=286;continue}}else if((U|0)==286){U=0;O=Ja*Ja*4.0;h[29202]=O;I=c[b>>2]|0;c[58288]=1;if((I|0)<1){ib=Ia}else{F=1;ea=O;ca=Ia;while(1){h[29159]=0.0;X=c[a>>2]|0;c[58286]=1;if((X|0)<1){jb=0.0}else{O=0.0;Va=1;while(1){ba=+h[n+((fa(Va,B)|0)+C+F<<3)>>3];kb=ba- +h[l+(Va+ -1<<3)>>3];lb=O+kb*kb;h[29159]=lb;if((Va|0)<(X|0)){Va=Va+1|0;O=lb}else{break}}h[A>>3]=kb;c[58286]=X+1;jb=lb}if(jb>ea){c[58332]=F;h[29202]=jb;mb=jb;nb=F}else{mb=ea;nb=ca}Va=F+1|0;c[58288]=Va;if((F|0)<(I|0)){F=Va;ea=mb;ca=nb}else{break}}if((nb|0)>0){U=294;break}else{ib=nb}}if(+h[29191]>0.0){U=54;continue}ea=+h[29190];O=+h[29156];if((Ja>=ea?Ja:ea)>O){U=54;continue}else{fb=ib;gb=Ka;hb=O}}if(!(hb>+h[f>>3])){U=309;break}O=hb*+h[29162];h[29183]=O;ea=hb/+h[f>>3];h[29191]=ea;do{if(!(ea<=16.0)){if(!(ea<=250.0)){ba=gb*hb;h[29156]=ba;ob=ba;break}else{ba=+V(+ea);na=ba*+h[f>>3];h[29156]=na;ob=na;break}}else{na=+h[f>>3];h[29156]=na;ob=na}}while(0);h[29183]=O>=ob?O:ob;ca=c[g>>2]|0;if((ca|0)<=1){U=53;continue}if((ca|0)>2){yPa(233704)|0;gPa()|0}yPa(233728)|0;POa(233824,233248,8)|0;POa(233824,233168,4)|0;gPa()|0;yPa(233752)|0;POa(233824,233360,8)|0;ca=c[a>>2]|0;c[58284]=1;if((ca|0)>=1){F=1;do{I=F+ -1|0;h[A>>3]=+h[k+(I<<3)>>3]+ +h[l+(I<<3)>>3];POa(233824,y,8)|0;I=c[58284]|0;F=I+1|0;c[58284]=F;}while((I|0)<(ca|0))}gPa()|0;U=53}if((U|0)==294){U=0;O=Ka*+V(+mb);ea=+h[29162]*Ja;na=O<=ea?O:ea;h[A>>3]=na;ea=+h[29156];O=na>=ea?na:ea;h[29192]=O;ea=O*O;h[29155]=ea;db=ea;U=62}else if((U|0)==309){U=0;if(!((fb|0)==-1)){break a}}do{if((U|0)==62){U=0;ea=+h[29203];if(db<=ea*.001){h[29196]=ea*.25;ca=c[b>>2]|0;c[58288]=1;if((ca|0)>=1){F=1;while(1){h[29159]=0.0;I=c[a>>2]|0;c[58284]=1;if((I|0)<1){pb=0.0}else{ea=0.0;K=1;while(1){O=+h[n+((fa(K,B)|0)+C+F<<3)>>3];qb=ea+O*+h[l+(K+ -1<<3)>>3];h[29159]=qb;if((K|0)<(I|0)){K=K+1|0;ea=qb}else{break}}c[58284]=I+1;pb=qb}h[29167]=+h[r+(F+ -1<<3)>>3]*pb;ea=pb- +h[29162]*+h[29203];h[29159]=ea;h[x+((c[b>>2]|0)+ -1+F<<3)>>3]=ea;K=c[a>>2]|0;c[58284]=1;if((K|0)>=1){X=1;while(1){Va=fa(X,B)|0;L=n+(Va+C+F<<3)|0;aa=X+ -1|0;$=p+(aa<<3)|0;h[$>>3]=+h[$>>3]+ +h[29167]*+h[L>>3];$=l+(aa<<3)|0;h[L>>3]=+h[L>>3]- +h[29162]*+h[$>>3];L=w+(aa<<3)|0;h[L>>3]=+h[s+(F+E+(fa(X,D)|0)<<3)>>3];ea=+h[29159]*+h[n+(F+C+Va<<3)>>3]+ +h[29196]*+h[$>>3];$=x+(aa<<3)|0;h[$>>3]=ea;aa=X+(c[b>>2]|0)|0;c[58296]=aa;c[58286]=1;if((X|0)<1){rb=X+1|0}else{O=ea;Va=1;while(1){da=s+((fa(Va,D)|0)+E+aa<<3)|0;J=Va+ -1|0;h[da>>3]=+h[da>>3]+ +h[L>>3]*+h[x+(J<<3)>>3]+O*+h[w+(J<<3)>>3];if((Va|0)>=(X|0)){break}O=+h[$>>3];Va=Va+1|0}Va=X+1|0;c[58286]=Va;rb=Va}c[58284]=rb;if((X|0)<(K|0)){X=rb}else{break}}}X=F+1|0;c[58288]=X;if((F|0)<(ca|0)){F=X}else{break}}}F=c[58348]|0;c[58288]=1;if((F|0)>=1){ca=1;while(1){h[29177]=0.0;X=c[b>>2]|0;c[58284]=1;b:do{if((X|0)>=1){O=0.0;K=1;while(1){I=t+(K+C+(fa(ca,B)|0)<<3)|0;h[29177]=+h[I>>3]+O;h[x+(K+ -1<<3)>>3]=+h[x+((c[b>>2]|0)+ -1+K<<3)>>3]*+h[I>>3];I=K+1|0;c[58284]=I;if((K|0)>=(X|0)){break b}O=+h[29177];K=I}}}while(0);X=c[a>>2]|0;c[58286]=1;if((X|0)>=1){K=1;while(1){I=K+ -1|0;O=+h[29196]*+h[29177]*+h[l+(I<<3)>>3];h[29159]=O;Va=c[b>>2]|0;c[58284]=1;if((Va|0)<1){sb=O}else{$=fa(K,B)|0;ea=O;L=1;while(1){tb=ea+ +h[x+(L+ -1<<3)>>3]*+h[n+(L+C+$<<3)>>3];h[29159]=tb;if((L|0)<(Va|0)){L=L+1|0;ea=tb}else{break}}c[58284]=Va+1;sb=tb}h[w+(I<<3)>>3]=sb;if((ca|0)<(c[58308]|0)){h[29159]=-+h[29159]}L=c[b>>2]|0;c[58284]=1;if((L|0)>=1){$=fa(ca,B)|0;aa=fa(K,D)|0;J=1;while(1){da=s+(J+E+aa<<3)|0;h[da>>3]=+h[29159]*+h[t+(J+C+$<<3)>>3]+ +h[da>>3];if((J|0)<(L|0)){J=J+1|0}else{break}}c[58284]=L+1}J=K+1|0;c[58286]=J;if((K|0)<(X|0)){K=J}else{break}}}K=c[a>>2]|0;c[58284]=1;if((K|0)>=1){X=c[58308]|0;J=1;while(1){$=(c[b>>2]|0)+J|0;c[58296]=$;ea=+h[w+(J+ -1<<3)>>3];if((ca|0)<(X|0)){ub=-ea}else{ub=ea}h[29167]=ub;c[58286]=1;if((J|0)<1){vb=J+1|0}else{ea=ub;aa=1;while(1){I=s+((fa(aa,D)|0)+E+$<<3)|0;h[I>>3]=ea*+h[w+(aa+ -1<<3)>>3]+ +h[I>>3];if((aa|0)>=(J|0)){break}ea=+h[29167];aa=aa+1|0}aa=J+1|0;c[58286]=aa;vb=aa}c[58284]=vb;if((J|0)<(K|0)){J=vb}else{break}}}J=ca+1|0;c[58288]=J;if((ca|0)<(F|0)){ca=J}else{break}}}c[58290]=0;ca=c[a>>2]|0;c[58286]=1;if((ca|0)>=1){F=0;J=1;while(1){K=J+ -1|0;X=x+(K<<3)|0;h[X>>3]=0.0;aa=c[b>>2]|0;c[58288]=1;if((aa|0)>=1){$=fa(J,B)|0;L=l+(K<<3)|0;I=$+C|0;ea=0.0;Va=1;while(1){h[X>>3]=ea+ +h[r+(Va+ -1<<3)>>3]*+h[n+(Va+C+$<<3)>>3];da=n+(I+Va<<3)|0;h[da>>3]=+h[da>>3]- +h[29162]*+h[L>>3];if((Va|0)>=(aa|0)){break}ea=+h[X>>3];Va=Va+1|0}c[58288]=aa+1}c[58284]=1;if((J|0)<1){wb=F}else{Va=1;L=F;while(1){I=L+1|0;c[58290]=I;$=(Va|0)<(J|0);da=q+(L<<3)|0;if($){Na=Va+ -1|0;G=l+(Na<<3)|0;xb=p+(K<<3)|0;h[xb>>3]=+h[xb>>3]+ +h[da>>3]*+h[G>>3];yb=G;zb=Na}else{Na=Va+ -1|0;yb=l+(Na<<3)|0;zb=Na}Na=l+(K<<3)|0;G=p+(zb<<3)|0;h[G>>3]=+h[da>>3]*+h[Na>>3]+ +h[G>>3];h[da>>3]=+h[da>>3]+ +h[x+(zb<<3)>>3]*+h[Na>>3]+ +h[yb>>3]*+h[X>>3];Na=(c[b>>2]|0)+E|0;h[s+(Na+Va+(fa(J,D)|0)<<3)>>3]=+h[s+(Na+J+(fa(Va,D)|0)<<3)>>3];Na=Va+1|0;c[58284]=Na;if($){Va=Na;L=I}else{wb=I;break}}}L=J+1|0;c[58286]=L;if((J|0)<(ca|0)){F=wb;J=L}else{break}}}J=c[a>>2]|0;c[58286]=1;if((J|0)>=1){F=1;while(1){ca=F+ -1|0;L=k+(ca<<3)|0;h[L>>3]=+h[l+(ca<<3)>>3]+ +h[L>>3];h[l+(F+ -1<<3)>>3]=0.0;if((F|0)<(J|0)){F=F+1|0}else{break}}c[58286]=J+1}h[29203]=0.0}if((c[58332]|0)>0){F=(c[58302]|0)+ -1|0;Sxa(a,b,l,n,s,t,233232,u,233328,233536,v,233456,w,w+(c[b>>2]<<3)|0,x,x+(F<<3)|0,x+(F+(c[a>>2]|0)<<3)|0)|0}F=c[b>>2]|0;c[58288]=1;if((F|0)>=1){L=1;while(1){h[29168]=0.0;h[29169]=0.0;h[29159]=0.0;ca=c[a>>2]|0;c[58286]=1;if((ca|0)<1){Ab=0.0;Bb=0.0}else{Va=L+C|0;X=L+E|0;ea=0.0;O=0.0;na=0.0;K=1;while(1){ba=+h[n+((fa(K,B)|0)+C+L<<3)>>3];Cb=na+ba*+h[v+(K+ -1<<3)>>3];h[29168]=Cb;ba=+h[n+(Va+(fa(K,B)|0)<<3)>>3];aa=K+ -1|0;Db=O+ba*+h[l+(aa<<3)>>3];h[29169]=Db;ba=+h[s+(X+(fa(K,D)|0)<<3)>>3];N=ea+ba*+h[v+(aa<<3)>>3];h[29159]=N;if((K|0)<(ca|0)){K=K+1|0;na=Cb;O=Db;ea=N}else{break}}c[58286]=ca+1;Ab=Db;Bb=Cb}K=L+ -1|0;h[x+(K<<3)>>3]=Bb*(Bb*+h[29162]+Ab);h[w+(K<<3)>>3]=+h[29159];K=L+1|0;c[58288]=K;if((L|0)<(F|0)){L=K}else{break}}}h[29163]=0.0;L=c[58348]|0;c[58288]=1;if((L|0)>=1){F=1;while(1){h[29159]=0.0;J=c[b>>2]|0;c[58284]=1;if((J|0)<1){Eb=0.0}else{ea=0.0;K=1;while(1){O=+h[t+(K+C+(fa(F,B)|0)<<3)>>3];Fb=ea+O*+h[x+(K+ -1<<3)>>3];h[29159]=Fb;if((K|0)<(J|0)){K=K+1|0;ea=Fb}else{break}}c[58284]=J+1;Eb=Fb}ea=Eb*Eb;O=+h[29163];if((F|0)<(c[58308]|0)){h[29163]=O+ea;na=-Eb;h[29159]=na;Gb=na}else{h[29163]=O-ea;Gb=Eb}K=c[b>>2]|0;c[58284]=1;if((K|0)>=1){ca=fa(F,B)|0;ea=Gb;X=1;while(1){Va=w+(X+ -1<<3)|0;h[Va>>3]=+h[Va>>3]+ea*+h[t+(X+C+ca<<3)>>3];if((X|0)>=(K|0)){break}ea=+h[29159];X=X+1|0}c[58284]=K+1}X=F+1|0;c[58288]=X;if((F|0)<(L|0)){F=X}else{break}}}h[29171]=0.0;h[29150]=0.0;F=c[a>>2]|0;c[58286]=1;if((F|0)<1){Hb=0.0;Ib=0.0}else{ea=0.0;L=1;while(1){h[29159]=0.0;X=c[b>>2]|0;c[58284]=1;if((X|0)<1){Jb=0.0}else{ca=fa(L,D)|0;O=0.0;J=1;while(1){Kb=O+ +h[x+(J+ -1<<3)>>3]*+h[s+(J+E+ca<<3)>>3];h[29159]=Kb;if((J|0)<(X|0)){J=J+1|0;O=Kb}else{break}}c[58284]=X+1;Jb=Kb}J=L+ -1|0;ca=v+(J<<3)|0;h[29171]=ea+Jb*+h[ca>>3];K=L+(c[b>>2]|0)|0;c[58298]=K;Va=c[a>>2]|0;c[58288]=1;if((Va|0)<1){Lb=Jb}else{O=Jb;aa=1;while(1){na=+h[s+((fa(aa,D)|0)+E+K<<3)>>3];Mb=O+na*+h[v+(aa+ -1<<3)>>3];h[29159]=Mb;if((aa|0)<(Va|0)){aa=aa+1|0;O=Mb}else{break}}c[58288]=Va+1;Lb=Mb}h[w+(K+ -1<<3)>>3]=Lb;O=+h[29171]+ +h[29159]*+h[ca>>3];h[29171]=O;na=+h[29150]+ +h[ca>>3]*+h[l+(J<<3)>>3];h[29150]=na;aa=L+1|0;c[58286]=aa;if((L|0)<(F|0)){ea=O;L=aa}else{Hb=O;Ib=na;break}}}ea=+h[29155];h[29163]=+h[29163]+(Ib*Ib+ea*(Ib+(Ib+ +h[29203])+ea*+h[29162]))-Hb;L=w+((c[58346]|0)+ -1<<3)|0;h[L>>3]=+h[29153]+ +h[L>>3];L=c[58332]|0;if((L|0)<=0){break}ea=+h[w+(L+ -1<<3)>>3];h[A>>3]=ea;na=+h[29153]+ +h[29182]*+h[29163]/(ea*ea);h[29167]=na;if(!(na>=0.0)){Nb=-na}else{Nb=na}if(!(Nb<=.8)){break}L=c[u>>2]|0;Rxa(a,b,l,n,s,t,233232,u,233384,233328,v,x,w,233304,m,x+(L<<3)|0,x+((L*6|1)+ -1<<3)|0)|0}}while(0);L=c[a>>2]|0;c[58284]=1;if((L|0)>=1){F=1;while(1){aa=F+ -1|0;h[m+(aa<<3)>>3]=+h[l+(aa<<3)>>3]+ +h[v+(aa<<3)>>3];aa=F+ -1|0;h[d+(aa<<3)>>3]=+h[k+(aa<<3)>>3]+ +h[m+(aa<<3)>>3];if((F|0)<(L|0)){F=F+1|0}else{break}}c[58284]=L+1}F=c[58292]|0;aa=F+1|0;c[58292]=aa;if((F|0)>=(c[58402]|0)){T=aa;U=159;break a}}}do{if((U|0)==159){c[58292]=T+ -1;if((c[g>>2]|0)<=0){break}yPa(233632)|0;gPa()|0}else if((U|0)==190){if((c[g>>2]|0)<=0){break}yPa(233680)|0;gPa()|0}}while(0);Nb=+h[29170];if(Nb<=+h[29141]){U=c[a>>2]|0;c[58284]=1;if((U|0)<1){Ob=Nb}else{T=1;while(1){m=T+ -1|0;h[d+(m<<3)>>3]=+h[k+(m<<3)>>3]+ +h[l+(m<<3)>>3];if((T|0)<(U|0)){T=T+1|0}else{break}}c[58284]=U+1;Ob=+h[29170]}h[29141]=Ob}if((c[g>>2]|0)<=0){i=z;return 0}yPa(233776)|0;POa(233824,233168,4)|0;gPa()|0;yPa(233800)|0;POa(233824,233128,8)|0;g=c[a>>2]|0;c[58284]=1;if((g|0)>=1){a=1;do{POa(233824,d+(a+ -1<<3)|0,8)|0;U=c[58284]|0;a=U+1|0;c[58284]=a;}while((U|0)<(g|0))}gPa()|0;i=z;return 0}function Bya(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0;g=i;j=c[e>>2]|0;e=~j;k=c[a>>2]|0;l=c[b>>2]|0;m=(k|0)>(l|0)?l:k;if((m|0)<2){n=k;o=l}else{l=0;k=2;while(1){if((k|0)>=2){B$a(d+(j+(fa(j,l)|0)<<3)|0,0,(l<<3)+8|0)|0}if((k|0)<(m|0)){l=l+1|0;k=k+1|0}else{break}}n=c[a>>2]|0;o=c[b>>2]|0}b=o+1|0;if((n|0)>=(b|0)&(o|0)<(n|0)){k=(n|0)<1;l=n<<3;p=0;q=b;while(1){b=fa(q,j)|0;if(!k){B$a(d+((fa(o+p|0,j)|0)<<3)|0,0,l|0)|0}h[d+(q+e+b<<3)>>3]=1.0;if((q|0)<(n|0)){p=p+1|0;q=q+1|0}else{break}}}if((m|0)<1){i=g;return 0}q=c[a>>2]|0;a=1;while(1){p=m-a|0;n=p+1|0;l=(p|0)<(q|0);o=fa(n,j)|0;if(l){k=o+e|0;b=n;while(1){r=d+(k+b<<3)|0;h[f+(b+ -1<<3)>>3]=+h[r>>3];h[r>>3]=0.0;if((b|0)<(q|0)){b=b+1|0}else{break}}}h[d+(n+e+o<<3)>>3]=1.0;b=f+(p<<3)|0;if(!(+h[b>>3]==0.0|l^1)){k=n;while(1){r=(fa(k,j)|0)+e|0;s=n;t=0.0;while(1){u=t+ +h[d+(r+s<<3)>>3]*+h[f+(s+ -1<<3)>>3];if((s|0)>=(q|0)){break}s=s+1|0;t=u}t=+h[b>>3];v=u/t;s=(fa(k,j)|0)+e|0;w=t;r=n;while(1){x=d+(s+r<<3)|0;h[x>>3]=+h[x>>3]-v*w;if((r|0)>=(q|0)){break}w=+h[f+(r<<3)>>3];r=r+1|0}if((k|0)<(q|0)){k=k+1|0}else{break}}}if((a|0)<(m|0)){a=a+1|0}else{break}}i=g;return 0}



function Hz(a,b,d,e,f,g,j,l,m,n,o,p){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=+g;j=+j;l=+l;m=+m;n=+n;o=+o;p=+p;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,W=0,X=0,Y=0,Z=0,_=0;q=i;i=i+128|0;r=q;s=q+24|0;t=q+48|0;u=q+72|0;v=q+96|0;w=q+120|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+16|0;C=d>=0.0;D=C?g:j;j=+U(+d);g=m*m*m*((C?e:f)/(D*D*l));l=j*g*2.0;f=g*2.0;g=l*.015625;e=f*.015625;do{if(g>n){if(!(l>=0.0)){E=c[63880]|0;F=A;h[k>>3]=l;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];F=E;E=v;G=20184;c[E+0>>2]=c[G+0>>2];c[E+4>>2]=c[G+4>>2];c[E+8>>2]=c[G+8>>2];c[E+12>>2]=c[G+12>>2];c[E+16>>2]=c[G+16>>2];c[E+20>>2]=c[G+20>>2];Oe[F&127](b,v,18984,A);F=c[63880]|0;G=z;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=F;F=u;E=20184;c[F+0>>2]=c[E+0>>2];c[F+4>>2]=c[E+4>>2];c[F+8>>2]=c[E+8>>2];c[F+12>>2]=c[E+12>>2];c[F+16>>2]=c[E+16>>2];c[F+20>>2]=c[E+20>>2];Oe[G&127](b,u,18984,z);}H=+V(+l);I=p*.27;J=I+2.51/H;if(!(J>0.0)){G=c[63880]|0;E=y;h[k>>3]=J;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=G;G=t;F=20184;c[G+0>>2]=c[F+0>>2];c[G+4>>2]=c[F+4>>2];c[G+8>>2]=c[F+8>>2];c[G+12>>2]=c[F+12>>2];c[G+16>>2]=c[F+16>>2];c[G+20>>2]=c[F+20>>2];Oe[E&127](b,t,19048,y);}K=H*+$a(+J)*-2.0;J=j*f;if(!(J>=0.0)){E=c[63880]|0;F=x;h[k>>3]=J;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];F=E;E=s;G=20184;c[E+0>>2]=c[G+0>>2];c[E+4>>2]=c[G+4>>2];c[E+8>>2]=c[G+8>>2];c[E+12>>2]=c[G+12>>2];c[E+16>>2]=c[G+16>>2];c[E+20>>2]=c[G+20>>2];Oe[F&127](b,s,19144,x);}H=+V(+J);J=I+2.51/H;if(!(J>0.0)){F=c[63880]|0;G=w;h[k>>3]=J;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=F;F=r;E=20184;c[F+0>>2]=c[E+0>>2];c[F+4>>2]=c[E+4>>2];c[F+8>>2]=c[E+8>>2];c[F+12>>2]=c[E+12>>2];c[F+16>>2]=c[E+16>>2];c[F+20>>2]=c[E+20>>2];Oe[G&127](b,r,19224,w);}I=(5.02/(j*J*2.0)- +da(+J)*(f/H))*.4342944819032518;if(!(K<o)){L=K;M=I;break}zz(B,b,l,n,o,p,d);L=+h[B>>3];M=+h[B+8>>3]}else{L=g;M=e}}while(0);if(C){N=L;O=D*N;P=O*m;Q=P*.7853981633974483;R=D*M;S=R*m;T=S*.7853981633974483;W=a;X=W;h[X>>3]=Q;Y=a;Z=Y+8|0;_=Z;h[_>>3]=T;i=q;return}N=-L;O=D*N;P=O*m;Q=P*.7853981633974483;R=D*M;S=R*m;T=S*.7853981633974483;W=a;X=W;h[X>>3]=Q;Y=a;Z=Y+8|0;_=Z;h[_>>3]=T;i=q;return}function Iz(a,b,d,e,f,g,j,l,m,n,o,p){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=+g;j=+j;l=+l;m=+m;n=+n;o=+o;p=+p;var q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0,H=0;q=i;i=i+32|0;r=q;s=q+24|0;t=i;i=i+8|0;o=n/m;if(!(o<=.0065)){u=.0065/o}else{u=1.0}n=+yd(+(+ca(+u)*745.0),+p);v=d>=0.0;u=v?e:f;f=v?g:j;j=+U(+d)/(f*m)*1.273239544735163;do{if(!(j<=n)){if(!(j>=p)){Jz(t,b,j,n,p,o);w=+h[t>>3];break}d=o/3.7+5.74/+W(+j,.9);if(!(d>0.0)){x=c[63880]|0;y=s;h[k>>3]=d;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];y=x;x=r;z=20184;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Oe[y&127](b,r,19304,s);}g=j/+$a(+d);w=g*g*.25}else{w=j*64.0}}while(0);j=f*f;f=+Nxa(m,-3);if(v){A=w;B=A/u;C=f*B;D=j*C;E=D*l;F=E*.5;G=a;H=G;h[H>>3]=F;i=q;return}A=-w;B=A/u;C=f*B;D=j*C;E=D*l;F=E*.5;G=a;H=G;h[H>>3]=F;i=q;return}function Jz(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=+g;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,X=0,Y=0;j=i;i=i+224|0;l=j;m=j+24|0;n=j+48|0;o=j+72|0;p=j+96|0;q=j+120|0;r=j+144|0;s=j+168|0;t=j+192|0;u=j+216|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;if(!(e>0.0)){D=c[63880]|0;E=C;h[k>>3]=e;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D;D=t;F=20184;c[D+0>>2]=c[F+0>>2];c[D+4>>2]=c[F+4>>2];c[D+8>>2]=c[F+8>>2];c[D+12>>2]=c[F+12>>2];c[D+16>>2]=c[F+16>>2];c[D+20>>2]=c[F+20>>2];Oe[E&127](b,t,18536,C);}G=+$a(+e);H=e*64.0;if(!(H>0.0)){C=c[63880]|0;t=B;h[k>>3]=H;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];t=C;C=s;E=20184;c[C+0>>2]=c[E+0>>2];c[C+4>>2]=c[E+4>>2];c[C+8>>2]=c[E+8>>2];c[C+12>>2]=c[E+12>>2];c[C+16>>2]=c[E+16>>2];c[C+20>>2]=c[E+20>>2];Oe[t&127](b,s,18472,B);}I=+$a(+H);H=+W(+f,.9);J=g/3.7+5.74/H;if(!(J>0.0)){B=c[63880]|0;s=A;h[k>>3]=J;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=B;B=r;t=20184;c[B+0>>2]=c[t+0>>2];c[B+4>>2]=c[t+4>>2];c[B+8>>2]=c[t+8>>2];c[B+12>>2]=c[t+12>>2];c[B+16>>2]=c[t+16>>2];c[B+20>>2]=c[t+20>>2];Oe[s&127](b,r,18600,A);}K=+$a(+J);L=f/K;M=L*L*.25;A=M>=0.0;if(!A){r=c[63880]|0;s=z;h[k>>3]=M;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=r;r=q;t=20184;c[r+0>>2]=c[t+0>>2];c[r+4>>2]=c[t+4>>2];c[r+8>>2]=c[t+8>>2];c[r+12>>2]=c[t+12>>2];c[r+16>>2]=c[t+16>>2];c[r+20>>2]=c[t+20>>2];Oe[s&127](b,q,18664,z);}L=g*.27+2.51/+V(+M);if(!A){A=c[63880]|0;z=y;h[k>>3]=M;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=A;A=p;q=20184;c[A+0>>2]=c[q+0>>2];c[A+4>>2]=c[q+4>>2];c[A+8>>2]=c[q+8>>2];c[A+12>>2]=c[q+12>>2];c[A+16>>2]=c[q+16>>2];c[A+20>>2]=c[q+20>>2];Oe[z&127](b,p,18664,y);}if(!(L>0.0)){y=c[63880]|0;p=x;h[k>>3]=L;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=y;y=o;z=20184;c[y+0>>2]=c[z+0>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];c[y+12>>2]=c[z+12>>2];c[y+16>>2]=c[z+16>>2];c[y+20>>2]=c[z+20>>2];Oe[p&127](b,o,18720,x);}+$a(+L);if(!(f>0.0)){x=c[63880]|0;o=w;h[k>>3]=f;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=x;x=n;p=20184;c[x+0>>2]=c[p+0>>2];c[x+4>>2]=c[p+4>>2];c[x+8>>2]=c[p+8>>2];c[x+12>>2]=c[p+12>>2];c[x+16>>2]=c[p+16>>2];c[x+20>>2]=c[p+20>>2];Oe[o&127](b,n,19392,w);}L=+$a(+f);if(!(M>0.0)){w=c[63880]|0;n=v;h[k>>3]=M;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=w;w=m;o=20184;c[w+0>>2]=c[o+0>>2];c[w+4>>2]=c[o+4>>2];c[w+8>>2]=c[o+8>>2];c[w+12>>2]=c[o+12>>2];c[w+16>>2]=c[o+16>>2];c[w+20>>2]=c[o+20>>2];Oe[n&127](b,m,18784,v);}f=1.121782646756099/(H*J*K)*4.0+2.0;K=L-G;G=(+$a(+M)-I)/K;I=(G*3.0+(-2.0-f))/K;M=(f+G*-2.0+1.0)/(K*K);K=d/e;if(K>0.0){N=+$a(+K);O=M*N;P=I+O;Q=N*P;R=Q+1.0;S=+W(+K,+R);T=S*e;U=T*64.0;X=a;Y=X;h[Y>>3]=U;i=j;return}v=c[63880]|0;m=u;h[k>>3]=K;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=v;v=l;n=20184;c[v+0>>2]=c[n+0>>2];c[v+4>>2]=c[n+4>>2];c[v+8>>2]=c[n+8>>2];c[v+12>>2]=c[n+12>>2];c[v+16>>2]=c[n+16>>2];c[v+20>>2]=c[n+20>>2];Oe[m&127](b,l,19456,u);N=+$a(+K);O=M*N;P=I+O;Q=N*P;R=Q+1.0;S=+W(+K,+R);T=S*e;U=T*64.0;X=a;Y=X;h[Y>>3]=U;i=j;return}function Kz(a,b,c,d,e,f,g,j,k,l,m,n,o){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;g=+g;j=+j;k=+k;l=+l;m=+m;n=+n;o=+o;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0;p=i;i=i+112|0;q=p;r=p+16|0;s=p+32|0;t=p+48|0;u=p+64|0;v=p+80|0;w=p+96|0;x=m/k;if(!(x<=.0065)){y=.0065/x}else{y=1.0}m=+yd(+(+W(+(+ca(+y)*745.0),.97)),+o);y=d*l;z=e*l;l=(y+z)*.5;A=+zd(+y,+z)+n;B=+yd(+y,+z)-n;if(A<=c){Hz(q,b,c-y,d,e,f,g,j,k,m,o,x);C=+h[q>>3];D=a;E=D;h[E>>3]=C;i=p;return}if(B>=c){Hz(r,b,c-z,d,e,f,g,j,k,m,o,x);C=+h[r>>3];D=a;E=D;h[E>>3]=C;i=p;return}Hz(s,b,A-y,d,e,f,g,j,k,m,o,x);y=+h[s>>3];n=+h[s+8>>3];Hz(t,b,B-z,d,e,f,g,j,k,m,o,x);x=+h[t>>3];o=+h[t+8>>3];Lz(u,b,l,B,A,x,y,o,n);m=+h[u+8>>3];if(l<c){Lz(v,b,c,l,A,0.0,y,m,n);C=+h[v>>3];D=a;E=D;h[E>>3]=C;i=p;return}else{Lz(w,b,c,B,l,x,0.0,o,m);C=+h[w>>3];D=a;E=D;h[E>>3]=C;i=p;return}}function Lz(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=+g;j=+j;k=+k;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,V=0.0,W=0.0,X=0.0,Y=0.0;m=i;i=i+56|0;n=m;o=m+24|0;p=m+48|0;q=i;i=i+8|0;if(!(e<f)){r=Owa(Owa(20880,Mwa(e,0,1,6)|0)|0,20936)|0;s=Owa(Owa(r,Mwa(f,0,1,6)|0)|0,20952)|0;r=c[63880]|0;t=o;u=20984;c[t+0>>2]=c[u+0>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];c[t+12>>2]=c[u+12>>2];c[t+16>>2]=c[u+16>>2];c[t+20>>2]=c[u+20>>2];Oe[r&127](b,o,s,q);}do{if(!(k*l>=0.0)){if(+U(+k)<1.0e-15){break}if(+U(+l)<1.0e-15){break}q=Owa(Owa(21008,Mwa(k,0,1,6)|0)|0,21184)|0;s=Owa(Owa(q,Mwa(l,0,1,6)|0)|0,21200)|0;q=c[63880]|0;o=n;r=21232;c[o+0>>2]=c[r+0>>2];c[o+4>>2]=c[r+4>>2];c[o+8>>2]=c[r+8>>2];c[o+12>>2]=c[r+12>>2];c[o+16>>2]=c[r+16>>2];c[o+20>>2]=c[r+20>>2];Oe[q&127](b,n,s,p);}}while(0);v=f-e;w=(j-g)/v;x=+U(+w);if(w==0.0){y=0.0;z=(d-e)*w+g;A=a;B=A;h[B>>3]=z;C=a;D=C+8|0;E=D;h[E>>3]=y;i=m;return}F=w*-2.0;G=F+k+l;if(+U(+G)<1.0e-13){H=d-e;I=k*-2.0;J=w*3.0;K=F+l+k;L=((e+f)*.5-e)/v;y=K*L*L*3.0+((I+(J-l))*L*2.0+k);z=H*(H*((I+(J+(H*(K/v)-l)))/v)+k)+g;A=a;B=A;h[B>>3]=z;C=a;D=C+8|0;E=D;h[E>>3]=y;i=m;return}K=v*k;H=-l;J=((k+l)*e*-3.0+(w*e*6.0+(K*-2.0+(v*w*3.0-v*l))))/(H-k+w*2.0)*.3333333333333333;I=J-e;L=f-J;J=I/v;M=F+l+k;F=k*-2.0;N=w*3.0;O=F+(N-l);P=M*J*J*3.0+(O*J*2.0+k);if(w>0.0){Q=1.0}else{Q=+(w<0.0|0)}J=Q*+yd(+(+U(+P)),+x)*.25;do{if(!(+U(+(k-l))<=1.0e-13)){R=(k*H+(-(l*l)-k*k)+w*(w*-1.5+k+l)*6.0)/(G*3.0);S=0}else{if(!(K+g<j)){R=k;S=0;break}R=k;S=1}}while(0);if(I>0.0&L<v){if(!(w*P<=0.0)){T=19}else{T=22}}else{T=19}do{if((T|0)==19){P=+U(+J);K=+U(+R);if(P<K){if(w*R>=0.0){T=22;break}}if(P<+U(+(w*.1))&S<<24>>24==0){V=K;W=P}else{T=34}}}while(0);do{if((T|0)==22){if(!(S<<24>>24==0)){T=34;break}V=+U(+R);W=+U(+J)}}while(0);if((T|0)==34){P=d-e;K=((e+f)*.5-e)/v;y=M*K*K*3.0+(O*K*2.0+k);z=P*(P*((F+(N+(P*(M/v)-l)))/v)+k)+g;A=a;B=A;h[B>>3]=z;C=a;D=C+8|0;E=D;h[E>>3]=y;i=m;return}do{if(W<V){if(!(w*R>=0.0)){X=J;break}X=R}else{X=J}}while(0);J=w*.1;T=+U(+X)<+U(+J);R=T?J:X;X=(I*k+L*l)/v;if(+U(+(X-R))<1.0e-6){Y=X*.999999}else{Y=R}R=(w-Y)/(X-Y)*3.0;X=I*R;I=L*R;R=X+e;L=f-I;w=(k-Y)/+zd(+(X*X),1.0e-13);X=(l-Y)/+zd(+(I*I),1.0e-13);I=e-R;l=w*I*I*I*-.3333333333333333-Y*e+g;g=f-L;if(R>d){e=d-R;y=Y;z=w*e*e*e*.3333333333333333+(Y*d+l);A=a;B=A;h[B>>3]=z;C=a;D=C+8|0;E=D;h[E>>3]=y;i=m;return}if(L>d){y=Y;z=Y*d+l;A=a;B=A;h[B>>3]=z;C=a;D=C+8|0;E=D;h[E>>3]=y;i=m;return}else{l=d-L;y=Y;z=X*l*l*l*.3333333333333333+(Y*d+(X*g*g*g*-.3333333333333333-Y*f+j));A=a;B=A;h[B>>3]=z;C=a;D=C+8|0;E=D;h[E>>3]=y;i=m;return}}function Mz(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0;b=i;i=i+8|0;e=b;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+16|0;w=1.0-d/647.096;c[t>>2]=6;bxa(u,1,t);t=u;x=19520;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];c[s>>2]=6;bxa(v,1,s);s=v;x=19536;c[s+0>>2]=c[x+0>>2];c[s+4>>2]=c[x+4>>2];c[s+8>>2]=c[x+8>>2];c[r>>2]=1;y=+h[(hxa(u,1,r)|0)>>3];c[q>>2]=1;z=y*+W(+w,+(+h[(hxa(v,1,q)|0)>>3]));c[p>>2]=2;y=+h[(hxa(u,1,p)|0)>>3];c[o>>2]=2;A=y*+W(+w,+(+h[(hxa(v,1,o)|0)>>3]));c[n>>2]=3;y=+h[(hxa(u,1,n)|0)>>3];c[m>>2]=3;B=y*+W(+w,+(+h[(hxa(v,1,m)|0)>>3]));c[l>>2]=4;y=+h[(hxa(u,1,l)|0)>>3];c[k>>2]=4;C=y*+W(+w,+(+h[(hxa(v,1,k)|0)>>3]));c[j>>2]=5;y=+h[(hxa(u,1,j)|0)>>3];c[g>>2]=5;D=y*+W(+w,+(+h[(hxa(v,1,g)|0)>>3]));c[f>>2]=6;y=+h[(hxa(u,1,f)|0)>>3];c[e>>2]=6;h[a>>3]=+ca(+(647.096/d*(z+(A+(B+(C+(D+y*+W(+w,+(+h[(hxa(v,1,e)|0)>>3])))))))))*22064.0e3;i=b;return}function Nz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0.0;e=i;i=i+120|0;f=e;g=e+32|0;j=e+64|0;k=e+96|0;l=e+104|0;m=e+112|0;n=j;o=d;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];c[n+12>>2]=c[o+12>>2];c[n+16>>2]=c[o+16>>2];c[n+20>>2]=c[o+20>>2];c[n+24>>2]=c[o+24>>2];c[n+28>>2]=c[o+28>>2];Oz(k,b,j);p=+h[k>>3];k=g;j=d;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];c[k+12>>2]=c[j+12>>2];c[k+16>>2]=c[j+16>>2];c[k+20>>2]=c[j+20>>2];c[k+24>>2]=c[j+24>>2];c[k+28>>2]=c[j+28>>2];Pz(l,b,g);q=+h[l>>3];l=f;g=d;c[l+0>>2]=c[g+0>>2];c[l+4>>2]=c[g+4>>2];c[l+8>>2]=c[g+8>>2];c[l+12>>2]=c[g+12>>2];c[l+16>>2]=c[g+16>>2];c[l+20>>2]=c[g+20>>2];c[l+24>>2]=c[g+24>>2];c[l+28>>2]=c[g+28>>2];Qz(m,b,f);h[a>>3]=p*(q/+h[m>>3]);i=e;return}function Oz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0;e=i;i=i+48|0;f=e;g=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;Dz(g,0,123.15);m=+h[g>>3];Dz(j,0,1273.15);n=+h[j>>3];Dz(k,0,+h[d+8>>3]);o=+h[k>>3];k=f;d=18968;c[k+0>>2]=c[d+0>>2];c[k+4>>2]=c[d+4>>2];c[k+8>>2]=c[d+8>>2];Ez(l,b,f,m,n,o);h[a>>3]=+h[l>>3]*1.0e-6;i=e;return}function Pz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0.0,q=0.0;e=i;i=i+40|0;f=e;g=e+16|0;j=e+32|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+16|0;o=d+16|0;c[m>>2]=1;p=+h[(hxa(o,1,m)|0)>>3];c[l>>2]=2;q=+h[(hxa(o,1,l)|0)>>3];l=j;h[k>>3]=q;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];gxa(n,2,p,j);p=+h[d>>3];q=+h[d+8>>3];d=a;a=g;j=n;c[a+0>>2]=c[j+0>>2];c[a+4>>2]=c[j+4>>2];c[a+8>>2]=c[j+8>>2];j=f;a=19856;c[j+0>>2]=c[a+0>>2];c[j+4>>2]=c[a+4>>2];c[j+8>>2]=c[a+8>>2];Xz(d,b,p,q,g,0.0,1.0,f);i=e;return}function Qz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0;e=i;i=i+48|0;f=e;g=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;Dz(g,0,123.15);m=+h[g>>3];Dz(j,0,1273.15);n=+h[j>>3];Dz(k,0,+h[d+8>>3]);o=+h[k>>3];k=f;d=19872;c[k+0>>2]=c[d+0>>2];c[k+4>>2]=c[d+4>>2];c[k+8>>2]=c[d+8>>2];Ez(l,b,f,m,n,o);h[a>>3]=+h[l>>3]*.001;i=e;return}function Rz(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;var g=0.0,j=0.0;b=i;g=e/f;f=g*1.570796326794897;do{if(!(g<=-.999999999)){if(g>=.999999999){j=1.0;break}j=+ub(+(+Z(+f)))*.5+.5}else{j=0.0}}while(0);h[a>>3]=j*c+(1.0-j)*d;i=b;return}function Sz(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=+f;var g=0,j=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0,u=0,v=0,w=0;g=i;i=i+32|0;j=g;l=g+24|0;m=+zd(+d,+e);n=+ca(+((d-m)/f*4.0))+ +ca(+((e-m)/f*4.0));if(n>0.0){o=+da(+n);p=o*f;q=p*.25;r=m+q;s=a;t=s;h[t>>3]=r;i=g;return}u=c[63880]|0;v=l;h[k>>3]=n;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];v=u;u=j;w=20184;c[u+0>>2]=c[w+0>>2];c[u+4>>2]=c[w+4>>2];c[u+8>>2]=c[w+8>>2];c[u+12>>2]=c[w+12>>2];c[u+16>>2]=c[w+16>>2];c[u+20>>2]=c[w+20>>2];Oe[v&127](b,j,19552,l);o=+da(+n);p=o*f;q=p*.25;r=m+q;s=a;t=s;h[t>>3]=r;i=g;return}function Tz(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=+g;j=+j;l=+l;var m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0.0;m=i;i=i+32|0;n=m;o=m+24|0;p=+zd(+d,+e);q=d-p;r=+ca(+(q/f*4.0));s=e-p;p=+ca(+(s/f*4.0));t=r+p;if(!(t>0.0)){u=c[63880]|0;v=o;h[k>>3]=t;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];v=u;u=n;w=20184;c[u+0>>2]=c[w+0>>2];c[u+4>>2]=c[w+4>>2];c[u+8>>2]=c[w+8>>2];c[u+12>>2]=c[w+12>>2];c[u+16>>2]=c[w+16>>2];c[u+20>>2]=c[w+20>>2];Oe[v&127](b,n,19552,o);}x=d>e?g:j;e=l/(f*f);h[a>>3]=x+(+da(+t)*l+f/t*(r*((g-x)/f-q*e)+p*((j-x)/f-s*e))*4.0)*.25;i=m;return}function Uz(a,b,c,d,e,f,g,j,k,l){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;g=+g;j=+j;k=+k;l=+l;var m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0;b=i;m=e/f;e=m*1.570796326794897;n=(k-m*l)/f;do{if(!(m<=-.99999999999)){if(m>=.9999999999){o=1.0;break}o=+ub(+(+Z(+e)))*.5+.5}else{o=0.0}}while(0);f=o*g+(1.0-o)*j;if(!(+U(+m)<1.0)){p=f;q=a;r=q;h[r>>3]=p;i=b;return}m=+vd(+(+Z(+e)))*+X(+e);p=f+(c-d)*(n/(m*m))*.7853981633974483;q=a;r=q;h[r>>3]=p;i=b;return}function Vz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0;b=i;i=i+40|0;e=b;f=b+32|0;g=e;j=d;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];c[g+24>>2]=c[j+24>>2];c[g+28>>2]=c[j+28>>2];Wz(f,0,e);h[a>>3]=+h[d>>3]/(+h[f>>3]*+h[d+8>>3]);i=b;return}function Wz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0;b=i;i=i+8|0;e=b;f=i;i=i+8|0;g=d+16|0;c[f>>2]=1;j=(1.0- +h[(hxa(g,1,f)|0)>>3])*287.0512249529787;c[e>>2]=1;h[a>>3]=j+ +h[(hxa(g,1,e)|0)>>3]*461.5233290850878;i=b;return}function Xz(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=+g;j=+j;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0;l=i;i=i+392|0;m=l;n=l+96|0;o=l+192|0;p=l+288|0;q=l+384|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+96|0;A=i;i=i+96|0;B=i;i=i+96|0;C=i;i=i+96|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;Yz(D,b,e);N=+h[D>>3];O=d-N;d=N/+zd(1.0e-13,+O)*.6219647130774989;c[y>>2]=1;P=+yd(+(d*(1.0- +h[(hxa(f,1,y)|0)>>3])),1.0);c[x>>2]=1;Sz(E,b,+h[(hxa(f,1,x)|0)>>3]-P,0.0,1.0e-5);Q=+h[E>>3];c[w>>2]=1;R=+h[(hxa(f,1,w)|0)>>3]-Q;c[v>>2]=1;S=1.0- +h[(hxa(f,1,v)|0)>>3];c[u>>2]=1;T=+h[(hxa(k,1,u)|0)>>3];Zz(F,b,e,j);U=+h[F>>3];c[t>>2]=1;V=+h[(hxa(f,1,t)|0)>>3]-P;c[s>>2]=1;P=(d+1.0)*+h[(hxa(k,1,s)|0)>>3];c[r>>2]=1;Tz(G,b,V,0.0,1.0e-5,P-(U-N*((g-U)/O))/O*.6219647130774989*(1.0- +h[(hxa(f,1,r)|0)>>3]),0.0,0.0);O=+h[G>>3];c[q>>2]=1;U=+h[(hxa(k,1,q)|0)>>3]-O;c[z>>2]=19680;h[z+8>>3]=.01801528;h[z+16>>3]=-13423382.81725291;h[z+24>>3]=549760.6476280135;h[z+32>>3]=1.0e3;q=z+40|0;k=19688;c[q+0>>2]=c[k+0>>2];c[q+4>>2]=c[k+4>>2];c[q+8>>2]=c[k+8>>2];k=z+52|0;q=19704;c[k+0>>2]=c[q+0>>2];c[k+4>>2]=c[q+4>>2];c[k+8>>2]=c[q+8>>2];q=z+64|0;k=19720;c[q+0>>2]=c[k+0>>2];c[q+4>>2]=c[k+4>>2];c[q+8>>2]=c[k+8>>2];k=z+76|0;q=19736;c[k+0>>2]=c[q+0>>2];c[k+4>>2]=c[q+4>>2];c[k+8>>2]=c[q+8>>2];h[z+88>>3]=461.5233290850878;q=p+0|0;k=z+0|0;z=q+96|0;do{c[q>>2]=c[k>>2];q=q+4|0;k=k+4|0}while((q|0)<(z|0));_z(H,b,p,e,0,0,0.0,j);g=+h[H>>3];c[A>>2]=19680;h[A+8>>3]=.01801528;h[A+16>>3]=-13423382.81725291;h[A+24>>3]=549760.6476280135;h[A+32>>3]=1.0e3;H=A+40|0;p=19688;c[H+0>>2]=c[p+0>>2];c[H+4>>2]=c[p+4>>2];c[H+8>>2]=c[p+8>>2];p=A+52|0;H=19704;c[p+0>>2]=c[H+0>>2];c[p+4>>2]=c[H+4>>2];c[p+8>>2]=c[H+8>>2];H=A+64|0;p=19720;c[H+0>>2]=c[p+0>>2];c[H+4>>2]=c[p+4>>2];c[H+8>>2]=c[p+8>>2];p=A+76|0;H=19736;c[p+0>>2]=c[H+0>>2];c[p+4>>2]=c[H+4>>2];c[p+8>>2]=c[H+8>>2];h[A+88>>3]=461.5233290850878;q=o+0|0;k=A+0|0;z=q+96|0;do{c[q>>2]=c[k>>2];q=q+4|0;k=k+4|0}while((q|0)<(z|0));$z(I,b,o,e,1,3,2547494.319);N=+h[I>>3];c[B>>2]=19752;h[B+8>>3]=.0289651159;h[B+16>>3]=-4333.833858403446;h[B+24>>3]=298609.6803431054;h[B+32>>3]=1.0e3;I=B+40|0;o=19760;c[I+0>>2]=c[o+0>>2];c[I+4>>2]=c[o+4>>2];c[I+8>>2]=c[o+8>>2];o=B+52|0;I=19776;c[o+0>>2]=c[I+0>>2];c[o+4>>2]=c[I+4>>2];c[o+8>>2]=c[I+8>>2];I=B+64|0;o=19792;c[I+0>>2]=c[o+0>>2];c[I+4>>2]=c[o+4>>2];c[I+8>>2]=c[o+8>>2];o=B+76|0;I=19808;c[o+0>>2]=c[I+0>>2];c[o+4>>2]=c[I+4>>2];c[o+8>>2]=c[I+8>>2];h[B+88>>3]=287.0512249529787;q=n+0|0;k=B+0|0;z=q+96|0;do{c[q>>2]=c[k>>2];q=q+4|0;k=k+4|0}while((q|0)<(z|0));_z(J,b,n,e,0,0,0.0,j);P=+h[J>>3];c[C>>2]=19752;h[C+8>>3]=.0289651159;h[C+16>>3]=-4333.833858403446;h[C+24>>3]=298609.6803431054;h[C+32>>3]=1.0e3;J=C+40|0;n=19760;c[J+0>>2]=c[n+0>>2];c[J+4>>2]=c[n+4>>2];c[J+8>>2]=c[n+8>>2];n=C+52|0;J=19776;c[n+0>>2]=c[J+0>>2];c[n+4>>2]=c[J+4>>2];c[n+8>>2]=c[J+8>>2];J=C+64|0;n=19792;c[J+0>>2]=c[n+0>>2];c[J+4>>2]=c[n+4>>2];c[J+8>>2]=c[n+8>>2];n=C+76|0;J=19808;c[n+0>>2]=c[J+0>>2];c[n+4>>2]=c[J+4>>2];c[n+8>>2]=c[J+8>>2];h[C+88>>3]=287.0512249529787;q=m+0|0;k=C+0|0;z=q+96|0;do{c[q>>2]=c[k>>2];q=q+4|0;k=k+4|0}while((q|0)<(z|0));$z(K,b,m,e,1,3,25104.684);V=+h[K>>3];aA(L,0,e,j);j=+h[L>>3];bA(M,0,e);h[a>>3]=R*g+(U*N+(S*P+(Q*j+O*+h[M>>3]-T*V)));i=l;return}function Yz(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0.0;b=i;i=i+16|0;d=b;e=b+8|0;Mz(d,0,c);f=+h[d>>3];cA(e,0,c);Rz(a,0,f,+h[e>>3],c+-273.16,1.0);i=b;return}function Zz(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0;b=i;i=i+32|0;e=b;f=b+8|0;g=b+16|0;j=b+24|0;Mz(e,0,c);k=+h[e>>3];cA(f,0,c);l=+h[f>>3];dA(g,0,c,d);m=+h[g>>3];eA(j,0,c,d);Uz(a,0,k,l,c+-273.16,1.0,m,+h[j>>3],d,0.0);i=b;return}function _z(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=+e;f=f|0;g=g|0;j=+j;k=+k;var l=0,m=0;g=i;i=i+104|0;f=g;b=g+96|0;l=f+0|0;m=d+0|0;d=l+96|0;do{c[l>>2]=c[m>>2];l=l+4|0;m=m+4|0}while((l|0)<(d|0));LA(b,0,f,e);h[a>>3]=+h[b>>3]*k;i=g;return}function $z(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=+e;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0,P=0;l=i;i=i+32|0;m=l;n=l+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;if(!(e>0.0)){w=c[63880]|0;x=v;h[k>>3]=e;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];x=w;w=m;y=20184;c[w+0>>2]=c[y+0>>2];c[w+4>>2]=c[y+4>>2];c[w+8>>2]=c[y+8>>2];c[w+12>>2]=c[y+12>>2];c[w+16>>2]=c[y+16>>2];c[w+20>>2]=c[y+20>>2];Oe[x&127](b,m,20208,v);}z=+h[d+88>>3];c[u>>2]=1;A=+h[(hxa(d+52|0,1,u)|0)>>3];u=d+40|0;c[t>>2]=2;B=+h[(hxa(u,1,t)|0)>>3]*+da(+e);c[s>>2]=3;C=+h[(hxa(u,1,s)|0)>>3];c[r>>2]=4;D=+h[(hxa(u,1,r)|0)>>3]*.5;c[q>>2]=5;E=+h[(hxa(u,1,q)|0)>>3]*.3333333333333333;c[p>>2]=6;F=+h[(hxa(u,1,p)|0)>>3]*.25;c[o>>2]=7;G=(A+(B+(C+(D+(E+(F+ +h[(hxa(u,1,o)|0)>>3]*e*.2)*e)*e)*e)*e))*e;c[n>>2]=1;F=z*((G- +h[(hxa(u,1,n)|0)>>3])/e);if(f<<24>>24==0){H=0.0}else{H=-+h[d+16>>3]}if((g|0)!=1){I=0.0;J=(g|0)==3;K=J?j:0.0;L=K+I;M=H+L;N=F+M;O=a;P=O;h[P>>3]=N;i=l;return}I=+h[d+24>>3];J=(g|0)==3;K=J?j:0.0;L=K+I;M=H+L;N=F+M;O=a;P=O;h[P>>3]=N;i=l;return}function aA(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0.0;b=i;e=c+-273.15;Uz(a,0,e*4200.0,e*2050.0+-333.0e3,c+-273.16,.1,d*4200.0,d*2050.0,d,0.0);i=b;return}function bA(a,b,c){a=a|0;b=b|0;c=+c;var d=0.0;b=i;d=c+-273.15;Rz(a,0,d*4200.0,d*2050.0+-333.0e3,c+-273.16,.1);i=b;return}function cA(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0.0,t=0.0,u=0.0;b=i;i=i+8|0;e=b;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+16|0;q=d/273.16;c[n>>2]=2;bxa(o,1,n);n=o;r=19824;c[n+0>>2]=c[r+0>>2];c[n+4>>2]=c[r+4>>2];c[n+8>>2]=c[r+8>>2];c[m>>2]=2;bxa(p,1,m);m=p;r=19840;c[m+0>>2]=c[r+0>>2];c[m+4>>2]=c[r+4>>2];c[m+8>>2]=c[r+8>>2];c[l>>2]=1;d=+h[(hxa(o,1,l)|0)>>3];c[k>>2]=2;s=+h[(hxa(o,1,k)|0)>>3];c[j>>2]=1;t=+h[(hxa(o,1,j)|0)>>3];c[g>>2]=1;u=-(t*+W(+q,+(+h[(hxa(p,1,g)|0)>>3])));c[f>>2]=2;t=+h[(hxa(o,1,f)|0)>>3];c[e>>2]=2;h[a>>3]=+ca(+(d+(s+(u-t*+W(+q,+(+h[(hxa(p,1,e)|0)>>3]))))))*611.657;i=b;return}function dA(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0,S=0.0,T=0.0,U=0.0,V=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+16|0;O=i;i=i+16|0;P=1.0-d/647.096;Q=-e/647.096;c[M>>2]=6;bxa(N,1,M);M=N;R=19520;c[M+0>>2]=c[R+0>>2];c[M+4>>2]=c[R+4>>2];c[M+8>>2]=c[R+8>>2];c[L>>2]=6;bxa(O,1,L);L=O;R=19536;c[L+0>>2]=c[R+0>>2];c[L+4>>2]=c[R+4>>2];c[L+8>>2]=c[R+8>>2];c[K>>2]=1;S=+h[(hxa(N,1,K)|0)>>3];c[J>>2]=1;T=S*+W(+P,+(+h[(hxa(O,1,J)|0)>>3]));c[I>>2]=2;S=+h[(hxa(N,1,I)|0)>>3];c[H>>2]=2;U=S*+W(+P,+(+h[(hxa(O,1,H)|0)>>3]));c[G>>2]=3;S=+h[(hxa(N,1,G)|0)>>3];c[F>>2]=3;V=S*+W(+P,+(+h[(hxa(O,1,F)|0)>>3]));c[E>>2]=4;S=+h[(hxa(N,1,E)|0)>>3];c[D>>2]=4;X=S*+W(+P,+(+h[(hxa(O,1,D)|0)>>3]));c[C>>2]=5;S=+h[(hxa(N,1,C)|0)>>3];c[B>>2]=5;Y=S*+W(+P,+(+h[(hxa(O,1,B)|0)>>3]));c[A>>2]=6;S=+h[(hxa(N,1,A)|0)>>3];c[z>>2]=6;Z=T+(U+(V+(X+(Y+S*+W(+P,+(+h[(hxa(O,1,z)|0)>>3]))))));S=647.096/d;Y=+ca(+(S*Z));c[y>>2]=1;X=+h[(hxa(N,1,y)|0)>>3];c[x>>2]=1;V=+W(+P,+(+h[(hxa(O,1,x)|0)>>3]+-1.0));c[w>>2]=1;U=X*V*Q*+h[(hxa(O,1,w)|0)>>3];c[v>>2]=2;V=+h[(hxa(N,1,v)|0)>>3];c[u>>2]=2;X=+W(+P,+(+h[(hxa(O,1,u)|0)>>3]+-1.0));c[t>>2]=2;T=V*X*Q*+h[(hxa(O,1,t)|0)>>3];c[s>>2]=3;X=+h[(hxa(N,1,s)|0)>>3];c[r>>2]=3;V=+W(+P,+(+h[(hxa(O,1,r)|0)>>3]+-1.0));c[q>>2]=3;_=X*V*Q*+h[(hxa(O,1,q)|0)>>3];c[p>>2]=4;V=+h[(hxa(N,1,p)|0)>>3];c[o>>2]=4;X=+W(+P,+(+h[(hxa(O,1,o)|0)>>3]+-1.0));c[n>>2]=4;$=V*X*Q*+h[(hxa(O,1,n)|0)>>3];c[m>>2]=5;X=+h[(hxa(N,1,m)|0)>>3];c[l>>2]=5;V=+W(+P,+(+h[(hxa(O,1,l)|0)>>3]+-1.0));c[k>>2]=5;aa=X*V*Q*+h[(hxa(O,1,k)|0)>>3];c[j>>2]=6;V=+h[(hxa(N,1,j)|0)>>3];c[g>>2]=6;X=+W(+P,+(+h[(hxa(O,1,g)|0)>>3]+-1.0));c[f>>2]=6;h[a>>3]=Y*(S*(U+(T+(_+($+(aa+V*X*Q*+h[(hxa(O,1,f)|0)>>3])))))-Z*e/(d*d)*647.096)*22064.0e3;i=b;return}function eA(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0.0,A=0.0,B=0.0,C=0.0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+16|0;x=d/273.16;d=e/273.16;c[u>>2]=2;bxa(v,1,u);u=v;y=19824;c[u+0>>2]=c[y+0>>2];c[u+4>>2]=c[y+4>>2];c[u+8>>2]=c[y+8>>2];c[t>>2]=2;bxa(w,1,t);t=w;y=19840;c[t+0>>2]=c[y+0>>2];c[t+4>>2]=c[y+4>>2];c[t+8>>2]=c[y+8>>2];c[s>>2]=1;e=+h[(hxa(v,1,s)|0)>>3];c[r>>2]=2;z=+h[(hxa(v,1,r)|0)>>3];c[q>>2]=1;A=+h[(hxa(v,1,q)|0)>>3];c[p>>2]=1;B=-(A*+W(+x,+(+h[(hxa(w,1,p)|0)>>3])));c[o>>2]=2;A=+h[(hxa(v,1,o)|0)>>3];c[n>>2]=2;C=+ca(+(e+(z+(B-A*+W(+x,+(+h[(hxa(w,1,n)|0)>>3]))))));c[m>>2]=1;A=+h[(hxa(v,1,m)|0)>>3];c[l>>2]=1;B=+W(+x,+(+h[(hxa(w,1,l)|0)>>3]+-1.0));c[k>>2]=1;z=-(A*B*d*+h[(hxa(w,1,k)|0)>>3]);c[j>>2]=2;B=+h[(hxa(v,1,j)|0)>>3];c[g>>2]=2;A=+W(+x,+(+h[(hxa(w,1,g)|0)>>3]+-1.0));c[f>>2]=2;h[a>>3]=C*(z-B*A*d*+h[(hxa(w,1,f)|0)>>3])*611.657;i=b;return}function fA(a,b,c){a=a|0;b=b|0;c=c|0;h[a>>3]=+h[c+8>>3];i=i;return}function gA(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=g|0;var h=0,j=0,k=0;g=i;i=i+16|0;h=g;j=a;a=h;k=f;c[a+0>>2]=c[k+0>>2];c[a+4>>2]=c[k+4>>2];c[a+8>>2]=c[k+8>>2];hA(j,b,e,d,h);i=g;return}function hA(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0;g=i;i=i+200|0;j=g;k=g+96|0;l=g+192|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+96|0;q=i;i=i+96|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;iA(r,b,e);v=+h[r>>3];c[o>>2]=1;w=1.0- +h[(hxa(f,1,o)|0)>>3];x=+yd(+(v*(w/+zd(1.0e-13,+(d-v)))*.6219647130774989),1.0);c[n>>2]=1;v=+zd(+(+h[(hxa(f,1,n)|0)>>3]-x),0.0);c[m>>2]=1;x=+h[(hxa(f,1,m)|0)>>3]-v;c[l>>2]=1;d=1.0- +h[(hxa(f,1,l)|0)>>3];c[p>>2]=19680;h[p+8>>3]=.01801528;h[p+16>>3]=-13423382.81725291;h[p+24>>3]=549760.6476280135;h[p+32>>3]=1.0e3;l=p+40|0;f=19688;c[l+0>>2]=c[f+0>>2];c[l+4>>2]=c[f+4>>2];c[l+8>>2]=c[f+8>>2];f=p+52|0;l=19704;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];l=p+64|0;f=19720;c[l+0>>2]=c[f+0>>2];c[l+4>>2]=c[f+4>>2];c[l+8>>2]=c[f+8>>2];f=p+76|0;l=19736;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];h[p+88>>3]=461.5233290850878;l=k+0|0;f=p+0|0;p=l+96|0;do{c[l>>2]=c[f>>2];l=l+4|0;f=f+4|0}while((l|0)<(p|0));$z(s,b,k,e,1,3,2547494.319);w=+h[s>>3];c[q>>2]=19752;h[q+8>>3]=.0289651159;h[q+16>>3]=-4333.833858403446;h[q+24>>3]=298609.6803431054;h[q+32>>3]=1.0e3;s=q+40|0;k=19760;c[s+0>>2]=c[k+0>>2];c[s+4>>2]=c[k+4>>2];c[s+8>>2]=c[k+8>>2];k=q+52|0;s=19776;c[k+0>>2]=c[s+0>>2];c[k+4>>2]=c[s+4>>2];c[k+8>>2]=c[s+8>>2];s=q+64|0;k=19792;c[s+0>>2]=c[k+0>>2];c[s+4>>2]=c[k+4>>2];c[s+8>>2]=c[k+8>>2];k=q+76|0;s=19808;c[k+0>>2]=c[s+0>>2];c[k+4>>2]=c[s+4>>2];c[k+8>>2]=c[s+8>>2];h[q+88>>3]=287.0512249529787;l=j+0|0;f=q+0|0;p=l+96|0;do{c[l>>2]=c[f>>2];l=l+4|0;f=f+4|0}while((l|0)<(p|0));$z(t,b,j,e,1,3,25104.684);y=+h[t>>3];pA(u,0,e);h[a>>3]=x*w+(d*y+v*+h[u>>3]);i=g;return}function iA(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0.0;b=i;i=i+16|0;d=b;e=b+8|0;jA(d,0,c);f=+h[d>>3];kA(e,0,c);lA(a,0,f,+h[e>>3],c+-273.16,1.0);i=b;return}function jA(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0;b=i;i=i+8|0;e=b;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+16|0;w=1.0-d/647.096;c[t>>2]=6;bxa(u,1,t);t=u;x=19520;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];c[s>>2]=6;bxa(v,1,s);s=v;x=19536;c[s+0>>2]=c[x+0>>2];c[s+4>>2]=c[x+4>>2];c[s+8>>2]=c[x+8>>2];c[r>>2]=1;y=+h[(hxa(u,1,r)|0)>>3];c[q>>2]=1;z=y*+W(+w,+(+h[(hxa(v,1,q)|0)>>3]));c[p>>2]=2;y=+h[(hxa(u,1,p)|0)>>3];c[o>>2]=2;A=y*+W(+w,+(+h[(hxa(v,1,o)|0)>>3]));c[n>>2]=3;y=+h[(hxa(u,1,n)|0)>>3];c[m>>2]=3;B=y*+W(+w,+(+h[(hxa(v,1,m)|0)>>3]));c[l>>2]=4;y=+h[(hxa(u,1,l)|0)>>3];c[k>>2]=4;C=y*+W(+w,+(+h[(hxa(v,1,k)|0)>>3]));c[j>>2]=5;y=+h[(hxa(u,1,j)|0)>>3];c[g>>2]=5;D=y*+W(+w,+(+h[(hxa(v,1,g)|0)>>3]));c[f>>2]=6;y=+h[(hxa(u,1,f)|0)>>3];c[e>>2]=6;h[a>>3]=+ca(+(647.096/d*(z+(A+(B+(C+(D+y*+W(+w,+(+h[(hxa(v,1,e)|0)>>3])))))))))*22064.0e3;i=b;return}function kA(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0.0,t=0.0,u=0.0;b=i;i=i+8|0;e=b;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+16|0;q=d/273.16;c[n>>2]=2;bxa(o,1,n);n=o;r=19824;c[n+0>>2]=c[r+0>>2];c[n+4>>2]=c[r+4>>2];c[n+8>>2]=c[r+8>>2];c[m>>2]=2;bxa(p,1,m);m=p;r=19840;c[m+0>>2]=c[r+0>>2];c[m+4>>2]=c[r+4>>2];c[m+8>>2]=c[r+8>>2];c[l>>2]=1;d=+h[(hxa(o,1,l)|0)>>3];c[k>>2]=2;s=+h[(hxa(o,1,k)|0)>>3];c[j>>2]=1;t=+h[(hxa(o,1,j)|0)>>3];c[g>>2]=1;u=-(t*+W(+q,+(+h[(hxa(p,1,g)|0)>>3])));c[f>>2]=2;t=+h[(hxa(o,1,f)|0)>>3];c[e>>2]=2;h[a>>3]=+ca(+(d+(s+(u-t*+W(+q,+(+h[(hxa(p,1,e)|0)>>3]))))))*611.657;i=b;return}function lA(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;var g=0.0,j=0.0;b=i;g=e/f;f=g*1.570796326794897;do{if(!(g<=-.999999999)){if(g>=.999999999){j=1.0;break}j=+ub(+(+Z(+f)))*.5+.5}else{j=0.0}}while(0);h[a>>3]=j*c+(1.0-j)*d;i=b;return}function mA(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0;b=i;i=i+16|0;g=b;j=f;f=g;c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];j=g;h[a>>3]=d;h[a+8>>3]=e;g=a+16|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];i=b;return}function nA(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=+g;j=j|0;k=k|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0.0,B=0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0;m=i;i=i+360|0;n=m;o=m+96|0;p=m+112|0;q=m+208|0;r=m+224|0;s=m+320|0;t=m+336|0;u=m+344|0;v=m+352|0;w=e+-1.0e-10;e=f+1.0e-10;x=s;y=j;c[x+0>>2]=c[y+0>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];y=r+0|0;x=k+0|0;z=y+96|0;do{c[y>>2]=c[x>>2];y=y+4|0;x=x+4|0}while((y|0)<(z|0));gA(t,b,w,g,s,r);f=+h[t>>3]-d;t=q;r=j;c[t+0>>2]=c[r+0>>2];c[t+4>>2]=c[r+4>>2];c[t+8>>2]=c[r+8>>2];y=p+0|0;x=k+0|0;z=y+96|0;do{c[y>>2]=c[x>>2];y=y+4|0;x=x+4|0}while((y|0)<(z|0));gA(u,b,e,g,q,p);A=+h[u>>3]-d;if(f>0.0&A>0.0){B=3}else{if(f<0.0&A<0.0){B=3}}if((B|0)==3){B=Owa(Owa(Owa(19888,Mwa(w,0,1,6)|0)|0,20024)|0,20032)|0;u=Owa(Owa(Owa(B,Mwa(e,0,1,6)|0)|0,20024)|0,20048)|0;B=Owa(Owa(Owa(u,Mwa(d,0,1,6)|0)|0,20024)|0,20064)|0;u=Owa(Owa(Owa(B,Mwa(f,0,1,6)|0)|0,20024)|0,20096)|0;oA(0,Owa(Owa(Owa(u,Mwa(A,0,1,6)|0)|0,20024)|0,20128)|0)}C=e-w;u=v;D=w;E=e;e=w;w=C;F=C;C=f;G=A;A=f;while(1){if(+U(+A)<+U(+G)){H=E;I=e;J=E;K=G;L=A;M=G}else{H=D;I=E;J=e;K=C;L=G;M=A}f=+U(+I)*2.0e-15+l;N=J*.5+I*-.5;if(+U(+N)<=f|L==0.0){break}do{if(+U(+F)<f){O=N;P=N}else{if(+U(+K)<=+U(+L)){O=N;P=N;break}Q=L/K;if(H==J){R=N*Q*2.0;S=1.0-Q}else{T=K/M;V=L/M;W=V+-1.0;R=Q*(N*T*(T-V)*2.0-(I-H)*W);S=(T+-1.0)*(Q+-1.0)*W}if(R>0.0){X=R;Y=-S}else{X=-R;Y=S}if(!(X*2.0<N*Y*3.0- +U(+(f*Y)))){O=N;P=N;break}if(!(X<+U(+(F*Y*.5)))){O=N;P=N;break}O=X/Y;P=w}}while(0);do{if(+U(+O)>f){Z=O}else{if(N>0.0){Z=f;break}Z=-f}}while(0);f=I+Z;B=o;p=j;c[B+0>>2]=c[p+0>>2];c[B+4>>2]=c[p+4>>2];c[B+8>>2]=c[p+8>>2];y=n+0|0;x=k+0|0;z=y+96|0;do{c[y>>2]=c[x>>2];y=y+4|0;x=x+4|0}while((y|0)<(z|0));gA(v,b,f,g,o,n);N=+h[u>>3]-d;if(!(N>0.0&M>0.0)){if(!(N<0.0&M<0.0)){D=I;E=f;e=J;w=O;F=P;C=L;G=N;A=M;continue}}W=f-I;D=I;E=f;e=I;w=W;F=W;C=L;G=N;A=L}h[a>>3]=I;i=m;return}function oA(a,b){a=a|0;b=b|0;a=i;Qxa(b);i=a;return}function pA(a,b,c){a=a|0;b=b|0;c=+c;var d=0.0;b=i;d=c+-273.15;lA(a,0,d*4200.0,d*2050.0+-333.0e3,c+-273.16,.1);i=b;return}function qA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0;b=i;i=i+40|0;e=b;f=b+32|0;g=e;j=d;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];c[g+24>>2]=c[j+24>>2];c[g+28>>2]=c[j+28>>2];rA(f,0,e);h[a>>3]=+h[d>>3]/(+h[f>>3]*+h[d+8>>3]);i=b;return}function rA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0;b=i;i=i+8|0;e=b;f=i;i=i+8|0;g=d+16|0;c[f>>2]=1;j=(1.0- +h[(hxa(g,1,f)|0)>>3])*287.0512249529787;c[e>>2]=1;h[a>>3]=j+ +h[(hxa(g,1,e)|0)>>3]*461.5233290850878;i=b;return}function sA(a,b,c,d,e,f,g,j,k,l){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;g=+g;j=+j;k=+k;l=+l;var m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0;b=i;m=e/f;e=m*1.570796326794897;n=(k-m*l)/f;do{if(!(m<=-.99999999999)){if(m>=.9999999999){o=1.0;break}o=+ub(+(+Z(+e)))*.5+.5}else{o=0.0}}while(0);f=o*g+(1.0-o)*j;if(!(+U(+m)<1.0)){p=f;q=a;r=q;h[r>>3]=p;i=b;return}m=+vd(+(+Z(+e)))*+X(+e);p=f+(c-d)*(n/(m*m))*.7853981633974483;q=a;r=q;h[r>>3]=p;i=b;return}function tA(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+80|0;h=g;j=g+32|0;k=g+48|0;l=j;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];uA(k,0,d,e,j);j=a;a=h;m=k;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];c[a+12>>2]=c[m+12>>2];c[a+16>>2]=c[m+16>>2];c[a+20>>2]=c[m+20>>2];c[a+24>>2]=c[m+24>>2];c[a+28>>2]=c[m+28>>2];vA(j,b,h);i=g;return}function uA(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0;b=i;i=i+40|0;g=b;j=b+16|0;k=b+32|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+32|0;p=i;i=i+32|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+32|0;t=i;i=i+32|0;u=o+16|0;c[n>>2]=2;bxa(u,1,n);c[m>>2]=2;bxa(u,1,m);if((Zva(f,1)|0)==2){m=p;n=j;v=f;c[n+0>>2]=c[v+0>>2];c[n+4>>2]=c[v+4>>2];c[n+8>>2]=c[v+8>>2];mA(m,0,d,e,j);j=p;p=t;c[p+0>>2]=c[j+0>>2];c[p+4>>2]=c[j+4>>2];c[p+8>>2]=c[j+8>>2];c[p+12>>2]=c[j+12>>2];c[p+16>>2]=c[j+16>>2];c[p+20>>2]=c[j+20>>2];c[p+24>>2]=c[j+24>>2];c[p+28>>2]=c[j+28>>2]}else{w=1.0- +jxa(f);gxa(q,1,w,l);c[k>>2]=q;ixa(1,r,2,f,k);k=s;f=g;q=r;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];mA(k,0,d,e,g);g=s;s=t;c[s+0>>2]=c[g+0>>2];c[s+4>>2]=c[g+4>>2];c[s+8>>2]=c[g+8>>2];c[s+12>>2]=c[g+12>>2];c[s+16>>2]=c[g+16>>2];c[s+20>>2]=c[g+20>>2];c[s+24>>2]=c[g+24>>2];c[s+28>>2]=c[g+28>>2]}h[o>>3]=+h[t>>3];h[o+8>>3]=+h[t+8>>3];cxa(t+16|0,u);u=o;o=a;c[o+0>>2]=c[u+0>>2];c[o+4>>2]=c[u+4>>2];c[o+8>>2]=c[u+8>>2];c[o+12>>2]=c[u+12>>2];c[o+16>>2]=c[u+16>>2];c[o+20>>2]=c[u+20>>2];c[o+24>>2]=c[u+24>>2];c[o+28>>2]=c[u+28>>2];i=b;return}function vA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0.0;e=i;i=i+24|0;f=e;g=e+16|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=d+16|0;c[l>>2]=1;o=+h[(hxa(n,1,l)|0)>>3];c[j>>2]=2;p=+h[(hxa(n,1,j)|0)>>3];j=g;h[k>>3]=p;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];gxa(m,2,o,g);o=+h[d>>3];p=+h[d+8>>3];d=a;a=f;g=m;c[a+0>>2]=c[g+0>>2];c[a+4>>2]=c[g+4>>2];c[a+8>>2]=c[g+8>>2];hA(d,b,o,p,f);i=e;return}function wA(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0,S=0.0,T=0.0,U=0.0,V=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+16|0;O=i;i=i+16|0;P=1.0-d/647.096;Q=-e/647.096;c[M>>2]=6;bxa(N,1,M);M=N;R=19520;c[M+0>>2]=c[R+0>>2];c[M+4>>2]=c[R+4>>2];c[M+8>>2]=c[R+8>>2];c[L>>2]=6;bxa(O,1,L);L=O;R=19536;c[L+0>>2]=c[R+0>>2];c[L+4>>2]=c[R+4>>2];c[L+8>>2]=c[R+8>>2];c[K>>2]=1;S=+h[(hxa(N,1,K)|0)>>3];c[J>>2]=1;T=S*+W(+P,+(+h[(hxa(O,1,J)|0)>>3]));c[I>>2]=2;S=+h[(hxa(N,1,I)|0)>>3];c[H>>2]=2;U=S*+W(+P,+(+h[(hxa(O,1,H)|0)>>3]));c[G>>2]=3;S=+h[(hxa(N,1,G)|0)>>3];c[F>>2]=3;V=S*+W(+P,+(+h[(hxa(O,1,F)|0)>>3]));c[E>>2]=4;S=+h[(hxa(N,1,E)|0)>>3];c[D>>2]=4;X=S*+W(+P,+(+h[(hxa(O,1,D)|0)>>3]));c[C>>2]=5;S=+h[(hxa(N,1,C)|0)>>3];c[B>>2]=5;Y=S*+W(+P,+(+h[(hxa(O,1,B)|0)>>3]));c[A>>2]=6;S=+h[(hxa(N,1,A)|0)>>3];c[z>>2]=6;Z=T+(U+(V+(X+(Y+S*+W(+P,+(+h[(hxa(O,1,z)|0)>>3]))))));S=647.096/d;Y=+ca(+(S*Z));c[y>>2]=1;X=+h[(hxa(N,1,y)|0)>>3];c[x>>2]=1;V=+W(+P,+(+h[(hxa(O,1,x)|0)>>3]+-1.0));c[w>>2]=1;U=X*V*Q*+h[(hxa(O,1,w)|0)>>3];c[v>>2]=2;V=+h[(hxa(N,1,v)|0)>>3];c[u>>2]=2;X=+W(+P,+(+h[(hxa(O,1,u)|0)>>3]+-1.0));c[t>>2]=2;T=V*X*Q*+h[(hxa(O,1,t)|0)>>3];c[s>>2]=3;X=+h[(hxa(N,1,s)|0)>>3];c[r>>2]=3;V=+W(+P,+(+h[(hxa(O,1,r)|0)>>3]+-1.0));c[q>>2]=3;_=X*V*Q*+h[(hxa(O,1,q)|0)>>3];c[p>>2]=4;V=+h[(hxa(N,1,p)|0)>>3];c[o>>2]=4;X=+W(+P,+(+h[(hxa(O,1,o)|0)>>3]+-1.0));c[n>>2]=4;$=V*X*Q*+h[(hxa(O,1,n)|0)>>3];c[m>>2]=5;X=+h[(hxa(N,1,m)|0)>>3];c[l>>2]=5;V=+W(+P,+(+h[(hxa(O,1,l)|0)>>3]+-1.0));c[k>>2]=5;aa=X*V*Q*+h[(hxa(O,1,k)|0)>>3];c[j>>2]=6;V=+h[(hxa(N,1,j)|0)>>3];c[g>>2]=6;X=+W(+P,+(+h[(hxa(O,1,g)|0)>>3]+-1.0));c[f>>2]=6;h[a>>3]=Y*(S*(U+(T+(_+($+(aa+V*X*Q*+h[(hxa(O,1,f)|0)>>3])))))-Z*e/(d*d)*647.096)*22064.0e3;i=b;return}function xA(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0;b=i;i=i+32|0;e=b;f=b+8|0;g=b+16|0;j=b+24|0;jA(e,0,c);k=+h[e>>3];kA(f,0,c);l=+h[f>>3];wA(g,0,c,d);m=+h[g>>3];yA(j,0,c,d);sA(a,0,k,l,c+-273.16,1.0,m,+h[j>>3],d,0.0);i=b;return}function yA(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0.0,A=0.0,B=0.0,C=0.0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+16|0;x=d/273.16;d=e/273.16;c[u>>2]=2;bxa(v,1,u);u=v;y=19824;c[u+0>>2]=c[y+0>>2];c[u+4>>2]=c[y+4>>2];c[u+8>>2]=c[y+8>>2];c[t>>2]=2;bxa(w,1,t);t=w;y=19840;c[t+0>>2]=c[y+0>>2];c[t+4>>2]=c[y+4>>2];c[t+8>>2]=c[y+8>>2];c[s>>2]=1;e=+h[(hxa(v,1,s)|0)>>3];c[r>>2]=2;z=+h[(hxa(v,1,r)|0)>>3];c[q>>2]=1;A=+h[(hxa(v,1,q)|0)>>3];c[p>>2]=1;B=-(A*+W(+x,+(+h[(hxa(w,1,p)|0)>>3])));c[o>>2]=2;A=+h[(hxa(v,1,o)|0)>>3];c[n>>2]=2;C=+ca(+(e+(z+(B-A*+W(+x,+(+h[(hxa(w,1,n)|0)>>3]))))));c[m>>2]=1;A=+h[(hxa(v,1,m)|0)>>3];c[l>>2]=1;B=+W(+x,+(+h[(hxa(w,1,l)|0)>>3]+-1.0));c[k>>2]=1;z=-(A*B*d*+h[(hxa(w,1,k)|0)>>3]);c[j>>2]=2;B=+h[(hxa(v,1,j)|0)>>3];c[g>>2]=2;A=+W(+x,+(+h[(hxa(w,1,g)|0)>>3]+-1.0));c[f>>2]=2;h[a>>3]=C*(z-B*A*d*+h[(hxa(w,1,f)|0)>>3])*611.657;i=b;return}function zA(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0;b=i;i=i+40|0;g=b;j=b+16|0;k=b+32|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+32|0;p=i;i=i+32|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+32|0;t=i;i=i+32|0;u=o+16|0;c[n>>2]=2;bxa(u,1,n);c[m>>2]=2;bxa(u,1,m);if((Zva(f,1)|0)==2){m=p;n=j;v=f;c[n+0>>2]=c[v+0>>2];c[n+4>>2]=c[v+4>>2];c[n+8>>2]=c[v+8>>2];uz(m,0,d,e,j);j=p;p=t;c[p+0>>2]=c[j+0>>2];c[p+4>>2]=c[j+4>>2];c[p+8>>2]=c[j+8>>2];c[p+12>>2]=c[j+12>>2];c[p+16>>2]=c[j+16>>2];c[p+20>>2]=c[j+20>>2];c[p+24>>2]=c[j+24>>2];c[p+28>>2]=c[j+28>>2]}else{w=1.0- +jxa(f);gxa(q,1,w,l);c[k>>2]=q;ixa(1,r,2,f,k);k=s;f=g;q=r;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];uz(k,0,d,e,g);g=s;s=t;c[s+0>>2]=c[g+0>>2];c[s+4>>2]=c[g+4>>2];c[s+8>>2]=c[g+8>>2];c[s+12>>2]=c[g+12>>2];c[s+16>>2]=c[g+16>>2];c[s+20>>2]=c[g+20>>2];c[s+24>>2]=c[g+24>>2];c[s+28>>2]=c[g+28>>2]}h[o>>3]=+h[t>>3];h[o+8>>3]=+h[t+8>>3];cxa(t+16|0,u);u=o;o=a;c[o+0>>2]=c[u+0>>2];c[o+4>>2]=c[u+4>>2];c[o+8>>2]=c[u+8>>2];c[o+12>>2]=c[u+12>>2];c[o+16>>2]=c[u+16>>2];c[o+20>>2]=c[u+20>>2];c[o+24>>2]=c[u+24>>2];c[o+28>>2]=c[u+28>>2];i=b;return}function AA(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0.0;b=i;i=i+16|0;d=b;e=b+8|0;BA(d,0,c);f=+h[d>>3];CA(e,0,c);DA(a,0,f,+h[e>>3],c+-273.16,1.0);i=b;return}function BA(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0;b=i;i=i+8|0;e=b;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+16|0;w=1.0-d/647.096;c[t>>2]=6;bxa(u,1,t);t=u;x=19520;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];c[s>>2]=6;bxa(v,1,s);s=v;x=19536;c[s+0>>2]=c[x+0>>2];c[s+4>>2]=c[x+4>>2];c[s+8>>2]=c[x+8>>2];c[r>>2]=1;y=+h[(hxa(u,1,r)|0)>>3];c[q>>2]=1;z=y*+W(+w,+(+h[(hxa(v,1,q)|0)>>3]));c[p>>2]=2;y=+h[(hxa(u,1,p)|0)>>3];c[o>>2]=2;A=y*+W(+w,+(+h[(hxa(v,1,o)|0)>>3]));c[n>>2]=3;y=+h[(hxa(u,1,n)|0)>>3];c[m>>2]=3;B=y*+W(+w,+(+h[(hxa(v,1,m)|0)>>3]));c[l>>2]=4;y=+h[(hxa(u,1,l)|0)>>3];c[k>>2]=4;C=y*+W(+w,+(+h[(hxa(v,1,k)|0)>>3]));c[j>>2]=5;y=+h[(hxa(u,1,j)|0)>>3];c[g>>2]=5;D=y*+W(+w,+(+h[(hxa(v,1,g)|0)>>3]));c[f>>2]=6;y=+h[(hxa(u,1,f)|0)>>3];c[e>>2]=6;h[a>>3]=+ca(+(647.096/d*(z+(A+(B+(C+(D+y*+W(+w,+(+h[(hxa(v,1,e)|0)>>3])))))))))*22064.0e3;i=b;return}function CA(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0.0,t=0.0,u=0.0;b=i;i=i+8|0;e=b;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+16|0;q=d/273.16;c[n>>2]=2;bxa(o,1,n);n=o;r=19824;c[n+0>>2]=c[r+0>>2];c[n+4>>2]=c[r+4>>2];c[n+8>>2]=c[r+8>>2];c[m>>2]=2;bxa(p,1,m);m=p;r=19840;c[m+0>>2]=c[r+0>>2];c[m+4>>2]=c[r+4>>2];c[m+8>>2]=c[r+8>>2];c[l>>2]=1;d=+h[(hxa(o,1,l)|0)>>3];c[k>>2]=2;s=+h[(hxa(o,1,k)|0)>>3];c[j>>2]=1;t=+h[(hxa(o,1,j)|0)>>3];c[g>>2]=1;u=-(t*+W(+q,+(+h[(hxa(p,1,g)|0)>>3])));c[f>>2]=2;t=+h[(hxa(o,1,f)|0)>>3];c[e>>2]=2;h[a>>3]=+ca(+(d+(s+(u-t*+W(+q,+(+h[(hxa(p,1,e)|0)>>3]))))))*611.657;i=b;return}function DA(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;var g=0.0,j=0.0;b=i;g=e/f;f=g*1.570796326794897;do{if(!(g<=-.999999999)){if(g>=.999999999){j=1.0;break}j=+ub(+(+Z(+f)))*.5+.5}else{j=0.0}}while(0);h[a>>3]=j*c+(1.0-j)*d;i=b;return}function EA(a,b,c){a=a|0;b=b|0;c=+c;var d=0.0;b=i;d=c+-273.15;DA(a,0,d*4200.0,d*2050.0+-333.0e3,c+-273.16,.1);i=b;return}function FA(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0;g=i;i=i+200|0;j=g;k=g+96|0;l=g+192|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+96|0;q=i;i=i+96|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;AA(r,b,e);v=+h[r>>3];c[o>>2]=1;w=1.0- +h[(hxa(f,1,o)|0)>>3];x=+yd(+(v*(w/+zd(1.0e-13,+(d-v)))*.6219647130774989),1.0);c[n>>2]=1;v=+zd(+(+h[(hxa(f,1,n)|0)>>3]-x),0.0);c[m>>2]=1;x=+h[(hxa(f,1,m)|0)>>3]-v;c[l>>2]=1;d=1.0- +h[(hxa(f,1,l)|0)>>3];c[p>>2]=19680;h[p+8>>3]=.01801528;h[p+16>>3]=-13423382.81725291;h[p+24>>3]=549760.6476280135;h[p+32>>3]=1.0e3;l=p+40|0;f=19688;c[l+0>>2]=c[f+0>>2];c[l+4>>2]=c[f+4>>2];c[l+8>>2]=c[f+8>>2];f=p+52|0;l=19704;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];l=p+64|0;f=19720;c[l+0>>2]=c[f+0>>2];c[l+4>>2]=c[f+4>>2];c[l+8>>2]=c[f+8>>2];f=p+76|0;l=19736;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];h[p+88>>3]=461.5233290850878;l=k+0|0;f=p+0|0;p=l+96|0;do{c[l>>2]=c[f>>2];l=l+4|0;f=f+4|0}while((l|0)<(p|0));$z(s,b,k,e,1,3,2547494.319);w=+h[s>>3];c[q>>2]=19752;h[q+8>>3]=.0289651159;h[q+16>>3]=-4333.833858403446;h[q+24>>3]=298609.6803431054;h[q+32>>3]=1.0e3;s=q+40|0;k=19760;c[s+0>>2]=c[k+0>>2];c[s+4>>2]=c[k+4>>2];c[s+8>>2]=c[k+8>>2];k=q+52|0;s=19776;c[k+0>>2]=c[s+0>>2];c[k+4>>2]=c[s+4>>2];c[k+8>>2]=c[s+8>>2];s=q+64|0;k=19792;c[s+0>>2]=c[k+0>>2];c[s+4>>2]=c[k+4>>2];c[s+8>>2]=c[k+8>>2];k=q+76|0;s=19808;c[k+0>>2]=c[s+0>>2];c[k+4>>2]=c[s+4>>2];c[k+8>>2]=c[s+8>>2];h[q+88>>3]=287.0512249529787;l=j+0|0;f=q+0|0;p=l+96|0;do{c[l>>2]=c[f>>2];l=l+4|0;f=f+4|0}while((l|0)<(p|0));$z(t,b,j,e,1,3,25104.684);y=+h[t>>3];EA(u,0,e);h[a>>3]=x*w+(d*y+v*+h[u>>3]);i=g;return}function GA(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+80|0;h=g;j=g+32|0;k=g+48|0;l=j;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];zA(k,0,d,e,j);j=a;a=h;m=k;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];c[a+12>>2]=c[m+12>>2];c[a+16>>2]=c[m+16>>2];c[a+20>>2]=c[m+20>>2];c[a+24>>2]=c[m+24>>2];c[a+28>>2]=c[m+28>>2];HA(j,b,h);i=g;return}function HA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0.0;e=i;i=i+24|0;f=e;g=e+16|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=d+16|0;c[l>>2]=1;o=+h[(hxa(n,1,l)|0)>>3];c[j>>2]=2;p=+h[(hxa(n,1,j)|0)>>3];j=g;h[k>>3]=p;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];gxa(m,2,o,g);o=+h[d>>3];p=+h[d+8>>3];d=a;a=f;g=m;c[a+0>>2]=c[g+0>>2];c[a+4>>2]=c[g+4>>2];c[a+8>>2]=c[g+8>>2];FA(d,b,o,p,f);i=e;return}function IA(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;k=i;i=i+56|0;l=k;m=k+24|0;n=k+48|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=Zva(g,1)|0;if(e<<24>>24!=0&f<<24>>24==0){f=Owa(Owa(Owa(Owa(20264,j)|0,20320)|0,b)|0,20352)|0;e=c[63880]|0;u=m;v=20544;c[u+0>>2]=c[v+0>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];c[u+12>>2]=c[v+12>>2];c[u+16>>2]=c[v+16>>2];c[u+20>>2]=c[v+20>>2];Oe[e&127](a,m,f,s);}if((t|0)<1){i=k;return}s=(JA(1,1,t)|0)==0;if(!s){f=1;do{c[r>>2]=f;if(!(+h[(hxa(g,1,r)|0)>>3]>=0.0)){m=Owa(Owa(Owa(Owa(20568,b)|0,20616)|0,j)|0,20632)|0;e=Owa(Owa(m,Lwa(f,0,1)|0)|0,20672)|0;c[q>>2]=f;m=Owa(Owa(e,Mwa(+h[(hxa(g,1,q)|0)>>3],0,1,6)|0)|0,20680)|0;e=c[63880]|0;v=l;u=20720;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[v+12>>2]=c[u+12>>2];c[v+16>>2]=c[u+16>>2];c[v+20>>2]=c[u+20>>2];Oe[e&127](a,l,m,p);}f=f+1|0;}while((JA(f,1,t)|0)!=0)}if((t|0)<=0){i=k;return}if(!(+U(+(+jxa(g)+-1.0))>1.0e-10)){i=k;return}if(s){w=18464}else{s=18464;f=1;while(1){p=Owa(s,20744)|0;l=Owa(Owa(p,Lwa(f,0,1)|0)|0,20760)|0;c[o>>2]=f;p=Owa(Owa(l,Mwa(+h[(hxa(g,1,o)|0)>>3],0,1,6)|0)|0,20768)|0;c[n>>2]=f;l=Owa(Owa(p,c[(Mxa(d,1,n)|0)>>2]|0)|0,20776)|0;p=f+1|0;if((JA(p,1,t)|0)==0){w=l;break}else{f=p;s=l}}}s=Owa(Owa(Owa(Owa(Owa(20784,b)|0,20616)|0,j)|0,20776)|0,20824)|0;oA(0,Owa(Owa(Owa(s,Mwa(+jxa(g),0,1,6)|0)|0,20872)|0,w)|0);i=k;return}function JA(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;if((b|0)>(c|0)){if((a|0)<(c|0)|(a|0)>(b|0)){e=4}else{f=1}}else{if((a|0)<(b|0)|(a|0)>(c|0)){e=4}else{f=1}}if((e|0)==4){f=0}i=d;return f|0}function KA(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;var g=0.0,j=0.0;b=i;g=e/f;f=g*1.570796326794897;do{if(!(g<=-.999999999)){if(g>=.999999999){j=1.0;break}j=+ub(+(+Z(+f)))*.5+.5}else{j=0.0}}while(0);h[a>>3]=j*c+(1.0-j)*d;i=b;return}function LA(a,b,d,e){a=a|0;b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=+h[d+88>>3];p=+Nxa(e,-2);q=d+40|0;c[n>>2]=1;r=+h[(hxa(q,1,n)|0)>>3];c[m>>2]=2;s=+h[(hxa(q,1,m)|0)>>3];c[l>>2]=3;t=+h[(hxa(q,1,l)|0)>>3];c[k>>2]=4;u=+h[(hxa(q,1,k)|0)>>3];c[j>>2]=5;v=+h[(hxa(q,1,j)|0)>>3];c[g>>2]=6;w=+h[(hxa(q,1,g)|0)>>3];c[f>>2]=7;h[a>>3]=o*p*(r+(s+(t+(u+(v+(w+ +h[(hxa(q,1,f)|0)>>3]*e)*e)*e)*e)*e)*e);i=b;return}function MA(a,b,d,e){a=a|0;b=b|0;d=d|0;e=+e;var f=0,g=0,j=0.0,k=0.0,l=0,m=0,n=0,o=0.0,p=0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;c[g>>2]=1;j=+h[(hxa(d,1,g)|0)>>3];g=Zva(d,1)|0;if((g|0)<2){k=j;l=a;m=l;h[m>>3]=k;i=b;return}if((JA(2,2,g)|0)==0){k=j;l=a;m=l;h[m>>3]=k;i=b;return}else{n=2;o=j}while(1){c[f>>2]=n;j=o*e+ +h[(hxa(d,1,f)|0)>>3];p=n+1|0;if((JA(p,2,g)|0)==0){k=j;break}else{o=j;n=p}}l=a;m=l;h[m>>3]=k;i=b;return}function NA(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=+e;f=+f;var g=0,j=0,k=0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0.0,s=0;b=i;i=i+8|0;g=b;j=i;i=i+8|0;k=Zva(d,1)|0;c[j>>2]=1;l=+h[(hxa(d,1,j)|0)>>3]*+(k+ -1|0);j=Zva(d,1)|0;m=j+ -1|0;if((j|0)<3){n=l;o=n*f;p=a;q=p;h[q>>3]=o;i=b;return}if((JA(2,2,m)|0)==0){n=l;o=n*f;p=a;q=p;h[q>>3]=o;i=b;return}else{r=l;s=2}while(1){c[g>>2]=s;l=r*e+ +(k-s|0)*+h[(hxa(d,1,g)|0)>>3];j=s+1|0;if((JA(j,2,m)|0)==0){n=l;break}else{s=j;r=l}}o=n*f;p=a;q=p;h[q>>3]=o;i=b;return}function OA(a){a=a|0;var b=0;a=i;i=i+8|0;b=i;i=i+8|0;hwa(4,0,21904,b);hwa(4,0,21944,a);i=a;return}function PA(a){a=a|0;var b=0,d=0;b=i;d=a+320|0;a=c[d>>2]|0;if((a|0)==0){i=b;return}W_a(a);c[d>>2]=0;i=b;return}function QA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;iA(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+408>>3]);if((Aza(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+424>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+1080>>3]*.999;l=j;m=l+8848|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;xA(e,c[f>>2]|0,+h[d+408>>3],+h[d+1064>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+8848|0;n=m;h[n>>3]=k;i=b;return}}function RA(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[63880]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=57624;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&127](mb,m,22008,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]}jA(t,c[ib>>2]|0,jb);jb=+h[t>>3];kA(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);jb=+h[v>>3];jA(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);pb=+h[w>>3];kA(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+416>>3];qb=+zd(1.0e-13,+(+h[w+424>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+nwa(c[ib>>2]|0,qb,22080,22e3,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(pb- +yd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{jA(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);sb=+h[z>>3];kA(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);sb=+h[B>>3];jA(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);jb=+h[C>>3];kA(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+zd(1.0e-13,+(+h[C+424>>3]- +h[E>>3]));pb=1.0- +h[C+416>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+nwa(c[ib>>2]|0,jb,22080,22e3,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{jA(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);vb=+h[F>>3];kA(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);vb=+h[H>>3];jA(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);sb=+h[I>>3];kA(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);sb=+h[K>>3];jA(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);jb=+h[L>>3];kA(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+424>>3]- +h[N>>3])|0)<<24>>24==0){jA(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);jb=+h[O>>3];kA(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Q,c[ib>>2]|0,+h[P+408>>3],+h[P+1064>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(R,c[ib>>2]|0,+h[Q+408>>3],+h[Q+1064>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(S,c[ib>>2]|0,jb,pb,+h[Q+408>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+1064>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+1080>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}jA(T,c[ib>>2]|0,+h[xb+408>>3]);qb=+h[T>>3];kA(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);qb=+h[V>>3];jA(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);pb=+h[W>>3];kA(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);pb=+h[Y>>3];jA(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);jb=+h[Z>>3];kA(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA($,c[ib>>2]|0,+h[_+408>>3],+h[_+1064>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(aa,c[ib>>2]|0,+h[$+408>>3],+h[$+1064>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(ba,c[ib>>2]|0,jb,rb,+h[$+408>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+1064>>3],0.0);zb=+h[ba>>3];jA(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);rb=+h[ca>>3];kA(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+424>>3];Ab=+zd(1.0e-13,+(jb-qb));qb=Ab*+zd(1.0e-13,+(jb-pb));pb=+h[ea+1072>>3];Ab=-(pb*+zd(1.0e-13,+(jb-sb)));sb=+h[ea+416>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+nwa(c[ib>>2]|0,qb,22384,22e3,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+416>>3];Cb=+h[ca+424>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+zd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+nwa(c[ib>>2]|0,Eb,22080,22e3,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+1072>>3]-wb}wb=+h[tb+408>>3];if(wb>0.0){Gb=wb}else{tb=c[63880]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=57624;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&127](Db,l,22008,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]}if(Gb>0.0){Hb=Gb}else{r=c[63880]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=57624;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&127](l,j,22008,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]}jA(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];kA(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);Hb=+h[ia>>3];jA(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);Fb=+h[ja>>3];kA(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3];if(zb>0.0){Ib=zb}else{la=c[63880]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=57624;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&127](ka,g,22008,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]}if(Ib>0.0){Jb=Ib}else{p=c[63880]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=57624;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&127](g,f,22008,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]}if(Jb>0.0){Kb=Jb}else{o=c[63880]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=57624;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&127](f,e,22008,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]}qb=Kb+-273.15;lA(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];jA(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);qb=+h[na>>3];kA(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);qb=+h[pa>>3];jA(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);Eb=+h[qa>>3];kA(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+416>>3];rb=+zd(1.0e-13,+(+h[qa+424>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+nwa(c[ib>>2]|0,rb,22080,22e3,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(Eb- +yd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{jA(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);Lb=+h[ta>>3];kA(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);Lb=+h[va>>3];jA(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);qb=+h[wa>>3];kA(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+zd(1.0e-13,+(+h[wa+424>>3]- +h[ya>>3]));Eb=1.0- +h[wa+416>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+nwa(c[ib>>2]|0,qb,22080,22e3,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{jA(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);Ob=+h[za>>3];kA(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);Ob=+h[Ba>>3];jA(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);Lb=+h[Ca>>3];kA(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);Lb=+h[Ea>>3];jA(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);qb=+h[Fa>>3];kA(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+424>>3]- +h[Ha>>3])|0)<<24>>24==0){jA(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);qb=+h[Ia>>3];kA(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Ka,c[ib>>2]|0,+h[Ja+408>>3],+h[Ja+1064>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(La,c[ib>>2]|0,+h[Ka+408>>3],+h[Ka+1064>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+408>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+1064>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+1080>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}jA(Na,c[ib>>2]|0,+h[Qb+408>>3]);rb=+h[Na>>3];kA(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);rb=+h[Pa>>3];jA(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);Eb=+h[Qa>>3];kA(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);Eb=+h[Sa>>3];jA(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);qb=+h[Ta>>3];kA(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Va,c[ib>>2]|0,+h[Ua+408>>3],+h[Ua+1064>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(Wa,c[ib>>2]|0,+h[Va+408>>3],+h[Va+1064>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Xa,c[ib>>2]|0,qb,Bb,+h[Va+408>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+1064>>3],0.0);Cb=+h[Xa>>3];jA(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);Bb=+h[Ya>>3];kA(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+424>>3];vb=+zd(1.0e-13,+(qb-rb));rb=vb*+zd(1.0e-13,+(qb-Eb));Eb=+h[Za+1072>>3];vb=-(Eb*+zd(1.0e-13,+(qb-Lb)));Lb=+h[Za+416>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+nwa(c[ib>>2]|0,rb,22384,22e3,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+416>>3];Tb=+h[Ya+424>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+zd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+nwa(c[ib>>2]|0,Vb,22080,22e3,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+1072>>3]-Pb}Pb=+h[Mb+408>>3];Wb=Pb+-273.15;Cb=+h[Mb+1064>>3];sA($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];jA(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);Pb=+h[ab>>3];kA(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);Pb=+h[cb>>3];jA(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);Wb=+h[db>>3];kA(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+408>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+nwa(c[ib>>2]|0,rb,22992,22e3,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+408>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+1072>>3]-ub);ub=+h[Yb+1064>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+nwa(c[ib>>2]|0,Xb,22992,22e3,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+1064>>3];ac=+h[Yb+408>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+Nxa(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+416>>3];Gb=+zd(1.0e-13,+(+h[Yb+424>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+nwa(c[ib>>2]|0,Gb,22080,22e3,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +zd(+(ac- +yd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+408>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+nwa(c[ib>>2]|0,ec,22992,22e3,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+408>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+1072>>3];ic=+h[gc+1064>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+nwa(c[ib>>2]|0,fc,22992,22e3,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+1064>>3];kc=+h[gc+408>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+Nxa(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+416>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+zd(1.0e-13,+(+h[gc+424>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9344|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9344|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+nwa(c[ib>>2]|0,Nb,22080,22e3,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9344|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function SA(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[63880]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=57624;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&127](mb,m,23024,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]}jA(t,c[ib>>2]|0,jb);jb=+h[t>>3];kA(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);jb=+h[v>>3];jA(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);pb=+h[w>>3];kA(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+440>>3];qb=+zd(1.0e-13,+(+h[w+448>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+nwa(c[ib>>2]|0,qb,23096,23016,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(pb- +yd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{jA(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);sb=+h[z>>3];kA(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);sb=+h[B>>3];jA(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);jb=+h[C>>3];kA(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+zd(1.0e-13,+(+h[C+448>>3]- +h[E>>3]));pb=1.0- +h[C+440>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+nwa(c[ib>>2]|0,jb,23096,23016,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{jA(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);vb=+h[F>>3];kA(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);vb=+h[H>>3];jA(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);sb=+h[I>>3];kA(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);sb=+h[K>>3];jA(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);jb=+h[L>>3];kA(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+448>>3]- +h[N>>3])|0)<<24>>24==0){jA(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);jb=+h[O>>3];kA(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Q,c[ib>>2]|0,+h[P+432>>3],+h[P+1088>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(R,c[ib>>2]|0,+h[Q+432>>3],+h[Q+1088>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(S,c[ib>>2]|0,jb,pb,+h[Q+432>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+1088>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+1104>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}jA(T,c[ib>>2]|0,+h[xb+432>>3]);qb=+h[T>>3];kA(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);qb=+h[V>>3];jA(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);pb=+h[W>>3];kA(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);pb=+h[Y>>3];jA(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);jb=+h[Z>>3];kA(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA($,c[ib>>2]|0,+h[_+432>>3],+h[_+1088>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(aa,c[ib>>2]|0,+h[$+432>>3],+h[$+1088>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(ba,c[ib>>2]|0,jb,rb,+h[$+432>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+1088>>3],0.0);zb=+h[ba>>3];jA(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);rb=+h[ca>>3];kA(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+448>>3];Ab=+zd(1.0e-13,+(jb-qb));qb=Ab*+zd(1.0e-13,+(jb-pb));pb=+h[ea+1096>>3];Ab=-(pb*+zd(1.0e-13,+(jb-sb)));sb=+h[ea+440>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+nwa(c[ib>>2]|0,qb,23400,23016,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+440>>3];Cb=+h[ca+448>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+zd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+nwa(c[ib>>2]|0,Eb,23096,23016,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+1096>>3]-wb}wb=+h[tb+432>>3];if(wb>0.0){Gb=wb}else{tb=c[63880]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=57624;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&127](Db,l,23024,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]}if(Gb>0.0){Hb=Gb}else{r=c[63880]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=57624;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&127](l,j,23024,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]}jA(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];kA(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);Hb=+h[ia>>3];jA(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);Fb=+h[ja>>3];kA(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3];if(zb>0.0){Ib=zb}else{la=c[63880]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=57624;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&127](ka,g,23024,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]}if(Ib>0.0){Jb=Ib}else{p=c[63880]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=57624;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&127](g,f,23024,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]}if(Jb>0.0){Kb=Jb}else{o=c[63880]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=57624;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&127](f,e,23024,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]}qb=Kb+-273.15;lA(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];jA(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);qb=+h[na>>3];kA(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);qb=+h[pa>>3];jA(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);Eb=+h[qa>>3];kA(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+440>>3];rb=+zd(1.0e-13,+(+h[qa+448>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+nwa(c[ib>>2]|0,rb,23096,23016,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(Eb- +yd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{jA(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);Lb=+h[ta>>3];kA(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);Lb=+h[va>>3];jA(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);qb=+h[wa>>3];kA(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+zd(1.0e-13,+(+h[wa+448>>3]- +h[ya>>3]));Eb=1.0- +h[wa+440>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+nwa(c[ib>>2]|0,qb,23096,23016,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{jA(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);Ob=+h[za>>3];kA(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);Ob=+h[Ba>>3];jA(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);Lb=+h[Ca>>3];kA(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);Lb=+h[Ea>>3];jA(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);qb=+h[Fa>>3];kA(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+448>>3]- +h[Ha>>3])|0)<<24>>24==0){jA(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);qb=+h[Ia>>3];kA(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Ka,c[ib>>2]|0,+h[Ja+432>>3],+h[Ja+1088>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(La,c[ib>>2]|0,+h[Ka+432>>3],+h[Ka+1088>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+432>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+1088>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+1104>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}jA(Na,c[ib>>2]|0,+h[Qb+432>>3]);rb=+h[Na>>3];kA(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);rb=+h[Pa>>3];jA(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);Eb=+h[Qa>>3];kA(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);Eb=+h[Sa>>3];jA(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);qb=+h[Ta>>3];kA(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Va,c[ib>>2]|0,+h[Ua+432>>3],+h[Ua+1088>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(Wa,c[ib>>2]|0,+h[Va+432>>3],+h[Va+1088>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Xa,c[ib>>2]|0,qb,Bb,+h[Va+432>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+1088>>3],0.0);Cb=+h[Xa>>3];jA(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);Bb=+h[Ya>>3];kA(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+448>>3];vb=+zd(1.0e-13,+(qb-rb));rb=vb*+zd(1.0e-13,+(qb-Eb));Eb=+h[Za+1096>>3];vb=-(Eb*+zd(1.0e-13,+(qb-Lb)));Lb=+h[Za+440>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+nwa(c[ib>>2]|0,rb,23400,23016,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+440>>3];Tb=+h[Ya+448>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+zd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+nwa(c[ib>>2]|0,Vb,23096,23016,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+1096>>3]-Pb}Pb=+h[Mb+432>>3];Wb=Pb+-273.15;Cb=+h[Mb+1088>>3];sA($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];jA(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);Pb=+h[ab>>3];kA(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);Pb=+h[cb>>3];jA(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);Wb=+h[db>>3];kA(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+432>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+nwa(c[ib>>2]|0,rb,24008,23016,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+432>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+1096>>3]-ub);ub=+h[Yb+1088>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+nwa(c[ib>>2]|0,Xb,24008,23016,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+1088>>3];ac=+h[Yb+432>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+Nxa(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+440>>3];Gb=+zd(1.0e-13,+(+h[Yb+448>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+nwa(c[ib>>2]|0,Gb,23096,23016,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +zd(+(ac- +yd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+432>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+nwa(c[ib>>2]|0,ec,24008,23016,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+432>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+1096>>3];ic=+h[gc+1088>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+nwa(c[ib>>2]|0,fc,24008,23016,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+1088>>3];kc=+h[gc+432>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+Nxa(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+440>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+zd(1.0e-13,+(+h[gc+448>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9328|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9328|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+nwa(c[ib>>2]|0,Nb,23096,23016,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9328|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function TA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;iA(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+432>>3]);if((Aza(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+448>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+1104>>3]*.999;l=j;m=l+8824|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;xA(e,c[f>>2]|0,+h[d+432>>3],+h[d+1088>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+8824|0;n=m;h[n>>3]=k;i=b;return}}function UA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;iA(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+512>>3]);if((Aza(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+528>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+1184>>3]*.999;l=j;m=l+8736|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;xA(e,c[f>>2]|0,+h[d+512>>3],+h[d+1168>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+8736|0;n=m;h[n>>3]=k;i=b;return}}function VA(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[63880]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=57624;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&127](mb,m,24040,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]}jA(t,c[ib>>2]|0,jb);jb=+h[t>>3];kA(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);jb=+h[v>>3];jA(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);pb=+h[w>>3];kA(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+520>>3];qb=+zd(1.0e-13,+(+h[w+528>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+nwa(c[ib>>2]|0,qb,24112,24032,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(pb- +yd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{jA(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);sb=+h[z>>3];kA(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);sb=+h[B>>3];jA(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);jb=+h[C>>3];kA(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+zd(1.0e-13,+(+h[C+528>>3]- +h[E>>3]));pb=1.0- +h[C+520>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+nwa(c[ib>>2]|0,jb,24112,24032,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{jA(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);vb=+h[F>>3];kA(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);vb=+h[H>>3];jA(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);sb=+h[I>>3];kA(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);sb=+h[K>>3];jA(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);jb=+h[L>>3];kA(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+528>>3]- +h[N>>3])|0)<<24>>24==0){jA(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);jb=+h[O>>3];kA(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Q,c[ib>>2]|0,+h[P+512>>3],+h[P+1168>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(R,c[ib>>2]|0,+h[Q+512>>3],+h[Q+1168>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(S,c[ib>>2]|0,jb,pb,+h[Q+512>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+1168>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+1184>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}jA(T,c[ib>>2]|0,+h[xb+512>>3]);qb=+h[T>>3];kA(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);qb=+h[V>>3];jA(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);pb=+h[W>>3];kA(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);pb=+h[Y>>3];jA(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);jb=+h[Z>>3];kA(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA($,c[ib>>2]|0,+h[_+512>>3],+h[_+1168>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(aa,c[ib>>2]|0,+h[$+512>>3],+h[$+1168>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(ba,c[ib>>2]|0,jb,rb,+h[$+512>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+1168>>3],0.0);zb=+h[ba>>3];jA(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);rb=+h[ca>>3];kA(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+528>>3];Ab=+zd(1.0e-13,+(jb-qb));qb=Ab*+zd(1.0e-13,+(jb-pb));pb=+h[ea+1176>>3];Ab=-(pb*+zd(1.0e-13,+(jb-sb)));sb=+h[ea+520>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+nwa(c[ib>>2]|0,qb,24416,24032,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+520>>3];Cb=+h[ca+528>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+zd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+nwa(c[ib>>2]|0,Eb,24112,24032,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+1176>>3]-wb}wb=+h[tb+512>>3];if(wb>0.0){Gb=wb}else{tb=c[63880]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=57624;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&127](Db,l,24040,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]}if(Gb>0.0){Hb=Gb}else{r=c[63880]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=57624;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&127](l,j,24040,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]}jA(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];kA(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);Hb=+h[ia>>3];jA(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);Fb=+h[ja>>3];kA(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3];if(zb>0.0){Ib=zb}else{la=c[63880]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=57624;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&127](ka,g,24040,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]}if(Ib>0.0){Jb=Ib}else{p=c[63880]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=57624;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&127](g,f,24040,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]}if(Jb>0.0){Kb=Jb}else{o=c[63880]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=57624;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&127](f,e,24040,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]}qb=Kb+-273.15;lA(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];jA(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);qb=+h[na>>3];kA(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);qb=+h[pa>>3];jA(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);Eb=+h[qa>>3];kA(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+520>>3];rb=+zd(1.0e-13,+(+h[qa+528>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+nwa(c[ib>>2]|0,rb,24112,24032,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(Eb- +yd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{jA(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);Lb=+h[ta>>3];kA(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);Lb=+h[va>>3];jA(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);qb=+h[wa>>3];kA(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+zd(1.0e-13,+(+h[wa+528>>3]- +h[ya>>3]));Eb=1.0- +h[wa+520>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+nwa(c[ib>>2]|0,qb,24112,24032,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{jA(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);Ob=+h[za>>3];kA(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);Ob=+h[Ba>>3];jA(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);Lb=+h[Ca>>3];kA(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);Lb=+h[Ea>>3];jA(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);qb=+h[Fa>>3];kA(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+528>>3]- +h[Ha>>3])|0)<<24>>24==0){jA(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);qb=+h[Ia>>3];kA(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Ka,c[ib>>2]|0,+h[Ja+512>>3],+h[Ja+1168>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(La,c[ib>>2]|0,+h[Ka+512>>3],+h[Ka+1168>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+512>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+1168>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+1184>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}jA(Na,c[ib>>2]|0,+h[Qb+512>>3]);rb=+h[Na>>3];kA(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);rb=+h[Pa>>3];jA(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);Eb=+h[Qa>>3];kA(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);Eb=+h[Sa>>3];jA(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);qb=+h[Ta>>3];kA(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Va,c[ib>>2]|0,+h[Ua+512>>3],+h[Ua+1168>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(Wa,c[ib>>2]|0,+h[Va+512>>3],+h[Va+1168>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Xa,c[ib>>2]|0,qb,Bb,+h[Va+512>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+1168>>3],0.0);Cb=+h[Xa>>3];jA(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);Bb=+h[Ya>>3];kA(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+528>>3];vb=+zd(1.0e-13,+(qb-rb));rb=vb*+zd(1.0e-13,+(qb-Eb));Eb=+h[Za+1176>>3];vb=-(Eb*+zd(1.0e-13,+(qb-Lb)));Lb=+h[Za+520>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+nwa(c[ib>>2]|0,rb,24416,24032,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+520>>3];Tb=+h[Ya+528>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+zd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+nwa(c[ib>>2]|0,Vb,24112,24032,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+1176>>3]-Pb}Pb=+h[Mb+512>>3];Wb=Pb+-273.15;Cb=+h[Mb+1168>>3];sA($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];jA(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);Pb=+h[ab>>3];kA(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);Pb=+h[cb>>3];jA(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);Wb=+h[db>>3];kA(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+512>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+nwa(c[ib>>2]|0,rb,25024,24032,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+512>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+1176>>3]-ub);ub=+h[Yb+1168>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+nwa(c[ib>>2]|0,Xb,25024,24032,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+1168>>3];ac=+h[Yb+512>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+Nxa(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+520>>3];Gb=+zd(1.0e-13,+(+h[Yb+528>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+nwa(c[ib>>2]|0,Gb,24112,24032,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +zd(+(ac- +yd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+512>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+nwa(c[ib>>2]|0,ec,25024,24032,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+512>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+1176>>3];ic=+h[gc+1168>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+nwa(c[ib>>2]|0,fc,25024,24032,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+1168>>3];kc=+h[gc+512>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+Nxa(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+520>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+zd(1.0e-13,+(+h[gc+528>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9296|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9296|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+nwa(c[ib>>2]|0,Nb,24112,24032,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9296|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function WA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;iA(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+584>>3]);if((Aza(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+600>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+1256>>3]*.999;l=j;m=l+8664|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;xA(e,c[f>>2]|0,+h[d+584>>3],+h[d+1240>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+8664|0;n=m;h[n>>3]=k;i=b;return}}



function Cya(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0,R=0.0,S=0.0;j=i;i=i+16|0;n=j;o=j+8|0;p=c[e>>2]|0;e=~p;q=+sya(233832);r=c[b>>2]|0;if((r|0)<1){s=r}else{t=1;while(1){u=+tya(a,d+((fa(t,p)|0)-p<<3)|0);v=t+ -1|0;h[l+(v<<3)>>3]=u;h[k+(v<<3)>>3]=u;h[m+(v<<3)>>3]=u;if((c[f>>2]|0)!=0){c[g+(v<<2)>>2]=t}if((t|0)<(r|0)){t=t+1|0}else{break}}s=c[b>>2]|0}t=c[a>>2]|0;r=(t|0)>(s|0)?s:t;if((r|0)<1){i=j;return 0}else{w=1}while(1){do{if((c[f>>2]|0)!=0){t=c[b>>2]|0;c[n>>2]=t;if((w|0)>(t|0)){break}else{x=w;y=w}while(1){z=+h[k+(x+ -1<<3)>>3]>+h[k+(y+ -1<<3)>>3]?x:y;if((x|0)<(t|0)){y=z;x=x+1|0}else{break}}if((z|0)==(w|0)){break}t=c[a>>2]|0;c[n>>2]=t;if((t|0)>=1){s=(fa(w,p)|0)+e|0;l=(fa(z,p)|0)+e|0;v=1;while(1){A=d+(s+v<<3)|0;u=+h[A>>3];B=d+(l+v<<3)|0;h[A>>3]=+h[B>>3];h[B>>3]=u;if((v|0)<(t|0)){v=v+1|0}else{break}}}v=w+ -1|0;t=z+ -1|0;h[k+(t<<3)>>3]=+h[k+(v<<3)>>3];h[m+(t<<3)>>3]=+h[m+(v<<3)>>3];l=g+(v<<2)|0;v=c[l>>2]|0;s=g+(t<<2)|0;c[l>>2]=c[s>>2];c[s>>2]=v}}while(0);c[n>>2]=1-w+(c[a>>2]|0);v=fa(w,p)|0;s=w+e|0;l=d+(s+v<<3)|0;u=+tya(n,l);a:do{if(u==0.0){C=w+1|0;D=u}else{E=+h[l>>3];if(E<0.0){F=-u}else{F=u}t=c[a>>2]|0;c[n>>2]=t;if((w|0)>(t|0)){G=E}else{B=v+e|0;A=w;while(1){H=d+(B+A<<3)|0;h[H>>3]=+h[H>>3]/F;if((A|0)<(t|0)){A=A+1|0}else{break}}G=+h[l>>3]}h[l>>3]=G+1.0;A=w+1|0;B=c[b>>2]|0;if((B|0)<(A|0)){C=A;D=F;break}c[n>>2]=B;if((w|0)>=(B|0)){C=A;D=F;break}H=A+e|0;I=v+e|0;J=t;K=B;B=A;while(1){c[o>>2]=J;L=(w|0)>(J|0);do{if(L){c[o>>2]=J}else{M=(fa(B,p)|0)+e|0;N=w;E=0.0;while(1){O=E+ +h[d+(I+N<<3)>>3]*+h[d+(M+N<<3)>>3];if((N|0)<(J|0)){E=O;N=N+1|0}else{break}}E=O/+h[l>>3];c[o>>2]=J;if(L){break}N=(fa(B,p)|0)+e|0;M=w;while(1){P=d+(N+M<<3)|0;h[P>>3]=+h[P>>3]-E*+h[d+(I+M<<3)>>3];if((M|0)<(J|0)){M=M+1|0}else{break}}}}while(0);do{if((c[f>>2]|0)==0){Q=K}else{L=B+ -1|0;M=k+(L<<3)|0;E=+h[M>>3];if(E==0.0){Q=K;break}N=fa(B,p)|0;R=+h[d+(s+N<<3)>>3]/E;S=1.0-R*R;R=E*+V(+(S<=0.0?0.0:S));h[M>>3]=R;P=m+(L<<3)|0;S=R/+h[P>>3];if(S*S*.05>q){Q=K;break}c[o>>2]=J-w;S=+tya(o,d+(H+N<<3)|0);h[M>>3]=S;h[P>>3]=S;Q=c[n>>2]|0}}while(0);if((B|0)>=(Q|0)){C=A;D=F;break a}J=c[a>>2]|0;K=Q;B=B+1|0}}}while(0);h[k+(w+ -1<<3)>>3]=-D;if((w|0)<(r|0)){w=C}else{break}}i=j;return 0}function Dya(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0;j=i;k=c[e>>2]|0;e=~k;l=c[b>>2]|0;b=l+ -1|0;if((l|0)<2){i=j;return 0}m=c[a>>2]|0;n=(m|0)<1;o=0.0;p=1;q=0.0;while(1){r=l-p|0;s=+h[f+(r+ -1<<3)>>3];t=!(s>=0.0);if(t){u=-s}else{u=s}if(u>1.0){v=1.0/s}else{v=o}if(t){w=-s}else{w=s}if(w>1.0){x=+V(+(1.0-v*v))}else{x=q}if(t){y=-s;z=!(s>=-1.0)?x:s}else{y=s;z=!(s<=1.0)?x:s}if(!(y<=1.0)){A=v}else{A=+V(+(1.0-z*z))}if(!n){t=(fa(r,k)|0)+e|0;r=fa(l,k)|0;B=1;while(1){C=d+(t+B<<3)|0;s=+h[C>>3];D=d+(B+e+r<<3)|0;E=+h[D>>3];h[D>>3]=z*s+A*E;h[C>>3]=A*s-z*E;if((B|0)<(m|0)){B=B+1|0}else{break}}}if((p|0)<(b|0)){o=A;p=p+1|0;q=z}else{break}}p=c[a>>2]|0;a=(p|0)<1;q=A;m=1;A=z;while(1){z=+h[g+(m+ -1<<3)>>3];n=!(z>=0.0);if(n){F=-z}else{F=z}if(F>1.0){G=1.0/z}else{G=q}if(n){H=-z}else{H=z}if(H>1.0){I=+V(+(1.0-G*G))}else{I=A}if(n){J=-z;K=!(z>=-1.0)?I:z}else{J=z;K=!(z<=1.0)?I:z}if(!(J<=1.0)){L=G}else{L=+V(+(1.0-K*K))}if(!a){n=(fa(m,k)|0)+e|0;f=fa(l,k)|0;B=1;while(1){r=d+(n+B<<3)|0;z=+h[r>>3];t=d+(B+e+f<<3)|0;o=+h[t>>3];h[t>>3]=L*o-K*z;h[r>>3]=L*z+K*o;if((B|0)<(p|0)){B=B+1|0}else{break}}}if((m|0)<(b|0)){q=L;m=m+1|0;A=K}else{break}}i=j;return 0}function Eya(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,W=0.0;e=i;l=+sya(233840);m=c[b>>2]|0;n=c[a>>2]|0;o=(fa(1-m+(n<<1)|0,m)|0)/2|0;p=o+(m-n)|0;if((m|0)<=(n|0)){q=m;r=p;while(1){h[j+(q+ -1<<3)>>3]=+h[d+(r+ -1<<3)>>3];if((q|0)<(n|0)){r=r+1|0;q=q+1|0}else{break}}}q=m+ -1|0;r=(m|0)<2;if(r){s=p}else{t=(q|0)>1?q:1;u=t+ -1|0;v=(m<<1)+o+(fa(u,m+ -3-n|0)|0)+ -2-n|0;o=Q$a(u|0,0,t+ -2|0,0)|0;t=J$a(o|0,J&1|0,1)|0;o=p;p=1;while(1){u=m-p|0;w=o+ -1+u-n|0;x=u+ -1|0;h[j+(x<<3)>>3]=0.0;y=g+(x<<3)|0;z=+h[y>>3];do{if(!(z==0.0)){x=g+(q<<3)|0;A=+h[x>>3];if(!(A>=0.0)){B=-A}else{B=A}if(!(z>=0.0)){C=-z}else{C=z}do{if(!(B>=C)){D=A/z;E=.5/+V(+(D*D*.25+.25));F=D*E;if(!(F>=0.0)){G=-F}else{G=F}if(!(l*G>1.0)){H=F;I=E;K=1.0;break}H=F;I=E;K=1.0/F}else{F=z/A;E=.5/+V(+(F*F*.25+.25));D=F*E;H=E;I=D;K=D}}while(0);h[x>>3]=I*z+H*A;h[y>>3]=K;if((u|0)>(n|0)){break}else{L=u;M=w}while(1){N=d+(M+ -1<<3)|0;D=+h[N>>3];O=j+(L+ -1<<3)|0;E=+h[O>>3];h[O>>3]=I*D+H*E;h[N>>3]=H*D-I*E;if((L|0)<(n|0)){M=M+1|0;L=L+1|0}else{break}}}}while(0);if((p|0)<(q|0)){p=p+1|0;o=w}else{break}}s=v-n-t|0}if((n|0)>=1){t=g+(q<<3)|0;g=1;while(1){v=g+ -1|0;o=j+(v<<3)|0;h[o>>3]=+h[o>>3]+ +h[t>>3]*+h[f+(v<<3)>>3];if((g|0)<(n|0)){g=g+1|0}else{break}}}c[k>>2]=0;if(r){P=s}else{r=1;g=s;while(1){s=j+(r+ -1<<3)|0;I=+h[s>>3];n=d+(g+ -1<<3)|0;if(!(I==0.0)){H=+h[n>>3];if(!(H>=0.0)){Q=-H}else{Q=H}if(!(I>=0.0)){R=-I}else{R=I}do{if(!(Q>=R)){K=H/I;G=.5/+V(+(K*K*.25+.25));C=K*G;if(!(C>=0.0)){S=-C}else{S=C}if(!(l*S>1.0)){T=C;U=G;W=1.0;break}T=C;U=G;W=1.0/C}else{C=I/H;G=.5/+V(+(C*C*.25+.25));K=C*G;T=G;U=K;W=K}}while(0);w=c[a>>2]|0;a:do{if((r|0)<=(w|0)){K=I;G=H;f=r;t=g;while(1){h[j+(f+ -1<<3)>>3]=T*K-U*G;h[d+(t+ -1<<3)>>3]=T*G+U*K;if((f|0)>=(w|0)){break a}K=+h[j+(f<<3)>>3];G=+h[d+(t<<3)>>3];f=f+1|0;t=t+1|0}}}while(0);h[s>>3]=W}if(+h[n>>3]==0.0){c[k>>2]=1}w=1-r+g+(c[a>>2]|0)|0;if((r|0)<(q|0)){r=r+1|0;g=w}else{P=w;break}}}g=c[a>>2]|0;a=c[b>>2]|0;if((a|0)<=(g|0)){b=a;a=P;while(1){h[d+(a+ -1<<3)>>3]=+h[j+(b+ -1<<3)>>3];if((b|0)<(g|0)){a=a+1|0;b=b+1|0}else{break}}}if(!(+h[d+(P+ -1<<3)>>3]==0.0)){i=e;return 0}c[k>>2]=1;i=e;return 0}function Fya(b,d,e,f,g,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,W=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0,Ka=0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0,Va=0;s=i;t=c[d>>2]|0;u=~t;h[29250]=.5;h[29268]=6.283185307179586;v=+h[l>>3];h[29263]=v*v;c[58522]=0;l=c[b>>2]|0;c[58540]=l;c[58538]=l;w=c[b>>2]|0;c[58462]=1;if((w|0)<1){x=l;y=0}else{z=1;while(1){A=z+ -1|0;h[n+(A<<3)>>3]=+h[e+(A<<3)>>3];if((z|0)<(w|0)){z=z+1|0}else{break}}c[58462]=w+1;x=l;y=0}a:while(1){w=c[b>>2]|0;c[58462]=1;if((w|0)>=1){z=1;while(1){h[p+(z+ -1<<3)>>3]=0.0;if((z|0)<(w|0)){z=z+1|0}else{break}}c[58462]=w+1}z=c[d>>2]|0;c[58466]=1;if((z|0)>=1){e=1;while(1){h[29254]=0.0;A=c[b>>2]|0;c[58464]=1;if((A|0)<1){B=0.0}else{v=0.0;C=1;while(1){D=+h[f+((fa(C,t)|0)+u+e<<3)>>3];E=v+D*+h[n+(C+ -1<<3)>>3];h[29254]=E;if((C|0)<(A|0)){C=C+1|0;v=E}else{break}}c[58464]=A+1;B=E}v=+h[k+(e+ -1<<3)>>3]*B;h[29254]=v;C=c[b>>2]|0;c[58462]=1;if((C|0)>=1){D=v;F=1;while(1){v=D*+h[f+((fa(F,t)|0)+u+e<<3)>>3];G=p+(F+ -1<<3)|0;h[G>>3]=+h[G>>3]+v;if((F|0)>=(C|0)){break}D=+h[29254];F=F+1|0}c[58462]=C+1}F=e+1|0;c[58466]=F;if((e|0)<(z|0)){e=F}else{break}}}c[58476]=0;e=c[b>>2]|0;c[58464]=1;if((e|0)>=1){z=1;w=0;while(1){if((z|0)<1){H=1;I=w}else{F=z+ -1|0;A=p+(F<<3)|0;G=n+(F<<3)|0;F=z+1|0;J=1;K=w;while(1){L=j+(K<<3)|0;if((J|0)<(z|0)){M=J+ -1|0;h[A>>3]=+h[A>>3]+ +h[L>>3]*+h[n+(M<<3)>>3];N=M}else{N=J+ -1|0}M=p+(N<<3)|0;h[M>>3]=+h[L>>3]*+h[G>>3]+ +h[M>>3];if((J|0)<(z|0)){J=J+1|0;K=K+1|0}else{break}}K=z+w|0;c[58476]=K;H=F;I=K}if((z|0)<(e|0)){z=z+1|0;w=I}else{break}}c[58462]=H;c[58464]=e+1}do{if((y|0)==0){h[29252]=0.0;h[29234]=0.0;w=c[b>>2]|0;c[58462]=1;if((w|0)>=1){z=1;while(1){h[m+(z+ -1<<3)>>3]=0.0;K=z+ -1|0;h[q+(K<<3)>>3]=0.0;D=+h[g+(K<<3)>>3]+ +h[p+(K<<3)>>3];h[o+(K<<3)>>3]=D;h[n+(K<<3)>>3]=-D;h[29234]=+h[29234]+D*D;if((z|0)<(w|0)){z=z+1|0}else{break}}c[58462]=w+1}h[r>>3]=0.0;D=+h[29234];if(D==0.0){O=55;break a}h[29239]=0.0;h[29242]=0.0;h[29237]=D;h[29257]=D;P=D;Q=0.0;R=0.0;S=+h[29263];T=0}else{if((y|0)>(x|0)){h[29236]=0.0;h[29243]=0.0;h[29244]=0.0;z=c[b>>2]|0;c[58462]=1;if((z|0)<1){U=0.0;W=0.0;Z=0.0}else{D=0.0;v=0.0;_=0.0;F=1;while(1){K=F+ -1|0;$=_+ +h[n+(K<<3)>>3]*+h[o+(K<<3)>>3];h[29236]=$;K=F+ -1|0;J=p+(K<<3)|0;aa=v+ +h[J>>3]*+h[n+(K<<3)>>3];h[29243]=aa;ba=D+ +h[J>>3]*+h[m+(K<<3)>>3];h[29244]=ba;if((F|0)<(z|0)){F=F+1|0;_=$;v=aa;D=ba}else{break}}c[58462]=z+1;U=ba;W=$;Z=aa}D=+h[29250];v=D*(+h[29247]-Z);h[29235]=v;_=+h[29240];ca=_+v;h[29251]=ca;h[29255]=ca;h[29253]=ca;c[58532]=0;a[233928]=1;da=+h[29268]/50.0;h[29254]=da;c[58462]=1;F=0;ea=ca;ga=ca;w=1;while(1){ha=+(w|0)*da;ia=+X(+ha);ja=+Y(+ha);ka=ia*(_+ia*v)+ja*(W+ia*U);do{if(ka<ea){h[29253]=ka;c[58532]=w;h[29264]=ga;la=w;ma=ka}else{if((w|0)!=(F+1|0)){la=F;ma=ea;break}h[29265]=ka;la=F;ma=ea}}while(0);K=w+1|0;if((K|0)<50){F=la;ea=ma;w=K;ga=ka}else{break}}h[29259]=ha;h[29245]=ia;h[29248]=ja;h[29256]=ka;c[58462]=50;h[29255]=ka;if((la|0)==49){h[29265]=ca;na=ca}else if((la|0)==0){h[29264]=ka;O=46}else{O=46}if((O|0)==46){O=0;na=+h[29265]}h[29259]=0.0;ga=+h[29264];if(ga!=na){ea=ga-ma;h[29264]=ea;ga=na-ma;h[29265]=ga;oa=D*(ea-ga)/(ea+ga);h[29259]=oa;pa=oa}else{pa=0.0}oa=da*(+(la|0)+pa);h[29259]=oa;ga=+X(+oa);h[29245]=ga;ea=+Y(+oa);h[29248]=ea;oa=ca-ga*(_+ga*v)-ea*(W+ga*U);h[29260]=oa;h[29237]=0.0;w=c[b>>2]|0;c[58462]=1;if((w|0)<1){qa=0.0;ra=oa}else{oa=ea;ea=ga;F=1;z=0;while(1){K=m+(z<<3)|0;h[K>>3]=ea*+h[K>>3]+oa*+h[n+(z<<3)>>3];K=F+ -1|0;J=q+(K<<3)|0;ga=+h[29245]*+h[J>>3]+ +h[29248]*+h[p+(K<<3)>>3];h[J>>3]=ga;sa=+h[o+(K<<3)>>3]+ga;ta=+h[29237]+sa*sa;h[29237]=ta;if((F|0)>=(w|0)){break}K=F;oa=+h[29248];ea=+h[29245];F=F+1|0;z=K}c[58462]=w+1;qa=ta;ra=+h[29260]}ea=ra+ +h[29252];h[29252]=ea;if((y|0)<(l|0)&ra/ea>.01){ua=qa;va=x}else{O=55;break a}}else{h[29243]=0.0;z=c[b>>2]|0;c[58464]=1;do{if((z|0)<1){ea=+h[29267];h[29258]=ea;wa=ea;xa=0.0;O=11}else{ea=0.0;F=1;while(1){K=F+ -1|0;ya=ea+ +h[n+(K<<3)>>3]*+h[p+(K<<3)>>3];h[29243]=ya;if((F|0)<(z|0)){F=F+1|0;ea=ya}else{break}}c[58464]=z+1;ea=+h[29267];h[29258]=ea;if(!(ya>0.0)){wa=ea;xa=ya;O=11;break}ea=ya/+h[29234];h[29254]=ea;if((y|0)==1){h[r>>3]=ea;za=ea;Aa=+h[29254]}else{za=+h[r>>3];Aa=ea}h[r>>3]=!(za<=Aa)?Aa:za;ea=+h[29258];oa=+h[29237];v=+h[29243];_=oa/v;ca=ea<=_?ea:_;h[29258]=ca;Ba=oa;Ca=v;Da=ca}}while(0);if((O|0)==11){O=0;Ba=+h[29237];Ca=xa;Da=wa}ca=Da*(Ba-Da*+h[29250]*Ca);h[29249]=ca;h[29252]=+h[29252]+ca;h[29262]=Ba;h[29237]=0.0;z=c[b>>2]|0;c[58462]=1;if((z|0)<1){Ea=Da;Fa=0.0}else{w=1;ca=Da;while(1){F=w+ -1|0;K=m+(F<<3)|0;h[K>>3]=+h[K>>3]+ca*+h[n+(F<<3)>>3];F=w+ -1|0;K=q+(F<<3)|0;v=+h[K>>3]+ +h[29258]*+h[p+(F<<3)>>3];h[K>>3]=v;oa=+h[o+(F<<3)>>3]+v;Ga=+h[29237]+oa*oa;h[29237]=Ga;Ha=+h[29258];if((w|0)<(z|0)){ca=Ha;w=w+1|0}else{break}}c[58462]=z+1;Ea=Ha;Fa=Ga}if(Ea<+h[29267]){if(+h[29249]<=+h[29252]*.01){O=55;break a}if(Fa<=+h[29257]*1.0e-4|(y|0)==(l|0)){O=55;break a}ca=Fa/+h[29262];h[29254]=ca;h[29234]=0.0;h[29239]=0.0;h[29242]=0.0;w=c[b>>2]|0;c[58462]=1;if((w|0)<1){O=55;break a}else{Ia=ca;Ja=1;Ka=0}while(1){F=n+(Ka<<3)|0;h[F>>3]=Ia*+h[F>>3]- +h[o+(Ka<<3)>>3]- +h[q+(Ka<<3)>>3];F=Ja+ -1|0;K=n+(F<<3)|0;ca=+h[K>>3];La=+h[29234]+ca*ca;h[29234]=La;J=m+(F<<3)|0;Ma=+h[29239]+ +h[K>>3]*+h[J>>3];h[29239]=Ma;ca=+h[J>>3];Na=+h[29242]+ca*ca;h[29242]=Na;if((Ja|0)>=(w|0)){break}J=Ja;Ia=+h[29254];Ja=Ja+1|0;Ka=J}c[58462]=w+1;if(Ma<=0.0){O=55;break a}ca=+h[29263];if(Na<ca){P=La;Q=Ma;R=Na;S=ca;T=y;break}}h[r>>3]=0.0;c[58538]=y;ua=+h[29237];va=y}if(ua<=+h[29257]*1.0e-4){O=55;break a}h[29240]=0.0;h[29247]=0.0;z=c[b>>2]|0;c[58462]=1;if((z|0)<1){Oa=0.0;Pa=0.0}else{ca=0.0;oa=0.0;J=1;while(1){K=J+ -1|0;Qa=oa+ +h[m+(K<<3)>>3]*+h[o+(K<<3)>>3];h[29240]=Qa;K=J+ -1|0;Ra=ca+ +h[m+(K<<3)>>3]*+h[q+(K<<3)>>3];h[29247]=Ra;if((J|0)<(z|0)){J=J+1|0;oa=Qa;ca=Ra}else{break}}c[58462]=z+1;Oa=Ra;Pa=Qa}ca=Pa+Oa;h[29246]=ca;oa=+h[29263];v=ua*oa;if(ca/+V(+v)<=-.99){O=55;break a}J=y+1|0;c[58522]=J;_=+V(+(v-ca*ca));h[29254]=_;v=oa/_;h[29264]=v;oa=ca/_;h[29265]=oa;w=c[b>>2]|0;c[58462]=1;if((w|0)<1){x=va;y=J;continue a}else{Sa=oa;Ta=v;Ua=1;Va=0}while(1){h[n+(Va<<3)>>3]=Ta*(+h[o+(Va<<3)>>3]+ +h[q+(Va<<3)>>3])-Sa*+h[m+(Va<<3)>>3];if((Ua|0)>=(w|0)){break}K=Ua;Sa=+h[29265];Ta=+h[29264];Ua=Ua+1|0;Va=K}c[58462]=w+1;x=va;y=J;continue a}}while(0);e=T+1|0;c[58522]=e;v=S-R;h[29254]=v;h[29267]=v/(Q+ +V(+(Q*Q+v*P)));y=e;x=x}if((O|0)==55){i=s;return 0}return 0}function Gya(b,d,e,f,g,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0,R=0;o=i;p=c[d>>2]|0;q=~p;r=c[j>>2]|0;j=~r;h[29277]=1.0;s=p-(c[b>>2]|0)|0;t=s+ -1|0;c[58560]=t;c[58550]=1;c[58544]=2;if((s|0)<3){u=1}else{s=2;v=1;while(1){do{if((s|0)==(c[g>>2]|0)){c[58550]=s;w=s}else{x=c[m>>2]|0;y=fa(s,p)|0;z=+h[f+(y+q+x<<3)>>3];if(!(z!=0.0)){w=v;break}A=fa(v,p)|0;B=x+q|0;x=f+(B+A<<3)|0;C=+h[x>>3];D=+V(+(z*z+C*C));h[29279]=D;C=+h[x>>3]/D;h[29286]=C;z=+h[f+(B+y<<3)>>3]/D;h[29287]=z;B=c[d>>2]|0;c[58542]=1;if((B|0)>=1){D=z;z=C;x=1;while(1){E=x+q|0;h[29279]=z*+h[f+(E+A<<3)>>3]+D*+h[f+(E+y<<3)>>3];E=x+q|0;F=f+(E+y<<3)|0;G=f+(E+A<<3)|0;h[F>>3]=z*+h[F>>3]-D*+h[G>>3];h[G>>3]=+h[29279];if((x|0)>=(B|0)){break}D=+h[29287];z=+h[29286];x=x+1|0}c[58542]=B+1}h[f+((c[m>>2]|0)+q+y<<3)>>3]=0.0;w=v}}while(0);x=s+1|0;c[58544]=x;if((s|0)<(t|0)){s=x;v=w}else{u=w;break}}}w=c[m>>2]|0;z=+h[f+(w+ -1<<3)>>3];h[29286]=z;if((c[g>>2]|0)>1){D=-z;h[29286]=D;H=D}else{H=z}v=(u|0)>1;if(v){h[29287]=+h[f+((fa(u,p)|0)+q+w<<3)>>3]}w=c[d>>2]|0;c[58542]=1;if((w|0)>=1){s=(fa(u,p)|0)+q|0;z=H;t=1;x=0;while(1){h[n+(x<<3)>>3]=z*+h[f+(x<<3)>>3];if(v){A=n+(t+ -1<<3)|0;h[A>>3]=+h[A>>3]+ +h[29287]*+h[f+(s+t<<3)>>3]}if((t|0)>=(w|0)){break}A=t;z=+h[29286];t=t+1|0;x=A}c[58542]=w+1}w=(c[m>>2]|0)+ -1|0;z=+h[n+(w<<3)>>3];h[29284]=z;x=k+(w<<3)|0;H=+h[x>>3];h[29278]=H;D=H*H;h[29288]=D;h[29285]=D+z*+h[l>>3];h[x>>3]=+h[x>>3]- +h[29277];a[234248]=0;do{if((u|0)==1){z=+h[29285];if(!(z>=0.0)){I=-z}else{I=z}z=+V(+I);h[29279]=z;D=+h[29286]/z;h[29287]=D;H=+h[29278]/z;h[29286]=H;x=c[d>>2]|0;c[58542]=1;if((x|0)<1){J=z}else{z=D;D=H;w=1;t=0;while(1){s=f+(t<<3)|0;h[s>>3]=D*+h[s>>3]-z*+h[k+(t<<3)>>3];if((w|0)>=(x|0)){break}s=w;z=+h[29287];D=+h[29286];w=w+1|0;t=s}c[58542]=x+1;J=+h[29279]}t=c[g>>2]|0;if((t|0)==1&J<0.0){c[g>>2]=2;K=2}else{K=t}if(!((K|0)<2|!(J>=0.0))){L=46}}else{c[58546]=1;if(!(+h[l>>3]>=0.0)){M=1}else{c[58546]=u;M=u}t=u+1-M|0;c[58548]=t;w=fa(t,p)|0;t=(c[m>>2]|0)+q|0;D=+h[29285];z=+h[f+(t+w<<3)>>3]/D;h[29279]=z;h[29286]=z*+h[l>>3];H=+h[29278];h[29287]=z*H;s=fa(M,p)|0;z=+h[f+(t+s<<3)>>3];h[29279]=z;C=+h[l>>3];if(!(C>=0.0)){N=-C}else{N=C}C=+h[29277]/+V(+(+h[29288]+z*N*z));h[29282]=C;if(!(D>=0.0)){O=-D}else{O=D}h[29283]=C*+V(+O);t=c[d>>2]|0;c[58542]=1;if((t|0)<1){P=D}else{D=z;z=H;H=C;v=1;while(1){A=f+(v+q+s<<3)|0;h[A>>3]=H*(z*+h[A>>3]-D*+h[k+(v+ -1<<3)>>3]);A=f+(v+q+w<<3)|0;G=v+ -1|0;h[A>>3]=+h[29283]*(+h[A>>3]- +h[29286]*+h[n+(G<<3)>>3]- +h[29287]*+h[k+(G<<3)>>3]);if((v|0)>=(t|0)){break}D=+h[29279];z=+h[29278];H=+h[29282];v=v+1|0}c[58542]=t+1;P=+h[29285]}if(!(P<=0.0)){break}H=+h[l>>3];if(H<0.0){c[g>>2]=(c[g>>2]|0)+1}if(H>=0.0){L=46}}}while(0);do{if((L|0)==46){a[234248]=1;c[g>>2]=(c[g>>2]|0)+ -1;M=c[d>>2]|0;c[58542]=1;if((M|0)<1){break}else{Q=1}while(1){u=f+(Q+ -1<<3)|0;h[29279]=+h[u>>3];K=f+(Q+q+(fa(c[g>>2]|0,p)|0)<<3)|0;h[u>>3]=+h[K>>3];h[K>>3]=+h[29279];K=Q+1|0;c[58542]=K;if((Q|0)<(M|0)){Q=K}else{break}}}}while(0);Q=c[b>>2]|0;c[58544]=1;if((Q|0)<1){i=o;return 0}else{R=1}while(1){b=(c[d>>2]|0)+R|0;c[58552]=b;p=fa(R,r)|0;P=+h[e+((c[m>>2]|0)+j+p<<3)>>3];g=b+ -1|0;q=n+(g<<3)|0;h[q>>3]=P;f=k+(g<<3)|0;O=+h[29278];N=+h[29285];J=(+h[29284]*+h[f>>3]-O*P)/N;h[29286]=J;P=(-(+h[l>>3]*+h[q>>3])-O*+h[f>>3])/N;h[29287]=P;c[58542]=1;a:do{if((b|0)>=1){N=P;O=J;f=1;while(1){q=e+(f+j+p<<3)|0;g=f+ -1|0;I=+h[q>>3]+O*+h[k+(g<<3)>>3]+N*+h[n+(g<<3)>>3];h[q>>3]=I;q=c[d>>2]|0;if((f|0)>(q|0)){h[e+((fa(f-q|0,r)|0)+j+b<<3)>>3]=I}q=f+1|0;c[58542]=q;if((f|0)>=(b|0)){break a}N=+h[29287];O=+h[29286];f=q}}}while(0);b=R+1|0;c[58544]=b;if((R|0)<(Q|0)){R=b}else{break}}i=o;return 0}function Hya(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0;m=i;if((b|0)<(d|0)){n=(b|0)<(e|0);o=0.0;p=-1;q=-1;r=b;while(1){if(n){s=c[f+(r<<2)>>2]|0;t=b;u=o;v=p;w=q;while(1){x=+U(+(+h[a+((fa(c[g+(t<<2)>>2]|0,d)|0)+s<<3)>>3]));y=x>u;z=y?r:w;A=y?t:v;B=y?x:u;y=t+1|0;if((y|0)<(e|0)){w=z;v=A;u=B;t=y}else{C=B;D=A;E=z;break}}}else{C=o;D=p;E=q}t=r+1|0;if((t|0)<(d|0)){o=C;p=D;q=E;r=t}else{F=C;G=D;H=E;break}}}else{F=0.0;G=-1;H=-1}if((G|H|0)<0){I=-1;i=m;return I|0}c[j>>2]=H;c[k>>2]=G;h[l>>3]=F;I=0;i=m;return I|0}function Iya(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0;g=i;i=i+24|0;j=g;k=g+8|0;l=g+16|0;m=(b|0)<=(d|0)?b:d;if((m|0)>0){n=0}else{o=0;i=g;return o|0}while(1){p=e+(n<<2)|0;q=f+(n<<2)|0;r=+h[a+((fa(c[q>>2]|0,b)|0)+(c[p>>2]|0)<<3)>>3];if((Hya(a,n,b,d,e,f,j,k,l)|0)!=0){o=-1;s=14;break}t=+U(+r);if(+h[l>>3]>t*1.125){u=c[p>>2]|0;v=e+(c[j>>2]<<2)|0;c[p>>2]=c[v>>2];c[v>>2]=u;u=c[q>>2]|0;v=f+(c[k>>2]<<2)|0;c[q>>2]=c[v>>2];c[v>>2]=u}u=c[p>>2]|0;p=fa(c[q>>2]|0,b)|0;t=+h[a+(p+u<<3)>>3];if(!(t!=0.0)){s=7;break}q=n+1|0;if((q|0)<(b|0)){v=(q|0)<(d|0);w=q;do{x=c[e+(w<<2)>>2]|0;y=a+(p+x<<3)|0;r=+h[y>>3];do{if(r!=0.0){z=-r/t;h[y>>3]=0.0;if(v){A=q}else{break}do{B=fa(c[f+(A<<2)>>2]|0,b)|0;C=a+(B+x<<3)|0;h[C>>3]=+h[C>>3]+z*+h[a+(u+B<<3)>>3];A=A+1|0;}while((A|0)<(d|0))}}while(0);w=w+1|0;}while((w|0)<(b|0))}if((q|0)<(m|0)){n=q}else{o=0;s=14;break}}if((s|0)==7){db(234312,234328,116,234352)}else if((s|0)==14){i=g;return o|0}return 0}function Jya(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=e;c[u>>2]=0;v=b+280|0;w=c[v>>2]|0;x=1;while(1){y=x+1|0;if((t$a(w,c[234360+(x<<2)>>2]|0)|0)==0){z=4;break}if((y|0)<8){x=y}else{break}}do{if((z|0)==4){c[u>>2]=x;if((x|0)==0){break}y=c[234464+(x<<2)>>2]|0;c[q>>2]=c[234360+(x<<2)>>2];c[q+4>>2]=y;hwa(23,0,234536,q);y=b+112|0;A=e+28|0;c[A>>2]=(c[y>>2]|0)+20;B=c[y>>2]|0;C=b+160|0;D=((c[C>>2]|0)*3|0)+50+(fa(B+9|0,B)|0)|0;c[e+32>>2]=D;B=X_a(D,8)|0;c[e+40>>2]=B;D=b+536|0;kwa(c[D>>2]|0,(B|0)!=0|0,234576,p);B=X_a(c[A>>2]|0,4)|0;c[e+36>>2]=B;kwa(c[D>>2]|0,(B|0)!=0|0,234576,o);c[e+56>>2]=c[C>>2];c[e+52>>2]=0;c[e+60>>2]=X_a(c[C>>2]|0,4)|0;c[e+24>>2]=V_a(8)|0;C=V_a(4)|0;c[e+20>>2]=C;c[C>>2]=c[206200>>2];kwa(c[D>>2]|0,(C|0)!=0|0,234576,n);C=c[y>>2]<<3;B=e+48|0;c[B>>2]=V_a(C)|0;A=e+44|0;c[A>>2]=V_a(C)|0;C=X_a(15,4)|0;E=e+12|0;c[E>>2]=C;kwa(c[D>>2]|0,(C|0)!=0|0,234576,m);C=X_a(5,4)|0;c[e+4>>2]=C;kwa(c[D>>2]|0,(C|0)!=0|0,234576,l);C=X_a(5,4)|0;c[e+8>>2]=C;kwa(c[D>>2]|0,(C|0)!=0|0,234576,k);c[e+16>>2]=0;h[e+64>>3]=1.4901161193847656e-8;C=c[y>>2]<<3;c[e+72>>2]=V_a(C)|0;c[e+76>>2]=V_a(C)|0;c[e+80>>2]=V_a(C)|0;C=c[E>>2]|0;c[C+8>>2]=1;D=c[u>>2]|0;a:do{switch(D|0){case 7:case 1:case 2:case 4:case 5:case 3:{if((oe[c[(c[b+540>>2]|0)+140>>2]&127](b)|0)==0){F=c[E>>2]|0;c[F+16>>2]=1;G=F;H=c[u>>2]|0;z=17;break a}if((c[y>>2]|0)==1){hwa(23,0,234592,j)}else{hwa(1,0,234664,g)}c[u>>2]=6;z=18;break};default:{G=C;H=D;z=17}}}while(0);if((z|0)==17){if((H|0)==2){I=G}else{z=18}}if((z|0)==18){a[d+28|0]=1;I=c[E>>2]|0}c[I+4>>2]=1;D=c[y>>2]|0;if((D|0)<=0){i=f;return 0}C=b+272|0;F=c[A>>2]|0;J=c[b+8>>2]|0;K=c[B>>2]|0;L=0;do{h[F+(L<<3)>>3]=+h[C>>3];h[K+(L<<3)>>3]=+h[C>>3]*+h[J+(L*112|0)+80>>3];L=L+1|0;}while((L|0)<(D|0));i=f;return 0}}while(0);if((c[206236>>2]|c[51534]|0)==0){M=w;N=b;O=N+536|0;P=O;Q=c[P>>2]|0;R=r;S=R;c[S>>2]=M;T=5;U=T;V=234496;W=V;lwa(Q,W,r)}c[t>>2]=w;jwa(23,1,234392,t);t=1;do{w=c[234464+(t<<2)>>2]|0;c[s>>2]=c[234360+(t<<2)>>2];c[s+4>>2]=w;jwa(23,0,234448,s);t=t+1|0;}while((t|0)<8);le[c[51674]&2047](23);M=c[v>>2]|0;N=b;O=N+536|0;P=O;Q=c[P>>2]|0;R=r;S=R;c[S>>2]=M;T=5;U=T;V=234496;W=V;lwa(Q,W,r);return 0}function Kya(a){a=a|0;var b=0;b=i;W_a(c[a+40>>2]|0);W_a(c[a+36>>2]|0);W_a(c[a+20>>2]|0);W_a(c[a+12>>2]|0);W_a(c[a+4>>2]|0);W_a(c[a+8>>2]|0);W_a(a);i=b;return 0}function Lya(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;s=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;h[D>>3]=0.0;E=a+4|0;F=c[E>>2]|0;G=c[F>>2]|0;H=c[b+48>>2]|0;I=(c[F+4>>2]|0)+8|0;F=c[I>>2]|0;J=a+112|0;K=c[J>>2]|0;L=F+(K<<3)|0;M=H+24|0;c[c[M>>2]>>2]=a;c[(c[M>>2]|0)+4>>2]=H;N=a+536|0;kwa(c[N>>2]|0,(c[M>>2]|0)!=0|0,234760,C);if((c[b+36>>2]|0)!=0){c[c[H+12>>2]>>2]=0;c[H+16>>2]=0}C=b;O=+h[C>>3];P=b+8|0;Q=O+ +h[P>>3];h[D>>3]=Q;if(O-Q>=-1.0e-13){hwa(3,0,234792,B);hwa(3,0,234832,A);A=c[J>>2]|0;if((A|0)>0){B=c[I>>2]|0;I=c[G+8>>2]|0;R=0;do{h[I+(R<<3)>>3]=+h[B+(R<<3)>>3]+ +h[F+(R+K<<3)>>3]*+h[P>>3];R=R+1|0;}while((R|0)<(A|0))}h[G>>3]=+h[D>>3];oe[c[(c[a+540>>2]|0)+28>>2]&127](a)|0;h[C>>3]=+h[D>>3];S=0;i=d;return S|0}A=z;h[k>>3]=O;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=Q;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];hwa(3,0,234856,z);z=H+16|0;A=z;R=a;P=b+24|0;b=H+12|0;K=H+44|0;F=H+48|0;B=H+40|0;I=H+32|0;T=H+36|0;U=H+28|0;V=U;W=H+20|0;X=H+52|0;Y=H+56|0;Z=H+60|0;_=c[r>>2]|0;$=c[t>>2]|0;aa=a+248|0;ba=a+540|0;ca=G;G=L;a:while(1){Q=+h[D>>3];L=y;h[k>>3]=+h[C>>3];c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];L=y+8|0;h[k>>3]=Q;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];hwa(23,0,234896,y);if((c[z>>2]|0)==1){qxa(c[R>>2]|0,1,c[E>>2]|0);L=c[E>>2]|0;da=c[L>>2]|0;ea=(c[(c[L+4>>2]|0)+8>>2]|0)+(c[J>>2]<<3)|0;h[da>>3]=+h[C>>3];fa=da;ga=ea}else{fa=ca;ga=G}if((c[P>>2]|0)!=5){IAa(a)|0;oe[c[(c[ba>>2]|0)+40>>2]&127](a)|0}ea=c[H>>2]|0;b:do{switch(ea|0){case 3:{Uxa(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,3,2,Y,c[Z>>2]|0)|0;break};case 7:{Uxa(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,7,3,X,0)|0;break};case 5:{Uxa(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,5,2,Y,c[Z>>2]|0)|0;break};case 6:{Uxa(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,6,2,Y,c[Z>>2]|0)|0;break};case 4:{Uxa(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,4,2,Y,c[Z>>2]|0)|0;break};default:{da=c[fa+8>>2]|0;L=c[b>>2]|0;ha=c[K>>2]|0;ia=c[F>>2]|0;ja=c[B>>2]|0;ka=c[T>>2]|0;la=c[M>>2]|0;ma=c[W>>2]|0;if((ea|0)==2){Uxa(1,J,C,da,ga,D,L,ha,ia,A,ja,I,ka,V,la,ma,7,3,X,0)|0;break b}else{Uxa(1,J,C,da,ga,D,L,ha,ia,A,ja,I,ka,V,la,ma,7,2,Y,c[Z>>2]|0)|0;break b}}}}while(0);ea=c[z>>2]|0;do{if((ea|0)==-1){Ad(_|0)|0;Ad($|0)|0;jwa(3,0,234928,x);hwa(3,0,235016,w);c[c[b>>2]>>2]=1}else{if((ea|0)<0){na=25;break a}if((ea|0)!=4){break}c[(c[N>>2]|0)+84>>2]=4}}while(0);ea=c[z>>2]|0;if((ea|0)==1){ca=fa;G=ga;continue}else if(!((ea|0)==-1)){na=31;break}Q=+h[C>>3];if(!(Q<=+h[aa>>3])){oa=Q;break}else{ca=fa;G=ga}}if((na|0)==25){Ad(_|0)|0;Ad($|0)|0;$=Uya(c[z>>2]|0)|0;if((c[P>>2]|0)!=5){IAa(a)|0;oe[c[(c[ba>>2]|0)+40>>2]&127](a)|0}oe[c[(c[ba>>2]|0)+28>>2]&127](a)|0;a=v;h[k>>3]=+h[fa>>3];c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];jwa(1,0,235040,v);S=$;i=d;return S|0}else if((na|0)==31){oa=+h[C>>3]}h[fa>>3]=oa;if((c[206156>>2]|0)!=0){hwa(3,1,235072,u);c[s>>2]=c[z>>2];hwa(3,0,235096,s);s=q;h[k>>3]=+h[C>>3];c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];hwa(3,0,235120,q);q=p;h[k>>3]=+h[(c[B>>2]|0)+24>>3];c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];hwa(3,0,235152,p);p=o;h[k>>3]=+h[(c[B>>2]|0)+16>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];hwa(3,0,235192,o);o=n;h[k>>3]=+h[(c[B>>2]|0)+48>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];hwa(3,0,235240,n);c[m>>2]=c[(c[T>>2]|0)+40>>2];hwa(3,0,235288,m);c[l>>2]=c[(c[T>>2]|0)+44>>2];hwa(3,0,235328,l);c[j>>2]=c[(c[T>>2]|0)+48>>2];hwa(3,0,235368,j);c[g>>2]=c[(c[T>>2]|0)+52>>2];hwa(3,0,235408,g);c[f>>2]=c[(c[T>>2]|0)+56>>2];hwa(3,0,235456,f);le[c[51674]&2047](3)}f=c[U>>2]|0;U=H+8|0;H=0;do{g=H+10|0;if(!(g>>>0<f>>>0)){na=37;break}c[(c[U>>2]|0)+(H<<2)>>2]=c[(c[T>>2]|0)+(g<<2)>>2];H=H+1|0;}while(H>>>0<5);if((na|0)==37){db(235496,235528,410,235560)}hwa(3,0,235576,e);S=0;i=d;return S|0}function Mya(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;f=c[g>>2]|0;g=f;b=f+536|0;k=f+4|0;l=c[c[k>>2]>>2]|0;m=+h[l>>3];h[l>>3]=+h[a>>3];a=(c[b>>2]|0)+84|0;l=c[a>>2]|0;c[a>>2]=2;IAa(g)|0;a=f+540|0;oe[c[(c[a>>2]|0)+40>>2]&127](g)|0;oe[c[(c[a>>2]|0)+28>>2]&127](g)|0;g=c[f+112>>2]|0;if((g|0)<=0){n=c[b>>2]|0;o=n;p=o+84|0;q=p;c[q>>2]=l;r=c[k>>2]|0;s=c[r>>2]|0;t=s;u=t;h[u>>3]=m;i=j;return 0}f=c[(c[c[k>>2]>>2]|0)+8>>2]|0;a=0;do{h[e+(a<<3)>>3]=+h[f+(g+a<<3)>>3]- +h[d+(a<<3)>>3];a=a+1|0;}while((a|0)<(g|0));n=c[b>>2]|0;o=n;p=o+84|0;q=p;c[q>>2]=l;r=c[k>>2]|0;s=c[r>>2]|0;t=s;u=t;h[u>>3]=m;i=j;return 0}function Nya(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;k=c[l>>2]|0;l=k;j=k+4|0;e=c[c[j>>2]>>2]|0;d=e+8|0;n=c[d>>2]|0;o=e;p=+h[o>>3];h[o>>3]=+h[a>>3];c[d>>2]=b;IAa(l)|0;b=k+540|0;oe[c[(c[b>>2]|0)+40>>2]&127](l)|0;oe[c[(c[b>>2]|0)+28>>2]&127](l)|0;Wya(l,f)|0;l=c[k+112>>2]|0;if((l|0)>0){q=0;r=0}else{s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}while(1){k=f+(r<<3)|0;h[k>>3]=+h[k>>3]- +h[g>>3];k=q+1|0;if((k|0)<(l|0)){r=r+1+l|0;q=k}else{break}}s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}function Oya(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0.0;j=i;e=c[g>>2]|0;g=e;d=e+536|0;a=(c[d>>2]|0)+84|0;k=c[a>>2]|0;c[a>>2]=4;a=e+4|0;l=c[c[a>>2]>>2]|0;m=+h[l>>3];h[l>>3]=+h[b>>3];IAa(g)|0;l=e+540|0;oe[c[(c[l>>2]|0)+40>>2]&127](g)|0;oe[c[(c[l>>2]|0)+28>>2]&127](g)|0;oe[c[(c[l>>2]|0)+32>>2]&127](g)|0;re[c[(c[l>>2]|0)+92>>2]&63](g,f,b)|0;c[(c[d>>2]|0)+84>>2]=k;h[c[c[a>>2]>>2]>>3]=m;i=j;return 0}function Pya(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;m=i;n=c[l>>2]|0;Xya(n,a,b,d,e,f,0,j,k,l,0)|0;l=c[n+112>>2]|0;if((l|0)>0){o=0;p=0}else{i=m;return 0}while(1){n=f+(p<<3)|0;h[n>>3]=+h[n>>3]- +h[g>>3];n=o+1|0;if((n|0)<(l|0)){p=p+1+l|0;o=n}else{break}}i=m;return 0}function Qya(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;k=c[l>>2]|0;l=k;j=k+4|0;e=c[c[j>>2]>>2]|0;d=e+8|0;n=c[d>>2]|0;o=e;p=+h[o>>3];h[o>>3]=+h[a>>3];c[d>>2]=b;IAa(l)|0;b=k+540|0;oe[c[(c[b>>2]|0)+40>>2]&127](l)|0;oe[c[(c[b>>2]|0)+28>>2]&127](l)|0;Vya(l,f)|0;l=c[k+112>>2]|0;if((l|0)>0){q=0;r=0}else{s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}while(1){k=f+(r<<3)|0;h[k>>3]=+h[k>>3]- +h[g>>3];k=q+1|0;if((k|0)<(l|0)){r=r+1+l|0;q=k}else{break}}s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}function Rya(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;i=i;return 0}function Sya(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;m=i;n=c[l>>2]|0;Yya(n,a,b,d,e,f,0,j,k,l,0)|0;l=c[n+112>>2]|0;if((l|0)>0){o=0;p=0}else{i=m;return 0}while(1){n=f+(p<<3)|0;h[n>>3]=+h[n>>3]- +h[g>>3];n=o+1|0;if((n|0)<(l|0)){p=p+1+l|0;o=n}else{break}}i=m;return 0}function Tya(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i;return 0}function Uya(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+8|0;c=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;switch(a|0){case-2:{jwa(1,0,235600,k);m=-2;i=b;return m|0};case-6:{jwa(1,0,235640,j);m=-6;i=b;return m|0};case-12:{jwa(1,0,236072,c);m=-12;i=b;return m|0};case-1:{jwa(3,0,234928,l);m=1;i=b;return m|0};case-9:{jwa(1,0,235800,f);m=-9;i=b;return m|0};case-10:{jwa(1,0,235888,e);m=-10;i=b;return m|0};case-8:{jwa(1,0,235752,g);m=-8;i=b;return m|0};case-3:{m=-3;i=b;return m|0};case-33:{jwa(1,0,236120,b);m=-33;i=b;return m|0};case-7:{jwa(1,0,235712,h);m=-7;i=b;return m|0};case-11:{jwa(1,0,235984,d);m=-11;i=b;return m|0};default:{m=-1;i=b;return m|0}}return 0}function Vya(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;e=a+540|0;f=c[(c[e>>2]|0)+120>>2]|0;g=a+464|0;j=c[g>>2]|0;if((c[j+(f*44|0)+24>>2]|0)==0){i=d;return 0}k=a;a=c[j+(f*44|0)>>2]|0;l=j;j=0;do{if((a|0)!=0){m=0;do{if(((c[(c[l+(f*44|0)+20>>2]|0)+(m<<2)>>2]|0)+ -1|0)==(j|0)){h[(c[l+(f*44|0)+28>>2]|0)+(m<<3)>>3]=1.0}m=m+1|0;}while(m>>>0<a>>>0)}oe[c[(c[e>>2]|0)+160>>2]&127](k)|0;l=c[g>>2]|0;a=c[l+(f*44|0)>>2]|0;do{if((a|0)!=0){m=c[l+(f*44|0)+28>>2]|0;n=0;do{do{if(+h[m+(n<<3)>>3]==1.0){if((n|0)==0){o=l+(f*44|0)+8|0;p=0}else{q=l+(f*44|0)+8|0;o=q;p=c[(c[q>>2]|0)+(n+ -1<<2)>>2]|0}q=c[(c[o>>2]|0)+(n<<2)>>2]|0;if(!(p>>>0<q>>>0)){break}r=c[l+(f*44|0)+12>>2]|0;s=c[l+(f*44|0)+4>>2]|0;t=c[l+(f*44|0)+36>>2]|0;u=p;do{v=c[r+(u<<2)>>2]|0;w=(fa(s,n)|0)+v|0;h[b+(w<<3)>>3]=+h[t+(v<<3)>>3];u=u+1|0;}while(u>>>0<q>>>0)}}while(0);n=n+1|0;}while(n>>>0<a>>>0);if((a|0)==0){break}n=c[l+(f*44|0)+20>>2]|0;m=0;do{if(((c[n+(m<<2)>>2]|0)+ -1|0)==(j|0)){h[(c[l+(f*44|0)+28>>2]|0)+(m<<3)>>3]=0.0}m=m+1|0;}while(m>>>0<a>>>0)}}while(0);j=j+1|0;}while(j>>>0<(c[l+(f*44|0)+24>>2]|0)>>>0);i=d;return 0}function Wya(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=a+540|0;f=c[e>>2]|0;g=c[f+120>>2]|0;j=a+464|0;k=c[j>>2]|0;if((c[k+(g*44|0)>>2]|0)==0){i=d;return 0}l=a;a=f;f=c[k+(g*44|0)+28>>2]|0;k=0;m=0;while(1){h[f+(k<<3)>>3]=1.0;oe[c[a+160>>2]&127](l)|0;n=c[j>>2]|0;o=c[n+(g*44|0)+4>>2]|0;if((o|0)==0){p=m}else{q=o>>>0>1?o:1;r=c[n+(g*44|0)+36>>2]|0;s=0;t=m;while(1){h[b+(t<<3)>>3]=+h[r+(s<<3)>>3];u=s+1|0;if(u>>>0<o>>>0){t=t+1|0;s=u}else{break}}p=m+q|0}s=c[n+(g*44|0)+28>>2]|0;h[s+(k<<3)>>3]=0.0;t=k+1|0;if(!(t>>>0<(c[n+(g*44|0)>>2]|0)>>>0)){break}a=c[e>>2]|0;f=s;k=t;m=p}i=d;return 0}function Xya(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0;n=i;j=c[m+4>>2]|0;o=+h[j+64>>3];p=a+112|0;a=c[p>>2]|0;if((a|0)<=0){i=n;return 0}q=j+80|0;j=a;do{j=j+ -1|0;r=+h[k>>3]*+h[e+(j<<3)>>3];a=d+(j<<3)|0;s=+h[a>>3];if(!(s>=0.0)){t=-s}else{t=s}u=r>=0.0;if(u){v=r}else{v=-r}r=+zd(+t,+v);w=+h[l+(j<<3)>>3];if(!(w>=0.0)){x=-w}else{x=w}w=o*+zd(+r,+x);if(u){y=w}else{y=-w}w=y+s-s;r=1.0/w;h[a>>3]=s+w;Mya(b,0,e,c[q>>2]|0,0,m,0)|0;u=c[p>>2]|0;if((u|0)>0){z=c[q>>2]|0;A=fa(u,j)|0;B=u;do{B=B+ -1|0;h[g+(A+B<<3)>>3]=r*(+h[z+(B<<3)>>3]- +h[f+(B<<3)>>3]);}while((B|0)>0)}h[a>>3]=s;}while((j|0)>0);i=n;return 0}function Yya(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;n=i;j=c[(c[a+540>>2]|0)+120>>2]|0;o=c[m+4>>2]|0;p=+h[o+64>>3];q=c[o+76>>2]|0;r=c[o+72>>2]|0;s=a+464|0;a=c[s>>2]|0;if((c[a+(j*44|0)+24>>2]|0)==0){i=n;return 0}t=o+80|0;o=c[a+(j*44|0)>>2]|0;u=a;a=0;do{if((o|0)!=0){v=0;do{if(((c[(c[u+(j*44|0)+20>>2]|0)+(v<<2)>>2]|0)+ -1|0)==(a|0)){w=+h[k>>3]*+h[e+(v<<3)>>3];x=d+(v<<3)|0;y=+h[x>>3];if(!(y>=0.0)){z=-y}else{z=y}A=w>=0.0;if(A){B=w}else{B=-w}w=+zd(+z,+B);y=+h[l+(v<<3)>>3];if(!(y>=0.0)){C=-y}else{C=y}y=p*+zd(+w,+C);D=q+(v<<3)|0;h[D>>3]=y;if(A){E=y}else{E=-y}h[D>>3]=E;y=+h[x>>3];h[D>>3]=E+y-y;h[r+(v<<3)>>3]=+h[x>>3];h[x>>3]=+h[D>>3]+ +h[x>>3];h[D>>3]=1.0/+h[D>>3]}v=v+1|0;}while(v>>>0<o>>>0)}Mya(b,0,e,c[t>>2]|0,0,m,0)|0;u=c[s>>2]|0;o=c[u+(j*44|0)>>2]|0;if((o|0)!=0){v=c[u+(j*44|0)+20>>2]|0;D=0;do{if(((c[v+(D<<2)>>2]|0)+ -1|0)==(a|0)){if((D|0)==0){F=u+(j*44|0)+8|0;G=0}else{x=u+(j*44|0)+8|0;F=x;G=c[(c[x>>2]|0)+(D+ -1<<2)>>2]|0}x=c[(c[F>>2]|0)+(D<<2)>>2]|0;if(G>>>0<x>>>0){A=c[t>>2]|0;H=q+(D<<3)|0;I=c[u+(j*44|0)+12>>2]|0;J=c[u+(j*44|0)+4>>2]|0;K=G;do{L=c[I+(K<<2)>>2]|0;M=(fa(J,D)|0)+L|0;h[g+(M<<3)>>3]=(+h[A+(L<<3)>>3]- +h[f+(L<<3)>>3])*+h[H>>3];K=K+1|0;}while(K>>>0<x>>>0)}h[d+(D<<3)>>3]=+h[r+(D<<3)>>3]}D=D+1|0;}while(D>>>0<o>>>0)}a=a+1|0;}while(a>>>0<(c[u+(j*44|0)+24>>2]|0)>>>0);i=n;return 0}function Zya(a,b){a=a|0;b=+b;h[a+496>>3]=b;i=i;return}function _ya(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0;e=i;le[c[(c[a+540>>2]|0)+112>>2]&2047](a);f=a+328|0;h[f>>3]=d+1.0;g=c[a+104>>2]|0;if((g|0)<=0){i=e;return}j=c[a+108>>2]|0;k=a+336|0;a=0;do{d=+h[j+(a*24|0)+8>>3];if(d>b){h[(c[k>>2]|0)+(a<<3)>>3]=d;l=d}else{m=+h[j+(a*24|0)+16>>3];n=d+m*+ea(+((b-d)/m));h[(c[k>>2]|0)+(a<<3)>>3]=n;l=n}if((a|0)==0){o=8}else{if(l<+h[f>>3]){o=8}}if((o|0)==8){o=0;h[f>>3]=l}a=a+1|0;}while((a|0)<(g|0));i=e;return}function $ya(b,c){b=b|0;c=c|0;var d=0,e=0.0,f=0,g=0.0;d=i;e=+h[c>>3];f=c+8|0;g=+h[b+328>>3];if(!(g<=e+ +h[f>>3]+1.0e-14)){i=d;return}h[f>>3]=g-e;a[b+317|0]=1;i=d;return}function aza(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0;d=i;i=i+8|0;e=d;f=a+160|0;if((c[f>>2]|0)<=0){g=swa(b)|0;j=(g|0)>0;k=j&1;i=d;return k|0}l=a+540|0;m=a+344|0;n=a+348|0;o=a+368|0;a=0;do{De[c[(c[l>>2]|0)+104>>2]&63](a,e)|0;p=+h[(c[m>>2]|0)+(a<<3)>>3];if(p==1.0){if(+h[(c[n>>2]|0)+(a<<3)>>3]==-1.0){q=7}else{q=5}}else{q=5}do{if((q|0)==5){q=0;if(!(p==-1.0)){break}if(+h[(c[n>>2]|0)+(a<<3)>>3]==1.0){q=7}}}while(0);if((q|0)==7){q=0;qwa(b,(c[o>>2]|0)+(a<<2)|0)}a=a+1|0;}while((a|0)<(c[f>>2]|0));g=swa(b)|0;j=(g|0)>0;k=j&1;i=d;return k|0}function bza(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;e=i;g=f+32|0;do{if((aza(b,c[g>>2]|0)|0)!=0){if((a[f+28|0]|0)!=0){break}cza(b,c[g>>2]|0,f)}}while(0);if((a[b+317|0]|0)==1){h=1;i=e;return h|0}b=(swa(d)|0)>0;h=b?2:0;i=e;return h|0}function cza(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=a+112|0;q=c[p>>2]<<3;r=V_a(q)|0;s=r;t=V_a(q)|0;q=t;h[n>>3]=+h[a+376>>3];u=a+4|0;h[o>>3]=+h[c[c[u>>2]>>2]>>3];c[59220]=owa(4)|0;if((r|0)==0){db(236888,236904,308,236936)}if((t|0)==0){db(236952,236904,309,236936)}v=vwa(b)|0;if((v|0)!=0){w=v;do{v=xwa(w)|0;c[l>>2]=c[v>>2];hwa(27,0,236968,l);w=wwa(w)|0;}while((w|0)!=0)}w=c[p>>2]|0;if((w|0)>0){l=c[(c[c[u>>2]>>2]|0)+8>>2]|0;v=(w|0)>1?w<<3:8;z$a(t|0,c[a+384>>2]|0,v|0)|0;z$a(r|0,l|0,v|0)|0}h[d>>3]=+fza(a,n,o,q,s,c[59220]|0,b);do{if((swa(c[59220]|0)|0)==0){s=twa(b)|0;q=a+344|0;x=+U(+(+h[(c[q>>2]|0)+(c[s>>2]<<3)>>3]));s=vwa(b)|0;if((s|0)==0){y=x}else{v=s;z=x;while(1){s=xwa(v)|0;x=+U(+(+h[(c[q>>2]|0)+(c[s>>2]<<3)>>3]));A=z>x?x:z;s=wwa(v)|0;if((s|0)==0){y=A;break}else{z=A;v=s}}}v=j;h[k>>3]=y;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];hwa(27,0,237016,j);v=vwa(b)|0;if((v|0)==0){break}else{B=v}do{v=xwa(B)|0;if(y==+U(+(+h[(c[q>>2]|0)+(c[v>>2]<<3)>>3]))){v=c[59220]|0;rwa(v,xwa(B)|0);v=xwa(B)|0;c[g>>2]=c[v>>2];hwa(27,0,237040,g)}B=wwa(B)|0;}while((B|0)!=0)}}while(0);pwa(b);if((c[206172>>2]|0)!=0){swa(c[59220]|0)|0}if((swa(c[59220]|0)|0)>0){B=m;do{g=twa(c[59220]|0)|0;c[m>>2]=c[g>>2];uwa(c[59220]|0);c[f>>2]=c[m>>2];hwa(7,0,237064,f);qwa(b,B);}while((swa(c[59220]|0)|0)>0)}h[d>>3]=+h[o>>3];o=c[c[u>>2]>>2]|0;h[o>>3]=+h[n>>3];n=c[p>>2]|0;if((n|0)>0){z$a(c[o+8>>2]|0,t|0,((n|0)>1?n<<3:8)|0)|0}df(a);iza(a);a=c[c[u>>2]>>2]|0;h[a>>3]=+h[d>>3];d=c[p>>2]|0;if((d|0)<=0){W_a(t);W_a(r);i=e;return}z$a(c[a+8>>2]|0,r|0,((d|0)>1?d<<3:8)|0)|0;W_a(t);W_a(r);i=e;return}function dza(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0;g=i;i=i+32|0;j=g;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+8|0;p=b+4|0;q=+h[c[c[p>>2]>>2]>>3];r=b+317|0;do{if((a[r]|0)!=0){mza(b);s=b+104|0;t=c[s>>2]|0;if((t|0)<=0){break}u=b+336|0;v=q+1.0e-14;w=b+340|0;x=b+108|0;y=t;t=0;while(1){if(!(+h[(c[u>>2]|0)+(t<<3)>>3]<=v)){z=y}else{a[(c[w>>2]|0)+t|0]=1;A=c[x>>2]|0;B=+h[A+(t*24|0)+8>>3];C=+h[A+(t*24|0)+16>>3];c[m>>2]=c[A+(t*24|0)>>2];A=m+4|0;h[k>>3]=B;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=m+12|0;h[k>>3]=C;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];hwa(7,0,236608,m);z=c[s>>2]|0}A=t+1|0;if((A|0)<(z|0)){y=z;t=A}else{break}}}}while(0);z=b+512|0;m=b+524|0;t=b+516|0;y=b+528|0;c[y>>2]=(c[y>>2]|0)-(c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]|0);if((swa(d)|0)>0){h[c[c[p>>2]>>2]>>3]=+h[e>>3];do{if((c[206172>>2]|0)!=0){e=vwa(d)|0;if((e|0)==0){break}p=b+540|0;s=e;do{e=xwa(s)|0;x=c[e>>2]|0;e=De[c[(c[p>>2]|0)+104>>2]&63](x,n)|0;w=c[n>>2]|0;c[l>>2]=x;c[l+4>>2]=e;gwa(7,0,w,236632,l);s=wwa(s)|0;}while((s|0)!=0)}}while(0);l=f+40|0;c[l>>2]=(c[l>>2]|0)+1;c[y>>2]=(c[y>>2]|0)+1;c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]=1;l=c[m>>2]|0;n=c[b+520>>2]|0;h[n+(l<<3)>>3]=q;s=b+532|0;do{if((c[s>>2]|0)==0){p=c[y>>2]|0;if((p|0)!=(c[z>>2]|0)){break}v=+h[n+(((l+1|0)%(p|0)|0)<<3)>>3];w=b+264|0;if(!(q-v<+h[w>>3])){break}e=xwa(vwa(d)|0)|0;x=De[c[(c[b+540>>2]|0)+104>>2]&63](c[e>>2]|0,o)|0;e=c[o>>2]|0;C=+h[w>>3];w=j;h[k>>3]=v;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=j+8|0;h[k>>3]=q;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[j+16>>2]=p;p=j+20|0;h[k>>3]=C;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];c[j+28>>2]=x;gwa(1,0,e,236648,j);c[s>>2]=1}}while(0);pwa(d)}else{c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]=0}c[m>>2]=((c[m>>2]|0)+1|0)%(c[z>>2]|0)|0;hza(b);eza(b);if((a[r]|0)==0){i=g;return}z=b+104|0;m=c[z>>2]|0;do{if((m|0)>0){t=b+340|0;d=b+108|0;s=b+336|0;j=m;o=0;while(1){l=(c[t>>2]|0)+o|0;if((a[l]|0)==0){D=j}else{a[l]=0;l=(c[s>>2]|0)+(o<<3)|0;h[l>>3]=+h[(c[d>>2]|0)+(o*24|0)+16>>3]+ +h[l>>3];D=c[z>>2]|0}l=o+1|0;if((l|0)<(D|0)){j=D;o=l}else{break}}if((D|0)<=0){break}o=b+336|0;j=b+328|0;d=0;do{s=c[o>>2]|0;if((d|0)==0){E=+h[s>>3];F=29}else{q=+h[s+(d<<3)>>3];if(q<+h[j>>3]){E=q;F=29}}if((F|0)==29){F=0;h[j>>3]=E}d=d+1|0;}while((d|0)<(D|0))}}while(0);a[r]=0;r=f+44|0;c[r>>2]=(c[r>>2]|0)+1;i=g;return}function eza(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;hwa(27,0,237256,b);d=a+344|0;re[c[(c[a+540>>2]|0)+92>>2]&63](a,c[d>>2]|0,c[c[a+4>>2]>>2]|0)|0;e=c[a+160>>2]|0;if((e|0)<=0){i=b;return}f=c[d>>2]|0;d=c[a+348>>2]|0;a=0;do{h[d+(a<<3)>>3]=+h[f+(a<<3)>>3];a=a+1|0;}while((a|0)<(e|0));i=b;return}function fza(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0;l=i;i=i+8|0;m=l;n=i;i=i+16|0;o=a+160|0;p=c[o>>2]|0;q=V_a(p<<3)|0;if((q|0)==0){db(237072,236904,409,237088)}if((p|0)>0){z$a(q|0,c[a+344>>2]|0,((p|0)>1?p<<3:8)|0)|0}r=+h[d>>3];p=n;h[k>>3]=+h[b>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n+8|0;h[k>>3]=r;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];hwa(27,0,237104,n);n=m;h[k>>3]=1.0e-9;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];hwa(27,0,237152,m);r=+h[d>>3];s=+h[b>>3];if(!(+U(+(r-s))>1.0e-9)){W_a(q);t=+h[b>>3];u=+h[d>>3];v=t+u;w=v*.5;i=l;return+w}m=a+4|0;n=a+112|0;p=a+540|0;x=a+344|0;y=a+348|0;z=c[n>>2]|0;A=s;s=r;while(1){r=(s+A)*.5;B=c[c[m>>2]>>2]|0;h[B>>3]=r;if((z|0)>0){C=c[B+8>>2]|0;B=0;do{h[C+(B<<3)>>3]=(+h[e+(B<<3)>>3]+ +h[f+(B<<3)>>3])*.5;B=B+1|0;}while((B|0)<(z|0))}IAa(a)|0;oe[c[(c[p>>2]|0)+40>>2]&127](a)|0;oe[c[(c[p>>2]|0)+28>>2]&127](a)|0;oe[c[(c[p>>2]|0)+32>>2]&127](a)|0;re[c[(c[p>>2]|0)+92>>2]&63](a,c[x>>2]|0,c[c[m>>2]>>2]|0)|0;B=(gza(a,g,j)|0)==0;C=c[n>>2]|0;D=(C|0)>0;do{if(B){if(D){E=c[(c[c[m>>2]>>2]|0)+8>>2]|0;F=0;do{h[e+(F<<3)>>3]=+h[E+(F<<3)>>3];F=F+1|0;}while((F|0)<(C|0))}h[b>>3]=r;F=c[o>>2]|0;if((F|0)>0){E=c[x>>2]|0;G=c[y>>2]|0;H=0;do{I=E+(H<<3)|0;h[G+(H<<3)>>3]=+h[I>>3];h[I>>3]=+h[q+(H<<3)>>3];H=H+1|0;}while((H|0)<(F|0))}J=+h[d>>3]}else{if(D){F=c[(c[c[m>>2]>>2]|0)+8>>2]|0;H=0;do{h[f+(H<<3)>>3]=+h[F+(H<<3)>>3];H=H+1|0;}while((H|0)<(C|0))}h[d>>3]=r;H=c[o>>2]|0;if((H|0)<=0){J=r;break}z$a(q|0,c[x>>2]|0,((H|0)>1?H<<3:8)|0)|0;J=r}}while(0);r=+h[b>>3];if(+U(+(J-r))>1.0e-9){z=C;A=r;s=J}else{break}}W_a(q);t=+h[b>>3];u=+h[d>>3];v=t+u;w=v*.5;i=l;return+w}function gza(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;pwa(b);hwa(27,0,237176,g);g=vwa(d)|0;if((g|0)==0){j=swa(b)|0;k=(j|0)>0;l=k&1;i=e;return l|0}d=a+344|0;m=a+348|0;a=g;do{g=xwa(a)|0;if(+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]==-1.0){g=xwa(a)|0;if(+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]==1.0){n=7}else{n=5}}else{n=5}do{if((n|0)==5){n=0;g=xwa(a)|0;if(!(+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]==1.0)){break}g=xwa(a)|0;if(+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]==-1.0){n=7}}}while(0);if((n|0)==7){n=0;g=xwa(a)|0;o=c[g>>2]|0;g=xwa(a)|0;p=+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]>0.0?236592:236600;g=xwa(a)|0;q=+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]>0.0?236592:236600;c[f>>2]=o;c[f+4>>2]=p;c[f+8>>2]=q;hwa(27,0,237216,f);qwa(b,xwa(a)|0)}a=wwa(a)|0;}while((a|0)!=0);j=swa(b)|0;k=(j|0)>0;l=k&1;i=e;return l|0}function hza(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+8|0;e=d;f=b+315|0;a[f]=0;g=b+540|0;De[c[(c[g>>2]|0)+96>>2]&63](b,1)|0;iza(b);jza(b);oe[c[(c[g>>2]|0)+36>>2]&127](b)|0;kza(b,8);h=lza(b)|0;j=oe[c[(c[g>>2]|0)+100>>2]&127](b)|0;k=b+312|0;if((a[k]|0)==0){l=1;m=j;n=h}else{jza(b);i=d;return}while(1){if((m|0)==0){if((a[f]|n)<<24>>24==0){o=7;break}}mza(b);iza(b);kza(b,8);oe[c[(c[g>>2]|0)+36>>2]&127](b)|0;if((l|0)>200){o=5;break}h=lza(b)|0;j=oe[c[(c[g>>2]|0)+100>>2]&127](b)|0;if((a[k]|0)==0){l=l+1|0;m=j;n=h}else{o=7;break}}if((o|0)==5){lwa(c[b+536>>2]|0,237296,e)}else if((o|0)==7){jza(b);i=d;return}}function iza(a){a=a|0;var b=0;b=i;z$a(c[a+356>>2]|0,c[a+352>>2]|0,c[a+164>>2]|0)|0;i=b;return}function jza(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+164|0;if((c[e>>2]|0)<=0){i=d;return}f=b+352|0;g=b+360|0;b=0;do{a[(c[g>>2]|0)+b|0]=(a[(c[f>>2]|0)+b|0]|0)!=0|0;b=b+1|0;}while((b|0)<(c[e>>2]|0));i=d;return}function kza(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+24|0;f=e;g=i;i=i+8|0;if((c[206144+(d<<2)>>2]|0)==0){i=e;return}hwa(d,1,237720,g);g=b+164|0;if((c[g>>2]|0)>0){h=b+540|0;j=b+352|0;k=b+356|0;b=0;do{l=oe[c[(c[h>>2]|0)+108>>2]&127](b)|0;m=(a[(c[j>>2]|0)+b|0]|0)!=0?84:70;n=oe[c[(c[h>>2]|0)+108>>2]&127](b)|0;o=(a[(c[k>>2]|0)+b|0]|0)!=0?84:70;c[f>>2]=b;c[f+4>>2]=l;c[f+8>>2]=m;c[f+12>>2]=n;c[f+16>>2]=o;hwa(d,0,237744,f);b=b+1|0;}while((b|0)<(c[g>>2]|0))}le[c[51674]&2047](d);i=e;return}function lza(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+164>>2]|0;if((e|0)<=0){f=0;i=d;return f|0}g=c[b+356>>2]|0;h=c[b+352>>2]|0;b=0;while(1){j=b+1|0;if((a[g+b|0]|0)!=(a[h+b|0]|0)){f=1;k=5;break}if((j|0)<(e|0)){b=j}else{f=0;k=5;break}}if((k|0)==5){i=d;return f|0}return 0}function mza(a){a=a|0;var b=0,d=0;b=i;d=c[c[a+4>>2]>>2]|0;z$a(c[a+400>>2]|0,c[d+8>>2]|0,c[a+116>>2]<<3|0)|0;z$a(c[a+404>>2]|0,c[d+12>>2]|0,c[a+124>>2]<<2|0)|0;z$a(c[a+408>>2]|0,c[d+16>>2]|0,c[a+128>>2]|0)|0;z$a(c[a+412>>2]|0,c[d+20>>2]|0,c[a+132>>2]<<2|0)|0;i=b;return}function nza(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=c[a+160>>2]|0;e=c[a+344>>2]|0;if((d|0)>0){f=c[a+348>>2]|0;g=0;do{h[f+(g<<3)>>3]=+h[e+(g<<3)>>3];g=g+1|0;}while((g|0)<(d|0))}re[c[(c[a+540>>2]|0)+92>>2]&63](a,e,c[c[a+4>>2]>>2]|0)|0;i=b;return}function oza(a){a=a|0;var b=0;b=i;pza(a);qza(a);mza(a);rza(a);i=b;return}function pza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=c[b+136>>2]|0;if((e|0)>0){f=c[b+24>>2]|0;g=c[b+416>>2]|0;j=0;do{h[g+(j<<3)>>3]=+h[f+(j*112|0)+96>>3];j=j+1|0;}while((j|0)<(e|0))}e=b+140|0;if((c[e>>2]|0)>0){j=c[b+28>>2]|0;f=c[b+420>>2]|0;g=0;do{c[f+(g<<2)>>2]=c[j+(g*60|0)+52>>2];g=g+1|0;}while((g|0)<(c[e>>2]|0))}e=b+144|0;if((c[e>>2]|0)>0){g=b+32|0;j=b+424|0;f=0;do{a[(c[j>>2]|0)+f|0]=a[(c[g>>2]|0)+(f*48|0)+42|0]|0;f=f+1|0;}while((f|0)<(c[e>>2]|0))}e=c[b+148>>2]|0;if((e|0)<=0){i=d;return}f=b+36|0;g=b+428|0;b=0;do{c[(c[g>>2]|0)+(b<<2)>>2]=c[(c[f>>2]|0)+(b*52|0)+44>>2];b=b+1|0;}while((b|0)<(e|0));i=d;return}function qza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[b+116>>2]|0;if((f|0)>0){g=c[b+8>>2]|0;j=c[e+8>>2]|0;k=0;do{h[j+(k<<3)>>3]=+h[g+(k*112|0)+96>>3];k=k+1|0;}while((k|0)<(f|0))}f=b+124|0;if((c[f>>2]|0)>0){k=c[b+12>>2]|0;g=c[e+12>>2]|0;j=0;do{c[g+(j<<2)>>2]=c[k+(j*60|0)+52>>2];j=j+1|0;}while((j|0)<(c[f>>2]|0))}f=b+128|0;if((c[f>>2]|0)>0){j=b+16|0;k=e+16|0;g=0;do{a[(c[k>>2]|0)+g|0]=a[(c[j>>2]|0)+(g*48|0)+42|0]|0;g=g+1|0;}while((g|0)<(c[f>>2]|0))}f=c[b+132>>2]|0;if((f|0)<=0){i=d;return}g=b+20|0;b=e+20|0;e=0;do{c[(c[b>>2]|0)+(e<<2)>>2]=c[(c[g>>2]|0)+(e*52|0)+44>>2];e=e+1|0;}while((e|0)<(f|0));i=d;return}function rza(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a;if((pxa(c[d>>2]|0)|0)<=1){i=b;return}e=a+4|0;f=a+116|0;g=a+124|0;j=a+128|0;k=a+132|0;a=1;do{l=a+ -1|0;m=c[e>>2]|0;n=c[m+(l<<2)>>2]|0;o=c[m+(a<<2)>>2]|0;h[o>>3]=+h[n>>3];z$a(c[o+8>>2]|0,c[n+8>>2]|0,c[f>>2]<<3|0)|0;n=c[e>>2]|0;z$a(c[(c[n+(a<<2)>>2]|0)+12>>2]|0,c[(c[n+(l<<2)>>2]|0)+12>>2]|0,c[g>>2]<<2|0)|0;n=c[e>>2]|0;z$a(c[(c[n+(a<<2)>>2]|0)+16>>2]|0,c[(c[n+(l<<2)>>2]|0)+16>>2]|0,c[j>>2]|0)|0;n=c[e>>2]|0;z$a(c[(c[n+(a<<2)>>2]|0)+20>>2]|0,c[(c[n+(l<<2)>>2]|0)+20>>2]|0,c[k>>2]<<2|0)|0;a=a+1|0;}while((a|0)<(pxa(c[d>>2]|0)|0));i=b;return}function sza(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+24|0;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+32|0;p=i;i=i+8|0;q=i;i=i+8|0;if((c[206144+(d<<2)>>2]|0)==0){i=e;return}hwa(d,1,237392,q);q=b+136|0;if((c[q>>2]|0)>0){hwa(d,1,237416,p);if((c[q>>2]|0)>0){p=b+24|0;r=b+416|0;s=0;while(1){t=s+1|0;u=c[p>>2]|0;v=c[u+(s*112|0)+4>>2]|0;w=+h[u+(s*112|0)+96>>3];x=(a[u+(s*112|0)+72|0]|0)!=0?237376:237384;y=+h[(c[r>>2]|0)+(s<<3)>>3];c[o>>2]=t;c[o+4>>2]=v;v=o+8|0;h[k>>3]=w;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];c[o+16>>2]=x;x=o+20|0;h[k>>3]=y;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];hwa(d,0,237432,o);if((t|0)<(c[q>>2]|0)){s=t}else{break}}}le[c[51674]&2047](d)}s=b+140|0;if((c[s>>2]|0)>0){hwa(d,1,237488,n);if((c[s>>2]|0)>0){n=b+28|0;q=b+420|0;o=0;while(1){r=o+1|0;p=c[n>>2]|0;t=c[p+(o*60|0)+4>>2]|0;x=c[p+(o*60|0)+52>>2]|0;v=(a[p+(o*60|0)+48|0]|0)!=0?237376:237384;p=c[(c[q>>2]|0)+(o<<2)>>2]|0;c[m>>2]=r;c[m+4>>2]=t;c[m+8>>2]=x;c[m+12>>2]=v;c[m+16>>2]=p;hwa(d,0,237512,m);if((r|0)<(c[s>>2]|0)){o=r}else{break}}}le[c[51674]&2047](d)}o=b+144|0;if((c[o>>2]|0)>0){hwa(d,1,237568,l);if((c[o>>2]|0)>0){l=b+32|0;s=b+424|0;m=0;while(1){q=m+1|0;n=c[l>>2]|0;r=c[n+(m*48|0)+4>>2]|0;p=(a[n+(m*48|0)+42|0]|0)!=0?237376:237384;v=(a[n+(m*48|0)+40|0]|0)!=0?237376:237384;n=(a[(c[s>>2]|0)+m|0]|0)!=0?237376:237384;c[j>>2]=q;c[j+4>>2]=r;c[j+8>>2]=p;c[j+12>>2]=v;c[j+16>>2]=n;hwa(d,0,237592,j);if((q|0)<(c[o>>2]|0)){m=q}else{break}}}le[c[51674]&2047](d)}m=b+148|0;if((c[m>>2]|0)>0){hwa(d,1,237648,g);if((c[m>>2]|0)>0){g=b+36|0;o=b+428|0;b=0;while(1){j=b+1|0;s=c[g>>2]|0;l=c[s+(b*52|0)+4>>2]|0;q=c[s+(b*52|0)+44>>2]|0;s=c[(c[o>>2]|0)+(b<<2)>>2]|0;c[f>>2]=j;c[f+4>>2]=l;c[f+8>>2]=q;c[f+12>>2]=s;hwa(d,0,237672,f);if((j|0)<(c[m>>2]|0)){b=j}else{break}}}le[c[51674]&2047](d)}le[c[51674]&2047](d);i=e;return}function tza(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a;if((pxa(c[d>>2]|0)|0)<=1){i=b;return}e=a+4|0;f=a+116|0;g=a+124|0;j=a+128|0;k=a+132|0;a=1;do{l=c[e>>2]|0;m=c[l+(a<<2)>>2]|0;n=a+ -1|0;o=c[l+(n<<2)>>2]|0;h[o>>3]=+h[m>>3];z$a(c[o+8>>2]|0,c[m+8>>2]|0,c[f>>2]<<3|0)|0;m=c[e>>2]|0;z$a(c[(c[m+(n<<2)>>2]|0)+12>>2]|0,c[(c[m+(a<<2)>>2]|0)+12>>2]|0,c[g>>2]<<2|0)|0;m=c[e>>2]|0;z$a(c[(c[m+(n<<2)>>2]|0)+16>>2]|0,c[(c[m+(a<<2)>>2]|0)+16>>2]|0,c[j>>2]|0)|0;m=c[e>>2]|0;z$a(c[(c[m+(n<<2)>>2]|0)+20>>2]|0,c[(c[m+(a<<2)>>2]|0)+20>>2]|0,c[k>>2]<<2|0)|0;a=a+1|0;}while((a|0)<(pxa(c[d>>2]|0)|0));i=b;return}function uza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[b+116>>2]|0;if((f|0)>0){g=c[e+8>>2]|0;j=c[b+8>>2]|0;k=0;do{h[j+(k*112|0)+96>>3]=+h[g+(k<<3)>>3];k=k+1|0;}while((k|0)<(f|0))}f=b+124|0;if((c[f>>2]|0)>0){k=c[e+12>>2]|0;g=c[b+12>>2]|0;j=0;do{c[g+(j*60|0)+52>>2]=c[k+(j<<2)>>2];j=j+1|0;}while((j|0)<(c[f>>2]|0))}f=b+128|0;if((c[f>>2]|0)>0){j=e+16|0;k=b+16|0;g=0;do{a[(c[k>>2]|0)+(g*48|0)+42|0]=a[(c[j>>2]|0)+g|0]|0;g=g+1|0;}while((g|0)<(c[f>>2]|0))}f=c[b+132>>2]|0;if((f|0)<=0){i=d;return}g=e+20|0;e=b+20|0;b=0;do{c[(c[e>>2]|0)+(b*52|0)+44>>2]=c[(c[g>>2]|0)+(b<<2)>>2];b=b+1|0;}while((b|0)<(f|0));i=d;return}function vza(a){a=a|0;var b=0,d=0;b=i;d=c[c[a+4>>2]>>2]|0;h[a+376>>3]=+h[d>>3];z$a(c[a+384>>2]|0,c[d+8>>2]|0,c[a+116>>2]<<3|0)|0;z$a(c[a+388>>2]|0,c[d+12>>2]|0,c[a+124>>2]<<2|0)|0;z$a(c[a+392>>2]|0,c[d+16>>2]|0,c[a+128>>2]|0)|0;z$a(c[a+396>>2]|0,c[d+20>>2]|0,c[a+132>>2]<<2|0)|0;i=b;return}function wza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+32|0;o=b;c[o>>2]=0;p=kxa(3,32)|0;c[o>>2]=p;if((p|0)==0){lwa(c[b+536>>2]|0,237776,m)}m=n;p=b+116|0;q=n+8|0;r=b+536|0;s=b+124|0;t=n+12|0;u=b+128|0;v=n+16|0;w=b+132|0;x=n+20|0;y=n;n=0;do{h[m>>3]=0.0;z=X_a(c[p>>2]|0,8)|0;c[q>>2]=z;kwa(c[r>>2]|0,(z|0)!=0|0,237832,l);z=X_a(c[s>>2]|0,4)|0;c[t>>2]=z;kwa(c[r>>2]|0,(z|0)!=0|0,237832,k);z=X_a(c[u>>2]|0,1)|0;c[v>>2]=z;kwa(c[r>>2]|0,(z|0)!=0|0,237832,j);z=X_a(c[w>>2]|0,4)|0;c[x>>2]=z;kwa(c[r>>2]|0,(z|0)!=0|0,237832,g);oxa(c[o>>2]|0,y);n=n+1|0;}while(n>>>0<3);n=X_a(3,4)|0;c[b+4>>2]=n;qxa(c[o>>2]|0,0,n);c[b+8>>2]=X_a(c[p>>2]|0,112)|0;c[b+12>>2]=X_a(c[s>>2]|0,60)|0;c[b+16>>2]=X_a(c[u>>2]|0,48)|0;c[b+20>>2]=X_a(c[w>>2]|0,52)|0;n=b+136|0;c[b+24>>2]=X_a(c[n>>2]|0,112)|0;o=c[b+140>>2]|0;c[b+28>>2]=X_a(o,60)|0;y=c[b+144>>2]|0;c[b+32>>2]=X_a(y,48)|0;g=c[b+148>>2]|0;c[b+36>>2]=X_a(g,52)|0;c[b+40>>2]=X_a(c[b+216>>2]|0,52)|0;c[b+44>>2]=X_a(c[b+220>>2]|0,52)|0;c[b+48>>2]=X_a(c[b+224>>2]|0,52)|0;c[b+52>>2]=X_a(c[b+228>>2]|0,52)|0;x=c[b+104>>2]|0;c[b+108>>2]=X_a(x,24)|0;h[b+328>>3]=+h[b+240>>3];c[b+336>>2]=X_a(x,8)|0;c[b+340>>2]=X_a(x,1)|0;c[b+300>>2]=1;c[b+292>>2]=1;c[b+296>>2]=1;x=c[b+160>>2]|0;c[b+344>>2]=X_a(x,8)|0;c[b+348>>2]=X_a(x,8)|0;j=c[b+164>>2]|0;c[b+352>>2]=X_a(j,1)|0;c[b+356>>2]=X_a(j,1)|0;c[b+360>>2]=X_a(j,1)|0;j=V_a(x<<2)|0;c[b+368>>2]=j;c[b+364>>2]=V_a(c[b+168>>2]<<3)|0;if((x|0)!=0){v=0;do{c[j+(v<<2)>>2]=v;v=v+1|0;}while(v>>>0<x>>>0)}x=c[p>>2]|0;c[b+384>>2]=X_a(x,8)|0;p=c[s>>2]|0;c[b+388>>2]=X_a(p,4)|0;s=c[u>>2]|0;c[b+392>>2]=X_a(s,1)|0;u=c[w>>2]|0;c[b+396>>2]=X_a(u,4)|0;c[b+400>>2]=X_a(x,8)|0;c[b+404>>2]=X_a(p,4)|0;c[b+408>>2]=X_a(s,1)|0;c[b+412>>2]=X_a(u,4)|0;c[b+416>>2]=X_a(c[n>>2]|0,8)|0;c[b+420>>2]=X_a(o,4)|0;c[b+424>>2]=X_a(y,1)|0;c[b+428>>2]=X_a(g,4)|0;c[b+432>>2]=X_a(c[b+152>>2]|0,8)|0;c[b+436>>2]=X_a(c[b+156>>2]|0,8)|0;g=V_a((c[b+192>>2]|0)*40|0)|0;c[b+484>>2]=g;y=b+540|0;le[c[(c[y>>2]|0)+20>>2]&2047](g);g=V_a((c[b+196>>2]|0)*80|0)|0;c[b+476>>2]=g;le[c[(c[y>>2]|0)+16>>2]&2047](g);g=V_a((c[b+200>>2]|0)*80|0)|0;c[b+468>>2]=g;le[c[(c[y>>2]|0)+12>>2]&2047](g);g=V_a((c[b+204>>2]|0)*48|0)|0;c[b+488>>2]=g;me[c[(c[y>>2]|0)+24>>2]&127](g,b);c[b+464>>2]=V_a((c[b+232>>2]|0)*44|0)|0;c[b+76>>2]=0;c[b+80>>2]=0;g=X_a(c[b+188>>2]|0,4)|0;c[b+320>>2]=g;kwa(c[r>>2]|0,(g|0)!=0|0,237848,f);c[b+512>>2]=100;c[b+516>>2]=X_a(100,4)|0;c[b+520>>2]=X_a(100,8)|0;c[b+524>>2]=0;c[b+528>>2]=0;c[b+532>>2]=0;h[b+304>>3]=1.0;a[b+313|0]=0;a[b+312|0]=0;a[b+314|0]=0;f=b+172|0;g=b+316|0;a[g]=0;a[g+1|0]=0;a[g+2|0]=0;a[g+3|0]=0;g=V_a(c[f>>2]<<2)|0;y=b+504|0;c[y>>2]=g;kwa(c[r>>2]|0,(g|0)!=0|0,237832,e);if((c[f>>2]|0)==0){i=d;return}else{A=0}do{e=kxa(1024,16)|0;c[(c[y>>2]|0)+(A<<2)>>2]=e;A=A+1|0;}while(A>>>0<(c[f>>2]|0)>>>0);i=d;return}function xza(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;d=a+4|0;e=c[d>>2]|0;f=0;do{g=c[e+(f<<2)>>2]|0;W_a(c[g+8>>2]|0);W_a(c[g+12>>2]|0);W_a(c[g+16>>2]|0);W_a(c[g+20>>2]|0);f=f+1|0;e=c[d>>2]|0}while(f>>>0<3);W_a(e);lxa(c[a>>2]|0);e=a+116|0;f=a+8|0;d=c[f>>2]|0;if((c[e>>2]|0)==0){h=d}else{g=d;d=0;while(1){Pxa(g+(d*112|0)|0);j=d+1|0;k=c[f>>2]|0;if(j>>>0<(c[e>>2]|0)>>>0){d=j;g=k}else{h=k;break}}}W_a(h);h=a+124|0;g=a+12|0;d=c[g>>2]|0;if((c[h>>2]|0)==0){l=d}else{e=d;d=0;while(1){Pxa(e+(d*60|0)|0);f=d+1|0;k=c[g>>2]|0;if(f>>>0<(c[h>>2]|0)>>>0){d=f;e=k}else{l=k;break}}}W_a(l);l=a+128|0;e=a+16|0;d=c[e>>2]|0;if((c[l>>2]|0)==0){m=d}else{h=d;d=0;while(1){Pxa(h+(d*48|0)|0);g=d+1|0;k=c[e>>2]|0;if(g>>>0<(c[l>>2]|0)>>>0){d=g;h=k}else{m=k;break}}}W_a(m);m=a+132|0;h=a+20|0;d=c[h>>2]|0;if((c[m>>2]|0)==0){n=d}else{l=d;d=0;while(1){Pxa(l+(d*52|0)|0);e=d+1|0;k=c[h>>2]|0;if(e>>>0<(c[m>>2]|0)>>>0){d=e;l=k}else{n=k;break}}}W_a(n);n=a+136|0;l=a+24|0;d=c[l>>2]|0;if((c[n>>2]|0)==0){o=d}else{m=d;d=0;while(1){Pxa(m+(d*112|0)|0);h=d+1|0;k=c[l>>2]|0;if(h>>>0<(c[n>>2]|0)>>>0){d=h;m=k}else{o=k;break}}}W_a(o);o=a+140|0;m=a+28|0;d=c[m>>2]|0;if((c[o>>2]|0)==0){p=d}else{n=d;d=0;while(1){Pxa(n+(d*60|0)|0);l=d+1|0;k=c[m>>2]|0;if(l>>>0<(c[o>>2]|0)>>>0){d=l;n=k}else{p=k;break}}}W_a(p);p=a+144|0;n=a+32|0;d=c[n>>2]|0;if((c[p>>2]|0)==0){q=d}else{o=d;d=0;while(1){Pxa(o+(d*48|0)|0);m=d+1|0;k=c[n>>2]|0;if(m>>>0<(c[p>>2]|0)>>>0){d=m;o=k}else{q=k;break}}}W_a(q);q=a+148|0;o=a+36|0;d=c[o>>2]|0;if((c[q>>2]|0)==0){r=d}else{p=d;d=0;while(1){Pxa(p+(d*52|0)|0);n=d+1|0;k=c[o>>2]|0;if(n>>>0<(c[q>>2]|0)>>>0){d=n;p=k}else{r=k;break}}}W_a(r);r=a+216|0;p=a+40|0;d=c[p>>2]|0;if((c[r>>2]|0)==0){s=d}else{q=d;d=0;while(1){Pxa(q+(d*52|0)+12|0);o=d+1|0;k=c[p>>2]|0;if(o>>>0<(c[r>>2]|0)>>>0){d=o;q=k}else{s=k;break}}}W_a(s);s=a+220|0;q=a+44|0;d=c[q>>2]|0;if((c[s>>2]|0)==0){t=d}else{r=d;d=0;while(1){Pxa(r+(d*52|0)+12|0);p=d+1|0;k=c[q>>2]|0;if(p>>>0<(c[s>>2]|0)>>>0){d=p;r=k}else{t=k;break}}}W_a(t);t=a+224|0;r=a+48|0;d=c[r>>2]|0;if((c[t>>2]|0)==0){u=d}else{s=d;d=0;while(1){Pxa(s+(d*52|0)+12|0);q=d+1|0;k=c[r>>2]|0;if(q>>>0<(c[t>>2]|0)>>>0){d=q;s=k}else{u=k;break}}}W_a(u);u=a+228|0;s=a+52|0;d=c[s>>2]|0;if((c[u>>2]|0)==0){v=d}else{t=d;d=0;while(1){Pxa(t+(d*52|0)+12|0);r=d+1|0;k=c[s>>2]|0;if(r>>>0<(c[u>>2]|0)>>>0){d=r;t=k}else{v=k;break}}}W_a(v);W_a(c[a+108>>2]|0);W_a(c[a+336>>2]|0);W_a(c[a+340>>2]|0);W_a(c[a+344>>2]|0);W_a(c[a+348>>2]|0);W_a(c[a+352>>2]|0);W_a(c[a+356>>2]|0);W_a(c[a+360>>2]|0);W_a(c[a+368>>2]|0);W_a(c[a+384>>2]|0);W_a(c[a+388>>2]|0);W_a(c[a+392>>2]|0);W_a(c[a+396>>2]|0);W_a(c[a+400>>2]|0);W_a(c[a+404>>2]|0);W_a(c[a+408>>2]|0);W_a(c[a+412>>2]|0);W_a(c[a+416>>2]|0);W_a(c[a+420>>2]|0);W_a(c[a+424>>2]|0);W_a(c[a+428>>2]|0);W_a(c[a+488>>2]|0);W_a(c[a+484>>2]|0);W_a(c[a+476>>2]|0);W_a(c[a+468>>2]|0);W_a(c[a+464>>2]|0);W_a(c[a+432>>2]|0);W_a(c[a+436>>2]|0);W_a(c[a+320>>2]|0);W_a(c[a+516>>2]|0);W_a(c[a+520>>2]|0);nOa(a+56|0);v=a+172|0;t=a+504|0;a=c[t>>2]|0;if((c[v>>2]|0)==0){w=a;x=w;W_a(x);i=b;return}else{y=a;z=0}while(1){lxa(c[y+(z<<2)>>2]|0);a=z+1|0;d=c[t>>2]|0;if(a>>>0<(c[v>>2]|0)>>>0){z=a;y=d}else{w=d;break}}x=w;W_a(x);i=b;return}function yza(a){a=+a;var b=0,d=0,e=0.0,f=0;b=i;i=i+8|0;d=b;e=a*1.0e-4;h[29736]=e;f=d;h[k>>3]=e;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];hwa(8,0,237896,d);i=b;return}function zza(a,b,c){a=+a;b=+b;c=c|0;var d=0,e=0.0,f=0.0,g=0.0;d=c<<24>>24!=0;e=+h[29736];f=e+e*+U(+(d?b:a));if(d){g=f}else{g=-f}i=i;return a-b<=g|0}function Aza(a,b){a=+a;b=+b;i=i;return a<b|0}function Bza(a,b){a=+a;b=+b;i=i;return a<=b|0}function Cza(a,b){a=+a;b=+b;i=i;return a>b|0}function Dza(a,b){a=+a;b=+b;i=i;return a>=b|0}function Eza(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;d=b;e=c[a+484>>2]|0;f=a+192|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+296|0;h=0;while(1){j=c[e+(h*40|0)>>2]|0;k=j<<2;c[e+(h*40|0)+20>>2]=V_a(k)|0;c[e+(h*40|0)+24>>2]=V_a(k)|0;if((c[g>>2]|0)!=1){l=5;break}Hza(j,e+(h*40|0)+28|0)|0;j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{l=6;break}}if((l|0)==5){lwa(c[a+536>>2]|0,237952,d)}else if((l|0)==6){i=b;return 0}return 0}function Fza(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=c[a+484>>2]|0;f=a+192|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+296|0;h=0;while(1){W_a(c[e+(h*40|0)+20>>2]|0);W_a(c[e+(h*40|0)+24>>2]|0);if((c[g>>2]|0)!=1){j=5;break}k=e+(h*40|0)+28|0;Iza(k)|0;W_a(c[k>>2]|0);k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{j=6;break}}if((j|0)==5){lwa(c[a+536>>2]|0,237952,d)}else if((j|0)==6){i=b;return 0}return 0}function Gza(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;j=i;i=i+24|0;l=i;i=i+24|0;m=i;i=i+24|0;n=c[b+484>>2]|0;o=b+192|0;p=c[o>>2]|0;if((p|0)<=0){q=0;i=e;return q|0}r=(d|0)==0;d=b+56|0;s=n+4|0;t=j+8|0;u=b+4|0;b=l+12|0;v=m+16|0;w=p;p=0;x=0;while(1){y=(a[n+(p*40|0)+36|0]|0)!=0;do{if(y|r){z=w;A=y?x:1}else{if((c[206212>>2]|c[51534]|0)==0){z=w;A=1;break}lOa(j,d,c[s>>2]|0);B=+h[c[c[u>>2]>>2]>>3];c[g>>2]=c[t>>2];C=g+4|0;h[k>>3]=B;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];jwa(17,1,237984,g);lOa(l,d,c[s>>2]|0);if((c[b>>2]|0)>0){C=0;while(1){D=C+1|0;lOa(m,d,c[s>>2]|0);E=c[(c[(c[v>>2]|0)+(C<<2)>>2]|0)+4>>2]|0;c[f>>2]=D;c[f+4>>2]=E;jwa(17,0,238016,f);lOa(l,d,c[s>>2]|0);if((D|0)<(c[b>>2]|0)){C=D}else{break}}}le[c[51674]&2047](17);z=c[o>>2]|0;A=1}}while(0);y=p+1|0;if((y|0)<(z|0)){w=z;p=y;x=A}else{q=A;break}}i=e;return q|0}function Hza(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=i;i=i+8|0;f=V_a(20)|0;c[b>>2]=f;kwa(0,(f|0)!=0|0,238024,e);e=V_a(a)|0;c[f>>2]=e;e=V_a(a)|0;c[f+4>>2]=e;e=V_a(a)|0;c[f+8>>2]=e;e=V_a(a)|0;c[f+16>>2]=e;kwa(0,(c[b>>2]|0)!=0|0,238056,d);i=d;return 0}function Iza(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;W_a(c[d>>2]|0);W_a(c[d+4>>2]|0);W_a(c[d+8>>2]|0);W_a(c[d+16>>2]|0);i=b;return 0}function Jza(a,b){a=a|0;b=b|0;b=i;i=i+8|0;lwa(c[a+536>>2]|0,238104,b);return 0}function Kza(a){a=a|0;a=i;i=i+8|0;lwa(0,238104,a);return 0}function Lza(a,b){a=a|0;b=b|0;b=i;i=i+8|0;lwa(c[a+536>>2]|0,238104,b);return 0}function Mza(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=b;e=c[a+476>>2]|0;f=a+196|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+292|0;h=0;while(1){j=c[e+(h<<6)+16>>2]|0;k=c[e+(h<<6)+12>>2]|0;l=j<<3;c[e+(h<<6)+28>>2]=V_a(l)|0;c[e+(h<<6)+36>>2]=V_a(l)|0;m=c[g>>2]|0;if((m|0)==2){c[e+(h<<6)+8>>2]=2;Vza(j,j,k,e+(h<<6)+24|0)|0}else if((m|0)==1){c[e+(h<<6)+32>>2]=V_a(fa(l,j)|0)|0;c[e+(h<<6)+8>>2]=1;Sza(j,e+(h<<6)+24|0)|0}else{n=6;break}j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{n=8;break}}if((n|0)==6){lwa(c[a+536>>2]|0,238144,d)}else if((n|0)==8){i=b;return 0}return 0}function Nza(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;e=(fa(c[f+16>>2]|0,b)|0)+a|0;h[(c[f+32>>2]|0)+(e<<3)>>3]=d;i=i;return}function Oza(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;e=i;yb(0,a|0,b|0,+d,c[c[f+24>>2]>>2]|0)|0;i=e;return}function Pza(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=c[a+476>>2]|0;f=a+196|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+292|0;h=0;while(1){W_a(c[e+(h<<6)+28>>2]|0);W_a(c[e+(h<<6)+36>>2]|0);j=c[g>>2]|0;if((j|0)==2){Wza(e+(h<<6)+24|0)|0}else if((j|0)==1){Tza(e+(h<<6)+24|0)|0;W_a(c[e+(h<<6)+32>>2]|0)}else{k=6;break}W_a(c[e+(h<<6)+24>>2]|0);j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{k=8;break}}if((k|0)==6){lwa(c[a+536>>2]|0,238144,d)}else if((k|0)==8){i=b;return 0}return 0}function Qza(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=c[b+476>>2]|0;h=c[b+292>>2]|0;if((h|0)==2){j=Xza(b,d)|0}else if((h|0)==1){j=Uza(b,d)|0}else{lwa(c[b+536>>2]|0,238144,f)}a[g+(d<<6)+56|0]=j;i=e;return 0}function Rza(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;j=i;i=i+24|0;l=i;i=i+24|0;m=i;i=i+24|0;n=c[b+476>>2]|0;o=b+196|0;p=c[o>>2]|0;if((p|0)<=0){q=0;i=e;return q|0}r=(d|0)==0;d=b+56|0;s=n+20|0;t=j+8|0;u=b+4|0;b=l+12|0;v=m+16|0;w=p;p=0;x=0;while(1){y=(a[n+(p<<6)+56|0]|0)!=0;do{if(y|r){z=w;A=y?x:1}else{if((c[206204>>2]|c[51534]|0)==0){z=w;A=1;break}lOa(j,d,c[s>>2]|0);B=+h[c[c[u>>2]>>2]>>3];c[g>>2]=c[t>>2];C=g+4|0;h[k>>3]=B;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];jwa(15,1,238176,g);lOa(l,d,c[s>>2]|0);if((c[b>>2]|0)>0){C=0;while(1){D=C+1|0;lOa(m,d,c[s>>2]|0);E=c[(c[(c[v>>2]|0)+(C<<2)>>2]|0)+4>>2]|0;c[f>>2]=D;c[f+4>>2]=E;jwa(15,0,238208,f);lOa(l,d,c[s>>2]|0);if((D|0)<(c[b>>2]|0)){C=D}else{break}}}le[c[51674]&2047](15);z=c[o>>2]|0;A=1}}while(0);y=p+1|0;if((y|0)<(z|0)){w=z;p=y;x=A}else{q=A;break}}i=e;return q|0}function Sza(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=V_a(12)|0;f=V_a(a<<2)|0;c[e>>2]=f;kwa(0,(f|0)!=0|0,238216,d);c[e+4>>2]=1;c[e+8>>2]=0;c[b>>2]=e;i=d;return 0}function Tza(a){a=a|0;var b=0;b=i;W_a(c[c[a>>2]>>2]|0);i=b;return 0}function Uza(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+24|0;m=i;i=i+16|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16384|0;v=i;i=i+4096|0;w=c[b+476>>2]|0;x=w+(d<<6)|0;y=c[w+(d<<6)+24>>2]|0;z=w+(d<<6)+16|0;A=c[z>>2]|0;B=w+(d<<6)+32|0;B$a(c[B>>2]|0,0,fa(A<<3,A)|0)|0;C=b;D=x;me[c[x>>2]&127](C,D);me[c[w+(d<<6)+4>>2]&127](C,D);if((c[206208>>2]|0)!=0){D=u;c[t>>2]=A;c[t+4>>2]=A;hwa(16,1,238272,t);t=(A|0)>0;do{if(t){u=0;do{a[D]=0;C=0;do{x=(fa(C,A)|0)+u|0;E=+h[(c[B>>2]|0)+(x<<3)>>3];c[r>>2]=D;x=r+4|0;h[k>>3]=E;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];lc(D|0,238296,r|0)|0;C=C+1|0;}while((C|0)<(A|0));c[q>>2]=D;hwa(16,0,238312,q);u=u+1|0;}while((u|0)<(A|0));c[p>>2]=A;hwa(16,1,238320,p);if(!t){break}u=w+(d<<6)+36|0;C=0;do{a[D]=0;E=+h[(c[u>>2]|0)+(C<<3)>>3];c[o>>2]=D;x=o+4|0;h[k>>3]=E;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];lc(D|0,238296,o|0)|0;c[n>>2]=D;hwa(16,0,238312,n);C=C+1|0;}while((C|0)<(A|0))}else{c[s>>2]=A;hwa(16,1,238320,s)}}while(0);le[c[51674]&2047](16)}s=w+(d<<6)+36|0;A=y+8|0;Vqa(z,y+4|0,c[B>>2]|0,z,c[y>>2]|0,c[s>>2]|0,z,A)|0;y=c[A>>2]|0;if((y|0)<0){E=+h[c[c[b+4>>2]>>2]>>3];c[m>>2]=c[w+(d<<6)+20>>2];A=m+4|0;h[k>>3]=E;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];c[m+12>>2]=y;jwa(1,0,238336,m);F=0;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;z$a(M|0,O|0,Q|0)|0;i=e;return F|0}if((y|0)<=0){F=1;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;z$a(M|0,O|0,Q|0)|0;i=e;return F|0}E=+h[c[c[b+4>>2]>>2]>>3];b=y+1|0;c[l>>2]=c[w+(d<<6)+20>>2];y=l+4|0;h[k>>3]=E;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];c[l+12>>2]=b;c[l+16>>2]=b;jwa(1,0,238424,l);if((c[206204>>2]|0)==0){F=0;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;z$a(M|0,O|0,Q|0)|0;i=e;return F|0}l=v;v=(c[z>>2]|0)>0;a[l]=0;if(v){v=0;do{b=c[z>>2]|0;if((b|0)>0){y=b;m=0;while(1){A=(fa(y,m)|0)+v|0;E=+h[(c[B>>2]|0)+(A<<3)>>3];c[j>>2]=l;A=j+4|0;h[k>>3]=E;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];lc(l|0,238528,j|0)|0;A=m+1|0;n=c[z>>2]|0;if((A|0)<(n|0)){m=A;y=n}else{R=n;break}}}else{R=b}v=v+1|0;a[l]=0}while((v|0)<(R|0))}if((c[z>>2]|0)>0){R=0;do{E=+h[(c[s>>2]|0)+(R<<3)>>3];c[g>>2]=l;v=g+4|0;h[k>>3]=E;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];lc(l|0,238528,g|0)|0;R=R+1|0;}while((R|0)<(c[z>>2]|0))}a[l]=0;if((c[z>>2]|0)>0){S=0}else{F=0;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;z$a(M|0,O|0,Q|0)|0;i=e;return F|0}while(1){E=+h[(c[s>>2]|0)+(S<<3)>>3];c[f>>2]=l;R=f+4|0;h[k>>3]=E;c[R>>2]=c[k>>2];c[R+4>>2]=c[k+4>>2];lc(l|0,238528,f|0)|0;R=S+1|0;if((R|0)<(c[z>>2]|0)){S=R}else{F=0;break}}G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;z$a(M|0,O|0,Q|0)|0;i=e;return F|0}function Vza(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=V_a(32)|0;kwa(0,(g|0)!=0|0,238536,f);c[g+20>>2]=b;b=g+24|0;c[b>>2]=a;c[g+28>>2]=d;d=g+8|0;ce(0,d|0)|0;Td(c[d>>2]|0,c[b>>2]|0,0)|0;ce(0,g+4|0)|0;Td(c[d>>2]|0,c[b>>2]|0,0)|0;b=g+12|0;cb(b|0)|0;Ob(238584,c[b>>2]|0)|0;c[e>>2]=g;i=f;return 0}function Wza(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;Fd(c[d+12>>2]|0)|0;Nb(c[d+8>>2]|0)|0;Nb(c[d+4>>2]|0)|0;i=b;return 0}function Xza(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;d=i;e=c[a+476>>2]|0;f=e+(b<<6)|0;g=c[e+(b<<6)+24>>2]|0;qd(c[g>>2]|0)|0;_d(0,g|0)|0;j=g+24|0;Sb(c[g>>2]|0,c[j>>2]|0,0)|0;k=a;a=f;me[c[f>>2]&127](k,a);Yc(c[g>>2]|0,1)|0;Va(c[g>>2]|0)|0;me[c[e+(b<<6)+4>>2]&127](k,a);if((c[j>>2]|0)>0){a=e+(b<<6)+36|0;k=g+8|0;f=k;l=0;while(1){ld(0,l|0,+(+h[(c[a>>2]|0)+(l<<3)>>3]),c[k>>2]|0)|0;m=l+1|0;if((m|0)<(c[j>>2]|0)){l=m}else{n=f;break}}}else{n=g+8|0}f=g+4|0;l=(qc(c[g>>2]|0,c[n>>2]|0,c[f>>2]|0,c[g+12>>2]|0)|0)==0|0;Mb(c[f>>2]|0,0,c[g+20>>2]|0,c[e+(b<<6)+28>>2]|0)|0;qd(c[g>>2]|0)|0;i=d;return l|0}function Yza(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=c[a+468>>2]|0;h=a+200|0;if((c[h>>2]|0)<=0){i=b;return 0}j=a+536|0;k=a;l=a+300|0;m=0;a:while(1){n=g+(m*80|0)|0;o=c[n>>2]|0;kwa(c[j>>2]|0,(c[g+(m*80|0)+32>>2]|0)!=0|0,238752,f);p=g+(m*80|0)+28|0;do{if(!((c[p>>2]|0)==-1)){kwa(c[j>>2]|0,(c[g+(m*80|0)+20>>2]|0)!=0|0,238792,e);if((oe[c[g+(m*80|0)+24>>2]&127](k)|0)==0){break}c[p>>2]=-1}}while(0);p=o<<3;c[g+(m*80|0)+44>>2]=V_a(p)|0;c[g+(m*80|0)+52>>2]=V_a(p)|0;c[g+(m*80|0)+48>>2]=V_a(p)|0;c[g+(m*80|0)+16>>2]=V_a(p)|0;c[g+(m*80|0)+8>>2]=V_a(p)|0;c[g+(m*80|0)+12>>2]=V_a(p)|0;me[c[g+(m*80|0)+36>>2]&127](k,n);do{if((c[g+(m*80|0)+56>>2]|0)==1){jAa(o,g+(m*80|0)+40|0)|0}else{p=c[l>>2]|0;if((p|0)==2){Jza(a,n)|0;break}else if((p|0)==1){bAa(o,g+(m*80|0)+40|0)|0;break}else if((p|0)==3){jAa(o,g+(m*80|0)+40|0)|0;break}else{q=12;break a}}}while(0);o=m+1|0;if((o|0)<(c[h>>2]|0)){m=o}else{q=14;break}}if((q|0)==12){lwa(c[j>>2]|0,238832,d)}else if((q|0)==14){i=b;return 0}return 0}function Zza(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=b;e=c[a+468>>2]|0;f=a+200|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+300|0;h=0;a:while(1){j=e+(h*80|0)|0;W_a(c[e+(h*80|0)+44>>2]|0);W_a(c[e+(h*80|0)+52>>2]|0);W_a(c[e+(h*80|0)+48>>2]|0);W_a(c[e+(h*80|0)+16>>2]|0);W_a(c[e+(h*80|0)+8>>2]|0);W_a(c[e+(h*80|0)+12>>2]|0);do{if((c[e+(h*80|0)+56>>2]|0)==1){k=e+(h*80|0)+40|0;kAa(k)|0;l=k}else{k=c[g>>2]|0;if((k|0)==2){m=7;break a}else if((k|0)==1){n=e+(h*80|0)+40|0;cAa(n)|0;l=n;break}else if((k|0)==3){k=e+(h*80|0)+40|0;kAa(k)|0;l=k;break}else{m=9;break a}}}while(0);W_a(c[l>>2]|0);k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{m=11;break}}if((m|0)==7){Kza(j)|0}else if((m|0)==9){lwa(c[a+536>>2]|0,238832,d)}else if((m|0)==11){i=b;return 0}return 0}function _za(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+8|0;f=e;g=c[b+468>>2]|0;c[b+472>>2]=d;h=b+319|0;a[h]=1;do{if((c[g+(d*80|0)+56>>2]|0)==1){j=(mAa(b,d)|0)&255}else{k=c[b+300>>2]|0;if((k|0)==3){j=(mAa(b,d)|0)&255;break}else if((k|0)==2){j=(Lza(b,d)|0)&255;break}else if((k|0)==1){k=b+536|0;l=(c[k>>2]|0)+84|0;m=c[l>>2]|0;c[l>>2]=3;l=dAa(b,d)|0;c[(c[k>>2]|0)+84>>2]=m;j=l&255;break}else{lwa(c[b+536>>2]|0,238832,f)}}}while(0);a[g+(d*80|0)+72|0]=j;a[h]=0;i=e;return 0}function $za(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0.0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+24|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+8|0;o=i;i=i+24|0;p=i;i=i+24|0;q=i;i=i+24|0;r=i;i=i+24|0;s=i;i=i+24|0;t=i;i=i+24|0;u=c[b+468>>2]|0;v=c[b+200>>2]|0;if((v|0)>0){w=0}else{x=0;i=e;return x|0}while(1){y=w+1|0;if((a[u+(w*80|0)+72|0]|0)==0){break}if((y|0)<(v|0)){w=y}else{x=0;z=22;break}}if((z|0)==22){i=e;return x|0}v=u+(w*80|0)+4|0;w=c[v>>2]|0;u=n;c[u>>2]=1;c[n+4>>2]=w;if((d|0)==0){x=1;i=e;return x|0}d=b+56|0;lOa(o,d,w);A=+h[c[c[b+4>>2]>>2]>>3];c[m>>2]=c[o+8>>2];o=m+4|0;h[k>>3]=A;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];iwa(17,1,u,238864,m);do{if((a[b+312|0]|0)==0){lOa(s,d,c[v>>2]|0);m=s+12|0;if((c[m>>2]|0)<=0){break}u=t+16|0;o=0;while(1){w=o+1|0;lOa(t,d,c[v>>2]|0);n=c[(c[(c[u>>2]|0)+(o<<2)>>2]|0)+4>>2]|0;c[f>>2]=w;c[f+4>>2]=n;jwa(17,0,239064,f);lOa(s,d,c[v>>2]|0);if((w|0)<(c[m>>2]|0)){o=w}else{break}}}else{jwa(17,1,238904,l);lOa(p,d,c[v>>2]|0);o=p+12|0;if((c[o>>2]|0)>0){m=b+116|0;u=r+16|0;w=b+8|0;n=q+16|0;y=0;while(1){a:do{if((c[m>>2]|0)>0){B=y+1|0;C=0;while(1){D=c[(c[w>>2]|0)+(C*112|0)+4>>2]|0;lOa(q,d,c[v>>2]|0);if((t$a(D,c[(c[(c[n>>2]|0)+(y<<2)>>2]|0)+4>>2]|0)|0)==0){break}D=C+1|0;if((D|0)<(c[m>>2]|0)){C=D}else{z=15;break a}}D=c[w>>2]|0;E=c[D+(C*112|0)+4>>2]|0;A=+h[D+(C*112|0)+96>>3];F=+h[D+(C*112|0)+80>>3];c[j>>2]=B;c[j+4>>2]=E;E=j+8|0;h[k>>3]=A;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=j+16|0;h[k>>3]=F;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];jwa(17,0,238984,j);G=y+1|0}else{z=15}}while(0);if((z|0)==15){z=0;E=y+1|0;lOa(r,d,c[v>>2]|0);D=c[(c[(c[u>>2]|0)+(y<<2)>>2]|0)+4>>2]|0;c[g>>2]=E;c[g+4>>2]=D;jwa(17,0,239024,g);G=E}lOa(p,d,c[v>>2]|0);if((G|0)<(c[o>>2]|0)){y=G}else{break}}}if((c[206212>>2]|c[51534]|0)==0){break}le[c[51674]&2047](17)}}while(0);if((c[206212>>2]|c[51534]|0)==0){x=1;i=e;return x|0}le[c[51674]&2047](17);x=1;i=e;return x|0}function aAa(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0.0,j=0.0,k=0.0;e=i;f=c[a+4>>2]|0;g=+h[c[f+4>>2]>>3];j=+h[c[f+8>>2]>>3];if(g==j){k=b;i=e;return+k}k=(b-d)*((+h[c[f>>2]>>3]-j)/(g-j))+d;i=e;return+k}function bAa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+8|0;e=i;i=i+8|0;f=V_a(144)|0;c[b>>2]=f;kwa(0,(f|0)!=0|0,239080,e);c[f>>2]=0;e=a<<3;g=V_a(e)|0;c[f+4>>2]=g;g=V_a(e)|0;c[f+16>>2]=g;c[f+8>>2]=1;g=V_a(e)|0;c[f+12>>2]=g;c[f+20>>2]=a;g=V_a(e)|0;c[f+24>>2]=g;g=X_a(a,8)|0;c[f+28>>2]=g;h[f+32>>3]=1.0e-12;c[f+40>>2]=a*1e4;g=a+ -1|0;c[f+44>>2]=g;c[f+48>>2]=g;h[f+56>>3]=1.0e-12;g=V_a(e)|0;c[f+64>>2]=g;g=V_a(e)|0;c[f+68>>2]=g;c[f+72>>2]=1;h[f+80>>3]=100.0;c[f+88>>2]=-1;c[f+92>>2]=0;c[f+96>>2]=0;c[f+100>>2]=0;g=fa(a,a)|0;j=X_a(g,8)|0;c[f+104>>2]=j;j=X_a(g,8)|0;c[f+108>>2]=j;c[f+112>>2]=a;j=(fa(a+1|0,a)|0)/2|0;a=V_a(j<<3)|0;c[f+116>>2]=a;c[f+120>>2]=j;j=V_a(e)|0;c[f+124>>2]=j;j=V_a(e)|0;c[f+128>>2]=j;j=V_a(e)|0;c[f+132>>2]=j;j=V_a(e)|0;c[f+136>>2]=j;j=V_a(e)|0;c[f+140>>2]=j;kwa(0,(c[b>>2]|0)!=0|0,239112,d);i=d;return 0}function cAa(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;W_a(c[d+4>>2]|0);W_a(c[d+16>>2]|0);W_a(c[d+12>>2]|0);W_a(c[d+24>>2]|0);W_a(c[d+28>>2]|0);W_a(c[d+64>>2]|0);W_a(c[d+68>>2]|0);W_a(c[d+104>>2]|0);W_a(c[d+108>>2]|0);W_a(c[d+116>>2]|0);W_a(c[d+124>>2]|0);W_a(c[d+128>>2]|0);W_a(c[d+132>>2]|0);W_a(c[d+136>>2]|0);W_a(c[d+140>>2]|0);i=b;return 0}function dAa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0.0,Y=0,Z=0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0.0,ab=0.0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0,kb=0;e=i;i=i+56|0;f=e;g=e+24|0;j=e+48|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+8|0;F=i;i=i+24|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+24|0;N=i;i=i+24|0;O=i;i=i+4096|0;P=i;i=i+24|0;Q=c[b+468>>2]|0;R=c[Q+(d*80|0)+40>>2]|0;S=R;T=c[Q+(d*80|0)+4>>2]|0;c[I>>2]=1;V=R+80|0;W=V;X=+h[V>>3];c[L>>2]=0;Y=b+164|0;Z=V_a(c[Y>>2]|0)|0;if((c[206212>>2]|0)!=0){lOa(M,b+56|0,T);_=+h[c[c[b+4>>2]>>2]>>3];c[H>>2]=c[M+8>>2];M=H+4|0;h[k>>3]=_;c[M>>2]=c[k>>2];c[M+4>>2]=c[k+4>>2];hwa(17,1,239152,H);H=R+20|0;if((c[H>>2]|0)>0){M=Q+(d*80|0)+44|0;$=Q+(d*80|0)+16|0;aa=Q+(d*80|0)+48|0;ba=Q+(d*80|0)+52|0;ca=0;do{_=+h[(c[M>>2]|0)+(ca<<3)>>3];c[G>>2]=ca;da=G+4|0;h[k>>3]=_;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];hwa(17,1,239208,G);_=+h[(c[aa>>2]|0)+(ca<<3)>>3];ea=+h[(c[ba>>2]|0)+(ca<<3)>>3];da=F;h[k>>3]=+h[(c[$>>2]|0)+(ca<<3)>>3];c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];da=F+8|0;h[k>>3]=_;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];da=F+16|0;h[k>>3]=ea;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];hwa(17,0,239224,F);le[c[51674]&2047](17);ca=ca+1|0;}while((ca|0)<(c[H>>2]|0))}le[c[51674]&2047](17)}H=b+314|0;ca=R+24|0;F=c[ca>>2]|0;if((a[H]|0)==0){z$a(F|0,c[Q+(d*80|0)+52>>2]|0,c[R+20>>2]<<3|0)|0}else{z$a(F|0,c[Q+(d*80|0)+44>>2]|0,c[R+20>>2]<<3|0)|0}F=R+20|0;$=F;ba=c[F>>2]|0;if((ba|0)>0){aa=c[ca>>2]|0;G=c[Q+(d*80|0)+16>>2]|0;M=c[R+12>>2]|0;da=0;do{ea=+U(+(+h[aa+(da<<3)>>3]));h[M+(da<<3)>>3]=+zd(+ea,+(+h[G+(da<<3)>>3]));da=da+1|0;}while((da|0)<(ba|0))}ba=R+8|0;da=(c[ba>>2]|0)!=0;if(da){c[ba>>2]=0}G=R+28|0;M=R+104|0;aa=R+112|0;ga=b;eAa($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;if(da){c[ba>>2]=1}da=b+318|0;ha=R+32|0;ia=R+40|0;ja=R+64|0;ka=R+72|0;la=ka;ma=R+88|0;na=R+92|0;oa=na;pa=R+96|0;qa=pa;ra=R+100|0;sa=R+116|0;ta=R+120|0;ua=R+124|0;va=R+128|0;wa=R+132|0;xa=R+136|0;ya=R+140|0;za=b+56|0;Aa=b+4|0;Ba=Q+(d*80|0)+52|0;Ca=Q+(d*80|0)+44|0;Da=Q+(d*80|0)+48|0;Ea=Q+(d*80|0)+16|0;Q=R+12|0;Fa=b+356|0;Ga=R+4|0;Ha=b+312|0;Ia=R+16|0;Ja=O;O=R+108|0;R=1;ea=1.0e-12;Ka=0;La=0;Ma=0;Na=0;a:while(1){Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[ca>>2]|0;Qa=c[Ea>>2]|0;Ra=c[Q>>2]|0;Sa=0;do{_=+U(+(+h[Pa+(Sa<<3)>>3]));h[Ra+(Sa<<3)>>3]=+zd(+_,+(+h[Qa+(Sa<<3)>>3]));Sa=Sa+1|0;}while((Sa|0)<(Oa|0))}if((c[206216>>2]|0)!=0){fAa(c[Q>>2]|0,$,18,239264);fAa(c[ca>>2]|0,$,18,239296)}do{if((c[ba>>2]|0)!=0){Oa=c[F>>2]|0;if((Oa|0)<=0){break}Sa=c[Q>>2]|0;Qa=c[ca>>2]|0;Ra=0;do{Pa=Qa+(Ra<<3)|0;h[Pa>>3]=1.0/+h[Sa+(Ra<<3)>>3]*+h[Pa>>3];Ra=Ra+1|0;}while((Ra|0)<(Oa|0))}}while(0);if((c[206216>>2]|0)!=0){fAa(c[ca>>2]|0,$,18,239328)}a[da]=R;uya(10,$,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,ha,ia,c[ja>>2]|0,la,W,ma,oa,qa,ra,c[sa>>2]|0,ta,c[ua>>2]|0,c[va>>2]|0,c[wa>>2]|0,c[xa>>2]|0,c[ya>>2]|0,ga,d)|0;a[da]=R^1;do{if((c[ba>>2]|0)!=0){Oa=c[F>>2]|0;if((Oa|0)<=0){break}Ra=c[ca>>2]|0;Sa=c[Q>>2]|0;Qa=0;do{Pa=Ra+(Qa<<3)|0;h[Pa>>3]=+h[Pa>>3]*+h[Sa+(Qa<<3)>>3];Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}}while(0);Oa=c[na>>2]|0;if((Oa|0)==0){lOa(N,za,T);_=+h[c[c[Aa>>2]>>2]>>3];Qa=g;Sa=N;c[Qa+0>>2]=c[Sa+0>>2];c[Qa+4>>2]=c[Sa+4>>2];c[Qa+8>>2]=c[Sa+8>>2];c[Qa+12>>2]=c[Sa+12>>2];c[Qa+16>>2]=c[Sa+16>>2];Oxa(3,g,_);Ta=c[na>>2]|0}else{Ta=Oa}do{if(!((Ta|0)==-1)){if((a[H]|0)==0){Ua=Ta}else{if((c[ba>>2]|0)==0){a[da]=0;eAa($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0}else{c[ba>>2]=0;a[da]=0;eAa($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;c[ba>>2]=1}iza(b);Ua=c[na>>2]|0}if((Ua|0)==-1){break}Oa=c[F>>2]|0;if((Oa|0)>0){Sa=c[Ga>>2]|0;Qa=c[G>>2]|0;Ra=c[Ia>>2]|0;Pa=0;Va=0;while(1){Wa=Sa+(Pa<<3)|0;h[Wa>>3]=1.0e-16;Xa=c[O>>2]|0;Ya=(Oa|0)>1?Oa:1;_=1.0e-16;Za=0;_a=Va;while(1){$a=+U(+(+h[Xa+(_a<<3)>>3]));ab=$a>_?$a:_;h[Wa>>3]=ab;bb=Za+1|0;if((bb|0)<(Oa|0)){_a=_a+1|0;Za=bb;_=ab}else{break}}h[Ra+(Pa<<3)>>3]=+h[Qa+(Pa<<3)>>3]*(1.0/ab);Za=Pa+1|0;if((Za|0)<(Oa|0)){Pa=Za;Va=Va+Ya|0}else{break}}}if((c[206216>>2]|0)!=0){hwa(18,1,239368,E);if((c[F>>2]|0)>0){Va=0;do{_=+h[(c[Ia>>2]|0)+(Va<<3)>>3];c[D>>2]=Va;Pa=D+4|0;h[k>>3]=_;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];hwa(18,1,239408,D);_=+h[(c[Ga>>2]|0)+(Va<<3)>>3];c[C>>2]=Va;Pa=C+4|0;h[k>>3]=_;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];hwa(18,0,239440,C);le[c[51674]&2047](18);Va=Va+1|0;}while((Va|0)<(c[F>>2]|0))}le[c[51674]&2047](18)}if((c[206220>>2]|0)!=0){Va=c[F>>2]|0;c[B>>2]=Va;c[B+4>>2]=Va;hwa(19,1,239472,B);if((c[F>>2]|0)>0){Va=0;do{a[Ja]=0;Pa=c[F>>2]|0;if((Pa|0)>0){Oa=Pa;Pa=0;do{Qa=(fa(Oa,Va)|0)+Pa|0;_=+h[(c[O>>2]|0)+(Qa<<3)>>3];c[A>>2]=Ja;Qa=A+4|0;h[k>>3]=_;c[Qa>>2]=c[k>>2];c[Qa+4>>2]=c[k+4>>2];lc(Ja|0,239496,A|0)|0;Pa=Pa+1|0;Oa=c[F>>2]|0;}while((Pa|0)<(Oa|0))}c[z>>2]=Ja;hwa(19,0,239504,z);Va=Va+1|0;}while((Va|0)<(c[F>>2]|0))}le[c[51674]&2047](19)}h[K>>3]=+tya($,c[Ia>>2]|0);h[J>>3]=+tya($,c[G>>2]|0)}}while(0);do{if((Ka|0)==0){cb=0}else{if(!(+h[J>>3]>ea)){cb=Ka;break}if(!(+h[K>>3]>ea)){cb=Ka;break}z$a(c[Fa>>2]|0,Z|0,c[Y>>2]|0)|0;cb=0}}while(0);Va=c[na>>2]|0;_=+h[J>>3];b:do{if((Va|0)<4){do{if(_>ea){if(!(+h[K>>3]>ea)){break}c[na>>2]=4;db=4;break b}}while(0);if((Va|0)==1){eb=68;break a}else{db=Va}}else{db=Va}}while(0);if(_<=ea){eb=68;break}if(+h[K>>3]<=ea){eb=68;break}Va=(db+ -4|0)>>>0<2;if(Va&(La|0)<3){Oa=c[ca>>2]|0;if((a[H]|0)==0){z$a(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{z$a(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}$a=+h[V>>3]/10.0;h[V>>3]=$a;Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[206212>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}Pa=w;h[k>>3]=$a;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];hwa(17,0,239552,w);gAa(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<4){Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[Ea>>2]|0;Ya=c[ca>>2]|0;Qa=0;do{Ra=Ya+(Qa<<3)|0;h[Ra>>3]=+h[Pa+(Qa<<3)>>3]*.1+ +h[Ra>>3];Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}h[V>>3]=X;Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[206212>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}hwa(17,0,239624,v);gAa(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<5){Oa=c[ca>>2]|0;if((a[H]|0)==0){z$a(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{z$a(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[Da>>2]|0;Pa=c[Ea>>2]|0;Ya=c[Q>>2]|0;Ra=0;do{_=+U(+(+h[Qa+(Ra<<3)>>3]));h[Ya+(Ra<<3)>>3]=+zd(+_,+(+h[Pa+(Ra<<3)>>3]));Ra=Ra+1|0;}while((Ra|0)<(Oa|0))}Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[206212>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}hwa(17,0,239688,u);gAa(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<6){Oa=c[ca>>2]|0;if((a[H]|0)==0){z$a(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{z$a(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}if((c[ba>>2]|0)!=0){c[ba>>2]=0}Oa=c[F>>2]|0;if((Oa|0)>0){Ra=c[ca>>2]|0;Pa=c[Ea>>2]|0;Ya=c[Q>>2]|0;Qa=0;do{_=+U(+(+h[Ra+(Qa<<3)>>3]));h[Ya+(Qa<<3)>>3]=+zd(+_,+(+h[Pa+(Qa<<3)>>3]));Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[206212>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}hwa(17,0,239760,t);gAa(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}do{if(Va&(La|0)<7){if((a[H]|0)==0){break}z$a(c[ca>>2]|0,c[Da>>2]|0,c[F>>2]<<3|0)|0;Oa=La+1|0;z$a(Z|0,c[Fa>>2]|0,c[Y>>2]|0)|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[206212>>2]|0)==0){fb=Na;gb=Ma;hb=ea;R=0;Ka=1;La=Oa;Na=fb;Ma=gb;ea=hb;continue a}hwa(17,0,239824,s);gAa(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;R=0;Ka=1;La=Oa;Na=fb;Ma=gb;ea=hb;continue a}}while(0);if(Va&(Ma|0)<1){z$a(c[ca>>2]|0,c[Da>>2]|0,c[F>>2]<<3|0)|0;if((c[ba>>2]|0)==0){c[ba>>2]=1}h[V>>3]=X;Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[206212>>2]|0)==0){fb=Na;hb=ea;R=1;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;continue}hwa(17,0,239896,r);gAa(S,L,J,K,18);fb=Na;hb=ea;R=1;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;continue}if(Va&(Ma|0)<2){Oa=c[ca>>2]|0;if((a[H]|0)==0){z$a(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{z$a(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[ca>>2]|0;Pa=0;do{Ya=Qa+(Pa<<3)|0;h[Ya>>3]=+h[Ya>>3]*1.01;Pa=Pa+1|0;}while((Pa|0)<(Oa|0))}Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[206212>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}hwa(17,0,239968,q);gAa(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<3){Oa=c[ca>>2]|0;if((a[H]|0)==0){z$a(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{z$a(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[ca>>2]|0;Qa=0;do{Ya=Pa+(Qa<<3)|0;h[Ya>>3]=+h[Ya>>3]*.99;Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[206212>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}hwa(17,0,240040,p);gAa(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<4){z$a(c[ca>>2]|0,c[Ea>>2]|0,c[F>>2]<<3|0)|0;Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[206212>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}hwa(17,0,240104,o);gAa(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<5){Oa=c[ca>>2]|0;if((a[H]|0)==0){z$a(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{z$a(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[Ga>>2]|0;Pa=c[ja>>2]|0;Ya=0;do{_=+U(+(+h[Qa+(Ya<<3)>>3]));h[Pa+(Ya<<3)>>3]=!(_<=1.0e-16)?_:1.0e-16;Ya=Ya+1|0;}while((Ya|0)<(Oa|0))}Oa=Ma+1|0;c[ka>>2]=2;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[206212>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}hwa(17,0,240176,n);gAa(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(!(Va&(Na|0)<1)){if(!(Va&(Na|0)<6)){eb=160;break}Oa=c[ca>>2]|0;if((a[H]|0)==0){z$a(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{z$a(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}_=ea*10.0;h[V>>3]=X;c[ka>>2]=1;Oa=Na+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[206212>>2]|0)==0){ib=R;ea=_;Ka=cb;La=0;Ma=0;Na=Oa;R=ib;continue}Ya=l;h[k>>3]=_;c[Ya>>2]=c[k>>2];c[Ya+4>>2]=c[k+4>>2];hwa(17,0,240312,l);gAa(S,L,J,K,18);ib=R;ea=_;Ka=cb;La=0;Ma=0;Na=Oa;R=ib;continue}Oa=c[ca>>2]|0;if((a[H]|0)==0){z$a(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{z$a(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Ya=c[ja>>2]|0;Pa=0;do{h[Ya+(Pa<<3)>>3]=1.0;Pa=Pa+1|0;}while((Pa|0)<(Oa|0))}c[ba>>2]=1;Oa=Na+1|0;c[ka>>2]=2;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[206212>>2]|0)==0){hb=ea;ib=R;Ka=cb;La=0;Ma=0;Na=Oa;ea=hb;R=ib;continue}hwa(17,0,240240,m);gAa(S,L,J,K,18);hb=ea;ib=R;Ka=cb;La=0;Ma=0;Na=Oa;ea=hb;R=ib}if((eb|0)==68){c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[206212>>2]|0)!=0){hwa(17,1,239512,y);c[x>>2]=La;c[x+4>>2]=Na+Ma;hwa(17,0,239528,x);le[c[51674]&2047](17);gAa(S,L,J,K,17)}x=(c[ba>>2]|0)!=0;if(x){c[ba>>2]=0;jb=x}else{jb=0}z$a(c[Ca>>2]|0,c[ca>>2]|0,c[F>>2]<<3|0)|0;eAa($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;if(!jb){kb=1;h[V>>3]=X;c[ka>>2]=1;W_a(Z);i=e;return kb|0}c[ba>>2]=1;kb=1;h[V>>3]=X;c[ka>>2]=1;W_a(Z);i=e;return kb|0}else if((eb|0)==160){if(!((db+ -2|0)>>>0<4)){kb=0;h[V>>3]=X;c[ka>>2]=1;W_a(Z);i=e;return kb|0}if((a[Ha]|0)==0){lOa(P,za,T);hb=+h[c[c[Aa>>2]>>2]>>3];Aa=f;T=P;c[Aa+0>>2]=c[T+0>>2];c[Aa+4>>2]=c[T+4>>2];c[Aa+8>>2]=c[T+8>>2];c[Aa+12>>2]=c[T+12>>2];c[Aa+16>>2]=c[T+16>>2];Oxa(0,f,hb);}if((c[206212>>2]|0)!=0){c[j>>2]=fa(fa(Ma,La)|0,Na)|0;hwa(17,0,240384,j);gAa(S,L,J,K,17)}z$a(c[Ca>>2]|0,c[ca>>2]|0,c[F>>2]<<3|0)|0;kb=0;h[V>>3]=X;c[ka>>2]=1;W_a(Z);i=e;return kb|0}return 0}function eAa(b,d,e,f,g,j,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0;g=i;i=i+8|0;n=g;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16384|0;w=l;x=c[l+468>>2]|0;y=c[x+(m*80|0)+40>>2]|0;z=l+318|0;A=c[j>>2]|0;if((A|0)==1){B=y+8|0;do{if((c[B>>2]|0)!=0){C=c[b>>2]|0;if((C|0)<=0){break}D=c[y+12>>2]|0;E=0;do{F=d+(E<<3)|0;h[F>>3]=+h[F>>3]*+h[D+(E<<3)>>3];E=E+1|0;}while((E|0)<(C|0))}}while(0);if((c[206224>>2]|0)!=0){c[u>>2]=c[y+96>>2];hwa(20,0,240632,u);fAa(d,b,20,240664)}Oe[c[x+(m*80|0)+32>>2]&127](l,d,e,j);if((c[206224>>2]|0)!=0){fAa(e,b,20,240680);c[t>>2]=c[y+96>>2];hwa(20,0,240696,t)}if((c[B>>2]|0)==0){i=g;return 0}B=c[b>>2]|0;if((B|0)<=0){i=g;return 0}t=c[y+12>>2]|0;j=0;do{u=d+(j<<3)|0;h[u>>3]=1.0/+h[t+(j<<3)>>3]*+h[u>>3];j=j+1|0;}while((j|0)<(B|0));i=g;return 0}else if((A|0)==2){B=(a[z]|0)!=0;if(B){a[z]=0}if((c[206224>>2]|0)!=0){hwa(20,0,240736,s)}if((c[x+(m*80|0)+28>>2]|0)==-1){iAa(w,f,d,e,m)}else{hAa(w,f,m)}do{if((c[206224>>2]|0)!=0){hwa(20,0,240776,r);if((c[206220>>2]|0)==0){break}m=v;w=c[b>>2]|0;c[q>>2]=w;c[q+4>>2]=w;hwa(19,1,239472,q);w=c[b>>2]|0;if((w|0)>0){e=y+20|0;d=w;w=0;do{a[m]=0;if((d|0)>0){x=0;do{G=+h[f+((fa(c[e>>2]|0,w)|0)+x<<3)>>3];c[p>>2]=m;s=p+4|0;h[k>>3]=G;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];lc(m|0,240808,p|0)|0;x=x+1|0;}while((x|0)<(c[b>>2]|0))}c[o>>2]=m;hwa(19,0,239504,o);w=w+1|0;d=c[b>>2]|0;}while((w|0)<(d|0))}le[c[51674]&2047](19)}}while(0);if(!B){i=g;return 0}a[z]=1;i=g;return 0}else{g=c[l+536>>2]|0;c[n>>2]=A;lwa(g,240824,n)}return 0}function fAa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0.0;f=i;i=i+16|0;g=f;j=i;i=i+8|0;if((c[206144+(d<<2)>>2]|0)==0){i=f;return}c[j>>2]=e;hwa(d,1,239504,j);if((c[b>>2]|0)>0){j=0;do{l=+h[a+(j<<3)>>3];c[g>>2]=j;e=g+4|0;h[k>>3]=l;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];hwa(d,0,240616,g);j=j+1|0;}while((j|0)<(c[b>>2]|0))}le[c[51674]&2047](d);i=f;return}function gAa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0;g=i;i=i+24|0;j=g;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+24|0;p=i;i=i+8|0;q=i;i=i+8|0;if((c[206144+(f<<2)>>2]|0)==0){i=g;return}hwa(f,1,240424,q);hwa(f,1,240440,p);p=a+20|0;if((c[p>>2]|0)>0){q=a+24|0;r=a+64|0;s=0;do{t=+h[(c[q>>2]|0)+(s<<3)>>3];u=+h[(c[r>>2]|0)+(s<<3)>>3];c[o>>2]=s;v=o+4|0;h[k>>3]=t;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];v=o+12|0;h[k>>3]=u;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];hwa(f,0,240456,o);s=s+1|0;}while((s|0)<(c[p>>2]|0))}le[c[51674]&2047](f);hwa(f,1,240496,n);if((c[p>>2]|0)>0){n=a+28|0;s=a+4|0;a=0;do{u=+h[(c[n>>2]|0)+(a<<3)>>3];t=+h[(c[s>>2]|0)+(a<<3)>>3];c[m>>2]=a;o=m+4|0;h[k>>3]=u;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=m+12|0;h[k>>3]=t;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];hwa(f,0,240512,m);a=a+1|0;}while((a|0)<(c[p>>2]|0))}le[c[51674]&2047](f);hwa(f,1,240552,l);t=+h[d>>3];u=+h[e>>3];c[j>>2]=c[b>>2];b=j+4|0;h[k>>3]=t;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=j+12|0;h[k>>3]=u;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];hwa(f,0,240568,j);le[c[51674]&2047](f);le[c[51674]&2047](f);i=g;return}function hAa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0;e=i;f=c[a+468>>2]|0;g=c[f+(d*80|0)+40>>2]|0;j=c[f+(d*80|0)+28>>2]|0;k=g+20|0;l=c[k>>2]|0;B$a(b|0,0,fa(l<<3,l)|0)|0;l=g+108|0;g=c[k>>2]|0;B$a(c[l>>2]|0,0,fa(g<<3,g)|0)|0;g=a+464|0;k=c[g>>2]|0;if((c[k+(j*44|0)+24>>2]|0)==0){i=e;return}m=f+(d*80|0)+20|0;d=a;a=c[k+(j*44|0)>>2]|0;f=k;k=0;do{if((a|0)!=0){n=0;do{if(((c[(c[f+(j*44|0)+20>>2]|0)+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[f+(j*44|0)+28>>2]|0)+(n<<3)>>3]=1.0}n=n+1|0;}while(n>>>0<a>>>0)}oe[c[m>>2]&127](d)|0;f=c[g>>2]|0;a=c[f+(j*44|0)>>2]|0;if((a|0)!=0){n=c[f+(j*44|0)+20>>2]|0;o=c[f+(j*44|0)+28>>2]|0;p=0;do{q=o+(p<<3)|0;do{if(+h[q>>3]==1.0){if((p|0)==0){r=f+(j*44|0)+8|0;s=0}else{t=f+(j*44|0)+8|0;r=t;s=c[(c[t>>2]|0)+(p+ -1<<2)>>2]|0}t=c[(c[r>>2]|0)+(p<<2)>>2]|0;if(!(s>>>0<t>>>0)){break}u=c[l>>2]|0;v=c[f+(j*44|0)+12>>2]|0;w=c[f+(j*44|0)+4>>2]|0;x=c[f+(j*44|0)+36>>2]|0;y=s;do{z=c[v+(y<<2)>>2]|0;A=(fa(w,p)|0)+z|0;B=+h[x+(z<<3)>>3];h[b+(A<<3)>>3]=B;h[u+(A<<3)>>3]=B;y=y+1|0;}while(y>>>0<t>>>0)}}while(0);if(((c[n+(p<<2)>>2]|0)+ -1|0)==(k|0)){h[q>>3]=0.0}p=p+1|0;}while(p>>>0<a>>>0)}k=k+1|0;}while(k>>>0<(c[f+(j*44|0)+24>>2]|0)>>>0);i=e;return}function iAa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0;g=i;i=i+8|0;j=g;k=c[(c[a+468>>2]|0)+(f*80|0)+40>>2]|0;l=k+56|0;m=+h[l>>3];n=+V(+m);c[j>>2]=1;o=k+20|0;p=o;if((c[o>>2]|0)<=0){i=g;return}q=k+128|0;r=k+108|0;s=k+112|0;k=a;t=m;a=0;while(1){m=+h[e+(a<<3)>>3];u=t*m;v=d+(a<<3)|0;w=+h[v>>3];if(!(w>=0.0)){x=-w}else{x=w}if(!(u>=0.0)){y=-u}else{y=u}u=+zd(+(n*+zd(+x,+y)),+n);if(!(m>=0.0)){z=-u}else{z=u}u=z+w-w;m=1.0/u;h[v>>3]=w+u;eAa(p,d,c[q>>2]|0,c[r>>2]|0,s,j,k,f)|0;A=c[o>>2]|0;if((A|0)>0){B=c[q>>2]|0;C=c[r>>2]|0;D=0;do{E=(fa(A,a)|0)+D|0;u=m*(+h[B+(D<<3)>>3]- +h[e+(D<<3)>>3]);h[b+(E<<3)>>3]=u;h[C+(E<<3)>>3]=u;D=D+1|0;}while((D|0)<(A|0))}h[v>>3]=w;D=a+1|0;if((D|0)>=(A|0)){break}t=+h[l>>3];a=D}i=g;return}function jAa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=i;i=i+8|0;f=V_a(80)|0;c[b>>2]=f;kwa(0,(f|0)!=0|0,240904,e);c[f>>2]=0;e=a<<3;g=V_a(e)|0;c[f+4>>2]=g;g=V_a(e)|0;c[f+8>>2]=g;c[f+12>>2]=a;g=V_a(e)|0;c[f+16>>2]=g;g=X_a(a,8)|0;c[f+20>>2]=g;h[f+24>>3]=1.0e-8;h[f+32>>3]=1.0e-8;c[f+44>>2]=a*100;h[f+56>>3]=2.220446049250313e-16;g=V_a(fa(e,a)|0)|0;c[f+64>>2]=g;g=V_a(e)|0;c[f+68>>2]=g;g=V_a(a<<2)|0;c[f+72>>2]=g;kwa(0,(c[b>>2]|0)!=0|0,240936,d);i=d;return 0}function kAa(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;W_a(c[d+4>>2]|0);W_a(c[d+8>>2]|0);W_a(c[d+16>>2]|0);W_a(c[d+20>>2]|0);W_a(c[d+64>>2]|0);W_a(c[d+68>>2]|0);W_a(c[d+72>>2]|0);i=b;return 0}function lAa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=c[a+468>>2]|0;g=c[f+(d*80|0)+28>>2]|0;j=c[(c[f+(d*80|0)+40>>2]|0)+12>>2]|0;B$a(b|0,0,fa(j<<3,j)|0)|0;j=a+464|0;k=c[j>>2]|0;if((c[k+(g*44|0)+24>>2]|0)==0){i=e;return 0}l=f+(d*80|0)+20|0;d=a;a=c[k+(g*44|0)>>2]|0;f=k;k=0;do{if((a|0)!=0){m=0;do{if(((c[(c[f+(g*44|0)+20>>2]|0)+(m<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[f+(g*44|0)+28>>2]|0)+(m<<3)>>3]=1.0}m=m+1|0;}while(m>>>0<a>>>0)}oe[c[l>>2]&127](d)|0;f=c[j>>2]|0;a=c[f+(g*44|0)>>2]|0;if((a|0)!=0){m=c[f+(g*44|0)+20>>2]|0;n=c[f+(g*44|0)+28>>2]|0;o=0;do{p=n+(o<<3)|0;do{if(+h[p>>3]==1.0){if((o|0)==0){q=f+(g*44|0)+8|0;r=0}else{s=f+(g*44|0)+8|0;q=s;r=c[(c[s>>2]|0)+(o+ -1<<2)>>2]|0}s=c[(c[q>>2]|0)+(o<<2)>>2]|0;if(!(r>>>0<s>>>0)){break}t=c[f+(g*44|0)+12>>2]|0;u=c[f+(g*44|0)+4>>2]|0;v=c[f+(g*44|0)+36>>2]|0;w=r;do{x=c[t+(w<<2)>>2]|0;y=(fa(u,o)|0)+x|0;h[b+(y<<3)>>3]=+h[v+(x<<3)>>3];w=w+1|0;}while(w>>>0<s>>>0)}}while(0);if(((c[m+(o<<2)>>2]|0)+ -1|0)==(k|0)){h[p>>3]=0.0}o=o+1|0;}while(o>>>0<a>>>0)}k=k+1|0;}while(k>>>0<(c[f+(g*44|0)+24>>2]|0)>>>0);i=e;return 0}function mAa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0.0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;e=i;i=i+72|0;f=e;g=e+24|0;j=e+48|0;l=i;i=i+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+24|0;r=i;i=i+24|0;s=i;i=i+8|0;t=i;i=i+24|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+24|0;x=i;i=i+24|0;y=i;i=i+24|0;z=c[b+468>>2]|0;A=c[z+(d*80|0)+40>>2]|0;B=c[z+(d*80|0)+4>>2]|0;C=A+40|0;D=C;c[C>>2]=0;E=A+16|0;F=z+(d*80|0)+52|0;G=A+12|0;H=G;z$a(c[E>>2]|0,c[F>>2]|0,c[G>>2]<<3|0)|0;I=b+56|0;if((c[206212>>2]|0)==0){J=b+4|0}else{lOa(w,I,B);K=b+4|0;L=+h[c[c[K>>2]>>2]>>3];c[v>>2]=c[w+8>>2];w=v+4|0;h[k>>3]=L;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];hwa(17,1,240976,v);if((c[G>>2]|0)>0){v=z+(d*80|0)+44|0;w=z+(d*80|0)+16|0;M=z+(d*80|0)+48|0;N=0;do{L=+h[(c[v>>2]|0)+(N<<3)>>3];c[u>>2]=N;O=u+4|0;h[k>>3]=L;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];hwa(17,1,241048,u);L=+h[(c[M>>2]|0)+(N<<3)>>3];P=+h[(c[F>>2]|0)+(N<<3)>>3];O=t;h[k>>3]=+h[(c[w>>2]|0)+(N<<3)>>3];c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=t+8|0;h[k>>3]=L;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=t+16|0;h[k>>3]=P;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];hwa(17,0,241064,t);le[c[51674]&2047](17);N=N+1|0;}while((N|0)<(c[G>>2]|0))}le[c[51674]&2047](17);J=K}K=b+318|0;N=A+20|0;t=A+24|0;w=A+56|0;F=A+44|0;M=A+64|0;u=A+68|0;v=A+72|0;O=A+48|0;Q=O;R=b;b=A+4|0;S=A+32|0;A=z+(d*80|0)+48|0;T=z+(d*80|0)+16|0;U=0;V=0;a:while(1){a[K]=1;W=c[E>>2]|0;X=c[N>>2]|0;Y=c[M>>2]|0;Z=c[u>>2]|0;_=c[v>>2]|0;c[k>>2]=c[t>>2];c[k+4>>2]=c[t+4>>2];nAa(H,W,X,+h[k>>3],w,c[F>>2]|0,D,Y,Z,_,Q,R,d);a[K]=0;if((c[O>>2]|0)==0){lOa(x,I,B);P=+h[c[c[J>>2]>>2]>>3];_=g;Z=x;c[_+0>>2]=c[Z+0>>2];c[_+4>>2]=c[Z+4>>2];c[_+8>>2]=c[Z+8>>2];c[_+12>>2]=c[Z+12>>2];c[_+16>>2]=c[Z+16>>2];Oxa(3,g,P);}$=+tya(H,c[b>>2]|0);aa=+tya(H,c[N>>2]|0);P=+h[S>>3];if(!(!(aa<=P)&!($<=P))){if((c[O>>2]|0)>0){ba=12;break}}do{if((V|0)<1){z$a(c[E>>2]|0,c[A>>2]|0,c[G>>2]<<3|0)|0;Z=c[C>>2]|0;hwa(17,0,241240,p);ca=Z}else{if((V|0)<2){Z=c[G>>2]|0;if((Z|0)>0){_=c[T>>2]|0;Y=c[E>>2]|0;X=0;do{W=Y+(X<<3)|0;h[W>>3]=+h[_+(X<<3)>>3]*.01+ +h[W>>3];X=X+1|0;}while((X|0)<(Z|0))}Z=c[C>>2]|0;hwa(17,0,241296,o);ca=Z;break}if((V|0)>=3){ba=28;break a}Z=c[G>>2]|0;if((Z|0)>0){X=c[T>>2]|0;_=c[E>>2]|0;Y=0;do{h[_+(Y<<3)>>3]=+h[X+(Y<<3)>>3];Y=Y+1|0;}while((Y|0)<(Z|0))}Z=c[C>>2]|0;hwa(17,0,241360,n);ca=Z}}while(0);U=ca+U|0;V=V+1|0}do{if((ba|0)==12){if((c[206212>>2]|0)==0){da=1;break}ca=(c[C>>2]|0)+U|0;c[s>>2]=V;hwa(17,0,241112,s);c[r>>2]=ca;ca=r+4|0;h[k>>3]=aa;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];ca=r+12|0;h[k>>3]=$;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];hwa(17,0,241152,r);if((c[G>>2]|0)>0){ea=0}else{da=1;break}while(1){P=+h[(c[E>>2]|0)+(ea<<3)>>3];L=+h[(c[N>>2]|0)+(ea<<3)>>3];c[q>>2]=ea;ca=q+4|0;h[k>>3]=P;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];ca=q+12|0;h[k>>3]=L;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];hwa(17,0,241208,q);ca=ea+1|0;if((ca|0)<(c[G>>2]|0)){ea=ca}else{da=1;break}}}else if((ba|0)==28){lOa(y,I,B);L=+h[c[c[J>>2]>>2]>>3];ca=f;n=y;c[ca+0>>2]=c[n+0>>2];c[ca+4>>2]=c[n+4>>2];c[ca+8>>2]=c[n+8>>2];c[ca+12>>2]=c[n+12>>2];c[ca+16>>2]=c[n+16>>2];Oxa(0,f,L);if((c[206212>>2]|0)==0){da=0;break}c[m>>2]=V;hwa(17,0,241440,m);c[l>>2]=U;n=l+4|0;h[k>>3]=aa;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=l+12|0;h[k>>3]=$;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];hwa(17,0,241152,l);if((c[206212>>2]|0)==0){da=0;break}if((c[G>>2]|0)>0){fa=0}else{da=0;break}while(1){L=+h[(c[E>>2]|0)+(fa<<3)>>3];P=+h[(c[N>>2]|0)+(fa<<3)>>3];c[j>>2]=fa;n=j+4|0;h[k>>3]=L;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=j+12|0;h[k>>3]=P;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];hwa(17,0,241208,j);n=fa+1|0;if((n|0)<(c[G>>2]|0)){fa=n}else{da=0;break}}}}while(0);if((c[206212>>2]|0)==0){ga=z;ha=d*80|0;ia=ga+ha|0;ja=ia+44|0;ka=ja;la=c[ka>>2]|0;ma=la;na=c[E>>2]|0;oa=na;pa=c[G>>2]|0;qa=pa<<3;z$a(ma|0,oa|0,qa|0)|0;i=e;return da|0}le[c[51674]&2047](17);ga=z;ha=d*80|0;ia=ga+ha|0;ja=ia+44|0;ka=ja;la=c[ka>>2]|0;ma=la;na=c[E>>2]|0;oa=na;pa=c[G>>2]|0;qa=pa<<3;z$a(ma|0,oa|0,qa|0)|0;i=e;return da|0}function nAa(b,d,e,f,g,j,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0;s=i;i=i+8|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+4096|0;E=q;F=c[q+468>>2]|0;G=c[F+(r*80|0)+40>>2]|0;H=+h[G+32>>3];c[B>>2]=1;c[C>>2]=1;do{if((c[206216>>2]|0)!=0){c[z>>2]=j;hwa(18,0,241480,z);if((c[b>>2]|0)>0){I=0}else{break}do{J=+h[d+(I<<3)>>3];c[y>>2]=I;K=y+4|0;h[k>>3]=J;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];hwa(18,0,241528,y);I=I+1|0;}while((I|0)<(c[b>>2]|0))}}while(0);c[p>>2]=1;I=F+(r*80|0)+28|0;F=D;D=G+12|0;y=G+8|0;z=G+4|0;K=G+20|0;L=G+64|0;G=j;a:while(1){oAa(d,e,A,q,r)|0;c[l>>2]=(c[l>>2]|0)+1;if((c[I>>2]|0)==-1){pAa(b,d,e,m,+h[g>>3],A,n,q,r);c[l>>2]=(c[b>>2]|0)+(c[l>>2]|0)}else{lAa(E,m,r)|0}if((c[206220>>2]|0)!=0){j=c[b>>2]|0;c[x>>2]=j;c[x+4>>2]=j;hwa(19,1,241544,x);if((c[D>>2]|0)>0){j=0;do{a[F]=0;if((c[D>>2]|0)>0){M=0;do{J=+h[m+((fa(c[b>>2]|0,j)|0)+M<<3)>>3];c[w>>2]=F;N=w+4|0;h[k>>3]=J;c[N>>2]=c[k>>2];c[N+4>>2]=c[k+4>>2];lc(F|0,241568,w|0)|0;M=M+1|0;}while((M|0)<(c[D>>2]|0))}c[v>>2]=F;hwa(19,0,241576,v);j=j+1|0;}while((j|0)<(c[D>>2]|0))}le[c[51674]&2047](19)}j=c[D>>2]|0;if((j|0)>0){M=c[z>>2]|0;N=c[K>>2]|0;O=c[y>>2]|0;P=0;Q=0;while(1){R=M+(P<<3)|0;h[R>>3]=1.0e-16;S=c[L>>2]|0;T=(j|0)>1?j:1;J=1.0e-16;V=0;W=Q;while(1){X=+U(+(+h[S+(W<<3)>>3]));Y=X>J?X:J;h[R>>3]=Y;Z=V+1|0;if((Z|0)<(j|0)){W=W+1|0;V=Z;J=Y}else{break}}h[O+(P<<3)>>3]=+h[N+(P<<3)>>3]*(1.0/Y);V=P+1|0;if((V|0)<(j|0)){P=V;Q=Q+T|0}else{_=O;break}}}else{_=c[y>>2]|0}J=+tya(b,_);if(!(!(J<=H)&!(+tya(b,e)<=H))){$=31;break}Vqa(b,B,m,b,o,e,b,C)|0;O=c[C>>2]|0;do{if((O|0)>0){c[p>>2]=-1;jwa(17,0,241584,u)}else{if((O|0)<0){c[p>>2]=-1;c[t>>2]=O;jwa(17,0,241616,t);break}Q=c[b>>2]|0;if((Q|0)>0){P=0;do{j=d+(P<<3)|0;h[j>>3]=+h[j>>3]- +h[e+(P<<3)>>3];P=P+1|0;}while((P|0)<(Q|0))}if(+tya(b,e)<=f){$=31;break a}}}while(0);if((G|0)<1){$=30;break}if((c[p>>2]|0)>-1){G=G+ -1|0}else{$=31;break}}if(($|0)==30){c[p>>2]=-1;i=s;return}else if(($|0)==31){i=s;return}}function oAa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;g=i;Oe[c[(c[e+468>>2]|0)+(f*80|0)+32>>2]&127](e,a,b,d);i=g;return 0}function pAa(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0;m=i;n=+V(+f);if((c[a>>2]|0)<=0){i=m;return}o=(c[(c[k+468>>2]|0)+(l*80|0)+56>>2]|0)==0;p=0;do{f=+h[b+(p<<3)>>3];if(o){if(!(f>=0.0)){q=-f}else{q=f}r=n*+zd(1.0,+q);if(!(+h[d+(p<<3)>>3]>=0.0)){s=-r}else{s=r}t=s+f-f}else{t=1.0}u=b+(p<<3)|0;h[u>>3]=t+f;r=1.0/t;oAa(b,j,g,k,l)|0;v=c[a>>2]|0;if((v|0)>0){w=0;do{x=(fa(v,p)|0)+w|0;h[e+(x<<3)>>3]=r*(+h[j+(w<<3)>>3]- +h[d+(w<<3)>>3]);w=w+1|0;}while((w|0)<(v|0))}h[u>>3]=f;p=p+1|0;}while((p|0)<(v|0));i=m;return}function qAa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=c[b+24>>2]|0;if((e|0)==3){f=Lya(a,b)|0;i=d;return f|0}else if((e|0)==1){g=c[a+4>>2]|0;j=c[g+4>>2]|0;sAa(c[g>>2]|0,+h[j>>3],c[j+8>>2]|0,c[a+112>>2]|0,b);f=0;i=d;return f|0}else if((e|0)==4){ze[c[(c[a+540>>2]|0)+56>>2]&1](a,+h[b+8>>3])|0;h[b>>3]=+h[c[c[a+4>>2]>>2]>>3];f=0;i=d;return f|0}else if((e|0)==2){rAa(a,b);f=0;i=d;return f|0}else{f=1;i=d;return f|0}return 0}function rAa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0;d=i;e=c[c[b+48>>2]>>2]|0;f=c[a+4>>2]|0;g=c[f>>2]|0;j=c[f+4>>2]|0;f=g+8|0;k=c[f>>2]|0;l=a+112|0;m=c[l>>2]|0;n=j+8|0;o=c[n>>2]|0;p=j;j=b+8|0;q=b;h[q>>3]=+h[p>>3]+ +h[j>>3];if((m|0)>0){b=c[e>>2]|0;r=0;do{h[b+(r<<3)>>3]=+h[o+(r+m<<3)>>3];r=r+1|0;}while((r|0)<(m|0))}r=g;g=a+540|0;o=m;b=1;do{if((o|0)>0){s=c[n>>2]|0;t=+h[241648+(b<<3)>>3];u=c[e+(b+ -1<<2)>>2]|0;v=c[f>>2]|0;w=0;while(1){h[v+(w<<3)>>3]=+h[s+(w<<3)>>3]+ +h[j>>3]*t*+h[u+(w<<3)>>3];x=w+1|0;if((x|0)<(o|0)){w=x}else{y=t;break}}}else{y=+h[241648+(b<<3)>>3]}h[r>>3]=+h[p>>3]+y*+h[j>>3];oe[c[(c[g>>2]|0)+28>>2]&127](a)|0;o=c[l>>2]|0;z=(o|0)>0;if(z){w=c[e+(b<<2)>>2]|0;u=0;do{h[w+(u<<3)>>3]=+h[k+(u+m<<3)>>3];u=u+1|0;}while((u|0)<(o|0))}b=b+1|0;}while((b|0)<4);if(!z){A=+h[q>>3];h[r>>3]=A;i=d;return}z=c[n>>2]|0;n=c[f>>2]|0;f=c[e>>2]|0;b=c[e+4>>2]|0;m=c[e+8>>2]|0;k=c[e+12>>2]|0;e=0;do{h[n+(e<<3)>>3]=+h[z+(e<<3)>>3]+(+h[f+(e<<3)>>3]*.16666666666666666+0.0+ +h[b+(e<<3)>>3]*.3333333333333333+ +h[m+(e<<3)>>3]*.3333333333333333+ +h[k+(e<<3)>>3]*.16666666666666666)*+h[j>>3];e=e+1|0;}while((e|0)<(o|0));A=+h[q>>3];h[r>>3]=A;i=d;return}function sAa(a,b,d,e,f){a=a|0;b=+b;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0;g=i;j=f+8|0;k=+h[j>>3];l=k+b;m=f;h[m>>3]=l;if((e|0)<=0){n=l;o=a;p=o;h[p>>3]=n;i=g;return}f=c[a+8>>2]|0;l=k;q=0;while(1){h[f+(q<<3)>>3]=+h[d+(q<<3)>>3]+ +h[d+(q+e<<3)>>3]*l;r=q+1|0;if((r|0)>=(e|0)){break}l=+h[j>>3];q=r}n=+h[m>>3];o=a;p=o;h[p>>3]=n;i=g;return}function tAa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+8|0;f=e;h[d>>3]=+h[b+240>>3];h[d+8>>3]=+h[b+264>>3];h[d+16>>3]=0.0;a[d+28|0]=0;c[d+32>>2]=owa(4)|0;c[d+36>>2]=0;c[d+40>>2]=0;c[d+44>>2]=0;g=c[d+24>>2]|0;a:do{if((g|0)==2){j=V_a(8)|0;c[j+4>>2]=4;k=V_a(20)|0;c[j>>2]=k;l=c[b+112>>2]|0;m=k;k=0;while(1){c[m+(k<<2)>>2]=X_a(l,8)|0;if((k|0)>=4){break}m=c[j>>2]|0;k=k+1|0}c[d+48>>2]=j;n=0}else if((g|0)==4){k=c[4404]|0;m=V_a(k<<2)|0;c[60426]=m;if((k|0)<=0){n=0;break}l=c[b+116>>2]|0;o=m;m=0;while(1){c[o+(m<<2)>>2]=X_a(l,8)|0;p=m+1|0;if((p|0)>=(k|0)){n=0;break a}o=c[60426]|0;m=p}}else if((g|0)==3){m=V_a(88)|0;hwa(23,0,241680,f);o=Jya(b,d,m)|0;c[d+48>>2]=m;n=o}else{n=0}}while(0);GAa(b)|0;if((c[2]|0)==0){i=e;return n|0}Exa(6);Bxa(1);i=e;return n|0}function uAa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=c[b+24>>2]|0;if((e|0)==2){f=b+48|0;g=c[f>>2]|0;h=c[g>>2]|0;if((c[g+4>>2]|0)>-1){g=h;j=0;while(1){W_a(c[g+(j<<2)>>2]|0);k=c[f>>2]|0;l=c[k>>2]|0;if((j|0)<(c[k+4>>2]|0)){j=j+1|0;g=l}else{m=l;break}}}else{m=h}W_a(m);W_a(c[f>>2]|0)}else if((e|0)==4){f=c[4404]|0;m=c[60426]|0;if((f|0)>0){h=m;g=0;while(1){W_a(c[h+(g<<2)>>2]|0);j=g+1|0;l=c[60426]|0;if((j|0)<(f|0)){g=j;h=l}else{n=l;break}}}else{n=m}W_a(n)}else if((e|0)==3){Kya(c[b+48>>2]|0)|0}HAa(a)|0;BAa(a);i=d;return 0}function vAa(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;k=i;i=i+8|0;l=k;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+168|0;c[o>>2]=0;p=i;i=i+160|0;q=b+536|0;r=c[q>>2]|0;u=0;pa(1260,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){t=K$a(c[s>>2]|0,o)|0;if((t|0)==0){fb(s|0,v|0)}J=v}else{t=-1}do{if((t|0)==1){w=0;x=0;y=0;z=0;A=J}else{u=0;sa(97,b|0)|0;s=u;u=0;if((s|0)!=0&(v|0)!=0){B=K$a(c[s>>2]|0,o)|0;if((B|0)==0){fb(s|0,v|0)}J=v}else{B=-1}if((B|0)==1){w=0;x=0;y=0;z=0;A=J;break}s=b+540|0;u=0;sa(c[(c[s>>2]|0)+40>>2]|0,b|0)|0;C=u;u=0;if((C|0)!=0&(v|0)!=0){D=K$a(c[C>>2]|0,o)|0;if((D|0)==0){fb(C|0,v|0)}J=v}else{D=-1}if((D|0)==1){w=0;x=0;y=0;z=0;A=J;break}if((a[b+440|0]|0)!=0){u=0;sa(c[(c[s>>2]|0)+44>>2]|0,b|0)|0;C=u;u=0;if((C|0)!=0&(v|0)!=0){E=K$a(c[C>>2]|0,o)|0;if((E|0)==0){fb(C|0,v|0)}J=v}else{E=-1}if((E|0)==1){w=0;x=0;y=0;z=0;A=J;break}}C=b+240|0;h[c[c[b+4>>2]>>2]>>3]=+h[C>>3];u=0;pa(c[(c[s>>2]|0)+4>>2]|0,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){F=K$a(c[s>>2]|0,o)|0;if((F|0)==0){fb(s|0,v|0)}J=v}else{F=-1}if((F|0)==1){w=0;x=0;y=0;z=C;A=J;break}u=0;pa(1261,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){G=K$a(c[s>>2]|0,o)|0;if((G|0)==0){fb(s|0,v|0)}J=v}else{G=-1}if((G|0)==1){w=0;x=0;y=0;z=C;A=J;break}u=0;oa(1,+(+h[b+272>>3]));s=u;u=0;if((s|0)!=0&(v|0)!=0){H=K$a(c[s>>2]|0,o)|0;if((H|0)==0){fb(s|0,v|0)}J=v}else{H=-1}if((H|0)==1){w=0;x=0;y=0;z=C;A=J;break}c[(c[q>>2]|0)+84>>2]=1;s=p;I=r+80|0;K=c[I>>2]|0;c[I>>2]=p;w$a(p,1,o|0)|0;u=0;L=u;u=0;if((L|0)!=0&(v|0)!=0){M=K$a(c[L>>2]|0,o)|0;if((M|0)==0){fb(L|0,v|0)}J=v}else{M=-1}if((M|0)==1){w=K;x=I;y=s;z=C;A=J;break}w=K;x=I;y=s;z=C;A=0}}while(0);a:while(1){do{if((A|0)==0){u=0;M=Ja(1,b|0,d|0,e|0,f|0,+g,j|0)|0;p=u;u=0;if((p|0)!=0&(v|0)!=0){N=K$a(c[p>>2]|0,o)|0;if((N|0)==0){fb(p|0,v|0)}J=v}else{N=-1}if((N|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue a}if((M|0)==0){S=0;T=1;break}u=0;Sa(14,1,0,241712,n|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){U=K$a(c[M>>2]|0,o)|0;if((U|0)==0){fb(M|0,v|0)}J=v}else{U=-1}if((U|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue a}h[b+248>>3]=+h[z>>3];S=-1;T=1}else{S=0;T=0}}while(0);c[x>>2]=w;u=0;M=u;u=0;if((M|0)!=0&(v|0)!=0){V=K$a(c[M>>2]|0,o)|0;if((V|0)==0){fb(M|0,v|0)}J=v}else{V=-1}if((V|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}if(T){W=S}else{u=0;Sa(15,2,0,241808,m|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){X=K$a(c[M>>2]|0,o)|0;if((X|0)==0){fb(M|0,v|0)}J=v}else{X=-1}if((X|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}W=-1}u=0;qa(c[247928>>2]|0,247904,b|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){Y=K$a(c[M>>2]|0,o)|0;if((Y|0)==0){fb(M|0,v|0)}J=v}else{Y=-1}if((Y|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}u=0;Sa(15,23,0,241864,l|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){Z=K$a(c[M>>2]|0,o)|0;if((Z|0)==0){fb(M|0,v|0)}J=v}else{Z=-1}if((Z|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}if((c[2]|0)==0){_=26;break}u=0;pa(1262,1);M=u;u=0;if((M|0)!=0&(v|0)!=0){$=K$a(c[M>>2]|0,o)|0;if(($|0)==0){fb(M|0,v|0)}J=v}else{$=-1}if(($|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R}else{break}}if((_|0)==26){i=k;return W|0}i=k;return W|0}



function XC(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[63880]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=57624;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&127](mb,m,33768,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]}jA(t,c[ib>>2]|0,jb);jb=+h[t>>3];kA(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);jb=+h[v>>3];jA(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);pb=+h[w>>3];kA(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+392>>3];qb=+zd(1.0e-13,+(+h[w+400>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+nwa(c[ib>>2]|0,qb,33840,33760,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(pb- +yd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{jA(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);sb=+h[z>>3];kA(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);sb=+h[B>>3];jA(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);jb=+h[C>>3];kA(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+zd(1.0e-13,+(+h[C+400>>3]- +h[E>>3]));pb=1.0- +h[C+392>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+nwa(c[ib>>2]|0,jb,33840,33760,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{jA(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);vb=+h[F>>3];kA(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);vb=+h[H>>3];jA(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);sb=+h[I>>3];kA(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);sb=+h[K>>3];jA(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);jb=+h[L>>3];kA(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+400>>3]- +h[N>>3])|0)<<24>>24==0){jA(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);jb=+h[O>>3];kA(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Q,c[ib>>2]|0,+h[P+384>>3],+h[P+1040>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(R,c[ib>>2]|0,+h[Q+384>>3],+h[Q+1040>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(S,c[ib>>2]|0,jb,pb,+h[Q+384>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+1040>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+1056>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}jA(T,c[ib>>2]|0,+h[xb+384>>3]);qb=+h[T>>3];kA(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);qb=+h[V>>3];jA(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);pb=+h[W>>3];kA(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);pb=+h[Y>>3];jA(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);jb=+h[Z>>3];kA(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA($,c[ib>>2]|0,+h[_+384>>3],+h[_+1040>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(aa,c[ib>>2]|0,+h[$+384>>3],+h[$+1040>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(ba,c[ib>>2]|0,jb,rb,+h[$+384>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+1040>>3],0.0);zb=+h[ba>>3];jA(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);rb=+h[ca>>3];kA(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+400>>3];Ab=+zd(1.0e-13,+(jb-qb));qb=Ab*+zd(1.0e-13,+(jb-pb));pb=+h[ea+1048>>3];Ab=-(pb*+zd(1.0e-13,+(jb-sb)));sb=+h[ea+392>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+nwa(c[ib>>2]|0,qb,34144,33760,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+392>>3];Cb=+h[ca+400>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+zd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+nwa(c[ib>>2]|0,Eb,33840,33760,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+1048>>3]-wb}wb=+h[tb+384>>3];if(wb>0.0){Gb=wb}else{tb=c[63880]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=57624;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&127](Db,l,33768,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]}if(Gb>0.0){Hb=Gb}else{r=c[63880]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=57624;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&127](l,j,33768,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]}jA(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];kA(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);Hb=+h[ia>>3];jA(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);Fb=+h[ja>>3];kA(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3];if(zb>0.0){Ib=zb}else{la=c[63880]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=57624;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&127](ka,g,33768,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]}if(Ib>0.0){Jb=Ib}else{p=c[63880]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=57624;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&127](g,f,33768,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]}if(Jb>0.0){Kb=Jb}else{o=c[63880]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=57624;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&127](f,e,33768,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]}qb=Kb+-273.15;lA(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];jA(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);qb=+h[na>>3];kA(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);qb=+h[pa>>3];jA(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);Eb=+h[qa>>3];kA(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+392>>3];rb=+zd(1.0e-13,+(+h[qa+400>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+nwa(c[ib>>2]|0,rb,33840,33760,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(Eb- +yd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{jA(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);Lb=+h[ta>>3];kA(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);Lb=+h[va>>3];jA(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);qb=+h[wa>>3];kA(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+zd(1.0e-13,+(+h[wa+400>>3]- +h[ya>>3]));Eb=1.0- +h[wa+392>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+nwa(c[ib>>2]|0,qb,33840,33760,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{jA(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);Ob=+h[za>>3];kA(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);Ob=+h[Ba>>3];jA(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);Lb=+h[Ca>>3];kA(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);Lb=+h[Ea>>3];jA(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);qb=+h[Fa>>3];kA(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+400>>3]- +h[Ha>>3])|0)<<24>>24==0){jA(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);qb=+h[Ia>>3];kA(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Ka,c[ib>>2]|0,+h[Ja+384>>3],+h[Ja+1040>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(La,c[ib>>2]|0,+h[Ka+384>>3],+h[Ka+1040>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+384>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+1040>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+1056>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}jA(Na,c[ib>>2]|0,+h[Qb+384>>3]);rb=+h[Na>>3];kA(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);rb=+h[Pa>>3];jA(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);Eb=+h[Qa>>3];kA(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);Eb=+h[Sa>>3];jA(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);qb=+h[Ta>>3];kA(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Va,c[ib>>2]|0,+h[Ua+384>>3],+h[Ua+1040>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(Wa,c[ib>>2]|0,+h[Va+384>>3],+h[Va+1040>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Xa,c[ib>>2]|0,qb,Bb,+h[Va+384>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+1040>>3],0.0);Cb=+h[Xa>>3];jA(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);Bb=+h[Ya>>3];kA(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+400>>3];vb=+zd(1.0e-13,+(qb-rb));rb=vb*+zd(1.0e-13,+(qb-Eb));Eb=+h[Za+1048>>3];vb=-(Eb*+zd(1.0e-13,+(qb-Lb)));Lb=+h[Za+392>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+nwa(c[ib>>2]|0,rb,34144,33760,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+392>>3];Tb=+h[Ya+400>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+zd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+nwa(c[ib>>2]|0,Vb,33840,33760,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+1048>>3]-Pb}Pb=+h[Mb+384>>3];Wb=Pb+-273.15;Cb=+h[Mb+1040>>3];sA($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];jA(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);Pb=+h[ab>>3];kA(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);Pb=+h[cb>>3];jA(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);Wb=+h[db>>3];kA(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+384>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+nwa(c[ib>>2]|0,rb,34752,33760,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+384>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+1048>>3]-ub);ub=+h[Yb+1040>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+nwa(c[ib>>2]|0,Xb,34752,33760,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+1040>>3];ac=+h[Yb+384>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+Nxa(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+392>>3];Gb=+zd(1.0e-13,+(+h[Yb+400>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+nwa(c[ib>>2]|0,Gb,33840,33760,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +zd(+(ac- +yd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+384>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+nwa(c[ib>>2]|0,ec,34752,33760,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+384>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+1048>>3];ic=+h[gc+1040>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+nwa(c[ib>>2]|0,fc,34752,33760,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+1040>>3];kc=+h[gc+384>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+Nxa(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+392>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+zd(1.0e-13,+(+h[gc+400>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9360|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9360|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+nwa(c[ib>>2]|0,Nb,33840,33760,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9360|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function YC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8040>>3]=+h[b+9360>>3]+(-(+h[b+5296>>3]*+h[b+1040>>3])- +h[b+8856>>3]*+h[b+384>>3]);i=i;return}function ZC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8504>>3]=+h[b+6224>>3]*+h[b+8040>>3]+ +h[b+6144>>3]*+h[b+5304>>3];i=i;return}function _C(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;gxa(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+368>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+376>>3];l=+h[a+360>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];tA(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5208>>3]=+h[f>>3];i=b;return}function $C(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6296>>3]=1.0- +h[b+368>>3];i=i;return}function aD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+368>>3];v=l;h[k>>3]=+h[t+6296>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];gxa(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+376>>3];w=+h[t+360>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];vz(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Bz(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+392>>3];f=j;h[k>>3]=+h[q+6304>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];gxa(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+400>>3];y=+h[f+384>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];vz(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Bz(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+5632>>3]=(+h[d+424>>3]+ +h[d+432>>3])*(w- +h[r>>3])*+h[d+1760>>3]*.5;i=b;return}function bD(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5120>>3];k=+zd(1.0e-13,+(+h[g+376>>3]-j));l=+h[g+6296>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+nwa(c[b+536>>2]|0,k,34784,34776,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8080|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=Cza(1.0e-13,+h[f+376>>3]- +h[f+5120>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+5120>>3];j=+h[x+376>>3];k=+zd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+8792>>3];k=+h[x+6296>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+1032>>3]- +h[x+8896>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+1032>>3]- +h[x+8896>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+1032>>3]- +h[x+8896>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+1032>>3]- +h[x+8896>>3]}K=(y-k*J)/+nwa(c[b+536>>2]|0,l,34848,34776,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+6296>>3];C=+h[L+5120>>3];D=+h[L+376>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+8896>>3];m=+zd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+nwa(c[b+536>>2]|0,m,34784,34776,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8080|0;w=v;h[w>>3]=n;i=d;return}function cD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+368>>3];p=f;h[k>>3]=+h[n+6296>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+376>>3];q=+h[p+360>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Nz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4896>>3]=+h[l>>3];i=b;return}function dD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+368>>3];p=f;h[k>>3]=+h[n+6296>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+376>>3];q=+h[p+360>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Qz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4736>>3]=+h[l>>3];i=b;return}function eD(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;xz(d,c[a+536>>2]|0,+h[f+4536>>3],+h[(c[a+416>>2]|0)+472>>3],+h[f+4736>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4856>>3]=+h[d>>3];i=b;return}function fD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+368>>3];p=f;h[k>>3]=+h[n+6296>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+376>>3];q=+h[p+360>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Oz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4776>>3]=+h[l>>3];i=b;return}function gD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+368>>3];p=f;h[k>>3]=+h[n+6296>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+376>>3];q=+h[p+360>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Vz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4816>>3]=+h[l>>3];i=b;return}function hD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+368>>3];p=f;h[k>>3]=+h[n+6296>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+376>>3];q=+h[p+360>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];fA(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4496>>3]=+h[l>>3];i=b;return}function iD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+368>>3];p=f;h[k>>3]=+h[n+6296>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+376>>3];q=+h[p+360>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+5768>>3]=+h[l>>3];i=b;return}function jD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+368>>3];p=f;h[k>>3]=+h[n+6296>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+376>>3];q=+h[p+360>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+5840>>3]=+h[l>>3];i=b;return}function kD(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5120>>3];k=+zd(1.0e-13,+(+h[g+376>>3]-j));l=+h[g+6296>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+nwa(c[b+536>>2]|0,k,34784,34976,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+5136>>3]=+yd(+(j*n*.6219647130774989),1.0);i=d;return}function lD(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(Cza(+h[a+368>>3]- +h[a+5136>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+8888|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+1024>>3]- +h[a+8080>>3];g=a;j=g+8888|0;k=j;h[k>>3]=f;i=b;return}function mD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8072>>3]=+h[b+1024>>3]- +h[b+8888>>3];i=i;return}function nD(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+5152>>3]=+zd(+(+h[d+368>>3]- +h[d+5136>>3]),0.0);i=b;return}function oD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5144>>3]=+h[b+368>>3]- +h[b+5152>>3];i=i;return}function pD(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5152>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+8888>>3];o=+h[g+8792>>3]*k+ +h[g+6296>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+nwa(c[b+536>>2]|0,l,34992,34984,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+8888>>3];q=+h[v+5152>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+8072>>3]*(1.0-q)+ +h[r+5144>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+8880|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+8880|0;C=B;h[C>>3]=z;i=d;return}p=t/+nwa(c[b+536>>2]|0,l,34992,34984,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+8880|0;C=B;h[C>>3]=z;i=d;return}function qD(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5152>>3];k=1.0-j;l=+h[g+6296>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+nwa(c[b+536>>2]|0,k,35040,35032,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+5152>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+5144>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+5184|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+5184|0;z=y;h[z>>3]=w;i=d;return}l=m/+nwa(c[b+536>>2]|0,p,35040,35032,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+5184|0;z=y;h[z>>3]=w;i=d;return}function rD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5192>>3]=+h[b+5208>>3]- +h[b+5184>>3]*+h[b+360>>3];i=i;return}function sD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8064>>3]=+h[b+9376>>3]+(-(+h[b+5184>>3]*+h[b+1016>>3])- +h[b+8880>>3]*+h[b+360>>3]);i=i;return}function tD(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5184>>3];k=+h[g+360>>3];l=j*k;m=l*l;n=+h[g+1032>>3]*l- +h[g+376>>3]*(j*+h[g+1016>>3]+k*+h[g+8880>>3]);if(m!=0.0){o=g;p=n/m;q=o;r=q+9384|0;s=r;h[s>>3]=p;i=d;return}if(n==0.0){o=g;p=n;q=o;r=q+9384|0;s=r;h[s>>3]=p;i=d;return}k=n/+nwa(c[b+536>>2]|0,m,35080,35072,+h[f>>3],(a[b+319|0]|0)!=0|0);o=c[(c[c[e>>2]>>2]|0)+8>>2]|0;p=k;q=o;r=q+9384|0;s=r;h[s>>3]=p;i=d;return}function uD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6152>>3]=+h[b+10144>>3]*+h[b+9384>>3];i=i;return}function vD(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+360>>3]*+h[g+5184>>3];k=+h[g+376>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+5200|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+5200|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,35136,35128,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+5200|0;p=o;h[p>>3]=m;i=d;return}function wD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6232>>3]=+h[b+10144>>3]*+h[b+5200>>3];i=i;return}function xD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6112>>3]=+h[b+368>>3]*+h[b+6152>>3]+ +h[b+1024>>3]*+h[b+6232>>3];i=i;return}function yD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8512>>3]=+h[b+6232>>3]*+h[b+8064>>3]+ +h[b+6152>>3]*+h[b+5192>>3];i=i;return}function zD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;gxa(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+344>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+352>>3];l=+h[a+336>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];tA(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5096>>3]=+h[f>>3];i=b;return}function AD(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;iA(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+336>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+5008>>3]=+yd(+(+h[d>>3]),+(+h[a+352>>3]*.999));i=b;return}function BD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6288>>3]=1.0- +h[b+344>>3];i=i;return}function CD(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5008>>3];k=+zd(1.0e-13,+(+h[g+352>>3]-j));l=+h[g+6288>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+nwa(c[b+536>>2]|0,k,35184,35176,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+5024>>3]=+yd(+(j*n*.6219647130774989),1.0);i=d;return}function DD(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+5040>>3]=+zd(+(+h[d+344>>3]- +h[d+5024>>3]),0.0);i=b;return}function ED(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5032>>3]=+h[b+344>>3]- +h[b+5040>>3];i=i;return}function FD(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5008>>3];k=+zd(1.0e-13,+(+h[g+352>>3]-j));l=+h[g+6288>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+nwa(c[b+536>>2]|0,k,35184,35248,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8104|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=Cza(1.0e-13,+h[f+352>>3]- +h[f+5008>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+5008>>3];j=+h[x+352>>3];k=+zd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+8800>>3];k=+h[x+6288>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+1008>>3]- +h[x+8920>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+1008>>3]- +h[x+8920>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+1008>>3]- +h[x+8920>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+1008>>3]- +h[x+8920>>3]}K=(y-k*J)/+nwa(c[b+536>>2]|0,l,35256,35248,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+6288>>3];C=+h[L+5008>>3];D=+h[L+352>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+8920>>3];m=+zd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+nwa(c[b+536>>2]|0,m,35184,35248,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8104|0;w=v;h[w>>3]=n;i=d;return}function GD(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(Cza(+h[a+344>>3]- +h[a+5024>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+8912|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+1e3>>3]- +h[a+8104>>3];g=a;j=g+8912|0;k=j;h[k>>3]=f;i=b;return}function HD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8096>>3]=+h[b+1e3>>3]- +h[b+8912>>3];i=i;return}function ID(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5040>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+8912>>3];o=+h[g+8800>>3]*k+ +h[g+6288>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+nwa(c[b+536>>2]|0,l,35392,35384,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+8912>>3];q=+h[v+5040>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+8096>>3]*(1.0-q)+ +h[r+5032>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+8904|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+8904|0;C=B;h[C>>3]=z;i=d;return}p=t/+nwa(c[b+536>>2]|0,l,35392,35384,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+8904|0;C=B;h[C>>3]=z;i=d;return}function JD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+344>>3];v=l;h[k>>3]=+h[t+6288>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];gxa(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+352>>3];w=+h[t+336>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];vz(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Bz(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+368>>3];f=j;h[k>>3]=+h[q+6296>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];gxa(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+376>>3];y=+h[f+360>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];vz(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Bz(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+5640>>3]=(+h[d+432>>3]+ +h[d+440>>3])*(w- +h[r>>3])*+h[d+1760>>3]*.5;i=b;return}function KD(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5040>>3];k=1.0-j;l=+h[g+6288>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+nwa(c[b+536>>2]|0,k,35440,35432,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+5040>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+5032>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+5072|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+5072|0;z=y;h[z>>3]=w;i=d;return}l=m/+nwa(c[b+536>>2]|0,p,35440,35432,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+5072|0;z=y;h[z>>3]=w;i=d;return}function LD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8088>>3]=+h[b+9392>>3]+(-(+h[b+5072>>3]*+h[b+992>>3])- +h[b+8904>>3]*+h[b+336>>3]);i=i;return}function MD(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+336>>3]*+h[g+5072>>3];k=+h[g+352>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+5088|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+5088|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,35480,35472,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+5088|0;p=o;h[p>>3]=m;i=d;return}function ND(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6240>>3]=+h[b+10152>>3]*+h[b+5088>>3];i=i;return}function OD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5080>>3]=+h[b+5096>>3]- +h[b+5072>>3]*+h[b+336>>3];i=i;return}function PD(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5072>>3];k=+h[g+336>>3];l=j*k;m=l*l;n=+h[g+1008>>3]*l- +h[g+352>>3]*(j*+h[g+992>>3]+k*+h[g+8904>>3]);if(m!=0.0){o=g;p=n/m;q=o;r=q+9400|0;s=r;h[s>>3]=p;i=d;return}if(n==0.0){o=g;p=n;q=o;r=q+9400|0;s=r;h[s>>3]=p;i=d;return}k=n/+nwa(c[b+536>>2]|0,m,35528,35520,+h[f>>3],(a[b+319|0]|0)!=0|0);o=c[(c[c[e>>2]>>2]|0)+8>>2]|0;p=k;q=o;r=q+9400|0;s=r;h[s>>3]=p;i=d;return}function QD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6160>>3]=+h[b+10152>>3]*+h[b+9400>>3];i=i;return}function RD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8520>>3]=+h[b+6240>>3]*+h[b+8088>>3]+ +h[b+6160>>3]*+h[b+5080>>3];i=i;return}function SD(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6120>>3]=+h[b+344>>3]*+h[b+6160>>3]+ +h[b+1e3>>3]*+h[b+6240>>3];i=i;return}function TD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+344>>3];p=f;h[k>>3]=+h[n+6288>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+352>>3];q=+h[p+336>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Nz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4904>>3]=+h[l>>3];i=b;return}function UD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+344>>3];p=f;h[k>>3]=+h[n+6288>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+352>>3];q=+h[p+336>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Qz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4744>>3]=+h[l>>3];i=b;return}function VD(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;xz(d,c[a+536>>2]|0,+h[f+4544>>3],+h[(c[a+416>>2]|0)+480>>3],+h[f+4744>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4864>>3]=+h[d>>3];i=b;return}function WD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+344>>3];p=f;h[k>>3]=+h[n+6288>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+352>>3];q=+h[p+336>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Oz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4784>>3]=+h[l>>3];i=b;return}function XD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+344>>3];p=f;h[k>>3]=+h[n+6288>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+352>>3];q=+h[p+336>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Vz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4824>>3]=+h[l>>3];i=b;return}function YD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+344>>3];p=f;h[k>>3]=+h[n+6288>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+352>>3];q=+h[p+336>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];fA(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4504>>3]=+h[l>>3];i=b;return}function ZD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+344>>3];p=f;h[k>>3]=+h[n+6288>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+352>>3];q=+h[p+336>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+5776>>3]=+h[l>>3];i=b;return}function _D(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+344>>3];p=f;h[k>>3]=+h[n+6288>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+352>>3];q=+h[p+336>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+5848>>3]=+h[l>>3];i=b;return}function $D(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[63880]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=57624;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&127](mb,m,35584,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]}jA(t,c[ib>>2]|0,jb);jb=+h[t>>3];kA(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);jb=+h[v>>3];jA(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);pb=+h[w>>3];kA(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+248>>3];qb=+zd(1.0e-13,+(+h[w+256>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+nwa(c[ib>>2]|0,qb,35656,35576,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(pb- +yd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{jA(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);sb=+h[z>>3];kA(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);sb=+h[B>>3];jA(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);jb=+h[C>>3];kA(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+zd(1.0e-13,+(+h[C+256>>3]- +h[E>>3]));pb=1.0- +h[C+248>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+nwa(c[ib>>2]|0,jb,35656,35576,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{jA(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);vb=+h[F>>3];kA(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);vb=+h[H>>3];jA(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);sb=+h[I>>3];kA(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);sb=+h[K>>3];jA(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);jb=+h[L>>3];kA(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+256>>3]- +h[N>>3])|0)<<24>>24==0){jA(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);jb=+h[O>>3];kA(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Q,c[ib>>2]|0,+h[P+240>>3],+h[P+896>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(R,c[ib>>2]|0,+h[Q+240>>3],+h[Q+896>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(S,c[ib>>2]|0,jb,pb,+h[Q+240>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+896>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+912>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}jA(T,c[ib>>2]|0,+h[xb+240>>3]);qb=+h[T>>3];kA(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);qb=+h[V>>3];jA(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);pb=+h[W>>3];kA(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);pb=+h[Y>>3];jA(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);jb=+h[Z>>3];kA(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA($,c[ib>>2]|0,+h[_+240>>3],+h[_+896>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(aa,c[ib>>2]|0,+h[$+240>>3],+h[$+896>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(ba,c[ib>>2]|0,jb,rb,+h[$+240>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+896>>3],0.0);zb=+h[ba>>3];jA(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);rb=+h[ca>>3];kA(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+256>>3];Ab=+zd(1.0e-13,+(jb-qb));qb=Ab*+zd(1.0e-13,+(jb-pb));pb=+h[ea+904>>3];Ab=-(pb*+zd(1.0e-13,+(jb-sb)));sb=+h[ea+248>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+nwa(c[ib>>2]|0,qb,35960,35576,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+248>>3];Cb=+h[ca+256>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+zd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+nwa(c[ib>>2]|0,Eb,35656,35576,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+904>>3]-wb}wb=+h[tb+240>>3];if(wb>0.0){Gb=wb}else{tb=c[63880]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=57624;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&127](Db,l,35584,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]}if(Gb>0.0){Hb=Gb}else{r=c[63880]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=57624;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&127](l,j,35584,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]}jA(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];kA(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);Hb=+h[ia>>3];jA(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);Fb=+h[ja>>3];kA(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3];if(zb>0.0){Ib=zb}else{la=c[63880]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=57624;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&127](ka,g,35584,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]}if(Ib>0.0){Jb=Ib}else{p=c[63880]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=57624;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&127](g,f,35584,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]}if(Jb>0.0){Kb=Jb}else{o=c[63880]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=57624;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&127](f,e,35584,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]}qb=Kb+-273.15;lA(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];jA(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);qb=+h[na>>3];kA(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);qb=+h[pa>>3];jA(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);Eb=+h[qa>>3];kA(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+248>>3];rb=+zd(1.0e-13,+(+h[qa+256>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+nwa(c[ib>>2]|0,rb,35656,35576,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(Eb- +yd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{jA(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);Lb=+h[ta>>3];kA(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);Lb=+h[va>>3];jA(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);qb=+h[wa>>3];kA(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+zd(1.0e-13,+(+h[wa+256>>3]- +h[ya>>3]));Eb=1.0- +h[wa+248>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+nwa(c[ib>>2]|0,qb,35656,35576,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{jA(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);Ob=+h[za>>3];kA(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);Ob=+h[Ba>>3];jA(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);Lb=+h[Ca>>3];kA(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);Lb=+h[Ea>>3];jA(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);qb=+h[Fa>>3];kA(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+256>>3]- +h[Ha>>3])|0)<<24>>24==0){jA(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);qb=+h[Ia>>3];kA(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Ka,c[ib>>2]|0,+h[Ja+240>>3],+h[Ja+896>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(La,c[ib>>2]|0,+h[Ka+240>>3],+h[Ka+896>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+240>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+896>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+912>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}jA(Na,c[ib>>2]|0,+h[Qb+240>>3]);rb=+h[Na>>3];kA(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);rb=+h[Pa>>3];jA(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);Eb=+h[Qa>>3];kA(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);Eb=+h[Sa>>3];jA(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);qb=+h[Ta>>3];kA(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Va,c[ib>>2]|0,+h[Ua+240>>3],+h[Ua+896>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(Wa,c[ib>>2]|0,+h[Va+240>>3],+h[Va+896>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Xa,c[ib>>2]|0,qb,Bb,+h[Va+240>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+896>>3],0.0);Cb=+h[Xa>>3];jA(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);Bb=+h[Ya>>3];kA(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+256>>3];vb=+zd(1.0e-13,+(qb-rb));rb=vb*+zd(1.0e-13,+(qb-Eb));Eb=+h[Za+904>>3];vb=-(Eb*+zd(1.0e-13,+(qb-Lb)));Lb=+h[Za+248>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+nwa(c[ib>>2]|0,rb,35960,35576,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+248>>3];Tb=+h[Ya+256>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+zd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+nwa(c[ib>>2]|0,Vb,35656,35576,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+904>>3]-Pb}Pb=+h[Mb+240>>3];Wb=Pb+-273.15;Cb=+h[Mb+896>>3];sA($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];jA(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);Pb=+h[ab>>3];kA(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);Pb=+h[cb>>3];jA(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);Wb=+h[db>>3];kA(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+240>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+nwa(c[ib>>2]|0,rb,36568,35576,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+240>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+904>>3]-ub);ub=+h[Yb+896>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+nwa(c[ib>>2]|0,Xb,36568,35576,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+896>>3];ac=+h[Yb+240>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+Nxa(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+248>>3];Gb=+zd(1.0e-13,+(+h[Yb+256>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+nwa(c[ib>>2]|0,Gb,35656,35576,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +zd(+(ac- +yd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+240>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+nwa(c[ib>>2]|0,ec,36568,35576,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+240>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+904>>3];ic=+h[gc+896>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+nwa(c[ib>>2]|0,fc,36568,35576,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+896>>3];kc=+h[gc+240>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+Nxa(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+248>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+zd(1.0e-13,+(+h[gc+256>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9424|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9424|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+nwa(c[ib>>2]|0,Nb,35656,35576,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9424|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function aE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4432>>3]=1.0- +h[b+248>>3];i=i;return}function bE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+248>>3];p=f;h[k>>3]=+h[n+4432>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+256>>3];q=+h[p+240>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+3952>>3]=+h[l>>3];i=b;return}function cE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[63880]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=57624;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&127](mb,m,36600,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]}jA(t,c[ib>>2]|0,jb);jb=+h[t>>3];kA(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);jb=+h[v>>3];jA(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);pb=+h[w>>3];kA(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+224>>3];qb=+zd(1.0e-13,+(+h[w+232>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+nwa(c[ib>>2]|0,qb,36672,36592,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(pb- +yd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{jA(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);sb=+h[z>>3];kA(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);sb=+h[B>>3];jA(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);jb=+h[C>>3];kA(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+zd(1.0e-13,+(+h[C+232>>3]- +h[E>>3]));pb=1.0- +h[C+224>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+nwa(c[ib>>2]|0,jb,36672,36592,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{jA(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);vb=+h[F>>3];kA(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);vb=+h[H>>3];jA(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);sb=+h[I>>3];kA(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);sb=+h[K>>3];jA(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);jb=+h[L>>3];kA(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+232>>3]- +h[N>>3])|0)<<24>>24==0){jA(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);jb=+h[O>>3];kA(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Q,c[ib>>2]|0,+h[P+216>>3],+h[P+872>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(R,c[ib>>2]|0,+h[Q+216>>3],+h[Q+872>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(S,c[ib>>2]|0,jb,pb,+h[Q+216>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+872>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+888>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}jA(T,c[ib>>2]|0,+h[xb+216>>3]);qb=+h[T>>3];kA(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);qb=+h[V>>3];jA(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);pb=+h[W>>3];kA(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);pb=+h[Y>>3];jA(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);jb=+h[Z>>3];kA(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA($,c[ib>>2]|0,+h[_+216>>3],+h[_+872>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(aa,c[ib>>2]|0,+h[$+216>>3],+h[$+872>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(ba,c[ib>>2]|0,jb,rb,+h[$+216>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+872>>3],0.0);zb=+h[ba>>3];jA(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);rb=+h[ca>>3];kA(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+232>>3];Ab=+zd(1.0e-13,+(jb-qb));qb=Ab*+zd(1.0e-13,+(jb-pb));pb=+h[ea+880>>3];Ab=-(pb*+zd(1.0e-13,+(jb-sb)));sb=+h[ea+224>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+nwa(c[ib>>2]|0,qb,36976,36592,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+224>>3];Cb=+h[ca+232>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+zd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+nwa(c[ib>>2]|0,Eb,36672,36592,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+880>>3]-wb}wb=+h[tb+216>>3];if(wb>0.0){Gb=wb}else{tb=c[63880]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=57624;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&127](Db,l,36600,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]}if(Gb>0.0){Hb=Gb}else{r=c[63880]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=57624;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&127](l,j,36600,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]}jA(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];kA(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);Hb=+h[ia>>3];jA(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);Fb=+h[ja>>3];kA(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3];if(zb>0.0){Ib=zb}else{la=c[63880]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=57624;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&127](ka,g,36600,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]}if(Ib>0.0){Jb=Ib}else{p=c[63880]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=57624;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&127](g,f,36600,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]}if(Jb>0.0){Kb=Jb}else{o=c[63880]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=57624;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&127](f,e,36600,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]}qb=Kb+-273.15;lA(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];jA(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);qb=+h[na>>3];kA(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);qb=+h[pa>>3];jA(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);Eb=+h[qa>>3];kA(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+224>>3];rb=+zd(1.0e-13,+(+h[qa+232>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+nwa(c[ib>>2]|0,rb,36672,36592,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(Eb- +yd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{jA(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);Lb=+h[ta>>3];kA(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);Lb=+h[va>>3];jA(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);qb=+h[wa>>3];kA(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+zd(1.0e-13,+(+h[wa+232>>3]- +h[ya>>3]));Eb=1.0- +h[wa+224>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+nwa(c[ib>>2]|0,qb,36672,36592,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{jA(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);Ob=+h[za>>3];kA(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);Ob=+h[Ba>>3];jA(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);Lb=+h[Ca>>3];kA(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);Lb=+h[Ea>>3];jA(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);qb=+h[Fa>>3];kA(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+232>>3]- +h[Ha>>3])|0)<<24>>24==0){jA(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);qb=+h[Ia>>3];kA(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Ka,c[ib>>2]|0,+h[Ja+216>>3],+h[Ja+872>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(La,c[ib>>2]|0,+h[Ka+216>>3],+h[Ka+872>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+216>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+872>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+888>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}jA(Na,c[ib>>2]|0,+h[Qb+216>>3]);rb=+h[Na>>3];kA(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);rb=+h[Pa>>3];jA(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);Eb=+h[Qa>>3];kA(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);Eb=+h[Sa>>3];jA(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);qb=+h[Ta>>3];kA(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Va,c[ib>>2]|0,+h[Ua+216>>3],+h[Ua+872>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(Wa,c[ib>>2]|0,+h[Va+216>>3],+h[Va+872>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Xa,c[ib>>2]|0,qb,Bb,+h[Va+216>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+872>>3],0.0);Cb=+h[Xa>>3];jA(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);Bb=+h[Ya>>3];kA(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+232>>3];vb=+zd(1.0e-13,+(qb-rb));rb=vb*+zd(1.0e-13,+(qb-Eb));Eb=+h[Za+880>>3];vb=-(Eb*+zd(1.0e-13,+(qb-Lb)));Lb=+h[Za+224>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+nwa(c[ib>>2]|0,rb,36976,36592,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+224>>3];Tb=+h[Ya+232>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+zd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+nwa(c[ib>>2]|0,Vb,36672,36592,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+880>>3]-Pb}Pb=+h[Mb+216>>3];Wb=Pb+-273.15;Cb=+h[Mb+872>>3];sA($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];jA(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);Pb=+h[ab>>3];kA(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);Pb=+h[cb>>3];jA(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);Wb=+h[db>>3];kA(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+216>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+nwa(c[ib>>2]|0,rb,37584,36592,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+216>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+880>>3]-ub);ub=+h[Yb+872>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+nwa(c[ib>>2]|0,Xb,37584,36592,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+872>>3];ac=+h[Yb+216>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+Nxa(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+224>>3];Gb=+zd(1.0e-13,+(+h[Yb+232>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+nwa(c[ib>>2]|0,Gb,36672,36592,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +zd(+(ac- +yd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+216>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+nwa(c[ib>>2]|0,ec,37584,36592,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+216>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+880>>3];ic=+h[gc+872>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+nwa(c[ib>>2]|0,fc,37584,36592,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+872>>3];kc=+h[gc+216>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+Nxa(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+224>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+zd(1.0e-13,+(+h[gc+232>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9440|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9440|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+nwa(c[ib>>2]|0,Nb,36672,36592,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9440|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function dE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4424>>3]=1.0- +h[b+224>>3];i=i;return}function eE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+224>>3];p=f;h[k>>3]=+h[n+4424>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+232>>3];q=+h[p+216>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+3856>>3]=+h[l>>3];i=b;return}function fE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[63880]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=57624;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&127](mb,m,37616,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]}jA(t,c[ib>>2]|0,jb);jb=+h[t>>3];kA(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);jb=+h[v>>3];jA(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);pb=+h[w>>3];kA(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+200>>3];qb=+zd(1.0e-13,+(+h[w+208>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+nwa(c[ib>>2]|0,qb,37688,37608,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(pb- +yd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{jA(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);sb=+h[z>>3];kA(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);sb=+h[B>>3];jA(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);jb=+h[C>>3];kA(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+zd(1.0e-13,+(+h[C+208>>3]- +h[E>>3]));pb=1.0- +h[C+200>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+nwa(c[ib>>2]|0,jb,37688,37608,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{jA(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);vb=+h[F>>3];kA(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);vb=+h[H>>3];jA(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);sb=+h[I>>3];kA(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);sb=+h[K>>3];jA(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);jb=+h[L>>3];kA(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+208>>3]- +h[N>>3])|0)<<24>>24==0){jA(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);jb=+h[O>>3];kA(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Q,c[ib>>2]|0,+h[P+192>>3],+h[P+848>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(R,c[ib>>2]|0,+h[Q+192>>3],+h[Q+848>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(S,c[ib>>2]|0,jb,pb,+h[Q+192>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+848>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+864>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}jA(T,c[ib>>2]|0,+h[xb+192>>3]);qb=+h[T>>3];kA(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);qb=+h[V>>3];jA(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);pb=+h[W>>3];kA(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);pb=+h[Y>>3];jA(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);jb=+h[Z>>3];kA(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA($,c[ib>>2]|0,+h[_+192>>3],+h[_+848>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(aa,c[ib>>2]|0,+h[$+192>>3],+h[$+848>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(ba,c[ib>>2]|0,jb,rb,+h[$+192>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+848>>3],0.0);zb=+h[ba>>3];jA(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);rb=+h[ca>>3];kA(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+208>>3];Ab=+zd(1.0e-13,+(jb-qb));qb=Ab*+zd(1.0e-13,+(jb-pb));pb=+h[ea+856>>3];Ab=-(pb*+zd(1.0e-13,+(jb-sb)));sb=+h[ea+200>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+nwa(c[ib>>2]|0,qb,37992,37608,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+200>>3];Cb=+h[ca+208>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+zd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+nwa(c[ib>>2]|0,Eb,37688,37608,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+856>>3]-wb}wb=+h[tb+192>>3];if(wb>0.0){Gb=wb}else{tb=c[63880]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=57624;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&127](Db,l,37616,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]}if(Gb>0.0){Hb=Gb}else{r=c[63880]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=57624;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&127](l,j,37616,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]}jA(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];kA(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);Hb=+h[ia>>3];jA(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);Fb=+h[ja>>3];kA(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3];if(zb>0.0){Ib=zb}else{la=c[63880]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=57624;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&127](ka,g,37616,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]}if(Ib>0.0){Jb=Ib}else{p=c[63880]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=57624;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&127](g,f,37616,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]}if(Jb>0.0){Kb=Jb}else{o=c[63880]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=57624;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&127](f,e,37616,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]}qb=Kb+-273.15;lA(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];jA(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);qb=+h[na>>3];kA(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);qb=+h[pa>>3];jA(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);Eb=+h[qa>>3];kA(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+200>>3];rb=+zd(1.0e-13,+(+h[qa+208>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+nwa(c[ib>>2]|0,rb,37688,37608,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(Eb- +yd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{jA(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);Lb=+h[ta>>3];kA(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);Lb=+h[va>>3];jA(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);qb=+h[wa>>3];kA(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+zd(1.0e-13,+(+h[wa+208>>3]- +h[ya>>3]));Eb=1.0- +h[wa+200>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+nwa(c[ib>>2]|0,qb,37688,37608,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{jA(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);Ob=+h[za>>3];kA(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);Ob=+h[Ba>>3];jA(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);Lb=+h[Ca>>3];kA(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);Lb=+h[Ea>>3];jA(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);qb=+h[Fa>>3];kA(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+208>>3]- +h[Ha>>3])|0)<<24>>24==0){jA(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);qb=+h[Ia>>3];kA(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Ka,c[ib>>2]|0,+h[Ja+192>>3],+h[Ja+848>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(La,c[ib>>2]|0,+h[Ka+192>>3],+h[Ka+848>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+192>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+848>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+864>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}jA(Na,c[ib>>2]|0,+h[Qb+192>>3]);rb=+h[Na>>3];kA(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);rb=+h[Pa>>3];jA(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);Eb=+h[Qa>>3];kA(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);Eb=+h[Sa>>3];jA(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);qb=+h[Ta>>3];kA(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Va,c[ib>>2]|0,+h[Ua+192>>3],+h[Ua+848>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(Wa,c[ib>>2]|0,+h[Va+192>>3],+h[Va+848>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Xa,c[ib>>2]|0,qb,Bb,+h[Va+192>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+848>>3],0.0);Cb=+h[Xa>>3];jA(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);Bb=+h[Ya>>3];kA(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+208>>3];vb=+zd(1.0e-13,+(qb-rb));rb=vb*+zd(1.0e-13,+(qb-Eb));Eb=+h[Za+856>>3];vb=-(Eb*+zd(1.0e-13,+(qb-Lb)));Lb=+h[Za+200>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+nwa(c[ib>>2]|0,rb,37992,37608,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+200>>3];Tb=+h[Ya+208>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+zd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+nwa(c[ib>>2]|0,Vb,37688,37608,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+856>>3]-Pb}Pb=+h[Mb+192>>3];Wb=Pb+-273.15;Cb=+h[Mb+848>>3];sA($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];jA(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);Pb=+h[ab>>3];kA(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);Pb=+h[cb>>3];jA(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);Wb=+h[db>>3];kA(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+192>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+nwa(c[ib>>2]|0,rb,38600,37608,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+192>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+856>>3]-ub);ub=+h[Yb+848>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+nwa(c[ib>>2]|0,Xb,38600,37608,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+848>>3];ac=+h[Yb+192>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+Nxa(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+200>>3];Gb=+zd(1.0e-13,+(+h[Yb+208>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+nwa(c[ib>>2]|0,Gb,37688,37608,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +zd(+(ac- +yd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+192>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+nwa(c[ib>>2]|0,ec,38600,37608,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+192>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+856>>3];ic=+h[gc+848>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+nwa(c[ib>>2]|0,fc,38600,37608,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+848>>3];kc=+h[gc+192>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+Nxa(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+200>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+zd(1.0e-13,+(+h[gc+208>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9456|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9456|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+nwa(c[ib>>2]|0,Nb,37688,37608,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9456|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function gE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;iA(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+192>>3]);if((Aza(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+208>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+864>>3]*.999;l=j;m=l+9056|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;xA(e,c[f>>2]|0,+h[d+192>>3],+h[d+848>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+9056|0;n=m;h[n>>3]=k;i=b;return}}function hE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;iA(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+96>>3]);if((Aza(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+112>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+768>>3]*.999;l=j;m=l+9144|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;xA(e,c[f>>2]|0,+h[d+96>>3],+h[d+752>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+9144|0;n=m;h[n>>3]=k;i=b;return}}



function wAa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0.0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=+h[d>>3];do{if(H>=+h[b+248>>3]){if((c[d+24>>2]|0)==5){break}I=G;h[k>>3]=H;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];hwa(8,0,241960,G);I=b+313|0;a[I]=1;hza(b);if((c[263300>>2]|0)==0){me[c[247924>>2]&127](247904,b)}a[I]=0}}while(0);if((e|0)!=0){xAa(Gd(e|0)|0,b)}if((c[206244>>2]|0)==0){i=f;return 0}Exa(0);hwa(25,0,242008,F);hwa(25,1,242032,E);H=+wxa(6);J=+wxa(6);K=J/+wxa(0)*100.0;E=D;h[k>>3]=H;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D+8|0;h[k>>3]=K;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];hwa(25,0,242040,D);K=+wxa(1);H=+wxa(1);J=H/+wxa(0)*100.0;D=C;h[k>>3]=K;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];D=C+8|0;h[k>>3]=J;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];hwa(25,0,242080,C);J=+wxa(2);K=+wxa(2);H=K/+wxa(0)*100.0;C=B;h[k>>3]=J;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=B+8|0;h[k>>3]=H;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];hwa(25,0,242112,B);H=+wxa(3);J=+wxa(3);K=J/+wxa(0)*100.0;B=A;h[k>>3]=H;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=K;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];hwa(25,0,242136,A);K=+wxa(4);H=+wxa(4);J=H/+wxa(0)*100.0;A=z;h[k>>3]=K;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=J;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];hwa(25,0,242176,z);J=+wxa(7);K=+wxa(7);H=K/+wxa(0)*100.0;z=y;h[k>>3]=J;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+8|0;h[k>>3]=H;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];hwa(25,0,242208,y);y=d+24|0;z=(c[y>>2]|0)==5;H=+wxa(0);J=H- +wxa(7);H=J- +wxa(4);J=H- +wxa(3);H=J- +wxa(2);J=H- +wxa(1);H=J- +wxa(6);J=+wxa(0);K=J- +wxa(7);J=K- +wxa(4);K=J- +wxa(3);J=K- +wxa(2);K=J- +wxa(1);J=K- +wxa(6);K=J/+wxa(0)*100.0;if(z){z=w;h[k>>3]=H;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=w+8|0;h[k>>3]=K;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];hwa(25,0,242272,w)}else{w=x;h[k>>3]=H;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=x+8|0;h[k>>3]=K;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];hwa(25,0,242240,x)}K=+wxa(0);H=+wxa(0);J=H/+wxa(0)*100.0;x=v;h[k>>3]=K;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];x=v+8|0;h[k>>3]=J;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];hwa(25,0,242304,v);le[c[51674]&2047](25);hwa(25,1,242328,u);c[t>>2]=c[d+40>>2];hwa(25,0,242336,t);c[s>>2]=c[d+44>>2];hwa(25,0,242360,s);le[c[51674]&2047](25);s=c[y>>2]|0;if((s|0)==3){y=d+48|0;d=c[y>>2]|0;t=c[d+8>>2]|0;u=c[d+4>>2]|0;c[u>>2]=(c[u>>2]|0)+(c[t>>2]|0);d=u+4|0;c[d>>2]=(c[d>>2]|0)+(c[t+4>>2]|0);d=u+8|0;c[d>>2]=(c[d>>2]|0)+(c[t+8>>2]|0);d=u+12|0;c[d>>2]=(c[d>>2]|0)+(c[t+12>>2]|0);d=u+16|0;c[d>>2]=(c[d>>2]|0)+(c[t+16>>2]|0);hwa(25,1,242384,r);c[q>>2]=c[c[(c[y>>2]|0)+4>>2]>>2];hwa(25,0,242400,q);c[p>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+4>>2];hwa(25,0,242416,p);c[o>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+8>>2];hwa(25,0,242448,o);c[n>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+12>>2];hwa(25,0,242480,n);c[m>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+16>>2];hwa(25,0,242504,m);le[c[51674]&2047](25)}else if((s|0)!=5){hwa(25,1,242536,l);hwa(25,0,242544,j);le[c[51674]&2047](25)}hwa(25,0,242608,g);Bxa(0);i=f;return 0}function xAa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+16|0;y=i;i=i+8|0;z=$b(b|0,243080)|0;b=c[t>>2]|0;A=d+4|0;B=y;h[k>>3]=+h[c[c[A>>2]>>2]>>3];c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];Cd(b|0,243088,y|0)|0;if((z|0)==0){C=Yd(10,b|0)|0;D=Ad(b|0)|0;i=e;return}y=d+116|0;B=d+124|0;E=d+128|0;F=d+132|0;G=d+216|0;H=d+220|0;I=d+224|0;J=d+228|0;K=d+136|0;L=d+140|0;M=d+144|0;N=d+148|0;O=d+36|0;P=d+428|0;Q=d+32|0;R=d+424|0;S=d+28|0;T=d+420|0;U=d+24|0;V=d+416|0;W=d+52|0;X=d+48|0;Y=d+44|0;Z=d+40|0;_=d+20|0;$=d+16|0;aa=d+12|0;ba=d+8|0;d=z;do{z=c[y>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((t$a(d,c[(c[ba>>2]|0)+(z*112|0)+4>>2]|0)|0)==0){da=+h[(c[(c[c[A>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];c[x>>2]=d;ea=x+4|0;h[k>>3]=da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];Cd(b|0,243104,x|0)|0;fa=c[y>>2]|0}else{fa=ca}ea=z+1|0;if((ea|0)<(fa|0)){ca=fa;z=ea}else{break}}}z=c[B>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((t$a(d,c[(c[aa>>2]|0)+(z*60|0)+4>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(z<<2)>>2]|0;c[w>>2]=d;c[w+4>>2]=ea;Cd(b|0,243120,w|0)|0;ga=c[B>>2]|0}else{ga=ca}ea=z+1|0;if((ea|0)<(ga|0)){ca=ga;z=ea}else{break}}}z=c[E>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((t$a(d,c[(c[$>>2]|0)+(z*48|0)+4>>2]|0)|0)==0){ea=a[(c[(c[c[A>>2]>>2]|0)+16>>2]|0)+z|0]|0;c[v>>2]=d;c[v+4>>2]=ea;Cd(b|0,243128,v|0)|0;ha=c[E>>2]|0}else{ha=ca}ea=z+1|0;if((ea|0)<(ha|0)){ca=ha;z=ea}else{break}}}z=c[F>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((t$a(d,c[(c[_>>2]|0)+(z*52|0)+4>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+20>>2]|0)+(z<<2)>>2]|0;c[u>>2]=d;c[u+4>>2]=ea;Cd(b|0,243136,u|0)|0;ia=c[F>>2]|0}else{ia=ca}ea=z+1|0;if((ea|0)<(ia|0)){ca=ia;z=ea}else{break}}}if((c[G>>2]|0)>0){z=0;do{ca=c[Z>>2]|0;do{if((t$a(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){da=+h[(c[(c[c[A>>2]>>2]|0)+8>>2]|0)+(c[ca+(z*52|0)+4>>2]<<3)>>3];if((c[ca+(z*52|0)>>2]|0)==0){c[r>>2]=d;ea=r+4|0;h[k>>3]=da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];Cd(b|0,243104,r|0)|0;break}else{c[s>>2]=d;ea=s+4|0;h[k>>3]=-da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];Cd(b|0,243104,s|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[G>>2]|0))}if((c[H>>2]|0)>0){z=0;do{ca=c[Y>>2]|0;do{if((t$a(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(c[ca+(z*52|0)+4>>2]<<2)>>2]|0;if((c[ca+(z*52|0)>>2]|0)==0){c[p>>2]=d;c[p+4>>2]=ea;Cd(b|0,243120,p|0)|0;break}else{c[q>>2]=d;c[q+4>>2]=0-ea;Cd(b|0,243120,q|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[H>>2]|0))}if((c[I>>2]|0)>0){z=0;do{ca=c[X>>2]|0;do{if((t$a(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){ea=a[(c[(c[c[A>>2]>>2]|0)+16>>2]|0)+(c[ca+(z*52|0)+4>>2]|0)|0]|0;if((c[ca+(z*52|0)>>2]|0)==0){c[n>>2]=d;c[n+4>>2]=ea;Cd(b|0,243128,n|0)|0;break}else{c[o>>2]=d;c[o+4>>2]=0-ea;Cd(b|0,243128,o|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[I>>2]|0))}z=c[J>>2]|0;if((z|0)>0){ca=z;z=0;while(1){ea=c[W>>2]|0;if((t$a(d,c[ea+(z*52|0)+16>>2]|0)|0)==0){ja=c[(c[(c[c[A>>2]>>2]|0)+20>>2]|0)+(c[ea+(z*52|0)+4>>2]<<2)>>2]|0;c[m>>2]=d;c[m+4>>2]=ja;Cd(b|0,243136,m|0)|0;ka=c[J>>2]|0}else{ka=ca}ja=z+1|0;if((ja|0)<(ka|0)){ca=ka;z=ja}else{break}}}z=c[K>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((t$a(d,c[(c[U>>2]|0)+(z*112|0)+4>>2]|0)|0)==0){da=+h[(c[V>>2]|0)+(z<<3)>>3];c[l>>2]=d;ja=l+4|0;h[k>>3]=da;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];Cd(b|0,243104,l|0)|0;la=c[K>>2]|0}else{la=ca}ja=z+1|0;if((ja|0)<(la|0)){ca=la;z=ja}else{break}}}z=c[L>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((t$a(d,c[(c[S>>2]|0)+(z*60|0)+4>>2]|0)|0)==0){ja=c[(c[T>>2]|0)+(z<<2)>>2]|0;c[j>>2]=d;c[j+4>>2]=ja;Cd(b|0,243120,j|0)|0;ma=c[L>>2]|0}else{ma=ca}ja=z+1|0;if((ja|0)<(ma|0)){ca=ma;z=ja}else{break}}}z=c[M>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((t$a(d,c[(c[Q>>2]|0)+(z*48|0)+4>>2]|0)|0)==0){ja=a[(c[R>>2]|0)+z|0]|0;c[g>>2]=d;c[g+4>>2]=ja;Cd(b|0,243128,g|0)|0;na=c[M>>2]|0}else{na=ca}ja=z+1|0;if((ja|0)<(na|0)){ca=na;z=ja}else{break}}}z=c[N>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((t$a(d,c[(c[O>>2]|0)+(z*52|0)+4>>2]|0)|0)==0){ja=c[(c[P>>2]|0)+(z<<2)>>2]|0;c[f>>2]=d;c[f+4>>2]=ja;Cd(b|0,243136,f|0)|0;oa=c[N>>2]|0}else{oa=ca}ja=z+1|0;if((ja|0)<(oa|0)){ca=oa;z=ja}else{break}}}d=$b(0,243080)|0;}while((d|0)!=0);C=Yd(10,b|0)|0;D=Ad(b|0)|0;i=e;return}function yAa(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0;m=i;i=i+16|0;n=m;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+56|0;t=s;u=s+24|0;c[u>>2]=j;a:do{switch(j|0){case 17:case 16:case 15:case 14:case 13:case 12:{c[u>>2]=3;break};case 11:case 10:case 9:case 6:case 7:case 8:{jwa(1,0,242632,r);v=1;i=m;return v|0};case 18:{w=c[4402]|0;do{if((w|0)!=0){if((t$a(w,242888)|0)!=0){break}c[u>>2]=4;break a}}while(0);hwa(23,0,242912,o);v=1;i=m;return v|0};case 4:{w=c[4402]|0;if((w|0)!=0){if((t$a(w,242744)|0)==0){break a}}hwa(23,0,242760,p);v=1;i=m;return v|0};case 5:{jwa(1,0,242704,q);v=1;i=m;return v|0};default:{}}}while(0);q=tAa(a,s)|0;Ie[c[207044>>2]&7]()|0;do{if((q|0)==0){p=vAa(a,b,d,e,f,g)|0;Ie[c[207044>>2]&7]()|0;if((p|0)!=0){x=p;break}if((c[u>>2]|0)!=5){me[c[247924>>2]&127](247904,a);rza(a)}y=+h[a+248>>3];p=n;h[k>>3]=+h[a+240>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n+8|0;h[k>>3]=y;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];hwa(23,0,243040,n);p=De[c[c[a+540>>2]>>2]&63](a,t)|0;Ie[c[207044>>2]&7]()|0;wAa(a,s,l)|0;Ie[c[207044>>2]&7]()|0;x=p}else{Ie[c[207044>>2]&7]()|0;x=q}}while(0);uAa(a,s)|0;v=x;i=m;return v|0}function zAa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=a+204|0;if((c[e>>2]|0)<=0){AAa(a);i=b;return}f=a+488|0;g=a;h=0;while(1){j=h+1|0;if((oe[c[(c[f>>2]|0)+(h*48|0)+40>>2]&127](g)|0)!=0){k=5;break}if((j|0)<(c[e>>2]|0)){h=j}else{k=6;break}}if((k|0)==5){lwa(c[a+536>>2]|0,243152,d)}else if((k|0)==6){AAa(a);i=b;return}}function AAa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;d=a+204|0;if((c[d>>2]|0)<=0){i=b;return}e=a+488|0;f=a+12|0;g=a+4|0;a=0;do{h=c[e>>2]|0;j=(c[c[h+(a*48|0)+12>>2]>>2]|0)-(c[c[f>>2]>>2]|0)|0;k=c[(c[c[g>>2]>>2]|0)+12>>2]|0;l=h+(a*48|0)|0;m=h+(a*48|0)+4|0;B$a(k+(j<<2)|0,0,fa(c[l>>2]<<2,c[m>>2]|0)|0)|0;n=h+(a*48|0)+8|0;if((c[n>>2]|0)>0){o=c[h+(a*48|0)+16>>2]|0;p=0;do{c[o+(p<<2)>>2]=p;p=p+1|0;}while((p|0)<(c[n>>2]|0))}n=c[l>>2]|0;if((n|0)>0){p=c[h+(a*48|0)+20>>2]|0;o=n;n=0;do{c[p+(n<<2)>>2]=o+~n;n=n+1|0;o=c[l>>2]|0;}while((n|0)<(o|0))}o=c[m>>2]|0;if((o|0)>0){n=o;o=0;do{c[k+(o+j+(fa(n,o)|0)<<2)>>2]=1;o=o+1|0;n=c[m>>2]|0;}while((o|0)<(n|0))}a=a+1|0;}while((a|0)<(c[d>>2]|0));i=b;return}function BAa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+204|0;if((c[d>>2]|0)<=0){i=b;return}e=a+488|0;a=0;do{f=c[e>>2]|0;W_a(c[f+(a*48|0)+28>>2]|0);W_a(c[f+(a*48|0)+32>>2]|0);W_a(c[f+(a*48|0)+16>>2]|0);W_a(c[f+(a*48|0)+20>>2]|0);W_a(c[f+(a*48|0)+24>>2]|0);a=a+1|0;}while((a|0)<(c[d>>2]|0));i=b;return}function CAa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+4096|0;p=b+204|0;if((c[p>>2]|0)<=0){q=0;i=f;return q|0}r=b+488|0;s=d<<24>>24==0;d=(e|0)==0;t=0;u=0;while(1){v=c[r>>2]|0;w=v+(u*48|0)|0;x=V_a(c[w>>2]<<2)|0;y=v+(u*48|0)+8|0;z=V_a(c[y>>2]<<2)|0;DAa(b,u);A=v+(u*48|0)+20|0;B=c[A>>2]|0;C=c[w>>2]|0;z$a(x|0,B|0,C<<2|0)|0;D=v+(u*48|0)+16|0;E=c[D>>2]|0;F=c[y>>2]|0;z$a(z|0,E|0,F<<2|0)|0;G=v+(u*48|0)+24|0;if(!((Iya(c[G>>2]|0,F,C,E,B)|0)==0|s)){break}B=EAa(x,c[A>>2]|0,c[w>>2]|0,c[y>>2]|0,c[v+(u*48|0)+4>>2]|0,c[v+(u*48|0)+12>>2]|0,c[v+(u*48|0)+28>>2]|0,c[v+(u*48|0)+32>>2]|0,b,e)|0;if(d){z$a(c[A>>2]|0,x|0,c[w>>2]<<2|0)|0;z$a(c[D>>2]|0,z|0,c[y>>2]<<2|0)|0}y=(B|0)==0?t:1;W_a(x);W_a(z);z=u+1|0;if((z|0)<(c[p>>2]|0)){t=y;u=z}else{q=y;H=15;break}}if((H|0)==15){i=f;return q|0}q=o;o=v+(u*48|0)+44|0;f=c[o>>2]|0;H=b+464|0;t=c[H>>2]|0;p=c[t+(f*44|0)>>2]|0;c[n>>2]=c[t+(f*44|0)+4>>2];c[n+4>>2]=p;c[n+8>>2]=f;jwa(5,1,243208,n);n=c[H>>2]|0;if((c[n+((c[o>>2]|0)*44|0)+4>>2]|0)!=0){f=n;n=0;do{a[q]=0;p=c[f+((c[o>>2]|0)*44|0)>>2]|0;if((p|0)!=0){t=p;p=0;do{d=(fa(t,n)|0)+p|0;I=+h[(c[G>>2]|0)+(d<<3)>>3];c[m>>2]=q;d=m+4|0;h[k>>3]=I;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];lc(q|0,243240,m|0)|0;p=p+1|0;t=c[(c[H>>2]|0)+((c[o>>2]|0)*44|0)>>2]|0;}while(p>>>0<t>>>0)}c[l>>2]=q;jwa(5,0,243248,l);n=n+1|0;f=c[H>>2]|0;}while(n>>>0<(c[f+((c[o>>2]|0)*44|0)+4>>2]|0)>>>0)}if((c[w>>2]|0)<=0){J=206696;K=c[51674]|0;le[K&2047](5);L=b;M=L+536|0;N=M;O=c[N>>2]|0;P=b;Q=P+4|0;R=Q;S=c[R>>2]|0;T=c[S>>2]|0;U=T;V=U;W=+h[V>>3];X=g;Y=X;h[k>>3]=W;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Z=5;_=Z;$=243256;aa=$;lwa(O,aa,g)}o=v+(u*48|0)+32|0;u=0;do{c[j>>2]=c[(c[(c[o>>2]|0)+(u<<2)>>2]|0)+4>>2];jwa(5,0,243248,j);u=u+1|0;}while((u|0)<(c[w>>2]|0));J=206696;K=c[51674]|0;le[K&2047](5);L=b;M=L+536|0;N=M;O=c[N>>2]|0;P=b;Q=P+4|0;R=Q;S=c[R>>2]|0;T=c[S>>2]|0;U=T;V=U;W=+h[V>>3];X=g;Y=X;h[k>>3]=W;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Z=5;_=Z;$=243256;aa=$;lwa(O,aa,g);return 0}function DAa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;e=a+488|0;f=c[e>>2]|0;g=c[f+(b*48|0)+44>>2]|0;j=a+464|0;k=c[j>>2]|0;l=c[f+(b*48|0)+24>>2]|0;B$a(l|0,0,fa(c[k+(g*44|0)+4>>2]<<3,c[k+(g*44|0)>>2]|0)|0)|0;k=c[j>>2]|0;if((c[k+(g*44|0)+24>>2]|0)==0){i=d;return}f=a;a=c[k+(g*44|0)>>2]|0;m=k;k=0;do{if((a|0)!=0){n=0;do{if(((c[(c[m+(g*44|0)+20>>2]|0)+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[m+(g*44|0)+28>>2]|0)+(n<<3)>>3]=1.0}n=n+1|0;}while(n>>>0<a>>>0)}oe[c[(c[e>>2]|0)+(b*48|0)+36>>2]&127](f)|0;m=c[j>>2]|0;a=c[m+(g*44|0)>>2]|0;do{if((a|0)!=0){n=c[m+(g*44|0)+28>>2]|0;o=0;do{do{if(+h[n+(o<<3)>>3]==1.0){if((o|0)==0){p=m+(g*44|0)+8|0;q=0}else{r=m+(g*44|0)+8|0;p=r;q=c[(c[r>>2]|0)+(o+ -1<<2)>>2]|0}r=c[(c[p>>2]|0)+(o<<2)>>2]|0;if(!(q>>>0<r>>>0)){break}s=c[m+(g*44|0)+12>>2]|0;t=c[m+(g*44|0)+4>>2]|0;u=c[m+(g*44|0)+36>>2]|0;v=q;do{w=c[s+(v<<2)>>2]|0;x=(fa(t,o)|0)+w|0;h[l+(x<<3)>>3]=+h[u+(w<<3)>>3];v=v+1|0;}while(v>>>0<r>>>0)}}while(0);o=o+1|0;}while(o>>>0<a>>>0);if((a|0)==0){break}o=c[m+(g*44|0)+20>>2]|0;n=0;do{if(((c[o+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[m+(g*44|0)+28>>2]|0)+(n<<3)>>3]=0.0}n=n+1|0;}while(n>>>0<a>>>0)}}while(0);k=k+1|0;}while(k>>>0<(c[m+(g*44|0)+24>>2]|0)>>>0);i=d;return}function EAa(a,b,d,e,f,g,j,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;o=i;i=i+8|0;p=o;q=X_a(d,4)|0;r=X_a(d,4)|0;s=r;t=(d|0)>0;if(t){u=0}else{v=0;W_a(q);W_a(r);i=o;return v|0}do{w=(u|0)<(e|0)?1:2;c[r+(c[b+(u<<2)>>2]<<2)>>2]=w;c[q+(c[a+(u<<2)>>2]<<2)>>2]=w;u=u+1|0;}while((u|0)<(d|0));if(t){x=0}else{v=0;W_a(q);W_a(r);i=o;return v|0}while(1){t=x+1|0;if((c[r+(x<<2)>>2]|0)!=(c[q+(x<<2)>>2]|0)){break}if((t|0)<(d|0)){x=t}else{v=0;y=9;break}}if((y|0)==9){W_a(q);W_a(r);i=o;return v|0}if((n|0)==0){v=-1;W_a(q);W_a(r);i=o;return v|0}n=p;h[k>>3]=+h[c[c[m+4>>2]>>2]>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];hwa(5,1,243360,p);FAa(s,d,f,c[g>>2]|0,j,l,m);if((c[206164>>2]|0)==0){v=-1;W_a(q);W_a(r);i=o;return v|0}le[c[51674]&2047](5);v=-1;W_a(q);W_a(r);i=o;return v|0}function FAa(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;k=i;i=i+8|0;l=k;m=e-(c[c[j+12>>2]>>2]|0)|0;e=j+4|0;n=c[(c[c[e>>2]>>2]|0)+12>>2]|0;B$a(n+(m<<2)|0,0,fa(b<<2,d)|0)|0;if((b|0)<=0){i=k;return}o=j+8|0;j=0;p=0;while(1){if((c[a+(j<<2)>>2]|0)==2){q=c[c[o>>2]>>2]|0;r=c[g+(j<<2)>>2]|0;s=(c[r>>2]|0)-q|0;t=(c[c[f+(p<<2)>>2]>>2]|0)-q|0;c[l>>2]=c[r+4>>2];hwa(5,0,243392,l);c[n+(p+m+(fa(j,d)|0)<<2)>>2]=1;r=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[r+(t<<3)>>3]=+h[r+(s<<3)>>3];u=p+1|0}else{u=p}s=j+1|0;if((s|0)<(b|0)){j=s;p=u}else{break}}i=k;return}function GAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0;d=i;i=i+16|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=mc(243408,243432)|0;o=(n|0)!=0;a[b+440|0]=o&1;if(o){p=0}else{i=d;return 0}a:while(1){while(1){o=Xd(n|0)|0;if((o|0)==-1){break a}else if((o|0)==10){break}}p=p+1|0}o=p+ -1|0;p=b+456|0;c[p>>2]=o;c[b+452>>2]=o;rb(n|0);do{}while((Xd(n|0)|0)!=10);q=c[b+152>>2]|0;r=X_a(o,4)|0;o=b+444|0;c[o>>2]=r;s=c[p>>2]|0;t=(s|0)>0;b:do{if(t){u=r;v=0;while(1){c[u+(v<<2)>>2]=X_a(q,8)|0;w=v+1|0;if((w|0)>=(s|0)){break}u=c[o>>2]|0;v=w}v=X_a(s,8)|0;u=b+448|0;c[u>>2]=v;if(!t){x=u;break}w=(q|0)>0;y=v;v=0;while(1){c[m>>2]=y+(v<<3);z=Za(n|0,243440,m|0)|0;if(w){A=0;while(1){c[l>>2]=(c[(c[o>>2]|0)+(v<<2)>>2]|0)+(A<<3);B=Za(n|0,243440,l|0)|0;C=A+1|0;if((C|0)<(q|0)){A=C}else{D=B;break}}}else{D=z}if((D|0)<0){c[p>>2]=v;E=v}else{E=c[p>>2]|0}A=v+1|0;if((A|0)>=(E|0)){x=u;break b}y=c[u>>2]|0;v=A}}else{v=b+448|0;c[v>>2]=X_a(s,8)|0;x=v}}while(0);kc(243448,j|0)|0;kc(243504,g|0)|0;if((c[p>>2]|0)>0){g=(q|0)>0;j=0;do{s=f;h[k>>3]=+h[(c[x>>2]|0)+(j<<3)>>3];c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];kc(243464,f|0)|0;if(g){s=0;while(1){E=s+1|0;F=+h[(c[(c[o>>2]|0)+(j<<2)>>2]|0)+(s<<3)>>3];c[e>>2]=E;D=e+4|0;h[k>>3]=F;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];kc(243488,e|0)|0;if((E|0)<(q|0)){s=E}else{break}}}j=j+1|0;}while((j|0)<(c[p>>2]|0))}wb(243504)|0;ad(n|0)|0;c[b+460>>2]=0;i=d;return 0}function HAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;if((a[b+440|0]|0)==0){i=d;return 0}W_a(c[b+448>>2]|0);e=b+452|0;f=b+444|0;b=c[f>>2]|0;if((c[e>>2]|0)>0){g=b;h=0;while(1){W_a(c[g+(h<<2)>>2]|0);j=h+1|0;k=c[f>>2]|0;if((j|0)<(c[e>>2]|0)){h=j;g=k}else{l=k;break}}}else{l=b}W_a(l);i=d;return 0}function IAa(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0;d=i;if((a[b+440|0]|0)==0){e=-1;i=d;return e|0}f=+h[c[c[b+4>>2]>>2]>>3];g=b+460|0;j=c[g>>2]|0;k=c[b+448>>2]|0;l=+h[k+(j<<3)>>3];if(f==l){m=c[b+152>>2]|0;if((m|0)<=0){e=1;i=d;return e|0}n=c[(c[b+444>>2]|0)+(j<<2)>>2]|0;o=c[b+432>>2]|0;p=0;while(1){h[o+(p<<3)>>3]=+h[n+(p<<3)>>3];q=p+1|0;if((q|0)<(m|0)){p=q}else{e=1;break}}i=d;return e|0}p=j+1|0;r=+h[k+(p<<3)>>3];if(f==r){m=c[b+152>>2]|0;if((m|0)<=0){e=1;i=d;return e|0}n=c[(c[b+444>>2]|0)+(j<<2)>>2]|0;o=c[b+432>>2]|0;q=0;while(1){s=q+1|0;h[o+(q<<3)>>3]=+h[n+(s<<3)>>3];if((s|0)<(m|0)){q=s}else{e=1;break}}i=d;return e|0}a:do{if(f>r){q=(c[b+456>>2]|0)+ -1|0;m=j;n=p;while(1){if((n|0)>=(q|0)){t=m;break a}c[g>>2]=n;o=n+1|0;if(f>+h[k+(o<<3)>>3]){s=n;n=o;m=s}else{t=n;break}}}else{t=j}}while(0);j=t+1|0;r=+h[k+(j<<3)>>3]- +h[k+(t<<3)>>3];k=c[b+152>>2]|0;if((k|0)<=0){e=0;i=d;return e|0}g=c[b+444>>2]|0;p=c[g+(t<<2)>>2]|0;t=c[g+(j<<2)>>2]|0;u=l+r;j=b+432|0;v=u-f;w=f-l;b=0;while(1){x=+h[p+(b<<3)>>3];y=+h[t+(b<<3)>>3];do{if(x!=y){if(x>0.0){z=1}else{z=(x<0.0)<<31>>31}if(y>0.0){A=1}else{A=(y<0.0)<<31>>31}if((z|0)==(A|0)){h[(c[j>>2]|0)+(b<<3)>>3]=(u*x+f*y-(f*x+l*y))/r;break}else{h[(c[j>>2]|0)+(b<<3)>>3]=(v*x+w*y)/r;break}}else{h[(c[j>>2]|0)+(b<<3)>>3]=x}}while(0);g=b+1|0;if((g|0)<(k|0)){b=g}else{e=0;break}}i=d;return e|0}function JAa(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;d=b;e=i;i=i+8|0;f=+KAa(a,1.0);if(!(f>1.0e-5)){g=0;i=b;return g|0}if((c[206180>>2]|0)==0){g=1;i=b;return g|0}j=e;h[k>>3]=f;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];hwa(9,1,243568,e);e=a+16|0;j=c[e>>2]|0;if((j|0)>0){l=a+48|0;a=j;j=0;while(1){f=+h[(c[l>>2]|0)+(j<<3)>>3];m=j+1|0;if(+U(+f)>1.0e-5){c[d>>2]=m;n=d+4|0;h[k>>3]=f;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];hwa(9,0,243680,d);o=c[e>>2]|0}else{o=a}if((m|0)<(o|0)){a=o;j=m}else{break}}}le[c[51674]&2047](9);g=1;i=b;return g|0}function KAa(b,d){b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0,z=0.0,A=0.0,B=0,C=0.0,D=0,E=0,F=0.0,G=0.0,H=0,I=0.0,J=0,K=0,L=0.0;e=i;f=c[b+60>>2]|0;ZAa(b);g=f+540|0;oe[c[(c[g>>2]|0)+84>>2]&127](f)|0;oe[c[(c[g>>2]|0)+36>>2]&127](f)|0;oe[c[(c[g>>2]|0)+32>>2]&127](f)|0;j=b+48|0;De[c[(c[g>>2]|0)+68>>2]&63](f,c[j>>2]|0)|0;g=f+8|0;k=c[f+184>>2]|0;if((k|0)>0){l=c[b+52>>2]|0;m=(l|0)==0;n=c[j>>2]|0;o=0.0;j=0;while(1){if(m){p=1.0}else{p=+h[l+(j<<3)>>3]}q=+h[n+(j<<3)>>3]/p;r=o+q*q;s=j+1|0;if((s|0)<(k|0)){o=r;j=s}else{t=r;break}}}else{t=0.0}if(!(d<1.0)){u=t;i=e;return+u}o=t*d;j=c[f+116>>2]|0;if((j|0)>0){k=c[g>>2]|0;n=b+56|0;t=1.0-d;l=f+4|0;p=o;m=0;s=0;while(1){if((a[k+(m*112|0)+88|0]|0)==0){v=p;w=s}else{x=c[n>>2]|0;if((x|0)==0){y=s;z=1.0}else{y=s+1|0;z=+h[x+(s<<3)>>3]}r=(+h[k+(m*112|0)+96>>3]- +h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+(m<<3)>>3])/z;v=p+r*t*r;w=y}x=m+1|0;if((x|0)<(j|0)){p=v;m=x;s=w}else{A=v;B=w;break}}}else{A=o;B=0}w=c[f+136>>2]|0;if((w|0)>0){s=c[f+24>>2]|0;m=b+56|0;o=1.0-d;y=f+416|0;v=A;l=0;k=B;while(1){do{if((a[s+(l*112|0)+88|0]|0)==0){C=v;D=k}else{if((a[s+(l*112|0)+72|0]|0)!=0){C=v;D=k;break}n=c[m>>2]|0;if((n|0)==0){E=k;F=1.0}else{E=k+1|0;F=+h[n+(k<<3)>>3]}p=(+h[s+(l*112|0)+96>>3]- +h[(c[y>>2]|0)+(l<<3)>>3])/F;C=v+p*o*p;D=E}}while(0);n=l+1|0;if((n|0)<(w|0)){v=C;l=n;k=D}else{G=C;H=D;break}}}else{G=A;H=B}B=c[f+120>>2]|0;D=j-B|0;if((D|0)>=(B|0)){u=G;i=e;return+u}j=c[g>>2]|0;g=b+56|0;A=1.0-d;b=f+416|0;d=G;f=D;D=H;while(1){do{if((a[j+(f*112|0)+88|0]|0)==0){I=d;J=D}else{if((a[j+(f*112|0)+72|0]|0)!=0){I=d;J=D;break}H=c[g>>2]|0;if((H|0)==0){K=D;L=1.0}else{K=D+1|0;L=+h[H+(D<<3)>>3]}G=(+h[j+(f*112|0)+96>>3]- +h[(c[b>>2]|0)+(f<<3)>>3])/L;I=d+G*A*G;J=K}}while(0);H=f+1|0;if((H|0)<(B|0)){d=I;f=H;D=J}else{u=I;break}}i=e;return+u}function LAa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+16|0;e=d;f=i;i=i+24|0;g=i;i=i+8|0;j=i;i=i+16|0;l=i;i=i+24|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+16|0;p=i;i=i+24|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+16|0;t=i;i=i+8|0;u=+KAa(b,1.0);if((c[206180>>2]|0)==0){i=d;return}v=b+16|0;w=c[v>>2]|0;if((w|0)>0){x=c[b+48>>2]|0;y=0.0;z=0;while(1){A=+h[x+(z<<3)>>3];B=y+A*A;C=z+1|0;if((C|0)<(w|0)){z=C;y=B}else{D=B;break}}}else{D=0.0}hwa(9,1,243704,t);t=b+52|0;if((c[t>>2]|0)==0){z=r;h[k>>3]=D;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];hwa(9,0,243768,r)}else{r=s;h[k>>3]=D;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=s+8|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];hwa(9,0,243728,s)}hwa(9,1,243792,q);q=b+4|0;s=c[q>>2]|0;if((s|0)>0){r=b+40|0;z=b+24|0;w=b+44|0;x=0;while(1){C=c[r>>2]|0;E=x+1|0;u=+h[(c[z>>2]|0)+(x<<3)>>3];F=c[(c[w>>2]|0)+(x<<2)>>2]|0;if((C|0)==0){c[o>>2]=E;G=o+4|0;h[k>>3]=u;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];c[o+12>>2]=F;hwa(9,0,243864,o)}else{D=+h[C+(x<<3)>>3];c[p>>2]=E;C=p+4|0;h[k>>3]=u;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[p+12>>2]=F;F=p+16|0;h[k>>3]=D;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];hwa(9,0,243816,p)}F=c[q>>2]|0;if((E|0)<(F|0)){x=E}else{H=F;I=E;break}}}else{H=s;I=0}s=b+8|0;if((I|0)<((c[s>>2]|0)+H|0)){H=b+40|0;x=b+24|0;p=b+44|0;o=I;while(1){w=c[H>>2]|0;z=o+1|0;D=+h[(c[x>>2]|0)+(o<<3)>>3];r=c[(c[p>>2]|0)+(o<<2)>>2]|0;if((w|0)==0){c[m>>2]=z;E=m+4|0;h[k>>3]=D;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];c[m+12>>2]=r;hwa(9,0,243952,m)}else{u=+h[w+(o<<3)>>3];c[n>>2]=z;w=n+4|0;h[k>>3]=D;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[n+12>>2]=r;r=n+16|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];hwa(9,0,243888,n)}if((z|0)<((c[s>>2]|0)+(c[q>>2]|0)|0)){o=z}else{J=z;break}}}else{J=I}I=b;if((J|0)<(c[I>>2]|0)){o=b+40|0;q=b+24|0;s=b+44|0;n=J;while(1){J=c[o>>2]|0;m=n+1|0;u=+h[(c[q>>2]|0)+(n<<3)>>3];p=c[(c[s>>2]|0)+(n<<2)>>2]|0;if((J|0)==0){c[j>>2]=m;x=j+4|0;h[k>>3]=u;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];c[j+12>>2]=p;hwa(9,0,244040,j)}else{D=+h[J+(n<<3)>>3];c[l>>2]=m;J=l+4|0;h[k>>3]=u;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];c[l+12>>2]=p;p=l+16|0;h[k>>3]=D;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];hwa(9,0,243984,l)}if((m|0)<(c[I>>2]|0)){n=m}else{break}}}le[c[51674]&2047](9);hwa(9,1,244072,g);if((c[v>>2]|0)>0){g=b+48|0;b=a+540|0;a=0;while(1){n=(c[t>>2]|0)==0;I=a+1|0;D=+h[(c[g>>2]|0)+(a<<3)>>3];l=oe[c[(c[b>>2]|0)+64>>2]&127](a)|0;if(n){c[e>>2]=I;n=e+4|0;h[k>>3]=D;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[e+12>>2]=l;hwa(9,0,243864,e)}else{u=+h[(c[t>>2]|0)+(a<<3)>>3];c[f>>2]=I;n=f+4|0;h[k>>3]=D;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[f+12>>2]=l;l=f+16|0;h[k>>3]=u;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];hwa(9,0,243816,f)}if((I|0)<(c[v>>2]|0)){a=I}else{break}}}le[c[51674]&2047](9);le[c[51674]&2047](9);i=d;return}function MAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0;d=i;i=i+24|0;e=d;f=i;i=i+8|0;g=i;i=i+24|0;j=i;i=i+8|0;l=i;i=i+24|0;m=i;i=i+8|0;n=i;i=i+40|0;o=i;i=i+8|0;p=i;i=i+24|0;q=i;i=i+8|0;r=i;i=i+40|0;s=i;i=i+8|0;t=i;i=i+8|0;u=b+8|0;if((c[206180>>2]|0)!=0){sza(b,9)}if((c[206240>>2]|0)==0){i=d;return}hwa(24,1,244096,t);t=b+112|0;v=c[t>>2]|0;do{if((v|0)>0){hwa(24,1,244136,s);if((c[t>>2]|0)>0){w=u;x=b+4|0;y=b+400|0;z=0;while(1){A=z+1|0;B=c[w>>2]|0;C=c[B+(z*112|0)+4>>2]|0;D=+h[B+(z*112|0)+96>>3];E=+h[B+(z*112|0)+80>>3];F=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];G=+h[(c[y>>2]|0)+(z<<3)>>3];c[r>>2]=A;c[r+4>>2]=C;C=r+8|0;h[k>>3]=D;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+16|0;h[k>>3]=E;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+24|0;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+32|0;h[k>>3]=G;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];hwa(24,0,244160,r);if((A|0)<(c[t>>2]|0)){z=A}else{break}}}le[c[51674]&2047](24);z=c[t>>2]|0;if((z|0)<=0){H=z;break}hwa(24,1,244216,q);z=c[t>>2]|0;if((z|0)<(z<<1|0)){y=u;x=b+4|0;w=b+400|0;A=z;while(1){z=A+1|0;C=c[(c[y>>2]|0)+(A*112|0)+4>>2]|0;G=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(A<<3)>>3];F=+h[(c[w>>2]|0)+(A<<3)>>3];c[p>>2]=z;c[p+4>>2]=C;C=p+8|0;h[k>>3]=G;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=p+16|0;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];hwa(24,0,244240,p);if((z|0)<(c[t>>2]<<1|0)){A=z}else{break}}}le[c[51674]&2047](24);H=c[t>>2]|0}else{H=v}}while(0);v=b+116|0;if((H<<1|0)<(c[v>>2]|0)){hwa(24,1,244272,o);o=c[t>>2]<<1;if((o|0)<(c[v>>2]|0)){t=u;u=b+4|0;H=b+400|0;p=o;while(1){o=p+1|0;q=c[t>>2]|0;r=c[q+(p*112|0)+4>>2]|0;F=+h[q+(p*112|0)+96>>3];G=+h[q+(p*112|0)+80>>3];E=+h[(c[(c[c[u>>2]>>2]|0)+8>>2]|0)+(p<<3)>>3];D=+h[(c[H>>2]|0)+(p<<3)>>3];c[n>>2]=o;c[n+4>>2]=r;r=n+8|0;h[k>>3]=F;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+16|0;h[k>>3]=G;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+24|0;h[k>>3]=E;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+32|0;h[k>>3]=D;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];hwa(24,0,244160,n);if((o|0)<(c[v>>2]|0)){p=o}else{break}}}le[c[51674]&2047](24)}p=b+124|0;if((c[p>>2]|0)>0){hwa(24,1,244296,m);if((c[p>>2]|0)>0){m=b+12|0;v=b+4|0;n=b+404|0;H=0;while(1){u=H+1|0;t=c[m>>2]|0;o=c[t+(H*60|0)+4>>2]|0;r=c[t+(H*60|0)+52>>2]|0;t=c[(c[(c[c[v>>2]>>2]|0)+12>>2]|0)+(H<<2)>>2]|0;q=c[(c[n>>2]|0)+(H<<2)>>2]|0;c[l>>2]=u;c[l+4>>2]=o;c[l+8>>2]=r;c[l+12>>2]=t;c[l+16>>2]=q;hwa(24,0,244320,l);if((u|0)<(c[p>>2]|0)){H=u}else{break}}}le[c[51674]&2047](24)}H=b+128|0;if((c[H>>2]|0)>0){hwa(24,1,244368,j);if((c[H>>2]|0)>0){j=b+16|0;p=b+4|0;l=b+408|0;n=0;while(1){v=n+1|0;m=c[j>>2]|0;u=c[m+(n*48|0)+4>>2]|0;q=(a[m+(n*48|0)+42|0]|0)!=0?244440:244448;m=(a[(c[(c[c[p>>2]>>2]|0)+16>>2]|0)+n|0]|0)!=0?244440:244448;t=(a[(c[l>>2]|0)+n|0]|0)!=0?244440:244448;c[g>>2]=v;c[g+4>>2]=u;c[g+8>>2]=q;c[g+12>>2]=m;c[g+16>>2]=t;hwa(24,0,244392,g);if((v|0)<(c[H>>2]|0)){n=v}else{break}}}le[c[51674]&2047](24)}n=b+132|0;if((c[n>>2]|0)>0){hwa(24,1,244456,f);if((c[n>>2]|0)>0){f=b+20|0;H=b+4|0;g=b+412|0;b=0;while(1){l=b+1|0;p=c[f>>2]|0;j=c[p+(b*52|0)+4>>2]|0;v=c[p+(b*52|0)+44>>2]|0;p=c[(c[(c[c[H>>2]>>2]|0)+20>>2]|0)+(b<<2)>>2]|0;t=c[(c[g>>2]|0)+(b<<2)>>2]|0;c[e>>2]=l;c[e+4>>2]=j;c[e+8>>2]=v;c[e+12>>2]=p;c[e+16>>2]=t;hwa(24,0,244480,e);if((l|0)<(c[n>>2]|0)){b=l}else{break}}}le[c[51674]&2047](24)}le[c[51674]&2047](24);i=d;return}function NAa(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0.0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;k=i;i=i+8|0;l=k;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=b+540|0;B=(c[(c[A>>2]|0)+72>>2]|0)!=0?3:2;hwa(9,0,244528,z);if((f|0)==0){pza(b);qza(b);C=6}else{if((a[f]|0)!=0){OAa(b,f,g)}pza(b);qza(b);if((a[f]|0)==0){C=6}}if((C|0)==6){oe[c[(c[A>>2]|0)+84>>2]&127](b)|0;oe[c[(c[A>>2]|0)+60>>2]&127](b)|0}do{if((d|0)==0){D=B}else{if((a[d]|0)==0){D=B;break}C=(t$a(d,246016)|0)==0|0;f=(t$a(d,246024)|0)==0;z=(t$a(d,246032)|0)==0;E=z?3:f?2:C;if((E|0)!=0){D=E;break}c[y>>2]=d;jwa(1,0,244576,y);jwa(1,0,244608,x);c[w>>2]=246016;c[w+4>>2]=245824;jwa(1,0,244632,w);c[v>>2]=246024;c[v+4>>2]=245904;jwa(1,0,244632,v);c[u>>2]=246032;c[u+4>>2]=245952;jwa(1,0,244632,u);lwa(c[b+536>>2]|0,244664,t)}}while(0);do{if((e|0)==0){F=3}else{if((a[e]|0)==0){F=3;break}else{G=1;H=0}do{t=(t$a(e,c[244688+(G<<2)>>2]|0)|0)==0;H=t?G:H;G=G+1|0;}while((G|0)<7);if((H|0)!=0){F=H;break}c[s>>2]=e;jwa(1,0,244720,s);jwa(1,0,244608,r);t=1;do{u=c[244752+(t<<2)>>2]|0;c[q>>2]=c[244688+(t<<2)>>2];c[q+4>>2]=u;jwa(1,0,244632,q);t=t+1|0;}while((t|0)<7);lwa(c[b+536>>2]|0,244664,p)}}while(0);p=c[244648+(D<<2)>>2]|0;c[o>>2]=c[244560+(D<<2)>>2];c[o+4>>2]=p;hwa(9,0,244784,o);o=(D|0)==2;if(o){p=c[244752+(F<<2)>>2]|0;c[n>>2]=c[244688+(F<<2)>>2];c[n+4>>2]=p;hwa(9,0,244824,n)}n=b+312|0;a[n]=1;p=b+200|0;if((c[p>>2]|0)>0){q=b+468|0;r=0;do{a[(c[q>>2]|0)+(r*80|0)+72|0]=1;r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+196|0;if((c[p>>2]|0)>0){r=b+476|0;q=0;do{a[(c[r>>2]|0)+(q<<6)+56|0]=1;q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+192|0;if((c[p>>2]|0)>0){q=b+484|0;r=0;do{a[(c[q>>2]|0)+(r*40|0)+36|0]=1;r=r+1|0;}while((r|0)<(c[p>>2]|0))}do{if((D|0)==1){I=0}else{if(o){I=PAa(b,F,j)|0;break}if((D|0)==3){QAa(b,j);I=0;break}else{lwa(c[b+536>>2]|0,244864,m)}}}while(0);if(($za(b,1)|0)!=0){J=-2;MAa(b);K=15;L=K;M=244888;N=M;hwa(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];_ya(b,R,V);W=1257;mza(b);X=1263;rza(b);Y=1258;hza(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=oe[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=De[ha&63](b,1)|0;ja=1266;nza(b);i=k;return J|0}if((Rza(b,1)|0)!=0){J=-3;MAa(b);K=15;L=K;M=244888;N=M;hwa(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];_ya(b,R,V);W=1257;mza(b);X=1263;rza(b);Y=1258;hza(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=oe[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=De[ha&63](b,1)|0;ja=1266;nza(b);i=k;return J|0}m=(Gza(b,1)|0)==0;J=m?I:-4;MAa(b);K=15;L=K;M=244888;N=M;hwa(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];_ya(b,R,V);W=1257;mza(b);X=1263;rza(b);Y=1258;hza(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=oe[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=De[ha&63](b,1)|0;ja=1266;nza(b);i=k;return J|0}function OAa(b,d,e){b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+16|0;A=i;i=i+48|0;B=i;i=i+8|0;c[z>>2]=d;C=z+4|0;h[k>>3]=e;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];hwa(9,0,246048,z);z=Twa(d,A)|0;if((z|0)!=0){C=c[b+536>>2]|0;c[y>>2]=d;c[y+4>>2]=z;lwa(C,246088,y)}hwa(9,0,246128,x);x=b+116|0;if((c[x>>2]|0)>0){y=b+8|0;C=0;do{z=Uwa(A,c[(c[y>>2]|0)+(C*112|0)+4>>2]|0)|0;d=c[y>>2]|0;do{if((z|0)==0){D=TAa(c[d+(C*112|0)+4>>2]|0)|0;E=Uwa(A,D)|0;W_a(D);D=c[y>>2]|0;if((E|0)!=0){F=D;G=E;H=7;break}E=c[D+(C*112|0)+4>>2]|0;if((u$a(E,246168,6)|0)==0){if((c[206180>>2]|0)==0){break}}else{D=u$a(E,246176,6)|0;if((c[206180>>2]|D|0)==0){break}}c[v>>2]=E;jwa(9,0,246184,v)}else{F=d;G=z;H=7}}while(0);if((H|0)==7){H=0;_wa(F+(C*112|0)+96|0,A,G,e)|0;z=c[y>>2]|0;I=+h[z+(C*112|0)+96>>3];c[w>>2]=c[z+(C*112|0)+4>>2];z=w+4|0;h[k>>3]=I;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];hwa(9,0,246152,w)}C=C+1|0;}while((C|0)<(c[x>>2]|0))}hwa(9,0,246240,u);u=b+136|0;if((c[u>>2]|0)>0){C=b+24|0;w=0;do{y=Uwa(A,c[(c[C>>2]|0)+(w*112|0)+4>>2]|0)|0;G=c[C>>2]|0;do{if((y|0)==0){F=TAa(c[G+(w*112|0)+4>>2]|0)|0;v=Uwa(A,F)|0;W_a(F);F=c[C>>2]|0;if((v|0)!=0){J=F;K=v;H=17;break}c[s>>2]=c[F+(w*112|0)+4>>2];jwa(9,0,246264,s)}else{J=G;K=y;H=17}}while(0);if((H|0)==17){H=0;_wa(J+(w*112|0)+96|0,A,K,e)|0;y=c[C>>2]|0;I=+h[y+(w*112|0)+96>>3];c[t>>2]=c[y+(w*112|0)+4>>2];y=t+4|0;h[k>>3]=I;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];hwa(9,0,246152,t)}w=w+1|0;}while((w|0)<(c[u>>2]|0))}hwa(9,0,246320,r);r=b+120|0;u=c[r>>2]|0;w=(c[x>>2]|0)-u|0;if((w|0)<(u|0)){u=b+24|0;x=w;do{w=Uwa(A,c[(c[u>>2]|0)+(x*112|0)+4>>2]|0)|0;t=c[u>>2]|0;do{if((w|0)==0){C=TAa(c[t+(x*112|0)+4>>2]|0)|0;K=Uwa(A,C)|0;W_a(C);C=c[u>>2]|0;if((K|0)!=0){L=C;M=K;H=24;break}c[p>>2]=c[C+(x*112|0)+4>>2];jwa(9,0,246264,p)}else{L=t;M=w;H=24}}while(0);if((H|0)==24){H=0;_wa(L+(x*112|0)+96|0,A,M,e)|0;w=c[u>>2]|0;I=+h[w+(x*112|0)+96>>3];c[q>>2]=c[w+(x*112|0)+4>>2];w=q+4|0;h[k>>3]=I;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];hwa(9,0,246152,q)}x=x+1|0;}while((x|0)<(c[r>>2]|0))}hwa(9,0,246344,o);o=b+140|0;if((c[o>>2]|0)>0){r=b+28|0;x=0;do{q=Uwa(A,c[(c[r>>2]|0)+(x*60|0)+4>>2]|0)|0;do{if((q|0)==0){u=TAa(c[(c[r>>2]|0)+(x*60|0)+4>>2]|0)|0;M=Uwa(A,u)|0;W_a(u);if((M|0)!=0){N=M;H=31;break}c[m>>2]=c[(c[r>>2]|0)+(x*60|0)+4>>2];jwa(9,0,246392,m)}else{N=q;H=31}}while(0);if((H|0)==31){H=0;_wa(B,A,N,e)|0;q=~~+h[B>>3];M=c[r>>2]|0;c[M+(x*60|0)+52>>2]=q;c[n>>2]=c[M+(x*60|0)+4>>2];c[n+4>>2]=q;hwa(9,0,246376,n)}x=x+1|0;}while((x|0)<(c[o>>2]|0))}hwa(9,0,246448,l);l=b+144|0;if((c[l>>2]|0)<=0){Rwa(A);i=f;return}o=b+32|0;b=0;do{x=Uwa(A,c[(c[o>>2]|0)+(b*48|0)+4>>2]|0)|0;do{if((x|0)==0){n=TAa(c[(c[o>>2]|0)+(b*48|0)+4>>2]|0)|0;r=Uwa(A,n)|0;W_a(n);if((r|0)!=0){O=r;H=38;break}c[g>>2]=c[(c[o>>2]|0)+(b*48|0)+4>>2];jwa(9,0,246496,g)}else{O=x;H=38}}while(0);if((H|0)==38){H=0;_wa(B,A,O,e)|0;a[(c[o>>2]|0)+(b*48|0)+42|0]=~~+h[B>>3];x=c[o>>2]|0;r=(a[x+(b*48|0)+42|0]|0)!=0?244440:244448;c[j>>2]=c[x+(b*48|0)+4>>2];c[j+4>>2]=r;hwa(9,0,246480,j)}b=b+1|0;}while((b|0)<(c[l>>2]|0));Rwa(A);i=f;return}function PAa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;Zya(a,+h[a+240>>3]);mza(a);rza(a);hza(a);tza(a);AAa(a);iza(a);mza(a);e=RAa(a,b,c)|0;rza(a);hza(a);nza(a);rza(a);i=d;return e|0}function QAa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+4096|0;Zya(b,+h[b+240>>3]);mza(b);rza(b);CAa(b,0,1)|0;v=b+540|0;w=c[v>>2]|0;if((c[w+76>>2]|0)!=0&(d|0)>1){x=u;u=b+8|0;y=b+116|0;z=X_a(c[y>>2]|0,8)|0;A=b+124|0;B=X_a(c[A>>2]|0,4)|0;C=b+128|0;D=X_a(c[C>>2]|0,1)|0;E=b+132|0;F=X_a(c[E>>2]|0,4)|0;G=b+536|0;kwa(c[G>>2]|0,(z|0)!=0|0,244920,t);kwa(c[G>>2]|0,(B|0)!=0|0,244920,s);kwa(c[G>>2]|0,(D|0)!=0|0,244920,r);kwa(c[G>>2]|0,(F|0)!=0|0,244920,q);q=c[y>>2]|0;if((q|0)>0){G=c[u>>2]|0;r=0;do{h[z+(r<<3)>>3]=+h[G+(r*112|0)+96>>3];r=r+1|0;}while((r|0)<(q|0))}q=c[A>>2]|0;if((q|0)>0){r=c[b+12>>2]|0;G=0;do{c[B+(G<<2)>>2]=c[r+(G*60|0)+52>>2];G=G+1|0;}while((G|0)<(q|0))}q=c[C>>2]|0;if((q|0)>0){G=c[b+16>>2]|0;r=0;do{a[D+r|0]=a[G+(r*48|0)+42|0]|0;r=r+1|0;}while((r|0)<(q|0))}q=c[E>>2]|0;if((q|0)>0){r=c[b+20>>2]|0;G=0;do{c[F+(G<<2)>>2]=c[r+(G*52|0)+44>>2];G=G+1|0;}while((G|0)<(q|0))}if((c[206180>>2]|0)==0){H=0}else{c[p>>2]=c[b+88>>2];lc(x|0,244936,p|0)|0;p=mc(x|0,244952)|0;c[o>>2]=244968;Cd(p|0,244960,o|0)|0;if((c[y>>2]|0)>0){o=u;x=0;do{c[n>>2]=c[(c[o>>2]|0)+(x*112|0)+4>>2];Cd(p|0,244960,n|0)|0;x=x+1|0;}while((x|0)<(c[y>>2]|0))}Yd(10,p|0)|0;H=p}hwa(9,1,244976,m);a:do{if((d|0)>0){I=+(d+ -1|0);m=b+304|0;p=b+4|0;x=0;do{J=+(x|0)/I;h[m>>3]=J>1.0?1.0:J;oe[c[(c[v>>2]|0)+80>>2]&127](b)|0;n=l;h[k>>3]=+h[m>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];hwa(9,0,245e3,l);if((c[206180>>2]|0)!=0){n=j;h[k>>3]=+h[m>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Cd(H|0,245024,j|0)|0;if((c[y>>2]|0)>0){n=0;do{o=g;h[k>>3]=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+(n<<3)>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];Cd(H|0,245024,g|0)|0;n=n+1|0;}while((n|0)<(c[y>>2]|0))}Yd(10,H|0)|0}if(($za(b,0)|0)!=0){break a}if((Rza(b,0)|0)!=0){break a}if((Gza(b,0)|0)!=0){break a}uza(b);x=x+1|0;}while((x|0)<(d|0))}}while(0);le[c[51674]&2047](9);if((c[206180>>2]|0)!=0){ad(H|0)|0}H=c[y>>2]|0;if((H|0)>0){y=c[u>>2]|0;u=0;do{h[y+(u*112|0)+96>>3]=+h[z+(u<<3)>>3];u=u+1|0;}while((u|0)<(H|0))}if((c[A>>2]|0)>0){H=c[b+12>>2]|0;u=0;do{c[H+(u*60|0)+52>>2]=c[B+(u<<2)>>2];u=u+1|0;}while((u|0)<(c[A>>2]|0))}if((c[C>>2]|0)>0){A=b+16|0;u=0;do{a[(c[A>>2]|0)+(u*48|0)+42|0]=a[D+u|0]|0;u=u+1|0;}while((u|0)<(c[C>>2]|0))}C=c[E>>2]|0;if((C|0)>0){E=b+20|0;u=0;do{c[(c[E>>2]|0)+(u*52|0)+44>>2]=c[F+(u<<2)>>2];u=u+1|0;}while((u|0)<(C|0))}W_a(z);W_a(B);W_a(D);W_a(F)}else{h[b+304>>3]=1.0;oe[c[w+80>>2]&127](b)|0}jza(b);if((CAa(b,1,1)|0)!=1){i=e;return}oe[c[(c[v>>2]|0)+80>>2]&127](b)|0;jza(b);if((CAa(b,1,1)|0)!=1){i=e;return}jwa(1,0,245032,f);i=e;return}function RAa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=UAa(b)|0;w=v;x=c[w>>2]|0;if((x|0)==0){hwa(9,0,245136,u);if((c[b+184>>2]|0)==0){De[c[(c[b+540>>2]|0)+68>>2]&63](b,c[v+48>>2]|0)|0}W_a(v);y=0;i=f;return y|0}u=b+184|0;z=c[u>>2]|0;if((z|0)==0){hwa(9,0,245168,t);De[c[(c[b+540>>2]|0)+68>>2]&63](b,c[v+48>>2]|0)|0;W_a(v);y=0;i=f;return y|0}do{if((c[v+16>>2]|0)<(x|0)){hwa(9,1,245240,s);t=V_a(c[w>>2]<<3)|0;A=v+40|0;B=c[A>>2]|0;c[A>>2]=0;C=+KAa(v,1.0);c[A>>2]=B;D=c[w>>2]|0;if((D|0)>0){E=v+24|0;F=c[E>>2]|0;G=0;while(1){H=F+(G<<3)|0;h[H>>3]=+h[H>>3]+1.0e-6;c[A>>2]=0;h[t+(G<<3)>>3]=+U(+(+KAa(v,1.0)-C))/1.0e-6;c[A>>2]=B;H=c[E>>2]|0;I=H+(G<<3)|0;h[I>>3]=+h[I>>3]+-1.0e-6;I=G+1|0;J=c[w>>2]|0;if((I|0)<(J|0)){G=I;F=H}else{K=J;break}}}else{K=D}F=c[u>>2]|0;if((F|0)>0){G=(K|0)>1;E=0;do{if(G){B=1;A=0;while(1){J=+h[t+(B<<3)>>3]>+h[t+(A<<3)>>3]?B:A;H=B+1|0;if((H|0)<(K|0)){A=J;B=H}else{L=J;break}}}else{L=0}h[t+(L<<3)>>3]=-1.0;E=E+1|0;}while((E|0)<(F|0))}hwa(9,1,245264,r);F=b+112|0;E=c[F>>2]|0;if((E|0)>0){G=b+8|0;D=v+44|0;B=v+24|0;A=E;E=0;J=0;while(1){H=(c[G>>2]|0)+(E*112|0)+72|0;if((a[H]|0)==0){if(!(+h[t+(J<<3)>>3]>=0.0)){M=A}else{a[H]=1;C=+h[(c[B>>2]|0)+(J<<3)>>3];c[q>>2]=c[(c[D>>2]|0)+(J<<2)>>2];H=q+4|0;h[k>>3]=C;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];hwa(9,0,245288,q);M=c[F>>2]|0}N=M;O=J+1|0}else{N=A;O=J}H=E+1|0;if((H|0)<(N|0)){A=N;E=H;J=O}else{P=O;break}}}else{P=0}J=b+136|0;if((c[J>>2]|0)>0){E=b+24|0;A=v+44|0;F=v+24|0;D=b+116|0;B=b+120|0;G=0;H=P;while(1){I=(c[E>>2]|0)+(G*112|0)+72|0;if((a[I]|0)==0){if(+h[t+(H<<3)>>3]>=0.0){a[I]=1;C=+h[(c[F>>2]|0)+(H<<3)>>3];c[p>>2]=c[(c[A>>2]|0)+(H<<2)>>2];I=p+4|0;h[k>>3]=C;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];hwa(9,0,245288,p)}Q=H+1|0}else{Q=H}I=c[B>>2]|0;R=(c[D>>2]|0)-I|0;if((R|0)<(I|0)){S=I;I=R;T=Q;while(1){V=(c[E>>2]|0)+(I*112|0)+72|0;if((a[V]|0)==0){if(!(+h[t+(T<<3)>>3]>=0.0)){W=S}else{a[V]=1;C=+h[(c[F>>2]|0)+(T<<3)>>3];c[o>>2]=c[(c[A>>2]|0)+(T<<2)>>2];V=o+4|0;h[k>>3]=C;c[V>>2]=c[k>>2];c[V+4>>2]=c[k+4>>2];hwa(9,0,245288,o);W=c[B>>2]|0}X=W;Y=T+1|0}else{X=S;Y=T}V=I+1|0;if((V|0)<(X|0)){S=X;I=V;T=Y}else{Z=V;_=Y;break}}}else{Z=R;_=Q}T=Z+1|0;if((T|0)<(c[J>>2]|0)){G=T;H=_}else{break}}}if((c[206180>>2]|0)!=0){le[c[51674]&2047](9);le[c[51674]&2047](9)}W_a(t);VAa(v);H=UAa(b)|0;if((c[H>>2]|0)!=0){$=H;break}hwa(9,0,245312,n);W_a(H);y=0;i=f;return y|0}else{if((z|0)<=(x|0)){$=v;break}hwa(9,0,245344,m);$=v}}while(0);do{if((d|0)==3|(d|0)==5){hwa(9,0,245360,l);SAa($,d,1,e);LAa(b,$);v=c[$>>2]|0;if((v|0)<=0){break}m=c[$+24>>2]|0;x=c[$+28>>2]|0;z=0;do{h[x+(z<<3)>>3]=+h[m+(z<<3)>>3];z=z+1|0;}while((z|0)<(v|0))}}while(0);if(+KAa($,1.0)>1.0e-9){l=$+40|0;v=c[l>>2]|0;if((v|0)!=0){W_a(v);c[l>>2]=0}l=$+52|0;v=c[l>>2]|0;if((v|0)!=0){W_a(v);c[l>>2]=0}l=$+56|0;v=c[l>>2]|0;if((v|0)!=0){W_a(v);c[l>>2]=0}SAa($,d,0,e);LAa(b,$);+KAa($,1.0)}else{hwa(9,0,245384,j)}hwa(9,1,245408,g);LAa(b,$);b=JAa($)|0;if((c[206180>>2]|0)!=0){le[c[51674]&2047](9)}VAa($);y=b;i=f;return y|0}function SAa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=c[a+60>>2]|0;h[n>>3]=0.0;p=a;q=V_a(c[p>>2]<<3)|0;r=q;s=+KAa(a,1.0);t=c[p>>2]|0;if((t|0)>0){u=c[a+28>>2]|0;v=c[a+24>>2]|0;w=0;do{x=+h[u+(w<<3)>>3];h[v+(w<<3)>>3]=x;h[q+(w<<3)>>3]=x;w=w+1|0;}while((w|0)<(t|0))}if(!(s>1.0e-12)){y=1;XAa(a,r);W_a(q);z=y+ -1|0;A=g;B=A;c[B>>2]=z;C=15;D=C;E=245536;F=E;hwa(9,0,F,g);i=f;return}t=(d|0)==0;d=a+24|0;x=s;w=1;a:while(1){c[m>>2]=w;hwa(9,0,245448,m);if(!t){WAa(a)}switch(b|0){case 2:{G=aBa(a)|0;break};case 4:{H=12;break a;break};case 6:{H=14;break a;break};case 3:{G=eBa(a,n,e)|0;break};case 1:{G=cBa(a)|0;break};case 5:{H=13;break a;break};default:{H=15;break a}}rza(o);hza(o);nza(o);rza(o);s=+KAa(a,1.0);v=(G|0)>-1;if(v&s<x){u=c[p>>2]|0;if((u|0)>0){I=c[d>>2]|0;J=0;do{h[q+(J<<3)>>3]=+h[I+(J<<3)>>3];J=J+1|0;}while((J|0)<(u|0))}hwa(9,0,245496,k);LAa(o,a);K=s}else{hwa(9,0,245512,j);if(v&s==x){y=w;H=23;break}else{K=x}}u=w+1|0;if((u|0)<201&s>1.0e-12){x=K;w=u}else{y=u;H=23;break}}if((H|0)==12){$Aa(a)|0}else if((H|0)==13){$Aa(a)|0}else if((H|0)==14){_Aa(o,a,0)|0}else if((H|0)==15){lwa(c[o+536>>2]|0,245472,l)}else if((H|0)==23){XAa(a,r);W_a(q);z=y+ -1|0;A=g;B=A;c[B>>2]=z;C=15;D=C;E=245536;F=E;hwa(9,0,F,g);i=f;return}}function TAa(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=i;d=x$a(b|0)|0;do{if((d|0)==0){e=V_a(1)|0;f=0}else{g=0;h=0;j=d;while(1){k=a[b+g|0]|0;if(k<<24>>24==91){l=h+1|0}else if(k<<24>>24==93){l=h+ -1|0}else{l=h}if((l|0)!=0&k<<24>>24==44){m=((a[b+(g+1)|0]|0)!=32)+j|0}else{m=j}k=g+1|0;if(k>>>0<d>>>0){g=k;h=l;j=m}else{break}}j=V_a(m+1|0)|0;if((m|0)==0){e=j;f=0;break}else{n=0;o=0;p=l}while(1){h=a[b+o|0]|0;if(h<<24>>24==93){q=p+ -1|0}else if(h<<24>>24==91){q=p+1|0}else{q=p}a[j+n|0]=h;do{if((q|0)!=0&h<<24>>24==44){if((a[b+(o+1)|0]|0)==32){r=n;break}g=n+1|0;a[j+g|0]=32;r=g}else{r=n}}while(0);h=r+1|0;if(h>>>0<m>>>0){n=h;o=o+1|0;p=q}else{e=j;f=m;break}}}}while(0);a[e+f|0]=0;if((s$a(e,246552,4)|0)!=0){i=c;return e|0}m=f>>>0>3;q=e+4|0;while(1){a:do{if(m){p=f;while(1){o=p+ -1|0;if((a[e+p|0]|0)==46){s=p;break a}if(o>>>0>3){p=o}else{s=o;break}}}else{s=f}}while(0);if((s|0)==3){t=24;break}p=s+ -3|0;z$a(e|0,q|0,p|0)|0;o=e+p|0;a[o]=678585700;a[o+1|0]=2650725;a[o+2|0]=10354;a[o+3|0]=40;if((s$a(e,246552,4)|0)!=0){t=24;break}}if((t|0)==24){i=c;return e|0}return 0}function UAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+32|0;n=i;i=i+32|0;o=i;i=i+32|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=V_a(64)|0;z=y;kwa(0,(y|0)!=0|0,246560,x);x=y+4|0;A=y+8|0;B=y+12|0;C=y+16|0;D=y+20|0;E=y+24|0;F=y+28|0;G=y+32|0;H=y+36|0;I=y+40|0;J=y+44|0;K=y+48|0;L=y+52|0;M=y+56|0;N=y+60|0;O=y+0|0;P=O+60|0;do{c[O>>2]=0;O=O+4|0}while((O|0)<(P|0));c[N>>2]=b;N=b+8|0;O=b+112|0;P=c[O>>2]|0;if((P|0)>0){Q=c[N>>2]|0;R=0;S=0;while(1){if((a[Q+(S*112|0)+72|0]|0)==0){T=R+1|0;c[x>>2]=T;V=T}else{V=R}T=S+1|0;if((T|0)<(P|0)){R=V;S=T}else{W=V;break}}}else{W=0}V=b+136|0;S=c[V>>2]|0;if((S|0)>0){R=c[b+24>>2]|0;P=0;x=0;while(1){if((a[R+(x*112|0)+72|0]|0)==0){Q=P+1|0;c[A>>2]=Q;X=Q}else{X=P}Q=x+1|0;if((Q|0)<(S|0)){P=X;x=Q}else{Y=X;break}}}else{Y=0}X=b+116|0;x=b+120|0;P=c[x>>2]|0;if((P|0)>0){S=c[X>>2]|0;A=c[N>>2]|0;R=0;Q=S-P|0;while(1){if((a[A+(Q*112|0)+72|0]|0)==0){P=R+1|0;c[B>>2]=P;Z=P}else{Z=R}P=Q+1|0;if((P|0)<(S|0)){R=Z;Q=P}else{_=Z;break}}}else{_=0}Z=Y+W+_|0;c[y>>2]=Z;if((Z|0)==0){i=d;return z|0}y=X_a(Z,8)|0;c[E>>2]=y;kwa(0,(y|0)!=0|0,246560,w);w=X_a(Z,8)|0;c[F>>2]=w;kwa(0,(w|0)!=0|0,246560,v);v=X_a(Z,8)|0;c[G>>2]=v;kwa(0,(v|0)!=0|0,246560,u);u=X_a(Z,8)|0;c[H>>2]=u;kwa(0,(u|0)!=0|0,246560,t);t=X_a(Z,8)|0;c[I>>2]=t;kwa(0,(t|0)!=0|0,246560,s);s=X_a(Z,4)|0;t=s;c[J>>2]=t;kwa(0,(s|0)!=0|0,246560,r);hwa(9,0,246576,q);c[p>>2]=Z;c[p+4>>2]=W;c[p+8>>2]=Y;c[p+12>>2]=_;hwa(9,0,246600,p);p=c[O>>2]|0;if((p|0)>0){_=N;Y=p;p=t;W=0;Z=0;while(1){q=c[_>>2]|0;if((a[q+(W*112|0)+72|0]|0)==0){c[p+(Z<<2)>>2]=c[q+(W*112|0)+4>>2];q=c[_>>2]|0;do{if((a[q+(W*112|0)+73|0]|0)==0){$=(c[I>>2]|0)+(Z<<3)|0;aa=1.0}else{ba=+h[q+(W*112|0)+80>>3];ca=+U(+ba);r=(c[I>>2]|0)+(Z<<3)|0;if(!(ba==0.0)){$=r;aa=ca;break}$=r;aa=1.0}}while(0);h[$>>3]=aa;r=q+(W*112|0)+96|0;s=(c[E>>2]|0)+(Z<<3)|0;h[s>>3]=+h[r>>3];u=(c[F>>2]|0)+(Z<<3)|0;h[u>>3]=+h[r>>3];h[(c[G>>2]|0)+(Z<<3)>>3]=+h[q+(W*112|0)+56>>3];h[(c[H>>2]|0)+(Z<<3)>>3]=+h[q+(W*112|0)+64>>3];r=Z+1|0;v=c[J>>2]|0;w=c[v+(Z<<2)>>2]|0;ca=+h[u>>3];ba=+h[$>>3];da=+h[s>>3];c[o>>2]=r;c[o+4>>2]=w;w=o+8|0;h[k>>3]=ca;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=o+16|0;h[k>>3]=ba;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=o+24|0;h[k>>3]=da;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];hwa(9,0,246688,o);ea=c[O>>2]|0;fa=v;ga=r}else{ea=Y;fa=p;ga=Z}r=W+1|0;if((r|0)<(ea|0)){Y=ea;p=fa;W=r;Z=ga}else{ha=fa;ia=ga;break}}}else{ha=t;ia=0}t=c[V>>2]|0;if((t|0)>0){ga=b+24|0;fa=t;t=ha;Z=0;W=ia;while(1){p=c[ga>>2]|0;if((a[p+(Z*112|0)+72|0]|0)==0){c[t+(W<<2)>>2]=c[p+(Z*112|0)+4>>2];p=c[ga>>2]|0;aa=+h[p+(Z*112|0)+80>>3];da=+U(+aa);ea=(c[I>>2]|0)+(W<<3)|0;h[ea>>3]=aa==0.0?1.0:da;Y=p+(Z*112|0)+96|0;O=(c[E>>2]|0)+(W<<3)|0;h[O>>3]=+h[Y>>3];o=(c[F>>2]|0)+(W<<3)|0;h[o>>3]=+h[Y>>3];h[(c[G>>2]|0)+(W<<3)>>3]=+h[p+(Z*112|0)+56>>3];h[(c[H>>2]|0)+(W<<3)>>3]=+h[p+(Z*112|0)+64>>3];p=W+1|0;Y=c[J>>2]|0;$=c[Y+(W<<2)>>2]|0;da=+h[o>>3];aa=+h[ea>>3];ba=+h[O>>3];c[n>>2]=p;c[n+4>>2]=$;$=n+8|0;h[k>>3]=da;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=n+16|0;h[k>>3]=aa;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=n+24|0;h[k>>3]=ba;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];hwa(9,0,246736,n);ja=c[V>>2]|0;ka=Y;la=p}else{ja=fa;ka=t;la=W}p=Z+1|0;if((p|0)<(ja|0)){fa=ja;t=ka;Z=p;W=la}else{ma=ka;na=la;break}}}else{ma=ha;na=ia}ia=c[x>>2]|0;if((ia|0)>0){ha=c[X>>2]|0;la=N;ka=ha;W=ma;ma=ha-ia|0;ia=na;while(1){na=c[la>>2]|0;if((a[na+(ma*112|0)+72|0]|0)==0){c[W+(ia<<2)>>2]=c[na+(ma*112|0)+4>>2];na=c[la>>2]|0;do{if((a[na+(ma*112|0)+73|0]|0)==0){oa=(c[I>>2]|0)+(ia<<3)|0;pa=1.0}else{ba=+h[na+(ma*112|0)+80>>3];aa=+U(+ba);ha=(c[I>>2]|0)+(ia<<3)|0;if(!(ba==0.0)){oa=ha;pa=aa;break}oa=ha;pa=1.0}}while(0);h[oa>>3]=pa;q=na+(ma*112|0)+96|0;ha=(c[E>>2]|0)+(ia<<3)|0;h[ha>>3]=+h[q>>3];Z=(c[F>>2]|0)+(ia<<3)|0;h[Z>>3]=+h[q>>3];h[(c[G>>2]|0)+(ia<<3)>>3]=+h[na+(ma*112|0)+56>>3];h[(c[H>>2]|0)+(ia<<3)>>3]=+h[na+(ma*112|0)+64>>3];q=ia+1|0;t=c[J>>2]|0;ja=c[t+(ia<<2)>>2]|0;aa=+h[Z>>3];ba=+h[oa>>3];da=+h[ha>>3];c[m>>2]=q;c[m+4>>2]=ja;ja=m+8|0;h[k>>3]=aa;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=m+16|0;h[k>>3]=ba;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=m+24|0;h[k>>3]=da;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];hwa(9,0,246792,m);qa=c[X>>2]|0;ra=t;sa=q}else{qa=ka;ra=W;sa=ia}q=ma+1|0;if((q|0)<(qa|0)){ka=qa;W=ra;ma=q;ia=sa}else{break}}}sa=c[b+184>>2]|0;c[C>>2]=sa;c[D>>2]=0;C=c[X>>2]|0;if((C|0)>0){X=c[N>>2]|0;ia=0;ma=0;while(1){if((a[X+(ma*112|0)+88|0]|0)==0){ta=ia}else{ra=ia+1|0;c[D>>2]=ra;ta=ra}ra=ma+1|0;if((ra|0)<(C|0)){ia=ta;ma=ra}else{ua=ta;break}}}else{ua=0}ta=c[V>>2]|0;if((ta|0)>0){V=c[b+24>>2]|0;ma=ua;ia=0;while(1){do{if((a[V+(ia*112|0)+88|0]|0)==0){va=ma}else{if((a[V+(ia*112|0)+72|0]|0)!=0){va=ma;break}X=ma+1|0;c[D>>2]=X;va=X}}while(0);na=ia+1|0;if((na|0)<(ta|0)){ma=va;ia=na}else{wa=va;break}}}else{wa=ua}ua=c[x>>2]|0;if((ua|0)>0){x=c[N>>2]|0;N=wa;va=C-ua|0;while(1){do{if((a[x+(va*112|0)+88|0]|0)==0){xa=N}else{if((a[x+(va*112|0)+72|0]|0)!=0){xa=N;break}ua=N+1|0;c[D>>2]=ua;xa=ua}}while(0);ua=va+1|0;if((ua|0)<(C|0)){N=xa;va=ua}else{ya=xa;break}}}else{ya=wa}wa=c[b+176>>2]|0;xa=c[b+180>>2]|0;c[l>>2]=sa;c[l+4>>2]=wa;c[l+8>>2]=xa;hwa(9,0,246848,l);c[j>>2]=ya;hwa(9,0,246920,j);j=X_a(sa,8)|0;c[K>>2]=j;kwa(0,(j|0)!=0|0,246560,g);g=V_a(sa<<3)|0;c[L>>2]=g;kwa(0,(g|0)!=0|0,246560,f);f=V_a(ya<<3)|0;c[M>>2]=f;kwa(0,(f|0)!=0|0,246560,e);if((sa|0)>0){e=0;do{h[g+(e<<3)>>3]=1.0;e=e+1|0;}while((e|0)<(sa|0))}if((ya|0)>0){za=0}else{i=d;return z|0}do{h[f+(za<<3)>>3]=1.0;za=za+1|0;}while((za|0)<(ya|0));i=d;return z|0}function VAa(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+24>>2]|0;if((d|0)!=0){W_a(d)}d=c[a+28>>2]|0;if((d|0)!=0){W_a(d)}d=c[a+32>>2]|0;if((d|0)!=0){W_a(d)}d=c[a+36>>2]|0;if((d|0)!=0){W_a(d)}d=c[a+40>>2]|0;if((d|0)!=0){W_a(d)}d=c[a+44>>2]|0;if((d|0)!=0){W_a(d)}d=c[a+48>>2]|0;if((d|0)!=0){W_a(d)}d=c[a+52>>2]|0;if((d|0)!=0){W_a(d)}d=c[a+56>>2]|0;if((d|0)==0){e=a;W_a(e);i=b;return}W_a(d);e=a;W_a(e);i=b;return}function WAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0.0,T=0,V=0,W=0;d=i;i=i+8|0;e=d;f=c[b+60>>2]|0;g=b+40|0;if((c[g>>2]|0)==0){i=d;return}j=b+52|0;k=c[j>>2]|0;if((k|0)==0){i=d;return}l=b+56|0;m=c[l>>2]|0;if((m|0)==0){i=d;return}n=b+16|0;o=c[n>>2]|0;p=X_a(o,8)|0;q=X_a(o,8)|0;r=b+20|0;s=c[r>>2]|0;t=X_a(s,8)|0;u=X_a(s,8)|0;v=X_a(o,8)|0;w=X_a(s,8)|0;if((o|0)>0){x=0;do{h[k+(x<<3)>>3]=1.0;x=x+1|0;}while((x|0)<(o|0))}if((s|0)>0){o=0;do{h[m+(o<<3)>>3]=1.0;o=o+1|0;}while((o|0)<(s|0))}+KAa(b,1.0);s=c[n>>2]|0;if((s|0)>0){z$a(p|0,c[b+48>>2]|0,((s|0)>1?s<<3:8)|0)|0}o=f+8|0;m=f+116|0;x=c[m>>2]|0;if((x|0)>0){k=c[o>>2]|0;y=f+4|0;z=0;A=0;while(1){if((a[k+(z*112|0)+88|0]|0)==0){B=A}else{h[t+(A<<3)>>3]=+h[k+(z*112|0)+96>>3]- +h[(c[(c[c[y>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];B=A+1|0}C=z+1|0;if((C|0)<(x|0)){z=C;A=B}else{D=B;break}}}else{D=0}B=f+136|0;A=c[B>>2]|0;if((A|0)>0){z=c[f+24>>2]|0;y=f+4|0;k=0;C=D;while(1){do{if((a[z+(k*112|0)+88|0]|0)==0){E=C}else{if((a[z+(k*112|0)+72|0]|0)!=0){E=C;break}h[t+(C<<3)>>3]=+h[z+(k*112|0)+96>>3]- +h[(c[(c[c[y>>2]>>2]|0)+8>>2]|0)+(k<<3)>>3];E=C+1|0}}while(0);F=k+1|0;if((F|0)<(A|0)){k=F;C=E}else{G=E;break}}}else{G=D}D=f+120|0;E=c[D>>2]|0;if((E|0)>0){C=c[o>>2]|0;k=f+4|0;A=x-E|0;E=G;while(1){do{if((a[C+(A*112|0)+88|0]|0)==0){H=E}else{if((a[C+(A*112|0)+72|0]|0)!=0){H=E;break}h[t+(E<<3)>>3]=+h[C+(A*112|0)+96>>3]- +h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+(A<<3)>>3];H=E+1|0}}while(0);G=A+1|0;if((G|0)<(x|0)){A=G;E=H}else{break}}}H=b;if((c[H>>2]|0)>0){E=b+24|0;A=o;o=f+4|0;x=f+24|0;f=b+48|0;k=c[E>>2]|0;C=0;while(1){G=k+(C<<3)|0;h[G>>3]=+h[G>>3]+1.0e-6;+KAa(b,1.0);G=c[n>>2]|0;y=(G|0)>0;if(y){z$a(q|0,c[f>>2]|0,((G|0)>1?G<<3:8)|0)|0}z=c[m>>2]|0;if((z|0)>0){F=c[A>>2]|0;I=0;J=0;while(1){if((a[F+(J*112|0)+88|0]|0)==0){K=I}else{h[u+(I<<3)>>3]=+h[F+(J*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(J<<3)>>3];K=I+1|0}L=J+1|0;if((L|0)<(z|0)){I=K;J=L}else{M=K;break}}}else{M=0}J=c[B>>2]|0;if((J|0)>0){I=c[x>>2]|0;F=M;L=0;while(1){do{if((a[I+(L*112|0)+88|0]|0)==0){N=F}else{if((a[I+(L*112|0)+72|0]|0)!=0){N=F;break}h[u+(F<<3)>>3]=+h[I+(L*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(L<<3)>>3];N=F+1|0}}while(0);O=L+1|0;if((O|0)<(J|0)){F=N;L=O}else{P=N;break}}}else{P=M}L=c[D>>2]|0;if((L|0)>0){F=c[A>>2]|0;J=P;I=z-L|0;while(1){do{if((a[F+(I*112|0)+88|0]|0)==0){Q=J}else{if((a[F+(I*112|0)+72|0]|0)!=0){Q=J;break}h[u+(J<<3)>>3]=+h[F+(I*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(I<<3)>>3];Q=J+1|0}}while(0);L=I+1|0;if((L|0)<(z|0)){J=Q;I=L}else{break}}}if(y){R=+h[(c[g>>2]|0)+(C<<3)>>3];I=0;do{S=+U(+(R*(+h[q+(I<<3)>>3]- +h[p+(I<<3)>>3])/1.0e-6));J=v+(I<<3)|0;if(S>+h[J>>3]){h[J>>3]=S}I=I+1|0;}while((I|0)<(G|0))}I=c[r>>2]|0;if((I|0)>0){R=+h[(c[g>>2]|0)+(C<<3)>>3];y=0;do{S=+U(+(R*(+h[u+(y<<3)>>3]- +h[t+(y<<3)>>3])/1.0e-6));J=w+(y<<3)|0;if(S>+h[J>>3]){h[J>>3]=S}y=y+1|0;}while((y|0)<(I|0))}I=c[E>>2]|0;y=I+(C<<3)|0;h[y>>3]=+h[y>>3]+-1.0e-6;y=C+1|0;if((y|0)<(c[H>>2]|0)){k=I;C=y}else{T=G;break}}}else{T=s}if((T|0)>0){s=T;T=0;while(1){R=+h[v+(T<<3)>>3];C=(c[j>>2]|0)+(T<<3)|0;if(R<1.0e-42){h[C>>3]=1.0;k=T+1|0;c[e>>2]=k;hwa(9,0,246960,e);V=k;W=c[n>>2]|0}else{h[C>>3]=R;V=T+1|0;W=s}if((V|0)<(W|0)){s=W;T=V}else{break}}}V=c[r>>2]|0;if((V|0)>0){r=c[l>>2]|0;l=0;do{R=+h[w+(l<<3)>>3];h[r+(l<<3)>>3]=R<1.0e-42?1.0:R;l=l+1|0;}while((l|0)<(V|0))}W_a(p);W_a(q);W_a(t);W_a(u);W_a(v);W_a(w);i=d;return}function XAa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a>>2]|0;if((e|0)<=0){i=d;return}f=c[a+24>>2]|0;a=0;do{h[f+(a<<3)>>3]=+h[b+(a<<3)>>3];a=a+1|0;}while((a|0)<(e|0));i=d;return}function YAa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0;d=i;e=c[a>>2]|0;if((e|0)<=0){i=d;return}f=c[a+40>>2]|0;g=(f|0)==0;j=c[a+24>>2]|0;a=0;do{k=+h[b+(a<<3)>>3];if(g){l=k}else{l=k*+h[f+(a<<3)>>3]}h[j+(a<<3)>>3]=l;a=a+1|0;}while((a|0)<(e|0));i=d;return}function ZAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;e=c[b+60>>2]|0;f=c[e+112>>2]|0;if((f|0)>0){g=b+24|0;j=c[e+8>>2]|0;k=0;l=0;while(1){if((a[j+(k*112|0)+72|0]|0)==0){h[(c[(c[c[e+4>>2]>>2]|0)+8>>2]|0)+(k<<3)>>3]=+h[(c[g>>2]|0)+(l<<3)>>3];m=l+1|0}else{m=l}n=k+1|0;if((n|0)<(f|0)){k=n;l=m}else{o=m;break}}}else{o=0}m=c[e+136>>2]|0;if((m|0)>0){l=b+24|0;k=c[e+24>>2]|0;f=0;g=o;while(1){if((a[k+(f*112|0)+72|0]|0)==0){h[(c[e+416>>2]|0)+(f<<3)>>3]=+h[(c[l>>2]|0)+(g<<3)>>3];p=g+1|0}else{p=g}j=f+1|0;if((j|0)<(m|0)){f=j;g=p}else{q=p;break}}}else{q=o}o=c[e+116>>2]|0;p=c[e+120>>2]|0;if((p|0)<=0){i=d;return}g=b+24|0;b=c[e+8>>2]|0;f=o-p|0;p=q;while(1){if((a[b+(f*112|0)+72|0]|0)==0){h[(c[e+400>>2]|0)+(f<<3)>>3]=+h[(c[g>>2]|0)+(p<<3)>>3];r=p+1|0}else{r=p}q=f+1|0;if((q|0)<(o|0)){f=q;p=r}else{break}}i=d;return}function _Aa(a,b,d){a=a|0;b=b|0;d=d|0;d=i;i=i+8|0;lwa(c[a+536>>2]|0,247032,d);return 0}function $Aa(a){a=a|0;a=i;i=i+8|0;lwa(0,247064,a);return 0}function aBa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;c[d>>2]=(c[206180>>2]|0)!=0?1e3:0;k=a;l=c[k>>2]|0;c[e>>2]=l*1e3;h[f>>3]=1.0e-12;h[g>>3]=10.0;m=l<<1|1;c[j>>2]=m;n=X_a((fa(m+13|0,m+l|0)|0)+((fa(l*3|0,l+3|0)|0)/2|0)|0,8)|0;kwa(0,(n|0)!=0|0,247104,b);c[61780]=c[a+60>>2];c[61782]=c[a+48>>2];zya(k,j,c[a+24>>2]|0,g,f,d,e,n,6)|0;W_a(n);c[61780]=0;c[61782]=0;n=JAa(a)|0;i=b;return n|0}function bBa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=-1;c[f+8>>2]=-1;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=b;b=f+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[f+48>>2]=c[61782];c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=c[61780];h[d>>3]=+KAa(f,1.0);i=e;return}function cBa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;h[o>>3]=0.0;h[p>>3]=0.0;h[q>>3]=0.0;c[r>>2]=0;c[s>>2]=0;c[t>>2]=0;c[u>>2]=0;c[v>>2]=0;w=a;x=c[w>>2]<<3;y=V_a(x)|0;z=y;A=V_a(x)|0;x=A;kwa(0,(y|0)!=0|0,247136,n);kwa(0,(A|0)!=0|0,247136,m);m=c[w>>2]|0;if((m|0)>0){n=c[a+24>>2]|0;B=0;do{C=+h[n+(B<<3)>>3];if(C!=0.0){D=+U(+C)/1.0e3}else{D=1.0}h[y+(B<<3)>>3]=D;h[A+(B<<3)>>3]=0.0;B=B+1|0;}while((B|0)<(m|0))}B=m*1e3|0;c[v>>2]=B;if((c[206180>>2]|0)==0){E=-1}else{E=(B|0)/10|0}c[r>>2]=E;h[p>>3]=1.0e-12;c[s>>2]=m;c[t>>2]=0;h[q>>3]=1.0e-12;D=+KAa(a,1.0);h[o>>3]=D;if(D!=0.0){c[61788]=c[a+60>>2];c[61790]=c[a+48>>2];wya(c[a+24>>2]|0,z,w,o,v,r,p,s,t,q,x,7,u)|0;c[61788]=0;c[61790]=0}else{x=l;h[k>>3]=D;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];hwa(9,0,247168,l)}D=+KAa(a,1.0);h[o>>3]=D;l=j;h[k>>3]=D;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];hwa(9,0,247272,j);j=c[u>>2]|0;do{if((j|0)==2){jwa(9,0,247368,f);F=-2;i=b;return F|0}else if((j|0)==1){if(!(+h[q>>3]<+h[o>>3])){break}c[g>>2]=c[v>>2];jwa(9,0,247288,g);F=-1;i=b;return F|0}else if((j|0)==4){jwa(9,0,247504,d);F=-4;i=b;return F|0}else if((j|0)==3){jwa(9,0,247432,e);F=-3;i=b;return F|0}}while(0);F=JAa(a)|0;i=b;return F|0}function dBa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=-1;c[f+8>>2]=-1;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=b;b=f+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[f+48>>2]=c[61790];c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=c[61788];h[d>>3]=+KAa(f,1.0);i=e;return}function eBa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=fa(d*1e3|0,c[a>>2]|0)|0;c[j>>2]=0;hwa(9,1,247560,g);if((c[206180>>2]|0)==0){l=0}else{l=(k|0)/10|0}fBa(a,d,k,l,b,j);c[f>>2]=c[j>>2];hwa(9,0,247584,f);le[c[51674]&2047](9);if(+h[b>>3]<1.0){m=-1;i=e;return m|0}b=JAa(a)|0;if((b|0)==0){m=0;i=e;return m|0}jwa(9,0,247600,e);m=b;i=e;return m|0}function fBa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0.0,Z=0,_=0,$=0,aa=0.0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0.0,Ca=0;j=i;i=i+8|0;l=j;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+24|0;v=i;i=i+32|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+4096|0;K=a;L=c[K>>2]|0;M=L+1|0;N=L<<3;O=V_a(fa(N,M)|0)|0;P=V_a(M<<3)|0;Q=V_a(N)|0;R=Q;S=V_a(N)|0;T=S;V=V_a(N)|0;W=V;X=V_a(N)|0;Y=+h[f>>3];if((c[206180>>2]|0)!=0&Y<1.0){N=J;c[I>>2]=c[(c[a+60>>2]|0)+88>>2];lc(N|0,247648,I|0)|0;I=mc(N|0,247664)|0;c[H>>2]=247680;Cd(I|0,247672,H|0)|0;c[G>>2]=247696;Cd(I|0,247672,G|0)|0;if((c[K>>2]|0)>0){G=a+44|0;H=0;do{c[F>>2]=c[(c[G>>2]|0)+(H<<2)>>2];Cd(I|0,247672,F|0)|0;H=H+1|0;}while((H|0)<(c[K>>2]|0))}Yd(10,I|0)|0;c[E>>2]=0;Cd(I|0,247704,E|0)|0;E=D;h[k>>3]=Y;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];Cd(I|0,247712,D|0)|0;if((c[K>>2]|0)>0){D=a+24|0;E=0;do{H=C;h[k>>3]=+h[(c[D>>2]|0)+(E<<3)>>3];c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];Cd(I|0,247712,C|0)|0;E=E+1|0;}while((E|0)<(c[K>>2]|0))}Yd(10,I|0)|0;Z=I}else{Z=0}kwa(0,(O|0)!=0|0,247720,B);kwa(0,(P|0)!=0|0,247720,A);kwa(0,(Q|0)!=0|0,247720,z);kwa(0,(S|0)!=0|0,247720,y);kwa(0,(V|0)!=0|0,247720,x);kwa(0,(X|0)!=0|0,247720,w);w=c[a+40>>2]|0;x=(L|0)>0;do{if((w|0)==0){if(!x){_=0;break}y=a+24|0;z=0;while(1){A=(c[y>>2]|0)+(z<<3)|0;B=0;do{h[O+((fa(B,L)|0)+z<<3)>>3]=+h[A>>3];B=B+1|0;}while((B|0)<(M|0));B=z+1|0;if((B|0)<(L|0)){z=B}else{$=14;break}}}else{if(!x){_=0;break}z=c[a+24>>2]|0;y=0;while(1){aa=+h[z+(y<<3)>>3]/+h[w+(y<<3)>>3];B=0;do{h[O+((fa(B,L)|0)+y<<3)>>3]=aa;B=B+1|0;}while((B|0)<(M|0));B=y+1|0;if((B|0)<(L|0)){y=B}else{$=14;break}}}}while(0);do{if(($|0)==14){w=(L|0)>0;if(w){ba=0}else{_=0;break}while(1){x=O+((fa(ba,L)|0)+ba<<3)|0;h[x>>3]=+h[x>>3]+1.0;x=ba+1|0;if((x|0)<(L|0)){ba=x}else{_=w;break}}}}while(0);ba=(L|0)>-1;w=a+16|0;aa=+(M|0);ca=+(L|0);x=(e|0)==0;y=a+48|0;da=1.0/+(b+ -1|0);b=(Z|0)==0;z=a+24|0;B=L<<3;ea=0.0;A=0;ga=Y;a:while(1){I=!(ga>=1.0);E=ga<1.0;ha=ea;C=A;b:while(1){D=C;c:while(1){ia=D+1|0;if(ba){H=0;do{YAa(a,O+((fa(H,L)|0)<<3)|0);h[P+(H<<3)>>3]=+KAa(a,ga);H=H+1|0;}while((H|0)<(M|0))}if(_){H=1;F=0;while(1){G=+h[P+(H<<3)>>3]<+h[P+(F<<3)>>3]?H:F;N=H+1|0;if((N|0)<(M|0)){F=G;H=N}else{ja=G;break}}}else{ja=0}ka=fa(ja,L)|0;la=O+(ka<<3)|0;YAa(a,la);+KAa(a,ga);H=c[w>>2]|0;if((H|0)>0){F=c[y>>2]|0;Y=0.0;G=0;do{ma=+U(+(+h[F+(G<<3)>>3]));Y=ma>Y?ma:Y;G=G+1|0;}while((G|0)<(H|0));na=!(Y<1.0e-12)}else{na=0}if(!((na|I)&(D|0)<(d|0))){break a}do{if(ba){H=0;G=ja;F=ja;while(1){ma=+h[P+(H<<3)>>3];N=ma>+h[P+(G<<3)>>3];oa=N?H:G;J=N?G:F;pa=!(ma>+h[P+(J<<3)>>3])|(H|0)==(oa|0)?J:H;J=H+1|0;if((J|0)<(M|0)){F=pa;G=oa;H=J}else{break}}if(ba){qa=0.0;ra=0}else{sa=0.0;ta=oa;ua=pa;break}do{qa=qa+ +h[P+(ra<<3)>>3];ra=ra+1|0;}while((ra|0)<(M|0));ma=qa/aa;if(ba){va=0.0;wa=0}else{sa=0.0;ta=oa;ua=pa;break}while(1){xa=+h[P+(wa<<3)>>3]-ma;ya=va+xa*xa;H=wa+1|0;if((H|0)<(M|0)){wa=H;va=ya}else{sa=ya;ta=oa;ua=pa;break}}}else{sa=0.0;ta=ja;ua=ja}}while(0);Y=sa/ca;do{if(!x){if(((ia|0)%(e|0)|0|0)!=0){break}ma=+h[P+(ja<<3)>>3];ya=+h[P+(ta<<3)>>3];H=v;h[k>>3]=ga;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];c[v+8>>2]=ia;H=v+12|0;h[k>>3]=ma;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=v+20|0;h[k>>3]=ya;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];hwa(9,0,247736,v)}}while(0);if(Y<1.0e-8&E){break b}if(_){B$a(X|0,0,B|0)|0}if(ba){H=0;do{if(!((H|0)==(ta|0)|_^1)){G=fa(H,L)|0;F=0;do{J=X+(F<<3)|0;h[J>>3]=+h[O+(F+G<<3)>>3]+ +h[J>>3];F=F+1|0;}while((F|0)<(L|0))}H=H+1|0;}while((H|0)<(M|0))}do{if(_){H=0;do{F=X+(H<<3)|0;h[F>>3]=+h[F>>3]/ca;H=H+1|0;}while((H|0)<(L|0));if(!_){break}H=fa(ta,L)|0;F=0;do{Y=+h[X+(F<<3)>>3];h[Q+(F<<3)>>3]=Y+(Y- +h[O+(F+H<<3)>>3]);F=F+1|0;}while((F|0)<(L|0))}}while(0);YAa(a,R);za=+KAa(a,ga);Y=+h[P+(ja<<3)>>3];do{if(Y<=za){if(!(za<=+h[P+(ua<<3)>>3])){break}if(!_){Aa=ia;D=Aa;continue c}z$a(O+(fa(B,ta)|0)|0,Q|0,B|0)|0;Aa=ia;D=Aa;continue c}}while(0);if(!(za<=Y)){break}if(_){F=0;do{ya=+h[X+(F<<3)>>3];h[S+(F<<3)>>3]=ya+(+h[Q+(F<<3)>>3]-ya)*2.0;F=F+1|0;}while((F|0)<(L|0))}YAa(a,T);if(+KAa(a,ga)<za){if(!_){Aa=ia;D=Aa;continue}z$a(O+(fa(B,ta)|0)|0,S|0,B|0)|0;Aa=ia;D=Aa;continue}else{if(!_){Aa=ia;D=Aa;continue}z$a(O+(fa(B,ta)|0)|0,Q|0,B|0)|0;Aa=ia;D=Aa;continue}}if(!(+h[P+(ua<<3)>>3]<=za)){$=89;break a}Y=+h[P+(ta<<3)>>3];if(!(za>=Y)){if(_){D=0;do{ya=+h[X+(D<<3)>>3];h[V+(D<<3)>>3]=ya+(+h[Q+(D<<3)>>3]-ya)*.5;D=D+1|0;}while((D|0)<(L|0))}YAa(a,W);Ba=+KAa(a,ga)}else{if(_){D=fa(ta,L)|0;F=0;do{ya=+h[X+(F<<3)>>3];h[V+(F<<3)>>3]=ya+(+h[O+(F+D<<3)>>3]-ya)*.5;F=F+1|0;}while((F|0)<(L|0))}YAa(a,W);Ba=+KAa(a,ga)}if(Ba<Y){if(!_){ha=Ba;C=ia;continue}z$a(O+(fa(B,ta)|0)|0,V|0,B|0)|0;ha=Ba;C=ia;continue}if(ba){Ca=0}else{ha=Ba;C=ia;continue}while(1){if(_){F=fa(Ca,L)|0;D=0;do{H=O+(D+F<<3)|0;h[H>>3]=(+h[H>>3]+ +h[O+(D+ka<<3)>>3])*.5;D=D+1|0;}while((D|0)<(L|0))}D=Ca+1|0;if((D|0)<(M|0)){Ca=D}else{ha=Ba;C=ia;continue b}}}Y=ga+da;ya=Y>1.0?1.0:Y;Y=+h[P+(ja<<3)>>3];C=u;h[k>>3]=ya;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[u+8>>2]=ia;C=u+12|0;h[k>>3]=Y;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];hwa(9,0,247776,u);if(b){ea=ha;A=ia;ga=ya;continue}c[t>>2]=ia;Cd(Z|0,247704,t|0)|0;C=s;h[k>>3]=ya;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];Cd(Z|0,247712,s|0)|0;if((c[K>>2]|0)>0){C=0;do{E=r;h[k>>3]=+h[(c[z>>2]|0)+(C<<3)>>3];c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];Cd(Z|0,247712,r|0)|0;C=C+1|0;}while((C|0)<(c[K>>2]|0))}Yd(10,Z|0)|0;ea=ha;A=ia;ga=ya}if(($|0)==89){$=q;h[k>>3]=za;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];jwa(9,0,247824,q);q=p;h[k>>3]=ha;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];jwa(9,0,247840,p);lwa(0,247856,o)}YAa(a,la);if((f|0)!=0){h[f>>3]=ga}if((g|0)!=0){c[g>>2]=ia}if(b){W_a(S);W_a(Q);W_a(V);W_a(X);W_a(P);W_a(O);i=j;return}c[n>>2]=ia;Cd(Z|0,247704,n|0)|0;n=m;h[k>>3]=ga;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Cd(Z|0,247712,m|0)|0;if((c[K>>2]|0)>0){m=0;do{n=l;h[k>>3]=+h[(c[z>>2]|0)+(m<<3)>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Cd(Z|0,247712,l|0)|0;m=m+1|0;}while((m|0)<(c[K>>2]|0))}Yd(10,Z|0)|0;ad(Z|0)|0;W_a(S);W_a(Q);W_a(V);W_a(X);W_a(P);W_a(O);i=j;return}function gBa(a,b){a=a|0;b=b|0;i=i;return}function hBa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=c[b+12>>2]|0;Bxa(3);Exa(0);w=+wxa(0);Bxa(0);x=d+4|0;y=u;h[k>>3]=+h[c[c[x>>2]>>2]>>3];c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];Cd(v|0,247936,u|0)|0;if((c[b+8>>2]|0)!=0){b=t;h[k>>3]=w;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];Cd(v|0,247936,t|0)|0}t=d+116|0;b=c[t>>2]|0;if((b|0)>0){u=d+8|0;y=b;b=0;while(1){if((a[(c[u>>2]|0)+(b*112|0)+104|0]|0)==0){z=s;h[k>>3]=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(b<<3)>>3];c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Cd(v|0,247936,s|0)|0;A=c[t>>2]|0}else{A=y}z=b+1|0;if((z|0)<(A|0)){y=A;b=z}else{break}}}b=d+124|0;A=c[b>>2]|0;if((A|0)>0){y=d+12|0;t=A;A=0;while(1){if((a[(c[y>>2]|0)+(A*60|0)+56|0]|0)==0){c[r>>2]=c[(c[(c[c[x>>2]>>2]|0)+12>>2]|0)+(A<<2)>>2];Cd(v|0,247944,r|0)|0;B=c[b>>2]|0}else{B=t}s=A+1|0;if((s|0)<(B|0)){t=B;A=s}else{break}}}A=d+128|0;B=c[A>>2]|0;if((B|0)>0){t=d+16|0;b=B;B=0;while(1){if((a[(c[t>>2]|0)+(B*48|0)+44|0]|0)==0){c[q>>2]=a[(c[(c[c[x>>2]>>2]|0)+16>>2]|0)+B|0]|0;Cd(v|0,247944,q|0)|0;C=c[A>>2]|0}else{C=b}r=B+1|0;if((r|0)<(C|0)){b=C;B=r}else{break}}}B=d+132|0;C=c[B>>2]|0;if((C|0)>0){b=d+20|0;A=C;C=0;while(1){if((a[(c[b>>2]|0)+(C*52|0)+48|0]|0)==0){c[p>>2]=c[(c[(c[c[x>>2]>>2]|0)+20>>2]|0)+(C<<2)>>2];Cd(v|0,247952,p|0)|0;D=c[B>>2]|0}else{D=A}q=C+1|0;if((q|0)<(D|0)){A=D;C=q}else{break}}}C=d+216|0;if((c[C>>2]|0)>0){D=d+40|0;A=0;do{B=c[D>>2]|0;do{if((a[B+(A*52|0)+48|0]|0)==0){p=a[B+(A*52|0)+8|0]|0;if(p<<24>>24==1){break}else if(p<<24>>24==2){E=c[c[x>>2]>>2]|0}else{E=(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(c[B+(A*52|0)+4>>2]<<3)|0}w=+h[E>>3];if((c[B+(A*52|0)>>2]|0)==0){p=n;h[k>>3]=w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];Cd(v|0,247936,n|0)|0;break}else{p=o;h[k>>3]=-w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];Cd(v|0,247936,o|0)|0;break}}}while(0);A=A+1|0;}while((A|0)<(c[C>>2]|0))}C=d+220|0;if((c[C>>2]|0)>0){A=d+44|0;o=0;do{n=c[A>>2]|0;do{if((a[n+(o*52|0)+48|0]|0)==0){if((a[n+(o*52|0)+8|0]|0)==1){break}E=c[(c[(c[c[x>>2]>>2]|0)+12>>2]|0)+(c[n+(o*52|0)+4>>2]<<2)>>2]|0;if((c[n+(o*52|0)>>2]|0)==0){c[l>>2]=E;Cd(v|0,247944,l|0)|0;break}else{c[m>>2]=0-E;Cd(v|0,247944,m|0)|0;break}}}while(0);o=o+1|0;}while((o|0)<(c[C>>2]|0))}C=d+224|0;if((c[C>>2]|0)>0){o=d+48|0;m=0;do{l=c[o>>2]|0;do{if((a[l+(m*52|0)+48|0]|0)==0){if((a[l+(m*52|0)+8|0]|0)==1){break}A=a[(c[(c[c[x>>2]>>2]|0)+16>>2]|0)+(c[l+(m*52|0)+4>>2]|0)|0]|0;if((c[l+(m*52|0)>>2]|0)==0){c[g>>2]=A<<24>>24;Cd(v|0,247944,g|0)|0;break}else{c[j>>2]=A<<24>>24!=1;Cd(v|0,247944,j|0)|0;break}}}while(0);m=m+1|0;}while((m|0)<(c[C>>2]|0))}C=d+228|0;m=c[C>>2]|0;if((m|0)<=0){F=Yd(10,v|0)|0;Exa(3);i=e;return}j=d+52|0;d=m;m=0;while(1){g=c[j>>2]|0;do{if((a[g+(m*52|0)+48|0]|0)==0){if((a[g+(m*52|0)+8|0]|0)==1){G=d;break}c[f>>2]=c[(c[(c[c[x>>2]>>2]|0)+20>>2]|0)+(c[g+(m*52|0)+4>>2]<<2)>>2];Cd(v|0,247952,f|0)|0;G=c[C>>2]|0}else{G=d}}while(0);g=m+1|0;if((g|0)<(G|0)){d=G;m=g}else{break}}F=Yd(10,v|0)|0;Exa(3);i=e;return}function iBa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=b;s=mc(c[r>>2]|0,247960)|0;t=c[d+536>>2]|0;u=c[r>>2]|0;r=ae(c[(Qc()|0)>>2]|0)|0;c[q>>2]=u;c[q+4>>2]=r;kwa(t,(s|0)!=0|0,247968,q);c[p>>2]=248024;Cd(s|0,247952,p|0)|0;if((c[b+8>>2]|0)!=0){c[o>>2]=248032;Cd(s|0,247952,o|0)|0}o=d+116|0;p=c[o>>2]|0;if((p|0)>0){q=d+8|0;t=p;p=0;while(1){r=c[q>>2]|0;if((a[r+(p*112|0)+104|0]|0)==0){c[n>>2]=c[r+(p*112|0)+4>>2];Cd(s|0,247952,n|0)|0;v=c[o>>2]|0}else{v=t}r=p+1|0;if((r|0)<(v|0)){t=v;p=r}else{break}}}p=d+124|0;v=c[p>>2]|0;if((v|0)>0){t=d+12|0;o=v;v=0;while(1){n=c[t>>2]|0;if((a[n+(v*60|0)+56|0]|0)==0){c[m>>2]=c[n+(v*60|0)+4>>2];Cd(s|0,247952,m|0)|0;w=c[p>>2]|0}else{w=o}n=v+1|0;if((n|0)<(w|0)){o=w;v=n}else{break}}}v=d+128|0;w=c[v>>2]|0;if((w|0)>0){o=d+16|0;p=w;w=0;while(1){m=c[o>>2]|0;if((a[m+(w*48|0)+44|0]|0)==0){c[l>>2]=c[m+(w*48|0)+4>>2];Cd(s|0,247952,l|0)|0;x=c[v>>2]|0}else{x=p}m=w+1|0;if((m|0)<(x|0)){p=x;w=m}else{break}}}w=d+132|0;x=c[w>>2]|0;if((x|0)>0){p=d+20|0;v=x;x=0;while(1){l=c[p>>2]|0;if((a[l+(x*52|0)+48|0]|0)==0){c[k>>2]=c[l+(x*52|0)+4>>2];Cd(s|0,247952,k|0)|0;y=c[w>>2]|0}else{y=v}l=x+1|0;if((l|0)<(y|0)){v=y;x=l}else{break}}}x=d+216|0;y=c[x>>2]|0;if((y|0)>0){v=d+40|0;w=y;y=0;while(1){k=c[v>>2]|0;do{if((a[k+(y*52|0)+48|0]|0)==0){if((a[k+(y*52|0)+8|0]|0)==1){z=w;break}c[j>>2]=c[k+(y*52|0)+16>>2];Cd(s|0,247952,j|0)|0;z=c[x>>2]|0}else{z=w}}while(0);k=y+1|0;if((k|0)<(z|0)){w=z;y=k}else{break}}}y=d+220|0;z=c[y>>2]|0;if((z|0)>0){w=d+44|0;x=z;z=0;while(1){j=c[w>>2]|0;do{if((a[j+(z*52|0)+48|0]|0)==0){if((a[j+(z*52|0)+8|0]|0)==1){A=x;break}c[h>>2]=c[j+(z*52|0)+16>>2];Cd(s|0,247952,h|0)|0;A=c[y>>2]|0}else{A=x}}while(0);j=z+1|0;if((j|0)<(A|0)){x=A;z=j}else{break}}}z=d+224|0;A=c[z>>2]|0;if((A|0)>0){x=d+48|0;y=A;A=0;while(1){h=c[x>>2]|0;do{if((a[h+(A*52|0)+48|0]|0)==0){if((a[h+(A*52|0)+8|0]|0)==1){B=y;break}c[g>>2]=c[h+(A*52|0)+16>>2];Cd(s|0,247952,g|0)|0;B=c[z>>2]|0}else{B=y}}while(0);h=A+1|0;if((h|0)<(B|0)){y=B;A=h}else{break}}}A=d+228|0;B=c[A>>2]|0;if((B|0)<=0){C=Yd(10,s|0)|0;D=s;E=b;F=E+12|0;G=F;c[G>>2]=D;i=e;return}y=d+52|0;d=B;B=0;while(1){z=c[y>>2]|0;do{if((a[z+(B*52|0)+48|0]|0)==0){if((a[z+(B*52|0)+8|0]|0)==1){H=d;break}c[f>>2]=c[z+(B*52|0)+16>>2];Cd(s|0,247952,f|0)|0;H=c[A>>2]|0}else{H=d}}while(0);z=B+1|0;if((z|0)<(H|0)){d=H;B=z}else{break}}C=Yd(10,s|0)|0;D=s;E=b;F=E+12|0;G=F;c[G>>2]=D;i=e;return}function jBa(a,b){a=a|0;b=b|0;var d=0;b=i;d=c[a+12>>2]|0;Bxa(3);ad(d|0)|0;Exa(3);i=b;return}function kBa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+104|0;e=d;f=d+16|0;g=d+32|0;j=d+40|0;k=d+48|0;l=d+56|0;m=d+72|0;n=d+88|0;o=c[a+12>>2]|0;c[k>>2]=0;p=o;fTa(l,p);q=o+184|0;r=m;c[r+0>>2]=c[q+0>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2];c[r+12>>2]=c[q+12>>2];q=f;r=m;c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];gTa(p,f)|0;lBa(b,k,g,j,+h[o+224>>3],+h[o+232>>3]);o=c[k>>2]|0;mBa(a,b,248048,c[j>>2]|0,c[g>>2]|0,o,8);W_a(o);c[k>>2]=0;k=n;o=l;c[k+0>>2]=c[o+0>>2];c[k+4>>2]=c[o+4>>2];c[k+8>>2]=c[o+8>>2];c[k+12>>2]=c[o+12>>2];o=e;k=n;c[o+0>>2]=c[k+0>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];c[o+12>>2]=c[k+12>>2];gTa(p,e)|0;i=d;return}function lBa(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=+j;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+8|0;c[e>>2]=2;l=b+136|0;m=b+140|0;n=b+144|0;o=(c[l>>2]|0)+1+(c[m>>2]|0)+(c[n>>2]|0)|0;c[f>>2]=o;p=X_a(fa(c[e>>2]|0,o)|0,8)|0;c[d>>2]=p;kwa(c[b+536>>2]|0,(p|0)!=0|0,248328,k);p=c[d>>2]|0;h[p>>3]=g;d=c[f>>2]|0;h[p+(d<<3)>>3]=j;f=c[l>>2]|0;if((f|0)>0){l=c[b+416>>2]|0;o=0;do{e=l+(o<<3)|0;o=o+1|0;h[p+(o<<3)>>3]=+h[e>>3];h[p+(d+o<<3)>>3]=+h[e>>3];}while((o|0)<(f|0))}o=f+1|0;f=c[m>>2]|0;if((f|0)>0){m=c[b+420>>2]|0;l=0;do{j=+(c[m+(l<<2)>>2]|0);e=l+o|0;h[p+(e<<3)>>3]=j;h[p+(d+e<<3)>>3]=j;l=l+1|0;}while((l|0)<(f|0))}l=f+o|0;o=c[n>>2]|0;if((o|0)<=0){i=k;return}n=c[b+424>>2]|0;b=0;do{f=n+b|0;m=l+b|0;h[p+(m<<3)>>3]=+(a[f]|0);h[p+(d+m<<3)>>3]=+(a[f]|0);b=b+1|0;}while((b|0)<(o|0));i=k;return}function mBa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;i=i+8|0;k=j;l=c[a+12>>2]|0;xBa(a,b,d,e,f,h);eTa(l,g,fa(fa(f,e)|0,h)|0)|0;if(BRa(l+(c[(c[l>>2]|0)+ -12>>2]|0)|0)|0){l=c[b+536>>2]|0;c[k>>2]=c[a>>2];lwa(l,248280,k)}else{i=j;return}}function nBa(a){a=a|0;var b=0;b=i;if((pCa(a+4|0)|0)!=0){i=b;return}ERa(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,4);i=b;return}function oBa(a){a=a|0;Uc(a|0)|0;_c()}function pBa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=$_a(320)|0;B$a(q|0,0,320)|0;qBa(q);r=a+12|0;c[r>>2]=q;s=(c[b+140>>2]|0)+(c[b+136>>2]|0)+(c[b+144>>2]|0)|0;c[f>>2]=0;c[k>>2]=0;c[l>>2]=0;Bxa(3);t=a+8|0;u=rBa(c[t>>2]|0,c[r>>2]|0,b)|0;r=q+316|0;c[r>>2]=u;v=sBa(a,b,u+s|0)|0;u=q+184|0;tBa(m,-1,-1);w=m;c[u+0>>2]=c[w+0>>2];c[u+4>>2]=c[w+4>>2];c[u+8>>2]=c[w+8>>2];c[u+12>>2]=c[w+12>>2];w=q+200|0;tBa(n,-1,-1);m=n;c[w+0>>2]=c[m+0>>2];c[w+4>>2]=c[m+4>>2];c[w+8>>2]=c[m+8>>2];c[w+12>>2]=c[m+12>>2];c[q+216>>2]=0;m=q+224|0;h[m>>3]=+h[b+240>>3];n=q+232|0;h[n>>3]=+h[b+248>>3];x=a;uBa(q,c[x>>2]|0,36);if(BRa(q+(c[(c[q>>2]|0)+ -12>>2]|0)|0)|0){y=c[b+536>>2]|0;c[e>>2]=c[x>>2];lwa(y,248104,e)}else{mBa(a,b,248136,4,11,248056,1);vBa((c[r>>2]|0)+s|0,v,f,g,j,0,0)|0;e=c[f>>2]|0;mBa(a,b,248144,c[g>>2]|0,c[j>>2]|0,e,1);W_a(e);c[f>>2]=0;vBa((c[r>>2]|0)+s|0,v,f,g,j,0,1)|0;e=c[f>>2]|0;mBa(a,b,248152,c[g>>2]|0,c[j>>2]|0,e,1);W_a(e);c[f>>2]=0;wBa(a,b,k,g,j,c[r>>2]|0,s);mBa(a,b,248168,c[j>>2]|0,c[g>>2]|0,c[k>>2]|0,4);s=q;fTa(o,s);r=o;c[u+0>>2]=c[r+0>>2];c[u+4>>2]=c[r+4>>2];c[u+8>>2]=c[r+8>>2];c[u+12>>2]=c[r+12>>2];lBa(b,l,g,j,+h[m>>3],+h[n>>3]);n=c[l>>2]|0;mBa(a,b,248048,c[j>>2]|0,c[g>>2]|0,n,8);fTa(p,s);g=p;c[w+0>>2]=c[g+0>>2];c[w+4>>2]=c[g+4>>2];c[w+8>>2]=c[g+8>>2];c[w+12>>2]=c[g+12>>2];g=yBa(q+240|0)|0;w=yBa(q+264|0)|0;p=yBa(q+288|0)|0;xBa(a,b,248184,g+1+w+p+(c[q+312>>2]|0)+(c[t>>2]|0)|0,0,8);W_a(n);W_a(c[k>>2]|0);c[l>>2]=0;c[k>>2]=0;MSa(s)|0;W_a(v);Exa(3);i=d;return}}function qBa(a){a=a|0;var b=0;b=i;zEa(a);i=b;return}function rBa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;i=i+24|0;g=f;h=f+8|0;j=f+16|0;k=(b|0)==0?1:2;c[g>>2]=0;b=e+116|0;l=c[b>>2]|0;if((l|0)>0){m=e+8|0;n=d+240|0;o=l;l=0;p=k;while(1){if((a[(c[m>>2]|0)+(l*112|0)+104|0]|0)==0){c[(DDa(n,g)|0)>>2]=p;q=c[b>>2]|0;r=c[g>>2]|0;s=p+1|0}else{q=o;r=l;s=p}t=r+1|0;c[g>>2]=t;if((t|0)<(q|0)){o=q;l=t;p=s}else{u=s;break}}}else{u=k}c[h>>2]=0;k=e+124|0;s=c[k>>2]|0;if((s|0)>0){p=e+12|0;l=d+264|0;q=s;s=0;o=u;while(1){if((a[(c[p>>2]|0)+(s*60|0)+56|0]|0)==0){c[(DDa(l,h)|0)>>2]=o;v=c[k>>2]|0;w=c[h>>2]|0;x=o+1|0}else{v=q;w=s;x=o}g=w+1|0;c[h>>2]=g;if((g|0)<(v|0)){q=v;s=g;o=x}else{y=x;break}}}else{y=u}c[j>>2]=0;u=e+128|0;x=c[u>>2]|0;if((x|0)>0){o=e+16|0;s=d+288|0;v=x;x=0;q=y;while(1){if((a[(c[o>>2]|0)+(x*48|0)+44|0]|0)==0){c[(DDa(s,j)|0)>>2]=q;z=c[u>>2]|0;A=c[j>>2]|0;B=q+1|0}else{z=v;A=x;B=q}h=A+1|0;c[j>>2]=h;if((h|0)<(z|0)){v=z;x=h;q=B}else{C=B;break}}}else{C=y}y=c[e+216>>2]|0;if((y|0)>0){B=c[e+40>>2]|0;q=0;x=C;while(1){z=((a[B+(q*52|0)+48|0]|0)==0)+x|0;v=q+1|0;if((v|0)<(y|0)){x=z;q=v}else{D=z;break}}}else{D=C}C=c[e+220>>2]|0;if((C|0)>0){q=c[e+44>>2]|0;x=0;y=D;while(1){B=((a[q+(x*52|0)+48|0]|0)==0)+y|0;z=x+1|0;if((z|0)<(C|0)){y=B;x=z}else{E=B;break}}}else{E=D}D=d+312|0;c[D>>2]=0;d=c[e+224>>2]|0;if((d|0)<=0){F=E;i=f;return F|0}x=c[e+48>>2]|0;e=0;y=0;C=E;while(1){if((a[x+(y*52|0)+48|0]|0)==0){if((c[x+(y*52|0)>>2]|0)==0){G=e}else{E=e+1|0;c[D>>2]=E;G=E}H=G;I=C+1|0}else{H=e;I=C}E=y+1|0;if((E|0)<(d|0)){e=H;y=E;C=I}else{F=I;break}}i=f;return F|0}function sBa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+24|0;g=f;h=f+8|0;j=f+16|0;k=c[b+12>>2]|0;l=V_a(e<<2)|0;e=l;c[l>>2]=248736;if((c[b+8>>2]|0)==0){m=1}else{c[l+4>>2]=248776;m=2}b=c[d+116>>2]|0;if((b|0)>0){n=c[d+8>>2]|0;o=m;p=0;while(1){if((a[n+(p*112|0)+104|0]|0)==0){c[l+(o<<2)>>2]=n+(p*112|0);q=o+1|0}else{q=o}r=p+1|0;if((r|0)<(b|0)){o=q;p=r}else{s=q;break}}}else{s=m}m=c[d+124>>2]|0;if((m|0)>0){q=c[d+12>>2]|0;p=s;o=0;while(1){if((a[q+(o*60|0)+56|0]|0)==0){c[l+(p<<2)>>2]=q+(o*60|0);t=p+1|0}else{t=p}b=o+1|0;if((b|0)<(m|0)){p=t;o=b}else{u=t;break}}}else{u=s}s=c[d+128>>2]|0;if((s|0)>0){t=c[d+16>>2]|0;o=u;p=0;while(1){if((a[t+(p*48|0)+44|0]|0)==0){c[l+(o<<2)>>2]=t+(p*48|0);v=o+1|0}else{v=o}m=p+1|0;if((m|0)<(s|0)){o=v;p=m}else{w=v;break}}}else{w=u}u=c[d+216>>2]|0;if((u|0)>0){v=c[d+40>>2]|0;p=w;o=0;while(1){if((a[v+(o*52|0)+48|0]|0)==0){c[l+(p<<2)>>2]=v+(o*52|0)+12;x=p+1|0}else{x=p}s=o+1|0;if((s|0)<(u|0)){p=x;o=s}else{y=x;break}}}else{y=w}w=c[d+220>>2]|0;if((w|0)>0){x=c[d+44>>2]|0;o=y;p=0;while(1){if((a[x+(p*52|0)+48|0]|0)==0){c[l+(o<<2)>>2]=x+(p*52|0)+12;z=o+1|0}else{z=o}u=p+1|0;if((u|0)<(w|0)){o=z;p=u}else{A=z;break}}}else{A=y}y=c[d+224>>2]|0;if((y|0)>0){z=c[d+48>>2]|0;p=A;o=0;while(1){if((a[z+(o*52|0)+48|0]|0)==0){c[l+(p<<2)>>2]=z+(o*52|0)+12;B=p+1|0}else{B=p}w=o+1|0;if((w|0)<(y|0)){p=B;o=w}else{C=B;break}}}else{C=A}c[g>>2]=0;A=d+136|0;if((c[A>>2]|0)>0){B=d+24|0;o=k+252|0;p=C;y=0;z=1;while(1){w=p+1|0;c[l+(p<<2)>>2]=(c[B>>2]|0)+(y*112|0);c[(DDa(o,g)|0)>>2]=z;x=z+1|0;u=(c[g>>2]|0)+1|0;c[g>>2]=u;if((u|0)<(c[A>>2]|0)){z=x;y=u;p=w}else{D=w;E=x;break}}}else{D=C;E=1}c[h>>2]=0;C=d+140|0;if((c[C>>2]|0)>0){p=d+28|0;y=k+276|0;z=D;A=0;g=E;while(1){o=z+1|0;c[l+(z<<2)>>2]=(c[p>>2]|0)+(A*60|0);c[(DDa(y,h)|0)>>2]=g;B=g+1|0;x=(c[h>>2]|0)+1|0;c[h>>2]=x;if((x|0)<(c[C>>2]|0)){g=B;A=x;z=o}else{F=o;G=B;break}}}else{F=D;G=E}c[j>>2]=0;E=d+144|0;if((c[E>>2]|0)<=0){i=f;return e|0}D=d+32|0;d=k+300|0;k=F;F=0;z=G;while(1){c[l+(k<<2)>>2]=(c[D>>2]|0)+(F*48|0);c[(DDa(d,j)|0)>>2]=z;G=(c[j>>2]|0)+1|0;c[j>>2]=G;if((G|0)<(c[E>>2]|0)){z=z+1|0;F=G;k=k+1|0}else{break}}i=f;return e|0}function tBa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;oCa(a,b,c);i=d;return}function uBa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=(nCa(a+4|0,b,d|16)|0)==0;d=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;if(f){ERa(d,4);i=e;return}else{CRa(d,0);i=e;return}}function vBa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;j=i;i=i+8|0;k=j;l=i;i=i+8|0;c[f>>2]=a;c[e>>2]=0;m=(a|0)>0;do{if(m){n=0;o=0;while(1){p=c[b+(o<<2)>>2]|0;q=x$a(c[(h?p+8|0:p+4|0)>>2]|0)|0;if((q|0)>(n|0)){c[e>>2]=q;r=q}else{r=n}q=o+1|0;if((q|0)<(a|0)){n=r;o=q}else{break}}o=X_a((fa(c[f>>2]|0,r)|0)+1|0,1)|0;c[d>>2]=o;kwa(0,(o|0)!=0|0,248256,l);if(!m){break}o=c[e>>2]|0;n=0;q=c[d>>2]|0;while(1){p=b+(n<<2)|0;s=c[p>>2]|0;I$a(q|0,c[(h?s+8|0:s+4|0)>>2]|0,o+1|0)|0;if(g){s=c[p>>2]|0;CBa(q,x$a(c[(h?s+8|0:s+4|0)>>2]|0)|0)}s=c[e>>2]|0;p=n+1|0;if((p|0)<(a|0)){o=s;n=p;q=q+s|0}else{t=s;break}}u=c[f>>2]|0;v=fa(u,t)|0;i=j;return v|0}else{q=X_a(1,1)|0;c[d>>2]=q;kwa(0,(q|0)!=0|0,248256,k)}}while(0);t=c[e>>2]|0;u=c[f>>2]|0;v=fa(u,t)|0;i=j;return v|0}function wBa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=c[b+12>>2]|0;c[f>>2]=j+h;c[g>>2]=4;g=X_a(c[f>>2]<<2,4)|0;c[e>>2]=g;kwa(c[d+536>>2]|0,(g|0)!=0|0,248304,k);g=s+240|0;f=yBa(g)|0;h=s+264|0;t=yBa(h)|0;u=s+288|0;v=yBa(u)|0;w=b+8|0;if((f+1+t+v|0)==(0-(c[w>>2]|0)|0)){x=0;y=1}else{v=c[e>>2]|0;t=0;f=0;b=1;while(1){c[v+(t<<2)>>2]=2;c[v+((t|1)<<2)>>2]=b;c[v+((t|2)<<2)>>2]=0;z=t+4|0;c[v+((t|3)<<2)>>2]=-1;A=b+1|0;B=f+1|0;C=yBa(g)|0;D=yBa(h)|0;E=yBa(u)|0;if(B>>>0<(C+1+D+E+(c[w>>2]|0)|0)>>>0){b=A;f=B;t=z}else{x=z;y=A;break}}}t=d+216|0;if((c[t>>2]|0)>0){f=d+40|0;b=s+252|0;w=x;v=0;while(1){A=c[f>>2]|0;do{if((a[A+(v*52|0)+48|0]|0)==0){z=a[A+(v*52|0)+8|0]|0;if(z<<24>>24==0){DBa(l,g,A+(v*52|0)+4|0);FBa(m,g);if(!(EBa(l,m)|0)){F=w;break}G=(c[(GBa(l)|0)+4>>2]|0)+1|0;H=2}else if(z<<24>>24==2){G=1;H=2}else if(z<<24>>24==1){DBa(l,b,A+(v*52|0)+4|0);FBa(n,b);if(!(EBa(l,n)|0)){F=w;break}G=(c[(GBa(l)|0)+4>>2]|0)+1|0;H=1}else{F=w;break}z=c[e>>2]|0;c[z+(w<<2)>>2]=H;if((c[(c[f>>2]|0)+(v*52|0)>>2]|0)==0){c[z+(w+1<<2)>>2]=G}else{c[z+(w+1<<2)>>2]=0-G}c[z+(w+2<<2)>>2]=0;c[z+(w+3<<2)>>2]=-1;F=w+4|0}else{F=w}}while(0);A=v+1|0;if((A|0)<(c[t>>2]|0)){w=F;v=A}else{I=F;break}}}else{I=x}x=d+220|0;if((c[x>>2]|0)>0){F=d+44|0;v=s+276|0;w=I;t=0;while(1){G=c[F>>2]|0;do{if((a[G+(t*52|0)+48|0]|0)==0){f=a[G+(t*52|0)+8|0]|0;if(f<<24>>24==0){DBa(l,h,G+(t*52|0)+4|0);FBa(o,h);H=EBa(l,o)|0;J=H?2:0}else if(f<<24>>24==1){DBa(l,v,G+(t*52|0)+4|0);FBa(p,v);J=(EBa(l,p)|0)&1}else{K=w;break}if((J|0)==0){K=w;break}f=c[e>>2]|0;c[f+(w<<2)>>2]=J;H=(c[(c[F>>2]|0)+(t*52|0)>>2]|0)==0;n=c[(GBa(l)|0)+4>>2]|0;if(H){c[f+(w+1<<2)>>2]=n+1}else{c[f+(w+1<<2)>>2]=~n}c[f+(w+2<<2)>>2]=0;c[f+(w+3<<2)>>2]=-1;K=w+4|0}else{K=w}}while(0);G=t+1|0;if((G|0)<(c[x>>2]|0)){w=K;t=G}else{L=K;break}}}else{L=I}I=d+224|0;if((c[I>>2]|0)>0){K=d+48|0;d=s+300|0;s=L;t=0;w=y;while(1){y=c[K>>2]|0;do{if((a[y+(t*52|0)+48|0]|0)==0){if((c[y+(t*52|0)>>2]|0)==0){x=a[y+(t*52|0)+8|0]|0;if(x<<24>>24==1){DBa(l,d,y+(t*52|0)+4|0);FBa(r,d);M=(EBa(l,r)|0)&1}else if(x<<24>>24==0){DBa(l,u,y+(t*52|0)+4|0);FBa(q,u);x=EBa(l,q)|0;M=x?2:0}else{N=s;O=w;break}if((M|0)==0){N=s;O=w;break}P=c[K>>2]|0;Q=M}else{P=y;Q=2}x=c[e>>2]|0;c[x+(s<<2)>>2]=Q;if((c[P+(t*52|0)>>2]|0)==0){c[x+(s+1<<2)>>2]=(c[(GBa(l)|0)+4>>2]|0)+1;R=w}else{c[x+(s+1<<2)>>2]=w;R=w+1|0}c[x+(s+2<<2)>>2]=0;c[x+(s+3<<2)>>2]=-1;N=s+4|0;O=R}else{N=s;O=w}}while(0);y=t+1|0;if((y|0)<(c[I>>2]|0)){s=N;t=y;w=O}else{S=N;break}}}else{S=L}if((j|0)==0){i=k;return}L=c[e>>2]|0;e=0;do{N=(e<<2)+S|0;c[L+(N<<2)>>2]=1;c[L+(N+1<<2)>>2]=e+2;c[L+(N+2<<2)>>2]=0;c[L+(N+3<<2)>>2]=0;e=e+1|0;}while(e>>>0<j>>>0);i=k;return}function xBa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+24|0;m=c[a+12>>2]|0;c[l>>2]=(g|0)==4?20:(g|0)==1?51:0;c[l+4>>2]=e;c[l+8>>2]=f;c[l+12>>2]=0;f=l+16|0;c[f>>2]=(x$a(d|0)|0)+1;e=m;eTa(e,l,20)|0;if(BRa(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){l=c[b+536>>2]|0;c[k>>2]=c[a>>2];lwa(l,248280,k)}eTa(e,d,c[f>>2]|0)|0;if(BRa(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){m=c[b+536>>2]|0;c[j>>2]=c[a>>2];lwa(m,248280,j)}else{i=h;return}}function yBa(a){a=a|0;var b=0,d=0;b=i;d=c[(kCa(a)|0)>>2]|0;i=b;return d|0}function zBa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d;f=d+16|0;g=a+12|0;h=c[g>>2]|0;j=h;Bxa(3);do{if(ARa(h+(c[(c[h>>2]|0)+ -12>>2]|0)|0)|0){k=h;l=h+200|0;m=f;c[m+0>>2]=c[l+0>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];c[m+12>>2]=c[l+12>>2];l=e;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[l+12>>2]=c[m+12>>2];gTa(k,e)|0;k=yBa(h+240|0)|0;m=yBa(h+264|0)|0;l=yBa(h+288|0)|0;xBa(a,b,248184,k+1+m+l+(c[h+312>>2]|0)+(c[a+8>>2]|0)|0,c[h+216>>2]|0,8);nBa(h)}else{if((h|0)!=0){break}c[g>>2]=0;Exa(3);i=d;return}}while(0);ABa(j);b$a(h);c[g>>2]=0;Exa(3);i=d;return}function ABa(a){a=a|0;var b=0;b=i;ICa(a);i=b;return}function BBa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;k=c[b+12>>2]|0;h[g>>3]=0.0;Bxa(3);Exa(0);h[j>>3]=+wxa(0);Bxa(0);l=k;m=d+4|0;eTa(l,c[c[m>>2]>>2]|0,8)|0;if((c[b+8>>2]|0)!=0){eTa(l,j,8)|0}j=d+116|0;n=c[j>>2]|0;if((n|0)>0){o=d+8|0;p=n;n=0;while(1){if((a[(c[o>>2]|0)+(n*112|0)+104|0]|0)==0){eTa(l,(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+(n<<3)|0,8)|0;q=c[j>>2]|0}else{q=p}r=n+1|0;if((r|0)<(q|0)){p=q;n=r}else{break}}}n=d+124|0;q=c[n>>2]|0;if((q|0)>0){p=d+12|0;j=g;o=q;q=0;while(1){if((a[(c[p>>2]|0)+(q*60|0)+56|0]|0)==0){h[g>>3]=+(c[(c[(c[c[m>>2]>>2]|0)+12>>2]|0)+(q<<2)>>2]|0);eTa(l,j,8)|0;s=c[n>>2]|0}else{s=o}r=q+1|0;if((r|0)<(s|0)){o=s;q=r}else{break}}}q=d+128|0;s=c[q>>2]|0;if((s|0)>0){o=d+16|0;n=g;j=s;s=0;while(1){if((a[(c[o>>2]|0)+(s*48|0)+44|0]|0)==0){h[g>>3]=+(a[(c[(c[c[m>>2]>>2]|0)+16>>2]|0)+s|0]|0);eTa(l,n,8)|0;t=c[q>>2]|0}else{t=j}p=s+1|0;if((p|0)<(t|0)){j=t;s=p}else{break}}}s=d+224|0;t=c[s>>2]|0;if((t|0)>0){j=d+48|0;q=g;n=t;t=0;while(1){o=c[j>>2]|0;do{if((a[o+(t*52|0)+48|0]|0)==0){if((c[o+(t*52|0)>>2]|0)==0){u=n;break}h[g>>3]=+((a[(c[(c[c[m>>2]>>2]|0)+16>>2]|0)+(c[o+(t*52|0)+4>>2]|0)|0]|0)!=1|0);eTa(l,q,8)|0;u=c[s>>2]|0}else{u=n}}while(0);o=t+1|0;if((o|0)<(u|0)){n=u;t=o}else{break}}}if(BRa(k+(c[(c[k>>2]|0)+ -12>>2]|0)|0)|0){t=c[d+536>>2]|0;c[f>>2]=c[b>>2];lwa(t,248224,f)}else{f=k+216|0;c[f>>2]=(c[f>>2]|0)+1;Exa(3);i=e;return}}function CBa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;if(c>>>0<6){i=d;return}if((u$a(b,248440,4)|0)!=0){i=d;return}c=b;while(1){e=Wa(b|0,46)|0;if((e|0)==0){f=8;break}g=e-c|0;e=g+1|0;if(e>>>0>4){h=4;do{a[b+(h+ -4)|0]=a[b+h|0]|0;h=h+1|0;}while(h>>>0<e>>>0)}e=b+(g+ -3)|0;a[e]=678585700;a[e+1|0]=2650725;a[e+2|0]=10354;a[e+3|0]=40;if((u$a(b,248440,4)|0)!=0){f=8;break}}if((f|0)==8){i=d;return}}function DBa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;YBa(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];OBa(a,f);i=e;return}function EBa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=MBa(a,b)|0;i=c;return d|0}function FBa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;PBa(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];OBa(a,e);i=d;return}function GBa(a){a=a|0;var b=0,c=0;b=i;c=HBa(IBa(a)|0)|0;i=b;return c|0}function HBa(a){a=a|0;var b=0,c=0;b=i;c=LBa(a)|0;i=b;return c|0}function IBa(a){a=a|0;var b=0,d=0;b=i;d=JBa((c[a>>2]|0)+16|0)|0;i=b;return d|0}function JBa(a){a=a|0;var b=0,c=0;b=i;c=KBa(a)|0;i=b;return c|0}function KBa(a){a=a|0;i=i;return a|0}function LBa(a){a=a|0;i=i;return a|0}function MBa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(NBa(a,b)|0)^1;i=c;return d|0}function NBa(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function OBa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];XBa(a,e);i=d;return}function PBa(a,b){a=a|0;b=b|0;var c=0;c=i;QBa(a,RBa(b)|0);i=c;return}function QBa(a,b){a=a|0;b=b|0;var c=0;c=i;WBa(a,b);i=c;return}function RBa(a){a=a|0;var b=0,c=0;b=i;c=SBa(TBa(a+4|0)|0)|0;i=b;return c|0}function SBa(a){a=a|0;var b=0,c=0;b=i;c=VBa(a)|0;i=b;return c|0}function TBa(a){a=a|0;var b=0,c=0;b=i;c=UBa(a)|0;i=b;return c|0}function UBa(a){a=a|0;i=i;return a|0}function VBa(a){a=a|0;i=i;return a|0}function WBa(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function XBa(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function YBa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=_Ba(b)|0;ZBa(f,b,d,h,RBa(b)|0);PBa(g,b);do{if(MBa(f,g)|0){h=$Ba(b)|0;if(aCa(h,d,bCa(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);PBa(a,b);i=e;return}function ZBa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;fCa(h);a:do{if((e|0)==0){j=f}else{k=$Ba(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(gCa(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;fCa(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;fCa(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);QBa(a,j);i=g;return}function _Ba(a){a=a|0;var b=0,d=0;b=i;d=c[(RBa(a)|0)>>2]|0;i=b;return d|0}function $Ba(a){a=a|0;var b=0,c=0;b=i;c=dCa(a+8|0)|0;i=b;return c|0}function aCa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=cCa(0,b,c)|0;i=a;return d|0}function bCa(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function cCa(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)<(c[d>>2]|0)|0}function dCa(a){a=a|0;var b=0,c=0;b=i;c=eCa(a)|0;i=b;return c|0}function eCa(a){a=a|0;i=i;return a|0}function fCa(a){a=a|0;var b=0;b=i;hCa(a,-1);i=b;return}function gCa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=cCa(0,b,c)|0;i=a;return d|0}function hCa(a,b){a=a|0;b=b|0;b=i;iCa(a,0);i=b;return}function iCa(a,b){a=a|0;b=b|0;c[a>>2]=0;i=i;return}function jCa(a){a=a|0;i=i;return c[a+4>>2]|0}function kCa(a){a=a|0;var b=0,c=0;b=i;c=lCa(a+8|0)|0;i=b;return c|0}function lCa(a){a=a|0;var b=0,c=0;b=i;c=mCa(a)|0;i=b;return c|0}function mCa(a){a=a|0;i=i;return a|0}function nCa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=a+64|0;if((c[f>>2]|0)!=0){g=0;i=e;return g|0}switch(d&-3|0){case 12:{h=248408;break};case 28:{h=248416;break};case 48:case 16:{h=248344;break};case 1:case 17:{h=248352;break};case 56:{h=248376;break};case 60:{h=248424;break};case 9:case 25:{h=248384;break};case 8:{h=248360;break};case 13:case 29:{h=248432;break};case 52:case 20:{h=248392;break};case 5:case 21:{h=248400;break};case 24:{h=248368;break};default:{g=0;i=e;return g|0}}if((a|0)==0){g=0;i=e;return g|0}j=mc(b|0,h|0)|0;c[f>>2]=j;if((j|0)==0){g=0;i=e;return g|0}c[a+88>>2]=d;if((d&2|0)==0){g=a;i=e;return g|0}if((Zc(j|0,0,2)|0)==0){g=a;i=e;return g|0}ad(c[f>>2]|0)|0;c[f>>2]=0;g=0;i=e;return g|0}function oCa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=b;c[e+4>>2]=d;i=i;return}function pCa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a+64|0;f=c[e>>2]|0;if((f|0)==0){g=0;i=b;return g|0}qCa(d,f,102);f=oe[c[(c[a>>2]|0)+24>>2]&127](a)|0;if((ad(rCa(d)|0)|0)==0){c[e>>2]=0;h=(f|0)==0?a:0}else{h=0}sCa(d);g=h;i=b;return g|0}function qCa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;zCa(a,b,c);i=d;return}function rCa(a){a=a|0;var b=0,d=0;b=i;d=vCa(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function sCa(a){a=a|0;var b=0;b=i;tCa(a);i=b;return}function tCa(a){a=a|0;var b=0;b=i;uCa(a,0);i=b;return}function uCa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=vCa(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}oe[c[(wCa(e)|0)>>2]&127](f)|0;i=d;return}function vCa(a){a=a|0;var b=0,c=0;b=i;c=yCa(a)|0;i=b;return c|0}function wCa(a){a=a|0;var b=0,c=0;b=i;c=xCa(a)|0;i=b;return c|0}function xCa(a){a=a|0;i=i;return a+4|0}function yCa(a){a=a|0;i=i;return a|0}function zCa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;d=c[(BCa(f)|0)>>2]|0;ACa(a,d,c[(CCa(g)|0)>>2]|0);i=e;return}function ACa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;DCa(a,b,c);i=d;return}function BCa(a){a=a|0;i=i;return a|0}function CCa(a){a=a|0;i=i;return a|0}function DCa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;d=c[(FCa(f)|0)>>2]|0;ECa(a,d,c[(GCa(g)|0)>>2]|0);i=e;return}function ECa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;c[a>>2]=c[(FCa(f)|0)>>2];c[a+4>>2]=c[(GCa(g)|0)>>2];i=e;return}function FCa(a){a=a|0;i=i;return a|0}function GCa(a){a=a|0;i=i;return a|0}function HCa(a){a=a|0;var b=0,d=0;b=i;d=a+8|0;J=c[d+4>>2]|0;i=b;return c[d>>2]|0}function ICa(a){a=a|0;var b=0;b=i;JCa(a+300|0);JCa(a+288|0);JCa(a+276|0);JCa(a+264|0);JCa(a+252|0);JCa(a+240|0);KCa(a);i=b;return}function JCa(a){a=a|0;var b=0;b=i;uDa(a);i=b;return}function KCa(a){a=a|0;var b=0;b=i;LCa(a,248488);IRa(a+104|0);i=b;return}function LCa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];PCa(a+4|0);i=d;return}function MCa(a){a=a|0;var b=0;b=i;KCa(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function NCa(a){a=a|0;var b=0;b=i;KCa(a);b$a(a);i=b;return}function OCa(a){a=a|0;var b=0;b=i;NCa(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function PCa(a){a=a|0;var b=0;b=i;QCa(a);i=b;return}function QCa(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=248616;pCa(b)|0;do{if((a[b+96|0]|0)!=0){e=c[b+32>>2]|0;if((e|0)==0){break}c$a(e)}}while(0);do{if((a[b+97|0]|0)!=0){e=c[b+56>>2]|0;if((e|0)==0){break}c$a(e)}}while(0);RRa(b);i=d;return}function RCa(a){a=a|0;var b=0;b=i;PCa(a);b$a(a);i=b;return}function SCa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;oe[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=sDa(d)|0;c[b+68>>2]=f;d=b+98|0;g=a[d]|0;h=tDa(f)|0;a[d]=h&1;if((g&255|0)==(h&1|0)){i=e;return}h=b;$Ra(h,0,0,0);eSa(h,0,0);h=b+96|0;g=(a[h]|0)!=0;if((a[d]|0)!=0){d=b+32|0;do{if(g){f=c[d>>2]|0;if((f|0)==0){break}c$a(f)}}while(0);f=b+97|0;a[h]=a[f]|0;j=b+60|0;c[b+52>>2]=c[j>>2];k=b+56|0;c[d>>2]=c[k>>2];c[j>>2]=0;c[k>>2]=0;a[f]=0;i=e;return}do{if(!g){f=b+32|0;k=c[f>>2]|0;if((k|0)==(b+44|0)){break}j=c[b+52>>2]|0;c[b+60>>2]=j;c[b+56>>2]=k;a[b+97|0]=0;c[f>>2]=a$a(j)|0;a[h]=1;i=e;return}}while(0);h=c[b+52>>2]|0;c[b+60>>2]=h;c[b+56>>2]=a$a(h)|0;a[b+97|0]=1;i=e;return}function TCa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=f;h=f+8|0;c[g>>2]=e;e=b;$Ra(e,0,0,0);eSa(e,0,0);j=b+96|0;do{if((a[j]|0)!=0){k=c[b+32>>2]|0;if((k|0)==0){break}c$a(k)}}while(0);k=b+97|0;do{if((a[k]|0)!=0){l=c[b+56>>2]|0;if((l|0)==0){break}c$a(l)}}while(0);l=c[g>>2]|0;m=b+52|0;c[m>>2]=l;do{if(l>>>0>8){n=a[b+98|0]|0;if(n<<24>>24==0|(d|0)==0){c[b+32>>2]=a$a(l)|0;a[j]=1;o=n;break}else{c[b+32>>2]=d;a[j]=0;o=n;break}}else{c[b+32>>2]=b+44;c[m>>2]=8;a[j]=0;o=a[b+98|0]|0}}while(0);if(!(o<<24>>24==0)){c[b+60>>2]=0;c[b+56>>2]=0;a[k]=0;i=f;return e|0}c[h>>2]=8;o=c[(pDa(g,h)|0)>>2]|0;c[b+60>>2]=o;if((d|0)!=0&o>>>0>7){c[b+56>>2]=d;a[k]=0;i=f;return e|0}else{c[b+56>>2]=a$a(o)|0;a[k]=1;i=f;return e|0}return 0}function UCa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+32|0;h=g;j=g+8|0;k=g+24|0;l=k;m=c[b+68>>2]|0;if((m|0)==0){n=Hc(4)|0;A_a(n);Zd(n|0,296008,128)}n=lDa(m)|0;m=b+64|0;do{if((c[m>>2]|0)!=0){o=(n|0)>0;if(!(o|(d|0)==0&(e|0)==0)){break}if((oe[c[(c[b>>2]|0)+24>>2]&127](b)|0)!=0){break}if(!(f>>>0<3)){tBa(a,-1,-1);i=g;return}p=c[m>>2]|0;if(o){o=Q$a(n|0,((n|0)<0)<<31>>31|0,d|0,e|0)|0;q=o}else{q=0}if((Zc(p|0,q|0,f|0)|0)==0){p=Bb(c[m>>2]|0)|0;tBa(j,p,((p|0)<0)<<31>>31);p=b+72|0;o=c[p+4>>2]|0;r=k;c[r>>2]=c[p>>2];c[r+4>>2]=o;o=h;r=l;c[o+0>>2]=c[r+0>>2];c[o+4>>2]=c[r+4>>2];oDa(j,h);r=a;o=j;c[r+0>>2]=c[o+0>>2];c[r+4>>2]=c[o+4>>2];c[r+8>>2]=c[o+8>>2];c[r+12>>2]=c[o+12>>2];i=g;return}else{tBa(a,-1,-1);i=g;return}}}while(0);tBa(a,-1,-1);i=g;return}function VCa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=f;h=b+64|0;do{if((c[h>>2]|0)!=0){if((oe[c[(c[b>>2]|0)+24>>2]&127](b)|0)!=0){break}j=c[h>>2]|0;k=HCa(d)|0;if((Zc(j|0,k|0,0)|0)==0){nDa(g,d);k=f;j=c[k+4>>2]|0;l=b+72|0;c[l>>2]=c[k>>2];c[l+4>>2]=j;j=a;l=d;c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];c[j+12>>2]=c[l+12>>2];i=e;return}else{tBa(a,-1,-1);i=e;return}}}while(0);tBa(a,-1,-1);i=e;return}function WCa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d;f=d+8|0;g=f;h=b+64|0;if((c[h>>2]|0)==0){j=0;i=d;return j|0}k=b+68|0;l=c[k>>2]|0;if((l|0)==0){m=Hc(4)|0;A_a(m);Zd(m|0,296008,128)}m=b+92|0;n=c[m>>2]|0;do{if((n&16|0)==0){if((n&8|0)==0){break}o=b+80|0;p=c[o+4>>2]|0;q=f;c[q>>2]=c[o>>2];c[q+4>>2]=p;do{if((a[b+98|0]|0)==0){p=lDa(l)|0;q=b+36|0;o=c[q>>2]|0;r=(c[b+40>>2]|0)-o|0;s=b;if((p|0)>0){t=ZRa(s)|0;u=(fa(t-(YRa(s)|0)|0,p)|0)+r|0;v=0;break}p=YRa(s)|0;if((p|0)==(ZRa(s)|0)){u=r;v=0;break}t=c[k>>2]|0;w=b+32|0;x=c[w>>2]|0;y=mDa(t,g,x,o,p-(XRa(s)|0)|0)|0;u=r-y+(c[q>>2]|0)-(c[w>>2]|0)|0;v=1}else{w=b;q=ZRa(w)|0;u=q-(YRa(w)|0)|0;v=0}}while(0);if((Zc(c[h>>2]|0,0-u|0,1)|0)!=0){j=-1;i=d;return j|0}if(v){w=f;q=c[w+4>>2]|0;y=b+72|0;c[y>>2]=c[w>>2];c[y+4>>2]=q}q=c[b+32>>2]|0;c[b+40>>2]=q;c[b+36>>2]=q;$Ra(b,0,0,0);c[m>>2]=0}else{q=b;y=bSa(q)|0;do{if((y|0)!=(aSa(q)|0)){if((De[c[(c[b>>2]|0)+52>>2]&63](b,-1)|0)==-1){j=-1}else{break}i=d;return j|0}}while(0);q=b+72|0;y=b+32|0;w=b+52|0;while(1){r=c[y>>2]|0;s=kDa(c[k>>2]|0,q,r,r+(c[w>>2]|0)|0,e)|0;r=c[y>>2]|0;p=(c[e>>2]|0)-r|0;if((uc(r|0,1,p|0,c[h>>2]|0)|0)!=(p|0)){j=-1;z=23;break}if((s|0)==2){j=-1;z=23;break}else if((s|0)!=1){z=10;break}}if((z|0)==10){if((Ad(c[h>>2]|0)|0)==0){break}else{j=-1}i=d;return j|0}else if((z|0)==23){i=d;return j|0}}}while(0);j=0;i=d;return j|0}function XCa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+32|0;k=d+40|0;l=b+64|0;if((c[l>>2]|0)==0){m=-1;i=d;return m|0}n=fDa(b)|0;o=b;if((YRa(o)|0)==0){p=e+1|0;$Ra(o,e,p,p)}if(n){q=0}else{n=ZRa(o)|0;c[f>>2]=(n-(XRa(o)|0)|0)/2|0;c[g>>2]=4;q=c[(gDa(f,g)|0)>>2]|0}g=YRa(o)|0;do{if((g|0)==(ZRa(o)|0)){A$a(XRa(o)|0,g+(0-q)|0,q|0)|0;if((a[b+98|0]|0)!=0){f=ZRa(o)|0;n=XRa(o)|0;p=vb(n+q|0,1,f-q-n|0,c[l>>2]|0)|0;if((p|0)==0){r=-1;break}n=XRa(o)|0;$Ra(o,n,n+q|0,n+(p+q)|0);r=dDa(a[YRa(o)|0]|0)|0;break}p=b+32|0;n=b+36|0;f=c[n>>2]|0;s=b+40|0;A$a(c[p>>2]|0,f|0,(c[s>>2]|0)-f|0)|0;f=c[p>>2]|0;t=f+((c[s>>2]|0)-(c[n>>2]|0))|0;c[n>>2]=t;if((f|0)==(b+44|0)){u=8}else{u=c[b+52>>2]|0}v=f+u|0;c[s>>2]=v;f=b+60|0;c[h>>2]=(c[f>>2]|0)-q;c[j>>2]=v-t;v=c[(gDa(h,j)|0)>>2]|0;w=b+72|0;x=w;y=c[x+4>>2]|0;z=b+80|0;c[z>>2]=c[x>>2];c[z+4>>2]=y;y=vb(t|0,1,v|0,c[l>>2]|0)|0;if((y|0)==0){r=-1;break}v=c[b+68>>2]|0;if((v|0)==0){t=Hc(4)|0;A_a(t);Zd(t|0,296008,128)}t=(c[n>>2]|0)+y|0;c[s>>2]=t;y=c[p>>2]|0;z=XRa(o)|0;if((hDa(v,w,y,t,n,z+q|0,z+(c[f>>2]|0)|0,k)|0)==3){f=c[p>>2]|0;$Ra(o,f,f,c[s>>2]|0);r=dDa(a[YRa(o)|0]|0)|0;break}s=c[k>>2]|0;f=XRa(o)|0;p=f+q|0;if((s|0)==(p|0)){r=-1;break}$Ra(o,f,p,s);r=dDa(a[YRa(o)|0]|0)|0}else{r=dDa(a[g]|0)|0}}while(0);if((XRa(o)|0)!=(e|0)){m=r;i=d;return m|0}$Ra(o,0,0,0);m=r;i=d;return m|0}function YCa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[b+64>>2]|0)==0){f=-1;i=e;return f|0}g=b;h=XRa(g)|0;j=YRa(g)|0;if(!(h>>>0<j>>>0)){f=-1;i=e;return f|0}if($Ca(d,-1)|0){_Ra(g,-1);f=cDa(d)|0;i=e;return f|0}h=(c[b+88>>2]&16|0)==0;b=aDa(d)|0;do{if(h){if(eDa(b,a[j+ -1|0]|0)|0){break}else{f=-1}i=e;return f|0}}while(0);_Ra(g,-1);a[YRa(g)|0]=b;f=d;i=e;return f|0}function ZCa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;j=b+64|0;if((c[j>>2]|0)==0){k=-1;i=e;return k|0}_Ca(b);l=b;m=aSa(l)|0;n=cSa(l)|0;if(!($Ca(d,-1)|0)){if((bSa(l)|0)==0){eSa(l,f,f+1|0)}f=aDa(d)|0;a[bSa(l)|0]=f;dSa(l,1)}f=bSa(l)|0;o=aSa(l)|0;if((f|0)!=(o|0)){a:do{if((a[b+98|0]|0)==0){p=b+32|0;q=c[p>>2]|0;c[g>>2]=q;r=b+68|0;s=c[r>>2]|0;if((s|0)==0){t=Hc(4)|0;u=t;A_a(u);v=296008;w=128;Zd(t|0,v|0,w|0)}x=b+72|0;y=b+52|0;z=q;q=s;while(1){s=aSa(l)|0;A=bSa(l)|0;B=bDa(q,x,s,A,h,z,z+(c[y>>2]|0)|0,g)|0;A=c[h>>2]|0;C=aSa(l)|0;if((A|0)==(C|0)){k=-1;D=22;break}if((B|0)==3){D=14;break}if(!(B>>>0<2)){k=-1;D=22;break}A=c[p>>2]|0;s=(c[g>>2]|0)-A|0;if((uc(A|0,1,s|0,c[j>>2]|0)|0)!=(s|0)){k=-1;D=22;break}if((B|0)!=1){break a}B=c[h>>2]|0;eSa(l,B,bSa(l)|0);B=cSa(l)|0;dSa(l,B-(aSa(l)|0)|0);B=c[r>>2]|0;if((B|0)==0){D=11;break}z=c[p>>2]|0;q=B}if((D|0)==11){t=Hc(4)|0;u=t;A_a(u);v=296008;w=128;Zd(t|0,v|0,w|0)}else if((D|0)==14){q=(bSa(l)|0)-C|0;if((uc(C|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}else if((D|0)==22){i=e;return k|0}}else{q=f-o|0;if((uc(o|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}}while(0);eSa(l,m,n)}k=cDa(d)|0;i=e;return k|0}function _Ca(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=b+92|0;if((c[e>>2]&16|0)!=0){i=d;return}f=b;$Ra(f,0,0,0);g=c[b+52>>2]|0;do{if(g>>>0>8){if((a[b+98|0]|0)==0){h=c[b+56>>2]|0;eSa(f,h,h+((c[b+60>>2]|0)+ -1)|0);break}else{h=c[b+32>>2]|0;eSa(f,h,h+(g+ -1)|0);break}}else{eSa(f,0,0)}}while(0);c[e>>2]=16;i=d;return}function $Ca(a,b){a=a|0;b=b|0;i=i;return(a|0)==(b|0)|0}function aDa(a){a=a|0;i=i;return a&255|0}function bDa(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=Me[c[(c[a>>2]|0)+12>>2]&15](a,b,d,e,f,g,h,j)|0;i=k;return l|0}function cDa(a){a=a|0;var b=0,c=0;b=i;c=$Ca(a,-1)|0;i=b;return(c?0:a)|0}function dDa(a){a=a|0;i=i;return a&255|0}function eDa(a,b){a=a|0;b=b|0;i=i;return a<<24>>24==b<<24>>24|0}function fDa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+92|0;if((c[e>>2]&8|0)!=0){f=0;i=d;return f|0}g=b;eSa(g,0,0);if((a[b+98|0]|0)==0){h=c[b+56>>2]|0;j=h+(c[b+60>>2]|0)|0;$Ra(g,h,j,j)}else{j=c[b+32>>2]|0;h=j+(c[b+52>>2]|0)|0;$Ra(g,j,h,h)}c[e>>2]=8;f=1;i=d;return f|0}function gDa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=iDa(b,c,e)|0;i=d;return g|0}function hDa(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=Me[c[(c[a>>2]|0)+16>>2]&15](a,b,d,e,f,g,h,j)|0;i=k;return l|0}function iDa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=jDa(0,b,a)|0;i=c;return(d?b:a)|0}function jDa(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)>>>0<(c[d>>2]|0)>>>0|0}function kDa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=Ee[c[(c[a>>2]|0)+20>>2]&63](a,b,d,e,f)|0;i=g;return h|0}function lDa(a){a=a|0;var b=0,d=0;b=i;d=oe[c[(c[a>>2]|0)+24>>2]&127](a)|0;i=b;return d|0}function mDa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=Ee[c[(c[a>>2]|0)+32>>2]&63](a,b,d,e,f)|0;i=g;return h|0}function nDa(a,b){a=a|0;b=b|0;var d=0,e=0;d=b;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;i=i;return}function oDa(a,b){a=a|0;b=b|0;var d=0,e=0;d=b;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;i=i;return}function pDa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=qDa(b,c,e)|0;i=d;return g|0}function qDa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=rDa(0,a,b)|0;i=c;return(d?b:a)|0}function rDa(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)<(c[d>>2]|0)|0}function sDa(a){a=a|0;var b=0,c=0;b=i;c=AXa(a,280512)|0;i=b;return c|0}function tDa(a){a=a|0;var b=0,d=0;b=i;d=oe[c[(c[a>>2]|0)+28>>2]&127](a)|0;i=b;return d|0}function uDa(a){a=a|0;var b=0;b=i;vDa(a);i=b;return}function vDa(a){a=a|0;var b=0;b=i;wDa(a);i=b;return}function wDa(a){a=a|0;var b=0;b=i;xDa(a,_Ba(a)|0);i=b;return}function xDa(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+8|0;fCa(d);if((b|0)==0){i=d;return}xDa(a,c[b>>2]|0);xDa(a,c[b+4>>2]|0);zDa(yDa(a)|0,b,1);i=d;return}function yDa(a){a=a|0;var b=0,c=0;b=i;c=BDa(a+4|0)|0;i=b;return c|0}function zDa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;ADa(0,b,0);i=c;return}function ADa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;b$a(b);i=c;return}function BDa(a){a=a|0;var b=0,c=0;b=i;c=CDa(a)|0;i=b;return c|0}function CDa(a){a=a|0;i=i;return a|0}function DDa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=EDa(a,f,b)|0;l=c[k>>2]|0;fCa(d+16|0);if((l|0)!=0){m=l;n=m;o=n+20|0;p=o;i=d;return p|0}GDa(j,a,b);HDa(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];FDa(g,e);IDa(j);j=c[f>>2]|0;JDa(a,j,k,KDa(g)|0);k=LDa(g)|0;IDa(g);m=k;n=m;o=n+20|0;p=o;i=d;return p|0}function EDa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=_Ba(h)|0;fCa(e);if((a|0)==0){j=RBa(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(cCa(0,d,a)|0){m=l;j=c[m>>2]|0;fCa(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(cCa(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;fCa(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function FDa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];xEa(a,e);i=d;return}function GDa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=yDa(d)|0;d=gEa(n,1)|0;hEa(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];fEa(j,d,h);iEa(0,bEa((jEa(j)|0)+16|0)|0,e);e=kEa(j)|0;a[e+4|0]=1;lEa(0,aEa((jEa(j)|0)+20|0)|0);a[e+5|0]=1;mEa(m,j);HDa(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];FDa(b,g);IDa(m);IDa(j);i=f;return}function HDa(a,b){a=a|0;b=b|0;var c=0;c=i;dEa(a,b);i=c;return}function IDa(a){a=a|0;var b=0;b=i;YDa(a);i=b;return}function JDa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;fCa(f);c[e>>2]=0;fCa(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=QDa(a)|0;b=c[c[e>>2]>>2]|0;fCa(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(RBa(a)|0)>>2]|0;RDa(e,c[d>>2]|0);d=SDa(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function KDa(a){a=a|0;var b=0,d=0;b=i;d=c[(ODa(a)|0)>>2]|0;i=b;return d|0}function LDa(a){a=a|0;var b=0,d=0;b=i;d=MDa(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function MDa(a){a=a|0;var b=0,c=0;b=i;c=NDa(a)|0;i=b;return c|0}function NDa(a){a=a|0;i=i;return a|0}function ODa(a){a=a|0;var b=0,c=0;b=i;c=PDa(a)|0;i=b;return c|0}function PDa(a){a=a|0;i=i;return a|0}function QDa(a){a=a|0;i=i;return a|0}



function dw(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+7776>>3]),1.0e-13);k=+h[g+568>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+6840|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+6840|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,15912,15904,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6840|0;p=o;h[p>>3]=m;i=d;return}function ew(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+544>>3];v=l;h[k>>3]=+h[t+7768>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];gxa(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+552>>3];w=+h[t+536>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];vz(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Bz(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+568>>3];f=j;h[k>>3]=+h[q+7776>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];gxa(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+576>>3];y=+h[f+560>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];vz(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Bz(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+7112>>3]=(+h[d+120>>3]+ +h[d+128>>3])*(w- +h[r>>3])*+h[d+1536>>3]*.5;i=b;return}function fw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+568>>3];p=f;h[k>>3]=+h[n+7776>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+576>>3];q=+h[p+560>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+9640>>3]=+h[l>>3];i=b;return}function gw(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+624>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7256>>3]=+h[(a?e+9648|0:e+9640|0)>>3];i=b;return}function hw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+568>>3];p=f;h[k>>3]=+h[n+7776>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+576>>3];q=+h[p+560>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+9584>>3]=+h[l>>3];i=b;return}function iw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+3404>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+7016>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+7016|0;h[c[g+3408>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+7016>>3]);h[c[(c[f>>2]|0)+3412>>2]>>3]=k;_za(a,42)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+7016>>3]=+h[c[(c[f>>2]|0)+3404>>2]>>3];i=b;return}function jw(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+7064>>3]=+h[b+7016>>3]*(+h[d+120>>3]+ +h[d+128>>3])*+h[d+1536>>3]*.5;i=i;return}function kw(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+7464>>3]=+h[b+6416>>3]*+h[d+128>>3]*+h[d+1432>>3]*(+h[b+528>>3]*.5+(+h[b+576>>3]*-.5+((+h[b+7016>>3]+ +h[b+7024>>3])*.5+ +h[d+1352>>3]*+h[b+6760>>3]*-10.0)));i=i;return}function lw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8464>>3]=+h[b+7504>>3]+ +h[b+7464>>3];i=i;return}function mw(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+7664>>3];k=+h[g+8464>>3]- +h[g+7584>>3]*+h[g+6752>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+7888|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+7888|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,15664,15952,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7888|0;p=o;h[p>>3]=m;i=d;return}function nw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+3484>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1192>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1192|0;h[c[g+3488>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1192>>3]);e=c[f>>2]|0;h[c[e+3492>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+3484>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+1208>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+1208|0;h[(c[e+3488>>2]|0)+8>>3]=+h[g>>3];k=+aAa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+1208>>3]);h[(c[(c[f>>2]|0)+3492>>2]|0)+8>>3]=k;_za(a,43)|0;j=c[(c[f>>2]|0)+3484>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1192>>3]=+h[j>>3];h[f+1208>>3]=+h[j+8>>3];BS(a);CS(a);DS(a);ES(a);FS(a);GS(a);i=b;return}function ow(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+624>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7304>>3]=+h[(a?e+9592|0:e+9584|0)>>3];i=b;return}function pw(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;iA(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+560>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+6792>>3]=+yd(+(+h[d>>3]),+(+h[a+576>>3]*.999));i=b;return}function qw(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6792>>3];k=+zd(1.0e-13,+(+h[g+576>>3]-j));l=+h[g+7776>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+nwa(c[b+536>>2]|0,k,15968,15960,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6808>>3]=+yd(+(j*n*.6219647130774989),1.0);i=d;return}function rw(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+6824>>3]=+zd(+(+h[d+568>>3]- +h[d+6808>>3]),0.0);i=b;return}function sw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6816>>3]=+h[b+568>>3]- +h[b+6824>>3];i=i;return}function tw(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6824>>3];k=1.0-j;l=+h[g+7776>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+nwa(c[b+536>>2]|0,k,16040,16032,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+6824>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+6816>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+6856|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+6856|0;z=y;h[z>>3]=w;i=d;return}l=m/+nwa(c[b+536>>2]|0,p,16040,16032,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+6856|0;z=y;h[z>>3]=w;i=d;return}function uw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6864>>3]=+h[b+6880>>3]- +h[b+6856>>3]*+h[b+560>>3];i=i;return}function vw(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+560>>3]*+h[g+6856>>3];k=+h[g+576>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+6872|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+6872|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,16080,16072,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6872|0;p=o;h[p>>3]=m;i=d;return}function ww(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7656>>3]=+h[b+9976>>3]*+h[b+6872>>3];i=i;return}function xw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7616>>3]=+h[b+568>>3]*+h[b+7656>>3];i=i;return}function yw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7696>>3]=+h[b+7656>>3]*+h[b+6864>>3];i=i;return}function zw(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+7656>>3];k=+h[g+7536>>3]- +h[g+568>>3]*+h[g+7576>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1224|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1224|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,16128,16120,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1224|0;p=o;h[p>>3]=m;i=d;return}function Aw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8616>>3]=-+h[b+1224>>3];i=i;return}function Bw(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+120>>3]*+h[j+6872>>3]*+h[e+1432>>3];l=+h[j+616>>3]+ +h[j+624>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6408|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6408|0;r=q;h[r>>3]=o;i=d;return}s=l/+nwa(c[b+536>>2]|0,k,16152,16144,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6408|0;r=q;h[r>>3]=o;i=d;return}function Cw(a){a=a|0;var b=0,d=0.0,e=0.0,f=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+6408>>3];e=+h[b+6416>>3];f=c[a+416>>2]|0;h[b+7160>>3]=+h[f+1536>>3]*(+h[b+9584>>3]*d*d*+h[f+120>>3]- +h[b+9592>>3]*e*e*+h[f+128>>3]);i=i;return}function Dw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7808>>3]=+h[b+7160>>3]+(-+h[b+7112>>3]- +h[b+7064>>3]);i=i;return}function Ew(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10024>>3];k=+h[g+7808>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1280|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1280|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,16224,16216,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1280|0;p=o;h[p>>3]=m;i=d;return}function Fw(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+576>>3];k=+h[g+568>>3];l=+h[g+6792>>3]*(k+ +h[g+7776>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+6832|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+6832|0;r=q;h[r>>3]=o;i=d;return}s=k/+nwa(c[b+536>>2]|0,l,16256,16248,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+6832|0;r=q;h[r>>3]=o;i=d;return}function Gw(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6792>>3];k=+zd(1.0e-13,+(+h[g+576>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+nwa(c[b+536>>2]|0,k,15968,16360,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+6800>>3]=m*.6219647130774989;i=d;return}function Hw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;gxa(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+592>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+600>>3];l=+h[a+584>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];tA(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6992>>3]=+h[f>>3];i=b;return}function Iw(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+608>>3];h[b+7352>>3]=d*+h[(!(d>=0.0)?b+6992|0:b+10904|0)>>3];i=i;return}function Jw(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+616>>3];h[b+7360>>3]=d*+h[(!(d>=0.0)?b+6880|0:b+6992|0)>>3];i=i;return}function Kw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7496>>3]=+h[b+7360>>3]- +h[b+7368>>3];i=i;return}function Lw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7488>>3]=+h[b+7352>>3]- +h[b+7360>>3];i=i;return}function Mw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7784>>3]=1.0- +h[b+592>>3];i=i;return}function Nw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+592>>3];p=f;h[k>>3]=+h[n+7784>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+600>>3];q=+h[p+584>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];fA(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+6360>>3]=+h[l>>3];i=b;return}function Ow(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+7784>>3]),1.0e-13);k=+h[g+592>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+6952|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+6952|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,16376,16368,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6952|0;p=o;h[p>>3]=m;i=d;return}function Pw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+568>>3];v=l;h[k>>3]=+h[t+7776>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];gxa(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+576>>3];w=+h[t+560>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];vz(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Bz(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+592>>3];f=j;h[k>>3]=+h[q+7784>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];gxa(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+600>>3];y=+h[f+584>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];vz(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Bz(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+7104>>3]=(+h[d+112>>3]+ +h[d+120>>3])*(w- +h[r>>3])*+h[d+1536>>3]*.5;i=b;return}function Qw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0.0,v=0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+16|0;m=i;i=i+32|0;n=i;i=i+32|0;o=i;i=i+8|0;p=i;i=i+8|0;q=a+4|0;r=c[(c[c[q>>2]>>2]|0)+8>>2]|0;s=+h[r+592>>3];t=j;h[k>>3]=+h[r+7784>>3];c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];gxa(l,2,s,j);j=a+536|0;t=c[j>>2]|0;r=c[(c[c[q>>2]>>2]|0)+8>>2]|0;s=+h[r+600>>3];u=+h[r+584>>3];r=g;v=l;c[r+0>>2]=c[v+0>>2];c[r+4>>2]=c[v+4>>2];c[r+8>>2]=c[v+8>>2];vz(m,t,s,u,g);g=c[j>>2]|0;t=f;v=m;c[t+0>>2]=c[v+0>>2];c[t+4>>2]=c[v+4>>2];c[t+8>>2]=c[v+8>>2];c[t+12>>2]=c[v+12>>2];c[t+16>>2]=c[v+16>>2];c[t+20>>2]=c[v+20>>2];c[t+24>>2]=c[v+24>>2];c[t+28>>2]=c[v+28>>2];Bz(o,g,f);u=+h[o>>3];o=c[j>>2]|0;s=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+9800>>3];f=e;g=1560;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];vz(n,o,15.0e4,s,e);e=c[j>>2]|0;j=d;o=n;c[j+0>>2]=c[o+0>>2];c[j+4>>2]=c[o+4>>2];c[j+8>>2]=c[o+8>>2];c[j+12>>2]=c[o+12>>2];c[j+16>>2]=c[o+16>>2];c[j+20>>2]=c[o+20>>2];c[j+24>>2]=c[o+24>>2];c[j+28>>2]=c[o+28>>2];Bz(p,e,d);d=c[a+416>>2]|0;h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+7096>>3]=+h[d+112>>3]*(u- +h[p>>3])*+h[d+1536>>3];i=b;return}function Rw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+592>>3];p=f;h[k>>3]=+h[n+7784>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+600>>3];q=+h[p+584>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+9632>>3]=+h[l>>3];i=b;return}function Sw(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+616>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7248>>3]=+h[(a?e+9640|0:e+9632|0)>>3];i=b;return}function Tw(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+608>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7240>>3]=+h[(a?e+9632|0:e+9624|0)>>3];i=b;return}function Uw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+592>>3];p=f;h[k>>3]=+h[n+7784>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+600>>3];q=+h[p+584>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+9576>>3]=+h[l>>3];i=b;return}function Vw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+3564>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+7008>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+7008|0;h[c[g+3568>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+7008>>3]);h[c[(c[f>>2]|0)+3572>>2]>>3]=k;_za(a,44)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+7008>>3]=+h[c[(c[f>>2]|0)+3564>>2]>>3];i=b;return}function Ww(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+7056>>3]=+h[b+7008>>3]*(+h[d+112>>3]+ +h[d+120>>3])*+h[d+1536>>3]*.5;i=i;return}function Xw(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+7456>>3]=+h[b+6408>>3]*+h[d+120>>3]*+h[d+1432>>3]*(+h[b+552>>3]*.5+(+h[b+600>>3]*-.5+((+h[b+7008>>3]+ +h[b+7016>>3])*.5+ +h[d+1352>>3]*+h[b+6872>>3]*-10.0)));i=i;return}function Yw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8456>>3]=+h[b+7496>>3]+ +h[b+7456>>3];i=i;return}function Zw(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+7656>>3];k=+h[g+8456>>3]- +h[g+7576>>3]*+h[g+6864>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+7864|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+7864|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,16128,16416,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7864|0;p=o;h[p>>3]=m;i=d;return}function _w(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+3644>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1216>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1216|0;h[c[g+3648>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1216>>3]);e=c[f>>2]|0;h[c[e+3652>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+3644>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+1232>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+1232|0;h[(c[e+3648>>2]|0)+8>>3]=+h[g>>3];k=+aAa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+1232>>3]);h[(c[(c[f>>2]|0)+3652>>2]|0)+8>>3]=k;_za(a,45)|0;j=c[(c[f>>2]|0)+3644>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1216>>3]=+h[j>>3];h[f+1232>>3]=+h[j+8>>3];LS(a);MS(a);NS(a);OS(a);PS(a);QS(a);i=b;return}function $w(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+616>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7296>>3]=+h[(a?e+9584|0:e+9576|0)>>3];i=b;return}function ax(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+3724>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+7e3>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+7e3|0;h[c[g+3728>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+7e3>>3]);h[c[(c[f>>2]|0)+3732>>2]>>3]=k;_za(a,46)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+7e3>>3]=+h[c[(c[f>>2]|0)+3724>>2]>>3];i=b;return}function bx(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+7048>>3]=+h[b+7e3>>3]*+h[d+1536>>3]*+h[d+112>>3];i=i;return}function cx(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+608>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7288>>3]=+h[(a?e+9576|0:e+9568|0)>>3];i=b;return}function dx(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;iA(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+584>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+6904>>3]=+yd(+(+h[d>>3]),+(+h[a+600>>3]*.999));i=b;return}function ex(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6904>>3];k=+zd(1.0e-13,+(+h[g+600>>3]-j));l=+h[g+7784>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+nwa(c[b+536>>2]|0,k,16432,16424,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6920>>3]=+yd(+(j*n*.6219647130774989),1.0);i=d;return}function fx(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+6936>>3]=+zd(+(+h[d+592>>3]- +h[d+6920>>3]),0.0);i=b;return}function gx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6928>>3]=+h[b+592>>3]- +h[b+6936>>3];i=i;return}function hx(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6936>>3];k=1.0-j;l=+h[g+7784>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+nwa(c[b+536>>2]|0,k,16504,16496,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+6936>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+6928>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+6968|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+6968|0;z=y;h[z>>3]=w;i=d;return}l=m/+nwa(c[b+536>>2]|0,p,16504,16496,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+6968|0;z=y;h[z>>3]=w;i=d;return}function ix(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6976>>3]=+h[b+6992>>3]- +h[b+6968>>3]*+h[b+584>>3];i=i;return}function jx(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+584>>3]*+h[g+6968>>3];k=+h[g+600>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+6984|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+6984|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,16544,16536,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6984|0;p=o;h[p>>3]=m;i=d;return}function kx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7648>>3]=+h[b+9968>>3]*+h[b+6984>>3];i=i;return}function lx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7608>>3]=+h[b+592>>3]*+h[b+7648>>3];i=i;return}function mx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7688>>3]=+h[b+7648>>3]*+h[b+6976>>3];i=i;return}function nx(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+7648>>3];k=+h[g+7528>>3]- +h[g+592>>3]*+h[g+7568>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1248|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1248|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,16592,16584,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1248|0;p=o;h[p>>3]=m;i=d;return}function ox(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8608>>3]=-+h[b+1248>>3];i=i;return}function px(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+112>>3]*+h[j+6984>>3]*+h[e+1432>>3];l=+h[j+608>>3]+ +h[j+616>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6400|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6400|0;r=q;h[r>>3]=o;i=d;return}s=l/+nwa(c[b+536>>2]|0,k,16616,16608,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6400|0;r=q;h[r>>3]=o;i=d;return}function qx(a){a=a|0;var b=0,d=0.0,e=0.0,f=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+6400>>3];e=+h[b+6408>>3];f=c[a+416>>2]|0;h[b+7152>>3]=+h[f+1536>>3]*(+h[b+9576>>3]*d*d*+h[f+112>>3]- +h[b+9584>>3]*e*e*+h[f+120>>3]);i=i;return}function rx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7800>>3]=+h[b+7152>>3]+(-+h[b+7104>>3]- +h[b+7056>>3]);i=i;return}function sx(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10016>>3];k=+h[g+7800>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1272|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1272|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,16688,16680,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1272|0;p=o;h[p>>3]=m;i=d;return}function tx(a){a=a|0;var b=0,d=0.0,e=0.0,f=0,g=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+7344>>3];e=+h[b+6400>>3];f=c[a+416>>2]|0;g=+h[f+112>>3];h[b+7144>>3]=+h[f+1536>>3]*(+h[b+9568>>3]*d*d*g- +h[b+9576>>3]*e*e*g);i=i;return}function ux(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7792>>3]=+h[b+7144>>3]+(-+h[b+7096>>3]- +h[b+7048>>3]);i=i;return}function vx(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10008>>3];k=+h[g+7792>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1264|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1264|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,16720,16712,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1264|0;p=o;h[p>>3]=m;i=d;return}function wx(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+7448>>3]=+h[b+6400>>3]*+h[d+112>>3]*+h[d+1432>>3]*(+h[b+576>>3]/1.5+(+h[b+7e3>>3]+(+h[b+7008>>3]*.5+ +h[d+1352>>3]*+h[b+6984>>3]*-10.0))+-1.0e5);i=i;return}function xx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8448>>3]=+h[b+7488>>3]+ +h[b+7448>>3];i=i;return}function yx(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+7648>>3];k=+h[g+8448>>3]- +h[g+7568>>3]*+h[g+6976>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+7840|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+7840|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,16592,16744,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7840|0;p=o;h[p>>3]=m;i=d;return}function zx(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+600>>3];k=+h[g+592>>3];l=+h[g+6904>>3]*(k+ +h[g+7784>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+6944|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+6944|0;r=q;h[r>>3]=o;i=d;return}s=k/+nwa(c[b+536>>2]|0,l,16760,16752,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+6944|0;r=q;h[r>>3]=o;i=d;return}function Ax(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6904>>3];k=+zd(1.0e-13,+(+h[g+600>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+nwa(c[b+536>>2]|0,k,16432,16864,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+6912>>3]=m*.6219647130774989;i=d;return}function Bx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+3804>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1256>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1256|0;h[c[g+3808>>2]>>3]=+h[j>>3];k=+aAa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1256>>3]);e=c[f>>2]|0;h[c[e+3812>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+3804>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+1240>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+1240|0;h[(c[e+3808>>2]|0)+8>>3]=+h[g>>3];k=+aAa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+1240>>3]);h[(c[(c[f>>2]|0)+3812>>2]|0)+8>>3]=k;_za(a,47)|0;j=c[(c[f>>2]|0)+3804>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1256>>3]=+h[j>>3];h[f+1240>>3]=+h[j+8>>3];VS(a);WS(a);XS(a);YS(a);ZS(a);_S(a);i=b;return}function Cx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7232>>3]=+h[b+648>>3]*+h[b+10048>>3];i=i;return}function Dx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7224>>3]=+h[b+640>>3]*+h[b+10040>>3];i=i;return}function Ex(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7216>>3]=+h[b+632>>3]*+h[b+10032>>3];i=i;return}function Fx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7208>>3]=+h[b+624>>3]*+h[b+10024>>3];i=i;return}function Gx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7200>>3]=+h[b+616>>3]*+h[b+10016>>3];i=i;return}function Hx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7192>>3]=+h[b+608>>3]*+h[b+10008>>3];i=i;return}function Ix(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0;b=i;i=i+40|0;d=b;e=b+16|0;f=b+32|0;g=i;i=i+8|0;j=i;i=i+16|0;l=i;i=i+16|0;c[g>>2]=16880;Lxa(j,2,16872,g);g=f;h[k>>3]=.99;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];gxa(l,2,.01,f);f=c[a+536>>2]|0;a=e;g=j;c[a+0>>2]=c[g+0>>2];c[a+4>>2]=c[g+4>>2];c[a+8>>2]=c[g+8>>2];g=d;a=l;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];IA(f,16888,e,0,1,d,16904);i=b;return}function Jx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+584>>3],190.0)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+584>>3],647.0)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(16920,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+584>>3],0,1,6)|0)|0,16984)|0,16888)|0,17032)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function Kx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+592>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+592>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(Owa(Owa(17120,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+592>>3],0,1,6)|0)|0,17144)|0,16872)|0,17160)|0,16888)|0,17176)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function Lx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+7784>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+7784>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(Owa(Owa(17280,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+7784>>3],0,1,6)|0)|0,17144)|0,16880)|0,17160)|0,16888)|0,17176)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function Mx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+600>>3],0.0)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(17304,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+600>>3],0,1,6)|0)|0,17320)|0,16888)|0,17344)|0;j=Owa(Owa(g,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+584>>3],0,1,6)|0)|0,17376)|0;f=c[a+536>>2]|0;a=c[63880]|0;g=d;k=17584;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Oe[a&127](f,d,j,e);i=b;return}function Nx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+560>>3],190.0)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+560>>3],647.0)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(16920,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+560>>3],0,1,6)|0)|0,16984)|0,16888)|0,17032)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function Ox(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+568>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+568>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(Owa(Owa(17120,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+568>>3],0,1,6)|0)|0,17144)|0,16872)|0,17160)|0,16888)|0,17176)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function Px(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+7776>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+7776>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(Owa(Owa(17280,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+7776>>3],0,1,6)|0)|0,17144)|0,16880)|0,17160)|0,16888)|0,17176)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function Qx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+576>>3],0.0)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(17304,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+576>>3],0,1,6)|0)|0,17320)|0,16888)|0,17344)|0;j=Owa(Owa(g,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+560>>3],0,1,6)|0)|0,17376)|0;f=c[a+536>>2]|0;a=c[63880]|0;g=d;k=17584;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Oe[a&127](f,d,j,e);i=b;return}function Rx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+536>>3],190.0)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+536>>3],647.0)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(16920,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+536>>3],0,1,6)|0)|0,16984)|0,16888)|0,17032)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function Sx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+544>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+544>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(Owa(Owa(17120,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+544>>3],0,1,6)|0)|0,17144)|0,16872)|0,17160)|0,16888)|0,17176)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function Tx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+7768>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+7768>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(Owa(Owa(17280,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+7768>>3],0,1,6)|0)|0,17144)|0,16880)|0,17160)|0,16888)|0,17176)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function Ux(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+552>>3],0.0)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(17304,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+552>>3],0,1,6)|0)|0,17320)|0,16888)|0,17344)|0;j=Owa(Owa(g,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+536>>3],0,1,6)|0)|0,17376)|0;f=c[a+536>>2]|0;a=c[63880]|0;g=d;k=17584;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Oe[a&127](f,d,j,e);i=b;return}function Vx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+512>>3],190.0)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+512>>3],647.0)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(16920,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+512>>3],0,1,6)|0)|0,16984)|0,16888)|0,17032)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function Wx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+520>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+520>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(Owa(Owa(17120,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+520>>3],0,1,6)|0)|0,17144)|0,16872)|0,17160)|0,16888)|0,17176)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function Xx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+7760>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+7760>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(Owa(Owa(17280,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+7760>>3],0,1,6)|0)|0,17144)|0,16880)|0,17160)|0,16888)|0,17176)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function Yx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+528>>3],0.0)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(17304,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+528>>3],0,1,6)|0)|0,17320)|0,16888)|0,17344)|0;j=Owa(Owa(g,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+512>>3],0,1,6)|0)|0,17376)|0;f=c[a+536>>2]|0;a=c[63880]|0;g=d;k=17584;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Oe[a&127](f,d,j,e);i=b;return}function Zx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+488>>3],190.0)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+488>>3],647.0)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(16920,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+488>>3],0,1,6)|0)|0,16984)|0,16888)|0,17032)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function _x(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+496>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+496>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(Owa(Owa(17120,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+496>>3],0,1,6)|0)|0,17144)|0,16872)|0,17160)|0,16888)|0,17176)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function $x(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+7752>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+7752>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(Owa(Owa(17280,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+7752>>3],0,1,6)|0)|0,17144)|0,16880)|0,17160)|0,16888)|0,17176)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function ay(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+504>>3],0.0)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(17304,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+504>>3],0,1,6)|0)|0,17320)|0,16888)|0,17344)|0;j=Owa(Owa(g,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+488>>3],0,1,6)|0)|0,17376)|0;f=c[a+536>>2]|0;a=c[63880]|0;g=d;k=17584;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Oe[a&127](f,d,j,e);i=b;return}function by(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((Dza(+h[f+1440>>3],+h[f+1464>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[63880]|0;g=d;j=17560;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Oe[a&127](f,d,17456,e);i=b;return}function cy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+432>>3],190.0)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+432>>3],647.0)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(16920,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+432>>3],0,1,6)|0)|0,16984)|0,16888)|0,17032)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function dy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+440>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+440>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(Owa(Owa(17120,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+440>>3],0,1,6)|0)|0,17144)|0,16872)|0,17160)|0,16888)|0,17176)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function ey(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6320>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6320>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(Owa(Owa(17280,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6320>>3],0,1,6)|0)|0,17144)|0,16880)|0,17160)|0,16888)|0,17176)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function fy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+448>>3],0.0)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(17304,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+448>>3],0,1,6)|0)|0,17320)|0,16888)|0,17344)|0;j=Owa(Owa(g,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+432>>3],0,1,6)|0)|0,17376)|0;f=c[a+536>>2]|0;a=c[63880]|0;g=d;k=17584;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Oe[a&127](f,d,j,e);i=b;return}function gy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+408>>3],190.0)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+408>>3],647.0)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(16920,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+408>>3],0,1,6)|0)|0,16984)|0,16888)|0,17032)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function hy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+416>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+416>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(Owa(Owa(17120,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+416>>3],0,1,6)|0)|0,17144)|0,16872)|0,17160)|0,16888)|0,17176)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function iy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6312>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6312>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(Owa(Owa(17280,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6312>>3],0,1,6)|0)|0,17144)|0,16880)|0,17160)|0,16888)|0,17176)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function jy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+424>>3],0.0)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(17304,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+424>>3],0,1,6)|0)|0,17320)|0,16888)|0,17344)|0;j=Owa(Owa(g,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+408>>3],0,1,6)|0)|0,17376)|0;f=c[a+536>>2]|0;a=c[63880]|0;g=d;k=17584;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Oe[a&127](f,d,j,e);i=b;return}function ky(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+384>>3],190.0)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+384>>3],647.0)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(16920,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+384>>3],0,1,6)|0)|0,16984)|0,16888)|0,17032)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function ly(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+392>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+392>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(Owa(Owa(17120,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+392>>3],0,1,6)|0)|0,17144)|0,16872)|0,17160)|0,16888)|0,17176)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function my(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6304>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6304>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(Owa(Owa(17280,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6304>>3],0,1,6)|0)|0,17144)|0,16880)|0,17160)|0,16888)|0,17176)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function ny(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+400>>3],0.0)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(17304,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+400>>3],0,1,6)|0)|0,17320)|0,16888)|0,17344)|0;j=Owa(Owa(g,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+384>>3],0,1,6)|0)|0,17376)|0;f=c[a+536>>2]|0;a=c[63880]|0;g=d;k=17584;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Oe[a&127](f,d,j,e);i=b;return}function oy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+360>>3],190.0)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+360>>3],647.0)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(16920,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+360>>3],0,1,6)|0)|0,16984)|0,16888)|0,17032)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function py(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+368>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+368>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(Owa(Owa(17120,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+368>>3],0,1,6)|0)|0,17144)|0,16872)|0,17160)|0,16888)|0,17176)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function qy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6296>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6296>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(Owa(Owa(17280,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6296>>3],0,1,6)|0)|0,17144)|0,16880)|0,17160)|0,16888)|0,17176)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function ry(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+376>>3],0.0)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(17304,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+376>>3],0,1,6)|0)|0,17320)|0,16888)|0,17344)|0;j=Owa(Owa(g,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+360>>3],0,1,6)|0)|0,17376)|0;f=c[a+536>>2]|0;a=c[63880]|0;g=d;k=17584;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Oe[a&127](f,d,j,e);i=b;return}function sy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+336>>3],190.0)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+336>>3],647.0)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(16920,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+336>>3],0,1,6)|0)|0,16984)|0,16888)|0,17032)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function ty(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+344>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+344>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(Owa(Owa(17120,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+344>>3],0,1,6)|0)|0,17144)|0,16872)|0,17160)|0,16888)|0,17176)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function uy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6288>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6288>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(Owa(Owa(17280,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6288>>3],0,1,6)|0)|0,17144)|0,16880)|0,17160)|0,16888)|0,17176)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function vy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+352>>3],0.0)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(17304,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+352>>3],0,1,6)|0)|0,17320)|0,16888)|0,17344)|0;j=Owa(Owa(g,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+336>>3],0,1,6)|0)|0,17376)|0;f=c[a+536>>2]|0;a=c[63880]|0;g=d;k=17584;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Oe[a&127](f,d,j,e);i=b;return}function wy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((Dza(+h[f+1664>>3],+h[f+1688>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[63880]|0;g=d;j=17560;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Oe[a&127](f,d,17456,e);i=b;return}function xy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+264>>3],190.0)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+264>>3],647.0)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(16920,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+264>>3],0,1,6)|0)|0,16984)|0,16888)|0,17032)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function yy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+272>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+272>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(Owa(Owa(17120,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+272>>3],0,1,6)|0)|0,17144)|0,16872)|0,17160)|0,16888)|0,17176)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function zy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+4440>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+4440>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(Owa(Owa(17280,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+4440>>3],0,1,6)|0)|0,17144)|0,16880)|0,17160)|0,16888)|0,17176)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function Ay(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+280>>3],0.0)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(17304,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+280>>3],0,1,6)|0)|0,17320)|0,16888)|0,17344)|0;j=Owa(Owa(g,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+264>>3],0,1,6)|0)|0,17376)|0;f=c[a+536>>2]|0;a=c[63880]|0;g=d;k=17584;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Oe[a&127](f,d,j,e);i=b;return}function By(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+240>>3],190.0)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+240>>3],647.0)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(16920,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+240>>3],0,1,6)|0)|0,16984)|0,16888)|0,17032)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function Cy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+248>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+248>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(Owa(Owa(17120,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+248>>3],0,1,6)|0)|0,17144)|0,16872)|0,17160)|0,16888)|0,17176)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function Dy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+4432>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+4432>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(Owa(Owa(17280,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+4432>>3],0,1,6)|0)|0,17144)|0,16880)|0,17160)|0,16888)|0,17176)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function Ey(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+256>>3],0.0)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(17304,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+256>>3],0,1,6)|0)|0,17320)|0,16888)|0,17344)|0;j=Owa(Owa(g,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+240>>3],0,1,6)|0)|0,17376)|0;f=c[a+536>>2]|0;a=c[63880]|0;g=d;k=17584;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Oe[a&127](f,d,j,e);i=b;return}function Fy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+216>>3],190.0)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+216>>3],647.0)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(16920,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+216>>3],0,1,6)|0)|0,16984)|0,16888)|0,17032)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function Gy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+224>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+224>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(Owa(Owa(17120,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+224>>3],0,1,6)|0)|0,17144)|0,16872)|0,17160)|0,16888)|0,17176)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function Hy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+4424>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+4424>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(Owa(Owa(17280,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+4424>>3],0,1,6)|0)|0,17144)|0,16880)|0,17160)|0,16888)|0,17176)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function Iy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+232>>3],0.0)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(17304,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+232>>3],0,1,6)|0)|0,17320)|0,16888)|0,17344)|0;j=Owa(Owa(g,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+216>>3],0,1,6)|0)|0,17376)|0;f=c[a+536>>2]|0;a=c[63880]|0;g=d;k=17584;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Oe[a&127](f,d,j,e);i=b;return}function Jy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+192>>3],190.0)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+192>>3],647.0)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(16920,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+192>>3],0,1,6)|0)|0,16984)|0,16888)|0,17032)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function Ky(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+200>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+200>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(Owa(Owa(17120,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+200>>3],0,1,6)|0)|0,17144)|0,16872)|0,17160)|0,16888)|0,17176)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function Ly(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+4416>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+4416>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(Owa(Owa(17280,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+4416>>3],0,1,6)|0)|0,17144)|0,16880)|0,17160)|0,16888)|0,17176)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function My(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+208>>3],0.0)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(17304,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+208>>3],0,1,6)|0)|0,17320)|0,16888)|0,17344)|0;j=Owa(Owa(g,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+192>>3],0,1,6)|0)|0,17376)|0;f=c[a+536>>2]|0;a=c[63880]|0;g=d;k=17584;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Oe[a&127](f,d,j,e);i=b;return}function Ny(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+168>>3],190.0)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+168>>3],647.0)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(16920,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+168>>3],0,1,6)|0)|0,16984)|0,16888)|0,17032)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function Oy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+176>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+176>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(Owa(Owa(17120,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+176>>3],0,1,6)|0)|0,17144)|0,16872)|0,17160)|0,16888)|0,17176)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function Py(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+4408>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+4408>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(Owa(Owa(17280,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+4408>>3],0,1,6)|0)|0,17144)|0,16880)|0,17160)|0,16888)|0,17176)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function Qy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+184>>3],0.0)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(17304,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+184>>3],0,1,6)|0)|0,17320)|0,16888)|0,17344)|0;j=Owa(Owa(g,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+168>>3],0,1,6)|0)|0,17376)|0;f=c[a+536>>2]|0;a=c[63880]|0;g=d;k=17584;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Oe[a&127](f,d,j,e);i=b;return}function Ry(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((Dza(+h[f+1896>>3],+h[f+1920>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[63880]|0;g=d;j=17560;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Oe[a&127](f,d,17456,e);i=b;return}function Sy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+96>>3],190.0)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+96>>3],647.0)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(16920,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+96>>3],0,1,6)|0)|0,16984)|0,16888)|0,17032)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function Ty(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+104>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+104>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(Owa(Owa(17120,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+104>>3],0,1,6)|0)|0,17144)|0,16872)|0,17160)|0,16888)|0,17176)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function Uy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+2872>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+2872>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(Owa(Owa(17280,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+2872>>3],0,1,6)|0)|0,17144)|0,16880)|0,17160)|0,16888)|0,17176)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function Vy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+112>>3],0.0)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(17304,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+112>>3],0,1,6)|0)|0,17320)|0,16888)|0,17344)|0;j=Owa(Owa(g,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+96>>3],0,1,6)|0)|0,17376)|0;f=c[a+536>>2]|0;a=c[63880]|0;g=d;k=17584;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Oe[a&127](f,d,j,e);i=b;return}function Wy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+72>>3],190.0)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+72>>3],647.0)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(16920,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+72>>3],0,1,6)|0)|0,16984)|0,16888)|0,17032)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function Xy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+80>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+80>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(Owa(Owa(17120,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+80>>3],0,1,6)|0)|0,17144)|0,16872)|0,17160)|0,16888)|0,17176)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function Yy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+2864>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+2864>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(Owa(Owa(17280,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+2864>>3],0,1,6)|0)|0,17144)|0,16880)|0,17160)|0,16888)|0,17176)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function Zy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+88>>3],0.0)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(17304,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+88>>3],0,1,6)|0)|0,17320)|0,16888)|0,17344)|0;j=Owa(Owa(g,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+72>>3],0,1,6)|0)|0,17376)|0;f=c[a+536>>2]|0;a=c[63880]|0;g=d;k=17584;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Oe[a&127](f,d,j,e);i=b;return}function _y(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+48>>3],190.0)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+48>>3],647.0)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(16920,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+48>>3],0,1,6)|0)|0,16984)|0,16888)|0,17032)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function $y(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+56>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+56>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(Owa(Owa(17120,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+56>>3],0,1,6)|0)|0,17144)|0,16872)|0,17160)|0,16888)|0,17176)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function az(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+2856>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+2856>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(Owa(Owa(17280,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+2856>>3],0,1,6)|0)|0,17144)|0,16880)|0,17160)|0,16888)|0,17176)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function bz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+64>>3],0.0)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(17304,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+64>>3],0,1,6)|0)|0,17320)|0,16888)|0,17344)|0;j=Owa(Owa(g,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+48>>3],0,1,6)|0)|0,17376)|0;f=c[a+536>>2]|0;a=c[63880]|0;g=d;k=17584;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Oe[a&127](f,d,j,e);i=b;return}function cz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+24>>3],190.0)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+24>>3],647.0)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(16920,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+24>>3],0,1,6)|0)|0,16984)|0,16888)|0,17032)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function dz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+32>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+32>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(Owa(Owa(17120,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+32>>3],0,1,6)|0)|0,17144)|0,16872)|0,17160)|0,16888)|0,17176)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function ez(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+2848>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+2848>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(Owa(Owa(17280,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+2848>>3],0,1,6)|0)|0,17144)|0,16880)|0,17160)|0,16888)|0,17176)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function fz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+40>>3],0.0)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(17304,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+40>>3],0,1,6)|0)|0,17320)|0,16888)|0,17344)|0;j=Owa(Owa(g,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+24>>3],0,1,6)|0)|0,17376)|0;f=c[a+536>>2]|0;a=c[63880]|0;g=d;k=17584;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Oe[a&127](f,d,j,e);i=b;return}function gz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[c[(c[c[f>>2]>>2]|0)+8>>2]>>3],190.0)|0;if(!(g<<24>>24==0|(Bza(+h[c[(c[c[f>>2]>>2]|0)+8>>2]>>3],647.0)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(16920,Mwa(+h[c[(c[c[f>>2]>>2]|0)+8>>2]>>3],0,1,6)|0)|0,16984)|0,16888)|0,17032)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function hz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(Owa(Owa(17120,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8>>3],0,1,6)|0)|0,17144)|0,16872)|0,17160)|0,16888)|0,17176)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function iz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+2840>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Bza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+2840>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(Owa(Owa(17280,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+2840>>3],0,1,6)|0)|0,17144)|0,16880)|0,17160)|0,16888)|0,17176)|0;f=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](f,d,g,e);i=b;return}function jz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+16>>3],0.0)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(17304,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+16>>3],0,1,6)|0)|0,17320)|0,16888)|0,17344)|0;j=Owa(Owa(g,Mwa(+h[c[(c[c[f>>2]>>2]|0)+8>>2]>>3],0,1,6)|0)|0,17376)|0;f=c[a+536>>2]|0;a=c[63880]|0;g=d;k=17584;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Oe[a&127](f,d,j,e);i=b;return}function kz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((Dza(+h[f+2120>>3],+h[f+2144>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[63880]|0;g=d;j=17560;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Oe[a&127](f,d,17456,e);i=b;return}function lz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((Dza(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+10672>>3],0.0)|0)<<24>>24==0)){i=b;return}g=Owa(Owa(Owa(Owa(17304,Mwa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+10672>>3],0,1,6)|0)|0,17320)|0,16888)|0,17344)|0;f=Owa(Owa(g,Mwa(293.15,0,1,6)|0)|0,17376)|0;g=c[a+536>>2]|0;a=c[63880]|0;j=d;k=17584;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&127](g,d,f,e);i=b;return}function mz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0;b=i;i=i+40|0;d=b;e=b+16|0;f=b+32|0;g=i;i=i+8|0;j=i;i=i+16|0;l=i;i=i+16|0;c[g>>2]=16880;Lxa(j,2,16872,g);g=f;h[k>>3]=.99;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];gxa(l,2,.01,f);f=c[a+536>>2]|0;a=e;g=j;c[a+0>>2]=c[g+0>>2];c[a+4>>2]=c[g+4>>2];c[a+8>>2]=c[g+8>>2];g=d;a=l;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];IA(f,16888,e,0,1,d,16904);i=b;return}function nz(b){b=b|0;var c=0;c=i;a[b+315|0]=0;a[b+314|0]=1;jf(b);kf(b);lf(b);mf(b);nf(b);of(b);pf(b);qf(b);rf(b);sf(b);tf(b);uf(b);vf(b);wf(b);xf(b);yf(b);zf(b);Af(b);Bf(b);Cf(b);Df(b);Ef(b);Ff(b);Gf(b);Hf(b);If(b);Jf(b);Kf(b);Lf(b);Mf(b);Nf(b);Of(b);Pf(b);Qf(b);Rf(b);Sf(b);Tf(b);Uf(b);Vf(b);Wf(b);Xf(b);Yf(b);Zf(b);_f(b);$f(b);ag(b);bg(b);cg(b);dg(b);eg(b);fg(b);gg(b);hg(b);ig(b);jg(b);kg(b);lg(b);mg(b);ng(b);og(b);pg(b);qg(b);rg(b);sg(b);tg(b);ug(b);vg(b);wg(b);xg(b);yg(b);zg(b);Ag(b);Bg(b);Cg(b);Dg(b);Eg(b);Fg(b);Gg(b);Hg(b);Ig(b);Jg(b);Kg(b);Lg(b);Mg(b);Ng(b);Og(b);Pg(b);Qg(b);Rg(b);Sg(b);Tg(b);Ug(b);Vg(b);Wg(b);Xg(b);Yg(b);Zg(b);_g(b);$g(b);ah(b);bh(b);ch(b);dh(b);eh(b);fh(b);gh(b);hh(b);ih(b);jh(b);kh(b);lh(b);mh(b);nh(b);oh(b);ph(b);qh(b);rh(b);sh(b);th(b);uh(b);vh(b);wh(b);xh(b);yh(b);zh(b);Ah(b);Bh(b);Ch(b);Dh(b);Eh(b);Fh(b);Gh(b);Hh(b);Ih(b);Jh(b);Kh(b);Lh(b);Mh(b);Nh(b);Oh(b);Ph(b);Qh(b);Rh(b);Sh(b);Th(b);Uh(b);Vh(b);Wh(b);Xh(b);Yh(b);Zh(b);_h(b);$h(b);ai(b);bi(b);ci(b);di(b);ei(b);fi(b);gi(b);hi(b);ii(b);ji(b);ki(b);li(b);mi(b);ni(b);oi(b);pi(b);qi(b);ri(b);si(b);ti(b);ui(b);vi(b);wi(b);xi(b);yi(b);zi(b);Ai(b);Bi(b);Ci(b);Di(b);Ei(b);Fi(b);Gi(b);Hi(b);Ii(b);Ji(b);Ki(b);Li(b);Mi(b);Ni(b);Oi(b);Pi(b);Qi(b);Ri(b);Si(b);Ti(b);Ui(b);Vi(b);Wi(b);Xi(b);Yi(b);Zi(b);_i(b);$i(b);aj(b);bj(b);cj(b);dj(b);ej(b);fj(b);gj(b);hj(b);ij(b);jj(b);kj(b);lj(b);mj(b);nj(b);oj(b);pj(b);qj(b);rj(b);sj(b);tj(b);uj(b);vj(b);wj(b);xj(b);yj(b);zj(b);Aj(b);Bj(b);Cj(b);Dj(b);Ej(b);Fj(b);Gj(b);Hj(b);Ij(b);Jj(b);Kj(b);Lj(b);Mj(b);Nj(b);Oj(b);Pj(b);Qj(b);Rj(b);Sj(b);Tj(b);Uj(b);Vj(b);Wj(b);Xj(b);Yj(b);Zj(b);_j(b);$j(b);ak(b);bk(b);ck(b);dk(b);ek(b);fk(b);gk(b);hk(b);ik(b);jk(b);kk(b);lk(b);mk(b);nk(b);ok(b);pk(b);qk(b);rk(b);sk(b);tk(b);uk(b);vk(b);wk(b);xk(b);yk(b);zk(b);Ak(b);Bk(b);Ck(b);Dk(b);Ek(b);Fk(b);Gk(b);Hk(b);Ik(b);Jk(b);Kk(b);Lk(b);Mk(b);Nk(b);Ok(b);Pk(b);Qk(b);Rk(b);Sk(b);Tk(b);Uk(b);Vk(b);Wk(b);Xk(b);Yk(b);Zk(b);_k(b);$k(b);al(b);bl(b);cl(b);dl(b);el(b);fl(b);gl(b);hl(b);il(b);jl(b);kl(b);ll(b);ml(b);nl(b);ol(b);pl(b);ql(b);rl(b);sl(b);tl(b);ul(b);vl(b);wl(b);xl(b);yl(b);zl(b);Al(b);Bl(b);Cl(b);Dl(b);El(b);Fl(b);Gl(b);Hl(b);Il(b);Jl(b);Kl(b);Ll(b);Ml(b);Nl(b);Ol(b);Pl(b);Ql(b);Rl(b);Sl(b);Tl(b);Ul(b);Vl(b);Wl(b);Xl(b);Yl(b);Zl(b);_l(b);$l(b);am(b);bm(b);cm(b);dm(b);em(b);fm(b);gm(b);hm(b);im(b);jm(b);km(b);lm(b);mm(b);nm(b);om(b);pm(b);qm(b);rm(b);sm(b);tm(b);um(b);vm(b);wm(b);xm(b);ym(b);zm(b);Am(b);Bm(b);Cm(b);Dm(b);Em(b);Fm(b);Gm(b);Hm(b);Im(b);Jm(b);Km(b);Lm(b);Mm(b);Nm(b);Om(b);Pm(b);Qm(b);Rm(b);Sm(b);Tm(b);Um(b);Vm(b);Wm(b);Xm(b);Ym(b);Zm(b);_m(b);$m(b);an(b);bn(b);cn(b);dn(b);en(b);fn(b);gn(b);hn(b);jn(b);kn(b);ln(b);mn(b);nn(b);on(b);pn(b);qn(b);rn(b);sn(b);tn(b);un(b);vn(b);wn(b);xn(b);yn(b);zn(b);An(b);Bn(b);Cn(b);Dn(b);En(b);Fn(b);Gn(b);Hn(b);In(b);Jn(b);Kn(b);Ln(b);Mn(b);Nn(b);On(b);Pn(b);Qn(b);Rn(b);Sn(b);Tn(b);Un(b);Vn(b);Wn(b);Xn(b);Yn(b);Zn(b);_n(b);$n(b);ao(b);bo(b);co(b);eo(b);fo(b);go(b);ho(b);io(b);jo(b);ko(b);lo(b);mo(b);no(b);oo(b);po(b);qo(b);ro(b);so(b);to(b);uo(b);vo(b);wo(b);xo(b);yo(b);zo(b);Ao(b);Bo(b);Co(b);Do(b);Eo(b);Fo(b);Go(b);Ho(b);Io(b);Jo(b);Ko(b);Lo(b);Mo(b);No(b);Oo(b);Po(b);Qo(b);Ro(b);So(b);To(b);Uo(b);Vo(b);Wo(b);Xo(b);Yo(b);Zo(b);_o(b);$o(b);ap(b);bp(b);cp(b);dp(b);ep(b);fp(b);gp(b);hp(b);ip(b);jp(b);kp(b);lp(b);mp(b);np(b);op(b);pp(b);qp(b);rp(b);sp(b);tp(b);up(b);vp(b);wp(b);xp(b);yp(b);zp(b);Ap(b);Bp(b);Cp(b);Dp(b);Ep(b);Fp(b);Gp(b);Hp(b);Ip(b);Jp(b);Kp(b);Lp(b);Mp(b);Np(b);Op(b);Pp(b);Qp(b);Rp(b);Sp(b);Tp(b);Up(b);Vp(b);Wp(b);Xp(b);Yp(b);Zp(b);_p(b);$p(b);aq(b);bq(b);cq(b);dq(b);eq(b);fq(b);gq(b);hq(b);iq(b);jq(b);kq(b);lq(b);mq(b);nq(b);oq(b);pq(b);qq(b);rq(b);sq(b);tq(b);uq(b);vq(b);wq(b);xq(b);yq(b);zq(b);Aq(b);Bq(b);Cq(b);Dq(b);Eq(b);Fq(b);Gq(b);Hq(b);Iq(b);Jq(b);Kq(b);Lq(b);Mq(b);Nq(b);Oq(b);Pq(b);Qq(b);Rq(b);Sq(b);Tq(b);Uq(b);Vq(b);Wq(b);Xq(b);Yq(b);Zq(b);_q(b);$q(b);ar(b);br(b);cr(b);dr(b);er(b);fr(b);gr(b);hr(b);ir(b);jr(b);kr(b);lr(b);mr(b);nr(b);or(b);pr(b);qr(b);rr(b);sr(b);tr(b);ur(b);vr(b);wr(b);xr(b);yr(b);zr(b);Ar(b);Br(b);Cr(b);Dr(b);Er(b);Fr(b);Gr(b);Hr(b);Ir(b);Jr(b);Kr(b);Lr(b);Mr(b);Nr(b);Or(b);Pr(b);Qr(b);Rr(b);Sr(b);Tr(b);Ur(b);Vr(b);Wr(b);Xr(b);Yr(b);Zr(b);_r(b);$r(b);as(b);bs(b);cs(b);ds(b);es(b);fs(b);gs(b);hs(b);is(b);js(b);ks(b);ls(b);ms(b);ns(b);os(b);ps(b);qs(b);rs(b);ss(b);ts(b);us(b);vs(b);ws(b);xs(b);ys(b);zs(b);As(b);Bs(b);Cs(b);Ds(b);Es(b);Fs(b);Gs(b);Hs(b);Is(b);Js(b);Ks(b);Ls(b);Ms(b);Ns(b);Os(b);Ps(b);Qs(b);Rs(b);Ss(b);Ts(b);Us(b);Vs(b);Ws(b);Xs(b);Ys(b);Zs(b);_s(b);$s(b);at(b);bt(b);ct(b);dt(b);et(b);ft(b);gt(b);ht(b);it(b);jt(b);kt(b);lt(b);mt(b);nt(b);ot(b);pt(b);qt(b);rt(b);st(b);tt(b);ut(b);vt(b);wt(b);xt(b);yt(b);zt(b);At(b);Bt(b);Ct(b);Dt(b);Et(b);Ft(b);Gt(b);Ht(b);It(b);Jt(b);Kt(b);Lt(b);Mt(b);Nt(b);Ot(b);Pt(b);Qt(b);Rt(b);St(b);Tt(b);Ut(b);Vt(b);Wt(b);Xt(b);Yt(b);Zt(b);_t(b);$t(b);au(b);bu(b);cu(b);du(b);eu(b);fu(b);gu(b);hu(b);iu(b);ju(b);ku(b);lu(b);mu(b);nu(b);ou(b);pu(b);qu(b);ru(b);su(b);tu(b);uu(b);vu(b);wu(b);xu(b);yu(b);zu(b);Au(b);Bu(b);Cu(b);Du(b);Eu(b);Fu(b);Gu(b);Hu(b);Iu(b);Ju(b);Ku(b);Lu(b);Mu(b);Nu(b);Ou(b);Pu(b);Qu(b);Ru(b);Su(b);Tu(b);Uu(b);Vu(b);Wu(b);Xu(b);Yu(b);Zu(b);_u(b);$u(b);av(b);bv(b);cv(b);dv(b);ev(b);fv(b);gv(b);hv(b);iv(b);jv(b);kv(b);lv(b);mv(b);nv(b);ov(b);pv(b);qv(b);rv(b);sv(b);tv(b);uv(b);vv(b);wv(b);xv(b);yv(b);zv(b);Av(b);Bv(b);Cv(b);Dv(b);Ev(b);Fv(b);Gv(b);Hv(b);Iv(b);Jv(b);Kv(b);Lv(b);Mv(b);Nv(b);Ov(b);Pv(b);Qv(b);Rv(b);Sv(b);Tv(b);Uv(b);Vv(b);Wv(b);Xv(b);Yv(b);Zv(b);_v(b);$v(b);aw(b);bw(b);cw(b);dw(b);ew(b);fw(b);gw(b);hw(b);iw(b);jw(b);kw(b);lw(b);mw(b);nw(b);ow(b);pw(b);qw(b);rw(b);sw(b);tw(b);uw(b);vw(b);ww(b);xw(b);yw(b);zw(b);Aw(b);Bw(b);Cw(b);Dw(b);Ew(b);Fw(b);Gw(b);Hw(b);Iw(b);Jw(b);Kw(b);Lw(b);Mw(b);Nw(b);Ow(b);Pw(b);Qw(b);Rw(b);Sw(b);Tw(b);Uw(b);Vw(b);Ww(b);Xw(b);Yw(b);Zw(b);_w(b);$w(b);ax(b);bx(b);cx(b);dx(b);ex(b);fx(b);gx(b);hx(b);ix(b);jx(b);kx(b);lx(b);mx(b);nx(b);ox(b);px(b);qx(b);rx(b);sx(b);tx(b);ux(b);vx(b);wx(b);xx(b);yx(b);zx(b);Ax(b);Bx(b);Cx(b);Dx(b);Ex(b);Fx(b);Gx(b);Hx(b);Ix(b);Jx(b);Kx(b);Lx(b);Mx(b);Nx(b);Ox(b);Px(b);Qx(b);Rx(b);Sx(b);Tx(b);Ux(b);Vx(b);Wx(b);Xx(b);Yx(b);Zx(b);_x(b);$x(b);ay(b);by(b);cy(b);dy(b);ey(b);fy(b);gy(b);hy(b);iy(b);jy(b);ky(b);ly(b);my(b);ny(b);oy(b);py(b);qy(b);ry(b);sy(b);ty(b);uy(b);vy(b);wy(b);xy(b);yy(b);zy(b);Ay(b);By(b);Cy(b);Dy(b);Ey(b);Fy(b);Gy(b);Hy(b);Iy(b);Jy(b);Ky(b);Ly(b);My(b);Ny(b);Oy(b);Py(b);Qy(b);Ry(b);Sy(b);Ty(b);Uy(b);Vy(b);Wy(b);Xy(b);Yy(b);Zy(b);_y(b);$y(b);az(b);bz(b);cz(b);dz(b);ez(b);fz(b);gz(b);hz(b);iz(b);jz(b);kz(b);lz(b);mz(b);i=c;return 0}function oz(b){b=b|0;var c=0;c=i;a[b+314|0]=0;pz(b);i=c;return 0}function pz(a){a=a|0;var b=0;b=i;ag(a);bg(a);cg(a);dg(a);eg(a);fg(a);gg(a);hg(a);ig(a);jg(a);kg(a);lg(a);mg(a);ng(a);og(a);pg(a);qg(a);rg(a);sg(a);tg(a);zg(a);Ag(a);Bg(a);Cg(a);Dg(a);Eg(a);Fg(a);Gg(a);Hg(a);Ig(a);Jg(a);Kg(a);Lg(a);Vg(a);Wg(a);Xg(a);Yg(a);Zg(a);_g(a);$g(a);ah(a);bh(a);ch(a);dh(a);eh(a);fh(a);gh(a);hh(a);ih(a);jh(a);ph(a);qh(a);rh(a);sh(a);th(a);uh(a);vh(a);wh(a);xh(a);yh(a);zh(a);Ah(a);Bh(a);Ch(a);Dh(a);Eh(a);Fh(a);Gh(a);Hh(a);Ih(a);Jh(a);Th(a);Uh(a);Vh(a);Wh(a);Yh(a);Zh(a);_h(a);$h(a);ai(a);bi(a);ci(a);di(a);ei(a);fi(a);gi(a);hi(a);ii(a);ji(a);ki(a);li(a);mi(a);ni(a);oi(a);pi(a);qi(a);ri(a);si(a);ti(a);ui(a);vi(a);wi(a);xi(a);yi(a);Bi(a);Ci(a);Ei(a);Fi(a);Gi(a);Ii(a);Ji(a);Ki(a);Li(a);Mi(a);Ni(a);Oi(a);Pi(a);Si(a);Ti(a);Ui(a);Vi(a);Wi(a);Xi(a);_i(a);$i(a);aj(a);bj(a);ej(a);fj(a);hj(a);ij(a);jj(a);kj(a);lj(a);mj(a);nj(a);pj(a);qj(a);rj(a);sj(a);tj(a);uj(a);vj(a);wj(a);zj(a);Aj(a);Bj(a);Cj(a);Dj(a);Ej(a);Hj(a);Ij(a);Jj(a);Kj(a);Nj(a);Oj(a);Qj(a);Rj(a);Sj(a);Tj(a);Uj(a);Vj(a);Wj(a);Yj(a);Zj(a);_j(a);$j(a);ak(a);bk(a);ck(a);dk(a);gk(a);hk(a);ik(a);jk(a);kk(a);lk(a);ok(a);pk(a);qk(a);rk(a);uk(a);vk(a);xk(a);yk(a);zk(a);Ak(a);Bk(a);Ck(a);Dk(a);Fk(a);Gk(a);Hk(a);Ik(a);Jk(a);Kk(a);Lk(a);Mk(a);Pk(a);Qk(a);Rk(a);Sk(a);Tk(a);Uk(a);Xk(a);Yk(a);Zk(a);_k(a);bl(a);cl(a);el(a);fl(a);gl(a);hl(a);il(a);jl(a);kl(a);ml(a);nl(a);ol(a);pl(a);ql(a);rl(a);sl(a);tl(a);wl(a);xl(a);yl(a);zl(a);Al(a);Bl(a);Kl(a);Ml(a);Pl(a);Ql(a);Rl(a);Sl(a);Tl(a);Ul(a);Vl(a);Wl(a);Xl(a);Yl(a);$l(a);am(a);bm(a);em(a);fm(a);gm(a);jm(a);km(a);mm(a);nm(a);om(a);qm(a);rm(a);sm(a);tm(a);um(a);vm(a);wm(a);xm(a);Am(a);Bm(a);Cm(a);Dm(a);Em(a);Fm(a);Im(a);Jm(a);Km(a);Lm(a);Om(a);Pm(a);Rm(a);Sm(a);Tm(a);Um(a);Vm(a);Wm(a);Xm(a);Zm(a);_m(a);$m(a);an(a);bn(a);cn(a);dn(a);en(a);hn(a);jn(a);kn(a);ln(a);mn(a);nn(a);qn(a);rn(a);sn(a);tn(a);wn(a);xn(a);zn(a);An(a);Bn(a);Cn(a);Dn(a);En(a);Fn(a);Hn(a);In(a);Jn(a);Kn(a);Ln(a);Mn(a);Nn(a);On(a);Rn(a);Sn(a);Tn(a);Un(a);Vn(a);Wn(a);Zn(a);_n(a);$n(a);ao(a);eo(a);fo(a);ho(a);io(a);jo(a);ko(a);lo(a);mo(a);no(a);po(a);qo(a);ro(a);so(a);to(a);uo(a);vo(a);wo(a);zo(a);Ao(a);Bo(a);Co(a);Do(a);Eo(a);No(a);Oo(a);Po(a);Qo(a);Ro(a);To(a);Uo(a);Vo(a);Wo(a);Yo(a);Zo(a);_o(a);$o(a);ap(a);bp(a);cp(a);dp(a);ep(a);fp(a);gp(a);hp(a);jp(a);kp(a);lp(a);mp(a);op(a);pp(a);qp(a);rp(a);sp(a);tp(a);up(a);vp(a);wp(a);xp(a);yp(a);zp(a);Ap(a);Bp(a);Cp(a);Ep(a);Fp(a);Gp(a);Hp(a);Ip(a);Jp(a);Kp(a);Lp(a);Mp(a);Np(a);Qp(a);Rp(a);Sp(a);Tp(a);Up(a);Vp(a);Wp(a);Xp(a);Yp(a);Zp(a);_p(a);bq(a);cq(a);dq(a);eq(a);fq(a);gq(a);hq(a);iq(a);jq(a);lq(a);mq(a);oq(a);pq(a);qq(a);rq(a);sq(a);tq(a);uq(a);wq(a);xq(a);yq(a);zq(a);Aq(a);Bq(a);Cq(a);Dq(a);Gq(a);Hq(a);Iq(a);Jq(a);Kq(a);Lq(a);Mq(a);Nq(a);Oq(a);Pq(a);Qq(a);Rq(a);Sq(a);Tq(a);Wq(a);Xq(a);Yq(a);Zq(a);_q(a);$q(a);ar(a);br(a);cr(a);er(a);fr(a);hr(a);ir(a);jr(a);kr(a);lr(a);mr(a);nr(a);pr(a);qr(a);rr(a);sr(a);tr(a);ur(a);vr(a);wr(a);zr(a);Ar(a);Br(a);Cr(a);Dr(a);Er(a);Fr(a);Gr(a);Hr(a);Ir(a);Jr(a);Kr(a);Lr(a);Mr(a);Pr(a);Qr(a);Rr(a);Sr(a);Tr(a);Ur(a);Vr(a);Wr(a);Xr(a);Zr(a);_r(a);as(a);bs(a);cs(a);ds(a);es(a);fs(a);gs(a);is(a);js(a);ks(a);ls(a);ms(a);ns(a);os(a);ps(a);ss(a);ts(a);us(a);vs(a);ws(a);xs(a);ys(a);zs(a);As(a);Bs(a);Cs(a);Ds(a);Es(a);Fs(a);Is(a);Js(a);Ks(a);Ls(a);Ms(a);Ns(a);Os(a);Ps(a);Qs(a);Rs(a);Ss(a);Ts(a);Us(a);Ws(a);Xs(a);Zs(a);_s(a);$s(a);at(a);bt(a);ct(a);dt(a);ft(a);gt(a);ht(a);it(a);jt(a);kt(a);lt(a);mt(a);pt(a);qt(a);rt(a);st(a);tt(a);ut(a);vt(a);wt(a);xt(a);yt(a);zt(a);At(a);Bt(a);Ct(a);Dt(a);Kt(a);Lt(a);Mt(a);Nt(a);Ot(a);Qt(a);Rt(a);St(a);Tt(a);Vt(a);Wt(a);Xt(a);Yt(a);Zt(a);_t(a);$t(a);au(a);cu(a);du(a);eu(a);fu(a);gu(a);hu(a);iu(a);lu(a);mu(a);ou(a);pu(a);qu(a);su(a);tu(a);uu(a);vu(a);wu(a);xu(a);yu(a);zu(a);Cu(a);Du(a);Eu(a);Fu(a);Gu(a);Hu(a);Ku(a);Lu(a);Mu(a);Nu(a);Qu(a);Ru(a);Tu(a);Uu(a);Vu(a);Wu(a);Xu(a);Yu(a);Zu(a);$u(a);av(a);bv(a);cv(a);dv(a);ev(a);fv(a);gv(a);jv(a);kv(a);lv(a);mv(a);nv(a);ov(a);rv(a);sv(a);tv(a);uv(a);xv(a);yv(a);Av(a);Bv(a);Cv(a);Dv(a);Ev(a);Fv(a);Gv(a);Iv(a);Jv(a);Kv(a);Lv(a);Mv(a);Nv(a);Ov(a);Pv(a);Sv(a);Tv(a);Uv(a);Vv(a);Wv(a);Xv(a);_v(a);$v(a);aw(a);bw(a);ew(a);fw(a);hw(a);iw(a);jw(a);kw(a);lw(a);mw(a);nw(a);pw(a);qw(a);rw(a);sw(a);tw(a);uw(a);vw(a);ww(a);zw(a);Aw(a);Bw(a);Cw(a);Dw(a);Ew(a);Hw(a);Iw(a);Jw(a);Kw(a);Lw(a);Mw(a);Pw(a);Qw(a);Rw(a);Uw(a);Vw(a);Ww(a);Xw(a);Yw(a);Zw(a);_w(a);ax(a);bx(a);dx(a);ex(a);fx(a);gx(a);hx(a);ix(a);jx(a);kx(a);nx(a);ox(a);px(a);qx(a);rx(a);sx(a);tx(a);ux(a);vx(a);wx(a);xx(a);yx(a);Bx(a);i=b;return}function qz(a,b){a=a|0;b=+b;i=i;return 0}function rz(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;kwa(c[a+536>>2]|0,(a|0)!=0|0,17816,b);c[a+540>>2]=17624;c[a+84>>2]=17848;c[a+88>>2]=17848;c[a+92>>2]=17896;c[a+96>>2]=17968;c[a+100>>2]=0;c[a+60>>2]=0;c[a+112>>2]=82;c[a+116>>2]=1373;d=a+136|0;e=a+120|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[d>>2]=298;c[a+140>>2]=73;c[a+144>>2]=134;c[a+148>>2]=0;c[a+152>>2]=0;c[a+156>>2]=0;c[a+232>>2]=5;c[a+216>>2]=996;c[a+220>>2]=0;c[a+224>>2]=0;c[a+228>>2]=0;c[a+160>>2]=2;c[a+104>>2]=0;c[a+164>>2]=2;c[a+168>>2]=0;c[a+176>>2]=90;c[a+180>>2]=0;c[a+184>>2]=90;c[a+188>>2]=0;c[a+56>>2]=18008;c[a+64>>2]=89;c[a+72>>2]=0;c[a+68>>2]=4001;c[a+192>>2]=0;c[a+196>>2]=5;c[a+200>>2]=48;c[a+204>>2]=0;c[a+208>>2]=0;c[a+212>>2]=0;c[a+172>>2]=0;i=b;return}function sz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0;d=i;e=i;i=i+168|0;c[e>>2]=0;f=i;i=i+544|0;g=i;i=i+88|0;h=i;i=i+160|0;j=i;i=i+160|0;u=0;Pa(3);k=u;u=0;if((k|0)!=0&(v|0)!=0){l=K$a(c[k>>2]|0,e)|0;if((l|0)==0){fb(k|0,v|0)}J=v}else{l=-1}k=J;do{if((l|0)==1){m=0;n=0;o=0;p=0;q=0;s=0;t=k}else if((l|0)==2){w=0;x=0;y=0;z=0;A=0;B=0;C=k;D=7}else{E=207024;F=207048;c[E+0>>2]=c[F+0>>2];c[E+4>>2]=c[F+4>>2];c[E+8>>2]=c[F+8>>2];c[E+12>>2]=c[F+12>>2];c[E+16>>2]=c[F+16>>2];c[E+20>>2]=c[F+20>>2];u=0;Pa(c[51756]|0);F=u;u=0;if((F|0)!=0&(v|0)!=0){G=K$a(c[F>>2]|0,e)|0;if((G|0)==0){fb(F|0,v|0)}J=v}else{G=-1}F=J;if((G|0)==1){m=0;n=0;o=0;p=0;q=0;s=0;t=F;break}else if((G|0)==2){w=0;x=0;y=0;z=0;A=0;B=0;C=F;D=7;break}F=g;E=F+0|0;H=E+88|0;do{c[E>>2]=0;E=E+4|0}while((E|0)<(H|0));u=0;E=sa(98,c[50986]|0)|0;H=u;u=0;if((H|0)!=0&(v|0)!=0){I=K$a(c[H>>2]|0,e)|0;if((I|0)==0){fb(H|0,v|0)}J=v}else{I=-1}H=J;if((I|0)==1){m=0;n=0;o=0;p=0;q=E;s=F;t=H;break}else if((I|0)==2){w=0;x=0;y=0;z=0;A=E;B=F;C=H;D=7;break}u=0;Ha(48,c[50986]|0,F|0)|0;H=u;u=0;if((H|0)!=0&(v|0)!=0){K=K$a(c[H>>2]|0,e)|0;if((K|0)==0){fb(H|0,v|0)}J=v}else{K=-1}H=J;if((K|0)==1){m=0;n=0;o=0;p=0;q=E;s=F;t=H;break}else if((K|0)==2){w=0;x=0;y=0;z=0;A=E;B=F;C=H;D=7;break}H=h;c[g>>2]=h;w$a(h,2,e|0)|0;u=0;L=u;u=0;if((L|0)!=0&(v|0)!=0){M=K$a(c[L>>2]|0,e)|0;if((M|0)==0){fb(L|0,v|0)}J=v}else{M=-1}L=J;if((M|0)==1){m=0;n=0;o=0;p=H;q=E;s=F;t=L;break}else if((M|0)==2){w=0;x=0;y=0;z=H;A=E;B=F;C=L;D=7;break}w=0;x=0;y=0;z=H;A=E;B=F;C=0;D=7}}while(0);while(1){if((D|0)==7){D=0;if((C|0)==0){M=j;h=g+4|0;K=c[h>>2]|0;c[h>>2]=j;w$a(j,1,e|0)|0;u=0;I=u;u=0;if((I|0)!=0&(v|0)!=0){N=K$a(c[I>>2]|0,e)|0;if((N|0)==0){fb(I|0,v|0)}J=v}else{N=-1}I=J;if((N|0)==1){m=K;n=h;o=M;p=z;q=A;s=B;t=I;continue}else if((N|0)==2){O=B;P=A;Q=z;w=K;x=h;y=M;C=I;B=O;A=P;z=Q;D=7;continue}m=K;n=h;o=M;p=z;q=A;s=B;t=0;continue}else{u=0;Ha(48,c[50986]|0,A|0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){R=K$a(c[M>>2]|0,e)|0;if((R|0)==0){fb(M|0,v|0)}J=v}else{R=-1}M=J;if((R|0)==1){m=w;n=x;o=y;p=z;q=A;s=B;t=M;continue}else if((R|0)==2){O=B;P=A;Q=z;S=y;T=x;U=w;C=M;B=O;A=P;z=Q;y=S;x=T;w=U;D=7;continue}u=0;Pa(4);M=u;u=0;if((M|0)!=0&(v|0)!=0){V=K$a(c[M>>2]|0,e)|0;if((V|0)==0){fb(M|0,v|0)}J=v}else{V=-1}M=J;if((V|0)==1){m=w;n=x;o=y;p=z;q=A;s=B;t=M;continue}else if((V|0)==2){O=B;P=A;Q=z;S=y;T=x;U=w;C=M;B=O;A=P;z=Q;y=S;x=T;w=U;D=7;continue}else{D=18;break}}}if((t|0)!=0){u=0;Pa(4);M=u;u=0;if((M|0)!=0&(v|0)!=0){W=K$a(c[M>>2]|0,e)|0;if((W|0)==0){fb(M|0,v|0)}J=v}else{W=-1}M=J;if((W|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((W|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}M=c[r>>2]|0;u=0;Ra(34,18064,154,1,M|0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){ba=K$a(c[M>>2]|0,e)|0;if((ba|0)==0){fb(M|0,v|0)}J=v}else{ba=-1}M=J;if((ba|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ba|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}u=0;M=u;u=0;if((M|0)!=0&(v|0)!=0){ca=K$a(c[M>>2]|0,e)|0;if((ca|0)==0){fb(M|0,v|0)}J=v}else{ca=-1}M=J;if((ca|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ca|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}u=0;sa(99,0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){da=K$a(c[M>>2]|0,e)|0;if((da|0)==0){fb(M|0,v|0)}J=v}else{da=-1}M=J;if((da|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((da|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}else{D=15;break}}u=0;pa(138,f|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){ea=K$a(c[M>>2]|0,e)|0;if((ea|0)==0){fb(M|0,v|0)}J=v}else{ea=-1}M=J;if((ea|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ea|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}c[f+536>>2]=g;u=0;M=va(31,a|0,b|0,f|0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){fa=K$a(c[h>>2]|0,e)|0;if((fa|0)==0){fb(h|0,v|0)}J=v}else{fa=-1}h=J;if((fa|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((fa|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}c[n>>2]=m;u=0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ga=K$a(c[h>>2]|0,e)|0;if((ga|0)==0){fb(h|0,v|0)}J=v}else{ga=-1}h=J;if((ga|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ga|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;Ha(48,c[50986]|0,q|0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ha=K$a(c[h>>2]|0,e)|0;if((ha|0)==0){fb(h|0,v|0)}J=v}else{ha=-1}h=J;if((ha|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ha|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;sa(99,0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ia=K$a(c[h>>2]|0,e)|0;if((ia|0)==0){fb(h|0,v|0)}J=v}else{ia=-1}h=J;if((ia|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ia|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;sa(99,0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ja=K$a(c[h>>2]|0,e)|0;if((ja|0)==0){fb(h|0,v|0)}J=v}else{ja=-1}h=J;if((ja|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ja|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;pa(139,M|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){ka=K$a(c[M>>2]|0,e)|0;if((ka|0)==0){fb(M|0,v|0)}J=v}else{ka=-1}M=J;if((ka|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa}else if((ka|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7}else{D=26;break}}if((D|0)==15){la=p;ma=s;i=d;return 1}else if((D|0)==18){la=z;ma=B;i=d;return 1}return 0}function tz(){var a=0;a=i;Ad(0)|0;uc(18224,18,1,c[r>>2]|0)|0;Ad(0)|0;i=a;return}function uz(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0;b=i;i=i+16|0;g=b;j=f;f=g;c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];j=g;h[a>>3]=d;h[a+8>>3]=e;g=a+16|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];i=b;return}function vz(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0;b=i;i=i+16|0;g=b;j=f;f=g;c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];j=g;h[a>>3]=d;h[a+8>>3]=e;g=a+16|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];i=b;return}function wz(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;h[a>>3]=+U(+c)*f/e*d;i=i;return}function xz(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=+e;h[a>>3]=d/e*c;i=i;return}function yz(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0;b=i;i=i+16|0;g=b;j=f;f=g;c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];j=g;h[a>>3]=d;h[a+8>>3]=e;g=a+16|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];i=b;return}function zz(a,b,d,e,f,g,j){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=+g;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0;l=i;i=i+224|0;m=l;n=l+24|0;o=l+48|0;p=l+72|0;q=l+96|0;r=l+120|0;s=l+144|0;t=l+168|0;u=l+192|0;v=l+216|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+16|0;F=e*64.0;if(!(F>0.0)){G=c[63880]|0;H=D;h[k>>3]=F;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=G;G=u;I=20184;c[G+0>>2]=c[I+0>>2];c[G+4>>2]=c[I+4>>2];c[G+8>>2]=c[I+8>>2];c[G+12>>2]=c[I+12>>2];c[G+16>>2]=c[I+16>>2];c[G+20>>2]=c[I+20>>2];Oe[H&127](b,u,18472,D);}J=+$a(+F);if(!(e>0.0)){D=c[63880]|0;u=C;h[k>>3]=e;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];u=D;D=t;H=20184;c[D+0>>2]=c[H+0>>2];c[D+4>>2]=c[H+4>>2];c[D+8>>2]=c[H+8>>2];c[D+12>>2]=c[H+12>>2];c[D+16>>2]=c[H+16>>2];c[D+20>>2]=c[H+20>>2];Oe[u&127](b,t,18536,C);}F=+$a(+e);e=g/3.7+5.74/+W(+f,.9);if(!(e>0.0)){C=c[63880]|0;t=B;h[k>>3]=e;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];t=C;C=s;u=20184;c[C+0>>2]=c[u+0>>2];c[C+4>>2]=c[u+4>>2];c[C+8>>2]=c[u+8>>2];c[C+12>>2]=c[u+12>>2];c[C+16>>2]=c[u+16>>2];c[C+20>>2]=c[u+20>>2];Oe[t&127](b,s,18600,B);}K=f/+$a(+e);e=K*K*.25;B=e>=0.0;if(!B){s=c[63880]|0;t=A;h[k>>3]=e;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];t=s;s=r;u=20184;c[s+0>>2]=c[u+0>>2];c[s+4>>2]=c[u+4>>2];c[s+8>>2]=c[u+8>>2];c[s+12>>2]=c[u+12>>2];c[s+16>>2]=c[u+16>>2];c[s+20>>2]=c[u+20>>2];Oe[t&127](b,r,18664,A);}K=+V(+e);f=g*.27+2.51/K;if(!B){B=c[63880]|0;A=z;h[k>>3]=e;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=B;B=q;r=20184;c[B+0>>2]=c[r+0>>2];c[B+4>>2]=c[r+4>>2];c[B+8>>2]=c[r+8>>2];c[B+12>>2]=c[r+12>>2];c[B+16>>2]=c[r+16>>2];c[B+20>>2]=c[r+20>>2];Oe[A&127](b,q,18664,z);}if(!(f>0.0)){z=c[63880]|0;q=y;h[k>>3]=f;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];q=z;z=p;A=20184;c[z+0>>2]=c[A+0>>2];c[z+4>>2]=c[A+4>>2];c[z+8>>2]=c[A+8>>2];c[z+12>>2]=c[A+12>>2];c[z+16>>2]=c[A+16>>2];c[z+20>>2]=c[A+20>>2];Oe[q&127](b,p,18720,y);}g=K*+$a(+f)*-2.0;if(!(e>0.0)){y=c[63880]|0;p=x;h[k>>3]=e;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=y;y=o;q=20184;c[y+0>>2]=c[q+0>>2];c[y+4>>2]=c[q+4>>2];c[y+8>>2]=c[q+8>>2];c[y+12>>2]=c[q+12>>2];c[y+16>>2]=c[q+16>>2];c[y+20>>2]=c[q+20>>2];Oe[p&127](b,o,18784,x);}K=+$a(+e);if(!(g>0.0)){x=c[63880]|0;o=w;h[k>>3]=g;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=x;x=n;p=20184;c[x+0>>2]=c[p+0>>2];c[x+4>>2]=c[p+4>>2];c[x+8>>2]=c[p+8>>2];c[x+12>>2]=c[p+12>>2];c[x+16>>2]=c[p+16>>2];c[x+20>>2]=c[p+20>>2];Oe[o&127](b,n,18840,w);}e=+$a(+g);L=1.090079149577162/(f*g)+.5;if(d>0.0){M=+$a(+d);Az(E,0,M,J,K,F,e,1.0,L);N=E;O=N;P=+h[O>>3];Q=E;R=Q+8|0;S=R;T=+h[S>>3];X=+W(10.0,+P);Y=+U(+j);Z=T/Y;_=X*Z;$=a;aa=$;h[aa>>3]=X;ba=a;ca=ba+8|0;da=ca;h[da>>3]=_;i=l;return}w=c[63880]|0;n=v;h[k>>3]=d;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=w;w=m;o=20184;c[w+0>>2]=c[o+0>>2];c[w+4>>2]=c[o+4>>2];c[w+8>>2]=c[o+8>>2];c[w+12>>2]=c[o+12>>2];c[w+16>>2]=c[o+16>>2];c[w+20>>2]=c[o+20>>2];Oe[n&127](b,m,18904,v);M=+$a(+d);Az(E,0,M,J,K,F,e,1.0,L);N=E;O=N;P=+h[O>>3];Q=E;R=Q+8|0;S=R;T=+h[S>>3];X=+W(10.0,+P);Y=+U(+j);Z=T/Y;_=X*Z;$=a;aa=$;h[aa>>3]=X;ba=a;ca=ba+8|0;da=ca;h[da>>3]=_;i=l;return}function Az(a,b,c,d,e,f,g,j,k){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;g=+g;j=+j;k=+k;var l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0;b=i;l=e-d;do{if(l!=l|0.0!=0.0|l==0.0){e=(f+g)*.5;m=g-f;if(m>0.0){n=1.0e+60;o=e;break}n=+(m<0.0|0)*1.0e+60;o=e}else{e=(c-d)/l;m=e*e;p=e*m;q=m*3.0;n=(m-e)*6.0/l*f+((e*-4.0+q+1.0)*j+((e-m)*6.0/l*g+(e*-2.0+q)*k));o=(m*-3.0+p*2.0+1.0)*f+(l*(p+(e+m*-2.0))*j+((q+p*-2.0)*g+l*(p-m)*k))}}while(0);h[a>>3]=o;h[a+8>>3]=n;i=b;return}function Bz(a,b,c){a=a|0;b=b|0;c=c|0;h[a>>3]=+h[c>>3];i=i;return}function Cz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0;e=i;i=i+48|0;f=e;g=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;Dz(g,0,123.15);m=+h[g>>3];Dz(j,0,1273.15);n=+h[j>>3];Dz(k,0,+h[d+8>>3]);o=+h[k>>3];k=f;d=18968;c[k+0>>2]=c[d+0>>2];c[k+4>>2]=c[d+4>>2];c[k+8>>2]=c[d+8>>2];Ez(l,b,f,m,n,o);h[a>>3]=+h[l>>3]*1.0e-6;i=e;return}function Dz(a,b,c){a=a|0;b=b|0;c=+c;h[a>>3]=c+-273.15;i=i;return}function Ez(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=+e;f=+f;g=+g;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0;b=i;i=i+120|0;j=b;k=b+16|0;l=b+32|0;m=b+48|0;n=b+64|0;o=b+80|0;p=b+88|0;q=b+96|0;r=b+104|0;s=b+112|0;if(g<e){t=n;u=d;c[t+0>>2]=c[u+0>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];MA(o,0,n,e);v=+h[o>>3];w=e-g;o=m;n=d;c[o+0>>2]=c[n+0>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2];NA(p,0,m,e,w);x=v- +h[p>>3];y=a;z=y;h[z>>3]=x;i=b;return}if(g>f){p=l;m=d;c[p+0>>2]=c[m+0>>2];c[p+4>>2]=c[m+4>>2];c[p+8>>2]=c[m+8>>2];MA(q,0,l,f);v=+h[q>>3];w=g-f;q=k;l=d;c[q+0>>2]=c[l+0>>2];c[q+4>>2]=c[l+4>>2];c[q+8>>2]=c[l+8>>2];NA(r,0,k,f,w);x=v+ +h[r>>3];y=a;z=y;h[z>>3]=x;i=b;return}else{r=j;k=d;c[r+0>>2]=c[k+0>>2];c[r+4>>2]=c[k+4>>2];c[r+8>>2]=c[k+8>>2];MA(s,0,j,g);x=+h[s>>3];y=a;z=y;h[z>>3]=x;i=b;return}}function Fz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0;b=i;i=i+40|0;e=b;f=b+32|0;g=e;j=d;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];c[g+24>>2]=c[j+24>>2];c[g+28>>2]=c[j+28>>2];Gz(f,0,e);h[a>>3]=+h[d>>3]/(+h[f>>3]*+h[d+8>>3]);i=b;return}function Gz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0;b=i;i=i+8|0;e=b;f=i;i=i+8|0;g=d+16|0;c[f>>2]=1;j=(1.0- +h[(hxa(g,1,f)|0)>>3])*287.0512249529787;c[e>>2]=1;h[a>>3]=j+ +h[(hxa(g,1,e)|0)>>3]*461.5233290850878;i=b;return}



function iE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[63880]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=57624;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&127](mb,m,38632,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]}jA(t,c[ib>>2]|0,jb);jb=+h[t>>3];kA(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);jb=+h[v>>3];jA(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);pb=+h[w>>3];kA(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+104>>3];qb=+zd(1.0e-13,+(+h[w+112>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+nwa(c[ib>>2]|0,qb,38704,38624,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(pb- +yd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{jA(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);sb=+h[z>>3];kA(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);sb=+h[B>>3];jA(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);jb=+h[C>>3];kA(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+zd(1.0e-13,+(+h[C+112>>3]- +h[E>>3]));pb=1.0- +h[C+104>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+nwa(c[ib>>2]|0,jb,38704,38624,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{jA(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);vb=+h[F>>3];kA(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);vb=+h[H>>3];jA(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);sb=+h[I>>3];kA(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);sb=+h[K>>3];jA(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);jb=+h[L>>3];kA(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+112>>3]- +h[N>>3])|0)<<24>>24==0){jA(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);jb=+h[O>>3];kA(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Q,c[ib>>2]|0,+h[P+96>>3],+h[P+752>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(R,c[ib>>2]|0,+h[Q+96>>3],+h[Q+752>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(S,c[ib>>2]|0,jb,pb,+h[Q+96>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+752>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+768>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}jA(T,c[ib>>2]|0,+h[xb+96>>3]);qb=+h[T>>3];kA(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);qb=+h[V>>3];jA(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);pb=+h[W>>3];kA(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);pb=+h[Y>>3];jA(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);jb=+h[Z>>3];kA(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA($,c[ib>>2]|0,+h[_+96>>3],+h[_+752>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(aa,c[ib>>2]|0,+h[$+96>>3],+h[$+752>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(ba,c[ib>>2]|0,jb,rb,+h[$+96>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+752>>3],0.0);zb=+h[ba>>3];jA(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);rb=+h[ca>>3];kA(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+112>>3];Ab=+zd(1.0e-13,+(jb-qb));qb=Ab*+zd(1.0e-13,+(jb-pb));pb=+h[ea+760>>3];Ab=-(pb*+zd(1.0e-13,+(jb-sb)));sb=+h[ea+104>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+nwa(c[ib>>2]|0,qb,39008,38624,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+104>>3];Cb=+h[ca+112>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+zd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+nwa(c[ib>>2]|0,Eb,38704,38624,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+760>>3]-wb}wb=+h[tb+96>>3];if(wb>0.0){Gb=wb}else{tb=c[63880]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=57624;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&127](Db,l,38632,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]}if(Gb>0.0){Hb=Gb}else{r=c[63880]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=57624;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&127](l,j,38632,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]}jA(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];kA(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);Hb=+h[ia>>3];jA(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);Fb=+h[ja>>3];kA(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3];if(zb>0.0){Ib=zb}else{la=c[63880]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=57624;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&127](ka,g,38632,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]}if(Ib>0.0){Jb=Ib}else{p=c[63880]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=57624;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&127](g,f,38632,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]}if(Jb>0.0){Kb=Jb}else{o=c[63880]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=57624;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&127](f,e,38632,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]}qb=Kb+-273.15;lA(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];jA(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);qb=+h[na>>3];kA(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);qb=+h[pa>>3];jA(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);Eb=+h[qa>>3];kA(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+104>>3];rb=+zd(1.0e-13,+(+h[qa+112>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+nwa(c[ib>>2]|0,rb,38704,38624,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(Eb- +yd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{jA(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);Lb=+h[ta>>3];kA(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);Lb=+h[va>>3];jA(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);qb=+h[wa>>3];kA(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+zd(1.0e-13,+(+h[wa+112>>3]- +h[ya>>3]));Eb=1.0- +h[wa+104>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+nwa(c[ib>>2]|0,qb,38704,38624,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{jA(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);Ob=+h[za>>3];kA(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);Ob=+h[Ba>>3];jA(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);Lb=+h[Ca>>3];kA(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);Lb=+h[Ea>>3];jA(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);qb=+h[Fa>>3];kA(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+112>>3]- +h[Ha>>3])|0)<<24>>24==0){jA(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);qb=+h[Ia>>3];kA(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Ka,c[ib>>2]|0,+h[Ja+96>>3],+h[Ja+752>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(La,c[ib>>2]|0,+h[Ka+96>>3],+h[Ka+752>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+96>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+752>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+768>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}jA(Na,c[ib>>2]|0,+h[Qb+96>>3]);rb=+h[Na>>3];kA(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);rb=+h[Pa>>3];jA(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);Eb=+h[Qa>>3];kA(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);Eb=+h[Sa>>3];jA(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);qb=+h[Ta>>3];kA(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Va,c[ib>>2]|0,+h[Ua+96>>3],+h[Ua+752>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(Wa,c[ib>>2]|0,+h[Va+96>>3],+h[Va+752>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Xa,c[ib>>2]|0,qb,Bb,+h[Va+96>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+752>>3],0.0);Cb=+h[Xa>>3];jA(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);Bb=+h[Ya>>3];kA(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+112>>3];vb=+zd(1.0e-13,+(qb-rb));rb=vb*+zd(1.0e-13,+(qb-Eb));Eb=+h[Za+760>>3];vb=-(Eb*+zd(1.0e-13,+(qb-Lb)));Lb=+h[Za+104>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+nwa(c[ib>>2]|0,rb,39008,38624,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+104>>3];Tb=+h[Ya+112>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+zd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+nwa(c[ib>>2]|0,Vb,38704,38624,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+760>>3]-Pb}Pb=+h[Mb+96>>3];Wb=Pb+-273.15;Cb=+h[Mb+752>>3];sA($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];jA(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);Pb=+h[ab>>3];kA(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);Pb=+h[cb>>3];jA(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);Wb=+h[db>>3];kA(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+96>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+nwa(c[ib>>2]|0,rb,39616,38624,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+96>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+760>>3]-ub);ub=+h[Yb+752>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+nwa(c[ib>>2]|0,Xb,39616,38624,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+752>>3];ac=+h[Yb+96>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+Nxa(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+104>>3];Gb=+zd(1.0e-13,+(+h[Yb+112>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+nwa(c[ib>>2]|0,Gb,38704,38624,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +zd(+(ac- +yd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+96>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+nwa(c[ib>>2]|0,ec,39616,38624,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+96>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+760>>3];ic=+h[gc+752>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+nwa(c[ib>>2]|0,fc,39616,38624,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+752>>3];kc=+h[gc+96>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+Nxa(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+104>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+zd(1.0e-13,+(+h[gc+112>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9488|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9488|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+nwa(c[ib>>2]|0,Nb,38704,38624,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9488|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function jE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;iA(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+24>>3]);if((Aza(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+40>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+696>>3]*.999;l=j;m=l+9216|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;xA(e,c[f>>2]|0,+h[d+24>>3],+h[d+680>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+9216|0;n=m;h[n>>3]=k;i=b;return}}function kE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[63880]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=57624;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&127](mb,m,39648,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]}jA(t,c[ib>>2]|0,jb);jb=+h[t>>3];kA(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);jb=+h[v>>3];jA(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);pb=+h[w>>3];kA(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+32>>3];qb=+zd(1.0e-13,+(+h[w+40>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+nwa(c[ib>>2]|0,qb,39720,39640,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(pb- +yd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{jA(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);sb=+h[z>>3];kA(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);sb=+h[B>>3];jA(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);jb=+h[C>>3];kA(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+zd(1.0e-13,+(+h[C+40>>3]- +h[E>>3]));pb=1.0- +h[C+32>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+nwa(c[ib>>2]|0,jb,39720,39640,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{jA(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);vb=+h[F>>3];kA(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);vb=+h[H>>3];jA(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);sb=+h[I>>3];kA(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);sb=+h[K>>3];jA(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);jb=+h[L>>3];kA(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+40>>3]- +h[N>>3])|0)<<24>>24==0){jA(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);jb=+h[O>>3];kA(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Q,c[ib>>2]|0,+h[P+24>>3],+h[P+680>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(R,c[ib>>2]|0,+h[Q+24>>3],+h[Q+680>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(S,c[ib>>2]|0,jb,pb,+h[Q+24>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+680>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+696>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}jA(T,c[ib>>2]|0,+h[xb+24>>3]);qb=+h[T>>3];kA(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);qb=+h[V>>3];jA(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);pb=+h[W>>3];kA(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);pb=+h[Y>>3];jA(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);jb=+h[Z>>3];kA(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA($,c[ib>>2]|0,+h[_+24>>3],+h[_+680>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(aa,c[ib>>2]|0,+h[$+24>>3],+h[$+680>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(ba,c[ib>>2]|0,jb,rb,+h[$+24>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+680>>3],0.0);zb=+h[ba>>3];jA(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);rb=+h[ca>>3];kA(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+40>>3];Ab=+zd(1.0e-13,+(jb-qb));qb=Ab*+zd(1.0e-13,+(jb-pb));pb=+h[ea+688>>3];Ab=-(pb*+zd(1.0e-13,+(jb-sb)));sb=+h[ea+32>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+nwa(c[ib>>2]|0,qb,40024,39640,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+32>>3];Cb=+h[ca+40>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+zd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+nwa(c[ib>>2]|0,Eb,39720,39640,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+688>>3]-wb}wb=+h[tb+24>>3];if(wb>0.0){Gb=wb}else{tb=c[63880]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=57624;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&127](Db,l,39648,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]}if(Gb>0.0){Hb=Gb}else{r=c[63880]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=57624;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&127](l,j,39648,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]}jA(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];kA(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);Hb=+h[ia>>3];jA(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);Fb=+h[ja>>3];kA(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3];if(zb>0.0){Ib=zb}else{la=c[63880]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=57624;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&127](ka,g,39648,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]}if(Ib>0.0){Jb=Ib}else{p=c[63880]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=57624;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&127](g,f,39648,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]}if(Jb>0.0){Kb=Jb}else{o=c[63880]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=57624;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&127](f,e,39648,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]}qb=Kb+-273.15;lA(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];jA(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);qb=+h[na>>3];kA(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);qb=+h[pa>>3];jA(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);Eb=+h[qa>>3];kA(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+32>>3];rb=+zd(1.0e-13,+(+h[qa+40>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+nwa(c[ib>>2]|0,rb,39720,39640,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(Eb- +yd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{jA(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);Lb=+h[ta>>3];kA(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);Lb=+h[va>>3];jA(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);qb=+h[wa>>3];kA(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+zd(1.0e-13,+(+h[wa+40>>3]- +h[ya>>3]));Eb=1.0- +h[wa+32>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+nwa(c[ib>>2]|0,qb,39720,39640,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{jA(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);Ob=+h[za>>3];kA(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);Ob=+h[Ba>>3];jA(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);Lb=+h[Ca>>3];kA(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);Lb=+h[Ea>>3];jA(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);qb=+h[Fa>>3];kA(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+40>>3]- +h[Ha>>3])|0)<<24>>24==0){jA(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);qb=+h[Ia>>3];kA(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Ka,c[ib>>2]|0,+h[Ja+24>>3],+h[Ja+680>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(La,c[ib>>2]|0,+h[Ka+24>>3],+h[Ka+680>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+24>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+680>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+696>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}jA(Na,c[ib>>2]|0,+h[Qb+24>>3]);rb=+h[Na>>3];kA(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);rb=+h[Pa>>3];jA(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);Eb=+h[Qa>>3];kA(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);Eb=+h[Sa>>3];jA(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);qb=+h[Ta>>3];kA(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Va,c[ib>>2]|0,+h[Ua+24>>3],+h[Ua+680>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(Wa,c[ib>>2]|0,+h[Va+24>>3],+h[Va+680>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Xa,c[ib>>2]|0,qb,Bb,+h[Va+24>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+680>>3],0.0);Cb=+h[Xa>>3];jA(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);Bb=+h[Ya>>3];kA(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+40>>3];vb=+zd(1.0e-13,+(qb-rb));rb=vb*+zd(1.0e-13,+(qb-Eb));Eb=+h[Za+688>>3];vb=-(Eb*+zd(1.0e-13,+(qb-Lb)));Lb=+h[Za+32>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+nwa(c[ib>>2]|0,rb,40024,39640,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+32>>3];Tb=+h[Ya+40>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+zd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+nwa(c[ib>>2]|0,Vb,39720,39640,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+688>>3]-Pb}Pb=+h[Mb+24>>3];Wb=Pb+-273.15;Cb=+h[Mb+680>>3];sA($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];jA(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);Pb=+h[ab>>3];kA(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);Pb=+h[cb>>3];jA(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);Wb=+h[db>>3];kA(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+24>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+nwa(c[ib>>2]|0,rb,40632,39640,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+24>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+688>>3]-ub);ub=+h[Yb+680>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+nwa(c[ib>>2]|0,Xb,40632,39640,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+680>>3];ac=+h[Yb+24>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+Nxa(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+32>>3];Gb=+zd(1.0e-13,+(+h[Yb+40>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+nwa(c[ib>>2]|0,Gb,39720,39640,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +zd(+(ac- +yd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+24>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+nwa(c[ib>>2]|0,ec,40632,39640,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+24>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+688>>3];ic=+h[gc+680>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+nwa(c[ib>>2]|0,fc,40632,39640,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+680>>3];kc=+h[gc+24>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+Nxa(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+32>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+zd(1.0e-13,+(+h[gc+40>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9536|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9536|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+nwa(c[ib>>2]|0,Nb,39720,39640,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9536|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function lE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[63880]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=57624;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&127](mb,m,40664,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]}jA(t,c[ib>>2]|0,jb);jb=+h[t>>3];kA(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);jb=+h[v>>3];jA(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);pb=+h[w>>3];kA(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+80>>3];qb=+zd(1.0e-13,+(+h[w+88>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+nwa(c[ib>>2]|0,qb,40736,40656,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(pb- +yd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{jA(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);sb=+h[z>>3];kA(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);sb=+h[B>>3];jA(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);jb=+h[C>>3];kA(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+zd(1.0e-13,+(+h[C+88>>3]- +h[E>>3]));pb=1.0- +h[C+80>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+nwa(c[ib>>2]|0,jb,40736,40656,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{jA(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);vb=+h[F>>3];kA(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);vb=+h[H>>3];jA(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);sb=+h[I>>3];kA(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);sb=+h[K>>3];jA(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);jb=+h[L>>3];kA(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]- +h[N>>3])|0)<<24>>24==0){jA(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);jb=+h[O>>3];kA(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Q,c[ib>>2]|0,+h[P+72>>3],+h[P+728>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(R,c[ib>>2]|0,+h[Q+72>>3],+h[Q+728>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(S,c[ib>>2]|0,jb,pb,+h[Q+72>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+728>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+744>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}jA(T,c[ib>>2]|0,+h[xb+72>>3]);qb=+h[T>>3];kA(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);qb=+h[V>>3];jA(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);pb=+h[W>>3];kA(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);pb=+h[Y>>3];jA(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);jb=+h[Z>>3];kA(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA($,c[ib>>2]|0,+h[_+72>>3],+h[_+728>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(aa,c[ib>>2]|0,+h[$+72>>3],+h[$+728>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(ba,c[ib>>2]|0,jb,rb,+h[$+72>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+728>>3],0.0);zb=+h[ba>>3];jA(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);rb=+h[ca>>3];kA(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+88>>3];Ab=+zd(1.0e-13,+(jb-qb));qb=Ab*+zd(1.0e-13,+(jb-pb));pb=+h[ea+736>>3];Ab=-(pb*+zd(1.0e-13,+(jb-sb)));sb=+h[ea+80>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+nwa(c[ib>>2]|0,qb,41040,40656,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+80>>3];Cb=+h[ca+88>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+zd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+nwa(c[ib>>2]|0,Eb,40736,40656,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+736>>3]-wb}wb=+h[tb+72>>3];if(wb>0.0){Gb=wb}else{tb=c[63880]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=57624;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&127](Db,l,40664,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]}if(Gb>0.0){Hb=Gb}else{r=c[63880]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=57624;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&127](l,j,40664,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]}jA(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];kA(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);Hb=+h[ia>>3];jA(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);Fb=+h[ja>>3];kA(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3];if(zb>0.0){Ib=zb}else{la=c[63880]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=57624;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&127](ka,g,40664,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]}if(Ib>0.0){Jb=Ib}else{p=c[63880]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=57624;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&127](g,f,40664,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]}if(Jb>0.0){Kb=Jb}else{o=c[63880]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=57624;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&127](f,e,40664,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]}qb=Kb+-273.15;lA(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];jA(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);qb=+h[na>>3];kA(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);qb=+h[pa>>3];jA(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);Eb=+h[qa>>3];kA(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+80>>3];rb=+zd(1.0e-13,+(+h[qa+88>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+nwa(c[ib>>2]|0,rb,40736,40656,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(Eb- +yd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{jA(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);Lb=+h[ta>>3];kA(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);Lb=+h[va>>3];jA(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);qb=+h[wa>>3];kA(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+zd(1.0e-13,+(+h[wa+88>>3]- +h[ya>>3]));Eb=1.0- +h[wa+80>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+nwa(c[ib>>2]|0,qb,40736,40656,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{jA(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);Ob=+h[za>>3];kA(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);Ob=+h[Ba>>3];jA(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);Lb=+h[Ca>>3];kA(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);Lb=+h[Ea>>3];jA(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);qb=+h[Fa>>3];kA(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]- +h[Ha>>3])|0)<<24>>24==0){jA(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);qb=+h[Ia>>3];kA(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Ka,c[ib>>2]|0,+h[Ja+72>>3],+h[Ja+728>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(La,c[ib>>2]|0,+h[Ka+72>>3],+h[Ka+728>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+72>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+728>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+744>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}jA(Na,c[ib>>2]|0,+h[Qb+72>>3]);rb=+h[Na>>3];kA(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);rb=+h[Pa>>3];jA(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);Eb=+h[Qa>>3];kA(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);Eb=+h[Sa>>3];jA(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);qb=+h[Ta>>3];kA(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Va,c[ib>>2]|0,+h[Ua+72>>3],+h[Ua+728>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(Wa,c[ib>>2]|0,+h[Va+72>>3],+h[Va+728>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Xa,c[ib>>2]|0,qb,Bb,+h[Va+72>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+728>>3],0.0);Cb=+h[Xa>>3];jA(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);Bb=+h[Ya>>3];kA(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+88>>3];vb=+zd(1.0e-13,+(qb-rb));rb=vb*+zd(1.0e-13,+(qb-Eb));Eb=+h[Za+736>>3];vb=-(Eb*+zd(1.0e-13,+(qb-Lb)));Lb=+h[Za+80>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+nwa(c[ib>>2]|0,rb,41040,40656,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+80>>3];Tb=+h[Ya+88>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+zd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+nwa(c[ib>>2]|0,Vb,40736,40656,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+736>>3]-Pb}Pb=+h[Mb+72>>3];Wb=Pb+-273.15;Cb=+h[Mb+728>>3];sA($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];jA(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);Pb=+h[ab>>3];kA(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);Pb=+h[cb>>3];jA(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);Wb=+h[db>>3];kA(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+72>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+nwa(c[ib>>2]|0,rb,41648,40656,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+72>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+736>>3]-ub);ub=+h[Yb+728>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+nwa(c[ib>>2]|0,Xb,41648,40656,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+728>>3];ac=+h[Yb+72>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+Nxa(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+80>>3];Gb=+zd(1.0e-13,+(+h[Yb+88>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+nwa(c[ib>>2]|0,Gb,40736,40656,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +zd(+(ac- +yd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+72>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+nwa(c[ib>>2]|0,ec,41648,40656,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+72>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+736>>3];ic=+h[gc+728>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+nwa(c[ib>>2]|0,fc,41648,40656,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+728>>3];kc=+h[gc+72>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+Nxa(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+80>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+zd(1.0e-13,+(+h[gc+88>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9504|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9504|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+nwa(c[ib>>2]|0,Nb,40736,40656,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9504|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function mE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;iA(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+48>>3]);if((Aza(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+64>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+720>>3]*.999;l=j;m=l+9192|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;xA(e,c[f>>2]|0,+h[d+48>>3],+h[d+704>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+9192|0;n=m;h[n>>3]=k;i=b;return}}function nE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[63880]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=57624;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&127](mb,m,41680,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]}jA(t,c[ib>>2]|0,jb);jb=+h[t>>3];kA(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);jb=+h[v>>3];jA(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);pb=+h[w>>3];kA(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+56>>3];qb=+zd(1.0e-13,+(+h[w+64>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+nwa(c[ib>>2]|0,qb,41752,41672,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(pb- +yd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{jA(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);sb=+h[z>>3];kA(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);sb=+h[B>>3];jA(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);jb=+h[C>>3];kA(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+zd(1.0e-13,+(+h[C+64>>3]- +h[E>>3]));pb=1.0- +h[C+56>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+nwa(c[ib>>2]|0,jb,41752,41672,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{jA(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);vb=+h[F>>3];kA(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);vb=+h[H>>3];jA(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);sb=+h[I>>3];kA(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);sb=+h[K>>3];jA(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);jb=+h[L>>3];kA(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]- +h[N>>3])|0)<<24>>24==0){jA(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);jb=+h[O>>3];kA(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Q,c[ib>>2]|0,+h[P+48>>3],+h[P+704>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(R,c[ib>>2]|0,+h[Q+48>>3],+h[Q+704>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(S,c[ib>>2]|0,jb,pb,+h[Q+48>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+704>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+720>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}jA(T,c[ib>>2]|0,+h[xb+48>>3]);qb=+h[T>>3];kA(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);qb=+h[V>>3];jA(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);pb=+h[W>>3];kA(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);pb=+h[Y>>3];jA(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);jb=+h[Z>>3];kA(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA($,c[ib>>2]|0,+h[_+48>>3],+h[_+704>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(aa,c[ib>>2]|0,+h[$+48>>3],+h[$+704>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(ba,c[ib>>2]|0,jb,rb,+h[$+48>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+704>>3],0.0);zb=+h[ba>>3];jA(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);rb=+h[ca>>3];kA(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+64>>3];Ab=+zd(1.0e-13,+(jb-qb));qb=Ab*+zd(1.0e-13,+(jb-pb));pb=+h[ea+712>>3];Ab=-(pb*+zd(1.0e-13,+(jb-sb)));sb=+h[ea+56>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+nwa(c[ib>>2]|0,qb,42056,41672,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+56>>3];Cb=+h[ca+64>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+zd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+nwa(c[ib>>2]|0,Eb,41752,41672,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+712>>3]-wb}wb=+h[tb+48>>3];if(wb>0.0){Gb=wb}else{tb=c[63880]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=57624;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&127](Db,l,41680,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]}if(Gb>0.0){Hb=Gb}else{r=c[63880]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=57624;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&127](l,j,41680,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]}jA(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];kA(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);Hb=+h[ia>>3];jA(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);Fb=+h[ja>>3];kA(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3];if(zb>0.0){Ib=zb}else{la=c[63880]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=57624;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&127](ka,g,41680,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]}if(Ib>0.0){Jb=Ib}else{p=c[63880]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=57624;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&127](g,f,41680,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]}if(Jb>0.0){Kb=Jb}else{o=c[63880]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=57624;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&127](f,e,41680,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]}qb=Kb+-273.15;lA(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];jA(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);qb=+h[na>>3];kA(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);qb=+h[pa>>3];jA(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);Eb=+h[qa>>3];kA(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+56>>3];rb=+zd(1.0e-13,+(+h[qa+64>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+nwa(c[ib>>2]|0,rb,41752,41672,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(Eb- +yd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{jA(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);Lb=+h[ta>>3];kA(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);Lb=+h[va>>3];jA(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);qb=+h[wa>>3];kA(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+zd(1.0e-13,+(+h[wa+64>>3]- +h[ya>>3]));Eb=1.0- +h[wa+56>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+nwa(c[ib>>2]|0,qb,41752,41672,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{jA(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);Ob=+h[za>>3];kA(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);Ob=+h[Ba>>3];jA(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);Lb=+h[Ca>>3];kA(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);Lb=+h[Ea>>3];jA(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);qb=+h[Fa>>3];kA(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]- +h[Ha>>3])|0)<<24>>24==0){jA(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);qb=+h[Ia>>3];kA(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Ka,c[ib>>2]|0,+h[Ja+48>>3],+h[Ja+704>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(La,c[ib>>2]|0,+h[Ka+48>>3],+h[Ka+704>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+48>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+704>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+720>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}jA(Na,c[ib>>2]|0,+h[Qb+48>>3]);rb=+h[Na>>3];kA(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);rb=+h[Pa>>3];jA(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);Eb=+h[Qa>>3];kA(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);Eb=+h[Sa>>3];jA(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);qb=+h[Ta>>3];kA(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Va,c[ib>>2]|0,+h[Ua+48>>3],+h[Ua+704>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(Wa,c[ib>>2]|0,+h[Va+48>>3],+h[Va+704>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Xa,c[ib>>2]|0,qb,Bb,+h[Va+48>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+704>>3],0.0);Cb=+h[Xa>>3];jA(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);Bb=+h[Ya>>3];kA(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+64>>3];vb=+zd(1.0e-13,+(qb-rb));rb=vb*+zd(1.0e-13,+(qb-Eb));Eb=+h[Za+712>>3];vb=-(Eb*+zd(1.0e-13,+(qb-Lb)));Lb=+h[Za+56>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+nwa(c[ib>>2]|0,rb,42056,41672,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+56>>3];Tb=+h[Ya+64>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+zd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+nwa(c[ib>>2]|0,Vb,41752,41672,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+712>>3]-Pb}Pb=+h[Mb+48>>3];Wb=Pb+-273.15;Cb=+h[Mb+704>>3];sA($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];jA(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);Pb=+h[ab>>3];kA(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);Pb=+h[cb>>3];jA(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);Wb=+h[db>>3];kA(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+48>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+nwa(c[ib>>2]|0,rb,42664,41672,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+48>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+712>>3]-ub);ub=+h[Yb+704>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+nwa(c[ib>>2]|0,Xb,42664,41672,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+704>>3];ac=+h[Yb+48>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+Nxa(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+56>>3];Gb=+zd(1.0e-13,+(+h[Yb+64>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+nwa(c[ib>>2]|0,Gb,41752,41672,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +zd(+(ac- +yd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+48>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+nwa(c[ib>>2]|0,ec,42664,41672,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+48>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+712>>3];ic=+h[gc+704>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+nwa(c[ib>>2]|0,fc,42664,41672,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+704>>3];kc=+h[gc+48>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+Nxa(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+56>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+zd(1.0e-13,+(+h[gc+64>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9520|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9520|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+nwa(c[ib>>2]|0,Nb,41752,41672,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9520|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function oE(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;iA(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+48>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+1672>>3]=+yd(+(+h[d>>3]),+(+h[a+64>>3]*.999));i=b;return}function pE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2864>>3]=1.0- +h[b+80>>3];i=i;return}function qE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+80>>3];p=f;h[k>>3]=+h[n+2864>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+88>>3];q=+h[p+72>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2296>>3]=+h[l>>3];i=b;return}function rE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+80>>3];p=f;h[k>>3]=+h[n+2864>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+88>>3];q=+h[p+72>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2400>>3]=+h[l>>3];i=b;return}function sE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;gxa(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+32>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+40>>3];l=+h[a+24>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];tA(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1648>>3]=+h[f>>3];i=b;return}function tE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[63880]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=57624;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&127](mb,m,42696,s);ib=lb;jb=+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]}jA(t,c[ib>>2]|0,jb);jb=+h[t>>3];kA(u,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(v,c[ib>>2]|0,jb,+h[u>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);jb=+h[v>>3];jA(w,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);pb=+h[w>>3];kA(x,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(y,c[ib>>2]|0,pb,+h[x>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+8>>3];qb=+zd(1.0e-13,+(+h[w+16>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+nwa(c[ib>>2]|0,qb,42768,42688,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(pb- +yd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{jA(z,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);sb=+h[z>>3];kA(A,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(B,c[ib>>2]|0,sb,+h[A>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);sb=+h[B>>3];jA(C,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);jb=+h[C>>3];kA(D,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(E,c[ib>>2]|0,jb,+h[D>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+zd(1.0e-13,+(+h[C+16>>3]- +h[E>>3]));pb=1.0- +h[C+8>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+nwa(c[ib>>2]|0,jb,42768,42688,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{jA(F,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);vb=+h[F>>3];kA(G,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(H,c[ib>>2]|0,vb,+h[G>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);vb=+h[H>>3];jA(I,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);sb=+h[I>>3];kA(J,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(K,c[ib>>2]|0,sb,+h[J>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);sb=+h[K>>3];jA(L,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);jb=+h[L>>3];kA(M,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(N,c[ib>>2]|0,jb,+h[M>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+16>>3]- +h[N>>3])|0)<<24>>24==0){jA(O,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);jb=+h[O>>3];kA(P,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Q,c[ib>>2]|0,+h[P>>3],+h[P+656>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(R,c[ib>>2]|0,+h[Q>>3],+h[Q+656>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(S,c[ib>>2]|0,jb,pb,+h[Q>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+656>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+672>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}jA(T,c[ib>>2]|0,+h[xb>>3]);qb=+h[T>>3];kA(U,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(V,c[ib>>2]|0,qb,+h[U>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);qb=+h[V>>3];jA(W,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);pb=+h[W>>3];kA(X,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(Y,c[ib>>2]|0,pb,+h[X>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);pb=+h[Y>>3];jA(Z,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);jb=+h[Z>>3];kA(_,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA($,c[ib>>2]|0,+h[_>>3],+h[_+656>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(aa,c[ib>>2]|0,+h[$>>3],+h[$+656>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(ba,c[ib>>2]|0,jb,rb,+h[$>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+656>>3],0.0);zb=+h[ba>>3];jA(ca,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);rb=+h[ca>>3];kA(ea,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+16>>3];Ab=+zd(1.0e-13,+(jb-qb));qb=Ab*+zd(1.0e-13,+(jb-pb));pb=+h[ea+664>>3];Ab=-(pb*+zd(1.0e-13,+(jb-sb)));sb=+h[ea+8>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+nwa(c[ib>>2]|0,qb,43072,42688,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+8>>3];Cb=+h[ca+16>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+zd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+nwa(c[ib>>2]|0,Eb,42768,42688,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+664>>3]-wb}wb=+h[tb>>3];if(wb>0.0){Gb=wb}else{tb=c[63880]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=57624;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&127](Db,l,42696,r);Gb=+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]}if(Gb>0.0){Hb=Gb}else{r=c[63880]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=57624;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&127](l,j,42696,q);Hb=+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]}jA(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];kA(ha,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);Hb=+h[ia>>3];jA(ja,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);Fb=+h[ja>>3];kA(ka,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3];if(zb>0.0){Ib=zb}else{la=c[63880]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=57624;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&127](ka,g,42696,p);Ib=+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]}if(Ib>0.0){Jb=Ib}else{p=c[63880]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=57624;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&127](g,f,42696,o);Jb=+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]}if(Jb>0.0){Kb=Jb}else{o=c[63880]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=57624;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&127](f,e,42696,n);Kb=+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]}qb=Kb+-273.15;lA(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];jA(na,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);qb=+h[na>>3];kA(oa,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);qb=+h[pa>>3];jA(qa,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);Eb=+h[qa>>3];kA(ra,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+8>>3];rb=+zd(1.0e-13,+(+h[qa+16>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+nwa(c[ib>>2]|0,rb,42768,42688,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(Eb- +yd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{jA(ta,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);Lb=+h[ta>>3];kA(ua,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);Lb=+h[va>>3];jA(wa,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);qb=+h[wa>>3];kA(xa,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+zd(1.0e-13,+(+h[wa+16>>3]- +h[ya>>3]));Eb=1.0- +h[wa+8>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+nwa(c[ib>>2]|0,qb,42768,42688,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{jA(za,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);Ob=+h[za>>3];kA(Aa,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);Ob=+h[Ba>>3];jA(Ca,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);Lb=+h[Ca>>3];kA(Da,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);Lb=+h[Ea>>3];jA(Fa,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);qb=+h[Fa>>3];kA(Ga,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+16>>3]- +h[Ha>>3])|0)<<24>>24==0){jA(Ia,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);qb=+h[Ia>>3];kA(Ja,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Ka,c[ib>>2]|0,+h[Ja>>3],+h[Ja+656>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(La,c[ib>>2]|0,+h[Ka>>3],+h[Ka+656>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Ma,c[ib>>2]|0,qb,Eb,+h[Ka>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+656>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+672>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}jA(Na,c[ib>>2]|0,+h[Qb>>3]);rb=+h[Na>>3];kA(Oa,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);rb=+h[Pa>>3];jA(Qa,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);Eb=+h[Qa>>3];kA(Ra,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);Eb=+h[Sa>>3];jA(Ta,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);qb=+h[Ta>>3];kA(Ua,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Va,c[ib>>2]|0,+h[Ua>>3],+h[Ua+656>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(Wa,c[ib>>2]|0,+h[Va>>3],+h[Va+656>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Xa,c[ib>>2]|0,qb,Bb,+h[Va>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+656>>3],0.0);Cb=+h[Xa>>3];jA(Ya,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);Bb=+h[Ya>>3];kA(Za,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+16>>3];vb=+zd(1.0e-13,+(qb-rb));rb=vb*+zd(1.0e-13,+(qb-Eb));Eb=+h[Za+664>>3];vb=-(Eb*+zd(1.0e-13,+(qb-Lb)));Lb=+h[Za+8>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+nwa(c[ib>>2]|0,rb,43072,42688,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+8>>3];Tb=+h[Ya+16>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+zd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+nwa(c[ib>>2]|0,Vb,42768,42688,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+664>>3]-Pb}Pb=+h[Mb>>3];Wb=Pb+-273.15;Cb=+h[Mb+656>>3];sA($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];jA(ab,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);Pb=+h[ab>>3];kA(bb,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);Pb=+h[cb>>3];jA(db,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);Wb=+h[db>>3];kA(eb,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+nwa(c[ib>>2]|0,rb,43680,42688,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+664>>3]-ub);ub=+h[Yb+656>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+nwa(c[ib>>2]|0,Xb,43680,42688,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+656>>3];ac=+h[Yb>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+Nxa(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+8>>3];Gb=+zd(1.0e-13,+(+h[Yb+16>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+nwa(c[ib>>2]|0,Gb,42768,42688,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +zd(+(ac- +yd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+nwa(c[ib>>2]|0,ec,43680,42688,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+664>>3];ic=+h[gc+656>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+nwa(c[ib>>2]|0,fc,43680,42688,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+656>>3];kc=+h[gc>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+Nxa(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+8>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+zd(1.0e-13,+(+h[gc+16>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9552|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9552|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+nwa(c[ib>>2]|0,Nb,42768,42688,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9552|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function uE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;iA(d,c[f>>2]|0,+h[c[(c[c[g>>2]>>2]|0)+8>>2]>>3]);if((Aza(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+16>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+672>>3]*.999;l=j;m=l+9240|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;xA(e,c[f>>2]|0,+h[d>>3],+h[d+656>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+9240|0;n=m;h[n>>3]=k;i=b;return}}function vE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2840>>3]=1.0- +h[b+8>>3];i=i;return}function wE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;h[k>>3]=.99;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];gxa(m,2,.01,l);l=a+536|0;s=c[l>>2]|0;t=a+4|0;u=c[(c[c[t>>2]>>2]|0)+8>>2]|0;v=+h[u+10672>>3];w=+h[u+2832>>3];u=g;x=m;c[u+0>>2]=c[x+0>>2];c[u+4>>2]=c[x+4>>2];c[u+8>>2]=c[x+8>>2];vz(n,s,v,w,g);g=c[l>>2]|0;s=f;x=n;c[s+0>>2]=c[x+0>>2];c[s+4>>2]=c[x+4>>2];c[s+8>>2]=c[x+8>>2];c[s+12>>2]=c[x+12>>2];c[s+16>>2]=c[x+16>>2];c[s+20>>2]=c[x+20>>2];c[s+24>>2]=c[x+24>>2];c[s+28>>2]=c[x+28>>2];Bz(q,g,f);w=+h[q>>3];q=c[(c[c[t>>2]>>2]|0)+8>>2]|0;v=+h[q+8>>3];f=j;h[k>>3]=+h[q+2840>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];gxa(o,2,v,j);j=c[l>>2]|0;f=c[(c[c[t>>2]>>2]|0)+8>>2]|0;v=+h[f+16>>3];y=+h[f>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];vz(p,j,v,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Bz(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[t>>2]>>2]|0)+8>>2]|0)+2128>>3]=+h[d+1032>>3]*(w- +h[r>>3])*+h[d+2216>>3];i=b;return}function xE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+8>>3];p=f;h[k>>3]=+h[n+2840>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+16>>3];q=+h[p>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2320>>3]=+h[l>>3];i=b;return}function yE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+8>>3];p=f;h[k>>3]=+h[n+2840>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+16>>3];q=+h[p>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2424>>3]=+h[l>>3];i=b;return}function zE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;gxa(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+16>>3];l=+h[a>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];tA(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1536>>3]=+h[f>>3];i=b;return}function AE(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;iA(d,c[a+536>>2]|0,+h[c[(c[c[e>>2]>>2]|0)+8>>2]>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+1448>>3]=+yd(+(+h[d>>3]),+(+h[a+16>>3]*.999));i=b;return}function BE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1448>>3];k=+zd(1.0e-13,+(+h[g+16>>3]-j));l=+h[g+2840>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+nwa(c[b+536>>2]|0,k,43712,43704,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8440|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=Cza(1.0e-13,+h[f+16>>3]- +h[f+1448>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+1448>>3];j=+h[x+16>>3];k=+zd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+9120>>3];k=+h[x+2840>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+672>>3]- +h[x+9240>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+672>>3]- +h[x+9240>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+672>>3]- +h[x+9240>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+672>>3]- +h[x+9240>>3]}K=(y-k*J)/+nwa(c[b+536>>2]|0,l,43776,43704,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+2840>>3];C=+h[L+1448>>3];D=+h[L+16>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+9240>>3];m=+zd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+nwa(c[b+536>>2]|0,m,43712,43704,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8440|0;w=v;h[w>>3]=n;i=d;return}function CE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1448>>3];k=+zd(1.0e-13,+(+h[g+16>>3]-j));l=+h[g+2840>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+nwa(c[b+536>>2]|0,k,43712,43904,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+1464>>3]=+yd(+(j*n*.6219647130774989),1.0);i=d;return}function DE(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(Cza(+h[a+8>>3]- +h[a+1464>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+9232|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+664>>3]- +h[a+8440>>3];g=a;j=g+9232|0;k=j;h[k>>3]=f;i=b;return}function EE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8432>>3]=+h[b+664>>3]- +h[b+9232>>3];i=i;return}function FE(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1480>>3]=+zd(+(+h[d+8>>3]- +h[d+1464>>3]),0.0);i=b;return}function GE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1472>>3]=+h[b+8>>3]- +h[b+1480>>3];i=i;return}function HE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1480>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+9232>>3];o=+h[g+9120>>3]*k+ +h[g+2840>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+nwa(c[b+536>>2]|0,l,43920,43912,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+9232>>3];q=+h[v+1480>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+8432>>3]*(1.0-q)+ +h[r+1472>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+9224|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+9224|0;C=B;h[C>>3]=z;i=d;return}p=t/+nwa(c[b+536>>2]|0,l,43920,43912,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+9224|0;C=B;h[C>>3]=z;i=d;return}function IE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1480>>3];k=1.0-j;l=+h[g+2840>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+nwa(c[b+536>>2]|0,k,43968,43960,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+1480>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+1472>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+1512|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+1512|0;z=y;h[z>>3]=w;i=d;return}l=m/+nwa(c[b+536>>2]|0,p,43968,43960,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+1512|0;z=y;h[z>>3]=w;i=d;return}function JE(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1520>>3]=+h[b+1536>>3]- +h[b+1512>>3]*+h[b>>3];i=i;return}



function wea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[105400]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7440>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7440>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(105408,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7440>>3],100864)|0)|0;g=c[63882]|0;j=e;k=171176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[105400]=1;i=d;return}function xea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[105552]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7352>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7352>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(105560,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7352>>3],100864)|0)|0;g=c[63882]|0;j=e;k=172064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[105552]=1;i=d;return}function yea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[105696]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7360>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7360>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(105704,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7360>>3],100864)|0)|0;g=c[63882]|0;j=e;k=172064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[105696]=1;i=d;return}function zea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[105840]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7368>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7368>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(105848,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7368>>3],100864)|0)|0;g=c[63882]|0;j=e;k=172064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[105840]=1;i=d;return}function Aea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[105984]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7376>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7376>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(105992,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7376>>3],100864)|0)|0;g=c[63882]|0;j=e;k=172064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[105984]=1;i=d;return}function Bea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[106128]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7384>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7384>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(106136,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7384>>3],100864)|0)|0;g=c[63882]|0;j=e;k=172064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[106128]=1;i=d;return}function Cea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[106272]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7392>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7392>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(106280,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7392>>3],100864)|0)|0;g=c[63882]|0;j=e;k=172064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[106272]=1;i=d;return}function Dea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[106416]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9576>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9576>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(106424,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9576>>3],100864)|0)|0;g=c[63882]|0;j=e;k=173152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[106416]=1;i=d;return}function Eea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[106568]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9584>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9584>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(106576,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9584>>3],100864)|0)|0;g=c[63882]|0;j=e;k=173152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[106568]=1;i=d;return}function Fea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[106720]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9592>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9592>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(106728,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9592>>3],100864)|0)|0;g=c[63882]|0;j=e;k=173152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[106720]=1;i=d;return}function Gea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[106872]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9600>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9600>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(106880,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9600>>3],100864)|0)|0;g=c[63882]|0;j=e;k=173152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[106872]=1;i=d;return}function Hea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[107024]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9608>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9608>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(107032,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9608>>3],100864)|0)|0;g=c[63882]|0;j=e;k=173152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[107024]=1;i=d;return}function Iea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[107176]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9616>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9616>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(107184,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9616>>3],100864)|0)|0;g=c[63882]|0;j=e;k=173152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[107176]=1;i=d;return}function Jea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[107328]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7288>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7288>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(107336,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7288>>3],100864)|0)|0;g=c[63882]|0;j=e;k=174184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[107328]=1;i=d;return}function Kea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[107496]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7296>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7296>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(107504,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7296>>3],100864)|0)|0;g=c[63882]|0;j=e;k=174184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[107496]=1;i=d;return}function Lea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[107664]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7304>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7304>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(107672,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7304>>3],100864)|0)|0;g=c[63882]|0;j=e;k=174184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[107664]=1;i=d;return}function Mea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[107832]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7312>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7312>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(107840,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7312>>3],100864)|0)|0;g=c[63882]|0;j=e;k=174184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[107832]=1;i=d;return}function Nea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[108e3]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7320>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7320>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(108008,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7320>>3],100864)|0)|0;g=c[63882]|0;j=e;k=174184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[108e3]=1;i=d;return}function Oea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[108168]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7328>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7328>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(108176,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7328>>3],100864)|0)|0;g=c[63882]|0;j=e;k=174184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[108168]=1;i=d;return}function Pea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[108336]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9632>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9632>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(108344,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9632>>3],100864)|0)|0;g=c[63882]|0;j=e;k=175272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[108336]=1;i=d;return}function Qea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[108488]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9640>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9640>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(108496,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9640>>3],100864)|0)|0;g=c[63882]|0;j=e;k=175272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[108488]=1;i=d;return}function Rea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[108640]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9648>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9648>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(108648,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9648>>3],100864)|0)|0;g=c[63882]|0;j=e;k=175272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[108640]=1;i=d;return}function Sea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[108792]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9656>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9656>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(108800,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9656>>3],100864)|0)|0;g=c[63882]|0;j=e;k=175272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[108792]=1;i=d;return}function Tea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[108944]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9664>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9664>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(108952,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9664>>3],100864)|0)|0;g=c[63882]|0;j=e;k=175272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[108944]=1;i=d;return}function Uea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[109096]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9672>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9672>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(109104,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9672>>3],100864)|0)|0;g=c[63882]|0;j=e;k=175272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[109096]=1;i=d;return}function Vea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[109248]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7240>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7240>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(109256,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7240>>3],100864)|0)|0;g=c[63882]|0;j=e;k=176304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[109248]=1;i=d;return}function Wea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[109416]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7248>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7248>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(109424,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7248>>3],100864)|0)|0;g=c[63882]|0;j=e;k=176304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[109416]=1;i=d;return}function Xea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[109584]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7256>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7256>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(109592,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7256>>3],100864)|0)|0;g=c[63882]|0;j=e;k=176304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[109584]=1;i=d;return}function Yea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[109752]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7264>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7264>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(109760,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7264>>3],100864)|0)|0;g=c[63882]|0;j=e;k=176304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[109752]=1;i=d;return}function Zea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[109920]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7272>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7272>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(109928,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7272>>3],100864)|0)|0;g=c[63882]|0;j=e;k=176304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[109920]=1;i=d;return}function _ea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[110088]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7280>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7280>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(110096,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7280>>3],100864)|0)|0;g=c[63882]|0;j=e;k=176304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[110088]=1;i=d;return}function $ea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[110256]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+608>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+608>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(110264,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+608>>3],100864)|0)|0;g=c[63882]|0;j=e;k=177432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[110256]=1;i=d;return}function afa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[110440]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+616>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+616>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(110448,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+616>>3],100864)|0)|0;g=c[63882]|0;j=e;k=177432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[110440]=1;i=d;return}function bfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[110624]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+624>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+624>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(110632,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+624>>3],100864)|0)|0;g=c[63882]|0;j=e;k=177432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[110624]=1;i=d;return}function cfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[110808]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+632>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+632>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(110816,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+632>>3],100864)|0)|0;g=c[63882]|0;j=e;k=177432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[110808]=1;i=d;return}function dfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[110992]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+640>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+640>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(111e3,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+640>>3],100864)|0)|0;g=c[63882]|0;j=e;k=177432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[110992]=1;i=d;return}function efa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[111176]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+648>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+648>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(111184,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+648>>3],100864)|0)|0;g=c[63882]|0;j=e;k=177432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[111176]=1;i=d;return}function ffa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[111360]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+600>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+600>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(111368,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+600>>3],100864)|0)|0;g=c[63882]|0;j=e;k=185504;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[111360]=1;i=d;return}function gfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[111504]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+592>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+592>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(111512,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+592>>3],100864)|0)|0;g=c[63882]|0;j=e;k=185672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[111504]=1;i=d;return}function hfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[111648]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6992>>3],-1.0e10)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6992>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=Owa(111656,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6992>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[111648]=1;i=d;return}function ifa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[111808]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6984>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6984>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(111816,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6984>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[111808]=1;i=d;return}function jfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[111952]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+584>>3],1.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+584>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=Owa(111960,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+584>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186136;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[111952]=1;i=d;return}function kfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[112088]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6976>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6976>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(112096,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6976>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[112088]=1;i=d;return}function lfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[112240]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6968>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6968>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=Owa(112248,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6968>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188872;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[112240]=1;i=d;return}function mfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[112384]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6960>>3],.001)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6960>>3],.25)|0)<<24>>24==0)){i=d;return}b=Owa(112392,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6960>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[112384]=1;i=d;return}function nfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[112528]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6952>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6952>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(112536,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6952>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[112528]=1;i=d;return}function ofa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[112760]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6936>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6936>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(112768,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6936>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[112760]=1;i=d;return}function pfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[112920]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6928>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6928>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(112928,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6928>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189232;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[112920]=1;i=d;return}function qfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[113072]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6920>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6920>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(113080,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6920>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[113072]=1;i=d;return}function rfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[113216]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6912>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6912>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(113224,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6912>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[113216]=1;i=d;return}function sfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[113360]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6904>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6904>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(113368,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6904>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[113360]=1;i=d;return}function tfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[113536]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+576>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+576>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(113544,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+576>>3],100864)|0)|0;g=c[63882]|0;j=e;k=185504;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[113536]=1;i=d;return}function ufa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[113680]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+568>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+568>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(113688,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+568>>3],100864)|0)|0;g=c[63882]|0;j=e;k=185672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[113680]=1;i=d;return}function vfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[113824]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6872>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6872>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(113832,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6872>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[113824]=1;i=d;return}function wfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[113968]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+560>>3],1.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+560>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=Owa(113976,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+560>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186136;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[113968]=1;i=d;return}function xfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[114104]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6864>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6864>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(114112,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6864>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[114104]=1;i=d;return}function yfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[114256]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6856>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6856>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=Owa(114264,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6856>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188872;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[114256]=1;i=d;return}function zfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[114400]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6848>>3],.001)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6848>>3],.25)|0)<<24>>24==0)){i=d;return}b=Owa(114408,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6848>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[114400]=1;i=d;return}function Afa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[114544]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6840>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6840>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(114552,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6840>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[114544]=1;i=d;return}function Bfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[114696]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6824>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6824>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(114704,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6824>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[114696]=1;i=d;return}function Cfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[114856]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6816>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6816>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(114864,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6816>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189232;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[114856]=1;i=d;return}function Dfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[115008]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6808>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6808>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(115016,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6808>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[115008]=1;i=d;return}function Efa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[115152]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6800>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6800>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(115160,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6800>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[115152]=1;i=d;return}function Ffa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[115296]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6792>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6792>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(115304,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6792>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[115296]=1;i=d;return}function Gfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[115472]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+552>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+552>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(115480,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+552>>3],100864)|0)|0;g=c[63882]|0;j=e;k=185504;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[115472]=1;i=d;return}function Hfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[115616]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+544>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+544>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(115624,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+544>>3],100864)|0)|0;g=c[63882]|0;j=e;k=185672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[115616]=1;i=d;return}function Ifa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[115760]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6760>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6760>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(115768,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6760>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[115760]=1;i=d;return}function Jfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[115904]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+536>>3],1.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+536>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=Owa(115912,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+536>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186136;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[115904]=1;i=d;return}function Kfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[116040]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6752>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6752>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(116048,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6752>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[116040]=1;i=d;return}function Lfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[116192]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6744>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6744>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=Owa(116200,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6744>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188872;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[116192]=1;i=d;return}function Mfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[116336]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6736>>3],.001)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6736>>3],.25)|0)<<24>>24==0)){i=d;return}b=Owa(116344,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6736>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[116336]=1;i=d;return}function Nfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[116480]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6728>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6728>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(116488,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6728>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[116480]=1;i=d;return}function Ofa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[116632]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6712>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6712>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(116640,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6712>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[116632]=1;i=d;return}function Pfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[116792]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6704>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6704>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(116800,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6704>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189232;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[116792]=1;i=d;return}function Qfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[116944]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6696>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6696>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(116952,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6696>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[116944]=1;i=d;return}function Rfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[117088]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6688>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6688>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(117096,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6688>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[117088]=1;i=d;return}function Sfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[117232]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6680>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6680>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(117240,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6680>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[117232]=1;i=d;return}function Tfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[117408]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+528>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+528>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(117416,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+528>>3],100864)|0)|0;g=c[63882]|0;j=e;k=185504;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[117408]=1;i=d;return}function Ufa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[117552]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+520>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+520>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(117560,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+520>>3],100864)|0)|0;g=c[63882]|0;j=e;k=185672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[117552]=1;i=d;return}function Vfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[117696]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6648>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6648>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(117704,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6648>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[117696]=1;i=d;return}function Wfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[117840]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+512>>3],1.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+512>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=Owa(117848,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+512>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186136;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[117840]=1;i=d;return}function Xfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[117976]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6640>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6640>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(117984,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6640>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[117976]=1;i=d;return}function Yfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[118128]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6632>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6632>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=Owa(118136,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6632>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188872;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[118128]=1;i=d;return}function Zfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[118272]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6624>>3],.001)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6624>>3],.25)|0)<<24>>24==0)){i=d;return}b=Owa(118280,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6624>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[118272]=1;i=d;return}function _fa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[118416]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6616>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6616>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(118424,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6616>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[118416]=1;i=d;return}function $fa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[118568]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6600>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6600>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(118576,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6600>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[118568]=1;i=d;return}function aga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[118728]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6592>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6592>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(118736,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6592>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189232;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[118728]=1;i=d;return}function bga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[118880]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6584>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6584>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(118888,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6584>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[118880]=1;i=d;return}function cga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[119024]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6576>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6576>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(119032,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6576>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[119024]=1;i=d;return}function dga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[119168]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6568>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6568>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(119176,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6568>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[119168]=1;i=d;return}function ega(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[119344]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+504>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+504>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(119352,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+504>>3],100864)|0)|0;g=c[63882]|0;j=e;k=185504;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[119344]=1;i=d;return}function fga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[119488]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+496>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+496>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(119496,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+496>>3],100864)|0)|0;g=c[63882]|0;j=e;k=185672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[119488]=1;i=d;return}function gga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[119632]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6544>>3],-1.0e10)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6544>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=Owa(119640,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6544>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[119632]=1;i=d;return}function hga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[119792]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6536>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6536>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(119800,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6536>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[119792]=1;i=d;return}function iga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[119936]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+488>>3],1.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+488>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=Owa(119944,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+488>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186136;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[119936]=1;i=d;return}function jga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[120072]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6528>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6528>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(120080,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6528>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[120072]=1;i=d;return}function kga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[120224]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6520>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6520>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=Owa(120232,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6520>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188872;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[120224]=1;i=d;return}function lga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[120368]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6512>>3],.001)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6512>>3],.25)|0)<<24>>24==0)){i=d;return}b=Owa(120376,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6512>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[120368]=1;i=d;return}function mga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[120512]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6504>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6504>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(120520,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6504>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[120512]=1;i=d;return}function nga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[120664]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6488>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6488>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(120672,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6488>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[120664]=1;i=d;return}function oga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[120824]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6480>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6480>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(120832,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6480>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189232;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[120824]=1;i=d;return}function pga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[120976]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6472>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6472>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(120984,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6472>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[120976]=1;i=d;return}function qga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[121120]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6464>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6464>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(121128,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6464>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[121120]=1;i=d;return}function rga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[121264]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6456>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6456>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(121272,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6456>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[121264]=1;i=d;return}function sga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[121440]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6360>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(121448,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6360>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[121440]=1;i=d;return}function tga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[121560]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6368>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(121568,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6368>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[121560]=1;i=d;return}function uga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[121680]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6376>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(121688,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6376>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[121680]=1;i=d;return}function vga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[121800]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6384>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(121808,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6384>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[121800]=1;i=d;return}function wga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[121920]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6392>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(121928,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6392>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[121920]=1;i=d;return}function xga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[122040]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10776>>3],1.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10776>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=Owa(122048,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10776>>3],100864)|0)|0;g=c[63882]|0;j=e;k=167744;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[122040]=1;i=d;return}function yga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[122168]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6344>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6344>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(122176,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6344>>3],100864)|0)|0;g=c[63882]|0;j=e;k=167576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[122168]=1;i=d;return}function zga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[122304]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6352>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6352>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(122312,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6352>>3],100864)|0)|0;g=c[63882]|0;j=e;k=167576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[122304]=1;i=d;return}function Aga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[122440]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10768>>3],1.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10768>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=Owa(122448,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10768>>3],100864)|0)|0;g=c[63882]|0;j=e;k=167744;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[122440]=1;i=d;return}function Bga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[122568]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6328>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6328>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(122576,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6328>>3],100864)|0)|0;g=c[63882]|0;j=e;k=167576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[122568]=1;i=d;return}function Cga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[122704]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6336>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6336>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(122712,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6336>>3],100864)|0)|0;g=c[63882]|0;j=e;k=167576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[122704]=1;i=d;return}function Dga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[122840]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6320>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6320>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(122848,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6320>>3],100864)|0)|0;g=c[63882]|0;j=e;k=167576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[122840]=1;i=d;return}function Ega(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[122984]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6312>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6312>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(122992,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6312>>3],100864)|0)|0;g=c[63882]|0;j=e;k=167576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[122984]=1;i=d;return}function Fga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[123128]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6304>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6304>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(123136,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6304>>3],100864)|0)|0;g=c[63882]|0;j=e;k=167576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[123128]=1;i=d;return}function Gga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[123272]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6296>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6296>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(123280,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6296>>3],100864)|0)|0;g=c[63882]|0;j=e;k=167576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[123272]=1;i=d;return}function Hga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[123416]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6288>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6288>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(123424,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6288>>3],100864)|0)|0;g=c[63882]|0;j=e;k=167576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[123416]=1;i=d;return}function Iga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[123560]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6208>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(123568,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6208>>3],100864)|0)|0;g=c[63882]|0;j=e;k=168208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[123560]=1;i=d;return}function Jga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[123648]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6216>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(123656,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6216>>3],100864)|0)|0;g=c[63882]|0;j=e;k=168208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[123648]=1;i=d;return}function Kga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[123736]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6224>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(123744,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6224>>3],100864)|0)|0;g=c[63882]|0;j=e;k=168208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[123736]=1;i=d;return}function Lga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[123824]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6232>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(123832,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6232>>3],100864)|0)|0;g=c[63882]|0;j=e;k=168208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[123824]=1;i=d;return}function Mga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[123912]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6240>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(123920,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6240>>3],100864)|0)|0;g=c[63882]|0;j=e;k=168208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[123912]=1;i=d;return}function Nga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[124e3]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6168>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(124008,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6168>>3],100864)|0)|0;g=c[63882]|0;j=e;k=168712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[124e3]=1;i=d;return}function Oga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[124096]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6176>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(124104,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6176>>3],100864)|0)|0;g=c[63882]|0;j=e;k=168712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[124096]=1;i=d;return}function Pga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[124192]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6184>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(124200,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6184>>3],100864)|0)|0;g=c[63882]|0;j=e;k=168712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[124192]=1;i=d;return}function Qga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[124288]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6192>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(124296,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6192>>3],100864)|0)|0;g=c[63882]|0;j=e;k=168712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[124288]=1;i=d;return}function Rga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[124384]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6200>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(124392,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6200>>3],100864)|0)|0;g=c[63882]|0;j=e;k=168712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[124384]=1;i=d;return}function Sga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[124480]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6128>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6128>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(124488,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6128>>3],100864)|0)|0;g=c[63882]|0;j=e;k=169456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[124480]=1;i=d;return}function Tga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[124624]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6136>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6136>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(124632,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6136>>3],100864)|0)|0;g=c[63882]|0;j=e;k=169456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[124624]=1;i=d;return}function Uga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[124768]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6144>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6144>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(124776,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6144>>3],100864)|0)|0;g=c[63882]|0;j=e;k=169456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[124768]=1;i=d;return}function Vga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[124912]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6152>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6152>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(124920,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6152>>3],100864)|0)|0;g=c[63882]|0;j=e;k=169456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[124912]=1;i=d;return}function Wga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[125056]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6160>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6160>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(125064,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6160>>3],100864)|0)|0;g=c[63882]|0;j=e;k=169456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[125056]=1;i=d;return}function Xga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[125200]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6088>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6088>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(125208,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6088>>3],100864)|0)|0;g=c[63882]|0;j=e;k=170240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[125200]=1;i=d;return}function Yga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[125352]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6096>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6096>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(125360,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6096>>3],100864)|0)|0;g=c[63882]|0;j=e;k=170240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[125352]=1;i=d;return}function Zga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[125504]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6104>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6104>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(125512,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6104>>3],100864)|0)|0;g=c[63882]|0;j=e;k=170240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[125504]=1;i=d;return}function _ga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[125656]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6112>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6112>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(125664,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6112>>3],100864)|0)|0;g=c[63882]|0;j=e;k=170240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[125656]=1;i=d;return}function $ga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[125808]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6120>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6120>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(125816,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6120>>3],100864)|0)|0;g=c[63882]|0;j=e;k=170240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[125808]=1;i=d;return}function aha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[125960]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5960>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5960>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(125968,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5960>>3],100864)|0)|0;g=c[63882]|0;j=e;k=126264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[125960]=1;i=d;return}function bha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[126112]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5952>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5952>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(126120,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5952>>3],100864)|0)|0;g=c[63882]|0;j=e;k=126264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[126112]=1;i=d;return}function cha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[126288]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5904>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5904>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(126296,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5904>>3],100864)|0)|0;g=c[63882]|0;j=e;k=171176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[126288]=1;i=d;return}function dha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[126440]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5912>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5912>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(126448,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5912>>3],100864)|0)|0;g=c[63882]|0;j=e;k=171176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[126440]=1;i=d;return}function eha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[126592]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5920>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5920>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(126600,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5920>>3],100864)|0)|0;g=c[63882]|0;j=e;k=171176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[126592]=1;i=d;return}function fha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[126744]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5928>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5928>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(126752,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5928>>3],100864)|0)|0;g=c[63882]|0;j=e;k=171176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[126744]=1;i=d;return}function gha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[126896]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5936>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5936>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(126904,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5936>>3],100864)|0)|0;g=c[63882]|0;j=e;k=171176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[126896]=1;i=d;return}function hha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[127048]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5944>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5944>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(127056,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5944>>3],100864)|0)|0;g=c[63882]|0;j=e;k=171176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[127048]=1;i=d;return}function iha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[127200]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5856>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5856>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(127208,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5856>>3],100864)|0)|0;g=c[63882]|0;j=e;k=172064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[127200]=1;i=d;return}function jha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[127344]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5864>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5864>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(127352,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5864>>3],100864)|0)|0;g=c[63882]|0;j=e;k=172064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[127344]=1;i=d;return}function kha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[127488]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5872>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5872>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(127496,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5872>>3],100864)|0)|0;g=c[63882]|0;j=e;k=172064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[127488]=1;i=d;return}function lha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[127632]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5880>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5880>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(127640,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5880>>3],100864)|0)|0;g=c[63882]|0;j=e;k=172064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[127632]=1;i=d;return}function mha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[127776]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5888>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5888>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(127784,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5888>>3],100864)|0)|0;g=c[63882]|0;j=e;k=172064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[127776]=1;i=d;return}function nha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[127920]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5896>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5896>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(127928,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5896>>3],100864)|0)|0;g=c[63882]|0;j=e;k=172064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[127920]=1;i=d;return}function oha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[128064]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5816>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5816>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(128072,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5816>>3],100864)|0)|0;g=c[63882]|0;j=e;k=173152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[128064]=1;i=d;return}function pha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[128216]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5824>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5824>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(128224,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5824>>3],100864)|0)|0;g=c[63882]|0;j=e;k=173152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[128216]=1;i=d;return}function qha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[128368]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5832>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5832>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(128376,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5832>>3],100864)|0)|0;g=c[63882]|0;j=e;k=173152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[128368]=1;i=d;return}function rha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[128520]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5840>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5840>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(128528,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5840>>3],100864)|0)|0;g=c[63882]|0;j=e;k=173152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[128520]=1;i=d;return}function sha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[128672]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5848>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5848>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(128680,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5848>>3],100864)|0)|0;g=c[63882]|0;j=e;k=173152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[128672]=1;i=d;return}function tha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[128824]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5784>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5784>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(128832,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5784>>3],100864)|0)|0;g=c[63882]|0;j=e;k=174184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[128824]=1;i=d;return}function uha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[128992]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5792>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5792>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(129e3,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5792>>3],100864)|0)|0;g=c[63882]|0;j=e;k=174184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[128992]=1;i=d;return}function vha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[129160]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5800>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5800>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(129168,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5800>>3],100864)|0)|0;g=c[63882]|0;j=e;k=174184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[129160]=1;i=d;return}function wha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[129328]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5808>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5808>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(129336,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5808>>3],100864)|0)|0;g=c[63882]|0;j=e;k=174184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[129328]=1;i=d;return}function xha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[129496]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5744>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5744>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(129504,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5744>>3],100864)|0)|0;g=c[63882]|0;j=e;k=175272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[129496]=1;i=d;return}function yha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[129648]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5752>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5752>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(129656,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5752>>3],100864)|0)|0;g=c[63882]|0;j=e;k=175272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[129648]=1;i=d;return}function zha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[129800]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5760>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5760>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(129808,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5760>>3],100864)|0)|0;g=c[63882]|0;j=e;k=175272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[129800]=1;i=d;return}function Aha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[129952]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5768>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5768>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(129960,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5768>>3],100864)|0)|0;g=c[63882]|0;j=e;k=175272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[129952]=1;i=d;return}function Bha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[130104]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5776>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5776>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(130112,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5776>>3],100864)|0)|0;g=c[63882]|0;j=e;k=175272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[130104]=1;i=d;return}function Cha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[130256]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5712>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5712>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(130264,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5712>>3],100864)|0)|0;g=c[63882]|0;j=e;k=176304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[130256]=1;i=d;return}function Dha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[130424]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5720>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5720>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(130432,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5720>>3],100864)|0)|0;g=c[63882]|0;j=e;k=176304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[130424]=1;i=d;return}function Eha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[130592]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5728>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5728>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(130600,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5728>>3],100864)|0)|0;g=c[63882]|0;j=e;k=176304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[130592]=1;i=d;return}function Fha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[130760]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5736>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5736>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(130768,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5736>>3],100864)|0)|0;g=c[63882]|0;j=e;k=176304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[130760]=1;i=d;return}function Gha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[130928]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+456>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+456>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(130936,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+456>>3],100864)|0)|0;g=c[63882]|0;j=e;k=177432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[130928]=1;i=d;return}function Hha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[131112]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+464>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+464>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(131120,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+464>>3],100864)|0)|0;g=c[63882]|0;j=e;k=177432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[131112]=1;i=d;return}function Iha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[131296]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+472>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+472>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(131304,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+472>>3],100864)|0)|0;g=c[63882]|0;j=e;k=177432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[131296]=1;i=d;return}function Jha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[131480]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+480>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+480>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(131488,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+480>>3],100864)|0)|0;g=c[63882]|0;j=e;k=177432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[131480]=1;i=d;return}function Kha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[131664]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+448>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+448>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(131672,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+448>>3],100864)|0)|0;g=c[63882]|0;j=e;k=185504;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[131664]=1;i=d;return}function Lha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[131808]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+440>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+440>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(131816,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+440>>3],100864)|0)|0;g=c[63882]|0;j=e;k=185672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[131808]=1;i=d;return}function Mha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[131952]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5544>>3],-1.0e10)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5544>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=Owa(131960,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5544>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[131952]=1;i=d;return}function Nha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[132112]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5536>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5536>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(132120,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5536>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[132112]=1;i=d;return}function Oha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[132256]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+432>>3],1.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+432>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=Owa(132264,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+432>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186136;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[132256]=1;i=d;return}function Pha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[132392]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5528>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5528>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(132400,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5528>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[132392]=1;i=d;return}function Qha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[132544]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5520>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5520>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=Owa(132552,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5520>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188872;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[132544]=1;i=d;return}function Rha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[132688]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5512>>3],.001)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5512>>3],.25)|0)<<24>>24==0)){i=d;return}b=Owa(132696,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5512>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[132688]=1;i=d;return}function Sha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[132832]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5504>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5504>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(132840,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5504>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[132832]=1;i=d;return}function Tha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[132984]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5488>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5488>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(132992,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5488>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[132984]=1;i=d;return}function Uha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[133144]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5480>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5480>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(133152,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5480>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189232;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[133144]=1;i=d;return}function Vha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[133296]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5472>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5472>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(133304,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5472>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[133296]=1;i=d;return}function Wha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[133440]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5464>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5464>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(133448,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5464>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[133440]=1;i=d;return}function Xha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[133584]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5456>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5456>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(133592,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5456>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[133584]=1;i=d;return}function Yha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[133760]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+424>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+424>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(133768,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+424>>3],100864)|0)|0;g=c[63882]|0;j=e;k=185504;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[133760]=1;i=d;return}



function Zha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[133904]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+416>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+416>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(133912,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+416>>3],100864)|0)|0;g=c[63882]|0;j=e;k=185672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[133904]=1;i=d;return}function _ha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[134048]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5424>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5424>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(134056,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5424>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[134048]=1;i=d;return}function $ha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[134192]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+408>>3],1.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+408>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=Owa(134200,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+408>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186136;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[134192]=1;i=d;return}function aia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[134328]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5416>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5416>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(134336,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5416>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[134328]=1;i=d;return}function bia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[134480]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5408>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5408>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=Owa(134488,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5408>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188872;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[134480]=1;i=d;return}function cia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[134624]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5400>>3],.001)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5400>>3],.25)|0)<<24>>24==0)){i=d;return}b=Owa(134632,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5400>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[134624]=1;i=d;return}function dia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[134768]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5392>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5392>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(134776,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5392>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[134768]=1;i=d;return}function eia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[134920]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5376>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5376>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(134928,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5376>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[134920]=1;i=d;return}function fia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[135080]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5368>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5368>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(135088,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5368>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189232;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[135080]=1;i=d;return}function gia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[135232]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5360>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5360>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(135240,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5360>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[135232]=1;i=d;return}function hia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[135376]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5352>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5352>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(135384,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5352>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[135376]=1;i=d;return}function iia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[135520]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5344>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5344>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(135528,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5344>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[135520]=1;i=d;return}function jia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[135696]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+400>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+400>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(135704,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+400>>3],100864)|0)|0;g=c[63882]|0;j=e;k=185504;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[135696]=1;i=d;return}function kia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[135840]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+392>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+392>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(135848,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+392>>3],100864)|0)|0;g=c[63882]|0;j=e;k=185672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[135840]=1;i=d;return}function lia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[135984]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5312>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5312>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(135992,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5312>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[135984]=1;i=d;return}function mia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[136128]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+384>>3],1.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+384>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=Owa(136136,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+384>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186136;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[136128]=1;i=d;return}function nia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[136264]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5304>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5304>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(136272,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5304>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[136264]=1;i=d;return}function oia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[136416]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5296>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5296>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=Owa(136424,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5296>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188872;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[136416]=1;i=d;return}function pia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[136560]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5288>>3],.001)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5288>>3],.25)|0)<<24>>24==0)){i=d;return}b=Owa(136568,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5288>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[136560]=1;i=d;return}function qia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[136704]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5280>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5280>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(136712,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5280>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[136704]=1;i=d;return}function ria(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[136856]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5264>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5264>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(136864,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5264>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[136856]=1;i=d;return}function sia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[137016]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5256>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5256>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(137024,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5256>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189232;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[137016]=1;i=d;return}function tia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[137168]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5248>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5248>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(137176,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5248>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[137168]=1;i=d;return}function uia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[137312]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5240>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5240>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(137320,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5240>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[137312]=1;i=d;return}function via(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[137456]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5232>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5232>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(137464,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5232>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[137456]=1;i=d;return}function wia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[137632]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+376>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+376>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(137640,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+376>>3],100864)|0)|0;g=c[63882]|0;j=e;k=185504;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[137632]=1;i=d;return}function xia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[137776]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+368>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+368>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(137784,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+368>>3],100864)|0)|0;g=c[63882]|0;j=e;k=185672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[137776]=1;i=d;return}function yia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[137920]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5200>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5200>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(137928,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5200>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[137920]=1;i=d;return}function zia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[138064]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+360>>3],1.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+360>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=Owa(138072,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+360>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186136;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[138064]=1;i=d;return}function Aia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[138200]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5192>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5192>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(138208,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5192>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[138200]=1;i=d;return}function Bia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[138352]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5184>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5184>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=Owa(138360,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5184>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188872;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[138352]=1;i=d;return}function Cia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[138496]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5176>>3],.001)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5176>>3],.25)|0)<<24>>24==0)){i=d;return}b=Owa(138504,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5176>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[138496]=1;i=d;return}function Dia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[138640]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5168>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5168>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(138648,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5168>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[138640]=1;i=d;return}function Eia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[138792]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5152>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5152>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(138800,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5152>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[138792]=1;i=d;return}function Fia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[138952]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5144>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5144>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(138960,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5144>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189232;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[138952]=1;i=d;return}function Gia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[139104]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5136>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5136>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(139112,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5136>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[139104]=1;i=d;return}function Hia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[139248]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5128>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5128>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(139256,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5128>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[139248]=1;i=d;return}function Iia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[139392]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5120>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5120>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(139400,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5120>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[139392]=1;i=d;return}function Jia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[139568]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+352>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+352>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(139576,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+352>>3],100864)|0)|0;g=c[63882]|0;j=e;k=185504;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[139568]=1;i=d;return}function Kia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[139712]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+344>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+344>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(139720,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+344>>3],100864)|0)|0;g=c[63882]|0;j=e;k=185672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[139712]=1;i=d;return}function Lia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[139856]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5096>>3],-1.0e10)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5096>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=Owa(139864,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5096>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[139856]=1;i=d;return}function Mia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[140016]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5088>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5088>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(140024,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5088>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[140016]=1;i=d;return}function Nia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[140160]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+336>>3],1.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+336>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=Owa(140168,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+336>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186136;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[140160]=1;i=d;return}function Oia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[140296]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5080>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5080>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(140304,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5080>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[140296]=1;i=d;return}function Pia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[140448]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5072>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5072>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=Owa(140456,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5072>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188872;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[140448]=1;i=d;return}function Qia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[140592]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5064>>3],.001)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5064>>3],.25)|0)<<24>>24==0)){i=d;return}b=Owa(140600,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5064>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[140592]=1;i=d;return}function Ria(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[140736]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5056>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5056>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(140744,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5056>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[140736]=1;i=d;return}function Sia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[140888]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5040>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5040>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(140896,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5040>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[140888]=1;i=d;return}function Tia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[141048]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5032>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5032>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(141056,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5032>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189232;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[141048]=1;i=d;return}function Uia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[141200]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5024>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5024>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(141208,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5024>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[141200]=1;i=d;return}function Via(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[141344]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5016>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5016>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(141352,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5016>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[141344]=1;i=d;return}function Wia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[141488]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5008>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5008>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(141496,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5008>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[141488]=1;i=d;return}function Xia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[141664]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4792>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4792>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(141672,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4792>>3],100864)|0)|0;g=c[63882]|0;j=e;k=142464;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[141664]=1;i=d;return}function Yia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[141824]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4800>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4800>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(141832,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4800>>3],100864)|0)|0;g=c[63882]|0;j=e;k=142464;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[141824]=1;i=d;return}function Zia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[141984]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4808>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4808>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(141992,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4808>>3],100864)|0)|0;g=c[63882]|0;j=e;k=142464;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[141984]=1;i=d;return}function _ia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[142144]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4816>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4816>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(142152,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4816>>3],100864)|0)|0;g=c[63882]|0;j=e;k=142464;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[142144]=1;i=d;return}function $ia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[142304]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4824>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4824>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(142312,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4824>>3],100864)|0)|0;g=c[63882]|0;j=e;k=142464;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[142304]=1;i=d;return}function aja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[142488]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4752>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4752>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(142496,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4752>>3],100864)|0)|0;g=c[63882]|0;j=e;k=143328;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[142488]=1;i=d;return}function bja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[142656]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4760>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4760>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(142664,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4760>>3],100864)|0)|0;g=c[63882]|0;j=e;k=143328;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[142656]=1;i=d;return}function cja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[142824]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4768>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4768>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(142832,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4768>>3],100864)|0)|0;g=c[63882]|0;j=e;k=143328;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[142824]=1;i=d;return}function dja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[142992]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4776>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4776>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(143e3,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4776>>3],100864)|0)|0;g=c[63882]|0;j=e;k=143328;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[142992]=1;i=d;return}function eja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[143160]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4784>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4784>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(143168,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4784>>3],100864)|0)|0;g=c[63882]|0;j=e;k=143328;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[143160]=1;i=d;return}function fja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[143352]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4712>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4712>>3],500.0)|0)<<24>>24==0)){i=d;return}b=Owa(143360,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4712>>3],100864)|0)|0;g=c[63882]|0;j=e;k=144192;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[143352]=1;i=d;return}function gja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[143520]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4720>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4720>>3],500.0)|0)<<24>>24==0)){i=d;return}b=Owa(143528,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4720>>3],100864)|0)|0;g=c[63882]|0;j=e;k=144192;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[143520]=1;i=d;return}function hja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[143688]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4728>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4728>>3],500.0)|0)<<24>>24==0)){i=d;return}b=Owa(143696,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4728>>3],100864)|0)|0;g=c[63882]|0;j=e;k=144192;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[143688]=1;i=d;return}function ija(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[143856]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4736>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4736>>3],500.0)|0)<<24>>24==0)){i=d;return}b=Owa(143864,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4736>>3],100864)|0)|0;g=c[63882]|0;j=e;k=144192;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[143856]=1;i=d;return}function jja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[144024]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4744>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4744>>3],500.0)|0)<<24>>24==0)){i=d;return}b=Owa(144032,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4744>>3],100864)|0)|0;g=c[63882]|0;j=e;k=144192;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[144024]=1;i=d;return}function kja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[144216]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4472>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(144224,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4472>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[144216]=1;i=d;return}function lja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[144336]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4480>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(144344,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4480>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[144336]=1;i=d;return}function mja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[144456]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4488>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(144464,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4488>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[144456]=1;i=d;return}function nja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[144576]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4496>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(144584,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4496>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[144576]=1;i=d;return}function oja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[144696]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4504>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(144704,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4504>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[144696]=1;i=d;return}function pja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[144816]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4464>>3],1.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4464>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=Owa(144824,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4464>>3],100864)|0)|0;g=c[63882]|0;j=e;k=167744;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[144816]=1;i=d;return}function qja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[144960]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4448>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4448>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(144968,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4448>>3],100864)|0)|0;g=c[63882]|0;j=e;k=167576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[144960]=1;i=d;return}function rja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[145104]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4456>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4456>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(145112,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4456>>3],100864)|0)|0;g=c[63882]|0;j=e;k=167576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[145104]=1;i=d;return}function sja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[145248]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4440>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4440>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(145256,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4440>>3],100864)|0)|0;g=c[63882]|0;j=e;k=167576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[145248]=1;i=d;return}function tja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[145392]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4432>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4432>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(145400,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4432>>3],100864)|0)|0;g=c[63882]|0;j=e;k=167576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[145392]=1;i=d;return}function uja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[145536]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4424>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4424>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(145544,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4424>>3],100864)|0)|0;g=c[63882]|0;j=e;k=167576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[145536]=1;i=d;return}function vja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[145680]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4416>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4416>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(145688,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4416>>3],100864)|0)|0;g=c[63882]|0;j=e;k=167576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[145680]=1;i=d;return}function wja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[145824]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4408>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4408>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(145832,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4408>>3],100864)|0)|0;g=c[63882]|0;j=e;k=167576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[145824]=1;i=d;return}function xja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[145968]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4400>>3],1.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4400>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=Owa(145976,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4400>>3],100864)|0)|0;g=c[63882]|0;j=e;k=167744;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[145968]=1;i=d;return}function yja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[146112]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4384>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4384>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(146120,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4384>>3],100864)|0)|0;g=c[63882]|0;j=e;k=167576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[146112]=1;i=d;return}function zja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[146256]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4392>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4392>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(146264,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4392>>3],100864)|0)|0;g=c[63882]|0;j=e;k=167576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[146256]=1;i=d;return}function Aja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[146400]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4304>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(146408,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4304>>3],100864)|0)|0;g=c[63882]|0;j=e;k=168208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[146400]=1;i=d;return}function Bja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[146488]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4312>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(146496,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4312>>3],100864)|0)|0;g=c[63882]|0;j=e;k=168208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[146488]=1;i=d;return}function Cja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[146576]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4320>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(146584,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4320>>3],100864)|0)|0;g=c[63882]|0;j=e;k=168208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[146576]=1;i=d;return}function Dja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[146664]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4328>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(146672,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4328>>3],100864)|0)|0;g=c[63882]|0;j=e;k=168208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[146664]=1;i=d;return}function Eja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[146752]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4336>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(146760,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4336>>3],100864)|0)|0;g=c[63882]|0;j=e;k=168208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[146752]=1;i=d;return}function Fja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[146840]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4264>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(146848,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4264>>3],100864)|0)|0;g=c[63882]|0;j=e;k=168712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[146840]=1;i=d;return}function Gja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[146936]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4272>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(146944,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4272>>3],100864)|0)|0;g=c[63882]|0;j=e;k=168712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[146936]=1;i=d;return}function Hja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[147032]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4280>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(147040,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4280>>3],100864)|0)|0;g=c[63882]|0;j=e;k=168712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[147032]=1;i=d;return}function Ija(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[147128]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4288>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(147136,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4288>>3],100864)|0)|0;g=c[63882]|0;j=e;k=168712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[147128]=1;i=d;return}function Jja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[147224]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4296>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(147232,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4296>>3],100864)|0)|0;g=c[63882]|0;j=e;k=168712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[147224]=1;i=d;return}function Kja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[147320]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4224>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4224>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(147328,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4224>>3],100864)|0)|0;g=c[63882]|0;j=e;k=169456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[147320]=1;i=d;return}function Lja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[147464]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4232>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4232>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(147472,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4232>>3],100864)|0)|0;g=c[63882]|0;j=e;k=169456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[147464]=1;i=d;return}function Mja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[147608]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4240>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4240>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(147616,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4240>>3],100864)|0)|0;g=c[63882]|0;j=e;k=169456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[147608]=1;i=d;return}function Nja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[147752]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4248>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4248>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(147760,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4248>>3],100864)|0)|0;g=c[63882]|0;j=e;k=169456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[147752]=1;i=d;return}function Oja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[147896]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4256>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4256>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(147904,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4256>>3],100864)|0)|0;g=c[63882]|0;j=e;k=169456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[147896]=1;i=d;return}function Pja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[148040]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4184>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4184>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(148048,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4184>>3],100864)|0)|0;g=c[63882]|0;j=e;k=170240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[148040]=1;i=d;return}function Qja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[148192]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4192>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4192>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(148200,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4192>>3],100864)|0)|0;g=c[63882]|0;j=e;k=170240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[148192]=1;i=d;return}function Rja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[148344]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4200>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4200>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(148352,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4200>>3],100864)|0)|0;g=c[63882]|0;j=e;k=170240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[148344]=1;i=d;return}function Sja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[148496]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4208>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4208>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(148504,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4208>>3],100864)|0)|0;g=c[63882]|0;j=e;k=170240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[148496]=1;i=d;return}function Tja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[148648]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4216>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4216>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(148656,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4216>>3],100864)|0)|0;g=c[63882]|0;j=e;k=170240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[148648]=1;i=d;return}function Uja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[148800]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4056>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4056>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(148808,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4056>>3],100864)|0)|0;g=c[63882]|0;j=e;k=171176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[148800]=1;i=d;return}function Vja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[148952]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4064>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4064>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(148960,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4064>>3],100864)|0)|0;g=c[63882]|0;j=e;k=171176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[148952]=1;i=d;return}function Wja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[149104]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4072>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4072>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(149112,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4072>>3],100864)|0)|0;g=c[63882]|0;j=e;k=171176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[149104]=1;i=d;return}function Xja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[149256]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4080>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4080>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(149264,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4080>>3],100864)|0)|0;g=c[63882]|0;j=e;k=171176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[149256]=1;i=d;return}function Yja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[149408]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4088>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4088>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(149416,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4088>>3],100864)|0)|0;g=c[63882]|0;j=e;k=171176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[149408]=1;i=d;return}function Zja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[149560]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4096>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4096>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(149568,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4096>>3],100864)|0)|0;g=c[63882]|0;j=e;k=171176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[149560]=1;i=d;return}function _ja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[149712]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4008>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4008>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(149720,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4008>>3],100864)|0)|0;g=c[63882]|0;j=e;k=172064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[149712]=1;i=d;return}function $ja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[149856]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4016>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4016>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(149864,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4016>>3],100864)|0)|0;g=c[63882]|0;j=e;k=172064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[149856]=1;i=d;return}function aka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15e4]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4024>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4024>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(150008,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4024>>3],100864)|0)|0;g=c[63882]|0;j=e;k=172064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[15e4]=1;i=d;return}function bka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[150144]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4032>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4032>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(150152,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4032>>3],100864)|0)|0;g=c[63882]|0;j=e;k=172064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[150144]=1;i=d;return}function cka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[150288]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4040>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4040>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(150296,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4040>>3],100864)|0)|0;g=c[63882]|0;j=e;k=172064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[150288]=1;i=d;return}function dka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[150432]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4048>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4048>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(150440,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4048>>3],100864)|0)|0;g=c[63882]|0;j=e;k=172064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[150432]=1;i=d;return}function eka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[150576]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3936>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3936>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(150584,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3936>>3],100864)|0)|0;g=c[63882]|0;j=e;k=173152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[150576]=1;i=d;return}function fka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[150728]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3944>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3944>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(150736,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3944>>3],100864)|0)|0;g=c[63882]|0;j=e;k=173152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[150728]=1;i=d;return}function gka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[150880]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3952>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3952>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(150888,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3952>>3],100864)|0)|0;g=c[63882]|0;j=e;k=173152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[150880]=1;i=d;return}function hka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[151032]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3960>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3960>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(151040,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3960>>3],100864)|0)|0;g=c[63882]|0;j=e;k=173152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[151032]=1;i=d;return}function ika(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[151184]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3968>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3968>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(151192,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3968>>3],100864)|0)|0;g=c[63882]|0;j=e;k=173152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[151184]=1;i=d;return}function jka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[151336]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3976>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3976>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(151344,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3976>>3],100864)|0)|0;g=c[63882]|0;j=e;k=173152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[151336]=1;i=d;return}function kka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[151488]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3984>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3984>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(151496,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3984>>3],100864)|0)|0;g=c[63882]|0;j=e;k=173152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[151488]=1;i=d;return}function lka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[151640]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3888>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3888>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(151648,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3888>>3],100864)|0)|0;g=c[63882]|0;j=e;k=174184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[151640]=1;i=d;return}function mka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[151808]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3896>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3896>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(151816,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3896>>3],100864)|0)|0;g=c[63882]|0;j=e;k=174184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[151808]=1;i=d;return}function nka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[151976]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3904>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3904>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(151984,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3904>>3],100864)|0)|0;g=c[63882]|0;j=e;k=174184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[151976]=1;i=d;return}function oka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[152144]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3912>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3912>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(152152,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3912>>3],100864)|0)|0;g=c[63882]|0;j=e;k=174184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[152144]=1;i=d;return}function pka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[152312]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3920>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3920>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(152320,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3920>>3],100864)|0)|0;g=c[63882]|0;j=e;k=174184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[152312]=1;i=d;return}function qka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[152480]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3928>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3928>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(152488,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3928>>3],100864)|0)|0;g=c[63882]|0;j=e;k=174184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[152480]=1;i=d;return}function rka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[152648]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3832>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3832>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(152656,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3832>>3],100864)|0)|0;g=c[63882]|0;j=e;k=175272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[152648]=1;i=d;return}function ska(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[152800]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3840>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3840>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(152808,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3840>>3],100864)|0)|0;g=c[63882]|0;j=e;k=175272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[152800]=1;i=d;return}function tka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[152952]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3848>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3848>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(152960,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3848>>3],100864)|0)|0;g=c[63882]|0;j=e;k=175272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[152952]=1;i=d;return}function uka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[153104]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3856>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3856>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(153112,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3856>>3],100864)|0)|0;g=c[63882]|0;j=e;k=175272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[153104]=1;i=d;return}function vka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[153256]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3864>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3864>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(153264,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3864>>3],100864)|0)|0;g=c[63882]|0;j=e;k=175272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[153256]=1;i=d;return}function wka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[153408]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3872>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3872>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(153416,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3872>>3],100864)|0)|0;g=c[63882]|0;j=e;k=175272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[153408]=1;i=d;return}function xka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[153560]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3880>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3880>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(153568,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3880>>3],100864)|0)|0;g=c[63882]|0;j=e;k=175272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[153560]=1;i=d;return}function yka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[153712]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3784>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3784>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(153720,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3784>>3],100864)|0)|0;g=c[63882]|0;j=e;k=176304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[153712]=1;i=d;return}function zka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[153880]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3792>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3792>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(153888,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3792>>3],100864)|0)|0;g=c[63882]|0;j=e;k=176304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[153880]=1;i=d;return}function Aka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[154048]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3800>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3800>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(154056,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3800>>3],100864)|0)|0;g=c[63882]|0;j=e;k=176304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[154048]=1;i=d;return}function Bka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[154216]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3808>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3808>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(154224,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3808>>3],100864)|0)|0;g=c[63882]|0;j=e;k=176304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[154216]=1;i=d;return}function Cka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[154384]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3816>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3816>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(154392,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3816>>3],100864)|0)|0;g=c[63882]|0;j=e;k=176304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[154384]=1;i=d;return}function Dka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[154552]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3824>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3824>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(154560,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3824>>3],100864)|0)|0;g=c[63882]|0;j=e;k=176304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[154552]=1;i=d;return}function Eka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[154720]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+288>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+288>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(154728,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+288>>3],100864)|0)|0;g=c[63882]|0;j=e;k=177432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[154720]=1;i=d;return}function Fka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[154904]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+296>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+296>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(154912,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+296>>3],100864)|0)|0;g=c[63882]|0;j=e;k=177432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[154904]=1;i=d;return}function Gka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[155088]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+304>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+304>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(155096,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+304>>3],100864)|0)|0;g=c[63882]|0;j=e;k=177432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[155088]=1;i=d;return}function Hka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[155272]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+312>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+312>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(155280,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+312>>3],100864)|0)|0;g=c[63882]|0;j=e;k=177432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[155272]=1;i=d;return}function Ika(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[155456]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+320>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+320>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(155464,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+320>>3],100864)|0)|0;g=c[63882]|0;j=e;k=177432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[155456]=1;i=d;return}function Jka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[155640]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+328>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+328>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(155648,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+328>>3],100864)|0)|0;g=c[63882]|0;j=e;k=177432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[155640]=1;i=d;return}function Kka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[155824]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+280>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+280>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(155832,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+280>>3],100864)|0)|0;g=c[63882]|0;j=e;k=185504;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[155824]=1;i=d;return}function Lka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[155968]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+272>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+272>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(155976,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+272>>3],100864)|0)|0;g=c[63882]|0;j=e;k=185672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[155968]=1;i=d;return}function Mka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[156112]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3536>>3],-1.0e10)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3536>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=Owa(156120,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3536>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[156112]=1;i=d;return}function Nka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[156272]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3528>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3528>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(156280,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3528>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[156272]=1;i=d;return}function Oka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[156416]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+264>>3],1.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+264>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=Owa(156424,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+264>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186136;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[156416]=1;i=d;return}function Pka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[156552]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3520>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3520>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(156560,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3520>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[156552]=1;i=d;return}function Qka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[156704]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3512>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3512>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=Owa(156712,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3512>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188872;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[156704]=1;i=d;return}function Rka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[156848]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3504>>3],.001)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3504>>3],.25)|0)<<24>>24==0)){i=d;return}b=Owa(156856,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3504>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[156848]=1;i=d;return}function Ska(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[156992]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3496>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3496>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(157e3,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3496>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[156992]=1;i=d;return}function Tka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[157144]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3480>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3480>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(157152,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3480>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[157144]=1;i=d;return}function Uka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[157304]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3472>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3472>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(157312,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3472>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189232;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[157304]=1;i=d;return}function Vka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[157456]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3464>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3464>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(157464,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3464>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[157456]=1;i=d;return}function Wka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[157600]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3456>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3456>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(157608,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3456>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[157600]=1;i=d;return}function Xka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[157744]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3448>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3448>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(157752,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3448>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[157744]=1;i=d;return}function Yka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[157920]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+256>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+256>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(157928,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+256>>3],100864)|0)|0;g=c[63882]|0;j=e;k=185504;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[157920]=1;i=d;return}function Zka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[158064]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+248>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+248>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(158072,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+248>>3],100864)|0)|0;g=c[63882]|0;j=e;k=185672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[158064]=1;i=d;return}function _ka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[158208]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3416>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3416>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(158216,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3416>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[158208]=1;i=d;return}function $ka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[158352]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+240>>3],1.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+240>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=Owa(158360,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+240>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186136;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[158352]=1;i=d;return}function ala(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[158488]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3408>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3408>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(158496,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3408>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[158488]=1;i=d;return}function bla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[158640]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3400>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3400>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=Owa(158648,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3400>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188872;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[158640]=1;i=d;return}function cla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[158784]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3392>>3],.001)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3392>>3],.25)|0)<<24>>24==0)){i=d;return}b=Owa(158792,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3392>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[158784]=1;i=d;return}function dla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[158928]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3384>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3384>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(158936,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3384>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[158928]=1;i=d;return}function ela(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[159080]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3368>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3368>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(159088,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3368>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[159080]=1;i=d;return}function fla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[159240]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3360>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3360>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(159248,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3360>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189232;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[159240]=1;i=d;return}function gla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[159392]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3352>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3352>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(159400,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3352>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[159392]=1;i=d;return}function hla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[159536]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3344>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3344>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(159544,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3344>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[159536]=1;i=d;return}function ila(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[159680]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3336>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3336>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(159688,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3336>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[159680]=1;i=d;return}function jla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[159856]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+232>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+232>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(159864,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+232>>3],100864)|0)|0;g=c[63882]|0;j=e;k=185504;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[159856]=1;i=d;return}function kla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16e4]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+224>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+224>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(160008,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+224>>3],100864)|0)|0;g=c[63882]|0;j=e;k=185672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[16e4]=1;i=d;return}function lla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[160144]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3304>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3304>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(160152,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3304>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[160144]=1;i=d;return}function mla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[160288]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+216>>3],1.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+216>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=Owa(160296,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+216>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186136;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[160288]=1;i=d;return}function nla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[160424]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3296>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3296>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(160432,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3296>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[160424]=1;i=d;return}function ola(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[160576]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3288>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3288>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=Owa(160584,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3288>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188872;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[160576]=1;i=d;return}function pla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[160720]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3280>>3],.001)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3280>>3],.25)|0)<<24>>24==0)){i=d;return}b=Owa(160728,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3280>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[160720]=1;i=d;return}function qla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[160864]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3272>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3272>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(160872,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3272>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[160864]=1;i=d;return}function rla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[161016]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3256>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3256>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(161024,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3256>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[161016]=1;i=d;return}function sla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[161176]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3248>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3248>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(161184,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3248>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189232;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[161176]=1;i=d;return}function tla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[161328]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3240>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3240>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(161336,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3240>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[161328]=1;i=d;return}function ula(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[161472]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3232>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3232>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(161480,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3232>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[161472]=1;i=d;return}function vla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[161616]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3224>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3224>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(161624,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3224>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[161616]=1;i=d;return}function wla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[161792]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+208>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+208>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(161800,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+208>>3],100864)|0)|0;g=c[63882]|0;j=e;k=185504;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[161792]=1;i=d;return}function xla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[161936]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+200>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+200>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(161944,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+200>>3],100864)|0)|0;g=c[63882]|0;j=e;k=185672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[161936]=1;i=d;return}function yla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[162080]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3192>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3192>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(162088,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3192>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[162080]=1;i=d;return}function zla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[162224]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+192>>3],1.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+192>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=Owa(162232,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+192>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186136;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[162224]=1;i=d;return}



function Ala(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[162360]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3184>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3184>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(162368,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3184>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[162360]=1;i=d;return}function Bla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[162512]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3176>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3176>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=Owa(162520,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3176>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188872;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[162512]=1;i=d;return}function Cla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[162656]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3168>>3],.001)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3168>>3],.25)|0)<<24>>24==0)){i=d;return}b=Owa(162664,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3168>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[162656]=1;i=d;return}function Dla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[162800]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3160>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3160>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(162808,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3160>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[162800]=1;i=d;return}function Ela(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[162952]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3144>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3144>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(162960,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3144>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[162952]=1;i=d;return}function Fla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[163112]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3136>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3136>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(163120,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3136>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189232;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[163112]=1;i=d;return}function Gla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[163264]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3128>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3128>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(163272,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3128>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[163264]=1;i=d;return}function Hla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[163408]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3120>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3120>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(163416,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3120>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[163408]=1;i=d;return}function Ila(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[163552]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3112>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3112>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(163560,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3112>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[163552]=1;i=d;return}function Jla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[163728]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+184>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+184>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(163736,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+184>>3],100864)|0)|0;g=c[63882]|0;j=e;k=185504;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[163728]=1;i=d;return}function Kla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[163872]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+176>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+176>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(163880,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+176>>3],100864)|0)|0;g=c[63882]|0;j=e;k=185672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[163872]=1;i=d;return}function Lla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[164016]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3088>>3],-1.0e10)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3088>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=Owa(164024,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3088>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[164016]=1;i=d;return}function Mla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[164176]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3080>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3080>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(164184,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3080>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[164176]=1;i=d;return}function Nla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[164320]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+168>>3],1.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+168>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=Owa(164328,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+168>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186136;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[164320]=1;i=d;return}function Ola(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[164456]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3072>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3072>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(164464,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3072>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[164456]=1;i=d;return}function Pla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[164608]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3064>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3064>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=Owa(164616,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3064>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188872;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[164608]=1;i=d;return}function Qla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[164752]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3056>>3],.001)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3056>>3],.25)|0)<<24>>24==0)){i=d;return}b=Owa(164760,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3056>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[164752]=1;i=d;return}function Rla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[164896]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3048>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3048>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(164904,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3048>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[164896]=1;i=d;return}function Sla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[165048]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3032>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3032>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(165056,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3032>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[165048]=1;i=d;return}function Tla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[165208]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3024>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3024>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(165216,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3024>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189232;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[165208]=1;i=d;return}function Ula(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[165360]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3016>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3016>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(165368,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3016>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[165360]=1;i=d;return}function Vla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[165504]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3008>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3008>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(165512,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3008>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[165504]=1;i=d;return}function Wla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[165648]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3e3>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3e3>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(165656,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3e3>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[165648]=1;i=d;return}function Xla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[165824]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2904>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(165832,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2904>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[165824]=1;i=d;return}function Yla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[165944]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2912>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(165952,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2912>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[165944]=1;i=d;return}function Zla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[166064]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2920>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(166072,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2920>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[166064]=1;i=d;return}function _la(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[166184]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2928>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(166192,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2928>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[166184]=1;i=d;return}function $la(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[166304]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2936>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(166312,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2936>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[166304]=1;i=d;return}function ama(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[166424]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2896>>3],1.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2896>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=Owa(166432,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2896>>3],100864)|0)|0;g=c[63882]|0;j=e;k=167744;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[166424]=1;i=d;return}function bma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[166568]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2880>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2880>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(166576,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2880>>3],100864)|0)|0;g=c[63882]|0;j=e;k=167576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[166568]=1;i=d;return}function cma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[166712]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2888>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2888>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(166720,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2888>>3],100864)|0)|0;g=c[63882]|0;j=e;k=167576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[166712]=1;i=d;return}function dma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[166856]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2872>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2872>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(166864,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2872>>3],100864)|0)|0;g=c[63882]|0;j=e;k=167576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[166856]=1;i=d;return}function ema(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[167e3]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2864>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2864>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(167008,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2864>>3],100864)|0)|0;g=c[63882]|0;j=e;k=167576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[167e3]=1;i=d;return}function fma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[167144]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2856>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2856>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(167152,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2856>>3],100864)|0)|0;g=c[63882]|0;j=e;k=167576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[167144]=1;i=d;return}function gma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[167288]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2848>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2848>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(167296,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2848>>3],100864)|0)|0;g=c[63882]|0;j=e;k=167576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[167288]=1;i=d;return}function hma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[167432]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2840>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2840>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(167440,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2840>>3],100864)|0)|0;g=c[63882]|0;j=e;k=167576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[167432]=1;i=d;return}function ima(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[167600]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2832>>3],1.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2832>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=Owa(167608,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2832>>3],100864)|0)|0;g=c[63882]|0;j=e;k=167744;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[167600]=1;i=d;return}function jma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[167768]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2752>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(167776,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2752>>3],100864)|0)|0;g=c[63882]|0;j=e;k=168208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[167768]=1;i=d;return}function kma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[167856]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2760>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(167864,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2760>>3],100864)|0)|0;g=c[63882]|0;j=e;k=168208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[167856]=1;i=d;return}function lma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[167944]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2768>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(167952,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2768>>3],100864)|0)|0;g=c[63882]|0;j=e;k=168208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[167944]=1;i=d;return}function mma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[168032]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2776>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(168040,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2776>>3],100864)|0)|0;g=c[63882]|0;j=e;k=168208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[168032]=1;i=d;return}function nma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[168120]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2784>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(168128,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2784>>3],100864)|0)|0;g=c[63882]|0;j=e;k=168208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[168120]=1;i=d;return}function oma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[168232]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2712>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(168240,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2712>>3],100864)|0)|0;g=c[63882]|0;j=e;k=168712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[168232]=1;i=d;return}function pma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[168328]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2720>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(168336,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2720>>3],100864)|0)|0;g=c[63882]|0;j=e;k=168712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[168328]=1;i=d;return}function qma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[168424]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2728>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(168432,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2728>>3],100864)|0)|0;g=c[63882]|0;j=e;k=168712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[168424]=1;i=d;return}function rma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[168520]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2736>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(168528,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2736>>3],100864)|0)|0;g=c[63882]|0;j=e;k=168712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[168520]=1;i=d;return}function sma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[168616]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2744>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(168624,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2744>>3],100864)|0)|0;g=c[63882]|0;j=e;k=168712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[168616]=1;i=d;return}function tma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[168736]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2672>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2672>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(168744,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2672>>3],100864)|0)|0;g=c[63882]|0;j=e;k=169456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[168736]=1;i=d;return}function uma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[168880]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2680>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2680>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(168888,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2680>>3],100864)|0)|0;g=c[63882]|0;j=e;k=169456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[168880]=1;i=d;return}function vma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[169024]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2688>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2688>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(169032,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2688>>3],100864)|0)|0;g=c[63882]|0;j=e;k=169456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[169024]=1;i=d;return}function wma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[169168]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2696>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2696>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(169176,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2696>>3],100864)|0)|0;g=c[63882]|0;j=e;k=169456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[169168]=1;i=d;return}function xma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[169312]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2704>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2704>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(169320,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2704>>3],100864)|0)|0;g=c[63882]|0;j=e;k=169456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[169312]=1;i=d;return}function yma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[169480]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2632>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2632>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(169488,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2632>>3],100864)|0)|0;g=c[63882]|0;j=e;k=170240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[169480]=1;i=d;return}function zma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[169632]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2640>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2640>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(169640,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2640>>3],100864)|0)|0;g=c[63882]|0;j=e;k=170240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[169632]=1;i=d;return}function Ama(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[169784]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2648>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2648>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(169792,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2648>>3],100864)|0)|0;g=c[63882]|0;j=e;k=170240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[169784]=1;i=d;return}function Bma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[169936]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2656>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2656>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(169944,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2656>>3],100864)|0)|0;g=c[63882]|0;j=e;k=170240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[169936]=1;i=d;return}function Cma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[170088]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2664>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2664>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(170096,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2664>>3],100864)|0)|0;g=c[63882]|0;j=e;k=170240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[170088]=1;i=d;return}function Dma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[170264]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2504>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2504>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(170272,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2504>>3],100864)|0)|0;g=c[63882]|0;j=e;k=171176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[170264]=1;i=d;return}function Ema(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[170416]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2512>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2512>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(170424,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2512>>3],100864)|0)|0;g=c[63882]|0;j=e;k=171176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[170416]=1;i=d;return}function Fma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[170568]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2520>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2520>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(170576,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2520>>3],100864)|0)|0;g=c[63882]|0;j=e;k=171176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[170568]=1;i=d;return}function Gma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[170720]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2528>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2528>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(170728,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2528>>3],100864)|0)|0;g=c[63882]|0;j=e;k=171176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[170720]=1;i=d;return}function Hma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[170872]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2536>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2536>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(170880,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2536>>3],100864)|0)|0;g=c[63882]|0;j=e;k=171176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[170872]=1;i=d;return}function Ima(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[171024]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2544>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2544>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(171032,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2544>>3],100864)|0)|0;g=c[63882]|0;j=e;k=171176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[171024]=1;i=d;return}function Jma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[171200]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2456>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2456>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(171208,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2456>>3],100864)|0)|0;g=c[63882]|0;j=e;k=172064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[171200]=1;i=d;return}function Kma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[171344]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2464>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2464>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(171352,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2464>>3],100864)|0)|0;g=c[63882]|0;j=e;k=172064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[171344]=1;i=d;return}function Lma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[171488]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2472>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2472>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(171496,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2472>>3],100864)|0)|0;g=c[63882]|0;j=e;k=172064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[171488]=1;i=d;return}function Mma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[171632]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2480>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2480>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(171640,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2480>>3],100864)|0)|0;g=c[63882]|0;j=e;k=172064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[171632]=1;i=d;return}function Nma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[171776]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2488>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2488>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(171784,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2488>>3],100864)|0)|0;g=c[63882]|0;j=e;k=172064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[171776]=1;i=d;return}function Oma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[171920]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2496>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2496>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(171928,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2496>>3],100864)|0)|0;g=c[63882]|0;j=e;k=172064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[171920]=1;i=d;return}function Pma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[172088]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2384>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2384>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(172096,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2384>>3],100864)|0)|0;g=c[63882]|0;j=e;k=173152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[172088]=1;i=d;return}function Qma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[172240]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2392>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2392>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(172248,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2392>>3],100864)|0)|0;g=c[63882]|0;j=e;k=173152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[172240]=1;i=d;return}function Rma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[172392]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2400>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2400>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(172400,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2400>>3],100864)|0)|0;g=c[63882]|0;j=e;k=173152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[172392]=1;i=d;return}function Sma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[172544]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2408>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2408>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(172552,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2408>>3],100864)|0)|0;g=c[63882]|0;j=e;k=173152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[172544]=1;i=d;return}function Tma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[172696]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2416>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2416>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(172704,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2416>>3],100864)|0)|0;g=c[63882]|0;j=e;k=173152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[172696]=1;i=d;return}function Uma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[172848]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2424>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2424>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(172856,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2424>>3],100864)|0)|0;g=c[63882]|0;j=e;k=173152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[172848]=1;i=d;return}function Vma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[173e3]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2432>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2432>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(173008,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2432>>3],100864)|0)|0;g=c[63882]|0;j=e;k=173152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[173e3]=1;i=d;return}function Wma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[173176]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2336>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2336>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(173184,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2336>>3],100864)|0)|0;g=c[63882]|0;j=e;k=174184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[173176]=1;i=d;return}function Xma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[173344]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2344>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2344>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(173352,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2344>>3],100864)|0)|0;g=c[63882]|0;j=e;k=174184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[173344]=1;i=d;return}function Yma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[173512]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2352>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2352>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(173520,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2352>>3],100864)|0)|0;g=c[63882]|0;j=e;k=174184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[173512]=1;i=d;return}function Zma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[173680]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2360>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2360>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(173688,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2360>>3],100864)|0)|0;g=c[63882]|0;j=e;k=174184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[173680]=1;i=d;return}function _ma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[173848]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2368>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2368>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(173856,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2368>>3],100864)|0)|0;g=c[63882]|0;j=e;k=174184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[173848]=1;i=d;return}function $ma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[174016]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2376>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2376>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(174024,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2376>>3],100864)|0)|0;g=c[63882]|0;j=e;k=174184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[174016]=1;i=d;return}function ana(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[174208]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2280>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2280>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(174216,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2280>>3],100864)|0)|0;g=c[63882]|0;j=e;k=175272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[174208]=1;i=d;return}function bna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[174360]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2288>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2288>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(174368,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2288>>3],100864)|0)|0;g=c[63882]|0;j=e;k=175272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[174360]=1;i=d;return}function cna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[174512]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2296>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2296>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(174520,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2296>>3],100864)|0)|0;g=c[63882]|0;j=e;k=175272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[174512]=1;i=d;return}function dna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[174664]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2304>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2304>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(174672,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2304>>3],100864)|0)|0;g=c[63882]|0;j=e;k=175272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[174664]=1;i=d;return}function ena(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[174816]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2312>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2312>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(174824,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2312>>3],100864)|0)|0;g=c[63882]|0;j=e;k=175272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[174816]=1;i=d;return}function fna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[174968]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2320>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2320>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(174976,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2320>>3],100864)|0)|0;g=c[63882]|0;j=e;k=175272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[174968]=1;i=d;return}function gna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[175120]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2328>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2328>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(175128,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2328>>3],100864)|0)|0;g=c[63882]|0;j=e;k=175272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[175120]=1;i=d;return}function hna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[175296]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2232>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2232>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(175304,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2232>>3],100864)|0)|0;g=c[63882]|0;j=e;k=176304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[175296]=1;i=d;return}function ina(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[175464]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2240>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2240>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(175472,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2240>>3],100864)|0)|0;g=c[63882]|0;j=e;k=176304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[175464]=1;i=d;return}function jna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[175632]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2248>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2248>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(175640,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2248>>3],100864)|0)|0;g=c[63882]|0;j=e;k=176304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[175632]=1;i=d;return}function kna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[175800]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2256>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2256>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(175808,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2256>>3],100864)|0)|0;g=c[63882]|0;j=e;k=176304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[175800]=1;i=d;return}function lna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[175968]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2264>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2264>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(175976,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2264>>3],100864)|0)|0;g=c[63882]|0;j=e;k=176304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[175968]=1;i=d;return}function mna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[176136]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2272>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2272>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(176144,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2272>>3],100864)|0)|0;g=c[63882]|0;j=e;k=176304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[176136]=1;i=d;return}function nna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[176328]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+120>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+120>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(176336,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+120>>3],100864)|0)|0;g=c[63882]|0;j=e;k=177432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[176328]=1;i=d;return}function ona(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[176512]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+128>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+128>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(176520,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+128>>3],100864)|0)|0;g=c[63882]|0;j=e;k=177432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[176512]=1;i=d;return}function pna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[176696]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+136>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+136>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(176704,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+136>>3],100864)|0)|0;g=c[63882]|0;j=e;k=177432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[176696]=1;i=d;return}function qna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[176880]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+144>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+144>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(176888,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+144>>3],100864)|0)|0;g=c[63882]|0;j=e;k=177432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[176880]=1;i=d;return}function rna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[177064]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+152>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+152>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(177072,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+152>>3],100864)|0)|0;g=c[63882]|0;j=e;k=177432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[177064]=1;i=d;return}function sna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[177248]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+160>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+160>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(177256,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+160>>3],100864)|0)|0;g=c[63882]|0;j=e;k=177432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[177248]=1;i=d;return}function tna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[177456]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+112>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+112>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(177464,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+112>>3],100864)|0)|0;g=c[63882]|0;j=e;k=185504;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[177456]=1;i=d;return}function una(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[177600]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+104>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+104>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(177608,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+104>>3],100864)|0)|0;g=c[63882]|0;j=e;k=185672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[177600]=1;i=d;return}function vna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[177744]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1984>>3],-1.0e10)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1984>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=Owa(177752,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1984>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[177744]=1;i=d;return}function wna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[177904]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1976>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1976>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(177912,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1976>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[177904]=1;i=d;return}function xna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[178048]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+96>>3],1.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+96>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=Owa(178056,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+96>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186136;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[178048]=1;i=d;return}function yna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[178184]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1968>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1968>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(178192,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1968>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[178184]=1;i=d;return}function zna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[178336]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1960>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1960>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=Owa(178344,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1960>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188872;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[178336]=1;i=d;return}function Ana(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[178480]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1952>>3],.001)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1952>>3],.25)|0)<<24>>24==0)){i=d;return}b=Owa(178488,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1952>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[178480]=1;i=d;return}function Bna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[178624]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1944>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1944>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(178632,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1944>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[178624]=1;i=d;return}function Cna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[178776]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1928>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1928>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(178784,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1928>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[178776]=1;i=d;return}function Dna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[178936]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1920>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1920>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(178944,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1920>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189232;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[178936]=1;i=d;return}function Ena(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[179088]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1912>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1912>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(179096,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1912>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[179088]=1;i=d;return}function Fna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[179232]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1904>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1904>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(179240,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1904>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[179232]=1;i=d;return}function Gna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[179376]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1896>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1896>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(179384,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1896>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[179376]=1;i=d;return}function Hna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[179552]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+88>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+88>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(179560,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+88>>3],100864)|0)|0;g=c[63882]|0;j=e;k=185504;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[179552]=1;i=d;return}function Ina(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[179696]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+80>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+80>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(179704,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+80>>3],100864)|0)|0;g=c[63882]|0;j=e;k=185672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[179696]=1;i=d;return}function Jna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[179840]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1864>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1864>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(179848,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1864>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[179840]=1;i=d;return}function Kna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[179984]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+72>>3],1.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+72>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=Owa(179992,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+72>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186136;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[179984]=1;i=d;return}function Lna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[180120]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1856>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1856>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(180128,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1856>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[180120]=1;i=d;return}function Mna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[180272]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1848>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1848>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=Owa(180280,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1848>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188872;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[180272]=1;i=d;return}function Nna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[180416]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1840>>3],.001)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1840>>3],.25)|0)<<24>>24==0)){i=d;return}b=Owa(180424,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1840>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[180416]=1;i=d;return}function Ona(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[180560]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1832>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1832>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(180568,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1832>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[180560]=1;i=d;return}function Pna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[180712]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1816>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1816>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(180720,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1816>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[180712]=1;i=d;return}function Qna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[180872]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1808>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1808>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(180880,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1808>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189232;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[180872]=1;i=d;return}function Rna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[181024]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1800>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1800>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(181032,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1800>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[181024]=1;i=d;return}function Sna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[181168]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1792>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1792>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(181176,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1792>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[181168]=1;i=d;return}function Tna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[181312]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1784>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1784>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(181320,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1784>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[181312]=1;i=d;return}function Una(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[181488]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+64>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+64>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(181496,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+64>>3],100864)|0)|0;g=c[63882]|0;j=e;k=185504;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[181488]=1;i=d;return}function Vna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[181632]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+56>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+56>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(181640,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+56>>3],100864)|0)|0;g=c[63882]|0;j=e;k=185672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[181632]=1;i=d;return}function Wna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[181776]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1752>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1752>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(181784,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1752>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[181776]=1;i=d;return}function Xna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[181920]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+48>>3],1.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+48>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=Owa(181928,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+48>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186136;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[181920]=1;i=d;return}function Yna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[182056]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1744>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1744>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(182064,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1744>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[182056]=1;i=d;return}function Zna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[182208]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1736>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1736>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=Owa(182216,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1736>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188872;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[182208]=1;i=d;return}function _na(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[182352]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1728>>3],.001)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1728>>3],.25)|0)<<24>>24==0)){i=d;return}b=Owa(182360,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1728>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[182352]=1;i=d;return}function $na(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[182496]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1720>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1720>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(182504,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1720>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[182496]=1;i=d;return}function aoa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[182648]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1704>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1704>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(182656,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1704>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[182648]=1;i=d;return}function boa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[182808]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1696>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1696>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(182816,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1696>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189232;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[182808]=1;i=d;return}function coa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[182960]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1688>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1688>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(182968,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1688>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[182960]=1;i=d;return}function doa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[183104]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1680>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1680>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(183112,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1680>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[183104]=1;i=d;return}function eoa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[183248]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1672>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1672>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(183256,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1672>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[183248]=1;i=d;return}function foa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[183424]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+40>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+40>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(183432,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+40>>3],100864)|0)|0;g=c[63882]|0;j=e;k=185504;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[183424]=1;i=d;return}function goa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[183568]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+32>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+32>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(183576,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+32>>3],100864)|0)|0;g=c[63882]|0;j=e;k=185672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[183568]=1;i=d;return}function hoa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[183712]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1640>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1640>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(183720,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1640>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[183712]=1;i=d;return}function ioa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[183856]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+24>>3],1.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+24>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=Owa(183864,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+24>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186136;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[183856]=1;i=d;return}function joa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[183992]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1632>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1632>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(184e3,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1632>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[183992]=1;i=d;return}function koa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[184144]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1624>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1624>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=Owa(184152,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1624>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188872;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[184144]=1;i=d;return}function loa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[184288]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1616>>3],.001)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1616>>3],.25)|0)<<24>>24==0)){i=d;return}b=Owa(184296,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1616>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[184288]=1;i=d;return}function moa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[184432]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1608>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1608>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(184440,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1608>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[184432]=1;i=d;return}function noa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[184584]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1592>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1592>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(184592,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1592>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[184584]=1;i=d;return}function ooa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[184744]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1584>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1584>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(184752,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1584>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189232;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[184744]=1;i=d;return}function poa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[184896]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1576>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1576>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(184904,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1576>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[184896]=1;i=d;return}function qoa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[185040]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1568>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1568>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(185048,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1568>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[185040]=1;i=d;return}function roa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[185184]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1560>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1560>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(185192,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1560>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[185184]=1;i=d;return}function soa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[185360]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+16>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+16>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(185368,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+16>>3],100864)|0)|0;g=c[63882]|0;j=e;k=185504;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[185360]=1;i=d;return}function toa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[185528]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(185536,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8>>3],100864)|0)|0;g=c[63882]|0;j=e;k=185672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[185528]=1;i=d;return}function uoa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[185696]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1536>>3],-1.0e10)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1536>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=Owa(185704,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1536>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[185696]=1;i=d;return}function voa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[185856]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1528>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1528>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(185864,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1528>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[185856]=1;i=d;return}function woa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[186e3]&1){i=d;return}g=b+4|0;b=Dza(+h[c[(c[c[g>>2]>>2]|0)+8>>2]>>3],1.0)|0;if(!(b<<24>>24==0|(Bza(+h[c[(c[c[g>>2]>>2]|0)+8>>2]>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=Owa(186008,Iwa(+h[c[(c[c[g>>2]>>2]|0)+8>>2]>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186136;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[186e3]=1;i=d;return}function xoa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[186160]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1520>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1520>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(186168,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1520>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[186160]=1;i=d;return}function yoa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[186312]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1512>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1512>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=Owa(186320,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1512>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188872;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[186312]=1;i=d;return}function zoa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[186456]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1504>>3],.001)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1504>>3],.25)|0)<<24>>24==0)){i=d;return}b=Owa(186464,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1504>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[186456]=1;i=d;return}function Aoa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[186624]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1496>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1496>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(186632,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1496>>3],100864)|0)|0;g=c[63882]|0;j=e;k=186776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[186624]=1;i=d;return}function Boa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[186800]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1480>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1480>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(186808,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1480>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[186800]=1;i=d;return}function Coa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[186960]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1472>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1472>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(186968,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1472>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189232;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[186960]=1;i=d;return}function Doa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[187112]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1464>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1464>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(187120,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1464>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[187112]=1;i=d;return}function Eoa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[187256]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1456>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1456>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(187264,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1456>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[187256]=1;i=d;return}function Foa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[187400]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1448>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1448>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(187408,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1448>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[187400]=1;i=d;return}function Goa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[187576]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1352>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(187584,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1352>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[187576]=1;i=d;return}function Hoa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[187696]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1360>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(187704,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1360>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[187696]=1;i=d;return}function Ioa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[187816]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1368>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(187824,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1368>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[187816]=1;i=d;return}function Joa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[187936]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1376>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(187944,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1376>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[187936]=1;i=d;return}function Koa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[188056]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1384>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(188064,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1384>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[188056]=1;i=d;return}function Loa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[188200]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10760>>3],-1.0e10)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10760>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=Owa(188208,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10760>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[188200]=1;i=d;return}function Moa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[188384]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10752>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10752>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(188392,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10752>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[188384]=1;i=d;return}function Noa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[188552]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10744>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10744>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(188560,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10744>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[188552]=1;i=d;return}function Ooa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[188728]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10736>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10736>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=Owa(188736,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10736>>3],100864)|0)|0;g=c[63882]|0;j=e;k=188872;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[188728]=1;i=d;return}function Poa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[188896]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10720>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10720>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(188904,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10720>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[188896]=1;i=d;return}function Qoa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[189080]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10712>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10712>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(189088,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10712>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189232;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[189080]=1;i=d;return}function Roa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[189256]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10704>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10704>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(189264,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10704>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[189256]=1;i=d;return}function Soa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[189424]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10696>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10696>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(189432,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10696>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[189424]=1;i=d;return}function Toa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[189592]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10688>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10688>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(189600,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10688>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[189592]=1;i=d;return}function Uoa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[189792]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10672>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10672>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(189800,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10672>>3],100864)|0)|0;g=c[63882]|0;j=e;k=189992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[189792]=1;i=d;return}function Voa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[190016]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1344>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(190024,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1344>>3],100864)|0)|0;g=c[63882]|0;j=e;k=190576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[190016]=1;i=d;return}function Woa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[190192]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1336>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(190200,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1336>>3],100864)|0)|0;g=c[63882]|0;j=e;k=190576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[190192]=1;i=d;return}function Xoa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[190288]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1328>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(190296,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1328>>3],100864)|0)|0;g=c[63882]|0;j=e;k=190576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[190288]=1;i=d;return}function Yoa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[190384]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1320>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(190392,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1320>>3],100864)|0)|0;g=c[63882]|0;j=e;k=190576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[190384]=1;i=d;return}function Zoa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[190480]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1312>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(190488,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1312>>3],100864)|0)|0;g=c[63882]|0;j=e;k=190576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[190480]=1;i=d;return}



function Oaa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[74976]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+904>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+904>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(74984,Iwa(+h[(c[g>>2]|0)+904>>3],69864)|0)|0;g=c[63882]|0;j=e;k=91424;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[74976]=1;i=d;return}function Paa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[75104]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+2176>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+2176>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(75112,Iwa(+h[(c[g>>2]|0)+2176>>3],69864)|0)|0;g=c[63882]|0;j=e;k=91592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[75104]=1;i=d;return}function Qaa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[75248]&1){i=d;return}g=b+420|0;b=Dza(+(c[(c[g>>2]|0)+248>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Bza(+(c[(c[g>>2]|0)+248>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=Owa(75256,Kwa(c[(c[g>>2]|0)+248>>2]|0,71200)|0)|0;g=c[63882]|0;h=e;j=91848;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[75248]=1;i=d;return}function Raa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[75480]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+2168>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+2168>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(75488,Iwa(+h[(c[g>>2]|0)+2168>>3],69864)|0)|0;g=c[63882]|0;j=e;k=92008;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[75480]=1;i=d;return}function Saa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[75616]&1){i=d;return}g=b+420|0;b=Dza(+(c[(c[g>>2]|0)+244>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Bza(+(c[(c[g>>2]|0)+244>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=Owa(75624,Kwa(c[(c[g>>2]|0)+244>>2]|0,71200)|0)|0;g=c[63882]|0;h=e;j=92248;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[75616]=1;i=d;return}function Taa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[75832]&1){i=d;return}g=b+420|0;b=Dza(+(c[(c[g>>2]|0)+240>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Bza(+(c[(c[g>>2]|0)+240>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=Owa(75840,Kwa(c[(c[g>>2]|0)+240>>2]|0,71200)|0)|0;g=c[63882]|0;h=e;j=92496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[75832]=1;i=d;return}function Uaa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76056]&1){i=d;return}g=b+420|0;b=Dza(+(c[(c[g>>2]|0)+224>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Bza(+(c[(c[g>>2]|0)+224>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=Owa(76064,Kwa(c[(c[g>>2]|0)+224>>2]|0,71200)|0)|0;g=c[63882]|0;h=e;j=92736;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[76056]=1;i=d;return}function Vaa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76272]&1){i=d;return}g=b+420|0;if(!((Dza(+(c[(c[g>>2]|0)+220>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Owa(76280,Kwa(c[(c[g>>2]|0)+220>>2]|0,71200)|0)|0;g=c[63882]|0;h=e;j=92848;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[76272]=1;i=d;return}function Waa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76360]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+2160>>3],-1.0e10)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+2160>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=Owa(76368,Iwa(+h[(c[g>>2]|0)+2160>>3],69864)|0)|0;g=c[63882]|0;j=e;k=93016;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[76360]=1;i=d;return}function Xaa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76504]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+2152>>3],1.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+2152>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=Owa(76512,Iwa(+h[(c[g>>2]|0)+2152>>3],69864)|0)|0;g=c[63882]|0;j=e;k=93168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[76504]=1;i=d;return}function Yaa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76632]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+2136>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(76640,Iwa(+h[(c[g>>2]|0)+2136>>3],69864)|0)|0;g=c[63882]|0;j=e;k=93288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[76632]=1;i=d;return}function Zaa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76728]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+2128>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(76736,Iwa(+h[(c[g>>2]|0)+2128>>3],69864)|0)|0;g=c[63882]|0;j=e;k=93408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[76728]=1;i=d;return}function _aa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76824]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+2112>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(76832,Iwa(+h[(c[g>>2]|0)+2112>>3],69864)|0)|0;g=c[63882]|0;j=e;k=93528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[76824]=1;i=d;return}function $aa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76920]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+2104>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(76928,Iwa(+h[(c[g>>2]|0)+2104>>3],69864)|0)|0;g=c[63882]|0;j=e;k=87704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[76920]=1;i=d;return}function aba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77048]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+816>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(77056,Iwa(+h[(c[g>>2]|0)+816>>3],69864)|0)|0;g=c[63882]|0;j=e;k=88288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[77048]=1;i=d;return}function bba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77160]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+808>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(77168,Iwa(+h[(c[g>>2]|0)+808>>3],69864)|0)|0;g=c[63882]|0;j=e;k=88288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[77160]=1;i=d;return}function cba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77272]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+800>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(77280,Iwa(+h[(c[g>>2]|0)+800>>3],69864)|0)|0;g=c[63882]|0;j=e;k=88288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[77272]=1;i=d;return}function dba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77384]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+792>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(77392,Iwa(+h[(c[g>>2]|0)+792>>3],69864)|0)|0;g=c[63882]|0;j=e;k=88288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[77384]=1;i=d;return}function eba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77496]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+784>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(77504,Iwa(+h[(c[g>>2]|0)+784>>3],69864)|0)|0;g=c[63882]|0;j=e;k=88288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[77496]=1;i=d;return}function fba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77608]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+2080>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(77616,Iwa(+h[(c[g>>2]|0)+2080>>3],69864)|0)|0;g=c[63882]|0;j=e;k=88432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[77608]=1;i=d;return}function gba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77728]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+2072>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(77736,Iwa(+h[(c[g>>2]|0)+2072>>3],69864)|0)|0;g=c[63882]|0;j=e;k=88576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[77728]=1;i=d;return}function hba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77848]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+2064>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+2064>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(77856,Iwa(+h[(c[g>>2]|0)+2064>>3],69864)|0)|0;g=c[63882]|0;j=e;k=88776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[77848]=1;i=d;return}function iba(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[78024]&1){i=d;return}g=b+420|0;b=Dza(+(c[(c[g>>2]|0)+212>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Bza(+(c[(c[g>>2]|0)+212>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=Owa(78032,Kwa(c[(c[g>>2]|0)+212>>2]|0,71200)|0)|0;g=c[63882]|0;h=e;j=89064;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[78024]=1;i=d;return}function jba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[78288]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+2048>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(78296,Iwa(+h[(c[g>>2]|0)+2048>>3],69864)|0)|0;g=c[63882]|0;j=e;k=89208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[78288]=1;i=d;return}function kba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[78408]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+2024>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(78416,Iwa(+h[(c[g>>2]|0)+2024>>3],69864)|0)|0;g=c[63882]|0;j=e;k=89352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[78408]=1;i=d;return}function lba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[78528]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+2008>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+2008>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(78536,Iwa(+h[(c[g>>2]|0)+2008>>3],69864)|0)|0;g=c[63882]|0;j=e;k=89544;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[78528]=1;i=d;return}function mba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[78696]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+2e3>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+2e3>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(78704,Iwa(+h[(c[g>>2]|0)+2e3>>3],69864)|0)|0;g=c[63882]|0;j=e;k=89736;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[78696]=1;i=d;return}function nba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[78864]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+656>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+656>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(78872,Iwa(+h[(c[g>>2]|0)+656>>3],69864)|0)|0;g=c[63882]|0;j=e;k=90480;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[78864]=1;i=d;return}function oba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[79008]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+648>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+648>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(79016,Iwa(+h[(c[g>>2]|0)+648>>3],69864)|0)|0;g=c[63882]|0;j=e;k=90480;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[79008]=1;i=d;return}function pba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[79152]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+640>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+640>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(79160,Iwa(+h[(c[g>>2]|0)+640>>3],69864)|0)|0;g=c[63882]|0;j=e;k=90480;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[79152]=1;i=d;return}function qba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[79296]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+632>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+632>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(79304,Iwa(+h[(c[g>>2]|0)+632>>3],69864)|0)|0;g=c[63882]|0;j=e;k=90480;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[79296]=1;i=d;return}function rba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[79440]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+624>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+624>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(79448,Iwa(+h[(c[g>>2]|0)+624>>3],69864)|0)|0;g=c[63882]|0;j=e;k=90480;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[79440]=1;i=d;return}function sba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[79584]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+1976>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+1976>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(79592,Iwa(+h[(c[g>>2]|0)+1976>>3],69864)|0)|0;g=c[63882]|0;j=e;k=90640;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[79584]=1;i=d;return}function tba(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[79720]&1){i=d;return}g=b+420|0;b=Dza(+(c[(c[g>>2]|0)+196>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Bza(+(c[(c[g>>2]|0)+196>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=Owa(79728,Kwa(c[(c[g>>2]|0)+196>>2]|0,71200)|0)|0;g=c[63882]|0;h=e;j=90888;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[79720]=1;i=d;return}function uba(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[79944]&1){i=d;return}g=b+420|0;b=Dza(+(c[(c[g>>2]|0)+192>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Bza(+(c[(c[g>>2]|0)+192>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=Owa(79952,Kwa(c[(c[g>>2]|0)+192>>2]|0,71200)|0)|0;g=c[63882]|0;h=e;j=91144;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[79944]=1;i=d;return}function vba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[80176]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+616>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+616>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(80184,Iwa(+h[(c[g>>2]|0)+616>>3],69864)|0)|0;g=c[63882]|0;j=e;k=91424;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[80176]=1;i=d;return}function wba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[80304]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+608>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+608>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(80312,Iwa(+h[(c[g>>2]|0)+608>>3],69864)|0)|0;g=c[63882]|0;j=e;k=91424;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[80304]=1;i=d;return}function xba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[80432]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+1952>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+1952>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(80440,Iwa(+h[(c[g>>2]|0)+1952>>3],69864)|0)|0;g=c[63882]|0;j=e;k=91592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[80432]=1;i=d;return}function yba(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[80576]&1){i=d;return}g=b+420|0;b=Dza(+(c[(c[g>>2]|0)+184>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Bza(+(c[(c[g>>2]|0)+184>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=Owa(80584,Kwa(c[(c[g>>2]|0)+184>>2]|0,71200)|0)|0;g=c[63882]|0;h=e;j=91848;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[80576]=1;i=d;return}function zba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[80808]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+1944>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+1944>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(80816,Iwa(+h[(c[g>>2]|0)+1944>>3],69864)|0)|0;g=c[63882]|0;j=e;k=92008;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[80808]=1;i=d;return}function Aba(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[80944]&1){i=d;return}g=b+420|0;b=Dza(+(c[(c[g>>2]|0)+180>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Bza(+(c[(c[g>>2]|0)+180>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=Owa(80952,Kwa(c[(c[g>>2]|0)+180>>2]|0,71200)|0)|0;g=c[63882]|0;h=e;j=92248;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[80944]=1;i=d;return}function Bba(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[81160]&1){i=d;return}g=b+420|0;b=Dza(+(c[(c[g>>2]|0)+176>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Bza(+(c[(c[g>>2]|0)+176>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=Owa(81168,Kwa(c[(c[g>>2]|0)+176>>2]|0,71200)|0)|0;g=c[63882]|0;h=e;j=92496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[81160]=1;i=d;return}function Cba(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[81384]&1){i=d;return}g=b+420|0;b=Dza(+(c[(c[g>>2]|0)+160>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Bza(+(c[(c[g>>2]|0)+160>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=Owa(81392,Kwa(c[(c[g>>2]|0)+160>>2]|0,71200)|0)|0;g=c[63882]|0;h=e;j=92736;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[81384]=1;i=d;return}function Dba(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[81600]&1){i=d;return}g=b+420|0;if(!((Dza(+(c[(c[g>>2]|0)+156>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Owa(81608,Kwa(c[(c[g>>2]|0)+156>>2]|0,71200)|0)|0;g=c[63882]|0;h=e;j=92848;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[81600]=1;i=d;return}function Eba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[81688]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+1936>>3],-1.0e10)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+1936>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=Owa(81696,Iwa(+h[(c[g>>2]|0)+1936>>3],69864)|0)|0;g=c[63882]|0;j=e;k=93016;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[81688]=1;i=d;return}function Fba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[81832]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+1928>>3],1.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+1928>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=Owa(81840,Iwa(+h[(c[g>>2]|0)+1928>>3],69864)|0)|0;g=c[63882]|0;j=e;k=93168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[81832]=1;i=d;return}function Gba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[81960]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+1912>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(81968,Iwa(+h[(c[g>>2]|0)+1912>>3],69864)|0)|0;g=c[63882]|0;j=e;k=93288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[81960]=1;i=d;return}function Hba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82056]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+1904>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(82064,Iwa(+h[(c[g>>2]|0)+1904>>3],69864)|0)|0;g=c[63882]|0;j=e;k=93408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[82056]=1;i=d;return}function Iba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82152]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+1888>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(82160,Iwa(+h[(c[g>>2]|0)+1888>>3],69864)|0)|0;g=c[63882]|0;j=e;k=93528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[82152]=1;i=d;return}function Jba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82248]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+1880>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(82256,Iwa(+h[(c[g>>2]|0)+1880>>3],69864)|0)|0;g=c[63882]|0;j=e;k=87704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[82248]=1;i=d;return}function Kba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82376]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+520>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(82384,Iwa(+h[(c[g>>2]|0)+520>>3],69864)|0)|0;g=c[63882]|0;j=e;k=88288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[82376]=1;i=d;return}function Lba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82488]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+512>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(82496,Iwa(+h[(c[g>>2]|0)+512>>3],69864)|0)|0;g=c[63882]|0;j=e;k=88288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[82488]=1;i=d;return}function Mba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82600]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+504>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(82608,Iwa(+h[(c[g>>2]|0)+504>>3],69864)|0)|0;g=c[63882]|0;j=e;k=88288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[82600]=1;i=d;return}function Nba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82712]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+496>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(82720,Iwa(+h[(c[g>>2]|0)+496>>3],69864)|0)|0;g=c[63882]|0;j=e;k=88288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[82712]=1;i=d;return}function Oba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82824]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+488>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(82832,Iwa(+h[(c[g>>2]|0)+488>>3],69864)|0)|0;g=c[63882]|0;j=e;k=88288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[82824]=1;i=d;return}function Pba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82936]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+1848>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(82944,Iwa(+h[(c[g>>2]|0)+1848>>3],69864)|0)|0;g=c[63882]|0;j=e;k=88432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[82936]=1;i=d;return}function Qba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83056]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+1840>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(83064,Iwa(+h[(c[g>>2]|0)+1840>>3],69864)|0)|0;g=c[63882]|0;j=e;k=88576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[83056]=1;i=d;return}function Rba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83176]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+1832>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+1832>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(83184,Iwa(+h[(c[g>>2]|0)+1832>>3],69864)|0)|0;g=c[63882]|0;j=e;k=88776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[83176]=1;i=d;return}function Sba(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83352]&1){i=d;return}g=b+420|0;b=Dza(+(c[(c[g>>2]|0)+148>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Bza(+(c[(c[g>>2]|0)+148>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=Owa(83360,Kwa(c[(c[g>>2]|0)+148>>2]|0,71200)|0)|0;g=c[63882]|0;h=e;j=89064;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[83352]=1;i=d;return}function Tba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83616]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+1816>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(83624,Iwa(+h[(c[g>>2]|0)+1816>>3],69864)|0)|0;g=c[63882]|0;j=e;k=89208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[83616]=1;i=d;return}function Uba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83736]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+1792>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(83744,Iwa(+h[(c[g>>2]|0)+1792>>3],69864)|0)|0;g=c[63882]|0;j=e;k=89352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[83736]=1;i=d;return}function Vba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83856]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+1776>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+1776>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(83864,Iwa(+h[(c[g>>2]|0)+1776>>3],69864)|0)|0;g=c[63882]|0;j=e;k=89544;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[83856]=1;i=d;return}function Wba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84024]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+1768>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+1768>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(84032,Iwa(+h[(c[g>>2]|0)+1768>>3],69864)|0)|0;g=c[63882]|0;j=e;k=89736;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[84024]=1;i=d;return}function Xba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84192]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+360>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+360>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(84200,Iwa(+h[(c[g>>2]|0)+360>>3],69864)|0)|0;g=c[63882]|0;j=e;k=90480;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[84192]=1;i=d;return}function Yba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84336]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+352>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+352>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(84344,Iwa(+h[(c[g>>2]|0)+352>>3],69864)|0)|0;g=c[63882]|0;j=e;k=90480;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[84336]=1;i=d;return}function Zba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84480]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+344>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+344>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(84488,Iwa(+h[(c[g>>2]|0)+344>>3],69864)|0)|0;g=c[63882]|0;j=e;k=90480;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[84480]=1;i=d;return}function _ba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84624]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+336>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+336>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(84632,Iwa(+h[(c[g>>2]|0)+336>>3],69864)|0)|0;g=c[63882]|0;j=e;k=90480;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[84624]=1;i=d;return}function $ba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84768]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+328>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+328>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(84776,Iwa(+h[(c[g>>2]|0)+328>>3],69864)|0)|0;g=c[63882]|0;j=e;k=90480;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[84768]=1;i=d;return}function aca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84912]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+1744>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+1744>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(84920,Iwa(+h[(c[g>>2]|0)+1744>>3],69864)|0)|0;g=c[63882]|0;j=e;k=90640;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[84912]=1;i=d;return}function bca(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[85048]&1){i=d;return}g=b+420|0;b=Dza(+(c[(c[g>>2]|0)+132>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Bza(+(c[(c[g>>2]|0)+132>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=Owa(85056,Kwa(c[(c[g>>2]|0)+132>>2]|0,71200)|0)|0;g=c[63882]|0;h=e;j=90888;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[85048]=1;i=d;return}function cca(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[85272]&1){i=d;return}g=b+420|0;b=Dza(+(c[(c[g>>2]|0)+128>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Bza(+(c[(c[g>>2]|0)+128>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=Owa(85280,Kwa(c[(c[g>>2]|0)+128>>2]|0,71200)|0)|0;g=c[63882]|0;h=e;j=91144;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[85272]=1;i=d;return}function dca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[85504]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+320>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+320>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(85512,Iwa(+h[(c[g>>2]|0)+320>>3],69864)|0)|0;g=c[63882]|0;j=e;k=91424;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[85504]=1;i=d;return}function eca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[85632]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+312>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+312>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(85640,Iwa(+h[(c[g>>2]|0)+312>>3],69864)|0)|0;g=c[63882]|0;j=e;k=91424;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[85632]=1;i=d;return}function fca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[85760]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+1720>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+1720>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(85768,Iwa(+h[(c[g>>2]|0)+1720>>3],69864)|0)|0;g=c[63882]|0;j=e;k=91592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[85760]=1;i=d;return}function gca(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[85904]&1){i=d;return}g=b+420|0;b=Dza(+(c[(c[g>>2]|0)+120>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Bza(+(c[(c[g>>2]|0)+120>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=Owa(85912,Kwa(c[(c[g>>2]|0)+120>>2]|0,71200)|0)|0;g=c[63882]|0;h=e;j=91848;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[85904]=1;i=d;return}function hca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[86136]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+1712>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+1712>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(86144,Iwa(+h[(c[g>>2]|0)+1712>>3],69864)|0)|0;g=c[63882]|0;j=e;k=92008;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[86136]=1;i=d;return}function ica(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[86272]&1){i=d;return}g=b+420|0;b=Dza(+(c[(c[g>>2]|0)+116>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Bza(+(c[(c[g>>2]|0)+116>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=Owa(86280,Kwa(c[(c[g>>2]|0)+116>>2]|0,71200)|0)|0;g=c[63882]|0;h=e;j=92248;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[86272]=1;i=d;return}function jca(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[86488]&1){i=d;return}g=b+420|0;b=Dza(+(c[(c[g>>2]|0)+112>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Bza(+(c[(c[g>>2]|0)+112>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=Owa(86496,Kwa(c[(c[g>>2]|0)+112>>2]|0,71200)|0)|0;g=c[63882]|0;h=e;j=92496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[86488]=1;i=d;return}function kca(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[86712]&1){i=d;return}g=b+420|0;b=Dza(+(c[(c[g>>2]|0)+96>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Bza(+(c[(c[g>>2]|0)+96>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=Owa(86720,Kwa(c[(c[g>>2]|0)+96>>2]|0,71200)|0)|0;g=c[63882]|0;h=e;j=92736;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[86712]=1;i=d;return}function lca(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[86928]&1){i=d;return}g=b+420|0;if(!((Dza(+(c[(c[g>>2]|0)+92>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Owa(86936,Kwa(c[(c[g>>2]|0)+92>>2]|0,71200)|0)|0;g=c[63882]|0;h=e;j=92848;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[86928]=1;i=d;return}function mca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87016]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+1704>>3],-1.0e10)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+1704>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=Owa(87024,Iwa(+h[(c[g>>2]|0)+1704>>3],69864)|0)|0;g=c[63882]|0;j=e;k=93016;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[87016]=1;i=d;return}function nca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87160]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+1696>>3],1.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+1696>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=Owa(87168,Iwa(+h[(c[g>>2]|0)+1696>>3],69864)|0)|0;g=c[63882]|0;j=e;k=93168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[87160]=1;i=d;return}function oca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87288]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+1680>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(87296,Iwa(+h[(c[g>>2]|0)+1680>>3],69864)|0)|0;g=c[63882]|0;j=e;k=93288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[87288]=1;i=d;return}function pca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87384]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+1672>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(87392,Iwa(+h[(c[g>>2]|0)+1672>>3],69864)|0)|0;g=c[63882]|0;j=e;k=93408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[87384]=1;i=d;return}function qca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87480]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+1656>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(87488,Iwa(+h[(c[g>>2]|0)+1656>>3],69864)|0)|0;g=c[63882]|0;j=e;k=93528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[87480]=1;i=d;return}function rca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87576]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+1648>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(87584,Iwa(+h[(c[g>>2]|0)+1648>>3],69864)|0)|0;g=c[63882]|0;j=e;k=87704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[87576]=1;i=d;return}function sca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87728]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+224>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(87736,Iwa(+h[(c[g>>2]|0)+224>>3],69864)|0)|0;g=c[63882]|0;j=e;k=88288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[87728]=1;i=d;return}function tca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87840]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+216>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(87848,Iwa(+h[(c[g>>2]|0)+216>>3],69864)|0)|0;g=c[63882]|0;j=e;k=88288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[87840]=1;i=d;return}function uca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87952]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+208>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(87960,Iwa(+h[(c[g>>2]|0)+208>>3],69864)|0)|0;g=c[63882]|0;j=e;k=88288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[87952]=1;i=d;return}function vca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[88064]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+200>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(88072,Iwa(+h[(c[g>>2]|0)+200>>3],69864)|0)|0;g=c[63882]|0;j=e;k=88288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[88064]=1;i=d;return}function wca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[88176]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+192>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(88184,Iwa(+h[(c[g>>2]|0)+192>>3],69864)|0)|0;g=c[63882]|0;j=e;k=88288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[88176]=1;i=d;return}function xca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[88312]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+1624>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(88320,Iwa(+h[(c[g>>2]|0)+1624>>3],69864)|0)|0;g=c[63882]|0;j=e;k=88432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[88312]=1;i=d;return}function yca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[88456]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+1616>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(88464,Iwa(+h[(c[g>>2]|0)+1616>>3],69864)|0)|0;g=c[63882]|0;j=e;k=88576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[88456]=1;i=d;return}function zca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[88600]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+1608>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+1608>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(88608,Iwa(+h[(c[g>>2]|0)+1608>>3],69864)|0)|0;g=c[63882]|0;j=e;k=88776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[88600]=1;i=d;return}function Aca(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[88800]&1){i=d;return}g=b+420|0;b=Dza(+(c[(c[g>>2]|0)+84>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Bza(+(c[(c[g>>2]|0)+84>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=Owa(88808,Kwa(c[(c[g>>2]|0)+84>>2]|0,71200)|0)|0;g=c[63882]|0;h=e;j=89064;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[88800]=1;i=d;return}function Bca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[89088]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+1592>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(89096,Iwa(+h[(c[g>>2]|0)+1592>>3],69864)|0)|0;g=c[63882]|0;j=e;k=89208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[89088]=1;i=d;return}function Cca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[89232]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+1568>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(89240,Iwa(+h[(c[g>>2]|0)+1568>>3],69864)|0)|0;g=c[63882]|0;j=e;k=89352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[89232]=1;i=d;return}function Dca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[89376]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+1552>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+1552>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(89384,Iwa(+h[(c[g>>2]|0)+1552>>3],69864)|0)|0;g=c[63882]|0;j=e;k=89544;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[89376]=1;i=d;return}function Eca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[89568]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+1544>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+1544>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(89576,Iwa(+h[(c[g>>2]|0)+1544>>3],69864)|0)|0;g=c[63882]|0;j=e;k=89736;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[89568]=1;i=d;return}function Fca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[89760]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+64>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+64>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(89768,Iwa(+h[(c[g>>2]|0)+64>>3],69864)|0)|0;g=c[63882]|0;j=e;k=90480;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[89760]=1;i=d;return}function Gca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[89904]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+56>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+56>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(89912,Iwa(+h[(c[g>>2]|0)+56>>3],69864)|0)|0;g=c[63882]|0;j=e;k=90480;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[89904]=1;i=d;return}function Hca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[90048]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+48>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+48>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(90056,Iwa(+h[(c[g>>2]|0)+48>>3],69864)|0)|0;g=c[63882]|0;j=e;k=90480;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[90048]=1;i=d;return}function Ica(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[90192]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+40>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+40>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(90200,Iwa(+h[(c[g>>2]|0)+40>>3],69864)|0)|0;g=c[63882]|0;j=e;k=90480;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[90192]=1;i=d;return}function Jca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[90336]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+32>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+32>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(90344,Iwa(+h[(c[g>>2]|0)+32>>3],69864)|0)|0;g=c[63882]|0;j=e;k=90480;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[90336]=1;i=d;return}function Kca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[90504]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+1520>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+1520>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(90512,Iwa(+h[(c[g>>2]|0)+1520>>3],69864)|0)|0;g=c[63882]|0;j=e;k=90640;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[90504]=1;i=d;return}function Lca(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[90664]&1){i=d;return}g=b+420|0;b=Dza(+(c[(c[g>>2]|0)+68>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Bza(+(c[(c[g>>2]|0)+68>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=Owa(90672,Kwa(c[(c[g>>2]|0)+68>>2]|0,71200)|0)|0;g=c[63882]|0;h=e;j=90888;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[90664]=1;i=d;return}function Mca(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[90912]&1){i=d;return}g=b+420|0;b=Dza(+(c[(c[g>>2]|0)+64>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Bza(+(c[(c[g>>2]|0)+64>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=Owa(90920,Kwa(c[(c[g>>2]|0)+64>>2]|0,71200)|0)|0;g=c[63882]|0;h=e;j=91144;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[90912]=1;i=d;return}function Nca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[91168]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+24>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+24>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(91176,Iwa(+h[(c[g>>2]|0)+24>>3],69864)|0)|0;g=c[63882]|0;j=e;k=91424;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[91168]=1;i=d;return}function Oca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[91296]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+16>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+16>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(91304,Iwa(+h[(c[g>>2]|0)+16>>3],69864)|0)|0;g=c[63882]|0;j=e;k=91424;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[91296]=1;i=d;return}function Pca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[91448]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+1496>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+1496>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(91456,Iwa(+h[(c[g>>2]|0)+1496>>3],69864)|0)|0;g=c[63882]|0;j=e;k=91592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[91448]=1;i=d;return}function Qca(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[91616]&1){i=d;return}g=b+420|0;b=Dza(+(c[(c[g>>2]|0)+56>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Bza(+(c[(c[g>>2]|0)+56>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=Owa(91624,Kwa(c[(c[g>>2]|0)+56>>2]|0,71200)|0)|0;g=c[63882]|0;h=e;j=91848;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[91616]=1;i=d;return}function Rca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[91872]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+1488>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+1488>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(91880,Iwa(+h[(c[g>>2]|0)+1488>>3],69864)|0)|0;g=c[63882]|0;j=e;k=92008;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[91872]=1;i=d;return}function Sca(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[92032]&1){i=d;return}g=b+420|0;b=Dza(+(c[(c[g>>2]|0)+52>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Bza(+(c[(c[g>>2]|0)+52>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=Owa(92040,Kwa(c[(c[g>>2]|0)+52>>2]|0,71200)|0)|0;g=c[63882]|0;h=e;j=92248;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[92032]=1;i=d;return}function Tca(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[92272]&1){i=d;return}g=b+420|0;b=Dza(+(c[(c[g>>2]|0)+48>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Bza(+(c[(c[g>>2]|0)+48>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=Owa(92280,Kwa(c[(c[g>>2]|0)+48>>2]|0,71200)|0)|0;g=c[63882]|0;h=e;j=92496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[92272]=1;i=d;return}function Uca(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[92520]&1){i=d;return}g=b+420|0;b=Dza(+(c[(c[g>>2]|0)+32>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Bza(+(c[(c[g>>2]|0)+32>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=Owa(92528,Kwa(c[(c[g>>2]|0)+32>>2]|0,71200)|0)|0;g=c[63882]|0;h=e;j=92736;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[92520]=1;i=d;return}function Vca(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[92760]&1){i=d;return}g=b+420|0;if(!((Dza(+(c[(c[g>>2]|0)+28>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Owa(92768,Kwa(c[(c[g>>2]|0)+28>>2]|0,71200)|0)|0;g=c[63882]|0;h=e;j=92848;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[92760]=1;i=d;return}function Wca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[92872]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+1480>>3],-1.0e10)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+1480>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=Owa(92880,Iwa(+h[(c[g>>2]|0)+1480>>3],69864)|0)|0;g=c[63882]|0;j=e;k=93016;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[92872]=1;i=d;return}function Xca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[93040]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+1472>>3],1.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+1472>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=Owa(93048,Iwa(+h[(c[g>>2]|0)+1472>>3],69864)|0)|0;g=c[63882]|0;j=e;k=93168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[93040]=1;i=d;return}function Yca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[93192]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+1456>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(93200,Iwa(+h[(c[g>>2]|0)+1456>>3],69864)|0)|0;g=c[63882]|0;j=e;k=93288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[93192]=1;i=d;return}function Zca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[93312]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+1448>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(93320,Iwa(+h[(c[g>>2]|0)+1448>>3],69864)|0)|0;g=c[63882]|0;j=e;k=93408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[93312]=1;i=d;return}function _ca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[93432]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+1432>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(93440,Iwa(+h[(c[g>>2]|0)+1432>>3],69864)|0)|0;g=c[63882]|0;j=e;k=93528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[93432]=1;i=d;return}function $ca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[93552]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+8>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+8>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(93560,Iwa(+h[(c[g>>2]|0)+8>>3],69864)|0)|0;g=c[63882]|0;j=e;k=93792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[93552]=1;i=d;return}function ada(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[93672]&1){i=d;return}g=b+416|0;b=Dza(+h[c[g>>2]>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[c[g>>2]>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(93680,Iwa(+h[c[g>>2]>>3],69864)|0)|0;g=c[63882]|0;j=e;k=93792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[93672]=1;i=d;return}function bda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[93816]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+1424>>3],1.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+1424>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=Owa(93824,Iwa(+h[(c[g>>2]|0)+1424>>3],69864)|0)|0;g=c[63882]|0;j=e;k=93936;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[93816]=1;i=d;return}function cda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[93960]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+1416>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+1416>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(93968,Iwa(+h[(c[g>>2]|0)+1416>>3],69864)|0)|0;g=c[63882]|0;j=e;k=94080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[93960]=1;i=d;return}function dda(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[94104]&1){i=d;return}g=b+420|0;b=Dza(+(c[(c[g>>2]|0)+24>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Bza(+(c[(c[g>>2]|0)+24>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=Owa(94112,Kwa(c[(c[g>>2]|0)+24>>2]|0,71200)|0)|0;g=c[63882]|0;h=e;j=94344;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[94104]=1;i=d;return}function eda(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[94368]&1){i=d;return}g=b+420|0;b=Dza(+(c[(c[g>>2]|0)+16>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Bza(+(c[(c[g>>2]|0)+16>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=Owa(94376,Kwa(c[(c[g>>2]|0)+16>>2]|0,71200)|0)|0;g=c[63882]|0;h=e;j=94664;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[94368]=1;i=d;return}function fda(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[94688]&1){i=d;return}g=b+420|0;b=Dza(+(c[(c[g>>2]|0)+12>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Bza(+(c[(c[g>>2]|0)+12>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=Owa(94696,Kwa(c[(c[g>>2]|0)+12>>2]|0,71200)|0)|0;g=c[63882]|0;h=e;j=94928;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[94688]=1;i=d;return}function gda(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[94952]&1){i=d;return}g=b+420|0;b=Dza(+(c[(c[g>>2]|0)+8>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Bza(+(c[(c[g>>2]|0)+8>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=Owa(94960,Kwa(c[(c[g>>2]|0)+8>>2]|0,71200)|0)|0;g=c[63882]|0;h=e;j=95176;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[94952]=1;i=d;return}function hda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[95200]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+1408>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(95208,Iwa(+h[(c[g>>2]|0)+1408>>3],69864)|0)|0;g=c[63882]|0;j=e;k=95296;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[95200]=1;i=d;return}function ida(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[95320]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+1400>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(95328,Iwa(+h[(c[g>>2]|0)+1400>>3],69864)|0)|0;g=c[63882]|0;j=e;k=95416;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[95320]=1;i=d;return}function jda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[95440]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+1392>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(95448,Iwa(+h[(c[g>>2]|0)+1392>>3],69864)|0)|0;g=c[63882]|0;j=e;k=95544;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[95440]=1;i=d;return}function kda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[95568]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+1384>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(95576,Iwa(+h[(c[g>>2]|0)+1384>>3],69864)|0)|0;g=c[63882]|0;j=e;k=95664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[95568]=1;i=d;return}function lda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[95688]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+1376>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(95696,Iwa(+h[(c[g>>2]|0)+1376>>3],69864)|0)|0;g=c[63882]|0;j=e;k=95792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[95688]=1;i=d;return}function mda(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[95816]&1){i=d;return}g=b+420|0;b=Dza(+(c[(c[g>>2]|0)+4>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Bza(+(c[(c[g>>2]|0)+4>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=Owa(95824,Kwa(c[(c[g>>2]|0)+4>>2]|0,71200)|0)|0;g=c[63882]|0;h=e;j=96048;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[95816]=1;i=d;return}function nda(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[96072]&1){i=d;return}g=b+420|0;b=Dza(+(c[c[g>>2]>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Bza(+(c[c[g>>2]>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=Owa(96080,Kwa(c[c[g>>2]>>2]|0,71200)|0)|0;g=c[63882]|0;h=e;j=96296;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[96072]=1;i=d;return}function oda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[96320]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+1344>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(96328,Iwa(+h[(c[g>>2]|0)+1344>>3],69864)|0)|0;g=c[63882]|0;j=e;k=96424;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[96320]=1;i=d;return}function pda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[96448]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+1336>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(96456,Iwa(+h[(c[g>>2]|0)+1336>>3],69864)|0)|0;g=c[63882]|0;j=e;k=96552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[96448]=1;i=d;return}function qda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[96576]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10920>>3],.001)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10920>>3],.25)|0)<<24>>24==0)){i=d;return}b=Owa(96584,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10920>>3],69864)|0)|0;g=c[63882]|0;j=e;k=97856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[96576]=1;i=d;return}function rda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[96792]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10912>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10912>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(96800,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10912>>3],69864)|0)|0;g=c[63882]|0;j=e;k=97048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[96792]=1;i=d;return}function sda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[97072]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9960>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9960>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(97080,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9960>>3],69864)|0)|0;g=c[63882]|0;j=e;k=98024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[97072]=1;i=d;return}function tda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[97216]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10904>>3],-1.0e10)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10904>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=Owa(97224,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10904>>3],69864)|0)|0;g=c[63882]|0;j=e;k=97376;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[97216]=1;i=d;return}function uda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[97400]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9920>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9920>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(97408,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9920>>3],69864)|0)|0;g=c[63882]|0;j=e;k=97688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[97400]=1;i=d;return}function vda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[97544]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9816>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9816>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(97552,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9816>>3],69864)|0)|0;g=c[63882]|0;j=e;k=97688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[97544]=1;i=d;return}function wda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[97712]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10896>>3],.001)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10896>>3],.25)|0)<<24>>24==0)){i=d;return}b=Owa(97720,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10896>>3],69864)|0)|0;g=c[63882]|0;j=e;k=97856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[97712]=1;i=d;return}function xda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[97880]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9808>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9808>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(97888,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9808>>3],69864)|0)|0;g=c[63882]|0;j=e;k=98024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[97880]=1;i=d;return}function yda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[98048]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10888>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10888>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(98056,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10888>>3],69864)|0)|0;g=c[63882]|0;j=e;k=98520;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[98048]=1;i=d;return}function zda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[98200]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9800>>3],1.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9800>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=Owa(98208,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9800>>3],69864)|0)|0;g=c[63882]|0;j=e;k=98344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[98200]=1;i=d;return}function Ada(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[98368]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10872>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10872>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(98376,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10872>>3],69864)|0)|0;g=c[63882]|0;j=e;k=98520;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[98368]=1;i=d;return}function Bda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[98544]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10864>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10864>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(98552,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10864>>3],69864)|0)|0;g=c[63882]|0;j=e;k=98688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[98544]=1;i=d;return}function Cda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[98712]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10856>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10856>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(98720,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10856>>3],69864)|0)|0;g=c[63882]|0;j=e;k=98856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[98712]=1;i=d;return}function Dda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[98880]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10848>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(98888,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10848>>3],69864)|0)|0;g=c[63882]|0;j=e;k=99392;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[98880]=1;i=d;return}function Eda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[99008]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10840>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(99016,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10840>>3],69864)|0)|0;g=c[63882]|0;j=e;k=99392;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[99008]=1;i=d;return}function Fda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[99136]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10832>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(99144,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10832>>3],69864)|0)|0;g=c[63882]|0;j=e;k=99392;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[99136]=1;i=d;return}function Gda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[99264]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10824>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(99272,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10824>>3],69864)|0)|0;g=c[63882]|0;j=e;k=99392;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[99264]=1;i=d;return}function Hda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[99416]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9624>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9624>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(99424,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9624>>3],69864)|0)|0;g=c[63882]|0;j=e;k=99568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[99416]=1;i=d;return}function Ida(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[99592]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9568>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9568>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(99600,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9568>>3],69864)|0)|0;g=c[63882]|0;j=e;k=99744;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[99592]=1;i=d;return}function Jda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[99768]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10816>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10816>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(99776,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10816>>3],69864)|0)|0;g=c[63882]|0;j=e;k=99928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[99768]=1;i=d;return}function Kda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[99952]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10808>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10808>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(99960,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10808>>3],69864)|0)|0;g=c[63882]|0;j=e;k=100104;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[99952]=1;i=d;return}function Lda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[100128]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10800>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10800>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=Owa(100136,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10800>>3],69864)|0)|0;g=c[63882]|0;j=e;k=100272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[100128]=1;i=d;return}function Mda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[100296]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10792>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10792>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(100304,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10792>>3],69864)|0)|0;g=c[63882]|0;j=e;k=100448;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[100296]=1;i=d;return}function Nda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[100472]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10784>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10784>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(100480,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10784>>3],69864)|0)|0;g=c[63882]|0;j=e;k=100616;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[100472]=1;i=d;return}function Oda(a){a=a|0;var b=0;b=i;W4(a);X4(a);Y4(a);Z4(a);_4(a);$4(a);a5(a);b5(a);c5(a);d5(a);e5(a);f5(a);g5(a);h5(a);i5(a);j5(a);k5(a);l5(a);m5(a);n5(a);o5(a);p5(a);q5(a);r5(a);s5(a);t5(a);u5(a);v5(a);w5(a);x5(a);y5(a);z5(a);A5(a);B5(a);C5(a);D5(a);E5(a);F5(a);G5(a);H5(a);I5(a);J5(a);K5(a);L5(a);M5(a);N5(a);O5(a);P5(a);Q5(a);R5(a);S5(a);T5(a);U5(a);V5(a);W5(a);X5(a);Y5(a);Z5(a);_5(a);$5(a);a6(a);b6(a);c6(a);d6(a);e6(a);f6(a);g6(a);h6(a);i6(a);j6(a);k6(a);l6(a);m6(a);n6(a);o6(a);p6(a);q6(a);r6(a);s6(a);t6(a);u6(a);v6(a);w6(a);x6(a);y6(a);z6(a);A6(a);B6(a);C6(a);D6(a);E6(a);F6(a);G6(a);H6(a);I6(a);J6(a);K6(a);L6(a);M6(a);N6(a);O6(a);P6(a);Q6(a);R6(a);S6(a);T6(a);U6(a);V6(a);W6(a);X6(a);Y6(a);Z6(a);_6(a);$6(a);a7(a);b7(a);c7(a);d7(a);e7(a);f7(a);g7(a);h7(a);i7(a);j7(a);k7(a);l7(a);m7(a);n7(a);o7(a);p7(a);q7(a);r7(a);s7(a);t7(a);u7(a);v7(a);w7(a);x7(a);y7(a);z7(a);A7(a);B7(a);C7(a);D7(a);E7(a);F7(a);G7(a);H7(a);I7(a);J7(a);K7(a);L7(a);M7(a);N7(a);O7(a);P7(a);Q7(a);R7(a);S7(a);T7(a);U7(a);V7(a);W7(a);X7(a);Y7(a);Z7(a);_7(a);$7(a);a8(a);b8(a);c8(a);d8(a);e8(a);f8(a);g8(a);h8(a);i8(a);j8(a);k8(a);l8(a);m8(a);n8(a);o8(a);p8(a);q8(a);r8(a);s8(a);t8(a);u8(a);v8(a);w8(a);x8(a);y8(a);z8(a);A8(a);B8(a);C8(a);D8(a);E8(a);F8(a);G8(a);H8(a);I8(a);J8(a);K8(a);L8(a);M8(a);N8(a);O8(a);P8(a);Q8(a);R8(a);S8(a);T8(a);U8(a);V8(a);W8(a);X8(a);Y8(a);Z8(a);_8(a);$8(a);a9(a);b9(a);c9(a);d9(a);e9(a);f9(a);g9(a);h9(a);i9(a);j9(a);k9(a);l9(a);m9(a);n9(a);o9(a);p9(a);q9(a);r9(a);s9(a);t9(a);u9(a);v9(a);w9(a);x9(a);y9(a);z9(a);A9(a);B9(a);C9(a);D9(a);E9(a);F9(a);G9(a);H9(a);I9(a);J9(a);K9(a);L9(a);M9(a);N9(a);O9(a);P9(a);Q9(a);R9(a);S9(a);T9(a);U9(a);V9(a);W9(a);X9(a);Y9(a);Z9(a);_9(a);$9(a);aaa(a);baa(a);caa(a);daa(a);eaa(a);faa(a);gaa(a);haa(a);iaa(a);jaa(a);kaa(a);laa(a);maa(a);naa(a);oaa(a);paa(a);qaa(a);raa(a);saa(a);taa(a);uaa(a);vaa(a);waa(a);xaa(a);yaa(a);zaa(a);Aaa(a);Baa(a);Caa(a);Daa(a);Eaa(a);Faa(a);Gaa(a);Haa(a);Iaa(a);Jaa(a);Kaa(a);Laa(a);Maa(a);Naa(a);Oaa(a);Paa(a);Qaa(a);Raa(a);Saa(a);Taa(a);Uaa(a);Vaa(a);Waa(a);Xaa(a);Yaa(a);Zaa(a);_aa(a);$aa(a);aba(a);bba(a);cba(a);dba(a);eba(a);fba(a);gba(a);hba(a);iba(a);jba(a);kba(a);lba(a);mba(a);nba(a);oba(a);pba(a);qba(a);rba(a);sba(a);tba(a);uba(a);vba(a);wba(a);xba(a);yba(a);zba(a);Aba(a);Bba(a);Cba(a);Dba(a);Eba(a);Fba(a);Gba(a);Hba(a);Iba(a);Jba(a);Kba(a);Lba(a);Mba(a);Nba(a);Oba(a);Pba(a);Qba(a);Rba(a);Sba(a);Tba(a);Uba(a);Vba(a);Wba(a);Xba(a);Yba(a);Zba(a);_ba(a);$ba(a);aca(a);bca(a);cca(a);dca(a);eca(a);fca(a);gca(a);hca(a);ica(a);jca(a);kca(a);lca(a);mca(a);nca(a);oca(a);pca(a);qca(a);rca(a);sca(a);tca(a);uca(a);vca(a);wca(a);xca(a);yca(a);zca(a);Aca(a);Bca(a);Cca(a);Dca(a);Eca(a);Fca(a);Gca(a);Hca(a);Ica(a);Jca(a);Kca(a);Lca(a);Mca(a);Nca(a);Oca(a);Pca(a);Qca(a);Rca(a);Sca(a);Tca(a);Uca(a);Vca(a);Wca(a);Xca(a);Yca(a);Zca(a);_ca(a);$ca(a);ada(a);bda(a);cda(a);dda(a);eda(a);fda(a);gda(a);hda(a);ida(a);jda(a);kda(a);lda(a);mda(a);nda(a);oda(a);pda(a);qda(a);rda(a);sda(a);tda(a);uda(a);vda(a);wda(a);xda(a);yda(a);zda(a);Ada(a);Bda(a);Cda(a);Dda(a);Eda(a);Fda(a);Gda(a);Hda(a);Ida(a);Jda(a);Kda(a);Lda(a);Mda(a);Nda(a);i=b;return 0}function Pda(b){b=b|0;var c=0;c=i;a[b+314|0]=0;Qda(b);i=c;return 0}function Qda(a){a=a|0;var b=0;b=i;jf(a);kf(a);lf(a);mf(a);nf(a);of(a);pf(a);qf(a);rf(a);sf(a);tf(a);uf(a);vf(a);wf(a);xf(a);yf(a);zf(a);Af(a);Bf(a);Cf(a);Df(a);Ef(a);Ff(a);Gf(a);Hf(a);If(a);Jf(a);Kf(a);Lf(a);Mf(a);Nf(a);Of(a);Pf(a);Qf(a);Rf(a);Sf(a);Tf(a);Uf(a);Vf(a);Wf(a);Xf(a);Yf(a);Zf(a);_f(a);$f(a);ug(a);vg(a);wg(a);xg(a);yg(a);Mg(a);Ng(a);Og(a);Pg(a);Qg(a);Rg(a);Sg(a);Tg(a);Ug(a);kh(a);lh(a);mh(a);nh(a);oh(a);Kh(a);Lh(a);Mh(a);Nh(a);Oh(a);Ph(a);Qh(a);Rh(a);Sh(a);Xh(a);zi(a);Ai(a);Di(a);Hi(a);Qi(a);Ri(a);Yi(a);Zi(a);cj(a);dj(a);gj(a);oj(a);xj(a);yj(a);Fj(a);Gj(a);Lj(a);Mj(a);Pj(a);Xj(a);ek(a);fk(a);mk(a);nk(a);sk(a);tk(a);wk(a);Ek(a);Nk(a);Ok(a);Vk(a);Wk(a);$k(a);al(a);dl(a);ll(a);ul(a);vl(a);Cl(a);Dl(a);El(a);Fl(a);Gl(a);Hl(a);Il(a);Jl(a);Ll(a);Nl(a);Ol(a);Zl(a);_l(a);cm(a);dm(a);hm(a);im(a);lm(a);pm(a);ym(a);zm(a);Gm(a);Hm(a);Mm(a);Nm(a);Qm(a);Ym(a);fn(a);gn(a);on(a);pn(a);un(a);vn(a);yn(a);Gn(a);Pn(a);Qn(a);Xn(a);Yn(a);bo(a);co(a);go(a);oo(a);xo(a);yo(a);Fo(a);Go(a);Ho(a);Io(a);Jo(a);Ko(a);Lo(a);Mo(a);So(a);Xo(a);ip(a);np(a);Dp(a);Op(a);Pp(a);$p(a);aq(a);kq(a);nq(a);vq(a);Eq(a);Fq(a);Uq(a);Vq(a);dr(a);gr(a);or(a);xr(a);yr(a);Nr(a);Or(a);Yr(a);$r(a);hs(a);qs(a);rs(a);Gs(a);Hs(a);Vs(a);Ys(a);et(a);nt(a);ot(a);Et(a);Ft(a);Gt(a);Ht(a);It(a);Jt(a);Pt(a);Ut(a);bu(a);ju(a);ku(a);nu(a);ru(a);Au(a);Bu(a);Iu(a);Ju(a);Ou(a);Pu(a);Su(a);_u(a);hv(a);iv(a);pv(a);qv(a);vv(a);wv(a);zv(a);Hv(a);Qv(a);Rv(a);Yv(a);Zv(a);cw(a);dw(a);gw(a);ow(a);xw(a);yw(a);Fw(a);Gw(a);Nw(a);Ow(a);Sw(a);Tw(a);$w(a);cx(a);lx(a);mx(a);zx(a);Ax(a);Cx(a);Dx(a);Ex(a);Fx(a);Gx(a);Hx(a);Ix(a);Jx(a);Kx(a);Lx(a);Mx(a);Nx(a);Ox(a);Px(a);Qx(a);Rx(a);Sx(a);Tx(a);Ux(a);Vx(a);Wx(a);Xx(a);Yx(a);Zx(a);_x(a);$x(a);ay(a);by(a);cy(a);dy(a);ey(a);fy(a);gy(a);hy(a);iy(a);jy(a);ky(a);ly(a);my(a);ny(a);oy(a);py(a);qy(a);ry(a);sy(a);ty(a);uy(a);vy(a);wy(a);xy(a);yy(a);zy(a);Ay(a);By(a);Cy(a);Dy(a);Ey(a);Fy(a);Gy(a);Hy(a);Iy(a);Jy(a);Ky(a);Ly(a);My(a);Ny(a);Oy(a);Py(a);Qy(a);Ry(a);Sy(a);Ty(a);Uy(a);Vy(a);Wy(a);Xy(a);Yy(a);Zy(a);_y(a);$y(a);az(a);bz(a);cz(a);dz(a);ez(a);fz(a);gz(a);hz(a);iz(a);jz(a);kz(a);lz(a);mz(a);i=b;return}function Rda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[100856]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7784>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7784>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(100872,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7784>>3],100864)|0)|0;g=c[63882]|0;j=e;k=167576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[100856]=1;i=d;return}function Sda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[101080]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7776>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7776>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(101088,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7776>>3],100864)|0)|0;g=c[63882]|0;j=e;k=167576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[101080]=1;i=d;return}function Tda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[101224]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7768>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7768>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(101232,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7768>>3],100864)|0)|0;g=c[63882]|0;j=e;k=167576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[101224]=1;i=d;return}function Uda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[101368]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7760>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7760>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(101376,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7760>>3],100864)|0)|0;g=c[63882]|0;j=e;k=167576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[101368]=1;i=d;return}function Vda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[101512]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7752>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7752>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(101520,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7752>>3],100864)|0)|0;g=c[63882]|0;j=e;k=167576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[101512]=1;i=d;return}function Wda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[101656]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7744>>3],1.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7744>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=Owa(101664,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7744>>3],100864)|0)|0;g=c[63882]|0;j=e;k=167744;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[101656]=1;i=d;return}function Xda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[101800]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7728>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7728>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(101808,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7728>>3],100864)|0)|0;g=c[63882]|0;j=e;k=167576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[101800]=1;i=d;return}function Yda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[101944]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7736>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7736>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(101952,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7736>>3],100864)|0)|0;g=c[63882]|0;j=e;k=167576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[101944]=1;i=d;return}function Zda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[102088]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7648>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(102096,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7648>>3],100864)|0)|0;g=c[63882]|0;j=e;k=168208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[102088]=1;i=d;return}function _da(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[102256]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7656>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(102264,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7656>>3],100864)|0)|0;g=c[63882]|0;j=e;k=168208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[102256]=1;i=d;return}function $da(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[102344]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7664>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(102352,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7664>>3],100864)|0)|0;g=c[63882]|0;j=e;k=168208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[102344]=1;i=d;return}function aea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[102432]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7672>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(102440,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7672>>3],100864)|0)|0;g=c[63882]|0;j=e;k=168208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[102432]=1;i=d;return}function bea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[102520]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7680>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(102528,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7680>>3],100864)|0)|0;g=c[63882]|0;j=e;k=168208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[102520]=1;i=d;return}function cea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[102608]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7608>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(102616,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7608>>3],100864)|0)|0;g=c[63882]|0;j=e;k=168712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[102608]=1;i=d;return}function dea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[102704]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7616>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(102712,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7616>>3],100864)|0)|0;g=c[63882]|0;j=e;k=168712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[102704]=1;i=d;return}function eea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[102800]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7624>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(102808,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7624>>3],100864)|0)|0;g=c[63882]|0;j=e;k=168712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[102800]=1;i=d;return}function fea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[102896]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7632>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(102904,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7632>>3],100864)|0)|0;g=c[63882]|0;j=e;k=168712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[102896]=1;i=d;return}function gea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[102992]&1){i=d;return}g=b+4|0;if(!((Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7640>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(103e3,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7640>>3],100864)|0)|0;g=c[63882]|0;j=e;k=168712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[102992]=1;i=d;return}function hea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[103088]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7568>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7568>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(103096,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7568>>3],100864)|0)|0;g=c[63882]|0;j=e;k=169456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[103088]=1;i=d;return}function iea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[103232]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7576>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7576>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(103240,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7576>>3],100864)|0)|0;g=c[63882]|0;j=e;k=169456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[103232]=1;i=d;return}function jea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[103376]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7584>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7584>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(103384,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7584>>3],100864)|0)|0;g=c[63882]|0;j=e;k=169456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[103376]=1;i=d;return}function kea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[103520]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7592>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7592>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(103528,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7592>>3],100864)|0)|0;g=c[63882]|0;j=e;k=169456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[103520]=1;i=d;return}function lea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[103664]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7600>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7600>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(103672,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7600>>3],100864)|0)|0;g=c[63882]|0;j=e;k=169456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[103664]=1;i=d;return}function mea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[103808]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7528>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7528>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(103816,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7528>>3],100864)|0)|0;g=c[63882]|0;j=e;k=170240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[103808]=1;i=d;return}function nea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[103960]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7536>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7536>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(103968,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7536>>3],100864)|0)|0;g=c[63882]|0;j=e;k=170240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[103960]=1;i=d;return}function oea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[104112]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7544>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7544>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(104120,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7544>>3],100864)|0)|0;g=c[63882]|0;j=e;k=170240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[104112]=1;i=d;return}function pea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[104264]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7552>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7552>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(104272,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7552>>3],100864)|0)|0;g=c[63882]|0;j=e;k=170240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[104264]=1;i=d;return}function qea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[104416]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7560>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7560>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(104424,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7560>>3],100864)|0)|0;g=c[63882]|0;j=e;k=170240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[104416]=1;i=d;return}function rea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[104568]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7400>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7400>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(104576,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7400>>3],100864)|0)|0;g=c[63882]|0;j=e;k=171176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[104568]=1;i=d;return}function sea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[104792]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7408>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7408>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(104800,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7408>>3],100864)|0)|0;g=c[63882]|0;j=e;k=171176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[104792]=1;i=d;return}function tea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[104944]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7416>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7416>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(104952,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7416>>3],100864)|0)|0;g=c[63882]|0;j=e;k=171176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[104944]=1;i=d;return}function uea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[105096]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7424>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7424>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(105104,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7424>>3],100864)|0)|0;g=c[63882]|0;j=e;k=171176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[105096]=1;i=d;return}function vea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[105248]&1){i=d;return}g=b+4|0;b=Dza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7432>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7432>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(105256,Iwa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7432>>3],100864)|0)|0;g=c[63882]|0;j=e;k=171176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[105248]=1;i=d;return}



function A2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2232>>3]=+h[b+2200>>3];i=i;return}function B2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2224>>3]=+h[b+2168>>3];i=i;return}function C2(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0;b=i;i=i+24|0;d=b;e=b+16|0;f=i;i=i+16|0;g=i;i=i+8|0;j=a+416|0;l=c[j>>2]|0;m=+h[l+904>>3];n=e;h[k>>3]=+h[l+912>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];gxa(f,2,m,e);e=c[a+536>>2]|0;a=c[j>>2]|0;m=(+h[a+2168>>3]+ +h[a+2200>>3])*.5;a=d;n=f;c[a+0>>2]=c[n+0>>2];c[a+4>>2]=c[n+4>>2];c[a+8>>2]=c[n+8>>2];tA(g,e,m,293.15,d);h[(c[j>>2]|0)+2160>>3]=+h[g>>3];i=b;return}function D2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2104>>3]=+h[b+1344>>3];i=i;return}function E2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2096>>3]=+h[b+1888>>3];i=i;return}function F2(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+107|0]=a[d+93|0]|0;i=i;return}function G2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2008>>3]=+h[b+1976>>3];i=i;return}function H2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2e3>>3]=+h[b+1944>>3];i=i;return}function I2(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0;b=i;i=i+24|0;d=b;e=b+16|0;f=i;i=i+16|0;g=i;i=i+8|0;j=a+416|0;l=c[j>>2]|0;m=+h[l+608>>3];n=e;h[k>>3]=+h[l+616>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];gxa(f,2,m,e);e=c[a+536>>2]|0;a=c[j>>2]|0;m=(+h[a+1944>>3]+ +h[a+1976>>3])*.5;a=d;n=f;c[a+0>>2]=c[n+0>>2];c[a+4>>2]=c[n+4>>2];c[a+8>>2]=c[n+8>>2];tA(g,e,m,293.15,d);h[(c[j>>2]|0)+1936>>3]=+h[g>>3];i=b;return}function J2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1880>>3]=+h[b+1344>>3];i=i;return}function K2(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+87|0]=a[d+73|0]|0;i=i;return}function L2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1776>>3]=+h[b+1744>>3];i=i;return}function M2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1768>>3]=+h[b+1712>>3];i=i;return}function N2(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0;b=i;i=i+24|0;d=b;e=b+16|0;f=i;i=i+16|0;g=i;i=i+8|0;j=a+416|0;l=c[j>>2]|0;m=+h[l+312>>3];n=e;h[k>>3]=+h[l+320>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];gxa(f,2,m,e);e=c[a+536>>2]|0;a=c[j>>2]|0;m=(+h[a+1712>>3]+ +h[a+1744>>3])*.5;a=d;n=f;c[a+0>>2]=c[n+0>>2];c[a+4>>2]=c[n+4>>2];c[a+8>>2]=c[n+8>>2];tA(g,e,m,293.15,d);h[(c[j>>2]|0)+1704>>3]=+h[g>>3];i=b;return}function O2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1648>>3]=+h[b+1344>>3];i=i;return}function P2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1640>>3]=+h[b+1432>>3];i=i;return}function Q2(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+67|0]=a[d+53|0]|0;i=i;return}function R2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1552>>3]=+h[b+1520>>3];i=i;return}function S2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1544>>3]=+h[b+1488>>3];i=i;return}function T2(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0;b=i;i=i+24|0;d=b;e=b+16|0;f=i;i=i+16|0;g=i;i=i+8|0;j=a+416|0;l=c[j>>2]|0;m=+h[l+16>>3];n=e;h[k>>3]=+h[l+24>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];gxa(f,2,m,e);e=c[a+536>>2]|0;a=c[j>>2]|0;m=(+h[a+1488>>3]+ +h[a+1520>>3])*.5;a=d;n=f;c[a+0>>2]=c[n+0>>2];c[a+4>>2]=c[n+4>>2];c[a+8>>2]=c[n+8>>2];tA(g,e,m,293.15,d);h[(c[j>>2]|0)+1480>>3]=+h[g>>3];i=b;return}function U2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1408>>3]=+h[b+1344>>3];i=i;return}function V2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1400>>3]=+h[b+1336>>3];i=i;return}function W2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1368>>3]=+h[b+1392>>3]*100.0;i=i;return}function X2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10976>>3]=15.0e4;i=i;return}function Y2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10664>>3]=0.0;i=i;return}function Z2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10656>>3]=0.0;i=i;return}function _2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10648>>3]=0.0;i=i;return}function $2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10640>>3]=0.0;i=i;return}function a3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10632>>3]=0.0;i=i;return}function b3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10624>>3]=0.0;i=i;return}function c3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10616>>3]=0.0;i=i;return}function d3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10608>>3]=0.0;i=i;return}function e3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10600>>3]=0.0;i=i;return}function f3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10592>>3]=0.0;i=i;return}function g3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10584>>3]=0.0;i=i;return}function h3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10576>>3]=0.0;i=i;return}function i3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10568>>3]=0.0;i=i;return}function j3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10560>>3]=0.0;i=i;return}function k3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10552>>3]=0.0;i=i;return}function l3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10536>>3]=.01;i=i;return}function m3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10968>>3]=293.15;i=i;return}function n3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10528>>3]=5.0;i=i;return}function o3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10520>>3]=10.0;i=i;return}function p3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10512>>3]=10.0;i=i;return}function q3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10504>>3]=10.0;i=i;return}function r3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10496>>3]=10.0;i=i;return}function s3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10488>>3]=5.0;i=i;return}function t3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10392>>3]=2.5;i=i;return}function u3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10384>>3]=5.0;i=i;return}function v3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10376>>3]=5.0;i=i;return}function w3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10368>>3]=5.0;i=i;return}function x3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10360>>3]=5.0;i=i;return}function y3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10352>>3]=2.5;i=i;return}function z3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10256>>3]=7.5;i=i;return}function A3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10248>>3]=5.0;i=i;return}function B3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10240>>3]=5.0;i=i;return}function C3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10232>>3]=7.5;i=i;return}function D3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10960>>3]=3.66;i=i;return}function E3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10104>>3]=.01;i=i;return}function F3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10096>>3]=5.0;i=i;return}function G3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10088>>3]=10.0;i=i;return}function H3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10080>>3]=10.0;i=i;return}function I3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10072>>3]=10.0;i=i;return}function J3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10064>>3]=10.0;i=i;return}function K3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10056>>3]=5.0;i=i;return}function L3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10952>>3]=293.15;i=i;return}function M3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10944>>3]=1.5;i=i;return}function N3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10936>>3]=20.0;i=i;return}function O3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10928>>3]=20.0;i=i;return}function P3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10920>>3]=.02879012713067693;i=i;return}function Q3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9960>>3]=.99;i=i;return}function R3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9920>>3]=.99;i=i;return}function S3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9816>>3]=.99;i=i;return}function T3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10896>>3]=.02879012713067693;i=i;return}function U3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9808>>3]=.99;i=i;return}function V3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10888>>3]=.0101010101010101;i=i;return}function W3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10872>>3]=.0101010101010101;i=i;return}function X3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10544>>3]=.99;i=i;return}function Y3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10112>>3]=.99;i=i;return}function Z3(b){b=b|0;var c=0,d=0;c=i;d=b+314|0;a[d]=1;wT(b);xT(b);yT(b);zT(b);AT(b);BT(b);CT(b);DT(b);ET(b);FT(b);GT(b);HT(b);IT(b);JT(b);KT(b);LT(b);MT(b);NT(b);OT(b);PT(b);QT(b);RT(b);ST(b);TT(b);UT(b);VT(b);WT(b);XT(b);YT(b);ZT(b);_T(b);$T(b);aU(b);bU(b);cU(b);dU(b);eU(b);fU(b);gU(b);hU(b);iU(b);jU(b);kU(b);lU(b);mU(b);nU(b);oU(b);pU(b);qU(b);rU(b);sU(b);tU(b);uU(b);vU(b);wU(b);xU(b);yU(b);zU(b);AU(b);BU(b);CU(b);DU(b);EU(b);FU(b);GU(b);HU(b);IU(b);JU(b);KU(b);LU(b);MU(b);NU(b);OU(b);PU(b);QU(b);RU(b);SU(b);TU(b);UU(b);VU(b);WU(b);XU(b);YU(b);ZU(b);_U(b);$U(b);aV(b);bV(b);cV(b);dV(b);eV(b);fV(b);gV(b);hV(b);iV(b);jV(b);kV(b);lV(b);mV(b);nV(b);oV(b);pV(b);qV(b);rV(b);sV(b);tV(b);uV(b);vV(b);wV(b);xV(b);yV(b);zV(b);AV(b);BV(b);CV(b);DV(b);EV(b);FV(b);GV(b);HV(b);IV(b);JV(b);KV(b);LV(b);MV(b);NV(b);OV(b);PV(b);QV(b);RV(b);SV(b);TV(b);UV(b);VV(b);WV(b);XV(b);YV(b);ZV(b);_V(b);$V(b);aW(b);bW(b);cW(b);dW(b);eW(b);fW(b);gW(b);hW(b);iW(b);jW(b);kW(b);lW(b);mW(b);nW(b);oW(b);pW(b);qW(b);rW(b);sW(b);tW(b);uW(b);vW(b);wW(b);xW(b);yW(b);zW(b);AW(b);BW(b);CW(b);DW(b);EW(b);FW(b);GW(b);HW(b);IW(b);JW(b);KW(b);LW(b);MW(b);NW(b);OW(b);PW(b);QW(b);RW(b);SW(b);TW(b);UW(b);VW(b);WW(b);XW(b);YW(b);ZW(b);_W(b);$W(b);aX(b);bX(b);cX(b);dX(b);eX(b);fX(b);gX(b);hX(b);iX(b);jX(b);kX(b);lX(b);mX(b);nX(b);oX(b);pX(b);qX(b);rX(b);sX(b);tX(b);uX(b);vX(b);wX(b);xX(b);yX(b);zX(b);AX(b);BX(b);CX(b);DX(b);EX(b);FX(b);GX(b);HX(b);IX(b);JX(b);KX(b);LX(b);MX(b);NX(b);OX(b);PX(b);QX(b);RX(b);SX(b);TX(b);UX(b);VX(b);WX(b);XX(b);YX(b);ZX(b);_X(b);$X(b);aY(b);bY(b);cY(b);dY(b);eY(b);fY(b);gY(b);hY(b);iY(b);jY(b);kY(b);lY(b);mY(b);nY(b);oY(b);pY(b);qY(b);rY(b);sY(b);tY(b);uY(b);vY(b);wY(b);xY(b);yY(b);zY(b);AY(b);BY(b);CY(b);DY(b);EY(b);FY(b);GY(b);HY(b);IY(b);JY(b);KY(b);LY(b);MY(b);NY(b);OY(b);PY(b);QY(b);RY(b);SY(b);TY(b);UY(b);VY(b);WY(b);XY(b);YY(b);ZY(b);_Y(b);$Y(b);aZ(b);bZ(b);cZ(b);dZ(b);eZ(b);fZ(b);gZ(b);hZ(b);iZ(b);jZ(b);kZ(b);lZ(b);mZ(b);nZ(b);oZ(b);pZ(b);qZ(b);rZ(b);sZ(b);tZ(b);uZ(b);vZ(b);wZ(b);xZ(b);yZ(b);zZ(b);AZ(b);BZ(b);CZ(b);DZ(b);EZ(b);FZ(b);GZ(b);HZ(b);IZ(b);JZ(b);KZ(b);LZ(b);MZ(b);NZ(b);OZ(b);PZ(b);QZ(b);RZ(b);SZ(b);TZ(b);UZ(b);VZ(b);WZ(b);XZ(b);YZ(b);ZZ(b);_Z(b);$Z(b);a_(b);b_(b);c_(b);d_(b);e_(b);f_(b);g_(b);h_(b);i_(b);j_(b);k_(b);l_(b);m_(b);n_(b);o_(b);p_(b);q_(b);r_(b);s_(b);t_(b);u_(b);v_(b);w_(b);x_(b);y_(b);z_(b);A_(b);B_(b);C_(b);D_(b);E_(b);F_(b);G_(b);H_(b);I_(b);J_(b);K_(b);L_(b);M_(b);N_(b);O_(b);P_(b);Q_(b);R_(b);S_(b);T_(b);U_(b);V_(b);W_(b);X_(b);Y_(b);Z_(b);__(b);$_(b);a$(b);b$(b);c$(b);d$(b);e$(b);f$(b);g$(b);h$(b);i$(b);j$(b);k$(b);l$(b);m$(b);n$(b);o$(b);p$(b);q$(b);r$(b);s$(b);t$(b);u$(b);v$(b);w$(b);x$(b);y$(b);z$(b);A$(b);B$(b);C$(b);D$(b);E$(b);F$(b);G$(b);H$(b);I$(b);J$(b);K$(b);L$(b);M$(b);N$(b);O$(b);P$(b);Q$(b);R$(b);S$(b);T$(b);U$(b);V$(b);W$(b);X$(b);Y$(b);Z$(b);_$(b);$$(b);a0(b);b0(b);c0(b);d0(b);e0(b);f0(b);g0(b);h0(b);i0(b);j0(b);k0(b);l0(b);m0(b);n0(b);o0(b);p0(b);q0(b);r0(b);s0(b);t0(b);u0(b);v0(b);w0(b);x0(b);y0(b);z0(b);A0(b);B0(b);C0(b);D0(b);E0(b);F0(b);G0(b);H0(b);I0(b);J0(b);K0(b);L0(b);M0(b);N0(b);O0(b);P0(b);Q0(b);R0(b);S0(b);T0(b);U0(b);V0(b);W0(b);X0(b);Y0(b);Z0(b);_0(b);$0(b);a1(b);b1(b);c1(b);d1(b);e1(b);f1(b);g1(b);h1(b);i1(b);j1(b);k1(b);l1(b);m1(b);n1(b);o1(b);p1(b);q1(b);r1(b);s1(b);t1(b);u1(b);v1(b);w1(b);x1(b);y1(b);z1(b);A1(b);B1(b);C1(b);D1(b);E1(b);F1(b);G1(b);H1(b);I1(b);J1(b);K1(b);L1(b);M1(b);N1(b);O1(b);P1(b);Q1(b);R1(b);S1(b);T1(b);U1(b);V1(b);W1(b);X1(b);Y1(b);Z1(b);_1(b);$1(b);a2(b);b2(b);c2(b);d2(b);e2(b);f2(b);g2(b);h2(b);i2(b);j2(b);k2(b);l2(b);m2(b);n2(b);o2(b);p2(b);q2(b);r2(b);s2(b);t2(b);u2(b);v2(b);w2(b);x2(b);y2(b);z2(b);A2(b);B2(b);C2(b);D2(b);E2(b);F2(b);G2(b);H2(b);I2(b);J2(b);K2(b);L2(b);M2(b);N2(b);O2(b);P2(b);Q2(b);R2(b);S2(b);T2(b);U2(b);V2(b);W2(b);X2(b);Y2(b);Z2(b);_2(b);$2(b);a3(b);b3(b);c3(b);d3(b);e3(b);f3(b);g3(b);h3(b);i3(b);j3(b);k3(b);l3(b);m3(b);n3(b);o3(b);p3(b);q3(b);r3(b);s3(b);t3(b);u3(b);v3(b);w3(b);x3(b);y3(b);z3(b);A3(b);B3(b);C3(b);D3(b);E3(b);F3(b);G3(b);H3(b);I3(b);J3(b);K3(b);L3(b);M3(b);N3(b);O3(b);P3(b);Q3(b);R3(b);S3(b);T3(b);U3(b);V3(b);W3(b);X3(b);Y3(b);a[d]=0;i=c;return 0}function _3(a){a=a|0;i=i;return}function $3(a){a=a|0;i=i;return 0}function a4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1536>>3]=+h[(c[a+416>>2]|0)+2160>>3];i=i;return}function b4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1648>>3]=+h[(c[a+416>>2]|0)+2160>>3];i=i;return}function c4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1760>>3]=+h[(c[a+416>>2]|0)+2160>>3];i=i;return}function d4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1872>>3]=+h[(c[a+416>>2]|0)+2160>>3];i=i;return}function e4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1984>>3]=+h[(c[a+416>>2]|0)+2160>>3];i=i;return}function f4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2032>>3]=(+h[b+2224>>3]- +h[b+2232>>3])/6.0;i=i;return}function g4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2024>>3]=(+h[b+2224>>3]- +h[b+2232>>3])/6.0;i=i;return}function h4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2016>>3]=(+h[b+2224>>3]- +h[b+2232>>3])/6.0;i=i;return}function i4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2008>>3]=(+h[b+2224>>3]- +h[b+2232>>3])/6.0;i=i;return}function j4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2e3>>3]=(+h[b+2224>>3]- +h[b+2232>>3])/6.0;i=i;return}function k4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1992>>3]=(+h[b+2224>>3]- +h[b+2232>>3])/6.0;i=i;return}function l4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3088>>3]=+h[(c[a+416>>2]|0)+1936>>3];i=i;return}function m4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3200>>3]=+h[(c[a+416>>2]|0)+1936>>3];i=i;return}function n4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3312>>3]=+h[(c[a+416>>2]|0)+1936>>3];i=i;return}function o4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3424>>3]=+h[(c[a+416>>2]|0)+1936>>3];i=i;return}function p4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3536>>3]=+h[(c[a+416>>2]|0)+1936>>3];i=i;return}function q4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3584>>3]=(+h[b+2e3>>3]- +h[b+2008>>3])/6.0;i=i;return}function r4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3576>>3]=(+h[b+2e3>>3]- +h[b+2008>>3])/6.0;i=i;return}function s4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3568>>3]=(+h[b+2e3>>3]- +h[b+2008>>3])/6.0;i=i;return}function t4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3560>>3]=(+h[b+2e3>>3]- +h[b+2008>>3])/6.0;i=i;return}function u4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3552>>3]=(+h[b+2e3>>3]- +h[b+2008>>3])/6.0;i=i;return}function v4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3544>>3]=(+h[b+2e3>>3]- +h[b+2008>>3])/6.0;i=i;return}function w4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4544>>3]=+h[(c[a+416>>2]|0)+1872>>3];i=i;return}function x4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4536>>3]=+h[(c[a+416>>2]|0)+1872>>3];i=i;return}function y4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4528>>3]=+h[(c[a+416>>2]|0)+1872>>3];i=i;return}function z4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4520>>3]=+h[(c[a+416>>2]|0)+1872>>3];i=i;return}function A4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4512>>3]=+h[(c[a+416>>2]|0)+1872>>3];i=i;return}function B4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5096>>3]=+h[(c[a+416>>2]|0)+1704>>3];i=i;return}function C4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5208>>3]=+h[(c[a+416>>2]|0)+1704>>3];i=i;return}function D4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5320>>3]=+h[(c[a+416>>2]|0)+1704>>3];i=i;return}function E4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5432>>3]=+h[(c[a+416>>2]|0)+1704>>3];i=i;return}function F4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5544>>3]=+h[(c[a+416>>2]|0)+1704>>3];i=i;return}function G4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5576>>3]=+h[b+1768>>3]*.25+ +h[b+1776>>3]*-.25;i=i;return}function H4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5568>>3]=+h[b+1768>>3]*.25+ +h[b+1776>>3]*-.25;i=i;return}function I4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5560>>3]=+h[b+1768>>3]*.25+ +h[b+1776>>3]*-.25;i=i;return}function J4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5552>>3]=+h[b+1768>>3]*.25+ +h[b+1776>>3]*-.25;i=i;return}function K4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6544>>3]=+h[(c[a+416>>2]|0)+1480>>3];i=i;return}function L4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6656>>3]=+h[(c[a+416>>2]|0)+1480>>3];i=i;return}function M4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6768>>3]=+h[(c[a+416>>2]|0)+1480>>3];i=i;return}function N4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6880>>3]=+h[(c[a+416>>2]|0)+1480>>3];i=i;return}function O4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6992>>3]=+h[(c[a+416>>2]|0)+1480>>3];i=i;return}function P4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7040>>3]=(+h[b+1544>>3]- +h[b+1552>>3])/6.0;i=i;return}function Q4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7032>>3]=(+h[b+1544>>3]- +h[b+1552>>3])/6.0;i=i;return}function R4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7024>>3]=(+h[b+1544>>3]- +h[b+1552>>3])/6.0;i=i;return}function S4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7016>>3]=(+h[b+1544>>3]- +h[b+1552>>3])/6.0;i=i;return}function T4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7008>>3]=(+h[b+1544>>3]- +h[b+1552>>3])/6.0;i=i;return}function U4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7e3>>3]=(+h[b+1544>>3]- +h[b+1552>>3])/6.0;i=i;return}function V4(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=i;i=i+16|0;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+16|0;S=i;i=i+16|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+16|0;X=i;i=i+16|0;Y=i;i=i+16|0;Z=i;i=i+16|0;_=i;i=i+16|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;hwa(9,1,69040,ca);if((c[206180>>2]|0)!=0){le[c[51674]&2047](9)}hwa(9,1,69064,ba);if((c[206180>>2]|0)!=0){le[c[51674]&2047](9)}hwa(9,1,69088,aa);if((c[206180>>2]|0)!=0){le[c[51674]&2047](9)}a4(a);b4(a);c4(a);d4(a);e4(a);f4(a);g4(a);h4(a);i4(a);j4(a);k4(a);l4(a);m4(a);n4(a);o4(a);p4(a);q4(a);r4(a);s4(a);t4(a);u4(a);v4(a);w4(a);x4(a);y4(a);z4(a);A4(a);B4(a);C4(a);D4(a);E4(a);F4(a);G4(a);H4(a);I4(a);J4(a);K4(a);L4(a);M4(a);N4(a);O4(a);P4(a);Q4(a);R4(a);S4(a);T4(a);U4(a);hwa(9,1,69112,$);$=a+4|0;da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+1536>>3];aa=a+8|0;a=c[aa>>2]|0;h[a+21600>>3]=da;c[_>>2]=c[a+21508>>2];a=_+4|0;h[k>>3]=da;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];hwa(9,0,69136,_);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+1648>>3];_=c[aa>>2]|0;h[_+23168>>3]=da;c[Z>>2]=c[_+23076>>2];_=Z+4|0;h[k>>3]=da;c[_>>2]=c[k>>2];c[_+4>>2]=c[k+4>>2];hwa(9,0,69136,Z);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+1760>>3];Z=c[aa>>2]|0;h[Z+24736>>3]=da;c[Y>>2]=c[Z+24644>>2];Z=Y+4|0;h[k>>3]=da;c[Z>>2]=c[k>>2];c[Z+4>>2]=c[k+4>>2];hwa(9,0,69136,Y);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+1872>>3];Y=c[aa>>2]|0;h[Y+26304>>3]=da;c[X>>2]=c[Y+26212>>2];Y=X+4|0;h[k>>3]=da;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];hwa(9,0,69136,X);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+1984>>3];X=c[aa>>2]|0;h[X+27872>>3]=da;c[W>>2]=c[X+27780>>2];X=W+4|0;h[k>>3]=da;c[X>>2]=c[k>>2];c[X+4>>2]=c[k+4>>2];hwa(9,0,69136,W);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+2032>>3];W=c[aa>>2]|0;h[W+28544>>3]=da;c[V>>2]=c[W+28452>>2];W=V+4|0;h[k>>3]=da;c[W>>2]=c[k>>2];c[W+4>>2]=c[k+4>>2];hwa(9,0,69136,V);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+2024>>3];V=c[aa>>2]|0;h[V+28432>>3]=da;c[U>>2]=c[V+28340>>2];V=U+4|0;h[k>>3]=da;c[V>>2]=c[k>>2];c[V+4>>2]=c[k+4>>2];hwa(9,0,69136,U);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+2016>>3];U=c[aa>>2]|0;h[U+28320>>3]=da;c[T>>2]=c[U+28228>>2];U=T+4|0;h[k>>3]=da;c[U>>2]=c[k>>2];c[U+4>>2]=c[k+4>>2];hwa(9,0,69136,T);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+2008>>3];T=c[aa>>2]|0;h[T+28208>>3]=da;c[S>>2]=c[T+28116>>2];T=S+4|0;h[k>>3]=da;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];hwa(9,0,69136,S);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+2e3>>3];S=c[aa>>2]|0;h[S+28096>>3]=da;c[R>>2]=c[S+28004>>2];S=R+4|0;h[k>>3]=da;c[S>>2]=c[k>>2];c[S+4>>2]=c[k+4>>2];hwa(9,0,69136,R);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+1992>>3];R=c[aa>>2]|0;h[R+27984>>3]=da;c[Q>>2]=c[R+27892>>2];R=Q+4|0;h[k>>3]=da;c[R>>2]=c[k>>2];c[R+4>>2]=c[k+4>>2];hwa(9,0,69136,Q);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+3088>>3];Q=c[aa>>2]|0;h[Q+43328>>3]=da;c[P>>2]=c[Q+43236>>2];Q=P+4|0;h[k>>3]=da;c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];hwa(9,0,69136,P);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+3200>>3];P=c[aa>>2]|0;h[P+44896>>3]=da;c[O>>2]=c[P+44804>>2];P=O+4|0;h[k>>3]=da;c[P>>2]=c[k>>2];c[P+4>>2]=c[k+4>>2];hwa(9,0,69136,O);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+3312>>3];O=c[aa>>2]|0;h[O+46464>>3]=da;c[N>>2]=c[O+46372>>2];O=N+4|0;h[k>>3]=da;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];hwa(9,0,69136,N);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+3424>>3];N=c[aa>>2]|0;h[N+48032>>3]=da;c[M>>2]=c[N+47940>>2];N=M+4|0;h[k>>3]=da;c[N>>2]=c[k>>2];c[N+4>>2]=c[k+4>>2];hwa(9,0,69136,M);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+3536>>3];M=c[aa>>2]|0;h[M+49600>>3]=da;c[L>>2]=c[M+49508>>2];M=L+4|0;h[k>>3]=da;c[M>>2]=c[k>>2];c[M+4>>2]=c[k+4>>2];hwa(9,0,69136,L);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+3584>>3];L=c[aa>>2]|0;h[L+50272>>3]=da;c[K>>2]=c[L+50180>>2];L=K+4|0;h[k>>3]=da;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];hwa(9,0,69136,K);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+3576>>3];K=c[aa>>2]|0;h[K+50160>>3]=da;c[J>>2]=c[K+50068>>2];K=J+4|0;h[k>>3]=da;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];hwa(9,0,69136,J);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+3568>>3];J=c[aa>>2]|0;h[J+50048>>3]=da;c[I>>2]=c[J+49956>>2];J=I+4|0;h[k>>3]=da;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];hwa(9,0,69136,I);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+3560>>3];I=c[aa>>2]|0;h[I+49936>>3]=da;c[H>>2]=c[I+49844>>2];I=H+4|0;h[k>>3]=da;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];hwa(9,0,69136,H);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+3552>>3];H=c[aa>>2]|0;h[H+49824>>3]=da;c[G>>2]=c[H+49732>>2];H=G+4|0;h[k>>3]=da;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];hwa(9,0,69136,G);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+3544>>3];G=c[aa>>2]|0;h[G+49712>>3]=da;c[F>>2]=c[G+49620>>2];G=F+4|0;h[k>>3]=da;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];hwa(9,0,69136,F);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+4544>>3];F=c[aa>>2]|0;h[F+63712>>3]=da;c[E>>2]=c[F+63620>>2];F=E+4|0;h[k>>3]=da;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];hwa(9,0,69136,E);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+4536>>3];E=c[aa>>2]|0;h[E+63600>>3]=da;c[D>>2]=c[E+63508>>2];E=D+4|0;h[k>>3]=da;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];hwa(9,0,69136,D);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+4528>>3];D=c[aa>>2]|0;h[D+63488>>3]=da;c[C>>2]=c[D+63396>>2];D=C+4|0;h[k>>3]=da;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];hwa(9,0,69136,C);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+4520>>3];C=c[aa>>2]|0;h[C+63376>>3]=da;c[B>>2]=c[C+63284>>2];C=B+4|0;h[k>>3]=da;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];hwa(9,0,69136,B);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+4512>>3];B=c[aa>>2]|0;h[B+63264>>3]=da;c[A>>2]=c[B+63172>>2];B=A+4|0;h[k>>3]=da;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];hwa(9,0,69136,A);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+5096>>3];A=c[aa>>2]|0;h[A+71440>>3]=da;c[z>>2]=c[A+71348>>2];A=z+4|0;h[k>>3]=da;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];hwa(9,0,69136,z);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+5208>>3];z=c[aa>>2]|0;h[z+73008>>3]=da;c[y>>2]=c[z+72916>>2];z=y+4|0;h[k>>3]=da;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];hwa(9,0,69136,y);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+5320>>3];y=c[aa>>2]|0;h[y+74576>>3]=da;c[x>>2]=c[y+74484>>2];y=x+4|0;h[k>>3]=da;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];hwa(9,0,69136,x);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+5432>>3];x=c[aa>>2]|0;h[x+76144>>3]=da;c[w>>2]=c[x+76052>>2];x=w+4|0;h[k>>3]=da;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];hwa(9,0,69136,w);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+5544>>3];w=c[aa>>2]|0;h[w+77712>>3]=da;c[v>>2]=c[w+77620>>2];w=v+4|0;h[k>>3]=da;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];hwa(9,0,69136,v);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+5576>>3];v=c[aa>>2]|0;h[v+78160>>3]=da;c[u>>2]=c[v+78068>>2];v=u+4|0;h[k>>3]=da;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];hwa(9,0,69136,u);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+5568>>3];u=c[aa>>2]|0;h[u+78048>>3]=da;c[t>>2]=c[u+77956>>2];u=t+4|0;h[k>>3]=da;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];hwa(9,0,69136,t);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+5560>>3];t=c[aa>>2]|0;h[t+77936>>3]=da;c[s>>2]=c[t+77844>>2];t=s+4|0;h[k>>3]=da;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];hwa(9,0,69136,s);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+5552>>3];s=c[aa>>2]|0;h[s+77824>>3]=da;c[r>>2]=c[s+77732>>2];s=r+4|0;h[k>>3]=da;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];hwa(9,0,69136,r);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+6544>>3];r=c[aa>>2]|0;h[r+91712>>3]=da;c[q>>2]=c[r+91620>>2];r=q+4|0;h[k>>3]=da;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];hwa(9,0,69136,q);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+6656>>3];q=c[aa>>2]|0;h[q+93280>>3]=da;c[p>>2]=c[q+93188>>2];q=p+4|0;h[k>>3]=da;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];hwa(9,0,69136,p);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+6768>>3];p=c[aa>>2]|0;h[p+94848>>3]=da;c[o>>2]=c[p+94756>>2];p=o+4|0;h[k>>3]=da;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];hwa(9,0,69136,o);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+6880>>3];o=c[aa>>2]|0;h[o+96416>>3]=da;c[n>>2]=c[o+96324>>2];o=n+4|0;h[k>>3]=da;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];hwa(9,0,69136,n);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+6992>>3];n=c[aa>>2]|0;h[n+97984>>3]=da;c[m>>2]=c[n+97892>>2];n=m+4|0;h[k>>3]=da;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];hwa(9,0,69136,m);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+7040>>3];m=c[aa>>2]|0;h[m+98656>>3]=da;c[l>>2]=c[m+98564>>2];m=l+4|0;h[k>>3]=da;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];hwa(9,0,69136,l);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+7032>>3];l=c[aa>>2]|0;h[l+98544>>3]=da;c[j>>2]=c[l+98452>>2];l=j+4|0;h[k>>3]=da;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];hwa(9,0,69136,j);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+7024>>3];j=c[aa>>2]|0;h[j+98432>>3]=da;c[g>>2]=c[j+98340>>2];j=g+4|0;h[k>>3]=da;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];hwa(9,0,69136,g);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+7016>>3];g=c[aa>>2]|0;h[g+98320>>3]=da;c[f>>2]=c[g+98228>>2];g=f+4|0;h[k>>3]=da;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];hwa(9,0,69136,f);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+7008>>3];f=c[aa>>2]|0;h[f+98208>>3]=da;c[e>>2]=c[f+98116>>2];f=e+4|0;h[k>>3]=da;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];hwa(9,0,69136,e);da=+h[(c[(c[c[$>>2]>>2]|0)+8>>2]|0)+7e3>>3];$=c[aa>>2]|0;h[$+98096>>3]=da;c[d>>2]=c[$+98004>>2];$=d+4|0;h[k>>3]=da;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];hwa(9,0,69136,d);if((c[206180>>2]|0)==0){i=b;return 0}le[c[51674]&2047](9);i=b;return 0}function W4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10112>>3]=.99;i=i;return}function X4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10544>>3]=.99;i=i;return}function Y4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10872>>3]=.0101010101010101;i=i;return}function Z4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10888>>3]=.0101010101010101;i=i;return}function _4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9808>>3]=.99;i=i;return}function $4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10896>>3]=.02879012713067693;i=i;return}function a5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9816>>3]=.99;i=i;return}function b5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9920>>3]=.99;i=i;return}function c5(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+24|0;d=b;e=b+16|0;f=c[a+536>>2]|0;g=d;j=69152;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];GA(e,f,15.0e4,293.15,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10904>>3]=+h[e>>3];i=b;return}function d5(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0;b=i;i=i+216|0;d=b;e=b+96|0;f=b+112|0;g=b+208|0;c[f>>2]=69168;h[f+8>>3]=.01801528;h[f+16>>3]=-13423382.81725291;h[f+24>>3]=549760.6476280135;h[f+32>>3]=1.0e3;j=f+40|0;k=69176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=f+52|0;j=69192;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];j=f+64|0;k=69208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=f+76|0;j=69224;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];h[f+88>>3]=461.5233290850878;j=c[a+536>>2]|0;k=a+4|0;l=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+10904>>3];a=e;m=69152;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];m=d+0|0;a=f+0|0;f=m+96|0;do{c[m>>2]=c[a>>2];m=m+4|0;a=a+4|0}while((m|0)<(f|0));nA(g,j,l,190.0,647.0,15.0e4,e,d,1.0e-13);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+9800>>3]=+h[g>>3];i=b;return}function e5(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0;b=i;i=i+88|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=a+536|0;k=c[j>>2]|0;l=a+4|0;m=+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+9800>>3];a=e;n=69240;c[a+0>>2]=c[n+0>>2];c[a+4>>2]=c[n+4>>2];c[a+8>>2]=c[n+8>>2];vz(f,k,15.0e4,m,e);e=c[j>>2]|0;j=d;k=f;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];c[j+24>>2]=c[k+24>>2];c[j+28>>2]=c[k+28>>2];Cz(g,e,d);h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+9624>>3]=+h[g>>3];i=b;return}function f5(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0;b=i;i=i+88|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=a+536|0;k=c[j>>2]|0;l=a+4|0;m=+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+9800>>3];a=e;n=69240;c[a+0>>2]=c[n+0>>2];c[a+4>>2]=c[n+4>>2];c[a+8>>2]=c[n+8>>2];vz(f,k,15.0e4,m,e);e=c[j>>2]|0;j=d;k=f;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];c[j+24>>2]=c[k+24>>2];c[j+28>>2]=c[k+28>>2];Fz(g,e,d);h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+9568>>3]=+h[g>>3];i=b;return}function g5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9960>>3]=.99;i=i;return}function h5(a){a=a|0;var b=0,d=0,e=0.0;b=i;i=i+8|0;d=b;AA(d,c[a+536>>2]|0,293.15);e=+yd(+(+h[d>>3]),149850.0);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10912>>3]=e;i=b;return}function i5(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10912>>3]*.625745065946724;if(j!=0.0){k=j;l=g;m=1500.0/k;n=l;o=n+10880|0;p=o;h[p>>3]=m;i=d;return}q=+nwa(c[b+536>>2]|0,j,69264,69256,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1500.0/k;n=l;o=n+10880|0;p=o;h[p>>3]=m;i=d;return}function j5(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10912>>3];k=+zd(1.0e-13,+(15.0e4-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+nwa(c[b+536>>2]|0,k,69328,69320,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+10864>>3]=m*.6219647130774989;i=d;return}function k5(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10912>>3];k=+zd(1.0e-13,+(15.0e4-j));if(k!=0.0){l=k;m=g;n=.99/l;o=j*n;p=o*.6219647130774989;q=+yd(+p,1.0);r=m;s=r+10856|0;t=s;h[t>>3]=q;i=d;return}u=+nwa(c[b+536>>2]|0,k,69328,69384,+h[f>>3],(a[b+319|0]|0)!=0|0);l=u;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=.99/l;o=j*n;p=o*.6219647130774989;q=+yd(+p,1.0);r=m;s=r+10856|0;t=s;h[t>>3]=q;i=d;return}function l5(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+10816>>3]=+zd(+(.01- +h[d+10856>>3]),0.0);i=b;return}function m5(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10808>>3]=.01- +h[b+10816>>3];i=i;return}function n5(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0,u=0,v=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10816>>3];k=1.0-j;if(k!=0.0){l=k;m=j;n=g;o=f}else{j=+nwa(c[b+536>>2]|0,k,69400,69392,+h[f>>3],(a[b+319|0]|0)!=0|0);f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;l=j;m=+h[g+10816>>3];n=g;o=f}j=284.1807127034489/l;l=1.0-m;m=+h[n+10808>>3];if(l!=0.0){p=n;q=m/l;r=q*461.5233290850878;s=j+r;t=p;u=t+10800|0;v=u;h[v>>3]=s;i=d;return}if(m==0.0){p=n;q=m;r=q*461.5233290850878;s=j+r;t=p;u=t+10800|0;v=u;h[v>>3]=s;i=d;return}k=m/+nwa(c[b+536>>2]|0,l,69400,69392,+h[o>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=k;r=q*461.5233290850878;s=j+r;t=p;u=t+10800|0;v=u;h[v>>3]=s;i=d;return}function o5(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10792>>3]=+h[b+10904>>3]+ +h[b+10800>>3]*-293.15;i=i;return}function p5(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10800>>3]*293.15;if(j!=0.0){k=j;l=g;m=15.0e4/k;n=l;o=n+10784|0;p=o;h[p>>3]=m;i=d;return}q=+nwa(c[b+536>>2]|0,j,69440,69432,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=15.0e4/k;n=l;o=n+10784|0;p=o;h[p>>3]=m;i=d;return}function q5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10920>>3]=.02879012713067693;i=i;return}function r5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10928>>3]=20.0;i=i;return}function s5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10936>>3]=20.0;i=i;return}function t5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10944>>3]=1.5;i=i;return}function u5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10952>>3]=293.15;i=i;return}function v5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10056>>3]=5.0;i=i;return}function w5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10064>>3]=10.0;i=i;return}function x5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10072>>3]=10.0;i=i;return}function y5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10080>>3]=10.0;i=i;return}function z5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10088>>3]=10.0;i=i;return}function A5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10096>>3]=5.0;i=i;return}function B5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10104>>3]=.01;i=i;return}function C5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10960>>3]=3.66;i=i;return}function D5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10232>>3]=7.5;i=i;return}function E5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10240>>3]=5.0;i=i;return}function F5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10248>>3]=5.0;i=i;return}function G5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10256>>3]=7.5;i=i;return}function H5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10352>>3]=2.5;i=i;return}function I5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10360>>3]=5.0;i=i;return}function J5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10368>>3]=5.0;i=i;return}function K5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10376>>3]=5.0;i=i;return}function L5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10384>>3]=5.0;i=i;return}function M5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10392>>3]=2.5;i=i;return}function N5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10488>>3]=5.0;i=i;return}function O5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10496>>3]=10.0;i=i;return}function P5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10504>>3]=10.0;i=i;return}function Q5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10512>>3]=10.0;i=i;return}function R5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10520>>3]=10.0;i=i;return}function S5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10528>>3]=5.0;i=i;return}function T5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10968>>3]=293.15;i=i;return}function U5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10536>>3]=.01;i=i;return}function V5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10552>>3]=0.0;i=i;return}function W5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10560>>3]=0.0;i=i;return}function X5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10568>>3]=0.0;i=i;return}function Y5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10576>>3]=0.0;i=i;return}function Z5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10584>>3]=0.0;i=i;return}function _5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10592>>3]=0.0;i=i;return}function $5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10600>>3]=0.0;i=i;return}function a6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10608>>3]=0.0;i=i;return}function b6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10616>>3]=0.0;i=i;return}function c6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10624>>3]=0.0;i=i;return}function d6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10632>>3]=0.0;i=i;return}function e6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10640>>3]=0.0;i=i;return}function f6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10648>>3]=0.0;i=i;return}function g6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10656>>3]=0.0;i=i;return}function h6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10664>>3]=0.0;i=i;return}function i6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10976>>3]=15.0e4;i=i;return}function j6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1368>>3]=+h[b+1392>>3]*100.0;i=i;return}function k6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1400>>3]=+h[b+1336>>3];i=i;return}function l6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1408>>3]=+h[b+1344>>3];i=i;return}function m6(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0;b=i;i=i+24|0;d=b;e=b+16|0;f=i;i=i+16|0;g=i;i=i+8|0;j=a+416|0;l=c[j>>2]|0;m=+h[l+16>>3];n=e;h[k>>3]=+h[l+24>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];gxa(f,2,m,e);e=c[a+536>>2]|0;a=c[j>>2]|0;m=(+h[a+1488>>3]+ +h[a+1520>>3])*.5;a=d;n=f;c[a+0>>2]=c[n+0>>2];c[a+4>>2]=c[n+4>>2];c[a+8>>2]=c[n+8>>2];tA(g,e,m,293.15,d);h[(c[j>>2]|0)+1480>>3]=+h[g>>3];i=b;return}function n6(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+h[b+1448>>3];h[b+1504>>3]=d*d*.7853981633974483;i=i;return}function o6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1512>>3]=+h[b+1448>>3]*3.141592653589793;i=i;return}function p6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1536>>3]=+h[b+1432>>3];i=i;return}function q6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1544>>3]=+h[b+1488>>3];i=i;return}function r6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1552>>3]=+h[b+1520>>3];i=i;return}function s6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1584>>3]=+h[b+1392>>3];i=i;return}function t6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1576>>3]=+h[b+1584>>3]*100.0;i=i;return}function u6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1600>>3]=+h[b+1352>>3];i=i;return}function v6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+72>>3]=+h[b+1440>>3]*.2;i=i;return}function w6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10008>>3]=+h[(c[a+416>>2]|0)+72>>3]*.5;i=i;return}function x6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9680>>3]=+h[b+72>>3]*+h[b+1512>>3];i=i;return}function y6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+80>>3]=+h[b+1440>>3]*.2;i=i;return}function z6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10016>>3]=(+h[b+72>>3]+ +h[b+80>>3])*.5;i=i;return}function A6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9688>>3]=+h[b+80>>3]*+h[b+1512>>3];i=i;return}function B6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+88>>3]=+h[b+1440>>3]*.2;i=i;return}function C6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10024>>3]=(+h[b+80>>3]+ +h[b+88>>3])*.5;i=i;return}function D6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9696>>3]=+h[b+88>>3]*+h[b+1512>>3];i=i;return}function E6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+96>>3]=+h[b+1440>>3]*.2;i=i;return}function F6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10032>>3]=(+h[b+88>>3]+ +h[b+96>>3])*.5;i=i;return}function G6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9704>>3]=+h[b+96>>3]*+h[b+1512>>3];i=i;return}function H6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+104>>3]=+h[b+1440>>3]*.2;i=i;return}function I6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10048>>3]=+h[(c[a+416>>2]|0)+104>>3]*.5;i=i;return}function J6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10040>>3]=(+h[b+96>>3]+ +h[b+104>>3])*.5;i=i;return}function K6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9712>>3]=+h[b+104>>3]*+h[b+1512>>3];i=i;return}function L6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+112>>3]=+h[b+1504>>3];i=i;return}function M6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9968>>3]=+h[b+112>>3]*+h[b+72>>3]*+h[b+1432>>3];i=i;return}function N6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+120>>3]=+h[b+1504>>3];i=i;return}function O6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9976>>3]=+h[b+120>>3]*+h[b+80>>3]*+h[b+1432>>3];i=i;return}function P6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+128>>3]=+h[b+1504>>3];i=i;return}function Q6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9984>>3]=+h[b+128>>3]*+h[b+88>>3]*+h[b+1432>>3];i=i;return}function R6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+136>>3]=+h[b+1504>>3];i=i;return}function S6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9992>>3]=+h[b+136>>3]*+h[b+96>>3]*+h[b+1432>>3];i=i;return}function T6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+144>>3]=+h[b+1504>>3];i=i;return}function U6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1e4>>3]=+h[b+144>>3]*+h[b+104>>3]*+h[b+1432>>3];i=i;return}function V6(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1512>>3];j=+h[f+1504>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+nwa(c[b+536>>2]|0,g,69480,69472,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+152>>3]=l*4.0;i=d;return}function W6(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1512>>3];j=+h[f+1504>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+nwa(c[b+536>>2]|0,g,69480,69496,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+160>>3]=l*4.0;i=d;return}function X6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9952>>3]=(+h[b+152>>3]+ +h[b+160>>3])*.5;i=i;return}function Y6(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1512>>3];j=+h[f+1504>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+nwa(c[b+536>>2]|0,g,69480,69504,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+168>>3]=l*4.0;i=d;return}function Z6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9944>>3]=(+h[b+160>>3]+ +h[b+168>>3])*.5;i=i;return}function _6(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1512>>3];j=+h[f+1504>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+nwa(c[b+536>>2]|0,g,69480,69512,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+176>>3]=l*4.0;i=d;return}function $6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9936>>3]=(+h[b+168>>3]+ +h[b+176>>3])*.5;i=i;return}function a7(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1512>>3];j=+h[f+1504>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+nwa(c[b+536>>2]|0,g,69480,69520,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+184>>3]=l*4.0;i=d;return}function b7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9928>>3]=(+h[b+176>>3]+ +h[b+184>>3])*.5;i=i;return}function c7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+192>>3]=+h[b+1456>>3];i=i;return}function d7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+200>>3]=+h[b+1456>>3];i=i;return}function e7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+208>>3]=+h[b+1456>>3];i=i;return}function f7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+216>>3]=+h[b+1456>>3];i=i;return}function g7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+224>>3]=+h[b+1456>>3];i=i;return}function h7(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0,u=0.0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0.0,E=0,F=0.0,G=0,H=0.0,I=0.0,J=0,K=0.0,L=0,M=0.0,N=0.0,O=0,P=0.0,Q=0,R=0.0,S=0.0,T=0,U=0.0,V=0,W=0.0,X=0.0,Y=0,Z=0.0,_=0,$=0.0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;j=d+24|0;k=d+32|0;l=d+40|0;m=b+536|0;n=c[m>>2]|0;o=b+416|0;p=c[o>>2]|0;q=+h[p+1536>>3];r=+h[p+1576>>3];do{if(q!=0.0){s=q;t=p;u=r/q}else{if(r==0.0){s=q;t=p;u=r;break}v=r/+nwa(n,q,69536,69528,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);w=c[o>>2]|0;s=+h[w+1536>>3];t=w;u=v}}while(0);q=+h[t+1616>>3];r=+h[t+1624>>3];p=b+4|0;w=c[c[p>>2]>>2]|0;v=+h[(c[w+8>>2]|0)+10008>>3];x=+h[t+152>>3];y=+h[t+192>>3];z=(y+y)*.5;y=+h[t+1584>>3];do{if(s!=0.0){A=t;B=y/s}else{if(y==0.0){A=t;B=y;break}C=y/+nwa(c[m>>2]|0,s,69536,69528,+h[w>>3],(a[b+319|0]|0)!=0|0);A=c[o>>2]|0;B=C}}while(0);Iz(e,n,u,q,q,r,r,v,x,z,B,+h[A+1560>>3]);B=+h[e>>3];e=c[m>>2]|0;A=c[o>>2]|0;z=+h[A+1536>>3];x=+h[A+1576>>3];do{if(z!=0.0){D=z;E=A;F=x/z}else{if(x==0.0){D=z;E=A;F=x;break}v=x/+nwa(e,z,69536,69528,+h[c[c[p>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);n=c[o>>2]|0;D=+h[n+1536>>3];E=n;F=v}}while(0);z=+h[E+1616>>3];x=+h[E+1624>>3];A=c[c[p>>2]>>2]|0;n=c[A+8>>2]|0;v=+h[n+10016>>3];r=+h[n+9952>>3];q=(+h[E+192>>3]+ +h[E+200>>3])*.5;u=+h[E+1584>>3];do{if(D!=0.0){G=E;H=u/D}else{if(u==0.0){G=E;H=u;break}s=u/+nwa(c[m>>2]|0,D,69536,69528,+h[A>>3],(a[b+319|0]|0)!=0|0);G=c[o>>2]|0;H=s}}while(0);Iz(f,e,F,z,z,x,x,v,r,q,H,+h[G+1560>>3]);H=+h[f>>3];f=c[m>>2]|0;G=c[o>>2]|0;q=+h[G+1536>>3];r=+h[G+1576>>3];do{if(q!=0.0){I=q;J=G;K=r/q}else{if(r==0.0){I=q;J=G;K=r;break}v=r/+nwa(f,q,69536,69528,+h[c[c[p>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);e=c[o>>2]|0;I=+h[e+1536>>3];J=e;K=v}}while(0);q=+h[J+1616>>3];r=+h[J+1624>>3];G=c[c[p>>2]>>2]|0;e=c[G+8>>2]|0;v=+h[e+10024>>3];x=+h[e+9944>>3];z=(+h[J+200>>3]+ +h[J+208>>3])*.5;F=+h[J+1584>>3];do{if(I!=0.0){L=J;M=F/I}else{if(F==0.0){L=J;M=F;break}D=F/+nwa(c[m>>2]|0,I,69536,69528,+h[G>>3],(a[b+319|0]|0)!=0|0);L=c[o>>2]|0;M=D}}while(0);Iz(g,f,K,q,q,r,r,v,x,z,M,+h[L+1560>>3]);M=+h[g>>3];g=c[m>>2]|0;L=c[o>>2]|0;z=+h[L+1536>>3];x=+h[L+1576>>3];do{if(z!=0.0){N=z;O=L;P=x/z}else{if(x==0.0){N=z;O=L;P=x;break}v=x/+nwa(g,z,69536,69528,+h[c[c[p>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);f=c[o>>2]|0;N=+h[f+1536>>3];O=f;P=v}}while(0);z=+h[O+1616>>3];x=+h[O+1624>>3];L=c[c[p>>2]>>2]|0;f=c[L+8>>2]|0;v=+h[f+10032>>3];r=+h[f+9936>>3];q=(+h[O+208>>3]+ +h[O+216>>3])*.5;K=+h[O+1584>>3];do{if(N!=0.0){Q=O;R=K/N}else{if(K==0.0){Q=O;R=K;break}I=K/+nwa(c[m>>2]|0,N,69536,69528,+h[L>>3],(a[b+319|0]|0)!=0|0);Q=c[o>>2]|0;R=I}}while(0);Iz(j,g,P,z,z,x,x,v,r,q,R,+h[Q+1560>>3]);R=+h[j>>3];j=c[m>>2]|0;Q=c[o>>2]|0;q=+h[Q+1536>>3];r=+h[Q+1576>>3];do{if(q!=0.0){S=q;T=Q;U=r/q}else{if(r==0.0){S=q;T=Q;U=r;break}v=r/+nwa(j,q,69536,69528,+h[c[c[p>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);g=c[o>>2]|0;S=+h[g+1536>>3];T=g;U=v}}while(0);q=+h[T+1616>>3];r=+h[T+1624>>3];Q=c[c[p>>2]>>2]|0;g=c[Q+8>>2]|0;v=+h[g+10040>>3];x=+h[g+9928>>3];z=(+h[T+216>>3]+ +h[T+224>>3])*.5;P=+h[T+1584>>3];do{if(S!=0.0){V=T;W=P/S}else{if(P==0.0){V=T;W=P;break}N=P/+nwa(c[m>>2]|0,S,69536,69528,+h[Q>>3],(a[b+319|0]|0)!=0|0);V=c[o>>2]|0;W=N}}while(0);Iz(k,j,U,q,q,r,r,v,x,z,W,+h[V+1560>>3]);W=+h[k>>3];k=c[m>>2]|0;V=c[o>>2]|0;z=+h[V+1536>>3];x=+h[V+1576>>3];do{if(z!=0.0){X=z;Y=V;Z=x/z}else{if(x==0.0){X=z;Y=V;Z=x;break}v=x/+nwa(k,z,69536,69528,+h[c[c[p>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);j=c[o>>2]|0;X=+h[j+1536>>3];Y=j;Z=v}}while(0);z=+h[Y+1616>>3];x=+h[Y+1624>>3];V=c[c[p>>2]>>2]|0;v=+h[(c[V+8>>2]|0)+10048>>3];r=+h[Y+184>>3];q=+h[Y+224>>3];U=(q+q)*.5;q=+h[Y+1584>>3];if(X!=0.0){_=Y;$=q/X;aa=_;ba=aa+1560|0;ca=ba;da=+h[ca>>3];Iz(l,k,Z,z,z,x,x,v,r,U,$,da);ea=l;fa=ea;ga=+h[fa>>3];ha=W+ga;ia=R+ha;ja=M+ia;ka=H+ja;la=B+ka;ma=c[p>>2]|0;na=c[ma>>2]|0;oa=na;pa=oa+8|0;qa=pa;ra=c[qa>>2]|0;sa=ra;ta=sa+10824|0;ua=ta;h[ua>>3]=la;i=d;return}if(q==0.0){_=Y;$=q;aa=_;ba=aa+1560|0;ca=ba;da=+h[ca>>3];Iz(l,k,Z,z,z,x,x,v,r,U,$,da);ea=l;fa=ea;ga=+h[fa>>3];ha=W+ga;ia=R+ha;ja=M+ia;ka=H+ja;la=B+ka;ma=c[p>>2]|0;na=c[ma>>2]|0;oa=na;pa=oa+8|0;qa=pa;ra=c[qa>>2]|0;sa=ra;ta=sa+10824|0;ua=ta;h[ua>>3]=la;i=d;return}S=q/+nwa(c[m>>2]|0,X,69536,69528,+h[V>>3],(a[b+319|0]|0)!=0|0);_=c[o>>2]|0;$=S;aa=_;ba=aa+1560|0;ca=ba;da=+h[ca>>3];Iz(l,k,Z,z,z,x,x,v,r,U,$,da);ea=l;fa=ea;ga=+h[fa>>3];ha=W+ga;ia=R+ha;ja=M+ia;ka=H+ja;la=B+ka;ma=c[p>>2]|0;na=c[ma>>2]|0;oa=na;pa=oa+8|0;qa=pa;ra=c[qa>>2]|0;sa=ra;ta=sa+10824|0;ua=ta;h[ua>>3]=la;i=d;return}function i7(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+67|0]=a[d+53|0]|0;i=i;return}function j7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1640>>3]=+h[b+1432>>3];i=i;return}function k7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1648>>3]=+h[b+1344>>3];i=i;return}function l7(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0;b=i;i=i+24|0;d=b;e=b+16|0;f=i;i=i+16|0;g=i;i=i+8|0;j=a+416|0;l=c[j>>2]|0;m=+h[l+312>>3];n=e;h[k>>3]=+h[l+320>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];gxa(f,2,m,e);e=c[a+536>>2]|0;a=c[j>>2]|0;m=(+h[a+1712>>3]+ +h[a+1744>>3])*.5;a=d;n=f;c[a+0>>2]=c[n+0>>2];c[a+4>>2]=c[n+4>>2];c[a+8>>2]=c[n+8>>2];tA(g,e,m,293.15,d);h[(c[j>>2]|0)+1704>>3]=+h[g>>3];i=b;return}function m7(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+h[b+1672>>3];h[b+1728>>3]=d*d*.7853981633974483;i=i;return}function n7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1736>>3]=+h[b+1672>>3]*3.141592653589793;i=i;return}function o7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1760>>3]=+h[b+1656>>3];i=i;return}function p7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1768>>3]=+h[b+1712>>3];i=i;return}function q7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1776>>3]=+h[b+1744>>3];i=i;return}function r7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1808>>3]=+h[b+1392>>3];i=i;return}function s7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1800>>3]=+h[b+1808>>3]*100.0;i=i;return}function t7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1824>>3]=+h[b+1352>>3];i=i;return}function u7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+368>>3]=+h[b+1664>>3]*.2;i=i;return}function v7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10160>>3]=+h[b+368>>3]*+h[b+1736>>3];i=i;return}function w7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+376>>3]=+h[b+1664>>3]*.2;i=i;return}function x7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10200>>3]=+h[b+368>>3]+ +h[b+376>>3]*.5;i=i;return}function y7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10168>>3]=+h[b+376>>3]*+h[b+1736>>3];i=i;return}function z7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+384>>3]=+h[b+1664>>3]*.2;i=i;return}function A7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10208>>3]=(+h[b+376>>3]+ +h[b+384>>3])*.5;i=i;return}function B7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10176>>3]=+h[b+384>>3]*+h[b+1736>>3];i=i;return}function C7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+392>>3]=+h[b+1664>>3]*.2;i=i;return}function D7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10216>>3]=(+h[b+384>>3]+ +h[b+392>>3])*.5;i=i;return}function E7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10184>>3]=+h[b+392>>3]*+h[b+1736>>3];i=i;return}function F7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+400>>3]=+h[b+1664>>3]*.2;i=i;return}function G7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10224>>3]=+h[b+392>>3]*.5+ +h[b+400>>3];i=i;return}function H7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10192>>3]=+h[b+400>>3]*+h[b+1736>>3];i=i;return}function I7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+408>>3]=+h[b+1728>>3];i=i;return}function J7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10120>>3]=+h[b+408>>3]*+h[b+368>>3]*+h[b+1656>>3];i=i;return}function K7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+416>>3]=+h[b+1728>>3];i=i;return}function L7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10128>>3]=+h[b+416>>3]*+h[b+376>>3]*+h[b+1656>>3];i=i;return}function M7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+424>>3]=+h[b+1728>>3];i=i;return}function N7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10136>>3]=+h[b+424>>3]*+h[b+384>>3]*+h[b+1656>>3];i=i;return}function O7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+432>>3]=+h[b+1728>>3];i=i;return}function P7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10144>>3]=+h[b+432>>3]*+h[b+392>>3]*+h[b+1656>>3];i=i;return}function Q7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+440>>3]=+h[b+1728>>3];i=i;return}function R7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10152>>3]=+h[b+440>>3]*+h[b+400>>3]*+h[b+1656>>3];i=i;return}function S7(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1736>>3];j=+h[f+1728>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+nwa(c[b+536>>2]|0,g,69576,69568,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+448>>3]=l*4.0;i=d;return}function T7(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1736>>3];j=+h[f+1728>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+nwa(c[b+536>>2]|0,g,69576,69592,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+456>>3]=l*4.0;i=d;return}function U7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9888>>3]=(+h[b+448>>3]+ +h[b+456>>3])*.5;i=i;return}function V7(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1736>>3];j=+h[f+1728>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+nwa(c[b+536>>2]|0,g,69576,69600,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+464>>3]=l*4.0;i=d;return}function W7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9896>>3]=(+h[b+456>>3]+ +h[b+464>>3])*.5;i=i;return}function X7(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1736>>3];j=+h[f+1728>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+nwa(c[b+536>>2]|0,g,69576,69608,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+472>>3]=l*4.0;i=d;return}function Y7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9904>>3]=(+h[b+464>>3]+ +h[b+472>>3])*.5;i=i;return}function Z7(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1736>>3];j=+h[f+1728>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+nwa(c[b+536>>2]|0,g,69576,69616,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+480>>3]=l*4.0;i=d;return}function _7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9912>>3]=(+h[b+472>>3]+ +h[b+480>>3])*.5;i=i;return}function $7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+488>>3]=+h[b+1680>>3];i=i;return}function a8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+496>>3]=+h[b+1680>>3];i=i;return}function b8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+504>>3]=+h[b+1680>>3];i=i;return}function c8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+512>>3]=+h[b+1680>>3];i=i;return}function d8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+520>>3]=+h[b+1680>>3];i=i;return}function e8(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0,E=0.0,F=0,G=0.0,H=0.0,I=0,J=0.0,K=0,L=0.0,M=0.0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;j=d+24|0;k=b+536|0;l=c[k>>2]|0;m=b+416|0;n=c[m>>2]|0;o=+h[n+1760>>3];p=+h[n+1800>>3];do{if(o!=0.0){q=o;r=n;s=p/o}else{if(p==0.0){q=o;r=n;s=p;break}t=p/+nwa(l,o,69632,69624,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);u=c[m>>2]|0;q=+h[u+1760>>3];r=u;s=t}}while(0);o=+h[r+1840>>3];p=+h[r+1848>>3];n=b+4|0;u=c[c[n>>2]>>2]|0;v=c[u+8>>2]|0;t=+h[v+10200>>3];w=+h[v+9888>>3];x=(+h[r+488>>3]+ +h[r+496>>3])*.5;y=+h[r+1808>>3];do{if(q!=0.0){z=r;A=y/q}else{if(y==0.0){z=r;A=y;break}B=y/+nwa(c[k>>2]|0,q,69632,69624,+h[u>>3],(a[b+319|0]|0)!=0|0);z=c[m>>2]|0;A=B}}while(0);Iz(e,l,s,o,o,p,p,t,w,x,A,+h[z+1784>>3]);A=+h[e>>3];e=c[k>>2]|0;z=c[m>>2]|0;x=+h[z+1760>>3];w=+h[z+1800>>3];do{if(x!=0.0){C=x;D=z;E=w/x}else{if(w==0.0){C=x;D=z;E=w;break}t=w/+nwa(e,x,69632,69624,+h[c[c[n>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);l=c[m>>2]|0;C=+h[l+1760>>3];D=l;E=t}}while(0);x=+h[D+1840>>3];w=+h[D+1848>>3];z=c[c[n>>2]>>2]|0;l=c[z+8>>2]|0;t=+h[l+10208>>3];p=+h[l+9896>>3];o=(+h[D+496>>3]+ +h[D+504>>3])*.5;s=+h[D+1808>>3];do{if(C!=0.0){F=D;G=s/C}else{if(s==0.0){F=D;G=s;break}q=s/+nwa(c[k>>2]|0,C,69632,69624,+h[z>>3],(a[b+319|0]|0)!=0|0);F=c[m>>2]|0;G=q}}while(0);Iz(f,e,E,x,x,w,w,t,p,o,G,+h[F+1784>>3]);G=+h[f>>3];f=c[k>>2]|0;F=c[m>>2]|0;o=+h[F+1760>>3];p=+h[F+1800>>3];do{if(o!=0.0){H=o;I=F;J=p/o}else{if(p==0.0){H=o;I=F;J=p;break}t=p/+nwa(f,o,69632,69624,+h[c[c[n>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);e=c[m>>2]|0;H=+h[e+1760>>3];I=e;J=t}}while(0);o=+h[I+1840>>3];p=+h[I+1848>>3];F=c[c[n>>2]>>2]|0;e=c[F+8>>2]|0;t=+h[e+10216>>3];w=+h[e+9904>>3];x=(+h[I+504>>3]+ +h[I+512>>3])*.5;E=+h[I+1808>>3];do{if(H!=0.0){K=I;L=E/H}else{if(E==0.0){K=I;L=E;break}C=E/+nwa(c[k>>2]|0,H,69632,69624,+h[F>>3],(a[b+319|0]|0)!=0|0);K=c[m>>2]|0;L=C}}while(0);Iz(g,f,J,o,o,p,p,t,w,x,L,+h[K+1784>>3]);L=+h[g>>3];g=c[k>>2]|0;K=c[m>>2]|0;x=+h[K+1760>>3];w=+h[K+1800>>3];do{if(x!=0.0){M=x;N=K;O=w/x}else{if(w==0.0){M=x;N=K;O=w;break}t=w/+nwa(g,x,69632,69624,+h[c[c[n>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);f=c[m>>2]|0;M=+h[f+1760>>3];N=f;O=t}}while(0);x=+h[N+1840>>3];w=+h[N+1848>>3];K=c[c[n>>2]>>2]|0;f=c[K+8>>2]|0;t=+h[f+10224>>3];p=+h[f+9912>>3];o=(+h[N+512>>3]+ +h[N+520>>3])*.5;J=+h[N+1808>>3];if(M!=0.0){P=N;Q=J/M;R=P;S=R+1784|0;T=S;U=+h[T>>3];Iz(j,g,O,x,x,w,w,t,p,o,Q,U);V=j;W=V;X=+h[W>>3];Y=L+X;Z=G+Y;_=A+Z;$=c[n>>2]|0;aa=c[$>>2]|0;ba=aa;ca=ba+8|0;da=ca;ea=c[da>>2]|0;fa=ea;ga=fa+10832|0;ha=ga;h[ha>>3]=_;i=d;return}if(J==0.0){P=N;Q=J;R=P;S=R+1784|0;T=S;U=+h[T>>3];Iz(j,g,O,x,x,w,w,t,p,o,Q,U);V=j;W=V;X=+h[W>>3];Y=L+X;Z=G+Y;_=A+Z;$=c[n>>2]|0;aa=c[$>>2]|0;ba=aa;ca=ba+8|0;da=ca;ea=c[da>>2]|0;fa=ea;ga=fa+10832|0;ha=ga;h[ha>>3]=_;i=d;return}H=J/+nwa(c[k>>2]|0,M,69632,69624,+h[K>>3],(a[b+319|0]|0)!=0|0);P=c[m>>2]|0;Q=H;R=P;S=R+1784|0;T=S;U=+h[T>>3];Iz(j,g,O,x,x,w,w,t,p,o,Q,U);V=j;W=V;X=+h[W>>3];Y=L+X;Z=G+Y;_=A+Z;$=c[n>>2]|0;aa=c[$>>2]|0;ba=aa;ca=ba+8|0;da=ca;ea=c[da>>2]|0;fa=ea;ga=fa+10832|0;ha=ga;h[ha>>3]=_;i=d;return}function f8(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+87|0]=a[d+73|0]|0;i=i;return}function g8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1864>>3]=+h[b+1656>>3];i=i;return}function h8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1880>>3]=+h[b+1344>>3];i=i;return}function i8(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0;b=i;i=i+24|0;d=b;e=b+16|0;f=i;i=i+16|0;g=i;i=i+8|0;j=a+416|0;l=c[j>>2]|0;m=+h[l+608>>3];n=e;h[k>>3]=+h[l+616>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];gxa(f,2,m,e);e=c[a+536>>2]|0;a=c[j>>2]|0;m=(+h[a+1944>>3]+ +h[a+1976>>3])*.5;a=d;n=f;c[a+0>>2]=c[n+0>>2];c[a+4>>2]=c[n+4>>2];c[a+8>>2]=c[n+8>>2];tA(g,e,m,293.15,d);h[(c[j>>2]|0)+1936>>3]=+h[g>>3];i=b;return}function j8(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+h[b+1904>>3];h[b+1960>>3]=d*d*.7853981633974483;i=i;return}function k8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1968>>3]=+h[b+1904>>3]*3.141592653589793;i=i;return}function l8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1992>>3]=+h[b+1888>>3];i=i;return}function m8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2e3>>3]=+h[b+1944>>3];i=i;return}function n8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2008>>3]=+h[b+1976>>3];i=i;return}function o8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2040>>3]=+h[b+1392>>3];i=i;return}function p8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2032>>3]=+h[b+2040>>3]*100.0;i=i;return}function q8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2056>>3]=+h[b+1352>>3];i=i;return}function r8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+664>>3]=+h[b+1896>>3]*.2;i=i;return}function s8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10304>>3]=+h[(c[a+416>>2]|0)+664>>3]*.5;i=i;return}function t8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9720>>3]=+h[b+664>>3]*+h[b+1968>>3];i=i;return}function u8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+672>>3]=+h[b+1896>>3]*.2;i=i;return}function v8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10312>>3]=(+h[b+664>>3]+ +h[b+672>>3])*.5;i=i;return}function w8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9728>>3]=+h[b+672>>3]*+h[b+1968>>3];i=i;return}function x8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+680>>3]=+h[b+1896>>3]*.2;i=i;return}function y8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10320>>3]=(+h[b+672>>3]+ +h[b+680>>3])*.5;i=i;return}function z8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9736>>3]=+h[b+680>>3]*+h[b+1968>>3];i=i;return}function A8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+688>>3]=+h[b+1896>>3]*.2;i=i;return}function B8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10328>>3]=(+h[b+680>>3]+ +h[b+688>>3])*.5;i=i;return}function C8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9744>>3]=+h[b+688>>3]*+h[b+1968>>3];i=i;return}function D8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+696>>3]=+h[b+1896>>3]*.2;i=i;return}function E8(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10344>>3]=+h[(c[a+416>>2]|0)+696>>3]*.5;i=i;return}function F8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10336>>3]=(+h[b+688>>3]+ +h[b+696>>3])*.5;i=i;return}function G8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9752>>3]=+h[b+696>>3]*+h[b+1968>>3];i=i;return}function H8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+704>>3]=+h[b+1960>>3];i=i;return}function I8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10264>>3]=+h[b+704>>3]*+h[b+664>>3]*+h[b+1888>>3];i=i;return}function J8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+712>>3]=+h[b+1960>>3];i=i;return}function K8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10272>>3]=+h[b+712>>3]*+h[b+672>>3]*+h[b+1888>>3];i=i;return}function L8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+720>>3]=+h[b+1960>>3];i=i;return}function M8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10280>>3]=+h[b+720>>3]*+h[b+680>>3]*+h[b+1888>>3];i=i;return}function N8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+728>>3]=+h[b+1960>>3];i=i;return}function O8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10288>>3]=+h[b+728>>3]*+h[b+688>>3]*+h[b+1888>>3];i=i;return}function P8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+736>>3]=+h[b+1960>>3];i=i;return}function Q8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10296>>3]=+h[b+736>>3]*+h[b+696>>3]*+h[b+1888>>3];i=i;return}function R8(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1968>>3];j=+h[f+1960>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+nwa(c[b+536>>2]|0,g,69672,69664,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+744>>3]=l*4.0;i=d;return}function S8(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1968>>3];j=+h[f+1960>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+nwa(c[b+536>>2]|0,g,69672,69688,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+752>>3]=l*4.0;i=d;return}function T8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9880>>3]=(+h[b+744>>3]+ +h[b+752>>3])*.5;i=i;return}function U8(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1968>>3];j=+h[f+1960>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+nwa(c[b+536>>2]|0,g,69672,69696,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+760>>3]=l*4.0;i=d;return}function V8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9872>>3]=(+h[b+752>>3]+ +h[b+760>>3])*.5;i=i;return}function W8(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1968>>3];j=+h[f+1960>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+nwa(c[b+536>>2]|0,g,69672,69704,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+768>>3]=l*4.0;i=d;return}function X8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9864>>3]=(+h[b+760>>3]+ +h[b+768>>3])*.5;i=i;return}function Y8(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1968>>3];j=+h[f+1960>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+nwa(c[b+536>>2]|0,g,69672,69712,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+776>>3]=l*4.0;i=d;return}function Z8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9856>>3]=(+h[b+768>>3]+ +h[b+776>>3])*.5;i=i;return}function _8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+784>>3]=+h[b+1912>>3];i=i;return}function $8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+792>>3]=+h[b+1912>>3];i=i;return}function a9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+800>>3]=+h[b+1912>>3];i=i;return}function b9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+808>>3]=+h[b+1912>>3];i=i;return}function c9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+816>>3]=+h[b+1912>>3];i=i;return}function d9(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0,u=0.0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0.0,E=0,F=0.0,G=0,H=0.0,I=0.0,J=0,K=0.0,L=0,M=0.0,N=0.0,O=0,P=0.0,Q=0,R=0.0,S=0.0,T=0,U=0.0,V=0,W=0.0,X=0.0,Y=0,Z=0.0,_=0,$=0.0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;j=d+24|0;k=d+32|0;l=d+40|0;m=b+536|0;n=c[m>>2]|0;o=b+416|0;p=c[o>>2]|0;q=+h[p+1992>>3];r=+h[p+2032>>3];do{if(q!=0.0){s=q;t=p;u=r/q}else{if(r==0.0){s=q;t=p;u=r;break}v=r/+nwa(n,q,69728,69720,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);w=c[o>>2]|0;s=+h[w+1992>>3];t=w;u=v}}while(0);q=+h[t+2072>>3];r=+h[t+2080>>3];p=b+4|0;w=c[c[p>>2]>>2]|0;v=+h[(c[w+8>>2]|0)+10304>>3];x=+h[t+744>>3];y=+h[t+784>>3];z=(y+y)*.5;y=+h[t+2040>>3];do{if(s!=0.0){A=t;B=y/s}else{if(y==0.0){A=t;B=y;break}C=y/+nwa(c[m>>2]|0,s,69728,69720,+h[w>>3],(a[b+319|0]|0)!=0|0);A=c[o>>2]|0;B=C}}while(0);Iz(e,n,u,q,q,r,r,v,x,z,B,+h[A+2016>>3]);B=+h[e>>3];e=c[m>>2]|0;A=c[o>>2]|0;z=+h[A+1992>>3];x=+h[A+2032>>3];do{if(z!=0.0){D=z;E=A;F=x/z}else{if(x==0.0){D=z;E=A;F=x;break}v=x/+nwa(e,z,69728,69720,+h[c[c[p>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);n=c[o>>2]|0;D=+h[n+1992>>3];E=n;F=v}}while(0);z=+h[E+2072>>3];x=+h[E+2080>>3];A=c[c[p>>2]>>2]|0;n=c[A+8>>2]|0;v=+h[n+10312>>3];r=+h[n+9880>>3];q=(+h[E+784>>3]+ +h[E+792>>3])*.5;u=+h[E+2040>>3];do{if(D!=0.0){G=E;H=u/D}else{if(u==0.0){G=E;H=u;break}s=u/+nwa(c[m>>2]|0,D,69728,69720,+h[A>>3],(a[b+319|0]|0)!=0|0);G=c[o>>2]|0;H=s}}while(0);Iz(f,e,F,z,z,x,x,v,r,q,H,+h[G+2016>>3]);H=+h[f>>3];f=c[m>>2]|0;G=c[o>>2]|0;q=+h[G+1992>>3];r=+h[G+2032>>3];do{if(q!=0.0){I=q;J=G;K=r/q}else{if(r==0.0){I=q;J=G;K=r;break}v=r/+nwa(f,q,69728,69720,+h[c[c[p>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);e=c[o>>2]|0;I=+h[e+1992>>3];J=e;K=v}}while(0);q=+h[J+2072>>3];r=+h[J+2080>>3];G=c[c[p>>2]>>2]|0;e=c[G+8>>2]|0;v=+h[e+10320>>3];x=+h[e+9872>>3];z=(+h[J+792>>3]+ +h[J+800>>3])*.5;F=+h[J+2040>>3];do{if(I!=0.0){L=J;M=F/I}else{if(F==0.0){L=J;M=F;break}D=F/+nwa(c[m>>2]|0,I,69728,69720,+h[G>>3],(a[b+319|0]|0)!=0|0);L=c[o>>2]|0;M=D}}while(0);Iz(g,f,K,q,q,r,r,v,x,z,M,+h[L+2016>>3]);M=+h[g>>3];g=c[m>>2]|0;L=c[o>>2]|0;z=+h[L+1992>>3];x=+h[L+2032>>3];do{if(z!=0.0){N=z;O=L;P=x/z}else{if(x==0.0){N=z;O=L;P=x;break}v=x/+nwa(g,z,69728,69720,+h[c[c[p>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);f=c[o>>2]|0;N=+h[f+1992>>3];O=f;P=v}}while(0);z=+h[O+2072>>3];x=+h[O+2080>>3];L=c[c[p>>2]>>2]|0;f=c[L+8>>2]|0;v=+h[f+10328>>3];r=+h[f+9864>>3];q=(+h[O+800>>3]+ +h[O+808>>3])*.5;K=+h[O+2040>>3];do{if(N!=0.0){Q=O;R=K/N}else{if(K==0.0){Q=O;R=K;break}I=K/+nwa(c[m>>2]|0,N,69728,69720,+h[L>>3],(a[b+319|0]|0)!=0|0);Q=c[o>>2]|0;R=I}}while(0);Iz(j,g,P,z,z,x,x,v,r,q,R,+h[Q+2016>>3]);R=+h[j>>3];j=c[m>>2]|0;Q=c[o>>2]|0;q=+h[Q+1992>>3];r=+h[Q+2032>>3];do{if(q!=0.0){S=q;T=Q;U=r/q}else{if(r==0.0){S=q;T=Q;U=r;break}v=r/+nwa(j,q,69728,69720,+h[c[c[p>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);g=c[o>>2]|0;S=+h[g+1992>>3];T=g;U=v}}while(0);q=+h[T+2072>>3];r=+h[T+2080>>3];Q=c[c[p>>2]>>2]|0;g=c[Q+8>>2]|0;v=+h[g+10336>>3];x=+h[g+9856>>3];z=(+h[T+808>>3]+ +h[T+816>>3])*.5;P=+h[T+2040>>3];do{if(S!=0.0){V=T;W=P/S}else{if(P==0.0){V=T;W=P;break}N=P/+nwa(c[m>>2]|0,S,69728,69720,+h[Q>>3],(a[b+319|0]|0)!=0|0);V=c[o>>2]|0;W=N}}while(0);Iz(k,j,U,q,q,r,r,v,x,z,W,+h[V+2016>>3]);W=+h[k>>3];k=c[m>>2]|0;V=c[o>>2]|0;z=+h[V+1992>>3];x=+h[V+2032>>3];do{if(z!=0.0){X=z;Y=V;Z=x/z}else{if(x==0.0){X=z;Y=V;Z=x;break}v=x/+nwa(k,z,69728,69720,+h[c[c[p>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);j=c[o>>2]|0;X=+h[j+1992>>3];Y=j;Z=v}}while(0);z=+h[Y+2072>>3];x=+h[Y+2080>>3];V=c[c[p>>2]>>2]|0;v=+h[(c[V+8>>2]|0)+10344>>3];r=+h[Y+776>>3];q=+h[Y+816>>3];U=(q+q)*.5;q=+h[Y+2040>>3];if(X!=0.0){_=Y;$=q/X;aa=_;ba=aa+2016|0;ca=ba;da=+h[ca>>3];Iz(l,k,Z,z,z,x,x,v,r,U,$,da);ea=l;fa=ea;ga=+h[fa>>3];ha=W+ga;ia=R+ha;ja=M+ia;ka=H+ja;la=B+ka;ma=c[p>>2]|0;na=c[ma>>2]|0;oa=na;pa=oa+8|0;qa=pa;ra=c[qa>>2]|0;sa=ra;ta=sa+10840|0;ua=ta;h[ua>>3]=la;i=d;return}if(q==0.0){_=Y;$=q;aa=_;ba=aa+2016|0;ca=ba;da=+h[ca>>3];Iz(l,k,Z,z,z,x,x,v,r,U,$,da);ea=l;fa=ea;ga=+h[fa>>3];ha=W+ga;ia=R+ha;ja=M+ia;ka=H+ja;la=B+ka;ma=c[p>>2]|0;na=c[ma>>2]|0;oa=na;pa=oa+8|0;qa=pa;ra=c[qa>>2]|0;sa=ra;ta=sa+10840|0;ua=ta;h[ua>>3]=la;i=d;return}S=q/+nwa(c[m>>2]|0,X,69728,69720,+h[V>>3],(a[b+319|0]|0)!=0|0);_=c[o>>2]|0;$=S;aa=_;ba=aa+2016|0;ca=ba;da=+h[ca>>3];Iz(l,k,Z,z,z,x,x,v,r,U,$,da);ea=l;fa=ea;ga=+h[fa>>3];ha=W+ga;ia=R+ha;ja=M+ia;ka=H+ja;la=B+ka;ma=c[p>>2]|0;na=c[ma>>2]|0;oa=na;pa=oa+8|0;qa=pa;ra=c[qa>>2]|0;sa=ra;ta=sa+10840|0;ua=ta;h[ua>>3]=la;i=d;return}function e9(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+107|0]=a[d+93|0]|0;i=i;return}function f9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2096>>3]=+h[b+1888>>3];i=i;return}function g9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2104>>3]=+h[b+1344>>3];i=i;return}function h9(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0;b=i;i=i+24|0;d=b;e=b+16|0;f=i;i=i+16|0;g=i;i=i+8|0;j=a+416|0;l=c[j>>2]|0;m=+h[l+904>>3];n=e;h[k>>3]=+h[l+912>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];gxa(f,2,m,e);e=c[a+536>>2]|0;a=c[j>>2]|0;m=(+h[a+2168>>3]+ +h[a+2200>>3])*.5;a=d;n=f;c[a+0>>2]=c[n+0>>2];c[a+4>>2]=c[n+4>>2];c[a+8>>2]=c[n+8>>2];tA(g,e,m,293.15,d);h[(c[j>>2]|0)+2160>>3]=+h[g>>3];i=b;return}function i9(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+h[b+2128>>3];h[b+2184>>3]=d*d*.7853981633974483;i=i;return}function j9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2192>>3]=+h[b+2128>>3]*3.141592653589793;i=i;return}function k9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2216>>3]=+h[b+2112>>3];i=i;return}function l9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2224>>3]=+h[b+2168>>3];i=i;return}function m9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2232>>3]=+h[b+2200>>3];i=i;return}function n9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2264>>3]=+h[b+1392>>3];i=i;return}function o9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2256>>3]=+h[b+2264>>3]*100.0;i=i;return}function p9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2280>>3]=+h[b+1352>>3];i=i;return}function q9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+960>>3]=+h[b+2120>>3]*.2;i=i;return}function r9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10440>>3]=+h[(c[a+416>>2]|0)+960>>3]*.5;i=i;return}function s9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9760>>3]=+h[b+960>>3]*+h[b+2192>>3];i=i;return}function t9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+968>>3]=+h[b+2120>>3]*.2;i=i;return}function u9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10448>>3]=(+h[b+960>>3]+ +h[b+968>>3])*.5;i=i;return}function v9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9768>>3]=+h[b+968>>3]*+h[b+2192>>3];i=i;return}function w9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+976>>3]=+h[b+2120>>3]*.2;i=i;return}function x9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10456>>3]=(+h[b+968>>3]+ +h[b+976>>3])*.5;i=i;return}function y9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9776>>3]=+h[b+976>>3]*+h[b+2192>>3];i=i;return}function z9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+984>>3]=+h[b+2120>>3]*.2;i=i;return}function A9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10464>>3]=(+h[b+976>>3]+ +h[b+984>>3])*.5;i=i;return}function B9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9784>>3]=+h[b+984>>3]*+h[b+2192>>3];i=i;return}function C9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+992>>3]=+h[b+2120>>3]*.2;i=i;return}function D9(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10480>>3]=+h[(c[a+416>>2]|0)+992>>3]*.5;i=i;return}function E9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10472>>3]=(+h[b+984>>3]+ +h[b+992>>3])*.5;i=i;return}function F9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9792>>3]=+h[b+992>>3]*+h[b+2192>>3];i=i;return}function G9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1e3>>3]=+h[b+2184>>3];i=i;return}function H9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10400>>3]=+h[b+1e3>>3]*+h[b+960>>3]*+h[b+2112>>3];i=i;return}function I9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1008>>3]=+h[b+2184>>3];i=i;return}function J9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10408>>3]=+h[b+1008>>3]*+h[b+968>>3]*+h[b+2112>>3];i=i;return}function K9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1016>>3]=+h[b+2184>>3];i=i;return}function L9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10416>>3]=+h[b+1016>>3]*+h[b+976>>3]*+h[b+2112>>3];i=i;return}function M9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1024>>3]=+h[b+2184>>3];i=i;return}function N9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10424>>3]=+h[b+1024>>3]*+h[b+984>>3]*+h[b+2112>>3];i=i;return}function O9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1032>>3]=+h[b+2184>>3];i=i;return}function P9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10432>>3]=+h[b+1032>>3]*+h[b+992>>3]*+h[b+2112>>3];i=i;return}function Q9(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2192>>3];j=+h[f+2184>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+nwa(c[b+536>>2]|0,g,69768,69760,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1040>>3]=l*4.0;i=d;return}function R9(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2192>>3];j=+h[f+2184>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+nwa(c[b+536>>2]|0,g,69768,69784,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1048>>3]=l*4.0;i=d;return}function S9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9848>>3]=(+h[b+1040>>3]+ +h[b+1048>>3])*.5;i=i;return}function T9(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2192>>3];j=+h[f+2184>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+nwa(c[b+536>>2]|0,g,69768,69792,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1056>>3]=l*4.0;i=d;return}function U9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9840>>3]=(+h[b+1048>>3]+ +h[b+1056>>3])*.5;i=i;return}function V9(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2192>>3];j=+h[f+2184>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+nwa(c[b+536>>2]|0,g,69768,69800,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1064>>3]=l*4.0;i=d;return}function W9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9832>>3]=(+h[b+1056>>3]+ +h[b+1064>>3])*.5;i=i;return}function X9(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2192>>3];j=+h[f+2184>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+nwa(c[b+536>>2]|0,g,69768,69808,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1072>>3]=l*4.0;i=d;return}function Y9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9824>>3]=(+h[b+1064>>3]+ +h[b+1072>>3])*.5;i=i;return}function Z9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1080>>3]=+h[b+2136>>3];i=i;return}function _9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1088>>3]=+h[b+2136>>3];i=i;return}function $9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1096>>3]=+h[b+2136>>3];i=i;return}function aaa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1104>>3]=+h[b+2136>>3];i=i;return}function baa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1112>>3]=+h[b+2136>>3];i=i;return}function caa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0,u=0.0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0.0,E=0,F=0.0,G=0,H=0.0,I=0.0,J=0,K=0.0,L=0,M=0.0,N=0.0,O=0,P=0.0,Q=0,R=0.0,S=0.0,T=0,U=0.0,V=0,W=0.0,X=0.0,Y=0,Z=0.0,_=0,$=0.0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;j=d+24|0;k=d+32|0;l=d+40|0;m=b+536|0;n=c[m>>2]|0;o=b+416|0;p=c[o>>2]|0;q=+h[p+2216>>3];r=+h[p+2256>>3];do{if(q!=0.0){s=q;t=p;u=r/q}else{if(r==0.0){s=q;t=p;u=r;break}v=r/+nwa(n,q,69824,69816,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);w=c[o>>2]|0;s=+h[w+2216>>3];t=w;u=v}}while(0);q=+h[t+2296>>3];r=+h[t+2304>>3];p=b+4|0;w=c[c[p>>2]>>2]|0;v=+h[(c[w+8>>2]|0)+10440>>3];x=+h[t+1040>>3];y=+h[t+1080>>3];z=(y+y)*.5;y=+h[t+2264>>3];do{if(s!=0.0){A=t;B=y/s}else{if(y==0.0){A=t;B=y;break}C=y/+nwa(c[m>>2]|0,s,69824,69816,+h[w>>3],(a[b+319|0]|0)!=0|0);A=c[o>>2]|0;B=C}}while(0);Iz(e,n,u,q,q,r,r,v,x,z,B,+h[A+2240>>3]);B=+h[e>>3];e=c[m>>2]|0;A=c[o>>2]|0;z=+h[A+2216>>3];x=+h[A+2256>>3];do{if(z!=0.0){D=z;E=A;F=x/z}else{if(x==0.0){D=z;E=A;F=x;break}v=x/+nwa(e,z,69824,69816,+h[c[c[p>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);n=c[o>>2]|0;D=+h[n+2216>>3];E=n;F=v}}while(0);z=+h[E+2296>>3];x=+h[E+2304>>3];A=c[c[p>>2]>>2]|0;n=c[A+8>>2]|0;v=+h[n+10448>>3];r=+h[n+9848>>3];q=(+h[E+1080>>3]+ +h[E+1088>>3])*.5;u=+h[E+2264>>3];do{if(D!=0.0){G=E;H=u/D}else{if(u==0.0){G=E;H=u;break}s=u/+nwa(c[m>>2]|0,D,69824,69816,+h[A>>3],(a[b+319|0]|0)!=0|0);G=c[o>>2]|0;H=s}}while(0);Iz(f,e,F,z,z,x,x,v,r,q,H,+h[G+2240>>3]);H=+h[f>>3];f=c[m>>2]|0;G=c[o>>2]|0;q=+h[G+2216>>3];r=+h[G+2256>>3];do{if(q!=0.0){I=q;J=G;K=r/q}else{if(r==0.0){I=q;J=G;K=r;break}v=r/+nwa(f,q,69824,69816,+h[c[c[p>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);e=c[o>>2]|0;I=+h[e+2216>>3];J=e;K=v}}while(0);q=+h[J+2296>>3];r=+h[J+2304>>3];G=c[c[p>>2]>>2]|0;e=c[G+8>>2]|0;v=+h[e+10456>>3];x=+h[e+9840>>3];z=(+h[J+1088>>3]+ +h[J+1096>>3])*.5;F=+h[J+2264>>3];do{if(I!=0.0){L=J;M=F/I}else{if(F==0.0){L=J;M=F;break}D=F/+nwa(c[m>>2]|0,I,69824,69816,+h[G>>3],(a[b+319|0]|0)!=0|0);L=c[o>>2]|0;M=D}}while(0);Iz(g,f,K,q,q,r,r,v,x,z,M,+h[L+2240>>3]);M=+h[g>>3];g=c[m>>2]|0;L=c[o>>2]|0;z=+h[L+2216>>3];x=+h[L+2256>>3];do{if(z!=0.0){N=z;O=L;P=x/z}else{if(x==0.0){N=z;O=L;P=x;break}v=x/+nwa(g,z,69824,69816,+h[c[c[p>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);f=c[o>>2]|0;N=+h[f+2216>>3];O=f;P=v}}while(0);z=+h[O+2296>>3];x=+h[O+2304>>3];L=c[c[p>>2]>>2]|0;f=c[L+8>>2]|0;v=+h[f+10464>>3];r=+h[f+9832>>3];q=(+h[O+1096>>3]+ +h[O+1104>>3])*.5;K=+h[O+2264>>3];do{if(N!=0.0){Q=O;R=K/N}else{if(K==0.0){Q=O;R=K;break}I=K/+nwa(c[m>>2]|0,N,69824,69816,+h[L>>3],(a[b+319|0]|0)!=0|0);Q=c[o>>2]|0;R=I}}while(0);Iz(j,g,P,z,z,x,x,v,r,q,R,+h[Q+2240>>3]);R=+h[j>>3];j=c[m>>2]|0;Q=c[o>>2]|0;q=+h[Q+2216>>3];r=+h[Q+2256>>3];do{if(q!=0.0){S=q;T=Q;U=r/q}else{if(r==0.0){S=q;T=Q;U=r;break}v=r/+nwa(j,q,69824,69816,+h[c[c[p>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);g=c[o>>2]|0;S=+h[g+2216>>3];T=g;U=v}}while(0);q=+h[T+2296>>3];r=+h[T+2304>>3];Q=c[c[p>>2]>>2]|0;g=c[Q+8>>2]|0;v=+h[g+10472>>3];x=+h[g+9824>>3];z=(+h[T+1104>>3]+ +h[T+1112>>3])*.5;P=+h[T+2264>>3];do{if(S!=0.0){V=T;W=P/S}else{if(P==0.0){V=T;W=P;break}N=P/+nwa(c[m>>2]|0,S,69824,69816,+h[Q>>3],(a[b+319|0]|0)!=0|0);V=c[o>>2]|0;W=N}}while(0);Iz(k,j,U,q,q,r,r,v,x,z,W,+h[V+2240>>3]);W=+h[k>>3];k=c[m>>2]|0;V=c[o>>2]|0;z=+h[V+2216>>3];x=+h[V+2256>>3];do{if(z!=0.0){X=z;Y=V;Z=x/z}else{if(x==0.0){X=z;Y=V;Z=x;break}v=x/+nwa(k,z,69824,69816,+h[c[c[p>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);j=c[o>>2]|0;X=+h[j+2216>>3];Y=j;Z=v}}while(0);z=+h[Y+2296>>3];x=+h[Y+2304>>3];V=c[c[p>>2]>>2]|0;v=+h[(c[V+8>>2]|0)+10480>>3];r=+h[Y+1072>>3];q=+h[Y+1112>>3];U=(q+q)*.5;q=+h[Y+2264>>3];if(X!=0.0){_=Y;$=q/X;aa=_;ba=aa+2240|0;ca=ba;da=+h[ca>>3];Iz(l,k,Z,z,z,x,x,v,r,U,$,da);ea=l;fa=ea;ga=+h[fa>>3];ha=W+ga;ia=R+ha;ja=M+ia;ka=H+ja;la=B+ka;ma=c[p>>2]|0;na=c[ma>>2]|0;oa=na;pa=oa+8|0;qa=pa;ra=c[qa>>2]|0;sa=ra;ta=sa+10848|0;ua=ta;h[ua>>3]=la;i=d;return}if(q==0.0){_=Y;$=q;aa=_;ba=aa+2240|0;ca=ba;da=+h[ca>>3];Iz(l,k,Z,z,z,x,x,v,r,U,$,da);ea=l;fa=ea;ga=+h[fa>>3];ha=W+ga;ia=R+ha;ja=M+ia;ka=H+ja;la=B+ka;ma=c[p>>2]|0;na=c[ma>>2]|0;oa=na;pa=oa+8|0;qa=pa;ra=c[qa>>2]|0;sa=ra;ta=sa+10848|0;ua=ta;h[ua>>3]=la;i=d;return}S=q/+nwa(c[m>>2]|0,X,69824,69816,+h[V>>3],(a[b+319|0]|0)!=0|0);_=c[o>>2]|0;$=S;aa=_;ba=aa+2240|0;ca=ba;da=+h[ca>>3];Iz(l,k,Z,z,z,x,x,v,r,U,$,da);ea=l;fa=ea;ga=+h[fa>>3];ha=W+ga;ia=R+ha;ja=M+ia;ka=H+ja;la=B+ka;ma=c[p>>2]|0;na=c[ma>>2]|0;oa=na;pa=oa+8|0;qa=pa;ra=c[qa>>2]|0;sa=ra;ta=sa+10848|0;ua=ta;h[ua>>3]=la;i=d;return}function daa(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+127|0]=a[d+113|0]|0;i=i;return}function eaa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2320>>3]=+h[b+2112>>3];i=i;return}function faa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2328>>3]=+h[b+1344>>3];i=i;return}function gaa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[69856]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+1320>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(69872,Iwa(+h[(c[g>>2]|0)+1320>>3],69864)|0)|0;g=c[63882]|0;j=e;k=70424;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[69856]=1;i=d;return}function haa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[70040]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+1296>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(70048,Iwa(+h[(c[g>>2]|0)+1296>>3],69864)|0)|0;g=c[63882]|0;j=e;k=70424;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[70040]=1;i=d;return}function iaa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[70136]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+1272>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(70144,Iwa(+h[(c[g>>2]|0)+1272>>3],69864)|0)|0;g=c[63882]|0;j=e;k=70424;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[70136]=1;i=d;return}function jaa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[70232]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+1248>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(70240,Iwa(+h[(c[g>>2]|0)+1248>>3],69864)|0)|0;g=c[63882]|0;j=e;k=70424;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[70232]=1;i=d;return}function kaa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[70328]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+1224>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(70336,Iwa(+h[(c[g>>2]|0)+1224>>3],69864)|0)|0;g=c[63882]|0;j=e;k=70424;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[70328]=1;i=d;return}function laa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[70448]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+2360>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(70456,Iwa(+h[(c[g>>2]|0)+2360>>3],69864)|0)|0;g=c[63882]|0;j=e;k=70616;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[70448]=1;i=d;return}function maa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[70640]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+1208>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+1208>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(70648,Iwa(+h[(c[g>>2]|0)+1208>>3],69864)|0)|0;g=c[63882]|0;j=e;k=93792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[70640]=1;i=d;return}function naa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[70832]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+1200>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+1200>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(70840,Iwa(+h[(c[g>>2]|0)+1200>>3],69864)|0)|0;g=c[63882]|0;j=e;k=93792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[70832]=1;i=d;return}function oaa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[70952]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+2344>>3],1.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+2344>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=Owa(70960,Iwa(+h[(c[g>>2]|0)+2344>>3],69864)|0)|0;g=c[63882]|0;j=e;k=93936;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[70952]=1;i=d;return}function paa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[71072]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+2336>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+2336>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(71080,Iwa(+h[(c[g>>2]|0)+2336>>3],69864)|0)|0;g=c[63882]|0;j=e;k=94080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[71072]=1;i=d;return}function qaa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[71192]&1){i=d;return}g=b+420|0;b=Dza(+(c[(c[g>>2]|0)+288>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Bza(+(c[(c[g>>2]|0)+288>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=Owa(71208,Kwa(c[(c[g>>2]|0)+288>>2]|0,71200)|0)|0;g=c[63882]|0;h=e;j=94344;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[71192]=1;i=d;return}function raa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[71440]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+2328>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(71448,Iwa(+h[(c[g>>2]|0)+2328>>3],69864)|0)|0;g=c[63882]|0;j=e;k=87704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[71440]=1;i=d;return}function saa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[71648]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+1112>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(71656,Iwa(+h[(c[g>>2]|0)+1112>>3],69864)|0)|0;g=c[63882]|0;j=e;k=88288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[71648]=1;i=d;return}function taa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[71832]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+1104>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(71840,Iwa(+h[(c[g>>2]|0)+1104>>3],69864)|0)|0;g=c[63882]|0;j=e;k=88288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[71832]=1;i=d;return}function uaa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[71944]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+1096>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(71952,Iwa(+h[(c[g>>2]|0)+1096>>3],69864)|0)|0;g=c[63882]|0;j=e;k=88288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[71944]=1;i=d;return}function vaa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72056]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+1088>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(72064,Iwa(+h[(c[g>>2]|0)+1088>>3],69864)|0)|0;g=c[63882]|0;j=e;k=88288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[72056]=1;i=d;return}function waa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72168]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+1080>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(72176,Iwa(+h[(c[g>>2]|0)+1080>>3],69864)|0)|0;g=c[63882]|0;j=e;k=88288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[72168]=1;i=d;return}function xaa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72280]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+2304>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(72288,Iwa(+h[(c[g>>2]|0)+2304>>3],69864)|0)|0;g=c[63882]|0;j=e;k=88432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[72280]=1;i=d;return}function yaa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72400]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+2296>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(72408,Iwa(+h[(c[g>>2]|0)+2296>>3],69864)|0)|0;g=c[63882]|0;j=e;k=88576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[72400]=1;i=d;return}function zaa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72520]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+2288>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+2288>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Owa(72528,Iwa(+h[(c[g>>2]|0)+2288>>3],69864)|0)|0;g=c[63882]|0;j=e;k=88776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[72520]=1;i=d;return}function Aaa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72696]&1){i=d;return}g=b+420|0;b=Dza(+(c[(c[g>>2]|0)+276>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Bza(+(c[(c[g>>2]|0)+276>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=Owa(72704,Kwa(c[(c[g>>2]|0)+276>>2]|0,71200)|0)|0;g=c[63882]|0;h=e;j=89064;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[72696]=1;i=d;return}function Baa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72960]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+2272>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(72968,Iwa(+h[(c[g>>2]|0)+2272>>3],69864)|0)|0;g=c[63882]|0;j=e;k=89208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[72960]=1;i=d;return}function Caa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73080]&1){i=d;return}g=b+416|0;if(!((Dza(+h[(c[g>>2]|0)+2248>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Owa(73088,Iwa(+h[(c[g>>2]|0)+2248>>3],69864)|0)|0;g=c[63882]|0;j=e;k=89352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[73080]=1;i=d;return}function Daa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73200]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+2232>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+2232>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(73208,Iwa(+h[(c[g>>2]|0)+2232>>3],69864)|0)|0;g=c[63882]|0;j=e;k=89544;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[73200]=1;i=d;return}function Eaa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73368]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+2224>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+2224>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(73376,Iwa(+h[(c[g>>2]|0)+2224>>3],69864)|0)|0;g=c[63882]|0;j=e;k=89736;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[73368]=1;i=d;return}function Faa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73536]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+952>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+952>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(73544,Iwa(+h[(c[g>>2]|0)+952>>3],69864)|0)|0;g=c[63882]|0;j=e;k=90480;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[73536]=1;i=d;return}function Gaa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73680]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+944>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+944>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(73688,Iwa(+h[(c[g>>2]|0)+944>>3],69864)|0)|0;g=c[63882]|0;j=e;k=90480;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[73680]=1;i=d;return}function Haa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73824]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+936>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+936>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(73832,Iwa(+h[(c[g>>2]|0)+936>>3],69864)|0)|0;g=c[63882]|0;j=e;k=90480;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[73824]=1;i=d;return}function Iaa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73968]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+928>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+928>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(73976,Iwa(+h[(c[g>>2]|0)+928>>3],69864)|0)|0;g=c[63882]|0;j=e;k=90480;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[73968]=1;i=d;return}function Jaa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[74112]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+920>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+920>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(74120,Iwa(+h[(c[g>>2]|0)+920>>3],69864)|0)|0;g=c[63882]|0;j=e;k=90480;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[74112]=1;i=d;return}function Kaa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[74256]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+2200>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+2200>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Owa(74264,Iwa(+h[(c[g>>2]|0)+2200>>3],69864)|0)|0;g=c[63882]|0;j=e;k=90640;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[74256]=1;i=d;return}function Laa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[74392]&1){i=d;return}g=b+420|0;b=Dza(+(c[(c[g>>2]|0)+260>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Bza(+(c[(c[g>>2]|0)+260>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=Owa(74400,Kwa(c[(c[g>>2]|0)+260>>2]|0,71200)|0)|0;g=c[63882]|0;h=e;j=90888;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[74392]=1;i=d;return}function Maa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[74616]&1){i=d;return}g=b+420|0;b=Dza(+(c[(c[g>>2]|0)+256>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Bza(+(c[(c[g>>2]|0)+256>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=Owa(74624,Kwa(c[(c[g>>2]|0)+256>>2]|0,71200)|0)|0;g=c[63882]|0;h=e;j=91144;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[74616]=1;i=d;return}function Naa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[74848]&1){i=d;return}g=b+416|0;b=Dza(+h[(c[g>>2]|0)+912>>3],0.0)|0;if(!(b<<24>>24==0|(Bza(+h[(c[g>>2]|0)+912>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Owa(74856,Iwa(+h[(c[g>>2]|0)+912>>3],69864)|0)|0;g=c[63882]|0;j=e;k=91424;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[74848]=1;i=d;return}



function c_a(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0;d=i;i=i+424|0;e=d;f=d+8|0;g=d+72|0;h=d+328|0;j=d+336|0;k=d+384|0;l=d+392|0;m=c[b+4>>2]|0;n=m+12|0;o=c[n>>2]|0;if((c[b+40>>2]|0)==0){p=b+20|0;j_a(m,c[p>>2]|0)|0;j_a(m,2)|0;c[p>>2]=(c[p>>2]|0)+1}p=j_a(m,0)|0;q=b+12|0;r=b+16|0;c[r>>2]=c[q>>2];s=c[n>>2]|0;t=(p|0)==0;a:do{if((s|0)>(o|0)&t){u=m+16|0;v=b+36|0;w=b;x=b+24|0;y=b+20|0;z=g;A=f;B=b+28|0;C=l;D=k;E=k+1|0;F=j;G=b;H=j+12|0;I=j+40|0;J=j+24|0;K=j+8|0;L=s;M=0;N=0;b:while(1){O=L+ -1|0;c[n>>2]=O;P=c[u>>2]|0;c:do{switch(c[P+(O<<2)>>2]|0){case 5:{Q=c[q>>2]|0;R=a[Q]|0;if(R<<24>>24==0){S=M;T=N;U=0;break c}V=c[v>>2]&1;W=(V|0)!=0;if(W&R<<24>>24==124){S=M;T=N;U=0;break c}do{if(!(W&R<<24>>24==41&(M|0)>0)){if((V|0)==0&R<<24>>24==92){if((a[Q+1|0]|0)==41){break}}X=j_a(m,5)|0;if((X|0)!=0){Y=M;Z=X;_=6;break b}X=j_a(m,N)|0;if((X|0)!=0){Y=M;Z=X;_=6;break b}X=j_a(m,6)|0;if((X|0)!=0){Y=M;Z=X;_=6;break b}S=M;T=N;U=j_a(m,4)|0;break c}}while(0);R=(V|M|0)==0?8:0;W=M+ -1|0;if((V|0)!=0){S=W;T=N;U=R;break c}c[q>>2]=Q+2;S=W;T=N;U=R;break};case 6:{R=L+ -2|0;c[n>>2]=R;W=c[P+(R<<2)>>2]|0;R=c[w>>2]|0;X=t_a(R,0,0,1,32)|0;if((X|0)==0){$=12;_=294;break b}aa=t_a(R,0,0,1,8)|0;R=X+4|0;c[R>>2]=aa;if((aa|0)==0){$=12;_=294;break b}c[X>>2]=1;c[X+8>>2]=-1;c[X+12>>2]=-1;c[aa>>2]=W;c[(c[R>>2]|0)+4>>2]=N;c[X+16>>2]=(c[N+16>>2]|0)+(c[W+16>>2]|0);S=M;T=X;U=0;break};case 2:{X=L+ -2|0;c[n>>2]=X;W=c[P+(X<<2)>>2]|0;if((c[N+12>>2]|0)>-1){X=c[w>>2]|0;R=t_a(X,0,0,1,32)|0;if((R|0)==0){$=12;_=294;break b}aa=t_a(X,0,0,1,20)|0;c[R+4>>2]=aa;if((aa|0)==0){$=12;_=294;break b}c[R>>2]=0;c[R+8>>2]=-1;c[R+12>>2]=-1;c[aa>>2]=-1;c[aa+4>>2]=-1;c[aa+8>>2]=-1;aa=c[w>>2]|0;X=t_a(aa,0,0,1,32)|0;if((X|0)==0){$=12;_=294;break b}ba=t_a(aa,0,0,1,8)|0;aa=X+4|0;c[aa>>2]=ba;if((ba|0)==0){$=12;_=294;break b}c[X>>2]=1;c[X+8>>2]=-1;c[X+12>>2]=-1;c[ba>>2]=R;c[(c[aa>>2]|0)+4>>2]=N;aa=N+16|0;ba=X+16|0;c[ba>>2]=(c[aa>>2]|0)+(c[R+16>>2]|0);c[ba>>2]=c[aa>>2];ca=X}else{ca=N}c[ca+12>>2]=W;W=ca+16|0;c[W>>2]=(c[W>>2]|0)+1;S=M;T=ca;U=0;break};case 10:{W=L+ -2|0;c[n>>2]=W;c[v>>2]=c[P+(W<<2)>>2];S=M;T=N;U=0;break};case 9:{W=c[q>>2]|0;X=a[W]|0;switch(X<<24>>24|0){case 92:{aa=c[v>>2]|0;if((aa&1|0)!=0){S=M;T=N;U=0;break c}ba=W+1|0;if((a[ba]|0)!=123){S=M;T=N;U=0;break c}c[q>>2]=ba;da=aa;ea=ba;break};case 63:case 43:{if((c[v>>2]&1|0)==0){S=M;T=N;U=0;break c}else{_=41}break};case 42:{_=41;break};case 123:{ba=c[v>>2]|0;if((ba&1|0)==0){S=M;T=N;U=0;break c}else{da=ba;ea=W}break};default:{S=M;T=N;U=0;break c}}if((_|0)==41){_=0;c[q>>2]=W+1;W=c[w>>2]|0;ba=t_a(W,0,0,1,32)|0;if((ba|0)==0){$=12;_=294;break b}aa=t_a(W,0,0,1,16)|0;c[ba+4>>2]=aa;if((aa|0)==0){$=12;_=294;break b}c[ba>>2]=2;c[ba+8>>2]=-1;c[ba+12>>2]=-1;c[aa>>2]=N;c[aa+4>>2]=X<<24>>24==43;c[aa+8>>2]=X<<24>>24==63?1:-1;X=aa+12|0;a[X]=a[X]&-2;c[ba+16>>2]=c[N+16>>2];S=M;T=ba;U=j_a(m,9)|0;break c}ba=ea+1|0;c[q>>2]=ba;X=a[ba]|0;if((X+ -48<<24>>24&255)<10){aa=X<<24>>24;if((aa+ -48|0)>>>0<10){fa=aa;ga=-1;ha=ba}else{$=10;_=294;break b}while(1){aa=((ga|0)<0?-48:(ga*10|0)+ -48|0)+fa|0;W=ha+1|0;R=a[W]|0;ia=R<<24>>24;if((ia+ -48|0)>>>0<10){ha=W;ga=aa;fa=ia}else{ja=R;ka=aa;la=W;break}}}else{ja=X;ka=-1;la=ba}do{if(ja<<24>>24==44){Q=la+1|0;V=a[Q]|0;W=V<<24>>24;if((W+ -48|0)>>>0<10){ma=W;na=-1;oa=Q}else{pa=V;qa=-1;ra=Q;break}while(1){Q=((na|0)<0?-48:(na*10|0)+ -48|0)+ma|0;V=oa+1|0;W=a[V]|0;aa=W<<24>>24;if((aa+ -48|0)>>>0<10){oa=V;na=Q;ma=aa}else{sa=W;ta=Q;ua=V;_=54;break}}}else{sa=ja;ta=ka;ua=la;_=54}}while(0);do{if((_|0)==54){_=0;if(!((ta|0)>-1)){pa=sa;qa=ta;ra=ua;break}if((ka|0)>(ta|0)|(ta|0)>255){$=10;_=294;break b}else{pa=sa;qa=ta;ra=ua}}}while(0);if(pa<<24>>24==0){$=9;_=294;break b}if((ra|0)==(ba|0)){$=10;_=294;break b}if((da&1|0)==0){if(!(pa<<24>>24==92)){$=10;_=294;break b}if((a[ra+1|0]|0)!=125){$=10;_=294;break b}va=ra+2|0}else{if(!(pa<<24>>24==125)){$=10;_=294;break b}va=ra+1|0}if((qa|ka|0)==0){X=c[w>>2]|0;V=t_a(X,0,0,1,32)|0;if((V|0)==0){$=12;_=294;break b}Q=t_a(X,0,0,1,20)|0;c[V+4>>2]=Q;if((Q|0)==0){$=12;_=294;break b}c[V>>2]=0;c[V+8>>2]=-1;c[V+12>>2]=-1;c[Q>>2]=-1;c[Q+4>>2]=-1;c[Q+8>>2]=-1;wa=V}else{V=(qa&ka|0)<0;Q=c[w>>2]|0;X=t_a(Q,0,0,1,32)|0;if((X|0)==0){$=12;_=294;break b}W=t_a(Q,0,0,1,16)|0;c[X+4>>2]=W;if((W|0)==0){$=12;_=294;break b}c[X>>2]=2;c[X+8>>2]=-1;c[X+12>>2]=-1;c[W>>2]=N;c[W+4>>2]=V?1:ka;c[W+8>>2]=V?1:qa;V=W+12|0;a[V]=a[V]&-2;c[X+16>>2]=c[N+16>>2];wa=X}c[q>>2]=va;S=M;T=wa;U=j_a(m,9)|0;break};case 3:{X=j_a(m,5)|0;if((X|0)!=0){Y=M;Z=X;_=6;break b}S=M;T=N;U=j_a(m,4)|0;break};case 7:{X=c[q>>2]|0;V=a[X]|0;if((V|0)==41){c[q>>2]=X+1;S=M;T=N;U=0;break c}else if((V|0)!=124){S=M;T=N;U=0;break c}V=j_a(m,7)|0;if((V|0)!=0){Y=M;Z=V;_=6;break b}V=j_a(m,N)|0;if((V|0)!=0){Y=M;Z=V;_=6;break b}V=j_a(m,8)|0;if((V|0)!=0){Y=M;Z=V;_=6;break b}V=j_a(m,3)|0;if((V|0)!=0){Y=M;Z=V;_=6;break b}c[q>>2]=(c[q>>2]|0)+1;S=M;T=N;U=0;break};case 1:{V=c[q>>2]|0;d:do{switch(a[V]|0){case 46:{X=(c[v>>2]&4|0)==0;W=c[w>>2]|0;Q=c[x>>2]|0;aa=t_a(W,0,0,1,32)|0;R=aa;ia=(aa|0)==0;if(X){if(ia){$=12;_=294;break b}X=t_a(W,0,0,1,20)|0;c[aa+4>>2]=X;if((X|0)==0){$=12;_=294;break b}c[aa>>2]=0;c[aa+8>>2]=-1;c[aa+12>>2]=-1;c[X>>2]=0;c[X+4>>2]=1114111;c[X+8>>2]=Q;xa=R;ya=(c[x>>2]|0)+1|0}else{if(ia){$=12;_=294;break b}ia=t_a(W,0,0,1,20)|0;c[aa+4>>2]=ia;if((ia|0)==0){$=12;_=294;break b}c[aa>>2]=0;c[aa+8>>2]=-1;c[aa+12>>2]=-1;c[ia>>2]=0;c[ia+4>>2]=9;c[ia+8>>2]=Q;Q=c[w>>2]|0;ia=(c[x>>2]|0)+1|0;W=t_a(Q,0,0,1,32)|0;if((W|0)==0){$=12;_=294;break b}X=t_a(Q,0,0,1,20)|0;c[W+4>>2]=X;if((X|0)==0){$=12;_=294;break b}c[W>>2]=0;c[W+8>>2]=-1;c[W+12>>2]=-1;c[X>>2]=11;c[X+4>>2]=1114111;c[X+8>>2]=ia;ia=c[w>>2]|0;X=t_a(ia,0,0,1,32)|0;if((X|0)==0){$=12;_=294;break b}Q=t_a(ia,0,0,1,8)|0;ia=X+4|0;c[ia>>2]=Q;if((Q|0)==0){$=12;_=294;break b}c[X>>2]=3;c[X+8>>2]=-1;c[X+12>>2]=-1;c[Q>>2]=R;c[(c[ia>>2]|0)+4>>2]=W;c[X+16>>2]=(c[W+16>>2]|0)+(c[aa+16>>2]|0);xa=X;ya=(c[x>>2]|0)+2|0}c[x>>2]=ya;c[q>>2]=(c[q>>2]|0)+1;S=M;T=xa;U=0;break c;break};case 92:{X=V+1|0;aa=a[X]|0;do{if((c[v>>2]&1|0)==0){if(aa<<24>>24==40){c[q>>2]=X;za=X;_=74;break d}else{W=a[V+1|0]|0;if(W<<24>>24==41){_=265;break d}else{Aa=W;break}}}else{Aa=aa}}while(0);aa=V+1|0;X=Aa<<24>>24==0;if(X){$=5;_=294;break b}else{Ba=295388|0;Ca=0}while(1){W=Ca+1|0;if((a[295384+(Ca<<3)|0]|0)==Aa<<24>>24){Da=Ba;break}ia=295388+(W<<3)|0;if((W|0)==12){Da=ia;break}else{Ba=ia;Ca=W}}W=c[Da>>2]|0;if((W|0)!=0){ia=F+0|0;R=G+0|0;Q=ia+40|0;do{c[ia>>2]=c[R>>2];ia=ia+4|0;R=R+4|0}while((ia|0)<(Q|0));c[H>>2]=W;c[I>>2]=1;R=c_a(j)|0;if((R|0)!=0){$=R;_=294;break b}c[q>>2]=(c[q>>2]|0)+2;c[x>>2]=c[J>>2];S=M;T=c[K>>2]|0;U=0;break c}if(X){$=5;_=294;break b}c[q>>2]=aa;R=a[aa]|0;e:do{switch(R|0){case 62:{ia=c[w>>2]|0;Q=t_a(ia,0,0,1,32)|0;Ea=Q;do{if((Q|0)==0){Fa=0}else{Ga=t_a(ia,0,0,1,20)|0;c[Q+4>>2]=Ga;if((Ga|0)==0){Fa=0;break}c[Q>>2]=0;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[Ga>>2]=-2;c[Ga+4>>2]=32;c[Ga+8>>2]=-1;Fa=Ea}}while(0);c[q>>2]=(c[q>>2]|0)+1;Ha=Fa;break};case 66:{Ea=c[w>>2]|0;Q=t_a(Ea,0,0,1,32)|0;ia=Q;do{if((Q|0)==0){Ia=0}else{Ga=t_a(Ea,0,0,1,20)|0;c[Q+4>>2]=Ga;if((Ga|0)==0){Ia=0;break}c[Q>>2]=0;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[Ga>>2]=-2;c[Ga+4>>2]=128;c[Ga+8>>2]=-1;Ia=ia}}while(0);c[q>>2]=(c[q>>2]|0)+1;Ha=Ia;break};case 120:{ia=V+2|0;c[q>>2]=ia;Q=a[ia]|0;if(Q<<24>>24==123){ia=V+3|0;c[q>>2]=ia;Ea=ia;ia=0;while(1){Ga=a[Ea]|0;if(Ga<<24>>24==0|Ga<<24>>24==125){Ja=ia;Ka=Ea;break}if((RZa(Ga<<24>>24)|0)==0){$=9;_=294;break b}Ga=c[q>>2]|0;a[l+ia|0]=a[Ga]|0;La=ia+1|0;Ma=Ga+1|0;c[q>>2]=Ma;if(La>>>0>31){Ja=La;Ka=Ma;break}else{Ea=Ma;ia=La}}c[q>>2]=Ka+1;a[l+Ja|0]=0;ia=Yb(C|0,0,16)|0;Ea=c[w>>2]|0;La=c[x>>2]|0;Ma=t_a(Ea,0,0,1,32)|0;Ga=Ma;do{if((Ma|0)==0){Na=0}else{Oa=t_a(Ea,0,0,1,20)|0;c[Ma+4>>2]=Oa;if((Oa|0)==0){Na=0;break}c[Ma>>2]=0;c[Ma+8>>2]=-1;c[Ma+12>>2]=-1;c[Oa>>2]=ia;c[Oa+4>>2]=ia;c[Oa+8>>2]=La;Na=Ga}}while(0);c[x>>2]=(c[x>>2]|0)+1;Ha=Na;break e}else{a[D+0|0]=0;a[D+1|0]=0;a[D+2|0]=0;Ga=(RZa(Q<<24>>24)|0)==0;La=c[q>>2]|0;if(Ga){Pa=La}else{a[D]=a[La]|0;Ga=La+1|0;c[q>>2]=Ga;Pa=Ga}if((RZa(a[Pa]|0)|0)!=0){Ga=c[q>>2]|0;a[E]=a[Ga]|0;c[q>>2]=Ga+1}Ga=Yb(D|0,0,16)|0;La=c[w>>2]|0;ia=c[x>>2]|0;Ma=t_a(La,0,0,1,32)|0;Ea=Ma;do{if((Ma|0)==0){Qa=0}else{Oa=t_a(La,0,0,1,20)|0;c[Ma+4>>2]=Oa;if((Oa|0)==0){Qa=0;break}c[Ma>>2]=0;c[Ma+8>>2]=-1;c[Ma+12>>2]=-1;c[Oa>>2]=Ga;c[Oa+4>>2]=Ga;c[Oa+8>>2]=ia;Qa=Ea}}while(0);c[x>>2]=(c[x>>2]|0)+1;Ha=Qa;break e}break};case 60:{Ea=c[w>>2]|0;ia=t_a(Ea,0,0,1,32)|0;Ga=ia;do{if((ia|0)==0){Ra=0}else{Ma=t_a(Ea,0,0,1,20)|0;c[ia+4>>2]=Ma;if((Ma|0)==0){Ra=0;break}c[ia>>2]=0;c[ia+8>>2]=-1;c[ia+12>>2]=-1;c[Ma>>2]=-2;c[Ma+4>>2]=16;c[Ma+8>>2]=-1;Ra=Ga}}while(0);c[q>>2]=(c[q>>2]|0)+1;Ha=Ra;break};case 98:{Ga=c[w>>2]|0;ia=t_a(Ga,0,0,1,32)|0;Ea=ia;do{if((ia|0)==0){Sa=0}else{Ma=t_a(Ga,0,0,1,20)|0;c[ia+4>>2]=Ma;if((Ma|0)==0){Sa=0;break}c[ia>>2]=0;c[ia+8>>2]=-1;c[ia+12>>2]=-1;c[Ma>>2]=-2;c[Ma+4>>2]=64;c[Ma+8>>2]=-1;Sa=Ea}}while(0);c[q>>2]=(c[q>>2]|0)+1;Ha=Sa;break};default:{if((KZa(R)|0)!=0){Ea=(a[c[q>>2]|0]|0)+ -48|0;ia=c[w>>2]|0;Ga=c[x>>2]|0;Ma=t_a(ia,0,0,1,32)|0;if((Ma|0)==0){$=12;_=294;break b}La=t_a(ia,0,0,1,20)|0;c[Ma+4>>2]=La;if((La|0)==0){$=12;_=294;break b}c[Ma>>2]=0;c[Ma+8>>2]=-1;c[Ma+12>>2]=-1;c[La>>2]=-4;c[La+4>>2]=Ea;c[La+8>>2]=Ga;c[x>>2]=(c[x>>2]|0)+1;Ga=c[B>>2]|0;c[B>>2]=(Ea|0)<(Ga|0)?Ga:Ea;c[q>>2]=(c[q>>2]|0)+1;S=M;T=Ma;U=0;break c}Ma=c[w>>2]|0;Ea=a[c[q>>2]|0]|0;Ga=c[x>>2]|0;La=t_a(Ma,0,0,1,32)|0;ia=La;do{if((La|0)==0){Ta=0}else{Q=t_a(Ma,0,0,1,20)|0;c[La+4>>2]=Q;if((Q|0)==0){Ta=0;break}c[La>>2]=0;c[La+8>>2]=-1;c[La+12>>2]=-1;c[Q>>2]=Ea;c[Q+4>>2]=Ea;c[Q+8>>2]=Ga;Ta=ia}}while(0);c[x>>2]=(c[x>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+1;Ha=Ta}}}while(0);if((Ha|0)==0){$=12;_=294;break b}else{S=M;T=Ha;U=0;break c}break};case 40:{if((c[v>>2]&1|0)!=0){za=V;_=74}break};case 36:{if((c[v>>2]&1|0)==0){if((a[V+1|0]|0)!=0){break d}}R=c[w>>2]|0;aa=t_a(R,0,0,1,32)|0;if((aa|0)==0){$=12;_=294;break b}X=t_a(R,0,0,1,20)|0;c[aa+4>>2]=X;if((X|0)==0){$=12;_=294;break b}c[aa>>2]=0;c[aa+8>>2]=-1;c[aa+12>>2]=-1;c[X>>2]=-2;c[X+4>>2]=2;c[X+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;S=M;T=aa;U=0;break c;break};case 63:case 43:case 123:case 124:case 42:{_=264;break};case 0:{_=265;break};case 41:{if((M|0)!=0){_=264}break};case 94:{if((c[v>>2]&1|0)==0){if((V|0)!=(c[r>>2]|0)){break d}aa=j_a(m,5)|0;if((aa|0)!=0){Y=M;Z=aa;_=6;break b}}aa=c[w>>2]|0;X=t_a(aa,0,0,1,32)|0;if((X|0)==0){$=12;_=294;break b}R=t_a(aa,0,0,1,20)|0;c[X+4>>2]=R;if((R|0)==0){$=12;_=294;break b}c[X>>2]=0;c[X+8>>2]=-1;c[X+12>>2]=-1;c[R>>2]=-2;c[R+4>>2]=1;c[R+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;S=M;T=X;U=0;break c;break};case 91:{X=V+1|0;c[q>>2]=X;R=V_a(128)|0;if((R|0)==0){$=12;_=294;break b}if((a[X]|0)==94){aa=V+2|0;c[q>>2]=aa;Ua=aa;Va=1}else{Ua=X;Va=0}X=(Va|0)==0;aa=R;R=0;W=0;ia=32;Ga=Ua;f:while(1){Ea=a[Ga]|0;if(Ea<<24>>24==93){if(Ga>>>0>(c[q>>2]|0)>>>0){_=85;break}}else if(Ea<<24>>24==0){Wa=aa;Xa=Ga;Ya=7;_=140;break}Ea=ZZa(e,Ga,-1)|0;if((Ea|0)<0){c[e>>2]=-1;Za=1}else{Za=Ea}Ea=Ga+Za|0;do{if((a[Ea]|0)==45){La=Za+1|0;Ma=Ga+La|0;if((a[Ma]|0)==93){_=94;break}Q=c[e>>2]|0;Oa=ZZa(e,Ma,-1)|0;if((Oa|0)<0){c[e>>2]=-1;_a=-1;$a=1}else{_a=c[e>>2]|0;$a=Oa}ab=0;bb=_a;cb=Q;db=Ga+($a+La)|0;eb=Q>>>0>_a>>>0?11:0}else{_=94}}while(0);g:do{if((_|0)==94){_=0;Q=a[Ga]|0;do{if(Q<<24>>24==91){La=a[Ga+1|0]|0;if(La<<24>>24==61|La<<24>>24==46){Wa=aa;Xa=Ga;Ya=3;_=140;break f}else if(!(La<<24>>24==58)){fb=0;break}La=Ga+2|0;Oa=La;while(1){Ma=a[Oa]|0;gb=Ma<<24>>24==0;if(Ma<<24>>24!=58&(gb^1)){Oa=Oa+1|0}else{break}}if(gb){Wa=aa;Xa=Ga;Ya=4;_=140;break f}Ma=Oa-Ga+ -2|0;hb=(Ma|0)>63?63:Ma;I$a(A|0,La|0,hb|0)|0;a[f+hb|0]=0;hb=JZa(A)|0;ab=hb;bb=1114111;cb=0;db=Oa+2|0;eb=(hb|0)==0?4:0;break g}else if(Q<<24>>24==45){if((a[Ga+1|0]|0)==93){fb=0;break}fb=(c[q>>2]|0)==(Ga|0)?0:11}else{fb=0}}while(0);Q=c[e>>2]|0;ab=0;bb=Q;cb=Q;db=Ea;eb=fb}}while(0);if((eb|0)!=0){Wa=aa;Xa=db;Ya=eb;_=140;break}Ea=(ab|0)!=0;do{if(X|Ea^1){Q=c[w>>2]|0;if((W|0)<(ia|0)){ib=aa;jb=ia}else{if((ia|0)>1024){Wa=aa;Xa=db;Ya=12;_=140;break f}hb=Y_a(aa,ia<<3)|0;if((hb|0)==0){Wa=aa;Xa=db;Ya=12;_=140;break f}else{ib=hb;jb=ia<<1}}hb=t_a(Q,0,0,1,32)|0;if((hb|0)==0){_=112;break f}Ma=t_a(Q,0,0,1,20)|0;Q=hb+4|0;c[Q>>2]=Ma;if((Ma|0)==0){_=112;break f}c[hb>>2]=0;c[hb+8>>2]=-1;c[hb+12>>2]=-1;c[Ma>>2]=cb;c[Ma+4>>2]=bb;c[Ma+8>>2]=-1;c[ib+(W<<2)>>2]=hb;c[(c[Q>>2]|0)+12>>2]=ab;kb=ib;lb=R;mb=W+1|0;nb=jb;ob=0}else{if((R|0)>63){kb=aa;lb=R;mb=W;nb=ia;ob=12;break}c[g+(R<<2)>>2]=ab;kb=aa;lb=R+1|0;mb=W;nb=ia;ob=0}}while(0);Q=(ob|0)==0;if(Q&(((c[v>>2]&2|0)==0|Ea)^1)){pb=kb;qb=mb;rb=nb;sb=cb}else{if(Q){aa=kb;R=lb;W=mb;ia=nb;Ga=db;continue}else{Wa=kb;Xa=db;Ya=ob;_=140;break}}while(1){Q=sb;while(1){if(Q>>>0>bb>>>0){aa=pb;R=lb;W=qb;ia=rb;Ga=db;continue f}if((MZa(Q)|0)!=0){_=118;break}tb=Q+1|0;if((QZa(Q)|0)==0){Q=tb}else{_=129;break}}if((_|0)==118){_=0;hb=SZa(Q)|0;Ma=Q+1|0;h:do{if((MZa(Ma)|0)==0){ub=hb;vb=Ma}else{wb=hb;xb=Ma;while(1){if((SZa(xb)|0)!=(wb+1|0)|xb>>>0>bb>>>0){ub=wb;vb=xb;break h}yb=SZa(xb)|0;zb=xb+1|0;if((MZa(zb)|0)==0){ub=yb;vb=zb;break}else{wb=yb;xb=zb}}}}while(0);Ma=c[w>>2]|0;if((qb|0)<(rb|0)){Ab=pb;Bb=rb}else{if((rb|0)>1024){Wa=pb;Xa=db;Ya=12;_=140;break f}xb=Y_a(pb,rb<<3)|0;if((xb|0)==0){Wa=pb;Xa=db;Ya=12;_=140;break f}else{Ab=xb;Bb=rb<<1}}xb=t_a(Ma,0,0,1,32)|0;wb=xb;do{if((xb|0)==0){Cb=0}else{Oa=t_a(Ma,0,0,1,20)|0;c[xb+4>>2]=Oa;if((Oa|0)==0){Cb=0;break}c[xb>>2]=0;c[xb+8>>2]=-1;c[xb+12>>2]=-1;c[Oa>>2]=hb;c[Oa+4>>2]=ub;c[Oa+8>>2]=-1;Cb=wb}}while(0);c[Ab+(qb<<2)>>2]=Cb;Db=Cb;Eb=Ab;Fb=Bb;Gb=vb}else if((_|0)==129){_=0;wb=UZa(Q)|0;i:do{if((QZa(tb)|0)==0){Hb=wb;Ib=tb}else{hb=wb;xb=tb;while(1){if((UZa(xb)|0)!=(hb+1|0)|xb>>>0>bb>>>0){Hb=hb;Ib=xb;break i}Ma=xb+1|0;Oa=UZa(xb)|0;if((QZa(Ma)|0)==0){Hb=Oa;Ib=Ma;break}else{hb=Oa;xb=Ma}}}}while(0);Q=c[w>>2]|0;if((qb|0)<(rb|0)){Jb=pb;Kb=rb}else{if((rb|0)>1024){Wa=pb;Xa=db;Ya=12;_=140;break f}xb=Y_a(pb,rb<<3)|0;if((xb|0)==0){Wa=pb;Xa=db;Ya=12;_=140;break f}else{Jb=xb;Kb=rb<<1}}xb=t_a(Q,0,0,1,32)|0;hb=xb;do{if((xb|0)==0){Lb=0}else{Ma=t_a(Q,0,0,1,20)|0;c[xb+4>>2]=Ma;if((Ma|0)==0){Lb=0;break}c[xb>>2]=0;c[xb+8>>2]=-1;c[xb+12>>2]=-1;c[Ma>>2]=wb;c[Ma+4>>2]=Hb;c[Ma+8>>2]=-1;Lb=hb}}while(0);c[Jb+(qb<<2)>>2]=Lb;Db=Lb;Eb=Jb;Fb=Kb;Gb=Ib}if((Db|0)==0){_=141;break f}else{pb=Eb;qb=qb+1|0;rb=Fb;sb=Gb}}}j:do{if((_|0)==85){_=0;c[q>>2]=Ga+1;ia=(Va|0)!=0;if(ia){gc(aa|0,W|0,4,62)}k:do{if((W|0)>0){X=(R|0)>0;Ea=R<<2;hb=Ea+4|0;if(ia){Mb=0;Nb=0;Ob=0;Pb=0}else{wb=0;xb=0;while(1){Q=aa+(wb<<2)|0;Ma=c[(c[Q>>2]|0)+4>>2]|0;do{if((Ma|0)==0){Qb=xb;Rb=0}else{c[Ma+8>>2]=c[x>>2];if(X){Oa=t_a(c[w>>2]|0,0,0,0,hb)|0;La=Ma+16|0;c[La>>2]=Oa;if((Oa|0)==0){Sb=aa;Tb=xb;Ub=12;break j}z$a(Oa|0,z|0,Ea|0)|0;c[(c[La>>2]|0)+(R<<2)>>2]=0}else{c[Ma+16>>2]=0}if((xb|0)==0){Qb=c[Q>>2]|0;Rb=0;break}La=c[w>>2]|0;Oa=c[Q>>2]|0;zb=t_a(La,0,0,1,32)|0;yb=zb;do{if((zb|0)==0){Vb=0}else{Wb=t_a(La,0,0,1,8)|0;Xb=zb+4|0;c[Xb>>2]=Wb;if((Wb|0)==0){Vb=0;break}c[zb>>2]=3;c[zb+8>>2]=-1;c[zb+12>>2]=-1;c[Wb>>2]=xb;c[(c[Xb>>2]|0)+4>>2]=Oa;c[zb+16>>2]=(c[Oa+16>>2]|0)+(c[xb+16>>2]|0);Vb=yb}}while(0);Qb=Vb;Rb=(Vb|0)==0?12:0}}while(0);Q=wb+1|0;if((Q|0)<(W|0)&(Rb|0)==0){wb=Q;xb=Qb}else{Zb=0;_b=Qb;$b=Rb;break k}}}while(1){xb=aa+(Ob<<2)|0;wb=c[(c[xb>>2]|0)+4>>2]|0;Q=c[wb>>2]|0;Ma=wb+4|0;yb=c[Ma>>2]|0;do{if((Q|0)<(Mb|0)){Oa=yb+1|0;ac=(Oa|0)<(Mb|0)?Mb:Oa;bc=Nb;cc=Pb;dc=0}else{if((Q|0)<=(Nb|0)){Oa=yb+1|0;ac=Oa;bc=Oa;cc=Pb;dc=0;break}c[wb>>2]=Nb;c[Ma>>2]=Q+ -1;Oa=yb+1|0;if((wb|0)==0){ac=Oa;bc=Oa;cc=Pb;dc=0;break}c[wb+8>>2]=c[x>>2];if(X){zb=t_a(c[w>>2]|0,0,0,0,hb)|0;La=wb+16|0;c[La>>2]=zb;if((zb|0)==0){Sb=aa;Tb=Pb;Ub=12;break j}z$a(zb|0,z|0,Ea|0)|0;c[(c[La>>2]|0)+(R<<2)>>2]=0}else{c[wb+16>>2]=0}if((Pb|0)==0){ac=Oa;bc=Oa;cc=c[xb>>2]|0;dc=0;break}La=c[w>>2]|0;zb=c[xb>>2]|0;Xb=t_a(La,0,0,1,32)|0;Wb=Xb;do{if((Xb|0)==0){ec=0}else{fc=t_a(La,0,0,1,8)|0;hc=Xb+4|0;c[hc>>2]=fc;if((fc|0)==0){ec=0;break}c[Xb>>2]=3;c[Xb+8>>2]=-1;c[Xb+12>>2]=-1;c[fc>>2]=Pb;c[(c[hc>>2]|0)+4>>2]=zb;c[Xb+16>>2]=(c[zb+16>>2]|0)+(c[Pb+16>>2]|0);ec=Wb}}while(0);ac=Oa;bc=Oa;cc=ec;dc=(ec|0)==0?12:0}}while(0);xb=Ob+1|0;if((xb|0)<(W|0)&(dc|0)==0){Mb=ac;Nb=bc;Ob=xb;Pb=cc}else{Zb=bc;_b=cc;$b=dc;break}}}else{Zb=0;_b=0;$b=0}}while(0);if(($b|0)!=0|ia^1){Sb=aa;Tb=_b;Ub=$b;break}Ea=c[w>>2]|0;hb=c[x>>2]|0;X=t_a(Ea,0,0,1,32)|0;xb=X;if((X|0)==0){Sb=aa;Tb=_b;Ub=12;break}wb=t_a(Ea,0,0,1,20)|0;c[X+4>>2]=wb;if((wb|0)==0){Sb=aa;Tb=_b;Ub=12;break}c[X>>2]=0;c[X+8>>2]=-1;c[X+12>>2]=-1;c[wb>>2]=Zb;c[wb+4>>2]=1114111;c[wb+8>>2]=hb;if((R|0)>0){hb=R<<2;Ea=t_a(c[w>>2]|0,0,0,0,hb+4|0)|0;yb=wb+16|0;c[yb>>2]=Ea;if((Ea|0)==0){Sb=aa;Tb=_b;Ub=12;break}z$a(Ea|0,z|0,hb|0)|0;c[(c[yb>>2]|0)+(R<<2)>>2]=0}else{c[wb+16>>2]=0}if((_b|0)==0){Sb=aa;Tb=xb;Ub=0;break}wb=c[w>>2]|0;yb=t_a(wb,0,0,1,32)|0;hb=yb;do{if((yb|0)==0){ic=0}else{Ea=t_a(wb,0,0,1,8)|0;Q=yb+4|0;c[Q>>2]=Ea;if((Ea|0)==0){ic=0;break}c[yb>>2]=3;c[yb+8>>2]=-1;c[yb+12>>2]=-1;c[Ea>>2]=_b;c[(c[Q>>2]|0)+4>>2]=xb;c[yb+16>>2]=(c[X+16>>2]|0)+(c[_b+16>>2]|0);ic=hb}}while(0);Sb=aa;Tb=ic;Ub=(ic|0)==0?12:0}else if((_|0)==112){_=0;c[ib+(W<<2)>>2]=0;Wa=ib;Xa=db;Ya=12;_=140}else if((_|0)==141){_=0;c[q>>2]=db;Sb=Eb;Tb=0;Ub=12}}while(0);if((_|0)==140){_=0;c[q>>2]=Xa;Sb=Wa;Tb=0;Ub=Ya}W_a(Sb);c[x>>2]=(c[x>>2]|0)+1;if((Ub|0)==0){S=M;T=Tb;U=0;break c}else{$=Ub;_=294;break b}break};default:{}}}while(0);if((_|0)==74){_=0;ba=M+1|0;c[q>>2]=za+1;W=j_a(m,c[y>>2]|0)|0;if((W|0)!=0){Y=ba;Z=W;_=6;break b}W=j_a(m,2)|0;if((W|0)!=0){Y=ba;Z=W;_=6;break b}W=j_a(m,0)|0;if((W|0)!=0){Y=ba;Z=W;_=6;break b}c[y>>2]=(c[y>>2]|0)+1;S=ba;T=N;U=0;break c}else if((_|0)==264){_=0;if((c[v>>2]&1|0)!=0){_=265}}if((_|0)==265){_=0;ba=c[w>>2]|0;W=t_a(ba,0,0,1,32)|0;if((W|0)==0){$=12;_=294;break b}aa=t_a(ba,0,0,1,20)|0;c[W+4>>2]=aa;if((aa|0)==0){$=12;_=294;break b}c[W>>2]=0;c[W+8>>2]=-1;c[W+12>>2]=-1;c[aa>>2]=-1;c[aa+4>>2]=-1;c[aa+8>>2]=-1;S=M;T=W;U=0;break c}W=ZZa(h,V,-1)|0;if((W|0)<0){c[h>>2]=-1;jc=1}else{jc=W}do{if((c[v>>2]&2|0)==0){_=280}else{if((QZa(c[h>>2]|0)|0)==0){if((MZa(c[h>>2]|0)|0)==0){_=280;break}}W=c[w>>2]|0;aa=SZa(c[h>>2]|0)|0;ba=SZa(c[h>>2]|0)|0;R=c[x>>2]|0;Ga=t_a(W,0,0,1,32)|0;if((Ga|0)==0){$=12;_=294;break b}hb=t_a(W,0,0,1,20)|0;c[Ga+4>>2]=hb;if((hb|0)==0){$=12;_=294;break b}c[Ga>>2]=0;c[Ga+8>>2]=-1;c[Ga+12>>2]=-1;c[hb>>2]=aa;c[hb+4>>2]=ba;c[hb+8>>2]=R;R=c[w>>2]|0;hb=UZa(c[h>>2]|0)|0;ba=UZa(c[h>>2]|0)|0;aa=c[x>>2]|0;W=t_a(R,0,0,1,32)|0;if((W|0)==0){$=12;_=294;break b}X=t_a(R,0,0,1,20)|0;c[W+4>>2]=X;if((X|0)==0){$=12;_=294;break b}c[W>>2]=0;c[W+8>>2]=-1;c[W+12>>2]=-1;c[X>>2]=hb;c[X+4>>2]=ba;c[X+8>>2]=aa;aa=c[w>>2]|0;X=t_a(aa,0,0,1,32)|0;if((X|0)==0){$=12;_=294;break b}ba=t_a(aa,0,0,1,8)|0;aa=X+4|0;c[aa>>2]=ba;if((ba|0)==0){$=12;_=294;break b}c[X>>2]=3;c[X+8>>2]=-1;c[X+12>>2]=-1;c[ba>>2]=Ga;c[(c[aa>>2]|0)+4>>2]=W;c[X+16>>2]=(c[W+16>>2]|0)+(c[Ga+16>>2]|0);kc=X}}while(0);if((_|0)==280){_=0;V=c[w>>2]|0;X=c[h>>2]|0;Ga=c[x>>2]|0;W=t_a(V,0,0,1,32)|0;if((W|0)==0){$=12;_=294;break b}aa=t_a(V,0,0,1,20)|0;c[W+4>>2]=aa;if((aa|0)==0){$=12;_=294;break b}c[W>>2]=0;c[W+8>>2]=-1;c[W+12>>2]=-1;c[aa>>2]=X;c[aa+4>>2]=X;c[aa+8>>2]=Ga;kc=W}c[x>>2]=(c[x>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+jc;S=M;T=kc;U=0;break};case 4:{W=j_a(m,9)|0;if((W|0)!=0){Y=M;Z=W;_=6;break b}S=M;T=N;U=j_a(m,1)|0;break};case 0:{if((c[v>>2]&1|0)!=0){W=j_a(m,7)|0;if((W|0)!=0){Y=M;Z=W;_=6;break b}}S=M;T=N;U=j_a(m,3)|0;break};case 8:{W=L+ -2|0;c[n>>2]=W;Ga=c[P+(W<<2)>>2]|0;W=c[w>>2]|0;aa=t_a(W,0,0,1,32)|0;if((aa|0)==0){$=12;_=294;break b}X=t_a(W,0,0,1,8)|0;W=aa+4|0;c[W>>2]=X;if((X|0)==0){$=12;_=294;break b}c[aa>>2]=3;c[aa+8>>2]=-1;c[aa+12>>2]=-1;c[X>>2]=Ga;c[(c[W>>2]|0)+4>>2]=N;c[aa+16>>2]=(c[N+16>>2]|0)+(c[Ga+16>>2]|0);S=M;T=aa;U=0;break};default:{S=M;T=N;U=0}}}while(0);P=c[n>>2]|0;O=(U|0)==0;if((P|0)>(o|0)&O){L=P;M=S;N=T}else{lc=O;mc=S;nc=T;oc=U;break a}}if((_|0)==6){lc=(Z|0)==0;mc=Y;nc=N;oc=Z;break}else if((_|0)==294){i=d;return $|0}}else{lc=t;mc=0;nc=0;oc=p}}while(0);p=(mc|0)>0;if(p|lc^1){$=p?8:oc;i=d;return $|0}c[b+8>>2]=nc;$=0;i=d;return $|0}function d_a(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0;g=i;h=d+12|0;j=c[h>>2]|0;k=(b|0)==0|(f|0)==0;if(!k){c[f+48>>2]=0;c[c[f+36>>2]>>2]=-1}l=c[f+28>>2]|0;m=V_a((l<<3)+8|0)|0;n=m;if((m|0)==0){o=12;i=g;return o|0}c[m>>2]=-1;p=V_a((l<<2)+4|0)|0;if((p|0)==0){W_a(m);o=12;i=g;return o|0}c[p>>2]=-1;q=0;while(1){if(q>>>0>l>>>0){break}else{q=q+1|0}}j_a(d,e)|0;e=j_a(d,0)|0;q=c[h>>2]|0;a:do{if((q|0)>(j|0)&(e|0)==0){l=d+16|0;r=f+32|0;s=f+16|0;t=f+36|0;u=q;v=0;w=-1;x=1;y=0;z=0;A=n;B=0;while(1){C=u+ -1|0;c[h>>2]=C;D=c[l>>2]|0;b:do{switch(c[D+(C<<2)>>2]|0){case 0:{E=u+ -2|0;c[h>>2]=E;F=c[D+(E<<2)>>2]|0;E=F;G=F+12|0;H=c[G>>2]|0;if((H|0)>-1){I=0;do{J=A+(I<<2)|0;I=I+1|0}while((c[J>>2]|0)>-1);c[J>>2]=H<<1;c[A+(I<<2)>>2]=-1;do{if(!k){K=0;while(1){if((c[p+(K<<2)>>2]|0)>-1){K=K+1|0}else{break}}c[(c[s>>2]|0)+(H*12|0)+8>>2]=0;if((K|0)<=0){break}L=V_a((K<<2)+4|0)|0;M=L;if((L|0)==0){N=w;O=y;P=z;Q=A;R=12;S=B;break a}c[(c[s>>2]|0)+(H*12|0)+8>>2]=M;T=c[p>>2]|0;if((T|0)>-1){U=M;V=T;T=0;while(1){c[U>>2]=V;W=T+1|0;X=c[p+(W<<2)>>2]|0;Y=L+(W<<2)|0;if((X|0)>-1){T=W;V=X;U=Y}else{Z=Y;break}}}else{Z=M}c[Z>>2]=-1}}while(0);H=j_a(d,c[G>>2]|0)|0;if((H|0)!=0){N=w;O=y;P=z;Q=A;R=H;S=B;break a}H=j_a(d,6)|0;if((H|0)!=0){N=w;O=y;P=z;Q=A;R=H;S=B;break a}}H=c[F>>2]|0;do{if((H|0)==3){I=c[F+4>>2]|0;U=c[I>>2]|0;V=c[I+4>>2]|0;I=(c[A>>2]|0)>-1;T=x+1|0;L=j_a(d,I?T:x)|0;if((L|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=L;ea=B;break}L=j_a(d,I?x:B)|0;if((L|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=L;ea=B;break}L=j_a(d,A)|0;if((L|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=L;ea=B;break}L=j_a(d,(c[A>>2]|0)>>>31^1)|0;if((L|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=L;ea=B;break}L=j_a(d,F)|0;if((L|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=L;ea=B;break}L=V;V=j_a(d,L)|0;if((V|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=V;ea=B;break}V=U;U=j_a(d,V)|0;if((U|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=U;ea=B;break}U=j_a(d,3)|0;if((U|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=U;ea=B;break}U=j_a(d,L)|0;if((U|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=U;ea=B;break}U=j_a(d,0)|0;if((U|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=U;ea=B;break}U=j_a(d,2)|0;if((U|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=U;ea=B;break}U=j_a(d,V)|0;if((U|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=U;ea=B;break}U=j_a(d,0)|0;if((U|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=U;ea=B;break}if((c[A>>2]|0)>-1){if(k){fa=w;ga=y;ha=0}else{U=l_a(b,E,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=v;if((w|0)>-1){V=c[t>>2]|0;L=0;while(1){ia=V+(L<<2)|0;ja=L+1|0;if((c[ia>>2]|0)>-1){L=ja}else{break}}c[ia>>2]=B;c[V+(ja<<2)>>2]=w;c[V+(L+2<<2)>>2]=-1;ka=-1;la=y+1|0}else{ka=w;la=y}M=c[A>>2]|0;if((M|0)>-1){I=c[s>>2]|0;K=M;M=0;do{Y=(K|0)/2|0;if((K&1|0)==0){c[I+(Y*12|0)>>2]=B}else{c[I+(Y*12|0)+4>>2]=B}M=M+1|0;K=c[A+(M<<2)>>2]|0;}while((K|0)>-1)}c[A>>2]=-1;fa=ka;ga=la;ha=U}c[A>>2]=-1;ma=fa;na=T;oa=ga;pa=z+1|0;qa=ha;ra=x}else{ma=w;na=x;oa=y;pa=z;qa=0;ra=B}if((c[F+16>>2]|0)<=0){_=v;$=ma;aa=na;ba=oa;ca=pa;da=qa;ea=ra;break}_=v;$=ma;aa=na+2|0;ba=oa;ca=pa;da=qa;ea=na+1|0}else if((H|0)==1){K=c[F+4>>2]|0;M=c[K>>2]|0;I=c[K+4>>2]|0;K=j_a(d,F)|0;if((K|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=K;ea=B;break}K=j_a(d,5)|0;if((K|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=K;ea=B;break}K=j_a(d,I)|0;if((K|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=K;ea=B;break}K=j_a(d,0)|0;if((K|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=K;ea=B;break}K=M+20|0;L=j_a(d,(c[K>>2]|0)+x|0)|0;if((L|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=L;ea=B;break}if((c[K>>2]|0)>0){K=(c[I+20>>2]|0)>0;sa=(K&1)+x|0;ta=K?x:-1}else{sa=x;ta=-1}K=j_a(d,ta)|0;if((K|0)!=0){_=v;$=w;aa=sa;ba=y;ca=z;da=K;ea=B;break}K=j_a(d,4)|0;if((K|0)!=0){_=v;$=w;aa=sa;ba=y;ca=z;da=K;ea=B;break}K=j_a(d,M)|0;if((K|0)!=0){_=v;$=w;aa=sa;ba=y;ca=z;da=K;ea=B;break}_=v;$=w;aa=sa;ba=y;ca=z;da=j_a(d,0)|0;ea=B}else if((H|0)==2){K=c[F+4>>2]|0;if(k){if((c[A>>2]|0)>-1){ua=1}else{ua=a[K+12|0]&1}M=j_a(d,ua)|0;if((M|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=M;ea=B;break}}else{M=j_a(d,B)|0;if((M|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=M;ea=B;break}M=j_a(d,a[K+12|0]&1)|0;if((M|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=M;ea=B;break}}M=j_a(d,F)|0;if((M|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=M;ea=B;break}M=j_a(d,1)|0;if((M|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=M;ea=B;break}M=j_a(d,c[K>>2]|0)|0;if((M|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=M;ea=B;break}M=j_a(d,0)|0;if((M|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=M;ea=B;break}if(!((c[A>>2]|0)>-1)){if((a[K+12|0]&1)==0){_=0;$=w;aa=x;ba=y;ca=z;da=0;ea=B;break}}if(k){va=w;wa=y;xa=0}else{M=l_a(b,E,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=(a[K+12|0]&1)==0?v:1;if((w|0)>-1){K=c[t>>2]|0;I=0;while(1){ya=K+(I<<2)|0;za=I+1|0;if((c[ya>>2]|0)>-1){I=za}else{break}}c[ya>>2]=B;c[K+(za<<2)>>2]=w;c[K+(I+2<<2)>>2]=-1;Aa=-1;Ba=y+1|0}else{Aa=w;Ba=y}T=c[A>>2]|0;if((T|0)>-1){U=c[s>>2]|0;L=T;T=0;do{V=(L|0)/2|0;if((L&1|0)==0){c[U+(V*12|0)>>2]=B}else{c[U+(V*12|0)+4>>2]=B}T=T+1|0;L=c[A+(T<<2)>>2]|0;}while((L|0)>-1)}c[A>>2]=-1;va=Aa;wa=Ba;xa=M}c[A>>2]=-1;_=0;$=va;aa=x+1|0;ba=wa;ca=z+1|0;da=xa;ea=x}else if((H|0)==0){L=c[c[F+4>>2]>>2]|0;if(!((L|0)>-1|(L|0)==-4)){_=v;$=w;aa=x;ba=y;ca=z;da=0;ea=B;break}if(!((c[A>>2]|0)>-1)){_=v;$=w;aa=x;ba=y;ca=z;da=0;ea=B;break}if(k){c[F+20>>2]=1;Ca=w;Da=y;Ea=0}else{L=l_a(b,E,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=v;if((w|0)>-1){T=c[t>>2]|0;U=0;while(1){Fa=T+(U<<2)|0;Ga=U+1|0;if((c[Fa>>2]|0)>-1){U=Ga}else{break}}c[Fa>>2]=B;c[T+(Ga<<2)>>2]=w;c[T+(U+2<<2)>>2]=-1;Ha=-1;Ia=y+1|0}else{Ha=w;Ia=y}M=c[A>>2]|0;if((M|0)>-1){I=c[s>>2]|0;K=M;M=0;do{V=(K|0)/2|0;if((K&1|0)==0){c[I+(V*12|0)>>2]=B}else{c[I+(V*12|0)+4>>2]=B}M=M+1|0;K=c[A+(M<<2)>>2]|0;}while((K|0)>-1)}c[A>>2]=-1;Ca=Ha;Da=Ia;Ea=L}c[A>>2]=-1;_=v;$=Ca;aa=x+1|0;ba=Da;ca=z+1|0;da=Ea;ea=x}else{_=v;$=w;aa=x;ba=y;ca=z;da=0;ea=B}}while(0);E=c[G>>2]|0;if((E|0)>-1){Ja=0}else{Ka=_;La=$;Ma=aa;Na=ba;Oa=ca;Pa=A;Qa=da;Ra=ea;break b}do{Sa=p+(Ja<<2)|0;Ja=Ja+1|0}while((c[Sa>>2]|0)>-1);c[Sa>>2]=E;c[p+(Ja<<2)>>2]=-1;Ka=_;La=$;Ma=aa;Na=ba;Oa=ca;Pa=A;Qa=da;Ra=ea;break};case 3:{G=c[D+(u+ -2<<2)>>2]|0;F=c[D+(u+ -3<<2)>>2]|0;H=c[D+(u+ -4<<2)>>2]|0;K=u+ -5|0;c[h>>2]=K;if(k){M=c[H+4>>2]|0;I=H+16|0;c[H+20>>2]=(c[(c[M>>2]|0)+20>>2]|0)+(c[D+(K<<2)>>2]|0)+(c[(c[M+4>>2]|0)+20>>2]|0)+((c[I>>2]|0)>0?2:0);Ta=I;Ua=c[h>>2]|0}else{Ta=H+16|0;Ua=K}K=c[D+(Ua+ -1<<2)>>2]|0;H=Ua+ -2|0;c[h>>2]=H;I=c[D+(H<<2)>>2]|0;H=Ua+ -3|0;c[h>>2]=H;M=c[D+(H<<2)>>2]|0;if((c[Ta>>2]|0)<=0){Ka=1;La=w;Ma=x;Na=y;Oa=z;Pa=K;Qa=0;Ra=B;break b}if(k){Va=0}else{m_a(b,G,I)|0;c[(c[r>>2]|0)+(I<<2)>>2]=1;I=m_a(b,F,M)|0;c[(c[r>>2]|0)+(M<<2)>>2]=1;Va=I}Ka=1;La=w;Ma=x;Na=y;Oa=z+2|0;Pa=K;Qa=Va;Ra=B;break};case 1:{K=u+ -2|0;c[h>>2]=K;I=c[D+(K<<2)>>2]|0;if(k){K=c[(c[c[I+4>>2]>>2]|0)+20>>2]|0;M=u+ -3|0;c[h>>2]=M;c[I+20>>2]=(c[D+(M<<2)>>2]|0)+K;Ka=v;La=-1;Ma=x;Na=y;Oa=z;Pa=A;Qa=0;Ra=B;break b}else{K=u+ -3|0;c[h>>2]=K;M=c[D+(K<<2)>>2]|0;K=u+ -4|0;c[h>>2]=K;I=(M|0)==0;Ka=I&1;La=I?w:c[D+(K<<2)>>2]|0;Ma=x;Na=y;Oa=z;Pa=A;Qa=0;Ra=B;break b}break};case 5:{K=u+ -2|0;c[h>>2]=K;I=c[D+(K<<2)>>2]|0;if(!k){Ka=v;La=w;Ma=x;Na=y;Oa=z;Pa=A;Qa=0;Ra=B;break b}K=c[I+4>>2]|0;c[I+20>>2]=(c[(c[K+4>>2]|0)+20>>2]|0)+(c[(c[K>>2]|0)+20>>2]|0);Ka=v;La=w;Ma=x;Na=y;Oa=z;Pa=A;Qa=0;Ra=B;break};case 2:{K=A;while(1){if((c[K>>2]|0)>-1){K=K+4|0}else{Ka=v;La=w;Ma=x;Na=y;Oa=z;Pa=K;Qa=0;Ra=B;break}}break};case 4:{K=u+ -2|0;c[h>>2]=K;E=c[D+(K<<2)>>2]|0;K=u+ -3|0;c[h>>2]=K;Ka=v;La=w;Ma=c[D+(K<<2)>>2]|0;Na=y;Oa=z;Pa=A;Qa=0;Ra=(E|0)>-1?E:B;break};case 6:{E=u+ -2|0;c[h>>2]=E;K=c[D+(E<<2)>>2]|0;E=0;do{Wa=A+(E<<2)|0;E=E+1|0}while((c[Wa>>2]|0)>-1);c[Wa>>2]=K<<1|1;c[A+(E<<2)>>2]=-1;I=0;while(1){if((c[p+(I<<2)>>2]|0)>-1){I=I+1|0}else{break}}c[p+(I+ -1<<2)>>2]=-1;Ka=v;La=w;Ma=x;Na=y;Oa=z;Pa=A;Qa=0;Ra=B;break};default:{Ka=v;La=w;Ma=x;Na=y;Oa=z;Pa=A;Qa=0;Ra=B}}}while(0);D=c[h>>2]|0;if((D|0)>(j|0)&(Qa|0)==0){u=D;v=Ka;w=La;x=Ma;y=Na;z=Oa;A=Pa;B=Ra}else{N=La;O=Na;P=Oa;Q=Pa;R=Qa;S=Ra;break a}}}else{N=-1;O=0;P=0;Q=n;R=e;S=0}}while(0);do{if(k){Xa=O}else{e=c[Q>>2]|0;if((e|0)>-1){n=c[f+16>>2]|0;Ra=e;e=0;do{Qa=(Ra|0)/2|0;if((Ra&1|0)==0){c[n+(Qa*12|0)>>2]=S}else{c[n+(Qa*12|0)+4>>2]=S}e=e+1|0;Ra=c[Q+(e<<2)>>2]|0;}while((Ra|0)>-1)}c[Q>>2]=-1;if(!((N|0)>-1)){Xa=O;break}Ra=c[f+36>>2]|0;e=0;while(1){Ya=Ra+(e<<2)|0;Za=e+1|0;if((c[Ya>>2]|0)>-1){e=Za}else{break}}c[Ya>>2]=S;c[Ra+(Za<<2)>>2]=N;c[Ra+(e+2<<2)>>2]=-1;Xa=O+1|0}}while(0);c[f+48>>2]=P;c[f+40>>2]=P;c[f+44>>2]=Xa;W_a(m);W_a(p);o=R;i=g;return o|0}function e_a(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=a;a:while(1){a=c[g>>2]|0;do{if((a|0)==2){h=c[g+4>>2]|0;j=h;if(!((c[h+8>>2]|0)==-1)){k=j;break}l=c[h>>2]|0;h=g_a(c[l+28>>2]|0,c[l+24>>2]|0,b,d,e)|0;if((h|0)==0){k=j}else{m=h;n=10;break a}}else if((a|0)==1){h=c[g+4>>2]|0;j=h+4|0;l=g_a(c[(c[h>>2]|0)+28>>2]|0,c[(c[j>>2]|0)+24>>2]|0,b,d,e)|0;if((l|0)!=0){m=l;n=10;break a}l=e_a(c[h>>2]|0,b,d,e)|0;if((l|0)==0){k=j}else{m=l;n=10;break a}}else if((a|0)==3){l=c[g+4>>2]|0;j=e_a(c[l>>2]|0,b,d,e)|0;if((j|0)!=0){m=j;n=10;break a}k=l+4|0}else{m=0;n=10;break a}}while(0);g=c[k>>2]|0}if((n|0)==10){i=f;return m|0}return 0}function f_a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=c[a+4>>2]|0;if((d|0)==0){i=b;return}a=d+4|0;e=c[d>>2]|0;if((c[a>>2]|0)==0){f=e}else{g=e;e=0;while(1){do{if((c[g+(e<<5)+8>>2]|0)==0){h=g}else{j=c[g+(e<<5)+16>>2]|0;if((j|0)==0){k=g}else{W_a(j);k=c[d>>2]|0}j=c[k+(e<<5)+28>>2]|0;if((j|0)==0){h=k;break}W_a(j);h=c[d>>2]|0}}while(0);j=e+1|0;if(j>>>0<(c[a>>2]|0)>>>0){g=h;e=j}else{f=h;break}}}if((f|0)!=0){W_a(f)}f=d+8|0;h=c[f>>2]|0;if((h|0)!=0){if((c[h+8>>2]|0)==0){l=h}else{e=h;while(1){h=c[e+16>>2]|0;if((h|0)!=0){W_a(h)}if((c[e+40>>2]|0)==0){break}else{e=e+32|0}}l=c[f>>2]|0}W_a(l)}l=d+16|0;f=c[l>>2]|0;if((f|0)!=0){e=d+28|0;h=c[e>>2]|0;if((h|0)==0){m=f}else{g=h;h=f;f=0;while(1){a=c[h+(f*12|0)+8>>2]|0;if((a|0)==0){n=h;o=g}else{W_a(a);n=c[l>>2]|0;o=c[e>>2]|0}a=f+1|0;if(a>>>0<o>>>0){g=o;h=n;f=a}else{m=n;break}}}W_a(m)}m=c[d+32>>2]|0;if((m|0)!=0){W_a(m)}m=c[d+20>>2]|0;if((m|0)!=0){W_a(m)}m=c[d+36>>2]|0;if((m|0)!=0){W_a(m)}W_a(d);i=b;return}function g_a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;g=i;h=a;a=c[h>>2]|0;j=(a|0)>-1;if((d|0)==0){if(!j){k=0;i=g;return k|0}l=b;m=a;a=h;while(1){a:do{if((c[l>>2]|0)>-1){n=b;o=m;while(1){p=e+(o<<2)|0;c[p>>2]=(c[p>>2]|0)+1;p=n+32|0;if(!((c[p>>2]|0)>-1)){break a}o=c[a>>2]|0;n=p}}}while(0);n=a+32|0;o=c[n>>2]|0;if((o|0)>-1){m=o;a=n}else{k=0;break}}i=g;return k|0}if(!j){k=0;i=g;return k|0}j=b;a=h;b:while(1){h=c[j>>2]|0;c:do{if((h|0)>-1){m=a+4|0;e=a+8|0;l=a+16|0;n=a+20|0;o=a+24|0;p=a+28|0;q=a+12|0;r=b;s=h;t=j;u=-1;while(1){v=r;w=s;x=t;while(1){y=v+32|0;if((w|0)!=(u|0)){break}z=y;A=c[z>>2]|0;if((A|0)>-1){w=A;x=z;v=y}else{break c}}z=d+(c[f+(c[a>>2]<<2)>>2]<<5)|0;while(1){B=z+8|0;if((c[B>>2]|0)==0){break}else{z=z+32|0}}c[z+40>>2]=0;c[z>>2]=c[m>>2];c[z+4>>2]=c[e>>2];A=c[x>>2]|0;c[B>>2]=d+(c[f+(A<<2)>>2]<<5);c[z+12>>2]=A;A=c[n>>2]|0;C=c[o>>2]|0;D=c[v+16>>2]|c[l>>2]|((A|0)!=0?4:0)|((C|0)!=0?8:0);E=z+20|0;c[E>>2]=D;F=c[p>>2]|0;G=z+24|0;if((F|0)>-1){c[G>>2]=F;c[E>>2]=D|256}else{c[G>>2]=A}if((C|0)==0){c[z+28>>2]=0}else{A=0;while(1){H=A+1|0;if((c[C+(A<<2)>>2]|0)==0){break}else{A=H}}A=V_a(H<<2)|0;C=A;c[z+28>>2]=C;if((A|0)==0){k=12;I=49;break b}x=c[o>>2]|0;G=c[x>>2]|0;if((G|0)==0){J=C}else{D=C;C=G;G=0;while(1){c[D>>2]=C;E=G+1|0;F=c[x+(E<<2)>>2]|0;K=A+(E<<2)|0;if((F|0)==0){J=K;break}else{G=E;C=F;D=K}}}c[J>>2]=0}D=c[q>>2]|0;if((D|0)==0){L=0}else{C=0;while(1){if((c[D+(C<<2)>>2]|0)>-1){C=C+1|0}else{L=C;break}}}C=v+12|0;D=c[C>>2]|0;if((D|0)==0){M=0}else{G=0;while(1){if((c[D+(G<<2)>>2]|0)>-1){G=G+1|0}else{M=G;break}}}G=z+16|0;D=c[G>>2]|0;if((D|0)!=0){W_a(D)}c[G>>2]=0;D=M+L|0;if((D|0)>0){v=V_a((D<<2)+4|0)|0;c[G>>2]=v;if((v|0)==0){k=12;I=49;break b}G=c[q>>2]|0;do{if((G|0)==0){N=0}else{D=c[G>>2]|0;if((D|0)>-1){O=D;P=0}else{N=0;break}while(1){c[v+(P<<2)>>2]=O;D=P+1|0;A=c[G+(D<<2)>>2]|0;if((A|0)>-1){P=D;O=A}else{N=D;break}}}}while(0);G=c[C>>2]|0;do{if((G|0)==0){Q=N}else{z=c[G>>2]|0;if(!((z|0)>-1)){Q=N;break}D=(N|0)>0;A=z;z=0;x=N;while(1){d:do{if(D){K=0;while(1){F=K+1|0;if((c[v+(K<<2)>>2]|0)==(A|0)){R=x;break d}if((F|0)<(N|0)){K=F}else{I=40;break}}}else{I=40}}while(0);if((I|0)==40){I=0;c[v+(x<<2)>>2]=A;R=x+1|0}K=z+1|0;F=c[G+(K<<2)>>2]|0;if((F|0)>-1){A=F;z=K;x=R}else{Q=R;break}}}}while(0);c[v+(Q<<2)>>2]=-1}G=y;C=c[G>>2]|0;if((C|0)>-1){r=y;s=C;t=G;u=w}else{break}}}}while(0);h=a+32|0;if((c[h>>2]|0)>-1){a=h}else{k=0;I=49;break}}if((I|0)==49){i=g;return k|0}return 0}function h_a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=i;h=(e|0)==0;a:do{if(h){j=0}else{k=0;while(1){if(!((c[e+(k<<2)>>2]|0)>-1)){j=k;break a}k=k+1|0}}}while(0);k=0;while(1){if((c[b+(k<<5)>>2]|0)>-1){k=k+1|0}else{l=0;break}}while(1){if((c[d+(l<<5)>>2]|0)>-1){l=l+1|0}else{break}}m=t_a(a,0,0,1,(l+k<<5)+32|0)|0;k=m;if((m|0)==0){n=0;i=g;return n|0}l=c[b>>2]|0;b:do{if((l|0)>-1){o=(j|0)>0;p=l;q=0;while(1){c[m+(q<<5)>>2]=p;c[m+(q<<5)+4>>2]=c[b+(q<<5)+4>>2];c[m+(q<<5)+8>>2]=c[b+(q<<5)+8>>2];c[m+(q<<5)+16>>2]=c[b+(q<<5)+16>>2]|f;c[m+(q<<5)+20>>2]=c[b+(q<<5)+20>>2];c[m+(q<<5)+24>>2]=c[b+(q<<5)+24>>2];c[m+(q<<5)+28>>2]=c[b+(q<<5)+28>>2];r=b+(q<<5)+12|0;s=c[r>>2]|0;t=(s|0)==0;if(t&h){c[m+(q<<5)+12>>2]=0}else{c:do{if(t){u=0}else{v=0;while(1){if(!((c[s+(v<<2)>>2]|0)>-1)){u=v;break c}v=v+1|0}}}while(0);s=t_a(a,0,0,0,(u+j<<2)+4|0)|0;t=s;if((s|0)==0){n=0;break}if((u|0)>0){v=c[r>>2]|0;w=0;while(1){c[s+(w<<2)>>2]=c[v+(w<<2)>>2];x=w+1|0;if((x|0)<(u|0)){w=x}else{y=u;break}}}else{y=0}if(o){w=0;while(1){c[s+(w+y<<2)>>2]=c[e+(w<<2)>>2];v=w+1|0;if((v|0)<(j|0)){w=v}else{z=j;break}}}else{z=0}c[s+(z+y<<2)>>2]=-1;c[m+(q<<5)+12>>2]=t}w=q+1|0;v=c[b+(w<<5)>>2]|0;if((v|0)>-1){p=v;q=w}else{A=w;break b}}i=g;return n|0}else{A=0}}while(0);b=c[d>>2]|0;y=m+(A<<5)|0;d:do{if((b|0)>-1){z=y;j=A;e=b;u=0;while(1){c[z>>2]=e;c[m+(j<<5)+4>>2]=c[d+(u<<5)+4>>2];c[m+(j<<5)+8>>2]=c[d+(u<<5)+8>>2];c[m+(j<<5)+16>>2]=c[d+(u<<5)+16>>2];c[m+(j<<5)+20>>2]=c[d+(u<<5)+20>>2];c[m+(j<<5)+24>>2]=c[d+(u<<5)+24>>2];c[m+(j<<5)+28>>2]=c[d+(u<<5)+28>>2];h=d+(u<<5)+12|0;f=c[h>>2]|0;if((f|0)==0){c[m+(j<<5)+12>>2]=0}else{l=0;while(1){if((c[f+(l<<2)>>2]|0)>-1){l=l+1|0}else{break}}f=t_a(a,0,0,0,(l<<2)+4|0)|0;t=f;if((f|0)==0){n=0;break}if((l|0)>0){s=c[h>>2]|0;q=0;while(1){c[f+(q<<2)>>2]=c[s+(q<<2)>>2];p=q+1|0;if((p|0)<(l|0)){q=p}else{B=l;break}}}else{B=0}c[f+(B<<2)>>2]=-1;c[m+(j<<5)+12>>2]=t}l=u+1|0;q=c[d+(l<<5)>>2]|0;s=l+A|0;h=m+(s<<5)|0;if((q|0)>-1){z=h;j=s;e=q;u=l}else{C=h;break d}}i=g;return n|0}else{C=y}}while(0);c[C>>2]=-1;n=k;i=g;return n|0}function i_a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=i;h=a+12|0;j=c[h>>2]|0;k=(f|0)!=0;if(k){c[f>>2]=0}l=j_a(a,b)|0;if((l|0)!=0){m=l;i=g;return m|0}l=a+16|0;b=(d|0)==0;n=(e|0)==0;a:while(1){o=c[h>>2]|0;if((o|0)<=(j|0)){m=0;p=28;break}q=o+ -1|0;c[h>>2]=q;o=c[(c[l>>2]|0)+(q<<2)>>2]|0;q=c[o>>2]|0;do{if((q|0)==3){r=c[o+4>>2]|0;s=c[r>>2]|0;if((c[s+8>>2]|0)!=0){t=j_a(a,s)|0;break}s=c[r+4>>2]|0;if((c[s+8>>2]|0)==0){continue a}t=j_a(a,s)|0}else if((q|0)==1){s=c[o+4>>2]|0;r=j_a(a,c[s>>2]|0)|0;if((r|0)!=0){m=r;p=28;break a}t=j_a(a,c[s+4>>2]|0)|0}else if((q|0)==0){s=c[o+4>>2]|0;r=c[s>>2]|0;if((r|0)==-2){if(n){continue a}c[e>>2]=c[e>>2]|c[s+4>>2];continue a}else if(!((r|0)==-3)){continue a}r=c[s+4>>2]|0;if(!((r|0)>-1)){continue a}b:do{if(!b){s=c[d>>2]|0;c:do{if((s|0)>-1){u=s;v=d;w=0;while(1){x=w+1|0;if((u|0)==(r|0)){break}y=d+(x<<2)|0;z=c[y>>2]|0;if((z|0)>-1){u=z;v=y;w=x}else{A=y;B=x;break c}}if((r|0)<0){A=v;B=w}else{break b}}else{A=d;B=0}}while(0);c[A>>2]=r;c[d+(B+1<<2)>>2]=-1}}while(0);if(!k){continue a}c[f>>2]=(c[f>>2]|0)+1;continue a}else if((q|0)==2){r=c[c[o+4>>2]>>2]|0;if((c[r+8>>2]|0)==0){continue a}t=j_a(a,r)|0}else{continue a}}while(0);if((t|0)!=0){m=t;p=28;break}}if((p|0)==28){i=g;return m|0}return 0}function j_a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+12|0;f=c[e>>2]|0;g=a;h=c[g>>2]|0;if((f|0)<(h|0)){c[(c[a+16>>2]|0)+(f<<2)>>2]=b;c[e>>2]=(c[e>>2]|0)+1;j=0;i=d;return j|0}e=c[a+4>>2]|0;if((h|0)>=(e|0)){j=12;i=d;return j|0}f=(c[a+8>>2]|0)+h|0;h=(f|0)>(e|0)?e:f;f=a+16|0;e=Y_a(c[f>>2]|0,h<<2)|0;if((e|0)==0){j=12;i=d;return j|0}else{c[g>>2]=h;c[f>>2]=e;j_a(a,b)|0;i=d;return 0}return 0}function k_a(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;l=i;m=d+12|0;n=c[m>>2]|0;j_a(d,e)|0;e=j_a(d,0)|0;a:do{if((e|0)==0){o=d+16|0;p=(f&1|0)==0;q=(f&2|0)==0;r=1;s=0;t=j;b:while(1){u=c[m>>2]|0;if((u|0)<=(n|0)){v=s;w=0;break a}x=u+ -1|0;c[m>>2]=x;y=c[o>>2]|0;z=c[y+(x<<2)>>2]|0;if((z|0)==1){x=u+ -2|0;c[m>>2]=x;A=s;B=r;t=c[y+(x<<2)>>2]|0;s=A;r=B;continue}else if((z|0)!=0){C=t;A=s;B=r;t=C;s=A;r=B;continue}z=u+ -2|0;c[m>>2]=z;u=c[y+(z<<2)>>2]|0;z=c[u>>2]|0;do{if((z|0)==1){y=c[u+4>>2]|0;x=c[y>>2]|0;D=y+4|0;E=c[D>>2]|0;F=t_a(b,0,0,1,32)|0;if((F|0)==0){G=29;break b}H=t_a(b,0,0,1,8)|0;I=F+4|0;c[I>>2]=H;if((H|0)==0){G=29;break b}c[F>>2]=1;c[F+8>>2]=-1;c[F+12>>2]=-1;c[H>>2]=x;c[(c[I>>2]|0)+4>>2]=E;c[F+16>>2]=(c[E+16>>2]|0)+(c[x+16>>2]|0);c[t>>2]=F;F=c[I>>2]|0;c[F>>2]=0;I=F+4|0;c[I>>2]=0;x=j_a(d,c[D>>2]|0)|0;if((x|0)!=0){v=s;w=x;break a}x=j_a(d,0)|0;if((x|0)!=0){v=s;w=x;break a}x=j_a(d,I)|0;if((x|0)!=0){v=s;w=x;break a}x=j_a(d,1)|0;if((x|0)!=0){v=s;w=x;break a}x=j_a(d,c[y>>2]|0)|0;if((x|0)!=0){v=s;w=x;break a}J=r;K=s;L=F;M=j_a(d,0)|0}else if((z|0)==3){F=c[u+4>>2]|0;x=c[F>>2]|0;y=F+4|0;I=c[y>>2]|0;D=t_a(b,0,0,1,32)|0;if((D|0)==0){G=20;break b}E=t_a(b,0,0,1,8)|0;H=D+4|0;c[H>>2]=E;if((E|0)==0){G=20;break b}c[D>>2]=3;c[D+8>>2]=-1;c[D+12>>2]=-1;c[E>>2]=x;c[(c[H>>2]|0)+4>>2]=I;c[D+16>>2]=(c[I+16>>2]|0)+(c[x+16>>2]|0);c[t>>2]=D;D=c[H>>2]|0;H=j_a(d,c[y>>2]|0)|0;if((H|0)!=0){v=s;w=H;break a}H=j_a(d,0)|0;if((H|0)!=0){v=s;w=H;break a}H=j_a(d,D+4|0)|0;if((H|0)!=0){v=s;w=H;break a}H=j_a(d,1)|0;if((H|0)!=0){v=s;w=H;break a}H=j_a(d,c[F>>2]|0)|0;if((H|0)!=0){v=s;w=H;break a}J=r;K=s;L=D;M=j_a(d,0)|0}else if((z|0)==2){D=c[u+4>>2]|0;H=j_a(d,c[D>>2]|0)|0;if((H|0)!=0){v=s;w=H;break a}H=j_a(d,0)|0;if((H|0)!=0){v=s;w=H;break a}H=c[D>>2]|0;F=c[D+4>>2]|0;y=c[D+8>>2]|0;x=a[D+12|0]|0;D=t_a(b,0,0,1,32)|0;if((D|0)==0){G=40;break b}I=t_a(b,0,0,1,16)|0;E=D+4|0;c[E>>2]=I;if((I|0)==0){G=40;break b}c[D>>2]=2;c[D+8>>2]=-1;c[D+12>>2]=-1;c[I>>2]=H;c[I+4>>2]=F;c[I+8>>2]=y;y=I+12|0;a[y]=a[y]&-2|x&1;c[D+16>>2]=c[H+16>>2];c[t>>2]=D;A=s;B=r;t=c[E>>2]|0;s=A;r=B;continue b}else if((z|0)==0){E=c[u+4>>2]|0;D=c[E+8>>2]|0;H=c[E>>2]|0;x=c[E+4>>2]|0;do{if((H|0)>-1|(H|0)==-4){N=r;O=x;P=H;Q=s+1|0;R=(c[g>>2]|0)+D|0}else{if(!((H|0)==-3)){N=r;O=x;P=H;Q=s;R=D;break}if(!p){N=r;O=-1;P=-1;Q=s;R=-1;break}if(q|(r|0)==0){N=r;O=x;P=-3;Q=s;R=D;break}c[h+(x<<2)>>2]=1;N=0;O=x;P=-3;Q=s;R=D}}while(0);D=t_a(b,0,0,1,32)|0;x=D;do{if((D|0)==0){S=0}else{H=t_a(b,0,0,1,20)|0;c[D+4>>2]=H;if((H|0)==0){S=0;break}c[D>>2]=0;c[D+8>>2]=-1;c[D+12>>2]=-1;c[H>>2]=P;c[H+4>>2]=O;c[H+8>>2]=R;S=x}}while(0);c[t>>2]=S;x=(S|0)==0?12:0;if((R|0)<=(c[k>>2]|0)){J=N;K=Q;L=t;M=x;break}c[k>>2]=R;J=N;K=Q;L=t;M=x}else{C=t;A=s;B=r;t=C;s=A;r=B;continue b}}while(0);if((M|0)==0){r=J;s=K;t=L}else{v=K;w=M;break a}}if((G|0)==20){c[t>>2]=0;v=s;w=12;break}else if((G|0)==29){c[t>>2]=0;v=s;w=12;break}else if((G|0)==40){c[t>>2]=0;v=s;w=12;break}}else{v=0;w=e}}while(0);c[g>>2]=(c[g>>2]|0)+v;i=l;return w|0}function l_a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=t_a(a,0,0,0,8)|0;if((f|0)==0){g=12;i=e;return g|0}h=t_a(a,0,0,1,32)|0;j=h;do{if((h|0)!=0){k=t_a(a,0,0,1,20)|0;c[h+4>>2]=k;if((k|0)==0){break}c[h>>2]=0;c[h+8>>2]=-1;c[h+12>>2]=-1;c[k>>2]=-3;c[k+4>>2]=d;c[k+8>>2]=-1;c[f>>2]=j;k=t_a(a,0,0,0,32)|0;l=f+4|0;c[l>>2]=k;if((k|0)==0){g=12;i=e;return g|0}m=b+4|0;c[k+4>>2]=c[m>>2];k=b;c[c[l>>2]>>2]=c[k>>2];n=c[l>>2]|0;c[n+8>>2]=-1;c[n+12>>2]=-1;c[n+24>>2]=0;c[(c[l>>2]|0)+28>>2]=0;c[(c[l>>2]|0)+20>>2]=0;c[m>>2]=f;c[k>>2]=1;g=0;i=e;return g|0}}while(0);c[f>>2]=0;g=12;i=e;return g|0}function m_a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=t_a(a,0,0,0,8)|0;if((f|0)==0){g=12;i=e;return g|0}h=t_a(a,0,0,1,32)|0;j=h;do{if((h|0)!=0){k=t_a(a,0,0,1,20)|0;c[h+4>>2]=k;if((k|0)==0){break}c[h>>2]=0;c[h+8>>2]=-1;c[h+12>>2]=-1;c[k>>2]=-3;c[k+4>>2]=d;c[k+8>>2]=-1;c[f+4>>2]=j;k=t_a(a,0,0,0,32)|0;c[f>>2]=k;if((k|0)==0){g=12;i=e;return g|0}l=b+4|0;c[k+4>>2]=c[l>>2];k=b;c[c[f>>2]>>2]=c[k>>2];m=c[f>>2]|0;c[m+8>>2]=-1;c[m+12>>2]=-1;c[m+24>>2]=0;c[(c[f>>2]|0)+28>>2]=0;c[(c[f>>2]|0)+20>>2]=0;c[l>>2]=f;c[k>>2]=1;g=0;i=e;return g|0}}while(0);c[f+4>>2]=0;g=12;i=e;return g|0}function n_a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[c[(c[a>>2]|0)+4>>2]>>2]|0;a=c[c[(c[b>>2]|0)+4>>2]>>2]|0;if((e|0)<(a|0)){f=-1;i=d;return f|0}f=(e|0)>(a|0)|0;i=d;return f|0}function o_a(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;g=d;a:do{if((b|0)==0){h=295632}else{j=b;k=295632;while(1){if((a[k]|0)==0){h=k;break a}l=j+ -1|0;m=k+((x$a(k|0)|0)+1)|0;if((l|0)==0){h=m;break}else{j=l;k=m}}}}while(0);c[g>>2]=(a[h]|0)==0?h+1|0:h;h=(Pc(e|0,f|0,295920,g|0)|0)+1|0;i=d;return h|0}function p_a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0;g=i;i=i+16|0;h=g;j=g+8|0;k=c[a+4>>2]|0;a=k;l=k+40|0;m=c[l>>2]|0;do{if((m|0)<1|(d|0)==0){n=0}else{o=V_a(m<<2)|0;if((o|0)==0){p=12}else{n=o;break}i=g;return p|0}}while(0);m=n;a:do{if((c[k+60>>2]|0)==0){c[h>>2]=0;o=f&1;q=f&2;r=k+56|0;s=c[r>>2]&4;if((n|0)==0){t=0}else{t=c[l>>2]|0}u=t<<2;v=c[k+52>>2]|0;w=v<<3;x=w+8|0;y=u+12+w+(x+(fa(u,v)|0)<<1)|0;z=V_a(y)|0;if((z|0)==0){A=12;break}B$a(z|0,0,y|0)|0;y=z;B=z+u&3;C=((B|0)==0?0:4-B|0)+u|0;B=z+C|0;D=B;E=C+x|0;C=z+E&3;F=((C|0)==0?0:4-C|0)+E|0;E=z+F|0;C=E;G=F+x|0;x=z+G&3;F=((x|0)==0?0:4-x|0)+G|0;G=z+F|0;x=F+w|0;w=z+x&3;if((v|0)>0){F=t<<3;H=0;I=z+(((w|0)==0?0:4-w|0)+x)|0;while(1){c[E+(H<<3)+4>>2]=I;c[B+(H<<3)+4>>2]=I+u;x=H+1|0;if((x|0)<(v|0)){I=I+F|0;H=x}else{J=0;break}}do{c[G+(J<<3)>>2]=-1;J=J+1|0;}while((J|0)<(v|0))}v=ZZa(h,b,4)|0;if((v|0)<1){if((v|0)<0){A=1;break}K=v+1|0}else{K=v}v=k+8|0;H=(s|0)==0;F=(o|0)==0;I=(t|0)>0;B=k+12|0;E=k+44|0;x=k+32|0;w=k+36|0;L=(t|0)==0;M=I^1;N=-1;O=0;P=0;Q=K;R=0;S=C;T=D;U=D;V=b+K|0;W=y;while(1){if((N|0)<0){X=c[v>>2]|0;Y=X+8|0;b:do{if((c[Y>>2]|0)==0){Z=N;_=O;$=U}else{aa=(P|0)==0;ba=(R|0)==95;ca=(P|0)<1&F;da=((R|0)!=10|H)^1;ea=Y;ga=N;ha=O;ia=U;ja=X;while(1){ka=ea;la=ja;c:while(1){ma=la+12|0;if((c[G+(c[ma>>2]<<3)>>2]|0)>=(P|0)){na=ga;oa=ha;pa=ia;break}qa=la+20|0;ra=c[qa>>2]|0;if((ra|0)==0){sa=260;break}d:do{if((ra&1|0)==0|ca|da){if((ra&2|0)!=0){ta=c[h>>2]|0;if((ta|q|0)!=0&((ta|0)!=10|H)){break}}do{if((ra&16|0)!=0){if(ba){break d}if((EZa(R)|0)!=0){break d}ta=c[h>>2]|0;if((ta|0)==95){break}if((EZa(ta)|0)==0){break d}}}while(0);ta=c[qa>>2]|0;if((ta&32|0)==0){ua=ta}else{if(!ba){if((EZa(R)|0)==0){break}}ta=c[h>>2]|0;if((ta|0)==95){break}if((EZa(ta)|0)!=0){break}ua=c[qa>>2]|0}do{if((ua&64|0)==0|aa){va=ua}else{ta=c[h>>2]|0;if((ta|0)==0){va=ua;break}if(ba){wa=ta;xa=1}else{ta=(EZa(R)|0)!=0|0;wa=c[h>>2]|0;xa=ta}if((wa|0)==95){ya=1}else{ya=(EZa(wa)|0)!=0|0}if((xa|0)==(ya|0)){break d}va=c[qa>>2]|0}}while(0);if((va&128|0)==0){sa=260;break c}if(aa){break}ta=c[h>>2]|0;if((ta|0)==0){break}if(ba){za=ta;Aa=1}else{ta=(EZa(R)|0)!=0|0;za=c[h>>2]|0;Aa=ta}if((za|0)==95){Ba=1}else{Ba=(EZa(za)|0)!=0|0}if((Aa|0)==(Ba|0)){sa=260;break c}}}while(0);qa=la+40|0;if((c[qa>>2]|0)==0){Z=ga;_=ha;$=ia;break b}else{ka=qa;la=la+32|0}}if((sa|0)==260){sa=0;qa=ia;c[qa>>2]=c[ka>>2];if(I){B$a(c[ia+4>>2]|0,-1,u|0)|0}ra=c[la+16>>2]|0;do{if((ra|0)!=0){ta=c[ra>>2]|0;if(!((ta|0)>-1)){break}Ca=ia+4|0;Da=ta;ta=ra;do{if((Da|0)<(t|0)){c[(c[Ca>>2]|0)+(Da<<2)>>2]=P}ta=ta+4|0;Da=c[ta>>2]|0;}while((Da|0)>-1)}}while(0);ra=(c[qa>>2]|0)!=(c[B>>2]|0);if(ra|M){Ea=ia+4|0;Fa=ra?ga:P;Ga=ra?ha:1}else{ra=ia+4|0;ka=c[ra>>2]|0;Da=0;while(1){c[n+(Da<<2)>>2]=c[ka+(Da<<2)>>2];ta=Da+1|0;if((ta|0)<(t|0)){Da=ta}else{Ea=ra;Fa=P;Ga=1;break}}}c[G+(c[ma>>2]<<3)>>2]=P;c[G+(c[ma>>2]<<3)+4>>2]=Ea;na=Fa;oa=Ga;pa=ia+8|0}ra=la+40|0;if((c[ra>>2]|0)==0){Z=na;_=oa;$=pa;break}else{ea=ra;ga=na;ha=oa;ia=pa;ja=la+32|0}}}}while(0);c[$>>2]=0;Ha=Z;Ia=_}else{if(L|(U|0)==(T|0)){Ja=N;break}else{Ha=N;Ia=O}}X=c[h>>2]|0;if((X|0)==0){Ja=Ha;break}Y=P+Q|0;ja=ZZa(h,V,4)|0;if((ja|0)<1){if((ja|0)<0){A=1;break a}Ka=ja+1|0}else{Ka=ja}ja=V+Ka|0;if((c[E>>2]|0)==0|(Ia|0)==0){La=Ia;Ma=T;Na=S}else{ia=T;ha=c[ia>>2]|0;if((ha|0)==0){Oa=S}else{ga=ha;ha=ia;ia=S;while(1){ea=c[w>>2]|0;ba=c[ea>>2]|0;aa=ha+4|0;e:do{if((ba|0)>-1){da=ba;ca=0;while(1){ra=c[ea+((ca|1)<<2)>>2]|0;if((da|0)>=(t|0)){Pa=ia;break e}Da=c[aa>>2]|0;if((c[Da+(ra<<2)>>2]|0)==(c[n+(ra<<2)>>2]|0)){if((c[Da+(da<<2)>>2]|0)<(c[n+(da<<2)>>2]|0)){Pa=ia;break e}}Da=ca+2|0;ra=c[ea+(Da<<2)>>2]|0;if((ra|0)>-1){da=ra;ca=Da}else{sa=287;break}}}else{sa=287}}while(0);if((sa|0)==287){sa=0;c[ia>>2]=ga;ea=ia+4|0;ba=c[ea>>2]|0;c[ea>>2]=c[aa>>2];c[aa>>2]=ba;Pa=ia+8|0}ba=ha+8|0;ea=c[ba>>2]|0;if((ea|0)==0){Oa=Pa;break}else{ga=ea;ha=ba;ia=Pa}}}c[Oa>>2]=0;La=0;Ma=S;Na=T}ia=c[Ma>>2]|0;if((ia|0)==0){Qa=Ha;Ra=La;Sa=Na;Ta=W}else{ha=(Y|0)==0;ga=(X|0)==95;ba=(Y|0)<1&F;ea=((X|0)!=10|H)^1;ca=ia;ia=Ha;da=La;la=Ma;Da=Na;ra=W;while(1){ka=ca+8|0;if((c[ka>>2]|0)==0){Ua=ia;Va=da;Wa=Da;Xa=ra}else{qa=la+4|0;ta=ka;ka=ia;Ca=da;Ya=Da;Za=ra;_a=ca;while(1){f:do{if((c[_a>>2]|0)>>>0>X>>>0){$a=ka;ab=Ca;bb=Ya;cb=Za}else{if((c[_a+4>>2]|0)>>>0<X>>>0){$a=ka;ab=Ca;bb=Ya;cb=Za;break}db=_a+20|0;eb=c[db>>2]|0;g:do{if((eb|0)!=0){if(!((eb&1|0)==0|ba|ea)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((eb&2|0)!=0){fb=c[h>>2]|0;if((fb|q|0)!=0&((fb|0)!=10|H)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}do{if((eb&16|0)!=0){if(ga){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((EZa(X)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}fb=c[h>>2]|0;if((fb|0)==95){break}if((EZa(fb)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}}while(0);fb=c[db>>2]|0;if((fb&32|0)==0){gb=fb}else{if(!ga){if((EZa(X)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}fb=c[h>>2]|0;if((fb|0)==95){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((EZa(fb)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}gb=c[db>>2]|0}do{if((gb&64|0)==0|ha){hb=gb}else{fb=c[h>>2]|0;if((fb|0)==0){hb=gb;break}if(ga){ib=fb;jb=1}else{fb=(EZa(X)|0)!=0|0;ib=c[h>>2]|0;jb=fb}if((ib|0)==95){kb=1}else{kb=(EZa(ib)|0)!=0|0}if((jb|0)==(kb|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}hb=c[db>>2]|0}}while(0);if((hb&128|0)==0){lb=hb}else{if(ha){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}fb=c[h>>2]|0;if((fb|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if(ga){mb=fb;nb=1}else{fb=(EZa(X)|0)!=0|0;mb=c[h>>2]|0;nb=fb}if((mb|0)==95){ob=1}else{ob=(EZa(mb)|0)!=0|0}if((nb|0)!=(ob|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}lb=c[db>>2]|0}do{if((lb&4|0)==0){pb=lb}else{if((c[r>>2]&2|0)!=0){pb=lb;break}if((IZa(X,c[_a+24>>2]|0)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}pb=c[db>>2]|0}}while(0);do{if((pb&4|0)!=0){if((c[r>>2]&2|0)==0){break}fb=UZa(X)|0;qb=_a+24|0;if((IZa(fb,c[qb>>2]|0)|0)!=0){break}fb=SZa(X)|0;if((IZa(fb,c[qb>>2]|0)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}}while(0);if((c[db>>2]&8|0)==0){break}qb=c[_a+28>>2]|0;fb=c[qb>>2]|0;if((fb|0)==0){break}if((c[r>>2]&2|0)==0){rb=qb;sb=fb;while(1){if((IZa(X,sb)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}rb=rb+4|0;sb=c[rb>>2]|0;if((sb|0)==0){break g}}}else{tb=qb}do{sb=SZa(X)|0;if((IZa(sb,c[tb>>2]|0)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}sb=UZa(X)|0;if((IZa(sb,c[tb>>2]|0)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}tb=tb+4|0;}while((c[tb>>2]|0)!=0)}}while(0);if(I){db=c[qa>>2]|0;eb=0;do{c[Za+(eb<<2)>>2]=c[db+(eb<<2)>>2];eb=eb+1|0;}while((eb|0)<(t|0))}eb=c[_a+16>>2]|0;do{if((eb|0)!=0){db=c[eb>>2]|0;if((db|0)>-1){ub=db;vb=eb}else{break}do{if((ub|0)<(t|0)){c[Za+(ub<<2)>>2]=Y}vb=vb+4|0;ub=c[vb>>2]|0;}while((ub|0)>-1)}}while(0);eb=_a+12|0;db=c[eb>>2]|0;qb=G+(db<<3)|0;if((c[qb>>2]|0)<(Y|0)){sb=Ya;c[sb>>2]=c[ta>>2];rb=Ya+4|0;fb=c[rb>>2]|0;c[rb>>2]=Za;c[qb>>2]=Y;c[G+(c[eb>>2]<<3)+4>>2]=rb;do{if((c[sb>>2]|0)==(c[B>>2]|0)){if((ka|0)==-1){if(!I){wb=Y;xb=1;break}yb=c[rb>>2]|0}else{if(!I){wb=ka;xb=Ca;break}eb=c[rb>>2]|0;if((c[eb>>2]|0)>(c[n>>2]|0)){wb=ka;xb=Ca;break}else{yb=eb}}eb=0;while(1){c[n+(eb<<2)>>2]=c[yb+(eb<<2)>>2];qb=eb+1|0;if((qb|0)<(t|0)){eb=qb}else{wb=Y;xb=1;break}}}else{wb=ka;xb=Ca}}while(0);$a=wb;ab=xb;bb=Ya+8|0;cb=fb;break}else{rb=c[x>>2]|0;sb=c[G+(db<<3)+4>>2]|0;eb=c[sb>>2]|0;if(I){zb=0}else{$a=ka;ab=Ca;bb=Ya;cb=Za;break}while(1){qb=c[Za+(zb<<2)>>2]|0;Ab=c[eb+(zb<<2)>>2]|0;if((c[rb+(zb<<2)>>2]|0)==0){if((qb|0)<(Ab|0)){break}if((qb|0)>(Ab|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}else{if((qb|0)>(Ab|0)){break}if((qb|0)<(Ab|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}Ab=zb+1|0;if((Ab|0)<(t|0)){zb=Ab}else{$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}c[sb>>2]=Za;if((c[ta>>2]|0)==(c[B>>2]|0)){Bb=0}else{$a=ka;ab=Ca;bb=Ya;cb=eb;break}while(1){c[n+(Bb<<2)>>2]=c[Za+(Bb<<2)>>2];rb=Bb+1|0;if((rb|0)<(t|0)){Bb=rb}else{$a=Y;ab=1;bb=Ya;cb=eb;break}}}}}while(0);eb=_a+40|0;if((c[eb>>2]|0)==0){Ua=$a;Va=ab;Wa=bb;Xa=cb;break}else{ta=eb;ka=$a;Ca=ab;Ya=bb;Za=cb;_a=_a+32|0}}}_a=la+8|0;Za=c[_a>>2]|0;if((Za|0)==0){Qa=Ua;Ra=Va;Sa=Wa;Ta=Xa;break}else{ca=Za;ia=Ua;da=Va;la=_a;Da=Wa;ra=Xa}}}c[Sa>>2]=0;N=Qa;O=Ra;P=Y;Q=Ka;R=X;S=Ma;T=Na;U=Sa;V=ja;W=Ta}W_a(z);Cb=Ja;Db=Ja>>>31;sa=375}else{c[j>>2]=0;W=f&1;V=f&2;U=k+56|0;T=c[U>>2]&4;S=r_a(0,0)|0;if((S|0)==0){A=12;break}R=t_a(S,0,0,0,32)|0;Q=R;if((R|0)==0){s_a(S);A=12;break}c[R+24>>2]=0;c[R+28>>2]=0;R=c[l>>2]|0;if((R|0)==0){Eb=0;sa=9}else{P=V_a(R<<2)|0;O=P;if((P|0)==0){Fb=0;Gb=0;Hb=12;Ib=0;Jb=O}else{Eb=O;sa=9}}do{if((sa|0)==9){O=Eb;P=c[k+28>>2]|0;if((P|0)==0){Kb=0}else{N=V_a(P<<3)|0;P=N;if((N|0)==0){Fb=0;Gb=P;Hb=12;Ib=0;Jb=Eb;break}else{Kb=P}}P=k+52|0;N=c[P>>2]|0;if((N|0)==0){Lb=0}else{B=V_a(N<<2)|0;N=B;if((B|0)==0){Fb=0;Gb=Kb;Hb=12;Ib=N;Jb=Eb;break}else{Lb=N}}N=Lb;B=(n|0)==0;I=k+8|0;G=k+12|0;x=k+32|0;r=(T|0)==0;H=(W|0)==0;q=R;F=-1;w=1;E=-1;L=Q;M=b;h:while(1){do{if((q|0)>0){if(B){B$a(O|0,-1,q<<2|0)|0;break}else{u=0;do{c[Eb+(u<<2)>>2]=-1;c[n+(u<<2)>>2]=-1;u=u+1|0;}while((u|0)<(c[l>>2]|0))}}}while(0);u=c[P>>2]|0;if((u|0)>0){B$a(N|0,0,u<<2|0)|0}u=c[j>>2]|0;v=w+E|0;y=ZZa(j,M,4)|0;if((y|0)<1){if((y|0)<0){A=1;break a}Mb=y+1|0}else{Mb=y}y=M+Mb|0;D=c[j>>2]|0;C=c[I>>2]|0;o=C+8|0;if((c[o>>2]|0)==0){Nb=F;Ob=0;Pb=Mb;Qb=L;sa=196}else{s=(v|0)==0;ra=(u|0)==95;Da=(v|0)<1&H;la=((u|0)!=10|r)^1;da=o;o=0;ia=L;ca=0;ga=C;while(1){C=ga+20|0;ha=c[C>>2]|0;i:do{if((ha|0)==0){sa=56}else{if(!((ha&1|0)==0|Da|la)){Rb=o;Sb=ia;Tb=ca;break}if((ha&2|0)!=0){ea=c[j>>2]|0;if((ea|V|0)!=0&((ea|0)!=10|r)){Rb=o;Sb=ia;Tb=ca;break}}do{if((ha&16|0)!=0){if(ra){Rb=o;Sb=ia;Tb=ca;break i}if((EZa(u)|0)!=0){Rb=o;Sb=ia;Tb=ca;break i}ea=c[j>>2]|0;if((ea|0)==95){break}if((EZa(ea)|0)==0){Rb=o;Sb=ia;Tb=ca;break i}}}while(0);ea=c[C>>2]|0;if((ea&32|0)==0){Ub=ea}else{if(!ra){if((EZa(u)|0)==0){Rb=o;Sb=ia;Tb=ca;break}}ea=c[j>>2]|0;if((ea|0)==95){Rb=o;Sb=ia;Tb=ca;break}if((EZa(ea)|0)!=0){Rb=o;Sb=ia;Tb=ca;break}Ub=c[C>>2]|0}do{if((Ub&64|0)==0|s){Vb=Ub}else{ea=c[j>>2]|0;if((ea|0)==0){Vb=Ub;break}if(ra){Wb=ea;Xb=1}else{ea=(EZa(u)|0)!=0|0;Wb=c[j>>2]|0;Xb=ea}if((Wb|0)==95){Yb=1}else{Yb=(EZa(Wb)|0)!=0|0}if((Xb|0)==(Yb|0)){Rb=o;Sb=ia;Tb=ca;break i}Vb=c[C>>2]|0}}while(0);if((Vb&128|0)==0){sa=56;break}if(s){Rb=o;Sb=ia;Tb=ca;break}ea=c[j>>2]|0;if((ea|0)==0){Rb=o;Sb=ia;Tb=ca;break}if(ra){Zb=ea;_b=1}else{ea=(EZa(u)|0)!=0|0;Zb=c[j>>2]|0;_b=ea}if((Zb|0)==95){$b=1}else{$b=(EZa(Zb)|0)!=0|0}if((_b|0)==($b|0)){sa=56}else{Rb=o;Sb=ia;Tb=ca}}}while(0);do{if((sa|0)==56){sa=0;if((ca|0)==0){Rb=c[ga+16>>2]|0;Sb=ia;Tb=c[da>>2]|0;break}C=ia+28|0;ha=c[C>>2]|0;if((ha|0)==0){ea=t_a(S,0,0,0,32)|0;ba=ea;if((ea|0)==0){sa=60;break h}c[ea+24>>2]=ia;c[ea+28>>2]=0;_a=t_a(S,0,0,0,c[l>>2]<<2)|0;c[ea+20>>2]=_a;if((_a|0)==0){sa=67;break h}c[C>>2]=ba;ac=ba}else{ac=ha}c[ac>>2]=v;c[ac+4>>2]=y;c[ac+8>>2]=c[da>>2];c[ac+12>>2]=c[ga+12>>2];c[ac+16>>2]=c[j>>2];if((c[l>>2]|0)>0){ha=c[ac+20>>2]|0;ba=0;do{c[ha+(ba<<2)>>2]=c[Eb+(ba<<2)>>2];ba=ba+1|0;}while((ba|0)<(c[l>>2]|0))}ba=c[ga+16>>2]|0;if((ba|0)==0){Rb=o;Sb=ac;Tb=ca;break}ha=c[ba>>2]|0;if(!((ha|0)>-1)){Rb=o;Sb=ac;Tb=ca;break}C=c[ac+20>>2]|0;_a=ha;ha=ba;while(1){ba=ha+4|0;c[C+(_a<<2)>>2]=v;ea=c[ba>>2]|0;if((ea|0)>-1){ha=ba;_a=ea}else{Rb=o;Sb=ac;Tb=ca;break}}}}while(0);_a=ga+40|0;if((c[_a>>2]|0)==0){break}else{da=_a;o=Rb;ia=Sb;ca=Tb;ga=ga+32|0}}do{if((Rb|0)==0){bc=0}else{ga=c[Rb>>2]|0;if((ga|0)>-1){cc=ga;dc=Rb}else{bc=Rb;break}while(1){c[Eb+(cc<<2)>>2]=v;ga=dc+4|0;ca=c[ga>>2]|0;if((ca|0)>-1){dc=ga;cc=ca}else{bc=ga;break}}}}while(0);if((Tb|0)==0){Nb=F;Ob=bc;Pb=Mb;Qb=Sb;sa=196}else{ec=F;fc=bc;gc=v;hc=Mb;ic=Sb;jc=Tb;kc=y}}j:while(1){if((sa|0)==196){sa=0;ga=c[Qb+24>>2]|0;if((ga|0)==0){break}ca=c[Qb+8>>2]|0;if((c[ca+20>>2]&256|0)!=0){c[Lb+(c[Qb+12>>2]<<2)>>2]=0}ia=c[Qb>>2]|0;o=c[Qb+4>>2]|0;c[j>>2]=c[Qb+16>>2];da=c[l>>2]|0;if((da|0)<=0){ec=Nb;fc=Ob;gc=ia;hc=Pb;ic=ga;jc=ca;kc=o;continue}u=c[Qb+20>>2]|0;ra=0;while(1){c[Eb+(ra<<2)>>2]=c[u+(ra<<2)>>2];s=ra+1|0;if((s|0)<(da|0)){ra=s}else{ec=Nb;fc=Ob;gc=ia;hc=Pb;ic=ga;jc=ca;kc=o;continue j}}}if((jc|0)==(c[G>>2]|0)){lc=fc;mc=gc;nc=hc;oc=ic}else{o=fc;ca=gc;ga=hc;ia=ic;ra=jc;da=kc;while(1){u=ra+8|0;do{if((c[u>>2]|0)==0){sa=109}else{if((c[ra+20>>2]&256|0)==0){sa=109;break}s=c[ra+24>>2]|0;q_a(s+1|0,Kb,c[U>>2]&-9,a,Eb,ca);la=c[Kb+(s<<3)>>2]|0;Da=c[Kb+(s<<3)+4>>2]|0;s=Da-la|0;if((u$a(b+la|0,da+ -1|0,s)|0)!=0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}_a=(Da|0)==(la|0);la=_a&1;Da=Lb+(c[ra+12>>2]<<2)|0;if(_a){if((c[Da>>2]|0)!=0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}}c[Da>>2]=la;la=s+ -1|0;s=la+ca|0;Da=c[j>>2]|0;_a=ZZa(j,da+la|0,4)|0;if((_a|0)<1){if((_a|0)<0){A=1;break a}pc=_a+1|0}else{pc=_a}qc=s;rc=pc+la|0;sc=pc;tc=Da}}while(0);do{if((sa|0)==109){sa=0;Da=c[j>>2]|0;if((Da|0)==0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}la=ZZa(j,da,4)|0;if((la|0)>=1){qc=ca;rc=la;sc=la;tc=Da;break}if((la|0)<0){A=1;break a}s=la+1|0;qc=ca;rc=s;sc=s;tc=Da}}while(0);Da=da+rc|0;s=qc+ga|0;if((c[u>>2]|0)==0){Nb=ec;Ob=o;Pb=sc;Qb=ia;sa=196;continue j}la=(s|0)==0;_a=(tc|0)==95;ha=(s|0)<1&H;C=((tc|0)!=10|r)^1;ea=u;ba=0;Za=o;Ya=ia;Ca=ra;while(1){k:do{if((c[Ca>>2]|0)>>>0>tc>>>0){uc=ba;vc=Za;wc=Ya}else{if((c[Ca+4>>2]|0)>>>0<tc>>>0){uc=ba;vc=Za;wc=Ya;break}ka=Ca+20|0;ta=c[ka>>2]|0;l:do{if((ta|0)!=0){if(!((ta&1|0)==0|ha|C)){uc=ba;vc=Za;wc=Ya;break k}if((ta&2|0)!=0){qa=c[j>>2]|0;if((qa|V|0)!=0&((qa|0)!=10|r)){uc=ba;vc=Za;wc=Ya;break k}}do{if((ta&16|0)!=0){if(_a){uc=ba;vc=Za;wc=Ya;break k}if((EZa(tc)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}qa=c[j>>2]|0;if((qa|0)==95){break}if((EZa(qa)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}}while(0);qa=c[ka>>2]|0;if((qa&32|0)==0){xc=qa}else{if(!_a){if((EZa(tc)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}qa=c[j>>2]|0;if((qa|0)==95){uc=ba;vc=Za;wc=Ya;break k}if((EZa(qa)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}xc=c[ka>>2]|0}do{if((xc&64|0)==0|la){yc=xc}else{qa=c[j>>2]|0;if((qa|0)==0){yc=xc;break}if(_a){zc=qa;Ac=1}else{qa=(EZa(tc)|0)!=0|0;zc=c[j>>2]|0;Ac=qa}if((zc|0)==95){Bc=1}else{Bc=(EZa(zc)|0)!=0|0}if((Ac|0)==(Bc|0)){uc=ba;vc=Za;wc=Ya;break k}yc=c[ka>>2]|0}}while(0);if((yc&128|0)==0){Cc=yc}else{if(la){uc=ba;vc=Za;wc=Ya;break k}qa=c[j>>2]|0;if((qa|0)==0){uc=ba;vc=Za;wc=Ya;break k}if(_a){Dc=qa;Ec=1}else{qa=(EZa(tc)|0)!=0|0;Dc=c[j>>2]|0;Ec=qa}if((Dc|0)==95){Fc=1}else{Fc=(EZa(Dc)|0)!=0|0}if((Ec|0)!=(Fc|0)){uc=ba;vc=Za;wc=Ya;break k}Cc=c[ka>>2]|0}do{if((Cc&4|0)==0){Gc=Cc}else{if((c[U>>2]&2|0)!=0){Gc=Cc;break}if((IZa(tc,c[Ca+24>>2]|0)|0)==0){uc=ba;vc=Za;wc=Ya;break k}Gc=c[ka>>2]|0}}while(0);do{if((Gc&4|0)!=0){if((c[U>>2]&2|0)==0){break}qa=UZa(tc)|0;aa=Ca+24|0;if((IZa(qa,c[aa>>2]|0)|0)!=0){break}qa=SZa(tc)|0;if((IZa(qa,c[aa>>2]|0)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}}while(0);if((c[ka>>2]&8|0)==0){break}aa=c[Ca+28>>2]|0;qa=c[aa>>2]|0;if((qa|0)==0){break}if((c[U>>2]&2|0)==0){eb=aa;sb=qa;while(1){if((IZa(tc,sb)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}eb=eb+4|0;sb=c[eb>>2]|0;if((sb|0)==0){break l}}}else{Hc=aa}do{sb=SZa(tc)|0;if((IZa(sb,c[Hc>>2]|0)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}sb=UZa(tc)|0;if((IZa(sb,c[Hc>>2]|0)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}Hc=Hc+4|0;}while((c[Hc>>2]|0)!=0)}}while(0);if((ba|0)==0){uc=c[ea>>2]|0;vc=c[Ca+16>>2]|0;wc=Ya;break}ka=Ya+28|0;ta=c[ka>>2]|0;if((ta|0)==0){aa=t_a(S,0,0,0,32)|0;sb=aa;if((aa|0)==0){sa=169;break h}c[aa+24>>2]=Ya;c[aa+28>>2]=0;eb=t_a(S,0,0,0,c[l>>2]<<2)|0;c[aa+20>>2]=eb;if((eb|0)==0){sa=176;break h}c[ka>>2]=sb;Ic=sb}else{Ic=ta}c[Ic>>2]=s;c[Ic+4>>2]=Da;c[Ic+8>>2]=c[ea>>2];c[Ic+12>>2]=c[Ca+12>>2];c[Ic+16>>2]=c[j>>2];if((c[l>>2]|0)>0){ta=c[Ic+20>>2]|0;sb=0;do{c[ta+(sb<<2)>>2]=c[Eb+(sb<<2)>>2];sb=sb+1|0;}while((sb|0)<(c[l>>2]|0))}sb=c[Ca+16>>2]|0;if((sb|0)==0){uc=ba;vc=Za;wc=Ic;break}ta=c[sb>>2]|0;if(!((ta|0)>-1)){uc=ba;vc=Za;wc=Ic;break}ka=c[Ic+20>>2]|0;eb=ta;ta=sb;while(1){c[ka+(eb<<2)>>2]=s;sb=ta+4|0;aa=c[sb>>2]|0;if((aa|0)>-1){ta=sb;eb=aa}else{uc=ba;vc=Za;wc=Ic;break}}}}while(0);eb=Ca+40|0;if((c[eb>>2]|0)==0){break}else{ea=eb;ba=uc;Za=vc;Ya=wc;Ca=Ca+32|0}}if((uc|0)==0){Nb=ec;Ob=vc;Pb=sc;Qb=wc;sa=196;continue j}do{if((vc|0)==0){Jc=0}else{Ca=c[vc>>2]|0;if((Ca|0)>-1){Kc=Ca;Lc=vc}else{Jc=vc;break}while(1){Ca=Lc+4|0;c[Eb+(Kc<<2)>>2]=s;Ya=c[Ca>>2]|0;if((Ya|0)>-1){Lc=Ca;Kc=Ya}else{Jc=Ca;break}}}}while(0);if((uc|0)==(c[G>>2]|0)){lc=Jc;mc=s;nc=sc;oc=wc;break}else{o=Jc;ca=s;ga=sc;ia=wc;ra=uc;da=Da}}}m:do{if((ec|0)<(mc|0)){sa=96}else{if((ec|0)!=(mc|0)|B){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}da=c[l>>2]|0;ra=c[x>>2]|0;if((da|0)>0){Mc=0}else{Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}while(1){ia=c[Eb+(Mc<<2)>>2]|0;ga=c[n+(Mc<<2)>>2]|0;if((c[ra+(Mc<<2)>>2]|0)==0){if((ia|0)<(ga|0)){sa=96;break m}if((ia|0)>(ga|0)){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}else{if((ia|0)>(ga|0)){Nc=da;break m}if((ia|0)<(ga|0)){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}ga=Mc+1|0;if((ga|0)<(da|0)){Mc=ga}else{Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}}}while(0);if((sa|0)==96){sa=0;if(B){Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue}Nc=c[l>>2]|0}if((Nc|0)>0){Oc=0}else{Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue}while(1){c[n+(Oc<<2)>>2]=c[Eb+(Oc<<2)>>2];da=Oc+1|0;if((da|0)<(c[l>>2]|0)){Oc=da}else{Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}}if((Nb|0)>=0){sa=205;break}if((c[j>>2]|0)==0){sa=205;break}c[j>>2]=D;q=c[l>>2]|0;F=Nb;w=Pb;E=v;L=Qb;M=y}if((sa|0)==60){s_a(S);if((Eb|0)!=0){W_a(O)}if((Kb|0)!=0){W_a(Kb)}if((Lb|0)==0){A=12;break a}W_a(N);A=12;break a}else if((sa|0)==67){s_a(S);if((Eb|0)!=0){W_a(O)}if((Kb|0)!=0){W_a(Kb)}if((Lb|0)==0){A=12;break a}W_a(N);A=12;break a}else if((sa|0)==169){s_a(S);if((Eb|0)!=0){W_a(O)}if((Kb|0)!=0){W_a(Kb)}if((Lb|0)==0){A=12;break a}W_a(N);A=12;break a}else if((sa|0)==176){s_a(S);if((Eb|0)!=0){W_a(O)}if((Kb|0)!=0){W_a(Kb)}if((Lb|0)==0){A=12;break a}W_a(N);A=12;break a}else if((sa|0)==205){Fb=Nb;Gb=Kb;Hb=Nb>>>31;Ib=Lb;Jb=Eb;break}}}while(0);s_a(S);if((Jb|0)!=0){W_a(Jb)}if((Gb|0)!=0){W_a(Gb)}if((Ib|0)==0){Cb=Fb;Db=Hb;sa=375;break}W_a(Ib);Cb=Fb;Db=Hb;sa=375}}while(0);do{if((sa|0)==375){if((Db|0)!=0){A=Db;break}q_a(d,e,c[k+56>>2]|0,a,n,Cb);A=0}}while(0);if((n|0)==0){p=A;i=g;return p|0}W_a(m);p=A;i=g;return p|0}function q_a(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;h=i;do{if((g|0)>-1){if((d&8|0)!=0){j=0;break}k=c[e+16>>2]|0;l=e+28|0;m=c[l>>2]|0;n=(a|0)!=0;if((m|0)!=0&n){o=e+48|0;p=0;while(1){q=c[k+(p*12|0)>>2]|0;if((q|0)==(c[o>>2]|0)){c[b+(p<<3)>>2]=g;r=g}else{s=c[f+(q<<2)>>2]|0;c[b+(p<<3)>>2]=s;r=s}s=c[k+(p*12|0)+4>>2]|0;if((s|0)==(c[o>>2]|0)){c[b+(p<<3)+4>>2]=g;t=g}else{q=c[f+(s<<2)>>2]|0;c[b+(p<<3)+4>>2]=q;t=q}if((r|0)==-1|(t|0)==-1){c[b+(p<<3)+4>>2]=-1;c[b+(p<<3)>>2]=-1}q=p+1|0;s=c[l>>2]|0;if(q>>>0<s>>>0&q>>>0<a>>>0){p=q}else{u=s;break}}}else{u=m}if((u|0)!=0&n){v=u;w=0}else{j=0;break}while(1){p=b+(w<<3)+4|0;o=c[k+(w*12|0)+8>>2]|0;do{if((o|0)==0){x=v}else{s=c[o>>2]|0;if(!((s|0)>-1)){x=v;break}q=b+(w<<3)|0;y=c[q>>2]|0;z=s;s=0;while(1){if((y|0)<(c[b+(z<<3)>>2]|0)){A=21}else{if((c[p>>2]|0)>(c[b+(z<<3)+4>>2]|0)){A=21}else{B=y}}if((A|0)==21){A=0;c[p>>2]=-1;c[q>>2]=-1;B=-1}C=s+1|0;D=c[o+(C<<2)>>2]|0;if((D|0)>-1){y=B;z=D;s=C}else{break}}x=c[l>>2]|0}}while(0);o=w+1|0;if(o>>>0<x>>>0&o>>>0<a>>>0){v=x;w=o}else{j=o;break}}}else{j=0}}while(0);if(j>>>0<a>>>0){E=j}else{i=h;return}do{c[b+(E<<3)>>2]=-1;c[b+(E<<3)+4>>2]=-1;E=E+1|0;}while(E>>>0<a>>>0);i=h;return}function r_a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if((a|0)==0){e=X_a(1,24)|0}else{c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;e=b}if((e|0)==0){f=0;i=d;return f|0}f=e;i=d;return f|0}function s_a(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a>>2]|0;if((d|0)==0){e=a;W_a(e);i=b;return}else{f=d}while(1){W_a(c[f>>2]|0);d=c[f+4>>2]|0;W_a(f);if((d|0)==0){break}else{f=d}}e=a;W_a(e);i=b;return}function t_a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;h=a+16|0;if((c[h>>2]|0)!=0){j=0;i=g;return j|0}k=a+12|0;l=c[k>>2]|0;do{if(l>>>0<f>>>0){if((b|0)!=0){if((d|0)!=0){c[a+8>>2]=d;c[k>>2]=1024;m=d;n=1024;break}c[h>>2]=1;j=0;i=g;return j|0}o=f<<3;p=o>>>0>1024?o:1024;o=V_a(8)|0;q=o;if((o|0)==0){c[h>>2]=1;j=0;i=g;return j|0}r=V_a(p)|0;c[o>>2]=r;if((r|0)==0){W_a(o);c[h>>2]=1;j=0;i=g;return j|0}c[o+4>>2]=0;r=a+4|0;s=c[r>>2]|0;if((s|0)!=0){c[s+4>>2]=q}s=a;if((c[s>>2]|0)==0){c[s>>2]=q}c[r>>2]=q;q=c[o>>2]|0;c[a+8>>2]=q;c[k>>2]=p;m=q;n=p}else{m=c[a+8>>2]|0;n=l}}while(0);l=m+f&3;h=((l|0)==0?0:4-l|0)+f|0;c[a+8>>2]=m+h;c[k>>2]=n-h;if((e|0)==0){j=m;i=g;return j|0}B$a(m|0,0,h|0)|0;j=m;i=g;return j|0}function u_a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;if((b|0)==0){e=a+((v_a(a)|0)<<2)|0;i=d;return e|0}else{f=a}while(1){g=c[f>>2]|0;if((g|0)==0|(g|0)==(b|0)){break}else{f=f+4|0}}e=(g|0)!=0?f:0;i=d;return e|0}function v_a(a){a=a|0;var b=0,d=0;b=i;d=a;while(1){if((c[d>>2]|0)==0){break}else{d=d+4|0}}i=b;return d-a>>2|0}function w_a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;if((d|0)==0){i=e;return a|0}else{f=d;g=b;h=a}while(1){b=f+ -1|0;c[h>>2]=c[g>>2];if((b|0)==0){break}else{h=h+4|0;g=g+4|0;f=b}}i=e;return a|0}function x_a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=(d|0)==0;if(a-b>>2>>>0<d>>>0){if(f){i=e;return a|0}else{g=d}do{g=g+ -1|0;c[a+(g<<2)>>2]=c[b+(g<<2)>>2];}while((g|0)!=0);i=e;return a|0}else{if(f){i=e;return a|0}else{h=b;j=a;k=d}while(1){d=k+ -1|0;c[j>>2]=c[h>>2];if((d|0)==0){break}else{k=d;j=j+4|0;h=h+4|0}}i=e;return a|0}return 0}function y_a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((d|0)==0){i=e;return a|0}else{f=d;g=a}while(1){d=f+ -1|0;c[g>>2]=b;if((d|0)==0){break}else{g=g+4|0;f=d}}i=e;return a|0}function z_a(a){a=a|0;i=i;return}function A_a(a){a=a|0;c[a>>2]=295936;i=i;return}function B_a(a){a=a|0;var b=0;b=i;Cb(a|0);b$a(a);i=b;return}function C_a(a){a=a|0;var b=0;b=i;Cb(a|0);i=b;return}function D_a(a){a=a|0;i=i;return 295952}function E_a(a){a=a|0;i=i;return}function F_a(a){a=a|0;i=i;return}function G_a(a){a=a|0;i=i;return}function H_a(a){a=a|0;var b=0;b=i;b$a(a);i=b;return}function I_a(a){a=a|0;var b=0;b=i;b$a(a);i=b;return}function J_a(a){a=a|0;var b=0;b=i;b$a(a);i=b;return}function K_a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+56|0;f=e;if((a|0)==(b|0)){g=1;i=e;return g|0}if((b|0)==0){g=0;i=e;return g|0}h=O_a(b,296064,296120,0)|0;b=h;if((h|0)==0){g=0;i=e;return g|0}j=f+0|0;k=j+56|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));c[f>>2]=b;c[f+8>>2]=a;c[f+12>>2]=-1;c[f+48>>2]=1;Oe[c[(c[h>>2]|0)+28>>2]&127](b,f,c[d>>2]|0,1);if((c[f+24>>2]|0)!=1){g=0;i=e;return g|0}c[d>>2]=c[f+16>>2];g=1;i=e;return g|0}function L_a(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((c[d+8>>2]|0)!=(b|0)){i=g;return}b=d+16|0;h=c[b>>2]|0;if((h|0)==0){c[b>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}e=d+24|0;if((c[e>>2]|0)!=2){i=g;return}c[e>>2]=f;i=g;return}function M_a(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((b|0)!=(c[d+8>>2]|0)){h=c[b+8>>2]|0;Oe[c[(c[h>>2]|0)+28>>2]&127](h,d,e,f);i=g;return}h=d+16|0;b=c[h>>2]|0;if((b|0)==0){c[h>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}e=d+24|0;if((c[e>>2]|0)!=2){i=g;return}c[e>>2]=f;i=g;return}function N_a(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((b|0)==(c[d+8>>2]|0)){h=d+16|0;j=c[h>>2]|0;if((j|0)==0){c[h>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((j|0)!=(e|0)){j=d+36|0;c[j>>2]=(c[j>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}j=d+24|0;if((c[j>>2]|0)!=2){i=g;return}c[j>>2]=f;i=g;return}j=c[b+12>>2]|0;h=b+16+(j<<3)|0;k=c[b+20>>2]|0;l=k>>8;if((k&1|0)==0){m=l}else{m=c[(c[e>>2]|0)+l>>2]|0}l=c[b+16>>2]|0;Oe[c[(c[l>>2]|0)+28>>2]&127](l,d,e+m|0,(k&2|0)!=0?f:2);if((j|0)<=1){i=g;return}j=d+54|0;k=b+24|0;while(1){b=c[k+4>>2]|0;m=b>>8;if((b&1|0)==0){n=m}else{n=c[(c[e>>2]|0)+m>>2]|0}m=c[k>>2]|0;Oe[c[(c[m>>2]|0)+28>>2]&127](m,d,e+n|0,(b&2|0)!=0?f:2);if((a[j]|0)!=0){o=16;break}b=k+8|0;if(b>>>0<h>>>0){k=b}else{o=16;break}}if((o|0)==16){i=g;return}}function O_a(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+56|0;j=h;k=c[d>>2]|0;l=d+(c[k+ -8>>2]|0)|0;m=c[k+ -4>>2]|0;k=m;c[j>>2]=f;c[j+4>>2]=d;c[j+8>>2]=e;c[j+12>>2]=g;g=j+16|0;e=j+20|0;d=j+24|0;n=j+28|0;o=j+32|0;p=j+40|0;q=(m|0)==(f|0);f=g;r=f+0|0;s=r+36|0;do{c[r>>2]=0;r=r+4|0}while((r|0)<(s|0));b[f+36>>1]=0;a[f+38|0]=0;if(q){c[j+48>>2]=1;xe[c[(c[m>>2]|0)+20>>2]&31](k,j,l,l,1,0);t=(c[d>>2]|0)==1?l:0;i=h;return t|0}ie[c[(c[m>>2]|0)+24>>2]&31](k,j,l,1,0);l=c[j+36>>2]|0;if((l|0)==0){if((c[p>>2]|0)!=1){t=0;i=h;return t|0}if((c[n>>2]|0)!=1){t=0;i=h;return t|0}t=(c[o>>2]|0)==1?c[e>>2]|0:0;i=h;return t|0}else if((l|0)==1){do{if((c[d>>2]|0)!=1){if((c[p>>2]|0)!=0){t=0;i=h;return t|0}if((c[n>>2]|0)!=1){t=0;i=h;return t|0}if((c[o>>2]|0)==1){break}else{t=0}i=h;return t|0}}while(0);t=c[g>>2]|0;i=h;return t|0}else{t=0;i=h;return t|0}return 0}function P_a(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;h=i;j=b;if((j|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}k=d+28|0;if((c[k>>2]|0)==1){i=h;return}c[k>>2]=f;i=h;return}if((j|0)==(c[d>>2]|0)){do{if((c[d+16>>2]|0)!=(e|0)){j=d+20|0;if((c[j>>2]|0)==(e|0)){break}c[d+32>>2]=f;k=d+44|0;if((c[k>>2]|0)==4){i=h;return}l=c[b+12>>2]|0;m=b+16+(l<<3)|0;a:do{if((l|0)>0){n=d+52|0;o=d+53|0;p=d+54|0;q=b+8|0;r=d+24|0;s=0;t=0;u=b+16|0;b:while(1){a[n]=0;a[o]=0;v=c[u+4>>2]|0;w=v>>8;if((v&1|0)==0){x=w}else{x=c[(c[e>>2]|0)+w>>2]|0}w=c[u>>2]|0;xe[c[(c[w>>2]|0)+20>>2]&31](w,d,e,e+x|0,2-(v>>>1&1)|0,g);if((a[p]|0)!=0){y=s;z=t;break}do{if((a[o]|0)==0){A=s;B=t}else{if((a[n]|0)==0){if((c[q>>2]&1|0)==0){y=s;z=1;break b}else{A=s;B=1;break}}if((c[r>>2]|0)==1){C=27;break a}if((c[q>>2]&2|0)==0){C=27;break a}else{A=1;B=1}}}while(0);v=u+8|0;if(v>>>0<m>>>0){s=A;t=B;u=v}else{y=A;z=B;break}}if(y){D=z;C=26}else{E=z;C=23}}else{E=0;C=23}}while(0);do{if((C|0)==23){c[j>>2]=e;m=d+40|0;c[m>>2]=(c[m>>2]|0)+1;if((c[d+36>>2]|0)!=1){D=E;C=26;break}if((c[d+24>>2]|0)!=2){D=E;C=26;break}a[d+54|0]=1;if(E){C=27}else{C=28}}}while(0);if((C|0)==26){if(D){C=27}else{C=28}}if((C|0)==27){c[k>>2]=3;i=h;return}else if((C|0)==28){c[k>>2]=4;i=h;return}}}while(0);if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}D=c[b+12>>2]|0;E=b+16+(D<<3)|0;z=c[b+20>>2]|0;y=z>>8;if((z&1|0)==0){F=y}else{F=c[(c[e>>2]|0)+y>>2]|0}y=c[b+16>>2]|0;ie[c[(c[y>>2]|0)+24>>2]&31](y,d,e+F|0,(z&2|0)!=0?f:2,g);z=b+24|0;if((D|0)<=1){i=h;return}D=c[b+8>>2]|0;do{if((D&2|0)==0){b=d+36|0;if((c[b>>2]|0)==1){break}if((D&1|0)==0){F=d+54|0;y=z;while(1){if((a[F]|0)!=0){C=53;break}if((c[b>>2]|0)==1){C=53;break}B=c[y+4>>2]|0;A=B>>8;if((B&1|0)==0){G=A}else{G=c[(c[e>>2]|0)+A>>2]|0}A=c[y>>2]|0;ie[c[(c[A>>2]|0)+24>>2]&31](A,d,e+G|0,(B&2|0)!=0?f:2,g);B=y+8|0;if(B>>>0<E>>>0){y=B}else{C=53;break}}if((C|0)==53){i=h;return}}y=d+24|0;F=d+54|0;k=z;while(1){if((a[F]|0)!=0){C=53;break}if((c[b>>2]|0)==1){if((c[y>>2]|0)==1){C=53;break}}B=c[k+4>>2]|0;A=B>>8;if((B&1|0)==0){H=A}else{H=c[(c[e>>2]|0)+A>>2]|0}A=c[k>>2]|0;ie[c[(c[A>>2]|0)+24>>2]&31](A,d,e+H|0,(B&2|0)!=0?f:2,g);B=k+8|0;if(B>>>0<E>>>0){k=B}else{C=53;break}}if((C|0)==53){i=h;return}}}while(0);H=d+54|0;G=z;while(1){if((a[H]|0)!=0){C=53;break}z=c[G+4>>2]|0;D=z>>8;if((z&1|0)==0){I=D}else{I=c[(c[e>>2]|0)+D>>2]|0}D=c[G>>2]|0;ie[c[(c[D>>2]|0)+24>>2]&31](D,d,e+I|0,(z&2|0)!=0?f:2,g);z=G+8|0;if(z>>>0<E>>>0){G=z}else{C=53;break}}if((C|0)==53){i=h;return}}function Q_a(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b;if((j|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}k=d+28|0;if((c[k>>2]|0)==1){i=h;return}c[k>>2]=f;i=h;return}if((j|0)!=(c[d>>2]|0)){j=c[b+8>>2]|0;ie[c[(c[j>>2]|0)+24>>2]&31](j,d,e,f,g);i=h;return}do{if((c[d+16>>2]|0)!=(e|0)){j=d+20|0;if((c[j>>2]|0)==(e|0)){break}c[d+32>>2]=f;k=d+44|0;if((c[k>>2]|0)==4){i=h;return}l=d+52|0;a[l]=0;m=d+53|0;a[m]=0;n=c[b+8>>2]|0;xe[c[(c[n>>2]|0)+20>>2]&31](n,d,e,e,1,g);if((a[m]|0)==0){o=0;p=13}else{if((a[l]|0)==0){o=1;p=13}}a:do{if((p|0)==13){c[j>>2]=e;l=d+40|0;c[l>>2]=(c[l>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){p=16;break}a[d+54|0]=1;if(o){break a}}else{p=16}}while(0);if((p|0)==16){if(o){break}}c[k>>2]=4;i=h;return}}while(0);c[k>>2]=3;i=h;return}}while(0);if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}function R_a(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;g=i;if((c[d+8>>2]|0)==(b|0)){if((c[d+4>>2]|0)!=(e|0)){i=g;return}h=d+28|0;if((c[h>>2]|0)==1){i=g;return}c[h>>2]=f;i=g;return}if((c[d>>2]|0)!=(b|0)){i=g;return}do{if((c[d+16>>2]|0)!=(e|0)){b=d+20|0;if((c[b>>2]|0)==(e|0)){break}c[d+32>>2]=f;c[b>>2]=e;b=d+40|0;c[b>>2]=(c[b>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){break}a[d+54|0]=1}}while(0);c[d+44>>2]=4;i=g;return}}while(0);if((f|0)!=1){i=g;return}c[d+32>>2]=1;i=g;return}function S_a(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;if((b|0)!=(c[d+8>>2]|0)){k=d+52|0;l=a[k]|0;m=d+53|0;n=a[m]|0;o=c[b+12>>2]|0;p=b+16+(o<<3)|0;a[k]=0;a[m]=0;q=c[b+20>>2]|0;r=q>>8;if((q&1|0)==0){s=r}else{s=c[(c[f>>2]|0)+r>>2]|0}r=c[b+16>>2]|0;xe[c[(c[r>>2]|0)+20>>2]&31](r,d,e,f+s|0,(q&2|0)!=0?g:2,h);a:do{if((o|0)>1){q=d+24|0;s=b+8|0;r=d+54|0;t=b+24|0;do{if((a[r]|0)!=0){break a}do{if((a[k]|0)==0){if((a[m]|0)==0){break}if((c[s>>2]&1|0)==0){break a}}else{if((c[q>>2]|0)==1){break a}if((c[s>>2]&2|0)==0){break a}}}while(0);a[k]=0;a[m]=0;u=c[t+4>>2]|0;v=u>>8;if((u&1|0)==0){w=v}else{w=c[(c[f>>2]|0)+v>>2]|0}v=c[t>>2]|0;xe[c[(c[v>>2]|0)+20>>2]&31](v,d,e,f+w|0,(u&2|0)!=0?g:2,h);t=t+8|0;}while(t>>>0<p>>>0)}}while(0);a[k]=l;a[m]=n;i=j;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=j;return}a[d+52|0]=1;f=d+16|0;n=c[f>>2]|0;if((n|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}if((n|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=j;return}e=d+24|0;n=c[e>>2]|0;if((n|0)==2){c[e>>2]=g;x=g}else{x=n}if(!((c[d+48>>2]|0)==1&(x|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}function T_a(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;if((b|0)!=(c[d+8>>2]|0)){k=c[b+8>>2]|0;xe[c[(c[k>>2]|0)+20>>2]&31](k,d,e,f,g,h);i=j;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=j;return}a[d+52|0]=1;f=d+16|0;h=c[f>>2]|0;if((h|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=j;return}e=d+24|0;h=c[e>>2]|0;if((h|0)==2){c[e>>2]=g;l=g}else{l=h}if(!((c[d+48>>2]|0)==1&(l|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}function U_a(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0;h=i;if((c[d+8>>2]|0)!=(b|0)){i=h;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=h;return}a[d+52|0]=1;f=d+16|0;b=c[f>>2]|0;if((b|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=h;return}a[d+54|0]=1;i=h;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=h;return}e=d+24|0;b=c[e>>2]|0;if((b|0)==2){c[e>>2]=g;j=g}else{j=b}if(!((c[d+48>>2]|0)==1&(j|0)==1)){i=h;return}a[d+54|0]=1;i=h;return}function V_a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0;b=i;do{if(a>>>0<245){if(a>>>0<11){d=16}else{d=a+11&-8}e=d>>>3;f=c[74092]|0;g=f>>>e;if((g&3|0)!=0){h=(g&1^1)+e|0;j=h<<1;k=296408+(j<<2)|0;l=296408+(j+2<<2)|0;j=c[l>>2]|0;m=j+8|0;n=c[m>>2]|0;do{if((k|0)==(n|0)){c[74092]=f&~(1<<h)}else{if(n>>>0<(c[296384>>2]|0)>>>0){md()}o=n+12|0;if((c[o>>2]|0)==(j|0)){c[o>>2]=k;c[l>>2]=n;break}else{md()}}}while(0);n=h<<3;c[j+4>>2]=n|3;l=j+(n|4)|0;c[l>>2]=c[l>>2]|1;p=m;i=b;return p|0}if(!(d>>>0>(c[296376>>2]|0)>>>0)){q=d;break}if((g|0)!=0){l=2<<e;n=g<<e&(l|0-l);l=(n&0-n)+ -1|0;n=l>>>12&16;k=l>>>n;l=k>>>5&8;o=k>>>l;k=o>>>2&4;r=o>>>k;o=r>>>1&2;s=r>>>o;r=s>>>1&1;t=(l|n|k|o|r)+(s>>>r)|0;r=t<<1;s=296408+(r<<2)|0;o=296408+(r+2<<2)|0;r=c[o>>2]|0;k=r+8|0;n=c[k>>2]|0;do{if((s|0)==(n|0)){c[74092]=f&~(1<<t)}else{if(n>>>0<(c[296384>>2]|0)>>>0){md()}l=n+12|0;if((c[l>>2]|0)==(r|0)){c[l>>2]=s;c[o>>2]=n;break}else{md()}}}while(0);n=t<<3;o=n-d|0;c[r+4>>2]=d|3;s=r+d|0;c[r+(d|4)>>2]=o|1;c[r+n>>2]=o;n=c[296376>>2]|0;if((n|0)!=0){f=c[296388>>2]|0;e=n>>>3;n=e<<1;g=296408+(n<<2)|0;m=c[74092]|0;j=1<<e;do{if((m&j|0)==0){c[74092]=m|j;u=296408+(n+2<<2)|0;v=g}else{e=296408+(n+2<<2)|0;h=c[e>>2]|0;if(!(h>>>0<(c[296384>>2]|0)>>>0)){u=e;v=h;break}md()}}while(0);c[u>>2]=f;c[v+12>>2]=f;c[f+8>>2]=v;c[f+12>>2]=g}c[296376>>2]=o;c[296388>>2]=s;p=k;i=b;return p|0}n=c[296372>>2]|0;if((n|0)==0){q=d;break}j=(n&0-n)+ -1|0;n=j>>>12&16;m=j>>>n;j=m>>>5&8;r=m>>>j;m=r>>>2&4;t=r>>>m;r=t>>>1&2;h=t>>>r;t=h>>>1&1;e=c[296672+((j|n|m|r|t)+(h>>>t)<<2)>>2]|0;t=(c[e+4>>2]&-8)-d|0;h=e;r=e;while(1){e=c[h+16>>2]|0;if((e|0)==0){m=c[h+20>>2]|0;if((m|0)==0){break}else{w=m}}else{w=e}e=(c[w+4>>2]&-8)-d|0;m=e>>>0<t>>>0;t=m?e:t;h=w;r=m?w:r}h=r;k=c[296384>>2]|0;if(h>>>0<k>>>0){md()}s=r+d|0;o=s;if(!(h>>>0<s>>>0)){md()}s=c[r+24>>2]|0;h=c[r+12>>2]|0;do{if((h|0)==(r|0)){g=r+20|0;f=c[g>>2]|0;if((f|0)==0){m=r+16|0;e=c[m>>2]|0;if((e|0)==0){x=0;break}else{y=e;z=m}}else{y=f;z=g}while(1){g=y+20|0;f=c[g>>2]|0;if((f|0)!=0){z=g;y=f;continue}f=y+16|0;g=c[f>>2]|0;if((g|0)==0){break}else{y=g;z=f}}if(z>>>0<k>>>0){md()}else{c[z>>2]=0;x=y;break}}else{f=c[r+8>>2]|0;if(f>>>0<k>>>0){md()}g=f+12|0;if((c[g>>2]|0)!=(r|0)){md()}m=h+8|0;if((c[m>>2]|0)==(r|0)){c[g>>2]=h;c[m>>2]=f;x=h;break}else{md()}}}while(0);a:do{if((s|0)!=0){h=c[r+28>>2]|0;k=296672+(h<<2)|0;do{if((r|0)==(c[k>>2]|0)){c[k>>2]=x;if((x|0)!=0){break}c[296372>>2]=c[296372>>2]&~(1<<h);break a}else{if(s>>>0<(c[296384>>2]|0)>>>0){md()}f=s+16|0;if((c[f>>2]|0)==(r|0)){c[f>>2]=x}else{c[s+20>>2]=x}if((x|0)==0){break a}}}while(0);if(x>>>0<(c[296384>>2]|0)>>>0){md()}c[x+24>>2]=s;h=c[r+16>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[296384>>2]|0)>>>0){md()}else{c[x+16>>2]=h;c[h+24>>2]=x;break}}}while(0);h=c[r+20>>2]|0;if((h|0)==0){break}if(h>>>0<(c[296384>>2]|0)>>>0){md()}else{c[x+20>>2]=h;c[h+24>>2]=x;break}}}while(0);if(t>>>0<16){s=t+d|0;c[r+4>>2]=s|3;h=r+(s+4)|0;c[h>>2]=c[h>>2]|1}else{c[r+4>>2]=d|3;c[r+(d|4)>>2]=t|1;c[r+(t+d)>>2]=t;h=c[296376>>2]|0;if((h|0)!=0){s=c[296388>>2]|0;k=h>>>3;h=k<<1;f=296408+(h<<2)|0;m=c[74092]|0;g=1<<k;do{if((m&g|0)==0){c[74092]=m|g;A=296408+(h+2<<2)|0;B=f}else{k=296408+(h+2<<2)|0;e=c[k>>2]|0;if(!(e>>>0<(c[296384>>2]|0)>>>0)){A=k;B=e;break}md()}}while(0);c[A>>2]=s;c[B+12>>2]=s;c[s+8>>2]=B;c[s+12>>2]=f}c[296376>>2]=t;c[296388>>2]=o}p=r+8|0;i=b;return p|0}else{if(a>>>0>4294967231){q=-1;break}h=a+11|0;g=h&-8;m=c[296372>>2]|0;if((m|0)==0){q=g;break}e=0-g|0;k=h>>>8;do{if((k|0)==0){C=0}else{if(g>>>0>16777215){C=31;break}h=(k+1048320|0)>>>16&8;n=k<<h;j=(n+520192|0)>>>16&4;l=n<<j;n=(l+245760|0)>>>16&2;D=14-(j|h|n)+(l<<n>>>15)|0;C=g>>>(D+7|0)&1|D<<1}}while(0);k=c[296672+(C<<2)>>2]|0;b:do{if((k|0)==0){E=e;F=0;G=0}else{if((C|0)==31){H=0}else{H=25-(C>>>1)|0}r=e;o=0;t=g<<H;f=k;s=0;while(1){D=c[f+4>>2]&-8;n=D-g|0;if(n>>>0<r>>>0){if((D|0)==(g|0)){E=n;F=f;G=f;break b}else{I=n;J=f}}else{I=r;J=s}n=c[f+20>>2]|0;D=c[f+16+(t>>>31<<2)>>2]|0;l=(n|0)==0|(n|0)==(D|0)?o:n;if((D|0)==0){E=I;F=l;G=J;break}else{r=I;o=l;t=t<<1;f=D;s=J}}}}while(0);if((F|0)==0&(G|0)==0){k=2<<C;e=m&(k|0-k);if((e|0)==0){q=g;break}k=(e&0-e)+ -1|0;e=k>>>12&16;s=k>>>e;k=s>>>5&8;f=s>>>k;s=f>>>2&4;t=f>>>s;f=t>>>1&2;o=t>>>f;t=o>>>1&1;K=c[296672+((k|e|s|f|t)+(o>>>t)<<2)>>2]|0}else{K=F}if((K|0)==0){L=E;M=G}else{t=E;o=K;f=G;while(1){s=(c[o+4>>2]&-8)-g|0;e=s>>>0<t>>>0;k=e?s:t;s=e?o:f;e=c[o+16>>2]|0;if((e|0)!=0){N=s;O=k;f=N;o=e;t=O;continue}e=c[o+20>>2]|0;if((e|0)==0){L=k;M=s;break}else{N=s;O=k;o=e;f=N;t=O}}}if((M|0)==0){q=g;break}if(!(L>>>0<((c[296376>>2]|0)-g|0)>>>0)){q=g;break}t=M;f=c[296384>>2]|0;if(t>>>0<f>>>0){md()}o=M+g|0;m=o;if(!(t>>>0<o>>>0)){md()}t=c[M+24>>2]|0;e=c[M+12>>2]|0;do{if((e|0)==(M|0)){k=M+20|0;s=c[k>>2]|0;if((s|0)==0){r=M+16|0;D=c[r>>2]|0;if((D|0)==0){P=0;break}else{Q=D;R=r}}else{Q=s;R=k}while(1){k=Q+20|0;s=c[k>>2]|0;if((s|0)!=0){R=k;Q=s;continue}s=Q+16|0;k=c[s>>2]|0;if((k|0)==0){break}else{Q=k;R=s}}if(R>>>0<f>>>0){md()}else{c[R>>2]=0;P=Q;break}}else{s=c[M+8>>2]|0;if(s>>>0<f>>>0){md()}k=s+12|0;if((c[k>>2]|0)!=(M|0)){md()}r=e+8|0;if((c[r>>2]|0)==(M|0)){c[k>>2]=e;c[r>>2]=s;P=e;break}else{md()}}}while(0);c:do{if((t|0)!=0){e=c[M+28>>2]|0;f=296672+(e<<2)|0;do{if((M|0)==(c[f>>2]|0)){c[f>>2]=P;if((P|0)!=0){break}c[296372>>2]=c[296372>>2]&~(1<<e);break c}else{if(t>>>0<(c[296384>>2]|0)>>>0){md()}s=t+16|0;if((c[s>>2]|0)==(M|0)){c[s>>2]=P}else{c[t+20>>2]=P}if((P|0)==0){break c}}}while(0);if(P>>>0<(c[296384>>2]|0)>>>0){md()}c[P+24>>2]=t;e=c[M+16>>2]|0;do{if((e|0)!=0){if(e>>>0<(c[296384>>2]|0)>>>0){md()}else{c[P+16>>2]=e;c[e+24>>2]=P;break}}}while(0);e=c[M+20>>2]|0;if((e|0)==0){break}if(e>>>0<(c[296384>>2]|0)>>>0){md()}else{c[P+20>>2]=e;c[e+24>>2]=P;break}}}while(0);d:do{if(L>>>0<16){t=L+g|0;c[M+4>>2]=t|3;e=M+(t+4)|0;c[e>>2]=c[e>>2]|1}else{c[M+4>>2]=g|3;c[M+(g|4)>>2]=L|1;c[M+(L+g)>>2]=L;e=L>>>3;if(L>>>0<256){t=e<<1;f=296408+(t<<2)|0;s=c[74092]|0;r=1<<e;do{if((s&r|0)==0){c[74092]=s|r;S=296408+(t+2<<2)|0;T=f}else{e=296408+(t+2<<2)|0;k=c[e>>2]|0;if(!(k>>>0<(c[296384>>2]|0)>>>0)){S=e;T=k;break}md()}}while(0);c[S>>2]=m;c[T+12>>2]=m;c[M+(g+8)>>2]=T;c[M+(g+12)>>2]=f;break}t=o;r=L>>>8;do{if((r|0)==0){U=0}else{if(L>>>0>16777215){U=31;break}s=(r+1048320|0)>>>16&8;k=r<<s;e=(k+520192|0)>>>16&4;D=k<<e;k=(D+245760|0)>>>16&2;l=14-(e|s|k)+(D<<k>>>15)|0;U=L>>>(l+7|0)&1|l<<1}}while(0);r=296672+(U<<2)|0;c[M+(g+28)>>2]=U;c[M+(g+20)>>2]=0;c[M+(g+16)>>2]=0;f=c[296372>>2]|0;l=1<<U;if((f&l|0)==0){c[296372>>2]=f|l;c[r>>2]=t;c[M+(g+24)>>2]=r;c[M+(g+12)>>2]=t;c[M+(g+8)>>2]=t;break}l=c[r>>2]|0;if((U|0)==31){V=0}else{V=25-(U>>>1)|0}e:do{if((c[l+4>>2]&-8|0)==(L|0)){W=l}else{r=L<<V;f=l;while(1){X=f+16+(r>>>31<<2)|0;k=c[X>>2]|0;if((k|0)==0){break}if((c[k+4>>2]&-8|0)==(L|0)){W=k;break e}else{r=r<<1;f=k}}if(X>>>0<(c[296384>>2]|0)>>>0){md()}else{c[X>>2]=t;c[M+(g+24)>>2]=f;c[M+(g+12)>>2]=t;c[M+(g+8)>>2]=t;break d}}}while(0);l=W+8|0;r=c[l>>2]|0;k=c[296384>>2]|0;if(W>>>0<k>>>0){md()}if(r>>>0<k>>>0){md()}else{c[r+12>>2]=t;c[l>>2]=t;c[M+(g+8)>>2]=r;c[M+(g+12)>>2]=W;c[M+(g+24)>>2]=0;break}}}while(0);p=M+8|0;i=b;return p|0}}while(0);M=c[296376>>2]|0;if(!(q>>>0>M>>>0)){W=M-q|0;X=c[296388>>2]|0;if(W>>>0>15){c[296388>>2]=X+q;c[296376>>2]=W;c[X+(q+4)>>2]=W|1;c[X+M>>2]=W;c[X+4>>2]=q|3}else{c[296376>>2]=0;c[296388>>2]=0;c[X+4>>2]=M|3;W=X+(M+4)|0;c[W>>2]=c[W>>2]|1}p=X+8|0;i=b;return p|0}X=c[296380>>2]|0;if(q>>>0<X>>>0){W=X-q|0;c[296380>>2]=W;X=c[296392>>2]|0;c[296392>>2]=X+q;c[X+(q+4)>>2]=W|1;c[X+4>>2]=q|3;p=X+8|0;i=b;return p|0}do{if((c[74210]|0)==0){X=pb(30)|0;if((X+ -1&X|0)==0){c[296848>>2]=X;c[296844>>2]=X;c[296852>>2]=-1;c[296856>>2]=-1;c[296860>>2]=0;c[296812>>2]=0;c[74210]=(vc(0)|0)&-16^1431655768;break}else{md()}}}while(0);X=q+48|0;W=c[296848>>2]|0;M=q+47|0;L=W+M|0;V=0-W|0;W=L&V;if(!(W>>>0>q>>>0)){p=0;i=b;return p|0}U=c[296808>>2]|0;do{if((U|0)!=0){T=c[296800>>2]|0;S=T+W|0;if(S>>>0<=T>>>0|S>>>0>U>>>0){p=0}else{break}i=b;return p|0}}while(0);f:do{if((c[296812>>2]&4|0)==0){U=c[296392>>2]|0;g:do{if((U|0)==0){Y=182}else{S=U;T=296816|0;while(1){Z=T;P=c[Z>>2]|0;if(!(P>>>0>S>>>0)){_=T+4|0;if((P+(c[_>>2]|0)|0)>>>0>S>>>0){break}}P=c[T+8>>2]|0;if((P|0)==0){Y=182;break g}else{T=P}}if((T|0)==0){Y=182;break}S=L-(c[296380>>2]|0)&V;if(!(S>>>0<2147483647)){$=0;break}t=lb(S|0)|0;P=(t|0)==((c[Z>>2]|0)+(c[_>>2]|0)|0);aa=t;ba=S;ca=P?t:-1;da=P?S:0;Y=191}}while(0);do{if((Y|0)==182){U=lb(0)|0;if((U|0)==(-1|0)){$=0;break}S=U;P=c[296844>>2]|0;t=P+ -1|0;if((t&S|0)==0){ea=W}else{ea=W-S+(t+S&0-P)|0}P=c[296800>>2]|0;S=P+ea|0;if(!(ea>>>0>q>>>0&ea>>>0<2147483647)){$=0;break}t=c[296808>>2]|0;if((t|0)!=0){if(S>>>0<=P>>>0|S>>>0>t>>>0){$=0;break}}t=lb(ea|0)|0;S=(t|0)==(U|0);aa=t;ba=ea;ca=S?U:-1;da=S?ea:0;Y=191}}while(0);h:do{if((Y|0)==191){S=0-ba|0;if((ca|0)!=(-1|0)){fa=ca;ga=da;Y=202;break f}do{if((aa|0)!=(-1|0)&ba>>>0<2147483647&ba>>>0<X>>>0){U=c[296848>>2]|0;t=M-ba+U&0-U;if(!(t>>>0<2147483647)){ha=ba;break}if((lb(t|0)|0)==(-1|0)){lb(S|0)|0;$=da;break h}else{ha=t+ba|0;break}}else{ha=ba}}while(0);if((aa|0)==(-1|0)){$=da}else{fa=aa;ga=ha;Y=202;break f}}}while(0);c[296812>>2]=c[296812>>2]|4;ia=$;Y=199}else{ia=0;Y=199}}while(0);do{if((Y|0)==199){if(!(W>>>0<2147483647)){break}$=lb(W|0)|0;ha=lb(0)|0;if(!((ha|0)!=(-1|0)&($|0)!=(-1|0)&$>>>0<ha>>>0)){break}aa=ha-$|0;ha=aa>>>0>(q+40|0)>>>0;if(ha){fa=$;ga=ha?aa:ia;Y=202}}}while(0);do{if((Y|0)==202){ia=(c[296800>>2]|0)+ga|0;c[296800>>2]=ia;if(ia>>>0>(c[296804>>2]|0)>>>0){c[296804>>2]=ia}ia=c[296392>>2]|0;W=296816|0;i:do{if((ia|0)==0){aa=c[296384>>2]|0;if((aa|0)==0|fa>>>0<aa>>>0){c[296384>>2]=fa}c[296816>>2]=fa;c[296820>>2]=ga;c[296828>>2]=0;c[296404>>2]=c[74210];c[296400>>2]=-1;aa=0;do{ha=aa<<1;$=296408+(ha<<2)|0;c[296408+(ha+3<<2)>>2]=$;c[296408+(ha+2<<2)>>2]=$;aa=aa+1|0;}while(aa>>>0<32);aa=fa+8|0;if((aa&7|0)==0){ja=0}else{ja=0-aa&7}aa=ga+ -40-ja|0;c[296392>>2]=fa+ja;c[296380>>2]=aa;c[fa+(ja+4)>>2]=aa|1;c[fa+(ga+ -36)>>2]=40;c[296396>>2]=c[296856>>2]}else{aa=W;while(1){ka=c[aa>>2]|0;la=aa+4|0;ma=c[la>>2]|0;if((fa|0)==(ka+ma|0)){Y=214;break}$=c[aa+8>>2]|0;if(($|0)==0){break}else{aa=$}}do{if((Y|0)==214){if((c[aa+12>>2]&8|0)!=0){break}$=ia;if(!($>>>0>=ka>>>0&$>>>0<fa>>>0)){break}c[la>>2]=ma+ga;$=(c[296380>>2]|0)+ga|0;ha=ia+8|0;if((ha&7|0)==0){na=0}else{na=0-ha&7}ha=$-na|0;c[296392>>2]=ia+na;c[296380>>2]=ha;c[ia+(na+4)>>2]=ha|1;c[ia+($+4)>>2]=40;c[296396>>2]=c[296856>>2];break i}}while(0);if(fa>>>0<(c[296384>>2]|0)>>>0){c[296384>>2]=fa}aa=fa+ga|0;$=296816|0;while(1){oa=$;if((c[oa>>2]|0)==(aa|0)){Y=224;break}ha=c[$+8>>2]|0;if((ha|0)==0){break}else{$=ha}}do{if((Y|0)==224){if((c[$+12>>2]&8|0)!=0){break}c[oa>>2]=fa;aa=$+4|0;c[aa>>2]=(c[aa>>2]|0)+ga;aa=fa+8|0;if((aa&7|0)==0){pa=0}else{pa=0-aa&7}aa=fa+(ga+8)|0;if((aa&7|0)==0){qa=0}else{qa=0-aa&7}aa=fa+(qa+ga)|0;ha=aa;da=pa+q|0;ba=fa+da|0;M=ba;X=aa-(fa+pa)-q|0;c[fa+(pa+4)>>2]=q|3;j:do{if((ha|0)==(c[296392>>2]|0)){ca=(c[296380>>2]|0)+X|0;c[296380>>2]=ca;c[296392>>2]=M;c[fa+(da+4)>>2]=ca|1}else{if((ha|0)==(c[296388>>2]|0)){ca=(c[296376>>2]|0)+X|0;c[296376>>2]=ca;c[296388>>2]=M;c[fa+(da+4)>>2]=ca|1;c[fa+(ca+da)>>2]=ca;break}ca=ga+4|0;ea=c[fa+(ca+qa)>>2]|0;if((ea&3|0)==1){_=ea&-8;Z=ea>>>3;k:do{if(ea>>>0<256){V=c[fa+((qa|8)+ga)>>2]|0;L=c[fa+(ga+12+qa)>>2]|0;S=296408+(Z<<1<<2)|0;do{if((V|0)!=(S|0)){if(V>>>0<(c[296384>>2]|0)>>>0){md()}if((c[V+12>>2]|0)==(ha|0)){break}md()}}while(0);if((L|0)==(V|0)){c[74092]=c[74092]&~(1<<Z);break}do{if((L|0)==(S|0)){ra=L+8|0}else{if(L>>>0<(c[296384>>2]|0)>>>0){md()}T=L+8|0;if((c[T>>2]|0)==(ha|0)){ra=T;break}md()}}while(0);c[V+12>>2]=L;c[ra>>2]=V}else{S=aa;T=c[fa+((qa|24)+ga)>>2]|0;t=c[fa+(ga+12+qa)>>2]|0;do{if((t|0)==(S|0)){U=qa|16;P=fa+(ca+U)|0;Q=P;R=c[P>>2]|0;if((R|0)==0){P=fa+(U+ga)|0;U=c[P>>2]|0;if((U|0)==0){sa=0;break}else{ta=U;ua=P}}else{ta=R;ua=Q}while(1){Q=ta+20|0;R=c[Q>>2]|0;if((R|0)!=0){ua=Q;ta=R;continue}R=ta+16|0;Q=c[R>>2]|0;if((Q|0)==0){break}else{ta=Q;ua=R}}if(ua>>>0<(c[296384>>2]|0)>>>0){md()}else{c[ua>>2]=0;sa=ta;break}}else{R=c[fa+((qa|8)+ga)>>2]|0;if(R>>>0<(c[296384>>2]|0)>>>0){md()}Q=R+12|0;if((c[Q>>2]|0)!=(S|0)){md()}P=t+8|0;if((c[P>>2]|0)==(S|0)){c[Q>>2]=t;c[P>>2]=R;sa=t;break}else{md()}}}while(0);if((T|0)==0){break}t=c[fa+(ga+28+qa)>>2]|0;V=296672+(t<<2)|0;do{if((S|0)==(c[V>>2]|0)){c[V>>2]=sa;if((sa|0)!=0){break}c[296372>>2]=c[296372>>2]&~(1<<t);break k}else{if(T>>>0<(c[296384>>2]|0)>>>0){md()}L=T+16|0;if((c[L>>2]|0)==(S|0)){c[L>>2]=sa}else{c[T+20>>2]=sa}if((sa|0)==0){break k}}}while(0);if(sa>>>0<(c[296384>>2]|0)>>>0){md()}c[sa+24>>2]=T;S=qa|16;t=c[fa+(S+ga)>>2]|0;do{if((t|0)!=0){if(t>>>0<(c[296384>>2]|0)>>>0){md()}else{c[sa+16>>2]=t;c[t+24>>2]=sa;break}}}while(0);t=c[fa+(ca+S)>>2]|0;if((t|0)==0){break}if(t>>>0<(c[296384>>2]|0)>>>0){md()}else{c[sa+20>>2]=t;c[t+24>>2]=sa;break}}}while(0);va=fa+((_|qa)+ga)|0;wa=_+X|0}else{va=ha;wa=X}ca=va+4|0;c[ca>>2]=c[ca>>2]&-2;c[fa+(da+4)>>2]=wa|1;c[fa+(wa+da)>>2]=wa;ca=wa>>>3;if(wa>>>0<256){Z=ca<<1;ea=296408+(Z<<2)|0;t=c[74092]|0;T=1<<ca;do{if((t&T|0)==0){c[74092]=t|T;xa=296408+(Z+2<<2)|0;ya=ea}else{ca=296408+(Z+2<<2)|0;V=c[ca>>2]|0;if(!(V>>>0<(c[296384>>2]|0)>>>0)){xa=ca;ya=V;break}md()}}while(0);c[xa>>2]=M;c[ya+12>>2]=M;c[fa+(da+8)>>2]=ya;c[fa+(da+12)>>2]=ea;break}Z=ba;T=wa>>>8;do{if((T|0)==0){za=0}else{if(wa>>>0>16777215){za=31;break}t=(T+1048320|0)>>>16&8;_=T<<t;V=(_+520192|0)>>>16&4;ca=_<<V;_=(ca+245760|0)>>>16&2;L=14-(V|t|_)+(ca<<_>>>15)|0;za=wa>>>(L+7|0)&1|L<<1}}while(0);T=296672+(za<<2)|0;c[fa+(da+28)>>2]=za;c[fa+(da+20)>>2]=0;c[fa+(da+16)>>2]=0;ea=c[296372>>2]|0;L=1<<za;if((ea&L|0)==0){c[296372>>2]=ea|L;c[T>>2]=Z;c[fa+(da+24)>>2]=T;c[fa+(da+12)>>2]=Z;c[fa+(da+8)>>2]=Z;break}L=c[T>>2]|0;if((za|0)==31){Aa=0}else{Aa=25-(za>>>1)|0}l:do{if((c[L+4>>2]&-8|0)==(wa|0)){Ba=L}else{T=wa<<Aa;ea=L;while(1){Ca=ea+16+(T>>>31<<2)|0;_=c[Ca>>2]|0;if((_|0)==0){break}if((c[_+4>>2]&-8|0)==(wa|0)){Ba=_;break l}else{T=T<<1;ea=_}}if(Ca>>>0<(c[296384>>2]|0)>>>0){md()}else{c[Ca>>2]=Z;c[fa+(da+24)>>2]=ea;c[fa+(da+12)>>2]=Z;c[fa+(da+8)>>2]=Z;break j}}}while(0);L=Ba+8|0;T=c[L>>2]|0;S=c[296384>>2]|0;if(Ba>>>0<S>>>0){md()}if(T>>>0<S>>>0){md()}else{c[T+12>>2]=Z;c[L>>2]=Z;c[fa+(da+8)>>2]=T;c[fa+(da+12)>>2]=Ba;c[fa+(da+24)>>2]=0;break}}}while(0);p=fa+(pa|8)|0;i=b;return p|0}}while(0);$=ia;da=296816|0;while(1){Da=c[da>>2]|0;if(!(Da>>>0>$>>>0)){Ea=c[da+4>>2]|0;Fa=Da+Ea|0;if(Fa>>>0>$>>>0){break}}da=c[da+8>>2]|0}da=Da+(Ea+ -39)|0;if((da&7|0)==0){Ga=0}else{Ga=0-da&7}da=Da+(Ea+ -47+Ga)|0;ba=da>>>0<(ia+16|0)>>>0?$:da;da=ba+8|0;M=da;X=fa+8|0;if((X&7|0)==0){Ha=0}else{Ha=0-X&7}X=ga+ -40-Ha|0;c[296392>>2]=fa+Ha;c[296380>>2]=X;c[fa+(Ha+4)>>2]=X|1;c[fa+(ga+ -36)>>2]=40;c[296396>>2]=c[296856>>2];c[ba+4>>2]=27;X=296816|0;c[da+0>>2]=c[X+0>>2];c[da+4>>2]=c[X+4>>2];c[da+8>>2]=c[X+8>>2];c[da+12>>2]=c[X+12>>2];c[296816>>2]=fa;c[296820>>2]=ga;c[296828>>2]=0;c[296824>>2]=M;M=ba+28|0;c[M>>2]=7;if((ba+32|0)>>>0<Fa>>>0){X=M;while(1){M=X+4|0;c[M>>2]=7;if((X+8|0)>>>0<Fa>>>0){X=M}else{break}}}if((ba|0)==($|0)){break}X=ba-ia|0;M=ia+(X+4)|0;c[M>>2]=c[M>>2]&-2;c[ia+4>>2]=X|1;c[ia+X>>2]=X;M=X>>>3;if(X>>>0<256){da=M<<1;ha=296408+(da<<2)|0;aa=c[74092]|0;f=1<<M;do{if((aa&f|0)==0){c[74092]=aa|f;Ia=296408+(da+2<<2)|0;Ja=ha}else{M=296408+(da+2<<2)|0;T=c[M>>2]|0;if(!(T>>>0<(c[296384>>2]|0)>>>0)){Ia=M;Ja=T;break}md()}}while(0);c[Ia>>2]=ia;c[Ja+12>>2]=ia;c[ia+8>>2]=Ja;c[ia+12>>2]=ha;break}da=ia;f=X>>>8;do{if((f|0)==0){Ka=0}else{if(X>>>0>16777215){Ka=31;break}aa=(f+1048320|0)>>>16&8;ba=f<<aa;$=(ba+520192|0)>>>16&4;T=ba<<$;ba=(T+245760|0)>>>16&2;M=14-($|aa|ba)+(T<<ba>>>15)|0;Ka=X>>>(M+7|0)&1|M<<1}}while(0);f=296672+(Ka<<2)|0;c[ia+28>>2]=Ka;c[ia+20>>2]=0;c[ia+16>>2]=0;ha=c[296372>>2]|0;M=1<<Ka;if((ha&M|0)==0){c[296372>>2]=ha|M;c[f>>2]=da;c[ia+24>>2]=f;c[ia+12>>2]=ia;c[ia+8>>2]=ia;break}M=c[f>>2]|0;if((Ka|0)==31){La=0}else{La=25-(Ka>>>1)|0}m:do{if((c[M+4>>2]&-8|0)==(X|0)){Ma=M}else{f=X<<La;ha=M;while(1){Na=ha+16+(f>>>31<<2)|0;ba=c[Na>>2]|0;if((ba|0)==0){break}if((c[ba+4>>2]&-8|0)==(X|0)){Ma=ba;break m}else{f=f<<1;ha=ba}}if(Na>>>0<(c[296384>>2]|0)>>>0){md()}else{c[Na>>2]=da;c[ia+24>>2]=ha;c[ia+12>>2]=ia;c[ia+8>>2]=ia;break i}}}while(0);X=Ma+8|0;M=c[X>>2]|0;f=c[296384>>2]|0;if(Ma>>>0<f>>>0){md()}if(M>>>0<f>>>0){md()}else{c[M+12>>2]=da;c[X>>2]=da;c[ia+8>>2]=M;c[ia+12>>2]=Ma;c[ia+24>>2]=0;break}}}while(0);ia=c[296380>>2]|0;if(!(ia>>>0>q>>>0)){break}W=ia-q|0;c[296380>>2]=W;ia=c[296392>>2]|0;c[296392>>2]=ia+q;c[ia+(q+4)>>2]=W|1;c[ia+4>>2]=q|3;p=ia+8|0;i=b;return p|0}}while(0);c[(Qc()|0)>>2]=12;p=0;i=b;return p|0}function W_a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;b=i;if((a|0)==0){i=b;return}d=a+ -8|0;e=d;f=c[296384>>2]|0;if(d>>>0<f>>>0){md()}g=c[a+ -4>>2]|0;h=g&3;if((h|0)==1){md()}j=g&-8;k=a+(j+ -8)|0;l=k;a:do{if((g&1|0)==0){m=c[d>>2]|0;if((h|0)==0){i=b;return}n=-8-m|0;o=a+n|0;p=o;q=m+j|0;if(o>>>0<f>>>0){md()}if((p|0)==(c[296388>>2]|0)){r=a+(j+ -4)|0;if((c[r>>2]&3|0)!=3){s=p;t=q;break}c[296376>>2]=q;c[r>>2]=c[r>>2]&-2;c[a+(n+4)>>2]=q|1;c[k>>2]=q;i=b;return}r=m>>>3;if(m>>>0<256){m=c[a+(n+8)>>2]|0;u=c[a+(n+12)>>2]|0;v=296408+(r<<1<<2)|0;do{if((m|0)!=(v|0)){if(m>>>0<f>>>0){md()}if((c[m+12>>2]|0)==(p|0)){break}md()}}while(0);if((u|0)==(m|0)){c[74092]=c[74092]&~(1<<r);s=p;t=q;break}do{if((u|0)==(v|0)){w=u+8|0}else{if(u>>>0<f>>>0){md()}x=u+8|0;if((c[x>>2]|0)==(p|0)){w=x;break}md()}}while(0);c[m+12>>2]=u;c[w>>2]=m;s=p;t=q;break}v=o;r=c[a+(n+24)>>2]|0;x=c[a+(n+12)>>2]|0;do{if((x|0)==(v|0)){y=a+(n+20)|0;z=y;A=c[y>>2]|0;if((A|0)==0){y=a+(n+16)|0;B=c[y>>2]|0;if((B|0)==0){C=0;break}else{D=B;E=y}}else{D=A;E=z}while(1){z=D+20|0;A=c[z>>2]|0;if((A|0)!=0){E=z;D=A;continue}A=D+16|0;z=c[A>>2]|0;if((z|0)==0){break}else{D=z;E=A}}if(E>>>0<f>>>0){md()}else{c[E>>2]=0;C=D;break}}else{A=c[a+(n+8)>>2]|0;if(A>>>0<f>>>0){md()}z=A+12|0;if((c[z>>2]|0)!=(v|0)){md()}y=x+8|0;if((c[y>>2]|0)==(v|0)){c[z>>2]=x;c[y>>2]=A;C=x;break}else{md()}}}while(0);if((r|0)==0){s=p;t=q;break}x=c[a+(n+28)>>2]|0;o=296672+(x<<2)|0;do{if((v|0)==(c[o>>2]|0)){c[o>>2]=C;if((C|0)!=0){break}c[296372>>2]=c[296372>>2]&~(1<<x);s=p;t=q;break a}else{if(r>>>0<(c[296384>>2]|0)>>>0){md()}m=r+16|0;if((c[m>>2]|0)==(v|0)){c[m>>2]=C}else{c[r+20>>2]=C}if((C|0)==0){s=p;t=q;break a}}}while(0);if(C>>>0<(c[296384>>2]|0)>>>0){md()}c[C+24>>2]=r;v=c[a+(n+16)>>2]|0;do{if((v|0)!=0){if(v>>>0<(c[296384>>2]|0)>>>0){md()}else{c[C+16>>2]=v;c[v+24>>2]=C;break}}}while(0);v=c[a+(n+20)>>2]|0;if((v|0)==0){s=p;t=q;break}if(v>>>0<(c[296384>>2]|0)>>>0){md()}else{c[C+20>>2]=v;c[v+24>>2]=C;s=p;t=q;break}}else{s=e;t=j}}while(0);if(!(s>>>0<k>>>0)){md()}e=a+(j+ -4)|0;C=c[e>>2]|0;if((C&1|0)==0){md()}do{if((C&2|0)==0){if((l|0)==(c[296392>>2]|0)){f=(c[296380>>2]|0)+t|0;c[296380>>2]=f;c[296392>>2]=s;c[s+4>>2]=f|1;if((s|0)!=(c[296388>>2]|0)){i=b;return}c[296388>>2]=0;c[296376>>2]=0;i=b;return}if((l|0)==(c[296388>>2]|0)){f=(c[296376>>2]|0)+t|0;c[296376>>2]=f;c[296388>>2]=s;c[s+4>>2]=f|1;c[s+f>>2]=f;i=b;return}f=(C&-8)+t|0;D=C>>>3;b:do{if(C>>>0<256){E=c[a+j>>2]|0;w=c[a+(j|4)>>2]|0;h=296408+(D<<1<<2)|0;do{if((E|0)!=(h|0)){if(E>>>0<(c[296384>>2]|0)>>>0){md()}if((c[E+12>>2]|0)==(l|0)){break}md()}}while(0);if((w|0)==(E|0)){c[74092]=c[74092]&~(1<<D);break}do{if((w|0)==(h|0)){F=w+8|0}else{if(w>>>0<(c[296384>>2]|0)>>>0){md()}d=w+8|0;if((c[d>>2]|0)==(l|0)){F=d;break}md()}}while(0);c[E+12>>2]=w;c[F>>2]=E}else{h=k;d=c[a+(j+16)>>2]|0;g=c[a+(j|4)>>2]|0;do{if((g|0)==(h|0)){v=a+(j+12)|0;r=v;x=c[v>>2]|0;if((x|0)==0){v=a+(j+8)|0;o=c[v>>2]|0;if((o|0)==0){G=0;break}else{H=o;I=v}}else{H=x;I=r}while(1){r=H+20|0;x=c[r>>2]|0;if((x|0)!=0){I=r;H=x;continue}x=H+16|0;r=c[x>>2]|0;if((r|0)==0){break}else{H=r;I=x}}if(I>>>0<(c[296384>>2]|0)>>>0){md()}else{c[I>>2]=0;G=H;break}}else{x=c[a+j>>2]|0;if(x>>>0<(c[296384>>2]|0)>>>0){md()}r=x+12|0;if((c[r>>2]|0)!=(h|0)){md()}v=g+8|0;if((c[v>>2]|0)==(h|0)){c[r>>2]=g;c[v>>2]=x;G=g;break}else{md()}}}while(0);if((d|0)==0){break}g=c[a+(j+20)>>2]|0;E=296672+(g<<2)|0;do{if((h|0)==(c[E>>2]|0)){c[E>>2]=G;if((G|0)!=0){break}c[296372>>2]=c[296372>>2]&~(1<<g);break b}else{if(d>>>0<(c[296384>>2]|0)>>>0){md()}w=d+16|0;if((c[w>>2]|0)==(h|0)){c[w>>2]=G}else{c[d+20>>2]=G}if((G|0)==0){break b}}}while(0);if(G>>>0<(c[296384>>2]|0)>>>0){md()}c[G+24>>2]=d;h=c[a+(j+8)>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[296384>>2]|0)>>>0){md()}else{c[G+16>>2]=h;c[h+24>>2]=G;break}}}while(0);h=c[a+(j+12)>>2]|0;if((h|0)==0){break}if(h>>>0<(c[296384>>2]|0)>>>0){md()}else{c[G+20>>2]=h;c[h+24>>2]=G;break}}}while(0);c[s+4>>2]=f|1;c[s+f>>2]=f;if((s|0)!=(c[296388>>2]|0)){J=f;break}c[296376>>2]=f;i=b;return}else{c[e>>2]=C&-2;c[s+4>>2]=t|1;c[s+t>>2]=t;J=t}}while(0);t=J>>>3;if(J>>>0<256){C=t<<1;e=296408+(C<<2)|0;G=c[74092]|0;j=1<<t;do{if((G&j|0)==0){c[74092]=G|j;K=296408+(C+2<<2)|0;L=e}else{t=296408+(C+2<<2)|0;a=c[t>>2]|0;if(!(a>>>0<(c[296384>>2]|0)>>>0)){K=t;L=a;break}md()}}while(0);c[K>>2]=s;c[L+12>>2]=s;c[s+8>>2]=L;c[s+12>>2]=e;i=b;return}e=s;L=J>>>8;do{if((L|0)==0){M=0}else{if(J>>>0>16777215){M=31;break}K=(L+1048320|0)>>>16&8;C=L<<K;j=(C+520192|0)>>>16&4;G=C<<j;C=(G+245760|0)>>>16&2;a=14-(j|K|C)+(G<<C>>>15)|0;M=J>>>(a+7|0)&1|a<<1}}while(0);L=296672+(M<<2)|0;c[s+28>>2]=M;c[s+20>>2]=0;c[s+16>>2]=0;a=c[296372>>2]|0;C=1<<M;c:do{if((a&C|0)==0){c[296372>>2]=a|C;c[L>>2]=e;c[s+24>>2]=L;c[s+12>>2]=s;c[s+8>>2]=s}else{G=c[L>>2]|0;if((M|0)==31){N=0}else{N=25-(M>>>1)|0}d:do{if((c[G+4>>2]&-8|0)==(J|0)){O=G}else{K=J<<N;j=G;while(1){P=j+16+(K>>>31<<2)|0;t=c[P>>2]|0;if((t|0)==0){break}if((c[t+4>>2]&-8|0)==(J|0)){O=t;break d}else{K=K<<1;j=t}}if(P>>>0<(c[296384>>2]|0)>>>0){md()}else{c[P>>2]=e;c[s+24>>2]=j;c[s+12>>2]=s;c[s+8>>2]=s;break c}}}while(0);G=O+8|0;f=c[G>>2]|0;K=c[296384>>2]|0;if(O>>>0<K>>>0){md()}if(f>>>0<K>>>0){md()}else{c[f+12>>2]=e;c[G>>2]=e;c[s+8>>2]=f;c[s+12>>2]=O;c[s+24>>2]=0;break}}}while(0);s=(c[296400>>2]|0)+ -1|0;c[296400>>2]=s;if((s|0)==0){Q=296824|0}else{i=b;return}while(1){s=c[Q>>2]|0;if((s|0)==0){break}else{Q=s+8|0}}c[296400>>2]=-1;i=b;return}function X_a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;do{if((a|0)==0){e=0}else{f=fa(b,a)|0;if(!((b|a)>>>0>65535)){e=f;break}e=((f>>>0)/(a>>>0)|0|0)==(b|0)?f:-1}}while(0);b=V_a(e)|0;if((b|0)==0){i=d;return b|0}if((c[b+ -4>>2]&3|0)==0){i=d;return b|0}B$a(b|0,0,e|0)|0;i=d;return b|0}function Y_a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;if((a|0)==0){e=V_a(b)|0;i=d;return e|0}if(b>>>0>4294967231){c[(Qc()|0)>>2]=12;e=0;i=d;return e|0}if(b>>>0<11){f=16}else{f=b+11&-8}g=Z_a(a+ -8|0,f)|0;if((g|0)!=0){e=g+8|0;i=d;return e|0}g=V_a(b)|0;if((g|0)==0){e=0;i=d;return e|0}f=c[a+ -4>>2]|0;h=(f&-8)-((f&3|0)==0?8:4)|0;z$a(g|0,a|0,(h>>>0<b>>>0?h:b)|0)|0;W_a(a);e=g;i=d;return e|0}



function rP(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[63880]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=57624;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&127](mb,m,39648,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]}jA(t,c[ib>>2]|0,jb);jb=+h[t>>3];kA(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);jb=+h[v>>3];jA(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);pb=+h[w>>3];kA(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+32>>3];qb=+zd(1.0e-13,+(+h[w+40>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+nwa(c[ib>>2]|0,qb,39720,57184,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(pb- +yd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{jA(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);sb=+h[z>>3];kA(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);sb=+h[B>>3];jA(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);jb=+h[C>>3];kA(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+zd(1.0e-13,+(+h[C+40>>3]- +h[E>>3]));pb=1.0- +h[C+32>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+nwa(c[ib>>2]|0,jb,39720,57184,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{jA(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);vb=+h[F>>3];kA(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);vb=+h[H>>3];jA(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);sb=+h[I>>3];kA(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);sb=+h[K>>3];jA(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);jb=+h[L>>3];kA(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+40>>3]- +h[N>>3])|0)<<24>>24==0){jA(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);jb=+h[O>>3];kA(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Q,c[ib>>2]|0,+h[P+24>>3],+h[P+680>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(R,c[ib>>2]|0,+h[Q+24>>3],+h[Q+680>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(S,c[ib>>2]|0,jb,pb,+h[Q+24>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+680>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+696>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}jA(T,c[ib>>2]|0,+h[xb+24>>3]);qb=+h[T>>3];kA(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);qb=+h[V>>3];jA(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);pb=+h[W>>3];kA(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);pb=+h[Y>>3];jA(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);jb=+h[Z>>3];kA(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA($,c[ib>>2]|0,+h[_+24>>3],+h[_+680>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(aa,c[ib>>2]|0,+h[$+24>>3],+h[$+680>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(ba,c[ib>>2]|0,jb,rb,+h[$+24>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+680>>3],0.0);zb=+h[ba>>3];jA(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);rb=+h[ca>>3];kA(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+40>>3];Ab=+zd(1.0e-13,+(jb-qb));qb=Ab*+zd(1.0e-13,+(jb-pb));pb=+h[ea+688>>3];Ab=-(pb*+zd(1.0e-13,+(jb-sb)));sb=+h[ea+32>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+nwa(c[ib>>2]|0,qb,40024,57184,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+32>>3];Cb=+h[ca+40>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+zd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+nwa(c[ib>>2]|0,Eb,39720,57184,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+688>>3]-wb}wb=+h[tb+24>>3];if(wb>0.0){Gb=wb}else{tb=c[63880]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=57624;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&127](Db,l,39648,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]}if(Gb>0.0){Hb=Gb}else{r=c[63880]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=57624;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&127](l,j,39648,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]}jA(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];kA(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);Hb=+h[ia>>3];jA(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);Fb=+h[ja>>3];kA(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3];if(zb>0.0){Ib=zb}else{la=c[63880]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=57624;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&127](ka,g,39648,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]}if(Ib>0.0){Jb=Ib}else{p=c[63880]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=57624;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&127](g,f,39648,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]}if(Jb>0.0){Kb=Jb}else{o=c[63880]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=57624;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&127](f,e,39648,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]}qb=Kb+-273.15;lA(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];jA(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);qb=+h[na>>3];kA(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);qb=+h[pa>>3];jA(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);Eb=+h[qa>>3];kA(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+32>>3];rb=+zd(1.0e-13,+(+h[qa+40>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+nwa(c[ib>>2]|0,rb,39720,57184,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(Eb- +yd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{jA(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);Lb=+h[ta>>3];kA(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);Lb=+h[va>>3];jA(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);qb=+h[wa>>3];kA(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+zd(1.0e-13,+(+h[wa+40>>3]- +h[ya>>3]));Eb=1.0- +h[wa+32>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+nwa(c[ib>>2]|0,qb,39720,57184,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{jA(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);Ob=+h[za>>3];kA(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);Ob=+h[Ba>>3];jA(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);Lb=+h[Ca>>3];kA(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);Lb=+h[Ea>>3];jA(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);qb=+h[Fa>>3];kA(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+40>>3]- +h[Ha>>3])|0)<<24>>24==0){jA(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);qb=+h[Ia>>3];kA(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Ka,c[ib>>2]|0,+h[Ja+24>>3],+h[Ja+680>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(La,c[ib>>2]|0,+h[Ka+24>>3],+h[Ka+680>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+24>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+680>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+696>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}jA(Na,c[ib>>2]|0,+h[Qb+24>>3]);rb=+h[Na>>3];kA(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);rb=+h[Pa>>3];jA(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);Eb=+h[Qa>>3];kA(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);Eb=+h[Sa>>3];jA(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);qb=+h[Ta>>3];kA(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Va,c[ib>>2]|0,+h[Ua+24>>3],+h[Ua+680>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(Wa,c[ib>>2]|0,+h[Va+24>>3],+h[Va+680>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Xa,c[ib>>2]|0,qb,Bb,+h[Va+24>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+680>>3],0.0);Cb=+h[Xa>>3];jA(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);Bb=+h[Ya>>3];kA(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+40>>3];vb=+zd(1.0e-13,+(qb-rb));rb=vb*+zd(1.0e-13,+(qb-Eb));Eb=+h[Za+688>>3];vb=-(Eb*+zd(1.0e-13,+(qb-Lb)));Lb=+h[Za+32>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+nwa(c[ib>>2]|0,rb,40024,57184,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+32>>3];Tb=+h[Ya+40>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+zd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+nwa(c[ib>>2]|0,Vb,39720,57184,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+688>>3]-Pb}Pb=+h[Mb+24>>3];Wb=Pb+-273.15;Cb=+h[Mb+680>>3];sA($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];jA(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);Pb=+h[ab>>3];kA(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);Pb=+h[cb>>3];jA(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);Wb=+h[db>>3];kA(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);lA(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+24>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+nwa(c[ib>>2]|0,rb,40632,57184,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+24>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+688>>3]-ub);ub=+h[Yb+680>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+nwa(c[ib>>2]|0,Xb,40632,57184,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+680>>3];ac=+h[Yb+24>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+Nxa(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+32>>3];Gb=+zd(1.0e-13,+(+h[Yb+40>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+nwa(c[ib>>2]|0,Gb,39720,57184,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +zd(+(ac- +yd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+24>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+nwa(c[ib>>2]|0,ec,40632,57184,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+24>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+688>>3];ic=+h[gc+680>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+nwa(c[ib>>2]|0,fc,40632,57184,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+680>>3];kc=+h[gc+24>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+Nxa(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+32>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+zd(1.0e-13,+(+h[gc+40>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9536|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9536|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+nwa(c[ib>>2]|0,Nb,39720,57184,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9536|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function sP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;iA(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+24>>3]);if((Aza(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+40>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+696>>3]*.999;l=j;m=l+9216|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;xA(e,c[f>>2]|0,+h[d+24>>3],+h[d+680>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+9216|0;n=m;h[n>>3]=k;i=b;return}}function tP(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1560>>3];k=+zd(1.0e-13,+(+h[g+40>>3]-j));l=+h[g+2848>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+nwa(c[b+536>>2]|0,k,44112,57192,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8416|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=Cza(1.0e-13,+h[f+40>>3]- +h[f+1560>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+1560>>3];j=+h[x+40>>3];k=+zd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+9112>>3];k=+h[x+2848>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+696>>3]- +h[x+9216>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+696>>3]- +h[x+9216>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+696>>3]- +h[x+9216>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+696>>3]- +h[x+9216>>3]}K=(y-k*J)/+nwa(c[b+536>>2]|0,l,44272,57192,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+2848>>3];C=+h[L+1560>>3];D=+h[L+40>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+9216>>3];m=+zd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+nwa(c[b+536>>2]|0,m,44112,57192,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8416|0;w=v;h[w>>3]=n;i=d;return}function uP(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(Cza(+h[a+32>>3]- +h[a+1576>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+9208|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+688>>3]- +h[a+8416>>3];g=a;j=g+9208|0;k=j;h[k>>3]=f;i=b;return}function vP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8408>>3]=+h[b+688>>3]- +h[b+9208>>3];i=i;return}function wP(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1592>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+9208>>3];o=+h[g+9112>>3]*k+ +h[g+2848>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+nwa(c[b+536>>2]|0,l,44408,57200,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+9208>>3];q=+h[v+1592>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+8408>>3]*(1.0-q)+ +h[r+1584>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+9200|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+9200|0;C=B;h[C>>3]=z;i=d;return}p=t/+nwa(c[b+536>>2]|0,l,44408,57200,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+9200|0;C=B;h[C>>3]=z;i=d;return}function xP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+9824>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+9800>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+9808>>3];h[a+8>>3]=+h[d+9600>>3];h[e+8>>3]=+h[d+9576>>3];h[f+8>>3]=+h[d+9584>>3];i=i;return}function yP(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0.0,k=0.0,l=0.0,m=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+696>>3]=+h[b>>3];h[a+680>>3]=+h[b+8>>3];rP(f);sP(f);tP(f);uP(f);vP(f);wP(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;g=f+1624|0;j=+h[g>>3];b=f+24|0;k=+h[b>>3];l=j*k;a=f+680|0;m=f+9200|0;h[d>>3]=+h[f+9544>>3]*l*l+(+h[f+40>>3]*(j*+h[a>>3]+k*+h[m>>3])-l*+h[f+696>>3]);h[d+8>>3]=+h[f+8400>>3]+(+h[m>>3]*+h[b>>3]+(+h[g>>3]*+h[a>>3]- +h[f+9536>>3]));i=e;return}function zP(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+28192>>3];h[c[b+8>>2]>>3]=+h[d+28168>>3];h[c[b+12>>2]>>3]=+h[d+28176>>3];i=i;return}function AP(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+2008>>3]=g;k=a+416|0;l=c[k>>2]|0;Kz(f,c[a+536>>2]|0,g,+h[j+2400>>3],+h[j+2408>>3],+h[j+2296>>3],+h[j+2304>>3],+h[j+10456>>3],+h[j+9840>>3],+h[l+2280>>3]*10.0,(+h[l+1088>>3]+ +h[l+1096>>3])*.5,+h[l+2272>>3]/6.0,+h[l+2240>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+136>>3]- +h[f>>3]*+h[(c[k>>2]|0)+2216>>3];i=e;return}function BP(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[63880]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=57624;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&127](mb,m,41680,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]}jA(t,c[ib>>2]|0,jb);jb=+h[t>>3];kA(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);jb=+h[v>>3];jA(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);pb=+h[w>>3];kA(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+56>>3];qb=+zd(1.0e-13,+(+h[w+64>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+nwa(c[ib>>2]|0,qb,41752,57208,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(pb- +yd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{jA(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);sb=+h[z>>3];kA(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);sb=+h[B>>3];jA(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);jb=+h[C>>3];kA(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+zd(1.0e-13,+(+h[C+64>>3]- +h[E>>3]));pb=1.0- +h[C+56>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+nwa(c[ib>>2]|0,jb,41752,57208,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{jA(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);vb=+h[F>>3];kA(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);vb=+h[H>>3];jA(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);sb=+h[I>>3];kA(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);sb=+h[K>>3];jA(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);jb=+h[L>>3];kA(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]- +h[N>>3])|0)<<24>>24==0){jA(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);jb=+h[O>>3];kA(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Q,c[ib>>2]|0,+h[P+48>>3],+h[P+704>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(R,c[ib>>2]|0,+h[Q+48>>3],+h[Q+704>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(S,c[ib>>2]|0,jb,pb,+h[Q+48>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+704>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+720>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}jA(T,c[ib>>2]|0,+h[xb+48>>3]);qb=+h[T>>3];kA(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);qb=+h[V>>3];jA(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);pb=+h[W>>3];kA(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);pb=+h[Y>>3];jA(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);jb=+h[Z>>3];kA(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA($,c[ib>>2]|0,+h[_+48>>3],+h[_+704>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(aa,c[ib>>2]|0,+h[$+48>>3],+h[$+704>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(ba,c[ib>>2]|0,jb,rb,+h[$+48>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+704>>3],0.0);zb=+h[ba>>3];jA(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);rb=+h[ca>>3];kA(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+64>>3];Ab=+zd(1.0e-13,+(jb-qb));qb=Ab*+zd(1.0e-13,+(jb-pb));pb=+h[ea+712>>3];Ab=-(pb*+zd(1.0e-13,+(jb-sb)));sb=+h[ea+56>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+nwa(c[ib>>2]|0,qb,42056,57208,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+56>>3];Cb=+h[ca+64>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+zd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+nwa(c[ib>>2]|0,Eb,41752,57208,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+712>>3]-wb}wb=+h[tb+48>>3];if(wb>0.0){Gb=wb}else{tb=c[63880]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=57624;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&127](Db,l,41680,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]}if(Gb>0.0){Hb=Gb}else{r=c[63880]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=57624;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&127](l,j,41680,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]}jA(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];kA(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);Hb=+h[ia>>3];jA(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);Fb=+h[ja>>3];kA(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3];if(zb>0.0){Ib=zb}else{la=c[63880]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=57624;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&127](ka,g,41680,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]}if(Ib>0.0){Jb=Ib}else{p=c[63880]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=57624;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&127](g,f,41680,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]}if(Jb>0.0){Kb=Jb}else{o=c[63880]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=57624;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&127](f,e,41680,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]}qb=Kb+-273.15;lA(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];jA(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);qb=+h[na>>3];kA(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);qb=+h[pa>>3];jA(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);Eb=+h[qa>>3];kA(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+56>>3];rb=+zd(1.0e-13,+(+h[qa+64>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+nwa(c[ib>>2]|0,rb,41752,57208,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(Eb- +yd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{jA(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);Lb=+h[ta>>3];kA(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);Lb=+h[va>>3];jA(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);qb=+h[wa>>3];kA(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+zd(1.0e-13,+(+h[wa+64>>3]- +h[ya>>3]));Eb=1.0- +h[wa+56>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+nwa(c[ib>>2]|0,qb,41752,57208,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{jA(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);Ob=+h[za>>3];kA(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);Ob=+h[Ba>>3];jA(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);Lb=+h[Ca>>3];kA(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);Lb=+h[Ea>>3];jA(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);qb=+h[Fa>>3];kA(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]- +h[Ha>>3])|0)<<24>>24==0){jA(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);qb=+h[Ia>>3];kA(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Ka,c[ib>>2]|0,+h[Ja+48>>3],+h[Ja+704>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(La,c[ib>>2]|0,+h[Ka+48>>3],+h[Ka+704>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+48>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+704>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+720>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}jA(Na,c[ib>>2]|0,+h[Qb+48>>3]);rb=+h[Na>>3];kA(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);rb=+h[Pa>>3];jA(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);Eb=+h[Qa>>3];kA(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);Eb=+h[Sa>>3];jA(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);qb=+h[Ta>>3];kA(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Va,c[ib>>2]|0,+h[Ua+48>>3],+h[Ua+704>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(Wa,c[ib>>2]|0,+h[Va+48>>3],+h[Va+704>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Xa,c[ib>>2]|0,qb,Bb,+h[Va+48>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+704>>3],0.0);Cb=+h[Xa>>3];jA(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);Bb=+h[Ya>>3];kA(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+64>>3];vb=+zd(1.0e-13,+(qb-rb));rb=vb*+zd(1.0e-13,+(qb-Eb));Eb=+h[Za+712>>3];vb=-(Eb*+zd(1.0e-13,+(qb-Lb)));Lb=+h[Za+56>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+nwa(c[ib>>2]|0,rb,42056,57208,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+56>>3];Tb=+h[Ya+64>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+zd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+nwa(c[ib>>2]|0,Vb,41752,57208,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+712>>3]-Pb}Pb=+h[Mb+48>>3];Wb=Pb+-273.15;Cb=+h[Mb+704>>3];sA($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];jA(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);Pb=+h[ab>>3];kA(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);Pb=+h[cb>>3];jA(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);Wb=+h[db>>3];kA(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]);lA(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+48>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+48>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+nwa(c[ib>>2]|0,rb,42664,57208,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+48>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+712>>3]-ub);ub=+h[Yb+704>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+nwa(c[ib>>2]|0,Xb,42664,57208,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+704>>3];ac=+h[Yb+48>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+Nxa(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+56>>3];Gb=+zd(1.0e-13,+(+h[Yb+64>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+nwa(c[ib>>2]|0,Gb,41752,57208,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +zd(+(ac- +yd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+48>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+nwa(c[ib>>2]|0,ec,42664,57208,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+48>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+712>>3];ic=+h[gc+704>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+nwa(c[ib>>2]|0,fc,42664,57208,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+704>>3];kc=+h[gc+48>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+Nxa(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+56>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+zd(1.0e-13,+(+h[gc+64>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9520|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9520|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+nwa(c[ib>>2]|0,Nb,41752,57208,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9520|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function CP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;iA(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+48>>3]);if((Aza(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+64>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+720>>3]*.999;l=j;m=l+9192|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;xA(e,c[f>>2]|0,+h[d+48>>3],+h[d+704>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+9192|0;n=m;h[n>>3]=k;i=b;return}}function DP(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1672>>3];k=+zd(1.0e-13,+(+h[g+64>>3]-j));l=+h[g+2856>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+nwa(c[b+536>>2]|0,k,44512,57216,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8392|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=Cza(1.0e-13,+h[f+64>>3]- +h[f+1672>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+1672>>3];j=+h[x+64>>3];k=+zd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+9104>>3];k=+h[x+2856>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+720>>3]- +h[x+9192>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+720>>3]- +h[x+9192>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+720>>3]- +h[x+9192>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+720>>3]- +h[x+9192>>3]}K=(y-k*J)/+nwa(c[b+536>>2]|0,l,44576,57216,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+2856>>3];C=+h[L+1672>>3];D=+h[L+64>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+9192>>3];m=+zd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+nwa(c[b+536>>2]|0,m,44512,57216,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8392|0;w=v;h[w>>3]=n;i=d;return}function EP(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(Cza(+h[a+56>>3]- +h[a+1688>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+9184|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+712>>3]- +h[a+8392>>3];g=a;j=g+9184|0;k=j;h[k>>3]=f;i=b;return}function FP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8384>>3]=+h[b+712>>3]- +h[b+9184>>3];i=i;return}function GP(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1704>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+9184>>3];o=+h[g+9104>>3]*k+ +h[g+2856>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+nwa(c[b+536>>2]|0,l,44720,57224,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+9184>>3];q=+h[v+1704>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+8384>>3]*(1.0-q)+ +h[r+1696>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+9176|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+9176|0;C=B;h[C>>3]=z;i=d;return}p=t/+nwa(c[b+536>>2]|0,l,44720,57224,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+9176|0;C=B;h[C>>3]=z;i=d;return}function HP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+10160>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+10136>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+10144>>3];h[a+8>>3]=+h[d+9936>>3];h[e+8>>3]=+h[d+9912>>3];h[f+8>>3]=+h[d+9920>>3];i=i;return}function IP(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0.0,k=0.0,l=0.0,m=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+720>>3]=+h[b>>3];h[a+704>>3]=+h[b+8>>3];BP(f);CP(f);DP(f);EP(f);FP(f);GP(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;g=f+1736|0;j=+h[g>>3];b=f+48|0;k=+h[b>>3];l=j*k;a=f+704|0;m=f+9176|0;h[d>>3]=+h[f+9528>>3]*l*l+(+h[f+64>>3]*(j*+h[a>>3]+k*+h[m>>3])-l*+h[f+720>>3]);h[d+8>>3]=+h[f+8376>>3]+(+h[m>>3]*+h[b>>3]+(+h[g>>3]*+h[a>>3]- +h[f+9520>>3]));i=e;return}function JP(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+28080>>3];h[c[b+8>>2]>>3]=+h[d+28056>>3];h[c[b+12>>2]>>3]=+h[d+28064>>3];i=i;return}function KP(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+2e3>>3]=g;k=a+416|0;l=c[k>>2]|0;Kz(f,c[a+536>>2]|0,g,+h[j+2392>>3],+h[j+2400>>3],+h[j+2288>>3],+h[j+2296>>3],+h[j+10448>>3],+h[j+9848>>3],+h[l+2280>>3]*10.0,(+h[l+1080>>3]+ +h[l+1088>>3])*.5,+h[l+2272>>3]/6.0,+h[l+2240>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+128>>3]- +h[f>>3]*+h[(c[k>>2]|0)+2216>>3];i=e;return}function LP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;iA(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+72>>3]);if((Aza(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+88>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+744>>3]*.999;l=j;m=l+9168|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;xA(e,c[f>>2]|0,+h[d+72>>3],+h[d+728>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+9168|0;n=m;h[n>>3]=k;i=b;return}}function MP(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1784>>3];k=+zd(1.0e-13,+(+h[g+88>>3]-j));l=+h[g+2864>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+nwa(c[b+536>>2]|0,k,44912,57232,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8368|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=Cza(1.0e-13,+h[f+88>>3]- +h[f+1784>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+1784>>3];j=+h[x+88>>3];k=+zd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+9096>>3];k=+h[x+2864>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+744>>3]- +h[x+9168>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+744>>3]- +h[x+9168>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+744>>3]- +h[x+9168>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+744>>3]- +h[x+9168>>3]}K=(y-k*J)/+nwa(c[b+536>>2]|0,l,44976,57232,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+2864>>3];C=+h[L+1784>>3];D=+h[L+88>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+9168>>3];m=+zd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+nwa(c[b+536>>2]|0,m,44912,57232,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8368|0;w=v;h[w>>3]=n;i=d;return}function NP(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(Cza(+h[a+80>>3]- +h[a+1800>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+9160|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+736>>3]- +h[a+8368>>3];g=a;j=g+9160|0;k=j;h[k>>3]=f;i=b;return}function OP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8360>>3]=+h[b+736>>3]- +h[b+9160>>3];i=i;return}function PP(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1816>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+9160>>3];o=+h[g+9096>>3]*k+ +h[g+2864>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+nwa(c[b+536>>2]|0,l,45120,57240,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+9160>>3];q=+h[v+1816>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+8360>>3]*(1.0-q)+ +h[r+1808>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+9152|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+9152|0;C=B;h[C>>3]=z;i=d;return}p=t/+nwa(c[b+536>>2]|0,l,45120,57240,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+9152|0;C=B;h[C>>3]=z;i=d;return}function QP(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[63880]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=57624;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&127](mb,m,40664,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]}jA(t,c[ib>>2]|0,jb);jb=+h[t>>3];kA(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);jb=+h[v>>3];jA(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);pb=+h[w>>3];kA(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+80>>3];qb=+zd(1.0e-13,+(+h[w+88>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+nwa(c[ib>>2]|0,qb,40736,57248,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(pb- +yd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{jA(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);sb=+h[z>>3];kA(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);sb=+h[B>>3];jA(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);jb=+h[C>>3];kA(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+zd(1.0e-13,+(+h[C+88>>3]- +h[E>>3]));pb=1.0- +h[C+80>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+nwa(c[ib>>2]|0,jb,40736,57248,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{jA(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);vb=+h[F>>3];kA(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);vb=+h[H>>3];jA(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);sb=+h[I>>3];kA(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);sb=+h[K>>3];jA(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);jb=+h[L>>3];kA(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]- +h[N>>3])|0)<<24>>24==0){jA(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);jb=+h[O>>3];kA(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Q,c[ib>>2]|0,+h[P+72>>3],+h[P+728>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(R,c[ib>>2]|0,+h[Q+72>>3],+h[Q+728>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(S,c[ib>>2]|0,jb,pb,+h[Q+72>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+728>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+744>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}jA(T,c[ib>>2]|0,+h[xb+72>>3]);qb=+h[T>>3];kA(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);qb=+h[V>>3];jA(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);pb=+h[W>>3];kA(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);pb=+h[Y>>3];jA(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);jb=+h[Z>>3];kA(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA($,c[ib>>2]|0,+h[_+72>>3],+h[_+728>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(aa,c[ib>>2]|0,+h[$+72>>3],+h[$+728>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(ba,c[ib>>2]|0,jb,rb,+h[$+72>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+728>>3],0.0);zb=+h[ba>>3];jA(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);rb=+h[ca>>3];kA(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+88>>3];Ab=+zd(1.0e-13,+(jb-qb));qb=Ab*+zd(1.0e-13,+(jb-pb));pb=+h[ea+736>>3];Ab=-(pb*+zd(1.0e-13,+(jb-sb)));sb=+h[ea+80>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+nwa(c[ib>>2]|0,qb,41040,57248,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+80>>3];Cb=+h[ca+88>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+zd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+nwa(c[ib>>2]|0,Eb,40736,57248,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+736>>3]-wb}wb=+h[tb+72>>3];if(wb>0.0){Gb=wb}else{tb=c[63880]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=57624;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&127](Db,l,40664,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]}if(Gb>0.0){Hb=Gb}else{r=c[63880]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=57624;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&127](l,j,40664,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]}jA(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];kA(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);Hb=+h[ia>>3];jA(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);Fb=+h[ja>>3];kA(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3];if(zb>0.0){Ib=zb}else{la=c[63880]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=57624;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&127](ka,g,40664,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]}if(Ib>0.0){Jb=Ib}else{p=c[63880]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=57624;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&127](g,f,40664,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]}if(Jb>0.0){Kb=Jb}else{o=c[63880]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=57624;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&127](f,e,40664,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]}qb=Kb+-273.15;lA(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];jA(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);qb=+h[na>>3];kA(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);qb=+h[pa>>3];jA(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);Eb=+h[qa>>3];kA(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+80>>3];rb=+zd(1.0e-13,+(+h[qa+88>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+nwa(c[ib>>2]|0,rb,40736,57248,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(Eb- +yd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{jA(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);Lb=+h[ta>>3];kA(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);Lb=+h[va>>3];jA(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);qb=+h[wa>>3];kA(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+zd(1.0e-13,+(+h[wa+88>>3]- +h[ya>>3]));Eb=1.0- +h[wa+80>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+nwa(c[ib>>2]|0,qb,40736,57248,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{jA(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);Ob=+h[za>>3];kA(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);Ob=+h[Ba>>3];jA(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);Lb=+h[Ca>>3];kA(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);Lb=+h[Ea>>3];jA(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);qb=+h[Fa>>3];kA(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]- +h[Ha>>3])|0)<<24>>24==0){jA(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);qb=+h[Ia>>3];kA(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Ka,c[ib>>2]|0,+h[Ja+72>>3],+h[Ja+728>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(La,c[ib>>2]|0,+h[Ka+72>>3],+h[Ka+728>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+72>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+728>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+744>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}jA(Na,c[ib>>2]|0,+h[Qb+72>>3]);rb=+h[Na>>3];kA(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);rb=+h[Pa>>3];jA(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);Eb=+h[Qa>>3];kA(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);Eb=+h[Sa>>3];jA(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);qb=+h[Ta>>3];kA(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Va,c[ib>>2]|0,+h[Ua+72>>3],+h[Ua+728>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(Wa,c[ib>>2]|0,+h[Va+72>>3],+h[Va+728>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Xa,c[ib>>2]|0,qb,Bb,+h[Va+72>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+728>>3],0.0);Cb=+h[Xa>>3];jA(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);Bb=+h[Ya>>3];kA(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+88>>3];vb=+zd(1.0e-13,+(qb-rb));rb=vb*+zd(1.0e-13,+(qb-Eb));Eb=+h[Za+736>>3];vb=-(Eb*+zd(1.0e-13,+(qb-Lb)));Lb=+h[Za+80>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+nwa(c[ib>>2]|0,rb,41040,57248,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+80>>3];Tb=+h[Ya+88>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+zd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+nwa(c[ib>>2]|0,Vb,40736,57248,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+736>>3]-Pb}Pb=+h[Mb+72>>3];Wb=Pb+-273.15;Cb=+h[Mb+728>>3];sA($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];jA(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);Pb=+h[ab>>3];kA(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);Pb=+h[cb>>3];jA(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);Wb=+h[db>>3];kA(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]);lA(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+72>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+72>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+nwa(c[ib>>2]|0,rb,41648,57248,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+72>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+736>>3]-ub);ub=+h[Yb+728>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+nwa(c[ib>>2]|0,Xb,41648,57248,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+728>>3];ac=+h[Yb+72>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+Nxa(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+80>>3];Gb=+zd(1.0e-13,+(+h[Yb+88>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+nwa(c[ib>>2]|0,Gb,40736,57248,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +zd(+(ac- +yd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+72>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+nwa(c[ib>>2]|0,ec,41648,57248,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+72>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+736>>3];ic=+h[gc+728>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+nwa(c[ib>>2]|0,fc,41648,57248,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+728>>3];kc=+h[gc+72>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+Nxa(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+80>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+zd(1.0e-13,+(+h[gc+88>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9504|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9504|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+nwa(c[ib>>2]|0,Nb,40736,57248,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9504|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function RP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+10496>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+10472>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+10480>>3];h[a+8>>3]=+h[d+10272>>3];h[e+8>>3]=+h[d+10248>>3];h[f+8>>3]=+h[d+10256>>3];i=i;return}function SP(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0.0,k=0.0,l=0.0,m=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+744>>3]=+h[b>>3];h[a+728>>3]=+h[b+8>>3];LP(f);MP(f);NP(f);OP(f);PP(f);QP(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;g=f+1848|0;j=+h[g>>3];b=f+72|0;k=+h[b>>3];l=j*k;a=f+728|0;m=f+9152|0;h[d>>3]=+h[f+9512>>3]*l*l+(+h[f+88>>3]*(j*+h[a>>3]+k*+h[m>>3])-l*+h[f+744>>3]);h[d+8>>3]=+h[f+8352>>3]+(+h[m>>3]*+h[b>>3]+(+h[g>>3]*+h[a>>3]- +h[f+9504>>3]));i=e;return}function TP(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+50144>>3];h[c[b+8>>2]>>3]=+h[d+50120>>3];h[c[b+12>>2]>>3]=+h[d+50128>>3];i=i;return}function UP(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+3576>>3]=g;k=a+416|0;l=c[k>>2]|0;Kz(f,c[a+536>>2]|0,g,+h[j+3968>>3],+h[j+3976>>3],+h[j+3864>>3],+h[j+3872>>3],+h[j+10336>>3],+h[j+9856>>3],+h[l+2056>>3]*5.0,(+h[l+808>>3]+ +h[l+816>>3])*.5,+h[l+2048>>3]/6.0,+h[l+2016>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+320>>3]- +h[f>>3]*+h[(c[k>>2]|0)+1992>>3];i=e;return}function VP(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+50032>>3];h[c[b+8>>2]>>3]=+h[d+50008>>3];h[c[b+12>>2]>>3]=+h[d+50016>>3];i=i;return}function WP(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+3568>>3]=g;k=a+416|0;l=c[k>>2]|0;Kz(f,c[a+536>>2]|0,g,+h[j+3960>>3],+h[j+3968>>3],+h[j+3856>>3],+h[j+3864>>3],+h[j+10328>>3],+h[j+9864>>3],+h[l+2056>>3]*5.0,(+h[l+800>>3]+ +h[l+808>>3])*.5,+h[l+2048>>3]/6.0,+h[l+2016>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+312>>3]- +h[f>>3]*+h[(c[k>>2]|0)+1992>>3];i=e;return}function XP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;iA(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+192>>3]);if((Aza(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+208>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+864>>3]*.999;l=j;m=l+9056|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;xA(e,c[f>>2]|0,+h[d+192>>3],+h[d+848>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+9056|0;n=m;h[n>>3]=k;i=b;return}}function YP(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3112>>3];k=+zd(1.0e-13,+(+h[g+208>>3]-j));l=+h[g+4416>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+nwa(c[b+536>>2]|0,k,46184,57256,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8248|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=Cza(1.0e-13,+h[f+208>>3]- +h[f+3112>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+3112>>3];j=+h[x+208>>3];k=+zd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+8952>>3];k=+h[x+4416>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+864>>3]- +h[x+9056>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+864>>3]- +h[x+9056>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+864>>3]- +h[x+9056>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+864>>3]- +h[x+9056>>3]}K=(y-k*J)/+nwa(c[b+536>>2]|0,l,46344,57256,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+4416>>3];C=+h[L+3112>>3];D=+h[L+208>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+9056>>3];m=+zd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+nwa(c[b+536>>2]|0,m,46184,57256,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8248|0;w=v;h[w>>3]=n;i=d;return}function ZP(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(Cza(+h[a+200>>3]- +h[a+3128>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+9048|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+856>>3]- +h[a+8248>>3];g=a;j=g+9048|0;k=j;h[k>>3]=f;i=b;return}function _P(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8240>>3]=+h[b+856>>3]- +h[b+9048>>3];i=i;return}function $P(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3144>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+9048>>3];o=+h[g+8952>>3]*k+ +h[g+4416>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+nwa(c[b+536>>2]|0,l,46480,57264,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+9048>>3];q=+h[v+3144>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+8240>>3]*(1.0-q)+ +h[r+3136>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+9040|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+9040|0;C=B;h[C>>3]=z;i=d;return}p=t/+nwa(c[b+536>>2]|0,l,46480,57264,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+9040|0;C=B;h[C>>3]=z;i=d;return}function aQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[63880]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=57624;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&127](mb,m,37616,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]}jA(t,c[ib>>2]|0,jb);jb=+h[t>>3];kA(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);jb=+h[v>>3];jA(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);pb=+h[w>>3];kA(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+200>>3];qb=+zd(1.0e-13,+(+h[w+208>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+nwa(c[ib>>2]|0,qb,37688,57272,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(pb- +yd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{jA(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);sb=+h[z>>3];kA(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);sb=+h[B>>3];jA(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);jb=+h[C>>3];kA(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+zd(1.0e-13,+(+h[C+208>>3]- +h[E>>3]));pb=1.0- +h[C+200>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+nwa(c[ib>>2]|0,jb,37688,57272,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{jA(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);vb=+h[F>>3];kA(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);vb=+h[H>>3];jA(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);sb=+h[I>>3];kA(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);sb=+h[K>>3];jA(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);jb=+h[L>>3];kA(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+208>>3]- +h[N>>3])|0)<<24>>24==0){jA(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);jb=+h[O>>3];kA(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Q,c[ib>>2]|0,+h[P+192>>3],+h[P+848>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(R,c[ib>>2]|0,+h[Q+192>>3],+h[Q+848>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(S,c[ib>>2]|0,jb,pb,+h[Q+192>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+848>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+864>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}jA(T,c[ib>>2]|0,+h[xb+192>>3]);qb=+h[T>>3];kA(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);qb=+h[V>>3];jA(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);pb=+h[W>>3];kA(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);pb=+h[Y>>3];jA(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);jb=+h[Z>>3];kA(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA($,c[ib>>2]|0,+h[_+192>>3],+h[_+848>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(aa,c[ib>>2]|0,+h[$+192>>3],+h[$+848>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(ba,c[ib>>2]|0,jb,rb,+h[$+192>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+848>>3],0.0);zb=+h[ba>>3];jA(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);rb=+h[ca>>3];kA(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+208>>3];Ab=+zd(1.0e-13,+(jb-qb));qb=Ab*+zd(1.0e-13,+(jb-pb));pb=+h[ea+856>>3];Ab=-(pb*+zd(1.0e-13,+(jb-sb)));sb=+h[ea+200>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+nwa(c[ib>>2]|0,qb,37992,57272,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+200>>3];Cb=+h[ca+208>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+zd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+nwa(c[ib>>2]|0,Eb,37688,57272,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+856>>3]-wb}wb=+h[tb+192>>3];if(wb>0.0){Gb=wb}else{tb=c[63880]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=57624;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&127](Db,l,37616,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]}if(Gb>0.0){Hb=Gb}else{r=c[63880]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=57624;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&127](l,j,37616,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]}jA(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];kA(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);Hb=+h[ia>>3];jA(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);Fb=+h[ja>>3];kA(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3];if(zb>0.0){Ib=zb}else{la=c[63880]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=57624;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&127](ka,g,37616,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]}if(Ib>0.0){Jb=Ib}else{p=c[63880]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=57624;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&127](g,f,37616,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]}if(Jb>0.0){Kb=Jb}else{o=c[63880]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=57624;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&127](f,e,37616,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]}qb=Kb+-273.15;lA(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];jA(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);qb=+h[na>>3];kA(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);qb=+h[pa>>3];jA(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);Eb=+h[qa>>3];kA(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+200>>3];rb=+zd(1.0e-13,+(+h[qa+208>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+nwa(c[ib>>2]|0,rb,37688,57272,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(Eb- +yd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{jA(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);Lb=+h[ta>>3];kA(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);Lb=+h[va>>3];jA(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);qb=+h[wa>>3];kA(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+zd(1.0e-13,+(+h[wa+208>>3]- +h[ya>>3]));Eb=1.0- +h[wa+200>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+nwa(c[ib>>2]|0,qb,37688,57272,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{jA(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);Ob=+h[za>>3];kA(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);Ob=+h[Ba>>3];jA(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);Lb=+h[Ca>>3];kA(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);Lb=+h[Ea>>3];jA(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);qb=+h[Fa>>3];kA(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+208>>3]- +h[Ha>>3])|0)<<24>>24==0){jA(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);qb=+h[Ia>>3];kA(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Ka,c[ib>>2]|0,+h[Ja+192>>3],+h[Ja+848>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(La,c[ib>>2]|0,+h[Ka+192>>3],+h[Ka+848>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+192>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+848>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+864>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}jA(Na,c[ib>>2]|0,+h[Qb+192>>3]);rb=+h[Na>>3];kA(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);rb=+h[Pa>>3];jA(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);Eb=+h[Qa>>3];kA(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);Eb=+h[Sa>>3];jA(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);qb=+h[Ta>>3];kA(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Va,c[ib>>2]|0,+h[Ua+192>>3],+h[Ua+848>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(Wa,c[ib>>2]|0,+h[Va+192>>3],+h[Va+848>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Xa,c[ib>>2]|0,qb,Bb,+h[Va+192>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+848>>3],0.0);Cb=+h[Xa>>3];jA(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);Bb=+h[Ya>>3];kA(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+208>>3];vb=+zd(1.0e-13,+(qb-rb));rb=vb*+zd(1.0e-13,+(qb-Eb));Eb=+h[Za+856>>3];vb=-(Eb*+zd(1.0e-13,+(qb-Lb)));Lb=+h[Za+200>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+nwa(c[ib>>2]|0,rb,37992,57272,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+200>>3];Tb=+h[Ya+208>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+zd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+nwa(c[ib>>2]|0,Vb,37688,57272,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+856>>3]-Pb}Pb=+h[Mb+192>>3];Wb=Pb+-273.15;Cb=+h[Mb+848>>3];sA($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];jA(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);Pb=+h[ab>>3];kA(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);Pb=+h[cb>>3];jA(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);Wb=+h[db>>3];kA(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]);lA(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+192>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+192>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+nwa(c[ib>>2]|0,rb,38600,57272,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+192>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+856>>3]-ub);ub=+h[Yb+848>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+nwa(c[ib>>2]|0,Xb,38600,57272,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+848>>3];ac=+h[Yb+192>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+Nxa(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+200>>3];Gb=+zd(1.0e-13,+(+h[Yb+208>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+nwa(c[ib>>2]|0,Gb,37688,57272,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +zd(+(ac- +yd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+192>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+nwa(c[ib>>2]|0,ec,38600,57272,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+192>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+856>>3];ic=+h[gc+848>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+nwa(c[ib>>2]|0,fc,38600,57272,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+848>>3];kc=+h[gc+192>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+Nxa(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+200>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+zd(1.0e-13,+(+h[gc+208>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9456|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9456|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+nwa(c[ib>>2]|0,Nb,37688,57272,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9456|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function bQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+12176>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+12152>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+12160>>3];h[a+8>>3]=+h[d+11952>>3];h[e+8>>3]=+h[d+11928>>3];h[f+8>>3]=+h[d+11936>>3];i=i;return}function cQ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0.0,k=0.0,l=0.0,m=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+864>>3]=+h[b>>3];h[a+848>>3]=+h[b+8>>3];XP(f);YP(f);ZP(f);_P(f);$P(f);aQ(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;g=f+3176|0;j=+h[g>>3];b=f+192|0;k=+h[b>>3];l=j*k;a=f+848|0;m=f+9040|0;h[d>>3]=+h[f+9464>>3]*l*l+(+h[f+208>>3]*(j*+h[a>>3]+k*+h[m>>3])-l*+h[f+864>>3]);h[d+8>>3]=+h[f+8232>>3]+(+h[m>>3]*+h[b>>3]+(+h[g>>3]*+h[a>>3]- +h[f+9456>>3]));i=e;return}function dQ(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+49920>>3];h[c[b+8>>2]>>3]=+h[d+49896>>3];h[c[b+12>>2]>>3]=+h[d+49904>>3];i=i;return}function eQ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+3560>>3]=g;k=a+416|0;l=c[k>>2]|0;Kz(f,c[a+536>>2]|0,g,+h[j+3952>>3],+h[j+3960>>3],+h[j+3848>>3],+h[j+3856>>3],+h[j+10320>>3],+h[j+9872>>3],+h[l+2056>>3]*5.0,(+h[l+792>>3]+ +h[l+800>>3])*.5,+h[l+2048>>3]/6.0,+h[l+2016>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+304>>3]- +h[f>>3]*+h[(c[k>>2]|0)+1992>>3];i=e;return}function fQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;iA(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+216>>3]);if((Aza(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+232>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+888>>3]*.999;l=j;m=l+9032|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;xA(e,c[f>>2]|0,+h[d+216>>3],+h[d+872>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+9032|0;n=m;h[n>>3]=k;i=b;return}}function gQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3224>>3];k=+zd(1.0e-13,+(+h[g+232>>3]-j));l=+h[g+4424>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+nwa(c[b+536>>2]|0,k,46736,57280,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8224|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=Cza(1.0e-13,+h[f+232>>3]- +h[f+3224>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+3224>>3];j=+h[x+232>>3];k=+zd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+8944>>3];k=+h[x+4424>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+888>>3]- +h[x+9032>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+888>>3]- +h[x+9032>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+888>>3]- +h[x+9032>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+888>>3]- +h[x+9032>>3]}K=(y-k*J)/+nwa(c[b+536>>2]|0,l,46896,57280,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+4424>>3];C=+h[L+3224>>3];D=+h[L+232>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+9032>>3];m=+zd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+nwa(c[b+536>>2]|0,m,46736,57280,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8224|0;w=v;h[w>>3]=n;i=d;return}function hQ(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(Cza(+h[a+224>>3]- +h[a+3240>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+9024|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+880>>3]- +h[a+8224>>3];g=a;j=g+9024|0;k=j;h[k>>3]=f;i=b;return}function iQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8216>>3]=+h[b+880>>3]- +h[b+9024>>3];i=i;return}function jQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3256>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+9024>>3];o=+h[g+8944>>3]*k+ +h[g+4424>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+nwa(c[b+536>>2]|0,l,47032,57288,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+9024>>3];q=+h[v+3256>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+8216>>3]*(1.0-q)+ +h[r+3248>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+9016|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+9016|0;C=B;h[C>>3]=z;i=d;return}p=t/+nwa(c[b+536>>2]|0,l,47032,57288,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+9016|0;C=B;h[C>>3]=z;i=d;return}



function WZ(a){a=a|0;var b=0,d=0,e=0,f=0,j=0.0;b=i;d=c[(a+4|0)>>2]|0;e=c[(a+468|0)>>2]|0;h[c[e+44>>2]>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+328>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+328|0;h[c[e+48>>2]>>3]=+h[f>>3];j=+aAa(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+328>>3]);d=c[(a+468|0)>>2]|0;h[c[d+52>>2]>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+44>>2]|0)+8>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+520>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+520|0;h[(c[d+48>>2]|0)+8>>3]=+h[e>>3];j=+aAa(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+520>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+52>>2]|0)+8>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+44>>2]|0)+16>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+200>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+200|0;h[(c[f+48>>2]|0)+16>>3]=+h[d>>3];j=+aAa(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+200>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+52>>2]|0)+16>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+44>>2]|0)+24>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+56>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+56|0;h[(c[e+48>>2]|0)+24>>3]=+h[f>>3];j=+aAa(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+56>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+52>>2]|0)+24>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+44>>2]|0)+32>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+32>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+32|0;h[(c[d+48>>2]|0)+32>>3]=+h[e>>3];j=+aAa(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+32>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+52>>2]|0)+32>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+44>>2]|0)+40>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+8>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+8|0;h[(c[f+48>>2]|0)+40>>3]=+h[d>>3];j=+aAa(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+8>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+52>>2]|0)+40>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+44>>2]|0)+48>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+80>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+80|0;h[(c[e+48>>2]|0)+48>>3]=+h[f>>3];j=+aAa(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+80>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+52>>2]|0)+48>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+44>>2]|0)+56>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+224>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+224|0;h[(c[d+48>>2]|0)+56>>3]=+h[e>>3];j=+aAa(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+224>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+52>>2]|0)+56>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+44>>2]|0)+64>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+248>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+248|0;h[(c[f+48>>2]|0)+64>>3]=+h[d>>3];j=+aAa(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+248>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+52>>2]|0)+64>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+44>>2]|0)+72>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+568>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+568|0;h[(c[e+48>>2]|0)+72>>3]=+h[f>>3];j=+aAa(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+568>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+52>>2]|0)+72>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+44>>2]|0)+80>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+544>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+544|0;h[(c[d+48>>2]|0)+80>>3]=+h[e>>3];j=+aAa(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+544>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+52>>2]|0)+80>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+44>>2]|0)+88>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+592>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+592|0;h[(c[f+48>>2]|0)+88>>3]=+h[d>>3];j=+aAa(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+592>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+52>>2]|0)+88>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+44>>2]|0)+96>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+5960>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+5960|0;h[(c[e+48>>2]|0)+96>>3]=+h[f>>3];j=+aAa(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+5960>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+52>>2]|0)+96>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+44>>2]|0)+104>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+272>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+272|0;h[(c[d+48>>2]|0)+104>>3]=+h[e>>3];j=+aAa(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+272>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+52>>2]|0)+104>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+44>>2]|0)+112>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+496>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+496|0;h[(c[f+48>>2]|0)+112>>3]=+h[d>>3];j=+aAa(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+496>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+52>>2]|0)+112>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+44>>2]|0)+120>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+176>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+176|0;h[(c[e+48>>2]|0)+120>>3]=+h[f>>3];j=+aAa(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+176>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+52>>2]|0)+120>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+44>>2]|0)+128>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+104>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+104|0;h[(c[d+48>>2]|0)+128>>3]=+h[e>>3];j=+aAa(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+104>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+52>>2]|0)+128>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+44>>2]|0)+136>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+416>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+416|0;h[(c[f+48>>2]|0)+136>>3]=+h[d>>3];j=+aAa(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+416>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+52>>2]|0)+136>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+44>>2]|0)+144>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+368>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+368|0;h[(c[e+48>>2]|0)+144>>3]=+h[f>>3];j=+aAa(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+368>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+52>>2]|0)+144>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+44>>2]|0)+152>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+392>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+392|0;h[(c[d+48>>2]|0)+152>>3]=+h[e>>3];j=+aAa(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+392>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+52>>2]|0)+152>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+44>>2]|0)+160>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+440>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+440|0;h[(c[f+48>>2]|0)+160>>3]=+h[d>>3];j=+aAa(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+440>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+52>>2]|0)+160>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+44>>2]|0)+168>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+344>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+344|0;h[(c[e+48>>2]|0)+168>>3]=+h[f>>3];j=+aAa(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+344>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+52>>2]|0)+168>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+44>>2]|0)+176>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+560>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+560|0;h[(c[d+48>>2]|0)+176>>3]=+h[e>>3];j=+aAa(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+560>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+52>>2]|0)+176>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+44>>2]|0)+184>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+576>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+576|0;h[(c[f+48>>2]|0)+184>>3]=+h[d>>3];j=+aAa(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+576>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+52>>2]|0)+184>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+44>>2]|0)+192>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+536>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+536|0;h[(c[e+48>>2]|0)+192>>3]=+h[f>>3];j=+aAa(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+536>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+52>>2]|0)+192>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+44>>2]|0)+200>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+552>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+552|0;h[(c[d+48>>2]|0)+200>>3]=+h[e>>3];j=+aAa(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+552>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+52>>2]|0)+200>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+44>>2]|0)+208>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+584>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+584|0;h[(c[f+48>>2]|0)+208>>3]=+h[d>>3];j=+aAa(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+584>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+52>>2]|0)+208>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+44>>2]|0)+216>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+600>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+600|0;h[(c[e+48>>2]|0)+216>>3]=+h[f>>3];j=+aAa(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+600>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+52>>2]|0)+216>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+44>>2]|0)+224>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+4544>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+4544|0;h[(c[d+48>>2]|0)+224>>3]=+h[e>>3];j=+aAa(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+4544>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+52>>2]|0)+224>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+44>>2]|0)+232>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4512>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+4512|0;h[(c[f+48>>2]|0)+232>>3]=+h[d>>3];j=+aAa(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4512>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+52>>2]|0)+232>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+44>>2]|0)+240>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+4520>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+4520|0;h[(c[e+48>>2]|0)+240>>3]=+h[f>>3];j=+aAa(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+4520>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+52>>2]|0)+240>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+44>>2]|0)+248>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+400>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+400|0;h[(c[d+48>>2]|0)+248>>3]=+h[e>>3];j=+aAa(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+400>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+52>>2]|0)+248>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+44>>2]|0)+256>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4536>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+4536|0;h[(c[f+48>>2]|0)+256>>3]=+h[d>>3];j=+aAa(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4536>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+52>>2]|0)+256>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+44>>2]|0)+264>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+360>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+360|0;h[(c[e+48>>2]|0)+264>>3]=+h[f>>3];j=+aAa(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+360>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+52>>2]|0)+264>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+44>>2]|0)+272>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+376>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+376|0;h[(c[d+48>>2]|0)+272>>3]=+h[e>>3];j=+aAa(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+376>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+52>>2]|0)+272>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+44>>2]|0)+280>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4528>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+4528|0;h[(c[f+48>>2]|0)+280>>3]=+h[d>>3];j=+aAa(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4528>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+52>>2]|0)+280>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+44>>2]|0)+288>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+384>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+384|0;h[(c[e+48>>2]|0)+288>>3]=+h[f>>3];j=+aAa(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+384>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+52>>2]|0)+288>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+44>>2]|0)+296>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+336>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+336|0;h[(c[d+48>>2]|0)+296>>3]=+h[e>>3];j=+aAa(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+336>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+52>>2]|0)+296>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+44>>2]|0)+304>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+352>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+352|0;h[(c[f+48>>2]|0)+304>>3]=+h[d>>3];j=+aAa(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+352>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+52>>2]|0)+304>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+44>>2]|0)+312>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+208>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+208|0;h[(c[e+48>>2]|0)+312>>3]=+h[f>>3];j=+aAa(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+208>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+52>>2]|0)+312>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+44>>2]|0)+320>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+64>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+64|0;h[(c[d+48>>2]|0)+320>>3]=+h[e>>3];j=+aAa(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+64>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+52>>2]|0)+320>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+44>>2]|0)+328>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+48>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+48|0;h[(c[f+48>>2]|0)+328>>3]=+h[d>>3];j=+aAa(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+48>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+52>>2]|0)+328>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+44>>2]|0)+336>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+40>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+40|0;h[(c[e+48>>2]|0)+336>>3]=+h[f>>3];j=+aAa(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+40>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+52>>2]|0)+336>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+44>>2]|0)+344>>3]=+h[c[(c[f>>2]|0)+8>>2]>>3];e=c[(c[f+4>>2]|0)+8>>2]|0;h[(c[d+48>>2]|0)+344>>3]=+h[e>>3];j=+aAa(a,+h[e>>3],+h[c[(c[f+8>>2]|0)+8>>2]>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+52>>2]|0)+344>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+44>>2]|0)+352>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+16>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+16|0;h[(c[f+48>>2]|0)+352>>3]=+h[d>>3];j=+aAa(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+16>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+52>>2]|0)+352>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+44>>2]|0)+360>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+24>>3];c[b+8>>2]=a;c[b+424>>2]=e;c[b+432>>2]=d;c[b+2216>>2]=0;c[b+2220>>2]=0;_Modelica_Fluid_Examples_BranchingDynamicPipes_eqFunction_1187$0(b);H=c[b+2216>>2]|0;A=c[b+2220>>2]|0;I=+g[b+2220>>2];c[b+2216>>2]=0;c[b+2220>>2]=0;if((H|0)==5){return}}function XZ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+272>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+3504|0;q=p;h[q>>3]=n;i=d;return}j=+nwa(c[b+536>>2]|0,k,61888,61880,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+3504|0;q=p;h[q>>3]=n;i=d;return}function YZ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+4440>>3]),1.0e-13);k=+h[g+272>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+3496|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+3496|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,61992,61984,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+3496|0;p=o;h[p>>3]=m;i=d;return}function ZZ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+440>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+5512|0;q=p;h[q>>3]=n;i=d;return}j=+nwa(c[b+536>>2]|0,k,62040,62032,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+5512|0;q=p;h[q>>3]=n;i=d;return}function _Z(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+6320>>3]),1.0e-13);k=+h[g+440>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+5504|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+5504|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,62144,62136,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+5504|0;p=o;h[p>>3]=m;i=d;return}function $Z(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5440>>3]=+h[b+432>>3]+-273.15;i=i;return}function a_(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+416>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+5400|0;q=p;h[q>>3]=n;i=d;return}j=+nwa(c[b+536>>2]|0,k,62192,62184,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+5400|0;q=p;h[q>>3]=n;i=d;return}function b_(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+6312>>3]),1.0e-13);k=+h[g+416>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+5392|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+5392|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,62296,62288,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+5392|0;p=o;h[p>>3]=m;i=d;return}function c_(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5336>>3]=+h[b+424>>3]*1.0e-5;i=i;return}function d_(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5328>>3]=+h[b+408>>3]+-273.15;i=i;return}function e_(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6168>>3]=+h[b+440>>3]*+h[b+6208>>3];i=i;return}function f_(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5448>>3]=+h[b+448>>3]*1.0e-5;i=i;return}function g_(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+456>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+5784>>3]=+h[(a?e+5824|0:e+5816|0)>>3];i=b;return}function h_(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+456>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+5712>>3]=+h[(a?e+5752|0:e+5744|0)>>3];i=b;return}function i_(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6448>>3]=+h[b+504>>3]*1.0e-5;i=i;return}function j_(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6456>>3];k=+zd(1.0e-13,+(+h[g+504>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+nwa(c[b+536>>2]|0,k,62344,62336,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+6464>>3]=m*.6219647130774989;i=d;return}function k_(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6552>>3]=+h[b+512>>3]+-273.15;i=i;return}function l_(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6560>>3]=+h[b+528>>3]*1.0e-5;i=i;return}function m_(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6568>>3];k=+zd(1.0e-13,+(+h[g+528>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+nwa(c[b+536>>2]|0,k,62416,62408,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+6576>>3]=m*.6219647130774989;i=d;return}function n_(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+520>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+6624|0;q=p;h[q>>3]=n;i=d;return}j=+nwa(c[b+536>>2]|0,k,62488,62480,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+6624|0;q=p;h[q>>3]=n;i=d;return}function o_(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+568>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+6848|0;q=p;h[q>>3]=n;i=d;return}j=+nwa(c[b+536>>2]|0,k,62592,62584,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+6848|0;q=p;h[q>>3]=n;i=d;return}function p_(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+7776>>3]),1.0e-13);k=+h[g+568>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+6840|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+6840|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,62696,62688,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6840|0;p=o;h[p>>3]=m;i=d;return}function q_(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6896>>3]=+h[b+600>>3]*1.0e-5;i=i;return}function r_(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6904>>3];k=+zd(1.0e-13,+(+h[g+600>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+nwa(c[b+536>>2]|0,k,62744,62736,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+6912>>3]=m*.6219647130774989;i=d;return}function s_(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6888>>3]=+h[b+584>>3]+-273.15;i=i;return}function t_(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+592>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+6960|0;q=p;h[q>>3]=n;i=d;return}j=+nwa(c[b+536>>2]|0,k,62816,62808,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+6960|0;q=p;h[q>>3]=n;i=d;return}function u_(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+7784>>3]),1.0e-13);k=+h[g+592>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+6952|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+6952|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,62920,62912,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6952|0;p=o;h[p>>3]=m;i=d;return}function v_(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+600>>3];k=+h[g+592>>3];l=+h[g+6904>>3]*(k+ +h[g+7784>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+6944|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+6944|0;r=q;h[r>>3]=o;i=d;return}s=k/+nwa(c[b+536>>2]|0,l,62968,62960,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+6944|0;r=q;h[r>>3]=o;i=d;return}function w_(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+592>>3];p=f;h[k>>3]=+h[n+7784>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+600>>3];q=+h[p+584>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];fA(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+6360>>3]=+h[l>>3];i=b;return}function x_(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+608>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7288>>3]=+h[(a?e+9576|0:e+9568|0)>>3];i=b;return}function y_(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+608>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7240>>3]=+h[(a?e+9632|0:e+9624|0)>>3];i=b;return}function z_(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7192>>3]=+h[b+608>>3]*+h[b+10008>>3];i=i;return}function A_(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6784>>3]=+h[b+576>>3]*1.0e-5;i=i;return}function B_(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+616>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7296>>3]=+h[(a?e+9584|0:e+9576|0)>>3];i=b;return}function C_(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6776>>3]=+h[b+560>>3]+-273.15;i=i;return}function D_(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+616>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7248>>3]=+h[(a?e+9640|0:e+9632|0)>>3];i=b;return}function E_(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+568>>3];p=f;h[k>>3]=+h[n+7776>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+576>>3];q=+h[p+560>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];fA(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+6368>>3]=+h[l>>3];i=b;return}function F_(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7616>>3]=+h[b+568>>3]*+h[b+7656>>3];i=i;return}function G_(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6792>>3];k=+zd(1.0e-13,+(+h[g+576>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+nwa(c[b+536>>2]|0,k,63080,63072,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+6800>>3]=m*.6219647130774989;i=d;return}function H_(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+576>>3];k=+h[g+568>>3];l=+h[g+6792>>3]*(k+ +h[g+7776>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+6832|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+6832|0;r=q;h[r>>3]=o;i=d;return}s=k/+nwa(c[b+536>>2]|0,l,63152,63144,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+6832|0;r=q;h[r>>3]=o;i=d;return}function I_(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6672>>3]=+h[b+552>>3]*1.0e-5;i=i;return}function J_(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6664>>3]=+h[b+536>>3]+-273.15;i=i;return}function K_(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+624>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7304>>3]=+h[(a?e+9592|0:e+9584|0)>>3];i=b;return}function L_(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+632>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7312>>3]=+h[(a?e+9600|0:e+9592|0)>>3];i=b;return}function M_(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+544>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+6736|0;q=p;h[q>>3]=n;i=d;return}j=+nwa(c[b+536>>2]|0,k,63264,63256,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+6736|0;q=p;h[q>>3]=n;i=d;return}function N_(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7624>>3]=+h[b+544>>3]*+h[b+7664>>3];i=i;return}function O_(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+624>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7256>>3]=+h[(a?e+9648|0:e+9640|0)>>3];i=b;return}function P_(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+632>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7264>>3]=+h[(a?e+9656|0:e+9648|0)>>3];i=b;return}function Q_(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+7768>>3]),1.0e-13);k=+h[g+544>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+6728|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+6728|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,63368,63360,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6728|0;p=o;h[p>>3]=m;i=d;return}function R_(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+544>>3];p=f;h[k>>3]=+h[n+7768>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+552>>3];q=+h[p+536>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];fA(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+6376>>3]=+h[l>>3];i=b;return}function S_(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7704>>3]=+h[b+7664>>3]*+h[b+6752>>3];i=i;return}function T_(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6680>>3];k=+zd(1.0e-13,+(+h[g+552>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+nwa(c[b+536>>2]|0,k,63416,63408,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+6688>>3]=m*.6219647130774989;i=d;return}function U_(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+552>>3];k=+h[g+544>>3];l=+h[g+6680>>3]*(k+ +h[g+7768>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+6720|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+6720|0;r=q;h[r>>3]=o;i=d;return}s=k/+nwa(c[b+536>>2]|0,l,63488,63480,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+6720|0;r=q;h[r>>3]=o;i=d;return}function V_(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7200>>3]=+h[b+616>>3]*+h[b+10016>>3];i=i;return}function W_(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7608>>3]=+h[b+592>>3]*+h[b+7648>>3];i=i;return}function X_(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7688>>3]=+h[b+7648>>3]*+h[b+6976>>3];i=i;return}function Y_(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7696>>3]=+h[b+7656>>3]*+h[b+6864>>3];i=i;return}function Z_(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7208>>3]=+h[b+624>>3]*+h[b+10024>>3];i=i;return}function __(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7216>>3]=+h[b+632>>3]*+h[b+10032>>3];i=i;return}function $_(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+640>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7272>>3]=+h[(a?e+9664|0:e+9656|0)>>3];i=b;return}function a$(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6440>>3]=+h[b+488>>3]+-273.15;i=i;return}function b$(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+496>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+6512|0;q=p;h[q>>3]=n;i=d;return}j=+nwa(c[b+536>>2]|0,k,63600,63592,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+6512|0;q=p;h[q>>3]=n;i=d;return}function c$(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+7752>>3]),1.0e-13);k=+h[g+496>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+6504|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+6504|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,63704,63696,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6504|0;p=o;h[p>>3]=m;i=d;return}function d$(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+504>>3];k=+h[g+496>>3];l=+h[g+6456>>3]*(k+ +h[g+7752>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+6496|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+6496|0;r=q;h[r>>3]=o;i=d;return}s=k/+nwa(c[b+536>>2]|0,l,63752,63744,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+6496|0;r=q;h[r>>3]=o;i=d;return}function e$(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+648>>3]),1.0e-15);k=+zd(+-+h[g+288>>3],1.0e-15);l=j+k;m=j*+h[g+496>>3]+k*+h[g+272>>3];if(l!=0.0){n=g;o=m/l;p=n;q=p+6344|0;r=q;h[r>>3]=o;i=d;return}if(m==0.0){n=g;o=m;p=n;q=p+6344|0;r=q;h[r>>3]=o;i=d;return}k=m/+nwa(c[b+536>>2]|0,l,63864,63856,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=k;p=n;q=p+6344|0;r=q;h[r>>3]=o;i=d;return}function f$(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+648>>3]),1.0e-15);k=+zd(+-+h[g+288>>3],1.0e-15);l=j+k;m=-(k*+h[g+272>>3])-j*+h[g+496>>3];if(l!=0.0){n=g;o=m/l;p=o+1.0;q=n;r=q+6352|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=o+1.0;q=n;r=q+6352|0;s=r;h[s>>3]=p;i=d;return}j=m/+nwa(c[b+536>>2]|0,l,63864,63952,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=o+1.0;q=n;r=q+6352|0;s=r;h[s>>3]=p;i=d;return}function g$(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3432>>3]=+h[b+264>>3]+-273.15;i=i;return}function h$(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3440>>3]=+h[b+280>>3]*1.0e-5;i=i;return}function i$(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+288>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3784>>3]=+h[(a?e+3840|0:e+3832|0)>>3];i=b;return}function j$(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+272>>3];p=f;h[k>>3]=+h[n+4440>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+280>>3];q=+h[p+264>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];fA(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2904>>3]=+h[l>>3];i=b;return}function k$(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3328>>3]=+h[b+256>>3]*1.0e-5;i=i;return}function l$(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3336>>3];k=+zd(1.0e-13,+(+h[g+256>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+nwa(c[b+536>>2]|0,k,63968,63960,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+3344>>3]=m*.6219647130774989;i=d;return}function m$(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+296>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3792>>3]=+h[(a?e+3848|0:e+3840|0)>>3];i=b;return}function n$(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3320>>3]=+h[b+240>>3]+-273.15;i=i;return}function o$(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3208>>3]=+h[b+216>>3]+-273.15;i=i;return}function p$(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3216>>3]=+h[b+232>>3]*1.0e-5;i=i;return}function q$(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3224>>3];k=+zd(1.0e-13,+(+h[g+232>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+nwa(c[b+536>>2]|0,k,64040,64032,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+3232>>3]=m*.6219647130774989;i=d;return}function r$(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3096>>3]=+h[b+192>>3]+-273.15;i=i;return}function s$(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+200>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+3168|0;q=p;h[q>>3]=n;i=d;return}j=+nwa(c[b+536>>2]|0,k,64112,64104,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+3168|0;q=p;h[q>>3]=n;i=d;return}function t$(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+4416>>3]),1.0e-13);k=+h[g+200>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+3160|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+3160|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,64216,64208,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+3160|0;p=o;h[p>>3]=m;i=d;return}function u$(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2984>>3]=+h[b+168>>3]+-273.15;i=i;return}function v$(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2992>>3]=+h[b+184>>3]*1.0e-5;i=i;return}function w$(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3e3>>3];k=+zd(1.0e-13,+(+h[g+184>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+nwa(c[b+536>>2]|0,k,64264,64256,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+3008>>3]=m*.6219647130774989;i=d;return}function x$(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+176>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+3056|0;q=p;h[q>>3]=n;i=d;return}j=+nwa(c[b+536>>2]|0,k,64336,64328,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+3056|0;q=p;h[q>>3]=n;i=d;return}function y$(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1880>>3]=+h[b+96>>3]+-273.15;i=i;return}function z$(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4376>>3]=+h[b+4336>>3]*+h[b+3072>>3];i=i;return}function A$(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4296>>3]=+h[b+176>>3]*+h[b+4336>>3];i=i;return}function B$(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+344>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+5064|0;q=p;h[q>>3]=n;i=d;return}j=+nwa(c[b+536>>2]|0,k,64440,64432,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+5064|0;q=p;h[q>>3]=n;i=d;return}function C$(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+6288>>3]),1.0e-13);k=+h[g+344>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+5056|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+5056|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,64544,64536,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+5056|0;p=o;h[p>>3]=m;i=d;return}function D$(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5e3>>3]=+h[b+352>>3]*1.0e-5;i=i;return}function E$(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6200>>3]=+h[b+344>>3]*+h[b+6240>>3];i=i;return}function F$(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4992>>3]=+h[b+336>>3]+-273.15;i=i;return}function G$(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+368>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+5176|0;q=p;h[q>>3]=n;i=d;return}j=+nwa(c[b+536>>2]|0,k,64592,64584,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+5176|0;q=p;h[q>>3]=n;i=d;return}function H$(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+6296>>3]),1.0e-13);k=+h[g+368>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+5168|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+5168|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,64696,64688,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+5168|0;p=o;h[p>>3]=m;i=d;return}function I$(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6192>>3]=+h[b+368>>3]*+h[b+6232>>3];i=i;return}function J$(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5216>>3]=+h[b+384>>3]+-273.15;i=i;return}function K$(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+392>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+5288|0;q=p;h[q>>3]=n;i=d;return}j=+nwa(c[b+536>>2]|0,k,64744,64736,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+5288|0;q=p;h[q>>3]=n;i=d;return}function L$(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5112>>3]=+h[b+376>>3]*1.0e-5;i=i;return}function M$(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5104>>3]=+h[b+360>>3]+-273.15;i=i;return}function N$(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+480>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+5808>>3]=+h[(a?e+5848|0:e+5840|0)>>3];i=b;return}function O$(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+480>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+5736>>3]=+h[(a?e+5776|0:e+5768|0)>>3];i=b;return}function P$(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+648>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7280>>3]=+h[(a?e+9672|0:e+9664|0)>>3];i=b;return}function Q$(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5224>>3]=+h[b+400>>3]*1.0e-5;i=i;return}function R$(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+464>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+5792>>3]=+h[(a?e+5832|0:e+5824|0)>>3];i=b;return}function S$(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+472>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+5800>>3]=+h[(a?e+5840|0:e+5832|0)>>3];i=b;return}function T$(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+464>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+5720>>3]=+h[(a?e+5760|0:e+5752|0)>>3];i=b;return}function U$(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+472>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+5728>>3]=+h[(a?e+5768|0:e+5760|0)>>3];i=b;return}function V$(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5232>>3];k=+zd(1.0e-13,+(+h[g+400>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+nwa(c[b+536>>2]|0,k,64848,64840,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+5240>>3]=m*.6219647130774989;i=d;return}function W$(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5688>>3]=+h[b+464>>3]*+h[b+10208>>3];i=i;return}function X$(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5696>>3]=+h[b+472>>3]*+h[b+10216>>3];i=i;return}function Y$(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5704>>3]=+h[b+480>>3]*+h[b+10224>>3];i=i;return}function Z$(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5120>>3];k=+zd(1.0e-13,+(+h[g+376>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+nwa(c[b+536>>2]|0,k,64920,64912,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+5128>>3]=m*.6219647130774989;i=d;return}function _$(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+376>>3];k=+h[g+368>>3];l=+h[g+5120>>3]*(k+ +h[g+6296>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+5160|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+5160|0;r=q;h[r>>3]=o;i=d;return}s=k/+nwa(c[b+536>>2]|0,l,64992,64984,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+5160|0;r=q;h[r>>3]=o;i=d;return}function $$(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+6304>>3]),1.0e-13);k=+h[g+392>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+5280|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+5280|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,65104,65096,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+5280|0;p=o;h[p>>3]=m;i=d;return}function a0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+400>>3];k=+h[g+392>>3];l=+h[g+5232>>3]*(k+ +h[g+6304>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+5272|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+5272|0;r=q;h[r>>3]=o;i=d;return}s=k/+nwa(c[b+536>>2]|0,l,65152,65144,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+5272|0;r=q;h[r>>3]=o;i=d;return}function b0(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6184>>3]=+h[b+392>>3]*+h[b+6224>>3];i=i;return}function c0(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6264>>3]=+h[b+6224>>3]*+h[b+5304>>3];i=i;return}function d0(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6272>>3]=+h[b+6232>>3]*+h[b+5192>>3];i=i;return}function e0(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6280>>3]=+h[b+6240>>3]*+h[b+5080>>3];i=i;return}function f0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5008>>3];k=+zd(1.0e-13,+(+h[g+352>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+nwa(c[b+536>>2]|0,k,65264,65256,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+5016>>3]=m*.6219647130774989;i=d;return}function g0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+352>>3];k=+h[g+344>>3];l=+h[g+5008>>3]*(k+ +h[g+6288>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+5048|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+5048|0;r=q;h[r>>3]=o;i=d;return}s=k/+nwa(c[b+536>>2]|0,l,65336,65328,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+5048|0;r=q;h[r>>3]=o;i=d;return}function h0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+328>>3]),1.0e-15);k=+zd(+-+h[g+120>>3],1.0e-15);l=j+k;m=j*+h[g+176>>3]+k*+h[g+104>>3];if(l!=0.0){n=g;o=m/l;p=n;q=p+6328|0;r=q;h[r>>3]=o;i=d;return}if(m==0.0){n=g;o=m;p=n;q=p+6328|0;r=q;h[r>>3]=o;i=d;return}k=m/+nwa(c[b+536>>2]|0,l,65448,65440,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=k;p=n;q=p+6328|0;r=q;h[r>>3]=o;i=d;return}function i0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+328>>3]),1.0e-15);k=+zd(+-+h[g+120>>3],1.0e-15);l=j+k;m=-(k*+h[g+104>>3])-j*+h[g+176>>3];if(l!=0.0){n=g;o=m/l;p=o+1.0;q=n;r=q+6336|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=o+1.0;q=n;r=q+6336|0;s=r;h[s>>3]=p;i=d;return}j=m/+nwa(c[b+536>>2]|0,l,65448,65536,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=o+1.0;q=n;r=q+6336|0;s=r;h[s>>3]=p;i=d;return}function j0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0.0;d=i;i=i+120|0;e=d;f=d+96|0;g=d+112|0;j=i;i=i+16|0;k=i;i=i+96|0;l=i;i=i+8|0;m=b+4|0;n=c[c[m>>2]>>2]|0;o=c[n+8>>2]|0;p=+zd(+(+h[o+328>>3]),1.0e-15);q=+zd(+-+h[o+120>>3],1.0e-15);r=p+q;s=p*+h[o+176>>3]+q*+h[o+104>>3];do{if(r!=0.0){t=s/r}else{if(s==0.0){t=s;break}t=s/+nwa(c[b+536>>2]|0,r,65448,65544,+h[n>>3],(a[b+319|0]|0)!=0|0)}}while(0);gxa(j,1,t,g);c[k>>2]=61192;h[k+8>>3]=.01801528;h[k+16>>3]=-13423382.81725291;h[k+24>>3]=549760.6476280135;h[k+32>>3]=1.0e3;g=k+40|0;n=61200;c[g+0>>2]=c[n+0>>2];c[g+4>>2]=c[n+4>>2];c[g+8>>2]=c[n+8>>2];n=k+52|0;g=61216;c[n+0>>2]=c[g+0>>2];c[n+4>>2]=c[g+4>>2];c[n+8>>2]=c[g+8>>2];g=k+64|0;n=61232;c[g+0>>2]=c[n+0>>2];c[g+4>>2]=c[n+4>>2];c[g+8>>2]=c[n+8>>2];n=k+76|0;g=61248;c[n+0>>2]=c[g+0>>2];c[n+4>>2]=c[g+4>>2];c[n+8>>2]=c[g+8>>2];h[k+88>>3]=461.5233290850878;g=c[b+536>>2]|0;n=c[c[m>>2]>>2]|0;o=c[n+8>>2]|0;t=+zd(+(+h[o+328>>3]),1.0e-15);r=+zd(+-+h[o+120>>3],1.0e-15);s=t+r;q=t*+h[o+3088>>3]+r*+h[o+1984>>3];do{if(s!=0.0){u=o;v=q/s}else{if(q==0.0){u=o;v=q;break}r=q/+nwa(g,s,65448,65544,+h[n>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[m>>2]>>2]|0)+8>>2]|0;v=r}}while(0);s=+h[u+352>>3];u=f;b=j;c[u+0>>2]=c[b+0>>2];c[u+4>>2]=c[b+4>>2];c[u+8>>2]=c[b+8>>2];b=e+0|0;u=k+0|0;k=b+96|0;do{c[b>>2]=c[u>>2];b=b+4|0;u=u+4|0}while((b|0)<(k|0));nA(l,g,v,190.0,647.0,s,f,e,1.0e-13);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+10768>>3]=+h[l>>3];i=d;return}function k0(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+328>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3928>>3]=+h[(a?e+3984|0:e+3976|0)>>3];i=b;return}function l0(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3776>>3]=+h[b+328>>3]*+h[b+10344>>3];i=i;return}function m0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+248>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+3392|0;q=p;h[q>>3]=n;i=d;return}j=+nwa(c[b+536>>2]|0,k,65560,65552,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+3392|0;q=p;h[q>>3]=n;i=d;return}function n0(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4272>>3]=+h[b+248>>3]*+h[b+4312>>3];i=i;return}function o0(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+296>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3896>>3]=+h[(a?e+3952|0:e+3944|0)>>3];i=b;return}function p0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+4432>>3]),1.0e-13);k=+h[g+248>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+3384|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+3384|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,65664,65656,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+3384|0;p=o;h[p>>3]=m;i=d;return}function q0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+256>>3];k=+h[g+248>>3];l=+h[g+3336>>3]*(k+ +h[g+4432>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+3376|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+3376|0;r=q;h[r>>3]=o;i=d;return}s=k/+nwa(c[b+536>>2]|0,l,65712,65704,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+3376|0;r=q;h[r>>3]=o;i=d;return}function r0(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+304>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3904>>3]=+h[(a?e+3960|0:e+3952|0)>>3];i=b;return}function s0(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3752>>3]=+h[b+304>>3]*+h[b+10320>>3];i=i;return}function t0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+224>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+3280|0;q=p;h[q>>3]=n;i=d;return}j=+nwa(c[b+536>>2]|0,k,65824,65816,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+3280|0;q=p;h[q>>3]=n;i=d;return}function u0(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+304>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3800>>3]=+h[(a?e+3856|0:e+3848|0)>>3];i=b;return}function v0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+4424>>3]),1.0e-13);k=+h[g+224>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+3272|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+3272|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,65928,65920,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+3272|0;p=o;h[p>>3]=m;i=d;return}function w0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+232>>3];k=+h[g+224>>3];l=+h[g+3224>>3]*(k+ +h[g+4424>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+3264|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+3264|0;r=q;h[r>>3]=o;i=d;return}s=k/+nwa(c[b+536>>2]|0,l,65976,65968,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+3264|0;r=q;h[r>>3]=o;i=d;return}function x0(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+224>>3];p=f;h[k>>3]=+h[n+4424>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+232>>3];q=+h[p+216>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];fA(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2920>>3]=+h[l>>3];i=b;return}function y0(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4280>>3]=+h[b+224>>3]*+h[b+4320>>3];i=i;return}function z0(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3104>>3]=+h[b+208>>3]*1.0e-5;i=i;return}function A0(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+312>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3912>>3]=+h[(a?e+3968|0:e+3960|0)>>3];i=b;return}function B0(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+320>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3920>>3]=+h[(a?e+3976|0:e+3968|0)>>3];i=b;return}function C0(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+312>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3808>>3]=+h[(a?e+3864|0:e+3856|0)>>3];i=b;return}function D0(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+320>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3816>>3]=+h[(a?e+3872|0:e+3864|0)>>3];i=b;return}function E0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3112>>3];k=+zd(1.0e-13,+(+h[g+208>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+nwa(c[b+536>>2]|0,k,66088,66080,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+3120>>3]=m*.6219647130774989;i=d;return}function F0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+208>>3];k=+h[g+200>>3];l=+h[g+3112>>3]*(k+ +h[g+4416>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+3152|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+3152|0;r=q;h[r>>3]=o;i=d;return}s=k/+nwa(c[b+536>>2]|0,l,66160,66152,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+3152|0;r=q;h[r>>3]=o;i=d;return}function G0(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+200>>3];p=f;h[k>>3]=+h[n+4416>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+208>>3];q=+h[p+192>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];fA(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2928>>3]=+h[l>>3];i=b;return}function H0(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4368>>3]=+h[b+4328>>3]*+h[b+3184>>3];i=i;return}function I0(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4288>>3]=+h[b+200>>3]*+h[b+4328>>3];i=i;return}function J0(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3760>>3]=+h[b+312>>3]*+h[b+10328>>3];i=i;return}function K0(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3768>>3]=+h[b+320>>3]*+h[b+10336>>3];i=i;return}function L0(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+328>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3824>>3]=+h[(a?e+3880|0:e+3872|0)>>3];i=b;return}function M0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+104>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+1952|0;q=p;h[q>>3]=n;i=d;return}j=+nwa(c[b+536>>2]|0,k,66272,66264,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+1952|0;q=p;h[q>>3]=n;i=d;return}function N0(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+120>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2336>>3]=+h[(a?e+2392|0:e+2384|0)>>3];i=b;return}function O0(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1888>>3]=+h[b+112>>3]*1.0e-5;i=i;return}function P0(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2192>>3]=+h[b+128>>3]*+h[b+10448>>3];i=i;return}function Q0(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1776>>3]=+h[b+88>>3]*1.0e-5;i=i;return}function R0(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1768>>3]=+h[b+72>>3]+-273.15;i=i;return}function S0(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2800>>3]=+h[b+2760>>3]*+h[b+1856>>3];i=i;return}function T0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+56>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+1728|0;q=p;h[q>>3]=n;i=d;return}j=+nwa(c[b+536>>2]|0,k,66376,66368,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+1728|0;q=p;h[q>>3]=n;i=d;return}function U0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+2856>>3]),1.0e-13);k=+h[g+56>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1720|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1720|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,66480,66472,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1720|0;p=o;h[p>>3]=m;i=d;return}function V0(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1544>>3]=+h[b+24>>3]+-273.15;i=i;return}function W0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+32>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+1616|0;q=p;h[q>>3]=n;i=d;return}j=+nwa(c[b+536>>2]|0,k,66528,66520,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+1616|0;q=p;h[q>>3]=n;i=d;return}function X0(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1440>>3]=+h[b+16>>3]*1.0e-5;i=i;return}function Y0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1448>>3];k=+zd(1.0e-13,+(+h[g+16>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+nwa(c[b+536>>2]|0,k,66632,66624,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+1456>>3]=m*.6219647130774989;i=d;return}function Z0(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1552>>3]=+h[b+40>>3]*1.0e-5;i=i;return}function _0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+80>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+1840|0;q=p;h[q>>3]=n;i=d;return}j=+nwa(c[b+536>>2]|0,k,66704,66696,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+1840|0;q=p;h[q>>3]=n;i=d;return}function $0(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2720>>3]=+h[b+80>>3]*+h[b+2760>>3];i=i;return}function a1(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+128>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2344>>3]=+h[(a?e+2400|0:e+2392|0)>>3];i=b;return}function b1(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+136>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2248>>3]=+h[(a?e+2304|0:e+2296|0)>>3];i=b;return}function c1(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+144>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2256>>3]=+h[(a?e+2312|0:e+2304|0)>>3];i=b;return}function d1(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1656>>3]=+h[b+48>>3]+-273.15;i=i;return}function e1(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1664>>3]=+h[b+64>>3]*1.0e-5;i=i;return}function f1(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+136>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2352>>3]=+h[(a?e+2408|0:e+2400|0)>>3];i=b;return}function g1(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+144>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2360>>3]=+h[(a?e+2416|0:e+2408|0)>>3];i=b;return}function h1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1672>>3];k=+zd(1.0e-13,+(+h[g+64>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+nwa(c[b+536>>2]|0,k,66808,66800,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+1680>>3]=m*.6219647130774989;i=d;return}function i1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+64>>3];k=+h[g+56>>3];l=+h[g+1672>>3]*(k+ +h[g+2856>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+1712|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+1712|0;r=q;h[r>>3]=o;i=d;return}s=k/+nwa(c[b+536>>2]|0,l,66880,66872,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+1712|0;r=q;h[r>>3]=o;i=d;return}function j1(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+56>>3];p=f;h[k>>3]=+h[n+2856>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+64>>3];q=+h[p+48>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];fA(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+1368>>3]=+h[l>>3];i=b;return}function k1(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2728>>3]=+h[b+56>>3]*+h[b+2768>>3];i=i;return}function l1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+2864>>3]),1.0e-13);k=+h[g+80>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1832|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1832|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,66992,66984,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1832|0;p=o;h[p>>3]=m;i=d;return}function m1(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+80>>3];p=f;h[k>>3]=+h[n+2864>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+88>>3];q=+h[p+72>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];fA(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+1360>>3]=+h[l>>3];i=b;return}function n1(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2200>>3]=+h[b+136>>3]*+h[b+10456>>3];i=i;return}function o1(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2208>>3]=+h[b+144>>3]*+h[b+10464>>3];i=i;return}function p1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1560>>3];k=+zd(1.0e-13,+(+h[g+40>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+nwa(c[b+536>>2]|0,k,67040,67032,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+1568>>3]=m*.6219647130774989;i=d;return}function q1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+1504|0;q=p;h[q>>3]=n;i=d;return}j=+nwa(c[b+536>>2]|0,k,67112,67104,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+1504|0;q=p;h[q>>3]=n;i=d;return}function r1(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2744>>3]=+h[b+8>>3]*+h[b+2784>>3];i=i;return}function s1(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1432>>3]=+h[b>>3]+-273.15;i=i;return}function t1(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+152>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2368>>3]=+h[(a?e+2424|0:e+2416|0)>>3];i=b;return}function u1(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+160>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2376>>3]=+h[(a?e+2432|0:e+2424|0)>>3];i=b;return}function v1(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+152>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2264>>3]=+h[(a?e+2320|0:e+2312|0)>>3];i=b;return}function w1(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+160>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2272>>3]=+h[(a?e+2328|0:e+2320|0)>>3];i=b;return}function x1(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2224>>3]=+h[b+160>>3]*+h[b+10480>>3];i=i;return}function y1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+2840>>3]),1.0e-13);k=+h[g+8>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1496|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1496|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,67216,67208,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1496|0;p=o;h[p>>3]=m;i=d;return}function z1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+16>>3];k=+h[g+8>>3];l=+h[g+1448>>3]*(k+ +h[g+2840>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+1488|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+1488|0;r=q;h[r>>3]=o;i=d;return}s=k/+nwa(c[b+536>>2]|0,l,67264,67256,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+1488|0;r=q;h[r>>3]=o;i=d;return}function A1(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+8>>3];p=f;h[k>>3]=+h[n+2840>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+16>>3];q=+h[p>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];fA(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+1384>>3]=+h[l>>3];i=b;return}function B1(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2216>>3]=+h[b+152>>3]*+h[b+10472>>3];i=i;return}function C1(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2824>>3]=+h[b+2784>>3]*+h[b+1520>>3];i=i;return}function D1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+2848>>3]),1.0e-13);k=+h[g+32>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1608|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1608|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,67376,67368,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1608|0;p=o;h[p>>3]=m;i=d;return}function E1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+40>>3];k=+h[g+32>>3];l=+h[g+1560>>3]*(k+ +h[g+2848>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+1600|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+1600|0;r=q;h[r>>3]=o;i=d;return}s=k/+nwa(c[b+536>>2]|0,l,67424,67416,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+1600|0;r=q;h[r>>3]=o;i=d;return}function F1(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+32>>3];p=f;h[k>>3]=+h[n+2848>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+40>>3];q=+h[p+24>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];fA(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+1376>>3]=+h[l>>3];i=b;return}function G1(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2736>>3]=+h[b+32>>3]*+h[b+2776>>3];i=i;return}function H1(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2816>>3]=+h[b+2776>>3]*+h[b+1632>>3];i=i;return}function I1(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2808>>3]=+h[b+2768>>3]*+h[b+1744>>3];i=i;return}function J1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1784>>3];k=+zd(1.0e-13,+(+h[g+88>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+nwa(c[b+536>>2]|0,k,67536,67528,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+1792>>3]=m*.6219647130774989;i=d;return}function K1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+88>>3];k=+h[g+80>>3];l=+h[g+1784>>3]*(k+ +h[g+2864>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+1824|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+1824|0;r=q;h[r>>3]=o;i=d;return}s=k/+nwa(c[b+536>>2]|0,l,67608,67600,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+1824|0;r=q;h[r>>3]=o;i=d;return}function L1(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+128>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2240>>3]=+h[(a?e+2296|0:e+2288|0)>>3];i=b;return}function M1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1896>>3];k=+zd(1.0e-13,+(+h[g+112>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+nwa(c[b+536>>2]|0,k,67720,67712,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+1904>>3]=m*.6219647130774989;i=d;return}function N1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+2872>>3]),1.0e-13);k=+h[g+104>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1944|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1944|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,67792,67784,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1944|0;p=o;h[p>>3]=m;i=d;return}function O1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+112>>3];k=+h[g+104>>3];l=+h[g+1896>>3]*(k+ +h[g+2872>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+1936|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+1936|0;r=q;h[r>>3]=o;i=d;return}s=k/+nwa(c[b+536>>2]|0,l,67840,67832,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+1936|0;r=q;h[r>>3]=o;i=d;return}function P1(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+104>>3];p=f;h[k>>3]=+h[n+2872>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+112>>3];q=+h[p+96>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];fA(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+1352>>3]=+h[l>>3];i=b;return}function Q1(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2792>>3]=+h[b+2752>>3]*+h[b+1968>>3];i=i;return}function R1(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2712>>3]=+h[b+104>>3]*+h[b+2752>>3];i=i;return}function S1(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+120>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2232>>3]=+h[(a?e+2288|0:e+2280|0)>>3];i=b;return}function T1(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2184>>3]=+h[b+120>>3]*+h[b+10440>>3];i=i;return}function U1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+4408>>3]),1.0e-13);k=+h[g+176>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+3048|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+3048|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,67952,67944,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+3048|0;p=o;h[p>>3]=m;i=d;return}function V1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+184>>3];k=+h[g+176>>3];l=+h[g+3e3>>3]*(k+ +h[g+4408>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+3040|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+3040|0;r=q;h[r>>3]=o;i=d;return}s=k/+nwa(c[b+536>>2]|0,l,68e3,67992,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+3040|0;r=q;h[r>>3]=o;i=d;return}function W1(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+176>>3];p=f;h[k>>3]=+h[n+4408>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+184>>3];q=+h[p+168>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];fA(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2936>>3]=+h[l>>3];i=b;return}function X1(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4360>>3]=+h[b+4320>>3]*+h[b+3296>>3];i=i;return}function Y1(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+248>>3];p=f;h[k>>3]=+h[n+4432>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+256>>3];q=+h[p+240>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];fA(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2912>>3]=+h[l>>3];i=b;return}function Z1(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4352>>3]=+h[b+4312>>3]*+h[b+3408>>3];i=i;return}function _1(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4264>>3]=+h[b+272>>3]*+h[b+4304>>3];i=i;return}function $1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3448>>3];k=+zd(1.0e-13,+(+h[g+280>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+nwa(c[b+536>>2]|0,k,68112,68104,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+3456>>3]=m*.6219647130774989;i=d;return}function a2(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+280>>3];k=+h[g+272>>3];l=+h[g+3448>>3]*(k+ +h[g+4440>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+3488|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+3488|0;r=q;h[r>>3]=o;i=d;return}s=k/+nwa(c[b+536>>2]|0,l,68184,68176,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+3488|0;r=q;h[r>>3]=o;i=d;return}function b2(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3744>>3]=+h[b+296>>3]*+h[b+10312>>3];i=i;return}function c2(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+288>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3888>>3]=+h[(a?e+3944|0:e+3936|0)>>3];i=b;return}function d2(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+640>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7320>>3]=+h[(a?e+9608|0:e+9600|0)>>3];i=b;return}function e2(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Cza(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+648>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7328>>3]=+h[(a?e+9616|0:e+9608|0)>>3];i=b;return}function f2(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+496>>3];p=f;h[k>>3]=+h[n+7752>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+504>>3];q=+h[p+488>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];fA(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+6392>>3]=+h[l>>3];i=b;return}function g2(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0.0;d=i;i=i+120|0;e=d;f=d+96|0;g=d+112|0;j=i;i=i+16|0;k=i;i=i+96|0;l=i;i=i+8|0;m=b+4|0;n=c[c[m>>2]>>2]|0;o=c[n+8>>2]|0;p=+zd(+(+h[o+648>>3]),1.0e-15);q=+zd(+-+h[o+288>>3],1.0e-15);r=p+q;s=p*+h[o+496>>3]+q*+h[o+272>>3];do{if(r!=0.0){t=s/r}else{if(s==0.0){t=s;break}t=s/+nwa(c[b+536>>2]|0,r,63864,68288,+h[n>>3],(a[b+319|0]|0)!=0|0)}}while(0);gxa(j,1,t,g);c[k>>2]=61192;h[k+8>>3]=.01801528;h[k+16>>3]=-13423382.81725291;h[k+24>>3]=549760.6476280135;h[k+32>>3]=1.0e3;g=k+40|0;n=61200;c[g+0>>2]=c[n+0>>2];c[g+4>>2]=c[n+4>>2];c[g+8>>2]=c[n+8>>2];n=k+52|0;g=61216;c[n+0>>2]=c[g+0>>2];c[n+4>>2]=c[g+4>>2];c[n+8>>2]=c[g+8>>2];g=k+64|0;n=61232;c[g+0>>2]=c[n+0>>2];c[g+4>>2]=c[n+4>>2];c[g+8>>2]=c[n+8>>2];n=k+76|0;g=61248;c[n+0>>2]=c[g+0>>2];c[n+4>>2]=c[g+4>>2];c[n+8>>2]=c[g+8>>2];h[k+88>>3]=461.5233290850878;g=c[b+536>>2]|0;n=c[c[m>>2]>>2]|0;o=c[n+8>>2]|0;t=+zd(+(+h[o+648>>3]),1.0e-15);r=+zd(+-+h[o+288>>3],1.0e-15);s=t+r;q=t*+h[o+6544>>3]+r*+h[o+3536>>3];do{if(s!=0.0){u=o;v=q/s}else{if(q==0.0){u=o;v=q;break}r=q/+nwa(g,s,63864,68288,+h[n>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[m>>2]>>2]|0)+8>>2]|0;v=r}}while(0);s=+h[u+448>>3];u=f;b=j;c[u+0>>2]=c[b+0>>2];c[u+4>>2]=c[b+4>>2];c[u+8>>2]=c[b+8>>2];b=e+0|0;u=k+0|0;k=b+96|0;do{c[b>>2]=c[u>>2];b=b+4|0;u=u+4|0}while((b|0)<(k|0));nA(l,g,v,190.0,647.0,s,f,e,1.0e-13);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+10776>>3]=+h[l>>3];i=d;return}function h2(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+(+h[g+7760>>3]),1.0e-13);k=+h[g+520>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+6616|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+6616|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,68304,68296,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6616|0;p=o;h[p>>3]=m;i=d;return}function i2(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+528>>3];k=+h[g+520>>3];l=+h[g+6568>>3]*(k+ +h[g+7760>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+6608|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+6608|0;r=q;h[r>>3]=o;i=d;return}s=k/+nwa(c[b+536>>2]|0,l,68352,68344,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+6608|0;r=q;h[r>>3]=o;i=d;return}function j2(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+520>>3];p=f;h[k>>3]=+h[n+7760>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+528>>3];q=+h[p+512>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];fA(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+6384>>3]=+h[l>>3];i=b;return}function k2(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7712>>3]=+h[b+7672>>3]*+h[b+6640>>3];i=i;return}function l2(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7632>>3]=+h[b+520>>3]*+h[b+7672>>3];i=i;return}function m2(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7224>>3]=+h[b+640>>3]*+h[b+10040>>3];i=i;return}function n2(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7640>>3]=+h[b+496>>3]*+h[b+7680>>3];i=i;return}function o2(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7720>>3]=+h[b+7680>>3]*+h[b+6528>>3];i=i;return}function p2(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6176>>3]=+h[b+416>>3]*+h[b+6216>>3];i=i;return}function q2(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6256>>3]=+h[b+6216>>3]*+h[b+5416>>3];i=i;return}function r2(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5344>>3];k=+zd(1.0e-13,+(+h[g+424>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+nwa(c[b+536>>2]|0,k,68464,68456,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+5352>>3]=m*.6219647130774989;i=d;return}function s2(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+424>>3];k=+h[g+416>>3];l=+h[g+5344>>3]*(k+ +h[g+6312>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+5384|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+5384|0;r=q;h[r>>3]=o;i=d;return}s=k/+nwa(c[b+536>>2]|0,l,68536,68528,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+5384|0;r=q;h[r>>3]=o;i=d;return}function t2(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5680>>3]=+h[b+456>>3]*+h[b+10200>>3];i=i;return}function u2(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6248>>3]=+h[b+6208>>3]*+h[b+5528>>3];i=i;return}function v2(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5456>>3];k=+zd(1.0e-13,+(+h[g+448>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+nwa(c[b+536>>2]|0,k,68648,68640,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+5464>>3]=m*.6219647130774989;i=d;return}function w2(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+448>>3];k=+h[g+440>>3];l=+h[g+5456>>3]*(k+ +h[g+6320>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+5496|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+5496|0;r=q;h[r>>3]=o;i=d;return}s=k/+nwa(c[b+536>>2]|0,l,68720,68712,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+5496|0;r=q;h[r>>3]=o;i=d;return}function x2(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3736>>3]=+h[b+288>>3]*+h[b+10304>>3];i=i;return}function y2(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7232>>3]=+h[b+648>>3]*+h[b+10048>>3];i=i;return}function z2(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4344>>3]=+h[b+4304>>3]*+h[b+3520>>3];i=i;return}function _Modelica_Fluid_Examples_BranchingDynamicPipes_eqFunction_1187$0(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,k=0;b=c[a+8>>2]|0;d=c[a+424>>2]|0;e=c[a+432>>2]|0;a:do{f=(c[(c[e+4>>2]|0)+8>>2]|0)+24|0;h[(c[d+48>>2]|0)+360>>3]=+h[f>>3];g=+aAa(b,+h[f>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+24>>3]);f=c[(b+468|0)>>2]|0;h[(c[f+52>>2]|0)+360>>3]=g;j=c[(b+4|0)>>2]|0;h[(c[f+44>>2]|0)+368>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+72>>3];k=(c[(c[j+4>>2]|0)+8>>2]|0)+72|0;h[(c[f+48>>2]|0)+368>>3]=+h[k>>3];g=+aAa(b,+h[k>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+72>>3]);j=c[(b+468|0)>>2]|0;h[(c[j+52>>2]|0)+368>>3]=g;k=c[(b+4|0)>>2]|0;h[(c[j+44>>2]|0)+376>>3]=+h[(c[(c[k>>2]|0)+8>>2]|0)+88>>3];f=(c[(c[k+4>>2]|0)+8>>2]|0)+88|0;h[(c[j+48>>2]|0)+376>>3]=+h[f>>3];g=+aAa(b,+h[f>>3],+h[(c[(c[k+8>>2]|0)+8>>2]|0)+88>>3]);k=c[(b+468|0)>>2]|0;h[(c[k+52>>2]|0)+376>>3]=g;f=c[(b+4|0)>>2]|0;h[(c[k+44>>2]|0)+384>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+112>>3];j=(c[(c[f+4>>2]|0)+8>>2]|0)+112|0;h[(c[k+48>>2]|0)+384>>3]=+h[j>>3];g=+aAa(b,+h[j>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+112>>3]);f=c[(b+468|0)>>2]|0;h[(c[f+52>>2]|0)+384>>3]=g;j=c[(b+4|0)>>2]|0;h[(c[f+44>>2]|0)+392>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+96>>3];k=(c[(c[j+4>>2]|0)+8>>2]|0)+96|0;h[(c[f+48>>2]|0)+392>>3]=+h[k>>3];g=+aAa(b,+h[k>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+96>>3]);j=c[(b+468|0)>>2]|0;h[(c[j+52>>2]|0)+392>>3]=g;k=c[(b+4|0)>>2]|0;h[(c[j+44>>2]|0)+400>>3]=+h[(c[(c[k>>2]|0)+8>>2]|0)+184>>3];f=(c[(c[k+4>>2]|0)+8>>2]|0)+184|0;h[(c[j+48>>2]|0)+400>>3]=+h[f>>3];g=+aAa(b,+h[f>>3],+h[(c[(c[k+8>>2]|0)+8>>2]|0)+184>>3]);k=c[(b+468|0)>>2]|0;h[(c[k+52>>2]|0)+400>>3]=g;f=c[(b+4|0)>>2]|0;h[(c[k+44>>2]|0)+408>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+168>>3];j=(c[(c[f+4>>2]|0)+8>>2]|0)+168|0;h[(c[k+48>>2]|0)+408>>3]=+h[j>>3];g=+aAa(b,+h[j>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+168>>3]);f=c[(b+468|0)>>2]|0;h[(c[f+52>>2]|0)+408>>3]=g;j=c[(b+4|0)>>2]|0;h[(c[f+44>>2]|0)+416>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+192>>3];k=(c[(c[j+4>>2]|0)+8>>2]|0)+192|0;h[(c[f+48>>2]|0)+416>>3]=+h[k>>3];g=+aAa(b,+h[k>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+192>>3]);j=c[(b+468|0)>>2]|0;h[(c[j+52>>2]|0)+416>>3]=g;k=c[(b+4|0)>>2]|0;h[(c[j+44>>2]|0)+424>>3]=+h[(c[(c[k>>2]|0)+8>>2]|0)+232>>3];f=(c[(c[k+4>>2]|0)+8>>2]|0)+232|0;h[(c[j+48>>2]|0)+424>>3]=+h[f>>3];g=+aAa(b,+h[f>>3],+h[(c[(c[k+8>>2]|0)+8>>2]|0)+232>>3]);k=c[(b+468|0)>>2]|0;h[(c[k+52>>2]|0)+424>>3]=g;f=c[(b+4|0)>>2]|0;h[(c[k+44>>2]|0)+432>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+216>>3];j=(c[(c[f+4>>2]|0)+8>>2]|0)+216|0;h[(c[k+48>>2]|0)+432>>3]=+h[j>>3];g=+aAa(b,+h[j>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+216>>3]);f=c[(b+468|0)>>2]|0;h[(c[f+52>>2]|0)+432>>3]=g;j=c[(b+4|0)>>2]|0;h[(c[f+44>>2]|0)+440>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+240>>3];k=(c[(c[j+4>>2]|0)+8>>2]|0)+240|0;h[(c[f+48>>2]|0)+440>>3]=+h[k>>3];g=+aAa(b,+h[k>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+240>>3]);j=c[(b+468|0)>>2]|0;h[(c[j+52>>2]|0)+440>>3]=g;k=c[(b+4|0)>>2]|0;h[(c[j+44>>2]|0)+448>>3]=+h[(c[(c[k>>2]|0)+8>>2]|0)+256>>3];f=(c[(c[k+4>>2]|0)+8>>2]|0)+256|0;h[(c[j+48>>2]|0)+448>>3]=+h[f>>3];g=+aAa(b,+h[f>>3],+h[(c[(c[k+8>>2]|0)+8>>2]|0)+256>>3]);k=c[(b+468|0)>>2]|0;h[(c[k+52>>2]|0)+448>>3]=g;f=c[(b+4|0)>>2]|0;h[(c[k+44>>2]|0)+456>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+280>>3];j=(c[(c[f+4>>2]|0)+8>>2]|0)+280|0;h[(c[k+48>>2]|0)+456>>3]=+h[j>>3];g=+aAa(b,+h[j>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+280>>3]);f=c[(b+468|0)>>2]|0;h[(c[f+52>>2]|0)+456>>3]=g;j=c[(b+4|0)>>2]|0;h[(c[f+44>>2]|0)+464>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+264>>3];k=(c[(c[j+4>>2]|0)+8>>2]|0)+264|0;h[(c[f+48>>2]|0)+464>>3]=+h[k>>3];g=+aAa(b,+h[k>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+264>>3]);j=c[(b+468|0)>>2]|0;h[(c[j+52>>2]|0)+464>>3]=g;k=c[(b+4|0)>>2]|0;h[(c[j+44>>2]|0)+472>>3]=+h[(c[(c[k>>2]|0)+8>>2]|0)+488>>3];f=(c[(c[k+4>>2]|0)+8>>2]|0)+488|0;h[(c[j+48>>2]|0)+472>>3]=+h[f>>3];g=+aAa(b,+h[f>>3],+h[(c[(c[k+8>>2]|0)+8>>2]|0)+488>>3]);k=c[(b+468|0)>>2]|0;h[(c[k+52>>2]|0)+472>>3]=g;f=c[(b+4|0)>>2]|0;h[(c[k+44>>2]|0)+480>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+528>>3];j=(c[(c[f+4>>2]|0)+8>>2]|0)+528|0;h[(c[k+48>>2]|0)+480>>3]=+h[j>>3];g=+aAa(b,+h[j>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+528>>3]);f=c[(b+468|0)>>2]|0;h[(c[f+52>>2]|0)+480>>3]=g;j=c[(b+4|0)>>2]|0;h[(c[f+44>>2]|0)+488>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+512>>3];k=(c[(c[j+4>>2]|0)+8>>2]|0)+512|0;h[(c[f+48>>2]|0)+488>>3]=+h[k>>3];g=+aAa(b,+h[k>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+512>>3]);j=c[(b+468|0)>>2]|0;h[(c[j+52>>2]|0)+488>>3]=g;k=c[(b+4|0)>>2]|0;h[(c[j+44>>2]|0)+496>>3]=+h[(c[(c[k>>2]|0)+8>>2]|0)+504>>3];f=(c[(c[k+4>>2]|0)+8>>2]|0)+504|0;h[(c[j+48>>2]|0)+496>>3]=+h[f>>3];g=+aAa(b,+h[f>>3],+h[(c[(c[k+8>>2]|0)+8>>2]|0)+504>>3]);k=c[(b+468|0)>>2]|0;h[(c[k+52>>2]|0)+496>>3]=g;f=c[(b+4|0)>>2]|0;h[(c[k+44>>2]|0)+504>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+448>>3];j=(c[(c[f+4>>2]|0)+8>>2]|0)+448|0;h[(c[k+48>>2]|0)+504>>3]=+h[j>>3];g=+aAa(b,+h[j>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+448>>3]);f=c[(b+468|0)>>2]|0;h[(c[f+52>>2]|0)+504>>3]=g;j=c[(b+4|0)>>2]|0;h[(c[f+44>>2]|0)+512>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+408>>3];k=(c[(c[j+4>>2]|0)+8>>2]|0)+408|0;h[(c[f+48>>2]|0)+512>>3]=+h[k>>3];g=+aAa(b,+h[k>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+408>>3]);j=c[(b+468|0)>>2]|0;h[(c[j+52>>2]|0)+512>>3]=g;k=c[(b+4|0)>>2]|0;h[(c[j+44>>2]|0)+520>>3]=+h[(c[(c[k>>2]|0)+8>>2]|0)+424>>3];f=(c[(c[k+4>>2]|0)+8>>2]|0)+424|0;h[(c[j+48>>2]|0)+520>>3]=+h[f>>3];g=+aAa(b,+h[f>>3],+h[(c[(c[k+8>>2]|0)+8>>2]|0)+424>>3]);k=c[(b+468|0)>>2]|0;h[(c[k+52>>2]|0)+520>>3]=g;f=c[(b+4|0)>>2]|0;h[(c[k+44>>2]|0)+528>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+432>>3];j=(c[(c[f+4>>2]|0)+8>>2]|0)+432|0;h[(c[k+48>>2]|0)+528>>3]=+h[j>>3];g=+aAa(b,+h[j>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+432>>3]);h[(c[(c[(b+468|0)>>2]|0)+52>>2]|0)+528>>3]=g;_za(b,0)|0;f=c[(c[(b+468|0)>>2]|0)+44>>2]|0;j=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;h[j+328>>3]=+h[f>>3];h[j+520>>3]=+h[f+8>>3];h[j+200>>3]=+h[f+16>>3];h[j+56>>3]=+h[f+24>>3];h[j+32>>3]=+h[f+32>>3];h[j+8>>3]=+h[f+40>>3];h[j+80>>3]=+h[f+48>>3];h[j+224>>3]=+h[f+56>>3];h[j+248>>3]=+h[f+64>>3];h[j+568>>3]=+h[f+72>>3];h[j+544>>3]=+h[f+80>>3];h[j+592>>3]=+h[f+88>>3];h[j+5960>>3]=+h[f+96>>3];h[j+272>>3]=+h[f+104>>3];h[j+496>>3]=+h[f+112>>3];h[j+176>>3]=+h[f+120>>3];h[j+104>>3]=+h[f+128>>3];h[j+416>>3]=+h[f+136>>3];h[j+368>>3]=+h[f+144>>3];h[j+392>>3]=+h[f+152>>3];h[j+440>>3]=+h[f+160>>3];h[j+344>>3]=+h[f+168>>3];h[j+560>>3]=+h[f+176>>3];h[j+576>>3]=+h[f+184>>3];f=c[(c[(b+468|0)>>2]|0)+44>>2]|0;j=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;h[j+536>>3]=+h[f+192>>3];h[j+552>>3]=+h[f+200>>3];h[j+584>>3]=+h[f+208>>3];h[j+600>>3]=+h[f+216>>3];h[j+4544>>3]=+h[f+224>>3];h[j+4512>>3]=+h[f+232>>3];h[j+4520>>3]=+h[f+240>>3];h[j+400>>3]=+h[f+248>>3];h[j+4536>>3]=+h[f+256>>3];h[j+360>>3]=+h[f+264>>3];h[j+376>>3]=+h[f+272>>3];h[j+4528>>3]=+h[f+280>>3];h[j+384>>3]=+h[f+288>>3];h[j+336>>3]=+h[f+296>>3];h[j+352>>3]=+h[f+304>>3];h[j+208>>3]=+h[f+312>>3];h[j+64>>3]=+h[f+320>>3];h[j+48>>3]=+h[f+328>>3];h[j+40>>3]=+h[f+336>>3];h[j>>3]=+h[f+344>>3];h[j+16>>3]=+h[f+352>>3];h[j+24>>3]=+h[f+360>>3];h[j+72>>3]=+h[f+368>>3];h[j+88>>3]=+h[f+376>>3];f=c[(c[(b+468|0)>>2]|0)+44>>2]|0;j=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;h[j+112>>3]=+h[f+384>>3];h[j+96>>3]=+h[f+392>>3];h[j+184>>3]=+h[f+400>>3];h[j+168>>3]=+h[f+408>>3];h[j+192>>3]=+h[f+416>>3];h[j+232>>3]=+h[f+424>>3];h[j+216>>3]=+h[f+432>>3];h[j+240>>3]=+h[f+440>>3];h[j+256>>3]=+h[f+448>>3];h[j+280>>3]=+h[f+456>>3];h[j+264>>3]=+h[f+464>>3];h[j+488>>3]=+h[f+472>>3];h[j+528>>3]=+h[f+480>>3];h[j+512>>3]=+h[f+488>>3];h[j+504>>3]=+h[f+496>>3];h[j+448>>3]=+h[f+504>>3];h[j+408>>3]=+h[f+512>>3];h[j+424>>3]=+h[f+520>>3];h[j+432>>3]=+h[f+528>>3];QA(b);RA(b);SA(b);TA(b);UA(b);VA(b);WA(b);XA(b);YA(b);ZA(b);_A(b);$A(b);aB(b);bB(b);cB(b);dB(b);eB(b);fB(b);gB(b);hB(b);iB(b);jB(b);kB(b);lB(b);mB(b);nB(b);oB(b);pB(b);qB(b);rB(b);sB(b);tB(b);uB(b);vB(b);wB(b);xB(b);yB(b);zB(b);AB(b);BB(b);CB(b);DB(b);EB(b);FB(b);GB(b);HB(b);IB(b);JB(b);KB(b);LB(b);MB(b);NB(b);OB(b);PB(b);QB(b);RB(b);SB(b);TB(b);UB(b);VB(b);WB(b);XB(b);YB(b);ZB(b);_B(b);$B(b);aC(b);bC(b);cC(b);dC(b);eC(b);fC(b);gC(b);hC(b);iC(b);jC(b);kC(b);lC(b);mC(b);nC(b);oC(b);pC(b);qC(b);rC(b);sC(b);tC(b);uC(b);vC(b);wC(b);xC(b);yC(b);zC(b);AC(b);BC(b);CC(b);DC(b);EC(b);FC(b);GC(b);HC(b);IC(b);JC(b);KC(b);LC(b);MC(b);NC(b);OC(b);PC(b);QC(b);RC(b);SC(b);TC(b);UC(b);VC(b);WC(b);XC(b);YC(b);ZC(b);_C(b);$C(b);aD(b);bD(b);cD(b);dD(b);eD(b);fD(b);gD(b);hD(b);iD(b);jD(b);kD(b);lD(b);mD(b);nD(b);oD(b);pD(b);qD(b);rD(b);sD(b);tD(b);uD(b);vD(b);wD(b);xD(b);yD(b);zD(b);AD(b);BD(b);CD(b);DD(b);ED(b);FD(b);GD(b);HD(b);ID(b);JD(b);KD(b);LD(b);MD(b);ND(b);OD(b);PD(b);QD(b);RD(b);SD(b);TD(b);UD(b);VD(b);WD(b);XD(b);YD(b);ZD(b);_D(b);$D(b);aE(b);bE(b);cE(b);dE(b);eE(b);fE(b);gE(b);hE(b);iE(b);jE(b);kE(b);lE(b);mE(b);nE(b);oE(b);pE(b);qE(b);rE(b);sE(b);tE(b);uE(b);vE(b);wE(b);xE(b);yE(b);zE(b);AE(b);BE(b);CE(b);DE(b);EE(b);FE(b);GE(b);HE(b);IE(b);JE(b);KE(b);LE(b);ME(b);NE(b);OE(b);PE(b);QE(b);RE(b);SE(b);TE(b);UE(b);VE(b);WE(b);XE(b);YE(b);ZE(b);_E(b);$E(b);aF(b);bF(b);cF(b);dF(b);eF(b);fF(b);gF(b);hF(b);iF(b);jF(b);kF(b);lF(b);mF(b);nF(b);oF(b);pF(b);qF(b);rF(b);sF(b);tF(b);uF(b);vF(b);wF(b);xF(b);yF(b);zF(b);AF(b);BF(b);CF(b);DF(b);EF(b);FF(b);GF(b);HF(b);IF(b);JF(b);KF(b);LF(b);MF(b);NF(b);OF(b);PF(b);QF(b);RF(b);SF(b);TF(b);UF(b);VF(b);WF(b);XF(b);YF(b);ZF(b);_F(b);$F(b);aG(b);bG(b);cG(b);dG(b);eG(b);fG(b);gG(b);hG(b);iG(b);jG(b);kG(b);lG(b);mG(b);nG(b);oG(b);pG(b);qG(b);rG(b);sG(b);tG(b);uG(b);vG(b);wG(b);xG(b);yG(b);zG(b);AG(b);BG(b);CG(b);DG(b);EG(b);FG(b);GG(b);HG(b);IG(b);JG(b);KG(b);LG(b);MG(b);NG(b);OG(b);PG(b);QG(b);RG(b);SG(b);TG(b);UG(b);VG(b);WG(b);XG(b);YG(b);ZG(b);_G(b);$G(b);aH(b);bH(b);cH(b);dH(b);eH(b);fH(b);gH(b);hH(b);iH(b);jH(b);kH(b);lH(b);mH(b);nH(b);oH(b);pH(b);qH(b);rH(b);sH(b);tH(b);uH(b);vH(b);wH(b);xH(b);yH(b);zH(b);AH(b);BH(b);CH(b);DH(b);EH(b);FH(b);GH(b);HH(b);IH(b);JH(b);KH(b);LH(b);MH(b);NH(b);OH(b);PH(b);QH(b);RH(b);SH(b);TH(b);UH(b);VH(b);WH(b);XH(b);YH(b);ZH(b);_H(b);$H(b);aI(b);bI(b);cI(b);dI(b);eI(b);fI(b);gI(b);hI(b);iI(b);jI(b);kI(b);lI(b);mI(b);nI(b);oI(b);pI(b);qI(b);rI(b);sI(b);tI(b);uI(b);vI(b);wI(b);xI(b);yI(b);zI(b);AI(b);BI(b);CI(b);DI(b);EI(b);FI(b);GI(b);HI(b);II(b);JI(b);KI(b);LI(b);MI(b);NI(b);OI(b);PI(b);QI(b);RI(b);SI(b);TI(b);UI(b);VI(b);WI(b);XI(b);YI(b);ZI(b);_I(b);$I(b);aJ(b);bJ(b);cJ(b);dJ(b);eJ(b);fJ(b);gJ(b);hJ(b);iJ(b);jJ(b);kJ(b);lJ(b);mJ(b);nJ(b);oJ(b);pJ(b);qJ(b);rJ(b);sJ(b);tJ(b);uJ(b);vJ(b);wJ(b);xJ(b);yJ(b);zJ(b);AJ(b);BJ(b);CJ(b);DJ(b);EJ(b);FJ(b);GJ(b);HJ(b);IJ(b);JJ(b);KJ(b);LJ(b);MJ(b);NJ(b);OJ(b);PJ(b);QJ(b);RJ(b);SJ(b);TJ(b);UJ(b);VJ(b);WJ(b);XJ(b);YJ(b);ZJ(b);_J(b);$J(b);aK(b);bK(b);cK(b);dK(b);eK(b);fK(b);gK(b);hK(b);iK(b);jK(b);kK(b);lK(b);mK(b);nK(b);oK(b);pK(b);qK(b);rK(b);sK(b);tK(b);uK(b);vK(b);wK(b);xK(b);yK(b);zK(b);AK(b);BK(b);CK(b);DK(b);EK(b);FK(b);GK(b);HK(b);IK(b);JK(b);KK(b);LK(b);MK(b);NK(b);OK(b);PK(b);QK(b);RK(b);SK(b);TK(b);UK(b);VK(b);WK(b);XK(b);YK(b);ZK(b);_K(b);$K(b);aL(b);bL(b);cL(b);dL(b);eL(b);fL(b);gL(b);hL(b);iL(b);jL(b);kL(b);lL(b);mL(b);nL(b);oL(b);pL(b);qL(b);rL(b);sL(b);tL(b);uL(b);vL(b);wL(b);xL(b);yL(b);zL(b);AL(b);BL(b);CL(b);DL(b);EL(b);FL(b);GL(b);HL(b);IL(b);JL(b);KL(b);LL(b);ML(b);NL(b);OL(b);PL(b);QL(b);RL(b);SL(b);TL(b);UL(b);VL(b);WL(b);XL(b);YL(b);ZL(b);_L(b);$L(b);aM(b);bM(b);cM(b);dM(b);eM(b);fM(b);gM(b);hM(b);iM(b);jM(b);kM(b);lM(b);mM(b);nM(b);oM(b);pM(b);qM(b);rM(b);sM(b);tM(b);uM(b);vM(b);wM(b);xM(b);yM(b);zM(b);AM(b);BM(b);CM(b);DM(b);EM(b);FM(b);GM(b);HM(b);IM(b);JM(b);KM(b);LM(b);MM(b);NM(b);OM(b);PM(b);QM(b);RM(b);SM(b);TM(b);UM(b);VM(b);WM(b);XM(b);YM(b);ZM(b);_M(b);$M(b);aN(b);bN(b);cN(b);dN(b);eN(b);fN(b);gN(b);hN(b);iN(b);jN(b);kN(b);lN(b);mN(b);nN(b);oN(b);pN(b);qN(b);rN(b);sN(b);tN(b);uN(b);vN(b);wN(b);xN(b);yN(b);zN(b);AN(b);BN(b);CN(b);DN(b);EN(b);FN(b);GN(b);HN(b);IN(b);JN(b);KN(b);LN(b);MN(b);NN(b);ON(b);PN(b);QN(b);RN(b);SN(b);TN(b);UN(b);VN(b);WN(b);XN(b);YN(b);ZN(b);_N(b);$N(b);aO(b);bO(b);cO(b);dO(b);eO(b);fO(b);gO(b);hO(b);iO(b);jO(b);kO(b);lO(b);mO(b);nO(b);oO(b);pO(b);qO(b);rO(b);sO(b);tO(b);uO(b);vO(b);wO(b);xO(b);yO(b);zO(b);AO(b);BO(b);CO(b);DO(b);EO(b);FO(b);GO(b);HO(b);IO(b);JO(b);KO(b);LO(b);MO(b);NO(b);OO(b);PO(b);QO(b);RO(b);SO(b);TO(b);UO(b);VO(b);WO(b);XO(b);YO(b);ZO(b);_O(b);$O(b);aP(b);i=a;c[a+2216>>2]=5;break a}while(0)}



function _Q(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[63880]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=57624;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&127](mb,m,31336,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]}jA(t,c[ib>>2]|0,jb);jb=+h[t>>3];kA(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);jb=+h[v>>3];jA(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);pb=+h[w>>3];kA(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+344>>3];qb=+zd(1.0e-13,+(+h[w+352>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+nwa(c[ib>>2]|0,qb,31408,57392,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(pb- +yd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{jA(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);sb=+h[z>>3];kA(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);sb=+h[B>>3];jA(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);jb=+h[C>>3];kA(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+zd(1.0e-13,+(+h[C+352>>3]- +h[E>>3]));pb=1.0- +h[C+344>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+nwa(c[ib>>2]|0,jb,31408,57392,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{jA(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);vb=+h[F>>3];kA(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);vb=+h[H>>3];jA(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);sb=+h[I>>3];kA(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);sb=+h[K>>3];jA(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);jb=+h[L>>3];kA(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+352>>3]- +h[N>>3])|0)<<24>>24==0){jA(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);jb=+h[O>>3];kA(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Q,c[ib>>2]|0,+h[P+336>>3],+h[P+992>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(R,c[ib>>2]|0,+h[Q+336>>3],+h[Q+992>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(S,c[ib>>2]|0,jb,pb,+h[Q+336>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+992>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+1008>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}jA(T,c[ib>>2]|0,+h[xb+336>>3]);qb=+h[T>>3];kA(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);qb=+h[V>>3];jA(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);pb=+h[W>>3];kA(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);pb=+h[Y>>3];jA(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);jb=+h[Z>>3];kA(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA($,c[ib>>2]|0,+h[_+336>>3],+h[_+992>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(aa,c[ib>>2]|0,+h[$+336>>3],+h[$+992>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(ba,c[ib>>2]|0,jb,rb,+h[$+336>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+992>>3],0.0);zb=+h[ba>>3];jA(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);rb=+h[ca>>3];kA(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+352>>3];Ab=+zd(1.0e-13,+(jb-qb));qb=Ab*+zd(1.0e-13,+(jb-pb));pb=+h[ea+1e3>>3];Ab=-(pb*+zd(1.0e-13,+(jb-sb)));sb=+h[ea+344>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+nwa(c[ib>>2]|0,qb,31712,57392,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+344>>3];Cb=+h[ca+352>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+zd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+nwa(c[ib>>2]|0,Eb,31408,57392,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+1e3>>3]-wb}wb=+h[tb+336>>3];if(wb>0.0){Gb=wb}else{tb=c[63880]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=57624;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&127](Db,l,31336,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]}if(Gb>0.0){Hb=Gb}else{r=c[63880]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=57624;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&127](l,j,31336,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]}jA(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];kA(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);Hb=+h[ia>>3];jA(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);Fb=+h[ja>>3];kA(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3];if(zb>0.0){Ib=zb}else{la=c[63880]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=57624;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&127](ka,g,31336,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]}if(Ib>0.0){Jb=Ib}else{p=c[63880]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=57624;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&127](g,f,31336,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]}if(Jb>0.0){Kb=Jb}else{o=c[63880]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=57624;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&127](f,e,31336,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]}qb=Kb+-273.15;lA(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];jA(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);qb=+h[na>>3];kA(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);qb=+h[pa>>3];jA(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);Eb=+h[qa>>3];kA(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+344>>3];rb=+zd(1.0e-13,+(+h[qa+352>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+nwa(c[ib>>2]|0,rb,31408,57392,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(Eb- +yd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{jA(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);Lb=+h[ta>>3];kA(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);Lb=+h[va>>3];jA(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);qb=+h[wa>>3];kA(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+zd(1.0e-13,+(+h[wa+352>>3]- +h[ya>>3]));Eb=1.0- +h[wa+344>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+nwa(c[ib>>2]|0,qb,31408,57392,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{jA(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);Ob=+h[za>>3];kA(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);Ob=+h[Ba>>3];jA(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);Lb=+h[Ca>>3];kA(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);Lb=+h[Ea>>3];jA(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);qb=+h[Fa>>3];kA(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+352>>3]- +h[Ha>>3])|0)<<24>>24==0){jA(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);qb=+h[Ia>>3];kA(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Ka,c[ib>>2]|0,+h[Ja+336>>3],+h[Ja+992>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(La,c[ib>>2]|0,+h[Ka+336>>3],+h[Ka+992>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+336>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+992>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+1008>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}jA(Na,c[ib>>2]|0,+h[Qb+336>>3]);rb=+h[Na>>3];kA(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);rb=+h[Pa>>3];jA(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);Eb=+h[Qa>>3];kA(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);Eb=+h[Sa>>3];jA(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);qb=+h[Ta>>3];kA(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Va,c[ib>>2]|0,+h[Ua+336>>3],+h[Ua+992>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(Wa,c[ib>>2]|0,+h[Va+336>>3],+h[Va+992>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Xa,c[ib>>2]|0,qb,Bb,+h[Va+336>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+992>>3],0.0);Cb=+h[Xa>>3];jA(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);Bb=+h[Ya>>3];kA(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+352>>3];vb=+zd(1.0e-13,+(qb-rb));rb=vb*+zd(1.0e-13,+(qb-Eb));Eb=+h[Za+1e3>>3];vb=-(Eb*+zd(1.0e-13,+(qb-Lb)));Lb=+h[Za+344>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+nwa(c[ib>>2]|0,rb,31712,57392,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+344>>3];Tb=+h[Ya+352>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+zd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+nwa(c[ib>>2]|0,Vb,31408,57392,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+1e3>>3]-Pb}Pb=+h[Mb+336>>3];Wb=Pb+-273.15;Cb=+h[Mb+992>>3];sA($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];jA(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);Pb=+h[ab>>3];kA(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);Pb=+h[cb>>3];jA(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);Wb=+h[db>>3];kA(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+336>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+nwa(c[ib>>2]|0,rb,32320,57392,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+336>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+1e3>>3]-ub);ub=+h[Yb+992>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+nwa(c[ib>>2]|0,Xb,32320,57392,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+992>>3];ac=+h[Yb+336>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+Nxa(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+344>>3];Gb=+zd(1.0e-13,+(+h[Yb+352>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+nwa(c[ib>>2]|0,Gb,31408,57392,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +zd(+(ac- +yd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+336>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+nwa(c[ib>>2]|0,ec,32320,57392,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+336>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+1e3>>3];ic=+h[gc+992>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+nwa(c[ib>>2]|0,fc,32320,57392,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+992>>3];kc=+h[gc+336>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+Nxa(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+344>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+zd(1.0e-13,+(+h[gc+352>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9392|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9392|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+nwa(c[ib>>2]|0,Nb,31408,57392,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9392|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function $Q(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+13968>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+13944>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+13952>>3];h[a+8>>3]=+h[d+14192>>3];h[e+8>>3]=+h[d+14168>>3];h[f+8>>3]=+h[d+14176>>3];i=i;return}function aR(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0.0,l=0.0,m=0.0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+992>>3]=+h[b>>3];h[a+1008>>3]=+h[b+8>>3];VQ(f);WQ(f);XQ(f);YQ(f);ZQ(f);_Q(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;g=f+8904|0;b=f+336|0;a=f+5072|0;j=f+992|0;h[d>>3]=+h[f+8088>>3]+(+h[g>>3]*+h[b>>3]+(+h[a>>3]*+h[j>>3]- +h[f+9392>>3]));k=+h[a>>3];l=+h[b>>3];m=k*l;h[d+8>>3]=+h[f+9400>>3]*m*m+(+h[f+352>>3]*(k*+h[j>>3]+l*+h[g>>3])-m*+h[f+1008>>3]);i=e;return}function bR(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+63584>>3];h[c[b+8>>2]>>3]=+h[d+63560>>3];h[c[b+12>>2]>>3]=+h[d+63568>>3];i=i;return}function cR(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+4536>>3]=g;xz(f,c[a+536>>2]|0,g,+h[(c[a+416>>2]|0)+472>>3],+h[j+4736>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+4856>>3]- +h[f>>3];i=e;return}function dR(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+78032>>3];h[c[b+8>>2]>>3]=+h[d+78008>>3];h[c[b+12>>2]>>3]=+h[d+78016>>3];i=i;return}function eR(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+5568>>3]=g;k=a+416|0;l=c[k>>2]|0;Kz(f,c[a+536>>2]|0,g,+h[j+5832>>3],+h[j+5840>>3],+h[j+5760>>3],+h[j+5768>>3],+h[j+10216>>3],+h[j+9904>>3],+h[l+1824>>3]*5.0,(+h[l+504>>3]+ +h[l+512>>3])*.5,+h[l+1816>>3]*.25,+h[l+1784>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+472>>3]- +h[f>>3]*+h[(c[k>>2]|0)+1760>>3];i=e;return}function fR(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[63880]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=57624;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&127](mb,m,32352,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]}jA(t,c[ib>>2]|0,jb);jb=+h[t>>3];kA(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);jb=+h[v>>3];jA(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);pb=+h[w>>3];kA(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+368>>3];qb=+zd(1.0e-13,+(+h[w+376>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+nwa(c[ib>>2]|0,qb,32424,57400,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(pb- +yd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{jA(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);sb=+h[z>>3];kA(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);sb=+h[B>>3];jA(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);jb=+h[C>>3];kA(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+zd(1.0e-13,+(+h[C+376>>3]- +h[E>>3]));pb=1.0- +h[C+368>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+nwa(c[ib>>2]|0,jb,32424,57400,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{jA(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);vb=+h[F>>3];kA(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);vb=+h[H>>3];jA(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);sb=+h[I>>3];kA(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);sb=+h[K>>3];jA(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);jb=+h[L>>3];kA(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+376>>3]- +h[N>>3])|0)<<24>>24==0){jA(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);jb=+h[O>>3];kA(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Q,c[ib>>2]|0,+h[P+360>>3],+h[P+1016>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(R,c[ib>>2]|0,+h[Q+360>>3],+h[Q+1016>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(S,c[ib>>2]|0,jb,pb,+h[Q+360>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+1016>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+1032>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}jA(T,c[ib>>2]|0,+h[xb+360>>3]);qb=+h[T>>3];kA(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);qb=+h[V>>3];jA(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);pb=+h[W>>3];kA(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);pb=+h[Y>>3];jA(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);jb=+h[Z>>3];kA(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA($,c[ib>>2]|0,+h[_+360>>3],+h[_+1016>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(aa,c[ib>>2]|0,+h[$+360>>3],+h[$+1016>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(ba,c[ib>>2]|0,jb,rb,+h[$+360>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+1016>>3],0.0);zb=+h[ba>>3];jA(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);rb=+h[ca>>3];kA(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+376>>3];Ab=+zd(1.0e-13,+(jb-qb));qb=Ab*+zd(1.0e-13,+(jb-pb));pb=+h[ea+1024>>3];Ab=-(pb*+zd(1.0e-13,+(jb-sb)));sb=+h[ea+368>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+nwa(c[ib>>2]|0,qb,32728,57400,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+368>>3];Cb=+h[ca+376>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+zd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+nwa(c[ib>>2]|0,Eb,32424,57400,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+1024>>3]-wb}wb=+h[tb+360>>3];if(wb>0.0){Gb=wb}else{tb=c[63880]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=57624;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&127](Db,l,32352,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]}if(Gb>0.0){Hb=Gb}else{r=c[63880]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=57624;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&127](l,j,32352,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]}jA(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];kA(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);Hb=+h[ia>>3];jA(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);Fb=+h[ja>>3];kA(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3];if(zb>0.0){Ib=zb}else{la=c[63880]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=57624;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&127](ka,g,32352,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]}if(Ib>0.0){Jb=Ib}else{p=c[63880]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=57624;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&127](g,f,32352,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]}if(Jb>0.0){Kb=Jb}else{o=c[63880]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=57624;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&127](f,e,32352,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]}qb=Kb+-273.15;lA(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];jA(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);qb=+h[na>>3];kA(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);qb=+h[pa>>3];jA(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);Eb=+h[qa>>3];kA(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+368>>3];rb=+zd(1.0e-13,+(+h[qa+376>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+nwa(c[ib>>2]|0,rb,32424,57400,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(Eb- +yd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{jA(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);Lb=+h[ta>>3];kA(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);Lb=+h[va>>3];jA(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);qb=+h[wa>>3];kA(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+zd(1.0e-13,+(+h[wa+376>>3]- +h[ya>>3]));Eb=1.0- +h[wa+368>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+nwa(c[ib>>2]|0,qb,32424,57400,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{jA(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);Ob=+h[za>>3];kA(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);Ob=+h[Ba>>3];jA(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);Lb=+h[Ca>>3];kA(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);Lb=+h[Ea>>3];jA(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);qb=+h[Fa>>3];kA(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+376>>3]- +h[Ha>>3])|0)<<24>>24==0){jA(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);qb=+h[Ia>>3];kA(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Ka,c[ib>>2]|0,+h[Ja+360>>3],+h[Ja+1016>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(La,c[ib>>2]|0,+h[Ka+360>>3],+h[Ka+1016>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+360>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+1016>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+1032>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}jA(Na,c[ib>>2]|0,+h[Qb+360>>3]);rb=+h[Na>>3];kA(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);rb=+h[Pa>>3];jA(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);Eb=+h[Qa>>3];kA(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);Eb=+h[Sa>>3];jA(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);qb=+h[Ta>>3];kA(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Va,c[ib>>2]|0,+h[Ua+360>>3],+h[Ua+1016>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(Wa,c[ib>>2]|0,+h[Va+360>>3],+h[Va+1016>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Xa,c[ib>>2]|0,qb,Bb,+h[Va+360>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+1016>>3],0.0);Cb=+h[Xa>>3];jA(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);Bb=+h[Ya>>3];kA(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+376>>3];vb=+zd(1.0e-13,+(qb-rb));rb=vb*+zd(1.0e-13,+(qb-Eb));Eb=+h[Za+1024>>3];vb=-(Eb*+zd(1.0e-13,+(qb-Lb)));Lb=+h[Za+368>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+nwa(c[ib>>2]|0,rb,32728,57400,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+368>>3];Tb=+h[Ya+376>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+zd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+nwa(c[ib>>2]|0,Vb,32424,57400,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+1024>>3]-Pb}Pb=+h[Mb+360>>3];Wb=Pb+-273.15;Cb=+h[Mb+1016>>3];sA($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];jA(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);Pb=+h[ab>>3];kA(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);Pb=+h[cb>>3];jA(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);Wb=+h[db>>3];kA(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+360>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+nwa(c[ib>>2]|0,rb,33336,57400,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+360>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+1024>>3]-ub);ub=+h[Yb+1016>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+nwa(c[ib>>2]|0,Xb,33336,57400,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+1016>>3];ac=+h[Yb+360>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+Nxa(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+368>>3];Gb=+zd(1.0e-13,+(+h[Yb+376>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+nwa(c[ib>>2]|0,Gb,32424,57400,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +zd(+(ac- +yd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+360>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+nwa(c[ib>>2]|0,ec,33336,57400,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+360>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+1024>>3];ic=+h[gc+1016>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+nwa(c[ib>>2]|0,fc,33336,57400,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+1016>>3];kc=+h[gc+360>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+Nxa(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+368>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+zd(1.0e-13,+(+h[gc+376>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9376|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9376|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+nwa(c[ib>>2]|0,Nb,32424,57400,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9376|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function gR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;iA(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+360>>3]);if((Aza(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+376>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+1032>>3]*.999;l=j;m=l+8896|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;xA(e,c[f>>2]|0,+h[d+360>>3],+h[d+1016>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+8896|0;n=m;h[n>>3]=k;i=b;return}}function hR(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5120>>3];k=+zd(1.0e-13,+(+h[g+376>>3]-j));l=+h[g+6296>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+nwa(c[b+536>>2]|0,k,34784,57408,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8080|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=Cza(1.0e-13,+h[f+376>>3]- +h[f+5120>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+5120>>3];j=+h[x+376>>3];k=+zd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+8792>>3];k=+h[x+6296>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+1032>>3]- +h[x+8896>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+1032>>3]- +h[x+8896>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+1032>>3]- +h[x+8896>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+1032>>3]- +h[x+8896>>3]}K=(y-k*J)/+nwa(c[b+536>>2]|0,l,34848,57408,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+6296>>3];C=+h[L+5120>>3];D=+h[L+376>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+8896>>3];m=+zd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+nwa(c[b+536>>2]|0,m,34784,57408,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8080|0;w=v;h[w>>3]=n;i=d;return}function iR(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(Cza(+h[a+368>>3]- +h[a+5136>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+8888|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+1024>>3]- +h[a+8080>>3];g=a;j=g+8888|0;k=j;h[k>>3]=f;i=b;return}function jR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8072>>3]=+h[b+1024>>3]- +h[b+8888>>3];i=i;return}function kR(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5152>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+8888>>3];o=+h[g+8792>>3]*k+ +h[g+6296>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+nwa(c[b+536>>2]|0,l,34992,57416,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+8888>>3];q=+h[v+5152>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+8072>>3]*(1.0-q)+ +h[r+5144>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+8880|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+8880|0;C=B;h[C>>3]=z;i=d;return}p=t/+nwa(c[b+536>>2]|0,l,34992,57416,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+8880|0;C=B;h[C>>3]=z;i=d;return}function lR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+14528>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+14504>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+14512>>3];h[a+8>>3]=+h[d+14304>>3];h[e+8>>3]=+h[d+14280>>3];h[f+8>>3]=+h[d+14288>>3];i=i;return}function mR(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0.0,k=0.0,l=0.0,m=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+1032>>3]=+h[b>>3];h[a+1016>>3]=+h[b+8>>3];fR(f);gR(f);hR(f);iR(f);jR(f);kR(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;g=f+5184|0;j=+h[g>>3];b=f+360|0;k=+h[b>>3];l=j*k;a=f+1016|0;m=f+8880|0;h[d>>3]=+h[f+9384>>3]*l*l+(+h[f+376>>3]*(j*+h[a>>3]+k*+h[m>>3])-l*+h[f+1032>>3]);h[d+8>>3]=+h[f+8064>>3]+(+h[m>>3]*+h[b>>3]+(+h[g>>3]*+h[a>>3]- +h[f+9376>>3]));i=e;return}function nR(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+63472>>3];h[c[b+8>>2]>>3]=+h[d+63448>>3];h[c[b+12>>2]>>3]=+h[d+63456>>3];i=i;return}function oR(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+4528>>3]=g;xz(f,c[a+536>>2]|0,g,+h[(c[a+416>>2]|0)+464>>3],+h[j+4728>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+4848>>3]- +h[f>>3];i=e;return}function pR(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+77920>>3];h[c[b+8>>2]>>3]=+h[d+77896>>3];h[c[b+12>>2]>>3]=+h[d+77904>>3];i=i;return}function qR(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+5560>>3]=g;k=a+416|0;l=c[k>>2]|0;Kz(f,c[a+536>>2]|0,g,+h[j+5824>>3],+h[j+5832>>3],+h[j+5752>>3],+h[j+5760>>3],+h[j+10208>>3],+h[j+9896>>3],+h[l+1824>>3]*5.0,(+h[l+496>>3]+ +h[l+504>>3])*.5,+h[l+1816>>3]*.25,+h[l+1784>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+464>>3]- +h[f>>3]*+h[(c[k>>2]|0)+1760>>3];i=e;return}function rR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;iA(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+384>>3]);if((Aza(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+400>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+1056>>3]*.999;l=j;m=l+8872|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;xA(e,c[f>>2]|0,+h[d+384>>3],+h[d+1040>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+8872|0;n=m;h[n>>3]=k;i=b;return}}function sR(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5232>>3];k=+zd(1.0e-13,+(+h[g+400>>3]-j));l=+h[g+6304>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+nwa(c[b+536>>2]|0,k,33368,57424,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8056|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=Cza(1.0e-13,+h[f+400>>3]- +h[f+5232>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+5232>>3];j=+h[x+400>>3];k=+zd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+8784>>3];k=+h[x+6304>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+1056>>3]- +h[x+8872>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+1056>>3]- +h[x+8872>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+1056>>3]- +h[x+8872>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+1056>>3]- +h[x+8872>>3]}K=(y-k*J)/+nwa(c[b+536>>2]|0,l,33528,57424,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+6304>>3];C=+h[L+5232>>3];D=+h[L+400>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+8872>>3];m=+zd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+nwa(c[b+536>>2]|0,m,33368,57424,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8056|0;w=v;h[w>>3]=n;i=d;return}function tR(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(Cza(+h[a+392>>3]- +h[a+5248>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+8864|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+1048>>3]- +h[a+8056>>3];g=a;j=g+8864|0;k=j;h[k>>3]=f;i=b;return}function uR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8048>>3]=+h[b+1048>>3]- +h[b+8864>>3];i=i;return}function vR(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5264>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+8864>>3];o=+h[g+8784>>3]*k+ +h[g+6304>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+nwa(c[b+536>>2]|0,l,33664,57432,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+8864>>3];q=+h[v+5264>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+8048>>3]*(1.0-q)+ +h[r+5256>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+8856|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+8856|0;C=B;h[C>>3]=z;i=d;return}p=t/+nwa(c[b+536>>2]|0,l,33664,57432,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+8856|0;C=B;h[C>>3]=z;i=d;return}function wR(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[63880]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=57624;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&127](mb,m,33768,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]}jA(t,c[ib>>2]|0,jb);jb=+h[t>>3];kA(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);jb=+h[v>>3];jA(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);pb=+h[w>>3];kA(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+392>>3];qb=+zd(1.0e-13,+(+h[w+400>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+nwa(c[ib>>2]|0,qb,33840,57440,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(pb- +yd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{jA(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);sb=+h[z>>3];kA(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);sb=+h[B>>3];jA(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);jb=+h[C>>3];kA(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+zd(1.0e-13,+(+h[C+400>>3]- +h[E>>3]));pb=1.0- +h[C+392>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+nwa(c[ib>>2]|0,jb,33840,57440,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{jA(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);vb=+h[F>>3];kA(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);vb=+h[H>>3];jA(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);sb=+h[I>>3];kA(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);sb=+h[K>>3];jA(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);jb=+h[L>>3];kA(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+400>>3]- +h[N>>3])|0)<<24>>24==0){jA(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);jb=+h[O>>3];kA(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Q,c[ib>>2]|0,+h[P+384>>3],+h[P+1040>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(R,c[ib>>2]|0,+h[Q+384>>3],+h[Q+1040>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(S,c[ib>>2]|0,jb,pb,+h[Q+384>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+1040>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+1056>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}jA(T,c[ib>>2]|0,+h[xb+384>>3]);qb=+h[T>>3];kA(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);qb=+h[V>>3];jA(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);pb=+h[W>>3];kA(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);pb=+h[Y>>3];jA(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);jb=+h[Z>>3];kA(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA($,c[ib>>2]|0,+h[_+384>>3],+h[_+1040>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(aa,c[ib>>2]|0,+h[$+384>>3],+h[$+1040>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(ba,c[ib>>2]|0,jb,rb,+h[$+384>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+1040>>3],0.0);zb=+h[ba>>3];jA(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);rb=+h[ca>>3];kA(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+400>>3];Ab=+zd(1.0e-13,+(jb-qb));qb=Ab*+zd(1.0e-13,+(jb-pb));pb=+h[ea+1048>>3];Ab=-(pb*+zd(1.0e-13,+(jb-sb)));sb=+h[ea+392>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+nwa(c[ib>>2]|0,qb,34144,57440,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+392>>3];Cb=+h[ca+400>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+zd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+nwa(c[ib>>2]|0,Eb,33840,57440,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+1048>>3]-wb}wb=+h[tb+384>>3];if(wb>0.0){Gb=wb}else{tb=c[63880]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=57624;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&127](Db,l,33768,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]}if(Gb>0.0){Hb=Gb}else{r=c[63880]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=57624;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&127](l,j,33768,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]}jA(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];kA(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);Hb=+h[ia>>3];jA(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);Fb=+h[ja>>3];kA(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3];if(zb>0.0){Ib=zb}else{la=c[63880]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=57624;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&127](ka,g,33768,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]}if(Ib>0.0){Jb=Ib}else{p=c[63880]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=57624;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&127](g,f,33768,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]}if(Jb>0.0){Kb=Jb}else{o=c[63880]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=57624;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&127](f,e,33768,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]}qb=Kb+-273.15;lA(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];jA(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);qb=+h[na>>3];kA(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);qb=+h[pa>>3];jA(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);Eb=+h[qa>>3];kA(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+392>>3];rb=+zd(1.0e-13,+(+h[qa+400>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+nwa(c[ib>>2]|0,rb,33840,57440,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(Eb- +yd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{jA(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);Lb=+h[ta>>3];kA(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);Lb=+h[va>>3];jA(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);qb=+h[wa>>3];kA(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+zd(1.0e-13,+(+h[wa+400>>3]- +h[ya>>3]));Eb=1.0- +h[wa+392>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+nwa(c[ib>>2]|0,qb,33840,57440,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{jA(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);Ob=+h[za>>3];kA(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);Ob=+h[Ba>>3];jA(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);Lb=+h[Ca>>3];kA(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);Lb=+h[Ea>>3];jA(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);qb=+h[Fa>>3];kA(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+400>>3]- +h[Ha>>3])|0)<<24>>24==0){jA(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);qb=+h[Ia>>3];kA(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Ka,c[ib>>2]|0,+h[Ja+384>>3],+h[Ja+1040>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(La,c[ib>>2]|0,+h[Ka+384>>3],+h[Ka+1040>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+384>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+1040>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+1056>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}jA(Na,c[ib>>2]|0,+h[Qb+384>>3]);rb=+h[Na>>3];kA(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);rb=+h[Pa>>3];jA(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);Eb=+h[Qa>>3];kA(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);Eb=+h[Sa>>3];jA(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);qb=+h[Ta>>3];kA(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Va,c[ib>>2]|0,+h[Ua+384>>3],+h[Ua+1040>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(Wa,c[ib>>2]|0,+h[Va+384>>3],+h[Va+1040>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Xa,c[ib>>2]|0,qb,Bb,+h[Va+384>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+1040>>3],0.0);Cb=+h[Xa>>3];jA(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);Bb=+h[Ya>>3];kA(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+400>>3];vb=+zd(1.0e-13,+(qb-rb));rb=vb*+zd(1.0e-13,+(qb-Eb));Eb=+h[Za+1048>>3];vb=-(Eb*+zd(1.0e-13,+(qb-Lb)));Lb=+h[Za+392>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+nwa(c[ib>>2]|0,rb,34144,57440,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+392>>3];Tb=+h[Ya+400>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+zd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+nwa(c[ib>>2]|0,Vb,33840,57440,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+1048>>3]-Pb}Pb=+h[Mb+384>>3];Wb=Pb+-273.15;Cb=+h[Mb+1040>>3];sA($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];jA(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);Pb=+h[ab>>3];kA(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);Pb=+h[cb>>3];jA(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);Wb=+h[db>>3];kA(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]);lA(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+384>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+384>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+nwa(c[ib>>2]|0,rb,34752,57440,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+384>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+1048>>3]-ub);ub=+h[Yb+1040>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+nwa(c[ib>>2]|0,Xb,34752,57440,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+1040>>3];ac=+h[Yb+384>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+Nxa(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+392>>3];Gb=+zd(1.0e-13,+(+h[Yb+400>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+nwa(c[ib>>2]|0,Gb,33840,57440,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +zd(+(ac- +yd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+384>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+nwa(c[ib>>2]|0,ec,34752,57440,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+384>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+1048>>3];ic=+h[gc+1040>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+nwa(c[ib>>2]|0,fc,34752,57440,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+1040>>3];kc=+h[gc+384>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+Nxa(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+392>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+zd(1.0e-13,+(+h[gc+400>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9360|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9360|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+nwa(c[ib>>2]|0,Nb,33840,57440,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9360|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function xR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+14864>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+14840>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+14848>>3];h[a+8>>3]=+h[d+14640>>3];h[e+8>>3]=+h[d+14616>>3];h[f+8>>3]=+h[d+14624>>3];i=i;return}function yR(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0.0,k=0.0,l=0.0,m=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+1056>>3]=+h[b>>3];h[a+1040>>3]=+h[b+8>>3];rR(f);sR(f);tR(f);uR(f);vR(f);wR(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;g=f+5296|0;j=+h[g>>3];b=f+384|0;k=+h[b>>3];l=j*k;a=f+1040|0;m=f+8856|0;h[d>>3]=+h[f+9368>>3]*l*l+(+h[f+400>>3]*(j*+h[a>>3]+k*+h[m>>3])-l*+h[f+1056>>3]);h[d+8>>3]=+h[f+8040>>3]+(+h[m>>3]*+h[b>>3]+(+h[g>>3]*+h[a>>3]- +h[f+9360>>3]));i=e;return}function zR(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+63360>>3];h[c[b+8>>2]>>3]=+h[d+63336>>3];h[c[b+12>>2]>>3]=+h[d+63344>>3];i=i;return}function AR(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+4520>>3]=g;xz(f,c[a+536>>2]|0,g,+h[(c[a+416>>2]|0)+456>>3],+h[j+4720>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+4840>>3]- +h[f>>3];i=e;return}function BR(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+77808>>3];h[c[b+8>>2]>>3]=+h[d+77784>>3];h[c[b+12>>2]>>3]=+h[d+77792>>3];i=i;return}function CR(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+5552>>3]=g;k=a+416|0;l=c[k>>2]|0;Kz(f,c[a+536>>2]|0,g,+h[j+5816>>3],+h[j+5824>>3],+h[j+5744>>3],+h[j+5752>>3],+h[j+10200>>3],+h[j+9888>>3],+h[l+1824>>3]*7.5,(+h[l+488>>3]+ +h[l+496>>3])*.5,+h[l+1816>>3]*.25,+h[l+1784>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+456>>3]- +h[f>>3]*+h[(c[k>>2]|0)+1760>>3];i=e;return}function DR(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[63880]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=57624;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&127](mb,m,22008,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]}jA(t,c[ib>>2]|0,jb);jb=+h[t>>3];kA(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);jb=+h[v>>3];jA(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);pb=+h[w>>3];kA(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+416>>3];qb=+zd(1.0e-13,+(+h[w+424>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+nwa(c[ib>>2]|0,qb,22080,57448,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(pb- +yd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{jA(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);sb=+h[z>>3];kA(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);sb=+h[B>>3];jA(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);jb=+h[C>>3];kA(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+zd(1.0e-13,+(+h[C+424>>3]- +h[E>>3]));pb=1.0- +h[C+416>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+nwa(c[ib>>2]|0,jb,22080,57448,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{jA(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);vb=+h[F>>3];kA(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);vb=+h[H>>3];jA(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);sb=+h[I>>3];kA(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);sb=+h[K>>3];jA(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);jb=+h[L>>3];kA(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+424>>3]- +h[N>>3])|0)<<24>>24==0){jA(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);jb=+h[O>>3];kA(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Q,c[ib>>2]|0,+h[P+408>>3],+h[P+1064>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(R,c[ib>>2]|0,+h[Q+408>>3],+h[Q+1064>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(S,c[ib>>2]|0,jb,pb,+h[Q+408>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+1064>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+1080>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}jA(T,c[ib>>2]|0,+h[xb+408>>3]);qb=+h[T>>3];kA(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);qb=+h[V>>3];jA(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);pb=+h[W>>3];kA(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);pb=+h[Y>>3];jA(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);jb=+h[Z>>3];kA(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA($,c[ib>>2]|0,+h[_+408>>3],+h[_+1064>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(aa,c[ib>>2]|0,+h[$+408>>3],+h[$+1064>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(ba,c[ib>>2]|0,jb,rb,+h[$+408>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+1064>>3],0.0);zb=+h[ba>>3];jA(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);rb=+h[ca>>3];kA(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+424>>3];Ab=+zd(1.0e-13,+(jb-qb));qb=Ab*+zd(1.0e-13,+(jb-pb));pb=+h[ea+1072>>3];Ab=-(pb*+zd(1.0e-13,+(jb-sb)));sb=+h[ea+416>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+nwa(c[ib>>2]|0,qb,22384,57448,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+416>>3];Cb=+h[ca+424>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+zd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+nwa(c[ib>>2]|0,Eb,22080,57448,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+1072>>3]-wb}wb=+h[tb+408>>3];if(wb>0.0){Gb=wb}else{tb=c[63880]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=57624;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&127](Db,l,22008,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]}if(Gb>0.0){Hb=Gb}else{r=c[63880]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=57624;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&127](l,j,22008,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]}jA(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];kA(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);Hb=+h[ia>>3];jA(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);Fb=+h[ja>>3];kA(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3];if(zb>0.0){Ib=zb}else{la=c[63880]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=57624;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&127](ka,g,22008,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]}if(Ib>0.0){Jb=Ib}else{p=c[63880]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=57624;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&127](g,f,22008,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]}if(Jb>0.0){Kb=Jb}else{o=c[63880]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=57624;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&127](f,e,22008,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]}qb=Kb+-273.15;lA(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];jA(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);qb=+h[na>>3];kA(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);qb=+h[pa>>3];jA(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);Eb=+h[qa>>3];kA(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+416>>3];rb=+zd(1.0e-13,+(+h[qa+424>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+nwa(c[ib>>2]|0,rb,22080,57448,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(Eb- +yd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{jA(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);Lb=+h[ta>>3];kA(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);Lb=+h[va>>3];jA(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);qb=+h[wa>>3];kA(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+zd(1.0e-13,+(+h[wa+424>>3]- +h[ya>>3]));Eb=1.0- +h[wa+416>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+nwa(c[ib>>2]|0,qb,22080,57448,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{jA(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);Ob=+h[za>>3];kA(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);Ob=+h[Ba>>3];jA(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);Lb=+h[Ca>>3];kA(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);Lb=+h[Ea>>3];jA(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);qb=+h[Fa>>3];kA(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+424>>3]- +h[Ha>>3])|0)<<24>>24==0){jA(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);qb=+h[Ia>>3];kA(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Ka,c[ib>>2]|0,+h[Ja+408>>3],+h[Ja+1064>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(La,c[ib>>2]|0,+h[Ka+408>>3],+h[Ka+1064>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+408>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+1064>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+1080>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}jA(Na,c[ib>>2]|0,+h[Qb+408>>3]);rb=+h[Na>>3];kA(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);rb=+h[Pa>>3];jA(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);Eb=+h[Qa>>3];kA(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);Eb=+h[Sa>>3];jA(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);qb=+h[Ta>>3];kA(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Va,c[ib>>2]|0,+h[Ua+408>>3],+h[Ua+1064>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(Wa,c[ib>>2]|0,+h[Va+408>>3],+h[Va+1064>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Xa,c[ib>>2]|0,qb,Bb,+h[Va+408>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+1064>>3],0.0);Cb=+h[Xa>>3];jA(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);Bb=+h[Ya>>3];kA(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+424>>3];vb=+zd(1.0e-13,+(qb-rb));rb=vb*+zd(1.0e-13,+(qb-Eb));Eb=+h[Za+1072>>3];vb=-(Eb*+zd(1.0e-13,+(qb-Lb)));Lb=+h[Za+416>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+nwa(c[ib>>2]|0,rb,22384,57448,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+416>>3];Tb=+h[Ya+424>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+zd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+nwa(c[ib>>2]|0,Vb,22080,57448,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+1072>>3]-Pb}Pb=+h[Mb+408>>3];Wb=Pb+-273.15;Cb=+h[Mb+1064>>3];sA($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];jA(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);Pb=+h[ab>>3];kA(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);Pb=+h[cb>>3];jA(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);Wb=+h[db>>3];kA(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]);lA(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+408>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+408>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+nwa(c[ib>>2]|0,rb,22992,57448,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+408>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+1072>>3]-ub);ub=+h[Yb+1064>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+nwa(c[ib>>2]|0,Xb,22992,57448,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+1064>>3];ac=+h[Yb+408>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+Nxa(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+416>>3];Gb=+zd(1.0e-13,+(+h[Yb+424>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+nwa(c[ib>>2]|0,Gb,22080,57448,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +zd(+(ac- +yd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+408>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+nwa(c[ib>>2]|0,ec,22992,57448,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+408>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+1072>>3];ic=+h[gc+1064>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+nwa(c[ib>>2]|0,fc,22992,57448,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+1064>>3];kc=+h[gc+408>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+Nxa(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+416>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+zd(1.0e-13,+(+h[gc+424>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9344|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9344|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+nwa(c[ib>>2]|0,Nb,22080,57448,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9344|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function ER(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;iA(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+408>>3]);if((Aza(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+424>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+1080>>3]*.999;l=j;m=l+8848|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;xA(e,c[f>>2]|0,+h[d+408>>3],+h[d+1064>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+8848|0;n=m;h[n>>3]=k;i=b;return}}function FR(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5344>>3];k=+zd(1.0e-13,+(+h[g+424>>3]-j));l=+h[g+6312>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+nwa(c[b+536>>2]|0,k,49656,57456,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8032|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=Cza(1.0e-13,+h[f+424>>3]- +h[f+5344>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+5344>>3];j=+h[x+424>>3];k=+zd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+8776>>3];k=+h[x+6312>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+1080>>3]- +h[x+8848>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+1080>>3]- +h[x+8848>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+1080>>3]- +h[x+8848>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+1080>>3]- +h[x+8848>>3]}K=(y-k*J)/+nwa(c[b+536>>2]|0,l,49728,57456,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+6312>>3];C=+h[L+5344>>3];D=+h[L+424>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+8848>>3];m=+zd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+nwa(c[b+536>>2]|0,m,49656,57456,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8032|0;w=v;h[w>>3]=n;i=d;return}function GR(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(Cza(+h[a+416>>3]- +h[a+5360>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+8840|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+1072>>3]- +h[a+8032>>3];g=a;j=g+8840|0;k=j;h[k>>3]=f;i=b;return}function HR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8024>>3]=+h[b+1072>>3]- +h[b+8840>>3];i=i;return}function IR(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5376>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+8840>>3];o=+h[g+8776>>3]*k+ +h[g+6312>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+nwa(c[b+536>>2]|0,l,49864,57464,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+8840>>3];q=+h[v+5376>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+8024>>3]*(1.0-q)+ +h[r+5368>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+8832|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+8832|0;C=B;h[C>>3]=z;i=d;return}p=t/+nwa(c[b+536>>2]|0,l,49864,57464,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+8832|0;C=B;h[C>>3]=z;i=d;return}function JR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+14976>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+14952>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+14960>>3];h[a+8>>3]=+h[d+15200>>3];h[e+8>>3]=+h[d+15176>>3];h[f+8>>3]=+h[d+15184>>3];i=i;return}function KR(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0.0,l=0.0,m=0.0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+1064>>3]=+h[b>>3];h[a+1080>>3]=+h[b+8>>3];DR(f);ER(f);FR(f);GR(f);HR(f);IR(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;g=f+8832|0;b=f+408|0;a=f+5408|0;j=f+1064|0;h[d>>3]=+h[f+8016>>3]+(+h[g>>3]*+h[b>>3]+(+h[a>>3]*+h[j>>3]- +h[f+9344>>3]));k=+h[a>>3];l=+h[b>>3];m=k*l;h[d+8>>3]=+h[f+9352>>3]*m*m+(+h[f+424>>3]*(k*+h[j>>3]+l*+h[g>>3])-m*+h[f+1080>>3]);i=e;return}function LR(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+63248>>3];h[c[b+8>>2]>>3]=+h[d+63224>>3];h[c[b+12>>2]>>3]=+h[d+63232>>3];i=i;return}function MR(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+4512>>3]=g;xz(f,c[a+536>>2]|0,g,+h[(c[a+416>>2]|0)+448>>3],+h[j+4712>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+4832>>3]- +h[f>>3];i=e;return}function NR(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+49696>>3];h[c[b+8>>2]>>3]=+h[d+49672>>3];h[c[b+12>>2]>>3]=+h[d+49680>>3];i=i;return}function OR(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0,k=0,l=0,m=0.0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+3544>>3]=g;k=a+416|0;l=c[k>>2]|0;m=+h[l+784>>3];Kz(f,c[a+536>>2]|0,g,+h[j+3936>>3],+h[j+3944>>3],+h[j+3832>>3],+h[j+3840>>3],+h[j+10304>>3],+h[l+744>>3],+h[l+2056>>3]*2.5,(m+m)*.5,+h[l+2048>>3]/6.0,+h[l+2016>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+288>>3]- +h[f>>3]*+h[(c[k>>2]|0)+1992>>3];i=e;return}function PR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;iA(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+264>>3]);if((Aza(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+280>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+936>>3]*.999;l=j;m=l+8984|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;xA(e,c[f>>2]|0,+h[d+264>>3],+h[d+920>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+8984|0;n=m;h[n>>3]=k;i=b;return}}function QR(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3448>>3];k=+zd(1.0e-13,+(+h[g+280>>3]-j));l=+h[g+4440>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+nwa(c[b+536>>2]|0,k,54584,57472,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8176|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=Cza(1.0e-13,+h[f+280>>3]- +h[f+3448>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+3448>>3];j=+h[x+280>>3];k=+zd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+8928>>3];k=+h[x+4440>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+936>>3]- +h[x+8984>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+936>>3]- +h[x+8984>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+936>>3]- +h[x+8984>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+936>>3]- +h[x+8984>>3]}K=(y-k*J)/+nwa(c[b+536>>2]|0,l,54744,57472,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+4440>>3];C=+h[L+3448>>3];D=+h[L+280>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+8984>>3];m=+zd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+nwa(c[b+536>>2]|0,m,54584,57472,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8176|0;w=v;h[w>>3]=n;i=d;return}function RR(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(Cza(+h[a+272>>3]- +h[a+3464>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+8976|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+928>>3]- +h[a+8176>>3];g=a;j=g+8976|0;k=j;h[k>>3]=f;i=b;return}function SR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8168>>3]=+h[b+928>>3]- +h[b+8976>>3];i=i;return}function TR(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3480>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+8976>>3];o=+h[g+8928>>3]*k+ +h[g+4440>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+nwa(c[b+536>>2]|0,l,54880,57480,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+8976>>3];q=+h[v+3480>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+8168>>3]*(1.0-q)+ +h[r+3472>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+8968|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+8968|0;C=B;h[C>>3]=z;i=d;return}p=t/+nwa(c[b+536>>2]|0,l,54880,57480,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+8968|0;C=B;h[C>>3]=z;i=d;return}



function kQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[63880]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=57624;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&127](mb,m,36600,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]}jA(t,c[ib>>2]|0,jb);jb=+h[t>>3];kA(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);jb=+h[v>>3];jA(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);pb=+h[w>>3];kA(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+224>>3];qb=+zd(1.0e-13,+(+h[w+232>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+nwa(c[ib>>2]|0,qb,36672,57296,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(pb- +yd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{jA(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);sb=+h[z>>3];kA(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);sb=+h[B>>3];jA(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);jb=+h[C>>3];kA(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+zd(1.0e-13,+(+h[C+232>>3]- +h[E>>3]));pb=1.0- +h[C+224>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+nwa(c[ib>>2]|0,jb,36672,57296,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{jA(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);vb=+h[F>>3];kA(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);vb=+h[H>>3];jA(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);sb=+h[I>>3];kA(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);sb=+h[K>>3];jA(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);jb=+h[L>>3];kA(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+232>>3]- +h[N>>3])|0)<<24>>24==0){jA(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);jb=+h[O>>3];kA(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Q,c[ib>>2]|0,+h[P+216>>3],+h[P+872>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(R,c[ib>>2]|0,+h[Q+216>>3],+h[Q+872>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(S,c[ib>>2]|0,jb,pb,+h[Q+216>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+872>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+888>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}jA(T,c[ib>>2]|0,+h[xb+216>>3]);qb=+h[T>>3];kA(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);qb=+h[V>>3];jA(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);pb=+h[W>>3];kA(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);pb=+h[Y>>3];jA(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);jb=+h[Z>>3];kA(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA($,c[ib>>2]|0,+h[_+216>>3],+h[_+872>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(aa,c[ib>>2]|0,+h[$+216>>3],+h[$+872>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(ba,c[ib>>2]|0,jb,rb,+h[$+216>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+872>>3],0.0);zb=+h[ba>>3];jA(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);rb=+h[ca>>3];kA(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+232>>3];Ab=+zd(1.0e-13,+(jb-qb));qb=Ab*+zd(1.0e-13,+(jb-pb));pb=+h[ea+880>>3];Ab=-(pb*+zd(1.0e-13,+(jb-sb)));sb=+h[ea+224>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+nwa(c[ib>>2]|0,qb,36976,57296,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+224>>3];Cb=+h[ca+232>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+zd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+nwa(c[ib>>2]|0,Eb,36672,57296,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+880>>3]-wb}wb=+h[tb+216>>3];if(wb>0.0){Gb=wb}else{tb=c[63880]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=57624;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&127](Db,l,36600,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]}if(Gb>0.0){Hb=Gb}else{r=c[63880]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=57624;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&127](l,j,36600,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]}jA(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];kA(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);Hb=+h[ia>>3];jA(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);Fb=+h[ja>>3];kA(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3];if(zb>0.0){Ib=zb}else{la=c[63880]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=57624;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&127](ka,g,36600,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]}if(Ib>0.0){Jb=Ib}else{p=c[63880]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=57624;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&127](g,f,36600,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]}if(Jb>0.0){Kb=Jb}else{o=c[63880]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=57624;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&127](f,e,36600,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]}qb=Kb+-273.15;lA(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];jA(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);qb=+h[na>>3];kA(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);qb=+h[pa>>3];jA(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);Eb=+h[qa>>3];kA(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+224>>3];rb=+zd(1.0e-13,+(+h[qa+232>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+nwa(c[ib>>2]|0,rb,36672,57296,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(Eb- +yd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{jA(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);Lb=+h[ta>>3];kA(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);Lb=+h[va>>3];jA(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);qb=+h[wa>>3];kA(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+zd(1.0e-13,+(+h[wa+232>>3]- +h[ya>>3]));Eb=1.0- +h[wa+224>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+nwa(c[ib>>2]|0,qb,36672,57296,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{jA(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);Ob=+h[za>>3];kA(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);Ob=+h[Ba>>3];jA(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);Lb=+h[Ca>>3];kA(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);Lb=+h[Ea>>3];jA(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);qb=+h[Fa>>3];kA(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+232>>3]- +h[Ha>>3])|0)<<24>>24==0){jA(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);qb=+h[Ia>>3];kA(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Ka,c[ib>>2]|0,+h[Ja+216>>3],+h[Ja+872>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(La,c[ib>>2]|0,+h[Ka+216>>3],+h[Ka+872>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+216>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+872>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+888>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}jA(Na,c[ib>>2]|0,+h[Qb+216>>3]);rb=+h[Na>>3];kA(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);rb=+h[Pa>>3];jA(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);Eb=+h[Qa>>3];kA(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);Eb=+h[Sa>>3];jA(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);qb=+h[Ta>>3];kA(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Va,c[ib>>2]|0,+h[Ua+216>>3],+h[Ua+872>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(Wa,c[ib>>2]|0,+h[Va+216>>3],+h[Va+872>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Xa,c[ib>>2]|0,qb,Bb,+h[Va+216>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+872>>3],0.0);Cb=+h[Xa>>3];jA(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);Bb=+h[Ya>>3];kA(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+232>>3];vb=+zd(1.0e-13,+(qb-rb));rb=vb*+zd(1.0e-13,+(qb-Eb));Eb=+h[Za+880>>3];vb=-(Eb*+zd(1.0e-13,+(qb-Lb)));Lb=+h[Za+224>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+nwa(c[ib>>2]|0,rb,36976,57296,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+224>>3];Tb=+h[Ya+232>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+zd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+nwa(c[ib>>2]|0,Vb,36672,57296,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+880>>3]-Pb}Pb=+h[Mb+216>>3];Wb=Pb+-273.15;Cb=+h[Mb+872>>3];sA($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];jA(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);Pb=+h[ab>>3];kA(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);Pb=+h[cb>>3];jA(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);Wb=+h[db>>3];kA(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]);lA(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+216>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+216>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+nwa(c[ib>>2]|0,rb,37584,57296,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+216>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+880>>3]-ub);ub=+h[Yb+872>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+nwa(c[ib>>2]|0,Xb,37584,57296,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+872>>3];ac=+h[Yb+216>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+Nxa(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+224>>3];Gb=+zd(1.0e-13,+(+h[Yb+232>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+nwa(c[ib>>2]|0,Gb,36672,57296,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +zd(+(ac- +yd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+216>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+nwa(c[ib>>2]|0,ec,37584,57296,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+216>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+880>>3];ic=+h[gc+872>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+nwa(c[ib>>2]|0,fc,37584,57296,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+872>>3];kc=+h[gc+216>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+Nxa(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+224>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+zd(1.0e-13,+(+h[gc+232>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9440|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9440|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+nwa(c[ib>>2]|0,Nb,36672,57296,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9440|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function lQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+12288>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+12264>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+12272>>3];h[a+8>>3]=+h[d+12512>>3];h[e+8>>3]=+h[d+12488>>3];h[f+8>>3]=+h[d+12496>>3];i=i;return}function mQ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0.0,l=0.0,m=0.0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+872>>3]=+h[b>>3];h[a+888>>3]=+h[b+8>>3];fQ(f);gQ(f);hQ(f);iQ(f);jQ(f);kQ(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;g=f+9016|0;b=f+216|0;a=f+3288|0;j=f+872|0;h[d>>3]=+h[f+8208>>3]+(+h[g>>3]*+h[b>>3]+(+h[a>>3]*+h[j>>3]- +h[f+9440>>3]));k=+h[a>>3];l=+h[b>>3];m=k*l;h[d+8>>3]=+h[f+9448>>3]*m*m+(+h[f+232>>3]*(k*+h[j>>3]+l*+h[g>>3])-m*+h[f+888>>3]);i=e;return}function nQ(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+49808>>3];h[c[b+8>>2]>>3]=+h[d+49784>>3];h[c[b+12>>2]>>3]=+h[d+49792>>3];i=i;return}function oQ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+3552>>3]=g;k=a+416|0;l=c[k>>2]|0;Kz(f,c[a+536>>2]|0,g,+h[j+3944>>3],+h[j+3952>>3],+h[j+3840>>3],+h[j+3848>>3],+h[j+10312>>3],+h[j+9880>>3],+h[l+2056>>3]*5.0,(+h[l+784>>3]+ +h[l+792>>3])*.5,+h[l+2048>>3]/6.0,+h[l+2016>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+296>>3]- +h[f>>3]*+h[(c[k>>2]|0)+1992>>3];i=e;return}function pQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[63880]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=57624;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&127](mb,m,35584,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]}jA(t,c[ib>>2]|0,jb);jb=+h[t>>3];kA(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);jb=+h[v>>3];jA(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);pb=+h[w>>3];kA(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+248>>3];qb=+zd(1.0e-13,+(+h[w+256>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+nwa(c[ib>>2]|0,qb,35656,57304,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(pb- +yd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{jA(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);sb=+h[z>>3];kA(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);sb=+h[B>>3];jA(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);jb=+h[C>>3];kA(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+zd(1.0e-13,+(+h[C+256>>3]- +h[E>>3]));pb=1.0- +h[C+248>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+nwa(c[ib>>2]|0,jb,35656,57304,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{jA(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);vb=+h[F>>3];kA(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);vb=+h[H>>3];jA(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);sb=+h[I>>3];kA(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);sb=+h[K>>3];jA(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);jb=+h[L>>3];kA(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+256>>3]- +h[N>>3])|0)<<24>>24==0){jA(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);jb=+h[O>>3];kA(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Q,c[ib>>2]|0,+h[P+240>>3],+h[P+896>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(R,c[ib>>2]|0,+h[Q+240>>3],+h[Q+896>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(S,c[ib>>2]|0,jb,pb,+h[Q+240>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+896>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+912>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}jA(T,c[ib>>2]|0,+h[xb+240>>3]);qb=+h[T>>3];kA(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);qb=+h[V>>3];jA(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);pb=+h[W>>3];kA(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);pb=+h[Y>>3];jA(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);jb=+h[Z>>3];kA(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA($,c[ib>>2]|0,+h[_+240>>3],+h[_+896>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(aa,c[ib>>2]|0,+h[$+240>>3],+h[$+896>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(ba,c[ib>>2]|0,jb,rb,+h[$+240>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+896>>3],0.0);zb=+h[ba>>3];jA(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);rb=+h[ca>>3];kA(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+256>>3];Ab=+zd(1.0e-13,+(jb-qb));qb=Ab*+zd(1.0e-13,+(jb-pb));pb=+h[ea+904>>3];Ab=-(pb*+zd(1.0e-13,+(jb-sb)));sb=+h[ea+248>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+nwa(c[ib>>2]|0,qb,35960,57304,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+248>>3];Cb=+h[ca+256>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+zd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+nwa(c[ib>>2]|0,Eb,35656,57304,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+904>>3]-wb}wb=+h[tb+240>>3];if(wb>0.0){Gb=wb}else{tb=c[63880]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=57624;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&127](Db,l,35584,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]}if(Gb>0.0){Hb=Gb}else{r=c[63880]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=57624;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&127](l,j,35584,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]}jA(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];kA(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);Hb=+h[ia>>3];jA(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);Fb=+h[ja>>3];kA(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3];if(zb>0.0){Ib=zb}else{la=c[63880]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=57624;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&127](ka,g,35584,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]}if(Ib>0.0){Jb=Ib}else{p=c[63880]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=57624;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&127](g,f,35584,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]}if(Jb>0.0){Kb=Jb}else{o=c[63880]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=57624;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&127](f,e,35584,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]}qb=Kb+-273.15;lA(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];jA(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);qb=+h[na>>3];kA(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);qb=+h[pa>>3];jA(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);Eb=+h[qa>>3];kA(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+248>>3];rb=+zd(1.0e-13,+(+h[qa+256>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+nwa(c[ib>>2]|0,rb,35656,57304,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(Eb- +yd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{jA(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);Lb=+h[ta>>3];kA(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);Lb=+h[va>>3];jA(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);qb=+h[wa>>3];kA(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+zd(1.0e-13,+(+h[wa+256>>3]- +h[ya>>3]));Eb=1.0- +h[wa+248>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+nwa(c[ib>>2]|0,qb,35656,57304,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{jA(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);Ob=+h[za>>3];kA(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);Ob=+h[Ba>>3];jA(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);Lb=+h[Ca>>3];kA(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);Lb=+h[Ea>>3];jA(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);qb=+h[Fa>>3];kA(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+256>>3]- +h[Ha>>3])|0)<<24>>24==0){jA(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);qb=+h[Ia>>3];kA(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Ka,c[ib>>2]|0,+h[Ja+240>>3],+h[Ja+896>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(La,c[ib>>2]|0,+h[Ka+240>>3],+h[Ka+896>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+240>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+896>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+912>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}jA(Na,c[ib>>2]|0,+h[Qb+240>>3]);rb=+h[Na>>3];kA(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);rb=+h[Pa>>3];jA(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);Eb=+h[Qa>>3];kA(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);Eb=+h[Sa>>3];jA(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);qb=+h[Ta>>3];kA(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Va,c[ib>>2]|0,+h[Ua+240>>3],+h[Ua+896>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(Wa,c[ib>>2]|0,+h[Va+240>>3],+h[Va+896>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Xa,c[ib>>2]|0,qb,Bb,+h[Va+240>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+896>>3],0.0);Cb=+h[Xa>>3];jA(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);Bb=+h[Ya>>3];kA(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+256>>3];vb=+zd(1.0e-13,+(qb-rb));rb=vb*+zd(1.0e-13,+(qb-Eb));Eb=+h[Za+904>>3];vb=-(Eb*+zd(1.0e-13,+(qb-Lb)));Lb=+h[Za+248>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+nwa(c[ib>>2]|0,rb,35960,57304,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+248>>3];Tb=+h[Ya+256>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+zd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+nwa(c[ib>>2]|0,Vb,35656,57304,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+904>>3]-Pb}Pb=+h[Mb+240>>3];Wb=Pb+-273.15;Cb=+h[Mb+896>>3];sA($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];jA(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);Pb=+h[ab>>3];kA(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);Pb=+h[cb>>3];jA(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);Wb=+h[db>>3];kA(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]);lA(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+240>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+240>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+nwa(c[ib>>2]|0,rb,36568,57304,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+240>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+904>>3]-ub);ub=+h[Yb+896>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+nwa(c[ib>>2]|0,Xb,36568,57304,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+896>>3];ac=+h[Yb+240>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+Nxa(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+248>>3];Gb=+zd(1.0e-13,+(+h[Yb+256>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+nwa(c[ib>>2]|0,Gb,35656,57304,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +zd(+(ac- +yd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+240>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+nwa(c[ib>>2]|0,ec,36568,57304,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+240>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+904>>3];ic=+h[gc+896>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+nwa(c[ib>>2]|0,fc,36568,57304,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+896>>3];kc=+h[gc+240>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+Nxa(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+248>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+zd(1.0e-13,+(+h[gc+256>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9424|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9424|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+nwa(c[ib>>2]|0,Nb,35656,57304,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9424|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function qQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;iA(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+240>>3]);if((Aza(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+256>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+912>>3]*.999;l=j;m=l+9008|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;xA(e,c[f>>2]|0,+h[d+240>>3],+h[d+896>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+9008|0;n=m;h[n>>3]=k;i=b;return}}function rQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3336>>3];k=+zd(1.0e-13,+(+h[g+256>>3]-j));l=+h[g+4432>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+nwa(c[b+536>>2]|0,k,47288,57312,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8200|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=Cza(1.0e-13,+h[f+256>>3]- +h[f+3336>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+3336>>3];j=+h[x+256>>3];k=+zd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+8936>>3];k=+h[x+4432>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+912>>3]- +h[x+9008>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+912>>3]- +h[x+9008>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+912>>3]- +h[x+9008>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+912>>3]- +h[x+9008>>3]}K=(y-k*J)/+nwa(c[b+536>>2]|0,l,47352,57312,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+4432>>3];C=+h[L+3336>>3];D=+h[L+256>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+9008>>3];m=+zd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+nwa(c[b+536>>2]|0,m,47288,57312,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8200|0;w=v;h[w>>3]=n;i=d;return}function sQ(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(Cza(+h[a+248>>3]- +h[a+3352>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+9e3|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+904>>3]- +h[a+8200>>3];g=a;j=g+9e3|0;k=j;h[k>>3]=f;i=b;return}function tQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8192>>3]=+h[b+904>>3]- +h[b+9e3>>3];i=i;return}function uQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3368>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+9e3>>3];o=+h[g+8936>>3]*k+ +h[g+4432>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+nwa(c[b+536>>2]|0,l,47496,57320,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+9e3>>3];q=+h[v+3368>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+8192>>3]*(1.0-q)+ +h[r+3360>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+8992|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+8992|0;C=B;h[C>>3]=z;i=d;return}p=t/+nwa(c[b+536>>2]|0,l,47496,57320,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+8992|0;C=B;h[C>>3]=z;i=d;return}function vQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+12848>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+12824>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+12832>>3];h[a+8>>3]=+h[d+12624>>3];h[e+8>>3]=+h[d+12600>>3];h[f+8>>3]=+h[d+12608>>3];i=i;return}function wQ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0.0,k=0.0,l=0.0,m=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+912>>3]=+h[b>>3];h[a+896>>3]=+h[b+8>>3];pQ(f);qQ(f);rQ(f);sQ(f);tQ(f);uQ(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;g=f+3400|0;j=+h[g>>3];b=f+240|0;k=+h[b>>3];l=j*k;a=f+896|0;m=f+8992|0;h[d>>3]=+h[f+9432>>3]*l*l+(+h[f+256>>3]*(j*+h[a>>3]+k*+h[m>>3])-l*+h[f+912>>3]);h[d+8>>3]=+h[f+8184>>3]+(+h[m>>3]*+h[b>>3]+(+h[g>>3]*+h[a>>3]- +h[f+9424>>3]));i=e;return}function xQ(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+27968>>3];h[c[b+8>>2]>>3]=+h[d+27944>>3];h[c[b+12>>2]>>3]=+h[d+27952>>3];i=i;return}function yQ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0,k=0,l=0,m=0.0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+1992>>3]=g;k=a+416|0;l=c[k>>2]|0;m=+h[l+1080>>3];Kz(f,c[a+536>>2]|0,g,+h[j+2384>>3],+h[j+2392>>3],+h[j+2280>>3],+h[j+2288>>3],+h[j+10440>>3],+h[l+1040>>3],+h[l+2280>>3]*5.0,(m+m)*.5,+h[l+2272>>3]/6.0,+h[l+2240>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+120>>3]- +h[f>>3]*+h[(c[k>>2]|0)+2216>>3];i=e;return}function zQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;iA(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+96>>3]);if((Aza(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+112>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+768>>3]*.999;l=j;m=l+9144|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;xA(e,c[f>>2]|0,+h[d+96>>3],+h[d+752>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+9144|0;n=m;h[n>>3]=k;i=b;return}}function AQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1896>>3];k=+zd(1.0e-13,+(+h[g+112>>3]-j));l=+h[g+2872>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+nwa(c[b+536>>2]|0,k,45312,57328,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8344|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=Cza(1.0e-13,+h[f+112>>3]- +h[f+1896>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+1896>>3];j=+h[x+112>>3];k=+zd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+9088>>3];k=+h[x+2872>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+768>>3]- +h[x+9144>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+768>>3]- +h[x+9144>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+768>>3]- +h[x+9144>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+768>>3]- +h[x+9144>>3]}K=(y-k*J)/+nwa(c[b+536>>2]|0,l,45472,57328,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+2872>>3];C=+h[L+1896>>3];D=+h[L+112>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+9144>>3];m=+zd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+nwa(c[b+536>>2]|0,m,45312,57328,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8344|0;w=v;h[w>>3]=n;i=d;return}function BQ(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(Cza(+h[a+104>>3]- +h[a+1912>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+9136|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+760>>3]- +h[a+8344>>3];g=a;j=g+9136|0;k=j;h[k>>3]=f;i=b;return}function CQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8336>>3]=+h[b+760>>3]- +h[b+9136>>3];i=i;return}function DQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1928>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+9136>>3];o=+h[g+9088>>3]*k+ +h[g+2872>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+nwa(c[b+536>>2]|0,l,45608,57336,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+9136>>3];q=+h[v+1928>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+8336>>3]*(1.0-q)+ +h[r+1920>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+9128|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+9128|0;C=B;h[C>>3]=z;i=d;return}p=t/+nwa(c[b+536>>2]|0,l,45608,57336,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+9128|0;C=B;h[C>>3]=z;i=d;return}function EQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[63880]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=57624;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&127](mb,m,38632,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]}jA(t,c[ib>>2]|0,jb);jb=+h[t>>3];kA(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);jb=+h[v>>3];jA(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);pb=+h[w>>3];kA(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+104>>3];qb=+zd(1.0e-13,+(+h[w+112>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+nwa(c[ib>>2]|0,qb,38704,57344,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(pb- +yd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{jA(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);sb=+h[z>>3];kA(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);sb=+h[B>>3];jA(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);jb=+h[C>>3];kA(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+zd(1.0e-13,+(+h[C+112>>3]- +h[E>>3]));pb=1.0- +h[C+104>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+nwa(c[ib>>2]|0,jb,38704,57344,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{jA(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);vb=+h[F>>3];kA(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);vb=+h[H>>3];jA(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);sb=+h[I>>3];kA(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);sb=+h[K>>3];jA(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);jb=+h[L>>3];kA(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+112>>3]- +h[N>>3])|0)<<24>>24==0){jA(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);jb=+h[O>>3];kA(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Q,c[ib>>2]|0,+h[P+96>>3],+h[P+752>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(R,c[ib>>2]|0,+h[Q+96>>3],+h[Q+752>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(S,c[ib>>2]|0,jb,pb,+h[Q+96>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+752>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+768>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}jA(T,c[ib>>2]|0,+h[xb+96>>3]);qb=+h[T>>3];kA(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);qb=+h[V>>3];jA(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);pb=+h[W>>3];kA(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);pb=+h[Y>>3];jA(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);jb=+h[Z>>3];kA(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA($,c[ib>>2]|0,+h[_+96>>3],+h[_+752>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(aa,c[ib>>2]|0,+h[$+96>>3],+h[$+752>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(ba,c[ib>>2]|0,jb,rb,+h[$+96>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+752>>3],0.0);zb=+h[ba>>3];jA(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);rb=+h[ca>>3];kA(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+112>>3];Ab=+zd(1.0e-13,+(jb-qb));qb=Ab*+zd(1.0e-13,+(jb-pb));pb=+h[ea+760>>3];Ab=-(pb*+zd(1.0e-13,+(jb-sb)));sb=+h[ea+104>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+nwa(c[ib>>2]|0,qb,39008,57344,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+104>>3];Cb=+h[ca+112>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+zd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+nwa(c[ib>>2]|0,Eb,38704,57344,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+760>>3]-wb}wb=+h[tb+96>>3];if(wb>0.0){Gb=wb}else{tb=c[63880]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=57624;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&127](Db,l,38632,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]}if(Gb>0.0){Hb=Gb}else{r=c[63880]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=57624;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&127](l,j,38632,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]}jA(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];kA(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);Hb=+h[ia>>3];jA(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);Fb=+h[ja>>3];kA(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3];if(zb>0.0){Ib=zb}else{la=c[63880]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=57624;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&127](ka,g,38632,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]}if(Ib>0.0){Jb=Ib}else{p=c[63880]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=57624;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&127](g,f,38632,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]}if(Jb>0.0){Kb=Jb}else{o=c[63880]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=57624;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&127](f,e,38632,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]}qb=Kb+-273.15;lA(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];jA(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);qb=+h[na>>3];kA(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);qb=+h[pa>>3];jA(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);Eb=+h[qa>>3];kA(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+104>>3];rb=+zd(1.0e-13,+(+h[qa+112>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+nwa(c[ib>>2]|0,rb,38704,57344,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(Eb- +yd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{jA(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);Lb=+h[ta>>3];kA(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);Lb=+h[va>>3];jA(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);qb=+h[wa>>3];kA(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+zd(1.0e-13,+(+h[wa+112>>3]- +h[ya>>3]));Eb=1.0- +h[wa+104>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+nwa(c[ib>>2]|0,qb,38704,57344,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{jA(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);Ob=+h[za>>3];kA(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);Ob=+h[Ba>>3];jA(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);Lb=+h[Ca>>3];kA(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);Lb=+h[Ea>>3];jA(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);qb=+h[Fa>>3];kA(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+112>>3]- +h[Ha>>3])|0)<<24>>24==0){jA(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);qb=+h[Ia>>3];kA(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Ka,c[ib>>2]|0,+h[Ja+96>>3],+h[Ja+752>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(La,c[ib>>2]|0,+h[Ka+96>>3],+h[Ka+752>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+96>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+752>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+768>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}jA(Na,c[ib>>2]|0,+h[Qb+96>>3]);rb=+h[Na>>3];kA(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);rb=+h[Pa>>3];jA(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);Eb=+h[Qa>>3];kA(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);Eb=+h[Sa>>3];jA(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);qb=+h[Ta>>3];kA(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Va,c[ib>>2]|0,+h[Ua+96>>3],+h[Ua+752>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(Wa,c[ib>>2]|0,+h[Va+96>>3],+h[Va+752>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Xa,c[ib>>2]|0,qb,Bb,+h[Va+96>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+752>>3],0.0);Cb=+h[Xa>>3];jA(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);Bb=+h[Ya>>3];kA(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+112>>3];vb=+zd(1.0e-13,+(qb-rb));rb=vb*+zd(1.0e-13,+(qb-Eb));Eb=+h[Za+760>>3];vb=-(Eb*+zd(1.0e-13,+(qb-Lb)));Lb=+h[Za+104>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+nwa(c[ib>>2]|0,rb,39008,57344,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+104>>3];Tb=+h[Ya+112>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+zd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+nwa(c[ib>>2]|0,Vb,38704,57344,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+760>>3]-Pb}Pb=+h[Mb+96>>3];Wb=Pb+-273.15;Cb=+h[Mb+752>>3];sA($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];jA(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);Pb=+h[ab>>3];kA(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);Pb=+h[cb>>3];jA(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);Wb=+h[db>>3];kA(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]);lA(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+96>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+96>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+nwa(c[ib>>2]|0,rb,39616,57344,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+96>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+760>>3]-ub);ub=+h[Yb+752>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+nwa(c[ib>>2]|0,Xb,39616,57344,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+752>>3];ac=+h[Yb+96>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+Nxa(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+104>>3];Gb=+zd(1.0e-13,+(+h[Yb+112>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+nwa(c[ib>>2]|0,Gb,38704,57344,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +zd(+(ac- +yd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+96>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+nwa(c[ib>>2]|0,ec,39616,57344,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+96>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+760>>3];ic=+h[gc+752>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+nwa(c[ib>>2]|0,fc,39616,57344,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+752>>3];kc=+h[gc+96>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+Nxa(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+104>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+zd(1.0e-13,+(+h[gc+112>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9488|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9488|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+nwa(c[ib>>2]|0,Nb,38704,57344,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9488|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function FQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+10608>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+10584>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+10592>>3];h[a+8>>3]=+h[d+10832>>3];h[e+8>>3]=+h[d+10808>>3];h[f+8>>3]=+h[d+10816>>3];i=i;return}function GQ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0.0,l=0.0,m=0.0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+752>>3]=+h[b>>3];h[a+768>>3]=+h[b+8>>3];zQ(f);AQ(f);BQ(f);CQ(f);DQ(f);EQ(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;g=f+9128|0;b=f+96|0;a=f+1960|0;j=f+752|0;h[d>>3]=+h[f+8328>>3]+(+h[g>>3]*+h[b>>3]+(+h[a>>3]*+h[j>>3]- +h[f+9488>>3]));k=+h[a>>3];l=+h[b>>3];m=k*l;h[d+8>>3]=+h[f+9496>>3]*m*m+(+h[f+112>>3]*(k*+h[j>>3]+l*+h[g>>3])-m*+h[f+768>>3]);i=e;return}function HQ(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+50256>>3];h[c[b+8>>2]>>3]=+h[d+50232>>3];h[c[b+12>>2]>>3]=+h[d+50240>>3];i=i;return}function IQ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0,k=0,l=0,m=0.0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+3584>>3]=g;k=a+416|0;l=c[k>>2]|0;m=+h[l+816>>3];Kz(f,c[a+536>>2]|0,g,+h[j+3976>>3],+h[j+3984>>3],+h[j+3872>>3],+h[j+3880>>3],+h[j+10344>>3],+h[l+776>>3],+h[l+2056>>3]*2.5,(m+m)*.5,+h[l+2048>>3]/6.0,+h[l+2016>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+328>>3]- +h[f>>3]*+h[(c[k>>2]|0)+1992>>3];i=e;return}function JQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[63880]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=57624;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&127](mb,m,30320,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]}jA(t,c[ib>>2]|0,jb);jb=+h[t>>3];kA(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);jb=+h[v>>3];jA(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);pb=+h[w>>3];kA(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+176>>3];qb=+zd(1.0e-13,+(+h[w+184>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+nwa(c[ib>>2]|0,qb,30392,57352,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(pb- +yd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{jA(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);sb=+h[z>>3];kA(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);sb=+h[B>>3];jA(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);jb=+h[C>>3];kA(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+zd(1.0e-13,+(+h[C+184>>3]- +h[E>>3]));pb=1.0- +h[C+176>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+nwa(c[ib>>2]|0,jb,30392,57352,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{jA(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);vb=+h[F>>3];kA(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);vb=+h[H>>3];jA(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);sb=+h[I>>3];kA(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);sb=+h[K>>3];jA(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);jb=+h[L>>3];kA(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+184>>3]- +h[N>>3])|0)<<24>>24==0){jA(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);jb=+h[O>>3];kA(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Q,c[ib>>2]|0,+h[P+168>>3],+h[P+824>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(R,c[ib>>2]|0,+h[Q+168>>3],+h[Q+824>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(S,c[ib>>2]|0,jb,pb,+h[Q+168>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+824>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+840>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}jA(T,c[ib>>2]|0,+h[xb+168>>3]);qb=+h[T>>3];kA(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);qb=+h[V>>3];jA(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);pb=+h[W>>3];kA(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);pb=+h[Y>>3];jA(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);jb=+h[Z>>3];kA(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA($,c[ib>>2]|0,+h[_+168>>3],+h[_+824>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(aa,c[ib>>2]|0,+h[$+168>>3],+h[$+824>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(ba,c[ib>>2]|0,jb,rb,+h[$+168>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+824>>3],0.0);zb=+h[ba>>3];jA(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);rb=+h[ca>>3];kA(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+184>>3];Ab=+zd(1.0e-13,+(jb-qb));qb=Ab*+zd(1.0e-13,+(jb-pb));pb=+h[ea+832>>3];Ab=-(pb*+zd(1.0e-13,+(jb-sb)));sb=+h[ea+176>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+nwa(c[ib>>2]|0,qb,30696,57352,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+176>>3];Cb=+h[ca+184>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+zd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+nwa(c[ib>>2]|0,Eb,30392,57352,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+832>>3]-wb}wb=+h[tb+168>>3];if(wb>0.0){Gb=wb}else{tb=c[63880]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=57624;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&127](Db,l,30320,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]}if(Gb>0.0){Hb=Gb}else{r=c[63880]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=57624;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&127](l,j,30320,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]}jA(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];kA(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);Hb=+h[ia>>3];jA(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);Fb=+h[ja>>3];kA(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3];if(zb>0.0){Ib=zb}else{la=c[63880]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=57624;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&127](ka,g,30320,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]}if(Ib>0.0){Jb=Ib}else{p=c[63880]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=57624;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&127](g,f,30320,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]}if(Jb>0.0){Kb=Jb}else{o=c[63880]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=57624;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&127](f,e,30320,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]}qb=Kb+-273.15;lA(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];jA(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);qb=+h[na>>3];kA(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);qb=+h[pa>>3];jA(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);Eb=+h[qa>>3];kA(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+176>>3];rb=+zd(1.0e-13,+(+h[qa+184>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+nwa(c[ib>>2]|0,rb,30392,57352,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(Eb- +yd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{jA(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);Lb=+h[ta>>3];kA(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);Lb=+h[va>>3];jA(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);qb=+h[wa>>3];kA(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+zd(1.0e-13,+(+h[wa+184>>3]- +h[ya>>3]));Eb=1.0- +h[wa+176>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+nwa(c[ib>>2]|0,qb,30392,57352,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{jA(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);Ob=+h[za>>3];kA(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);Ob=+h[Ba>>3];jA(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);Lb=+h[Ca>>3];kA(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);Lb=+h[Ea>>3];jA(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);qb=+h[Fa>>3];kA(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+184>>3]- +h[Ha>>3])|0)<<24>>24==0){jA(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);qb=+h[Ia>>3];kA(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Ka,c[ib>>2]|0,+h[Ja+168>>3],+h[Ja+824>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(La,c[ib>>2]|0,+h[Ka+168>>3],+h[Ka+824>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+168>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+824>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+840>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}jA(Na,c[ib>>2]|0,+h[Qb+168>>3]);rb=+h[Na>>3];kA(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);rb=+h[Pa>>3];jA(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);Eb=+h[Qa>>3];kA(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);Eb=+h[Sa>>3];jA(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);qb=+h[Ta>>3];kA(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Va,c[ib>>2]|0,+h[Ua+168>>3],+h[Ua+824>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(Wa,c[ib>>2]|0,+h[Va+168>>3],+h[Va+824>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Xa,c[ib>>2]|0,qb,Bb,+h[Va+168>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+824>>3],0.0);Cb=+h[Xa>>3];jA(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);Bb=+h[Ya>>3];kA(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+184>>3];vb=+zd(1.0e-13,+(qb-rb));rb=vb*+zd(1.0e-13,+(qb-Eb));Eb=+h[Za+832>>3];vb=-(Eb*+zd(1.0e-13,+(qb-Lb)));Lb=+h[Za+176>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+nwa(c[ib>>2]|0,rb,30696,57352,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+176>>3];Tb=+h[Ya+184>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+zd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+nwa(c[ib>>2]|0,Vb,30392,57352,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+832>>3]-Pb}Pb=+h[Mb+168>>3];Wb=Pb+-273.15;Cb=+h[Mb+824>>3];sA($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];jA(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);Pb=+h[ab>>3];kA(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);Pb=+h[cb>>3];jA(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);Wb=+h[db>>3];kA(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+168>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+nwa(c[ib>>2]|0,rb,31304,57352,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+168>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+832>>3]-ub);ub=+h[Yb+824>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+nwa(c[ib>>2]|0,Xb,31304,57352,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+824>>3];ac=+h[Yb+168>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+Nxa(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+176>>3];Gb=+zd(1.0e-13,+(+h[Yb+184>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+nwa(c[ib>>2]|0,Gb,30392,57352,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +zd(+(ac- +yd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+168>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+nwa(c[ib>>2]|0,ec,31304,57352,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+168>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+832>>3];ic=+h[gc+824>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+nwa(c[ib>>2]|0,fc,31304,57352,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+824>>3];kc=+h[gc+168>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+Nxa(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+176>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+zd(1.0e-13,+(+h[gc+184>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9472|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9472|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+nwa(c[ib>>2]|0,Nb,30392,57352,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9472|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function KQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;iA(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+168>>3]);if((Aza(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+184>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+840>>3]*.999;l=j;m=l+9080|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;xA(e,c[f>>2]|0,+h[d+168>>3],+h[d+824>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+9080|0;n=m;h[n>>3]=k;i=b;return}}function LQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3e3>>3];k=+zd(1.0e-13,+(+h[g+184>>3]-j));l=+h[g+4408>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+nwa(c[b+536>>2]|0,k,45712,57360,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8272|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=Cza(1.0e-13,+h[f+184>>3]- +h[f+3e3>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+3e3>>3];j=+h[x+184>>3];k=+zd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+8960>>3];k=+h[x+4408>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+840>>3]- +h[x+9080>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+840>>3]- +h[x+9080>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+840>>3]- +h[x+9080>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+840>>3]- +h[x+9080>>3]}K=(y-k*J)/+nwa(c[b+536>>2]|0,l,45872,57360,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+4408>>3];C=+h[L+3e3>>3];D=+h[L+184>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+9080>>3];m=+zd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+nwa(c[b+536>>2]|0,m,45712,57360,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8272|0;w=v;h[w>>3]=n;i=d;return}function MQ(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(Cza(+h[a+176>>3]- +h[a+3016>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+9072|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+832>>3]- +h[a+8272>>3];g=a;j=g+9072|0;k=j;h[k>>3]=f;i=b;return}function NQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8264>>3]=+h[b+832>>3]- +h[b+9072>>3];i=i;return}function OQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3032>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+9072>>3];o=+h[g+8960>>3]*k+ +h[g+4408>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+nwa(c[b+536>>2]|0,l,46008,57368,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+9072>>3];q=+h[v+3032>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+8264>>3]*(1.0-q)+ +h[r+3024>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+9064|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+9064|0;C=B;h[C>>3]=z;i=d;return}p=t/+nwa(c[b+536>>2]|0,l,46008,57368,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+9064|0;C=B;h[C>>3]=z;i=d;return}function PQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+11840>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+11816>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+11824>>3];h[a+8>>3]=+h[d+11616>>3];h[e+8>>3]=+h[d+11592>>3];h[f+8>>3]=+h[d+11600>>3];i=i;return}function QQ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0.0,k=0.0,l=0.0,m=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+840>>3]=+h[b>>3];h[a+824>>3]=+h[b+8>>3];JQ(f);KQ(f);LQ(f);MQ(f);NQ(f);OQ(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;g=f+3064|0;j=+h[g>>3];b=f+168|0;k=+h[b>>3];l=j*k;a=f+824|0;m=f+9064|0;h[d>>3]=+h[f+9480>>3]*l*l+(+h[f+184>>3]*(j*+h[a>>3]+k*+h[m>>3])-l*+h[f+840>>3]);h[d+8>>3]=+h[f+8256>>3]+(+h[m>>3]*+h[b>>3]+(+h[g>>3]*+h[a>>3]- +h[f+9472>>3]));i=e;return}function RQ(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+63696>>3];h[c[b+8>>2]>>3]=+h[d+63672>>3];h[c[b+12>>2]>>3]=+h[d+63680>>3];i=i;return}function SQ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+4544>>3]=g;xz(f,c[a+536>>2]|0,g,+h[(c[a+416>>2]|0)+480>>3],+h[j+4744>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+4864>>3]- +h[f>>3];i=e;return}function TQ(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+78144>>3];h[c[b+8>>2]>>3]=+h[d+78120>>3];h[c[b+12>>2]>>3]=+h[d+78128>>3];i=i;return}function UQ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+5576>>3]=g;k=a+416|0;l=c[k>>2]|0;Kz(f,c[a+536>>2]|0,g,+h[j+5840>>3],+h[j+5848>>3],+h[j+5768>>3],+h[j+5776>>3],+h[j+10224>>3],+h[j+9912>>3],+h[l+1824>>3]*7.5,(+h[l+512>>3]+ +h[l+520>>3])*.5,+h[l+1816>>3]*.25,+h[l+1784>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+480>>3]- +h[f>>3]*+h[(c[k>>2]|0)+1760>>3];i=e;return}function VQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;iA(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+336>>3]);if((Aza(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+352>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+1008>>3]*.999;l=j;m=l+8920|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;xA(e,c[f>>2]|0,+h[d+336>>3],+h[d+992>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+8920|0;n=m;h[n>>3]=k;i=b;return}}function WQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5008>>3];k=+zd(1.0e-13,+(+h[g+352>>3]-j));l=+h[g+6288>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+nwa(c[b+536>>2]|0,k,35184,57376,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8104|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=Cza(1.0e-13,+h[f+352>>3]- +h[f+5008>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+5008>>3];j=+h[x+352>>3];k=+zd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+8800>>3];k=+h[x+6288>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+1008>>3]- +h[x+8920>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+1008>>3]- +h[x+8920>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+1008>>3]- +h[x+8920>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+1008>>3]- +h[x+8920>>3]}K=(y-k*J)/+nwa(c[b+536>>2]|0,l,35256,57376,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+6288>>3];C=+h[L+5008>>3];D=+h[L+352>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+8920>>3];m=+zd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+nwa(c[b+536>>2]|0,m,35184,57376,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8104|0;w=v;h[w>>3]=n;i=d;return}function XQ(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(Cza(+h[a+344>>3]- +h[a+5024>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+8912|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+1e3>>3]- +h[a+8104>>3];g=a;j=g+8912|0;k=j;h[k>>3]=f;i=b;return}function YQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8096>>3]=+h[b+1e3>>3]- +h[b+8912>>3];i=i;return}function ZQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5040>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+8912>>3];o=+h[g+8800>>3]*k+ +h[g+6288>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+nwa(c[b+536>>2]|0,l,35392,57384,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+8912>>3];q=+h[v+5040>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+8096>>3]*(1.0-q)+ +h[r+5032>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+8904|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+8904|0;C=B;h[C>>3]=z;i=d;return}p=t/+nwa(c[b+536>>2]|0,l,35392,57384,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+8904|0;C=B;h[C>>3]=z;i=d;return}



function UR(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[63880]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=57624;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&127](mb,m,29304,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]}jA(t,c[ib>>2]|0,jb);jb=+h[t>>3];kA(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);jb=+h[v>>3];jA(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);pb=+h[w>>3];kA(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+272>>3];qb=+zd(1.0e-13,+(+h[w+280>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+nwa(c[ib>>2]|0,qb,29376,57488,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(pb- +yd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{jA(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);sb=+h[z>>3];kA(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);sb=+h[B>>3];jA(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);jb=+h[C>>3];kA(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+zd(1.0e-13,+(+h[C+280>>3]- +h[E>>3]));pb=1.0- +h[C+272>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+nwa(c[ib>>2]|0,jb,29376,57488,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{jA(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);vb=+h[F>>3];kA(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);vb=+h[H>>3];jA(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);sb=+h[I>>3];kA(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);sb=+h[K>>3];jA(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);jb=+h[L>>3];kA(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+280>>3]- +h[N>>3])|0)<<24>>24==0){jA(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);jb=+h[O>>3];kA(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Q,c[ib>>2]|0,+h[P+264>>3],+h[P+920>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(R,c[ib>>2]|0,+h[Q+264>>3],+h[Q+920>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(S,c[ib>>2]|0,jb,pb,+h[Q+264>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+920>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+936>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}jA(T,c[ib>>2]|0,+h[xb+264>>3]);qb=+h[T>>3];kA(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);qb=+h[V>>3];jA(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);pb=+h[W>>3];kA(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);pb=+h[Y>>3];jA(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);jb=+h[Z>>3];kA(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA($,c[ib>>2]|0,+h[_+264>>3],+h[_+920>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(aa,c[ib>>2]|0,+h[$+264>>3],+h[$+920>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(ba,c[ib>>2]|0,jb,rb,+h[$+264>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+920>>3],0.0);zb=+h[ba>>3];jA(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);rb=+h[ca>>3];kA(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+280>>3];Ab=+zd(1.0e-13,+(jb-qb));qb=Ab*+zd(1.0e-13,+(jb-pb));pb=+h[ea+928>>3];Ab=-(pb*+zd(1.0e-13,+(jb-sb)));sb=+h[ea+272>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+nwa(c[ib>>2]|0,qb,29680,57488,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+272>>3];Cb=+h[ca+280>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+zd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+nwa(c[ib>>2]|0,Eb,29376,57488,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+928>>3]-wb}wb=+h[tb+264>>3];if(wb>0.0){Gb=wb}else{tb=c[63880]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=57624;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&127](Db,l,29304,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]}if(Gb>0.0){Hb=Gb}else{r=c[63880]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=57624;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&127](l,j,29304,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]}jA(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];kA(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);Hb=+h[ia>>3];jA(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);Fb=+h[ja>>3];kA(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3];if(zb>0.0){Ib=zb}else{la=c[63880]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=57624;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&127](ka,g,29304,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]}if(Ib>0.0){Jb=Ib}else{p=c[63880]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=57624;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&127](g,f,29304,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]}if(Jb>0.0){Kb=Jb}else{o=c[63880]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=57624;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&127](f,e,29304,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]}qb=Kb+-273.15;lA(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];jA(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);qb=+h[na>>3];kA(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);qb=+h[pa>>3];jA(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);Eb=+h[qa>>3];kA(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+272>>3];rb=+zd(1.0e-13,+(+h[qa+280>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+nwa(c[ib>>2]|0,rb,29376,57488,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(Eb- +yd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{jA(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);Lb=+h[ta>>3];kA(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);Lb=+h[va>>3];jA(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);qb=+h[wa>>3];kA(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+zd(1.0e-13,+(+h[wa+280>>3]- +h[ya>>3]));Eb=1.0- +h[wa+272>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+nwa(c[ib>>2]|0,qb,29376,57488,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{jA(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);Ob=+h[za>>3];kA(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);Ob=+h[Ba>>3];jA(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);Lb=+h[Ca>>3];kA(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);Lb=+h[Ea>>3];jA(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);qb=+h[Fa>>3];kA(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+280>>3]- +h[Ha>>3])|0)<<24>>24==0){jA(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);qb=+h[Ia>>3];kA(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Ka,c[ib>>2]|0,+h[Ja+264>>3],+h[Ja+920>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(La,c[ib>>2]|0,+h[Ka+264>>3],+h[Ka+920>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+264>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+920>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+936>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}jA(Na,c[ib>>2]|0,+h[Qb+264>>3]);rb=+h[Na>>3];kA(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);rb=+h[Pa>>3];jA(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);Eb=+h[Qa>>3];kA(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);Eb=+h[Sa>>3];jA(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);qb=+h[Ta>>3];kA(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Va,c[ib>>2]|0,+h[Ua+264>>3],+h[Ua+920>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(Wa,c[ib>>2]|0,+h[Va+264>>3],+h[Va+920>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Xa,c[ib>>2]|0,qb,Bb,+h[Va+264>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+920>>3],0.0);Cb=+h[Xa>>3];jA(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);Bb=+h[Ya>>3];kA(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+280>>3];vb=+zd(1.0e-13,+(qb-rb));rb=vb*+zd(1.0e-13,+(qb-Eb));Eb=+h[Za+928>>3];vb=-(Eb*+zd(1.0e-13,+(qb-Lb)));Lb=+h[Za+272>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+nwa(c[ib>>2]|0,rb,29680,57488,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+272>>3];Tb=+h[Ya+280>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+zd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+nwa(c[ib>>2]|0,Vb,29376,57488,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+928>>3]-Pb}Pb=+h[Mb+264>>3];Wb=Pb+-273.15;Cb=+h[Mb+920>>3];sA($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];jA(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);Pb=+h[ab>>3];kA(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);Pb=+h[cb>>3];jA(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);Wb=+h[db>>3];kA(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+264>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+nwa(c[ib>>2]|0,rb,30288,57488,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+264>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+928>>3]-ub);ub=+h[Yb+920>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+nwa(c[ib>>2]|0,Xb,30288,57488,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+920>>3];ac=+h[Yb+264>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+Nxa(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+272>>3];Gb=+zd(1.0e-13,+(+h[Yb+280>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+nwa(c[ib>>2]|0,Gb,29376,57488,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +zd(+(ac- +yd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+264>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+nwa(c[ib>>2]|0,ec,30288,57488,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+264>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+928>>3];ic=+h[gc+920>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+nwa(c[ib>>2]|0,fc,30288,57488,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+920>>3];kc=+h[gc+264>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+Nxa(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+272>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+zd(1.0e-13,+(+h[gc+280>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9408|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9408|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+nwa(c[ib>>2]|0,Nb,29376,57488,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9408|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function VR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+12960>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+12936>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+12944>>3];h[a+8>>3]=+h[d+13184>>3];h[e+8>>3]=+h[d+13160>>3];h[f+8>>3]=+h[d+13168>>3];i=i;return}function WR(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0.0,l=0.0,m=0.0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+920>>3]=+h[b>>3];h[a+936>>3]=+h[b+8>>3];PR(f);QR(f);RR(f);SR(f);TR(f);UR(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;g=f+8968|0;b=f+264|0;a=f+3512|0;j=f+920|0;h[d>>3]=+h[f+8160>>3]+(+h[g>>3]*+h[b>>3]+(+h[a>>3]*+h[j>>3]- +h[f+9408>>3]));k=+h[a>>3];l=+h[b>>3];m=k*l;h[d+8>>3]=+h[f+9416>>3]*m*m+(+h[f+280>>3]*(k*+h[j>>3]+l*+h[g>>3])-m*+h[f+936>>3]);i=e;return}function XR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;iA(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+432>>3]);if((Aza(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+448>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+1104>>3]*.999;l=j;m=l+8824|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;xA(e,c[f>>2]|0,+h[d+432>>3],+h[d+1088>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+8824|0;n=m;h[n>>3]=k;i=b;return}}function YR(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5456>>3];k=+zd(1.0e-13,+(+h[g+448>>3]-j));l=+h[g+6320>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+nwa(c[b+536>>2]|0,k,50056,57496,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8008|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=Cza(1.0e-13,+h[f+448>>3]- +h[f+5456>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+5456>>3];j=+h[x+448>>3];k=+zd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+8768>>3];k=+h[x+6320>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+1104>>3]- +h[x+8824>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+1104>>3]- +h[x+8824>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+1104>>3]- +h[x+8824>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+1104>>3]- +h[x+8824>>3]}K=(y-k*J)/+nwa(c[b+536>>2]|0,l,50216,57496,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+6320>>3];C=+h[L+5456>>3];D=+h[L+448>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+8824>>3];m=+zd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+nwa(c[b+536>>2]|0,m,50056,57496,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8008|0;w=v;h[w>>3]=n;i=d;return}function ZR(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(Cza(+h[a+440>>3]- +h[a+5472>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+8816|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+1096>>3]- +h[a+8008>>3];g=a;j=g+8816|0;k=j;h[k>>3]=f;i=b;return}function _R(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8e3>>3]=+h[b+1096>>3]- +h[b+8816>>3];i=i;return}function $R(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5488>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+8816>>3];o=+h[g+8768>>3]*k+ +h[g+6320>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+nwa(c[b+536>>2]|0,l,50352,57504,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+8816>>3];q=+h[v+5488>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+8e3>>3]*(1.0-q)+ +h[r+5480>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+8808|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+8808|0;C=B;h[C>>3]=z;i=d;return}p=t/+nwa(c[b+536>>2]|0,l,50352,57504,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+8808|0;C=B;h[C>>3]=z;i=d;return}function aS(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[63880]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=57624;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&127](mb,m,23024,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]}jA(t,c[ib>>2]|0,jb);jb=+h[t>>3];kA(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);jb=+h[v>>3];jA(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);pb=+h[w>>3];kA(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+440>>3];qb=+zd(1.0e-13,+(+h[w+448>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+nwa(c[ib>>2]|0,qb,23096,57512,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(pb- +yd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{jA(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);sb=+h[z>>3];kA(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);sb=+h[B>>3];jA(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);jb=+h[C>>3];kA(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+zd(1.0e-13,+(+h[C+448>>3]- +h[E>>3]));pb=1.0- +h[C+440>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+nwa(c[ib>>2]|0,jb,23096,57512,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{jA(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);vb=+h[F>>3];kA(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);vb=+h[H>>3];jA(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);sb=+h[I>>3];kA(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);sb=+h[K>>3];jA(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);jb=+h[L>>3];kA(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+448>>3]- +h[N>>3])|0)<<24>>24==0){jA(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);jb=+h[O>>3];kA(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Q,c[ib>>2]|0,+h[P+432>>3],+h[P+1088>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(R,c[ib>>2]|0,+h[Q+432>>3],+h[Q+1088>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(S,c[ib>>2]|0,jb,pb,+h[Q+432>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+1088>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+1104>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}jA(T,c[ib>>2]|0,+h[xb+432>>3]);qb=+h[T>>3];kA(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);qb=+h[V>>3];jA(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);pb=+h[W>>3];kA(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);pb=+h[Y>>3];jA(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);jb=+h[Z>>3];kA(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA($,c[ib>>2]|0,+h[_+432>>3],+h[_+1088>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(aa,c[ib>>2]|0,+h[$+432>>3],+h[$+1088>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(ba,c[ib>>2]|0,jb,rb,+h[$+432>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+1088>>3],0.0);zb=+h[ba>>3];jA(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);rb=+h[ca>>3];kA(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+448>>3];Ab=+zd(1.0e-13,+(jb-qb));qb=Ab*+zd(1.0e-13,+(jb-pb));pb=+h[ea+1096>>3];Ab=-(pb*+zd(1.0e-13,+(jb-sb)));sb=+h[ea+440>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+nwa(c[ib>>2]|0,qb,23400,57512,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+440>>3];Cb=+h[ca+448>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+zd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+nwa(c[ib>>2]|0,Eb,23096,57512,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+1096>>3]-wb}wb=+h[tb+432>>3];if(wb>0.0){Gb=wb}else{tb=c[63880]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=57624;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&127](Db,l,23024,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]}if(Gb>0.0){Hb=Gb}else{r=c[63880]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=57624;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&127](l,j,23024,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]}jA(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];kA(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);Hb=+h[ia>>3];jA(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);Fb=+h[ja>>3];kA(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3];if(zb>0.0){Ib=zb}else{la=c[63880]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=57624;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&127](ka,g,23024,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]}if(Ib>0.0){Jb=Ib}else{p=c[63880]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=57624;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&127](g,f,23024,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]}if(Jb>0.0){Kb=Jb}else{o=c[63880]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=57624;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&127](f,e,23024,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]}qb=Kb+-273.15;lA(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];jA(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);qb=+h[na>>3];kA(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);qb=+h[pa>>3];jA(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);Eb=+h[qa>>3];kA(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+440>>3];rb=+zd(1.0e-13,+(+h[qa+448>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+nwa(c[ib>>2]|0,rb,23096,57512,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(Eb- +yd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{jA(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);Lb=+h[ta>>3];kA(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);Lb=+h[va>>3];jA(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);qb=+h[wa>>3];kA(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+zd(1.0e-13,+(+h[wa+448>>3]- +h[ya>>3]));Eb=1.0- +h[wa+440>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+nwa(c[ib>>2]|0,qb,23096,57512,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{jA(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);Ob=+h[za>>3];kA(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);Ob=+h[Ba>>3];jA(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);Lb=+h[Ca>>3];kA(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);Lb=+h[Ea>>3];jA(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);qb=+h[Fa>>3];kA(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+448>>3]- +h[Ha>>3])|0)<<24>>24==0){jA(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);qb=+h[Ia>>3];kA(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Ka,c[ib>>2]|0,+h[Ja+432>>3],+h[Ja+1088>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(La,c[ib>>2]|0,+h[Ka+432>>3],+h[Ka+1088>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+432>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+1088>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+1104>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}jA(Na,c[ib>>2]|0,+h[Qb+432>>3]);rb=+h[Na>>3];kA(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);rb=+h[Pa>>3];jA(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);Eb=+h[Qa>>3];kA(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);Eb=+h[Sa>>3];jA(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);qb=+h[Ta>>3];kA(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Va,c[ib>>2]|0,+h[Ua+432>>3],+h[Ua+1088>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(Wa,c[ib>>2]|0,+h[Va+432>>3],+h[Va+1088>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Xa,c[ib>>2]|0,qb,Bb,+h[Va+432>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+1088>>3],0.0);Cb=+h[Xa>>3];jA(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);Bb=+h[Ya>>3];kA(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+448>>3];vb=+zd(1.0e-13,+(qb-rb));rb=vb*+zd(1.0e-13,+(qb-Eb));Eb=+h[Za+1096>>3];vb=-(Eb*+zd(1.0e-13,+(qb-Lb)));Lb=+h[Za+440>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+nwa(c[ib>>2]|0,rb,23400,57512,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+440>>3];Tb=+h[Ya+448>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+zd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+nwa(c[ib>>2]|0,Vb,23096,57512,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+1096>>3]-Pb}Pb=+h[Mb+432>>3];Wb=Pb+-273.15;Cb=+h[Mb+1088>>3];sA($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];jA(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);Pb=+h[ab>>3];kA(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);Pb=+h[cb>>3];jA(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);Wb=+h[db>>3];kA(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]);lA(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+432>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+432>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+nwa(c[ib>>2]|0,rb,24008,57512,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+432>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+1096>>3]-ub);ub=+h[Yb+1088>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+nwa(c[ib>>2]|0,Xb,24008,57512,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+1088>>3];ac=+h[Yb+432>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+Nxa(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+440>>3];Gb=+zd(1.0e-13,+(+h[Yb+448>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+nwa(c[ib>>2]|0,Gb,23096,57512,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +zd(+(ac- +yd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+432>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+nwa(c[ib>>2]|0,ec,24008,57512,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+432>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+1096>>3];ic=+h[gc+1088>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+nwa(c[ib>>2]|0,fc,24008,57512,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+1088>>3];kc=+h[gc+432>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+Nxa(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+440>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+zd(1.0e-13,+(+h[gc+448>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9328|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9328|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+nwa(c[ib>>2]|0,Nb,23096,57512,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9328|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function bS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+15312>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+15288>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+15296>>3];h[a+8>>3]=+h[d+15536>>3];h[e+8>>3]=+h[d+15512>>3];h[f+8>>3]=+h[d+15520>>3];i=i;return}function cS(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0.0,l=0.0,m=0.0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+1088>>3]=+h[b>>3];h[a+1104>>3]=+h[b+8>>3];XR(f);YR(f);ZR(f);_R(f);$R(f);aS(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;g=f+8808|0;b=f+432|0;a=f+5520|0;j=f+1088|0;h[d>>3]=+h[f+7992>>3]+(+h[g>>3]*+h[b>>3]+(+h[a>>3]*+h[j>>3]- +h[f+9328>>3]));k=+h[a>>3];l=+h[b>>3];m=k*l;h[d+8>>3]=+h[f+9336>>3]*m*m+(+h[f+448>>3]*(k*+h[j>>3]+l*+h[g>>3])-m*+h[f+1104>>3]);i=e;return}function dS(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+98640>>3];h[c[b+8>>2]>>3]=+h[d+98616>>3];h[c[b+12>>2]>>3]=+h[d+98624>>3];i=i;return}function eS(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0,k=0,l=0,m=0.0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+7040>>3]=g;k=a+416|0;l=c[k>>2]|0;m=+h[l+224>>3];Kz(f,c[a+536>>2]|0,g,+h[j+9608>>3],+h[j+9616>>3],+h[j+9664>>3],+h[j+9672>>3],+h[j+10048>>3],+h[l+184>>3],+h[l+1600>>3]*5.0,(m+m)*.5,+h[l+1592>>3]/6.0,+h[l+1560>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+648>>3]- +h[f>>3]*+h[(c[k>>2]|0)+1536>>3];i=e;return}function fS(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+98528>>3];h[c[b+8>>2]>>3]=+h[d+98504>>3];h[c[b+12>>2]>>3]=+h[d+98512>>3];i=i;return}function gS(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+7032>>3]=g;k=a+416|0;l=c[k>>2]|0;Kz(f,c[a+536>>2]|0,g,+h[j+9600>>3],+h[j+9608>>3],+h[j+9656>>3],+h[j+9664>>3],+h[j+10040>>3],+h[j+9928>>3],+h[l+1600>>3]*10.0,(+h[l+216>>3]+ +h[l+224>>3])*.5,+h[l+1592>>3]/6.0,+h[l+1560>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+640>>3]- +h[f>>3]*+h[(c[k>>2]|0)+1536>>3];i=e;return}function hS(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[63880]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=57624;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&127](mb,m,47840,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]}jA(t,c[ib>>2]|0,jb);jb=+h[t>>3];kA(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);jb=+h[v>>3];jA(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);pb=+h[w>>3];kA(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+496>>3];qb=+zd(1.0e-13,+(+h[w+504>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+nwa(c[ib>>2]|0,qb,47912,57520,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(pb- +yd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{jA(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);sb=+h[z>>3];kA(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);sb=+h[B>>3];jA(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);jb=+h[C>>3];kA(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+zd(1.0e-13,+(+h[C+504>>3]- +h[E>>3]));pb=1.0- +h[C+496>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+nwa(c[ib>>2]|0,jb,47912,57520,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{jA(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);vb=+h[F>>3];kA(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);vb=+h[H>>3];jA(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);sb=+h[I>>3];kA(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);sb=+h[K>>3];jA(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);jb=+h[L>>3];kA(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+504>>3]- +h[N>>3])|0)<<24>>24==0){jA(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);jb=+h[O>>3];kA(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Q,c[ib>>2]|0,+h[P+488>>3],+h[P+1144>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(R,c[ib>>2]|0,+h[Q+488>>3],+h[Q+1144>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(S,c[ib>>2]|0,jb,pb,+h[Q+488>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+1144>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+1160>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}jA(T,c[ib>>2]|0,+h[xb+488>>3]);qb=+h[T>>3];kA(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);qb=+h[V>>3];jA(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);pb=+h[W>>3];kA(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);pb=+h[Y>>3];jA(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);jb=+h[Z>>3];kA(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA($,c[ib>>2]|0,+h[_+488>>3],+h[_+1144>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(aa,c[ib>>2]|0,+h[$+488>>3],+h[$+1144>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(ba,c[ib>>2]|0,jb,rb,+h[$+488>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+1144>>3],0.0);zb=+h[ba>>3];jA(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);rb=+h[ca>>3];kA(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+504>>3];Ab=+zd(1.0e-13,+(jb-qb));qb=Ab*+zd(1.0e-13,+(jb-pb));pb=+h[ea+1152>>3];Ab=-(pb*+zd(1.0e-13,+(jb-sb)));sb=+h[ea+496>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+nwa(c[ib>>2]|0,qb,48216,57520,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+496>>3];Cb=+h[ca+504>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+zd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+nwa(c[ib>>2]|0,Eb,47912,57520,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+1152>>3]-wb}wb=+h[tb+488>>3];if(wb>0.0){Gb=wb}else{tb=c[63880]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=57624;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&127](Db,l,47840,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]}if(Gb>0.0){Hb=Gb}else{r=c[63880]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=57624;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&127](l,j,47840,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]}jA(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];kA(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);Hb=+h[ia>>3];jA(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);Fb=+h[ja>>3];kA(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3];if(zb>0.0){Ib=zb}else{la=c[63880]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=57624;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&127](ka,g,47840,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]}if(Ib>0.0){Jb=Ib}else{p=c[63880]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=57624;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&127](g,f,47840,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]}if(Jb>0.0){Kb=Jb}else{o=c[63880]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=57624;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&127](f,e,47840,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]}qb=Kb+-273.15;lA(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];jA(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);qb=+h[na>>3];kA(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);qb=+h[pa>>3];jA(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);Eb=+h[qa>>3];kA(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+496>>3];rb=+zd(1.0e-13,+(+h[qa+504>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+nwa(c[ib>>2]|0,rb,47912,57520,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(Eb- +yd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{jA(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);Lb=+h[ta>>3];kA(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);Lb=+h[va>>3];jA(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);qb=+h[wa>>3];kA(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+zd(1.0e-13,+(+h[wa+504>>3]- +h[ya>>3]));Eb=1.0- +h[wa+496>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+nwa(c[ib>>2]|0,qb,47912,57520,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{jA(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);Ob=+h[za>>3];kA(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);Ob=+h[Ba>>3];jA(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);Lb=+h[Ca>>3];kA(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);Lb=+h[Ea>>3];jA(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);qb=+h[Fa>>3];kA(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+504>>3]- +h[Ha>>3])|0)<<24>>24==0){jA(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);qb=+h[Ia>>3];kA(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Ka,c[ib>>2]|0,+h[Ja+488>>3],+h[Ja+1144>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(La,c[ib>>2]|0,+h[Ka+488>>3],+h[Ka+1144>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+488>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+1144>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+1160>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}jA(Na,c[ib>>2]|0,+h[Qb+488>>3]);rb=+h[Na>>3];kA(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);rb=+h[Pa>>3];jA(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);Eb=+h[Qa>>3];kA(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);Eb=+h[Sa>>3];jA(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);qb=+h[Ta>>3];kA(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Va,c[ib>>2]|0,+h[Ua+488>>3],+h[Ua+1144>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(Wa,c[ib>>2]|0,+h[Va+488>>3],+h[Va+1144>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Xa,c[ib>>2]|0,qb,Bb,+h[Va+488>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+1144>>3],0.0);Cb=+h[Xa>>3];jA(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);Bb=+h[Ya>>3];kA(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+504>>3];vb=+zd(1.0e-13,+(qb-rb));rb=vb*+zd(1.0e-13,+(qb-Eb));Eb=+h[Za+1152>>3];vb=-(Eb*+zd(1.0e-13,+(qb-Lb)));Lb=+h[Za+496>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+nwa(c[ib>>2]|0,rb,48216,57520,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+496>>3];Tb=+h[Ya+504>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+zd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+nwa(c[ib>>2]|0,Vb,47912,57520,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+1152>>3]-Pb}Pb=+h[Mb+488>>3];Wb=Pb+-273.15;Cb=+h[Mb+1144>>3];sA($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];jA(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);Pb=+h[ab>>3];kA(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);Pb=+h[cb>>3];jA(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);Wb=+h[db>>3];kA(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]);lA(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+488>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+488>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+nwa(c[ib>>2]|0,rb,48824,57520,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+488>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+1152>>3]-ub);ub=+h[Yb+1144>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+nwa(c[ib>>2]|0,Xb,48824,57520,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+1144>>3];ac=+h[Yb+488>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+Nxa(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+496>>3];Gb=+zd(1.0e-13,+(+h[Yb+504>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+nwa(c[ib>>2]|0,Gb,47912,57520,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +zd(+(ac- +yd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+488>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+nwa(c[ib>>2]|0,ec,48824,57520,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+488>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+1152>>3];ic=+h[gc+1144>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+nwa(c[ib>>2]|0,fc,48824,57520,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+1144>>3];kc=+h[gc+488>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+Nxa(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+496>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+zd(1.0e-13,+(+h[gc+504>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9312|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9312|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+nwa(c[ib>>2]|0,Nb,47912,57520,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9312|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function iS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;iA(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+488>>3]);if((Aza(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+504>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+1160>>3]*.999;l=j;m=l+8760|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;xA(e,c[f>>2]|0,+h[d+488>>3],+h[d+1144>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+8760|0;n=m;h[n>>3]=k;i=b;return}}function jS(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6456>>3];k=+zd(1.0e-13,+(+h[g+504>>3]-j));l=+h[g+7752>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+nwa(c[b+536>>2]|0,k,49256,57528,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+7952|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=Cza(1.0e-13,+h[f+504>>3]- +h[f+6456>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+6456>>3];j=+h[x+504>>3];k=+zd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+8640>>3];k=+h[x+7752>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+1160>>3]- +h[x+8760>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+1160>>3]- +h[x+8760>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+1160>>3]- +h[x+8760>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+1160>>3]- +h[x+8760>>3]}K=(y-k*J)/+nwa(c[b+536>>2]|0,l,49416,57528,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+7752>>3];C=+h[L+6456>>3];D=+h[L+504>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+8760>>3];m=+zd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+nwa(c[b+536>>2]|0,m,49256,57528,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+7952|0;w=v;h[w>>3]=n;i=d;return}function kS(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(Cza(+h[a+496>>3]- +h[a+6472>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+8752|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+1152>>3]- +h[a+7952>>3];g=a;j=g+8752|0;k=j;h[k>>3]=f;i=b;return}function lS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7944>>3]=+h[b+1152>>3]- +h[b+8752>>3];i=i;return}function mS(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6488>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+8752>>3];o=+h[g+8640>>3]*k+ +h[g+7752>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+nwa(c[b+536>>2]|0,l,49552,57536,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+8752>>3];q=+h[v+6488>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+7944>>3]*(1.0-q)+ +h[r+6480>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+8744|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+8744|0;C=B;h[C>>3]=z;i=d;return}p=t/+nwa(c[b+536>>2]|0,l,49552,57536,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+8744|0;C=B;h[C>>3]=z;i=d;return}function nS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+16320>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+16296>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+16304>>3];h[a+8>>3]=+h[d+16096>>3];h[e+8>>3]=+h[d+16072>>3];h[f+8>>3]=+h[d+16080>>3];i=i;return}function oS(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0.0,k=0.0,l=0.0,m=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+1160>>3]=+h[b>>3];h[a+1144>>3]=+h[b+8>>3];hS(f);iS(f);jS(f);kS(f);lS(f);mS(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;g=f+6520|0;j=+h[g>>3];b=f+488|0;k=+h[b>>3];l=j*k;a=f+1144|0;m=f+8744|0;h[d>>3]=+h[f+9320>>3]*l*l+(+h[f+504>>3]*(j*+h[a>>3]+k*+h[m>>3])-l*+h[f+1160>>3]);h[d+8>>3]=+h[f+7936>>3]+(+h[m>>3]*+h[b>>3]+(+h[g>>3]*+h[a>>3]- +h[f+9312>>3]));i=e;return}function pS(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+98416>>3];h[c[b+8>>2]>>3]=+h[d+98392>>3];h[c[b+12>>2]>>3]=+h[d+98400>>3];i=i;return}function qS(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+7024>>3]=g;k=a+416|0;l=c[k>>2]|0;Kz(f,c[a+536>>2]|0,g,+h[j+9592>>3],+h[j+9600>>3],+h[j+9648>>3],+h[j+9656>>3],+h[j+10032>>3],+h[j+9936>>3],+h[l+1600>>3]*10.0,(+h[l+208>>3]+ +h[l+216>>3])*.5,+h[l+1592>>3]/6.0,+h[l+1560>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+632>>3]- +h[f>>3]*+h[(c[k>>2]|0)+1536>>3];i=e;return}function rS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;iA(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+512>>3]);if((Aza(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+528>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+1184>>3]*.999;l=j;m=l+8736|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;xA(e,c[f>>2]|0,+h[d+512>>3],+h[d+1168>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+8736|0;n=m;h[n>>3]=k;i=b;return}}function sS(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6568>>3];k=+zd(1.0e-13,+(+h[g+528>>3]-j));l=+h[g+7760>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+nwa(c[b+536>>2]|0,k,48856,57544,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+7928|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=Cza(1.0e-13,+h[f+528>>3]- +h[f+6568>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+6568>>3];j=+h[x+528>>3];k=+zd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+8632>>3];k=+h[x+7760>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+1184>>3]- +h[x+8736>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+1184>>3]- +h[x+8736>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+1184>>3]- +h[x+8736>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+1184>>3]- +h[x+8736>>3]}K=(y-k*J)/+nwa(c[b+536>>2]|0,l,49016,57544,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+7760>>3];C=+h[L+6568>>3];D=+h[L+528>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+8736>>3];m=+zd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+nwa(c[b+536>>2]|0,m,48856,57544,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+7928|0;w=v;h[w>>3]=n;i=d;return}function tS(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(Cza(+h[a+520>>3]- +h[a+6584>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+8728|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+1176>>3]- +h[a+7928>>3];g=a;j=g+8728|0;k=j;h[k>>3]=f;i=b;return}function uS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7920>>3]=+h[b+1176>>3]- +h[b+8728>>3];i=i;return}function vS(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6600>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+8728>>3];o=+h[g+8632>>3]*k+ +h[g+7760>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+nwa(c[b+536>>2]|0,l,49152,57552,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+8728>>3];q=+h[v+6600>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+7920>>3]*(1.0-q)+ +h[r+6592>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+8720|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+8720|0;C=B;h[C>>3]=z;i=d;return}p=t/+nwa(c[b+536>>2]|0,l,49152,57552,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+8720|0;C=B;h[C>>3]=z;i=d;return}function wS(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[63880]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=57624;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&127](mb,m,24040,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]}jA(t,c[ib>>2]|0,jb);jb=+h[t>>3];kA(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);jb=+h[v>>3];jA(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);pb=+h[w>>3];kA(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+520>>3];qb=+zd(1.0e-13,+(+h[w+528>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+nwa(c[ib>>2]|0,qb,24112,57560,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(pb- +yd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{jA(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);sb=+h[z>>3];kA(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);sb=+h[B>>3];jA(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);jb=+h[C>>3];kA(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+zd(1.0e-13,+(+h[C+528>>3]- +h[E>>3]));pb=1.0- +h[C+520>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+nwa(c[ib>>2]|0,jb,24112,57560,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{jA(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);vb=+h[F>>3];kA(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);vb=+h[H>>3];jA(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);sb=+h[I>>3];kA(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);sb=+h[K>>3];jA(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);jb=+h[L>>3];kA(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+528>>3]- +h[N>>3])|0)<<24>>24==0){jA(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);jb=+h[O>>3];kA(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Q,c[ib>>2]|0,+h[P+512>>3],+h[P+1168>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(R,c[ib>>2]|0,+h[Q+512>>3],+h[Q+1168>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(S,c[ib>>2]|0,jb,pb,+h[Q+512>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+1168>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+1184>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}jA(T,c[ib>>2]|0,+h[xb+512>>3]);qb=+h[T>>3];kA(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);qb=+h[V>>3];jA(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);pb=+h[W>>3];kA(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);pb=+h[Y>>3];jA(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);jb=+h[Z>>3];kA(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA($,c[ib>>2]|0,+h[_+512>>3],+h[_+1168>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(aa,c[ib>>2]|0,+h[$+512>>3],+h[$+1168>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(ba,c[ib>>2]|0,jb,rb,+h[$+512>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+1168>>3],0.0);zb=+h[ba>>3];jA(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);rb=+h[ca>>3];kA(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+528>>3];Ab=+zd(1.0e-13,+(jb-qb));qb=Ab*+zd(1.0e-13,+(jb-pb));pb=+h[ea+1176>>3];Ab=-(pb*+zd(1.0e-13,+(jb-sb)));sb=+h[ea+520>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+nwa(c[ib>>2]|0,qb,24416,57560,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+520>>3];Cb=+h[ca+528>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+zd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+nwa(c[ib>>2]|0,Eb,24112,57560,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+1176>>3]-wb}wb=+h[tb+512>>3];if(wb>0.0){Gb=wb}else{tb=c[63880]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=57624;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&127](Db,l,24040,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]}if(Gb>0.0){Hb=Gb}else{r=c[63880]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=57624;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&127](l,j,24040,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]}jA(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];kA(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);Hb=+h[ia>>3];jA(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);Fb=+h[ja>>3];kA(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3];if(zb>0.0){Ib=zb}else{la=c[63880]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=57624;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&127](ka,g,24040,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]}if(Ib>0.0){Jb=Ib}else{p=c[63880]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=57624;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&127](g,f,24040,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]}if(Jb>0.0){Kb=Jb}else{o=c[63880]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=57624;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&127](f,e,24040,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]}qb=Kb+-273.15;lA(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];jA(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);qb=+h[na>>3];kA(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);qb=+h[pa>>3];jA(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);Eb=+h[qa>>3];kA(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+520>>3];rb=+zd(1.0e-13,+(+h[qa+528>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+nwa(c[ib>>2]|0,rb,24112,57560,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(Eb- +yd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{jA(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);Lb=+h[ta>>3];kA(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);Lb=+h[va>>3];jA(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);qb=+h[wa>>3];kA(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+zd(1.0e-13,+(+h[wa+528>>3]- +h[ya>>3]));Eb=1.0- +h[wa+520>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+nwa(c[ib>>2]|0,qb,24112,57560,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{jA(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);Ob=+h[za>>3];kA(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);Ob=+h[Ba>>3];jA(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);Lb=+h[Ca>>3];kA(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);Lb=+h[Ea>>3];jA(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);qb=+h[Fa>>3];kA(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+528>>3]- +h[Ha>>3])|0)<<24>>24==0){jA(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);qb=+h[Ia>>3];kA(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Ka,c[ib>>2]|0,+h[Ja+512>>3],+h[Ja+1168>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(La,c[ib>>2]|0,+h[Ka+512>>3],+h[Ka+1168>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+512>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+1168>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+1184>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}jA(Na,c[ib>>2]|0,+h[Qb+512>>3]);rb=+h[Na>>3];kA(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);rb=+h[Pa>>3];jA(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);Eb=+h[Qa>>3];kA(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);Eb=+h[Sa>>3];jA(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);qb=+h[Ta>>3];kA(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Va,c[ib>>2]|0,+h[Ua+512>>3],+h[Ua+1168>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(Wa,c[ib>>2]|0,+h[Va+512>>3],+h[Va+1168>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Xa,c[ib>>2]|0,qb,Bb,+h[Va+512>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+1168>>3],0.0);Cb=+h[Xa>>3];jA(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);Bb=+h[Ya>>3];kA(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+528>>3];vb=+zd(1.0e-13,+(qb-rb));rb=vb*+zd(1.0e-13,+(qb-Eb));Eb=+h[Za+1176>>3];vb=-(Eb*+zd(1.0e-13,+(qb-Lb)));Lb=+h[Za+520>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+nwa(c[ib>>2]|0,rb,24416,57560,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+520>>3];Tb=+h[Ya+528>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+zd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+nwa(c[ib>>2]|0,Vb,24112,57560,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+1176>>3]-Pb}Pb=+h[Mb+512>>3];Wb=Pb+-273.15;Cb=+h[Mb+1168>>3];sA($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];jA(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);Pb=+h[ab>>3];kA(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);Pb=+h[cb>>3];jA(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);Wb=+h[db>>3];kA(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]);lA(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+512>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+512>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+nwa(c[ib>>2]|0,rb,25024,57560,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+512>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+1176>>3]-ub);ub=+h[Yb+1168>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+nwa(c[ib>>2]|0,Xb,25024,57560,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+1168>>3];ac=+h[Yb+512>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+Nxa(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+520>>3];Gb=+zd(1.0e-13,+(+h[Yb+528>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+nwa(c[ib>>2]|0,Gb,24112,57560,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +zd(+(ac- +yd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+512>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+nwa(c[ib>>2]|0,ec,25024,57560,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+512>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+1176>>3];ic=+h[gc+1168>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+nwa(c[ib>>2]|0,fc,25024,57560,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+1168>>3];kc=+h[gc+512>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+Nxa(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+520>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+zd(1.0e-13,+(+h[gc+528>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9296|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9296|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+nwa(c[ib>>2]|0,Nb,24112,57560,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9296|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function xS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+16432>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+16408>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+16416>>3];h[a+8>>3]=+h[d+16656>>3];h[e+8>>3]=+h[d+16632>>3];h[f+8>>3]=+h[d+16640>>3];i=i;return}function yS(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0.0,l=0.0,m=0.0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+1168>>3]=+h[b>>3];h[a+1184>>3]=+h[b+8>>3];rS(f);sS(f);tS(f);uS(f);vS(f);wS(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;g=f+8720|0;b=f+512|0;a=f+6632|0;j=f+1168|0;h[d>>3]=+h[f+7912>>3]+(+h[g>>3]*+h[b>>3]+(+h[a>>3]*+h[j>>3]- +h[f+9296>>3]));k=+h[a>>3];l=+h[b>>3];m=k*l;h[d+8>>3]=+h[f+9304>>3]*m*m+(+h[f+528>>3]*(k*+h[j>>3]+l*+h[g>>3])-m*+h[f+1184>>3]);i=e;return}function zS(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+98304>>3];h[c[b+8>>2]>>3]=+h[d+98280>>3];h[c[b+12>>2]>>3]=+h[d+98288>>3];i=i;return}function AS(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+7016>>3]=g;k=a+416|0;l=c[k>>2]|0;Kz(f,c[a+536>>2]|0,g,+h[j+9584>>3],+h[j+9592>>3],+h[j+9640>>3],+h[j+9648>>3],+h[j+10024>>3],+h[j+9944>>3],+h[l+1600>>3]*10.0,(+h[l+200>>3]+ +h[l+208>>3])*.5,+h[l+1592>>3]/6.0,+h[l+1560>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+624>>3]- +h[f>>3]*+h[(c[k>>2]|0)+1536>>3];i=e;return}function BS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;iA(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+536>>3]);if((Aza(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+552>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+1208>>3]*.999;l=j;m=l+8712|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;xA(e,c[f>>2]|0,+h[d+536>>3],+h[d+1192>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+8712|0;n=m;h[n>>3]=k;i=b;return}}function CS(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6680>>3];k=+zd(1.0e-13,+(+h[g+552>>3]-j));l=+h[g+7768>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+nwa(c[b+536>>2]|0,k,28104,57568,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+7904|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=Cza(1.0e-13,+h[f+552>>3]- +h[f+6680>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+6680>>3];j=+h[x+552>>3];k=+zd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+8624>>3];k=+h[x+7768>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+1208>>3]- +h[x+8712>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+1208>>3]- +h[x+8712>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+1208>>3]- +h[x+8712>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+1208>>3]- +h[x+8712>>3]}K=(y-k*J)/+nwa(c[b+536>>2]|0,l,28168,57568,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+7768>>3];C=+h[L+6680>>3];D=+h[L+552>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+8712>>3];m=+zd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+nwa(c[b+536>>2]|0,m,28104,57568,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+7904|0;w=v;h[w>>3]=n;i=d;return}function DS(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(Cza(+h[a+544>>3]- +h[a+6696>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+8704|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+1200>>3]- +h[a+7904>>3];g=a;j=g+8704|0;k=j;h[k>>3]=f;i=b;return}function ES(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7896>>3]=+h[b+1200>>3]- +h[b+8704>>3];i=i;return}function FS(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6712>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+8704>>3];o=+h[g+8624>>3]*k+ +h[g+7768>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+nwa(c[b+536>>2]|0,l,28312,57576,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+8704>>3];q=+h[v+6712>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+7896>>3]*(1.0-q)+ +h[r+6704>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+8696|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+8696|0;C=B;h[C>>3]=z;i=d;return}p=t/+nwa(c[b+536>>2]|0,l,28312,57576,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+8696|0;C=B;h[C>>3]=z;i=d;return}



function RDa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=e+8|0;h=(d|0)==(b|0);a[d+12|0]=h&1;if(h){i=e;return}else{j=d}while(1){k=j+8|0;d=c[k>>2]|0;if((a[d+12|0]|0)!=0){l=17;break}h=VDa(d)|0;m=c[d+8>>2]|0;if(h){h=c[m+4>>2]|0;fCa(f);if((h|0)==0){l=7;break}d=h+12|0;if((a[d]|0)!=0){l=7;break}h=c[k>>2]|0;a[h+12|0]=1;n=c[h+8>>2]|0;a[n+12|0]=(n|0)==(b|0)|0;a[d]=1;o=n}else{n=c[m>>2]|0;fCa(g);if((n|0)==0){l=14;break}m=n+12|0;if((a[m]|0)!=0){l=14;break}n=c[k>>2]|0;a[n+12|0]=1;d=c[n+8>>2]|0;a[d+12|0]=(d|0)==(b|0)|0;a[m]=1;o=d}if((o|0)==(b|0)){l=17;break}else{j=o}}if((l|0)==7){if(VDa(j)|0){p=j}else{o=c[k>>2]|0;WDa(o);p=o}o=c[p+8>>2]|0;a[o+12|0]=1;p=c[o+8>>2]|0;a[p+12|0]=0;XDa(p);i=e;return}else if((l|0)==14){if(VDa(j)|0){p=c[k>>2]|0;XDa(p);q=p}else{q=j}j=c[q+8>>2]|0;a[j+12|0]=1;q=c[j+8>>2]|0;a[q+12|0]=0;WDa(q);i=e;return}else if((l|0)==17){i=e;return}}function SDa(a){a=a|0;var b=0,c=0;b=i;c=TDa(a+8|0)|0;i=b;return c|0}function TDa(a){a=a|0;var b=0,c=0;b=i;c=UDa(a)|0;i=b;return c|0}function UDa(a){a=a|0;i=i;return a|0}function VDa(a){a=a|0;i=i;return(c[c[a+8>>2]>>2]|0)==(a|0)|0}function WDa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=a+4|0;e=c[d>>2]|0;f=e;g=c[f>>2]|0;c[d>>2]=g;fCa(b);if((g|0)!=0){c[(c[d>>2]|0)+8>>2]=a}d=a+8|0;c[e+8>>2]=c[d>>2];g=VDa(a)|0;h=c[d>>2]|0;if(g){c[h>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}else{c[h+4>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}}function XDa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=a;e=c[d>>2]|0;f=e+4|0;g=c[f>>2]|0;c[d>>2]=g;fCa(b);if((g|0)!=0){c[(c[d>>2]|0)+8>>2]=a}d=a+8|0;c[e+8>>2]=c[d>>2];g=VDa(a)|0;h=c[d>>2]|0;if(g){c[h>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}else{c[h+4>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}}function YDa(a){a=a|0;var b=0;b=i;ZDa(a,0);i=b;return}function ZDa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=MDa(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}$Da(_Da(e)|0,f);i=d;return}function _Da(a){a=a|0;var b=0,c=0;b=i;c=cEa(a)|0;i=b;return c|0}function $Da(a,b){a=a|0;b=b|0;var d=0;d=i;if((b|0)==0){i=d;return}zDa(c[a>>2]|0,b,1);i=d;return}function aEa(a){a=a|0;i=i;return a|0}function bEa(a){a=a|0;i=i;return a|0}function cEa(a){a=a|0;i=i;return a+4|0}function dEa(a,b){a=a|0;b=b|0;var c=0;c=i;eEa(a,b);i=c;return}function eEa(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function fEa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];pEa(a,b,f);i=e;return}function gEa(a,b){a=a|0;b=b|0;var c=0;a=i;c=oEa(0,b,0)|0;i=a;return c|0}function hEa(a,b){a=a|0;b=b|0;var c=0;c=i;nEa(a,b);i=c;return}function iEa(a,b,d){a=a|0;b=b|0;d=d|0;if((b|0)!=0){c[b>>2]=c[d>>2]}i=i;return}function jEa(a){a=a|0;var b=0,d=0;b=i;d=c[(ODa(a)|0)>>2]|0;i=b;return d|0}function kEa(a){a=a|0;var b=0,c=0;b=i;c=_Da(a)|0;i=b;return c|0}function lEa(a,b){a=a|0;b=b|0;if((b|0)!=0){c[b>>2]=0}i=i;return}function mEa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;dEa(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];FDa(h,f);HDa(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];FDa(a,e);IDa(h);i=d;return}function nEa(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function oEa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=$_a(b*24|0)|0;i=c;return a|0}function pEa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(rEa(g)|0)>>2]|0;g=sEa(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];qEa(b,a,f);i=e;return}function qEa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];tEa(a,b,f);i=e;return}function rEa(a){a=a|0;i=i;return a|0}function sEa(a){a=a|0;i=i;return a|0}function tEa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(vEa(g)|0)>>2]|0;g=wEa(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];uEa(b,a,f);i=e;return}function uEa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(vEa(f)|0)>>2];f=wEa(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function vEa(a){a=a|0;i=i;return a|0}function wEa(a){a=a|0;i=i;return a|0}function xEa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=LDa(yEa(b)|0)|0;h=wEa(kEa(yEa(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];qEa(g,a,e);i=d;return}function yEa(a){a=a|0;i=i;return c[a>>2]|0}function zEa(a){a=a|0;var b=0;b=i;i=i+48|0;AEa(a);tBa(a+184|0,0,0);tBa(a+200|0,0,0);BEa(a+240|0,b);BEa(a+252|0,b+8|0);BEa(a+264|0,b+16|0);BEa(a+276|0,b+24|0);BEa(a+288|0,b+32|0);BEa(a+300|0,b+40|0);i=b;return}function AEa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+104|0;NRa(d);e=a;c[e>>2]=248460;f=d;c[f>>2]=248480;d=a+4|0;USa(a,248492|0,d);c[e>>2]=248460;c[f>>2]=248480;OEa(d);i=b;return}function BEa(a,b){a=a|0;b=b|0;b=i;CEa(a,0);i=b;return}function CEa(a,b){a=a|0;b=b|0;b=i;i=i+8|0;DEa(a,b);i=b;return}function DEa(a,b){a=a|0;b=b|0;b=i;EEa(a,0);i=b;return}function EEa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;FEa(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;GEa(f,0,e);e=RBa(b)|0;c[(QDa(b)|0)>>2]=e;i=d;return}function FEa(a){a=a|0;var b=0;b=i;KEa(a);i=b;return}function GEa(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;HEa(b,c,f);i=e;return}function HEa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(JEa(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;IEa(d,b,f);i=e;return}function IEa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(JEa(e)|0)>>2];i=d;return}function JEa(a){a=a|0;i=i;return a|0}function KEa(a){a=a|0;var b=0;b=i;LEa(a);i=b;return}function LEa(a){a=a|0;var b=0;b=i;MEa(a);i=b;return}function MEa(a){a=a|0;var b=0;b=i;NEa(a);i=b;return}function NEa(a){a=a|0;c[a>>2]=0;i=i;return}function OEa(a){a=a|0;var b=0;b=i;PEa(a);i=b;return}function PEa(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;j=d;WRa(j);c[d>>2]=248616;c[d+32>>2]=0;c[d+36>>2]=0;c[d+40>>2]=0;k=d+68|0;l=d+52|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;fCa(f);f=d+98|0;l=k;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[l+20>>2]=0;c[l+24>>2]=0;b[l+28>>1]=0;a[l+30|0]=0;SRa(g,j);l=QEa(g)|0;yXa(g);if(!l){m=d;n=c[d>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=re[r&63](d,0,4096)|0;i=e;return}SRa(h,j);c[k>>2]=sDa(h)|0;yXa(h);a[f]=(tDa(c[k>>2]|0)|0)&1;m=d;n=c[d>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=re[r&63](d,0,4096)|0;i=e;return}function QEa(a){a=a|0;var b=0,c=0;b=i;c=zXa(a,280512)|0;i=b;return c|0}function REa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+8|0;e=d;f=c[a+12>>2]|0;Bxa(3);g=f+8|0;h=g;j=c[g>>2]|0;g=f+12|0;k=c[g>>2]|0;if((j|0)<(k|0)){SEa(a,b,c[f>>2]|0,h);Exa(3);i=d;return}l=~~(+(k|0)*1.4+ +(k-j|0)+2.0e3);c[g>>2]=l;j=f+16|0;k=Y_a(c[f>>2]|0,fa(l<<3,c[j>>2]|0)|0)|0;l=k;c[f>>2]=l;if((k|0)==0){k=c[b+536>>2]|0;c[e>>2]=fa(c[j>>2]|0,c[g>>2]|0)|0;lwa(k,248888,e)}SEa(a,b,l,h);Exa(3);i=d;return}function SEa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;g=i;j=c[b+12>>2]|0;Exa(0);k=+wxa(0);Bxa(0);l=c[c[d+4>>2]>>2]|0;m=l;n=+h[m>>3];o=j+4|0;j=c[o>>2]|0;p=j+1|0;c[o>>2]=p;h[e+(j<<3)>>3]=n;if((c[b+8>>2]|0)==0){q=p}else{b=j+2|0;c[o>>2]=b;h[e+(p<<3)>>3]=k;q=b}b=d+116|0;p=c[b>>2]|0;if((p|0)>0){j=c[d+8>>2]|0;r=p;p=q;s=0;while(1){if((a[j+(s*112|0)+104|0]|0)==0){k=+h[(c[l+8>>2]|0)+(s<<3)>>3];t=p+1|0;c[o>>2]=t;h[e+(p<<3)>>3]=k;u=c[b>>2]|0;v=t}else{u=r;v=p}t=s+1|0;if((t|0)<(u|0)){r=u;p=v;s=t}else{w=v;break}}}else{w=q}q=d+124|0;v=c[q>>2]|0;if((v|0)>0){s=c[d+12>>2]|0;p=v;v=w;u=0;while(1){if((a[s+(u*60|0)+56|0]|0)==0){k=+(c[(c[l+12>>2]|0)+(u<<2)>>2]|0);r=v+1|0;c[o>>2]=r;h[e+(v<<3)>>3]=k;x=c[q>>2]|0;y=r}else{x=p;y=v}r=u+1|0;if((r|0)<(x|0)){p=x;v=y;u=r}else{z=y;break}}}else{z=w}w=d+128|0;y=c[w>>2]|0;if((y|0)>0){u=c[d+16>>2]|0;v=y;y=z;x=0;while(1){if((a[u+(x*48|0)+44|0]|0)==0){k=+(a[(c[l+16>>2]|0)+x|0]|0);p=y+1|0;c[o>>2]=p;h[e+(y<<3)>>3]=k;A=c[w>>2]|0;B=p}else{A=v;B=y}p=x+1|0;if((p|0)<(A|0)){v=A;y=B;x=p}else{C=B;break}}}else{C=z}z=d+216|0;if((c[z>>2]|0)>0){B=d+416|0;x=c[d+40>>2]|0;y=C;A=0;while(1){do{if((a[x+(A*52|0)+48|0]|0)==0){v=a[x+(A*52|0)+8|0]|0;do{if(v<<24>>24==2){D=m}else{w=c[x+(A*52|0)+4>>2]|0;if(v<<24>>24==1){D=(c[B>>2]|0)+(w<<3)|0;break}else{D=(c[l+8>>2]|0)+(w<<3)|0;break}}}while(0);k=+h[D>>3];if((c[x+(A*52|0)>>2]|0)==0){v=y+1|0;c[o>>2]=v;h[e+(y<<3)>>3]=k;E=v;break}else{v=y+1|0;c[o>>2]=v;h[e+(y<<3)>>3]=-k;E=v;break}}else{E=y}}while(0);v=A+1|0;if((v|0)<(c[z>>2]|0)){y=E;A=v}else{F=E;break}}}else{F=C}C=d+220|0;if((c[C>>2]|0)>0){E=d+40|0;A=d+420|0;y=c[d+44>>2]|0;z=F;x=0;while(1){do{if((a[y+(x*52|0)+48|0]|0)==0){D=c[(c[((a[y+(x*52|0)+8|0]|0)==1?A:l+12|0)>>2]|0)+(c[(c[E>>2]|0)+(x*52|0)+4>>2]<<2)>>2]|0;if((c[y+(x*52|0)>>2]|0)==0){B=z+1|0;c[o>>2]=B;h[e+(z<<3)>>3]=+(D|0);G=B;break}else{B=z+1|0;c[o>>2]=B;h[e+(z<<3)>>3]=+(0-D|0);G=B;break}}else{G=z}}while(0);B=x+1|0;if((B|0)<(c[C>>2]|0)){z=G;x=B}else{H=G;break}}}else{H=F}F=d+224|0;if((c[F>>2]|0)<=0){I=c[f>>2]|0;J=I+1|0;c[f>>2]=J;i=g;return}G=d+44|0;x=d+40|0;z=d+424|0;C=c[d+48>>2]|0;d=H;H=0;while(1){do{if((a[C+(H*52|0)+48|0]|0)==0){y=a[(c[((a[(c[G>>2]|0)+(H*52|0)+8|0]|0)==1?z:l+16|0)>>2]|0)+(c[(c[x>>2]|0)+(H*52|0)+4>>2]|0)|0]|0;if((c[C+(H*52|0)>>2]|0)==0){E=d+1|0;c[o>>2]=E;h[e+(d<<3)>>3]=+(y<<24>>24);K=E;break}else{E=d+1|0;c[o>>2]=E;h[e+(d<<3)>>3]=+(y<<24>>24!=1|0);K=E;break}}else{K=d}}while(0);E=H+1|0;if((E|0)<(c[F>>2]|0)){d=K;H=E}else{break}}I=c[f>>2]|0;J=I+1|0;c[f>>2]=J;i=g;return}function TEa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=V_a(24)|0;Bxa(3);c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;j=g+16|0;c[j>>2]=0;k=a+4|0;l=c[k>>2]|0;c[g+12>>2]=l;m=b+536|0;kwa(c[m>>2]|0,l>>>31^1,248944,f);f=b+8|0;b=c[a+8>>2]|0;l=UEa(b,f)|0;c[g+20>>2]=l;l=UEa(b,f)|0;c[j>>2]=l;j=c[k>>2]|0;k=V_a(fa(l<<3,j)|0)|0;c[g>>2]=k;if((k|0)==0){k=c[m>>2]|0;c[e>>2]=fa(l,j)|0;lwa(k,249024,e)}else{c[h>>2]=0;c[a+12>>2]=g;Exa(3);i=d;return}}function UEa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;f=(b|0)==0?1:2;b=c[d+108>>2]|0;if((b|0)>0){g=c[d>>2]|0;h=0;j=f;while(1){k=((a[g+(h*112|0)+104|0]|0)==0)+j|0;l=h+1|0;if((l|0)<(b|0)){j=k;h=l}else{m=k;break}}}else{m=f}f=c[d+116>>2]|0;if((f|0)>0){h=c[d+4>>2]|0;j=0;b=m;while(1){g=((a[h+(j*60|0)+56|0]|0)==0)+b|0;k=j+1|0;if((k|0)<(f|0)){b=g;j=k}else{n=g;break}}}else{n=m}m=c[d+120>>2]|0;if((m|0)>0){j=c[d+8>>2]|0;b=0;f=n;while(1){h=((a[j+(b*48|0)+44|0]|0)==0)+f|0;g=b+1|0;if((g|0)<(m|0)){f=h;b=g}else{o=h;break}}}else{o=n}n=c[d+208>>2]|0;if((n|0)>0){b=c[d+32>>2]|0;f=0;m=o;while(1){j=((a[b+(f*52|0)+48|0]|0)==0)+m|0;h=f+1|0;if((h|0)<(n|0)){m=j;f=h}else{p=j;break}}}else{p=o}o=c[d+212>>2]|0;if((o|0)>0){f=c[d+36>>2]|0;m=0;n=p;while(1){b=((a[f+(m*52|0)+48|0]|0)==0)+n|0;j=m+1|0;if((j|0)<(o|0)){n=b;m=j}else{q=b;break}}}else{q=p}p=c[d+216>>2]|0;if((p|0)<=0){r=q;i=e;return r|0}m=c[d+40>>2]|0;d=0;n=q;while(1){q=((a[m+(d*52|0)+48|0]|0)==0)+n|0;o=d+1|0;if((o|0)<(p|0)){n=q;d=o}else{r=q;break}}i=e;return r|0}function VEa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=b+12|0;s=c[r>>2]|0;t=s;Bxa(3);u=b;v=mc(c[u>>2]|0,249088)|0;if((v|0)==0){WEa(t);w=c[d+536>>2]|0;x=c[u>>2]|0;y=ae(c[(Qc()|0)>>2]|0)|0;c[q>>2]=x;c[q+4>>2]=y;lwa(w,249096,q)}uc(249152,46,1,v|0)|0;q=s+20|0;c[p>>2]=c[q>>2];Cd(v|0,249200,p|0)|0;p=s+8|0;c[o>>2]=c[p>>2];Cd(v|0,249224,o|0)|0;uc(249248,40,1,v|0)|0;uc(249296,11,1,v|0)|0;uc(249312,14,1,v|0)|0;if((c[p>>2]|0)>0){o=0;do{w=fa(c[q>>2]|0,o)|0;z=+h[(c[s>>2]|0)+(w<<3)>>3];XEa(v,z,z);o=o+1|0;}while((o|0)<(c[p>>2]|0))}Yd(10,v|0)|0;if((c[b+8>>2]|0)==0){A=1}else{uc(249328,18,1,v|0)|0;if((c[p>>2]|0)>0){b=0;do{o=fa(c[q>>2]|0,b)|0;w=c[s>>2]|0;XEa(v,+h[w+(o<<3)>>3],+h[w+(o+1<<3)>>3]);b=b+1|0;}while((b|0)<(c[p>>2]|0))}Yd(10,v|0)|0;A=2}b=d+116|0;o=c[b>>2]|0;if((o|0)>0){w=d+8|0;y=o;o=0;x=A;while(1){B=c[w>>2]|0;if((a[B+(o*112|0)+104|0]|0)==0){c[n>>2]=c[B+(o*112|0)+4>>2];Cd(v|0,249352,n|0)|0;if((c[p>>2]|0)>0){B=0;do{C=fa(c[q>>2]|0,B)|0;D=c[s>>2]|0;XEa(v,+h[D+(C<<3)>>3],+h[D+(C+x<<3)>>3]);B=B+1|0;}while((B|0)<(c[p>>2]|0))}Yd(10,v|0)|0;E=c[b>>2]|0;F=x+1|0}else{E=y;F=x}B=o+1|0;if((B|0)<(E|0)){y=E;o=B;x=F}else{G=F;break}}}else{G=A}A=d+124|0;F=c[A>>2]|0;if((F|0)>0){x=d+12|0;o=F;F=0;E=G;while(1){y=c[x>>2]|0;if((a[y+(F*60|0)+56|0]|0)==0){c[m>>2]=c[y+(F*60|0)+4>>2];Cd(v|0,249352,m|0)|0;if((c[p>>2]|0)>0){y=0;do{b=fa(c[q>>2]|0,y)|0;n=c[s>>2]|0;XEa(v,+h[n+(b<<3)>>3],+h[n+(b+E<<3)>>3]);y=y+1|0;}while((y|0)<(c[p>>2]|0))}Yd(10,v|0)|0;H=c[A>>2]|0;I=E+1|0}else{H=o;I=E}y=F+1|0;if((y|0)<(H|0)){o=H;F=y;E=I}else{J=I;break}}}else{J=G}G=d+128|0;I=c[G>>2]|0;if((I|0)>0){E=d+16|0;F=I;I=0;H=J;while(1){o=c[E>>2]|0;if((a[o+(I*48|0)+44|0]|0)==0){c[l>>2]=c[o+(I*48|0)+4>>2];Cd(v|0,249352,l|0)|0;if((c[p>>2]|0)>0){o=0;do{A=fa(c[q>>2]|0,o)|0;m=c[s>>2]|0;XEa(v,+h[m+(A<<3)>>3],+h[m+(A+H<<3)>>3]);o=o+1|0;}while((o|0)<(c[p>>2]|0))}Yd(10,v|0)|0;K=c[G>>2]|0;L=H+1|0}else{K=F;L=H}o=I+1|0;if((o|0)<(K|0)){F=K;I=o;H=L}else{M=L;break}}}else{M=J}J=d+216|0;L=c[J>>2]|0;if((L|0)>0){H=d+40|0;I=L;L=0;K=M;while(1){F=c[H>>2]|0;if((a[F+(L*52|0)+48|0]|0)==0){c[k>>2]=c[F+(L*52|0)+16>>2];Cd(v|0,249352,k|0)|0;if((c[p>>2]|0)>0){F=0;do{G=fa(c[q>>2]|0,F)|0;l=c[s>>2]|0;XEa(v,+h[l+(G<<3)>>3],+h[l+(G+K<<3)>>3]);F=F+1|0;}while((F|0)<(c[p>>2]|0))}Yd(10,v|0)|0;N=c[J>>2]|0;O=K+1|0}else{N=I;O=K}F=L+1|0;if((F|0)<(N|0)){I=N;L=F;K=O}else{P=O;break}}}else{P=M}M=d+220|0;O=c[M>>2]|0;if((O|0)>0){K=d+44|0;L=O;O=0;N=P;while(1){I=c[K>>2]|0;if((a[I+(O*52|0)+48|0]|0)==0){c[j>>2]=c[I+(O*52|0)+16>>2];Cd(v|0,249352,j|0)|0;if((c[p>>2]|0)>0){I=0;do{J=fa(c[q>>2]|0,I)|0;k=c[s>>2]|0;XEa(v,+h[k+(J<<3)>>3],+h[k+(J+N<<3)>>3]);I=I+1|0;}while((I|0)<(c[p>>2]|0))}Yd(10,v|0)|0;Q=c[M>>2]|0;R=N+1|0}else{Q=L;R=N}I=O+1|0;if((I|0)<(Q|0)){L=Q;O=I;N=R}else{S=R;break}}}else{S=P}P=d+224|0;R=c[P>>2]|0;if((R|0)>0){N=d+48|0;O=R;R=0;Q=S;while(1){S=c[N>>2]|0;if((a[S+(R*52|0)+48|0]|0)==0){c[g>>2]=c[S+(R*52|0)+16>>2];Cd(v|0,249352,g|0)|0;if((c[p>>2]|0)>0){S=0;do{L=fa(c[q>>2]|0,S)|0;M=c[s>>2]|0;XEa(v,+h[M+(L<<3)>>3],+h[M+(L+Q<<3)>>3]);S=S+1|0;}while((S|0)<(c[p>>2]|0))}Yd(10,v|0)|0;T=c[P>>2]|0;U=Q+1|0}else{T=O;U=Q}S=R+1|0;if((S|0)<(T|0)){O=T;R=S;Q=U}else{break}}}WEa(t);if((ad(v|0)|0)==0){W_a(c[r>>2]|0);c[r>>2]=0;Exa(3);i=e;return}else{e=c[d+536>>2]|0;c[f>>2]=c[u>>2];lwa(e,249368,f)}}function WEa(a){a=a|0;var b=0,d=0;b=i;d=a;a=c[d>>2]|0;if((a|0)==0){i=b;return}W_a(a);c[d>>2]=0;i=b;return}function XEa(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=f;h[k>>3]=b;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=f+8|0;h[k>>3]=d;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];Cd(a|0,249416,f|0)|0;i=e;return}function YEa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=$_a(192)|0;B$a(m|0,0,192)|0;ZEa(m);c[a+12>>2]=m;n=m;o=a;uBa(n,c[o>>2]|0,36);if(BRa(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){a=c[b+536>>2]|0;c[g>>2]=c[o>>2];lwa(a,249456,g)}else{g=m;eTa(g,249432,14)|0;fTa(h,g);a=HCa(h)|0;h=m+184|0;c[h>>2]=a;eTa(g,249448,4)|0;_Ea(n,b+8|0);fTa(j,g);b=HCa(j)|0;j=m+188|0;c[j>>2]=b;m=c[h>>2]|0;tBa(k,m,((m|0)<0)<<31>>31);h=f;a=k;c[h+0>>2]=c[a+0>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[h+12>>2]=c[a+12>>2];gTa(g,f)|0;$Ea(n,-4-m+b|0);b=c[j>>2]|0;tBa(l,b,((b|0)<0)<<31>>31);b=e;j=l;c[b+0>>2]=c[j+0>>2];c[b+4>>2]=c[j+4>>2];c[b+8>>2]=c[j+8>>2];c[b+12>>2]=c[j+12>>2];gTa(g,e)|0;Exa(3);i=d;return}}function ZEa(a){a=a|0;var b=0;b=i;sFa(a);i=b;return}function _Ea(a,b){a=a|0;b=b|0;var c=0;c=i;bFa(a,3);cFa(a,249632);bFa(a,0);cFa(a,249640);bFa(a,2);nFa(a,b);oFa(a,b);cFa(a,249648);bFa(a,0);i=c;return}function $Ea(a,b){a=a|0;b=b|0;var d=0;d=i;c[62406]=Nd(b|0)|0;eTa(a,249624,4)|0;i=d;return}function aFa(b,d,e,f){b=b|0;d=+d;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+112|0;j=g;k=g+16|0;l=g+32|0;m=g+48|0;n=g+64|0;o=g+80|0;p=g+96|0;q=b;fTa(l,q);r=HCa(l)|0;$Ea(b,0);fTa(m,q);l=HCa(m)|0;bFa(b,1);cFa(b,249520);m=e+128|0;s=e+132|0;t=e+136|0;u=e+140|0;dFa(b,(c[m>>2]|0)+1+(c[s>>2]|0)+(c[t>>2]|0)+(c[u>>2]|0)|0);eFa(b,d);if((c[m>>2]|0)>0){e=f+176|0;v=0;do{eFa(b,+h[(c[e>>2]|0)+(v<<3)>>3]);v=v+1|0;}while((v|0)<(c[m>>2]|0))}if((c[s>>2]|0)>0){m=f+180|0;v=0;do{fFa(b,c[(c[m>>2]|0)+(v<<2)>>2]|0);v=v+1|0;}while((v|0)<(c[s>>2]|0))}if((c[t>>2]|0)>0){s=f+184|0;v=0;do{gFa(b,(a[(c[s>>2]|0)+v|0]|0)!=0);v=v+1|0;}while((v|0)<(c[t>>2]|0))}if((c[u>>2]|0)>0){t=f+188|0;f=0;do{cFa(b,c[(c[t>>2]|0)+(f<<2)>>2]|0);f=f+1|0;}while((f|0)<(c[u>>2]|0))}fTa(n,q);u=HCa(n)|0;n=y$a(0,r|0,32)|0;tBa(o,n,J);n=k;r=o;c[n+0>>2]=c[r+0>>2];c[n+4>>2]=c[r+4>>2];c[n+8>>2]=c[r+8>>2];c[n+12>>2]=c[r+12>>2];gTa(q,k)|0;$Ea(b,u-l|0);tBa(p,u,((u|0)<0)<<31>>31);u=j;l=p;c[u+0>>2]=c[l+0>>2];c[u+4>>2]=c[l+4>>2];c[u+8>>2]=c[l+8>>2];c[u+12>>2]=c[l+12>>2];gTa(q,j)|0;i=g;return}function bFa(b,d){b=b|0;d=d|0;var e=0;e=i;a[249608]=-33;c[62404]=Nd(d|0)|0;d=b;eTa(d,249608,1)|0;eTa(d,249616,4)|0;i=e;return}function cFa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e;c[f>>2]=Nd(x$a(d|0)|0)|0;a[249600]=-37;g=b;eTa(g,249600,1)|0;eTa(g,f,4)|0;eTa(g,d,x$a(d|0)|0)|0;i=e;return}function dFa(b,d){b=b|0;d=d|0;var e=0;e=i;a[249584]=-35;c[62398]=Nd(d|0)|0;d=b;eTa(d,249584,1)|0;eTa(d,249592,4)|0;i=e;return}function eFa(b,c){b=b|0;c=+c;var d=0,e=0;d=i;a[249568]=-53;mFa(c);e=b;eTa(e,249568,1)|0;eTa(e,249576,8)|0;i=d;return}function fFa(b,d){b=b|0;d=d|0;var e=0;e=i;a[249552]=-46;c[62390]=Nd(d|0)|0;d=b;eTa(d,249552,1)|0;eTa(d,249560,4)|0;i=e;return}function gFa(b,c){b=b|0;c=c|0;var d=0;d=i;a[249544]=c?-61:-62;eTa(b,249544,1)|0;i=d;return}function hFa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a+12>>2]|0;a=b+8|0;f=b+240|0;aFa(e,+h[f>>3],a,f);aFa(e,+h[b+248>>3],a,f);i=d;return}function iFa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+112|0;f=e;g=e+16|0;j=e+32|0;k=e+48|0;l=e+64|0;m=e+80|0;n=e+96|0;o=c[b+12>>2]|0;b=o;p=o;fTa(j,p);o=HCa(j)|0;$Ea(b,0);fTa(k,p);j=HCa(k)|0;bFa(b,1);cFa(b,249528);k=d+116|0;q=d+124|0;r=d+128|0;s=d+132|0;dFa(b,(c[k>>2]|0)+1+(c[q>>2]|0)+(c[r>>2]|0)+(c[s>>2]|0)|0);t=d+4|0;eFa(b,+h[c[c[t>>2]>>2]>>3]);if((c[k>>2]|0)>0){d=0;do{eFa(b,+h[(c[(c[c[t>>2]>>2]|0)+8>>2]|0)+(d<<3)>>3]);d=d+1|0;}while((d|0)<(c[k>>2]|0))}if((c[q>>2]|0)>0){k=0;do{fFa(b,c[(c[(c[c[t>>2]>>2]|0)+12>>2]|0)+(k<<2)>>2]|0);k=k+1|0;}while((k|0)<(c[q>>2]|0))}if((c[r>>2]|0)>0){q=0;do{gFa(b,(a[(c[(c[c[t>>2]>>2]|0)+16>>2]|0)+q|0]|0)!=0);q=q+1|0;}while((q|0)<(c[r>>2]|0))}if((c[s>>2]|0)>0){r=0;do{cFa(b,c[(c[(c[c[t>>2]>>2]|0)+20>>2]|0)+(r<<2)>>2]|0);r=r+1|0;}while((r|0)<(c[s>>2]|0))}fTa(l,p);s=HCa(l)|0;l=y$a(0,o|0,32)|0;tBa(m,l,J);l=g;o=m;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];gTa(p,g)|0;$Ea(b,s-j|0);tBa(n,s,((s|0)<0)<<31>>31);s=f;j=n;c[s+0>>2]=c[j+0>>2];c[s+4>>2]=c[j+4>>2];c[s+8>>2]=c[j+8>>2];c[s+12>>2]=c[j+12>>2];gTa(p,f)|0;i=e;return}function jFa(a,b){a=a|0;b=b|0;var d=0;b=i;d=a+12|0;a=c[d>>2]|0;nBa(a);Bxa(3);if((a|0)!=0){kFa(a);b$a(a)}c[d>>2]=0;Exa(3);i=b;return}function kFa(a){a=a|0;var b=0;b=i;lFa(a);i=b;return}function lFa(a){a=a|0;var b=0;b=i;KCa(a);i=b;return}function mFa(b){b=+b;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+8|0;e=d;h[e>>3]=b;if((Nd(1)|0)==1){f=e;g=c[f+4>>2]|0;j=249576;c[j>>2]=c[f>>2];c[j+4>>2]=g;i=d;return}h[k>>3]=b;g=c[k>>2]&255;j=0;while(1){a[249576+(7-j)|0]=g;f=j+1|0;if((f|0)>=8){break}g=a[e+f|0]|0;j=f}i=d;return}function nFa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;cFa(a,249520);bFa(a,4);cFa(a,249656);bFa(a,0);cFa(a,249664);f=b+128|0;g=b+132|0;h=b+136|0;j=b+140|0;dFa(a,(c[f>>2]|0)+1+(c[g>>2]|0)+(c[h>>2]|0)+(c[j>>2]|0)|0);cFa(a,249672);if((c[f>>2]|0)>0){k=b+16|0;l=0;do{cFa(a,c[(c[k>>2]|0)+(l*112|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){l=b+20|0;k=0;do{cFa(a,c[(c[l>>2]|0)+(k*60|0)+4>>2]|0);k=k+1|0;}while((k|0)<(c[g>>2]|0))}if((c[h>>2]|0)>0){k=b+24|0;l=0;do{cFa(a,c[(c[k>>2]|0)+(l*48|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[h>>2]|0))}if((c[j>>2]|0)>0){l=b+28|0;k=0;do{cFa(a,c[(c[l>>2]|0)+(k*52|0)+4>>2]|0);k=k+1|0;}while((k|0)<(c[j>>2]|0))}k=e;l=249760;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];pFa(a,b,e);cFa(a,249696);bFa(a,(c[f>>2]|0)+1+(c[g>>2]|0)+(c[h>>2]|0)+(c[j>>2]|0)|0);qFa(a,249672,249704);if((c[f>>2]|0)>0){e=b+16|0;l=0;do{k=c[e>>2]|0;qFa(a,c[k+(l*112|0)+4>>2]|0,c[k+(l*112|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){f=b+20|0;l=0;do{e=c[f>>2]|0;qFa(a,c[e+(l*60|0)+4>>2]|0,c[e+(l*60|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[g>>2]|0))}if((c[h>>2]|0)>0){g=b+24|0;l=0;do{f=c[g>>2]|0;qFa(a,c[f+(l*48|0)+4>>2]|0,c[f+(l*48|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[h>>2]|0))}if((c[j>>2]|0)<=0){i=d;return}h=b+28|0;b=0;do{l=c[h>>2]|0;qFa(a,c[l+(b*52|0)+4>>2]|0,c[l+(b*52|0)+8>>2]|0);b=b+1|0;}while((b|0)<(c[j>>2]|0));i=d;return}function oFa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d;f=b+108|0;g=c[f>>2]|0;h=b+116|0;j=c[h>>2]|0;k=b+120|0;l=c[k>>2]|0;m=b+124|0;n=c[m>>2]|0;cFa(a,249528);bFa(a,4);cFa(a,249656);bFa(a,0);cFa(a,249664);o=g+1+j+l+n|0;dFa(a,o);cFa(a,249672);if((c[f>>2]|0)>0){n=b;l=0;do{cFa(a,c[(c[n>>2]|0)+(l*112|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[h>>2]|0)>0){l=b+4|0;n=0;do{cFa(a,c[(c[l>>2]|0)+(n*60|0)+4>>2]|0);n=n+1|0;}while((n|0)<(c[h>>2]|0))}if((c[k>>2]|0)>0){n=b+8|0;l=0;do{cFa(a,c[(c[n>>2]|0)+(l*48|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[k>>2]|0))}if((c[m>>2]|0)>0){l=b+12|0;n=0;do{cFa(a,c[(c[l>>2]|0)+(n*52|0)+4>>2]|0);n=n+1|0;}while((n|0)<(c[m>>2]|0))}n=e;l=249680;c[n+0>>2]=c[l+0>>2];c[n+4>>2]=c[l+4>>2];c[n+8>>2]=c[l+8>>2];pFa(a,b,e);cFa(a,249696);bFa(a,o);qFa(a,249672,249704);if((c[f>>2]|0)>0){o=b;e=0;do{l=c[o>>2]|0;qFa(a,c[l+(e*112|0)+4>>2]|0,c[l+(e*112|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[f>>2]|0))}if((c[h>>2]|0)>0){f=b+4|0;e=0;do{o=c[f>>2]|0;qFa(a,c[o+(e*60|0)+4>>2]|0,c[o+(e*60|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[h>>2]|0))}if((c[k>>2]|0)>0){h=b+8|0;e=0;do{f=c[h>>2]|0;qFa(a,c[f+(e*48|0)+4>>2]|0,c[f+(e*48|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[k>>2]|0))}if((c[m>>2]|0)<=0){i=d;return}k=b+12|0;b=0;do{e=c[k>>2]|0;qFa(a,c[e+(b*52|0)+4>>2]|0,c[e+(b*52|0)+8>>2]|0);b=b+1|0;}while((b|0)<(c[m>>2]|0));i=d;return}function pFa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;cFa(b,249728);g=d+208|0;h=c[g>>2]|0;if((h|0)>0){j=c[d+32>>2]|0;k=0;l=0;while(1){m=(c[e+(a[j+(k*52|0)+8|0]<<2)>>2]|0)+l|0;n=k+1|0;if((n|0)<(h|0)){l=m;k=n}else{o=m;break}}}else{o=0}k=d+212|0;l=c[k>>2]|0;if((l|0)>0){h=c[d+36>>2]|0;j=0;m=o;while(1){n=(c[e+(a[h+(j*52|0)+8|0]<<2)>>2]|0)+m|0;p=j+1|0;if((p|0)<(l|0)){m=n;j=p}else{q=n;break}}}else{q=o}o=d+216|0;j=c[o>>2]|0;if((j|0)>0){m=c[d+40>>2]|0;l=0;h=q;while(1){n=(c[e+(a[m+(l*52|0)+8|0]<<2)>>2]|0)+h|0;p=l+1|0;if((p|0)<(j|0)){h=n;l=p}else{r=n;break}}}else{r=q}q=d+220|0;l=c[q>>2]|0;if((l|0)>0){h=c[d+44>>2]|0;j=0;m=r;while(1){n=(c[e+(a[h+(j*52|0)+8|0]<<2)>>2]|0)+m|0;p=j+1|0;if((p|0)<(l|0)){m=n;j=p}else{s=n;break}}}else{s=r}bFa(b,s);s=c[g>>2]|0;if((s|0)>0){r=d+32|0;j=d+16|0;m=d;l=s;s=0;h=0;while(1){n=c[r>>2]|0;p=a[n+(s*52|0)+8|0]|0;if((c[e+(p<<24>>24<<2)>>2]|0)==0){t=l;u=h}else{v=p<<24>>24==2?249672:h;if(p<<24>>24==1){w=c[(c[j>>2]|0)+((c[n+(s*52|0)+4>>2]|0)*112|0)+4>>2]|0}else if(p<<24>>24==0){w=c[(c[m>>2]|0)+((c[n+(s*52|0)+4>>2]|0)*112|0)+4>>2]|0}else{w=v}rFa(b,c[n+(s*52|0)+16>>2]|0,w,(c[n+(s*52|0)>>2]|0)!=0);t=c[g>>2]|0;u=w}n=s+1|0;if((n|0)<(t|0)){l=t;s=n;h=u}else{x=u;break}}}else{x=0}u=c[k>>2]|0;if((u|0)>0){h=d+36|0;s=d+20|0;t=d+4|0;l=u;u=0;w=x;while(1){g=c[h>>2]|0;m=a[g+(u*52|0)+8|0]|0;if((c[e+(m<<24>>24<<2)>>2]|0)==0){y=l;z=w}else{j=m<<24>>24==2?249672:w;if(m<<24>>24==1){A=c[(c[s>>2]|0)+((c[g+(u*52|0)+4>>2]|0)*60|0)+4>>2]|0}else if(m<<24>>24==0){A=c[(c[t>>2]|0)+((c[g+(u*52|0)+4>>2]|0)*60|0)+4>>2]|0}else{A=j}rFa(b,c[g+(u*52|0)+16>>2]|0,A,(c[g+(u*52|0)>>2]|0)!=0);y=c[k>>2]|0;z=A}g=u+1|0;if((g|0)<(y|0)){l=y;u=g;w=z}else{B=z;break}}}else{B=x}x=c[o>>2]|0;if((x|0)>0){z=d+40|0;w=d+24|0;u=d+8|0;y=x;x=0;l=B;while(1){A=c[z>>2]|0;k=a[A+(x*52|0)+8|0]|0;if((c[e+(k<<24>>24<<2)>>2]|0)==0){C=y;D=l}else{t=k<<24>>24==2?249672:l;if(k<<24>>24==0){E=c[(c[u>>2]|0)+((c[A+(x*52|0)+4>>2]|0)*48|0)+4>>2]|0}else if(k<<24>>24==1){E=c[(c[w>>2]|0)+((c[A+(x*52|0)+4>>2]|0)*48|0)+4>>2]|0}else{E=t}rFa(b,c[A+(x*52|0)+16>>2]|0,E,(c[A+(x*52|0)>>2]|0)!=0);C=c[o>>2]|0;D=E}A=x+1|0;if((A|0)<(C|0)){y=C;x=A;l=D}else{F=D;break}}}else{F=B}B=c[q>>2]|0;if((B|0)<=0){i=f;return}D=d+44|0;l=d+28|0;x=d+12|0;d=B;B=0;C=F;while(1){F=c[D>>2]|0;y=a[F+(B*52|0)+8|0]|0;if((c[e+(y<<24>>24<<2)>>2]|0)==0){G=d;H=C}else{E=y<<24>>24==2?249672:C;if(y<<24>>24==1){I=c[(c[l>>2]|0)+((c[F+(B*52|0)+4>>2]|0)*52|0)+4>>2]|0}else if(y<<24>>24==0){I=c[(c[x>>2]|0)+((c[F+(B*52|0)+4>>2]|0)*52|0)+4>>2]|0}else{I=E}rFa(b,c[F+(B*52|0)+16>>2]|0,I,(c[F+(B*52|0)>>2]|0)!=0);G=c[q>>2]|0;H=I}F=B+1|0;if((F|0)<(G|0)){d=G;B=F;C=H}else{break}}i=f;return}function qFa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;cFa(a,b);bFa(a,1);cFa(a,249712);cFa(a,c);i=d;return}function rFa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;cFa(a,b);bFa(a,d?2:1);cFa(a,249736);cFa(a,c);if(!d){i=e;return}cFa(a,249744);cFa(a,249752);i=e;return}function sFa(a){a=a|0;var b=0;b=i;AEa(a);i=b;return}function tFa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=i;i=i+288|0;d=c;e=c+16|0;f=c+32|0;g=c+48|0;h=c+64|0;j=c+80|0;k=c+96|0;l=c+112|0;m=c+128|0;n=c+144|0;o=c+160|0;p=c+176|0;q=c+192|0;r=c+208|0;s=c+224|0;t=c+240|0;u=c+256|0;v=c+272|0;KQa(e,249776);GQa(d,vFa(a,e)|0);uFa(d,b+4|0);QQa(d);QQa(e);KQa(g,249784);GQa(f,vFa(a,g)|0);wFa(f,b);QQa(f);QQa(g);KQa(j,249800);GQa(h,vFa(a,j)|0);uFa(h,b+8|0);QQa(h);QQa(j);KQa(l,249816);GQa(k,vFa(a,l)|0);uFa(k,b+12|0);QQa(k);QQa(l);KQa(n,249832);GQa(m,vFa(a,n)|0);xFa(m,b+16|0,0);QQa(m);QQa(n);KQa(p,249848);GQa(o,vFa(a,p)|0);xFa(o,b+20|0,0);QQa(o);QQa(p);KQa(r,249864);GQa(q,vFa(a,r)|0);xFa(q,b+24|0,0);QQa(q);QQa(r);KQa(t,249872);GQa(s,vFa(a,t)|0);xFa(s,b+28|0,0);QQa(s);QQa(t);KQa(v,249888);GQa(u,vFa(a,v)|0);xFa(u,b+32|0,0);QQa(u);QQa(v);i=c;return}function uFa(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+8|0;if((b|0)==0){jwa(22,0,253096,d);i=d;return}else{c[b>>2]=Gd(lRa(a)|0)|0;i=d;return}}function vFa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=GJa(a,f,b)|0;l=c[k>>2]|0;fCa(d+16|0);if((l|0)!=0){m=l;n=m;o=n+28|0;p=o;i=d;return p|0}IJa(j,a,b);JJa(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];HJa(g,e);KJa(j);j=c[f>>2]|0;LJa(a,j,k,MJa(g)|0);k=NJa(g)|0;KJa(g);m=k;n=m;o=n+28|0;p=o;i=d;return p|0}function wFa(a,b){a=a|0;b=b|0;var d=0;d=i;if((oRa(a,250064)|0)==0){c[b>>2]=1;i=d;return}if((oRa(a,250072)|0)==0){c[b>>2]=0;i=d;return}else{c[b>>2]=Ic(lRa(a)|0)|0;i=d;return}}function xFa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if((oRa(a,250040)|0)==0){c[b>>2]=d}if((oRa(a,250064)|0)==0){c[b>>2]=1;i=e;return}if((oRa(a,250072)|0)==0){c[b>>2]=0;i=e;return}else{c[b>>2]=Ic(lRa(a)|0)|0;i=e;return}}function yFa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0;e=i;i=i+56|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;KQa(j,249904);GQa(g,vFa(b,j)|0);y=d+48|0;zFa(g,y);QQa(g);QQa(j);KQa(m,249920);GQa(l,vFa(b,m)|0);j=d+56|0;AFa(l,j,0.0);QQa(l);QQa(m);KQa(o,249928);GQa(n,vFa(b,o)|0);m=d+32|0;zFa(n,m);QQa(n);QQa(o);KQa(q,249936);GQa(p,vFa(b,q)|0);o=d+33|0;zFa(p,o);QQa(p);QQa(q);KQa(s,249952);GQa(r,vFa(b,s)|0);q=d+40|0;AFa(r,q,1.0);QQa(r);QQa(s);KQa(u,249960);GQa(t,vFa(b,u)|0);s=d+16|0;AFa(t,s,-1.7976931348623157e+308);QQa(t);QQa(u);KQa(w,249968);GQa(v,vFa(b,w)|0);u=d+24|0;AFa(v,u,1.7976931348623157e+308);QQa(v);QQa(w);KQa(x,249776);w=lRa(vFa(b,x)|0)|0;b=(a[y]|0)!=0;z=+h[j>>3];j=(a[m]|0)!=0?250064:250072;m=(a[o]|0)!=0;A=+h[q>>3];B=+h[s>>3];C=+h[u>>3];c[f>>2]=w;c[f+4>>2]=b?250040:250048;w=f+8|0;h[k>>3]=z;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[f+16>>2]=b?250040:250056;c[f+20>>2]=j;c[f+24>>2]=m?250040:250048;j=f+28|0;h[k>>3]=A;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];c[f+36>>2]=m?250040:250056;m=f+40|0;h[k>>3]=B;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=f+48|0;h[k>>3]=C;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];hwa(4,0,249976,f);QQa(x);i=e;return}function zFa(b,c){b=b|0;c=c|0;var d=0;d=i;a[c]=(oRa(b,250064)|0)==0|0;i=d;return}function AFa(a,b,c){a=a|0;b=b|0;c=+c;var d=0;d=i;if((oRa(a,250040)|0)==0){h[b>>3]=c;i=d;return}if((oRa(a,250064)|0)==0){h[b>>3]=1.0;i=d;return}if((oRa(a,250072)|0)==0){h[b>>3]=0.0;i=d;return}else{h[b>>3]=+p$a(lRa(a)|0);i=d;return}}function BFa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+32|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;KQa(h,249904);GQa(g,vFa(b,h)|0);s=d+13|0;zFa(g,s);QQa(g);QQa(h);KQa(k,249920);GQa(j,vFa(b,k)|0);h=d+16|0;xFa(j,h,0);QQa(j);QQa(k);KQa(m,249928);GQa(l,vFa(b,m)|0);k=d+12|0;zFa(l,k);QQa(l);QQa(m);KQa(o,249960);GQa(n,vFa(b,o)|0);m=d+4|0;xFa(n,m,-2147483648);QQa(n);QQa(o);KQa(q,249968);GQa(p,vFa(b,q)|0);o=d+8|0;xFa(p,o,2147483647);QQa(p);QQa(q);KQa(r,249776);q=lRa(vFa(b,r)|0)|0;b=(a[s]|0)!=0;s=c[h>>2]|0;h=(a[k]|0)!=0?250064:250072;k=c[m>>2]|0;m=c[o>>2]|0;c[f>>2]=q;c[f+4>>2]=b?250040:250048;c[f+8>>2]=s;c[f+12>>2]=b?250040:250056;c[f+16>>2]=h;c[f+20>>2]=k;c[f+24>>2]=m;hwa(4,0,250080,f);QQa(r);i=e;return}function CFa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+24|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;KQa(h,249904);GQa(g,vFa(b,h)|0);o=d+5|0;zFa(g,o);QQa(g);QQa(h);KQa(k,249920);GQa(j,vFa(b,k)|0);h=d+6|0;zFa(j,h);QQa(j);QQa(k);KQa(m,249928);GQa(l,vFa(b,m)|0);k=d+4|0;zFa(l,k);QQa(l);QQa(m);KQa(n,249776);m=lRa(vFa(b,n)|0)|0;b=(a[o]|0)!=0;o=(a[h]|0)!=0?250064:250072;h=(a[k]|0)!=0?250064:250072;c[f>>2]=m;c[f+4>>2]=b?250040:250048;c[f+8>>2]=o;c[f+12>>2]=b?250040:250056;c[f+16>>2]=h;hwa(4,0,250136,f);QQa(n);i=e;return}function DFa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;KQa(h,249904);GQa(g,vFa(b,h)|0);m=d+4|0;zFa(g,m);QQa(g);QQa(h);KQa(k,249920);GQa(j,vFa(b,k)|0);h=d+8|0;uFa(j,h);QQa(j);QQa(k);KQa(l,249776);k=lRa(vFa(b,l)|0)|0;b=(a[m]|0)!=0;m=c[h>>2]|0;c[f>>2]=k;c[f+4>>2]=b?250040:250048;c[f+8>>2]=m;c[f+12>>2]=b?250040:250056;hwa(4,0,250176,f);QQa(l);i=e;return}function EFa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+16|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+16|0;la=i;i=i+16|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+200|0;ra=i;i=i+16|0;sa=i;i=i+16|0;ta=i;i=i+8|0;ua=i;i=i+16|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+16|0;za=i;i=i+16|0;Aa=i;i=i+1024|0;Ba=i;i=i+8|0;Ca=i;i=i+16|0;Da=i;i=i+8|0;Ea=i;i=i+16|0;Fa=i;i=i+16|0;Ga=i;i=i+16|0;Ha=i;i=i+16|0;Ia=i;i=i+16|0;Ja=i;i=i+16|0;Ka=i;i=i+16|0;La=i;i=i+16|0;Ma=i;i=i+16|0;Na=i;i=i+16|0;Oa=i;i=i+16|0;Pa=i;i=i+16|0;Qa=i;i=i+16|0;Ra=i;i=i+16|0;Sa=i;i=i+16|0;Ta=i;i=i+16|0;Ua=i;i=i+16|0;Va=i;i=i+16|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+16|0;eb=i;i=i+16|0;fb=i;i=i+16|0;gb=i;i=i+16|0;hb=i;i=i+16|0;ib=i;i=i+16|0;jb=i;i=i+16|0;kb=i;i=i+16|0;lb=i;i=i+16|0;mb=i;i=i+16|0;nb=i;i=i+16|0;ob=i;i=i+16|0;pb=i;i=i+16|0;qb=i;i=i+16|0;rb=i;i=i+16|0;sb=i;i=i+16|0;tb=i;i=i+16|0;ub=i;i=i+16|0;wb=i;i=i+8|0;xb=i;i=i+16|0;yb=i;i=i+16|0;zb=i;i=i+8|0;Ab=i;i=i+16|0;Bb=i;i=i+16|0;Cb=i;i=i+8|0;Db=i;i=i+16|0;Eb=i;i=i+16|0;Fb=i;i=i+8|0;Gb=i;i=i+16|0;Hb=i;i=i+16|0;Ib=i;i=i+8|0;Jb=i;i=i+16|0;Kb=i;i=i+16|0;Lb=i;i=i+8|0;Mb=i;i=i+16|0;Nb=i;i=i+16|0;Ob=i;i=i+8|0;Pb=i;i=i+16|0;Qb=i;i=i+16|0;Rb=i;i=i+8|0;Sb=i;i=i+16|0;Tb=i;i=i+16|0;Ub=i;i=i+8|0;Vb=i;i=i+16|0;Wb=i;i=i+16|0;Xb=i;i=i+8|0;Yb=i;i=i+16|0;Zb=i;i=i+16|0;_b=i;i=i+8|0;$b=i;i=i+16|0;ac=i;i=i+16|0;bc=i;i=i+8|0;cc=i;i=i+16|0;dc=i;i=i+16|0;ec=i;i=i+8|0;fc=i;i=i+16|0;gc=i;i=i+8|0;hc=i;i=i+8|0;ic=i;i=i+16|0;jc=i;i=i+16|0;kc=i;i=i+8|0;lc=i;i=i+16|0;nc=i;i=i+16|0;oc=i;i=i+8|0;pc=i;i=i+16|0;qc=i;i=i+16|0;rc=i;i=i+8|0;sc=i;i=i+16|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+16|0;wc=i;i=i+16|0;xc=i;i=i+8|0;yc=i;i=i+16|0;zc=i;i=i+16|0;Ac=i;i=i+8|0;Bc=i;i=i+16|0;Cc=i;i=i+16|0;Dc=i;i=i+8|0;Ec=i;i=i+16|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+16|0;Ic=i;i=i+16|0;Jc=i;i=i+8|0;Kc=i;i=i+16|0;Lc=i;i=i+16|0;Mc=i;i=i+8|0;Nc=i;i=i+16|0;Oc=i;i=i+16|0;Pc=i;i=i+8|0;Qc=i;i=i+16|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+16|0;Uc=i;i=i+16|0;Vc=qa;FFa(qa);EQa(ra);GFa(sa,ta);GFa(ua,va);va=b+92|0;do{if((c[va>>2]|0)==0){if((c[263224>>2]|0)==0){KQa(za,c[b+80>>2]|0);HFa(ya,za,250200);RQa(ra,ya)|0;QQa(ya);QQa(za)}else{SQa(ra,c[263352>>2]|0)|0}ta=mc(lRa(ra)|0,250216)|0;if((ta|0)!=0){Wc=ta;break}c[pa>>2]=lRa(ra)|0;lwa(0,250224,pa)}else{Wc=0}}while(0);pa=bra(0)|0;if((pa|0)==0){ad(Wc|0)|0;lwa(0,250328,oa)}mra(pa,Vc);nra(pa,8,102);Vc=c[va>>2]|0;do{if((Vc|0)==0){oa=Aa;B$a(oa|0,0,1024)|0;while(1){za=vb(oa|0,1,1024,Wc|0)|0;ya=za>>>0<1024;if((ora(pa,oa,za,ya&1)|0)==0){Xc=12;break}if(ya){Xc=14;break}}if((Xc|0)==12){ad(Wc|0)|0;oa=lRa(ra)|0;ya=wra(tra(pa)|0)|0;za=ura(pa)|0;c[na>>2]=oa;c[na+4>>2]=ya;c[na+8>>2]=za;jwa(1,0,250408,na);ira(pa);lwa(0,250496,ma)}else if((Xc|0)==14){ad(Wc|0)|0;break}}else{if((ora(pa,Vc,x$a(Vc|0)|0,1)|0)!=0){break}za=c[r>>2]|0;ya=c[va>>2]|0;oa=wra(tra(pa)|0)|0;ta=ura(pa)|0;c[la>>2]=ya;c[la+4>>2]=oa;c[la+8>>2]=ta;Cd(za|0,250520,la|0)|0;za=c[va>>2]|0;ta=wra(tra(pa)|0)|0;oa=ura(pa)|0;c[ka>>2]=za;c[ka+4>>2]=ta;c[ka+8>>2]=oa;jwa(1,0,250536,ka);ira(pa);lwa(0,250496,ja)}}while(0);ja=qa;KQa(Ca,250624);LFa(Ba,ja,Ca);MFa(Da,ja);ka=KFa(Ba,Da)|0;QQa(Ca);Ca=b+88|0;Da=c[Ca>>2]|0;do{if(ka){Ba=lRa(ra)|0;c[ia>>2]=Da;c[ia+4>>2]=Ba;jwa(1,0,250632,ia)}else{KQa(Ea,250624);Ba=t$a(Da,lRa(vFa(ja,Ea)|0)|0)|0;QQa(Ea);if((Ba|0)==0){break}ira(pa);KQa(Fa,250624);Ba=lRa(vFa(ja,Fa)|0)|0;va=lRa(ra)|0;la=c[Ca>>2]|0;c[ha>>2]=Ba;c[ha+4>>2]=va;c[ha+8>>2]=la;jwa(1,0,250680,ha);QQa(Fa);lwa(0,250496,ga)}}while(0);NFa(qa,b,c[263436>>2]|0,c[263440>>2]|0);hwa(23,1,250776,fa);fa=qa+12|0;KQa(Ha,250816);GQa(Ga,vFa(fa,Ha)|0);ga=d;AFa(Ga,ga,0.0);QQa(Ga);QQa(Ha);Ha=ea;h[k>>3]=+h[ga>>3];c[Ha>>2]=c[k>>2];c[Ha+4>>2]=c[k+4>>2];hwa(23,0,250832,ea);KQa(Ja,250848);GQa(Ia,vFa(fa,Ja)|0);ea=d+8|0;AFa(Ia,ea,1.0);QQa(Ia);QQa(Ja);Ja=da;h[k>>3]=+h[ea>>3];c[Ja>>2]=c[k>>2];c[Ja+4>>2]=c[k+4>>2];hwa(23,0,250864,da);KQa(La,250880);GQa(Ka,vFa(fa,La)|0);da=d+24|0;AFa(Ka,da,(+h[ea>>3]- +h[ga>>3])/500.0);QQa(Ka);QQa(La);La=ca;h[k>>3]=+h[da>>3];c[La>>2]=c[k>>2];c[La+4>>2]=c[k+4>>2];hwa(23,0,250896,ca);KQa(Na,250912);GQa(Ma,vFa(fa,Na)|0);ca=d+32|0;AFa(Ma,ca,1.0e-5);QQa(Ma);QQa(Na);Na=ba;h[k>>3]=+h[ca>>3];c[Na>>2]=c[k>>2];c[Na+4>>2]=c[k+4>>2];hwa(23,0,250928,ba);KQa(Pa,250944);GQa(Oa,vFa(fa,Pa)|0);ba=d+40|0;uFa(Oa,ba);QQa(Oa);QQa(Pa);c[aa>>2]=c[ba>>2];hwa(23,0,250952,aa);KQa(Ra,250976);GQa(Qa,vFa(fa,Ra)|0);aa=d+44|0;uFa(Qa,aa);QQa(Qa);QQa(Ra);c[$>>2]=c[aa>>2];hwa(23,0,250992,$);KQa(Ta,251016);GQa(Sa,vFa(fa,Ta)|0);fa=d+48|0;uFa(Sa,fa);QQa(Sa);QQa(Ta);c[_>>2]=c[fa>>2];hwa(23,0,251032,_);KQa(Va,251056);GQa(Ua,vFa(ja,Va)|0);_=d+268|0;uFa(Ua,_);QQa(Ua);QQa(Va);c[Z>>2]=c[_>>2];hwa(23,0,251080,Z);if((c[206236>>2]|0)!=0){le[c[51674]&2047](23)}KQa(eb,251104);GQa(db,vFa(ja,eb)|0);xFa(db,Wa,0);QQa(db);QQa(eb);KQa(gb,251136);GQa(fb,vFa(ja,gb)|0);xFa(fb,Xa,0);QQa(fb);QQa(gb);KQa(ib,251168);GQa(hb,vFa(ja,ib)|0);xFa(hb,Ya,0);QQa(hb);QQa(ib);KQa(kb,251192);GQa(jb,vFa(ja,kb)|0);xFa(jb,_a,0);QQa(jb);QQa(kb);KQa(mb,251224);GQa(lb,vFa(ja,mb)|0);xFa(lb,Za,0);QQa(lb);QQa(mb);KQa(ob,251264);GQa(nb,vFa(ja,ob)|0);xFa(nb,ab,0);QQa(nb);QQa(ob);KQa(qb,251296);GQa(pb,vFa(ja,qb)|0);xFa(pb,$a,0);QQa(pb);QQa(qb);KQa(sb,251336);GQa(rb,vFa(ja,sb)|0);xFa(rb,cb,0);QQa(rb);QQa(sb);KQa(ub,251368);GQa(tb,vFa(ja,ub)|0);xFa(tb,bb,0);QQa(tb);QQa(ub);ub=c[Wa>>2]|0;Wa=b+104|0;do{if((ub|0)==(c[Wa>>2]|0)){tb=b+108|0;if((c[Xa>>2]|0)!=((c[tb>>2]|0)-(ub<<1)|0)){break}ja=b+128|0;if((c[Ya>>2]|0)!=(c[ja>>2]|0)){break}sb=b+132|0;if((c[_a>>2]|0)!=(c[sb>>2]|0)){break}rb=b+116|0;if((c[Za>>2]|0)!=(c[rb>>2]|0)){break}qb=b+136|0;if((c[ab>>2]|0)!=(c[qb>>2]|0)){break}pb=b+120|0;if((c[$a>>2]|0)!=(c[pb>>2]|0)){break}ob=b+140|0;if((c[cb>>2]|0)!=(c[ob>>2]|0)){break}nb=b+124|0;if((c[bb>>2]|0)!=(c[nb>>2]|0)){break}c[O>>2]=251912;hwa(4,1,251888,O);if((c[Wa>>2]|0)>0){mb=b;lb=qa+24|0;kb=0;do{jb=c[mb>>2]|0;c[wb>>2]=kb;ib=OFa(lb,wb)|0;tFa(ib,jb+(kb*112|0)|0);yFa(ib,jb+(kb*112|0)+40|0);hb=jb+(kb*112|0)+4|0;do{if((a[c[hb>>2]|0]|0)==36){a[(c[mb>>2]|0)+(kb*112|0)+104|0]=1}else{if((c[263220>>2]|0)!=0){break}KQa(xb,251928);jb=(oRa(vFa(ib,xb)|0,250064)|0)==0;QQa(xb);if(!jb){break}c[N>>2]=c[hb>>2];hwa(4,0,251944,N);a[(c[mb>>2]|0)+(kb*112|0)+104|0]=1}}while(0);KQa(yb,c[hb>>2]|0);c[(PFa(sa,yb)|0)>>2]=kb;QQa(yb);kb=kb+1|0;}while((kb|0)<(c[Wa>>2]|0))}if((c[206160>>2]|0)!=0){le[c[51674]&2047](4)}c[M>>2]=251976;hwa(4,1,251888,M);kb=c[Wa>>2]|0;if((kb|0)>0){mb=b;lb=qa+36|0;ib=kb;kb=0;do{jb=ib+kb|0;gb=c[mb>>2]|0;c[zb>>2]=kb;fb=OFa(lb,zb)|0;tFa(fb,gb+(jb*112|0)|0);yFa(fb,gb+(jb*112|0)+40|0);eb=gb+(jb*112|0)+4|0;do{if((a[c[eb>>2]|0]|0)==36){a[(c[mb>>2]|0)+(jb*112|0)+104|0]=1}else{if((c[263220>>2]|0)!=0){break}KQa(Ab,251928);gb=(oRa(vFa(fb,Ab)|0,250064)|0)==0;QQa(Ab);if(!gb){break}c[L>>2]=c[eb>>2];hwa(4,0,251944,L);a[(c[mb>>2]|0)+(jb*112|0)+104|0]=1}}while(0);KQa(Bb,c[eb>>2]|0);c[(PFa(sa,Bb)|0)>>2]=jb;QQa(Bb);kb=kb+1|0;ib=c[Wa>>2]|0;}while((kb|0)<(ib|0))}if((c[206160>>2]|0)!=0){le[c[51674]&2047](4)}c[K>>2]=252e3;hwa(4,1,251888,K);ib=c[Wa>>2]<<1;if(((c[tb>>2]|0)-ib|0)>0){kb=b;mb=qa+48|0;lb=ib;ib=0;do{fb=lb+ib|0;hb=c[kb>>2]|0;c[Cb>>2]=ib;gb=OFa(mb,Cb)|0;tFa(gb,hb+(fb*112|0)|0);yFa(gb,hb+(fb*112|0)+40|0);db=hb+(fb*112|0)+4|0;do{if((a[c[db>>2]|0]|0)==36){a[(c[kb>>2]|0)+(fb*112|0)+104|0]=1}else{if((c[263220>>2]|0)!=0){break}KQa(Db,251928);hb=(oRa(vFa(gb,Db)|0,250064)|0)==0;QQa(Db);if(!hb){break}c[J>>2]=c[db>>2];hwa(4,0,251944,J);a[(c[kb>>2]|0)+(fb*112|0)+104|0]=1}}while(0);KQa(Eb,c[db>>2]|0);c[(PFa(sa,Eb)|0)>>2]=fb;QQa(Eb);ib=ib+1|0;lb=c[Wa>>2]<<1;}while((ib|0)<((c[tb>>2]|0)-lb|0))}if((c[206160>>2]|0)!=0){le[c[51674]&2047](4)}c[I>>2]=252016;hwa(4,1,251888,I);if((c[rb>>2]|0)>0){lb=b+4|0;tb=qa+84|0;ib=0;do{kb=c[lb>>2]|0;c[Fb>>2]=ib;mb=OFa(tb,Fb)|0;tFa(mb,kb+(ib*60|0)|0);BFa(mb,kb+(ib*60|0)+36|0);gb=kb+(ib*60|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[lb>>2]|0)+(ib*60|0)+56|0]=1}else{if((c[263220>>2]|0)!=0){break}KQa(Gb,251928);kb=(oRa(vFa(mb,Gb)|0,250064)|0)==0;QQa(Gb);if(!kb){break}c[H>>2]=c[gb>>2];hwa(4,0,251944,H);a[(c[lb>>2]|0)+(ib*60|0)+56|0]=1}}while(0);KQa(Hb,c[gb>>2]|0);c[(PFa(sa,Hb)|0)>>2]=ib;QQa(Hb);ib=ib+1|0;}while((ib|0)<(c[rb>>2]|0))}if((c[206160>>2]|0)!=0){le[c[51674]&2047](4)}c[G>>2]=252040;hwa(4,1,251888,G);if((c[pb>>2]|0)>0){rb=b+8|0;ib=qa+120|0;lb=0;do{tb=c[rb>>2]|0;c[Ib>>2]=lb;mb=OFa(ib,Ib)|0;tFa(mb,tb+(lb*48|0)|0);CFa(mb,tb+(lb*48|0)+36|0);fb=tb+(lb*48|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[rb>>2]|0)+(lb*48|0)+44|0]=1}else{if((c[263220>>2]|0)!=0){break}KQa(Jb,251928);tb=(oRa(vFa(mb,Jb)|0,250064)|0)==0;QQa(Jb);if(!tb){break}c[F>>2]=c[fb>>2];hwa(4,0,251944,F);a[(c[rb>>2]|0)+(lb*48|0)+44|0]=1}}while(0);KQa(Kb,c[fb>>2]|0);c[(PFa(sa,Kb)|0)>>2]=lb;QQa(Kb);lb=lb+1|0;}while((lb|0)<(c[pb>>2]|0))}if((c[206160>>2]|0)!=0){le[c[51674]&2047](4)}c[E>>2]=252064;hwa(4,1,251888,E);if((c[nb>>2]|0)>0){pb=b+12|0;lb=qa+156|0;rb=0;do{ib=c[pb>>2]|0;c[Lb>>2]=rb;mb=OFa(lb,Lb)|0;tFa(mb,ib+(rb*52|0)|0);DFa(mb,ib+(rb*52|0)+36|0);gb=ib+(rb*52|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[pb>>2]|0)+(rb*52|0)+48|0]=1}else{if((c[263220>>2]|0)!=0){break}KQa(Mb,251928);ib=(oRa(vFa(mb,Mb)|0,250064)|0)==0;QQa(Mb);if(!ib){break}c[D>>2]=c[gb>>2];hwa(4,0,251944,D);a[(c[pb>>2]|0)+(rb*52|0)+48|0]=1}}while(0);KQa(Nb,c[gb>>2]|0);c[(PFa(sa,Nb)|0)>>2]=rb;QQa(Nb);rb=rb+1|0;}while((rb|0)<(c[nb>>2]|0))}if((c[206160>>2]|0)!=0){le[c[51674]&2047](4)}c[C>>2]=252088;hwa(4,1,251888,C);if((c[ja>>2]|0)>0){nb=b+16|0;rb=qa+60|0;pb=0;do{lb=c[nb>>2]|0;c[Ob>>2]=pb;mb=OFa(rb,Ob)|0;tFa(mb,lb+(pb*112|0)|0);yFa(mb,lb+(pb*112|0)+40|0);fb=lb+(pb*112|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[nb>>2]|0)+(pb*112|0)+104|0]=1}else{if((c[263220>>2]|0)!=0){break}KQa(Pb,251928);lb=(oRa(vFa(mb,Pb)|0,250064)|0)==0;QQa(Pb);if(!lb){break}c[B>>2]=c[fb>>2];hwa(4,0,251944,B);a[(c[nb>>2]|0)+(pb*112|0)+104|0]=1}}while(0);KQa(Qb,c[fb>>2]|0);c[(PFa(ua,Qb)|0)>>2]=pb;QQa(Qb);pb=pb+1|0;}while((pb|0)<(c[ja>>2]|0))}if((c[206160>>2]|0)!=0){le[c[51674]&2047](4)}c[A>>2]=252104;hwa(4,1,251888,A);if((c[sb>>2]|0)>0){ja=b+20|0;pb=qa+96|0;nb=0;do{rb=c[ja>>2]|0;c[Rb>>2]=nb;mb=OFa(pb,Rb)|0;tFa(mb,rb+(nb*60|0)|0);BFa(mb,rb+(nb*60|0)+36|0);gb=rb+(nb*60|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[ja>>2]|0)+(nb*60|0)+56|0]=1}else{if((c[263220>>2]|0)!=0){break}KQa(Sb,251928);rb=(oRa(vFa(mb,Sb)|0,250064)|0)==0;QQa(Sb);if(!rb){break}c[z>>2]=c[gb>>2];hwa(4,0,251944,z);a[(c[ja>>2]|0)+(nb*60|0)+56|0]=1}}while(0);KQa(Tb,c[gb>>2]|0);c[(PFa(ua,Tb)|0)>>2]=nb;QQa(Tb);nb=nb+1|0;}while((nb|0)<(c[sb>>2]|0))}if((c[206160>>2]|0)!=0){le[c[51674]&2047](4)}c[y>>2]=252128;hwa(4,1,251888,y);if((c[qb>>2]|0)>0){sb=b+24|0;nb=qa+132|0;ja=0;do{pb=c[sb>>2]|0;c[Ub>>2]=ja;mb=OFa(nb,Ub)|0;tFa(mb,pb+(ja*48|0)|0);CFa(mb,pb+(ja*48|0)+36|0);fb=pb+(ja*48|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[sb>>2]|0)+(ja*48|0)+44|0]=1}else{if((c[263220>>2]|0)!=0){break}KQa(Vb,251928);pb=(oRa(vFa(mb,Vb)|0,250064)|0)==0;QQa(Vb);if(!pb){break}c[x>>2]=c[fb>>2];hwa(4,0,251944,x);a[(c[sb>>2]|0)+(ja*48|0)+44|0]=1}}while(0);KQa(Wb,c[fb>>2]|0);c[(PFa(ua,Wb)|0)>>2]=ja;QQa(Wb);ja=ja+1|0;}while((ja|0)<(c[qb>>2]|0))}if((c[206160>>2]|0)!=0){le[c[51674]&2047](4)}c[w>>2]=252152;hwa(4,1,251888,w);if((c[ob>>2]|0)>0){qb=b+28|0;ja=qa+168|0;sb=0;do{nb=c[qb>>2]|0;c[Xb>>2]=sb;mb=OFa(ja,Xb)|0;tFa(mb,nb+(sb*52|0)|0);DFa(mb,nb+(sb*52|0)+36|0);gb=nb+(sb*52|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[qb>>2]|0)+(sb*52|0)+48|0]=1}else{if((c[263220>>2]|0)!=0){break}KQa(Yb,251928);nb=(oRa(vFa(mb,Yb)|0,250064)|0)==0;QQa(Yb);if(!nb){break}c[v>>2]=c[gb>>2];hwa(4,0,251944,v);a[(c[qb>>2]|0)+(sb*52|0)+48|0]=1}}while(0);KQa(Zb,c[gb>>2]|0);c[(PFa(ua,Zb)|0)>>2]=sb;QQa(Zb);sb=sb+1|0;}while((sb|0)<(c[ob>>2]|0))}if((c[206160>>2]|0)!=0){le[c[51674]&2047](4)}hwa(4,1,252176,u);ob=b+208|0;a:do{if((c[ob>>2]|0)>0){sb=qa+72|0;qb=b+32|0;ja=0;b:while(1){c[_b>>2]=ja;mb=OFa(sb,_b)|0;tFa(mb,(c[qb>>2]|0)+(ja*52|0)+12|0);EQa($b);c[bc>>2]=ja;mb=OFa(sb,bc)|0;KQa(cc,252216);GQa(ac,vFa(mb,cc)|0);QFa(ac,$b);QQa(ac);QQa(cc);mb=(oRa($b,252224)|0)==0;fb=c[qb>>2]|0;nb=mb&1;c[fb+(ja*52|0)>>2]=nb;c[t>>2]=c[fb+(ja*52|0)+16>>2];c[t+4>>2]=nb;hwa(4,0,252240,t);nb=c[qb>>2]|0;if((a[c[nb+(ja*52|0)+16>>2]|0]|0)==36){a[nb+(ja*52|0)+48|0]=1}c[ec>>2]=ja;nb=OFa(sb,ec)|0;KQa(fc,252280);GQa(dc,vFa(nb,fc)|0);QFa(dc,$b);QQa(dc);QQa(fc);RFa(wa,sa,$b);RFa(xa,ua,$b);TFa(gc,sa);do{if(SFa(wa,gc)|0){nb=c[(UFa(wa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(ja*52|0)+4>>2]=nb;a[fb+(ja*52|0)+8|0]=0}else{TFa(hc,ua);if(SFa(xa,hc)|0){fb=c[(UFa(xa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(ja*52|0)+4>>2]=fb;a[nb+(ja*52|0)+8|0]=1;break}if((oRa($b,252296)|0)!=0){break b}a[(c[qb>>2]|0)+(ja*52|0)+8|0]=2}}while(0);QQa($b);ja=ja+1|0;if((ja|0)>=(c[ob>>2]|0)){break a}}zRa(jc,252304,$b);HFa(ic,jc,252328);QQa(jc);c[s>>2]=lRa(ic)|0;lwa(0,252344,s)}}while(0);if((c[206160>>2]|0)!=0){le[c[51674]&2047](4)}hwa(4,1,252352,q);ob=b+212|0;c:do{if((c[ob>>2]|0)>0){ja=qa+108|0;qb=b+36|0;sb=0;while(1){c[kc>>2]=sb;gb=OFa(ja,kc)|0;tFa(gb,(c[qb>>2]|0)+(sb*52|0)+12|0);EQa(lc);c[oc>>2]=sb;gb=OFa(ja,oc)|0;KQa(pc,252216);GQa(nc,vFa(gb,pc)|0);QFa(nc,lc);QQa(nc);QQa(pc);gb=(oRa(lc,252224)|0)==0;nb=c[qb>>2]|0;fb=gb&1;c[nb+(sb*52|0)>>2]=fb;c[p>>2]=c[nb+(sb*52|0)+16>>2];c[p+4>>2]=fb;hwa(4,0,252240,p);fb=c[qb>>2]|0;if((a[c[fb+(sb*52|0)+16>>2]|0]|0)==36){a[fb+(sb*52|0)+48|0]=1}c[rc>>2]=sb;fb=OFa(ja,rc)|0;KQa(sc,252280);GQa(qc,vFa(fb,sc)|0);QFa(qc,lc);QQa(qc);QQa(sc);RFa(wa,sa,lc);RFa(xa,ua,lc);TFa(tc,sa);if(SFa(wa,tc)|0){fb=c[(UFa(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(sb*52|0)+4>>2]=fb;a[nb+(sb*52|0)+8|0]=0}else{TFa(uc,ua);if(!(SFa(xa,uc)|0)){break}nb=c[(UFa(xa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(sb*52|0)+4>>2]=nb;a[fb+(sb*52|0)+8|0]=1}QQa(lc);sb=sb+1|0;if((sb|0)>=(c[ob>>2]|0)){break c}}zRa(wc,252392,lc);HFa(vc,wc,252328);QQa(wc);c[o>>2]=lRa(vc)|0;lwa(0,252344,o)}}while(0);if((c[206160>>2]|0)!=0){le[c[51674]&2047](4)}hwa(4,1,252416,n);ob=b+216|0;d:do{if((c[ob>>2]|0)>0){sb=qa+144|0;qb=b+40|0;ja=0;while(1){c[xc>>2]=ja;fb=OFa(sb,xc)|0;tFa(fb,(c[qb>>2]|0)+(ja*52|0)+12|0);EQa(yc);c[Ac>>2]=ja;fb=OFa(sb,Ac)|0;KQa(Bc,252216);GQa(zc,vFa(fb,Bc)|0);QFa(zc,yc);QQa(zc);QQa(Bc);fb=(oRa(yc,252224)|0)==0;nb=c[qb>>2]|0;gb=fb&1;c[nb+(ja*52|0)>>2]=gb;c[m>>2]=c[nb+(ja*52|0)+16>>2];c[m+4>>2]=gb;hwa(4,0,252240,m);gb=c[qb>>2]|0;if((a[c[gb+(ja*52|0)+16>>2]|0]|0)==36){a[gb+(ja*52|0)+48|0]=1}c[Dc>>2]=ja;gb=OFa(sb,Dc)|0;KQa(Ec,252280);GQa(Cc,vFa(gb,Ec)|0);QFa(Cc,yc);QQa(Cc);QQa(Ec);RFa(wa,sa,yc);RFa(xa,ua,yc);TFa(Fc,sa);if(SFa(wa,Fc)|0){gb=c[(UFa(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(ja*52|0)+4>>2]=gb;a[nb+(ja*52|0)+8|0]=0}else{TFa(Gc,ua);if(!(SFa(xa,Gc)|0)){break}nb=c[(UFa(xa)|0)+12>>2]|0;gb=c[qb>>2]|0;c[gb+(ja*52|0)+4>>2]=nb;a[gb+(ja*52|0)+8|0]=1}QQa(yc);ja=ja+1|0;if((ja|0)>=(c[ob>>2]|0)){break d}}zRa(Ic,252456,yc);HFa(Hc,Ic,252328);QQa(Ic);c[l>>2]=lRa(Hc)|0;lwa(0,252344,l)}}while(0);if((c[206160>>2]|0)!=0){le[c[51674]&2047](4)}hwa(4,1,252480,j);ob=b+220|0;e:do{if((c[ob>>2]|0)>0){ja=qa+180|0;qb=b+44|0;sb=0;while(1){c[Jc>>2]=sb;gb=OFa(ja,Jc)|0;tFa(gb,(c[qb>>2]|0)+(sb*52|0)+12|0);EQa(Kc);c[Mc>>2]=sb;gb=OFa(ja,Mc)|0;KQa(Nc,252216);GQa(Lc,vFa(gb,Nc)|0);QFa(Lc,Kc);QQa(Lc);QQa(Nc);gb=(oRa(Kc,252224)|0)==0;nb=c[qb>>2]|0;fb=gb&1;c[nb+(sb*52|0)>>2]=fb;c[g>>2]=c[nb+(sb*52|0)+16>>2];c[g+4>>2]=fb;hwa(4,0,252240,g);fb=c[qb>>2]|0;if((a[c[fb+(sb*52|0)+16>>2]|0]|0)==36){a[fb+(sb*52|0)+48|0]=1}c[Pc>>2]=sb;fb=OFa(ja,Pc)|0;KQa(Qc,252280);GQa(Oc,vFa(fb,Qc)|0);QFa(Oc,Kc);QQa(Oc);QQa(Qc);RFa(wa,sa,Kc);RFa(xa,ua,Kc);TFa(Rc,sa);if(SFa(wa,Rc)|0){fb=c[(UFa(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(sb*52|0)+4>>2]=fb;a[nb+(sb*52|0)+8|0]=0}else{TFa(Sc,ua);if(!(SFa(xa,Sc)|0)){break}nb=c[(UFa(xa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(sb*52|0)+4>>2]=nb;a[fb+(sb*52|0)+8|0]=1}QQa(Kc);sb=sb+1|0;if((sb|0)>=(c[ob>>2]|0)){break e}}zRa(Uc,252520,Kc);HFa(Tc,Uc,252328);QQa(Uc);c[f>>2]=lRa(Tc)|0;lwa(0,252344,f)}}while(0);if((c[206160>>2]|0)==0){ira(pa);VFa(ua);VFa(sa);QQa(ra);WFa(qa);i=e;return}le[c[51674]&2047](4);ira(pa);VFa(ua);VFa(sa);QQa(ra);WFa(qa);i=e;return}}while(0);if((c[206232>>2]|c[51534]|0)==0){ira(pa);Yc=Ad(0)|0;Id(-1)}jwa(22,1,251408,Y);Y=c[Wa>>2]|0;c[X>>2]=ub;c[X+4>>2]=Y;jwa(22,0,251456,X);X=(c[b+108>>2]|0)-(c[Wa>>2]<<1)|0;c[W>>2]=c[Xa>>2];c[W+4>>2]=X;jwa(22,0,251504,W);W=c[b+128>>2]|0;c[V>>2]=c[Ya>>2];c[V+4>>2]=W;jwa(22,0,251552,V);V=c[b+132>>2]|0;c[U>>2]=c[_a>>2];c[U+4>>2]=V;jwa(22,0,251600,U);U=c[b+116>>2]|0;c[T>>2]=c[Za>>2];c[T+4>>2]=U;jwa(22,0,251648,T);T=c[b+136>>2]|0;c[S>>2]=c[ab>>2];c[S+4>>2]=T;jwa(22,0,251696,S);S=c[b+120>>2]|0;c[R>>2]=c[$a>>2];c[R+4>>2]=S;jwa(22,0,251744,R);R=c[b+140>>2]|0;c[Q>>2]=c[cb>>2];c[Q+4>>2]=R;jwa(22,0,251792,Q);Q=c[b+124>>2]|0;c[P>>2]=c[bb>>2];c[P+4>>2]=Q;jwa(22,0,251840,P);le[c[51674]&2047](22);ira(pa);Yc=Ad(0)|0;Id(-1)}function FFa(a){a=a|0;var b=0;b=i;HMa(a);i=b;return}function GFa(a,b){a=a|0;b=b|0;b=i;mIa(a,0);i=b;return}function HFa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+8|0;FQa(a,d);e=OQa(b)|0;f=uGa(c)|0;pRa(a,PQa(b)|0,e,f+e|0);hRa(a,c,f)|0;i=d;return}function IFa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;if((t$a(b,253152)|0)==0){t=c[d>>2]|0;if((t|0)==0){i=e;return}u=a;v=t;t=0;do{KQa(g,v);w=vFa(u,g)|0;SQa(w,c[d+((t|1)<<2)>>2]|0)|0;QQa(g);t=t+2|0;v=c[d+(t<<2)>>2]|0;}while((v|0)!=0);i=e;return}if((t$a(b,253176)|0)==0){v=c[d>>2]|0;if((v|0)==0){i=e;return}t=a+12|0;g=v;v=0;do{KQa(h,g);u=vFa(t,h)|0;SQa(u,c[d+((v|1)<<2)>>2]|0)|0;QQa(h);v=v+2|0;g=c[d+(v<<2)>>2]|0;}while((g|0)!=0);i=e;return}if((t$a(b,253200)|0)!=0){do{if((t$a(b,253456)|0)!=0){if((t$a(b,253464)|0)==0){break}if((t$a(b,253472)|0)==0){break}if((t$a(b,253480)|0)==0){break}i=e;return}}while(0);g=(c[d>>2]|0)==0;v=a+196|0;h=a+192|0;t=OFa(c[v>>2]|0,h)|0;if(g){x=t}else{g=t;t=d;u=0;while(1){KQa(r,c[t>>2]|0);w=vFa(g,r)|0;SQa(w,c[d+((u|1)<<2)>>2]|0)|0;QQa(r);w=u+2|0;y=d+(w<<2)|0;z=(c[y>>2]|0)==0;A=OFa(c[v>>2]|0,h)|0;if(z){x=A;break}else{u=w;t=y;g=A}}}KQa(s,253488);SQa(vFa(x,s)|0,b)|0;QQa(s);i=e;return}XFa(j,k);EQa(l);EQa(m);k=a+192|0;s=k;c[k>>2]=-1;b=a+196|0;c[b>>2]=0;x=c[d>>2]|0;if((x|0)!=0){g=x;x=0;do{KQa(n,g);t=vFa(j,n)|0;SQa(t,c[d+((x|1)<<2)>>2]|0)|0;QQa(n);x=x+2|0;g=c[d+(x<<2)>>2]|0;}while((g|0)!=0)}KQa(o,253216);RQa(l,vFa(j,o)|0)|0;QQa(o);KQa(p,253232);RQa(m,vFa(j,p)|0)|0;QQa(p);c[k>>2]=Ic(lRa(l)|0)|0;if((oRa(m,253248)|0)==0){B=a+24|0}else{B=c[b>>2]|0}c[b>>2]=B;if((oRa(m,253256)|0)==0){C=a+36|0}else{C=c[b>>2]|0}c[b>>2]=C;if((oRa(m,253264)|0)==0){D=a+48|0}else{D=c[b>>2]|0}c[b>>2]=D;if((oRa(m,253272)|0)==0){E=a+60|0}else{E=c[b>>2]|0}c[b>>2]=E;if((oRa(m,253280)|0)==0){F=a+72|0}else{F=c[b>>2]|0}c[b>>2]=F;if((oRa(m,253288)|0)==0){G=a+84|0}else{G=c[b>>2]|0}c[b>>2]=G;if((oRa(m,253296)|0)==0){H=a+96|0}else{H=c[b>>2]|0}c[b>>2]=H;if((oRa(m,253304)|0)==0){I=a+108|0}else{I=c[b>>2]|0}c[b>>2]=I;if((oRa(m,253312)|0)==0){J=a+120|0}else{J=c[b>>2]|0}c[b>>2]=J;if((oRa(m,253320)|0)==0){K=a+132|0}else{K=c[b>>2]|0}c[b>>2]=K;if((oRa(m,253328)|0)==0){L=a+144|0}else{L=c[b>>2]|0}c[b>>2]=L;if((oRa(m,253336)|0)==0){M=a+156|0}else{M=c[b>>2]|0}c[b>>2]=M;if((oRa(m,253344)|0)==0){N=a+168|0}else{N=c[b>>2]|0}c[b>>2]=N;if((oRa(m,253352)|0)==0){O=a+180|0}else{O=c[b>>2]|0}c[b>>2]=O;a=lRa(m)|0;KQa(q,249776);N=lRa(vFa(j,q)|0)|0;c[f>>2]=a;c[f+4>>2]=N;kwa(0,(O|0)!=0|0,253360,f);QQa(q);kLa(OFa(c[b>>2]|0,s)|0,j)|0;QQa(m);QQa(l);dGa(j);i=e;return}function JFa(a,b){a=a|0;b=b|0;i=i;return}function KFa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=XHa(a,b)|0;i=c;return d|0}function LFa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;eIa(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];YHa(a,f);i=e;return}function MFa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;ZHa(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];YHa(a,e);i=d;return}function NFa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0;f=i;i=i+8|0;g=f;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+192|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+16|0;S=i;i=i+16|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+16|0;X=i;i=i+16|0;Y=i;i=i+16|0;Z=i;i=i+16|0;_=i;i=i+8|0;$=i;i=i+16|0;aa=i;i=i+8|0;ba=i;i=i+16|0;ca=i;i=i+8|0;da=i;i=i+16|0;ea=i;i=i+8|0;fa=i;i=i+16|0;ga=i;i=i+8|0;ha=i;i=i+16|0;ia=i;i=i+8|0;ja=i;i=i+16|0;ka=i;i=i+8|0;la=i;i=i+16|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+16|0;qa=i;i=i+8|0;ra=i;i=i+16|0;sa=i;i=i+8|0;ta=i;i=i+16|0;ua=i;i=i+8|0;va=i;i=i+16|0;wa=i;i=i+8|0;xa=i;i=i+16|0;ya=i;i=i+8|0;za=i;i=i+16|0;Aa=i;i=i+8|0;Ba=i;i=i+16|0;Ca=i;i=i+8|0;Da=i;i=i+16|0;Ea=i;i=i+8|0;Fa=i;i=i+16|0;Ga=i;i=i+8|0;Ha=i;i=i+16|0;Ia=i;i=i+8|0;Ja=i;i=i+16|0;Ka=i;i=i+8|0;La=i;i=i+16|0;Ma=i;i=i+8|0;Na=i;i=i+16|0;Oa=i;i=i+8|0;Pa=i;i=i+16|0;Qa=i;i=i+8|0;Ra=i;i=i+16|0;Sa=i;i=i+8|0;Ta=i;i=i+16|0;Ua=i;i=i+8|0;Va=i;i=i+16|0;Wa=i;i=i+8|0;Xa=i;i=i+16|0;Ya=i;i=i+8|0;Za=i;i=i+16|0;_a=i;i=i+8|0;$a=i;i=i+16|0;ab=i;i=i+8|0;bb=i;i=i+16|0;cb=i;i=i+8|0;db=i;i=i+16|0;eb=i;i=i+8|0;fb=i;i=i+16|0;gb=i;i=i+8|0;hb=i;i=i+16|0;ib=i;i=i+8|0;jb=i;i=i+16|0;kb=i;i=i+8|0;lb=i;i=i+16|0;mb=i;i=i+8|0;nb=i;i=i+16|0;ob=i;i=i+8|0;pb=i;i=i+16|0;qb=i;i=i+8|0;rb=i;i=i+16|0;sb=i;i=i+8|0;tb=i;i=i+16|0;ub=i;i=i+8|0;vb=i;i=i+16|0;wb=i;i=i+8|0;xb=i;i=i+16|0;yb=i;i=i+8|0;zb=i;i=i+16|0;Ab=i;i=i+8|0;Bb=i;i=i+16|0;Cb=i;i=i+8|0;Db=i;i=i+16|0;Eb=i;i=i+8|0;Fb=i;i=i+16|0;Gb=i;i=i+8|0;Hb=i;i=i+16|0;Ib=i;i=i+8|0;Jb=i;i=i+16|0;Kb=i;i=i+8|0;Lb=i;i=i+16|0;Mb=i;i=i+8|0;Nb=i;i=i+16|0;Ob=i;i=i+8|0;Pb=i;i=i+16|0;Qb=i;i=i+8|0;Rb=i;i=i+16|0;Sb=i;i=i+8|0;Tb=i;i=i+16|0;Ub=i;i=i+8|0;Vb=i;i=i+16|0;Wb=i;i=i+8|0;Xb=i;i=i+16|0;Yb=i;i=i+8|0;Zb=i;i=i+16|0;_b=i;i=i+8|0;ac=i;i=i+16|0;bc=i;i=i+8|0;cc=i;i=i+16|0;XFa(o,p);p=(d|0)!=0;dc=(e|0)==0;if(!(dc|p^1)){lwa(0,252544,n)}if(p){ec=Gd(d|0)|0}else{ec=0}if(dc){fc=ec}else{c[m>>2]=e;hwa(23,0,252688,m);YFa(q);ZFa(q,e,8);if(!(_Fa(q)|0)){c[l>>2]=e;lwa(0,252728,l)}EQa(r);l=q;$Fa(l,r)|0;GQa(s,r);while(1){e=$Fa(l,r)|0;if(!(ARa(e+(c[(c[e>>2]|0)+ -12>>2]|0)|0)|0)){break}zRa(t,252808,r);fRa(s,t)|0;QQa(t)}t=Gd(lRa(s)|0)|0;aGa(q);QQa(s);QQa(r);bGa(q);fc=t}if((fc|0)==0){hwa(23,0,252896,g);dGa(o);i=f;return}EQa(u);EQa(v);c[k>>2]=fc;hwa(23,0,252816,k);k=$b(fc|0,252808)|0;if((k|0)!=0){g=k;do{k=$_a(12)|0;KQa(k,g);t=mRa(k,252848,0)|0;kRa(w,k,0,t);RQa(u,w)|0;QQa(w);kRa(x,k,t+1|0,(XQa(k)|0)+~t|0);RQa(v,x)|0;QQa(x);RQa(vFa(o,u)|0,v)|0;t=lRa(u)|0;k=lRa(v)|0;c[j>>2]=t;c[j+4>>2]=k;hwa(23,0,252856,j);g=$b(0,252808)|0;}while((g|0)!=0)}W_a(fc);fc=a+12|0;KQa(y,250944);g=vFa(fc,y)|0;KQa(z,250944);if((cGa(o,z)|0)==0){KQa(B,250944);gc=1;hc=0;ic=vFa(fc,B)|0}else{KQa(A,250944);gc=0;hc=1;ic=vFa(o,A)|0}RQa(g,ic)|0;if(gc){QQa(B)}if(hc){QQa(A)}QQa(z);QQa(y);KQa(C,250816);y=vFa(fc,C)|0;KQa(D,250816);if((cGa(o,D)|0)==0){KQa(F,250816);jc=1;kc=0;lc=vFa(fc,F)|0}else{KQa(E,250816);jc=0;kc=1;lc=vFa(o,E)|0}RQa(y,lc)|0;if(jc){QQa(F)}if(kc){QQa(E)}QQa(D);QQa(C);KQa(G,250848);C=vFa(fc,G)|0;KQa(H,250848);if((cGa(o,H)|0)==0){KQa(J,250848);mc=1;nc=0;oc=vFa(fc,J)|0}else{KQa(I,250848);mc=0;nc=1;oc=vFa(o,I)|0}RQa(C,oc)|0;if(mc){QQa(J)}if(nc){QQa(I)}QQa(H);QQa(G);KQa(K,250880);G=vFa(fc,K)|0;KQa(L,250880);if((cGa(o,L)|0)==0){KQa(N,250880);pc=0;qc=1;rc=vFa(fc,N)|0}else{KQa(M,250880);pc=1;qc=0;rc=vFa(o,M)|0}RQa(G,rc)|0;if(qc){QQa(N)}if(pc){QQa(M)}QQa(L);QQa(K);KQa(O,250912);K=vFa(fc,O)|0;KQa(P,250912);if((cGa(o,P)|0)==0){KQa(R,250912);sc=1;tc=0;uc=vFa(fc,R)|0}else{KQa(Q,250912);sc=0;tc=1;uc=vFa(o,Q)|0}RQa(K,uc)|0;if(sc){QQa(R)}if(tc){QQa(Q)}QQa(P);QQa(O);KQa(S,250976);O=vFa(fc,S)|0;KQa(T,250976);if((cGa(o,T)|0)==0){KQa(V,250976);vc=1;wc=0;xc=vFa(fc,V)|0}else{KQa(U,250976);vc=0;wc=1;xc=vFa(o,U)|0}RQa(O,xc)|0;if(vc){QQa(V)}if(wc){QQa(U)}QQa(T);QQa(S);KQa(W,251016);S=vFa(fc,W)|0;KQa(X,251016);if((cGa(o,X)|0)==0){KQa(Z,251016);yc=1;zc=0;Ac=vFa(fc,Z)|0}else{KQa(Y,251016);yc=0;zc=1;Ac=vFa(o,Y)|0}RQa(S,Ac)|0;if(yc){QQa(Z)}if(zc){QQa(Y)}QQa(X);QQa(W);W=b+104|0;X=c[W>>2]|0;if((X|0)>0){Y=a+24|0;zc=a+36|0;Z=0;while(1){c[_>>2]=Z;yc=OFa(Y,_)|0;KQa($,249920);Ac=vFa(yc,$)|0;c[aa>>2]=Z;yc=OFa(Y,aa)|0;KQa(ba,249776);if((cGa(o,vFa(yc,ba)|0)|0)==0){c[ea>>2]=Z;yc=OFa(Y,ea)|0;KQa(fa,249920);Bc=1;Cc=0;Dc=vFa(yc,fa)|0}else{c[ca>>2]=Z;yc=OFa(Y,ca)|0;KQa(da,249776);Bc=0;Cc=1;Dc=vFa(o,vFa(yc,da)|0)|0}RQa(Ac,Dc)|0;if(Bc){QQa(fa)}if(Cc){QQa(da)}QQa(ba);QQa($);c[ga>>2]=Z;Ac=OFa(zc,ga)|0;KQa(ha,249920);yc=vFa(Ac,ha)|0;c[ia>>2]=Z;Ac=OFa(zc,ia)|0;KQa(ja,249776);if((cGa(o,vFa(Ac,ja)|0)|0)==0){c[ma>>2]=Z;Ac=OFa(zc,ma)|0;KQa(na,249920);Ec=1;Fc=0;Gc=vFa(Ac,na)|0}else{c[ka>>2]=Z;Ac=OFa(zc,ka)|0;KQa(la,249776);Ec=0;Fc=1;Gc=vFa(o,vFa(Ac,la)|0)|0}RQa(yc,Gc)|0;if(Ec){QQa(na)}if(Fc){QQa(la)}QQa(ja);QQa(ha);yc=Z+1|0;Ac=c[W>>2]|0;if((yc|0)<(Ac|0)){Z=yc}else{Hc=Ac;break}}}else{Hc=X}X=b+108|0;if(((c[X>>2]|0)-(Hc<<1)|0)>0){Hc=a+48|0;Z=0;do{c[oa>>2]=Z;ha=OFa(Hc,oa)|0;KQa(pa,249920);ja=vFa(ha,pa)|0;c[qa>>2]=Z;ha=OFa(Hc,qa)|0;KQa(ra,249776);if((cGa(o,vFa(ha,ra)|0)|0)==0){c[ua>>2]=Z;ha=OFa(Hc,ua)|0;KQa(va,249920);Ic=1;Jc=0;Kc=vFa(ha,va)|0}else{c[sa>>2]=Z;ha=OFa(Hc,sa)|0;KQa(ta,249776);Ic=0;Jc=1;Kc=vFa(o,vFa(ha,ta)|0)|0}RQa(ja,Kc)|0;if(Ic){QQa(va)}if(Jc){QQa(ta)}QQa(ra);QQa(pa);Z=Z+1|0;}while((Z|0)<((c[X>>2]|0)-(c[W>>2]<<1)|0))}W=b+116|0;if((c[W>>2]|0)>0){X=a+84|0;Z=0;do{c[wa>>2]=Z;pa=OFa(X,wa)|0;KQa(xa,249920);ra=vFa(pa,xa)|0;c[ya>>2]=Z;pa=OFa(X,ya)|0;KQa(za,249776);if((cGa(o,vFa(pa,za)|0)|0)==0){c[Ca>>2]=Z;pa=OFa(X,Ca)|0;KQa(Da,249920);Lc=1;Mc=0;Nc=vFa(pa,Da)|0}else{c[Aa>>2]=Z;pa=OFa(X,Aa)|0;KQa(Ba,249776);Lc=0;Mc=1;Nc=vFa(o,vFa(pa,Ba)|0)|0}RQa(ra,Nc)|0;if(Lc){QQa(Da)}if(Mc){QQa(Ba)}QQa(za);QQa(xa);Z=Z+1|0;}while((Z|0)<(c[W>>2]|0))}W=b+120|0;if((c[W>>2]|0)>0){Z=a+120|0;xa=0;do{c[Ea>>2]=xa;za=OFa(Z,Ea)|0;KQa(Fa,249920);Ba=vFa(za,Fa)|0;c[Ga>>2]=xa;za=OFa(Z,Ga)|0;KQa(Ha,249776);if((cGa(o,vFa(za,Ha)|0)|0)==0){c[Ka>>2]=xa;za=OFa(Z,Ka)|0;KQa(La,249920);Oc=1;Pc=0;Qc=vFa(za,La)|0}else{c[Ia>>2]=xa;za=OFa(Z,Ia)|0;KQa(Ja,249776);Oc=0;Pc=1;Qc=vFa(o,vFa(za,Ja)|0)|0}RQa(Ba,Qc)|0;if(Oc){QQa(La)}if(Pc){QQa(Ja)}QQa(Ha);QQa(Fa);xa=xa+1|0;}while((xa|0)<(c[W>>2]|0))}W=b+124|0;if((c[W>>2]|0)>0){xa=a+156|0;Fa=0;do{c[Ma>>2]=Fa;Ha=OFa(xa,Ma)|0;KQa(Na,249920);Ja=vFa(Ha,Na)|0;c[Oa>>2]=Fa;Ha=OFa(xa,Oa)|0;KQa(Pa,249776);if((cGa(o,vFa(Ha,Pa)|0)|0)==0){c[Sa>>2]=Fa;Ha=OFa(xa,Sa)|0;KQa(Ta,249920);Rc=1;Sc=0;Tc=vFa(Ha,Ta)|0}else{c[Qa>>2]=Fa;Ha=OFa(xa,Qa)|0;KQa(Ra,249776);Rc=0;Sc=1;Tc=vFa(o,vFa(Ha,Ra)|0)|0}RQa(Ja,Tc)|0;if(Rc){QQa(Ta)}if(Sc){QQa(Ra)}QQa(Pa);QQa(Na);Fa=Fa+1|0;}while((Fa|0)<(c[W>>2]|0))}W=b+128|0;if((c[W>>2]|0)>0){Fa=a+60|0;Na=0;do{c[Ua>>2]=Na;Pa=OFa(Fa,Ua)|0;KQa(Va,249920);Ra=vFa(Pa,Va)|0;c[Wa>>2]=Na;Pa=OFa(Fa,Wa)|0;KQa(Xa,249776);if((cGa(o,vFa(Pa,Xa)|0)|0)==0){c[_a>>2]=Na;Pa=OFa(Fa,_a)|0;KQa($a,249920);Uc=1;Vc=0;Wc=vFa(Pa,$a)|0}else{c[Ya>>2]=Na;Pa=OFa(Fa,Ya)|0;KQa(Za,249776);Uc=0;Vc=1;Wc=vFa(o,vFa(Pa,Za)|0)|0}RQa(Ra,Wc)|0;if(Uc){QQa($a)}if(Vc){QQa(Za)}QQa(Xa);QQa(Va);Na=Na+1|0;}while((Na|0)<(c[W>>2]|0))}W=b+132|0;if((c[W>>2]|0)>0){Na=a+96|0;Va=0;do{c[ab>>2]=Va;Xa=OFa(Na,ab)|0;KQa(bb,249920);Za=vFa(Xa,bb)|0;c[cb>>2]=Va;Xa=OFa(Na,cb)|0;KQa(db,249776);if((cGa(o,vFa(Xa,db)|0)|0)==0){c[gb>>2]=Va;Xa=OFa(Na,gb)|0;KQa(hb,249920);Xc=1;Yc=0;Zc=vFa(Xa,hb)|0}else{c[eb>>2]=Va;Xa=OFa(Na,eb)|0;KQa(fb,249776);Xc=0;Yc=1;Zc=vFa(o,vFa(Xa,fb)|0)|0}RQa(Za,Zc)|0;if(Xc){QQa(hb)}if(Yc){QQa(fb)}QQa(db);QQa(bb);Va=Va+1|0;}while((Va|0)<(c[W>>2]|0))}W=b+136|0;if((c[W>>2]|0)>0){Va=a+132|0;bb=0;do{c[ib>>2]=bb;db=OFa(Va,ib)|0;KQa(jb,249920);fb=vFa(db,jb)|0;c[kb>>2]=bb;db=OFa(Va,kb)|0;KQa(lb,249776);if((cGa(o,vFa(db,lb)|0)|0)==0){c[ob>>2]=bb;db=OFa(Va,ob)|0;KQa(pb,249920);_c=1;$c=0;ad=vFa(db,pb)|0}else{c[mb>>2]=bb;db=OFa(Va,mb)|0;KQa(nb,249776);_c=0;$c=1;ad=vFa(o,vFa(db,nb)|0)|0}RQa(fb,ad)|0;if(_c){QQa(pb)}if($c){QQa(nb)}QQa(lb);QQa(jb);bb=bb+1|0;}while((bb|0)<(c[W>>2]|0))}W=b+140|0;if((c[W>>2]|0)>0){bb=a+168|0;jb=0;do{c[qb>>2]=jb;lb=OFa(bb,qb)|0;KQa(rb,249920);nb=vFa(lb,rb)|0;c[sb>>2]=jb;lb=OFa(bb,sb)|0;KQa(tb,249776);if((cGa(o,vFa(lb,tb)|0)|0)==0){c[wb>>2]=jb;lb=OFa(bb,wb)|0;KQa(xb,249920);bd=1;cd=0;dd=vFa(lb,xb)|0}else{c[ub>>2]=jb;lb=OFa(bb,ub)|0;KQa(vb,249776);bd=0;cd=1;dd=vFa(o,vFa(lb,vb)|0)|0}RQa(nb,dd)|0;if(bd){QQa(xb)}if(cd){QQa(vb)}QQa(tb);QQa(rb);jb=jb+1|0;}while((jb|0)<(c[W>>2]|0))}W=b+208|0;if((c[W>>2]|0)>0){jb=a+72|0;rb=0;do{c[yb>>2]=rb;tb=OFa(jb,yb)|0;KQa(zb,249920);vb=vFa(tb,zb)|0;c[Ab>>2]=rb;tb=OFa(jb,Ab)|0;KQa(Bb,249776);if((cGa(o,vFa(tb,Bb)|0)|0)==0){c[Eb>>2]=rb;tb=OFa(jb,Eb)|0;KQa(Fb,249920);ed=1;fd=0;gd=vFa(tb,Fb)|0}else{c[Cb>>2]=rb;tb=OFa(jb,Cb)|0;KQa(Db,249776);ed=0;fd=1;gd=vFa(o,vFa(tb,Db)|0)|0}RQa(vb,gd)|0;if(ed){QQa(Fb)}if(fd){QQa(Db)}QQa(Bb);QQa(zb);rb=rb+1|0;}while((rb|0)<(c[W>>2]|0))}W=b+212|0;if((c[W>>2]|0)>0){rb=a+108|0;zb=0;do{c[Gb>>2]=zb;Bb=OFa(rb,Gb)|0;KQa(Hb,249920);Db=vFa(Bb,Hb)|0;c[Ib>>2]=zb;Bb=OFa(rb,Ib)|0;KQa(Jb,249776);if((cGa(o,vFa(Bb,Jb)|0)|0)==0){c[Mb>>2]=zb;Bb=OFa(rb,Mb)|0;KQa(Nb,249920);hd=0;id=1;jd=vFa(Bb,Nb)|0}else{c[Kb>>2]=zb;Bb=OFa(rb,Kb)|0;KQa(Lb,249776);hd=1;id=0;jd=vFa(o,vFa(Bb,Lb)|0)|0}RQa(Db,jd)|0;if(id){QQa(Nb)}if(hd){QQa(Lb)}QQa(Jb);QQa(Hb);zb=zb+1|0;}while((zb|0)<(c[W>>2]|0))}W=b+216|0;if((c[W>>2]|0)>0){zb=a+144|0;Hb=0;do{c[Ob>>2]=Hb;Jb=OFa(zb,Ob)|0;KQa(Pb,249920);Lb=vFa(Jb,Pb)|0;c[Qb>>2]=Hb;Jb=OFa(zb,Qb)|0;KQa(Rb,249776);if((cGa(o,vFa(Jb,Rb)|0)|0)==0){c[Ub>>2]=Hb;Jb=OFa(zb,Ub)|0;KQa(Vb,249920);kd=1;ld=0;md=vFa(Jb,Vb)|0}else{c[Sb>>2]=Hb;Jb=OFa(zb,Sb)|0;KQa(Tb,249776);kd=0;ld=1;md=vFa(o,vFa(Jb,Tb)|0)|0}RQa(Lb,md)|0;if(kd){QQa(Vb)}if(ld){QQa(Tb)}QQa(Rb);QQa(Pb);Hb=Hb+1|0;}while((Hb|0)<(c[W>>2]|0))}W=b+220|0;if((c[W>>2]|0)>0){b=a+180|0;a=0;do{c[Wb>>2]=a;Hb=OFa(b,Wb)|0;KQa(Xb,249920);Pb=vFa(Hb,Xb)|0;c[Yb>>2]=a;Hb=OFa(b,Yb)|0;KQa(Zb,249776);if((cGa(o,vFa(Hb,Zb)|0)|0)==0){c[bc>>2]=a;Hb=OFa(b,bc)|0;KQa(cc,249920);nd=1;od=0;pd=vFa(Hb,cc)|0}else{c[_b>>2]=a;Hb=OFa(b,_b)|0;KQa(ac,249776);nd=0;od=1;pd=vFa(o,vFa(Hb,ac)|0)|0}RQa(Pb,pd)|0;if(nd){QQa(cc)}if(od){QQa(ac)}QQa(Zb);QQa(Xb);a=a+1|0;}while((a|0)<(c[W>>2]|0))}hwa(23,0,252880,h);QQa(v);QQa(u);dGa(o);i=f;return}function OFa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=vIa(a,f,b)|0;l=c[k>>2]|0;fCa(d+16|0);if((l|0)!=0){m=l;n=m;o=n+20|0;p=o;i=d;return p|0}xIa(j,a,b);yIa(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];wIa(g,e);zIa(j);j=c[f>>2]|0;AIa(a,j,k,BIa(g)|0);k=CIa(g)|0;zIa(g);m=k;n=m;o=n+20|0;p=o;i=d;return p|0}function PFa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=ZGa(a,f,b)|0;l=c[k>>2]|0;fCa(d+16|0);if((l|0)!=0){m=l;n=m;o=n+28|0;p=o;i=d;return p|0}$Ga(j,a,b);aHa(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];_Ga(g,e);bHa(j);j=c[f>>2]|0;cHa(a,j,k,dHa(g)|0);k=eHa(g)|0;bHa(g);m=k;n=m;o=n+28|0;p=o;i=d;return p|0}function QFa(a,b){a=a|0;b=b|0;var c=0;c=i;RQa(b,a)|0;i=c;return}function RFa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;QGa(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];IGa(a,f);i=e;return}function SFa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=GGa(a,b)|0;i=c;return d|0}function TFa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;JGa(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];IGa(a,e);i=d;return}function UFa(a){a=a|0;var b=0,c=0;b=i;c=DGa(a)|0;i=b;return c|0}function VFa(a){a=a|0;var b=0;b=i;aLa(a);i=b;return}function WFa(a){a=a|0;var b=0;b=i;PKa(a);i=b;return}function XFa(a,b){a=a|0;b=b|0;b=i;wJa(a,0);i=b;return}function YFa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+108|0;NRa(d);e=a;c[e>>2]=252948;f=d;c[f>>2]=252968;d=a+8|0;FSa(a,252980|0,d);c[e>>2]=252948;c[f>>2]=252968;OEa(d);i=b;return}function ZFa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=(nCa(a+8|0,b,d|8)|0)==0;d=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;if(f){ERa(d,4);i=e;return}else{CRa(d,0);i=e;return}}function _Fa(a){a=a|0;var b=0,c=0;b=i;c=yGa(a+8|0)|0;i=b;return c|0}function $Fa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=xGa(a,b,LRa(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,10)|0)|0;i=d;return e|0}function aGa(a){a=a|0;var b=0;b=i;if((pCa(a+8|0)|0)!=0){i=b;return}ERa(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,4);i=b;return}function bGa(a){a=a|0;var b=0;b=i;CGa(a,252976);IRa(a+108|0);i=b;return}function cGa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=eGa(a,b)|0;i=c;return d|0}function dGa(a){a=a|0;var b=0;b=i;EKa(a);i=b;return}function eGa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+8|0;e=d;f=gGa(a)|0;fCa(e);if((f|0)==0){g=0;i=d;return g|0}h=hGa(a)|0;a=f;while(1){f=a+16|0;if(iGa(h,b,f)|0){j=a}else{if(!(jGa(h,f,b)|0)){g=1;k=8;break}j=a+4|0}f=c[j>>2]|0;fCa(e);if((f|0)==0){g=0;k=8;break}else{a=f}}if((k|0)==8){i=d;return g|0}return 0}function fGa(a){a=a|0;var b=0,c=0;b=i;c=SBa(pGa(a+4|0)|0)|0;i=b;return c|0}function gGa(a){a=a|0;var b=0,d=0;b=i;d=c[(fGa(a)|0)>>2]|0;i=b;return d|0}function hGa(a){a=a|0;var b=0,c=0;b=i;c=nGa(a+8|0)|0;i=b;return c|0}function iGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=kGa(0,b,c)|0;i=a;return d|0}function jGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=kGa(0,b,c)|0;i=a;return d|0}function kGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=lGa(b,c)|0;i=a;return d|0}function lGa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(nRa(a,b)|0)<0;i=c;return d|0}function mGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=s$a(a,b,c)|0;i=d;return e|0}function nGa(a){a=a|0;var b=0,c=0;b=i;c=oGa(a)|0;i=b;return c|0}function oGa(a){a=a|0;i=i;return a|0}function pGa(a){a=a|0;var b=0,c=0;b=i;c=qGa(a)|0;i=b;return c|0}function qGa(a){a=a|0;i=i;return a|0}function rGa(a,b){a=a|0;b=b|0;var c=0;a=i;c=tGa(0,b,0)|0;i=a;return c|0}function sGa(b,c){b=b|0;c=c|0;a[b]=a[c]|0;i=i;return}function tGa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=$_a(b)|0;i=c;return a|0}function uGa(a){a=a|0;var b=0,c=0;b=i;c=x$a(a|0)|0;i=b;return c|0}function vGa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=wGa(b,c,e)|0;i=d;return g|0}function wGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=jDa(0,a,b)|0;i=c;return(d?b:a)|0}function xGa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;KSa(f,a,1);if(!(NSa(f)|0)){i=e;return a|0}eRa(b);f=0;while(1){g=TRa(JRa(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0)|0)|0;if($Ca(g,-1)|0){h=2;j=f;break}k=f+1|0;l=aDa(g)|0;if(eDa(l,d)|0){h=0;j=k;break}gRa(b,l);if((OQa(b)|0)==-17){h=4;j=k;break}else{f=k}}ERa(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,(j|0)==0?h|4:h);i=e;return a|0}function yGa(a){a=a|0;i=i;return(c[a+64>>2]|0)!=0|0}function zGa(a){a=a|0;var b=0;b=i;bGa(a);b$a(a);i=b;return}function AGa(a){a=a|0;var b=0;b=i;bGa(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function BGa(a){a=a|0;var b=0;b=i;zGa(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function CGa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];PCa(a+8|0);i=d;return}function DGa(a){a=a|0;var b=0,d=0;b=i;d=EGa((c[a>>2]|0)+16|0)|0;i=b;return d|0}function EGa(a){a=a|0;var b=0,c=0;b=i;c=FGa(a)|0;i=b;return c|0}function FGa(a){a=a|0;i=i;return a|0}function GGa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(HGa(a,b)|0)^1;i=c;return d|0}function HGa(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function IGa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];PGa(a,e);i=d;return}function JGa(a,b){a=a|0;b=b|0;var c=0;c=i;KGa(a,LGa(b)|0);i=c;return}function KGa(a,b){a=a|0;b=b|0;var c=0;c=i;OGa(a,b);i=c;return}function LGa(a){a=a|0;var b=0,c=0;b=i;c=SBa(MGa(a+4|0)|0)|0;i=b;return c|0}function MGa(a){a=a|0;var b=0,c=0;b=i;c=NGa(a)|0;i=b;return c|0}function NGa(a){a=a|0;i=i;return a|0}function OGa(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function PGa(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function QGa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=SGa(b)|0;RGa(f,b,d,h,LGa(b)|0);JGa(g,b);do{if(GGa(f,g)|0){h=TGa(b)|0;if(UGa(h,d,VGa(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);JGa(a,b);i=e;return}function RGa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;fCa(h);a:do{if((e|0)==0){j=f}else{k=TGa(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(YGa(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;fCa(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;fCa(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);KGa(a,j);i=g;return}function SGa(a){a=a|0;var b=0,d=0;b=i;d=c[(LGa(a)|0)>>2]|0;i=b;return d|0}function TGa(a){a=a|0;var b=0,c=0;b=i;c=WGa(a+8|0)|0;i=b;return c|0}function UGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=kGa(0,b,c)|0;i=a;return d|0}function VGa(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function WGa(a){a=a|0;var b=0,c=0;b=i;c=XGa(a)|0;i=b;return c|0}function XGa(a){a=a|0;i=i;return a|0}function YGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=kGa(0,b,c)|0;i=a;return d|0}function ZGa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=SGa(h)|0;fCa(e);if((a|0)==0){j=LGa(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(kGa(0,d,a)|0){m=l;j=c[m>>2]|0;fCa(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(kGa(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;fCa(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function _Ga(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];VHa(a,e);i=d;return}function $Ga(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=AHa(d)|0;d=CHa(n,1)|0;DHa(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];BHa(j,d,h);EHa(0,tHa((FHa(j)|0)+16|0)|0,e);e=GHa(j)|0;a[e+4|0]=1;HHa(0,rHa((FHa(j)|0)+28|0)|0);a[e+5|0]=1;IHa(m,j);aHa(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];_Ga(b,g);bHa(m);bHa(j);i=f;return}function aHa(a,b){a=a|0;b=b|0;var c=0;c=i;yHa(a,b);i=c;return}function bHa(a){a=a|0;var b=0;b=i;nHa(a);i=b;return}function cHa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;fCa(f);c[e>>2]=0;fCa(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=jHa(a)|0;b=c[c[e>>2]>>2]|0;fCa(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(LGa(a)|0)>>2]|0;RDa(e,c[d>>2]|0);d=kHa(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function dHa(a){a=a|0;var b=0,d=0;b=i;d=c[(hHa(a)|0)>>2]|0;i=b;return d|0}function eHa(a){a=a|0;var b=0,d=0;b=i;d=fHa(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function fHa(a){a=a|0;var b=0,c=0;b=i;c=gHa(a)|0;i=b;return c|0}function gHa(a){a=a|0;i=i;return a|0}function hHa(a){a=a|0;var b=0,c=0;b=i;c=iHa(a)|0;i=b;return c|0}function iHa(a){a=a|0;i=i;return a|0}function jHa(a){a=a|0;i=i;return a|0}function kHa(a){a=a|0;var b=0,c=0;b=i;c=lHa(a+8|0)|0;i=b;return c|0}function lHa(a){a=a|0;var b=0,c=0;b=i;c=mHa(a)|0;i=b;return c|0}function mHa(a){a=a|0;i=i;return a|0}function nHa(a){a=a|0;var b=0;b=i;oHa(a,0);i=b;return}function oHa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=fHa(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}qHa(pHa(e)|0,f);i=d;return}function pHa(a){a=a|0;var b=0,c=0;b=i;c=xHa(a)|0;i=b;return c|0}function qHa(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+4|0]|0)!=0){f=c[b>>2]|0;sHa(f,tHa(d+16|0)|0)}if((d|0)==0){i=e;return}uHa(c[b>>2]|0,d,1);i=e;return}function rHa(a){a=a|0;i=i;return a|0}function sHa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;wHa(d,0,c);i=b;return}function tHa(a){a=a|0;i=i;return a|0}function uHa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;vHa(0,b,0);i=c;return}function vHa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;b$a(b);i=c;return}function wHa(a,b,c){a=a|0;b=b|0;c=c|0;b=i;QQa(c);i=b;return}function xHa(a){a=a|0;i=i;return a+4|0}function yHa(a,b){a=a|0;b=b|0;var c=0;c=i;zHa(a,b);i=c;return}function zHa(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function AHa(a){a=a|0;var b=0,c=0;b=i;c=THa(a+4|0)|0;i=b;return c|0}function BHa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];LHa(a,b,f);i=e;return}function CHa(a,b){a=a|0;b=b|0;var c=0;a=i;c=KHa(0,b,0)|0;i=a;return c|0}function DHa(a,b){a=a|0;b=b|0;var c=0;c=i;JHa(a,b);i=c;return}function EHa(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}GQa(b,c);i=a;return}function FHa(a){a=a|0;var b=0,d=0;b=i;d=c[(hHa(a)|0)>>2]|0;i=b;return d|0}function GHa(a){a=a|0;var b=0,c=0;b=i;c=pHa(a)|0;i=b;return c|0}function HHa(a,b){a=a|0;b=b|0;if((b|0)!=0){c[b>>2]=0}i=i;return}function IHa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;yHa(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];_Ga(h,f);aHa(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];_Ga(a,e);bHa(h);i=d;return}function JHa(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function KHa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=$_a(b<<5)|0;i=c;return a|0}function LHa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(NHa(g)|0)>>2]|0;g=OHa(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];MHa(b,a,f);i=e;return}function MHa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];PHa(a,b,f);i=e;return}function NHa(a){a=a|0;i=i;return a|0}function OHa(a){a=a|0;i=i;return a|0}function PHa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(RHa(g)|0)>>2]|0;g=SHa(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];QHa(b,a,f);i=e;return}function QHa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(RHa(f)|0)>>2];f=SHa(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function RHa(a){a=a|0;i=i;return a|0}function SHa(a){a=a|0;i=i;return a|0}function THa(a){a=a|0;var b=0,c=0;b=i;c=UHa(a)|0;i=b;return c|0}function UHa(a){a=a|0;i=i;return a|0}function VHa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=eHa(WHa(b)|0)|0;h=SHa(GHa(WHa(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];MHa(g,a,e);i=d;return}function WHa(a){a=a|0;i=i;return c[a>>2]|0}function XHa(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function YHa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];dIa(a,e);i=d;return}function ZHa(a,b){a=a|0;b=b|0;var c=0;c=i;_Ha(a,$Ha(b)|0);i=c;return}function _Ha(a,b){a=a|0;b=b|0;var c=0;c=i;cIa(a,b);i=c;return}function $Ha(a){a=a|0;var b=0,c=0;b=i;c=SBa(aIa(a+4|0)|0)|0;i=b;return c|0}function aIa(a){a=a|0;var b=0,c=0;b=i;c=bIa(a)|0;i=b;return c|0}function bIa(a){a=a|0;i=i;return a|0}function cIa(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function dIa(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function eIa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=gIa(b)|0;fIa(f,b,d,h,$Ha(b)|0);ZHa(g,b);do{if(hIa(f,g)|0){h=iIa(b)|0;if(iGa(h,d,jIa(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);ZHa(a,b);i=e;return}function fIa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;fCa(h);a:do{if((e|0)==0){j=f}else{k=iIa(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(jGa(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;fCa(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;fCa(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);_Ha(a,j);i=g;return}function gIa(a){a=a|0;var b=0,d=0;b=i;d=c[($Ha(a)|0)>>2]|0;i=b;return d|0}function hIa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(XHa(a,b)|0)^1;i=c;return d|0}function iIa(a){a=a|0;var b=0,c=0;b=i;c=kIa(a+8|0)|0;i=b;return c|0}function jIa(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function kIa(a){a=a|0;var b=0,c=0;b=i;c=lIa(a)|0;i=b;return c|0}function lIa(a){a=a|0;i=i;return a|0}function mIa(a,b){a=a|0;b=b|0;b=i;i=i+8|0;nIa(a,b);i=b;return}function nIa(a,b){a=a|0;b=b|0;b=i;oIa(a,0);i=b;return}function oIa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;pIa(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;qIa(f,0,e);e=LGa(b)|0;c[(jHa(b)|0)>>2]=e;i=d;return}function pIa(a){a=a|0;var b=0;b=i;tIa(a);i=b;return}function qIa(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;rIa(b,c,f);i=e;return}function rIa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(JEa(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;sIa(d,b,f);i=e;return}function sIa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(JEa(e)|0)>>2];i=d;return}function tIa(a){a=a|0;var b=0;b=i;uIa(a);i=b;return}function uIa(a){a=a|0;var b=0;b=i;MEa(a);i=b;return}function vIa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=vJa(h)|0;fCa(e);if((a|0)==0){j=IIa(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(cCa(0,d,a)|0){m=l;j=c[m>>2]|0;fCa(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(cCa(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;fCa(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function wIa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];tJa(a,e);i=d;return}function xIa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=_Ia(d)|0;d=aJa(n,1)|0;bJa(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];$Ia(j,d,h);cJa(0,bEa((dJa(j)|0)+16|0)|0,e);e=eJa(j)|0;a[e+4|0]=1;fJa(0,TIa((dJa(j)|0)+20|0)|0);a[e+5|0]=1;gJa(m,j);yIa(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];wIa(b,g);zIa(m);zIa(j);i=f;return}function yIa(a,b){a=a|0;b=b|0;var c=0;c=i;YIa(a,b);i=c;return}function zIa(a){a=a|0;var b=0;b=i;OIa(a);i=b;return}function AIa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;fCa(f);c[e>>2]=0;fCa(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=HIa(a)|0;b=c[c[e>>2]>>2]|0;fCa(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(IIa(a)|0)>>2]|0;RDa(e,c[d>>2]|0);d=JIa(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function BIa(a){a=a|0;var b=0,d=0;b=i;d=c[(FIa(a)|0)>>2]|0;i=b;return d|0}function CIa(a){a=a|0;var b=0,d=0;b=i;d=DIa(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function DIa(a){a=a|0;var b=0,c=0;b=i;c=EIa(a)|0;i=b;return c|0}function EIa(a){a=a|0;i=i;return a|0}function FIa(a){a=a|0;var b=0,c=0;b=i;c=GIa(a)|0;i=b;return c|0}function GIa(a){a=a|0;i=i;return a|0}function HIa(a){a=a|0;i=i;return a|0}function IIa(a){a=a|0;var b=0,c=0;b=i;c=SBa(MIa(a+4|0)|0)|0;i=b;return c|0}function JIa(a){a=a|0;var b=0,c=0;b=i;c=KIa(a+8|0)|0;i=b;return c|0}function KIa(a){a=a|0;var b=0,c=0;b=i;c=LIa(a)|0;i=b;return c|0}function LIa(a){a=a|0;i=i;return a|0}function MIa(a){a=a|0;var b=0,c=0;b=i;c=NIa(a)|0;i=b;return c|0}function NIa(a){a=a|0;i=i;return a|0}function OIa(a){a=a|0;var b=0;b=i;PIa(a,0);i=b;return}function PIa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=DIa(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}RIa(QIa(e)|0,f);i=d;return}function QIa(a){a=a|0;var b=0,c=0;b=i;c=XIa(a)|0;i=b;return c|0}function RIa(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+5|0]|0)!=0){f=c[b>>2]|0;SIa(f,TIa(d+20|0)|0)}if((d|0)==0){i=e;return}UIa(c[b>>2]|0,d,1);i=e;return}function SIa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;WIa(d,0,c);i=b;return}function TIa(a){a=a|0;i=i;return a|0}function UIa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;VIa(0,b,0);i=c;return}function VIa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;b$a(b);i=c;return}function WIa(a,b,c){a=a|0;b=b|0;c=c|0;b=i;dGa(c);i=b;return}function XIa(a){a=a|0;i=i;return a+4|0}function YIa(a,b){a=a|0;b=b|0;var c=0;c=i;ZIa(a,b);i=c;return}function ZIa(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function _Ia(a){a=a|0;var b=0,c=0;b=i;c=rJa(a+4|0)|0;i=b;return c|0}function $Ia(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];jJa(a,b,f);i=e;return}function aJa(a,b){a=a|0;b=b|0;var c=0;a=i;c=iJa(0,b,0)|0;i=a;return c|0}function bJa(a,b){a=a|0;b=b|0;var c=0;c=i;hJa(a,b);i=c;return}function cJa(a,b,d){a=a|0;b=b|0;d=d|0;if((b|0)!=0){c[b>>2]=c[d>>2]}i=i;return}function dJa(a){a=a|0;var b=0,d=0;b=i;d=c[(FIa(a)|0)>>2]|0;i=b;return d|0}function eJa(a){a=a|0;var b=0,c=0;b=i;c=QIa(a)|0;i=b;return c|0}function fJa(a,b){a=a|0;b=b|0;a=i;i=i+8|0;if((b|0)==0){i=a;return}XFa(b,a);i=a;return}function gJa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;YIa(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];wIa(h,f);yIa(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];wIa(a,e);zIa(h);i=d;return}function hJa(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function iJa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=$_a(b<<5)|0;i=c;return a|0}function jJa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(lJa(g)|0)>>2]|0;g=mJa(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];kJa(b,a,f);i=e;return}function kJa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];nJa(a,b,f);i=e;return}function lJa(a){a=a|0;i=i;return a|0}function mJa(a){a=a|0;i=i;return a|0}function nJa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(pJa(g)|0)>>2]|0;g=qJa(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];oJa(b,a,f);i=e;return}function oJa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(pJa(f)|0)>>2];f=qJa(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function pJa(a){a=a|0;i=i;return a|0}function qJa(a){a=a|0;i=i;return a|0}function rJa(a){a=a|0;var b=0,c=0;b=i;c=sJa(a)|0;i=b;return c|0}function sJa(a){a=a|0;i=i;return a|0}function tJa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=CIa(uJa(b)|0)|0;h=qJa(eJa(uJa(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];kJa(g,a,e);i=d;return}function uJa(a){a=a|0;i=i;return c[a>>2]|0}function vJa(a){a=a|0;var b=0,d=0;b=i;d=c[(IIa(a)|0)>>2]|0;i=b;return d|0}function wJa(a,b){a=a|0;b=b|0;b=i;i=i+8|0;xJa(a,b);i=b;return}function xJa(a,b){a=a|0;b=b|0;b=i;yJa(a,0);i=b;return}function yJa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;zJa(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;AJa(f,0,e);e=$Ha(b)|0;c[(BJa(b)|0)>>2]=e;i=d;return}function zJa(a){a=a|0;var b=0;b=i;EJa(a);i=b;return}function AJa(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;CJa(b,c,f);i=e;return}function BJa(a){a=a|0;i=i;return a|0}function CJa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(JEa(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;DJa(d,b,f);i=e;return}function DJa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(JEa(e)|0)>>2];i=d;return}function EJa(a){a=a|0;var b=0;b=i;FJa(a);i=b;return}function FJa(a){a=a|0;var b=0;b=i;MEa(a);i=b;return}function GJa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=gIa(h)|0;fCa(e);if((a|0)==0){j=$Ha(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(kGa(0,d,a)|0){m=l;j=c[m>>2]|0;fCa(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(kGa(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;fCa(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function HJa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];CKa(a,e);i=d;return}function IJa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=hKa(d)|0;d=jKa(n,1)|0;kKa(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];iKa(j,d,h);lKa(0,tHa((mKa(j)|0)+16|0)|0,e);e=nKa(j)|0;a[e+4|0]=1;oKa(0,_Ja((mKa(j)|0)+28|0)|0);a[e+5|0]=1;pKa(m,j);JJa(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];HJa(b,g);KJa(m);KJa(j);i=f;return}function JJa(a,b){a=a|0;b=b|0;var c=0;c=i;fKa(a,b);i=c;return}function KJa(a){a=a|0;var b=0;b=i;VJa(a);i=b;return}function LJa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;fCa(f);c[e>>2]=0;fCa(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=BJa(a)|0;b=c[c[e>>2]>>2]|0;fCa(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[($Ha(a)|0)>>2]|0;RDa(e,c[d>>2]|0);d=SJa(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function MJa(a){a=a|0;var b=0,d=0;b=i;d=c[(QJa(a)|0)>>2]|0;i=b;return d|0}function NJa(a){a=a|0;var b=0,d=0;b=i;d=OJa(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function OJa(a){a=a|0;var b=0,c=0;b=i;c=PJa(a)|0;i=b;return c|0}function PJa(a){a=a|0;i=i;return a|0}function QJa(a){a=a|0;var b=0,c=0;b=i;c=RJa(a)|0;i=b;return c|0}function RJa(a){a=a|0;i=i;return a|0}function SJa(a){a=a|0;var b=0,c=0;b=i;c=TJa(a+8|0)|0;i=b;return c|0}function TJa(a){a=a|0;var b=0,c=0;b=i;c=UJa(a)|0;i=b;return c|0}function UJa(a){a=a|0;i=i;return a|0}function VJa(a){a=a|0;var b=0;b=i;WJa(a,0);i=b;return}function WJa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=OJa(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}YJa(XJa(e)|0,f);i=d;return}function XJa(a){a=a|0;var b=0,c=0;b=i;c=eKa(a)|0;i=b;return c|0}function YJa(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+5|0]|0)!=0){f=c[b>>2]|0;ZJa(f,_Ja(d+28|0)|0)}if((a[b+4|0]|0)!=0){f=c[b>>2]|0;$Ja(f,tHa(d+16|0)|0)}if((d|0)==0){i=e;return}aKa(c[b>>2]|0,d,1);i=e;return}function ZJa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;dKa(d,0,c);i=b;return}function _Ja(a){a=a|0;i=i;return a|0}function $Ja(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;cKa(d,0,c);i=b;return}function aKa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;bKa(0,b,0);i=c;return}function bKa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;b$a(b);i=c;return}function cKa(a,b,c){a=a|0;b=b|0;c=c|0;b=i;QQa(c);i=b;return}function dKa(a,b,c){a=a|0;b=b|0;c=c|0;b=i;QQa(c);i=b;return}function eKa(a){a=a|0;i=i;return a+4|0}function fKa(a,b){a=a|0;b=b|0;var c=0;c=i;gKa(a,b);i=c;return}function gKa(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function hKa(a){a=a|0;var b=0,c=0;b=i;c=AKa(a+4|0)|0;i=b;return c|0}function iKa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];sKa(a,b,f);i=e;return}function jKa(a,b){a=a|0;b=b|0;var c=0;a=i;c=rKa(0,b,0)|0;i=a;return c|0}function kKa(a,b){a=a|0;b=b|0;var c=0;c=i;qKa(a,b);i=c;return}function lKa(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}GQa(b,c);i=a;return}function mKa(a){a=a|0;var b=0,d=0;b=i;d=c[(QJa(a)|0)>>2]|0;i=b;return d|0}function nKa(a){a=a|0;var b=0,c=0;b=i;c=XJa(a)|0;i=b;return c|0}function oKa(a,b){a=a|0;b=b|0;a=i;if((b|0)==0){i=a;return}EQa(b);i=a;return}function pKa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;fKa(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];HJa(h,f);JJa(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];HJa(a,e);KJa(h);i=d;return}function qKa(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function rKa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=$_a(b*40|0)|0;i=c;return a|0}function sKa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(uKa(g)|0)>>2]|0;g=vKa(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];tKa(b,a,f);i=e;return}function tKa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];wKa(a,b,f);i=e;return}function uKa(a){a=a|0;i=i;return a|0}function vKa(a){a=a|0;i=i;return a|0}function wKa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(yKa(g)|0)>>2]|0;g=zKa(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];xKa(b,a,f);i=e;return}function xKa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(yKa(f)|0)>>2];f=zKa(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function yKa(a){a=a|0;i=i;return a|0}function zKa(a){a=a|0;i=i;return a|0}function AKa(a){a=a|0;var b=0,c=0;b=i;c=BKa(a)|0;i=b;return c|0}function BKa(a){a=a|0;i=i;return a|0}function CKa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=NJa(DKa(b)|0)|0;h=zKa(nKa(DKa(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];tKa(g,a,e);i=d;return}function DKa(a){a=a|0;i=i;return c[a>>2]|0}function EKa(a){a=a|0;var b=0;b=i;FKa(a);i=b;return}function FKa(a){a=a|0;var b=0;b=i;GKa(a);i=b;return}function GKa(a){a=a|0;var b=0;b=i;HKa(a,gIa(a)|0);i=b;return}function HKa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;fCa(d);if((b|0)==0){i=d;return}HKa(a,c[b>>2]|0);HKa(a,c[b+4>>2]|0);e=hKa(a)|0;IKa(e,JKa(b+16|0)|0);aKa(e,b,1);i=d;return}function IKa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;KKa(d,0,c);i=b;return}function JKa(a){a=a|0;i=i;return a|0}



function IN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+272>>3];v=l;h[k>>3]=+h[t+4440>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];gxa(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+280>>3];w=+h[t+264>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];vz(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Bz(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+4448>>3];f=j;h[k>>3]=+h[q+4456>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];gxa(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+448>>3];y=+h[f+4464>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];vz(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Bz(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+3640>>3]=+h[d+704>>3]*(w- +h[r>>3])*+h[d+1992>>3];i=b;return}function JN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+4448>>3];p=f;h[k>>3]=+h[n+4456>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+448>>3];q=+h[p+4464>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+3936>>3]=+h[l>>3];i=b;return}function KN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+640>>3]=+h[b+7600>>3]+ +h[b+648>>3];i=i;return}function LN(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+640>>3];h[b+7384>>3]=d*+h[(!(d>=0.0)?b+6544|0:b+6656|0)>>3];i=i;return}function MN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+632>>3]=+h[b+7592>>3]+ +h[b+640>>3];i=i;return}function NN(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+632>>3];h[b+7376>>3]=d*+h[(!(d>=0.0)?b+6656|0:b+6768|0)>>3];i=i;return}function ON(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7512>>3]=+h[b+7376>>3]- +h[b+7384>>3];i=i;return}function PN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7472>>3]=+h[b+8472>>3]- +h[b+7512>>3];i=i;return}function QN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+624>>3]=+h[b+7584>>3]+ +h[b+632>>3];i=i;return}function RN(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+128>>3]*+h[j+6760>>3]*+h[e+1432>>3];l=+h[j+624>>3]+ +h[j+632>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6416|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6416|0;r=q;h[r>>3]=o;i=d;return}s=l/+nwa(c[b+536>>2]|0,k,55088,55080,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6416|0;r=q;h[r>>3]=o;i=d;return}function SN(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+624>>3];h[b+7368>>3]=d*+h[(!(d>=0.0)?b+6768|0:b+6880|0)>>3];i=i;return}function TN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7504>>3]=+h[b+7368>>3]- +h[b+7376>>3];i=i;return}function UN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7464>>3]=+h[b+8464>>3]- +h[b+7504>>3];i=i;return}function VN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+616>>3]=+h[b+7576>>3]+ +h[b+624>>3];i=i;return}function WN(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+616>>3];h[b+7360>>3]=d*+h[(!(d>=0.0)?b+6880|0:b+6992|0)>>3];i=i;return}function XN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7496>>3]=+h[b+7360>>3]- +h[b+7368>>3];i=i;return}function YN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7456>>3]=+h[b+8456>>3]- +h[b+7496>>3];i=i;return}function ZN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+608>>3]=+h[b+7568>>3]+ +h[b+616>>3];i=i;return}function _N(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+608>>3];h[b+7352>>3]=d*+h[(!(d>=0.0)?b+6992|0:b+10904|0)>>3];i=i;return}function $N(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7488>>3]=+h[b+7352>>3]- +h[b+7360>>3];i=i;return}function aO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7448>>3]=+h[b+8448>>3]- +h[b+7488>>3];i=i;return}function bO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0.0,u=0,v=0.0,w=0,x=0,y=0,z=0.0;d=i;i=i+56|0;e=d;f=d+32|0;g=d+48|0;j=i;i=i+16|0;l=i;i=i+32|0;m=i;i=i+32|0;n=i;i=i+8|0;o=g;h[k>>3]=.99;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];gxa(j,2,.01,g);g=b+536|0;o=c[g>>2]|0;p=b+4|0;q=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+9800>>3];r=f;s=j;c[r+0>>2]=c[s+0>>2];c[r+4>>2]=c[s+4>>2];c[r+8>>2]=c[s+8>>2];mA(m,o,15.0e4,q,f);f=l;o=m;c[f+0>>2]=c[o+0>>2];c[f+4>>2]=c[o+4>>2];c[f+8>>2]=c[o+8>>2];c[f+12>>2]=c[o+12>>2];c[f+16>>2]=c[o+16>>2];c[f+20>>2]=c[o+20>>2];c[f+24>>2]=c[o+24>>2];c[f+28>>2]=c[o+28>>2];o=c[g>>2]|0;f=e;m=l;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];c[f+12>>2]=c[m+12>>2];c[f+16>>2]=c[m+16>>2];c[f+20>>2]=c[m+20>>2];c[f+24>>2]=c[m+24>>2];c[f+28>>2]=c[m+28>>2];qA(n,o,e);e=c[b+416>>2]|0;q=+h[n>>3]*+h[e+1432>>3]*+h[e+112>>3];e=c[c[p>>2]>>2]|0;n=c[e+8>>2]|0;t=+h[n+608>>3];if(q!=0.0){u=n;v=t/q;w=u;x=w+7344|0;y=x;h[y>>3]=v;i=d;return}if(t==0.0){u=n;v=t;w=u;x=w+7344|0;y=x;h[y>>3]=v;i=d;return}z=t/+nwa(c[g>>2]|0,q,55160,55152,+h[e>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[p>>2]>>2]|0)+8>>2]|0;v=z;w=u;x=w+7344|0;y=x;h[y>>3]=v;i=d;return}function cO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+112>>3]*+h[j+6984>>3]*+h[e+1432>>3];l=+h[j+608>>3]+ +h[j+616>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6400|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6400|0;r=q;h[r>>3]=o;i=d;return}s=l/+nwa(c[b+536>>2]|0,k,55368,55360,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6400|0;r=q;h[r>>3]=o;i=d;return}function dO(a){a=a|0;var b=0,d=0.0,e=0.0,f=0,g=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+7344>>3];e=+h[b+6400>>3];f=c[a+416>>2]|0;g=+h[f+112>>3];h[b+7144>>3]=+h[f+1536>>3]*(+h[b+9568>>3]*d*d*g- +h[b+9576>>3]*e*e*g);i=i;return}function eO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7048>>3]=+h[b+7144>>3]- +h[b+7096>>3]- +h[b+7792>>3];i=i;return}function fO(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+1536>>3]*+h[e+112>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7048>>3];if(f!=0.0){l=j;m=k/f;n=l;o=n+7e3|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+7e3|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,f,55440,55432,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7e3|0;p=o;h[p>>3]=m;i=d;return}function gO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+120>>3]*+h[j+6872>>3]*+h[e+1432>>3];l=+h[j+616>>3]+ +h[j+624>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6408|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6408|0;r=q;h[r>>3]=o;i=d;return}s=l/+nwa(c[b+536>>2]|0,k,55496,55488,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6408|0;r=q;h[r>>3]=o;i=d;return}function hO(a){a=a|0;var b=0,d=0.0,e=0.0,f=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+6408>>3];e=+h[b+6416>>3];f=c[a+416>>2]|0;h[b+7160>>3]=+h[f+1536>>3]*(+h[b+9584>>3]*d*d*+h[f+120>>3]- +h[b+9592>>3]*e*e*+h[f+128>>3]);i=i;return}function iO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7064>>3]=+h[b+7160>>3]- +h[b+7112>>3]- +h[b+7808>>3];i=i;return}function jO(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=(+h[e+120>>3]+ +h[e+128>>3])*+h[e+1536>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7064>>3];if(f!=0.0){l=j;m=k/f;n=m*2.0;o=l;p=o+7016|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*2.0;o=l;p=o+7016|0;q=p;h[q>>3]=n;i=d;return}r=k/+nwa(c[b+536>>2]|0,f,55568,55560,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*2.0;o=l;p=o+7016|0;q=p;h[q>>3]=n;i=d;return}function kO(a){a=a|0;var b=0,d=0.0,e=0.0,f=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+6400>>3];e=+h[b+6408>>3];f=c[a+416>>2]|0;h[b+7152>>3]=+h[f+1536>>3]*(+h[b+9576>>3]*d*d*+h[f+112>>3]- +h[b+9584>>3]*e*e*+h[f+120>>3]);i=i;return}function lO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7056>>3]=+h[b+7152>>3]- +h[b+7104>>3]- +h[b+7800>>3];i=i;return}function mO(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=(+h[e+112>>3]+ +h[e+120>>3])*+h[e+1536>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7056>>3];if(f!=0.0){l=j;m=k/f;n=m*2.0;o=l;p=o+7008|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*2.0;o=l;p=o+7008|0;q=p;h[q>>3]=n;i=d;return}r=k/+nwa(c[b+536>>2]|0,f,55648,55640,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*2.0;o=l;p=o+7008|0;q=p;h[q>>3]=n;i=d;return}function nO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+136>>3]*+h[j+6648>>3]*+h[e+1432>>3];l=+h[j+632>>3]+ +h[j+640>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6424|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6424|0;r=q;h[r>>3]=o;i=d;return}s=l/+nwa(c[b+536>>2]|0,k,55728,55720,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6424|0;r=q;h[r>>3]=o;i=d;return}function oO(a){a=a|0;var b=0,d=0.0,e=0.0,f=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+6416>>3];e=+h[b+6424>>3];f=c[a+416>>2]|0;h[b+7168>>3]=+h[f+1536>>3]*(+h[b+9592>>3]*d*d*+h[f+128>>3]- +h[b+9600>>3]*e*e*+h[f+136>>3]);i=i;return}function pO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7072>>3]=+h[b+7168>>3]- +h[b+7120>>3]- +h[b+7816>>3];i=i;return}function qO(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=(+h[e+128>>3]+ +h[e+136>>3])*+h[e+1536>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7072>>3];if(f!=0.0){l=j;m=k/f;n=m*2.0;o=l;p=o+7024|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*2.0;o=l;p=o+7024|0;q=p;h[q>>3]=n;i=d;return}r=k/+nwa(c[b+536>>2]|0,f,55800,55792,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*2.0;o=l;p=o+7024|0;q=p;h[q>>3]=n;i=d;return}function rO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+144>>3]*+h[j+6536>>3]*+h[e+1432>>3];l=+h[j+640>>3]+ +h[j+648>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6432|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6432|0;r=q;h[r>>3]=o;i=d;return}s=l/+nwa(c[b+536>>2]|0,k,55880,55872,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6432|0;r=q;h[r>>3]=o;i=d;return}function sO(a){a=a|0;var b=0,d=0.0,e=0.0,f=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+6424>>3];e=+h[b+6432>>3];f=c[a+416>>2]|0;h[b+7176>>3]=+h[f+1536>>3]*(+h[b+9600>>3]*d*d*+h[f+136>>3]- +h[b+9608>>3]*e*e*+h[f+144>>3]);i=i;return}function tO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7080>>3]=+h[b+7176>>3]- +h[b+7128>>3]- +h[b+7824>>3];i=i;return}function uO(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=(+h[e+136>>3]+ +h[e+144>>3])*+h[e+1536>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7080>>3];if(f!=0.0){l=j;m=k/f;n=m*2.0;o=l;p=o+7032|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*2.0;o=l;p=o+7032|0;q=p;h[q>>3]=n;i=d;return}r=k/+nwa(c[b+536>>2]|0,f,55952,55944,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*2.0;o=l;p=o+7032|0;q=p;h[q>>3]=n;i=d;return}function vO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0.0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0.0;d=i;i=i+56|0;e=d;f=d+32|0;g=d+48|0;j=i;i=i+16|0;l=i;i=i+32|0;m=i;i=i+32|0;n=i;i=i+8|0;o=b+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[p+4448>>3];r=g;h[k>>3]=+h[p+4456>>3];c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];gxa(j,2,q,g);g=b+536|0;r=c[g>>2]|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[p+448>>3];s=+h[p+4464>>3];p=f;t=j;c[p+0>>2]=c[t+0>>2];c[p+4>>2]=c[t+4>>2];c[p+8>>2]=c[t+8>>2];mA(m,r,q,s,f);f=l;r=m;c[f+0>>2]=c[r+0>>2];c[f+4>>2]=c[r+4>>2];c[f+8>>2]=c[r+8>>2];c[f+12>>2]=c[r+12>>2];c[f+16>>2]=c[r+16>>2];c[f+20>>2]=c[r+20>>2];c[f+24>>2]=c[r+24>>2];c[f+28>>2]=c[r+28>>2];r=c[g>>2]|0;f=e;m=l;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];c[f+12>>2]=c[m+12>>2];c[f+16>>2]=c[m+16>>2];c[f+20>>2]=c[m+20>>2];c[f+24>>2]=c[m+24>>2];c[f+28>>2]=c[m+28>>2];qA(n,r,e);e=c[b+416>>2]|0;s=+h[n>>3]*+h[e+704>>3]*+h[e+1888>>3];e=c[c[o>>2]>>2]|0;n=c[e+8>>2]|0;q=+h[n+288>>3];if(s!=0.0){u=n;v=q/s;w=u;x=w+4e3|0;y=x;h[y>>3]=v;i=d;return}if(q==0.0){u=n;v=q;w=u;x=w+4e3|0;y=x;h[y>>3]=v;i=d;return}z=q/+nwa(c[g>>2]|0,s,56032,56024,+h[e>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[o>>2]>>2]|0)+8>>2]|0;v=z;w=u;x=w+4e3|0;y=x;h[y>>3]=v;i=d;return}function wO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5960>>3];if(!(j>=0.0)){k=g;l=j*+h[g+5544>>3];m=k;n=m+5856|0;o=n;h[o>>3]=l;i=d;return}p=+zd(+(+h[g+648>>3]),1.0e-15);q=+zd(+-+h[g+288>>3],1.0e-15);r=p+q;s=p*+h[g+6544>>3]+q*+h[g+3536>>3];do{if(r!=0.0){t=j;u=g;v=s/r}else{if(s==0.0){t=j;u=g;v=s;break}q=s/+nwa(c[b+536>>2]|0,r,56280,56272,+h[f>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[w+5960>>3];u=w;v=q}}while(0);k=u;l=v*t;m=k;n=m+5856|0;o=n;h[o>>3]=l;i=d;return}function xO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6048>>3]=+h[b+5856>>3]- +h[b+5864>>3];i=i;return}function yO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6008>>3]=+h[b+8488>>3]+(-+h[b+6048>>3]- +h[b+5968>>3]);i=i;return}function zO(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0,k=0,l=0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;e=c[b+416>>2]|0;f=+h[e+1232>>3];g=f*40.0;j=b+4|0;k=c[c[j>>2]>>2]|0;l=c[k+8>>2]|0;m=+h[l+6008>>3]-(1.0-f*+h[e+1224>>3])*40.0;if(g!=0.0){n=l;o=m/g;p=n;q=p+1344|0;r=q;h[r>>3]=o;i=d;return}if(m==0.0){n=l;o=m;p=n;q=p+1344|0;r=q;h[r>>3]=o;i=d;return}f=m/+nwa(c[b+536>>2]|0,g,56376,56368,+h[k>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[j>>2]>>2]|0)+8>>2]|0;o=f;p=n;q=p+1344|0;r=q;h[r>>3]=o;i=d;return}function AO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+648>>3];if(j>=0.0){k=g;l=j*+h[g+6544>>3];m=k;n=m+7392|0;o=n;h[o>>3]=l;i=d;return}p=+zd(+-+h[g+5960>>3],1.0e-15);q=+zd(+-+h[g+288>>3],1.0e-15);r=p+q;s=p*+h[g+5544>>3]+q*+h[g+3536>>3];do{if(r!=0.0){t=j;u=g;v=s/r}else{if(s==0.0){t=j;u=g;v=s;break}q=s/+nwa(c[b+536>>2]|0,r,56408,56400,+h[f>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[w+648>>3];u=w;v=q}}while(0);k=u;l=v*t;m=k;n=m+7392|0;o=n;h[o>>3]=l;i=d;return}function BO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7520>>3]=+h[b+7384>>3]- +h[b+7392>>3];i=i;return}function CO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7480>>3]=+h[b+8480>>3]- +h[b+7520>>3];i=i;return}function DO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+704>>3]*+h[j+3528>>3]*+h[e+1888>>3];l=+h[j+288>>3]+ +h[j+296>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+2944|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+2944|0;r=q;h[r>>3]=o;i=d;return}s=l/+nwa(c[b+536>>2]|0,k,56488,56480,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+2944|0;r=q;h[r>>3]=o;i=d;return}function EO(a){a=a|0;var b=0,d=0.0,e=0.0,f=0,g=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+4e3>>3];e=+h[b+2944>>3];f=c[a+416>>2]|0;g=+h[f+704>>3];h[b+3688>>3]=+h[f+1992>>3]*(+h[b+3936>>3]*d*d*g- +h[b+3944>>3]*e*e*g);i=i;return}function FO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3592>>3]=+h[b+3688>>3]- +h[b+3640>>3]- +h[b+8112>>3];i=i;return}function GO(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+1992>>3]*+h[e+704>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+3592>>3];if(f!=0.0){l=j;m=k/f;n=l;o=n+3544|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+3544|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,f,56560,56552,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+3544|0;p=o;h[p>>3]=m;i=d;return}function HO(a){a=a|0;var b=0,d=0.0,e=0.0,f=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+2944>>3];e=+h[b+2952>>3];f=c[a+416>>2]|0;h[b+3696>>3]=+h[f+1992>>3]*(+h[b+3944>>3]*d*d*+h[f+704>>3]- +h[b+3952>>3]*e*e*+h[f+712>>3]);i=i;return}function IO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3600>>3]=+h[b+3696>>3]- +h[b+3648>>3]- +h[b+8120>>3];i=i;return}function JO(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=(+h[e+704>>3]+ +h[e+712>>3])*+h[e+1992>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+3600>>3];if(f!=0.0){l=j;m=k/f;n=m*2.0;o=l;p=o+3552|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*2.0;o=l;p=o+3552|0;q=p;h[q>>3]=n;i=d;return}r=k/+nwa(c[b+536>>2]|0,f,56616,56608,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*2.0;o=l;p=o+3552|0;q=p;h[q>>3]=n;i=d;return}function KO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+-+h[g+5960>>3],1.0e-15);k=+zd(+-+h[g+288>>3],1.0e-15);l=j+k;m=-(k*+h[g+272>>3])-j*+h[g+440>>3];if(l!=0.0){n=g;o=m/l;p=o+1.0;q=n;r=q+7736|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=o+1.0;q=n;r=q+7736|0;s=r;h[s>>3]=p;i=d;return}j=m/+nwa(c[b+536>>2]|0,l,56408,56688,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=o+1.0;q=n;r=q+7736|0;s=r;h[s>>3]=p;i=d;return}function LO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+zd(+-+h[g+5960>>3],1.0e-15);k=+zd(+-+h[g+288>>3],1.0e-15);l=j+k;m=j*+h[g+440>>3]+k*+h[g+272>>3];if(l!=0.0){n=g;o=m/l;p=n;q=p+7728|0;r=q;h[r>>3]=o;i=d;return}if(m==0.0){n=g;o=m;p=n;q=p+7728|0;r=q;h[r>>3]=o;i=d;return}k=m/+nwa(c[b+536>>2]|0,l,56408,56696,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=k;p=n;q=p+7728|0;r=q;h[r>>3]=o;i=d;return}function MO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+648>>3];if(j>=0.0){k=g;l=j*+h[g+496>>3];m=k;n=m+7440|0;o=n;h[o>>3]=l;i=d;return}p=+zd(+-+h[g+5960>>3],1.0e-15);q=+zd(+-+h[g+288>>3],1.0e-15);r=p+q;s=p*+h[g+440>>3]+q*+h[g+272>>3];do{if(r!=0.0){t=j;u=g;v=s/r}else{if(s==0.0){t=j;u=g;v=s;break}q=s/+nwa(c[b+536>>2]|0,r,56408,56704,+h[f>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[w+648>>3];u=w;v=q}}while(0);k=u;l=v*t;m=k;n=m+7440|0;o=n;h[o>>3]=l;i=d;return}function NO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7432>>3]=+h[b+7560>>3]+ +h[b+7440>>3];i=i;return}function OO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7424>>3]=+h[b+7552>>3]+ +h[b+7432>>3];i=i;return}function PO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7416>>3]=+h[b+7544>>3]+ +h[b+7424>>3];i=i;return}function QO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7408>>3]=+h[b+7536>>3]+ +h[b+7416>>3];i=i;return}function RO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7400>>3]=+h[b+7528>>3]+ +h[b+7408>>3];i=i;return}function SO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8160>>3]=+h[b+9408>>3]+(-(+h[b+3512>>3]*+h[b+920>>3])- +h[b+8968>>3]*+h[b+264>>3]);i=i;return}function TO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8528>>3]=+h[b+4304>>3]*+h[b+8160>>3]+ +h[b+4224>>3]*+h[b+3520>>3];i=i;return}function UO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4104>>3]=+h[b+8528>>3]- +h[b+4144>>3];i=i;return}function VO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0.0;d=i;i=i+120|0;e=d;f=d+96|0;g=d+112|0;j=i;i=i+48|0;l=i;i=i+8|0;m=i;i=i+48|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+96|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=b+4|0;w=c[c[v>>2]>>2]|0;x=c[w+8>>2]|0;y=+zd(+-+h[x+5960>>3],1.0e-15);z=+zd(+-+h[x+288>>3],1.0e-15);A=y+z;B=y*+h[x+440>>3]+z*+h[x+272>>3];do{if(A!=0.0){C=B/A}else{if(B==0.0){C=B;break}C=B/+nwa(c[b+536>>2]|0,A,56408,56712,+h[w>>3],(a[b+319|0]|0)!=0|0)}}while(0);gxa(o,1,C,n);n=m;h[k>>3]=575.573102;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=m+8|0;h[k>>3]=.931782653;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=m+16|0;h[k>>3]=.00722271286;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=m+24|0;h[k>>3]=-734255737.0e-14;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=m+32|0;h[k>>3]=4.95504349e-9;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=m+40|0;h[k>>3]=-1.336933246e-12;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];gxa(q,7,-39479.6083,m);m=l;h[k>>3]=17.24205775;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];gxa(r,2,-33039.7431,l);l=j;h[k>>3]=-2412.698562;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];l=j+8|0;h[k>>3]=4.64611078;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];l=j+16|0;h[k>>3]=.002291998307;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];l=j+24|0;h[k>>3]=-6.836830479999999e-7;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];l=j+32|0;h[k>>3]=9.426468930000001e-11;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];l=j+40|0;h[k>>3]=-4.82238053e-15;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];gxa(s,7,1034972.096,j);j=g;h[k>>3]=-7.97814851;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];gxa(t,2,-13842.86509,g);c[p>>2]=50528;h[p+8>>3]=.01801528;h[p+16>>3]=-13423382.81725291;h[p+24>>3]=549760.6476280135;h[p+32>>3]=1.0e3;g=p+40|0;j=q;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];j=p+52|0;g=r;c[j+0>>2]=c[g+0>>2];c[j+4>>2]=c[g+4>>2];c[j+8>>2]=c[g+8>>2];g=p+64|0;j=s;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];j=p+76|0;g=t;c[j+0>>2]=c[g+0>>2];c[j+4>>2]=c[g+4>>2];c[j+8>>2]=c[g+8>>2];h[p+88>>3]=461.5233290850878;g=c[b+536>>2]|0;j=c[c[v>>2]>>2]|0;t=c[j+8>>2]|0;C=+zd(+-+h[t+5960>>3],1.0e-15);A=+zd(+-+h[t+288>>3],1.0e-15);B=C+A;z=C*+h[t+5544>>3]+A*+h[t+3536>>3];do{if(B!=0.0){D=t;E=z/B}else{if(z==0.0){D=t;E=z;break}A=z/+nwa(g,B,56408,56712,+h[j>>3],(a[b+319|0]|0)!=0|0);D=c[(c[c[v>>2]>>2]|0)+8>>2]|0;E=A}}while(0);B=+h[D+448>>3];D=f;b=o;c[D+0>>2]=c[b+0>>2];c[D+4>>2]=c[b+4>>2];c[D+8>>2]=c[b+8>>2];b=e+0|0;D=p+0|0;p=b+96|0;do{c[b>>2]=c[D>>2];b=b+4|0;D=D+4|0}while((b|0)<(p|0));nA(u,g,E,190.0,647.0,B,f,e,1.0e-13);h[(c[(c[c[v>>2]>>2]|0)+8>>2]|0)+7744>>3]=+h[u>>3];i=d;return}function WO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+7728>>3];v=l;h[k>>3]=+h[t+7736>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];gxa(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+448>>3];w=+h[t+7744>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];vz(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Bz(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+496>>3];f=j;h[k>>3]=+h[q+7752>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];gxa(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+504>>3];y=+h[f+488>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];vz(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Bz(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+7136>>3]=+h[d+144>>3]*(w- +h[r>>3])*+h[d+1536>>3];i=b;return}function XO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+7728>>3];p=f;h[k>>3]=+h[n+7736>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+448>>3];q=+h[p+7744>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+9672>>3]=+h[l>>3];i=b;return}function YO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+7728>>3];p=f;h[k>>3]=+h[n+7736>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+448>>3];q=+h[p+7744>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+9616>>3]=+h[l>>3];i=b;return}function ZO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0.0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0.0;d=i;i=i+56|0;e=d;f=d+32|0;g=d+48|0;j=i;i=i+16|0;l=i;i=i+32|0;m=i;i=i+32|0;n=i;i=i+8|0;o=b+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[p+7728>>3];r=g;h[k>>3]=+h[p+7736>>3];c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];gxa(j,2,q,g);g=b+536|0;r=c[g>>2]|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[p+448>>3];s=+h[p+7744>>3];p=f;t=j;c[p+0>>2]=c[t+0>>2];c[p+4>>2]=c[t+4>>2];c[p+8>>2]=c[t+8>>2];mA(m,r,q,s,f);f=l;r=m;c[f+0>>2]=c[r+0>>2];c[f+4>>2]=c[r+4>>2];c[f+8>>2]=c[r+8>>2];c[f+12>>2]=c[r+12>>2];c[f+16>>2]=c[r+16>>2];c[f+20>>2]=c[r+20>>2];c[f+24>>2]=c[r+24>>2];c[f+28>>2]=c[r+28>>2];r=c[g>>2]|0;f=e;m=l;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];c[f+12>>2]=c[m+12>>2];c[f+16>>2]=c[m+16>>2];c[f+20>>2]=c[m+20>>2];c[f+24>>2]=c[m+24>>2];c[f+28>>2]=c[m+28>>2];qA(n,r,e);e=c[b+416>>2]|0;s=+h[n>>3]*+h[e+144>>3]*+h[e+1432>>3];e=c[c[o>>2]>>2]|0;n=c[e+8>>2]|0;q=+h[n+648>>3];if(s!=0.0){u=n;v=q/s;w=u;x=w+7336|0;y=x;h[y>>3]=v;i=d;return}if(q==0.0){u=n;v=q;w=u;x=w+7336|0;y=x;h[y>>3]=v;i=d;return}z=q/+nwa(c[g>>2]|0,s,56728,56720,+h[e>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[o>>2]>>2]|0)+8>>2]|0;v=z;w=u;x=w+7336|0;y=x;h[y>>3]=v;i=d;return}function _O(a){a=a|0;var b=0,d=0.0,e=0.0,f=0,g=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+6432>>3];e=+h[b+7336>>3];f=c[a+416>>2]|0;g=+h[f+144>>3];h[b+7184>>3]=+h[f+1536>>3]*(+h[b+9608>>3]*d*d*g- +h[b+9616>>3]*e*e*g);i=i;return}function $O(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7088>>3]=+h[b+7184>>3]- +h[b+7136>>3]- +h[b+7832>>3];i=i;return}function aP(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+1536>>3]*+h[e+144>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7088>>3];if(f!=0.0){l=j;m=k/f;n=l;o=n+7040|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+7040|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,f,56976,56968,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+7040|0;p=o;h[p>>3]=m;i=d;return}function bP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=a+8|0;a=c[d>>2]|0;e=b+16|0;f=c[e>>2]|0;h[f>>3]=+h[a+4672>>3];g=b+8|0;j=c[g>>2]|0;h[j>>3]=+h[a+4648>>3];k=b+12|0;b=c[k>>2]|0;h[b>>3]=+h[a+4656>>3];h[f+8>>3]=+h[a+7360>>3];h[j+8>>3]=+h[a+7336>>3];h[b+8>>3]=+h[a+7344>>3];h[f+16>>3]=+h[a+2880>>3];h[j+16>>3]=+h[a+2856>>3];h[b+16>>3]=+h[a+2864>>3];h[f+24>>3]=+h[a+864>>3];h[j+24>>3]=+h[a+840>>3];h[b+24>>3]=+h[a+848>>3];h[f+32>>3]=+h[a+528>>3];h[j+32>>3]=+h[a+504>>3];h[b+32>>3]=+h[a+512>>3];h[f+40>>3]=+h[a+192>>3];h[j+40>>3]=+h[a+168>>3];h[b+40>>3]=+h[a+176>>3];h[f+48>>3]=+h[a+1200>>3];h[j+48>>3]=+h[a+1176>>3];h[b+48>>3]=+h[a+1184>>3];h[f+56>>3]=+h[a+3216>>3];h[j+56>>3]=+h[a+3192>>3];h[b+56>>3]=+h[a+3200>>3];a=c[d>>2]|0;j=c[e>>2]|0;h[j+64>>3]=+h[a+3552>>3];f=c[g>>2]|0;h[f+64>>3]=+h[a+3528>>3];h[b+64>>3]=+h[a+3536>>3];h[j+72>>3]=+h[a+8032>>3];h[f+72>>3]=+h[a+8008>>3];b=c[k>>2]|0;h[b+72>>3]=+h[a+8016>>3];h[j+80>>3]=+h[a+7696>>3];h[f+80>>3]=+h[a+7672>>3];h[b+80>>3]=+h[a+7680>>3];h[j+88>>3]=+h[a+8368>>3];h[f+88>>3]=+h[a+8344>>3];h[b+88>>3]=+h[a+8352>>3];h[j+96>>3]=+h[a+83520>>3];h[f+96>>3]=+h[a+83496>>3];h[b+96>>3]=+h[a+83504>>3];h[j+104>>3]=+h[a+3888>>3];h[f+104>>3]=+h[a+3864>>3];h[b+104>>3]=+h[a+3872>>3];h[j+112>>3]=+h[a+7024>>3];h[f+112>>3]=+h[a+7e3>>3];h[b+112>>3]=+h[a+7008>>3];h[j+120>>3]=+h[a+2544>>3];h[f+120>>3]=+h[a+2520>>3];h[b+120>>3]=+h[a+2528>>3];a=c[d>>2]|0;f=c[e>>2]|0;h[f+128>>3]=+h[a+1536>>3];j=c[g>>2]|0;h[j+128>>3]=+h[a+1512>>3];h[b+128>>3]=+h[a+1520>>3];h[f+136>>3]=+h[a+5904>>3];h[j+136>>3]=+h[a+5880>>3];b=c[k>>2]|0;h[b+136>>3]=+h[a+5888>>3];h[f+144>>3]=+h[a+5232>>3];h[j+144>>3]=+h[a+5208>>3];h[b+144>>3]=+h[a+5216>>3];h[f+152>>3]=+h[a+5568>>3];h[j+152>>3]=+h[a+5544>>3];h[b+152>>3]=+h[a+5552>>3];h[f+160>>3]=+h[a+6240>>3];h[j+160>>3]=+h[a+6216>>3];h[b+160>>3]=+h[a+6224>>3];h[f+168>>3]=+h[a+4896>>3];h[j+168>>3]=+h[a+4872>>3];h[b+168>>3]=+h[a+4880>>3];h[f+176>>3]=+h[a+7920>>3];h[j+176>>3]=+h[a+7896>>3];h[b+176>>3]=+h[a+7904>>3];h[f+184>>3]=+h[a+8144>>3];h[j+184>>3]=+h[a+8120>>3];h[b+184>>3]=+h[a+8128>>3];a=c[d>>2]|0;j=c[e>>2]|0;h[j+192>>3]=+h[a+7584>>3];f=c[g>>2]|0;h[f+192>>3]=+h[a+7560>>3];h[b+192>>3]=+h[a+7568>>3];h[j+200>>3]=+h[a+7808>>3];h[f+200>>3]=+h[a+7784>>3];b=c[k>>2]|0;h[b+200>>3]=+h[a+7792>>3];h[j+208>>3]=+h[a+8256>>3];h[f+208>>3]=+h[a+8232>>3];h[b+208>>3]=+h[a+8240>>3];h[j+216>>3]=+h[a+8480>>3];h[f+216>>3]=+h[a+8456>>3];h[b+216>>3]=+h[a+8464>>3];h[j+224>>3]=+h[a+63696>>3];h[f+224>>3]=+h[a+63672>>3];h[b+224>>3]=+h[a+63680>>3];h[j+232>>3]=+h[a+63248>>3];h[f+232>>3]=+h[a+63224>>3];h[b+232>>3]=+h[a+63232>>3];h[j+240>>3]=+h[a+63360>>3];h[f+240>>3]=+h[a+63336>>3];h[b+240>>3]=+h[a+63344>>3];h[j+248>>3]=+h[a+5680>>3];h[f+248>>3]=+h[a+5656>>3];h[b+248>>3]=+h[a+5664>>3];a=c[d>>2]|0;f=c[e>>2]|0;h[f+256>>3]=+h[a+63584>>3];j=c[g>>2]|0;h[j+256>>3]=+h[a+63560>>3];h[b+256>>3]=+h[a+63568>>3];h[f+264>>3]=+h[a+5120>>3];h[j+264>>3]=+h[a+5096>>3];b=c[k>>2]|0;h[b+264>>3]=+h[a+5104>>3];h[f+272>>3]=+h[a+5344>>3];h[j+272>>3]=+h[a+5320>>3];h[b+272>>3]=+h[a+5328>>3];h[f+280>>3]=+h[a+63472>>3];h[j+280>>3]=+h[a+63448>>3];h[b+280>>3]=+h[a+63456>>3];h[f+288>>3]=+h[a+5456>>3];h[j+288>>3]=+h[a+5432>>3];h[b+288>>3]=+h[a+5440>>3];h[f+296>>3]=+h[a+4784>>3];h[j+296>>3]=+h[a+4760>>3];h[b+296>>3]=+h[a+4768>>3];h[f+304>>3]=+h[a+5008>>3];h[j+304>>3]=+h[a+4984>>3];h[b+304>>3]=+h[a+4992>>3];h[f+312>>3]=+h[a+2992>>3];h[j+312>>3]=+h[a+2968>>3];h[b+312>>3]=+h[a+2976>>3];a=c[d>>2]|0;j=c[e>>2]|0;h[j+320>>3]=+h[a+976>>3];f=c[g>>2]|0;h[f+320>>3]=+h[a+952>>3];h[b+320>>3]=+h[a+960>>3];h[j+328>>3]=+h[a+752>>3];h[f+328>>3]=+h[a+728>>3];b=c[k>>2]|0;h[b+328>>3]=+h[a+736>>3];h[j+336>>3]=+h[a+640>>3];h[f+336>>3]=+h[a+616>>3];h[b+336>>3]=+h[a+624>>3];h[j+344>>3]=+h[a+80>>3];h[f+344>>3]=+h[a+56>>3];h[b+344>>3]=+h[a+64>>3];h[j+352>>3]=+h[a+304>>3];h[f+352>>3]=+h[a+280>>3];h[b+352>>3]=+h[a+288>>3];h[j+360>>3]=+h[a+416>>3];h[f+360>>3]=+h[a+392>>3];h[b+360>>3]=+h[a+400>>3];h[j+368>>3]=+h[a+1088>>3];h[f+368>>3]=+h[a+1064>>3];h[b+368>>3]=+h[a+1072>>3];h[j+376>>3]=+h[a+1312>>3];h[f+376>>3]=+h[a+1288>>3];h[b+376>>3]=+h[a+1296>>3];a=c[d>>2]|0;f=c[e>>2]|0;h[f+384>>3]=+h[a+1648>>3];j=c[g>>2]|0;h[j+384>>3]=+h[a+1624>>3];h[b+384>>3]=+h[a+1632>>3];h[f+392>>3]=+h[a+1424>>3];h[j+392>>3]=+h[a+1400>>3];b=c[k>>2]|0;h[b+392>>3]=+h[a+1408>>3];h[f+400>>3]=+h[a+2656>>3];h[j+400>>3]=+h[a+2632>>3];h[b+400>>3]=+h[a+2640>>3];h[f+408>>3]=+h[a+2432>>3];h[j+408>>3]=+h[a+2408>>3];h[b+408>>3]=+h[a+2416>>3];h[f+416>>3]=+h[a+2768>>3];h[j+416>>3]=+h[a+2744>>3];h[b+416>>3]=+h[a+2752>>3];h[f+424>>3]=+h[a+3328>>3];h[j+424>>3]=+h[a+3304>>3];h[b+424>>3]=+h[a+3312>>3];h[f+432>>3]=+h[a+3104>>3];h[j+432>>3]=+h[a+3080>>3];h[b+432>>3]=+h[a+3088>>3];h[f+440>>3]=+h[a+3440>>3];h[j+440>>3]=+h[a+3416>>3];h[b+440>>3]=+h[a+3424>>3];a=c[d>>2]|0;j=c[e>>2]|0;h[j+448>>3]=+h[a+3664>>3];f=c[g>>2]|0;h[f+448>>3]=+h[a+3640>>3];h[b+448>>3]=+h[a+3648>>3];h[j+456>>3]=+h[a+4e3>>3];h[f+456>>3]=+h[a+3976>>3];b=c[k>>2]|0;h[b+456>>3]=+h[a+3984>>3];h[j+464>>3]=+h[a+3776>>3];h[f+464>>3]=+h[a+3752>>3];h[b+464>>3]=+h[a+3760>>3];h[j+472>>3]=+h[a+6912>>3];h[f+472>>3]=+h[a+6888>>3];h[b+472>>3]=+h[a+6896>>3];h[j+480>>3]=+h[a+7472>>3];h[f+480>>3]=+h[a+7448>>3];h[b+480>>3]=+h[a+7456>>3];h[j+488>>3]=+h[a+7248>>3];h[f+488>>3]=+h[a+7224>>3];h[b+488>>3]=+h[a+7232>>3];h[j+496>>3]=+h[a+7136>>3];h[f+496>>3]=+h[a+7112>>3];h[b+496>>3]=+h[a+7120>>3];h[j+504>>3]=+h[a+6352>>3];h[f+504>>3]=+h[a+6328>>3];h[b+504>>3]=+h[a+6336>>3];a=c[d>>2]|0;d=c[e>>2]|0;h[d+512>>3]=+h[a+5792>>3];e=c[g>>2]|0;h[e+512>>3]=+h[a+5768>>3];h[b+512>>3]=+h[a+5776>>3];h[d+520>>3]=+h[a+6016>>3];h[e+520>>3]=+h[a+5992>>3];b=c[k>>2]|0;h[b+520>>3]=+h[a+6e3>>3];h[d+528>>3]=+h[a+6128>>3];h[e+528>>3]=+h[a+6104>>3];h[b+528>>3]=+h[a+6112>>3];i=i;return}function cP(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0.0,v=0,w=0,x=0.0,y=0,z=0,B=0.0,C=0,D=0,E=0.0,F=0,G=0,J=0.0,K=0,L=0,M=0.0,N=0,O=0,P=0.0,Q=0,R=0,S=0.0,T=0,U=0,V=0.0,W=0,X=0,Y=0.0,Z=0.0;f=i;i=i+4488|0;j=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;h[j+328>>3]=+h[d>>3];h[j+520>>3]=+h[d+8>>3];h[j+200>>3]=+h[d+16>>3];h[j+56>>3]=+h[d+24>>3];h[j+32>>3]=+h[d+32>>3];h[j+8>>3]=+h[d+40>>3];h[j+80>>3]=+h[d+48>>3];h[j+224>>3]=+h[d+56>>3];h[j+248>>3]=+h[d+64>>3];h[j+568>>3]=+h[d+72>>3];h[j+544>>3]=+h[d+80>>3];h[j+592>>3]=+h[d+88>>3];h[j+5960>>3]=+h[d+96>>3];h[j+272>>3]=+h[d+104>>3];h[j+496>>3]=+h[d+112>>3];h[j+176>>3]=+h[d+120>>3];h[j+104>>3]=+h[d+128>>3];h[j+416>>3]=+h[d+136>>3];h[j+368>>3]=+h[d+144>>3];h[j+392>>3]=+h[d+152>>3];h[j+440>>3]=+h[d+160>>3];h[j+344>>3]=+h[d+168>>3];h[j+560>>3]=+h[d+176>>3];h[j+576>>3]=+h[d+184>>3];j=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;h[j+536>>3]=+h[d+192>>3];h[j+552>>3]=+h[d+200>>3];h[j+584>>3]=+h[d+208>>3];h[j+600>>3]=+h[d+216>>3];h[j+4544>>3]=+h[d+224>>3];h[j+4512>>3]=+h[d+232>>3];h[j+4520>>3]=+h[d+240>>3];h[j+400>>3]=+h[d+248>>3];h[j+4536>>3]=+h[d+256>>3];h[j+360>>3]=+h[d+264>>3];h[j+376>>3]=+h[d+272>>3];h[j+4528>>3]=+h[d+280>>3];h[j+384>>3]=+h[d+288>>3];h[j+336>>3]=+h[d+296>>3];h[j+352>>3]=+h[d+304>>3];h[j+208>>3]=+h[d+312>>3];h[j+64>>3]=+h[d+320>>3];h[j+48>>3]=+h[d+328>>3];h[j+40>>3]=+h[d+336>>3];h[j>>3]=+h[d+344>>3];h[j+16>>3]=+h[d+352>>3];h[j+24>>3]=+h[d+360>>3];h[j+72>>3]=+h[d+368>>3];h[j+88>>3]=+h[d+376>>3];h[j+112>>3]=+h[d+384>>3];j=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;h[j+96>>3]=+h[d+392>>3];h[j+184>>3]=+h[d+400>>3];h[j+168>>3]=+h[d+408>>3];h[j+192>>3]=+h[d+416>>3];h[j+232>>3]=+h[d+424>>3];h[j+216>>3]=+h[d+432>>3];h[j+240>>3]=+h[d+440>>3];h[j+256>>3]=+h[d+448>>3];h[j+280>>3]=+h[d+456>>3];h[j+264>>3]=+h[d+464>>3];h[j+488>>3]=+h[d+472>>3];h[j+528>>3]=+h[d+480>>3];h[j+512>>3]=+h[d+488>>3];h[j+504>>3]=+h[d+496>>3];h[j+448>>3]=+h[d+504>>3];h[j+408>>3]=+h[d+512>>3];h[j+424>>3]=+h[d+520>>3];h[j+432>>3]=+h[d+528>>3];QA(b);RA(b);SA(b);TA(b);UA(b);VA(b);WA(b);XA(b);YA(b);ZA(b);_A(b);$A(b);aB(b);bB(b);cB(b);dB(b);eB(b);fB(b);gB(b);hB(b);iB(b);jB(b);kB(b);lB(b);mB(b);nB(b);oB(b);pB(b);qB(b);rB(b);sB(b);tB(b);uB(b);vB(b);wB(b);xB(b);yB(b);zB(b);AB(b);BB(b);CB(b);DB(b);EB(b);FB(b);GB(b);HB(b);IB(b);JB(b);KB(b);LB(b);MB(b);NB(b);OB(b);PB(b);QB(b);RB(b);SB(b);TB(b);UB(b);VB(b);WB(b);XB(b);YB(b);ZB(b);_B(b);$B(b);aC(b);bC(b);cC(b);dC(b);eC(b);fC(b);gC(b);hC(b);iC(b);jC(b);kC(b);lC(b);mC(b);nC(b);oC(b);pC(b);qC(b);rC(b);sC(b);tC(b);uC(b);vC(b);wC(b);xC(b);yC(b);zC(b);AC(b);BC(b);CC(b);DC(b);EC(b);FC(b);GC(b);HC(b);IC(b);JC(b);KC(b);LC(b);MC(b);NC(b);OC(b);PC(b);QC(b);RC(b);SC(b);TC(b);UC(b);VC(b);WC(b);XC(b);YC(b);ZC(b);_C(b);$C(b);aD(b);bD(b);cD(b);dD(b);eD(b);fD(b);gD(b);hD(b);iD(b);jD(b);kD(b);lD(b);mD(b);nD(b);oD(b);pD(b);qD(b);rD(b);sD(b);tD(b);uD(b);vD(b);wD(b);xD(b);yD(b);zD(b);AD(b);BD(b);CD(b);DD(b);ED(b);FD(b);GD(b);HD(b);ID(b);JD(b);KD(b);LD(b);MD(b);ND(b);OD(b);PD(b);QD(b);RD(b);SD(b);TD(b);UD(b);VD(b);WD(b);XD(b);YD(b);ZD(b);_D(b);$D(b);aE(b);bE(b);cE(b);dE(b);eE(b);fE(b);gE(b);hE(b);iE(b);jE(b);kE(b);lE(b);mE(b);nE(b);oE(b);pE(b);qE(b);rE(b);sE(b);tE(b);uE(b);vE(b);wE(b);xE(b);yE(b);zE(b);AE(b);BE(b);CE(b);DE(b);EE(b);FE(b);GE(b);HE(b);IE(b);JE(b);KE(b);LE(b);ME(b);NE(b);OE(b);PE(b);QE(b);RE(b);SE(b);TE(b);UE(b);VE(b);WE(b);XE(b);YE(b);ZE(b);_E(b);$E(b);aF(b);bF(b);cF(b);dF(b);eF(b);fF(b);gF(b);hF(b);iF(b);jF(b);kF(b);lF(b);mF(b);nF(b);oF(b);pF(b);qF(b);rF(b);sF(b);tF(b);uF(b);vF(b);wF(b);xF(b);yF(b);zF(b);AF(b);BF(b);CF(b);DF(b);EF(b);FF(b);GF(b);HF(b);IF(b);JF(b);KF(b);LF(b);MF(b);NF(b);OF(b);PF(b);QF(b);RF(b);SF(b);TF(b);UF(b);VF(b);WF(b);XF(b);YF(b);ZF(b);_F(b);$F(b);aG(b);bG(b);cG(b);dG(b);eG(b);fG(b);gG(b);hG(b);iG(b);jG(b);kG(b);lG(b);mG(b);nG(b);oG(b);pG(b);qG(b);rG(b);sG(b);tG(b);uG(b);vG(b);wG(b);xG(b);yG(b);zG(b);AG(b);BG(b);CG(b);DG(b);EG(b);FG(b);GG(b);HG(b);IG(b);JG(b);KG(b);LG(b);MG(b);NG(b);OG(b);PG(b);QG(b);RG(b);SG(b);TG(b);UG(b);VG(b);WG(b);XG(b);YG(b);ZG(b);_G(b);$G(b);aH(b);bH(b);cH(b);dH(b);eH(b);fH(b);gH(b);hH(b);iH(b);jH(b);kH(b);lH(b);mH(b);nH(b);oH(b);pH(b);qH(b);rH(b);sH(b);tH(b);uH(b);vH(b);wH(b);xH(b);yH(b);zH(b);AH(b);BH(b);CH(b);DH(b);EH(b);FH(b);GH(b);HH(b);IH(b);JH(b);KH(b);LH(b);MH(b);NH(b);OH(b);PH(b);QH(b);RH(b);SH(b);TH(b);UH(b);VH(b);WH(b);XH(b);YH(b);ZH(b);_H(b);$H(b);aI(b);bI(b);cI(b);dI(b);eI(b);fI(b);gI(b);hI(b);iI(b);jI(b);kI(b);lI(b);mI(b);nI(b);oI(b);pI(b);qI(b);rI(b);sI(b);tI(b);uI(b);vI(b);wI(b);xI(b);yI(b);zI(b);AI(b);BI(b);CI(b);DI(b);EI(b);FI(b);GI(b);HI(b);II(b);JI(b);KI(b);LI(b);MI(b);NI(b);OI(b);PI(b);QI(b);RI(b);SI(b);TI(b);UI(b);VI(b);WI(b);XI(b);YI(b);ZI(b);_I(b);$I(b);aJ(b);bJ(b);cJ(b);dJ(b);eJ(b);fJ(b);gJ(b);hJ(b);iJ(b);jJ(b);kJ(b);lJ(b);mJ(b);nJ(b);oJ(b);pJ(b);qJ(b);rJ(b);sJ(b);tJ(b);uJ(b);vJ(b);wJ(b);xJ(b);yJ(b);zJ(b);AJ(b);BJ(b);CJ(b);DJ(b);EJ(b);FJ(b);GJ(b);HJ(b);IJ(b);JJ(b);KJ(b);LJ(b);MJ(b);NJ(b);OJ(b);PJ(b);QJ(b);RJ(b);SJ(b);TJ(b);UJ(b);VJ(b);WJ(b);XJ(b);YJ(b);ZJ(b);_J(b);$J(b);aK(b);bK(b);cK(b);dK(b);eK(b);fK(b);gK(b);hK(b);iK(b);jK(b);kK(b);lK(b);mK(b);nK(b);oK(b);pK(b);qK(b);rK(b);sK(b);tK(b);uK(b);vK(b);wK(b);xK(b);yK(b);zK(b);AK(b);BK(b);CK(b);DK(b);EK(b);FK(b);GK(b);HK(b);IK(b);JK(b);KK(b);LK(b);MK(b);NK(b);OK(b);PK(b);QK(b);RK(b);SK(b);TK(b);UK(b);VK(b);WK(b);XK(b);YK(b);ZK(b);_K(b);$K(b);aL(b);bL(b);cL(b);dL(b);eL(b);fL(b);gL(b);hL(b);iL(b);jL(b);kL(b);lL(b);mL(b);nL(b);oL(b);pL(b);qL(b);rL(b);sL(b);tL(b);uL(b);vL(b);wL(b);xL(b);yL(b);zL(b);AL(b);BL(b);CL(b);DL(b);EL(b);FL(b);GL(b);HL(b);IL(b);JL(b);KL(b);LL(b);ML(b);NL(b);OL(b);PL(b);QL(b);RL(b);SL(b);TL(b);UL(b);VL(b);WL(b);XL(b);YL(b);ZL(b);_L(b);$L(b);aM(b);bM(b);cM(b);dM(b);eM(b);fM(b);gM(b);hM(b);iM(b);jM(b);kM(b);lM(b);mM(b);nM(b);oM(b);pM(b);qM(b);rM(b);sM(b);tM(b);uM(b);vM(b);wM(b);xM(b);yM(b);zM(b);AM(b);BM(b);CM(b);DM(b);EM(b);FM(b);GM(b);HM(b);IM(b);JM(b);KM(b);LM(b);MM(b);NM(b);OM(b);PM(b);QM(b);RM(b);SM(b);TM(b);UM(b);VM(b);WM(b);XM(b);YM(b);ZM(b);_M(b);$M(b);aN(b);bN(b);cN(b);dN(b);eN(b);fN(b);gN(b);hN(b);iN(b);jN(b);kN(b);lN(b);mN(b);nN(b);oN(b);pN(b);qN(b);rN(b);sN(b);tN(b);uN(b);vN(b);wN(b);xN(b);yN(b);zN(b);AN(b);BN(b);CN(b);DN(b);EN(b);FN(b);GN(b);HN(b);IN(b);JN(b);KN(b);LN(b);MN(b);NN(b);ON(b);PN(b);QN(b);RN(b);SN(b);TN(b);UN(b);VN(b);WN(b);XN(b);YN(b);ZN(b);_N(b);$N(b);aO(b);bO(b);cO(b);dO(b);eO(b);fO(b);gO(b);hO(b);iO(b);jO(b);kO(b);lO(b);mO(b);nO(b);oO(b);pO(b);qO(b);rO(b);sO(b);tO(b);uO(b);vO(b);wO(b);xO(b);yO(b);zO(b);AO(b);BO(b);CO(b);DO(b);EO(b);FO(b);GO(b);HO(b);IO(b);JO(b);KO(b);LO(b);MO(b);NO(b);OO(b);PO(b);QO(b);RO(b);SO(b);TO(b);UO(b);VO(b);WO(b);XO(b);YO(b);ZO(b);_O(b);$O(b);aP(b);d=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;k=+h[d+464>>3];h[e>>3]=+h[d+5920>>3]-k*+h[(!(k>=0.0)?d+392|0:d+416|0)>>3];j=c[(b+416|0)>>2]|0;h[e+8>>3]=+h[d+6016>>3]- +h[d+4520>>3]*+h[d+10168>>3]*(+h[d+1336>>3]- +h[d+4480>>3])*+h[j+1864>>3];k=+h[(b+304|0)>>3];Kz(f,c[(b+536|0)>>2]|0,+h[d+5552>>3],+h[d+5816>>3],+h[d+5824>>3],+h[d+5744>>3],+h[d+5752>>3],+h[d+10200>>3],+h[d+9888>>3],+h[j+1824>>3]*7.5,(+h[j+488>>3]+ +h[j+496>>3])*.5,+h[j+1816>>3]*.25,+h[j+1784>>3]);l=+h[f>>3];j=c[c[(b+4|0)>>2]>>2]|0;d=c[j+8>>2]|0;m=+h[d+456>>3];n=c[(b+416|0)>>2]|0;o=+h[d+5552>>3]+ +h[n+1824>>3]*+h[n+1840>>3]*-7.5;p=+h[n+1792>>3];q=+h[n+1800>>3];do{if(p!=0.0){r=d;s=n;t=q/p}else{if(q==0.0){r=d;s=n;t=q;break}u=q/+nwa(c[(b+536|0)>>2]|0,p,57032,57024,+h[j>>3],(a[b+319|0]|0)!=0|0);r=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;s=c[(b+416|0)>>2]|0;t=u}}while(0);h[e+16>>3]=m+((k+-1.0)*o*t-k*l*+h[s+1760>>3]);l=+h[(b+304|0)>>3];k=+h[s+224>>3];Kz(f+8|0,c[(b+536|0)>>2]|0,+h[r+7040>>3],+h[r+9608>>3],+h[r+9616>>3],+h[r+9664>>3],+h[r+9672>>3],+h[r+10048>>3],+h[s+184>>3],+h[s+1600>>3]*5.0,(k+k)*.5,+h[s+1592>>3]/6.0,+h[s+1560>>3]);k=+h[(f+8|0)>>3];s=c[c[(b+4|0)>>2]>>2]|0;r=c[s+8>>2]|0;t=+h[r+648>>3];j=c[(b+416|0)>>2]|0;o=+h[r+7040>>3]+ +h[j+1600>>3]*+h[j+1616>>3]*-5.0;m=+h[j+1568>>3];p=+h[j+1576>>3];do{if(m!=0.0){v=r;w=j;x=p/m}else{if(p==0.0){v=r;w=j;x=p;break}q=p/+nwa(c[(b+536|0)>>2]|0,m,57064,57024,+h[s>>3],(a[b+319|0]|0)!=0|0);v=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;w=c[(b+416|0)>>2]|0;x=q}}while(0);h[e+24>>3]=t+((l+-1.0)*o*x-l*k*+h[w+1536>>3]);h[e+32>>3]=+h[v+6008>>3]- +h[v+4512>>3]*+h[v+10160>>3]*(+h[v+1344>>3]- +h[v+4472>>3])*+h[w+1864>>3];k=+h[v+624>>3];h[e+40>>3]=+h[v+7416>>3]-k*+h[(!(k>=0.0)?v+544|0:v+568|0)>>3];k=+h[(b+304|0)>>3];Kz(f+16|0,c[(b+536|0)>>2]|0,+h[v+7024>>3],+h[v+9592>>3],+h[v+9600>>3],+h[v+9648>>3],+h[v+9656>>3],+h[v+10032>>3],+h[v+9936>>3],+h[w+1600>>3]*10.0,(+h[w+208>>3]+ +h[w+216>>3])*.5,+h[w+1592>>3]/6.0,+h[w+1560>>3]);l=+h[(f+16|0)>>3];w=c[c[(b+4|0)>>2]>>2]|0;v=c[w+8>>2]|0;x=+h[v+632>>3];s=c[(b+416|0)>>2]|0;o=+h[v+7024>>3]+ +h[s+1600>>3]*+h[s+1616>>3]*-10.0;t=+h[s+1568>>3];m=+h[s+1576>>3];do{if(t!=0.0){y=v;z=s;B=m/t}else{if(m==0.0){y=v;z=s;B=m;break}p=m/+nwa(c[(b+536|0)>>2]|0,t,57064,57024,+h[w>>3],(a[b+319|0]|0)!=0|0);y=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;z=c[(b+416|0)>>2]|0;B=p}}while(0);h[e+48>>3]=x+((k+-1.0)*o*B-k*l*+h[z+1536>>3]);l=+h[y+632>>3];h[e+56>>3]=+h[y+7424>>3]-l*+h[(!(l>=0.0)?y+520|0:y+544|0)>>3];l=+h[(b+304|0)>>3];Kz(f+24|0,c[(b+536|0)>>2]|0,+h[y+7032>>3],+h[y+9600>>3],+h[y+9608>>3],+h[y+9656>>3],+h[y+9664>>3],+h[y+10040>>3],+h[y+9928>>3],+h[z+1600>>3]*10.0,(+h[z+216>>3]+ +h[z+224>>3])*.5,+h[z+1592>>3]/6.0,+h[z+1560>>3]);k=+h[(f+24|0)>>3];z=c[c[(b+4|0)>>2]>>2]|0;y=c[z+8>>2]|0;B=+h[y+640>>3];w=c[(b+416|0)>>2]|0;o=+h[y+7032>>3]+ +h[w+1600>>3]*+h[w+1616>>3]*-10.0;x=+h[w+1568>>3];t=+h[w+1576>>3];do{if(x!=0.0){C=y;D=w;E=t/x}else{if(t==0.0){C=y;D=w;E=t;break}m=t/+nwa(c[(b+536|0)>>2]|0,x,57064,57024,+h[z>>3],(a[b+319|0]|0)!=0|0);C=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;D=c[(b+416|0)>>2]|0;E=m}}while(0);h[e+64>>3]=B+((l+-1.0)*o*E-l*k*+h[D+1536>>3]);k=+h[(b+304|0)>>3];l=+h[D+784>>3];Kz(f+32|0,c[(b+536|0)>>2]|0,+h[C+3544>>3],+h[C+3936>>3],+h[C+3944>>3],+h[C+3832>>3],+h[C+3840>>3],+h[C+10304>>3],+h[D+744>>3],+h[D+2056>>3]*2.5,(l+l)*.5,+h[D+2048>>3]/6.0,+h[D+2016>>3]);l=+h[(f+32|0)>>3];D=c[c[(b+4|0)>>2]>>2]|0;C=c[D+8>>2]|0;E=+h[C+288>>3];z=c[(b+416|0)>>2]|0;o=+h[C+3544>>3]+ +h[z+2056>>3]*+h[z+2072>>3]*-2.5;B=+h[z+2024>>3];x=+h[z+2032>>3];do{if(B!=0.0){F=C;G=z;J=x/B}else{if(x==0.0){F=C;G=z;J=x;break}t=x/+nwa(c[(b+536|0)>>2]|0,B,57096,57024,+h[D>>3],(a[b+319|0]|0)!=0|0);F=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;G=c[(b+416|0)>>2]|0;J=t}}while(0);h[e+72>>3]=E+((k+-1.0)*o*J-k*l*+h[G+1992>>3]);l=+h[(b+304|0)>>3];Kz(f+40|0,c[(b+536|0)>>2]|0,+h[F+3552>>3],+h[F+3944>>3],+h[F+3952>>3],+h[F+3840>>3],+h[F+3848>>3],+h[F+10312>>3],+h[F+9880>>3],+h[G+2056>>3]*5.0,(+h[G+784>>3]+ +h[G+792>>3])*.5,+h[G+2048>>3]/6.0,+h[G+2016>>3]);k=+h[(f+40|0)>>3];G=c[c[(b+4|0)>>2]>>2]|0;F=c[G+8>>2]|0;J=+h[F+296>>3];D=c[(b+416|0)>>2]|0;o=+h[F+3552>>3]+ +h[D+2056>>3]*+h[D+2072>>3]*-5.0;E=+h[D+2024>>3];B=+h[D+2032>>3];do{if(E!=0.0){K=F;L=D;M=B/E}else{if(B==0.0){K=F;L=D;M=B;break}x=B/+nwa(c[(b+536|0)>>2]|0,E,57096,57024,+h[G>>3],(a[b+319|0]|0)!=0|0);K=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;L=c[(b+416|0)>>2]|0;M=x}}while(0);h[e+80>>3]=J+((l+-1.0)*o*M-l*k*+h[L+1992>>3]);G=K+3560|0;D=L+1352|0;F=L+1888|0;h[e+88>>3]=+h[K+4112>>3]- +h[K+2952>>3]*+h[L+712>>3]*+h[F>>3]*(+h[K+232>>3]*.5+(+h[K+280>>3]*-.5+((+h[K+3552>>3]+ +h[G>>3])*.5+ +h[D>>3]*+h[K+3416>>3]*-5.0)));h[e+96>>3]=+h[K+4120>>3]- +h[K+2960>>3]*+h[L+720>>3]*+h[F>>3]*(+h[K+208>>3]*.5+(+h[K+256>>3]*-.5+((+h[G>>3]+ +h[K+3568>>3])*.5+ +h[D>>3]*+h[K+3304>>3]*-5.0)));k=+h[(b+304|0)>>3];Kz(f+48|0,c[(b+536|0)>>2]|0,+h[G>>3],+h[K+3952>>3],+h[K+3960>>3],+h[K+3848>>3],+h[K+3856>>3],+h[K+10320>>3],+h[K+9872>>3],+h[L+2056>>3]*5.0,(+h[L+792>>3]+ +h[L+800>>3])*.5,+h[L+2048>>3]/6.0,+h[L+2016>>3]);l=+h[(f+48|0)>>3];L=c[c[(b+4|0)>>2]>>2]|0;K=c[L+8>>2]|0;M=+h[K+304>>3];G=c[(b+416|0)>>2]|0;o=+h[K+3560>>3]+ +h[G+2056>>3]*+h[G+2072>>3]*-5.0;J=+h[G+2024>>3];E=+h[G+2032>>3];do{if(J!=0.0){N=K;O=G;P=E/J}else{if(E==0.0){N=K;O=G;P=E;break}B=E/+nwa(c[(b+536|0)>>2]|0,J,57096,57024,+h[L>>3],(a[b+319|0]|0)!=0|0);N=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;O=c[(b+416|0)>>2]|0;P=B}}while(0);h[e+104>>3]=M+((k+-1.0)*o*P-k*l*+h[O+1992>>3]);L=N+3576|0;G=O+1352|0;K=O+1888|0;h[e+112>>3]=+h[N+4128>>3]- +h[N+2968>>3]*+h[O+728>>3]*+h[K>>3]*(+h[N+184>>3]*.5+(+h[N+232>>3]*-.5+((+h[N+3568>>3]+ +h[L>>3])*.5+ +h[G>>3]*+h[N+3192>>3]*-5.0)));h[e+120>>3]=+h[N+4136>>3]- +h[N+2976>>3]*+h[O+736>>3]*+h[K>>3]*((+h[N+352>>3]- +h[N+208>>3])/1.5+(+h[L>>3]*.5+(+h[N+3584>>3]+ +h[G>>3]*+h[N+3080>>3]*-5.0)));l=+h[(b+304|0)>>3];Kz(f+56|0,c[(b+536|0)>>2]|0,+h[L>>3],+h[N+3968>>3],+h[N+3976>>3],+h[N+3864>>3],+h[N+3872>>3],+h[N+10336>>3],+h[N+9856>>3],+h[O+2056>>3]*5.0,(+h[O+808>>3]+ +h[O+816>>3])*.5,+h[O+2048>>3]/6.0,+h[O+2016>>3]);k=+h[(f+56|0)>>3];O=c[c[(b+4|0)>>2]>>2]|0;N=c[O+8>>2]|0;P=+h[N+320>>3];L=c[(b+416|0)>>2]|0;o=+h[N+3576>>3]+ +h[L+2056>>3]*+h[L+2072>>3]*-5.0;M=+h[L+2024>>3];J=+h[L+2032>>3];do{if(M!=0.0){Q=N;R=L;S=J/M}else{if(J==0.0){Q=N;R=L;S=J;break}E=J/+nwa(c[(b+536|0)>>2]|0,M,57096,57024,+h[O>>3],(a[b+319|0]|0)!=0|0);Q=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;R=c[(b+416|0)>>2]|0;S=E}}while(0);h[e+128>>3]=P+((l+-1.0)*o*S-l*k*+h[R+1992>>3]);h[e+136>>3]=+h[Q+2552>>3]- +h[Q+1392>>3]*+h[R+1e3>>3]*+h[R+2112>>3]*((+h[Q+88>>3]- +h[Q+352>>3])/1.5+(+h[Q+1992>>3]+(+h[Q+2e3>>3]*.5+ +h[R+1352>>3]*+h[Q+1976>>3]*-10.0)));k=+h[(b+304|0)>>3];l=+h[R+816>>3];Kz(f+64|0,c[(b+536|0)>>2]|0,+h[Q+3584>>3],+h[Q+3976>>3],+h[Q+3984>>3],+h[Q+3872>>3],+h[Q+3880>>3],+h[Q+10344>>3],+h[R+776>>3],+h[R+2056>>3]*2.5,(l+l)*.5,+h[R+2048>>3]/6.0,+h[R+2016>>3]);l=+h[(f+64|0)>>3];R=c[c[(b+4|0)>>2]>>2]|0;Q=c[R+8>>2]|0;S=+h[Q+328>>3];O=c[(b+416|0)>>2]|0;o=+h[Q+3584>>3]+ +h[O+2056>>3]*+h[O+2072>>3]*-2.5;P=+h[O+2024>>3];M=+h[O+2032>>3];do{if(P!=0.0){T=Q;U=O;V=M/P}else{if(M==0.0){T=Q;U=O;V=M;break}J=M/+nwa(c[(b+536|0)>>2]|0,P,57096,57024,+h[R>>3],(a[b+319|0]|0)!=0|0);T=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;U=c[(b+416|0)>>2]|0;V=J}}while(0);h[e+144>>3]=S+((k+-1.0)*o*V-k*l*+h[U+1992>>3]);l=+h[(b+304|0)>>3];Kz(f+72|0,c[(b+536|0)>>2]|0,+h[T+2e3>>3],+h[T+2392>>3],+h[T+2400>>3],+h[T+2288>>3],+h[T+2296>>3],+h[T+10448>>3],+h[T+9848>>3],+h[U+2280>>3]*10.0,(+h[U+1080>>3]+ +h[U+1088>>3])*.5,+h[U+2272>>3]/6.0,+h[U+2240>>3]);k=+h[(f+72|0)>>3];U=c[c[(b+4|0)>>2]>>2]|0;T=c[U+8>>2]|0;V=+h[T+128>>3];R=c[(b+416|0)>>2]|0;o=+h[T+2e3>>3]+ +h[R+2280>>3]*+h[R+2296>>3]*-10.0;S=+h[R+2248>>3];P=+h[R+2256>>3];do{if(S!=0.0){W=T;X=R;Y=P/S}else{if(P==0.0){W=T;X=R;Y=P;break}M=P/+nwa(c[(b+536|0)>>2]|0,S,57128,57024,+h[U>>3],(a[b+319|0]|0)!=0|0);W=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;X=c[(b+416|0)>>2]|0;Y=M}}while(0);h[e+152>>3]=V+((l+-1.0)*o*Y-l*k*+h[X+2216>>3]);k=+h[W+136>>3];h[e+160>>3]=+h[W+2520>>3]-k*+h[(!(k>=0.0)?W+56|0:W+80|0)>>3];k=+h[W+160>>3];if(!(k>=0.0)){Z=.01}else{Z=+h[W+8>>3]}h[e+168>>3]=+h[W+2544>>3]-k*Z;h[e+176>>3]=+h[W+2576>>3]- +h[W+1416>>3]*+h[X+1024>>3]*+h[X+2112>>3]*(+h[W+16>>3]*.5+(+h[W+64>>3]*-.5+((+h[W+2016>>3]+ +h[W+2024>>3])*.5+ +h[X+1352>>3]*+h[W+1640>>3]*-10.0)));Z=+h[(b+304|0)>>3];k=+h[X+1112>>3];Kz(f+80|0,c[(b+536|0)>>2]|0,+h[W+2032>>3],+h[W+2424>>3],+h[W+2432>>3],+h[W+2320>>3],+h[W+2328>>3],+h[W+10480>>3],+h[X+1072>>3],+h[X+2280>>3]*5.0,(k+k)*.5,+h[X+2272>>3]/6.0,+h[X+2240>>3]);k=+h[(f+80|0)>>3];X=c[c[(b+4|0)>>2]>>2]|0;W=c[X+8>>2]|0;l=+h[W+160>>3];U=c[(b+416|0)>>2]|0;Y=+h[W+2032>>3]+ +h[U+2280>>3]*+h[U+2296>>3]*-5.0;o=+h[U+2248>>3];V=+h[U+2256>>3];c[f+224>>2]=b;c[f+240>>2]=e;g[f+664>>2]=Z;g[f+680>>2]=k;c[f+688>>2]=X;c[f+696>>2]=W;g[f+704>>2]=l;c[f+712>>2]=U;g[f+720>>2]=Y;g[f+728>>2]=o;g[f+736>>2]=V;c[f+4408>>2]=0;c[f+4412>>2]=0;_residualFunc1187$0(f);H=c[f+4408>>2]|0;A=c[f+4412>>2]|0;I=+g[f+4412>>2];c[f+4408>>2]=0;c[f+4412>>2]=0;if((H|0)==5){return}}function dP(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+28528>>3];h[c[b+8>>2]>>3]=+h[d+28504>>3];h[c[b+12>>2]>>3]=+h[d+28512>>3];i=i;return}function eP(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0,k=0,l=0,m=0.0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+2032>>3]=g;k=a+416|0;l=c[k>>2]|0;m=+h[l+1112>>3];Kz(f,c[a+536>>2]|0,g,+h[j+2424>>3],+h[j+2432>>3],+h[j+2320>>3],+h[j+2328>>3],+h[j+10480>>3],+h[l+1072>>3],+h[l+2280>>3]*5.0,(m+m)*.5,+h[l+2272>>3]/6.0,+h[l+2240>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+160>>3]- +h[f>>3]*+h[(c[k>>2]|0)+2216>>3];i=e;return}function fP(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+28416>>3];h[c[b+8>>2]>>3]=+h[d+28392>>3];h[c[b+12>>2]>>3]=+h[d+28400>>3];i=i;return}function gP(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+2024>>3]=g;k=a+416|0;l=c[k>>2]|0;Kz(f,c[a+536>>2]|0,g,+h[j+2416>>3],+h[j+2424>>3],+h[j+2312>>3],+h[j+2320>>3],+h[j+10472>>3],+h[j+9824>>3],+h[l+2280>>3]*10.0,(+h[l+1104>>3]+ +h[l+1112>>3])*.5,+h[l+2272>>3]/6.0,+h[l+2240>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+152>>3]- +h[f>>3]*+h[(c[k>>2]|0)+2216>>3];i=e;return}function hP(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[63880]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=57624;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&127](mb,m,42696,s);ib=lb;jb=+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]}jA(t,c[ib>>2]|0,jb);jb=+h[t>>3];kA(u,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(v,c[ib>>2]|0,jb,+h[u>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);jb=+h[v>>3];jA(w,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);pb=+h[w>>3];kA(x,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(y,c[ib>>2]|0,pb,+h[x>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+8>>3];qb=+zd(1.0e-13,+(+h[w+16>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+nwa(c[ib>>2]|0,qb,42768,57160,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(pb- +yd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{jA(z,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);sb=+h[z>>3];kA(A,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(B,c[ib>>2]|0,sb,+h[A>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);sb=+h[B>>3];jA(C,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);jb=+h[C>>3];kA(D,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(E,c[ib>>2]|0,jb,+h[D>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+zd(1.0e-13,+(+h[C+16>>3]- +h[E>>3]));pb=1.0- +h[C+8>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+nwa(c[ib>>2]|0,jb,42768,57160,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{jA(F,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);vb=+h[F>>3];kA(G,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(H,c[ib>>2]|0,vb,+h[G>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);vb=+h[H>>3];jA(I,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);sb=+h[I>>3];kA(J,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(K,c[ib>>2]|0,sb,+h[J>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);sb=+h[K>>3];jA(L,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);jb=+h[L>>3];kA(M,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(N,c[ib>>2]|0,jb,+h[M>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+16>>3]- +h[N>>3])|0)<<24>>24==0){jA(O,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);jb=+h[O>>3];kA(P,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Q,c[ib>>2]|0,+h[P>>3],+h[P+656>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(R,c[ib>>2]|0,+h[Q>>3],+h[Q+656>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(S,c[ib>>2]|0,jb,pb,+h[Q>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+656>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+672>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}jA(T,c[ib>>2]|0,+h[xb>>3]);qb=+h[T>>3];kA(U,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(V,c[ib>>2]|0,qb,+h[U>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);qb=+h[V>>3];jA(W,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);pb=+h[W>>3];kA(X,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(Y,c[ib>>2]|0,pb,+h[X>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);pb=+h[Y>>3];jA(Z,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);jb=+h[Z>>3];kA(_,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA($,c[ib>>2]|0,+h[_>>3],+h[_+656>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(aa,c[ib>>2]|0,+h[$>>3],+h[$+656>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(ba,c[ib>>2]|0,jb,rb,+h[$>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+656>>3],0.0);zb=+h[ba>>3];jA(ca,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);rb=+h[ca>>3];kA(ea,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+16>>3];Ab=+zd(1.0e-13,+(jb-qb));qb=Ab*+zd(1.0e-13,+(jb-pb));pb=+h[ea+664>>3];Ab=-(pb*+zd(1.0e-13,+(jb-sb)));sb=+h[ea+8>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+nwa(c[ib>>2]|0,qb,43072,57160,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+8>>3];Cb=+h[ca+16>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+zd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+nwa(c[ib>>2]|0,Eb,42768,57160,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+664>>3]-wb}wb=+h[tb>>3];if(wb>0.0){Gb=wb}else{tb=c[63880]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=57624;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&127](Db,l,42696,r);Gb=+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]}if(Gb>0.0){Hb=Gb}else{r=c[63880]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=57624;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&127](l,j,42696,q);Hb=+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]}jA(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];kA(ha,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);Hb=+h[ia>>3];jA(ja,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);Fb=+h[ja>>3];kA(ka,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3];if(zb>0.0){Ib=zb}else{la=c[63880]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=57624;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&127](ka,g,42696,p);Ib=+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]}if(Ib>0.0){Jb=Ib}else{p=c[63880]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=57624;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&127](g,f,42696,o);Jb=+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]}if(Jb>0.0){Kb=Jb}else{o=c[63880]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=57624;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&127](f,e,42696,n);Kb=+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]}qb=Kb+-273.15;lA(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];jA(na,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);qb=+h[na>>3];kA(oa,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);qb=+h[pa>>3];jA(qa,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);Eb=+h[qa>>3];kA(ra,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+8>>3];rb=+zd(1.0e-13,+(+h[qa+16>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+nwa(c[ib>>2]|0,rb,42768,57160,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(Eb- +yd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{jA(ta,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);Lb=+h[ta>>3];kA(ua,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);Lb=+h[va>>3];jA(wa,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);qb=+h[wa>>3];kA(xa,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+zd(1.0e-13,+(+h[wa+16>>3]- +h[ya>>3]));Eb=1.0- +h[wa+8>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+nwa(c[ib>>2]|0,qb,42768,57160,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{jA(za,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);Ob=+h[za>>3];kA(Aa,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);Ob=+h[Ba>>3];jA(Ca,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);Lb=+h[Ca>>3];kA(Da,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);Lb=+h[Ea>>3];jA(Fa,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);qb=+h[Fa>>3];kA(Ga,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+16>>3]- +h[Ha>>3])|0)<<24>>24==0){jA(Ia,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);qb=+h[Ia>>3];kA(Ja,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Ka,c[ib>>2]|0,+h[Ja>>3],+h[Ja+656>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(La,c[ib>>2]|0,+h[Ka>>3],+h[Ka+656>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Ma,c[ib>>2]|0,qb,Eb,+h[Ka>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+656>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+672>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}jA(Na,c[ib>>2]|0,+h[Qb>>3]);rb=+h[Na>>3];kA(Oa,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);rb=+h[Pa>>3];jA(Qa,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);Eb=+h[Qa>>3];kA(Ra,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);Eb=+h[Sa>>3];jA(Ta,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);qb=+h[Ta>>3];kA(Ua,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Va,c[ib>>2]|0,+h[Ua>>3],+h[Ua+656>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(Wa,c[ib>>2]|0,+h[Va>>3],+h[Va+656>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Xa,c[ib>>2]|0,qb,Bb,+h[Va>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+656>>3],0.0);Cb=+h[Xa>>3];jA(Ya,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);Bb=+h[Ya>>3];kA(Za,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+16>>3];vb=+zd(1.0e-13,+(qb-rb));rb=vb*+zd(1.0e-13,+(qb-Eb));Eb=+h[Za+664>>3];vb=-(Eb*+zd(1.0e-13,+(qb-Lb)));Lb=+h[Za+8>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+nwa(c[ib>>2]|0,rb,43072,57160,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+8>>3];Tb=+h[Ya+16>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+zd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+nwa(c[ib>>2]|0,Vb,42768,57160,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+664>>3]-Pb}Pb=+h[Mb>>3];Wb=Pb+-273.15;Cb=+h[Mb+656>>3];sA($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];jA(ab,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);Pb=+h[ab>>3];kA(bb,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);Pb=+h[cb>>3];jA(db,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);Wb=+h[db>>3];kA(eb,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);lA(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+nwa(c[ib>>2]|0,rb,43680,57160,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+664>>3]-ub);ub=+h[Yb+656>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+nwa(c[ib>>2]|0,Xb,43680,57160,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+656>>3];ac=+h[Yb>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+Nxa(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+8>>3];Gb=+zd(1.0e-13,+(+h[Yb+16>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+nwa(c[ib>>2]|0,Gb,42768,57160,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +zd(+(ac- +yd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+nwa(c[ib>>2]|0,ec,43680,57160,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+664>>3];ic=+h[gc+656>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+nwa(c[ib>>2]|0,fc,43680,57160,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+656>>3];kc=+h[gc>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+Nxa(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+8>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+zd(1.0e-13,+(+h[gc+16>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9552|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9552|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+nwa(c[ib>>2]|0,Nb,42768,57160,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9552|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function iP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;iA(d,c[f>>2]|0,+h[c[(c[c[g>>2]>>2]|0)+8>>2]>>3]);if((Aza(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+16>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+672>>3]*.999;l=j;m=l+9240|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;xA(e,c[f>>2]|0,+h[d>>3],+h[d+656>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+9240|0;n=m;h[n>>3]=k;i=b;return}}function jP(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1448>>3];k=+zd(1.0e-13,+(+h[g+16>>3]-j));l=+h[g+2840>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+nwa(c[b+536>>2]|0,k,43712,57168,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8440|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=Cza(1.0e-13,+h[f+16>>3]- +h[f+1448>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+1448>>3];j=+h[x+16>>3];k=+zd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+9120>>3];k=+h[x+2840>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+672>>3]- +h[x+9240>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+672>>3]- +h[x+9240>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+672>>3]- +h[x+9240>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+672>>3]- +h[x+9240>>3]}K=(y-k*J)/+nwa(c[b+536>>2]|0,l,43776,57168,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+2840>>3];C=+h[L+1448>>3];D=+h[L+16>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+9240>>3];m=+zd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+nwa(c[b+536>>2]|0,m,43712,57168,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8440|0;w=v;h[w>>3]=n;i=d;return}function kP(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(Cza(+h[a+8>>3]- +h[a+1464>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+9232|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+664>>3]- +h[a+8440>>3];g=a;j=g+9232|0;k=j;h[k>>3]=f;i=b;return}function lP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8432>>3]=+h[b+664>>3]- +h[b+9232>>3];i=i;return}function mP(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1480>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+9232>>3];o=+h[g+9120>>3]*k+ +h[g+2840>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+nwa(c[b+536>>2]|0,l,43920,57176,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+9232>>3];q=+h[v+1480>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+8432>>3]*(1.0-q)+ +h[r+1472>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+9224|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+9224|0;C=B;h[C>>3]=z;i=d;return}p=t/+nwa(c[b+536>>2]|0,l,43920,57176,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+9224|0;C=B;h[C>>3]=z;i=d;return}function nP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+9488>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+9464>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+9472>>3];h[a+8>>3]=+h[d+9264>>3];h[e+8>>3]=+h[d+9240>>3];h[f+8>>3]=+h[d+9248>>3];i=i;return}function oP(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0.0,k=0.0,l=0.0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+672>>3]=+h[b>>3];h[a+656>>3]=+h[b+8>>3];hP(f);iP(f);jP(f);kP(f);lP(f);mP(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;g=f+1512|0;j=+h[g>>3];k=+h[f>>3];l=j*k;b=f+656|0;a=f+9224|0;h[d>>3]=+h[f+9560>>3]*l*l+(+h[f+16>>3]*(j*+h[b>>3]+k*+h[a>>3])-l*+h[f+672>>3]);h[d+8>>3]=+h[f+8424>>3]+(+h[a>>3]*+h[f>>3]+(+h[g>>3]*+h[b>>3]- +h[f+9552>>3]));i=e;return}function pP(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+28304>>3];h[c[b+8>>2]>>3]=+h[d+28280>>3];h[c[b+12>>2]>>3]=+h[d+28288>>3];i=i;return}function qP(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+2016>>3]=g;k=a+416|0;l=c[k>>2]|0;Kz(f,c[a+536>>2]|0,g,+h[j+2408>>3],+h[j+2416>>3],+h[j+2304>>3],+h[j+2312>>3],+h[j+10464>>3],+h[j+9832>>3],+h[l+2280>>3]*10.0,(+h[l+1096>>3]+ +h[l+1104>>3])*.5,+h[l+2272>>3]/6.0,+h[l+2240>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+144>>3]- +h[f>>3]*+h[(c[k>>2]|0)+2216>>3];i=e;return}function _residualFunc1187$0(b){b=b|0;var d=0,e=0,f=0.0,j=0.0,k=0,l=0,m=0.0,n=0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,L=0,M=0.0,N=0.0,O=0,P=0,Q=0.0,R=0,S=0,T=0.0,U=0,V=0,W=0.0,X=0,Y=0,Z=0.0,_=0,$=0,aa=0.0,ba=0,ca=0,da=0,ea=0.0,fa=0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0.0,la=0,ma=0,na=0.0,oa=0,pa=0.0,qa=0.0,ra=0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0.0,ya=0.0,za=0,Aa=0.0,Ba=0,Ca=0,Da=0.0,Ea=0,Fa=0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0,Ka=0,La=0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0.0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0.0,fb=0.0,gb=0,hb=0,ib=0,jb=0.0,kb=0.0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0.0,sb=0,tb=0,ub=0,vb=0.0,wb=0,xb=0,yb=0,zb=0.0,Ab=0,Bb=0,Cb=0,Db=0.0,Eb=0,Fb=0,Gb=0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0,Lb=0,Mb=0,Nb=0.0,Ob=0.0,Pb=0,Qb=0,Rb=0,Sb=0.0,Tb=0,Ub=0,Vb=0,Wb=0.0,Xb=0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0.0,dc=0.0,ec=0,fc=0,gc=0,hc=0.0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0.0,tc=0,uc=0,vc=0,wc=0.0,xc=0,yc=0,zc=0,Ac=0.0,Bc=0,Cc=0,Dc=0,Ec=0.0,Fc=0.0,Gc=0,Hc=0,Ic=0,Jc=0.0,Kc=0.0,Lc=0,Mc=0,Nc=0,Oc=0.0,Pc=0,Qc=0,Rc=0,Sc=0.0,Tc=0.0,Uc=0.0,Vc=0.0,Wc=0,Xc=0,Yc=0,Zc=0.0,_c=0.0,$c=0.0,ad=0.0,bd=0.0,cd=0.0,dd=0,ed=0,fd=0,gd=0.0,hd=0.0,id=0.0,jd=0.0,kd=0.0,ld=0,md=0,nd=0;d=c[b+224>>2]|0;e=c[b+240>>2]|0;f=+g[b+664>>2];j=+g[b+680>>2];k=c[b+688>>2]|0;l=c[b+696>>2]|0;m=+g[b+704>>2];n=c[b+712>>2]|0;o=+g[b+720>>2];p=+g[b+728>>2];q=+g[b+736>>2];a:do{do{if(p!=0.0){r=l;s=n;t=q/p}else{if(q==0.0){r=l;s=n;t=q;break}u=q/+nwa(c[(d+536|0)>>2]|0,p,57128,57024,+h[k>>3],(a[d+319|0]|0)!=0|0);r=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;s=c[(d+416|0)>>2]|0;t=u}}while(0);h[e+184>>3]=m+((f+-1.0)*o*t-f*j*+h[s+2216>>3]);h[e+192>>3]=+h[r+2584>>3]- +h[r+1424>>3]*+h[s+1032>>3]*+h[s+2112>>3]*((+h[r+10672>>3]- +h[r+40>>3])/1.5+(+h[r+2024>>3]*.5+(+h[r+2032>>3]+ +h[s+1352>>3]*+h[r+1528>>3]*-10.0)));u=+h[(d+304|0)>>3];Kz(b+88|0,c[(d+536|0)>>2]|0,+h[r+2008>>3],+h[r+2400>>3],+h[r+2408>>3],+h[r+2296>>3],+h[r+2304>>3],+h[r+10456>>3],+h[r+9840>>3],+h[s+2280>>3]*10.0,(+h[s+1088>>3]+ +h[s+1096>>3])*.5,+h[s+2272>>3]/6.0,+h[s+2240>>3]);v=+h[(b+88|0)>>3];w=c[c[(d+4|0)>>2]>>2]|0;x=c[w+8>>2]|0;y=+h[x+136>>3];z=c[(d+416|0)>>2]|0;A=+h[x+2008>>3]+ +h[z+2280>>3]*+h[z+2296>>3]*-10.0;B=+h[z+2248>>3];C=+h[z+2256>>3];do{if(B!=0.0){D=x;E=z;F=C/B}else{if(C==0.0){D=x;E=z;F=C;break}G=C/+nwa(c[(d+536|0)>>2]|0,B,57128,57024,+h[w>>3],(a[d+319|0]|0)!=0|0);D=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;E=c[(d+416|0)>>2]|0;F=G}}while(0);h[e+200>>3]=y+((u+-1.0)*A*F-u*v*+h[E+2216>>3]);B=+h[(d+304|0)>>3];Kz(b+96|0,c[(d+536|0)>>2]|0,+h[D+2024>>3],+h[D+2416>>3],+h[D+2424>>3],+h[D+2312>>3],+h[D+2320>>3],+h[D+10472>>3],+h[D+9824>>3],+h[E+2280>>3]*10.0,(+h[E+1104>>3]+ +h[E+1112>>3])*.5,+h[E+2272>>3]/6.0,+h[E+2240>>3]);C=+h[(b+96|0)>>3];w=c[c[(d+4|0)>>2]>>2]|0;z=c[w+8>>2]|0;G=+h[z+152>>3];x=c[(d+416|0)>>2]|0;H=+h[z+2024>>3]+ +h[x+2280>>3]*+h[x+2296>>3]*-10.0;I=+h[x+2248>>3];J=+h[x+2256>>3];do{if(I!=0.0){K=z;L=x;M=J/I}else{if(J==0.0){K=z;L=x;M=J;break}N=J/+nwa(c[(d+536|0)>>2]|0,I,57128,57024,+h[w>>3],(a[d+319|0]|0)!=0|0);K=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;L=c[(d+416|0)>>2]|0;M=N}}while(0);h[e+208>>3]=G+((B+-1.0)*H*M-B*C*+h[L+2216>>3]);I=+h[(d+304|0)>>3];Kz(b+104|0,c[(d+536|0)>>2]|0,+h[K+3568>>3],+h[K+3960>>3],+h[K+3968>>3],+h[K+3856>>3],+h[K+3864>>3],+h[K+10328>>3],+h[K+9864>>3],+h[L+2056>>3]*5.0,(+h[L+800>>3]+ +h[L+808>>3])*.5,+h[L+2048>>3]/6.0,+h[L+2016>>3]);J=+h[(b+104|0)>>3];w=c[c[(d+4|0)>>2]>>2]|0;x=c[w+8>>2]|0;v=+h[x+312>>3];z=c[(d+416|0)>>2]|0;u=+h[x+3568>>3]+ +h[z+2056>>3]*+h[z+2072>>3]*-5.0;A=+h[z+2024>>3];y=+h[z+2032>>3];do{if(A!=0.0){O=x;P=z;Q=y/A}else{if(y==0.0){O=x;P=z;Q=y;break}N=y/+nwa(c[(d+536|0)>>2]|0,A,57096,57024,+h[w>>3],(a[d+319|0]|0)!=0|0);O=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;P=c[(d+416|0)>>2]|0;Q=N}}while(0);h[e+216>>3]=v+((I+-1.0)*u*Q-I*J*+h[P+1992>>3]);A=+h[(d+304|0)>>3];Kz(b+112|0,c[(d+536|0)>>2]|0,+h[O+5576>>3],+h[O+5840>>3],+h[O+5848>>3],+h[O+5768>>3],+h[O+5776>>3],+h[O+10224>>3],+h[O+9912>>3],+h[P+1824>>3]*7.5,(+h[P+512>>3]+ +h[P+520>>3])*.5,+h[P+1816>>3]*.25,+h[P+1784>>3]);y=+h[(b+112|0)>>3];w=c[c[(d+4|0)>>2]>>2]|0;z=c[w+8>>2]|0;C=+h[z+480>>3];x=c[(d+416|0)>>2]|0;B=+h[z+5576>>3]+ +h[x+1824>>3]*+h[x+1840>>3]*-7.5;H=+h[x+1792>>3];G=+h[x+1800>>3];do{if(H!=0.0){R=z;S=x;T=G/H}else{if(G==0.0){R=z;S=x;T=G;break}N=G/+nwa(c[(d+536|0)>>2]|0,H,57032,57024,+h[w>>3],(a[d+319|0]|0)!=0|0);R=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;S=c[(d+416|0)>>2]|0;T=N}}while(0);h[e+224>>3]=C+((A+-1.0)*B*T-A*y*+h[S+1760>>3]);h[e+232>>3]=+h[R+6040>>3]- +h[R+4544>>3]*+h[R+10192>>3]*(+h[R+1312>>3]- +h[R+4504>>3])*+h[S+1864>>3];H=+h[R+480>>3];h[e+240>>3]=+h[R+5936>>3]-H*+h[(!(H>=0.0)?R+344|0:R+368|0)>>3];KA(b+120|0,c[(d+536|0)>>2]|0,+h[R+4688>>3],+h[R+4648>>3],+h[R+4928>>3]+-6150.0,3850.0);w=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;h[e+248>>3]=+h[w+4848>>3]- +h[(b+120|0)>>3];x=c[(d+416|0)>>2]|0;h[e+256>>3]=+h[w+6032>>3]- +h[w+4536>>3]*+h[w+10184>>3]*(+h[w+1320>>3]- +h[w+4496>>3])*+h[x+1864>>3];H=+h[(d+304|0)>>3];G=+h[x+1080>>3];Kz(b+128|0,c[(d+536|0)>>2]|0,+h[w+1992>>3],+h[w+2384>>3],+h[w+2392>>3],+h[w+2280>>3],+h[w+2288>>3],+h[w+10440>>3],+h[x+1040>>3],+h[x+2280>>3]*5.0,(G+G)*.5,+h[x+2272>>3]/6.0,+h[x+2240>>3]);G=+h[(b+128|0)>>3];x=c[c[(d+4|0)>>2]>>2]|0;w=c[x+8>>2]|0;J=+h[w+120>>3];z=c[(d+416|0)>>2]|0;I=+h[w+1992>>3]+ +h[z+2280>>3]*+h[z+2296>>3]*-5.0;u=+h[z+2248>>3];v=+h[z+2256>>3];do{if(u!=0.0){U=w;V=z;W=v/u}else{if(v==0.0){U=w;V=z;W=v;break}N=v/+nwa(c[(d+536|0)>>2]|0,u,57128,57024,+h[x>>3],(a[d+319|0]|0)!=0|0);U=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;V=c[(d+416|0)>>2]|0;W=N}}while(0);h[e+264>>3]=J+((H+-1.0)*I*W-H*G*+h[V+2216>>3]);KA(b+136|0,c[(d+536|0)>>2]|0,+h[U+4696>>3],+h[U+4656>>3],+h[U+4936>>3]+-6150.0,3850.0);x=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;h[e+272>>3]=+h[x+4856>>3]- +h[(b+136|0)>>3];u=+h[(d+304|0)>>3];z=c[(d+416|0)>>2]|0;Kz(b+144|0,c[(d+536|0)>>2]|0,+h[x+5560>>3],+h[x+5824>>3],+h[x+5832>>3],+h[x+5752>>3],+h[x+5760>>3],+h[x+10208>>3],+h[x+9896>>3],+h[z+1824>>3]*5.0,(+h[z+496>>3]+ +h[z+504>>3])*.5,+h[z+1816>>3]*.25,+h[z+1784>>3]);v=+h[(b+144|0)>>3];z=c[c[(d+4|0)>>2]>>2]|0;x=c[z+8>>2]|0;y=+h[x+464>>3];w=c[(d+416|0)>>2]|0;A=+h[x+5560>>3]+ +h[w+1824>>3]*+h[w+1840>>3]*-5.0;B=+h[w+1792>>3];C=+h[w+1800>>3];do{if(B!=0.0){X=x;Y=w;Z=C/B}else{if(C==0.0){X=x;Y=w;Z=C;break}N=C/+nwa(c[(d+536|0)>>2]|0,B,57032,57024,+h[z>>3],(a[d+319|0]|0)!=0|0);X=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;Y=c[(d+416|0)>>2]|0;Z=N}}while(0);h[e+280>>3]=y+((u+-1.0)*A*Z-u*v*+h[Y+1760>>3]);KA(b+152|0,c[(d+536|0)>>2]|0,+h[X+4680>>3],+h[X+4640>>3],+h[X+4920>>3]+-6150.0,3850.0);z=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;h[e+288>>3]=+h[z+4840>>3]- +h[(b+152|0)>>3];KA(b+160|0,c[(d+536|0)>>2]|0,+h[z+4672>>3],+h[z+4632>>3],+h[z+4912>>3]+-6150.0,3850.0);z=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;h[e+296>>3]=+h[z+4832>>3]- +h[(b+160|0)>>3];KA(b+168|0,c[(d+536|0)>>2]|0,+h[z+4704>>3],+h[z+4664>>3],+h[z+4944>>3]+-6150.0,3850.0);z=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;h[e+304>>3]=+h[z+4864>>3]- +h[(b+168|0)>>3];w=c[(d+416|0)>>2]|0;h[e+312>>3]=+h[z+7448>>3]- +h[z+6400>>3]*+h[w+112>>3]*+h[w+1432>>3]*(+h[z+576>>3]/1.5+(+h[z+7e3>>3]+(+h[(z+7008|0)>>3]*.5+ +h[w+1352>>3]*+h[z+6984>>3]*-10.0))+-1.0e5);B=+h[(d+304|0)>>3];Kz(b+176|0,c[(d+536|0)>>2]|0,+h[(z+7008|0)>>3],+h[z+9576>>3],+h[z+9584>>3],+h[z+9632>>3],+h[z+9640>>3],+h[z+10016>>3],+h[z+9952>>3],+h[w+1600>>3]*10.0,(+h[w+192>>3]+ +h[w+200>>3])*.5,+h[w+1592>>3]/6.0,+h[w+1560>>3]);C=+h[(b+176|0)>>3];w=c[c[(d+4|0)>>2]>>2]|0;z=c[w+8>>2]|0;G=+h[z+616>>3];x=c[(d+416|0)>>2]|0;H=+h[z+7008>>3]+ +h[x+1600>>3]*+h[x+1616>>3]*-10.0;I=+h[x+1568>>3];J=+h[x+1576>>3];do{if(I!=0.0){_=z;$=x;aa=J/I}else{if(J==0.0){_=z;$=x;aa=J;break}N=J/+nwa(c[(d+536|0)>>2]|0,I,57064,57024,+h[w>>3],(a[d+319|0]|0)!=0|0);_=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;$=c[(d+416|0)>>2]|0;aa=N}}while(0);h[e+320>>3]=G+((B+-1.0)*H*aa-B*C*+h[$+1536>>3]);I=+h[_+616>>3];h[e+328>>3]=+h[_+7408>>3]-I*+h[(!(I>=0.0)?_+568|0:_+592|0)>>3];I=+h[(d+304|0)>>3];J=+h[$+192>>3];Kz(b+184|0,c[(d+536|0)>>2]|0,+h[_+7e3>>3],+h[_+9568>>3],+h[_+9576>>3],+h[_+9624>>3],+h[_+9632>>3],+h[_+10008>>3],+h[$+152>>3],+h[$+1600>>3]*5.0,(J+J)*.5,+h[$+1592>>3]/6.0,+h[$+1560>>3]);J=+h[(b+184|0)>>3];w=c[c[(d+4|0)>>2]>>2]|0;x=c[w+8>>2]|0;v=+h[x+608>>3];z=c[(d+416|0)>>2]|0;u=+h[x+7e3>>3]+ +h[z+1600>>3]*+h[z+1616>>3]*-5.0;A=+h[z+1568>>3];y=+h[z+1576>>3];do{if(A!=0.0){ba=x;ca=w;da=z;ea=y/A}else{if(y==0.0){ba=x;ca=w;da=z;ea=y;break}N=y/+nwa(c[(d+536|0)>>2]|0,A,57064,57024,+h[w>>3],(a[d+319|0]|0)!=0|0);fa=c[c[(d+4|0)>>2]>>2]|0;ba=c[fa+8>>2]|0;ca=fa;da=c[(d+416|0)>>2]|0;ea=N}}while(0);h[e+336>>3]=v+((I+-1.0)*u*ea-I*J*+h[da+1536>>3]);A=+h[ba+608>>3];if(!(A>=0.0)){ga=+h[ba+592>>3]}else{ga=.01}h[e+344>>3]=+h[ba+7400>>3]-A*ga;h[e+352>>3]=+h[ba+7464>>3]- +h[ba+6416>>3]*+h[da+128>>3]*+h[da+1432>>3]*(+h[ba+528>>3]*.5+(+h[ba+576>>3]*-.5+((+h[ba+7016>>3]+ +h[ba+7024>>3])*.5+ +h[da+1352>>3]*+h[ba+6760>>3]*-10.0)));A=+h[ba+5952>>3];if(!(A>=0.0)){y=+zd(+(+h[ba+328>>3]),1.0e-15);C=+zd(+-+h[ba+120>>3],1.0e-15);B=y*+h[ba+176>>3]+C*+h[ba+104>>3];do{if(y+C!=0.0){ha=A;ia=ba;ja=ca;ka=B/(y+C)}else{if(B==0.0){ha=A;ia=ba;ja=ca;ka=B;break}H=B/+nwa(c[(d+536|0)>>2]|0,y+C,52240,57024,+h[ca>>3],(a[d+319|0]|0)!=0|0);w=c[c[(d+4|0)>>2]>>2]|0;z=c[w+8>>2]|0;ha=+h[z+5952>>3];ia=z;ja=w;ka=H}}while(0);la=ia;ma=ja;na=ka*ha}else{la=ba;ma=ca;na=A*+h[ba+344>>3]}h[e+360>>3]=+h[la+5944>>3]-na;C=+h[la+5960>>3];if(!(C>=0.0)){oa=la;pa=C*+h[la+440>>3]}else{y=+zd(+(+h[la+648>>3]),1.0e-15);B=+zd(+-+h[la+288>>3],1.0e-15);J=y*+h[la+496>>3]+B*+h[la+272>>3];do{if(y+B!=0.0){qa=C;ra=la;sa=J/(y+B)}else{if(J==0.0){qa=C;ra=la;sa=J;break}I=J/+nwa(c[(d+536|0)>>2]|0,y+B,56280,57024,+h[ma>>3],(a[d+319|0]|0)!=0|0);w=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;qa=+h[w+5960>>3];ra=w;sa=I}}while(0);oa=ra;pa=sa*qa}h[e+368>>3]=+h[oa+5904>>3]-pa;B=+h[(d+304|0)>>3];w=c[(d+416|0)>>2]|0;Kz(b+192|0,c[(d+536|0)>>2]|0,+h[oa+5568>>3],+h[oa+5832>>3],+h[oa+5840>>3],+h[oa+5760>>3],+h[oa+5768>>3],+h[oa+10216>>3],+h[oa+9904>>3],+h[w+1824>>3]*5.0,(+h[w+504>>3]+ +h[w+512>>3])*.5,+h[w+1816>>3]*.25,+h[w+1784>>3]);y=+h[(b+192|0)>>3];w=c[c[(d+4|0)>>2]>>2]|0;z=c[w+8>>2]|0;J=+h[z+472>>3];x=c[(d+416|0)>>2]|0;C=+h[z+5568>>3]+ +h[x+1824>>3]*+h[x+1840>>3]*-5.0;A=+h[x+1792>>3];I=+h[x+1800>>3];do{if(A!=0.0){ta=z;ua=x;va=I/A}else{if(I==0.0){ta=z;ua=x;va=I;break}u=I/+nwa(c[(d+536|0)>>2]|0,A,57032,57024,+h[w>>3],(a[d+319|0]|0)!=0|0);ta=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;ua=c[(d+416|0)>>2]|0;va=u}}while(0);h[e+376>>3]=J+((B+-1.0)*C*va-B*y*+h[ua+1760>>3]);A=+h[ta+472>>3];h[e+384>>3]=+h[ta+5928>>3]-A*+h[(!(A>=0.0)?ta+368|0:ta+392|0)>>3];h[e+392>>3]=+h[ta+6024>>3]- +h[ta+4528>>3]*+h[ta+10176>>3]*(+h[ta+1328>>3]- +h[ta+4488>>3])*+h[ua+1864>>3];h[e+400>>3]=+h[ta+2568>>3]- +h[ta+1408>>3]*+h[ua+1016>>3]*+h[ua+2112>>3]*(+h[ta+40>>3]*.5+(+h[ta+88>>3]*-.5+((+h[ta+2008>>3]+ +h[ta+2016>>3])*.5+ +h[ua+1352>>3]*+h[ta+1752>>3]*-10.0)));h[e+408>>3]=+h[ta+4216>>3]+(+h[ta+4096>>3]- +h[ta+4088>>3]);A=+h[ta+640>>3];h[e+416>>3]=+h[ta+7432>>3]-A*+h[(!(A>=0.0)?ta+496|0:ta+520|0)>>3];w=c[c[(d+4|0)>>2]>>2]|0;x=c[w+8>>2]|0;A=+h[x+288>>3];if(!(A>=0.0)){wa=x;xa=A*+h[x+272>>3]}else{I=+zd(+(+h[x+648>>3]),1.0e-15);u=+zd(+-+h[x+5960>>3],1.0e-15);v=I*+h[x+496>>3]+u*+h[x+440>>3];do{if(I+u!=0.0){ya=A;za=x;Aa=v/(I+u)}else{if(v==0.0){ya=A;za=x;Aa=v;break}H=v/+nwa(c[(d+536|0)>>2]|0,I+u,54984,57024,+h[w>>3],(a[d+319|0]|0)!=0|0);z=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;ya=+h[z+288>>3];za=z;Aa=H}}while(0);wa=za;xa=Aa*ya}h[e+424>>3]=+h[wa+4056>>3]-xa;w=c[(d+416|0)>>2]|0;h[e+432>>3]=+h[wa+4104>>3]- +h[wa+2944>>3]*+h[w+704>>3]*+h[w+1888>>3]*((+h[wa+256>>3]- +h[wa+448>>3])/1.5+(+h[wa+3544>>3]+(+h[wa+3552>>3]*.5+ +h[(w+1352|0)>>3]*+h[wa+3528>>3]*-5.0)));x=wa+552|0;h[e+440>>3]=+h[wa+7456>>3]- +h[wa+6408>>3]*+h[w+120>>3]*+h[(w+1432|0)>>3]*(+h[x>>3]*.5+(+h[wa+600>>3]*-.5+((+h[wa+7008>>3]+ +h[wa+7016>>3])*.5+ +h[(w+1352|0)>>3]*+h[wa+6872>>3]*-10.0)));h[e+448>>3]=+h[wa+7472>>3]- +h[wa+6424>>3]*+h[w+136>>3]*+h[(w+1432|0)>>3]*(+h[wa+504>>3]*.5+(+h[x>>3]*-.5+((+h[wa+7024>>3]+ +h[wa+7032>>3])*.5+ +h[(w+1352|0)>>3]*+h[wa+6648>>3]*-10.0)));u=+h[(d+304|0)>>3];w=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;x=c[(d+416|0)>>2]|0;Kz(b+200|0,c[(d+536|0)>>2]|0,+h[w+7016>>3],+h[w+9584>>3],+h[w+9592>>3],+h[w+9640>>3],+h[w+9648>>3],+h[w+10024>>3],+h[w+9944>>3],+h[x+1600>>3]*10.0,(+h[x+200>>3]+ +h[x+208>>3])*.5,+h[x+1592>>3]/6.0,+h[x+1560>>3]);I=+h[(b+200|0)>>3];x=c[c[(d+4|0)>>2]>>2]|0;w=c[x+8>>2]|0;v=+h[w+624>>3];z=c[(d+416|0)>>2]|0;A=+h[w+7016>>3]+ +h[z+1600>>3]*+h[z+1616>>3]*-10.0;y=+h[z+1568>>3];B=+h[z+1576>>3];do{if(y!=0.0){Ba=w;Ca=z;Da=B/y}else{if(B==0.0){Ba=w;Ca=z;Da=B;break}C=B/+nwa(c[(d+536|0)>>2]|0,y,57064,57024,+h[x>>3],(a[d+319|0]|0)!=0|0);Ba=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;Ca=c[(d+416|0)>>2]|0;Da=C}}while(0);h[e+456>>3]=v+((u+-1.0)*A*Da-u*I*+h[Ca+1536>>3]);y=+h[Ba+296>>3];x=Ba+248|0;h[e+464>>3]=+h[Ba+4064>>3]-y*+h[(!(y>=0.0)?x:Ba+272|0)>>3];y=+h[Ba+304>>3];h[e+472>>3]=+h[Ba+4072>>3]-y*+h[(!(y>=0.0)?Ba+224|0:x)>>3];y=+h[Ba+128>>3];h[e+480>>3]=+h[Ba+2512>>3]-y*+h[(!(y>=0.0)?Ba+80|0:Ba+104|0)>>3];y=+h[Ba+152>>3];x=Ba+32|0;h[e+488>>3]=+h[Ba+2536>>3]-y*+h[(!(y>=0.0)?Ba+8|0:x)>>3];y=+h[Ba+144>>3];h[e+496>>3]=+h[Ba+2528>>3]-y*+h[(!(y>=0.0)?x:Ba+56|0)>>3];y=+h[(d+304|0)>>3];Kz(b+208|0,c[(d+536|0)>>2]|0,+h[Ba+2016>>3],+h[Ba+2408>>3],+h[Ba+2416>>3],+h[Ba+2304>>3],+h[Ba+2312>>3],+h[Ba+10464>>3],+h[Ba+9832>>3],+h[Ca+2280>>3]*10.0,(+h[Ca+1096>>3]+ +h[Ca+1104>>3])*.5,+h[Ca+2272>>3]/6.0,+h[Ca+2240>>3]);B=+h[(b+208|0)>>3];x=c[c[(d+4|0)>>2]>>2]|0;z=c[x+8>>2]|0;C=+h[z+144>>3];w=c[(d+416|0)>>2]|0;J=+h[z+2016>>3]+ +h[w+2280>>3]*+h[w+2296>>3]*-10.0;H=+h[w+2248>>3];G=+h[w+2256>>3];if(H!=0.0){Ea=z;Fa=w;Ga=G/H;Ha=J*Ga;Ia=(y+-1.0)*Ha;Ja=Fa;Ka=Ja+2216|0;La=Ka;Ma=+h[La>>3];Na=B*Ma;Oa=y*Na;Pa=Ia-Oa;Qa=C+Pa;Ra=e;Sa=Ra+504|0;Ta=Sa;h[Ta>>3]=Qa;Ua=Ea;Va=Ua+312|0;Wa=Va;Xa=+h[Wa>>3];Ya=!(Xa>=0.0);Za=Ea;_a=Za+224|0;$a=_a;ab=Ea;bb=ab+200|0;cb=bb;db=Ya?cb:$a;eb=+h[db>>3];fb=Xa*eb;gb=Ea;hb=gb+4080|0;ib=hb;jb=+h[ib>>3];kb=jb-fb;lb=e;mb=lb+512|0;nb=mb;h[nb>>3]=kb;ob=Ea;pb=ob+7480|0;qb=pb;rb=+h[qb>>3];sb=Ea;tb=sb+6432|0;ub=tb;vb=+h[ub>>3];wb=Fa;xb=wb+144|0;yb=xb;zb=+h[yb>>3];Ab=Ea;Bb=Ab+448|0;Cb=Bb;Db=+h[Cb>>3];Eb=Ea;Fb=Eb+528|0;Gb=Fb;Hb=+h[Gb>>3];Ib=Db-Hb;Jb=Ib/1.5;Kb=Ea;Lb=Kb+7032|0;Mb=Lb;Nb=+h[Mb>>3];Ob=Nb*.5;Pb=Ea;Qb=Pb+7040|0;Rb=Qb;Sb=+h[Rb>>3];Tb=Fa;Ub=Tb+1352|0;Vb=Ub;Wb=+h[Vb>>3];Xb=Ea;Yb=Xb+6536|0;Zb=Yb;_b=+h[Zb>>3];$b=Wb*_b;ac=$b*-10.0;bc=Sb+ac;cc=Ob+bc;dc=Jb+cc;ec=Fa;fc=ec+1432|0;gc=fc;hc=+h[gc>>3];ic=hc*dc;jc=zb*ic;kc=vb*jc;lc=rb-kc;mc=e;nc=mc+520|0;oc=nc;h[oc>>3]=lc;pc=Ea;qc=pc+2560|0;rc=qc;sc=+h[rc>>3];tc=Ea;uc=tc+1400|0;vc=uc;wc=+h[vc>>3];xc=Fa;yc=xc+1008|0;zc=yc;Ac=+h[zc>>3];Bc=Ea;Cc=Bc+64|0;Dc=Cc;Ec=+h[Dc>>3];Fc=Ec*.5;Gc=Ea;Hc=Gc+112|0;Ic=Hc;Jc=+h[Ic>>3];Kc=Jc*-.5;Lc=Ea;Mc=Lc+2e3|0;Nc=Mc;Oc=+h[Nc>>3];Pc=Ea;Qc=Pc+2008|0;Rc=Qc;Sc=+h[Rc>>3];Tc=Oc+Sc;Uc=Tc*.5;Vc=+h[Vb>>3];Wc=Ea;Xc=Wc+1864|0;Yc=Xc;Zc=+h[Yc>>3];_c=Vc*Zc;$c=_c*-10.0;ad=Uc+$c;bd=Kc+ad;cd=Fc+bd;dd=Fa;ed=dd+2112|0;fd=ed;gd=+h[fd>>3];hd=gd*cd;id=Ac*hd;jd=wc*id;kd=sc-jd;ld=e;md=ld+528|0;nd=md;h[nd>>3]=kd;i=b;c[b+4408>>2]=5;break a}if(G==0.0){Ea=z;Fa=w;Ga=G;Ha=J*Ga;Ia=(y+-1.0)*Ha;Ja=Fa;Ka=Ja+2216|0;La=Ka;Ma=+h[La>>3];Na=B*Ma;Oa=y*Na;Pa=Ia-Oa;Qa=C+Pa;Ra=e;Sa=Ra+504|0;Ta=Sa;h[Ta>>3]=Qa;Ua=Ea;Va=Ua+312|0;Wa=Va;Xa=+h[Wa>>3];Ya=!(Xa>=0.0);Za=Ea;_a=Za+224|0;$a=_a;ab=Ea;bb=ab+200|0;cb=bb;db=Ya?cb:$a;eb=+h[db>>3];fb=Xa*eb;gb=Ea;hb=gb+4080|0;ib=hb;jb=+h[ib>>3];kb=jb-fb;lb=e;mb=lb+512|0;nb=mb;h[nb>>3]=kb;ob=Ea;pb=ob+7480|0;qb=pb;rb=+h[qb>>3];sb=Ea;tb=sb+6432|0;ub=tb;vb=+h[ub>>3];wb=Fa;xb=wb+144|0;yb=xb;zb=+h[yb>>3];Ab=Ea;Bb=Ab+448|0;Cb=Bb;Db=+h[Cb>>3];Eb=Ea;Fb=Eb+528|0;Gb=Fb;Hb=+h[Gb>>3];Ib=Db-Hb;Jb=Ib/1.5;Kb=Ea;Lb=Kb+7032|0;Mb=Lb;Nb=+h[Mb>>3];Ob=Nb*.5;Pb=Ea;Qb=Pb+7040|0;Rb=Qb;Sb=+h[Rb>>3];Tb=Fa;Ub=Tb+1352|0;Vb=Ub;Wb=+h[Vb>>3];Xb=Ea;Yb=Xb+6536|0;Zb=Yb;_b=+h[Zb>>3];$b=Wb*_b;ac=$b*-10.0;bc=Sb+ac;cc=Ob+bc;dc=Jb+cc;ec=Fa;fc=ec+1432|0;gc=fc;hc=+h[gc>>3];ic=hc*dc;jc=zb*ic;kc=vb*jc;lc=rb-kc;mc=e;nc=mc+520|0;oc=nc;h[oc>>3]=lc;pc=Ea;qc=pc+2560|0;rc=qc;sc=+h[rc>>3];tc=Ea;uc=tc+1400|0;vc=uc;wc=+h[vc>>3];xc=Fa;yc=xc+1008|0;zc=yc;Ac=+h[zc>>3];Bc=Ea;Cc=Bc+64|0;Dc=Cc;Ec=+h[Dc>>3];Fc=Ec*.5;Gc=Ea;Hc=Gc+112|0;Ic=Hc;Jc=+h[Ic>>3];Kc=Jc*-.5;Lc=Ea;Mc=Lc+2e3|0;Nc=Mc;Oc=+h[Nc>>3];Pc=Ea;Qc=Pc+2008|0;Rc=Qc;Sc=+h[Rc>>3];Tc=Oc+Sc;Uc=Tc*.5;Vc=+h[Vb>>3];Wc=Ea;Xc=Wc+1864|0;Yc=Xc;Zc=+h[Yc>>3];_c=Vc*Zc;$c=_c*-10.0;ad=Uc+$c;bd=Kc+ad;cd=Fc+bd;dd=Fa;ed=dd+2112|0;fd=ed;gd=+h[fd>>3];hd=gd*cd;id=Ac*hd;jd=wc*id;kd=sc-jd;ld=e;md=ld+528|0;nd=md;h[nd>>3]=kd;i=b;c[b+4408>>2]=5;break a}N=G/+nwa(c[(d+536|0)>>2]|0,H,57128,57024,+h[x>>3],(a[d+319|0]|0)!=0|0);Ea=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;Fa=c[(d+416|0)>>2]|0;Ga=N;Ha=J*Ga;Ia=(y+-1.0)*Ha;Ja=Fa;Ka=Ja+2216|0;La=Ka;Ma=+h[La>>3];Na=B*Ma;Oa=y*Na;Pa=Ia-Oa;Qa=C+Pa;Ra=e;Sa=Ra+504|0;Ta=Sa;h[Ta>>3]=Qa;Ua=Ea;Va=Ua+312|0;Wa=Va;Xa=+h[Wa>>3];Ya=!(Xa>=0.0);Za=Ea;_a=Za+224|0;$a=_a;ab=Ea;bb=ab+200|0;cb=bb;db=Ya?cb:$a;eb=+h[db>>3];fb=Xa*eb;gb=Ea;hb=gb+4080|0;ib=hb;jb=+h[ib>>3];kb=jb-fb;lb=e;mb=lb+512|0;nb=mb;h[nb>>3]=kb;ob=Ea;pb=ob+7480|0;qb=pb;rb=+h[qb>>3];sb=Ea;tb=sb+6432|0;ub=tb;vb=+h[ub>>3];wb=Fa;xb=wb+144|0;yb=xb;zb=+h[yb>>3];Ab=Ea;Bb=Ab+448|0;Cb=Bb;Db=+h[Cb>>3];Eb=Ea;Fb=Eb+528|0;Gb=Fb;Hb=+h[Gb>>3];Ib=Db-Hb;Jb=Ib/1.5;Kb=Ea;Lb=Kb+7032|0;Mb=Lb;Nb=+h[Mb>>3];Ob=Nb*.5;Pb=Ea;Qb=Pb+7040|0;Rb=Qb;Sb=+h[Rb>>3];Tb=Fa;Ub=Tb+1352|0;Vb=Ub;Wb=+h[Vb>>3];Xb=Ea;Yb=Xb+6536|0;Zb=Yb;_b=+h[Zb>>3];$b=Wb*_b;ac=$b*-10.0;bc=Sb+ac;cc=Ob+bc;dc=Jb+cc;ec=Fa;fc=ec+1432|0;gc=fc;hc=+h[gc>>3];ic=hc*dc;jc=zb*ic;kc=vb*jc;lc=rb-kc;mc=e;nc=mc+520|0;oc=nc;h[oc>>3]=lc;pc=Ea;qc=pc+2560|0;rc=qc;sc=+h[rc>>3];tc=Ea;uc=tc+1400|0;vc=uc;wc=+h[vc>>3];xc=Fa;yc=xc+1008|0;zc=yc;Ac=+h[zc>>3];Bc=Ea;Cc=Bc+64|0;Dc=Cc;Ec=+h[Dc>>3];Fc=Ec*.5;Gc=Ea;Hc=Gc+112|0;Ic=Hc;Jc=+h[Ic>>3];Kc=Jc*-.5;Lc=Ea;Mc=Lc+2e3|0;Nc=Mc;Oc=+h[Nc>>3];Pc=Ea;Qc=Pc+2008|0;Rc=Qc;Sc=+h[Rc>>3];Tc=Oc+Sc;Uc=Tc*.5;Vc=+h[Vb>>3];Wc=Ea;Xc=Wc+1864|0;Yc=Xc;Zc=+h[Yc>>3];_c=Vc*Zc;$c=_c*-10.0;ad=Uc+$c;bd=Kc+ad;cd=Fc+bd;dd=Fa;ed=dd+2112|0;fd=ed;gd=+h[fd>>3];hd=gd*cd;id=Ac*hd;jd=wc*id;kd=sc-jd;ld=e;md=ld+528|0;nd=md;h[nd>>3]=kd;i=b;c[b+4408>>2]=5;break a}while(0)}



function nC(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[63880]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=57624;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&127](mb,m,29304,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]}jA(t,c[ib>>2]|0,jb);jb=+h[t>>3];kA(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);jb=+h[v>>3];jA(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);pb=+h[w>>3];kA(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+272>>3];qb=+zd(1.0e-13,+(+h[w+280>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+nwa(c[ib>>2]|0,qb,29376,29296,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(pb- +yd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{jA(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);sb=+h[z>>3];kA(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);sb=+h[B>>3];jA(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);jb=+h[C>>3];kA(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+zd(1.0e-13,+(+h[C+280>>3]- +h[E>>3]));pb=1.0- +h[C+272>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+nwa(c[ib>>2]|0,jb,29376,29296,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{jA(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);vb=+h[F>>3];kA(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);vb=+h[H>>3];jA(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);sb=+h[I>>3];kA(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);sb=+h[K>>3];jA(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);jb=+h[L>>3];kA(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+280>>3]- +h[N>>3])|0)<<24>>24==0){jA(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);jb=+h[O>>3];kA(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Q,c[ib>>2]|0,+h[P+264>>3],+h[P+920>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(R,c[ib>>2]|0,+h[Q+264>>3],+h[Q+920>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(S,c[ib>>2]|0,jb,pb,+h[Q+264>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+920>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+936>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}jA(T,c[ib>>2]|0,+h[xb+264>>3]);qb=+h[T>>3];kA(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);qb=+h[V>>3];jA(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);pb=+h[W>>3];kA(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);pb=+h[Y>>3];jA(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);jb=+h[Z>>3];kA(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA($,c[ib>>2]|0,+h[_+264>>3],+h[_+920>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(aa,c[ib>>2]|0,+h[$+264>>3],+h[$+920>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(ba,c[ib>>2]|0,jb,rb,+h[$+264>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+920>>3],0.0);zb=+h[ba>>3];jA(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);rb=+h[ca>>3];kA(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+280>>3];Ab=+zd(1.0e-13,+(jb-qb));qb=Ab*+zd(1.0e-13,+(jb-pb));pb=+h[ea+928>>3];Ab=-(pb*+zd(1.0e-13,+(jb-sb)));sb=+h[ea+272>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+nwa(c[ib>>2]|0,qb,29680,29296,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+272>>3];Cb=+h[ca+280>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+zd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+nwa(c[ib>>2]|0,Eb,29376,29296,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+928>>3]-wb}wb=+h[tb+264>>3];if(wb>0.0){Gb=wb}else{tb=c[63880]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=57624;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&127](Db,l,29304,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]}if(Gb>0.0){Hb=Gb}else{r=c[63880]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=57624;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&127](l,j,29304,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]}jA(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];kA(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);Hb=+h[ia>>3];jA(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);Fb=+h[ja>>3];kA(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3];if(zb>0.0){Ib=zb}else{la=c[63880]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=57624;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&127](ka,g,29304,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]}if(Ib>0.0){Jb=Ib}else{p=c[63880]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=57624;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&127](g,f,29304,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]}if(Jb>0.0){Kb=Jb}else{o=c[63880]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=57624;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&127](f,e,29304,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]}qb=Kb+-273.15;lA(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];jA(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);qb=+h[na>>3];kA(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);qb=+h[pa>>3];jA(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);Eb=+h[qa>>3];kA(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+272>>3];rb=+zd(1.0e-13,+(+h[qa+280>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+nwa(c[ib>>2]|0,rb,29376,29296,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(Eb- +yd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{jA(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);Lb=+h[ta>>3];kA(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);Lb=+h[va>>3];jA(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);qb=+h[wa>>3];kA(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+zd(1.0e-13,+(+h[wa+280>>3]- +h[ya>>3]));Eb=1.0- +h[wa+272>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+nwa(c[ib>>2]|0,qb,29376,29296,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{jA(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);Ob=+h[za>>3];kA(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);Ob=+h[Ba>>3];jA(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);Lb=+h[Ca>>3];kA(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);Lb=+h[Ea>>3];jA(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);qb=+h[Fa>>3];kA(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+280>>3]- +h[Ha>>3])|0)<<24>>24==0){jA(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);qb=+h[Ia>>3];kA(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Ka,c[ib>>2]|0,+h[Ja+264>>3],+h[Ja+920>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(La,c[ib>>2]|0,+h[Ka+264>>3],+h[Ka+920>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+264>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+920>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+936>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}jA(Na,c[ib>>2]|0,+h[Qb+264>>3]);rb=+h[Na>>3];kA(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);rb=+h[Pa>>3];jA(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);Eb=+h[Qa>>3];kA(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);Eb=+h[Sa>>3];jA(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);qb=+h[Ta>>3];kA(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Va,c[ib>>2]|0,+h[Ua+264>>3],+h[Ua+920>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(Wa,c[ib>>2]|0,+h[Va+264>>3],+h[Va+920>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Xa,c[ib>>2]|0,qb,Bb,+h[Va+264>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+920>>3],0.0);Cb=+h[Xa>>3];jA(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);Bb=+h[Ya>>3];kA(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+280>>3];vb=+zd(1.0e-13,+(qb-rb));rb=vb*+zd(1.0e-13,+(qb-Eb));Eb=+h[Za+928>>3];vb=-(Eb*+zd(1.0e-13,+(qb-Lb)));Lb=+h[Za+272>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+nwa(c[ib>>2]|0,rb,29680,29296,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+272>>3];Tb=+h[Ya+280>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+zd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+nwa(c[ib>>2]|0,Vb,29376,29296,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+928>>3]-Pb}Pb=+h[Mb+264>>3];Wb=Pb+-273.15;Cb=+h[Mb+920>>3];sA($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];jA(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);Pb=+h[ab>>3];kA(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);Pb=+h[cb>>3];jA(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);Wb=+h[db>>3];kA(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]);lA(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+264>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+264>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+nwa(c[ib>>2]|0,rb,30288,29296,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+264>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+928>>3]-ub);ub=+h[Yb+920>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+nwa(c[ib>>2]|0,Xb,30288,29296,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+920>>3];ac=+h[Yb+264>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+Nxa(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+272>>3];Gb=+zd(1.0e-13,+(+h[Yb+280>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+nwa(c[ib>>2]|0,Gb,29376,29296,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +zd(+(ac- +yd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+264>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+nwa(c[ib>>2]|0,ec,30288,29296,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+264>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+928>>3];ic=+h[gc+920>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+nwa(c[ib>>2]|0,fc,30288,29296,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+920>>3];kc=+h[gc+264>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+Nxa(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+272>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+zd(1.0e-13,+(+h[gc+280>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9408|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9408|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+nwa(c[ib>>2]|0,Nb,29376,29296,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9408|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function oC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;iA(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+240>>3]);if((Aza(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+256>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+912>>3]*.999;l=j;m=l+9008|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;xA(e,c[f>>2]|0,+h[d+240>>3],+h[d+896>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+9008|0;n=m;h[n>>3]=k;i=b;return}}function pC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;iA(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+216>>3]);if((Aza(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+232>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+888>>3]*.999;l=j;m=l+9032|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;xA(e,c[f>>2]|0,+h[d+216>>3],+h[d+872>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+9032|0;n=m;h[n>>3]=k;i=b;return}}function qC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;iA(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+168>>3]);if((Aza(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+184>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+840>>3]*.999;l=j;m=l+9080|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;xA(e,c[f>>2]|0,+h[d+168>>3],+h[d+824>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+9080|0;n=m;h[n>>3]=k;i=b;return}}function rC(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[63880]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=57624;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&127](mb,m,30320,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]}jA(t,c[ib>>2]|0,jb);jb=+h[t>>3];kA(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);jb=+h[v>>3];jA(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);pb=+h[w>>3];kA(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+176>>3];qb=+zd(1.0e-13,+(+h[w+184>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+nwa(c[ib>>2]|0,qb,30392,30312,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(pb- +yd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{jA(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);sb=+h[z>>3];kA(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);sb=+h[B>>3];jA(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);jb=+h[C>>3];kA(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+zd(1.0e-13,+(+h[C+184>>3]- +h[E>>3]));pb=1.0- +h[C+176>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+nwa(c[ib>>2]|0,jb,30392,30312,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{jA(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);vb=+h[F>>3];kA(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);vb=+h[H>>3];jA(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);sb=+h[I>>3];kA(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);sb=+h[K>>3];jA(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);jb=+h[L>>3];kA(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+184>>3]- +h[N>>3])|0)<<24>>24==0){jA(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);jb=+h[O>>3];kA(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Q,c[ib>>2]|0,+h[P+168>>3],+h[P+824>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(R,c[ib>>2]|0,+h[Q+168>>3],+h[Q+824>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(S,c[ib>>2]|0,jb,pb,+h[Q+168>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+824>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+840>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}jA(T,c[ib>>2]|0,+h[xb+168>>3]);qb=+h[T>>3];kA(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);qb=+h[V>>3];jA(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);pb=+h[W>>3];kA(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);pb=+h[Y>>3];jA(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);jb=+h[Z>>3];kA(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA($,c[ib>>2]|0,+h[_+168>>3],+h[_+824>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(aa,c[ib>>2]|0,+h[$+168>>3],+h[$+824>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(ba,c[ib>>2]|0,jb,rb,+h[$+168>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+824>>3],0.0);zb=+h[ba>>3];jA(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);rb=+h[ca>>3];kA(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+184>>3];Ab=+zd(1.0e-13,+(jb-qb));qb=Ab*+zd(1.0e-13,+(jb-pb));pb=+h[ea+832>>3];Ab=-(pb*+zd(1.0e-13,+(jb-sb)));sb=+h[ea+176>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+nwa(c[ib>>2]|0,qb,30696,30312,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+176>>3];Cb=+h[ca+184>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+zd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+nwa(c[ib>>2]|0,Eb,30392,30312,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+832>>3]-wb}wb=+h[tb+168>>3];if(wb>0.0){Gb=wb}else{tb=c[63880]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=57624;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&127](Db,l,30320,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]}if(Gb>0.0){Hb=Gb}else{r=c[63880]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=57624;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&127](l,j,30320,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]}jA(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];kA(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);Hb=+h[ia>>3];jA(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);Fb=+h[ja>>3];kA(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3];if(zb>0.0){Ib=zb}else{la=c[63880]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=57624;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&127](ka,g,30320,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]}if(Ib>0.0){Jb=Ib}else{p=c[63880]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=57624;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&127](g,f,30320,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]}if(Jb>0.0){Kb=Jb}else{o=c[63880]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=57624;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&127](f,e,30320,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]}qb=Kb+-273.15;lA(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];jA(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);qb=+h[na>>3];kA(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);qb=+h[pa>>3];jA(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);Eb=+h[qa>>3];kA(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+176>>3];rb=+zd(1.0e-13,+(+h[qa+184>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+nwa(c[ib>>2]|0,rb,30392,30312,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(Eb- +yd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{jA(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);Lb=+h[ta>>3];kA(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);Lb=+h[va>>3];jA(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);qb=+h[wa>>3];kA(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+zd(1.0e-13,+(+h[wa+184>>3]- +h[ya>>3]));Eb=1.0- +h[wa+176>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+nwa(c[ib>>2]|0,qb,30392,30312,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{jA(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);Ob=+h[za>>3];kA(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);Ob=+h[Ba>>3];jA(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);Lb=+h[Ca>>3];kA(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);Lb=+h[Ea>>3];jA(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);qb=+h[Fa>>3];kA(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+184>>3]- +h[Ha>>3])|0)<<24>>24==0){jA(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);qb=+h[Ia>>3];kA(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Ka,c[ib>>2]|0,+h[Ja+168>>3],+h[Ja+824>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(La,c[ib>>2]|0,+h[Ka+168>>3],+h[Ka+824>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+168>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+824>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+840>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}jA(Na,c[ib>>2]|0,+h[Qb+168>>3]);rb=+h[Na>>3];kA(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);rb=+h[Pa>>3];jA(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);Eb=+h[Qa>>3];kA(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);Eb=+h[Sa>>3];jA(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);qb=+h[Ta>>3];kA(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Va,c[ib>>2]|0,+h[Ua+168>>3],+h[Ua+824>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(Wa,c[ib>>2]|0,+h[Va+168>>3],+h[Va+824>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Xa,c[ib>>2]|0,qb,Bb,+h[Va+168>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+824>>3],0.0);Cb=+h[Xa>>3];jA(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);Bb=+h[Ya>>3];kA(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+184>>3];vb=+zd(1.0e-13,+(qb-rb));rb=vb*+zd(1.0e-13,+(qb-Eb));Eb=+h[Za+832>>3];vb=-(Eb*+zd(1.0e-13,+(qb-Lb)));Lb=+h[Za+176>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+nwa(c[ib>>2]|0,rb,30696,30312,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+176>>3];Tb=+h[Ya+184>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+zd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+nwa(c[ib>>2]|0,Vb,30392,30312,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+832>>3]-Pb}Pb=+h[Mb+168>>3];Wb=Pb+-273.15;Cb=+h[Mb+824>>3];sA($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];jA(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);Pb=+h[ab>>3];kA(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);Pb=+h[cb>>3];jA(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);Wb=+h[db>>3];kA(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]);lA(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+168>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+168>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+nwa(c[ib>>2]|0,rb,31304,30312,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+168>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+832>>3]-ub);ub=+h[Yb+824>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+nwa(c[ib>>2]|0,Xb,31304,30312,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+824>>3];ac=+h[Yb+168>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+Nxa(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+176>>3];Gb=+zd(1.0e-13,+(+h[Yb+184>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+nwa(c[ib>>2]|0,Gb,30392,30312,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +zd(+(ac- +yd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+168>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+nwa(c[ib>>2]|0,ec,31304,30312,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+168>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+832>>3];ic=+h[gc+824>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+nwa(c[ib>>2]|0,fc,31304,30312,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+824>>3];kc=+h[gc+168>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+Nxa(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+176>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+zd(1.0e-13,+(+h[gc+184>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9472|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9472|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+nwa(c[ib>>2]|0,Nb,30392,30312,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9472|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function sC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;iA(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+336>>3]);if((Aza(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+352>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+1008>>3]*.999;l=j;m=l+8920|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;xA(e,c[f>>2]|0,+h[d+336>>3],+h[d+992>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+8920|0;n=m;h[n>>3]=k;i=b;return}}function tC(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[63880]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=57624;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&127](mb,m,31336,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]}jA(t,c[ib>>2]|0,jb);jb=+h[t>>3];kA(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);jb=+h[v>>3];jA(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);pb=+h[w>>3];kA(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+344>>3];qb=+zd(1.0e-13,+(+h[w+352>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+nwa(c[ib>>2]|0,qb,31408,31328,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(pb- +yd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{jA(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);sb=+h[z>>3];kA(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);sb=+h[B>>3];jA(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);jb=+h[C>>3];kA(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+zd(1.0e-13,+(+h[C+352>>3]- +h[E>>3]));pb=1.0- +h[C+344>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+nwa(c[ib>>2]|0,jb,31408,31328,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{jA(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);vb=+h[F>>3];kA(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);vb=+h[H>>3];jA(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);sb=+h[I>>3];kA(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);sb=+h[K>>3];jA(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);jb=+h[L>>3];kA(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+352>>3]- +h[N>>3])|0)<<24>>24==0){jA(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);jb=+h[O>>3];kA(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Q,c[ib>>2]|0,+h[P+336>>3],+h[P+992>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(R,c[ib>>2]|0,+h[Q+336>>3],+h[Q+992>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(S,c[ib>>2]|0,jb,pb,+h[Q+336>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+992>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+1008>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}jA(T,c[ib>>2]|0,+h[xb+336>>3]);qb=+h[T>>3];kA(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);qb=+h[V>>3];jA(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);pb=+h[W>>3];kA(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);pb=+h[Y>>3];jA(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);jb=+h[Z>>3];kA(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA($,c[ib>>2]|0,+h[_+336>>3],+h[_+992>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(aa,c[ib>>2]|0,+h[$+336>>3],+h[$+992>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(ba,c[ib>>2]|0,jb,rb,+h[$+336>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+992>>3],0.0);zb=+h[ba>>3];jA(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);rb=+h[ca>>3];kA(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+352>>3];Ab=+zd(1.0e-13,+(jb-qb));qb=Ab*+zd(1.0e-13,+(jb-pb));pb=+h[ea+1e3>>3];Ab=-(pb*+zd(1.0e-13,+(jb-sb)));sb=+h[ea+344>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+nwa(c[ib>>2]|0,qb,31712,31328,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+344>>3];Cb=+h[ca+352>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+zd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+nwa(c[ib>>2]|0,Eb,31408,31328,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+1e3>>3]-wb}wb=+h[tb+336>>3];if(wb>0.0){Gb=wb}else{tb=c[63880]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=57624;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&127](Db,l,31336,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]}if(Gb>0.0){Hb=Gb}else{r=c[63880]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=57624;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&127](l,j,31336,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]}jA(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];kA(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);Hb=+h[ia>>3];jA(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);Fb=+h[ja>>3];kA(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3];if(zb>0.0){Ib=zb}else{la=c[63880]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=57624;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&127](ka,g,31336,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]}if(Ib>0.0){Jb=Ib}else{p=c[63880]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=57624;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&127](g,f,31336,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]}if(Jb>0.0){Kb=Jb}else{o=c[63880]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=57624;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&127](f,e,31336,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]}qb=Kb+-273.15;lA(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];jA(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);qb=+h[na>>3];kA(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);qb=+h[pa>>3];jA(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);Eb=+h[qa>>3];kA(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+344>>3];rb=+zd(1.0e-13,+(+h[qa+352>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+nwa(c[ib>>2]|0,rb,31408,31328,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(Eb- +yd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{jA(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);Lb=+h[ta>>3];kA(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);Lb=+h[va>>3];jA(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);qb=+h[wa>>3];kA(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+zd(1.0e-13,+(+h[wa+352>>3]- +h[ya>>3]));Eb=1.0- +h[wa+344>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+nwa(c[ib>>2]|0,qb,31408,31328,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{jA(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);Ob=+h[za>>3];kA(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);Ob=+h[Ba>>3];jA(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);Lb=+h[Ca>>3];kA(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);Lb=+h[Ea>>3];jA(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);qb=+h[Fa>>3];kA(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+352>>3]- +h[Ha>>3])|0)<<24>>24==0){jA(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);qb=+h[Ia>>3];kA(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Ka,c[ib>>2]|0,+h[Ja+336>>3],+h[Ja+992>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(La,c[ib>>2]|0,+h[Ka+336>>3],+h[Ka+992>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+336>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+992>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+1008>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}jA(Na,c[ib>>2]|0,+h[Qb+336>>3]);rb=+h[Na>>3];kA(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);rb=+h[Pa>>3];jA(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);Eb=+h[Qa>>3];kA(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);Eb=+h[Sa>>3];jA(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);qb=+h[Ta>>3];kA(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Va,c[ib>>2]|0,+h[Ua+336>>3],+h[Ua+992>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(Wa,c[ib>>2]|0,+h[Va+336>>3],+h[Va+992>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Xa,c[ib>>2]|0,qb,Bb,+h[Va+336>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+992>>3],0.0);Cb=+h[Xa>>3];jA(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);Bb=+h[Ya>>3];kA(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+352>>3];vb=+zd(1.0e-13,+(qb-rb));rb=vb*+zd(1.0e-13,+(qb-Eb));Eb=+h[Za+1e3>>3];vb=-(Eb*+zd(1.0e-13,+(qb-Lb)));Lb=+h[Za+344>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+nwa(c[ib>>2]|0,rb,31712,31328,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+344>>3];Tb=+h[Ya+352>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+zd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+nwa(c[ib>>2]|0,Vb,31408,31328,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+1e3>>3]-Pb}Pb=+h[Mb+336>>3];Wb=Pb+-273.15;Cb=+h[Mb+992>>3];sA($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];jA(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);Pb=+h[ab>>3];kA(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);Pb=+h[cb>>3];jA(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);Wb=+h[db>>3];kA(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]);lA(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+336>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+336>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+nwa(c[ib>>2]|0,rb,32320,31328,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+336>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+1e3>>3]-ub);ub=+h[Yb+992>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+nwa(c[ib>>2]|0,Xb,32320,31328,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+992>>3];ac=+h[Yb+336>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+Nxa(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+344>>3];Gb=+zd(1.0e-13,+(+h[Yb+352>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+nwa(c[ib>>2]|0,Gb,31408,31328,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +zd(+(ac- +yd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+336>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+nwa(c[ib>>2]|0,ec,32320,31328,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+336>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+1e3>>3];ic=+h[gc+992>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+nwa(c[ib>>2]|0,fc,32320,31328,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+992>>3];kc=+h[gc+336>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+Nxa(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+344>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+zd(1.0e-13,+(+h[gc+352>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9392|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9392|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+nwa(c[ib>>2]|0,Nb,31408,31328,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9392|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function uC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;iA(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+360>>3]);if((Aza(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+376>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+1032>>3]*.999;l=j;m=l+8896|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;xA(e,c[f>>2]|0,+h[d+360>>3],+h[d+1016>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+8896|0;n=m;h[n>>3]=k;i=b;return}}function vC(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[63880]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=57624;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&127](mb,m,32352,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]}jA(t,c[ib>>2]|0,jb);jb=+h[t>>3];kA(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);jb=+h[v>>3];jA(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);pb=+h[w>>3];kA(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+368>>3];qb=+zd(1.0e-13,+(+h[w+376>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+nwa(c[ib>>2]|0,qb,32424,32344,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(pb- +yd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{jA(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);sb=+h[z>>3];kA(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);sb=+h[B>>3];jA(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);jb=+h[C>>3];kA(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+zd(1.0e-13,+(+h[C+376>>3]- +h[E>>3]));pb=1.0- +h[C+368>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+nwa(c[ib>>2]|0,jb,32424,32344,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{jA(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);vb=+h[F>>3];kA(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);vb=+h[H>>3];jA(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);sb=+h[I>>3];kA(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);sb=+h[K>>3];jA(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);jb=+h[L>>3];kA(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+376>>3]- +h[N>>3])|0)<<24>>24==0){jA(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);jb=+h[O>>3];kA(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Q,c[ib>>2]|0,+h[P+360>>3],+h[P+1016>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(R,c[ib>>2]|0,+h[Q+360>>3],+h[Q+1016>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(S,c[ib>>2]|0,jb,pb,+h[Q+360>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+1016>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+1032>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}jA(T,c[ib>>2]|0,+h[xb+360>>3]);qb=+h[T>>3];kA(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);qb=+h[V>>3];jA(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);pb=+h[W>>3];kA(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);pb=+h[Y>>3];jA(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);jb=+h[Z>>3];kA(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA($,c[ib>>2]|0,+h[_+360>>3],+h[_+1016>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(aa,c[ib>>2]|0,+h[$+360>>3],+h[$+1016>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(ba,c[ib>>2]|0,jb,rb,+h[$+360>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+1016>>3],0.0);zb=+h[ba>>3];jA(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);rb=+h[ca>>3];kA(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+376>>3];Ab=+zd(1.0e-13,+(jb-qb));qb=Ab*+zd(1.0e-13,+(jb-pb));pb=+h[ea+1024>>3];Ab=-(pb*+zd(1.0e-13,+(jb-sb)));sb=+h[ea+368>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+nwa(c[ib>>2]|0,qb,32728,32344,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+368>>3];Cb=+h[ca+376>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+zd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+nwa(c[ib>>2]|0,Eb,32424,32344,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+1024>>3]-wb}wb=+h[tb+360>>3];if(wb>0.0){Gb=wb}else{tb=c[63880]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=57624;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&127](Db,l,32352,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]}if(Gb>0.0){Hb=Gb}else{r=c[63880]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=57624;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&127](l,j,32352,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]}jA(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];kA(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);Hb=+h[ia>>3];jA(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);Fb=+h[ja>>3];kA(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3];if(zb>0.0){Ib=zb}else{la=c[63880]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=57624;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&127](ka,g,32352,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]}if(Ib>0.0){Jb=Ib}else{p=c[63880]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=57624;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&127](g,f,32352,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]}if(Jb>0.0){Kb=Jb}else{o=c[63880]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=57624;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&127](f,e,32352,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]}qb=Kb+-273.15;lA(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];jA(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);qb=+h[na>>3];kA(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);qb=+h[pa>>3];jA(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);Eb=+h[qa>>3];kA(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+368>>3];rb=+zd(1.0e-13,+(+h[qa+376>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+nwa(c[ib>>2]|0,rb,32424,32344,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(Eb- +yd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{jA(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);Lb=+h[ta>>3];kA(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);Lb=+h[va>>3];jA(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);qb=+h[wa>>3];kA(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+zd(1.0e-13,+(+h[wa+376>>3]- +h[ya>>3]));Eb=1.0- +h[wa+368>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+nwa(c[ib>>2]|0,qb,32424,32344,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{jA(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);Ob=+h[za>>3];kA(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);Ob=+h[Ba>>3];jA(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);Lb=+h[Ca>>3];kA(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);Lb=+h[Ea>>3];jA(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);qb=+h[Fa>>3];kA(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+376>>3]- +h[Ha>>3])|0)<<24>>24==0){jA(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);qb=+h[Ia>>3];kA(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Ka,c[ib>>2]|0,+h[Ja+360>>3],+h[Ja+1016>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(La,c[ib>>2]|0,+h[Ka+360>>3],+h[Ka+1016>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+360>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+1016>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+1032>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}jA(Na,c[ib>>2]|0,+h[Qb+360>>3]);rb=+h[Na>>3];kA(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);rb=+h[Pa>>3];jA(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);Eb=+h[Qa>>3];kA(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);Eb=+h[Sa>>3];jA(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);qb=+h[Ta>>3];kA(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Va,c[ib>>2]|0,+h[Ua+360>>3],+h[Ua+1016>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(Wa,c[ib>>2]|0,+h[Va+360>>3],+h[Va+1016>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Xa,c[ib>>2]|0,qb,Bb,+h[Va+360>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+1016>>3],0.0);Cb=+h[Xa>>3];jA(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);Bb=+h[Ya>>3];kA(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+376>>3];vb=+zd(1.0e-13,+(qb-rb));rb=vb*+zd(1.0e-13,+(qb-Eb));Eb=+h[Za+1024>>3];vb=-(Eb*+zd(1.0e-13,+(qb-Lb)));Lb=+h[Za+368>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+nwa(c[ib>>2]|0,rb,32728,32344,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+368>>3];Tb=+h[Ya+376>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+zd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+nwa(c[ib>>2]|0,Vb,32424,32344,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+1024>>3]-Pb}Pb=+h[Mb+360>>3];Wb=Pb+-273.15;Cb=+h[Mb+1016>>3];sA($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];jA(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);Pb=+h[ab>>3];kA(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);Pb=+h[cb>>3];jA(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);Wb=+h[db>>3];kA(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]);lA(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+360>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+360>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+nwa(c[ib>>2]|0,rb,33336,32344,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+360>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+1024>>3]-ub);ub=+h[Yb+1016>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+nwa(c[ib>>2]|0,Xb,33336,32344,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+1016>>3];ac=+h[Yb+360>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+Nxa(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+368>>3];Gb=+zd(1.0e-13,+(+h[Yb+376>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+nwa(c[ib>>2]|0,Gb,32424,32344,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +zd(+(ac- +yd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+360>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+nwa(c[ib>>2]|0,ec,33336,32344,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+360>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+1024>>3];ic=+h[gc+1016>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+nwa(c[ib>>2]|0,fc,33336,32344,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+1016>>3];kc=+h[gc+360>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+Nxa(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+368>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+zd(1.0e-13,+(+h[gc+376>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9376|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9376|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+nwa(c[ib>>2]|0,Nb,32424,32344,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9376|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function wC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;iA(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+384>>3]);if((Aza(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+400>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+1056>>3]*.999;l=j;m=l+8872|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;xA(e,c[f>>2]|0,+h[d+384>>3],+h[d+1040>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+8872|0;n=m;h[n>>3]=k;i=b;return}}function xC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;gxa(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+392>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+400>>3];l=+h[a+384>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];tA(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5320>>3]=+h[f>>3];i=b;return}function yC(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;iA(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+360>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+5120>>3]=+yd(+(+h[d>>3]),+(+h[a+376>>3]*.999));i=b;return}function zC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6304>>3]=1.0- +h[b+392>>3];i=i;return}function AC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+392>>3];p=f;h[k>>3]=+h[n+6304>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+400>>3];q=+h[p+384>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Nz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4888>>3]=+h[l>>3];i=b;return}function BC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+392>>3];p=f;h[k>>3]=+h[n+6304>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+400>>3];q=+h[p+384>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Qz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4728>>3]=+h[l>>3];i=b;return}function CC(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;xz(d,c[a+536>>2]|0,+h[f+4528>>3],+h[(c[a+416>>2]|0)+464>>3],+h[f+4728>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4848>>3]=+h[d>>3];i=b;return}function DC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+392>>3];p=f;h[k>>3]=+h[n+6304>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+400>>3];q=+h[p+384>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Oz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4768>>3]=+h[l>>3];i=b;return}function EC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+392>>3];p=f;h[k>>3]=+h[n+6304>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+400>>3];q=+h[p+384>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Vz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4808>>3]=+h[l>>3];i=b;return}function FC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+392>>3];p=f;h[k>>3]=+h[n+6304>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+400>>3];q=+h[p+384>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];yz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];fA(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4488>>3]=+h[l>>3];i=b;return}function GC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+392>>3];p=f;h[k>>3]=+h[n+6304>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+400>>3];q=+h[p+384>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+5760>>3]=+h[l>>3];i=b;return}function HC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+392>>3];p=f;h[k>>3]=+h[n+6304>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+400>>3];q=+h[p+384>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+5832>>3]=+h[l>>3];i=b;return}function IC(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;iA(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+384>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+5232>>3]=+yd(+(+h[d>>3]),+(+h[a+400>>3]*.999));i=b;return}function JC(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5232>>3];k=+zd(1.0e-13,+(+h[g+400>>3]-j));l=+h[g+6304>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+nwa(c[b+536>>2]|0,k,33368,33360,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+5248>>3]=+yd(+(j*n*.6219647130774989),1.0);i=d;return}function KC(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+5264>>3]=+zd(+(+h[d+392>>3]- +h[d+5248>>3]),0.0);i=b;return}function LC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5256>>3]=+h[b+392>>3]- +h[b+5264>>3];i=i;return}function MC(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5264>>3];k=1.0-j;l=+h[g+6304>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+nwa(c[b+536>>2]|0,k,33440,33432,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+5264>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+5256>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+5296|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+5296|0;z=y;h[z>>3]=w;i=d;return}l=m/+nwa(c[b+536>>2]|0,p,33440,33432,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+5296|0;z=y;h[z>>3]=w;i=d;return}function NC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5304>>3]=+h[b+5320>>3]- +h[b+5296>>3]*+h[b+384>>3];i=i;return}function OC(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+384>>3]*+h[g+5296>>3];k=+h[g+400>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+5312|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+5312|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,33480,33472,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+5312|0;p=o;h[p>>3]=m;i=d;return}function PC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6224>>3]=+h[b+10136>>3]*+h[b+5312>>3];i=i;return}function QC(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5232>>3];k=+zd(1.0e-13,+(+h[g+400>>3]-j));l=+h[g+6304>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+nwa(c[b+536>>2]|0,k,33368,33520,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8056|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=Cza(1.0e-13,+h[f+400>>3]- +h[f+5232>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+5232>>3];j=+h[x+400>>3];k=+zd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+8784>>3];k=+h[x+6304>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+1056>>3]- +h[x+8872>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+1056>>3]- +h[x+8872>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+1056>>3]- +h[x+8872>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+1056>>3]- +h[x+8872>>3]}K=(y-k*J)/+nwa(c[b+536>>2]|0,l,33528,33520,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+6304>>3];C=+h[L+5232>>3];D=+h[L+400>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+8872>>3];m=+zd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+nwa(c[b+536>>2]|0,m,33368,33520,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+8056|0;w=v;h[w>>3]=n;i=d;return}function RC(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(Cza(+h[a+392>>3]- +h[a+5248>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+8864|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+1048>>3]- +h[a+8056>>3];g=a;j=g+8864|0;k=j;h[k>>3]=f;i=b;return}function SC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8048>>3]=+h[b+1048>>3]- +h[b+8864>>3];i=i;return}function TC(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5264>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+8864>>3];o=+h[g+8784>>3]*k+ +h[g+6304>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+nwa(c[b+536>>2]|0,l,33664,33656,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+8864>>3];q=+h[v+5264>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+8048>>3]*(1.0-q)+ +h[r+5256>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+8856|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+8856|0;C=B;h[C>>3]=z;i=d;return}p=t/+nwa(c[b+536>>2]|0,l,33664,33656,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+8856|0;C=B;h[C>>3]=z;i=d;return}function UC(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+5296>>3];k=+h[g+384>>3];l=j*k;m=l*l;n=+h[g+1056>>3]*l- +h[g+400>>3]*(j*+h[g+1040>>3]+k*+h[g+8856>>3]);if(m!=0.0){o=g;p=n/m;q=o;r=q+9368|0;s=r;h[s>>3]=p;i=d;return}if(n==0.0){o=g;p=n;q=o;r=q+9368|0;s=r;h[s>>3]=p;i=d;return}k=n/+nwa(c[b+536>>2]|0,m,33712,33704,+h[f>>3],(a[b+319|0]|0)!=0|0);o=c[(c[c[e>>2]>>2]|0)+8>>2]|0;p=k;q=o;r=q+9368|0;s=r;h[s>>3]=p;i=d;return}function VC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6144>>3]=+h[b+10136>>3]*+h[b+9368>>3];i=i;return}function WC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6104>>3]=+h[b+392>>3]*+h[b+6144>>3]+ +h[b+1048>>3]*+h[b+6224>>3];i=i;return}



function _oa(a){a=a|0;var b=0;b=i;Rda(a);Sda(a);Tda(a);Uda(a);Vda(a);Wda(a);Xda(a);Yda(a);Zda(a);_da(a);$da(a);aea(a);bea(a);cea(a);dea(a);eea(a);fea(a);gea(a);hea(a);iea(a);jea(a);kea(a);lea(a);mea(a);nea(a);oea(a);pea(a);qea(a);rea(a);sea(a);tea(a);uea(a);vea(a);wea(a);xea(a);yea(a);zea(a);Aea(a);Bea(a);Cea(a);Dea(a);Eea(a);Fea(a);Gea(a);Hea(a);Iea(a);Jea(a);Kea(a);Lea(a);Mea(a);Nea(a);Oea(a);Pea(a);Qea(a);Rea(a);Sea(a);Tea(a);Uea(a);Vea(a);Wea(a);Xea(a);Yea(a);Zea(a);_ea(a);$ea(a);afa(a);bfa(a);cfa(a);dfa(a);efa(a);ffa(a);gfa(a);hfa(a);ifa(a);jfa(a);kfa(a);lfa(a);mfa(a);nfa(a);ofa(a);pfa(a);qfa(a);rfa(a);sfa(a);tfa(a);ufa(a);vfa(a);wfa(a);xfa(a);yfa(a);zfa(a);Afa(a);Bfa(a);Cfa(a);Dfa(a);Efa(a);Ffa(a);Gfa(a);Hfa(a);Ifa(a);Jfa(a);Kfa(a);Lfa(a);Mfa(a);Nfa(a);Ofa(a);Pfa(a);Qfa(a);Rfa(a);Sfa(a);Tfa(a);Ufa(a);Vfa(a);Wfa(a);Xfa(a);Yfa(a);Zfa(a);_fa(a);$fa(a);aga(a);bga(a);cga(a);dga(a);ega(a);fga(a);gga(a);hga(a);iga(a);jga(a);kga(a);lga(a);mga(a);nga(a);oga(a);pga(a);qga(a);rga(a);sga(a);tga(a);uga(a);vga(a);wga(a);xga(a);yga(a);zga(a);Aga(a);Bga(a);Cga(a);Dga(a);Ega(a);Fga(a);Gga(a);Hga(a);Iga(a);Jga(a);Kga(a);Lga(a);Mga(a);Nga(a);Oga(a);Pga(a);Qga(a);Rga(a);Sga(a);Tga(a);Uga(a);Vga(a);Wga(a);Xga(a);Yga(a);Zga(a);_ga(a);$ga(a);aha(a);bha(a);cha(a);dha(a);eha(a);fha(a);gha(a);hha(a);iha(a);jha(a);kha(a);lha(a);mha(a);nha(a);oha(a);pha(a);qha(a);rha(a);sha(a);tha(a);uha(a);vha(a);wha(a);xha(a);yha(a);zha(a);Aha(a);Bha(a);Cha(a);Dha(a);Eha(a);Fha(a);Gha(a);Hha(a);Iha(a);Jha(a);Kha(a);Lha(a);Mha(a);Nha(a);Oha(a);Pha(a);Qha(a);Rha(a);Sha(a);Tha(a);Uha(a);Vha(a);Wha(a);Xha(a);Yha(a);Zha(a);_ha(a);$ha(a);aia(a);bia(a);cia(a);dia(a);eia(a);fia(a);gia(a);hia(a);iia(a);jia(a);kia(a);lia(a);mia(a);nia(a);oia(a);pia(a);qia(a);ria(a);sia(a);tia(a);uia(a);via(a);wia(a);xia(a);yia(a);zia(a);Aia(a);Bia(a);Cia(a);Dia(a);Eia(a);Fia(a);Gia(a);Hia(a);Iia(a);Jia(a);Kia(a);Lia(a);Mia(a);Nia(a);Oia(a);Pia(a);Qia(a);Ria(a);Sia(a);Tia(a);Uia(a);Via(a);Wia(a);Xia(a);Yia(a);Zia(a);_ia(a);$ia(a);aja(a);bja(a);cja(a);dja(a);eja(a);fja(a);gja(a);hja(a);ija(a);jja(a);kja(a);lja(a);mja(a);nja(a);oja(a);pja(a);qja(a);rja(a);sja(a);tja(a);uja(a);vja(a);wja(a);xja(a);yja(a);zja(a);Aja(a);Bja(a);Cja(a);Dja(a);Eja(a);Fja(a);Gja(a);Hja(a);Ija(a);Jja(a);Kja(a);Lja(a);Mja(a);Nja(a);Oja(a);Pja(a);Qja(a);Rja(a);Sja(a);Tja(a);Uja(a);Vja(a);Wja(a);Xja(a);Yja(a);Zja(a);_ja(a);$ja(a);aka(a);bka(a);cka(a);dka(a);eka(a);fka(a);gka(a);hka(a);ika(a);jka(a);kka(a);lka(a);mka(a);nka(a);oka(a);pka(a);qka(a);rka(a);ska(a);tka(a);uka(a);vka(a);wka(a);xka(a);yka(a);zka(a);Aka(a);Bka(a);Cka(a);Dka(a);Eka(a);Fka(a);Gka(a);Hka(a);Ika(a);Jka(a);Kka(a);Lka(a);Mka(a);Nka(a);Oka(a);Pka(a);Qka(a);Rka(a);Ska(a);Tka(a);Uka(a);Vka(a);Wka(a);Xka(a);Yka(a);Zka(a);_ka(a);$ka(a);ala(a);bla(a);cla(a);dla(a);ela(a);fla(a);gla(a);hla(a);ila(a);jla(a);kla(a);lla(a);mla(a);nla(a);ola(a);pla(a);qla(a);rla(a);sla(a);tla(a);ula(a);vla(a);wla(a);xla(a);yla(a);zla(a);Ala(a);Bla(a);Cla(a);Dla(a);Ela(a);Fla(a);Gla(a);Hla(a);Ila(a);Jla(a);Kla(a);Lla(a);Mla(a);Nla(a);Ola(a);Pla(a);Qla(a);Rla(a);Sla(a);Tla(a);Ula(a);Vla(a);Wla(a);Xla(a);Yla(a);Zla(a);_la(a);$la(a);ama(a);bma(a);cma(a);dma(a);ema(a);fma(a);gma(a);hma(a);ima(a);jma(a);kma(a);lma(a);mma(a);nma(a);oma(a);pma(a);qma(a);rma(a);sma(a);tma(a);uma(a);vma(a);wma(a);xma(a);yma(a);zma(a);Ama(a);Bma(a);Cma(a);Dma(a);Ema(a);Fma(a);Gma(a);Hma(a);Ima(a);Jma(a);Kma(a);Lma(a);Mma(a);Nma(a);Oma(a);Pma(a);Qma(a);Rma(a);Sma(a);Tma(a);Uma(a);Vma(a);Wma(a);Xma(a);Yma(a);Zma(a);_ma(a);$ma(a);ana(a);bna(a);cna(a);dna(a);ena(a);fna(a);gna(a);hna(a);ina(a);jna(a);kna(a);lna(a);mna(a);nna(a);ona(a);pna(a);qna(a);rna(a);sna(a);tna(a);una(a);vna(a);wna(a);xna(a);yna(a);zna(a);Ana(a);Bna(a);Cna(a);Dna(a);Ena(a);Fna(a);Gna(a);Hna(a);Ina(a);Jna(a);Kna(a);Lna(a);Mna(a);Nna(a);Ona(a);Pna(a);Qna(a);Rna(a);Sna(a);Tna(a);Una(a);Vna(a);Wna(a);Xna(a);Yna(a);Zna(a);_na(a);$na(a);aoa(a);boa(a);coa(a);doa(a);eoa(a);foa(a);goa(a);hoa(a);ioa(a);joa(a);koa(a);loa(a);moa(a);noa(a);ooa(a);poa(a);qoa(a);roa(a);soa(a);toa(a);uoa(a);voa(a);woa(a);xoa(a);yoa(a);zoa(a);Aoa(a);Boa(a);Coa(a);Doa(a);Eoa(a);Foa(a);Goa(a);Hoa(a);Ioa(a);Joa(a);Koa(a);Loa(a);Moa(a);Noa(a);Ooa(a);Poa(a);Qoa(a);Roa(a);Soa(a);Toa(a);Uoa(a);Voa(a);Woa(a);Xoa(a);Yoa(a);Zoa(a);i=b;return 0}function $oa(a){a=a|0;i=i;return 1}function apa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=a+464|0;a=c[d>>2]|0;c[a+44>>2]=82;c[a+48>>2]=82;c[a+72>>2]=X_a(82,8)|0;a=X_a(82,8)|0;c[(c[d>>2]|0)+80>>2]=a;a=X_a(0,8)|0;c[(c[d>>2]|0)+76>>2]=a;a=V_a(328)|0;c[(c[d>>2]|0)+52>>2]=a;a=V_a(3320)|0;c[(c[d>>2]|0)+56>>2]=a;a=V_a(328)|0;c[(c[d>>2]|0)+64>>2]=a;a=c[d>>2]|0;c[a+68>>2]=16;c[a+84>>2]=0;a=c[(c[d>>2]|0)+52>>2]|0;c[a+304>>2]=5;c[a+308>>2]=9;c[a+312>>2]=9;c[a+316>>2]=9;c[a+320>>2]=9;c[a+324>>2]=13;c[a+300>>2]=7;c[a+296>>2]=8;c[a+292>>2]=7;c[a+288>>2]=9;c[a+284>>2]=11;c[a+280>>2]=9;c[a+276>>2]=9;c[a+272>>2]=11;c[a+268>>2]=9;c[a+264>>2]=9;c[a+260>>2]=11;c[a+256>>2]=9;c[a+252>>2]=12;c[a+248>>2]=15;c[a+244>>2]=12;c[a+228>>2]=8;c[a+232>>2]=9;c[a+236>>2]=9;c[a+240>>2]=8;c[a+224>>2]=12;c[a+220>>2]=15;c[a+216>>2]=12;c[a+212>>2]=9;c[a+208>>2]=11;c[a+204>>2]=9;c[a+200>>2]=9;c[a+196>>2]=11;c[a+192>>2]=9;c[a+188>>2]=9;c[a+184>>2]=11;c[a+180>>2]=9;c[a+176>>2]=12;c[a+172>>2]=15;c[a+168>>2]=12;c[a+144>>2]=13;c[a+148>>2]=9;c[a+152>>2]=9;c[a+156>>2]=9;c[a+160>>2]=9;c[a+164>>2]=13;c[a+140>>2]=12;c[a+136>>2]=15;c[a+132>>2]=12;a=c[d>>2]|0;e=c[a+52>>2]|0;c[e+128>>2]=9;c[e+124>>2]=11;c[e+120>>2]=9;c[e+116>>2]=9;c[e+112>>2]=11;c[e+108>>2]=9;c[e+104>>2]=9;c[e+100>>2]=11;c[e+96>>2]=9;c[e+92>>2]=12;c[e+88>>2]=15;c[e+84>>2]=12;c[e+60>>2]=13;c[e+64>>2]=9;c[e+68>>2]=9;c[e+72>>2]=9;c[e+76>>2]=9;c[e+80>>2]=5;c[e+56>>2]=12;c[e+52>>2]=15;c[e+48>>2]=12;c[e+44>>2]=9;c[e+40>>2]=11;c[e+36>>2]=9;c[e+32>>2]=9;c[e+28>>2]=11;c[e+24>>2]=9;c[e+20>>2]=9;c[e+16>>2]=11;c[e+12>>2]=9;c[e+8>>2]=7;c[e+4>>2]=8;c[e>>2]=7;f=8;g=7;h=1;while(1){j=f+g|0;c[e+(h<<2)>>2]=j;k=h+1|0;if((k|0)>=82){break}f=c[e+(k<<2)>>2]|0;h=k;g=j}bpa(e,c[a+56>>2]|0);a=c[d>>2]|0;cpa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;dpa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;epa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;fpa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;gpa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;hpa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;ipa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;jpa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;kpa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;lpa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;mpa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;npa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;opa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;ppa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;qpa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;rpa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;spa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;tpa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;upa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;vpa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;wpa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;xpa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;ypa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;zpa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Apa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Bpa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Cpa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Dpa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Epa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Fpa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Gpa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Hpa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Ipa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Jpa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Kpa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Lpa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Mpa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Npa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Opa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Ppa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Qpa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Rpa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Spa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Tpa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Upa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Vpa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Wpa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Xpa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Ypa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Zpa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;_pa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;$pa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;aqa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;bqa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;cqa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;dqa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;eqa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;fqa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;gqa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;hqa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;iqa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;jqa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;kqa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;lqa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;mqa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;nqa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;oqa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;pqa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;qqa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;rqa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;sqa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;tqa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;uqa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;vqa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;wqa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;xqa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;yqa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;zqa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Aqa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Bqa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Cqa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[(c[d>>2]|0)+64>>2]|0;c[a+304>>2]=1;c[a+316>>2]=1;c[a+228>>2]=1;c[a+240>>2]=1;c[a+148>>2]=1;c[a+160>>2]=1;c[a+64>>2]=1;c[a+76>>2]=1;c[a+308>>2]=2;c[a+320>>2]=2;c[a+232>>2]=2;c[a+176>>2]=2;c[a+152>>2]=2;c[a+68>>2]=2;c[a+80>>2]=2;c[a+312>>2]=3;c[a+324>>2]=3;c[a+236>>2]=3;c[a+156>>2]=3;c[a+72>>2]=3;c[a+56>>2]=3;c[a+300>>2]=4;c[a+264>>2]=4;c[a+212>>2]=4;c[a+172>>2]=4;c[a+128>>2]=4;c[a+32>>2]=4;c[a+296>>2]=5;c[a+260>>2]=5;c[a+208>>2]=5;c[a+168>>2]=5;c[a+124>>2]=5;c[a+28>>2]=5;c[a+292>>2]=6;c[a+256>>2]=6;c[a+204>>2]=6;c[a+164>>2]=6;c[a+120>>2]=6;c[a+24>>2]=6;c[a+288>>2]=7;c[a+252>>2]=7;c[a+200>>2]=7;c[a+116>>2]=7;c[a+60>>2]=7;c[a+20>>2]=7;c[a+284>>2]=8;c[a+248>>2]=8;c[a+196>>2]=8;c[a+112>>2]=8;a=c[(c[d>>2]|0)+64>>2]|0;c[a+52>>2]=8;c[a+16>>2]=8;c[a+280>>2]=9;c[a+244>>2]=9;c[a+192>>2]=9;c[a+108>>2]=9;c[a+48>>2]=9;c[a+12>>2]=9;c[a+276>>2]=10;c[a+224>>2]=10;c[a+188>>2]=10;c[a+104>>2]=10;c[a+44>>2]=10;c[a+8>>2]=10;c[a+272>>2]=11;c[a+220>>2]=11;c[a+184>>2]=11;c[a+100>>2]=11;c[a+40>>2]=11;c[a+4>>2]=11;c[a+268>>2]=12;c[a+216>>2]=12;c[a+180>>2]=12;c[a+96>>2]=12;c[a+36>>2]=12;c[a>>2]=12;c[a+144>>2]=13;c[a+92>>2]=13;c[a+140>>2]=14;c[a+88>>2]=14;c[a+136>>2]=15;c[a+84>>2]=15;c[a+132>>2]=16;i=b;return 0}function bpa(a,b){a=a|0;b=b|0;var d=0;d=a+304|0;c[b+((c[d>>2]|0)+ -5<<2)>>2]=73;c[b+((c[d>>2]|0)+ -4<<2)>>2]=74;c[b+((c[d>>2]|0)+ -3<<2)>>2]=75;c[b+((c[d>>2]|0)+ -2<<2)>>2]=77;c[b+((c[d>>2]|0)+ -1<<2)>>2]=76;i=i;return}function cpa(a,b){a=a|0;b=b|0;var d=0;d=a+308|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=70;c[b+((c[d>>2]|0)+ -8<<2)>>2]=71;c[b+((c[d>>2]|0)+ -7<<2)>>2]=72;c[b+((c[d>>2]|0)+ -6<<2)>>2]=73;c[b+((c[d>>2]|0)+ -5<<2)>>2]=74;c[b+((c[d>>2]|0)+ -4<<2)>>2]=75;c[b+((c[d>>2]|0)+ -3<<2)>>2]=78;c[b+((c[d>>2]|0)+ -2<<2)>>2]=77;c[b+((c[d>>2]|0)+ -1<<2)>>2]=76;i=i;return}function dpa(a,b){a=a|0;b=b|0;var d=0;d=a+312|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=67;c[b+((c[d>>2]|0)+ -8<<2)>>2]=68;c[b+((c[d>>2]|0)+ -7<<2)>>2]=69;c[b+((c[d>>2]|0)+ -6<<2)>>2]=70;c[b+((c[d>>2]|0)+ -5<<2)>>2]=71;c[b+((c[d>>2]|0)+ -4<<2)>>2]=72;c[b+((c[d>>2]|0)+ -3<<2)>>2]=79;c[b+((c[d>>2]|0)+ -2<<2)>>2]=78;c[b+((c[d>>2]|0)+ -1<<2)>>2]=77;i=i;return}function epa(a,b){a=a|0;b=b|0;var d=0;d=a+316|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=64;c[b+((c[d>>2]|0)+ -8<<2)>>2]=65;c[b+((c[d>>2]|0)+ -7<<2)>>2]=66;c[b+((c[d>>2]|0)+ -6<<2)>>2]=67;c[b+((c[d>>2]|0)+ -5<<2)>>2]=68;c[b+((c[d>>2]|0)+ -4<<2)>>2]=69;c[b+((c[d>>2]|0)+ -3<<2)>>2]=80;c[b+((c[d>>2]|0)+ -2<<2)>>2]=79;c[b+((c[d>>2]|0)+ -1<<2)>>2]=78;i=i;return}function fpa(a,b){a=a|0;b=b|0;var d=0;d=a+320|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=61;c[b+((c[d>>2]|0)+ -8<<2)>>2]=62;c[b+((c[d>>2]|0)+ -7<<2)>>2]=63;c[b+((c[d>>2]|0)+ -6<<2)>>2]=64;c[b+((c[d>>2]|0)+ -5<<2)>>2]=65;c[b+((c[d>>2]|0)+ -4<<2)>>2]=66;c[b+((c[d>>2]|0)+ -3<<2)>>2]=81;c[b+((c[d>>2]|0)+ -2<<2)>>2]=80;c[b+((c[d>>2]|0)+ -1<<2)>>2]=79;i=i;return}function gpa(a,b){a=a|0;b=b|0;var d=0;d=a+324|0;c[b+((c[d>>2]|0)+ -13<<2)>>2]=33;c[b+((c[d>>2]|0)+ -12<<2)>>2]=34;c[b+((c[d>>2]|0)+ -11<<2)>>2]=35;c[b+((c[d>>2]|0)+ -10<<2)>>2]=36;c[b+((c[d>>2]|0)+ -9<<2)>>2]=54;c[b+((c[d>>2]|0)+ -8<<2)>>2]=55;c[b+((c[d>>2]|0)+ -7<<2)>>2]=56;c[b+((c[d>>2]|0)+ -6<<2)>>2]=57;c[b+((c[d>>2]|0)+ -5<<2)>>2]=61;c[b+((c[d>>2]|0)+ -4<<2)>>2]=62;c[b+((c[d>>2]|0)+ -3<<2)>>2]=63;c[b+((c[d>>2]|0)+ -2<<2)>>2]=81;c[b+((c[d>>2]|0)+ -1<<2)>>2]=80;i=i;return}function hpa(a,b){a=a|0;b=b|0;var d=0;d=a+300|0;c[b+((c[d>>2]|0)+ -7<<2)>>2]=70;c[b+((c[d>>2]|0)+ -6<<2)>>2]=72;c[b+((c[d>>2]|0)+ -5<<2)>>2]=73;c[b+((c[d>>2]|0)+ -4<<2)>>2]=74;c[b+((c[d>>2]|0)+ -3<<2)>>2]=75;c[b+((c[d>>2]|0)+ -2<<2)>>2]=77;c[b+((c[d>>2]|0)+ -1<<2)>>2]=76;i=i;return}function ipa(a,b){a=a|0;b=b|0;var d=0;d=a+296|0;c[b+((c[d>>2]|0)+ -8<<2)>>2]=70;c[b+((c[d>>2]|0)+ -7<<2)>>2]=71;c[b+((c[d>>2]|0)+ -6<<2)>>2]=72;c[b+((c[d>>2]|0)+ -5<<2)>>2]=73;c[b+((c[d>>2]|0)+ -4<<2)>>2]=74;c[b+((c[d>>2]|0)+ -3<<2)>>2]=75;c[b+((c[d>>2]|0)+ -2<<2)>>2]=77;c[b+((c[d>>2]|0)+ -1<<2)>>2]=76;i=i;return}function jpa(a,b){a=a|0;b=b|0;var d=0;d=a+292|0;c[b+((c[d>>2]|0)+ -7<<2)>>2]=70;c[b+((c[d>>2]|0)+ -6<<2)>>2]=72;c[b+((c[d>>2]|0)+ -5<<2)>>2]=73;c[b+((c[d>>2]|0)+ -4<<2)>>2]=74;c[b+((c[d>>2]|0)+ -3<<2)>>2]=75;c[b+((c[d>>2]|0)+ -2<<2)>>2]=77;c[b+((c[d>>2]|0)+ -1<<2)>>2]=76;i=i;return}function kpa(a,b){a=a|0;b=b|0;var d=0;d=a+288|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=67;c[b+((c[d>>2]|0)+ -8<<2)>>2]=69;c[b+((c[d>>2]|0)+ -7<<2)>>2]=70;c[b+((c[d>>2]|0)+ -6<<2)>>2]=71;c[b+((c[d>>2]|0)+ -5<<2)>>2]=72;c[b+((c[d>>2]|0)+ -4<<2)>>2]=73;c[b+((c[d>>2]|0)+ -3<<2)>>2]=75;c[b+((c[d>>2]|0)+ -2<<2)>>2]=78;c[b+((c[d>>2]|0)+ -1<<2)>>2]=77;i=i;return}function lpa(a,b){a=a|0;b=b|0;var d=0;d=a+284|0;c[b+((c[d>>2]|0)+ -11<<2)>>2]=67;c[b+((c[d>>2]|0)+ -10<<2)>>2]=68;c[b+((c[d>>2]|0)+ -9<<2)>>2]=69;c[b+((c[d>>2]|0)+ -8<<2)>>2]=70;c[b+((c[d>>2]|0)+ -7<<2)>>2]=71;c[b+((c[d>>2]|0)+ -6<<2)>>2]=72;c[b+((c[d>>2]|0)+ -5<<2)>>2]=73;c[b+((c[d>>2]|0)+ -4<<2)>>2]=74;c[b+((c[d>>2]|0)+ -3<<2)>>2]=75;c[b+((c[d>>2]|0)+ -2<<2)>>2]=78;c[b+((c[d>>2]|0)+ -1<<2)>>2]=77;i=i;return}function mpa(a,b){a=a|0;b=b|0;var d=0;d=a+280|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=67;c[b+((c[d>>2]|0)+ -8<<2)>>2]=69;c[b+((c[d>>2]|0)+ -7<<2)>>2]=70;c[b+((c[d>>2]|0)+ -6<<2)>>2]=71;c[b+((c[d>>2]|0)+ -5<<2)>>2]=72;c[b+((c[d>>2]|0)+ -4<<2)>>2]=73;c[b+((c[d>>2]|0)+ -3<<2)>>2]=75;c[b+((c[d>>2]|0)+ -2<<2)>>2]=78;c[b+((c[d>>2]|0)+ -1<<2)>>2]=77;i=i;return}function npa(a,b){a=a|0;b=b|0;var d=0;d=a+276|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=64;c[b+((c[d>>2]|0)+ -8<<2)>>2]=66;c[b+((c[d>>2]|0)+ -7<<2)>>2]=67;c[b+((c[d>>2]|0)+ -6<<2)>>2]=68;c[b+((c[d>>2]|0)+ -5<<2)>>2]=69;c[b+((c[d>>2]|0)+ -4<<2)>>2]=70;c[b+((c[d>>2]|0)+ -3<<2)>>2]=72;c[b+((c[d>>2]|0)+ -2<<2)>>2]=79;c[b+((c[d>>2]|0)+ -1<<2)>>2]=78;i=i;return}function opa(a,b){a=a|0;b=b|0;var d=0;d=a+272|0;c[b+((c[d>>2]|0)+ -11<<2)>>2]=64;c[b+((c[d>>2]|0)+ -10<<2)>>2]=65;c[b+((c[d>>2]|0)+ -9<<2)>>2]=66;c[b+((c[d>>2]|0)+ -8<<2)>>2]=67;c[b+((c[d>>2]|0)+ -7<<2)>>2]=68;c[b+((c[d>>2]|0)+ -6<<2)>>2]=69;c[b+((c[d>>2]|0)+ -5<<2)>>2]=70;c[b+((c[d>>2]|0)+ -4<<2)>>2]=71;c[b+((c[d>>2]|0)+ -3<<2)>>2]=72;c[b+((c[d>>2]|0)+ -2<<2)>>2]=79;c[b+((c[d>>2]|0)+ -1<<2)>>2]=78;i=i;return}function ppa(a,b){a=a|0;b=b|0;var d=0;d=a+268|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=64;c[b+((c[d>>2]|0)+ -8<<2)>>2]=66;c[b+((c[d>>2]|0)+ -7<<2)>>2]=67;c[b+((c[d>>2]|0)+ -6<<2)>>2]=68;c[b+((c[d>>2]|0)+ -5<<2)>>2]=69;c[b+((c[d>>2]|0)+ -4<<2)>>2]=70;c[b+((c[d>>2]|0)+ -3<<2)>>2]=72;c[b+((c[d>>2]|0)+ -2<<2)>>2]=79;c[b+((c[d>>2]|0)+ -1<<2)>>2]=78;i=i;return}function qpa(a,b){a=a|0;b=b|0;var d=0;d=a+264|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=61;c[b+((c[d>>2]|0)+ -8<<2)>>2]=63;c[b+((c[d>>2]|0)+ -7<<2)>>2]=64;c[b+((c[d>>2]|0)+ -6<<2)>>2]=65;c[b+((c[d>>2]|0)+ -5<<2)>>2]=66;c[b+((c[d>>2]|0)+ -4<<2)>>2]=67;c[b+((c[d>>2]|0)+ -3<<2)>>2]=69;c[b+((c[d>>2]|0)+ -2<<2)>>2]=80;c[b+((c[d>>2]|0)+ -1<<2)>>2]=79;i=i;return}function rpa(a,b){a=a|0;b=b|0;var d=0;d=a+260|0;c[b+((c[d>>2]|0)+ -11<<2)>>2]=61;c[b+((c[d>>2]|0)+ -10<<2)>>2]=62;c[b+((c[d>>2]|0)+ -9<<2)>>2]=63;c[b+((c[d>>2]|0)+ -8<<2)>>2]=64;c[b+((c[d>>2]|0)+ -7<<2)>>2]=65;c[b+((c[d>>2]|0)+ -6<<2)>>2]=66;c[b+((c[d>>2]|0)+ -5<<2)>>2]=67;c[b+((c[d>>2]|0)+ -4<<2)>>2]=68;c[b+((c[d>>2]|0)+ -3<<2)>>2]=69;c[b+((c[d>>2]|0)+ -2<<2)>>2]=80;c[b+((c[d>>2]|0)+ -1<<2)>>2]=79;i=i;return}function spa(a,b){a=a|0;b=b|0;var d=0;d=a+256|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=61;c[b+((c[d>>2]|0)+ -8<<2)>>2]=63;c[b+((c[d>>2]|0)+ -7<<2)>>2]=64;c[b+((c[d>>2]|0)+ -6<<2)>>2]=65;c[b+((c[d>>2]|0)+ -5<<2)>>2]=66;c[b+((c[d>>2]|0)+ -4<<2)>>2]=67;c[b+((c[d>>2]|0)+ -3<<2)>>2]=69;c[b+((c[d>>2]|0)+ -2<<2)>>2]=80;c[b+((c[d>>2]|0)+ -1<<2)>>2]=79;i=i;return}function tpa(a,b){a=a|0;b=b|0;var d=0;d=a+252|0;c[b+((c[d>>2]|0)+ -12<<2)>>2]=33;c[b+((c[d>>2]|0)+ -11<<2)>>2]=35;c[b+((c[d>>2]|0)+ -10<<2)>>2]=36;c[b+((c[d>>2]|0)+ -9<<2)>>2]=54;c[b+((c[d>>2]|0)+ -8<<2)>>2]=56;c[b+((c[d>>2]|0)+ -7<<2)>>2]=61;c[b+((c[d>>2]|0)+ -6<<2)>>2]=62;c[b+((c[d>>2]|0)+ -5<<2)>>2]=63;c[b+((c[d>>2]|0)+ -4<<2)>>2]=64;c[b+((c[d>>2]|0)+ -3<<2)>>2]=66;c[b+((c[d>>2]|0)+ -2<<2)>>2]=81;c[b+((c[d>>2]|0)+ -1<<2)>>2]=80;i=i;return}function upa(a,b){a=a|0;b=b|0;var d=0;d=a+248|0;c[b+((c[d>>2]|0)+ -15<<2)>>2]=33;c[b+((c[d>>2]|0)+ -14<<2)>>2]=34;c[b+((c[d>>2]|0)+ -13<<2)>>2]=35;c[b+((c[d>>2]|0)+ -12<<2)>>2]=36;c[b+((c[d>>2]|0)+ -11<<2)>>2]=54;c[b+((c[d>>2]|0)+ -10<<2)>>2]=55;c[b+((c[d>>2]|0)+ -9<<2)>>2]=56;c[b+((c[d>>2]|0)+ -8<<2)>>2]=61;c[b+((c[d>>2]|0)+ -7<<2)>>2]=62;c[b+((c[d>>2]|0)+ -6<<2)>>2]=63;c[b+((c[d>>2]|0)+ -5<<2)>>2]=64;c[b+((c[d>>2]|0)+ -4<<2)>>2]=65;c[b+((c[d>>2]|0)+ -3<<2)>>2]=66;c[b+((c[d>>2]|0)+ -2<<2)>>2]=81;c[b+((c[d>>2]|0)+ -1<<2)>>2]=80;i=i;return}function vpa(a,b){a=a|0;b=b|0;var d=0;d=a+244|0;c[b+((c[d>>2]|0)+ -12<<2)>>2]=33;c[b+((c[d>>2]|0)+ -11<<2)>>2]=35;c[b+((c[d>>2]|0)+ -10<<2)>>2]=36;c[b+((c[d>>2]|0)+ -9<<2)>>2]=54;c[b+((c[d>>2]|0)+ -8<<2)>>2]=56;c[b+((c[d>>2]|0)+ -7<<2)>>2]=61;c[b+((c[d>>2]|0)+ -6<<2)>>2]=62;c[b+((c[d>>2]|0)+ -5<<2)>>2]=63;c[b+((c[d>>2]|0)+ -4<<2)>>2]=64;c[b+((c[d>>2]|0)+ -3<<2)>>2]=66;c[b+((c[d>>2]|0)+ -2<<2)>>2]=81;c[b+((c[d>>2]|0)+ -1<<2)>>2]=80;i=i;return}function wpa(a,b){a=a|0;b=b|0;var d=0;d=a+228|0;c[b+((c[d>>2]|0)+ -8<<2)>>2]=51;c[b+((c[d>>2]|0)+ -7<<2)>>2]=52;c[b+((c[d>>2]|0)+ -6<<2)>>2]=53;c[b+((c[d>>2]|0)+ -5<<2)>>2]=54;c[b+((c[d>>2]|0)+ -4<<2)>>2]=55;c[b+((c[d>>2]|0)+ -3<<2)>>2]=56;c[b+((c[d>>2]|0)+ -2<<2)>>2]=58;c[b+((c[d>>2]|0)+ -1<<2)>>2]=57;i=i;return}function xpa(a,b){a=a|0;b=b|0;var d=0;d=a+232|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=48;c[b+((c[d>>2]|0)+ -8<<2)>>2]=49;c[b+((c[d>>2]|0)+ -7<<2)>>2]=50;c[b+((c[d>>2]|0)+ -6<<2)>>2]=51;c[b+((c[d>>2]|0)+ -5<<2)>>2]=52;c[b+((c[d>>2]|0)+ -4<<2)>>2]=53;c[b+((c[d>>2]|0)+ -3<<2)>>2]=59;c[b+((c[d>>2]|0)+ -2<<2)>>2]=58;c[b+((c[d>>2]|0)+ -1<<2)>>2]=57;i=i;return}function ypa(a,b){a=a|0;b=b|0;var d=0;d=a+236|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=45;c[b+((c[d>>2]|0)+ -8<<2)>>2]=46;c[b+((c[d>>2]|0)+ -7<<2)>>2]=47;c[b+((c[d>>2]|0)+ -6<<2)>>2]=48;c[b+((c[d>>2]|0)+ -5<<2)>>2]=49;c[b+((c[d>>2]|0)+ -4<<2)>>2]=50;c[b+((c[d>>2]|0)+ -3<<2)>>2]=60;c[b+((c[d>>2]|0)+ -2<<2)>>2]=59;c[b+((c[d>>2]|0)+ -1<<2)>>2]=58;i=i;return}function zpa(a,b){a=a|0;b=b|0;var d=0;d=a+240|0;c[b+((c[d>>2]|0)+ -8<<2)>>2]=42;c[b+((c[d>>2]|0)+ -7<<2)>>2]=43;c[b+((c[d>>2]|0)+ -6<<2)>>2]=44;c[b+((c[d>>2]|0)+ -5<<2)>>2]=45;c[b+((c[d>>2]|0)+ -4<<2)>>2]=46;c[b+((c[d>>2]|0)+ -3<<2)>>2]=47;c[b+((c[d>>2]|0)+ -2<<2)>>2]=60;c[b+((c[d>>2]|0)+ -1<<2)>>2]=59;i=i;return}function Apa(a,b){a=a|0;b=b|0;var d=0;d=a+224|0;c[b+((c[d>>2]|0)+ -12<<2)>>2]=33;c[b+((c[d>>2]|0)+ -11<<2)>>2]=35;c[b+((c[d>>2]|0)+ -10<<2)>>2]=36;c[b+((c[d>>2]|0)+ -9<<2)>>2]=51;c[b+((c[d>>2]|0)+ -8<<2)>>2]=53;c[b+((c[d>>2]|0)+ -7<<2)>>2]=54;c[b+((c[d>>2]|0)+ -6<<2)>>2]=55;c[b+((c[d>>2]|0)+ -5<<2)>>2]=56;c[b+((c[d>>2]|0)+ -4<<2)>>2]=57;c[b+((c[d>>2]|0)+ -3<<2)>>2]=61;c[b+((c[d>>2]|0)+ -2<<2)>>2]=63;c[b+((c[d>>2]|0)+ -1<<2)>>2]=81;i=i;return}function Bpa(a,b){a=a|0;b=b|0;var d=0;d=a+220|0;c[b+((c[d>>2]|0)+ -15<<2)>>2]=33;c[b+((c[d>>2]|0)+ -14<<2)>>2]=34;c[b+((c[d>>2]|0)+ -13<<2)>>2]=35;c[b+((c[d>>2]|0)+ -12<<2)>>2]=36;c[b+((c[d>>2]|0)+ -11<<2)>>2]=51;c[b+((c[d>>2]|0)+ -10<<2)>>2]=52;c[b+((c[d>>2]|0)+ -9<<2)>>2]=53;c[b+((c[d>>2]|0)+ -8<<2)>>2]=54;c[b+((c[d>>2]|0)+ -7<<2)>>2]=55;c[b+((c[d>>2]|0)+ -6<<2)>>2]=56;c[b+((c[d>>2]|0)+ -5<<2)>>2]=57;c[b+((c[d>>2]|0)+ -4<<2)>>2]=61;c[b+((c[d>>2]|0)+ -3<<2)>>2]=62;c[b+((c[d>>2]|0)+ -2<<2)>>2]=63;c[b+((c[d>>2]|0)+ -1<<2)>>2]=81;i=i;return}function Cpa(a,b){a=a|0;b=b|0;var d=0;d=a+216|0;c[b+((c[d>>2]|0)+ -12<<2)>>2]=33;c[b+((c[d>>2]|0)+ -11<<2)>>2]=35;c[b+((c[d>>2]|0)+ -10<<2)>>2]=36;c[b+((c[d>>2]|0)+ -9<<2)>>2]=51;c[b+((c[d>>2]|0)+ -8<<2)>>2]=53;c[b+((c[d>>2]|0)+ -7<<2)>>2]=54;c[b+((c[d>>2]|0)+ -6<<2)>>2]=55;c[b+((c[d>>2]|0)+ -5<<2)>>2]=56;c[b+((c[d>>2]|0)+ -4<<2)>>2]=57;c[b+((c[d>>2]|0)+ -3<<2)>>2]=61;c[b+((c[d>>2]|0)+ -2<<2)>>2]=63;c[b+((c[d>>2]|0)+ -1<<2)>>2]=81;i=i;return}function Dpa(a,b){a=a|0;b=b|0;var d=0;d=a+212|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=48;c[b+((c[d>>2]|0)+ -8<<2)>>2]=50;c[b+((c[d>>2]|0)+ -7<<2)>>2]=51;c[b+((c[d>>2]|0)+ -6<<2)>>2]=52;c[b+((c[d>>2]|0)+ -5<<2)>>2]=53;c[b+((c[d>>2]|0)+ -4<<2)>>2]=54;c[b+((c[d>>2]|0)+ -3<<2)>>2]=56;c[b+((c[d>>2]|0)+ -2<<2)>>2]=58;c[b+((c[d>>2]|0)+ -1<<2)>>2]=57;i=i;return}function Epa(a,b){a=a|0;b=b|0;var d=0;d=a+208|0;c[b+((c[d>>2]|0)+ -11<<2)>>2]=48;c[b+((c[d>>2]|0)+ -10<<2)>>2]=49;c[b+((c[d>>2]|0)+ -9<<2)>>2]=50;c[b+((c[d>>2]|0)+ -8<<2)>>2]=51;c[b+((c[d>>2]|0)+ -7<<2)>>2]=52;c[b+((c[d>>2]|0)+ -6<<2)>>2]=53;c[b+((c[d>>2]|0)+ -5<<2)>>2]=54;c[b+((c[d>>2]|0)+ -4<<2)>>2]=55;c[b+((c[d>>2]|0)+ -3<<2)>>2]=56;c[b+((c[d>>2]|0)+ -2<<2)>>2]=58;c[b+((c[d>>2]|0)+ -1<<2)>>2]=57;i=i;return}function Fpa(a,b){a=a|0;b=b|0;var d=0;d=a+204|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=48;c[b+((c[d>>2]|0)+ -8<<2)>>2]=50;c[b+((c[d>>2]|0)+ -7<<2)>>2]=51;c[b+((c[d>>2]|0)+ -6<<2)>>2]=52;c[b+((c[d>>2]|0)+ -5<<2)>>2]=53;c[b+((c[d>>2]|0)+ -4<<2)>>2]=54;c[b+((c[d>>2]|0)+ -3<<2)>>2]=56;c[b+((c[d>>2]|0)+ -2<<2)>>2]=58;c[b+((c[d>>2]|0)+ -1<<2)>>2]=57;i=i;return}function Gpa(a,b){a=a|0;b=b|0;var d=0;d=a+200|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=45;c[b+((c[d>>2]|0)+ -8<<2)>>2]=47;c[b+((c[d>>2]|0)+ -7<<2)>>2]=48;c[b+((c[d>>2]|0)+ -6<<2)>>2]=49;c[b+((c[d>>2]|0)+ -5<<2)>>2]=50;c[b+((c[d>>2]|0)+ -4<<2)>>2]=51;c[b+((c[d>>2]|0)+ -3<<2)>>2]=53;c[b+((c[d>>2]|0)+ -2<<2)>>2]=59;c[b+((c[d>>2]|0)+ -1<<2)>>2]=58;i=i;return}function Hpa(a,b){a=a|0;b=b|0;var d=0;d=a+196|0;c[b+((c[d>>2]|0)+ -11<<2)>>2]=45;c[b+((c[d>>2]|0)+ -10<<2)>>2]=46;c[b+((c[d>>2]|0)+ -9<<2)>>2]=47;c[b+((c[d>>2]|0)+ -8<<2)>>2]=48;c[b+((c[d>>2]|0)+ -7<<2)>>2]=49;c[b+((c[d>>2]|0)+ -6<<2)>>2]=50;c[b+((c[d>>2]|0)+ -5<<2)>>2]=51;c[b+((c[d>>2]|0)+ -4<<2)>>2]=52;c[b+((c[d>>2]|0)+ -3<<2)>>2]=53;c[b+((c[d>>2]|0)+ -2<<2)>>2]=59;c[b+((c[d>>2]|0)+ -1<<2)>>2]=58;i=i;return}function Ipa(a,b){a=a|0;b=b|0;var d=0;d=a+192|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=45;c[b+((c[d>>2]|0)+ -8<<2)>>2]=47;c[b+((c[d>>2]|0)+ -7<<2)>>2]=48;c[b+((c[d>>2]|0)+ -6<<2)>>2]=49;c[b+((c[d>>2]|0)+ -5<<2)>>2]=50;c[b+((c[d>>2]|0)+ -4<<2)>>2]=51;c[b+((c[d>>2]|0)+ -3<<2)>>2]=53;c[b+((c[d>>2]|0)+ -2<<2)>>2]=59;c[b+((c[d>>2]|0)+ -1<<2)>>2]=58;i=i;return}function Jpa(a,b){a=a|0;b=b|0;var d=0;d=a+188|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=42;c[b+((c[d>>2]|0)+ -8<<2)>>2]=44;c[b+((c[d>>2]|0)+ -7<<2)>>2]=45;c[b+((c[d>>2]|0)+ -6<<2)>>2]=46;c[b+((c[d>>2]|0)+ -5<<2)>>2]=47;c[b+((c[d>>2]|0)+ -4<<2)>>2]=48;c[b+((c[d>>2]|0)+ -3<<2)>>2]=50;c[b+((c[d>>2]|0)+ -2<<2)>>2]=60;c[b+((c[d>>2]|0)+ -1<<2)>>2]=59;i=i;return}function Kpa(a,b){a=a|0;b=b|0;var d=0;d=a+184|0;c[b+((c[d>>2]|0)+ -11<<2)>>2]=42;c[b+((c[d>>2]|0)+ -10<<2)>>2]=43;c[b+((c[d>>2]|0)+ -9<<2)>>2]=44;c[b+((c[d>>2]|0)+ -8<<2)>>2]=45;c[b+((c[d>>2]|0)+ -7<<2)>>2]=46;c[b+((c[d>>2]|0)+ -6<<2)>>2]=47;c[b+((c[d>>2]|0)+ -5<<2)>>2]=48;c[b+((c[d>>2]|0)+ -4<<2)>>2]=49;c[b+((c[d>>2]|0)+ -3<<2)>>2]=50;c[b+((c[d>>2]|0)+ -2<<2)>>2]=60;c[b+((c[d>>2]|0)+ -1<<2)>>2]=59;i=i;return}function Lpa(a,b){a=a|0;b=b|0;var d=0;d=a+180|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=42;c[b+((c[d>>2]|0)+ -8<<2)>>2]=44;c[b+((c[d>>2]|0)+ -7<<2)>>2]=45;c[b+((c[d>>2]|0)+ -6<<2)>>2]=46;c[b+((c[d>>2]|0)+ -5<<2)>>2]=47;c[b+((c[d>>2]|0)+ -4<<2)>>2]=48;c[b+((c[d>>2]|0)+ -3<<2)>>2]=50;c[b+((c[d>>2]|0)+ -2<<2)>>2]=60;c[b+((c[d>>2]|0)+ -1<<2)>>2]=59;i=i;return}function Mpa(a,b){a=a|0;b=b|0;var d=0;d=a+176|0;c[b+((c[d>>2]|0)+ -12<<2)>>2]=12;c[b+((c[d>>2]|0)+ -11<<2)>>2]=14;c[b+((c[d>>2]|0)+ -10<<2)>>2]=15;c[b+((c[d>>2]|0)+ -9<<2)>>2]=21;c[b+((c[d>>2]|0)+ -8<<2)>>2]=23;c[b+((c[d>>2]|0)+ -7<<2)>>2]=41;c[b+((c[d>>2]|0)+ -6<<2)>>2]=42;c[b+((c[d>>2]|0)+ -5<<2)>>2]=43;c[b+((c[d>>2]|0)+ -4<<2)>>2]=44;c[b+((c[d>>2]|0)+ -3<<2)>>2]=45;c[b+((c[d>>2]|0)+ -2<<2)>>2]=47;c[b+((c[d>>2]|0)+ -1<<2)>>2]=60;i=i;return}function Npa(a,b){a=a|0;b=b|0;var d=0;d=a+172|0;c[b+((c[d>>2]|0)+ -15<<2)>>2]=12;c[b+((c[d>>2]|0)+ -14<<2)>>2]=13;c[b+((c[d>>2]|0)+ -13<<2)>>2]=14;c[b+((c[d>>2]|0)+ -12<<2)>>2]=15;c[b+((c[d>>2]|0)+ -11<<2)>>2]=21;c[b+((c[d>>2]|0)+ -10<<2)>>2]=22;c[b+((c[d>>2]|0)+ -9<<2)>>2]=23;c[b+((c[d>>2]|0)+ -8<<2)>>2]=41;c[b+((c[d>>2]|0)+ -7<<2)>>2]=42;c[b+((c[d>>2]|0)+ -6<<2)>>2]=43;c[b+((c[d>>2]|0)+ -5<<2)>>2]=44;c[b+((c[d>>2]|0)+ -4<<2)>>2]=45;c[b+((c[d>>2]|0)+ -3<<2)>>2]=46;c[b+((c[d>>2]|0)+ -2<<2)>>2]=47;c[b+((c[d>>2]|0)+ -1<<2)>>2]=60;i=i;return}function Opa(a,b){a=a|0;b=b|0;var d=0;d=a+168|0;c[b+((c[d>>2]|0)+ -12<<2)>>2]=12;c[b+((c[d>>2]|0)+ -11<<2)>>2]=14;c[b+((c[d>>2]|0)+ -10<<2)>>2]=15;c[b+((c[d>>2]|0)+ -9<<2)>>2]=21;c[b+((c[d>>2]|0)+ -8<<2)>>2]=23;c[b+((c[d>>2]|0)+ -7<<2)>>2]=41;c[b+((c[d>>2]|0)+ -6<<2)>>2]=42;c[b+((c[d>>2]|0)+ -5<<2)>>2]=43;c[b+((c[d>>2]|0)+ -4<<2)>>2]=44;c[b+((c[d>>2]|0)+ -3<<2)>>2]=45;c[b+((c[d>>2]|0)+ -2<<2)>>2]=47;c[b+((c[d>>2]|0)+ -1<<2)>>2]=60;i=i;return}function Ppa(a,b){a=a|0;b=b|0;var d=0;d=a+144|0;c[b+((c[d>>2]|0)+ -13<<2)>>2]=33;c[b+((c[d>>2]|0)+ -12<<2)>>2]=34;c[b+((c[d>>2]|0)+ -11<<2)>>2]=35;c[b+((c[d>>2]|0)+ -10<<2)>>2]=37;c[b+((c[d>>2]|0)+ -9<<2)>>2]=36;c[b+((c[d>>2]|0)+ -8<<2)>>2]=54;c[b+((c[d>>2]|0)+ -7<<2)>>2]=55;c[b+((c[d>>2]|0)+ -6<<2)>>2]=56;c[b+((c[d>>2]|0)+ -5<<2)>>2]=57;c[b+((c[d>>2]|0)+ -4<<2)>>2]=61;c[b+((c[d>>2]|0)+ -3<<2)>>2]=62;c[b+((c[d>>2]|0)+ -2<<2)>>2]=63;c[b+((c[d>>2]|0)+ -1<<2)>>2]=81;i=i;return}function Qpa(a,b){a=a|0;b=b|0;var d=0;d=a+148|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=30;c[b+((c[d>>2]|0)+ -8<<2)>>2]=31;c[b+((c[d>>2]|0)+ -7<<2)>>2]=32;c[b+((c[d>>2]|0)+ -6<<2)>>2]=33;c[b+((c[d>>2]|0)+ -5<<2)>>2]=34;c[b+((c[d>>2]|0)+ -4<<2)>>2]=35;c[b+((c[d>>2]|0)+ -3<<2)>>2]=38;c[b+((c[d>>2]|0)+ -2<<2)>>2]=37;c[b+((c[d>>2]|0)+ -1<<2)>>2]=36;i=i;return}function Rpa(a,b){a=a|0;b=b|0;var d=0;d=a+152|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=27;c[b+((c[d>>2]|0)+ -8<<2)>>2]=28;c[b+((c[d>>2]|0)+ -7<<2)>>2]=29;c[b+((c[d>>2]|0)+ -6<<2)>>2]=30;c[b+((c[d>>2]|0)+ -5<<2)>>2]=31;c[b+((c[d>>2]|0)+ -4<<2)>>2]=32;c[b+((c[d>>2]|0)+ -3<<2)>>2]=39;c[b+((c[d>>2]|0)+ -2<<2)>>2]=38;c[b+((c[d>>2]|0)+ -1<<2)>>2]=37;i=i;return}function Spa(a,b){a=a|0;b=b|0;var d=0;d=a+156|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=24;c[b+((c[d>>2]|0)+ -8<<2)>>2]=25;c[b+((c[d>>2]|0)+ -7<<2)>>2]=26;c[b+((c[d>>2]|0)+ -6<<2)>>2]=27;c[b+((c[d>>2]|0)+ -5<<2)>>2]=28;c[b+((c[d>>2]|0)+ -4<<2)>>2]=29;c[b+((c[d>>2]|0)+ -3<<2)>>2]=40;c[b+((c[d>>2]|0)+ -2<<2)>>2]=39;c[b+((c[d>>2]|0)+ -1<<2)>>2]=38;i=i;return}function Tpa(a,b){a=a|0;b=b|0;var d=0;d=a+160|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=21;c[b+((c[d>>2]|0)+ -8<<2)>>2]=22;c[b+((c[d>>2]|0)+ -7<<2)>>2]=23;c[b+((c[d>>2]|0)+ -6<<2)>>2]=24;c[b+((c[d>>2]|0)+ -5<<2)>>2]=25;c[b+((c[d>>2]|0)+ -4<<2)>>2]=26;c[b+((c[d>>2]|0)+ -3<<2)>>2]=41;c[b+((c[d>>2]|0)+ -2<<2)>>2]=40;c[b+((c[d>>2]|0)+ -1<<2)>>2]=39;i=i;return}function Upa(a,b){a=a|0;b=b|0;var d=0;d=a+164|0;c[b+((c[d>>2]|0)+ -13<<2)>>2]=12;c[b+((c[d>>2]|0)+ -12<<2)>>2]=13;c[b+((c[d>>2]|0)+ -11<<2)>>2]=14;c[b+((c[d>>2]|0)+ -10<<2)>>2]=15;c[b+((c[d>>2]|0)+ -9<<2)>>2]=21;c[b+((c[d>>2]|0)+ -8<<2)>>2]=22;c[b+((c[d>>2]|0)+ -7<<2)>>2]=23;c[b+((c[d>>2]|0)+ -6<<2)>>2]=41;c[b+((c[d>>2]|0)+ -5<<2)>>2]=40;c[b+((c[d>>2]|0)+ -4<<2)>>2]=42;c[b+((c[d>>2]|0)+ -3<<2)>>2]=43;c[b+((c[d>>2]|0)+ -2<<2)>>2]=44;c[b+((c[d>>2]|0)+ -1<<2)>>2]=60;i=i;return}function Vpa(a,b){a=a|0;b=b|0;var d=0;d=a+140|0;c[b+((c[d>>2]|0)+ -12<<2)>>2]=30;c[b+((c[d>>2]|0)+ -11<<2)>>2]=32;c[b+((c[d>>2]|0)+ -10<<2)>>2]=33;c[b+((c[d>>2]|0)+ -9<<2)>>2]=34;c[b+((c[d>>2]|0)+ -8<<2)>>2]=35;c[b+((c[d>>2]|0)+ -7<<2)>>2]=37;c[b+((c[d>>2]|0)+ -6<<2)>>2]=36;c[b+((c[d>>2]|0)+ -5<<2)>>2]=54;c[b+((c[d>>2]|0)+ -4<<2)>>2]=56;c[b+((c[d>>2]|0)+ -3<<2)>>2]=61;c[b+((c[d>>2]|0)+ -2<<2)>>2]=63;c[b+((c[d>>2]|0)+ -1<<2)>>2]=81;i=i;return}function Wpa(a,b){a=a|0;b=b|0;var d=0;d=a+136|0;c[b+((c[d>>2]|0)+ -15<<2)>>2]=30;c[b+((c[d>>2]|0)+ -14<<2)>>2]=31;c[b+((c[d>>2]|0)+ -13<<2)>>2]=32;c[b+((c[d>>2]|0)+ -12<<2)>>2]=33;c[b+((c[d>>2]|0)+ -11<<2)>>2]=34;c[b+((c[d>>2]|0)+ -10<<2)>>2]=35;c[b+((c[d>>2]|0)+ -9<<2)>>2]=37;c[b+((c[d>>2]|0)+ -8<<2)>>2]=36;c[b+((c[d>>2]|0)+ -7<<2)>>2]=54;c[b+((c[d>>2]|0)+ -6<<2)>>2]=55;c[b+((c[d>>2]|0)+ -5<<2)>>2]=56;c[b+((c[d>>2]|0)+ -4<<2)>>2]=61;c[b+((c[d>>2]|0)+ -3<<2)>>2]=62;c[b+((c[d>>2]|0)+ -2<<2)>>2]=63;c[b+((c[d>>2]|0)+ -1<<2)>>2]=81;i=i;return}function Xpa(a,b){a=a|0;b=b|0;var d=0;d=a+132|0;c[b+((c[d>>2]|0)+ -12<<2)>>2]=30;c[b+((c[d>>2]|0)+ -11<<2)>>2]=32;c[b+((c[d>>2]|0)+ -10<<2)>>2]=33;c[b+((c[d>>2]|0)+ -9<<2)>>2]=34;c[b+((c[d>>2]|0)+ -8<<2)>>2]=35;c[b+((c[d>>2]|0)+ -7<<2)>>2]=37;c[b+((c[d>>2]|0)+ -6<<2)>>2]=36;c[b+((c[d>>2]|0)+ -5<<2)>>2]=54;c[b+((c[d>>2]|0)+ -4<<2)>>2]=56;c[b+((c[d>>2]|0)+ -3<<2)>>2]=61;c[b+((c[d>>2]|0)+ -2<<2)>>2]=63;c[b+((c[d>>2]|0)+ -1<<2)>>2]=81;i=i;return}function Ypa(a,b){a=a|0;b=b|0;var d=0;d=a+128|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=27;c[b+((c[d>>2]|0)+ -8<<2)>>2]=29;c[b+((c[d>>2]|0)+ -7<<2)>>2]=30;c[b+((c[d>>2]|0)+ -6<<2)>>2]=31;c[b+((c[d>>2]|0)+ -5<<2)>>2]=32;c[b+((c[d>>2]|0)+ -4<<2)>>2]=33;c[b+((c[d>>2]|0)+ -3<<2)>>2]=35;c[b+((c[d>>2]|0)+ -2<<2)>>2]=38;c[b+((c[d>>2]|0)+ -1<<2)>>2]=37;i=i;return}function Zpa(a,b){a=a|0;b=b|0;var d=0;d=a+124|0;c[b+((c[d>>2]|0)+ -11<<2)>>2]=27;c[b+((c[d>>2]|0)+ -10<<2)>>2]=28;c[b+((c[d>>2]|0)+ -9<<2)>>2]=29;c[b+((c[d>>2]|0)+ -8<<2)>>2]=30;c[b+((c[d>>2]|0)+ -7<<2)>>2]=31;c[b+((c[d>>2]|0)+ -6<<2)>>2]=32;c[b+((c[d>>2]|0)+ -5<<2)>>2]=33;c[b+((c[d>>2]|0)+ -4<<2)>>2]=34;c[b+((c[d>>2]|0)+ -3<<2)>>2]=35;c[b+((c[d>>2]|0)+ -2<<2)>>2]=38;c[b+((c[d>>2]|0)+ -1<<2)>>2]=37;i=i;return}function _pa(a,b){a=a|0;b=b|0;var d=0;d=a+120|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=27;c[b+((c[d>>2]|0)+ -8<<2)>>2]=29;c[b+((c[d>>2]|0)+ -7<<2)>>2]=30;c[b+((c[d>>2]|0)+ -6<<2)>>2]=31;c[b+((c[d>>2]|0)+ -5<<2)>>2]=32;c[b+((c[d>>2]|0)+ -4<<2)>>2]=33;c[b+((c[d>>2]|0)+ -3<<2)>>2]=35;c[b+((c[d>>2]|0)+ -2<<2)>>2]=38;c[b+((c[d>>2]|0)+ -1<<2)>>2]=37;i=i;return}function $pa(a,b){a=a|0;b=b|0;var d=0;d=a+116|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=24;c[b+((c[d>>2]|0)+ -8<<2)>>2]=26;c[b+((c[d>>2]|0)+ -7<<2)>>2]=27;c[b+((c[d>>2]|0)+ -6<<2)>>2]=28;c[b+((c[d>>2]|0)+ -5<<2)>>2]=29;c[b+((c[d>>2]|0)+ -4<<2)>>2]=30;c[b+((c[d>>2]|0)+ -3<<2)>>2]=32;c[b+((c[d>>2]|0)+ -2<<2)>>2]=39;c[b+((c[d>>2]|0)+ -1<<2)>>2]=38;i=i;return}function aqa(a,b){a=a|0;b=b|0;var d=0;d=a+112|0;c[b+((c[d>>2]|0)+ -11<<2)>>2]=24;c[b+((c[d>>2]|0)+ -10<<2)>>2]=25;c[b+((c[d>>2]|0)+ -9<<2)>>2]=26;c[b+((c[d>>2]|0)+ -8<<2)>>2]=27;c[b+((c[d>>2]|0)+ -7<<2)>>2]=28;c[b+((c[d>>2]|0)+ -6<<2)>>2]=29;c[b+((c[d>>2]|0)+ -5<<2)>>2]=30;c[b+((c[d>>2]|0)+ -4<<2)>>2]=31;c[b+((c[d>>2]|0)+ -3<<2)>>2]=32;c[b+((c[d>>2]|0)+ -2<<2)>>2]=39;c[b+((c[d>>2]|0)+ -1<<2)>>2]=38;i=i;return}function bqa(a,b){a=a|0;b=b|0;var d=0;d=a+108|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=24;c[b+((c[d>>2]|0)+ -8<<2)>>2]=26;c[b+((c[d>>2]|0)+ -7<<2)>>2]=27;c[b+((c[d>>2]|0)+ -6<<2)>>2]=28;c[b+((c[d>>2]|0)+ -5<<2)>>2]=29;c[b+((c[d>>2]|0)+ -4<<2)>>2]=30;c[b+((c[d>>2]|0)+ -3<<2)>>2]=32;c[b+((c[d>>2]|0)+ -2<<2)>>2]=39;c[b+((c[d>>2]|0)+ -1<<2)>>2]=38;i=i;return}function cqa(a,b){a=a|0;b=b|0;var d=0;d=a+104|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=21;c[b+((c[d>>2]|0)+ -8<<2)>>2]=23;c[b+((c[d>>2]|0)+ -7<<2)>>2]=24;c[b+((c[d>>2]|0)+ -6<<2)>>2]=25;c[b+((c[d>>2]|0)+ -5<<2)>>2]=26;c[b+((c[d>>2]|0)+ -4<<2)>>2]=27;c[b+((c[d>>2]|0)+ -3<<2)>>2]=29;c[b+((c[d>>2]|0)+ -2<<2)>>2]=40;c[b+((c[d>>2]|0)+ -1<<2)>>2]=39;i=i;return}function dqa(a,b){a=a|0;b=b|0;var d=0;d=a+100|0;c[b+((c[d>>2]|0)+ -11<<2)>>2]=21;c[b+((c[d>>2]|0)+ -10<<2)>>2]=22;c[b+((c[d>>2]|0)+ -9<<2)>>2]=23;c[b+((c[d>>2]|0)+ -8<<2)>>2]=24;c[b+((c[d>>2]|0)+ -7<<2)>>2]=25;c[b+((c[d>>2]|0)+ -6<<2)>>2]=26;c[b+((c[d>>2]|0)+ -5<<2)>>2]=27;c[b+((c[d>>2]|0)+ -4<<2)>>2]=28;c[b+((c[d>>2]|0)+ -3<<2)>>2]=29;c[b+((c[d>>2]|0)+ -2<<2)>>2]=40;c[b+((c[d>>2]|0)+ -1<<2)>>2]=39;i=i;return}function eqa(a,b){a=a|0;b=b|0;var d=0;d=a+96|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=21;c[b+((c[d>>2]|0)+ -8<<2)>>2]=23;c[b+((c[d>>2]|0)+ -7<<2)>>2]=24;c[b+((c[d>>2]|0)+ -6<<2)>>2]=25;c[b+((c[d>>2]|0)+ -5<<2)>>2]=26;c[b+((c[d>>2]|0)+ -4<<2)>>2]=27;c[b+((c[d>>2]|0)+ -3<<2)>>2]=29;c[b+((c[d>>2]|0)+ -2<<2)>>2]=40;c[b+((c[d>>2]|0)+ -1<<2)>>2]=39;i=i;return}function fqa(a,b){a=a|0;b=b|0;var d=0;d=a+92|0;c[b+((c[d>>2]|0)+ -12<<2)>>2]=12;c[b+((c[d>>2]|0)+ -11<<2)>>2]=14;c[b+((c[d>>2]|0)+ -10<<2)>>2]=15;c[b+((c[d>>2]|0)+ -9<<2)>>2]=21;c[b+((c[d>>2]|0)+ -8<<2)>>2]=22;c[b+((c[d>>2]|0)+ -7<<2)>>2]=23;c[b+((c[d>>2]|0)+ -6<<2)>>2]=24;c[b+((c[d>>2]|0)+ -5<<2)>>2]=26;c[b+((c[d>>2]|0)+ -4<<2)>>2]=41;c[b+((c[d>>2]|0)+ -3<<2)>>2]=40;c[b+((c[d>>2]|0)+ -2<<2)>>2]=42;c[b+((c[d>>2]|0)+ -1<<2)>>2]=44;i=i;return}function gqa(a,b){a=a|0;b=b|0;var d=0;d=a+88|0;c[b+((c[d>>2]|0)+ -15<<2)>>2]=12;c[b+((c[d>>2]|0)+ -14<<2)>>2]=13;c[b+((c[d>>2]|0)+ -13<<2)>>2]=14;c[b+((c[d>>2]|0)+ -12<<2)>>2]=15;c[b+((c[d>>2]|0)+ -11<<2)>>2]=21;c[b+((c[d>>2]|0)+ -10<<2)>>2]=22;c[b+((c[d>>2]|0)+ -9<<2)>>2]=23;c[b+((c[d>>2]|0)+ -8<<2)>>2]=24;c[b+((c[d>>2]|0)+ -7<<2)>>2]=25;c[b+((c[d>>2]|0)+ -6<<2)>>2]=26;c[b+((c[d>>2]|0)+ -5<<2)>>2]=41;c[b+((c[d>>2]|0)+ -4<<2)>>2]=40;c[b+((c[d>>2]|0)+ -3<<2)>>2]=42;c[b+((c[d>>2]|0)+ -2<<2)>>2]=43;c[b+((c[d>>2]|0)+ -1<<2)>>2]=44;i=i;return}function hqa(a,b){a=a|0;b=b|0;var d=0;d=a+84|0;c[b+((c[d>>2]|0)+ -12<<2)>>2]=12;c[b+((c[d>>2]|0)+ -11<<2)>>2]=14;c[b+((c[d>>2]|0)+ -10<<2)>>2]=15;c[b+((c[d>>2]|0)+ -9<<2)>>2]=21;c[b+((c[d>>2]|0)+ -8<<2)>>2]=22;c[b+((c[d>>2]|0)+ -7<<2)>>2]=23;c[b+((c[d>>2]|0)+ -6<<2)>>2]=24;c[b+((c[d>>2]|0)+ -5<<2)>>2]=26;c[b+((c[d>>2]|0)+ -4<<2)>>2]=41;c[b+((c[d>>2]|0)+ -3<<2)>>2]=40;c[b+((c[d>>2]|0)+ -2<<2)>>2]=42;c[b+((c[d>>2]|0)+ -1<<2)>>2]=44;i=i;return}function iqa(a,b){a=a|0;b=b|0;var d=0;d=a+60|0;c[b+((c[d>>2]|0)+ -13<<2)>>2]=12;c[b+((c[d>>2]|0)+ -12<<2)>>2]=13;c[b+((c[d>>2]|0)+ -11<<2)>>2]=14;c[b+((c[d>>2]|0)+ -10<<2)>>2]=16;c[b+((c[d>>2]|0)+ -9<<2)>>2]=15;c[b+((c[d>>2]|0)+ -8<<2)>>2]=21;c[b+((c[d>>2]|0)+ -7<<2)>>2]=22;c[b+((c[d>>2]|0)+ -6<<2)>>2]=23;c[b+((c[d>>2]|0)+ -5<<2)>>2]=41;c[b+((c[d>>2]|0)+ -4<<2)>>2]=42;c[b+((c[d>>2]|0)+ -3<<2)>>2]=43;c[b+((c[d>>2]|0)+ -2<<2)>>2]=44;c[b+((c[d>>2]|0)+ -1<<2)>>2]=60;i=i;return}function jqa(a,b){a=a|0;b=b|0;var d=0;d=a+64|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=9;c[b+((c[d>>2]|0)+ -8<<2)>>2]=10;c[b+((c[d>>2]|0)+ -7<<2)>>2]=11;c[b+((c[d>>2]|0)+ -6<<2)>>2]=12;c[b+((c[d>>2]|0)+ -5<<2)>>2]=13;c[b+((c[d>>2]|0)+ -4<<2)>>2]=14;c[b+((c[d>>2]|0)+ -3<<2)>>2]=17;c[b+((c[d>>2]|0)+ -2<<2)>>2]=16;c[b+((c[d>>2]|0)+ -1<<2)>>2]=15;i=i;return}function kqa(a,b){a=a|0;b=b|0;var d=0;d=a+68|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=6;c[b+((c[d>>2]|0)+ -8<<2)>>2]=7;c[b+((c[d>>2]|0)+ -7<<2)>>2]=8;c[b+((c[d>>2]|0)+ -6<<2)>>2]=9;c[b+((c[d>>2]|0)+ -5<<2)>>2]=10;c[b+((c[d>>2]|0)+ -4<<2)>>2]=11;c[b+((c[d>>2]|0)+ -3<<2)>>2]=18;c[b+((c[d>>2]|0)+ -2<<2)>>2]=17;c[b+((c[d>>2]|0)+ -1<<2)>>2]=16;i=i;return}function lqa(a,b){a=a|0;b=b|0;var d=0;d=a+72|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=3;c[b+((c[d>>2]|0)+ -8<<2)>>2]=4;c[b+((c[d>>2]|0)+ -7<<2)>>2]=5;c[b+((c[d>>2]|0)+ -6<<2)>>2]=6;c[b+((c[d>>2]|0)+ -5<<2)>>2]=7;c[b+((c[d>>2]|0)+ -4<<2)>>2]=8;c[b+((c[d>>2]|0)+ -3<<2)>>2]=19;c[b+((c[d>>2]|0)+ -2<<2)>>2]=18;c[b+((c[d>>2]|0)+ -1<<2)>>2]=17;i=i;return}function mqa(a,b){a=a|0;b=b|0;var d=0;d=a+76|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=0;c[b+((c[d>>2]|0)+ -8<<2)>>2]=1;c[b+((c[d>>2]|0)+ -7<<2)>>2]=2;c[b+((c[d>>2]|0)+ -6<<2)>>2]=3;c[b+((c[d>>2]|0)+ -5<<2)>>2]=4;c[b+((c[d>>2]|0)+ -4<<2)>>2]=5;c[b+((c[d>>2]|0)+ -3<<2)>>2]=20;c[b+((c[d>>2]|0)+ -2<<2)>>2]=19;c[b+((c[d>>2]|0)+ -1<<2)>>2]=18;i=i;return}function nqa(a,b){a=a|0;b=b|0;var d=0;d=a+80|0;c[b+((c[d>>2]|0)+ -5<<2)>>2]=0;c[b+((c[d>>2]|0)+ -4<<2)>>2]=1;c[b+((c[d>>2]|0)+ -3<<2)>>2]=2;c[b+((c[d>>2]|0)+ -2<<2)>>2]=20;c[b+((c[d>>2]|0)+ -1<<2)>>2]=19;i=i;return}function oqa(a,b){a=a|0;b=b|0;var d=0;d=a+56|0;c[b+((c[d>>2]|0)+ -12<<2)>>2]=9;c[b+((c[d>>2]|0)+ -11<<2)>>2]=11;c[b+((c[d>>2]|0)+ -10<<2)>>2]=12;c[b+((c[d>>2]|0)+ -9<<2)>>2]=13;c[b+((c[d>>2]|0)+ -8<<2)>>2]=14;c[b+((c[d>>2]|0)+ -7<<2)>>2]=16;c[b+((c[d>>2]|0)+ -6<<2)>>2]=15;c[b+((c[d>>2]|0)+ -5<<2)>>2]=21;c[b+((c[d>>2]|0)+ -4<<2)>>2]=23;c[b+((c[d>>2]|0)+ -3<<2)>>2]=41;c[b+((c[d>>2]|0)+ -2<<2)>>2]=42;c[b+((c[d>>2]|0)+ -1<<2)>>2]=44;i=i;return}function pqa(a,b){a=a|0;b=b|0;var d=0;d=a+52|0;c[b+((c[d>>2]|0)+ -15<<2)>>2]=9;c[b+((c[d>>2]|0)+ -14<<2)>>2]=10;c[b+((c[d>>2]|0)+ -13<<2)>>2]=11;c[b+((c[d>>2]|0)+ -12<<2)>>2]=12;c[b+((c[d>>2]|0)+ -11<<2)>>2]=13;c[b+((c[d>>2]|0)+ -10<<2)>>2]=14;c[b+((c[d>>2]|0)+ -9<<2)>>2]=16;c[b+((c[d>>2]|0)+ -8<<2)>>2]=15;c[b+((c[d>>2]|0)+ -7<<2)>>2]=21;c[b+((c[d>>2]|0)+ -6<<2)>>2]=22;c[b+((c[d>>2]|0)+ -5<<2)>>2]=23;c[b+((c[d>>2]|0)+ -4<<2)>>2]=41;c[b+((c[d>>2]|0)+ -3<<2)>>2]=42;c[b+((c[d>>2]|0)+ -2<<2)>>2]=43;c[b+((c[d>>2]|0)+ -1<<2)>>2]=44;i=i;return}function qqa(a,b){a=a|0;b=b|0;var d=0;d=a+48|0;c[b+((c[d>>2]|0)+ -12<<2)>>2]=9;c[b+((c[d>>2]|0)+ -11<<2)>>2]=11;c[b+((c[d>>2]|0)+ -10<<2)>>2]=12;c[b+((c[d>>2]|0)+ -9<<2)>>2]=13;c[b+((c[d>>2]|0)+ -8<<2)>>2]=14;c[b+((c[d>>2]|0)+ -7<<2)>>2]=16;c[b+((c[d>>2]|0)+ -6<<2)>>2]=15;c[b+((c[d>>2]|0)+ -5<<2)>>2]=21;c[b+((c[d>>2]|0)+ -4<<2)>>2]=23;c[b+((c[d>>2]|0)+ -3<<2)>>2]=41;c[b+((c[d>>2]|0)+ -2<<2)>>2]=42;c[b+((c[d>>2]|0)+ -1<<2)>>2]=44;i=i;return}function rqa(a,b){a=a|0;b=b|0;var d=0;d=a+44|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=6;c[b+((c[d>>2]|0)+ -8<<2)>>2]=8;c[b+((c[d>>2]|0)+ -7<<2)>>2]=9;c[b+((c[d>>2]|0)+ -6<<2)>>2]=10;c[b+((c[d>>2]|0)+ -5<<2)>>2]=11;c[b+((c[d>>2]|0)+ -4<<2)>>2]=12;c[b+((c[d>>2]|0)+ -3<<2)>>2]=14;c[b+((c[d>>2]|0)+ -2<<2)>>2]=17;c[b+((c[d>>2]|0)+ -1<<2)>>2]=16;i=i;return}function sqa(a,b){a=a|0;b=b|0;var d=0;d=a+40|0;c[b+((c[d>>2]|0)+ -11<<2)>>2]=6;c[b+((c[d>>2]|0)+ -10<<2)>>2]=7;c[b+((c[d>>2]|0)+ -9<<2)>>2]=8;c[b+((c[d>>2]|0)+ -8<<2)>>2]=9;c[b+((c[d>>2]|0)+ -7<<2)>>2]=10;c[b+((c[d>>2]|0)+ -6<<2)>>2]=11;c[b+((c[d>>2]|0)+ -5<<2)>>2]=12;c[b+((c[d>>2]|0)+ -4<<2)>>2]=13;c[b+((c[d>>2]|0)+ -3<<2)>>2]=14;c[b+((c[d>>2]|0)+ -2<<2)>>2]=17;c[b+((c[d>>2]|0)+ -1<<2)>>2]=16;i=i;return}function tqa(a,b){a=a|0;b=b|0;var d=0;d=a+36|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=6;c[b+((c[d>>2]|0)+ -8<<2)>>2]=8;c[b+((c[d>>2]|0)+ -7<<2)>>2]=9;c[b+((c[d>>2]|0)+ -6<<2)>>2]=10;c[b+((c[d>>2]|0)+ -5<<2)>>2]=11;c[b+((c[d>>2]|0)+ -4<<2)>>2]=12;c[b+((c[d>>2]|0)+ -3<<2)>>2]=14;c[b+((c[d>>2]|0)+ -2<<2)>>2]=17;c[b+((c[d>>2]|0)+ -1<<2)>>2]=16;i=i;return}function uqa(a,b){a=a|0;b=b|0;var d=0;d=a+32|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=3;c[b+((c[d>>2]|0)+ -8<<2)>>2]=5;c[b+((c[d>>2]|0)+ -7<<2)>>2]=6;c[b+((c[d>>2]|0)+ -6<<2)>>2]=7;c[b+((c[d>>2]|0)+ -5<<2)>>2]=8;c[b+((c[d>>2]|0)+ -4<<2)>>2]=9;c[b+((c[d>>2]|0)+ -3<<2)>>2]=11;c[b+((c[d>>2]|0)+ -2<<2)>>2]=18;c[b+((c[d>>2]|0)+ -1<<2)>>2]=17;i=i;return}function vqa(a,b){a=a|0;b=b|0;var d=0;d=a+28|0;c[b+((c[d>>2]|0)+ -11<<2)>>2]=3;c[b+((c[d>>2]|0)+ -10<<2)>>2]=4;c[b+((c[d>>2]|0)+ -9<<2)>>2]=5;c[b+((c[d>>2]|0)+ -8<<2)>>2]=6;c[b+((c[d>>2]|0)+ -7<<2)>>2]=7;c[b+((c[d>>2]|0)+ -6<<2)>>2]=8;c[b+((c[d>>2]|0)+ -5<<2)>>2]=9;c[b+((c[d>>2]|0)+ -4<<2)>>2]=10;c[b+((c[d>>2]|0)+ -3<<2)>>2]=11;c[b+((c[d>>2]|0)+ -2<<2)>>2]=18;c[b+((c[d>>2]|0)+ -1<<2)>>2]=17;i=i;return}function wqa(a,b){a=a|0;b=b|0;var d=0;d=a+24|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=3;c[b+((c[d>>2]|0)+ -8<<2)>>2]=5;c[b+((c[d>>2]|0)+ -7<<2)>>2]=6;c[b+((c[d>>2]|0)+ -6<<2)>>2]=7;c[b+((c[d>>2]|0)+ -5<<2)>>2]=8;c[b+((c[d>>2]|0)+ -4<<2)>>2]=9;c[b+((c[d>>2]|0)+ -3<<2)>>2]=11;c[b+((c[d>>2]|0)+ -2<<2)>>2]=18;c[b+((c[d>>2]|0)+ -1<<2)>>2]=17;i=i;return}function xqa(a,b){a=a|0;b=b|0;var d=0;d=a+20|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=0;c[b+((c[d>>2]|0)+ -8<<2)>>2]=2;c[b+((c[d>>2]|0)+ -7<<2)>>2]=3;c[b+((c[d>>2]|0)+ -6<<2)>>2]=4;c[b+((c[d>>2]|0)+ -5<<2)>>2]=5;c[b+((c[d>>2]|0)+ -4<<2)>>2]=6;c[b+((c[d>>2]|0)+ -3<<2)>>2]=8;c[b+((c[d>>2]|0)+ -2<<2)>>2]=19;c[b+((c[d>>2]|0)+ -1<<2)>>2]=18;i=i;return}function yqa(a,b){a=a|0;b=b|0;var d=0;d=a+16|0;c[b+((c[d>>2]|0)+ -11<<2)>>2]=0;c[b+((c[d>>2]|0)+ -10<<2)>>2]=1;c[b+((c[d>>2]|0)+ -9<<2)>>2]=2;c[b+((c[d>>2]|0)+ -8<<2)>>2]=3;c[b+((c[d>>2]|0)+ -7<<2)>>2]=4;c[b+((c[d>>2]|0)+ -6<<2)>>2]=5;c[b+((c[d>>2]|0)+ -5<<2)>>2]=6;c[b+((c[d>>2]|0)+ -4<<2)>>2]=7;c[b+((c[d>>2]|0)+ -3<<2)>>2]=8;c[b+((c[d>>2]|0)+ -2<<2)>>2]=19;c[b+((c[d>>2]|0)+ -1<<2)>>2]=18;i=i;return}function zqa(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=0;c[b+((c[d>>2]|0)+ -8<<2)>>2]=2;c[b+((c[d>>2]|0)+ -7<<2)>>2]=3;c[b+((c[d>>2]|0)+ -6<<2)>>2]=4;c[b+((c[d>>2]|0)+ -5<<2)>>2]=5;c[b+((c[d>>2]|0)+ -4<<2)>>2]=6;c[b+((c[d>>2]|0)+ -3<<2)>>2]=8;c[b+((c[d>>2]|0)+ -2<<2)>>2]=19;c[b+((c[d>>2]|0)+ -1<<2)>>2]=18;i=i;return}function Aqa(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;c[b+((c[d>>2]|0)+ -7<<2)>>2]=0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=1;c[b+((c[d>>2]|0)+ -5<<2)>>2]=2;c[b+((c[d>>2]|0)+ -4<<2)>>2]=3;c[b+((c[d>>2]|0)+ -3<<2)>>2]=5;c[b+((c[d>>2]|0)+ -2<<2)>>2]=20;c[b+((c[d>>2]|0)+ -1<<2)>>2]=19;i=i;return}function Bqa(a,b){a=a|0;b=b|0;var d=0;d=a+4|0;c[b+((c[d>>2]|0)+ -8<<2)>>2]=0;c[b+((c[d>>2]|0)+ -7<<2)>>2]=1;c[b+((c[d>>2]|0)+ -6<<2)>>2]=2;c[b+((c[d>>2]|0)+ -5<<2)>>2]=3;c[b+((c[d>>2]|0)+ -4<<2)>>2]=4;c[b+((c[d>>2]|0)+ -3<<2)>>2]=5;c[b+((c[d>>2]|0)+ -2<<2)>>2]=20;c[b+((c[d>>2]|0)+ -1<<2)>>2]=19;i=i;return}function Cqa(a,b){a=a|0;b=b|0;c[b+((c[a>>2]|0)+ -7<<2)>>2]=0;c[b+((c[a>>2]|0)+ -6<<2)>>2]=1;c[b+((c[a>>2]|0)+ -5<<2)>>2]=2;c[b+((c[a>>2]|0)+ -4<<2)>>2]=3;c[b+((c[a>>2]|0)+ -3<<2)>>2]=5;c[b+((c[a>>2]|0)+ -2<<2)>>2]=20;c[b+((c[a>>2]|0)+ -1<<2)>>2]=19;i=i;return}function Dqa(a){a=a|0;i=i;return 1}function Eqa(a){a=a|0;i=i;return 1}function Fqa(a){a=a|0;i=i;return 1}function Gqa(a){a=a|0;i=i;return 0}function Hqa(a){a=a|0;i=i;return 0}function Iqa(a){a=a|0;i=i;return 0}function Jqa(a){a=a|0;i=i;return 0}function Kqa(a){a=a|0;i=i;return 0}function Lqa(a,b){a=a|0;b=b|0;i=i;return-1}function Mqa(a,b){a=a|0;b=b|0;i=i;return-1}function Nqa(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i;return-1}function Oqa(){i=i;return 190600}function Pqa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0,o=0,p=0.0,q=0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0;e=i;f=c[a>>2]|0;if((f|0)<1){g=0;i=e;return g|0}a=c[d>>2]|0;if((a|0)<1){g=0;i=e;return g|0}if((f|0)==1){g=1;i=e;return g|0}j=+h[b>>3];d=!(j>=0.0);if((a|0)==1){if(d){k=-j}else{k=j}if((f|0)<2){g=1;i=e;return g|0}else{l=k;m=2;n=1}while(1){k=+h[b+(m+ -1<<3)>>3];o=!(k>=0.0);if(o){p=-k}else{p=k}q=p<=l;if(q|o^1){r=q?l:k;s=q?n:m}else{r=-k;s=m}q=m+1|0;if((q|0)>(f|0)){g=s;break}else{l=r;m=q;n=s}}i=e;return g|0}if(d){t=-j}else{t=j}if((f|0)<2){g=1;i=e;return g|0}j=t;d=2;s=a+1|0;n=1;while(1){t=+h[b+(s+ -1<<3)>>3];m=!(t>=0.0);if(m){u=-t}else{u=t}q=u<=j;if(q|m^1){v=q?j:t;w=q?n:d}else{v=-t;w=d}q=d+1|0;if((q|0)>(f|0)){g=w;break}else{j=v;d=q;s=a+s|0;n=w}}i=e;return g|0}function Qqa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[a>>2]|0;if((g|0)<1){i=f;return 0}j=c[e>>2]|0;if((j|0)<1){i=f;return 0}if((j|0)!=1){e=fa(j,g)|0;if((e|0)>0){k=1}else{i=f;return 0}do{l=d+(k+ -1<<3)|0;h[l>>3]=+h[b>>3]*+h[l>>3];k=k+j|0;}while((k|0)<=(e|0));i=f;return 0}e=(g|0)%5|0;do{if((e|0)==0){m=g}else{if((e|0)<1){n=g}else{k=1;do{j=d+(k+ -1<<3)|0;h[j>>3]=+h[b>>3]*+h[j>>3];k=k+1|0;}while((k|0)<=(e|0));n=c[a>>2]|0}if((n|0)>=5){m=n;break}i=f;return 0}}while(0);n=e+1|0;if((n|0)>(m|0)){i=f;return 0}else{o=n}do{n=d+(o+ -1<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+1<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+2<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+3<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];o=o+5|0;}while((o|0)<=(m|0));i=f;return 0}function Rqa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0;g=i;j=c[a>>2]|0;if((j|0)<1){i=g;return 0}k=c[d>>2]|0;do{if((k|0)==1){l=c[f>>2]|0;if((l|0)!=1){m=l;n=1;break}l=(j|0)%3|0;do{if((l|0)==0){o=j}else{if((l|0)<1){p=j}else{q=1;do{r=q+ -1|0;s=b+(r<<3)|0;t=+h[s>>3];u=e+(r<<3)|0;h[s>>3]=+h[u>>3];h[u>>3]=t;q=q+1|0;}while((q|0)<=(l|0));p=c[a>>2]|0}if((p|0)>=3){o=p;break}i=g;return 0}}while(0);q=l+1|0;if((q|0)>(o|0)){i=g;return 0}else{v=q}do{q=v+ -1|0;u=b+(q<<3)|0;t=+h[u>>3];s=e+(q<<3)|0;h[u>>3]=+h[s>>3];h[s>>3]=t;s=b+(v<<3)|0;t=+h[s>>3];u=e+(v<<3)|0;h[s>>3]=+h[u>>3];h[u>>3]=t;u=v+1|0;s=b+(u<<3)|0;t=+h[s>>3];q=e+(u<<3)|0;h[s>>3]=+h[q>>3];h[q>>3]=t;v=v+3|0;}while((v|0)<=(o|0));i=g;return 0}else{if((k|0)<0){w=(fa(1-j|0,k)|0)+1|0}else{w=1}m=c[f>>2]|0;n=w}}while(0);if((m|0)<0){x=1;y=n;z=(fa(1-j|0,m)|0)+1|0}else{x=1;y=n;z=1}while(1){n=b+(y+ -1<<3)|0;t=+h[n>>3];m=e+(z+ -1<<3)|0;h[n>>3]=+h[m>>3];h[m>>3]=t;m=x+1|0;if((m|0)>(j|0)){break}else{z=(c[f>>2]|0)+z|0;y=(c[d>>2]|0)+y|0;x=m}}i=g;return 0}function Sqa(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;m=i;i=i+8|0;n=m;o=c[l>>2]|0;l=~o;c[n>>2]=0;p=c[a>>2]|0;do{if((p|0)<0){c[n>>2]=1}else{q=c[b>>2]|0;if((q|0)<0){c[n>>2]=2;break}r=c[f>>2]|0;if((r|0)==0){c[n>>2]=5;break}s=c[j>>2]|0;if((s|0)==0){c[n>>2]=7;break}if((o|0)<(((p|0)>1?p:1)|0)){c[n>>2]=9;break}if((p|0)==0|(q|0)==0){i=m;return 0}if(+h[d>>3]==0.0){i=m;return 0}if((s|0)>0){t=1}else{t=1-(fa(s,q+ -1|0)|0)|0}if((r|0)==1){if((q|0)<1){i=m;return 0}else{u=s;v=1;w=t}while(1){x=+h[g+(w+ -1<<3)>>3];do{if(x!=0.0){y=x*+h[d>>3];z=c[a>>2]|0;if((z|0)<1){A=u;break}B=(fa(v,o)|0)+l|0;C=1;do{D=k+(B+C<<3)|0;h[D>>3]=+h[D>>3]+y*+h[e+(C+ -1<<3)>>3];C=C+1|0;}while((C|0)<=(z|0));A=c[j>>2]|0}else{A=u}}while(0);z=v+1|0;if((z|0)>(q|0)){break}else{u=A;v=z;w=A+w|0}}i=m;return 0}if((r|0)>0){E=1}else{E=1-(fa(p+ -1|0,r)|0)|0}if((q|0)<1){i=m;return 0}else{F=s;G=1;H=t}while(1){x=+h[g+(H+ -1<<3)>>3];do{if(x!=0.0){y=x*+h[d>>3];z=c[a>>2]|0;if((z|0)<1){I=F;break}C=(fa(G,o)|0)+l|0;B=1;D=E;while(1){J=k+(C+B<<3)|0;h[J>>3]=+h[J>>3]+y*+h[e+(D+ -1<<3)>>3];J=B+1|0;if((J|0)>(z|0)){break}else{D=(c[f>>2]|0)+D|0;B=J}}I=c[j>>2]|0}else{I=F}}while(0);B=G+1|0;if((B|0)>(q|0)){break}else{F=I;G=B;H=I+H|0}}i=m;return 0}}while(0);Db(194776,n|0)|0;i=m;return 0}function Tqa(a,b,d,e,f,g,j,k,l,m,n,o,p){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0.0,U=0.0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0,da=0;q=i;i=i+8|0;r=q;s=c[k>>2]|0;t=~s;u=c[m>>2]|0;v=~u;w=c[p>>2]|0;x=~w;y=vya(a,194784)|0;z=vya(b,194784)|0;A=(y|0)!=0;y=c[(A?d:f)>>2]|0;B=(z|0)!=0;z=c[(B?f:e)>>2]|0;c[r>>2]=0;do{if(A){C=5}else{if((vya(a,194792)|0)!=0){C=5;break}if((vya(a,194800)|0)!=0){C=5;break}c[r>>2]=1}}while(0);a:do{if((C|0)==5){do{if(!B){if((vya(b,194792)|0)!=0){break}if((vya(b,194800)|0)!=0){break}c[r>>2]=2;break a}}while(0);a=c[d>>2]|0;if((a|0)<0){c[r>>2]=3;break}D=c[e>>2]|0;if((D|0)<0){c[r>>2]=4;break}E=c[f>>2]|0;if((E|0)<0){c[r>>2]=5;break}if((c[k>>2]|0)<(((y|0)>1?y:1)|0)){c[r>>2]=8;break}if((c[m>>2]|0)<(((z|0)>1?z:1)|0)){c[r>>2]=10;break}if((c[p>>2]|0)<(((a|0)>1?a:1)|0)){c[r>>2]=13;break}if((c[r>>2]|0)!=0){break}if((a|0)==0|(D|0)==0){i=q;return 0}F=+h[g>>3]==0.0;do{if(F|(E|0)==0){if(+h[n>>3]==1.0){i=q;return 0}if(!F){break}G=(D|0)<1;if(+h[n>>3]==0.0){if(G){i=q;return 0}else{H=a;I=0;J=2}while(1){if((H|0)>=1){B$a(o+((fa(w,I)|0)<<3)|0,0,H<<3|0)|0}if((J|0)>(D|0)){break}H=c[d>>2]|0;I=I+1|0;J=J+1|0}i=q;return 0}if(G){i=q;return 0}else{K=a;L=1}while(1){if((K|0)>=1){M=(fa(L,w)|0)+x|0;N=1;do{O=o+(M+N<<3)|0;h[O>>3]=+h[n>>3]*+h[O>>3];N=N+1|0;}while((N|0)<=(K|0))}N=L+1|0;if((N|0)>(D|0)){break}K=c[d>>2]|0;L=N}i=q;return 0}}while(0);F=(D|0)<1;if(B){if(!A){if(F){i=q;return 0}else{P=a;Q=1}while(1){if((P|0)>=1){E=(fa(Q,w)|0)+x|0;G=(fa(Q,u)|0)+v|0;N=1;do{M=c[f>>2]|0;if((M|0)<1){R=0.0}else{O=(fa(N,s)|0)+t|0;S=1;T=0.0;while(1){U=T+ +h[j+(O+S<<3)>>3]*+h[l+(G+S<<3)>>3];V=S+1|0;if((V|0)>(M|0)){R=U;break}else{T=U;S=V}}}T=+h[n>>3];U=R*+h[g>>3];S=o+(E+N<<3)|0;if(T==0.0){W=U}else{W=U+T*+h[S>>3]}h[S>>3]=W;N=N+1|0;}while((N|0)<=(P|0))}N=Q+1|0;if((N|0)>(D|0)){break}P=c[d>>2]|0;Q=N}i=q;return 0}if(F){i=q;return 0}else{X=0;Y=1}while(1){N=o+((fa(w,X)|0)<<3)|0;T=+h[n>>3];b:do{if(T==0.0){E=c[d>>2]|0;if((E|0)<1){break}B$a(N|0,0,E<<3|0)|0}else{if(!(T!=1.0)){break}E=c[d>>2]|0;if((E|0)<1){break}G=(fa(Y,w)|0)+x|0;U=T;S=1;while(1){M=o+(G+S<<3)|0;h[M>>3]=U*+h[M>>3];M=S+1|0;if((M|0)>(E|0)){break b}U=+h[n>>3];S=M}}}while(0);N=c[f>>2]|0;if((N|0)>=1){S=(fa(Y,u)|0)+v|0;E=(fa(Y,w)|0)+x|0;G=1;do{T=+h[l+(S+G<<3)>>3];do{if(T!=0.0){U=T*+h[g>>3];M=c[d>>2]|0;if((M|0)<1){break}O=(fa(G,s)|0)+t|0;V=1;do{Z=o+(E+V<<3)|0;h[Z>>3]=+h[Z>>3]+U*+h[j+(O+V<<3)>>3];V=V+1|0;}while((V|0)<=(M|0))}}while(0);G=G+1|0;}while((G|0)<=(N|0))}N=Y+1|0;if((N|0)>(D|0)){break}X=X+1|0;Y=N}i=q;return 0}else{if(!A){if(F){i=q;return 0}else{_=a;$=1}while(1){if((_|0)>=1){N=(fa($,w)|0)+x|0;G=$+v|0;E=1;do{S=c[f>>2]|0;if((S|0)<1){aa=0.0}else{M=(fa(E,s)|0)+t|0;V=1;T=0.0;while(1){U=T+ +h[j+(M+V<<3)>>3]*+h[l+(G+(fa(V,u)|0)<<3)>>3];O=V+1|0;if((O|0)>(S|0)){aa=U;break}else{T=U;V=O}}}T=+h[n>>3];U=aa*+h[g>>3];V=o+(N+E<<3)|0;if(T==0.0){ba=U}else{ba=U+T*+h[V>>3]}h[V>>3]=ba;E=E+1|0;}while((E|0)<=(_|0))}E=$+1|0;if((E|0)>(D|0)){break}_=c[d>>2]|0;$=E}i=q;return 0}if(F){i=q;return 0}else{ca=0;da=1}while(1){a=o+((fa(w,ca)|0)<<3)|0;T=+h[n>>3];c:do{if(T==0.0){E=c[d>>2]|0;if((E|0)<1){break}B$a(a|0,0,E<<3|0)|0}else{if(!(T!=1.0)){break}E=c[d>>2]|0;if((E|0)<1){break}N=(fa(da,w)|0)+x|0;U=T;G=1;while(1){V=o+(N+G<<3)|0;h[V>>3]=U*+h[V>>3];V=G+1|0;if((V|0)>(E|0)){break c}U=+h[n>>3];G=V}}}while(0);a=c[f>>2]|0;if((a|0)>=1){G=da+v|0;E=(fa(da,w)|0)+x|0;N=1;do{T=+h[l+(G+(fa(N,u)|0)<<3)>>3];do{if(T!=0.0){U=T*+h[g>>3];V=c[d>>2]|0;if((V|0)<1){break}S=(fa(N,s)|0)+t|0;M=1;do{O=o+(E+M<<3)|0;h[O>>3]=+h[O>>3]+U*+h[j+(S+M<<3)>>3];M=M+1|0;}while((M|0)<=(V|0))}}while(0);N=N+1|0;}while((N|0)<=(a|0))}a=da+1|0;if((a|0)>(D|0)){break}ca=ca+1|0;da=a}i=q;return 0}}}while(0);Db(194808,r|0)|0;i=q;return 0}function Uqa(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0.0,O=0,P=0,Q=0.0,R=0,S=0.0,T=0.0,U=0,V=0.0,W=0,X=0.0,Y=0,Z=0,_=0;o=i;i=i+8|0;p=o;q=c[l>>2]|0;r=~q;s=c[n>>2]|0;t=~s;u=(vya(a,194816)|0)!=0;v=c[(u?f:g)>>2]|0;w=vya(e,194824)|0;x=vya(b,194832)|0;c[p>>2]=0;do{if(u){y=4}else{if((vya(a,194840)|0)!=0){y=4;break}c[p>>2]=1}}while(0);a:do{if((y|0)==4){do{if((x|0)==0){if((vya(b,194816)|0)!=0){break}c[p>>2]=2;break a}}while(0);do{if((vya(d,194824)|0)==0){if((vya(d,194848)|0)!=0){break}if((vya(d,194856)|0)!=0){break}c[p>>2]=3;break a}}while(0);do{if((vya(e,194832)|0)==0){if((vya(e,194824)|0)!=0){break}c[p>>2]=4;break a}}while(0);a=c[f>>2]|0;if((a|0)<0){c[p>>2]=5;break}z=c[g>>2]|0;if((z|0)<0){c[p>>2]=6;break}if((c[l>>2]|0)<(((v|0)>1?v:1)|0)){c[p>>2]=9;break}if((c[n>>2]|0)<(((a|0)>1?a:1)|0)){c[p>>2]=11;break}if((c[p>>2]|0)!=0){break}if((a|0)==0|(z|0)==0){i=o;return 0}if(+h[j>>3]==0.0){if((z|0)<1){i=o;return 0}else{A=a;B=0;C=2}while(1){if((A|0)>=1){B$a(m+((fa(s,B)|0)<<3)|0,0,A<<3|0)|0}if((C|0)>(z|0)){break}A=c[f>>2]|0;B=B+1|0;C=C+1|0}i=o;return 0}z=(vya(d,194824)|0)!=0;a=(x|0)!=0;D=c[g>>2]|0;if(u){E=(D|0)<1;if(!z){if(a){if(E){i=o;return 0}F=(w|0)==0;G=1;do{H=c[f>>2]|0;if((H|0)>=1){I=(fa(G,s)|0)+t|0;J=1;do{K=m+(I+J<<3)|0;L=+h[j>>3]*+h[K>>3];M=J+ -1|0;if((M|0)<1){N=L}else{O=(fa(J,q)|0)+r|0;P=1;Q=L;while(1){L=Q- +h[k+(O+P<<3)>>3]*+h[m+(I+P<<3)>>3];R=P+1|0;if((R|0)>(M|0)){N=L;break}else{Q=L;P=R}}}if(F){S=N}else{S=N/+h[k+(J+r+(fa(J,q)|0)<<3)>>3]}h[K>>3]=S;J=J+1|0;}while((J|0)<=(H|0))}G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}if(E){i=o;return 0}G=(w|0)==0;F=1;do{H=c[f>>2]|0;b:do{if((H|0)>0){J=(fa(F,s)|0)+t|0;I=H;P=H;while(1){M=m+(J+P<<3)|0;Q=+h[j>>3]*+h[M>>3];O=P+1|0;if((O|0)>(I|0)){T=Q}else{R=(fa(P,q)|0)+r|0;U=O;L=Q;while(1){Q=L- +h[k+(R+U<<3)>>3]*+h[m+(J+U<<3)>>3];O=U+1|0;if((O|0)>(I|0)){T=Q;break}else{L=Q;U=O}}}if(G){V=T}else{V=T/+h[k+(P+r+(fa(P,q)|0)<<3)>>3]}h[M>>3]=V;U=P+ -1|0;if((U|0)<=0){break b}I=c[f>>2]|0;P=U}}}while(0);F=F+1|0;}while((F|0)<=(D|0));i=o;return 0}if(a){if(E){i=o;return 0}F=(w|0)==0;G=1;do{L=+h[j>>3];c:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}P=(fa(G,s)|0)+t|0;Q=L;I=1;while(1){J=m+(P+I<<3)|0;h[J>>3]=Q*+h[J>>3];J=I+1|0;if((J|0)>(H|0)){y=43;break c}Q=+h[j>>3];I=J}}else{y=43}}while(0);d:do{if((y|0)==43){y=0;I=c[f>>2]|0;if((I|0)<=0){break}H=(fa(G,s)|0)+t|0;if(F){P=I;while(1){J=m+(H+P<<3)|0;L=+h[J>>3];K=P+ -1|0;e:do{if(L!=0.0){if((K|0)<1){break d}U=(fa(P,q)|0)+r|0;Q=L;R=1;while(1){O=m+(H+R<<3)|0;h[O>>3]=+h[O>>3]-Q*+h[k+(U+R<<3)>>3];O=R+1|0;if((O|0)>(K|0)){break e}Q=+h[J>>3];R=O}}}while(0);if((K|0)>0){P=K}else{break d}}}else{W=I}while(1){P=m+(H+W<<3)|0;L=+h[P>>3];f:do{if(L!=0.0){Q=L/+h[k+(W+r+(fa(W,q)|0)<<3)>>3];h[P>>3]=Q;J=W+ -1|0;if((J|0)<1){break d}M=(fa(W,q)|0)+r|0;X=Q;R=1;while(1){U=m+(H+R<<3)|0;h[U>>3]=+h[U>>3]-X*+h[k+(M+R<<3)>>3];U=R+1|0;if((U|0)>(J|0)){Y=J;break f}X=+h[P>>3];R=U}}else{Y=W+ -1|0}}while(0);if((Y|0)>0){W=Y}else{break}}}}while(0);G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}if(E){i=o;return 0}G=(w|0)==0;F=1;do{L=+h[j>>3];g:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}I=(fa(F,s)|0)+t|0;X=L;P=1;while(1){K=m+(I+P<<3)|0;h[K>>3]=X*+h[K>>3];K=P+1|0;if((K|0)>(H|0)){y=64;break g}X=+h[j>>3];P=K}}else{y=64}}while(0);do{if((y|0)==64){y=0;P=c[f>>2]|0;if((P|0)<1){break}H=(fa(F,s)|0)+t|0;if(G){I=1;while(1){K=m+(H+I<<3)|0;L=+h[K>>3];h:do{if(L!=0.0){R=c[f>>2]|0;J=I+1|0;if((J|0)>(R|0)){Z=J;break}M=(fa(I,q)|0)+r|0;X=L;U=J;while(1){O=m+(H+U<<3)|0;h[O>>3]=+h[O>>3]-X*+h[k+(M+U<<3)>>3];O=U+1|0;if((O|0)>(R|0)){Z=J;break h}X=+h[K>>3];U=O}}else{Z=I+1|0}}while(0);if((Z|0)>(P|0)){break}else{I=Z}}}else{I=1;while(1){K=m+(H+I<<3)|0;L=+h[K>>3];i:do{if(L!=0.0){X=L/+h[k+(I+r+(fa(I,q)|0)<<3)>>3];h[K>>3]=X;U=c[f>>2]|0;J=I+1|0;if((J|0)>(U|0)){_=J;break}R=(fa(I,q)|0)+r|0;Q=X;M=J;while(1){O=m+(H+M<<3)|0;h[O>>3]=+h[O>>3]-Q*+h[k+(R+M<<3)>>3];O=M+1|0;if((O|0)>(U|0)){_=J;break i}Q=+h[K>>3];M=O}}else{_=I+1|0}}while(0);if((_|0)>(P|0)){break}else{I=_}}}}}while(0);F=F+1|0;}while((F|0)<=(D|0));i=o;return 0}if(!z){if(a){if((D|0)<=0){i=o;return 0}F=(w|0)==0;G=D;while(1){do{if(!F){L=1.0/+h[k+(G+r+(fa(G,q)|0)<<3)>>3];E=c[f>>2]|0;if((E|0)<1){break}I=(fa(G,s)|0)+t|0;P=1;do{H=m+(I+P<<3)|0;h[H>>3]=L*+h[H>>3];P=P+1|0;}while((P|0)<=(E|0))}}while(0);E=G+ -1|0;if((E|0)>=1){P=(fa(G,q)|0)+r|0;I=(fa(G,s)|0)+t|0;H=1;do{L=+h[k+(P+H<<3)>>3];do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}M=(fa(H,s)|0)+t|0;J=1;do{U=m+(M+J<<3)|0;h[U>>3]=+h[U>>3]-L*+h[m+(I+J<<3)>>3];J=J+1|0;}while((J|0)<=(K|0))}}while(0);H=H+1|0;}while((H|0)<=(E|0))}L=+h[j>>3];j:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}I=(fa(G,s)|0)+t|0;Q=L;P=1;while(1){K=m+(I+P<<3)|0;h[K>>3]=Q*+h[K>>3];K=P+1|0;if((K|0)>(H|0)){break j}Q=+h[j>>3];P=K}}}while(0);if((E|0)>0){G=E}else{break}}i=o;return 0}else{if((D|0)<1){i=o;return 0}G=(w|0)==0;F=1;while(1){do{if(!G){L=1.0/+h[k+(F+r+(fa(F,q)|0)<<3)>>3];z=c[f>>2]|0;if((z|0)<1){break}P=(fa(F,s)|0)+t|0;H=1;do{I=m+(P+H<<3)|0;h[I>>3]=L*+h[I>>3];H=H+1|0;}while((H|0)<=(z|0))}}while(0);E=c[g>>2]|0;z=F+1|0;if((z|0)<=(E|0)){H=(fa(F,q)|0)+r|0;P=(fa(F,s)|0)+t|0;I=z;do{L=+h[k+(H+I<<3)>>3];do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}J=(fa(I,s)|0)+t|0;M=1;do{U=m+(J+M<<3)|0;h[U>>3]=+h[U>>3]-L*+h[m+(P+M<<3)>>3];M=M+1|0;}while((M|0)<=(K|0))}}while(0);I=I+1|0;}while((I|0)<=(E|0))}L=+h[j>>3];k:do{if(L!=1.0){E=c[f>>2]|0;if((E|0)<1){break}I=(fa(F,s)|0)+t|0;Q=L;P=1;while(1){H=m+(I+P<<3)|0;h[H>>3]=Q*+h[H>>3];H=P+1|0;if((H|0)>(E|0)){break k}Q=+h[j>>3];P=H}}}while(0);if((z|0)>(D|0)){break}else{F=z}}i=o;return 0}}if(a){if((D|0)<1){i=o;return 0}F=(w|0)==0;G=1;do{L=+h[j>>3];l:do{if(L!=1.0){P=c[f>>2]|0;if((P|0)<1){break}E=(fa(G,s)|0)+t|0;Q=L;I=1;while(1){H=m+(E+I<<3)|0;h[H>>3]=Q*+h[H>>3];H=I+1|0;if((H|0)>(P|0)){break l}Q=+h[j>>3];I=H}}}while(0);z=G+ -1|0;if((z|0)>=1){I=(fa(G,q)|0)+r|0;P=(fa(G,s)|0)+t|0;E=1;do{H=k+(I+E<<3)|0;L=+h[H>>3];m:do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}M=(fa(E,s)|0)+t|0;Q=L;J=1;while(1){U=m+(P+J<<3)|0;h[U>>3]=+h[U>>3]-Q*+h[m+(M+J<<3)>>3];U=J+1|0;if((U|0)>(K|0)){break m}Q=+h[H>>3];J=U}}}while(0);E=E+1|0;}while((E|0)<=(z|0))}do{if(!F){L=1.0/+h[k+(G+r+(fa(G,q)|0)<<3)>>3];z=c[f>>2]|0;if((z|0)<1){break}E=(fa(G,s)|0)+t|0;P=1;do{I=m+(E+P<<3)|0;h[I>>3]=L*+h[I>>3];P=P+1|0;}while((P|0)<=(z|0))}}while(0);G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}else{if((D|0)<=0){i=o;return 0}G=(w|0)==0;F=D;do{L=+h[j>>3];n:do{if(L!=1.0){a=c[f>>2]|0;if((a|0)<1){break}z=(fa(F,s)|0)+t|0;Q=L;P=1;while(1){E=m+(z+P<<3)|0;h[E>>3]=Q*+h[E>>3];E=P+1|0;if((E|0)>(a|0)){break n}Q=+h[j>>3];P=E}}}while(0);P=c[g>>2]|0;a=F+1|0;if((a|0)<=(P|0)){z=(fa(F,q)|0)+r|0;E=(fa(F,s)|0)+t|0;I=a;do{a=k+(z+I<<3)|0;L=+h[a>>3];o:do{if(L!=0.0){H=c[f>>2]|0;if((H|0)<1){break}J=(fa(I,s)|0)+t|0;Q=L;K=1;while(1){M=m+(E+K<<3)|0;h[M>>3]=+h[M>>3]-Q*+h[m+(J+K<<3)>>3];M=K+1|0;if((M|0)>(H|0)){break o}Q=+h[a>>3];K=M}}}while(0);I=I+1|0;}while((I|0)<=(P|0))}do{if(!G){L=1.0/+h[k+(F+r+(fa(F,q)|0)<<3)>>3];P=c[f>>2]|0;if((P|0)<1){break}I=(fa(F,s)|0)+t|0;E=1;do{z=m+(I+E<<3)|0;h[z>>3]=L*+h[z>>3];E=E+1|0;}while((E|0)<=(P|0))}}while(0);F=F+ -1|0;}while((F|0)>0);i=o;return 0}}}while(0);Db(194864,p|0)|0;i=o;return 0}function Vqa(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;k=i;i=i+8|0;l=k;c[j>>2]=0;m=c[a>>2]|0;do{if((m|0)<0){c[j>>2]=-1;n=-1}else{if((c[b>>2]|0)<0){c[j>>2]=-2;n=-2;break}o=(m|0)>1?m:1;if((c[e>>2]|0)<(o|0)){c[j>>2]=-4;n=-4;break}if((c[h>>2]|0)<(o|0)){c[j>>2]=-7;n=-7;break}Xqa(a,a,d,e,f,j)|0;if((c[j>>2]|0)!=0){i=k;return 0}Yqa(194880,a,b,d,e,f,g,h,j)|0;i=k;return 0}}while(0);c[l>>2]=0-n;Db(194872,l|0)|0;i=k;return 0}function Wqa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0,I=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;o=c[e>>2]|0;p=~o;c[g>>2]=0;q=c[a>>2]|0;do{if((q|0)<0){c[g>>2]=-1;r=-1}else{s=c[b>>2]|0;if((s|0)<0){c[g>>2]=-2;r=-2;break}if((c[e>>2]|0)<(((q|0)>1?q:1)|0)){c[g>>2]=-4;r=-4;break}if((q|0)==0|(s|0)==0){i=j;return 0}t=+cya(194904);s=c[a>>2]|0;u=c[b>>2]|0;v=(s|0)>(u|0)?u:s;c[k>>2]=v;if((v|0)<1){i=j;return 0}else{w=s;x=1}while(1){c[l>>2]=1-x+w;s=x+ -1|0;v=fa(x,o)|0;u=x+p|0;y=u+v|0;z=d+(y<<3)|0;A=s+(Pqa(l,z,194912)|0)|0;c[f+(s<<2)>>2]=A;B=v+p|0;a:do{if(+h[d+(B+A<<3)>>3]!=0.0){if((A|0)!=(x|0)){Rqa(b,d+(s<<3)|0,e,d+(A+ -1<<3)|0,e)|0}C=c[a>>2]|0;if((x|0)>=(C|0)){break}D=+h[z>>3];h[n>>3]=D;if(!(D>=0.0)){E=-D}else{E=D}F=C-x|0;c[l>>2]=F;if(E>=t){h[n>>3]=1.0/D;Qqa(l,n,d+(x-o+v<<3)|0,194912)|0;break}if((F|0)<1){break}else{G=D;H=1}while(1){C=d+(y+H<<3)|0;h[C>>3]=+h[C>>3]/G;C=H+1|0;if((C|0)>(F|0)){break a}G=+h[z>>3];H=C}}else{if((c[g>>2]|0)!=0){break}c[g>>2]=x}}while(0);z=c[a>>2]|0;y=c[b>>2]|0;if((x|0)<(((z|0)>(y|0)?y:z)|0)){c[l>>2]=z-x;c[m>>2]=y-x;y=x+1|0;z=fa(y,o)|0;Sqa(l,m,194920,d+(B+y<<3)|0,194912,d+(u+z<<3)|0,e,d+(y+p+z<<3)|0,e)|0;I=y}else{I=x+1|0}if((I|0)>(c[k>>2]|0)){break}w=c[a>>2]|0;x=I}i=j;return 0}}while(0);c[k>>2]=0-r;Db(194896,k|0)|0;i=j;return 0}function Xqa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;h=i;i=i+48|0;j=h;k=h+8|0;l=h+16|0;m=h+24|0;n=h+32|0;o=h+40|0;p=c[e>>2]|0;q=~p;c[g>>2]=0;r=c[a>>2]|0;do{if((r|0)<0){c[g>>2]=-1;s=-1}else{t=c[b>>2]|0;if((t|0)<0){c[g>>2]=-2;s=-2;break}if((c[e>>2]|0)<(((r|0)>1?r:1)|0)){c[g>>2]=-4;s=-4;break}if((r|0)==0|(t|0)==0){i=h;return 0}t=194952;u=_qa(194936,194928,194944,a,b,t,t)|0;do{if((u|0)>=2){t=c[a>>2]|0;v=c[b>>2]|0;w=(t|0)>(v|0)?v:t;if((u|0)>=(w|0)){break}c[j>>2]=w;c[m>>2]=1;if((w|0)>0){x=v;y=t;z=1}else{i=h;return 0}while(1){t=((y|0)>(x|0)?x:y)-z+1|0;c[n>>2]=(t|0)<=(u|0)?t:u;c[k>>2]=y+1-z;Wqa(k,n,d+(z+q+(fa(z,p)|0)<<3)|0,e,f+(z+ -1<<2)|0,o)|0;do{if((c[g>>2]|0)==0){t=c[o>>2]|0;if((t|0)<=0){break}c[g>>2]=t+ -1+(c[m>>2]|0)}}while(0);t=c[a>>2]|0;c[l>>2]=t;v=c[m>>2]|0;w=v+ -1|0;A=w+(c[n>>2]|0)|0;B=(t|0)<=(A|0)?t:A;c[k>>2]=B;if((v|0)<=(B|0)){t=v;do{v=f+(t+ -1<<2)|0;c[v>>2]=(c[v>>2]|0)+w;t=t+1|0;}while((t|0)<=(B|0))}c[k>>2]=w;c[l>>2]=A;Zqa(k,d,e,m,l,f,194936)|0;B=c[m>>2]|0;t=c[n>>2]|0;v=t+B|0;C=c[b>>2]|0;do{if((v|0)>(C|0)){D=B}else{c[k>>2]=1-B-t+C;c[l>>2]=v+ -1;Zqa(k,d+((fa(v,p)|0)-p<<3)|0,e,m,l,f,194936)|0;E=c[m>>2]|0;F=c[n>>2]|0;c[k>>2]=(c[b>>2]|0)+1-E-F;G=E+q|0;Uqa(194960,194968,194976,194992,n,k,195e3,d+(G+(fa(E,p)|0)<<3)|0,e,d+(G+(fa(F+E|0,p)|0)<<3)|0,e)|0;E=c[m>>2]|0;F=c[n>>2]|0;G=F+E|0;H=c[a>>2]|0;if((G|0)>(H|0)){D=E;break}c[k>>2]=1-E-F+H;c[l>>2]=(c[b>>2]|0)+1-E-F;F=fa(G,p)|0;H=194976;Tqa(H,H,k,l,n,195008,d+((fa(E,p)|0)+q+G<<3)|0,e,d+(E+q+F<<3)|0,e,195e3,d+(G+q+F<<3)|0,e)|0;D=c[m>>2]|0}}while(0);v=D+u|0;c[m>>2]=v;if((v|0)>(c[j>>2]|0)){break}x=c[b>>2]|0;y=c[a>>2]|0;z=v}i=h;return 0}}while(0);Wqa(a,b,d,e,f,g)|0;i=h;return 0}}while(0);c[j>>2]=0-s;Db(194928,j|0)|0;i=h;return 0}function Yqa(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0;l=i;i=i+8|0;m=l;c[k>>2]=0;n=(vya(a,195016)|0)!=0;do{if(n){o=5}else{if((vya(a,195024)|0)!=0){o=5;break}if((vya(a,195032)|0)!=0){o=5;break}c[k>>2]=-1;p=-1}}while(0);do{if((o|0)==5){a=c[b>>2]|0;if((a|0)<0){c[k>>2]=-2;p=-2;break}q=c[d>>2]|0;if((q|0)<0){c[k>>2]=-3;p=-3;break}r=(a|0)>1?a:1;if((c[f>>2]|0)<(r|0)){c[k>>2]=-5;p=-5;break}if((c[j>>2]|0)<(r|0)){c[k>>2]=-8;p=-8;break}r=c[k>>2]|0;if((r|0)!=0){p=r;break}if((a|0)==0|(q|0)==0){i=l;return 0}if(n){q=195048;Zqa(d,h,j,q,b,g,q)|0;Uqa(195056,195064,195072,195088,b,d,195096,e,f,h,j)|0;Uqa(195056,195104,195072,195112,b,d,195096,e,f,h,j)|0;i=l;return 0}else{Uqa(195056,195104,195128,195112,b,d,195096,e,f,h,j)|0;Uqa(195056,195064,195128,195088,b,d,195096,e,f,h,j)|0;Zqa(d,h,j,195048,b,g,195144)|0;i=l;return 0}}}while(0);c[m>>2]=0-p;Db(195040,m|0)|0;i=l;return 0}function Zqa(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0;k=i;l=c[d>>2]|0;d=~l;m=c[j>>2]|0;do{if((m|0)>0){n=c[e>>2]|0;o=n;p=f;q=1;r=n}else{if((m|0)<0){n=c[f>>2]|0;o=n;p=e;q=-1;r=(fa(1-n|0,m)|0)+1|0;break}else{i=k;return 0}}}while(0);e=c[p>>2]|0;p=c[a>>2]|0;f=((p|0)/32|0)<<5;if((f|0)<1){s=m;t=p}else{p=(q|0)<0;n=p?(o|0)>=(e|0):(o|0)<=(e|0);u=m;m=1;while(1){if(n){v=m+31|0;if(p){w=u;x=o;y=r;while(1){z=c[g+(y+ -1<<2)>>2]|0;if((z|0)==(x|0)){A=w}else{B=x+d|0;C=z+d|0;z=m;do{D=fa(z,l)|0;E=b+(B+D<<3)|0;F=+h[E>>3];G=b+(C+D<<3)|0;h[E>>3]=+h[G>>3];h[G>>3]=F;z=z+1|0;}while((z|0)<=(v|0));A=c[j>>2]|0}z=x+q|0;if((z|0)<(e|0)){H=A;break}else{w=A;x=z;y=A+y|0}}}else{y=u;x=o;w=r;while(1){z=c[g+(w+ -1<<2)>>2]|0;if((z|0)==(x|0)){I=y}else{C=x+d|0;B=z+d|0;z=m;do{G=fa(z,l)|0;E=b+(C+G<<3)|0;F=+h[E>>3];D=b+(B+G<<3)|0;h[E>>3]=+h[D>>3];h[D>>3]=F;z=z+1|0;}while((z|0)<=(v|0));I=c[j>>2]|0}z=x+q|0;if((z|0)>(e|0)){H=I;break}else{y=I;x=z;w=I+w|0}}}}else{H=u}w=m+32|0;if((w|0)>(f|0)){break}else{u=H;m=w}}s=H;t=c[a>>2]|0}if((f|0)==(t|0)){i=k;return 0}t=f|1;f=(q|0)<0;if(!(f?(o|0)>=(e|0):(o|0)<=(e|0))){i=k;return 0}if(f){f=s;H=o;m=r;while(1){u=c[g+(m+ -1<<2)>>2]|0;do{if((u|0)==(H|0)){J=f}else{I=c[a>>2]|0;if((t|0)>(I|0)){J=f;break}A=H+d|0;p=u+d|0;n=t;do{w=fa(n,l)|0;x=b+(A+w<<3)|0;F=+h[x>>3];y=b+(p+w<<3)|0;h[x>>3]=+h[y>>3];h[y>>3]=F;n=n+1|0;}while((n|0)<=(I|0));J=c[j>>2]|0}}while(0);u=H+q|0;if((u|0)<(e|0)){break}else{f=J;H=u;m=J+m|0}}i=k;return 0}else{m=s;s=o;o=r;while(1){r=c[g+(o+ -1<<2)>>2]|0;do{if((r|0)==(s|0)){K=m}else{J=c[a>>2]|0;if((t|0)>(J|0)){K=m;break}H=s+d|0;f=r+d|0;u=t;do{I=fa(u,l)|0;n=b+(H+I<<3)|0;F=+h[n>>3];p=b+(f+I<<3)|0;h[n>>3]=+h[p>>3];h[p>>3]=F;u=u+1|0;}while((u|0)<=(J|0));K=c[j>>2]|0}}while(0);r=s+q|0;if((r|0)>(e|0)){break}else{m=K;s=r;o=K+o|0}}i=k;return 0}return 0}function _qa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=x$a(d|0)|0;switch(c[b>>2]|0){case 11:{q=$qa(195408,195392,195400)|0;i=k;return q|0};case 16:case 15:case 14:case 13:case 12:{q=ara(b,d,e,f,g,h,j)|0;i=k;return q|0};case 6:{h=c[f>>2]|0;f=c[g>>2]|0;q=~~(+(((h|0)>(f|0)?f:h)|0)*1.600000023841858);i=k;return q|0};case 7:{q=1;i=k;return q|0};case 8:{q=50;i=k;return q|0};case 9:{q=25;i=k;return q|0};case 10:{q=$qa(195384,195392,195400)|0;i=k;return q|0};case 4:{q=6;i=k;return q|0};case 5:{q=2;i=k;return q|0};case 3:case 2:case 1:{h=o;EOa(h,d,1,p);p=a[h]|0;do{if((p+ -97<<24>>24&255)<26){d=p+ -32<<24>>24;a[h]=d;f=o+1|0;e=a[f]|0;if((e+ -97<<24>>24&255)<26){a[f]=e+ -32<<24>>24}e=o+2|0;f=a[e]|0;if((f+ -97<<24>>24&255)<26){a[e]=f+ -32<<24>>24}f=o+3|0;e=a[f]|0;if((e+ -97<<24>>24&255)<26){a[f]=e+ -32<<24>>24}e=o+4|0;f=a[e]|0;if((f+ -97<<24>>24&255)<26){a[e]=f+ -32<<24>>24}f=o+5|0;e=a[f]|0;if(!((e+ -97<<24>>24&255)<26)){r=d;break}a[f]=e+ -32<<24>>24;r=d}else{r=p}}while(0);p=r<<24>>24==83;h=r<<24>>24==68;d=p|h;if(!(r<<24>>24==67|r<<24>>24==68|r<<24>>24==83|r<<24>>24==90)){q=1;i=k;return q|0}e=l;EOa(e,o+1|0,1,2);l=m;EOa(l,o+3|0,1,3);o=n;EOa(o,m+1|0,1,2);m=c[b>>2]|0;if((m|0)==3){if((DOa(e,195152,1,2)|0)==0){if((DOa(l,195168,1,3)|0)==0){q=128;i=k;return q|0}if((DOa(l,195176,1,3)|0)==0){q=128;i=k;return q|0}if((DOa(l,195184,1,3)|0)==0){q=128;i=k;return q|0}if((DOa(l,195192,1,3)|0)==0){q=128;i=k;return q|0}if((DOa(l,195200,1,3)|0)==0){q=128;i=k;return q|0}b=(DOa(l,195208,1,3)|0)==0;q=b?128:0;i=k;return q|0}if((DOa(e,195232,1,2)|0)==0){if(!(r<<24>>24==68|r<<24>>24==83)){q=0;i=k;return q|0}b=(DOa(l,195240,1,3)|0)==0;q=b?32:0;i=k;return q|0}if(r<<24>>24==68|r<<24>>24==83){s=141}else if(r<<24>>24==67|r<<24>>24==90){s=138}else{q=0;i=k;return q|0}do{if((s|0)==138){if((DOa(e,195256,1,2)|0)==0){b=(DOa(l,195240,1,3)|0)==0;q=b?32:0;i=k;return q|0}else{if(r<<24>>24==67|r<<24>>24==90){break}else if(r<<24>>24==68|r<<24>>24==83){s=141;break}else{q=0}i=k;return q|0}}}while(0);do{if((s|0)==141){if((DOa(e,195264,1,2)|0)!=0){if(r<<24>>24==67|r<<24>>24==90){break}else{q=0}i=k;return q|0}if((a[l]|0)!=71){q=0;i=k;return q|0}do{if((DOa(o,195272,1,2)|0)!=0){if((DOa(o,195280,1,2)|0)==0){break}if((DOa(o,195288,1,2)|0)==0){break}if((DOa(o,195296,1,2)|0)==0){break}if((DOa(o,195304,1,2)|0)==0){break}if((DOa(o,195312,1,2)|0)==0){break}if((DOa(o,195320,1,2)|0)==0){break}else{q=0}i=k;return q|0}}while(0);q=128;i=k;return q|0}}while(0);if((DOa(e,195328,1,2)|0)!=0){q=0;i=k;return q|0}if((a[l]|0)!=71){q=0;i=k;return q|0}do{if((DOa(o,195272,1,2)|0)!=0){if((DOa(o,195280,1,2)|0)==0){break}if((DOa(o,195288,1,2)|0)==0){break}if((DOa(o,195296,1,2)|0)==0){break}if((DOa(o,195304,1,2)|0)==0){break}if((DOa(o,195312,1,2)|0)==0){break}if((DOa(o,195320,1,2)|0)==0){break}else{q=0}i=k;return q|0}}while(0);q=128;i=k;return q|0}else if((m|0)==2){if((DOa(e,195152,1,2)|0)==0){if((DOa(l,195168,1,3)|0)==0){q=2;i=k;return q|0}if((DOa(l,195176,1,3)|0)==0){q=2;i=k;return q|0}if((DOa(l,195184,1,3)|0)==0){q=2;i=k;return q|0}if((DOa(l,195192,1,3)|0)==0){q=2;i=k;return q|0}if((DOa(l,195200,1,3)|0)==0){q=2;i=k;return q|0}if((DOa(l,195208,1,3)|0)==0){q=2;i=k;return q|0}q=2;i=k;return q|0}if((DOa(e,195232,1,2)|0)==0){m=(DOa(l,195160,1,3)|0)==0;if(m|(p|h)^1){q=m?8:2;i=k;return q|0}q=2;i=k;return q|0}if(r<<24>>24==67|r<<24>>24==90){s=91}else if(r<<24>>24==68|r<<24>>24==83){s=94}else{q=2;i=k;return q|0}do{if((s|0)==91){if((DOa(e,195256,1,2)|0)==0){q=2;i=k;return q|0}else{if(r<<24>>24==67|r<<24>>24==90){break}else if(r<<24>>24==68|r<<24>>24==83){s=94;break}else{q=2}i=k;return q|0}}}while(0);do{if((s|0)==94){if((DOa(e,195264,1,2)|0)!=0){if(r<<24>>24==67|r<<24>>24==90){break}else{q=2}i=k;return q|0}m=a[l]|0;if(m<<24>>24==71){if((DOa(o,195272,1,2)|0)==0){q=2;i=k;return q|0}if((DOa(o,195280,1,2)|0)==0){q=2;i=k;return q|0}if((DOa(o,195288,1,2)|0)==0){q=2;i=k;return q|0}if((DOa(o,195296,1,2)|0)==0){q=2;i=k;return q|0}if((DOa(o,195304,1,2)|0)==0){q=2;i=k;return q|0}if((DOa(o,195312,1,2)|0)==0){q=2;i=k;return q|0}q=2;i=k;return q|0}else if(m<<24>>24==77){if((DOa(o,195272,1,2)|0)==0){q=2;i=k;return q|0}if((DOa(o,195280,1,2)|0)==0){q=2;i=k;return q|0}if((DOa(o,195288,1,2)|0)==0){q=2;i=k;return q|0}if((DOa(o,195296,1,2)|0)==0){q=2;i=k;return q|0}if((DOa(o,195304,1,2)|0)==0){q=2;i=k;return q|0}if((DOa(o,195312,1,2)|0)==0){q=2;i=k;return q|0}q=2;i=k;return q|0}else{q=2;i=k;return q|0}}}while(0);if((DOa(e,195328,1,2)|0)!=0){q=2;i=k;return q|0}m=a[l]|0;if(m<<24>>24==77){if((DOa(o,195272,1,2)|0)==0){q=2;i=k;return q|0}if((DOa(o,195280,1,2)|0)==0){q=2;i=k;return q|0}if((DOa(o,195288,1,2)|0)==0){q=2;i=k;return q|0}if((DOa(o,195296,1,2)|0)==0){q=2;i=k;return q|0}if((DOa(o,195304,1,2)|0)==0){q=2;i=k;return q|0}if((DOa(o,195312,1,2)|0)==0){q=2;i=k;return q|0}q=2;i=k;return q|0}else if(m<<24>>24==71){if((DOa(o,195272,1,2)|0)==0){q=2;i=k;return q|0}if((DOa(o,195280,1,2)|0)==0){q=2;i=k;return q|0}if((DOa(o,195288,1,2)|0)==0){q=2;i=k;return q|0}if((DOa(o,195296,1,2)|0)==0){q=2;i=k;return q|0}if((DOa(o,195304,1,2)|0)==0){q=2;i=k;return q|0}if((DOa(o,195312,1,2)|0)==0){q=2;i=k;return q|0}q=2;i=k;return q|0}else{q=2;i=k;return q|0}}else{if((DOa(e,195152,1,2)|0)==0){if((DOa(l,195160,1,3)|0)==0){q=64;i=k;return q|0}if((DOa(l,195168,1,3)|0)==0){q=32;i=k;return q|0}if((DOa(l,195176,1,3)|0)==0){q=32;i=k;return q|0}if((DOa(l,195184,1,3)|0)==0){q=32;i=k;return q|0}if((DOa(l,195192,1,3)|0)==0){q=32;i=k;return q|0}if((DOa(l,195200,1,3)|0)==0){q=32;i=k;return q|0}if((DOa(l,195208,1,3)|0)==0){q=32;i=k;return q|0}m=(DOa(l,195216,1,3)|0)==0;q=m?64:1;i=k;return q|0}if((DOa(e,195224,1,2)|0)==0){m=(DOa(l,195160,1,3)|0)==0;q=m?64:1;i=k;return q|0}if((DOa(e,195232,1,2)|0)==0){m=(DOa(l,195160,1,3)|0)==0;if(m|d^1){q=m?64:1;i=k;return q|0}m=(DOa(l,195240,1,3)|0)==0;if(m){q=m?32:1;i=k;return q|0}m=(DOa(l,195248,1,3)|0)==0;q=m?64:1;i=k;return q|0}do{if(r<<24>>24==67|r<<24>>24==90){if((DOa(e,195256,1,2)|0)!=0){if(r<<24>>24==67|r<<24>>24==90){s=48;break}else if(r<<24>>24==68|r<<24>>24==83){s=29;break}else{break}}if((DOa(l,195160,1,3)|0)==0){q=64;i=k;return q|0}if((DOa(l,195240,1,3)|0)==0){q=32;i=k;return q|0}m=(DOa(l,195248,1,3)|0)==0;q=m?64:1;i=k;return q|0}else if(r<<24>>24==68|r<<24>>24==83){s=29}}while(0);do{if((s|0)==29){if((DOa(e,195264,1,2)|0)!=0){if(r<<24>>24==67|r<<24>>24==90){s=48;break}else{break}}m=a[l]|0;if(m<<24>>24==71){do{if((DOa(o,195272,1,2)|0)!=0){if((DOa(o,195280,1,2)|0)==0){break}if((DOa(o,195288,1,2)|0)==0){break}if((DOa(o,195296,1,2)|0)==0){break}if((DOa(o,195304,1,2)|0)==0){break}if((DOa(o,195312,1,2)|0)==0){break}if((DOa(o,195320,1,2)|0)==0){break}else{q=1}i=k;return q|0}}while(0);q=32;i=k;return q|0}else if(m<<24>>24==77){do{if((DOa(o,195272,1,2)|0)!=0){if((DOa(o,195280,1,2)|0)==0){break}if((DOa(o,195288,1,2)|0)==0){break}if((DOa(o,195296,1,2)|0)==0){break}if((DOa(o,195304,1,2)|0)==0){break}if((DOa(o,195312,1,2)|0)==0){break}if((DOa(o,195320,1,2)|0)==0){break}else{q=1}i=k;return q|0}}while(0);q=32;i=k;return q|0}else{q=1;i=k;return q|0}}}while(0);do{if((s|0)==48){if((DOa(e,195328,1,2)|0)!=0){break}m=a[l]|0;if(m<<24>>24==77){do{if((DOa(o,195272,1,2)|0)!=0){if((DOa(o,195280,1,2)|0)==0){break}if((DOa(o,195288,1,2)|0)==0){break}if((DOa(o,195296,1,2)|0)==0){break}if((DOa(o,195304,1,2)|0)==0){break}if((DOa(o,195312,1,2)|0)==0){break}if((DOa(o,195320,1,2)|0)==0){break}else{q=1}i=k;return q|0}}while(0);q=32;i=k;return q|0}else if(m<<24>>24==71){do{if((DOa(o,195272,1,2)|0)!=0){if((DOa(o,195280,1,2)|0)==0){break}if((DOa(o,195288,1,2)|0)==0){break}if((DOa(o,195296,1,2)|0)==0){break}if((DOa(o,195304,1,2)|0)==0){break}if((DOa(o,195312,1,2)|0)==0){break}if((DOa(o,195320,1,2)|0)==0){break}else{q=1}i=k;return q|0}}while(0);q=32;i=k;return q|0}else{q=1;i=k;return q|0}}}while(0);if((DOa(e,195336,1,2)|0)==0){if((DOa(l,195160,1,3)|0)!=0){q=1;i=k;return q|0}q=(c[j>>2]|0)<65?1:32;i=k;return q|0}if((DOa(e,195344,1,2)|0)==0){if((DOa(l,195160,1,3)|0)!=0){q=1;i=k;return q|0}q=(c[g>>2]|0)<65?1:32;i=k;return q|0}if((DOa(e,195312,1,2)|0)==0){g=(DOa(l,195216,1,3)|0)==0;q=g?64:1;i=k;return q|0}if((DOa(e,195352,1,2)|0)==0){g=(DOa(l,195360,1,3)|0)==0;q=g?64:1;i=k;return q|0}if(!(r<<24>>24==68|r<<24>>24==83)){q=1;i=k;return q|0}if((DOa(e,195368,1,2)|0)==0){i=k;return 1}else{q=1;i=k;return q|0}}break};default:{q=-1;i=k;return q|0}}return 0}function $qa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0.0,h=0.0,j=0.0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0;e=i;f=+g[d>>2];h=+g[b>>2];do{if(!(f/h<=f)){j=-f/h;if(j>=h){k=0;break}l=f/(f+j);if(l!=h){k=0;break}j=f/l;if(j>=h){k=0;break}m=h+l;if(m!=h){k=0;break}n=f/m;if(n<=f){k=0;break}m=j*n;if(m>=h){k=0;break}j=n*n;if(j<=f){k=0;break}if((c[a>>2]|0)==0){k=1;break}n=j+m;o=j/j;p=h*j;q=l*m;l=j/m;if(n==n&0.0==0.0|l==l&0.0==0.0|o==o&0.0==0.0|p==p&0.0==0.0|q==q&0.0==0.0){k=0;break}p=q*0.0;k=(p!=p|0.0!=0.0)&1}else{k=0}}while(0);i=e;return k|0}function ara(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+8|0;e=j;d=c[a>>2]|0;if((d|0)==16|(d|0)==13|(d|0)==15){b=(c[h>>2]|0)-(c[f>>2]|0)+1|0;if((b|0)>149){g[e>>2]=+da(+(+(b|0)))/.6931471805599453;f=(b|0)/(COa(e)|0)|0;k=c[a>>2]|0;l=(f|0)>10?f:10}else{k=d;l=(b|0)>59?10:(b|0)>29?4:2}f=(b|0)>5999?256:(b|0)>2999?128:(b|0)>589?64:l;l=f-((f|0)%2|0)|0;m=k;n=b;o=(l|0)>2?l:2}else{m=d;n=0;o=0}switch(m|0){case 14:{p=14;i=j;return p|0};case 12:{p=75;i=j;return p|0};case 16:{m=(o|0)>13;i=j;return(m?2:m&1)|0};case 13:{if((n|0)<501){p=o;i=j;return p|0}p=(o*3|0)/2|0;i=j;return p|0};case 15:{p=o;i=j;return p|0};default:{p=-1;i=j;return p|0}}return 0}function bra(a){a=a|0;var b=0,c=0;b=i;i=i+8|0;c=cra(a,0,0)|0;i=b;return c|0}function cra(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;i=i+24|0;e=dra(a,b,c,0)|0;i=d;return e|0}function dra(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+64|0;h=b;b=d;d=e;e=f;do{if((b|0)!=0){j=oe[c[b>>2]&127](500)|0;if((j|0)==0){break}f=j+12|0;c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2]}else{j=V_a(500)|0;if((j|0)==0){break}f=j+12|0;c[f>>2]=29;c[f+4>>2]=49;c[f+8>>2]=1253}}while(0);b=j;if((j|0)==0){k=b;l=k;i=g;return l|0}c[b+8>>2]=0;c[j+32>>2]=0;c[j+380>>2]=16;c[j+392>>2]=oe[c[j+12>>2]&127](c[j+380>>2]<<4)|0;b=j+12|0;if((c[j+392>>2]|0)==0){le[c[b+8>>2]&2047](j);k=0;l=k;i=g;return l|0}c[j+44>>2]=oe[c[b>>2]&127](1024)|0;b=j;if((c[j+44>>2]|0)==0){le[c[b+20>>2]&2047](c[j+392>>2]|0);le[c[j+20>>2]&2047](j);k=0;l=k;i=g;return l|0}c[j+48>>2]=(c[b+44>>2]|0)+1024;do{if((e|0)!=0){c[j+356>>2]=e}else{c[j+356>>2]=osa(j+12|0)|0;if((c[j+356>>2]|0)!=0){break}le[c[j+20>>2]&2047](c[j+44>>2]|0);le[c[j+20>>2]&2047](c[j+392>>2]|0);le[c[j+20>>2]&2047](j);k=0;l=k;i=g;return l|0}}while(0);c[j+376>>2]=0;c[j+368>>2]=0;c[j+304>>2]=0;c[j+468>>2]=0;c[j+464>>2]=0;c[j+124>>2]=0;c[j+248>>2]=0;a[j+472|0]=33;a[j+236|0]=0;a[j+237|0]=0;c[j+396>>2]=0;c[j+400>>2]=0;a[j+404|0]=0;psa(j+416|0,j+12|0);psa(j+440|0,j+12|0);fra(j,h);do{if((h|0)!=0){if((c[j+232>>2]|0)!=0){break}ira(j);k=0;l=k;i=g;return l|0}}while(0);if((d|0)!=0){a[j+236|0]=1;c[j+228>>2]=Jsa()|0;a[j+472|0]=a[d]|0}else{c[j+228>>2]=Asa()|0}k=j;l=k;i=g;return l|0}function era(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+24|0;d=a;a=c[d>>2]|0;a:do{if((c[d+4>>2]|0)!=0){e=a;while(1){if((e|0)==0){break a}f=c[e>>2]|0;c[e>>2]=c[d+4>>2];c[d+4>>2]=e;e=f}}else{c[d+4>>2]=a}}while(0);c[d>>2]=0;c[d+16>>2]=0;c[d+12>>2]=0;c[d+8>>2]=0;i=b;return}function fra(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=d;c[f+280>>2]=36;Sua(f+256|0);if((b|0)!=0){g=gra(f+416|0,b)|0}else{g=0}c[f+232>>2]=g;c[f+360>>2]=0;Bsa(f+148|0,f+144|0,0)|0;c[f>>2]=0;c[f+4>>2]=0;c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=0;c[f+64>>2]=0;c[f+68>>2]=0;c[f+72>>2]=0;c[f+76>>2]=0;c[f+80>>2]=0;c[f+84>>2]=0;c[f+88>>2]=0;c[f+92>>2]=0;c[f+96>>2]=0;c[f+100>>2]=0;c[f+104>>2]=0;c[f+108>>2]=0;c[f+112>>2]=0;c[f+116>>2]=f;c[f+120>>2]=0;c[f+128>>2]=0;c[f+132>>2]=0;c[f+136>>2]=0;c[f+140>>2]=0;c[f+24>>2]=c[f+8>>2];c[f+28>>2]=c[f+8>>2];c[f+36>>2]=0;c[f+40>>2]=0;c[f+344>>2]=0;c[f+348>>2]=0;c[f+316>>2]=0;c[f+320>>2]=0;c[f+324>>2]=0;c[f+328>>2]=0;c[f+332>>2]=0;c[f+336>>2]=0;c[f+340>>2]=0;a[f+352|0]=0;a[f+353|0]=0;g=f+408|0;c[g+0>>2]=0;c[g+4>>2]=0;c[f+284>>2]=0;c[f+288>>2]=0;c[f+292>>2]=0;c[f+296>>2]=0;c[f+300>>2]=0;a[f+308|0]=1;c[f+312>>2]=0;c[f+364>>2]=0;c[f+372>>2]=0;c[f+384>>2]=0;c[f+240>>2]=0;c[f+252>>2]=0;c[f+244>>2]=0;c[f+476>>2]=0;c[f+480>>2]=0;a[f+488|0]=0;a[f+489|0]=0;c[f+492>>2]=0;c[f+496>>2]=0;i=e;return}function gra(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+24|0;f=b;b=d;while(1){if((c[f+12>>2]|0)==(c[f+8>>2]|0)){if(!((xra(f)|0)<<24>>24!=0)){g=5;break}}d=a[b]|0;h=f+12|0;j=c[h>>2]|0;c[h>>2]=j+1;a[j]=d;d=b;b=d+1|0;if((a[d]|0)==0){g=6;break}}if((g|0)==5){k=0;l=k;i=e;return l|0}else if((g|0)==6){b=c[f+16>>2]|0;c[f+16>>2]=c[f+12>>2];k=b;l=k;i=e;return l|0}return 0}function hra(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+56|0;f=b;b=d;d=c[f+356>>2]|0;g=b;a:while(1){if((a[b]|0)==0){h=45;break}do{if((a[g]|0)!=12){if((a[g]|0)==0){break}j=c[f+428>>2]|0;k=f+416|0;if((a[g]|0)!=61){if((j|0)==(c[k+8>>2]|0)){if(!((xra(f+416|0)|0)<<24>>24!=0)){h=44;break a}}l=a[g]|0;m=f+428|0;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;g=g+1|0;continue a}if((j-(c[k+16>>2]|0)|0)==0){o=d+152|0}else{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((xra(f+416|0)|0)<<24>>24!=0)){h=19;break a}}k=f+428|0;j=c[k>>2]|0;c[k>>2]=j+1;a[j]=0;o=Ara(f,d+60|0,c[f+432>>2]|0,8)|0;if((o|0)==0){h=20;break a}if((c[o>>2]|0)==(c[f+432>>2]|0)){c[o>>2]=gra(d+80|0,c[o>>2]|0)|0;if((c[o>>2]|0)==0){h=23;break a}}c[f+428>>2]=c[f+432>>2]}b=g+1|0;while(1){if((a[b]|0)!=12){p=(a[b]|0)!=0}else{p=0}q=(c[f+428>>2]|0)==(c[f+424>>2]|0);if(!p){break}if(q){if(!((xra(f+416|0)|0)<<24>>24!=0)){h=32;break a}}j=a[b]|0;k=f+428|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=j;b=b+1|0}if(q){if(!((xra(f+416|0)|0)<<24>>24!=0)){h=36;break a}}j=f+428|0;l=c[j>>2]|0;c[j>>2]=l+1;a[l]=0;if((Era(f,o,0,c[f+432>>2]|0,f+372|0)|0)!=0){h=37;break a}c[f+428>>2]=c[f+432>>2];if((a[b]|0)!=0){b=b+1|0}g=b;continue a}}while(0);if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((xra(f+416|0)|0)<<24>>24!=0)){h=8;break}}l=f+428|0;j=c[l>>2]|0;c[l>>2]=j+1;a[j]=0;j=Ara(f,d,c[f+432>>2]|0,0)|0;if((j|0)!=0){a[j+32|0]=1}if((a[g]|0)!=0){g=g+1|0}b=g;c[f+428>>2]=c[f+432>>2]}if((h|0)==8){r=0;s=r;i=e;return s|0}else if((h|0)==19){r=0;s=r;i=e;return s|0}else if((h|0)==20){r=0;s=r;i=e;return s|0}else if((h|0)==23){r=0;s=r;i=e;return s|0}else if((h|0)==32){r=0;s=r;i=e;return s|0}else if((h|0)==36){r=0;s=r;i=e;return s|0}else if((h|0)==37){r=0;s=r;i=e;return s|0}else if((h|0)==44){r=0;s=r;i=e;return s|0}else if((h|0)==45){r=1;s=r;i=e;return s|0}return 0}function ira(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+40|0;e=b;if((e|0)==0){i=d;return}b=c[e+364>>2]|0;while(1){if((b|0)==0){f=e;if((c[e+368>>2]|0)==0){break}b=c[f+368>>2]|0;c[e+368>>2]=0}g=b;b=c[b>>2]|0;le[c[e+20>>2]&2047](c[g+36>>2]|0);jra(c[g+44>>2]|0,e);le[c[e+20>>2]&2047](g)}b=c[f+300>>2]|0;while(1){if((b|0)==0){h=e;if((c[e+304>>2]|0)==0){break}b=c[h+304>>2]|0;c[e+304>>2]=0}f=b;b=c[b+8>>2]|0;le[c[e+20>>2]&2047](f)}jra(c[h+376>>2]|0,e);jra(c[e+372>>2]|0,e);kra(e+416|0);kra(e+440|0);do{if((a[e+488|0]|0)==0){if((c[e+356>>2]|0)==0){break}lra(c[e+356>>2]|0,((c[e+476>>2]|0)!=0^1)&1,e+12|0)}}while(0);le[c[e+20>>2]&2047](c[e+392>>2]|0);le[c[e+20>>2]&2047](c[e+464>>2]|0);le[c[e+20>>2]&2047](c[e+8>>2]|0);le[c[e+20>>2]&2047](c[e+44>>2]|0);le[c[e+20>>2]&2047](c[e+396>>2]|0);le[c[e+20>>2]&2047](c[e+240>>2]|0);if((c[e+252>>2]|0)!=0){le[c[e+252>>2]&2047](c[e+244>>2]|0)}le[c[e+20>>2]&2047](e);i=d;return}function jra(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+24|0;e=a;a=b;while(1){b=e;if((b|0)==0){break}e=c[b+4>>2]|0;le[c[a+20>>2]&2047](c[b+16>>2]|0);le[c[a+20>>2]&2047](b)}i=d;return}function kra(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+32|0;d=a;a=c[d>>2]|0;while(1){if((a|0)==0){break}e=c[a>>2]|0;le[c[(c[d+20>>2]|0)+8>>2]&2047](a);a=e}a=c[d+4>>2]|0;while(1){if((a|0)==0){break}e=c[a>>2]|0;le[c[(c[d+20>>2]|0)+8>>2]&2047](a);a=e}i=b;return}function lra(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+40|0;f=e+24|0;g=a;a=b;b=d;yra(f,g+20|0);while(1){d=zra(f)|0;if((d|0)==0){break}if((c[d+16>>2]|0)==0){continue}le[c[b+8>>2]&2047](c[d+20>>2]|0)}Dra(g);Dra(g+132|0);Dra(g+20|0);Dra(g+40|0);Dra(g+60|0);kra(g+80|0);kra(g+104|0);if(!(a<<24>>24!=0)){h=b;j=h;k=j+8|0;l=k;m=c[l>>2]|0;n=g;o=n;le[m&2047](o);i=e;return}le[c[b+8>>2]&2047](c[g+184>>2]|0);le[c[b+8>>2]&2047](c[g+164>>2]|0);h=b;j=h;k=j+8|0;l=k;m=c[l>>2]|0;n=g;o=n;le[m&2047](o);i=e;return}function mra(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=a;a=(c[e+4>>2]|0)==(c[e>>2]|0);f=b;c[e>>2]=f;if(!a){i=d;return}c[e+4>>2]=f;i=d;return}function nra(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+24|0;f=a;c[f+52>>2]=b;c[f+56>>2]=d;i=e;return}function ora(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=d;d=e;e=f;f=c[h+480>>2]|0;do{if((f|0)==3){c[h+284>>2]=33;j=0;k=j;i=g;return k|0}else if((f|0)==0){if((c[h+476>>2]|0)!=0){break}if((pra(h)|0)<<24>>24!=0){break}c[h+284>>2]=1;j=0;k=j;i=g;return k|0}else if((f|0)==2){c[h+284>>2]=36;j=0;k=j;i=g;return k|0}}while(0);c[h+480>>2]=1;if((d|0)!=0){f=rra(h,d)|0;if((f|0)==0){j=0;k=j;i=g;return k|0}else{z$a(f|0,b|0,d|0)|0;j=sra(h,d,e)|0;k=j;i=g;return k|0}}a[h+484|0]=e;if((e|0)==0){j=1;k=j;i=g;return k|0}c[h+296>>2]=c[h+24>>2];c[h+40>>2]=c[h+28>>2];c[h+284>>2]=Ne[c[h+280>>2]&63](h,c[h+24>>2]|0,c[h+40>>2]|0,h+24|0)|0;e=h;if((c[h+284>>2]|0)!=0){c[h+292>>2]=c[e+288>>2];c[h+280>>2]=37;j=0;k=j;i=g;return k|0}d=c[e+480>>2]|0;if((d|0)==1|(d|0)==0){c[h+480>>2]=2}else if((d|0)==3){Oe[c[(c[h+144>>2]|0)+52>>2]&127](c[h+144>>2]|0,c[h+296>>2]|0,c[h+24>>2]|0,h+408|0);c[h+296>>2]=c[h+24>>2];j=2;k=j;i=g;return k|0}j=1;k=j;i=g;return k|0}function pra(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=b;if((c[e+496>>2]|0)==0){c[e+496>>2]=msa()|0}if((a[e+236|0]|0)!=0){f=hra(e,197192)|0;g=f;i=d;return g|0}else{f=1;g=f;i=d;return g|0}return 0}function qra(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;i=i+32|0;i=e;return c[a+284>>2]|0}function rra(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+72|0;e=a;a=b;b=c[e+480>>2]|0;if((b|0)==3){c[e+284>>2]=33;f=0;g=f;i=d;return g|0}else if((b|0)==2){c[e+284>>2]=36;f=0;g=f;i=d;return g|0}else{if((a|0)>((c[e+32>>2]|0)-(c[e+28>>2]|0)|0)){b=a+((c[e+28>>2]|0)-(c[e+24>>2]|0))|0;a=(c[e+24>>2]|0)-(c[e+8>>2]|0)|0;h=a;h=(h|0)>1024?1024:a;b=b+h|0;do{if((b|0)<=((c[e+32>>2]|0)-(c[e+8>>2]|0)|0)){if((h|0)>=((c[e+24>>2]|0)-(c[e+8>>2]|0)|0)){break}a=(c[e+24>>2]|0)-(c[e+8>>2]|0)-h|0;A$a(c[e+8>>2]|0,(c[e+8>>2]|0)+a|0,(c[e+28>>2]|0)-(c[e+24>>2]|0)+h|0)|0;j=e+28|0;c[j>>2]=(c[j>>2]|0)+(0-a);j=e+24|0;c[j>>2]=(c[j>>2]|0)+(0-a)}else{a=(c[e+32>>2]|0)-(c[e+24>>2]|0)|0;j=a;j=(j|0)==0?1024:a;do{j=j<<1;}while((j|0)<(b|0));a=oe[c[e+12>>2]&127](j)|0;if((a|0)==0){c[e+284>>2]=1;f=0;g=f;i=d;return g|0}c[e+32>>2]=a+j;if((c[e+24>>2]|0)!=0){k=(c[e+24>>2]|0)-(c[e+8>>2]|0)|0;l=k;l=(l|0)>1024?1024:k;z$a(a|0,(c[e+24>>2]|0)+(0-l)|0,(c[e+28>>2]|0)-(c[e+24>>2]|0)+l|0)|0;le[c[e+20>>2]&2047](c[e+8>>2]|0);c[e+8>>2]=a;c[e+28>>2]=(c[e+8>>2]|0)+((c[e+28>>2]|0)-(c[e+24>>2]|0))+l;c[e+24>>2]=(c[e+8>>2]|0)+l;break}else{c[e+28>>2]=a+((c[e+28>>2]|0)-(c[e+24>>2]|0));l=a;c[e+8>>2]=l;c[e+24>>2]=l;break}}}while(0);c[e+292>>2]=0;c[e+288>>2]=0;c[e+296>>2]=0}f=c[e+28>>2]|0;g=f;i=d;return g|0}return 0}function sra(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+48|0;g=b;b=d;d=e;e=1;h=c[g+480>>2]|0;do{if((h|0)==0){if((c[g+476>>2]|0)!=0){break}if((pra(g)|0)<<24>>24!=0){break}c[g+284>>2]=1;j=0;k=j;i=f;return k|0}else if((h|0)==2){c[g+284>>2]=36;j=0;k=j;i=f;return k|0}else if((h|0)==3){c[g+284>>2]=33;j=0;k=j;i=f;return k|0}}while(0);c[g+480>>2]=1;h=c[g+24>>2]|0;c[g+296>>2]=h;l=g+28|0;c[l>>2]=(c[l>>2]|0)+b;c[g+40>>2]=c[g+28>>2];l=g+36|0;c[l>>2]=(c[l>>2]|0)+b;a[g+484|0]=d;c[g+284>>2]=Ne[c[g+280>>2]&63](g,h,c[g+40>>2]|0,g+24|0)|0;h=g;if((c[g+284>>2]|0)!=0){c[g+292>>2]=c[h+288>>2];c[g+280>>2]=37;j=0;k=j;i=f;return k|0}b=c[h+480>>2]|0;do{if((b|0)==1|(b|0)==0){if((d|0)==0){break}c[g+480>>2]=2;j=e;k=j;i=f;return k|0}else if((b|0)==3){e=2}}while(0);Oe[c[(c[g+144>>2]|0)+52>>2]&127](c[g+144>>2]|0,c[g+296>>2]|0,c[g+24>>2]|0,g+408|0);c[g+296>>2]=c[g+24>>2];j=e;k=j;i=f;return k|0}function tra(a){a=a|0;var b=0;b=i;i=i+8|0;i=b;return c[a+284>>2]|0}function ura(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;do{if((c[d+288>>2]|0)!=0){if(!((c[d+288>>2]|0)>>>0>=(c[d+296>>2]|0)>>>0)){break}Oe[c[(c[d+144>>2]|0)+52>>2]&127](c[d+144>>2]|0,c[d+296>>2]|0,c[d+288>>2]|0,d+408|0);c[d+296>>2]=c[d+288>>2]}}while(0);i=b;return(c[d+408>>2]|0)+1|0}function vra(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+56|0;h=g+16|0;j=g+48|0;k=b;b=d;c[h>>2]=e;e=f;if((a[b+72|0]|0)!=0){Ke[c[k+80>>2]&15](c[k+4>>2]|0,c[h>>2]|0,e-(c[h>>2]|0)|0);i=g;return}f=k;if((b|0)==(c[k+144>>2]|0)){l=f+288|0;m=k+292|0}else{l=c[f+300>>2]|0;m=(c[k+300>>2]|0)+4|0}do{c[j>>2]=c[k+44>>2];ie[c[b+60>>2]&31](b,h,e,j,c[k+48>>2]|0);c[m>>2]=c[h>>2];Ke[c[k+80>>2]&15](c[k+4>>2]|0,c[k+44>>2]|0,(c[j>>2]|0)-(c[k+44>>2]|0)|0);c[l>>2]=c[h>>2];}while((c[h>>2]|0)!=(e|0));i=g;return}function wra(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=a;if(d>>>0>0&d>>>0<41){e=c[195416+(d<<2)>>2]|0;f=e;i=b;return f|0}else{e=0;f=e;i=b;return f|0}return 0}function xra(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+56|0;d=a;do{if((c[d+4>>2]|0)!=0){a=d;if((c[d+16>>2]|0)==0){c[d>>2]=c[a+4>>2];c[d+4>>2]=c[c[d+4>>2]>>2];c[c[d>>2]>>2]=0;c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+(c[(c[d>>2]|0)+4>>2]|0);c[d+12>>2]=c[d+16>>2];e=1;f=e;i=b;return f|0}if(((c[a+8>>2]|0)-(c[d+16>>2]|0)|0)>=(c[(c[d+4>>2]|0)+4>>2]|0)){break}a=c[c[d+4>>2]>>2]|0;c[c[d+4>>2]>>2]=c[d>>2];c[d>>2]=c[d+4>>2];c[d+4>>2]=a;z$a((c[d>>2]|0)+8|0,c[d+16>>2]|0,(c[d+8>>2]|0)-(c[d+16>>2]|0)|0)|0;c[d+12>>2]=(c[d>>2]|0)+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+(c[(c[d>>2]|0)+4>>2]|0);e=1;f=e;i=b;return f|0}}while(0);do{if((c[d>>2]|0)!=0){if((c[d+16>>2]|0)!=((c[d>>2]|0)+8|0)){g=11;break}a=(c[d+8>>2]|0)-(c[d+16>>2]|0)<<1;h=De[c[(c[d+20>>2]|0)+4>>2]&63](c[d>>2]|0,8+a|0)|0;if((h|0)!=0){c[d>>2]=h;c[(c[d>>2]|0)+4>>2]=a;c[d+12>>2]=(c[d>>2]|0)+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+a;break}e=0;f=e;i=b;return f|0}else{g=11}}while(0);if((g|0)==11){g=(c[d+8>>2]|0)-(c[d+16>>2]|0)|0;if((g|0)<1024){g=1024}else{g=g<<1}a=oe[c[c[d+20>>2]>>2]&127](8+g|0)|0;if((a|0)==0){e=0;f=e;i=b;return f|0}c[a+4>>2]=g;c[a>>2]=c[d>>2];c[d>>2]=a;if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){z$a(a+8|0,c[d+16>>2]|0,(c[d+12>>2]|0)-(c[d+16>>2]|0)|0)|0}c[d+12>>2]=a+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=a+8;c[d+8>>2]=a+8+g}e=1;f=e;i=b;return f|0}function yra(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=a;a=b;c[e>>2]=c[a>>2];c[e+4>>2]=(c[e>>2]|0)+(c[a+8>>2]<<2);i=d;return}function zra(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+24|0;d=a;while(1){if((c[d>>2]|0)==(c[d+4>>2]|0)){e=5;break}a=d;f=c[a>>2]|0;c[a>>2]=f+4;g=c[f>>2]|0;if((g|0)!=0){e=4;break}}if((e|0)==4){h=g;j=h;i=b;return j|0}else if((e|0)==5){h=0;j=h;i=b;return j|0}return 0}



function Ara(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+136|0;j=b;b=e;e=f;f=g;a:do{if((c[b+8>>2]|0)==0){if((f|0)==0){k=0;l=k;i=h;return l|0}a[b+4|0]=6;c[b+8>>2]=64;g=c[b+8>>2]<<2;c[b>>2]=oe[c[c[b+16>>2]>>2]&127](g)|0;m=b;if((c[b>>2]|0)!=0){B$a(c[m>>2]|0,0,g|0)|0;g=Bra(j,e)|0;n=g&(c[b+8>>2]|0)-1;break}c[m+8>>2]=0;k=0;l=k;i=h;return l|0}else{m=Bra(j,e)|0;g=(c[b+8>>2]|0)-1|0;o=0;n=m&g;while(1){if((c[(c[b>>2]|0)+(n<<2)>>2]|0)==0){break}if((Cra(e,c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]|0)|0)<<24>>24!=0){p=10;break}if(!(o<<24>>24!=0)){o=((m&~g)>>>((d[b+4|0]|0)-1|0)&g>>>2|1)&255}if(n>>>0<(o&255)>>>0){n=n+((c[b+8>>2]|0)-(o&255))|0;continue}else{n=n-(o&255)|0;continue}}if((p|0)==10){k=c[(c[b>>2]|0)+(n<<2)>>2]|0;l=k;i=h;return l|0}if((f|0)==0){k=0;l=k;i=h;return l|0}if(((c[b+12>>2]|0)>>>((d[b+4|0]|0)-1|0)|0)==0){break}g=(d[b+4|0]|0)+1&255;q=1<<(g&255);r=q-1|0;s=q<<2;t=oe[c[c[b+16>>2]>>2]&127](s)|0;if((t|0)==0){k=0;l=k;i=h;return l|0}B$a(t|0,0,s|0)|0;n=0;while(1){if(!(n>>>0<(c[b+8>>2]|0)>>>0)){break}if((c[(c[b>>2]|0)+(n<<2)>>2]|0)!=0){s=Bra(j,c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]|0)|0;u=s&r;o=0;while(1){if((c[t+(u<<2)>>2]|0)==0){break}if(!(o<<24>>24!=0)){o=((s&~r)>>>((g&255)-1|0)&r>>>2|1)&255}if(u>>>0<(o&255)>>>0){u=u+(q-(o&255))|0;continue}else{u=u-(o&255)|0;continue}}c[t+(u<<2)>>2]=c[(c[b>>2]|0)+(n<<2)>>2]}n=n+1|0}le[c[(c[b+16>>2]|0)+8>>2]&2047](c[b>>2]|0);c[b>>2]=t;a[b+4|0]=g;c[b+8>>2]=q;n=m&r;o=0;while(1){if((c[(c[b>>2]|0)+(n<<2)>>2]|0)==0){break a}if(!(o<<24>>24!=0)){o=((m&~r)>>>((g&255)-1|0)&r>>>2|1)&255}if(n>>>0<(o&255)>>>0){n=n+(q-(o&255))|0;continue}else{n=n-(o&255)|0;continue}}}}while(0);j=oe[c[c[b+16>>2]>>2]&127](f)|0;c[(c[b>>2]|0)+(n<<2)>>2]=j;if((c[(c[b>>2]|0)+(n<<2)>>2]|0)!=0){B$a(c[(c[b>>2]|0)+(n<<2)>>2]|0,0,f|0)|0;c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]=e;e=b+12|0;c[e>>2]=(c[e>>2]|0)+1;k=c[(c[b>>2]|0)+(n<<2)>>2]|0;l=k;i=h;return l|0}else{k=0;l=k;i=h;return l|0}return 0}function Bra(b,e){b=b|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+24|0;g=e;e=c[b+496>>2]|0;while(1){h=e;if((a[g]|0)==0){break}b=g;g=b+1|0;e=h*1000003^d[b]}i=f;return h|0}function Cra(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=c;while(1){if((a[e]|0)!=(a[b]|0)){f=6;break}if((a[e]|0)==0){f=4;break}e=e+1|0;b=b+1|0}if((f|0)==4){g=1;h=g;i=d;return h|0}else if((f|0)==6){g=0;h=g;i=d;return h|0}return 0}function Dra(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=a;a=0;while(1){e=c[(c[d+16>>2]|0)+8>>2]|0;if(!(a>>>0<(c[d+8>>2]|0)>>>0)){break}le[e&2047](c[(c[d>>2]|0)+(a<<2)>>2]|0);a=a+1|0}le[e&2047](c[d>>2]|0);i=b;return}function Era(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+96|0;j=b;b=d;d=e;e=f;f=g;g=0;k=1;l=1;do{if((a[e]|0)==0){if((c[b>>2]|0)==0){break}m=28;n=m;i=h;return n|0}}while(0);do{if((c[b>>2]|0)!=0){if((a[c[b>>2]|0]|0)!=120){break}if((a[(c[b>>2]|0)+1|0]|0)!=109){break}if((a[(c[b>>2]|0)+2|0]|0)!=108){break}do{if((a[(c[b>>2]|0)+3|0]|0)==110){if((a[(c[b>>2]|0)+4|0]|0)!=115){break}if((a[(c[b>>2]|0)+5|0]|0)!=0){break}m=39;n=m;i=h;return n|0}}while(0);if((a[(c[b>>2]|0)+3|0]|0)!=0){break}g=1}}while(0);o=0;while(1){p=(k&255|0)!=0;if((a[e+o|0]|0)==0){break}do{if(p){if((o|0)<=36){if((a[e+o|0]|0)==(a[197e3+o|0]|0)){break}}k=0}}while(0);do{if(!(g<<24>>24!=0)){if((l&255|0)==0){break}if((o|0)<=29){if((a[e+o|0]|0)==(a[197040+o|0]|0)){break}}l=0}}while(0);o=o+1|0}if(p){q=(o|0)==36}else{q=0}k=q&1;if((l&255|0)!=0){r=(o|0)==29}else{r=0}l=r&1;if((g&255|0)!=(k&255|0)){m=(g&255|0)!=0?38:40;n=m;i=h;return n|0}if(l<<24>>24!=0){m=40;n=m;i=h;return n|0}if((a[j+472|0]|0)!=0){o=o+1|0}l=j;do{if((c[j+376>>2]|0)!=0){s=c[l+376>>2]|0;do{if((o|0)>(c[s+24>>2]|0)){g=De[c[j+16>>2]&63](c[s+16>>2]|0,o+24|0)|0;if((g|0)!=0){c[s+16>>2]=g;c[s+24>>2]=o+24;break}m=1;n=m;i=h;return n|0}}while(0);c[j+376>>2]=c[s+4>>2]}else{s=oe[c[l+12>>2]&127](28)|0;if((s|0)==0){m=1;n=m;i=h;return n|0}c[s+16>>2]=oe[c[j+12>>2]&127](o+24|0)|0;if((c[s+16>>2]|0)!=0){c[s+24>>2]=o+24;break}le[c[j+20>>2]&2047](s);m=1;n=m;i=h;return n|0}}while(0);c[s+20>>2]=o;z$a(c[s+16>>2]|0,e|0,o|0)|0;if((a[j+472|0]|0)!=0){a[(c[s+16>>2]|0)+(o-1)|0]=a[j+472|0]|0}c[s>>2]=b;c[s+12>>2]=d;c[s+8>>2]=c[b+4>>2];do{if((a[e]|0)==0){if((b|0)!=((c[j+356>>2]|0)+152|0)){t=52;break}c[b+4>>2]=0}else{t=52}}while(0);if((t|0)==52){c[b+4>>2]=s}c[s+4>>2]=c[f>>2];c[f>>2]=s;do{if((d|0)!=0){if((c[j+100>>2]|0)==0){break}Ke[c[j+100>>2]&15](c[j+4>>2]|0,c[b>>2]|0,(c[b+4>>2]|0)!=0?e:0)}}while(0);m=0;n=m;i=h;return n|0}function Fra(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+24|0;e=b;if((re[((a[e+236|0]&255|0)!=0?34:35)&63](e+148|0,e+144|0,c[e+232>>2]|0)|0)!=0){f=0;g=f;i=d;return g|0}else{f=lsa(e,c[e+232>>2]|0)|0;g=f;i=d;return g|0}return 0}function Gra(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=g+32|0;j=b;b=d;d=e;c[h>>2]=b;e=Ne[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;k=Hra(j,c[j+144>>2]|0,b,d,e,c[h>>2]|0,f,((a[j+484|0]|0)!=0^1)&1)|0;i=g;return k|0}function Hra(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;m=i;i=i+368|0;n=m+48|0;o=b;b=e;e=f;f=g;g=h;c[n>>2]=j;j=k;k=l;l=c[o+356>>2]|0;h=o;if((b|0)==(c[o+144>>2]|0)){p=h+288|0;q=o+292|0}else{p=c[h+300>>2]|0;q=(c[o+300>>2]|0)+4|0}a:while(1){h=1;c[p>>2]=e;c[q>>2]=c[n>>2];b:do{if((g|0)<=0){if((k&255|0)!=0){if((g|0)!=0){r=7;break a}}switch(g|0){case-15:{g=0-g|0;break b;break};case-4:{r=13;break a;break};case 0:{r=9;break a;break};case-1:{r=10;break a;break};case-2:{r=11;break a;break};default:{g=0-g|0;c[n>>2]=f;break b}}}}while(0);s=Ee[c[o+256>>2]&63](o+256|0,g,e,c[n>>2]|0,b)|0;c:do{switch(s|0){case 9:{if((re[c[b+48>>2]&63](b,e,c[n>>2]|0)|0)!=0){c[o+316>>2]=0;break c}t=l+80|0;if((a[l+128|0]|0)==0){c[l+92>>2]=c[t+16>>2];c[o+316>>2]=0;break c}u=Jra(t,b,e,c[n>>2]|0)|0;if((u|0)==0){r=190;break a}c[o+316>>2]=Ara(o,l,u,36)|0;if((c[o+316>>2]|0)==0){r=192;break a}t=l+80|0;if((c[c[o+316>>2]>>2]|0)!=(u|0)){c[l+92>>2]=c[t+16>>2];c[o+316>>2]=0;break c}c[l+96>>2]=c[t+12>>2];c[(c[o+316>>2]|0)+24>>2]=0;a[(c[o+316>>2]|0)+33|0]=0;if((c[o+476>>2]|0)!=0){v=1}else{v=(c[o+300>>2]|0)!=0}a[(c[o+316>>2]|0)+34|0]=(v^1)&1;if((c[o+136>>2]|0)==0){break c}h=0;break};case 36:case 35:{if((a[l+128|0]|0)==0){break c}if((Qra(c[o+344>>2]|0,c[o+348>>2]|0,a[o+352|0]|0,a[o+353|0]|0,0,o)|0)==0){r=117;break a}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)==0){break c}do{if((a[c[o+332>>2]|0]|0)==40){r=123}else{if((a[c[o+332>>2]|0]|0)!=78){break}if((a[(c[o+332>>2]|0)+1|0]|0)==79){r=123}}}while(0);if((r|0)==123){r=0;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((xra(o+416|0)|0)<<24>>24!=0)){r=128;break a}}t=o+428|0;u=c[t>>2]|0;c[t>>2]=u+1;a[u]=41;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((xra(o+416|0)|0)<<24>>24!=0)){r=128;break a}}u=o+428|0;t=c[u>>2]|0;c[u>>2]=t+1;a[t]=0;c[o+332>>2]=c[o+432>>2];c[o+432>>2]=c[o+428>>2]}c[q>>2]=e;xe[c[o+132>>2]&31](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,c[c[o+348>>2]>>2]|0,c[o+332>>2]|0,0,(s|0)==36|0);era(o+416|0);h=0;break};case 7:{if((c[o+84>>2]|0)==0){break c}ie[c[o+84>>2]&31](c[o+4>>2]|0,c[o+320>>2]|0,c[o+324>>2]|0,c[o+328>>2]|0,1);c[o+320>>2]=0;era(o+416|0);h=0;break};case 34:{c[o+344>>2]=Mra(o,b,e,c[n>>2]|0)|0;if((c[o+344>>2]|0)!=0){r=102}else{r=90;break a}break};case 22:{c[o+348>>2]=Nra(o,b,e,c[n>>2]|0)|0;if((c[o+348>>2]|0)==0){r=92;break a}a[o+352|0]=0;c[o+332>>2]=0;a[o+353|0]=0;r=102;break};case 23:{a[o+352|0]=1;c[o+332>>2]=197080;r=102;break};case 57:{w=Ira(o,1,e,c[n>>2]|0)|0;if((w|0)!=0){r=35;break a}b=c[o+144>>2]|0;h=0;break};case 2:{r=75;break a;break};case 13:{r=168;break};case 12:{if((a[l+128|0]|0)==0){break c}x=Sra(o,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;t=c[l+120>>2]|0;do{if((c[o+316>>2]|0)!=0){c[(c[o+316>>2]|0)+4>>2]=t;c[(c[o+316>>2]|0)+8>>2]=(c[l+116>>2]|0)-(c[l+120>>2]|0);c[l+120>>2]=c[l+116>>2];if((c[o+136>>2]|0)==0){break}c[q>>2]=e;Ce[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,d[(c[o+316>>2]|0)+33|0]|0,c[(c[o+316>>2]|0)+4>>2]|0,c[(c[o+316>>2]|0)+8>>2]|0,c[o+360>>2]|0,0,0,0);h=0}else{c[l+116>>2]=t}}while(0);if((x|0)!=0){r=153;break a}break};case 14:{r=45;break};case 15:{if((d[l+128|0]|0)==0){break c}if((c[o+316>>2]|0)==0){break c}if((c[o+136>>2]|0)==0){break c}c[q>>2]=e;Ce[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,d[(c[o+316>>2]|0)+33|0]|0,0,0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,0);h=0;break};case 16:{if((d[l+128|0]|0)==0){break c}if((c[o+316>>2]|0)==0){break c}t=Jra(l+80|0,b,e,c[n>>2]|0)|0;c[(c[o+316>>2]|0)+28>>2]=t;if((c[(c[o+316>>2]|0)+28>>2]|0)==0){r=181;break a}c[l+96>>2]=c[l+92>>2];if((c[o+92>>2]|0)!=0){c[q>>2]=e;xe[c[o+92>>2]&31](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,c[(c[o+316>>2]|0)+28>>2]|0);h=0;break c}if((c[o+136>>2]|0)==0){break c}c[q>>2]=e;Ce[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,0,0,0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,c[(c[o+316>>2]|0)+28>>2]|0);h=0;break};case 8:{if((c[o+320>>2]|0)!=0){ie[c[o+84>>2]&31](c[o+4>>2]|0,c[o+320>>2]|0,c[o+324>>2]|0,c[o+328>>2]|0,0);era(o+416|0);h=0}if((c[o+324>>2]|0)!=0){r=57}else{if((d[o+489|0]|0)!=0){r=57}}if((r|0)==57){r=0;t=a[l+129|0]|0;a[l+129|0]=1;do{if((c[o+492>>2]|0)!=0){if((c[o+112>>2]|0)==0){break}u=Ara(o,l+132|0,197072,36)|0;if((u|0)==0){r=60;break a}if((a[o+489|0]|0)!=0){c[u+20>>2]=c[o+360>>2]}a[l+131|0]=0;if((Ee[c[o+112>>2]&63](c[o+116>>2]|0,0,c[u+20>>2]|0,c[u+16>>2]|0,c[u+24>>2]|0)|0)==0){r=64;break a}if((a[l+131|0]|0)==0){if((c[o+324>>2]|0)!=0){break}a[l+129|0]=t;break}if((a[l+130|0]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((oe[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=69;break a}}}while(0);a[o+489|0]=0}if((c[o+88>>2]|0)==0){break c}le[c[o+88>>2]&2047](c[o+4>>2]|0);h=0;break};case 1:{y=Ira(o,0,e,c[n>>2]|0)|0;if((y|0)!=0){r=25;break a}b=c[o+144>>2]|0;h=0;break};case 6:{a[o+489|0]=0;c[o+316>>2]=Ara(o,l+132|0,197072,36)|0;if((c[o+316>>2]|0)==0){r=38;break a}a[l+129|0]=1;if((c[o+84>>2]|0)==0){r=45;break c}if((Ne[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)==0){r=41;break a}t=Jra(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((t|0)==0){r=43;break a}Kra(t);c[o+432>>2]=c[o+428>>2];c[o+328>>2]=t;h=0;r=47;break};case 38:case 37:{if((a[l+128|0]|0)==0){break c}z=Rra(o,b,a[o+352|0]|0,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0,l+80|0)|0;if((z|0)!=0){r=132;break a}t=c[l+96>>2]|0;c[l+96>>2]=c[l+92>>2];if((Qra(c[o+344>>2]|0,c[o+348>>2]|0,a[o+352|0]|0,0,t,o)|0)==0){r=134;break a}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)==0){break c}do{if((a[c[o+332>>2]|0]|0)==40){r=140}else{if((a[c[o+332>>2]|0]|0)!=78){break}if((a[(c[o+332>>2]|0)+1|0]|0)==79){r=140}}}while(0);if((r|0)==140){r=0;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((xra(o+416|0)|0)<<24>>24!=0)){r=145;break a}}u=o+428|0;A=c[u>>2]|0;c[u>>2]=A+1;a[A]=41;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((xra(o+416|0)|0)<<24>>24!=0)){r=145;break a}}A=o+428|0;u=c[A>>2]|0;c[A>>2]=u+1;a[u]=0;c[o+332>>2]=c[o+432>>2];c[o+432>>2]=c[o+428>>2]}c[q>>2]=e;xe[c[o+132>>2]&31](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,c[c[o+348>>2]>>2]|0,c[o+332>>2]|0,t,(s|0)==38|0);era(o+416|0);h=0;break};case 4:{if((c[o+84>>2]|0)!=0){c[o+320>>2]=Jra(o+416|0,b,e,c[n>>2]|0)|0;if((c[o+320>>2]|0)==0){r=29;break a}c[o+432>>2]=c[o+428>>2];c[o+328>>2]=0;h=0}c[o+324>>2]=0;break};case 28:{c[o+332>>2]=197120;r=102;break};case 29:{c[o+332>>2]=197136;r=102;break};case 30:{c[o+332>>2]=197144;r=102;break};case 5:{a[o+489|0]=0;a[l+129|0]=1;u=o;if((c[o+84>>2]|0)!=0){c[o+324>>2]=Jra(u+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((c[o+324>>2]|0)==0){r=156;break a}c[o+432>>2]=c[o+428>>2];h=0}else{c[u+324>>2]=197072}do{if((a[l+130|0]|0)==0){if((c[o+492>>2]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((oe[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=163;break a}}}while(0);if((c[o+316>>2]|0)!=0){r=168;break c}c[o+316>>2]=Ara(o,l+132|0,197072,36)|0;if((c[o+316>>2]|0)==0){r=166;break a}c[(c[o+316>>2]|0)+24>>2]=0;r=168;break};case 32:case 31:{if((d[l+128|0]|0)==0){break c}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)!=0){B=197176}else{B=(s|0)==32?197160:197184}if((Ora(o+416|0,B)|0)==0){r=111;break a}if((Pra(o+416|0,b,e,c[n>>2]|0)|0)==0){r=113;break a}c[o+332>>2]=c[o+432>>2];h=0;break};case 10:{t=l+80|0;if((a[l+128|0]|0)==0){c[l+92>>2]=c[t+16>>2];c[o+316>>2]=0;break c}u=Jra(t,b,e,c[n>>2]|0)|0;if((u|0)==0){r=202;break a}c[o+316>>2]=Ara(o,l+132|0,u,36)|0;if((c[o+316>>2]|0)==0){r=204;break a}t=l+80|0;if((c[c[o+316>>2]>>2]|0)!=(u|0)){c[l+92>>2]=c[t+16>>2];c[o+316>>2]=0;break c}c[l+96>>2]=c[t+12>>2];c[(c[o+316>>2]|0)+24>>2]=0;a[(c[o+316>>2]|0)+33|0]=1;if((c[o+476>>2]|0)!=0){C=1}else{C=(c[o+300>>2]|0)!=0}a[(c[o+316>>2]|0)+34|0]=(C^1)&1;if((c[o+136>>2]|0)==0){break c}h=0;break};case 58:{if((c[o+80>>2]|0)!=0){vra(o,b,e,c[n>>2]|0)}h=0;D=Tra(o,b,n,f,j,k)|0;if((D|0)!=0){r=239;break a}if((c[n>>2]|0)==0){r=241;break a}break};case 18:{c[o+340>>2]=0;c[o+336>>2]=0;if((c[o+96>>2]|0)==0){break c}c[o+336>>2]=Jra(o+416|0,b,e,c[n>>2]|0)|0;if((c[o+336>>2]|0)==0){r=214;break a}c[o+432>>2]=c[o+428>>2];h=0;break};case 21:{if((Ne[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)==0){r=217;break a}if((c[o+336>>2]|0)==0){break c}t=Jra(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((t|0)==0){r=220;break a}Kra(t);c[o+340>>2]=t;c[o+432>>2]=c[o+428>>2];h=0;break};case 19:{do{if((c[o+336>>2]|0)!=0){if((c[o+96>>2]|0)==0){break}t=Jra(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((t|0)==0){r=225;break a}c[q>>2]=e;ie[c[o+96>>2]&31](c[o+4>>2]|0,c[o+336>>2]|0,c[o+360>>2]|0,t,c[o+340>>2]|0);h=0}}while(0);era(o+416|0);break};case 20:{do{if((c[o+340>>2]|0)!=0){if((c[o+96>>2]|0)==0){break}c[q>>2]=e;ie[c[o+96>>2]&31](c[o+4>>2]|0,c[o+336>>2]|0,c[o+360>>2]|0,0,c[o+340>>2]|0);h=0}}while(0);era(o+416|0);break};case-1:{r=232;break a;break};case 44:{do{if((c[o+260>>2]|0)>>>0>=(c[o+468>>2]|0)>>>0){t=o+12|0;if((c[o+468>>2]|0)==0){u=c[t>>2]|0;c[o+468>>2]=32;c[o+464>>2]=oe[u&127](32)|0;if((c[o+464>>2]|0)!=0){break}else{r=251;break a}}u=c[t+4>>2]|0;t=c[o+464>>2]|0;A=o+468|0;E=c[A>>2]<<1;c[A>>2]=E;A=De[u&63](t,E)|0;if((A|0)==0){r=245;break a}c[o+464>>2]=A;if((c[l+184>>2]|0)==0){break}A=De[c[o+16>>2]&63](c[l+184>>2]|0,c[o+468>>2]<<2)|0;if((A|0)==0){r=248;break a}c[l+184>>2]=A}}while(0);a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=0;if((a[l+160|0]|0)==0){break c}A=Vra(o)|0;if((A|0)<0){r=254;break a}c[(c[l+184>>2]|0)+(c[l+180>>2]<<2)>>2]=A;E=l+180|0;c[E>>2]=(c[E>>2]|0)+1;c[(c[l+164>>2]|0)+(A*28|0)>>2]=6;if((c[o+128>>2]|0)==0){break c}h=0;break};case 50:{if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)==124){r=258;break a}a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=44;if((d[l+160|0]|0)==0){break c}if((c[o+128>>2]|0)==0){break c}h=0;break};case 49:{if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)==44){r=263;break a}do{if((d[l+160|0]|0)!=0){if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)!=0){break}if((c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]|0)==3){break}c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=5;if((c[o+128>>2]|0)==0){break}h=0}}while(0);a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=124;break};case 59:case 60:{a[l+129|0]=1;A=l;do{if((c[o+492>>2]|0)!=0){E=Jra(A+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((E|0)==0){r=273;break a}t=Ara(o,l+132|0,E,0)|0;c[l+92>>2]=c[l+96>>2];do{if((c[o+272>>2]|0)!=0){if((d[l+130|0]|0)!=0){if((c[o+300>>2]|0)!=0){r=282;break}}else{if((a[l+129|0]|0)!=0){r=282;break}}if((t|0)==0){r=279;break a}if((a[t+34|0]|0)==0){r=281;break a}}else{r=282}}while(0);do{if((r|0)==282){r=0;if((t|0)!=0){break}a[l+128|0]=a[l+130|0]|0;if((s|0)!=60){break c}if((c[o+120>>2]|0)==0){break c}Ke[c[o+120>>2]&15](c[o+4>>2]|0,E,1);h=0;break c}}while(0);if((a[t+32|0]|0)!=0){r=287;break a}if((c[t+4>>2]|0)!=0){F=Wra(o,t,((s|0)==60?1:0)&255)|0;if((F|0)!=0){r=290;break a}h=0;break c}E=l;if((c[o+112>>2]|0)==0){a[l+128|0]=a[E+130|0]|0;break c}a[E+131|0]=0;a[t+32|0]=1;E=(Ee[c[o+112>>2]&63](c[o+116>>2]|0,0,c[t+20>>2]|0,c[t+16>>2]|0,c[t+24>>2]|0)|0)!=0;a[t+32|0]=0;if(!E){r=294;break a}h=0;if((a[l+131|0]|0)!=0){break}a[l+128|0]=a[l+130|0]|0;break c}else{a[l+128|0]=a[A+130|0]|0}}while(0);if((a[l+130|0]|0)!=0){break c}if((c[o+108>>2]|0)==0){break c}if((oe[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=301;break a}break};case 53:{G=1;r=319;break};case 52:{G=2;r=319;break};case 54:{G=3;r=319;break};case 40:{if((c[o+128>>2]|0)==0){break c}c[o+344>>2]=Mra(o,b,e,c[n>>2]|0)|0;if((c[o+344>>2]|0)==0){r=304;break a}c[l+180>>2]=0;c[l+176>>2]=0;a[l+160|0]=1;h=0;break};case 42:case 41:{if((a[l+160|0]|0)==0){break c}if((c[o+128>>2]|0)!=0){A=oe[c[o+12>>2]&127](20)|0;if((A|0)==0){r=309;break a}c[A+4>>2]=0;c[A+8>>2]=0;c[A+12>>2]=0;c[A+16>>2]=0;c[A>>2]=(s|0)==41?2:1;c[q>>2]=e;Ke[c[o+128>>2]&15](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,A);h=0}a[l+160|0]=0;break};case 43:{if((a[l+160|0]|0)==0){break c}c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=3;if((c[o+128>>2]|0)==0){break c}h=0;break};case 51:{G=0;r=319;break};case 47:{G=1;r=334;break};case 46:{G=2;r=334;break};case 48:{G=3;r=334;break};case 45:{G=0;r=334;break};case 56:{if((Zra(o,b,e,c[n>>2]|0)|0)==0){r=347;break a}h=0;break};case 0:{if((g|0)!=14){break c}h=0;break};case 3:{if((c[o+84>>2]|0)==0){break c}h=0;break};case 11:{if((d[l+128|0]|0)==0){break c}if((c[o+136>>2]|0)==0){break c}h=0;break};case 55:{if((Yra(o,b,e,c[n>>2]|0)|0)==0){r=344;break a}h=0;break};case 17:{if((c[o+96>>2]|0)==0){break c}h=0;break};case 33:{if((d[l+128|0]|0)==0){break c}if((c[o+132>>2]|0)==0){break c}h=0;break};case 39:{if((c[o+128>>2]|0)==0){break c}h=0;break};case 24:{a[o+353|0]=1;c[o+332>>2]=197088;r=102;break};case 25:{c[o+332>>2]=197096;r=102;break};case 26:{c[o+332>>2]=197104;r=102;break};case 27:{c[o+332>>2]=197112;r=102;break};default:{}}}while(0);do{if((r|0)==45){r=0;if((Ne[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)!=0){r=47}else{r=46;break a}}else if((r|0)==102){r=0;if((d[l+128|0]|0)==0){break}if((c[o+132>>2]|0)==0){break}h=0}else if((r|0)==168){r=0;if((d[l+128|0]|0)==0){break}if((c[o+316>>2]|0)==0){break}s=Jra(l+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;c[(c[o+316>>2]|0)+16>>2]=s;if((c[(c[o+316>>2]|0)+16>>2]|0)==0){r=171;break a}c[(c[o+316>>2]|0)+20>>2]=c[o+360>>2];c[l+96>>2]=c[l+92>>2];if((c[o+136>>2]|0)==0){break}h=0}else if((r|0)==319){r=0;if((a[l+160|0]|0)==0){break}s=c[n>>2]|0;if((G|0)==0){H=s}else{H=s+(0-(c[b+68>>2]|0))|0}s=Vra(o)|0;if((s|0)<0){r=323;break a}c[(c[l+164>>2]|0)+(s*28|0)>>2]=4;c[(c[l+164>>2]|0)+(s*28|0)+4>>2]=G;A=Mra(o,b,e,H)|0;if((A|0)==0){r=325;break a}E=c[A>>2]|0;c[(c[l+164>>2]|0)+(s*28|0)+8>>2]=E;s=0;do{A=s;s=A+1|0;}while((a[E+A|0]|0)!=0);E=l+168|0;c[E>>2]=(c[E>>2]|0)+s;if((c[o+128>>2]|0)==0){break}h=0}else if((r|0)==334){r=0;if((a[l+160|0]|0)==0){break}if((c[o+128>>2]|0)!=0){h=0}E=l+180|0;c[E>>2]=(c[E>>2]|0)+ -1;c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+(c[l+180>>2]<<2)>>2]|0)*28|0)+4>>2]=G;if((c[l+180>>2]|0)!=0){break}if(!(h<<24>>24!=0)){E=Xra(o)|0;if((E|0)==0){r=340;break a}c[q>>2]=e;Ke[c[o+128>>2]&15](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,E)}a[l+160|0]=0;c[l+168>>2]=0}}while(0);do{if((r|0)==47){r=0;if((d[l+128|0]|0)==0){break}if((c[o+316>>2]|0)==0){break}E=Jra(l+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((E|0)==0){r=50;break a}Kra(E);c[(c[o+316>>2]|0)+24>>2]=E;c[l+96>>2]=c[l+92>>2];if((c[o+136>>2]|0)==0){break}h=0}}while(0);do{if((h&255|0)!=0){if((c[o+80>>2]|0)==0){break}vra(o,b,e,c[n>>2]|0)}}while(0);h=c[o+480>>2]|0;if((h|0)==3){r=367;break}else if((h|0)==2){r=368;break}e=c[n>>2]|0;g=Ne[c[b>>2]&63](b,e,f,n)|0}if((r|0)==7){c[j>>2]=e;I=0;J=I;i=m;return J|0}else if((r|0)==9){c[p>>2]=c[n>>2];I=4;J=I;i=m;return J|0}else if((r|0)==10){I=5;J=I;i=m;return J|0}else if((r|0)==11){I=6;J=I;i=m;return J|0}else if((r|0)==13){do{if((b|0)!=(c[o+144>>2]|0)){if((a[(c[o+300>>2]|0)+20|0]|0)!=0){break}c[j>>2]=e;I=0;J=I;i=m;return J|0}}while(0);do{if((d[o+488|0]|0)==0){if((b|0)!=(c[o+144>>2]|0)){break}I=3;J=I;i=m;return J|0}}while(0);if((Ee[c[o+256>>2]&63](o+256|0,-4,f,f,b)|0)==-1){I=29;J=I;i=m;return J|0}else{c[j>>2]=e;I=0;J=I;i=m;return J|0}}else if((r|0)==25){I=y;J=I;i=m;return J|0}else if((r|0)==29){I=1;J=I;i=m;return J|0}else if((r|0)==35){I=w;J=I;i=m;return J|0}else if((r|0)==38){I=1;J=I;i=m;return J|0}else if((r|0)==41){I=32;J=I;i=m;return J|0}else if((r|0)==43){I=1;J=I;i=m;return J|0}else if((r|0)==46){I=32;J=I;i=m;return J|0}else if((r|0)==50){I=1;J=I;i=m;return J|0}else if((r|0)==60){I=1;J=I;i=m;return J|0}else if((r|0)==64){I=21;J=I;i=m;return J|0}else if((r|0)==69){I=22;J=I;i=m;return J|0}else if((r|0)==75){do{if((a[o+489|0]|0)!=0){w=a[l+129|0]|0;a[l+129|0]=1;if((c[o+492>>2]|0)==0){break}if((c[o+112>>2]|0)==0){break}y=Ara(o,l+132|0,197072,36)|0;if((y|0)==0){I=1;J=I;i=m;return J|0}c[y+20>>2]=c[o+360>>2];a[l+131|0]=0;if((Ee[c[o+112>>2]&63](c[o+116>>2]|0,0,c[y+20>>2]|0,c[y+16>>2]|0,c[y+24>>2]|0)|0)==0){I=21;J=I;i=m;return J|0}if((a[l+131|0]|0)==0){a[l+129|0]=w;break}if((a[l+130|0]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((oe[c[o+108>>2]&127](c[o+4>>2]|0)|0)!=0){break}I=22;J=I;i=m;return J|0}}while(0);c[o+280>>2]=38;I=Lra(o,e,f,j)|0;J=I;i=m;return J|0}else if((r|0)==90){I=1;J=I;i=m;return J|0}else if((r|0)==92){I=1;J=I;i=m;return J|0}else if((r|0)==111){I=1;J=I;i=m;return J|0}else if((r|0)==113){I=1;J=I;i=m;return J|0}else if((r|0)==117){I=1;J=I;i=m;return J|0}else if((r|0)==128){I=1;J=I;i=m;return J|0}else if((r|0)==132){I=z;J=I;i=m;return J|0}else if((r|0)==134){I=1;J=I;i=m;return J|0}else if((r|0)==145){I=1;J=I;i=m;return J|0}else if((r|0)==153){I=x;J=I;i=m;return J|0}else if((r|0)==156){I=1;J=I;i=m;return J|0}else if((r|0)==163){I=22;J=I;i=m;return J|0}else if((r|0)==166){I=1;J=I;i=m;return J|0}else if((r|0)==171){I=1;J=I;i=m;return J|0}else if((r|0)==181){I=1;J=I;i=m;return J|0}else if((r|0)==190){I=1;J=I;i=m;return J|0}else if((r|0)==192){I=1;J=I;i=m;return J|0}else if((r|0)==202){I=1;J=I;i=m;return J|0}else if((r|0)==204){I=1;J=I;i=m;return J|0}else if((r|0)==214){I=1;J=I;i=m;return J|0}else if((r|0)==217){I=32;J=I;i=m;return J|0}else if((r|0)==220){I=1;J=I;i=m;return J|0}else if((r|0)==225){I=1;J=I;i=m;return J|0}else if((r|0)==232){x=g;if((x|0)==28){I=10;J=I;i=m;return J|0}else if((x|0)==12){I=17;J=I;i=m;return J|0}else{I=2;J=I;i=m;return J|0}}else if((r|0)==239){I=D;J=I;i=m;return J|0}else if((r|0)==241){c[o+280>>2]=39;I=D;J=I;i=m;return J|0}else if((r|0)==245){I=1;J=I;i=m;return J|0}else if((r|0)==248){I=1;J=I;i=m;return J|0}else if((r|0)==251){I=1;J=I;i=m;return J|0}else if((r|0)==254){I=1;J=I;i=m;return J|0}else if((r|0)==258){I=2;J=I;i=m;return J|0}else if((r|0)==263){I=2;J=I;i=m;return J|0}else if((r|0)==273){I=1;J=I;i=m;return J|0}else if((r|0)==279){I=11;J=I;i=m;return J|0}else if((r|0)==281){I=24;J=I;i=m;return J|0}else if((r|0)==287){I=12;J=I;i=m;return J|0}else if((r|0)==290){I=F;J=I;i=m;return J|0}else if((r|0)==294){I=21;J=I;i=m;return J|0}else if((r|0)==301){I=22;J=I;i=m;return J|0}else if((r|0)==304){I=1;J=I;i=m;return J|0}else if((r|0)==309){I=1;J=I;i=m;return J|0}else if((r|0)==323){I=1;J=I;i=m;return J|0}else if((r|0)==325){I=1;J=I;i=m;return J|0}else if((r|0)==340){I=1;J=I;i=m;return J|0}else if((r|0)==344){I=1;J=I;i=m;return J|0}else if((r|0)==347){I=1;J=I;i=m;return J|0}else if((r|0)==367){c[j>>2]=c[n>>2];I=0;J=I;i=m;return J|0}else if((r|0)==368){I=35;J=I;i=m;return J|0}return 0}function Ira(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+104|0;h=g+40|0;j=g+56|0;k=g+64|0;l=g+72|0;m=g+88|0;n=b;b=d;d=e;e=f;c[h>>2]=0;f=0;c[j>>2]=0;c[k>>2]=0;o=0;c[m>>2]=-1;p=(b|0)!=0;if((ne[((a[n+236|0]&255|0)!=0?1:2)&7](b,c[n+144>>2]|0,d,e,n+288|0,k,l,h,j,m)|0)==0){if(p){q=31;r=q;i=g;return r|0}else{q=30;r=q;i=g;return r|0}}do{if(!p){if((c[m>>2]|0)!=1){break}a[(c[n+356>>2]|0)+130|0]=1;if((c[n+492>>2]|0)!=1){break}c[n+492>>2]=0}}while(0);do{if((c[n+140>>2]|0)!=0){do{if((c[h>>2]|0)!=0){p=c[n+144>>2]|0;b=c[h>>2]|0;s=c[h>>2]|0;f=Jra(n+440|0,p,b,s+(De[c[(c[n+144>>2]|0)+32>>2]&63](c[n+144>>2]|0,c[h>>2]|0)|0)|0)|0;if((f|0)!=0){c[n+456>>2]=c[n+452>>2];break}q=1;r=q;i=g;return r|0}}while(0);do{if((c[k>>2]|0)!=0){o=Jra(n+440|0,c[n+144>>2]|0,c[k>>2]|0,(c[l>>2]|0)+(0-(c[(c[n+144>>2]|0)+68>>2]|0))|0)|0;if((o|0)!=0){break}q=1;r=q;i=g;return r|0}}while(0);Oe[c[n+140>>2]&127](c[n+4>>2]|0,o,f,c[m>>2]|0)}else{if((c[n+80>>2]|0)==0){break}vra(n,c[n+144>>2]|0,d,e)}}while(0);do{if((c[n+232>>2]|0)==0){if((c[j>>2]|0)!=0){if((c[(c[j>>2]|0)+68>>2]|0)==(c[(c[n+144>>2]|0)+68>>2]|0)){c[n+144>>2]=c[j>>2];break}c[n+288>>2]=c[h>>2];q=19;r=q;i=g;return r|0}if((c[h>>2]|0)==0){break}do{if((f|0)==0){e=c[n+144>>2]|0;d=c[h>>2]|0;m=c[h>>2]|0;f=Jra(n+440|0,e,d,m+(De[c[(c[n+144>>2]|0)+32>>2]&63](c[n+144>>2]|0,c[h>>2]|0)|0)|0)|0;if((f|0)!=0){break}q=1;r=q;i=g;return r|0}}while(0);m=lsa(n,f)|0;era(n+440|0);if((m|0)==18){c[n+288>>2]=c[h>>2]}q=m;r=q;i=g;return r|0}}while(0);if((f|0)!=0){t=34}else{if((o|0)!=0){t=34}}if((t|0)==34){era(n+440|0)}q=0;r=q;i=g;return r|0}function Jra(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+40|0;h=b;if((Pra(h,d,e,f)|0)==0){j=0;k=j;i=g;return k|0}do{if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if((xra(h)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);f=h+12|0;e=c[f>>2]|0;c[f>>2]=e+1;a[e]=0;j=c[h+16>>2]|0;k=j;i=g;return k|0}function Kra(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=i;i=i+24|0;d=b;b=d;e=d;while(1){if((a[e]|0)==0){break}f=a[e]|0;do{if((f|0)==10|(f|0)==13|(f|0)==32){if((b|0)==(d|0)){break}if((a[b+ -1|0]|0)==32){break}g=b;b=g+1|0;a[g]=32}else{g=b;b=g+1|0;a[g]=a[e]|0}}while(0);e=e+1|0}if((b|0)==(d|0)){h=b;a[h]=0;i=c;return}if((a[b+ -1|0]|0)!=32){h=b;a[h]=0;i=c;return}b=b+ -1|0;h=b;a[h]=0;i=c;return}function Lra(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=asa(h,0,c[h+144>>2]|0,d,e,f,((a[h+484|0]|0)!=0^1)&1)|0;do{if((b|0)==0){if((isa(h)|0)<<24>>24!=0){break}j=1;k=j;i=g;return k|0}}while(0);j=b;k=j;i=g;return k|0}function Mra(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=a;a=c[g+356>>2]|0;h=Jra(a+80|0,b,d,e)|0;if((h|0)==0){j=0;k=j;i=f;return k|0}e=Ara(g,a+20|0,h,24)|0;if((e|0)==0){j=0;k=j;i=f;return k|0}d=a+80|0;do{if((c[e>>2]|0)!=(h|0)){c[a+92>>2]=c[d+16>>2]}else{c[a+96>>2]=c[d+12>>2];if((jsa(g,e)|0)!=0){break}j=0;k=j;i=f;return k|0}}while(0);j=e;k=j;i=f;return k|0}function Nra(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+80|0;h=b;b=d;d=e;e=f;f=c[h+356>>2]|0;do{if((c[f+92>>2]|0)==(c[f+88>>2]|0)){if((xra(f+80|0)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);l=f+92|0;m=c[l>>2]|0;c[l>>2]=m+1;a[m]=0;m=Jra(f+80|0,b,d,e)|0;if((m|0)==0){j=0;k=j;i=g;return k|0}m=m+1|0;e=Ara(h,f+40|0,m,12)|0;if((e|0)==0){j=0;k=j;i=g;return k|0}d=f+80|0;a:do{if((c[e>>2]|0)!=(m|0)){c[f+92>>2]=c[d+16>>2]}else{c[f+96>>2]=c[d+12>>2];if((a[h+236|0]|0)==0){break}do{if((a[m]|0)==120){if((a[m+1|0]|0)!=109){break}if((a[m+2|0]|0)!=108){break}if((a[m+3|0]|0)!=110){break}if((a[m+4|0]|0)!=115){break}if((a[m+5|0]|0)!=0){if((a[m+5|0]|0)!=58){break}}if((a[m+5|0]|0)==0){c[e+4>>2]=f+152}else{c[e+4>>2]=Ara(h,f+60|0,m+6|0,8)|0}a[e+9|0]=1;break a}}while(0);b=0;while(1){if((a[m+b|0]|0)==0){break a}if((a[m+b|0]|0)==58){break}b=b+1|0}l=0;while(1){n=(c[f+92>>2]|0)==(c[f+88>>2]|0);if((l|0)>=(b|0)){break}if(n){if(!((xra(f+80|0)|0)<<24>>24!=0)){o=30;break}}p=a[m+l|0]|0;q=f+92|0;r=c[q>>2]|0;c[q>>2]=r+1;a[r]=p;l=l+1|0}if((o|0)==30){j=0;k=j;i=g;return k|0}do{if(n){if((xra(f+80|0)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);l=f+92|0;b=c[l>>2]|0;c[l>>2]=b+1;a[b]=0;c[e+4>>2]=Ara(h,f+60|0,c[f+96>>2]|0,8)|0;b=f+80|0;if((c[c[e+4>>2]>>2]|0)==(c[f+96>>2]|0)){c[f+96>>2]=c[b+12>>2];break}else{c[f+92>>2]=c[b+16>>2];break}}}while(0);j=e;k=j;i=g;return k|0}function Ora(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+24|0;f=b;b=d;while(1){g=f;if((a[b]|0)==0){h=7;break}if((c[g+12>>2]|0)==(c[f+8>>2]|0)){if(!((xra(f)|0)<<24>>24!=0)){h=6;break}}d=a[b]|0;j=f+12|0;k=c[j>>2]|0;c[j>>2]=k+1;a[k]=d;b=b+1|0}if((h|0)==6){l=0;m=l;i=e;return m|0}else if((h|0)==7){l=c[g+16>>2]|0;m=l;i=e;return m|0}return 0}function Pra(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+40|0;g=f+24|0;h=a;a=b;c[g>>2]=d;d=e;do{if((c[h+12>>2]|0)==0){if((xra(h)|0)<<24>>24!=0){break}j=0;k=j;i=f;return k|0}}while(0);while(1){ie[c[a+60>>2]&31](a,g,d,h+12|0,c[h+8>>2]|0);l=h;if((c[g>>2]|0)==(d|0)){m=7;break}if(!((xra(l)|0)<<24>>24!=0)){m=6;break}}if((m|0)==6){j=0;k=j;i=f;return k|0}else if((m|0)==7){j=c[l+16>>2]|0;k=j;i=f;return k|0}return 0}function Qra(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+88|0;k=b;b=d;d=e;e=f;f=g;g=h;if((f|0)!=0){l=3}else{if((e&255|0)!=0){l=3}}do{if((l|0)==3){h=0;while(1){if((h|0)>=(c[k+12>>2]|0)){break}if((b|0)==(c[(c[k+20>>2]|0)+(h*12|0)>>2]|0)){l=6;break}h=h+1|0}if((l|0)==6){m=1;n=m;i=j;return n|0}if((e&255|0)==0){break}if((c[k+8>>2]|0)!=0){break}if((a[b+9|0]|0)!=0){break}c[k+8>>2]=b}}while(0);do{if((c[k+12>>2]|0)==(c[k+16>>2]|0)){e=k+16|0;if((c[k+16>>2]|0)==0){c[e>>2]=8;c[k+20>>2]=oe[c[g+12>>2]&127]((c[k+16>>2]|0)*12|0)|0;if((c[k+20>>2]|0)!=0){break}m=0;n=m;i=j;return n|0}l=c[e>>2]<<1;e=De[c[g+16>>2]&63](c[k+20>>2]|0,l*12|0)|0;if((e|0)!=0){c[k+16>>2]=l;c[k+20>>2]=e;break}m=0;n=m;i=j;return n|0}}while(0);g=(c[k+20>>2]|0)+((c[k+12>>2]|0)*12|0)|0;c[g>>2]=b;c[g+8>>2]=f;a[g+4|0]=d;if(!(d<<24>>24!=0)){a[b+8|0]=1}b=k+12|0;c[b>>2]=(c[b>>2]|0)+1;m=1;n=m;i=j;return n|0}function Rra(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;i=i+64|0;k=e;e=h;h=ksa(b,d,k,f,g,e)|0;if((h|0)!=0){l=h;m=l;i=j;return m|0}do{if(!(k<<24>>24!=0)){if(((c[e+12>>2]|0)-(c[e+16>>2]|0)|0)==0){break}if((a[(c[e+12>>2]|0)+ -1|0]|0)!=32){break}h=e+12|0;c[h>>2]=(c[h>>2]|0)+ -1}}while(0);do{if((c[e+12>>2]|0)==(c[e+8>>2]|0)){if((xra(e)|0)<<24>>24!=0){break}l=1;m=l;i=j;return m|0}}while(0);k=e+12|0;e=c[k>>2]|0;c[k>>2]=e+1;a[e]=0;l=0;m=l;i=j;return m|0}function Sra(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=i;i=i+128|0;j=h+72|0;k=h+104|0;l=b;b=e;e=f;f=g;g=c[l+356>>2]|0;m=g+104|0;n=0;o=c[l+276>>2]|0;c[l+276>>2]=1;do{if((c[m>>2]|0)==0){if((xra(m)|0)<<24>>24!=0){break}p=1;q=p;i=h;return q|0}}while(0);a:while(1){b:do{switch(Ne[c[b+20>>2]&63](b,e,f,j)|0){case-3:{c[j>>2]=e+(c[b+68>>2]|0);r=28;break};case-4:{r=24;break a;break};case 6:case 9:{if((Pra(m,b,e,c[j>>2]|0)|0)==0){r=26;break a}break};case 10:{s=De[c[b+44>>2]&63](b,e)|0;if((s|0)<0){r=33;break a}s=rsa(s,k)|0;if((s|0)==0){r=37;break a}t=0;while(1){if((t|0)>=(s|0)){break b}if((c[m+8>>2]|0)==(c[m+12>>2]|0)){if(!((xra(m)|0)<<24>>24!=0)){r=44;break a}}u=a[k+t|0]|0;v=m+12|0;w=c[v>>2]|0;c[v>>2]=w+1;a[w]=u;t=t+1|0}break};case-1:{r=46;break a;break};case 0:{r=49;break a;break};case 7:{r=28;break};case 28:{if((d[l+488|0]|0)==0){if((b|0)==(c[l+144>>2]|0)){r=23;break a}}t=Jra(l+416|0,b,e+(c[b+68>>2]|0)|0,(c[j>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((t|0)==0){r=8;break a}s=Ara(l,g+132|0,t,0)|0;c[l+428>>2]=c[l+432>>2];if((s|0)==0){r=10;break a}if((a[s+32|0]|0)!=0){r=12;break a}if((c[s+16>>2]|0)==0){a[s+32|0]=1;n=Sra(l,c[l+228>>2]|0,c[s+4>>2]|0,(c[s+4>>2]|0)+(c[s+8>>2]|0)|0)|0;a[s+32|0]=0;if((n|0)!=0){break a}else{break b}}t=g;if((c[l+112>>2]|0)==0){a[g+128|0]=a[t+130|0]|0;break b}a[t+131|0]=0;a[s+32|0]=1;t=(Ee[c[l+112>>2]&63](c[l+116>>2]|0,0,c[s+20>>2]|0,c[s+16>>2]|0,c[s+24>>2]|0)|0)!=0;a[s+32|0]=0;if(!t){r=18;break a}if((a[g+131|0]|0)!=0){break b}a[g+128|0]=a[g+130|0]|0;break};default:{r=52;break a}}}while(0);if((r|0)==28){r=0;if((c[m+8>>2]|0)==(c[m+12>>2]|0)){if(!((xra(m)|0)<<24>>24!=0)){r=30;break}}t=m+12|0;s=c[t>>2]|0;c[t>>2]=s+1;a[s]=10}e=c[j>>2]|0}if((r|0)==8){n=1}else if((r|0)==10){a[g+128|0]=a[g+130|0]|0}else if((r|0)==12){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=12}else if((r|0)==18){n=21}else if((r|0)==23){c[l+288>>2]=e;n=10}else if((r|0)==24){n=0}else if((r|0)==26){n=1}else if((r|0)==30){n=1}else if((r|0)==33){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=14}else if((r|0)==37){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=14}else if((r|0)==44){n=1}else if((r|0)==46){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=4}else if((r|0)==49){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=c[j>>2]}n=4}else if((r|0)==52){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=23}c[l+276>>2]=o;p=n;q=p;i=h;return q|0}function Tra(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+96|0;j=h+56|0;k=a;a=b;b=d;d=f;f=g;g=c[b>>2]|0;l=k;if((a|0)==(c[k+144>>2]|0)){m=l+288|0;c[m>>2]=g;n=k+292|0}else{m=c[l+300>>2]|0;n=(c[k+300>>2]|0)+4|0}c[m>>2]=g;c[b>>2]=0;l=Ne[c[a+12>>2]&63](a,g,e,j)|0;c[n>>2]=c[j>>2];switch(l|0){case-4:case-1:{if(f<<24>>24!=0){c[d>>2]=g;o=0;p=o;i=h;return p|0}else{o=2;p=o;i=h;return p|0}break};case 42:{if((c[k+80>>2]|0)!=0){vra(k,a,g,c[j>>2]|0)}c[b>>2]=c[j>>2];c[d>>2]=c[j>>2];if((c[k+480>>2]|0)==2){o=35;p=o;i=h;return p|0}else{o=0;p=o;i=h;return p|0}break};case 0:{c[m>>2]=c[j>>2];o=4;p=o;i=h;return p|0};case-2:{if(f<<24>>24!=0){c[d>>2]=g;o=0;p=o;i=h;return p|0}else{o=6;p=o;i=h;return p|0}break};default:{c[m>>2]=c[j>>2];o=23;p=o;i=h;return p|0}}return 0}function Ura(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=g+16|0;j=b;c[h>>2]=d;d=e;e=f;f=Tra(j,c[j+144>>2]|0,h,d,e,((a[j+484|0]|0)!=0^1)&1)|0;if((f|0)!=0){k=f;l=k;i=g;return l|0}if((c[h>>2]|0)!=0){c[j+280>>2]=40;k=Gra(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}else{k=f;l=k;i=g;return l|0}return 0}function Vra(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+56|0;d=a;a=c[d+356>>2]|0;do{if((c[a+184>>2]|0)==0){c[a+184>>2]=oe[c[d+12>>2]&127](c[d+468>>2]<<2)|0;if((c[a+184>>2]|0)!=0){c[c[a+184>>2]>>2]=0;break}e=-1;f=e;i=b;return f|0}}while(0);if((c[a+176>>2]|0)>>>0>=(c[a+172>>2]|0)>>>0){g=d+12|0;do{if((c[a+164>>2]|0)!=0){h=De[c[g+4>>2]&63](c[a+164>>2]|0,(c[a+172>>2]<<1)*28|0)|0;if((h|0)!=0){d=a+172|0;c[d>>2]=c[d>>2]<<1;break}e=-1;f=e;i=b;return f|0}else{h=oe[c[g>>2]&127](896)|0;if((h|0)!=0){c[a+172>>2]=32;break}e=-1;f=e;i=b;return f|0}}while(0);c[a+164>>2]=h}h=a+176|0;g=c[h>>2]|0;c[h>>2]=g+1;h=g;g=(c[a+164>>2]|0)+(h*28|0)|0;if((c[a+180>>2]|0)!=0){d=(c[a+164>>2]|0)+((c[(c[a+184>>2]|0)+((c[a+180>>2]|0)-1<<2)>>2]|0)*28|0)|0;if((c[d+16>>2]|0)!=0){c[(c[a+164>>2]|0)+((c[d+16>>2]|0)*28|0)+24>>2]=h}if((c[d+20>>2]|0)==0){c[d+12>>2]=h}c[d+16>>2]=h;a=d+20|0;c[a>>2]=(c[a>>2]|0)+1}c[g+24>>2]=0;c[g+20>>2]=0;c[g+16>>2]=0;c[g+12>>2]=0;e=h;f=e;i=b;return f|0}function Wra(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+80|0;g=f+48|0;h=b;b=d;d=e;e=h;do{if((c[h+304>>2]|0)!=0){j=c[e+304>>2]|0;c[h+304>>2]=c[j+8>>2]}else{j=oe[c[e+12>>2]&127](24)|0;if((j|0)!=0){break}k=1;l=k;i=f;return l|0}}while(0);a[b+32|0]=1;c[b+12>>2]=0;c[j+8>>2]=c[h+300>>2];c[h+300>>2]=j;c[j+12>>2]=b;c[j+16>>2]=c[h+312>>2];a[j+20|0]=d;c[j>>2]=0;c[j+4>>2]=0;d=c[b+4>>2]|0;e=(c[b+4>>2]|0)+(c[b+8>>2]|0)|0;m=h;if((a[b+33|0]|0)!=0){n=Ne[c[c[m+228>>2]>>2]&63](c[h+228>>2]|0,d,e,g)|0;o=Hra(h,c[h+228>>2]|0,d,e,n,c[g>>2]|0,g,0)|0}else{o=asa(m,c[h+312>>2]|0,c[h+228>>2]|0,d,e,g,0)|0}a:do{if((o|0)==0){do{if((e|0)!=(c[g>>2]|0)){if((c[h+480>>2]|0)!=3){break}c[b+12>>2]=(c[g>>2]|0)-d;c[h+280>>2]=41;break a}}while(0);a[b+32|0]=0;c[h+300>>2]=c[j+8>>2];c[j+8>>2]=c[h+304>>2];c[h+304>>2]=j}}while(0);k=o;l=k;i=f;return l|0}function Xra(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+56|0;d=b+32|0;e=b+40|0;f=a;a=c[f+356>>2]|0;g=oe[c[f+12>>2]&127](((c[a+176>>2]|0)*20|0)+(c[a+168>>2]|0)|0)|0;if((g|0)!=0){c[e>>2]=g+((c[a+176>>2]|0)*20|0);c[d>>2]=g+20;$ra(f,0,g,d,e);h=g;j=h;i=b;return j|0}else{h=0;j=h;i=b;return j|0}return 0}function Yra(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=a;a=b;b=d;d=e;if((c[g+64>>2]|0)==0){if((c[g+80>>2]|0)!=0){vra(g,a,b,d)}h=1;j=h;i=f;return j|0}b=b+(c[a+68>>2]<<1)|0;e=b+(De[c[a+32>>2]&63](a,b)|0)|0;k=Jra(g+416|0,a,b,e)|0;if((k|0)==0){h=0;j=h;i=f;return j|0}c[g+432>>2]=c[g+428>>2];b=De[c[a+36>>2]&63](a,e)|0;e=Jra(g+416|0,a,b,d+(0-(c[a+68>>2]<<1))|0)|0;if((e|0)!=0){_ra(e);Ke[c[g+64>>2]&15](c[g+4>>2]|0,k,e);era(g+416|0);h=1;j=h;i=f;return j|0}else{h=0;j=h;i=f;return j|0}return 0}function Zra(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+48|0;g=a;a=b;b=d;d=e;e=g;if((c[g+68>>2]|0)==0){if((c[e+80>>2]|0)!=0){vra(g,a,b,d)}h=1;j=h;i=f;return j|0}k=Jra(e+416|0,a,b+(c[a+68>>2]<<2)|0,d+(0-((c[a+68>>2]|0)*3|0))|0)|0;if((k|0)!=0){_ra(k);me[c[g+68>>2]&127](c[g+4>>2]|0,k);era(g+416|0);h=1;j=h;i=f;return j|0}else{h=0;j=h;i=f;return j|0}return 0}function _ra(b){b=b|0;var c=0,d=0,e=0,f=0;c=i;i=i+16|0;d=b;while(1){if((a[d]|0)==0){e=12;break}f=d;if((a[d]|0)==13){break}d=f+1|0}if((e|0)==12){i=c;return}e=f;do{do{if((a[d]|0)==13){f=e;e=f+1|0;a[f]=10;f=d+1|0;d=f;if((a[f]|0)!=10){break}d=d+1|0}else{f=d;d=f+1|0;b=e;e=b+1|0;a[b]=a[f]|0}}while(0);}while((a[d]|0)!=0);a[e]=0;i=c;return}function $ra(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+72|0;j=b;b=d;d=e;e=f;f=g;g=c[j+356>>2]|0;c[d>>2]=c[(c[g+164>>2]|0)+(b*28|0)>>2];c[d+4>>2]=c[(c[g+164>>2]|0)+(b*28|0)+4>>2];if((c[d>>2]|0)==4){c[d+8>>2]=c[f>>2];k=c[(c[g+164>>2]|0)+(b*28|0)+8>>2]|0;while(1){l=a[k]|0;m=f;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;if((a[k]|0)==0){break}k=k+1|0}c[d+12>>2]=0;c[d+16>>2]=0;i=h;return}else{c[d+12>>2]=c[(c[g+164>>2]|0)+(b*28|0)+20>>2];c[d+16>>2]=c[e>>2];k=e;c[k>>2]=(c[k>>2]|0)+((c[d+12>>2]|0)*20|0);k=0;l=c[(c[g+164>>2]|0)+(b*28|0)+12>>2]|0;while(1){if(!(k>>>0<(c[d+12>>2]|0)>>>0)){break}$ra(j,l,(c[d+16>>2]|0)+(k*20|0)|0,e,f);k=k+1|0;l=c[(c[g+164>>2]|0)+(l*28|0)+24>>2]|0}c[d+8>>2]=0;i=h;return}}function asa(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;l=i;i=i+392|0;m=l+32|0;n=l+88|0;o=l+104|0;p=l+128|0;q=l+168|0;r=l+184|0;s=l+232|0;t=l+248|0;u=l+344|0;v=l+352|0;w=l+368|0;x=l+384|0;y=b;b=e;e=f;c[m>>2]=g;g=h;h=j;j=k;k=c[y+356>>2]|0;f=y;if((e|0)==(c[y+144>>2]|0)){z=f+288|0;A=y+292|0}else{z=c[f+300>>2]|0;A=(c[y+300>>2]|0)+4|0}c[z>>2]=c[m>>2];a:while(1){c[n>>2]=c[m>>2];f=Ne[c[e+4>>2]&63](e,c[m>>2]|0,g,n)|0;c[A>>2]=c[n>>2];b:do{switch(f|0){case-4:{B=17;break a;break};case 3:case 4:{C=(c[m>>2]|0)+(c[e+68>>2]|0)|0;c[s>>2]=0;D=1;c[t>>2]=Jra(y+416|0,e,C,C+(De[c[e+32>>2]&63](e,C)|0)|0)|0;if((c[t>>2]|0)==0){B=89;break a}c[y+432>>2]=c[y+428>>2];E=dsa(y,e,c[m>>2]|0,t,s)|0;if((E|0)!=0){B=91;break a}c[y+432>>2]=c[y+428>>2];if((c[y+52>>2]|0)!=0){Ke[c[y+52>>2]&15](c[y+4>>2]|0,c[t>>2]|0,c[y+392>>2]|0);D=0}if((c[y+56>>2]|0)!=0){if((c[y+52>>2]|0)!=0){c[z>>2]=c[A>>2]}me[c[y+56>>2]&127](c[y+4>>2]|0,c[t>>2]|0);D=0}do{if((D&255|0)!=0){if((c[y+80>>2]|0)==0){break}vra(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);era(y+416|0);while(1){if((c[s>>2]|0)==0){break}D=c[s>>2]|0;if((c[y+104>>2]|0)!=0){me[c[y+104>>2]&127](c[y+4>>2]|0,c[c[D>>2]>>2]|0)}c[s>>2]=c[(c[s>>2]|0)+4>>2];c[D+4>>2]=c[y+376>>2];c[y+376>>2]=D;c[(c[D>>2]|0)+4>>2]=c[D+8>>2]}if((c[y+312>>2]|0)==0){B=107;break a}break};case 9:{a[p]=re[c[e+48>>2]&63](e,(c[m>>2]|0)+(c[e+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[e+68>>2]|0))|0)|0;if((a[p]|0)!=0){D=y;if((c[y+60>>2]|0)!=0){Ke[c[D+60>>2]&15](c[y+4>>2]|0,p,1);break b}if((c[D+80>>2]|0)==0){break b}vra(y,e,c[m>>2]|0,c[n>>2]|0);break b}D=Jra(k+80|0,e,(c[m>>2]|0)+(c[e+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[e+68>>2]|0))|0)|0;if((D|0)==0){B=37;break a}C=Ara(y,k,D,0)|0;c[k+92>>2]=c[k+96>>2];do{if((a[k+129|0]|0)!=0){if((d[k+130|0]|0)!=0){B=40;break}if((C|0)!=0){break}F=y;if((c[y+120>>2]|0)!=0){Ke[c[F+120>>2]&15](c[y+4>>2]|0,D,0);break b}if((c[F+80>>2]|0)==0){break b}vra(y,e,c[m>>2]|0,c[n>>2]|0);break b}else{B=40}}while(0);if((B|0)==40){B=0;if((C|0)==0){B=41;break a}if((a[C+34|0]|0)==0){B=43;break a}}if((a[C+32|0]|0)!=0){B=50;break a}if((c[C+28>>2]|0)!=0){B=52;break a}D=y;if((c[C+4>>2]|0)!=0){F=y;if((a[D+308|0]|0)!=0){G=Wra(F,C,0)|0;if((G|0)!=0){B=60;break a}else{break b}}H=y;if((c[F+120>>2]|0)!=0){Ke[c[H+120>>2]&15](c[y+4>>2]|0,c[C>>2]|0,0);break b}if((c[H+80>>2]|0)==0){break b}vra(y,e,c[m>>2]|0,c[n>>2]|0);break b}else{if((c[D+112>>2]|0)==0){if((c[y+80>>2]|0)==0){break b}vra(y,e,c[m>>2]|0,c[n>>2]|0);break b}a[C+32|0]=1;D=csa(y)|0;a[C+32|0]=0;if((D|0)==0){B=63;break a}if((Ee[c[y+112>>2]&63](c[y+116>>2]|0,D,c[C+20>>2]|0,c[C+16>>2]|0,c[C+24>>2]|0)|0)==0){B=65;break a}c[y+428>>2]=c[y+432>>2];break b}break};case 0:{B=24;break a;break};case 1:case 2:{D=y;if((c[y+368>>2]|0)!=0){I=c[D+368>>2]|0;c[y+368>>2]=c[c[y+368>>2]>>2]}else{I=oe[c[D+12>>2]&127](48)|0;if((I|0)==0){B=72;break a}c[I+36>>2]=oe[c[y+12>>2]&127](32)|0;if((c[I+36>>2]|0)==0){B=74;break a}c[I+40>>2]=(c[I+36>>2]|0)+32}c[I+44>>2]=0;c[I>>2]=c[y+364>>2];c[y+364>>2]=I;c[I+16>>2]=0;c[I+20>>2]=0;c[I+4>>2]=(c[m>>2]|0)+(c[e+68>>2]|0);c[I+8>>2]=De[c[e+32>>2]&63](e,c[I+4>>2]|0)|0;D=y+312|0;c[D>>2]=(c[D>>2]|0)+1;D=(c[I+4>>2]|0)+(c[I+8>>2]|0)|0;c[r>>2]=c[I+4>>2];c[q>>2]=c[I+36>>2];while(1){ie[c[e+60>>2]&31](e,r,D,q,(c[I+40>>2]|0)+ -1|0);J=(c[q>>2]|0)-(c[I+36>>2]|0)|0;if((c[r>>2]|0)==(D|0)){break}H=(c[I+40>>2]|0)-(c[I+36>>2]|0)<<1;F=De[c[y+16>>2]&63](c[I+36>>2]|0,H)|0;if((F|0)==0){B=80;break a}c[I+36>>2]=F;c[I+40>>2]=F+H;c[q>>2]=F+J}c[I+24>>2]=J;c[I+12>>2]=c[I+36>>2];a[c[q>>2]|0]=0;K=dsa(y,e,c[m>>2]|0,I+12|0,I+44|0)|0;if((K|0)!=0){B=82;break a}D=y;do{if((c[y+52>>2]|0)!=0){Ke[c[D+52>>2]&15](c[y+4>>2]|0,c[I+12>>2]|0,c[y+392>>2]|0)}else{if((c[D+80>>2]|0)==0){break}vra(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);era(y+416|0);break};case 6:{D=c[y+60>>2]|0;if((D|0)==0){if((c[y+80>>2]|0)==0){break b}vra(y,e,c[m>>2]|0,c[n>>2]|0);break b}if((a[e+72|0]|0)!=0){Ke[D&15](c[y+4>>2]|0,c[m>>2]|0,(c[n>>2]|0)-(c[m>>2]|0)|0);break b}while(1){c[x>>2]=c[y+44>>2];ie[c[e+60>>2]&31](e,m,c[n>>2]|0,x,c[y+48>>2]|0);c[A>>2]=c[m>>2];Ke[D&15](c[y+4>>2]|0,c[y+44>>2]|0,(c[x>>2]|0)-(c[y+44>>2]|0)|0);if((c[m>>2]|0)==(c[n>>2]|0)){break b}c[z>>2]=c[m>>2]}break};case 11:{if((Yra(y,e,c[m>>2]|0,c[n>>2]|0)|0)==0){B=174;break a}break};case 13:{if((Zra(y,e,c[m>>2]|0,c[n>>2]|0)|0)==0){B=176;break a}break};case 10:{D=De[c[e+44>>2]&63](e,c[m>>2]|0)|0;if((D|0)<0){B=135;break a}C=y;if((c[y+60>>2]|0)!=0){F=c[C+60>>2]|0;H=c[y+4>>2]|0;L=rsa(D,u)|0;Ke[F&15](H,u,L);break b}if((c[C+80>>2]|0)==0){break b}vra(y,e,c[m>>2]|0,c[n>>2]|0);break};case-5:{B=153;break a;break};case 12:{B=140;break a;break};case 5:{if((c[y+312>>2]|0)==(b|0)){B=109;break a}C=c[y+364>>2]|0;c[y+364>>2]=c[C>>2];c[C>>2]=c[y+368>>2];c[y+368>>2]=C;M=(c[m>>2]|0)+(c[e+68>>2]<<1)|0;L=De[c[e+32>>2]&63](e,M)|0;if((L|0)!=(c[C+8>>2]|0)){B=112;break a}if((s$a(c[C+4>>2]|0,M,L)|0)!=0){B=112;break a}L=y+312|0;c[L>>2]=(c[L>>2]|0)+ -1;do{if((c[y+56>>2]|0)!=0){L=c[C+16>>2]|0;do{if((d[y+236|0]|0)!=0){if((L|0)==0){break}H=(c[C+12>>2]|0)+(c[C+28>>2]|0)|0;while(1){if((a[L]|0)==0){break}F=L;L=F+1|0;D=H;H=D+1|0;a[D]=a[F]|0}F=c[C+20>>2]|0;c:do{if((d[y+237|0]|0)!=0){if((F|0)==0){break}D=H;H=D+1|0;a[D]=a[y+472|0]|0;while(1){if((a[F]|0)==0){break c}D=F;F=D+1|0;N=H;H=N+1|0;a[N]=a[D]|0}}}while(0);a[H]=0}}while(0);me[c[y+56>>2]&127](c[y+4>>2]|0,c[C+12>>2]|0)}else{if((c[y+80>>2]|0)==0){break}vra(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);while(1){if((c[C+44>>2]|0)==0){break}L=c[C+44>>2]|0;if((c[y+104>>2]|0)!=0){me[c[y+104>>2]&127](c[y+4>>2]|0,c[c[L>>2]>>2]|0)}c[C+44>>2]=c[(c[C+44>>2]|0)+4>>2];c[L+4>>2]=c[y+376>>2];c[y+376>>2]=L;c[(c[L>>2]|0)+4>>2]=c[L+8>>2]}if((c[y+312>>2]|0)==0){B=133;break a}break};case-3:{B=6;break a;break};case-2:{B=28;break a;break};case-1:{B=25;break a;break};case 7:{if((c[y+60>>2]|0)!=0){a[v]=10;Ke[c[y+60>>2]&15](c[y+4>>2]|0,v,1);break b}if((c[y+80>>2]|0)==0){break b}vra(y,e,c[m>>2]|0,c[n>>2]|0);break};case 8:{C=y;do{if((c[y+72>>2]|0)!=0){le[c[C+72>>2]&2047](c[y+4>>2]|0)}else{if((c[C+80>>2]|0)==0){break}vra(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);O=fsa(y,e,n,g,h,j)|0;if((O|0)!=0){B=150;break a}if((c[n>>2]|0)==0){B=152;break a}break};default:{if((c[y+80>>2]|0)==0){break b}vra(y,e,c[m>>2]|0,c[n>>2]|0)}}}while(0);f=c[n>>2]|0;c[m>>2]=f;c[z>>2]=f;f=c[y+480>>2]|0;if((f|0)==3){B=180;break}else if((f|0)==2){B=181;break}}if((B|0)==6){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}c[A>>2]=g;do{if((c[y+60>>2]|0)!=0){a[o]=10;Ke[c[y+60>>2]&15](c[y+4>>2]|0,o,1)}else{if((c[y+80>>2]|0)==0){break}vra(y,e,c[m>>2]|0,g)}}while(0);if((b|0)==0){P=3;Q=P;i=l;return Q|0}if((c[y+312>>2]|0)!=(b|0)){P=13;Q=P;i=l;return Q|0}else{c[h>>2]=g;P=0;Q=P;i=l;return Q|0}}else if((B|0)==17){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}if((b|0)<=0){P=3;Q=P;i=l;return Q|0}if((c[y+312>>2]|0)!=(b|0)){P=13;Q=P;i=l;return Q|0}else{c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}}else if((B|0)==24){c[z>>2]=c[n>>2];P=4;Q=P;i=l;return Q|0}else if((B|0)==25){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}else{P=5;Q=P;i=l;return Q|0}}else if((B|0)==28){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}else{P=6;Q=P;i=l;return Q|0}}else if((B|0)==37){P=1;Q=P;i=l;return Q|0}else if((B|0)==41){P=11;Q=P;i=l;return Q|0}else if((B|0)==43){P=24;Q=P;i=l;return Q|0}else if((B|0)==50){P=12;Q=P;i=l;return Q|0}else if((B|0)==52){P=15;Q=P;i=l;return Q|0}else if((B|0)==60){P=G;Q=P;i=l;return Q|0}else if((B|0)==63){P=1;Q=P;i=l;return Q|0}else if((B|0)==65){P=21;Q=P;i=l;return Q|0}else if((B|0)==72){P=1;Q=P;i=l;return Q|0}else if((B|0)==74){le[c[y+20>>2]&2047](I);P=1;Q=P;i=l;return Q|0}else if((B|0)==80){P=1;Q=P;i=l;return Q|0}else if((B|0)==82){P=K;Q=P;i=l;return Q|0}else if((B|0)==89){P=1;Q=P;i=l;return Q|0}else if((B|0)==91){P=E;Q=P;i=l;return Q|0}else if((B|0)==107){P=esa(y,c[n>>2]|0,g,h)|0;Q=P;i=l;return Q|0}else if((B|0)==109){P=13;Q=P;i=l;return Q|0}else if((B|0)==112){c[z>>2]=M;P=7;Q=P;i=l;return Q|0}else if((B|0)==133){P=esa(y,c[n>>2]|0,g,h)|0;Q=P;i=l;return Q|0}else if((B|0)==135){P=14;Q=P;i=l;return Q|0}else if((B|0)==140){P=17;Q=P;i=l;return Q|0}else if((B|0)==150){P=O;Q=P;i=l;return Q|0}else if((B|0)==152){c[y+280>>2]=42;P=O;Q=P;i=l;return Q|0}else if((B|0)==153){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}do{if((c[y+60>>2]|0)!=0){j=y;if((a[e+72|0]|0)!=0){Ke[c[j+60>>2]&15](c[y+4>>2]|0,c[m>>2]|0,g-(c[m>>2]|0)|0);break}else{c[w>>2]=c[j+44>>2];ie[c[e+60>>2]&31](e,m,g,w,c[y+48>>2]|0);Ke[c[y+60>>2]&15](c[y+4>>2]|0,c[y+44>>2]|0,(c[w>>2]|0)-(c[y+44>>2]|0)|0);break}}else{if((c[y+80>>2]|0)==0){break}vra(y,e,c[m>>2]|0,g)}}while(0);if((b|0)==0){c[z>>2]=g;P=3;Q=P;i=l;return Q|0}m=g;if((c[y+312>>2]|0)!=(b|0)){c[z>>2]=m;P=13;Q=P;i=l;return Q|0}else{c[h>>2]=m;P=0;Q=P;i=l;return Q|0}}else if((B|0)==174){P=1;Q=P;i=l;return Q|0}else if((B|0)==176){P=1;Q=P;i=l;return Q|0}else if((B|0)==180){c[h>>2]=c[n>>2];P=0;Q=P;i=l;return Q|0}else if((B|0)==181){P=35;Q=P;i=l;return Q|0}return 0}function bsa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+104|0;h=g+64|0;j=b;b=d;d=e;e=f;f=c[j+300>>2]|0;if((f|0)==0){k=23;l=k;i=g;return l|0}m=c[f+12>>2]|0;n=(c[m+4>>2]|0)+(c[m+12>>2]|0)|0;o=(c[m+4>>2]|0)+(c[m+8>>2]|0)|0;p=j;if((a[m+33|0]|0)!=0){q=Ne[c[c[p+228>>2]>>2]&63](c[j+228>>2]|0,n,o,h)|0;r=Hra(j,c[j+228>>2]|0,n,o,q,c[h>>2]|0,h,0)|0}else{r=asa(p,c[f+16>>2]|0,c[j+228>>2]|0,n,o,h,0)|0}if((r|0)!=0){k=r;l=k;i=g;return l|0}do{if((o|0)!=(c[h>>2]|0)){if((c[j+480>>2]|0)!=3){break}c[m+12>>2]=(c[h>>2]|0)-(c[m+4>>2]|0);k=r;l=k;i=g;return l|0}}while(0);a[m+32|0]=0;c[j+300>>2]=c[f+8>>2];c[f+8>>2]=c[j+304>>2];c[j+304>>2]=f;f=j+280|0;if((a[m+33|0]|0)!=0){c[f>>2]=40;m=Ne[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;k=Hra(j,c[j+144>>2]|0,b,d,m,c[h>>2]|0,e,((a[j+484|0]|0)!=0^1)&1)|0;l=k;i=g;return l|0}else{c[f>>2]=38;k=asa(j,(c[j+476>>2]|0)!=0?1:0,c[j+144>>2]|0,b,d,e,((a[j+484|0]|0)!=0^1)&1)|0;l=k;i=g;return l|0}return 0}function csa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+104|0;e=d+24|0;f=b;b=c[f+356>>2]|0;g=0;do{if((c[b+156>>2]|0)!=0){do{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if((xra(f+416|0)|0)<<24>>24!=0){break}h=0;j=h;i=d;return j|0}}while(0);k=f+428|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=61;l=c[(c[b+156>>2]|0)+20>>2]|0;if((a[f+472|0]|0)!=0){l=l+ -1|0}k=0;while(1){if((k|0)>=(l|0)){m=13;break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((xra(f+416|0)|0)<<24>>24!=0)){break}}n=a[(c[(c[b+156>>2]|0)+16>>2]|0)+k|0]|0;o=f+428|0;p=c[o>>2]|0;c[o>>2]=p+1;a[p]=n;k=k+1|0}if((m|0)==13){g=1;break}h=0;j=h;i=d;return j|0}}while(0);yra(e,b+60|0);a:while(1){k=zra(e)|0;if((k|0)==0){m=40;break}if((c[k+4>>2]|0)==0){continue}if((g&255|0)!=0){if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((xra(f+416|0)|0)<<24>>24!=0)){m=21;break}}l=f+428|0;n=c[l>>2]|0;c[l>>2]=n+1;a[n]=12}n=c[k>>2]|0;while(1){q=(c[f+428>>2]|0)==(c[f+424>>2]|0);if((a[n]|0)==0){break}if(q){if(!((xra(f+416|0)|0)<<24>>24!=0)){m=27;break a}}l=a[n]|0;p=f+428|0;o=c[p>>2]|0;c[p>>2]=o+1;a[o]=l;n=n+1|0}if(q){if(!((xra(f+416|0)|0)<<24>>24!=0)){m=31;break}}n=f+428|0;l=c[n>>2]|0;c[n>>2]=l+1;a[l]=61;l=c[(c[k+4>>2]|0)+20>>2]|0;if((a[f+472|0]|0)!=0){l=l+ -1|0}n=0;while(1){if((n|0)>=(l|0)){break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((xra(f+416|0)|0)<<24>>24!=0)){m=38;break a}}o=a[(c[(c[k+4>>2]|0)+16>>2]|0)+n|0]|0;p=f+428|0;r=c[p>>2]|0;c[p>>2]=r+1;a[r]=o;n=n+1|0}g=1}if((m|0)==21){h=0;j=h;i=d;return j|0}else if((m|0)==27){h=0;j=h;i=d;return j|0}else if((m|0)==31){h=0;j=h;i=d;return j|0}else if((m|0)==38){h=0;j=h;i=d;return j|0}else if((m|0)==40){yra(e,b);b:while(1){b=zra(e)|0;if((b|0)==0){m=55;break}if((a[b+32|0]|0)==0){continue}if((g&255|0)!=0){if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((xra(f+416|0)|0)<<24>>24!=0)){m=47;break}}q=f+428|0;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=12}n=c[b>>2]|0;while(1){if((a[n]|0)==0){break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((xra(f+416|0)|0)<<24>>24!=0)){m=53;break b}}b=a[n]|0;q=f+428|0;k=c[q>>2]|0;c[q>>2]=k+1;a[k]=b;n=n+1|0}g=1}if((m|0)==47){h=0;j=h;i=d;return j|0}else if((m|0)==53){h=0;j=h;i=d;return j|0}else if((m|0)==55){do{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if((xra(f+416|0)|0)<<24>>24!=0){break}h=0;j=h;i=d;return j|0}}while(0);m=f+428|0;g=c[m>>2]|0;c[m>>2]=g+1;a[g]=0;h=c[f+432>>2]|0;j=h;i=d;return j|0}}return 0}function dsa(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;j=i;i=i+352|0;k=b;b=e;e=f;f=g;g=h;h=c[k+356>>2]|0;l=0;m=0;n=Ara(k,h+20|0,c[f>>2]|0,0)|0;do{if((n|0)==0){o=gra(h+80|0,c[f>>2]|0)|0;if((o|0)==0){p=1;q=p;i=j;return q|0}n=Ara(k,h+20|0,o,24)|0;if((n|0)==0){p=1;q=p;i=j;return q|0}if((d[k+236|0]|0)==0){break}if((jsa(k,n)|0)!=0){break}p=1;q=p;i=j;return q|0}}while(0);o=c[n+12>>2]|0;r=Ne[c[b+40>>2]&63](b,e,c[k+380>>2]|0,c[k+392>>2]|0)|0;do{if((r+o|0)>(c[k+380>>2]|0)){s=c[k+380>>2]|0;c[k+380>>2]=r+o+16;t=De[c[k+16>>2]&63](c[k+392>>2]|0,c[k+380>>2]<<4)|0;if((t|0)==0){p=1;q=p;i=j;return q|0}else{c[k+392>>2]=t;if((r|0)<=(s|0)){break}Ne[c[b+40>>2]&63](b,e,r,c[k+392>>2]|0)|0;break}}}while(0);e=c[k+392>>2]|0;s=0;a:while(1){if((s|0)>=(r|0)){u=43;break}t=(c[k+392>>2]|0)+(s<<4)|0;v=c[t>>2]|0;w=c[t>>2]|0;x=Nra(k,b,v,w+(De[c[b+32>>2]&63](b,c[t>>2]|0)|0)|0)|0;if((x|0)==0){u=17;break}if((a[(c[x>>2]|0)+ -1|0]|0)!=0){u=19;break}a[(c[x>>2]|0)+ -1|0]=1;t=l;l=t+1|0;c[e+(t<<2)>>2]=c[x>>2];if((a[(c[k+392>>2]|0)+(s<<4)+12|0]|0)!=0){c[e+(l<<2)>>2]=Jra(k+416|0,b,c[(c[k+392>>2]|0)+(s<<4)+4>>2]|0,c[(c[k+392>>2]|0)+(s<<4)+8>>2]|0)|0;if((c[e+(l<<2)>>2]|0)==0){u=33;break}c[k+432>>2]=c[k+428>>2]}else{t=1;b:do{if((a[x+8|0]|0)!=0){w=0;while(1){if((w|0)>=(o|0)){break b}y=w;if((x|0)==(c[(c[n+20>>2]|0)+(w*12|0)>>2]|0)){break}w=y+1|0}t=a[(c[n+20>>2]|0)+(y*12|0)+4|0]|0}}while(0);z=Rra(k,b,t,c[(c[k+392>>2]|0)+(s<<4)+4>>2]|0,c[(c[k+392>>2]|0)+(s<<4)+8>>2]|0,k+416|0)|0;if((z|0)!=0){u=30;break}c[e+(l<<2)>>2]=c[k+432>>2];c[k+432>>2]=c[k+428>>2]}do{if((c[x+4>>2]|0)!=0){if((a[x+9|0]|0)==0){l=l+1|0;m=m+1|0;a[(c[x>>2]|0)+ -1|0]=2;break}A=Era(k,c[x+4>>2]|0,x,c[e+(l<<2)>>2]|0,g)|0;if((A|0)!=0){u=38;break a}l=l+ -1|0}else{l=l+1|0}}while(0);s=s+1|0}if((u|0)==17){p=1;q=p;i=j;return q|0}else if((u|0)==19){if((b|0)==(c[k+144>>2]|0)){c[k+288>>2]=c[(c[k+392>>2]|0)+(s<<4)>>2]}p=8;q=p;i=j;return q|0}else if((u|0)==30){p=z;q=p;i=j;return q|0}else if((u|0)==33){p=1;q=p;i=j;return q|0}else if((u|0)==38){p=A;q=p;i=j;return q|0}else if((u|0)==43){c[k+384>>2]=l;c:do{if((c[n+8>>2]|0)!=0){if((a[(c[c[n+8>>2]>>2]|0)+ -1|0]|0)==0){u=50;break}s=0;while(1){if((s|0)>=(l|0)){break c}B=s;if((c[e+(s<<2)>>2]|0)==(c[c[n+8>>2]>>2]|0)){break}s=B+2|0}c[k+388>>2]=B}else{u=50}}while(0);if((u|0)==50){c[k+388>>2]=-1}s=0;d:while(1){if((s|0)>=(o|0)){break}B=(c[n+20>>2]|0)+(s*12|0)|0;do{if((a[(c[c[B>>2]>>2]|0)+ -1|0]|0)==0){if((c[B+8>>2]|0)==0){break}A=c[B>>2]|0;if((c[(c[B>>2]|0)+4>>2]|0)==0){a[(c[A>>2]|0)+ -1|0]=1;z=l;l=z+1|0;c[e+(z<<2)>>2]=c[c[B>>2]>>2];z=l;l=z+1|0;c[e+(z<<2)>>2]=c[B+8>>2];break}if((a[A+9|0]|0)!=0){C=Era(k,c[(c[B>>2]|0)+4>>2]|0,c[B>>2]|0,c[B+8>>2]|0,g)|0;if((C|0)!=0){u=58;break d}else{break}}else{a[(c[c[B>>2]>>2]|0)+ -1|0]=2;m=m+1|0;A=l;l=A+1|0;c[e+(A<<2)>>2]=c[c[B>>2]>>2];A=l;l=A+1|0;c[e+(A<<2)>>2]=c[B+8>>2];break}}}while(0);s=s+1|0}if((u|0)==58){p=C;q=p;i=j;return q|0}c[e+(l<<2)>>2]=0;s=0;e:do{if((m|0)!=0){C=c[k+400>>2]|0;o=1<<d[k+404|0];do{if((m<<1>>d[k+404|0]|0)!=0){do{B=k+404|0;A=a[B]|0;a[B]=A+1<<24>>24;}while((m>>(A&255)|0)!=0);if((d[k+404|0]|0)<3){a[k+404|0]=3}o=1<<d[k+404|0];A=De[c[k+16>>2]&63](c[k+396>>2]|0,o*12|0)|0;if((A|0)!=0){c[k+396>>2]=A;C=0;break}p=1;q=p;i=j;return q|0}}while(0);f:do{if((C|0)==0){C=-1;D=o;while(1){if((D|0)==0){break f}A=D+ -1|0;D=A;c[(c[k+396>>2]|0)+(A*12|0)>>2]=C}}}while(0);A=C+ -1|0;C=A;c[k+400>>2]=A;g:while(1){if((s|0)>=(l|0)){break e}A=c[e+(s<<2)>>2]|0;if((a[A+ -1|0]|0)==2){B=c[k+496>>2]|0;a[A+ -1|0]=0;z=c[(c[(Ara(k,h+40|0,A,0)|0)+4>>2]|0)+4>>2]|0;if((z|0)==0){u=78;break}D=0;while(1){if((D|0)>=(c[z+20>>2]|0)){break}b=a[(c[z+16>>2]|0)+D|0]|0;if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((xra(k+416|0)|0)<<24>>24!=0)){u=84;break g}}y=k+428|0;x=c[y>>2]|0;c[y>>2]=x+1;a[x]=b;B=B*1000003^b&255;D=D+1|0}do{b=A;A=b+1|0;}while((a[b]|0)!=58);do{b=a[A]|0;if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((xra(k+416|0)|0)<<24>>24!=0)){u=89;break g}}x=a[A]|0;y=k+428|0;t=c[y>>2]|0;c[y>>2]=t+1;a[t]=x;B=B*1000003^b&255;b=A;A=b+1|0;}while((a[b]|0)!=0);b=0;x=o-1|0;D=B&x;while(1){if((c[(c[k+396>>2]|0)+(D*12|0)>>2]|0)!=(C|0)){break}if((B|0)==(c[(c[k+396>>2]|0)+(D*12|0)+4>>2]|0)){t=c[k+432>>2]|0;y=c[(c[k+396>>2]|0)+(D*12|0)+8>>2]|0;while(1){if((a[t]|0)!=(a[y]|0)){break}if((a[t]|0)==0){break}t=t+1|0;y=y+1|0}if((a[t]|0)==0){u=98;break g}}if(!(b<<24>>24!=0)){b=((B&~x)>>>((d[k+404|0]|0)-1|0)&x>>>2|1)&255}if((D|0)<(b&255|0)){D=D+(o-(b&255))|0;continue}else{D=D-(b&255)|0;continue}}if((a[k+237|0]|0)!=0){a[(c[k+428>>2]|0)+ -1|0]=a[k+472|0]|0;A=c[c[z>>2]>>2]|0;do{if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((xra(k+416|0)|0)<<24>>24!=0)){u=109;break g}}b=a[A]|0;x=k+428|0;y=c[x>>2]|0;c[x>>2]=y+1;a[y]=b;b=A;A=b+1|0;}while((a[b]|0)!=0)}A=c[k+432>>2]|0;c[k+432>>2]=c[k+428>>2];c[e+(s<<2)>>2]=A;c[(c[k+396>>2]|0)+(D*12|0)>>2]=C;c[(c[k+396>>2]|0)+(D*12|0)+4>>2]=B;c[(c[k+396>>2]|0)+(D*12|0)+8>>2]=A;z=m+ -1|0;m=z;if((z|0)==0){u=111;break}}else{a[A+ -1|0]=0}s=s+2|0}if((u|0)==78){p=27;q=p;i=j;return q|0}else if((u|0)==84){p=1;q=p;i=j;return q|0}else if((u|0)==89){p=1;q=p;i=j;return q|0}else if((u|0)==98){p=8;q=p;i=j;return q|0}else if((u|0)==109){p=1;q=p;i=j;return q|0}else if((u|0)==111){s=s+2|0;break}}}while(0);while(1){if((s|0)>=(l|0)){break}a[(c[e+(s<<2)>>2]|0)+ -1|0]=0;s=s+2|0}e=c[g>>2]|0;while(1){if((e|0)==0){break}a[(c[c[e+12>>2]>>2]|0)+ -1|0]=0;e=c[e+4>>2]|0}if((a[k+236|0]|0)==0){p=0;q=p;i=j;return q|0}do{if((c[n+4>>2]|0)!=0){e=c[(c[n+4>>2]|0)+4>>2]|0;if((e|0)!=0){E=c[f>>2]|0;do{g=E;E=g+1|0;}while((a[g]|0)!=58)}else{p=27;q=p;i=j;return q|0}}else{if((c[h+156>>2]|0)!=0){e=c[h+156>>2]|0;E=c[f>>2]|0;break}p=0;q=p;i=j;return q|0}}while(0);h=0;do{if((d[k+237|0]|0)!=0){if((c[c[e>>2]>>2]|0)==0){break}do{n=h;h=n+1|0;}while((a[(c[c[e>>2]>>2]|0)+n|0]|0)!=0)}}while(0);c[f+4>>2]=E;c[f+16>>2]=c[e+20>>2];c[f+8>>2]=c[c[e>>2]>>2];c[f+20>>2]=h;s=0;do{n=s;s=n+1|0;}while((a[E+n|0]|0)!=0);r=s+(c[e+20>>2]|0)+h|0;if((r|0)>(c[e+24>>2]|0)){F=oe[c[k+12>>2]&127](r+24|0)|0;if((F|0)==0){p=1;q=p;i=j;return q|0}c[e+24>>2]=r+24;z$a(F|0,c[e+16>>2]|0,c[e+20>>2]|0)|0;r=c[k+364>>2]|0;while(1){if((r|0)==0){break}if((c[r+12>>2]|0)==(c[e+16>>2]|0)){c[r+12>>2]=F}r=c[r>>2]|0}le[c[k+20>>2]&2047](c[e+16>>2]|0);c[e+16>>2]=F}F=(c[e+16>>2]|0)+(c[e+20>>2]|0)|0;z$a(F|0,E|0,s|0)|0;if((h|0)!=0){F=F+(s-1)|0;a[F]=a[k+472|0]|0;z$a(F+1|0,c[c[e>>2]>>2]|0,h|0)|0}c[f>>2]=c[e+16>>2];p=0;q=p;i=j;return q|0}return 0}function esa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+56|0;h=g+40|0;j=b;b=d;d=e;e=f;c[j+280>>2]=43;c[j+288>>2]=b;a:while(1){c[h>>2]=0;f=Ne[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;c[j+292>>2]=c[h>>2];b:do{switch(f|0){case-15:{k=3;break a;break};case 13:{if((Zra(j,c[j+144>>2]|0,b,c[h>>2]|0)|0)==0){k=13;break a}break};case 0:{k=14;break a;break};case-4:{k=7;break a;break};case 11:{if((Yra(j,c[j+144>>2]|0,b,c[h>>2]|0)|0)==0){k=11;break a}break};case-1:{k=15;break a;break};case-2:{k=18;break a;break};case 15:{if((c[j+80>>2]|0)==0){break b}vra(j,c[j+144>>2]|0,b,c[h>>2]|0);break};default:{k=21;break a}}}while(0);f=c[h>>2]|0;b=f;c[j+288>>2]=f;f=c[j+480>>2]|0;if((f|0)==2){k=24;break}else if((f|0)==3){k=23;break}}if((k|0)==3){do{if((c[j+80>>2]|0)!=0){vra(j,c[j+144>>2]|0,b,c[h>>2]|0);if((c[j+480>>2]|0)!=2){break}l=35;m=l;i=g;return m|0}}while(0);c[e>>2]=c[h>>2];l=0;m=l;i=g;return m|0}else if((k|0)==7){c[e>>2]=b;l=0;m=l;i=g;return m|0}else if((k|0)==11){l=1;m=l;i=g;return m|0}else if((k|0)==13){l=1;m=l;i=g;return m|0}else if((k|0)==14){c[j+288>>2]=c[h>>2];l=4;m=l;i=g;return m|0}else if((k|0)==15){if((a[j+484|0]|0)!=0){l=5;m=l;i=g;return m|0}else{c[e>>2]=b;l=0;m=l;i=g;return m|0}}else if((k|0)==18){if((a[j+484|0]|0)!=0){l=6;m=l;i=g;return m|0}else{c[e>>2]=b;l=0;m=l;i=g;return m|0}}else if((k|0)==21){l=9;m=l;i=g;return m|0}else if((k|0)==23){c[e>>2]=c[h>>2];l=0;m=l;i=g;return m|0}else if((k|0)==24){l=35;m=l;i=g;return m|0}return 0}function fsa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;i=i+120|0;k=j+56|0;l=j+80|0;m=j+96|0;n=j+112|0;o=b;b=d;d=e;e=f;f=g;g=h;c[k>>2]=c[d>>2];h=o;if((b|0)==(c[o+144>>2]|0)){p=h+288|0;c[p>>2]=c[k>>2];q=o+292|0}else{p=c[h+300>>2]|0;q=(c[o+300>>2]|0)+4|0}c[p>>2]=c[k>>2];c[d>>2]=0;a:while(1){h=Ne[c[b+8>>2]&63](b,c[k>>2]|0,e,l)|0;c[q>>2]=c[l>>2];b:do{switch(h|0){case 0:{r=24;break a;break};case-2:{r=25;break a;break};case 7:{if((c[o+60>>2]|0)!=0){a[m]=10;Ke[c[o+60>>2]&15](c[o+4>>2]|0,m,1);break b}if((c[o+80>>2]|0)==0){break b}vra(o,b,c[k>>2]|0,c[l>>2]|0);break};case 6:{s=c[o+60>>2]|0;if((s|0)==0){if((c[o+80>>2]|0)==0){break b}vra(o,b,c[k>>2]|0,c[l>>2]|0);break b}if((a[b+72|0]|0)!=0){Ke[s&15](c[o+4>>2]|0,c[k>>2]|0,(c[l>>2]|0)-(c[k>>2]|0)|0);break b}while(1){c[n>>2]=c[o+44>>2];ie[c[b+60>>2]&31](b,k,c[l>>2]|0,n,c[o+48>>2]|0);c[q>>2]=c[l>>2];Ke[s&15](c[o+4>>2]|0,c[o+44>>2]|0,(c[n>>2]|0)-(c[o+44>>2]|0)|0);if((c[k>>2]|0)==(c[l>>2]|0)){break b}c[p>>2]=c[k>>2]}break};case-4:case-1:{r=28;break a;break};case 40:{r=6;break a;break};default:{r=31;break a}}}while(0);h=c[l>>2]|0;c[k>>2]=h;c[p>>2]=h;h=c[o+480>>2]|0;if((h|0)==2){r=34;break}else if((h|0)==3){r=33;break}}if((r|0)==6){n=o;do{if((c[o+76>>2]|0)!=0){le[c[n+76>>2]&2047](c[o+4>>2]|0)}else{if((c[n+80>>2]|0)==0){break}vra(o,b,c[k>>2]|0,c[l>>2]|0)}}while(0);c[d>>2]=c[l>>2];c[f>>2]=c[l>>2];if((c[o+480>>2]|0)==2){t=35;u=t;i=j;return u|0}else{t=0;u=t;i=j;return u|0}}else if((r|0)==24){c[p>>2]=c[l>>2];t=4;u=t;i=j;return u|0}else if((r|0)==25){if(g<<24>>24!=0){c[f>>2]=c[k>>2];t=0;u=t;i=j;return u|0}else{t=6;u=t;i=j;return u|0}}else if((r|0)==28){if(g<<24>>24!=0){c[f>>2]=c[k>>2];t=0;u=t;i=j;return u|0}else{t=20;u=t;i=j;return u|0}}else if((r|0)==31){c[p>>2]=c[l>>2];t=23;u=t;i=j;return u|0}else if((r|0)==33){c[f>>2]=c[l>>2];t=0;u=t;i=j;return u|0}else if((r|0)==34){t=35;u=t;i=j;return u|0}return 0}function gsa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=g+16|0;j=b;c[h>>2]=d;d=e;e=f;f=fsa(j,c[j+144>>2]|0,h,d,e,((a[j+484|0]|0)!=0^1)&1)|0;if((f|0)!=0){k=f;l=k;i=g;return l|0}if((c[h>>2]|0)==0){k=f;l=k;i=g;return l|0}f=j+280|0;if((c[j+476>>2]|0)!=0){c[f>>2]=44;k=hsa(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}else{c[f>>2]=38;k=Lra(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}return 0}function hsa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=asa(h,1,c[h+144>>2]|0,d,e,f,((a[h+484|0]|0)!=0^1)&1)|0;do{if((b|0)==0){if((isa(h)|0)<<24>>24!=0){break}j=1;k=j;i=g;return k|0}}while(0);j=b;k=j;i=g;return k|0}function isa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+56|0;d=a;a=c[d+364>>2]|0;while(1){if((a|0)==0){e=13;break}f=(c[a+24>>2]|0)+1|0;g=(c[a+36>>2]|0)+f|0;if((c[a+4>>2]|0)==(g|0)){e=13;break}h=f+((c[a+8>>2]|0)+0)|0;if((h|0)>((c[a+40>>2]|0)-(c[a+36>>2]|0)|0)){j=De[c[d+16>>2]&63](c[a+36>>2]|0,h)|0;if((j|0)==0){e=6;break}if((c[a+12>>2]|0)==(c[a+36>>2]|0)){c[a+12>>2]=j}if((c[a+16>>2]|0)!=0){c[a+16>>2]=j+((c[a+16>>2]|0)-(c[a+36>>2]|0))}c[a+36>>2]=j;c[a+40>>2]=j+h;g=j+f|0}z$a(g|0,c[a+4>>2]|0,c[a+8>>2]|0)|0;c[a+4>>2]=g;a=c[a>>2]|0}if((e|0)==6){k=0;l=k;i=b;return l|0}else if((e|0)==13){k=1;l=k;i=b;return l|0}return 0}function jsa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+56|0;f=b;b=d;d=c[f+356>>2]|0;g=c[b>>2]|0;a:while(1){if((a[g]|0)==0){h=20;break}if((a[g]|0)==58){j=c[b>>2]|0;while(1){k=(c[d+92>>2]|0)==(c[d+88>>2]|0);if((j|0)==(g|0)){break}if(k){if(!((xra(d+80|0)|0)<<24>>24!=0)){h=9;break a}}l=a[j]|0;m=d+92|0;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;j=j+1|0}if(k){if(!((xra(d+80|0)|0)<<24>>24!=0)){h=13;break}}j=d+92|0;l=c[j>>2]|0;c[j>>2]=l+1;a[l]=0;l=Ara(f,d+60|0,c[d+96>>2]|0,8)|0;if((l|0)==0){h=14;break}j=d+80|0;if((c[l>>2]|0)==(c[d+96>>2]|0)){c[d+96>>2]=c[j+12>>2]}else{c[d+92>>2]=c[j+16>>2]}c[b+4>>2]=l}g=g+1|0}if((h|0)==9){o=0;p=o;i=e;return p|0}else if((h|0)==13){o=0;p=o;i=e;return p|0}else if((h|0)==14){o=0;p=o;i=e;return p|0}else if((h|0)==20){o=1;p=o;i=e;return p|0}return 0}function ksa(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;k=i;i=i+152|0;l=k+64|0;m=k+80|0;n=b;b=e;e=f;f=g;g=h;h=j;j=c[n+356>>2]|0;a:while(1){b:do{switch(Ne[c[b+16>>2]&63](b,f,g,l)|0){case 9:{o=(re[c[b+48>>2]&63](b,f+(c[b+68>>2]|0)|0,(c[l>>2]|0)+(0-(c[b+68>>2]|0))|0)|0)&255;if(o<<24>>24!=0){if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((xra(h)|0)<<24>>24!=0)){p=42;break a}}q=h+12|0;r=c[q>>2]|0;c[q>>2]=r+1;a[r]=o;break b}o=Jra(n+440|0,b,f+(c[b+68>>2]|0)|0,(c[l>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((o|0)==0){p=44;break a}r=Ara(n,j,o,0)|0;c[n+452>>2]=c[n+456>>2];if((h|0)==(j+80|0)){if((c[n+272>>2]|0)!=0){if((d[j+130|0]|0)!=0){s=(c[n+300>>2]|0)!=0}else{s=(a[j+129|0]|0)!=0}t=((s^1)&1|0)!=0}else{t=0}u=t&1}else{if((a[j+129|0]|0)!=0){v=(d[j+130|0]|0)!=0}else{v=1}u=v&1}o=(r|0)!=0;if(u<<24>>24!=0){if(!o){p=57;break a}if((a[r+34|0]|0)==0){p=59;break a}}else{if(!o){break b}}if((a[r+32|0]|0)!=0){p=62;break a}if((c[r+28>>2]|0)!=0){p=66;break a}if((c[r+4>>2]|0)==0){p=70;break a}o=(c[r+4>>2]|0)+(c[r+8>>2]|0)|0;a[r+32|0]=1;w=ksa(n,c[n+228>>2]|0,e,c[r+4>>2]|0,o,h)|0;a[r+32|0]=0;if((w|0)!=0){p=74;break a}break};case 6:{if((Pra(h,b,f,c[l>>2]|0)|0)==0){p=29;break a}break};case 7:case 39:{p=31;break};case-1:{p=7;break a;break};case-4:{p=3;break a;break};case 0:{p=4;break a;break};case-3:{c[l>>2]=f+(c[b+68>>2]|0);p=31;break};case 10:{r=De[c[b+44>>2]&63](b,f)|0;if((r|0)<0){p=11;break a}do{if(!(e<<24>>24!=0)){if((r|0)!=32){break}if(((c[h+12>>2]|0)-(c[h+16>>2]|0)|0)==0){break b}if((a[(c[h+12>>2]|0)+ -1|0]|0)==32){break b}}}while(0);r=rsa(r,m)|0;if((r|0)==0){p=19;break a}o=0;while(1){if((o|0)>=(r|0)){break b}if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((xra(h)|0)<<24>>24!=0)){p=27;break a}}q=a[m+o|0]|0;x=h+12|0;y=c[x>>2]|0;c[x>>2]=y+1;a[y]=q;o=o+1|0}break};default:{p=75;break a}}}while(0);do{if((p|0)==31){p=0;if(!(e<<24>>24!=0)){if(((c[h+12>>2]|0)-(c[h+16>>2]|0)|0)==0){break}if((a[(c[h+12>>2]|0)+ -1|0]|0)==32){break}}if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((xra(h)|0)<<24>>24!=0)){p=37;break a}}o=h+12|0;r=c[o>>2]|0;c[o>>2]=r+1;a[r]=32}}while(0);f=c[l>>2]|0}if((p|0)==3){z=0;A=z;i=k;return A|0}else if((p|0)==4){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=c[l>>2]}z=4;A=z;i=k;return A|0}else if((p|0)==7){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=4;A=z;i=k;return A|0}else if((p|0)==11){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=14;A=z;i=k;return A|0}else if((p|0)==19){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=14;A=z;i=k;return A|0}else if((p|0)==27){z=1;A=z;i=k;return A|0}else if((p|0)==29){z=1;A=z;i=k;return A|0}else if((p|0)==37){z=1;A=z;i=k;return A|0}else if((p|0)==42){z=1;A=z;i=k;return A|0}else if((p|0)==44){z=1;A=z;i=k;return A|0}else if((p|0)==57){z=11;A=z;i=k;return A|0}else if((p|0)==59){z=24;A=z;i=k;return A|0}else if((p|0)==62){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=12;A=z;i=k;return A|0}else if((p|0)==66){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=15;A=z;i=k;return A|0}else if((p|0)==70){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=16;A=z;i=k;return A|0}else if((p|0)==74){z=w;A=z;i=k;return A|0}else if((p|0)==75){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=23;A=z;i=k;return A|0}return 0}function lsa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+1080|0;f=e+24|0;g=b;b=d;do{if((c[g+124>>2]|0)!=0){d=0;while(1){if((d|0)>=256){break}c[f+(d<<2)>>2]=-1;d=d+1|0}c[f+1028>>2]=0;c[f+1024>>2]=0;c[f+1032>>2]=0;do{if((re[c[g+124>>2]&63](c[g+248>>2]|0,b,f)|0)!=0){d=c[g+12>>2]|0;h=ssa()|0;c[g+240>>2]=oe[d&127](h)|0;if((c[g+240>>2]|0)!=0){h=Ne[((a[g+236|0]&255|0)!=0?45:46)&63](c[g+240>>2]|0,f,c[f+1028>>2]|0,c[f+1024>>2]|0)|0;if((h|0)==0){break}c[g+244>>2]=c[f+1024>>2];c[g+252>>2]=c[f+1032>>2];c[g+144>>2]=h;j=0;k=j;i=e;return k|0}if((c[f+1032>>2]|0)!=0){le[c[f+1032>>2]&2047](c[f+1024>>2]|0)}j=1;k=j;i=e;return k|0}}while(0);if((c[f+1032>>2]|0)==0){break}le[c[f+1032>>2]&2047](c[f+1024>>2]|0)}}while(0);j=18;k=j;i=e;return k|0}function msa(){var a=0,b=0;a=i;i=i+8|0;fc(((vc(0)|0)>>>0)%4294967295|0|0);b=F$a()|0;i=a;return b|0}function nsa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+48|0;g=a;a=Fra(g)|0;if((a|0)!=0){h=a;j=h;i=f;return j|0}else{c[g+280>>2]=40;h=Gra(g,b,d,e)|0;j=h;i=f;return j|0}return 0}function osa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=oe[c[e>>2]&127](188)|0;f=b;if((b|0)==0){g=f;h=g;i=d;return h|0}else{psa(f+80|0,e);psa(b+104|0,e);qsa(b,e);qsa(b+20|0,e);qsa(b+40|0,e);qsa(b+60|0,e);a[b+131|0]=0;qsa(b+132|0,e);c[b+152>>2]=0;c[b+156>>2]=0;a[b+160|0]=0;c[b+184>>2]=0;c[b+164>>2]=0;c[b+180>>2]=0;c[b+172>>2]=0;c[b+176>>2]=0;c[b+168>>2]=0;a[b+128|0]=1;a[b+129|0]=0;a[b+130|0]=0;g=b;h=g;i=d;return h|0}return 0}function psa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=a;c[e>>2]=0;c[e+4>>2]=0;c[e+16>>2]=0;c[e+12>>2]=0;c[e+8>>2]=0;c[e+20>>2]=b;i=d;return}function qsa(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=b;a[f+4|0]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f>>2]=0;c[f+16>>2]=d;i=e;return}function rsa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=c;if((e|0)<0){f=0;g=f;i=d;return g|0}c=e;if((e|0)<128){a[b]=c;f=1;g=f;i=d;return g|0}h=e;if((c|0)<2048){a[b]=h>>6|192;a[b+1|0]=e&63|128;f=2;g=f;i=d;return g|0}c=e;if((h|0)<65536){a[b]=c>>12|224;a[b+1|0]=e>>6&63|128;a[b+2|0]=e&63|128;f=3;g=f;i=d;return g|0}if((c|0)<1114112){a[b]=e>>18|240;a[b+1|0]=e>>12&63|128;a[b+2|0]=e>>6&63|128;a[b+3|0]=e&63|128;f=4;g=f;i=d;return g|0}else{f=0;g=f;i=d;return g|0}return 0}function ssa(){i=i;return 1912}function tsa(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+64|0;k=e;e=f;f=g;g=h;h=k;l=0;while(1){if((l|0)>=368){break}a[k+l|0]=a[203328+l|0]|0;l=l+1|0}l=0;a:while(1){if((l|0)>=128){break}do{if((d[203404+l|0]|0|0)!=28){if((d[203404+l|0]|0|0)==0){break}if((c[e+(l<<2)>>2]|0)!=(l|0)){m=9;break a}}}while(0);l=l+1|0}if((m|0)==9){n=0;o=n;i=j;return o|0}l=0;b:while(1){if((l|0)>=256){m=36;break}k=c[e+(l<<2)>>2]|0;do{if((k|0)==-1){a[h+76+l|0]=1;b[h+376+(l<<1)>>1]=-1;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=0}else{p=k;if((k|0)<0){if((p|0)<-4){m=17;break b}a[h+76+l|0]=5-(k+2);a[h+888+(l<<2)|0]=0;b[h+376+(l<<1)>>1]=0;break}q=k;if((p|0)<128){do{if((d[203404+q|0]|0|0)!=28){if((d[203404+k|0]|0|0)==0){break}if((k|0)!=(l|0)){m=23;break b}}}while(0);a[h+76+l|0]=a[203404+k|0]|0;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=k;b[h+376+(l<<1)>>1]=(k|0)==0?65535:k;break}if((usa(q)|0)<0){a[h+76+l|0]=0;b[h+376+(l<<1)>>1]=-1;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=0;break}if((k|0)>65535){m=28;break b}do{if((c[197496+(((d[197240+(k>>8)|0]|0)<<3)+((k&255)>>5)<<2)>>2]&1<<(k&31)|0)!=0){a[h+76+l|0]=22}else{p=h+76+l|0;if((c[197496+(((d[198776+(k>>8)|0]|0)<<3)+((k&255)>>5)<<2)>>2]&1<<(k&31)|0)!=0){a[p]=26;break}else{a[p]=28;break}}}while(0);a[h+888+(l<<2)|0]=rsa(k,h+888+(l<<2)+1|0)|0;b[h+376+(l<<1)>>1]=k}}while(0);l=l+1|0}if((m|0)==17){n=0;o=n;i=j;return o|0}else if((m|0)==23){n=0;o=n;i=j;return o|0}else if((m|0)==28){n=0;o=n;i=j;return o|0}else if((m|0)==36){c[h+372>>2]=g;c[h+368>>2]=f;if((f|0)!=0){c[h+332>>2]=50;c[h+336>>2]=50;c[h+340>>2]=50;c[h+344>>2]=51;c[h+348>>2]=51;c[h+352>>2]=51;c[h+356>>2]=52;c[h+360>>2]=52;c[h+364>>2]=52}c[h+60>>2]=14;c[h+64>>2]=15;n=h;o=n;i=j;return o|0}return 0}function usa(a){a=a|0;var b=0,c=0,e=0,f=0;b=i;i=i+16|0;c=a;a:do{switch(c>>8|0){case 255:{if(!((c|0)==65534|(c|0)==65535)){e=7;break a}f=-1;break};case 223:case 222:case 221:case 220:case 219:case 218:case 217:case 216:{f=-1;break};case 0:{if((d[203404+c|0]|0|0)!=0){e=7;break a}f=-1;break};default:{e=7}}}while(0);if((e|0)==7){f=c}i=b;return f|0}function vsa(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+40|0;f=a;a=De[c[f+368>>2]&63](c[f+372>>2]|0,b)|0;if((a&-65536|0)!=0){g=0;h=g;i=e;return h|0}else{g=c[197496+(((d[198776+(a>>8)|0]|0)<<3)+((a&255)>>5)<<2)>>2]&1<<(a&31);h=g;i=e;return h|0}return 0}function wsa(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+40|0;f=a;a=De[c[f+368>>2]&63](c[f+372>>2]|0,b)|0;if((a&-65536|0)!=0){g=0;h=g;i=e;return h|0}else{g=c[197496+(((d[197240+(a>>8)|0]|0)<<3)+((a&255)>>5)<<2)>>2]&1<<(a&31);h=g;i=e;return h|0}return 0}function xsa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=a;a=De[c[e+368>>2]&63](c[e+372>>2]|0,b)|0;if((a&-65536|0)!=0){f=1;g=f&1;i=d;return g|0}f=(usa(a)|0)<0;g=f&1;i=d;return g|0}function ysa(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i;i=i+80|0;k=j+48|0;l=b;b=e;e=f;f=g;g=h;h=l;a:while(1){if((c[b>>2]|0)==(e|0)){m=9;break}n=h+888+(d[c[b>>2]|0]<<2)|0;o=n;n=o+1|0;p=a[o]|0;if((p|0)==0){p=rsa(De[c[h+368>>2]&63](c[h+372>>2]|0,c[b>>2]|0)|0,k)|0;if((p|0)>(g-(c[f>>2]|0)|0)){m=9;break}n=k;o=b;c[o>>2]=(c[o>>2]|0)+((d[l+76+(d[c[b>>2]|0]|0)|0]|0)-3)}else{if((p|0)>(g-(c[f>>2]|0)|0)){m=9;break}o=b;c[o>>2]=(c[o>>2]|0)+1}while(1){o=n;n=o+1|0;q=a[o]|0;o=f;r=c[o>>2]|0;c[o>>2]=r+1;a[r]=q;q=p+ -1|0;p=q;if((q|0)==0){continue a}}}if((m|0)==9){i=j;return}}function zsa(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+56|0;k=a;a=e;e=f;f=g;g=h;h=k;while(1){if((c[a>>2]|0)==(e|0)){l=8;break}if((c[f>>2]|0)==(g|0)){l=8;break}m=b[h+376+((d[c[a>>2]|0]|0)<<1)>>1]|0;if((m&65535|0)==0){m=(De[c[h+368>>2]&63](c[h+372>>2]|0,c[a>>2]|0)|0)&65535;n=a;c[n>>2]=(c[n>>2]|0)+((d[k+76+(d[c[a>>2]|0]|0)|0]|0)-3)}else{n=a;c[n>>2]=(c[n>>2]|0)+1}n=f;o=c[n>>2]|0;c[n>>2]=o+2;b[o>>1]=m}if((l|0)==8){i=j;return}}function Asa(){i=i;return 202960}function Bsa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+40|0;g=b;b=d;d=Csa(e)|0;if((d|0)==-1){h=0;j=h;i=f;return j|0}else{a[g+73|0]=d;c[g>>2]=47;c[g+4>>2]=48;c[g+52>>2]=68;c[g+76>>2]=b;c[b>>2]=g;h=1;j=h;i=f;return j|0}return 0}function Csa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+24|0;d=a;if((d|0)==0){e=6;f=e;i=b;return f|0}a=0;while(1){if((a|0)>=6){g=8;break}h=a;if((Qsa(d,c[202864+(a<<2)>>2]|0)|0)!=0){g=6;break}a=h+1|0}if((g|0)==6){e=h;f=e;i=b;return f|0}else if((g|0)==8){e=-1;f=e;i=b;return f|0}return 0}function Dsa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=Oua(201304,a,0,b,c,d)|0;i=e;return f|0}function Esa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=Oua(201304,a,1,b,c,d)|0;i=e;return f|0}function Fsa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=i;i=i+32|0;lua(202072,b,c,d);i=a;return}function Gsa(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+80|0;m=Hsa(36,a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function Hsa(a,b,d,e,f,g,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;n=i;i=i+128|0;o=n+32|0;p=n+96|0;q=n+104|0;r=n+112|0;s=a;a=b;b=d;c[o>>2]=e;e=f;f=g;g=h;h=j;j=k;k=l;l=m;c[p>>2]=0;c[q>>2]=0;c[r>>2]=0;c[o>>2]=(c[o>>2]|0)+((c[b+68>>2]|0)*5|0);e=e+(0-(c[b+68>>2]<<1))|0;m=(Pua(b,c[o>>2]|0,e,q,r,p,o)|0)!=0;if(!(m&(c[q>>2]|0)!=0)){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}do{if((Ne[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,202808)|0)!=0){if((g|0)!=0){c[g>>2]=c[p>>2]}if((h|0)!=0){c[h>>2]=c[o>>2]}if((Pua(b,c[o>>2]|0,e,q,r,p,o)|0)==0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}if((c[q>>2]|0)!=0){break}if((a|0)!=0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}else{t=1;u=t;i=n;return u|0}}else{if((a|0)!=0){break}c[f>>2]=c[q>>2];t=0;u=t;i=n;return u|0}}while(0);do{if((Ne[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,202816)|0)!=0){h=Qua(b,c[p>>2]|0,e)|0;do{if(!(97<=(h|0)&(h|0)<=122)){if(65<=(h|0)&(h|0)<=90){break}c[f>>2]=c[p>>2];t=0;u=t;i=n;return u|0}}while(0);if((j|0)!=0){c[j>>2]=c[p>>2]}if((k|0)!=0){c[k>>2]=re[s&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0)|0}if((Pua(b,c[o>>2]|0,e,q,r,p,o)|0)==0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}if((c[q>>2]|0)!=0){break}t=1;u=t;i=n;return u|0}}while(0);do{if((Ne[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,202832)|0)!=0){if((a|0)!=0){break}do{if((Ne[c[b+28>>2]&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0,202848)|0)!=0){if((l|0)==0){break}c[l>>2]=1}else{if((Ne[c[b+28>>2]&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0,202856)|0)!=0){if((l|0)==0){break}c[l>>2]=0;break}else{c[f>>2]=c[p>>2];t=0;u=t;i=n;return u|0}}}while(0);while(1){if((Rua(Qua(b,c[o>>2]|0,e)|0)|0)==0){break}c[o>>2]=(c[o>>2]|0)+(c[b+68>>2]|0)}if((c[o>>2]|0)!=(e|0)){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}else{t=1;u=t;i=n;return u|0}}}while(0);c[f>>2]=c[q>>2];t=0;u=t;i=n;return u|0}function Isa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+176|0;g=f+16|0;h=f+32|0;j=f+160|0;k=b;c[g>>2]=d;d=e;c[j>>2]=h;ie[c[k+60>>2]&31](k,g,d,j,(c[j>>2]|0)+128+ -1|0);if((c[g>>2]|0)!=(d|0)){l=0;m=l;i=f;return m|0}a[c[j>>2]|0]=0;do{if((Qsa(h,199032)|0)!=0){if((c[k+68>>2]|0)!=2){break}l=k;m=l;i=f;return m|0}}while(0);k=Csa(h)|0;if((k|0)==-1){l=0;m=l;i=f;return m|0}else{l=c[201304+(k<<2)>>2]|0;m=l;i=f;return m|0}return 0}function Jsa(){i=i;return 200936}function Ksa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+40|0;g=b;b=d;d=Csa(e)|0;if((d|0)==-1){h=0;j=h;i=f;return j|0}else{a[g+73|0]=d;c[g>>2]=49;c[g+4>>2]=50;c[g+52>>2]=68;c[g+76>>2]=b;c[b>>2]=g;h=1;j=h;i=f;return j|0}return 0}function Lsa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=Oua(199040,a,0,b,c,d)|0;i=e;return f|0}function Msa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=Oua(199040,a,1,b,c,d)|0;i=e;return f|0}function Nsa(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+80|0;m=Hsa(37,a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function Osa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+176|0;g=f+16|0;h=f+32|0;j=f+160|0;k=b;c[g>>2]=d;d=e;c[j>>2]=h;ie[c[k+60>>2]&31](k,g,d,j,(c[j>>2]|0)+128+ -1|0);if((c[g>>2]|0)!=(d|0)){l=0;m=l;i=f;return m|0}a[c[j>>2]|0]=0;do{if((Qsa(h,199032)|0)!=0){if((c[k+68>>2]|0)!=2){break}l=k;m=l;i=f;return m|0}}while(0);k=Csa(h)|0;if((k|0)==-1){l=0;m=l;i=f;return m|0}else{l=c[199040+(k<<2)>>2]|0;m=l;i=f;return m|0}return 0}function Psa(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+40|0;g=tsa(b,c,d,e)|0;if((g|0)==0){h=g;i=f;return h|0}a[g+134|0]=23;h=g;i=f;return h|0}function Qsa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+40|0;e=b;b=c;while(1){c=e;e=c+1|0;f=a[c]|0;c=b;b=c+1|0;g=a[c]|0;do{if(97<=(f<<24>>24|0)){if((f<<24>>24|0)>122){break}f=(f<<24>>24)+ -32&255}}while(0);do{if(97<=(g<<24>>24|0)){if((g<<24>>24|0)>122){break}g=(g<<24>>24)+ -32&255}}while(0);if((f<<24>>24|0)!=(g<<24>>24|0)){h=9;break}if(!(f<<24>>24!=0)){h=11;break}}if((h|0)==9){j=0;k=j;i=d;return k|0}else if((h|0)==11){j=1;k=j;i=d;return k|0}return 0}function Rsa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=gta(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 2:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=gta(a[g+1|0]|0,a[b]|0)|0}switch(n|0){case 15:{k=ota(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -2;k=29;l=k;i=h;return l|0};case 16:{k=tta(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 31:{c[f>>2]=b+2;k=23;l=k;i=h;return l|0};case 29:{g=b;if((c[197496+((d[197240+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){b=g+2|0;o=18;p=77;break a}if((c[197496+((d[198776+(d[g+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){p=76;break a}b=b+2|0;o=19;p=77;break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 32:{b=b+2|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[g]|0)|0]|0}else{q=gta(a[g+1|0]|0,a[b]|0)|0}switch(q|0){case 34:{c[f>>2]=b+2;k=37;l=k;i=h;return l|0};case 15:{c[f>>2]=b+2;k=35;l=k;i=h;return l|0};case 33:{c[f>>2]=b+2;k=36;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 13:{k=sta(13,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 23:case 27:case 26:case 25:{o=19;b=b+2|0;p=77;break};case 11:{c[f>>2]=b+2;k=17;l=k;i=h;return l|0};case 19:{k=uta(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 36:{c[f>>2]=b+2;k=21;l=k;i=h;return l|0};case 24:case 22:{o=18;b=b+2|0;p=77;break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 10:case 21:{p=25;break};case 20:{c[f>>2]=b+2;k=25;l=k;i=h;return l|0};case 35:{c[f>>2]=b+2;k=38;l=k;i=h;return l|0};case 9:{if((b+2|0)!=(e|0)){p=25;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 30:{k=ita(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=93){break}if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+3|0]|0)!=0){break}if((a[b+2|0]|0)!=62){break}c[f>>2]=b+4;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 12:{k=sta(12,j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{p=76}}}while(0);if((p|0)==25){while(1){p=0;b=b+2|0;r=b;if((b|0)==(e|0)){p=32;break}q=b;if((a[r+1|0]|0)==0){s=d[j+76+(d[q]|0)|0]|0}else{s=gta(a[q+1|0]|0,a[b]|0)|0}if((s|0)==10|(s|0)==21){p=25;continue}else if((s|0)!=9){p=31;break}if((b+2|0)!=(e|0)){p=25}else{p=31;break}}if((p|0)==31){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((p|0)==32){c[f>>2]=r;k=15;l=k;i=h;return l|0}}else if((p|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((p|0)==77){b:while(1){p=0;if((b|0)==(e|0)){p=126;break}r=b;if((a[b+1|0]|0)==0){t=d[j+76+(d[r]|0)|0]|0}else{t=gta(a[r+1|0]|0,a[b]|0)|0}switch(t|0){case 29:{if((c[197496+((d[198776+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){p=83;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 34:{p=116;break b;break};case 23:{b=b+2|0;r=o;if((r|0)==41){o=19;p=77;continue b}else if((r|0)!=18){p=77;continue b}if((b|0)==(e|0)){p=97;break b}o=41;r=b;if((a[b+1|0]|0)==0){u=d[j+76+(d[r]|0)|0]|0}else{u=gta(a[r+1|0]|0,a[b]|0)|0}switch(u|0){case 6:{p=108;break b;break};case 5:{p=105;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[197496+((d[198776+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){p=103;break b}break};case 7:{p=111;break b;break};default:{o=19;p=77;continue b}}b=b+2|0;p=77;continue b;break};case 33:{p=119;break b;break};case 15:{p=122;break b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{p=94;break b;break};case 6:{p=88;break b;break};case 5:{p=85;break b;break};case 7:{p=91;break b;break};default:{p=125;break b}}b=b+2|0;p=77}if((p|0)==83){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((p|0)==85){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==88){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==91){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==94){c[f>>2]=b;k=o;l=k;i=h;return l|0}else if((p|0)==97){k=-1;l=k;i=h;return l|0}else if((p|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((p|0)==105){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==108){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==111){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==116){e=b;if((o|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=32;l=k;i=h;return l|0}}else if((p|0)==119){e=b;if((o|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=31;l=k;i=h;return l|0}}else if((p|0)==122){e=b;if((o|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=30;l=k;i=h;return l|0}}else if((p|0)==125){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((p|0)==126){k=0-o|0;l=k;i=h;return l|0}}return 0}function Ssa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=gta(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 9:{b=b+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=gta(a[g+1|0]|0,a[b]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 3:{k=hta(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b+1|0]|0)!=0){break a}if((a[b]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 2:{k=lta(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=68;break}n=b;if((a[o+1|0]|0)==0){q=d[j+76+(d[n]|0)|0]|0}else{q=gta(a[n+1|0]|0,a[b]|0)|0}switch(q|0){case 5:{r=b;if((e-b|0)<2){p=49;break b}b=r+2|0;continue b;break};case 6:{s=b;if((e-b|0)<3){p=52;break b}b=s+3|0;continue b;break};case 7:{t=b;if((e-b|0)<4){p=55;break b}b=t+4|0;continue b;break};case 4:{if((b+2|0)==(e|0)){p=66;break b}do{if((a[b+3|0]|0)==0){if((a[b+2|0]|0)!=93){break}if((b+4|0)==(e|0)){p=66;break b}if((a[b+5|0]|0)==0){if((a[b+4|0]|0)==62){p=65;break b}}b=b+2|0;continue b}}while(0);b=b+2|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{p=66;break b;break};default:{b=b+2|0;continue b}}}if((p|0)==49){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==52){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==65){c[f>>2]=b+4;k=0;l=k;i=h;return l|0}else if((p|0)==66){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==68){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function Tsa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=gta(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=gta(a[g+1|0]|0,a[b]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+1|0]|0)!=0){break a}if((a[b]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;k=40;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=57;break}n=b;if((a[o+1|0]|0)==0){q=d[j+76+(d[n]|0)|0]|0}else{q=gta(a[n+1|0]|0,a[b]|0)|0}switch(q|0){case 5:{r=b;if((e-b|0)<2){p=47;break b}b=r+2|0;continue b;break};case 6:{s=b;if((e-b|0)<3){p=50;break b}b=s+3|0;continue b;break};case 7:{t=b;if((e-b|0)<4){p=53;break b}b=t+4|0;continue b;break};case 4:case 10:case 9:case 8:case 1:case 0:{p=55;break b;break};default:{b=b+2|0;continue b}}}if((p|0)==47){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==50){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==53){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==57){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}



function XA(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[63880]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=57624;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&127](mb,m,25056,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]}jA(t,c[ib>>2]|0,jb);jb=+h[t>>3];kA(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);jb=+h[v>>3];jA(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);pb=+h[w>>3];kA(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+592>>3];qb=+zd(1.0e-13,+(+h[w+600>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+nwa(c[ib>>2]|0,qb,25128,25048,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(pb- +yd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{jA(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);sb=+h[z>>3];kA(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);sb=+h[B>>3];jA(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);jb=+h[C>>3];kA(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+zd(1.0e-13,+(+h[C+600>>3]- +h[E>>3]));pb=1.0- +h[C+592>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+nwa(c[ib>>2]|0,jb,25128,25048,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{jA(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);vb=+h[F>>3];kA(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);vb=+h[H>>3];jA(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);sb=+h[I>>3];kA(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);sb=+h[K>>3];jA(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);jb=+h[L>>3];kA(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+600>>3]- +h[N>>3])|0)<<24>>24==0){jA(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);jb=+h[O>>3];kA(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Q,c[ib>>2]|0,+h[P+584>>3],+h[P+1240>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(R,c[ib>>2]|0,+h[Q+584>>3],+h[Q+1240>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(S,c[ib>>2]|0,jb,pb,+h[Q+584>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+1240>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+1256>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}jA(T,c[ib>>2]|0,+h[xb+584>>3]);qb=+h[T>>3];kA(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);qb=+h[V>>3];jA(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);pb=+h[W>>3];kA(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);pb=+h[Y>>3];jA(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);jb=+h[Z>>3];kA(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA($,c[ib>>2]|0,+h[_+584>>3],+h[_+1240>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(aa,c[ib>>2]|0,+h[$+584>>3],+h[$+1240>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(ba,c[ib>>2]|0,jb,rb,+h[$+584>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+1240>>3],0.0);zb=+h[ba>>3];jA(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);rb=+h[ca>>3];kA(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+600>>3];Ab=+zd(1.0e-13,+(jb-qb));qb=Ab*+zd(1.0e-13,+(jb-pb));pb=+h[ea+1248>>3];Ab=-(pb*+zd(1.0e-13,+(jb-sb)));sb=+h[ea+592>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+nwa(c[ib>>2]|0,qb,25432,25048,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+592>>3];Cb=+h[ca+600>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+zd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+nwa(c[ib>>2]|0,Eb,25128,25048,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+1248>>3]-wb}wb=+h[tb+584>>3];if(wb>0.0){Gb=wb}else{tb=c[63880]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=57624;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&127](Db,l,25056,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]}if(Gb>0.0){Hb=Gb}else{r=c[63880]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=57624;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&127](l,j,25056,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]}jA(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];kA(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);Hb=+h[ia>>3];jA(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);Fb=+h[ja>>3];kA(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3];if(zb>0.0){Ib=zb}else{la=c[63880]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=57624;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&127](ka,g,25056,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]}if(Ib>0.0){Jb=Ib}else{p=c[63880]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=57624;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&127](g,f,25056,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]}if(Jb>0.0){Kb=Jb}else{o=c[63880]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=57624;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&127](f,e,25056,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]}qb=Kb+-273.15;lA(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];jA(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);qb=+h[na>>3];kA(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);qb=+h[pa>>3];jA(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);Eb=+h[qa>>3];kA(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+592>>3];rb=+zd(1.0e-13,+(+h[qa+600>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+nwa(c[ib>>2]|0,rb,25128,25048,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(Eb- +yd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{jA(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);Lb=+h[ta>>3];kA(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);Lb=+h[va>>3];jA(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);qb=+h[wa>>3];kA(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+zd(1.0e-13,+(+h[wa+600>>3]- +h[ya>>3]));Eb=1.0- +h[wa+592>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+nwa(c[ib>>2]|0,qb,25128,25048,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{jA(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);Ob=+h[za>>3];kA(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);Ob=+h[Ba>>3];jA(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);Lb=+h[Ca>>3];kA(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);Lb=+h[Ea>>3];jA(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);qb=+h[Fa>>3];kA(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+600>>3]- +h[Ha>>3])|0)<<24>>24==0){jA(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);qb=+h[Ia>>3];kA(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Ka,c[ib>>2]|0,+h[Ja+584>>3],+h[Ja+1240>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(La,c[ib>>2]|0,+h[Ka+584>>3],+h[Ka+1240>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+584>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+1240>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+1256>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}jA(Na,c[ib>>2]|0,+h[Qb+584>>3]);rb=+h[Na>>3];kA(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);rb=+h[Pa>>3];jA(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);Eb=+h[Qa>>3];kA(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);Eb=+h[Sa>>3];jA(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);qb=+h[Ta>>3];kA(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Va,c[ib>>2]|0,+h[Ua+584>>3],+h[Ua+1240>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(Wa,c[ib>>2]|0,+h[Va+584>>3],+h[Va+1240>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Xa,c[ib>>2]|0,qb,Bb,+h[Va+584>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+1240>>3],0.0);Cb=+h[Xa>>3];jA(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);Bb=+h[Ya>>3];kA(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+600>>3];vb=+zd(1.0e-13,+(qb-rb));rb=vb*+zd(1.0e-13,+(qb-Eb));Eb=+h[Za+1248>>3];vb=-(Eb*+zd(1.0e-13,+(qb-Lb)));Lb=+h[Za+592>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+nwa(c[ib>>2]|0,rb,25432,25048,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+592>>3];Tb=+h[Ya+600>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+zd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+nwa(c[ib>>2]|0,Vb,25128,25048,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+1248>>3]-Pb}Pb=+h[Mb+584>>3];Wb=Pb+-273.15;Cb=+h[Mb+1240>>3];sA($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];jA(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);Pb=+h[ab>>3];kA(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);Pb=+h[cb>>3];jA(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);Wb=+h[db>>3];kA(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+584>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+nwa(c[ib>>2]|0,rb,26040,25048,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+584>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+1248>>3]-ub);ub=+h[Yb+1240>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+nwa(c[ib>>2]|0,Xb,26040,25048,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+1240>>3];ac=+h[Yb+584>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+Nxa(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+592>>3];Gb=+zd(1.0e-13,+(+h[Yb+600>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+nwa(c[ib>>2]|0,Gb,25128,25048,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +zd(+(ac- +yd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+584>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+nwa(c[ib>>2]|0,ec,26040,25048,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+584>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+1248>>3];ic=+h[gc+1240>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+nwa(c[ib>>2]|0,fc,26040,25048,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+1240>>3];kc=+h[gc+584>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+Nxa(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+592>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+zd(1.0e-13,+(+h[gc+600>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9248|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9248|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+nwa(c[ib>>2]|0,Nb,25128,25048,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9248|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function YA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7784>>3]=1.0- +h[b+592>>3];i=i;return}function ZA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+592>>3];v=l;h[k>>3]=+h[t+7784>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];gxa(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+600>>3];w=+h[t+584>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];vz(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Bz(q,g,f);w=+h[q>>3];q=j;h[k>>3]=.99;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];gxa(o,2,.01,j);j=c[l>>2]|0;u=+h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+9800>>3];q=e;f=o;c[q+0>>2]=c[f+0>>2];c[q+4>>2]=c[f+4>>2];c[q+8>>2]=c[f+8>>2];vz(p,j,15.0e4,u,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Bz(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+7096>>3]=+h[d+112>>3]*(w- +h[r>>3])*+h[d+1536>>3];i=b;return}function _A(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+592>>3];p=f;h[k>>3]=+h[n+7784>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+600>>3];q=+h[p+584>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+9576>>3]=+h[l>>3];i=b;return}function $A(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;iA(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+560>>3]);if((Aza(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+576>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+1232>>3]*.999;l=j;m=l+8688|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;xA(e,c[f>>2]|0,+h[d+560>>3],+h[d+1216>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+8688|0;n=m;h[n>>3]=k;i=b;return}}function aB(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[63880]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=57624;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&127](mb,m,26072,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]}jA(t,c[ib>>2]|0,jb);jb=+h[t>>3];kA(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);jb=+h[v>>3];jA(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);pb=+h[w>>3];kA(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+568>>3];qb=+zd(1.0e-13,+(+h[w+576>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+nwa(c[ib>>2]|0,qb,26144,26064,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(pb- +yd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{jA(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);sb=+h[z>>3];kA(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);sb=+h[B>>3];jA(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);jb=+h[C>>3];kA(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+zd(1.0e-13,+(+h[C+576>>3]- +h[E>>3]));pb=1.0- +h[C+568>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+nwa(c[ib>>2]|0,jb,26144,26064,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{jA(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);vb=+h[F>>3];kA(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);vb=+h[H>>3];jA(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);sb=+h[I>>3];kA(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);sb=+h[K>>3];jA(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);jb=+h[L>>3];kA(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+576>>3]- +h[N>>3])|0)<<24>>24==0){jA(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);jb=+h[O>>3];kA(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Q,c[ib>>2]|0,+h[P+560>>3],+h[P+1216>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(R,c[ib>>2]|0,+h[Q+560>>3],+h[Q+1216>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(S,c[ib>>2]|0,jb,pb,+h[Q+560>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+1216>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+1232>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}jA(T,c[ib>>2]|0,+h[xb+560>>3]);qb=+h[T>>3];kA(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);qb=+h[V>>3];jA(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);pb=+h[W>>3];kA(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);pb=+h[Y>>3];jA(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);jb=+h[Z>>3];kA(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA($,c[ib>>2]|0,+h[_+560>>3],+h[_+1216>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(aa,c[ib>>2]|0,+h[$+560>>3],+h[$+1216>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(ba,c[ib>>2]|0,jb,rb,+h[$+560>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+1216>>3],0.0);zb=+h[ba>>3];jA(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);rb=+h[ca>>3];kA(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+576>>3];Ab=+zd(1.0e-13,+(jb-qb));qb=Ab*+zd(1.0e-13,+(jb-pb));pb=+h[ea+1224>>3];Ab=-(pb*+zd(1.0e-13,+(jb-sb)));sb=+h[ea+568>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+nwa(c[ib>>2]|0,qb,26448,26064,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+568>>3];Cb=+h[ca+576>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+zd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+nwa(c[ib>>2]|0,Eb,26144,26064,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+1224>>3]-wb}wb=+h[tb+560>>3];if(wb>0.0){Gb=wb}else{tb=c[63880]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=57624;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&127](Db,l,26072,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]}if(Gb>0.0){Hb=Gb}else{r=c[63880]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=57624;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&127](l,j,26072,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]}jA(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];kA(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);Hb=+h[ia>>3];jA(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);Fb=+h[ja>>3];kA(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3];if(zb>0.0){Ib=zb}else{la=c[63880]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=57624;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&127](ka,g,26072,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]}if(Ib>0.0){Jb=Ib}else{p=c[63880]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=57624;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&127](g,f,26072,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]}if(Jb>0.0){Kb=Jb}else{o=c[63880]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=57624;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&127](f,e,26072,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]}qb=Kb+-273.15;lA(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];jA(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);qb=+h[na>>3];kA(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);qb=+h[pa>>3];jA(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);Eb=+h[qa>>3];kA(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+568>>3];rb=+zd(1.0e-13,+(+h[qa+576>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+nwa(c[ib>>2]|0,rb,26144,26064,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(Eb- +yd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{jA(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);Lb=+h[ta>>3];kA(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);Lb=+h[va>>3];jA(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);qb=+h[wa>>3];kA(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+zd(1.0e-13,+(+h[wa+576>>3]- +h[ya>>3]));Eb=1.0- +h[wa+568>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+nwa(c[ib>>2]|0,qb,26144,26064,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{jA(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);Ob=+h[za>>3];kA(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);Ob=+h[Ba>>3];jA(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);Lb=+h[Ca>>3];kA(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);Lb=+h[Ea>>3];jA(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);qb=+h[Fa>>3];kA(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+576>>3]- +h[Ha>>3])|0)<<24>>24==0){jA(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);qb=+h[Ia>>3];kA(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Ka,c[ib>>2]|0,+h[Ja+560>>3],+h[Ja+1216>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(La,c[ib>>2]|0,+h[Ka+560>>3],+h[Ka+1216>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+560>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+1216>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+1232>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}jA(Na,c[ib>>2]|0,+h[Qb+560>>3]);rb=+h[Na>>3];kA(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);rb=+h[Pa>>3];jA(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);Eb=+h[Qa>>3];kA(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);Eb=+h[Sa>>3];jA(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);qb=+h[Ta>>3];kA(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Va,c[ib>>2]|0,+h[Ua+560>>3],+h[Ua+1216>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(Wa,c[ib>>2]|0,+h[Va+560>>3],+h[Va+1216>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Xa,c[ib>>2]|0,qb,Bb,+h[Va+560>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+1216>>3],0.0);Cb=+h[Xa>>3];jA(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);Bb=+h[Ya>>3];kA(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+576>>3];vb=+zd(1.0e-13,+(qb-rb));rb=vb*+zd(1.0e-13,+(qb-Eb));Eb=+h[Za+1224>>3];vb=-(Eb*+zd(1.0e-13,+(qb-Lb)));Lb=+h[Za+568>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+nwa(c[ib>>2]|0,rb,26448,26064,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+568>>3];Tb=+h[Ya+576>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+zd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+nwa(c[ib>>2]|0,Vb,26144,26064,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+1224>>3]-Pb}Pb=+h[Mb+560>>3];Wb=Pb+-273.15;Cb=+h[Mb+1216>>3];sA($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];jA(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);Pb=+h[ab>>3];kA(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);Pb=+h[cb>>3];jA(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);Wb=+h[db>>3];kA(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+560>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+nwa(c[ib>>2]|0,rb,27056,26064,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+560>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+1224>>3]-ub);ub=+h[Yb+1216>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+nwa(c[ib>>2]|0,Xb,27056,26064,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+1216>>3];ac=+h[Yb+560>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+Nxa(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+568>>3];Gb=+zd(1.0e-13,+(+h[Yb+576>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+nwa(c[ib>>2]|0,Gb,26144,26064,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +zd(+(ac- +yd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+560>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+nwa(c[ib>>2]|0,ec,27056,26064,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+560>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+1224>>3];ic=+h[gc+1216>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+nwa(c[ib>>2]|0,fc,27056,26064,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+1216>>3];kc=+h[gc+560>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+Nxa(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+568>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+zd(1.0e-13,+(+h[gc+576>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9264|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9264|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+nwa(c[ib>>2]|0,Nb,26144,26064,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9264|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function bB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;gxa(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+568>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+576>>3];l=+h[a+560>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];tA(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6880>>3]=+h[f>>3];i=b;return}function cB(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;iA(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+560>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+6792>>3]=+yd(+(+h[d>>3]),+(+h[a+576>>3]*.999));i=b;return}function dB(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[63880]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=57624;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&127](mb,m,27088,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]}jA(t,c[ib>>2]|0,jb);jb=+h[t>>3];kA(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);jb=+h[v>>3];jA(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);pb=+h[w>>3];kA(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+544>>3];qb=+zd(1.0e-13,+(+h[w+552>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+nwa(c[ib>>2]|0,qb,27160,27080,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(pb- +yd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{jA(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);sb=+h[z>>3];kA(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);sb=+h[B>>3];jA(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);jb=+h[C>>3];kA(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+zd(1.0e-13,+(+h[C+552>>3]- +h[E>>3]));pb=1.0- +h[C+544>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+nwa(c[ib>>2]|0,jb,27160,27080,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{jA(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);vb=+h[F>>3];kA(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);vb=+h[H>>3];jA(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);sb=+h[I>>3];kA(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);sb=+h[K>>3];jA(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);jb=+h[L>>3];kA(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+552>>3]- +h[N>>3])|0)<<24>>24==0){jA(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);jb=+h[O>>3];kA(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Q,c[ib>>2]|0,+h[P+536>>3],+h[P+1192>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(R,c[ib>>2]|0,+h[Q+536>>3],+h[Q+1192>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(S,c[ib>>2]|0,jb,pb,+h[Q+536>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+1192>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+1208>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}jA(T,c[ib>>2]|0,+h[xb+536>>3]);qb=+h[T>>3];kA(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);qb=+h[V>>3];jA(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);pb=+h[W>>3];kA(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);pb=+h[Y>>3];jA(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);jb=+h[Z>>3];kA(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA($,c[ib>>2]|0,+h[_+536>>3],+h[_+1192>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(aa,c[ib>>2]|0,+h[$+536>>3],+h[$+1192>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(ba,c[ib>>2]|0,jb,rb,+h[$+536>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+1192>>3],0.0);zb=+h[ba>>3];jA(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);rb=+h[ca>>3];kA(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+552>>3];Ab=+zd(1.0e-13,+(jb-qb));qb=Ab*+zd(1.0e-13,+(jb-pb));pb=+h[ea+1200>>3];Ab=-(pb*+zd(1.0e-13,+(jb-sb)));sb=+h[ea+544>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+nwa(c[ib>>2]|0,qb,27464,27080,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+544>>3];Cb=+h[ca+552>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+zd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+nwa(c[ib>>2]|0,Eb,27160,27080,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+1200>>3]-wb}wb=+h[tb+536>>3];if(wb>0.0){Gb=wb}else{tb=c[63880]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=57624;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&127](Db,l,27088,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]}if(Gb>0.0){Hb=Gb}else{r=c[63880]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=57624;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&127](l,j,27088,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]}jA(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];kA(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);Hb=+h[ia>>3];jA(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);Fb=+h[ja>>3];kA(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3];if(zb>0.0){Ib=zb}else{la=c[63880]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=57624;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&127](ka,g,27088,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]}if(Ib>0.0){Jb=Ib}else{p=c[63880]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=57624;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&127](g,f,27088,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]}if(Jb>0.0){Kb=Jb}else{o=c[63880]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=57624;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&127](f,e,27088,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]}qb=Kb+-273.15;lA(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];jA(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);qb=+h[na>>3];kA(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);qb=+h[pa>>3];jA(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);Eb=+h[qa>>3];kA(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+544>>3];rb=+zd(1.0e-13,+(+h[qa+552>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+nwa(c[ib>>2]|0,rb,27160,27080,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(Eb- +yd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{jA(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);Lb=+h[ta>>3];kA(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);Lb=+h[va>>3];jA(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);qb=+h[wa>>3];kA(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+zd(1.0e-13,+(+h[wa+552>>3]- +h[ya>>3]));Eb=1.0- +h[wa+544>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+nwa(c[ib>>2]|0,qb,27160,27080,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{jA(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);Ob=+h[za>>3];kA(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);Ob=+h[Ba>>3];jA(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);Lb=+h[Ca>>3];kA(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);Lb=+h[Ea>>3];jA(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);qb=+h[Fa>>3];kA(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+552>>3]- +h[Ha>>3])|0)<<24>>24==0){jA(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);qb=+h[Ia>>3];kA(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Ka,c[ib>>2]|0,+h[Ja+536>>3],+h[Ja+1192>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(La,c[ib>>2]|0,+h[Ka+536>>3],+h[Ka+1192>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+536>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+1192>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+1208>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}jA(Na,c[ib>>2]|0,+h[Qb+536>>3]);rb=+h[Na>>3];kA(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);rb=+h[Pa>>3];jA(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);Eb=+h[Qa>>3];kA(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);Eb=+h[Sa>>3];jA(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);qb=+h[Ta>>3];kA(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Va,c[ib>>2]|0,+h[Ua+536>>3],+h[Ua+1192>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(Wa,c[ib>>2]|0,+h[Va+536>>3],+h[Va+1192>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Xa,c[ib>>2]|0,qb,Bb,+h[Va+536>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+1192>>3],0.0);Cb=+h[Xa>>3];jA(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);Bb=+h[Ya>>3];kA(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+552>>3];vb=+zd(1.0e-13,+(qb-rb));rb=vb*+zd(1.0e-13,+(qb-Eb));Eb=+h[Za+1200>>3];vb=-(Eb*+zd(1.0e-13,+(qb-Lb)));Lb=+h[Za+544>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+nwa(c[ib>>2]|0,rb,27464,27080,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+544>>3];Tb=+h[Ya+552>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+zd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+nwa(c[ib>>2]|0,Vb,27160,27080,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+1200>>3]-Pb}Pb=+h[Mb+536>>3];Wb=Pb+-273.15;Cb=+h[Mb+1192>>3];sA($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];jA(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);Pb=+h[ab>>3];kA(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);Pb=+h[cb>>3];jA(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);Wb=+h[db>>3];kA(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+536>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+nwa(c[ib>>2]|0,rb,28072,27080,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+536>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+1200>>3]-ub);ub=+h[Yb+1192>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+nwa(c[ib>>2]|0,Xb,28072,27080,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+1192>>3];ac=+h[Yb+536>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+Nxa(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+544>>3];Gb=+zd(1.0e-13,+(+h[Yb+552>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+nwa(c[ib>>2]|0,Gb,27160,27080,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +zd(+(ac- +yd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+536>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+nwa(c[ib>>2]|0,ec,28072,27080,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+536>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+1200>>3];ic=+h[gc+1192>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+nwa(c[ib>>2]|0,fc,28072,27080,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+1192>>3];kc=+h[gc+536>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+Nxa(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+544>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+zd(1.0e-13,+(+h[gc+552>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9280|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9280|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+nwa(c[ib>>2]|0,Nb,27160,27080,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9280|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function eB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7768>>3]=1.0- +h[b+544>>3];i=i;return}function fB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+544>>3];p=f;h[k>>3]=+h[n+7768>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+552>>3];q=+h[p+536>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+9648>>3]=+h[l>>3];i=b;return}function gB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+544>>3];p=f;h[k>>3]=+h[n+7768>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+552>>3];q=+h[p+536>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+9592>>3]=+h[l>>3];i=b;return}function hB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;gxa(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+544>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+552>>3];l=+h[a+536>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];tA(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6768>>3]=+h[f>>3];i=b;return}function iB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;iA(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+536>>3]);if((Aza(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+552>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+1208>>3]*.999;l=j;m=l+8712|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;xA(e,c[f>>2]|0,+h[d+536>>3],+h[d+1192>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+8712|0;n=m;h[n>>3]=k;i=b;return}}function jB(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;iA(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+536>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+6680>>3]=+yd(+(+h[d>>3]),+(+h[a+552>>3]*.999));i=b;return}function kB(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6680>>3];k=+zd(1.0e-13,+(+h[g+552>>3]-j));l=+h[g+7768>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+nwa(c[b+536>>2]|0,k,28104,28096,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+7904|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=Cza(1.0e-13,+h[f+552>>3]- +h[f+6680>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+6680>>3];j=+h[x+552>>3];k=+zd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+8624>>3];k=+h[x+7768>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+1208>>3]- +h[x+8712>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+1208>>3]- +h[x+8712>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+1208>>3]- +h[x+8712>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+1208>>3]- +h[x+8712>>3]}K=(y-k*J)/+nwa(c[b+536>>2]|0,l,28168,28096,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+7768>>3];C=+h[L+6680>>3];D=+h[L+552>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+8712>>3];m=+zd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+nwa(c[b+536>>2]|0,m,28104,28096,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+7904|0;w=v;h[w>>3]=n;i=d;return}function lB(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6680>>3];k=+zd(1.0e-13,+(+h[g+552>>3]-j));l=+h[g+7768>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+nwa(c[b+536>>2]|0,k,28104,28296,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6696>>3]=+yd(+(j*n*.6219647130774989),1.0);i=d;return}function mB(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(Cza(+h[a+544>>3]- +h[a+6696>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+8704|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+1200>>3]- +h[a+7904>>3];g=a;j=g+8704|0;k=j;h[k>>3]=f;i=b;return}function nB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7896>>3]=+h[b+1200>>3]- +h[b+8704>>3];i=i;return}function oB(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+6712>>3]=+zd(+(+h[d+544>>3]- +h[d+6696>>3]),0.0);i=b;return}function pB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6704>>3]=+h[b+544>>3]- +h[b+6712>>3];i=i;return}function qB(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6712>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+8704>>3];o=+h[g+8624>>3]*k+ +h[g+7768>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+nwa(c[b+536>>2]|0,l,28312,28304,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+8704>>3];q=+h[v+6712>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+7896>>3]*(1.0-q)+ +h[r+6704>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+8696|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+8696|0;C=B;h[C>>3]=z;i=d;return}p=t/+nwa(c[b+536>>2]|0,l,28312,28304,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+8696|0;C=B;h[C>>3]=z;i=d;return}function rB(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6712>>3];k=1.0-j;l=+h[g+7768>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+nwa(c[b+536>>2]|0,k,28360,28352,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+6712>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+6704>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+6744|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+6744|0;z=y;h[z>>3]=w;i=d;return}l=m/+nwa(c[b+536>>2]|0,p,28360,28352,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+6744|0;z=y;h[z>>3]=w;i=d;return}function sB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6752>>3]=+h[b+6768>>3]- +h[b+6744>>3]*+h[b+536>>3];i=i;return}function tB(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+536>>3]*+h[g+6744>>3];k=+h[g+552>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+6760|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+6760|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,28400,28392,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6760|0;p=o;h[p>>3]=m;i=d;return}function uB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7664>>3]=+h[b+9984>>3]*+h[b+6760>>3];i=i;return}function vB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;gxa(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+592>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+600>>3];l=+h[a+584>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];tA(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6992>>3]=+h[f>>3];i=b;return}function wB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+592>>3];p=f;h[k>>3]=+h[n+7784>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+600>>3];q=+h[p+584>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+9632>>3]=+h[l>>3];i=b;return}function xB(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;iA(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+584>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+6904>>3]=+yd(+(+h[d>>3]),+(+h[a+600>>3]*.999));i=b;return}function yB(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6904>>3];k=+zd(1.0e-13,+(+h[g+600>>3]-j));l=+h[g+7784>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+nwa(c[b+536>>2]|0,k,28448,28440,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6920>>3]=+yd(+(j*n*.6219647130774989),1.0);i=d;return}function zB(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+6936>>3]=+zd(+(+h[d+592>>3]- +h[d+6920>>3]),0.0);i=b;return}function AB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6928>>3]=+h[b+592>>3]- +h[b+6936>>3];i=i;return}function BB(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6936>>3];k=1.0-j;l=+h[g+7784>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+nwa(c[b+536>>2]|0,k,28520,28512,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+6936>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+6928>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+6968|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+6968|0;z=y;h[z>>3]=w;i=d;return}l=m/+nwa(c[b+536>>2]|0,p,28520,28512,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+6968|0;z=y;h[z>>3]=w;i=d;return}function CB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6976>>3]=+h[b+6992>>3]- +h[b+6968>>3]*+h[b+584>>3];i=i;return}function DB(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+584>>3]*+h[g+6968>>3];k=+h[g+600>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+6984|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+6984|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,28560,28552,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6984|0;p=o;h[p>>3]=m;i=d;return}function EB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7648>>3]=+h[b+9968>>3]*+h[b+6984>>3];i=i;return}function FB(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6904>>3];k=+zd(1.0e-13,+(+h[g+600>>3]-j));l=+h[g+7784>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+nwa(c[b+536>>2]|0,k,28448,28600,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+7856|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=Cza(1.0e-13,+h[f+600>>3]- +h[f+6904>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+6904>>3];j=+h[x+600>>3];k=+zd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+8608>>3];k=+h[x+7784>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+1256>>3]- +h[x+8664>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+1256>>3]- +h[x+8664>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+1256>>3]- +h[x+8664>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+1256>>3]- +h[x+8664>>3]}K=(y-k*J)/+nwa(c[b+536>>2]|0,l,28608,28600,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+7784>>3];C=+h[L+6904>>3];D=+h[L+600>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+8664>>3];m=+zd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+nwa(c[b+536>>2]|0,m,28448,28600,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+7856|0;w=v;h[w>>3]=n;i=d;return}function GB(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(Cza(+h[a+592>>3]- +h[a+6920>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+8656|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+1248>>3]- +h[a+7856>>3];g=a;j=g+8656|0;k=j;h[k>>3]=f;i=b;return}function HB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7848>>3]=+h[b+1248>>3]- +h[b+8656>>3];i=i;return}function IB(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6936>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+8656>>3];o=+h[g+8608>>3]*k+ +h[g+7784>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+nwa(c[b+536>>2]|0,l,28744,28736,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+8656>>3];q=+h[v+6936>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+7848>>3]*(1.0-q)+ +h[r+6928>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+8648|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+8648|0;C=B;h[C>>3]=z;i=d;return}p=t/+nwa(c[b+536>>2]|0,l,28744,28736,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+8648|0;C=B;h[C>>3]=z;i=d;return}function JB(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6968>>3];k=+h[g+584>>3];l=j*k;m=l*l;n=+h[g+1256>>3]*l- +h[g+600>>3]*(j*+h[g+1240>>3]+k*+h[g+8648>>3]);if(m!=0.0){o=g;p=n/m;q=o;r=q+9256|0;s=r;h[s>>3]=p;i=d;return}if(n==0.0){o=g;p=n;q=o;r=q+9256|0;s=r;h[s>>3]=p;i=d;return}k=n/+nwa(c[b+536>>2]|0,m,28792,28784,+h[f>>3],(a[b+319|0]|0)!=0|0);o=c[(c[c[e>>2]>>2]|0)+8>>2]|0;p=k;q=o;r=q+9256|0;s=r;h[s>>3]=p;i=d;return}function KB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7568>>3]=+h[b+9968>>3]*+h[b+9256>>3];i=i;return}function LB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7528>>3]=+h[b+592>>3]*+h[b+7568>>3]+ +h[b+1248>>3]*+h[b+7648>>3];i=i;return}function MB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7840>>3]=+h[b+9248>>3]+(-(+h[b+6968>>3]*+h[b+1240>>3])- +h[b+8648>>3]*+h[b+584>>3]);i=i;return}function NB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8448>>3]=+h[b+7648>>3]*+h[b+7840>>3]+ +h[b+7568>>3]*+h[b+6976>>3];i=i;return}function OB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7776>>3]=1.0- +h[b+568>>3];i=i;return}function PB(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6792>>3];k=+zd(1.0e-13,+(+h[g+576>>3]-j));l=+h[g+7776>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+nwa(c[b+536>>2]|0,k,28848,28840,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6808>>3]=+yd(+(j*n*.6219647130774989),1.0);i=d;return}function QB(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+6824>>3]=+zd(+(+h[d+568>>3]- +h[d+6808>>3]),0.0);i=b;return}function RB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6816>>3]=+h[b+568>>3]- +h[b+6824>>3];i=i;return}function SB(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6824>>3];k=1.0-j;l=+h[g+7776>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+nwa(c[b+536>>2]|0,k,28920,28912,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+6824>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+6816>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+6856|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+6856|0;z=y;h[z>>3]=w;i=d;return}l=m/+nwa(c[b+536>>2]|0,p,28920,28912,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+6856|0;z=y;h[z>>3]=w;i=d;return}function TB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6864>>3]=+h[b+6880>>3]- +h[b+6856>>3]*+h[b+560>>3];i=i;return}function UB(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+560>>3]*+h[g+6856>>3];k=+h[g+576>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+6872|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+6872|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,28960,28952,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6872|0;p=o;h[p>>3]=m;i=d;return}function VB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7656>>3]=+h[b+9976>>3]*+h[b+6872>>3];i=i;return}function WB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+544>>3];v=l;h[k>>3]=+h[t+7768>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];gxa(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+552>>3];w=+h[t+536>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];vz(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Bz(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+568>>3];f=j;h[k>>3]=+h[q+7776>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];gxa(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+576>>3];y=+h[f+560>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];vz(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Bz(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+7112>>3]=(+h[d+120>>3]+ +h[d+128>>3])*(w- +h[r>>3])*+h[d+1536>>3]*.5;i=b;return}function XB(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6792>>3];k=+zd(1.0e-13,+(+h[g+576>>3]-j));l=+h[g+7776>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+nwa(c[b+536>>2]|0,k,28848,29e3,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+7880|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=Cza(1.0e-13,+h[f+576>>3]- +h[f+6792>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+6792>>3];j=+h[x+576>>3];k=+zd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+8616>>3];k=+h[x+7776>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+1232>>3]- +h[x+8688>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+1232>>3]- +h[x+8688>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+1232>>3]- +h[x+8688>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+1232>>3]- +h[x+8688>>3]}K=(y-k*J)/+nwa(c[b+536>>2]|0,l,29008,29e3,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+7776>>3];C=+h[L+6792>>3];D=+h[L+576>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+8688>>3];m=+zd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+nwa(c[b+536>>2]|0,m,28848,29e3,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+7880|0;w=v;h[w>>3]=n;i=d;return}function YB(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(Cza(+h[a+568>>3]- +h[a+6808>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+8680|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+1224>>3]- +h[a+7880>>3];g=a;j=g+8680|0;k=j;h[k>>3]=f;i=b;return}function ZB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7872>>3]=+h[b+1224>>3]- +h[b+8680>>3];i=i;return}function _B(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6824>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+8680>>3];o=+h[g+8616>>3]*k+ +h[g+7776>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+nwa(c[b+536>>2]|0,l,29144,29136,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+8680>>3];q=+h[v+6824>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+7872>>3]*(1.0-q)+ +h[r+6816>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+8672|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+8672|0;C=B;h[C>>3]=z;i=d;return}p=t/+nwa(c[b+536>>2]|0,l,29144,29136,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+8672|0;C=B;h[C>>3]=z;i=d;return}function $B(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6856>>3];k=+h[g+560>>3];l=j*k;m=l*l;n=+h[g+1232>>3]*l- +h[g+576>>3]*(j*+h[g+1216>>3]+k*+h[g+8672>>3]);if(m!=0.0){o=g;p=n/m;q=o;r=q+9272|0;s=r;h[s>>3]=p;i=d;return}if(n==0.0){o=g;p=n;q=o;r=q+9272|0;s=r;h[s>>3]=p;i=d;return}k=n/+nwa(c[b+536>>2]|0,m,29192,29184,+h[f>>3],(a[b+319|0]|0)!=0|0);o=c[(c[c[e>>2]>>2]|0)+8>>2]|0;p=k;q=o;r=q+9272|0;s=r;h[s>>3]=p;i=d;return}function aC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7576>>3]=+h[b+9976>>3]*+h[b+9272>>3];i=i;return}function bC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7536>>3]=+h[b+568>>3]*+h[b+7576>>3]+ +h[b+1224>>3]*+h[b+7656>>3];i=i;return}function cC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7864>>3]=+h[b+9264>>3]+(-(+h[b+6856>>3]*+h[b+1216>>3])- +h[b+8672>>3]*+h[b+560>>3]);i=i;return}function dC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8456>>3]=+h[b+7656>>3]*+h[b+7864>>3]+ +h[b+7576>>3]*+h[b+6864>>3];i=i;return}function eC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+568>>3];p=f;h[k>>3]=+h[n+7776>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+576>>3];q=+h[p+560>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Fz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+9584>>3]=+h[l>>3];i=b;return}function fC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+568>>3];v=l;h[k>>3]=+h[t+7776>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];gxa(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+576>>3];w=+h[t+560>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];vz(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Bz(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+592>>3];f=j;h[k>>3]=+h[q+7784>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];gxa(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+600>>3];y=+h[f+584>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];vz(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Bz(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+7104>>3]=(+h[d+112>>3]+ +h[d+120>>3])*(w- +h[r>>3])*+h[d+1536>>3]*.5;i=b;return}function gC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+568>>3];p=f;h[k>>3]=+h[n+7776>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gxa(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+576>>3];q=+h[p+560>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];vz(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Cz(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+9640>>3]=+h[l>>3];i=b;return}function hC(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6744>>3];k=+h[g+536>>3];l=j*k;m=l*l;n=+h[g+1208>>3]*l- +h[g+552>>3]*(j*+h[g+1192>>3]+k*+h[g+8696>>3]);if(m!=0.0){o=g;p=n/m;q=o;r=q+9288|0;s=r;h[s>>3]=p;i=d;return}if(n==0.0){o=g;p=n;q=o;r=q+9288|0;s=r;h[s>>3]=p;i=d;return}k=n/+nwa(c[b+536>>2]|0,m,29248,29240,+h[f>>3],(a[b+319|0]|0)!=0|0);o=c[(c[c[e>>2]>>2]|0)+8>>2]|0;p=k;q=o;r=q+9288|0;s=r;h[s>>3]=p;i=d;return}function iC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7584>>3]=+h[b+9984>>3]*+h[b+9288>>3];i=i;return}function jC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7544>>3]=+h[b+544>>3]*+h[b+7584>>3]+ +h[b+1200>>3]*+h[b+7664>>3];i=i;return}function kC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7888>>3]=+h[b+9280>>3]+(-(+h[b+6744>>3]*+h[b+1192>>3])- +h[b+8696>>3]*+h[b+536>>3]);i=i;return}function lC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8464>>3]=+h[b+7664>>3]*+h[b+7888>>3]+ +h[b+7584>>3]*+h[b+6752>>3];i=i;return}function mC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;iA(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+264>>3]);if((Aza(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+280>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+936>>3]*.999;l=j;m=l+8984|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;xA(e,c[f>>2]|0,+h[d+264>>3],+h[d+920>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+8984|0;n=m;h[n>>3]=k;i=b;return}}



function vT(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0.0;d=i;i=i+16|0;e=d;f=i;i=i+16|0;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+16|0;S=i;i=i+16|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+16|0;X=i;i=i+16|0;Y=i;i=i+16|0;Z=i;i=i+16|0;_=i;i=i+16|0;$=i;i=i+16|0;aa=i;i=i+16|0;ba=i;i=i+16|0;ca=i;i=i+16|0;da=i;i=i+16|0;ea=i;i=i+16|0;fa=i;i=i+16|0;ga=i;i=i+16|0;ha=i;i=i+16|0;ia=i;i=i+16|0;ja=i;i=i+16|0;ka=i;i=i+16|0;la=i;i=i+16|0;ma=i;i=i+16|0;na=i;i=i+16|0;oa=i;i=i+16|0;pa=i;i=i+16|0;qa=i;i=i+16|0;ra=i;i=i+16|0;sa=i;i=i+16|0;ta=i;i=i+16|0;ua=i;i=i+16|0;va=i;i=i+16|0;wa=i;i=i+16|0;xa=i;i=i+16|0;ya=i;i=i+16|0;za=i;i=i+16|0;Aa=i;i=i+16|0;Ba=i;i=i+16|0;Ca=i;i=i+16|0;Da=i;i=i+16|0;Ea=i;i=i+16|0;Fa=i;i=i+16|0;Ga=i;i=i+16|0;Ha=i;i=i+16|0;Ia=i;i=i+16|0;Ja=i;i=i+16|0;Ka=i;i=i+16|0;La=i;i=i+16|0;Ma=i;i=i+16|0;Na=i;i=i+16|0;Oa=i;i=i+16|0;Pa=i;i=i+16|0;Qa=i;i=i+16|0;Ra=i;i=i+8|0;hwa(21,1,60904,Ra);Ra=a+416|0;Sa=c[Ra>>2]|0;Ta=+h[Sa+1568>>3]+ +h[Sa+1592>>3]*-1.0e3;h[b>>3]=Ta;Sa=uT(0)|0;c[Qa>>2]=1;c[Qa+4>>2]=Sa;Sa=Qa+8|0;h[k>>3]=Ta;c[Sa>>2]=c[k>>2];c[Sa+4>>2]=c[k+4>>2];hwa(21,0,60936,Qa);Qa=c[Ra>>2]|0;Ta=+h[Qa+1592>>3]- +h[Qa+1384>>3];h[b+8>>3]=Ta;Qa=uT(1)|0;c[Pa>>2]=2;c[Pa+4>>2]=Qa;Qa=Pa+8|0;h[k>>3]=Ta;c[Qa>>2]=c[k>>2];c[Qa+4>>2]=c[k+4>>2];hwa(21,0,60936,Pa);Pa=a+4|0;Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+1264>>3];h[b+16>>3]=Ta;a=uT(2)|0;c[Oa>>2]=3;c[Oa+4>>2]=a;a=Oa+8|0;h[k>>3]=Ta;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];hwa(21,0,60936,Oa);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+1272>>3];h[b+24>>3]=Ta;Oa=uT(3)|0;c[Na>>2]=4;c[Na+4>>2]=Oa;Oa=Na+8|0;h[k>>3]=Ta;c[Oa>>2]=c[k>>2];c[Oa+4>>2]=c[k+4>>2];hwa(21,0,60936,Na);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+1280>>3];h[b+32>>3]=Ta;Na=uT(4)|0;c[Ma>>2]=5;c[Ma+4>>2]=Na;Na=Ma+8|0;h[k>>3]=Ta;c[Na>>2]=c[k>>2];c[Na+4>>2]=c[k+4>>2];hwa(21,0,60936,Ma);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+1288>>3];h[b+40>>3]=Ta;Ma=uT(5)|0;c[La>>2]=6;c[La+4>>2]=Ma;Ma=La+8|0;h[k>>3]=Ta;c[Ma>>2]=c[k>>2];c[Ma+4>>2]=c[k+4>>2];hwa(21,0,60936,La);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+1296>>3];h[b+48>>3]=Ta;La=uT(6)|0;c[Ka>>2]=7;c[Ka+4>>2]=La;La=Ka+8|0;h[k>>3]=Ta;c[La>>2]=c[k>>2];c[La+4>>2]=c[k+4>>2];hwa(21,0,60936,Ka);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+1304>>3];h[b+56>>3]=Ta;Ka=uT(7)|0;c[Ja>>2]=8;c[Ja+4>>2]=Ka;Ka=Ja+8|0;h[k>>3]=Ta;c[Ka>>2]=c[k>>2];c[Ka+4>>2]=c[k+4>>2];hwa(21,0,60936,Ja);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+1240>>3];h[b+64>>3]=Ta;Ja=uT(8)|0;c[Ia>>2]=9;c[Ia+4>>2]=Ja;Ja=Ia+8|0;h[k>>3]=Ta;c[Ja>>2]=c[k>>2];c[Ja+4>>2]=c[k+4>>2];hwa(21,0,60936,Ia);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+1216>>3];h[b+72>>3]=Ta;Ia=uT(9)|0;c[Ha>>2]=10;c[Ha+4>>2]=Ia;Ia=Ha+8|0;h[k>>3]=Ta;c[Ia>>2]=c[k>>2];c[Ia+4>>2]=c[k+4>>2];hwa(21,0,60936,Ha);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+1192>>3];h[b+80>>3]=Ta;Ha=uT(10)|0;c[Ga>>2]=11;c[Ga+4>>2]=Ha;Ha=Ga+8|0;h[k>>3]=Ta;c[Ha>>2]=c[k>>2];c[Ha+4>>2]=c[k+4>>2];hwa(21,0,60936,Ga);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+1168>>3];h[b+88>>3]=Ta;Ga=uT(11)|0;c[Fa>>2]=12;c[Fa+4>>2]=Ga;Ga=Fa+8|0;h[k>>3]=Ta;c[Ga>>2]=c[k>>2];c[Ga+4>>2]=c[k+4>>2];hwa(21,0,60936,Fa);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+1144>>3];h[b+96>>3]=Ta;Fa=uT(12)|0;c[Ea>>2]=13;c[Ea+4>>2]=Fa;Fa=Ea+8|0;h[k>>3]=Ta;c[Fa>>2]=c[k>>2];c[Fa+4>>2]=c[k+4>>2];hwa(21,0,60936,Ea);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+1256>>3];h[b+104>>3]=Ta;Ea=uT(13)|0;c[Da>>2]=14;c[Da+4>>2]=Ea;Ea=Da+8|0;h[k>>3]=Ta;c[Ea>>2]=c[k>>2];c[Ea+4>>2]=c[k+4>>2];hwa(21,0,60936,Da);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+1232>>3];h[b+112>>3]=Ta;Da=uT(14)|0;c[Ca>>2]=15;c[Ca+4>>2]=Da;Da=Ca+8|0;h[k>>3]=Ta;c[Da>>2]=c[k>>2];c[Da+4>>2]=c[k+4>>2];hwa(21,0,60936,Ca);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+1208>>3];h[b+120>>3]=Ta;Ca=uT(15)|0;c[Ba>>2]=16;c[Ba+4>>2]=Ca;Ca=Ba+8|0;h[k>>3]=Ta;c[Ca>>2]=c[k>>2];c[Ca+4>>2]=c[k+4>>2];hwa(21,0,60936,Ba);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+1184>>3];h[b+128>>3]=Ta;Ba=uT(16)|0;c[Aa>>2]=17;c[Aa+4>>2]=Ba;Ba=Aa+8|0;h[k>>3]=Ta;c[Ba>>2]=c[k>>2];c[Ba+4>>2]=c[k+4>>2];hwa(21,0,60936,Aa);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+1160>>3];h[b+136>>3]=Ta;Aa=uT(17)|0;c[za>>2]=18;c[za+4>>2]=Aa;Aa=za+8|0;h[k>>3]=Ta;c[Aa>>2]=c[k>>2];c[Aa+4>>2]=c[k+4>>2];hwa(21,0,60936,za);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+1248>>3];h[b+144>>3]=Ta;za=uT(18)|0;c[ya>>2]=19;c[ya+4>>2]=za;za=ya+8|0;h[k>>3]=Ta;c[za>>2]=c[k>>2];c[za+4>>2]=c[k+4>>2];hwa(21,0,60936,ya);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+1224>>3];h[b+152>>3]=Ta;ya=uT(19)|0;c[xa>>2]=20;c[xa+4>>2]=ya;ya=xa+8|0;h[k>>3]=Ta;c[ya>>2]=c[k>>2];c[ya+4>>2]=c[k+4>>2];hwa(21,0,60936,xa);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+1200>>3];h[b+160>>3]=Ta;xa=uT(20)|0;c[wa>>2]=21;c[wa+4>>2]=xa;xa=wa+8|0;h[k>>3]=Ta;c[xa>>2]=c[k>>2];c[xa+4>>2]=c[k+4>>2];hwa(21,0,60936,wa);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+1176>>3];h[b+168>>3]=Ta;wa=uT(21)|0;c[va>>2]=22;c[va+4>>2]=wa;wa=va+8|0;h[k>>3]=Ta;c[wa>>2]=c[k>>2];c[wa+4>>2]=c[k+4>>2];hwa(21,0,60936,va);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+1152>>3];h[b+176>>3]=Ta;va=uT(22)|0;c[ua>>2]=23;c[ua+4>>2]=va;va=ua+8|0;h[k>>3]=Ta;c[va>>2]=c[k>>2];c[va+4>>2]=c[k+4>>2];hwa(21,0,60936,ua);ua=c[Ra>>2]|0;Ta=+h[ua+1792>>3]+ +h[ua+1816>>3]*-1.0e3;h[b+184>>3]=Ta;ua=uT(23)|0;c[ta>>2]=24;c[ta+4>>2]=ua;ua=ta+8|0;h[k>>3]=Ta;c[ua>>2]=c[k>>2];c[ua+4>>2]=c[k+4>>2];hwa(21,0,60936,ta);ta=c[Ra>>2]|0;Ta=+h[ta+1816>>3]- +h[ta+1384>>3];h[b+192>>3]=Ta;ta=uT(24)|0;c[sa>>2]=25;c[sa+4>>2]=ta;ta=sa+8|0;h[k>>3]=Ta;c[ta>>2]=c[k>>2];c[ta+4>>2]=c[k+4>>2];hwa(21,0,60936,sa);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+1112>>3];h[b+200>>3]=Ta;sa=uT(25)|0;c[ra>>2]=26;c[ra+4>>2]=sa;sa=ra+8|0;h[k>>3]=Ta;c[sa>>2]=c[k>>2];c[sa+4>>2]=c[k+4>>2];hwa(21,0,60936,ra);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+1120>>3];h[b+208>>3]=Ta;ra=uT(26)|0;c[qa>>2]=27;c[qa+4>>2]=ra;ra=qa+8|0;h[k>>3]=Ta;c[ra>>2]=c[k>>2];c[ra+4>>2]=c[k+4>>2];hwa(21,0,60936,qa);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+1128>>3];h[b+216>>3]=Ta;qa=uT(27)|0;c[pa>>2]=28;c[pa+4>>2]=qa;qa=pa+8|0;h[k>>3]=Ta;c[qa>>2]=c[k>>2];c[qa+4>>2]=c[k+4>>2];hwa(21,0,60936,pa);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+1136>>3];h[b+224>>3]=Ta;pa=uT(28)|0;c[oa>>2]=29;c[oa+4>>2]=pa;pa=oa+8|0;h[k>>3]=Ta;c[pa>>2]=c[k>>2];c[pa+4>>2]=c[k+4>>2];hwa(21,0,60936,oa);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+1088>>3];h[b+232>>3]=Ta;oa=uT(29)|0;c[na>>2]=30;c[na+4>>2]=oa;oa=na+8|0;h[k>>3]=Ta;c[oa>>2]=c[k>>2];c[oa+4>>2]=c[k+4>>2];hwa(21,0,60936,na);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+1064>>3];h[b+240>>3]=Ta;na=uT(30)|0;c[ma>>2]=31;c[ma+4>>2]=na;na=ma+8|0;h[k>>3]=Ta;c[na>>2]=c[k>>2];c[na+4>>2]=c[k+4>>2];hwa(21,0,60936,ma);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+1040>>3];h[b+248>>3]=Ta;ma=uT(31)|0;c[la>>2]=32;c[la+4>>2]=ma;ma=la+8|0;h[k>>3]=Ta;c[ma>>2]=c[k>>2];c[ma+4>>2]=c[k+4>>2];hwa(21,0,60936,la);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+1016>>3];h[b+256>>3]=Ta;la=uT(32)|0;c[ka>>2]=33;c[ka+4>>2]=la;la=ka+8|0;h[k>>3]=Ta;c[la>>2]=c[k>>2];c[la+4>>2]=c[k+4>>2];hwa(21,0,60936,ka);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+992>>3];h[b+264>>3]=Ta;ka=uT(33)|0;c[ja>>2]=34;c[ja+4>>2]=ka;ka=ja+8|0;h[k>>3]=Ta;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];hwa(21,0,60936,ja);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+1104>>3];h[b+272>>3]=Ta;ja=uT(34)|0;c[ia>>2]=35;c[ia+4>>2]=ja;ja=ia+8|0;h[k>>3]=Ta;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];hwa(21,0,60936,ia);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+1080>>3];h[b+280>>3]=Ta;ia=uT(35)|0;c[ha>>2]=36;c[ha+4>>2]=ia;ia=ha+8|0;h[k>>3]=Ta;c[ia>>2]=c[k>>2];c[ia+4>>2]=c[k+4>>2];hwa(21,0,60936,ha);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+1056>>3];h[b+288>>3]=Ta;ha=uT(36)|0;c[ga>>2]=37;c[ga+4>>2]=ha;ha=ga+8|0;h[k>>3]=Ta;c[ha>>2]=c[k>>2];c[ha+4>>2]=c[k+4>>2];hwa(21,0,60936,ga);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+1032>>3];h[b+296>>3]=Ta;ga=uT(37)|0;c[fa>>2]=38;c[fa+4>>2]=ga;ga=fa+8|0;h[k>>3]=Ta;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];hwa(21,0,60936,fa);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+1008>>3];h[b+304>>3]=Ta;fa=uT(38)|0;c[ea>>2]=39;c[ea+4>>2]=fa;fa=ea+8|0;h[k>>3]=Ta;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];hwa(21,0,60936,ea);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+1096>>3];h[b+312>>3]=Ta;ea=uT(39)|0;c[da>>2]=40;c[da+4>>2]=ea;ea=da+8|0;h[k>>3]=Ta;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];hwa(21,0,60936,da);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+1072>>3];h[b+320>>3]=Ta;da=uT(40)|0;c[ca>>2]=41;c[ca+4>>2]=da;da=ca+8|0;h[k>>3]=Ta;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];hwa(21,0,60936,ca);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+1048>>3];h[b+328>>3]=Ta;ca=uT(41)|0;c[ba>>2]=42;c[ba+4>>2]=ca;ca=ba+8|0;h[k>>3]=Ta;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];hwa(21,0,60936,ba);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+1024>>3];h[b+336>>3]=Ta;ba=uT(42)|0;c[aa>>2]=43;c[aa+4>>2]=ba;ba=aa+8|0;h[k>>3]=Ta;c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];hwa(21,0,60936,aa);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+1e3>>3];h[b+344>>3]=Ta;aa=uT(43)|0;c[$>>2]=44;c[$+4>>2]=aa;aa=$+8|0;h[k>>3]=Ta;c[aa>>2]=c[k>>2];c[aa+4>>2]=c[k+4>>2];hwa(21,0,60936,$);$=c[Ra>>2]|0;Ta=+h[$+2024>>3]+ +h[$+2048>>3]*-1.0e3;h[b+352>>3]=Ta;$=uT(44)|0;c[_>>2]=45;c[_+4>>2]=$;$=_+8|0;h[k>>3]=Ta;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];hwa(21,0,60936,_);_=c[Ra>>2]|0;Ta=+h[_+2048>>3]- +h[_+1384>>3];h[b+360>>3]=Ta;_=uT(45)|0;c[Z>>2]=46;c[Z+4>>2]=_;_=Z+8|0;h[k>>3]=Ta;c[_>>2]=c[k>>2];c[_+4>>2]=c[k+4>>2];hwa(21,0,60936,Z);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+944>>3];h[b+368>>3]=Ta;Z=uT(46)|0;c[Y>>2]=47;c[Y+4>>2]=Z;Z=Y+8|0;h[k>>3]=Ta;c[Z>>2]=c[k>>2];c[Z+4>>2]=c[k+4>>2];hwa(21,0,60936,Y);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+952>>3];h[b+376>>3]=Ta;Y=uT(47)|0;c[X>>2]=48;c[X+4>>2]=Y;Y=X+8|0;h[k>>3]=Ta;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];hwa(21,0,60936,X);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+960>>3];h[b+384>>3]=Ta;X=uT(48)|0;c[W>>2]=49;c[W+4>>2]=X;X=W+8|0;h[k>>3]=Ta;c[X>>2]=c[k>>2];c[X+4>>2]=c[k+4>>2];hwa(21,0,60936,W);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+968>>3];h[b+392>>3]=Ta;W=uT(49)|0;c[V>>2]=50;c[V+4>>2]=W;W=V+8|0;h[k>>3]=Ta;c[W>>2]=c[k>>2];c[W+4>>2]=c[k+4>>2];hwa(21,0,60936,V);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+976>>3];h[b+400>>3]=Ta;V=uT(50)|0;c[U>>2]=51;c[U+4>>2]=V;V=U+8|0;h[k>>3]=Ta;c[V>>2]=c[k>>2];c[V+4>>2]=c[k+4>>2];hwa(21,0,60936,U);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+984>>3];h[b+408>>3]=Ta;U=uT(51)|0;c[T>>2]=52;c[T+4>>2]=U;U=T+8|0;h[k>>3]=Ta;c[U>>2]=c[k>>2];c[U+4>>2]=c[k+4>>2];hwa(21,0,60936,T);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+920>>3];h[b+416>>3]=Ta;T=uT(52)|0;c[S>>2]=53;c[S+4>>2]=T;T=S+8|0;h[k>>3]=Ta;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];hwa(21,0,60936,S);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+896>>3];h[b+424>>3]=Ta;S=uT(53)|0;c[R>>2]=54;c[R+4>>2]=S;S=R+8|0;h[k>>3]=Ta;c[S>>2]=c[k>>2];c[S+4>>2]=c[k+4>>2];hwa(21,0,60936,R);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+872>>3];h[b+432>>3]=Ta;R=uT(54)|0;c[Q>>2]=55;c[Q+4>>2]=R;R=Q+8|0;h[k>>3]=Ta;c[R>>2]=c[k>>2];c[R+4>>2]=c[k+4>>2];hwa(21,0,60936,Q);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+848>>3];h[b+440>>3]=Ta;Q=uT(55)|0;c[P>>2]=56;c[P+4>>2]=Q;Q=P+8|0;h[k>>3]=Ta;c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];hwa(21,0,60936,P);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+824>>3];h[b+448>>3]=Ta;P=uT(56)|0;c[O>>2]=57;c[O+4>>2]=P;P=O+8|0;h[k>>3]=Ta;c[P>>2]=c[k>>2];c[P+4>>2]=c[k+4>>2];hwa(21,0,60936,O);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+936>>3];h[b+456>>3]=Ta;O=uT(57)|0;c[N>>2]=58;c[N+4>>2]=O;O=N+8|0;h[k>>3]=Ta;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];hwa(21,0,60936,N);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+912>>3];h[b+464>>3]=Ta;N=uT(58)|0;c[M>>2]=59;c[M+4>>2]=N;N=M+8|0;h[k>>3]=Ta;c[N>>2]=c[k>>2];c[N+4>>2]=c[k+4>>2];hwa(21,0,60936,M);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+888>>3];h[b+472>>3]=Ta;M=uT(59)|0;c[L>>2]=60;c[L+4>>2]=M;M=L+8|0;h[k>>3]=Ta;c[M>>2]=c[k>>2];c[M+4>>2]=c[k+4>>2];hwa(21,0,60936,L);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+864>>3];h[b+480>>3]=Ta;L=uT(60)|0;c[K>>2]=61;c[K+4>>2]=L;L=K+8|0;h[k>>3]=Ta;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];hwa(21,0,60936,K);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+840>>3];h[b+488>>3]=Ta;K=uT(61)|0;c[J>>2]=62;c[J+4>>2]=K;K=J+8|0;h[k>>3]=Ta;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];hwa(21,0,60936,J);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+928>>3];h[b+496>>3]=Ta;J=uT(62)|0;c[I>>2]=63;c[I+4>>2]=J;J=I+8|0;h[k>>3]=Ta;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];hwa(21,0,60936,I);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+904>>3];h[b+504>>3]=Ta;I=uT(63)|0;c[H>>2]=64;c[H+4>>2]=I;I=H+8|0;h[k>>3]=Ta;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];hwa(21,0,60936,H);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+880>>3];h[b+512>>3]=Ta;H=uT(64)|0;c[G>>2]=65;c[G+4>>2]=H;H=G+8|0;h[k>>3]=Ta;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];hwa(21,0,60936,G);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+856>>3];h[b+520>>3]=Ta;G=uT(65)|0;c[F>>2]=66;c[F+4>>2]=G;G=F+8|0;h[k>>3]=Ta;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];hwa(21,0,60936,F);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+832>>3];h[b+528>>3]=Ta;F=uT(66)|0;c[E>>2]=67;c[E+4>>2]=F;F=E+8|0;h[k>>3]=Ta;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];hwa(21,0,60936,E);E=c[Ra>>2]|0;Ta=+h[E+2248>>3]+ +h[E+2272>>3]*-1.0e3;h[b+536>>3]=Ta;E=uT(67)|0;c[D>>2]=68;c[D+4>>2]=E;E=D+8|0;h[k>>3]=Ta;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];hwa(21,0,60936,D);D=c[Ra>>2]|0;Ta=+h[D+2272>>3]- +h[D+1384>>3];h[b+544>>3]=Ta;D=uT(68)|0;c[C>>2]=69;c[C+4>>2]=D;D=C+8|0;h[k>>3]=Ta;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];hwa(21,0,60936,C);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+776>>3];h[b+552>>3]=Ta;C=uT(69)|0;c[B>>2]=70;c[B+4>>2]=C;C=B+8|0;h[k>>3]=Ta;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];hwa(21,0,60936,B);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+784>>3];h[b+560>>3]=Ta;B=uT(70)|0;c[A>>2]=71;c[A+4>>2]=B;B=A+8|0;h[k>>3]=Ta;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];hwa(21,0,60936,A);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+792>>3];h[b+568>>3]=Ta;A=uT(71)|0;c[z>>2]=72;c[z+4>>2]=A;A=z+8|0;h[k>>3]=Ta;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];hwa(21,0,60936,z);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+800>>3];h[b+576>>3]=Ta;z=uT(72)|0;c[y>>2]=73;c[y+4>>2]=z;z=y+8|0;h[k>>3]=Ta;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];hwa(21,0,60936,y);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+808>>3];h[b+584>>3]=Ta;y=uT(73)|0;c[x>>2]=74;c[x+4>>2]=y;y=x+8|0;h[k>>3]=Ta;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];hwa(21,0,60936,x);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+816>>3];h[b+592>>3]=Ta;x=uT(74)|0;c[w>>2]=75;c[w+4>>2]=x;x=w+8|0;h[k>>3]=Ta;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];hwa(21,0,60936,w);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+752>>3];h[b+600>>3]=Ta;w=uT(75)|0;c[v>>2]=76;c[v+4>>2]=w;w=v+8|0;h[k>>3]=Ta;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];hwa(21,0,60936,v);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+728>>3];h[b+608>>3]=Ta;v=uT(76)|0;c[u>>2]=77;c[u+4>>2]=v;v=u+8|0;h[k>>3]=Ta;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];hwa(21,0,60936,u);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+704>>3];h[b+616>>3]=Ta;u=uT(77)|0;c[t>>2]=78;c[t+4>>2]=u;u=t+8|0;h[k>>3]=Ta;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];hwa(21,0,60936,t);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+680>>3];h[b+624>>3]=Ta;t=uT(78)|0;c[s>>2]=79;c[s+4>>2]=t;t=s+8|0;h[k>>3]=Ta;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];hwa(21,0,60936,s);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+656>>3];h[b+632>>3]=Ta;s=uT(79)|0;c[r>>2]=80;c[r+4>>2]=s;s=r+8|0;h[k>>3]=Ta;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];hwa(21,0,60936,r);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+768>>3];h[b+640>>3]=Ta;r=uT(80)|0;c[q>>2]=81;c[q+4>>2]=r;r=q+8|0;h[k>>3]=Ta;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];hwa(21,0,60936,q);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+744>>3];h[b+648>>3]=Ta;q=uT(81)|0;c[p>>2]=82;c[p+4>>2]=q;q=p+8|0;h[k>>3]=Ta;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];hwa(21,0,60936,p);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+720>>3];h[b+656>>3]=Ta;p=uT(82)|0;c[o>>2]=83;c[o+4>>2]=p;p=o+8|0;h[k>>3]=Ta;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];hwa(21,0,60936,o);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+696>>3];h[b+664>>3]=Ta;o=uT(83)|0;c[n>>2]=84;c[n+4>>2]=o;o=n+8|0;h[k>>3]=Ta;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];hwa(21,0,60936,n);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+672>>3];h[b+672>>3]=Ta;n=uT(84)|0;c[m>>2]=85;c[m+4>>2]=n;n=m+8|0;h[k>>3]=Ta;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];hwa(21,0,60936,m);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+760>>3];h[b+680>>3]=Ta;m=uT(85)|0;c[l>>2]=86;c[l+4>>2]=m;m=l+8|0;h[k>>3]=Ta;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];hwa(21,0,60936,l);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+736>>3];h[b+688>>3]=Ta;l=uT(86)|0;c[j>>2]=87;c[j+4>>2]=l;l=j+8|0;h[k>>3]=Ta;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];hwa(21,0,60936,j);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+712>>3];h[b+696>>3]=Ta;j=uT(87)|0;c[g>>2]=88;c[g+4>>2]=j;j=g+8|0;h[k>>3]=Ta;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];hwa(21,0,60936,g);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+688>>3];h[b+704>>3]=Ta;g=uT(88)|0;c[f>>2]=89;c[f+4>>2]=g;g=f+8|0;h[k>>3]=Ta;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];hwa(21,0,60936,f);Ta=+h[(c[(c[c[Pa>>2]>>2]|0)+8>>2]|0)+664>>3];h[b+712>>3]=Ta;b=uT(89)|0;c[e>>2]=90;c[e+4>>2]=b;b=e+8|0;h[k>>3]=Ta;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];hwa(21,0,60936,e);if((c[206228>>2]|0)==0){i=d;return 0}le[c[51674]&2047](21);i=d;return 0}function wT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2328>>3]=+h[b+1344>>3];i=i;return}function xT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2320>>3]=+h[b+2112>>3];i=i;return}function yT(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+127|0]=a[d+113|0]|0;i=i;return}function zT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1112>>3]=+h[b+2136>>3];i=i;return}function AT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1104>>3]=+h[b+2136>>3];i=i;return}function BT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1096>>3]=+h[b+2136>>3];i=i;return}function CT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1088>>3]=+h[b+2136>>3];i=i;return}function DT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1080>>3]=+h[b+2136>>3];i=i;return}function ET(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+992>>3]=+h[b+2120>>3]*.2;i=i;return}function FT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+984>>3]=+h[b+2120>>3]*.2;i=i;return}function GT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+976>>3]=+h[b+2120>>3]*.2;i=i;return}function HT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+968>>3]=+h[b+2120>>3]*.2;i=i;return}function IT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+960>>3]=+h[b+2120>>3]*.2;i=i;return}function JT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2280>>3]=+h[b+1352>>3];i=i;return}function KT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2264>>3]=+h[b+1392>>3];i=i;return}function LT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2256>>3]=+h[b+2264>>3]*100.0;i=i;return}function MT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2216>>3]=+h[b+2112>>3];i=i;return}function NT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2192>>3]=+h[b+2128>>3]*3.141592653589793;i=i;return}function OT(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+h[b+2128>>3];h[b+2184>>3]=d*d*.7853981633974483;i=i;return}function PT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1e3>>3]=+h[b+2184>>3];i=i;return}function QT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1008>>3]=+h[b+2184>>3];i=i;return}function RT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1016>>3]=+h[b+2184>>3];i=i;return}function ST(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1024>>3]=+h[b+2184>>3];i=i;return}function TT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1032>>3]=+h[b+2184>>3];i=i;return}function UT(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2192>>3];j=+h[f+2184>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+nwa(c[b+536>>2]|0,g,60960,60952,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1040>>3]=l*4.0;i=d;return}function VT(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2192>>3];j=+h[f+2184>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+nwa(c[b+536>>2]|0,g,60960,60976,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1048>>3]=l*4.0;i=d;return}function WT(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2192>>3];j=+h[f+2184>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+nwa(c[b+536>>2]|0,g,60960,60984,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1056>>3]=l*4.0;i=d;return}function XT(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2192>>3];j=+h[f+2184>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+nwa(c[b+536>>2]|0,g,60960,60992,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1064>>3]=l*4.0;i=d;return}function YT(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2192>>3];j=+h[f+2184>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+nwa(c[b+536>>2]|0,g,60960,61e3,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1072>>3]=l*4.0;i=d;return}function ZT(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+816>>3]=+h[b+1912>>3];i=i;return}function _T(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+808>>3]=+h[b+1912>>3];i=i;return}function $T(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+800>>3]=+h[b+1912>>3];i=i;return}function aU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+792>>3]=+h[b+1912>>3];i=i;return}function bU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+784>>3]=+h[b+1912>>3];i=i;return}function cU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+696>>3]=+h[b+1896>>3]*.2;i=i;return}function dU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+688>>3]=+h[b+1896>>3]*.2;i=i;return}function eU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+680>>3]=+h[b+1896>>3]*.2;i=i;return}function fU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+672>>3]=+h[b+1896>>3]*.2;i=i;return}function gU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+664>>3]=+h[b+1896>>3]*.2;i=i;return}function hU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2056>>3]=+h[b+1352>>3];i=i;return}function iU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2040>>3]=+h[b+1392>>3];i=i;return}function jU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2032>>3]=+h[b+2040>>3]*100.0;i=i;return}function kU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1992>>3]=+h[b+1888>>3];i=i;return}function lU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1968>>3]=+h[b+1904>>3]*3.141592653589793;i=i;return}function mU(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+h[b+1904>>3];h[b+1960>>3]=d*d*.7853981633974483;i=i;return}function nU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+704>>3]=+h[b+1960>>3];i=i;return}function oU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+712>>3]=+h[b+1960>>3];i=i;return}function pU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+720>>3]=+h[b+1960>>3];i=i;return}function qU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+728>>3]=+h[b+1960>>3];i=i;return}function rU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+736>>3]=+h[b+1960>>3];i=i;return}function sU(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1968>>3];j=+h[f+1960>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+nwa(c[b+536>>2]|0,g,61016,61008,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+744>>3]=l*4.0;i=d;return}function tU(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1968>>3];j=+h[f+1960>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+nwa(c[b+536>>2]|0,g,61016,61032,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+752>>3]=l*4.0;i=d;return}function uU(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1968>>3];j=+h[f+1960>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+nwa(c[b+536>>2]|0,g,61016,61040,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+760>>3]=l*4.0;i=d;return}function vU(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1968>>3];j=+h[f+1960>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+nwa(c[b+536>>2]|0,g,61016,61048,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+768>>3]=l*4.0;i=d;return}function wU(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1968>>3];j=+h[f+1960>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+nwa(c[b+536>>2]|0,g,61016,61056,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+776>>3]=l*4.0;i=d;return}function xU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1864>>3]=+h[b+1656>>3];i=i;return}function yU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+520>>3]=+h[b+1680>>3];i=i;return}function zU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+512>>3]=+h[b+1680>>3];i=i;return}function AU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+504>>3]=+h[b+1680>>3];i=i;return}function BU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+496>>3]=+h[b+1680>>3];i=i;return}function CU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+488>>3]=+h[b+1680>>3];i=i;return}function DU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+400>>3]=+h[b+1664>>3]*.2;i=i;return}function EU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+392>>3]=+h[b+1664>>3]*.2;i=i;return}function FU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+384>>3]=+h[b+1664>>3]*.2;i=i;return}function GU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+376>>3]=+h[b+1664>>3]*.2;i=i;return}function HU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+368>>3]=+h[b+1664>>3]*.2;i=i;return}function IU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1824>>3]=+h[b+1352>>3];i=i;return}function JU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1808>>3]=+h[b+1392>>3];i=i;return}function KU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1800>>3]=+h[b+1808>>3]*100.0;i=i;return}function LU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1760>>3]=+h[b+1656>>3];i=i;return}function MU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1736>>3]=+h[b+1672>>3]*3.141592653589793;i=i;return}function NU(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+h[b+1672>>3];h[b+1728>>3]=d*d*.7853981633974483;i=i;return}function OU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+408>>3]=+h[b+1728>>3];i=i;return}function PU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+416>>3]=+h[b+1728>>3];i=i;return}function QU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+424>>3]=+h[b+1728>>3];i=i;return}function RU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+432>>3]=+h[b+1728>>3];i=i;return}function SU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+440>>3]=+h[b+1728>>3];i=i;return}function TU(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1736>>3];j=+h[f+1728>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+nwa(c[b+536>>2]|0,g,61072,61064,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+448>>3]=l*4.0;i=d;return}function UU(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1736>>3];j=+h[f+1728>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+nwa(c[b+536>>2]|0,g,61072,61088,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+456>>3]=l*4.0;i=d;return}function VU(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1736>>3];j=+h[f+1728>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+nwa(c[b+536>>2]|0,g,61072,61096,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+464>>3]=l*4.0;i=d;return}function WU(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1736>>3];j=+h[f+1728>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+nwa(c[b+536>>2]|0,g,61072,61104,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+472>>3]=l*4.0;i=d;return}function XU(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1736>>3];j=+h[f+1728>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+nwa(c[b+536>>2]|0,g,61072,61112,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+480>>3]=l*4.0;i=d;return}function YU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+224>>3]=+h[b+1456>>3];i=i;return}function ZU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+216>>3]=+h[b+1456>>3];i=i;return}function _U(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+208>>3]=+h[b+1456>>3];i=i;return}function $U(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+200>>3]=+h[b+1456>>3];i=i;return}function aV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+192>>3]=+h[b+1456>>3];i=i;return}function bV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+104>>3]=+h[b+1440>>3]*.2;i=i;return}function cV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+96>>3]=+h[b+1440>>3]*.2;i=i;return}function dV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+88>>3]=+h[b+1440>>3]*.2;i=i;return}function eV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+80>>3]=+h[b+1440>>3]*.2;i=i;return}function fV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+72>>3]=+h[b+1440>>3]*.2;i=i;return}function gV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1600>>3]=+h[b+1352>>3];i=i;return}function hV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1584>>3]=+h[b+1392>>3];i=i;return}function iV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1576>>3]=+h[b+1584>>3]*100.0;i=i;return}function jV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1536>>3]=+h[b+1432>>3];i=i;return}function kV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1512>>3]=+h[b+1448>>3]*3.141592653589793;i=i;return}function lV(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+h[b+1448>>3];h[b+1504>>3]=d*d*.7853981633974483;i=i;return}function mV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+112>>3]=+h[b+1504>>3];i=i;return}function nV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+120>>3]=+h[b+1504>>3];i=i;return}function oV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+128>>3]=+h[b+1504>>3];i=i;return}function pV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+136>>3]=+h[b+1504>>3];i=i;return}function qV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+144>>3]=+h[b+1504>>3];i=i;return}function rV(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1512>>3];j=+h[f+1504>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+nwa(c[b+536>>2]|0,g,61128,61120,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+152>>3]=l*4.0;i=d;return}function sV(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1512>>3];j=+h[f+1504>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+nwa(c[b+536>>2]|0,g,61128,61144,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+160>>3]=l*4.0;i=d;return}function tV(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1512>>3];j=+h[f+1504>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+nwa(c[b+536>>2]|0,g,61128,61152,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+168>>3]=l*4.0;i=d;return}function uV(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1512>>3];j=+h[f+1504>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+nwa(c[b+536>>2]|0,g,61128,61160,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+176>>3]=l*4.0;i=d;return}function vV(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1512>>3];j=+h[f+1504>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+nwa(c[b+536>>2]|0,g,61128,61168,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+184>>3]=l*4.0;i=d;return}function wV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10480>>3]=+h[(c[a+416>>2]|0)+992>>3]*.5;i=i;return}function xV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10472>>3]=(+h[b+984>>3]+ +h[b+992>>3])*.5;i=i;return}function yV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10464>>3]=(+h[b+976>>3]+ +h[b+984>>3])*.5;i=i;return}function zV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10456>>3]=(+h[b+968>>3]+ +h[b+976>>3])*.5;i=i;return}function AV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10448>>3]=(+h[b+960>>3]+ +h[b+968>>3])*.5;i=i;return}function BV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10440>>3]=+h[(c[a+416>>2]|0)+960>>3]*.5;i=i;return}function CV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10432>>3]=+h[b+1032>>3]*+h[b+992>>3]*+h[b+2112>>3];i=i;return}function DV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10424>>3]=+h[b+1024>>3]*+h[b+984>>3]*+h[b+2112>>3];i=i;return}function EV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10416>>3]=+h[b+1016>>3]*+h[b+976>>3]*+h[b+2112>>3];i=i;return}function FV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10408>>3]=+h[b+1008>>3]*+h[b+968>>3]*+h[b+2112>>3];i=i;return}function GV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10400>>3]=+h[b+1e3>>3]*+h[b+960>>3]*+h[b+2112>>3];i=i;return}function HV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10344>>3]=+h[(c[a+416>>2]|0)+696>>3]*.5;i=i;return}function IV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10336>>3]=(+h[b+688>>3]+ +h[b+696>>3])*.5;i=i;return}function JV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10328>>3]=(+h[b+680>>3]+ +h[b+688>>3])*.5;i=i;return}function KV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10320>>3]=(+h[b+672>>3]+ +h[b+680>>3])*.5;i=i;return}function LV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10312>>3]=(+h[b+664>>3]+ +h[b+672>>3])*.5;i=i;return}function MV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10304>>3]=+h[(c[a+416>>2]|0)+664>>3]*.5;i=i;return}function NV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10296>>3]=+h[b+736>>3]*+h[b+696>>3]*+h[b+1888>>3];i=i;return}function OV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10288>>3]=+h[b+728>>3]*+h[b+688>>3]*+h[b+1888>>3];i=i;return}function PV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10280>>3]=+h[b+720>>3]*+h[b+680>>3]*+h[b+1888>>3];i=i;return}function QV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10272>>3]=+h[b+712>>3]*+h[b+672>>3]*+h[b+1888>>3];i=i;return}function RV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10264>>3]=+h[b+704>>3]*+h[b+664>>3]*+h[b+1888>>3];i=i;return}function SV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10224>>3]=+h[b+392>>3]*.5+ +h[b+400>>3];i=i;return}function TV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10216>>3]=(+h[b+384>>3]+ +h[b+392>>3])*.5;i=i;return}function UV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10208>>3]=(+h[b+376>>3]+ +h[b+384>>3])*.5;i=i;return}function VV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10200>>3]=+h[b+368>>3]+ +h[b+376>>3]*.5;i=i;return}function WV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10192>>3]=+h[b+400>>3]*+h[b+1736>>3];i=i;return}function XV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10184>>3]=+h[b+392>>3]*+h[b+1736>>3];i=i;return}function YV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10176>>3]=+h[b+384>>3]*+h[b+1736>>3];i=i;return}function ZV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10168>>3]=+h[b+376>>3]*+h[b+1736>>3];i=i;return}function _V(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10160>>3]=+h[b+368>>3]*+h[b+1736>>3];i=i;return}function $V(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10152>>3]=+h[b+440>>3]*+h[b+400>>3]*+h[b+1656>>3];i=i;return}function aW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10144>>3]=+h[b+432>>3]*+h[b+392>>3]*+h[b+1656>>3];i=i;return}function bW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10136>>3]=+h[b+424>>3]*+h[b+384>>3]*+h[b+1656>>3];i=i;return}function cW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10128>>3]=+h[b+416>>3]*+h[b+376>>3]*+h[b+1656>>3];i=i;return}function dW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10120>>3]=+h[b+408>>3]*+h[b+368>>3]*+h[b+1656>>3];i=i;return}function eW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10048>>3]=+h[(c[a+416>>2]|0)+104>>3]*.5;i=i;return}function fW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10040>>3]=(+h[b+96>>3]+ +h[b+104>>3])*.5;i=i;return}function gW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10032>>3]=(+h[b+88>>3]+ +h[b+96>>3])*.5;i=i;return}function hW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10024>>3]=(+h[b+80>>3]+ +h[b+88>>3])*.5;i=i;return}function iW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10016>>3]=(+h[b+72>>3]+ +h[b+80>>3])*.5;i=i;return}function jW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10008>>3]=+h[(c[a+416>>2]|0)+72>>3]*.5;i=i;return}function kW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1e4>>3]=+h[b+144>>3]*+h[b+104>>3]*+h[b+1432>>3];i=i;return}function lW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9992>>3]=+h[b+136>>3]*+h[b+96>>3]*+h[b+1432>>3];i=i;return}function mW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9984>>3]=+h[b+128>>3]*+h[b+88>>3]*+h[b+1432>>3];i=i;return}function nW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9976>>3]=+h[b+120>>3]*+h[b+80>>3]*+h[b+1432>>3];i=i;return}function oW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9968>>3]=+h[b+112>>3]*+h[b+72>>3]*+h[b+1432>>3];i=i;return}function pW(a){a=a|0;var b=0,d=0,e=0.0;b=i;i=i+8|0;d=b;AA(d,c[a+536>>2]|0,293.15);e=+yd(+(+h[d>>3]),149850.0);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10912>>3]=e;i=b;return}function qW(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+24|0;d=b;e=b+16|0;f=c[a+536>>2]|0;g=d;j=61176;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];GA(e,f,15.0e4,293.15,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10904>>3]=+h[e>>3];i=b;return}function rW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9952>>3]=(+h[b+152>>3]+ +h[b+160>>3])*.5;i=i;return}function sW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9944>>3]=(+h[b+160>>3]+ +h[b+168>>3])*.5;i=i;return}function tW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9936>>3]=(+h[b+168>>3]+ +h[b+176>>3])*.5;i=i;return}function uW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9928>>3]=(+h[b+176>>3]+ +h[b+184>>3])*.5;i=i;return}function vW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9888>>3]=(+h[b+448>>3]+ +h[b+456>>3])*.5;i=i;return}function wW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9896>>3]=(+h[b+456>>3]+ +h[b+464>>3])*.5;i=i;return}function xW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9904>>3]=(+h[b+464>>3]+ +h[b+472>>3])*.5;i=i;return}function yW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9912>>3]=(+h[b+472>>3]+ +h[b+480>>3])*.5;i=i;return}function zW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9880>>3]=(+h[b+744>>3]+ +h[b+752>>3])*.5;i=i;return}function AW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9872>>3]=(+h[b+752>>3]+ +h[b+760>>3])*.5;i=i;return}function BW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9864>>3]=(+h[b+760>>3]+ +h[b+768>>3])*.5;i=i;return}function CW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9856>>3]=(+h[b+768>>3]+ +h[b+776>>3])*.5;i=i;return}function DW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9848>>3]=(+h[b+1040>>3]+ +h[b+1048>>3])*.5;i=i;return}function EW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9840>>3]=(+h[b+1048>>3]+ +h[b+1056>>3])*.5;i=i;return}function FW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9832>>3]=(+h[b+1056>>3]+ +h[b+1064>>3])*.5;i=i;return}function GW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9824>>3]=(+h[b+1064>>3]+ +h[b+1072>>3])*.5;i=i;return}function HW(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0;b=i;i=i+216|0;d=b;e=b+96|0;f=b+112|0;g=b+208|0;c[f>>2]=61192;h[f+8>>3]=.01801528;h[f+16>>3]=-13423382.81725291;h[f+24>>3]=549760.6476280135;h[f+32>>3]=1.0e3;j=f+40|0;k=61200;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=f+52|0;j=61216;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];j=f+64|0;k=61232;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=f+76|0;j=61248;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];h[f+88>>3]=461.5233290850878;j=c[a+536>>2]|0;k=a+4|0;l=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+10904>>3];a=e;m=61176;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];m=d+0|0;a=f+0|0;f=m+96|0;do{c[m>>2]=c[a>>2];m=m+4|0;a=a+4|0}while((m|0)<(f|0));nA(g,j,l,190.0,647.0,15.0e4,e,d,1.0e-13);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+9800>>3]=+h[g>>3];i=b;return}function IW(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10912>>3]*.625745065946724;if(j!=0.0){k=j;l=g;m=1500.0/k;n=l;o=n+10880|0;p=o;h[p>>3]=m;i=d;return}q=+nwa(c[b+536>>2]|0,j,61272,61264,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1500.0/k;n=l;o=n+10880|0;p=o;h[p>>3]=m;i=d;return}function JW(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10912>>3];k=+zd(1.0e-13,+(15.0e4-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+nwa(c[b+536>>2]|0,k,61336,61328,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+10864>>3]=m*.6219647130774989;i=d;return}function KW(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10912>>3];k=+zd(1.0e-13,+(15.0e4-j));if(k!=0.0){l=k;m=g;n=.99/l;o=j*n;p=o*.6219647130774989;q=+yd(+p,1.0);r=m;s=r+10856|0;t=s;h[t>>3]=q;i=d;return}u=+nwa(c[b+536>>2]|0,k,61336,61392,+h[f>>3],(a[b+319|0]|0)!=0|0);l=u;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=.99/l;o=j*n;p=o*.6219647130774989;q=+yd(+p,1.0);r=m;s=r+10856|0;t=s;h[t>>3]=q;i=d;return}function LW(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0,u=0.0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0.0,E=0,F=0.0,G=0,H=0.0,I=0.0,J=0,K=0.0,L=0,M=0.0,N=0.0,O=0,P=0.0,Q=0,R=0.0,S=0.0,T=0,U=0.0,V=0,W=0.0,X=0.0,Y=0,Z=0.0,_=0,$=0.0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;j=d+24|0;k=d+32|0;l=d+40|0;m=b+536|0;n=c[m>>2]|0;o=b+416|0;p=c[o>>2]|0;q=+h[p+2216>>3];r=+h[p+2256>>3];do{if(q!=0.0){s=q;t=p;u=r/q}else{if(r==0.0){s=q;t=p;u=r;break}v=r/+nwa(n,q,61408,61400,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);w=c[o>>2]|0;s=+h[w+2216>>3];t=w;u=v}}while(0);q=+h[t+2296>>3];r=+h[t+2304>>3];p=b+4|0;w=c[c[p>>2]>>2]|0;v=+h[(c[w+8>>2]|0)+10440>>3];x=+h[t+1040>>3];y=+h[t+1080>>3];z=(y+y)*.5;y=+h[t+2264>>3];do{if(s!=0.0){A=t;B=y/s}else{if(y==0.0){A=t;B=y;break}C=y/+nwa(c[m>>2]|0,s,61408,61400,+h[w>>3],(a[b+319|0]|0)!=0|0);A=c[o>>2]|0;B=C}}while(0);Iz(e,n,u,q,q,r,r,v,x,z,B,+h[A+2240>>3]);B=+h[e>>3];e=c[m>>2]|0;A=c[o>>2]|0;z=+h[A+2216>>3];x=+h[A+2256>>3];do{if(z!=0.0){D=z;E=A;F=x/z}else{if(x==0.0){D=z;E=A;F=x;break}v=x/+nwa(e,z,61408,61400,+h[c[c[p>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);n=c[o>>2]|0;D=+h[n+2216>>3];E=n;F=v}}while(0);z=+h[E+2296>>3];x=+h[E+2304>>3];A=c[c[p>>2]>>2]|0;n=c[A+8>>2]|0;v=+h[n+10448>>3];r=+h[n+9848>>3];q=(+h[E+1080>>3]+ +h[E+1088>>3])*.5;u=+h[E+2264>>3];do{if(D!=0.0){G=E;H=u/D}else{if(u==0.0){G=E;H=u;break}s=u/+nwa(c[m>>2]|0,D,61408,61400,+h[A>>3],(a[b+319|0]|0)!=0|0);G=c[o>>2]|0;H=s}}while(0);Iz(f,e,F,z,z,x,x,v,r,q,H,+h[G+2240>>3]);H=+h[f>>3];f=c[m>>2]|0;G=c[o>>2]|0;q=+h[G+2216>>3];r=+h[G+2256>>3];do{if(q!=0.0){I=q;J=G;K=r/q}else{if(r==0.0){I=q;J=G;K=r;break}v=r/+nwa(f,q,61408,61400,+h[c[c[p>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);e=c[o>>2]|0;I=+h[e+2216>>3];J=e;K=v}}while(0);q=+h[J+2296>>3];r=+h[J+2304>>3];G=c[c[p>>2]>>2]|0;e=c[G+8>>2]|0;v=+h[e+10456>>3];x=+h[e+9840>>3];z=(+h[J+1088>>3]+ +h[J+1096>>3])*.5;F=+h[J+2264>>3];do{if(I!=0.0){L=J;M=F/I}else{if(F==0.0){L=J;M=F;break}D=F/+nwa(c[m>>2]|0,I,61408,61400,+h[G>>3],(a[b+319|0]|0)!=0|0);L=c[o>>2]|0;M=D}}while(0);Iz(g,f,K,q,q,r,r,v,x,z,M,+h[L+2240>>3]);M=+h[g>>3];g=c[m>>2]|0;L=c[o>>2]|0;z=+h[L+2216>>3];x=+h[L+2256>>3];do{if(z!=0.0){N=z;O=L;P=x/z}else{if(x==0.0){N=z;O=L;P=x;break}v=x/+nwa(g,z,61408,61400,+h[c[c[p>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);f=c[o>>2]|0;N=+h[f+2216>>3];O=f;P=v}}while(0);z=+h[O+2296>>3];x=+h[O+2304>>3];L=c[c[p>>2]>>2]|0;f=c[L+8>>2]|0;v=+h[f+10464>>3];r=+h[f+9832>>3];q=(+h[O+1096>>3]+ +h[O+1104>>3])*.5;K=+h[O+2264>>3];do{if(N!=0.0){Q=O;R=K/N}else{if(K==0.0){Q=O;R=K;break}I=K/+nwa(c[m>>2]|0,N,61408,61400,+h[L>>3],(a[b+319|0]|0)!=0|0);Q=c[o>>2]|0;R=I}}while(0);Iz(j,g,P,z,z,x,x,v,r,q,R,+h[Q+2240>>3]);R=+h[j>>3];j=c[m>>2]|0;Q=c[o>>2]|0;q=+h[Q+2216>>3];r=+h[Q+2256>>3];do{if(q!=0.0){S=q;T=Q;U=r/q}else{if(r==0.0){S=q;T=Q;U=r;break}v=r/+nwa(j,q,61408,61400,+h[c[c[p>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);g=c[o>>2]|0;S=+h[g+2216>>3];T=g;U=v}}while(0);q=+h[T+2296>>3];r=+h[T+2304>>3];Q=c[c[p>>2]>>2]|0;g=c[Q+8>>2]|0;v=+h[g+10472>>3];x=+h[g+9824>>3];z=(+h[T+1104>>3]+ +h[T+1112>>3])*.5;P=+h[T+2264>>3];do{if(S!=0.0){V=T;W=P/S}else{if(P==0.0){V=T;W=P;break}N=P/+nwa(c[m>>2]|0,S,61408,61400,+h[Q>>3],(a[b+319|0]|0)!=0|0);V=c[o>>2]|0;W=N}}while(0);Iz(k,j,U,q,q,r,r,v,x,z,W,+h[V+2240>>3]);W=+h[k>>3];k=c[m>>2]|0;V=c[o>>2]|0;z=+h[V+2216>>3];x=+h[V+2256>>3];do{if(z!=0.0){X=z;Y=V;Z=x/z}else{if(x==0.0){X=z;Y=V;Z=x;break}v=x/+nwa(k,z,61408,61400,+h[c[c[p>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);j=c[o>>2]|0;X=+h[j+2216>>3];Y=j;Z=v}}while(0);z=+h[Y+2296>>3];x=+h[Y+2304>>3];V=c[c[p>>2]>>2]|0;v=+h[(c[V+8>>2]|0)+10480>>3];r=+h[Y+1072>>3];q=+h[Y+1112>>3];U=(q+q)*.5;q=+h[Y+2264>>3];if(X!=0.0){_=Y;$=q/X;aa=_;ba=aa+2240|0;ca=ba;da=+h[ca>>3];Iz(l,k,Z,z,z,x,x,v,r,U,$,da);ea=l;fa=ea;ga=+h[fa>>3];ha=W+ga;ia=R+ha;ja=M+ia;ka=H+ja;la=B+ka;ma=c[p>>2]|0;na=c[ma>>2]|0;oa=na;pa=oa+8|0;qa=pa;ra=c[qa>>2]|0;sa=ra;ta=sa+10848|0;ua=ta;h[ua>>3]=la;i=d;return}if(q==0.0){_=Y;$=q;aa=_;ba=aa+2240|0;ca=ba;da=+h[ca>>3];Iz(l,k,Z,z,z,x,x,v,r,U,$,da);ea=l;fa=ea;ga=+h[fa>>3];ha=W+ga;ia=R+ha;ja=M+ia;ka=H+ja;la=B+ka;ma=c[p>>2]|0;na=c[ma>>2]|0;oa=na;pa=oa+8|0;qa=pa;ra=c[qa>>2]|0;sa=ra;ta=sa+10848|0;ua=ta;h[ua>>3]=la;i=d;return}S=q/+nwa(c[m>>2]|0,X,61408,61400,+h[V>>3],(a[b+319|0]|0)!=0|0);_=c[o>>2]|0;$=S;aa=_;ba=aa+2240|0;ca=ba;da=+h[ca>>3];Iz(l,k,Z,z,z,x,x,v,r,U,$,da);ea=l;fa=ea;ga=+h[fa>>3];ha=W+ga;ia=R+ha;ja=M+ia;ka=H+ja;la=B+ka;ma=c[p>>2]|0;na=c[ma>>2]|0;oa=na;pa=oa+8|0;qa=pa;ra=c[qa>>2]|0;sa=ra;ta=sa+10848|0;ua=ta;h[ua>>3]=la;i=d;return}function MW(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0,u=0.0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0.0,E=0,F=0.0,G=0,H=0.0,I=0.0,J=0,K=0.0,L=0,M=0.0,N=0.0,O=0,P=0.0,Q=0,R=0.0,S=0.0,T=0,U=0.0,V=0,W=0.0,X=0.0,Y=0,Z=0.0,_=0,$=0.0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;j=d+24|0;k=d+32|0;l=d+40|0;m=b+536|0;n=c[m>>2]|0;o=b+416|0;p=c[o>>2]|0;q=+h[p+1992>>3];r=+h[p+2032>>3];do{if(q!=0.0){s=q;t=p;u=r/q}else{if(r==0.0){s=q;t=p;u=r;break}v=r/+nwa(n,q,61448,61440,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);w=c[o>>2]|0;s=+h[w+1992>>3];t=w;u=v}}while(0);q=+h[t+2072>>3];r=+h[t+2080>>3];p=b+4|0;w=c[c[p>>2]>>2]|0;v=+h[(c[w+8>>2]|0)+10304>>3];x=+h[t+744>>3];y=+h[t+784>>3];z=(y+y)*.5;y=+h[t+2040>>3];do{if(s!=0.0){A=t;B=y/s}else{if(y==0.0){A=t;B=y;break}C=y/+nwa(c[m>>2]|0,s,61448,61440,+h[w>>3],(a[b+319|0]|0)!=0|0);A=c[o>>2]|0;B=C}}while(0);Iz(e,n,u,q,q,r,r,v,x,z,B,+h[A+2016>>3]);B=+h[e>>3];e=c[m>>2]|0;A=c[o>>2]|0;z=+h[A+1992>>3];x=+h[A+2032>>3];do{if(z!=0.0){D=z;E=A;F=x/z}else{if(x==0.0){D=z;E=A;F=x;break}v=x/+nwa(e,z,61448,61440,+h[c[c[p>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);n=c[o>>2]|0;D=+h[n+1992>>3];E=n;F=v}}while(0);z=+h[E+2072>>3];x=+h[E+2080>>3];A=c[c[p>>2]>>2]|0;n=c[A+8>>2]|0;v=+h[n+10312>>3];r=+h[n+9880>>3];q=(+h[E+784>>3]+ +h[E+792>>3])*.5;u=+h[E+2040>>3];do{if(D!=0.0){G=E;H=u/D}else{if(u==0.0){G=E;H=u;break}s=u/+nwa(c[m>>2]|0,D,61448,61440,+h[A>>3],(a[b+319|0]|0)!=0|0);G=c[o>>2]|0;H=s}}while(0);Iz(f,e,F,z,z,x,x,v,r,q,H,+h[G+2016>>3]);H=+h[f>>3];f=c[m>>2]|0;G=c[o>>2]|0;q=+h[G+1992>>3];r=+h[G+2032>>3];do{if(q!=0.0){I=q;J=G;K=r/q}else{if(r==0.0){I=q;J=G;K=r;break}v=r/+nwa(f,q,61448,61440,+h[c[c[p>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);e=c[o>>2]|0;I=+h[e+1992>>3];J=e;K=v}}while(0);q=+h[J+2072>>3];r=+h[J+2080>>3];G=c[c[p>>2]>>2]|0;e=c[G+8>>2]|0;v=+h[e+10320>>3];x=+h[e+9872>>3];z=(+h[J+792>>3]+ +h[J+800>>3])*.5;F=+h[J+2040>>3];do{if(I!=0.0){L=J;M=F/I}else{if(F==0.0){L=J;M=F;break}D=F/+nwa(c[m>>2]|0,I,61448,61440,+h[G>>3],(a[b+319|0]|0)!=0|0);L=c[o>>2]|0;M=D}}while(0);Iz(g,f,K,q,q,r,r,v,x,z,M,+h[L+2016>>3]);M=+h[g>>3];g=c[m>>2]|0;L=c[o>>2]|0;z=+h[L+1992>>3];x=+h[L+2032>>3];do{if(z!=0.0){N=z;O=L;P=x/z}else{if(x==0.0){N=z;O=L;P=x;break}v=x/+nwa(g,z,61448,61440,+h[c[c[p>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);f=c[o>>2]|0;N=+h[f+1992>>3];O=f;P=v}}while(0);z=+h[O+2072>>3];x=+h[O+2080>>3];L=c[c[p>>2]>>2]|0;f=c[L+8>>2]|0;v=+h[f+10328>>3];r=+h[f+9864>>3];q=(+h[O+800>>3]+ +h[O+808>>3])*.5;K=+h[O+2040>>3];do{if(N!=0.0){Q=O;R=K/N}else{if(K==0.0){Q=O;R=K;break}I=K/+nwa(c[m>>2]|0,N,61448,61440,+h[L>>3],(a[b+319|0]|0)!=0|0);Q=c[o>>2]|0;R=I}}while(0);Iz(j,g,P,z,z,x,x,v,r,q,R,+h[Q+2016>>3]);R=+h[j>>3];j=c[m>>2]|0;Q=c[o>>2]|0;q=+h[Q+1992>>3];r=+h[Q+2032>>3];do{if(q!=0.0){S=q;T=Q;U=r/q}else{if(r==0.0){S=q;T=Q;U=r;break}v=r/+nwa(j,q,61448,61440,+h[c[c[p>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);g=c[o>>2]|0;S=+h[g+1992>>3];T=g;U=v}}while(0);q=+h[T+2072>>3];r=+h[T+2080>>3];Q=c[c[p>>2]>>2]|0;g=c[Q+8>>2]|0;v=+h[g+10336>>3];x=+h[g+9856>>3];z=(+h[T+808>>3]+ +h[T+816>>3])*.5;P=+h[T+2040>>3];do{if(S!=0.0){V=T;W=P/S}else{if(P==0.0){V=T;W=P;break}N=P/+nwa(c[m>>2]|0,S,61448,61440,+h[Q>>3],(a[b+319|0]|0)!=0|0);V=c[o>>2]|0;W=N}}while(0);Iz(k,j,U,q,q,r,r,v,x,z,W,+h[V+2016>>3]);W=+h[k>>3];k=c[m>>2]|0;V=c[o>>2]|0;z=+h[V+1992>>3];x=+h[V+2032>>3];do{if(z!=0.0){X=z;Y=V;Z=x/z}else{if(x==0.0){X=z;Y=V;Z=x;break}v=x/+nwa(k,z,61448,61440,+h[c[c[p>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);j=c[o>>2]|0;X=+h[j+1992>>3];Y=j;Z=v}}while(0);z=+h[Y+2072>>3];x=+h[Y+2080>>3];V=c[c[p>>2]>>2]|0;v=+h[(c[V+8>>2]|0)+10344>>3];r=+h[Y+776>>3];q=+h[Y+816>>3];U=(q+q)*.5;q=+h[Y+2040>>3];if(X!=0.0){_=Y;$=q/X;aa=_;ba=aa+2016|0;ca=ba;da=+h[ca>>3];Iz(l,k,Z,z,z,x,x,v,r,U,$,da);ea=l;fa=ea;ga=+h[fa>>3];ha=W+ga;ia=R+ha;ja=M+ia;ka=H+ja;la=B+ka;ma=c[p>>2]|0;na=c[ma>>2]|0;oa=na;pa=oa+8|0;qa=pa;ra=c[qa>>2]|0;sa=ra;ta=sa+10840|0;ua=ta;h[ua>>3]=la;i=d;return}if(q==0.0){_=Y;$=q;aa=_;ba=aa+2016|0;ca=ba;da=+h[ca>>3];Iz(l,k,Z,z,z,x,x,v,r,U,$,da);ea=l;fa=ea;ga=+h[fa>>3];ha=W+ga;ia=R+ha;ja=M+ia;ka=H+ja;la=B+ka;ma=c[p>>2]|0;na=c[ma>>2]|0;oa=na;pa=oa+8|0;qa=pa;ra=c[qa>>2]|0;sa=ra;ta=sa+10840|0;ua=ta;h[ua>>3]=la;i=d;return}S=q/+nwa(c[m>>2]|0,X,61448,61440,+h[V>>3],(a[b+319|0]|0)!=0|0);_=c[o>>2]|0;$=S;aa=_;ba=aa+2016|0;ca=ba;da=+h[ca>>3];Iz(l,k,Z,z,z,x,x,v,r,U,$,da);ea=l;fa=ea;ga=+h[fa>>3];ha=W+ga;ia=R+ha;ja=M+ia;ka=H+ja;la=B+ka;ma=c[p>>2]|0;na=c[ma>>2]|0;oa=na;pa=oa+8|0;qa=pa;ra=c[qa>>2]|0;sa=ra;ta=sa+10840|0;ua=ta;h[ua>>3]=la;i=d;return}function NW(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0,E=0.0,F=0,G=0.0,H=0.0,I=0,J=0.0,K=0,L=0.0,M=0.0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;j=d+24|0;k=b+536|0;l=c[k>>2]|0;m=b+416|0;n=c[m>>2]|0;o=+h[n+1760>>3];p=+h[n+1800>>3];do{if(o!=0.0){q=o;r=n;s=p/o}else{if(p==0.0){q=o;r=n;s=p;break}t=p/+nwa(l,o,61488,61480,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);u=c[m>>2]|0;q=+h[u+1760>>3];r=u;s=t}}while(0);o=+h[r+1840>>3];p=+h[r+1848>>3];n=b+4|0;u=c[c[n>>2]>>2]|0;v=c[u+8>>2]|0;t=+h[v+10200>>3];w=+h[v+9888>>3];x=(+h[r+488>>3]+ +h[r+496>>3])*.5;y=+h[r+1808>>3];do{if(q!=0.0){z=r;A=y/q}else{if(y==0.0){z=r;A=y;break}B=y/+nwa(c[k>>2]|0,q,61488,61480,+h[u>>3],(a[b+319|0]|0)!=0|0);z=c[m>>2]|0;A=B}}while(0);Iz(e,l,s,o,o,p,p,t,w,x,A,+h[z+1784>>3]);A=+h[e>>3];e=c[k>>2]|0;z=c[m>>2]|0;x=+h[z+1760>>3];w=+h[z+1800>>3];do{if(x!=0.0){C=x;D=z;E=w/x}else{if(w==0.0){C=x;D=z;E=w;break}t=w/+nwa(e,x,61488,61480,+h[c[c[n>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);l=c[m>>2]|0;C=+h[l+1760>>3];D=l;E=t}}while(0);x=+h[D+1840>>3];w=+h[D+1848>>3];z=c[c[n>>2]>>2]|0;l=c[z+8>>2]|0;t=+h[l+10208>>3];p=+h[l+9896>>3];o=(+h[D+496>>3]+ +h[D+504>>3])*.5;s=+h[D+1808>>3];do{if(C!=0.0){F=D;G=s/C}else{if(s==0.0){F=D;G=s;break}q=s/+nwa(c[k>>2]|0,C,61488,61480,+h[z>>3],(a[b+319|0]|0)!=0|0);F=c[m>>2]|0;G=q}}while(0);Iz(f,e,E,x,x,w,w,t,p,o,G,+h[F+1784>>3]);G=+h[f>>3];f=c[k>>2]|0;F=c[m>>2]|0;o=+h[F+1760>>3];p=+h[F+1800>>3];do{if(o!=0.0){H=o;I=F;J=p/o}else{if(p==0.0){H=o;I=F;J=p;break}t=p/+nwa(f,o,61488,61480,+h[c[c[n>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);e=c[m>>2]|0;H=+h[e+1760>>3];I=e;J=t}}while(0);o=+h[I+1840>>3];p=+h[I+1848>>3];F=c[c[n>>2]>>2]|0;e=c[F+8>>2]|0;t=+h[e+10216>>3];w=+h[e+9904>>3];x=(+h[I+504>>3]+ +h[I+512>>3])*.5;E=+h[I+1808>>3];do{if(H!=0.0){K=I;L=E/H}else{if(E==0.0){K=I;L=E;break}C=E/+nwa(c[k>>2]|0,H,61488,61480,+h[F>>3],(a[b+319|0]|0)!=0|0);K=c[m>>2]|0;L=C}}while(0);Iz(g,f,J,o,o,p,p,t,w,x,L,+h[K+1784>>3]);L=+h[g>>3];g=c[k>>2]|0;K=c[m>>2]|0;x=+h[K+1760>>3];w=+h[K+1800>>3];do{if(x!=0.0){M=x;N=K;O=w/x}else{if(w==0.0){M=x;N=K;O=w;break}t=w/+nwa(g,x,61488,61480,+h[c[c[n>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);f=c[m>>2]|0;M=+h[f+1760>>3];N=f;O=t}}while(0);x=+h[N+1840>>3];w=+h[N+1848>>3];K=c[c[n>>2]>>2]|0;f=c[K+8>>2]|0;t=+h[f+10224>>3];p=+h[f+9912>>3];o=(+h[N+512>>3]+ +h[N+520>>3])*.5;J=+h[N+1808>>3];if(M!=0.0){P=N;Q=J/M;R=P;S=R+1784|0;T=S;U=+h[T>>3];Iz(j,g,O,x,x,w,w,t,p,o,Q,U);V=j;W=V;X=+h[W>>3];Y=L+X;Z=G+Y;_=A+Z;$=c[n>>2]|0;aa=c[$>>2]|0;ba=aa;ca=ba+8|0;da=ca;ea=c[da>>2]|0;fa=ea;ga=fa+10832|0;ha=ga;h[ha>>3]=_;i=d;return}if(J==0.0){P=N;Q=J;R=P;S=R+1784|0;T=S;U=+h[T>>3];Iz(j,g,O,x,x,w,w,t,p,o,Q,U);V=j;W=V;X=+h[W>>3];Y=L+X;Z=G+Y;_=A+Z;$=c[n>>2]|0;aa=c[$>>2]|0;ba=aa;ca=ba+8|0;da=ca;ea=c[da>>2]|0;fa=ea;ga=fa+10832|0;ha=ga;h[ha>>3]=_;i=d;return}H=J/+nwa(c[k>>2]|0,M,61488,61480,+h[K>>3],(a[b+319|0]|0)!=0|0);P=c[m>>2]|0;Q=H;R=P;S=R+1784|0;T=S;U=+h[T>>3];Iz(j,g,O,x,x,w,w,t,p,o,Q,U);V=j;W=V;X=+h[W>>3];Y=L+X;Z=G+Y;_=A+Z;$=c[n>>2]|0;aa=c[$>>2]|0;ba=aa;ca=ba+8|0;da=ca;ea=c[da>>2]|0;fa=ea;ga=fa+10832|0;ha=ga;h[ha>>3]=_;i=d;return}function OW(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0,u=0.0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0.0,E=0,F=0.0,G=0,H=0.0,I=0.0,J=0,K=0.0,L=0,M=0.0,N=0.0,O=0,P=0.0,Q=0,R=0.0,S=0.0,T=0,U=0.0,V=0,W=0.0,X=0.0,Y=0,Z=0.0,_=0,$=0.0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;j=d+24|0;k=d+32|0;l=d+40|0;m=b+536|0;n=c[m>>2]|0;o=b+416|0;p=c[o>>2]|0;q=+h[p+1536>>3];r=+h[p+1576>>3];do{if(q!=0.0){s=q;t=p;u=r/q}else{if(r==0.0){s=q;t=p;u=r;break}v=r/+nwa(n,q,61528,61520,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);w=c[o>>2]|0;s=+h[w+1536>>3];t=w;u=v}}while(0);q=+h[t+1616>>3];r=+h[t+1624>>3];p=b+4|0;w=c[c[p>>2]>>2]|0;v=+h[(c[w+8>>2]|0)+10008>>3];x=+h[t+152>>3];y=+h[t+192>>3];z=(y+y)*.5;y=+h[t+1584>>3];do{if(s!=0.0){A=t;B=y/s}else{if(y==0.0){A=t;B=y;break}C=y/+nwa(c[m>>2]|0,s,61528,61520,+h[w>>3],(a[b+319|0]|0)!=0|0);A=c[o>>2]|0;B=C}}while(0);Iz(e,n,u,q,q,r,r,v,x,z,B,+h[A+1560>>3]);B=+h[e>>3];e=c[m>>2]|0;A=c[o>>2]|0;z=+h[A+1536>>3];x=+h[A+1576>>3];do{if(z!=0.0){D=z;E=A;F=x/z}else{if(x==0.0){D=z;E=A;F=x;break}v=x/+nwa(e,z,61528,61520,+h[c[c[p>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);n=c[o>>2]|0;D=+h[n+1536>>3];E=n;F=v}}while(0);z=+h[E+1616>>3];x=+h[E+1624>>3];A=c[c[p>>2]>>2]|0;n=c[A+8>>2]|0;v=+h[n+10016>>3];r=+h[n+9952>>3];q=(+h[E+192>>3]+ +h[E+200>>3])*.5;u=+h[E+1584>>3];do{if(D!=0.0){G=E;H=u/D}else{if(u==0.0){G=E;H=u;break}s=u/+nwa(c[m>>2]|0,D,61528,61520,+h[A>>3],(a[b+319|0]|0)!=0|0);G=c[o>>2]|0;H=s}}while(0);Iz(f,e,F,z,z,x,x,v,r,q,H,+h[G+1560>>3]);H=+h[f>>3];f=c[m>>2]|0;G=c[o>>2]|0;q=+h[G+1536>>3];r=+h[G+1576>>3];do{if(q!=0.0){I=q;J=G;K=r/q}else{if(r==0.0){I=q;J=G;K=r;break}v=r/+nwa(f,q,61528,61520,+h[c[c[p>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);e=c[o>>2]|0;I=+h[e+1536>>3];J=e;K=v}}while(0);q=+h[J+1616>>3];r=+h[J+1624>>3];G=c[c[p>>2]>>2]|0;e=c[G+8>>2]|0;v=+h[e+10024>>3];x=+h[e+9944>>3];z=(+h[J+200>>3]+ +h[J+208>>3])*.5;F=+h[J+1584>>3];do{if(I!=0.0){L=J;M=F/I}else{if(F==0.0){L=J;M=F;break}D=F/+nwa(c[m>>2]|0,I,61528,61520,+h[G>>3],(a[b+319|0]|0)!=0|0);L=c[o>>2]|0;M=D}}while(0);Iz(g,f,K,q,q,r,r,v,x,z,M,+h[L+1560>>3]);M=+h[g>>3];g=c[m>>2]|0;L=c[o>>2]|0;z=+h[L+1536>>3];x=+h[L+1576>>3];do{if(z!=0.0){N=z;O=L;P=x/z}else{if(x==0.0){N=z;O=L;P=x;break}v=x/+nwa(g,z,61528,61520,+h[c[c[p>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);f=c[o>>2]|0;N=+h[f+1536>>3];O=f;P=v}}while(0);z=+h[O+1616>>3];x=+h[O+1624>>3];L=c[c[p>>2]>>2]|0;f=c[L+8>>2]|0;v=+h[f+10032>>3];r=+h[f+9936>>3];q=(+h[O+208>>3]+ +h[O+216>>3])*.5;K=+h[O+1584>>3];do{if(N!=0.0){Q=O;R=K/N}else{if(K==0.0){Q=O;R=K;break}I=K/+nwa(c[m>>2]|0,N,61528,61520,+h[L>>3],(a[b+319|0]|0)!=0|0);Q=c[o>>2]|0;R=I}}while(0);Iz(j,g,P,z,z,x,x,v,r,q,R,+h[Q+1560>>3]);R=+h[j>>3];j=c[m>>2]|0;Q=c[o>>2]|0;q=+h[Q+1536>>3];r=+h[Q+1576>>3];do{if(q!=0.0){S=q;T=Q;U=r/q}else{if(r==0.0){S=q;T=Q;U=r;break}v=r/+nwa(j,q,61528,61520,+h[c[c[p>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);g=c[o>>2]|0;S=+h[g+1536>>3];T=g;U=v}}while(0);q=+h[T+1616>>3];r=+h[T+1624>>3];Q=c[c[p>>2]>>2]|0;g=c[Q+8>>2]|0;v=+h[g+10040>>3];x=+h[g+9928>>3];z=(+h[T+216>>3]+ +h[T+224>>3])*.5;P=+h[T+1584>>3];do{if(S!=0.0){V=T;W=P/S}else{if(P==0.0){V=T;W=P;break}N=P/+nwa(c[m>>2]|0,S,61528,61520,+h[Q>>3],(a[b+319|0]|0)!=0|0);V=c[o>>2]|0;W=N}}while(0);Iz(k,j,U,q,q,r,r,v,x,z,W,+h[V+1560>>3]);W=+h[k>>3];k=c[m>>2]|0;V=c[o>>2]|0;z=+h[V+1536>>3];x=+h[V+1576>>3];do{if(z!=0.0){X=z;Y=V;Z=x/z}else{if(x==0.0){X=z;Y=V;Z=x;break}v=x/+nwa(k,z,61528,61520,+h[c[c[p>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);j=c[o>>2]|0;X=+h[j+1536>>3];Y=j;Z=v}}while(0);z=+h[Y+1616>>3];x=+h[Y+1624>>3];V=c[c[p>>2]>>2]|0;v=+h[(c[V+8>>2]|0)+10048>>3];r=+h[Y+184>>3];q=+h[Y+224>>3];U=(q+q)*.5;q=+h[Y+1584>>3];if(X!=0.0){_=Y;$=q/X;aa=_;ba=aa+1560|0;ca=ba;da=+h[ca>>3];Iz(l,k,Z,z,z,x,x,v,r,U,$,da);ea=l;fa=ea;ga=+h[fa>>3];ha=W+ga;ia=R+ha;ja=M+ia;ka=H+ja;la=B+ka;ma=c[p>>2]|0;na=c[ma>>2]|0;oa=na;pa=oa+8|0;qa=pa;ra=c[qa>>2]|0;sa=ra;ta=sa+10824|0;ua=ta;h[ua>>3]=la;i=d;return}if(q==0.0){_=Y;$=q;aa=_;ba=aa+1560|0;ca=ba;da=+h[ca>>3];Iz(l,k,Z,z,z,x,x,v,r,U,$,da);ea=l;fa=ea;ga=+h[fa>>3];ha=W+ga;ia=R+ha;ja=M+ia;ka=H+ja;la=B+ka;ma=c[p>>2]|0;na=c[ma>>2]|0;oa=na;pa=oa+8|0;qa=pa;ra=c[qa>>2]|0;sa=ra;ta=sa+10824|0;ua=ta;h[ua>>3]=la;i=d;return}S=q/+nwa(c[m>>2]|0,X,61528,61520,+h[V>>3],(a[b+319|0]|0)!=0|0);_=c[o>>2]|0;$=S;aa=_;ba=aa+1560|0;ca=ba;da=+h[ca>>3];Iz(l,k,Z,z,z,x,x,v,r,U,$,da);ea=l;fa=ea;ga=+h[fa>>3];ha=W+ga;ia=R+ha;ja=M+ia;ka=H+ja;la=B+ka;ma=c[p>>2]|0;na=c[ma>>2]|0;oa=na;pa=oa+8|0;qa=pa;ra=c[qa>>2]|0;sa=ra;ta=sa+10824|0;ua=ta;h[ua>>3]=la;i=d;return}function PW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9792>>3]=+h[b+992>>3]*+h[b+2192>>3];i=i;return}function QW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9784>>3]=+h[b+984>>3]*+h[b+2192>>3];i=i;return}function RW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9776>>3]=+h[b+976>>3]*+h[b+2192>>3];i=i;return}function SW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9768>>3]=+h[b+968>>3]*+h[b+2192>>3];i=i;return}function TW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9760>>3]=+h[b+960>>3]*+h[b+2192>>3];i=i;return}function UW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9752>>3]=+h[b+696>>3]*+h[b+1968>>3];i=i;return}function VW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9744>>3]=+h[b+688>>3]*+h[b+1968>>3];i=i;return}function WW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9736>>3]=+h[b+680>>3]*+h[b+1968>>3];i=i;return}function XW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9728>>3]=+h[b+672>>3]*+h[b+1968>>3];i=i;return}function YW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9720>>3]=+h[b+664>>3]*+h[b+1968>>3];i=i;return}function ZW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9712>>3]=+h[b+104>>3]*+h[b+1512>>3];i=i;return}function _W(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9704>>3]=+h[b+96>>3]*+h[b+1512>>3];i=i;return}function $W(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9696>>3]=+h[b+88>>3]*+h[b+1512>>3];i=i;return}function aX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9688>>3]=+h[b+80>>3]*+h[b+1512>>3];i=i;return}function bX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9680>>3]=+h[b+72>>3]*+h[b+1512>>3];i=i;return}function cX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0;b=i;i=i+88|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=a+536|0;k=c[j>>2]|0;l=a+4|0;m=+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+9800>>3];a=e;n=61560;c[a+0>>2]=c[n+0>>2];c[a+4>>2]=c[n+4>>2];c[a+8>>2]=c[n+8>>2];vz(f,k,15.0e4,m,e);e=c[j>>2]|0;j=d;k=f;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];c[j+24>>2]=c[k+24>>2];c[j+28>>2]=c[k+28>>2];Cz(g,e,d);h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+9624>>3]=+h[g>>3];i=b;return}function dX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0;b=i;i=i+88|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=a+536|0;k=c[j>>2]|0;l=a+4|0;m=+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+9800>>3];a=e;n=61560;c[a+0>>2]=c[n+0>>2];c[a+4>>2]=c[n+4>>2];c[a+8>>2]=c[n+8>>2];vz(f,k,15.0e4,m,e);e=c[j>>2]|0;j=d;k=f;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];c[j+24>>2]=c[k+24>>2];c[j+28>>2]=c[k+28>>2];Fz(g,e,d);h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+9568>>3]=+h[g>>3];i=b;return}function eX(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+10816>>3]=+zd(+(.01- +h[d+10856>>3]),0.0);i=b;return}function fX(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10808>>3]=.01- +h[b+10816>>3];i=i;return}function gX(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0,u=0,v=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10816>>3];k=1.0-j;if(k!=0.0){l=k;m=j;n=g;o=f}else{j=+nwa(c[b+536>>2]|0,k,61584,61576,+h[f>>3],(a[b+319|0]|0)!=0|0);f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;l=j;m=+h[g+10816>>3];n=g;o=f}j=284.1807127034489/l;l=1.0-m;m=+h[n+10808>>3];if(l!=0.0){p=n;q=m/l;r=q*461.5233290850878;s=j+r;t=p;u=t+10800|0;v=u;h[v>>3]=s;i=d;return}if(m==0.0){p=n;q=m;r=q*461.5233290850878;s=j+r;t=p;u=t+10800|0;v=u;h[v>>3]=s;i=d;return}k=m/+nwa(c[b+536>>2]|0,l,61584,61576,+h[o>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=k;r=q*461.5233290850878;s=j+r;t=p;u=t+10800|0;v=u;h[v>>3]=s;i=d;return}function hX(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10792>>3]=+h[b+10904>>3]+ +h[b+10800>>3]*-293.15;i=i;return}function iX(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10800>>3]*293.15;if(j!=0.0){k=j;l=g;m=15.0e4/k;n=l;o=n+10784|0;p=o;h[p>>3]=m;i=d;return}q=+nwa(c[b+536>>2]|0,j,61624,61616,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=15.0e4/k;n=l;o=n+10784|0;p=o;h[p>>3]=m;i=d;return}function jX(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[c[b+356>>2]|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[c[b+356>>2]|0]|0;k=zza(+h[c[c[b+4>>2]>>2]>>3],+h[(c[b+416>>2]|0)+2376>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=k;f=j;break}else{j=zza(+h[c[c[b+4>>2]>>2]>>3],+h[(c[b+416>>2]|0)+2376>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=j;f=j;break}}else{if(g){g=a[c[b+356>>2]|0]|0;j=Aza(+h[c[c[b+4>>2]>>2]>>3],+h[(c[b+416>>2]|0)+2376>>3])|0;a[c[b+352>>2]|0]=j;f=g;break}else{g=Aza(+h[c[c[b+4>>2]>>2]>>3],+h[(c[b+416>>2]|0)+2376>>3])|0;a[c[b+352>>2]|0]=g;f=g;break}}}}while(0);if(!(f<<24>>24==0)){l=b+416|0;m=0.0;n=c[l>>2]|0;o=n;p=o+2368|0;q=p;r=+h[q>>3];s=m+r;t=b;u=t+4|0;v=u;w=c[v>>2]|0;x=c[w>>2]|0;y=x;z=y+8|0;A=z;B=c[A>>2]|0;C=B;D=C+10672|0;E=D;h[E>>3]=s;i=d;return}do{if((a[e]|0)==0){F=a[(c[b+356>>2]|0)+1|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){g=a[(c[b+356>>2]|0)+1|0]|0;j=c[b+416>>2]|0;k=zza(+h[c[c[b+4>>2]>>2]>>3],+h[j+2376>>3]+ +h[j+2360>>3],a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=k;F=g;break}else{g=c[b+416>>2]|0;k=zza(+h[c[c[b+4>>2]>>2]>>3],+h[g+2376>>3]+ +h[g+2360>>3],a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=k;F=k;break}}else{if(f){f=a[(c[b+356>>2]|0)+1|0]|0;k=c[b+416>>2]|0;g=Aza(+h[c[c[b+4>>2]>>2]>>3],+h[k+2376>>3]+ +h[k+2360>>3])|0;a[(c[b+352>>2]|0)+1|0]=g;F=f;break}else{f=c[b+416>>2]|0;g=Aza(+h[c[c[b+4>>2]>>2]>>3],+h[f+2376>>3]+ +h[f+2360>>3])|0;a[(c[b+352>>2]|0)+1|0]=g;F=g;break}}}}while(0);if(F<<24>>24==0){F=b+416|0;l=F;m=+h[(c[F>>2]|0)+2352>>3];n=c[l>>2]|0;o=n;p=o+2368|0;q=p;r=+h[q>>3];s=m+r;t=b;u=t+4|0;v=u;w=c[v>>2]|0;x=c[w>>2]|0;y=x;z=y+8|0;A=z;B=c[A>>2]|0;C=B;D=C+10672|0;E=D;h[E>>3]=s;i=d;return}G=+h[c[c[b+4>>2]>>2]>>3];F=b+416|0;e=c[F>>2]|0;H=G- +h[e+2376>>3];I=+h[e+2360>>3];J=+h[e+2352>>3];do{if(I!=0.0){K=J/I}else{if(J==0.0){K=J;break}K=J/+nwa(c[b+536>>2]|0,I,61664,61656,G,(a[b+319|0]|0)!=0|0)}}while(0);l=F;m=H*K;n=c[l>>2]|0;o=n;p=o+2368|0;q=p;r=+h[q>>3];s=m+r;t=b;u=t+4|0;v=u;w=c[v>>2]|0;x=c[w>>2]|0;y=x;z=y+8|0;A=z;B=c[A>>2]|0;C=B;D=C+10672|0;E=D;h[E>>3]=s;i=d;return}function kX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,k=0;b=i;i=i+24|0;d=b;e=b+16|0;f=c[a+536>>2]|0;g=a+4|0;j=+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10672>>3];a=d;k=61176;c[a+0>>2]=c[k+0>>2];c[a+4>>2]=c[k+4>>2];c[a+8>>2]=c[k+8>>2];GA(e,f,j,293.15,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10760>>3]=+h[e>>3];i=b;return}function lX(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;AA(d,c[a+536>>2]|0,293.15);e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+10688>>3]=+yd(+(+h[d>>3]),+(+h[e+10672>>3]*.999));i=b;return}function mX(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10688>>3];k=+zd(1.0e-13,+(+h[g+10672>>3]-j));if(k!=0.0){l=k;m=g;n=.99/l;o=j*n;p=o*.6219647130774989;q=+yd(+p,1.0);r=m;s=r+10704|0;t=s;h[t>>3]=q;i=d;return}u=+nwa(c[b+536>>2]|0,k,61688,61680,+h[f>>3],(a[b+319|0]|0)!=0|0);l=u;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=.99/l;o=j*n;p=o*.6219647130774989;q=+yd(+p,1.0);r=m;s=r+10704|0;t=s;h[t>>3]=q;i=d;return}function nX(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+10720>>3]=+zd(+(.01- +h[d+10704>>3]),0.0);i=b;return}function oX(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10712>>3]=.01- +h[b+10720>>3];i=i;return}function pX(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0,u=0,v=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10720>>3];k=1.0-j;if(k!=0.0){l=k;m=j;n=g;o=f}else{j=+nwa(c[b+536>>2]|0,k,61760,61752,+h[f>>3],(a[b+319|0]|0)!=0|0);f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;l=j;m=+h[g+10720>>3];n=g;o=f}j=284.1807127034489/l;l=1.0-m;m=+h[n+10712>>3];if(l!=0.0){p=n;q=m/l;r=q*461.5233290850878;s=j+r;t=p;u=t+10736|0;v=u;h[v>>3]=s;i=d;return}if(m==0.0){p=n;q=m;r=q*461.5233290850878;s=j+r;t=p;u=t+10736|0;v=u;h[v>>3]=s;i=d;return}k=m/+nwa(c[b+536>>2]|0,l,61760,61752,+h[o>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=k;r=q*461.5233290850878;s=j+r;t=p;u=t+10736|0;v=u;h[v>>3]=s;i=d;return}function qX(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10744>>3]=+h[b+10760>>3]+ +h[b+10736>>3]*-293.15;i=i;return}function rX(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10736>>3]*293.15;k=+h[g+10672>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+10752|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+10752|0;p=o;h[p>>3]=m;i=d;return}q=k/+nwa(c[b+536>>2]|0,j,61800,61792,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+10752|0;p=o;h[p>>3]=m;i=d;return}function sX(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10688>>3];k=+zd(1.0e-13,+(+h[g+10672>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+nwa(c[b+536>>2]|0,k,61688,61832,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+10696>>3]=m*.6219647130774989;i=d;return}function tX(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+10688>>3];k=+h[g+10672>>3];do{if(j!=0.0){l=g;m=k/j}else{if(k==0.0){l=g;m=k;break}n=k/+nwa(c[b+536>>2]|0,j,61848,61840,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+10728>>3]=m*.01598094902253916;i=d;return}function uX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0;b=i;i=i+216|0;d=b;e=b+96|0;f=b+112|0;g=b+208|0;c[f>>2]=61192;h[f+8>>3]=.01801528;h[f+16>>3]=-13423382.81725291;h[f+24>>3]=549760.6476280135;h[f+32>>3]=1.0e3;j=f+40|0;k=61200;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=f+52|0;j=61216;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];j=f+64|0;k=61232;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=f+76|0;j=61248;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];h[f+88>>3]=461.5233290850878;j=c[a+536>>2]|0;k=a+4|0;a=c[(c[c[k>>2]>>2]|0)+8>>2]|0;l=+h[a+10760>>3];m=+h[a+10672>>3];a=e;n=61176;c[a+0>>2]=c[n+0>>2];c[a+4>>2]=c[n+4>>2];c[a+8>>2]=c[n+8>>2];n=d+0|0;a=f+0|0;f=n+96|0;do{c[n>>2]=c[a>>2];n=n+4|0;a=a+4|0}while((n|0)<(f|0));nA(g,j,l,190.0,647.0,m,e,d,1.0e-13);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+2832>>3]=+h[g>>3];i=b;return}function vX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0;b=i;i=i+88|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=a+536|0;k=c[j>>2]|0;l=a+4|0;a=c[(c[c[l>>2]>>2]|0)+8>>2]|0;m=+h[a+10672>>3];n=+h[a+2832>>3];a=e;o=61560;c[a+0>>2]=c[o+0>>2];c[a+4>>2]=c[o+4>>2];c[a+8>>2]=c[o+8>>2];vz(f,k,m,n,e);e=c[j>>2]|0;j=d;k=f;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];c[j+24>>2]=c[k+24>>2];c[j+28>>2]=c[k+28>>2];Cz(g,e,d);h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+2328>>3]=+h[g>>3];i=b;return}function wX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0;b=i;i=i+88|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=a+536|0;k=c[j>>2]|0;l=a+4|0;a=c[(c[c[l>>2]>>2]|0)+8>>2]|0;m=+h[a+10672>>3];n=+h[a+2832>>3];a=e;o=61560;c[a+0>>2]=c[o+0>>2];c[a+4>>2]=c[o+4>>2];c[a+8>>2]=c[o+8>>2];vz(f,k,m,n,e);e=c[j>>2]|0;j=d;k=f;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];c[j+24>>2]=c[k+24>>2];c[j+28>>2]=c[k+28>>2];Fz(g,e,d);h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+2432>>3]=+h[g>>3];i=b;return}function xX(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10680>>3]=+h[b+10672>>3]*1.0e-5;i=i;return}function yX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+664>>3]=0.0;i=i;return}function zX(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9120>>3]=-+h[b+664>>3];i=i;return}function AX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+688>>3]=0.0;i=i;return}function BX(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9112>>3]=-+h[b+688>>3];i=i;return}function CX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+712>>3]=0.0;i=i;return}function DX(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9104>>3]=-+h[b+712>>3];i=i;return}function EX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+736>>3]=0.0;i=i;return}function FX(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9096>>3]=-+h[b+736>>3];i=i;return}function GX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+760>>3]=0.0;i=i;return}function HX(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9088>>3]=-+h[b+760>>3];i=i;return}function IX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+672>>3]=0.0;i=i;return}function JX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+696>>3]=0.0;i=i;return}function KX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+720>>3]=0.0;i=i;return}function LX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+744>>3]=0.0;i=i;return}function MX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+768>>3]=0.0;i=i;return}function NX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+656>>3]=0.0;i=i;return}function OX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+680>>3]=0.0;i=i;return}function PX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+704>>3]=0.0;i=i;return}function QX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+728>>3]=0.0;i=i;return}function RX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+752>>3]=0.0;i=i;return}function SX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+816>>3]=0.0;i=i;return}function TX(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8320>>3]=+h[b+816>>3]*+h[b+10480>>3];i=i;return}function UX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+808>>3]=0.0;i=i;return}function VX(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8312>>3]=+h[b+808>>3]*+h[b+10472>>3];i=i;return}function WX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+800>>3]=0.0;i=i;return}function XX(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8304>>3]=+h[b+800>>3]*+h[b+10464>>3];i=i;return}function YX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+792>>3]=0.0;i=i;return}function ZX(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8296>>3]=+h[b+792>>3]*+h[b+10456>>3];i=i;return}function _X(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+784>>3]=0.0;i=i;return}function $X(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8288>>3]=+h[b+784>>3]*+h[b+10448>>3];i=i;return}function aY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+776>>3]=0.0;i=i;return}function bY(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8280>>3]=+h[b+776>>3]*+h[b+10440>>3];i=i;return}function cY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2272>>3]=+h[b+1384>>3];i=i;return}function dY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2248>>3]=+h[b+2272>>3]*1.0e3;i=i;return}function eY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+832>>3]=0.0;i=i;return}function fY(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8960>>3]=-+h[b+832>>3];i=i;return}function gY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+856>>3]=0.0;i=i;return}function hY(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8952>>3]=-+h[b+856>>3];i=i;return}function iY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+880>>3]=0.0;i=i;return}function jY(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8944>>3]=-+h[b+880>>3];i=i;return}function kY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+904>>3]=0.0;i=i;return}function lY(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8936>>3]=-+h[b+904>>3];i=i;return}function mY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+928>>3]=0.0;i=i;return}function nY(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8928>>3]=-+h[b+928>>3];i=i;return}function oY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+840>>3]=0.0;i=i;return}function pY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+864>>3]=0.0;i=i;return}function qY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+888>>3]=0.0;i=i;return}function rY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+912>>3]=0.0;i=i;return}function sY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+936>>3]=0.0;i=i;return}function tY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+824>>3]=0.0;i=i;return}function uY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+848>>3]=0.0;i=i;return}function vY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+872>>3]=0.0;i=i;return}function wY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+896>>3]=0.0;i=i;return}function xY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+920>>3]=0.0;i=i;return}function yY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+984>>3]=0.0;i=i;return}function zY(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8152>>3]=+h[b+984>>3]*+h[b+10344>>3];i=i;return}function AY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+976>>3]=0.0;i=i;return}function BY(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8144>>3]=+h[b+976>>3]*+h[b+10336>>3];i=i;return}function CY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+968>>3]=0.0;i=i;return}function DY(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8136>>3]=+h[b+968>>3]*+h[b+10328>>3];i=i;return}function EY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+960>>3]=0.0;i=i;return}function FY(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8128>>3]=+h[b+960>>3]*+h[b+10320>>3];i=i;return}function GY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+952>>3]=0.0;i=i;return}function HY(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8120>>3]=+h[b+952>>3]*+h[b+10312>>3];i=i;return}function IY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+944>>3]=0.0;i=i;return}function JY(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8112>>3]=+h[b+944>>3]*+h[b+10304>>3];i=i;return}function KY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2048>>3]=+h[b+1384>>3];i=i;return}function LY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2024>>3]=+h[b+2048>>3]*1.0e3;i=i;return}function MY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1e3>>3]=0.0;i=i;return}function NY(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8800>>3]=-+h[b+1e3>>3];i=i;return}function OY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1024>>3]=0.0;i=i;return}function PY(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8792>>3]=-+h[b+1024>>3];i=i;return}function QY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1048>>3]=0.0;i=i;return}function RY(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8784>>3]=-+h[b+1048>>3];i=i;return}function SY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1072>>3]=0.0;i=i;return}function TY(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8776>>3]=-+h[b+1072>>3];i=i;return}function UY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1096>>3]=0.0;i=i;return}function VY(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8768>>3]=-+h[b+1096>>3];i=i;return}function WY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1008>>3]=0.0;i=i;return}function XY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1032>>3]=0.0;i=i;return}function YY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1056>>3]=0.0;i=i;return}function ZY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1080>>3]=0.0;i=i;return}function _Y(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1104>>3]=0.0;i=i;return}function $Y(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+992>>3]=0.0;i=i;return}function aZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1016>>3]=0.0;i=i;return}function bZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1040>>3]=0.0;i=i;return}function cZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1064>>3]=0.0;i=i;return}function dZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1088>>3]=0.0;i=i;return}function eZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1136>>3]=0.0;i=i;return}function fZ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7984>>3]=+h[b+1136>>3]*+h[b+10224>>3];i=i;return}function gZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1128>>3]=0.0;i=i;return}function hZ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7976>>3]=+h[b+1128>>3]*+h[b+10216>>3];i=i;return}function iZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1120>>3]=0.0;i=i;return}function jZ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7968>>3]=+h[b+1120>>3]*+h[b+10208>>3];i=i;return}function kZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1112>>3]=0.0;i=i;return}function lZ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7960>>3]=+h[b+1112>>3]*+h[b+10200>>3];i=i;return}function mZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1816>>3]=+h[b+1384>>3];i=i;return}function nZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1792>>3]=+h[b+1816>>3]*1.0e3;i=i;return}function oZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1152>>3]=0.0;i=i;return}function pZ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8640>>3]=-+h[b+1152>>3];i=i;return}function qZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1176>>3]=0.0;i=i;return}function rZ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8632>>3]=-+h[b+1176>>3];i=i;return}function sZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1200>>3]=0.0;i=i;return}function tZ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8624>>3]=-+h[b+1200>>3];i=i;return}function uZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1224>>3]=0.0;i=i;return}function vZ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8616>>3]=-+h[b+1224>>3];i=i;return}function wZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1248>>3]=0.0;i=i;return}function xZ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8608>>3]=-+h[b+1248>>3];i=i;return}function yZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1160>>3]=0.0;i=i;return}function zZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1184>>3]=0.0;i=i;return}function AZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1208>>3]=0.0;i=i;return}function BZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1232>>3]=0.0;i=i;return}function CZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1256>>3]=0.0;i=i;return}function DZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1144>>3]=0.0;i=i;return}function EZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1168>>3]=0.0;i=i;return}function FZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1192>>3]=0.0;i=i;return}function GZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1216>>3]=0.0;i=i;return}function HZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1240>>3]=0.0;i=i;return}function IZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1304>>3]=0.0;i=i;return}function JZ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7832>>3]=+h[b+1304>>3]*+h[b+10048>>3];i=i;return}function KZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1296>>3]=0.0;i=i;return}function LZ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7824>>3]=+h[b+1296>>3]*+h[b+10040>>3];i=i;return}function MZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1288>>3]=0.0;i=i;return}function NZ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7816>>3]=+h[b+1288>>3]*+h[b+10032>>3];i=i;return}function OZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1280>>3]=0.0;i=i;return}function PZ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7808>>3]=+h[b+1280>>3]*+h[b+10024>>3];i=i;return}function QZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1272>>3]=0.0;i=i;return}function RZ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7800>>3]=+h[b+1272>>3]*+h[b+10016>>3];i=i;return}function SZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1264>>3]=0.0;i=i;return}function TZ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7792>>3]=+h[b+1264>>3]*+h[b+10008>>3];i=i;return}function UZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1592>>3]=+h[b+1384>>3];i=i;return}function VZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1568>>3]=+h[b+1592>>3]*1.0e3;i=i;return}



function GS(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[63880]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=57624;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&127](mb,m,27088,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]}jA(t,c[ib>>2]|0,jb);jb=+h[t>>3];kA(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);jb=+h[v>>3];jA(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);pb=+h[w>>3];kA(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+544>>3];qb=+zd(1.0e-13,+(+h[w+552>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+nwa(c[ib>>2]|0,qb,27160,57584,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(pb- +yd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{jA(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);sb=+h[z>>3];kA(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);sb=+h[B>>3];jA(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);jb=+h[C>>3];kA(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+zd(1.0e-13,+(+h[C+552>>3]- +h[E>>3]));pb=1.0- +h[C+544>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+nwa(c[ib>>2]|0,jb,27160,57584,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{jA(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);vb=+h[F>>3];kA(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);vb=+h[H>>3];jA(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);sb=+h[I>>3];kA(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);sb=+h[K>>3];jA(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);jb=+h[L>>3];kA(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+552>>3]- +h[N>>3])|0)<<24>>24==0){jA(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);jb=+h[O>>3];kA(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Q,c[ib>>2]|0,+h[P+536>>3],+h[P+1192>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(R,c[ib>>2]|0,+h[Q+536>>3],+h[Q+1192>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(S,c[ib>>2]|0,jb,pb,+h[Q+536>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+1192>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+1208>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}jA(T,c[ib>>2]|0,+h[xb+536>>3]);qb=+h[T>>3];kA(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);qb=+h[V>>3];jA(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);pb=+h[W>>3];kA(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);pb=+h[Y>>3];jA(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);jb=+h[Z>>3];kA(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA($,c[ib>>2]|0,+h[_+536>>3],+h[_+1192>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(aa,c[ib>>2]|0,+h[$+536>>3],+h[$+1192>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(ba,c[ib>>2]|0,jb,rb,+h[$+536>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+1192>>3],0.0);zb=+h[ba>>3];jA(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);rb=+h[ca>>3];kA(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+552>>3];Ab=+zd(1.0e-13,+(jb-qb));qb=Ab*+zd(1.0e-13,+(jb-pb));pb=+h[ea+1200>>3];Ab=-(pb*+zd(1.0e-13,+(jb-sb)));sb=+h[ea+544>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+nwa(c[ib>>2]|0,qb,27464,57584,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+544>>3];Cb=+h[ca+552>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+zd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+nwa(c[ib>>2]|0,Eb,27160,57584,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+1200>>3]-wb}wb=+h[tb+536>>3];if(wb>0.0){Gb=wb}else{tb=c[63880]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=57624;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&127](Db,l,27088,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]}if(Gb>0.0){Hb=Gb}else{r=c[63880]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=57624;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&127](l,j,27088,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]}jA(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];kA(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);Hb=+h[ia>>3];jA(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);Fb=+h[ja>>3];kA(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3];if(zb>0.0){Ib=zb}else{la=c[63880]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=57624;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&127](ka,g,27088,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]}if(Ib>0.0){Jb=Ib}else{p=c[63880]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=57624;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&127](g,f,27088,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]}if(Jb>0.0){Kb=Jb}else{o=c[63880]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=57624;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&127](f,e,27088,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]}qb=Kb+-273.15;lA(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];jA(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);qb=+h[na>>3];kA(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);qb=+h[pa>>3];jA(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);Eb=+h[qa>>3];kA(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+544>>3];rb=+zd(1.0e-13,+(+h[qa+552>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+nwa(c[ib>>2]|0,rb,27160,57584,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(Eb- +yd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{jA(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);Lb=+h[ta>>3];kA(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);Lb=+h[va>>3];jA(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);qb=+h[wa>>3];kA(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+zd(1.0e-13,+(+h[wa+552>>3]- +h[ya>>3]));Eb=1.0- +h[wa+544>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+nwa(c[ib>>2]|0,qb,27160,57584,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{jA(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);Ob=+h[za>>3];kA(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);Ob=+h[Ba>>3];jA(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);Lb=+h[Ca>>3];kA(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);Lb=+h[Ea>>3];jA(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);qb=+h[Fa>>3];kA(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+552>>3]- +h[Ha>>3])|0)<<24>>24==0){jA(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);qb=+h[Ia>>3];kA(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Ka,c[ib>>2]|0,+h[Ja+536>>3],+h[Ja+1192>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(La,c[ib>>2]|0,+h[Ka+536>>3],+h[Ka+1192>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+536>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+1192>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+1208>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}jA(Na,c[ib>>2]|0,+h[Qb+536>>3]);rb=+h[Na>>3];kA(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);rb=+h[Pa>>3];jA(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);Eb=+h[Qa>>3];kA(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);Eb=+h[Sa>>3];jA(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);qb=+h[Ta>>3];kA(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Va,c[ib>>2]|0,+h[Ua+536>>3],+h[Ua+1192>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(Wa,c[ib>>2]|0,+h[Va+536>>3],+h[Va+1192>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Xa,c[ib>>2]|0,qb,Bb,+h[Va+536>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+1192>>3],0.0);Cb=+h[Xa>>3];jA(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);Bb=+h[Ya>>3];kA(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+552>>3];vb=+zd(1.0e-13,+(qb-rb));rb=vb*+zd(1.0e-13,+(qb-Eb));Eb=+h[Za+1200>>3];vb=-(Eb*+zd(1.0e-13,+(qb-Lb)));Lb=+h[Za+544>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+nwa(c[ib>>2]|0,rb,27464,57584,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+544>>3];Tb=+h[Ya+552>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+zd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+nwa(c[ib>>2]|0,Vb,27160,57584,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+1200>>3]-Pb}Pb=+h[Mb+536>>3];Wb=Pb+-273.15;Cb=+h[Mb+1192>>3];sA($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];jA(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);Pb=+h[ab>>3];kA(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);Pb=+h[cb>>3];jA(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);Wb=+h[db>>3];kA(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]);lA(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+536>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+536>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+nwa(c[ib>>2]|0,rb,28072,57584,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+536>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+1200>>3]-ub);ub=+h[Yb+1192>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+nwa(c[ib>>2]|0,Xb,28072,57584,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+1192>>3];ac=+h[Yb+536>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+Nxa(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+544>>3];Gb=+zd(1.0e-13,+(+h[Yb+552>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+nwa(c[ib>>2]|0,Gb,27160,57584,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +zd(+(ac- +yd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+536>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+nwa(c[ib>>2]|0,ec,28072,57584,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+536>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+1200>>3];ic=+h[gc+1192>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+nwa(c[ib>>2]|0,fc,28072,57584,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+1192>>3];kc=+h[gc+536>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+Nxa(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+544>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+zd(1.0e-13,+(+h[gc+552>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9280|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9280|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+nwa(c[ib>>2]|0,Nb,27160,57584,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9280|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function HS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+16768>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+16744>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+16752>>3];h[a+8>>3]=+h[d+16992>>3];h[e+8>>3]=+h[d+16968>>3];h[f+8>>3]=+h[d+16976>>3];i=i;return}function IS(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0.0,l=0.0,m=0.0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+1192>>3]=+h[b>>3];h[a+1208>>3]=+h[b+8>>3];BS(f);CS(f);DS(f);ES(f);FS(f);GS(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;g=f+8696|0;b=f+536|0;a=f+6744|0;j=f+1192|0;h[d>>3]=+h[f+7888>>3]+(+h[g>>3]*+h[b>>3]+(+h[a>>3]*+h[j>>3]- +h[f+9280>>3]));k=+h[a>>3];l=+h[b>>3];m=k*l;h[d+8>>3]=+h[f+9288>>3]*m*m+(+h[f+552>>3]*(k*+h[j>>3]+l*+h[g>>3])-m*+h[f+1208>>3]);i=e;return}function JS(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+98192>>3];h[c[b+8>>2]>>3]=+h[d+98168>>3];h[c[b+12>>2]>>3]=+h[d+98176>>3];i=i;return}function KS(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+7008>>3]=g;k=a+416|0;l=c[k>>2]|0;Kz(f,c[a+536>>2]|0,g,+h[j+9576>>3],+h[j+9584>>3],+h[j+9632>>3],+h[j+9640>>3],+h[j+10016>>3],+h[j+9952>>3],+h[l+1600>>3]*10.0,(+h[l+192>>3]+ +h[l+200>>3])*.5,+h[l+1592>>3]/6.0,+h[l+1560>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+616>>3]- +h[f>>3]*+h[(c[k>>2]|0)+1536>>3];i=e;return}function LS(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[63880]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=57624;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&127](mb,m,26072,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]}jA(t,c[ib>>2]|0,jb);jb=+h[t>>3];kA(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);jb=+h[v>>3];jA(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);pb=+h[w>>3];kA(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+568>>3];qb=+zd(1.0e-13,+(+h[w+576>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+nwa(c[ib>>2]|0,qb,26144,57592,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(pb- +yd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{jA(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);sb=+h[z>>3];kA(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);sb=+h[B>>3];jA(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);jb=+h[C>>3];kA(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+zd(1.0e-13,+(+h[C+576>>3]- +h[E>>3]));pb=1.0- +h[C+568>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+nwa(c[ib>>2]|0,jb,26144,57592,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{jA(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);vb=+h[F>>3];kA(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);vb=+h[H>>3];jA(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);sb=+h[I>>3];kA(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);sb=+h[K>>3];jA(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);jb=+h[L>>3];kA(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+576>>3]- +h[N>>3])|0)<<24>>24==0){jA(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);jb=+h[O>>3];kA(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Q,c[ib>>2]|0,+h[P+560>>3],+h[P+1216>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(R,c[ib>>2]|0,+h[Q+560>>3],+h[Q+1216>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(S,c[ib>>2]|0,jb,pb,+h[Q+560>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+1216>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+1232>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}jA(T,c[ib>>2]|0,+h[xb+560>>3]);qb=+h[T>>3];kA(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);qb=+h[V>>3];jA(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);pb=+h[W>>3];kA(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);pb=+h[Y>>3];jA(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);jb=+h[Z>>3];kA(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA($,c[ib>>2]|0,+h[_+560>>3],+h[_+1216>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(aa,c[ib>>2]|0,+h[$+560>>3],+h[$+1216>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(ba,c[ib>>2]|0,jb,rb,+h[$+560>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+1216>>3],0.0);zb=+h[ba>>3];jA(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);rb=+h[ca>>3];kA(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+576>>3];Ab=+zd(1.0e-13,+(jb-qb));qb=Ab*+zd(1.0e-13,+(jb-pb));pb=+h[ea+1224>>3];Ab=-(pb*+zd(1.0e-13,+(jb-sb)));sb=+h[ea+568>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+nwa(c[ib>>2]|0,qb,26448,57592,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+568>>3];Cb=+h[ca+576>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+zd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+nwa(c[ib>>2]|0,Eb,26144,57592,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+1224>>3]-wb}wb=+h[tb+560>>3];if(wb>0.0){Gb=wb}else{tb=c[63880]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=57624;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&127](Db,l,26072,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]}if(Gb>0.0){Hb=Gb}else{r=c[63880]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=57624;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&127](l,j,26072,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]}jA(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];kA(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);Hb=+h[ia>>3];jA(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);Fb=+h[ja>>3];kA(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3];if(zb>0.0){Ib=zb}else{la=c[63880]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=57624;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&127](ka,g,26072,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]}if(Ib>0.0){Jb=Ib}else{p=c[63880]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=57624;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&127](g,f,26072,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]}if(Jb>0.0){Kb=Jb}else{o=c[63880]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=57624;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&127](f,e,26072,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]}qb=Kb+-273.15;lA(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];jA(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);qb=+h[na>>3];kA(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);qb=+h[pa>>3];jA(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);Eb=+h[qa>>3];kA(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+568>>3];rb=+zd(1.0e-13,+(+h[qa+576>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+nwa(c[ib>>2]|0,rb,26144,57592,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(Eb- +yd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{jA(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);Lb=+h[ta>>3];kA(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);Lb=+h[va>>3];jA(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);qb=+h[wa>>3];kA(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+zd(1.0e-13,+(+h[wa+576>>3]- +h[ya>>3]));Eb=1.0- +h[wa+568>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+nwa(c[ib>>2]|0,qb,26144,57592,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{jA(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);Ob=+h[za>>3];kA(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);Ob=+h[Ba>>3];jA(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);Lb=+h[Ca>>3];kA(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);Lb=+h[Ea>>3];jA(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);qb=+h[Fa>>3];kA(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+576>>3]- +h[Ha>>3])|0)<<24>>24==0){jA(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);qb=+h[Ia>>3];kA(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Ka,c[ib>>2]|0,+h[Ja+560>>3],+h[Ja+1216>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(La,c[ib>>2]|0,+h[Ka+560>>3],+h[Ka+1216>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+560>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+1216>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+1232>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}jA(Na,c[ib>>2]|0,+h[Qb+560>>3]);rb=+h[Na>>3];kA(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);rb=+h[Pa>>3];jA(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);Eb=+h[Qa>>3];kA(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);Eb=+h[Sa>>3];jA(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);qb=+h[Ta>>3];kA(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Va,c[ib>>2]|0,+h[Ua+560>>3],+h[Ua+1216>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(Wa,c[ib>>2]|0,+h[Va+560>>3],+h[Va+1216>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Xa,c[ib>>2]|0,qb,Bb,+h[Va+560>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+1216>>3],0.0);Cb=+h[Xa>>3];jA(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);Bb=+h[Ya>>3];kA(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+576>>3];vb=+zd(1.0e-13,+(qb-rb));rb=vb*+zd(1.0e-13,+(qb-Eb));Eb=+h[Za+1224>>3];vb=-(Eb*+zd(1.0e-13,+(qb-Lb)));Lb=+h[Za+568>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+nwa(c[ib>>2]|0,rb,26448,57592,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+568>>3];Tb=+h[Ya+576>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+zd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+nwa(c[ib>>2]|0,Vb,26144,57592,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+1224>>3]-Pb}Pb=+h[Mb+560>>3];Wb=Pb+-273.15;Cb=+h[Mb+1216>>3];sA($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];jA(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);Pb=+h[ab>>3];kA(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);Pb=+h[cb>>3];jA(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);Wb=+h[db>>3];kA(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]);lA(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+560>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+560>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+nwa(c[ib>>2]|0,rb,27056,57592,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+560>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+1224>>3]-ub);ub=+h[Yb+1216>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+nwa(c[ib>>2]|0,Xb,27056,57592,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+1216>>3];ac=+h[Yb+560>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+Nxa(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+568>>3];Gb=+zd(1.0e-13,+(+h[Yb+576>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+nwa(c[ib>>2]|0,Gb,26144,57592,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +zd(+(ac- +yd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+560>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+nwa(c[ib>>2]|0,ec,27056,57592,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+560>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+1224>>3];ic=+h[gc+1216>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+nwa(c[ib>>2]|0,fc,27056,57592,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+1216>>3];kc=+h[gc+560>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+Nxa(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+568>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+zd(1.0e-13,+(+h[gc+576>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9264|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9264|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+nwa(c[ib>>2]|0,Nb,26144,57592,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9264|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function MS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;iA(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+560>>3]);if((Aza(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+576>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+1232>>3]*.999;l=j;m=l+8688|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;xA(e,c[f>>2]|0,+h[d+560>>3],+h[d+1216>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+8688|0;n=m;h[n>>3]=k;i=b;return}}function NS(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6792>>3];k=+zd(1.0e-13,+(+h[g+576>>3]-j));l=+h[g+7776>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+nwa(c[b+536>>2]|0,k,28848,57600,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+7880|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=Cza(1.0e-13,+h[f+576>>3]- +h[f+6792>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+6792>>3];j=+h[x+576>>3];k=+zd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+8616>>3];k=+h[x+7776>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+1232>>3]- +h[x+8688>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+1232>>3]- +h[x+8688>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+1232>>3]- +h[x+8688>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+1232>>3]- +h[x+8688>>3]}K=(y-k*J)/+nwa(c[b+536>>2]|0,l,29008,57600,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+7776>>3];C=+h[L+6792>>3];D=+h[L+576>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+8688>>3];m=+zd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+nwa(c[b+536>>2]|0,m,28848,57600,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+7880|0;w=v;h[w>>3]=n;i=d;return}function OS(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(Cza(+h[a+568>>3]- +h[a+6808>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+8680|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+1224>>3]- +h[a+7880>>3];g=a;j=g+8680|0;k=j;h[k>>3]=f;i=b;return}function PS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7872>>3]=+h[b+1224>>3]- +h[b+8680>>3];i=i;return}function QS(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6824>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+8680>>3];o=+h[g+8616>>3]*k+ +h[g+7776>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+nwa(c[b+536>>2]|0,l,29144,57608,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+8680>>3];q=+h[v+6824>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+7872>>3]*(1.0-q)+ +h[r+6816>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+8672|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+8672|0;C=B;h[C>>3]=z;i=d;return}p=t/+nwa(c[b+536>>2]|0,l,29144,57608,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+8672|0;C=B;h[C>>3]=z;i=d;return}function RS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+17104>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+17080>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+17088>>3];h[a+8>>3]=+h[d+17328>>3];h[e+8>>3]=+h[d+17304>>3];h[f+8>>3]=+h[d+17312>>3];i=i;return}function SS(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0.0,l=0.0,m=0.0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+1216>>3]=+h[b>>3];h[a+1232>>3]=+h[b+8>>3];LS(f);MS(f);NS(f);OS(f);PS(f);QS(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;g=f+8672|0;b=f+560|0;a=f+6856|0;j=f+1216|0;h[d>>3]=+h[f+7864>>3]+(+h[g>>3]*+h[b>>3]+(+h[a>>3]*+h[j>>3]- +h[f+9264>>3]));k=+h[a>>3];l=+h[b>>3];m=k*l;h[d+8>>3]=+h[f+9272>>3]*m*m+(+h[f+576>>3]*(k*+h[j>>3]+l*+h[g>>3])-m*+h[f+1232>>3]);i=e;return}function TS(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+98080>>3];h[c[b+8>>2]>>3]=+h[d+98056>>3];h[c[b+12>>2]>>3]=+h[d+98064>>3];i=i;return}function US(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0,k=0,l=0,m=0.0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+7e3>>3]=g;k=a+416|0;l=c[k>>2]|0;m=+h[l+192>>3];Kz(f,c[a+536>>2]|0,g,+h[j+9568>>3],+h[j+9576>>3],+h[j+9624>>3],+h[j+9632>>3],+h[j+10008>>3],+h[l+152>>3],+h[l+1600>>3]*5.0,(m+m)*.5,+h[l+1592>>3]/6.0,+h[l+1560>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+608>>3]- +h[f>>3]*+h[(c[k>>2]|0)+1536>>3];i=e;return}function VS(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[63880]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=57624;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&127](mb,m,25056,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]}jA(t,c[ib>>2]|0,jb);jb=+h[t>>3];kA(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);jb=+h[v>>3];jA(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);pb=+h[w>>3];kA(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+592>>3];qb=+zd(1.0e-13,+(+h[w+600>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+nwa(c[ib>>2]|0,qb,25128,57616,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(pb- +yd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{jA(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);sb=+h[z>>3];kA(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);sb=+h[B>>3];jA(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);jb=+h[C>>3];kA(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+zd(1.0e-13,+(+h[C+600>>3]- +h[E>>3]));pb=1.0- +h[C+592>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+nwa(c[ib>>2]|0,jb,25128,57616,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{jA(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);vb=+h[F>>3];kA(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);vb=+h[H>>3];jA(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);sb=+h[I>>3];kA(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);sb=+h[K>>3];jA(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);jb=+h[L>>3];kA(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+600>>3]- +h[N>>3])|0)<<24>>24==0){jA(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);jb=+h[O>>3];kA(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Q,c[ib>>2]|0,+h[P+584>>3],+h[P+1240>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(R,c[ib>>2]|0,+h[Q+584>>3],+h[Q+1240>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(S,c[ib>>2]|0,jb,pb,+h[Q+584>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+1240>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+1256>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}jA(T,c[ib>>2]|0,+h[xb+584>>3]);qb=+h[T>>3];kA(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);qb=+h[V>>3];jA(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);pb=+h[W>>3];kA(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);pb=+h[Y>>3];jA(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);jb=+h[Z>>3];kA(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA($,c[ib>>2]|0,+h[_+584>>3],+h[_+1240>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(aa,c[ib>>2]|0,+h[$+584>>3],+h[$+1240>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(ba,c[ib>>2]|0,jb,rb,+h[$+584>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+1240>>3],0.0);zb=+h[ba>>3];jA(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);rb=+h[ca>>3];kA(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+600>>3];Ab=+zd(1.0e-13,+(jb-qb));qb=Ab*+zd(1.0e-13,+(jb-pb));pb=+h[ea+1248>>3];Ab=-(pb*+zd(1.0e-13,+(jb-sb)));sb=+h[ea+592>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+nwa(c[ib>>2]|0,qb,25432,57616,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+592>>3];Cb=+h[ca+600>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+zd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+nwa(c[ib>>2]|0,Eb,25128,57616,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+1248>>3]-wb}wb=+h[tb+584>>3];if(wb>0.0){Gb=wb}else{tb=c[63880]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=57624;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&127](Db,l,25056,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]}if(Gb>0.0){Hb=Gb}else{r=c[63880]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=57624;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&127](l,j,25056,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]}jA(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];kA(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);Hb=+h[ia>>3];jA(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);Fb=+h[ja>>3];kA(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3];if(zb>0.0){Ib=zb}else{la=c[63880]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=57624;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&127](ka,g,25056,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]}if(Ib>0.0){Jb=Ib}else{p=c[63880]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=57624;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&127](g,f,25056,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]}if(Jb>0.0){Kb=Jb}else{o=c[63880]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=57624;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&127](f,e,25056,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]}qb=Kb+-273.15;lA(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];jA(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);qb=+h[na>>3];kA(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);qb=+h[pa>>3];jA(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);Eb=+h[qa>>3];kA(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+592>>3];rb=+zd(1.0e-13,+(+h[qa+600>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+nwa(c[ib>>2]|0,rb,25128,57616,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Cza(Eb- +yd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{jA(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);Lb=+h[ta>>3];kA(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);Lb=+h[va>>3];jA(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);qb=+h[wa>>3];kA(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+zd(1.0e-13,+(+h[wa+600>>3]- +h[ya>>3]));Eb=1.0- +h[wa+592>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+nwa(c[ib>>2]|0,qb,25128,57616,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{jA(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);Ob=+h[za>>3];kA(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);Ob=+h[Ba>>3];jA(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);Lb=+h[Ca>>3];kA(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);Lb=+h[Ea>>3];jA(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);qb=+h[Fa>>3];kA(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);if((Cza(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+600>>3]- +h[Ha>>3])|0)<<24>>24==0){jA(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);qb=+h[Ia>>3];kA(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Ka,c[ib>>2]|0,+h[Ja+584>>3],+h[Ja+1240>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(La,c[ib>>2]|0,+h[Ka+584>>3],+h[Ka+1240>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+584>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+1240>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+1256>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}jA(Na,c[ib>>2]|0,+h[Qb+584>>3]);rb=+h[Na>>3];kA(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);rb=+h[Pa>>3];jA(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);Eb=+h[Qa>>3];kA(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);Eb=+h[Sa>>3];jA(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);qb=+h[Ta>>3];kA(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;wA(Va,c[ib>>2]|0,+h[Ua+584>>3],+h[Ua+1240>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yA(Wa,c[ib>>2]|0,+h[Va+584>>3],+h[Va+1240>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sA(Xa,c[ib>>2]|0,qb,Bb,+h[Va+584>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+1240>>3],0.0);Cb=+h[Xa>>3];jA(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);Bb=+h[Ya>>3];kA(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+600>>3];vb=+zd(1.0e-13,+(qb-rb));rb=vb*+zd(1.0e-13,+(qb-Eb));Eb=+h[Za+1248>>3];vb=-(Eb*+zd(1.0e-13,+(qb-Lb)));Lb=+h[Za+592>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+nwa(c[ib>>2]|0,rb,25432,57616,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+592>>3];Tb=+h[Ya+600>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+zd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+nwa(c[ib>>2]|0,Vb,25128,57616,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+1248>>3]-Pb}Pb=+h[Mb+584>>3];Wb=Pb+-273.15;Cb=+h[Mb+1240>>3];sA($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];jA(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);Pb=+h[ab>>3];kA(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);Pb=+h[cb>>3];jA(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);Wb=+h[db>>3];kA(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]);lA(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+584>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+584>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+nwa(c[ib>>2]|0,rb,26040,57616,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+584>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+1248>>3]-ub);ub=+h[Yb+1240>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+nwa(c[ib>>2]|0,Xb,26040,57616,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+1240>>3];ac=+h[Yb+584>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+Nxa(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+592>>3];Gb=+zd(1.0e-13,+(+h[Yb+600>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+nwa(c[ib>>2]|0,Gb,25128,57616,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +zd(+(ac- +yd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+584>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+nwa(c[ib>>2]|0,ec,26040,57616,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+584>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+1248>>3];ic=+h[gc+1240>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+nwa(c[ib>>2]|0,fc,26040,57616,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+1240>>3];kc=+h[gc+584>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+Nxa(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+592>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+zd(1.0e-13,+(+h[gc+600>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9248|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9248|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+nwa(c[ib>>2]|0,Nb,25128,57616,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+yd(+pc,1.0);rc=kc-qc;sc=+zd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+9248|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function WS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;iA(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+584>>3]);if((Aza(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+600>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+1256>>3]*.999;l=j;m=l+8664|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;xA(e,c[f>>2]|0,+h[d+584>>3],+h[d+1240>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+8664|0;n=m;h[n>>3]=k;i=b;return}}function XS(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6904>>3];k=+zd(1.0e-13,+(+h[g+600>>3]-j));l=+h[g+7784>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+nwa(c[b+536>>2]|0,k,28448,57648,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((Aza(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+7856|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=Cza(1.0e-13,+h[f+600>>3]- +h[f+6904>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+6904>>3];j=+h[x+600>>3];k=+zd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+8608>>3];k=+h[x+7784>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+1256>>3]- +h[x+8664>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+1256>>3]- +h[x+8664>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+1256>>3]- +h[x+8664>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+1256>>3]- +h[x+8664>>3]}K=(y-k*J)/+nwa(c[b+536>>2]|0,l,28608,57648,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+7784>>3];C=+h[L+6904>>3];D=+h[L+600>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+8664>>3];m=+zd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+nwa(c[b+536>>2]|0,m,28448,57648,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+7856|0;w=v;h[w>>3]=n;i=d;return}function YS(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(Cza(+h[a+592>>3]- +h[a+6920>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+8656|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+1248>>3]- +h[a+7856>>3];g=a;j=g+8656|0;k=j;h[k>>3]=f;i=b;return}function ZS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7848>>3]=+h[b+1248>>3]- +h[b+8656>>3];i=i;return}function _S(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6936>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+8656>>3];o=+h[g+8608>>3]*k+ +h[g+7784>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+nwa(c[b+536>>2]|0,l,28744,57656,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+8656>>3];q=+h[v+6936>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+7848>>3]*(1.0-q)+ +h[r+6928>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+8648|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+8648|0;C=B;h[C>>3]=z;i=d;return}p=t/+nwa(c[b+536>>2]|0,l,28744,57656,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+8648|0;C=B;h[C>>3]=z;i=d;return}function $S(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+17664>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+17640>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+17648>>3];h[a+8>>3]=+h[d+17440>>3];h[e+8>>3]=+h[d+17416>>3];h[f+8>>3]=+h[d+17424>>3];i=i;return}function aT(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0.0,l=0.0,m=0.0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+1256>>3]=+h[b>>3];h[a+1240>>3]=+h[b+8>>3];VS(f);WS(f);XS(f);YS(f);ZS(f);_S(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;g=f+8648|0;b=f+584|0;a=f+6968|0;j=f+1240|0;h[d>>3]=+h[f+7840>>3]+(+h[g>>3]*+h[b>>3]+(+h[a>>3]*+h[j>>3]- +h[f+9248>>3]));k=+h[a>>3];l=+h[b>>3];m=k*l;h[d+8>>3]=+h[f+9256>>3]*m*m+(+h[f+600>>3]*(k*+h[j>>3]+l*+h[g>>3])-m*+h[f+1256>>3]);i=e;return}function bT(a){a=a|0;c[a+4>>2]=1187;c[a>>2]=67;c[a+56>>2]=0;c[a+32>>2]=19;c[a+20>>2]=0;c[a+24>>2]=0;c[a+28>>2]=-1;c[a+36>>2]=43;c[a+84>>2]=1789;c[a+80>>2]=1;c[a+136>>2]=0;c[a+112>>2]=20;c[a+100>>2]=0;c[a+104>>2]=0;c[a+108>>2]=-1;c[a+116>>2]=44;c[a+164>>2]=1821;c[a+160>>2]=1;c[a+216>>2]=0;c[a+192>>2]=21;c[a+180>>2]=0;c[a+184>>2]=0;c[a+188>>2]=-1;c[a+196>>2]=45;c[a+244>>2]=1834;c[a+240>>2]=2;c[a+296>>2]=0;c[a+272>>2]=22;c[a+260>>2]=0;c[a+264>>2]=0;c[a+268>>2]=-1;c[a+276>>2]=46;c[a+324>>2]=1865;c[a+320>>2]=1;c[a+376>>2]=0;c[a+352>>2]=23;c[a+340>>2]=0;c[a+344>>2]=0;c[a+348>>2]=-1;c[a+356>>2]=47;c[a+404>>2]=1878;c[a+400>>2]=2;c[a+456>>2]=0;c[a+432>>2]=24;c[a+420>>2]=0;c[a+424>>2]=0;c[a+428>>2]=-1;c[a+436>>2]=48;c[a+484>>2]=1909;c[a+480>>2]=1;c[a+536>>2]=0;c[a+512>>2]=25;c[a+500>>2]=0;c[a+504>>2]=0;c[a+508>>2]=-1;c[a+516>>2]=49;c[a+564>>2]=1922;c[a+560>>2]=2;c[a+616>>2]=0;c[a+592>>2]=26;c[a+580>>2]=0;c[a+584>>2]=0;c[a+588>>2]=-1;c[a+596>>2]=50;c[a+644>>2]=1953;c[a+640>>2]=1;c[a+696>>2]=0;c[a+672>>2]=27;c[a+660>>2]=0;c[a+664>>2]=0;c[a+668>>2]=-1;c[a+676>>2]=51;c[a+724>>2]=1966;c[a+720>>2]=2;c[a+776>>2]=0;c[a+752>>2]=28;c[a+740>>2]=0;c[a+744>>2]=0;c[a+748>>2]=-1;c[a+756>>2]=52;c[a+804>>2]=2024;c[a+800>>2]=1;c[a+856>>2]=0;c[a+832>>2]=29;c[a+820>>2]=0;c[a+824>>2]=0;c[a+828>>2]=-1;c[a+836>>2]=53;c[a+884>>2]=2056;c[a+880>>2]=1;c[a+936>>2]=0;c[a+912>>2]=30;c[a+900>>2]=0;c[a+904>>2]=0;c[a+908>>2]=-1;c[a+916>>2]=54;c[a+964>>2]=2069;c[a+960>>2]=2;c[a+1016>>2]=0;c[a+992>>2]=31;c[a+980>>2]=0;c[a+984>>2]=0;c[a+988>>2]=-1;c[a+996>>2]=55;c[a+1044>>2]=2100;c[a+1040>>2]=1;c[a+1096>>2]=0;c[a+1072>>2]=32;c[a+1060>>2]=0;c[a+1064>>2]=0;c[a+1068>>2]=-1;c[a+1076>>2]=56;c[a+1124>>2]=2113;c[a+1120>>2]=2;c[a+1176>>2]=0;c[a+1152>>2]=33;c[a+1140>>2]=0;c[a+1144>>2]=0;c[a+1148>>2]=-1;c[a+1156>>2]=57;c[a+1204>>2]=2144;c[a+1200>>2]=1;c[a+1256>>2]=0;c[a+1232>>2]=34;c[a+1220>>2]=0;c[a+1224>>2]=0;c[a+1228>>2]=-1;c[a+1236>>2]=58;c[a+1284>>2]=2157;c[a+1280>>2]=2;c[a+1336>>2]=0;c[a+1312>>2]=35;c[a+1300>>2]=0;c[a+1304>>2]=0;c[a+1308>>2]=-1;c[a+1316>>2]=59;c[a+1364>>2]=2191;c[a+1360>>2]=1;c[a+1416>>2]=0;c[a+1392>>2]=36;c[a+1380>>2]=0;c[a+1384>>2]=0;c[a+1388>>2]=-1;c[a+1396>>2]=60;c[a+1444>>2]=2210;c[a+1440>>2]=2;c[a+1496>>2]=0;c[a+1472>>2]=37;c[a+1460>>2]=0;c[a+1464>>2]=0;c[a+1468>>2]=-1;c[a+1476>>2]=61;c[a+1524>>2]=2218;c[a+1520>>2]=1;c[a+1576>>2]=0;c[a+1552>>2]=38;c[a+1540>>2]=0;c[a+1544>>2]=0;c[a+1548>>2]=-1;c[a+1556>>2]=62;c[a+1604>>2]=2237;c[a+1600>>2]=2;c[a+1656>>2]=0;c[a+1632>>2]=39;c[a+1620>>2]=0;c[a+1624>>2]=0;c[a+1628>>2]=-1;c[a+1636>>2]=63;c[a+1684>>2]=2268;c[a+1680>>2]=1;c[a+1736>>2]=0;c[a+1712>>2]=40;c[a+1700>>2]=0;c[a+1704>>2]=0;c[a+1708>>2]=-1;c[a+1716>>2]=64;c[a+1764>>2]=2287;c[a+1760>>2]=1;c[a+1816>>2]=0;c[a+1792>>2]=41;c[a+1780>>2]=0;c[a+1784>>2]=0;c[a+1788>>2]=-1;c[a+1796>>2]=65;c[a+1844>>2]=2300;c[a+1840>>2]=2;c[a+1896>>2]=0;c[a+1872>>2]=42;c[a+1860>>2]=0;c[a+1864>>2]=0;c[a+1868>>2]=-1;c[a+1876>>2]=66;c[a+1924>>2]=2322;c[a+1920>>2]=1;c[a+1976>>2]=0;c[a+1952>>2]=43;c[a+1940>>2]=0;c[a+1944>>2]=0;c[a+1948>>2]=-1;c[a+1956>>2]=67;c[a+2004>>2]=2344;c[a+2e3>>2]=1;c[a+2056>>2]=0;c[a+2032>>2]=44;c[a+2020>>2]=0;c[a+2024>>2]=0;c[a+2028>>2]=-1;c[a+2036>>2]=68;c[a+2084>>2]=2357;c[a+2080>>2]=2;c[a+2136>>2]=0;c[a+2112>>2]=45;c[a+2100>>2]=0;c[a+2104>>2]=0;c[a+2108>>2]=-1;c[a+2116>>2]=69;c[a+2164>>2]=2379;c[a+2160>>2]=1;c[a+2216>>2]=0;c[a+2192>>2]=46;c[a+2180>>2]=0;c[a+2184>>2]=0;c[a+2188>>2]=-1;c[a+2196>>2]=70;c[a+2244>>2]=2401;c[a+2240>>2]=1;c[a+2296>>2]=0;c[a+2272>>2]=47;c[a+2260>>2]=0;c[a+2264>>2]=0;c[a+2268>>2]=-1;c[a+2276>>2]=71;c[a+2324>>2]=2414;c[a+2320>>2]=2;c[a+2376>>2]=0;c[a+2352>>2]=48;c[a+2340>>2]=0;c[a+2344>>2]=0;c[a+2348>>2]=-1;c[a+2356>>2]=72;c[a+2404>>2]=2436;c[a+2400>>2]=1;c[a+2456>>2]=0;c[a+2432>>2]=49;c[a+2420>>2]=0;c[a+2424>>2]=0;c[a+2428>>2]=-1;c[a+2436>>2]=73;c[a+2484>>2]=2462;c[a+2480>>2]=1;c[a+2536>>2]=0;c[a+2512>>2]=50;c[a+2500>>2]=0;c[a+2504>>2]=0;c[a+2508>>2]=-1;c[a+2516>>2]=74;c[a+2564>>2]=2475;c[a+2560>>2]=2;c[a+2616>>2]=0;c[a+2592>>2]=51;c[a+2580>>2]=0;c[a+2584>>2]=0;c[a+2588>>2]=-1;c[a+2596>>2]=75;c[a+2644>>2]=2497;c[a+2640>>2]=1;c[a+2696>>2]=0;c[a+2672>>2]=52;c[a+2660>>2]=0;c[a+2664>>2]=0;c[a+2668>>2]=-1;c[a+2676>>2]=76;c[a+2724>>2]=2517;c[a+2720>>2]=1;c[a+2776>>2]=0;c[a+2752>>2]=53;c[a+2740>>2]=0;c[a+2744>>2]=0;c[a+2748>>2]=-1;c[a+2756>>2]=77;c[a+2804>>2]=2536;c[a+2800>>2]=2;c[a+2856>>2]=0;c[a+2832>>2]=54;c[a+2820>>2]=0;c[a+2824>>2]=0;c[a+2828>>2]=-1;c[a+2836>>2]=78;c[a+2884>>2]=2550;c[a+2880>>2]=2;c[a+2936>>2]=0;c[a+2912>>2]=55;c[a+2900>>2]=0;c[a+2904>>2]=0;c[a+2908>>2]=-1;c[a+2916>>2]=79;c[a+2964>>2]=2560;c[a+2960>>2]=1;c[a+3016>>2]=0;c[a+2992>>2]=56;c[a+2980>>2]=0;c[a+2984>>2]=0;c[a+2988>>2]=-1;c[a+2996>>2]=80;c[a+3044>>2]=2592;c[a+3040>>2]=1;c[a+3096>>2]=0;c[a+3072>>2]=57;c[a+3060>>2]=0;c[a+3064>>2]=0;c[a+3068>>2]=-1;c[a+3076>>2]=81;c[a+3124>>2]=2605;c[a+3120>>2]=2;c[a+3176>>2]=0;c[a+3152>>2]=58;c[a+3140>>2]=0;c[a+3144>>2]=0;c[a+3148>>2]=-1;c[a+3156>>2]=82;c[a+3204>>2]=2636;c[a+3200>>2]=1;c[a+3256>>2]=0;c[a+3232>>2]=59;c[a+3220>>2]=0;c[a+3224>>2]=0;c[a+3228>>2]=-1;c[a+3236>>2]=83;c[a+3284>>2]=2649;c[a+3280>>2]=2;c[a+3336>>2]=0;c[a+3312>>2]=60;c[a+3300>>2]=0;c[a+3304>>2]=0;c[a+3308>>2]=-1;c[a+3316>>2]=84;c[a+3364>>2]=2680;c[a+3360>>2]=1;c[a+3416>>2]=0;c[a+3392>>2]=61;c[a+3380>>2]=0;c[a+3384>>2]=0;c[a+3388>>2]=-1;c[a+3396>>2]=85;c[a+3444>>2]=2693;c[a+3440>>2]=2;c[a+3496>>2]=0;c[a+3472>>2]=62;c[a+3460>>2]=0;c[a+3464>>2]=0;c[a+3468>>2]=-1;c[a+3476>>2]=86;c[a+3524>>2]=2728;c[a+3520>>2]=1;c[a+3576>>2]=0;c[a+3552>>2]=63;c[a+3540>>2]=0;c[a+3544>>2]=0;c[a+3548>>2]=-1;c[a+3556>>2]=87;c[a+3604>>2]=2741;c[a+3600>>2]=2;c[a+3656>>2]=0;c[a+3632>>2]=64;c[a+3620>>2]=0;c[a+3624>>2]=0;c[a+3628>>2]=-1;c[a+3636>>2]=88;c[a+3684>>2]=2744;c[a+3680>>2]=1;c[a+3736>>2]=0;c[a+3712>>2]=65;c[a+3700>>2]=0;c[a+3704>>2]=0;c[a+3708>>2]=-1;c[a+3716>>2]=89;c[a+3764>>2]=2779;c[a+3760>>2]=2;c[a+3816>>2]=0;c[a+3792>>2]=66;c[a+3780>>2]=0;c[a+3784>>2]=0;c[a+3788>>2]=-1;c[a+3796>>2]=90;i=i;return}function cT(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;g=a+416|0;ye[c[e>>2]&3](0,0,-(+h[f+4544>>3]*+h[f+10192>>3]*+h[(c[g>>2]|0)+1864>>3]),0,b);ye[c[e>>2]&3](0,1,1.0,1,b);ye[c[e>>2]&3](1,0,+h[(c[g>>2]|0)+1328>>3]*40.0,2,b);ye[c[e>>2]&3](1,1,-1.0,3,b);i=d;return}function dT(a,b){a=a|0;b=b|0;var d=0,e=0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;e=c[a+416>>2]|0;a=c[b+36>>2]|0;h[a>>3]=-(+h[d+4544>>3]*+h[d+10192>>3]*+h[d+4504>>3]*+h[e+1864>>3]);h[a+8>>3]=(1.0- +h[e+1328>>3]*+h[e+1320>>3])*-40.0;i=i;return}function eT(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;g=a+416|0;ye[c[e>>2]&3](0,0,-(+h[f+4536>>3]*+h[f+10184>>3]*+h[(c[g>>2]|0)+1864>>3]),0,b);ye[c[e>>2]&3](0,1,1.0,1,b);ye[c[e>>2]&3](1,0,+h[(c[g>>2]|0)+1304>>3]*40.0,2,b);ye[c[e>>2]&3](1,1,-1.0,3,b);i=d;return}function fT(a,b){a=a|0;b=b|0;var d=0,e=0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;e=c[a+416>>2]|0;a=c[b+36>>2]|0;h[a>>3]=-(+h[d+4536>>3]*+h[d+10184>>3]*+h[d+4496>>3]*+h[e+1864>>3]);h[a+8>>3]=(1.0- +h[e+1304>>3]*+h[e+1296>>3])*-40.0;i=i;return}function gT(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;ye[c[e>>2]&3](0,0,1.0,0,b);f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;g=a+416|0;ye[c[e>>2]&3](0,1,-(+h[f+4528>>3]*+h[f+10176>>3]*+h[(c[g>>2]|0)+1864>>3]),1,b);ye[c[e>>2]&3](1,0,-1.0,2,b);ye[c[e>>2]&3](1,1,+h[(c[g>>2]|0)+1280>>3]*40.0,3,b);i=d;return}function hT(a,b){a=a|0;b=b|0;var d=0,e=0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;e=c[a+416>>2]|0;a=c[b+36>>2]|0;h[a>>3]=-(+h[d+4528>>3]*+h[d+10176>>3]*+h[d+4488>>3]*+h[e+1864>>3]);h[a+8>>3]=(1.0- +h[e+1280>>3]*+h[e+1272>>3])*-40.0;i=i;return}function iT(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;ye[c[e>>2]&3](0,0,1.0,0,b);f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;g=a+416|0;ye[c[e>>2]&3](0,1,-(+h[f+4520>>3]*+h[f+10168>>3]*+h[(c[g>>2]|0)+1864>>3]),1,b);ye[c[e>>2]&3](1,0,-1.0,2,b);ye[c[e>>2]&3](1,1,+h[(c[g>>2]|0)+1256>>3]*40.0,3,b);i=d;return}function jT(a,b){a=a|0;b=b|0;var d=0,e=0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;e=c[a+416>>2]|0;a=c[b+36>>2]|0;h[a>>3]=-(+h[d+4520>>3]*+h[d+10168>>3]*+h[d+4480>>3]*+h[e+1864>>3]);h[a+8>>3]=(1.0- +h[e+1256>>3]*+h[e+1248>>3])*-40.0;i=i;return}function kT(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;ye[c[e>>2]&3](0,0,1.0,0,b);f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;g=a+416|0;ye[c[e>>2]&3](0,1,-(+h[f+4512>>3]*+h[f+10160>>3]*+h[(c[g>>2]|0)+1864>>3]),1,b);ye[c[e>>2]&3](1,0,-1.0,2,b);ye[c[e>>2]&3](1,1,+h[(c[g>>2]|0)+1232>>3]*40.0,3,b);i=d;return}function lT(a,b){a=a|0;b=b|0;var d=0,e=0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;e=c[a+416>>2]|0;a=c[b+36>>2]|0;h[a>>3]=-(+h[d+4512>>3]*+h[d+10160>>3]*+h[d+4472>>3]*+h[e+1864>>3]);h[a+8>>3]=(1.0- +h[e+1232>>3]*+h[e+1224>>3])*-40.0;i=i;return}function mT(a){a=a|0;c[a+20>>2]=2269;c[a+16>>2]=2;c[a+12>>2]=4;c[a>>2]=91;c[a+4>>2]=92;c[a+84>>2]=2323;c[a+80>>2]=2;c[a+76>>2]=4;c[a+64>>2]=93;c[a+68>>2]=94;c[a+148>>2]=2380;c[a+144>>2]=2;c[a+140>>2]=4;c[a+128>>2]=95;c[a+132>>2]=96;c[a+212>>2]=2437;c[a+208>>2]=2;c[a+204>>2]=4;c[a+192>>2]=97;c[a+196>>2]=98;c[a+276>>2]=2498;c[a+272>>2]=2;c[a+268>>2]=4;c[a+256>>2]=99;c[a+260>>2]=100;i=i;return}function nT(a,b){a=a|0;b=b|0;i=i;return}function oT(a){a=a|0;i=i;return}function pT(a,b){a=a|0;b=b|0;c[b>>2]=c[57744+(a<<2)>>2];i=i;return c[57752+(a<<2)>>2]|0}function qT(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0;e=i;f=b+4|0;g=b+416|0;j=b+360|0;b=(zza(+h[c[c[f>>2]>>2]>>3],+h[(c[g>>2]|0)+2376>>3],a[c[j>>2]|0]|0)|0)<<24>>24!=0;h[d>>3]=b?1.0:-1.0;b=c[g>>2]|0;g=(zza(+h[c[c[f>>2]>>2]>>3],+h[b+2376>>3]+ +h[b+2360>>3],a[(c[j>>2]|0)+1|0]|0)|0)<<24>>24!=0;h[d+8>>3]=g?1.0:-1.0;i=e;return 0}function rT(a){a=a|0;i=i;return c[57752+(a<<2)>>2]|0}function sT(b,d){b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0,k=0.0,l=0,m=0;e=i;f=b+4|0;g=+h[c[c[f>>2]>>2]>>3];j=b+416|0;k=+h[(c[j>>2]|0)+2376>>3];if((d|0)==0){d=b+352|0;a[c[d>>2]|0]=g<k|0;l=c[j>>2]|0;a[(c[d>>2]|0)+1|0]=+h[c[c[f>>2]>>2]>>3]<+h[l+2376>>3]+ +h[l+2360>>3]|0;i=e;return 0}else{l=b+360|0;d=zza(g,k,a[c[l>>2]|0]|0)|0;m=b+352|0;a[c[m>>2]|0]=d;d=c[j>>2]|0;j=zza(+h[c[c[f>>2]>>2]>>3],+h[d+2376>>3]+ +h[d+2360>>3],a[(c[l>>2]|0)+1|0]|0)|0;a[(c[m>>2]|0)+1|0]=j;i=e;return 0}return 0}function tT(a){a=a|0;a=i;i=i+8|0;hwa(8,1,57760,a);if((c[206176>>2]|0)==0){i=a;return 0}le[c[51674]&2047](8);i=a;return 0}function uT(a){a=a|0;i=i;return c[60544+(a<<2)>>2]|0}



function Z_a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;e=a+4|0;f=c[e>>2]|0;g=f&-8;h=a;j=a+g|0;k=j;l=c[296384>>2]|0;if(h>>>0<l>>>0){md()}m=f&3;if(!((m|0)!=1&h>>>0<j>>>0)){md()}h=a+(g|4)|0;n=c[h>>2]|0;if((n&1|0)==0){md()}if((m|0)==0){if(b>>>0<256){o=0;i=d;return o|0}do{if(!(g>>>0<(b+4|0)>>>0)){if((g-b|0)>>>0>c[296848>>2]<<1>>>0){break}else{o=a}i=d;return o|0}}while(0);o=0;i=d;return o|0}if(!(g>>>0<b>>>0)){m=g-b|0;if(!(m>>>0>15)){o=a;i=d;return o|0}c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=m|3;c[h>>2]=c[h>>2]|1;__a(a+b|0,m);o=a;i=d;return o|0}if((k|0)==(c[296392>>2]|0)){m=(c[296380>>2]|0)+g|0;if(!(m>>>0>b>>>0)){o=0;i=d;return o|0}h=m-b|0;c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=h|1;c[296392>>2]=a+b;c[296380>>2]=h;o=a;i=d;return o|0}if((k|0)==(c[296388>>2]|0)){h=(c[296376>>2]|0)+g|0;if(h>>>0<b>>>0){o=0;i=d;return o|0}m=h-b|0;if(m>>>0>15){c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=m|1;c[a+h>>2]=m;p=a+(h+4)|0;c[p>>2]=c[p>>2]&-2;q=a+b|0;r=m}else{c[e>>2]=f&1|h|2;f=a+(h+4)|0;c[f>>2]=c[f>>2]|1;q=0;r=0}c[296376>>2]=r;c[296388>>2]=q;o=a;i=d;return o|0}if((n&2|0)!=0){o=0;i=d;return o|0}q=(n&-8)+g|0;if(q>>>0<b>>>0){o=0;i=d;return o|0}r=q-b|0;f=n>>>3;a:do{if(n>>>0<256){h=c[a+(g+8)>>2]|0;m=c[a+(g+12)>>2]|0;p=296408+(f<<1<<2)|0;do{if((h|0)!=(p|0)){if(h>>>0<l>>>0){md()}if((c[h+12>>2]|0)==(k|0)){break}md()}}while(0);if((m|0)==(h|0)){c[74092]=c[74092]&~(1<<f);break}do{if((m|0)==(p|0)){s=m+8|0}else{if(m>>>0<l>>>0){md()}t=m+8|0;if((c[t>>2]|0)==(k|0)){s=t;break}md()}}while(0);c[h+12>>2]=m;c[s>>2]=h}else{p=j;t=c[a+(g+24)>>2]|0;u=c[a+(g+12)>>2]|0;do{if((u|0)==(p|0)){v=a+(g+20)|0;w=v;x=c[v>>2]|0;if((x|0)==0){v=a+(g+16)|0;y=c[v>>2]|0;if((y|0)==0){z=0;break}else{A=y;B=v}}else{A=x;B=w}while(1){w=A+20|0;x=c[w>>2]|0;if((x|0)!=0){B=w;A=x;continue}x=A+16|0;w=c[x>>2]|0;if((w|0)==0){break}else{A=w;B=x}}if(B>>>0<l>>>0){md()}else{c[B>>2]=0;z=A;break}}else{x=c[a+(g+8)>>2]|0;if(x>>>0<l>>>0){md()}w=x+12|0;if((c[w>>2]|0)!=(p|0)){md()}v=u+8|0;if((c[v>>2]|0)==(p|0)){c[w>>2]=u;c[v>>2]=x;z=u;break}else{md()}}}while(0);if((t|0)==0){break}u=c[a+(g+28)>>2]|0;h=296672+(u<<2)|0;do{if((p|0)==(c[h>>2]|0)){c[h>>2]=z;if((z|0)!=0){break}c[296372>>2]=c[296372>>2]&~(1<<u);break a}else{if(t>>>0<(c[296384>>2]|0)>>>0){md()}m=t+16|0;if((c[m>>2]|0)==(p|0)){c[m>>2]=z}else{c[t+20>>2]=z}if((z|0)==0){break a}}}while(0);if(z>>>0<(c[296384>>2]|0)>>>0){md()}c[z+24>>2]=t;p=c[a+(g+16)>>2]|0;do{if((p|0)!=0){if(p>>>0<(c[296384>>2]|0)>>>0){md()}else{c[z+16>>2]=p;c[p+24>>2]=z;break}}}while(0);p=c[a+(g+20)>>2]|0;if((p|0)==0){break}if(p>>>0<(c[296384>>2]|0)>>>0){md()}else{c[z+20>>2]=p;c[p+24>>2]=z;break}}}while(0);if(r>>>0<16){c[e>>2]=q|c[e>>2]&1|2;z=a+(q|4)|0;c[z>>2]=c[z>>2]|1;o=a;i=d;return o|0}else{c[e>>2]=c[e>>2]&1|b|2;c[a+(b+4)>>2]=r|3;e=a+(q|4)|0;c[e>>2]=c[e>>2]|1;__a(a+b|0,r);o=a;i=d;return o|0}return 0}function __a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=i;e=a+b|0;f=e;g=c[a+4>>2]|0;a:do{if((g&1|0)==0){h=c[a>>2]|0;if((g&3|0)==0){i=d;return}j=a+(0-h)|0;k=j;l=h+b|0;m=c[296384>>2]|0;if(j>>>0<m>>>0){md()}if((k|0)==(c[296388>>2]|0)){n=a+(b+4)|0;if((c[n>>2]&3|0)!=3){o=k;p=l;break}c[296376>>2]=l;c[n>>2]=c[n>>2]&-2;c[a+(4-h)>>2]=l|1;c[e>>2]=l;i=d;return}n=h>>>3;if(h>>>0<256){q=c[a+(8-h)>>2]|0;r=c[a+(12-h)>>2]|0;s=296408+(n<<1<<2)|0;do{if((q|0)!=(s|0)){if(q>>>0<m>>>0){md()}if((c[q+12>>2]|0)==(k|0)){break}md()}}while(0);if((r|0)==(q|0)){c[74092]=c[74092]&~(1<<n);o=k;p=l;break}do{if((r|0)==(s|0)){t=r+8|0}else{if(r>>>0<m>>>0){md()}u=r+8|0;if((c[u>>2]|0)==(k|0)){t=u;break}md()}}while(0);c[q+12>>2]=r;c[t>>2]=q;o=k;p=l;break}s=j;n=c[a+(24-h)>>2]|0;u=c[a+(12-h)>>2]|0;do{if((u|0)==(s|0)){v=16-h|0;w=a+(v+4)|0;x=w;y=c[w>>2]|0;if((y|0)==0){w=a+v|0;v=c[w>>2]|0;if((v|0)==0){z=0;break}else{A=v;B=w}}else{A=y;B=x}while(1){x=A+20|0;y=c[x>>2]|0;if((y|0)!=0){B=x;A=y;continue}y=A+16|0;x=c[y>>2]|0;if((x|0)==0){break}else{A=x;B=y}}if(B>>>0<m>>>0){md()}else{c[B>>2]=0;z=A;break}}else{y=c[a+(8-h)>>2]|0;if(y>>>0<m>>>0){md()}x=y+12|0;if((c[x>>2]|0)!=(s|0)){md()}w=u+8|0;if((c[w>>2]|0)==(s|0)){c[x>>2]=u;c[w>>2]=y;z=u;break}else{md()}}}while(0);if((n|0)==0){o=k;p=l;break}u=c[a+(28-h)>>2]|0;m=296672+(u<<2)|0;do{if((s|0)==(c[m>>2]|0)){c[m>>2]=z;if((z|0)!=0){break}c[296372>>2]=c[296372>>2]&~(1<<u);o=k;p=l;break a}else{if(n>>>0<(c[296384>>2]|0)>>>0){md()}j=n+16|0;if((c[j>>2]|0)==(s|0)){c[j>>2]=z}else{c[n+20>>2]=z}if((z|0)==0){o=k;p=l;break a}}}while(0);if(z>>>0<(c[296384>>2]|0)>>>0){md()}c[z+24>>2]=n;s=16-h|0;u=c[a+s>>2]|0;do{if((u|0)!=0){if(u>>>0<(c[296384>>2]|0)>>>0){md()}else{c[z+16>>2]=u;c[u+24>>2]=z;break}}}while(0);u=c[a+(s+4)>>2]|0;if((u|0)==0){o=k;p=l;break}if(u>>>0<(c[296384>>2]|0)>>>0){md()}else{c[z+20>>2]=u;c[u+24>>2]=z;o=k;p=l;break}}else{o=a;p=b}}while(0);z=c[296384>>2]|0;if(e>>>0<z>>>0){md()}A=a+(b+4)|0;B=c[A>>2]|0;do{if((B&2|0)==0){if((f|0)==(c[296392>>2]|0)){t=(c[296380>>2]|0)+p|0;c[296380>>2]=t;c[296392>>2]=o;c[o+4>>2]=t|1;if((o|0)!=(c[296388>>2]|0)){i=d;return}c[296388>>2]=0;c[296376>>2]=0;i=d;return}if((f|0)==(c[296388>>2]|0)){t=(c[296376>>2]|0)+p|0;c[296376>>2]=t;c[296388>>2]=o;c[o+4>>2]=t|1;c[o+t>>2]=t;i=d;return}t=(B&-8)+p|0;g=B>>>3;b:do{if(B>>>0<256){u=c[a+(b+8)>>2]|0;h=c[a+(b+12)>>2]|0;n=296408+(g<<1<<2)|0;do{if((u|0)!=(n|0)){if(u>>>0<z>>>0){md()}if((c[u+12>>2]|0)==(f|0)){break}md()}}while(0);if((h|0)==(u|0)){c[74092]=c[74092]&~(1<<g);break}do{if((h|0)==(n|0)){C=h+8|0}else{if(h>>>0<z>>>0){md()}m=h+8|0;if((c[m>>2]|0)==(f|0)){C=m;break}md()}}while(0);c[u+12>>2]=h;c[C>>2]=u}else{n=e;m=c[a+(b+24)>>2]|0;j=c[a+(b+12)>>2]|0;do{if((j|0)==(n|0)){q=a+(b+20)|0;r=q;y=c[q>>2]|0;if((y|0)==0){q=a+(b+16)|0;w=c[q>>2]|0;if((w|0)==0){D=0;break}else{E=w;F=q}}else{E=y;F=r}while(1){r=E+20|0;y=c[r>>2]|0;if((y|0)!=0){F=r;E=y;continue}y=E+16|0;r=c[y>>2]|0;if((r|0)==0){break}else{E=r;F=y}}if(F>>>0<z>>>0){md()}else{c[F>>2]=0;D=E;break}}else{y=c[a+(b+8)>>2]|0;if(y>>>0<z>>>0){md()}r=y+12|0;if((c[r>>2]|0)!=(n|0)){md()}q=j+8|0;if((c[q>>2]|0)==(n|0)){c[r>>2]=j;c[q>>2]=y;D=j;break}else{md()}}}while(0);if((m|0)==0){break}j=c[a+(b+28)>>2]|0;u=296672+(j<<2)|0;do{if((n|0)==(c[u>>2]|0)){c[u>>2]=D;if((D|0)!=0){break}c[296372>>2]=c[296372>>2]&~(1<<j);break b}else{if(m>>>0<(c[296384>>2]|0)>>>0){md()}h=m+16|0;if((c[h>>2]|0)==(n|0)){c[h>>2]=D}else{c[m+20>>2]=D}if((D|0)==0){break b}}}while(0);if(D>>>0<(c[296384>>2]|0)>>>0){md()}c[D+24>>2]=m;n=c[a+(b+16)>>2]|0;do{if((n|0)!=0){if(n>>>0<(c[296384>>2]|0)>>>0){md()}else{c[D+16>>2]=n;c[n+24>>2]=D;break}}}while(0);n=c[a+(b+20)>>2]|0;if((n|0)==0){break}if(n>>>0<(c[296384>>2]|0)>>>0){md()}else{c[D+20>>2]=n;c[n+24>>2]=D;break}}}while(0);c[o+4>>2]=t|1;c[o+t>>2]=t;if((o|0)!=(c[296388>>2]|0)){G=t;break}c[296376>>2]=t;i=d;return}else{c[A>>2]=B&-2;c[o+4>>2]=p|1;c[o+p>>2]=p;G=p}}while(0);p=G>>>3;if(G>>>0<256){B=p<<1;A=296408+(B<<2)|0;D=c[74092]|0;b=1<<p;do{if((D&b|0)==0){c[74092]=D|b;H=296408+(B+2<<2)|0;I=A}else{p=296408+(B+2<<2)|0;a=c[p>>2]|0;if(!(a>>>0<(c[296384>>2]|0)>>>0)){H=p;I=a;break}md()}}while(0);c[H>>2]=o;c[I+12>>2]=o;c[o+8>>2]=I;c[o+12>>2]=A;i=d;return}A=o;I=G>>>8;do{if((I|0)==0){J=0}else{if(G>>>0>16777215){J=31;break}H=(I+1048320|0)>>>16&8;B=I<<H;b=(B+520192|0)>>>16&4;D=B<<b;B=(D+245760|0)>>>16&2;a=14-(b|H|B)+(D<<B>>>15)|0;J=G>>>(a+7|0)&1|a<<1}}while(0);I=296672+(J<<2)|0;c[o+28>>2]=J;c[o+20>>2]=0;c[o+16>>2]=0;a=c[296372>>2]|0;B=1<<J;if((a&B|0)==0){c[296372>>2]=a|B;c[I>>2]=A;c[o+24>>2]=I;c[o+12>>2]=o;c[o+8>>2]=o;i=d;return}B=c[I>>2]|0;if((J|0)==31){K=0}else{K=25-(J>>>1)|0}c:do{if((c[B+4>>2]&-8|0)==(G|0)){L=B}else{J=G<<K;I=B;while(1){M=I+16+(J>>>31<<2)|0;a=c[M>>2]|0;if((a|0)==0){break}if((c[a+4>>2]&-8|0)==(G|0)){L=a;break c}else{J=J<<1;I=a}}if(M>>>0<(c[296384>>2]|0)>>>0){md()}c[M>>2]=A;c[o+24>>2]=I;c[o+12>>2]=o;c[o+8>>2]=o;i=d;return}}while(0);M=L+8|0;G=c[M>>2]|0;B=c[296384>>2]|0;if(L>>>0<B>>>0){md()}if(G>>>0<B>>>0){md()}c[G+12>>2]=A;c[M>>2]=A;c[o+8>>2]=G;c[o+12>>2]=L;c[o+24>>2]=0;i=d;return}function $_a(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=(a|0)==0?1:a;while(1){e=V_a(d)|0;if((e|0)!=0){f=6;break}a=c[74216]|0;c[74216]=0+a;if((a|0)==0){f=5;break}Le[a&7]()}if((f|0)==5){d=Hc(4)|0;c[d>>2]=296880;Zd(d|0,296928,136)}else if((f|0)==6){i=b;return e|0}return 0}function a$a(a){a=a|0;var b=0,c=0;b=i;c=$_a(a)|0;i=b;return c|0}function b$a(a){a=a|0;var b=0;b=i;if((a|0)!=0){W_a(a)}i=b;return}function c$a(a){a=a|0;var b=0;b=i;b$a(a);i=b;return}function d$a(a){a=a|0;var b=0;b=i;Cb(a|0);b$a(a);i=b;return}function e$a(a){a=a|0;var b=0;b=i;Cb(a|0);i=b;return}function f$a(a){a=a|0;i=i;return 296896}function g$a(){var a=0;a=Hc(4)|0;c[a>>2]=296880;Zd(a|0,296928,136)}function h$a(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,ga=0.0,ha=0,ia=0.0,ja=0,ka=0.0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0.0,ua=0,va=0.0,wa=0,xa=0,ya=0,za=0,Aa=0.0,Ba=0,Ca=0.0,Da=0.0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0.0,tc=0,uc=0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0.0,Ac=0.0,Bc=0,Dc=0,Ec=0.0,Fc=0,Gc=0.0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0;g=i;i=i+512|0;h=g;if((e|0)==0){j=24;k=-149}else if((e|0)==1){j=53;k=-1074}else if((e|0)==2){j=53;k=-1074}else{l=0.0;i=g;return+l}e=b+4|0;m=b+100|0;do{n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;o=d[n]|0}else{o=k$a(b)|0}}while((od(o|0)|0)!=0);do{if((o|0)==43|(o|0)==45){n=1-(((o|0)==45)<<1)|0;p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;q=d[p]|0;r=n;break}else{q=k$a(b)|0;r=n;break}}else{q=o;r=1}}while(0);o=q;q=0;while(1){if((o|32|0)!=(a[296944+q|0]|0)){s=o;t=q;break}do{if(q>>>0<7){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;u=d[n]|0;break}else{u=k$a(b)|0;break}}else{u=o}}while(0);n=q+1|0;if(n>>>0<8){o=u;q=n}else{s=u;t=n;break}}do{if((t|0)==3){v=23}else if((t|0)!=8){u=(f|0)==0;if(!(t>>>0<4|u)){if((t|0)==8){break}else{v=23;break}}a:do{if((t|0)==0){q=s;o=0;while(1){if((q|32|0)!=(a[296960+o|0]|0)){w=q;x=o;break a}do{if(o>>>0<2){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;A=d[n]|0;break}else{A=k$a(b)|0;break}}else{A=q}}while(0);n=o+1|0;if(n>>>0<3){q=A;o=n}else{w=A;x=n;break}}}else{w=s;x=t}}while(0);if((x|0)==0){do{if((w|0)==48){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;B=d[o]|0}else{B=k$a(b)|0}if((B|32|0)!=120){if((c[m>>2]|0)==0){C=48;break}c[e>>2]=(c[e>>2]|0)+ -1;C=48;break}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;D=d[o]|0;E=0}else{D=k$a(b)|0;E=0}while(1){if((D|0)==46){v=70;break}else if((D|0)!=48){F=0;G=0;H=0;I=0;K=D;L=E;M=0;N=0;O=1.0;P=0;Q=0.0;break}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;D=d[o]|0;E=1;continue}else{D=k$a(b)|0;E=1;continue}}b:do{if((v|0)==70){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;R=d[o]|0}else{R=k$a(b)|0}if((R|0)==48){S=-1;T=-1}else{F=0;G=0;H=0;I=0;K=R;L=E;M=1;N=0;O=1.0;P=0;Q=0.0;break}while(1){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;V=d[o]|0}else{V=k$a(b)|0}if((V|0)!=48){F=S;G=T;H=0;I=0;K=V;L=1;M=1;N=0;O=1.0;P=0;Q=0.0;break b}o=H$a(S|0,T|0,-1,-1)|0;S=o;T=J}}}while(0);c:while(1){o=K+ -48|0;do{if(o>>>0<10){W=o;v=84}else{q=K|32;n=(K|0)==46;if(!((q+ -97|0)>>>0<6|n)){X=K;break c}if(n){if((M|0)==0){Y=H;Z=I;_=H;$=I;aa=L;ba=1;ca=N;da=O;ea=P;ga=Q;break}else{X=46;break c}}else{W=(K|0)>57?q+ -87|0:o;v=84;break}}}while(0);if((v|0)==84){v=0;do{if((I|0)<0|(I|0)==0&H>>>0<8){ha=N;ia=O;ja=W+(P<<4)|0;ka=Q}else{if((I|0)<0|(I|0)==0&H>>>0<14){la=O*.0625;ha=N;ia=la;ja=P;ka=Q+la*+(W|0);break}if(!((W|0)!=0&(N|0)==0)){ha=N;ia=O;ja=P;ka=Q;break}ha=1;ia=O;ja=P;ka=Q+O*.5}}while(0);o=H$a(H|0,I|0,1,0)|0;Y=F;Z=G;_=o;$=J;aa=1;ba=M;ca=ha;da=ia;ea=ja;ga=ka}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;F=Y;G=Z;H=_;I=$;K=d[o]|0;L=aa;M=ba;N=ca;O=da;P=ea;Q=ga;continue}else{F=Y;G=Z;H=_;I=$;K=k$a(b)|0;L=aa;M=ba;N=ca;O=da;P=ea;Q=ga;continue}}if((L|0)==0){o=(c[m>>2]|0)==0;if(!o){c[e>>2]=(c[e>>2]|0)+ -1}do{if(u){j$a(b,0)}else{if(o){break}q=c[e>>2]|0;c[e>>2]=q+ -1;if((M|0)==0){break}c[e>>2]=q+ -2}}while(0);l=+(r|0)*0.0;i=g;return+l}o=(M|0)==0;q=o?H:F;n=o?I:G;if((I|0)<0|(I|0)==0&H>>>0<8){o=H;p=I;ma=P;while(1){na=ma<<4;oa=H$a(o|0,p|0,1,0)|0;pa=J;if((pa|0)<0|(pa|0)==0&oa>>>0<8){ma=na;p=pa;o=oa}else{qa=na;break}}}else{qa=P}do{if((X|32|0)==112){o=i$a(b,f)|0;p=J;if(!((o|0)==0&(p|0)==-2147483648)){ra=o;sa=p;break}if(u){j$a(b,0);l=0.0;i=g;return+l}else{if((c[m>>2]|0)==0){ra=0;sa=0;break}c[e>>2]=(c[e>>2]|0)+ -1;ra=0;sa=0;break}}else{if((c[m>>2]|0)==0){ra=0;sa=0;break}c[e>>2]=(c[e>>2]|0)+ -1;ra=0;sa=0}}while(0);p=C$a(q|0,n|0,2)|0;o=H$a(p|0,J|0,-32,-1)|0;p=H$a(o|0,J|0,ra|0,sa|0)|0;o=J;if((qa|0)==0){l=+(r|0)*0.0;i=g;return+l}if((o|0)>0|(o|0)==0&p>>>0>(0-k|0)>>>0){c[(Qc()|0)>>2]=34;l=+(r|0)*1.7976931348623157e+308*1.7976931348623157e+308;i=g;return+l}ma=k+ -106|0;na=((ma|0)<0)<<31>>31;if((o|0)<(na|0)|(o|0)==(na|0)&p>>>0<ma>>>0){c[(Qc()|0)>>2]=34;l=+(r|0)*1.2882297539194267e-231*1.2882297539194267e-231;i=g;return+l}if((qa|0)>-1){ma=p;na=o;oa=qa;la=Q;while(1){pa=oa<<1;if(!(la>=.5)){ta=la;ua=pa}else{ta=la+-1.0;ua=pa|1}va=la+ta;pa=H$a(ma|0,na|0,-1,-1)|0;wa=J;if((ua|0)>-1){ma=pa;na=wa;oa=ua;la=va}else{xa=pa;ya=wa;za=ua;Aa=va;break}}}else{xa=p;ya=o;za=qa;Aa=Q}oa=G$a(32,0,k|0,((k|0)<0)<<31>>31|0)|0;na=H$a(xa|0,ya|0,oa|0,J|0)|0;oa=J;if(0>(oa|0)|0==(oa|0)&j>>>0>na>>>0){Ba=(na|0)<0?0:na}else{Ba=j}do{if((Ba|0)<53){la=+(r|0);va=+id(+(+l$a(1.0,84-Ba|0)),+la);if(!((Ba|0)<32&Aa!=0.0)){Ca=la;Da=va;Ea=za;Fa=Aa;break}na=za&1;Ca=la;Da=va;Ea=(na^1)+za|0;Fa=(na|0)==0?0.0:Aa}else{Ca=+(r|0);Da=0.0;Ea=za;Fa=Aa}}while(0);va=Ca*Fa+(Da+Ca*+(Ea>>>0))-Da;if(!(va!=0.0)){c[(Qc()|0)>>2]=34}l=+m$a(va,xa);i=g;return+l}else{C=w}}while(0);o=k+j|0;p=0-o|0;na=C;oa=0;while(1){if((na|0)==46){v=139;break}else if((na|0)!=48){Ga=na;Ha=0;Ia=0;Ja=oa;Ka=0;break}ma=c[e>>2]|0;if(ma>>>0<(c[m>>2]|0)>>>0){c[e>>2]=ma+1;na=d[ma]|0;oa=1;continue}else{na=k$a(b)|0;oa=1;continue}}d:do{if((v|0)==139){na=c[e>>2]|0;if(na>>>0<(c[m>>2]|0)>>>0){c[e>>2]=na+1;La=d[na]|0}else{La=k$a(b)|0}if((La|0)==48){Ma=-1;Na=-1}else{Ga=La;Ha=0;Ia=0;Ja=oa;Ka=1;break}while(1){na=c[e>>2]|0;if(na>>>0<(c[m>>2]|0)>>>0){c[e>>2]=na+1;Oa=d[na]|0}else{Oa=k$a(b)|0}if((Oa|0)!=48){Ga=Oa;Ha=Ma;Ia=Na;Ja=1;Ka=1;break d}na=H$a(Ma|0,Na|0,-1,-1)|0;Ma=na;Na=J}}}while(0);oa=h;c[oa>>2]=0;na=Ga+ -48|0;ma=(Ga|0)==46;e:do{if(na>>>0<10|ma){n=h+496|0;q=Ga;wa=ma;pa=na;Pa=0;Qa=0;Ra=Ha;Sa=Ia;Ta=Ja;Ua=Ka;Va=0;Wa=0;Xa=0;while(1){do{if(wa){if((Ua|0)==0){Ya=Pa;Za=Qa;_a=Pa;$a=Qa;ab=Ta;bb=1;cb=Va;db=Wa;eb=Xa}else{fb=q;gb=Pa;hb=Qa;ib=Ra;jb=Sa;kb=Ta;lb=Va;mb=Wa;nb=Xa;break e}}else{ob=H$a(Pa|0,Qa|0,1,0)|0;pb=J;qb=(q|0)!=48;if((Wa|0)>=125){if(!qb){Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=Ta;bb=Ua;cb=Va;db=Wa;eb=Xa;break}c[n>>2]=c[n>>2]|1;Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=Ta;bb=Ua;cb=Va;db=Wa;eb=Xa;break}rb=h+(Wa<<2)|0;if((Va|0)==0){sb=pa}else{sb=q+ -48+((c[rb>>2]|0)*10|0)|0}c[rb>>2]=sb;rb=Va+1|0;tb=(rb|0)==9;Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=1;bb=Ua;cb=tb?0:rb;db=(tb&1)+Wa|0;eb=qb?ob:Xa}}while(0);ob=c[e>>2]|0;if(ob>>>0<(c[m>>2]|0)>>>0){c[e>>2]=ob+1;ub=d[ob]|0}else{ub=k$a(b)|0}ob=ub+ -48|0;qb=(ub|0)==46;if(ob>>>0<10|qb){q=ub;wa=qb;pa=ob;Pa=_a;Qa=$a;Ra=Ya;Sa=Za;Ta=ab;Ua=bb;Va=cb;Wa=db;Xa=eb}else{vb=ub;wb=_a;xb=$a;yb=Ya;zb=Za;Ab=ab;Bb=bb;Cb=cb;Db=db;Eb=eb;v=162;break}}}else{vb=Ga;wb=0;xb=0;yb=Ha;zb=Ia;Ab=Ja;Bb=Ka;Cb=0;Db=0;Eb=0;v=162}}while(0);if((v|0)==162){na=(Bb|0)==0;fb=vb;gb=wb;hb=xb;ib=na?wb:yb;jb=na?xb:zb;kb=Ab;lb=Cb;mb=Db;nb=Eb}na=(kb|0)!=0;do{if(na){if((fb|32|0)!=101){v=171;break}ma=i$a(b,f)|0;Xa=J;do{if((ma|0)==0&(Xa|0)==-2147483648){if(u){j$a(b,0);l=0.0;i=g;return+l}else{if((c[m>>2]|0)==0){Fb=0;Gb=0;break}c[e>>2]=(c[e>>2]|0)+ -1;Fb=0;Gb=0;break}}else{Fb=ma;Gb=Xa}}while(0);Xa=H$a(Fb|0,Gb|0,ib|0,jb|0)|0;Hb=Xa;Ib=J}else{v=171}}while(0);do{if((v|0)==171){if(!((fb|0)>-1)){Hb=ib;Ib=jb;break}if((c[m>>2]|0)==0){Hb=ib;Ib=jb;break}c[e>>2]=(c[e>>2]|0)+ -1;Hb=ib;Ib=jb}}while(0);if(!na){c[(Qc()|0)>>2]=22;j$a(b,0);l=0.0;i=g;return+l}Xa=c[oa>>2]|0;if((Xa|0)==0){l=+(r|0)*0.0;i=g;return+l}do{if((Hb|0)==(gb|0)&(Ib|0)==(hb|0)&((hb|0)<0|(hb|0)==0&gb>>>0<10)){if(!(j>>>0>30)){if((Xa>>>j|0)!=0){break}}l=+(r|0)*+(Xa>>>0);i=g;return+l}}while(0);Xa=(k|0)/-2|0;na=((Xa|0)<0)<<31>>31;if((Ib|0)>(na|0)|(Ib|0)==(na|0)&Hb>>>0>Xa>>>0){c[(Qc()|0)>>2]=34;l=+(r|0)*1.7976931348623157e+308*1.7976931348623157e+308;i=g;return+l}Xa=k+ -106|0;na=((Xa|0)<0)<<31>>31;if((Ib|0)<(na|0)|(Ib|0)==(na|0)&Hb>>>0<Xa>>>0){c[(Qc()|0)>>2]=34;l=+(r|0)*1.2882297539194267e-231*1.2882297539194267e-231;i=g;return+l}if((lb|0)==0){Jb=mb}else{if((lb|0)<9){Xa=h+(mb<<2)|0;na=c[Xa>>2]|0;ma=lb;do{na=na*10|0;ma=ma+1|0;}while((ma|0)<9);c[Xa>>2]=na}Jb=mb+1|0}do{if((nb|0)<9){if(!((nb|0)<=(Hb|0)&(Hb|0)<18)){break}if((Hb|0)==9){l=+(r|0)*+((c[oa>>2]|0)>>>0);i=g;return+l}if((Hb|0)<9){l=+(r|0)*+((c[oa>>2]|0)>>>0)/+(c[296976+(8-Hb<<2)>>2]|0);i=g;return+l}ma=j+27+(fa(Hb,-3)|0)|0;Wa=c[oa>>2]|0;if((ma|0)<=30){if((Wa>>>ma|0)!=0){break}}l=+(r|0)*+(Wa>>>0)*+(c[296976+(Hb+ -10<<2)>>2]|0);i=g;return+l}}while(0);oa=(Hb|0)%9|0;if((oa|0)==0){Kb=0;Lb=0;Mb=Hb;Nb=Jb}else{na=(Hb|0)>-1?oa:oa+9|0;oa=c[296976+(8-na<<2)>>2]|0;do{if((Jb|0)==0){Ob=0;Pb=Hb;Qb=0}else{Xa=1e9/(oa|0)|0;Wa=0;ma=0;Va=0;Ua=Hb;while(1){Ta=h+(Va<<2)|0;Sa=c[Ta>>2]|0;Ra=((Sa>>>0)/(oa>>>0)|0)+ma|0;c[Ta>>2]=Ra;Rb=fa((Sa>>>0)%(oa>>>0)|0,Xa)|0;Sa=Va+1|0;if((Va|0)==(Wa|0)&(Ra|0)==0){Sb=Sa&127;Tb=Ua+ -9|0}else{Sb=Wa;Tb=Ua}if((Sa|0)==(Jb|0)){break}else{Wa=Sb;Ua=Tb;Va=Sa;ma=Rb}}if((Rb|0)==0){Ob=Sb;Pb=Tb;Qb=Jb;break}c[h+(Jb<<2)>>2]=Rb;Ob=Sb;Pb=Tb;Qb=Jb+1|0}}while(0);Kb=Ob;Lb=0;Mb=9-na+Pb|0;Nb=Qb}f:while(1){oa=h+(Kb<<2)|0;if((Mb|0)<18){ma=Lb;Va=Nb;while(1){Ua=0;Wa=Va+127|0;Xa=Va;while(1){Sa=Wa&127;Ra=h+(Sa<<2)|0;Ta=C$a(c[Ra>>2]|0,0,29)|0;Qa=H$a(Ta|0,J|0,Ua|0,0)|0;Ta=J;if(Ta>>>0>0|(Ta|0)==0&Qa>>>0>1e9){Pa=R$a(Qa|0,Ta|0,1e9,0)|0;pa=S$a(Qa|0,Ta|0,1e9,0)|0;Ub=pa;Vb=Pa}else{Ub=Qa;Vb=0}c[Ra>>2]=Ub;Ra=(Sa|0)==(Kb|0);if((Sa|0)!=(Xa+127&127|0)|Ra){Wb=Xa}else{Wb=(Ub|0)==0?Sa:Xa}if(Ra){break}else{Ua=Vb;Wa=Sa+ -1|0;Xa=Wb}}Xa=ma+ -29|0;if((Vb|0)==0){ma=Xa;Va=Wb}else{Xb=Xa;Yb=Vb;Zb=Wb;break}}}else{if((Mb|0)==18){_b=Lb;$b=Nb}else{ac=Kb;bc=Lb;cc=Mb;dc=Nb;break}while(1){if(!((c[oa>>2]|0)>>>0<9007199)){ac=Kb;bc=_b;cc=18;dc=$b;break f}Va=0;ma=$b+127|0;Xa=$b;while(1){Wa=ma&127;Ua=h+(Wa<<2)|0;Sa=C$a(c[Ua>>2]|0,0,29)|0;Ra=H$a(Sa|0,J|0,Va|0,0)|0;Sa=J;if(Sa>>>0>0|(Sa|0)==0&Ra>>>0>1e9){Qa=R$a(Ra|0,Sa|0,1e9,0)|0;Pa=S$a(Ra|0,Sa|0,1e9,0)|0;ec=Pa;fc=Qa}else{ec=Ra;fc=0}c[Ua>>2]=ec;Ua=(Wa|0)==(Kb|0);if((Wa|0)!=(Xa+127&127|0)|Ua){gc=Xa}else{gc=(ec|0)==0?Wa:Xa}if(Ua){break}else{Va=fc;ma=Wa+ -1|0;Xa=gc}}Xa=_b+ -29|0;if((fc|0)==0){_b=Xa;$b=gc}else{Xb=Xa;Yb=fc;Zb=gc;break}}}oa=Kb+127&127;if((oa|0)==(Zb|0)){Xa=Zb+127&127;ma=h+((Zb+126&127)<<2)|0;c[ma>>2]=c[ma>>2]|c[h+(Xa<<2)>>2];hc=Xa}else{hc=Zb}c[h+(oa<<2)>>2]=Yb;Kb=oa;Lb=Xb;Mb=Mb+9|0;Nb=hc}g:while(1){ic=dc+1&127;na=h+((dc+127&127)<<2)|0;oa=ac;Xa=bc;ma=cc;while(1){Va=(ma|0)==18;Wa=(ma|0)>27?9:1;jc=oa;kc=Xa;while(1){Ua=0;while(1){Ra=Ua+jc&127;if((Ra|0)==(dc|0)){lc=2;break}Qa=c[h+(Ra<<2)>>2]|0;Ra=c[296968+(Ua<<2)>>2]|0;if(Qa>>>0<Ra>>>0){lc=2;break}Pa=Ua+1|0;if(Qa>>>0>Ra>>>0){lc=Ua;break}if((Pa|0)<2){Ua=Pa}else{lc=Pa;break}}if((lc|0)==2&Va){break g}mc=Wa+kc|0;if((jc|0)==(dc|0)){jc=dc;kc=mc}else{break}}Va=(1<<Wa)+ -1|0;Ua=1e9>>>Wa;nc=jc;oc=0;Pa=jc;pc=ma;do{Ra=h+(Pa<<2)|0;Qa=c[Ra>>2]|0;Sa=(Qa>>>Wa)+oc|0;c[Ra>>2]=Sa;oc=fa(Qa&Va,Ua)|0;Qa=(Pa|0)==(nc|0)&(Sa|0)==0;Pa=Pa+1&127;pc=Qa?pc+ -9|0:pc;nc=Qa?Pa:nc;}while((Pa|0)!=(dc|0));if((oc|0)==0){oa=nc;Xa=mc;ma=pc;continue}if((ic|0)!=(nc|0)){break}c[na>>2]=c[na>>2]|1;oa=nc;Xa=mc;ma=pc}c[h+(dc<<2)>>2]=oc;ac=nc;bc=mc;cc=pc;dc=ic}ma=jc&127;if((ma|0)==(dc|0)){c[h+(ic+ -1<<2)>>2]=0;qc=ic}else{qc=dc}va=+((c[h+(ma<<2)>>2]|0)>>>0);ma=jc+1&127;if((ma|0)==(qc|0)){Xa=qc+1&127;c[h+(Xa+ -1<<2)>>2]=0;rc=Xa}else{rc=qc}la=+(r|0);sc=la*(va*1.0e9+ +((c[h+(ma<<2)>>2]|0)>>>0));ma=kc+53|0;Xa=ma-k|0;if((Xa|0)<(j|0)){tc=(Xa|0)<0?0:Xa;uc=1}else{tc=j;uc=0}if((tc|0)<53){va=+id(+(+l$a(1.0,105-tc|0)),+sc);vc=+Cc(+sc,+(+l$a(1.0,53-tc|0)));wc=va;xc=vc;yc=va+(sc-vc)}else{wc=0.0;xc=0.0;yc=sc}oa=jc+2&127;do{if((oa|0)==(rc|0)){zc=xc}else{na=c[h+(oa<<2)>>2]|0;do{if(na>>>0<5e8){if((na|0)==0){if((jc+3&127|0)==(rc|0)){Ac=xc;break}}Ac=la*.25+xc}else{if(na>>>0>5e8){Ac=la*.75+xc;break}if((jc+3&127|0)==(rc|0)){Ac=la*.5+xc;break}else{Ac=la*.75+xc;break}}}while(0);if((53-tc|0)<=1){zc=Ac;break}if(+Cc(+Ac,1.0)!=0.0){zc=Ac;break}zc=Ac+1.0}}while(0);la=yc+zc-wc;do{if((ma&2147483647|0)>(-2-o|0)){if(!(+U(+la)>=9007199254740992.0)){Bc=uc;Dc=kc;Ec=la}else{Bc=(uc|0)!=0&(tc|0)==(Xa|0)?0:uc;Dc=kc+1|0;Ec=la*.5}if((Dc+50|0)<=(p|0)){if(!((Bc|0)!=0&zc!=0.0)){Fc=Dc;Gc=Ec;break}}c[(Qc()|0)>>2]=34;Fc=Dc;Gc=Ec}else{Fc=kc;Gc=la}}while(0);l=+m$a(Gc,Fc);i=g;return+l}else if((x|0)==3){p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;Hc=d[p]|0}else{Hc=k$a(b)|0}if((Hc|0)==40){Ic=1}else{if((c[m>>2]|0)==0){l=+y;i=g;return+l}c[e>>2]=(c[e>>2]|0)+ -1;l=+y;i=g;return+l}while(1){p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;Jc=d[p]|0}else{Jc=k$a(b)|0}if(!((Jc+ -48|0)>>>0<10|(Jc+ -65|0)>>>0<26)){if(!((Jc+ -97|0)>>>0<26|(Jc|0)==95)){break}}Ic=Ic+1|0}if((Jc|0)==41){l=+y;i=g;return+l}p=(c[m>>2]|0)==0;if(!p){c[e>>2]=(c[e>>2]|0)+ -1}if(u){c[(Qc()|0)>>2]=22;j$a(b,0);l=0.0;i=g;return+l}if((Ic|0)==0|p){l=+y;i=g;return+l}else{Kc=Ic}while(1){p=Kc+ -1|0;c[e>>2]=(c[e>>2]|0)+ -1;if((p|0)==0){l=+y;break}else{Kc=p}}i=g;return+l}else{if((c[m>>2]|0)!=0){c[e>>2]=(c[e>>2]|0)+ -1}c[(Qc()|0)>>2]=22;j$a(b,0);l=0.0;i=g;return+l}}}while(0);do{if((v|0)==23){b=(c[m>>2]|0)==0;if(!b){c[e>>2]=(c[e>>2]|0)+ -1}if(t>>>0<4|(f|0)==0|b){break}else{Lc=t}do{c[e>>2]=(c[e>>2]|0)+ -1;Lc=Lc+ -1|0;}while(Lc>>>0>3)}}while(0);l=+(r|0)*+z;i=g;return+l}function i$a(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=a+4|0;g=c[f>>2]|0;h=a+100|0;if(g>>>0<(c[h>>2]|0)>>>0){c[f>>2]=g+1;j=d[g]|0}else{j=k$a(a)|0}do{if((j|0)==43|(j|0)==45){g=(j|0)==45|0;k=c[f>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){c[f>>2]=k+1;l=d[k]|0}else{l=k$a(a)|0}if((l+ -48|0)>>>0<10|(b|0)==0){m=l;n=g;break}if((c[h>>2]|0)==0){m=l;n=g;break}c[f>>2]=(c[f>>2]|0)+ -1;m=l;n=g}else{m=j;n=0}}while(0);if((m+ -48|0)>>>0>9){if((c[h>>2]|0)==0){o=0;p=-2147483648;J=p;i=e;return o|0}c[f>>2]=(c[f>>2]|0)+ -1;o=0;p=-2147483648;J=p;i=e;return o|0}else{q=m;r=0}while(1){s=q+ -48+r|0;m=c[f>>2]|0;if(m>>>0<(c[h>>2]|0)>>>0){c[f>>2]=m+1;t=d[m]|0}else{t=k$a(a)|0}if(!((t+ -48|0)>>>0<10&(s|0)<214748364)){break}q=t;r=s*10|0}r=((s|0)<0)<<31>>31;if((t+ -48|0)>>>0<10){q=s;m=r;j=t;while(1){l=Q$a(q|0,m|0,10,0)|0;b=J;g=H$a(j|0,((j|0)<0)<<31>>31|0,-48,-1)|0;k=H$a(g|0,J|0,l|0,b|0)|0;b=J;l=c[f>>2]|0;if(l>>>0<(c[h>>2]|0)>>>0){c[f>>2]=l+1;u=d[l]|0}else{u=k$a(a)|0}if((u+ -48|0)>>>0<10&((b|0)<21474836|(b|0)==21474836&k>>>0<2061584302)){j=u;m=b;q=k}else{v=k;w=b;x=u;break}}}else{v=s;w=r;x=t}if((x+ -48|0)>>>0<10){do{x=c[f>>2]|0;if(x>>>0<(c[h>>2]|0)>>>0){c[f>>2]=x+1;y=d[x]|0}else{y=k$a(a)|0}}while((y+ -48|0)>>>0<10)}if((c[h>>2]|0)!=0){c[f>>2]=(c[f>>2]|0)+ -1}f=(n|0)!=0;n=G$a(0,0,v|0,w|0)|0;o=f?n:v;p=f?J:w;J=p;i=e;return o|0}function j$a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a+104>>2]=b;e=c[a+8>>2]|0;f=c[a+4>>2]|0;g=e-f|0;c[a+108>>2]=g;if((b|0)!=0&(g|0)>(b|0)){c[a+100>>2]=f+b;i=d;return}else{c[a+100>>2]=e;i=d;return}}function k$a(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=b+104|0;g=c[f>>2]|0;if((g|0)==0){h=3}else{if((c[b+108>>2]|0)<(g|0)){h=3}}do{if((h|0)==3){g=o$a(b)|0;if((g|0)<0){break}j=c[f>>2]|0;k=c[b+8>>2]|0;do{if((j|0)==0){h=8}else{l=c[b+4>>2]|0;m=j-(c[b+108>>2]|0)+ -1|0;if((k-l|0)<=(m|0)){h=8;break}c[b+100>>2]=l+m}}while(0);if((h|0)==8){c[b+100>>2]=k}j=c[b+4>>2]|0;if((k|0)!=0){m=b+108|0;c[m>>2]=k+1-j+(c[m>>2]|0)}m=j+ -1|0;if((d[m]|0|0)==(g|0)){n=g;i=e;return n|0}a[m]=g;n=g;i=e;return n|0}}while(0);c[b+100>>2]=0;n=-1;i=e;return n|0}function l$a(a,b){a=+a;b=b|0;var d=0,e=0.0,f=0,g=0,j=0.0;d=i;do{if((b|0)>1023){e=a*8.98846567431158e+307;f=b+ -1023|0;if((f|0)<=1023){g=f;j=e;break}f=b+ -2046|0;g=(f|0)>1023?1023:f;j=e*8.98846567431158e+307}else{if(!((b|0)<-1022)){g=b;j=a;break}e=a*1.2882297539194267e-231;f=b+1022|0;if(!((f|0)<-1022)){g=f;j=e;break}f=b+2044|0;g=(f|0)<-1022?-1022:f;j=e*1.2882297539194267e-231}}while(0);b=C$a(g+1023|0,0,52)|0;g=J;c[k>>2]=b;c[k+4>>2]=g;a=j*+h[k>>3];i=d;return+a}function m$a(a,b){a=+a;b=b|0;var c=0,d=0.0;c=i;d=+l$a(a,b);i=c;return+d}function n$a(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+74|0;f=a[e]|0;a[e]=f+ -1<<24>>24|f;f=b+20|0;e=b+44|0;if((c[f>>2]|0)>>>0>(c[e>>2]|0)>>>0){re[c[b+36>>2]&63](b,0,0)|0}c[b+16>>2]=0;c[b+28>>2]=0;c[f>>2]=0;f=b;g=c[f>>2]|0;if((g&20|0)==0){h=c[e>>2]|0;c[b+8>>2]=h;c[b+4>>2]=h;j=0;i=d;return j|0}if((g&4|0)==0){j=-1;i=d;return j|0}c[f>>2]=g|32;j=-1;i=d;return j|0}function o$a(a){a=a|0;var b=0,e=0,f=0;b=i;i=i+8|0;e=b;do{if((c[a+8>>2]|0)==0){if((n$a(a)|0)==0){break}else{f=-1}i=b;return f|0}}while(0);if((re[c[a+32>>2]&63](a,e,1)|0)!=1){f=-1;i=b;return f|0}f=d[e]|0;i=b;return f|0}function p$a(a){a=a|0;var b=0,c=0.0;b=i;c=+q$a(a,0);i=b;return+c}function q$a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;j$a(e,0);h=+h$a(e,1,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if((b|0)==0){i=d;return+h}if((j|0)==0){k=a}else{k=a+j|0}c[b>>2]=k;i=d;return+h}function r$a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;j$a(e,0);h=+h$a(e,2,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if((b|0)==0){i=d;return+h}if((j|0)==0){k=a}else{k=a+j|0}c[b>>2]=k;i=d;return+h}function s$a(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)==0){f=0;i=e;return f|0}else{g=d;h=b;j=c}while(1){k=a[h]|0;l=a[j]|0;if(!(k<<24>>24==l<<24>>24)){break}c=g+ -1|0;if((c|0)==0){f=0;m=5;break}else{g=c;h=h+1|0;j=j+1|0}}if((m|0)==5){i=e;return f|0}f=(k&255)-(l&255)|0;i=e;return f|0}function t$a(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a[b]|0;f=a[c]|0;if(e<<24>>24!=f<<24>>24|e<<24>>24==0|f<<24>>24==0){g=e;h=f;j=g&255;k=h&255;l=j-k|0;i=d;return l|0}else{m=b;n=c}while(1){c=m+1|0;b=n+1|0;f=a[c]|0;e=a[b]|0;if(f<<24>>24!=e<<24>>24|f<<24>>24==0|e<<24>>24==0){g=f;h=e;break}else{n=b;m=c}}j=g&255;k=h&255;l=j-k|0;i=d;return l|0}function u$a(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;if((e|0)==0){g=0;i=f;return g|0}h=a[b]|0;a:do{if(h<<24>>24==0){j=0;k=c}else{l=e;m=h;n=b;o=c;while(1){p=l+ -1|0;q=a[o]|0;if(!((p|0)!=0&q<<24>>24!=0&m<<24>>24==q<<24>>24)){j=m;k=o;break a}q=n+1|0;r=o+1|0;s=a[q]|0;if(s<<24>>24==0){j=0;k=r;break}else{m=s;n=q;o=r;l=p}}}}while(0);g=(j&255)-(d[k]|0)|0;i=f;return g|0}function v$a(){c[69320]=p;c[69362]=p;c[74004]=p;c[74234]=p}function w$a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;w=w+1|0;c[a>>2]=w;while((e|0)<40){if((c[d+(e<<2)>>2]|0)==0){c[d+(e<<2)>>2]=w;c[d+((e<<2)+4)>>2]=b;c[d+((e<<2)+8)>>2]=0;return 0}e=e+2|0}hc(116);hc(111);hc(111);hc(32);hc(109);hc(97);hc(110);hc(121);hc(32);hc(115);hc(101);hc(116);hc(106);hc(109);hc(112);hc(115);hc(32);hc(105);hc(110);hc(32);hc(97);hc(32);hc(102);hc(117);hc(110);hc(99);hc(116);hc(105);hc(111);hc(110);hc(32);hc(99);hc(97);hc(108);hc(108);hc(44);hc(32);hc(98);hc(117);hc(105);hc(108);hc(100);hc(32);hc(119);hc(105);hc(116);hc(104);hc(32);hc(97);hc(32);hc(104);hc(105);hc(103);hc(104);hc(101);hc(114);hc(32);hc(118);hc(97);hc(108);hc(117);hc(101);hc(32);hc(102);hc(111);hc(114);hc(32);hc(77);hc(65);hc(88);hc(95);hc(83);hc(69);hc(84);hc(74);hc(77);hc(80);hc(83);hc(10);ga(0);return 0}function x$a(b){b=b|0;var c=0;c=b;while(a[c]|0){c=c+1|0}return c-b|0}function y$a(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=(b|0)<0?-1:0;return b>>c-32|0}function z$a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if((e|0)>=4096)return nb(b|0,d|0,e|0)|0;f=b|0;if((b&3)==(d&3)){while(b&3){if((e|0)==0)return f|0;a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}while((e|0)>=4){c[b>>2]=c[d>>2];b=b+4|0;d=d+4|0;e=e-4|0}}while((e|0)>0){a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}return f|0}function A$a(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;if((c|0)<(b|0)&(b|0)<(c+d|0)){e=b;c=c+d|0;b=b+d|0;while((d|0)>0){b=b-1|0;c=c-1|0;d=d-1|0;a[b]=a[c]|0}b=e}else{z$a(b,c,d)|0}return b|0}function B$a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=b+e|0;if((e|0)>=20){d=d&255;g=b&3;h=d|d<<8|d<<16|d<<24;i=f&~3;if(g){g=b+4-g|0;while((b|0)<(g|0)){a[b]=d;b=b+1|0}}while((b|0)<(i|0)){c[b>>2]=h;b=b+4|0}}while((b|0)<(f|0)){a[b]=d;b=b+1|0}return b-e|0}function C$a(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b<<c|(a&(1<<c)-1<<32-c)>>>32-c;return a<<c}J=a<<c-32;return 0}function D$a(b,c){b=b|0;c=c|0;var d=0;do{a[b+d|0]=a[c+d|0];d=d+1|0}while(a[c+(d-1)|0]|0);return b|0}function E$a(a){a=a|0;var b=0;b=(fa(c[a>>2]|0,31010991)|0)+1735287159&2147483647;c[a>>2]=b;return b|0}function F$a(){return E$a(o)|0}function G$a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=b-d>>>0;e=b-d-(c>>>0>a>>>0|0)>>>0;return(J=e,a-c>>>0|0)|0}function H$a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=a+c>>>0;return(J=b+d+(e>>>0<a>>>0|0)>>>0,e|0)|0}function I$a(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;while((e|0)<(d|0)){a[b+e|0]=f?0:a[c+e|0]|0;f=f?1:(a[c+e|0]|0)==0;e=e+1|0}return b|0}function J$a(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=0;return b>>>c-32|0}function K$a(a,b){a=a|0;b=b|0;var d=0,e=0;while((d|0)<20){e=c[b+(d<<2)>>2]|0;if((e|0)==0)break;if((e|0)==(a|0)){return c[b+((d<<2)+4)>>2]|0}d=d+2|0}return 0}function L$a(b){b=b|0;var c=0;c=a[n+(b>>>24)|0]|0;if((c|0)<8)return c|0;c=a[n+(b>>16&255)|0]|0;if((c|0)<8)return c+8|0;c=a[n+(b>>8&255)|0]|0;if((c|0)<8)return c+16|0;return(a[n+(b&255)|0]|0)+24|0}function M$a(b){b=b|0;var c=0;c=a[m+(b&255)|0]|0;if((c|0)<8)return c|0;c=a[m+(b>>8&255)|0]|0;if((c|0)<8)return c+8|0;c=a[m+(b>>16&255)|0]|0;if((c|0)<8)return c+16|0;return(a[m+(b>>>24)|0]|0)+24|0}function N$a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=a&65535;d=b&65535;e=fa(d,c)|0;f=a>>>16;a=(e>>>16)+(fa(d,f)|0)|0;d=b>>>16;b=fa(d,c)|0;return(J=(a>>>16)+(fa(d,f)|0)+(((a&65535)+b|0)>>>16)|0,a+b<<16|e&65535|0)|0}function O$a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=b>>31|((b|0)<0?-1:0)<<1;f=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;g=d>>31|((d|0)<0?-1:0)<<1;h=((d|0)<0?-1:0)>>31|((d|0)<0?-1:0)<<1;i=G$a(e^a,f^b,e,f)|0;b=J;a=g^e;e=h^f;f=G$a((T$a(i,b,G$a(g^c,h^d,g,h)|0,J,0)|0)^a,J^e,a,e)|0;return(J=J,f)|0}function P$a(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+8|0;g=f|0;h=b>>31|((b|0)<0?-1:0)<<1;j=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;k=e>>31|((e|0)<0?-1:0)<<1;l=((e|0)<0?-1:0)>>31|((e|0)<0?-1:0)<<1;m=G$a(h^a,j^b,h,j)|0;b=J;T$a(m,b,G$a(k^d,l^e,k,l)|0,J,g)|0;l=G$a(c[g>>2]^h,c[g+4>>2]^j,h,j)|0;j=J;i=f;return(J=j,l)|0}function Q$a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=a;a=c;c=N$a(e,a)|0;f=J;return(J=(fa(b,a)|0)+(fa(d,e)|0)+f|f&0,c|0|0)|0}function R$a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=T$a(a,b,c,d,0)|0;return(J=J,e)|0}function S$a(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=f|0;T$a(a,b,d,e,g)|0;i=f;return(J=c[g+4>>2]|0,c[g>>2]|0)|0}function T$a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0;g=a;h=b;i=h;j=d;k=e;l=k;if((i|0)==0){m=(f|0)!=0;if((l|0)==0){if(m){c[f>>2]=(g>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(g>>>0)/(j>>>0)>>>0;return(J=n,o)|0}else{if(!m){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=b&0;n=0;o=0;return(J=n,o)|0}}m=(l|0)==0;do{if((j|0)==0){if(m){if((f|0)!=0){c[f>>2]=(i>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(i>>>0)/(j>>>0)>>>0;return(J=n,o)|0}if((g|0)==0){if((f|0)!=0){c[f>>2]=0;c[f+4>>2]=(i>>>0)%(l>>>0)}n=0;o=(i>>>0)/(l>>>0)>>>0;return(J=n,o)|0}p=l-1|0;if((p&l|0)==0){if((f|0)!=0){c[f>>2]=a|0;c[f+4>>2]=p&i|b&0}n=0;o=i>>>((M$a(l|0)|0)>>>0);return(J=n,o)|0}p=(L$a(l|0)|0)-(L$a(i|0)|0)|0;if(p>>>0<=30){q=p+1|0;r=31-p|0;s=q;t=i<<r|g>>>(q>>>0);u=i>>>(q>>>0);v=0;w=g<<r;break}if((f|0)==0){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(J=n,o)|0}else{if(!m){r=(L$a(l|0)|0)-(L$a(i|0)|0)|0;if(r>>>0<=31){q=r+1|0;p=31-r|0;x=r-31>>31;s=q;t=g>>>(q>>>0)&x|i<<p;u=i>>>(q>>>0)&x;v=0;w=g<<p;break}if((f|0)==0){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(J=n,o)|0}p=j-1|0;if((p&j|0)!=0){x=(L$a(j|0)|0)+33-(L$a(i|0)|0)|0;q=64-x|0;r=32-x|0;y=r>>31;z=x-32|0;A=z>>31;s=x;t=r-1>>31&i>>>(z>>>0)|(i<<r|g>>>(x>>>0))&A;u=A&i>>>(x>>>0);v=g<<q&y;w=(i<<q|g>>>(z>>>0))&y|g<<r&x-33>>31;break}if((f|0)!=0){c[f>>2]=p&g;c[f+4>>2]=0}if((j|0)==1){n=h|b&0;o=a|0|0;return(J=n,o)|0}else{p=M$a(j|0)|0;n=i>>>(p>>>0)|0;o=i<<32-p|g>>>(p>>>0)|0;return(J=n,o)|0}}}while(0);if((s|0)==0){B=w;C=v;D=u;E=t;F=0;G=0}else{g=d|0|0;d=k|e&0;e=H$a(g,d,-1,-1)|0;k=J;i=w;w=v;v=u;u=t;t=s;s=0;while(1){H=w>>>31|i<<1;I=s|w<<1;j=u<<1|i>>>31|0;a=u>>>31|v<<1|0;G$a(e,k,j,a)|0;b=J;h=b>>31|((b|0)<0?-1:0)<<1;K=h&1;L=G$a(j,a,h&g,(((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1)&d)|0;M=J;b=t-1|0;if((b|0)==0){break}else{i=H;w=I;v=M;u=L;t=b;s=K}}B=H;C=I;D=M;E=L;F=0;G=K}K=C;C=0;if((f|0)!=0){c[f>>2]=E;c[f+4>>2]=D}n=(K|0)>>>31|(B|C)<<1|(C<<1|K>>>31)&0|F;o=(K<<1|0>>>31)&-2|G;return(J=n,o)|0}function U$a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return he[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function V$a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ie[a&31](b|0,c|0,d|0,e|0,f|0)}function W$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;return je[a&1](b|0,c|0,d|0,e|0,+f,g|0,h|0,i|0)|0}function X$a(a,b){a=a|0;b=+b;ke[a&1](+b)}function Y$a(a,b){a=a|0;b=b|0;le[a&2047](b|0)}function Z$a(a,b,c){a=a|0;b=b|0;c=c|0;me[a&127](b|0,c|0)}function _$a(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;return ne[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)|0}function $$a(a,b){a=a|0;b=b|0;return oe[a&127](b|0)|0}function a0a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;pe[a&1](b|0,c|0,+d,e|0)}function b0a(a,b,c,d,e,f,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;return qe[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0)|0}function c0a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return re[a&63](b|0,c|0,d|0)|0}function d0a(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;return se[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0,v|0,w|0)|0}function e0a(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;return te[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0)|0}function f0a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;ue[a&7](b|0,c|0,d|0,e|0,f|0,+g)}function g0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ve[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function h0a(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;return we[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0,v|0,w|0,x|0,y|0)|0}function i0a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;xe[a&31](b|0,c|0,d|0,e|0,f|0,g|0)}function j0a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;ye[a&3](b|0,c|0,+d,e|0,f|0)}function k0a(a,b,c){a=a|0;b=b|0;c=+c;return ze[a&1](b|0,+c)|0}function l0a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Ae[a&63](b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function m0a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;Be[a&3](b|0,c|0,d|0,e|0,f|0,g|0,+h)}function n0a(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;Ce[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function o0a(a,b,c){a=a|0;b=b|0;c=c|0;return De[a&63](b|0,c|0)|0}function p0a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return Ee[a&63](b|0,c|0,d|0,e|0,f|0)|0}function q0a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;return Fe[a&1](b|0,c|0,d|0,e|0,+f,g|0)|0}function r0a(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;return+Ge[a&1](b|0,+c,+d)}function s0a(a,b,c){a=a|0;b=b|0;c=c|0;return+He[a&1](b|0,c|0)}function t0a(a){a=a|0;return Ie[a&7]()|0}function u0a(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;return Je[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)|0}function v0a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ke[a&15](b|0,c|0,d|0)}function w0a(a){a=a|0;Le[a&7]()}function x0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return Me[a&15](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)|0}function y0a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Ne[a&63](b|0,c|0,d|0,e|0)|0}function z0a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Oe[a&127](b|0,c|0,d|0,e|0)}function A0a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ga(0);return 0}function B0a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ga(1)}function C0a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;ga(2);return 0}function D0a(a){a=+a;ga(3)}function E0a(a){a=a|0;ga(4)}function F0a(a){a=a|0;Id(a|0)}function G0a(a,b){a=a|0;b=b|0;ga(5)}function H0a(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ga(6);return 0}function I0a(a){a=a|0;ga(7);return 0}function J0a(a){a=a|0;return Rc(a|0)|0}function K0a(a){a=a|0;return Rd(a|0)|0}function L0a(a){a=a|0;return zc(a|0)|0}function M0a(a){a=a|0;return Gd(a|0)|0}function N0a(a){a=a|0;return rd(a|0)|0}function O0a(a){a=a|0;return Ad(a|0)|0}function P0a(a){a=a|0;return ad(a|0)|0}function Q0a(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;ga(8)}function R0a(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;ga(9);return 0}function S0a(a,b,c){a=a|0;b=b|0;c=c|0;ga(10);return 0}function T0a(a,b,c){a=a|0;b=b|0;c=c|0;return Cd(a|0,b|0,c|0)|0}function U0a(a,b,c){a=a|0;b=b|0;c=c|0;return lc(a|0,b|0,c|0)|0}function V0a(a,b,c){a=a|0;b=b|0;c=c|0;return Za(a|0,b|0,c|0)|0}function W0a(a,b,c){a=a|0;b=b|0;c=c|0;return Hd(a|0,b|0,c|0)|0}function X0a(a,b,c){a=a|0;b=b|0;c=c|0;return Dd(a|0,b|0,c|0)|0}function Y0a(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;ga(11);return 0}function Z0a(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;ga(12);return 0}function _0a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;ga(13)}function $0a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ga(14)}function a1a(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;ga(15);return 0}function b1a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ga(16)}function c1a(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;ga(17)}function d1a(a,b){a=a|0;b=+b;ga(18);return 0}function e1a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ga(19)}function f1a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;ga(20)}function g1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ga(21)}function h1a(a,b){a=a|0;b=b|0;ga(22);return 0}function i1a(a,b){a=a|0;b=b|0;return Wd(a|0,b|0)|0}function j1a(a,b){a=a|0;b=b|0;return kc(a|0,b|0)|0}function k1a(a,b){a=a|0;b=b|0;return jb(a|0,b|0)|0}function l1a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ga(23);return 0}function m1a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;ga(24);return 0}function n1a(a,b,c){a=a|0;b=+b;c=+c;ga(25);return 0.0}function o1a(a,b){a=a|0;b=b|0;ga(26);return 0.0}function p1a(){ga(27);return 0}function q1a(){return kb()|0}function r1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ga(28);return 0}function s1a(a,b,c){a=a|0;b=b|0;c=c|0;ga(29)}function t1a(){ga(30)}function u1a(){Xc()}function v1a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ga(31);return 0}function w1a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ga(32);return 0}function x1a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return uc(a|0,b|0,c|0,d|0)|0}function y1a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Pc(a|0,b|0,c|0,d|0)|0}function z1a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ga(33)}




// EMSCRIPTEN_END_FUNCS
var he=[A0a,Mya,Oya,Tya,YNa,A0a,A0a,A0a];var ie=[B0a,eta,fta,Kta,Lta,nua,oua,Lua,Mua,Nua,R_a,Q_a,P_a,ixa,ysa,zsa,iwa,gwa,B0a,B0a,B0a,B0a,B0a,B0a,B0a,B0a,B0a,B0a,B0a,B0a,B0a,B0a];var je=[C0a,yAa];var ke=[D0a,yza];var le=[E0a,OA,PA,bT,mT,_3,oT,dwa,KCa,NCa,MCa,OCa,WSa,VSa,YSa,XSa,PCa,RCa,bGa,zGa,AGa,BGa,HSa,GSa,JSa,ISa,iNa,uNa,HNa,INa,JNa,LNa,NNa,DPa,EPa,KPa,LPa,RPa,SPa,YPa,ZPa,jQa,iQa,oQa,nQa,qQa,rQa,AQa,zQa,HRa,GRa,QRa,PRa,sSa,rSa,QSa,PSa,SSa,RSa,iTa,hTa,kTa,jTa,qTa,pTa,FRa,rTa,oTa,sTa,uTa,tTa,CXa,ATa,zTa,FTa,ETa,cUa,bUa,GUa,FUa,UUa,TUa,gVa,fVa,uVa,tVa,HVa,GVa,KVa,JVa,OVa,NVa,ZVa,YVa,iWa,hWa,tWa,sWa,EWa,DWa,OWa,NWa,WWa,VWa,aXa,$Wa,gXa,fXa,lXa,kXa,uXa,tXa,SXa,RXa,pXa,hYa,OYa,NYa,QYa,PYa,vTa,BXa,EXa,$Xa,pYa,AYa,LYa,MYa,C_a,B_a,E_a,H_a,F_a,G_a,I_a,J_a,e$a,d$a,rz,F0a,QA,RA,SA,TA,UA,VA,WA,XA,YA,ZA,_A,$A,aB,bB,cB,dB,eB,fB,gB,hB,iB,jB,kB,lB,mB,nB,oB,pB,qB,rB,sB,tB,uB,vB,wB,xB,yB,zB,AB,BB,CB,DB,EB,FB,GB,HB,IB,JB,KB,LB,MB,NB,OB,PB,QB,RB,SB,TB,UB,VB,WB,XB,YB,ZB,_B,$B,aC,bC,cC,dC,eC,fC,gC,hC,iC,jC,kC,lC,mC,nC,oC,pC,qC,rC,sC,tC,uC,vC,wC,xC,yC,zC,AC,BC,CC,DC,EC,FC,GC,HC,IC,JC,KC,LC,MC,NC,OC,PC,QC,RC,SC,TC,UC,VC,WC,XC,YC,ZC,_C,$C,aD,bD,cD,dD,eD,fD,gD,hD,iD,jD,kD,lD,mD,nD,oD,pD,qD,rD,sD,tD,uD,vD,wD,xD,yD,zD,AD,BD,CD,DD,ED,FD,GD,HD,ID,JD,KD,LD,MD,ND,OD,PD,QD,RD,SD,TD,UD,VD,WD,XD,YD,ZD,_D,$D,aE,bE,cE,dE,eE,fE,gE,hE,iE,jE,kE,lE,mE,nE,oE,pE,qE,rE,sE,tE,uE,vE,wE,xE,yE,zE,AE,BE,CE,DE,EE,FE,GE,HE,IE,JE,KE,LE,ME,NE,OE,PE,QE,RE,SE,TE,UE,VE,WE,XE,YE,ZE,_E,$E,aF,bF,cF,dF,eF,fF,gF,hF,iF,jF,kF,lF,mF,nF,oF,pF,qF,rF,sF,tF,uF,vF,wF,xF,yF,zF,AF,BF,CF,DF,EF,FF,GF,HF,IF,JF,KF,LF,MF,NF,OF,PF,QF,RF,SF,TF,UF,VF,WF,XF,YF,ZF,_F,$F,aG,bG,cG,dG,eG,fG,gG,hG,iG,jG,kG,lG,mG,nG,oG,pG,qG,rG,sG,tG,uG,vG,wG,xG,yG,zG,AG,BG,CG,DG,EG,FG,GG,HG,IG,JG,KG,LG,MG,NG,OG,PG,QG,RG,SG,TG,UG,VG,WG,XG,YG,ZG,_G,$G,aH,bH,cH,dH,eH,fH,gH,hH,iH,jH,kH,lH,mH,nH,oH,pH,qH,rH,sH,tH,uH,vH,wH,xH,yH,zH,AH,BH,CH,DH,EH,FH,GH,HH,IH,JH,KH,LH,MH,NH,OH,PH,QH,RH,SH,TH,UH,VH,WH,XH,YH,ZH,_H,$H,aI,bI,cI,dI,eI,fI,gI,hI,iI,jI,kI,lI,mI,nI,oI,pI,qI,rI,sI,tI,uI,vI,wI,xI,yI,zI,AI,BI,CI,DI,EI,FI,GI,HI,II,JI,KI,LI,MI,NI,OI,PI,QI,RI,SI,TI,UI,VI,WI,XI,YI,ZI,_I,$I,aJ,bJ,cJ,dJ,eJ,fJ,gJ,hJ,iJ,jJ,kJ,lJ,mJ,nJ,oJ,pJ,qJ,rJ,sJ,tJ,uJ,vJ,wJ,xJ,yJ,zJ,AJ,BJ,CJ,DJ,EJ,FJ,GJ,HJ,IJ,JJ,KJ,LJ,MJ,NJ,OJ,PJ,QJ,RJ,SJ,TJ,UJ,VJ,WJ,XJ,YJ,ZJ,_J,$J,aK,bK,cK,dK,eK,fK,gK,hK,iK,jK,kK,lK,mK,nK,oK,pK,qK,rK,sK,tK,uK,vK,wK,xK,yK,zK,AK,BK,CK,DK,EK,FK,GK,HK,IK,JK,KK,LK,MK,NK,OK,PK,QK,RK,SK,TK,UK,VK,WK,XK,YK,ZK,_K,$K,aL,bL,cL,dL,eL,fL,gL,hL,iL,jL,kL,lL,mL,nL,oL,pL,qL,rL,sL,tL,uL,vL,wL,xL,yL,zL,AL,BL,CL,DL,EL,FL,GL,HL,IL,JL,KL,LL,ML,NL,OL,PL,QL,RL,SL,TL,UL,VL,WL,XL,YL,ZL,_L,$L,aM,bM,cM,dM,eM,fM,gM,hM,iM,jM,kM,lM,mM,nM,oM,pM,qM,rM,sM,tM,uM,vM,wM,xM,yM,zM,AM,BM,CM,DM,EM,FM,GM,HM,IM,JM,KM,LM,MM,NM,OM,PM,QM,RM,SM,TM,UM,VM,WM,XM,YM,ZM,_M,$M,aN,bN,cN,dN,eN,fN,gN,hN,iN,jN,kN,lN,mN,nN,oN,pN,qN,rN,sN,tN,uN,vN,wN,xN,yN,zN,AN,BN,CN,DN,EN,FN,GN,HN,IN,JN,KN,LN,MN,NN,ON,PN,QN,RN,SN,TN,UN,VN,WN,XN,YN,ZN,_N,$N,aO,bO,cO,dO,eO,fO,gO,hO,iO,jO,kO,lO,mO,nO,oO,pO,qO,rO,sO,tO,uO,vO,wO,xO,yO,zO,AO,BO,CO,DO,EO,FO,GO,HO,IO,JO,KO,LO,MO,NO,OO,PO,QO,RO,SO,TO,UO,VO,WO,XO,YO,ZO,_O,$O,aP,jf,kf,lf,mf,nf,of,pf,qf,rf,sf,tf,uf,vf,wf,xf,yf,zf,Af,Bf,Cf,Df,Ef,Ff,Gf,Hf,If,Jf,Kf,Lf,Mf,Nf,Of,Pf,Qf,Rf,Sf,Tf,Uf,Vf,Wf,Xf,Yf,Zf,_f,$f,ug,vg,wg,xg,yg,Mg,Ng,Og,Pg,Qg,Rg,Sg,Tg,Ug,kh,lh,mh,nh,oh,Kh,Lh,Mh,Nh,Oh,Ph,Qh,Rh,Sh,Xh,zi,Ai,Di,Hi,Qi,Ri,Yi,Zi,cj,dj,gj,oj,xj,yj,Fj,Gj,Lj,Mj,Pj,Xj,ek,fk,mk,nk,sk,tk,wk,Ek,Nk,Ok,Vk,Wk,$k,al,dl,ll,ul,vl,Cl,Dl,El,Fl,Gl,Hl,Il,Jl,Ll,Nl,Ol,Zl,_l,cm,dm,hm,im,lm,pm,ym,zm,Gm,Hm,Mm,Nm,Qm,Ym,fn,gn,on,pn,un,vn,yn,Gn,Pn,Qn,Xn,Yn,bo,co,go,oo,xo,yo,Fo,Go,Ho,Io,Jo,Ko,Lo,Mo,So,Xo,ip,np,Dp,Op,Pp,$p,aq,kq,nq,vq,Eq,Fq,Uq,Vq,dr,gr,or,xr,yr,Nr,Or,Yr,$r,hs,qs,rs,Gs,Hs,Vs,Ys,et,nt,ot,Et,Ft,Gt,Ht,It,Jt,Pt,Ut,bu,ju,ku,nu,ru,Au,Bu,Iu,Ju,Ou,Pu,Su,_u,hv,iv,pv,qv,vv,wv,zv,Hv,Qv,Rv,Yv,Zv,cw,dw,gw,ow,xw,yw,Fw,Gw,Nw,Ow,Sw,Tw,$w,cx,lx,mx,zx,Ax,Cx,Dx,Ex,Fx,Gx,Hx,Ix,Jx,Kx,Lx,Mx,Nx,Ox,Px,Qx,Rx,Sx,Tx,Ux,Vx,Wx,Xx,Yx,Zx,_x,$x,ay,by,cy,dy,ey,fy,gy,hy,iy,jy,ky,ly,my,ny,oy,py,qy,ry,sy,ty,uy,vy,wy,xy,yy,zy,Ay,By,Cy,Dy,Ey,Fy,Gy,Hy,Iy,Jy,Ky,Ly,My,Ny,Oy,Py,Qy,Ry,Sy,Ty,Uy,Vy,Wy,Xy,Yy,Zy,_y,$y,az,bz,cz,dz,ez,fz,gz,hz,iz,jz,kz,lz,mz,W_a,fwa,df,iza,mza,hza,BAa,oza,zAa,Exa,rza,pza,qza,nza,tza,AAa,uza,jza,wza,dNa,xza,bPa,CPa,DXa,wZa,GWa,DZa,CZa,BZa,AZa,zZa,yZa,QQa,sRa,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a,E0a];var me=[G0a,nT,gBa,SCa,fSa,FPa,MPa,TPa,_Pa,tSa,RVa,SVa,TVa,UVa,WVa,XVa,aWa,bWa,cWa,dWa,fWa,gWa,lWa,mWa,nWa,oWa,qWa,rWa,wWa,xWa,yWa,zWa,BWa,CWa,jXa,oXa,VYa,XYa,ZYa,WYa,YYa,_Ya,$ya,bP,dP,fP,nP,pP,xP,zP,HP,JP,RP,TP,VP,bQ,dQ,lQ,nQ,vQ,xQ,FQ,HQ,PQ,RQ,TQ,$Q,bR,dR,lR,nR,pR,xR,zR,BR,JR,LR,NR,VR,bS,dS,fS,nS,pS,xS,zS,HS,JS,RS,TS,$S,cT,dT,eT,fT,gT,hT,iT,jT,kT,lT,sza,JFa,iBa,hBa,jBa,pBa,BBa,kBa,zBa,YEa,iFa,hFa,jFa,TEa,REa,VEa,kOa,G0a,G0a,G0a,G0a,G0a,G0a,G0a,G0a,G0a,G0a];var ne=[H0a,Nsa,Gsa,Nya,Pya,Qya,Rya,Sya];var oe=[I0a,oz,Pda,nz,ff,gf,hf,$3,V4,uT,Z3,Oda,_oa,tT,rT,$oa,apa,Dqa,Eqa,Fqa,Gqa,Hqa,Iqa,Jqa,Kqa,J0a,K0a,L0a,zwa,V_a,M0a,WCa,kSa,XCa,nSa,jSa,QNa,GPa,ySa,ASa,BSa,xSa,NPa,OPa,UPa,mSa,$Pa,aQa,kQa,pQa,mTa,hVa,$Ya,bZa,dZa,jZa,lZa,fZa,hZa,vVa,aZa,cZa,eZa,kZa,mZa,gZa,iZa,PVa,QVa,VVa,_Va,$Va,eWa,jWa,kWa,pWa,uWa,vWa,AWa,lYa,mYa,oYa,RYa,TYa,SYa,UYa,dYa,eYa,gYa,vYa,wYa,zYa,GYa,HYa,KYa,D_a,f$a,IAa,N0a,O0a,GAa,HAa,P0a,YMa,zNa,Eza,Mza,Yza,Fza,Pza,Zza,uPa,o$a,I0a,I0a,I0a,I0a,I0a,I0a,I0a,I0a,I0a,I0a,I0a,I0a,I0a,I0a,I0a];var pe=[Q0a,gxa];var qe=[R0a,wya];var re=[S0a,qT,Xsa,bta,Bta,Hta,eua,kua,TCa,lSa,pSa,gSa,uSa,zSa,HPa,DSa,VPa,uQa,vQa,yTa,DTa,hXa,mXa,UXa,WXa,ZXa,FXa,KXa,MXa,PXa,K_a,fNa,hxa,Mxa,Ksa,Bsa,Isa,Osa,T0a,U0a,V0a,CAa,cNa,_Ma,W0a,mPa,X0a,S0a,S0a,S0a,S0a,S0a,S0a,S0a,S0a,S0a,S0a,S0a,S0a,S0a,S0a,S0a,S0a,S0a];var se=[Y0a,Aya];var te=[Z0a,Uxa];var ue=[_0a,OUa,RUa,aVa,cVa,_0a,_0a,_0a];var ve=[$0a,IVa,LVa,FWa,JWa,PWa,RWa,$0a];var we=[a1a,uya];var xe=[b1a,awa,UCa,ONa,vSa,hSa,HUa,IUa,MUa,SUa,VUa,WUa,_Ua,dVa,iXa,nXa,U_a,T_a,S_a,bwa,b1a,b1a,b1a,b1a,b1a,b1a,b1a,b1a,b1a,b1a,b1a,b1a];var ye=[c1a,Nza,Oza,c1a];var ze=[d1a,qz];var Ae=[e1a,GTa,ITa,KTa,MTa,OTa,QTa,STa,UTa,WTa,YTa,_Ta,dUa,fUa,hUa,jUa,lUa,nUa,pUa,rUa,tUa,vUa,xUa,LUa,NUa,ZUa,$Ua,iVa,jVa,kVa,lVa,mVa,wVa,xVa,yVa,zVa,AVa,_Wa,eXa,e1a,e1a,e1a,e1a,e1a,e1a,e1a,e1a,e1a,e1a,e1a,e1a,e1a,e1a,e1a,e1a,e1a,e1a,e1a,e1a,e1a,e1a,e1a,e1a,e1a];var Be=[f1a,XWa,bXa,f1a];var Ce=[g1a,nVa,BVa,g1a];var De=[h1a,ef,vT,sT,pT,Lqa,Mqa,Zsa,_sa,ata,Dta,Eta,Gta,gua,hua,jua,pua,qua,rua,sua,tua,uua,vua,wua,YCa,ZCa,RNa,SNa,CSa,IPa,PPa,ESa,oSa,WPa,bQa,qSa,TXa,VXa,XXa,JXa,LXa,NXa,qAa,$za,Rza,Gza,_za,Qza,i1a,Y_a,vsa,wsa,xsa,j1a,Pwa,Uza,Xza,Jza,mAa,dAa,Lza,k1a,n_a,h1a];var Ee=[l1a,wTa,BTa,_Xa,kYa,nYa,QXa,cYa,fYa,uYa,xYa,FYa,IYa,Tua,Kva,Lva,Yua,Vua,Iva,Jva,Zua,_ua,$ua,ava,bva,yva,zva,pva,iva,dva,cva,eva,fva,hva,gva,Wua,Uua,jva,kva,lva,mva,nva,ova,qva,rva,sva,tva,xva,vva,uva,wva,Eva,Ava,Bva,Cva,Dva,Fva,Gva,Hva,Mva,Nva,Ova,Pva,JUa];var Fe=[m1a,NAa];var Ge=[n1a,aAa];var He=[o1a,cya];var Ie=[p1a,Oqa,q1a,Awa,zPa,APa,xPa,p1a];var Je=[r1a,zya];var Ke=[s1a,hNa,tQa,nTa,bxa,lwa,bBa,dBa,IFa,jOa,s1a,s1a,s1a,s1a,s1a,s1a];var Le=[t1a,u1a,ywa,Sva,tz,t1a,t1a,t1a];var Me=[v1a,Nqa,iYa,jYa,aYa,bYa,qYa,sYa,BYa,DYa,eAa,v1a,v1a,v1a,v1a,v1a];var Ne=[w1a,Rsa,Ssa,Tsa,Usa,Vsa,Wsa,Ysa,$sa,dta,vta,wta,xta,yta,zta,Ata,Cta,Fta,Jta,_ta,$ta,aua,bua,cua,dua,fua,iua,mua,YXa,GXa,HXa,IXa,OXa,bza,x1a,vya,nsa,qra,Lra,Ura,Gra,bsa,gsa,esa,hsa,Psa,tsa,Dsa,Esa,Lsa,Msa,aUa,PUa,y1a,w1a,w1a,w1a,w1a,w1a,w1a,w1a,w1a,w1a,w1a];var Oe=[z1a,cta,Ita,lua,VCa,gNa,PNa,wSa,iSa,xTa,CTa,L_a,M_a,N_a,jwa,hwa,dza,Lxa,kwa,cP,eP,gP,oP,qP,yP,AP,IP,KP,SP,UP,WP,cQ,eQ,mQ,oQ,wQ,yQ,GQ,IQ,QQ,SQ,UQ,aR,cR,eR,mR,oR,qR,yR,AR,CR,KR,MR,OR,WR,cS,eS,gS,oS,qS,yS,AS,IS,KS,SS,US,aT,EOa,Fsa,mwa,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a,z1a];return{_testSetjmp:K$a,_saveSetjmp:w$a,_free:W_a,_main:sz,_rand_r:E$a,_realloc:Y_a,_i64Add:H$a,_memmove:A$a,_bitshift64Ashr:y$a,_memset:B$a,_malloc:V_a,_strncpy:I$a,_memcpy:z$a,_strlen:x$a,_bitshift64Lshr:J$a,_bitshift64Shl:C$a,_i64Subtract:G$a,_strcpy:D$a,_calloc:X_a,_rand:F$a,__GLOBAL__I_a:dQa,runPostSets:v$a,stackAlloc:Pe,stackSave:Qe,stackRestore:Re,setThrew:Se,setTempRet0:Ve,setTempRet1:We,setTempRet2:Xe,setTempRet3:Ye,setTempRet4:Ze,setTempRet5:_e,setTempRet6:$e,setTempRet7:af,setTempRet8:bf,setTempRet9:cf,dynCall_iiiiiiii:U$a,dynCall_viiiii:V$a,dynCall_iiiiidiii:W$a,dynCall_vd:X$a,dynCall_vi:Y$a,dynCall_vii:Z$a,dynCall_iiiiiiiiiii:_$a,dynCall_ii:$$a,dynCall_viidi:a0a,dynCall_iiiiiiiiiiiiii:b0a,dynCall_iiii:c0a,dynCall_iiiiiiiiiiiiiiiiiiiiiii:d0a,dynCall_iiiiiiiiiiiiiiiiiiiii:e0a,dynCall_viiiiid:f0a,dynCall_viiiiiiii:g0a,dynCall_iiiiiiiiiiiiiiiiiiiiiiiii:h0a,dynCall_viiiiii:i0a,dynCall_viidii:j0a,dynCall_iid:k0a,dynCall_viiiiiii:l0a,dynCall_viiiiiid:m0a,dynCall_viiiiiiiii:n0a,dynCall_iii:o0a,dynCall_iiiiii:p0a,dynCall_iiiiidi:q0a,dynCall_didd:r0a,dynCall_dii:s0a,dynCall_i:t0a,dynCall_iiiiiiiiii:u0a,dynCall_viii:v0a,dynCall_v:w0a,dynCall_iiiiiiiii:x0a,dynCall_iiiii:y0a,dynCall_viiii:z0a}})


// EMSCRIPTEN_END_ASM
({ "Math": Math, "Int8Array": Int8Array, "Int16Array": Int16Array, "Int32Array": Int32Array, "Uint8Array": Uint8Array, "Uint16Array": Uint16Array, "Uint32Array": Uint32Array, "Float32Array": Float32Array, "Float64Array": Float64Array }, { "abort": abort, "assert": assert, "asmPrintInt": asmPrintInt, "asmPrintFloat": asmPrintFloat, "min": Math_min, "invoke_iiiiiiii": invoke_iiiiiiii, "invoke_viiiii": invoke_viiiii, "invoke_iiiiidiii": invoke_iiiiidiii, "invoke_vd": invoke_vd, "invoke_vi": invoke_vi, "invoke_vii": invoke_vii, "invoke_iiiiiiiiiii": invoke_iiiiiiiiiii, "invoke_ii": invoke_ii, "invoke_viidi": invoke_viidi, "invoke_iiiiiiiiiiiiii": invoke_iiiiiiiiiiiiii, "invoke_iiii": invoke_iiii, "invoke_iiiiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiiiii, "invoke_iiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiii, "invoke_viiiiid": invoke_viiiiid, "invoke_viiiiiiii": invoke_viiiiiiii, "invoke_iiiiiiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiiiiiii, "invoke_viiiiii": invoke_viiiiii, "invoke_viidii": invoke_viidii, "invoke_iid": invoke_iid, "invoke_viiiiiii": invoke_viiiiiii, "invoke_viiiiiid": invoke_viiiiiid, "invoke_viiiiiiiii": invoke_viiiiiiiii, "invoke_iii": invoke_iii, "invoke_iiiiii": invoke_iiiiii, "invoke_iiiiidi": invoke_iiiiidi, "invoke_didd": invoke_didd, "invoke_dii": invoke_dii, "invoke_i": invoke_i, "invoke_iiiiiiiiii": invoke_iiiiiiiiii, "invoke_viii": invoke_viii, "invoke_v": invoke_v, "invoke_iiiiiiiii": invoke_iiiiiiiii, "invoke_iiiii": invoke_iiiii, "invoke_viiii": invoke_viiii, "_fabs": _fabs, "_exp": _exp, "_lis_matrix_assemble": _lis_matrix_assemble, "_strrchr": _strrchr, "_pthread_key_create": _pthread_key_create, "_vsscanf": _vsscanf, "_fscanf": _fscanf, "___cxa_guard_acquire": ___cxa_guard_acquire, "_log10": _log10, "_fstat": _fstat, "_pclose": _pclose, "_lis_solver_create": _lis_solver_create, "___assert_fail": ___assert_fail, "__ZSt18uncaught_exceptionv": __ZSt18uncaught_exceptionv, "_longjmp": _longjmp, "__isLeapYear": __isLeapYear, "_clock_gettime": _clock_gettime, "_fsync": _fsync, "_signal": _signal, "_GC_collect_a_little": _GC_collect_a_little, "_sbrk": _sbrk, "_strtoull": _strtoull, "_emscripten_memcpy_big": _emscripten_memcpy_big, "_sinh": _sinh, "_sysconf": _sysconf, "_close": _close, "_rewind": _rewind, "_cos": _cos, "_fileno": _fileno, "_tanh": _tanh, "_fread": _fread, "_puts": _puts, "_isatty": _isatty, "_lis_matrix_set_value": _lis_matrix_set_value, "_write": _write, "_isblank": _isblank, "_ftell": _ftell, "__ZNSt9exceptionD2Ev": __ZNSt9exceptionD2Ev, "_xerbla_": _xerbla_, "_round": _round, "___cxa_does_inherit": ___cxa_does_inherit, "_strtoll_l": _strtoll_l, "_strstr": _strstr, "___cxa_rethrow": ___cxa_rethrow, "_llvm_lifetime_end": _llvm_lifetime_end, "_catclose": _catclose, "_tmpnam": _tmpnam, "_lis_vector_get_values": _lis_vector_get_values, "_lis_vector_destroy": _lis_vector_destroy, "_lis_solver_set_option": _lis_solver_set_option, "_tmpfile": _tmpfile, "_send": _send, "_pow": _pow, "_lis_matrix_set_size": _lis_matrix_set_size, "___cxa_free_exception": ___cxa_free_exception, "___cxa_find_matching_catch": ___cxa_find_matching_catch, "_isxdigit_l": _isxdigit_l, "___cxa_guard_release": ___cxa_guard_release, "_truncate": _truncate, "_strtol": _strtol, "__reallyNegative": __reallyNegative, "_sin": _sin, "_strtok": _strtok, "___setErrNo": ___setErrNo, "_newlocale": _newlocale, "_isdigit_l": _isdigit_l, "___resumeException": ___resumeException, "_freelocale": _freelocale, "_srand": _srand, "_qsort": _qsort, "_putchar": _putchar, "_floor": _floor, "_pthread_mutex_unlock": _pthread_mutex_unlock, "_printf": _printf, "_sprintf": _sprintf, "_fopen": _fopen, "_vasprintf": _vasprintf, "_emscripten_get_now": _emscripten_get_now, "_stat": _stat, "_lis_solve": _lis_solve, "_strtoull_l": _strtoull_l, "_read": _read, "__addDays": __addDays, "_fwrite": _fwrite, "_time": _time, "_pthread_mutex_lock": _pthread_mutex_lock, "_catopen": _catopen, "_exit": _exit, "_GC_strdup": _GC_strdup, "_freopen": _freopen, "___ctype_b_loc": ___ctype_b_loc, "_fmod": _fmod, "_strtok_r": _strtok_r, "_lseek": _lseek, "_access": _access, "_vfprintf": _vfprintf, "___cxa_allocate_exception": ___cxa_allocate_exception, "_atoi": _atoi, "_strtoll": _strtoll, "_pwrite": _pwrite, "_localtime_r": _localtime_r, "_tzset": _tzset, "_open": _open, "_uselocale": _uselocale, "_snprintf": _snprintf, "___errno_location": ___errno_location, "_GC_malloc": _GC_malloc, "___cxa_end_catch": ___cxa_end_catch, "_perror": _perror, "___cxa_begin_catch": ___cxa_begin_catch, "_strftime": _strftime, "_ftruncate": _ftruncate, "_GC_init": _GC_init, "_lis_matrix_set_type": _lis_matrix_set_type, "_fseek": _fseek, "__ZSt9terminatev": __ZSt9terminatev, "_isxdigit": _isxdigit, "_fclose": _fclose, "_vsnprintf": _vsnprintf, "__parseInt": __parseInt, "_log": _log, "_pthread_cond_broadcast": _pthread_cond_broadcast, "_popen": _popen, "_recv": _recv, "_tan": _tan, "_copysign": _copysign, "__parseInt64": __parseInt64, "__getFloat": __getFloat, "_lis_vector_set_value": _lis_vector_set_value, "_abort": _abort, "_ceil": _ceil, "_isspace": _isspace, "_localtime": _localtime, "_lis_matrix_destroy": _lis_matrix_destroy, "_pthread_getspecific": _pthread_getspecific, "_pthread_cond_wait": _pthread_cond_wait, "_llvm_lifetime_start": _llvm_lifetime_start, "___cxa_is_number_type": ___cxa_is_number_type, "_cosh": _cosh, "_ungetc": _ungetc, "_system": _system, "_fmin": _fmin, "_fmax": _fmax, "_fflush": _fflush, "_strftime_l": _strftime_l, "_fprintf": _fprintf, "_sscanf": _sscanf, "_catgets": _catgets, "_lis_solver_destroy": _lis_solver_destroy, "_strdup": _strdup, "_asprintf": _asprintf, "__exit": __exit, "___ctype_toupper_loc": ___ctype_toupper_loc, "_bsearch": _bsearch, "__arraySum": __arraySum, "__formatString": __formatString, "_htonl": _htonl, "___ctype_tolower_loc": ___ctype_tolower_loc, "_unlink": _unlink, "_fputs": _fputs, "_GC_malloc_atomic": _GC_malloc_atomic, "_pread": _pread, "_lis_vector_set_size": _lis_vector_set_size, "_mkport": _mkport, "__scanString": __scanString, "_pthread_setspecific": _pthread_setspecific, "_fgetc": _fgetc, "_fputc": _fputc, "___cxa_throw": ___cxa_throw, "_lis_matrix_create": _lis_matrix_create, "_isdigit": _isdigit, "_strerror": _strerror, "_emscripten_longjmp": _emscripten_longjmp, "_lis_vector_create": _lis_vector_create, "_atexit": _atexit, "_sqrt": _sqrt, "_strerror_r": _strerror_r, "STACKTOP": STACKTOP, "STACK_MAX": STACK_MAX, "tempDoublePtr": tempDoublePtr, "ABORT": ABORT, "cttz_i8": cttz_i8, "ctlz_i8": ctlz_i8, "___rand_seed": ___rand_seed, "NaN": NaN, "Infinity": Infinity, "__ZTISt9exception": __ZTISt9exception, "___dso_handle": ___dso_handle, "_stderr": _stderr, "_stdin": _stdin, "_stdout": _stdout }, buffer);
var _testSetjmp = Module["_testSetjmp"] = asm["_testSetjmp"];
var _saveSetjmp = Module["_saveSetjmp"] = asm["_saveSetjmp"];
var _free = Module["_free"] = asm["_free"];
var _main = Module["_main"] = asm["_main"];
var _rand_r = Module["_rand_r"] = asm["_rand_r"];
var _realloc = Module["_realloc"] = asm["_realloc"];
var _i64Add = Module["_i64Add"] = asm["_i64Add"];
var _memmove = Module["_memmove"] = asm["_memmove"];
var _bitshift64Ashr = Module["_bitshift64Ashr"] = asm["_bitshift64Ashr"];
var _memset = Module["_memset"] = asm["_memset"];
var _malloc = Module["_malloc"] = asm["_malloc"];
var _strncpy = Module["_strncpy"] = asm["_strncpy"];
var _memcpy = Module["_memcpy"] = asm["_memcpy"];
var _strlen = Module["_strlen"] = asm["_strlen"];
var _bitshift64Lshr = Module["_bitshift64Lshr"] = asm["_bitshift64Lshr"];
var _bitshift64Shl = Module["_bitshift64Shl"] = asm["_bitshift64Shl"];
var _i64Subtract = Module["_i64Subtract"] = asm["_i64Subtract"];
var _strcpy = Module["_strcpy"] = asm["_strcpy"];
var _calloc = Module["_calloc"] = asm["_calloc"];
var _rand = Module["_rand"] = asm["_rand"];
var __GLOBAL__I_a = Module["__GLOBAL__I_a"] = asm["__GLOBAL__I_a"];
var runPostSets = Module["runPostSets"] = asm["runPostSets"];
var dynCall_iiiiiiii = Module["dynCall_iiiiiiii"] = asm["dynCall_iiiiiiii"];
var dynCall_viiiii = Module["dynCall_viiiii"] = asm["dynCall_viiiii"];
var dynCall_iiiiidiii = Module["dynCall_iiiiidiii"] = asm["dynCall_iiiiidiii"];
var dynCall_vd = Module["dynCall_vd"] = asm["dynCall_vd"];
var dynCall_vi = Module["dynCall_vi"] = asm["dynCall_vi"];
var dynCall_vii = Module["dynCall_vii"] = asm["dynCall_vii"];
var dynCall_iiiiiiiiiii = Module["dynCall_iiiiiiiiiii"] = asm["dynCall_iiiiiiiiiii"];
var dynCall_ii = Module["dynCall_ii"] = asm["dynCall_ii"];
var dynCall_viidi = Module["dynCall_viidi"] = asm["dynCall_viidi"];
var dynCall_iiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiii"];
var dynCall_iiii = Module["dynCall_iiii"] = asm["dynCall_iiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiiiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiii"];
var dynCall_viiiiid = Module["dynCall_viiiiid"] = asm["dynCall_viiiiid"];
var dynCall_viiiiiiii = Module["dynCall_viiiiiiii"] = asm["dynCall_viiiiiiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"];
var dynCall_viiiiii = Module["dynCall_viiiiii"] = asm["dynCall_viiiiii"];
var dynCall_viidii = Module["dynCall_viidii"] = asm["dynCall_viidii"];
var dynCall_iid = Module["dynCall_iid"] = asm["dynCall_iid"];
var dynCall_viiiiiii = Module["dynCall_viiiiiii"] = asm["dynCall_viiiiiii"];
var dynCall_viiiiiid = Module["dynCall_viiiiiid"] = asm["dynCall_viiiiiid"];
var dynCall_viiiiiiiii = Module["dynCall_viiiiiiiii"] = asm["dynCall_viiiiiiiii"];
var dynCall_iii = Module["dynCall_iii"] = asm["dynCall_iii"];
var dynCall_iiiiii = Module["dynCall_iiiiii"] = asm["dynCall_iiiiii"];
var dynCall_iiiiidi = Module["dynCall_iiiiidi"] = asm["dynCall_iiiiidi"];
var dynCall_didd = Module["dynCall_didd"] = asm["dynCall_didd"];
var dynCall_dii = Module["dynCall_dii"] = asm["dynCall_dii"];
var dynCall_i = Module["dynCall_i"] = asm["dynCall_i"];
var dynCall_iiiiiiiiii = Module["dynCall_iiiiiiiiii"] = asm["dynCall_iiiiiiiiii"];
var dynCall_viii = Module["dynCall_viii"] = asm["dynCall_viii"];
var dynCall_v = Module["dynCall_v"] = asm["dynCall_v"];
var dynCall_iiiiiiiii = Module["dynCall_iiiiiiiii"] = asm["dynCall_iiiiiiiii"];
var dynCall_iiiii = Module["dynCall_iiiii"] = asm["dynCall_iiiii"];
var dynCall_viiii = Module["dynCall_viiii"] = asm["dynCall_viiii"];

Runtime.stackAlloc = function(size) { return asm['stackAlloc'](size) };
Runtime.stackSave = function() { return asm['stackSave']() };
Runtime.stackRestore = function(top) { asm['stackRestore'](top) };


// TODO: strip out parts of this we do not need

//======= begin closure i64 code =======

// Copyright 2009 The Closure Library Authors. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS-IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/**
 * @fileoverview Defines a Long class for representing a 64-bit two's-complement
 * integer value, which faithfully simulates the behavior of a Java "long". This
 * implementation is derived from LongLib in GWT.
 *
 */

var i64Math = (function() { // Emscripten wrapper
  var goog = { math: {} };


  /**
   * Constructs a 64-bit two's-complement integer, given its low and high 32-bit
   * values as *signed* integers.  See the from* functions below for more
   * convenient ways of constructing Longs.
   *
   * The internal representation of a long is the two given signed, 32-bit values.
   * We use 32-bit pieces because these are the size of integers on which
   * Javascript performs bit-operations.  For operations like addition and
   * multiplication, we split each number into 16-bit pieces, which can easily be
   * multiplied within Javascript's floating-point representation without overflow
   * or change in sign.
   *
   * In the algorithms below, we frequently reduce the negative case to the
   * positive case by negating the input(s) and then post-processing the result.
   * Note that we must ALWAYS check specially whether those values are MIN_VALUE
   * (-2^63) because -MIN_VALUE == MIN_VALUE (since 2^63 cannot be represented as
   * a positive number, it overflows back into a negative).  Not handling this
   * case would often result in infinite recursion.
   *
   * @param {number} low  The low (signed) 32 bits of the long.
   * @param {number} high  The high (signed) 32 bits of the long.
   * @constructor
   */
  goog.math.Long = function(low, high) {
    /**
     * @type {number}
     * @private
     */
    this.low_ = low | 0;  // force into 32 signed bits.

    /**
     * @type {number}
     * @private
     */
    this.high_ = high | 0;  // force into 32 signed bits.
  };


  // NOTE: Common constant values ZERO, ONE, NEG_ONE, etc. are defined below the
  // from* methods on which they depend.


  /**
   * A cache of the Long representations of small integer values.
   * @type {!Object}
   * @private
   */
  goog.math.Long.IntCache_ = {};


  /**
   * Returns a Long representing the given (32-bit) integer value.
   * @param {number} value The 32-bit integer in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromInt = function(value) {
    if (-128 <= value && value < 128) {
      var cachedObj = goog.math.Long.IntCache_[value];
      if (cachedObj) {
        return cachedObj;
      }
    }

    var obj = new goog.math.Long(value | 0, value < 0 ? -1 : 0);
    if (-128 <= value && value < 128) {
      goog.math.Long.IntCache_[value] = obj;
    }
    return obj;
  };


  /**
   * Returns a Long representing the given value, provided that it is a finite
   * number.  Otherwise, zero is returned.
   * @param {number} value The number in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromNumber = function(value) {
    if (isNaN(value) || !isFinite(value)) {
      return goog.math.Long.ZERO;
    } else if (value <= -goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MIN_VALUE;
    } else if (value + 1 >= goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MAX_VALUE;
    } else if (value < 0) {
      return goog.math.Long.fromNumber(-value).negate();
    } else {
      return new goog.math.Long(
          (value % goog.math.Long.TWO_PWR_32_DBL_) | 0,
          (value / goog.math.Long.TWO_PWR_32_DBL_) | 0);
    }
  };


  /**
   * Returns a Long representing the 64-bit integer that comes by concatenating
   * the given high and low bits.  Each is assumed to use 32 bits.
   * @param {number} lowBits The low 32-bits.
   * @param {number} highBits The high 32-bits.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromBits = function(lowBits, highBits) {
    return new goog.math.Long(lowBits, highBits);
  };


  /**
   * Returns a Long representation of the given string, written using the given
   * radix.
   * @param {string} str The textual representation of the Long.
   * @param {number=} opt_radix The radix in which the text is written.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromString = function(str, opt_radix) {
    if (str.length == 0) {
      throw Error('number format error: empty string');
    }

    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (str.charAt(0) == '-') {
      return goog.math.Long.fromString(str.substring(1), radix).negate();
    } else if (str.indexOf('-') >= 0) {
      throw Error('number format error: interior "-" character: ' + str);
    }

    // Do several (8) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 8));

    var result = goog.math.Long.ZERO;
    for (var i = 0; i < str.length; i += 8) {
      var size = Math.min(8, str.length - i);
      var value = parseInt(str.substring(i, i + size), radix);
      if (size < 8) {
        var power = goog.math.Long.fromNumber(Math.pow(radix, size));
        result = result.multiply(power).add(goog.math.Long.fromNumber(value));
      } else {
        result = result.multiply(radixToPower);
        result = result.add(goog.math.Long.fromNumber(value));
      }
    }
    return result;
  };


  // NOTE: the compiler should inline these constant values below and then remove
  // these variables, so there should be no runtime penalty for these.


  /**
   * Number used repeated below in calculations.  This must appear before the
   * first call to any from* function below.
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_16_DBL_ = 1 << 16;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_24_DBL_ = 1 << 24;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_32_DBL_ =
      goog.math.Long.TWO_PWR_16_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_31_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ / 2;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_48_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_64_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_32_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_63_DBL_ =
      goog.math.Long.TWO_PWR_64_DBL_ / 2;


  /** @type {!goog.math.Long} */
  goog.math.Long.ZERO = goog.math.Long.fromInt(0);


  /** @type {!goog.math.Long} */
  goog.math.Long.ONE = goog.math.Long.fromInt(1);


  /** @type {!goog.math.Long} */
  goog.math.Long.NEG_ONE = goog.math.Long.fromInt(-1);


  /** @type {!goog.math.Long} */
  goog.math.Long.MAX_VALUE =
      goog.math.Long.fromBits(0xFFFFFFFF | 0, 0x7FFFFFFF | 0);


  /** @type {!goog.math.Long} */
  goog.math.Long.MIN_VALUE = goog.math.Long.fromBits(0, 0x80000000 | 0);


  /**
   * @type {!goog.math.Long}
   * @private
   */
  goog.math.Long.TWO_PWR_24_ = goog.math.Long.fromInt(1 << 24);


  /** @return {number} The value, assuming it is a 32-bit integer. */
  goog.math.Long.prototype.toInt = function() {
    return this.low_;
  };


  /** @return {number} The closest floating-point representation to this value. */
  goog.math.Long.prototype.toNumber = function() {
    return this.high_ * goog.math.Long.TWO_PWR_32_DBL_ +
           this.getLowBitsUnsigned();
  };


  /**
   * @param {number=} opt_radix The radix in which the text should be written.
   * @return {string} The textual representation of this value.
   */
  goog.math.Long.prototype.toString = function(opt_radix) {
    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (this.isZero()) {
      return '0';
    }

    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        // We need to change the Long value before it can be negated, so we remove
        // the bottom-most digit in this base and then recurse to do the rest.
        var radixLong = goog.math.Long.fromNumber(radix);
        var div = this.div(radixLong);
        var rem = div.multiply(radixLong).subtract(this);
        return div.toString(radix) + rem.toInt().toString(radix);
      } else {
        return '-' + this.negate().toString(radix);
      }
    }

    // Do several (6) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 6));

    var rem = this;
    var result = '';
    while (true) {
      var remDiv = rem.div(radixToPower);
      var intval = rem.subtract(remDiv.multiply(radixToPower)).toInt();
      var digits = intval.toString(radix);

      rem = remDiv;
      if (rem.isZero()) {
        return digits + result;
      } else {
        while (digits.length < 6) {
          digits = '0' + digits;
        }
        result = '' + digits + result;
      }
    }
  };


  /** @return {number} The high 32-bits as a signed value. */
  goog.math.Long.prototype.getHighBits = function() {
    return this.high_;
  };


  /** @return {number} The low 32-bits as a signed value. */
  goog.math.Long.prototype.getLowBits = function() {
    return this.low_;
  };


  /** @return {number} The low 32-bits as an unsigned value. */
  goog.math.Long.prototype.getLowBitsUnsigned = function() {
    return (this.low_ >= 0) ?
        this.low_ : goog.math.Long.TWO_PWR_32_DBL_ + this.low_;
  };


  /**
   * @return {number} Returns the number of bits needed to represent the absolute
   *     value of this Long.
   */
  goog.math.Long.prototype.getNumBitsAbs = function() {
    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        return 64;
      } else {
        return this.negate().getNumBitsAbs();
      }
    } else {
      var val = this.high_ != 0 ? this.high_ : this.low_;
      for (var bit = 31; bit > 0; bit--) {
        if ((val & (1 << bit)) != 0) {
          break;
        }
      }
      return this.high_ != 0 ? bit + 33 : bit + 1;
    }
  };


  /** @return {boolean} Whether this value is zero. */
  goog.math.Long.prototype.isZero = function() {
    return this.high_ == 0 && this.low_ == 0;
  };


  /** @return {boolean} Whether this value is negative. */
  goog.math.Long.prototype.isNegative = function() {
    return this.high_ < 0;
  };


  /** @return {boolean} Whether this value is odd. */
  goog.math.Long.prototype.isOdd = function() {
    return (this.low_ & 1) == 1;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long equals the other.
   */
  goog.math.Long.prototype.equals = function(other) {
    return (this.high_ == other.high_) && (this.low_ == other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long does not equal the other.
   */
  goog.math.Long.prototype.notEquals = function(other) {
    return (this.high_ != other.high_) || (this.low_ != other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than the other.
   */
  goog.math.Long.prototype.lessThan = function(other) {
    return this.compare(other) < 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than or equal to the other.
   */
  goog.math.Long.prototype.lessThanOrEqual = function(other) {
    return this.compare(other) <= 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than the other.
   */
  goog.math.Long.prototype.greaterThan = function(other) {
    return this.compare(other) > 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than or equal to the other.
   */
  goog.math.Long.prototype.greaterThanOrEqual = function(other) {
    return this.compare(other) >= 0;
  };


  /**
   * Compares this Long with the given one.
   * @param {goog.math.Long} other Long to compare against.
   * @return {number} 0 if they are the same, 1 if the this is greater, and -1
   *     if the given one is greater.
   */
  goog.math.Long.prototype.compare = function(other) {
    if (this.equals(other)) {
      return 0;
    }

    var thisNeg = this.isNegative();
    var otherNeg = other.isNegative();
    if (thisNeg && !otherNeg) {
      return -1;
    }
    if (!thisNeg && otherNeg) {
      return 1;
    }

    // at this point, the signs are the same, so subtraction will not overflow
    if (this.subtract(other).isNegative()) {
      return -1;
    } else {
      return 1;
    }
  };


  /** @return {!goog.math.Long} The negation of this value. */
  goog.math.Long.prototype.negate = function() {
    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.MIN_VALUE;
    } else {
      return this.not().add(goog.math.Long.ONE);
    }
  };


  /**
   * Returns the sum of this and the given Long.
   * @param {goog.math.Long} other Long to add to this one.
   * @return {!goog.math.Long} The sum of this and the given Long.
   */
  goog.math.Long.prototype.add = function(other) {
    // Divide each number into 4 chunks of 16 bits, and then sum the chunks.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 + b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 + b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 + b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 + b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns the difference of this and the given Long.
   * @param {goog.math.Long} other Long to subtract from this.
   * @return {!goog.math.Long} The difference of this and the given Long.
   */
  goog.math.Long.prototype.subtract = function(other) {
    return this.add(other.negate());
  };


  /**
   * Returns the product of this and the given long.
   * @param {goog.math.Long} other Long to multiply with this.
   * @return {!goog.math.Long} The product of this and the other.
   */
  goog.math.Long.prototype.multiply = function(other) {
    if (this.isZero()) {
      return goog.math.Long.ZERO;
    } else if (other.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return other.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return this.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().multiply(other.negate());
      } else {
        return this.negate().multiply(other).negate();
      }
    } else if (other.isNegative()) {
      return this.multiply(other.negate()).negate();
    }

    // If both longs are small, use float multiplication
    if (this.lessThan(goog.math.Long.TWO_PWR_24_) &&
        other.lessThan(goog.math.Long.TWO_PWR_24_)) {
      return goog.math.Long.fromNumber(this.toNumber() * other.toNumber());
    }

    // Divide each long into 4 chunks of 16 bits, and then add up 4x4 products.
    // We can skip products that would overflow.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 * b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 * b00;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c16 += a00 * b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 * b00;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a16 * b16;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a00 * b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 * b00 + a32 * b16 + a16 * b32 + a00 * b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns this Long divided by the given one.
   * @param {goog.math.Long} other Long by which to divide.
   * @return {!goog.math.Long} This Long divided by the given one.
   */
  goog.math.Long.prototype.div = function(other) {
    if (other.isZero()) {
      throw Error('division by zero');
    } else if (this.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      if (other.equals(goog.math.Long.ONE) ||
          other.equals(goog.math.Long.NEG_ONE)) {
        return goog.math.Long.MIN_VALUE;  // recall that -MIN_VALUE == MIN_VALUE
      } else if (other.equals(goog.math.Long.MIN_VALUE)) {
        return goog.math.Long.ONE;
      } else {
        // At this point, we have |other| >= 2, so |this/other| < |MIN_VALUE|.
        var halfThis = this.shiftRight(1);
        var approx = halfThis.div(other).shiftLeft(1);
        if (approx.equals(goog.math.Long.ZERO)) {
          return other.isNegative() ? goog.math.Long.ONE : goog.math.Long.NEG_ONE;
        } else {
          var rem = this.subtract(other.multiply(approx));
          var result = approx.add(rem.div(other));
          return result;
        }
      }
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().div(other.negate());
      } else {
        return this.negate().div(other).negate();
      }
    } else if (other.isNegative()) {
      return this.div(other.negate()).negate();
    }

    // Repeat the following until the remainder is less than other:  find a
    // floating-point that approximates remainder / other *from below*, add this
    // into the result, and subtract it from the remainder.  It is critical that
    // the approximate value is less than or equal to the real value so that the
    // remainder never becomes negative.
    var res = goog.math.Long.ZERO;
    var rem = this;
    while (rem.greaterThanOrEqual(other)) {
      // Approximate the result of division. This may be a little greater or
      // smaller than the actual value.
      var approx = Math.max(1, Math.floor(rem.toNumber() / other.toNumber()));

      // We will tweak the approximate result by changing it in the 48-th digit or
      // the smallest non-fractional digit, whichever is larger.
      var log2 = Math.ceil(Math.log(approx) / Math.LN2);
      var delta = (log2 <= 48) ? 1 : Math.pow(2, log2 - 48);

      // Decrease the approximation until it is smaller than the remainder.  Note
      // that if it is too large, the product overflows and is negative.
      var approxRes = goog.math.Long.fromNumber(approx);
      var approxRem = approxRes.multiply(other);
      while (approxRem.isNegative() || approxRem.greaterThan(rem)) {
        approx -= delta;
        approxRes = goog.math.Long.fromNumber(approx);
        approxRem = approxRes.multiply(other);
      }

      // We know the answer can't be zero... and actually, zero would cause
      // infinite recursion since we would make no progress.
      if (approxRes.isZero()) {
        approxRes = goog.math.Long.ONE;
      }

      res = res.add(approxRes);
      rem = rem.subtract(approxRem);
    }
    return res;
  };


  /**
   * Returns this Long modulo the given one.
   * @param {goog.math.Long} other Long by which to mod.
   * @return {!goog.math.Long} This Long modulo the given one.
   */
  goog.math.Long.prototype.modulo = function(other) {
    return this.subtract(this.div(other).multiply(other));
  };


  /** @return {!goog.math.Long} The bitwise-NOT of this value. */
  goog.math.Long.prototype.not = function() {
    return goog.math.Long.fromBits(~this.low_, ~this.high_);
  };


  /**
   * Returns the bitwise-AND of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to AND.
   * @return {!goog.math.Long} The bitwise-AND of this and the other.
   */
  goog.math.Long.prototype.and = function(other) {
    return goog.math.Long.fromBits(this.low_ & other.low_,
                                   this.high_ & other.high_);
  };


  /**
   * Returns the bitwise-OR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to OR.
   * @return {!goog.math.Long} The bitwise-OR of this and the other.
   */
  goog.math.Long.prototype.or = function(other) {
    return goog.math.Long.fromBits(this.low_ | other.low_,
                                   this.high_ | other.high_);
  };


  /**
   * Returns the bitwise-XOR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to XOR.
   * @return {!goog.math.Long} The bitwise-XOR of this and the other.
   */
  goog.math.Long.prototype.xor = function(other) {
    return goog.math.Long.fromBits(this.low_ ^ other.low_,
                                   this.high_ ^ other.high_);
  };


  /**
   * Returns this Long with bits shifted to the left by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the left by the given amount.
   */
  goog.math.Long.prototype.shiftLeft = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var low = this.low_;
      if (numBits < 32) {
        var high = this.high_;
        return goog.math.Long.fromBits(
            low << numBits,
            (high << numBits) | (low >>> (32 - numBits)));
      } else {
        return goog.math.Long.fromBits(0, low << (numBits - 32));
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount.
   */
  goog.math.Long.prototype.shiftRight = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >> numBits);
      } else {
        return goog.math.Long.fromBits(
            high >> (numBits - 32),
            high >= 0 ? 0 : -1);
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount, with
   * the new top bits matching the current sign bit.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount, with
   *     zeros placed into the new leading bits.
   */
  goog.math.Long.prototype.shiftRightUnsigned = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >>> numBits);
      } else if (numBits == 32) {
        return goog.math.Long.fromBits(high, 0);
      } else {
        return goog.math.Long.fromBits(high >>> (numBits - 32), 0);
      }
    }
  };

  //======= begin jsbn =======

  var navigator = { appName: 'Modern Browser' }; // polyfill a little

  // Copyright (c) 2005  Tom Wu
  // All Rights Reserved.
  // http://www-cs-students.stanford.edu/~tjw/jsbn/

  /*
   * Copyright (c) 2003-2005  Tom Wu
   * All Rights Reserved.
   *
   * Permission is hereby granted, free of charge, to any person obtaining
   * a copy of this software and associated documentation files (the
   * "Software"), to deal in the Software without restriction, including
   * without limitation the rights to use, copy, modify, merge, publish,
   * distribute, sublicense, and/or sell copies of the Software, and to
   * permit persons to whom the Software is furnished to do so, subject to
   * the following conditions:
   *
   * The above copyright notice and this permission notice shall be
   * included in all copies or substantial portions of the Software.
   *
   * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
   * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
   * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
   *
   * IN NO EVENT SHALL TOM WU BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
   * INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
   * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF
   * THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT
   * OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   *
   * In addition, the following condition applies:
   *
   * All redistributions must retain an intact copy of this copyright notice
   * and disclaimer.
   */

  // Basic JavaScript BN library - subset useful for RSA encryption.

  // Bits per digit
  var dbits;

  // JavaScript engine analysis
  var canary = 0xdeadbeefcafe;
  var j_lm = ((canary&0xffffff)==0xefcafe);

  // (public) Constructor
  function BigInteger(a,b,c) {
    if(a != null)
      if("number" == typeof a) this.fromNumber(a,b,c);
      else if(b == null && "string" != typeof a) this.fromString(a,256);
      else this.fromString(a,b);
  }

  // return new, unset BigInteger
  function nbi() { return new BigInteger(null); }

  // am: Compute w_j += (x*this_i), propagate carries,
  // c is initial carry, returns final carry.
  // c < 3*dvalue, x < 2*dvalue, this_i < dvalue
  // We need to select the fastest one that works in this environment.

  // am1: use a single mult and divide to get the high bits,
  // max digit bits should be 26 because
  // max internal value = 2*dvalue^2-2*dvalue (< 2^53)
  function am1(i,x,w,j,c,n) {
    while(--n >= 0) {
      var v = x*this[i++]+w[j]+c;
      c = Math.floor(v/0x4000000);
      w[j++] = v&0x3ffffff;
    }
    return c;
  }
  // am2 avoids a big mult-and-extract completely.
  // Max digit bits should be <= 30 because we do bitwise ops
  // on values up to 2*hdvalue^2-hdvalue-1 (< 2^31)
  function am2(i,x,w,j,c,n) {
    var xl = x&0x7fff, xh = x>>15;
    while(--n >= 0) {
      var l = this[i]&0x7fff;
      var h = this[i++]>>15;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x7fff)<<15)+w[j]+(c&0x3fffffff);
      c = (l>>>30)+(m>>>15)+xh*h+(c>>>30);
      w[j++] = l&0x3fffffff;
    }
    return c;
  }
  // Alternately, set max digit bits to 28 since some
  // browsers slow down when dealing with 32-bit numbers.
  function am3(i,x,w,j,c,n) {
    var xl = x&0x3fff, xh = x>>14;
    while(--n >= 0) {
      var l = this[i]&0x3fff;
      var h = this[i++]>>14;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x3fff)<<14)+w[j]+c;
      c = (l>>28)+(m>>14)+xh*h;
      w[j++] = l&0xfffffff;
    }
    return c;
  }
  if(j_lm && (navigator.appName == "Microsoft Internet Explorer")) {
    BigInteger.prototype.am = am2;
    dbits = 30;
  }
  else if(j_lm && (navigator.appName != "Netscape")) {
    BigInteger.prototype.am = am1;
    dbits = 26;
  }
  else { // Mozilla/Netscape seems to prefer am3
    BigInteger.prototype.am = am3;
    dbits = 28;
  }

  BigInteger.prototype.DB = dbits;
  BigInteger.prototype.DM = ((1<<dbits)-1);
  BigInteger.prototype.DV = (1<<dbits);

  var BI_FP = 52;
  BigInteger.prototype.FV = Math.pow(2,BI_FP);
  BigInteger.prototype.F1 = BI_FP-dbits;
  BigInteger.prototype.F2 = 2*dbits-BI_FP;

  // Digit conversions
  var BI_RM = "0123456789abcdefghijklmnopqrstuvwxyz";
  var BI_RC = new Array();
  var rr,vv;
  rr = "0".charCodeAt(0);
  for(vv = 0; vv <= 9; ++vv) BI_RC[rr++] = vv;
  rr = "a".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;
  rr = "A".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;

  function int2char(n) { return BI_RM.charAt(n); }
  function intAt(s,i) {
    var c = BI_RC[s.charCodeAt(i)];
    return (c==null)?-1:c;
  }

  // (protected) copy this to r
  function bnpCopyTo(r) {
    for(var i = this.t-1; i >= 0; --i) r[i] = this[i];
    r.t = this.t;
    r.s = this.s;
  }

  // (protected) set from integer value x, -DV <= x < DV
  function bnpFromInt(x) {
    this.t = 1;
    this.s = (x<0)?-1:0;
    if(x > 0) this[0] = x;
    else if(x < -1) this[0] = x+DV;
    else this.t = 0;
  }

  // return bigint initialized to value
  function nbv(i) { var r = nbi(); r.fromInt(i); return r; }

  // (protected) set from string and radix
  function bnpFromString(s,b) {
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 256) k = 8; // byte array
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else { this.fromRadix(s,b); return; }
    this.t = 0;
    this.s = 0;
    var i = s.length, mi = false, sh = 0;
    while(--i >= 0) {
      var x = (k==8)?s[i]&0xff:intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-") mi = true;
        continue;
      }
      mi = false;
      if(sh == 0)
        this[this.t++] = x;
      else if(sh+k > this.DB) {
        this[this.t-1] |= (x&((1<<(this.DB-sh))-1))<<sh;
        this[this.t++] = (x>>(this.DB-sh));
      }
      else
        this[this.t-1] |= x<<sh;
      sh += k;
      if(sh >= this.DB) sh -= this.DB;
    }
    if(k == 8 && (s[0]&0x80) != 0) {
      this.s = -1;
      if(sh > 0) this[this.t-1] |= ((1<<(this.DB-sh))-1)<<sh;
    }
    this.clamp();
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) clamp off excess high words
  function bnpClamp() {
    var c = this.s&this.DM;
    while(this.t > 0 && this[this.t-1] == c) --this.t;
  }

  // (public) return string representation in given radix
  function bnToString(b) {
    if(this.s < 0) return "-"+this.negate().toString(b);
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else return this.toRadix(b);
    var km = (1<<k)-1, d, m = false, r = "", i = this.t;
    var p = this.DB-(i*this.DB)%k;
    if(i-- > 0) {
      if(p < this.DB && (d = this[i]>>p) > 0) { m = true; r = int2char(d); }
      while(i >= 0) {
        if(p < k) {
          d = (this[i]&((1<<p)-1))<<(k-p);
          d |= this[--i]>>(p+=this.DB-k);
        }
        else {
          d = (this[i]>>(p-=k))&km;
          if(p <= 0) { p += this.DB; --i; }
        }
        if(d > 0) m = true;
        if(m) r += int2char(d);
      }
    }
    return m?r:"0";
  }

  // (public) -this
  function bnNegate() { var r = nbi(); BigInteger.ZERO.subTo(this,r); return r; }

  // (public) |this|
  function bnAbs() { return (this.s<0)?this.negate():this; }

  // (public) return + if this > a, - if this < a, 0 if equal
  function bnCompareTo(a) {
    var r = this.s-a.s;
    if(r != 0) return r;
    var i = this.t;
    r = i-a.t;
    if(r != 0) return (this.s<0)?-r:r;
    while(--i >= 0) if((r=this[i]-a[i]) != 0) return r;
    return 0;
  }

  // returns bit length of the integer x
  function nbits(x) {
    var r = 1, t;
    if((t=x>>>16) != 0) { x = t; r += 16; }
    if((t=x>>8) != 0) { x = t; r += 8; }
    if((t=x>>4) != 0) { x = t; r += 4; }
    if((t=x>>2) != 0) { x = t; r += 2; }
    if((t=x>>1) != 0) { x = t; r += 1; }
    return r;
  }

  // (public) return the number of bits in "this"
  function bnBitLength() {
    if(this.t <= 0) return 0;
    return this.DB*(this.t-1)+nbits(this[this.t-1]^(this.s&this.DM));
  }

  // (protected) r = this << n*DB
  function bnpDLShiftTo(n,r) {
    var i;
    for(i = this.t-1; i >= 0; --i) r[i+n] = this[i];
    for(i = n-1; i >= 0; --i) r[i] = 0;
    r.t = this.t+n;
    r.s = this.s;
  }

  // (protected) r = this >> n*DB
  function bnpDRShiftTo(n,r) {
    for(var i = n; i < this.t; ++i) r[i-n] = this[i];
    r.t = Math.max(this.t-n,0);
    r.s = this.s;
  }

  // (protected) r = this << n
  function bnpLShiftTo(n,r) {
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<cbs)-1;
    var ds = Math.floor(n/this.DB), c = (this.s<<bs)&this.DM, i;
    for(i = this.t-1; i >= 0; --i) {
      r[i+ds+1] = (this[i]>>cbs)|c;
      c = (this[i]&bm)<<bs;
    }
    for(i = ds-1; i >= 0; --i) r[i] = 0;
    r[ds] = c;
    r.t = this.t+ds+1;
    r.s = this.s;
    r.clamp();
  }

  // (protected) r = this >> n
  function bnpRShiftTo(n,r) {
    r.s = this.s;
    var ds = Math.floor(n/this.DB);
    if(ds >= this.t) { r.t = 0; return; }
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<bs)-1;
    r[0] = this[ds]>>bs;
    for(var i = ds+1; i < this.t; ++i) {
      r[i-ds-1] |= (this[i]&bm)<<cbs;
      r[i-ds] = this[i]>>bs;
    }
    if(bs > 0) r[this.t-ds-1] |= (this.s&bm)<<cbs;
    r.t = this.t-ds;
    r.clamp();
  }

  // (protected) r = this - a
  function bnpSubTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]-a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c -= a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c -= a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c -= a.s;
    }
    r.s = (c<0)?-1:0;
    if(c < -1) r[i++] = this.DV+c;
    else if(c > 0) r[i++] = c;
    r.t = i;
    r.clamp();
  }

  // (protected) r = this * a, r != this,a (HAC 14.12)
  // "this" should be the larger one if appropriate.
  function bnpMultiplyTo(a,r) {
    var x = this.abs(), y = a.abs();
    var i = x.t;
    r.t = i+y.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < y.t; ++i) r[i+x.t] = x.am(0,y[i],r,i,0,x.t);
    r.s = 0;
    r.clamp();
    if(this.s != a.s) BigInteger.ZERO.subTo(r,r);
  }

  // (protected) r = this^2, r != this (HAC 14.16)
  function bnpSquareTo(r) {
    var x = this.abs();
    var i = r.t = 2*x.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < x.t-1; ++i) {
      var c = x.am(i,x[i],r,2*i,0,1);
      if((r[i+x.t]+=x.am(i+1,2*x[i],r,2*i+1,c,x.t-i-1)) >= x.DV) {
        r[i+x.t] -= x.DV;
        r[i+x.t+1] = 1;
      }
    }
    if(r.t > 0) r[r.t-1] += x.am(i,x[i],r,2*i,0,1);
    r.s = 0;
    r.clamp();
  }

  // (protected) divide this by m, quotient and remainder to q, r (HAC 14.20)
  // r != q, this != m.  q or r may be null.
  function bnpDivRemTo(m,q,r) {
    var pm = m.abs();
    if(pm.t <= 0) return;
    var pt = this.abs();
    if(pt.t < pm.t) {
      if(q != null) q.fromInt(0);
      if(r != null) this.copyTo(r);
      return;
    }
    if(r == null) r = nbi();
    var y = nbi(), ts = this.s, ms = m.s;
    var nsh = this.DB-nbits(pm[pm.t-1]);	// normalize modulus
    if(nsh > 0) { pm.lShiftTo(nsh,y); pt.lShiftTo(nsh,r); }
    else { pm.copyTo(y); pt.copyTo(r); }
    var ys = y.t;
    var y0 = y[ys-1];
    if(y0 == 0) return;
    var yt = y0*(1<<this.F1)+((ys>1)?y[ys-2]>>this.F2:0);
    var d1 = this.FV/yt, d2 = (1<<this.F1)/yt, e = 1<<this.F2;
    var i = r.t, j = i-ys, t = (q==null)?nbi():q;
    y.dlShiftTo(j,t);
    if(r.compareTo(t) >= 0) {
      r[r.t++] = 1;
      r.subTo(t,r);
    }
    BigInteger.ONE.dlShiftTo(ys,t);
    t.subTo(y,y);	// "negative" y so we can replace sub with am later
    while(y.t < ys) y[y.t++] = 0;
    while(--j >= 0) {
      // Estimate quotient digit
      var qd = (r[--i]==y0)?this.DM:Math.floor(r[i]*d1+(r[i-1]+e)*d2);
      if((r[i]+=y.am(0,qd,r,j,0,ys)) < qd) {	// Try it out
        y.dlShiftTo(j,t);
        r.subTo(t,r);
        while(r[i] < --qd) r.subTo(t,r);
      }
    }
    if(q != null) {
      r.drShiftTo(ys,q);
      if(ts != ms) BigInteger.ZERO.subTo(q,q);
    }
    r.t = ys;
    r.clamp();
    if(nsh > 0) r.rShiftTo(nsh,r);	// Denormalize remainder
    if(ts < 0) BigInteger.ZERO.subTo(r,r);
  }

  // (public) this mod a
  function bnMod(a) {
    var r = nbi();
    this.abs().divRemTo(a,null,r);
    if(this.s < 0 && r.compareTo(BigInteger.ZERO) > 0) a.subTo(r,r);
    return r;
  }

  // Modular reduction using "classic" algorithm
  function Classic(m) { this.m = m; }
  function cConvert(x) {
    if(x.s < 0 || x.compareTo(this.m) >= 0) return x.mod(this.m);
    else return x;
  }
  function cRevert(x) { return x; }
  function cReduce(x) { x.divRemTo(this.m,null,x); }
  function cMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }
  function cSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  Classic.prototype.convert = cConvert;
  Classic.prototype.revert = cRevert;
  Classic.prototype.reduce = cReduce;
  Classic.prototype.mulTo = cMulTo;
  Classic.prototype.sqrTo = cSqrTo;

  // (protected) return "-1/this % 2^DB"; useful for Mont. reduction
  // justification:
  //         xy == 1 (mod m)
  //         xy =  1+km
  //   xy(2-xy) = (1+km)(1-km)
  // x[y(2-xy)] = 1-k^2m^2
  // x[y(2-xy)] == 1 (mod m^2)
  // if y is 1/x mod m, then y(2-xy) is 1/x mod m^2
  // should reduce x and y(2-xy) by m^2 at each step to keep size bounded.
  // JS multiply "overflows" differently from C/C++, so care is needed here.
  function bnpInvDigit() {
    if(this.t < 1) return 0;
    var x = this[0];
    if((x&1) == 0) return 0;
    var y = x&3;		// y == 1/x mod 2^2
    y = (y*(2-(x&0xf)*y))&0xf;	// y == 1/x mod 2^4
    y = (y*(2-(x&0xff)*y))&0xff;	// y == 1/x mod 2^8
    y = (y*(2-(((x&0xffff)*y)&0xffff)))&0xffff;	// y == 1/x mod 2^16
    // last step - calculate inverse mod DV directly;
    // assumes 16 < DB <= 32 and assumes ability to handle 48-bit ints
    y = (y*(2-x*y%this.DV))%this.DV;		// y == 1/x mod 2^dbits
    // we really want the negative inverse, and -DV < y < DV
    return (y>0)?this.DV-y:-y;
  }

  // Montgomery reduction
  function Montgomery(m) {
    this.m = m;
    this.mp = m.invDigit();
    this.mpl = this.mp&0x7fff;
    this.mph = this.mp>>15;
    this.um = (1<<(m.DB-15))-1;
    this.mt2 = 2*m.t;
  }

  // xR mod m
  function montConvert(x) {
    var r = nbi();
    x.abs().dlShiftTo(this.m.t,r);
    r.divRemTo(this.m,null,r);
    if(x.s < 0 && r.compareTo(BigInteger.ZERO) > 0) this.m.subTo(r,r);
    return r;
  }

  // x/R mod m
  function montRevert(x) {
    var r = nbi();
    x.copyTo(r);
    this.reduce(r);
    return r;
  }

  // x = x/R mod m (HAC 14.32)
  function montReduce(x) {
    while(x.t <= this.mt2)	// pad x so am has enough room later
      x[x.t++] = 0;
    for(var i = 0; i < this.m.t; ++i) {
      // faster way of calculating u0 = x[i]*mp mod DV
      var j = x[i]&0x7fff;
      var u0 = (j*this.mpl+(((j*this.mph+(x[i]>>15)*this.mpl)&this.um)<<15))&x.DM;
      // use am to combine the multiply-shift-add into one call
      j = i+this.m.t;
      x[j] += this.m.am(0,u0,x,i,0,this.m.t);
      // propagate carry
      while(x[j] >= x.DV) { x[j] -= x.DV; x[++j]++; }
    }
    x.clamp();
    x.drShiftTo(this.m.t,x);
    if(x.compareTo(this.m) >= 0) x.subTo(this.m,x);
  }

  // r = "x^2/R mod m"; x != r
  function montSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  // r = "xy/R mod m"; x,y != r
  function montMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }

  Montgomery.prototype.convert = montConvert;
  Montgomery.prototype.revert = montRevert;
  Montgomery.prototype.reduce = montReduce;
  Montgomery.prototype.mulTo = montMulTo;
  Montgomery.prototype.sqrTo = montSqrTo;

  // (protected) true iff this is even
  function bnpIsEven() { return ((this.t>0)?(this[0]&1):this.s) == 0; }

  // (protected) this^e, e < 2^32, doing sqr and mul with "r" (HAC 14.79)
  function bnpExp(e,z) {
    if(e > 0xffffffff || e < 1) return BigInteger.ONE;
    var r = nbi(), r2 = nbi(), g = z.convert(this), i = nbits(e)-1;
    g.copyTo(r);
    while(--i >= 0) {
      z.sqrTo(r,r2);
      if((e&(1<<i)) > 0) z.mulTo(r2,g,r);
      else { var t = r; r = r2; r2 = t; }
    }
    return z.revert(r);
  }

  // (public) this^e % m, 0 <= e < 2^32
  function bnModPowInt(e,m) {
    var z;
    if(e < 256 || m.isEven()) z = new Classic(m); else z = new Montgomery(m);
    return this.exp(e,z);
  }

  // protected
  BigInteger.prototype.copyTo = bnpCopyTo;
  BigInteger.prototype.fromInt = bnpFromInt;
  BigInteger.prototype.fromString = bnpFromString;
  BigInteger.prototype.clamp = bnpClamp;
  BigInteger.prototype.dlShiftTo = bnpDLShiftTo;
  BigInteger.prototype.drShiftTo = bnpDRShiftTo;
  BigInteger.prototype.lShiftTo = bnpLShiftTo;
  BigInteger.prototype.rShiftTo = bnpRShiftTo;
  BigInteger.prototype.subTo = bnpSubTo;
  BigInteger.prototype.multiplyTo = bnpMultiplyTo;
  BigInteger.prototype.squareTo = bnpSquareTo;
  BigInteger.prototype.divRemTo = bnpDivRemTo;
  BigInteger.prototype.invDigit = bnpInvDigit;
  BigInteger.prototype.isEven = bnpIsEven;
  BigInteger.prototype.exp = bnpExp;

  // public
  BigInteger.prototype.toString = bnToString;
  BigInteger.prototype.negate = bnNegate;
  BigInteger.prototype.abs = bnAbs;
  BigInteger.prototype.compareTo = bnCompareTo;
  BigInteger.prototype.bitLength = bnBitLength;
  BigInteger.prototype.mod = bnMod;
  BigInteger.prototype.modPowInt = bnModPowInt;

  // "constants"
  BigInteger.ZERO = nbv(0);
  BigInteger.ONE = nbv(1);

  // jsbn2 stuff

  // (protected) convert from radix string
  function bnpFromRadix(s,b) {
    this.fromInt(0);
    if(b == null) b = 10;
    var cs = this.chunkSize(b);
    var d = Math.pow(b,cs), mi = false, j = 0, w = 0;
    for(var i = 0; i < s.length; ++i) {
      var x = intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-" && this.signum() == 0) mi = true;
        continue;
      }
      w = b*w+x;
      if(++j >= cs) {
        this.dMultiply(d);
        this.dAddOffset(w,0);
        j = 0;
        w = 0;
      }
    }
    if(j > 0) {
      this.dMultiply(Math.pow(b,j));
      this.dAddOffset(w,0);
    }
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) return x s.t. r^x < DV
  function bnpChunkSize(r) { return Math.floor(Math.LN2*this.DB/Math.log(r)); }

  // (public) 0 if this == 0, 1 if this > 0
  function bnSigNum() {
    if(this.s < 0) return -1;
    else if(this.t <= 0 || (this.t == 1 && this[0] <= 0)) return 0;
    else return 1;
  }

  // (protected) this *= n, this >= 0, 1 < n < DV
  function bnpDMultiply(n) {
    this[this.t] = this.am(0,n-1,this,0,0,this.t);
    ++this.t;
    this.clamp();
  }

  // (protected) this += n << w words, this >= 0
  function bnpDAddOffset(n,w) {
    if(n == 0) return;
    while(this.t <= w) this[this.t++] = 0;
    this[w] += n;
    while(this[w] >= this.DV) {
      this[w] -= this.DV;
      if(++w >= this.t) this[this.t++] = 0;
      ++this[w];
    }
  }

  // (protected) convert to radix string
  function bnpToRadix(b) {
    if(b == null) b = 10;
    if(this.signum() == 0 || b < 2 || b > 36) return "0";
    var cs = this.chunkSize(b);
    var a = Math.pow(b,cs);
    var d = nbv(a), y = nbi(), z = nbi(), r = "";
    this.divRemTo(d,y,z);
    while(y.signum() > 0) {
      r = (a+z.intValue()).toString(b).substr(1) + r;
      y.divRemTo(d,y,z);
    }
    return z.intValue().toString(b) + r;
  }

  // (public) return value as integer
  function bnIntValue() {
    if(this.s < 0) {
      if(this.t == 1) return this[0]-this.DV;
      else if(this.t == 0) return -1;
    }
    else if(this.t == 1) return this[0];
    else if(this.t == 0) return 0;
    // assumes 16 < DB < 32
    return ((this[1]&((1<<(32-this.DB))-1))<<this.DB)|this[0];
  }

  // (protected) r = this + a
  function bnpAddTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]+a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c += a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c += a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += a.s;
    }
    r.s = (c<0)?-1:0;
    if(c > 0) r[i++] = c;
    else if(c < -1) r[i++] = this.DV+c;
    r.t = i;
    r.clamp();
  }

  BigInteger.prototype.fromRadix = bnpFromRadix;
  BigInteger.prototype.chunkSize = bnpChunkSize;
  BigInteger.prototype.signum = bnSigNum;
  BigInteger.prototype.dMultiply = bnpDMultiply;
  BigInteger.prototype.dAddOffset = bnpDAddOffset;
  BigInteger.prototype.toRadix = bnpToRadix;
  BigInteger.prototype.intValue = bnIntValue;
  BigInteger.prototype.addTo = bnpAddTo;

  //======= end jsbn =======

  // Emscripten wrapper
  var Wrapper = {
    abs: function(l, h) {
      var x = new goog.math.Long(l, h);
      var ret;
      if (x.isNegative()) {
        ret = x.negate();
      } else {
        ret = x;
      }
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
    },
    ensureTemps: function() {
      if (Wrapper.ensuredTemps) return;
      Wrapper.ensuredTemps = true;
      Wrapper.two32 = new BigInteger();
      Wrapper.two32.fromString('4294967296', 10);
      Wrapper.two64 = new BigInteger();
      Wrapper.two64.fromString('18446744073709551616', 10);
      Wrapper.temp1 = new BigInteger();
      Wrapper.temp2 = new BigInteger();
    },
    lh2bignum: function(l, h) {
      var a = new BigInteger();
      a.fromString(h.toString(), 10);
      var b = new BigInteger();
      a.multiplyTo(Wrapper.two32, b);
      var c = new BigInteger();
      c.fromString(l.toString(), 10);
      var d = new BigInteger();
      c.addTo(b, d);
      return d;
    },
    stringify: function(l, h, unsigned) {
      var ret = new goog.math.Long(l, h).toString();
      if (unsigned && ret[0] == '-') {
        // unsign slowly using jsbn bignums
        Wrapper.ensureTemps();
        var bignum = new BigInteger();
        bignum.fromString(ret, 10);
        ret = new BigInteger();
        Wrapper.two64.addTo(bignum, ret);
        ret = ret.toString(10);
      }
      return ret;
    },
    fromString: function(str, base, min, max, unsigned) {
      Wrapper.ensureTemps();
      var bignum = new BigInteger();
      bignum.fromString(str, base);
      var bigmin = new BigInteger();
      bigmin.fromString(min, 10);
      var bigmax = new BigInteger();
      bigmax.fromString(max, 10);
      if (unsigned && bignum.compareTo(BigInteger.ZERO) < 0) {
        var temp = new BigInteger();
        bignum.addTo(Wrapper.two64, temp);
        bignum = temp;
      }
      var error = false;
      if (bignum.compareTo(bigmin) < 0) {
        bignum = bigmin;
        error = true;
      } else if (bignum.compareTo(bigmax) > 0) {
        bignum = bigmax;
        error = true;
      }
      var ret = goog.math.Long.fromString(bignum.toString()); // min-max checks should have clamped this to a range goog.math.Long can handle well
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
      if (error) throw 'range error';
    }
  };
  return Wrapper;
})();

//======= end closure i64 code =======



// === Auto-generated postamble setup entry stuff ===

if (memoryInitializer) {
  if (ENVIRONMENT_IS_NODE || ENVIRONMENT_IS_SHELL) {
    var data = Module['readBinary'](memoryInitializer);
    HEAPU8.set(data, STATIC_BASE);
  } else {
    addRunDependency('memory initializer');
    Browser.asyncLoad(memoryInitializer, function(data) {
      HEAPU8.set(data, STATIC_BASE);
      removeRunDependency('memory initializer');
    }, function(data) {
      throw 'could not load memory initializer ' + memoryInitializer;
    });
  }
}

function ExitStatus(status) {
  this.name = "ExitStatus";
  this.message = "Program terminated with exit(" + status + ")";
  this.status = status;
};
ExitStatus.prototype = new Error();
ExitStatus.prototype.constructor = ExitStatus;

var initialStackTop;
var preloadStartTime = null;
var calledMain = false;

dependenciesFulfilled = function runCaller() {
  // If run has never been called, and we should call run (INVOKE_RUN is true, and Module.noInitialRun is not false)
  if (!Module['calledRun'] && shouldRunNow) run();
  if (!Module['calledRun']) dependenciesFulfilled = runCaller; // try this again later, after new deps are fulfilled
}

Module['callMain'] = Module.callMain = function callMain(args) {
  assert(runDependencies == 0, 'cannot call main when async dependencies remain! (listen on __ATMAIN__)');
  assert(__ATPRERUN__.length == 0, 'cannot call main when preRun functions remain to be called');

  args = args || [];

  if (ENVIRONMENT_IS_WEB && preloadStartTime !== null) {
    Module.printErr('preload time: ' + (Date.now() - preloadStartTime) + ' ms');
  }

  ensureInitRuntime();

  var argc = args.length+1;
  function pad() {
    for (var i = 0; i < 4-1; i++) {
      argv.push(0);
    }
  }
  var argv = [allocate(intArrayFromString("/bin/this.program"), 'i8', ALLOC_NORMAL) ];
  pad();
  for (var i = 0; i < argc-1; i = i + 1) {
    argv.push(allocate(intArrayFromString(args[i]), 'i8', ALLOC_NORMAL));
    pad();
  }
  argv.push(0);
  argv = allocate(argv, 'i32', ALLOC_NORMAL);

  initialStackTop = STACKTOP;

  try {

    var ret = Module['_main'](argc, argv, 0);


    // if we're not running an evented main loop, it's time to exit
    if (!Module['noExitRuntime']) {
      exit(ret);
    }
  }
  catch(e) {
    if (e instanceof ExitStatus) {
      // exit() throws this once it's done to make sure execution
      // has been stopped completely
      return;
    } else if (e == 'SimulateInfiniteLoop') {
      // running an evented main loop, don't immediately exit
      Module['noExitRuntime'] = true;
      return;
    } else {
      if (e && typeof e === 'object' && e.stack) Module.printErr('exception thrown: ' + [e, e.stack]);
      throw e;
    }
  } finally {
    calledMain = true;
  }
}




function run(args) {
  args = args || Module['arguments'];

  if (preloadStartTime === null) preloadStartTime = Date.now();

  if (runDependencies > 0) {
    Module.printErr('run() called, but dependencies remain, so not running');
    return;
  }

  preRun();

  if (runDependencies > 0) return; // a preRun added a dependency, run will be called later
  if (Module['calledRun']) return; // run may have just been called through dependencies being fulfilled just in this very frame

  function doRun() {
    if (Module['calledRun']) return; // run may have just been called while the async setStatus time below was happening
    Module['calledRun'] = true;

    ensureInitRuntime();

    preMain();

    if (Module['_main'] && shouldRunNow) {
      Module['callMain'](args);
    }

    postRun();
  }

  if (Module['setStatus']) {
    Module['setStatus']('Running...');
    setTimeout(function() {
      setTimeout(function() {
        Module['setStatus']('');
      }, 1);
      if (!ABORT) doRun();
    }, 1);
  } else {
    doRun();
  }
}
Module['run'] = Module.run = run;

function exit(status) {
  ABORT = true;
  EXITSTATUS = status;
  STACKTOP = initialStackTop;

  // exit the runtime
  exitRuntime();

  // TODO We should handle this differently based on environment.
  // In the browser, the best we can do is throw an exception
  // to halt execution, but in node we could process.exit and
  // I'd imagine SM shell would have something equivalent.
  // This would let us set a proper exit status (which
  // would be great for checking test exit statuses).
  // https://github.com/kripken/emscripten/issues/1371

  // throw an exception to halt the current execution
  throw new ExitStatus(status);
}
Module['exit'] = Module.exit = exit;

function abort(text) {
  if (text) {
    Module.print(text);
    Module.printErr(text);
  }

  ABORT = true;
  EXITSTATUS = 1;

  throw 'abort() at ' + stackTrace();
}
Module['abort'] = Module.abort = abort;

// {{PRE_RUN_ADDITIONS}}

if (Module['preInit']) {
  if (typeof Module['preInit'] == 'function') Module['preInit'] = [Module['preInit']];
  while (Module['preInit'].length > 0) {
    Module['preInit'].pop()();
  }
}

// shouldRunNow refers to calling main(), not run().
var shouldRunNow = true;
if (Module['noInitialRun']) {
  shouldRunNow = false;
}


run();

// {{POST_RUN_ADDITIONS}}






// {{MODULE_ADDITIONS}}






