var Module = {};
var preloadComplete = false;

Module['noInitialRun'] = true;
Module['OpenModelica_readFile'] = function(fname) {
  return intArrayToString(FS.findObject(fname).contents);
};
Module['OpenModelica_readFileBuffer'] = function(fname) {
  return FS.findObject(fname).contents;
};

try { // Try to add an event listener like a webworker thread
  self.addEventListener('message', function(e) {
    var data = e.data;
    if (!data) return;
    if (data.preload) {
      var error = function() {console.log('error...'); /* self.postError({message: "Preload failed"}); */ };
      if (!preloadComplete) {
        FS.createPreloadedFile('/', data.basename + "_init.xml", data.basename + "_init.xml", true, false, function() {
        FS.createLazyFile('/', data.basename + "_info.xml", data.basename + "_info.xml", true, false);
        preloadComplete = true;
        self.postMessage({preloaded:true});
      }, error);
      } else {
        self.postMessage({preloaded:true});
      }
      return;
    }
    var result = {};
    result.status = "Simulation failed"
    try {
      shouldRunNow = true;
      var args = ['-override','outputFormat=csv,stopTime=' +  data.stopTime +',tolerance=' + data.tolerance + ',stepSize=' + data.stepSize];
      Module.callMain(args);
      result.csv = intArrayToString(FS.findObject(data.basename + "_res.csv").contents);
      result.status = "Simulation finished";

  } catch(e) {
  }
  self.postMessage(result);
  }, false);
} catch (e) {
}

// The Module object: Our interface to the outside world. We import
// and export values on it, and do the work to get that through
// closure compiler if necessary. There are various ways Module can be used:
// 1. Not defined. We create it here
// 2. A function parameter, function(Module) { ..generated code.. }
// 3. pre-run appended it, var Module = {}; ..generated code..
// 4. External script tag defines var Module.
// We need to do an eval in order to handle the closure compiler
// case, where this code here is minified but Module was defined
// elsewhere (e.g. case 4 above). We also need to check if Module
// already exists (e.g. case 3 above).
// Note that if you want to run closure, and also to use Module
// after the generated code, you will need to define   var Module = {};
// before the code. Then that object will be used in the code, and you
// can continue to use Module afterwards as well.
var Module;
if (!Module) Module = eval('(function() { try { return Module || {} } catch(e) { return {} } })()');

// Sometimes an existing Module object exists with properties
// meant to overwrite the default module functionality. Here
// we collect those properties and reapply _after_ we configure
// the current environment's defaults to avoid having to be so
// defensive during initialization.
var moduleOverrides = {};
for (var key in Module) {
  if (Module.hasOwnProperty(key)) {
    moduleOverrides[key] = Module[key];
  }
}

// The environment setup code below is customized to use Module.
// *** Environment setup code ***
var ENVIRONMENT_IS_NODE = typeof process === 'object' && typeof require === 'function';
var ENVIRONMENT_IS_WEB = typeof window === 'object';
var ENVIRONMENT_IS_WORKER = typeof importScripts === 'function';
var ENVIRONMENT_IS_SHELL = !ENVIRONMENT_IS_WEB && !ENVIRONMENT_IS_NODE && !ENVIRONMENT_IS_WORKER;

if (ENVIRONMENT_IS_NODE) {
  // Expose functionality in the same simple way that the shells work
  // Note that we pollute the global namespace here, otherwise we break in node
  if (!Module['print']) Module['print'] = function print(x) {
    process['stdout'].write(x + '\n');
  };
  if (!Module['printErr']) Module['printErr'] = function printErr(x) {
    process['stderr'].write(x + '\n');
  };

  var nodeFS = require('fs');
  var nodePath = require('path');

  Module['read'] = function read(filename, binary) {
    filename = nodePath['normalize'](filename);
    var ret = nodeFS['readFileSync'](filename);
    // The path is absolute if the normalized version is the same as the resolved.
    if (!ret && filename != nodePath['resolve'](filename)) {
      filename = path.join(__dirname, '..', 'src', filename);
      ret = nodeFS['readFileSync'](filename);
    }
    if (ret && !binary) ret = ret.toString();
    return ret;
  };

  Module['readBinary'] = function readBinary(filename) { return Module['read'](filename, true) };

  Module['load'] = function load(f) {
    globalEval(read(f));
  };

  Module['arguments'] = process['argv'].slice(2);

  module['exports'] = Module;
}
else if (ENVIRONMENT_IS_SHELL) {
  if (!Module['print']) Module['print'] = print;
  if (typeof printErr != 'undefined') Module['printErr'] = printErr; // not present in v8 or older sm

  if (typeof read != 'undefined') {
    Module['read'] = read;
  } else {
    Module['read'] = function read() { throw 'no read() available (jsc?)' };
  }

  Module['readBinary'] = function readBinary(f) {
    return read(f, 'binary');
  };

  if (typeof scriptArgs != 'undefined') {
    Module['arguments'] = scriptArgs;
  } else if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  this['Module'] = Module;

  eval("if (typeof gc === 'function' && gc.toString().indexOf('[native code]') > 0) var gc = undefined"); // wipe out the SpiderMonkey shell 'gc' function, which can confuse closure (uses it as a minified name, and it is then initted to a non-falsey value unexpectedly)
}
else if (ENVIRONMENT_IS_WEB || ENVIRONMENT_IS_WORKER) {
  Module['read'] = function read(url) {
    var xhr = new XMLHttpRequest();
    xhr.open('GET', url, false);
    xhr.send(null);
    return xhr.responseText;
  };

  if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  if (typeof console !== 'undefined') {
    if (!Module['print']) Module['print'] = function print(x) {
      console.log(x);
    };
    if (!Module['printErr']) Module['printErr'] = function printErr(x) {
      console.log(x);
    };
  } else {
    // Probably a worker, and without console.log. We can do very little here...
    var TRY_USE_DUMP = false;
    if (!Module['print']) Module['print'] = (TRY_USE_DUMP && (typeof(dump) !== "undefined") ? (function(x) {
      dump(x);
    }) : (function(x) {
      // self.postMessage(x); // enable this if you want stdout to be sent as messages
    }));
  }

  if (ENVIRONMENT_IS_WEB) {
    this['Module'] = Module;
  } else {
    Module['load'] = importScripts;
  }
}
else {
  // Unreachable because SHELL is dependant on the others
  throw 'Unknown runtime environment. Where are we?';
}

function globalEval(x) {
  eval.call(null, x);
}
if (!Module['load'] == 'undefined' && Module['read']) {
  Module['load'] = function load(f) {
    globalEval(Module['read'](f));
  };
}
if (!Module['print']) {
  Module['print'] = function(){};
}
if (!Module['printErr']) {
  Module['printErr'] = Module['print'];
}
if (!Module['arguments']) {
  Module['arguments'] = [];
}
// *** Environment setup code ***

// Closure helpers
Module.print = Module['print'];
Module.printErr = Module['printErr'];

// Callbacks
Module['preRun'] = [];
Module['postRun'] = [];

// Merge back in the overrides
for (var key in moduleOverrides) {
  if (moduleOverrides.hasOwnProperty(key)) {
    Module[key] = moduleOverrides[key];
  }
}



// === Auto-generated preamble library stuff ===

//========================================
// Runtime code shared with compiler
//========================================

var Runtime = {
  stackSave: function () {
    return STACKTOP;
  },
  stackRestore: function (stackTop) {
    STACKTOP = stackTop;
  },
  forceAlign: function (target, quantum) {
    quantum = quantum || 4;
    if (quantum == 1) return target;
    if (isNumber(target) && isNumber(quantum)) {
      return Math.ceil(target/quantum)*quantum;
    } else if (isNumber(quantum) && isPowerOfTwo(quantum)) {
      return '(((' +target + ')+' + (quantum-1) + ')&' + -quantum + ')';
    }
    return 'Math.ceil((' + target + ')/' + quantum + ')*' + quantum;
  },
  isNumberType: function (type) {
    return type in Runtime.INT_TYPES || type in Runtime.FLOAT_TYPES;
  },
  isPointerType: function isPointerType(type) {
  return type[type.length-1] == '*';
},
  isStructType: function isStructType(type) {
  if (isPointerType(type)) return false;
  if (isArrayType(type)) return true;
  if (/<?\{ ?[^}]* ?\}>?/.test(type)) return true; // { i32, i8 } etc. - anonymous struct types
  // See comment in isStructPointerType()
  return type[0] == '%';
},
  INT_TYPES: {"i1":0,"i8":0,"i16":0,"i32":0,"i64":0},
  FLOAT_TYPES: {"float":0,"double":0},
  or64: function (x, y) {
    var l = (x | 0) | (y | 0);
    var h = (Math.round(x / 4294967296) | Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  and64: function (x, y) {
    var l = (x | 0) & (y | 0);
    var h = (Math.round(x / 4294967296) & Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  xor64: function (x, y) {
    var l = (x | 0) ^ (y | 0);
    var h = (Math.round(x / 4294967296) ^ Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  getNativeTypeSize: function (type) {
    switch (type) {
      case 'i1': case 'i8': return 1;
      case 'i16': return 2;
      case 'i32': return 4;
      case 'i64': return 8;
      case 'float': return 4;
      case 'double': return 8;
      default: {
        if (type[type.length-1] === '*') {
          return Runtime.QUANTUM_SIZE; // A pointer
        } else if (type[0] === 'i') {
          var bits = parseInt(type.substr(1));
          assert(bits % 8 === 0);
          return bits/8;
        } else {
          return 0;
        }
      }
    }
  },
  getNativeFieldSize: function (type) {
    return Math.max(Runtime.getNativeTypeSize(type), Runtime.QUANTUM_SIZE);
  },
  dedup: function dedup(items, ident) {
  var seen = {};
  if (ident) {
    return items.filter(function(item) {
      if (seen[item[ident]]) return false;
      seen[item[ident]] = true;
      return true;
    });
  } else {
    return items.filter(function(item) {
      if (seen[item]) return false;
      seen[item] = true;
      return true;
    });
  }
},
  set: function set() {
  var args = typeof arguments[0] === 'object' ? arguments[0] : arguments;
  var ret = {};
  for (var i = 0; i < args.length; i++) {
    ret[args[i]] = 0;
  }
  return ret;
},
  STACK_ALIGN: 8,
  getAlignSize: function (type, size, vararg) {
    // we align i64s and doubles on 64-bit boundaries, unlike x86
    if (!vararg && (type == 'i64' || type == 'double')) return 8;
    if (!type) return Math.min(size, 8); // align structures internally to 64 bits
    return Math.min(size || (type ? Runtime.getNativeFieldSize(type) : 0), Runtime.QUANTUM_SIZE);
  },
  calculateStructAlignment: function calculateStructAlignment(type) {
    type.flatSize = 0;
    type.alignSize = 0;
    var diffs = [];
    var prev = -1;
    var index = 0;
    type.flatIndexes = type.fields.map(function(field) {
      index++;
      var size, alignSize;
      if (Runtime.isNumberType(field) || Runtime.isPointerType(field)) {
        size = Runtime.getNativeTypeSize(field); // pack char; char; in structs, also char[X]s.
        alignSize = Runtime.getAlignSize(field, size);
      } else if (Runtime.isStructType(field)) {
        if (field[1] === '0') {
          // this is [0 x something]. When inside another structure like here, it must be at the end,
          // and it adds no size
          // XXX this happens in java-nbody for example... assert(index === type.fields.length, 'zero-length in the middle!');
          size = 0;
          if (Types.types[field]) {
            alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
          } else {
            alignSize = type.alignSize || QUANTUM_SIZE;
          }
        } else {
          size = Types.types[field].flatSize;
          alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
        }
      } else if (field[0] == 'b') {
        // bN, large number field, like a [N x i8]
        size = field.substr(1)|0;
        alignSize = 1;
      } else if (field[0] === '<') {
        // vector type
        size = alignSize = Types.types[field].flatSize; // fully aligned
      } else if (field[0] === 'i') {
        // illegal integer field, that could not be legalized because it is an internal structure field
        // it is ok to have such fields, if we just use them as markers of field size and nothing more complex
        size = alignSize = parseInt(field.substr(1))/8;
        assert(size % 1 === 0, 'cannot handle non-byte-size field ' + field);
      } else {
        assert(false, 'invalid type for calculateStructAlignment');
      }
      if (type.packed) alignSize = 1;
      type.alignSize = Math.max(type.alignSize, alignSize);
      var curr = Runtime.alignMemory(type.flatSize, alignSize); // if necessary, place this on aligned memory
      type.flatSize = curr + size;
      if (prev >= 0) {
        diffs.push(curr-prev);
      }
      prev = curr;
      return curr;
    });
    if (type.name_ && type.name_[0] === '[') {
      // arrays have 2 elements, so we get the proper difference. then we scale here. that way we avoid
      // allocating a potentially huge array for [999999 x i8] etc.
      type.flatSize = parseInt(type.name_.substr(1))*type.flatSize/2;
    }
    type.flatSize = Runtime.alignMemory(type.flatSize, type.alignSize);
    if (diffs.length == 0) {
      type.flatFactor = type.flatSize;
    } else if (Runtime.dedup(diffs).length == 1) {
      type.flatFactor = diffs[0];
    }
    type.needsFlattening = (type.flatFactor != 1);
    return type.flatIndexes;
  },
  generateStructInfo: function (struct, typeName, offset) {
    var type, alignment;
    if (typeName) {
      offset = offset || 0;
      type = (typeof Types === 'undefined' ? Runtime.typeInfo : Types.types)[typeName];
      if (!type) return null;
      if (type.fields.length != struct.length) {
        printErr('Number of named fields must match the type for ' + typeName + ': possibly duplicate struct names. Cannot return structInfo');
        return null;
      }
      alignment = type.flatIndexes;
    } else {
      var type = { fields: struct.map(function(item) { return item[0] }) };
      alignment = Runtime.calculateStructAlignment(type);
    }
    var ret = {
      __size__: type.flatSize
    };
    if (typeName) {
      struct.forEach(function(item, i) {
        if (typeof item === 'string') {
          ret[item] = alignment[i] + offset;
        } else {
          // embedded struct
          var key;
          for (var k in item) key = k;
          ret[key] = Runtime.generateStructInfo(item[key], type.fields[i], alignment[i]);
        }
      });
    } else {
      struct.forEach(function(item, i) {
        ret[item[1]] = alignment[i];
      });
    }
    return ret;
  },
  dynCall: function (sig, ptr, args) {
    if (args && args.length) {
      if (!args.splice) args = Array.prototype.slice.call(args);
      args.splice(0, 0, ptr);
      return Module['dynCall_' + sig].apply(null, args);
    } else {
      return Module['dynCall_' + sig].call(null, ptr);
    }
  },
  functionPointers: [],
  addFunction: function (func) {
    for (var i = 0; i < Runtime.functionPointers.length; i++) {
      if (!Runtime.functionPointers[i]) {
        Runtime.functionPointers[i] = func;
        return 2*(1 + i);
      }
    }
    throw 'Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS.';
  },
  removeFunction: function (index) {
    Runtime.functionPointers[(index-2)/2] = null;
  },
  getAsmConst: function (code, numArgs) {
    // code is a constant string on the heap, so we can cache these
    if (!Runtime.asmConstCache) Runtime.asmConstCache = {};
    var func = Runtime.asmConstCache[code];
    if (func) return func;
    var args = [];
    for (var i = 0; i < numArgs; i++) {
      args.push(String.fromCharCode(36) + i); // $0, $1 etc
    }
    code = Pointer_stringify(code);
    if (code[0] === '"') {
      // tolerate EM_ASM("..code..") even though EM_ASM(..code..) is correct
      if (code.indexOf('"', 1) === code.length-1) {
        code = code.substr(1, code.length-2);
      } else {
        // something invalid happened, e.g. EM_ASM("..code($0)..", input)
        abort('invalid EM_ASM input |' + code + '|. Please use EM_ASM(..code..) (no quotes) or EM_ASM({ ..code($0).. }, input) (to input values)');
      }
    }
    return Runtime.asmConstCache[code] = eval('(function(' + args.join(',') + '){ ' + code + ' })'); // new Function does not allow upvars in node
  },
  warnOnce: function (text) {
    if (!Runtime.warnOnce.shown) Runtime.warnOnce.shown = {};
    if (!Runtime.warnOnce.shown[text]) {
      Runtime.warnOnce.shown[text] = 1;
      Module.printErr(text);
    }
  },
  funcWrappers: {},
  getFuncWrapper: function (func, sig) {
    assert(sig);
    if (!Runtime.funcWrappers[func]) {
      Runtime.funcWrappers[func] = function dynCall_wrapper() {
        return Runtime.dynCall(sig, func, arguments);
      };
    }
    return Runtime.funcWrappers[func];
  },
  UTF8Processor: function () {
    var buffer = [];
    var needed = 0;
    this.processCChar = function (code) {
      code = code & 0xFF;

      if (buffer.length == 0) {
        if ((code & 0x80) == 0x00) {        // 0xxxxxxx
          return String.fromCharCode(code);
        }
        buffer.push(code);
        if ((code & 0xE0) == 0xC0) {        // 110xxxxx
          needed = 1;
        } else if ((code & 0xF0) == 0xE0) { // 1110xxxx
          needed = 2;
        } else {                            // 11110xxx
          needed = 3;
        }
        return '';
      }

      if (needed) {
        buffer.push(code);
        needed--;
        if (needed > 0) return '';
      }

      var c1 = buffer[0];
      var c2 = buffer[1];
      var c3 = buffer[2];
      var c4 = buffer[3];
      var ret;
      if (buffer.length == 2) {
        ret = String.fromCharCode(((c1 & 0x1F) << 6)  | (c2 & 0x3F));
      } else if (buffer.length == 3) {
        ret = String.fromCharCode(((c1 & 0x0F) << 12) | ((c2 & 0x3F) << 6)  | (c3 & 0x3F));
      } else {
        // http://mathiasbynens.be/notes/javascript-encoding#surrogate-formulae
        var codePoint = ((c1 & 0x07) << 18) | ((c2 & 0x3F) << 12) |
                        ((c3 & 0x3F) << 6)  | (c4 & 0x3F);
        ret = String.fromCharCode(
          Math.floor((codePoint - 0x10000) / 0x400) + 0xD800,
          (codePoint - 0x10000) % 0x400 + 0xDC00);
      }
      buffer.length = 0;
      return ret;
    }
    this.processJSString = function processJSString(string) {
      string = unescape(encodeURIComponent(string));
      var ret = [];
      for (var i = 0; i < string.length; i++) {
        ret.push(string.charCodeAt(i));
      }
      return ret;
    }
  },
  getCompilerSetting: function (name) {
    throw 'You must build with -s RETAIN_COMPILER_SETTINGS=1 for Runtime.getCompilerSetting or emscripten_get_compiler_setting to work';
  },
  stackAlloc: function (size) { var ret = STACKTOP;STACKTOP = (STACKTOP + size)|0;STACKTOP = (((STACKTOP)+7)&-8); return ret; },
  staticAlloc: function (size) { var ret = STATICTOP;STATICTOP = (STATICTOP + size)|0;STATICTOP = (((STATICTOP)+7)&-8); return ret; },
  dynamicAlloc: function (size) { var ret = DYNAMICTOP;DYNAMICTOP = (DYNAMICTOP + size)|0;DYNAMICTOP = (((DYNAMICTOP)+7)&-8); if (DYNAMICTOP >= TOTAL_MEMORY) enlargeMemory();; return ret; },
  alignMemory: function (size,quantum) { var ret = size = Math.ceil((size)/(quantum ? quantum : 8))*(quantum ? quantum : 8); return ret; },
  makeBigInt: function (low,high,unsigned) { var ret = (unsigned ? ((+((low>>>0)))+((+((high>>>0)))*(+4294967296))) : ((+((low>>>0)))+((+((high|0)))*(+4294967296)))); return ret; },
  GLOBAL_BASE: 8,
  QUANTUM_SIZE: 4,
  __dummy__: 0
}


Module['Runtime'] = Runtime;









//========================================
// Runtime essentials
//========================================

var __THREW__ = 0; // Used in checking for thrown exceptions.

var ABORT = false; // whether we are quitting the application. no code should run after this. set in exit() and abort()
var EXITSTATUS = 0;

var undef = 0;
// tempInt is used for 32-bit signed values or smaller. tempBigInt is used
// for 32-bit unsigned values or more than 32 bits. TODO: audit all uses of tempInt
var tempValue, tempInt, tempBigInt, tempInt2, tempBigInt2, tempPair, tempBigIntI, tempBigIntR, tempBigIntS, tempBigIntP, tempBigIntD, tempDouble, tempFloat;
var tempI64, tempI64b;
var tempRet0, tempRet1, tempRet2, tempRet3, tempRet4, tempRet5, tempRet6, tempRet7, tempRet8, tempRet9;

function assert(condition, text) {
  if (!condition) {
    abort('Assertion failed: ' + text);
  }
}

var globalScope = this;

// C calling interface. A convenient way to call C functions (in C files, or
// defined with extern "C").
//
// Note: LLVM optimizations can inline and remove functions, after which you will not be
//       able to call them. Closure can also do so. To avoid that, add your function to
//       the exports using something like
//
//         -s EXPORTED_FUNCTIONS='["_main", "_myfunc"]'
//
// @param ident      The name of the C function (note that C++ functions will be name-mangled - use extern "C")
// @param returnType The return type of the function, one of the JS types 'number', 'string' or 'array' (use 'number' for any C pointer, and
//                   'array' for JavaScript arrays and typed arrays; note that arrays are 8-bit).
// @param argTypes   An array of the types of arguments for the function (if there are no arguments, this can be ommitted). Types are as in returnType,
//                   except that 'array' is not possible (there is no way for us to know the length of the array)
// @param args       An array of the arguments to the function, as native JS values (as in returnType)
//                   Note that string arguments will be stored on the stack (the JS string will become a C string on the stack).
// @return           The return value, as a native JS value (as in returnType)
function ccall(ident, returnType, argTypes, args) {
  return ccallFunc(getCFunc(ident), returnType, argTypes, args);
}
Module["ccall"] = ccall;

// Returns the C function with a specified identifier (for C++, you need to do manual name mangling)
function getCFunc(ident) {
  try {
    var func = Module['_' + ident]; // closure exported function
    if (!func) func = eval('_' + ident); // explicit lookup
  } catch(e) {
  }
  assert(func, 'Cannot call unknown function ' + ident + ' (perhaps LLVM optimizations or closure removed it?)');
  return func;
}

// Internal function that does a C call using a function, not an identifier
function ccallFunc(func, returnType, argTypes, args) {
  var stack = 0;
  function toC(value, type) {
    if (type == 'string') {
      if (value === null || value === undefined || value === 0) return 0; // null string
      value = intArrayFromString(value);
      type = 'array';
    }
    if (type == 'array') {
      if (!stack) stack = Runtime.stackSave();
      var ret = Runtime.stackAlloc(value.length);
      writeArrayToMemory(value, ret);
      return ret;
    }
    return value;
  }
  function fromC(value, type) {
    if (type == 'string') {
      return Pointer_stringify(value);
    }
    assert(type != 'array');
    return value;
  }
  var i = 0;
  var cArgs = args ? args.map(function(arg) {
    return toC(arg, argTypes[i++]);
  }) : [];
  var ret = fromC(func.apply(null, cArgs), returnType);
  if (stack) Runtime.stackRestore(stack);
  return ret;
}

// Returns a native JS wrapper for a C function. This is similar to ccall, but
// returns a function you can call repeatedly in a normal way. For example:
//
//   var my_function = cwrap('my_c_function', 'number', ['number', 'number']);
//   alert(my_function(5, 22));
//   alert(my_function(99, 12));
//
function cwrap(ident, returnType, argTypes) {
  var func = getCFunc(ident);
  return function() {
    return ccallFunc(func, returnType, argTypes, Array.prototype.slice.call(arguments));
  }
}
Module["cwrap"] = cwrap;

// Sets a value in memory in a dynamic way at run-time. Uses the
// type data. This is the same as makeSetValue, except that
// makeSetValue is done at compile-time and generates the needed
// code then, whereas this function picks the right code at
// run-time.
// Note that setValue and getValue only do *aligned* writes and reads!
// Note that ccall uses JS types as for defining types, while setValue and
// getValue need LLVM types ('i8', 'i32') - this is a lower-level operation
function setValue(ptr, value, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': HEAP8[(ptr)]=value; break;
      case 'i8': HEAP8[(ptr)]=value; break;
      case 'i16': HEAP16[((ptr)>>1)]=value; break;
      case 'i32': HEAP32[((ptr)>>2)]=value; break;
      case 'i64': (tempI64 = [value>>>0,(tempDouble=value,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((ptr)>>2)]=tempI64[0],HEAP32[(((ptr)+(4))>>2)]=tempI64[1]); break;
      case 'float': HEAPF32[((ptr)>>2)]=value; break;
      case 'double': HEAPF64[((ptr)>>3)]=value; break;
      default: abort('invalid type for setValue: ' + type);
    }
}
Module['setValue'] = setValue;

// Parallel to setValue.
function getValue(ptr, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': return HEAP8[(ptr)];
      case 'i8': return HEAP8[(ptr)];
      case 'i16': return HEAP16[((ptr)>>1)];
      case 'i32': return HEAP32[((ptr)>>2)];
      case 'i64': return HEAP32[((ptr)>>2)];
      case 'float': return HEAPF32[((ptr)>>2)];
      case 'double': return HEAPF64[((ptr)>>3)];
      default: abort('invalid type for setValue: ' + type);
    }
  return null;
}
Module['getValue'] = getValue;

var ALLOC_NORMAL = 0; // Tries to use _malloc()
var ALLOC_STACK = 1; // Lives for the duration of the current function call
var ALLOC_STATIC = 2; // Cannot be freed
var ALLOC_DYNAMIC = 3; // Cannot be freed except through sbrk
var ALLOC_NONE = 4; // Do not allocate
Module['ALLOC_NORMAL'] = ALLOC_NORMAL;
Module['ALLOC_STACK'] = ALLOC_STACK;
Module['ALLOC_STATIC'] = ALLOC_STATIC;
Module['ALLOC_DYNAMIC'] = ALLOC_DYNAMIC;
Module['ALLOC_NONE'] = ALLOC_NONE;

// allocate(): This is for internal use. You can use it yourself as well, but the interface
//             is a little tricky (see docs right below). The reason is that it is optimized
//             for multiple syntaxes to save space in generated code. So you should
//             normally not use allocate(), and instead allocate memory using _malloc(),
//             initialize it with setValue(), and so forth.
// @slab: An array of data, or a number. If a number, then the size of the block to allocate,
//        in *bytes* (note that this is sometimes confusing: the next parameter does not
//        affect this!)
// @types: Either an array of types, one for each byte (or 0 if no type at that position),
//         or a single type which is used for the entire block. This only matters if there
//         is initial data - if @slab is a number, then this does not matter at all and is
//         ignored.
// @allocator: How to allocate memory, see ALLOC_*
function allocate(slab, types, allocator, ptr) {
  var zeroinit, size;
  if (typeof slab === 'number') {
    zeroinit = true;
    size = slab;
  } else {
    zeroinit = false;
    size = slab.length;
  }

  var singleType = typeof types === 'string' ? types : null;

  var ret;
  if (allocator == ALLOC_NONE) {
    ret = ptr;
  } else {
    ret = [_malloc, Runtime.stackAlloc, Runtime.staticAlloc, Runtime.dynamicAlloc][allocator === undefined ? ALLOC_STATIC : allocator](Math.max(size, singleType ? 1 : types.length));
  }

  if (zeroinit) {
    var ptr = ret, stop;
    assert((ret & 3) == 0);
    stop = ret + (size & ~3);
    for (; ptr < stop; ptr += 4) {
      HEAP32[((ptr)>>2)]=0;
    }
    stop = ret + size;
    while (ptr < stop) {
      HEAP8[((ptr++)|0)]=0;
    }
    return ret;
  }

  if (singleType === 'i8') {
    if (slab.subarray || slab.slice) {
      HEAPU8.set(slab, ret);
    } else {
      HEAPU8.set(new Uint8Array(slab), ret);
    }
    return ret;
  }

  var i = 0, type, typeSize, previousType;
  while (i < size) {
    var curr = slab[i];

    if (typeof curr === 'function') {
      curr = Runtime.getFunctionIndex(curr);
    }

    type = singleType || types[i];
    if (type === 0) {
      i++;
      continue;
    }

    if (type == 'i64') type = 'i32'; // special case: we have one i32 here, and one i32 later

    setValue(ret+i, curr, type);

    // no need to look up size unless type changes, so cache it
    if (previousType !== type) {
      typeSize = Runtime.getNativeTypeSize(type);
      previousType = type;
    }
    i += typeSize;
  }

  return ret;
}
Module['allocate'] = allocate;

function Pointer_stringify(ptr, /* optional */ length) {
  // TODO: use TextDecoder
  // Find the length, and check for UTF while doing so
  var hasUtf = false;
  var t;
  var i = 0;
  while (1) {
    t = HEAPU8[(((ptr)+(i))|0)];
    if (t >= 128) hasUtf = true;
    else if (t == 0 && !length) break;
    i++;
    if (length && i == length) break;
  }
  if (!length) length = i;

  var ret = '';

  if (!hasUtf) {
    var MAX_CHUNK = 1024; // split up into chunks, because .apply on a huge string can overflow the stack
    var curr;
    while (length > 0) {
      curr = String.fromCharCode.apply(String, HEAPU8.subarray(ptr, ptr + Math.min(length, MAX_CHUNK)));
      ret = ret ? ret + curr : curr;
      ptr += MAX_CHUNK;
      length -= MAX_CHUNK;
    }
    return ret;
  }

  var utf8 = new Runtime.UTF8Processor();
  for (i = 0; i < length; i++) {
    t = HEAPU8[(((ptr)+(i))|0)];
    ret += utf8.processCChar(t);
  }
  return ret;
}
Module['Pointer_stringify'] = Pointer_stringify;

// Given a pointer 'ptr' to a null-terminated UTF16LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF16ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var codeUnit = HEAP16[(((ptr)+(i*2))>>1)];
    if (codeUnit == 0)
      return str;
    ++i;
    // fromCharCode constructs a character from a UTF-16 code unit, so we can pass the UTF16 string right through.
    str += String.fromCharCode(codeUnit);
  }
}
Module['UTF16ToString'] = UTF16ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF16LE form. The copy will require at most (str.length*2+1)*2 bytes of space in the HEAP.
function stringToUTF16(str, outPtr) {
  for(var i = 0; i < str.length; ++i) {
    // charCodeAt returns a UTF-16 encoded code unit, so it can be directly written to the HEAP.
    var codeUnit = str.charCodeAt(i); // possibly a lead surrogate
    HEAP16[(((outPtr)+(i*2))>>1)]=codeUnit;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP16[(((outPtr)+(str.length*2))>>1)]=0;
}
Module['stringToUTF16'] = stringToUTF16;

// Given a pointer 'ptr' to a null-terminated UTF32LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF32ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var utf32 = HEAP32[(((ptr)+(i*4))>>2)];
    if (utf32 == 0)
      return str;
    ++i;
    // Gotcha: fromCharCode constructs a character from a UTF-16 encoded code (pair), not from a Unicode code point! So encode the code point to UTF-16 for constructing.
    if (utf32 >= 0x10000) {
      var ch = utf32 - 0x10000;
      str += String.fromCharCode(0xD800 | (ch >> 10), 0xDC00 | (ch & 0x3FF));
    } else {
      str += String.fromCharCode(utf32);
    }
  }
}
Module['UTF32ToString'] = UTF32ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF32LE form. The copy will require at most (str.length+1)*4 bytes of space in the HEAP,
// but can use less, since str.length does not return the number of characters in the string, but the number of UTF-16 code units in the string.
function stringToUTF32(str, outPtr) {
  var iChar = 0;
  for(var iCodeUnit = 0; iCodeUnit < str.length; ++iCodeUnit) {
    // Gotcha: charCodeAt returns a 16-bit word that is a UTF-16 encoded code unit, not a Unicode code point of the character! We must decode the string to UTF-32 to the heap.
    var codeUnit = str.charCodeAt(iCodeUnit); // possibly a lead surrogate
    if (codeUnit >= 0xD800 && codeUnit <= 0xDFFF) {
      var trailSurrogate = str.charCodeAt(++iCodeUnit);
      codeUnit = 0x10000 + ((codeUnit & 0x3FF) << 10) | (trailSurrogate & 0x3FF);
    }
    HEAP32[(((outPtr)+(iChar*4))>>2)]=codeUnit;
    ++iChar;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP32[(((outPtr)+(iChar*4))>>2)]=0;
}
Module['stringToUTF32'] = stringToUTF32;

function demangle(func) {
  var i = 3;
  // params, etc.
  var basicTypes = {
    'v': 'void',
    'b': 'bool',
    'c': 'char',
    's': 'short',
    'i': 'int',
    'l': 'long',
    'f': 'float',
    'd': 'double',
    'w': 'wchar_t',
    'a': 'signed char',
    'h': 'unsigned char',
    't': 'unsigned short',
    'j': 'unsigned int',
    'm': 'unsigned long',
    'x': 'long long',
    'y': 'unsigned long long',
    'z': '...'
  };
  var subs = [];
  var first = true;
  function dump(x) {
    //return;
    if (x) Module.print(x);
    Module.print(func);
    var pre = '';
    for (var a = 0; a < i; a++) pre += ' ';
    Module.print (pre + '^');
  }
  function parseNested() {
    i++;
    if (func[i] === 'K') i++; // ignore const
    var parts = [];
    while (func[i] !== 'E') {
      if (func[i] === 'S') { // substitution
        i++;
        var next = func.indexOf('_', i);
        var num = func.substring(i, next) || 0;
        parts.push(subs[num] || '?');
        i = next+1;
        continue;
      }
      if (func[i] === 'C') { // constructor
        parts.push(parts[parts.length-1]);
        i += 2;
        continue;
      }
      var size = parseInt(func.substr(i));
      var pre = size.toString().length;
      if (!size || !pre) { i--; break; } // counter i++ below us
      var curr = func.substr(i + pre, size);
      parts.push(curr);
      subs.push(curr);
      i += pre + size;
    }
    i++; // skip E
    return parts;
  }
  function parse(rawList, limit, allowVoid) { // main parser
    limit = limit || Infinity;
    var ret = '', list = [];
    function flushList() {
      return '(' + list.join(', ') + ')';
    }
    var name;
    if (func[i] === 'N') {
      // namespaced N-E
      name = parseNested().join('::');
      limit--;
      if (limit === 0) return rawList ? [name] : name;
    } else {
      // not namespaced
      if (func[i] === 'K' || (first && func[i] === 'L')) i++; // ignore const and first 'L'
      var size = parseInt(func.substr(i));
      if (size) {
        var pre = size.toString().length;
        name = func.substr(i + pre, size);
        i += pre + size;
      }
    }
    first = false;
    if (func[i] === 'I') {
      i++;
      var iList = parse(true);
      var iRet = parse(true, 1, true);
      ret += iRet[0] + ' ' + name + '<' + iList.join(', ') + '>';
    } else {
      ret = name;
    }
    paramLoop: while (i < func.length && limit-- > 0) {
      //dump('paramLoop');
      var c = func[i++];
      if (c in basicTypes) {
        list.push(basicTypes[c]);
      } else {
        switch (c) {
          case 'P': list.push(parse(true, 1, true)[0] + '*'); break; // pointer
          case 'R': list.push(parse(true, 1, true)[0] + '&'); break; // reference
          case 'L': { // literal
            i++; // skip basic type
            var end = func.indexOf('E', i);
            var size = end - i;
            list.push(func.substr(i, size));
            i += size + 2; // size + 'EE'
            break;
          }
          case 'A': { // array
            var size = parseInt(func.substr(i));
            i += size.toString().length;
            if (func[i] !== '_') throw '?';
            i++; // skip _
            list.push(parse(true, 1, true)[0] + ' [' + size + ']');
            break;
          }
          case 'E': break paramLoop;
          default: ret += '?' + c; break paramLoop;
        }
      }
    }
    if (!allowVoid && list.length === 1 && list[0] === 'void') list = []; // avoid (void)
    return rawList ? list : ret + flushList();
  }
  try {
    // Special-case the entry point, since its name differs from other name mangling.
    if (func == 'Object._main' || func == '_main') {
      return 'main()';
    }
    if (typeof func === 'number') func = Pointer_stringify(func);
    if (func[0] !== '_') return func;
    if (func[1] !== '_') return func; // C function
    if (func[2] !== 'Z') return func;
    switch (func[3]) {
      case 'n': return 'operator new()';
      case 'd': return 'operator delete()';
    }
    return parse();
  } catch(e) {
    return func;
  }
}

function demangleAll(text) {
  return text.replace(/__Z[\w\d_]+/g, function(x) { var y = demangle(x); return x === y ? x : (x + ' [' + y + ']') });
}

function stackTrace() {
  var stack = new Error().stack;
  return stack ? demangleAll(stack) : '(no stack trace available)'; // Stack trace is not available at least on IE10 and Safari 6.
}

// Memory management

var PAGE_SIZE = 4096;
function alignMemoryPage(x) {
  return (x+4095)&-4096;
}

var HEAP;
var HEAP8, HEAPU8, HEAP16, HEAPU16, HEAP32, HEAPU32, HEAPF32, HEAPF64;

var STATIC_BASE = 0, STATICTOP = 0, staticSealed = false; // static area
var STACK_BASE = 0, STACKTOP = 0, STACK_MAX = 0; // stack area
var DYNAMIC_BASE = 0, DYNAMICTOP = 0; // dynamic area handled by sbrk

function enlargeMemory() {
  abort('Cannot enlarge memory arrays. Either (1) compile with -s TOTAL_MEMORY=X with X higher than the current value ' + TOTAL_MEMORY + ', (2) compile with ALLOW_MEMORY_GROWTH which adjusts the size at runtime but prevents some optimizations, or (3) set Module.TOTAL_MEMORY before the program runs.');
}

var TOTAL_STACK = Module['TOTAL_STACK'] || 5242880;
var TOTAL_MEMORY = Module['TOTAL_MEMORY'] || 536870912;
var FAST_MEMORY = Module['FAST_MEMORY'] || 2097152;

var totalMemory = 4096;
while (totalMemory < TOTAL_MEMORY || totalMemory < 2*TOTAL_STACK) {
  if (totalMemory < 16*1024*1024) {
    totalMemory *= 2;
  } else {
    totalMemory += 16*1024*1024
  }
}
if (totalMemory !== TOTAL_MEMORY) {
  Module.printErr('increasing TOTAL_MEMORY to ' + totalMemory + ' to be more reasonable');
  TOTAL_MEMORY = totalMemory;
}

// Initialize the runtime's memory
// check for full engine support (use string 'subarray' to avoid closure compiler confusion)
assert(typeof Int32Array !== 'undefined' && typeof Float64Array !== 'undefined' && !!(new Int32Array(1)['subarray']) && !!(new Int32Array(1)['set']),
       'JS engine does not provide full typed array support');

var buffer = new ArrayBuffer(TOTAL_MEMORY);
HEAP8 = new Int8Array(buffer);
HEAP16 = new Int16Array(buffer);
HEAP32 = new Int32Array(buffer);
HEAPU8 = new Uint8Array(buffer);
HEAPU16 = new Uint16Array(buffer);
HEAPU32 = new Uint32Array(buffer);
HEAPF32 = new Float32Array(buffer);
HEAPF64 = new Float64Array(buffer);

// Endianness check (note: assumes compiler arch was little-endian)
HEAP32[0] = 255;
assert(HEAPU8[0] === 255 && HEAPU8[3] === 0, 'Typed arrays 2 must be run on a little-endian system');

Module['HEAP'] = HEAP;
Module['HEAP8'] = HEAP8;
Module['HEAP16'] = HEAP16;
Module['HEAP32'] = HEAP32;
Module['HEAPU8'] = HEAPU8;
Module['HEAPU16'] = HEAPU16;
Module['HEAPU32'] = HEAPU32;
Module['HEAPF32'] = HEAPF32;
Module['HEAPF64'] = HEAPF64;

function callRuntimeCallbacks(callbacks) {
  while(callbacks.length > 0) {
    var callback = callbacks.shift();
    if (typeof callback == 'function') {
      callback();
      continue;
    }
    var func = callback.func;
    if (typeof func === 'number') {
      if (callback.arg === undefined) {
        Runtime.dynCall('v', func);
      } else {
        Runtime.dynCall('vi', func, [callback.arg]);
      }
    } else {
      func(callback.arg === undefined ? null : callback.arg);
    }
  }
}

var __ATPRERUN__  = []; // functions called before the runtime is initialized
var __ATINIT__    = []; // functions called during startup
var __ATMAIN__    = []; // functions called when main() is to be run
var __ATEXIT__    = []; // functions called during shutdown
var __ATPOSTRUN__ = []; // functions called after the runtime has exited

var runtimeInitialized = false;

function preRun() {
  // compatibility - merge in anything from Module['preRun'] at this time
  if (Module['preRun']) {
    if (typeof Module['preRun'] == 'function') Module['preRun'] = [Module['preRun']];
    while (Module['preRun'].length) {
      addOnPreRun(Module['preRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPRERUN__);
}

function ensureInitRuntime() {
  if (runtimeInitialized) return;
  runtimeInitialized = true;
  callRuntimeCallbacks(__ATINIT__);
}

function preMain() {
  callRuntimeCallbacks(__ATMAIN__);
}

function exitRuntime() {
  callRuntimeCallbacks(__ATEXIT__);
}

function postRun() {
  // compatibility - merge in anything from Module['postRun'] at this time
  if (Module['postRun']) {
    if (typeof Module['postRun'] == 'function') Module['postRun'] = [Module['postRun']];
    while (Module['postRun'].length) {
      addOnPostRun(Module['postRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPOSTRUN__);
}

function addOnPreRun(cb) {
  __ATPRERUN__.unshift(cb);
}
Module['addOnPreRun'] = Module.addOnPreRun = addOnPreRun;

function addOnInit(cb) {
  __ATINIT__.unshift(cb);
}
Module['addOnInit'] = Module.addOnInit = addOnInit;

function addOnPreMain(cb) {
  __ATMAIN__.unshift(cb);
}
Module['addOnPreMain'] = Module.addOnPreMain = addOnPreMain;

function addOnExit(cb) {
  __ATEXIT__.unshift(cb);
}
Module['addOnExit'] = Module.addOnExit = addOnExit;

function addOnPostRun(cb) {
  __ATPOSTRUN__.unshift(cb);
}
Module['addOnPostRun'] = Module.addOnPostRun = addOnPostRun;

// Tools

// This processes a JS string into a C-line array of numbers, 0-terminated.
// For LLVM-originating strings, see parser.js:parseLLVMString function
function intArrayFromString(stringy, dontAddNull, length /* optional */) {
  var ret = (new Runtime.UTF8Processor()).processJSString(stringy);
  if (length) {
    ret.length = length;
  }
  if (!dontAddNull) {
    ret.push(0);
  }
  return ret;
}
Module['intArrayFromString'] = intArrayFromString;

function intArrayToString(array) {
  var ret = [];
  for (var i = 0; i < array.length; i++) {
    var chr = array[i];
    if (chr > 0xFF) {
      chr &= 0xFF;
    }
    ret.push(String.fromCharCode(chr));
  }
  return ret.join('');
}
Module['intArrayToString'] = intArrayToString;

// Write a Javascript array to somewhere in the heap
function writeStringToMemory(string, buffer, dontAddNull) {
  var array = intArrayFromString(string, dontAddNull);
  var i = 0;
  while (i < array.length) {
    var chr = array[i];
    HEAP8[(((buffer)+(i))|0)]=chr;
    i = i + 1;
  }
}
Module['writeStringToMemory'] = writeStringToMemory;

function writeArrayToMemory(array, buffer) {
  for (var i = 0; i < array.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=array[i];
  }
}
Module['writeArrayToMemory'] = writeArrayToMemory;

function writeAsciiToMemory(str, buffer, dontAddNull) {
  for (var i = 0; i < str.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=str.charCodeAt(i);
  }
  if (!dontAddNull) HEAP8[(((buffer)+(str.length))|0)]=0;
}
Module['writeAsciiToMemory'] = writeAsciiToMemory;

function unSign(value, bits, ignore) {
  if (value >= 0) {
    return value;
  }
  return bits <= 32 ? 2*Math.abs(1 << (bits-1)) + value // Need some trickery, since if bits == 32, we are right at the limit of the bits JS uses in bitshifts
                    : Math.pow(2, bits)         + value;
}
function reSign(value, bits, ignore) {
  if (value <= 0) {
    return value;
  }
  var half = bits <= 32 ? Math.abs(1 << (bits-1)) // abs is needed if bits == 32
                        : Math.pow(2, bits-1);
  if (value >= half && (bits <= 32 || value > half)) { // for huge values, we can hit the precision limit and always get true here. so don't do that
                                                       // but, in general there is no perfect solution here. With 64-bit ints, we get rounding and errors
                                                       // TODO: In i64 mode 1, resign the two parts separately and safely
    value = -2*half + value; // Cannot bitshift half, as it may be at the limit of the bits JS uses in bitshifts
  }
  return value;
}

// check for imul support, and also for correctness ( https://bugs.webkit.org/show_bug.cgi?id=126345 )
if (!Math['imul'] || Math['imul'](0xffffffff, 5) !== -5) Math['imul'] = function imul(a, b) {
  var ah  = a >>> 16;
  var al = a & 0xffff;
  var bh  = b >>> 16;
  var bl = b & 0xffff;
  return (al*bl + ((ah*bl + al*bh) << 16))|0;
};
Math.imul = Math['imul'];


var Math_abs = Math.abs;
var Math_cos = Math.cos;
var Math_sin = Math.sin;
var Math_tan = Math.tan;
var Math_acos = Math.acos;
var Math_asin = Math.asin;
var Math_atan = Math.atan;
var Math_atan2 = Math.atan2;
var Math_exp = Math.exp;
var Math_log = Math.log;
var Math_sqrt = Math.sqrt;
var Math_ceil = Math.ceil;
var Math_floor = Math.floor;
var Math_pow = Math.pow;
var Math_imul = Math.imul;
var Math_fround = Math.fround;
var Math_min = Math.min;

// A counter of dependencies for calling run(). If we need to
// do asynchronous work before running, increment this and
// decrement it. Incrementing must happen in a place like
// PRE_RUN_ADDITIONS (used by emcc to add file preloading).
// Note that you can add dependencies in preRun, even though
// it happens right before run - run will be postponed until
// the dependencies are met.
var runDependencies = 0;
var runDependencyWatcher = null;
var dependenciesFulfilled = null; // overridden to take different actions when all run dependencies are fulfilled

function addRunDependency(id) {
  runDependencies++;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
}
Module['addRunDependency'] = addRunDependency;
function removeRunDependency(id) {
  runDependencies--;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
  if (runDependencies == 0) {
    if (runDependencyWatcher !== null) {
      clearInterval(runDependencyWatcher);
      runDependencyWatcher = null;
    }
    if (dependenciesFulfilled) {
      var callback = dependenciesFulfilled;
      dependenciesFulfilled = null;
      callback(); // can add another dependenciesFulfilled
    }
  }
}
Module['removeRunDependency'] = removeRunDependency;

Module["preloadedImages"] = {}; // maps url to image data
Module["preloadedAudios"] = {}; // maps url to audio data


var memoryInitializer = null;

// === Body ===
var __ZTVN10__cxxabiv117__class_type_infoE = 329816;
var __ZTVN10__cxxabiv120__si_class_type_infoE = 329856;




STATIC_BASE = 8;

STATICTOP = STATIC_BASE + Runtime.alignMemory(330683);
/* global initializers */ __ATINIT__.push({ func: function() { __GLOBAL__I_a() } });


/* memory initializer */ allocate([0,0,0,0,0,0,0,0,95,112,114,111,102,46,100,97,116,97,0,0,0,0,0,0,119,98,0,0,0,0,0,0,84,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,111,117,116,112,117,116,32,102,105,108,101,32,37,115,32,99,111,117,108,100,32,110,111,116,32,98,101,32,111,112,101,110,101,100,58,32,37,115,0,0,0,0,0,0,0,0,111,102,102,115,101,116,32,118,97,108,117,101,32,102,111,114,32,116,104,101,32,110,101,120,116,32,115,116,101,112,58,32,37,46,49,48,102,0,0,0,99,97,108,108,32,115,111,108,118,101,114,32,102,114,111,109,32,37,103,32,116,111,32,37,103,32,40,115,116,101,112,83,105,122,101,58,32,37,103,41,0,0,0,0,0,0,0,0,82,117,110,110,105,110,103,0,37,115,32,101,118,101,110,116,32,97,116,32,116,105,109,101,32,37,46,49,50,103,0,0,116,105,109,101,0,0,0,0,115,116,97,116,101,0,0,0,68,105,115,97,98,108,101,100,32,116,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,98,101,99,97,117,115,101,32,116,104,101,32,111,117,116,112,117,116,32,102,105,108,101,32,99,111,117,108,100,32,110,111,116,32,98,101,32,103,101,110,101,114,97,116,101,100,58,32,37,115,0,0,0,83,105,109,117,108,97,116,105,111,110,32,99,97,108,108,32,116,101,114,109,105,110,97,116,101,40,41,32,97,116,32,116,105,109,101,32,37,102,10,77,101,115,115,97,103,101,32,58,32,37,115,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,73,110,116,101,103,114,97,116,111,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,110,111,110,45,108,105,110,101,97,114,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,109,105,120,101,100,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,112,114,111,98,97,98,108,121,32,97,32,115,116,114,111,110,103,32,99,111,109,112,111,110,101,110,116,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,70,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,117,115,101,32,102,108,97,103,115,32,45,108,118,32,76,79,71,95,78,76,83,44,32,76,79,71,95,76,83,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,40,9,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,50,93,41,0,0,1,0,0,0,42,9,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,50,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,51,93,41,0,0,1,0,0,0,44,9,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,51,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,52,93,41,0,0,1,0,0,0,46,9,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,52,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,53,93,41,0,0,1,0,0,0,48,9,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,53,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,54,93,41,0,0,1,0,0,0,50,9,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,54,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,55,93,41,0,0,1,0,0,0,52,9,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,55,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,56,93,41,0,0,1,0,0,0,54,9,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,56,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,57,93,41,0,0,1,0,0,0,56,9,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,57,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,48,93,41,0,1,0,0,0,58,9,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,48,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,49,93,41,0,0,0,0,0,0,0,0,1,0,0,0,60,9,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,49,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,50,93,41,0,0,0,0,0,0,0,0,1,0,0,0,62,9,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,50,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,51,93,41,0,0,0,0,0,0,0,0,1,0,0,0,64,9,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,51,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,52,93,41,0,0,0,0,0,0,0,0,1,0,0,0,66,9,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,52,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,53,93,41,0,0,0,0,0,0,0,0,1,0,0,0,68,9,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,53,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,54,93,41,0,0,0,0,0,0,0,0,1,0,0,0,70,9,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,54,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,55,93,41,0,0,0,0,0,0,0,0,1,0,0,0,72,9,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,55,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,56,93,41,0,0,0,0,0,0,0,0,1,0,0,0,74,9,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,56,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,57,93,41,0,0,0,0,0,0,0,0,1,0,0,0,76,9,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,57,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,50,48,93,41,0,0,0,0,0,0,0,0,1,0,0,0,78,9,0,0,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,50,48,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,1,0,0,0,100,9,0,0,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,1,0,0,0,102,9,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,50,93,41,0,0,1,0,0,0,104,9,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,50,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,51,93,41,0,0,1,0,0,0,106,9,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,51,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,52,93,41,0,0,1,0,0,0,108,9,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,52,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,53,93,41,0,0,1,0,0,0,110,9,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,53,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,54,93,41,0,0,1,0,0,0,112,9,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,54,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,55,93,41,0,0,1,0,0,0,114,9,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,55,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,56,93,41,0,0,1,0,0,0,116,9,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,56,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,57,93,41,0,0,1,0,0,0,118,9,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,57,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,48,93,41,0,1,0,0,0,120,9,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,48,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,49,93,41,0,0,0,0,0,0,0,0,1,0,0,0,122,9,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,49,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,50,93,41,0,0,0,0,0,0,0,0,1,0,0,0,124,9,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,50,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,51,93,41,0,0,0,0,0,0,0,0,1,0,0,0,126,9,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,51,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,52,93,41,0,0,0,0,0,0,0,0,1,0,0,0,128,9,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,52,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,53,93,41,0,0,0,0,0,0,0,0,1,0,0,0,130,9,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,53,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,54,93,41,0,0,0,0,0,0,0,0,1,0,0,0,132,9,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,54,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,55,93,41,0,0,0,0,0,0,0,0,1,0,0,0,134,9,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,55,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,56,93,41,0,0,0,0,0,0,0,0,1,0,0,0,136,9,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,56,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,57,93,41,0,0,0,0,0,0,0,0,1,0,0,0,138,9,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,57,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,50,48,93,41,0,0,0,0,0,0,0,0,1,0,0,0,163,9,0,0,109,97,115,115,70,108,111,119,82,97,116,101,50,46,109,101,100,105,117,109,46,100,0,0,1,0,0,0,169,9,0,0,109,97,115,115,70,108,111,119,82,97,116,101,49,46,109,101,100,105,117,109,46,100,0,0,1,0,0,0,171,9,0,0,82,97,109,112,49,46,100,117,114,97,116,105,111,110,0,0,1,0,0,0,176,9,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,49,93,0,0,0,1,0,0,0,184,9,0,0,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,50,48,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,49,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,1,0,0,0,187,9,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,117,105,100,86,111,108,117,109,101,115,91,50,48,93,0,0,0,0,0,1,0,0,0,191,9,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,48,93,0,0,0,1,0,0,0,196,9,0,0,72,69,88,46,112,105,112,101,95,50,46,109,115,91,50,48,93,0,0,0,0,0,0,0,1,0,0,0,206,9,0,0,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,57,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,48,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,1,0,0,0,209,9,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,117,105,100,86,111,108,117,109,101,115,91,49,57,93,0,0,0,0,0,1,0,0,0,213,9,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,57,93,0,0,0,1,0,0,0,218,9,0,0,72,69,88,46,112,105,112,101,95,50,46,109,115,91,49,57,93,0,0,0,0,0,0,0,1,0,0,0,228,9,0,0,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,56,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,57,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,1,0,0,0,231,9,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,117,105,100,86,111,108,117,109,101,115,91,49,56,93,0,0,0,0,0,1,0,0,0,235,9,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,56,93,0,0,0,1,0,0,0,240,9,0,0,72,69,88,46,112,105,112,101,95,50,46,109,115,91,49,56,93,0,0,0,0,0,0,0,1,0,0,0,250,9,0,0,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,55,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,56,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,1,0,0,0,253,9,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,117,105,100,86,111,108,117,109,101,115,91,49,55,93,0,0,0,0,0,1,0,0,0,1,10,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,55,93,0,0,0,1,0,0,0,6,10,0,0,72,69,88,46,112,105,112,101,95,50,46,109,115,91,49,55,93,0,0,0,0,0,0,0,1,0,0,0,16,10,0,0,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,54,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,55,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,1,0,0,0,19,10,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,117,105,100,86,111,108,117,109,101,115,91,49,54,93,0,0,0,0,0,1,0,0,0,23,10,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,54,93,0,0,0,1,0,0,0,28,10,0,0,72,69,88,46,112,105,112,101,95,50,46,109,115,91,49,54,93,0,0,0,0,0,0,0,1,0,0,0,38,10,0,0,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,53,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,54,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,1,0,0,0,41,10,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,117,105,100,86,111,108,117,109,101,115,91,49,53,93,0,0,0,0,0,1,0,0,0,45,10,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,53,93,0,0,0,1,0,0,0,50,10,0,0,72,69,88,46,112,105,112,101,95,50,46,109,115,91,49,53,93,0,0,0,0,0,0,0,1,0,0,0,60,10,0,0,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,52,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,53,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,1,0,0,0,63,10,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,117,105,100,86,111,108,117,109,101,115,91,49,52,93,0,0,0,0,0,1,0,0,0,67,10,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,52,93,0,0,0,1,0,0,0,72,10,0,0,72,69,88,46,112,105,112,101,95,50,46,109,115,91,49,52,93,0,0,0,0,0,0,0,1,0,0,0,82,10,0,0,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,51,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,52,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,1,0,0,0,85,10,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,117,105,100,86,111,108,117,109,101,115,91,49,51,93,0,0,0,0,0,1,0,0,0,89,10,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,51,93,0,0,0,1,0,0,0,94,10,0,0,72,69,88,46,112,105,112,101,95,50,46,109,115,91,49,51,93,0,0,0,0,0,0,0,1,0,0,0,104,10,0,0,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,50,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,51,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,1,0,0,0,107,10,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,117,105,100,86,111,108,117,109,101,115,91,49,50,93,0,0,0,0,0,1,0,0,0,111,10,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,50,93,0,0,0,1,0,0,0,116,10,0,0,72,69,88,46,112,105,112,101,95,50,46,109,115,91,49,50,93,0,0,0,0,0,0,0,1,0,0,0,126,10,0,0,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,49,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,50,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,1,0,0,0,129,10,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,117,105,100,86,111,108,117,109,101,115,91,49,49,93,0,0,0,0,0,1,0,0,0,133,10,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,49,93,0,0,0,1,0,0,0,138,10,0,0,72,69,88,46,112,105,112,101,95,50,46,109,115,91,49,49,93,0,0,0,0,0,0,0,1,0,0,0,148,10,0,0,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,48,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,49,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,1,0,0,0,151,10,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,117,105,100,86,111,108,117,109,101,115,91,49,48,93,0,0,0,0,0,1,0,0,0,155,10,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,48,93,0,0,0,1,0,0,0,160,10,0,0,72,69,88,46,112,105,112,101,95,50,46,109,115,91,49,48,93,0,0,0,0,0,0,0,1,0,0,0,170,10,0,0,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,57,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,48,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,110,80,97,114,97,108,108,101,108,0,1,0,0,0,173,10,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,117,105,100,86,111,108,117,109,101,115,91,57,93,0,0,0,0,0,0,1,0,0,0,177,10,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,57,93,0,0,0,0,1,0,0,0,182,10,0,0,72,69,88,46,112,105,112,101,95,50,46,109,115,91,57,93,0,0,0,0,0,0,0,0,1,0,0,0,192,10,0,0,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,56,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,57,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,110,80,97,114,97,108,108,101,108,0,0,1,0,0,0,195,10,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,117,105,100,86,111,108,117,109,101,115,91,56,93,0,0,0,0,0,0,1,0,0,0,199,10,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,56,93,0,0,0,0,1,0,0,0,204,10,0,0,72,69,88,46,112,105,112,101,95,50,46,109,115,91,56,93,0,0,0,0,0,0,0,0,1,0,0,0,214,10,0,0,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,55,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,56,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,110,80,97,114,97,108,108,101,108,0,0,1,0,0,0,217,10,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,117,105,100,86,111,108,117,109,101,115,91,55,93,0,0,0,0,0,0,1,0,0,0,221,10,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,55,93,0,0,0,0,1,0,0,0,226,10,0,0,72,69,88,46,112,105,112,101,95,50,46,109,115,91,55,93,0,0,0,0,0,0,0,0,1,0,0,0,236,10,0,0,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,54,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,55,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,110,80,97,114,97,108,108,101,108,0,0,1,0,0,0,239,10,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,117,105,100,86,111,108,117,109,101,115,91,54,93,0,0,0,0,0,0,1,0,0,0,243,10,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,54,93,0,0,0,0,1,0,0,0,248,10,0,0,72,69,88,46,112,105,112,101,95,50,46,109,115,91,54,93,0,0,0,0,0,0,0,0,1,0,0,0,2,11,0,0,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,53,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,54,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,110,80,97,114,97,108,108,101,108,0,0,1,0,0,0,5,11,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,117,105,100,86,111,108,117,109,101,115,91,53,93,0,0,0,0,0,0,1,0,0,0,9,11,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,53,93,0,0,0,0,1,0,0,0,14,11,0,0,72,69,88,46,112,105,112,101,95,50,46,109,115,91,53,93,0,0,0,0,0,0,0,0,1,0,0,0,24,11,0,0,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,52,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,53,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,110,80,97,114,97,108,108,101,108,0,0,1,0,0,0,27,11,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,117,105,100,86,111,108,117,109,101,115,91,52,93,0,0,0,0,0,0,1,0,0,0,31,11,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,52,93,0,0,0,0,1,0,0,0,36,11,0,0,72,69,88,46,112,105,112,101,95,50,46,109,115,91,52,93,0,0,0,0,0,0,0,0,1,0,0,0,46,11,0,0,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,51,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,52,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,110,80,97,114,97,108,108,101,108,0,0,1,0,0,0,49,11,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,117,105,100,86,111,108,117,109,101,115,91,51,93,0,0,0,0,0,0,1,0,0,0,53,11,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,51,93,0,0,0,0,1,0,0,0,58,11,0,0,72,69,88,46,112,105,112,101,95,50,46,109,115,91,51,93,0,0,0,0,0,0,0,0,1,0,0,0,68,11,0,0,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,50,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,51,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,110,80,97,114,97,108,108,101,108,0,0,1,0,0,0,71,11,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,117,105,100,86,111,108,117,109,101,115,91,50,93,0,0,0,0,0,0,1,0,0,0,77,11,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,117,105,100,86,111,108,117,109,101,115,91,49,93,0,0,0,0,0,0,1,0,0,0,78,11,0,0,72,69,88,46,112,105,112,101,95,50,46,110,80,97,114,97,108,108,101,108,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,93,0,0,1,0,0,0,81,11,0,0,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,110,80,97,114,97,108,108,101,108,0,0,1,0,0,0,84,11,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,0,0,0,0,1,0,0,0,89,11,0,0,72,69,88,46,112,105,112,101,95,50,46,109,115,91,50,93,0,0,0,0,0,0,0,0,1,0,0,0,97,11,0,0,72,69,88,46,112,105,112,101,95,50,46,109,115,91,49,93,0,0,0,0,0,0,0,0,1,0,0,0,109,11,0,0,72,69,88,46,112,105,112,101,95,49,46,110,80,97,114,97,108,108,101,108,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,49,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,50,48,93,0,0,0,0,0,0,0,0,1,0,0,0,113,11,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,48,93,0,0,0,1,0,0,0,124,11,0,0,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,50,48,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,48,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,50,48,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,0,1,0,0,0,127,11,0,0,40,105,102,32,72,69,88,46,112,105,112,101,95,49,46,118,115,91,50,48,93,32,62,61,32,48,46,48,32,116,104,101,110,32,49,57,46,53,32,101,108,115,101,32,48,46,53,41,32,42,32,72,69,88,46,112,105,112,101,95,49,46,108,101,110,103,116,104,115,91,50,48,93,0,0,0,0,0,0,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,50,48,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,50,48,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,1,0,0,0,128,11,0,0,1,0,0,0,134,11,0,0,72,69,88,46,119,97,108,108,46,99,95,119,97,108,108,32,42,32,72,69,88,46,119,97,108,108,46,109,91,50,48,93,0,0,0,0,0,0,0,0,1,0,0,0,137,11,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,117,105,100,86,111,108,117,109,101,115,91,50,48,93,0,0,0,0,0,1,0,0,0,141,11,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,57,93,0,0,0,1,0,0,0,147,11,0,0,72,69,88,46,112,105,112,101,95,49,46,109,115,91,50,48,93,0,0,0,0,0,0,0,1,0,0,0,159,11,0,0,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,57,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,57,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,49,57,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,0,1,0,0,0,162,11,0,0,40,105,102,32,72,69,88,46,112,105,112,101,95,49,46,118,115,91,49,57,93,32,62,61,32,48,46,48,32,116,104,101,110,32,49,56,46,53,32,101,108,115,101,32,49,46,53,41,32,42,32,72,69,88,46,112,105,112,101,95,49,46,108,101,110,103,116,104,115,91,49,57,93,0,0,0,0,0,0,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,49,57,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,49,57,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,1,0,0,0,163,11,0,0,1,0,0,0,169,11,0,0,72,69,88,46,119,97,108,108], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE);
/* memory initializer */ allocate([46,99,95,119,97,108,108,32,42,32,72,69,88,46,119,97,108,108,46,109,91,49,57,93,0,0,0,0,0,0,0,0,1,0,0,0,172,11,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,117,105,100,86,111,108,117,109,101,115,91,49,57,93,0,0,0,0,0,1,0,0,0,176,11,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,56,93,0,0,0,1,0,0,0,182,11,0,0,72,69,88,46,112,105,112,101,95,49,46,109,115,91,49,57,93,0,0,0,0,0,0,0,1,0,0,0,194,11,0,0,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,56,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,56,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,49,56,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,0,1,0,0,0,197,11,0,0,40,105,102,32,72,69,88,46,112,105,112,101,95,49,46,118,115,91,49,56,93,32,62,61,32,48,46,48,32,116,104,101,110,32,49,55,46,53,32,101,108,115,101,32,50,46,53,41,32,42,32,72,69,88,46,112,105,112,101,95,49,46,108,101,110,103,116,104,115,91,49,56,93,0,0,0,0,0,0,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,49,56,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,49,56,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,1,0,0,0,198,11,0,0,1,0,0,0,204,11,0,0,72,69,88,46,119,97,108,108,46,99,95,119,97,108,108,32,42,32,72,69,88,46,119,97,108,108,46,109,91,49,56,93,0,0,0,0,0,0,0,0,1,0,0,0,207,11,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,117,105,100,86,111,108,117,109,101,115,91,49,56,93,0,0,0,0,0,1,0,0,0,211,11,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,55,93,0,0,0,1,0,0,0,217,11,0,0,72,69,88,46,112,105,112,101,95,49,46,109,115,91,49,56,93,0,0,0,0,0,0,0,1,0,0,0,229,11,0,0,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,55,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,55,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,49,55,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,0,1,0,0,0,232,11,0,0,40,105,102,32,72,69,88,46,112,105,112,101,95,49,46,118,115,91,49,55,93,32,62,61,32,48,46,48,32,116,104,101,110,32,49,54,46,53,32,101,108,115,101,32,51,46,53,41,32,42,32,72,69,88,46,112,105,112,101,95,49,46,108,101,110,103,116,104,115,91,49,55,93,0,0,0,0,0,0,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,49,55,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,49,55,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,1,0,0,0,233,11,0,0,1,0,0,0,239,11,0,0,72,69,88,46,119,97,108,108,46,99,95,119,97,108,108,32,42,32,72,69,88,46,119,97,108,108,46,109,91,49,55,93,0,0,0,0,0,0,0,0,1,0,0,0,242,11,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,117,105,100,86,111,108,117,109,101,115,91,49,55,93,0,0,0,0,0,1,0,0,0,246,11,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,54,93,0,0,0,1,0,0,0,252,11,0,0,72,69,88,46,112,105,112,101,95,49,46,109,115,91,49,55,93,0,0,0,0,0,0,0,1,0,0,0,8,12,0,0,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,54,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,54,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,49,54,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,0,1,0,0,0,11,12,0,0,40,105,102,32,72,69,88,46,112,105,112,101,95,49,46,118,115,91,49,54,93,32,62,61,32,48,46,48,32,116,104,101,110,32,49,53,46,53,32,101,108,115,101,32,52,46,53,41,32,42,32,72,69,88,46,112,105,112,101,95,49,46,108,101,110,103,116,104,115,91,49,54,93,0,0,0,0,0,0,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,49,54,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,49,54,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,1,0,0,0,12,12,0,0,1,0,0,0,18,12,0,0,72,69,88,46,119,97,108,108,46,99,95,119,97,108,108,32,42,32,72,69,88,46,119,97,108,108,46,109,91,49,54,93,0,0,0,0,0,0,0,0,1,0,0,0,21,12,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,117,105,100,86,111,108,117,109,101,115,91,49,54,93,0,0,0,0,0,1,0,0,0,25,12,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,53,93,0,0,0,1,0,0,0,31,12,0,0,72,69,88,46,112,105,112,101,95,49,46,109,115,91,49,54,93,0,0,0,0,0,0,0,1,0,0,0,43,12,0,0,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,53,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,53,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,49,53,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,0,1,0,0,0,46,12,0,0,40,105,102,32,72,69,88,46,112,105,112,101,95,49,46,118,115,91,49,53,93,32,62,61,32,48,46,48,32,116,104,101,110,32,49,52,46,53,32,101,108,115,101,32,53,46,53,41,32,42,32,72,69,88,46,112,105,112,101,95,49,46,108,101,110,103,116,104,115,91,49,53,93,0,0,0,0,0,0,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,49,53,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,49,53,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,1,0,0,0,47,12,0,0,1,0,0,0,53,12,0,0,72,69,88,46,119,97,108,108,46,99,95,119,97,108,108,32,42,32,72,69,88,46,119,97,108,108,46,109,91,49,53,93,0,0,0,0,0,0,0,0,1,0,0,0,56,12,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,117,105,100,86,111,108,117,109,101,115,91,49,53,93,0,0,0,0,0,1,0,0,0,60,12,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,52,93,0,0,0,1,0,0,0,66,12,0,0,72,69,88,46,112,105,112,101,95,49,46,109,115,91,49,53,93,0,0,0,0,0,0,0,1,0,0,0,78,12,0,0,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,52,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,52,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,49,52,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,0,1,0,0,0,81,12,0,0,40,105,102,32,72,69,88,46,112,105,112,101,95,49,46,118,115,91,49,52,93,32,62,61,32,48,46,48,32,116,104,101,110,32,49,51,46,53,32,101,108,115,101,32,54,46,53,41,32,42,32,72,69,88,46,112,105,112,101,95,49,46,108,101,110,103,116,104,115,91,49,52,93,0,0,0,0,0,0,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,49,52,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,49,52,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,1,0,0,0,82,12,0,0,1,0,0,0,88,12,0,0,72,69,88,46,119,97,108,108,46,99,95,119,97,108,108,32,42,32,72,69,88,46,119,97,108,108,46,109,91,49,52,93,0,0,0,0,0,0,0,0,1,0,0,0,91,12,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,117,105,100,86,111,108,117,109,101,115,91,49,52,93,0,0,0,0,0,1,0,0,0,95,12,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,51,93,0,0,0,1,0,0,0,101,12,0,0,72,69,88,46,112,105,112,101,95,49,46,109,115,91,49,52,93,0,0,0,0,0,0,0,1,0,0,0,113,12,0,0,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,51,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,51,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,49,51,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,0,1,0,0,0,116,12,0,0,40,105,102,32,72,69,88,46,112,105,112,101,95,49,46,118,115,91,49,51,93,32,62,61,32,48,46,48,32,116,104,101,110,32,49,50,46,53,32,101,108,115,101,32,55,46,53,41,32,42,32,72,69,88,46,112,105,112,101,95,49,46,108,101,110,103,116,104,115,91,49,51,93,0,0,0,0,0,0,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,49,51,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,49,51,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,1,0,0,0,117,12,0,0,1,0,0,0,123,12,0,0,72,69,88,46,119,97,108,108,46,99,95,119,97,108,108,32,42,32,72,69,88,46,119,97,108,108,46,109,91,49,51,93,0,0,0,0,0,0,0,0,1,0,0,0,126,12,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,117,105,100,86,111,108,117,109,101,115,91,49,51,93,0,0,0,0,0,1,0,0,0,130,12,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,50,93,0,0,0,1,0,0,0,136,12,0,0,72,69,88,46,112,105,112,101,95,49,46,109,115,91,49,51,93,0,0,0,0,0,0,0,1,0,0,0,148,12,0,0,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,50,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,50,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,49,50,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,0,1,0,0,0,151,12,0,0,40,105,102,32,72,69,88,46,112,105,112,101,95,49,46,118,115,91,49,50,93,32,62,61,32,48,46,48,32,116,104,101,110,32,49,49,46,53,32,101,108,115,101,32,56,46,53,41,32,42,32,72,69,88,46,112,105,112,101,95,49,46,108,101,110,103,116,104,115,91,49,50,93,0,0,0,0,0,0,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,49,50,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,49,50,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,1,0,0,0,152,12,0,0,1,0,0,0,158,12,0,0,72,69,88,46,119,97,108,108,46,99,95,119,97,108,108,32,42,32,72,69,88,46,119,97,108,108,46,109,91,49,50,93,0,0,0,0,0,0,0,0,1,0,0,0,161,12,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,117,105,100,86,111,108,117,109,101,115,91,49,50,93,0,0,0,0,0,1,0,0,0,165,12,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,49,93,0,0,0,1,0,0,0,171,12,0,0,72,69,88,46,112,105,112,101,95,49,46,109,115,91,49,50,93,0,0,0,0,0,0,0,1,0,0,0,183,12,0,0,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,49,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,49,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,49,49,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,0,1,0,0,0,186,12,0,0,40,105,102,32,72,69,88,46,112,105,112,101,95,49,46,118,115,91,49,49,93,32,62,61,32,48,46,48,32,116,104,101,110,32,49,48,46,53,32,101,108,115,101,32,57,46,53,41,32,42,32,72,69,88,46,112,105,112,101,95,49,46,108,101,110,103,116,104,115,91,49,49,93,0,0,0,0,0,0,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,49,49,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,49,49,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,1,0,0,0,187,12,0,0,1,0,0,0,193,12,0,0,72,69,88,46,119,97,108,108,46,99,95,119,97,108,108,32,42,32,72,69,88,46,119,97,108,108,46,109,91,49,49,93,0,0,0,0,0,0,0,0,1,0,0,0,196,12,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,117,105,100,86,111,108,117,109,101,115,91,49,49,93,0,0,0,0,0,1,0,0,0,200,12,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,48,93,0,0,0,1,0,0,0,206,12,0,0,72,69,88,46,112,105,112,101,95,49,46,109,115,91,49,49,93,0,0,0,0,0,0,0,1,0,0,0,218,12,0,0,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,48,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,48,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,49,48,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,0,1,0,0,0,221,12,0,0,40,105,102,32,72,69,88,46,112,105,112,101,95,49,46,118,115,91,49,48,93,32,62,61,32,48,46,48,32,116,104,101,110,32,57,46,53,32,101,108,115,101,32,49,48,46,53,41,32,42,32,72,69,88,46,112,105,112,101,95,49,46,108,101,110,103,116,104,115,91,49,48,93,0,0,0,0,0,0,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,49,48,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,49,48,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,1,0,0,0,222,12,0,0,1,0,0,0,228,12,0,0,72,69,88,46,119,97,108,108,46,99,95,119,97,108,108,32,42,32,72,69,88,46,119,97,108,108,46,109,91,49,48,93,0,0,0,0,0,0,0,0,1,0,0,0,231,12,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,117,105,100,86,111,108,117,109,101,115,91,49,48,93,0,0,0,0,0,1,0,0,0,235,12,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,57,93,0,0,0,0,1,0,0,0,241,12,0,0,72,69,88,46,112,105,112,101,95,49,46,109,115,91,49,48,93,0,0,0,0,0,0,0,1,0,0,0,253,12,0,0,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,57,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,57,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,110,80,97,114,97,108,108,101,108,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,57,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,1,0,0,0,0,13,0,0,40,105,102,32,72,69,88,46,112,105,112,101,95,49,46,118,115,91,57,93,32,62,61,32,48,46,48,32,116,104,101,110,32,56,46,53,32,101,108,115,101,32,49,49,46,53,41,32,42,32,72,69,88,46,112,105,112,101,95,49,46,108,101,110,103,116,104,115,91,57,93,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,57,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,57,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,0,0,1,0,0,0,1,13,0,0,1,0,0,0,7,13,0,0,72,69,88,46,119,97,108,108,46,99,95,119,97,108,108,32,42,32,72,69,88,46,119,97,108,108,46,109,91,57,93,0,1,0,0,0,10,13,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,117,105,100,86,111,108,117,109,101,115,91,57,93,0,0,0,0,0,0,1,0,0,0,14,13,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,56,93,0,0,0,0,1,0,0,0,20,13,0,0,72,69,88,46,112,105,112,101,95,49,46,109,115,91,57,93,0,0,0,0,0,0,0,0,1,0,0,0,32,13,0,0,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,56,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,56,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,110,80,97,114,97,108,108,101,108,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,56,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,1,0,0,0,35,13,0,0,40,105,102,32,72,69,88,46,112,105,112,101,95,49,46,118,115,91,56,93,32,62,61,32,48,46,48,32,116,104,101,110,32,55,46,53,32,101,108,115,101,32,49,50,46,53,41,32,42,32,72,69,88,46,112,105,112,101,95,49,46,108,101,110,103,116,104,115,91,56,93,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,56,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,56,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,0,0,1,0,0,0,36,13,0,0,1,0,0,0,42,13,0,0,72,69,88,46,119,97,108,108,46,99,95,119,97,108,108,32,42,32,72,69,88,46,119,97,108,108,46,109,91,56,93,0,1,0,0,0,45,13,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,117,105,100,86,111,108,117,109,101,115,91,56,93,0,0,0,0,0,0,1,0,0,0,49,13,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,55,93,0,0,0,0,1,0,0,0,55,13,0,0,72,69,88,46,112,105,112,101,95,49,46,109,115,91,56,93,0,0,0,0,0,0,0,0,1,0,0,0,67,13,0,0,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,55,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,55,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,110,80,97,114,97,108,108,101,108,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,55,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,1,0,0,0,70,13,0,0,40,105,102,32,72,69,88,46,112,105,112,101,95,49,46,118,115,91,55,93,32,62,61,32,48,46,48,32,116,104,101,110,32,54,46,53,32,101,108,115,101,32,49,51,46,53,41,32,42,32,72,69,88,46,112,105,112,101,95,49,46,108,101,110,103,116,104,115,91,55,93,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,55,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,55,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,0,0,1,0,0,0,71,13,0,0,1,0,0,0,77,13,0,0,72,69,88,46,119,97,108,108,46,99,95,119,97,108,108,32,42,32,72,69,88,46,119,97,108,108,46,109,91,55,93,0,1,0,0,0,80,13,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,117,105,100,86,111,108,117,109,101,115,91,55,93,0,0,0,0,0,0,1,0,0,0,84,13,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,54,93,0,0,0,0,1,0,0,0,90,13,0,0,72,69,88,46,112,105,112,101,95,49,46,109,115,91,55,93,0,0,0,0,0,0,0,0,1,0,0,0,102,13,0,0,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,54,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,54,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,110,80,97,114,97,108,108,101,108,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,54,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,1,0,0,0,105,13,0,0,40,105,102,32,72,69,88,46,112,105,112,101,95,49,46,118,115,91,54,93,32,62,61,32,48,46,48,32,116,104,101,110,32,53,46,53,32,101,108,115,101,32,49,52,46,53,41,32,42,32,72,69,88,46,112,105,112,101,95,49,46,108,101,110,103,116,104,115,91,54,93,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,54,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,54,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,0,0,1,0,0,0,106,13,0,0,1,0,0,0,112,13,0,0,72,69,88,46,119,97,108,108,46,99,95,119,97,108,108,32,42,32,72,69,88,46,119,97,108,108,46,109,91,54,93,0,1,0,0,0,115,13,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,117,105,100,86,111,108,117,109,101,115,91,54,93,0,0,0,0,0,0,1,0,0,0,119,13,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,53,93,0,0,0,0,1,0,0,0,125,13,0,0,72,69,88,46,112,105,112,101,95,49,46,109,115,91,54,93,0,0,0,0,0,0,0,0,1,0,0,0,137,13,0,0,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,53,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,53,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,110,80,97,114,97,108,108,101,108,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,53,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,1,0,0,0,140,13,0,0,40,105,102,32,72,69,88,46,112,105,112,101,95,49,46,118,115,91,53,93,32,62,61,32,48,46,48,32,116,104,101,110,32,52,46,53,32,101,108,115,101,32,49,53,46,53,41,32,42,32,72,69,88,46,112,105,112,101,95,49,46,108,101,110,103,116,104,115,91,53,93,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,53,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,53,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,0,0,1,0,0,0,141,13,0,0,1,0,0,0,147,13,0,0,72,69,88,46,119,97,108,108,46,99,95,119,97,108,108,32,42,32,72,69,88,46,119,97,108,108,46,109,91,53,93,0,1,0,0,0,150,13,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,117,105,100,86,111,108,117,109,101,115,91,53,93,0,0,0,0,0,0,1,0,0,0,154,13,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,52,93,0,0,0,0,1,0,0,0,160,13,0,0,72,69,88,46,112,105,112,101,95,49,46,109,115,91,53,93,0,0,0,0,0,0,0,0,1,0,0,0,172,13,0,0,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,52,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,52,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,110,80,97,114,97,108,108,101,108,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,52,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,1,0,0,0,175,13,0,0,40,105,102,32,72,69,88,46,112,105,112,101,95,49,46,118,115,91,52,93,32,62,61,32,48,46,48,32,116,104,101,110,32,51,46,53,32,101,108,115,101,32,49,54,46,53,41,32,42,32,72,69,88,46,112,105,112,101,95,49,46,108,101,110,103,116,104,115,91,52,93,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,52,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,52,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,0,0,1,0,0,0,176,13,0,0,1,0,0,0,182,13,0,0,72,69,88,46,119,97,108,108,46,99,95,119,97,108,108,32,42,32,72,69,88,46,119,97,108,108,46,109,91,52,93,0,1,0,0,0,185,13,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,117,105,100,86,111,108,117,109,101,115,91,52,93,0,0,0,0,0,0,1,0,0,0,189,13,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,51,93,0,0,0,0,1,0,0,0,195,13,0,0,72,69,88,46,112,105,112,101,95,49,46,109,115,91,52,93,0,0,0,0,0,0,0,0,1,0,0,0,207,13,0,0,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,51,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,51,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,110,80,97,114,97,108,108,101,108,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,51,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,1,0,0,0,210,13,0,0,40,105,102,32,72,69,88,46,112,105,112,101,95,49,46,118,115,91,51,93,32,62,61,32,48,46,48,32,116,104,101,110,32,50,46,53,32,101,108,115,101,32,49,55,46,53,41,32,42,32,72,69,88,46,112,105,112,101,95,49,46,108,101,110,103,116,104,115,91,51,93,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,51,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,51,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,0,0,1,0,0,0,211,13,0,0,1,0,0,0,217,13,0,0,72,69,88,46,119,97,108,108,46,99,95,119,97,108,108,32,42,32,72,69,88,46,119,97,108,108,46,109,91,51,93,0,1,0,0,0,220,13,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,117,105,100,86,111,108,117,109,101,115,91,51,93,0,0,0,0,0,0,1,0,0,0,224,13,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,0,0,0,0,1,0,0,0,230,13,0,0,72,69,88,46,112,105,112,101,95,49,46,109,115,91,51,93,0,0,0,0,0,0,0,0,1,0,0,0,242,13,0,0,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,50,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,110,80,97,114,97,108,108,101,108,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,50,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,1,0,0,0,245,13,0,0,40,105,102,32,72,69,88,46,112,105,112,101,95,49,46,118,115,91,50,93,32,62,61,32,48,46,48,32,116,104,101,110,32,49,46,53,32,101,108,115,101,32,49,56,46,53,41,32,42,32,72,69,88,46,112,105,112,101,95,49,46,108,101,110,103,116,104,115,91,50,93,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,50,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,50,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,0,0,1,0,0,0,246,13,0,0,1,0,0,0,252,13,0,0,72,69,88,46,119,97,108,108,46,99,95,119,97,108,108,32,42,32,72,69,88,46,119,97,108,108,46,109,91,50,93,0,1,0,0,0,255,13,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,117,105,100,86,111,108,117,109,101,115,91,49,93,0,0,0,0,0,0,1,0,0,0,1,14,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,117,105,100,86,111,108,117,109,101,115,91,50,93,0,0,0,0,0,0,1,0,0,0,4,14,0,0,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,110,80,97,114,97,108,108,101,108,0,0,96,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,49,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,1,0,0,0,9,14,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,0,0,0,0,1,0,0,0,13,14,0,0,40,105,102,32,72,69,88,46,112,105,112,101,95,49,46,118,115,91,49,93,32,62,61,32,48,46,48,32,116,104,101,110,32,48,46,53,32,101,108,115,101,32,49,57,46,53,41,32,42,32,72,69,88,46,112,105,112,101,95,49,46,108,101,110,103,116,104,115,91,49,93,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,49,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,49,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+10240);
/* memory initializer */ allocate([1,0,0,0,14,14,0,0,1,0,0,0,21,14,0,0,72,69,88,46,119,97,108,108,46,99,95,119,97,108,108,32,42,32,72,69,88,46,119,97,108,108,46,109,91,49,93,0,1,0,0,0,25,14,0,0,72,69,88,46,112,105,112,101,95,49,46,109,115,91,49,93,0,0,0,0,0,0,0,0,1,0,0,0,32,14,0,0,72,69,88,46,112,105,112,101,95,49,46,109,115,91,50,93,0,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,69,120,97,109,112,108,101,115,47,72,101,97,116,69,120,99,104,97,110,103,101,114,46,109,111,0,0,0,0,87,97,108,108,32,104,97,115,32,110,101,103,97,116,105,118,101,32,100,105,109,101,110,115,105,111,110,115,0,0,0,0,120,80,0,0,207,1,0,0,8,0,0,0,207,1,0,0,54,0,0,0,0,0,0,0,80,114,101,115,115,117,114,101,32,40,61,32,0,0,0,0,32,80,97,41,32,111,102,32,109,101,100,105,117,109,32,34,0,0,0,0,0,0,0,0,87,97,116,101,114,73,70,57,55,0,0,0,0,0,0,0,34,32,105,115,32,110,101,103,97,116,105,118,101,10,40,84,101,109,112,101,114,97,116,117,114,101,32,61,32,0,0,0,32,75,41,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,112,97,99,107,97,103,101,46,109,111,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,80,105,112,101,115,46,109,111,0,0,0,0,0,80,97,114,97,109,101,116,101,114,32,108,101,110,103,116,104,32,109,117,115,116,32,98,101,32,103,114,101,97,116,101,114,32,111,114,32,101,113,117,97,108,32,104,101,105,103,104,116,95,97,98,46,0,0,0,0,176,81,0,0,25,1,0,0,7,0,0,0,25,1,0,0,90,0,0,0,0,0,0,0,119,97,116,101,114,0,0,0,66,111,117,110,100,97,114,121,95,112,84,0,0,0,0,0,77,97,115,115,70,108,111,119,83,111,117,114,99,101,95,84,0,0,0,0,0,0,0,0,104,81,0,0,82,17,0,0,7,0,0,0,83,17,0,0,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,1,0,0,0,8,0,0,0,9,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,1,0,0,0,3,0,0,0,13,0,0,0,4,0,0,0,14,0,0,0,6,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,1,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,69,114,114,111,114,32,119,104,105,108,101,32,105,110,105,116,105,97,108,105,122,101,32,68,97,116,97,0,0,0,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,69,120,97,109,112,108,101,115,46,72,101,97,116,69,120,99,104,97,110,103,101,114,46,72,101,97,116,69,120,99,104,97,110,103,101,114,83,105,109,117,108,97,116,105,111,110,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,69,120,97,109,112,108,101,115,0,0,0,0,0,123,56,99,52,101,56,49,48,102,45,51,100,102,51,45,52,97,48,48,45,56,50,55,54,45,49,55,54,102,97,51,99,57,102,57,101,48,125,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,69,120,97,109,112,108,101,115,46,72,101,97,116,69,120,99,104,97,110,103,101,114,46,72,101,97,116,69,120,99,104,97,110,103,101,114,83,105,109,117,108,97,116,105,111,110,95,105,110,102,111,46,120,109,108,0,0,83,116,97,99,107,32,111,118,101,114,102,108,111,119,32,100,101,116,101,99,116,101,100,32,97,110,100,32,119,97,115,32,110,111,116,32,99,97,117,103,104,116,46,10,83,101,110,100,32,117,115,32,97,32,98,117,103,32,114,101,112,111,114,116,32,97,116,32,104,116,116,112,115,58,47,47,116,114,97,99,46,111,112,101,110,109,111,100,101,108,105,99,97,46,111,114,103,47,79,112,101,110,77,111,100,101,108,105,99,97,47,110,101,119,116,105,99,107,101,116,10,32,32,32,32,73,110,99,108,117,100,101,32,116,104,101,32,102,111,108,108,111,119,105,110,103,32,116,114,97,99,101,58,10,0,0,0,0,0,0,69,120,101,99,117,116,105,111,110,32,102,97,105,108,101,100,33,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,54,52,46,48,32,42,32,82,101,49,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,82,101,49,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,97,117,120,50,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,76,50,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,97,117,120,52,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,76,50,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,97,117,120,53,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,108,97,109,98,100,97,50,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,108,97,109,98,100,97,50,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,50,46,53,49,32,47,32,115,113,114,116,40,108,97,109,98,100,97,50,41,32,43,32,48,46,50,55,32,42,32,68,101,108,116,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,97,117,120,49,32,42,32,97,98,115,40,100,112,95,102,114,105,99,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,50,46,53,49,32,47,32,97,117,120,50,32,43,32,48,46,50,55,32,42,32,68,101,108,116,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,82,101,50,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,82,101,32,47,32,82,101,49,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,68,101,108,116,97,32,47,32,51,46,55,32,43,32,53,46,55,52,32,47,32,82,101,32,94,32,48,46,57,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,114,101,103,70,117,110,51,40,41,58,32,68,97,116,97,32,112,111,105,110,116,115,32,110,111,116,32,115,111,114,116,101,100,32,97,112,112,114,111,112,114,105,97,116,101,108,121,32,40,120,48,32,61,32,0,0,32,62,32,120,49,32,61,32,0,0,0,0,0,0,0,0,41,46,32,80,108,101,97,115,101,32,102,108,105,112,32,97,114,103,117,109,101,110,116,115,46,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,85,116,105,108,105,116,105,101,115,46,109,111,0,168,89,0,0,94,2,0,0,5,0,0,0,95,2,0,0,74,0,0,0,0,0,0,0,114,101,103,70,117,110,51,40,41,58,32,68,101,114,105,118,97,116,105,118,101,115,32,97,116,32,100,97,116,97,32,112,111,105,110,116,115,32,100,111,32,110,111,116,32,97,108,108,111,119,32,99,111,45,109,111,110,111,116,111,110,101,32,105,110,116,101,114,112,111,108,97,116,105,111,110,44,32,97,115,32,98,111,116,104,32,97,114,101,32,110,111,110,45,122,101,114,111,44,32,111,102,32,111,112,112,111,115,105,116,101,32,115,105,103,110,32,97,110,100,32,104,97,118,101,32,97,110,32,97,98,115,111,108,117,116,101,32,118,97,108,117,101,32,108,97,114,103,101,114,32,116,104,97,110,32,109,97,99,104,105,110,101,32,101,112,115,32,40,121,48,100,32,61,32,0,44,32,121,49,100,32,61,32,0,0,0,0,0,0,0,0,41,46,32,80,108,101,97,115,101,32,99,111,114,114,101,99,116,32,97,114,103,117,109,101,110,116,115,46,0,0,0,0,168,89,0,0,101,2,0,0,7,0,0,0,102,2,0,0,79,0,0,0,0,0,0,0,10,87,114,111,110,103,32,118,97,108,117,101,32,111,102,32,112,97,114,97,109,101,116,101,114,32,100,101,102,105,110,101,95,112,32,40,61,32,102,97,108,115,101,41,32,105,110,32,109,111,100,101,108,32,34,0,34,58,10,84,104,101,32,115,101,108,101,99,116,101,100,32,109,101,100,105,117,109,32,34,0,0,0,0,0,0,0,0,34,32,104,97,115,32,77,101,100,105,117,109,46,115,105,110,103,108,101,83,116,97,116,101,61,116,114,117,101,46,10,84,104,101,114,101,102,111,114,101,44,32,97,110,32,98,111,117,110,100,97,114,121,32,100,101,110,115,105,116,121,32,99,97,110,110,111,116,32,98,101,32,100,101,102,105,110,101,100,32,97,110,100,10,100,101,102,105,110,101,95,112,32,61,32,116,114,117,101,32,105,115,32,114,101,113,117,105,114,101,100,46,10,0,0,0,0,0,0,0,168,89,0,0,18,0,0,0,5,0,0,0,23,0,0,0,3,0,0,0,0,0,0,0,10,87,114,111,110,103,32,98,111,117,110,100,97,114,121,32,109,97,115,115,32,102,114,97,99,116,105,111,110,115,32,105,110,32,109,101,100,105,117,109,32,34,0,0,0,0,0,0,34,32,105,110,32,109,111,100,101,108,32,34,0,0,0,0,34,58,10,84,104,101,32,98,111,117,110,100,97,114,121,32,118,97,108,117,101,32,88,95,98,111,117,110,100,97,114,121,40,0,0,0,0,0,0,0,41,32,61,32,0,0,0,0,10,105,115,32,110,101,103,97,116,105,118,101,46,32,73,116,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,46,10,0,0,0,0,0,168,89,0,0,26,0,0,0,7,0,0,0,33,0,0,0,3,0,0,0,0,0,0,0,32,32,32,88,95,98,111,117,110,100,97,114,121,91,0,0,93,32,61,32,0,0,0,0,32,34,0,0,0,0,0,0,34,10,0,0,0,0,0,0,84,104,101,32,98,111,117,110,100,97,114,121,32,109,97,115,115,32,102,114,97,99,116,105,111,110,115,32,105,110,32,109,101,100,105,117,109,32,34,0,100,111,32,110,111,116,32,115,117,109,32,117,112,32,116,111,32,49,46,32,73,110,115,116,101,97,100,44,32,115,117,109,40,88,95,98,111,117,110,100,97,114,121,41,32,61,32,0,58,10,0,0,0,0,0,0,66,97,115,101,73,70,57,55,46,100,111,102,112,116,51,58,32,102,117,110,99,116,105,111,110,32,99,97,108,108,101,100,32,111,117,116,115,105,100,101,32,111,102,32,114,101,103,105,111,110,32,51,33,32,112,32,116,111,111,32,108,111,119,10,112,32,61,32,0,0,0,0,32,80,97,32,60,32,0,0,32,80,97,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,87,97,116,101,114,47,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,109,111,0,0,0,0,0,0,120,93,0,0,117,19,0,0,9,0,0,0,119,19,0,0,76,0,0,0,0,0,0,0,66,97,115,101,73,70,57,55,46,100,111,102,112,116,51,58,32,102,117,110,99,116,105,111,110,32,99,97,108,108,101,100,32,111,117,116,115,105,100,101,32,111,102,32,114,101,103,105,111,110,32,51,33,32,84,32,116,111,111,32,108,111,119,10,84,32,61,32,0,0,0,0,32,75,32,60,32,0,0,0,32,75,0,0,0,0,0,0,120,93,0,0,120,19,0,0,9,0,0,0,122,19,0,0,73,0,0,0,0,0,0,0,66,97,115,101,73,70,57,55,46,100,111,102,112,116,51,58,32,102,117,110,99,116,105,111,110,32,99,97,108,108,101,100,32,111,117,116,115,105,100,101,32,111,102,32,114,101,103,105,111,110,32,51,33,32,84,32,116,111,111,32,104,105,103,104,10,112,32,61,32,0,0,0,32,80,97,44,32,84,32,61,32,0,0,0,0,0,0,0,120,93,0,0,123,19,0,0,9,0,0,0,125,19,0,0,66,0,0,0,0,0,0,0,120,93,0,0,178,19,0,0,9,0,0,0,178,19,0,0,81,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,118,101,114,115,101,32,102,117,110,99,116,105,111,110,32,100,111,102,112,116,51,58,32,105,116,101,114,97,116,105,111,110,32,102,97,105,108,101,100,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,116,115,97,116,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,32,80,97,32,60,61,32,0,32,80,97,32,40,116,114,105,112,108,101,32,112,111,105,110,116,32,112,114,101,115,115,117,114,101,41,0,0,0,0,0,120,93,0,0,82,11,0,0,9,0,0,0,85,11,0,0,41,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,53,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,0,0,32,80,97,32,60,61,32,32,48,46,48,32,80,97,0,0,120,93,0,0,190,8,0,0,9,0,0,0,192,8,0,0,40,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,53,58,32,105,110,112,117,116,32,112,114,101,115,115,117,114,101,32,40,61,32,0,0,0,0,0,32,80,97,41,32,105,115,32,104,105,103,104,101,114,32,116,104,97,110,32,49,48,32,77,112,97,32,105,110,32,114,101,103,105,111,110,32,53,0,0,120,93,0,0,193,8,0,0,9,0,0,0,194,8,0,0,67,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,53,58,32,105,110,112,117,116,32,116,101,109,112,101,114,97,116,117,114,101,32,40,61,32,0,0,32,75,41,32,105,115,32,104,105,103,104,101,114,32,116,104,97,110,32,108,105,109,105,116,32,111,102,32,50,50,55,51,46,49,53,75,32,105,110,32,114,101,103,105,111,110,32,53,0,0,0,0,0,0,0,0,120,93,0,0,195,8,0,0,9,0,0,0,196,8,0,0,77,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,103,46,112,105,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,49,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,0,0,120,93,0,0,103,6,0,0,9,0,0,0,106,6,0,0,41,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,49,58,32,116,104,101,32,105,110,112,117,116,32,112,114,101,115,115,117,114,101,32,40,61,32,0,32,80,97,41,32,105,115,32,104,105,103,104,101,114,32,116,104,97,110,32,49,48,48,32,77,112,97,0,0,0,0,0,120,93,0,0,107,6,0,0,9,0,0,0,108,6,0,0,56,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,49,58,32,116,104,101,32,116,101,109,112,101,114,97,116,117,114,101,32,40,61,32,0,0,0,0,32,75,41,32,105,115,32,108,111,119,101,114,32,116,104,97,110,32,50,55,51,46,49,53,32,75,33,0,0,0,0,0,120,93,0,0,109,6,0,0,9,0,0,0,110,6,0,0,53,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,102,46,100,101,108,116,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,1,0,0,0,216,124,0,0,224,124,0,0,0,0,0,0,1,0,0,0,200,123,0,0,208,123,0,0,0,0,0,0,1,0,0,0,184,122,0,0,192,122,0,0,0,0,0,0,1,0,0,0,184,121,0,0,192,121,0,0,0,0,0,0,1,0,0,0,184,120,0,0,192,120,0,0,0,0,0,0,1,0,0,0,184,119,0,0,192,119,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,111,91,50,53,93,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,50,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,0,0,120,93,0,0,6,7,0,0,9,0,0,0,8,7,0,0,40,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,50,58,32,116,104,101,32,105,110,112,117,116,32,112,114,101,115,115,117,114,101,32,40,61,32,0,120,93,0,0,9,7,0,0,9,0,0,0,10,7,0,0,56,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,50,58,32,116,104,101,32,116,101,109,112,101,114,97,116,117,114,101,32,40,61,32,0,0,0,0,120,93,0,0,11,7,0,0,9,0,0,0,12,7,0,0,53,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,50,58,32,116,104,101,32,105,110,112,117,116,32,116,101,109,112,101,114,97,116,117,114,101,32,40,61,32,0,0,0,0,0,0,32,75,41,32,105,115,32,104,105,103,104,101,114,32,116,104,97,110,32,116,104,101,32,108,105,109,105,116,32,111,102,32,49,48,55,51,46,49,53,32,75,0,0,0,0,0,0,0,120,93,0,0,13,7,0,0,9,0,0,0,15,7,0,0,55,0,0,0,0,0,0,0,48,85,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,116,112,104,49,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,120,93,0,0,37,10,0,0,9,0,0,0,40,10,0,0,41,0,0,0,0,0,0,0,120,93,0,0,204,11,0,0,9,0,0,0,206,11,0,0,62,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,112,115,97,116,58,32,105,110,112,117,116,32,116,101,109,112,101,114,97,116,117,114,101,32,40,61,32,54,49,49,46,54,53,55,32,75,41,46,10,108,111,119,101,114,32,116,104,97,110,32,116,104,101,32,116,114,105,112,108,101,32,112,111,105,110,116,32,116,101,109,112,101,114,97,116,117,114,101,32,50,55,51,46,49,54,32,75,0,0,0,0,1,0,0,0,192,118,0,0,200,118,0,0,0,0,0,0,1,0,0,0,200,117,0,0,208,117,0,0,0,0,0,0,1,0,0,0,208,116,0,0,216,116,0,0,0,0,0,0,1,0,0,0,200,115,0,0,208,115,0,0,0,0,0,0,1,0,0,0,192,114,0,0,200,114,0,0,0,0,0,0,1,0,0,0,184,113,0,0,192,113,0,0,0,0,0,0,1,0,0,0,136,113,0,0,144,113,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,98,111,117,110,100,97,114,121,50,51,111,102,112,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,120,93,0,0,222,0,0,0,9,0,0,0,225,0,0,0,41,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,104,111,102,112,84,50,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,120,93,0,0,19,17,0,0,9,0,0,0,22,17,0,0,41,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,104,111,102,112,84,49,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,120,93,0,0,122,16,0,0,9,0,0,0,125,16,0,0,41,0,0,0,0,0,0,0,120,93,0,0,214,19,0,0,11,0,0,0,215,19,0,0,91,0,0,0,0,0,0,0,73,110,118,101,114,115,101,32,105,116,101,114,97,116,105,111,110,32,111,102,32,100,116,32,102,114,111,109,32,112,104,32,99,97,108,108,101,100,32,105,110,32,50,32,112,104,97,115,101,32,114,101,103,105,111,110,58,32,116,104,105,115,32,99,97,110,32,110,111,116,32,119,111,114,107,0,0,0,0,0,120,93,0,0,246,19,0,0,9,0,0,0,247,19,0,0,65,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,118,101,114,115,101,32,102,117,110,99,116,105,111,110,32,100,116,111,102,112,104,51,58,32,105,116,101,114,97,116,105,111,110,32,102,97,105,108,101,100,0,0,0,0,0,120,93,0,0,221,20,0,0,9,0,0,0,221,20,0,0,81,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,118,101,114,115,101,32,102,117,110,99,116,105,111,110,32,116,111,102,112,104,53,58,32,105,116,101,114,97,116,105,111,110,32,102,97,105,108,101,100,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,104,117,112,112,101,114,111,102,112,49,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,0,0,120,93,0,0,80,1,0,0,9,0,0,0,83,1,0,0,41,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,104,108,111,119,101,114,111,102,112,50,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,0,0,120,93,0,0,160,1,0,0,9,0,0,0,163,1,0,0,41,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,104,108,111,119,101,114,111,102,112,49,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,0,0,120,93,0,0,54,1,0,0,9,0,0,0,57,1,0,0,41,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,104,108,111,119,101,114,111,102,112,53,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,0,0,120,93,0,0,238,0,0,0,9,0,0,0,241,0,0,0,41,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,104,117,112,112,101,114,111,102,112,53,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,0,0,120,93,0,0,255,0,0,0,9,0,0,0,2,1,0,0,41,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,104,117,112,112,101,114,111,102,112,50,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,0,0,120,93,0,0,222,1,0,0,9,0,0,0,225,1,0,0,41,0,0,0,0,0,0,0,1,0,0,0,48,112,0,0,56,112,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,118,105,115,99,95,100,84,112,32,102,111,114,32,118,105,115,99,111,115,105,116,121,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,100,101,110,115,105,116,121,10,100,32,61,32,0,0,0,0,32,60,61,32,0,0,0,0,32,40,116,114,105,112,108,101,32,112,111,105,110,116,32,100,101,110,115,105,116,121,41,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,118,105,115,99,95,100,84,112,58,32,118,105,115,99,111,115,105,116,121,32,99,111,109,112,117,116,101,100,32,111,117,116,115,105,100,101,32,116,104,101,32,114,97,110,103,101,10,111,102,32,118,97,108,105,100,105,116,121,32,111,102,32,116,104,101,32,73,70,57,55,32,102,111,114,109,117,108,97,116,105,111,110,58,32,112,32,61,32,0,0,0,32,80,97,44,32,84,99,32,61,32,0,0,0,0,0,0,120,93,0,0,87,15,0,0,9,0,0,0,90,15,0,0,37,0,0,0,0,0,0,0,120,93,0,0,91,15,0,0,9,0,0,0,96,15,0,0,44,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,114,101,103,105,111,110,32,99,111,109,112,117,116,97,116,105,111,110,32,111,102,32,73,70,57,55,32,115,116,101,97,109,32,116,97,98,108,101,115,40,112,32,61,32,0,0,0,44,32,84,32,61,32,0,0,41,0,0,0,0,0,0,0,120,93,0,0,48,28,0,0,7,0,0,0,49,28,0,0,58,0,0,0,0,0,0,0,1,0,0,0,56,111,0,0,64,111,0,0,0,0,0,0,1,0,0,0,0,111,0,0,8,111,0,0,0,0,0,0,1,0,0,0,216,110,0,0,224,110,0,0,0,0,0,0,1,0,0,0,184,110,0,0,192,110,0,0,0,0,0,0,1,0,0,0,160,110,0,0,168,110,0,0,0,0,0,0,1,0,0,0,120,110,0,0,128,110,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,99,111,110,100,95,100,84,112,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,100,101,110,115,105,116,121,10,100,32,61,32,0,0,120,93,0,0,219,15,0,0,9,0,0,0,222,15,0,0,37,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,99,111,110,100,95,100,84,112,58,32,116,104,101,114,109,97,108,32,99,111,110,100,117,99,116,105,118,105,116,121,32,99,111,109,112,117,116,101,100,32,111,117,116,115,105,100,101,32,116,104,101,32,114,97,110,103,101,10,111,102,32,118,97,108,105,100,105,116,121,32,111,102,32,116,104,101,32,73,70,57,55,32,102,111,114,109,117,108,97,116,105,111,110,58,32,112,32,61,32,0,0,0,0,0,0,0,0,120,93,0,0,223,15,0,0,9,0,0,0,227,15,0,0,44,0,0,0,0,0,0,0,120,93,0,0,255,15,0,0,13,0,0,0,0,16,0,0,81,0,0,0,0,0,0,0,84,104,101,32,115,99,105,101,110,116,105,102,105,99,32,109,101,116,104,111,100,32,119,111,114,107,115,32,111,110,108,121,32,102,111,114,32,116,101,109,112,101,114,97,116,117,114,101,32,117,112,32,116,111,32,54,50,51,46,49,53,32,75,0,84,104,101,114,109,97,108,32,99,111,110,100,117,99,116,105,118,105,116,121,32,99,97,110,32,111,110,108,121,32,98,101,32,99,97,108,108,101,100,32,105,110,32,116,104,101,32,111,110,101,45,112,104,97,115,101,32,114,101,103,105,111,110,115,32,98,101,108,111,119,32,54,50,51,46,49,53,32,75,10,40,112,32,61,32,0,0,0,32,75,44,32,114,101,103,105,111,110,32,61,32,0,0,0,120,93,0,0,40,16,0,0,13,0,0,0,43,16,0,0,54,0,0,0,0,0,0,0,120,93,0,0,11,25,0,0,7,0,0,0,11,25,0,0,71,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,118,101,114,115,101,32,105,116,101,114,97,116,105,111,110,32,111,102,32,115,116,101,97,109,32,116,97,98,108,101,115,0,0,0,0,0,0,44,32,104,32,61,32,0,0,120,93,0,0,22,25,0,0,7,0,0,0,23,25,0,0,58,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,103,159,34,226,65,14,133,63,98,89,122,126,98,174,158,63,172,145,184,34,140,250,143,63,126,174,50,42,219,77,113,191,2,0,0,0,0,0,0,0,170,153,181,20,144,246,197,191,193,139,190,130,52,35,3,64,3,0,0,0,0,0,0,0,11,65,14,74,152,105,217,191,65,127,161,71,140,158,217,63,246,40,92,143,194,245,240,63,4,0,0,0,0,0,0,0,88,101,240,65,25,244,177,63,143,53,35,131,220,69,136,63,102,50,185,164,172,215,91,63,82,184,30,133,235,81,240,191,6,0,0,0,0,0,0,0,70,38,224,215,72,146,228,63,14,74,152,105,251,119,16,192,185,136,239,196,172,183,24,192,135,48,225,68,178,79,105,63,246,252,122,207,146,17,181,63,114,249,15,233,183,47,36,64,30,0,0,0,0,0,0,0,254,193,118,230,212,68,245,63,144,84,58,179,184,58,251,63,213,168,44,175,1,230,20,64,169,77,156,220,239,108,33,64,122,42,241,202,63,164,253,191,179,112,229,46,186,227,217,191,108,8,142,203,184,185,1,192,208,37,28,122,139,63,36,192,234,0,45,2,8,0,35,192,14,196,13,83,182,227,237,63,244,104,79,110,128,62,207,63,182,211,123,207,237,106,250,63,103,75,177,254,42,243,19,64,140,34,181,154,191,131,17,64,0,0,0,0,0,0,0,0,103,33,14,205,205,27,147,63,145,13,197,153,54,142,232,191,137,45,119,69,116,120,209,191,105,210,125,107,237,94,237,191,0,0,0,0,0,0,0,0,37,250,231,47,21,151,192,191,113,238,233,201,128,220,215,63,153,219,214,121,200,146,219,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,46,49,87,133,84,241,166,63,135,89,30,90,26,174,188,191,5,140,236,82,60,17,193,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,42,0,0,0,0,0,0,0,102,233,84,67,44,108,224,63,94,63,14,148,37,132,212,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,146,76,152,122,231,232,191,208,196,42,148,59,34,200,63,25,161,233,54,242,138,203,63,209,13,3,76,207,106,231,63,54,90,14,244,80,219,243,63,203,158,4,54,231,160,247,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,107,108,10,191,47,9,210,191,8,60,48,128,240,33,241,191,149,73,13,109,0,54,244,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,203,126,130,48,92,194,198,63,252,86,235,196,229,120,221,63,107,35,67,51,244,244,205,63,137,194,29,94,198,131,223,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,220,181,41,195,93,98,165,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,251,55,47,78,124,196,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,193,4,234,164,41,144,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,151,88,73,198,146,187,109,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,248,196,66,103,212,192,117,64,133,199,236,54,203,172,242,191,226,202,254,210,61,179,80,63,25,115,134,86,91,228,129,64,99,5,225,42,114,214,43,64,32,0,0,0,0,0,0,0,0,0,0,0,0,0,24,64,0,0,0,0,0,0,32,64,0,0,0,0,0,0,40,64,0,0,0,0,0,0,50,64,0,0,0,0,0,0,16,64,0,0,0,0,0,0,28,64,0,0,0,0,0,0,36,64,0,0,0,0,0,0,20,64,0,0,0,0,0,0,40,64,0,0,0,0,0,0,8,64,0,0,0,0,0,0,16,64,0,0,0,0,0,0,54,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,8,64,0,0,0,0,0,0,28,64,0,0,0,0,0,0,8,64,0,0,0,0,0,0,48,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,64,0,0,0,0,0,0,8,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,32,0,0,0,0,0,0,0,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,36,192,0,0,0,0,0,0,36,192,0,0,0,0,0,0,36,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,16,192,0,0,0,0,0,0,16,192,0,0,0,0,0,0,8,192,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,192,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,8,64,0,0,0,0,0,0,16,64,0,0,0,0,0,0,20,64,0,0,0,0,0,0,32,64,32,0,0,0,0,0,0,0,27,82,16,195,221,180,117,63,91,241,78,159,211,197,197,191,232,255,187,127,199,67,38,64,218,1,248,99,246,5,161,192,206,136,30,128,39,149,64,191,48,128,218,26,207,206,225,63,240,4,46,183,154,223,34,192,202,136,215,255,21,16,211,191,53,217,90,128,221,123,87,64,96,90,249,145,239,193,147,63,112,55,147,142,204,253,218,63,163,49,164,161,90,37,76,193,177,214,63,238,242,53,126,191,8,53,151,241,70,180,214,191,219,168,78,20,129,246,255,191,128,189,125,5,23,121,242,63,106,24,188,51,171,51,182,64,51,132,142,203,34,141,128,63,185,137,15,26,189,17,198,63,103,2,133,8,232,174,240,63,117,149,156,29,96,13,211,191,220,149,151,95,192,238,225,63,74,192,30,215,113,157,209,63,201,162,112,86,16,253,194,191,77,228,10,220,83,171,176,191,227,251,230,96,194,101,7,192,83,250,58,253,84,5,177,63,139,233,23,51,210,47,12,64,66,43,165,221,120,248,141,191,205,57,22,215,212,245,1,192,102,59,4,98,115,175,241,63,101,90,82,13,170,237,164,191,30,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,8,64,0,0,0,0,0,0,24,64,0,0,0,0,0,0,28,64,0,0,0,0,0,0,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,64,0,0,0,0,0,0,20,64,0,0,0,0,0,0,24,64,0,0,0,0,0,0,36,64,0,0,0,0,0,0,8,64,0,0,0,0,0,0,24,64,0,0,0,0,0,0,36,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,16,64,0,0,0,0,0,0,20,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,64,0,0,0,0,0,0,24,64,30,0,0,0,0,0,0,0,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,16,192,0,0,0,0,0,0,16,192,0,0,0,0,0,0,16,192,0,0,0,0,0,0,8,192,0,0,0,0,0,0,8,192,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,192,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,30,0,0,0,0,0,0,0,125,184,117,9,34,88,35,190,173,203,40,168,167,53,78,62,229,95,204,153,121,156,195,62,254,182,180,246,203,101,1,191,18,48,47,21,9,176,81,63,201,60,7,228,82,94,209,191,146,130,40,50,1,39,241,63,80,49,160,27,129,82,235,191,246,174,159,174,28,145,246,190,144,218,49,221,87,56,73,63,102,117,23,114,203,168,113,191,17,114,159,221,142,3,221,63,83,94,100,244,123,63,224,191,136,254,137,238,104,30,89,192,254,28,203,4,207,14,204,191,58,249,102,172,225,175,9,192,18,211,236,226,138,252,130,64,231,85,151,136,54,70,66,63,249,169,122,242,247,255,199,63,70,140,135,102,188,138,130,63,249,126,253,99,70,68,210,63,125,150,168,88,97,228,160,63,230,210,248,105,245,180,206,63,138,172,175,65,105,79,19,64,104,245,29,59,110,155,39,192,119,152,47,138,217,177,197,63,81,88,2,150,187,109,146,191,36,129,254,185,99,9,163,63,224,240,16,12,61,117,171,191,96,179,24,60,39,182,249,63,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,64,0,0,0,0,0,0,24,64,0,0,0,0,0,0,44,64,0,0,0,0,0,0,48,64,0,0,0,0,0,0,52,64,0,0,0,0,0,0,54,64,0,0,0,0,0,0,240,63], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+20480);
/* memory initializer */ allocate([0,0,0,0,0,0,20,64,0,0,0,0,0,0,40,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,16,64,0,0,0,0,0,0,36,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,8,64,0,0,0,0,0,0,16,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,64,0,0,0,0,0,0,16,64,0,0,0,0,0,0,20,64,31,0,0,0,0,0,0,0,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,36,192,0,0,0,0,0,0,36,192,0,0,0,0,0,0,36,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,20,192,0,0,0,0,0,0,8,192,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,192,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,8,64,0,0,0,0,0,0,8,64,0,0,0,0,0,0,16,64,0,0,0,0,0,0,16,64,0,0,0,0,0,0,36,64,0,0,0,0,0,0,40,64,31,0,0,0,0,0,0,0,227,139,224,185,7,240,129,190,199,167,35,43,83,31,211,62,40,114,77,59,34,174,238,190,41,130,212,196,250,47,122,63,63,226,81,247,138,76,119,64,152,254,207,52,139,18,188,192,100,178,19,129,109,128,33,65,128,60,67,165,246,105,68,193,89,239,89,2,195,131,1,191,251,187,130,30,23,35,153,191,195,72,114,66,134,231,71,64,201,118,94,97,66,9,224,62,55,111,232,94,106,7,85,63,170,153,252,205,103,136,145,63,24,215,84,75,40,5,33,192,233,234,135,170,60,245,139,191,125,151,220,87,30,32,208,190,68,241,91,70,74,164,107,63,178,108,175,52,233,166,225,191,206,12,139,3,160,85,231,63,97,97,173,126,173,83,132,191,249,173,4,9,6,139,190,191,51,14,161,48,222,103,233,63,53,239,38,140,197,18,221,63,222,108,213,220,59,225,202,63,33,203,14,111,2,77,122,191,203,46,12,82,120,20,152,191,183,35,106,48,182,169,100,63,238,50,72,229,102,84,127,191,29,139,85,18,145,227,139,63,111,231,135,7,126,62,139,191,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,20,64,0,0,0,0,0,0,36,64,0,0,0,0,0,0,40,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,64,0,0,0,0,0,0,16,64,0,0,0,0,0,0,36,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,20,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,16,64,0,0,0,0,0,0,24,64,0,0,0,0,0,0,36,64,0,0,0,0,0,0,44,64,0,0,0,0,0,0,48,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,63,33,0,0,0,0,0,0,0,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,36,192,0,0,0,0,0,0,36,192,0,0,0,0,0,0,36,192,0,0,0,0,0,0,36,192,0,0,0,0,0,0,36,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,16,192,0,0,0,0,0,0,16,192,0,0,0,0,0,0,8,192,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,192,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,8,64,0,0,0,0,0,0,20,64,0,0,0,0,0,0,24,64,0,0,0,0,0,0,32,64,33,0,0,0,0,0,0,0,77,167,246,65,166,242,0,63,149,115,198,175,185,184,32,191,108,133,64,64,120,47,63,191,140,106,98,88,202,150,89,63,223,23,144,208,200,16,187,63,239,224,44,179,125,118,85,192,164,38,97,234,30,161,134,64,31,236,239,98,140,73,104,63,166,229,119,245,35,71,120,191,219,58,64,176,10,222,137,191,178,42,1,159,147,159,189,191,158,152,86,48,155,57,85,64,166,99,70,220,226,61,134,191,170,142,33,156,255,153,143,63,106,100,216,77,47,54,179,63,132,234,73,145,175,219,153,63,193,132,70,10,49,217,174,191,171,220,81,100,26,156,8,192,247,200,6,135,176,99,173,191,219,94,228,246,139,35,20,64,58,0,51,85,69,154,237,191,184,70,117,189,181,86,15,64,193,109,7,107,34,84,83,192,97,26,42,55,139,138,194,64,245,24,97,50,133,133,53,193,210,177,220,201,81,50,96,65,11,93,150,161,24,142,235,63,150,223,73,71,181,177,212,63,181,166,108,245,236,241,235,63,67,187,199,160,31,242,219,191,232,227,2,191,153,87,210,63,178,144,147,195,28,222,192,191,63,45,198,149,134,183,123,63,99,97,108,108,32,101,120,116,101,114,110,97,108,32,79,98,106,101,99,116,32,67,111,110,115,116,114,117,99,116,111,114,115,0,0,0,0,0,0,0,99,97,108,108,32,101,120,116,101,114,110,97,108,32,79,98,106,101,99,116,32,67,111,110,115,116,114,117,99,116,111,114,115,32,102,105,110,105,115,104,101,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,22,2,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,55,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,56,93,41,0,0,1,0,0,0,24,2,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,54,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,55,93,41,0,0,1,0,0,0,27,2,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,55,93,0,0,0,0,1,0,0,0,33,2,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,55,93,32,94,32,50,46,48,0,0,0,0,0,0,1,0,0,0,41,2,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,56,93,0,0,0,0,1,0,0,0,44,2,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,56,93,32,94,32,50,46,48,0,0,0,0,0,0,1,0,0,0,48,2,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,56,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,57,93,41,0,0,1,0,0,0,54,2,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,57,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,48,93,41,0,1,0,0,0,65,2,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,0,1,0,0,0,68,2,0,0,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,56,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,56,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,110,80,97,114,97,108,108,101,108,0,0,1,0,0,0,71,2,0,0,40,105,102,32,72,69,88,46,112,105,112,101,95,49,46,118,115,91,56,93,32,62,61,32,48,46,48,32,116,104,101,110,32,55,46,53,32,101,108,115,101,32,49,50,46,53,41,32,42,32,72,69,88,46,112,105,112,101,95,49,46,108,101,110,103,116,104,115,91,56,93,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,56,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,1,0,0,0,74,2,0,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,56,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,56,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,0,0,1,0,0,0,78,2,0,0,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,57,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,57,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,110,80,97,114,97,108,108,101,108,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,57,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,1,0,0,0,82,2,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,57,93,32,94,32,50,46,48,0,0,0,0,0,0,1,0,0,0,85,2,0,0,40,105,102,32,72,69,88,46,112,105,112,101,95,49,46,118,115,91,57,93,32,62,61,32,48,46,48,32,116,104,101,110,32,56,46,53,32,101,108,115,101,32,49,49,46,53,41,32,42,32,72,69,88,46,112,105,112,101,95,49,46,108,101,110,103,116,104,115,91,57,93,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,57,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,57,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,0,0,1,0,0,0,86,2,0,0,1,0,0,0,88,2,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,57,93,0,0,0,0,1,0,0,0,91,2,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,48,93,0,0,0,1,0,0,0,95,2,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,48,93,32,94,32,50,46,48,0,0,0,0,0,1,0,0,0,102,2,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,48,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,49,93,41,0,0,0,0,0,0,0,0,1,0,0,0,106,2,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,49,93,0,0,0,1,0,0,0,112,2,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,49,93,32,94,32,50,46,48,0,0,0,0,0,1,0,0,0,116,2,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,49,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,50,93,41,0,0,0,0,0,0,0,0,1,0,0,0,124,2,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,50,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,51,93,41,0,0,0,0,0,0,0,0,1,0,0,0,131,2,0,0,1,0,0,0,136,2,0,0,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,48,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,48,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,49,48,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,0,1,0,0,0,140,2,0,0,40,105,102,32,72,69,88,46,112,105,112,101,95,49,46,118,115,91,49,48,93,32,62,61,32,48,46,48,32,116,104,101,110,32,57,46,53,32,101,108,115,101,32,49,48,46,53,41,32,42,32,72,69,88,46,112,105,112,101,95,49,46,108,101,110,103,116,104,115,91,49,48,93,0,0,0,0,0,0,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,49,48,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,49,48,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,1,0,0,0,141,2,0,0,1,0,0,0,143,2,0,0,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,49,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,49,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,1,0,0,0,146,2,0,0,40,105,102,32,72,69,88,46,112,105,112,101,95,49,46,118,115,91,49,49,93,32,62,61,32,48,46,48,32,116,104,101,110,32,49,48,46,53,32,101,108,115,101,32,57,46,53,41,32,42,32,72,69,88,46,112,105,112,101,95,49,46,108,101,110,103,116,104,115,91,49,49,93,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,49,49,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,0,1,0,0,0,149,2,0,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,49,49,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,49,49,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,1,0,0,0,150,2,0,0,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,50,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,50,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,49,50,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,0,1,0,0,0,154,2,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,50,93,32,94,32,50,46,48,0,0,0,0,0,1,0,0,0,156,2,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,50,93,0,0,0,1,0,0,0,159,2,0,0,40,105,102,32,72,69,88,46,112,105,112,101,95,49,46,118,115,91,49,50,93,32,62,61,32,48,46,48,32,116,104,101,110,32,49,49,46,53,32,101,108,115,101,32,56,46,53,41,32,42,32,72,69,88,46,112,105,112,101,95,49,46,108,101,110,103,116,104,115,91,49,50,93,0,0,0,0,0,0,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,49,50,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,49,50,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,1,0,0,0,160,2,0,0,1,0,0,0,165,2,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,51,93,0,0,0,1,0,0,0,170,2,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,51,93,32,94,32,50,46,48,0,0,0,0,0,1,0,0,0,175,2,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,51,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,52,93,41,0,0,0,0,0,0,0,0,1,0,0,0,183,2,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,52,93,0,0,0,1,0,0,0,191,2,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,52,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,53,93,41,0,0,0,0,0,0,0,0,1,0,0,0,198,2,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,54,93,32,94,32,50,46,48,0,0,0,0,0,1,0,0,0,201,2,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,53,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,54,93,41,0,0,0,0,0,0,0,0,1,0,0,0,203,2,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,52,93,32,94,32,50,46,48,0,0,0,0,0,1,0,0,0,212,2,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,53,93,32,94,32,50,46,48,0,0,0,0,0,1,0,0,0,214,2,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,53,93,0,0,0,1,0,0,0,217,2,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,54,93,0,0,0,1,0,0,0,223,2,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,54,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,55,93,41,0,0,0,0,0,0,0,0,1,0,0,0,230,2,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,55,93,32,94,32,50,46,48,0,0,0,0,0,1,0,0,0,232,2,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,55,93,0,0,0,1,0,0,0,236,2,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,55,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,56,93,41,0,0,0,0,0,0,0,0,1,0,0,0,242,2,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,57,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,50,48,93,41,0,0,0,0,0,0,0,0,1,0,0,0,244,2,0,0,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,50,48,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,1,0,0,0,251,2,0,0,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,1,0,0,0,253,2,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,50,93,41,0,0,1,0,0,0,1,3,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,0,1,0,0,0,2,3,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,94,32,50,46,48,0,0,0,0,0,0,1,0,0,0,4,3,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,0,0,0,0,1,0,0,0,11,3,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,48,93,0,0,0,1,0,0,0,16,3,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,48,93,32,94,32,50,46,48,0,0,0,0,0,1,0,0,0,20,3,0,0,1,0,0,0,28,3,0,0,1,0,0,0,29,3,0,0,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,50,48,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,48,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,1,0,0,0,31,3,0,0,40,105,102,32,72,69,88,46,112,105,112,101,95,49,46,118,115,91,50,48,93,32,62,61,32,48,46,48,32,116,104,101,110,32,49,57,46,53,32,101,108,115,101,32,48,46,53,41,32,42,32,72,69,88,46,112,105,112,101,95,49,46,108,101,110,103,116,104,115,91,50,48,93,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,50,48,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,0,1,0,0,0,34,3,0,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,50,48,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,50,48,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,1,0,0,0,43,3,0,0,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,54,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,54,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,1,0,0,0,46,3,0,0,40,105,102,32,72,69,88,46,112,105,112,101,95,49,46,118,115,91,49,54,93,32,62,61,32,48,46,48,32,116,104,101,110,32,49,53,46,53,32,101,108,115,101,32,52,46,53,41,32,42,32,72,69,88,46,112,105,112,101,95,49,46,108,101,110,103,116,104,115,91,49,54,93,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,49,54,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,0,1,0,0,0,49,3,0,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,49,54,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,49,54,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,1,0,0,0,57,3,0,0,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,51,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,51,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,49,51,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,0,1,0,0,0,61,3,0,0,40,105,102,32,72,69,88,46,112,105,112,101,95,49,46,118,115,91,49,51,93,32,62,61,32,48,46,48,32,116,104,101,110,32,49,50,46,53,32,101,108,115,101,32,55,46,53,41,32,42,32,72,69,88,46,112,105,112,101,95,49,46,108,101,110,103,116,104,115,91,49,51,93,0,0,0,0,0,0,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,49,51,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,49,51,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,1,0,0,0,62,3,0,0,1,0,0,0,64,3,0,0,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,52,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,52,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,49,52,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,0,1,0,0,0,68,3,0,0,40,105,102,32,72,69,88,46,112,105,112,101,95,49,46,118,115,91,49,52,93,32,62,61,32,48,46,48,32,116,104,101,110,32,49,51,46,53,32,101,108,115,101,32,54,46,53,41,32,42,32,72,69,88,46,112,105,112,101,95,49,46,108,101,110,103,116,104,115,91,49,52,93,0,0,0,0,0,0,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,49,52,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,49,52,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,1,0,0,0,69,3,0,0,1,0,0,0,71,3,0,0,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,53,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,53,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,1,0,0,0,73,3,0,0,40,105,102,32,72,69,88,46,112,105,112,101,95,49,46,118,115,91,49,53,93,32,62,61,32,48,46,48,32,116,104,101,110,32,49,52,46,53,32,101,108,115,101,32,53,46,53,41,32,42,32,72,69,88,46,112,105,112,101,95,49,46,108,101,110,103,116,104,115,91,49,53,93,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,49,53,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,0,1,0,0,0,76,3,0,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,49,53,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,49,53,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,1,0,0,0,78,3,0,0,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,55,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,55,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,1,0,0,0,81,3,0,0,40,105,102,32,72,69,88,46,112,105,112,101,95,49,46,118,115,91,49,55,93,32,62,61,32,48,46,48,32,116,104,101,110,32,49,54,46,53,32,101,108,115,101,32,51,46,53,41,32,42,32,72,69,88,46,112,105,112,101,95,49,46,108,101,110,103,116,104,115,91,49,55,93,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,49,55,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,0,1,0,0,0,84,3,0,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,49,55,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,49,55,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,1,0,0,0,85,3,0,0,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,57,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,57,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,49,57,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,0,1,0,0,0,88,3,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,57,93,32,94,32,50,46,48,0,0,0,0,0,1,0,0,0,90,3,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,57,93,0,0,0,1,0,0,0,93,3,0,0,40,105,102,32,72,69,88,46,112,105,112,101,95,49,46,118,115,91,49,57,93,32,62,61,32,48,46,48,32,116,104,101,110,32,49,56,46,53,32,101,108,115,101,32,49,46,53,41,32,42,32,72,69,88,46,112,105,112,101,95,49,46,108,101,110,103,116,104,115,91,49,57,93,0,0,0,0,0,0,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,49,57,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,49,57,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,1,0,0,0,94,3,0,0,1,0,0,0,99,3,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,56,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,57,93,41,0,0,0,0,0,0,0,0,1,0,0,0,101,3,0,0,72,69,88,46,119,97,108,108,46,115,0,0,0,0,0,0,1,0,0,0,109,3,0,0,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,56,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,56,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,49,56,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,0,1,0,0,0,113,3,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,56,93,32,94,32,50,46,48,0,0,0,0,0,1,0,0,0,115,3,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,56,93,0,0,0,1,0,0,0,118,3,0,0,40,105,102,32,72,69,88,46,112,105,112,101,95,49,46,118,115,91,49,56,93,32,62,61,32,48,46,48,32,116,104,101,110,32,49,55,46,53,32,101,108,115,101,32,50,46,53,41,32,42,32,72,69,88,46,112,105,112,101,95,49,46,108,101,110,103,116,104,115,91,49,56,93,0,0,0,0,0,0,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,49,56,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,49,56,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,1,0,0,0,119,3,0,0,1,0,0,0,130,3,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,51,93,32,94,32,50,46,48,0,0,0,0,0,0,1,0,0,0,139,3,0,0,72,69,88,46,112,105,112,101], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+30720);
/* memory initializer */ allocate([95,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,51,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,52,93,41,0,0,1,0,0,0,145,3,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,52,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,53,93,41,0,0,1,0,0,0,147,3,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,53,93,32,94,32,50,46,48,0,0,0,0,0,0,1,0,0,0,150,3,0,0,1,0,0,0,152,3,0,0,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,52,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,53,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,110,80,97,114,97,108,108,101,108,0,0,1,0,0,0,156,3,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,52,93,32,94,32,50,46,48,0,0,0,0,0,0,1,0,0,0,158,3,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,52,93,0,0,0,0,1,0,0,0,162,3,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,51,93,0,0,0,0,1,0,0,0,165,3,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,50,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,51,93,41,0,0,1,0,0,0,166,3,0,0,1,0,0,0,168,3,0,0,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,51,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,52,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,110,80,97,114,97,108,108,101,108,0,0,1,0,0,0,170,3,0,0,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,50,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,51,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,110,80,97,114,97,108,108,101,108,0,0,1,0,0,0,174,3,0,0,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,110,80,97,114,97,108,108,101,108,0,0,1,0,0,0,179,3,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,53,93,0,0,0,0,1,0,0,0,185,3,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,54,93,0,0,0,0,1,0,0,0,190,3,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,54,93,32,94,32,50,46,48,0,0,0,0,0,0,1,0,0,0,194,3,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,53,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,54,93,41,0,0,1,0,0,0,196,3,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,54,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,55,93,41,0,0,1,0,0,0,202,3,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,55,93,0,0,0,0,1,0,0,0,204,3,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,55,93,32,94,32,50,46,48,0,0,0,0,0,0,1,0,0,0,209,3,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,55,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,56,93,41,0,0,1,0,0,0,216,3,0,0,1,0,0,0,220,3,0,0,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,54,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,55,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,110,80,97,114,97,108,108,101,108,0,0,1,0,0,0,227,3,0,0,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,53,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,54,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,110,80,97,114,97,108,108,101,108,0,0,1,0,0,0,231,3,0,0,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,55,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,56,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,110,80,97,114,97,108,108,101,108,0,0,1,0,0,0,233,3,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,56,93,0,0,0,0,1,0,0,0,234,3,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,56,93,32,94,32,50,46,48,0,0,0,0,0,0,1,0,0,0,238,3,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,57,93,0,0,0,0,1,0,0,0,244,3,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,57,93,32,94,32,50,46,48,0,0,0,0,0,0,1,0,0,0,251,3,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,56,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,57,93,41,0,0,1,0,0,0,253,3,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,48,93,0,0,0,1,0,0,0,255,3,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,48,93,32,94,32,50,46,48,0,0,0,0,0,1,0,0,0,11,4,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,50,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,51,93,41,0,0,0,0,0,0,0,0,1,0,0,0,24,4,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,54,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,55,93,41,0,0,0,0,0,0,0,0,1,0,0,0,26,4,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,55,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,56,93,41,0,0,0,0,0,0,0,0,1,0,0,0,29,4,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,56,93,0,0,0,1,0,0,0,31,4,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,56,93,32,94,32,50,46,48,0,0,0,0,0,1,0,0,0,36,4,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,55,93,0,0,0,1,0,0,0,37,4,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,55,93,32,94,32,50,46,48,0,0,0,0,0,1,0,0,0,41,4,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,53,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,54,93,41,0,0,0,0,0,0,0,0,1,0,0,0,43,4,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,52,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,53,93,41,0,0,0,0,0,0,0,0,1,0,0,0,45,4,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,51,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,52,93,41,0,0,0,0,0,0,0,0,1,0,0,0,50,4,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,49,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,50,93,41,0,0,0,0,0,0,0,0,1,0,0,0,52,4,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,48,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,49,93,41,0,0,0,0,0,0,0,0,1,0,0,0,54,4,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,57,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,48,93,41,0,1,0,0,0,57,4,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,49,93,0,0,0,1,0,0,0,59,4,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,49,93,32,94,32,50,46,48,0,0,0,0,0,1,0,0,0,64,4,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,50,93,0,0,0,1,0,0,0,66,4,0,0,1,0,0,0,73,4,0,0,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,50,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,51,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,1,0,0,0,78,4,0,0,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,48,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,49,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,1,0,0,0,83,4,0,0,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,57,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,48,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,110,80,97,114,97,108,108,101,108,0,1,0,0,0,90,4,0,0,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,56,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,57,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,110,80,97,114,97,108,108,101,108,0,0,1,0,0,0,94,4,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,50,93,32,94,32,50,46,48,0,0,0,0,0,1,0,0,0,95,4,0,0,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,49,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,50,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,1,0,0,0,100,4,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,51,93,0,0,0,1,0,0,0,106,4,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,51,93,32,94,32,50,46,48,0,0,0,0,0,1,0,0,0,118,4,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,52,93,32,94,32,50,46,48,0,0,0,0,0,1,0,0,0,119,4,0,0,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,51,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,52,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,1,0,0,0,122,4,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,52,93,0,0,0,1,0,0,0,130,4,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,53,93,0,0,0,1,0,0,0,132,4,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,53,93,32,94,32,50,46,48,0,0,0,0,0,1,0,0,0,135,4,0,0,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,52,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,53,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,1,0,0,0,145,4,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,54,93,0,0,0,1,0,0,0,147,4,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,54,93,32,94,32,50,46,48,0,0,0,0,0,1,0,0,0,148,4,0,0,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,53,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,54,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,1,0,0,0,158,4,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,54,93,32,94,32,50,46,48,0,0,0,0,0,0,1,0,0,0,161,4,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,54,93,0,0,0,0,1,0,0,0,165,4,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,53,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,54,93,41,0,0,1,0,0,0,171,4,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,53,93,32,94,32,50,46,48,0,0,0,0,0,0,1,0,0,0,173,4,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,53,93,0,0,0,0,1,0,0,0,177,4,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,52,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,53,93,41,0,0,1,0,0,0,183,4,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,52,93,32,94,32,50,46,48,0,0,0,0,0,0,1,0,0,0,186,4,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,52,93,0,0,0,0,1,0,0,0,197,4,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,94,32,50,46,48,0,0,0,0,0,0,1,0,0,0,199,4,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,50,93,41,0,0,1,0,0,0,201,4,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,0,0,0,0,1,0,0,0,209,4,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,94,32,50,46,48,0,0,0,0,0,0,1,0,0,0,211,4,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,0,0,0,0,1,0,0,0,216,4,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,50,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,51,93,41,0,0,1,0,0,0,218,4,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,51,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,52,93,41,0,0,1,0,0,0,225,4,0,0,1,0,0,0,227,4,0,0,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,49,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,110,80,97,114,97,108,108,101,108,0,0,1,0,0,0,230,4,0,0,40,105,102,32,72,69,88,46,112,105,112,101,95,49,46,118,115,91,49,93,32,62,61,32,48,46,48,32,116,104,101,110,32,48,46,53,32,101,108,115,101,32,49,57,46,53,41,32,42,32,72,69,88,46,112,105,112,101,95,49,46,108,101,110,103,116,104,115,91,49,93,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,49,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,1,0,0,0,233,4,0,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,49,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,49,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,0,0,1,0,0,0,237,4,0,0,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,50,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,110,80,97,114,97,108,108,101,108,0,0,1,0,0,0,239,4,0,0,40,105,102,32,72,69,88,46,112,105,112,101,95,49,46,118,115,91,50,93,32,62,61,32,48,46,48,32,116,104,101,110,32,49,46,53,32,101,108,115,101,32,49,56,46,53,41,32,42,32,72,69,88,46,112,105,112,101,95,49,46,108,101,110,103,116,104,115,91,50,93,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,50,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,1,0,0,0,242,4,0,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,50,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,50,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,0,0,1,0,0,0,249,4,0,0,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,52,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,52,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,110,80,97,114,97,108,108,101,108,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,52,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,1,0,0,0,252,4,0,0,40,105,102,32,72,69,88,46,112,105,112,101,95,49,46,118,115,91,52,93,32,62,61,32,48,46,48,32,116,104,101,110,32,51,46,53,32,101,108,115,101,32,49,54,46,53,41,32,42,32,72,69,88,46,112,105,112,101,95,49,46,108,101,110,103,116,104,115,91,52,93,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,52,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,52,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,0,0,1,0,0,0,253,4,0,0,1,0,0,0,2,5,0,0,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,53,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,53,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,110,80,97,114,97,108,108,101,108,0,0,1,0,0,0,5,5,0,0,40,105,102,32,72,69,88,46,112,105,112,101,95,49,46,118,115,91,53,93,32,62,61,32,48,46,48,32,116,104,101,110,32,52,46,53,32,101,108,115,101,32,49,53,46,53,41,32,42,32,72,69,88,46,112,105,112,101,95,49,46,108,101,110,103,116,104,115,91,53,93,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,53,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,1,0,0,0,8,5,0,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,53,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,53,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,0,0,1,0,0,0,15,5,0,0,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,55,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,55,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,110,80,97,114,97,108,108,101,108,0,0,1,0,0,0,17,5,0,0,40,105,102,32,72,69,88,46,112,105,112,101,95,49,46,118,115,91,55,93,32,62,61,32,48,46,48,32,116,104,101,110,32,54,46,53,32,101,108,115,101,32,49,51,46,53,41,32,42,32,72,69,88,46,112,105,112,101,95,49,46,108,101,110,103,116,104,115,91,55,93,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,55,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,1,0,0,0,20,5,0,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,55,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,55,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,0,0,1,0,0,0,22,5,0,0,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,54,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,54,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,110,80,97,114,97,108,108,101,108,0,0,1,0,0,0,25,5,0,0,40,105,102,32,72,69,88,46,112,105,112,101,95,49,46,118,115,91,54,93,32,62,61,32,48,46,48,32,116,104,101,110,32,53,46,53,32,101,108,115,101,32,49,52,46,53,41,32,42,32,72,69,88,46,112,105,112,101,95,49,46,108,101,110,103,116,104,115,91,54,93,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,54,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,1,0,0,0,28,5,0,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,54,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,54,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,0,0,1,0,0,0,35,5,0,0,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,51,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,51,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,110,80,97,114,97,108,108,101,108,0,0,64,126,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,109,97,120,40,49,101,45,49,48,44,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,82,101,115,91,51,93,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,1,0,0,0,39,5,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,51,93,32,94,32,50,46,48,0,0,0,0,0,0,1,0,0,0,41,5,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,51,93,0,0,0,0,1,0,0,0,44,5,0,0,40,105,102,32,72,69,88,46,112,105,112,101,95,49,46,118,115,91,51,93,32,62,61,32,48,46,48,32,116,104,101,110,32,50,46,53,32,101,108,115,101,32,49,55,46,53,41,32,42,32,72,69,88,46,112,105,112,101,95,49,46,108,101,110,103,116,104,115,91,51,93,0,49,46,48,32,43,32,49,50,46,55,32,42,32,40,48,46,49,50,53,32,42,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,88,105,115,91,51,93,41,32,94,32,48,46,53,32,42,32,40,45,49,46,48,32,43,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,80,114,115,91,51,93,32,94,32,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,41,0,0,0,0,0,0,1,0,0,0,45,5,0,0,1,0,0,0,60,5,0,0,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,54,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,55,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,1,0,0,0,64,5,0,0,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,55,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,56,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,1,0,0,0,69,5,0,0,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,56,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,57,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,1,0,0,0,70,5,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,57,93,32,94,32,50,46,48,0,0,0,0,0,1,0,0,0,72,5,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,57,93,0,0,0,1,0,0,0,77,5,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,56,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,57,93,41,0,0,0,0,0,0,0,0,1,0,0,0,82,5,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,48,93,32,94,32,50,46,48,0,0,0,0,0,1,0,0,0,83,5,0,0,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,57,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,48,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,1,0,0,0,85,5,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,48,93,0,0,0,1,0,0,0,91,5,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,57,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,50,48,93,41,0,0,0,0,0,0,0,0,1,0,0,0,96,5,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,49,93,32,94,32,50,46,48,0,0,0,0,0,1,0,0,0,97,5,0,0,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,50,48,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,49,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,1,0,0,0,100,5,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,49,93,0,0,0,1,0,0,0,108,5,0,0,1,0,0,0,14,6,0,0,1,0,0,0,18,9,0,0,72,69,88,46,119,97,108,108,46,115,0,0,0,0,0,0,1,0,0,0,18,9,0,0,1,0,0,0,19,9,0,0,1,0,0,0,19,9,0,0,1,0,0,0,20,9,0,0,1,0,0,0,20,9,0,0,1,0,0,0,21,9,0,0,1,0,0,0,21,9,0,0,1,0,0,0,22,9,0,0,1,0,0,0,22,9,0,0,1,0,0,0,23,9,0,0,1,0,0,0,23,9,0,0,1,0,0,0,24,9,0,0,1,0,0,0,24,9,0,0,1,0,0,0,25,9,0,0,1,0,0,0,25,9,0,0,1,0,0,0,26,9,0,0,1,0,0,0,26,9,0,0,1,0,0,0,27,9,0,0,1,0,0,0,27,9,0,0,1,0,0,0,28,9,0,0,1,0,0,0,28,9,0,0,1,0,0,0,29,9,0,0,1,0,0,0,29,9,0,0,1,0,0,0,30,9,0,0,1,0,0,0,30,9,0,0,1,0,0,0,31,9,0,0,1,0,0,0,31,9,0,0,1,0,0,0,32,9,0,0,1,0,0,0,32,9,0,0,1,0,0,0,33,9,0,0,1,0,0,0,33,9,0,0,1,0,0,0,34,9,0,0,1,0,0,0,34,9,0,0,1,0,0,0,35,9,0,0,1,0,0,0,35,9,0,0,1,0,0,0,36,9,0,0,1,0,0,0,36,9,0,0,1,0,0,0,37,9,0,0,1,0,0,0,37,9,0,0,1,0,0,0,133,11,0,0,1,0,0,0,133,11,0,0,1,0,0,0,168,11,0,0,1,0,0,0,168,11,0,0,1,0,0,0,203,11,0,0,1,0,0,0,203,11,0,0,1,0,0,0,238,11,0,0,1,0,0,0,238,11,0,0,1,0,0,0,17,12,0,0,1,0,0,0,17,12,0,0,1,0,0,0,52,12,0,0,1,0,0,0,52,12,0,0,1,0,0,0,87,12,0,0,1,0,0,0,87,12,0,0,1,0,0,0,122,12,0,0,1,0,0,0,122,12,0,0,1,0,0,0,157,12,0,0,1,0,0,0,157,12,0,0,1,0,0,0,192,12,0,0,1,0,0,0,192,12,0,0,1,0,0,0,227,12,0,0,1,0,0,0,227,12,0,0,1,0,0,0,6,13,0,0,1,0,0,0,6,13,0,0,1,0,0,0,41,13,0,0,1,0,0,0,41,13,0,0,1,0,0,0,76,13,0,0,1,0,0,0,76,13,0,0,1,0,0,0,111,13,0,0,1,0,0,0,111,13,0,0,1,0,0,0,146,13,0,0,1,0,0,0,146,13,0,0,1,0,0,0,181,13,0,0,1,0,0,0,181,13,0,0,1,0,0,0,216,13,0,0,1,0,0,0,216,13,0,0,1,0,0,0,251,13,0,0,1,0,0,0,251,13,0,0,1,0,0,0,19,14,0,0,1,0,0,0,19,14,0,0,116,105,109,101,32,60,32,82,97,109,112,49,46,115,116,97,114,116,84,105,109,101,0,0,116,105,109,101,32,60,32,82,97,109,112,49,46,115,116,97,114,116,84,105,109,101,32,43,32,82,97,109,112,49,46,100,117,114,97,116,105,111,110,0,1,0,0,0,171,9,0,0,1,0,0,0,171,9,0,0,152,198,0,0,160,198,0,0,88,198,0,0,112,198,0,0,99,104,101,99,107,32,102,111,114,32,100,105,115,99,114,101,116,101,32,99,104,97,110,103,101,115,0,0,0,0,0,0,36,68,69,82,46,72,69,88,46,119,97,108,108,46,84,91,49,93,0,0,0,0,0,0,36,68,69,82,46,72,69,88,46,119,97,108,108,46,84,91,50,93,0,0,0,0,0,0,36,68,69,82,46,72,69,88,46,119,97,108,108,46,84,91,51,93,0,0,0,0,0,0,36,68,69,82,46,72,69,88,46,119,97,108,108,46,84,91,52,93,0,0,0,0,0,0,36,68,69,82,46,72,69,88,46,119,97,108,108,46,84,91,53,93,0,0,0,0,0,0,36,68,69,82,46,72,69,88,46,119,97,108,108,46,84,91,54,93,0,0,0,0,0,0,36,68,69,82,46,72,69,88,46,119,97,108,108,46,84,91,55,93,0,0,0,0,0,0,36,68,69,82,46,72,69,88,46,119,97,108,108,46,84,91,56,93,0,0,0,0,0,0,36,68,69,82,46,72,69,88,46,119,97,108,108,46,84,91,57,93,0,0,0,0,0,0,36,68,69,82,46,72,69,88,46,119,97,108,108,46,84,91,49,48,93,0,0,0,0,0,36,68,69,82,46,72,69,88,46,119,97,108,108,46,84,91,49,49,93,0,0,0,0,0,36,68,69,82,46,72,69,88,46,119,97,108,108,46,84,91,49,50,93,0,0,0,0,0,36,68,69,82,46,72,69,88,46,119,97,108,108,46,84,91], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+40960);
/* memory initializer */ allocate([49,51,93,0,0,0,0,0,36,68,69,82,46,72,69,88,46,119,97,108,108,46,84,91,49,52,93,0,0,0,0,0,36,68,69,82,46,72,69,88,46,119,97,108,108,46,84,91,49,53,93,0,0,0,0,0,36,68,69,82,46,72,69,88,46,119,97,108,108,46,84,91,49,54,93,0,0,0,0,0,36,68,69,82,46,72,69,88,46,119,97,108,108,46,84,91,49,55,93,0,0,0,0,0,36,68,69,82,46,72,69,88,46,119,97,108,108,46,84,91,49,56,93,0,0,0,0,0,36,68,69,82,46,72,69,88,46,119,97,108,108,46,84,91,49,57,93,0,0,0,0,0,36,68,69,82,46,72,69,88,46,119,97,108,108,46,84,91,50,48,93,0,0,0,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,43,32,40,45,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,103,41,32,42,32,40,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,49,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,50,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,51,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,52,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,53,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,54,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,55,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,56,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,57,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,49,48,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,49,49,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,49,50,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,49,51,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,49,52,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,49,53,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,49,54,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,49,55,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,49,56,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,49,57,93,32,43,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,50,48,93,41,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,95,110,111,109,105,110,97,108,32,45,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,43,32,40,45,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,41,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,109,97,108,108,0,0,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,93,46,84,0,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,93,46,84,0,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,51,93,46,84,0,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,52,93,46,84,0,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,53,93,46,84,0,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,54,93,46,84,0,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,55,93,46,84,0,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,56,93,46,84,0,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,57,93,46,84,0,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,48,93,46,84,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,49,93,46,84,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,50,93,46,84,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,51,93,46,84,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,52,93,46,84,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,53,93,46,84,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,54,93,46,84,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,55,93,46,84,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,56,93,46,84,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,57,93,46,84,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,48,93,46,84,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,93,46,112,0,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,93,46,112,0,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,51,93,46,112,0,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,52,93,46,112,0,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,53,93,46,112,0,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,54,93,46,112,0,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,55,93,46,112,0,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,56,93,46,112,0,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,57,93,46,112,0,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,48,93,46,112,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,49,93,46,112,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,50,93,46,112,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,51,93,46,112,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,52,93,46,112,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,53,93,46,112,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,54,93,46,112,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,55,93,46,112,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,56,93,46,112,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,57,93,46,112,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,48,93,46,112,0,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,43,32,40,45,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,103,41,32,42,32,40,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,49,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,50,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,51,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,52,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,53,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,54,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,55,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,56,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,57,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,49,48,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,49,49,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,49,50,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,49,51,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,49,52,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,49,53,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,49,54,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,49,55,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,49,56,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,49,57,93,32,43,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,50,48,93,41,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,95,110,111,109,105,110,97,108,32,45,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,43,32,40,45,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,41,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,109,97,108,108,0,0,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,93,46,84,0,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,93,46,84,0,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,51,93,46,84,0,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,52,93,46,84,0,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,53,93,46,84,0,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,54,93,46,84,0,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,55,93,46,84,0,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,56,93,46,84,0,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,57,93,46,84,0,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,48,93,46,84,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,49,93,46,84,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,50,93,46,84,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,51,93,46,84,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,52,93,46,84,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,53,93,46,84,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,54,93,46,84,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,55,93,46,84,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,56,93,46,84,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,57,93,46,84,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,48,93,46,84,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,93,46,112,0,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,93,46,112,0,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,51,93,46,112,0,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,52,93,46,112,0,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,53,93,46,112,0,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,54,93,46,112,0,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,55,93,46,112,0,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,56,93,46,112,0,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,57,93,46,112,0,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,48,93,46,112,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,49,93,46,112,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,50,93,46,112,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,51,93,46,112,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,52,93,46,112,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,53,93,46,112,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,54,93,46,112,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,55,93,46,112,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,56,93,46,112,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,57,93,46,112,0,0,0,36,68,69,82,46,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,48,93,46,112,0,0,0,216,198,0,0,240,198,0,0,8,199,0,0,32,199,0,0,56,199,0,0,80,199,0,0,104,199,0,0,128,199,0,0,152,199,0,0,176,199,0,0,200,199,0,0,224,199,0,0,248,199,0,0,16,200,0,0,40,200,0,0,64,200,0,0,88,200,0,0,112,200,0,0,136,200,0,0,160,200,0,0,184,200,0,0,8,204,0,0,120,204,0,0,152,204,0,0,184,204,0,0,216,204,0,0,248,204,0,0,24,205,0,0,56,205,0,0,88,205,0,0,120,205,0,0,152,205,0,0,184,205,0,0,216,205,0,0,248,205,0,0,24,206,0,0,56,206,0,0,88,206,0,0,120,206,0,0,152,206,0,0,184,206,0,0,216,206,0,0,248,206,0,0,24,207,0,0,56,207,0,0,88,207,0,0,120,207,0,0,152,207,0,0,184,207,0,0,216,207,0,0,248,207,0,0,24,208,0,0,56,208,0,0,88,208,0,0,120,208,0,0,152,208,0,0,184,208,0,0,216,208,0,0,248,208,0,0,24,209,0,0,56,209,0,0,88,209,0,0,120,209,0,0,200,212,0,0,56,213,0,0,88,213,0,0,120,213,0,0,152,213,0,0,184,213,0,0,216,213,0,0,248,213,0,0,24,214,0,0,56,214,0,0,88,214,0,0,120,214,0,0,152,214,0,0,184,214,0,0,216,214,0,0,248,214,0,0,24,215,0,0,56,215,0,0,88,215,0,0,120,215,0,0,152,215,0,0,184,215,0,0,216,215,0,0,248,215,0,0,24,216,0,0,56,216,0,0,88,216,0,0,120,216,0,0,152,216,0,0,184,216,0,0,216,216,0,0,248,216,0,0,24,217,0,0,56,217,0,0,88,217,0,0,120,217,0,0,152,217,0,0,184,217,0,0,216,217,0,0,248,217,0,0,24,218,0,0,117,112,100,97,116,105,110,103,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,91,37,100,93,58,32,37,115,32,61,32,37,103,0,0,0,1,0,0,0,34,0,0,0,72,69,88,46,112,105,112,101,95,50,46,112,101,114,105,109,101,116,101,114,0,0,0,0,1,0,0,0,35,0,0,0,1,0,0,0,36,0,0,0,1,0,0,0,37,0,0,0,1,0,0,0,38,0,0,0,1,0,0,0,39,0,0,0,1,0,0,0,40,0,0,0,1,0,0,0,41,0,0,0,1,0,0,0,42,0,0,0,1,0,0,0,43,0,0,0,1,0,0,0,44,0,0,0,1,0,0,0,45,0,0,0,1,0,0,0,46,0,0,0,1,0,0,0,47,0,0,0,1,0,0,0,48,0,0,0,1,0,0,0,49,0,0,0,1,0,0,0,50,0,0,0,1,0,0,0,51,0,0,0,1,0,0,0,52,0,0,0,1,0,0,0,53,0,0,0,1,0,0,0,122,0,0,0,72,69,88,46,112,105,112,101,95,49,46,112,101,114,105,109,101,116,101,114,0,0,0,0,1,0,0,0,123,0,0,0,1,0,0,0,124,0,0,0,1,0,0,0,125,0,0,0,1,0,0,0,126,0,0,0,1,0,0,0,127,0,0,0,1,0,0,0,128,0,0,0,1,0,0,0,129,0,0,0,1,0,0,0,130,0,0,0,1,0,0,0,131,0,0,0,1,0,0,0,132,0,0,0,1,0,0,0,133,0,0,0,1,0,0,0,134,0,0,0,1,0,0,0,135,0,0,0,1,0,0,0,136,0,0,0,1,0,0,0,137,0,0,0,1,0,0,0,138,0,0,0,1,0,0,0,139,0,0,0,1,0,0,0,140,0,0,0,1,0,0,0,141,0,0,0,1,0,0,0,115,1,0,0,97,109,98,105,101,110,116,49,46,109,101,100,105,117,109,46,100,0,0,0,0,0,0,0,1,0,0,0,116,1,0,0,97,109,98,105,101,110,116,50,46,109,101,100,105,117,109,46,100,0,0,0,0,0,0,0,1,0,0,0,121,1,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,1,0,0,0,122,1,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,1,0,0,0,125,1,0,0,82,97,109,112,49,46,100,117,114,97,116,105,111,110,0,0,1,0,0,0,168,6,0,0,72,69,88,46,112,105,112,101,95,49,46,110,80,97,114,97,108,108,101,108,32,42,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,49,93,32,42,32,72,69,88,46,112,105,112,101,95,49,46,99,114,111,115,115,65,114,101,97,115,91,50,48,93,0,0,0,0,0,0,0,0,1,0,0,0,175,6,0,0,72,69,88,46,112,105,112,101,95,50,46,110,80,97,114,97,108,108,101,108,32,42,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,42,32,72,69,88,46,112,105,112,101,95,50,46,99,114,111,115,115,65,114,101,97,115,91,49,93,0,0,1,0,0,0,33,7,0,0,109,97,115,115,70,108,111,119,82,97,116,101,49,46,109,101,100,105,117,109,46,100,0,0,1,0,0,0,52,7,0,0,109,97,115,115,70,108,111,119,82,97,116,101,50,46,109,101,100,105,117,109,46,100,0,0,117,112,100,97,116,105,110,103,32,109,105,110,45,118,97,108,117,101,115,0,0,0,0,0,117,112,100,97,116,105,110,103,32,109,97,120,45,118,97,108,117,101,115,0,0,0,0,0,117,112,100,97,116,105,110,103,32,110,111,109,105,110,97,108,45,118,97,108,117,101,115,0,117,112,100,97,116,105,110,103,32,115,116,97,114,116,45,118,97,108,117,101,115,0,0,0,37,115,40,115,116,97,114,116,61,37,103,41,0,0,0,0,1,0,0,0,154,15,0,0,97,109,98,105,101,110,116,49,46,109,101,100,105,117,109,46,100,0,0,0,0,0,0,0,1,0,0,0,161,15,0,0,97,109,98,105,101,110,116,50,46,109,101,100,105,117,109,46,100,0,0,0,0,0,0,0,1,0,0,0,160,16,0,0,72,69,88,46,112,105,112,101,95,49,46,112,101,114,105,109,101,116,101,114,0,0,0,0,1,0,0,0,161,16,0,0,1,0,0,0,163,16,0,0,1,0,0,0,165,16,0,0,1,0,0,0,167,16,0,0,1,0,0,0,169,16,0,0,1,0,0,0,171,16,0,0,1,0,0,0,173,16,0,0,1,0,0,0,175,16,0,0,1,0,0,0,177,16,0,0,1,0,0,0,179,16,0,0,1,0,0,0,181,16,0,0,1,0,0,0,183,16,0,0,1,0,0,0,185,16,0,0,1,0,0,0,187,16,0,0,1,0,0,0,189,16,0,0,1,0,0,0,191,16,0,0,1,0,0,0,193,16,0,0,1,0,0,0,195,16,0,0,1,0,0,0,197,16,0,0,1,0,0,0,219,16,0,0,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,1,0,0,0,58,17,0,0,72,69,88,46,112,105,112,101,95,50,46,112,101,114,105,109,101,116,101,114,0,0,0,0,1,0,0,0,59,17,0,0,1,0,0,0,61,17,0,0,1,0,0,0,63,17,0,0,1,0,0,0,65,17,0,0,1,0,0,0,67,17,0,0,1,0,0,0,69,17,0,0,1,0,0,0,71,17,0,0,1,0,0,0,73,17,0,0,1,0,0,0,75,17,0,0,1,0,0,0,77,17,0,0,1,0,0,0,79,17,0,0,1,0,0,0,81,17,0,0,1,0,0,0,83,17,0,0,1,0,0,0,85,17,0,0,1,0,0,0,87,17,0,0,1,0,0,0,89,17,0,0,1,0,0,0,91,17,0,0,1,0,0,0,93,17,0,0,1,0,0,0,95,17,0,0,1,0,0,0,117,17,0,0,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,0,0,100,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,115,121,115,116,101,109,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,83,121,115,116,101,109,46,109,111,0,0,0,0,112,226,0,0,32,0,0,0,3,0,0,0,34,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,115,121,115,116,101,109,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,112,226,0,0,29,0,0,0,3,0,0,0,31,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,109,97,115,115,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,109,97,115,115,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,115,121,115,116,101,109,46,109,97,115,115,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,112,226,0,0,26,0,0,0,3,0,0,0,28,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,103,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,84,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,84,95,115,116,97,114,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,112,226,0,0,47,0,0,0,3,0,0,0,49,0,0,0,47,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,112,226,0,0,44,0,0,0,3,0,0,0,46,0,0,0,47,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,109,95,102,108,111,119,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,109,95,102,108,111,119,95,115,109,97,108,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,112,226,0,0,63,0,0,0,3,0,0,0,65,0,0,0,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,100,112,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,100,112,95,115,109,97,108,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,112,226,0,0,60,0,0,0,3,0,0,0,62,0,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,101,112,115,95,109,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,101,112,115,95,109,95,102,108,111,119,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,112,226,0,0,57,0,0,0,3,0,0,0,59,0,0,0,62,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,115,121,115,116,101,109,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,112,226,0,0,35,0,0,0,3,0,0,0,38,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,115,121,115,116,101,109,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,112,226,0,0,22,0,0,0,3,0,0,0,25,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,84,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,112,226,0,0,11,0,0,0,3,0,0,0,13,0,0,0,44,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,112,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,112,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,112,226,0,0,8,0,0,0,3,0,0,0,10,0,0,0,44,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,97,109,112,49,46,100,117,114,97,116,105,111,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,97,109,112,49,46,100,117,114,97,116,105,111,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,66,108,111,99,107,115,47,83,111,117,114,99,101,115,46,109,111,0,0,152,234,0,0,162,1,0,0,5,0,0,0,163,1,0,0,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,97,115,115,70,108,111,119,82,97,116,101,49,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,97,115,115,70,108,111,119,82,97,116,101,49,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,109,97,115,115,70,108,111,119,82,97,116,101,49,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,83,111,117,114,99,101,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,97,115,115,70,108,111,119,82,97,116,101,49,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,97,115,115,70,108,111,119,82,97,116,101,49,46,84,32,62,61,32,49,46,48,32,97,110,100,32,109,97,115,115,70,108,111,119,82,97,116,101,49,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,97,115,115,70,108,111,119,82,97,116,101,49,46,109,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,97,115,115,70,108,111,119,82,97,116,101,49,46,109,95,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,109,97,115,115,70,108,111,119,82,97,116,101,49,46,109,95,102,108,111,119,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,97,115,115,70,108,111,119,82,97,116,101,49,46,102,108,111,119,68,105,114,101,99,116,105,111,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,97,115,115,70,108,111,119,82,97,116,101,49,46,102,108,111,119,68,105,114,101,99,116,105,111,110,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,69,110,116,101,114,105,110,103,32,97,110,100,32,109,97,115,115,70,108,111,119,82,97,116,101,49,46,102,108,111,119,68,105,114,101,99,116,105,111,110,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,66,105,100,105,114,101,99,116,105,111,110,97,108,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,97,115,115,70,108,111,119,82,97,116,101,50,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,97,115,115,70,108,111,119,82,97,116,101,50,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,109,97,115,115,70,108,111,119,82,97,116,101,50,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,128,235,0,0,208,1,0,0,5,0,0,0,211,1,0,0,70,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,97,115,115,70,108,111,119,82,97,116,101,50,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,97,115,115,70,108,111,119,82,97,116,101,50,46,84,32,62,61,32,49,46,48,32,97,110,100,32,109,97,115,115,70,108,111,119,82,97,116,101,50,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,128,235,0,0,204,1,0,0,5,0,0,0,207,1,0,0,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,97,115,115,70,108,111,119,82,97,116,101,50,46,109,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,97,115,115,70,108,111,119,82,97,116,101,50,46,109,95,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,109,97,115,115,70,108,111,119,82,97,116,101,50,46,109,95,102,108,111,119,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,128,235,0,0,200,1,0,0,5,0,0,0,203,1,0,0,54,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,97,115,115,70,108,111,119,82,97,116,101,50,46,102,108,111,119,68,105,114,101,99,116,105,111,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+51200);
/* memory initializer */ allocate([110,116,101,114,118,97,108,58,32,109,97,115,115,70,108,111,119,82,97,116,101,50,46,102,108,111,119,68,105,114,101,99,116,105,111,110,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,69,110,116,101,114,105,110,103,32,97,110,100,32,109,97,115,115,70,108,111,119,82,97,116,101,50,46,102,108,111,119,68,105,114,101,99,116,105,111,110,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,66,105,100,105,114,101,99,116,105,111,110,97,108,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,128,235,0,0,74,3,0,0,5,0,0,0,76,3,0,0,95,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,49,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,49,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,49,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,49,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,49,46,84,32,62,61,32,49,46,48,32,97,110,100,32,97,109,98,105,101,110,116,49,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,49,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,49,46,112,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,49,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,49,46,102,108,111,119,68,105,114,101,99,116,105,111,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,49,46,102,108,111,119,68,105,114,101,99,116,105,111,110,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,69,110,116,101,114,105,110,103,32,97,110,100,32,97,109,98,105,101,110,116,49,46,102,108,111,119,68,105,114,101,99,116,105,111,110,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,66,105,100,105,114,101,99,116,105,111,110,97,108,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,50,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,50,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,50,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,128,235,0,0,150,0,0,0,5,0,0,0,153,0,0,0,70,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,50,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,50,46,84,32,62,61,32,49,46,48,32,97,110,100,32,97,109,98,105,101,110,116,50,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,128,235,0,0,146,0,0,0,5,0,0,0,149,0,0,0,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,50,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,50,46,112,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,50,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,128,235,0,0,142,0,0,0,5,0,0,0,145,0,0,0,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,50,46,102,108,111,119,68,105,114,101,99,116,105,111,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,50,46,102,108,111,119,68,105,114,101,99,116,105,111,110,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,69,110,116,101,114,105,110,103,32,97,110,100,32,97,109,98,105,101,110,116,50,46,102,108,111,119,68,105,114,101,99,116,105,111,110,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,66,105,100,105,114,101,99,116,105,111,110,97,108,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,128,235,0,0,20,3,0,0,5,0,0,0,22,3,0,0,95,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,73,110,116,101,114,102,97,99,101,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,114,111,117,103,104,110,101,115,115,101,115,91,50,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,114,111,117,103,104,110,101,115,115,101,115,91,50,48,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,80,105,112,101,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,114,111,117,103,104,110,101,115,115,101,115,91,49,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,114,111,117,103,104,110,101,115,115,101,115,91,49,57,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,114,111,117,103,104,110,101,115,115,101,115,91,49,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,114,111,117,103,104,110,101,115,115,101,115,91,49,56,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,114,111,117,103,104,110,101,115,115,101,115,91,49,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,114,111,117,103,104,110,101,115,115,101,115,91,49,55,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,114,111,117,103,104,110,101,115,115,101,115,91,49,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,114,111,117,103,104,110,101,115,115,101,115,91,49,54,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,114,111,117,103,104,110,101,115,115,101,115,91,49,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,114,111,117,103,104,110,101,115,115,101,115,91,49,53,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,114,111,117,103,104,110,101,115,115,101,115,91,49,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,114,111,117,103,104,110,101,115,115,101,115,91,49,52,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,114,111,117,103,104,110,101,115,115,101,115,91,49,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,114,111,117,103,104,110,101,115,115,101,115,91,49,51,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,114,111,117,103,104,110,101,115,115,101,115,91,49,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,114,111,117,103,104,110,101,115,115,101,115,91,49,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,114,111,117,103,104,110,101,115,115,101,115,91,49,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,114,111,117,103,104,110,101,115,115,101,115,91,49,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,114,111,117,103,104,110,101,115,115,101,115,91,49,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,114,111,117,103,104,110,101,115,115,101,115,91,49,48,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,114,111,117,103,104,110,101,115,115,101,115,91,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,114,111,117,103,104,110,101,115,115,101,115,91,57,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,114,111,117,103,104,110,101,115,115,101,115,91,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,114,111,117,103,104,110,101,115,115,101,115,91,56,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,114,111,117,103,104,110,101,115,115,101,115,91,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,114,111,117,103,104,110,101,115,115,101,115,91,55,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,114,111,117,103,104,110,101,115,115,101,115,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,114,111,117,103,104,110,101,115,115,101,115,91,54,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,114,111,117,103,104,110,101,115,115,101,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,114,111,117,103,104,110,101,115,115,101,115,91,53,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,114,111,117,103,104,110,101,115,115,101,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,114,111,117,103,104,110,101,115,115,101,115,91,52,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,114,111,117,103,104,110,101,115,115,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,114,111,117,103,104,110,101,115,115,101,115,91,51,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,114,111,117,103,104,110,101,115,115,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,114,111,117,103,104,110,101,115,115,101,115,91,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,114,111,117,103,104,110,101,115,115,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,114,111,117,103,104,110,101,115,115,101,115,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,50,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,50,48,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,50,48,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,49,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,49,57,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,49,57,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,49,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,49,56,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,49,56,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,49,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,49,55,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,49,55,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,49,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,49,54,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,49,54,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,49,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,49,53,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,49,53,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,49,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,49,52,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,49,52,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,49,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,49,51,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,49,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,49,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,49,50,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,49,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,49,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,49,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,49,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,49,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,49,48,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,49,48,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,57,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,57,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,56,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,56,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,55,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,55,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,54,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,54,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,53,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,53,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,52,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,52,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,112,115,95,115,116,97,114,116,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,112,95,98,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,112,95,98,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,112,95,98,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,88,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,88,95,115,116,97,114,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,88,95,115,116,97,114,116,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,112,95,97,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,112,95,97,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,112,95,97,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,97,115,115,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,97,115,115,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,97,115,115,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+61440);
/* memory initializer */ allocate([32,72,69,88,46,112,105,112,101,95,50,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,111,100,101,108,83,116,114,117,99,116,117,114,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,111,100,101,108,83,116,114,117,99,116,117,114,101,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,77,111,100,101,108,83,116,114,117,99,116,117,114,101,46,97,118,95,118,98,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,111,100,101,108,83,116,114,117,99,116,117,114,101,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,77,111,100,101,108,83,116,114,117,99,116,117,114,101,46,97,95,118,98,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,110,78,111,100,101,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,110,78,111,100,101,115,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,104,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,104,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,104,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,84,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,84,95,115,116,97,114,116,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,84,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,114,111,117,103,104,110,101,115,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,114,111,117,103,104,110,101,115,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,110,80,97,114,97,108,108,101,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,110,80,97,114,97,108,108,101,108,32,62,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,104,246,0,0,236,1,0,0,5,0,0,0,237,1,0,0,42,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,114,111,117,103,104,110,101,115,115,101,115,91,50,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,114,111,117,103,104,110,101,115,115,101,115,91,50,48,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,114,111,117,103,104,110,101,115,115,101,115,91,49,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,114,111,117,103,104,110,101,115,115,101,115,91,49,57,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,114,111,117,103,104,110,101,115,115,101,115,91,49,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,114,111,117,103,104,110,101,115,115,101,115,91,49,56,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,114,111,117,103,104,110,101,115,115,101,115,91,49,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,114,111,117,103,104,110,101,115,115,101,115,91,49,55,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,114,111,117,103,104,110,101,115,115,101,115,91,49,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,114,111,117,103,104,110,101,115,115,101,115,91,49,54,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,114,111,117,103,104,110,101,115,115,101,115,91,49,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,114,111,117,103,104,110,101,115,115,101,115,91,49,53,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,114,111,117,103,104,110,101,115,115,101,115,91,49,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,114,111,117,103,104,110,101,115,115,101,115,91,49,52,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,114,111,117,103,104,110,101,115,115,101,115,91,49,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,114,111,117,103,104,110,101,115,115,101,115,91,49,51,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,114,111,117,103,104,110,101,115,115,101,115,91,49,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,114,111,117,103,104,110,101,115,115,101,115,91,49,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,114,111,117,103,104,110,101,115,115,101,115,91,49,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,114,111,117,103,104,110,101,115,115,101,115,91,49,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,114,111,117,103,104,110,101,115,115,101,115,91,49,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,114,111,117,103,104,110,101,115,115,101,115,91,49,48,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,114,111,117,103,104,110,101,115,115,101,115,91,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,114,111,117,103,104,110,101,115,115,101,115,91,57,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,114,111,117,103,104,110,101,115,115,101,115,91,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,114,111,117,103,104,110,101,115,115,101,115,91,56,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,114,111,117,103,104,110,101,115,115,101,115,91,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,114,111,117,103,104,110,101,115,115,101,115,91,55,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,114,111,117,103,104,110,101,115,115,101,115,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,114,111,117,103,104,110,101,115,115,101,115,91,54,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,114,111,117,103,104,110,101,115,115,101,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,114,111,117,103,104,110,101,115,115,101,115,91,53,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,114,111,117,103,104,110,101,115,115,101,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,114,111,117,103,104,110,101,115,115,101,115,91,52,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,114,111,117,103,104,110,101,115,115,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,114,111,117,103,104,110,101,115,115,101,115,91,51,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,114,111,117,103,104,110,101,115,115,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,114,111,117,103,104,110,101,115,115,101,115,91,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,114,111,117,103,104,110,101,115,115,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,114,111,117,103,104,110,101,115,115,101,115,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,48,247,0,0,68,1,0,0,7,0,0,0,70,1,0,0,45,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,48,247,0,0,87,4,0,0,13,0,0,0,91,4,0,0,74,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,48,247,0,0,80,4,0,0,13,0,0,0,82,4,0,0,75,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,48,247,0,0,26,4,0,0,13,0,0,0,28,4,0,0,97,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,48,247,0,0,21,4,0,0,13,0,0,0,23,4,0,0,109,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,48,247,0,0,229,4,0,0,13,0,0,0,231,4,0,0,79,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,48,247,0,0,221,4,0,0,13,0,0,0,222,4,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,48,247,0,0,32,4,0,0,13,0,0,0,34,4,0,0,97,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,48,247,0,0,29,4,0,0,13,0,0,0,31,4,0,0,97,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,50,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,50,48,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,50,48,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,49,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,49,57,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,49,57,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,49,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,49,56,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,49,56,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,49,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,49,55,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,49,55,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,49,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,49,54,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,49,54,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,49,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,49,53,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,49,53,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,49,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,49,52,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,49,52,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,49,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,49,51,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,49,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,49,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,49,50,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,49,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,49,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,49,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,49,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,49,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,49,48,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,49,48,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,57,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,57,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,56,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,56,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,55,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,55,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,54,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,54,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,53,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,53,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,52,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,52,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,112,115,95,115,116,97,114,116,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,104,246,0,0,73,3,0,0,3,0,0,0,75,3,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,112,95,98,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,112,95,98,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,112,95,98,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,104,246,0,0,70,3,0,0,3,0,0,0,72,3,0,0,47,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,104,246,0,0,62,3,0,0,3,0,0,0,64,3,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,104,246,0,0,59,3,0,0,3,0,0,0,61,3,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,88,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,88,95,115,116,97,114,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,88,95,115,116,97,114,116,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,104,246,0,0,92,3,0,0,3,0,0,0,94,3,0,0,69,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,48,247,0,0,83,1,0,0,7,0,0,0,85,1,0,0,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,48,247,0,0,78,1,0,0,7,0,0,0,80,1,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,112,95,97,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,112,95,97,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,112,95,97,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,104,246,0,0,67,3,0,0,3,0,0,0,69,3,0,0,47,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,97,115,115,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,97,115,115,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,97,115,115,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,104,246,0,0,56,3,0,0,3,0,0,0,58,3,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+71680);
/* memory initializer */ allocate([101,95,49,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,104,246,0,0,53,3,0,0,3,0,0,0,55,3,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,111,100,101,108,83,116,114,117,99,116,117,114,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,111,100,101,108,83,116,114,117,99,116,117,114,101,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,77,111,100,101,108,83,116,114,117,99,116,117,114,101,46,97,118,95,118,98,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,111,100,101,108,83,116,114,117,99,116,117,114,101,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,77,111,100,101,108,83,116,114,117,99,116,117,114,101,46,97,95,118,98,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,48,247,0,0,91,1,0,0,7,0,0,0,93,1,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,110,78,111,100,101,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,110,78,111,100,101,115,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,48,247,0,0,88,1,0,0,7,0,0,0,89,1,0,0,57,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,104,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,104,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,104,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,104,246,0,0,86,3,0,0,3,0,0,0,91,3,0,0,88,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,84,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,84,95,115,116,97,114,116,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,84,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,104,246,0,0,80,3,0,0,3,0,0,0,85,3,0,0,84,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,114,111,117,103,104,110,101,115,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,114,111,117,103,104,110,101,115,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,48,247,0,0,7,1,0,0,7,0,0,0,9,1,0,0,47,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,48,247,0,0,255,0,0,0,7,0,0,0,0,1,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,110,80,97,114,97,108,108,101,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,110,80,97,114,97,108,108,101,108,32,62,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,48,247,0,0,248,0,0,0,7,0,0,0,249,0,0,0,45,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,88,95,115,116,97,114,116,95,50,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,88,95,115,116,97,114,116,95,50,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,88,95,115,116,97,114,116,95,50,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,69,120,97,109,112,108,101,115,47,72,101,97,116,69,120,99,104,97,110,103,101,114,46,109,111,0,0,0,0,224,69,1,0,226,0,0,0,7,0,0,0,228,0,0,0,92,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,88,95,115,116,97,114,116,95,49,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,88,95,115,116,97,114,116,95,49,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,88,95,115,116,97,114,116,95,49,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,224,69,1,0,201,0,0,0,7,0,0,0,203,0,0,0,96,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,109,95,119,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,109,95,119,97,108,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,224,69,1,0,159,0,0,0,7,0,0,0,159,0,0,0,72,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,109,91,50,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,109,91,50,48,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,109,91,49,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,109,91,49,57,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,109,91,49,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,109,91,49,56,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,109,91,49,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,109,91,49,55,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,109,91,49,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,109,91,49,54,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,109,91,49,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,109,91,49,53,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,109,91,49,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,109,91,49,52,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,109,91,49,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,109,91,49,51,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,109,91,49,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,109,91,49,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,109,91,49,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,109,91,49,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,109,91,49,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,109,91,49,48,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,109,91,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,109,91,57,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,109,91,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,109,91,56,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,109,91,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,109,91,55,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,109,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,109,91,54,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,109,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,109,91,53,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,109,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,109,91,52,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,109,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,109,91,51,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,109,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,109,91,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,109,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,109,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,224,69,1,0,177,1,0,0,7,0,0,0,178,1,0,0,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,72,69,88,46,119,97,108,108,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,224,69,1,0,181,1,0,0,7,0,0,0,183,1,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,100,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,100,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,224,69,1,0,185,1,0,0,7,0,0,0,185,1,0,0,72,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,95,115,116,97,114,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,224,69,1,0,184,1,0,0,7,0,0,0,184,1,0,0,70,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,114,104,111,95,119,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,114,104,111,95,119,97,108,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,224,69,1,0,172,1,0,0,7,0,0,0,172,1,0,0,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,110,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,224,69,1,0,166,1,0,0,7,0,0,0,167,1,0,0,56,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,95,98,95,115,116,97,114,116,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,95,98,95,115,116,97,114,116,50,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,95,98,95,115,116,97,114,116,50,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,224,69,1,0,211,0,0,0,7,0,0,0,213,0,0,0,70,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,95,97,95,115,116,97,114,116,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,95,97,95,115,116,97,114,116,50,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,95,97,95,115,116,97,114,116,50,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,224,69,1,0,208,0,0,0,7,0,0,0,210,0,0,0,70,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,95,98,95,115,116,97,114,116,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,95,98,95,115,116,97,114,116,49,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,95,98,95,115,116,97,114,116,49,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,224,69,1,0,186,0,0,0,7,0,0,0,188,0,0,0,70,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,95,97,95,115,116,97,114,116,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,95,97,95,115,116,97,114,116,49,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,95,97,95,115,116,97,114,116,49,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,224,69,1,0,183,0,0,0,7,0,0,0,185,0,0,0,70,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,109,95,102,108,111,119,95,115,116,97,114,116,95,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,109,95,102,108,111,119,95,115,116,97,114,116,95,50,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,109,95,102,108,111,119,95,115,116,97,114,116,95,50,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,224,69,1,0,229,0,0,0,7,0,0,0,230,0,0,0,120,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,109,95,102,108,111,119,95,115,116,97,114,116,95,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,109,95,102,108,111,119,95,115,116,97,114,116,95,49,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,109,95,102,108,111,119,95,115,116,97,114,116,95,49,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,224,69,1,0,204,0,0,0,7,0,0,0,205,0,0,0,117,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,72,69,88,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,224,69,1,0,171,0,0,0,7,0,0,0,173,0,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,109,97,115,115,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,109,97,115,115,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,72,69,88,46,109,97,115,115,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,224,69,1,0,168,0,0,0,7,0,0,0,170,0,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,72,69,88,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,224,69,1,0,165,0,0,0,7,0,0,0,167,0,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,104,95,115,116,97,114,116,95,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,104,95,115,116,97,114,116,95,50,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,104,95,115,116,97,114,116,95,50,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,224,69,1,0,220,0,0,0,7,0,0,0,225,0,0,0,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,84,95,115,116,97,114,116,95,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,84,95,115,116,97,114,116,95,50,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,84,95,115,116,97,114,116,95,50,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,224,69,1,0,214,0,0,0,7,0,0,0,219,0,0,0,107,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,104,95,115,116,97,114,116,95,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,104,95,115,116,97,114,116,95,49,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,104,95,115,116,97,114,116,95,49,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,224,69,1,0,195,0,0,0,7,0,0,0,200,0,0,0,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,84,95,115,116,97,114,116,95,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,84,95,115,116,97,114,116,95,49,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,84,95,115,116,97,114,116,95,49,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,224,69,1,0,189,0,0,0,7,0,0,0,194,0,0,0,107,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,100,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,100,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,224,69,1,0,178,0,0,0,7,0,0,0,179,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,84,119,97,108,108,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,84,119,97,108,108,95,115,116,97,114,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,224,69,1,0,176,0,0,0,7,0,0,0,177,0,0,0,131,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,114,104,111,95,119,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,114,104,111,95,119,97,108,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,224,69,1,0,155,0,0,0,7,0,0,0,156,0,0,0,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,115,95,119,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,115,95,119,97,108,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,224,69,1,0,147,0,0,0,7,0,0,0,148,0,0,0,53,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,109,111,100,101,108,83,116,114,117,99,116,117,114,101,95,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,109,111,100,101,108,83,116,114,117,99,116,117,114,101,95,50,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,77,111,100,101,108,83,116,114,117,99,116,117,114,101,46,97,118,95,118,98,32,97,110,100,32,72,69,88,46,109,111,100,101,108,83,116,114,117,99,116,117,114,101,95,50,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,77,111,100,101,108,83,116,114,117,99,116,117,114,101,46,97,95,118,98,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,224,69,1,0,115,0,0,0,7,0,0,0,117,0,0,0,73,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,109,111,100,101,108,83,116,114,117,99,116,117,114,101,95,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,109,111,100,101,108,83,116,114,117,99,116,117,114,101,95,49,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,77,111,100,101,108,83,116,114,117,99,116,117,114,101,46,97,118,95,118,98,32,97,110,100,32,72,69,88,46,109,111,100,101,108,83,116,114,117,99,116,117,114,101,95,49,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,77,111,100,101,108,83,116,114,117,99,116,117,114,101,46,97,95,118,98,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,224,69,1,0,112,0,0,0,7,0,0,0,114,0,0,0,73,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,110,78,111,100,101,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,110,78,111,100,101,115,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,224,69,1,0,111,0,0,0,7,0,0,0,111,0,0,0,65,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,108,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,108,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,224,69,1,0,110,0,0,0,7,0,0,0,110,0,0,0,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,48,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,48,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,48,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,87,97,116,101,114,47,112,97,99,107,97,103,101,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,57,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,57,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,57,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,56,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,56,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,56,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,55,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,55,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,55,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,54,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,54,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,54,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,53,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,53,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,53,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,52,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,52,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,52,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,51,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,51,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,51,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,50,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,50,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,50,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,49,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,49,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,49,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,48,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,48,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,48,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,57,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,57,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,57,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,56,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,56,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,56,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,55,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+81920);
/* memory initializer */ allocate([44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,55,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,55,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,54,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,54,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,54,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,53,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,53,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,53,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,52,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,52,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,52,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,51,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,51,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,51,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,112,97,99,107,97,103,101,46,109,111,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,48,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,48,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,48,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,57,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,57,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,57,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,56,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,56,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,56,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,55,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,55,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,55,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,54,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,54,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,54,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,53,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,53,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,53,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,52,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,52,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,52,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,51,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,51,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,51,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,50,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,50,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,50,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,49,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,49,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,49,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,48,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,48,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,48,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,57,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,57,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,57,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,56,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,56,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,56,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,55,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,55,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,55,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,54,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,54,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,54,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,53,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,53,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,53,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,52,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,52,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,52,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,51,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,51,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,51,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,50,46,109,101,100,105,117,109,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,50,46,109,101,100,105,117,109,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,50,46,109,101,100,105,117,109,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,50,46,109,101,100,105,117,109,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,50,46,109,101,100,105,117,109,46,100,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,50,46,109,101,100,105,117,109,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,50,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,50,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,97,109,98,105,101,110,116,50,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,49,46,109,101,100,105,117,109,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,49,46,109,101,100,105,117,109,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,49,46,109,101,100,105,117,109,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,200,108,1,0,33,17,0,0,7,0,0,0,33,17,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,49,46,109,101,100,105,117,109,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,49,46,109,101,100,105,117,109,46,100,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,49,46,109,101,100,105,117,109,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,200,108,1,0,34,17,0,0,7,0,0,0,34,17,0,0,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,49,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,49,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,97,109,98,105,101,110,116,49,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,200,108,1,0,150,27,0,0,7,0,0,0,150,27,0,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,49,46,109,101,100,105,117,109,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,49,46,109,101,100,105,117,109,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,49,46,109,101,100,105,117,109,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,50,46,109,101,100,105,117,109,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,50,46,109,101,100,105,117,109,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,50,46,109,101,100,105,117,109,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,200,108,1,0,38,17,0,0,7,0,0,0,38,17,0,0,68,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,49,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,49,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,49,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,48,247,0,0,52,4,0,0,13,0,0,0,52,4,0,0,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,50,49,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,50,49,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,50,49,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,96,1,0,145,0,0,0,5,0,0,0,145,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,48,247,0,0,245,4,0,0,13,0,0,0,1,5,0,0,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,97,115,115,70,108,111,119,82,97,116,101,49,46,109,101,100,105,117,109,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,97,115,115,70,108,111,119,82,97,116,101,49,46,109,101,100,105,117,109,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,109,97,115,115,70,108,111,119,82,97,116,101,49,46,109,101,100,105,117,109,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,97,115,115,70,108,111,119,82,97,116,101,49,46,109,101,100,105,117,109,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,97,115,115,70,108,111,119,82,97,116,101,49,46,109,101,100,105,117,109,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,109,97,115,115,70,108,111,119,82,97,116,101,49,46,109,101,100,105,117,109,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,97,115,115,70,108,111,119,82,97,116,101,49,46,109,101,100,105,117,109,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,97,115,115,70,108,111,119,82,97,116,101,49,46,109,101,100,105,117,109,46,82,32,62,61,32,48,46,48,32,97,110,100,32,109,97,115,115,70,108,111,119,82,97,116,101,49,46,109,101,100,105,117,109,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,97,115,115,70,108,111,119,82,97,116,101,49,46,109,101,100,105,117,109,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,97,115,115,70,108,111,119,82,97,116,101,49,46,109,101,100,105,117,109,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,109,97,115,115,70,108,111,119,82,97,116,101,49,46,109,101,100,105,117,109,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,97,115,115,70,108,111,119,82,97,116,101,50,46,109,101,100,105,117,109,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,97,115,115,70,108,111,119,82,97,116,101,50,46,109,101,100,105,117,109,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,109,97,115,115,70,108,111,119,82,97,116,101,50,46,109,101,100,105,117,109,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,97,115,115,70,108,111,119,82,97,116,101,50,46,109,101,100,105,117,109,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,97,115,115,70,108,111,119,82,97,116,101,50,46,109,101,100,105,117,109,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,109,97,115,115,70,108,111,119,82,97,116,101,50,46,109,101,100,105,117,109,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,97,115,115,70,108,111,119,82,97,116,101,50,46,109,101,100,105,117,109,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,97,115,115,70,108,111,119,82,97,116,101,50,46,109,101,100,105,117,109,46,82,32,62,61,32,48,46,48,32,97,110,100,32,109,97,115,115,70,108,111,119,82,97,116,101,50,46,109,101,100,105,117,109,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,97,115,115,70,108,111,119,82,97,116,101,50,46,109,101,100,105,117,109,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,97,115,115,70,108,111,119,82,97,116,101,50,46,109,101,100,105,117,109,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,109,97,115,115,70,108,111,119,82,97,116,101,50,46,109,101,100,105,117,109,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,49,46,109,101,100,105,117,109,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,49,46,109,101,100,105,117,109,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,49,46,109,101,100,105,117,109,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,49,46,109,101,100,105,117,109,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,49,46,109,101,100,105,117,109,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,97,109,98,105,101,110,116,49,46,109,101,100,105,117,109,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,49,46,109,101,100,105,117,109,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,49,46,109,101,100,105,117,109,46,82,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,49,46,109,101,100,105,117,109,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,49,46,109,101,100,105,117,109,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,49,46,109,101,100,105,117,109,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,97,109,98,105,101,110,116,49,46,109,101,100,105,117,109,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,50,46,109,101,100,105,117,109,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,50,46,109,101,100,105,117,109,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,50,46,109,101,100,105,117,109,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,50,46,109,101,100,105,117,109,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,50,46,109,101,100,105,117,109,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,97,109,98,105,101,110,116,50,46,109,101,100,105,117,109,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,96,1,0,164,0,0,0,5,0,0,0,168,0,0,0,70,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,50,46,109,101,100,105,117,109,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,50,46,109,101,100,105,117,109,46,82,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,50,46,109,101,100,105,117,109,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,50,46,109,101,100,105,117,109,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,50,46,109,101,100,105,117,109,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,97,109,98,105,101,110,116,50,46,109,101,100,105,117,109,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,48,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,48,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,48,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,48,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,48,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,48,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,48,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,48,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,48,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,57,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,57,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,57,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,57,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,57,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+92160);
/* memory initializer */ allocate([112,101,95,50,46,109,101,100,105,117,109,115,91,49,57,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,57,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,57,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,57,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,56,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,56,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,56,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,56,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,56,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,56,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,56,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,56,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,56,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,55,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,55,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,55,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,55,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,55,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,55,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,55,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,55,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,55,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,54,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,54,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,54,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,54,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,54,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,54,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,54,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,54,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,54,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,53,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,53,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,53,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,53,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,53,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,53,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,53,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,53,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,53,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,52,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,52,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,52,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,52,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,52,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,52,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,52,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,52,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,52,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,51,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,51,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,51,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,51,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,51,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,51,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,51,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,51,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,51,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,50,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,50,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,50,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,50,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,50,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,50,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,50,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,50,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,50,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,49,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,49,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,49,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,49,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,49,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,49,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,49,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,49,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,49,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,48,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,48,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,48,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,48,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,48,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,48,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,48,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,48,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,48,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,57,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,57,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,57,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,57,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,57,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,57,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,57,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,57,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,57,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,56,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,56,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,56,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,56,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,56,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,56,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,56,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,56,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,56,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,55,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,55,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,55,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,55,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,55,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,55,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,55,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,55,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,55,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,54,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,54,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,54,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,54,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,54,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,54,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,54,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,54,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,54,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,53,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,53,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,53,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,53,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,53,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,53,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,53,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,53,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,53,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,52,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,52,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,52,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,52,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,52,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,52,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,52,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,52,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,52,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,51,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,51,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,51,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,51,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,51,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,51,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,51,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,51,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,51,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,200,108,1,0,74,22,0,0,7,0,0,0,75,22,0,0,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,48,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,48,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,48,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,48,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,48,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,48,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,48,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,48,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,48,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,57,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,57,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,57,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,57,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,57,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,57,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,57,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,57,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,57,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,56,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,56,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,56,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,56,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,56,93,46,82,32,62], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+102400);
/* memory initializer */ allocate([61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,56,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,56,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,56,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,56,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,55,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,55,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,55,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,55,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,55,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,55,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,55,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,55,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,55,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,54,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,54,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,54,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,54,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,54,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,54,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,54,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,54,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,54,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,53,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,53,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,53,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,53,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,53,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,53,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,53,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,53,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,53,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,52,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,52,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,52,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,52,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,52,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,52,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,52,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,52,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,52,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,51,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,51,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,51,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,51,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,51,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,51,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,51,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,51,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,51,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,50,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,50,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,50,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,50,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,50,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,50,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,50,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,50,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,50,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,49,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,49,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,49,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,49,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,49,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,49,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,49,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,49,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,49,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,48,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,48,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,48,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,48,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,48,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,48,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,48,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,48,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,48,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,57,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,57,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,57,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,57,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,57,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,57,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,57,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,57,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,57,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,56,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,56,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,56,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,56,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,56,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,56,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,56,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,56,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,56,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,55,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,55,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,55,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,55,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,55,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,55,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,55,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,55,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,55,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,54,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,54,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,54,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,54,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,54,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,54,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,54,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,54,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,54,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,53,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,53,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,53,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,53,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,53,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,53,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,53,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,53,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,53,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,52,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,52,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,52,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,52,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,52,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,52,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,52,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,52,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,52,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,51,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,51,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,51,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,51,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,51,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,51,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,51,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,51,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,51,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,200,108,1,0,36,17,0,0,7,0,0,0,37,17,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,200,108,1,0,39,17,0,0,7,0,0,0,39,17,0,0,71,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,200,108,1,0,40,17,0,0,7,0,0,0,40,17,0,0,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,48,247,0,0,55,4,0,0,13,0,0,0,55,4,0,0,125,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,103,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,111,114,116,95,98,49,46,104,95,111,117,116,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,111,114,116,95,98,49,46,104,95,111,117,116,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,111,114,116,95,98,49,46,104,95,111,117,116,102,108,111,119,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,73,110,116,101,114,102,97,99,101,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,111,114,116,95,97,49,46,104,95,111,117,116,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,111,114,116,95,97,49,46,104,95,111,117,116,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,111,114,116,95,97,49,46,104,95,111,117,116,102,108,111,119,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,111,114,116,95,98,50,46,104,95,111,117,116,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,111,114,116,95,98,50,46,104,95,111,117,116,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,111,114,116,95,98,50,46,104,95,111,117,116,102,108,111,119,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,111,114,116,95,97,50,46,104,95,111,117,116,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,111,114,116,95,97,50,46,104,95,111,117,116,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,111,114,116,95,97,50,46,104,95,111,117,116,102,108,111,119,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,48,219,1,0,16,0,0,0,5,0,0,0,17,0,0,0,84,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,98,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,98,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,69,120,97,109,112,108,101,115,47,72,101,97,116,69,120,99,104,97,110,103,101,114,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,98,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,98,91,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,98,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,98,91,51,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,98,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,98,91,52,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,98,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,98,91,53,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,98,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+112640);
/* memory initializer */ allocate([119,97,108,108,46,84,98,91,54,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,98,91,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,98,91,55,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,98,91,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,98,91,56,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,98,91,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,98,91,57,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,98,91,49,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,98,91,49,48,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,98,91,49,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,98,91,49,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,98,91,49,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,98,91,49,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,98,91,49,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,98,91,49,51,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,98,91,49,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,98,91,49,52,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,98,91,49,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,98,91,49,53,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,98,91,49,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,98,91,49,54,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,98,91,49,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,98,91,49,55,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,98,91,49,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,98,91,49,56,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,98,91,49,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,98,91,49,57,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,98,91,50,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,98,91,50,48,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,240,221,1,0,187,1,0,0,7,0,0,0,187,1,0,0,54,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,97,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,97,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,97,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,97,91,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,97,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,97,91,51,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,97,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,97,91,52,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,97,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,97,91,53,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,97,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,97,91,54,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,97,91,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,97,91,55,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,97,91,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,97,91,56,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,97,91,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,97,91,57,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,97,91,49,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,97,91,49,48,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,97,91,49,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,97,91,49,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,97,91,49,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,97,91,49,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,97,91,49,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,97,91,49,51,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,97,91,49,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,97,91,49,52,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,97,91,49,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,97,91,49,53,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,97,91,49,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,97,91,49,54,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,97,91,49,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,97,91,49,55,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,97,91,49,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,97,91,49,56,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,97,91,49,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,97,91,49,57,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,97,91,50,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,97,91,50,48,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,240,221,1,0,188,1,0,0,7,0,0,0,188,1,0,0,54,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,91,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,91,51,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,91,52,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,91,53,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,91,54,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,91,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,91,55,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,91,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,91,56,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,91,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,91,57,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,91,49,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,91,49,48,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,91,49,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,91,49,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,91,49,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,91,49,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,91,49,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,91,49,51,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,91,49,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,91,49,52,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,91,49,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,91,49,53,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,91,49,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,91,49,54,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,91,49,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,91,49,55,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,91,49,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,91,49,56,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,91,49,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,91,49,57,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,119,97,108,108,46,84,91,50,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,119,97,108,108,46,84,91,50,48,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,240,221,1,0,189,1,0,0,7,0,0,0,190,1,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,95,97,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,95,97,46,100,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,95,97,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,87,97,116,101,114,47,112,97,99,107,97,103,101,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,95,97,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,95,97,46,84,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,95,97,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,50,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,50,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,50,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,51,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,51,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,51,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,52,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,52,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,52,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,53,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,53,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,53,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,54,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,54,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,54,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,55,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,55,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,55,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,56,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,56,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,56,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,57,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,57,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,57,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,49,48,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,49,48,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,49,48,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,49,49,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,49,49,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,49,49,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,49,50,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,49,50,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,49,50,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,49,51,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,49,51,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,49,51,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,49,52,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,49,52,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,49,52,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,49,53,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,49,53,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,49,53,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,49,54,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,49,54,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,49,54,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,49,55,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,49,55,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,49,55,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,49,56,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,49,56,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,49,56,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,49,57,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,49,57,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,115,116,97,116,101,115,70,77,91,49,57,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,115,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,115,91,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,115,91,51,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,115,91,52,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,115,91,53,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,115,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,115,91,54,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,115,91,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,115,91,55,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,115,91,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,115,91,56,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,115,91,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,115,91,57,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,115,91,49,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,115,91,49,48,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,115,91,49,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,115,91,49,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,115,91,49,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,115,91,49,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,115,91,49,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,115,91,49,51,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,115,91,49,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+122880);
/* memory initializer */ allocate([69,88,46,112,105,112,101,95,49,46,109,115,91,49,52,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,115,91,49,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,115,91,49,53,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,115,91,49,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,115,91,49,54,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,115,91,49,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,115,91,49,55,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,115,91,49,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,115,91,49,56,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,115,91,49,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,115,91,49,57,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,115,91,50,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,115,91,50,48,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,50,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,51,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,52,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,52,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,53,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,53,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,54,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,54,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,55,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,55,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,56,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,56,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,57,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,57,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,49,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,49,48,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,49,48,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,49,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,49,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,49,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,49,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,49,50,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,49,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,49,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,49,51,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,49,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,49,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,49,52,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,49,52,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,49,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,49,53,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,49,53,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,49,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,49,54,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,49,54,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,49,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,49,55,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,49,55,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,49,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,49,56,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,49,56,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,49,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,49,57,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,49,57,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,50,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,50,48,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,98,95,102,108,111,119,115,91,50,48,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,50,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,80,105,112,101,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,51,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,52,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,52,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,53,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,53,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,54,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,54,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,55,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,55,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,56,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,56,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,57,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,57,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,49,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,49,48,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,49,48,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,49,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,49,49,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,49,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,49,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,49,50,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,49,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,49,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,49,51,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,49,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,49,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,49,52,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,49,52,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,49,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,49,53,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,49,53,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,49,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,49,54,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,49,54,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,49,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,49,55,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,49,55,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,49,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,49,56,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,49,56,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,49,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,49,57,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,49,57,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,50,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,50,48,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,50,48,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,50,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,50,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,95,102,108,111,119,115,91,50,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,49,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,50,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,51,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,52,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,52,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,53,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,53,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,54,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,54,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,55,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,55,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,56,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,56,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,57,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,57,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,49,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,49,48,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,49,48,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,49,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,49,49,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,49,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,49,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,49,50,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,49,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,49,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,49,51,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,49,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,49,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,49,52,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,49,52,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,49,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,49,53,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,49,53,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,49,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,49,54,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,49,54,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,49,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,49,55,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,49,55,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,49,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,49,56,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,49,56,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+133120);
/* memory initializer */ allocate([86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,49,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,49,57,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,49,57,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,50,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,50,48,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,50,48,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,50,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,50,49,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,72,95,102,108,111,119,115,91,50,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,52,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,52,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,53,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,53,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,54,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,54,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,55,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,55,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,56,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,56,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,57,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,57,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,48,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,48,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,50,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,51,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,52,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,52,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,53,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,53,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,54,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,54,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,55,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,55,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,56,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,56,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,57,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,57,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,48,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,48,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,52,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,52,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,53,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,53,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,54,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,54,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,55,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,55,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,56,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,56,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,57,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,57,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,48,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,48,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,50,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,51,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,52,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,52,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,53,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,53,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,54,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,54,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,55,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,55,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,56,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,56,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,57,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,57,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,50,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,50,48,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,50,48,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,52,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,52,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,53,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,53,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,54,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,54,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,55,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,55,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,56,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,56,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,57,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,57,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,48,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,48,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,50,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,51,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,52,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,52,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,53,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,53,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,54,93,32,111,117], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+143368);
/* memory initializer */ allocate([116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,54,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,54,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,55,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,55,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,56,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,56,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,57,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,57,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,48,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,48,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,52,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,52,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,53,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,53,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,54,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,54,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,55,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,55,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,56,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,56,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,57,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,57,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,48,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,48,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,50,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,51,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,52,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,52,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,53,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,53,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,54,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,54,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,55,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,55,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,56,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,56,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,57,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,57,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,50,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,50,48,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,50,48,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,112,97,99,107,97,103,101,46,109,111,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,51,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,51,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,51,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,51,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,51,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,51,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,51,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,51,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,51,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,51,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,51,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,51,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,52,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,52,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,52,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,52,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,52,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,52,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,52,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,52,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,52,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,52,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,52,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,52,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,53,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,53,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,53,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,53,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,53,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,53,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,53,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,53,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,53,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,53,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,53,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,53,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,54,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,54,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,54,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,54,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,54,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,54,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,54,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,54,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,54,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,54,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,54,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,54,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,55,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,55,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,55,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,55,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,55,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,55,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,55,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,55,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,55,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,55,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,55,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,55,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,56,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,56,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,56,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,56,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,56,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,56,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,56,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,56,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,56,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,56,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,56,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,56,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,57,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,57,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,57,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,57,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,57,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,57,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,57,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,57,93,46,117,32,62,61,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+153608);
/* memory initializer */ allocate([45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,57,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,57,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,57,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,57,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,48,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,48,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,48,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,48,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,48,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,48,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,48,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,48,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,48,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,48,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,48,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,48,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,49,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,49,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,49,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,49,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,49,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,49,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,49,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,49,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,49,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,49,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,49,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,49,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,50,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,50,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,50,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,50,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,50,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,50,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,50,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,50,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,50,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,50,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,50,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,50,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,51,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,51,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,51,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,51,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,51,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,51,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,51,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,51,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,51,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,51,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,51,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,51,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,52,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,52,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,52,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,52,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,52,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,52,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,52,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,52,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,52,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,52,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,52,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,52,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,53,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,53,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,53,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,53,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,53,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,53,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,53,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,53,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,53,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,53,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,53,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,53,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,54,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,54,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,54,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,54,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,54,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,54,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,54,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,54,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,54,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,54,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,54,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,54,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,55,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,55,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,55,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,55,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,55,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,55,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,55,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,55,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,55,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,55,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,55,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,55,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,56,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,56,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,56,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,56,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,56,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,56,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,56,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,56,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,56,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,56,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,56,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,56,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,57,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,57,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,57,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,57,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,57,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,57,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,57,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,57,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,57,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,57,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,57,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,49,57,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,48,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,48,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,48,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,48,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,48,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,48,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,48,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,48,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,48,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,48,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,48,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,109,101,100,105,117,109,115,91,50,48,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,52,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,52,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,53,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,53,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,54,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,54,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,55,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,55,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,56,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,56,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,57,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,57,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,49,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,49,48,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,49,48,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,49,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,49,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,49,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,49,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,49,50,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,49,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,49,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,49,51,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,49,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,49,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,49,52,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,49,52,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,49,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,49,53,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,49,53,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+163848);
/* memory initializer */ allocate([86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,49,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,49,54,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,49,54,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,49,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,49,55,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,49,55,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,49,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,49,56,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,49,56,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,49,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,49,57,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,49,57,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,50,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,50,48,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,109,117,115,91,50,48,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,200,23,2,0,160,6,0,0,7,0,0,0,160,6,0,0,59,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,49,93,32,60,61,32,53,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,50,93,32,60,61,32,53,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,51,93,32,60,61,32,53,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,52,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,52,93,32,60,61,32,53,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,53,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,53,93,32,60,61,32,53,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,54,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,54,93,32,60,61,32,53,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,55,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,55,93,32,60,61,32,53,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,56,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,56,93,32,60,61,32,53,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,57,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,57,93,32,60,61,32,53,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,49,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,49,48,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,49,48,93,32,60,61,32,53,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,49,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,49,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,49,49,93,32,60,61,32,53,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,49,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,49,50,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,49,50,93,32,60,61,32,53,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,49,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,49,51,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,49,51,93,32,60,61,32,53,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,49,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,49,52,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,49,52,93,32,60,61,32,53,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,49,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,49,53,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,49,53,93,32,60,61,32,53,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,49,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,49,54,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,49,54,93,32,60,61,32,53,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,49,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,49,55,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,49,55,93,32,60,61,32,53,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,49,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,49,56,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,49,56,93,32,60,61,32,53,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,49,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,49,57,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,49,57,93,32,60,61,32,53,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,50,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,50,48,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,108,97,109,98,100,97,115,91,50,48,93,32,60,61,32,53,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,200,23,2,0,161,6,0,0,7,0,0,0,161,6,0,0,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,95,98,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,95,98,46,100,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,95,98,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,64,245,1,0,144,0,0,0,5,0,0,0,144,0,0,0,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,95,98,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,95,98,46,84,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,95,98,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,64,245,1,0,145,0,0,0,5,0,0,0,145,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,51,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,51,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,51,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,52,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,52,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,52,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,53,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,53,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,53,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,54,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,54,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,54,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,55,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,55,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,55,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,56,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,56,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,56,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,57,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,57,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,57,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,49,48,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,49,48,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,49,48,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,49,49,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,49,49,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,49,49,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,49,50,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,49,50,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,49,50,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,49,51,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,49,51,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,49,51,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,49,52,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,49,52,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,49,52,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,49,53,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,49,53,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,49,53,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,49,54,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,49,54,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,49,54,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,49,55,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,49,55,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,49,55,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,49,56,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,49,56,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,49,56,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,49,57,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,49,57,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,49,57,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,50,48,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,50,48,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,115,116,97,116,101,115,70,77,91,50,48,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,64,245,1,0,143,0,0,0,5,0,0,0,143,0,0,0,43,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,115,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,115,91,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,115,91,51,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,115,91,52,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,115,91,53,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,115,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,115,91,54,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,115,91,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,115,91,55,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,115,91,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,115,91,56,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,115,91,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,115,91,57,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,115,91,49,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,115,91,49,48,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,115,91,49,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,115,91,49,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,115,91,49,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,115,91,49,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,115,91,49,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,115,91,49,51,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,115,91,49,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,115,91,49,52,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,115,91,49,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,115,91,49,53,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,115,91,49,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,115,91,49,54,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,115,91,49,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,115,91,49,55,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,115,91,49,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,115,91,49,56,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,115,91,49,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,115,91,49,57,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+174096);
/* memory initializer */ allocate([86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,115,91,50,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,115,91,50,48,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,48,219,1,0,102,3,0,0,3,0,0,0,102,3,0,0,29,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,50,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,51,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,52,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,52,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,53,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,53,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,54,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,54,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,55,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,55,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,56,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,56,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,57,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,57,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,49,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,49,48,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,49,48,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,49,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,49,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,49,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,49,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,49,50,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,49,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,49,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,49,51,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,49,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,49,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,49,52,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,49,52,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,49,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,49,53,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,49,53,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,49,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,49,54,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,49,54,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,49,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,49,55,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,49,55,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,49,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,49,56,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,49,56,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,49,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,49,57,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,49,57,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,50,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,50,48,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,98,95,102,108,111,119,115,91,50,48,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,48,219,1,0,118,3,0,0,3,0,0,0,118,3,0,0,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,50,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,51,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,52,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,52,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,53,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,53,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,54,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,54,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,55,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,55,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,56,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,56,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,57,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,57,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,49,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,49,48,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,49,48,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,49,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,49,49,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,49,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,49,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,49,50,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,49,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,49,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,49,51,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,49,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,49,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,49,52,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,49,52,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,49,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,49,53,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,49,53,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,49,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,49,54,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,49,54,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,49,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,49,55,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,49,55,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,49,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,49,56,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,49,56,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,49,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,49,57,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,49,57,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,50,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,50,48,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,95,102,108,111,119,115,91,50,48,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,200,23,2,0,144,1,0,0,7,0,0,0,147,1,0,0,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,49,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,50,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,51,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,52,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,52,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,53,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,53,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,54,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,54,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,55,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,55,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,56,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,56,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,57,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,57,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,49,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,49,48,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,49,48,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,49,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,49,49,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,49,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,49,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,49,50,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,49,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,49,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,49,51,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,49,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,49,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,49,52,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,49,52,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,49,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,49,53,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,49,53,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,49,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,49,54,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,49,54,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,49,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,49,55,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,49,55,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,49,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,49,56,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,49,56,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,49,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,49,57,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,49,57,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,50,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,50,48,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,50,48,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,50,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,50,49,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,72,95,102,108,111,119,115,91,50,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,200,23,2,0,152,1,0,0,7,0,0,0,153,1,0,0,65,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,111,117], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+184336);
/* memory initializer */ allocate([116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,52,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,52,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,53,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,53,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,54,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,54,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,55,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,55,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,56,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,56,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,57,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,57,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,48,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,48,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,50,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,51,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,52,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,52,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,53,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,53,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,54,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,54,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,55,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,55,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,56,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,56,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,57,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,57,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,48,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,48,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,200,23,2,0,52,4,0,0,13,0,0,0,52,4,0,0,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,52,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,52,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,53,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,53,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,54,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,54,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,55,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,55,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,56,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,56,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,57,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,57,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,48,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,48,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,50,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,51,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,52,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,52,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,53,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,53,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,54,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,54,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,55,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,55,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,56,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,56,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,57,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,57,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,50,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,50,48,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,50,48,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,200,23,2,0,53,4,0,0,13,0,0,0,53,4,0,0,70,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,52,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,52,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,53,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,53,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,54,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,54,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,55,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,55,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,56,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,56,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,57,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,57,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,48,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,48,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,50,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,51,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,52,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,52,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,53,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,53,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,54,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,54,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,55,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,55,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,56,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,56,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,57,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,57,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+194576);
/* memory initializer */ allocate([86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,48,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,48,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,200,23,2,0,55,4,0,0,13,0,0,0,55,4,0,0,125,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,52,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,52,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,53,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,53,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,54,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,54,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,55,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,55,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,56,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,56,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,57,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,57,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,48,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,48,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,49,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,50,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,51,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,52,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,52,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,53,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,53,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,54,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,54,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,55,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,55,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,55,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,56,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,56,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,56,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,57,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,57,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,57,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,50,48,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,50,48,93,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,50,48,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,200,23,2,0,56,4,0,0,13,0,0,0,56,4,0,0,80,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,51,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,51,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,51,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,51,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,51,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,51,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,51,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,51,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,51,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,51,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,51,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,51,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,52,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,52,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,52,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,52,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,52,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,52,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,52,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,52,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,52,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,52,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,52,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,52,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,53,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,53,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,53,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,53,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,53,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,53,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,53,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,53,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,53,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,53,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,53,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,53,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,54,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,54,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,54,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,54,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,54,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,54,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,54,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,54,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,54,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,54,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,54,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,54,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,55,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,55,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,55,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,55,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,55,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,55,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,55,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,55,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,55,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,55,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,55,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,55,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,56,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,56,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,56,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,56,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,56,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,56,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,56,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,56,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,56,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,56,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,56,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,56,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,57,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,57,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,57,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,57,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,57,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,57,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,57,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,57,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,57,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,57,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,57,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,57,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,48,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,48,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,48,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,48,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,48,93,46,84,32,62,61,32,49,46,48,32,97,110], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+204824);
/* memory initializer */ allocate([100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,48,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,48,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,48,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,48,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,48,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,48,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,48,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,49,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,49,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,49,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,49,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,49,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,49,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,49,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,49,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,49,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,49,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,49,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,49,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,50,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,50,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,50,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,50,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,50,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,50,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,50,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,50,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,50,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,50,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,50,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,50,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,51,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,51,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,51,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,51,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,51,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,51,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,51,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,51,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,51,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,51,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,51,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,51,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,52,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,52,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,52,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,52,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,52,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,52,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,52,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,52,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,52,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,52,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,52,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,52,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,53,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,53,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,53,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,53,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,53,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,53,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,53,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,53,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,53,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,53,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,53,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,53,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,54,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,54,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,54,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,54,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,54,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,54,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,54,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,54,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,54,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,54,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,54,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,54,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,55,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,55,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,55,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,55,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,55,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,55,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,55,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,55,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,55,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,55,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,55,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,55,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,56,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,56,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,56,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,56,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,56,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,56,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,56,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,56,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,56,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,56,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,56,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,56,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,57,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,57,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,57,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,57,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,57,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,57,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,57,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,57,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,57,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,57,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,57,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,49,57,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,48,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,48,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,48,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,80,106,2,0,30,17,0,0,7,0,0,0,30,17,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,48,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,48,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,48,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,80,106,2,0,35,17,0,0,7,0,0,0,35,17,0,0,44,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,48,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,48,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,48,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,48,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,48,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,72,69,88,46,112,105,112,101,95,50,46,109,101,100,105,117,109,115,91,50,48,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,97,115,115,70,108,111,119,82,97,116,101,50,46,109,101,100,105,117,109,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,97,115,115,70,108,111,119,82,97,116,101,50,46,109,101,100,105,117,109,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,109,97,115,115,70,108,111,119,82,97,116,101,50,46,109,101,100,105,117,109,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,97,115,115,70,108,111,119,82,97,116,101,50,46,109,101,100,105,117,109,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,97,115,115,70,108,111,119,82,97,116,101,50,46,109,101,100,105,117,109,46,100,32,62,61,32,48,46,48,32,97,110,100,32,109,97,115,115,70,108,111,119,82,97,116,101,50,46,109,101,100,105,117,109,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,97,115,115,70,108,111,119,82,97,116,101,50,46,109,101,100,105,117,109,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,97,115,115,70,108,111,119,82,97,116,101,50,46,109,101,100,105,117,109,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,109,97,115,115,70,108,111,119,82,97,116,101,50,46,109,101,100,105,117,109,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,97,115,115,70,108,111,119,82,97,116,101,50,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,97,115,115,70,108,111,119,82,97,116,101,50,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,109,97,115,115,70,108,111,119,82,97,116,101,50,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,97,115,115,70,108,111,119,82,97,116,101,49,46,109,101,100,105,117,109,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,97,115,115,70,108,111,119,82,97,116,101,49,46,109,101,100,105,117,109,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,109,97,115,115,70,108,111,119,82,97,116,101,49,46,109,101,100,105,117,109,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,80,106,2,0,33,17,0,0,7,0,0,0,33,17,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,97,115,115,70,108,111,119,82,97,116,101,49,46,109,101,100,105,117,109,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,97,115,115,70,108,111,119,82,97,116,101,49,46,109,101,100,105,117,109,46,100,32,62,61,32,48,46,48,32,97,110,100,32,109,97,115,115,70,108,111,119,82,97,116,101,49,46,109,101,100,105,117,109,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,80,106,2,0,34,17,0,0,7,0,0,0,34,17,0,0,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,97,115,115,70,108,111,119,82,97,116,101,49,46,109,101,100,105,117,109,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,97,115,115,70,108,111,119,82,97,116,101,49,46,109,101,100,105,117,109,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,109,97,115,115,70,108,111,119,82,97,116,101,49,46,109,101,100,105,117,109,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,80,106,2,0,38,17,0,0,7,0,0,0,38,17,0,0,68,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,97,115,115,70,108,111,119,82,97,116,101,49,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,97,115,115,70,108,111,119,82,97,116,101,49,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,109,97,115,115,70,108,111,119,82,97,116,101,49,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,80,106,2,0,150,27,0,0,7,0,0,0,150,27,0,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,97,109,112,49,46,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,97,109,112,49,46,121,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,82,97,109,112,49,46,121,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,66,108,111,99,107,115,47,73,110,116,101,114,102,97,99,101,115,46,109,111,0,0,0,0,0,0,0,208,105,3,0,20,1,0,0,5,0,0,0,21,1,0,0,68,0,0,0,0,0,0,0,109,111,100,101,108,32,108,105,110,101,97,114,95,77,111,100,101,108,105,99,97,95,70,108,117,105,100,95,69,120,97,109,112,108,101,115,95,72,101,97,116,69,120,99,104,97,110,103,101,114,95,72,101,97,116,69,120,99,104,97,110,103,101,114,83,105,109,117,108,97,116,105,111,110,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,110,32,61,32,49,48,48,59,32,47,47,32,115,116,97,116,101,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,107,32,61,32,48,59,32,47,47,32,116,111,112,45,108,101,118,101,108,32,105,110,112,117,116,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,108,32,61,32,48,59,32,47,47,32,116,111,112,45,108,101,118,101,108,32,111,117,116,112,117,116,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,120,48,91,49,48,48,93,32,61,32,123,37,115,125,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,117,48,91,48,93,32,61,32,123,37,115,125,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,65,91,49,48,48,44,49,48,48,93,32,61,32,91,37,115,93,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,66,91,49,48,48,44,48,93,32,61,32,122,101,114,111,115,40,49,48,48,44,48,41,59,37,115,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,67,91,48,44,49,48,48,93,32,61,32,122,101,114,111,115,40,48,44,49,48,48,41,59,37,115,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,68,91,48,44,48,93,32,61,32,122,101,114,111,115,40,48,44,48,41,59,37,115,10,32,32,82,101,97,108,32,120,91,49,48,48,93,40,115,116,97,114,116,61,120,48,41,59,10,32,32,105,110,112,117,116,32,82,101,97,108,32,117,91,48,93,59,10,32,32,111,117,116,112,117,116,32,82,101,97,108,32,121,91,48,93,59,10,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,50,80,109,101,100,105,117,109,115,108,66,50,48,114,66,80,84,32,61,32,120,91,49,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,50,80,109,101,100,105,117,109,115,108,66,50,48,114,66,80,112,32,61,32,120,91,50,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,50,80,109,101,100,105,117,109,115,108,66,49,57,114,66,80,84,32,61,32,120,91,51,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,50,80,109,101,100,105,117,109,115,108,66,49,57,114,66,80,112,32,61,32,120,91,52,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,50,80,109,101,100,105,117,109,115,108,66,49,56,114,66,80,84,32,61,32,120,91,53,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,50,80,109,101,100,105,117,109,115,108,66,49,56,114,66,80,112,32,61,32,120,91,54,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,50,80,109,101,100,105,117,109,115,108,66,49,55,114,66,80,84,32,61,32,120,91,55,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,50,80,109,101,100,105,117,109,115,108,66,49,55,114,66,80,112,32,61,32,120,91,56,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,50,80,109,101,100,105,117,109,115,108,66,49,54,114,66,80,84,32,61,32,120,91,57,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,50,80,109,101,100,105,117,109,115,108,66,49,54,114,66,80,112,32,61,32,120,91,49,48,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,50,80,109,101,100,105,117,109,115,108,66,49,53,114,66,80,84,32,61,32,120,91,49,49,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,50,80,109,101,100,105,117,109,115,108,66,49,53,114,66,80,112,32,61,32,120,91,49,50,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,50,80,109,101,100,105,117,109,115,108,66,49,52,114,66,80,84,32,61,32,120,91,49,51,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,50,80,109,101,100,105,117,109,115,108,66,49,52,114,66,80,112,32,61,32,120,91,49,52,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,50,80,109,101,100,105,117,109,115,108,66,49,51,114,66,80,84,32,61,32,120,91,49,53,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,50,80,109,101,100,105,117,109,115,108,66,49,51,114,66,80,112,32,61,32,120,91,49,54,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,50,80,109,101,100,105,117,109,115,108,66,49,50,114,66,80,84,32,61,32,120,91,49,55,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,50,80,109,101,100,105,117,109,115,108,66,49,50,114,66,80,112,32,61,32,120,91,49,56,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,50,80,109,101,100,105,117,109,115,108,66,49,49,114,66,80,84,32,61,32,120,91,49,57,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,50,80,109,101,100,105,117,109,115,108,66,49,49,114,66,80,112,32,61,32,120,91,50,48,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,50,80,109,101,100,105,117,109,115,108,66,49,48,114,66,80,84,32,61,32,120,91,50,49,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,50,80,109,101,100,105,117,109,115,108,66,49,48,114,66,80,112,32,61,32,120,91,50,50,93,59,10,32,32,82,101], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+215064);
/* memory initializer */ allocate([97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,50,80,109,101,100,105,117,109,115,108,66,57,114,66,80,84,32,61,32,120,91,50,51,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,50,80,109,101,100,105,117,109,115,108,66,57,114,66,80,112,32,61,32,120,91,50,52,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,50,80,109,101,100,105,117,109,115,108,66,56,114,66,80,84,32,61,32,120,91,50,53,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,50,80,109,101,100,105,117,109,115,108,66,56,114,66,80,112,32,61,32,120,91,50,54,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,50,80,109,101,100,105,117,109,115,108,66,55,114,66,80,84,32,61,32,120,91,50,55,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,50,80,109,101,100,105,117,109,115,108,66,55,114,66,80,112,32,61,32,120,91,50,56,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,50,80,109,101,100,105,117,109,115,108,66,54,114,66,80,84,32,61,32,120,91,50,57,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,50,80,109,101,100,105,117,109,115,108,66,54,114,66,80,112,32,61,32,120,91,51,48,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,50,80,109,101,100,105,117,109,115,108,66,53,114,66,80,84,32,61,32,120,91,51,49,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,50,80,109,101,100,105,117,109,115,108,66,53,114,66,80,112,32,61,32,120,91,51,50,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,50,80,109,101,100,105,117,109,115,108,66,52,114,66,80,84,32,61,32,120,91,51,51,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,50,80,109,101,100,105,117,109,115,108,66,52,114,66,80,112,32,61,32,120,91,51,52,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,50,80,109,101,100,105,117,109,115,108,66,51,114,66,80,84,32,61,32,120,91,51,53,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,50,80,109,101,100,105,117,109,115,108,66,51,114,66,80,112,32,61,32,120,91,51,54,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,50,80,109,101,100,105,117,109,115,108,66,50,114,66,80,84,32,61,32,120,91,51,55,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,50,80,109,101,100,105,117,109,115,108,66,50,114,66,80,112,32,61,32,120,91,51,56,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,50,80,109,101,100,105,117,109,115,108,66,49,114,66,80,84,32,61,32,120,91,51,57,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,50,80,109,101,100,105,117,109,115,108,66,49,114,66,80,112,32,61,32,120,91,52,48,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,49,80,109,101,100,105,117,109,115,108,66,50,48,114,66,80,84,32,61,32,120,91,52,49,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,49,80,109,101,100,105,117,109,115,108,66,50,48,114,66,80,112,32,61,32,120,91,52,50,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,49,80,109,101,100,105,117,109,115,108,66,49,57,114,66,80,84,32,61,32,120,91,52,51,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,49,80,109,101,100,105,117,109,115,108,66,49,57,114,66,80,112,32,61,32,120,91,52,52,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,49,80,109,101,100,105,117,109,115,108,66,49,56,114,66,80,84,32,61,32,120,91,52,53,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,49,80,109,101,100,105,117,109,115,108,66,49,56,114,66,80,112,32,61,32,120,91,52,54,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,49,80,109,101,100,105,117,109,115,108,66,49,55,114,66,80,84,32,61,32,120,91,52,55,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,49,80,109,101,100,105,117,109,115,108,66,49,55,114,66,80,112,32,61,32,120,91,52,56,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,49,80,109,101,100,105,117,109,115,108,66,49,54,114,66,80,84,32,61,32,120,91,52,57,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,49,80,109,101,100,105,117,109,115,108,66,49,54,114,66,80,112,32,61,32,120,91,53,48,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,49,80,109,101,100,105,117,109,115,108,66,49,53,114,66,80,84,32,61,32,120,91,53,49,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,49,80,109,101,100,105,117,109,115,108,66,49,53,114,66,80,112,32,61,32,120,91,53,50,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,49,80,109,101,100,105,117,109,115,108,66,49,52,114,66,80,84,32,61,32,120,91,53,51,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,49,80,109,101,100,105,117,109,115,108,66,49,52,114,66,80,112,32,61,32,120,91,53,52,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,49,80,109,101,100,105,117,109,115,108,66,49,51,114,66,80,84,32,61,32,120,91,53,53,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,49,80,109,101,100,105,117,109,115,108,66,49,51,114,66,80,112,32,61,32,120,91,53,54,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,49,80,109,101,100,105,117,109,115,108,66,49,50,114,66,80,84,32,61,32,120,91,53,55,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,49,80,109,101,100,105,117,109,115,108,66,49,50,114,66,80,112,32,61,32,120,91,53,56,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,49,80,109,101,100,105,117,109,115,108,66,49,49,114,66,80,84,32,61,32,120,91,53,57,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,49,80,109,101,100,105,117,109,115,108,66,49,49,114,66,80,112,32,61,32,120,91,54,48,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,49,80,109,101,100,105,117,109,115,108,66,49,48,114,66,80,84,32,61,32,120,91,54,49,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,49,80,109,101,100,105,117,109,115,108,66,49,48,114,66,80,112,32,61,32,120,91,54,50,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,49,80,109,101,100,105,117,109,115,108,66,57,114,66,80,84,32,61,32,120,91,54,51,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,49,80,109,101,100,105,117,109,115,108,66,57,114,66,80,112,32,61,32,120,91,54,52,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,49,80,109,101,100,105,117,109,115,108,66,56,114,66,80,84,32,61,32,120,91,54,53,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,49,80,109,101,100,105,117,109,115,108,66,56,114,66,80,112,32,61,32,120,91,54,54,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,49,80,109,101,100,105,117,109,115,108,66,55,114,66,80,84,32,61,32,120,91,54,55,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,49,80,109,101,100,105,117,109,115,108,66,55,114,66,80,112,32,61,32,120,91,54,56,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,49,80,109,101,100,105,117,109,115,108,66,54,114,66,80,84,32,61,32,120,91,54,57,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,49,80,109,101,100,105,117,109,115,108,66,54,114,66,80,112,32,61,32,120,91,55,48,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,49,80,109,101,100,105,117,109,115,108,66,53,114,66,80,84,32,61,32,120,91,55,49,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,49,80,109,101,100,105,117,109,115,108,66,53,114,66,80,112,32,61,32,120,91,55,50,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,49,80,109,101,100,105,117,109,115,108,66,52,114,66,80,84,32,61,32,120,91,55,51,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,49,80,109,101,100,105,117,109,115,108,66,52,114,66,80,112,32,61,32,120,91,55,52,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,49,80,109,101,100,105,117,109,115,108,66,51,114,66,80,84,32,61,32,120,91,55,53,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,49,80,109,101,100,105,117,109,115,108,66,51,114,66,80,112,32,61,32,120,91,55,54,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,49,80,109,101,100,105,117,109,115,108,66,50,114,66,80,84,32,61,32,120,91,55,55,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,49,80,109,101,100,105,117,109,115,108,66,50,114,66,80,112,32,61,32,120,91,55,56,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,49,80,109,101,100,105,117,109,115,108,66,49,114,66,80,84,32,61,32,120,91,55,57,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,112,105,112,101,95,49,80,109,101,100,105,117,109,115,108,66,49,114,66,80,112,32,61,32,120,91,56,48,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,119,97,108,108,80,84,108,66,49,114,66,32,61,32,120,91,56,49,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,119,97,108,108,80,84,108,66,50,114,66,32,61,32,120,91,56,50,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,119,97,108,108,80,84,108,66,51,114,66,32,61,32,120,91,56,51,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,119,97,108,108,80,84,108,66,52,114,66,32,61,32,120,91,56,52,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,119,97,108,108,80,84,108,66,53,114,66,32,61,32,120,91,56,53,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,119,97,108,108,80,84,108,66,54,114,66,32,61,32,120,91,56,54,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,119,97,108,108,80,84,108,66,55,114,66,32,61,32,120,91,56,55,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,119,97,108,108,80,84,108,66,56,114,66,32,61,32,120,91,56,56,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,119,97,108,108,80,84,108,66,57,114,66,32,61,32,120,91,56,57,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,119,97,108,108,80,84,108,66,49,48,114,66,32,61,32,120,91,57,48,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,119,97,108,108,80,84,108,66,49,49,114,66,32,61,32,120,91,57,49,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,119,97,108,108,80,84,108,66,49,50,114,66,32,61,32,120,91,57,50,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,119,97,108,108,80,84,108,66,49,51,114,66,32,61,32,120,91,57,51,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,119,97,108,108,80,84,108,66,49,52,114,66,32,61,32,120,91,57,52,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,119,97,108,108,80,84,108,66,49,53,114,66,32,61,32,120,91,57,53,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,119,97,108,108,80,84,108,66,49,54,114,66,32,61,32,120,91,57,54,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,119,97,108,108,80,84,108,66,49,55,114,66,32,61,32,120,91,57,55,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,119,97,108,108,80,84,108,66,49,56,114,66,32,61,32,120,91,57,56,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,119,97,108,108,80,84,108,66,49,57,114,66,32,61,32,120,91,57,57,93,59,10,32,32,82,101,97,108,32,120,95,80,72,69,88,80,119,97,108,108,80,84,108,66,50,48,114,66,32,61,32,120,91,49,48,48,93,59,10,32,32,32,32,32,32,10,101,113,117,97,116,105,111,110,10,32,32,100,101,114,40,120,41,32,61,32,65,32,42,32,120,32,43,32,66,32,42,32,117,59,10,32,32,121,32,61,32,67,32,42,32,120,32,43,32,68,32,42,32,117,59,10,101,110,100,32,108,105,110,101,97,114,95,77,111,100,101,108,105,99,97,95,70,108,117,105,100,95,69,120,97,109,112,108,101,115,95,72,101,97,116,69,120,99,104,97,110,103,101,114,95,72,101,97,116,69,120,99,104,97,110,103,101,114,83,105,109,117,108,97,116,105,111,110,59,10,0,0,0,68,71,69,82,32,32,0,0,78,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,68,71,69,77,77,32,0,0,76,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,85,0,0,0,0,0,0,0,82,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,68,84,82,83,77,32,0,0,68,71,69,83,86,32,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,68,71,69,84,70,50,0,0,83,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,240,191,68,71,69,84,82,70,0,0,1,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,76,101,102,116,0,0,0,0,76,111,119,101,114,0,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,85,110,105,116,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,191,78,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,68,71,69,84,82,83,0,0,1,0,0,0,0,0,0,0,76,101,102,116,0,0,0,0,76,111,119,101,114,0,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,85,110,105,116,0,0,0,0,0,0,0,0,0,0,240,63,85,112,112,101,114,0,0,0,78,111,110,45,117,110,105,116,0,0,0,0,0,0,0,0,84,114,97,110,115,112,111,115,101,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,71,69,0,0,0,0,0,0,84,82,70,0,0,0,0,0,81,82,70,0,0,0,0,0,82,81,70,0,0,0,0,0,76,81,70,0,0,0,0,0,81,76,70,0,0,0,0,0,72,82,68,0,0,0,0,0,66,82,68,0,0,0,0,0,84,82,73,0,0,0,0,0,80,79,0,0,0,0,0,0,83,89,0,0,0,0,0,0,84,82,68,0,0,0,0,0,71,83,84,0,0,0,0,0,72,69,0,0,0,0,0,0,79,82,0,0,0,0,0,0,81,82,0,0,0,0,0,0,82,81,0,0,0,0,0,0,76,81,0,0,0,0,0,0,81,76,0,0,0,0,0,0,72,82,0,0,0,0,0,0,84,82,0,0,0,0,0,0,66,82,0,0,0,0,0,0,85,78,0,0,0,0,0,0,71,66,0,0,0,0,0,0,80,66,0,0,0,0,0,0,76,65,0,0,0,0,0,0,85,85,77,0,0,0,0,0,83,84,0,0,0,0,0,0,69,66,90,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,128,3,0,240,128,3,0,0,129,3,0,24,129,3,0,56,129,3,0,72,129,3,0,96,129,3,0,112,129,3,0,136,129,3,0,168,129,3,0,208,129,3,0,232,129,3,0,8,130,3,0,32,130,3,0,72,130,3,0,104,130,3,0,152,130,3,0,200,130,3,0,224,130,3,0,24,131,3,0,48,131,3,0,96,131,3,0,128,131,3,0,184,131,3,0,224,131,3,0,24,132,3,0,72,132,3,0,88,132,3,0,120,132,3,0,160,132,3,0,192,132,3,0,232,132,3,0,16,133,3,0,40,133,3,0,64,133,3,0,80,133,3,0,104,133,3,0,152,133,3,0,232,133,3,0,40,134,3,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,115,121,110,116,97,120,32,101,114,114,111,114,0,0,0,0,110,111,32,101,108,101,109,101,110,116,32,102,111,117,110,100,0,0,0,0,0,0,0,0,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,32,40,105,110,118,97,108,105,100,32,116,111,107,101,110,41,0,117,110,99,108,111,115,101,100,32,116,111,107,101,110,0,0,112,97,114,116,105,97,108,32,99,104,97,114,97,99,116,101,114,0,0,0,0,0,0,0,109,105,115,109,97,116,99,104,101,100,32,116,97,103,0,0,100,117,112,108,105,99,97,116,101,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,106,117,110,107,32,97,102,116,101,114,32,100,111,99,117,109,101,110,116,32,101,108,101,109,101,110,116,0,0,0,0,0,105,108,108,101,103,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,117,110,100,101,102,105,110,101,100,32,101,110,116,105,116,121,0,0,0,0,0,0,0,0,114,101,99,117,114,115,105,118,101,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,97,115,121,110,99,104,114,111,110,111,117,115,32,101,110,116,105,116,121,0,0,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,105,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,110,117,109,98,101,114,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,98,105,110,97,114,121,32,101,110,116,105,116,121,0,0,0,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,105,110,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,0,0,88,77,76,32,111,114,32,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,97,116,32,115,116,97,114,116,32,111,102,32,101,110,116,105,116,121,0,0,117,110,107,110,111,119,110,32,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,101,110,99,111,100,105,110,103,32,115,112,101,99,105,102,105,101,100,32,105,110,32,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,105,115,32,105,110,99,111,114,114,101,99,116,0,0,0,0,0,0,117,110,99,108,111,115,101,100,32,67,68,65,84,65,32,115,101,99,116,105,111,110,0,0,101,114,114,111,114,32,105,110,32,112,114,111,99,101,115,115,105,110,103,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,100,111,99,117,109,101,110,116,32,105,115,32,110,111,116,32,115,116,97,110,100,97,108,111,110,101,0,0,0,0,0,0,117,110,101,120,112,101,99,116,101,100,32,112,97,114,115,101,114,32,115,116,97,116,101,32,45,32,112,108,101,97,115,101,32,115,101,110,100,32,97,32,98,117,103,32,114,101,112,111,114,116,0,0,0,0,0,0,101,110,116,105,116,121,32,100,101,99,108,97,114,101,100,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,0,0,114,101,113,117,101,115,116,101,100,32,102,101,97,116,117,114,101,32,114,101,113,117,105,114,101,115,32,88,77,76,95,68,84,68,32,115,117,112,112,111,114,116,32,105,110,32,69,120,112,97,116,0,0,0,0,0,99,97,110,110,111,116,32,99,104,97,110,103,101,32,115,101,116,116,105,110,103,32,111,110,99,101,32,112,97,114,115,105,110,103,32,104,97,115,32,98,101,103,117,110,0,0,0,0,117,110,98,111,117,110,100,32,112,114,101,102,105,120,0,0,109,117,115,116,32,110,111,116,32,117,110,100,101,99,108,97,114,101,32,112,114,101,102,105,120,0,0,0,0,0,0,0,105,110,99,111,109,112,108,101,116,101,32,109,97,114,107,117,112,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,0,0,0,0,0,0,0,105,108,108,101,103,97,108,32,99,104,97,114,97,99,116,101,114,40,115,41,32,105,110,32,112,117,98,108,105,99,32,105,100,0,0,0,0,0,0,0,112,97,114,115,101,114,32,115,117,115,112,101,110,100,101,100,0,0,0,0,0,0,0,0,112,97,114,115,101,114,32,110,111,116,32,115,117,115,112,101,110,100,101,100,0,0,0,0,112,97,114,115,105,110,103,32,97,98,111,114,116,101,100,0,112,97,114,115,105,110,103,32,102,105,110,105,115,104,101,100,0,0,0,0,0,0,0,0,99,97,110,110,111,116,32,115,117,115,112,101,110,100,32,105,110,32,101,120,116,101,114,110,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,0,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,41,32,109,117,115,116,32,110,111,116,32,98,101,32,117,110,100,101,99,108,97,114,101,100,32,111,114,32,98,111,117,110,100,32,116,111,32,97,110,111,116,104,101,114,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,110,115,41,32,109,117,115,116,32,110,111,116,32,98,101,32,100,101,99,108,97,114,101,100,32,111,114,32,117,110,100,101,99,108,97,114,101,100,0,0,0,0,0,0,112,114,101,102,105,120,32,109,117,115,116,32,110,111,116,32,98,101,32,98,111,117,110,100,32,116,111,32,111,110,101,32,111,102,32,116,104,101,32,114,101,115,101,114,118,101,100,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,115,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,48,47,120,109,108,110,115,47,0,0,0,35,0,0,0,0,0,0,0,67,68,65,84,65,0,0,0,73,68,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,69,78,84,73,84,89,0,0,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,0,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,0,78,79,84,65,84,73,79,78,40,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,120,109,108,61,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,0,0,0,0,2,3,4,5,6,7,8,0,0,9,10,11,12,13,14,15,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,4,254,255,255,135,254,255,255,7,0,0,0,0,0,0,0,0,255,255,127,255,255,255,127,255,255,255,255,255,255,255,243,127,254,253,255,255,255,255,255,127,255,255,255,255,255,255,255,255,15,224,255,255,255,255,49,252,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,3,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,0,0,0,0,0,0,0,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,254,7,0,0,0,0,254,255,255,255,255,255,255,255,255,124,255,127,47,0,96,0,0,0,224,255,255,255,255,255,255,35,0,0,0,255,3,0,0,0,224,159,249,255,255,253,197,3,0,0,0,176,3,0,3,0,224,135,249,255,255,253,109,3,0,0,0,94,0,0,28,0,224,175,251,255,255,253,237,35,0,0,0,0,1,0,0,0,224,159,249,255,255,253,205,35,0,0,0,176,3,0,0,0,224,199,61,214,24,199,191,3,0,0,0,0,0,0,0,0,224,223,253,255,255,253,239,3,0,0,0,0,3,0,0,0,224,223,253,255,255,253,239,3,0,0,0,64,3,0,0,0,224,223,253,255,255,253,255,3,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,13,0,63,0,0,0,0,0,0,0,150,37,240,254,174,108,13,32,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,254,255,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,63,0,255,255,255,255,127,0,237,218,7,0,0,0,0,80,1,80,49,130,171,98,44,0,0,0,0,64,0,201,128,245,7,0,0,0,0,8,1,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,3,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,64,76,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,254,3,0,0,254,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,7,224,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,255,7,254,255,255,135,254,255,255,7,0,0,0,0,0,0,128,0,255,255,127,255,255,255,127,255,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,3,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,3,0,0,0,192,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,123,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,254,255,251,255,255,187,22,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,255,255,7,0,255,3,255,255,255,255,255,255,255,255,255,124,255,127,239,255,255,61,255,3,238,255,255,255,255,255,255,243,255,63,30,255,207,255,0,0,238,159,249,255,255,253,197,211,159,57,128,176,207,255,3,0,228,135,249,255,255,253,109,211,135,57,0,94,192,255,31,0,238,175,251,255,255,253,237,243,191,59,0,0,193,255,0,0,238,159,249,255,255,253,205,243,143,57,192,176,195,255,0,0,236,199,61,214,24,199,191,195,199,61,128,0,128,255,0,0,238,223,253,255,255,253,239,195,223,61,96,0,195,255,0,0,236,223,253,255,255,253,239,195,223,61,96,64,195,255,0,0,236,223,253,255,255,253,255,195,207,61,128,0,195,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,255,7,255,127,255,3,0,0,0,0,150,37,240,254,174,108,255,59,95,63,255,3,0,0,0,0,0,0,0,3,255,3,160,194,255,254,255,255,255,3,254,255,223,15,191,254,255,63,254,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,31,2,0,0,0,160,0,0,0,254,255,62,0,254,255,255,255,255,255,255,255,255,255,31,102,254,255,255,255,255,255,255,255,255,255,255,119,25,3,26,27,28,29,30,0,0,31,32,33,34,35,36,37,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,38,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,39,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,85,84,70,45,49,54,0,0,88,148,3,0,232,146,3,0,112,145,3,0,248,143,3,0,248,143,3,0,128,142,3,0,112,145,3,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,68,65,84,65,91,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,4,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,12,0,0,0,5,0,0,0,2,0,0,0,18,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,68,65,84,65,91,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,67,68,65,84,65,91,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,9,0,0,0,8,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,32,159,3,0,168,155,3,0,56,154,3,0,200,152,3,0,200,152,3,0,88,151,3,0,56,154,3,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+225304);
/* memory initializer */ allocate([36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,4,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,12,0,0,0,5,0,0,0,2,0,0,0,18,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,118,101,114,115,105,111,110,0,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,115,116,97,110,100,97,108,111,110,101,0,0,0,0,0,0,121,101,115,0,0,0,0,0,110,111,0,0,0,0,0,0,104,157,3,0,120,157,3,0,136,157,3,0,88,142,3,0,144,157,3,0,160,157,3,0,73,83,79,45,56,56,53,57,45,49,0,0,0,0,0,0,85,83,45,65,83,67,73,73,0,0,0,0,0,0,0,0,85,84,70,45,56,0,0,0,85,84,70,45,49,54,66,69,0,0,0,0,0,0,0,0,85,84,70,45,49,54,76,69,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,9,0,0,0,8,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,78,84,73,84,89,0,0,65,84,84,76,73,83,84,0,69,76,69,77,69,78,84,0,78,79,84,65,84,73,79,78,0,0,0,0,0,0,0,0,83,89,83,84,69,77,0,0,80,85,66,76,73,67,0,0,69,77,80,84,89,0,0,0,65,78,89,0,0,0,0,0,80,67,68,65,84,65,0,0,0,161,3,0,8,161,3,0,16,161,3,0,24,161,3,0,144,160,3,0,32,161,3,0,48,161,3,0,56,161,3,0,67,68,65,84,65,0,0,0,73,68,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,0,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,0,73,77,80,76,73,69,68,0,82,69,81,85,73,82,69,68,0,0,0,0,0,0,0,0,70,73,88,69,68,0,0,0,78,68,65,84,65,0,0,0,73,78,67,76,85,68,69,0,73,71,78,79,82,69,0,0,68,79,67,84,89,80,69,0,0,0,0,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,105,115,32,78,85,76,76,33,10,0,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,115,32,97,114,101,32,60,32,48,33,10,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,115,32,115,105,122,101,115,32,97,114,101,32,78,85,76,76,33,10,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,32,115,105,122,101,32,102,111,114,32,100,105,109,101,110,115,105,111,110,32,37,100,32,105,115,32,37,100,32,60,32,48,33,10,0,117,116,105,108,47,98,97,115,101,95,97,114,114,97,121,46,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,162,3,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,1,0,0,0,68,105,109,101,110,115,105,111,110,32,37,100,32,104,97,115,32,98,111,117,110,100,115,32,49,46,46,37,100,44,32,103,111,116,32,97,114,114,97,121,32,115,117,98,115,99,114,105,112,116,32,37,100,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,97,41,0,0,0,0,0,0,0,0,115,105,122,101,95,111,102,95,100,105,109,101,110,115,105,111,110,95,98,97,115,101,95,97,114,114,97,121,0,0,0,0,40,105,32,62,32,48,41,32,38,38,32,40,105,32,60,61,32,97,45,62,110,100,105,109,115,41,0,0,0,0,0,0,3,0,0,0,0,0,0,0,76,79,71,95,85,78,75,78,79,87,78,0,0,0,0,0,115,116,100,111,117,116,0,0,97,115,115,101,114,116,0,0,76,79,71,95,68,68,65,83,82,84,0,0,0,0,0,0,76,79,71,95,68,69,66,85,71,0,0,0,0,0,0,0,76,79,71,95,68,83,83,0,76,79,71,95,68,83,83,95,74,65,67,0,0,0,0,0,76,79,71,95,69,86,69,78,84,83,0,0,0,0,0,0,76,79,71,95,69,86,69,78,84,83,95,86,0,0,0,0,76,79,71,95,73,78,73,84,0,0,0,0,0,0,0,0,76,79,71,95,73,80,79,80,84,0,0,0,0,0,0,0,76,79,71,95,73,80,79,80,84,95,70,85,76,76,0,0,76,79,71,95,73,80,79,80,84,95,74,65,67,0,0,0,76,79,71,95,73,80,79,80,84,95,72,69,83,83,69,0,76,79,71,95,74,65,67,0,76,79,71,95,76,83,0,0,76,79,71,95,76,83,95,86,0,0,0,0,0,0,0,0,76,79,71,95,78,76,83,0,76,79,71,95,78,76,83,95,86,0,0,0,0,0,0,0,76,79,71,95,78,76,83,95,74,65,67,0,0,0,0,0,76,79,71,95,78,76,83,95,82,69,83,0,0,0,0,0,76,79,71,95,82,69,83,95,73,78,73,84,0,0,0,0,76,79,71,95,83,73,77,85,76,65,84,73,79,78,0,0,76,79,71,95,83,79,76,86,69,82,0,0,0,0,0,0,76,79,71,95,83,79,84,73,0,0,0,0,0,0,0,0,76,79,71,95,83,84,65,84,83,0,0,0,0,0,0,0,76,79,71,95,85,84,73,76,0,0,0,0,0,0,0,0,76,79,71,95,90,69,82,79,67,82,79,83,83,73,78,71,83,0,0,0,0,0,0,0,40,163,3,0,56,163,3,0,64,163,3,0,72,163,3,0,88,163,3,0,104,163,3,0,112,163,3,0,128,163,3,0,144,163,3,0,160,163,3,0,176,163,3,0,192,163,3,0,208,163,3,0,224,163,3,0,240,163,3,0,248,163,3,0,0,164,3,0,16,164,3,0,24,164,3,0,40,164,3,0,56,164,3,0,72,164,3,0,88,164,3,0,104,164,3,0,120,164,3,0,136,164,3,0,152,164,3,0,168,164,3,0,117,110,107,110,111,119,110,0,116,104,105,115,32,115,116,114,101,97,109,32,105,115,32,97,108,119,97,121,115,32,97,99,116,105,118,101,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,100,97,115,115,108,32,115,111,108,118,101,114,0,0,0,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,100,101,98,117,103,32,105,110,102,111,114,109,97,116,105,111,110,0,0,0,0,111,117,116,112,117,116,115,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,106,97,99,111,98,105,97,110,32,111,102,32,116,104,101,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,100,117,114,105,110,103,32,101,118,101,110,116,32,105,116,101,114,97,116,105,111,110,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,101,118,101,110,116,32,115,121,115,116,101,109,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,100,117,114,105,110,103,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,105,110,102,111,114,109,97,116,105,111,110,32,102,114,111,109,32,73,112,111,112,116,0,0,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,102,114,111,109,32,73,112,111,112,116,0,0,0,0,0,99,104,101,99,107,32,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,119,105,116,104,32,73,112,111,112,116,0,0,0,0,0,0,0,0,99,104,101,99,107,32,104,101,115,115,105,97,110,32,109,97,116,114,105,120,32,119,105,116,104,32,73,112,111,112,116,0,111,117,116,112,117,116,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,117,115,101,100,32,98,121,32,100,97,115,115,108,0,0,0,0,0,0,0,108,111,103,103,105,110,103,32,102,111,114,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,0,108,111,103,103,105,110,103,32,102,111,114,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,111,117,116,112,117,116,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,111,102,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,101,118,101,114,121,32,101,118,97,108,117,97,116,105,111,110,32,111,102,32,116,104,101,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,114,101,115,105,100,117,97,108,115,32,111,102,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,115,105,109,117,108,97,116,105,111,110,32,112,114,111,99,101,115,115,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,115,111,108,118,101,114,32,112,114,111,99,101,115,115,0,0,0,0,0,102,105,110,97,108,32,115,111,108,117,116,105,111,110,32,111,102,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,115,116,97,116,105,115,116,105,99,115,32,97,98,111,117,116,32,116,105,109,101,114,47,101,118,101,110,116,115,47,115,111,108,118,101,114,0,63,63,63,0,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,116,104,101,32,122,101,114,111,99,114,111,115,115,105,110,103,115,0,0,48,165,3,0,56,165,3,0,56,165,3,0,88,165,3,0,136,165,3,0,168,165,3,0,224,165,3,0,16,166,3,0,64,166,3,0,96,166,3,0,144,166,3,0,168,166,3,0,200,166,3,0,240,166,3,0,16,167,3,0,64,167,3,0,96,167,3,0,136,167,3,0,168,167,3,0,208,167,3,0,0,168,3,0,56,168,3,0,96,168,3,0,144,168,3,0,192,168,3,0,232,168,3,0,24,169,3,0,32,169,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,91,37,115,58,37,100,58,37,100,45,37,100,58,37,100,58,37,115,93,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,119,114,105,116,97,98,108,101,0,0,0,0,0,0,0,0,37,45,49,55,115,32,124,32,0,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,37,45,55,115,32,124,32,0,48,165,3,0,32,172,3,0,40,172,3,0,48,172,3,0,64,163,3,0,56,172,3,0,124,32,0,0,0,0,0,0,60,109,101,115,115,97,103,101,32,115,116,114,101,97,109,61,34,37,115,34,32,116,121,112,101,61,34,37,115,34,32,116,101,120,116,61,34,0,0,0,34,62,10,0,0,0,0,0,60,117,115,101,100,32,105,110,100,101,120,61,34,37,100,34,32,47,62,10,0,0,0,0,60,47,109,101,115,115,97,103,101,62,10,0,0,0,0,0,34,32,47,62,10,0,0,0,7,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,38,97,109,112,59,0,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,105,110,102,111,0,0,0,0,119,97,114,110,105,110,103,0,101,114,114,111,114,0,0,0,100,101,98,117,103,0,0,0,34,62,0,0,0,0,0,0,115,111,108,118,101,114,32,119,105,108,108,32,116,114,121,32,116,111,32,104,97,110,100,108,101,32,100,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,32,97,116,32,116,105,109,101,32,37,46,49,54,103,58,32,37,115,0,0,0,0,100,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,32,97,116,32,116,105,109,101,32,37,46,49,54,103,44,32,100,105,118,105,115,111,114,58,32,37,115,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,105,110,118,97,108,105,100,32,108,105,115,116,45,112,111,105,110,116,101,114,0,0,0,0,101,109,112,116,121,32,108,105,115,116,0,0,0,0,0,0,105,110,118,97,108,105,100,32,102,105,115,116,32,108,105,115,116,45,112,111,105,110,116,101,114,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,108,105,115,116,45,110,111,100,101,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,100,97,116,97,32,110,111,100,101,0,0,0,0,0,0,0,1,0,0,0,25,0,0,0,26,0,0,0,26,0,0,0,27,0,0,0,2,0,0,0,2,0,0,0,28,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,37,100,100,0,0,0,0,37,100,100,0,0,0,0,0,45,37,100,46,37,100,103,0,37,100,46,37,100,103,0,0,98,105,110,84,114,97,110,115,0,0,0,0,0,0,0,0,176,173,3,0,0,0,0,0,98,105,110,78,111,114,109,97,108,0,0,0,0,0,0,0,200,173,3,0,0,0,0,0,65,99,108,97,115,115,0,0,110,97,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,100,97,116,97,73,110,102,111,0,0,0,0,0,0,0,0,100,97,116,97,95,49,0,0,100,97,116,97,95,50,0,0,224,173,3,0,232,173,3,0,240,173,3,0,0,174,3,0,16,174,3,0,24,174,3,0,51,0,0,0,51,0,0,0,51,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,49,41,0,0,0,0,0,0,77,97,116,114,105,120,32,116,121,112,101,32,109,105,115,109,97,116,99,104,0,0,0,0,77,97,116,114,105,120,32,117,115,101,115,32,105,109,97,103,105,110,97,114,121,32,110,117,109,98,101,114,115,0,0,0,67,111,117,108,100,32,110,111,116,32,100,101,116,101,114,109,105,110,101,32,115,105,122,101,32,111,102,32,109,97,116,114,105,120,32,101,108,101,109,101,110,116,115,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,50,41,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,51,41,0,0,0,0,0,0,77,97,116,114,105,120,32,110,97,109,101,32,109,105,115,109,97,116,99,104,0,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,52,32,114,111,119,115,0,0,0,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,49,32,99,111,108,115,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,65,99,108,97,115,115,32,109,97,116,114,105,120,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,98,105,110,84,114,97,110,115,32,111,114,32,98,105,110,78,111,114,109,97,108,32,102,111,114,109,97,116,0,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,110,97,109,101,115,32,109,97,116,114,105,120,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,73,110,102,111,32,109,97,116,114,105,120,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,99,111,110,116,97,105,110,32,97,116,32,108,101,97,115,116,32,49,32,118,97,114,105,97,98,108,101,0,0,0,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,32,111,114,32,50,32,99,111,108,115,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,95,49,32,109,97,116,114,105,120,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,99,111,110,116,97,105,110,101,100,32,112,97,114,97,109,101,116,101,114,32,116,104,97,116,32,99,104,97,110,103,101,100,32,98,101,116,119,101,101,110,32,115,116,97,114,116,32,97,110,100,32,115,116,111,112,45,116,105,109,101,0,0,0,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,32,111,114,32,50,32,114,111,119,115,0,84,111,111,32,102,101,119,32,114,111,119,115,32,105,110,32,100,97,116,97,95,50,32,109,97,116,114,105,120,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,95,50,32,109,97,116,114,105,120,0,0,0,73,109,112,108,101,109,101,110,116,97,116,105,111,110,32,101,114,114,111,114,58,32,85,110,107,110,111,119,110,32,99,97,115,101,0,0,0,0,0,0,97,98,115,86,97,114,73,110,100,101,120,32,62,32,48,32,38,38,32,97,98,115,86,97,114,73,110,100,101,120,32,60,61,32,114,101,97,100,101,114,45,62,110,118,97,114,0,0,117,116,105,108,47,114,101,97,100,95,109,97,116,108,97,98,52,46,99,0,0,0,0,0,111,109,99,95,109,97,116,108,97,98,52,95,114,101,97,100,95,118,97,108,115,0,0,0,111,109,99,95,109,97,116,108,97,98,52,95,114,101,97,100,95,115,105,110,103,108,101,95,118,97,108,0,0,0,0,0,117,116,105,108,47,114,101,97,108,95,97,114,114,97,121,46,99,0,0,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,97,41,0,0,0,0,0,0,0,0,115,117,109,95,114,101,97,108,95,97,114,114,97,121,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,101,109,112,116,121,32,82,105,110,103,66,117,102,102,101,114,0,0,0,0,0,0,0,0,105,110,100,101,120,32,91,37,100,93,32,111,117,116,32,111,102,32,114,97,110,103,101,32,91,37,100,58,37,100,93,0,48,185,3,0,0,0,0,0,168,184,3,0,0,0,0,0,32,184,3,0,0,0,0,0,152,183,3,0,0,0,0,0,144,182,3,0,0,0,0,0,136,181,3,0,0,0,0,0,128,180,3,0,0,0,0,0,120,179,3,0,0,0,0,0,97,99,99,95,116,112,32,33,61,32,48,0,0,0,0,0,117,116,105,108,47,114,116,99,108,111,99,107,46,99,0,0,114,116,95,105,110,105,116,0,109,97,120,95,116,112,32,33,61,32,48,0,0,0,0,0,116,111,116,97,108,95,116,112,32,33,61,32,48,0,0,0,116,105,99,107,95,116,112,32,33,61,32,48,0,0,0,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,32,33,61,32,48,0,0,0,0,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,109,105,110,32,33,61,32,48,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,109,97,120,32,33,61,32,48,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,116,111,116,97,108,32,33,61,32,48], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+235544);
/* memory initializer */ allocate([69,114,114,111,114,32,115,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,83,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,58,32,105,116,101,114,97,116,105,111,110,32,110,111,116,32,109,97,107,105,110,103,32,112,114,111,103,114,101,115,115,44,32,116,114,121,105,110,103,32,119,105,116,104,32,100,105,102,102,101,114,101,110,116,32,115,116,97,114,116,105,110,103,32,112,111,105,110,116,115,32,40,43,37,103,41,0,83,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,58,32,105,116,101,114,97,116,105,111,110,32,110,111,116,32,109,97,107,105,110,103,32,112,114,111,103,114,101,115,115,44,32,116,114,121,105,110,103,32,116,111,32,100,101,99,114,101,97,115,101,32,102,97,99,116,111,114,32,116,111,32,37,103,0,0,0,0,0,105,109,112,114,111,112,101,114,32,105,110,112,117,116,32,112,97,114,97,109,101,116,101,114,115,32,116,111,32,110,111,110,108,105,110,101,97,114,32,101,113,46,32,115,121,115,116,58,32,37,115,32,97,116,32,116,105,109,101,32,37,103,0,0,85,110,107,110,111,119,110,32,101,113,117,97,116,105,111,110,32,115,121,115,116,101,109,32,101,114,114,111,114,58,32,37,100,32,37,115,32,37,103,0,70,76,65,71,95,85,78,75,78,79,87,78,0,0,0,0,99,108,111,99,107,0,0,0,99,112,117,0,0,0,0,0,101,109,105,116,95,112,114,111,116,101,99,116,101,100,0,0,102,0,0,0,0,0,0,0,104,101,108,112,0,0,0,0,105,105,102,0,0,0,0,0,105,105,109,0,0,0,0,0,105,105,116,0,0,0,0,0,105,108,115,0,0,0,0,0,105,110,116,101,114,97,99,116,105,118,101,0,0,0,0,0,105,111,109,0,0,0,0,0,105,112,111,112,116,95,104,101,115,115,101,0,0,0,0,0,105,112,111,112,116,95,106,97,99,0,0,0,0,0,0,0,105,112,111,112,116,95,105,110,105,116,0,0,0,0,0,0,108,0,0,0,0,0,0,0,108,111,103,70,111,114,109,97,116,0,0,0,0,0,0,0,108,115,0,0,0,0,0,0,108,115,95,105,112,111,112,116,0,0,0,0,0,0,0,0,108,118,0,0,0,0,0,0,109,101,97,115,117,114,101,84,105,109,101,80,108,111,116,70,111,114,109,97,116,0,0,0,110,108,115,0,0,0,0,0,110,111,101,109,105,116,0,0,110,111,69,118,101,110,116,69,109,105,116,0,0,0,0,0,111,117,116,112,117,116,0,0,111,118,101,114,114,105,100,101,0,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,70,105,108,101,0,0,0,0,112,111,114,116,0,0,0,0,114,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,70,76,65,71,95,77,65,88,0,0,0,0,0,0,0,0,24,187,3,0,40,187,3,0,48,187,3,0,56,187,3,0,72,187,3,0,80,187,3,0,88,187,3,0,96,187,3,0,104,187,3,0,112,187,3,0,120,187,3,0,136,187,3,0,144,187,3,0,160,187,3,0,176,187,3,0,192,187,3,0,200,187,3,0,216,187,3,0,224,187,3,0,240,187,3,0,248,187,3,0,16,188,3,0,24,188,3,0,32,188,3,0,48,188,3,0,56,188,3,0,72,188,3,0,88,188,3,0,96,188,3,0,104,188,3,0,112,188,3,0,120,188,3,0,117,110,107,110,111,119,110,0,115,101,108,101,99,116,115,32,116,104,101,32,116,121,112,101,32,111,102,32,99,108,111,99,107,32,116,111,32,117,115,101,32,45,99,108,111,99,107,61,82,84,44,32,45,99,108,111,99,107,61,67,89,67,32,111,114,32,45,99,108,111,99,107,61,67,80,85,0,0,0,0,100,117,109,112,115,32,116,104,101,32,99,112,117,45,116,105,109,101,32,105,110,116,111,32,116,104,101,32,114,101,115,117,108,116,115,45,102,105,108,101,0,0,0,0,0,0,0,0,101,109,105,116,115,32,112,114,111,116,101,99,116,101,100,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,110,101,119,32,115,101,116,117,112,32,88,77,76,32,102,105,108,101,32,116,111,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,99,111,100,101,0,0,0,103,101,116,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,116,104,97,116,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,110,32,101,120,116,101,114,110,97,108,32,102,105,108,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,109,101,116,104,111,100,0,0,0,0,0,0,0,91,100,111,117,98,108,101,93,32,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,0,91,105,110,116,93,32,100,101,102,97,117,108,116,58,32,49,0,0,0,0,0,0,0,0,115,112,101,99,105,102,121,32,105,110,116,101,114,97,99,116,105,118,101,32,115,105,109,117,108,97,116,105,111,110,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,112,116,105,109,105,122,97,116,105,111,110,32,109,101,116,104,111,100,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,104,101,115,115,105,97,110,32,102,111,114,32,73,112,111,112,116,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,102,111,114,32,73,112,111,112,116,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,111,114,32,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,119,104,101,114,101,32,116,104,101,32,108,105,110,101,97,114,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,32,115,104,111,117,108,100,32,98,101,32,112,101,114,102,111,114,109,101,100,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,46,32,45,108,111,103,70,111,114,109,97,116,61,116,101,120,116,32,40,100,101,102,97,117,108,116,41,32,111,114,32,45,108,111,103,70,111,114,109,97,116,61,120,109,108,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,102,111,114,32,105,112,111,112,116,0,0,0,0,0,0,91,115,116,114,105,110,103,32,108,105,115,116,93,32,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,103,105,110,103,32,108,101,118,101,108,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,111,117,116,112,117,116,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,109,101,97,115,117,114,101,32,116,105,109,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,110,111,110,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,0,100,111,32,110,111,116,32,101,109,105,116,32,97,110,121,32,114,101,115,117,108,116,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,32,102,105,108,101,0,0,0,0,0,0,100,111,32,110,111,116,32,101,109,105,116,32,101,118,101,110,116,32,112,111,105,110,116,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,32,102,105,108,101,0,0,0,0,0,111,117,116,112,117,116,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,97,44,32,98,32,97,110,100,32,99,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,116,111,32,116,104,101,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,0,0,0,0,0,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,0,119,105,108,108,32,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,32,119,105,116,104,32,116,104,101,32,118,97,108,117,101,115,32,102,114,111,109,32,116,104,101,32,102,105,108,101,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,105,110,116,101,114,97,99,116,105,118,101,32,115,105,109,117,108,97,116,105,111,110,32,112,111,114,116,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,110,101,119,32,114,101,115,117,108,116,32,102,105,108,101,32,116,104,97,110,32,116,104,101,32,100,101,102,97,117,108,116,32,77,111,100,101,108,95,114,101,115,46,109,97,116,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,115,111,108,118,101,114,0,0,0,0,0,0,115,104,111,119,115,32,97,108,108,32,119,97,114,110,105,110,103,115,32,101,118,101,110,32,105,102,32,97,32,114,101,108,97,116,101,100,32,108,111,103,45,115,116,114,101,97,109,32,105,115,32,105,110,97,99,116,105,118,101,0,0,0,0,0,8,189,3,0,16,189,3,0,88,189,3,0,136,189,3,0,184,189,3,0,0,190,3,0,64,190,3,0,136,190,3,0,184,190,3,0,0,191,3,0,24,191,3,0,56,191,3,0,112,191,3,0,152,191,3,0,192,191,3,0,248,191,3,0,72,192,3,0,168,192,3,0,216,192,3,0,16,193,3,0,64,193,3,0,136,193,3,0,176,193,3,0,224,193,3,0,16,194,3,0,104,194,3,0,176,194,3,0,32,195,3,0,80,195,3,0,152,195,3,0,184,195,3,0,120,188,3,0,115,101,108,101,99,116,115,32,116,104,101,32,116,121,112,101,32,111,102,32,99,108,111,99,107,32,116,111,32,117,115,101,32,45,99,108,111,99,107,61,82,84,44,32,45,99,108,111,99,107,61,67,89,67,32,111,114,32,45,99,108,111,99,107,61,67,80,85,10,32,32,82,84,61,109,111,110,111,116,111,110,105,99,32,114,101,97,108,45,116,105,109,101,32,99,108,111,99,107,44,32,67,80,85,61,112,114,111,99,101,115,115,45,98,97,115,101,100,32,67,80,85,45,116,105,109,101,44,32,67,89,67,61,99,112,117,32,99,121,99,108,101,115,32,109,101,97,115,117,114,101,100,32,119,105,116,104,32,82,68,84,83,67,0,0,0,0,0,32,32,45,32,100,117,109,112,115,32,116,104,101,32,99,112,117,45,116,105,109,101,32,105,110,116,111,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,10,32,32,45,32,36,99,112,117,84,105,109,101,32,105,115,32,116,104,101,32,118,97,114,105,97,98,108,101,32,110,97,109,101,32,105,110,115,105,100,101,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,0,0,0,0,103,101,116,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,116,104,97,116,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,10,32,32,101,46,103,46,32,45,104,101,108,112,61,102,32,112,114,105,110,116,115,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,102,111,114,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,32,102,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,115,116,101,112,115,32,102,111,114,32,104,111,109,111,116,111,112,121,32,109,101,116,104,111,100,32,40,114,101,113,117,105,114,101,100,58,32,45,105,105,109,61,115,121,109,98,111,108,105,99,41,32,111,114,10,39,115,116,97,114,116,32,118,97,108,117,101,32,104,111,109,111,116,111,112,121,39,32,109,101,116,104,111,100,32,40,114,101,113,117,105,114,101,100,58,32,45,105,105,109,61,110,117,109,101,114,105,99,32,45,105,111,109,61,110,101,108,100,101,114,95,109,101,97,100,95,101,120,41,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,104,101,115,115,101,109,97,116,114,105,120,32,102,111,114,32,73,112,111,112,116,40,79,77,67,44,32,66,70,71,83,44,32,99,111,110,115,116,41,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,102,111,114,32,73,112,111,112,116,40,83,89,77,44,32,78,85,77,44,32,78,85,77,68,69,78,83,69,41,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,111,114,32,111,112,116,105,109,105,122,97,116,105,111,110,32,40,115,105,109,44,32,99,111,110,115,116,41,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,10,32,32,108,97,112,97,99,107,44,32,108,105,115,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,102,111,114,32,73,112,111,112,116,44,32,100,101,102,97,117,108,116,32,109,117,109,112,115,46,10,32,78,111,116,101,58,32,85,115,101,32,105,102,32,121,111,117,32,98,117,105,108,100,32,105,112,111,112,116,32,119,105,116,104,32,111,116,104,101,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,108,105,107,101,32,109,97,50,55,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,103,105,110,103,32,108,101,118,101,108,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,111,117,116,112,117,116,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,109,101,97,115,117,114,101,32,116,105,109,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,10,32,32,115,118,103,10,32,32,106,112,103,10,32,32,112,115,10,32,32,103,105,102,10,32,32,46,46,46,0,0,0,0,0,0,0,0,111,117,116,112,117,116,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,97,44,32,98,32,97,110,100,32,99,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,116,111,32,116,104,101,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,10,32,32,116,105,109,101,32,61,32,118,97,108,117,101,44,32,97,32,61,32,118,97,108,117,101,44,32,98,32,61,32,118,97,108,117,101,44,32,99,32,61,32,118,97,108,117,101,0,0,0,0,0,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,10,32,32,101,46,103,46,32,118,97,114,49,61,115,116,97,114,116,49,44,118,97,114,50,61,115,116,97,114,116,50,44,112,97,114,51,61,115,116,97,114,116,51,44,115,116,97,114,116,84,105,109,101,61,118,97,108,49,44,115,116,111,112,84,105,109,101,61,118,97,108,50,44,115,116,101,112,83,105,122,101,61,118,97,108,51,44,10,32,32,32,32,32,32,32,116,111,108,101,114,97,110,99,101,61,118,97,108,52,44,115,111,108,118,101,114,61,34,115,101,101,32,45,115,34,44,111,117,116,112,117,116,70,111,114,109,97,116,61,34,109,97,116,124,112,108,116,124,99,115,118,124,101,109,112,116,121,34,44,118,97,114,105,97,98,108,101,70,105,108,116,101,114,61,34,102,105,108,116,101,114,34,0,0,0,119,105,108,108,32,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,32,119,105,116,104,32,116,104,101,32,118,97,108,117,101,115,32,102,114,111,109,32,116,104,101,32,102,105,108,101,10,32,32,110,111,116,101,32,116,104,97,116,58,32,45,111,118,101,114,114,105,100,101,70,105,108,101,32,67,65,78,78,79,84,32,98,101,32,117,115,101,100,32,119,105,116,104,32,45,111,118,101,114,114,105,100,101,10,32,32,117,115,101,32,119,104,101,110,32,118,97,114,105,97,98,108,101,115,32,102,111,114,32,45,111,118,101,114,114,105,100,101,32,97,114,101,32,116,111,111,32,109,97,110,121,32,97,110,100,32,100,111,32,110,111,116,32,102,105,116,32,105,110,32,99,111,109,109,97,110,100,32,108,105,110,101,32,115,105,122,101,10,32,32,111,118,101,114,114,105,100,101,70,105,108,101,78,97,109,101,32,99,111,110,116,97,105,110,115,32,108,105,110,101,115,32,111,102,32,116,104,101,32,102,111,114,109,58,32,118,97,114,49,61,115,116,97,114,116,49,0,0,0,0,0,0,8,189,3,0,120,196,3,0,32,197,3,0,136,189,3,0,184,189,3,0,136,197,3,0,64,190,3,0,136,190,3,0,16,198,3,0,80,198,3,0,24,191,3,0,56,191,3,0,240,198,3,0,48,199,3,0,112,199,3,0,248,191,3,0,72,192,3,0,176,199,3,0,232,199,3,0,112,200,3,0,152,200,3,0,136,193,3,0,176,193,3,0,224,193,3,0,0,201,3,0,136,201,3,0,136,202,3,0,32,195,3,0,80,195,3,0,152,195,3,0,184,195,3,0,120,188,3,0,0,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,49,120,44,56,48,97,49,41,0,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,73,49,32,61,2,44,105,49,48,41,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,73,49,32,61,2,44,105,49,48,44,51,120,44,2,73,50,32,61,2,44,105,49,48,41,0,0,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,82,49,32,61,2,44,101,50,49,46,49,51,41,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,44,32,32,82,49,32,61,2,44,101,50,49,46,49,51,44,51,120,44,2,82,50,32,61,2,44,101,50,49,46,49,51,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,207,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,208,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,208,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,208,3,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,72,69,32,76,65,83,84,32,83,84,69,80,32,84,69,82,77,73,78,65,84,69,68,32,87,73,84,72,32,65,32,78,69,71,65,84,73,86,69,0,0,0,0,0,0,0,49,0,0,0,0,0,0,0,201,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,86,65,76,85,69,32,40,61,73,49,41,32,79,70,32,73,68,73,68,32,65,78,68,32,78,79,32,65,80,80,82,79,80,82,73,65,84,69,0,47,0,0,0,0,0,0,0,202,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,67,84,73,79,78,32,87,65,83,32,84,65,75,69,78,46,32,82,85,78,32,84,69,82,77,73,78,65,84,69,68,0,0,0,0,0,0,0,41,0,0,0,0,0,0,0,203,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,67,85,82,82,69,78,84,32,84,32,40,61,82,49,41,32,32,53,48,48,32,83,84,69,80,83,0,0,38,0,0,0,0,0,0,0,98,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,65,75,69,78,32,79,78,32,84,72,73,83,32,67,65,76,76,32,66,69,70,79,82,69,32,82,69,65,67,72,73,78,71,32,84,79,85,84,0,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,99,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,84,79,79,32,77,85,67,72,32,65,67,67,85,82,65,67,89,32,82,69,81,85,69,83,84,69,68,0,108,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,70,79,82,32,80,82,69,67,73,83,73,79,78,32,79,70,32,77,65,67,72,73,78,69,46,32,82,84,79,76,32,65,78,68,32,65,84,79,76,0,0,0,0,0,0,0,0,109,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,87,69,82,69,32,73,78,67,82,69,65,83,69,68,32,84,79,32,65,80,80,82,79,80,82,73,65,84,69,32,86,65,76,85,69,83,0,0,0,45,0,0,0,0,0,0,0,110,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,87,84,0,0,118,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,72,65,83,32,66,69,67,79,77,69,32,46,76,69,46,32,48,46,48,0,0,0,0,28,0,0,0,0,0,0,0,119,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,65,78,68,32,83,84,69,80,83,73,90,69,32,72,32,40,61,82,50,41,32,84,72,69,0,0,0,0,44,0,0,0,0,0,0,0,128,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,69,82,82,79,82,32,84,69,83,84,32,70,65,73,76,69,68,32,82,69,80,69,65,84,69,68,76,89,32,79,82,32,87,73,84,72,32,65,66,83,40,72,41,61,72,77,73,78,0,0,0,0,0,0,0,57,0,0,0,0,0,0,0,129,2,0,0,0,0,0,0,138,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,70,65,73,76,69,68,32,84,79,32,67,79,78,86,69,82,71,69,32,82,69,80,69,65,84,69,68,76,89,0,0,0,0,0,0,0,0,139,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,79,82,32,87,73,84,72,32,65,66,83,40,72,41,61,72,77,73,78,0,0,0,0,140,2,0,0,0,0,0,0,148,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,84,69,82,65,84,73,79,78,32,77,65,84,82,73,88,32,73,83,32,83,73,78,71,85,76,65,82,0,0,0,37,0,0,0,0,0,0,0,149,2,0,0,0,0,0,0,158,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,67,79,85,76,68,32,78,79,84,32,67,79,78,86,69,82,71,69,46,32,32,65,76,83,79,44,32,84,72,69,0,0,0,0,0,0,0,159,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,69,82,82,79,82,32,84,69,83,84,32,70,65,73,76,69,68,32,82,69,80,69,65,84,69,68,76,89,46,0,0,160,2,0,0,0,0,0,0,163,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,67,79,85,76,68,32,78,79,84,32,67,79,78,86,69,82,71,69,32,66,69,67,65,85,83,69,0,0,0,164,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,82,69,83,32,87,65,83,32,69,81,85,65,76,32,84,79,32,77,73,78,85,83,32,79,78,69,0,0,0,0,36,0,0,0,0,0,0,0,165,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,65,78,68,32,83,84,69,80,83,73,90,69,32,72,32,40,61,82,50,41,0,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,168,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,82,69,83,32,87,65,83,32,69,81,85,65,76,32,84,79,32,77,73,78,85,83,32,84,87,79,0,0,0,0,169,2,0,0,0,0,0,0,173,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,73,84,73,65,76,32,89,80,82,73,77,69,32,67,79,85,76,68,32,78,79,84,32,66,69,32,67,79,77,80,85,84,69,68,0,0,0,174,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,73,78,70,79,32,86,69,67,84,79,82,32,73,83,32,78,79,84,32,90,69,82,79,32,79,82,32,79,78,69,0,55,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,78,69,81,32,40,61,73,49,41,32,46,76,69,46,32,48,0,0,0,0,0,0,0,25,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,65,88,79,82,68,32,40,61,73,49,41,32,78,79,84,32,73,78,32,82,65,78,71,69,0,0,0,0,0,0,34,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,82,87,79,82,75,32,76,69,78,71,84,72,32,78,69,69,68,69,68,44,32,76,69,78,82,87,32,40,61,73,49,41,44,32,69,88,67,69,69,68,83,32,76,82,87,32,40,61,73,50,41,0,0,0,0,60,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,87,79,82,75,32,76,69,78,71,84,72,32,78,69,69,68,69,68,44,32,76,69,78,73,87,32,40,61,73,49,41,44,32,69,88,67,69,69,68,83,32,76,73,87,32,40,61,73,50,41,0,0,0,0,5,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,82,84,79,76,32,73,83,32,46,76,84,46,32,48,0,39,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,65,84,79,76,32,73,83,32,46,76,84,46,32,48,0,7,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,76,76,32,69,76,69,77,69,78,84,83,32,79,70,32,82,84,79,76,32,65,78,68,32,65,84,79,76,32,65,82,69,32,90,69,82,79,0,8,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,52,41,32,61,32,49,32,65,78,68,32,84,83,84,79,80,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,79,85,84,32,40,61,82,50,41,0,0,54,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,72,77,65,88,32,40,61,82,49,41,32,46,76,84,46,32,48,46,48,0,0,0,0,10,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,79,85,84,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,32,40,61,82,50,41,0,0,0,0,0,0,11,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,56,41,61,49,32,65,78,68,32,72,48,61,48,46,48,0,0,0,29,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,87,84,32,73,83,32,46,76,69,46,32,48,46,48,0,13,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,84,79,85,84,32,40,61,82,49,41,32,84,79,79,32,67,76,79,83,69,32,84,79,32,84,32,40,61,82,50,41,32,84,79,32,83,84,65,82,84,32,73,78,84,69,71,82,65,84,73,79,78,0,0,0,0,14,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,52,41,61,49,32,65,78,68,32,84,83,84,79,80,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,32,40,61,82,50,41,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,76,32,40,61,73,49,41,32,73,76,76,69,71,65,76,46,32,69,73,84,72,69,82,32,46,76,84,46,32,48,32,79,82,32,46,71,84,46,32,78,69,81,0,0,0,0,52,0,0,0,0,0,0,0,17,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,85,32,40,61,73,49,41,32,73,76,76,69,71,65,76,46,32,69,73,84,72,69,82,32,46,76,84,46,32,48,32,79,82,32,46,71,84,46,32,78,69,81,0,0,0,0,18,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,79,85,84,32,40,61,82,49,41,32,73,83,32,69,81,85,65,76,32,84,79,32,84,32,40,61,82,50,41,0,19,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,78,71,32,40,61,73,49,41,32,46,76,84,46,32,48,0,0,0,0,0,0,0,0,24,0,0,0,0,0,0,0,30,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,79,78,69,32,79,82,32,77,79,82,69,32,67,79,77,80,79,78,69,78,84,83,32,79,70,32,71,32,72,65,83,32,65,32,82,79,79,84,0,32,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,32,84,79,79,32,78,69,65,82,32,84,79,32,84,72,69,32,73,78,73,84,73,65,76,32,80,79,73,78,84,0,0,68,65,83,83,76,45,45,32,32,82,69,80,69,65,84,69,68,32,79,67,67,85,82,82,69,78,67,69,83,32,79,70,32,73,76,76,69,71,65,76,32,73,78,80,85,84,0,0,46,0,0,0,0,0,0,0,33,3,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,82,85,78,32,84,69,82,77,73,78,65,84,69,68,46,32,65,80,80,65,82,69,78,84,32,73,78,70,73,78,73,84,69,32,76,79,79,80,0,34,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,97,116,32,112,111,105,110,116,32,105,110,32,116,105,109,101,58,32,37,103,0,0,0,0,99,106,58,32,37,103,0,0,115,116,97,116,101,115,0,0,91,37,108,100,93,32,37,103,0,0,0,0,0,0,0,0,97,110,97,108,121,116,105,99,97,108,32,74,97,99,111,98,105,97,110,0,0,0,0,0,37,115,37,103,32,0,0,0,37,115,0,0,0,0,0,0,110,117,109,101,114,105,99,97,108,32,74,97,99,111,98,105,97,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,0,0,0,0,0,0,0,83,0,0,0,0,0,0,0,66,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,82,0,0,0,0,0,0,0,77,0,0,0,0,0,0,0,85,0,0,0,0,0,0,0,76,0,0,0,0,0,0,0,79], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+244144);
/* memory initializer */ allocate([40,47,47,2,32,87,65,82,78,73,78,71,46,32,84,104,101,32,118,97,108,117,101,32,69,77,73,78,32,109,97,121,32,98,101,32,105,110,99,111,114,114,101,99,116,58,45,2,44,2,32,32,69,77,73,78,32,61,32,2,44,105,56,44,47,2,32,73,102,44,32,97,102,116,101,114,32,105,110,115,112,101,99,116,105,111,110,44,32,116,104,101,32,118,97,108,117,101,32,69,77,73,78,32,108,111,111,107,115,2,44,2,32,97,99,99,101,112,116,97,98,108,101,32,112,108,101,97,115,101,32,99,111,109,109,101,110,116,32,111,117,116,32,2,44,47,2,32,116,104,101,32,73,70,32,98,108,111,99,107,32,97,115,32,109,97,114,107,101,100,32,119,105,116,104,105,110,32,116,104,101,32,99,111,100,101,32,111,102,32,114,111,117,116,105,110,101,2,44,2,32,68,76,65,77,67,50,44,2,44,47,2,32,111,116,104,101,114,119,105,115,101,32,115,117,112,112,108,121,32,69,77,73,78,32,101,120,112,108,105,99,105,116,108,121,46,2,44,47,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,32,226,3,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,191,76,0,0,0,0,176,60,49,101,0,0,0,0,16,0,244,14,255,255,255,255,239,127,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,2,32,80,114,111,103,114,101,115,115,32,82,101,112,111,114,116,32,101,118,101,114,121,2,44,105,52,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,2,47,44,2,32,69,86,65,76,46,32,32,32,70,85,78,67,46,86,65,76,85,69,46,2,44,49,48,120,44,2,80,65,82,65,77,69,84,69,82,32,86,65,76,85,69,83,2,41,0,0,0,0,40,47,49,120,44,105,52,44,50,120,44,103,49,50,46,53,44,50,120,44,53,103,49,49,46,52,44,51,40,47,50,49,120,44,53,103,49,49,46,52,41,41,0,0,0,0,0,0,40,2,32,78,111,46,32,111,102,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,32,62,32,2,44,105,53,41,0,0,40,2,32,82,77,83,32,111,102,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,111,102,32,108,97,115,116,32,115,105,109,112,108,101,120,32,61,2,44,103,49,52,46,54,41,0,0,0,0,0,40,2,32,67,101,110,116,114,111,105,100,32,111,102,32,108,97,115,116,32,115,105,109,112,108,101,120,32,61,2,44,52,40,47,49,120,44,54,103,49,51,46,53,41,41,0,0,0,40,2,32,70,117,110,99,116,105,111,110,32,118,97,108,117,101,32,97,116,32,99,101,110,116,114,111,105,100,32,61,2,44,103,49,52,46,54,41,0,40,47,2,32,69,86,73,68,69,78,67,69,32,79,70,32,67,79,78,86,69,82,71,69,78,67,69,2,41,0,0,0,40,47,47,2,32,77,105,110,105,109,117,109,32,102,111,117,110,100,32,97,102,116,101,114,2,44,105,53,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,2,41,0,0,0,40,2,32,77,105,110,105,109,117,109,32,97,116,2,44,52,40,47,49,120,44,54,103,49,51,46,54,41,41,0,0,0,40,2,32,70,117,110,99,116,105,111,110,32,118,97,108,117,101,32,97,116,32,109,105,110,105,109,117,109,32,61,2,44,103,49,52,46,54,41,0,0,40,47,2,32,70,105,116,116,105,110,103,32,113,117,97,100,114,97,116,105,99,32,115,117,114,102,97,99,101,32,97,98,111,117,116,32,115,117,112,112,111,115,101,100,32,109,105,110,105,109,117,109,2,47,41,0,40,47,2,32,77,65,84,82,73,88,32,79,70,32,69,83,84,73,77,65,84,69,68,32,83,69,67,79,78,68,32,68,69,82,73,86,65,84,73,86,69,83,32,78,79,84,32,43,86,69,32,68,69,70,78,46,2,47,2,32,77,73,78,73,77,85,77,32,80,82,79,66,65,66,76,89,32,78,79,84,32,70,79,85,78,68,2,47,41,0,0,0,0,0,0,0,40,47,49,48,120,44,2,83,101,97,114,99,104,32,114,101,115,116,97,114,116,105,110,103,2,47,41,0,0,0,0,0,40,2,32,77,105,110,105,109,117,109,32,111,102,32,113,117,97,100,114,97,116,105,99,32,115,117,114,102,97,99,101,32,61,2,44,103,49,52,46,54,44,2,32,97,116,2,44,52,40,47,49,120,44,54,103,49,51,46,53,41,41,0,0,0,40,2,32,73,70,32,84,72,73,83,32,68,73,70,70,69,82,83,32,66,89,32,77,85,67,72,32,70,82,79,77,32,84,72,69,32,77,73,78,73,77,85,77,32,69,83,84,73,77,65,84,69,68,2,44,49,120,44,2,70,82,79,77,32,84,72,69,32,77,73,78,73,77,73,90,65,84,73,79,78,44,2,47,2,32,84,72,69,32,77,73,78,73,77,85,77,32,77,65,89,32,66,69,32,70,65,76,83,69,32,38,47,79,82,32,84,72,69,32,73,78,70,79,82,77,65,84,73,79,78,32,77,65,84,82,73,88,32,77,65,89,32,66,69,2,44,49,120,44,2,73,78,65,67,67,85,82,65,84,69,2,47,41,0,0,0,0,0,40,2,32,82,97,110,107,32,111,102,32,105,110,102,111,114,109,97,116,105,111,110,32,109,97,116,114,105,120,32,61,2,44,105,51,47,2,32,73,110,118,101,114,115,101,32,111,102,32,105,110,102,111,114,109,97,116,105,111,110,32,109,97,116,114,105,120,58,45,2,41,0,40,47,2,32,73,102,32,116,104,101,32,102,117,110,99,116,105,111,110,32,109,105,110,105,109,105,122,101,100,32,119,97,115,32,45,76,79,71,40,76,73,75,69,76,73,72,79,79,68,41,44,2,47,2,32,116,104,105,115,32,105,115,32,116,104,101,32,99,111,118,97,114,105,97,110,99,101,32,109,97,116,114,105,120,32,111,102,32,116,104,101,32,112,97,114,97,109,101,116,101,114,115,46,2,47,2,32,73,102,32,116,104,101,32,102,117,110,99,116,105,111,110,32,119,97,115,32,97,32,115,117,109,32,111,102,32,115,113,117,97,114,101,115,32,111,102,32,114,101,115,105,100,117,97,108,115,44,2,47,2,32,116,104,105,115,32,109,97,116,114,105,120,32,109,117,115,116,32,98,101,32,109,117,108,116,105,112,108,105,101,100,32,98,121,32,116,119,105,99,101,32,116,104,101,32,101,115,116,105,109,97,116,101,100,2,44,49,120,44,2,114,101,115,105,100,117,97,108,32,118,97,114,105,97,110,99,101,2,47,2,32,116,111,32,111,98,116,97,105,110,32,116,104,101,32,99,111,118,97,114,105,97,110,99,101,32,109,97,116,114,105,120,46,2,47,41,0,0,0,0,40,2,32,73,78,70,79,82,77,65,84,73,79,78,32,77,65,84,82,73,88,58,45,2,47,41,0,0,0,0,0,0,40,47,47,2,32,67,79,82,82,69,76,65,84,73,79,78,32,77,65,84,82,73,88,58,45,2,41,0,0,0,0,0,40,47,2,32,65,32,102,117,114,116,104,101,114,2,44,105,52,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,32,104,97,118,101,32,98,101,101,110,32,117,115,101,100,2,47,41,0,0,0,0,0,0,40,49,120,44,54,103,49,51,46,53,41,0,0,0,0,0,40,47,41], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+254488);
/* memory initializer */ allocate([160,230,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,231,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,231,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,231,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,231,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,231,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,231,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,231,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,231,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,231,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,231,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,231,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,231,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,231,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,232,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,232,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,232,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,232,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,231,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,232,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,233,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,233,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,233,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,234,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,234,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,235,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,235,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,235,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,236,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,236,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,236,3,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,78,80,84,32,105,115,32,110,111,116,32,105,110,2,44,2,32,116,104,101,32,114,101,113,117,105,114,101,100,32,105,110,116,101,114,118,97,108,2,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,112,15,4,0,0,0,0,0,0,0,0,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,67,65,76,70,85,78,32,104,97,115,32,98,101,101,110,2,44,2,32,99,97,108,108,101,100,32,77,65,88,70,85,78,32,116,105,109,101,115,46,2,41,0,0,0,0,0,0,40,47,52,120,44,2,70,117,110,99,116,105,111,110,32,110,117,109,98,101,114,2,44,105,54,44,2,32,32,32,32,70,32,61,2,44,49,112,100,49,56,46,49,48,44,2,32,32,32,32,84,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,88,32,105,115,58,2,47,40,50,120,44,53,100,49,53,46,54,41,41,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,97,32,116,114,117,115,116,2,44,2,32,114,101,103,105,111,110,32,115,116,101,112,32,104,97,115,32,102,97,105,108,101,100,32,116,111,32,114,101,100,117,99,101,32,81,46,2,41,0,0,0,0,0,0,0,40,53,120,41,0,0,0,0,40,47,52,120,44,2,78,101,119,32,82,72,79,32,61,2,44,49,112,100,49,49,46,52,44,53,120,44,2,78,117,109,98,101,114,32,111,102,2,44,2,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,61,2,44,105,54,41,0,0,0,0,0,0,0,0,40,52,120,44,2,76,101,97,115,116,32,118,97,108,117,101,32,111,102,32,70,32,61,2,44,49,112,100,50,51,46,49,53,44,57,120,44,2,84,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,88,32,105,115,58,2,47,40,50,120,44,53,100,49,53,46,54,41,41,0,0,0,0,0,40,47,52,120,44,2,65,116,32,116,104,101,32,114,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,2,44,53,120,44,2,78,117,109,98,101,114,32,111,102,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,61,2,44,105,54,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,80,16,4,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,160,16,4,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,248,16,4,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,80,17,4,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,88,17,4,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,160,17,4,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,240,17,4,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,160,17,4,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,105,118,111,116,32,33,61,32,48,0,0,0,0,0,0,109,97,116,104,45,115,117,112,112,111,114,116,47,112,105,118,111,116,46,99,0,0,0,0,112,105,118,111,116,0,0,0,40,30,4,0,72,31,4,0,80,31,4,0,96,31,4,0,112,31,4,0,128,31,4,0,152,31,4,0,176,31,4,0,117,110,114,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,32,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,40,30,4,0,48,30,4,0,120,30,4,0,160,30,4,0,192,30,4,0,224,30,4,0,8,31,4,0,48,31,4,0,117,110,114,101,99,111,103,110,105,122,101,100,32,100,97,115,115,108,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,37,115,0,0,0,0,0,124,32,115,111,108,118,101,114,32,124,32,85,115,101,32,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,9,37,115,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,78,111,32,83,112,97,114,115,101,80,97,116,116,101,114,110,44,32,115,105,110,99,101,32,116,104,101,114,101,32,97,114,101,32,110,111,32,115,116,97,116,101,115,33,32,83,119,105,116,99,104,32,98,97,99,107,32,116,111,32,110,111,114,109,97,108,46,0,0,0,0,0,74,97,99,111,98,105,97,110,32,111,114,32,83,112,97,114,115,101,80,97,116,116,101,114,110,32,105,115,32,110,111,116,32,103,101,110,101,114,97,116,101,100,32,111,114,32,102,97,105,108,101,100,32,116,111,32,105,110,105,116,105,97,108,105,122,101,33,32,83,119,105,116,99,104,32,98,97,99,107,32,116,111,32,110,111,114,109,97,108,46,0,0,0,0,0,0,99,111,117,108,100,32,110,111,116,32,112,97,115,115,101,100,32,116,111,32,68,68,65,83,82,84,0,0,0,0,0,0,68,101,115,105,114,101,100,32,115,116,101,112,32,116,111,32,115,109,97,108,108,32,116,114,121,32,110,101,120,116,32,111,110,101,0,0,0,0,0,0,73,110,116,101,114,112,111,108,97,116,101,32,108,105,110,101,97,114,0,0,0,0,0,0,67,97,108,108,105,110,103,32,68,68,65,83,82,84,32,102,114,111,109,32,37,46,49,53,103,32,116,111,32,37,46,49,53,103,0,0,0,0,0,0,83,116,97,114,116,32,115,116,101,112,32,37,46,49,53,103,32,116,111,32,37,46,49,53,103,0,0,0,0,0,0,0,65,32,108,97,114,103,101,32,97,109,111,117,110,116,32,111,102,32,119,111,114,107,32,104,97,115,32,98,101,101,110,32,101,120,112,101,110,100,101,100,46,40,65,98,111,117,116,32,53,48,48,32,115,116,101,112,115,41,46,32,84,114,121,105,110,103,32,116,111,32,99,111,110,116,105,110,117,101,32,46,46,46,0,0,0,0,0,0,68,65,83,83,76,32,119,105,108,108,32,116,114,121,32,97,103,97,105,110,46,46,46,0,99,97,110,39,116,32,99,111,110,116,105,110,117,101,46,32,116,105,109,101,32,61,32,37,102,0,0,0,0,0,0,0,100,97,115,115,108,32,99,97,108,108,32,115,116,97,105,115,116,105,99,115,58,32,0,0,118,97,108,117,101,32,111,102,32,105,100,105,100,58,32,37,100,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,116,105,109,101,32,118,97,108,117,101,58,32,37,48,46,52,103,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,105,110,116,101,103,114,97,116,105,111,110,32,116,105,109,101,32,118,97,108,117,101,58,32,37,48,46,52,103,0,0,0,115,116,101,112,32,115,105,122,101,32,72,32,116,111,32,98,101,32,97,116,116,101,109,112,116,101,100,32,111,110,32,110,101,120,116,32,115,116,101,112,58,32,37,48,46,52,103,0,115,116,101,112,32,115,105,122,101,32,117,115,101,100,32,111,110,32,108,97,115,116,32,115,117,99,99,101,115,115,102,117,108,32,115,116,101,112,58,32,37,48,46,52,103,0,0,0,110,117,109,98,101,114,32,111,102,32,115,116,101,112,115,32,116,97,107,101,110,32,115,111,32,102,97,114,58,32,37,100,0,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,99,97,108,108,115,32,111,102,32,102,117,110,99,116,105,111,110,79,68,69,40,41,32,58,32,37,100,0,0,0,110,117,109,98,101,114,32,111,102,32,99,97,108,99,117,108,97,116,105,111,110,32,111,102,32,106,97,99,111,98,105,97,110,32,58,32,37,100,0,0,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,99,111,110,118,101,114,103,101,110,99,101,32,116,101,115,116,32,102,97,105,108,117,114,101,115,58,32,37,100,0,0,0,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,58,32,37,100,0,49,48,32,43,32,117,105,32,60,32,100,97,115,115,108,68,97,116,97,45,62,108,105,119,0,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,111,108,118,101,114,47,100,97,115,115,108,46,99,0,0,0,0,0,0,0,100,97,115,114,116,95,115,116,101,112,0,0,0,0,0,0,70,105,110,105,115,104,101,100,32,68,68,65,83,82,84,32,115,116,101,112,46,0,0,0,84,104,101,32,101,114,114,111,114,32,116,111,108,101,114,97,110,99,101,115,32,97,114,101,32,116,111,111,32,115,116,114,105,110,103,101,110,116,0,0,68,68,65,83,83,76,32,104,97,100,32,114,101,112,101,97,116,101,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,32,111,110,32,116,104,101,32,108,97,115,116,32,97,116,116,101,109,112,116,101,100,32,115,116,101,112,46,0,0,0,0,0,84,104,101,32,99,111,114,114,101,99,116,111,114,32,99,111,117,108,100,32,110,111,116,32,99,111,110,118,101,114,103,101,46,0,0,0,0,0,0,0,84,104,101,32,109,97,116,114,105,120,32,111,102,32,112,97,114,116,105,97,108,32,100,101,114,105,118,97,116,105,118,101,115,32,105,115,32,115,105,110,103,117,108,97,114,46,0,0,84,104,101,32,99,111,114,114,101,99,116,111,114,32,99,111,117,108,100,32,110,111,116,32,99,111,110,118,101,114,103,101,46,32,84,104,101,114,101,32,119,101,114,101,32,114,101,112,101,97,116,101,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,32,105,110,32,116,104,105,115,32,115,116,101,112,46,0,65,32,77,111,100,101,108,105,99,97,32,97,115,115,101,114,116,32,112,114,101,118,101,110,116,115,32,116,104,101,32,105,110,116,101,103,114,97,116,111,114,32,116,111,32,99,111,110,116,105,110,117,101,46,32,70,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,117,115,101,32,45,108,118,32,76,79,71,95,68,68,65,83,82,84,0,0,73,82,69,83,32,101,113,117,97,108,32,116,111,32,45,50,32,119,97,115,32,101,110,99,111,117,110,116,101,114,101,100,32,97,110,100,32,99,111,110,116,114,111,108,32,105,115,32,98,101,105,110,103,32,114,101,116,117,114,110,101,100,32,116,111,32,116,104,101,32,99,97,108,108,105,110,103,32,112,114,111,103,114,97,109,46,0,0,68,68,65,83,83,76,32,102,97,105,108,101,100,32,116,111,32,99,111,109,112,117,116,101,32,116,104,101,32,105,110,105,116,105,97,108,32,89,80,82,73,77,69,46,0,0,0,0,84,104,101,32,99,111,100,101,32,104,97,115,32,101,110,99,111,117,110,116,101,114,101,100,32,116,114,111,117,98,108,101,32,102,114,111,109,32,119,104,105,99,104,32,105,116,32,99,97,110,110,111,116,32,114,101,99,111,118,101,114,46,0,0,117,110,107,110,111,119,110,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,44,32,119,105,116,104,32,105,110,116,101,114,118,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,105,110,116,101,114,110,97,108,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,100,97,115,115,108,32,102,111,114,32,100,101,98,117,103,32,112,114,111,112,111,115,101,0,100,97,115,115,108,0,0,0,100,97,115,115,108,119,111,114,116,0,0,0,0,0,0,0,100,97,115,115,108,83,121,109,74,97,99,0,0,0,0,0,100,97,115,115,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,67,111,108,111,114,83,121,109,74,97,99,0,0,0,0,0,0,0,0,100,97,115,115,108,73,110,116,101,114,110,97,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,116,101,115,116,0,0,0,0,0,0,0,84,82,85,69,0,0,0,0,70,65,76,83,69,0,0,0,91,37,108,100,93,32,115,97,109,112,108,101,40,37,103,44,32,37,103,41,0,0,0,0,91,37,108,100,93,32,37,115,0,0,0,0,0,0,0,0,67,104,97,116,116,101,114,105,110,103,32,100,101,116,101,99,116,101,100,32,97,114,111,117,110,100,32,116,105,109,101,32,37,46,49,50,103,46,46,37,46,49,50,103,32,40,37,100,32,115,116,97,116,101,32,101,118,101,110,116,115,32,105,110,32,97,32,114,111,119,32,119,105,116,104,32,97,32,116,111,116,97,108,32,116,105,109,101,32,100,101,108,116,97,32,108,101,115,115,32,116,104,97,110,32,116,104,101,32,115,116,101,112,32,115,105,122,101,32,37,46,49,50,103,41,46,32,84,104,105,115,32,99,97,110,32,98,101,32,97,32,112,101,114,102,111,114,109,97,110,99,101,32,98,111,116,116,108,101,110,101,99,107,46,32,85,115,101,32,45,108,118,32,76,79,71,95,69,86,69,78,84,83,32,102,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,46,32,84,104,101,32,122,101,114,111,45,99,114,111,115,115,105,110,103,32,119,97,115,58,32,37,115,0,0,0,0,0,0,0,0,0,115,116,97,116,101,115,95,114,105,103,104,116,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,111,108,118,101,114,47,101,118,101,110,116,115,46,99,0,0,0,0,0,0,102,105,110,100,82,111,111,116,0,0,0,0,0,0,0,0,115,116,97,116,101,115,95,108,101,102,116,0,0,0,0,0,115,101,97,114,99,104,32,102,111,114,32,99,117,114,114,101,110,116,32,101,118,101,110,116,46,32,69,118,101,110,116,115,32,105,110,32,108,105,115,116,58,32,37,108,100,0,0,0,77,105,110,105,109,117,109,32,118,97,108,117,101,58,32,37,101,0,0,0,0,0,0,0,97,100,100,101,100,32,116,109,112,32,101,118,101,110,116,32,58,32,37,108,100,0,0,0,37,108,100,32,0,0,0,0,98,97,99,107,117,112,95,103,111,117,116,0,0,0,0,0,98,105,115,101,99,116,105,111,110,0,0,0,0,0,0,0,98,105,115,101,99,116,105,111,110,32,109,101,116,104,111,100,32,115,116,97,114,116,115,32,105,110,32,105,110,116,101,114,118,97,108,32,91,37,101,44,32,37,101,93,0,0,0,0,84,84,79,76,32,105,115,32,115,101,116,32,116,111,58,32,37,101,0,0,0,0,0,0,98,105,115,101,99,116,105,111,110,32,99,104,101,99,107,115,32,102,111,114,32,99,111,110,100,105,116,105,111,110,32,99,104,97,110,103,101,115,0,0,37,108,100,32,99,104,97,110,103,101,100,32,102,114,111,109,32,37,115,32,116,111,32,99,117,114,114,101,110,116,32,37,115,0,0,0,0,0,0,0,115,97,118,101,32,97,108,108,32,122,101,114,111,99,114,111,115,115,105,110,103,115,32,97,102,116,101,114,32,97,110,32,101,118,101,110,116,0,0,0,69,82,82,79,82,58,32,84,111,111,32,109,97,110,121,32,101,118,101,110,116,32,105,116,101,114,97,116,105,111,110,115,46,32,83,121,115,116,101,109,32,105,115,32,105,110,99,111,110,115,105,115,116,101,110,116,46,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,46,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,112,97,114,97,109,101,116,101,114,32,118,97,108,117,101,115,0,0,0,0,0,0,0,0,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,103,0,0,0,0,0,0,0,0,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,37,115,40,115,116,97,114,116,61,37,108,100,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,108,100,0,0,0,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,66,111,111,108,101,97,110,32,37,115,40,115,116,97,114,116,61,37,115,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,115,0,0,0,0,0,115,116,114,105,110,103,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,83,116,114,105,110,103,32,37,115,40,115,116,97,114,116,61,34,37,115,34,41,32,61,32,34,37,115,34,0,0,0,0,115,116,97,116,117,115,32,111,102,32,114,101,108,97,116,105,111,110,115,0,0,0,0,0,91,37,108,100,93,32,37,115,32,61,32,37,99,32,124,32,112,114,101,40,37,115,41,32,61,32,37,99,0,0,0,0,89,111,117,114,32,109,101,109,111,114,121,32,105,115,32,110,111,116,32,115,116,114,111,110,103,32,101,110,111,117,103,104,32,102,111,114,32,111,117,114,32,82,105,110,103,98,117,102,102,101,114,33,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,101,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,101,120,116,101,114,110,97,108,32,111,98,106,101,99,116,115,0,0,0,0,0,0,0,187,189,215,217,223,124,219,61,83,101,116,32,116,111,108,101,114,97,110,99,101,32,102,111,114,32,122,101,114,111,45,99,114,111,115,115,105,110,103,32,104,121,115,116,101,114,101,115,105,115,32,116,111,58,32,37,101,0,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,109,105,120,101,100,32,115,111,108,118,101,114,0,0,0,0,0,0,0,109,105,120,101,100,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,0,91,37,100,93,32,37,115,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,0,97,108,108,111,99,97,116,101,77,105,120,101,100,83,101,97,114,99,104,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,0,0,0,0,110,111,32,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,0,0,0,108,105,110,101,97,114,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,91,37,100,93,32,37,115,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,100,97,116,97,32,102,111,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,108,97,112,97,99,107,46,0,0,0,0,0,0,0,65,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,0,0,0,0,0,0,0,37,115,37,50,48,46,49,50,103,32,0,0,0,0,0,0,37,115,0,0,0,0,0,0,98,32,118,101,99,116,111,114,32,91,37,100,93,0,0,0,69,114,114,111,114,32,115,111,108,118,105,110,103,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,111,102,32,101,113,117,97,116,105,111,110,115,32,40,110,111,46,32,37,100,41,32,97,116,32,116,105,109,101,32,37,102,46,32,65,114,103,117,109,101,110,116,32,37,100,32,105,108,108,101,103,97,108,46,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,115,111,108,118,101,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,111,102,32,101,113,117,97,116,105,111,110,115,32,40,110,111,46,32,37,100,41,32,97,116,32,116,105,109,101,32,37,102,44,32,115,121,115,116,101,109,32,105,115,32,115,105,110,103,117,108,97,114,32,102,111,114,32,85,91,37,100,44,32,37,100,93,46,0,0,0,0,0,0,0,37,115,37,49,48,103,32,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,100,97,116,97,32,102,111,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,76,105,115,46,0,0,45,105,32,102,103,109,114,101,115,32,0,0,0,0,0,0,78,76,83,95,85,78,75,78,79,87,78,0,0,0,0,0,104,121,98,114,105,100,0,0,107,105,110,115,111,108,0,0,110,101,119,116,111,110,0,0,78,76,83,95,77,65,88,0,152,39,4,0,168,39,4,0,176,39,4,0,184,39,4,0,192,39,4,0,0,0,0,0,117,110,107,110,111,119,110,0,100,101,102,97,117,108,116,32,109,101,116,104,111,100,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,78,101,119,116,111,110,32,82,97,112,104,115,111,110,0,0,224,39,4,0,232,39,4,0,248,39,4,0,8,40,4,0,192,39,4,0,0,0,0,0,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,105,110,118,97,108,105,100,0,0,0,0,106,97,99,111,98,105,97,110,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,105,110,118,97,108,105,100,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,110,111,110,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,0,0,0,0,0,112,114,111,112,101,114,32,115,116,97,114,116,45,118,97,108,117,101,115,32,102,111,114,32,115,111,109,101,32,111,102,32,116,104,101,32,102,111,108,108,111,119,105,110,103,32,105,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,115,32,109,105,103,104,116,32,104,101,108,112,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,63,44,32,110,111,109,105,110,97,108,61,63,41,0,0,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,0,0,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,115,116,97,114,116,32,115,111,108,118,105,110,103,32,110,111,110,45,108,105,110,101,97,114,32,115,121,115,116,101,109,32,62,62,37,115,60,60,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,102,0,0,0,0,0,0,115,99,97,108,105,110,103,32,61,32,37,102,10,111,108,100,32,61,32,37,102,10,101,120,116,114,97,112,111,108,97,116,101,100,32,61,32,37,102,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,32,120,32,118,101,99,116,111,114,0,0,0,0,0,0,0,0,73,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,32,118,97,108,117,101,115,0,0,0,0,0,0,0,73,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,32,118,97,108,117,101,115,32,40,115,99,97,108,101,100,41,0,0,0,0,0,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,32,102,111,114,32,114,101,115,105,100,117,97,108,32,118,101,99,116,111,114,0,0,0,0,0,115,99,97,108,101,100,32,114,101,115,105,100,117,97,108,32,91,37,100,93,32,58,32,37,46,50,48,101,0,0,0,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,91,37,100,93,32,58,32,37,46,50,48,101,0,0,0,0,0,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,37,115,37,49,48,103,32,0,37,115,0,0,0,0,0,0,115,121,115,116,101,109,32,115,111,108,118,101,100,0,0,0,37,100,32,114,101,116,114,105,101,115,10,37,100,32,114,101,115,116,97,114,116,115,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,100,101,99,114,101,97,115,105,110,103,32,105,110,105,116,105,97,108,32,115,116,101,112,32,98,111,117,110,100,32,116,111,32,37,102,46,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,115,111,108,117,116,105,111,110,32,112,111,105,110,116,32,98,121,32,49,37,37,46,0,0,0,0,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,111,108,100,32,118,97,108,117,101,115,32,97,115,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,46,0,0,0,0,0,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,119,105,116,104,111,117,116,32,115,99,97,108,105,110,103,32,97,116,32,97,108,108,46,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,116,111,32,115,111,108,118,101,32,97,32,100,105,115,99,111,110,116,105,110,117,111,117,115,32,115,121,115,116,101,109,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,117,115,101,32,111,108,100,32,118,97,108,117,101,115,32,105,110,115,116,101,97,100,32,101,120,116,114,97,112,111,108,97,116,101,100,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,105,110,105,116,105,97,108,32,112,111,105,110,116,32,98,121,32,97,100,100,105,110,103,32,49,37,37,46,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,105,110,105,116,105,97,108,32,112,111,105,110,116,32,98,121,32,45,49,37,37,46,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,97,115,32,105,110,105,116,105,97,108,32,112,111,105,110,116,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,119,105,116,104,32,111,119,110,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,46,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,100,105,115,97,98,108,101,32,115,111,108,118,101,114,32,105,110,116,101,114,110,97,108,32,115,99,97,108,105,110,103,46,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,114,101,100,117,99,101,32,116,104,101,32,116,111,108,101,114,97,110,99,101,32,115,108,105,103,104,116,108,121,32,116,111,32,37,101,46,0,0,35,35,35,32,78,111,32,83,111,108,117,116,105,111,110,33,32,35,35,35,10,32,97,102,116,101,114,32,37,100,32,114,101,115,116,97,114,116,115,0,110,108,115,32,115,116,97,116,117,115,0,0,0,0,0,0,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,46,50,48,101,32,91,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,61,32,37,49,54,101,93,0,0,0,102,117,110,99,116,105,111,110,115,0,0,0,0,0,0,0,114,101,115,91,37,100,93,32,61,32,37,46,50,48,101,32,91,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,61,32,37,49,54,101,93,0,115,116,97,116,105,115,116,105,99,115,0,0,0,0,0,0,110,102,117,110,99,32,61,32,37,100,10,101,114,114,111,114,32,61,32,37,46,50,48,101,10,101,114,114,111,114,95,115,99,97,108,101,100,32,61,32,37,46,50,48,101,0,0,0,91,37,50,100,93,32,37,50,48,46,49,50,103,0,0,0,45,45,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,99,97,108,108,32,37,100,32,45,45,0,120,32,118,101,99,116,111,114,0,0,0,0,0,0,0,0,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,0,45,45,32,101,110,100,32,111,102,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,99,97,108,108,32,37,100,32,45,45,0,0,45,45,32,98,101,103,105,110,32,99,97,108,99,117,108,97,116,105,110,103,32,106,97,99,111,98,105,97,110,32,45,45,0,0,0,0,0,0,0,0,45,45,32,101,110,100,32,99,97,108,99,117,108,97,116,105,110,103,32,106,97,99,111,98,105,97,110,32,45,45,0,0,37,115,37,50,48,46,49,50,103,32,0,0,0,0,0,0,87,101,108,108,44,32,116,104,105,115,32,105,115,32,101,109,98,97,114,114,97,115,105,110,103,46,32,84,104,101,32,110,111,110,45,108,105,110,101,97,114,32,115,111,108,118,101,114,32,115,104,111,117,108,100,32,110,101,118,101,114,32,99,97,108,108,32,116,104,105,115,32,99,97,115,101,46,37,100,0,97,108,108,111,99,97,116,105,111,110,78,101,119,116,111,110,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,97,108,108,111,99,97,116,105,111,110,78,101,119,116,111,110,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,83,116,97,114,116,32,115,111,108,118,105,110,103,32,78,111,110,45,76,105,110,101,97,114,32,83,121,115,116,101,109,32,37,115,32,97,116,32,116,105,109,101,32,37,103,32,119,105,116,104,32,78,101,119,116,111,110,32,83,111,108,118,101,114,0,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,46,49,53,101,0,0,0,115,99,97,108,105,110,103,32,61,32,37,102,32,43,43,43,32,111,108,100,32,61,32,37,101,32,43,43,43,32,101,120,116,114,97,112,111,108,97,116,101,100,32,61,32,37,101,0,42,42,42,32,83,121,115,116,101,109,32,115,111,108,118,101,100,32,42,42,42,10,37,100,32,114,101,115,116,97,114,116,115,0,0,0,0,0,0,0,110,102,117,110,99,32,61,32,37,100,32,43,43,43,32,101,114,114,111,114,32,61,32,37,46,49,53,101,32,43,43,43,32,101,114,114,111,114,95,115,99,97,108,101,100,32,61,32,37,46,49,53,101,0,0,0,120,91,37,100,93,32,61,32,37,46,49,53,101,10,9,114,101,115,105,100,117,97,108,32,61,32,37,101,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,111,108,100,32,118,97,108,117,101,115,46,0,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,115,111,108,117,116,105,111,110,32,112,111,105,110,116,32,98,121,32,49,37,37,46,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,110,111,109,105,110,97,108,32,118,97,108,117,101,115,32,97,115,32,105,110,105,116,105,97,108,32,115,111,108,117,116,105,111,110,46,0,0,0,0,0,0,0,35,35,35,32,78,111,32,83,111,108,117,116,105,111,110,33,32,35,35,35,10,32,97,102,116,101,114,32,37,100,32,114,101,115,116,97,114,116,115,0,35,35,35,35,35,35,35,35,35,32,83,116,97,114,116,32,78,101,119,116,111,110,32,109,97,120,102,101,118,58,32,37,100,32,35,35,35,35,35,35,35,35,35,0,0,0,0,0,120,91,37,100,93,58,32,37,101,32,0,0,0,0,0,0,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,37,115,37,49,48,103,32,0,37,115,0,0,0,0,0,0,74,97,99,111,98,105,97,110,32,77,97,116,114,105,120,32,115,105,110,103,117,108,97,114,33,0,0,0,0,0,0,0,105,108,108,101,103,97,108,32,32,105,110,112,117,116,32,105,110,32,97,114,103,117,109,101,110,116,32,37,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,240,63,73,110,105,116,105,97,108,105,122,105,110,103,32,68,65,83,83,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,116,111], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+265172);
/* memory initializer */ allocate([114,105,110,103,32,114,101,115,117,108,116,115,32,97,110,100,32,101,120,105,116,105,110,103,46,10,85,115,101,32,45,108,118,61,76,79,71,95,73,78,73,84,32,45,119,32,102,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,46,0,115,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,98,121,32,97,110,32,97,115,115,101,114,116,105,111,110,32,97,116,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,87,114,111,116,101,32,112,97,114,97,109,101,116,101,114,115,32,116,111,32,116,104,101,32,102,105,108,101,32,97,102,116,101,114,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,40,102,111,114,32,111,117,116,112,117,116,32,102,111,114,109,97,116,115,32,116,104,97,116,32,115,117,112,112,111,114,116,32,116,104,105,115,41,0,0,0,0,0,0,0,0,116,101,114,109,105,110,97,108,32,101,118,101,110,116,32,97,116,32,115,116,111,112,32,116,105,109,101,32,37,103,0,0,70,105,110,105,115,104,101,100,0,0,0,0,0,0,0,0,35,35,35,32,83,84,65,84,73,83,84,73,67,83,32,35,35,35,0,0,0,0,0,0,116,105,109,101,114,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,112,114,101,45,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,115,116,101,112,115,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,99,114,101,97,116,105,110,103,32,111,117,116,112,117,116,45,102,105,108,101,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,101,118,101,110,116,45,104,97,110,100,108,105,110,103,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,111,118,101,114,104,101,97,100,0,0,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,115,105,109,117,108,97,116,105,111,110,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,116,111,116,97,108,0,0,0,101,118,101,110,116,115,0,0,37,53,108,100,32,115,116,97,116,101,32,101,118,101,110,116,115,0,0,0,0,0,0,0,37,53,108,100,32,116,105,109,101,32,101,118,101,110,116,115,0,0,0,0,0,0,0,0,115,111,108,118,101,114,58,32,68,65,83,83,76,0,0,0,37,53,100,32,115,116,101,112,115,32,116,97,107,101,110,0,37,53,100,32,99,97,108,108,115,32,111,102,32,102,117,110,99,116,105,111,110,79,68,69,0,0,0,0,0,0,0,0,37,53,100,32,101,118,97,108,117,97,116,105,111,110,115,32,111,102,32,106,97,99,111,98,105,97,110,0,0,0,0,0,37,53,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,0,37,53,100,32,99,111,110,118,101,114,103,101,110,99,101,32,116,101,115,116,32,102,97,105,108,117,114,101,115,0,0,0,115,111,108,118,101,114,0,0,115,111,114,114,121,32,45,32,110,111,32,115,111,108,118,101,114,32,115,116,97,116,105,115,116,105,99,115,32,97,118,97,105,108,97,98,108,101,46,32,91,110,111,116,32,121,101,116,32,105,109,112,108,101,109,101,110,116,101,100,93,0,0,0,35,35,35,32,69,78,68,32,83,84,65,84,73,83,84,73,67,83,32,35,35,35,0,0,83,117,110,100,105,97,108,47,107,105,110,115,111,108,32,105,115,32,110,101,101,100,101,100,32,98,117,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,46,32,80,108,101,97,115,101,32,99,104,111,111,115,101,32,111,116,104,101,114,32,115,111,108,118,101,114,46,0,73,112,111,112,116,32,105,115,32,110,101,101,100,101,100,32,98,117,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,46,0,0,0,0,0,0,105,110,108,105,110,101,45,101,117,108,101,114,0,0,0,0,82,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,105,110,108,105,110,101,45,101,117,108,101,114,44,32,98,117,116,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,32,119,97,115,32,110,111,116,32,99,111,109,112,105,108,101,100,32,119,105,116,104,32,115,117,112,112,111,114,116,32,102,111,114,32,105,116,46,32,67,111,109,112,105,108,101,32,119,105,116,104,32,45,68,95,79,77,67,95,73,78,76,73,78,69,95,69,85,76,69,82,46,0,0,0,0,0,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,0,82,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,44,32,98,117,116,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,32,119,97,115,32,110,111,116,32,99,111,109,112,105,108,101,100,32,119,105,116,104,32,115,117,112,112,111,114,116,32,102,111,114,32,105,116,46,32,67,111,109,112,105,108,101,32,119,105,116,104,32,45,68,95,79,77,67,95,73,78,76,73,78,69,95,82,75,46,0,0,0,83,116,97,114,116,32,110,117,109,101,114,105,99,97,108,32,115,111,108,118,101,114,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,0,0,44,0,0,0,0,0,0,0,116,105,109,101,61,37,46,50,48,103,0,0,0,0,0,0,44,37,115,61,37,46,50,48,103,0,0,0,0,0,0,0,44,37,115,61,37,108,105,0,44,37,115,61,37,105,0,0,44,37,115,61,34,37,115,34,0,0,0,0,0,0,0,0,99,97,110,32,110,111,116,32,105,110,105,116,105,97,108,122,101,32,74,97,99,111,98,105,97,110,115,32,102,111,114,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,106,97,99,111,98,105,97,110,32,37,100,120,37,100,32,91,105,100,58,32,37,108,100,93,0,0,0,0,0,0,0,0,37,115,37,46,53,101,32,0,37,115,0,0,0,0,0,0,69,114,114,111,114,44,32,115,105,110,103,117,108,97,114,32,74,97,99,111,98,105,97,110,32,102,111,114,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,32,97,116,32,116,105,109,101,32,37,102,10,85,115,101,32,45,108,118,32,76,79,71,95,68,83,83,95,74,65,67,32,116,111,32,103,101,116,32,116,104,101,32,74,97,99,111,98,105,97,110,0,115,101,108,101,99,116,32,110,101,119,32,115,116,97,116,101,115,32,97,116,32,116,105,109,101,32,37,102,0,0,0,0,115,101,108,101,99,116,32,37,115,0,0,0,0,0,0,0,101,120,116,101,114,110,97,108,73,110,112,117,116,46,99,115,118,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,37,108,102,0,0,0,0,0,10,69,120,116,101,114,110,97,108,32,73,110,112,117,116,0,10,73,110,112,117,116,58,32,116,61,37,102,32,32,32,9,0,0,0,0,0,0,0,0,117,37,100,40,116,41,61,32,37,102,32,9,0,0,0,0,10,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,0,0,0,0,0,0,0,101,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,121,115,116,101,109,32,111,102,32,105,110,105,116,105,97,108,32,101,113,117,97,116,105,111,110,115,32,97,114,101,32,110,111,116,32,99,111,110,115,105,115,116,101,110,116,10,40,108,101,97,115,116,32,115,113,117,97,114,101,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,32,105,115,32,37,103,41,0,0,0,0,0,114,101,115,105,100,117,97,108,91,37,108,100,93,32,61,32,37,103,0,0,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,115,116,97,116,117,115,0,0,0,108,101,97,115,116,32,115,113,117,97,114,101,32,118,97,108,117,101,58,32,37,103,32,91,115,99,97,108,101,100,58,32,37,103,93,0,0,0,0,0,108,101,97,115,116,32,115,113,117,97,114,101,32,118,97,108,117,101,58,32,37,103,0,0,117,110,102,105,120,101,100,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,112,97,114,97,109,101,116,101,114,41,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,0,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,112,97,114,97,109,101,116,101,114,41,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,100,105,115,99,114,101,116,101,41,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,100,105,115,99,114,101,116,101,41,0,0,0,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,0,35,35,35,32,83,79,76,85,84,73,79,78,32,79,70,32,84,72,69,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,115,116,97,116,101,115,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,32,40,112,114,101,58,32,37,103,41,0,0,0,0,0,0,100,101,114,105,118,97,116,105,118,101,115,32,118,97,114,105,97,98,108,101,115,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,32,61,32,37,103,32,40,112,114,101,58,32,37,103,41,0,0,0,0,111,116,104,101,114,32,114,101,97,108,32,118,97,114,105,97,98,108,101,115,0,0,0,0,105,110,116,101,103,101,114,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,73,110,116,101,103,101,114,32,37,115,40,115,116,97,114,116,61,37,108,100,41,32,61,32,37,108,100,32,40,112,114,101,58,32,37,108,100,41,0,0,0,0,98,111,111,108,101,97,110,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,66,111,111,108,101,97,110,32,37,115,40,115,116,97,114,116,61,37,115,41,32,61,32,37,115,32,40,112,114,101,58,32,37,115,41,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,115,116,114,105,110,103,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,91,37,108,100,93,32,83,116,114,105,110,103,32,37,115,40,115,116,97,114,116,61,34,37,115,34,41,32,61,32,34,37,115,34,32,40,112,114,101,58,32,34,37,115,34,41,0,0,35,35,35,32,83,84,65,82,84,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,0,0,200,66,4,0,144,68,4,0,152,68,4,0,160,68,4,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,105,105,109,32,37,115,0,0,0,0,0,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,124,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,200,66,4,0,208,67,4,0,32,68,4,0,80,68,4,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,200,66,4,0,144,67,4,0,152,67,4,0,160,67,4,0,176,67,4,0,184,67,4,0,200,67,4,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,105,111,109,32,37,115,0,0,0,0,0,200,66,4,0,208,66,4,0,232,66,4,0,248,66,4,0,64,67,4,0,80,67,4,0,112,67,4,0,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,109,101,116,104,111,100,58,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,32,109,101,116,104,111,100,58,32,32,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,111,112,116,105,111,110,32,45,105,105,109,0,35,35,35,32,69,78,68,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,37,115,95,104,111,109,111,116,111,112,121,46,99,115,118,0,119,116,0,0,0,0,0,0,37,115,44,0,0,0,0,0,108,97,109,98,100,97,0,0,104,111,109,111,116,111,112,121,32,112,114,111,99,101,115,115,0,0,0,0,0,0,0,0,108,97,109,98,100,97,32,61,32,37,103,32,100,111,110,101,0,0,0,0,0,0,0,0,37,46,49,54,103,44,0,0,67,97,110,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,117,110,105,113,117,101,32,116,104,101,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,46,32,85,115,101,32,45,108,118,32,76,79,71,95,68,83,83,32,116,111,32,115,101,101,32,116,104,101,32,115,119,105,116,99,104,105,110,103,32,115,116,97,116,101,32,115,101,116,46,0,0,0,110,111,32,118,97,114,105,97,98,108,101,115,32,116,111,32,105,110,105,116,105,97,108,105,122,101,0,0,0,0,0,0,110,111,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,32,40,110,101,105,116,104,101,114,32,105,110,105,116,105,97,108,32,101,113,117,97,116,105,111,110,115,32,110,111,114,32,105,110,105,116,105,97,108,32,97,108,103,111,114,105,116,104,109,115,41,0,117,110,100,101,114,45,100,101,116,101,114,109,105,110,101,100,0,0,0,0,0,0,0,0,115,101,116,116,105,110,103,32,102,105,120,101,100,61,116,114,117,101,32,102,111,114,58,0,37,115,40,102,105,120,101,100,61,116,114,117,101,41,32,61,32,37,103,0,0,0,0,0,110,111,32,105,110,105,116,105,97,108,32,118,97,108,117,101,115,32,116,111,32,99,97,108,99,117,108,97,116,101,0,0,111,118,101,114,45,100,101,116,101,114,109,105,110,101,100,0,115,116,97,114,116,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,0,0,115,107,105,112,32,119,47,111,32,115,99,97,108,105,110,103,0,0,0,0,0,0,0,0,35,35,35,32,70,73,78,65,76,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,82,69,83,85,76,84,83,32,35,35,35,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,45,110,114,46,32,37,108,100,0,0,117,110,115,117,112,112,111,114,116,101,100,32,111,112,116,105,111,110,32,45,105,111,109,0,117,112,100,97,116,105,110,103,32,98,101,115,116,90,0,0,110,111,116,32,117,112,100,97,116,105,110,103,32,98,101,115,116,90,0,0,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,45,99,97,108,108,115,58,32,37,108,100,0,117,110,107,110,111,119,110,0,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,0,0,0,0,0,0,66,114,101,110,116,39,115,32,109,101,116,104,111,100,0,0,69,120,116,101,110,100,101,100,32,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,32,40,115,101,101,32,45,105,108,115,32,102,111,114,32,103,108,111,98,97,108,32,104,111,109,111,116,111,112,121,41,32,45,32,100,101,102,97,117,108,116,0,0,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,73,110,116,101,114,105,111,114,32,80,111,105,110,116,32,79,80,84,105,109,105,122,101,114,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,0,110,101,119,117,111,97,0,0,110,101,108,100,101,114,95,109,101,97,100,95,101,120,0,0,107,105,110,115,111,108,0,0,107,105,110,115,111,108,95,115,99,97,108,101,100,0,0,0,105,112,111,112,116,0,0,0,115,101,116,115,32,97,108,108,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,105,114,32,115,116,97,114,116,32,118,97,108,117,101,115,32,97,110,100,32,115,107,105,112,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,99,101,115,115,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,110,117,109,101,114,105,99,97,108,108,121,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,115,121,109,98,111,108,105,99,97,108,108,121,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,110,117,109,101,114,105,99,0,115,121,109,98,111,108,105,99,0,0,0,0,0,0,0,0,105,109,112,111,114,116,32,115,116,97,114,116,32,118,97,108,117,101,115,10,102,105,108,101,58,32,37,115,10,116,105,109,101,58,32,37,103,0,0,0,117,110,97,98,108,101,32,116,111,32,114,101,97,100,32,105,110,112,117,116,45,102,105,108,101,32,60,37,115,62,32,91,37,115,93,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,118,97,114,105,97,98,108,101,115,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,103,41,0,0,36,90,69,82,79,46,0,0,36,112,68,69,82,46,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,114,101,97,108,32,118,97,114,105,97,98,108,101,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,114,101,97,108,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,100,105,115,99,114,101,116,101,0,0,0,0,105,109,112,111,114,116,32,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,108,100,41,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,105,109,112,111,114,116,32,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,115,41,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,100,101,114,40,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,105,110,105,116,105,97,108,32,112,114,111,98,108,101,109,58,0,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,117,110,102,105,120,101,100,32,118,97,114,105,97,98,108,101,115,58,32,32,37,108,100,32,40,37,108,100,32,115,116,97,116,101,115,32,43,32,37,108,100,32,112,97,114,97,109,101,116,101,114,115,32,43,32,37,108,100,32,100,105,115,99,114,101,116,101,32,114,101,97,108,115,41,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,91,37,108,100,93,32,100,105,115,99,114,101,116,101,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,58,32,32,37,108,100,32,40,37,108,100,32,101,113,117,97,116,105,111,110,115,32,43,32,37,108,100,32,97,108,103,111,114,105,116,104,109,115,41,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,115,116,97,114,116,32,118,97,108,117,101,32,114,101,115,105,100,117,97,108,115,58,32,37,108,100,0,0,0,0,91,37,108,100,93,32,114,101,115,105,100,117,97,108,32,105,115,32,105,110,101,102,102,101,99,116,105,118,101,32,40,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,32,105,115,32,115,101,116,32,116,111,32,49,46,48,41,0,0,0,0,0,0,0,110,111,32,105,112,111,112,116,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,0,0,110,111,32,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,95,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,124,32,82,101,115,117,108,116,32,111,102,32,108,101,97,115,116,83,113,117,97,114,101,32,109,101,116,104,111,100,32,61,32,37,103,46,32,84,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,105,116,115,32,116,111,32,116,104,101,32,115,121,115,116,101,109,0,0,0,0,0,0,0,0,108,101,97,115,116,83,113,117,97,114,101,61,37,103,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,111,108,118,101,114,32,105,116,101,114,97,116,101,100,32,37,100,32,116,105,109,101,115,32,119,105,116,104,111,117,116,32,102,105,110,100,105,110,103,32,97,32,115,111,108,117,116,105,111,110,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,73,110,99,111,110,115,105,115,116,101,110,116,32,105,110,105,116,105,97,108,32,99,111,110,100,105,116,105,111,110,115,46,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,78,117,109,98,101,114,32,111,102,32,105,110,105,116,105,97,108,32,118,97,108,117,101,115,32,116,111,32,99,97,108,99,117,108,97,116,101,32,60,32,49,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,73,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,78,76,79,79,80,32,60,32,49,46,0,0,0,0,0,78,101,108,100,101,114,77,101,97,100,79,112,116,105,109,105,122,97,116,105,111,110,0,0,105,116,101,114,97,116,105,111,110,115,58,32,37,108,100,0,116,114,121,32,45,105,108,115,32,116,111,32,97,99,116,105,118,97,116,101,32,115,116,97,114,116,32,118,97,108,117,101,32,104,111,109,111,116,111,112,121,0,0,0,0,0,0,0,37,115,95,105,110,105,116,80,97,116,104,46,99,115,118,0,119,116,0,0,0,0,0,0,37,115,44,0,0,0,0,0,105,116,101,114,97,116,105,111,110,0,0,0,0,0,0,0,108,97,109,98,100,97,0,0,37,108,100,44,0,0,0,0,37,46,49,54,103,44,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,108,97,109,98,100,97,32,105,115,32,37,45,51,103,32,105,110,32,115,116,101,112,61,37,54,100,32,97,116,32,102,61,37,103,32,91,37,103,93,0,105,110,99,114,101,97,115,105,110,103,32,108,97,109,98,100,97,32,116,111,32,37,45,51,103,32,105,110,32,115,116,101,112,32,37,54,100,32,97,116,32,102,61,37,103,0,0,0,102,120,114,32,61,32,37,103,0,0,0,0,0,0,0,0,102,120,107,32,61,32,37,103,0,0,0,0,0,0,0,0,117,110,100,101,102,105,110,101,100,32,101,114,114,111,114,32,105,110,32,78,101,108,100,101,114,77,101,97,100,79,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,37,46,49,54,103,44,0,0,37,105,44,0,0,0,0,0,34,37,115,34,44,0,0,0,119,0,0,0,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,99,114,101,97,116,101,32,111,117,116,112,117,116,32,102,105,108,101,58,32,91,37,115,93,32,98,101,99,97,117,115,101,32,111,102,32,37,115,0,0,116,105,109,101,0,0,0,0,36,99,112,117,84,105,109,101,0,0,0,0,0,0,0,0,100,97,116,97,95,49,0,0,65,49,32,98,116,46,32,105,114,49,32,110,97,32,32,84,106,32,32,114,101,32,32,97,99,32,32,110,116,32,32,115,111,32,32,32,114,32,32,32,121,32,32,32,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,0,65,99,108,97,115,115,0,0,110,97,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,100,97,116,97,73,110,102,111,0,0,0,0,0,0,0,0,100,97,116,97,95,50,0,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,109,97,116,32,102,105,108,101,32,37,115,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,102,105,108,101,32,37,115,0,0,0,0,0,67,97,110,110,111,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,0,0,67,97,110,110,111,116,32,119,114,105,116,101,32,116,111,32,102,105,108,101,32,37,115,0,67,97,110,110,111,116,32,97,108,108,111,99,32,109,101,109,111,114,121,0,0,0,0,0,77,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,119,0,0,0,0,0,0,0,97,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,114,43,0,0,0,0,0,0,119,43,0,0,0,0,0,0,97,43,0,0,0,0,0,0,119,98,0,0,0,0,0,0,97,98,0,0,0,0,0,0,114,98,0,0,0,0,0,0,114,43,98,0,0,0,0,0,119,43,98,0,0,0,0,0,97,43,98,0,0,0,0,0,100,101,114,40,0,0,0,0,104,0,0,0,0,0,0,0,120,78,4,0,8,0,0,0,9,0,0,0,152,255,255,255,152,255,255,255,120,78,4,0,10,0,0,0,11,0,0,0,28,78,4,0,148,78,4,0,168,78,4,0,48,78,4,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,111,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,136,8,5,0,72,78,4,0,16,196,4,0,0,0,0,0,104,0,0,0,0,0,0,0,16,196,4,0,12,0,0,0,13,0,0,0,152,255,255,255,152,255,255,255,16,196,4,0,14,0,0,0,15,0,0,0,0,0,0,0,32,79,4,0,16,0,0,0,17,0,0,0,3,0,0,0,8,0,0,0,2,0,0,0,4,0,0,0,31,0,0,0,32,0,0,0,9,0,0,0,33,0,0,0,34,0,0,0,24,0,0,0,10,0,0,0,25,0,0,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,102,105,108,101,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,136,8,5,0,240,78,4,0,8,195,4,0,0,0,0,0,0,0,0,0,168,79,4,0,176,79,4,0,160,79,4,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,128,79,4,0,144,79,4,0,160,79,4,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,36,99,112,117,84,105,109,101,0,0,0,0,0,0,0,0,99,112,117,32,116,105,109,101,32,91,115,93,0,0,0,0,0,0,0,0,0,0,0,0,116,105,109,101,0,0,0,0,83,105,109,117,108,97,116,105,111,110,32,116,105,109,101,32,91,115,93,0,0,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,111,102,32,115,105,122,101,32,37,108,100,0,0,0,0,0,65,117,116,111,109,97,116,105,99,32,111,117,116,112,117,116,32,115,116,101,112,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,105,110,32,79,112,101,110,77,111,100,101,108,105,99,97,32,121,101,116,46,32,83,101,116,32,110,117,109,112,111,105,110,116,115,32,62,61,32,48,46,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,111,102,32,115,105,122,101,32,37,108,100,32,102,97,105,108,101,100,0,0,0,0,0,0,119,0,0,0,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,99,114,101,97,116,101,32,111,117,116,112,117,116,32,102,105,108,101,58,32,91,37,115,93,32,98,101,99,97,117,115,101,32,111,102,32,37,115,0,0,35,80,116,111,108,101,109,121,32,80,108,111,116,32,102,105,108,101,44,32,103,101,110,101,114,97,116,101,100,32,98,121,32,79,112,101,110,77,111,100,101,108,105,99,97,10,0,0,35,78,117,109,98,101,114,111,102,86,97,114,105,97,98,108,101,115,61,37,100,10,0,0,35,73,110,116,101,114,118,97,108,83,105,122,101,61,37,108,100,10,0,0,0,0,0,0,84,105,116,108,101,84,101,120,116,58,32,79,112,101,110,77,111,100,101,108,105,99,97,32,115,105,109,117,108,97,116,105,111,110,32,112,108,111,116,10,0,0,0,0,0,0,0,0,88,76,97,98,101,108,58,32,116,10,10,0,0,0,0,0,68,97,116,97,83,101,116,58,32,116,105,109,101,10,0,0,68,97,116,97,83,101,116,58,32,36,99,112,117,84,105,109,101,10,0,0,0,0,0,0,68,97,116,97,83,101,116,58,32,37,115,10,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,119,114,105,116,101,32,116,111,32,111,117,116,112,117,116,32,102,105,108,101,32,37,115,10,0,0,0,0,0,0,0,0,37,46,49,54,103,44,32,37,46,49,54,103,10,0,0,0,114,101,99,111,110,58,119,97,108,108,58,118,48,49,0,0,0,0,0,0,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,109,97,116,32,102,105,108,101,32,37,115,0,112,97,114,97,109,115,0,0,99,111,110,116,105,110,117,111,117,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,109,101,116,97,0,0,0,116,97,98,115,0,0,0,0,111,98,106,115,0,0,0,0,116,109,101,116,97,0,0,0,115,105,103,115,0,0,0,0,116,105,109,101,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,118,109,101,116,97,0,0,0,84,105,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,97,108,115,0,0,0,0,0,115,0,0,0,0,0,0,0,116,0,0,0,0,0,0,0,105,110,118,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,110,97,109,101,0,0,0,0,118,97,108,117,101,82,101,102,101,114,101,110,99,101,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,102,105,108,101,78,97,109,101,0,0,0,0,0,0,0,0,115,116,97,114,116,76,105,110,101,0,0,0,0,0,0,0,115,116,97,114,116,67,111,108,117,109,110,0,0,0,0,0,101,110,100,76,105,110,101,0,101,110,100,67,111,108,117,109,110,0,0,0,0,0,0,0,102,105,108,101,87,114,105,116,97,98,108,101,0,0,0,0,117,115,101,83,116,97,114,116,0,0,0,0,0,0,0,0,115,116,97,114,116,0,0,0,102,105,120,101,100,0,0,0,117,115,101,78,111,109,105,110,97,108,0,0,0,0,0,0,110,111,109,105,110,97,108,0,109,105,110,0,0,0,0,0,109,97,120,0,0,0,0,0,82,101,97,108,32,37,115,40,37,115,115,116,97,114,116,61,37,103,37,115,44,32,102,105,120,101,100,61,37,115,44,32,37,115,110,111,109,105,110,97,108,61,37,103,37,115,44,32,109,105,110,61,37,103,44,32,109,97,120,61,37,103,41,0,0,0,0,0,0,0,0,0,123,0,0,0,0,0,0,0,125,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,73,110,116,101,103,101,114,32,37,115,40,37,115,115,116,97,114,116,61,37,108,100,37,115,44,32,102,105,120,101,100,61,37,115,44,32,109,105,110,61,37,108,100,44,32,109,97,120,61,37,108,100,41,0,0,0,66,111,111,108,101,97,110,32,37,115,40,37,115,115,116,97,114,116,61,37,115,37,115,44,32,102,105,120,101,100,61,37,115,41,0,0,0,0,0,0,83,116,114,105,110,103,32,37,115,40,37,115,115,116,97,114,116,61,37,115,37,115,41,0,95,105,110,105,116,46,120,109,108,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,99,97,110,32,110,111,116,32,114,101,97,100,32,102,105,108,101,32,37,115,32,97,115,32,115,101,116,117,112,32,102,105,108,101,32,116,111,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,99,111,100,101,46,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,99,111,117,108,100,110,39,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,32,102,111,114,32,116,104,101,32,88,77,76,32,112,97,114,115,101,114,33,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,102,105,108,101,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,10,0,0,0,0,0,0,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,37,115,44,32,37,115,32,37,108,117,10,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,100,97,116,97,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,10,0,0,0,0,0,0,0,0,103,117,105,100,0,0,0,0,84,104,101,32,77,111,100,101,108,32,71,85,73,68,58,32,37,115,32,105,115,32,110,111,116,32,115,101,116,32,105,110,32,102,105,108,101,58,32,37,115,0,0,0,0,0,0,0,69,114,114,111,114,44,32,116,104,101,32,71,85,73,68,58,32,37,115,32,102,114,111,109,32,105,110,112,117,116,32,100,97,116,97,32,102,105,108,101,58,32,37,115,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,104,101,32,71,85,73,68,32,99,111,109,112,105,108,101,100,32,105,110,32,116,104,101,32,109,111,100,101,108,58,32,37,115,0,0,114,101,97,100,32,97,108,108,32,116,104,101,32,68,101,102,97,117,108,116,69,120,112,101,114,105,109,101,110,116,32,118,97,108,117,101,115,58,0,0,115,116,97,114,116,84,105,109,101,0,0,0,0,0,0,0,115,116,97,114,116,84,105,109,101,32,61,32,37,103,0,0,115,116,111,112,84,105,109,101,0,0,0,0,0,0,0,0,115,116,111,112,84,105,109,101,32,61,32,37,103,0,0,0,115,116,101,112,83,105,122,101,0,0,0,0,0,0,0,0,115,116,101,112,83,105,122,101,32,61,32,37,103,0,0,0,116,111,108,101,114,97,110,99,101,0,0,0,0,0,0,0,116,111,108,101,114,97,110,99,101,32,61,32,37,103,0,0,115,111,108,118,101,114,0,0,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,0,0,0,0,0,0,0,111,117,116,112,117,116,70,111,114,109,97,116,0,0,0,0,111,117,116,112,117,116,32,102,111,114,109,97,116,58,32,37,115,0,0,0,0,0,0,0,118,97,114,105,97,98,108,101,70,105,108,116,101,114,0,0,118,97,114,105,97,98,108,101,32,102,105,108,116,101,114,58,32,37,115,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,0,0,0,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,58,32,37,115,0,0,0,0,110,117,109,98,101,114,79,102,67,111,110,116,105,110,117,111,117,115,83,116,97,116,101,115,0,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,82,101,97,108,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,110,117,109,98,101,114,79,102,82,101,97,108,80,97,114,97,109,101,116,101,114,115,0,0,110,117,109,98,101,114,79,102,73,110,116,101,103,101,114,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,73,110,116,101,103,101,114,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,66,111,111,108,101,97,110,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,66,111,111,108,101,97,110,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,83,116,114,105,110,103,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,83,116,114,105,110,103,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,69,114,114,111,114,44,32,105,110,112,117,116,32,100,97,116,97,32,102,105,108,101,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,109,111,100,101,108,46,0,0,0,0,110,120,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,100,0,0,0,0,0,0,0,110,121,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,0,0,0,110,112,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,0,0,0,110,112,105,110,116,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,121,105,110,116,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,112,98,111,111,108,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,110,121,98,111,111,108,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,110,112,115,116,114,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,121,115,116,114,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,37,115,0,0,0,0,114,101,97,108,32,115,116,97,116,101,115,0,0,0,0,0,105,115,80,114,111,116,101,99,116,101,100,0,0,0,0,0,102,105,108,116,101,114,105,110,103,32,112,114,111,116,101,99,116,101,100,32,118,97,114,105,97,98,108,101,32,37,115,0,114,101,97,108], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+275412);
/* memory initializer */ allocate([32,115,116,97,116,101,32,100,101,114,105,118,97,116,105,118,101,115,0,0,114,101,97,108,32,97,108,103,101,98,114,97,105,99,115,0,105,110,116,101,103,101,114,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,98,111,111,108,101,97,110,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,115,116,114,105,110,103,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,115,116,114,105,110,103,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,114,101,97,108,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,0,0,0,97,108,105,97,115,0,0,0,110,101,103,97,116,101,100,65,108,105,97,115,0,0,0,0,114,101,97,100,32,102,111,114,32,37,115,32,110,101,103,97,116,101,100,32,37,100,32,102,114,111,109,32,115,101,116,117,112,32,102,105,108,101,0,0,97,108,105,97,115,86,97,114,105,97,98,108,101,0,0,0,116,105,109,101,0,0,0,0,82,101,97,108,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,0,0,0,32,110,111,116,32,102,111,117,110,100,46,0,0,0,0,0,37,115,0,0,0,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,105,110,116,101,103,101,114,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,73,110,116,101,103,101,114,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,98,111,111,108,101,97,110,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,66,111,111,108,101,97,110,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,115,116,114,105,110,103,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,0,83,116,114,105,110,103,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,117,115,97,103,101,32,101,114,114,111,114,32,121,111,117,32,99,97,110,110,111,116,32,104,97,118,101,32,98,111,116,104,32,45,111,118,101,114,114,105,100,101,32,97,110,100,32,45,111,118,101,114,114,105,100,101,70,105,108,101,32,97,99,116,105,118,101,32,97,116,32,116,104,101,32,115,97,109,101,32,116,105,109,101,46,32,115,101,101,32,77,111,100,101,108,32,45,63,32,102,111,114,32,109,111,114,101,32,105,110,102,111,33,0,0,0,0,0,114,101,97,100,32,111,118,101,114,114,105,100,101,32,118,97,108,117,101,115,32,102,114,111,109,32,102,105,108,101,58,32,37,115,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,99,111,117,108,100,32,110,111,116,32,111,112,101,110,32,116,104,101,32,102,105,108,101,32,103,105,118,101,110,32,116,111,32,45,111,118,101,114,114,105,100,101,70,105,108,101,61,37,115,0,0,0,0,0,44,0,0,0,0,0,0,0,114,101,97,100,32,111,118,101,114,114,105,100,101,32,118,97,108,117,101,115,58,32,37,115,0,0,0,0,0,0,0,0,61,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,32,37,115,32,61,32,37,115,0,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,32,100,111,110,101,33,0,0,78,79,32,111,118,101,114,114,105,100,101,32,103,105,118,101,110,32,111,110,32,116,104,101,32,99,111,109,109,97,110,100,32,108,105,110,101,46,0,0,108,0,0,0,0,0,0,0,0,96,4,0,18,0,0,0,19,0,0,0,148,255,255,255,148,255,255,255,0,96,4,0,20,0,0,0,21,0,0,0,164,95,4,0,28,96,4,0,48,96,4,0,184,95,4,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,105,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,136,8,5,0,208,95,4,0,128,195,4,0,0,0,0,0,108,0,0,0,0,0,0,0,128,195,4,0,22,0,0,0,23,0,0,0,148,255,255,255,148,255,255,255,128,195,4,0,24,0,0,0,25,0,0,0,101,114,114,111,114,32,114,101,97,100,95,118,97,108,117,101,44,32,110,111,32,100,97,116,97,32,97,108,108,111,99,97,116,101,100,32,102,111,114,32,115,116,111,114,105,110,103,32,115,116,114,105,110,103,0,0,102,109,105,77,111,100,101,108,68,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,68,101,102,97,117,108,116,69,120,112,101,114,105,109,101,110,116,0,0,0,0,0,0,0,83,99,97,108,97,114,86,97,114,105,97,98,108,101,0,0,99,108,97,115,115,73,110,100,101,120,0,0,0,0,0,0,99,108,97,115,115,84,121,112,101,0,0,0,0,0,0,0,114,83,116,97,0,0,0,0,114,68,101,114,0,0,0,0,114,65,108,103,0,0,0,0,114,80,97,114,0,0,0,0,114,65,108,105,0,0,0,0,105,65,108,103,0,0,0,0,105,80,97,114,0,0,0,0,105,65,108,105,0,0,0,0,98,65,108,103,0,0,0,0,98,80,97,114,0,0,0,0,98,65,108,105,0,0,0,0,115,65,108,103,0,0,0,0,115,80,97,114,0,0,0,0,115,65,108,105,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,101,114,114,111,114,32,114,101,97,100,105,110,103,32,116,104,101,32,120,109,108,32,102,105,108,101,44,32,102,111,117,110,100,32,117,110,107,110,111,119,110,32,99,108,97,115,115,58,32,37,115,32,32,102,111,114,32,118,97,114,105,97,98,108,101,58,32,37,115,0,82,101,97,108,0,0,0,0,73,110,116,101,103,101,114,0,66,111,111,108,101,97,110,0,83,116,114,105,110,103,0,0,118,97,114,105,97,98,108,101,84,121,112,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,76,79,71,95,65,76,76,0,44,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,37,45,49,56,115,32,91,37,115,93,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,108,118,32,37,115,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,110,108,115,61,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,108,97,112,97,99,107,0,0,108,105,115,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,108,115,32,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,0,0,0,100,101,102,97,117,108,116,32,109,101,116,104,111,100,0,0,76,105,115,0,0,0,0,0,94,40,0,0,0,0,0,0,41,36,0,0,0,0,0,0,36,100,117,109,109,121,0,0,46,42,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,111,109,112,105,108,101,32,114,101,103,117,108,97,114,32,101,120,112,114,101,115,115,105,111,110,58,32,0,0,32,119,105,116,104,32,101,114,114,111,114,58,32,0,0,0,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,111,117,116,112,117,116,116,105,110,103,32,97,108,108,32,118,97,114,105,97,98,108,101,115,46,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,73,110,116,101,114,118,97,108,115,32,61,32,37,108,100,0,67,80,85,0,0,0,0,0,82,84,0,0,0,0,0,0,67,89,67,0,0,0,0,0,91,117,110,107,110,111,119,110,32,99,108,111,99,107,45,116,121,112,101,93,32,103,111,116,32,37,115,44,32,101,120,112,101,99,116,101,100,32,67,80,85,124,82,84,124,67,89,67,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,82,84,46,0,0,0,0,0,67,104,111,115,101,110,32,99,108,111,99,107,45,116,121,112,101,58,32,37,115,32,110,111,116,32,97,118,97,105,108,97,98,108,101,32,102,111,114,32,116,104,101,32,99,117,114,114,101,110,116,32,112,108,97,116,102,111,114,109,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,114,101,97,108,45,116,105,109,101,46,0,0,76,105,110,101,97,114,105,122,97,116,105,111,110,32,119,105,108,108,32,112,101,114,102,111,114,109,101,100,32,97,116,32,112,111,105,110,116,32,111,102,32,116,105,109,101,58,32,37,102,0,0,0,0,0,0,0,111,118,101,114,119,114,105,116,101,32,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,32,91,102,114,111,109,32,99,111,109,109,97,110,100,32,108,105,110,101,93,0,95,114,101,115,46,0,0,0,0,0,0,0,0,0,0,0,76,105,110,101,97,114,32,109,111,100,101,108,32,105,115,32,99,114,101,97,116,101,100,33,0,0,0,0,0,0,0,0,95,112,114,111,102,46,120,109,108,0,0,0,0,0,0,0,95,112,114,111,102,46,112,108,116,0,0,0,0,0,0,0,115,118,103,0,0,0,0,0,101,109,112,116,121,0,0,0,99,115,118,0,0,0,0,0,109,97,116,0,0,0,0,0,119,97,108,108,0,0,0,0,112,108,116,0,0,0,0,0,85,110,107,110,111,119,110,32,111,117,116,112,117,116,32,102,111,114,109,97,116,58,32,0,65,108,108,111,99,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,115,116,111,114,97,103,101,32,102,111,114,32,109,101,116,104,111,100,32,39,37,115,39,32,97,110,100,32,102,105,108,101,61,39,37,115,39,0,0,56,106,4,0,32,108,4,0,40,108,4,0,112,110,4,0,136,108,4,0,152,108,4,0,120,110,4,0,128,110,4,0,136,110,4,0,144,110,4,0,160,110,4,0,176,110,4,0,192,110,4,0,208,110,4,0,224,110,4,0,240,110,4,0,0,111,4,0,24,111,4,0,80,110,4,0,104,110,4,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,115,32,37,115,0,0,0,0,0,0,0,56,106,4,0,32,108,4,0,40,108,4,0,56,108,4,0,136,108,4,0,152,108,4,0,168,108,4,0,200,108,4,0,232,108,4,0,8,109,4,0,48,109,4,0,88,109,4,0,128,109,4,0,168,109,4,0,192,109,4,0,224,109,4,0,0,110,4,0,40,110,4,0,80,110,4,0,104,110,4,0,114,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,37,115,0,0,0,117,115,97,103,101,58,32,37,115,0,0,0,0,0,0,0,60,45,37,115,62,10,32,32,37,115,0,0,0,0,0,0,60,45,37,115,61,118,97,108,117,101,62,32,111,114,32,60,45,37,115,32,118,97,108,117,101,62,10,32,32,37,115,0,91,117,110,107,110,111,119,110,32,102,108,97,103,45,116,121,112,101,93,32,60,45,37,115,62,0,0,0,0,0,0,0,120,109,108,0,0,0,0,0,116,101,120,116,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,45,108,111,103,70,111,114,109,97,116,61,37,115,44,32,101,120,112,101,99,116,101,100,32,116,101,120,116,32,111,114,32,120,109,108,0,0,0,0,0,0,0,0,100,101,116,97,105,108,101,100,32,102,108,97,103,45,100,101,115,99,114,105,112,116,105,111,110,32,102,111,114,58,32,60,45,37,115,62,10,37,115,0,100,101,116,97,105,108,101,100,32,102,108,97,103,45,100,101,115,99,114,105,112,116,105,111,110,32,102,111,114,58,32,60,45,37,115,61,118,97,108,117,101,62,32,111,114,32,60,45,37,115,32,118,97,108,117,101,62,10,37,115,0,0,0,0,56,106,4,0,0,108,4,0,8,108,4,0,16,108,4,0,56,106,4,0,64,107,4,0,144,107,4,0,192,107,4,0,56,106,4,0,0,107,4,0,8,107,4,0,16,107,4,0,32,107,4,0,40,107,4,0,56,107,4,0,0,0,0,0,56,106,4,0,64,106,4,0,88,106,4,0,104,106,4,0,176,106,4,0,192,106,4,0,224,106,4,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,45,104,101,108,112,61,37,115,0,0,0,117,115,101,32,37,115,32,45,104,101,108,112,32,102,111,114,32,97,32,108,105,115,116,32,111,102,32,97,108,108,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,115,0,0,0,0,0,0,0,69,114,114,111,114,58,32,67,111,117,108,100,32,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,116,104,101,32,103,108,111,98,97,108,32,100,97,116,97,32,115,116,114,117,99,116,117,114,101,32,102,105,108,101,0,0,0,0,0,0,78,111,32,118,97,114,105,97,98,108,101,115,32,105,110,32,116,104,101,32,109,111,100,101,108,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,109,111,100,101,108,62,37,115,60,47,109,111,100,101,108,62,10,0,0,0,0,0,0,60,99,117,114,114,101,110,116,83,116,101,112,83,105,122,101,62,37,103,60,47,99,117,114,114,101,110,116,83,116,101,112,83,105,122,101,62,10,0,0,60,111,108,100,84,105,109,101,62,37,46,49,50,103,60,47,111,108,100,84,105,109,101,62,10,0,0,0,0,0,0,0,60,111,108,100,84,105,109,101,50,62,37,46,49,50,103,60,47,111,108,100,84,105,109,101,50,62,10,0,0,0,0,0,60,100,105,102,102,79,108,100,84,105,109,101,62,37,103,60,47,100,105,102,102,79,108,100,84,105,109,101,62,10,0,0,60,99,117,114,114,101,110,116,84,105,109,101,62,37,103,60,47,99,117,114,114,101,110,116,84,105,109,101,62,10,0,0,60,100,105,102,102,67,117,114,114,101,110,116,84,105,109,101,62,37,103,60,47,100,105,102,102,67,117,114,114,101,110,116,84,105,109,101,62,10,0,0,5,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,26,0,0,0,0,0,0,0,65,115,115,101,114,116,105,111,110,32,116,114,105,103,103,101,114,101,100,32,98,121,32,101,120,116,101,114,110,97,108,32,67,32,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,87,97,114,110,105,110,103,58,32,0,0,0,0,0,0,0,69,114,114,111,114,58,32,0,85,110,104,97,110,100,108,101,100,32,65,115,115,101,114,116,105,111,110,45,69,114,114,111,114,0,0,0,0,0,0,0,117,110,107,110,111,119,110,0,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,0,0,0,0,0,0,66,114,101,110,116,39,115,32,109,101,116,104,111,100,0,0,69,120,116,101,110,100,101,100,32,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,32,40,115,101,101,32,45,105,108,115,32,102,111,114,32,103,108,111,98,97,108,32,104,111,109,111,116,111,112,121,41,32,45,32,100,101,102,97,117,108,116,0,0,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,73,110,116,101,114,105,111,114,32,80,111,105,110,116,32,79,80,84,105,109,105,122,101,114,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,0,110,101,119,117,111,97,0,0,110,101,108,100,101,114,95,109,101,97,100,95,101,120,0,0,107,105,110,115,111,108,0,0,107,105,110,115,111,108,95,115,99,97,108,101,100,0,0,0,105,112,111,112,116,0,0,0,115,101,116,115,32,97,108,108,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,105,114,32,115,116,97,114,116,32,118,97,108,117,101,115,32,97,110,100,32,115,107,105,112,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,99,101,115,115,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,110,117,109,101,114,105,99,97,108,108,121,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,115,121,109,98,111,108,105,99,97,108,108,121,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,110,117,109,101,114,105,99,0,115,121,109,98,111,108,105,99,0,0,0,0,0,0,0,0,101,117,108,101,114,0,0,0,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,44,32,119,105,116,104,32,105,110,116,101,114,118,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,105,110,108,105,110,101,45,101,117,108,101,114,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,114,97,100,97,117,53,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,114,97,100,97,117,51,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,114,97,100,97,117,49,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,108,111,98,97,116,116,111,50,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,52,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,54,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,100,97,115,115,108,32,102,111,114,32,100,101,98,117,103,32,112,114,111,112,111,115,101,0,100,97,115,115,108,32,119,105,116,104,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,105,110,116,101,114,110,97,108,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,0,113,115,115,0,0,0,0,0,100,97,115,115,108,0,0,0,114,97,100,97,117,53,0,0,114,97,100,97,117,51,0,0,114,97,100,97,117,49,0,0,108,111,98,97,116,116,111,50,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,52,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,54,0,0,0,0,0,0,0,0,100,97,115,115,108,119,111,114,116,0,0,0,0,0,0,0,100,97,115,115,108,116,101,115,116,0,0,0,0,0,0,0,100,97,115,115,108,83,121,109,74,97,99,0,0,0,0,0,100,97,115,115,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,67,111,108,111,114,83,121,109,74,97,99,0,0,0,0,0,0,0,0,100,97,115,115,108,73,110,116,101,114,110,97,108,78,117,109,74,97,99,0,0,0,0,0,60,115,116,97,116,117,115,62,0,0,0,0,0,0,0,0,60,112,104,97,115,101,62,85,78,75,78,79,87,78,60,47,112,104,97,115,101,62,0,0,60,47,115,116,97,116,117,115,62,0,0,0,0,0,0,0,44,0,0,0,0,0,0,0,59,0,0,0,0,0,0,0,115,101,101,100,58,32,100,97,116,97,45,62,115,105,109,117,108,97,116,105,111,110,73,110,102,111,46,97,110,97,108,121,116,105,99,74,97,99,111,98,105,97,110,115,91,105,110,100,101,120,93,46,115,101,101,100,86,97,114,115,91,37,100,93,61,32,37,102,0,0,0,0,119,114,105,116,101,32,105,110,32,106,97,99,91,37,100,93,45,91,37,100,44,37,100,93,61,37,103,32,102,114,111,109,32,114,111,119,91,37,100,93,61,37,103,0,0,0,0,0,80,114,105,110,116,32,106,97,99,58,0,0,0,0,0,0,37,32,46,53,101,32,0,0,99,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,65,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,66,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,67,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,68,32,0,0,0,0,105,32,102,111,114,32,105,32,105,110,32,49,58,48,0,0,108,105,110,101,97,114,95,0,46,109,111,0,0,0,0,0,119,98,0,0,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,0,0,0,0,0,56,0,0,0,0,0,0,0,88,113,4,0,27,0,0,0,28,0,0,0,200,255,255,255,200,255,255,255,88,113,4,0,29,0,0,0,30,0,0,0,228,112,4,0,116,113,4,0,136,113,4,0,248,112,4,0,78,83,116,51,95,95,49,49,57,98,97,115,105,99,95,111,115,116,114,105,110,103,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,136,8,5,0,16,113,4,0,16,196,4,0,0,0,0,0,56,0,0,0,0,0,0,0,16,196,4,0,12,0,0,0,13,0,0,0,200,255,255,255,200,255,255,255,16,196,4,0,14,0,0,0,15,0,0,0,0,0,0,0,24,114,4,0,31,0,0,0,32,0,0,0,4,0,0,0,11,0,0,0,3,0,0,0,6,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,36,0,0,0,34,0,0,0,26,0,0,0,10,0,0,0,27,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,105,110,103,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,0,0,0,0,136,8,5,0,208,113,4,0,8,195,4,0,0,0,0,0,67,97,108,117,99,117,108,97,116,101,32,111,110,101,32,99,111,108,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,103,110,117,112,108,111,116,0,80,108,111,116,115,32,111,102,32,112,114,111,102,105,108,105,110,103,32,100,97,116,97,32,119,101,114,101,32,100,105,115,97,98,108,101,100,58,32,37,115,10,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,37,115,58,32,37,115,10,0,0,115,101,116,32,116,101,114,109,105,110,97,108,32,115,118,103,10,0,0,0,0,0,0,0,115,101,116,32,110,111,107,101,121,10,0,0,0,0,0,0,115,101,116,32,102,111,114,109,97,116,32,121,32,34,37,103,34,10,0,0,0,0,0,0,69,120,101,99,117,116,105,111,110,32,116,105,109,101,32,111,102,32,103,108,111,98,97,108,32,115,116,101,112,115,0,0,0,0,0,0,0,0,0,0,60,33,68,79,67,84,89,80,69,32,100,111,99,32,91,32,32,60,33,69,76,69,77,69,78,84,32,115,105,109,117,108,97,116,105,111,110,32,40,109,111,100,101,108,105,110,102,111,44,32,118,97,114,105,97,98,108,101,115,44,32,102,117,110,99,116,105,111,110,115,44,32,101,113,117,97,116,105,111,110,115,41,62,32,32,60,33,65,84,84,76,73,83,84,32,118,97,114,105,97,98,108,101,32,105,100,32,73,68,32,35,82,69,81,85,73,82,69,68,62,32,32,60,33,69,76,69,77,69,78,84,32,101,113,117,97,116,105,111,110,32,40,114,101,102,115,41,62,32,32,60,33,65,84,84,76,73,83,84,32,101,113,117,97,116,105,111,110,32,105,100,32,73,68,32,35,82,69,81,85,73,82,69,68,62,32,32,60,33,69,76,69,77,69,78,84,32,112,114,111,102,105,108,101,98,108,111,99,107,115,32,40,112,114,111,102,105,108,101,98,108,111,99,107,42,41,62,32,32,60,33,69,76,69,77,69,78,84,32,112,114,111,102,105,108,101,98,108,111,99,107,32,40,114,101,102,115,44,32,110,99,97,108,108,44,32,116,105,109,101,44,32,109,97,120,84,105,109,101,41,62,32,32,60,33,69,76,69,77,69,78,84,32,114,101,102,115,32,40,114,101,102,42,41,62,32,32,60,33,65,84,84,76,73,83,84,32,114,101,102,32,114,101,102,105,100,32,73,68,82,69,70,32,35,82,69,81,85,73,82,69,68,62,32,32,93,62,10,0,0,0,0,116,105,109,101,40,41,32,102,97,105,108,101,100,58,32,37,115,0,0,0,0,0,0,0,37,89,45,37,109,45,37,100,32,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,115,116,114,102,116,105,109,101,40,41,32,102,97,105,108,101,100,0,0,0,0,0,0,0,60,115,105,109,117,108,97,116,105,111,110,62,10,0,0,0,60,109,111,100,101,108,105,110,102,111,62,10,0,0,0,0,60,110,97,109,101,62,0,0,60,47,110,97,109,101,62,10,0,0,0,0,0,0,0,0,60,112,114,101,102,105,120,62,0,0,0,0,0,0,0,0,60,47,112,114,101,102,105,120,62,10,0,0,0,0,0,0,60,100,97,116,101,62,0,0,60,47,100,97,116,101,62,10,0,0,0,0,0,0,0,0,60,109,101,116,104,111,100,62,0,0,0,0,0,0,0,0,60,47,109,101,116,104,111,100,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,70,111,114,109,97,116,62,0,0,60,47,111,117,116,112,117,116,70,111,114,109,97,116,62,10,0,0,0,0,0,0,0,0,60,111,117,116,112,117,116,70,105,108,101,110,97,109,101,62,0,0,0,0,0,0,0,0,60,47,111,117,116,112,117,116,70,105,108,101,110,97,109,101,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,70,105,108,101,115,105,122,101,62,37,108,100,60,47,111,117,116,112,117,116,70,105,108,101,115,105,122,101,62,10,0,0,0,60,111,118,101,114,104,101,97,100,84,105,109,101,62,37,102,60,47,111,118,101,114,104,101,97,100,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,112,114,101,105,110,105,116,84,105,109,101,62,37,102,60,47,112,114,101,105,110,105,116,84,105,109,101,62,10,0,0,60,105,110,105,116,84,105,109,101,62,37,102,60,47,105,110,105,116,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,101,118,101,110,116,84,105,109,101,62,37,102,60,47,101,118,101,110,116,84,105,109,101,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,84,105,109,101,62,37,102,60,47,111,117,116,112,117,116,84,105,109,101,62,10,0,0,0,0,60,108,105,110,101,97,114,105,122,101,84,105,109,101,62,37,102,60,47,108,105,110,101,97,114,105,122,101,84,105,109,101,62,10,0,0,0,0,0,0,60,116,111,116,97,108,84,105,109,101,62,37,102,60,47,116,111,116,97,108,84,105,109,101,62,10,0,0,0,0,0,0,60,116,111,116,97,108,83,116,101,112,115,84,105,109,101,62,37,102,60,47,116,111,116,97,108,83,116,101,112,115,84,105,109,101,62,10,0,0,0,0,60,110,117,109,83,116,101,112,62,37,100,60,47,110,117,109,83,116,101,112,62,10,0,0,60,109,97,120,84,105,109,101,62,37,46,57,102,60,47,109,97,120,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,47,109,111,100,101,108,105,110,102,111,62,10,0,0,0,60,109,111,100,101,108,105,110,102,111,95,101,120,116,62,10,0,0,0,0,0,0,0,0,60,111,100,101,84,105,109,101,62,37,102,60,47,111,100,101,84,105,109,101,62,10,0,0,60,111,100,101,84,105,109,101,84,105,99,107,115,62,37,108,117,60,47,111,100,101,84,105,109,101,84,105,99,107,115,62,10,0,0,0,0,0,0,0,60,47,109,111,100,101,108,105,110,102,111,95,101,120,116,62,10,0,0,0,0,0,0,0,60,112,114,111,102,105,108,105,110,103,100,97,116,97,104,101,97,100,101,114,62,10,0,0,60,47,112,114,111,102,105,108,105,110,103,100,97,116,97,104,101,97,100,101,114,62,10,0,60,118,97,114,105,97,98,108,101,115,62,10,0,0,0,0,60,47,118,97,114,105,97,98,108,101,115,62,10,0,0,0,60,102,117,110,99,116,105,111,110,115,62,10,0,0,0,0,60,47,102,117,110,99,116,105,111,110,115,62,10,0,0,0,60,101,113,117,97,116,105,111,110,115,62,10,0,0,0,0,60,47,101,113,117,97,116,105,111,110,115,62,10,0,0,0,60,112,114,111,102,105,108,101,98,108,111,99,107,115,62,10,0,0,0,0,0,0,0,0,60,47,112,114,111,102,105,108,101,98,108,111,99,107,115,62,10,0,0,0,0,0,0,0,60,47,115,105,109,117,108,97,116,105,111,110,62,10,0,0,98,117,102,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,109,111,100,101,108,105,110,102,111,46,99,0,0,112,114,105,110,116,77,111,100,101,108,73,110,102,111,0,0,87,97,114,110,105,110,103,58,32,80,108,111,116,32,99,111,109,109,97,110,100,32,102,97,105,108,101,100,10,0,0,0,120,115,108,116,112,114,111,99,0,0,0,0,0,0,0,0,37,115,32,45,111,32,37,115,95,112,114,111,102,46,104,116,109,108,32,37,115,47,115,104,97,114,101,47,111,109,99,47,115,99,114,105,112,116,115,47,100,101,102,97,117,108,116,95,112,114,111,102,105,108,105,110,103,46,120,115,108,32,37,115,95,112,114,111,102,46,120,109,108,0,0,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,32,109,105,115,115,105,110,103,0,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,103,101,110,101,114,97,116,101,32,104,116,109,108,32,118,101,114,115,105,111,110,32,111,102,32,112,114,111,102,105,108,105,110,103,32,114,101,115,117,108,116,115,58,32,37,115,10,0,0,0,0,0,0,0,84,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,97,114,101,32,115,116,111,114,101,100,32,105,110,32,37,115,95,112,114,111,102,46,104,116,109,108,32,40,104,117,109,97,110,45,114,101,97,100,97,98,108,101,41,32,97,110,100,32,37,115,95,112,114,111,102,46,120,109,108,32,40,102,111,114,32,88,83,76,32,116,114,97,110,115,102,111,114,109,115,32,111,114,32,109,111,114,101,32,100,101,116,97,105,108,115,41,0,0,0,0,0,0,101,113,0,0,0,0,0,0,60,112,114,111,102,105,108,101,98,108,111,99,107,62,10,0,60,114,101,102,32,114,101,102,105,100,61,34,101,113,37,100,34,47,62,10,0,0,0,0,60,110,99,97,108,108,62,37,100,60,47,110,99,97,108,108,62,10,0,0,0,0,0,0,60,116,105,109,101,62,37,46,57,102,60,47,116,105,109,101,62,10,0,0,0,0,0,0,60,47,112,114,111,102,105,108,101,98,108,111,99,107,62,10,0,0,0,0,0,0,0,0,60,101,113,117,97,116,105,111,110,32,105,100,61,34,101,113,37,100,34,32,110,97,109,101,61,34,0,0,0,0,0,0,34,62,10,0,0,0,0,0,60,114,101,102,115,62,10,0,60,114,101,102,32,114,101,102,105,100,61,34,118,97,114,37,100,34,32,47,62,10,0,0,60,47,114,101,102,115,62,10,0,0,0,0,0,0,0,0,60,99,97,108,99,105,110,102,111,32,116,105,109,101,61,34,37,102,34,32,99,111,117,110,116,61,34,37,108,117,34,47,62,10,0,0,0,0,0,0,60,47,101,113,117,97,116,105,111,110,62,10,0,0,0,0,102,117,110,0,0,0,0,0,60,102,117,110,99,116,105,111,110,32,105,100,61,34,102,117,110,37,100,34,62,10,0,0,60,47,102,117,110,99,116,105,111,110,62,10,0,0,0,0,60,105,110,102,111,32,102,105,108,101,110,97,109,101,61,34,0,0,0,0,0,0,0,0,34,32,115,116,97,114,116,108,105,110,101,61,34,37,100,34,32,115,116,97,114,116,99,111,108,61,34,37,100,34,32,101,110,100,108,105,110,101,61,34,37,100,34,32,101,110,100,99,111,108,61,34,37,100,34,32,114,101,97,100,111,110,108,121,61,34,37,115,34,32,47,62,10,0,0,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,119,114,105,116,97,98,108,101,0,0,0,0,0,0,0,0,60,118,97,114,105,97,98,108,101,32,105,100,61,34,118,97,114,37,100,34,32,110,97,109,101,61,34,0,0,0,0,0,34,32,99,111,109,109,101,110,116,61,34,0,0,0,0,0,60,47,118,97,114,105,97,98,108,101,62,10,0,0,0,0,37,115,95,112,114,111,102,46,100,97,116,97,0,0,0,0,60,102,105,108,101,110,97,109,101,62,0,0,0,0,0,0,60,47,102,105,108,101,110,97,109,101,62,10,0,0,0,0,60,102,105,108,101,115,105,122,101,62,37,108,100,60,47,102,105,108,101,115,105,122,101,62,10,0,0,0,0,0,0,0,60,102,111,114,109,97,116,62,10,0,0,0,0,0,0,0,60,117,105,110,116,51,50,62,115,116,101,112,60,47,117,105,110,116,51,50,62,10,0,0,60,100,111,117,98,108,101,62,116,105,109,101,60,47,100,111,117,98,108,101,62,10,0,0,60,100,111,117,98,108,101,62,99,112,117,32,116,105,109,101,60,47,100,111,117,98,108,101,62,10,0,0,0,0,0,0,60,117,105,110,116,51,50,62,0,0,0,0,0,0,0,0,32,40,99,97,108,108,115,41,60,47,117,105,110,116,51,50,62,10,0,0,0,0,0,0,60,100,111,117,98,108,101,62,0,0,0,0,0,0,0,0,32,40,99,112,117,32,116,105,109,101,41,60,47,100,111,117,98,108,101,62,10,0,0,0,60,47,102,111,114,109,97,116,62,10,0,0,0,0,0,0,114,98,0,0,0,0,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,38,97,112,111,115,59,0,0,38,113,117,111,116,59,0,0,112,108,111,116,32,34,37,115,95,112,114,111,102,46,100,97,116,97,34,32,98,105,110,97,114,121,32,102,111,114,109,97,116,61,34,37,37,42,117,105,110,116,51,50,37,37,50,100,111,117,98,108,101,37,37,42,37,100,117,105,110,116,51,50,37,37,37,100,100,111,117,98,108,101,34,32,117,115,105,110,103,32,49,58,40,36,37,100,62,49,101,45,57,32,63,32,36,37,100,32,58,32,49,101,45,51,48,41,32,119,32,108,32,108,119,32,37,100,10,0,112,108,111,116,32,34,37,115,95,112,114,111,102,46,100,97,116,97,34,32,98,105,110,97,114,121,32,102,111,114,109,97,116,61,34,37,37,42,117,105,110,116,51,50,37,37,42,50,100,111,117,98,108,101,37,37,37,100,117,105,110,116,51,50,37,37,42,37,100,100,111,117,98,108,101,34,32,117,115,105,110,103,32,37,100,32,119,32,108,32,108,119,32,37,100,10,0,0,0,0,0,0,0,0,117,110,115,101,116,32,120,116,105,99,115,10,0,0,0,0,117,110,115,101,116,32,121,116,105,99,115,10,0,0,0,0,117,110,115,101,116,32,98,111,114,100,101,114,10,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,46,116,104,117,109,98,46,115,118,103,34,10,0,0,0,0,115,101,116,32,116,105,116,108,101,10,0,0,0,0,0,0,115,101,116,32,120,108,97,98,101,108,10,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,10,0,0,0,0,0,115,101,116,32,108,111,103,32,121,10,0,0,0,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,42,58,37,103,93,10,0,0,0,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,42,58,42,93,10,0,0,0,0,0,0,0,115,101,116,32,110,111,108,111,103,32,120,121,10,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,37,103,58,37,103,93,10,0,0,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,95,99,111,117,110,116,46,116,104,117,109,98,46,115,118,103,34,10,0,0,0,0,0,0,115,101,116,32,121,116,105,99,115,10,0,0,0,0,0,0,115,101,116,32,120,116,105,99,115,10,0,0,0,0,0,0,115,101,116,32,98,111,114,100,101,114,10,0,0,0,0,0,115,101,116,32,116,101,114,109,105,110,97,108,32,37,115,10,0,0,0,0,0,0,0,0,115,101,116,32,116,105,116,108,101,32,34,37,115,34,10,0,115,101,116,32,120,108,97,98,101,108,32,34,71,108,111,98,97,108,32,115,116,101,112,32,97,116,32,116,105,109,101,34,10,0,0,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,32,34,69,120,101,99,117,116,105,111,110,32,116,105,109,101,32,91,115,93,34,10,0,0,0,0,0,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,46,37,115,34,10,0,0,0,115,101,116,32,120,108,97,98,101,108,32,34,71,108,111,98,97,108,32,115,116,101,112,32,110,117,109,98,101,114,34,10,0,0,0,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,32,34,69,120,101,99,117,116,105,111,110,32,99,111,117,110,116,34,10,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,95,99,111,117,110,116,46,37,115,34,10,0,0,0,0,0,114,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,102,105,108,101,32,37,115,58,32,37,115,10,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,114,101,97,116,101,32,101,120,112,97,116,32,111,98,106,101,99,116,0,0,0,68,117,109,109,121,32,101,113,117,97,116,105,111,110,32,115,111,32,119,101,32,99,97,110,32,105,110,100,101,120,32,102,114,111,109,32,49,0,0,0,37,115,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,102,105,108,101,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,105,109,117,108,97,116,105,111,110,95,105,110,102,111,95,120,109,108,46,99,0,0,0,0,0,0,0,0,37,115,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,100,97,116,97,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,0,0,0,0,0,0,0,120,109,108,45,62,110,69,113,117,97,116,105,111,110,115,32,61,61,32,40,108,111,110,103,41,32,117,115,101,114,68,97,116,97,91,49,93,0,0,0,109,111,100,101,108,73,110,102,111,88,109,108,73,110,105,116,0,0,0,0,0,0,0,0,120,109,108,45,62,110,70,117,110,99,116,105,111,110,115,32,61,61,32,40,108,111,110,103,41,32,117,115,101,114,68,97,116,97,91,51,93,0,0,0,82,101,113,117,101,115,116,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,112,114,111,102,105,108,101,114,32,105,110,100,101,120,32,37,108,100,44,32,98,117,116,32,119,101,32,111,110,108,121,32,104,97,118,101,32,37,108,100,32,115,117,99,104,32,98,108,111,99,107,115,0,0,0,0,82,101,113,117,101,115,116,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,112,114,111,102,105,108,101,114,32,105,110,100,101,120,32,37,108,100,44,32,98,117,116,32,99,111,117,108,100,32,110,111,116,32,102,105,110,100,32,105,116,33,0,0,0,0,0,0,118,97,114,105,97,98,108,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,113,117,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,108,105,110,101,97,114,0,0,76,105,110,101,97,114,32,102,117,110,99,116,105,111,110,32,40,105,110,100,101,120,32,37,108,100,44,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+285652);
/* memory initializer */ allocate([115,105,122,101,32,37,100,41,0,0,0,0,110,111,110,108,105,110,101,97,114,0,0,0,0,0,0,0,78,111,110,108,105,110,101,97,114,32,102,117,110,99,116,105,111,110,32,40,114,101,115,105,100,117,97,108,70,117,110,99,37,108,100,44,32,115,105,122,101,32,37,100,41,0,0,0,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,100,101,102,105,110,101,115,0,110,97,109,101,0,0,0,0,60,100,101,102,105,110,101,115,62,32,110,101,101,100,115,32,116,111,32,104,97,118,101,32,101,120,97,99,116,108,121,32,111,110,101,32,97,116,116,114,105,98,117,116,101,58,32,110,97,109,101,0,0,0,0,0,0,0,0,0,0,0,0,0,105,110,102,111,0,0,0,0,102,105,108,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,108,105,110,101,83,116,97,114,116,0,0,0,0,0,0,0,108,105,110,101,69,110,100,0,99,111,108,83,116,97,114,116,0,0,0,0,0,0,0,0,99,111,108,69,110,100,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,37,115,58,32,85,110,107,110,111,119,110,32,97,116,116,114,105,98,117,116,101,32,105,110,32,60,105,110,102,111,62,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,99,111,110,116,97,105,110,101,100,32,109,111,114,101,32,101,113,117,97,116,105,111,110,115,32,116,104,97,110,32,101,120,112,101,99,116,101,100,32,40,37,108,100,41,0,0,0,0,105,110,100,101,120,0,0,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,99,111,110,116,97,105,110,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,111,117,116,32,105,110,100,101,120,0,0,0,0,0,0,0,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,103,111,116,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,105,110,100,101,120,32,37,108,100,44,32,101,120,112,101,99,116,101,100,32,37,108,100,0,0,0,0,0,0,0,83,79,77,69,32,78,73,67,69,32,69,81,85,65,84,73,79,78,32,78,65,77,69,32,40,116,111,32,98,101,32,115,101,116,32,97,32,108,105,116,116,108,101,32,108,97,116,101,114,41,0,0,0,0,0,0,99,111,109,109,101,110,116,0,60,118,97,114,62,45,116,97,103,32,100,105,100,32,110,111,116,32,115,101,116,32,110,97,109,101,32,97,110,100,32,99,111,109,109,101,110,116,0,0,35,70,73,88,77,69,35,0,84,79,68,79,58,32,83,101,116,32,109,101,32,117,112,33,33,33,0,0,0,0,0,0,100,117,109,109,121,86,97,114,83,116,97,116,101,83,101,116,74,97,99,0,0,0,0,0,255,255,255,255,168,134,4,0,168,134,4,0,168,134,4,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,82,101,102,101,114,101,110,99,101,100,32,39,37,115,39,32,116,104,97,116,32,119,97,115,32,110,111,116,32,100,101,99,108,97,114,101,100,32,97,115,32,60,118,97,114,105,97,98,108,101,62,0,0,0,0,0,63,0,0,0,0,0,0,0,104,101,108,112,0,0,0,0,70,76,65,71,95,77,65,88,0,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,78,65,77,69,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,68,69,83,67,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,68,69,84,65,73,76,69,68,95,68,69,83,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,97,99,104,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,32,99,97,110,32,111,110,108,121,32,98,101,32,117,115,101,100,32,111,110,99,101,58,32,37,115,0,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,37,115,0,83,84,79,80,32,0,0,0,32,115,116,97,116,101,109,101,110,116,32,101,120,101,99,117,116,101,100,10,0,0,0,0,37,115,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,110,100,102,105,108,101,0,101,114,114,111,114,32,105,110,32,102,111,114,109,97,116,0,105,108,108,101,103,97,108,32,117,110,105,116,32,110,117,109,98,101,114,0,0,0,0,0,102,111,114,109,97,116,116,101,100,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,0,117,110,102,111,114,109,97,116,116,101,100,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,100,105,114,101,99,116,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,115,101,113,117,101,110,116,105,97,108,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,99,97,110,39,116,32,98,97,99,107,115,112,97,99,101,32,102,105,108,101,0,0,0,0,110,117,108,108,32,102,105,108,101,32,110,97,109,101,0,0,99,97,110,39,116,32,115,116,97,116,32,102,105,108,101,0,117,110,105,116,32,110,111,116,32,99,111,110,110,101,99,116,101,100,0,0,0,0,0,0,111,102,102,32,101,110,100,32,111,102,32,114,101,99,111,114,100,0,0,0,0,0,0,0,116,114,117,110,99,97,116,105,111,110,32,102,97,105,108,101,100,32,105,110,32,101,110,100,102,105,108,101,0,0,0,0,105,110,99,111,109,112,114,101,104,101,110,115,105,98,108,101,32,108,105,115,116,32,105,110,112,117,116,0,0,0,0,0,111,117,116,32,111,102,32,102,114,101,101,32,115,112,97,99,101,0,0,0,0,0,0,0,114,101,97,100,32,117,110,101,120,112,101,99,116,101,100,32,99,104,97,114,97,99,116,101,114,0,0,0,0,0,0,0,98,97,100,32,108,111,103,105,99,97,108,32,105,110,112,117,116,32,102,105,101,108,100,0,98,97,100,32,118,97,114,105,97,98,108,101,32,116,121,112,101,0,0,0,0,0,0,0,98,97,100,32,110,97,109,101,108,105,115,116,32,110,97,109,101,0,0,0,0,0,0,0,118,97,114,105,97,98,108,101,32,110,111,116,32,105,110,32,110,97,109,101,108,105,115,116,0,0,0,0,0,0,0,0,110,111,32,101,110,100,32,114,101,99,111,114,100,0,0,0,118,97,114,105,97,98,108,101,32,99,111,117,110,116,32,105,110,99,111,114,114,101,99,116,0,0,0,0,0,0,0,0,115,117,98,115,99,114,105,112,116,32,102,111,114,32,115,99,97,108,97,114,32,118,97,114,105,97,98,108,101,0,0,0,105,110,118,97,108,105,100,32,97,114,114,97,121,32,115,101,99,116,105,111,110,0,0,0,115,117,98,115,116,114,105,110,103,32,111,117,116,32,111,102,32,98,111,117,110,100,115,0,115,117,98,115,99,114,105,112,116,32,111,117,116,32,111,102,32,98,111,117,110,100,115,0,99,97,110,39,116,32,114,101,97,100,32,102,105,108,101,0,99,97,110,39,116,32,119,114,105,116,101,32,102,105,108,101,0,0,0,0,0,0,0,0,39,110,101,119,39,32,102,105,108,101,32,101,120,105,115,116,115,0,0,0,0,0,0,0,99,97,110,39,116,32,97,112,112,101,110,100,32,116,111,32,102,105,108,101,0,0,0,0,110,111,110,45,112,111,115,105,116,105,118,101,32,114,101,99,111,114,100,32,110,117,109,98,101,114,0,0,0,0,0,0,110,109,76,98,117,102,32,111,118,101,114,102,108,111,119,0,80,137,4,0,96,137,4,0,120,137,4,0,152,137,4,0,184,137,4,0,208,137,4,0,240,137,4,0,8,138,4,0,24,138,4,0,40,138,4,0,64,138,4,0,88,138,4,0,120,138,4,0,152,138,4,0,40,138,4,0,176,138,4,0,208,138,4,0,232,138,4,0,0,139,4,0,24,139,4,0,56,139,4,0,72,139,4,0,104,139,4,0,136,139,4,0,160,139,4,0,184,139,4,0,208,139,4,0,224,139,4,0,248,139,4,0,16,140,4,0,40,140,4,0,72,140,4,0,37,115,58,32,105,108,108,101,103,97,108,32,101,114,114,111,114,32,110,117,109,98,101,114,32,37,100,10,0,0,0,0,37,115,58,32,101,110,100,32,111,102,32,102,105,108,101,10,0,0,0,0,0,0,0,0,37,115,58,32,37,115,10,0,0,0,0,0,0,0,0,0,97,112,112,97,114,101,110,116,32,115,116,97,116,101,58,32,117,110,105,116,32,37,100,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+295892);
/* memory initializer */ allocate([110,97,109,101,100,32,37,115,10,0,0,0,0,0,0,0,40,117,110,110,97,109,101,100,41,10,0,0,0,0,0,0,97,112,112,97,114,101,110,116,32,115,116,97,116,101,58,32,105,110,116,101,114,110,97,108,32,73,47,79,10,0,0,0,0,0,0,0,0,0,0,0,108,97,115,116,32,102,111,114,109,97,116,58,32,37,115,10,0,0,0,0,0,0,0,0,108,97,116,101,108,121,32,37,115,32,37,115,32,37,115,32,37,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,114,101,97,100,105,110,103,0,119,114,105,116,105,110,103,0,0,0,0,0,0,0,0,0,115,101,113,117,101,110,116,105,97,108,0,0,0,0,0,0,100,105,114,101,99,116,0,0,0,0,0,0,0,0,0,0,102,111,114,109,97,116,116,101,100,0,0,0,0,0,0,0,117,110,102,111,114,109,97,116,116,101,100,0,0,0,0,0,0,0,0,0,0,0,0,0,101,120,116,101,114,110,97,108,0,0,0,0,0,0,0,0,105,110,116,101,114,110,97,108,0,0,0,0,0,0,0,0,32,73,79], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+303096);
/* memory initializer */ allocate([117,110,107,110,111,119,110,32,99,111,100,101,32,105,110,32,100,111,95,102,105,111,58,32,37,100,10,37,115,10,0,0,100,111,95,102,105,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,109,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,100,32,115,116,114,105,110,103,0,0,0,0,0,0,102,111,114,109,97,116,32,116,111,111,32,99,111,109,112,108,105,99,97,116,101,100,58,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,114,0,0,0,0,0,0,0,80,181,4,0,88,181,4,0,119,98,0,0,0,0,0,0,119,0,0,0,0,0,0,0,114,43,98,0,0,0,0,0,114,43,0,0,0,0,0,0,104,181,4,0,112,181,4,0,120,181,4,0,128,181,4,0,144,1,0,0,0,0,0,0,240,181,4,0,0,0,0,0,111,112,101,110,0,0,0,0,102,111,114,116,46,37,108,100,0,0,0,0,0,0,0,0,110,111,32,115,112,97,99,101,0,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,100,0,0,0,0,0,0,0,102,0,0,0,0,0,0,0,117,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,109,97,108,108,111,99,32,102,97,105,108,117,114,101,0,0,115,116,97,114,116,105,111,0,115,102,101,0,0,0,0,0,37,35,46,42,69,0,0,0,37,43,46,50,100,0,0,0,37,35,46,42,102,0,0,0,119,95,101,100,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,100,101,58,32,37,100,10,0,0,0,0,0,0,119,95,110,101,100,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,100,101,58,32,37,100,10,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,0,0,0,0,0,0,0,0,108,101,102,116,32,111,102,102,0,0,0,0,0,0,0,0,114,101,99,101,110,100,0,0,115,116,97,114,116,105,111,0,119,114,105,116,101,32,115,116,97,114,116], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+308320);
/* memory initializer */ allocate([200,188,4,0,33,0,0,0,34,0,0,0,5,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,37,0,0,0,38,0,0,0,13,0,0,0,39,0,0,0,40,0,0,0,28,0,0,0,14,0,0,0,29,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,119,69,69,0,0,0,0,0,0,0,0,136,8,5,0,168,188,4,0,72,195,4,0,0,0,0,0,0,0,0,0,48,189,4,0,35,0,0,0,36,0,0,0,6,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,41,0,0,0,38,0,0,0,13,0,0,0,42,0,0,0,43,0,0,0,30,0,0,0,15,0,0,0,31,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,119,69,69,0,136,8,5,0,24,189,4,0,72,195,4,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,108,111,99,97,108,101,32,102,111,114,32,115,116,97,110,100,97,114,100,32,105,110,112,117,116,0,0,0,0,0,0,0,200,189,4,0,37,0,0,0,38,0,0,0,7,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,44,0,0,0,32,0,0,0,9,0,0,0,45,0,0,0,34,0,0,0,32,0,0,0,16,0,0,0,33,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,99,69,69,0,0,0,0,0,0,0,0,136,8,5,0,168,189,4,0,8,195,4,0,0,0,0,0,0,0,0,0,48,190,4,0,39,0,0,0,40,0,0,0,8,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,46,0,0,0,47,0,0,0,34,0,0,0,10,0,0,0,35,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,99,69,69,0,136,8,5,0,24,190,4,0,8,195,4,0,0,0,0,0,78,83,116,51,95,95,49,49,52,95,95,115,104,97,114,101,100,95,99,111,117,110,116,69,0,0,0,0,0,0,0,0,96,8,5,0,64,190,4,0,0,0,0,0,168,190,4,0,41,0,0,0,42,0,0,0,48,0,0,0,0,0,0,0,0,0,0,0,80,191,4,0,43,0,0,0,44,0,0,0,49,0,0,0,0,0,0,0,83,116,49,49,108,111,103,105,99,95,101,114,114,111,114,0,136,8,5,0,152,190,4,0,0,0,0,0,0,0,0,0,0,0,0,0,232,190,4,0,41,0,0,0,45,0,0,0,48,0,0,0,0,0,0,0,83,116,49,50,108,101,110,103,116,104,95,101,114,114,111,114,0,0,0,0,0,0,0,0,136,8,5,0,208,190,4,0,168,190,4,0,0,0,0,0,0,0,0,0,40,191,4,0,41,0,0,0,46,0,0,0,48,0,0,0,0,0,0,0,83,116,49,50,111,117,116,95,111,102,95,114,97,110,103,101,0,0,0,0,0,0,0,0,136,8,5,0,16,191,4,0,168,190,4,0,0,0,0,0,83,116,49,51,114,117,110,116,105,109,101,95,101,114,114,111,114,0,0,0,0,0,0,0,136,8,5,0,56,191,4,0,0,0,0,0,0,0,0,0,58,32,0,0,0,0,0,0,0,0,0,0,152,191,4,0,47,0,0,0,48,0,0,0,49,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,115,121,115,116,101,109,95,101,114,114,111,114,69,0,0,136,8,5,0,128,191,4,0,80,191,4,0,0,0,0,0,78,83,116,51,95,95,49,49,52,101,114,114,111,114,95,99,97,116,101,103,111,114,121,69,0,0,0,0,0,0,0,0,96,8,5,0,168,191,4,0,78,83,116,51,95,95,49,49,50,95,95,100,111,95,109,101,115,115,97,103,101,69,0,0,136,8,5,0,208,191,4,0,200,191,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,115,105,99,95,115,116,114,105,110,103,0,0,0,0,0,0,0,0,128,194,4,0,49,0,0,0,50,0,0,0,0,0,0,0,8,195,4,0,51,0,0,0,52,0,0,0,4,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,45,0,0,0,34,0,0,0,32,0,0,0,10,0,0,0,35,0,0,0,0,0,0,0,72,195,4,0,53,0,0,0,54,0,0,0,9,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,41,0,0,0,38,0,0,0,13,0,0,0,39,0,0,0,40,0,0,0,28,0,0,0,15,0,0,0,31,0,0,0,8,0,0,0,0,0,0,0,128,195,4,0,22,0,0,0,23,0,0,0,248,255,255,255,248,255,255,255,128,195,4,0,24,0,0,0,25,0,0,0,8,0,0,0,0,0,0,0,200,195,4,0,55,0,0,0,56,0,0,0,248,255,255,255,248,255,255,255,200,195,4,0,57,0,0,0,58,0,0,0,4,0,0,0,0,0,0,0,16,196,4,0,12,0,0,0,13,0,0,0,252,255,255,255,252,255,255,255,16,196,4,0,14,0,0,0,15,0,0,0,4,0,0,0,0,0,0,0,88,196,4,0,59,0,0,0,60,0,0,0,252,255,255,255,252,255,255,255,88,196,4,0,61,0,0,0,62,0,0,0,105,111,115,116,114,101,97,109,0,0,0,0,0,0,0,0,117,110,115,112,101,99,105,102,105,101,100,32,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,32,101,114,114,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,194,4,0,63,0,0,0,64,0,0,0,49,0,0,0,0,0,0,0,0,0,0,0,72,194,4,0,65,0,0,0,66,0,0,0,105,111,115,95,98,97,115,101,58,58,99,108,101,97,114,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,55,102,97,105,108,117,114,101,69,0,0,0,0,0,0,0,136,8,5,0,0,194,4,0,152,191,4,0,0,0,0,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,69,0,0,0,0,0,0,0,96,8,5,0,48,194,4,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,136,8,5,0,80,194,4,0,72,194,4,0,0,0,0,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,136,8,5,0,144,194,4,0,72,194,4,0,0,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,0,96,8,5,0,208,194,4,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,0,96,8,5,0,16,195,4,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,232,8,5,0,80,195,4,0,0,0,0,0,1,0,0,0,128,194,4,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,232,8,5,0,152,195,4,0,0,0,0,0,1,0,0,0,192,194,4,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,232,8,5,0,224,195,4,0,0,0,0,0,1,0,0,0,128,194,4,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,232,8,5,0,40,196,4,0,0,0,0,0,1,0,0,0,192,194,4,0,3,244,255,255,0,0,0,0,184,196,4,0,67,0,0,0,68,0,0,0,50,0,0,0,2,0,0,0,17,0,0,0,18,0,0,0,3,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,57,95,95,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,69,0,0,0,136,8,5,0,152,196,4,0,232,191,4,0,0,0,0,0,0,0,0,0,224,210,4,0,69,0,0,0,70,0,0,0,71,0,0,0,1,0,0,0,9,0,0,0,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,211,4,0,72,0,0,0,73,0,0,0,71,0,0,0,2,0,0,0,10,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,215,4,0,74,0,0,0,75,0,0,0,71,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,65,66,67,68,69,70,120,88,43,45,112,80,105,73,110,78,0,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,80,216,4,0,76,0,0,0,77,0,0,0,71,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,217,4,0,78,0,0,0,79,0,0,0,71,0,0,0,6,0,0,0,7,0,0,0,23,0,0,0,8,0,0,0,24,0,0,0,1,0,0,0,2,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,217,4,0,80,0,0,0,81,0,0,0,71,0,0,0,10,0,0,0,11,0,0,0,25,0,0,0,12,0,0,0,26,0,0,0,3,0,0,0,4,0,0,0,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,208,212,4,0,82,0,0,0,83,0,0,0,71,0,0,0,51,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,1,0,0,0,248,255,255,255,208,212,4,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,37,109,47,37,100,47,37,121,37,89,45,37,109,45,37,100,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,37,72,58,37,77,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,112,213,4,0,84,0,0,0,85,0,0,0,71,0,0,0,59,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,2,0,0,0,248,255,255,255,112,213,4,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,37,0,0,0,89,0,0,0,45,0,0,0,37,0,0,0,109,0,0,0,45,0,0,0,37,0,0,0,100,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,0,214,4,0,86,0,0,0,87,0,0,0,71,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,214,4,0,88,0,0,0,89,0,0,0,71,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,211,4,0,90,0,0,0,91,0,0,0,71,0,0,0,67,0,0,0,68,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,69,0,0,0,14,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,211,4,0,92,0,0,0,93,0,0,0,71,0,0,0,70,0,0,0,71,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,72,0,0,0,20,0,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,211,4,0,94,0,0,0,95,0,0,0,71,0,0,0,73,0,0,0,74,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,75,0,0,0,26,0,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,212,4,0,96,0,0,0,97,0,0,0,71,0,0,0,76,0,0,0,77,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,78,0,0,0,32,0,0,0,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,218,4,0,98,0,0,0,99,0,0,0,71,0,0,0,3,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,37,76,102,0,0,0,0,0,109,111,110,101,121,95,103,101,116,32,101,114,114,111,114,0,0,0,0,0,200,218,4,0,100,0,0,0,101,0,0,0,71,0,0,0,5,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,0,0,0,0,88,219,4,0,102,0,0,0,103,0,0,0,71,0,0,0,1,0,0,0,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,46,48,76,102,0,0,0,0,0,0,0,232,219,4,0,104,0,0,0,105,0,0,0,71,0,0,0,2,0,0,0,38,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,214,4,0,106,0,0,0,107,0,0,0,71,0,0,0,21,0,0,0,14,0,0,0,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,214,4,0,108,0,0,0,109,0,0,0,71,0,0,0,22,0,0,0,15,0,0,0,35,0,0,0,0,0,0,0,0,0,0,0,118,101,99,116,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,0,0,0,0,184,210,4,0,110,0,0,0,111,0,0,0,71,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,207,4,0,112,0,0,0,113,0,0,0,71,0,0,0,36,0,0,0,23,0,0,0,37,0,0,0,24,0,0,0,38,0,0,0,28,0,0,0,25,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,208,4,0,114,0,0,0,115,0,0,0,71,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,79,0,0,0,80,0,0,0,5,0,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,210,4,0,116,0,0,0,117,0,0,0,71,0,0,0,82,0,0,0,83,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,0,0,0,0,144,210,4,0,118,0,0,0,119,0,0,0,71,0,0,0,84,0,0,0,85,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,116,114,117,101,0,0,0,0,116,0,0,0,114,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,102,97,108,115,101,0,0,0,102,0,0,0,97,0,0,0,108,0,0,0,115,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,109,47,37,100,47,37,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,97,32,37,98,32,37,100,32,37,72,58,37,77,58,37,83,32,37,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,97,0,0,0,32,0,0,0,37,0,0,0,98,0,0,0,32,0,0,0,37,0,0,0,100,0,0,0,32,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,108,111,99,97,108,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,0,0,0,0,0,0,0,200,206,4,0,120,0,0,0,121,0,0,0,71,0,0,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,102,97,99,101,116,69,0,0,0,136,8,5,0,176,206,4,0,96,190,4,0,0,0,0,0,0,0,0,0,88,207,4,0,120,0,0,0,122,0,0,0,71,0,0,0,26,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,39,0,0,0,27,0,0,0,40,0,0,0,28,0,0,0,41,0,0,0,32,0,0,0,29,0,0,0,6,0,0,0,0,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,119,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,48,99,116,121,112,101,95,98,97,115,101,69,0,0,0,0,96,8,5,0,56,207,4,0,232,8,5,0,32,207,4,0,0,0,0,0,2,0,0,0,200,206,4,0,2,0,0,0,80,207,4,0,2,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,99,69,69,0,0,0,0,0,0,0,232,8,5,0,120,207,4,0,0,0,0,0,2,0,0,0,200,206,4,0,2,0,0,0,80,207,4,0,2,0,0,0,0,0,0,0,40,208,4,0,120,0,0,0,123,0,0,0,71,0,0,0,4,0,0,0,5,0,0,0,7,0,0,0,86,0,0,0,87,0,0,0,8,0,0,0,88,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,99,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,99,111,100,101,99,118,116,95,98,97,115,101,69,0,0,96,8,5,0,8,208,4,0,232,8,5,0,224,207,4,0,0,0,0,0,2,0,0,0,200,206,4,0,2,0,0,0,32,208,4,0,2,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,119,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,232,8,5,0,72,208,4,0,0,0,0,0,2,0,0,0,200,206,4,0,2,0,0,0,32,208,4,0,2,0,0,0,0,0,0,0,232,208,4,0,120,0,0,0,124,0,0,0,71,0,0,0,6,0,0,0,7,0,0,0,9,0,0,0,89,0,0,0,90,0,0,0,10,0,0,0,91,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,115,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,232,8,5,0,192,208,4,0,0,0,0,0,2,0,0,0,200,206,4,0,2,0,0,0,32,208,4,0,2,0,0,0,0,0,0,0,96,209,4,0,120,0,0,0,125,0,0,0,71,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,105,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,232,8,5,0,56,209,4,0,0,0,0,0,2,0,0,0,200,206,4,0,2,0,0,0,32,208,4,0,2,0,0,0,0,0,0,0,216,209,4,0,120,0,0,0,126,0,0,0,71,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,49,54,95,95,110,97,114,114,111,119,95,116,111,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,0,136,8,5,0,176,209,4,0,96,209,4,0,0,0,0,0,0,0,0,0,64,210,4,0,120,0,0,0,127,0,0,0,71,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,49,55,95,95,119,105,100,101,110,95,102,114,111,109,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,136,8,5,0,24,210,4,0,96,209,4,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,99,69,69,0,0,0,0,136,8,5,0,80,210,4,0,200,206,4,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,119,69,69,0,0,0,0,136,8,5,0,120,210,4,0,200,206,4,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,95,95,105,109,112,69,0,0,0,136,8,5,0,160,210,4,0,200,206,4,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,99,69,69,0,0,0,0,0,136,8,5,0,200,210,4,0,200,206,4,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,119,69,69,0,0,0,0,0,136,8,5,0,240,210,4,0,200,206,4,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,48,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,95,98,97,115,101,69,0,0,0,0,96,8,5,0,56,211,4,0,232,8,5,0,24,211,4,0,0,0,0,0,2,0,0,0,200,206,4,0,2,0,0,0,80,211,4,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,49,69,69,69,0,0,0,0,0,232,8,5,0,120,211,4,0,0,0,0,0,2,0,0,0,200,206,4,0,2,0,0,0,80,211,4,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,48,69,69,69,0,0,0,0,0,232,8,5,0,184,211,4,0,0,0,0,0,2,0,0,0,200,206,4,0,2,0,0,0,80,211,4,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,49,69,69,69,0,0,0,0,0,232,8,5,0,248,211,4,0,0,0,0,0,2,0,0,0,200,206,4,0,2,0,0,0,80,211,4,0,2,0,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,57,116,105,109,101,95,98,97,115,101,69,0,0,0,0,0,0,96,8,5,0,128,212,4,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,99,69,69,0,0,0,0,0,0,0,96,8,5,0,160,212,4,0,232,8,5,0,56,212,4,0,0,0,0,0,3,0,0,0,200,206,4,0,2,0,0,0,152,212,4,0,2,0,0,0,200,212,4,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,119,69,69,0,0,0,0,0,0,0,96,8,5,0,64,213,4,0,232,8,5,0,248,212,4,0,0,0,0,0,3,0,0,0,200,206,4,0,2,0,0,0,152,212,4,0,2,0,0,0,104,213,4,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,49,48,95,95,116,105,109,101,95,112,117,116,69,0,0,0,0,96,8,5,0,224,213,4,0,232,8,5,0,152,213,4,0,0,0,0,0,2,0,0,0,200,206,4,0,2,0,0,0,248,213,4,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,232,8,5,0,32,214,4,0,0,0,0,0,2,0,0,0,200,206,4,0,2,0,0,0,248,213,4,0,0,8,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,99,69,69,0,0,0,0,78,83,116,51,95,95,49,49,51,109,101,115,115,97,103,101,115,95,98,97,115,101,69,0,96,8,5,0,160,214,4,0,232,8,5,0,136,214,4,0,0,0,0,0,2,0,0,0,200,206,4,0,2,0,0,0,184,214,4,0,2,0,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,119,69,69,0,0,0,0,232,8,5,0,224,214,4,0,0,0,0,0,2,0,0,0,200,206,4,0,2,0,0,0,184,214,4,0,2,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,103,101,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,96,8,5,0,120,215,4,0,232,8,5,0,96,215,4,0,0,0,0,0,1,0,0,0,152,215,4,0,0,0,0,0,232,8,5,0,24,215,4,0,0,0,0,0,2,0,0,0,200,206,4,0,2,0,0,0,160,215,4,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,119,69,69,0,0,0,232,8,5,0,32,216,4,0,0,0,0,0,1,0,0,0,152,215,4,0,0,0,0,0,232,8,5,0,216,215,4,0,0,0,0,0,2,0,0,0,200,206,4,0,2,0,0,0,56,216,4,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,112,117,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,96,8,5,0,208,216,4,0,232,8,5,0,184,216,4,0,0,0,0,0,1,0,0,0,240,216,4,0,0,0,0,0,232,8,5,0,112,216,4,0,0,0,0,0,2,0,0,0,200,206,4,0,2,0,0,0,248,216,4,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,119,69,69,0,0,0,232,8,5,0,120,217,4,0,0,0,0,0,1,0,0,0,240,216,4,0,0,0,0,0,232,8,5,0,48,217,4,0,0,0,0,0,2,0,0,0,200,206,4,0,2,0,0,0,144,217,4,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,99,69,69,0,0,0,0,0,0,0,0,96,8,5,0,16,218,4,0,232,8,5,0,200,217,4,0,0,0,0,0,2,0,0,0,200,206,4,0,2,0,0,0,48,218,4,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,119,69,69,0,0,0,0,0,0,0,0,96,8,5,0,160,218,4,0,232,8,5,0,88,218,4,0,0,0,0,0,2,0,0,0,200,206,4,0,2,0,0,0,192,218,4,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,99,69,69,0,0,0,0,0,0,0,0,96,8,5,0,48,219,4,0,232,8,5,0,232,218,4,0,0,0,0,0,2,0,0,0,200,206,4,0,2,0,0,0,80,219,4,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,119,69,69,0,0,0,0,0,0,0,0,96,8,5,0,192,219,4,0,232,8,5,0,120,219,4,0,0,0,0,0,2,0,0,0,200,206,4,0,2,0,0,0,224,219,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,80,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,77,0,0,0,0,0,0,80,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,114,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,99,0,0,0,104,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,105,0,0,0,108,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,117,0,0,0,115,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,116,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,111,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+310372);
/* memory initializer */ allocate([74,97,110,117,97,114,121,0,70,101,98,114,117,97,114,121,0,0,0,0,0,0,0,0,77,97,114,99,104,0,0,0,65,112,114,105,108,0,0,0,77,97,121,0,0,0,0,0,74,117,110,101,0,0,0,0,74,117,108,121,0,0,0,0,65,117,103,117,115,116,0,0,83,101,112,116,101,109,98,101,114,0,0,0,0,0,0,0,79,99,116,111,98,101,114,0,78,111,118,101,109,98,101,114,0,0,0,0,0,0,0,0,68,101,99,101,109,98,101,114,0,0,0,0,0,0,0,0,74,97,110,0,0,0,0,0,70,101,98,0,0,0,0,0,77,97,114,0,0,0,0,0,65,112,114,0,0,0,0,0,74,117,110,0,0,0,0,0,74,117,108,0,0,0,0,0,65,117,103,0,0,0,0,0,83,101,112,0,0,0,0,0,79,99,116,0,0,0,0,0,78,111,118,0,0,0,0,0,68,101,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,114,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,117,0,0,0,114,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,117,110,100,97,121,0,0,77,111,110,100,97,121,0,0,84,117,101,115,100,97,121,0,87,101,100,110,101,115,100,97,121,0,0,0,0,0,0,0,84,104,117,114,115,100,97,121,0,0,0,0,0,0,0,0,70,114,105,100,97,121,0,0,83,97,116,117,114,100,97,121,0,0,0,0,0,0,0,0,83,117,110,0,0,0,0,0,77,111,110,0,0,0,0,0,84,117,101,0,0,0,0,0,87,101,100,0,0,0,0,0,84,104,117,0,0,0,0,0,70,114,105,0,0,0,0,0,83,97,116,0,0,0,0,0,18,17,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,17,34,35,36,17,37,38,39,40,41,42,43,44,17,45,46,47,16,16,48,16,16,16,16,16,16,16,49,50,51,16,52,53,16,16,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,54,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,55,17,17,17,17,56,17,57,58,59,60,61,62,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,63,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,64,65,17,66,67,68,69,70,71,72,73,16,16,16,74,75,76,77,78,16,16,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,17,17,17,82,83,16,16,16,16,16,16,16,16,16,16,16,17,17,17,17,84,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,17,85,16,16,16,16,86,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,87,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,88,89,90,91,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,92,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,254,255,255,7,254,255,255,7,0,0,0,0,0,4,32,4,255,255,127,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,195,255,3,0,31,80,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,223,60,64,215,255,255,251,255,255,255,255,255,255,255,255,255,191,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,3,252,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,254,255,255,255,127,2,254,255,255,255,255,0,0,0,0,0,255,191,182,0,255,255,255,7,7,0,0,0,255,7,255,255,255,255,255,255,255,254,255,195,255,255,255,255,255,255,255,255,255,255,255,255,239,31,254,225,255,159,0,0,255,255,255,255,255,255,0,224,255,255,255,255,255,255,255,255,255,255,255,255,3,0,255,255,255,255,255,7,48,4,255,255,255,252,255,31,0,0,255,255,255,1,0,0,0,0,0,0,0,0,253,31,0,0,0,0,0,0,240,3,255,127,255,255,255,255,255,255,255,239,255,223,225,255,207,255,254,254,238,159,249,255,255,253,197,227,159,89,128,176,207,255,3,0,238,135,249,255,255,253,109,195,135,25,2,94,192,255,63,0,238,191,251,255,255,253,237,227,191,27,1,0,207,255,0,0,238,159,249,255,255,253,237,227,159,25,192,176,207,255,2,0,236,199,61,214,24,199,255,195,199,29,129,0,192,255,0,0,238,223,253,255,255,253,239,227,223,29,96,3,207,255,0,0,236,223,253,255,255,253,239,227,223,29,96,64,207,255,6,0,236,223,253,255,255,255,255,231,223,93,128,0,207,255,0,252,236,255,127,252,255,255,251,47,127,128,95,255,0,0,12,0,254,255,255,255,255,127,255,7,63,32,255,3,0,0,0,0,150,37,240,254,174,236,255,59,95,32,255,243,0,0,0,0,1,0,0,0,255,3,0,0,255,254,255,255,255,31,254,255,3,255,255,254,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,249,255,3,255,255,231,193,255,255,127,64,255,51,255,255,255,255,191,32,255,255,255,255,255,247,255,255,255,255,255,255,255,255,255,61,127,61,255,255,255,255,255,61,255,255,255,255,61,127,61,255,127,255,255,255,255,255,255,255,61,255,255,255,255,255,255,255,255,135,0,0,0,0,255,255,0,0,255,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,159,255,255,254,255,255,7,255,255,255,255,255,255,255,255,255,199,1,0,255,223,15,0,255,255,15,0,255,255,15,0,255,223,13,0,255,255,255,255,255,255,207,255,255,1,128,16,255,3,0,0,0,0,255,3,255,255,255,255,255,255,255,255,255,255,255,0,255,255,255,255,255,7,255,255,255,255,255,255,255,255,63,0,255,255,255,31,255,15,255,1,192,255,255,255,255,63,31,0,255,255,255,255,255,15,255,255,255,3,255,3,0,0,0,0,255,255,255,15,255,255,255,255,255,255,255,127,254,255,31,0,255,3,255,3,128,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,239,255,239,15,255,3,0,0,0,0,255,255,255,255,255,243,255,255,255,255,255,255,191,255,3,0,255,255,255,255,255,255,63,0,255,227,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,222,111,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,128,0,0,255,31,0,0,0,0,0,0,0,0,0,0,0,0,132,252,47,62,80,189,255,243,224,67,0,0,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,255,255,255,255,255,255,3,0,0,255,255,255,255,255,127,255,255,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,120,12,0,255,255,255,255,191,32,255,255,255,255,255,255,255,128,0,0,255,255,127,0,127,127,127,127,127,127,127,127,255,255,255,255,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,0,0,0,254,3,62,31,254,255,255,255,255,255,255,255,255,255,127,224,254,255,255,255,255,255,255,255,255,255,255,247,224,255,255,255,255,63,254,255,255,255,255,255,255,255,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,63,255,31,255,255,255,15,0,0,255,255,255,255,255,127,240,143,255,255,255,128,255,255,255,255,255,255,255,255,255,255,0,0,0,0,128,255,252,255,255,255,255,255,255,255,255,255,255,255,255,121,15,0,255,7,0,0,0,0,0,0,0,0,0,255,187,247,255,255,255,0,0,0,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,15,0,255,3,0,0,252,8,255,255,255,255,255,7,255,255,255,255,7,0,255,255,255,31,255,255,255,255,255,255,247,255,0,128,255,3,0,0,0,0,255,255,255,255,255,255,127,0,255,63,255,3,255,255,127,4,255,255,255,255,255,255,255,127,5,0,0,56,255,255,60,0,126,126,126,0,127,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,7,255,3,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,127,248,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,0,127,0,248,224,255,253,127,95,219,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,248,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,255,255,255,255,255,255,255,255,252,255,255,255,255,255,255,0,0,0,0,0,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,223,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,255,3,254,255,255,7,254,255,255,7,192,255,255,255,255,255,255,255,255,255,255,127,252,252,252,28,0,0,0,0,255,239,255,255,127,255,255,183,255,63,255,63,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,31,255,255,255,255,255,255,1,0,0,0,0,0,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,63,255,255,255,255,15,255,62,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,3,0,0,0,0,0,0,0,0,0,0,63,253,255,255,255,255,191,145,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,63,0,255,255,255,3,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,192,0,0,0,0,0,0,0,0,111,240,239,254,255,255,15,0,0,0,0,0,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,255,63,0,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,192,255,0,0,252,255,255,255,255,255,255,1,0,0,255,255,255,1,255,3,255,255,255,255,255,255,199,255,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,30,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,3,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,31,0,255,255,255,255,255,127,0,0,248,255,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,255,255,255,223,100,222,255,235,239,255,255,255,255,255,255,255,191,231,223,223,255,255,255,123,95,252,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,253,255,255,247,255,255,255,247,255,255,223,255,255,255,223,255,255,127,255,255,255,127,255,255,255,253,255,255,255,253,255,255,247,207,255,255,255,255,255,255,239,255,255,255,150,254,247,10,132,234,150,170,150,247,247,94,255,251,255,15,238,251,255,15,0,0,0,0,0,0,0,0,97,108,110,117,109,0,97,108,112,104,97,0,98,108,97,110,107,0,99,110,116,114,108,0,100,105,103,105,116,0,103,114,97,112,104,0,108,111,119,101,114,0,112,114,105,110,116,0,112,117,110,99,116,0,115,112,97,99,101,0,117,112,112,101,114,0,120,100,105,103,105,116,0,0,0,0,0,0,0,0,18,16,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,16,16,34,35,16,36,37,38,39,40,41,42,43,16,44,45,46,17,47,48,17,17,49,17,17,17,50,51,52,53,54,55,56,57,17,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,58,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,59,16,60,61,62,63,64,65,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,66,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,67,16,16,68,16,69,70,71,16,72,16,73,16,16,16,16,74,75,76,77,16,16,78,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,16,16,16,16,82,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,83,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,84,85,86,87,16,16,88,89,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,90,16,91,92,93,94,95,96,97,98,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,254,255,0,252,1,0,0,248,1,0,0,120,0,0,0,0,255,251,223,251,0,0,128,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,0,252,255,224,175,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,32,64,176,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,134,254,255,255,255,0,64,73,0,0,0,0,0,24,0,223,255,0,200,0,0,0,0,0,0,0,1,0,60,0,0,0,0,0,0,0,0,0,0,0,0,16,224,1,30,0,96,255,191,0,0,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,207,3,0,0,0,3,0,32,255,127,0,0,0,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,0,0,0,16,0,32,30,0,48,0,1,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,252,15,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,3,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,253,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,255,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,63,2,0,0,0,0,0,0,0,0,0,4,0,0,0,0,16,0,0,0,0,0,0,128,0,128,192,223,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,31,0,0,0,0,0,0,254,255,255,255,0,252,255,255,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,192,255,223,255,7,0,0,0,0,0,0,0,0,0,0,128,6,0,252,0,0,24,62,0,0,128,191,0,204,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,96,255,255,255,31,0,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,0,0,1,0,0,24,0,0,0,0,0,0,0,0,0,56,0,0,0,0,16,0,0,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,0,254,127,47,0,0,255,3,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,196,255,255,255,255,0,0,0,192,0,0,0,0,0,0,0,0,1,0,224,159,0,0,0,0,127,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,16,0,0,252,255,255,255,31,0,0,0,0,0,12,0,0,0,0,0,0,64,0,12,240,0,0,0,0,0,0,192,248,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,255,0,255,255,255,33,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,127,0,0,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,3,224,0,224,0,224,0,96,128,248,255,255,255,252,255,255,255,255,255,127,31,252,241,127,255,127,0,0,255,255,255,3,0,0,255,255,255,255,1,0,123,3,208,193,175,66,0,12,31,188,255,255,0,0,0,0,0,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,127,0,0,0,255,7,0,0,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,252,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,135,3,254,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,255,15,0,0,0,0,0,0,0,0,255,255,255,251,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,255,15,30,255,255,255,1,252,193,224,0,0,0,0,0,0,0,0,0,0,0,30,1,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,0,0,0,0,255,255,255,255,15,0,0,0,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,0,0,0,0,0,0,192,0,224,0,0,0,0,0,0,0,0,0,0,0,128,15,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,255,255,127,0,3,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,8,0,0,0,15,255,3,0,0,0,0,0,0,240,0,0,0,0,0,0,0,0,0,16,192,0,0,255,255,3,7,0,0,0,0,0,248,0,0,0,0,8,128,0,0,0,0,0,0,0,0,0,0,8,0,255,63,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,0,0,128,11,0,0,0,0,0,0,0,128,2,0,0,192,0,0,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,255,255,255,3,127,0,255,255,255,255,247,255,127,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,254,255,0,252,1,0,0,248,1,0,0,248,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,127,127,0,48,135,255,255,255,255,255,143,255,0,0,0,0,0,0,224,255,255,7,255,15,0,0,0,0,0,0,255,255,255,255,255,63,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,143,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,135,255,0,255,1,0,0,0,224,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,0,0,0,255,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,63,252,255,63,0,0,0,3,0,0,0,0,0,0,254,3,0,0,0,0,0,0,0,0,0,0,0,0,0,24,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,225,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,7,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,255,255,255,255,127,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,127,0,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,8,0,0,0,8,0,0,32,0,0,0,32,0,0,128,0,0,0,128,0,0,0,2,0,0,0,2,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,127,254,127,254,255,254,255,0,0,0,0,255,7,255,255,255,127,255,255,255,255,255,255,255,15,255,255,255,255,255,7,0,0,0,0,0,0,0,0,192,255,255,255,7,0,255,255,255,255,255,7,255,1,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,1,0,191,255,255,255,255,255,255,255,255,31,255,255,15,0,255,255,255,255,223,7,0,0,255,255,1,0,255,255,255,255,255,255,255,127,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,30,255,255,255,255,255,255,255,63,15,0,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,255,255,255,255,255,255,255,255,225,255,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,9,0,0,0,10,0,0,0,13,0,0,0,11,0,0,0,12,0,0,0,133,0,0,0,0,32,0,0,1,32,0,0,2,32,0,0,3,32,0,0,4,32,0,0,5,32,0,0,6,32,0,0,8,32,0,0,9,32,0,0,10,32,0,0,40,32,0,0,41,32,0,0,95,32,0,0,0,48,0,0,0,0,0,0,65,0,32,26,192,0,32,31,0,1,1,47,50,1,1,5,57,1,1,15,74,1,1,45,121,1,1,5,112,3,1,3,145,3,32,17,163,3,32,9,0,4,80,16,16,4,32,32,96,4,1,33,138,4,1,53,193,4,1,13,208,4,1,63,20,5,1,19,49,5,48,38,160,1,1,5,179,1,1,3,205,1,1,15,222,1,1,17,248,1,1,39,34,2,1,17,216,3,1,23,0,30,1,149,160,30,1,95,8,31,248,8,24,31,248,6,40,31,248,8,56,31,248,8,72,31,248,6,104,31,248,8,136,31,248,8,152,31,248,8,168,31,248,8,184,31,248,2,186,31,182,2,200,31,170,4,216,31,248,2,218,31,156,2,232,31,248,2,234,31,144,2,248,31,128,2,250,31,130,2,70,2,1,9,16,5,1,3,96,33,16,16,0,44,48,47,103,44,1,5,128,44,1,99,235,44,1,3,64,166,1,45,128,166,1,23,34,167,1,13,50,167,1,61,121,167,1,3,126,167,1,9,144,167,1,3,160,167,1,9,33,255,32,26,0,0,0,0,73,0,49,1,83,0,127,1,48,1,105,0,120,1,255,0,129,1,83,2,130,1,131,1,132,1,133,1,134,1,84,2,135,1,136,1,137,1,86,2,138,1,87,2,139,1,140,1,142,1,221,1,143,1,89,2,144,1,91,2,145,1,146,1,147,1,96,2,148,1,99,2,150,1,105,2,151,1,104,2,152,1,153,1,156,1,111,2,157,1,114,2,159,1,117,2,166,1,128,2,167,1,168,1,169,1,131,2,172,1,173,1,174,1,136,2,175,1,176,1,177,1,138,2,178,1,139,2,183,1,146,2,184,1,185,1,188,1,189,1,196,1,198,1,196,1,197,1,197,1,198,1,199,1,201,1,199,1,200,1,200,1,201,1,202,1,204,1,202,1,203,1,203,1,204,1,241,1,243,1,241,1,242,1,242,1,243,1,244,1,245,1,246,1,149,1,247,1,191,1,32,2,158,1,134,3,172,3,136,3,173,3,137,3,174,3,138,3,175,3,140,3,204,3,142,3,205,3,143,3,206,3,153,3,69,3,153,3,190,31,163,3,194,3,247,3,248,3,250,3,251,3,96,30,155,30,223,0,223,0,158,30,223,0,89,31,81,31,91,31,83,31,93,31,85,31,95,31,87,31,188,31,179,31,204,31,195,31,236,31,229,31,252,31,243,31,58,2,101,44,59,2,60,2,61,2,154,1,62,2,102,44,65,2,66,2,67,2,128,1,68,2,137,2,69,2,140,2,244,3,184,3,249,3,242,3,253,3,123,3,254,3,124,3,255,3,125,3,192,4,207,4,38,33,201,3,42,33,107,0,43,33,229,0,50,33,78,33,131,33,132,33,96,44,97,44,98,44,107,2,99,44,125,29,100,44,125,2,109,44,81,2,110,44,113,2,111,44,80,2,112,44,82,2,114,44,115,44,117,44,118,44,126,44,63,2,127,44,64,2,242,44,243,44,125,167,121,29,139,167,140,167,141,167,101,2,170,167,102,2,199,16,39,45,205,16,45,45,118,3,119,3,156,3,181,0,146,3,208,3,152,3,209,3,166,3,213,3,160,3,214,3,154,3,240,3,161,3,241,3,149,3,245,3,207,3,215,3,0,0,0,0,0,0,0,0,2,0,0,192,3,0,0,192,4,0,0,192,5,0,0,192,6,0,0,192,7,0,0,192,8,0,0,192,9,0,0,192,10,0,0,192,11,0,0,192,12,0,0,192,13,0,0,192,14,0,0,192,15,0,0,192,16,0,0,192,17,0,0,192,18,0,0,192,19,0,0,192,20,0,0,192,21,0,0,192,22,0,0,192,23,0,0,192,24,0,0,192,25,0,0,192,26,0,0,192,27,0,0,192,28,0,0,192,29,0,0,192,30,0,0,192,31,0,0,192,0,0,0,179,1,0,0,195,2,0,0,195,3,0,0,195,4,0,0,195,5,0,0,195,6,0,0,195,7,0,0,195,8,0,0,195,9,0,0,195,10,0,0,195,11,0,0,195,12,0,0,195,13,0,0,211,14,0,0,195,15,0,0,195,0,0,12,187,1,0,12,195,2,0,12,195,3,0,12,195,4,0,12,211,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,116,0,0,0,208,5,5,0,110,0,0,0,216,5,5,0,114,0,0,0,224,5,5,0,102,0,0,0,232,5,5,0,97,0,0,0,240,5,5,0,101,0,0,0,248,5,5,0,119,0,0,0,0,6,5,0,87,0,0,0,16,6,5,0,115,0,0,0,32,6,5,0,83,0,0,0,48,6,5,0,100,0,0,0,64,6,5,0,68,0,0,0,80,6,5,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,13,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,27,0,0,0,0,0,0,0,91,91,58,97,108,110,117,109,58,93,95,93,0,0,0,0,91,94,91,58,97,108,110,117,109,58,93,95,93,0,0,0,91,91,58,115,112,97,99,101,58,93,93,0,0,0,0,0,91,94,91,58,115,112,97,99,101,58,93,93,0,0,0,0,91,91,58,100,105,103,105,116,58,93,93,0,0,0,0,0,91,94,91,58,100,105,103,105,116,58,93,93,0,0,0,0,78,111,32,101,114,114,111,114,0,78,111,32,109,97,116,99,104,0,73,110,118,97,108,105,100,32,114,101,103,101,120,112,0,85,110,107,110,111,119,110,32,99,111,108,108,97,116,105,110,103,32,101,108,101,109,101,110,116,0,85,110,107,110,111,119,110,32,99,104,97,114,97,99,116,101,114,32,99,108,97,115,115,32,110,97,109,101,0,84,114,97,105,108,105,110,103,32,98,97,99,107,115,108,97,115,104,0,73,110,118,97,108,105,100,32,98,97,99,107,32,114,101,102,101,114,101,110,99,101,0,77,105,115,115,105,110,103,32,39,93,39,0,77,105,115,115,105,110,103,32,39,41,39,0,77,105,115,115,105,110,103,32,39,125,39,0,73,110,118,97,108,105,100,32,99,111,110,116,101,110,116,115,32,111,102,32,123,125,0,73,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,114,97,110,103,101,0,79,117,116,32,111,102,32,109,101,109,111,114,121,0,82,101,112,101,116,105,116,105,111,110,32,110,111,116,32,112,114,101,99,101,100,101,100,32,98,121,32,118,97,108,105,100,32,101,120,112,114,101,115,115,105,111,110,0,0,85,110,107,110,111,119,110,32,101,114,114,111,114,0,0,0,37,115,0,0,0,0,0,0,0,0,0,0,216,7,5,0,128,0,0,0,129,0,0,0,95,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,99,97,115,116,0,0,0,83,116,57,116,121,112,101,95,105,110,102,111,0,0,0,0,96,8,5,0,176,7,5,0,83,116,56,98,97,100,95,99,97,115,116,0,0,0,0,0,136,8,5,0,200,7,5,0,0,0,0,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,54,95,95,115,104,105,109,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,0,136,8,5,0,232,7,5,0,192,7,5,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,55,95,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,136,8,5,0,32,8,5,0,16,8,5,0,0,0,0,0,0,0,0,0,72,8,5,0,130,0,0,0,131,0,0,0,132,0,0,0,133,0,0,0,30,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,208,8,5,0,130,0,0,0,134,0,0,0,132,0,0,0,133,0,0,0,30,0,0,0,17,0,0,0,11,0,0,0,12,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,48,95,95,115,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,136,8,5,0,168,8,5,0,72,8,5,0,0,0,0,0,0,0,0,0,48,9,5,0,130,0,0,0,135,0,0,0,132,0,0,0,133,0,0,0,30,0,0,0,18,0,0,0,12,0,0,0,13,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,49,95,95,118,109,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,136,8,5,0,8,9,5,0,72,8,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,11,5,0,136,0,0,0,137,0,0,0,96,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,97,108,108,111,99,0,0,83,116,57,98,97,100,95,97,108,108,111,99,0,0,0,0,136,8,5,0,96,11,5,0,0,0,0,0,0,0,0,0,105,110,102,105,110,105,116,121,0,0,0,0,0,0,0,0,110,97,110,0,0,0,0,0,95,112,137,0,255,9,47,15,10,0,0,0,100,0,0,0,232,3,0,0,16,39,0,0,160,134,1,0,64,66,15,0,128,150,152,0,0,225,245,5], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+320712);




var tempDoublePtr = Runtime.alignMemory(allocate(12, "i8", ALLOC_STATIC), 8);

assert(tempDoublePtr % 8 == 0);

function copyTempFloat(ptr) { // functions, because inlining this code increases code size too much

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

}

function copyTempDouble(ptr) {

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

  HEAP8[tempDoublePtr+4] = HEAP8[ptr+4];

  HEAP8[tempDoublePtr+5] = HEAP8[ptr+5];

  HEAP8[tempDoublePtr+6] = HEAP8[ptr+6];

  HEAP8[tempDoublePtr+7] = HEAP8[ptr+7];

}


  function _llvm_lifetime_end() {}

  
  
  var ERRNO_CODES={EPERM:1,ENOENT:2,ESRCH:3,EINTR:4,EIO:5,ENXIO:6,E2BIG:7,ENOEXEC:8,EBADF:9,ECHILD:10,EAGAIN:11,EWOULDBLOCK:11,ENOMEM:12,EACCES:13,EFAULT:14,ENOTBLK:15,EBUSY:16,EEXIST:17,EXDEV:18,ENODEV:19,ENOTDIR:20,EISDIR:21,EINVAL:22,ENFILE:23,EMFILE:24,ENOTTY:25,ETXTBSY:26,EFBIG:27,ENOSPC:28,ESPIPE:29,EROFS:30,EMLINK:31,EPIPE:32,EDOM:33,ERANGE:34,ENOMSG:42,EIDRM:43,ECHRNG:44,EL2NSYNC:45,EL3HLT:46,EL3RST:47,ELNRNG:48,EUNATCH:49,ENOCSI:50,EL2HLT:51,EDEADLK:35,ENOLCK:37,EBADE:52,EBADR:53,EXFULL:54,ENOANO:55,EBADRQC:56,EBADSLT:57,EDEADLOCK:35,EBFONT:59,ENOSTR:60,ENODATA:61,ETIME:62,ENOSR:63,ENONET:64,ENOPKG:65,EREMOTE:66,ENOLINK:67,EADV:68,ESRMNT:69,ECOMM:70,EPROTO:71,EMULTIHOP:72,EDOTDOT:73,EBADMSG:74,ENOTUNIQ:76,EBADFD:77,EREMCHG:78,ELIBACC:79,ELIBBAD:80,ELIBSCN:81,ELIBMAX:82,ELIBEXEC:83,ENOSYS:38,ENOTEMPTY:39,ENAMETOOLONG:36,ELOOP:40,EOPNOTSUPP:95,EPFNOSUPPORT:96,ECONNRESET:104,ENOBUFS:105,EAFNOSUPPORT:97,EPROTOTYPE:91,ENOTSOCK:88,ENOPROTOOPT:92,ESHUTDOWN:108,ECONNREFUSED:111,EADDRINUSE:98,ECONNABORTED:103,ENETUNREACH:101,ENETDOWN:100,ETIMEDOUT:110,EHOSTDOWN:112,EHOSTUNREACH:113,EINPROGRESS:115,EALREADY:114,EDESTADDRREQ:89,EMSGSIZE:90,EPROTONOSUPPORT:93,ESOCKTNOSUPPORT:94,EADDRNOTAVAIL:99,ENETRESET:102,EISCONN:106,ENOTCONN:107,ETOOMANYREFS:109,EUSERS:87,EDQUOT:122,ESTALE:116,ENOTSUP:95,ENOMEDIUM:123,EILSEQ:84,EOVERFLOW:75,ECANCELED:125,ENOTRECOVERABLE:131,EOWNERDEAD:130,ESTRPIPE:86};
  
  var ERRNO_MESSAGES={0:"Success",1:"Not super-user",2:"No such file or directory",3:"No such process",4:"Interrupted system call",5:"I/O error",6:"No such device or address",7:"Arg list too long",8:"Exec format error",9:"Bad file number",10:"No children",11:"No more processes",12:"Not enough core",13:"Permission denied",14:"Bad address",15:"Block device required",16:"Mount device busy",17:"File exists",18:"Cross-device link",19:"No such device",20:"Not a directory",21:"Is a directory",22:"Invalid argument",23:"Too many open files in system",24:"Too many open files",25:"Not a typewriter",26:"Text file busy",27:"File too large",28:"No space left on device",29:"Illegal seek",30:"Read only file system",31:"Too many links",32:"Broken pipe",33:"Math arg out of domain of func",34:"Math result not representable",35:"File locking deadlock error",36:"File or path name too long",37:"No record locks available",38:"Function not implemented",39:"Directory not empty",40:"Too many symbolic links",42:"No message of desired type",43:"Identifier removed",44:"Channel number out of range",45:"Level 2 not synchronized",46:"Level 3 halted",47:"Level 3 reset",48:"Link number out of range",49:"Protocol driver not attached",50:"No CSI structure available",51:"Level 2 halted",52:"Invalid exchange",53:"Invalid request descriptor",54:"Exchange full",55:"No anode",56:"Invalid request code",57:"Invalid slot",59:"Bad font file fmt",60:"Device not a stream",61:"No data (for no delay io)",62:"Timer expired",63:"Out of streams resources",64:"Machine is not on the network",65:"Package not installed",66:"The object is remote",67:"The link has been severed",68:"Advertise error",69:"Srmount error",70:"Communication error on send",71:"Protocol error",72:"Multihop attempted",73:"Cross mount point (not really error)",74:"Trying to read unreadable message",75:"Value too large for defined data type",76:"Given log. name not unique",77:"f.d. invalid for this operation",78:"Remote address changed",79:"Can   access a needed shared lib",80:"Accessing a corrupted shared lib",81:".lib section in a.out corrupted",82:"Attempting to link in too many libs",83:"Attempting to exec a shared library",84:"Illegal byte sequence",86:"Streams pipe error",87:"Too many users",88:"Socket operation on non-socket",89:"Destination address required",90:"Message too long",91:"Protocol wrong type for socket",92:"Protocol not available",93:"Unknown protocol",94:"Socket type not supported",95:"Not supported",96:"Protocol family not supported",97:"Address family not supported by protocol family",98:"Address already in use",99:"Address not available",100:"Network interface is not configured",101:"Network is unreachable",102:"Connection reset by network",103:"Connection aborted",104:"Connection reset by peer",105:"No buffer space available",106:"Socket is already connected",107:"Socket is not connected",108:"Can't send after socket shutdown",109:"Too many references",110:"Connection timed out",111:"Connection refused",112:"Host is down",113:"Host is unreachable",114:"Socket already connected",115:"Connection already in progress",116:"Stale file handle",122:"Quota exceeded",123:"No medium (in tape drive)",125:"Operation canceled",130:"Previous owner died",131:"State not recoverable"};
  
  
  var ___errno_state=0;function ___setErrNo(value) {
      // For convenient setting and returning of errno.
      HEAP32[((___errno_state)>>2)]=value;
      return value;
    }
  
  var PATH={splitPath:function (filename) {
        var splitPathRe = /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;
        return splitPathRe.exec(filename).slice(1);
      },normalizeArray:function (parts, allowAboveRoot) {
        // if the path tries to go above the root, `up` ends up > 0
        var up = 0;
        for (var i = parts.length - 1; i >= 0; i--) {
          var last = parts[i];
          if (last === '.') {
            parts.splice(i, 1);
          } else if (last === '..') {
            parts.splice(i, 1);
            up++;
          } else if (up) {
            parts.splice(i, 1);
            up--;
          }
        }
        // if the path is allowed to go above the root, restore leading ..s
        if (allowAboveRoot) {
          for (; up--; up) {
            parts.unshift('..');
          }
        }
        return parts;
      },normalize:function (path) {
        var isAbsolute = path.charAt(0) === '/',
            trailingSlash = path.substr(-1) === '/';
        // Normalize the path
        path = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), !isAbsolute).join('/');
        if (!path && !isAbsolute) {
          path = '.';
        }
        if (path && trailingSlash) {
          path += '/';
        }
        return (isAbsolute ? '/' : '') + path;
      },dirname:function (path) {
        var result = PATH.splitPath(path),
            root = result[0],
            dir = result[1];
        if (!root && !dir) {
          // No dirname whatsoever
          return '.';
        }
        if (dir) {
          // It has a dirname, strip trailing slash
          dir = dir.substr(0, dir.length - 1);
        }
        return root + dir;
      },basename:function (path) {
        // EMSCRIPTEN return '/'' for '/', not an empty string
        if (path === '/') return '/';
        var lastSlash = path.lastIndexOf('/');
        if (lastSlash === -1) return path;
        return path.substr(lastSlash+1);
      },extname:function (path) {
        return PATH.splitPath(path)[3];
      },join:function () {
        var paths = Array.prototype.slice.call(arguments, 0);
        return PATH.normalize(paths.join('/'));
      },join2:function (l, r) {
        return PATH.normalize(l + '/' + r);
      },resolve:function () {
        var resolvedPath = '',
          resolvedAbsolute = false;
        for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
          var path = (i >= 0) ? arguments[i] : FS.cwd();
          // Skip empty and invalid entries
          if (typeof path !== 'string') {
            throw new TypeError('Arguments to path.resolve must be strings');
          } else if (!path) {
            continue;
          }
          resolvedPath = path + '/' + resolvedPath;
          resolvedAbsolute = path.charAt(0) === '/';
        }
        // At this point the path should be resolved to a full absolute path, but
        // handle relative paths to be safe (might happen when process.cwd() fails)
        resolvedPath = PATH.normalizeArray(resolvedPath.split('/').filter(function(p) {
          return !!p;
        }), !resolvedAbsolute).join('/');
        return ((resolvedAbsolute ? '/' : '') + resolvedPath) || '.';
      },relative:function (from, to) {
        from = PATH.resolve(from).substr(1);
        to = PATH.resolve(to).substr(1);
        function trim(arr) {
          var start = 0;
          for (; start < arr.length; start++) {
            if (arr[start] !== '') break;
          }
          var end = arr.length - 1;
          for (; end >= 0; end--) {
            if (arr[end] !== '') break;
          }
          if (start > end) return [];
          return arr.slice(start, end - start + 1);
        }
        var fromParts = trim(from.split('/'));
        var toParts = trim(to.split('/'));
        var length = Math.min(fromParts.length, toParts.length);
        var samePartsLength = length;
        for (var i = 0; i < length; i++) {
          if (fromParts[i] !== toParts[i]) {
            samePartsLength = i;
            break;
          }
        }
        var outputParts = [];
        for (var i = samePartsLength; i < fromParts.length; i++) {
          outputParts.push('..');
        }
        outputParts = outputParts.concat(toParts.slice(samePartsLength));
        return outputParts.join('/');
      }};
  
  var TTY={ttys:[],init:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // currently, FS.init does not distinguish if process.stdin is a file or TTY
        //   // device, it always assumes it's a TTY device. because of this, we're forcing
        //   // process.stdin to UTF8 encoding to at least make stdin reading compatible
        //   // with text files until FS.init can be refactored.
        //   process['stdin']['setEncoding']('utf8');
        // }
      },shutdown:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // inolen: any idea as to why node -e 'process.stdin.read()' wouldn't exit immediately (with process.stdin being a tty)?
        //   // isaacs: because now it's reading from the stream, you've expressed interest in it, so that read() kicks off a _read() which creates a ReadReq operation
        //   // inolen: I thought read() in that case was a synchronous operation that just grabbed some amount of buffered data if it exists?
        //   // isaacs: it is. but it also triggers a _read() call, which calls readStart() on the handle
        //   // isaacs: do process.stdin.pause() and i'd think it'd probably close the pending call
        //   process['stdin']['pause']();
        // }
      },register:function (dev, ops) {
        TTY.ttys[dev] = { input: [], output: [], ops: ops };
        FS.registerDevice(dev, TTY.stream_ops);
      },stream_ops:{open:function (stream) {
          var tty = TTY.ttys[stream.node.rdev];
          if (!tty) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          stream.tty = tty;
          stream.seekable = false;
        },close:function (stream) {
          // flush any pending line data
          if (stream.tty.output.length) {
            stream.tty.ops.put_char(stream.tty, 10);
          }
        },read:function (stream, buffer, offset, length, pos /* ignored */) {
          if (!stream.tty || !stream.tty.ops.get_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          var bytesRead = 0;
          for (var i = 0; i < length; i++) {
            var result;
            try {
              result = stream.tty.ops.get_char(stream.tty);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            if (result === undefined && bytesRead === 0) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
            if (result === null || result === undefined) break;
            bytesRead++;
            buffer[offset+i] = result;
          }
          if (bytesRead) {
            stream.node.timestamp = Date.now();
          }
          return bytesRead;
        },write:function (stream, buffer, offset, length, pos) {
          if (!stream.tty || !stream.tty.ops.put_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          for (var i = 0; i < length; i++) {
            try {
              stream.tty.ops.put_char(stream.tty, buffer[offset+i]);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
          }
          if (length) {
            stream.node.timestamp = Date.now();
          }
          return i;
        }},default_tty_ops:{get_char:function (tty) {
          if (!tty.input.length) {
            var result = null;
            if (ENVIRONMENT_IS_NODE) {
              result = process['stdin']['read']();
              if (!result) {
                if (process['stdin']['_readableState'] && process['stdin']['_readableState']['ended']) {
                  return null;  // EOF
                }
                return undefined;  // no data available
              }
            } else if (typeof window != 'undefined' &&
              typeof window.prompt == 'function') {
              // Browser.
              result = window.prompt('Input: ');  // returns null on cancel
              if (result !== null) {
                result += '\n';
              }
            } else if (typeof readline == 'function') {
              // Command line.
              result = readline();
              if (result !== null) {
                result += '\n';
              }
            }
            if (!result) {
              return null;
            }
            tty.input = intArrayFromString(result, true);
          }
          return tty.input.shift();
        },put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['print'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }},default_tty1_ops:{put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['printErr'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }}};
  
  var MEMFS={ops_table:null,CONTENT_OWNING:1,CONTENT_FLEXIBLE:2,CONTENT_FIXED:3,mount:function (mount) {
        return MEMFS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createNode:function (parent, name, mode, dev) {
        if (FS.isBlkdev(mode) || FS.isFIFO(mode)) {
          // no supported
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (!MEMFS.ops_table) {
          MEMFS.ops_table = {
            dir: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                lookup: MEMFS.node_ops.lookup,
                mknod: MEMFS.node_ops.mknod,
                rename: MEMFS.node_ops.rename,
                unlink: MEMFS.node_ops.unlink,
                rmdir: MEMFS.node_ops.rmdir,
                readdir: MEMFS.node_ops.readdir,
                symlink: MEMFS.node_ops.symlink
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek
              }
            },
            file: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek,
                read: MEMFS.stream_ops.read,
                write: MEMFS.stream_ops.write,
                allocate: MEMFS.stream_ops.allocate,
                mmap: MEMFS.stream_ops.mmap
              }
            },
            link: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                readlink: MEMFS.node_ops.readlink
              },
              stream: {}
            },
            chrdev: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: FS.chrdev_stream_ops
            },
          };
        }
        var node = FS.createNode(parent, name, mode, dev);
        if (FS.isDir(node.mode)) {
          node.node_ops = MEMFS.ops_table.dir.node;
          node.stream_ops = MEMFS.ops_table.dir.stream;
          node.contents = {};
        } else if (FS.isFile(node.mode)) {
          node.node_ops = MEMFS.ops_table.file.node;
          node.stream_ops = MEMFS.ops_table.file.stream;
          node.contents = [];
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        } else if (FS.isLink(node.mode)) {
          node.node_ops = MEMFS.ops_table.link.node;
          node.stream_ops = MEMFS.ops_table.link.stream;
        } else if (FS.isChrdev(node.mode)) {
          node.node_ops = MEMFS.ops_table.chrdev.node;
          node.stream_ops = MEMFS.ops_table.chrdev.stream;
        }
        node.timestamp = Date.now();
        // add the new node to the parent
        if (parent) {
          parent.contents[name] = node;
        }
        return node;
      },ensureFlexible:function (node) {
        if (node.contentMode !== MEMFS.CONTENT_FLEXIBLE) {
          var contents = node.contents;
          node.contents = Array.prototype.slice.call(contents);
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        }
      },node_ops:{getattr:function (node) {
          var attr = {};
          // device numbers reuse inode numbers.
          attr.dev = FS.isChrdev(node.mode) ? node.id : 1;
          attr.ino = node.id;
          attr.mode = node.mode;
          attr.nlink = 1;
          attr.uid = 0;
          attr.gid = 0;
          attr.rdev = node.rdev;
          if (FS.isDir(node.mode)) {
            attr.size = 4096;
          } else if (FS.isFile(node.mode)) {
            attr.size = node.contents.length;
          } else if (FS.isLink(node.mode)) {
            attr.size = node.link.length;
          } else {
            attr.size = 0;
          }
          attr.atime = new Date(node.timestamp);
          attr.mtime = new Date(node.timestamp);
          attr.ctime = new Date(node.timestamp);
          // NOTE: In our implementation, st_blocks = Math.ceil(st_size/st_blksize),
          //       but this is not required by the standard.
          attr.blksize = 4096;
          attr.blocks = Math.ceil(attr.size / attr.blksize);
          return attr;
        },setattr:function (node, attr) {
          if (attr.mode !== undefined) {
            node.mode = attr.mode;
          }
          if (attr.timestamp !== undefined) {
            node.timestamp = attr.timestamp;
          }
          if (attr.size !== undefined) {
            MEMFS.ensureFlexible(node);
            var contents = node.contents;
            if (attr.size < contents.length) contents.length = attr.size;
            else while (attr.size > contents.length) contents.push(0);
          }
        },lookup:function (parent, name) {
          throw FS.genericErrors[ERRNO_CODES.ENOENT];
        },mknod:function (parent, name, mode, dev) {
          return MEMFS.createNode(parent, name, mode, dev);
        },rename:function (old_node, new_dir, new_name) {
          // if we're overwriting a directory at new_name, make sure it's empty.
          if (FS.isDir(old_node.mode)) {
            var new_node;
            try {
              new_node = FS.lookupNode(new_dir, new_name);
            } catch (e) {
            }
            if (new_node) {
              for (var i in new_node.contents) {
                throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
              }
            }
          }
          // do the internal rewiring
          delete old_node.parent.contents[old_node.name];
          old_node.name = new_name;
          new_dir.contents[new_name] = old_node;
          old_node.parent = new_dir;
        },unlink:function (parent, name) {
          delete parent.contents[name];
        },rmdir:function (parent, name) {
          var node = FS.lookupNode(parent, name);
          for (var i in node.contents) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
          }
          delete parent.contents[name];
        },readdir:function (node) {
          var entries = ['.', '..']
          for (var key in node.contents) {
            if (!node.contents.hasOwnProperty(key)) {
              continue;
            }
            entries.push(key);
          }
          return entries;
        },symlink:function (parent, newname, oldpath) {
          var node = MEMFS.createNode(parent, newname, 511 /* 0777 */ | 40960, 0);
          node.link = oldpath;
          return node;
        },readlink:function (node) {
          if (!FS.isLink(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          return node.link;
        }},stream_ops:{read:function (stream, buffer, offset, length, position) {
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (size > 8 && contents.subarray) { // non-trivial, and typed array
            buffer.set(contents.subarray(position, position + size), offset);
          } else
          {
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          }
          return size;
        },write:function (stream, buffer, offset, length, position, canOwn) {
          var node = stream.node;
          node.timestamp = Date.now();
          var contents = node.contents;
          if (length && contents.length === 0 && position === 0 && buffer.subarray) {
            // just replace it with the new data
            if (canOwn && offset === 0) {
              node.contents = buffer; // this could be a subarray of Emscripten HEAP, or allocated from some other source.
              node.contentMode = (buffer.buffer === HEAP8.buffer) ? MEMFS.CONTENT_OWNING : MEMFS.CONTENT_FIXED;
            } else {
              node.contents = new Uint8Array(buffer.subarray(offset, offset+length));
              node.contentMode = MEMFS.CONTENT_FIXED;
            }
            return length;
          }
          MEMFS.ensureFlexible(node);
          var contents = node.contents;
          while (contents.length < position) contents.push(0);
          for (var i = 0; i < length; i++) {
            contents[position + i] = buffer[offset + i];
          }
          return length;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              position += stream.node.contents.length;
            }
          }
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          stream.ungotten = [];
          stream.position = position;
          return position;
        },allocate:function (stream, offset, length) {
          MEMFS.ensureFlexible(stream.node);
          var contents = stream.node.contents;
          var limit = offset + length;
          while (limit > contents.length) contents.push(0);
        },mmap:function (stream, buffer, offset, length, position, prot, flags) {
          if (!FS.isFile(stream.node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          var ptr;
          var allocated;
          var contents = stream.node.contents;
          // Only make a new copy when MAP_PRIVATE is specified.
          if ( !(flags & 2) &&
                (contents.buffer === buffer || contents.buffer === buffer.buffer) ) {
            // We can't emulate MAP_SHARED when the file is not backed by the buffer
            // we're mapping to (e.g. the HEAP buffer).
            allocated = false;
            ptr = contents.byteOffset;
          } else {
            // Try to avoid unnecessary slices.
            if (position > 0 || position + length < contents.length) {
              if (contents.subarray) {
                contents = contents.subarray(position, position + length);
              } else {
                contents = Array.prototype.slice.call(contents, position, position + length);
              }
            }
            allocated = true;
            ptr = _malloc(length);
            if (!ptr) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOMEM);
            }
            buffer.set(contents, ptr);
          }
          return { ptr: ptr, allocated: allocated };
        }}};
  
  var IDBFS={dbs:{},indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_VERSION:21,DB_STORE_NAME:"FILE_DATA",mount:function (mount) {
        // reuse all of the core MEMFS functionality
        return MEMFS.mount.apply(null, arguments);
      },syncfs:function (mount, populate, callback) {
        IDBFS.getLocalSet(mount, function(err, local) {
          if (err) return callback(err);
  
          IDBFS.getRemoteSet(mount, function(err, remote) {
            if (err) return callback(err);
  
            var src = populate ? remote : local;
            var dst = populate ? local : remote;
  
            IDBFS.reconcile(src, dst, callback);
          });
        });
      },getDB:function (name, callback) {
        // check the cache first
        var db = IDBFS.dbs[name];
        if (db) {
          return callback(null, db);
        }
  
        var req;
        try {
          req = IDBFS.indexedDB().open(name, IDBFS.DB_VERSION);
        } catch (e) {
          return callback(e);
        }
        req.onupgradeneeded = function(e) {
          var db = e.target.result;
          var transaction = e.target.transaction;
  
          var fileStore;
  
          if (db.objectStoreNames.contains(IDBFS.DB_STORE_NAME)) {
            fileStore = transaction.objectStore(IDBFS.DB_STORE_NAME);
          } else {
            fileStore = db.createObjectStore(IDBFS.DB_STORE_NAME);
          }
  
          fileStore.createIndex('timestamp', 'timestamp', { unique: false });
        };
        req.onsuccess = function() {
          db = req.result;
  
          // add to the cache
          IDBFS.dbs[name] = db;
          callback(null, db);
        };
        req.onerror = function() {
          callback(this.error);
        };
      },getLocalSet:function (mount, callback) {
        var entries = {};
  
        function isRealDir(p) {
          return p !== '.' && p !== '..';
        };
        function toAbsolute(root) {
          return function(p) {
            return PATH.join2(root, p);
          }
        };
  
        var check = FS.readdir(mount.mountpoint).filter(isRealDir).map(toAbsolute(mount.mountpoint));
  
        while (check.length) {
          var path = check.pop();
          var stat;
  
          try {
            stat = FS.stat(path);
          } catch (e) {
            return callback(e);
          }
  
          if (FS.isDir(stat.mode)) {
            check.push.apply(check, FS.readdir(path).filter(isRealDir).map(toAbsolute(path)));
          }
  
          entries[path] = { timestamp: stat.mtime };
        }
  
        return callback(null, { type: 'local', entries: entries });
      },getRemoteSet:function (mount, callback) {
        var entries = {};
  
        IDBFS.getDB(mount.mountpoint, function(err, db) {
          if (err) return callback(err);
  
          var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readonly');
          transaction.onerror = function() { callback(this.error); };
  
          var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
          var index = store.index('timestamp');
  
          index.openKeyCursor().onsuccess = function(event) {
            var cursor = event.target.result;
  
            if (!cursor) {
              return callback(null, { type: 'remote', db: db, entries: entries });
            }
  
            entries[cursor.primaryKey] = { timestamp: cursor.key };
  
            cursor.continue();
          };
        });
      },loadLocalEntry:function (path, callback) {
        var stat, node;
  
        try {
          var lookup = FS.lookupPath(path);
          node = lookup.node;
          stat = FS.stat(path);
        } catch (e) {
          return callback(e);
        }
  
        if (FS.isDir(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode });
        } else if (FS.isFile(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode, contents: node.contents });
        } else {
          return callback(new Error('node type not supported'));
        }
      },storeLocalEntry:function (path, entry, callback) {
        try {
          if (FS.isDir(entry.mode)) {
            FS.mkdir(path, entry.mode);
          } else if (FS.isFile(entry.mode)) {
            FS.writeFile(path, entry.contents, { encoding: 'binary', canOwn: true });
          } else {
            return callback(new Error('node type not supported'));
          }
  
          FS.utime(path, entry.timestamp, entry.timestamp);
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },removeLocalEntry:function (path, callback) {
        try {
          var lookup = FS.lookupPath(path);
          var stat = FS.stat(path);
  
          if (FS.isDir(stat.mode)) {
            FS.rmdir(path);
          } else if (FS.isFile(stat.mode)) {
            FS.unlink(path);
          }
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },loadRemoteEntry:function (store, path, callback) {
        var req = store.get(path);
        req.onsuccess = function(event) { callback(null, event.target.result); };
        req.onerror = function() { callback(this.error); };
      },storeRemoteEntry:function (store, path, entry, callback) {
        var req = store.put(entry, path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },removeRemoteEntry:function (store, path, callback) {
        var req = store.delete(path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },reconcile:function (src, dst, callback) {
        var total = 0;
  
        var create = [];
        Object.keys(src.entries).forEach(function (key) {
          var e = src.entries[key];
          var e2 = dst.entries[key];
          if (!e2 || e.timestamp > e2.timestamp) {
            create.push(key);
            total++;
          }
        });
  
        var remove = [];
        Object.keys(dst.entries).forEach(function (key) {
          var e = dst.entries[key];
          var e2 = src.entries[key];
          if (!e2) {
            remove.push(key);
            total++;
          }
        });
  
        if (!total) {
          return callback(null);
        }
  
        var errored = false;
        var completed = 0;
        var db = src.type === 'remote' ? src.db : dst.db;
        var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readwrite');
        var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= total) {
            return callback(null);
          }
        };
  
        transaction.onerror = function() { done(this.error); };
  
        // sort paths in ascending order so directory entries are created
        // before the files inside them
        create.sort().forEach(function (path) {
          if (dst.type === 'local') {
            IDBFS.loadRemoteEntry(store, path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeLocalEntry(path, entry, done);
            });
          } else {
            IDBFS.loadLocalEntry(path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeRemoteEntry(store, path, entry, done);
            });
          }
        });
  
        // sort paths in descending order so files are deleted before their
        // parent directories
        remove.sort().reverse().forEach(function(path) {
          if (dst.type === 'local') {
            IDBFS.removeLocalEntry(path, done);
          } else {
            IDBFS.removeRemoteEntry(store, path, done);
          }
        });
      }};
  
  var NODEFS={isWindows:false,staticInit:function () {
        NODEFS.isWindows = !!process.platform.match(/^win/);
      },mount:function (mount) {
        assert(ENVIRONMENT_IS_NODE);
        return NODEFS.createNode(null, '/', NODEFS.getMode(mount.opts.root), 0);
      },createNode:function (parent, name, mode, dev) {
        if (!FS.isDir(mode) && !FS.isFile(mode) && !FS.isLink(mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node = FS.createNode(parent, name, mode);
        node.node_ops = NODEFS.node_ops;
        node.stream_ops = NODEFS.stream_ops;
        return node;
      },getMode:function (path) {
        var stat;
        try {
          stat = fs.lstatSync(path);
          if (NODEFS.isWindows) {
            // On Windows, directories return permission bits 'rw-rw-rw-', even though they have 'rwxrwxrwx', so 
            // propagate write bits to execute bits.
            stat.mode = stat.mode | ((stat.mode & 146) >> 1);
          }
        } catch (e) {
          if (!e.code) throw e;
          throw new FS.ErrnoError(ERRNO_CODES[e.code]);
        }
        return stat.mode;
      },realPath:function (node) {
        var parts = [];
        while (node.parent !== node) {
          parts.push(node.name);
          node = node.parent;
        }
        parts.push(node.mount.opts.root);
        parts.reverse();
        return PATH.join.apply(null, parts);
      },flagsToPermissionStringMap:{0:"r",1:"r+",2:"r+",64:"r",65:"r+",66:"r+",129:"rx+",193:"rx+",514:"w+",577:"w",578:"w+",705:"wx",706:"wx+",1024:"a",1025:"a",1026:"a+",1089:"a",1090:"a+",1153:"ax",1154:"ax+",1217:"ax",1218:"ax+",4096:"rs",4098:"rs+"},flagsToPermissionString:function (flags) {
        if (flags in NODEFS.flagsToPermissionStringMap) {
          return NODEFS.flagsToPermissionStringMap[flags];
        } else {
          return flags;
        }
      },node_ops:{getattr:function (node) {
          var path = NODEFS.realPath(node);
          var stat;
          try {
            stat = fs.lstatSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          // node.js v0.10.20 doesn't report blksize and blocks on Windows. Fake them with default blksize of 4096.
          // See http://support.microsoft.com/kb/140365
          if (NODEFS.isWindows && !stat.blksize) {
            stat.blksize = 4096;
          }
          if (NODEFS.isWindows && !stat.blocks) {
            stat.blocks = (stat.size+stat.blksize-1)/stat.blksize|0;
          }
          return {
            dev: stat.dev,
            ino: stat.ino,
            mode: stat.mode,
            nlink: stat.nlink,
            uid: stat.uid,
            gid: stat.gid,
            rdev: stat.rdev,
            size: stat.size,
            atime: stat.atime,
            mtime: stat.mtime,
            ctime: stat.ctime,
            blksize: stat.blksize,
            blocks: stat.blocks
          };
        },setattr:function (node, attr) {
          var path = NODEFS.realPath(node);
          try {
            if (attr.mode !== undefined) {
              fs.chmodSync(path, attr.mode);
              // update the common node structure mode as well
              node.mode = attr.mode;
            }
            if (attr.timestamp !== undefined) {
              var date = new Date(attr.timestamp);
              fs.utimesSync(path, date, date);
            }
            if (attr.size !== undefined) {
              fs.truncateSync(path, attr.size);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },lookup:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          var mode = NODEFS.getMode(path);
          return NODEFS.createNode(parent, name, mode);
        },mknod:function (parent, name, mode, dev) {
          var node = NODEFS.createNode(parent, name, mode, dev);
          // create the backing node for this in the fs root as well
          var path = NODEFS.realPath(node);
          try {
            if (FS.isDir(node.mode)) {
              fs.mkdirSync(path, node.mode);
            } else {
              fs.writeFileSync(path, '', { mode: node.mode });
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return node;
        },rename:function (oldNode, newDir, newName) {
          var oldPath = NODEFS.realPath(oldNode);
          var newPath = PATH.join2(NODEFS.realPath(newDir), newName);
          try {
            fs.renameSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },unlink:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.unlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },rmdir:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.rmdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readdir:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },symlink:function (parent, newName, oldPath) {
          var newPath = PATH.join2(NODEFS.realPath(parent), newName);
          try {
            fs.symlinkSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readlink:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        }},stream_ops:{open:function (stream) {
          var path = NODEFS.realPath(stream.node);
          try {
            if (FS.isFile(stream.node.mode)) {
              stream.nfd = fs.openSync(path, NODEFS.flagsToPermissionString(stream.flags));
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },close:function (stream) {
          try {
            if (FS.isFile(stream.node.mode) && stream.nfd) {
              fs.closeSync(stream.nfd);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },read:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(length);
          var res;
          try {
            res = fs.readSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          if (res > 0) {
            for (var i = 0; i < res; i++) {
              buffer[offset + i] = nbuffer[i];
            }
          }
          return res;
        },write:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(buffer.subarray(offset, offset + length));
          var res;
          try {
            res = fs.writeSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return res;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              try {
                var stat = fs.fstatSync(stream.nfd);
                position += stat.size;
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES[e.code]);
              }
            }
          }
  
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
  
          stream.position = position;
          return position;
        }}};
  
  var _stdin=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stdout=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stderr=allocate(1, "i32*", ALLOC_STATIC);
  
  function _fflush(stream) {
      // int fflush(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fflush.html
      // we don't currently perform any user-space buffering of data
    }var FS={root:null,mounts:[],devices:[null],streams:[],nextInode:1,nameTable:null,currentPath:"/",initialized:false,ignorePermissions:true,ErrnoError:null,genericErrors:{},handleFSError:function (e) {
        if (!(e instanceof FS.ErrnoError)) throw e + ' : ' + stackTrace();
        return ___setErrNo(e.errno);
      },lookupPath:function (path, opts) {
        path = PATH.resolve(FS.cwd(), path);
        opts = opts || {};
  
        var defaults = {
          follow_mount: true,
          recurse_count: 0
        };
        for (var key in defaults) {
          if (opts[key] === undefined) {
            opts[key] = defaults[key];
          }
        }
  
        if (opts.recurse_count > 8) {  // max recursive lookup of 8
          throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
        }
  
        // split the path
        var parts = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), false);
  
        // start at the root
        var current = FS.root;
        var current_path = '/';
  
        for (var i = 0; i < parts.length; i++) {
          var islast = (i === parts.length-1);
          if (islast && opts.parent) {
            // stop resolving
            break;
          }
  
          current = FS.lookupNode(current, parts[i]);
          current_path = PATH.join2(current_path, parts[i]);
  
          // jump to the mount's root node if this is a mountpoint
          if (FS.isMountpoint(current)) {
            if (!islast || (islast && opts.follow_mount)) {
              current = current.mounted.root;
            }
          }
  
          // by default, lookupPath will not follow a symlink if it is the final path component.
          // setting opts.follow = true will override this behavior.
          if (!islast || opts.follow) {
            var count = 0;
            while (FS.isLink(current.mode)) {
              var link = FS.readlink(current_path);
              current_path = PATH.resolve(PATH.dirname(current_path), link);
              
              var lookup = FS.lookupPath(current_path, { recurse_count: opts.recurse_count });
              current = lookup.node;
  
              if (count++ > 40) {  // limit max consecutive symlinks to 40 (SYMLOOP_MAX).
                throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
              }
            }
          }
        }
  
        return { path: current_path, node: current };
      },getPath:function (node) {
        var path;
        while (true) {
          if (FS.isRoot(node)) {
            var mount = node.mount.mountpoint;
            if (!path) return mount;
            return mount[mount.length-1] !== '/' ? mount + '/' + path : mount + path;
          }
          path = path ? node.name + '/' + path : node.name;
          node = node.parent;
        }
      },hashName:function (parentid, name) {
        var hash = 0;
  
  
        for (var i = 0; i < name.length; i++) {
          hash = ((hash << 5) - hash + name.charCodeAt(i)) | 0;
        }
        return ((parentid + hash) >>> 0) % FS.nameTable.length;
      },hashAddNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        node.name_next = FS.nameTable[hash];
        FS.nameTable[hash] = node;
      },hashRemoveNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        if (FS.nameTable[hash] === node) {
          FS.nameTable[hash] = node.name_next;
        } else {
          var current = FS.nameTable[hash];
          while (current) {
            if (current.name_next === node) {
              current.name_next = node.name_next;
              break;
            }
            current = current.name_next;
          }
        }
      },lookupNode:function (parent, name) {
        var err = FS.mayLookup(parent);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        var hash = FS.hashName(parent.id, name);
        for (var node = FS.nameTable[hash]; node; node = node.name_next) {
          var nodeName = node.name;
          if (node.parent.id === parent.id && nodeName === name) {
            return node;
          }
        }
        // if we failed to find it in the cache, call into the VFS
        return FS.lookup(parent, name);
      },createNode:function (parent, name, mode, rdev) {
        if (!FS.FSNode) {
          FS.FSNode = function(parent, name, mode, rdev) {
            if (!parent) {
              parent = this;  // root node sets parent to itself
            }
            this.parent = parent;
            this.mount = parent.mount;
            this.mounted = null;
            this.id = FS.nextInode++;
            this.name = name;
            this.mode = mode;
            this.node_ops = {};
            this.stream_ops = {};
            this.rdev = rdev;
          };
  
          FS.FSNode.prototype = {};
  
          // compatibility
          var readMode = 292 | 73;
          var writeMode = 146;
  
          // NOTE we must use Object.defineProperties instead of individual calls to
          // Object.defineProperty in order to make closure compiler happy
          Object.defineProperties(FS.FSNode.prototype, {
            read: {
              get: function() { return (this.mode & readMode) === readMode; },
              set: function(val) { val ? this.mode |= readMode : this.mode &= ~readMode; }
            },
            write: {
              get: function() { return (this.mode & writeMode) === writeMode; },
              set: function(val) { val ? this.mode |= writeMode : this.mode &= ~writeMode; }
            },
            isFolder: {
              get: function() { return FS.isDir(this.mode); },
            },
            isDevice: {
              get: function() { return FS.isChrdev(this.mode); },
            },
          });
        }
  
        var node = new FS.FSNode(parent, name, mode, rdev);
  
        FS.hashAddNode(node);
  
        return node;
      },destroyNode:function (node) {
        FS.hashRemoveNode(node);
      },isRoot:function (node) {
        return node === node.parent;
      },isMountpoint:function (node) {
        return !!node.mounted;
      },isFile:function (mode) {
        return (mode & 61440) === 32768;
      },isDir:function (mode) {
        return (mode & 61440) === 16384;
      },isLink:function (mode) {
        return (mode & 61440) === 40960;
      },isChrdev:function (mode) {
        return (mode & 61440) === 8192;
      },isBlkdev:function (mode) {
        return (mode & 61440) === 24576;
      },isFIFO:function (mode) {
        return (mode & 61440) === 4096;
      },isSocket:function (mode) {
        return (mode & 49152) === 49152;
      },flagModes:{"r":0,"rs":1052672,"r+":2,"w":577,"wx":705,"xw":705,"w+":578,"wx+":706,"xw+":706,"a":1089,"ax":1217,"xa":1217,"a+":1090,"ax+":1218,"xa+":1218},modeStringToFlags:function (str) {
        var flags = FS.flagModes[str];
        if (typeof flags === 'undefined') {
          throw new Error('Unknown file open mode: ' + str);
        }
        return flags;
      },flagsToPermissionString:function (flag) {
        var accmode = flag & 2097155;
        var perms = ['r', 'w', 'rw'][accmode];
        if ((flag & 512)) {
          perms += 'w';
        }
        return perms;
      },nodePermissions:function (node, perms) {
        if (FS.ignorePermissions) {
          return 0;
        }
        // return 0 if any user, group or owner bits are set.
        if (perms.indexOf('r') !== -1 && !(node.mode & 292)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('w') !== -1 && !(node.mode & 146)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('x') !== -1 && !(node.mode & 73)) {
          return ERRNO_CODES.EACCES;
        }
        return 0;
      },mayLookup:function (dir) {
        return FS.nodePermissions(dir, 'x');
      },mayCreate:function (dir, name) {
        try {
          var node = FS.lookupNode(dir, name);
          return ERRNO_CODES.EEXIST;
        } catch (e) {
        }
        return FS.nodePermissions(dir, 'wx');
      },mayDelete:function (dir, name, isdir) {
        var node;
        try {
          node = FS.lookupNode(dir, name);
        } catch (e) {
          return e.errno;
        }
        var err = FS.nodePermissions(dir, 'wx');
        if (err) {
          return err;
        }
        if (isdir) {
          if (!FS.isDir(node.mode)) {
            return ERRNO_CODES.ENOTDIR;
          }
          if (FS.isRoot(node) || FS.getPath(node) === FS.cwd()) {
            return ERRNO_CODES.EBUSY;
          }
        } else {
          if (FS.isDir(node.mode)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return 0;
      },mayOpen:function (node, flags) {
        if (!node) {
          return ERRNO_CODES.ENOENT;
        }
        if (FS.isLink(node.mode)) {
          return ERRNO_CODES.ELOOP;
        } else if (FS.isDir(node.mode)) {
          if ((flags & 2097155) !== 0 ||  // opening for write
              (flags & 512)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return FS.nodePermissions(node, FS.flagsToPermissionString(flags));
      },MAX_OPEN_FDS:4096,nextfd:function (fd_start, fd_end) {
        fd_start = fd_start || 0;
        fd_end = fd_end || FS.MAX_OPEN_FDS;
        for (var fd = fd_start; fd <= fd_end; fd++) {
          if (!FS.streams[fd]) {
            return fd;
          }
        }
        throw new FS.ErrnoError(ERRNO_CODES.EMFILE);
      },getStream:function (fd) {
        return FS.streams[fd];
      },createStream:function (stream, fd_start, fd_end) {
        if (!FS.FSStream) {
          FS.FSStream = function(){};
          FS.FSStream.prototype = {};
          // compatibility
          Object.defineProperties(FS.FSStream.prototype, {
            object: {
              get: function() { return this.node; },
              set: function(val) { this.node = val; }
            },
            isRead: {
              get: function() { return (this.flags & 2097155) !== 1; }
            },
            isWrite: {
              get: function() { return (this.flags & 2097155) !== 0; }
            },
            isAppend: {
              get: function() { return (this.flags & 1024); }
            }
          });
        }
        if (stream.__proto__) {
          // reuse the object
          stream.__proto__ = FS.FSStream.prototype;
        } else {
          var newStream = new FS.FSStream();
          for (var p in stream) {
            newStream[p] = stream[p];
          }
          stream = newStream;
        }
        var fd = FS.nextfd(fd_start, fd_end);
        stream.fd = fd;
        FS.streams[fd] = stream;
        return stream;
      },closeStream:function (fd) {
        FS.streams[fd] = null;
      },getStreamFromPtr:function (ptr) {
        return FS.streams[ptr - 1];
      },getPtrForStream:function (stream) {
        return stream ? stream.fd + 1 : 0;
      },chrdev_stream_ops:{open:function (stream) {
          var device = FS.getDevice(stream.node.rdev);
          // override node's stream ops with the device's
          stream.stream_ops = device.stream_ops;
          // forward the open call
          if (stream.stream_ops.open) {
            stream.stream_ops.open(stream);
          }
        },llseek:function () {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }},major:function (dev) {
        return ((dev) >> 8);
      },minor:function (dev) {
        return ((dev) & 0xff);
      },makedev:function (ma, mi) {
        return ((ma) << 8 | (mi));
      },registerDevice:function (dev, ops) {
        FS.devices[dev] = { stream_ops: ops };
      },getDevice:function (dev) {
        return FS.devices[dev];
      },getMounts:function (mount) {
        var mounts = [];
        var check = [mount];
  
        while (check.length) {
          var m = check.pop();
  
          mounts.push(m);
  
          check.push.apply(check, m.mounts);
        }
  
        return mounts;
      },syncfs:function (populate, callback) {
        if (typeof(populate) === 'function') {
          callback = populate;
          populate = false;
        }
  
        var mounts = FS.getMounts(FS.root.mount);
        var completed = 0;
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= mounts.length) {
            callback(null);
          }
        };
  
        // sync all mounts
        mounts.forEach(function (mount) {
          if (!mount.type.syncfs) {
            return done(null);
          }
          mount.type.syncfs(mount, populate, done);
        });
      },mount:function (type, opts, mountpoint) {
        var root = mountpoint === '/';
        var pseudo = !mountpoint;
        var node;
  
        if (root && FS.root) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        } else if (!root && !pseudo) {
          var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
          mountpoint = lookup.path;  // use the absolute path
          node = lookup.node;
  
          if (FS.isMountpoint(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
          }
  
          if (!FS.isDir(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
          }
        }
  
        var mount = {
          type: type,
          opts: opts,
          mountpoint: mountpoint,
          mounts: []
        };
  
        // create a root node for the fs
        var mountRoot = type.mount(mount);
        mountRoot.mount = mount;
        mount.root = mountRoot;
  
        if (root) {
          FS.root = mountRoot;
        } else if (node) {
          // set as a mountpoint
          node.mounted = mount;
  
          // add the new mount to the current mount's children
          if (node.mount) {
            node.mount.mounts.push(mount);
          }
        }
  
        return mountRoot;
      },unmount:function (mountpoint) {
        var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
        if (!FS.isMountpoint(lookup.node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
  
        // destroy the nodes for this mount, and all its child mounts
        var node = lookup.node;
        var mount = node.mounted;
        var mounts = FS.getMounts(mount);
  
        Object.keys(FS.nameTable).forEach(function (hash) {
          var current = FS.nameTable[hash];
  
          while (current) {
            var next = current.name_next;
  
            if (mounts.indexOf(current.mount) !== -1) {
              FS.destroyNode(current);
            }
  
            current = next;
          }
        });
  
        // no longer a mountpoint
        node.mounted = null;
  
        // remove this mount from the child mounts
        var idx = node.mount.mounts.indexOf(mount);
        assert(idx !== -1);
        node.mount.mounts.splice(idx, 1);
      },lookup:function (parent, name) {
        return parent.node_ops.lookup(parent, name);
      },mknod:function (path, mode, dev) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var err = FS.mayCreate(parent, name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.mknod) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.mknod(parent, name, mode, dev);
      },create:function (path, mode) {
        mode = mode !== undefined ? mode : 438 /* 0666 */;
        mode &= 4095;
        mode |= 32768;
        return FS.mknod(path, mode, 0);
      },mkdir:function (path, mode) {
        mode = mode !== undefined ? mode : 511 /* 0777 */;
        mode &= 511 | 512;
        mode |= 16384;
        return FS.mknod(path, mode, 0);
      },mkdev:function (path, mode, dev) {
        if (typeof(dev) === 'undefined') {
          dev = mode;
          mode = 438 /* 0666 */;
        }
        mode |= 8192;
        return FS.mknod(path, mode, dev);
      },symlink:function (oldpath, newpath) {
        var lookup = FS.lookupPath(newpath, { parent: true });
        var parent = lookup.node;
        var newname = PATH.basename(newpath);
        var err = FS.mayCreate(parent, newname);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.symlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.symlink(parent, newname, oldpath);
      },rename:function (old_path, new_path) {
        var old_dirname = PATH.dirname(old_path);
        var new_dirname = PATH.dirname(new_path);
        var old_name = PATH.basename(old_path);
        var new_name = PATH.basename(new_path);
        // parents must exist
        var lookup, old_dir, new_dir;
        try {
          lookup = FS.lookupPath(old_path, { parent: true });
          old_dir = lookup.node;
          lookup = FS.lookupPath(new_path, { parent: true });
          new_dir = lookup.node;
        } catch (e) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // need to be part of the same mount
        if (old_dir.mount !== new_dir.mount) {
          throw new FS.ErrnoError(ERRNO_CODES.EXDEV);
        }
        // source must exist
        var old_node = FS.lookupNode(old_dir, old_name);
        // old path should not be an ancestor of the new path
        var relative = PATH.relative(old_path, new_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        // new path should not be an ancestor of the old path
        relative = PATH.relative(new_path, old_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
        }
        // see if the new path already exists
        var new_node;
        try {
          new_node = FS.lookupNode(new_dir, new_name);
        } catch (e) {
          // not fatal
        }
        // early out if nothing needs to change
        if (old_node === new_node) {
          return;
        }
        // we'll need to delete the old entry
        var isdir = FS.isDir(old_node.mode);
        var err = FS.mayDelete(old_dir, old_name, isdir);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // need delete permissions if we'll be overwriting.
        // need create permissions if new doesn't already exist.
        err = new_node ?
          FS.mayDelete(new_dir, new_name, isdir) :
          FS.mayCreate(new_dir, new_name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!old_dir.node_ops.rename) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(old_node) || (new_node && FS.isMountpoint(new_node))) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // if we are going to change the parent, check write permissions
        if (new_dir !== old_dir) {
          err = FS.nodePermissions(old_dir, 'w');
          if (err) {
            throw new FS.ErrnoError(err);
          }
        }
        // remove the node from the lookup hash
        FS.hashRemoveNode(old_node);
        // do the underlying fs rename
        try {
          old_dir.node_ops.rename(old_node, new_dir, new_name);
        } catch (e) {
          throw e;
        } finally {
          // add the node back to the hash (in case node_ops.rename
          // changed its name)
          FS.hashAddNode(old_node);
        }
      },rmdir:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, true);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.rmdir) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.rmdir(parent, name);
        FS.destroyNode(node);
      },readdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        if (!node.node_ops.readdir) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        return node.node_ops.readdir(node);
      },unlink:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, false);
        if (err) {
          // POSIX says unlink should set EPERM, not EISDIR
          if (err === ERRNO_CODES.EISDIR) err = ERRNO_CODES.EPERM;
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.unlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.unlink(parent, name);
        FS.destroyNode(node);
      },readlink:function (path) {
        var lookup = FS.lookupPath(path);
        var link = lookup.node;
        if (!link.node_ops.readlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        return link.node_ops.readlink(link);
      },stat:function (path, dontFollow) {
        var lookup = FS.lookupPath(path, { follow: !dontFollow });
        var node = lookup.node;
        if (!node.node_ops.getattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return node.node_ops.getattr(node);
      },lstat:function (path) {
        return FS.stat(path, true);
      },chmod:function (path, mode, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          mode: (mode & 4095) | (node.mode & ~4095),
          timestamp: Date.now()
        });
      },lchmod:function (path, mode) {
        FS.chmod(path, mode, true);
      },fchmod:function (fd, mode) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chmod(stream.node, mode);
      },chown:function (path, uid, gid, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          timestamp: Date.now()
          // we ignore the uid / gid for now
        });
      },lchown:function (path, uid, gid) {
        FS.chown(path, uid, gid, true);
      },fchown:function (fd, uid, gid) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chown(stream.node, uid, gid);
      },truncate:function (path, len) {
        if (len < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: true });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!FS.isFile(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var err = FS.nodePermissions(node, 'w');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        node.node_ops.setattr(node, {
          size: len,
          timestamp: Date.now()
        });
      },ftruncate:function (fd, len) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        FS.truncate(stream.node, len);
      },utime:function (path, atime, mtime) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        node.node_ops.setattr(node, {
          timestamp: Math.max(atime, mtime)
        });
      },open:function (path, flags, mode, fd_start, fd_end) {
        flags = typeof flags === 'string' ? FS.modeStringToFlags(flags) : flags;
        mode = typeof mode === 'undefined' ? 438 /* 0666 */ : mode;
        if ((flags & 64)) {
          mode = (mode & 4095) | 32768;
        } else {
          mode = 0;
        }
        var node;
        if (typeof path === 'object') {
          node = path;
        } else {
          path = PATH.normalize(path);
          try {
            var lookup = FS.lookupPath(path, {
              follow: !(flags & 131072)
            });
            node = lookup.node;
          } catch (e) {
            // ignore
          }
        }
        // perhaps we need to create the node
        if ((flags & 64)) {
          if (node) {
            // if O_CREAT and O_EXCL are set, error out if the node already exists
            if ((flags & 128)) {
              throw new FS.ErrnoError(ERRNO_CODES.EEXIST);
            }
          } else {
            // node doesn't exist, try to create it
            node = FS.mknod(path, mode, 0);
          }
        }
        if (!node) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
        }
        // can't truncate a device
        if (FS.isChrdev(node.mode)) {
          flags &= ~512;
        }
        // check permissions
        var err = FS.mayOpen(node, flags);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // do truncation if necessary
        if ((flags & 512)) {
          FS.truncate(node, 0);
        }
        // we've already handled these, don't pass down to the underlying vfs
        flags &= ~(128 | 512);
  
        // register the stream with the filesystem
        var stream = FS.createStream({
          node: node,
          path: FS.getPath(node),  // we want the absolute path to the node
          flags: flags,
          seekable: true,
          position: 0,
          stream_ops: node.stream_ops,
          // used by the file family libc calls (fopen, fwrite, ferror, etc.)
          ungotten: [],
          error: false
        }, fd_start, fd_end);
        // call the new stream's open function
        if (stream.stream_ops.open) {
          stream.stream_ops.open(stream);
        }
        if (Module['logReadFiles'] && !(flags & 1)) {
          if (!FS.readFiles) FS.readFiles = {};
          if (!(path in FS.readFiles)) {
            FS.readFiles[path] = 1;
            Module['printErr']('read file: ' + path);
          }
        }
        return stream;
      },close:function (stream) {
        try {
          if (stream.stream_ops.close) {
            stream.stream_ops.close(stream);
          }
        } catch (e) {
          throw e;
        } finally {
          FS.closeStream(stream.fd);
        }
      },llseek:function (stream, offset, whence) {
        if (!stream.seekable || !stream.stream_ops.llseek) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        return stream.stream_ops.llseek(stream, offset, whence);
      },read:function (stream, buffer, offset, length, position) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.read) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        var bytesRead = stream.stream_ops.read(stream, buffer, offset, length, position);
        if (!seeking) stream.position += bytesRead;
        return bytesRead;
      },write:function (stream, buffer, offset, length, position, canOwn) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.write) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        if (stream.flags & 1024) {
          // seek to the end before writing in append mode
          FS.llseek(stream, 0, 2);
        }
        var bytesWritten = stream.stream_ops.write(stream, buffer, offset, length, position, canOwn);
        if (!seeking) stream.position += bytesWritten;
        return bytesWritten;
      },allocate:function (stream, offset, length) {
        if (offset < 0 || length <= 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (!FS.isFile(stream.node.mode) && !FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        if (!stream.stream_ops.allocate) {
          throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
        }
        stream.stream_ops.allocate(stream, offset, length);
      },mmap:function (stream, buffer, offset, length, position, prot, flags) {
        // TODO if PROT is PROT_WRITE, make sure we have write access
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EACCES);
        }
        if (!stream.stream_ops.mmap) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        return stream.stream_ops.mmap(stream, buffer, offset, length, position, prot, flags);
      },ioctl:function (stream, cmd, arg) {
        if (!stream.stream_ops.ioctl) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTTY);
        }
        return stream.stream_ops.ioctl(stream, cmd, arg);
      },readFile:function (path, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'r';
        opts.encoding = opts.encoding || 'binary';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var ret;
        var stream = FS.open(path, opts.flags);
        var stat = FS.stat(path);
        var length = stat.size;
        var buf = new Uint8Array(length);
        FS.read(stream, buf, 0, length, 0);
        if (opts.encoding === 'utf8') {
          ret = '';
          var utf8 = new Runtime.UTF8Processor();
          for (var i = 0; i < length; i++) {
            ret += utf8.processCChar(buf[i]);
          }
        } else if (opts.encoding === 'binary') {
          ret = buf;
        }
        FS.close(stream);
        return ret;
      },writeFile:function (path, data, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'w';
        opts.encoding = opts.encoding || 'utf8';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var stream = FS.open(path, opts.flags, opts.mode);
        if (opts.encoding === 'utf8') {
          var utf8 = new Runtime.UTF8Processor();
          var buf = new Uint8Array(utf8.processJSString(data));
          FS.write(stream, buf, 0, buf.length, 0, opts.canOwn);
        } else if (opts.encoding === 'binary') {
          FS.write(stream, data, 0, data.length, 0, opts.canOwn);
        }
        FS.close(stream);
      },cwd:function () {
        return FS.currentPath;
      },chdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        if (!FS.isDir(lookup.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        var err = FS.nodePermissions(lookup.node, 'x');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        FS.currentPath = lookup.path;
      },createDefaultDirectories:function () {
        FS.mkdir('/tmp');
      },createDefaultDevices:function () {
        // create /dev
        FS.mkdir('/dev');
        // setup /dev/null
        FS.registerDevice(FS.makedev(1, 3), {
          read: function() { return 0; },
          write: function() { return 0; }
        });
        FS.mkdev('/dev/null', FS.makedev(1, 3));
        // setup /dev/tty and /dev/tty1
        // stderr needs to print output using Module['printErr']
        // so we register a second tty just for it.
        TTY.register(FS.makedev(5, 0), TTY.default_tty_ops);
        TTY.register(FS.makedev(6, 0), TTY.default_tty1_ops);
        FS.mkdev('/dev/tty', FS.makedev(5, 0));
        FS.mkdev('/dev/tty1', FS.makedev(6, 0));
        // we're not going to emulate the actual shm device,
        // just create the tmp dirs that reside in it commonly
        FS.mkdir('/dev/shm');
        FS.mkdir('/dev/shm/tmp');
      },createStandardStreams:function () {
        // TODO deprecate the old functionality of a single
        // input / output callback and that utilizes FS.createDevice
        // and instead require a unique set of stream ops
  
        // by default, we symlink the standard streams to the
        // default tty devices. however, if the standard streams
        // have been overwritten we create a unique device for
        // them instead.
        if (Module['stdin']) {
          FS.createDevice('/dev', 'stdin', Module['stdin']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdin');
        }
        if (Module['stdout']) {
          FS.createDevice('/dev', 'stdout', null, Module['stdout']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdout');
        }
        if (Module['stderr']) {
          FS.createDevice('/dev', 'stderr', null, Module['stderr']);
        } else {
          FS.symlink('/dev/tty1', '/dev/stderr');
        }
  
        // open default streams for the stdin, stdout and stderr devices
        var stdin = FS.open('/dev/stdin', 'r');
        HEAP32[((_stdin)>>2)]=FS.getPtrForStream(stdin);
        assert(stdin.fd === 0, 'invalid handle for stdin (' + stdin.fd + ')');
  
        var stdout = FS.open('/dev/stdout', 'w');
        HEAP32[((_stdout)>>2)]=FS.getPtrForStream(stdout);
        assert(stdout.fd === 1, 'invalid handle for stdout (' + stdout.fd + ')');
  
        var stderr = FS.open('/dev/stderr', 'w');
        HEAP32[((_stderr)>>2)]=FS.getPtrForStream(stderr);
        assert(stderr.fd === 2, 'invalid handle for stderr (' + stderr.fd + ')');
      },ensureErrnoError:function () {
        if (FS.ErrnoError) return;
        FS.ErrnoError = function ErrnoError(errno) {
          this.errno = errno;
          for (var key in ERRNO_CODES) {
            if (ERRNO_CODES[key] === errno) {
              this.code = key;
              break;
            }
          }
          this.message = ERRNO_MESSAGES[errno];
        };
        FS.ErrnoError.prototype = new Error();
        FS.ErrnoError.prototype.constructor = FS.ErrnoError;
        // Some errors may happen quite a bit, to avoid overhead we reuse them (and suffer a lack of stack info)
        [ERRNO_CODES.ENOENT].forEach(function(code) {
          FS.genericErrors[code] = new FS.ErrnoError(code);
          FS.genericErrors[code].stack = '<generic error, no stack>';
        });
      },staticInit:function () {
        FS.ensureErrnoError();
  
        FS.nameTable = new Array(4096);
  
        FS.mount(MEMFS, {}, '/');
  
        FS.createDefaultDirectories();
        FS.createDefaultDevices();
      },init:function (input, output, error) {
        assert(!FS.init.initialized, 'FS.init was previously called. If you want to initialize later with custom parameters, remove any earlier calls (note that one is automatically added to the generated code)');
        FS.init.initialized = true;
  
        FS.ensureErrnoError();
  
        // Allow Module.stdin etc. to provide defaults, if none explicitly passed to us here
        Module['stdin'] = input || Module['stdin'];
        Module['stdout'] = output || Module['stdout'];
        Module['stderr'] = error || Module['stderr'];
  
        FS.createStandardStreams();
      },quit:function () {
        FS.init.initialized = false;
        for (var i = 0; i < FS.streams.length; i++) {
          var stream = FS.streams[i];
          if (!stream) {
            continue;
          }
          FS.close(stream);
        }
      },getMode:function (canRead, canWrite) {
        var mode = 0;
        if (canRead) mode |= 292 | 73;
        if (canWrite) mode |= 146;
        return mode;
      },joinPath:function (parts, forceRelative) {
        var path = PATH.join.apply(null, parts);
        if (forceRelative && path[0] == '/') path = path.substr(1);
        return path;
      },absolutePath:function (relative, base) {
        return PATH.resolve(base, relative);
      },standardizePath:function (path) {
        return PATH.normalize(path);
      },findObject:function (path, dontResolveLastLink) {
        var ret = FS.analyzePath(path, dontResolveLastLink);
        if (ret.exists) {
          return ret.object;
        } else {
          ___setErrNo(ret.error);
          return null;
        }
      },analyzePath:function (path, dontResolveLastLink) {
        // operate from within the context of the symlink's target
        try {
          var lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          path = lookup.path;
        } catch (e) {
        }
        var ret = {
          isRoot: false, exists: false, error: 0, name: null, path: null, object: null,
          parentExists: false, parentPath: null, parentObject: null
        };
        try {
          var lookup = FS.lookupPath(path, { parent: true });
          ret.parentExists = true;
          ret.parentPath = lookup.path;
          ret.parentObject = lookup.node;
          ret.name = PATH.basename(path);
          lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          ret.exists = true;
          ret.path = lookup.path;
          ret.object = lookup.node;
          ret.name = lookup.node.name;
          ret.isRoot = lookup.path === '/';
        } catch (e) {
          ret.error = e.errno;
        };
        return ret;
      },createFolder:function (parent, name, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.mkdir(path, mode);
      },createPath:function (parent, path, canRead, canWrite) {
        parent = typeof parent === 'string' ? parent : FS.getPath(parent);
        var parts = path.split('/').reverse();
        while (parts.length) {
          var part = parts.pop();
          if (!part) continue;
          var current = PATH.join2(parent, part);
          try {
            FS.mkdir(current);
          } catch (e) {
            // ignore EEXIST
          }
          parent = current;
        }
        return current;
      },createFile:function (parent, name, properties, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.create(path, mode);
      },createDataFile:function (parent, name, data, canRead, canWrite, canOwn) {
        var path = name ? PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name) : parent;
        var mode = FS.getMode(canRead, canWrite);
        var node = FS.create(path, mode);
        if (data) {
          if (typeof data === 'string') {
            var arr = new Array(data.length);
            for (var i = 0, len = data.length; i < len; ++i) arr[i] = data.charCodeAt(i);
            data = arr;
          }
          // make sure we can write to the file
          FS.chmod(node, mode | 146);
          var stream = FS.open(node, 'w');
          FS.write(stream, data, 0, data.length, 0, canOwn);
          FS.close(stream);
          FS.chmod(node, mode);
        }
        return node;
      },createDevice:function (parent, name, input, output) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(!!input, !!output);
        if (!FS.createDevice.major) FS.createDevice.major = 64;
        var dev = FS.makedev(FS.createDevice.major++, 0);
        // Create a fake device that a set of stream ops to emulate
        // the old behavior.
        FS.registerDevice(dev, {
          open: function(stream) {
            stream.seekable = false;
          },
          close: function(stream) {
            // flush any pending line data
            if (output && output.buffer && output.buffer.length) {
              output(10);
            }
          },
          read: function(stream, buffer, offset, length, pos /* ignored */) {
            var bytesRead = 0;
            for (var i = 0; i < length; i++) {
              var result;
              try {
                result = input();
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
              if (result === undefined && bytesRead === 0) {
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
              if (result === null || result === undefined) break;
              bytesRead++;
              buffer[offset+i] = result;
            }
            if (bytesRead) {
              stream.node.timestamp = Date.now();
            }
            return bytesRead;
          },
          write: function(stream, buffer, offset, length, pos) {
            for (var i = 0; i < length; i++) {
              try {
                output(buffer[offset+i]);
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
            }
            if (length) {
              stream.node.timestamp = Date.now();
            }
            return i;
          }
        });
        return FS.mkdev(path, mode, dev);
      },createLink:function (parent, name, target, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        return FS.symlink(target, path);
      },forceLoadFile:function (obj) {
        if (obj.isDevice || obj.isFolder || obj.link || obj.contents) return true;
        var success = true;
        if (typeof XMLHttpRequest !== 'undefined') {
          throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.");
        } else if (Module['read']) {
          // Command-line.
          try {
            // WARNING: Can't read binary files in V8's d8 or tracemonkey's js, as
            //          read() will try to parse UTF8.
            obj.contents = intArrayFromString(Module['read'](obj.url), true);
          } catch (e) {
            success = false;
          }
        } else {
          throw new Error('Cannot load without read() or XMLHttpRequest.');
        }
        if (!success) ___setErrNo(ERRNO_CODES.EIO);
        return success;
      },createLazyFile:function (parent, name, url, canRead, canWrite) {
        if (typeof XMLHttpRequest !== 'undefined') {
          if (!ENVIRONMENT_IS_WORKER) throw 'Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc';
          // Lazy chunked Uint8Array (implements get and length from Uint8Array). Actual getting is abstracted away for eventual reuse.
          function LazyUint8Array() {
            this.lengthKnown = false;
            this.chunks = []; // Loaded chunks. Index is the chunk number
          }
          LazyUint8Array.prototype.get = function LazyUint8Array_get(idx) {
            if (idx > this.length-1 || idx < 0) {
              return undefined;
            }
            var chunkOffset = idx % this.chunkSize;
            var chunkNum = Math.floor(idx / this.chunkSize);
            return this.getter(chunkNum)[chunkOffset];
          }
          LazyUint8Array.prototype.setDataGetter = function LazyUint8Array_setDataGetter(getter) {
            this.getter = getter;
          }
          LazyUint8Array.prototype.cacheLength = function LazyUint8Array_cacheLength() {
              // Find length
              var xhr = new XMLHttpRequest();
              xhr.open('HEAD', url, false);
              xhr.send(null);
              if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
              var datalength = Number(xhr.getResponseHeader("Content-length"));
              var header;
              var hasByteServing = (header = xhr.getResponseHeader("Accept-Ranges")) && header === "bytes";
              var chunkSize = 1024*1024; // Chunk size in bytes
  
              if (!hasByteServing) chunkSize = datalength;
  
              // Function to get a range from the remote URL.
              var doXHR = (function(from, to) {
                if (from > to) throw new Error("invalid range (" + from + ", " + to + ") or no bytes requested!");
                if (to > datalength-1) throw new Error("only " + datalength + " bytes available! programmer error!");
  
                // TODO: Use mozResponseArrayBuffer, responseStream, etc. if available.
                var xhr = new XMLHttpRequest();
                xhr.open('GET', url, false);
                if (datalength !== chunkSize) xhr.setRequestHeader("Range", "bytes=" + from + "-" + to);
  
                // Some hints to the browser that we want binary data.
                if (typeof Uint8Array != 'undefined') xhr.responseType = 'arraybuffer';
                if (xhr.overrideMimeType) {
                  xhr.overrideMimeType('text/plain; charset=x-user-defined');
                }
  
                xhr.send(null);
                if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
                if (xhr.response !== undefined) {
                  return new Uint8Array(xhr.response || []);
                } else {
                  return intArrayFromString(xhr.responseText || '', true);
                }
              });
              var lazyArray = this;
              lazyArray.setDataGetter(function(chunkNum) {
                var start = chunkNum * chunkSize;
                var end = (chunkNum+1) * chunkSize - 1; // including this byte
                end = Math.min(end, datalength-1); // if datalength-1 is selected, this is the last block
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") {
                  lazyArray.chunks[chunkNum] = doXHR(start, end);
                }
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") throw new Error("doXHR failed!");
                return lazyArray.chunks[chunkNum];
              });
  
              this._length = datalength;
              this._chunkSize = chunkSize;
              this.lengthKnown = true;
          }
  
          var lazyArray = new LazyUint8Array();
          Object.defineProperty(lazyArray, "length", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._length;
              }
          });
          Object.defineProperty(lazyArray, "chunkSize", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._chunkSize;
              }
          });
  
          var properties = { isDevice: false, contents: lazyArray };
        } else {
          var properties = { isDevice: false, url: url };
        }
  
        var node = FS.createFile(parent, name, properties, canRead, canWrite);
        // This is a total hack, but I want to get this lazy file code out of the
        // core of MEMFS. If we want to keep this lazy file concept I feel it should
        // be its own thin LAZYFS proxying calls to MEMFS.
        if (properties.contents) {
          node.contents = properties.contents;
        } else if (properties.url) {
          node.contents = null;
          node.url = properties.url;
        }
        // override each stream op with one that tries to force load the lazy file first
        var stream_ops = {};
        var keys = Object.keys(node.stream_ops);
        keys.forEach(function(key) {
          var fn = node.stream_ops[key];
          stream_ops[key] = function forceLoadLazyFile() {
            if (!FS.forceLoadFile(node)) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            return fn.apply(null, arguments);
          };
        });
        // use a custom read function
        stream_ops.read = function stream_ops_read(stream, buffer, offset, length, position) {
          if (!FS.forceLoadFile(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EIO);
          }
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (contents.slice) { // normal array
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          } else {
            for (var i = 0; i < size; i++) { // LazyUint8Array from sync binary XHR
              buffer[offset + i] = contents.get(position + i);
            }
          }
          return size;
        };
        node.stream_ops = stream_ops;
        return node;
      },createPreloadedFile:function (parent, name, url, canRead, canWrite, onload, onerror, dontCreateFile, canOwn) {
        Browser.init();
        // TODO we should allow people to just pass in a complete filename instead
        // of parent and name being that we just join them anyways
        var fullname = name ? PATH.resolve(PATH.join2(parent, name)) : parent;
        function processData(byteArray) {
          function finish(byteArray) {
            if (!dontCreateFile) {
              FS.createDataFile(parent, name, byteArray, canRead, canWrite, canOwn);
            }
            if (onload) onload();
            removeRunDependency('cp ' + fullname);
          }
          var handled = false;
          Module['preloadPlugins'].forEach(function(plugin) {
            if (handled) return;
            if (plugin['canHandle'](fullname)) {
              plugin['handle'](byteArray, fullname, finish, function() {
                if (onerror) onerror();
                removeRunDependency('cp ' + fullname);
              });
              handled = true;
            }
          });
          if (!handled) finish(byteArray);
        }
        addRunDependency('cp ' + fullname);
        if (typeof url == 'string') {
          Browser.asyncLoad(url, function(byteArray) {
            processData(byteArray);
          }, onerror);
        } else {
          processData(url);
        }
      },indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_NAME:function () {
        return 'EM_FS_' + window.location.pathname;
      },DB_VERSION:20,DB_STORE_NAME:"FILE_DATA",saveFilesToDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = function openRequest_onupgradeneeded() {
          console.log('creating db');
          var db = openRequest.result;
          db.createObjectStore(FS.DB_STORE_NAME);
        };
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          var transaction = db.transaction([FS.DB_STORE_NAME], 'readwrite');
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var putRequest = files.put(FS.analyzePath(path).object.contents, path);
            putRequest.onsuccess = function putRequest_onsuccess() { ok++; if (ok + fail == total) finish() };
            putRequest.onerror = function putRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      },loadFilesFromDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = onerror; // no database to load from
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          try {
            var transaction = db.transaction([FS.DB_STORE_NAME], 'readonly');
          } catch(e) {
            onerror(e);
            return;
          }
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var getRequest = files.get(path);
            getRequest.onsuccess = function getRequest_onsuccess() {
              if (FS.analyzePath(path).exists) {
                FS.unlink(path);
              }
              FS.createDataFile(PATH.dirname(path), PATH.basename(path), getRequest.result, true, true, true);
              ok++;
              if (ok + fail == total) finish();
            };
            getRequest.onerror = function getRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      }};
  
  function _lseek(fildes, offset, whence) {
      // off_t lseek(int fildes, off_t offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/lseek.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        return FS.llseek(stream, offset, whence);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fileno(stream) {
      // int fileno(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fileno.html
      return FS.getStreamFromPtr(stream).fd;
    }function _fseek(stream, offset, whence) {
      // int fseek(FILE *stream, long offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fseek.html
      var fd = _fileno(stream);
      var ret = _lseek(fd, offset, whence);
      if (ret == -1) {
        return -1;
      }
      stream = FS.getStreamFromPtr(stream);
      stream.eof = false;
      return 0;
    }

  
  function _close(fildes) {
      // int close(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/close.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        FS.close(stream);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fsync(fildes) {
      // int fsync(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fsync.html
      var stream = FS.getStream(fildes);
      if (stream) {
        // We write directly to the file system, so there's nothing to do here.
        return 0;
      } else {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
    }function _fclose(stream) {
      // int fclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fclose.html
      var fd = _fileno(stream);
      _fsync(fd);
      return _close(fd);
    }

  function _pthread_mutex_lock() {}

  
  
  function _isspace(chr) {
      return (chr == 32) || (chr >= 9 && chr <= 13);
    }
  function __parseInt64(str, endptr, base, min, max, unsign) {
      var isNegative = false;
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      if (HEAP8[(str)] == 45) {
        str++;
        isNegative = true;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var ok = false;
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            ok = true; // we saw an initial zero, perhaps the entire thing is just "0"
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
      var start = str;
  
      // Get digits.
      var chr;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          str++;
          ok = true;
        }
      }
  
      if (!ok) {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return ((asm["setTempRet0"](0),0)|0);
      }
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      try {
        var numberString = isNegative ? '-'+Pointer_stringify(start, str - start) : Pointer_stringify(start, str - start);
        i64Math.fromString(numberString, finalBase, min, max, unsign);
      } catch(e) {
        ___setErrNo(ERRNO_CODES.ERANGE); // not quite correct
      }
  
      return ((asm["setTempRet0"](((HEAP32[(((tempDoublePtr)+(4))>>2)])|0)),((HEAP32[((tempDoublePtr)>>2)])|0))|0);
    }function _strtoull(str, endptr, base) {
      return __parseInt64(str, endptr, base, 0, '18446744073709551615', true);  // ULONG_MAX.
    }


  function _lis_solver_create() {
  Module['printErr']('missing function: lis_solver_create'); abort(-1);
  }

  var _emscripten_check_longjmp=true;

  
  function __parseInt(str, endptr, base, min, max, bits, unsign) {
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      var multiplier = 1;
      if (HEAP8[(str)] == 45) {
        multiplier = -1;
        str++;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            str++;
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
  
      // Get digits.
      var chr;
      var ret = 0;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          ret = ret * finalBase + digit;
          str++;
        }
      }
  
      // Apply sign.
      ret *= multiplier;
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      // Unsign if needed.
      if (unsign) {
        if (Math.abs(ret) > max) {
          ret = max;
          ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          ret = unSign(ret, bits);
        }
      }
  
      // Validate range.
      if (ret > max || ret < min) {
        ret = ret > max ? max : min;
        ___setErrNo(ERRNO_CODES.ERANGE);
      }
  
      if (bits == 64) {
        return ((asm["setTempRet0"]((tempDouble=ret,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)),ret>>>0)|0);
      }
  
      return ret;
    }function _strtol(str, endptr, base) {
      return __parseInt(str, endptr, base, -2147483648, 2147483647, 32);  // LONG_MIN, LONG_MAX.
    }

  
  
  
  
  function _mkport() { throw 'TODO' }var SOCKFS={mount:function (mount) {
        return FS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createSocket:function (family, type, protocol) {
        var streaming = type == 1;
        if (protocol) {
          assert(streaming == (protocol == 6)); // if SOCK_STREAM, must be tcp
        }
  
        // create our internal socket structure
        var sock = {
          family: family,
          type: type,
          protocol: protocol,
          server: null,
          peers: {},
          pending: [],
          recv_queue: [],
          sock_ops: SOCKFS.websocket_sock_ops
        };
  
        // create the filesystem node to store the socket structure
        var name = SOCKFS.nextname();
        var node = FS.createNode(SOCKFS.root, name, 49152, 0);
        node.sock = sock;
  
        // and the wrapping stream that enables library functions such
        // as read and write to indirectly interact with the socket
        var stream = FS.createStream({
          path: name,
          node: node,
          flags: FS.modeStringToFlags('r+'),
          seekable: false,
          stream_ops: SOCKFS.stream_ops
        });
  
        // map the new stream to the socket structure (sockets have a 1:1
        // relationship with a stream)
        sock.stream = stream;
  
        return sock;
      },getSocket:function (fd) {
        var stream = FS.getStream(fd);
        if (!stream || !FS.isSocket(stream.node.mode)) {
          return null;
        }
        return stream.node.sock;
      },stream_ops:{poll:function (stream) {
          var sock = stream.node.sock;
          return sock.sock_ops.poll(sock);
        },ioctl:function (stream, request, varargs) {
          var sock = stream.node.sock;
          return sock.sock_ops.ioctl(sock, request, varargs);
        },read:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          var msg = sock.sock_ops.recvmsg(sock, length);
          if (!msg) {
            // socket is closed
            return 0;
          }
          buffer.set(msg.buffer, offset);
          return msg.buffer.length;
        },write:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          return sock.sock_ops.sendmsg(sock, buffer, offset, length);
        },close:function (stream) {
          var sock = stream.node.sock;
          sock.sock_ops.close(sock);
        }},nextname:function () {
        if (!SOCKFS.nextname.current) {
          SOCKFS.nextname.current = 0;
        }
        return 'socket[' + (SOCKFS.nextname.current++) + ']';
      },websocket_sock_ops:{createPeer:function (sock, addr, port) {
          var ws;
  
          if (typeof addr === 'object') {
            ws = addr;
            addr = null;
            port = null;
          }
  
          if (ws) {
            // for sockets that've already connected (e.g. we're the server)
            // we can inspect the _socket property for the address
            if (ws._socket) {
              addr = ws._socket.remoteAddress;
              port = ws._socket.remotePort;
            }
            // if we're just now initializing a connection to the remote,
            // inspect the url property
            else {
              var result = /ws[s]?:\/\/([^:]+):(\d+)/.exec(ws.url);
              if (!result) {
                throw new Error('WebSocket URL must be in the format ws(s)://address:port');
              }
              addr = result[1];
              port = parseInt(result[2], 10);
            }
          } else {
            // create the actual websocket object and connect
            try {
              var url = 'ws://' + addr + ':' + port;
              // the node ws library API is slightly different than the browser's
              var opts = ENVIRONMENT_IS_NODE ? {headers: {'websocket-protocol': ['binary']}} : ['binary'];
              // If node we use the ws library.
              var WebSocket = ENVIRONMENT_IS_NODE ? require('ws') : window['WebSocket'];
              ws = new WebSocket(url, opts);
              ws.binaryType = 'arraybuffer';
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EHOSTUNREACH);
            }
          }
  
  
          var peer = {
            addr: addr,
            port: port,
            socket: ws,
            dgram_send_queue: []
          };
  
          SOCKFS.websocket_sock_ops.addPeer(sock, peer);
          SOCKFS.websocket_sock_ops.handlePeerEvents(sock, peer);
  
          // if this is a bound dgram socket, send the port number first to allow
          // us to override the ephemeral port reported to us by remotePort on the
          // remote end.
          if (sock.type === 2 && typeof sock.sport !== 'undefined') {
            peer.dgram_send_queue.push(new Uint8Array([
                255, 255, 255, 255,
                'p'.charCodeAt(0), 'o'.charCodeAt(0), 'r'.charCodeAt(0), 't'.charCodeAt(0),
                ((sock.sport & 0xff00) >> 8) , (sock.sport & 0xff)
            ]));
          }
  
          return peer;
        },getPeer:function (sock, addr, port) {
          return sock.peers[addr + ':' + port];
        },addPeer:function (sock, peer) {
          sock.peers[peer.addr + ':' + peer.port] = peer;
        },removePeer:function (sock, peer) {
          delete sock.peers[peer.addr + ':' + peer.port];
        },handlePeerEvents:function (sock, peer) {
          var first = true;
  
          var handleOpen = function () {
            try {
              var queued = peer.dgram_send_queue.shift();
              while (queued) {
                peer.socket.send(queued);
                queued = peer.dgram_send_queue.shift();
              }
            } catch (e) {
              // not much we can do here in the way of proper error handling as we've already
              // lied and said this data was sent. shut it down.
              peer.socket.close();
            }
          };
  
          function handleMessage(data) {
            assert(typeof data !== 'string' && data.byteLength !== undefined);  // must receive an ArrayBuffer
            data = new Uint8Array(data);  // make a typed array view on the array buffer
  
  
            // if this is the port message, override the peer's port with it
            var wasfirst = first;
            first = false;
            if (wasfirst &&
                data.length === 10 &&
                data[0] === 255 && data[1] === 255 && data[2] === 255 && data[3] === 255 &&
                data[4] === 'p'.charCodeAt(0) && data[5] === 'o'.charCodeAt(0) && data[6] === 'r'.charCodeAt(0) && data[7] === 't'.charCodeAt(0)) {
              // update the peer's port and it's key in the peer map
              var newport = ((data[8] << 8) | data[9]);
              SOCKFS.websocket_sock_ops.removePeer(sock, peer);
              peer.port = newport;
              SOCKFS.websocket_sock_ops.addPeer(sock, peer);
              return;
            }
  
            sock.recv_queue.push({ addr: peer.addr, port: peer.port, data: data });
          };
  
          if (ENVIRONMENT_IS_NODE) {
            peer.socket.on('open', handleOpen);
            peer.socket.on('message', function(data, flags) {
              if (!flags.binary) {
                return;
              }
              handleMessage((new Uint8Array(data)).buffer);  // copy from node Buffer -> ArrayBuffer
            });
            peer.socket.on('error', function() {
              // don't throw
            });
          } else {
            peer.socket.onopen = handleOpen;
            peer.socket.onmessage = function peer_socket_onmessage(event) {
              handleMessage(event.data);
            };
          }
        },poll:function (sock) {
          if (sock.type === 1 && sock.server) {
            // listen sockets should only say they're available for reading
            // if there are pending clients.
            return sock.pending.length ? (64 | 1) : 0;
          }
  
          var mask = 0;
          var dest = sock.type === 1 ?  // we only care about the socket state for connection-based sockets
            SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport) :
            null;
  
          if (sock.recv_queue.length ||
              !dest ||  // connection-less sockets are always ready to read
              (dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {  // let recv return 0 once closed
            mask |= (64 | 1);
          }
  
          if (!dest ||  // connection-less sockets are always ready to write
              (dest && dest.socket.readyState === dest.socket.OPEN)) {
            mask |= 4;
          }
  
          if ((dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {
            mask |= 16;
          }
  
          return mask;
        },ioctl:function (sock, request, arg) {
          switch (request) {
            case 21531:
              var bytes = 0;
              if (sock.recv_queue.length) {
                bytes = sock.recv_queue[0].data.length;
              }
              HEAP32[((arg)>>2)]=bytes;
              return 0;
            default:
              return ERRNO_CODES.EINVAL;
          }
        },close:function (sock) {
          // if we've spawned a listen server, close it
          if (sock.server) {
            try {
              sock.server.close();
            } catch (e) {
            }
            sock.server = null;
          }
          // close any peer connections
          var peers = Object.keys(sock.peers);
          for (var i = 0; i < peers.length; i++) {
            var peer = sock.peers[peers[i]];
            try {
              peer.socket.close();
            } catch (e) {
            }
            SOCKFS.websocket_sock_ops.removePeer(sock, peer);
          }
          return 0;
        },bind:function (sock, addr, port) {
          if (typeof sock.saddr !== 'undefined' || typeof sock.sport !== 'undefined') {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already bound
          }
          sock.saddr = addr;
          sock.sport = port || _mkport();
          // in order to emulate dgram sockets, we need to launch a listen server when
          // binding on a connection-less socket
          // note: this is only required on the server side
          if (sock.type === 2) {
            // close the existing server if it exists
            if (sock.server) {
              sock.server.close();
              sock.server = null;
            }
            // swallow error operation not supported error that occurs when binding in the
            // browser where this isn't supported
            try {
              sock.sock_ops.listen(sock, 0);
            } catch (e) {
              if (!(e instanceof FS.ErrnoError)) throw e;
              if (e.errno !== ERRNO_CODES.EOPNOTSUPP) throw e;
            }
          }
        },connect:function (sock, addr, port) {
          if (sock.server) {
            throw new FS.ErrnoError(ERRNO_CODS.EOPNOTSUPP);
          }
  
          // TODO autobind
          // if (!sock.addr && sock.type == 2) {
          // }
  
          // early out if we're already connected / in the middle of connecting
          if (typeof sock.daddr !== 'undefined' && typeof sock.dport !== 'undefined') {
            var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
            if (dest) {
              if (dest.socket.readyState === dest.socket.CONNECTING) {
                throw new FS.ErrnoError(ERRNO_CODES.EALREADY);
              } else {
                throw new FS.ErrnoError(ERRNO_CODES.EISCONN);
              }
            }
          }
  
          // add the socket to our peer list and set our
          // destination address / port to match
          var peer = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
          sock.daddr = peer.addr;
          sock.dport = peer.port;
  
          // always "fail" in non-blocking mode
          throw new FS.ErrnoError(ERRNO_CODES.EINPROGRESS);
        },listen:function (sock, backlog) {
          if (!ENVIRONMENT_IS_NODE) {
            throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
          }
          if (sock.server) {
             throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already listening
          }
          var WebSocketServer = require('ws').Server;
          var host = sock.saddr;
          sock.server = new WebSocketServer({
            host: host,
            port: sock.sport
            // TODO support backlog
          });
  
          sock.server.on('connection', function(ws) {
            if (sock.type === 1) {
              var newsock = SOCKFS.createSocket(sock.family, sock.type, sock.protocol);
  
              // create a peer on the new socket
              var peer = SOCKFS.websocket_sock_ops.createPeer(newsock, ws);
              newsock.daddr = peer.addr;
              newsock.dport = peer.port;
  
              // push to queue for accept to pick up
              sock.pending.push(newsock);
            } else {
              // create a peer on the listen socket so calling sendto
              // with the listen socket and an address will resolve
              // to the correct client
              SOCKFS.websocket_sock_ops.createPeer(sock, ws);
            }
          });
          sock.server.on('closed', function() {
            sock.server = null;
          });
          sock.server.on('error', function() {
            // don't throw
          });
        },accept:function (listensock) {
          if (!listensock.server) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          var newsock = listensock.pending.shift();
          newsock.stream.flags = listensock.stream.flags;
          return newsock;
        },getname:function (sock, peer) {
          var addr, port;
          if (peer) {
            if (sock.daddr === undefined || sock.dport === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            }
            addr = sock.daddr;
            port = sock.dport;
          } else {
            // TODO saddr and sport will be set for bind()'d UDP sockets, but what
            // should we be returning for TCP sockets that've been connect()'d?
            addr = sock.saddr || 0;
            port = sock.sport || 0;
          }
          return { addr: addr, port: port };
        },sendmsg:function (sock, buffer, offset, length, addr, port) {
          if (sock.type === 2) {
            // connection-less sockets will honor the message address,
            // and otherwise fall back to the bound destination address
            if (addr === undefined || port === undefined) {
              addr = sock.daddr;
              port = sock.dport;
            }
            // if there was no address to fall back to, error out
            if (addr === undefined || port === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.EDESTADDRREQ);
            }
          } else {
            // connection-based sockets will only use the bound
            addr = sock.daddr;
            port = sock.dport;
          }
  
          // find the peer for the destination address
          var dest = SOCKFS.websocket_sock_ops.getPeer(sock, addr, port);
  
          // early out if not connected with a connection-based socket
          if (sock.type === 1) {
            if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            } else if (dest.socket.readyState === dest.socket.CONNECTING) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // create a copy of the incoming data to send, as the WebSocket API
          // doesn't work entirely with an ArrayBufferView, it'll just send
          // the entire underlying buffer
          var data;
          if (buffer instanceof Array || buffer instanceof ArrayBuffer) {
            data = buffer.slice(offset, offset + length);
          } else {  // ArrayBufferView
            data = buffer.buffer.slice(buffer.byteOffset + offset, buffer.byteOffset + offset + length);
          }
  
          // if we're emulating a connection-less dgram socket and don't have
          // a cached connection, queue the buffer to send upon connect and
          // lie, saying the data was sent now.
          if (sock.type === 2) {
            if (!dest || dest.socket.readyState !== dest.socket.OPEN) {
              // if we're not connected, open a new connection
              if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                dest = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
              }
              dest.dgram_send_queue.push(data);
              return length;
            }
          }
  
          try {
            // send the actual data
            dest.socket.send(data);
            return length;
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
        },recvmsg:function (sock, length) {
          // http://pubs.opengroup.org/onlinepubs/7908799/xns/recvmsg.html
          if (sock.type === 1 && sock.server) {
            // tcp servers should not be recv()'ing on the listen socket
            throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
          }
  
          var queued = sock.recv_queue.shift();
          if (!queued) {
            if (sock.type === 1) {
              var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
  
              if (!dest) {
                // if we have a destination address but are not connected, error out
                throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
              }
              else if (dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                // return null if the socket has closed
                return null;
              }
              else {
                // else, our socket is in a valid state but truly has nothing available
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
            } else {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // queued.data will be an ArrayBuffer if it's unadulterated, but if it's
          // requeued TCP data it'll be an ArrayBufferView
          var queuedLength = queued.data.byteLength || queued.data.length;
          var queuedOffset = queued.data.byteOffset || 0;
          var queuedBuffer = queued.data.buffer || queued.data;
          var bytesRead = Math.min(length, queuedLength);
          var res = {
            buffer: new Uint8Array(queuedBuffer, queuedOffset, bytesRead),
            addr: queued.addr,
            port: queued.port
          };
  
  
          // push back any unread data for TCP connections
          if (sock.type === 1 && bytesRead < queuedLength) {
            var bytesRemaining = queuedLength - bytesRead;
            queued.data = new Uint8Array(queuedBuffer, queuedOffset + bytesRead, bytesRemaining);
            sock.recv_queue.unshift(queued);
          }
  
          return res;
        }}};function _send(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _write(fd, buf, len);
    }
  
  function _pwrite(fildes, buf, nbyte, offset) {
      // ssize_t pwrite(int fildes, const void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _write(fildes, buf, nbyte) {
      // ssize_t write(int fildes, const void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fputc(c, stream) {
      // int fputc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputc.html
      var chr = unSign(c & 0xFF);
      HEAP8[((_fputc.ret)|0)]=chr;
      var fd = _fileno(stream);
      var ret = _write(fd, _fputc.ret, 1);
      if (ret == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return -1;
      } else {
        return chr;
      }
    }

  
  var ___strtok_state=0;
  
  function _strtok_r(s, delim, lasts) {
      var skip_leading_delim = 1;
      var spanp;
      var c, sc;
      var tok;
  
  
      if (s == 0 && (s = getValue(lasts, 'i8*')) == 0) {
        return 0;
      }
  
      cont: while (1) {
        c = getValue(s++, 'i8');
        for (spanp = delim; (sc = getValue(spanp++, 'i8')) != 0;) {
          if (c == sc) {
            if (skip_leading_delim) {
              continue cont;
            } else {
              setValue(lasts, s, 'i8*');
              setValue(s - 1, 0, 'i8');
              return s - 1;
            }
          }
        }
        break;
      }
  
      if (c == 0) {
        setValue(lasts, 0, 'i8*');
        return 0;
      }
      tok = s - 1;
  
      for (;;) {
        c = getValue(s++, 'i8');
        spanp = delim;
        do {
          if ((sc = getValue(spanp++, 'i8')) == c) {
            if (c == 0) {
              s = 0;
            } else {
              setValue(s - 1, 0, 'i8');
            }
            setValue(lasts, s, 'i8*');
            return tok;
          }
        } while (sc != 0);
      }
      abort('strtok_r error!');
    }function _strtok(s, delim) {
      return _strtok_r(s, delim, ___strtok_state);
    }

  function _fwrite(ptr, size, nitems, stream) {
      // size_t fwrite(const void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fwrite.html
      var bytesToWrite = nitems * size;
      if (bytesToWrite == 0) return 0;
      var fd = _fileno(stream);
      var bytesWritten = _write(fd, ptr, bytesToWrite);
      if (bytesWritten == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return 0;
      } else {
        return Math.floor(bytesWritten / size);
      }
    }

  
  function _putchar(c) {
      // int putchar(int c);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/putchar.html
      return _fputc(c, HEAP32[((_stdout)>>2)]);
    } 
  Module["_saveSetjmp"] = _saveSetjmp;

  
   
  Module["_strlen"] = _strlen;function _fputs(s, stream) {
      // int fputs(const char *restrict s, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputs.html
      var fd = _fileno(stream);
      return _write(fd, s, _strlen(s));
    }

  var Browser={mainLoop:{scheduler:null,method:"",shouldPause:false,paused:false,queue:[],pause:function () {
          Browser.mainLoop.shouldPause = true;
        },resume:function () {
          if (Browser.mainLoop.paused) {
            Browser.mainLoop.paused = false;
            Browser.mainLoop.scheduler();
          }
          Browser.mainLoop.shouldPause = false;
        },updateStatus:function () {
          if (Module['setStatus']) {
            var message = Module['statusMessage'] || 'Please wait...';
            var remaining = Browser.mainLoop.remainingBlockers;
            var expected = Browser.mainLoop.expectedBlockers;
            if (remaining) {
              if (remaining < expected) {
                Module['setStatus'](message + ' (' + (expected - remaining) + '/' + expected + ')');
              } else {
                Module['setStatus'](message);
              }
            } else {
              Module['setStatus']('');
            }
          }
        }},isFullScreen:false,pointerLock:false,moduleContextCreatedCallbacks:[],workers:[],init:function () {
        if (!Module["preloadPlugins"]) Module["preloadPlugins"] = []; // needs to exist even in workers
  
        if (Browser.initted || ENVIRONMENT_IS_WORKER) return;
        Browser.initted = true;
  
        try {
          new Blob();
          Browser.hasBlobConstructor = true;
        } catch(e) {
          Browser.hasBlobConstructor = false;
          console.log("warning: no blob constructor, cannot create blobs with mimetypes");
        }
        Browser.BlobBuilder = typeof MozBlobBuilder != "undefined" ? MozBlobBuilder : (typeof WebKitBlobBuilder != "undefined" ? WebKitBlobBuilder : (!Browser.hasBlobConstructor ? console.log("warning: no BlobBuilder") : null));
        Browser.URLObject = typeof window != "undefined" ? (window.URL ? window.URL : window.webkitURL) : undefined;
        if (!Module.noImageDecoding && typeof Browser.URLObject === 'undefined') {
          console.log("warning: Browser does not support creating object URLs. Built-in browser image decoding will not be available.");
          Module.noImageDecoding = true;
        }
  
        // Support for plugins that can process preloaded files. You can add more of these to
        // your app by creating and appending to Module.preloadPlugins.
        //
        // Each plugin is asked if it can handle a file based on the file's name. If it can,
        // it is given the file's raw data. When it is done, it calls a callback with the file's
        // (possibly modified) data. For example, a plugin might decompress a file, or it
        // might create some side data structure for use later (like an Image element, etc.).
  
        var imagePlugin = {};
        imagePlugin['canHandle'] = function imagePlugin_canHandle(name) {
          return !Module.noImageDecoding && /\.(jpg|jpeg|png|bmp)$/i.test(name);
        };
        imagePlugin['handle'] = function imagePlugin_handle(byteArray, name, onload, onerror) {
          var b = null;
          if (Browser.hasBlobConstructor) {
            try {
              b = new Blob([byteArray], { type: Browser.getMimetype(name) });
              if (b.size !== byteArray.length) { // Safari bug #118630
                // Safari's Blob can only take an ArrayBuffer
                b = new Blob([(new Uint8Array(byteArray)).buffer], { type: Browser.getMimetype(name) });
              }
            } catch(e) {
              Runtime.warnOnce('Blob constructor present but fails: ' + e + '; falling back to blob builder');
            }
          }
          if (!b) {
            var bb = new Browser.BlobBuilder();
            bb.append((new Uint8Array(byteArray)).buffer); // we need to pass a buffer, and must copy the array to get the right data range
            b = bb.getBlob();
          }
          var url = Browser.URLObject.createObjectURL(b);
          var img = new Image();
          img.onload = function img_onload() {
            assert(img.complete, 'Image ' + name + ' could not be decoded');
            var canvas = document.createElement('canvas');
            canvas.width = img.width;
            canvas.height = img.height;
            var ctx = canvas.getContext('2d');
            ctx.drawImage(img, 0, 0);
            Module["preloadedImages"][name] = canvas;
            Browser.URLObject.revokeObjectURL(url);
            if (onload) onload(byteArray);
          };
          img.onerror = function img_onerror(event) {
            console.log('Image ' + url + ' could not be decoded');
            if (onerror) onerror();
          };
          img.src = url;
        };
        Module['preloadPlugins'].push(imagePlugin);
  
        var audioPlugin = {};
        audioPlugin['canHandle'] = function audioPlugin_canHandle(name) {
          return !Module.noAudioDecoding && name.substr(-4) in { '.ogg': 1, '.wav': 1, '.mp3': 1 };
        };
        audioPlugin['handle'] = function audioPlugin_handle(byteArray, name, onload, onerror) {
          var done = false;
          function finish(audio) {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = audio;
            if (onload) onload(byteArray);
          }
          function fail() {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = new Audio(); // empty shim
            if (onerror) onerror();
          }
          if (Browser.hasBlobConstructor) {
            try {
              var b = new Blob([byteArray], { type: Browser.getMimetype(name) });
            } catch(e) {
              return fail();
            }
            var url = Browser.URLObject.createObjectURL(b); // XXX we never revoke this!
            var audio = new Audio();
            audio.addEventListener('canplaythrough', function() { finish(audio) }, false); // use addEventListener due to chromium bug 124926
            audio.onerror = function audio_onerror(event) {
              if (done) return;
              console.log('warning: browser could not fully decode audio ' + name + ', trying slower base64 approach');
              function encode64(data) {
                var BASE = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
                var PAD = '=';
                var ret = '';
                var leftchar = 0;
                var leftbits = 0;
                for (var i = 0; i < data.length; i++) {
                  leftchar = (leftchar << 8) | data[i];
                  leftbits += 8;
                  while (leftbits >= 6) {
                    var curr = (leftchar >> (leftbits-6)) & 0x3f;
                    leftbits -= 6;
                    ret += BASE[curr];
                  }
                }
                if (leftbits == 2) {
                  ret += BASE[(leftchar&3) << 4];
                  ret += PAD + PAD;
                } else if (leftbits == 4) {
                  ret += BASE[(leftchar&0xf) << 2];
                  ret += PAD;
                }
                return ret;
              }
              audio.src = 'data:audio/x-' + name.substr(-3) + ';base64,' + encode64(byteArray);
              finish(audio); // we don't wait for confirmation this worked - but it's worth trying
            };
            audio.src = url;
            // workaround for chrome bug 124926 - we do not always get oncanplaythrough or onerror
            Browser.safeSetTimeout(function() {
              finish(audio); // try to use it even though it is not necessarily ready to play
            }, 10000);
          } else {
            return fail();
          }
        };
        Module['preloadPlugins'].push(audioPlugin);
  
        // Canvas event setup
  
        var canvas = Module['canvas'];
        canvas.requestPointerLock = canvas['requestPointerLock'] ||
                                    canvas['mozRequestPointerLock'] ||
                                    canvas['webkitRequestPointerLock'];
        canvas.exitPointerLock = document['exitPointerLock'] ||
                                 document['mozExitPointerLock'] ||
                                 document['webkitExitPointerLock'] ||
                                 function(){}; // no-op if function does not exist
        canvas.exitPointerLock = canvas.exitPointerLock.bind(document);
  
        function pointerLockChange() {
          Browser.pointerLock = document['pointerLockElement'] === canvas ||
                                document['mozPointerLockElement'] === canvas ||
                                document['webkitPointerLockElement'] === canvas;
        }
  
        document.addEventListener('pointerlockchange', pointerLockChange, false);
        document.addEventListener('mozpointerlockchange', pointerLockChange, false);
        document.addEventListener('webkitpointerlockchange', pointerLockChange, false);
  
        if (Module['elementPointerLock']) {
          canvas.addEventListener("click", function(ev) {
            if (!Browser.pointerLock && canvas.requestPointerLock) {
              canvas.requestPointerLock();
              ev.preventDefault();
            }
          }, false);
        }
      },createContext:function (canvas, useWebGL, setInModule, webGLContextAttributes) {
        var ctx;
        var errorInfo = '?';
        function onContextCreationError(event) {
          errorInfo = event.statusMessage || errorInfo;
        }
        try {
          if (useWebGL) {
            var contextAttributes = {
              antialias: false,
              alpha: false
            };
  
            if (webGLContextAttributes) {
              for (var attribute in webGLContextAttributes) {
                contextAttributes[attribute] = webGLContextAttributes[attribute];
              }
            }
  
  
            canvas.addEventListener('webglcontextcreationerror', onContextCreationError, false);
            try {
              ['experimental-webgl', 'webgl'].some(function(webglId) {
                return ctx = canvas.getContext(webglId, contextAttributes);
              });
            } finally {
              canvas.removeEventListener('webglcontextcreationerror', onContextCreationError, false);
            }
          } else {
            ctx = canvas.getContext('2d');
          }
          if (!ctx) throw ':(';
        } catch (e) {
          Module.print('Could not create canvas: ' + [errorInfo, e]);
          return null;
        }
        if (useWebGL) {
          // Set the background of the WebGL canvas to black
          canvas.style.backgroundColor = "black";
  
          // Warn on context loss
          canvas.addEventListener('webglcontextlost', function(event) {
            alert('WebGL context lost. You will need to reload the page.');
          }, false);
        }
        if (setInModule) {
          GLctx = Module.ctx = ctx;
          Module.useWebGL = useWebGL;
          Browser.moduleContextCreatedCallbacks.forEach(function(callback) { callback() });
          Browser.init();
        }
        return ctx;
      },destroyContext:function (canvas, useWebGL, setInModule) {},fullScreenHandlersInstalled:false,lockPointer:undefined,resizeCanvas:undefined,requestFullScreen:function (lockPointer, resizeCanvas) {
        Browser.lockPointer = lockPointer;
        Browser.resizeCanvas = resizeCanvas;
        if (typeof Browser.lockPointer === 'undefined') Browser.lockPointer = true;
        if (typeof Browser.resizeCanvas === 'undefined') Browser.resizeCanvas = false;
  
        var canvas = Module['canvas'];
        function fullScreenChange() {
          Browser.isFullScreen = false;
          if ((document['webkitFullScreenElement'] || document['webkitFullscreenElement'] ||
               document['mozFullScreenElement'] || document['mozFullscreenElement'] ||
               document['fullScreenElement'] || document['fullscreenElement']) === canvas) {
            canvas.cancelFullScreen = document['cancelFullScreen'] ||
                                      document['mozCancelFullScreen'] ||
                                      document['webkitCancelFullScreen'];
            canvas.cancelFullScreen = canvas.cancelFullScreen.bind(document);
            if (Browser.lockPointer) canvas.requestPointerLock();
            Browser.isFullScreen = true;
            if (Browser.resizeCanvas) Browser.setFullScreenCanvasSize();
          } else if (Browser.resizeCanvas){
            Browser.setWindowedCanvasSize();
          }
          if (Module['onFullScreen']) Module['onFullScreen'](Browser.isFullScreen);
        }
  
        if (!Browser.fullScreenHandlersInstalled) {
          Browser.fullScreenHandlersInstalled = true;
          document.addEventListener('fullscreenchange', fullScreenChange, false);
          document.addEventListener('mozfullscreenchange', fullScreenChange, false);
          document.addEventListener('webkitfullscreenchange', fullScreenChange, false);
        }
  
        canvas.requestFullScreen = canvas['requestFullScreen'] ||
                                   canvas['mozRequestFullScreen'] ||
                                   (canvas['webkitRequestFullScreen'] ? function() { canvas['webkitRequestFullScreen'](Element['ALLOW_KEYBOARD_INPUT']) } : null);
        canvas.requestFullScreen();
      },requestAnimationFrame:function requestAnimationFrame(func) {
        if (typeof window === 'undefined') { // Provide fallback to setTimeout if window is undefined (e.g. in Node.js)
          setTimeout(func, 1000/60);
        } else {
          if (!window.requestAnimationFrame) {
            window.requestAnimationFrame = window['requestAnimationFrame'] ||
                                           window['mozRequestAnimationFrame'] ||
                                           window['webkitRequestAnimationFrame'] ||
                                           window['msRequestAnimationFrame'] ||
                                           window['oRequestAnimationFrame'] ||
                                           window['setTimeout'];
          }
          window.requestAnimationFrame(func);
        }
      },safeCallback:function (func) {
        return function() {
          if (!ABORT) return func.apply(null, arguments);
        };
      },safeRequestAnimationFrame:function (func) {
        return Browser.requestAnimationFrame(function() {
          if (!ABORT) func();
        });
      },safeSetTimeout:function (func, timeout) {
        return setTimeout(function() {
          if (!ABORT) func();
        }, timeout);
      },safeSetInterval:function (func, timeout) {
        return setInterval(function() {
          if (!ABORT) func();
        }, timeout);
      },getMimetype:function (name) {
        return {
          'jpg': 'image/jpeg',
          'jpeg': 'image/jpeg',
          'png': 'image/png',
          'bmp': 'image/bmp',
          'ogg': 'audio/ogg',
          'wav': 'audio/wav',
          'mp3': 'audio/mpeg'
        }[name.substr(name.lastIndexOf('.')+1)];
      },getUserMedia:function (func) {
        if(!window.getUserMedia) {
          window.getUserMedia = navigator['getUserMedia'] ||
                                navigator['mozGetUserMedia'];
        }
        window.getUserMedia(func);
      },getMovementX:function (event) {
        return event['movementX'] ||
               event['mozMovementX'] ||
               event['webkitMovementX'] ||
               0;
      },getMovementY:function (event) {
        return event['movementY'] ||
               event['mozMovementY'] ||
               event['webkitMovementY'] ||
               0;
      },getMouseWheelDelta:function (event) {
        return Math.max(-1, Math.min(1, event.type === 'DOMMouseScroll' ? event.detail : -event.wheelDelta));
      },mouseX:0,mouseY:0,mouseMovementX:0,mouseMovementY:0,calculateMouseEvent:function (event) { // event should be mousemove, mousedown or mouseup
        if (Browser.pointerLock) {
          // When the pointer is locked, calculate the coordinates
          // based on the movement of the mouse.
          // Workaround for Firefox bug 764498
          if (event.type != 'mousemove' &&
              ('mozMovementX' in event)) {
            Browser.mouseMovementX = Browser.mouseMovementY = 0;
          } else {
            Browser.mouseMovementX = Browser.getMovementX(event);
            Browser.mouseMovementY = Browser.getMovementY(event);
          }
          
          // check if SDL is available
          if (typeof SDL != "undefined") {
          	Browser.mouseX = SDL.mouseX + Browser.mouseMovementX;
          	Browser.mouseY = SDL.mouseY + Browser.mouseMovementY;
          } else {
          	// just add the mouse delta to the current absolut mouse position
          	// FIXME: ideally this should be clamped against the canvas size and zero
          	Browser.mouseX += Browser.mouseMovementX;
          	Browser.mouseY += Browser.mouseMovementY;
          }        
        } else {
          // Otherwise, calculate the movement based on the changes
          // in the coordinates.
          var rect = Module["canvas"].getBoundingClientRect();
          var x, y;
          
          // Neither .scrollX or .pageXOffset are defined in a spec, but
          // we prefer .scrollX because it is currently in a spec draft.
          // (see: http://www.w3.org/TR/2013/WD-cssom-view-20131217/)
          var scrollX = ((typeof window.scrollX !== 'undefined') ? window.scrollX : window.pageXOffset);
          var scrollY = ((typeof window.scrollY !== 'undefined') ? window.scrollY : window.pageYOffset);
          if (event.type == 'touchstart' ||
              event.type == 'touchend' ||
              event.type == 'touchmove') {
            var t = event.touches.item(0);
            if (t) {
              x = t.pageX - (scrollX + rect.left);
              y = t.pageY - (scrollY + rect.top);
            } else {
              return;
            }
          } else {
            x = event.pageX - (scrollX + rect.left);
            y = event.pageY - (scrollY + rect.top);
          }
  
          // the canvas might be CSS-scaled compared to its backbuffer;
          // SDL-using content will want mouse coordinates in terms
          // of backbuffer units.
          var cw = Module["canvas"].width;
          var ch = Module["canvas"].height;
          x = x * (cw / rect.width);
          y = y * (ch / rect.height);
  
          Browser.mouseMovementX = x - Browser.mouseX;
          Browser.mouseMovementY = y - Browser.mouseY;
          Browser.mouseX = x;
          Browser.mouseY = y;
        }
      },xhrLoad:function (url, onload, onerror) {
        var xhr = new XMLHttpRequest();
        xhr.open('GET', url, true);
        xhr.responseType = 'arraybuffer';
        xhr.onload = function xhr_onload() {
          if (xhr.status == 200 || (xhr.status == 0 && xhr.response)) { // file URLs can return 0
            onload(xhr.response);
          } else {
            onerror();
          }
        };
        xhr.onerror = onerror;
        xhr.send(null);
      },asyncLoad:function (url, onload, onerror, noRunDep) {
        Browser.xhrLoad(url, function(arrayBuffer) {
          assert(arrayBuffer, 'Loading data file "' + url + '" failed (no arrayBuffer).');
          onload(new Uint8Array(arrayBuffer));
          if (!noRunDep) removeRunDependency('al ' + url);
        }, function(event) {
          if (onerror) {
            onerror();
          } else {
            throw 'Loading data file "' + url + '" failed.';
          }
        });
        if (!noRunDep) addRunDependency('al ' + url);
      },resizeListeners:[],updateResizeListeners:function () {
        var canvas = Module['canvas'];
        Browser.resizeListeners.forEach(function(listener) {
          listener(canvas.width, canvas.height);
        });
      },setCanvasSize:function (width, height, noUpdates) {
        var canvas = Module['canvas'];
        canvas.width = width;
        canvas.height = height;
        if (!noUpdates) Browser.updateResizeListeners();
      },windowedWidth:0,windowedHeight:0,setFullScreenCanvasSize:function () {
        var canvas = Module['canvas'];
        this.windowedWidth = canvas.width;
        this.windowedHeight = canvas.height;
        canvas.width = screen.width;
        canvas.height = screen.height;
        // check if SDL is available   
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags | 0x00800000; // set SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      },setWindowedCanvasSize:function () {
        var canvas = Module['canvas'];
        canvas.width = this.windowedWidth;
        canvas.height = this.windowedHeight;
        // check if SDL is available       
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags & ~0x00800000; // clear SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      }};


  
  function _malloc(bytes) {
      /* Over-allocate to make sure it is byte-aligned by 8.
       * This will leak memory, but this is only the dummy
       * implementation (replaced by dlmalloc normally) so
       * not an issue.
       */
      var ptr = Runtime.dynamicAlloc(bytes + 8);
      return (ptr+8) & 0xFFFFFFF8;
    }
  Module["_malloc"] = _malloc;
  
  var ___tm_current=allocate(44, "i8", ALLOC_STATIC);
  
  
  var ___tm_timezone=allocate(intArrayFromString("GMT"), "i8", ALLOC_STATIC);
  
  
  var _tzname=allocate(8, "i32*", ALLOC_STATIC);
  
  var _daylight=allocate(1, "i32*", ALLOC_STATIC);
  
  var _timezone=allocate(1, "i32*", ALLOC_STATIC);function _tzset() {
      // TODO: Use (malleable) environment variables instead of system settings.
      if (_tzset.called) return;
      _tzset.called = true;
  
      HEAP32[((_timezone)>>2)]=-(new Date()).getTimezoneOffset() * 60;
  
      var winter = new Date(2000, 0, 1);
      var summer = new Date(2000, 6, 1);
      HEAP32[((_daylight)>>2)]=Number(winter.getTimezoneOffset() != summer.getTimezoneOffset());
  
      var winterName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | winter.toString().match(/\(([A-Z]+)\)/)[1];
      var summerName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | summer.toString().match(/\(([A-Z]+)\)/)[1];
      var winterNamePtr = allocate(intArrayFromString(winterName), 'i8', ALLOC_NORMAL);
      var summerNamePtr = allocate(intArrayFromString(summerName), 'i8', ALLOC_NORMAL);
      HEAP32[((_tzname)>>2)]=winterNamePtr;
      HEAP32[(((_tzname)+(4))>>2)]=summerNamePtr;
    }function _localtime_r(time, tmPtr) {
      _tzset();
      var date = new Date(HEAP32[((time)>>2)]*1000);
      HEAP32[((tmPtr)>>2)]=date.getSeconds();
      HEAP32[(((tmPtr)+(4))>>2)]=date.getMinutes();
      HEAP32[(((tmPtr)+(8))>>2)]=date.getHours();
      HEAP32[(((tmPtr)+(12))>>2)]=date.getDate();
      HEAP32[(((tmPtr)+(16))>>2)]=date.getMonth();
      HEAP32[(((tmPtr)+(20))>>2)]=date.getFullYear()-1900;
      HEAP32[(((tmPtr)+(24))>>2)]=date.getDay();
  
      var start = new Date(date.getFullYear(), 0, 1);
      var yday = Math.floor((date.getTime() - start.getTime()) / (1000 * 60 * 60 * 24));
      HEAP32[(((tmPtr)+(28))>>2)]=yday;
      HEAP32[(((tmPtr)+(36))>>2)]=start.getTimezoneOffset() * 60;
  
      var dst = Number(start.getTimezoneOffset() != date.getTimezoneOffset());
      HEAP32[(((tmPtr)+(32))>>2)]=dst;
  
      HEAP32[(((tmPtr)+(40))>>2)]=___tm_timezone;
  
      return tmPtr;
    }function _localtime(time) {
      return _localtime_r(time, ___tm_current);
    }

   
  Module["_bitshift64Ashr"] = _bitshift64Ashr;

  
  var PTHREAD_SPECIFIC={};function _pthread_setspecific(key, value) {
      if (!(key in PTHREAD_SPECIFIC)) {
        return ERRNO_CODES.EINVAL;
      }
      PTHREAD_SPECIFIC[key] = value;
      return 0;
    }

  function _GC_init() {
  Module['printErr']('missing function: GC_init'); abort(-1);
  }

  var _ceil=Math_ceil;

  function _GC_strdup() {
  Module['printErr']('missing function: GC_strdup'); abort(-1);
  }

  function _GC_malloc_atomic() {
  Module['printErr']('missing function: GC_malloc_atomic'); abort(-1);
  }

  
  function _isxdigit(chr) {
      return (chr >= 48 && chr <= 57) ||
             (chr >= 97 && chr <= 102) ||
             (chr >= 65 && chr <= 70);
    }function _isxdigit_l(chr) {
      return _isxdigit(chr); // no locale support yet
    }

  
  function _puts(s) {
      // int puts(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/puts.html
      // NOTE: puts() always writes an extra newline.
      var stdout = HEAP32[((_stdout)>>2)];
      var ret = _fputs(s, stdout);
      if (ret < 0) {
        return ret;
      } else {
        var newlineRet = _fputc(10, stdout);
        return (newlineRet < 0) ? -1 : ret + 1;
      }
    }
  
  
  function _strerror_r(errnum, strerrbuf, buflen) {
      if (errnum in ERRNO_MESSAGES) {
        if (ERRNO_MESSAGES[errnum].length > buflen - 1) {
          return ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          var msg = ERRNO_MESSAGES[errnum];
          writeAsciiToMemory(msg, strerrbuf);
          return 0;
        }
      } else {
        return ___setErrNo(ERRNO_CODES.EINVAL);
      }
    }function _strerror(errnum) {
      if (!_strerror.buffer) _strerror.buffer = _malloc(256);
      _strerror_r(errnum, _strerror.buffer, 256);
      return _strerror.buffer;
    }
  
  function ___errno_location() {
      return ___errno_state;
    }function _perror(s) {
      // void perror(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/perror.html
      var stdout = HEAP32[((_stdout)>>2)];
      if (s) {
        _fputs(s, stdout);
        _fputc(58, stdout);
        _fputc(32, stdout);
      }
      var errnum = HEAP32[((___errno_location())>>2)];
      _puts(_strerror(errnum));
    }

  
  function _emscripten_memcpy_big(dest, src, num) {
      HEAPU8.set(HEAPU8.subarray(src, src+num), dest);
      return dest;
    } 
  Module["_memcpy"] = _memcpy;


  function _strstr(ptr1, ptr2) {
      var check = 0, start;
      do {
        if (!check) {
          start = ptr1;
          check = ptr2;
        }
        var curr1 = HEAP8[((ptr1++)|0)];
        var curr2 = HEAP8[((check++)|0)];
        if (curr2 == 0) return start;
        if (curr2 != curr1) {
          // rewind to one character after start, to find ez in eeez
          ptr1 = start + 1;
          check = 0;
        }
      } while (curr1);
      return 0;
    }

   
  Module["_memmove"] = _memmove;

  function _newlocale(mask, locale, base) {
      return _malloc(4);
    }

  function _signal(sig, func) {
      // TODO
      return 0;
    }

  
  function _sinh(x) {
      var p = Math.pow(Math.E, x);
      return (p - (1 / p)) / 2;
    }
  
  function _cosh(x) {
      var p = Math.pow(Math.E, x);
      return (p + (1 / p)) / 2;
    }function _tanh(x) {
      return _sinh(x) / _cosh(x);
    }

  var _emscripten_preinvoke=true;

  function _pthread_cond_wait() {
      return 0;
    }

  
  
  
  var ___cxa_exception_header_size=8;
  
  function _free() {
  }
  Module["_free"] = _free;function ___cxa_free_exception(ptr) {
      try {
        return _free(ptr - ___cxa_exception_header_size);
      } catch(e) { // XXX FIXME
      }
    }
  
  var ___cxa_last_thrown_exception=0;
  
  var ___cxa_caught_exceptions=[];function ___cxa_end_catch() {
      if (___cxa_end_catch.rethrown) {
        ___cxa_end_catch.rethrown = false;
        return;
      }
      // Clear state flag.
      asm['setThrew'](0);
      // Call destructor if one is registered then clear it.
      var ptr = ___cxa_caught_exceptions.pop();
      if (ptr) {
        header = ptr - ___cxa_exception_header_size;
        var destructor = HEAP32[(((header)+(4))>>2)];
        if (destructor) {
          Runtime.dynCall('vi', destructor, [ptr]);
          HEAP32[(((header)+(4))>>2)]=0;
        }
        ___cxa_free_exception(ptr);
        ___cxa_last_thrown_exception = 0;
      }
    }function ___cxa_rethrow() {
      ___cxa_end_catch.rethrown = true;
      var ptr = ___cxa_caught_exceptions.pop();
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }

  
  
  function _open(path, oflag, varargs) {
      // int open(const char *path, int oflag, ...);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/open.html
      var mode = HEAP32[((varargs)>>2)];
      path = Pointer_stringify(path);
      try {
        var stream = FS.open(path, oflag, mode);
        return stream.fd;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fopen(filename, mode) {
      // FILE *fopen(const char *restrict filename, const char *restrict mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fopen.html
      var flags;
      mode = Pointer_stringify(mode);
      if (mode[0] == 'r') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 0;
        }
      } else if (mode[0] == 'w') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 512;
      } else if (mode[0] == 'a') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 1024;
      } else {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return 0;
      }
      var fd = _open(filename, flags, allocate([0x1FF, 0, 0, 0], 'i32', ALLOC_STACK));  // All creation permissions.
      return fd === -1 ? 0 : FS.getPtrForStream(FS.getStream(fd));
    }function _freopen(filename, mode, stream) {
      // FILE *freopen(const char *restrict filename, const char *restrict mode, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/freopen.html
      if (!filename) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (!streamObj) {
          ___setErrNo(ERRNO_CODES.EBADF);
          return 0;
        }
        if (_freopen.buffer) _free(_freopen.buffer);
        filename = intArrayFromString(streamObj.path);
        filename = allocate(filename, 'i8', ALLOC_NORMAL);
      }
      _fclose(stream);
      return _fopen(filename, mode);
    }

  function _round(x) {
      return (x < 0) ? -Math.round(-x) : Math.round(x);
    }

  
  function _emscripten_get_now() {
      if (!_emscripten_get_now.actual) {
        if (ENVIRONMENT_IS_NODE) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() {
            var t = process['hrtime']();
            return t[0] * 1e3 + t[1] / 1e6;
          }
        } else if (typeof dateNow !== 'undefined') {
          _emscripten_get_now.actual = dateNow;
        } else if (ENVIRONMENT_IS_WEB && window['performance'] && window['performance']['now']) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() { return window['performance']['now'](); };
        } else {
          _emscripten_get_now.actual = Date.now;
        }
      }
      return _emscripten_get_now.actual();
    }function _clock_gettime(clk_id, tp) {
      // int clock_gettime(clockid_t clk_id, struct timespec *tp);
      var now;
      if (clk_id === 0) {
        now = Date.now();
      } else {
        now = _emscripten_get_now();
      }
      HEAP32[((tp)>>2)]=Math.floor(now/1000); // seconds
      HEAP32[(((tp)+(4))>>2)]=Math.floor((now % 1000)*1000*1000); // nanoseconds
      return 0;
    }

  
  function _tmpnam(s, dir, prefix) {
      // char *tmpnam(char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/tmpnam.html
      // NOTE: The dir and prefix arguments are for internal use only.
      var folder = FS.findObject(dir || '/tmp');
      if (!folder || !folder.isFolder) {
        dir = '/tmp';
        folder = FS.findObject(dir);
        if (!folder || !folder.isFolder) return 0;
      }
      var name = prefix || 'file';
      do {
        name += String.fromCharCode(65 + Math.floor(Math.random() * 25));
      } while (name in folder.contents);
      var result = dir + '/' + name;
      if (!_tmpnam.buffer) _tmpnam.buffer = _malloc(256);
      if (!s) s = _tmpnam.buffer;
      writeAsciiToMemory(result, s);
      return s;
    }function _tmpfile() {
      // FILE *tmpfile(void);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/tmpfile.html
      // TODO: Delete the created file on closing.
      if (_tmpfile.mode) {
        _tmpfile.mode = allocate(intArrayFromString('w+'), 'i8', ALLOC_NORMAL);
      }
      return _fopen(_tmpnam(0), _tmpfile.mode);
    }

  
  
  
  function __getFloat(text) {
      return /^[+-]?[0-9]*\.?[0-9]+([eE][+-]?[0-9]+)?/.exec(text);
    }function __scanString(format, get, unget, varargs) {
      if (!__scanString.whiteSpace) {
        __scanString.whiteSpace = {};
        __scanString.whiteSpace[32] = 1;
        __scanString.whiteSpace[9] = 1;
        __scanString.whiteSpace[10] = 1;
        __scanString.whiteSpace[11] = 1;
        __scanString.whiteSpace[12] = 1;
        __scanString.whiteSpace[13] = 1;
      }
      // Supports %x, %4x, %d.%d, %lld, %s, %f, %lf.
      // TODO: Support all format specifiers.
      format = Pointer_stringify(format);
      var soFar = 0;
      if (format.indexOf('%n') >= 0) {
        // need to track soFar
        var _get = get;
        get = function get() {
          soFar++;
          return _get();
        }
        var _unget = unget;
        unget = function unget() {
          soFar--;
          return _unget();
        }
      }
      var formatIndex = 0;
      var argsi = 0;
      var fields = 0;
      var argIndex = 0;
      var next;
  
      mainLoop:
      for (var formatIndex = 0; formatIndex < format.length;) {
        if (format[formatIndex] === '%' && format[formatIndex+1] == 'n') {
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          HEAP32[((argPtr)>>2)]=soFar;
          formatIndex += 2;
          continue;
        }
  
        if (format[formatIndex] === '%') {
          var nextC = format.indexOf('c', formatIndex+1);
          if (nextC > 0) {
            var maxx = 1;
            if (nextC > formatIndex+1) {
              var sub = format.substring(formatIndex+1, nextC);
              maxx = parseInt(sub);
              if (maxx != sub) maxx = 0;
            }
            if (maxx) {
              var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
              argIndex += Runtime.getAlignSize('void*', null, true);
              fields++;
              for (var i = 0; i < maxx; i++) {
                next = get();
                HEAP8[((argPtr++)|0)]=next;
                if (next === 0) return i > 0 ? fields : fields-1; // we failed to read the full length of this field
              }
              formatIndex += nextC - formatIndex + 1;
              continue;
            }
          }
        }
  
        // handle %[...]
        if (format[formatIndex] === '%' && format.indexOf('[', formatIndex+1) > 0) {
          var match = /\%([0-9]*)\[(\^)?(\]?[^\]]*)\]/.exec(format.substring(formatIndex));
          if (match) {
            var maxNumCharacters = parseInt(match[1]) || Infinity;
            var negateScanList = (match[2] === '^');
            var scanList = match[3];
  
            // expand "middle" dashs into character sets
            var middleDashMatch;
            while ((middleDashMatch = /([^\-])\-([^\-])/.exec(scanList))) {
              var rangeStartCharCode = middleDashMatch[1].charCodeAt(0);
              var rangeEndCharCode = middleDashMatch[2].charCodeAt(0);
              for (var expanded = ''; rangeStartCharCode <= rangeEndCharCode; expanded += String.fromCharCode(rangeStartCharCode++));
              scanList = scanList.replace(middleDashMatch[1] + '-' + middleDashMatch[2], expanded);
            }
  
            var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
            argIndex += Runtime.getAlignSize('void*', null, true);
            fields++;
  
            for (var i = 0; i < maxNumCharacters; i++) {
              next = get();
              if (negateScanList) {
                if (scanList.indexOf(String.fromCharCode(next)) < 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              } else {
                if (scanList.indexOf(String.fromCharCode(next)) >= 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              }
            }
  
            // write out null-terminating character
            HEAP8[((argPtr++)|0)]=0;
            formatIndex += match[0].length;
            
            continue;
          }
        }      
        // remove whitespace
        while (1) {
          next = get();
          if (next == 0) return fields;
          if (!(next in __scanString.whiteSpace)) break;
        }
        unget();
  
        if (format[formatIndex] === '%') {
          formatIndex++;
          var suppressAssignment = false;
          if (format[formatIndex] == '*') {
            suppressAssignment = true;
            formatIndex++;
          }
          var maxSpecifierStart = formatIndex;
          while (format[formatIndex].charCodeAt(0) >= 48 &&
                 format[formatIndex].charCodeAt(0) <= 57) {
            formatIndex++;
          }
          var max_;
          if (formatIndex != maxSpecifierStart) {
            max_ = parseInt(format.slice(maxSpecifierStart, formatIndex), 10);
          }
          var long_ = false;
          var half = false;
          var longLong = false;
          if (format[formatIndex] == 'l') {
            long_ = true;
            formatIndex++;
            if (format[formatIndex] == 'l') {
              longLong = true;
              formatIndex++;
            }
          } else if (format[formatIndex] == 'h') {
            half = true;
            formatIndex++;
          }
          var type = format[formatIndex];
          formatIndex++;
          var curr = 0;
          var buffer = [];
          // Read characters according to the format. floats are trickier, they may be in an unfloat state in the middle, then be a valid float later
          if (type == 'f' || type == 'e' || type == 'g' ||
              type == 'F' || type == 'E' || type == 'G') {
            next = get();
            while (next > 0 && (!(next in __scanString.whiteSpace)))  {
              buffer.push(String.fromCharCode(next));
              next = get();
            }
            var m = __getFloat(buffer.join(''));
            var last = m ? m[0].length : 0;
            for (var i = 0; i < buffer.length - last + 1; i++) {
              unget();
            }
            buffer.length = last;
          } else {
            next = get();
            var first = true;
            
            // Strip the optional 0x prefix for %x.
            if ((type == 'x' || type == 'X') && (next == 48)) {
              var peek = get();
              if (peek == 120 || peek == 88) {
                next = get();
              } else {
                unget();
              }
            }
            
            while ((curr < max_ || isNaN(max_)) && next > 0) {
              if (!(next in __scanString.whiteSpace) && // stop on whitespace
                  (type == 's' ||
                   ((type === 'd' || type == 'u' || type == 'i') && ((next >= 48 && next <= 57) ||
                                                                     (first && next == 45))) ||
                   ((type === 'x' || type === 'X') && (next >= 48 && next <= 57 ||
                                     next >= 97 && next <= 102 ||
                                     next >= 65 && next <= 70))) &&
                  (formatIndex >= format.length || next !== format[formatIndex].charCodeAt(0))) { // Stop when we read something that is coming up
                buffer.push(String.fromCharCode(next));
                next = get();
                curr++;
                first = false;
              } else {
                break;
              }
            }
            unget();
          }
          if (buffer.length === 0) return 0;  // Failure.
          if (suppressAssignment) continue;
  
          var text = buffer.join('');
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          switch (type) {
            case 'd': case 'u': case 'i':
              if (half) {
                HEAP16[((argPtr)>>1)]=parseInt(text, 10);
              } else if (longLong) {
                (tempI64 = [parseInt(text, 10)>>>0,(tempDouble=parseInt(text, 10),(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((argPtr)>>2)]=tempI64[0],HEAP32[(((argPtr)+(4))>>2)]=tempI64[1]);
              } else {
                HEAP32[((argPtr)>>2)]=parseInt(text, 10);
              }
              break;
            case 'X':
            case 'x':
              HEAP32[((argPtr)>>2)]=parseInt(text, 16);
              break;
            case 'F':
            case 'f':
            case 'E':
            case 'e':
            case 'G':
            case 'g':
            case 'E':
              // fallthrough intended
              if (long_) {
                HEAPF64[((argPtr)>>3)]=parseFloat(text);
              } else {
                HEAPF32[((argPtr)>>2)]=parseFloat(text);
              }
              break;
            case 's':
              var array = intArrayFromString(text);
              for (var j = 0; j < array.length; j++) {
                HEAP8[(((argPtr)+(j))|0)]=array[j];
              }
              break;
          }
          fields++;
        } else if (format[formatIndex].charCodeAt(0) in __scanString.whiteSpace) {
          next = get();
          while (next in __scanString.whiteSpace) {
            if (next <= 0) break mainLoop;  // End of input.
            next = get();
          }
          unget(next);
          formatIndex++;
        } else {
          // Not a specifier.
          next = get();
          if (format[formatIndex].charCodeAt(0) !== next) {
            unget(next);
            break mainLoop;
          }
          formatIndex++;
        }
      }
      return fields;
    }function _sscanf(s, format, varargs) {
      // int sscanf(const char *restrict s, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var index = 0;
      function get() { return HEAP8[(((s)+(index++))|0)]; };
      function unget() { index--; };
      return __scanString(format, get, unget, varargs);
    }function _vsscanf(s, format, va_arg) {
      return _sscanf(s, format, HEAP32[((va_arg)>>2)]);
    }

  
  
  function __reallyNegative(x) {
      return x < 0 || (x === 0 && (1/x) === -Infinity);
    }function __formatString(format, varargs) {
      var textIndex = format;
      var argIndex = 0;
      function getNextArg(type) {
        // NOTE: Explicitly ignoring type safety. Otherwise this fails:
        //       int x = 4; printf("%c\n", (char)x);
        var ret;
        if (type === 'double') {
          ret = (HEAP32[((tempDoublePtr)>>2)]=HEAP32[(((varargs)+(argIndex))>>2)],HEAP32[(((tempDoublePtr)+(4))>>2)]=HEAP32[(((varargs)+((argIndex)+(4)))>>2)],(+(HEAPF64[(tempDoublePtr)>>3])));
        } else if (type == 'i64') {
          ret = [HEAP32[(((varargs)+(argIndex))>>2)],
                 HEAP32[(((varargs)+(argIndex+4))>>2)]];
  
        } else {
          type = 'i32'; // varargs are always i32, i64, or double
          ret = HEAP32[(((varargs)+(argIndex))>>2)];
        }
        argIndex += Runtime.getNativeFieldSize(type);
        return ret;
      }
  
      var ret = [];
      var curr, next, currArg;
      while(1) {
        var startTextIndex = textIndex;
        curr = HEAP8[(textIndex)];
        if (curr === 0) break;
        next = HEAP8[((textIndex+1)|0)];
        if (curr == 37) {
          // Handle flags.
          var flagAlwaysSigned = false;
          var flagLeftAlign = false;
          var flagAlternative = false;
          var flagZeroPad = false;
          var flagPadSign = false;
          flagsLoop: while (1) {
            switch (next) {
              case 43:
                flagAlwaysSigned = true;
                break;
              case 45:
                flagLeftAlign = true;
                break;
              case 35:
                flagAlternative = true;
                break;
              case 48:
                if (flagZeroPad) {
                  break flagsLoop;
                } else {
                  flagZeroPad = true;
                  break;
                }
              case 32:
                flagPadSign = true;
                break;
              default:
                break flagsLoop;
            }
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          }
  
          // Handle width.
          var width = 0;
          if (next == 42) {
            width = getNextArg('i32');
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          } else {
            while (next >= 48 && next <= 57) {
              width = width * 10 + (next - 48);
              textIndex++;
              next = HEAP8[((textIndex+1)|0)];
            }
          }
  
          // Handle precision.
          var precisionSet = false, precision = -1;
          if (next == 46) {
            precision = 0;
            precisionSet = true;
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
            if (next == 42) {
              precision = getNextArg('i32');
              textIndex++;
            } else {
              while(1) {
                var precisionChr = HEAP8[((textIndex+1)|0)];
                if (precisionChr < 48 ||
                    precisionChr > 57) break;
                precision = precision * 10 + (precisionChr - 48);
                textIndex++;
              }
            }
            next = HEAP8[((textIndex+1)|0)];
          }
          if (precision < 0) {
            precision = 6; // Standard default.
            precisionSet = false;
          }
  
          // Handle integer sizes. WARNING: These assume a 32-bit architecture!
          var argSize;
          switch (String.fromCharCode(next)) {
            case 'h':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 104) {
                textIndex++;
                argSize = 1; // char (actually i32 in varargs)
              } else {
                argSize = 2; // short (actually i32 in varargs)
              }
              break;
            case 'l':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 108) {
                textIndex++;
                argSize = 8; // long long
              } else {
                argSize = 4; // long
              }
              break;
            case 'L': // long long
            case 'q': // int64_t
            case 'j': // intmax_t
              argSize = 8;
              break;
            case 'z': // size_t
            case 't': // ptrdiff_t
            case 'I': // signed ptrdiff_t or unsigned size_t
              argSize = 4;
              break;
            default:
              argSize = null;
          }
          if (argSize) textIndex++;
          next = HEAP8[((textIndex+1)|0)];
  
          // Handle type specifier.
          switch (String.fromCharCode(next)) {
            case 'd': case 'i': case 'u': case 'o': case 'x': case 'X': case 'p': {
              // Integer.
              var signed = next == 100 || next == 105;
              argSize = argSize || 4;
              var currArg = getNextArg('i' + (argSize * 8));
              var origArg = currArg;
              var argText;
              // Flatten i64-1 [low, high] into a (slightly rounded) double
              if (argSize == 8) {
                currArg = Runtime.makeBigInt(currArg[0], currArg[1], next == 117);
              }
              // Truncate to requested size.
              if (argSize <= 4) {
                var limit = Math.pow(256, argSize) - 1;
                currArg = (signed ? reSign : unSign)(currArg & limit, argSize * 8);
              }
              // Format the number.
              var currAbsArg = Math.abs(currArg);
              var prefix = '';
              if (next == 100 || next == 105) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], null); else
                argText = reSign(currArg, 8 * argSize, 1).toString(10);
              } else if (next == 117) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], true); else
                argText = unSign(currArg, 8 * argSize, 1).toString(10);
                currArg = Math.abs(currArg);
              } else if (next == 111) {
                argText = (flagAlternative ? '0' : '') + currAbsArg.toString(8);
              } else if (next == 120 || next == 88) {
                prefix = (flagAlternative && currArg != 0) ? '0x' : '';
                if (argSize == 8 && i64Math) {
                  if (origArg[1]) {
                    argText = (origArg[1]>>>0).toString(16);
                    var lower = (origArg[0]>>>0).toString(16);
                    while (lower.length < 8) lower = '0' + lower;
                    argText += lower;
                  } else {
                    argText = (origArg[0]>>>0).toString(16);
                  }
                } else
                if (currArg < 0) {
                  // Represent negative numbers in hex as 2's complement.
                  currArg = -currArg;
                  argText = (currAbsArg - 1).toString(16);
                  var buffer = [];
                  for (var i = 0; i < argText.length; i++) {
                    buffer.push((0xF - parseInt(argText[i], 16)).toString(16));
                  }
                  argText = buffer.join('');
                  while (argText.length < argSize * 2) argText = 'f' + argText;
                } else {
                  argText = currAbsArg.toString(16);
                }
                if (next == 88) {
                  prefix = prefix.toUpperCase();
                  argText = argText.toUpperCase();
                }
              } else if (next == 112) {
                if (currAbsArg === 0) {
                  argText = '(nil)';
                } else {
                  prefix = '0x';
                  argText = currAbsArg.toString(16);
                }
              }
              if (precisionSet) {
                while (argText.length < precision) {
                  argText = '0' + argText;
                }
              }
  
              // Add sign if needed
              if (currArg >= 0) {
                if (flagAlwaysSigned) {
                  prefix = '+' + prefix;
                } else if (flagPadSign) {
                  prefix = ' ' + prefix;
                }
              }
  
              // Move sign to prefix so we zero-pad after the sign
              if (argText.charAt(0) == '-') {
                prefix = '-' + prefix;
                argText = argText.substr(1);
              }
  
              // Add padding.
              while (prefix.length + argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad) {
                    argText = '0' + argText;
                  } else {
                    prefix = ' ' + prefix;
                  }
                }
              }
  
              // Insert the result into the buffer.
              argText = prefix + argText;
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 'f': case 'F': case 'e': case 'E': case 'g': case 'G': {
              // Float.
              var currArg = getNextArg('double');
              var argText;
              if (isNaN(currArg)) {
                argText = 'nan';
                flagZeroPad = false;
              } else if (!isFinite(currArg)) {
                argText = (currArg < 0 ? '-' : '') + 'inf';
                flagZeroPad = false;
              } else {
                var isGeneral = false;
                var effectivePrecision = Math.min(precision, 20);
  
                // Convert g/G to f/F or e/E, as per:
                // http://pubs.opengroup.org/onlinepubs/9699919799/functions/printf.html
                if (next == 103 || next == 71) {
                  isGeneral = true;
                  precision = precision || 1;
                  var exponent = parseInt(currArg.toExponential(effectivePrecision).split('e')[1], 10);
                  if (precision > exponent && exponent >= -4) {
                    next = ((next == 103) ? 'f' : 'F').charCodeAt(0);
                    precision -= exponent + 1;
                  } else {
                    next = ((next == 103) ? 'e' : 'E').charCodeAt(0);
                    precision--;
                  }
                  effectivePrecision = Math.min(precision, 20);
                }
  
                if (next == 101 || next == 69) {
                  argText = currArg.toExponential(effectivePrecision);
                  // Make sure the exponent has at least 2 digits.
                  if (/[eE][-+]\d$/.test(argText)) {
                    argText = argText.slice(0, -1) + '0' + argText.slice(-1);
                  }
                } else if (next == 102 || next == 70) {
                  argText = currArg.toFixed(effectivePrecision);
                  if (currArg === 0 && __reallyNegative(currArg)) {
                    argText = '-' + argText;
                  }
                }
  
                var parts = argText.split('e');
                if (isGeneral && !flagAlternative) {
                  // Discard trailing zeros and periods.
                  while (parts[0].length > 1 && parts[0].indexOf('.') != -1 &&
                         (parts[0].slice(-1) == '0' || parts[0].slice(-1) == '.')) {
                    parts[0] = parts[0].slice(0, -1);
                  }
                } else {
                  // Make sure we have a period in alternative mode.
                  if (flagAlternative && argText.indexOf('.') == -1) parts[0] += '.';
                  // Zero pad until required precision.
                  while (precision > effectivePrecision++) parts[0] += '0';
                }
                argText = parts[0] + (parts.length > 1 ? 'e' + parts[1] : '');
  
                // Capitalize 'E' if needed.
                if (next == 69) argText = argText.toUpperCase();
  
                // Add sign.
                if (currArg >= 0) {
                  if (flagAlwaysSigned) {
                    argText = '+' + argText;
                  } else if (flagPadSign) {
                    argText = ' ' + argText;
                  }
                }
              }
  
              // Add padding.
              while (argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad && (argText[0] == '-' || argText[0] == '+')) {
                    argText = argText[0] + '0' + argText.slice(1);
                  } else {
                    argText = (flagZeroPad ? '0' : ' ') + argText;
                  }
                }
              }
  
              // Adjust case.
              if (next < 97) argText = argText.toUpperCase();
  
              // Insert the result into the buffer.
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 's': {
              // String.
              var arg = getNextArg('i8*');
              var argLength = arg ? _strlen(arg) : '(null)'.length;
              if (precisionSet) argLength = Math.min(argLength, precision);
              if (!flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              if (arg) {
                for (var i = 0; i < argLength; i++) {
                  ret.push(HEAPU8[((arg++)|0)]);
                }
              } else {
                ret = ret.concat(intArrayFromString('(null)'.substr(0, argLength), true));
              }
              if (flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              break;
            }
            case 'c': {
              // Character.
              if (flagLeftAlign) ret.push(getNextArg('i8'));
              while (--width > 0) {
                ret.push(32);
              }
              if (!flagLeftAlign) ret.push(getNextArg('i8'));
              break;
            }
            case 'n': {
              // Write the length written so far to the next parameter.
              var ptr = getNextArg('i32*');
              HEAP32[((ptr)>>2)]=ret.length;
              break;
            }
            case '%': {
              // Literal percent sign.
              ret.push(curr);
              break;
            }
            default: {
              // Unknown specifiers remain untouched.
              for (var i = startTextIndex; i < textIndex + 2; i++) {
                ret.push(HEAP8[(i)]);
              }
            }
          }
          textIndex += 2;
          // TODO: Support a/A (hex float) and m (last error) specifiers.
          // TODO: Support %1${specifier} for arg selection.
        } else {
          ret.push(curr);
          textIndex += 1;
        }
      }
      return ret;
    }function _snprintf(s, n, format, varargs) {
      // int snprintf(char *restrict s, size_t n, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var limit = (n === undefined) ? result.length
                                    : Math.min(result.length, Math.max(n - 1, 0));
      if (s < 0) {
        s = -s;
        var buf = _malloc(limit+1);
        HEAP32[((s)>>2)]=buf;
        s = buf;
      }
      for (var i = 0; i < limit; i++) {
        HEAP8[(((s)+(i))|0)]=result[i];
      }
      if (limit < n || (n === undefined)) HEAP8[(((s)+(i))|0)]=0;
      return result.length;
    }

  
  
  
  function _recv(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _read(fd, buf, len);
    }
  
  function _pread(fildes, buf, nbyte, offset) {
      // ssize_t pread(int fildes, void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _read(fildes, buf, nbyte) {
      // ssize_t read(int fildes, void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fread(ptr, size, nitems, stream) {
      // size_t fread(void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fread.html
      var bytesToRead = nitems * size;
      if (bytesToRead == 0) {
        return 0;
      }
      var bytesRead = 0;
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      while (streamObj.ungotten.length && bytesToRead > 0) {
        HEAP8[((ptr++)|0)]=streamObj.ungotten.pop();
        bytesToRead--;
        bytesRead++;
      }
      var err = _read(streamObj.fd, ptr, bytesToRead);
      if (err == -1) {
        if (streamObj) streamObj.error = true;
        return 0;
      }
      bytesRead += err;
      if (bytesRead < bytesToRead) streamObj.eof = true;
      return Math.floor(bytesRead / size);
    }function _fgetc(stream) {
      // int fgetc(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fgetc.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) return -1;
      if (streamObj.eof || streamObj.error) return -1;
      var ret = _fread(_fgetc.ret, 1, 1, stream);
      if (ret == 0) {
        return -1;
      } else if (ret == -1) {
        streamObj.error = true;
        return -1;
      } else {
        return HEAPU8[((_fgetc.ret)|0)];
      }
    }

  function _pclose(stream) {
      // int pclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/pclose.html
      // We allow only one process, so no pipes.
      ___setErrNo(ERRNO_CODES.ECHILD);
      return -1;
    }

   
  Module["_memset"] = _memset;

  var _BDtoILow=true;


   
  Module["_bitshift64Shl"] = _bitshift64Shl;

  var _llvm_memcpy_p0i8_p0i8_i32=_memcpy;

  function ___assert_fail(condition, filename, line, func) {
      ABORT = true;
      throw 'Assertion failed: ' + Pointer_stringify(condition) + ', at: ' + [filename ? Pointer_stringify(filename) : 'unknown filename', line, func ? Pointer_stringify(func) : 'unknown function'] + ' at ' + stackTrace();
    }

  function _lis_matrix_assemble() {
  Module['printErr']('missing function: lis_matrix_assemble'); abort(-1);
  }

  
  function _isdigit(chr) {
      return chr >= 48 && chr <= 57;
    }function _isdigit_l(chr) {
      return _isdigit(chr); // no locale support yet
    }

  function _atexit(func, arg) {
      __ATEXIT__.unshift({ func: func, arg: arg });
    }


  function _access(path, amode) {
      // int access(const char *path, int amode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/access.html
      path = Pointer_stringify(path);
      if (amode & ~7) {
        // need a valid mode
        ___setErrNo(ERRNO_CODES.EINVAL);
        return -1;
      }
      var node;
      try {
        var lookup = FS.lookupPath(path, { follow: true });
        node = lookup.node;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
      var perms = '';
      if (amode & 4) perms += 'r';
      if (amode & 2) perms += 'w';
      if (amode & 1) perms += 'x';
      if (perms /* otherwise, they've just passed F_OK */ && FS.nodePermissions(node, perms)) {
        ___setErrNo(ERRNO_CODES.EACCES);
        return -1;
      }
      return 0;
    }

  function _ftell(stream) {
      // long ftell(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftell.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      if (FS.isChrdev(stream.node.mode)) {
        ___setErrNo(ERRNO_CODES.ESPIPE);
        return -1;
      } else {
        return stream.position;
      }
    }

  
  function __exit(status) {
      // void _exit(int status);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/exit.html
      Module['exit'](status);
    }function _exit(status) {
      __exit(status);
    }

  function _sprintf(s, format, varargs) {
      // int sprintf(char *restrict s, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      return _snprintf(s, undefined, format, varargs);
    }

  var _emscripten_get_longjmp_result=true;

  function ___ctype_b_loc() {
      // http://refspecs.freestandards.org/LSB_3.0.0/LSB-Core-generic/LSB-Core-generic/baselib---ctype-b-loc.html
      var me = ___ctype_b_loc;
      if (!me.ret) {
        var values = [
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,8195,8194,8194,8194,8194,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,24577,49156,49156,49156,
          49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,55304,55304,55304,55304,55304,55304,55304,55304,
          55304,55304,49156,49156,49156,49156,49156,49156,49156,54536,54536,54536,54536,54536,54536,50440,50440,50440,50440,50440,
          50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,49156,49156,49156,49156,49156,
          49156,54792,54792,54792,54792,54792,54792,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,
          50696,50696,50696,50696,50696,50696,50696,49156,49156,49156,49156,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        ];
        var i16size = 2;
        var arr = _malloc(values.length * i16size);
        for (var i = 0; i < values.length; i++) {
          HEAP16[(((arr)+(i * i16size))>>1)]=values[i];
        }
        me.ret = allocate([arr + 128 * i16size], 'i16*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _strrchr(ptr, chr) {
      var ptr2 = ptr + _strlen(ptr);
      do {
        if (HEAP8[(ptr2)] == chr) return ptr2;
        ptr2--;
      } while (ptr2 >= ptr);
      return 0;
    }

  function _freelocale(locale) {
      _free(locale);
    }

  function _catgets(catd, set_id, msg_id, s) {
      // char *catgets (nl_catd catd, int set_id, int msg_id, const char *s)
      return s;
    }

  function _fmod(x, y) {
      return x % y;
    }

  function _fmax(x, y) {
      return isNaN(x) ? y : isNaN(y) ? x : Math.max(x, y);
    }

  function _asprintf(s, format, varargs) {
      return _sprintf(-s, format, varargs);
    }

  function _GC_malloc() {
  Module['printErr']('missing function: GC_malloc'); abort(-1);
  }

  function ___cxa_guard_acquire(variable) {
      if (!HEAP8[(variable)]) { // ignore SAFE_HEAP stuff because llvm mixes i64 and i8 here
        HEAP8[(variable)]=1;
        return 1;
      }
      return 0;
    }

  function _lis_vector_destroy() {
  Module['printErr']('missing function: lis_vector_destroy'); abort(-1);
  }

  
  function __ZSt18uncaught_exceptionv() { // std::uncaught_exception()
      return !!__ZSt18uncaught_exceptionv.uncaught_exception;
    }function ___cxa_begin_catch(ptr) {
      __ZSt18uncaught_exceptionv.uncaught_exception--;
      ___cxa_caught_exceptions.push(___cxa_last_thrown_exception);
      return ptr;
    }

  function _lis_vector_create() {
  Module['printErr']('missing function: lis_vector_create'); abort(-1);
  }

  function _lis_matrix_set_type() {
  Module['printErr']('missing function: lis_matrix_set_type'); abort(-1);
  }


  var _cos=Math_cos;

  function _lis_matrix_set_value() {
  Module['printErr']('missing function: lis_matrix_set_value'); abort(-1);
  }



  function __ZNSt9exceptionD2Ev() {}

  function _lis_solver_destroy() {
  Module['printErr']('missing function: lis_solver_destroy'); abort(-1);
  }

  function _popen(command, mode) {
      // FILE *popen(const char *command, const char *mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/popen.html
      // We allow only one process, so no pipes.
      ___setErrNo(ERRNO_CODES.EMFILE);
      return 0;
    }

  function _isblank(chr) {
      return chr == 32 || chr == 9;
    }

   
  Module["_strcpy"] = _strcpy;

  function _copysign(a, b) {
      return __reallyNegative(a) === __reallyNegative(b) ? a : -a;
    }

  function _bsearch(key, base, num, size, compar) {
      function cmp(x, y) {
        return Module['dynCall_iii'](compar, x, y);
      };
      var left = 0;
      var right = num;
      var mid, test, addr;
  
      while (left < right) {
        mid = (left + right) >>> 1;
        addr = base + (mid * size);
        test = cmp(key, addr);
        if (test < 0) {
          right = mid;
        } else if (test > 0) {
          left = mid + 1;
        } else {
          return addr;
        }
      }
  
      return 0;
    }

  function _fmin(x, y) {
      return isNaN(x) ? y : isNaN(y) ? x : Math.min(x, y);
    }

  
  var PTHREAD_SPECIFIC_NEXT_KEY=1;function _pthread_key_create(key, destructor) {
      if (key == 0) {
        return ERRNO_CODES.EINVAL;
      }
      HEAP32[((key)>>2)]=PTHREAD_SPECIFIC_NEXT_KEY;
      // values start at 0
      PTHREAD_SPECIFIC[PTHREAD_SPECIFIC_NEXT_KEY] = 0;
      PTHREAD_SPECIFIC_NEXT_KEY++;
      return 0;
    }

  function _lis_vector_get_values() {
  Module['printErr']('missing function: lis_vector_get_values'); abort(-1);
  }

  var _acos=Math_acos;

  
  function __isLeapYear(year) {
        return year%4 === 0 && (year%100 !== 0 || year%400 === 0);
    }
  
  function __arraySum(array, index) {
      var sum = 0;
      for (var i = 0; i <= index; sum += array[i++]);
      return sum;
    }
  
  
  var __MONTH_DAYS_LEAP=[31,29,31,30,31,30,31,31,30,31,30,31];
  
  var __MONTH_DAYS_REGULAR=[31,28,31,30,31,30,31,31,30,31,30,31];function __addDays(date, days) {
      var newDate = new Date(date.getTime());
      while(days > 0) {
        var leap = __isLeapYear(newDate.getFullYear());
        var currentMonth = newDate.getMonth();
        var daysInCurrentMonth = (leap ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR)[currentMonth];
  
        if (days > daysInCurrentMonth-newDate.getDate()) {
          // we spill over to next month
          days -= (daysInCurrentMonth-newDate.getDate()+1);
          newDate.setDate(1);
          if (currentMonth < 11) {
            newDate.setMonth(currentMonth+1)
          } else {
            newDate.setMonth(0);
            newDate.setFullYear(newDate.getFullYear()+1);
          }
        } else {
          // we stay in current month 
          newDate.setDate(newDate.getDate()+days);
          return newDate;
        }
      }
  
      return newDate;
    }function _strftime(s, maxsize, format, tm) {
      // size_t strftime(char *restrict s, size_t maxsize, const char *restrict format, const struct tm *restrict timeptr);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/strftime.html
      
      var date = {
        tm_sec: HEAP32[((tm)>>2)],
        tm_min: HEAP32[(((tm)+(4))>>2)],
        tm_hour: HEAP32[(((tm)+(8))>>2)],
        tm_mday: HEAP32[(((tm)+(12))>>2)],
        tm_mon: HEAP32[(((tm)+(16))>>2)],
        tm_year: HEAP32[(((tm)+(20))>>2)],
        tm_wday: HEAP32[(((tm)+(24))>>2)],
        tm_yday: HEAP32[(((tm)+(28))>>2)],
        tm_isdst: HEAP32[(((tm)+(32))>>2)]
      };
  
      var pattern = Pointer_stringify(format);
  
      // expand format
      var EXPANSION_RULES_1 = {
        '%c': '%a %b %d %H:%M:%S %Y',     // Replaced by the locale's appropriate date and time representation - e.g., Mon Aug  3 14:02:01 2013
        '%D': '%m/%d/%y',                 // Equivalent to %m / %d / %y
        '%F': '%Y-%m-%d',                 // Equivalent to %Y - %m - %d
        '%h': '%b',                       // Equivalent to %b
        '%r': '%I:%M:%S %p',              // Replaced by the time in a.m. and p.m. notation
        '%R': '%H:%M',                    // Replaced by the time in 24-hour notation
        '%T': '%H:%M:%S',                 // Replaced by the time
        '%x': '%m/%d/%y',                 // Replaced by the locale's appropriate date representation
        '%X': '%H:%M:%S',                 // Replaced by the locale's appropriate date representation
      };
      for (var rule in EXPANSION_RULES_1) {
        pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_1[rule]);
      }
  
      var WEEKDAYS = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
      var MONTHS = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
  
      function leadingSomething(value, digits, character) {
        var str = typeof value === 'number' ? value.toString() : (value || '');
        while (str.length < digits) {
          str = character[0]+str;
        }
        return str;
      };
  
      function leadingNulls(value, digits) {
        return leadingSomething(value, digits, '0');
      };
  
      function compareByDay(date1, date2) {
        function sgn(value) {
          return value < 0 ? -1 : (value > 0 ? 1 : 0);
        };
  
        var compare;
        if ((compare = sgn(date1.getFullYear()-date2.getFullYear())) === 0) {
          if ((compare = sgn(date1.getMonth()-date2.getMonth())) === 0) {
            compare = sgn(date1.getDate()-date2.getDate());
          }
        }
        return compare;
      };
  
      function getFirstWeekStartDate(janFourth) {
          switch (janFourth.getDay()) {
            case 0: // Sunday
              return new Date(janFourth.getFullYear()-1, 11, 29);
            case 1: // Monday
              return janFourth;
            case 2: // Tuesday
              return new Date(janFourth.getFullYear(), 0, 3);
            case 3: // Wednesday
              return new Date(janFourth.getFullYear(), 0, 2);
            case 4: // Thursday
              return new Date(janFourth.getFullYear(), 0, 1);
            case 5: // Friday
              return new Date(janFourth.getFullYear()-1, 11, 31);
            case 6: // Saturday
              return new Date(janFourth.getFullYear()-1, 11, 30);
          }
      };
  
      function getWeekBasedYear(date) {
          var thisDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          var janFourthThisYear = new Date(thisDate.getFullYear(), 0, 4);
          var janFourthNextYear = new Date(thisDate.getFullYear()+1, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          if (compareByDay(firstWeekStartThisYear, thisDate) <= 0) {
            // this date is after the start of the first week of this year
            if (compareByDay(firstWeekStartNextYear, thisDate) <= 0) {
              return thisDate.getFullYear()+1;
            } else {
              return thisDate.getFullYear();
            }
          } else { 
            return thisDate.getFullYear()-1;
          }
      };
  
      var EXPANSION_RULES_2 = {
        '%a': function(date) {
          return WEEKDAYS[date.tm_wday].substring(0,3);
        },
        '%A': function(date) {
          return WEEKDAYS[date.tm_wday];
        },
        '%b': function(date) {
          return MONTHS[date.tm_mon].substring(0,3);
        },
        '%B': function(date) {
          return MONTHS[date.tm_mon];
        },
        '%C': function(date) {
          var year = date.tm_year+1900;
          return leadingNulls(Math.floor(year/100),2);
        },
        '%d': function(date) {
          return leadingNulls(date.tm_mday, 2);
        },
        '%e': function(date) {
          return leadingSomething(date.tm_mday, 2, ' ');
        },
        '%g': function(date) {
          // %g, %G, and %V give values according to the ISO 8601:2000 standard week-based year. 
          // In this system, weeks begin on a Monday and week 1 of the year is the week that includes 
          // January 4th, which is also the week that includes the first Thursday of the year, and 
          // is also the first week that contains at least four days in the year. 
          // If the first Monday of January is the 2nd, 3rd, or 4th, the preceding days are part of 
          // the last week of the preceding year; thus, for Saturday 2nd January 1999, 
          // %G is replaced by 1998 and %V is replaced by 53. If December 29th, 30th, 
          // or 31st is a Monday, it and any following days are part of week 1 of the following year. 
          // Thus, for Tuesday 30th December 1997, %G is replaced by 1998 and %V is replaced by 01.
          
          return getWeekBasedYear(date).toString().substring(2);
        },
        '%G': function(date) {
          return getWeekBasedYear(date);
        },
        '%H': function(date) {
          return leadingNulls(date.tm_hour, 2);
        },
        '%I': function(date) {
          return leadingNulls(date.tm_hour < 13 ? date.tm_hour : date.tm_hour-12, 2);
        },
        '%j': function(date) {
          // Day of the year (001-366)
          return leadingNulls(date.tm_mday+__arraySum(__isLeapYear(date.tm_year+1900) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, date.tm_mon-1), 3);
        },
        '%m': function(date) {
          return leadingNulls(date.tm_mon+1, 2);
        },
        '%M': function(date) {
          return leadingNulls(date.tm_min, 2);
        },
        '%n': function() {
          return '\n';
        },
        '%p': function(date) {
          if (date.tm_hour > 0 && date.tm_hour < 13) {
            return 'AM';
          } else {
            return 'PM';
          }
        },
        '%S': function(date) {
          return leadingNulls(date.tm_sec, 2);
        },
        '%t': function() {
          return '\t';
        },
        '%u': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay() || 7;
        },
        '%U': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Sunday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year+1900, 0, 1);
          var firstSunday = janFirst.getDay() === 0 ? janFirst : __addDays(janFirst, 7-janFirst.getDay());
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
          
          // is target date after the first Sunday?
          if (compareByDay(firstSunday, endDate) < 0) {
            // calculate difference in days between first Sunday and endDate
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstSundayUntilEndJanuary = 31-firstSunday.getDate();
            var days = firstSundayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
  
          return compareByDay(firstSunday, janFirst) === 0 ? '01': '00';
        },
        '%V': function(date) {
          // Replaced by the week number of the year (Monday as the first day of the week) 
          // as a decimal number [01,53]. If the week containing 1 January has four 
          // or more days in the new year, then it is considered week 1. 
          // Otherwise, it is the last week of the previous year, and the next week is week 1. 
          // Both January 4th and the first Thursday of January are always in week 1. [ tm_year, tm_wday, tm_yday]
          var janFourthThisYear = new Date(date.tm_year+1900, 0, 4);
          var janFourthNextYear = new Date(date.tm_year+1901, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          var endDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          if (compareByDay(endDate, firstWeekStartThisYear) < 0) {
            // if given date is before this years first week, then it belongs to the 53rd week of last year
            return '53';
          } 
  
          if (compareByDay(firstWeekStartNextYear, endDate) <= 0) {
            // if given date is after next years first week, then it belongs to the 01th week of next year
            return '01';
          }
  
          // given date is in between CW 01..53 of this calendar year
          var daysDifference;
          if (firstWeekStartThisYear.getFullYear() < date.tm_year+1900) {
            // first CW of this year starts last year
            daysDifference = date.tm_yday+32-firstWeekStartThisYear.getDate()
          } else {
            // first CW of this year starts this year
            daysDifference = date.tm_yday+1-firstWeekStartThisYear.getDate();
          }
          return leadingNulls(Math.ceil(daysDifference/7), 2);
        },
        '%w': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay();
        },
        '%W': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Monday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year, 0, 1);
          var firstMonday = janFirst.getDay() === 1 ? janFirst : __addDays(janFirst, janFirst.getDay() === 0 ? 1 : 7-janFirst.getDay()+1);
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
  
          // is target date after the first Monday?
          if (compareByDay(firstMonday, endDate) < 0) {
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstMondayUntilEndJanuary = 31-firstMonday.getDate();
            var days = firstMondayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
          return compareByDay(firstMonday, janFirst) === 0 ? '01': '00';
        },
        '%y': function(date) {
          // Replaced by the last two digits of the year as a decimal number [00,99]. [ tm_year]
          return (date.tm_year+1900).toString().substring(2);
        },
        '%Y': function(date) {
          // Replaced by the year as a decimal number (for example, 1997). [ tm_year]
          return date.tm_year+1900;
        },
        '%z': function(date) {
          // Replaced by the offset from UTC in the ISO 8601:2000 standard format ( +hhmm or -hhmm ),
          // or by no characters if no timezone is determinable. 
          // For example, "-0430" means 4 hours 30 minutes behind UTC (west of Greenwich). 
          // If tm_isdst is zero, the standard time offset is used. 
          // If tm_isdst is greater than zero, the daylight savings time offset is used. 
          // If tm_isdst is negative, no characters are returned. 
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%Z': function(date) {
          // Replaced by the timezone name or abbreviation, or by no bytes if no timezone information exists. [ tm_isdst]
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%%': function() {
          return '%';
        }
      };
      for (var rule in EXPANSION_RULES_2) {
        if (pattern.indexOf(rule) >= 0) {
          pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_2[rule](date));
        }
      }
  
      var bytes = intArrayFromString(pattern, false);
      if (bytes.length > maxsize) {
        return 0;
      } 
  
      writeArrayToMemory(bytes, s);
      return bytes.length-1;
    }

  var ___cxa_atexit=_atexit;

  
   
  Module["_rand_r"] = _rand_r;
  
  var ___rand_seed=allocate([0x0273459b, 0, 0, 0], "i32", ALLOC_STATIC); 
  Module["_rand"] = _rand;

  var _llvm_memset_p0i8_i32=_memset;

   
  Module["_i64Subtract"] = _i64Subtract;

   
  Module["_i64Add"] = _i64Add;

  var _pow=Math_pow;

  
  
  
  function ___cxa_is_number_type(type) {
      var isNumber = false;
      try { if (type == __ZTIi) isNumber = true } catch(e){}
      try { if (type == __ZTIj) isNumber = true } catch(e){}
      try { if (type == __ZTIl) isNumber = true } catch(e){}
      try { if (type == __ZTIm) isNumber = true } catch(e){}
      try { if (type == __ZTIx) isNumber = true } catch(e){}
      try { if (type == __ZTIy) isNumber = true } catch(e){}
      try { if (type == __ZTIf) isNumber = true } catch(e){}
      try { if (type == __ZTId) isNumber = true } catch(e){}
      try { if (type == __ZTIe) isNumber = true } catch(e){}
      try { if (type == __ZTIc) isNumber = true } catch(e){}
      try { if (type == __ZTIa) isNumber = true } catch(e){}
      try { if (type == __ZTIh) isNumber = true } catch(e){}
      try { if (type == __ZTIs) isNumber = true } catch(e){}
      try { if (type == __ZTIt) isNumber = true } catch(e){}
      return isNumber;
    }function ___cxa_does_inherit(definiteType, possibilityType, possibility) {
      if (possibility == 0) return false;
      if (possibilityType == 0 || possibilityType == definiteType)
        return true;
      var possibility_type_info;
      if (___cxa_is_number_type(possibilityType)) {
        possibility_type_info = possibilityType;
      } else {
        var possibility_type_infoAddr = HEAP32[((possibilityType)>>2)] - 8;
        possibility_type_info = HEAP32[((possibility_type_infoAddr)>>2)];
      }
      switch (possibility_type_info) {
      case 0: // possibility is a pointer
        // See if definite type is a pointer
        var definite_type_infoAddr = HEAP32[((definiteType)>>2)] - 8;
        var definite_type_info = HEAP32[((definite_type_infoAddr)>>2)];
        if (definite_type_info == 0) {
          // Also a pointer; compare base types of pointers
          var defPointerBaseAddr = definiteType+8;
          var defPointerBaseType = HEAP32[((defPointerBaseAddr)>>2)];
          var possPointerBaseAddr = possibilityType+8;
          var possPointerBaseType = HEAP32[((possPointerBaseAddr)>>2)];
          return ___cxa_does_inherit(defPointerBaseType, possPointerBaseType, possibility);
        } else
          return false; // one pointer and one non-pointer
      case 1: // class with no base class
        return false;
      case 2: // class with base class
        var parentTypeAddr = possibilityType + 8;
        var parentType = HEAP32[((parentTypeAddr)>>2)];
        return ___cxa_does_inherit(definiteType, parentType, possibility);
      default:
        return false; // some unencountered type
      }
    }
  
  function ___resumeException(ptr) {
      if (!___cxa_last_thrown_exception) { ___cxa_last_thrown_exception = ptr; }
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }function ___cxa_find_matching_catch(thrown, throwntype) {
      if (thrown == -1) thrown = ___cxa_last_thrown_exception;
      header = thrown - ___cxa_exception_header_size;
      if (throwntype == -1) throwntype = HEAP32[((header)>>2)];
      var typeArray = Array.prototype.slice.call(arguments, 2);
  
      // If throwntype is a pointer, this means a pointer has been
      // thrown. When a pointer is thrown, actually what's thrown
      // is a pointer to the pointer. We'll dereference it.
      if (throwntype != 0 && !___cxa_is_number_type(throwntype)) {
        var throwntypeInfoAddr= HEAP32[((throwntype)>>2)] - 8;
        var throwntypeInfo= HEAP32[((throwntypeInfoAddr)>>2)];
        if (throwntypeInfo == 0)
          thrown = HEAP32[((thrown)>>2)];
      }
      // The different catch blocks are denoted by different types.
      // Due to inheritance, those types may not precisely match the
      // type of the thrown object. Find one which matches, and
      // return the type of the catch block which should be called.
      for (var i = 0; i < typeArray.length; i++) {
        if (___cxa_does_inherit(typeArray[i], throwntype, thrown))
          return ((asm["setTempRet0"](typeArray[i]),thrown)|0);
      }
      // Shouldn't happen unless we have bogus data in typeArray
      // or encounter a type for which emscripten doesn't have suitable
      // typeinfo defined. Best-efforts match just in case.
      return ((asm["setTempRet0"](throwntype),thrown)|0);
    }function ___cxa_throw(ptr, type, destructor) {
      if (!___cxa_throw.initialized) {
        try {
          HEAP32[((__ZTVN10__cxxabiv119__pointer_type_infoE)>>2)]=0; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv117__class_type_infoE)>>2)]=1; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv120__si_class_type_infoE)>>2)]=2; // Workaround for libcxxabi integration bug
        } catch(e){}
        ___cxa_throw.initialized = true;
      }
      var header = ptr - ___cxa_exception_header_size;
      HEAP32[((header)>>2)]=type;
      HEAP32[(((header)+(4))>>2)]=destructor;
      ___cxa_last_thrown_exception = ptr;
      if (!("uncaught_exception" in __ZSt18uncaught_exceptionv)) {
        __ZSt18uncaught_exceptionv.uncaught_exception = 1;
      } else {
        __ZSt18uncaught_exceptionv.uncaught_exception++;
      }
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }

  function _lis_vector_set_value() {
  Module['printErr']('missing function: lis_vector_set_value'); abort(-1);
  }

  
  function _fprintf(stream, format, varargs) {
      // int fprintf(FILE *restrict stream, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var stack = Runtime.stackSave();
      var ret = _fwrite(allocate(result, 'i8', ALLOC_STACK), 1, result.length, stream);
      Runtime.stackRestore(stack);
      return ret;
    }function _printf(format, varargs) {
      // int printf(const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var stdout = HEAP32[((_stdout)>>2)];
      return _fprintf(stdout, format, varargs);
    }

  function _htonl(value) {
      return ((value & 0xff) << 24) + ((value & 0xff00) << 8) +
             ((value & 0xff0000) >>> 8) + ((value & 0xff000000) >>> 24);
    }


  function _lis_solve() {
  Module['printErr']('missing function: lis_solve'); abort(-1);
  }

   
  Module["_strncpy"] = _strncpy;

  function _strtoull_l(str, endptr, base) {
      return _strtoull(str, endptr, base); // no locale support yet
    }

  var _log=Math_log;

  var _emscripten_postinvoke=true;

  function _xerbla_() {
  Module['printErr']('missing function: xerbla_'); abort(-1);
  }

  var _copysignl=_copysign;

  
  function _strtoll(str, endptr, base) {
      return __parseInt64(str, endptr, base, '-9223372036854775808', '9223372036854775807');  // LLONG_MIN, LLONG_MAX.
    }function _strtoll_l(str, endptr, base) {
      return _strtoll(str, endptr, base); // no locale support yet
    }

  function _qsort(base, num, size, cmp) {
      if (num == 0 || size == 0) return;
      // forward calls to the JavaScript sort method
      // first, sort the items logically
      var keys = [];
      for (var i = 0; i < num; i++) keys.push(i);
      keys.sort(function(a, b) {
        return Module['dynCall_iii'](cmp, base+a*size, base+b*size);
      });
      // apply the sort
      var temp = _malloc(num*size);
      _memcpy(temp, base, num*size);
      for (var i = 0; i < num; i++) {
        if (keys[i] == i) continue; // already in place
        _memcpy(base+i*size, temp+keys[i]*size, size);
      }
      _free(temp);
    }

  function _system(command) {
      // int system(const char *command);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/system.html
      // Can't call external programs.
      ___setErrNo(ERRNO_CODES.EAGAIN);
      return -1;
    }

  function _lis_matrix_create() {
  Module['printErr']('missing function: lis_matrix_create'); abort(-1);
  }

  function _strdup(ptr) {
      var len = _strlen(ptr);
      var newStr = _malloc(len + 1);
      (_memcpy(newStr, ptr, len)|0);
      HEAP8[(((newStr)+(len))|0)]=0;
      return newStr;
    }

  function _log10(x) {
      return Math.log(x) / Math.LN10;
    }

   
  Module["_bitshift64Lshr"] = _bitshift64Lshr;

  function _srand(seed) {
      HEAP32[((___rand_seed)>>2)]=seed
    }

  function _isatty(fildes) {
      // int isatty(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/isatty.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      // HACK - implement tcgetattr
      if (!stream.tty) {
        ___setErrNo(ERRNO_CODES.ENOTTY);
        return 0;
      }
      return 1;
    }

  var _putc=_fputc;

  var _BDtoIHigh=true;

  function _pthread_cond_broadcast() {
      return 0;
    }

  
  
   
  Module["_testSetjmp"] = _testSetjmp;function _longjmp(env, value) {
      asm['setThrew'](env, value || 1);
      throw 'longjmp';
    }function _emscripten_longjmp(env, value) {
      _longjmp(env, value);
    }

  function __ZSt9terminatev() {
      _exit(-1234);
    }

  var _fseeko=_fseek;

  function _lis_matrix_set_size() {
  Module['printErr']('missing function: lis_matrix_set_size'); abort(-1);
  }

  function _vfprintf(s, f, va_arg) {
      return _fprintf(s, f, HEAP32[((va_arg)>>2)]);
    }

  
  function _atoi(ptr) {
      return _strtol(ptr, null, 10);
    }var _atol=_atoi;

  function _pthread_mutex_unlock() {}

  function _sbrk(bytes) {
      // Implement a Linux-like 'memory area' for our 'process'.
      // Changes the size of the memory area by |bytes|; returns the
      // address of the previous top ('break') of the memory area
      // We control the "dynamic" memory - DYNAMIC_BASE to DYNAMICTOP
      var self = _sbrk;
      if (!self.called) {
        DYNAMICTOP = alignMemoryPage(DYNAMICTOP); // make sure we start out aligned
        self.called = true;
        assert(Runtime.dynamicAlloc);
        self.alloc = Runtime.dynamicAlloc;
        Runtime.dynamicAlloc = function() { abort('cannot dynamically allocate, sbrk now has control') };
      }
      var ret = DYNAMICTOP;
      if (bytes != 0) self.alloc(bytes);
      return ret;  // Previous break location.
    }

  
  function _ungetc(c, stream) {
      // int ungetc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ungetc.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        return -1;
      }
      if (c === -1) {
        // do nothing for EOF character
        return c;
      }
      c = unSign(c & 0xFF);
      stream.ungotten.push(c);
      stream.eof = false;
      return c;
    }function _fscanf(stream, format, varargs) {
      // int fscanf(FILE *restrict stream, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        return -1;
      }
      var buffer = [];
      function get() {
        var c = _fgetc(stream);
        buffer.push(c);
        return c;
      };
      function unget() {
        _ungetc(buffer.pop(), stream);
      };
      return __scanString(format, get, unget, varargs);
    }


  var _BItoD=true;

  
  function _stat(path, buf, dontResolveLastLink) {
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/stat.html
      // int stat(const char *path, struct stat *buf);
      // NOTE: dontResolveLastLink is a shortcut for lstat(). It should never be
      //       used in client code.
      path = typeof path !== 'string' ? Pointer_stringify(path) : path;
      try {
        var stat = dontResolveLastLink ? FS.lstat(path) : FS.stat(path);
        HEAP32[((buf)>>2)]=stat.dev;
        HEAP32[(((buf)+(4))>>2)]=0;
        HEAP32[(((buf)+(8))>>2)]=stat.ino;
        HEAP32[(((buf)+(12))>>2)]=stat.mode;
        HEAP32[(((buf)+(16))>>2)]=stat.nlink;
        HEAP32[(((buf)+(20))>>2)]=stat.uid;
        HEAP32[(((buf)+(24))>>2)]=stat.gid;
        HEAP32[(((buf)+(28))>>2)]=stat.rdev;
        HEAP32[(((buf)+(32))>>2)]=0;
        HEAP32[(((buf)+(36))>>2)]=stat.size;
        HEAP32[(((buf)+(40))>>2)]=4096;
        HEAP32[(((buf)+(44))>>2)]=stat.blocks;
        HEAP32[(((buf)+(48))>>2)]=Math.floor(stat.atime.getTime() / 1000);
        HEAP32[(((buf)+(52))>>2)]=0;
        HEAP32[(((buf)+(56))>>2)]=Math.floor(stat.mtime.getTime() / 1000);
        HEAP32[(((buf)+(60))>>2)]=0;
        HEAP32[(((buf)+(64))>>2)]=Math.floor(stat.ctime.getTime() / 1000);
        HEAP32[(((buf)+(68))>>2)]=0;
        HEAP32[(((buf)+(72))>>2)]=stat.ino;
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fstat(fildes, buf) {
      // int fstat(int fildes, struct stat *buf);
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/fstat.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      return _stat(stream.path, buf);
    }

  function _catclose(catd) {
      // int catclose (nl_catd catd)
      return 0;
    }

  function _llvm_lifetime_start() {}

  function ___cxa_guard_release() {}


  
  function _truncate(path, length) {
      // int truncate(const char *path, off_t length);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/truncate.html
      // NOTE: The path argument may be a string, to simplify ftruncate().
      if (typeof path !== 'string') path = Pointer_stringify(path);
      try {
        FS.truncate(path, length);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _ftruncate(fildes, length) {
      // int ftruncate(int fildes, off_t length);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftruncate.html
      try {
        FS.ftruncate(fildes, length);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }

  function _uselocale(locale) {
      return 0;
    }

  function _vsnprintf(s, n, format, va_arg) {
      return _snprintf(s, n, format, HEAP32[((va_arg)>>2)]);
    }


  function _sysconf(name) {
      // long sysconf(int name);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/sysconf.html
      switch(name) {
        case 30: return PAGE_SIZE;
        case 132:
        case 133:
        case 12:
        case 137:
        case 138:
        case 15:
        case 235:
        case 16:
        case 17:
        case 18:
        case 19:
        case 20:
        case 149:
        case 13:
        case 10:
        case 236:
        case 153:
        case 9:
        case 21:
        case 22:
        case 159:
        case 154:
        case 14:
        case 77:
        case 78:
        case 139:
        case 80:
        case 81:
        case 79:
        case 82:
        case 68:
        case 67:
        case 164:
        case 11:
        case 29:
        case 47:
        case 48:
        case 95:
        case 52:
        case 51:
        case 46:
          return 200809;
        case 27:
        case 246:
        case 127:
        case 128:
        case 23:
        case 24:
        case 160:
        case 161:
        case 181:
        case 182:
        case 242:
        case 183:
        case 184:
        case 243:
        case 244:
        case 245:
        case 165:
        case 178:
        case 179:
        case 49:
        case 50:
        case 168:
        case 169:
        case 175:
        case 170:
        case 171:
        case 172:
        case 97:
        case 76:
        case 32:
        case 173:
        case 35:
          return -1;
        case 176:
        case 177:
        case 7:
        case 155:
        case 8:
        case 157:
        case 125:
        case 126:
        case 92:
        case 93:
        case 129:
        case 130:
        case 131:
        case 94:
        case 91:
          return 1;
        case 74:
        case 60:
        case 69:
        case 70:
        case 4:
          return 1024;
        case 31:
        case 42:
        case 72:
          return 32;
        case 87:
        case 26:
        case 33:
          return 2147483647;
        case 34:
        case 1:
          return 47839;
        case 38:
        case 36:
          return 99;
        case 43:
        case 37:
          return 2048;
        case 0: return 2097152;
        case 3: return 65536;
        case 28: return 32768;
        case 44: return 32767;
        case 75: return 16384;
        case 39: return 1000;
        case 89: return 700;
        case 71: return 256;
        case 40: return 255;
        case 2: return 100;
        case 180: return 64;
        case 25: return 20;
        case 5: return 16;
        case 6: return 6;
        case 73: return 4;
        case 84: return 1;
      }
      ___setErrNo(ERRNO_CODES.EINVAL);
      return -1;
    }


  var _ftello=_ftell;

  function _strftime_l(s, maxsize, format, tm) {
      return _strftime(s, maxsize, format, tm); // no locale support yet
    }

  function _abort() {
      Module['abort']();
    }




  var _tan=Math_tan;


  function _pthread_getspecific(key) {
      return PTHREAD_SPECIFIC[key] || 0;
    }

  var _fabs=Math_abs;

  var _floor=Math_floor;

  var _getc=_fgetc;

  var _sqrt=Math_sqrt;

  var _llvm_memmove_p0i8_p0i8_i32=_memmove;

  function _rewind(stream) {
      // void rewind(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/rewind.html
      _fseek(stream, 0, 0);  // SEEK_SET.
      var streamObj = FS.getStreamFromPtr(stream);
      if (streamObj) streamObj.error = false;
    }

  function ___cxa_allocate_exception(size) {
      var ptr = _malloc(size + ___cxa_exception_header_size);
      return ptr + ___cxa_exception_header_size;
    }

  var _sin=Math_sin;

  var _fmodl=_fmod;



  function _vasprintf(s, format, va_arg) {
      return _asprintf(s, format, HEAP32[((va_arg)>>2)]);
    }

  function _catopen(name, oflag) {
      // nl_catd catopen (const char *name, int oflag)
      return -1;
    }

  function ___ctype_toupper_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-toupper-loc.html
      var me = ___ctype_toupper_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,
          73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,
          81,82,83,84,85,86,87,88,89,90,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,
          145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,
          175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,
          205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,
          235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _lis_matrix_destroy() {
  Module['printErr']('missing function: lis_matrix_destroy'); abort(-1);
  }

  function ___ctype_tolower_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-tolower-loc.html
      var me = ___ctype_tolower_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,91,92,93,94,95,96,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,
          134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,
          164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,
          194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,
          224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,
          254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _lis_vector_set_size() {
  Module['printErr']('missing function: lis_vector_set_size'); abort(-1);
  }

  function _unlink(path) {
      // int unlink(const char *path);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/unlink.html
      path = Pointer_stringify(path);
      try {
        FS.unlink(path);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }


  var _emscripten_prep_setjmp=true;

  var _emscripten_setjmp=true;

  function _GC_collect_a_little() {
  Module['printErr']('missing function: GC_collect_a_little'); abort(-1);
  }


  function _lis_solver_set_option() {
  Module['printErr']('missing function: lis_solver_set_option'); abort(-1);
  }

  var _exp=Math_exp;

  function _time(ptr) {
      var ret = Math.floor(Date.now()/1000);
      if (ptr) {
        HEAP32[((ptr)>>2)]=ret;
      }
      return ret;
    }

  var __ZTISt9exception=allocate([allocate([1,0,0,0,0,0,0], "i8", ALLOC_STATIC)+8, 0], "i32", ALLOC_STATIC);

  var ___dso_handle=allocate(1, "i32*", ALLOC_STATIC);



FS.staticInit();__ATINIT__.unshift({ func: function() { if (!Module["noFSInit"] && !FS.init.initialized) FS.init() } });__ATMAIN__.push({ func: function() { FS.ignorePermissions = false } });__ATEXIT__.push({ func: function() { FS.quit() } });Module["FS_createFolder"] = FS.createFolder;Module["FS_createPath"] = FS.createPath;Module["FS_createDataFile"] = FS.createDataFile;Module["FS_createPreloadedFile"] = FS.createPreloadedFile;Module["FS_createLazyFile"] = FS.createLazyFile;Module["FS_createLink"] = FS.createLink;Module["FS_createDevice"] = FS.createDevice;
___errno_state = Runtime.staticAlloc(4); HEAP32[((___errno_state)>>2)]=0;
__ATINIT__.unshift({ func: function() { TTY.init() } });__ATEXIT__.push({ func: function() { TTY.shutdown() } });TTY.utf8 = new Runtime.UTF8Processor();
if (ENVIRONMENT_IS_NODE) { var fs = require("fs"); NODEFS.staticInit(); }
_fputc.ret = allocate([0], "i8", ALLOC_STATIC);
__ATINIT__.push({ func: function() { SOCKFS.root = FS.mount(SOCKFS, {}, null); } });
___strtok_state = Runtime.staticAlloc(4);
Module["requestFullScreen"] = function Module_requestFullScreen(lockPointer, resizeCanvas) { Browser.requestFullScreen(lockPointer, resizeCanvas) };
  Module["requestAnimationFrame"] = function Module_requestAnimationFrame(func) { Browser.requestAnimationFrame(func) };
  Module["setCanvasSize"] = function Module_setCanvasSize(width, height, noUpdates) { Browser.setCanvasSize(width, height, noUpdates) };
  Module["pauseMainLoop"] = function Module_pauseMainLoop() { Browser.mainLoop.pause() };
  Module["resumeMainLoop"] = function Module_resumeMainLoop() { Browser.mainLoop.resume() };
  Module["getUserMedia"] = function Module_getUserMedia() { Browser.getUserMedia() }
_fgetc.ret = allocate([0], "i8", ALLOC_STATIC);
STACK_BASE = STACKTOP = Runtime.alignMemory(STATICTOP);

staticSealed = true; // seal the static portion of memory

STACK_MAX = STACK_BASE + 5242880;

DYNAMIC_BASE = DYNAMICTOP = Runtime.alignMemory(STACK_MAX);

assert(DYNAMIC_BASE < TOTAL_MEMORY, "TOTAL_MEMORY not big enough for stack");

 var ctlz_i8 = allocate([8,7,6,6,5,5,5,5,4,4,4,4,4,4,4,4,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0], "i8", ALLOC_DYNAMIC);
 var cttz_i8 = allocate([8,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,7,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0], "i8", ALLOC_DYNAMIC);

var Math_min = Math.min;
function invoke_iiiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    return Module["dynCall_iiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiidiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vd(index,a1) {
  try {
    Module["dynCall_vd"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vi(index,a1) {
  try {
    Module["dynCall_vi"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vii(index,a1,a2) {
  try {
    Module["dynCall_vii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10) {
  try {
    return Module["dynCall_iiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_ii(index,a1) {
  try {
    return Module["dynCall_ii"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viidi(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_viidi"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13) {
  try {
    return Module["dynCall_iiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiii(index,a1,a2,a3) {
  try {
    return Module["dynCall_iiii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiid(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiid"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    Module["dynCall_viiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiii(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiii"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viidii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viidii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iid(index,a1,a2) {
  try {
    return Module["dynCall_iid"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiid(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiid"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    Module["dynCall_viiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iii(index,a1,a2) {
  try {
    return Module["dynCall_iii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiii(index,a1,a2,a3,a4,a5) {
  try {
    return Module["dynCall_iiiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiidi(index,a1,a2,a3,a4,a5,a6) {
  try {
    return Module["dynCall_iiiiidi"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_didd(index,a1,a2,a3) {
  try {
    return Module["dynCall_didd"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_dii(index,a1,a2) {
  try {
    return Module["dynCall_dii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_i(index) {
  try {
    return Module["dynCall_i"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    return Module["dynCall_iiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viii(index,a1,a2,a3) {
  try {
    Module["dynCall_viii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_v(index) {
  try {
    Module["dynCall_v"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiii(index,a1,a2,a3,a4) {
  try {
    return Module["dynCall_iiiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiii(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_viiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function asmPrintInt(x, y) {
  Module.print('int ' + x + ',' + y);// + ' ' + new Error().stack);
}
function asmPrintFloat(x, y) {
  Module.print('float ' + x + ',' + y);// + ' ' + new Error().stack);
}
// EMSCRIPTEN_START_ASM
var asm=(function(global,env,buffer){"use asm";var a=new global.Int8Array(buffer);var b=new global.Int16Array(buffer);var c=new global.Int32Array(buffer);var d=new global.Uint8Array(buffer);var e=new global.Uint16Array(buffer);var f=new global.Uint32Array(buffer);var g=new global.Float32Array(buffer);var h=new global.Float64Array(buffer);var i=env.STACKTOP|0;var j=env.STACK_MAX|0;var k=env.tempDoublePtr|0;var l=env.ABORT|0;var m=env.cttz_i8|0;var n=env.ctlz_i8|0;var o=env.___rand_seed|0;var p=env.__ZTISt9exception|0;var q=env.___dso_handle|0;var r=env._stderr|0;var s=env._stdin|0;var t=env._stdout|0;var u=0;var v=0;var w=0;var x=0;var y=+env.NaN,z=+env.Infinity;var A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0.0;var J=0;var K=0;var L=0;var M=0;var N=0;var O=0;var P=0;var Q=0;var R=0;var S=0;var T=global.Math.floor;var U=global.Math.abs;var V=global.Math.sqrt;var W=global.Math.pow;var X=global.Math.cos;var Y=global.Math.sin;var Z=global.Math.tan;var _=global.Math.acos;var $=global.Math.asin;var aa=global.Math.atan;var ba=global.Math.atan2;var ca=global.Math.exp;var da=global.Math.log;var ea=global.Math.ceil;var fa=global.Math.imul;var ga=env.abort;var ha=env.assert;var ia=env.asmPrintInt;var ja=env.asmPrintFloat;var ka=env.min;var la=env.invoke_iiiiiiii;var ma=env.invoke_viiiii;var na=env.invoke_iiiiidiii;var oa=env.invoke_vd;var pa=env.invoke_vi;var qa=env.invoke_vii;var ra=env.invoke_iiiiiiiiiii;var sa=env.invoke_ii;var ta=env.invoke_viidi;var ua=env.invoke_iiiiiiiiiiiiii;var va=env.invoke_iiii;var wa=env.invoke_iiiiiiiiiiiiiiiiiiiiiii;var xa=env.invoke_iiiiiiiiiiiiiiiiiiiii;var ya=env.invoke_viiiiid;var za=env.invoke_viiiiiiii;var Aa=env.invoke_iiiiiiiiiiiiiiiiiiiiiiiii;var Ba=env.invoke_viiiiii;var Ca=env.invoke_viidii;var Da=env.invoke_iid;var Ea=env.invoke_viiiiiii;var Fa=env.invoke_viiiiiid;var Ga=env.invoke_viiiiiiiii;var Ha=env.invoke_iii;var Ia=env.invoke_iiiiii;var Ja=env.invoke_iiiiidi;var Ka=env.invoke_didd;var La=env.invoke_dii;var Ma=env.invoke_i;var Na=env.invoke_iiiiiiiiii;var Oa=env.invoke_viii;var Pa=env.invoke_v;var Qa=env.invoke_iiiiiiiii;var Ra=env.invoke_iiiii;var Sa=env.invoke_viiii;var Ta=env._fabs;var Ua=env._exp;var Va=env._lis_matrix_assemble;var Wa=env._strrchr;var Xa=env._pthread_key_create;var Ya=env._vsscanf;var Za=env._fscanf;var _a=env.___cxa_guard_acquire;var $a=env._log10;var ab=env._fstat;var bb=env._pclose;var cb=env._lis_solver_create;var db=env.___assert_fail;var eb=env.__ZSt18uncaught_exceptionv;var fb=env._longjmp;var gb=env.__isLeapYear;var hb=env._clock_gettime;var ib=env._fsync;var jb=env._signal;var kb=env._GC_collect_a_little;var lb=env._sbrk;var mb=env._strtoull;var nb=env._emscripten_memcpy_big;var ob=env._sinh;var pb=env._sysconf;var qb=env._close;var rb=env._rewind;var sb=env._cos;var tb=env._fileno;var ub=env._tanh;var vb=env._fread;var wb=env._puts;var xb=env._isatty;var yb=env._lis_matrix_set_value;var zb=env._write;var Ab=env._isblank;var Bb=env._ftell;var Cb=env.__ZNSt9exceptionD2Ev;var Db=env._xerbla_;var Eb=env._round;var Fb=env.___cxa_does_inherit;var Gb=env._strtoll_l;var Hb=env._strstr;var Ib=env.___cxa_rethrow;var Jb=env._llvm_lifetime_end;var Kb=env._catclose;var Lb=env._tmpnam;var Mb=env._lis_vector_get_values;var Nb=env._lis_vector_destroy;var Ob=env._lis_solver_set_option;var Pb=env._tmpfile;var Qb=env._send;var Rb=env._pow;var Sb=env._lis_matrix_set_size;var Tb=env.___cxa_free_exception;var Ub=env.___cxa_find_matching_catch;var Vb=env._isxdigit_l;var Wb=env.___cxa_guard_release;var Xb=env._truncate;var Yb=env._strtol;var Zb=env.__reallyNegative;var _b=env._sin;var $b=env._strtok;var ac=env.___setErrNo;var bc=env._newlocale;var cc=env._isdigit_l;var dc=env.___resumeException;var ec=env._freelocale;var fc=env._srand;var gc=env._qsort;var hc=env._putchar;var ic=env._floor;var jc=env._pthread_mutex_unlock;var kc=env._printf;var lc=env._sprintf;var mc=env._fopen;var nc=env._vasprintf;var oc=env._emscripten_get_now;var pc=env._stat;var qc=env._lis_solve;var rc=env._strtoull_l;var sc=env._read;var tc=env.__addDays;var uc=env._fwrite;var vc=env._time;var wc=env._pthread_mutex_lock;var xc=env._catopen;var yc=env._exit;var zc=env._GC_strdup;var Ac=env._freopen;var Bc=env.___ctype_b_loc;var Cc=env._fmod;var Dc=env._strtok_r;var Ec=env._lseek;var Fc=env._access;var Gc=env._vfprintf;var Hc=env.___cxa_allocate_exception;var Ic=env._atoi;var Jc=env._strtoll;var Kc=env._pwrite;var Lc=env._localtime_r;var Mc=env._tzset;var Nc=env._open;var Oc=env._uselocale;var Pc=env._snprintf;var Qc=env.___errno_location;var Rc=env._GC_malloc;var Sc=env.___cxa_end_catch;var Tc=env._perror;var Uc=env.___cxa_begin_catch;var Vc=env._strftime;var Wc=env._ftruncate;var Xc=env._GC_init;var Yc=env._lis_matrix_set_type;var Zc=env._fseek;var _c=env.__ZSt9terminatev;var $c=env._isxdigit;var ad=env._fclose;var bd=env._vsnprintf;var cd=env.__parseInt;var dd=env._log;var ed=env._pthread_cond_broadcast;var fd=env._popen;var gd=env._recv;var hd=env._tan;var id=env._copysign;var jd=env.__parseInt64;var kd=env.__getFloat;var ld=env._lis_vector_set_value;var md=env._abort;var nd=env._ceil;var od=env._isspace;var pd=env._localtime;var qd=env._lis_matrix_destroy;var rd=env._pthread_getspecific;var sd=env._pthread_cond_wait;var td=env._llvm_lifetime_start;var ud=env.___cxa_is_number_type;var vd=env._acos;var wd=env._cosh;var xd=env._ungetc;var yd=env._system;var zd=env._fmin;var Ad=env._fmax;var Bd=env._fflush;var Cd=env._strftime_l;var Dd=env._fprintf;var Ed=env._sscanf;var Fd=env._catgets;var Gd=env._lis_solver_destroy;var Hd=env._strdup;var Id=env._asprintf;var Jd=env.__exit;var Kd=env.___ctype_toupper_loc;var Ld=env._bsearch;var Md=env.__arraySum;var Nd=env.__formatString;var Od=env._htonl;var Pd=env.___ctype_tolower_loc;var Qd=env._unlink;var Rd=env._fputs;var Sd=env._GC_malloc_atomic;var Td=env._pread;var Ud=env._lis_vector_set_size;var Vd=env._mkport;var Wd=env.__scanString;var Xd=env._pthread_setspecific;var Yd=env._fgetc;var Zd=env._fputc;var _d=env.___cxa_throw;var $d=env._lis_matrix_create;var ae=env._isdigit;var be=env._strerror;var ce=env._emscripten_longjmp;var de=env._lis_vector_create;var ee=env._atexit;var fe=env._sqrt;var ge=env._strerror_r;var he=0.0;
// EMSCRIPTEN_START_FUNCS
function DUa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=33;break}o=b;if((a[m]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=kUa(a[o]|0,a[b+1|0]|0)|0}switch(p|0){case 10:{n=16;break a;break};case 5:{b=b+2|0;continue a;break};case 2:{n=15;break a;break};case 6:{b=b+3|0;continue a;break};case 21:{n=29;break a;break};case 3:{n=12;break a;break};case 7:{b=b+4|0;continue a;break};case 9:{n=19;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=QUa(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==16){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==19){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b]|0)==0){q=d[j+76+(d[e+1|0]|0)|0]|0}else{q=kUa(a[e]|0,a[b+1|0]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==29){q=b;if((b|0)==(g|0)){c[f>>2]=q+2;k=39;l=k;i=h;return l|0}else{c[f>>2]=q;k=6;l=k;i=h;return l|0}}else if((n|0)==33){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function EUa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=32;break}o=b;if((a[m]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=kUa(a[o]|0,a[b+1|0]|0)|0}switch(p|0){case 9:{n=21;break a;break};case 5:{b=b+2|0;continue a;break};case 10:{n=18;break a;break};case 3:{n=12;break a;break};case 7:{b=b+4|0;continue a;break};case 30:{n=15;break a;break};case 6:{b=b+3|0;continue a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=QUa(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){if((b|0)==(g|0)){p=RUa(j,b+2|0,e,f)|0;k=(p|0)==22?0:p;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==18){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==21){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b]|0)==0){q=d[j+76+(d[e+1|0]|0)|0]|0}else{q=kUa(a[e]|0,a[b+1|0]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function FUa(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){e=b;if((a[b]|0)==0){h=d[g+76+(d[e+1|0]|0)|0]|0}else{h=kUa(a[e]|0,a[b+1|0]|0)|0}switch(h|0){case 7:{e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=7;break a}else{k=8}break};case 5:{break};case 6:{k=8;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{j=c;c=j+1|0;e=b;b=e+1|0;if((a[j]|0)!=(a[e]|0)){k=15;break a}e=c;c=e+1|0;j=b;b=j+1|0;if((a[e]|0)!=(a[j]|0)){k=17;break a}else{continue a}break};default:{k=18;break a}}if((k|0)==8){k=0;j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=9;break}}e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=11;break}j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=13;break}}if((k|0)==7){l=0;m=l;i=f;return m|0}else if((k|0)==9){l=0;m=l;i=f;return m|0}else if((k|0)==11){l=0;m=l;i=f;return m|0}else if((k|0)==13){l=0;m=l;i=f;return m|0}else if((k|0)==15){l=0;m=l;i=f;return m|0}else if((k|0)==17){l=0;m=l;i=f;return m|0}else if((k|0)==18){k=c;if((a[c]|0)==0){n=d[g+76+(d[k+1|0]|0)|0]|0}else{n=kUa(a[k]|0,a[c+1|0]|0)|0}switch(n|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{l=0;m=l;i=f;return m|0};default:{l=1;m=l;i=f;return m|0}}}return 0}function GUa(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=9;break}if(g){h=4;break}if((a[f]|0)!=0){h=7;break}if((a[f+1|0]|0)!=(a[d]|0)){h=7;break}f=f+2|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==7){j=0;k=j;i=b;return k|0}else if((h|0)==9){j=g&1;k=j;i=b;return k|0}return 0}function HUa(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;e=i;i=i+24|0;f=b;b=c;c=b;a:while(1){g=b;if((a[b]|0)==0){h=d[f+76+(d[g+1|0]|0)|0]|0}else{h=kUa(a[g]|0,a[b+1|0]|0)|0}switch(h|0){case 5:{b=b+2|0;continue a;break};case 6:{b=b+3|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{b=b+2|0;continue a;break};case 7:{b=b+4|0;continue a;break};default:{break a}}}i=e;return b-c|0}function IUa(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=c;while(1){c=b;if((a[b]|0)==0){g=d[f+76+(d[c+1|0]|0)|0]|0}else{g=kUa(a[c]|0,a[b+1|0]|0)|0}if(!((g|0)==21|(g|0)==9|(g|0)==10)){break}b=b+2|0}i=e;return b|0}function JUa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+2|0;a:while(1){m=b;if((a[b]|0)==0){n=d[j+76+(d[m+1|0]|0)|0]|0}else{n=kUa(a[m]|0,a[b+1|0]|0)|0}b:do{switch(n|0){case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b]|0)==0){o=a[b+1|0]|0}else{o=-1}if((o|0)!=32){break}if((a[b+2|0]|0)==0){p=a[b+3|0]|0}else{p=-1}if((p|0)==32){break}m=b+2|0;if((a[b+2|0]|0)==0){q=d[j+76+(d[m+1|0]|0)|0]|0}else{q=kUa(a[m]|0,a[b+3|0]|0)|0}if((q|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};default:{}}}while(0);b=b+2|0}i=h;return k|0}function KUa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=c;c=0;d=d+4|0;a:do{if((a[d]|0)==0){if((a[d+1|0]|0)!=120){e=16;break}d=d+2|0;while(1){if((a[d]|0)==0){f=(a[d+1|0]|0)==59}else{f=0}if(!(f^1)){break a}if((a[d]|0)==0){g=a[d+1|0]|0}else{g=-1}h=g;switch(h|0){case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|h-48;break};case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(h-97))|0;break};case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(h-65))|0;break};default:{}}if((c|0)>=1114112){break}d=d+2|0}j=-1;k=j;i=b;return k|0}else{e=16}}while(0);b:do{if((e|0)==16){while(1){e=0;if((a[d]|0)==0){l=(a[d+1|0]|0)==59}else{l=0}if(!(l^1)){break b}if((a[d]|0)==0){m=a[d+1|0]|0}else{m=-1}c=c*10|0;c=c+(m-48)|0;if((c|0)>=1114112){break}d=d+2|0;e=16}j=-1;k=j;i=b;return k|0}}while(0);j=yTa(c)|0;k=j;i=b;return k|0}function LUa(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;e=c;c=(d-e|0)/2|0;do{if((c|0)==3){if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=97){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=109){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=112){break}f=38;g=f;i=b;return g|0}else if((c|0)==4){if((a[e]|0)==0){h=a[e+1|0]|0}else{h=-1}if((h|0)==97){e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=112){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=111){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=115){break}f=39;g=f;i=b;return g|0}else if((h|0)==113){e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=117){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=111){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=116){break}f=34;g=f;i=b;return g|0}else{break}}else if((c|0)==2){if((a[e+2|0]|0)!=0){break}if((a[e+3|0]|0)!=116){break}if((a[e]|0)==0){j=a[e+1|0]|0}else{j=-1}if((j|0)==108){f=60;g=f;i=b;return g|0}else if((j|0)==103){f=62;g=f;i=b;return g|0}else{break}}}while(0);f=0;g=f;i=b;return g|0}function MUa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=b;b=e;e=f;f=g;while(1){if(!(b>>>0<e>>>0)){break}g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=kUa(a[g]|0,a[b+1|0]|0)|0}switch(k|0){case 10:{c[f+4>>2]=-1;g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;break};case 9:{g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;do{if((b|0)!=(e|0)){g=b;if((a[b]|0)==0){l=d[j+76+(d[g+1|0]|0)|0]|0}else{l=kUa(a[g]|0,a[b+1|0]|0)|0}if((l|0)!=10){break}b=b+2|0}}while(0);c[f+4>>2]=-1;break};case 6:{b=b+3|0;break};case 7:{b=b+4|0;break};case 5:{b=b+2|0;break};default:{b=b+2|0}}g=f+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}function NUa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+2|0;e=e+ -2|0;a:while(1){if((b|0)==(e|0)){k=18;break}g=b;if((a[b]|0)==0){l=d[j+76+(d[g+1|0]|0)|0]|0}else{l=kUa(a[g]|0,a[b+1|0]|0)|0}b:do{switch(l|0){case 21:{if((a[b]|0)!=0){break b}if((a[b+1|0]|0)==9){k=9;break a}break};case 22:case 26:{if((a[b]|0)==0){m=a[b+1|0]|0}else{m=-1}if((m&-128|0)!=0){k=13}break};case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};default:{k=13}}}while(0);if((k|0)==13){k=0;if((a[b]|0)==0){n=a[b+1|0]|0}else{n=-1}if(!((n|0)==64|(n|0)==36)){k=16;break}}b=b+2|0}if((k|0)==9){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==16){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==18){o=1;p=o;i=h;return p|0}return 0}function OUa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+80|0;h=d;d=e;e=f;f=g;g=c[h>>2]|0;a:while(1){j=g;if((g|0)==(d|0)){k=18;break}l=a[j+1|0]|0;m=a[g]|0;b:do{switch(m&255|0){case 7:case 6:case 5:case 4:case 3:case 2:case 1:{k=8;break};case 0:{if((l&255|0)>=128){k=8;break b}if((c[e>>2]|0)==(f|0)){k=6;break a}n=e;o=c[n>>2]|0;c[n>>2]=o+1;a[o]=l;break};case 219:case 218:case 217:case 216:{if((f-(c[e>>2]|0)|0)<4){k=15;break a}o=((m&3)<<2|(l&255)>>6&3)+1|0;n=e;p=c[n>>2]|0;c[n>>2]=p+1;a[p]=o>>2|240;p=e;n=c[p>>2]|0;c[p>>2]=n+1;a[n]=(l&255)>>2&15|(o&3)<<4|128;g=g+2|0;o=a[g+1|0]|0;n=((l&3)<<4|(a[g]&3)<<2|(o&255)>>6|128)&255;p=e;q=c[p>>2]|0;c[p>>2]=q+1;a[q]=n;n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=o&63|128;break};default:{if((f-(c[e>>2]|0)|0)<3){k=12;break a}o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=(m&255)>>4|224;q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(m&15)<<2|(l&255)>>6|128;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}}}while(0);if((k|0)==8){k=0;if((f-(c[e>>2]|0)|0)<2){k=9;break}q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(l&255)>>6|(m&255)<<2|192;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}g=g+2|0}if((k|0)==6){c[h>>2]=g;i=b;return}else if((k|0)==9){c[h>>2]=g;i=b;return}else if((k|0)==12){c[h>>2]=g;i=b;return}else if((k|0)==15){c[h>>2]=g;i=b;return}else if((k|0)==18){c[h>>2]=j;i=b;return}}function PUa(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;e=i;i=i+40|0;k=f;f=g;g=h;h=j;do{if((f-(c[k>>2]|0)|0)>(((h-(c[g>>2]|0)|0)/2|0)<<1|0)){if((a[f+ -2|0]&248|0)!=216){break}f=f+ -2|0}}while(0);while(1){if((c[k>>2]|0)==(f|0)){l=7;break}if((c[g>>2]|0)==(h|0)){l=7;break}j=((d[c[k>>2]|0]|0)<<8|(d[(c[k>>2]|0)+1|0]|0))&65535;m=g;n=c[m>>2]|0;c[m>>2]=n+2;b[n>>1]=j;j=k;c[j>>2]=(c[j>>2]|0)+2}if((l|0)==7){i=e;return}}function QUa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=kUa(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 24:case 22:{break};case 19:{k=SUa(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 29:{if((c[231512+((d[231256+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=kUa(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 6:{n=32;break b;break};case 7:{n=35;break b;break};case 5:{n=29;break b;break};case 18:{n=38;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[231512+((d[232792+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=27;break b}break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=9;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function RUa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=kUa(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 24:case 22:{break};case 30:case 9:case 10:case 21:{c[f>>2]=b;k=22;l=k;i=h;return l|0};case 29:{if((c[231512+((d[231256+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=kUa(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 6:{n=32;break b;break};case 5:{n=29;break b;break};case 29:{if((c[231512+((d[232792+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=27;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 18:{n=38;break b;break};case 7:{n=35;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=28;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function SUa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b]|0)==0){if((a[b+1|0]|0)!=120){break}k=TUa(j,b+2|0,e,f)|0;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=kUa(a[g]|0,a[b+1|0]|0)|0}g=b;if((m|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=kUa(a[g]|0,a[b+1|0]|0)|0}if((n|0)==18){o=16;break}else if((n|0)!=25){o=17;break}b=b+2|0}if((o|0)==16){c[f>>2]=b+2;k=10;l=k;i=h;return l|0}else if((o|0)==17){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function TUa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=kUa(a[g]|0,a[b+1|0]|0)|0}g=b;if(!((k+ -24|0)>>>0<2)){c[f>>2]=g;l=0;m=l;i=h;return m|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=kUa(a[g]|0,a[b+1|0]|0)|0}if((n|0)==18){o=13;break}else if(!((n|0)==24|(n|0)==25)){o=14;break}b=b+2|0}if((o|0)==13){c[f>>2]=b+2;l=10;m=l;i=h;return m|0}else if((o|0)==14){c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);l=-1;m=l;i=h;return m|0}function UUa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=kUa(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[231512+((d[231256+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 16:{g=b+2|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=kUa(a[g]|0,a[b+1|0]|0)|0}if((n|0)==27){k=VUa(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((n|0)==20){k=WUa(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 17:{k=YUa(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 24:case 22:{break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 15:{k=XUa(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;n=0;b:while(1){if((b|0)==(e|0)){o=98;break}m=b;if((a[b]|0)==0){p=d[j+76+(d[m+1|0]|0)|0]|0}else{p=kUa(a[m]|0,a[b+1|0]|0)|0}switch(p|0){case 29:{if((c[231512+((d[232792+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=37;break b}break};case 10:case 9:case 21:{o=69;break b;break};case 5:{o=39;break b;break};case 23:{if((n|0)!=0){o=49;break b}n=1;b=b+2|0;if((b|0)==(e|0)){o=51;break b}m=b;if((a[b]|0)==0){q=d[j+76+(d[m+1|0]|0)|0]|0}else{q=kUa(a[m]|0,a[b+1|0]|0)|0}switch(q|0){case 5:{o=59;break b;break};case 29:{if((c[231512+((d[231256+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=57;break b}break};case 24:case 22:{break};case 6:{o=62;break b;break};case 7:{o=65;break b;break};default:{o=68;break b}}b=b+2|0;continue b;break};case 7:{o=45;break b;break};case 11:{o=90;break b;break};case 17:{break b;break};case 6:{o=42;break b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{o=97;break b}}b=b+2|0}c:do{if((o|0)==37){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==39){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==42){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==45){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==51){k=-1;l=k;i=h;return l|0}else if((o|0)==57){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==59){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==62){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==65){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==68){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==69){b=b+2|0;d:while(1){if((b|0)==(e|0)){o=89;break}q=b;if((a[b]|0)==0){r=d[j+76+(d[q+1|0]|0)|0]|0}else{r=kUa(a[q]|0,a[b+1|0]|0)|0}switch(r|0){case 29:{o=75;break d;break};case 7:{o=84;break d;break};case 6:{o=81;break d;break};case 10:case 9:case 21:{break};case 5:{o=78;break d;break};case 24:case 22:{break d;break};case 11:{o=90;break c;break};case 17:{break c;break};default:{o=88;break d}}b=b+2|0}do{if((o|0)==75){if((c[231512+((d[231256+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==81){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==84){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==89){k=-1;l=k;i=h;return l|0}}while(0);b=b+2|0;k=ZUa(j,b,e,f)|0;l=k;i=h;return l|0}else if((o|0)==97){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==98){k=-1;l=k;i=h;return l|0}}while(0);if((o|0)==90){c[f>>2]=b+2;k=2;l=k;i=h;return l|0}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=4;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=0;l=k;i=h;return l|0}function VUa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b]|0)==0){if((a[b+1|0]|0)!=45){break}b=b+2|0;b:while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=kUa(a[g]|0,a[b+1|0]|0)|0}switch(k|0){case 5:{if((e-b|0)<2){l=12;break b}b=b+2|0;continue b;break};case 8:case 1:case 0:{l=20;break b;break};case 27:{g=b+2|0;b=g;if((g|0)==(e|0)){l=22;break b}if((a[b]|0)!=0){continue b}if((a[b+1|0]|0)==45){l=25;break b}else{continue b}break};case 7:{if((e-b|0)<4){l=18;break b}b=b+4|0;continue b;break};case 6:{if((e-b|0)<3){l=15;break b}b=b+3|0;continue b;break};default:{b=b+2|0;continue b}}}if((l|0)==12){m=-2;n=m;i=h;return n|0}else if((l|0)==15){m=-2;n=m;i=h;return n|0}else if((l|0)==18){m=-2;n=m;i=h;return n|0}else if((l|0)==20){c[f>>2]=b;m=0;n=m;i=h;return n|0}else if((l|0)==22){m=-1;n=m;i=h;return n|0}else if((l|0)==25){g=b+2|0;b=g;if((g|0)==(e|0)){m=-1;n=m;i=h;return n|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;m=13;n=m;i=h;return n|0}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}while(0);m=-1;n=m;i=h;return n|0}function WUa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<12){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=9;break}if((a[k]|0)!=0){l=7;break}if((a[g+1|0]|0)!=(a[233832+e|0]|0)){l=7;break}e=e+1|0;g=g+2|0}if((l|0)==7){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==9){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function XUa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}n=b;if((a[b]|0)==0){o=d[k+76+(d[n+1|0]|0)|0]|0}else{o=kUa(a[n]|0,a[b+1|0]|0)|0}a:do{switch(o|0){case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 24:case 22:{break};case 29:{if((c[231512+((d[231256+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;l=0;m=l;i=h;return m|0};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){p=70;break}o=b;if((a[b]|0)==0){q=d[k+76+(d[o+1|0]|0)|0]|0}else{q=kUa(a[o]|0,a[b+1|0]|0)|0}switch(q|0){case 15:{p=62;break b;break};case 6:{p=31;break b;break};case 5:{p=28;break b;break};case 29:{if((c[231512+((d[232792+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){p=26;break b}break};case 10:case 9:case 21:{p=37;break b;break};case 7:{p=34;break b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{break b}}b=b+2|0}do{if((p|0)==26){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==28){if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==31){if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==34){if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==37){q=b;if((_Ua(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;c:while(1){if((b|0)==(e|0)){p=61;break}q=b;if((a[b]|0)==0){r=d[k+76+(d[q+1|0]|0)|0]|0}else{r=kUa(a[q]|0,a[b+1|0]|0)|0}switch(r|0){case 5:{if((e-b|0)<2){p=46;break c}b=b+2|0;continue c;break};case 6:{if((e-b|0)<3){p=49;break c}b=b+3|0;continue c;break};case 8:case 1:case 0:{p=54;break c;break};case 7:{if((e-b|0)<4){p=52;break c}b=b+4|0;continue c;break};case 15:{b=b+2|0;if((b|0)==(e|0)){p=56;break c}if((a[b]|0)!=0){continue c}if((a[b+1|0]|0)==62){p=59;break c}else{continue c}break};default:{b=b+2|0;continue c}}}if((p|0)==46){l=-2;m=l;i=h;return m|0}else if((p|0)==49){l=-2;m=l;i=h;return m|0}else if((p|0)==52){l=-2;m=l;i=h;return m|0}else if((p|0)==54){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==56){l=-1;m=l;i=h;return m|0}else if((p|0)==59){c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==61){l=-1;m=l;i=h;return m|0}}else if((p|0)==62){q=b;if((_Ua(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b]|0)!=0){break}if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==70){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function YUa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=kUa(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 29:{if((c[231512+((d[231256+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=50;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=kUa(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 6:{n=31;break b;break};case 5:{n=28;break b;break};case 11:{n=48;break b;break};case 29:{if((c[231512+((d[232792+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=26;break b}break};case 7:{n=34;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 23:{b=b+2|0;continue b;break};case 10:case 9:case 21:{n=37;break b;break};default:{n=49;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){b=b+2|0;while(1){if((b|0)==(e|0)){n=46;break}o=b;if((a[b]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=kUa(a[o]|0,a[b+1|0]|0)|0}if((p|0)==11){n=43;break}else if(!((p|0)==10|(p|0)==9|(p|0)==21)){n=44;break}b=b+2|0}if((n|0)==43){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==44){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==46){k=-1;l=k;i=h;return l|0}}else if((n|0)==48){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==50){k=-1;l=k;i=h;return l|0}return 0}function ZUa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=115;break}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){m=d[k+76+(d[b+1|0]|0)|0]|0}else{m=kUa(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}b:do{switch(m|0){case 14:{break};case 27:case 26:case 25:case 24:case 22:{l=9;break};case 23:{if((g|0)!=0){l=20;break a}g=1;c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=22;break a}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){n=d[k+76+(d[b+1|0]|0)|0]|0}else{n=kUa(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(n|0){case 5:{l=30;break a;break};case 29:{if((c[231512+((d[231256+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)==0){l=28;break a}break};case 6:{l=33;break a;break};case 24:case 22:{break};case 7:{l=36;break a;break};default:{l=39;break a}}c[j>>2]=(c[j>>2]|0)+2;continue a;break};case 6:{l=13;break a;break};case 5:{l=10;break a;break};case 7:{l=16;break a;break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=41;break a}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){o=d[k+76+(d[b+1|0]|0)|0]|0}else{o=kUa(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}b=o;if((b|0)==14){break b}p=b;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=47;break a}}break};case 29:{if((c[231512+((d[232792+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)!=0){l=9}else{l=8;break a}break};default:{l=114;break a}}}while(0);if((l|0)==9){l=0;c[j>>2]=(c[j>>2]|0)+2;continue}g=0;while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=50;break a}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){q=d[k+76+(d[p+1|0]|0)|0]|0}else{q=kUa(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}r=q;if((r|0)==12|(r|0)==13){break}p=r;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=56;break a}}c[j>>2]=(c[j>>2]|0)+2;c:while(1){if((c[j>>2]|0)==(e|0)){l=59;break a}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){s=d[k+76+(d[p+1|0]|0)|0]|0}else{s=kUa(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}p=s;if((p|0)==(r|0)){break}switch(p|0){case 7:{if((e-(c[j>>2]|0)|0)<4){l=72;break a}c[j>>2]=(c[j>>2]|0)+4;continue c;break};case 3:{t=QUa(k,(c[j>>2]|0)+2|0,e,j)|0;if((t|0)<=0){l=76;break a}else{continue c}break};case 2:{l=79;break a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=66;break a}c[j>>2]=(c[j>>2]|0)+2;continue c;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=69;break a}c[j>>2]=(c[j>>2]|0)+3;continue c;break};case 8:case 1:case 0:{l=74;break a;break};default:{c[j>>2]=(c[j>>2]|0)+2;continue c}}}c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=82;break}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){u=d[k+76+(d[p+1|0]|0)|0]|0}else{u=kUa(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(u|0){case 17:{l=107;break a;break};case 10:case 9:case 21:{break};case 11:{l=106;break a;break};default:{l=87;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=89;break a}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){v=d[k+76+(d[p+1|0]|0)|0]|0}else{v=kUa(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(v|0){case 17:{l=107;break a;break};case 10:case 9:case 21:{break};case 11:{l=106;break a;break};case 5:{l=97;break a;break};case 29:{l=94;break d;break};case 7:{l=103;break a;break};case 24:case 22:{break d;break};case 6:{l=100;break a;break};default:{l=113;break a}}}if((l|0)==94){l=0;if((c[231512+((d[231256+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)==0){l=95;break}}c[j>>2]=(c[j>>2]|0)+2}if((l|0)==8){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==10){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==13){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==16){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==20){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==22){w=-1;x=w;i=h;return x|0}else if((l|0)==28){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==30){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==33){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==36){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==39){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==41){w=-1;x=w;i=h;return x|0}else if((l|0)==47){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==50){w=-1;x=w;i=h;return x|0}else if((l|0)==56){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==59){w=-1;x=w;i=h;return x|0}else if((l|0)==66){w=-2;x=w;i=h;return x|0}else if((l|0)==69){w=-2;x=w;i=h;return x|0}else if((l|0)==72){w=-2;x=w;i=h;return x|0}else if((l|0)==74){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==76){if((t|0)==0){c[f>>2]=c[j>>2]}w=t;x=w;i=h;return x|0}else if((l|0)==79){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==82){w=-1;x=w;i=h;return x|0}else if((l|0)==87){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==89){w=-1;x=w;i=h;return x|0}else if((l|0)==95){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==97){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==100){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==103){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+2;w=1;x=w;i=h;return x|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){w=-1;x=w;i=h;return x|0}do{if((a[c[j>>2]|0]|0)==0){if((a[(c[j>>2]|0)+1|0]|0)!=62){break}c[f>>2]=(c[j>>2]|0)+2;w=3;x=w;i=h;return x|0}}while(0);c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==113){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==114){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==115){w=-1;x=w;i=h;return x|0}return 0}function _Ua(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;if((e-g|0)!=6){h=1;j=h;i=b;return j|0}if((a[g]|0)==0){k=a[g+1|0]|0}else{k=-1}if((k|0)==88){f=1}else if((k|0)!=120){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g]|0)==0){l=a[g+1|0]|0}else{l=-1}if((l|0)==77){f=1}else if((l|0)!=109){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g]|0)==0){m=a[g+1|0]|0}else{m=-1}if((m|0)==76){f=1}else if((m|0)!=108){h=1;j=h;i=b;return j|0}if((f|0)!=0){h=0;j=h;i=b;return j|0}else{c[d>>2]=12;h=1;j=h;i=b;return j|0}return 0}function $Ua(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+56|0;k=b;b=e;e=f;f=g;g=h;a:while(1){if((e|0)==(f|0)){l=27;break}h=e;if((a[e]|0)==0){m=d[b+76+(d[h+1|0]|0)|0]|0}else{m=kUa(a[h]|0,a[e+1|0]|0)|0}h=m;switch(h|0){case 5:{if((f-e|0)<2){l=8;break a}e=e+2|0;continue a;break};case 6:{if((f-e|0)<3){l=11;break a}e=e+3|0;continue a;break};case 13:case 12:{e=e+2|0;if((h|0)!=(k|0)){continue a}else{l=18;break a}break};case 8:case 1:case 0:{l=16;break a;break};case 7:{if((f-e|0)<4){l=14;break a}e=e+4|0;continue a;break};default:{e=e+2|0;continue a}}}if((l|0)==8){n=-2;o=n;i=j;return o|0}else if((l|0)==11){n=-2;o=n;i=j;return o|0}else if((l|0)==14){n=-2;o=n;i=j;return o|0}else if((l|0)==16){c[g>>2]=e;n=0;o=n;i=j;return o|0}else if((l|0)==18){if((e|0)==(f|0)){n=-27;o=n;i=j;return o|0}c[g>>2]=e;g=e;if((a[e]|0)==0){p=d[b+76+(d[g+1|0]|0)|0]|0}else{p=kUa(a[g]|0,a[e+1|0]|0)|0}switch(p|0){case 20:case 30:case 11:case 10:case 9:case 21:{n=27;o=n;i=j;return o|0};default:{n=0;o=n;i=j;return o|0}}}else if((l|0)==27){n=-1;o=n;i=j;return o|0}return 0}function aVa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=kUa(a[g]|0,a[b+1|0]|0)|0}if((m|0)==24|(m|0)==22){b=b+2|0;a:while(1){if((b|0)==(e|0)){n=26;break}g=b;if((a[b]|0)==0){o=d[j+76+(d[g+1|0]|0)|0]|0}else{o=kUa(a[g]|0,a[b+1|0]|0)|0}switch(o|0){case 10:case 9:case 21:{break a;break};case 30:{n=16;break a;break};case 24:case 22:{break};default:{n=25;break a}}b=b+2|0}do{if((n|0)==16){if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}o=b+2|0;if((a[b+2|0]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=kUa(a[o]|0,a[b+3|0]|0)|0}if(!((p|0)==30|(p|0)==10|(p|0)==9|(p|0)==21)){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==25){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==26){k=-1;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=16;l=k;i=h;return l|0}else if((m|0)==27){k=VUa(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=b+2;k=33;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}return 0}function bVa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=kUa(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 29:{if((c[231512+((d[231256+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=39;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=kUa(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 7:{n=34;break b;break};case 29:{if((c[231512+((d[232792+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=26;break b}break};case 5:{n=28;break b;break};case 6:{n=31;break b;break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{n=37;break b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{n=38;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){c[f>>2]=b;k=20;l=k;i=h;return l|0}else if((n|0)==38){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==39){k=-20;l=k;i=h;return l|0}return 0}function cVa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 23:case 27:case 26:case 25:{m=19;b=b+1|0;break};case 24:case 22:{m=18;b=b+1|0;break};case 19:{k=OVa(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 2:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}switch(d[j+76+(d[b]|0)|0]|0){case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -1;k=29;l=k;i=h;return l|0};case 16:{k=NVa(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 15:{k=IVa(j,b+1|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b]|0)==93){if((b+1|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}if((Ee[c[j+344>>2]&63](j,b)|0)!=0){b=b+2|0;m=18;break a}g=b;if((Ee[c[j+332>>2]&63](j,b)|0)!=0){b=g+2|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}if((Ee[c[j+348>>2]&63](j,b)|0)!=0){b=b+3|0;m=18;break a}g=b;if((Ee[c[j+336>>2]&63](j,b)|0)!=0){b=g+3|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 32:{b=b+1|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}switch(d[j+76+(d[b]|0)|0]|0){case 34:{c[f>>2]=b+1;k=37;l=k;i=h;return l|0};case 15:{c[f>>2]=b+1;k=35;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 33:{c[f>>2]=b+1;k=36;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 10:case 21:{n=15;break};case 30:{k=CVa(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 11:{c[f>>2]=b+1;k=17;l=k;i=h;return l|0};case 20:{c[f>>2]=b+1;k=25;l=k;i=h;return l|0};case 13:{k=MVa(13,j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 9:{if((b+1|0)!=(e|0)){n=15;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 36:{c[f>>2]=b+1;k=21;l=k;i=h;return l|0};case 31:{c[f>>2]=b+1;k=23;l=k;i=h;return l|0};case 35:{c[f>>2]=b+1;k=38;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}if((Ee[c[j+352>>2]&63](j,b)|0)!=0){b=b+4|0;m=18;break a}g=b;if((Ee[c[j+340>>2]&63](j,b)|0)!=0){b=g+4|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 12:{k=MVa(12,j,b+1|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);if((n|0)==15){while(1){n=0;b=b+1|0;o=b;if((b|0)==(e|0)){n=19;break}g=d[j+76+(d[o]|0)|0]|0;if((g|0)==10|(g|0)==21){n=15;continue}else if((g|0)!=9){n=18;break}if((b+1|0)!=(e|0)){n=15}else{n=18;break}}if((n|0)==18){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((n|0)==19){c[f>>2]=o;k=15;l=k;i=h;return l|0}}b:while(1){if((b|0)==(e|0)){n=120;break}switch(d[j+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){n=77;break b}p=b;if((Ee[c[j+336>>2]&63](j,b)|0)==0){n=79;break b}b=p+3|0;continue b;break};case 23:{b=b+1|0;o=m;if((o|0)==41){m=19;continue b}else if((o|0)!=18){continue b}if((b|0)==(e|0)){n=89;break b}m=41;switch(d[j+76+(d[b]|0)|0]|0){case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 6:{if((e-b|0)<3){n=99;break b}q=b;if((Ee[c[j+336>>2]&63](j,b)|0)==0){n=101;break b}b=q+3|0;continue b;break};case 5:{if((e-b|0)<2){n=94;break b}r=b;if((Ee[c[j+332>>2]&63](j,b)|0)==0){n=96;break b}b=r+2|0;continue b;break};case 29:{n=91;break b;break};case 7:{if((e-b|0)<4){n=104;break b}s=b;if((Ee[c[j+340>>2]&63](j,b)|0)==0){n=106;break b}b=s+4|0;continue b;break};default:{m=19;continue b}}break};case 29:{n=69;break b;break};case 7:{if((e-b|0)<4){n=82;break b}t=b;if((Ee[c[j+340>>2]&63](j,b)|0)==0){n=84;break b}b=t+4|0;continue b;break};case 33:{n=113;break b;break};case 15:{n=116;break b;break};case 34:{n=110;break b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{n=86;break b;break};case 5:{if((e-b|0)<2){n=72;break b}u=b;if((Ee[c[j+332>>2]&63](j,b)|0)==0){n=74;break b}b=u+2|0;continue b;break};default:{n=119;break b}}}if((n|0)==69){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==72){k=-2;l=k;i=h;return l|0}else if((n|0)==74){c[f>>2]=u;k=0;l=k;i=h;return l|0}else if((n|0)==77){k=-2;l=k;i=h;return l|0}else if((n|0)==79){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((n|0)==82){k=-2;l=k;i=h;return l|0}else if((n|0)==84){c[f>>2]=t;k=0;l=k;i=h;return l|0}else if((n|0)==86){c[f>>2]=b;k=m;l=k;i=h;return l|0}else if((n|0)==89){k=-1;l=k;i=h;return l|0}else if((n|0)==91){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==94){k=-2;l=k;i=h;return l|0}else if((n|0)==96){c[f>>2]=r;k=0;l=k;i=h;return l|0}else if((n|0)==99){k=-2;l=k;i=h;return l|0}else if((n|0)==101){c[f>>2]=q;k=0;l=k;i=h;return l|0}else if((n|0)==104){k=-2;l=k;i=h;return l|0}else if((n|0)==106){c[f>>2]=s;k=0;l=k;i=h;return l|0}else if((n|0)==110){s=b;if((m|0)==19){c[f>>2]=s;k=0;l=k;i=h;return l|0}else{c[f>>2]=s+1;k=32;l=k;i=h;return l|0}}else if((n|0)==113){s=b;if((m|0)==19){c[f>>2]=s;k=0;l=k;i=h;return l|0}else{c[f>>2]=s+1;k=31;l=k;i=h;return l|0}}else if((n|0)==116){s=b;if((m|0)==19){c[f>>2]=s;k=0;l=k;i=h;return l|0}else{c[f>>2]=s+1;k=30;l=k;i=h;return l|0}}else if((n|0)==119){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==120){k=0-m|0;l=k;i=h;return l|0}return 0}function dVa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 9:{b=b+1|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}if((d[j+76+(d[b]|0)|0]|0)==10){b=b+1|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((Ee[c[j+360>>2]&63](j,b)|0)==0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b]|0)!=93){break a}b=b+1|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}g=b;if((a[b]|0)!=62){b=g+ -1|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((Ee[c[j+364>>2]&63](j,b)|0)==0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 3:{k=BVa(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((Ee[c[j+356>>2]&63](j,b)|0)==0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+1;k=7;l=k;i=h;return l|0};case 2:{k=FVa(j,b+1|0,e,f)|0;l=k;i=h;return l|0};default:{b=b+1|0}}}while(0);b:while(1){m=b;if((b|0)==(e|0)){n=60;break}switch(d[j+76+(d[m]|0)|0]|0){case 10:case 9:case 8:case 1:case 0:case 2:case 3:{n=58;break b;break};case 4:{if((b+1|0)==(e|0)){n=58;break b}g=b;if((a[b+1|0]|0)!=93){b=g+1|0;continue b}if((g+2|0)==(e|0)){n=58;break b}o=b;if((a[b+2|0]|0)==62){n=57;break b}b=o+1|0;continue b;break};case 7:{if((e-b|0)<4){n=49;break b}if((Ee[c[j+364>>2]&63](j,b)|0)!=0){n=49;break b}b=b+4|0;continue b;break};case 5:{if((e-b|0)<2){n=41;break b}if((Ee[c[j+356>>2]&63](j,b)|0)!=0){n=41;break b}b=b+2|0;continue b;break};case 6:{if((e-b|0)<3){n=45;break b}if((Ee[c[j+360>>2]&63](j,b)|0)!=0){n=45;break b}b=b+3|0;continue b;break};default:{b=b+1|0;continue b}}}if((n|0)==41){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==45){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==57){c[f>>2]=o+2;k=0;l=k;i=h;return l|0}else if((n|0)==58){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==60){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function eVa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 10:{c[f>>2]=b+1;k=7;l=k;i=h;return l|0};case 9:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((d[j+76+(d[b]|0)|0]|0)==10){b=b+1|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((Ee[c[j+356>>2]&63](j,b)|0)==0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((Ee[c[j+364>>2]&63](j,b)|0)==0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((Ee[c[j+360>>2]&63](j,b)|0)==0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b]|0)!=93){break a}b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)!=62){b=g+ -1|0;break a}c[f>>2]=g+1;k=40;l=k;i=h;return l|0};default:{b=b+1|0}}}while(0);b:while(1){m=b;if((b|0)==(e|0)){n=51;break}switch(d[j+76+(d[m]|0)|0]|0){case 7:{if((e-b|0)<4){n=47;break b}if((Ee[c[j+364>>2]&63](j,b)|0)!=0){n=47;break b}b=b+4|0;continue b;break};case 5:{if((e-b|0)<2){n=39;break b}if((Ee[c[j+356>>2]&63](j,b)|0)!=0){n=39;break b}b=b+2|0;continue b;break};case 6:{if((e-b|0)<3){n=43;break b}if((Ee[c[j+360>>2]&63](j,b)|0)!=0){n=43;break b}b=b+3|0;continue b;break};case 4:case 10:case 9:case 8:case 1:case 0:{n=49;break b;break};default:{b=b+1|0;continue b}}}if((n|0)==39){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==43){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==47){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==51){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function fVa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;g=0;a:while(1){if((b|0)==(e|0)){k=37;break}switch(d[j+76+(d[b]|0)|0]|0){case 4:{l=b+1|0;b=l;if((l|0)==(e|0)){k=28;break a}if((a[b]|0)!=93){continue a}l=b+1|0;b=l;if((l|0)==(e|0)){k=31;break a}if((a[b]|0)!=62){continue a}b=b+1|0;if((g|0)==0){k=34;break a}g=g+ -1|0;continue a;break};case 6:{if((e-b|0)<3){k=10;break a}m=b;if((Ee[c[j+360>>2]&63](j,b)|0)!=0){k=12;break a}b=m+3|0;continue a;break};case 7:{if((e-b|0)<4){k=15;break a}n=b;if((Ee[c[j+364>>2]&63](j,b)|0)!=0){k=17;break a}b=n+4|0;continue a;break};case 2:{l=b+1|0;b=l;if((l|0)==(e|0)){k=21;break a}if((a[b]|0)!=33){continue a}l=b+1|0;b=l;if((l|0)==(e|0)){k=24;break a}if((a[b]|0)!=91){continue a}g=g+1|0;b=b+1|0;continue a;break};case 8:case 1:case 0:{k=19;break a;break};case 5:{if((e-b|0)<2){k=5;break a}o=b;if((Ee[c[j+356>>2]&63](j,b)|0)!=0){k=7;break a}b=o+2|0;continue a;break};default:{b=b+1|0;continue a}}}if((k|0)==5){p=-2;q=p;i=h;return q|0}else if((k|0)==7){c[f>>2]=o;p=0;q=p;i=h;return q|0}else if((k|0)==10){p=-2;q=p;i=h;return q|0}else if((k|0)==12){c[f>>2]=m;p=0;q=p;i=h;return q|0}else if((k|0)==15){p=-2;q=p;i=h;return q|0}else if((k|0)==17){c[f>>2]=n;p=0;q=p;i=h;return q|0}else if((k|0)==19){c[f>>2]=b;p=0;q=p;i=h;return q|0}else if((k|0)==21){p=-1;q=p;i=h;return q|0}else if((k|0)==24){p=-1;q=p;i=h;return q|0}else if((k|0)==28){p=-1;q=p;i=h;return q|0}else if((k|0)==31){p=-1;q=p;i=h;return q|0}else if((k|0)==34){c[f>>2]=b;p=42;q=p;i=h;return q|0}else if((k|0)==37){p=-1;q=p;i=h;return q|0}return 0}function gVa(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+48|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-4;k=j;i=g;return k|0}f=a;a:while(1){l=a;if((a|0)==(b|0)){m=27;break}switch(d[h+76+(d[l]|0)|0]|0|0){case 2:{m=12;break a;break};case 10:{m=13;break a;break};case 5:{a=a+2|0;continue a;break};case 9:{m=16;break a;break};case 3:{m=9;break a;break};case 6:{a=a+3|0;continue a;break};case 7:{a=a+4|0;continue a;break};case 21:{m=23;break a;break};default:{a=a+1|0;continue a}}}if((m|0)==9){if((a|0)==(f|0)){j=BVa(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==12){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((m|0)==13){n=a;if((a|0)==(f|0)){c[e>>2]=n+1;j=7;k=j;i=g;return k|0}else{c[e>>2]=n;j=6;k=j;i=g;return k|0}}else if((m|0)==16){n=a;if((a|0)!=(f|0)){c[e>>2]=n;j=6;k=j;i=g;return k|0}a=n+1|0;if((a|0)==(b|0)){j=-3;k=j;i=g;return k|0}if((d[h+76+(d[a]|0)|0]|0|0)==10){a=a+1|0}c[e>>2]=a;j=7;k=j;i=g;return k|0}else if((m|0)==23){h=a;if((a|0)==(f|0)){c[e>>2]=h+1;j=39;k=j;i=g;return k|0}else{c[e>>2]=h;j=6;k=j;i=g;return k|0}}else if((m|0)==27){c[e>>2]=l;j=6;k=j;i=g;return k|0}return 0}function hVa(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+56|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-4;k=j;i=g;return k|0}f=a;a:while(1){l=a;if((a|0)==(b|0)){m=26;break}switch(d[h+76+(d[l]|0)|0]|0|0){case 5:{a=a+2|0;continue a;break};case 6:{a=a+3|0;continue a;break};case 10:{m=15;break a;break};case 3:{m=9;break a;break};case 9:{m=18;break a;break};case 7:{a=a+4|0;continue a;break};case 30:{m=12;break a;break};default:{a=a+1|0;continue a}}}if((m|0)==9){if((a|0)==(f|0)){j=BVa(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==12){if((a|0)==(f|0)){n=CVa(h,a+1|0,b,e)|0;j=(n|0)==22?0:n;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==15){n=a;if((a|0)==(f|0)){c[e>>2]=n+1;j=7;k=j;i=g;return k|0}else{c[e>>2]=n;j=6;k=j;i=g;return k|0}}else if((m|0)==18){n=a;if((a|0)!=(f|0)){c[e>>2]=n;j=6;k=j;i=g;return k|0}a=n+1|0;if((a|0)==(b|0)){j=-3;k=j;i=g;return k|0}if((d[h+76+(d[a]|0)|0]|0|0)==10){a=a+1|0}c[e>>2]=a;j=7;k=j;i=g;return k|0}else if((m|0)==26){c[e>>2]=l;j=6;k=j;i=g;return k|0}return 0}function iVa(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){switch(d[g+76+(d[b]|0)|0]|0){case 5:{break};case 6:{h=5;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{e=c;c=e+1|0;j=b;b=j+1|0;if((a[e]|0)!=(a[j]|0)){h=12;break a}else{continue a}break};case 7:{j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){h=4;break a}else{h=5}break};default:{h=13;break a}}if((h|0)==5){h=0;e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){h=6;break}}j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){h=8;break}e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){h=10;break}}if((h|0)==4){k=0;l=k;i=f;return l|0}else if((h|0)==6){k=0;l=k;i=f;return l|0}else if((h|0)==8){k=0;l=k;i=f;return l|0}else if((h|0)==10){k=0;l=k;i=f;return l|0}else if((h|0)==12){k=0;l=k;i=f;return l|0}else if((h|0)==13){if((a[b]|0)==(a[c]|0)){k=1;l=k;i=f;return l|0}switch(d[g+76+(d[c]|0)|0]|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{k=0;l=k;i=f;return l|0};default:{k=1;l=k;i=f;return l|0}}}return 0}function jVa(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=8;break}if(g){h=4;break}if((a[f]|0)!=(a[d]|0)){h=6;break}f=f+1|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==6){j=0;k=j;i=b;return k|0}else if((h|0)==8){j=g&1;k=j;i=b;return k|0}return 0}function kVa(a,b){a=a|0;b=b|0;var c=0,e=0;c=i;i=i+24|0;e=a;a=b;b=a;a:while(1){switch(d[e+76+(d[a]|0)|0]|0|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:{a=a+1|0;continue a;break};case 7:{a=a+4|0;continue a;break};case 5:{a=a+2|0;continue a;break};case 6:{a=a+3|0;continue a;break};default:{break a}}}i=c;return a-b|0}function lVa(a,b){a=a|0;b=b|0;var c=0,e=0;c=i;i=i+16|0;e=a;a=b;while(1){b=d[e+76+(d[a]|0)|0]|0;if(!((b|0)==21|(b|0)==9|(b|0)==10)){break}a=a+1|0}i=c;return a|0}function mVa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+1|0;a:while(1){b:do{switch(d[j+76+(d[b]|0)|0]|0){case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+3|0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+1}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b]|0)!=32){break}if((a[b+1|0]|0)==32){break}if((d[j+76+(d[b+1|0]|0)|0]|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+1}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};default:{}}}while(0);b=b+1|0}i=h;return k|0}function nVa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;b=i;i=i+48|0;d=c;c=0;d=d+2|0;a:do{if((a[d]|0)==120){d=d+1|0;while(1){if(!((a[d]|0)==59^1)){break a}e=a[d]|0;switch(e|0){case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(e-65))|0;break};case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(e-97))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|e-48;break};default:{}}if((c|0)>=1114112){break}d=d+1|0}f=-1;g=f;i=b;return g|0}else{while(1){if(!((a[d]|0)==59^1)){break a}c=c*10|0;c=c+((a[d]|0)-48)|0;if((c|0)>=1114112){break}d=d+1|0}f=-1;g=f;i=b;return g|0}}while(0);f=yTa(c)|0;g=f;i=b;return g|0}function oVa(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;b=i;i=i+32|0;e=c;c=(d-e|0)/1|0;do{if((c|0)==3){if((a[e]|0)!=97){break}e=e+1|0;if((a[e]|0)!=109){break}e=e+1|0;if((a[e]|0)!=112){break}f=38;g=f;i=b;return g|0}else if((c|0)==4){d=a[e]|0;if((d|0)==113){e=e+1|0;if((a[e]|0)!=117){break}e=e+1|0;if((a[e]|0)!=111){break}e=e+1|0;if((a[e]|0)!=116){break}f=34;g=f;i=b;return g|0}else if((d|0)==97){e=e+1|0;if((a[e]|0)!=112){break}e=e+1|0;if((a[e]|0)!=111){break}e=e+1|0;if((a[e]|0)!=115){break}f=39;g=f;i=b;return g|0}else{break}}else if((c|0)==2){if((a[e+1|0]|0)!=116){break}d=a[e]|0;if((d|0)==108){f=60;g=f;i=b;return g|0}else if((d|0)==103){f=62;g=f;i=b;return g|0}else{break}}}while(0);f=0;g=f;i=b;return g|0}function pVa(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+32|0;h=a;a=b;b=e;e=f;while(1){if(!(a>>>0<b>>>0)){break}switch(d[h+76+(d[a]|0)|0]|0|0){case 5:{a=a+2|0;break};case 9:{f=e;c[f>>2]=(c[f>>2]|0)+1;a=a+1|0;do{if((a|0)!=(b|0)){if((d[h+76+(d[a]|0)|0]|0|0)!=10){break}a=a+1|0}}while(0);c[e+4>>2]=-1;break};case 6:{a=a+3|0;break};case 7:{a=a+4|0;break};case 10:{c[e+4>>2]=-1;f=e;c[f>>2]=(c[f>>2]|0)+1;a=a+1|0;break};default:{a=a+1|0}}f=e+4|0;c[f>>2]=(c[f>>2]|0)+1}i=g;return}function qVa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+1|0;e=e+ -1|0;a:while(1){if((b|0)==(e|0)){k=10;break}switch(d[j+76+(d[b]|0)|0]|0){case 22:case 26:{if((a[b]&-128|0)!=0){k=7}break};case 21:{if((a[b]|0)==9){k=5;break a}break};case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};default:{k=7}}if((k|0)==7){k=0;g=a[b]|0;if(!((g|0)==64|(g|0)==36)){k=8;break}}b=b+1|0}if((k|0)==5){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((k|0)==8){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((k|0)==10){l=1;m=l;i=h;return m|0}return 0}function rVa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;b=i;i=i+56|0;h=d;d=e;e=f;f=g;a:do{if((d-(c[h>>2]|0)|0)>(f-(c[e>>2]|0)|0)){d=(c[h>>2]|0)+(f-(c[e>>2]|0))|0;while(1){if(!(d>>>0>(c[h>>2]|0)>>>0)){break a}if((a[d+ -1|0]&192|0)!=128){break a}d=d+ -1|0}}}while(0);f=c[e>>2]|0;g=c[h>>2]|0;while(1){j=g;if((g|0)==(d|0)){break}a[f]=a[j]|0;g=g+1|0;f=f+1|0}c[h>>2]=j;c[e>>2]=f;i=b;return}function sVa(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+64|0;l=e;e=f;f=g;g=h;h=j;j=c[g>>2]|0;m=c[e>>2]|0;while(1){if((m|0)==(f|0)){n=10;break}if((j|0)==(h|0)){n=10;break}o=d[l+76+(d[m]|0)|0]|0;if((o|0)==7){if((j+2|0)==(h|0)){n=10;break}p=(a[m]&7)<<18|(a[m+1|0]&63)<<12|(a[m+2|0]&63)<<6|a[m+3|0]&63;p=p-65536|0;b[j>>1]=p>>>10|55296;b[j+2>>1]=p&1023|56320;j=j+4|0;m=m+4|0;continue}else if((o|0)==5){p=j;j=p+2|0;b[p>>1]=(a[m]&31)<<6|a[m+1|0]&63;m=m+2|0;continue}else if((o|0)==6){o=j;j=o+2|0;b[o>>1]=(a[m]&15)<<12|(a[m+1|0]&63)<<6|a[m+2|0]&63;m=m+3|0;continue}else{o=m;m=o+1|0;p=j;j=p+2|0;b[p>>1]=a[o]|0;continue}}if((n|0)==10){c[e>>2]=m;c[g>>2]=j;i=k;return}}function tVa(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[231512+(((d[232792+((d[f]|0)>>2&7)|0]|0)<<3)+((a[f]&3)<<1)+((d[f+1|0]|0)>>5&1)<<2)>>2]&1<<(a[f+1|0]&31)|0}function uVa(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[231512+(((d[232792+(((a[f]&15)<<4)+((d[f+1|0]|0)>>2&15))|0]|0)<<3)+((a[f+1|0]&3)<<1)+((d[f+2|0]|0)>>5&1)<<2)>>2]&1<<(a[f+2|0]&31)|0}function vVa(a,b){a=a|0;b=b|0;b=i;i=i+16|0;i=b;return 0}function wVa(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[231512+(((d[231256+((d[f]|0)>>2&7)|0]|0)<<3)+((a[f]&3)<<1)+((d[f+1|0]|0)>>5&1)<<2)>>2]&1<<(a[f+1|0]&31)|0}function xVa(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[231512+(((d[231256+(((a[f]&15)<<4)+((d[f+1|0]|0)>>2&15))|0]|0)<<3)+((a[f+1|0]&3)<<1)+((d[f+2|0]|0)>>5&1)<<2)>>2]&1<<(a[f+2|0]&31)|0}function yVa(b,c){b=b|0;c=c|0;var e=0,f=0;b=i;i=i+16|0;e=c;do{if((d[e]|0|0)<194){f=1}else{if((a[e+1|0]&128|0)==0){f=1;break}f=(a[e+1|0]&192|0)==192}}while(0);i=b;return f&1|0}function zVa(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=c;if((a[e+2|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}do{if((d[e]|0|0)==239){if((d[e+1|0]|0|0)!=191){h=5;break}if((d[e+2|0]|0|0)>189){f=1}else{break}g=f&1;i=b;return g|0}else{h=5}}while(0);do{if((h|0)==5){if((a[e+2|0]&192|0)==192){f=1}else{break}g=f&1;i=b;return g|0}}while(0);h=d[e+1|0]|0;do{if((d[e]|0|0)==224){if((h|0)<160){j=1;break}j=(a[e+1|0]&192|0)==192}else{if((h&128|0)==0){j=1;break}c=d[e+1|0]|0;if((d[e]|0|0)==237){k=(c|0)>159}else{k=(c&192|0)==192}j=(k&1|0)!=0}}while(0);f=(j&1|0)!=0;g=f&1;i=b;return g|0}function AVa(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=c;if((a[e+3|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}if((a[e+3|0]&192|0)==192){f=1;g=f&1;i=b;return g|0}if((a[e+2|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}if((a[e+2|0]&192|0)==192){f=1;g=f&1;i=b;return g|0}c=d[e+1|0]|0;do{if((d[e]|0|0)==240){if((c|0)<144){h=1;break}h=(a[e+1|0]&192|0)==192}else{if((c&128|0)==0){h=1;break}j=d[e+1|0]|0;if((d[e]|0|0)==244){k=(j|0)>143}else{k=(j&192|0)==192}h=(k&1|0)!=0}}while(0);f=(h&1|0)!=0;g=f&1;i=b;return g|0}function BVa(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((Ee[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 19:{j=DVa(h,a+1|0,b,e)|0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((Ee[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((Ee[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=44;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 29:{l=25;break b;break};case 6:{if((b-a|0)<3){l=33;break b}m=a;if((Ee[c[h+336>>2]&63](h,a)|0)==0){l=35;break b}a=m+3|0;continue b;break};case 7:{if((b-a|0)<4){l=38;break b}n=a;if((Ee[c[h+340>>2]&63](h,a)|0)==0){l=40;break b}a=n+4|0;continue b;break};case 18:{l=42;break b;break};case 5:{if((b-a|0)<2){l=28;break b}o=a;if((Ee[c[h+332>>2]&63](h,a)|0)==0){l=30;break b}a=o+2|0;continue b;break};default:{l=43;break b}}}if((l|0)==25){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==28){j=-2;k=j;i=g;return k|0}else if((l|0)==30){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==33){j=-2;k=j;i=g;return k|0}else if((l|0)==35){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==38){j=-2;k=j;i=g;return k|0}else if((l|0)==40){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a+1;j=9;k=j;i=g;return k|0}else if((l|0)==43){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==44){j=-1;k=j;i=g;return k|0}return 0}function CVa(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((Ee[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 30:case 9:case 10:case 21:{c[e>>2]=a;j=22;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((Ee[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((Ee[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=44;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 29:{l=25;break b;break};case 6:{if((b-a|0)<3){l=33;break b}m=a;if((Ee[c[h+336>>2]&63](h,a)|0)==0){l=35;break b}a=m+3|0;continue b;break};case 7:{if((b-a|0)<4){l=38;break b}n=a;if((Ee[c[h+340>>2]&63](h,a)|0)==0){l=40;break b}a=n+4|0;continue b;break};case 18:{l=42;break b;break};case 5:{if((b-a|0)<2){l=28;break b}o=a;if((Ee[c[h+332>>2]&63](h,a)|0)==0){l=30;break b}a=o+2|0;continue b;break};default:{l=43;break b}}}if((l|0)==25){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==28){j=-2;k=j;i=g;return k|0}else if((l|0)==30){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==33){j=-2;k=j;i=g;return k|0}else if((l|0)==35){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==38){j=-2;k=j;i=g;return k|0}else if((l|0)==40){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a+1;j=28;k=j;i=g;return k|0}else if((l|0)==43){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==44){j=-1;k=j;i=g;return k|0}return 0}function DVa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){if((a[b]|0)==120){k=EVa(j,b+1|0,e,f)|0;l=k;i=h;return l|0}g=b;if((d[j+76+(d[b]|0)|0]|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+1|0;while(1){if((b|0)==(e|0)){break a}g=d[j+76+(d[b]|0)|0]|0;if((g|0)==18){m=9;break}else if((g|0)!=25){m=10;break}b=b+1|0}if((m|0)==9){c[f>>2]=b+1;k=10;l=k;i=h;return l|0}else if((m|0)==10){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function EVa(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;a:do{if((a|0)!=(b|0)){f=a;if(!(((d[h+76+(d[a]|0)|0]|0)+ -24|0)>>>0<2)){c[e>>2]=f;j=0;k=j;i=g;return k|0}a=f+1|0;while(1){if((a|0)==(b|0)){break a}f=d[h+76+(d[a]|0)|0]|0;if((f|0)==18){l=7;break}else if(!((f|0)==24|(f|0)==25)){l=8;break}a=a+1|0}if((l|0)==7){c[e>>2]=a+1;j=10;k=j;i=g;return k|0}else if((l|0)==8){c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);j=-1;k=j;i=g;return k|0}function FVa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 24:case 22:{b=b+1|0;break};case 29:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((Ee[c[j+344>>2]&63](j,b)|0)!=0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 15:{k=IVa(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 16:{g=b+1|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=d[j+76+(d[b]|0)|0]|0;if((g|0)==20){k=HVa(j,b+1|0,e,f)|0;l=k;i=h;return l|0}else if((g|0)==27){k=GVa(j,b+1|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((Ee[c[j+348>>2]&63](j,b)|0)!=0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 17:{k=JVa(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((Ee[c[j+352>>2]&63](j,b)|0)!=0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);g=0;b:while(1){if((b|0)==(e|0)){m=104;break}switch(d[j+76+(d[b]|0)|0]|0){case 17:{break b;break};case 29:{m=33;break b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 10:case 9:case 21:{m=73;break b;break};case 7:{if((e-b|0)<4){m=46;break b}n=b;if((Ee[c[j+340>>2]&63](j,b)|0)==0){m=48;break b}b=n+4|0;continue b;break};case 6:{if((e-b|0)<3){m=41;break b}o=b;if((Ee[c[j+336>>2]&63](j,b)|0)==0){m=43;break b}b=o+3|0;continue b;break};case 11:{m=97;break b;break};case 5:{if((e-b|0)<2){m=36;break b}p=b;if((Ee[c[j+332>>2]&63](j,b)|0)==0){m=38;break b}b=p+2|0;continue b;break};case 23:{if((g|0)!=0){m=51;break b}g=1;b=b+1|0;if((b|0)==(e|0)){m=53;break b}switch(d[j+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){m=63;break b}q=b;if((Ee[c[j+348>>2]&63](j,b)|0)==0){m=65;break b}b=q+3|0;continue b;break};case 24:case 22:{b=b+1|0;continue b;break};case 7:{if((e-b|0)<4){m=68;break b}r=b;if((Ee[c[j+352>>2]&63](j,b)|0)==0){m=70;break b}b=r+4|0;continue b;break};case 29:{m=55;break b;break};case 5:{if((e-b|0)<2){m=58;break b}s=b;if((Ee[c[j+344>>2]&63](j,b)|0)==0){m=60;break b}b=s+2|0;continue b;break};default:{m=72;break b}}break};default:{m=103;break b}}}c:do{if((m|0)==33){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==36){k=-2;l=k;i=h;return l|0}else if((m|0)==38){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==41){k=-2;l=k;i=h;return l|0}else if((m|0)==43){c[f>>2]=o;k=0;l=k;i=h;return l|0}else if((m|0)==46){k=-2;l=k;i=h;return l|0}else if((m|0)==48){c[f>>2]=n;k=0;l=k;i=h;return l|0}else if((m|0)==51){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==53){k=-1;l=k;i=h;return l|0}else if((m|0)==55){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==58){k=-2;l=k;i=h;return l|0}else if((m|0)==60){c[f>>2]=s;k=0;l=k;i=h;return l|0}else if((m|0)==63){k=-2;l=k;i=h;return l|0}else if((m|0)==65){c[f>>2]=q;k=0;l=k;i=h;return l|0}else if((m|0)==68){k=-2;l=k;i=h;return l|0}else if((m|0)==70){c[f>>2]=r;k=0;l=k;i=h;return l|0}else if((m|0)==72){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==73){b=b+1|0;d:while(1){if((b|0)==(e|0)){m=96;break}switch(d[j+76+(d[b]|0)|0]|0){case 17:{break c;break};case 24:case 22:{m=77;break d;break};case 29:{m=76;break d;break};case 10:case 9:case 21:{break};case 5:{m=78;break d;break};case 6:{m=83;break d;break};case 7:{m=88;break d;break};case 11:{m=97;break c;break};default:{m=94;break d}}b=b+1|0}do{if((m|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==77){b=b+1|0}else if((m|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((Ee[c[j+344>>2]&63](j,b)|0)!=0){b=g+2|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==83){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((Ee[c[j+348>>2]&63](j,b)|0)!=0){b=g+3|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==88){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((Ee[c[j+352>>2]&63](j,b)|0)!=0){b=g+4|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==94){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==96){k=-1;l=k;i=h;return l|0}}while(0);k=KVa(j,b,e,f)|0;l=k;i=h;return l|0}else if((m|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==104){k=-1;l=k;i=h;return l|0}}while(0);if((m|0)==97){c[f>>2]=b+1;k=2;l=k;i=h;return l|0}b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}e=b;if((a[b]|0)==62){c[f>>2]=e+1;k=4;l=k;i=h;return l|0}else{c[f>>2]=e;k=0;l=k;i=h;return l|0}return 0}function GVa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b]|0)!=45){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+1|0;b:while(1){if((b|0)==(e|0)){break a}switch(d[j+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){m=13;break b}n=b;if((Ee[c[j+360>>2]&63](j,b)|0)!=0){m=15;break b}b=n+3|0;continue b;break};case 8:case 1:case 0:{m=22;break b;break};case 5:{if((e-b|0)<2){m=8;break b}o=b;if((Ee[c[j+356>>2]&63](j,b)|0)!=0){m=10;break b}b=o+2|0;continue b;break};case 7:{if((e-b|0)<4){m=18;break b}p=b;if((Ee[c[j+364>>2]&63](j,b)|0)!=0){m=20;break b}b=p+4|0;continue b;break};case 27:{g=b+1|0;b=g;if((g|0)==(e|0)){m=24;break b}if((a[b]|0)==45){m=26;break b}else{continue b}break};default:{b=b+1|0;continue b}}}if((m|0)==8){k=-2;l=k;i=h;return l|0}else if((m|0)==10){c[f>>2]=o;k=0;l=k;i=h;return l|0}else if((m|0)==13){k=-2;l=k;i=h;return l|0}else if((m|0)==15){c[f>>2]=n;k=0;l=k;i=h;return l|0}else if((m|0)==18){k=-2;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==22){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==24){k=-1;l=k;i=h;return l|0}else if((m|0)==26){g=b+1|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==62){c[f>>2]=g+1;k=13;l=k;i=h;return l|0}else{c[f>>2]=g;k=0;l=k;i=h;return l|0}}}}while(0);k=-1;l=k;i=h;return l|0}function HVa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<6){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=8;break}if((a[k]|0)!=(a[234208+e|0]|0)){l=6;break}e=e+1|0;g=g+1|0}if((l|0)==6){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==8){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function IVa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}a:do{switch(d[k+76+(d[b]|0)|0]|0){case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}n=b;if((Ee[c[k+352>>2]&63](k,b)|0)!=0){b=n+4|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}n=b;if((Ee[c[k+348>>2]&63](k,b)|0)!=0){b=n+3|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}n=b;if((Ee[c[k+344>>2]&63](k,b)|0)!=0){b=n+2|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 29:{c[f>>2]=b;l=0;m=l;i=h;return m|0};case 24:case 22:{b=b+1|0;break};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b:while(1){if((b|0)==(e|0)){o=75;break}switch(d[k+76+(d[b]|0)|0]|0){case 15:{o=68;break b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 5:{if((e-b|0)<2){o=27;break b}p=b;if((Ee[c[k+332>>2]&63](k,b)|0)==0){o=29;break b}b=p+2|0;continue b;break};case 6:{if((e-b|0)<3){o=32;break b}q=b;if((Ee[c[k+336>>2]&63](k,b)|0)==0){o=34;break b}b=q+3|0;continue b;break};case 10:case 9:case 21:{o=41;break b;break};case 29:{o=24;break b;break};case 7:{if((e-b|0)<4){o=37;break b}r=b;if((Ee[c[k+340>>2]&63](k,b)|0)==0){o=39;break b}b=r+4|0;continue b;break};default:{break b}}}do{if((o|0)==24){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((o|0)==27){l=-2;m=l;i=h;return m|0}else if((o|0)==29){c[f>>2]=p;l=0;m=l;i=h;return m|0}else if((o|0)==32){l=-2;m=l;i=h;return m|0}else if((o|0)==34){c[f>>2]=q;l=0;m=l;i=h;return m|0}else if((o|0)==37){l=-2;m=l;i=h;return m|0}else if((o|0)==39){c[f>>2]=r;l=0;m=l;i=h;return m|0}else if((o|0)==41){n=b;if((LVa(k,g,b,j)|0)==0){c[f>>2]=n;l=0;m=l;i=h;return m|0}b=n+1|0;c:while(1){if((b|0)==(e|0)){o=67;break}switch(d[k+76+(d[b]|0)|0]|0){case 7:{if((e-b|0)<4){o=57;break c}s=b;if((Ee[c[k+364>>2]&63](k,b)|0)!=0){o=59;break c}b=s+4|0;continue c;break};case 8:case 1:case 0:{o=61;break c;break};case 15:{b=b+1|0;if((b|0)==(e|0)){o=63;break c}if((a[b]|0)==62){o=65;break c}else{continue c}break};case 5:{if((e-b|0)<2){o=47;break c}t=b;if((Ee[c[k+356>>2]&63](k,b)|0)!=0){o=49;break c}b=t+2|0;continue c;break};case 6:{if((e-b|0)<3){o=52;break c}u=b;if((Ee[c[k+360>>2]&63](k,b)|0)!=0){o=54;break c}b=u+3|0;continue c;break};default:{b=b+1|0;continue c}}}if((o|0)==47){l=-2;m=l;i=h;return m|0}else if((o|0)==49){c[f>>2]=t;l=0;m=l;i=h;return m|0}else if((o|0)==52){l=-2;m=l;i=h;return m|0}else if((o|0)==54){c[f>>2]=u;l=0;m=l;i=h;return m|0}else if((o|0)==57){l=-2;m=l;i=h;return m|0}else if((o|0)==59){c[f>>2]=s;l=0;m=l;i=h;return m|0}else if((o|0)==61){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((o|0)==63){l=-1;m=l;i=h;return m|0}else if((o|0)==65){c[f>>2]=b+1;l=c[j>>2]|0;m=l;i=h;return m|0}else if((o|0)==67){l=-1;m=l;i=h;return m|0}}else if((o|0)==68){n=b;if((LVa(k,g,b,j)|0)==0){c[f>>2]=n;l=0;m=l;i=h;return m|0}b=n+1|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b]|0)!=62){break}c[f>>2]=b+1;l=c[j>>2]|0;m=l;i=h;return m|0}else if((o|0)==75){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function JVa(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((Ee[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((Ee[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((Ee[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=51;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 23:{a=a+1|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 5:{if((b-a|0)<2){l=27;break b}m=a;if((Ee[c[h+332>>2]&63](h,a)|0)==0){l=29;break b}a=m+2|0;continue b;break};case 6:{if((b-a|0)<3){l=32;break b}n=a;if((Ee[c[h+336>>2]&63](h,a)|0)==0){l=34;break b}a=n+3|0;continue b;break};case 10:case 9:case 21:{l=41;break b;break};case 29:{l=24;break b;break};case 7:{if((b-a|0)<4){l=37;break b}o=a;if((Ee[c[h+340>>2]&63](h,a)|0)==0){l=39;break b}a=o+4|0;continue b;break};case 11:{l=49;break b;break};default:{l=50;break b}}}if((l|0)==24){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==27){j=-2;k=j;i=g;return k|0}else if((l|0)==29){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==32){j=-2;k=j;i=g;return k|0}else if((l|0)==34){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==37){j=-2;k=j;i=g;return k|0}else if((l|0)==39){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==41){a=a+1|0;while(1){if((a|0)==(b|0)){l=47;break}o=d[h+76+(d[a]|0)|0]|0;if((o|0)==11){l=44;break}else if(!((o|0)==10|(o|0)==9|(o|0)==21)){l=45;break}a=a+1|0}if((l|0)==44){c[e>>2]=a+1;j=5;k=j;i=g;return k|0}else if((l|0)==45){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==47){j=-1;k=j;i=g;return k|0}}else if((l|0)==49){c[e>>2]=a+1;j=5;k=j;i=g;return k|0}else if((l|0)==50){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==51){j=-1;k=j;i=g;return k|0}return 0}function KVa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=114;break}b:do{switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 29:{l=4;break a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=12;break a}b=(Ee[c[k+336>>2]&63](k,c[j>>2]|0)|0)!=0;m=c[j>>2]|0;if(!b){l=14;break a}c[j>>2]=m+3;continue a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=17;break a}b=(Ee[c[k+340>>2]&63](k,c[j>>2]|0)|0)!=0;n=c[j>>2]|0;if(!b){l=19;break a}c[j>>2]=n+4;continue a;break};case 23:{if((g|0)!=0){l=22;break a}g=1;c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=24;break a}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 29:{l=26;break a;break};case 24:case 22:{c[j>>2]=(c[j>>2]|0)+1;continue a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=39;break a}b=(Ee[c[k+352>>2]&63](k,c[j>>2]|0)|0)!=0;o=c[j>>2]|0;if(!b){l=41;break a}c[j>>2]=o+4;continue a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=34;break a}b=(Ee[c[k+348>>2]&63](k,c[j>>2]|0)|0)!=0;p=c[j>>2]|0;if(!b){l=36;break a}c[j>>2]=p+3;continue a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=29;break a}b=(Ee[c[k+344>>2]&63](k,c[j>>2]|0)|0)!=0;q=c[j>>2]|0;if(!b){l=31;break a}c[j>>2]=q+2;continue a;break};default:{l=43;break a}}break};case 27:case 26:case 25:case 24:case 22:{c[j>>2]=(c[j>>2]|0)+1;continue a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=7;break a}b=(Ee[c[k+332>>2]&63](k,c[j>>2]|0)|0)!=0;r=c[j>>2]|0;if(!b){l=9;break a}c[j>>2]=r+2;continue a;break};case 14:{break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=45;break a}b=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((b|0)==14){break b}s=b;if(!((s|0)==9|(s|0)==10|(s|0)==21)){l=48;break a}}break};default:{l=113;break a}}}while(0);g=0;while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=51;break a}t=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((t|0)==12|(t|0)==13){break}s=t;if(!((s|0)==9|(s|0)==10|(s|0)==21)){l=54;break a}}c[j>>2]=(c[j>>2]|0)+1;c:while(1){if((c[j>>2]|0)==(e|0)){l=57;break a}s=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((s|0)==(t|0)){break}switch(s|0){case 3:{u=BVa(k,(c[j>>2]|0)+1|0,e,j)|0;if((u|0)<=0){l=77;break a}else{continue c}break};case 2:{l=80;break a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=61;break a}s=(Ee[c[k+356>>2]&63](k,c[j>>2]|0)|0)!=0;v=c[j>>2]|0;if(s){l=63;break a}c[j>>2]=v+2;continue c;break};case 8:case 1:case 0:{l=75;break a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=66;break a}s=(Ee[c[k+360>>2]&63](k,c[j>>2]|0)|0)!=0;w=c[j>>2]|0;if(s){l=68;break a}c[j>>2]=w+3;continue c;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=71;break a}s=(Ee[c[k+364>>2]&63](k,c[j>>2]|0)|0)!=0;x=c[j>>2]|0;if(s){l=73;break a}c[j>>2]=x+4;continue c;break};default:{c[j>>2]=(c[j>>2]|0)+1;continue c}}}c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=83;break}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 11:{l=106;break a;break};case 17:{l=107;break a;break};case 10:case 9:case 21:{break};default:{l=85;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=87;break a}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 11:{l=106;break a;break};case 6:{l=96;break d;break};case 17:{l=107;break a;break};case 10:case 9:case 21:{break};case 24:case 22:{l=90;break d;break};case 7:{l=101;break d;break};case 29:{l=89;break a;break};case 5:{l=91;break d;break};default:{l=112;break a}}}if((l|0)==90){l=0;c[j>>2]=(c[j>>2]|0)+1;continue}else if((l|0)==91){l=0;if((e-(c[j>>2]|0)|0)<2){l=92;break}s=(Ee[c[k+344>>2]&63](k,c[j>>2]|0)|0)!=0;y=c[j>>2]|0;if(!s){l=94;break}c[j>>2]=y+2;continue}else if((l|0)==96){l=0;if((e-(c[j>>2]|0)|0)<3){l=97;break}s=(Ee[c[k+348>>2]&63](k,c[j>>2]|0)|0)!=0;z=c[j>>2]|0;if(!s){l=99;break}c[j>>2]=z+3;continue}else if((l|0)==101){l=0;if((e-(c[j>>2]|0)|0)<4){l=102;break}s=(Ee[c[k+352>>2]&63](k,c[j>>2]|0)|0)!=0;A=c[j>>2]|0;if(!s){l=104;break}c[j>>2]=A+4;continue}}if((l|0)==4){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==7){B=-2;C=B;i=h;return C|0}else if((l|0)==9){c[f>>2]=r;B=0;C=B;i=h;return C|0}else if((l|0)==12){B=-2;C=B;i=h;return C|0}else if((l|0)==14){c[f>>2]=m;B=0;C=B;i=h;return C|0}else if((l|0)==17){B=-2;C=B;i=h;return C|0}else if((l|0)==19){c[f>>2]=n;B=0;C=B;i=h;return C|0}else if((l|0)==22){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==24){B=-1;C=B;i=h;return C|0}else if((l|0)==26){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==29){B=-2;C=B;i=h;return C|0}else if((l|0)==31){c[f>>2]=q;B=0;C=B;i=h;return C|0}else if((l|0)==34){B=-2;C=B;i=h;return C|0}else if((l|0)==36){c[f>>2]=p;B=0;C=B;i=h;return C|0}else if((l|0)==39){B=-2;C=B;i=h;return C|0}else if((l|0)==41){c[f>>2]=o;B=0;C=B;i=h;return C|0}else if((l|0)==43){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==45){B=-1;C=B;i=h;return C|0}else if((l|0)==48){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==51){B=-1;C=B;i=h;return C|0}else if((l|0)==54){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==57){B=-1;C=B;i=h;return C|0}else if((l|0)==61){B=-2;C=B;i=h;return C|0}else if((l|0)==63){c[f>>2]=v;B=0;C=B;i=h;return C|0}else if((l|0)==66){B=-2;C=B;i=h;return C|0}else if((l|0)==68){c[f>>2]=w;B=0;C=B;i=h;return C|0}else if((l|0)==71){B=-2;C=B;i=h;return C|0}else if((l|0)==73){c[f>>2]=x;B=0;C=B;i=h;return C|0}else if((l|0)==75){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==77){if((u|0)==0){c[f>>2]=c[j>>2]}B=u;C=B;i=h;return C|0}else if((l|0)==80){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==83){B=-1;C=B;i=h;return C|0}else if((l|0)==85){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==87){B=-1;C=B;i=h;return C|0}else if((l|0)==89){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==92){B=-2;C=B;i=h;return C|0}else if((l|0)==94){c[f>>2]=y;B=0;C=B;i=h;return C|0}else if((l|0)==97){B=-2;C=B;i=h;return C|0}else if((l|0)==99){c[f>>2]=z;B=0;C=B;i=h;return C|0}else if((l|0)==102){B=-2;C=B;i=h;return C|0}else if((l|0)==104){c[f>>2]=A;B=0;C=B;i=h;return C|0}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+1;B=1;C=B;i=h;return C|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){B=-1;C=B;i=h;return C|0}e=c[j>>2]|0;if((a[c[j>>2]|0]|0)==62){c[f>>2]=e+1;B=3;C=B;i=h;return C|0}else{c[f>>2]=e;B=0;C=B;i=h;return C|0}}else if((l|0)==112){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==113){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==114){B=-1;C=B;i=h;return C|0}return 0}function LVa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;do{if((e-g|0)!=3){h=1}else{j=a[g]|0;if((j|0)==88){f=1}else if((j|0)!=120){h=1;break}g=g+1|0;j=a[g]|0;if((j|0)==77){f=1}else if((j|0)!=109){h=1;break}g=g+1|0;j=a[g]|0;if((j|0)==76){f=1}else if((j|0)!=108){h=1;break}if((f|0)!=0){h=0;break}else{c[d>>2]=12;h=1;break}}}while(0);i=b;return h|0}function MVa(a,b,e,f,g){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+56|0;j=a;a=b;b=e;e=f;f=g;a:while(1){if((b|0)==(e|0)){k=27;break}g=d[a+76+(d[b]|0)|0]|0;switch(g|0){case 7:{if((e-b|0)<4){k=15;break a}l=b;if((Ee[c[a+364>>2]&63](a,b)|0)!=0){k=17;break a}b=l+4|0;continue a;break};case 5:{if((e-b|0)<2){k=5;break a}m=b;if((Ee[c[a+356>>2]&63](a,b)|0)!=0){k=7;break a}b=m+2|0;continue a;break};case 8:case 1:case 0:{k=19;break a;break};case 13:case 12:{b=b+1|0;if((g|0)!=(j|0)){continue a}else{k=21;break a}break};case 6:{if((e-b|0)<3){k=10;break a}n=b;if((Ee[c[a+360>>2]&63](a,b)|0)!=0){k=12;break a}b=n+3|0;continue a;break};default:{b=b+1|0;continue a}}}if((k|0)==5){o=-2;p=o;i=h;return p|0}else if((k|0)==7){c[f>>2]=m;o=0;p=o;i=h;return p|0}else if((k|0)==10){o=-2;p=o;i=h;return p|0}else if((k|0)==12){c[f>>2]=n;o=0;p=o;i=h;return p|0}else if((k|0)==15){o=-2;p=o;i=h;return p|0}else if((k|0)==17){c[f>>2]=l;o=0;p=o;i=h;return p|0}else if((k|0)==19){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==21){if((b|0)==(e|0)){o=-27;p=o;i=h;return p|0}c[f>>2]=b;switch(d[a+76+(d[b]|0)|0]|0|0){case 20:case 30:case 11:case 10:case 9:case 21:{o=27;p=o;i=h;return p|0};default:{o=0;p=o;i=h;return p|0}}}else if((k|0)==27){o=-1;p=o;i=h;return p|0}return 0}function NVa(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}f=d[h+76+(d[a]|0)|0]|0;if((f|0)==27){j=GVa(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else if((f|0)==20){c[e>>2]=a+1;j=33;k=j;i=g;return k|0}else if((f|0)==24|(f|0)==22){a=a+1|0;a:while(1){if((a|0)==(b|0)){l=17;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 10:case 9:case 21:{break a;break};case 24:case 22:{break};case 30:{l=10;break a;break};default:{l=16;break a}}a=a+1|0}do{if((l|0)==10){if((a+1|0)==(b|0)){j=-1;k=j;i=g;return k|0}f=d[h+76+(d[a+1|0]|0)|0]|0;if(!((f|0)==30|(f|0)==10|(f|0)==9|(f|0)==21)){break}c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==16){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==17){j=-1;k=j;i=g;return k|0}}while(0);c[e>>2]=a;j=16;k=j;i=g;return k|0}else{c[e>>2]=a;j=0;k=j;i=g;return k|0}return 0}function OVa(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 24:case 22:{a=a+1|0;break};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((Ee[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((Ee[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((Ee[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=43;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){l=32;break b}m=a;if((Ee[c[h+336>>2]&63](h,a)|0)==0){l=34;break b}a=m+3|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 29:{l=24;break b;break};case 7:{if((b-a|0)<4){l=37;break b}n=a;if((Ee[c[h+340>>2]&63](h,a)|0)==0){l=39;break b}a=n+4|0;continue b;break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{l=41;break b;break};case 5:{if((b-a|0)<2){l=27;break b}o=a;if((Ee[c[h+332>>2]&63](h,a)|0)==0){l=29;break b}a=o+2|0;continue b;break};default:{l=42;break b}}}if((l|0)==24){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==27){j=-2;k=j;i=g;return k|0}else if((l|0)==29){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==32){j=-2;k=j;i=g;return k|0}else if((l|0)==34){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==37){j=-2;k=j;i=g;return k|0}else if((l|0)==39){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==41){c[e>>2]=a;j=20;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==43){j=-20;k=j;i=g;return k|0}return 0}function PVa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;i=i+40|0;h=d;d=e;e=f;f=g;while(1){if((c[h>>2]|0)==(d|0)){j=5;break}if((c[e>>2]|0)==(f|0)){j=5;break}g=h;k=c[g>>2]|0;c[g>>2]=k+1;g=a[k]|0;k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=g}if((j|0)==5){i=b;return}}function QVa(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;a=i;i=i+40|0;j=e;e=f;f=g;g=h;while(1){if((c[j>>2]|0)==(e|0)){k=5;break}if((c[f>>2]|0)==(g|0)){k=5;break}h=j;l=c[h>>2]|0;c[h>>2]=l+1;h=d[l]|0;l=f;m=c[l>>2]|0;c[l>>2]=m+2;b[m>>1]=h}if((k|0)==5){i=a;return}}function RVa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;i=i+48|0;h=d;d=e;e=f;f=g;while(1){if((c[h>>2]|0)==(d|0)){j=8;break}g=a[c[h>>2]|0]|0;if((g&128|0)!=0){if((f-(c[e>>2]|0)|0)<2){j=8;break}k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=(g&255)>>6|192;l=e;k=c[l>>2]|0;c[l>>2]=k+1;a[k]=g&63|128;g=h;c[g>>2]=(c[g>>2]|0)+1;continue}else{if((c[e>>2]|0)==(f|0)){j=8;break}g=h;k=c[g>>2]|0;c[g>>2]=k+1;g=a[k]|0;k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=g;continue}}if((j|0)==8){i=b;return}}function SVa(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=i;i=i+72|0;l=b;b=e;e=f;f=g;g=h;h=j;if((f|0)==(g|0)){m=-4;n=m;i=k;return n|0}j=c[b+76>>2]|0;a:do{if((f+1|0)==(g|0)){if(((a[b+73|0]|0)+ -3|0)>>>0<3){m=-1;n=m;i=k;return n|0}b:do{switch(d[f]|0){case 239:case 255:case 254:{if((a[b+73|0]|0)!=0){break b}if((e|0)==1){break a}break};case 60:case 0:{break};default:{break a}}}while(0);m=-1;n=m;i=k;return n|0}else{o=d[f]<<8|d[f+1|0];if((o|0)==15360){if((a[b+73|0]|0)==4){p=16}else{if((a[b+73|0]|0)==3){p=16}}if((p|0)==16){if((e|0)==1){break}}c[j>>2]=c[l+20>>2];m=Oe[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}else if((o|0)==61371){if((e|0)==1){q=a[b+73|0]|0;if((q|0)==0|(q|0)==4|(q|0)==5|(q|0)==3){break}}if((f+2|0)==(g|0)){m=-1;n=m;i=k;return n|0}if((d[f+2|0]|0)!=191){break}c[h>>2]=f+3;c[j>>2]=c[l+8>>2];m=14;n=m;i=k;return n|0}else if((o|0)==65279){if((a[b+73|0]|0)==0){if((e|0)==1){break}}c[h>>2]=f+2;c[j>>2]=c[l+16>>2];m=14;n=m;i=k;return n|0}else if((o|0)==65534){if((a[b+73|0]|0)==0){if((e|0)==1){break}}c[h>>2]=f+2;c[j>>2]=c[l+20>>2];m=14;n=m;i=k;return n|0}else{if((a[f]|0)==0){if((e|0)==1){if((a[b+73|0]|0)==5){break}}c[j>>2]=c[l+16>>2];m=Oe[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}else{if((a[f+1|0]|0)!=0){break}if((e|0)==1){break}c[j>>2]=c[l+20>>2];m=Oe[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}}}}while(0);c[j>>2]=c[l+(a[b+73|0]<<2)>>2];m=Oe[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}function TVa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+80|0;k=a;a=b;b=d;d=e;e=f;f=g;g=h;if((a|0)==(b|0)){c[d>>2]=0;l=1;m=l;i=j;return m|0}if((VVa(UVa(k,a,b)|0)|0)==0){c[g>>2]=a;l=0;m=l;i=j;return m|0}do{a=a+(c[k+68>>2]|0)|0;}while((VVa(UVa(k,a,b)|0)|0)!=0);if((a|0)==(b|0)){c[d>>2]=0;l=1;m=l;i=j;return m|0}c[d>>2]=a;while(1){n=UVa(k,a,b)|0;if((n|0)==-1){o=10;break}if((n|0)==61){o=12;break}if((VVa(n)|0)!=0){o=14;break}a=a+(c[k+68>>2]|0)|0}do{if((o|0)==10){c[g>>2]=a;l=0;m=l;i=j;return m|0}else if((o|0)==12){c[e>>2]=a}else if((o|0)==14){c[e>>2]=a;do{a=a+(c[k+68>>2]|0)|0;h=UVa(k,a,b)|0;n=h;}while((VVa(h)|0)!=0);if((n|0)==61){break}c[g>>2]=a;l=0;m=l;i=j;return m|0}}while(0);if((a|0)==(c[d>>2]|0)){c[g>>2]=a;l=0;m=l;i=j;return m|0}a=a+(c[k+68>>2]|0)|0;n=UVa(k,a,b)|0;while(1){if((VVa(n)|0)==0){break}a=a+(c[k+68>>2]|0)|0;n=UVa(k,a,b)|0}if((n|0)!=34&(n|0)!=39){c[g>>2]=a;l=0;m=l;i=j;return m|0}d=n&255;a=a+(c[k+68>>2]|0)|0;c[f>>2]=a;a:while(1){n=UVa(k,a,b)|0;if((n|0)==(d<<24>>24|0)){o=33;break}do{if(!(97<=(n|0)&(n|0)<=122)){if(65<=(n|0)&(n|0)<=90){break}if((48<=(n|0)&(n|0)<=57^1)&(n|0)!=46&(n|0)!=45&(n|0)!=95){o=31;break a}}}while(0);a=a+(c[k+68>>2]|0)|0}if((o|0)==31){c[g>>2]=a;l=0;m=l;i=j;return m|0}else if((o|0)==33){c[g>>2]=a+(c[k+68>>2]|0);l=1;m=l;i=j;return m|0}return 0}function UVa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+48|0;g=f+16|0;h=f+32|0;j=f+40|0;k=b;c[g>>2]=d;c[j>>2]=h;je[c[k+60>>2]&31](k,g,e,j,(c[j>>2]|0)+1|0);if((c[j>>2]|0)==(h|0)){l=-1;m=l;i=f;return m|0}else{l=a[h]|0;m=l;i=f;return m|0}return 0}function VVa(a){a=a|0;var b=0,c=0,d=0;b=i;i=i+16|0;c=a;if((c|0)==9|(c|0)==10|(c|0)==13|(c|0)==32){d=1}else{d=0}i=b;return d|0}function WVa(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;c[d>>2]=13;c[d+16>>2]=1;c[d+12>>2]=0;c[d+20>>2]=0;i=b;return}function XVa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 16:{if((Oe[c[b+28>>2]&63](b,d+(c[b+68>>2]<<1)|0,e,237952)|0)==0){j=10;break a}c[h>>2]=15;k=3;break};case 29:{c[h>>2]=16;k=2;break};case 11:{c[h>>2]=14;k=55;break};case 15:{c[h>>2]=14;k=0;break};case 13:{c[h>>2]=14;k=56;break};case 14:{k=0;break};case 12:{c[h>>2]=14;k=1;break};default:{j=10}}}while(0);if((j|0)==10){k=$Va(h,a)|0}i=g;return k|0}function YVa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;a:do{switch(a|0){case 34:{if((c[h+12>>2]|0)==0){j=9;break a}b=h+12|0;c[b>>2]=(c[b>>2]|0)-1;k=0;break};case 33:{c[h>>2]=17;k=0;break};case 26:{j=9;break};case 15:{k=0;break};case-4:{if((c[h+12>>2]|0)!=0){j=9;break a}k=0;break};default:{k=_Va(h,a,d,e,f)|0}}}while(0);if((j|0)==9){k=$Va(h,a)|0}i=g;return k|0}function ZVa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;if((f|0)==15){j=0;k=j;i=g;return k|0}else if((f|0)==18){l=3}do{if((l|0)==3){if((Oe[c[e+28>>2]&63](e,b,d,237936)|0)!=0){c[h>>2]=18;j=0;k=j;i=g;return k|0}if((Oe[c[e+28>>2]&63](e,b,d,237944)|0)==0){break}c[h>>2]=19;j=0;k=j;i=g;return k|0}}while(0);j=$Va(h,a)|0;k=j;i=g;return k|0}function _Va(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;a:do{switch(a|0){case 15:{j=0;k=j;i=g;return k|0};case-4:{j=0;k=j;i=g;return k|0};case 26:{c[h>>2]=24;j=3;k=j;i=g;return k|0};case 13:{j=56;k=j;i=g;return k|0};case 11:{j=55;k=j;i=g;return k|0};case 28:{j=60;k=j;i=g;return k|0};case 16:{if((Oe[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,237712)|0)!=0){c[h>>2]=20;j=11;k=j;i=g;return k|0}if((Oe[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,237720)|0)!=0){c[h>>2]=21;j=33;k=j;i=g;return k|0}if((Oe[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,237728)|0)!=0){c[h>>2]=22;j=39;k=j;i=g;return k|0}if((Oe[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,237736)|0)==0){break a}c[h>>2]=23;j=17;k=j;i=g;return k|0};default:{}}}while(0);j=$Va(h,a)|0;k=j;i=g;return k|0}function $Va(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+24|0;e=a;do{if((c[e+16>>2]|0)==0){if((b|0)!=28){break}f=59;g=f;i=d;return g|0}}while(0);c[e>>2]=16;f=-1;g=f;i=d;return g|0}function aWa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;e=i;i=i+40|0;i=e;return 0}function bWa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=26;g=9}else if((b|0)==15){g=11}else if((b|0)==22){c[e>>2]=25;g=11}else{g=$Va(e,a)|0}i=f;return g|0}function cWa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=27;g=34}else if((b|0)==15){g=33}else{g=$Va(e,a)|0}i=f;return g|0}function dWa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=39}else if((b|0)==41|(b|0)==18){c[e>>2]=28;g=40}else{g=$Va(e,a)|0}i=f;return g|0}function eWa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=17}else if((b|0)==18){c[e>>2]=29;g=18}else{g=$Va(e,a)|0}i=f;return g|0}function fWa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==17){c[e>>2]=30;g=8}else{g=$Va(e,a)|0}i=f;return g|0}function gWa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==11){g=55}else if((b|0)==15){g=0}else if((b|0)==29){c[e>>2]=16;g=2}else if((b|0)==13){g=56}else{g=$Va(e,a)|0}i=f;return g|0}function hWa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;if((f|0)==15){j=17;k=j;i=g;return k|0}else if((f|0)==18){l=3}do{if((l|0)==3){if((Oe[c[e+28>>2]&63](e,b,d,237752)|0)!=0){c[h>>2]=31;j=17;k=j;i=g;return k|0}if((Oe[c[e+28>>2]&63](e,b,d,237760)|0)==0){break}c[h>>2]=32;j=17;k=j;i=g;return k|0}}while(0);j=$Va(h,a)|0;k=j;i=g;return k|0}function iWa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=17}else if((b|0)==27){c[e>>2]=33;c[e+8>>2]=17;g=19}else{g=$Va(e,a)|0}i=f;return g|0}function jWa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=34;g=21}else if((b|0)==15){g=17}else{g=$Va(e,a)|0}i=f;return g|0}function kWa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=33;c[e+8>>2]=17;g=19}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=20}else if((b|0)==15){g=17}else{g=$Va(e,a)|0}i=f;return g|0}function lWa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=c[e+8>>2]|0;h=g;i=f;return h|0}else if((b|0)==15){g=c[e+8>>2]|0;h=g;i=f;return h|0}else{g=$Va(e,a)|0;h=g;i=f;return h|0}return 0}function mWa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=39;k=j;i=g;return k|0}else if((f|0)==23){c[h>>2]=37;c[h+4>>2]=1;j=44;k=j;i=g;return k|0}else if((f|0)==18){if((Oe[c[e+28>>2]&63](e,b,d,237768)|0)!=0){c[h>>2]=33;c[h+8>>2]=39;j=42;k=j;i=g;return k|0}if((Oe[c[e+28>>2]&63](e,b,d,237776)|0)==0){break}c[h>>2]=33;c[h+8>>2]=39;j=41;k=j;i=g;return k|0}}while(0);j=$Va(h,a)|0;k=j;i=g;return k|0}function nWa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 20:{if((Oe[c[b+28>>2]&63](b,d+(c[b+68>>2]|0)|0,e,237784)|0)==0){j=10;break a}c[h>>2]=38;k=43;break};case 30:{c[h>>2]=40;k=53;break};case 31:{c[h>>2]=40;k=52;break};case 32:{c[h>>2]=40;k=54;break};case 15:{k=39;break};case 23:{c[h+4>>2]=2;c[h>>2]=39;k=44;break};case 41:case 18:{c[h>>2]=40;k=51;break};default:{j=10}}}while(0);if((j|0)==10){k=$Va(h,a)|0}i=g;return k|0}function oWa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=39}else if((b|0)==21){c[e>>2]=41;g=39}else if((b|0)==24){c[e>>2]=33;c[e+8>>2]=39;g=45}else if((b|0)==36){c[e>>2]=33;c[e+8>>2]=39;g=46}else{g=$Va(e,a)|0}i=f;return g|0}function pWa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;switch(a|0){case 15:{g=39;break};case 41:case 18:{c[e>>2]=40;g=51;break};case 32:{c[e>>2]=40;g=54;break};case 23:{b=e+4|0;c[b>>2]=(c[b>>2]|0)+1;g=44;break};case 31:{c[e>>2]=40;g=52;break};case 30:{c[e>>2]=40;g=53;break};default:{g=$Va(e,a)|0}}i=f;return g|0}function qWa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;switch(a|0){case 38:{c[e>>2]=39;g=50;h=g;i=f;return h|0};case 15:{g=39;h=g;i=f;return h|0};case 35:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=47;h=g;i=f;return h|0};case 24:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=45;h=g;i=f;return h|0};case 36:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=46;h=g;i=f;return h|0};case 21:{c[e>>2]=39;g=49;h=g;i=f;return h|0};case 37:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=48;h=g;i=f;return h|0};default:{g=$Va(e,a)|0;h=g;i=f;return h|0}}return 0}function rWa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=39}else if((b|0)==41|(b|0)==18){c[e>>2]=42;g=51}else{g=$Va(e,a)|0}i=f;return g|0}function sWa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==21){c[e>>2]=41;g=39}else if((b|0)==15){g=39}else if((b|0)==36){c[e>>2]=33;c[e+8>>2]=39;g=46}else{g=$Va(e,a)|0}i=f;return g|0}function tWa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=33}else if((b|0)==41|(b|0)==18){c[e>>2]=43;g=22}else{g=$Va(e,a)|0}i=f;return g|0}function uWa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+56|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==23){c[h>>2]=46;j=33;k=j;i=g;return k|0}else if((f|0)==15){j=33;k=j;i=g;return k|0}else if((f|0)==18){l=0;while(1){m=c[e+28>>2]|0;n=e;o=b;p=d;if((l|0)>=8){break}if((Oe[m&63](n,o,p,c[237792+(l<<2)>>2]|0)|0)!=0){q=6;break}l=l+1|0}if((q|0)==6){c[h>>2]=44;j=23+l|0;k=j;i=g;return k|0}if((Oe[m&63](n,o,p,237736)|0)==0){break}c[h>>2]=45;j=33;k=j;i=g;return k|0}}while(0);j=$Va(h,a)|0;k=j;i=g;return k|0}function vWa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==27){c[h>>2]=27;j=37;k=j;i=g;return k|0}else if((f|0)==15){j=33;k=j;i=g;return k|0}else if((f|0)==20){if((Oe[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,237896)|0)!=0){c[h>>2]=27;j=35;k=j;i=g;return k|0}if((Oe[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,237904)|0)!=0){c[h>>2]=27;j=36;k=j;i=g;return k|0}if((Oe[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,237920)|0)==0){break}c[h>>2]=47;j=33;k=j;i=g;return k|0}}while(0);j=$Va(h,a)|0;k=j;i=g;return k|0}function wWa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==23){c[e>>2]=48;g=33}else if((b|0)==15){g=33}else{g=$Va(e,a)|0}i=f;return g|0}function xWa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==41|(b|0)==18|(b|0)==19){c[e>>2]=49;g=31}else{g=$Va(e,a)|0}i=f;return g|0}function yWa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==21){c[e>>2]=46;g=33}else if((b|0)==24){c[e>>2]=44;g=33}else if((b|0)==15){g=33}else{g=$Va(e,a)|0}i=f;return g|0}function zWa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==18){c[e>>2]=50;g=32}else{g=$Va(e,a)|0}i=f;return g|0}function AWa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==21){c[e>>2]=48;g=33}else if((b|0)==24){c[e>>2]=44;g=33}else{g=$Va(e,a)|0}i=f;return g|0}function BWa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==27){c[e>>2]=27;g=38}else{g=$Va(e,a)|0}i=f;return g|0}function CWa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=51;g=10}else if((b|0)==15){g=11}else{g=$Va(e,a)|0}i=f;return g|0}function DWa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=11;k=j;i=g;return k|0}else if((f|0)==18){if((Oe[c[e+28>>2]&63](e,b,d,237752)|0)!=0){c[h>>2]=52;j=11;k=j;i=g;return k|0}if((Oe[c[e+28>>2]&63](e,b,d,237760)|0)==0){break}c[h>>2]=53;j=11;k=j;i=g;return k|0}else if((f|0)==27){c[h>>2]=33;c[h+8>>2]=11;j=12;k=j;i=g;return k|0}}while(0);j=$Va(h,a)|0;k=j;i=g;return k|0}function EWa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==27){c[e>>2]=54;g=13}else{g=$Va(e,a)|0}i=f;return g|0}function FWa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==27){c[e>>2]=52;g=14}else{g=$Va(e,a)|0}i=f;return g|0}function GWa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;f=a;do{if((f|0)==18){if((Oe[c[b+28>>2]&63](b,d,e,237928)|0)==0){break}c[h>>2]=55;j=11;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}else if((f|0)==17){c[h>>2]=(c[h+16>>2]|0)!=0?35:36;j=15;k=j;i=g;return k|0}}while(0);j=$Va(h,a)|0;k=j;i=g;return k|0}function HWa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==18){c[e>>2]=33;c[e+8>>2]=11;g=16}else{g=$Va(e,a)|0}i=f;return g|0}function IWa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==27){c[h>>2]=33;c[h+8>>2]=11;j=12;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}else if((f|0)==18){if((Oe[c[e+28>>2]&63](e,b,d,237752)|0)!=0){c[h>>2]=56;j=11;k=j;i=g;return k|0}if((Oe[c[e+28>>2]&63](e,b,d,237760)|0)==0){break}c[h>>2]=57;j=11;k=j;i=g;return k|0}}while(0);j=$Va(h,a)|0;k=j;i=g;return k|0}function JWa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=58;g=13}else if((b|0)==15){g=11}else{g=$Va(e,a)|0}i=f;return g|0}function KWa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=56;g=14}else if((b|0)==15){g=11}else{g=$Va(e,a)|0}i=f;return g|0}function LWa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11;h=g;i=f;return h|0}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=15;h=g;i=f;return h|0}else{g=$Va(e,a)|0;h=g;i=f;return h|0}return 0}function MWa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=0;h=g;i=f;return h|0}else if((b|0)==25){c[e>>2]=36;b=e+12|0;c[b>>2]=(c[b>>2]|0)+1;g=0;h=g;i=f;return h|0}else{g=$Va(e,a)|0;h=g;i=f;return h|0}return 0}function NWa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==25){c[e>>2]=36;g=58}else if((b|0)==15){g=0}else{g=$Va(e,a)|0}i=f;return g|0}function OWa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 11:{j=55;break};case 13:{j=56;break};case 15:{j=0;break};case 14:{j=0;break};case 29:{c[h>>2]=16;j=2;break};case 16:{if((Oe[c[b+28>>2]&63](b,d+(c[b+68>>2]<<1)|0,e,237952)|0)==0){k=9;break a}c[h>>2]=15;j=3;break};default:{k=9}}}while(0);if((k|0)==9){j=$Va(h,a)|0}i=g;return j|0}function PWa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=59;g=4}else if((b|0)==15){g=3}else{g=$Va(e,a)|0}i=f;return g|0}function QWa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==18){if((Oe[c[e+28>>2]&63](e,b,d,237752)|0)!=0){c[h>>2]=60;j=3;k=j;i=g;return k|0}if((Oe[c[e+28>>2]&63](e,b,d,237760)|0)==0){break}c[h>>2]=61;j=3;k=j;i=g;return k|0}else if((f|0)==15){j=3;k=j;i=g;return k|0}else if((f|0)==25){c[h>>2]=35;j=7;k=j;i=g;return k|0}else if((f|0)==17){c[h>>2]=30;j=8;k=j;i=g;return k|0}}while(0);j=$Va(h,a)|0;k=j;i=g;return k|0}function RWa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=62;g=5}else if((b|0)==15){g=3}else{g=$Va(e,a)|0}i=f;return g|0}function SWa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==27){c[e>>2]=60;g=6}else{g=$Va(e,a)|0}i=f;return g|0}function TWa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==25){c[e>>2]=35;g=7}else if((b|0)==17){c[e>>2]=30;g=8}else{g=$Va(e,a)|0}i=f;return g|0}function UWa(){i=i;return}function VWa(){i=i;return}function WWa(){var a=0;a=i;Xa(237960,0)|0;i=a;return}function XWa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;if((a|0)==0){e=c[r>>2]|0;uc(237968,29,1,e|0)|0;Bd(e|0)|0;f=0;i=b;return f|0}e=c[a>>2]|0;if((e|0)<0){g=c[r>>2]|0;uc(238e3,54,1,g|0)|0;Bd(g|0)|0;f=0;i=b;return f|0}g=c[a+4>>2]|0;if((g|0)==0){a=c[r>>2]|0;uc(238056,47,1,a|0)|0;Bd(a|0)|0;f=0;i=b;return f|0}if((e|0)>0){h=0}else{f=1;i=b;return f|0}while(1){j=c[g+(h<<2)>>2]|0;a=h+1|0;if((j|0)<0){break}if((a|0)<(e|0)){h=a}else{f=1;k=11;break}}if((k|0)==11){i=b;return f|0}k=c[r>>2]|0;c[d>>2]=h;c[d+4>>2]=j;Dd(k|0,238104,d|0)|0;Bd(k|0)|0;f=0;i=b;return f|0}function YWa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;d=c[a>>2]|0;if((d|0)<=0){e=1;i=b;return e|0}f=c[a+4>>2]|0;a=0;g=1;while(1){h=fa(c[f+(a<<2)>>2]|0,g)|0;j=a+1|0;if((j|0)<(d|0)){g=h;a=j}else{e=h;break}}i=b;return e|0}function ZWa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;c[a>>2]=1;f=GXa(1)|0;c[a+4>>2]=f;c[f>>2]=b;c[a+8>>2]=d;i=e;return}function _Wa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;c[a>>2]=b;f=a+4|0;c[f>>2]=GXa(b)|0;if((b|0)>0){g=0;h=1}else{j=1;i=e;return j|0}while(1){a=c[d>>2]|0;k=c[a>>2]|0;c[d>>2]=a+4;c[(c[f>>2]|0)+(g<<2)>>2]=k;a=fa(k,h)|0;k=g+1|0;if((k|0)<(b|0)){h=a;g=k}else{j=a;break}}i=e;return j|0}function $Wa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+40|0;f=e;g=e+24|0;if((b|0)<=0){h=0;i=e;return h|0}j=a+4|0;a=0;k=0;while(1){l=c[d>>2]|0;m=c[l>>2]|0;c[d>>2]=l+4;l=c[(c[j>>2]|0)+(a<<2)>>2]|0;if((m|0)<1|(m|0)>(l|0)){n=c[72300]|0;o=a+1|0;c[g>>2]=o;c[g+4>>2]=l;c[g+8>>2]=m;p=n;n=f;q=238200;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];Pe[p&127](0,f,238224,g);r=o;s=c[(c[j>>2]|0)+(a<<2)>>2]|0}else{r=a+1|0;s=l}l=m+ -1+(fa(s,k)|0)|0;if((r|0)<(b|0)){a=r;k=l}else{h=l;break}}i=e;return h|0}function aXa(a,b){a=a|0;b=b|0;var d=0;d=i;if((XWa(a)|0)==0){db(238280,238168,347,238304)}do{if((b|0)>0){if((c[a>>2]|0)<(b|0)){break}i=d;return c[(c[a+4>>2]|0)+(b+ -1<<2)>>2]|0}}while(0);db(238336,238168,348,238304);return 0}function bXa(){var a=0,b=0,d=0;a=i;b=240080|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));b=240192|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));b=240304|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));c[240084>>2]=1;c[240088>>2]=1;i=a;return}function cXa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+24|0;e=d;f=c[b+4>>2]|0;g=c[b+8>>2]|0;h=c[b+12>>2]|0;j=c[b+16>>2]|0;k=(c[b+20>>2]|0)!=0?240440:240456;c[e>>2]=c[b>>2];c[e+4>>2]=f;c[e+8>>2]=g;c[e+12>>2]=h;c[e+16>>2]=j;c[e+20>>2]=k;Dd(a|0,240416,e|0)|0;i=d;return}function dXa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=240304+(d<<2)|0;o=240192+(d<<2)|0;p=240504+(b<<2)|0;q=238784+(d<<2)|0;r=e;e=f;f=(g|0)!=0;a:while(1){b:do{if(f){c[l>>2]=240488;kc(240472,l|0)|0;s=240488}else{if((c[60016]|0)==(d|0)){if((c[o>>2]|0)>0){t=240488}else{u=5}}else{u=5}if((u|0)==5){u=0;t=c[q>>2]|0}c[m>>2]=t;kc(240472,m|0)|0;do{if((c[60016]|0)==(d|0)){if((c[n>>2]|0)!=(b|0)){break}if((c[o>>2]|0)>0){s=240488;break b}}}while(0);s=c[p>>2]|0}}while(0);c[k>>2]=s;kc(240496,k|0)|0;c[n>>2]=b;c[60016]=d;if((c[o>>2]|0)>0){g=0;while(1){kc(240528,j|0)|0;v=g+1|0;if((v|0)<(c[o>>2]|0)){g=v}else{w=0;break}}}else{w=0}while(1){x=e+w|0;g=a[x]|0;if(g<<24>>24==0){break a}else if(g<<24>>24==10){break}w=w+1|0}a[x]=0;wb(e|0)|0;r=0;e=e+(w+1)|0;f=1}wb(e|0)|0;Bd(0)|0;if((r|0)==0){i=h;return}c[o>>2]=(c[o>>2]|0)+1;i=h;return}function eXa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+8|0;h=f;j=i;i=i+8|0;k=c[240504+(a<<2)>>2]|0;c[j>>2]=c[238784+(b<<2)>>2];c[j+4>>2]=k;kc(240536,j|0)|0;fXa(e);if((g|0)==0){Rd(((d|0)!=0?240576:240624)|0,c[t>>2]|0)|0;l=t;m=c[t>>2]|0;n=Bd(m|0)|0;i=f;return}wb(240704)|0;if((c[g>>2]|0)>=1){e=1;while(1){c[h>>2]=c[g+(e<<2)>>2];kc(240584,h|0)|0;if((e|0)<(c[g>>2]|0)){e=e+1|0}else{break}}}if((d|0)!=0){l=t;m=c[t>>2]|0;n=Bd(m|0)|0;i=f;return}uc(240608,11,1,c[t>>2]|0)|0;l=t;m=c[t>>2]|0;n=Bd(m|0)|0;i=f;return}function fXa(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[t>>2]|0;f=b;while(1){b=a[f]|0;if(b<<24>>24==60){uc(240656,4,1,e|0)|0}else if(b<<24>>24==62){uc(240664,4,1,e|0)|0}else if(b<<24>>24==0){break}else if(b<<24>>24==38){uc(240648,5,1,e|0)|0}else{Zd(b<<24>>24|0,e|0)|0}f=f+1|0}i=d;return}function gXa(a){a=a|0;var b=0;b=240192+(a<<2)|0;c[b>>2]=(c[b>>2]|0)+ -1;i=i;return}function hXa(a){a=a|0;var b=0;b=(a|0)==0;c[60160]=b?1:19;c[60158]=b?7:1409;i=i;return}function iXa(a){a=a|0;var b=0;a=i;b=c[t>>2]|0;uc(240608,11,1,b|0)|0;Bd(b|0)|0;i=a;return}function jXa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;i=i+2064|0;h=g+2048|0;if((c[240080+(a<<2)>>2]|0)==0){i=g;return}j=g;c[h>>2]=f;bd(j|0,2048,e|0,h|0)|0;ye[c[60160]&31](1,a,b,j,0,d);i=g;return}function kXa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+2064|0;g=f+2048|0;if((c[240080+(a<<2)>>2]|0)==0){i=f;return}h=f;c[g>>2]=e;bd(h|0,2048,d|0,g|0)|0;ye[c[60160]&31](1,a,b,h,0,0);i=f;return}function lXa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+2064|0;h=g;j=g+2048|0;do{if((c[60018]|0)==0){if((c[240080+(a<<2)>>2]|0)!=0){break}i=g;return}}while(0);k=h;c[j>>2]=f;bd(k|0,2048,e|0,j|0)|0;ye[c[60160]&31](2,a,b,k,0,d);i=g;return}function mXa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+2064|0;g=f;h=f+2048|0;do{if((c[60018]|0)==0){if((c[240080+(a<<2)>>2]|0)!=0){break}i=f;return}}while(0);j=g;c[h>>2]=e;bd(j|0,2048,d|0,h|0)|0;ye[c[60160]&31](2,a,b,j,0,0);i=f;return}function nXa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+2064|0;g=f+2048|0;if((b|0)!=0){i=f;return}b=f;c[g>>2]=e;bd(b|0,2048,d|0,g|0)|0;ye[c[60160]&31](4,2,0,b,0,0);if((a|0)==0){h=rd(c[59490]|0)|0}else{h=a}fb(c[h+76>>2]|0,1)}function oXa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+2064|0;f=e+2048|0;g=e;c[f>>2]=d;bd(g|0,2048,b|0,f|0)|0;ye[c[60160]&31](5,2,0,g,0,0);if((a|0)==0){h=rd(c[59490]|0)|0}else{h=a}fb(c[h+76>>2]|0,1)}function pXa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+2064|0;g=f+2048|0;h=f;c[g>>2]=e;bd(h|0,2048,d|0,g|0)|0;ye[c[60160]&31](5,2,0,h,0,b);if((a|0)==0){j=rd(c[59490]|0)|0}else{j=a}fb(c[j+76>>2]|0,1)}function qXa(a,b,d,e,f,g){a=a|0;b=+b;d=d|0;e=e|0;f=+f;g=g|0;var j=0,l=0,m=0;j=i;i=i+16|0;l=j;m=i;i=i+16|0;if(g<<24>>24==0){g=l;h[k>>3]=f;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[l+8>>2]=d;pXa(a,e,240776,l)}else{l=m;h[k>>3]=f;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];c[m+8>>2]=d;lXa(26,0,e,240712,m);i=j;return+b}return 0.0}function rXa(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=Wpb(16)|0;nXa(0,(d|0)!=0|0,240824,b);c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=a;c[d+12>>2]=0;i=b;return d|0}function sXa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((a|0)==0){i=b;return}d=a;e=c[d>>2]|0;if((e|0)!=0){f=e;while(1){e=c[f+4>>2]|0;Xpb(c[f>>2]|0);Xpb(f);if((e|0)==0){break}else{f=e}}}c[a+12>>2]=0;c[d>>2]=0;c[a+4>>2]=0;i=b;return}function tXa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;nXa(0,(a|0)!=0|0,240840,f);f=Wpb(8)|0;g=f;nXa(0,(f|0)!=0|0,240824,e);e=a+8|0;h=Wpb(c[e>>2]|0)|0;c[f>>2]=h;nXa(0,(h|0)!=0|0,240824,d);Aqb(c[f>>2]|0,b|0,c[e>>2]|0)|0;e=a;c[f+4>>2]=c[e>>2];f=a+12|0;c[f>>2]=(c[f>>2]|0)+1;c[e>>2]=g;e=a+4|0;if((c[e>>2]|0)!=0){i=d;return}c[e>>2]=g;i=d;return}function uXa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;nXa(0,(a|0)!=0|0,240840,f);f=Wpb(8)|0;g=f;nXa(0,(f|0)!=0|0,240824,e);e=a+8|0;h=Wpb(c[e>>2]|0)|0;c[f>>2]=h;nXa(0,(h|0)!=0|0,240824,d);Aqb(c[f>>2]|0,b|0,c[e>>2]|0)|0;c[f+4>>2]=0;f=a+12|0;c[f>>2]=(c[f>>2]|0)+1;f=a+4|0;e=c[f>>2]|0;if((e|0)!=0){c[e+4>>2]=g}c[f>>2]=g;f=a;if((c[f>>2]|0)!=0){i=d;return}c[f>>2]=g;i=d;return}function vXa(a){a=a|0;var b=0;b=i;i=i+8|0;nXa(0,(a|0)!=0|0,240840,b);i=b;return c[a+12>>2]|0}function wXa(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;nXa(0,(a|0)!=0|0,240840,d);d=a;nXa(0,(c[d>>2]|0)!=0|0,240864,b);i=b;return c[c[d>>2]>>2]|0}function xXa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((a|0)==0){i=b;return}d=a;e=c[d>>2]|0;if((e|0)==0){i=b;return}f=c[e+4>>2]|0;Xpb(c[e>>2]|0);Xpb(c[d>>2]|0);c[d>>2]=f;d=a+12|0;c[d>>2]=(c[d>>2]|0)+ -1;if((f|0)!=0){i=b;return}c[a+4>>2]=0;i=b;return}function yXa(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;nXa(0,(a|0)!=0|0,240840,d);d=a;nXa(0,(c[d>>2]|0)!=0|0,240880,b);i=b;return c[d>>2]|0}function zXa(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=(a|0)!=0;nXa(0,d&1,240912,b);if(!d){e=0;i=b;return e|0}e=c[a+4>>2]|0;i=b;return e|0}function AXa(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;nXa(0,(a|0)!=0|0,240912,d);d=a;nXa(0,(c[d>>2]|0)!=0|0,240936,b);i=b;return c[d>>2]|0}function BXa(){var a=0,b=0,d=0;a=i;b=Wpb(16)|0;c[60252]=b;c[b+4>>2]=0;c[b+8>>2]=2097152;d=Wpb(2097152)|0;c[b>>2]=d;c[b+12>>2]=0;i=a;return}function CXa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=HXa(a)|0;wc(241016)|0;IXa(d);a=c[60252]|0;e=a+4|0;f=c[e>>2]|0;g=(c[a>>2]|0)+f|0;c[e>>2]=f+d;jc(241016)|0;Cqb(g|0,0,d|0)|0;i=b;return g|0}function DXa(){var a=0,b=0,d=0,e=0;a=i;b=c[60252]|0;d=c[b+12>>2]|0;if((d|0)==0){e=b}else{b=d;while(1){d=c[b+12>>2]|0;Xpb(c[b>>2]|0);Xpb(b);if((d|0)==0){break}else{b=d}}e=c[60252]|0}c[e+4>>2]=0;c[e+12>>2]=0;i=a;return 0}function EXa(a){a=a|0;var b=0,d=0;b=i;d=pe[c[240968>>2]&127](a<<3)|0;i=b;return d|0}function FXa(a){a=a|0;var b=0,d=0;b=i;d=pe[c[240968>>2]&127](a<<2)|0;i=b;return d|0}function GXa(a){a=a|0;var b=0,d=0;b=i;d=pe[c[240968>>2]&127](a<<2)|0;i=b;return d|0}function HXa(a){a=a|0;i=i;return a+7&-8|0}function IXa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[60252]|0;e=d+8|0;if(!(((c[e>>2]|0)-(c[d+4>>2]|0)|0)>>>0<a>>>0)){i=b;return}f=Wpb(16)|0;c[f+12>>2]=d;c[60252]=f;c[f+4>>2]=0;d=JXa((((c[e>>2]|0)*3|0)>>>1)+a|0)|0;c[f+8>>2]=d;a=Wpb(d)|0;c[f>>2]=a;i=b;return}function JXa(a){a=a|0;var b=0;b=a+ -1|0;a=b>>>1|b;b=a>>>2|a;a=b>>>4|b;b=a>>>8|a;i=i;return(b>>>16|b)+1|0}function KXa(a){a=a|0;var b=0,c=0;b=i;c=yqb(a|0)|0;i=b;return c|0}function LXa(b,d){b=+b;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0;e=i;i=i+8|0;f=e;g=i;i=i+40|0;j=i;i=i+400|0;l=g;m=j;a[l]=37;Eqb(g+1|0,d|0)|0;d=f;h[k>>3]=b;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];lc(m|0,l|0,f|0)|0;f=MXa(m)|0;i=e;return f|0}function MXa(a){a=a|0;var b=0,c=0,d=0;b=i;c=yqb(a|0)|0;d=QXa(c)|0;Aqb(d|0,a|0,c|0)|0;i=b;return d|0}function NXa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+8|0;f=e;g=i;i=i+40|0;h=i;i=i+400|0;j=g;k=h;a[j]=37;Eqb(g+1|0,d|0)|0;c[f>>2]=b;lc(k|0,j|0,f|0)|0;f=MXa(k)|0;i=e;return f|0}function OXa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+8|0;g=f;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+40|0;l=i;i=i+400|0;m=k;n=l;a[m]=37;l=k+1|0;if(e<<24>>24==0){c[h>>2]=d;lc(l|0,241048,h|0)|0;o=g;p=o;c[p>>2]=b;q=39;r=q;s=lc(n|0,m|0,g|0)|0;t=MXa(n)|0;i=f;return t|0}else{c[j>>2]=d;lc(l|0,241040,j|0)|0;o=g;p=o;c[p>>2]=b;q=39;r=q;s=lc(n|0,m|0,g|0)|0;t=MXa(n)|0;i=f;return t|0}return 0}function PXa(b,d,e,f){b=+b;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+8|0;j=g;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+40|0;o=i;i=i+400|0;p=n;q=o;a[p]=37;o=n+1|0;if(e<<24>>24==0){c[l>>2]=d;c[l+4>>2]=f;lc(o|0,241064,l|0)|0}else{c[m>>2]=d;c[m+4>>2]=f;lc(o|0,241056,m|0)|0}m=j;h[k>>3]=b;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];lc(q|0,p|0,j|0)|0;j=MXa(q)|0;i=g;return j|0}function QXa(b){b=b|0;var d=0,e=0;d=i;e=pe[c[240972>>2]&127](b+1|0)|0;if((e|0)==0){i=d;return e|0}a[e+b|0]=0;i=d;return e|0}function RXa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=i;d=KXa(a)|0;e=KXa(b)|0;f=QXa(e+d|0)|0;Aqb(f|0,a|0,d|0)|0;Aqb(f+d|0,b|0,e|0)|0;i=c;return f|0}function SXa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=uqb(c[a>>2]|0,c[b>>2]|0)|0;i=d;return e|0}function TXa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;b=i;c=(a|0)%100|0;d=(c|0)/10|0;e=(a|0)%10|0;a:do{if((a+999|0)>>>0>1998){f=-1}else{if((((a|0)%1e3|0)+99|0)>>>0>198){f=-1;break}if((e|0)==2){f=-1;break}else if((e|0)==1){if((c+ -50|0)>>>0>9){f=-1;break}}switch(d|0){case 0:{f=8;break a;break};case 3:{f=2;break a;break};case 5:{f=1;break a;break};case 1:{f=4;break a;break};case 4:{f=2;break a;break};case 2:{f=4;break a;break};default:{f=-1;break a}}}}while(0);i=b;return f|0}function UXa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a;e=c[d>>2]|0;if((e|0)!=0){ad(e|0)|0;c[d>>2]=0}e=a+4|0;f=c[e>>2]|0;if((f|0)!=0){Xpb(f);c[e>>2]=0}e=a+8|0;if((c[e>>2]|0)!=0){f=a+12|0;g=0;do{Xpb(c[(c[f>>2]|0)+(g<<4)>>2]|0);Xpb(c[(c[f>>2]|0)+(g<<4)+4>>2]|0);g=g+1|0;}while(g>>>0<(c[e>>2]|0)>>>0)}c[e>>2]=0;if((c[d>>2]|0)!=0){d=a+12|0;Xpb(c[d>>2]|0);c[d>>2]=0}d=a+20|0;e=c[d>>2]|0;if((e|0)!=0){Xpb(e);c[d>>2]=0}d=a+24|0;e=c[d>>2]|0;g=a+40|0;if((e&2147483647|0)!=0){a=e;e=0;while(1){f=c[(c[g>>2]|0)+(e<<2)>>2]|0;if((f|0)==0){h=a}else{Xpb(f);h=c[d>>2]|0}f=e+1|0;if(f>>>0<h<<1>>>0){a=h;e=f}else{break}}}c[d>>2]=0;d=c[g>>2]|0;if((d|0)==0){i=b;return}Xpb(d);c[g>>2]=0;i=b;return}function VXa(b){b=b|0;var c=0,d=0,e=0,f=0,g=0;c=i;d=0;e=0;while(1){f=a[b+d|0]|0;if(f<<24>>24==32){g=e}else{a[b+e|0]=f;g=e+1|0}f=d+1|0;if(f>>>0>(yqb(b|0)|0)>>>0){break}else{d=f;e=g}}i=c;return}



function Sfb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((b|0)==(d|0)){i=e;return b|0}f=a[d]|0;if((f&1)==0){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}d=a[b]|0;if((d&1)==0){j=d;k=10}else{d=c[b>>2]|0;j=d&255;k=(d&-2)+ -1|0}d=(j&1)==0;if(k>>>0<h>>>0){if(d){l=(j&255)>>>1}else{l=c[b+4>>2]|0}jgb(b,k,h-k|0,l,0,l,h,g);i=e;return b|0}if(d){m=b+1|0}else{m=c[b+8>>2]|0}Bqb(m|0,g|0,h|0)|0;a[m+h|0]=0;if((a[b]&1)==0){a[b]=h<<1;i=e;return b|0}else{c[b+4>>2]=h;i=e;return b|0}return 0}function Tfb(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=Ufb(a,b)|0;i=c;return d|0}function Ufb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=yqb(d|0)|0;g=a[b]|0;if((g&1)==0){h=g;j=10}else{g=c[b>>2]|0;h=g&255;j=(g&-2)+ -1|0}g=(h&1)==0;if(j>>>0<f>>>0){if(g){k=(h&255)>>>1}else{k=c[b+4>>2]|0}jgb(b,j,f-j|0,k,0,k,f,d);i=e;return b|0}if(g){l=b+1|0}else{l=c[b+8>>2]|0}Bqb(l|0,d|0,f|0)|0;a[l+f|0]=0;if((a[b]&1)==0){a[b]=f<<1;i=e;return b|0}else{c[b+4>>2]=f;i=e;return b|0}return 0}function Vfb(a,b){a=a|0;b=b|0;c[a+4>>2]=b;i=i;return}function Wfb(a){a=a|0;i=i;return a+1|0}function Xfb(b,c){b=b|0;c=c|0;a[b]=c<<1;i=i;return}function Yfb(b){b=b|0;var d=0,e=0,f=0;d=i;e=a[b]|0;if((e&1)==0){f=(e&255)>>>1;i=d;return f|0}else{f=c[b+4>>2]|0;i=d;return f|0}return 0}function Zfb(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=10;i=d;return e|0}e=(c[b>>2]&-2)+ -1|0;i=d;return e|0}function _fb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=a[b]|0;h=(g&1)==0;if(h){j=(g&255)>>>1}else{j=c[b+4>>2]|0}if(j>>>0<d>>>0){$fb(b,d-j|0,e)|0;i=f;return}if(h){a[b+1+d|0]=0;a[b]=d<<1;i=f;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;i=f;return}}function $fb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if((d|0)==0){i=f;return b|0}g=a[b]|0;if((g&1)==0){h=g;j=10}else{g=c[b>>2]|0;h=g&255;j=(g&-2)+ -1|0}if((h&1)==0){k=(h&255)>>>1}else{k=c[b+4>>2]|0}if((j-k|0)>>>0<d>>>0){kgb(b,j,d-j+k|0,k,k,0,0);l=a[b]|0}else{l=h}if((l&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}Cqb(m+k|0,e|0,d|0)|0;e=k+d|0;if((a[b]&1)==0){a[b]=e<<1}else{c[b+4>>2]=e}a[m+e|0]=0;i=f;return b|0}function agb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a[b]|0;g=(f&1)==0;if(g){h=(f&255)>>>1}else{h=c[b+4>>2]|0}if(h>>>0<d>>>0){$fb(b,d-h|0,0)|0;i=e;return}if(g){a[b+1+d|0]=0;a[b]=d<<1;i=e;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;i=e;return}}function bgb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>4294967279){Dfb(0)}f=a[b]|0;if((f&1)==0){g=f;h=10}else{f=c[b>>2]|0;g=f&255;h=(f&-2)+ -1|0}if((g&1)==0){j=(g&255)>>>1}else{j=c[b+4>>2]|0}f=j>>>0>d>>>0?j:d;if(f>>>0<11){k=10}else{k=(f+16&-16)+ -1|0}if((k|0)==(h|0)){i=e;return}do{if((k|0)==10){l=b+1|0;m=0;n=c[b+8>>2]|0;o=1}else{f=k+1|0;if(k>>>0>h>>>0){p=aqb(f)|0}else{p=aqb(f)|0}if((g&1)==0){l=p;m=1;n=b+1|0;o=0;break}else{l=p;m=1;n=c[b+8>>2]|0;o=1;break}}}while(0);if((g&1)==0){q=(g&255)>>>1}else{q=c[b+4>>2]|0}Aqb(l|0,n|0,q+1|0)|0;if(o){cqb(n)}if(m){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=l;i=e;return}else{a[b]=j<<1;i=e;return}}function cgb(a){a=a|0;var b=0;if(a>>>0<11){b=10}else{b=(a+16&-16)+ -1|0}i=i;return b|0}function dgb(a,b){a=a|0;b=b|0;c[a>>2]=b|1;i=i;return}function egb(a,b){a=a|0;b=b|0;c[a+8>>2]=b;i=i;return}function fgb(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){a[b+1|0]=0;a[b]=0;i=d;return}else{a[c[b+8>>2]|0]=0;c[b+4>>2]=0;i=d;return}}function ggb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a[d]|0;if((f&1)==0){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}d=igb(b,g,h)|0;i=e;return d|0}function hgb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+ -1|0;j=c[b+4>>2]|0}else{h=10;j=(f&255)>>>1}if((j|0)==(h|0)){kgb(b,h,1,h,h,0,0);if((a[b]&1)==0){k=7}else{k=8}}else{if(g){k=8}else{k=7}}if((k|0)==7){a[b]=(j<<1)+2;l=b+1|0;m=j+1|0}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g}a[l+j|0]=d;a[l+m|0]=0;i=e;return}function igb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b]|0;if((g&1)==0){h=10;j=g}else{g=c[b>>2]|0;h=(g&-2)+ -1|0;j=g&255}if((j&1)==0){k=(j&255)>>>1}else{k=c[b+4>>2]|0}if((h-k|0)>>>0<e>>>0){jgb(b,h,e-h+k|0,k,k,0,e,d);i=f;return b|0}if((e|0)==0){i=f;return b|0}if((j&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}Aqb(l+k|0,d|0,e|0)|0;d=k+e|0;if((a[b]&1)==0){a[b]=d<<1}else{c[b+4>>2]=d}a[l+d|0]=0;i=f;return b|0}function jgb(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;if((-18-d|0)>>>0<e>>>0){Dfb(0)}if((a[b]&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}do{if(d>>>0<2147483623){n=e+d|0;o=d<<1;p=n>>>0<o>>>0?o:n;if(p>>>0<11){q=11;break}q=p+16&-16}else{q=-17}}while(0);e=aqb(q)|0;if((g|0)!=0){Aqb(e|0,m|0,g|0)|0}if((j|0)!=0){Aqb(e+g|0,k|0,j|0)|0}k=f-h|0;if((k|0)!=(g|0)){Aqb(e+(j+g)|0,m+(h+g)|0,k-g|0)|0}if((d|0)!=10){cqb(m)}c[b+8>>2]=e;c[b>>2]=q|1;q=k+j|0;c[b+4>>2]=q;a[e+q|0]=0;i=l;return}function kgb(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;if((-17-d|0)>>>0<e>>>0){Dfb(0)}if((a[b]&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}do{if(d>>>0<2147483623){m=e+d|0;n=d<<1;o=m>>>0<n>>>0?n:m;if(o>>>0<11){p=11;break}p=o+16&-16}else{p=-17}}while(0);e=aqb(p)|0;if((g|0)!=0){Aqb(e|0,l|0,g|0)|0}o=f-h|0;if((o|0)!=(g|0)){Aqb(e+(j+g)|0,l+(h+g)|0,o-g|0)|0}if((d|0)==10){q=b;r=q+8|0;s=r;c[s>>2]=e;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}cqb(l);q=b;r=q+8|0;s=r;c[s>>2]=e;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}function lgb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;Ofb(a,b,c,d,0);i=e;return}function mgb(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=b+1|0;i=d;return e|0}else{e=c[b+8>>2]|0;i=d;return e|0}return 0}function ngb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=yqb(d|0)|0;h=a[b]|0;j=(h&1)==0;if(j){k=(h&255)>>>1}else{k=c[b+4>>2]|0}if(k>>>0<e>>>0|(k-e|0)>>>0<g>>>0){l=-1;i=f;return l|0}if((g|0)==0){l=e;i=f;return l|0}if(j){m=b+1|0}else{m=c[b+8>>2]|0}b=m+e|0;j=m+k|0;h=d+g|0;if((j-b|0)<(g|0)){l=-1;i=f;return l|0}n=k+(1-g)|0;g=m+n|0;if((n|0)==(e|0)){l=-1;i=f;return l|0}e=a[d]|0;n=b;a:while(1){if((a[n]|0)==e<<24>>24){b=n;k=d;do{k=k+1|0;if((k|0)==(h|0)){break a}b=b+1|0;}while((a[b]|0)==(a[k]|0))}k=n+1|0;if((k|0)==(g|0)){l=-1;o=18;break}else{n=k}}if((o|0)==18){i=f;return l|0}if((n|0)==(j|0)){l=-1;i=f;return l|0}l=n-m|0;i=f;return l|0}function ogb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)==0;if(g){h=(f&255)>>>1}else{h=c[b+4>>2]|0}f=a[d]|0;j=(f&1)==0;if(j){k=(f&255)>>>1}else{k=c[d+4>>2]|0}if(g){l=b+1|0}else{l=c[b+8>>2]|0}if(j){m=d+1|0}else{m=c[d+8>>2]|0}d=k>>>0<h>>>0;j=tqb(l,m,d?k:h)|0;if((j|0)==0){i=e;return(h>>>0<k>>>0?-1:d&1)|0}else{i=e;return j|0}return 0}function pgb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=yqb(d|0)|0;g=a[b]|0;h=(g&1)==0;if(h){j=(g&255)>>>1}else{j=c[b+4>>2]|0}if((f|0)==-1){Efb(0)}if(h){k=b+1|0}else{k=c[b+8>>2]|0}b=j>>>0>f>>>0;h=tqb(k,d,b?f:j)|0;if((h|0)==0){i=e;return(j>>>0<f>>>0?-1:b&1)|0}else{i=e;return h|0}return 0}function qgb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;if(f>>>0>4294967279){Dfb(0)}if(f>>>0<11){a[b]=e<<1;h=b+1|0;Aqb(h|0,d|0,e|0)|0;j=h;k=j+e|0;l=k;a[l]=0;i=g;return}else{m=f+16&-16;f=aqb(m)|0;c[b+8>>2]=f;c[b>>2]=m|1;c[b+4>>2]=e;h=f;Aqb(h|0,d|0,e|0)|0;j=h;k=j+e|0;l=k;a[l]=0;i=g;return}}function rgb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>1073741807){Dfb(0)}if(e>>>0<2){a[b]=e<<1;g=b+4|0}else{h=e+4&-4;j=aqb(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}xpb(g,d,e)|0;c[g+(e<<2)>>2]=0;i=f;return}function sgb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>1073741807){Dfb(0)}if(d>>>0<2){a[b]=d<<1;g=b+4|0}else{h=d+4&-4;j=aqb(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}zpb(g,e,d)|0;c[g+(d<<2)>>2]=0;i=f;return}function tgb(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){i=d;return}cqb(c[b+8>>2]|0);i=d;return}function ugb(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=vgb(a,b,wpb(b)|0)|0;i=c;return d|0}function vgb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b]|0;if((g&1)==0){h=1;j=g}else{g=c[b>>2]|0;h=(g&-2)+ -1|0;j=g&255}g=(j&1)==0;if(h>>>0<e>>>0){if(g){k=(j&255)>>>1}else{k=c[b+4>>2]|0}ygb(b,h,e-h|0,k,0,k,e,d);i=f;return b|0}if(g){l=b+4|0}else{l=c[b+8>>2]|0}ypb(l,d,e)|0;c[l+(e<<2)>>2]=0;if((a[b]&1)==0){a[b]=e<<1;i=f;return b|0}else{c[b+4>>2]=e;i=f;return b|0}return 0}function wgb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>1073741807){Dfb(0)}f=a[b]|0;if((f&1)==0){g=f;h=1}else{f=c[b>>2]|0;g=f&255;h=(f&-2)+ -1|0}if((g&1)==0){j=(g&255)>>>1}else{j=c[b+4>>2]|0}f=j>>>0>d>>>0?j:d;if(f>>>0<2){k=1}else{k=(f+4&-4)+ -1|0}if((k|0)==(h|0)){i=e;return}do{if((k|0)==1){l=b+4|0;m=0;n=c[b+8>>2]|0;o=1}else{f=(k<<2)+4|0;if(k>>>0>h>>>0){p=aqb(f)|0}else{p=aqb(f)|0}f=p;if((g&1)==0){l=f;m=1;n=b+4|0;o=0;break}else{l=f;m=1;n=c[b+8>>2]|0;o=1;break}}}while(0);if((g&1)==0){q=(g&255)>>>1}else{q=c[b+4>>2]|0}xpb(l,n,q+1|0)|0;if(o){cqb(n)}if(m){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=l;i=e;return}else{a[b]=j<<1;i=e;return}}function xgb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+ -1|0;j=c[b+4>>2]|0}else{h=1;j=(f&255)>>>1}if((j|0)==(h|0)){zgb(b,h,1,h,h,0,0);if((a[b]&1)==0){k=7}else{k=8}}else{if(g){k=8}else{k=7}}if((k|0)==7){a[b]=(j<<1)+2;l=b+4|0;m=j+1|0}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g}c[l+(j<<2)>>2]=d;c[l+(m<<2)>>2]=0;i=e;return}function ygb(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;if((1073741806-d|0)>>>0<e>>>0){Dfb(0)}if((a[b]&1)==0){m=b+4|0}else{m=c[b+8>>2]|0}do{if(d>>>0<536870887){n=e+d|0;o=d<<1;p=n>>>0<o>>>0?o:n;if(p>>>0<2){q=2;break}q=p+4&-4}else{q=1073741807}}while(0);e=aqb(q<<2)|0;p=e;if((g|0)!=0){xpb(p,m,g)|0}if((j|0)!=0){xpb(e+(g<<2)|0,k,j)|0}k=f-h|0;if((k|0)!=(g|0)){xpb(e+(j+g<<2)|0,m+(h+g<<2)|0,k-g|0)|0}if((d|0)!=1){cqb(m)}c[b+8>>2]=p;c[b>>2]=q|1;q=k+j|0;c[b+4>>2]=q;c[e+(q<<2)>>2]=0;i=l;return}function zgb(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;if((1073741807-d|0)>>>0<e>>>0){Dfb(0)}if((a[b]&1)==0){l=b+4|0}else{l=c[b+8>>2]|0}do{if(d>>>0<536870887){m=e+d|0;n=d<<1;o=m>>>0<n>>>0?n:m;if(o>>>0<2){p=2;break}p=o+4&-4}else{p=1073741807}}while(0);e=aqb(p<<2)|0;o=e;if((g|0)!=0){xpb(o,l,g)|0}m=f-h|0;if((m|0)!=(g|0)){xpb(e+(j+g<<2)|0,l+(h+g<<2)|0,m-g|0)|0}if((d|0)==1){q=b;r=q+8|0;s=r;c[s>>2]=o;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}cqb(l);q=b;r=q+8|0;s=r;c[s>>2]=o;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}function Agb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=b;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;g=yqb(d|0)|0;h=a[e]|0;if((h&1)==0){j=(h&255)>>>1}else{j=c[e+4>>2]|0}h=j+g|0;if(h>>>0>4294967279){Dfb(0)}if(h>>>0<11){a[b]=g<<1;k=b+1|0}else{l=h+16&-16;h=aqb(l)|0;c[b+8>>2]=h;c[b>>2]=l|1;c[b+4>>2]=g;k=h}Aqb(k|0,d|0,g|0)|0;a[k+g|0]=0;if((a[e]&1)==0){m=e+1|0;n=igb(b,m,j)|0;i=f;return}else{m=c[e+8>>2]|0;n=igb(b,m,j)|0;i=f;return}}function Bgb(a){a=a|0;i=i;return(c[a+16>>2]&5|0)==0|0}function Cgb(a){a=a|0;i=i;return(c[a+16>>2]&5|0)!=0|0}function Dgb(a,b){a=a|0;b=b|0;var c=0;c=i;Egb(a,b);i=c;return}function Egb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=(c[b+24>>2]|0)==0;if(h){c[b+16>>2]=d|1}else{c[b+16>>2]=d}if(((h&1|d)&c[b+20>>2]|0)==0){i=e;return}e=Hc(16)|0;do{if((a[311744]|0)==0){if((_a(311744)|0)==0){break}c[77934]=312440;ee(67,311736,q|0)|0;Wb(311744)}}while(0);b=e;d=g;c[d>>2]=1;c[d+4>>2]=311736;d=f;h=g;c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];zfb(b,f,311792);c[e>>2]=311760;_d(e|0,311840,63)}function Fgb(a,b){a=a|0;b=b|0;var d=0;d=i;Egb(a,c[a+16>>2]|b);i=d;return}function Ggb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;c[a>>2]=311784;d=c[a+40>>2]|0;e=a+32|0;f=a+36|0;if((d|0)!=0){g=d;do{g=g+ -1|0;Le[c[(c[e>>2]|0)+(g<<2)>>2]&15](0,a,c[(c[f>>2]|0)+(g<<2)>>2]|0);}while((g|0)!=0)}zmb(a+28|0);Xpb(c[e>>2]|0);Xpb(c[f>>2]|0);Xpb(c[a+48>>2]|0);Xpb(c[a+60>>2]|0);i=b;return}function Hgb(a){a=a|0;var b=0;b=i;Ggb(a);cqb(a);i=b;return}function Igb(a){a=a|0;var b=0;b=i;Ggb(a);i=b;return}function Jgb(a){a=a|0;var b=0;b=i;Ggb(a);i=b;return}function Kgb(a){a=a|0;i=i;return c[a+24>>2]|0}function Lgb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=b;e=a+76|0;f=c[e>>2]|0;if(!((f|0)==-1)){g=f&255;i=b;return g|0}ymb(d,a+28|0);a=Bmb(d,314128)|0;f=Ee[c[(c[a>>2]|0)+28>>2]&63](a,32)|0;zmb(d);c[e>>2]=f<<24>>24;g=f;i=b;return g|0}function Mgb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=d;ymb(e,a+28|0);a=Bmb(e,314128)|0;f=Ee[c[(c[a>>2]|0)+28>>2]&63](a,b)|0;zmb(e);i=d;return f|0}function Ngb(a,b){a=a|0;b=b|0;var c=0;c=i;ymb(a,b+28|0);i=c;return}function Ogb(a){a=a|0;c[a>>2]=311384;i=i;return}function Pgb(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;c[a+24>>2]=b;c[a+16>>2]=(b|0)==0;c[a+20>>2]=0;c[a+4>>2]=4098;c[a+12>>2]=0;c[a+8>>2]=6;b=a+28|0;e=a+32|0;a=e+40|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(a|0));xmb(b);i=d;return}function Qgb(a){a=a|0;var b=0;b=i;c[a>>2]=311400;zmb(a+4|0);cqb(a);i=b;return}function Rgb(a){a=a|0;var b=0;b=i;c[a>>2]=311400;zmb(a+4|0);i=b;return}function Sgb(a){a=a|0;var b=0;b=i;c[a>>2]=311400;zmb(a+4|0);i=b;return}function Tgb(a,b){a=a|0;b=b|0;var c=0;c=i;ymb(a,b+4|0);i=c;return}function Ugb(a){a=a|0;var b=0,e=0,f=0,g=0;b=i;e=a+12|0;f=c[e>>2]|0;if((f|0)==(c[a+16>>2]|0)){g=pe[c[(c[a>>2]|0)+40>>2]&127](a)|0;i=b;return g|0}else{c[e>>2]=f+1;g=d[f]|0;i=b;return g|0}return 0}function Vgb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b+24|0;g=c[f>>2]|0;if((g|0)==(c[b+28>>2]|0)){h=Ee[c[(c[b>>2]|0)+52>>2]&63](b,d&255)|0;i=e;return h|0}else{c[f>>2]=g+1;a[g]=d;h=d&255;i=e;return h|0}return 0}function Wgb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=se[c[(c[a>>2]|0)+48>>2]&63](a,b,d)|0;i=e;return f|0}function Xgb(a){a=a|0;var b=0,d=0;b=i;c[a>>2]=311400;xmb(a+4|0);d=a+8|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;i=b;return}function Ygb(a){a=a|0;i=i;return c[a+8>>2]|0}function Zgb(a){a=a|0;i=i;return c[a+12>>2]|0}function _gb(a){a=a|0;i=i;return c[a+16>>2]|0}function $gb(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;c[d>>2]=(c[d>>2]|0)+b;i=i;return}function ahb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a+8>>2]=b;c[a+12>>2]=d;c[a+16>>2]=e;i=i;return}function bhb(a){a=a|0;i=i;return c[a+20>>2]|0}function chb(a){a=a|0;i=i;return c[a+24>>2]|0}function dhb(a){a=a|0;i=i;return c[a+28>>2]|0}function ehb(a,b){a=a|0;b=b|0;var d=0;d=a+24|0;c[d>>2]=(c[d>>2]|0)+b;i=i;return}function fhb(a,b,d){a=a|0;b=b|0;d=d|0;c[a+24>>2]=b;c[a+20>>2]=b;c[a+28>>2]=d;i=i;return}function ghb(a,b){a=a|0;b=b|0;i=i;return}function hhb(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return a|0}function ihb(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;i=i;return}function jhb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;i=i;return}function khb(a){a=a|0;i=i;return 0}function lhb(a){a=a|0;i=i;return 0}function mhb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;if((e|0)<=0){g=0;i=f;return g|0}h=b+12|0;j=b+16|0;k=d;d=0;while(1){l=c[h>>2]|0;if(l>>>0<(c[j>>2]|0)>>>0){c[h>>2]=l+1;m=a[l]|0}else{l=pe[c[(c[b>>2]|0)+40>>2]&127](b)|0;if((l|0)==-1){g=d;n=8;break}m=l&255}a[k]=m;l=d+1|0;if((l|0)<(e|0)){k=k+1|0;d=l}else{g=l;n=8;break}}if((n|0)==8){i=f;return g|0}return 0}function nhb(a){a=a|0;i=i;return-1}function ohb(a){a=a|0;var b=0,e=0,f=0;b=i;if((pe[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){e=-1;i=b;return e|0}f=a+12|0;a=c[f>>2]|0;c[f>>2]=a+1;e=d[a]|0;i=b;return e|0}function phb(a,b){a=a|0;b=b|0;i=i;return-1}function qhb(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((f|0)<=0){h=0;i=g;return h|0}j=b+24|0;k=b+28|0;l=e;e=0;while(1){m=c[j>>2]|0;if(m>>>0<(c[k>>2]|0)>>>0){n=a[l]|0;c[j>>2]=m+1;a[m]=n}else{if((Ee[c[(c[b>>2]|0)+52>>2]&63](b,d[l]|0)|0)==-1){h=e;o=7;break}}n=e+1|0;if((n|0)<(f|0)){l=l+1|0;e=n}else{h=n;o=7;break}}if((o|0)==7){i=g;return h|0}return 0}function rhb(a,b){a=a|0;b=b|0;i=i;return-1}function shb(a){a=a|0;var b=0;b=i;c[a>>2]=311464;zmb(a+4|0);cqb(a);i=b;return}function thb(a){a=a|0;var b=0;b=i;c[a>>2]=311464;zmb(a+4|0);i=b;return}function uhb(a,b){a=a|0;b=b|0;i=i;return}function vhb(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return a|0}function whb(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;i=i;return}function xhb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;i=i;return}function yhb(a){a=a|0;i=i;return 0}function zhb(a){a=a|0;i=i;return 0}function Ahb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+12|0;h=a+16|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){c[g>>2]=k+4;l=c[k>>2]|0}else{k=pe[c[(c[a>>2]|0)+40>>2]&127](a)|0;if((k|0)==-1){f=b;m=8;break}else{l=k}}c[j>>2]=l;k=b+1|0;if((k|0)>=(d|0)){f=k;m=8;break}j=j+4|0;b=k}if((m|0)==8){i=e;return f|0}return 0}function Bhb(a){a=a|0;i=i;return-1}function Chb(a){a=a|0;var b=0,d=0,e=0;b=i;if((pe[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){d=-1;i=b;return d|0}e=a+12|0;a=c[e>>2]|0;c[e>>2]=a+4;d=c[a>>2]|0;i=b;return d|0}function Dhb(a,b){a=a|0;b=b|0;i=i;return-1}function Ehb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+24|0;h=a+28|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){l=c[j>>2]|0;c[g>>2]=k+4;c[k>>2]=l}else{if((Ee[c[(c[a>>2]|0)+52>>2]&63](a,c[j>>2]|0)|0)==-1){f=b;m=8;break}}l=b+1|0;if((l|0)>=(d|0)){f=l;m=8;break}j=j+4|0;b=l}if((m|0)==8){i=e;return f|0}return 0}function Fhb(a,b){a=a|0;b=b|0;i=i;return-1}function Ghb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b>>2]|0;c[a>>2]=f;c[a+(c[f+ -12>>2]|0)>>2]=c[b+4>>2];c[a+4>>2]=0;b=c[(c[a>>2]|0)+ -12>>2]|0;c[a+(b+24)>>2]=d;c[a+(b+16)>>2]=(d|0)==0;c[a+(b+20)>>2]=0;c[a+(b+4)>>2]=4098;c[a+(b+12)>>2]=0;c[a+(b+8)>>2]=6;d=a+(b+28)|0;f=a+(b+32)+0|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));xmb(d);c[a+(b+72)>>2]=0;c[a+(b+76)>>2]=-1;i=e;return}function Hhb(a){a=a|0;var b=0;b=i;Ggb(a+8|0);cqb(a);i=b;return}function Ihb(a){a=a|0;var b=0;b=i;Ggb(a+8|0);i=b;return}function Jhb(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;Ggb(a+(d+8)|0);cqb(a+d|0);i=b;return}function Khb(a){a=a|0;var b=0;b=i;Ggb(a+((c[(c[a>>2]|0)+ -12>>2]|0)+8)|0);i=b;return}function Lhb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;Mhb(a,b,c);i=d;return}function Mhb(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+8|0;h=g;j=d;a[j]=0;d=c[(c[e>>2]|0)+ -12>>2]|0;k=c[e+(d+16)>>2]|0;if((k|0)!=0){Egb(e+d|0,k|4);i=g;return}k=c[e+(d+72)>>2]|0;if((k|0)!=0){Nhb(k)|0}a:do{if(!f){k=c[(c[e>>2]|0)+ -12>>2]|0;if((c[e+(k+4)>>2]&4096|0)==0){break}ymb(h,e+(k+28)|0);k=Bmb(h,314128)|0;zmb(h);d=k+8|0;k=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;while(1){if((k|0)==0){break}if((c[k+12>>2]|0)==(c[k+16>>2]|0)){l=(pe[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1;m=l?0:k;if((m|0)==0){break}else{n=m}}else{n=k}m=n+12|0;l=c[m>>2]|0;o=n+16|0;if((l|0)==(c[o>>2]|0)){p=(pe[c[(c[n>>2]|0)+36>>2]&127](n)|0)&255}else{p=a[l]|0}if(!(p<<24>>24>-1)){q=18;break}if((b[(c[d>>2]|0)+(p<<24>>24<<1)>>1]&8192)==0){q=18;break}l=c[m>>2]|0;if((l|0)==(c[o>>2]|0)){pe[c[(c[n>>2]|0)+40>>2]&127](n)|0;k=n;continue}else{c[m>>2]=l+1;k=n;continue}}do{if((q|0)==18){if((n|0)==0){break}if((c[n+12>>2]|0)!=(c[n+16>>2]|0)){break a}if(!((pe[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1|(n|0)==0)){break a}}}while(0);k=c[(c[e>>2]|0)+ -12>>2]|0;Egb(e+k|0,c[e+(k+16)>>2]|6)}}while(0);a[j]=(c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+16)>>2]|0)==0|0;i=g;return}function Nhb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+8|0;e=d;f=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(f+24)>>2]|0)==0){i=d;return b|0}g=e;a[g]=0;c[e+4>>2]=b;do{if((c[b+(f+16)>>2]|0)==0){h=c[b+(f+72)>>2]|0;if((h|0)==0){j=f}else{Nhb(h)|0;j=c[(c[b>>2]|0)+ -12>>2]|0}a[g]=1;h=c[b+(j+24)>>2]|0;if(!((pe[c[(c[h>>2]|0)+24>>2]&127](h)|0)==-1)){break}h=c[(c[b>>2]|0)+ -12>>2]|0;Egb(b+h|0,c[b+(h+16)>>2]|1)}}while(0);aib(e);i=d;return b|0}function Ohb(b){b=b|0;i=i;return(a[b]|0)!=0|0}function Phb(a){a=a|0;var b=0;b=a+16|0;c[b>>2]=c[b>>2]|1;if((c[a+20>>2]&1|0)==0){i=i;return}else{Ib()}}function Qhb(a){a=a|0;var b=0;b=i;Ggb(a+8|0);cqb(a);i=b;return}function Rhb(a){a=a|0;var b=0;b=i;Ggb(a+8|0);i=b;return}function Shb(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;Ggb(a+(d+8)|0);cqb(a+d|0);i=b;return}function Thb(a){a=a|0;var b=0;b=i;Ggb(a+((c[(c[a>>2]|0)+ -12>>2]|0)+8)|0);i=b;return}function Uhb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+8|0;e=d;f=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(f+24)>>2]|0)==0){i=d;return b|0}g=e;a[g]=0;c[e+4>>2]=b;do{if((c[b+(f+16)>>2]|0)==0){h=c[b+(f+72)>>2]|0;if((h|0)==0){j=f}else{Uhb(h)|0;j=c[(c[b>>2]|0)+ -12>>2]|0}a[g]=1;h=c[b+(j+24)>>2]|0;if(!((pe[c[(c[h>>2]|0)+24>>2]&127](h)|0)==-1)){break}h=c[(c[b>>2]|0)+ -12>>2]|0;Egb(b+h|0,c[b+(h+16)>>2]|1)}}while(0);mib(e);i=d;return b|0}function Vhb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b>>2]|0;c[a>>2]=f;c[a+(c[f+ -12>>2]|0)>>2]=c[b+4>>2];b=c[(c[a>>2]|0)+ -12>>2]|0;c[a+(b+24)>>2]=d;c[a+(b+16)>>2]=(d|0)==0;c[a+(b+20)>>2]=0;c[a+(b+4)>>2]=4098;c[a+(b+12)>>2]=0;c[a+(b+8)>>2]=6;d=a+(b+28)|0;f=a+(b+32)+0|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));xmb(d);c[a+(b+72)>>2]=0;c[a+(b+76)>>2]=-1;i=e;return}function Whb(a){a=a|0;var b=0;b=i;Ggb(a+4|0);cqb(a);i=b;return}function Xhb(a){a=a|0;var b=0;b=i;Ggb(a+4|0);i=b;return}function Yhb(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;Ggb(a+(d+4)|0);cqb(a+d|0);i=b;return}function Zhb(a){a=a|0;var b=0;b=i;Ggb(a+((c[(c[a>>2]|0)+ -12>>2]|0)+4)|0);i=b;return}function _hb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=b;a[f]=0;c[b+4>>2]=d;b=c[(c[d>>2]|0)+ -12>>2]|0;if((c[d+(b+16)>>2]|0)!=0){i=e;return}g=c[d+(b+72)>>2]|0;if((g|0)!=0){Nhb(g)|0}a[f]=1;i=e;return}function $hb(a){a=a|0;var b=0;b=i;aib(a);i=b;return}function aib(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[d>>2]|0;e=c[(c[a>>2]|0)+ -12>>2]|0;if((c[a+(e+24)>>2]|0)==0){i=b;return}if((c[a+(e+16)>>2]|0)!=0){i=b;return}if((c[a+(e+4)>>2]&8192|0)==0){i=b;return}if(eb()|0){i=b;return}e=c[d>>2]|0;a=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(!((pe[c[(c[a>>2]|0)+24>>2]&127](a)|0)==-1)){i=b;return}a=c[d>>2]|0;d=c[(c[a>>2]|0)+ -12>>2]|0;Egb(a+d|0,c[a+(d+16)>>2]|1);i=b;return}function bib(b){b=b|0;i=i;return(a[b]|0)!=0|0}function cib(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=pe[b&127](a)|0;i=c;return d|0}function dib(b,d){b=b|0;d=+d;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+48|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;m=j;a[m]=0;c[j+4>>2]=b;n=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(n+16)>>2]|0)!=0){aib(j);i=e;return b|0}o=c[b+(n+72)>>2]|0;if((o|0)==0){p=n}else{Nhb(o)|0;p=c[(c[b>>2]|0)+ -12>>2]|0}a[m]=1;ymb(k,b+(p+28)|0);p=Bmb(k,312848)|0;m=p;zmb(k);k=c[(c[b>>2]|0)+ -12>>2]|0;o=c[b+(k+24)>>2]|0;n=b+(k+76)|0;q=c[n>>2]|0;if((q|0)==-1){ymb(h,b+(k+28)|0);r=Bmb(h,314128)|0;s=Ee[c[(c[r>>2]|0)+28>>2]&63](r,32)|0;zmb(h);c[n>>2]=s<<24>>24;t=s}else{t=q&255}q=b+k|0;k=c[(c[p>>2]|0)+32>>2]|0;c[g>>2]=o;o=f;p=g;c[o+0>>2]=c[p+0>>2];ve[k&7](l,m,f,q,t,d);if((c[l>>2]|0)!=0){aib(j);i=e;return b|0}l=c[(c[b>>2]|0)+ -12>>2]|0;Egb(b+l|0,c[b+(l+16)>>2]|5);aib(j);i=e;return b|0}function eib(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+8|0;f=e;g=f;a[g]=0;c[f+4>>2]=b;h=c[b>>2]|0;j=c[h+ -12>>2]|0;if((c[b+(j+16)>>2]|0)!=0){aib(f);i=e;return b|0}k=c[b+(j+72)>>2]|0;if((k|0)==0){l=h;m=j}else{Nhb(k)|0;k=c[b>>2]|0;l=k;m=c[k+ -12>>2]|0}a[g]=1;g=c[b+(m+24)>>2]|0;m=g;do{if((g|0)==0){n=l}else{k=g+24|0;j=c[k>>2]|0;if((j|0)!=(c[g+28>>2]|0)){c[k>>2]=j+1;a[j]=d;aib(f);i=e;return b|0}if((Ee[c[(c[g>>2]|0)+52>>2]&63](m,d&255)|0)==-1){n=c[b>>2]|0;break}else{aib(f);i=e;return b|0}}}while(0);d=c[n+ -12>>2]|0;Egb(b+d|0,c[b+(d+16)>>2]|1);aib(f);i=e;return b|0}function fib(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=g;a[h]=0;c[g+4>>2]=b;j=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(j+16)>>2]|0)!=0){aib(g);i=f;return b|0}k=c[b+(j+72)>>2]|0;if((k|0)!=0){Nhb(k)|0}a[h]=1;if((e|0)==0){aib(g);i=f;return b|0}h=c[b+((c[(c[b>>2]|0)+ -12>>2]|0)+24)>>2]|0;if((se[c[(c[h>>2]|0)+48>>2]&63](h,d,e)|0)==(e|0)){aib(g);i=f;return b|0}e=c[(c[b>>2]|0)+ -12>>2]|0;Egb(b+e|0,c[b+(e+16)>>2]|1);aib(g);i=f;return b|0}function gib(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(e+16)>>2]&5|0)==0){f=c[b+(e+24)>>2]|0;ye[c[(c[f>>2]|0)+16>>2]&31](a,f,0,0,1,16);i=d;return}else{f=a;c[f>>2]=0;c[f+4>>2]=0;f=a+8|0;c[f>>2]=-1;c[f+4>>2]=-1;i=d;return}}function hib(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+56|0;f=e;g=e+16|0;h=e+32|0;j=e+40|0;k=h;a[k]=0;c[h+4>>2]=b;l=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(l+16)>>2]|0)!=0){aib(h);i=e;return b|0}m=c[b+(l+72)>>2]|0;if((m|0)==0){n=l}else{Nhb(m)|0;n=c[(c[b>>2]|0)+ -12>>2]|0}a[k]=1;k=c[b+(n+24)>>2]|0;n=k;m=d;d=g;l=c[(c[k>>2]|0)+20>>2]|0;c[d+0>>2]=c[m+0>>2];c[d+4>>2]=c[m+4>>2];c[d+8>>2]=c[m+8>>2];c[d+12>>2]=c[m+12>>2];m=f;d=g;c[m+0>>2]=c[d+0>>2];c[m+4>>2]=c[d+4>>2];c[m+8>>2]=c[d+8>>2];c[m+12>>2]=c[d+12>>2];Pe[l&127](j,n,f,16);f=j+8|0;if(!((c[f>>2]|0)==-1&(c[f+4>>2]|0)==-1)){aib(h);i=e;return b|0}f=c[(c[b>>2]|0)+ -12>>2]|0;Egb(b+f|0,c[b+(f+16)>>2]|4);aib(h);i=e;return b|0}function iib(a){a=a|0;var b=0;b=i;Ggb(a+4|0);cqb(a);i=b;return}function jib(a){a=a|0;var b=0;b=i;Ggb(a+4|0);i=b;return}function kib(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;Ggb(a+(d+4)|0);cqb(a+d|0);i=b;return}function lib(a){a=a|0;var b=0;b=i;Ggb(a+((c[(c[a>>2]|0)+ -12>>2]|0)+4)|0);i=b;return}function mib(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[d>>2]|0;e=c[(c[a>>2]|0)+ -12>>2]|0;if((c[a+(e+24)>>2]|0)==0){i=b;return}if((c[a+(e+16)>>2]|0)!=0){i=b;return}if((c[a+(e+4)>>2]&8192|0)==0){i=b;return}if(eb()|0){i=b;return}e=c[d>>2]|0;a=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(!((pe[c[(c[a>>2]|0)+24>>2]&127](a)|0)==-1)){i=b;return}a=c[d>>2]|0;d=c[(c[a>>2]|0)+ -12>>2]|0;Egb(a+d|0,c[a+(d+16)>>2]|1);i=b;return}function nib(a){a=a|0;i=i;return 311680}function oib(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;if((c|0)==1){Jfb(a,311696,35);i=d;return}else{xfb(a,b,c);i=d;return}}function pib(a){a=a|0;i=i;return}function qib(a){a=a|0;var b=0;b=i;Bfb(a);cqb(a);i=b;return}function rib(a){a=a|0;var b=0;b=i;Bfb(a);i=b;return}function sib(a){a=a|0;var b=0;b=i;Ggb(a);cqb(a);i=b;return}function tib(a){a=a|0;var b=0;b=i;cqb(a);i=b;return}function uib(a){a=a|0;var b=0;b=i;cqb(a);i=b;return}function vib(a){a=a|0;i=i;return}function wib(a){a=a|0;i=i;return}function xib(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;a:do{if((e|0)==(f|0)){g=c;h=6}else{j=e;k=c;while(1){if((k|0)==(d|0)){l=-1;break a}m=a[k]|0;n=a[j]|0;if(m<<24>>24<n<<24>>24){l=-1;break a}if(n<<24>>24<m<<24>>24){l=1;break a}m=k+1|0;n=j+1|0;if((n|0)==(f|0)){g=m;h=6;break}else{j=n;k=m}}}}while(0);if((h|0)==6){l=(g|0)!=(d|0)|0}i=b;return l|0}function yib(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;g=e;h=f-g|0;if(h>>>0>4294967279){Dfb(b)}if(h>>>0<11){a[b]=h<<1;j=b+1|0}else{k=h+16&-16;l=aqb(k)|0;c[b+8>>2]=l;c[b>>2]=k|1;c[b+4>>2]=h;j=l}if((e|0)==(f|0)){m=j;a[m]=0;i=d;return}else{n=e;o=j}while(1){a[o]=a[n]|0;e=n+1|0;if((e|0)==(f|0)){break}else{o=o+1|0;n=e}}m=j+(f+(0-g))|0;a[m]=0;i=d;return}function zib(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;if((c|0)==(d|0)){e=0;i=b;return e|0}else{f=0;g=c}while(1){c=(a[g]|0)+(f<<4)|0;h=c&-268435456;j=(h>>>24|h)^c;c=g+1|0;if((c|0)==(d|0)){e=j;break}else{g=c;f=j}}i=b;return e|0}function Aib(a){a=a|0;var b=0;b=i;cqb(a);i=b;return}function Bib(a){a=a|0;i=i;return}function Cib(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;a=i;a:do{if((e|0)==(f|0)){g=b;h=6}else{j=e;k=b;while(1){if((k|0)==(d|0)){l=-1;break a}m=c[k>>2]|0;n=c[j>>2]|0;if((m|0)<(n|0)){l=-1;break a}if((n|0)<(m|0)){l=1;break a}m=k+4|0;n=j+4|0;if((n|0)==(f|0)){g=m;h=6;break}else{j=n;k=m}}}}while(0);if((h|0)==6){l=(g|0)!=(d|0)|0}i=a;return l|0}function Dib(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;d=i;g=e;h=f-g|0;j=h>>2;if(j>>>0>1073741807){Dfb(b)}if(j>>>0<2){a[b]=h>>>1;k=b+4|0}else{h=j+4&-4;l=aqb(h<<2)|0;c[b+8>>2]=l;c[b>>2]=h|1;c[b+4>>2]=j;k=l}if((e|0)==(f|0)){m=k;c[m>>2]=0;i=d;return}l=f+ -4+(0-g)|0;g=e;e=k;while(1){c[e>>2]=c[g>>2];j=g+4|0;if((j|0)==(f|0)){break}else{e=e+4|0;g=j}}m=k+((l>>>2)+1<<2)|0;c[m>>2]=0;i=d;return}function Eib(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;a=i;if((b|0)==(d|0)){e=0;i=a;return e|0}else{f=0;g=b}while(1){b=(c[g>>2]|0)+(f<<4)|0;h=b&-268435456;j=(h>>>24|h)^b;b=g+4|0;if((b|0)==(d|0)){e=j;break}else{g=b;f=j}}i=a;return e|0}function Fib(a){a=a|0;var b=0;b=i;cqb(a);i=b;return}function Gib(a){a=a|0;i=i;return}function Hib(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+136|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=k+40|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+88|0;v=k+96|0;w=k+104|0;x=k+128|0;if((c[g+4>>2]&1|0)==0){c[q>>2]=-1;y=c[(c[d>>2]|0)+16>>2]|0;z=e;c[s>>2]=c[z>>2];c[t>>2]=c[f>>2];A=n;B=s;c[A+0>>2]=c[B+0>>2];B=m;A=t;c[B+0>>2]=c[A+0>>2];Be[y&63](r,d,n,m,g,h,q);m=c[r>>2]|0;c[z>>2]=m;z=c[q>>2]|0;if((z|0)==0){a[j]=0}else if((z|0)==1){a[j]=1}else{a[j]=1;c[h>>2]=4}c[b>>2]=m;i=k;return}Ngb(u,g);m=u;u=c[m>>2]|0;if(!((c[78532]|0)==-1)){c[p>>2]=314128;c[p+4>>2]=1431;c[p+8>>2]=0;Cfb(314128,p,1432)}p=(c[314132>>2]|0)+ -1|0;z=c[u+8>>2]|0;if(!((c[u+12>>2]|0)-z>>2>>>0>p>>>0)){C=Hc(4)|0;D=C;Bpb(D);E=329688;F=128;_d(C|0,E|0,F|0)}u=c[z+(p<<2)>>2]|0;if((u|0)==0){C=Hc(4)|0;D=C;Bpb(D);E=329688;F=128;_d(C|0,E|0,F|0)}F=u;hfb(c[m>>2]|0)|0;Ngb(v,g);g=v;v=c[g>>2]|0;if(!((c[78568]|0)==-1)){c[o>>2]=314272;c[o+4>>2]=1431;c[o+8>>2]=0;Cfb(314272,o,1432)}o=(c[314276>>2]|0)+ -1|0;m=c[v+8>>2]|0;if(!((c[v+12>>2]|0)-m>>2>>>0>o>>>0)){G=Hc(4)|0;H=G;Bpb(H);I=329688;J=128;_d(G|0,I|0,J|0)}v=c[m+(o<<2)>>2]|0;if((v|0)==0){G=Hc(4)|0;H=G;Bpb(H);I=329688;J=128;_d(G|0,I|0,J|0)}J=v;hfb(c[g>>2]|0)|0;g=w;ne[c[(c[v>>2]|0)+24>>2]&255](g,J);ne[c[(c[v>>2]|0)+28>>2]&255](w+12|0,J);c[x>>2]=c[f>>2];f=w+24|0;J=l;v=x;c[J+0>>2]=c[v+0>>2];v=Iib(e,l,g,f,F,h,1)|0;a[j]=(v|0)==(g|0)|0;c[b>>2]=c[e>>2];Rfb(w+12|0);Rfb(w);i=k;return}function Iib(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;k=i;i=i+104|0;l=(f-e|0)/12|0;m=k;do{if(l>>>0>100){n=Wpb(l)|0;if((n|0)!=0){o=n;p=n;break}hqb()}else{o=0;p=m}}while(0);m=(e|0)==(f|0);if(m){q=0;r=l}else{n=e;s=0;t=l;l=p;while(1){u=a[n]|0;if((u&1)==0){v=(u&255)>>>1}else{v=c[n+4>>2]|0}if((v|0)==0){a[l]=2;w=s+1|0;x=t+ -1|0}else{a[l]=1;w=s;x=t}u=n+12|0;if((u|0)==(f|0)){q=w;r=x;break}else{n=u;s=w;t=x;l=l+1|0}}}l=b;b=d;d=0;x=q;q=r;a:while(1){r=c[l>>2]|0;do{if((r|0)==0){y=0}else{if((c[r+12>>2]|0)!=(c[r+16>>2]|0)){y=r;break}if((pe[c[(c[r>>2]|0)+36>>2]&127](r)|0)==-1){c[l>>2]=0;y=0;break}else{y=c[l>>2]|0;break}}}while(0);r=(y|0)==0;t=c[b>>2]|0;do{if((t|0)==0){z=0}else{if((c[t+12>>2]|0)!=(c[t+16>>2]|0)){z=t;break}if(!((pe[c[(c[t>>2]|0)+36>>2]&127](t)|0)==-1)){z=t;break}c[b>>2]=0;z=0}}while(0);A=(z|0)==0;B=c[l>>2]|0;if(!((r^A)&(q|0)!=0)){break}t=c[B+12>>2]|0;if((t|0)==(c[B+16>>2]|0)){C=(pe[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{C=a[t]|0}if(j){D=C}else{D=Ee[c[(c[g>>2]|0)+12>>2]&63](g,C)|0}t=d+1|0;if(m){d=t;q=q;x=x;continue}b:do{if(j){w=0;s=e;n=x;v=q;u=p;while(1){do{if((a[u]|0)==1){E=a[s]|0;F=(E&1)==0;if(F){G=s+1|0}else{G=c[s+8>>2]|0}if(!(D<<24>>24==(a[G+d|0]|0))){a[u]=0;H=w;I=n;J=v+ -1|0;break}if(F){K=(E&255)>>>1}else{K=c[s+4>>2]|0}if((K|0)!=(t|0)){H=1;I=n;J=v;break}a[u]=2;H=1;I=n+1|0;J=v+ -1|0}else{H=w;I=n;J=v}}while(0);E=s+12|0;if((E|0)==(f|0)){L=H;M=I;N=J;break b}w=H;s=E;n=I;v=J;u=u+1|0}}else{u=0;v=e;n=x;s=q;w=p;while(1){do{if((a[w]|0)==1){if((a[v]&1)==0){O=v+1|0}else{O=c[v+8>>2]|0}if(!(D<<24>>24==(Ee[c[(c[g>>2]|0)+12>>2]&63](g,a[O+d|0]|0)|0)<<24>>24)){a[w]=0;P=u;Q=n;R=s+ -1|0;break}E=a[v]|0;if((E&1)==0){S=(E&255)>>>1}else{S=c[v+4>>2]|0}if((S|0)!=(t|0)){P=1;Q=n;R=s;break}a[w]=2;P=1;Q=n+1|0;R=s+ -1|0}else{P=u;Q=n;R=s}}while(0);E=v+12|0;if((E|0)==(f|0)){L=P;M=Q;N=R;break b}u=P;v=E;n=Q;s=R;w=w+1|0}}}while(0);if(!L){d=t;x=M;q=N;continue}r=c[l>>2]|0;w=r+12|0;s=c[w>>2]|0;if((s|0)==(c[r+16>>2]|0)){pe[c[(c[r>>2]|0)+40>>2]&127](r)|0}else{c[w>>2]=s+1}if((N+M|0)>>>0<2){d=t;x=M;q=N;continue}else{T=e;U=M;V=p}while(1){do{if((a[V]|0)==2){s=a[T]|0;if((s&1)==0){W=(s&255)>>>1}else{W=c[T+4>>2]|0}if((W|0)==(t|0)){X=U;break}a[V]=0;X=U+ -1|0}else{X=U}}while(0);s=T+12|0;if((s|0)==(f|0)){d=t;x=X;q=N;continue a}else{T=s;U=X;V=V+1|0}}}do{if((B|0)==0){Y=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){Y=B;break}if((pe[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[l>>2]=0;Y=0;break}else{Y=c[l>>2]|0;break}}}while(0);l=(Y|0)==0;do{if(A){Z=78}else{if((c[z+12>>2]|0)!=(c[z+16>>2]|0)){if(l){break}else{Z=80;break}}if((pe[c[(c[z>>2]|0)+36>>2]&127](z)|0)==-1){c[b>>2]=0;Z=78;break}else{if(l){break}else{Z=80;break}}}}while(0);if((Z|0)==78){if(l){Z=80}}if((Z|0)==80){c[h>>2]=c[h>>2]|2}c:do{if(m){Z=85}else{if((a[p]|0)==2){_=e;break}else{$=e;aa=p}while(1){l=$+12|0;b=aa+1|0;if((l|0)==(f|0)){Z=85;break c}if((a[b]|0)==2){_=l;break}else{aa=b;$=l}}}}while(0);if((Z|0)==85){c[h>>2]=c[h>>2]|4;_=f}if((o|0)==0){i=k;return _|0}Xpb(o);i=k;return _|0}function Jib(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Kib(a,0,k,j,f,g,h);i=b;return}function Kib(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==0){t=0}else if((s|0)==64){t=8}else{t=10}s=k;Ajb(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;_fb(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((pe[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((pe[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}_fb(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}_fb(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(pe[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((ajb(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){pe[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=wob(F,c[o>>2]|0,h,t)|0;Nlb(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((pe[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;Rfb(n);Rfb(m);i=d;return}if((pe[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;Rfb(n);Rfb(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;Rfb(n);Rfb(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;Rfb(n);Rfb(m);i=d;return}function Lib(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Mib(a,0,k,j,f,g,h);i=b;return}function Mib(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==0){t=0}else if((s|0)==8){t=16}else{t=10}s=k;Ajb(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;_fb(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((pe[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((pe[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;K=(B&255)>>>1}else{B=c[x>>2]|0;I=B;K=B}_fb(n,K<<1,0);if((a[n]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}_fb(n,L,0);if((a[n]&1)==0){M=u}else{M=c[v>>2]|0}c[o>>2]=M+I;N=M}else{N=z}B=A+12|0;G=c[B>>2]|0;O=A+16|0;if((G|0)==(c[O>>2]|0)){P=(pe[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{P=a[G]|0}if((ajb(P,t,N,o,r,y,m,g,q,s)|0)!=0){E=D;F=N;break}G=c[B>>2]|0;if((G|0)==(c[O>>2]|0)){pe[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=N;continue}else{c[B>>2]=G+1;l=A;z=N;continue}}N=a[m]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[m+4>>2]|0}do{if((Q|0)!=0){N=c[q>>2]|0;if((N-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=N+4;c[N>>2]=z}}while(0);r=vob(F,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;Nlb(m,g,c[q>>2]|0,h);do{if((A|0)==0){R=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){R=A;break}if(!((pe[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){R=A;break}c[k>>2]=0;R=0}}while(0);k=(R|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}S=b;T=S;c[T>>2]=R;Rfb(n);Rfb(m);i=d;return}if((pe[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}S=b;T=S;c[T>>2]=R;Rfb(n);Rfb(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}S=b;T=S;c[T>>2]=R;Rfb(n);Rfb(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;S=b;T=S;c[T>>2]=R;Rfb(n);Rfb(m);i=d;return}function Nib(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Oib(a,0,k,j,f,g,h);i=b;return}function Oib(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+256|0;l=e;m=e+32|0;n=e+40|0;o=e+56|0;p=e+72|0;q=e+80|0;r=e+240|0;s=e+248|0;t=c[h+4>>2]&74;if((t|0)==8){u=16}else if((t|0)==64){u=8}else if((t|0)==0){u=0}else{u=10}t=l;Ajb(n,h,t,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;_fb(o,10,0);if((a[o]&1)==0){h=o+1|0;v=h;w=o+8|0;x=h}else{h=o+8|0;v=o+1|0;w=h;x=c[h>>2]|0}c[p>>2]=x;h=q;c[r>>2]=h;c[s>>2]=0;l=f;f=g;g=o;y=o+4|0;z=a[m]|0;m=c[l>>2]|0;A=x;a:while(1){do{if((m|0)==0){B=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){B=m;break}if(!((pe[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){B=m;break}c[l>>2]=0;B=0}}while(0);x=(B|0)==0;C=c[f>>2]|0;do{if((C|0)==0){D=18}else{if((c[C+12>>2]|0)!=(c[C+16>>2]|0)){if(x){E=C;break}else{F=C;G=A;break a}}if((pe[c[(c[C>>2]|0)+36>>2]&127](C)|0)==-1){c[f>>2]=0;D=18;break}else{if(x){E=C;break}else{F=C;G=A;break a}}}}while(0);if((D|0)==18){D=0;if(x){F=0;G=A;break}else{E=0}}C=a[o]|0;H=(C&1)==0;if(H){I=(C&255)>>>1}else{I=c[y>>2]|0}if(((c[p>>2]|0)-A|0)==(I|0)){if(H){J=(C&255)>>>1;K=(C&255)>>>1}else{C=c[y>>2]|0;J=C;K=C}_fb(o,K<<1,0);if((a[o]&1)==0){L=10}else{L=(c[g>>2]&-2)+ -1|0}_fb(o,L,0);if((a[o]&1)==0){M=v}else{M=c[w>>2]|0}c[p>>2]=M+J;N=M}else{N=A}C=B+12|0;H=c[C>>2]|0;O=B+16|0;if((H|0)==(c[O>>2]|0)){P=(pe[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{P=a[H]|0}if((ajb(P,u,N,p,s,z,n,h,r,t)|0)!=0){F=E;G=N;break}H=c[C>>2]|0;if((H|0)==(c[O>>2]|0)){pe[c[(c[B>>2]|0)+40>>2]&127](B)|0;m=B;A=N;continue}else{c[C>>2]=H+1;m=B;A=N;continue}}N=a[n]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[n+4>>2]|0}do{if((Q|0)!=0){N=c[r>>2]|0;if((N-q|0)>=160){break}A=c[s>>2]|0;c[r>>2]=N+4;c[N>>2]=A}}while(0);b[k>>1]=uob(G,c[p>>2]|0,j,u)|0;Nlb(n,h,c[r>>2]|0,j);do{if((B|0)==0){R=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){R=B;break}if(!((pe[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1)){R=B;break}c[l>>2]=0;R=0}}while(0);l=(R|0)==0;do{if((F|0)==0){D=54}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){if(!l){break}S=d;T=S;c[T>>2]=R;Rfb(o);Rfb(n);i=e;return}if((pe[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1){c[f>>2]=0;D=54;break}if(!(l^(F|0)==0)){break}S=d;T=S;c[T>>2]=R;Rfb(o);Rfb(n);i=e;return}}while(0);do{if((D|0)==54){if(l){break}S=d;T=S;c[T>>2]=R;Rfb(o);Rfb(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;S=d;T=S;c[T>>2]=R;Rfb(o);Rfb(n);i=e;return}function Pib(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Qib(a,0,k,j,f,g,h);i=b;return}function Qib(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==64){t=8}else if((s|0)==8){t=16}else{t=10}s=k;Ajb(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;_fb(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((pe[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((pe[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}_fb(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}_fb(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(pe[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((ajb(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){pe[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=tob(F,c[o>>2]|0,h,t)|0;Nlb(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((pe[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;Rfb(n);Rfb(m);i=d;return}if((pe[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;Rfb(n);Rfb(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;Rfb(n);Rfb(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;Rfb(n);Rfb(m);i=d;return}function Rib(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Sib(a,0,k,j,f,g,h);i=b;return}function Sib(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==64){t=8}else if((s|0)==0){t=0}else{t=10}s=k;Ajb(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;_fb(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((pe[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((pe[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}_fb(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}_fb(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(pe[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((ajb(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){pe[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=sob(F,c[o>>2]|0,h,t)|0;Nlb(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((pe[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;Rfb(n);Rfb(m);i=d;return}if((pe[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;Rfb(n);Rfb(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;Rfb(n);Rfb(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;Rfb(n);Rfb(m);i=d;return}function Tib(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Uib(a,0,k,j,f,g,h);i=b;return}function Uib(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==8){t=16}else if((s|0)==0){t=0}else{t=10}s=k;Ajb(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;_fb(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((pe[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((pe[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;K=(B&255)>>>1}else{B=c[x>>2]|0;I=B;K=B}_fb(n,K<<1,0);if((a[n]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}_fb(n,L,0);if((a[n]&1)==0){M=u}else{M=c[v>>2]|0}c[o>>2]=M+I;N=M}else{N=z}B=A+12|0;G=c[B>>2]|0;O=A+16|0;if((G|0)==(c[O>>2]|0)){P=(pe[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{P=a[G]|0}if((ajb(P,t,N,o,r,y,m,g,q,s)|0)!=0){E=D;F=N;break}G=c[B>>2]|0;if((G|0)==(c[O>>2]|0)){pe[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=N;continue}else{c[B>>2]=G+1;l=A;z=N;continue}}N=a[m]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[m+4>>2]|0}do{if((Q|0)!=0){N=c[q>>2]|0;if((N-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=N+4;c[N>>2]=z}}while(0);r=rob(F,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;Nlb(m,g,c[q>>2]|0,h);do{if((A|0)==0){R=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){R=A;break}if(!((pe[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){R=A;break}c[k>>2]=0;R=0}}while(0);k=(R|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}S=b;T=S;c[T>>2]=R;Rfb(n);Rfb(m);i=d;return}if((pe[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}S=b;T=S;c[T>>2]=R;Rfb(n);Rfb(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}S=b;T=S;c[T>>2]=R;Rfb(n);Rfb(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;S=b;T=S;c[T>>2]=R;Rfb(n);Rfb(m);i=d;return}function Vib(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Wib(a,0,k,j,f,g,h);i=b;return}function Wib(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;Bjb(n,h,v,l,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;_fb(o,10,0);if((a[o]&1)==0){h=o+1|0;w=h;x=o+8|0;y=h}else{h=o+8|0;w=o+1|0;x=h;y=c[h>>2]|0}c[p>>2]=y;h=q;c[r>>2]=h;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((pe[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((pe[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}_fb(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}_fb(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(pe[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((Cjb(R,t,u,P,p,B,l,n,h,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){pe[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);g[k>>2]=+qob(I,c[p>>2]|0,j);Nlb(n,h,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((pe[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;Rfb(o);Rfb(n);i=d;return}if((pe[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;Rfb(o);Rfb(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;Rfb(o);Rfb(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;Rfb(o);Rfb(n);i=d;return}function Xib(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Yib(a,0,k,j,f,g,h);i=b;return}function Yib(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;Bjb(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;_fb(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((pe[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((pe[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}_fb(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}_fb(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(pe[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((Cjb(R,t,u,P,p,B,l,n,g,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){pe[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);h[k>>3]=+pob(I,c[p>>2]|0,j);Nlb(n,g,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((pe[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;Rfb(o);Rfb(n);i=d;return}if((pe[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;Rfb(o);Rfb(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;Rfb(o);Rfb(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;Rfb(o);Rfb(n);i=d;return}function Zib(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];_ib(a,0,k,j,f,g,h);i=b;return}function _ib(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;Bjb(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;_fb(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((pe[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((pe[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}_fb(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}_fb(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(pe[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((Cjb(R,t,u,P,p,B,l,n,g,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){pe[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);h[k>>3]=+oob(I,c[p>>2]|0,j);Nlb(n,g,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((pe[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;Rfb(o);Rfb(n);i=d;return}if((pe[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;Rfb(o);Rfb(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;Rfb(o);Rfb(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;Rfb(o);Rfb(n);i=d;return}function $ib(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;d=i;i=i+8|0;k=d;l=i;i=i+16|0;m=i;i=i+32|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+160|0;s=i;i=i+8|0;t=i;i=i+8|0;u=n;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Ngb(o,g);g=o;o=c[g>>2]|0;if(!((c[78532]|0)==-1)){c[l>>2]=314128;c[l+4>>2]=1431;c[l+8>>2]=0;Cfb(314128,l,1432)}l=(c[314132>>2]|0)+ -1|0;u=c[o+8>>2]|0;if(!((c[o+12>>2]|0)-u>>2>>>0>l>>>0)){v=Hc(4)|0;w=v;Bpb(w);x=329688;y=128;_d(v|0,x|0,y|0)}o=c[u+(l<<2)>>2]|0;if((o|0)==0){v=Hc(4)|0;w=v;Bpb(w);x=329688;y=128;_d(v|0,x|0,y|0)}y=m;Oe[c[(c[o>>2]|0)+32>>2]&63](o,312672,312698|0,y)|0;hfb(c[g>>2]|0)|0;g=p;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;_fb(p,10,0);if((a[p]&1)==0){g=p+1|0;z=g;A=p+8|0;B=g}else{g=p+8|0;z=p+1|0;A=g;B=c[g>>2]|0}c[q>>2]=B;g=r;c[s>>2]=g;c[t>>2]=0;r=e;e=f;f=p;o=p+4|0;m=c[r>>2]|0;x=B;a:while(1){do{if((m|0)==0){C=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){C=m;break}if(!((pe[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){C=m;break}c[r>>2]=0;C=0}}while(0);B=(C|0)==0;v=c[e>>2]|0;do{if((v|0)==0){D=19}else{if((c[v+12>>2]|0)!=(c[v+16>>2]|0)){if(B){break}else{E=x;break a}}if((pe[c[(c[v>>2]|0)+36>>2]&127](v)|0)==-1){c[e>>2]=0;D=19;break}else{if(B){break}else{E=x;break a}}}}while(0);if((D|0)==19){D=0;if(B){E=x;break}}v=a[p]|0;w=(v&1)==0;if(w){F=(v&255)>>>1}else{F=c[o>>2]|0}if(((c[q>>2]|0)-x|0)==(F|0)){if(w){G=(v&255)>>>1;H=(v&255)>>>1}else{v=c[o>>2]|0;G=v;H=v}_fb(p,H<<1,0);if((a[p]&1)==0){I=10}else{I=(c[f>>2]&-2)+ -1|0}_fb(p,I,0);if((a[p]&1)==0){J=z}else{J=c[A>>2]|0}c[q>>2]=J+G;K=J}else{K=x}v=C+12|0;w=c[v>>2]|0;l=C+16|0;if((w|0)==(c[l>>2]|0)){L=(pe[c[(c[C>>2]|0)+36>>2]&127](C)|0)&255}else{L=a[w]|0}if((ajb(L,16,K,q,t,0,n,g,s,y)|0)!=0){E=K;break}w=c[v>>2]|0;if((w|0)==(c[l>>2]|0)){pe[c[(c[C>>2]|0)+40>>2]&127](C)|0;m=C;x=K;continue}else{c[v>>2]=w+1;m=C;x=K;continue}}a[E+3|0]=0;do{if((a[314024]|0)==0){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);K=c[78504]|0;c[k>>2]=j;if((bjb(E,K,312712,k)|0)!=1){c[h>>2]=4}k=c[r>>2]|0;do{if((k|0)==0){M=0}else{if((c[k+12>>2]|0)!=(c[k+16>>2]|0)){M=k;break}if(!((pe[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1)){M=k;break}c[r>>2]=0;M=0}}while(0);r=(M|0)==0;k=c[e>>2]|0;do{if((k|0)==0){D=54}else{if((c[k+12>>2]|0)!=(c[k+16>>2]|0)){if(!r){break}N=b;O=N;c[O>>2]=M;Rfb(p);Rfb(n);i=d;return}if((pe[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1){c[e>>2]=0;D=54;break}if(!(r^(k|0)==0)){break}N=b;O=N;c[O>>2]=M;Rfb(p);Rfb(n);i=d;return}}while(0);do{if((D|0)==54){if(r){break}N=b;O=N;c[O>>2]=M;Rfb(p);Rfb(n);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;N=b;O=N;c[O>>2]=M;Rfb(p);Rfb(n);i=d;return}function ajb(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do{if(p){q=(a[m+24|0]|0)==b<<24>>24;if(!q){if(!((a[m+25|0]|0)==b<<24>>24)){break}}c[f>>2]=e+1;a[e]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}}while(0);q=a[j]|0;if((q&1)==0){s=(q&255)>>>1}else{s=c[j+4>>2]|0}if((s|0)!=0&b<<24>>24==h<<24>>24){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+26|0;h=m;while(1){l=h+1|0;if((a[h]|0)==b<<24>>24){t=h;break}if((l|0)==(k|0)){t=k;break}else{h=l}}h=t-m|0;if((h|0)>23){r=-1;i=n;return r|0}do{if((d|0)==10|(d|0)==8){if((h|0)<(d|0)){break}else{r=-1}i=n;return r|0}else if((d|0)==16){if((h|0)<22){break}if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+ -1|0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;m=a[312672+h|0]|0;c[f>>2]=o+1;a[o]=m;r=0;i=n;return r|0}}while(0);e=a[312672+h|0]|0;c[f>>2]=o+1;a[o]=e;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function bjb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Oc(b|0)|0;b=Ya(a|0,d|0,g|0)|0;if((e|0)==0){i=f;return b|0}Oc(e|0)|0;i=f;return b|0}function cjb(a){a=a|0;var b=0;b=i;cqb(a);i=b;return}function djb(a){a=a|0;i=i;return}function ejb(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+136|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=k+40|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+88|0;v=k+96|0;w=k+104|0;x=k+128|0;if((c[g+4>>2]&1|0)==0){c[q>>2]=-1;y=c[(c[d>>2]|0)+16>>2]|0;z=e;c[s>>2]=c[z>>2];c[t>>2]=c[f>>2];A=n;B=s;c[A+0>>2]=c[B+0>>2];B=m;A=t;c[B+0>>2]=c[A+0>>2];Be[y&63](r,d,n,m,g,h,q);m=c[r>>2]|0;c[z>>2]=m;z=c[q>>2]|0;if((z|0)==1){a[j]=1}else if((z|0)==0){a[j]=0}else{a[j]=1;c[h>>2]=4}c[b>>2]=m;i=k;return}Ngb(u,g);m=u;u=c[m>>2]|0;if(!((c[78530]|0)==-1)){c[p>>2]=314120;c[p+4>>2]=1431;c[p+8>>2]=0;Cfb(314120,p,1432)}p=(c[314124>>2]|0)+ -1|0;z=c[u+8>>2]|0;if(!((c[u+12>>2]|0)-z>>2>>>0>p>>>0)){C=Hc(4)|0;D=C;Bpb(D);E=329688;F=128;_d(C|0,E|0,F|0)}u=c[z+(p<<2)>>2]|0;if((u|0)==0){C=Hc(4)|0;D=C;Bpb(D);E=329688;F=128;_d(C|0,E|0,F|0)}F=u;hfb(c[m>>2]|0)|0;Ngb(v,g);g=v;v=c[g>>2]|0;if(!((c[78570]|0)==-1)){c[o>>2]=314280;c[o+4>>2]=1431;c[o+8>>2]=0;Cfb(314280,o,1432)}o=(c[314284>>2]|0)+ -1|0;m=c[v+8>>2]|0;if(!((c[v+12>>2]|0)-m>>2>>>0>o>>>0)){G=Hc(4)|0;H=G;Bpb(H);I=329688;J=128;_d(G|0,I|0,J|0)}v=c[m+(o<<2)>>2]|0;if((v|0)==0){G=Hc(4)|0;H=G;Bpb(H);I=329688;J=128;_d(G|0,I|0,J|0)}J=v;hfb(c[g>>2]|0)|0;g=w;ne[c[(c[v>>2]|0)+24>>2]&255](g,J);ne[c[(c[v>>2]|0)+28>>2]&255](w+12|0,J);c[x>>2]=c[f>>2];f=w+24|0;J=l;v=x;c[J+0>>2]=c[v+0>>2];v=fjb(e,l,g,f,F,h,1)|0;a[j]=(v|0)==(g|0)|0;c[b>>2]=c[e>>2];tgb(w+12|0);tgb(w);i=k;return}function fjb(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;k=i;i=i+104|0;l=(f-e|0)/12|0;m=k;do{if(l>>>0>100){n=Wpb(l)|0;if((n|0)!=0){o=n;p=n;break}hqb()}else{o=0;p=m}}while(0);m=(e|0)==(f|0);if(m){q=0;r=l}else{n=e;s=0;t=l;l=p;while(1){u=a[n]|0;if((u&1)==0){v=(u&255)>>>1}else{v=c[n+4>>2]|0}if((v|0)==0){a[l]=2;w=s+1|0;x=t+ -1|0}else{a[l]=1;w=s;x=t}u=n+12|0;if((u|0)==(f|0)){q=w;r=x;break}else{n=u;s=w;t=x;l=l+1|0}}}l=b;b=d;d=0;x=q;q=r;a:while(1){r=c[l>>2]|0;do{if((r|0)==0){y=1}else{t=c[r+12>>2]|0;if((t|0)==(c[r+16>>2]|0)){z=pe[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{z=c[t>>2]|0}if((z|0)==-1){c[l>>2]=0;y=1;break}else{y=(c[l>>2]|0)==0;break}}}while(0);r=c[b>>2]|0;do{if((r|0)==0){A=0;B=1}else{t=c[r+12>>2]|0;if((t|0)==(c[r+16>>2]|0)){C=pe[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{C=c[t>>2]|0}if(!((C|0)==-1)){A=r;B=0;break}c[b>>2]=0;A=0;B=1}}while(0);D=c[l>>2]|0;if(!((y^B)&(q|0)!=0)){break}r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){E=pe[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{E=c[r>>2]|0}if(j){F=E}else{F=Ee[c[(c[g>>2]|0)+28>>2]&63](g,E)|0}r=d+1|0;if(m){d=r;q=q;x=x;continue}b:do{if(j){t=0;w=e;s=x;n=q;v=p;while(1){do{if((a[v]|0)==1){u=a[w]|0;G=(u&1)==0;if(G){H=w+4|0}else{H=c[w+8>>2]|0}if((F|0)!=(c[H+(d<<2)>>2]|0)){a[v]=0;I=t;J=s;K=n+ -1|0;break}if(G){L=(u&255)>>>1}else{L=c[w+4>>2]|0}if((L|0)!=(r|0)){I=1;J=s;K=n;break}a[v]=2;I=1;J=s+1|0;K=n+ -1|0}else{I=t;J=s;K=n}}while(0);u=w+12|0;if((u|0)==(f|0)){M=I;N=J;O=K;break b}t=I;w=u;s=J;n=K;v=v+1|0}}else{v=0;n=e;s=x;w=q;t=p;while(1){do{if((a[t]|0)==1){if((a[n]&1)==0){P=n+4|0}else{P=c[n+8>>2]|0}if((F|0)!=(Ee[c[(c[g>>2]|0)+28>>2]&63](g,c[P+(d<<2)>>2]|0)|0)){a[t]=0;Q=v;R=s;S=w+ -1|0;break}u=a[n]|0;if((u&1)==0){T=(u&255)>>>1}else{T=c[n+4>>2]|0}if((T|0)!=(r|0)){Q=1;R=s;S=w;break}a[t]=2;Q=1;R=s+1|0;S=w+ -1|0}else{Q=v;R=s;S=w}}while(0);u=n+12|0;if((u|0)==(f|0)){M=Q;N=R;O=S;break b}v=Q;n=u;s=R;w=S;t=t+1|0}}}while(0);if(!M){d=r;x=N;q=O;continue}t=c[l>>2]|0;w=t+12|0;s=c[w>>2]|0;if((s|0)==(c[t+16>>2]|0)){pe[c[(c[t>>2]|0)+40>>2]&127](t)|0}else{c[w>>2]=s+4}if((O+N|0)>>>0<2){d=r;x=N;q=O;continue}else{U=e;V=N;W=p}while(1){do{if((a[W]|0)==2){s=a[U]|0;if((s&1)==0){X=(s&255)>>>1}else{X=c[U+4>>2]|0}if((X|0)==(r|0)){Y=V;break}a[W]=0;Y=V+ -1|0}else{Y=V}}while(0);s=U+12|0;if((s|0)==(f|0)){d=r;x=Y;q=O;continue a}else{U=s;V=Y;W=W+1|0}}}do{if((D|0)==0){Z=1}else{W=c[D+12>>2]|0;if((W|0)==(c[D+16>>2]|0)){_=pe[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{_=c[W>>2]|0}if((_|0)==-1){c[l>>2]=0;Z=1;break}else{Z=(c[l>>2]|0)==0;break}}}while(0);do{if((A|0)==0){$=85}else{l=c[A+12>>2]|0;if((l|0)==(c[A+16>>2]|0)){aa=pe[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{aa=c[l>>2]|0}if((aa|0)==-1){c[b>>2]=0;$=85;break}else{if(Z){break}else{$=87;break}}}}while(0);if(($|0)==85){if(Z){$=87}}if(($|0)==87){c[h>>2]=c[h>>2]|2}c:do{if(m){$=92}else{if((a[p]|0)==2){ba=e;break}else{ca=e;da=p}while(1){Z=ca+12|0;b=da+1|0;if((Z|0)==(f|0)){$=92;break c}if((a[b]|0)==2){ba=Z;break}else{da=b;ca=Z}}}}while(0);if(($|0)==92){c[h>>2]=c[h>>2]|4;ba=f}if((o|0)==0){i=k;return ba|0}Xpb(o);i=k;return ba|0}function gjb(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];hjb(a,0,k,j,f,g,h);i=b;return}function hjb(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;Djb(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;_fb(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=pe[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=pe[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}_fb(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}_fb(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=pe[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((zjb(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){pe[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=wob(I,c[o>>2]|0,h,t)|0;Nlb(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=pe[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=pe[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;Rfb(n);Rfb(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;Rfb(n);Rfb(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;Rfb(n);Rfb(m);i=d;return}function ijb(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];jjb(a,0,k,j,f,g,h);i=b;return}function jjb(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==64){t=8}else if((s|0)==0){t=0}else{t=10}s=k;Djb(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;_fb(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=pe[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=pe[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){K=(w&255)>>>1}else{K=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(K|0)){if(E){L=(w&255)>>>1;M=(w&255)>>>1}else{w=c[x>>2]|0;L=w;M=w}_fb(n,M<<1,0);if((a[n]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}_fb(n,N,0);if((a[n]&1)==0){O=u}else{O=c[v>>2]|0}c[o>>2]=O+L;P=O}else{P=z}w=A+12|0;E=c[w>>2]|0;Q=A+16|0;if((E|0)==(c[Q>>2]|0)){R=pe[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{R=c[E>>2]|0}if((zjb(R,t,P,o,r,y,m,g,q,s)|0)!=0){H=G;I=P;break}E=c[w>>2]|0;if((E|0)==(c[Q>>2]|0)){pe[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=P;continue}else{c[w>>2]=E+4;l=A;z=P;continue}}P=a[m]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[m+4>>2]|0}do{if((S|0)!=0){P=c[q>>2]|0;if((P-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=P+4;c[P>>2]=z}}while(0);r=vob(I,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;Nlb(m,g,c[q>>2]|0,h);do{if((A|0)==0){T=0;U=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){V=pe[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{V=c[q>>2]|0}if(!((V|0)==-1)){T=A;U=0;break}c[k>>2]=0;T=0;U=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){W=pe[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{W=c[k>>2]|0}if((W|0)==-1){c[e>>2]=0;D=60;break}if(!U){break}X=b;Y=X;c[Y>>2]=T;Rfb(n);Rfb(m);i=d;return}}while(0);do{if((D|0)==60){if(U){break}X=b;Y=X;c[Y>>2]=T;Rfb(n);Rfb(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;X=b;Y=X;c[Y>>2]=T;Rfb(n);Rfb(m);i=d;return}function kjb(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];ljb(a,0,k,j,f,g,h);i=b;return}function ljb(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+328|0;l=e;m=e+104|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+152|0;r=e+312|0;s=e+320|0;t=c[h+4>>2]&74;if((t|0)==64){u=8}else if((t|0)==0){u=0}else if((t|0)==8){u=16}else{u=10}t=l;Djb(n,h,t,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;_fb(o,10,0);if((a[o]&1)==0){h=o+1|0;v=h;w=o+8|0;x=h}else{h=o+8|0;v=o+1|0;w=h;x=c[h>>2]|0}c[p>>2]=x;h=q;c[r>>2]=h;c[s>>2]=0;l=f;f=g;g=o;y=o+4|0;z=c[m>>2]|0;m=c[l>>2]|0;A=x;a:while(1){do{if((m|0)==0){B=0;C=1}else{x=c[m+12>>2]|0;if((x|0)==(c[m+16>>2]|0)){D=pe[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{D=c[x>>2]|0}if(!((D|0)==-1)){B=m;C=0;break}c[l>>2]=0;B=0;C=1}}while(0);x=c[f>>2]|0;do{if((x|0)==0){E=21}else{F=c[x+12>>2]|0;if((F|0)==(c[x+16>>2]|0)){G=pe[c[(c[x>>2]|0)+36>>2]&127](x)|0}else{G=c[F>>2]|0}if((G|0)==-1){c[f>>2]=0;E=21;break}else{if(C){H=x;break}else{I=x;J=A;break a}}}}while(0);if((E|0)==21){E=0;if(C){I=0;J=A;break}else{H=0}}x=a[o]|0;F=(x&1)==0;if(F){K=(x&255)>>>1}else{K=c[y>>2]|0}if(((c[p>>2]|0)-A|0)==(K|0)){if(F){L=(x&255)>>>1;M=(x&255)>>>1}else{x=c[y>>2]|0;L=x;M=x}_fb(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[g>>2]&-2)+ -1|0}_fb(o,N,0);if((a[o]&1)==0){O=v}else{O=c[w>>2]|0}c[p>>2]=O+L;P=O}else{P=A}x=B+12|0;F=c[x>>2]|0;Q=B+16|0;if((F|0)==(c[Q>>2]|0)){R=pe[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{R=c[F>>2]|0}if((zjb(R,u,P,p,s,z,n,h,r,t)|0)!=0){I=H;J=P;break}F=c[x>>2]|0;if((F|0)==(c[Q>>2]|0)){pe[c[(c[B>>2]|0)+40>>2]&127](B)|0;m=B;A=P;continue}else{c[x>>2]=F+4;m=B;A=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){P=c[r>>2]|0;if((P-q|0)>=160){break}A=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=A}}while(0);b[k>>1]=uob(J,c[p>>2]|0,j,u)|0;Nlb(n,h,c[r>>2]|0,j);do{if((B|0)==0){T=0;U=1}else{r=c[B+12>>2]|0;if((r|0)==(c[B+16>>2]|0)){V=pe[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{V=c[r>>2]|0}if(!((V|0)==-1)){T=B;U=0;break}c[l>>2]=0;T=0;U=1}}while(0);do{if((I|0)==0){E=60}else{l=c[I+12>>2]|0;if((l|0)==(c[I+16>>2]|0)){W=pe[c[(c[I>>2]|0)+36>>2]&127](I)|0}else{W=c[l>>2]|0}if((W|0)==-1){c[f>>2]=0;E=60;break}if(!U){break}X=d;Y=X;c[Y>>2]=T;Rfb(o);Rfb(n);i=e;return}}while(0);do{if((E|0)==60){if(U){break}X=d;Y=X;c[Y>>2]=T;Rfb(o);Rfb(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;X=d;Y=X;c[Y>>2]=T;Rfb(o);Rfb(n);i=e;return}function mjb(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];njb(a,0,k,j,f,g,h);i=b;return}function njb(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;Djb(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;_fb(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=pe[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=pe[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}_fb(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}_fb(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=pe[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((zjb(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){pe[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=tob(I,c[o>>2]|0,h,t)|0;Nlb(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=pe[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=pe[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;Rfb(n);Rfb(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;Rfb(n);Rfb(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;Rfb(n);Rfb(m);i=d;return}function ojb(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];pjb(a,0,k,j,f,g,h);i=b;return}function pjb(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;Djb(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;_fb(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=pe[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=pe[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}_fb(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}_fb(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=pe[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((zjb(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){pe[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=sob(I,c[o>>2]|0,h,t)|0;Nlb(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=pe[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=pe[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;Rfb(n);Rfb(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;Rfb(n);Rfb(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;Rfb(n);Rfb(m);i=d;return}function qjb(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];rjb(a,0,k,j,f,g,h);i=b;return}function rjb(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==64){t=8}else if((s|0)==0){t=0}else{t=10}s=k;Djb(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;_fb(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=pe[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=pe[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){K=(w&255)>>>1}else{K=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(K|0)){if(E){L=(w&255)>>>1;M=(w&255)>>>1}else{w=c[x>>2]|0;L=w;M=w}_fb(n,M<<1,0);if((a[n]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}_fb(n,N,0);if((a[n]&1)==0){O=u}else{O=c[v>>2]|0}c[o>>2]=O+L;P=O}else{P=z}w=A+12|0;E=c[w>>2]|0;Q=A+16|0;if((E|0)==(c[Q>>2]|0)){R=pe[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{R=c[E>>2]|0}if((zjb(R,t,P,o,r,y,m,g,q,s)|0)!=0){H=G;I=P;break}E=c[w>>2]|0;if((E|0)==(c[Q>>2]|0)){pe[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=P;continue}else{c[w>>2]=E+4;l=A;z=P;continue}}P=a[m]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[m+4>>2]|0}do{if((S|0)!=0){P=c[q>>2]|0;if((P-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=P+4;c[P>>2]=z}}while(0);r=rob(I,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;Nlb(m,g,c[q>>2]|0,h);do{if((A|0)==0){T=0;U=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){V=pe[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{V=c[q>>2]|0}if(!((V|0)==-1)){T=A;U=0;break}c[k>>2]=0;T=0;U=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){W=pe[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{W=c[k>>2]|0}if((W|0)==-1){c[e>>2]=0;D=60;break}if(!U){break}X=b;Y=X;c[Y>>2]=T;Rfb(n);Rfb(m);i=d;return}}while(0);do{if((D|0)==60){if(U){break}X=b;Y=X;c[Y>>2]=T;Rfb(n);Rfb(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;X=b;Y=X;c[Y>>2]=T;Rfb(n);Rfb(m);i=d;return}function sjb(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];tjb(a,0,k,j,f,g,h);i=b;return}function tjb(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;Ejb(n,h,v,l,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;_fb(o,10,0);if((a[o]&1)==0){h=o+1|0;w=h;x=o+8|0;y=h}else{h=o+8|0;w=o+1|0;x=h;y=c[h>>2]|0}c[p>>2]=y;h=q;c[r>>2]=h;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=pe[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=pe[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}_fb(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}_fb(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=pe[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((Fjb(T,t,u,R,p,B,l,n,h,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){pe[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);g[k>>2]=+qob(L,c[p>>2]|0,j);Nlb(n,h,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=pe[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=pe[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;Rfb(o);Rfb(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;Rfb(o);Rfb(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;Rfb(o);Rfb(n);i=d;return}function ujb(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];vjb(a,0,k,j,f,g,h);i=b;return}function vjb(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;Ejb(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;_fb(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=pe[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=pe[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}_fb(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}_fb(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=pe[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((Fjb(T,t,u,R,p,B,l,n,g,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){pe[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);h[k>>3]=+pob(L,c[p>>2]|0,j);Nlb(n,g,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=pe[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=pe[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;Rfb(o);Rfb(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;Rfb(o);Rfb(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;Rfb(o);Rfb(n);i=d;return}function wjb(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];xjb(a,0,k,j,f,g,h);i=b;return}function xjb(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;Ejb(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;_fb(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=pe[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=pe[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}_fb(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}_fb(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=pe[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((Fjb(T,t,u,R,p,B,l,n,g,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){pe[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);h[k>>3]=+oob(L,c[p>>2]|0,j);Nlb(n,g,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=pe[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=pe[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;Rfb(o);Rfb(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;Rfb(o);Rfb(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;Rfb(o);Rfb(n);i=d;return}function yjb(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=i;i=i+8|0;k=d;l=i;i=i+16|0;m=i;i=i+104|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+160|0;s=i;i=i+8|0;t=i;i=i+8|0;u=n;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Ngb(o,g);g=o;o=c[g>>2]|0;if(!((c[78530]|0)==-1)){c[l>>2]=314120;c[l+4>>2]=1431;c[l+8>>2]=0;Cfb(314120,l,1432)}l=(c[314124>>2]|0)+ -1|0;u=c[o+8>>2]|0;if(!((c[o+12>>2]|0)-u>>2>>>0>l>>>0)){v=Hc(4)|0;w=v;Bpb(w);x=329688;y=128;_d(v|0,x|0,y|0)}o=c[u+(l<<2)>>2]|0;if((o|0)==0){v=Hc(4)|0;w=v;Bpb(w);x=329688;y=128;_d(v|0,x|0,y|0)}y=m;Oe[c[(c[o>>2]|0)+48>>2]&63](o,312672,312698|0,y)|0;hfb(c[g>>2]|0)|0;g=p;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;_fb(p,10,0);if((a[p]&1)==0){g=p+1|0;z=g;A=p+8|0;B=g}else{g=p+8|0;z=p+1|0;A=g;B=c[g>>2]|0}c[q>>2]=B;g=r;c[s>>2]=g;c[t>>2]=0;r=e;e=f;f=p;o=p+4|0;m=c[r>>2]|0;x=B;a:while(1){do{if((m|0)==0){C=0;D=1}else{B=c[m+12>>2]|0;if((B|0)==(c[m+16>>2]|0)){E=pe[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{E=c[B>>2]|0}if(!((E|0)==-1)){C=m;D=0;break}c[r>>2]=0;C=0;D=1}}while(0);B=c[e>>2]|0;do{if((B|0)==0){F=22}else{v=c[B+12>>2]|0;if((v|0)==(c[B+16>>2]|0)){G=pe[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{G=c[v>>2]|0}if((G|0)==-1){c[e>>2]=0;F=22;break}else{if(D){break}else{H=x;break a}}}}while(0);if((F|0)==22){F=0;if(D){H=x;break}}B=a[p]|0;v=(B&1)==0;if(v){I=(B&255)>>>1}else{I=c[o>>2]|0}if(((c[q>>2]|0)-x|0)==(I|0)){if(v){J=(B&255)>>>1;K=(B&255)>>>1}else{B=c[o>>2]|0;J=B;K=B}_fb(p,K<<1,0);if((a[p]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}_fb(p,L,0);if((a[p]&1)==0){M=z}else{M=c[A>>2]|0}c[q>>2]=M+J;N=M}else{N=x}B=C+12|0;v=c[B>>2]|0;w=C+16|0;if((v|0)==(c[w>>2]|0)){O=pe[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{O=c[v>>2]|0}if((zjb(O,16,N,q,t,0,n,g,s,y)|0)!=0){H=N;break}v=c[B>>2]|0;if((v|0)==(c[w>>2]|0)){pe[c[(c[C>>2]|0)+40>>2]&127](C)|0;m=C;x=N;continue}else{c[B>>2]=v+4;m=C;x=N;continue}}a[H+3|0]=0;do{if((a[314024]|0)==0){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);N=c[78504]|0;c[k>>2]=j;if((bjb(H,N,312712,k)|0)!=1){c[h>>2]=4}k=c[r>>2]|0;do{if((k|0)==0){P=0;Q=1}else{N=c[k+12>>2]|0;if((N|0)==(c[k+16>>2]|0)){R=pe[c[(c[k>>2]|0)+36>>2]&127](k)|0}else{R=c[N>>2]|0}if(!((R|0)==-1)){P=k;Q=0;break}c[r>>2]=0;P=0;Q=1}}while(0);r=c[e>>2]|0;do{if((r|0)==0){F=60}else{k=c[r+12>>2]|0;if((k|0)==(c[r+16>>2]|0)){S=pe[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{S=c[k>>2]|0}if((S|0)==-1){c[e>>2]=0;F=60;break}if(!Q){break}T=b;U=T;c[U>>2]=P;Rfb(p);Rfb(n);i=d;return}}while(0);do{if((F|0)==60){if(Q){break}T=b;U=T;c[U>>2]=P;Rfb(p);Rfb(n);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;T=b;U=T;c[U>>2]=P;Rfb(p);Rfb(n);i=d;return}function zjb(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do{if(p){q=(c[m+96>>2]|0)==(b|0);if(!q){if((c[m+100>>2]|0)!=(b|0)){break}}c[f>>2]=e+1;a[e]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}}while(0);q=a[j]|0;if((q&1)==0){s=(q&255)>>>1}else{s=c[j+4>>2]|0}if((s|0)!=0&(b|0)==(h|0)){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+104|0;h=m;while(1){l=h+4|0;if((c[h>>2]|0)==(b|0)){t=h;break}if((l|0)==(k|0)){t=k;break}else{h=l}}h=t-m|0;m=h>>2;if((h|0)>92){r=-1;i=n;return r|0}do{if((d|0)==16){if((h|0)<88){break}if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+ -1|0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;t=a[312672+m|0]|0;c[f>>2]=o+1;a[o]=t;r=0;i=n;return r|0}else if((d|0)==10|(d|0)==8){if((m|0)<(d|0)){break}else{r=-1}i=n;return r|0}}while(0);d=a[312672+m|0]|0;c[f>>2]=o+1;a[o]=d;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function Ajb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g;j=g+16|0;k=g+32|0;Ngb(k,d);d=k;k=c[d>>2]|0;if(!((c[78532]|0)==-1)){c[j>>2]=314128;c[j+4>>2]=1431;c[j+8>>2]=0;Cfb(314128,j,1432)}j=(c[314132>>2]|0)+ -1|0;l=c[k+8>>2]|0;if(!((c[k+12>>2]|0)-l>>2>>>0>j>>>0)){m=Hc(4)|0;n=m;Bpb(n);o=329688;p=128;_d(m|0,o|0,p|0)}k=c[l+(j<<2)>>2]|0;if((k|0)==0){m=Hc(4)|0;n=m;Bpb(n);o=329688;p=128;_d(m|0,o|0,p|0)}Oe[c[(c[k>>2]|0)+32>>2]&63](k,312672,312698|0,e)|0;e=c[d>>2]|0;if(!((c[78568]|0)==-1)){c[h>>2]=314272;c[h+4>>2]=1431;c[h+8>>2]=0;Cfb(314272,h,1432)}h=(c[314276>>2]|0)+ -1|0;k=c[e+8>>2]|0;if(!((c[e+12>>2]|0)-k>>2>>>0>h>>>0)){q=Hc(4)|0;r=q;Bpb(r);s=329688;t=128;_d(q|0,s|0,t|0)}e=c[k+(h<<2)>>2]|0;if((e|0)==0){q=Hc(4)|0;r=q;Bpb(r);s=329688;t=128;_d(q|0,s|0,t|0)}else{t=e;a[f]=pe[c[(c[e>>2]|0)+16>>2]&127](t)|0;ne[c[(c[e>>2]|0)+20>>2]&255](b,t);hfb(c[d>>2]|0)|0;i=g;return}}function Bjb(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+40|0;j=h;k=h+16|0;l=h+32|0;Ngb(l,d);d=l;l=c[d>>2]|0;if(!((c[78532]|0)==-1)){c[k>>2]=314128;c[k+4>>2]=1431;c[k+8>>2]=0;Cfb(314128,k,1432)}k=(c[314132>>2]|0)+ -1|0;m=c[l+8>>2]|0;if(!((c[l+12>>2]|0)-m>>2>>>0>k>>>0)){n=Hc(4)|0;o=n;Bpb(o);p=329688;q=128;_d(n|0,p|0,q|0)}l=c[m+(k<<2)>>2]|0;if((l|0)==0){n=Hc(4)|0;o=n;Bpb(o);p=329688;q=128;_d(n|0,p|0,q|0)}Oe[c[(c[l>>2]|0)+32>>2]&63](l,312672,312704|0,e)|0;e=c[d>>2]|0;if(!((c[78568]|0)==-1)){c[j>>2]=314272;c[j+4>>2]=1431;c[j+8>>2]=0;Cfb(314272,j,1432)}j=(c[314276>>2]|0)+ -1|0;l=c[e+8>>2]|0;if(!((c[e+12>>2]|0)-l>>2>>>0>j>>>0)){r=Hc(4)|0;s=r;Bpb(s);t=329688;u=128;_d(r|0,t|0,u|0)}e=c[l+(j<<2)>>2]|0;if((e|0)==0){r=Hc(4)|0;s=r;Bpb(s);t=329688;u=128;_d(r|0,t|0,u|0)}else{u=e;a[f]=pe[c[(c[e>>2]|0)+12>>2]&127](u)|0;a[g]=pe[c[(c[e>>2]|0)+16>>2]&127](u)|0;ne[c[(c[e>>2]|0)+20>>2]&255](b,u);hfb(c[d>>2]|0)|0;i=h;return}}function Cjb(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;if(b<<24>>24==h<<24>>24){if((a[d]|0)==0){q=-1;i=p;return q|0}a[d]=0;h=c[g>>2]|0;c[g>>2]=h+1;a[h]=46;h=a[k]|0;if((h&1)==0){r=(h&255)>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){q=0;i=p;return q|0}r=c[m>>2]|0;if((r-l|0)>=160){q=0;i=p;return q|0}h=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=h;q=0;i=p;return q|0}do{if(b<<24>>24==j<<24>>24){h=a[k]|0;if((h&1)==0){s=(h&255)>>>1}else{s=c[k+4>>2]|0}if((s|0)==0){break}if((a[d]|0)==0){q=-1;i=p;return q|0}h=c[m>>2]|0;if((h-l|0)>=160){q=0;i=p;return q|0}r=c[n>>2]|0;c[m>>2]=h+4;c[h>>2]=r;c[n>>2]=0;q=0;i=p;return q|0}}while(0);s=o+32|0;j=o;while(1){r=j+1|0;if((a[j]|0)==b<<24>>24){t=j;break}if((r|0)==(s|0)){t=s;break}else{j=r}}j=t-o|0;if((j|0)>31){q=-1;i=p;return q|0}o=a[312672+j|0]|0;if((j|0)==24|(j|0)==25){t=c[g>>2]|0;do{if((t|0)!=(f|0)){if((a[t+ -1|0]&95|0)==(a[e]&127|0)){break}else{q=-1}i=p;return q|0}}while(0);c[g>>2]=t+1;a[t]=o;q=0;i=p;return q|0}else if((j|0)==23|(j|0)==22){a[e]=80;t=c[g>>2]|0;c[g>>2]=t+1;a[t]=o;q=0;i=p;return q|0}else{t=a[e]|0;do{if((o&95|0)==(t<<24>>24|0)){a[e]=t|-128;if((a[d]|0)==0){break}a[d]=0;f=a[k]|0;if((f&1)==0){u=(f&255)>>>1}else{u=c[k+4>>2]|0}if((u|0)==0){break}f=c[m>>2]|0;if((f-l|0)>=160){break}s=c[n>>2]|0;c[m>>2]=f+4;c[f>>2]=s}}while(0);m=c[g>>2]|0;c[g>>2]=m+1;a[m]=o;if((j|0)>21){q=0;i=p;return q|0}c[n>>2]=(c[n>>2]|0)+1;q=0;i=p;return q|0}return 0}function Djb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+40|0;g=f;h=f+16|0;j=f+32|0;Ngb(j,b);b=j;j=c[b>>2]|0;if(!((c[78530]|0)==-1)){c[h>>2]=314120;c[h+4>>2]=1431;c[h+8>>2]=0;Cfb(314120,h,1432)}h=(c[314124>>2]|0)+ -1|0;k=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-k>>2>>>0>h>>>0)){l=Hc(4)|0;m=l;Bpb(m);n=329688;o=128;_d(l|0,n|0,o|0)}j=c[k+(h<<2)>>2]|0;if((j|0)==0){l=Hc(4)|0;m=l;Bpb(m);n=329688;o=128;_d(l|0,n|0,o|0)}Oe[c[(c[j>>2]|0)+48>>2]&63](j,312672,312698|0,d)|0;d=c[b>>2]|0;if(!((c[78570]|0)==-1)){c[g>>2]=314280;c[g+4>>2]=1431;c[g+8>>2]=0;Cfb(314280,g,1432)}g=(c[314284>>2]|0)+ -1|0;j=c[d+8>>2]|0;if(!((c[d+12>>2]|0)-j>>2>>>0>g>>>0)){p=Hc(4)|0;q=p;Bpb(q);r=329688;s=128;_d(p|0,r|0,s|0)}d=c[j+(g<<2)>>2]|0;if((d|0)==0){p=Hc(4)|0;q=p;Bpb(q);r=329688;s=128;_d(p|0,r|0,s|0)}else{s=d;c[e>>2]=pe[c[(c[d>>2]|0)+16>>2]&127](s)|0;ne[c[(c[d>>2]|0)+20>>2]&255](a,s);hfb(c[b>>2]|0)|0;i=f;return}}function Ejb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g;j=g+16|0;k=g+32|0;Ngb(k,b);b=k;k=c[b>>2]|0;if(!((c[78530]|0)==-1)){c[j>>2]=314120;c[j+4>>2]=1431;c[j+8>>2]=0;Cfb(314120,j,1432)}j=(c[314124>>2]|0)+ -1|0;l=c[k+8>>2]|0;if(!((c[k+12>>2]|0)-l>>2>>>0>j>>>0)){m=Hc(4)|0;n=m;Bpb(n);o=329688;p=128;_d(m|0,o|0,p|0)}k=c[l+(j<<2)>>2]|0;if((k|0)==0){m=Hc(4)|0;n=m;Bpb(n);o=329688;p=128;_d(m|0,o|0,p|0)}Oe[c[(c[k>>2]|0)+48>>2]&63](k,312672,312704|0,d)|0;d=c[b>>2]|0;if(!((c[78570]|0)==-1)){c[h>>2]=314280;c[h+4>>2]=1431;c[h+8>>2]=0;Cfb(314280,h,1432)}h=(c[314284>>2]|0)+ -1|0;k=c[d+8>>2]|0;if(!((c[d+12>>2]|0)-k>>2>>>0>h>>>0)){q=Hc(4)|0;r=q;Bpb(r);s=329688;t=128;_d(q|0,s|0,t|0)}d=c[k+(h<<2)>>2]|0;if((d|0)==0){q=Hc(4)|0;r=q;Bpb(r);s=329688;t=128;_d(q|0,s|0,t|0)}else{t=d;c[e>>2]=pe[c[(c[d>>2]|0)+12>>2]&127](t)|0;c[f>>2]=pe[c[(c[d>>2]|0)+16>>2]&127](t)|0;ne[c[(c[d>>2]|0)+20>>2]&255](a,t);hfb(c[b>>2]|0)|0;i=g;return}}function Fjb(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;if((b|0)==(h|0)){if((a[d]|0)==0){q=-1;i=p;return q|0}a[d]=0;h=c[g>>2]|0;c[g>>2]=h+1;a[h]=46;h=a[k]|0;if((h&1)==0){r=(h&255)>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){q=0;i=p;return q|0}r=c[m>>2]|0;if((r-l|0)>=160){q=0;i=p;return q|0}h=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=h;q=0;i=p;return q|0}do{if((b|0)==(j|0)){h=a[k]|0;if((h&1)==0){s=(h&255)>>>1}else{s=c[k+4>>2]|0}if((s|0)==0){break}if((a[d]|0)==0){q=-1;i=p;return q|0}h=c[m>>2]|0;if((h-l|0)>=160){q=0;i=p;return q|0}r=c[n>>2]|0;c[m>>2]=h+4;c[h>>2]=r;c[n>>2]=0;q=0;i=p;return q|0}}while(0);s=o+128|0;j=o;while(1){r=j+4|0;if((c[j>>2]|0)==(b|0)){t=j;break}if((r|0)==(s|0)){t=s;break}else{j=r}}j=t-o|0;o=j>>2;if((j|0)>124){q=-1;i=p;return q|0}t=a[312672+o|0]|0;do{if((o|0)==24|(o|0)==25){s=c[g>>2]|0;do{if((s|0)!=(f|0)){if((a[s+ -1|0]&95|0)==(a[e]&127|0)){break}else{q=-1}i=p;return q|0}}while(0);c[g>>2]=s+1;a[s]=t;q=0;i=p;return q|0}else if((o|0)==23|(o|0)==22){a[e]=80}else{b=a[e]|0;if((t&95|0)!=(b<<24>>24|0)){break}a[e]=b|-128;if((a[d]|0)==0){break}a[d]=0;b=a[k]|0;if((b&1)==0){u=(b&255)>>>1}else{u=c[k+4>>2]|0}if((u|0)==0){break}b=c[m>>2]|0;if((b-l|0)>=160){break}r=c[n>>2]|0;c[m>>2]=b+4;c[b>>2]=r}}while(0);m=c[g>>2]|0;c[g>>2]=m+1;a[m]=t;if((j|0)>84){q=0;i=p;return q|0}c[n>>2]=(c[n>>2]|0)+1;q=0;i=p;return q|0}function Gjb(a){a=a|0;var b=0;b=i;cqb(a);i=b;return}function Hjb(a){a=a|0;i=i;return}function Ijb(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;j=i;i=i+56|0;k=j;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;if((c[f+4>>2]&1|0)==0){p=c[(c[d>>2]|0)+24>>2]|0;c[m>>2]=c[e>>2];q=h&1;r=k;s=m;c[r+0>>2]=c[s+0>>2];ye[p&31](b,d,k,f,g,q);i=j;return}Ngb(n,f);f=n;n=c[f>>2]|0;if(!((c[78568]|0)==-1)){c[l>>2]=314272;c[l+4>>2]=1431;c[l+8>>2]=0;Cfb(314272,l,1432)}l=(c[314276>>2]|0)+ -1|0;q=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-q>>2>>>0>l>>>0)){t=Hc(4)|0;u=t;Bpb(u);v=329688;w=128;_d(t|0,v|0,w|0)}n=c[q+(l<<2)>>2]|0;if((n|0)==0){t=Hc(4)|0;u=t;Bpb(u);v=329688;w=128;_d(t|0,v|0,w|0)}w=n;hfb(c[f>>2]|0)|0;f=c[n>>2]|0;if(h){ne[c[f+24>>2]&255](o,w)}else{ne[c[f+28>>2]&255](o,w)}w=a[o]|0;if((w&1)==0){f=o+1|0;x=f;y=f;z=o+8|0}else{f=o+8|0;x=c[f>>2]|0;y=o+1|0;z=f}f=e;e=o+4|0;h=w;w=x;while(1){if((h&1)==0){A=y;B=(h&255)>>>1}else{A=c[z>>2]|0;B=c[e>>2]|0}if((w|0)==(A+B|0)){break}x=a[w]|0;n=c[f>>2]|0;do{if((n|0)!=0){v=n+24|0;t=c[v>>2]|0;if((t|0)!=(c[n+28>>2]|0)){c[v>>2]=t+1;a[t]=x;break}if(!((Ee[c[(c[n>>2]|0)+52>>2]&63](n,x&255)|0)==-1)){break}c[f>>2]=0}}while(0);h=a[o]|0;w=w+1|0}c[b>>2]=c[f>>2];Rfb(o);i=j;return}function Jjb(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=312920;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=100}}while(0);w=m;do{if((a[314024]|0)==0){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);v=c[78504]|0;c[k>>2]=h;h=Kjb(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;Ngb(q,f);Ljb(w,y,k,z,o,p,q);hfb(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];ncb(b,j,z,e,o,f,g);i=d;return}function Kjb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;c[h>>2]=f;f=Oc(d|0)|0;d=bd(a|0,b|0,e|0,h|0)|0;if((f|0)==0){i=g;return d|0}Oc(f|0)|0;i=g;return d|0}function Ljb(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[78532]|0)==-1)){c[m>>2]=314128;c[m+4>>2]=1431;c[m+8>>2]=0;Cfb(314128,m,1432)}m=(c[314132>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Hc(4)|0;r=q;Bpb(r);s=329688;t=128;_d(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Hc(4)|0;r=q;Bpb(r);s=329688;t=128;_d(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[78568]|0)==-1)){c[l>>2]=314272;c[l+4>>2]=1431;c[l+8>>2]=0;Cfb(314272,l,1432)}l=(c[314276>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Hc(4)|0;v=u;Bpb(v);w=329688;x=128;_d(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Hc(4)|0;v=u;Bpb(v);w=329688;x=128;_d(u|0,w|0,x|0)}x=s;ne[c[(c[s>>2]|0)+20>>2]&255](n,x);w=a[n]|0;if((w&1)==0){y=(w&255)>>>1}else{y=c[n+4>>2]|0}do{if((y|0)==0){Oe[c[(c[j>>2]|0)+32>>2]&63](t,b,e,f)|0;c[h>>2]=f+(e-b)}else{c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=Ee[c[(c[j>>2]|0)+28>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=u;z=b+1|0}else{z=b}do{if((e-z|0)>1){if((a[z]|0)!=48){A=z;break}u=z+1|0;w=a[u]|0;if(!(w<<24>>24==88|w<<24>>24==120)){A=z;break}w=Ee[c[(c[j>>2]|0)+28>>2]&63](t,48)|0;v=c[h>>2]|0;c[h>>2]=v+1;a[v]=w;w=Ee[c[(c[j>>2]|0)+28>>2]&63](t,a[u]|0)|0;u=c[h>>2]|0;c[h>>2]=u+1;a[u]=w;A=z+2|0}else{A=z}}while(0);do{if((A|0)!=(e|0)){w=e+ -1|0;if(w>>>0>A>>>0){B=A;C=w}else{break}do{w=a[B]|0;a[B]=a[C]|0;a[C]=w;B=B+1|0;C=C+ -1|0;}while(B>>>0<C>>>0)}}while(0);w=pe[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(A>>>0<e>>>0){u=n+1|0;v=n+4|0;l=n+8|0;o=0;q=0;r=A;while(1){m=(a[n]&1)==0;do{if((a[(m?u:c[l>>2]|0)+q|0]|0)==0){D=o;E=q}else{if((o|0)!=(a[(m?u:c[l>>2]|0)+q|0]|0)){D=o;E=q;break}p=c[h>>2]|0;c[h>>2]=p+1;a[p]=w;p=a[n]|0;if((p&1)==0){F=(p&255)>>>1}else{F=c[v>>2]|0}D=0;E=(q>>>0<(F+ -1|0)>>>0)+q|0}}while(0);m=Ee[c[(c[j>>2]|0)+28>>2]&63](t,a[r]|0)|0;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=m;m=r+1|0;if(m>>>0<e>>>0){o=D+1|0;q=E;r=m}else{break}}}r=f+(A-b)|0;q=c[h>>2]|0;if((r|0)==(q|0)){break}o=q+ -1|0;if(o>>>0>r>>>0){G=r;H=o}else{break}do{o=a[G]|0;a[G]=a[H]|0;a[H]=o;G=G+1|0;H=H+ -1|0;}while(G>>>0<H>>>0)}}while(0);if((d|0)==(e|0)){I=c[h>>2]|0;c[g>>2]=I;Rfb(n);i=k;return}else{I=f+(d-b)|0;c[g>>2]=I;Rfb(n);i=k;return}}function Mjb(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=100}}while(0);x=n;do{if((a[314024]|0)==0){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);y=c[78504]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=Kjb(x,22,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==32){z=l}else if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else{A=20}}while(0);if((A|0)==20){z=x}A=o;Ngb(r,f);Ljb(x,z,l,A,p,q,r);hfb(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];ncb(b,k,A,e,p,f,g);i=d;return}function Njb(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=312920;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=117}}while(0);w=m;do{if((a[314024]|0)==0){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);v=c[78504]|0;c[k>>2]=h;h=Kjb(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;Ngb(q,f);Ljb(w,y,k,z,o,p,q);hfb(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];ncb(b,j,z,e,o,f,g);i=d;return}function Ojb(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==64){a[x]=111}else if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else{a[x]=117}}while(0);x=n;do{if((a[314024]|0)==0){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);w=c[78504]|0;y=l;c[y>>2]=h;c[y+4>>2]=j;j=Kjb(x,23,w,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==32){z=l}else if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else{A=20}}while(0);if((A|0)==20){z=x}A=o;Ngb(r,f);Ljb(x,z,l,A,p,q,r);hfb(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];ncb(b,k,A,e,p,f,g);i=d;return}function Pjb(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+24|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+64|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){if((q&1|0)==0){a[E]=97;F=0;break}else{a[E]=65;F=0;break}}else{a[E]=46;C=E+2|0;a[E+1|0]=42;if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[314024]|0)==0){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);r=c[78504]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=Kjb(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=Kjb(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[314024]|0)==0;if(F){do{if(o){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);r=c[78504]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=Qjb(s,r,z,n)|0}else{do{if(o){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);o=c[78504]|0;c[m>>2]=c[f+8>>2];r=m+4|0;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=Qjb(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}hqb()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==32){L=G}else if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=Wpb(K<<1)|0;if((M|0)!=0){N=I;O=M;P=M;break}hqb()}}while(0);Ngb(w,f);Rjb(N,L,G,P,u,v,w);hfb(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];ncb(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){Xpb(O)}if((J|0)==0){i=d;return}Xpb(J);i=d;return}function Qjb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Oc(b|0)|0;b=nc(a|0,d|0,g|0)|0;if((e|0)==0){i=f;return b|0}Oc(e|0)|0;i=f;return b|0}function Rjb(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[78532]|0)==-1)){c[m>>2]=314128;c[m+4>>2]=1431;c[m+8>>2]=0;Cfb(314128,m,1432)}m=(c[314132>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Hc(4)|0;r=q;Bpb(r);s=329688;t=128;_d(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Hc(4)|0;r=q;Bpb(r);s=329688;t=128;_d(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[78568]|0)==-1)){c[l>>2]=314272;c[l+4>>2]=1431;c[l+8>>2]=0;Cfb(314272,l,1432)}l=(c[314276>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Hc(4)|0;v=u;Bpb(v);w=329688;x=128;_d(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Hc(4)|0;v=u;Bpb(v);w=329688;x=128;_d(u|0,w|0,x|0)}x=s;ne[c[(c[s>>2]|0)+20>>2]&255](n,x);c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=Ee[c[(c[j>>2]|0)+28>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=u;y=b+1|0}else{y=b}u=e;a:do{if((u-y|0)>1){if((a[y]|0)!=48){z=14;break}w=y+1|0;v=a[w]|0;if(!(v<<24>>24==88|v<<24>>24==120)){z=14;break}v=Ee[c[(c[j>>2]|0)+28>>2]&63](t,48)|0;l=c[h>>2]|0;c[h>>2]=l+1;a[l]=v;v=y+2|0;l=Ee[c[(c[j>>2]|0)+28>>2]&63](t,a[w]|0)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=l;if(v>>>0<e>>>0){A=v}else{B=v;C=v;break}while(1){l=a[A]|0;do{if((a[314024]|0)==0){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);w=A+1|0;if(($c(l<<24>>24|0,c[78504]|0)|0)==0){B=v;C=A;break a}if(w>>>0<e>>>0){A=w}else{B=v;C=w;break}}}else{z=14}}while(0);b:do{if((z|0)==14){if(y>>>0<e>>>0){D=y}else{B=y;C=y;break}while(1){A=a[D]|0;do{if((a[314024]|0)==0){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);l=D+1|0;if((ae(A<<24>>24|0,c[78504]|0)|0)==0){B=y;C=D;break b}if(l>>>0<e>>>0){D=l}else{B=y;C=l;break}}}}while(0);y=a[n]|0;if((y&1)==0){E=(y&255)>>>1}else{E=c[n+4>>2]|0}do{if((E|0)==0){Oe[c[(c[j>>2]|0)+32>>2]&63](t,B,C,c[h>>2]|0)|0;c[h>>2]=(c[h>>2]|0)+(C-B)}else{do{if((B|0)!=(C|0)){y=C+ -1|0;if(y>>>0>B>>>0){F=B;G=y}else{break}do{y=a[F]|0;a[F]=a[G]|0;a[G]=y;F=F+1|0;G=G+ -1|0;}while(F>>>0<G>>>0)}}while(0);A=pe[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<C>>>0){y=n+1|0;D=n+4|0;z=n+8|0;l=0;v=0;w=B;while(1){o=(a[n]&1)==0;do{if((a[(o?y:c[z>>2]|0)+v|0]|0)>0){if((l|0)!=(a[(o?y:c[z>>2]|0)+v|0]|0)){H=l;I=v;break}q=c[h>>2]|0;c[h>>2]=q+1;a[q]=A;q=a[n]|0;if((q&1)==0){J=(q&255)>>>1}else{J=c[D>>2]|0}H=0;I=(v>>>0<(J+ -1|0)>>>0)+v|0}else{H=l;I=v}}while(0);o=Ee[c[(c[j>>2]|0)+28>>2]&63](t,a[w]|0)|0;q=c[h>>2]|0;c[h>>2]=q+1;a[q]=o;o=w+1|0;if(o>>>0<C>>>0){l=H+1|0;v=I;w=o}else{break}}}w=f+(B-b)|0;v=c[h>>2]|0;if((w|0)==(v|0)){break}l=v+ -1|0;if(l>>>0>w>>>0){K=w;L=l}else{break}do{l=a[K]|0;a[K]=a[L]|0;a[L]=l;K=K+1|0;L=L+ -1|0;}while(K>>>0<L>>>0)}}while(0);c:do{if(C>>>0<e>>>0){L=C;while(1){K=a[L]|0;if(K<<24>>24==46){break}B=Ee[c[(c[j>>2]|0)+28>>2]&63](t,K)|0;K=c[h>>2]|0;c[h>>2]=K+1;a[K]=B;B=L+1|0;if(B>>>0<e>>>0){L=B}else{M=B;break c}}B=pe[c[(c[s>>2]|0)+12>>2]&127](x)|0;K=c[h>>2]|0;c[h>>2]=K+1;a[K]=B;M=L+1|0}else{M=C}}while(0);Oe[c[(c[j>>2]|0)+32>>2]&63](t,M,e,c[h>>2]|0)|0;t=(c[h>>2]|0)+(u-M)|0;c[h>>2]=t;if((d|0)==(e|0)){N=t;c[g>>2]=N;Rfb(n);i=k;return}N=f+(d-b)|0;c[g>>2]=N;Rfb(n);i=k;return}



function Sjb(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+64|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){a[E]=76;C=E+1|0;if((q&1|0)==0){a[C]=97;F=0;break}else{a[C]=65;F=0;break}}else{a[E]=46;a[E+1|0]=42;a[E+2|0]=76;C=E+3|0;if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[314024]|0)==0){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);r=c[78504]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=Kjb(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=Kjb(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[314024]|0)==0;if(F){do{if(o){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);r=c[78504]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=Qjb(s,r,z,n)|0}else{do{if(o){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);o=c[78504]|0;r=m;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=Qjb(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}hqb()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==32){L=G}else if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=Wpb(K<<1)|0;if((M|0)!=0){N=I;O=M;P=M;break}hqb()}}while(0);Ngb(w,f);Rjb(N,L,G,P,u,v,w);hfb(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];ncb(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){Xpb(O)}if((J|0)==0){i=d;return}Xpb(J);i=d;return}function Tjb(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+40|0;p=i;i=i+8|0;q=i;i=i+8|0;r=m;m=312928;a[r+0|0]=a[m+0|0]|0;a[r+1|0]=a[m+1|0]|0;a[r+2|0]=a[m+2|0]|0;a[r+3|0]=a[m+3|0]|0;a[r+4|0]=a[m+4|0]|0;a[r+5|0]=a[m+5|0]|0;m=n;do{if((a[314024]|0)==0){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);s=c[78504]|0;c[k>>2]=h;h=Kjb(m,20,s,r,k)|0;k=n+h|0;r=c[f+4>>2]&176;do{if((r|0)==16){s=a[m]|0;if(s<<24>>24==43|s<<24>>24==45){t=n+1|0;break}if(!((h|0)>1&s<<24>>24==48)){u=10;break}s=a[n+1|0]|0;if(!(s<<24>>24==88|s<<24>>24==120)){u=10;break}t=n+2|0}else if((r|0)==32){t=k}else{u=10}}while(0);if((u|0)==10){t=m}u=o;Ngb(p,f);r=p;p=c[r>>2]|0;if(!((c[78532]|0)==-1)){c[l>>2]=314128;c[l+4>>2]=1431;c[l+8>>2]=0;Cfb(314128,l,1432)}l=(c[314132>>2]|0)+ -1|0;s=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-s>>2>>>0>l>>>0)){v=Hc(4)|0;w=v;Bpb(w);x=329688;y=128;_d(v|0,x|0,y|0)}p=c[s+(l<<2)>>2]|0;if((p|0)==0){v=Hc(4)|0;w=v;Bpb(w);x=329688;y=128;_d(v|0,x|0,y|0)}hfb(c[r>>2]|0)|0;Oe[c[(c[p>>2]|0)+32>>2]&63](p,m,k,u)|0;m=o+h|0;if((t|0)==(k|0)){z=m;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];ncb(b,j,u,z,m,f,g);I=j;i=d;return}z=o+(t-n)|0;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];ncb(b,j,u,z,m,f,g);I=j;i=d;return}function Ujb(a){a=a|0;var b=0;b=i;cqb(a);i=b;return}function Vjb(a){a=a|0;i=i;return}function Wjb(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;j=i;i=i+56|0;k=j;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;if((c[f+4>>2]&1|0)==0){p=c[(c[d>>2]|0)+24>>2]|0;c[m>>2]=c[e>>2];q=h&1;r=k;s=m;c[r+0>>2]=c[s+0>>2];ye[p&31](b,d,k,f,g,q);i=j;return}Ngb(n,f);f=n;n=c[f>>2]|0;if(!((c[78570]|0)==-1)){c[l>>2]=314280;c[l+4>>2]=1431;c[l+8>>2]=0;Cfb(314280,l,1432)}l=(c[314284>>2]|0)+ -1|0;q=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-q>>2>>>0>l>>>0)){t=Hc(4)|0;u=t;Bpb(u);v=329688;w=128;_d(t|0,v|0,w|0)}n=c[q+(l<<2)>>2]|0;if((n|0)==0){t=Hc(4)|0;u=t;Bpb(u);v=329688;w=128;_d(t|0,v|0,w|0)}w=n;hfb(c[f>>2]|0)|0;f=c[n>>2]|0;if(h){ne[c[f+24>>2]&255](o,w)}else{ne[c[f+28>>2]&255](o,w)}w=a[o]|0;if((w&1)==0){f=o+4|0;x=f;y=o+8|0;z=f}else{f=o+8|0;x=c[f>>2]|0;y=f;z=o+4|0}f=e;e=w;w=x;while(1){if((e&1)==0){A=z;B=(e&255)>>>1}else{A=c[y>>2]|0;B=c[z>>2]|0}if((w|0)==(A+(B<<2)|0)){break}x=c[w>>2]|0;h=c[f>>2]|0;do{if((h|0)!=0){n=h+24|0;v=c[n>>2]|0;if((v|0)==(c[h+28>>2]|0)){C=Ee[c[(c[h>>2]|0)+52>>2]&63](h,x)|0}else{c[n>>2]=v+4;c[v>>2]=x;C=x}if(!((C|0)==-1)){break}c[f>>2]=0}}while(0);e=a[o]|0;w=w+4|0}c[b>>2]=c[f>>2];tgb(o);i=j;return}function Xjb(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+88|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=312920;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=100}}while(0);w=m;do{if((a[314024]|0)==0){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);v=c[78504]|0;c[k>>2]=h;h=Kjb(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;Ngb(q,f);Yjb(w,y,k,z,o,p,q);hfb(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];Zjb(b,j,z,e,o,f,g);i=d;return}function Yjb(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[78530]|0)==-1)){c[m>>2]=314120;c[m+4>>2]=1431;c[m+8>>2]=0;Cfb(314120,m,1432)}m=(c[314124>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Hc(4)|0;r=q;Bpb(r);s=329688;t=128;_d(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Hc(4)|0;r=q;Bpb(r);s=329688;t=128;_d(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[78570]|0)==-1)){c[l>>2]=314280;c[l+4>>2]=1431;c[l+8>>2]=0;Cfb(314280,l,1432)}l=(c[314284>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Hc(4)|0;v=u;Bpb(v);w=329688;x=128;_d(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Hc(4)|0;v=u;Bpb(v);w=329688;x=128;_d(u|0,w|0,x|0)}x=s;ne[c[(c[s>>2]|0)+20>>2]&255](n,x);w=a[n]|0;if((w&1)==0){y=(w&255)>>>1}else{y=c[n+4>>2]|0}do{if((y|0)==0){Oe[c[(c[j>>2]|0)+48>>2]&63](t,b,e,f)|0;w=f+(e-b<<2)|0;c[h>>2]=w;z=w}else{c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=Ee[c[(c[j>>2]|0)+44>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=u;A=b+1|0}else{A=b}do{if((e-A|0)>1){if((a[A]|0)!=48){B=A;break}u=A+1|0;w=a[u]|0;if(!(w<<24>>24==88|w<<24>>24==120)){B=A;break}w=Ee[c[(c[j>>2]|0)+44>>2]&63](t,48)|0;v=c[h>>2]|0;c[h>>2]=v+4;c[v>>2]=w;w=Ee[c[(c[j>>2]|0)+44>>2]&63](t,a[u]|0)|0;u=c[h>>2]|0;c[h>>2]=u+4;c[u>>2]=w;B=A+2|0}else{B=A}}while(0);do{if((B|0)!=(e|0)){w=e+ -1|0;if(w>>>0>B>>>0){C=B;D=w}else{break}do{w=a[C]|0;a[C]=a[D]|0;a[D]=w;C=C+1|0;D=D+ -1|0;}while(C>>>0<D>>>0)}}while(0);w=pe[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<e>>>0){u=n+1|0;v=n+4|0;l=n+8|0;o=0;q=0;r=B;while(1){m=(a[n]&1)==0;do{if((a[(m?u:c[l>>2]|0)+q|0]|0)==0){E=o;F=q}else{if((o|0)!=(a[(m?u:c[l>>2]|0)+q|0]|0)){E=o;F=q;break}p=c[h>>2]|0;c[h>>2]=p+4;c[p>>2]=w;p=a[n]|0;if((p&1)==0){G=(p&255)>>>1}else{G=c[v>>2]|0}E=0;F=(q>>>0<(G+ -1|0)>>>0)+q|0}}while(0);m=Ee[c[(c[j>>2]|0)+44>>2]&63](t,a[r]|0)|0;p=c[h>>2]|0;H=p+4|0;c[h>>2]=H;c[p>>2]=m;m=r+1|0;if(m>>>0<e>>>0){o=E+1|0;q=F;r=m}else{I=H;break}}}else{I=c[h>>2]|0}r=f+(B-b<<2)|0;if((r|0)==(I|0)){z=I;break}q=I+ -4|0;if(q>>>0>r>>>0){J=r;K=q}else{z=I;break}while(1){q=c[J>>2]|0;c[J>>2]=c[K>>2];c[K>>2]=q;q=J+4|0;r=K+ -4|0;if(q>>>0<r>>>0){K=r;J=q}else{z=I;break}}}}while(0);if((d|0)==(e|0)){L=z;c[g>>2]=L;Rfb(n);i=k;return}L=f+(d-b<<2)|0;c[g>>2]=L;Rfb(n);i=k;return}function Zjb(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i;i=i+16|0;l=k;m=d;d=c[m>>2]|0;if((d|0)==0){c[b>>2]=0;i=k;return}n=g;g=e;o=n-g>>2;p=h+12|0;h=c[p>>2]|0;q=(h|0)>(o|0)?h-o|0:0;o=f;h=o-g|0;g=h>>2;do{if((h|0)>0){if((se[c[(c[d>>2]|0)+48>>2]&63](d,e,g)|0)==(g|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);do{if((q|0)>0){sgb(l,q,j);if((a[l]&1)==0){r=l+4|0}else{r=c[l+8>>2]|0}if((se[c[(c[d>>2]|0)+48>>2]&63](d,r,q)|0)==(q|0)){tgb(l);break}c[m>>2]=0;c[b>>2]=0;tgb(l);i=k;return}}while(0);l=n-o|0;o=l>>2;do{if((l|0)>0){if((se[c[(c[d>>2]|0)+48>>2]&63](d,f,o)|0)==(o|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);c[p>>2]=0;c[b>>2]=d;i=k;return}function _jb(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+168|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==64){a[x]=111}else if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else{a[x]=100}}while(0);x=n;do{if((a[314024]|0)==0){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);w=c[78504]|0;y=l;c[y>>2]=h;c[y+4>>2]=j;j=Kjb(x,22,w,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;Ngb(r,f);Yjb(x,z,l,A,p,q,r);hfb(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];Zjb(b,k,A,e,p,f,g);i=d;return}function $jb(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+88|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=312920;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=117}}while(0);w=m;do{if((a[314024]|0)==0){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);v=c[78504]|0;c[k>>2]=h;h=Kjb(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else if((s|0)==32){y=k}else{z=20}}while(0);if((z|0)==20){y=w}z=n;Ngb(q,f);Yjb(w,y,k,z,o,p,q);hfb(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];Zjb(b,j,z,e,o,f,g);i=d;return}function akb(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+176|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=117}}while(0);x=n;do{if((a[314024]|0)==0){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);y=c[78504]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=Kjb(x,23,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;Ngb(r,f);Yjb(x,z,l,A,p,q,r);hfb(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];Zjb(b,k,A,e,p,f,g);i=d;return}function bkb(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+24|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+232|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){if((q&1|0)==0){a[E]=97;F=0;break}else{a[E]=65;F=0;break}}else{a[E]=46;C=E+2|0;a[E+1|0]=42;if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[314024]|0)==0){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);r=c[78504]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=Kjb(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=Kjb(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[314024]|0)==0;if(F){do{if(o){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);r=c[78504]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=Qjb(s,r,z,n)|0}else{do{if(o){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);o=c[78504]|0;c[m>>2]=c[f+8>>2];r=m+4|0;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=Qjb(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}hqb()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==32){L=G}else if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=Wpb(K<<3)|0;s=M;if((M|0)!=0){N=I;O=s;P=s;break}hqb()}}while(0);Ngb(w,f);ckb(N,L,G,P,u,v,w);hfb(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];Zjb(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){Xpb(O)}if((J|0)==0){i=d;return}Xpb(J);i=d;return}function ckb(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[78530]|0)==-1)){c[m>>2]=314120;c[m+4>>2]=1431;c[m+8>>2]=0;Cfb(314120,m,1432)}m=(c[314124>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Hc(4)|0;r=q;Bpb(r);s=329688;t=128;_d(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Hc(4)|0;r=q;Bpb(r);s=329688;t=128;_d(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[78570]|0)==-1)){c[l>>2]=314280;c[l+4>>2]=1431;c[l+8>>2]=0;Cfb(314280,l,1432)}l=(c[314284>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Hc(4)|0;v=u;Bpb(v);w=329688;x=128;_d(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Hc(4)|0;v=u;Bpb(v);w=329688;x=128;_d(u|0,w|0,x|0)}x=s;ne[c[(c[s>>2]|0)+20>>2]&255](n,x);c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=Ee[c[(c[j>>2]|0)+44>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=u;y=b+1|0}else{y=b}u=e;a:do{if((u-y|0)>1){if((a[y]|0)!=48){z=14;break}w=y+1|0;v=a[w]|0;if(!(v<<24>>24==88|v<<24>>24==120)){z=14;break}v=Ee[c[(c[j>>2]|0)+44>>2]&63](t,48)|0;l=c[h>>2]|0;c[h>>2]=l+4;c[l>>2]=v;v=y+2|0;l=Ee[c[(c[j>>2]|0)+44>>2]&63](t,a[w]|0)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=l;if(v>>>0<e>>>0){A=v}else{B=v;C=v;break}while(1){l=a[A]|0;do{if((a[314024]|0)==0){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);w=A+1|0;if(($c(l<<24>>24|0,c[78504]|0)|0)==0){B=v;C=A;break a}if(w>>>0<e>>>0){A=w}else{B=v;C=w;break}}}else{z=14}}while(0);b:do{if((z|0)==14){if(y>>>0<e>>>0){D=y}else{B=y;C=y;break}while(1){A=a[D]|0;do{if((a[314024]|0)==0){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);l=D+1|0;if((ae(A<<24>>24|0,c[78504]|0)|0)==0){B=y;C=D;break b}if(l>>>0<e>>>0){D=l}else{B=y;C=l;break}}}}while(0);y=a[n]|0;if((y&1)==0){E=(y&255)>>>1}else{E=c[n+4>>2]|0}do{if((E|0)==0){Oe[c[(c[j>>2]|0)+48>>2]&63](t,B,C,c[h>>2]|0)|0;y=(c[h>>2]|0)+(C-B<<2)|0;c[h>>2]=y;F=y}else{do{if((B|0)!=(C|0)){y=C+ -1|0;if(y>>>0>B>>>0){G=B;H=y}else{break}do{y=a[G]|0;a[G]=a[H]|0;a[H]=y;G=G+1|0;H=H+ -1|0;}while(G>>>0<H>>>0)}}while(0);A=pe[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<C>>>0){y=n+1|0;D=n+4|0;z=n+8|0;l=0;v=0;w=B;while(1){o=(a[n]&1)==0;do{if((a[(o?y:c[z>>2]|0)+v|0]|0)>0){if((l|0)!=(a[(o?y:c[z>>2]|0)+v|0]|0)){I=l;J=v;break}q=c[h>>2]|0;c[h>>2]=q+4;c[q>>2]=A;q=a[n]|0;if((q&1)==0){K=(q&255)>>>1}else{K=c[D>>2]|0}I=0;J=(v>>>0<(K+ -1|0)>>>0)+v|0}else{I=l;J=v}}while(0);o=Ee[c[(c[j>>2]|0)+44>>2]&63](t,a[w]|0)|0;q=c[h>>2]|0;r=q+4|0;c[h>>2]=r;c[q>>2]=o;o=w+1|0;if(o>>>0<C>>>0){l=I+1|0;v=J;w=o}else{L=r;break}}}else{L=c[h>>2]|0}w=f+(B-b<<2)|0;if((w|0)==(L|0)){F=L;break}v=L+ -4|0;if(v>>>0>w>>>0){M=w;N=v}else{F=L;break}while(1){v=c[M>>2]|0;c[M>>2]=c[N>>2];c[N>>2]=v;v=M+4|0;w=N+ -4|0;if(v>>>0<w>>>0){N=w;M=v}else{F=L;break}}}}while(0);c:do{if(C>>>0<e>>>0){L=C;while(1){M=a[L]|0;if(M<<24>>24==46){break}N=Ee[c[(c[j>>2]|0)+44>>2]&63](t,M)|0;M=c[h>>2]|0;B=M+4|0;c[h>>2]=B;c[M>>2]=N;N=L+1|0;if(N>>>0<e>>>0){L=N}else{O=B;P=N;break c}}N=pe[c[(c[s>>2]|0)+12>>2]&127](x)|0;B=c[h>>2]|0;M=B+4|0;c[h>>2]=M;c[B>>2]=N;O=M;P=L+1|0}else{O=F;P=C}}while(0);Oe[c[(c[j>>2]|0)+48>>2]&63](t,P,e,O)|0;O=(c[h>>2]|0)+(u-P<<2)|0;c[h>>2]=O;if((d|0)==(e|0)){Q=O;c[g>>2]=Q;Rfb(n);i=k;return}Q=f+(d-b<<2)|0;c[g>>2]=Q;Rfb(n);i=k;return}function dkb(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+232|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){a[E]=76;C=E+1|0;if((q&1|0)==0){a[C]=97;F=0;break}else{a[C]=65;F=0;break}}else{a[E]=46;a[E+1|0]=42;a[E+2|0]=76;C=E+3|0;if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[314024]|0)==0){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);r=c[78504]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=Kjb(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=Kjb(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[314024]|0)==0;if(F){do{if(o){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);r=c[78504]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=Qjb(s,r,z,n)|0}else{do{if(o){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);o=c[78504]|0;r=m;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=Qjb(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}hqb()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=Wpb(K<<3)|0;s=M;if((M|0)!=0){N=I;O=s;P=s;break}hqb()}}while(0);Ngb(w,f);ckb(N,L,G,P,u,v,w);hfb(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];Zjb(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){Xpb(O)}if((J|0)==0){i=d;return}Xpb(J);i=d;return}function ekb(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+152|0;p=i;i=i+8|0;q=i;i=i+8|0;r=m;m=312928;a[r+0|0]=a[m+0|0]|0;a[r+1|0]=a[m+1|0]|0;a[r+2|0]=a[m+2|0]|0;a[r+3|0]=a[m+3|0]|0;a[r+4|0]=a[m+4|0]|0;a[r+5|0]=a[m+5|0]|0;m=n;do{if((a[314024]|0)==0){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);s=c[78504]|0;c[k>>2]=h;h=Kjb(m,20,s,r,k)|0;k=n+h|0;r=c[f+4>>2]&176;do{if((r|0)==16){s=a[m]|0;if(s<<24>>24==43|s<<24>>24==45){t=n+1|0;break}if(!((h|0)>1&s<<24>>24==48)){u=10;break}s=a[n+1|0]|0;if(!(s<<24>>24==88|s<<24>>24==120)){u=10;break}t=n+2|0}else if((r|0)==32){t=k}else{u=10}}while(0);if((u|0)==10){t=m}Ngb(p,f);u=p;p=c[u>>2]|0;if(!((c[78530]|0)==-1)){c[l>>2]=314120;c[l+4>>2]=1431;c[l+8>>2]=0;Cfb(314120,l,1432)}l=(c[314124>>2]|0)+ -1|0;r=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-r>>2>>>0>l>>>0)){v=Hc(4)|0;w=v;Bpb(w);x=329688;y=128;_d(v|0,x|0,y|0)}p=c[r+(l<<2)>>2]|0;if((p|0)==0){v=Hc(4)|0;w=v;Bpb(w);x=329688;y=128;_d(v|0,x|0,y|0)}hfb(c[u>>2]|0)|0;u=o;Oe[c[(c[p>>2]|0)+48>>2]&63](p,m,k,u)|0;m=o+(h<<2)|0;if((t|0)==(k|0)){z=m;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];Zjb(b,j,u,z,m,f,g);I=j;i=d;return}z=o+(t-n<<2)|0;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];Zjb(b,j,u,z,m,f,g);I=j;i=d;return}function fkb(d,e,f,g,h,j,k,l,m){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;n=i;i=i+64|0;o=n;p=n+8|0;q=n+16|0;r=n+32|0;s=n+40|0;t=n+48|0;u=n+56|0;Ngb(r,h);v=r;r=c[v>>2]|0;if(!((c[78532]|0)==-1)){c[q>>2]=314128;c[q+4>>2]=1431;c[q+8>>2]=0;Cfb(314128,q,1432)}q=(c[314132>>2]|0)+ -1|0;w=c[r+8>>2]|0;if(!((c[r+12>>2]|0)-w>>2>>>0>q>>>0)){x=Hc(4)|0;y=x;Bpb(y);z=329688;A=128;_d(x|0,z|0,A|0)}r=c[w+(q<<2)>>2]|0;if((r|0)==0){x=Hc(4)|0;y=x;Bpb(y);z=329688;A=128;_d(x|0,z|0,A|0)}A=r;hfb(c[v>>2]|0)|0;c[j>>2]=0;v=f;a:do{if((l|0)==(m|0)){B=65}else{z=g;x=r+8|0;y=t;q=u;w=s;C=l;D=0;b:while(1){E=D;while(1){if((E|0)!=0){B=65;break a}F=c[v>>2]|0;do{if((F|0)==0){G=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){G=F;break}if(!((pe[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1)){G=F;break}c[v>>2]=0;G=0}}while(0);F=(G|0)==0;H=c[z>>2]|0;c:do{if((H|0)==0){B=19}else{do{if((c[H+12>>2]|0)==(c[H+16>>2]|0)){if(!((pe[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1)){break}c[z>>2]=0;B=19;break c}}while(0);if(F){I=H}else{B=20;break b}}}while(0);if((B|0)==19){B=0;if(F){B=20;break b}else{I=0}}if((se[c[(c[r>>2]|0)+36>>2]&63](A,a[C]|0,0)|0)<<24>>24==37){B=22;break}H=a[C]|0;if(H<<24>>24>-1){J=c[x>>2]|0;if(!((b[J+(H<<24>>24<<1)>>1]&8192)==0)){K=C;B=33;break}}L=G+12|0;H=c[L>>2]|0;M=G+16|0;if((H|0)==(c[M>>2]|0)){N=(pe[c[(c[G>>2]|0)+36>>2]&127](G)|0)&255}else{N=a[H]|0}H=Ee[c[(c[r>>2]|0)+12>>2]&63](A,N)|0;if(H<<24>>24==(Ee[c[(c[r>>2]|0)+12>>2]&63](A,a[C]|0)|0)<<24>>24){B=60;break}c[j>>2]=4;E=4}d:do{if((B|0)==22){B=0;E=C+1|0;if((E|0)==(m|0)){B=23;break b}H=se[c[(c[r>>2]|0)+36>>2]&63](A,a[E]|0,0)|0;if(H<<24>>24==48|H<<24>>24==69){O=C+2|0;if((O|0)==(m|0)){B=26;break b}P=O;Q=se[c[(c[r>>2]|0)+36>>2]&63](A,a[O]|0,0)|0;R=H}else{P=E;Q=H;R=0}H=c[(c[e>>2]|0)+36>>2]|0;c[y>>2]=G;c[q>>2]=I;E=p;O=t;c[E+0>>2]=c[O+0>>2];O=o;E=u;c[O+0>>2]=c[E+0>>2];De[H&3](s,e,p,o,h,j,k,Q,R);c[v>>2]=c[w>>2];S=P+1|0}else if((B|0)==33){while(1){B=0;H=K+1|0;if((H|0)==(m|0)){T=m;break}E=a[H]|0;if(!(E<<24>>24>-1)){T=H;break}if((b[J+(E<<24>>24<<1)>>1]&8192)==0){T=H;break}else{K=H;B=33}}F=G;H=I;E=I;while(1){do{if((F|0)==0){U=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){U=F;break}if(!((pe[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1)){U=F;break}c[v>>2]=0;U=0}}while(0);O=(U|0)==0;do{if((E|0)==0){V=H;B=46}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(O){W=H;X=E;break}else{S=T;break d}}if((pe[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[z>>2]=0;V=0;B=46;break}else{if(O^(H|0)==0){W=H;X=H;break}else{S=T;break d}}}}while(0);if((B|0)==46){B=0;if(O){S=T;break d}else{W=V;X=0}}Y=U+12|0;Z=c[Y>>2]|0;_=U+16|0;if((Z|0)==(c[_>>2]|0)){$=(pe[c[(c[U>>2]|0)+36>>2]&127](U)|0)&255}else{$=a[Z]|0}if(!($<<24>>24>-1)){S=T;break d}if((b[(c[x>>2]|0)+($<<24>>24<<1)>>1]&8192)==0){S=T;break d}Z=c[Y>>2]|0;if((Z|0)==(c[_>>2]|0)){pe[c[(c[U>>2]|0)+40>>2]&127](U)|0;F=U;H=W;E=X;continue}else{c[Y>>2]=Z+1;F=U;H=W;E=X;continue}}}else if((B|0)==60){B=0;E=c[L>>2]|0;if((E|0)==(c[M>>2]|0)){pe[c[(c[G>>2]|0)+40>>2]&127](G)|0}else{c[L>>2]=E+1}S=C+1|0}}while(0);if((S|0)==(m|0)){B=65;break a}C=S;D=c[j>>2]|0}if((B|0)==20){c[j>>2]=4;aa=G;break}else if((B|0)==23){c[j>>2]=4;aa=G;break}else if((B|0)==26){c[j>>2]=4;aa=G;break}}}while(0);if((B|0)==65){aa=c[v>>2]|0}v=f;do{if((aa|0)==0){ba=0}else{if((c[aa+12>>2]|0)!=(c[aa+16>>2]|0)){ba=aa;break}if(!((pe[c[(c[aa>>2]|0)+36>>2]&127](aa)|0)==-1)){ba=aa;break}c[v>>2]=0;ba=0}}while(0);v=(ba|0)==0;aa=g;g=c[aa>>2]|0;e:do{if((g|0)==0){B=75}else{do{if((c[g+12>>2]|0)==(c[g+16>>2]|0)){if(!((pe[c[(c[g>>2]|0)+36>>2]&127](g)|0)==-1)){break}c[aa>>2]=0;B=75;break e}}while(0);if(!v){break}ca=d;da=ca;c[da>>2]=ba;i=n;return}}while(0);do{if((B|0)==75){if(v){break}ca=d;da=ca;c[da>>2]=ba;i=n;return}}while(0);c[j>>2]=c[j>>2]|2;ca=d;da=ca;c[da>>2]=ba;i=n;return}function gkb(a){a=a|0;var b=0;b=i;cqb(a);i=b;return}function hkb(a){a=a|0;i=i;return}function ikb(a){a=a|0;i=i;return 2}function jkb(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];e=l;d=m;c[e+0>>2]=c[d+0>>2];d=k;e=n;c[d+0>>2]=c[e+0>>2];fkb(a,b,l,k,f,g,h,313032,313040|0);i=j;return}function kkb(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=d+8|0;q=pe[c[(c[p>>2]|0)+20>>2]&127](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q]|0;if((f&1)==0){r=q+1|0;s=q+1|0;t=(f&255)>>>1}else{f=c[q+8>>2]|0;r=f;s=f;t=c[q+4>>2]|0}q=r+t|0;t=m;r=n;c[t+0>>2]=c[r+0>>2];r=l;t=o;c[r+0>>2]=c[t+0>>2];fkb(b,d,m,l,g,h,j,s,q);i=k;return}function lkb(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;Ngb(n,f);f=n;n=c[f>>2]|0;if(!((c[78532]|0)==-1)){c[m>>2]=314128;c[m+4>>2]=1431;c[m+8>>2]=0;Cfb(314128,m,1432)}m=(c[314132>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Hc(4)|0;q=p;Bpb(q);r=329688;s=128;_d(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Hc(4)|0;q=p;Bpb(q);r=329688;s=128;_d(p|0,r|0,s|0)}s=n;hfb(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=pe[c[c[e>>2]>>2]&127](e)|0;c[l>>2]=f;f=b+168|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=Iib(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=168){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+24>>2]=((g|0)/12|0|0)%7|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function mkb(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;Ngb(n,f);f=n;n=c[f>>2]|0;if(!((c[78532]|0)==-1)){c[m>>2]=314128;c[m+4>>2]=1431;c[m+8>>2]=0;Cfb(314128,m,1432)}m=(c[314132>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Hc(4)|0;q=p;Bpb(q);r=329688;s=128;_d(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Hc(4)|0;q=p;Bpb(q);r=329688;s=128;_d(p|0,r|0,s|0)}s=n;hfb(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=pe[c[(c[e>>2]|0)+4>>2]&127](e)|0;c[l>>2]=f;f=b+288|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=Iib(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=288){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+16>>2]=((g|0)/12|0|0)%12|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function nkb(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+40|0;j=b;k=b+8|0;l=b+16|0;m=b+32|0;Ngb(m,f);f=m;m=c[f>>2]|0;if(!((c[78532]|0)==-1)){c[l>>2]=314128;c[l+4>>2]=1431;c[l+8>>2]=0;Cfb(314128,l,1432)}l=(c[314132>>2]|0)+ -1|0;n=c[m+8>>2]|0;if(!((c[m+12>>2]|0)-n>>2>>>0>l>>>0)){o=Hc(4)|0;p=o;Bpb(p);q=329688;r=128;_d(o|0,q|0,r|0)}m=c[n+(l<<2)>>2]|0;if((m|0)==0){o=Hc(4)|0;p=o;Bpb(p);q=329688;r=128;_d(o|0,q|0,r|0)}r=m;hfb(c[f>>2]|0)|0;f=h+20|0;c[k>>2]=c[e>>2];e=j;h=k;c[e+0>>2]=c[h+0>>2];h=skb(d,j,g,r,4)|0;if((c[g>>2]&4|0)!=0){s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}if((h|0)<69){x=h+2e3|0}else{x=(h+ -69|0)>>>0<31?h+1900|0:h}c[f>>2]=x+ -1900;s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}function okb(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;l=i;i=i+576|0;m=l;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+104|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;M=l+208|0;N=l+216|0;O=l+224|0;P=l+232|0;Q=l+240|0;R=l+248|0;S=l+256|0;T=l+264|0;U=l+272|0;V=l+280|0;W=l+288|0;X=l+296|0;Y=l+304|0;Z=l+312|0;_=l+320|0;$=l+328|0;aa=l+336|0;ba=l+344|0;ca=l+360|0;da=l+368|0;ea=l+376|0;fa=l+384|0;ga=l+392|0;ha=l+400|0;ia=l+408|0;ja=l+416|0;ka=l+424|0;la=l+432|0;ma=l+440|0;na=l+448|0;oa=l+456|0;pa=l+464|0;qa=l+472|0;ra=l+480|0;sa=l+488|0;ta=l+496|0;ua=l+504|0;va=l+512|0;wa=l+520|0;xa=l+528|0;ya=l+536|0;za=l+544|0;Aa=l+552|0;Ba=l+560|0;Ca=l+568|0;c[h>>2]=0;Ngb(ca,g);Da=ca;ca=c[Da>>2]|0;if(!((c[78532]|0)==-1)){c[ba>>2]=314128;c[ba+4>>2]=1431;c[ba+8>>2]=0;Cfb(314128,ba,1432)}ba=(c[314132>>2]|0)+ -1|0;Ea=c[ca+8>>2]|0;if(!((c[ca+12>>2]|0)-Ea>>2>>>0>ba>>>0)){Fa=Hc(4)|0;Ga=Fa;Bpb(Ga);Ha=329688;Ia=128;_d(Fa|0,Ha|0,Ia|0)}ca=c[Ea+(ba<<2)>>2]|0;if((ca|0)==0){Fa=Hc(4)|0;Ga=Fa;Bpb(Ga);Ha=329688;Ia=128;_d(Fa|0,Ha|0,Ia|0)}Ia=ca;hfb(c[Da>>2]|0)|0;a:do{switch(k<<24>>24|0){case 83:{c[U>>2]=c[f>>2];c[w+0>>2]=c[U+0>>2];Da=skb(e,w,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<61){c[j>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 65:case 97:{ca=c[f>>2]|0;Da=d+8|0;Ha=pe[c[c[Da>>2]>>2]&127](Da)|0;c[aa>>2]=ca;c[Q+0>>2]=c[aa+0>>2];ca=(Iib(e,Q,Ha,Ha+168|0,Ia,h,0)|0)-Ha|0;if((ca|0)>=168){break a}c[j+24>>2]=((ca|0)/12|0|0)%7|0;break};case 70:{ca=e;c[ka>>2]=c[ca>>2];c[la>>2]=c[f>>2];c[J+0>>2]=c[ka+0>>2];c[I+0>>2]=c[la+0>>2];fkb(ja,d,J,I,g,h,j,313048,313056|0);c[ca>>2]=c[ja>>2];break};case 89:{c[R>>2]=c[f>>2];c[n+0>>2]=c[R+0>>2];ca=skb(e,n,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}c[j+20>>2]=ca+ -1900;break};case 72:{c[Z>>2]=c[f>>2];c[H+0>>2]=c[Z+0>>2];ca=skb(e,H,h,Ia,2)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(ca|0)<24){c[j+8>>2]=ca;break a}else{c[h>>2]=Ha|4;break a}break};case 112:{c[na>>2]=c[f>>2];c[B+0>>2]=c[na+0>>2];qkb(d,j+8|0,e,B,h,Ia);break};case 101:case 100:{Ha=j+12|0;c[_>>2]=c[f>>2];c[M+0>>2]=c[_+0>>2];ca=skb(e,M,h,Ia,2)|0;Da=c[h>>2]|0;do{if((Da&4|0)==0){if(!((ca+ -1|0)>>>0<31)){break}c[Ha>>2]=ca;break a}}while(0);c[h>>2]=Da|4;break};case 84:{ca=e;c[va>>2]=c[ca>>2];c[wa>>2]=c[f>>2];c[v+0>>2]=c[va+0>>2];c[u+0>>2]=c[wa+0>>2];fkb(ua,d,v,u,g,h,j,313080,313088|0);c[ca>>2]=c[ua>>2];break};case 109:{c[W>>2]=c[f>>2];c[E+0>>2]=c[W+0>>2];ca=skb(e,E,h,Ia,2)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(ca|0)<13){c[j+16>>2]=ca+ -1;break a}else{c[h>>2]=Ha|4;break a}break};case 116:case 110:{c[ma>>2]=c[f>>2];c[C+0>>2]=c[ma+0>>2];pkb(0,e,C,h,Ia);break};case 121:{c[S>>2]=c[f>>2];c[o+0>>2]=c[S+0>>2];Ha=skb(e,o,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}if((Ha|0)<69){Ja=Ha+2e3|0}else{Ja=(Ha+ -69|0)>>>0<31?Ha+1900|0:Ha}c[j+20>>2]=Ja+ -1900;break};case 73:{Ha=j+8|0;c[Y>>2]=c[f>>2];c[G+0>>2]=c[Y+0>>2];ca=skb(e,G,h,Ia,2)|0;Fa=c[h>>2]|0;do{if((Fa&4|0)==0){if(!((ca+ -1|0)>>>0<12)){break}c[Ha>>2]=ca;break a}}while(0);c[h>>2]=Fa|4;break};case 37:{c[Ca>>2]=c[f>>2];c[m+0>>2]=c[Ca+0>>2];rkb(0,e,m,h,Ia);break};case 106:{c[X>>2]=c[f>>2];c[F+0>>2]=c[X+0>>2];ca=skb(e,F,h,Ia,3)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(ca|0)<366){c[j+28>>2]=ca;break a}else{c[h>>2]=Ha|4;break a}break};case 77:{c[V>>2]=c[f>>2];c[D+0>>2]=c[V+0>>2];Ha=skb(e,D,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Ha|0)<60){c[j+4>>2]=Ha;break a}else{c[h>>2]=ca|4;break a}break};case 104:case 66:case 98:{ca=c[f>>2]|0;Ha=d+8|0;Da=pe[c[(c[Ha>>2]|0)+4>>2]&127](Ha)|0;c[$>>2]=ca;c[P+0>>2]=c[$+0>>2];ca=(Iib(e,P,Da,Da+288|0,Ia,h,0)|0)-Da|0;if((ca|0)>=288){break a}c[j+16>>2]=((ca|0)/12|0|0)%12|0;break};case 99:{ca=d+8|0;Da=pe[c[(c[ca>>2]|0)+12>>2]&127](ca)|0;ca=e;c[ea>>2]=c[ca>>2];c[fa>>2]=c[f>>2];Ha=a[Da]|0;if((Ha&1)==0){Ka=Da+1|0;La=Da+1|0;Ma=(Ha&255)>>>1}else{Ha=c[Da+8>>2]|0;Ka=Ha;La=Ha;Ma=c[Da+4>>2]|0}c[O+0>>2]=c[ea+0>>2];c[N+0>>2]=c[fa+0>>2];fkb(da,d,O,N,g,h,j,La,Ka+Ma|0);c[ca>>2]=c[da>>2];break};case 68:{ca=e;c[ha>>2]=c[ca>>2];c[ia>>2]=c[f>>2];c[L+0>>2]=c[ha+0>>2];c[K+0>>2]=c[ia+0>>2];fkb(ga,d,L,K,g,h,j,313040,313048|0);c[ca>>2]=c[ga>>2];break};case 120:{ca=c[(c[d>>2]|0)+20>>2]|0;c[xa>>2]=c[e>>2];c[ya>>2]=c[f>>2];c[s+0>>2]=c[xa+0>>2];c[r+0>>2]=c[ya+0>>2];Be[ca&63](b,d,s,r,g,h,j);i=l;return};case 82:{ca=e;c[sa>>2]=c[ca>>2];c[ta>>2]=c[f>>2];c[y+0>>2]=c[sa+0>>2];c[x+0>>2]=c[ta+0>>2];fkb(ra,d,y,x,g,h,j,313072,313077|0);c[ca>>2]=c[ra>>2];break};case 119:{c[T>>2]=c[f>>2];c[t+0>>2]=c[T+0>>2];ca=skb(e,t,h,Ia,1)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<7){c[j+24>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 88:{Da=d+8|0;ca=pe[c[(c[Da>>2]|0)+24>>2]&127](Da)|0;Da=e;c[Aa>>2]=c[Da>>2];c[Ba>>2]=c[f>>2];Ha=a[ca]|0;if((Ha&1)==0){Na=ca+1|0;Oa=ca+1|0;Pa=(Ha&255)>>>1}else{Ha=c[ca+8>>2]|0;Na=Ha;Oa=Ha;Pa=c[ca+4>>2]|0}c[q+0>>2]=c[Aa+0>>2];c[p+0>>2]=c[Ba+0>>2];fkb(za,d,q,p,g,h,j,Oa,Na+Pa|0);c[Da>>2]=c[za>>2];break};case 114:{Da=e;c[pa>>2]=c[Da>>2];c[qa>>2]=c[f>>2];c[A+0>>2]=c[pa+0>>2];c[z+0>>2]=c[qa+0>>2];fkb(oa,d,A,z,g,h,j,313056,313067|0);c[Da>>2]=c[oa>>2];break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}function pkb(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;j=e;e=f;f=h+8|0;a:while(1){h=c[j>>2]|0;do{if((h|0)==0){k=0}else{if((c[h+12>>2]|0)!=(c[h+16>>2]|0)){k=h;break}if((pe[c[(c[h>>2]|0)+36>>2]&127](h)|0)==-1){c[j>>2]=0;k=0;break}else{k=c[j>>2]|0;break}}}while(0);h=(k|0)==0;l=c[e>>2]|0;do{if((l|0)==0){m=12}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){if(h){n=l;break}else{o=l;break a}}if((pe[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1){c[e>>2]=0;m=12;break}else{if(h){n=l;break}else{o=l;break a}}}}while(0);if((m|0)==12){m=0;if(h){o=0;break}else{n=0}}l=c[j>>2]|0;p=c[l+12>>2]|0;if((p|0)==(c[l+16>>2]|0)){q=(pe[c[(c[l>>2]|0)+36>>2]&127](l)|0)&255}else{q=a[p]|0}if(!(q<<24>>24>-1)){o=n;break}if((b[(c[f>>2]|0)+(q<<24>>24<<1)>>1]&8192)==0){o=n;break}p=c[j>>2]|0;l=p+12|0;r=c[l>>2]|0;if((r|0)==(c[p+16>>2]|0)){pe[c[(c[p>>2]|0)+40>>2]&127](p)|0;continue}else{c[l>>2]=r+1;continue}}n=c[j>>2]|0;do{if((n|0)==0){s=0}else{if((c[n+12>>2]|0)!=(c[n+16>>2]|0)){s=n;break}if((pe[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1){c[j>>2]=0;s=0;break}else{s=c[j>>2]|0;break}}}while(0);j=(s|0)==0;b:do{if((o|0)==0){m=32}else{do{if((c[o+12>>2]|0)==(c[o+16>>2]|0)){if(!((pe[c[(c[o>>2]|0)+36>>2]&127](o)|0)==-1)){break}c[e>>2]=0;m=32;break b}}while(0);if(!j){break}i=d;return}}while(0);do{if((m|0)==32){if(j){break}i=d;return}}while(0);c[g>>2]=c[g>>2]|2;i=d;return}function qkb(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;l=j+8|0;m=b+8|0;b=pe[c[(c[m>>2]|0)+8>>2]&127](m)|0;m=a[b]|0;if((m&1)==0){n=(m&255)>>>1}else{n=c[b+4>>2]|0}m=a[b+12|0]|0;if((m&1)==0){o=(m&255)>>>1}else{o=c[b+16>>2]|0}if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];f=b+24|0;o=k;n=l;c[o+0>>2]=c[n+0>>2];n=Iib(e,k,b,f,h,g,0)|0;g=n-b|0;do{if((n|0)==(b|0)){if((c[d>>2]|0)!=12){break}c[d>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[d>>2]|0;if((g|0)>=12){i=j;return}c[d>>2]=g+12;i=j;return}function rkb(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;b=i;h=d;d=c[h>>2]|0;do{if((d|0)==0){j=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){j=d;break}if((pe[c[(c[d>>2]|0)+36>>2]&127](d)|0)==-1){c[h>>2]=0;j=0;break}else{j=c[h>>2]|0;break}}}while(0);d=(j|0)==0;j=e;e=c[j>>2]|0;a:do{if((e|0)==0){k=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if(!((pe[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){break}c[j>>2]=0;k=11;break a}}while(0);if(d){l=e}else{k=12}}}while(0);if((k|0)==11){if(d){k=12}else{l=0}}if((k|0)==12){c[f>>2]=c[f>>2]|6;i=b;return}d=c[h>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){m=(pe[c[(c[d>>2]|0)+36>>2]&127](d)|0)&255}else{m=a[e]|0}if(!((se[c[(c[g>>2]|0)+36>>2]&63](g,m,0)|0)<<24>>24==37)){c[f>>2]=c[f>>2]|4;i=b;return}m=c[h>>2]|0;g=m+12|0;e=c[g>>2]|0;if((e|0)==(c[m+16>>2]|0)){pe[c[(c[m>>2]|0)+40>>2]&127](m)|0}else{c[g>>2]=e+1}e=c[h>>2]|0;do{if((e|0)==0){n=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){n=e;break}if((pe[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[h>>2]=0;n=0;break}else{n=c[h>>2]|0;break}}}while(0);h=(n|0)==0;b:do{if((l|0)==0){k=31}else{do{if((c[l+12>>2]|0)==(c[l+16>>2]|0)){if(!((pe[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){break}c[j>>2]=0;k=31;break b}}while(0);if(!h){break}i=b;return}}while(0);do{if((k|0)==31){if(h){break}i=b;return}}while(0);c[f>>2]=c[f>>2]|2;i=b;return}function skb(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;j=i;k=d;d=c[k>>2]|0;do{if((d|0)==0){l=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){l=d;break}if((pe[c[(c[d>>2]|0)+36>>2]&127](d)|0)==-1){c[k>>2]=0;l=0;break}else{l=c[k>>2]|0;break}}}while(0);d=(l|0)==0;l=e;e=c[l>>2]|0;a:do{if((e|0)==0){m=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if(!((pe[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){break}c[l>>2]=0;m=11;break a}}while(0);if(d){n=e}else{m=12}}}while(0);if((m|0)==11){if(d){m=12}else{n=0}}if((m|0)==12){c[f>>2]=c[f>>2]|6;o=0;i=j;return o|0}d=c[k>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){p=(pe[c[(c[d>>2]|0)+36>>2]&127](d)|0)&255}else{p=a[e]|0}do{if(p<<24>>24>-1){e=g+8|0;if((b[(c[e>>2]|0)+(p<<24>>24<<1)>>1]&2048)==0){break}d=(se[c[(c[g>>2]|0)+36>>2]&63](g,p,0)|0)<<24>>24;q=c[k>>2]|0;r=q+12|0;s=c[r>>2]|0;if((s|0)==(c[q+16>>2]|0)){pe[c[(c[q>>2]|0)+40>>2]&127](q)|0;t=h;u=n;v=n;w=d}else{c[r>>2]=s+1;t=h;u=n;v=n;w=d}while(1){x=w+ -48|0;d=t+ -1|0;s=c[k>>2]|0;do{if((s|0)==0){y=0}else{if((c[s+12>>2]|0)!=(c[s+16>>2]|0)){y=s;break}if((pe[c[(c[s>>2]|0)+36>>2]&127](s)|0)==-1){c[k>>2]=0;y=0;break}else{y=c[k>>2]|0;break}}}while(0);s=(y|0)==0;do{if((v|0)==0){z=u;A=0}else{if((c[v+12>>2]|0)!=(c[v+16>>2]|0)){z=u;A=v;break}if(!((pe[c[(c[v>>2]|0)+36>>2]&127](v)|0)==-1)){z=u;A=u;break}c[l>>2]=0;z=0;A=0}}while(0);B=c[k>>2]|0;if(!((s^(A|0)==0)&(d|0)>0)){m=40;break}r=c[B+12>>2]|0;if((r|0)==(c[B+16>>2]|0)){C=(pe[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{C=a[r]|0}if(!(C<<24>>24>-1)){o=x;m=52;break}if((b[(c[e>>2]|0)+(C<<24>>24<<1)>>1]&2048)==0){o=x;m=52;break}r=((se[c[(c[g>>2]|0)+36>>2]&63](g,C,0)|0)<<24>>24)+(x*10|0)|0;q=c[k>>2]|0;D=q+12|0;E=c[D>>2]|0;if((E|0)==(c[q+16>>2]|0)){pe[c[(c[q>>2]|0)+40>>2]&127](q)|0;F=d;u=z;v=A;w=r;t=F;continue}else{c[D>>2]=E+1;F=d;u=z;v=A;w=r;t=F;continue}}if((m|0)==40){do{if((B|0)==0){G=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){G=B;break}if((pe[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[k>>2]=0;G=0;break}else{G=c[k>>2]|0;break}}}while(0);e=(G|0)==0;b:do{if((z|0)==0){m=50}else{do{if((c[z+12>>2]|0)==(c[z+16>>2]|0)){if(!((pe[c[(c[z>>2]|0)+36>>2]&127](z)|0)==-1)){break}c[l>>2]=0;m=50;break b}}while(0);if(e){o=x}else{break}i=j;return o|0}}while(0);do{if((m|0)==50){if(e){break}else{o=x}i=j;return o|0}}while(0);c[f>>2]=c[f>>2]|2;o=x;i=j;return o|0}else if((m|0)==52){i=j;return o|0}}}while(0);c[f>>2]=c[f>>2]|4;o=0;i=j;return o|0}function tkb(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;l=i;i=i+64|0;m=l;n=l+8|0;o=l+16|0;p=l+32|0;q=l+40|0;r=l+48|0;s=l+56|0;Ngb(p,f);t=p;p=c[t>>2]|0;if(!((c[78530]|0)==-1)){c[o>>2]=314120;c[o+4>>2]=1431;c[o+8>>2]=0;Cfb(314120,o,1432)}o=(c[314124>>2]|0)+ -1|0;u=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-u>>2>>>0>o>>>0)){v=Hc(4)|0;w=v;Bpb(w);x=329688;y=128;_d(v|0,x|0,y|0)}p=c[u+(o<<2)>>2]|0;if((p|0)==0){v=Hc(4)|0;w=v;Bpb(w);x=329688;y=128;_d(v|0,x|0,y|0)}y=p;hfb(c[t>>2]|0)|0;c[g>>2]=0;t=d;a:do{if((j|0)==(k|0)){z=69}else{x=e;v=r;w=s;o=q;u=j;A=0;b:while(1){B=A;while(1){if((B|0)!=0){z=69;break a}C=c[t>>2]|0;do{if((C|0)==0){D=0;E=1}else{F=c[C+12>>2]|0;if((F|0)==(c[C+16>>2]|0)){G=pe[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{G=c[F>>2]|0}if(!((G|0)==-1)){D=C;E=0;break}c[t>>2]=0;D=0;E=1}}while(0);C=c[x>>2]|0;do{if((C|0)==0){z=22}else{F=c[C+12>>2]|0;if((F|0)==(c[C+16>>2]|0)){H=pe[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{H=c[F>>2]|0}if((H|0)==-1){c[x>>2]=0;z=22;break}else{if(E){I=C;break}else{z=24;break b}}}}while(0);if((z|0)==22){z=0;if(E){z=24;break b}else{I=0}}if((se[c[(c[p>>2]|0)+52>>2]&63](y,c[u>>2]|0,0)|0)<<24>>24==37){z=26;break}if(se[c[(c[p>>2]|0)+12>>2]&63](y,8192,c[u>>2]|0)|0){J=u;z=36;break}K=D+12|0;C=c[K>>2]|0;L=D+16|0;if((C|0)==(c[L>>2]|0)){M=pe[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{M=c[C>>2]|0}C=Ee[c[(c[p>>2]|0)+28>>2]&63](y,M)|0;if((C|0)==(Ee[c[(c[p>>2]|0)+28>>2]&63](y,c[u>>2]|0)|0)){z=64;break}c[g>>2]=4;B=4}c:do{if((z|0)==26){z=0;B=u+4|0;if((B|0)==(k|0)){z=27;break b}C=se[c[(c[p>>2]|0)+52>>2]&63](y,c[B>>2]|0,0)|0;if(C<<24>>24==48|C<<24>>24==69){F=u+8|0;if((F|0)==(k|0)){z=30;break b}N=F;O=se[c[(c[p>>2]|0)+52>>2]&63](y,c[F>>2]|0,0)|0;P=C}else{N=B;O=C;P=0}C=c[(c[b>>2]|0)+36>>2]|0;c[v>>2]=D;c[w>>2]=I;B=n;F=r;c[B+0>>2]=c[F+0>>2];F=m;B=s;c[F+0>>2]=c[B+0>>2];De[C&3](q,b,n,m,f,g,h,O,P);c[t>>2]=c[o>>2];Q=N+4|0}else if((z|0)==36){while(1){z=0;C=J+4|0;if((C|0)==(k|0)){R=k;break}if(se[c[(c[p>>2]|0)+12>>2]&63](y,8192,c[C>>2]|0)|0){J=C;z=36}else{R=C;break}}C=D;B=I;F=I;while(1){do{if((C|0)==0){S=0;T=1}else{U=c[C+12>>2]|0;if((U|0)==(c[C+16>>2]|0)){V=pe[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{V=c[U>>2]|0}if(!((V|0)==-1)){S=C;T=0;break}c[t>>2]=0;S=0;T=1}}while(0);do{if((F|0)==0){W=B;z=51}else{U=c[F+12>>2]|0;if((U|0)==(c[F+16>>2]|0)){X=pe[c[(c[F>>2]|0)+36>>2]&127](F)|0}else{X=c[U>>2]|0}if((X|0)==-1){c[x>>2]=0;W=0;z=51;break}else{if(T^(B|0)==0){Y=B;Z=B;break}else{Q=R;break c}}}}while(0);if((z|0)==51){z=0;if(T){Q=R;break c}else{Y=W;Z=0}}U=S+12|0;_=c[U>>2]|0;$=S+16|0;if((_|0)==(c[$>>2]|0)){aa=pe[c[(c[S>>2]|0)+36>>2]&127](S)|0}else{aa=c[_>>2]|0}if(!(se[c[(c[p>>2]|0)+12>>2]&63](y,8192,aa)|0)){Q=R;break c}_=c[U>>2]|0;if((_|0)==(c[$>>2]|0)){pe[c[(c[S>>2]|0)+40>>2]&127](S)|0;C=S;B=Y;F=Z;continue}else{c[U>>2]=_+4;C=S;B=Y;F=Z;continue}}}else if((z|0)==64){z=0;F=c[K>>2]|0;if((F|0)==(c[L>>2]|0)){pe[c[(c[D>>2]|0)+40>>2]&127](D)|0}else{c[K>>2]=F+4}Q=u+4|0}}while(0);if((Q|0)==(k|0)){z=69;break a}u=Q;A=c[g>>2]|0}if((z|0)==24){c[g>>2]=4;ba=D;break}else if((z|0)==27){c[g>>2]=4;ba=D;break}else if((z|0)==30){c[g>>2]=4;ba=D;break}}}while(0);if((z|0)==69){ba=c[t>>2]|0}t=d;do{if((ba|0)==0){ca=0;da=1}else{d=c[ba+12>>2]|0;if((d|0)==(c[ba+16>>2]|0)){ea=pe[c[(c[ba>>2]|0)+36>>2]&127](ba)|0}else{ea=c[d>>2]|0}if(!((ea|0)==-1)){ca=ba;da=0;break}c[t>>2]=0;ca=0;da=1}}while(0);t=e;e=c[t>>2]|0;do{if((e|0)==0){z=82}else{ba=c[e+12>>2]|0;if((ba|0)==(c[e+16>>2]|0)){fa=pe[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{fa=c[ba>>2]|0}if((fa|0)==-1){c[t>>2]=0;z=82;break}if(!da){break}ga=a;ha=ga;c[ha>>2]=ca;i=l;return}}while(0);do{if((z|0)==82){if(da){break}ga=a;ha=ga;c[ha>>2]=ca;i=l;return}}while(0);c[g>>2]=c[g>>2]|2;ga=a;ha=ga;c[ha>>2]=ca;i=l;return}function ukb(a){a=a|0;var b=0;b=i;cqb(a);i=b;return}function vkb(a){a=a|0;i=i;return}function wkb(a){a=a|0;i=i;return 2}function xkb(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];e=l;d=m;c[e+0>>2]=c[d+0>>2];d=k;e=n;c[d+0>>2]=c[e+0>>2];tkb(a,b,l,k,f,g,h,313184,313216|0);i=j;return}function ykb(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=d+8|0;q=pe[c[(c[p>>2]|0)+20>>2]&127](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q]|0;if((f&1)==0){r=q+4|0;s=q+4|0;t=(f&255)>>>1}else{f=c[q+8>>2]|0;r=f;s=f;t=c[q+4>>2]|0}q=r+(t<<2)|0;t=m;r=n;c[t+0>>2]=c[r+0>>2];r=l;t=o;c[r+0>>2]=c[t+0>>2];tkb(b,d,m,l,g,h,j,s,q);i=k;return}function zkb(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;Ngb(n,f);f=n;n=c[f>>2]|0;if(!((c[78530]|0)==-1)){c[m>>2]=314120;c[m+4>>2]=1431;c[m+8>>2]=0;Cfb(314120,m,1432)}m=(c[314124>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Hc(4)|0;q=p;Bpb(q);r=329688;s=128;_d(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Hc(4)|0;q=p;Bpb(q);r=329688;s=128;_d(p|0,r|0,s|0)}s=n;hfb(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=pe[c[c[e>>2]>>2]&127](e)|0;c[l>>2]=f;f=b+168|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=fjb(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=168){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+24>>2]=((g|0)/12|0|0)%7|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function Akb(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;Ngb(n,f);f=n;n=c[f>>2]|0;if(!((c[78530]|0)==-1)){c[m>>2]=314120;c[m+4>>2]=1431;c[m+8>>2]=0;Cfb(314120,m,1432)}m=(c[314124>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Hc(4)|0;q=p;Bpb(q);r=329688;s=128;_d(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Hc(4)|0;q=p;Bpb(q);r=329688;s=128;_d(p|0,r|0,s|0)}s=n;hfb(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=pe[c[(c[e>>2]|0)+4>>2]&127](e)|0;c[l>>2]=f;f=b+288|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=fjb(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=288){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+16>>2]=((g|0)/12|0|0)%12|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function Bkb(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+40|0;j=b;k=b+8|0;l=b+16|0;m=b+32|0;Ngb(m,f);f=m;m=c[f>>2]|0;if(!((c[78530]|0)==-1)){c[l>>2]=314120;c[l+4>>2]=1431;c[l+8>>2]=0;Cfb(314120,l,1432)}l=(c[314124>>2]|0)+ -1|0;n=c[m+8>>2]|0;if(!((c[m+12>>2]|0)-n>>2>>>0>l>>>0)){o=Hc(4)|0;p=o;Bpb(p);q=329688;r=128;_d(o|0,q|0,r|0)}m=c[n+(l<<2)>>2]|0;if((m|0)==0){o=Hc(4)|0;p=o;Bpb(p);q=329688;r=128;_d(o|0,q|0,r|0)}r=m;hfb(c[f>>2]|0)|0;f=h+20|0;c[k>>2]=c[e>>2];e=j;h=k;c[e+0>>2]=c[h+0>>2];h=Gkb(d,j,g,r,4)|0;if((c[g>>2]&4|0)!=0){s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}if((h|0)<69){x=h+2e3|0}else{x=(h+ -69|0)>>>0<31?h+1900|0:h}c[f>>2]=x+ -1900;s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}function Ckb(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;l=i;i=i+576|0;m=l;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+104|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;M=l+208|0;N=l+216|0;O=l+224|0;P=l+232|0;Q=l+240|0;R=l+248|0;S=l+256|0;T=l+264|0;U=l+272|0;V=l+280|0;W=l+288|0;X=l+296|0;Y=l+304|0;Z=l+312|0;_=l+320|0;$=l+328|0;aa=l+336|0;ba=l+344|0;ca=l+360|0;da=l+368|0;ea=l+376|0;fa=l+384|0;ga=l+392|0;ha=l+400|0;ia=l+408|0;ja=l+416|0;ka=l+424|0;la=l+432|0;ma=l+440|0;na=l+448|0;oa=l+456|0;pa=l+464|0;qa=l+472|0;ra=l+480|0;sa=l+488|0;ta=l+496|0;ua=l+504|0;va=l+512|0;wa=l+520|0;xa=l+528|0;ya=l+536|0;za=l+544|0;Aa=l+552|0;Ba=l+560|0;Ca=l+568|0;c[h>>2]=0;Ngb(ca,g);Da=ca;ca=c[Da>>2]|0;if(!((c[78530]|0)==-1)){c[ba>>2]=314120;c[ba+4>>2]=1431;c[ba+8>>2]=0;Cfb(314120,ba,1432)}ba=(c[314124>>2]|0)+ -1|0;Ea=c[ca+8>>2]|0;if(!((c[ca+12>>2]|0)-Ea>>2>>>0>ba>>>0)){Fa=Hc(4)|0;Ga=Fa;Bpb(Ga);Ha=329688;Ia=128;_d(Fa|0,Ha|0,Ia|0)}ca=c[Ea+(ba<<2)>>2]|0;if((ca|0)==0){Fa=Hc(4)|0;Ga=Fa;Bpb(Ga);Ha=329688;Ia=128;_d(Fa|0,Ha|0,Ia|0)}Ia=ca;hfb(c[Da>>2]|0)|0;a:do{switch(k<<24>>24|0){case 82:{Da=e;c[sa>>2]=c[Da>>2];c[ta>>2]=c[f>>2];c[y+0>>2]=c[sa+0>>2];c[x+0>>2]=c[ta+0>>2];tkb(ra,d,y,x,g,h,j,313328,313348|0);c[Da>>2]=c[ra>>2];break};case 101:case 100:{Da=j+12|0;c[_>>2]=c[f>>2];c[M+0>>2]=c[_+0>>2];ca=Gkb(e,M,h,Ia,2)|0;Ha=c[h>>2]|0;do{if((Ha&4|0)==0){if(!((ca+ -1|0)>>>0<31)){break}c[Da>>2]=ca;break a}}while(0);c[h>>2]=Ha|4;break};case 73:{ca=j+8|0;c[Y>>2]=c[f>>2];c[G+0>>2]=c[Y+0>>2];Da=Gkb(e,G,h,Ia,2)|0;Fa=c[h>>2]|0;do{if((Fa&4|0)==0){if(!((Da+ -1|0)>>>0<12)){break}c[ca>>2]=Da;break a}}while(0);c[h>>2]=Fa|4;break};case 116:case 110:{c[ma>>2]=c[f>>2];c[C+0>>2]=c[ma+0>>2];Dkb(0,e,C,h,Ia);break};case 109:{c[W>>2]=c[f>>2];c[E+0>>2]=c[W+0>>2];Da=Gkb(e,E,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<13){c[j+16>>2]=Da+ -1;break a}else{c[h>>2]=ca|4;break a}break};case 89:{c[R>>2]=c[f>>2];c[n+0>>2]=c[R+0>>2];ca=Gkb(e,n,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}c[j+20>>2]=ca+ -1900;break};case 37:{c[Ca>>2]=c[f>>2];c[m+0>>2]=c[Ca+0>>2];Fkb(0,e,m,h,Ia);break};case 84:{ca=e;c[va>>2]=c[ca>>2];c[wa>>2]=c[f>>2];c[v+0>>2]=c[va+0>>2];c[u+0>>2]=c[wa+0>>2];tkb(ua,d,v,u,g,h,j,313352,313384|0);c[ca>>2]=c[ua>>2];break};case 70:{ca=e;c[ka>>2]=c[ca>>2];c[la>>2]=c[f>>2];c[J+0>>2]=c[ka+0>>2];c[I+0>>2]=c[la+0>>2];tkb(ja,d,J,I,g,h,j,313248,313280|0);c[ca>>2]=c[ja>>2];break};case 104:case 66:case 98:{ca=c[f>>2]|0;Da=d+8|0;Ha=pe[c[(c[Da>>2]|0)+4>>2]&127](Da)|0;c[$>>2]=ca;c[P+0>>2]=c[$+0>>2];ca=(fjb(e,P,Ha,Ha+288|0,Ia,h,0)|0)-Ha|0;if((ca|0)>=288){break a}c[j+16>>2]=((ca|0)/12|0|0)%12|0;break};case 65:case 97:{ca=c[f>>2]|0;Ha=d+8|0;Da=pe[c[c[Ha>>2]>>2]&127](Ha)|0;c[aa>>2]=ca;c[Q+0>>2]=c[aa+0>>2];ca=(fjb(e,Q,Da,Da+168|0,Ia,h,0)|0)-Da|0;if((ca|0)>=168){break a}c[j+24>>2]=((ca|0)/12|0|0)%7|0;break};case 121:{c[S>>2]=c[f>>2];c[o+0>>2]=c[S+0>>2];ca=Gkb(e,o,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}if((ca|0)<69){Ja=ca+2e3|0}else{Ja=(ca+ -69|0)>>>0<31?ca+1900|0:ca}c[j+20>>2]=Ja+ -1900;break};case 106:{c[X>>2]=c[f>>2];c[F+0>>2]=c[X+0>>2];ca=Gkb(e,F,h,Ia,3)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<366){c[j+28>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 83:{c[U>>2]=c[f>>2];c[w+0>>2]=c[U+0>>2];Da=Gkb(e,w,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<61){c[j>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 72:{c[Z>>2]=c[f>>2];c[H+0>>2]=c[Z+0>>2];ca=Gkb(e,H,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<24){c[j+8>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 77:{c[V>>2]=c[f>>2];c[D+0>>2]=c[V+0>>2];Da=Gkb(e,D,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<60){c[j+4>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 99:{ca=d+8|0;Da=pe[c[(c[ca>>2]|0)+12>>2]&127](ca)|0;ca=e;c[ea>>2]=c[ca>>2];c[fa>>2]=c[f>>2];Ha=a[Da]|0;if((Ha&1)==0){Ka=Da+4|0;La=Da+4|0;Ma=(Ha&255)>>>1}else{Ha=c[Da+8>>2]|0;Ka=Ha;La=Ha;Ma=c[Da+4>>2]|0}c[O+0>>2]=c[ea+0>>2];c[N+0>>2]=c[fa+0>>2];tkb(da,d,O,N,g,h,j,La,Ka+(Ma<<2)|0);c[ca>>2]=c[da>>2];break};case 68:{ca=e;c[ha>>2]=c[ca>>2];c[ia>>2]=c[f>>2];c[L+0>>2]=c[ha+0>>2];c[K+0>>2]=c[ia+0>>2];tkb(ga,d,L,K,g,h,j,313216,313248|0);c[ca>>2]=c[ga>>2];break};case 120:{ca=c[(c[d>>2]|0)+20>>2]|0;c[xa>>2]=c[e>>2];c[ya>>2]=c[f>>2];c[s+0>>2]=c[xa+0>>2];c[r+0>>2]=c[ya+0>>2];Be[ca&63](b,d,s,r,g,h,j);i=l;return};case 119:{c[T>>2]=c[f>>2];c[t+0>>2]=c[T+0>>2];ca=Gkb(e,t,h,Ia,1)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<7){c[j+24>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 88:{Da=d+8|0;ca=pe[c[(c[Da>>2]|0)+24>>2]&127](Da)|0;Da=e;c[Aa>>2]=c[Da>>2];c[Ba>>2]=c[f>>2];Ha=a[ca]|0;if((Ha&1)==0){Na=ca+4|0;Oa=ca+4|0;Pa=(Ha&255)>>>1}else{Ha=c[ca+8>>2]|0;Na=Ha;Oa=Ha;Pa=c[ca+4>>2]|0}c[q+0>>2]=c[Aa+0>>2];c[p+0>>2]=c[Ba+0>>2];tkb(za,d,q,p,g,h,j,Oa,Na+(Pa<<2)|0);c[Da>>2]=c[za>>2];break};case 114:{Da=e;c[pa>>2]=c[Da>>2];c[qa>>2]=c[f>>2];c[A+0>>2]=c[pa+0>>2];c[z+0>>2]=c[qa+0>>2];tkb(oa,d,A,z,g,h,j,313280,313324|0);c[Da>>2]=c[oa>>2];break};case 112:{c[na>>2]=c[f>>2];c[B+0>>2]=c[na+0>>2];Ekb(d,j+8|0,e,B,h,Ia);break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}function Dkb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;a=i;g=b;b=d;a:while(1){d=c[g>>2]|0;do{if((d|0)==0){h=1}else{j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){k=pe[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);d=c[b>>2]|0;do{if((d|0)==0){l=15}else{j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){m=pe[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{m=c[j>>2]|0}if((m|0)==-1){c[b>>2]=0;l=15;break}else{if(h){n=d;break}else{o=d;break a}}}}while(0);if((l|0)==15){l=0;if(h){o=0;break}else{n=0}}d=c[g>>2]|0;j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){p=pe[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{p=c[j>>2]|0}if(!(se[c[(c[f>>2]|0)+12>>2]&63](f,8192,p)|0)){o=n;break}j=c[g>>2]|0;d=j+12|0;q=c[d>>2]|0;if((q|0)==(c[j+16>>2]|0)){pe[c[(c[j>>2]|0)+40>>2]&127](j)|0;continue}else{c[d>>2]=q+4;continue}}n=c[g>>2]|0;do{if((n|0)==0){r=1}else{p=c[n+12>>2]|0;if((p|0)==(c[n+16>>2]|0)){s=pe[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{s=c[p>>2]|0}if((s|0)==-1){c[g>>2]=0;r=1;break}else{r=(c[g>>2]|0)==0;break}}}while(0);do{if((o|0)==0){l=37}else{g=c[o+12>>2]|0;if((g|0)==(c[o+16>>2]|0)){t=pe[c[(c[o>>2]|0)+36>>2]&127](o)|0}else{t=c[g>>2]|0}if((t|0)==-1){c[b>>2]=0;l=37;break}if(!r){break}i=a;return}}while(0);do{if((l|0)==37){if(r){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function Ekb(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;l=j+8|0;m=b+8|0;b=pe[c[(c[m>>2]|0)+8>>2]&127](m)|0;m=a[b]|0;if((m&1)==0){n=(m&255)>>>1}else{n=c[b+4>>2]|0}m=a[b+12|0]|0;if((m&1)==0){o=(m&255)>>>1}else{o=c[b+16>>2]|0}if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];f=b+24|0;o=k;n=l;c[o+0>>2]=c[n+0>>2];n=fjb(e,k,b,f,h,g,0)|0;g=n-b|0;do{if((n|0)==(b|0)){if((c[d>>2]|0)!=12){break}c[d>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[d>>2]|0;if((g|0)>=12){i=j;return}c[d>>2]=g+12;i=j;return}function Fkb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a=i;g=b;b=c[g>>2]|0;do{if((b|0)==0){h=1}else{j=c[b+12>>2]|0;if((j|0)==(c[b+16>>2]|0)){k=pe[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);k=d;d=c[k>>2]|0;do{if((d|0)==0){l=14}else{b=c[d+12>>2]|0;if((b|0)==(c[d+16>>2]|0)){m=pe[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{m=c[b>>2]|0}if((m|0)==-1){c[k>>2]=0;l=14;break}else{if(h){n=d;break}else{l=16;break}}}}while(0);if((l|0)==14){if(h){l=16}else{n=0}}if((l|0)==16){c[e>>2]=c[e>>2]|6;i=a;return}h=c[g>>2]|0;d=c[h+12>>2]|0;if((d|0)==(c[h+16>>2]|0)){o=pe[c[(c[h>>2]|0)+36>>2]&127](h)|0}else{o=c[d>>2]|0}if(!((se[c[(c[f>>2]|0)+52>>2]&63](f,o,0)|0)<<24>>24==37)){c[e>>2]=c[e>>2]|4;i=a;return}o=c[g>>2]|0;f=o+12|0;d=c[f>>2]|0;if((d|0)==(c[o+16>>2]|0)){pe[c[(c[o>>2]|0)+40>>2]&127](o)|0}else{c[f>>2]=d+4}d=c[g>>2]|0;do{if((d|0)==0){p=1}else{f=c[d+12>>2]|0;if((f|0)==(c[d+16>>2]|0)){q=pe[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{q=c[f>>2]|0}if((q|0)==-1){c[g>>2]=0;p=1;break}else{p=(c[g>>2]|0)==0;break}}}while(0);do{if((n|0)==0){l=38}else{g=c[n+12>>2]|0;if((g|0)==(c[n+16>>2]|0)){r=pe[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{r=c[g>>2]|0}if((r|0)==-1){c[k>>2]=0;l=38;break}if(!p){break}i=a;return}}while(0);do{if((l|0)==38){if(p){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function Gkb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=i;h=a;a=c[h>>2]|0;do{if((a|0)==0){j=1}else{k=c[a+12>>2]|0;if((k|0)==(c[a+16>>2]|0)){l=pe[c[(c[a>>2]|0)+36>>2]&127](a)|0}else{l=c[k>>2]|0}if((l|0)==-1){c[h>>2]=0;j=1;break}else{j=(c[h>>2]|0)==0;break}}}while(0);l=b;b=c[l>>2]|0;do{if((b|0)==0){m=14}else{a=c[b+12>>2]|0;if((a|0)==(c[b+16>>2]|0)){n=pe[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{n=c[a>>2]|0}if((n|0)==-1){c[l>>2]=0;m=14;break}else{if(j){o=b;break}else{m=16;break}}}}while(0);if((m|0)==14){if(j){m=16}else{o=0}}if((m|0)==16){c[d>>2]=c[d>>2]|6;p=0;i=g;return p|0}j=c[h>>2]|0;b=c[j+12>>2]|0;if((b|0)==(c[j+16>>2]|0)){q=pe[c[(c[j>>2]|0)+36>>2]&127](j)|0}else{q=c[b>>2]|0}if(!(se[c[(c[e>>2]|0)+12>>2]&63](e,2048,q)|0)){c[d>>2]=c[d>>2]|4;p=0;i=g;return p|0}b=(se[c[(c[e>>2]|0)+52>>2]&63](e,q,0)|0)<<24>>24;q=c[h>>2]|0;j=q+12|0;n=c[j>>2]|0;if((n|0)==(c[q+16>>2]|0)){pe[c[(c[q>>2]|0)+40>>2]&127](q)|0;r=f;s=o;t=o;u=b}else{c[j>>2]=n+4;r=f;s=o;t=o;u=b}while(1){v=u+ -48|0;b=r+ -1|0;o=c[h>>2]|0;do{if((o|0)==0){w=1}else{f=c[o+12>>2]|0;if((f|0)==(c[o+16>>2]|0)){x=pe[c[(c[o>>2]|0)+36>>2]&127](o)|0}else{x=c[f>>2]|0}if((x|0)==-1){c[h>>2]=0;w=1;break}else{w=(c[h>>2]|0)==0;break}}}while(0);do{if((t|0)==0){y=s;z=0;A=1}else{o=c[t+12>>2]|0;if((o|0)==(c[t+16>>2]|0)){B=pe[c[(c[t>>2]|0)+36>>2]&127](t)|0}else{B=c[o>>2]|0}if((B|0)==-1){c[l>>2]=0;y=0;z=0;A=1;break}else{y=s;z=s;A=(s|0)==0;break}}}while(0);C=c[h>>2]|0;if(!((w^A)&(b|0)>0)){break}o=c[C+12>>2]|0;if((o|0)==(c[C+16>>2]|0)){D=pe[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{D=c[o>>2]|0}if(!(se[c[(c[e>>2]|0)+12>>2]&63](e,2048,D)|0)){p=v;m=63;break}o=((se[c[(c[e>>2]|0)+52>>2]&63](e,D,0)|0)<<24>>24)+(v*10|0)|0;f=c[h>>2]|0;n=f+12|0;j=c[n>>2]|0;if((j|0)==(c[f+16>>2]|0)){pe[c[(c[f>>2]|0)+40>>2]&127](f)|0;E=b;s=y;t=z;u=o;r=E;continue}else{c[n>>2]=j+4;E=b;s=y;t=z;u=o;r=E;continue}}if((m|0)==63){i=g;return p|0}do{if((C|0)==0){F=1}else{E=c[C+12>>2]|0;if((E|0)==(c[C+16>>2]|0)){G=pe[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{G=c[E>>2]|0}if((G|0)==-1){c[h>>2]=0;F=1;break}else{F=(c[h>>2]|0)==0;break}}}while(0);do{if((y|0)==0){m=60}else{h=c[y+12>>2]|0;if((h|0)==(c[y+16>>2]|0)){H=pe[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{H=c[h>>2]|0}if((H|0)==-1){c[l>>2]=0;m=60;break}if(F){p=v}else{break}i=g;return p|0}}while(0);do{if((m|0)==60){if(F){break}else{p=v}i=g;return p|0}}while(0);c[d>>2]=c[d>>2]|2;p=v;i=g;return p|0}function Hkb(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[e>>2]|0;do{if((a[314024]|0)==0){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);if((f|0)==(c[78504]|0)){g=b;cqb(g);i=d;return}ec(c[e>>2]|0);g=b;cqb(g);i=d;return}function Ikb(b){b=b|0;var d=0,e=0;d=i;e=b+8|0;b=c[e>>2]|0;do{if((a[314024]|0)==0){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);if((b|0)==(c[78504]|0)){i=d;return}ec(c[e>>2]|0);i=d;return}function Jkb(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=i;i=i+112|0;f=g;l=g+8|0;m=l;n=f;a[n]=37;o=f+1|0;a[o]=j;p=f+2|0;a[p]=k;a[f+3|0]=0;if(!(k<<24>>24==0)){a[o]=k;a[p]=j}j=Vc(m|0,100,n|0,h|0,c[d+8>>2]|0)|0;d=l+j|0;l=c[e>>2]|0;if((j|0)==0){q=l;r=b;s=r;c[s>>2]=q;i=g;return}else{t=m;u=l;v=l}while(1){l=a[t]|0;do{if((v|0)==0){w=u;x=0}else{m=v+24|0;j=c[m>>2]|0;if((j|0)==(c[v+28>>2]|0)){e=(Ee[c[(c[v>>2]|0)+52>>2]&63](v,l&255)|0)==-1;w=e?0:u;x=e?0:v;break}else{c[m>>2]=j+1;a[j]=l;w=u;x=v;break}}}while(0);l=t+1|0;if((l|0)==(d|0)){q=w;break}else{t=l;u=w;v=x}}r=b;s=r;c[s>>2]=q;i=g;return}function Kkb(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[e>>2]|0;do{if((a[314024]|0)==0){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);if((f|0)==(c[78504]|0)){g=b;cqb(g);i=d;return}ec(c[e>>2]|0);g=b;cqb(g);i=d;return}function Lkb(b){b=b|0;var d=0,e=0;d=i;e=b+8|0;b=c[e>>2]|0;do{if((a[314024]|0)==0){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);if((b|0)==(c[78504]|0)){i=d;return}ec(c[e>>2]|0);i=d;return}function Mkb(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+408|0;e=f;k=f+400|0;l=e;c[k>>2]=e+400;Nkb(b+8|0,l,k,g,h,j);j=c[k>>2]|0;k=c[d>>2]|0;if((l|0)==(j|0)){m=k;n=a;o=n;c[o>>2]=m;i=f;return}else{p=l;q=k;r=k}while(1){k=c[p>>2]|0;if((q|0)==0){s=r;t=0}else{l=q+24|0;d=c[l>>2]|0;if((d|0)==(c[q+28>>2]|0)){u=Ee[c[(c[q>>2]|0)+52>>2]&63](q,k)|0}else{c[l>>2]=d+4;c[d>>2]=k;u=k}k=(u|0)==-1;s=k?0:r;t=k?0:q}k=p+4|0;if((k|0)==(j|0)){m=s;break}else{p=k;q=t;r=s}}n=a;o=n;c[o>>2]=m;i=f;return}function Nkb(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+120|0;k=j;l=j+112|0;m=i;i=i+8|0;n=j+8|0;o=k;a[o]=37;p=k+1|0;a[p]=g;q=k+2|0;a[q]=h;a[k+3|0]=0;if(!(h<<24>>24==0)){a[p]=h;a[q]=g}g=b;Vc(n|0,100,o|0,f|0,c[g>>2]|0)|0;f=l;c[f>>2]=0;c[f+4>>2]=0;c[m>>2]=n;n=(c[e>>2]|0)-d>>2;f=Oc(c[g>>2]|0)|0;g=Zob(d,m,n,l)|0;if((f|0)!=0){Oc(f|0)|0}if((g|0)==-1){Jlb(315008)}else{c[e>>2]=d+(g<<2);i=j;return}}function Okb(a){a=a|0;var b=0;b=i;cqb(a);i=b;return}function Pkb(a){a=a|0;i=i;return}function Qkb(a){a=a|0;i=i;return 127}function Rkb(a){a=a|0;i=i;return 127}function Skb(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function Tkb(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function Ukb(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function Vkb(a,b){a=a|0;b=b|0;b=i;Nfb(a,1,45);i=b;return}function Wkb(a){a=a|0;i=i;return 0}function Xkb(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function Ykb(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function Zkb(a){a=a|0;var b=0;b=i;cqb(a);i=b;return}function _kb(a){a=a|0;i=i;return}function $kb(a){a=a|0;i=i;return 127}function alb(a){a=a|0;i=i;return 127}function blb(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function clb(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function dlb(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function elb(a,b){a=a|0;b=b|0;b=i;Nfb(a,1,45);i=b;return}function flb(a){a=a|0;i=i;return 0}function glb(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function hlb(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function ilb(a){a=a|0;var b=0;b=i;cqb(a);i=b;return}function jlb(a){a=a|0;i=i;return}function klb(a){a=a|0;i=i;return 2147483647}function llb(a){a=a|0;i=i;return 2147483647}function mlb(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function nlb(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function olb(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function plb(a,b){a=a|0;b=b|0;b=i;sgb(a,1,45);i=b;return}function qlb(a){a=a|0;i=i;return 0}function rlb(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function slb(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function tlb(a){a=a|0;var b=0;b=i;cqb(a);i=b;return}function ulb(a){a=a|0;i=i;return}function vlb(a){a=a|0;i=i;return 2147483647}function wlb(a){a=a|0;i=i;return 2147483647}function xlb(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function ylb(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function zlb(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function Alb(a,b){a=a|0;b=b|0;b=i;sgb(a,1,45);i=b;return}function Blb(a){a=a|0;i=i;return 0}function Clb(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function Dlb(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function Elb(a){a=a|0;var b=0;b=i;cqb(a);i=b;return}function Flb(a){a=a|0;i=i;return}function Glb(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+104|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+104|0;w=p;c[w>>2]=o;x=p+4|0;c[x>>2]=1433;y=o+100|0;Ngb(r,h);o=r;z=c[o>>2]|0;if(!((c[78532]|0)==-1)){c[n>>2]=314128;c[n+4>>2]=1431;c[n+8>>2]=0;Cfb(314128,n,1432)}n=(c[314132>>2]|0)+ -1|0;A=c[z+8>>2]|0;if(!((c[z+12>>2]|0)-A>>2>>>0>n>>>0)){B=Hc(4)|0;C=B;Bpb(C);D=329688;E=128;_d(B|0,D|0,E|0)}z=c[A+(n<<2)>>2]|0;if((z|0)==0){B=Hc(4)|0;C=B;Bpb(C);D=329688;E=128;_d(B|0,D|0,E|0)}E=z;a[s]=0;D=f;c[t>>2]=c[D>>2];f=c[h+4>>2]|0;h=l;B=t;c[h+0>>2]=c[B+0>>2];B=Ilb(e,l,g,r,f,j,s,E,p,q,y)|0;do{if(B){y=u;Oe[c[(c[z>>2]|0)+32>>2]&63](E,313744,313754|0,y)|0;p=v;f=c[q>>2]|0;r=c[w>>2]|0;g=f-r|0;do{if((g|0)>98){l=Wpb(g+2|0)|0;if((l|0)!=0){F=l;G=l;break}hqb()}else{F=0;G=p}}while(0);if((a[s]|0)==0){H=G}else{a[G]=45;H=G+1|0}if(r>>>0<f>>>0){g=u+10|0;l=u;h=H;t=r;while(1){C=a[t]|0;n=y;while(1){A=n+1|0;if((a[n]|0)==C<<24>>24){I=n;break}if((A|0)==(g|0)){I=g;break}else{n=A}}a[h]=a[313744+(I-l)|0]|0;n=t+1|0;C=h+1|0;if(n>>>0<(c[q>>2]|0)>>>0){h=C;t=n}else{J=C;break}}}else{J=H}a[J]=0;c[m>>2]=k;if((Ed(p|0,313760,m|0)|0)!=1){t=Hc(8)|0;nfb(t,313768);_d(t|0,311120,43)}if((F|0)==0){break}Xpb(F)}}while(0);F=e;e=c[F>>2]|0;do{if((e|0)==0){K=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){K=e;break}if(!((pe[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){K=e;break}c[F>>2]=0;K=0}}while(0);F=(K|0)==0;e=c[D>>2]|0;do{if((e|0)==0){L=31}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){if(F){break}else{L=33;break}}if((pe[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[D>>2]=0;L=31;break}else{if(F){break}else{L=33;break}}}}while(0);if((L|0)==31){if(F){L=33}}if((L|0)==33){c[j>>2]=c[j>>2]|2}c[b>>2]=K;hfb(c[o>>2]|0)|0;o=c[w>>2]|0;c[w>>2]=0;if((o|0)==0){i=d;return}me[c[x>>2]&2047](o);i=d;return}function Hlb(a){a=a|0;i=i;return}function Ilb(e,f,g,h,j,k,l,m,n,o,p){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0;q=i;i=i+408|0;r=q;s=q+400|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;D=r;c[s>>2]=0;E=w;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=x;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=y;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=z;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=A;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;Mlb(g,h,t,u,v,w,x,y,z,B);t=n;c[o>>2]=c[t>>2];h=e;e=f;f=m+8|0;m=z+1|0;g=z+4|0;E=z+8|0;F=y+1|0;G=y+4|0;H=y+8|0;I=(j&512|0)!=0;j=x+1|0;J=x+8|0;K=x+4|0;L=A+1|0;M=A+8|0;N=A+4|0;O=s+3|0;P=n+4|0;n=w+4|0;Q=r+400|0;r=D;R=D;D=p;p=0;S=0;T=1433;a:while(1){U=c[h>>2]|0;do{if((U|0)==0){V=0}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){V=U;break}if((pe[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[h>>2]=0;V=0;break}else{V=c[h>>2]|0;break}}}while(0);U=(V|0)==0;W=c[e>>2]|0;do{if((W|0)==0){X=12}else{if((c[W+12>>2]|0)!=(c[W+16>>2]|0)){if(U){Y=W;break}else{Z=R;_=r;$=S;aa=T;X=269;break a}}if((pe[c[(c[W>>2]|0)+36>>2]&127](W)|0)==-1){c[e>>2]=0;X=12;break}else{if(U){Y=W;break}else{Z=R;_=r;$=S;aa=T;X=269;break a}}}}while(0);if((X|0)==12){X=0;if(U){Z=R;_=r;$=S;aa=T;X=269;break}else{Y=0}}b:do{switch(a[s+p|0]|0){case 2:{if(!((S|0)!=0|p>>>0<2)){if((p|0)==2){ba=(a[O]|0)!=0}else{ba=0}if(!(I|ba)){ca=D;da=R;ea=r;fa=Q;ga=0;ha=T;break b}}W=a[x]|0;ia=(W&1)==0;ja=ia?j:c[J>>2]|0;c:do{if((p|0)==0){ka=Y;la=Y;ma=W;na=ja}else{if((d[s+(p+ -1)|0]|0)>=2){ka=Y;la=Y;ma=W;na=ja;break}oa=ja+(ia?(W&255)>>>1:c[K>>2]|0)|0;pa=ja;while(1){if((pa|0)==(oa|0)){qa=oa;break}ra=a[pa]|0;if(!(ra<<24>>24>-1)){qa=pa;break}if((b[(c[f>>2]|0)+(ra<<24>>24<<1)>>1]&8192)==0){qa=pa;break}else{pa=pa+1|0}}pa=qa-ja|0;oa=a[A]|0;ra=(oa&1)==0;if(ra){sa=(oa&255)>>>1}else{sa=c[N>>2]|0}if(pa>>>0>sa>>>0){ka=Y;la=Y;ma=W;na=ja;break}if(ra){ra=(oa&255)>>>1;ta=A+1+(ra-pa)|0;ua=L;va=ra}else{ra=c[M>>2]|0;oa=c[N>>2]|0;ta=ra+(oa-pa)|0;ua=ra;va=oa}oa=ua+va|0;if((ta|0)==(oa|0)){ka=Y;la=Y;ma=W;na=qa;break}else{wa=ja;xa=ta}while(1){if((a[xa]|0)!=(a[wa]|0)){ka=Y;la=Y;ma=W;na=ja;break c}ra=xa+1|0;if((ra|0)==(oa|0)){ka=Y;la=Y;ma=W;na=qa;break}else{wa=wa+1|0;xa=ra}}}}while(0);d:while(1){if((ma&1)==0){ya=j;za=(ma&255)>>>1}else{ya=c[J>>2]|0;za=c[K>>2]|0}if((na|0)==(ya+za|0)){break}W=c[h>>2]|0;do{if((W|0)==0){Aa=0}else{if((c[W+12>>2]|0)!=(c[W+16>>2]|0)){Aa=W;break}if((pe[c[(c[W>>2]|0)+36>>2]&127](W)|0)==-1){c[h>>2]=0;Aa=0;break}else{Aa=c[h>>2]|0;break}}}while(0);W=(Aa|0)==0;do{if((la|0)==0){Ba=ka;X=147}else{if((c[la+12>>2]|0)!=(c[la+16>>2]|0)){if(W){Ca=ka;Da=la;break}else{break d}}if((pe[c[(c[la>>2]|0)+36>>2]&127](la)|0)==-1){c[e>>2]=0;Ba=0;X=147;break}else{if(W^(ka|0)==0){Ca=ka;Da=ka;break}else{break d}}}}while(0);if((X|0)==147){X=0;if(W){break}else{Ca=Ba;Da=0}}ja=c[h>>2]|0;ia=c[ja+12>>2]|0;if((ia|0)==(c[ja+16>>2]|0)){Ea=(pe[c[(c[ja>>2]|0)+36>>2]&127](ja)|0)&255}else{Ea=a[ia]|0}if(!(Ea<<24>>24==(a[na]|0))){break}ia=c[h>>2]|0;ja=ia+12|0;oa=c[ja>>2]|0;if((oa|0)==(c[ia+16>>2]|0)){pe[c[(c[ia>>2]|0)+40>>2]&127](ia)|0}else{c[ja>>2]=oa+1}ka=Ca;la=Da;ma=a[x]|0;na=na+1|0}if(!I){ca=D;da=R;ea=r;fa=Q;ga=S;ha=T;break b}oa=a[x]|0;if((oa&1)==0){Fa=j;Ga=(oa&255)>>>1}else{Fa=c[J>>2]|0;Ga=c[K>>2]|0}if((na|0)==(Fa+Ga|0)){ca=D;da=R;ea=r;fa=Q;ga=S;ha=T}else{X=162;break a}break};case 0:{X=26;break};case 3:{oa=a[y]|0;ja=(oa&1)==0;if(ja){Ha=(oa&255)>>>1}else{Ha=c[G>>2]|0}ia=a[z]|0;ra=(ia&1)==0;if(ra){Ia=(ia&255)>>>1}else{Ia=c[g>>2]|0}if((Ha|0)==(0-Ia|0)){ca=D;da=R;ea=r;fa=Q;ga=S;ha=T;break b}if(ja){Ja=(oa&255)>>>1}else{Ja=c[G>>2]|0}do{if((Ja|0)!=0){if(ra){Ka=(ia&255)>>>1}else{Ka=c[g>>2]|0}if((Ka|0)==0){break}pa=c[h>>2]|0;La=c[pa+12>>2]|0;Ma=c[pa+16>>2]|0;if((La|0)==(Ma|0)){Na=(pe[c[(c[pa>>2]|0)+36>>2]&127](pa)|0)&255;Oa=c[h>>2]|0;Pa=Na;Qa=c[Oa+16>>2]|0;Ra=c[Oa+12>>2]|0;Sa=Oa;Ta=a[y]|0}else{Pa=a[La]|0;Qa=Ma;Ra=La;Sa=pa;Ta=oa}pa=Sa+12|0;La=(Ra|0)==(Qa|0);if(Pa<<24>>24==(a[(Ta&1)==0?F:c[H>>2]|0]|0)){if(La){pe[c[(c[Sa>>2]|0)+40>>2]&127](Sa)|0}else{c[pa>>2]=Ra+1}pa=a[y]|0;if((pa&1)==0){Ua=(pa&255)>>>1}else{Ua=c[G>>2]|0}ca=D;da=R;ea=r;fa=Q;ga=Ua>>>0>1?y:S;ha=T;break b}if(La){Va=(pe[c[(c[Sa>>2]|0)+36>>2]&127](Sa)|0)&255}else{Va=a[Ra]|0}if(!(Va<<24>>24==(a[(a[z]&1)==0?m:c[E>>2]|0]|0))){X=112;break a}La=c[h>>2]|0;pa=La+12|0;Ma=c[pa>>2]|0;if((Ma|0)==(c[La+16>>2]|0)){pe[c[(c[La>>2]|0)+40>>2]&127](La)|0}else{c[pa>>2]=Ma+1}a[l]=1;Ma=a[z]|0;if((Ma&1)==0){Wa=(Ma&255)>>>1}else{Wa=c[g>>2]|0}ca=D;da=R;ea=r;fa=Q;ga=Wa>>>0>1?z:S;ha=T;break b}}while(0);if(ja){Xa=(oa&255)>>>1}else{Xa=c[G>>2]|0}ra=c[h>>2]|0;Ma=c[ra+12>>2]|0;pa=(Ma|0)==(c[ra+16>>2]|0);if((Xa|0)==0){if(pa){La=(pe[c[(c[ra>>2]|0)+36>>2]&127](ra)|0)&255;Ya=La;Za=a[z]|0}else{Ya=a[Ma]|0;Za=ia}if(!(Ya<<24>>24==(a[(Za&1)==0?m:c[E>>2]|0]|0))){ca=D;da=R;ea=r;fa=Q;ga=S;ha=T;break b}La=c[h>>2]|0;Oa=La+12|0;Na=c[Oa>>2]|0;if((Na|0)==(c[La+16>>2]|0)){pe[c[(c[La>>2]|0)+40>>2]&127](La)|0}else{c[Oa>>2]=Na+1}a[l]=1;Na=a[z]|0;if((Na&1)==0){_a=(Na&255)>>>1}else{_a=c[g>>2]|0}ca=D;da=R;ea=r;fa=Q;ga=_a>>>0>1?z:S;ha=T;break b}if(pa){pa=(pe[c[(c[ra>>2]|0)+36>>2]&127](ra)|0)&255;$a=pa;ab=a[y]|0}else{$a=a[Ma]|0;ab=oa}if(!($a<<24>>24==(a[(ab&1)==0?F:c[H>>2]|0]|0))){a[l]=1;ca=D;da=R;ea=r;fa=Q;ga=S;ha=T;break b}Ma=c[h>>2]|0;pa=Ma+12|0;ra=c[pa>>2]|0;if((ra|0)==(c[Ma+16>>2]|0)){pe[c[(c[Ma>>2]|0)+40>>2]&127](Ma)|0}else{c[pa>>2]=ra+1}ra=a[y]|0;if((ra&1)==0){bb=(ra&255)>>>1}else{bb=c[G>>2]|0}ca=D;da=R;ea=r;fa=Q;ga=bb>>>0>1?y:S;ha=T;break};case 4:{ra=D;pa=R;Ma=r;Na=Q;Oa=0;La=T;e:while(1){cb=c[h>>2]|0;do{if((cb|0)==0){db=0}else{if((c[cb+12>>2]|0)!=(c[cb+16>>2]|0)){db=cb;break}if((pe[c[(c[cb>>2]|0)+36>>2]&127](cb)|0)==-1){c[h>>2]=0;db=0;break}else{db=c[h>>2]|0;break}}}while(0);cb=(db|0)==0;W=c[e>>2]|0;do{if((W|0)==0){X=173}else{if((c[W+12>>2]|0)!=(c[W+16>>2]|0)){if(cb){break}else{break e}}if((pe[c[(c[W>>2]|0)+36>>2]&127](W)|0)==-1){c[e>>2]=0;X=173;break}else{if(cb){break}else{break e}}}}while(0);if((X|0)==173){X=0;if(cb){break}}W=c[h>>2]|0;eb=c[W+12>>2]|0;if((eb|0)==(c[W+16>>2]|0)){fb=(pe[c[(c[W>>2]|0)+36>>2]&127](W)|0)&255}else{fb=a[eb]|0}do{if(fb<<24>>24>-1){if((b[(c[f>>2]|0)+(fb<<24>>24<<1)>>1]&2048)==0){X=189;break}eb=c[o>>2]|0;if((eb|0)==(ra|0)){W=(c[P>>2]|0)!=1433;gb=c[t>>2]|0;hb=ra-gb|0;ib=hb>>>0<2147483647?hb<<1:-1;jb=Zpb(W?gb:0,ib)|0;if((jb|0)==0){X=182;break a}do{if(W){c[t>>2]=jb;kb=jb}else{gb=c[t>>2]|0;c[t>>2]=jb;if((gb|0)==0){kb=jb;break}me[c[P>>2]&2047](gb);kb=c[t>>2]|0}}while(0);c[P>>2]=1408;jb=kb+hb|0;c[o>>2]=jb;lb=jb;mb=(c[t>>2]|0)+ib|0}else{lb=eb;mb=ra}c[o>>2]=lb+1;a[lb]=fb;nb=mb;ob=pa;pb=Ma;qb=Na;rb=Oa+1|0;sb=La}else{X=189}}while(0);if((X|0)==189){X=0;cb=a[w]|0;if((cb&1)==0){tb=(cb&255)>>>1}else{tb=c[n>>2]|0}if((tb|0)==0|(Oa|0)==0){break}if(!(fb<<24>>24==(a[v]|0))){break}if((Ma|0)==(Na|0)){cb=Ma-pa|0;jb=cb>>>0<2147483647?cb<<1:-1;if((La|0)==1433){ub=0}else{ub=pa}W=Zpb(ub,jb)|0;if((W|0)==0){X=198;break a}vb=W;wb=W+(cb>>2<<2)|0;xb=W+(jb>>>2<<2)|0;yb=1408}else{vb=pa;wb=Ma;xb=Na;yb=La}c[wb>>2]=Oa;nb=ra;ob=vb;pb=wb+4|0;qb=xb;rb=0;sb=yb}jb=c[h>>2]|0;W=jb+12|0;cb=c[W>>2]|0;if((cb|0)==(c[jb+16>>2]|0)){pe[c[(c[jb>>2]|0)+40>>2]&127](jb)|0;ra=nb;pa=ob;Ma=pb;Na=qb;Oa=rb;La=sb;continue}else{c[W>>2]=cb+1;ra=nb;pa=ob;Ma=pb;Na=qb;Oa=rb;La=sb;continue}}if((pa|0)==(Ma|0)|(Oa|0)==0){zb=pa;Ab=Ma;Bb=Na;Cb=La}else{if((Ma|0)==(Na|0)){oa=Ma-pa|0;ia=oa>>>0<2147483647?oa<<1:-1;if((La|0)==1433){Db=0}else{Db=pa}ja=Zpb(Db,ia)|0;if((ja|0)==0){X=209;break a}Eb=ja;Fb=ja+(oa>>2<<2)|0;Gb=ja+(ia>>>2<<2)|0;Hb=1408}else{Eb=pa;Fb=Ma;Gb=Na;Hb=La}c[Fb>>2]=Oa;zb=Eb;Ab=Fb+4|0;Bb=Gb;Cb=Hb}if((c[B>>2]|0)>0){ia=c[h>>2]|0;do{if((ia|0)==0){Ib=0}else{if((c[ia+12>>2]|0)!=(c[ia+16>>2]|0)){Ib=ia;break}if((pe[c[(c[ia>>2]|0)+36>>2]&127](ia)|0)==-1){c[h>>2]=0;Ib=0;break}else{Ib=c[h>>2]|0;break}}}while(0);ia=(Ib|0)==0;Oa=c[e>>2]|0;do{if((Oa|0)==0){X=223}else{if((c[Oa+12>>2]|0)!=(c[Oa+16>>2]|0)){if(ia){Jb=Oa;break}else{X=229;break a}}if((pe[c[(c[Oa>>2]|0)+36>>2]&127](Oa)|0)==-1){c[e>>2]=0;X=223;break}else{if(ia){Jb=Oa;break}else{X=229;break a}}}}while(0);if((X|0)==223){X=0;if(ia){X=229;break a}else{Jb=0}}Oa=c[h>>2]|0;La=c[Oa+12>>2]|0;if((La|0)==(c[Oa+16>>2]|0)){Kb=(pe[c[(c[Oa>>2]|0)+36>>2]&127](Oa)|0)&255}else{Kb=a[La]|0}if(!(Kb<<24>>24==(a[u]|0))){X=229;break a}La=c[h>>2]|0;Oa=La+12|0;Na=c[Oa>>2]|0;if((Na|0)==(c[La+16>>2]|0)){pe[c[(c[La>>2]|0)+40>>2]&127](La)|0;Lb=Jb;Mb=Jb;Nb=ra}else{c[Oa>>2]=Na+1;Lb=Jb;Mb=Jb;Nb=ra}while(1){Na=c[h>>2]|0;do{if((Na|0)==0){Ob=0}else{if((c[Na+12>>2]|0)!=(c[Na+16>>2]|0)){Ob=Na;break}if((pe[c[(c[Na>>2]|0)+36>>2]&127](Na)|0)==-1){c[h>>2]=0;Ob=0;break}else{Ob=c[h>>2]|0;break}}}while(0);Na=(Ob|0)==0;do{if((Mb|0)==0){Pb=Lb;X=243}else{if((c[Mb+12>>2]|0)!=(c[Mb+16>>2]|0)){if(Na){Qb=Lb;Rb=Mb;break}else{X=250;break a}}if((pe[c[(c[Mb>>2]|0)+36>>2]&127](Mb)|0)==-1){c[e>>2]=0;Pb=0;X=243;break}else{if(Na^(Lb|0)==0){Qb=Lb;Rb=Lb;break}else{X=250;break a}}}}while(0);if((X|0)==243){X=0;if(Na){X=250;break a}else{Qb=Pb;Rb=0}}Oa=c[h>>2]|0;La=c[Oa+12>>2]|0;if((La|0)==(c[Oa+16>>2]|0)){Sb=(pe[c[(c[Oa>>2]|0)+36>>2]&127](Oa)|0)&255}else{Sb=a[La]|0}if(!(Sb<<24>>24>-1)){X=250;break a}if((b[(c[f>>2]|0)+(Sb<<24>>24<<1)>>1]&2048)==0){X=250;break a}La=c[o>>2]|0;if((La|0)==(Nb|0)){Oa=(c[P>>2]|0)!=1433;Ma=c[t>>2]|0;pa=Nb-Ma|0;ja=pa>>>0<2147483647?pa<<1:-1;oa=Zpb(Oa?Ma:0,ja)|0;if((oa|0)==0){X=253;break a}do{if(Oa){c[t>>2]=oa;Tb=oa}else{Ma=c[t>>2]|0;c[t>>2]=oa;if((Ma|0)==0){Tb=oa;break}me[c[P>>2]&2047](Ma);Tb=c[t>>2]|0}}while(0);c[P>>2]=1408;oa=Tb+pa|0;c[o>>2]=oa;Ub=oa;Vb=(c[t>>2]|0)+ja|0}else{Ub=La;Vb=Nb}oa=c[h>>2]|0;Oa=c[oa+12>>2]|0;if((Oa|0)==(c[oa+16>>2]|0)){Na=(pe[c[(c[oa>>2]|0)+36>>2]&127](oa)|0)&255;Wb=Na;Xb=c[o>>2]|0}else{Wb=a[Oa]|0;Xb=Ub}c[o>>2]=Xb+1;a[Xb]=Wb;Oa=(c[B>>2]|0)+ -1|0;c[B>>2]=Oa;Na=c[h>>2]|0;oa=Na+12|0;Ma=c[oa>>2]|0;if((Ma|0)==(c[Na+16>>2]|0)){pe[c[(c[Na>>2]|0)+40>>2]&127](Na)|0}else{c[oa>>2]=Ma+1}if((Oa|0)>0){Lb=Qb;Mb=Rb;Nb=Vb}else{Yb=Vb;break}}}else{Yb=ra}if((c[o>>2]|0)==(c[t>>2]|0)){X=267;break a}else{ca=Yb;da=zb;ea=Ab;fa=Bb;ga=S;ha=Cb}break};case 1:{if((p|0)==3){Z=R;_=r;$=S;aa=T;X=269;break a}ia=c[h>>2]|0;Oa=c[ia+12>>2]|0;if((Oa|0)==(c[ia+16>>2]|0)){Zb=(pe[c[(c[ia>>2]|0)+36>>2]&127](ia)|0)&255}else{Zb=a[Oa]|0}if(!(Zb<<24>>24>-1)){X=25;break a}if((b[(c[f>>2]|0)+(Zb<<24>>24<<1)>>1]&8192)==0){X=25;break a}Oa=c[h>>2]|0;ia=Oa+12|0;Ma=c[ia>>2]|0;if((Ma|0)==(c[Oa+16>>2]|0)){_b=(pe[c[(c[Oa>>2]|0)+40>>2]&127](Oa)|0)&255}else{c[ia>>2]=Ma+1;_b=a[Ma]|0}hgb(A,_b);X=26;break};default:{ca=D;da=R;ea=r;fa=Q;ga=S;ha=T}}}while(0);f:do{if((X|0)==26){X=0;if((p|0)==3){Z=R;_=r;$=S;aa=T;X=269;break a}else{$b=Y;ac=Y}while(1){U=c[h>>2]|0;do{if((U|0)==0){bc=0}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){bc=U;break}if((pe[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[h>>2]=0;bc=0;break}else{bc=c[h>>2]|0;break}}}while(0);U=(bc|0)==0;do{if((ac|0)==0){cc=$b;X=37}else{if((c[ac+12>>2]|0)!=(c[ac+16>>2]|0)){if(U){dc=$b;ec=ac;break}else{ca=D;da=R;ea=r;fa=Q;ga=S;ha=T;break f}}if((pe[c[(c[ac>>2]|0)+36>>2]&127](ac)|0)==-1){c[e>>2]=0;cc=0;X=37;break}else{if(U^($b|0)==0){dc=$b;ec=$b;break}else{ca=D;da=R;ea=r;fa=Q;ga=S;ha=T;break f}}}}while(0);if((X|0)==37){X=0;if(U){ca=D;da=R;ea=r;fa=Q;ga=S;ha=T;break f}else{dc=cc;ec=0}}La=c[h>>2]|0;ja=c[La+12>>2]|0;if((ja|0)==(c[La+16>>2]|0)){fc=(pe[c[(c[La>>2]|0)+36>>2]&127](La)|0)&255}else{fc=a[ja]|0}if(!(fc<<24>>24>-1)){ca=D;da=R;ea=r;fa=Q;ga=S;ha=T;break f}if((b[(c[f>>2]|0)+(fc<<24>>24<<1)>>1]&8192)==0){ca=D;da=R;ea=r;fa=Q;ga=S;ha=T;break f}ja=c[h>>2]|0;La=ja+12|0;pa=c[La>>2]|0;if((pa|0)==(c[ja+16>>2]|0)){gc=(pe[c[(c[ja>>2]|0)+40>>2]&127](ja)|0)&255}else{c[La>>2]=pa+1;gc=a[pa]|0}hgb(A,gc);$b=dc;ac=ec}}}while(0);ra=p+1|0;if(ra>>>0<4){Q=fa;r=ea;R=da;D=ca;p=ra;S=ga;T=ha}else{Z=da;_=ea;$=ga;aa=ha;X=269;break}}g:do{if((X|0)==25){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==112){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==162){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==182){hqb()}else if((X|0)==198){hqb()}else if((X|0)==209){hqb()}else if((X|0)==229){c[k>>2]=c[k>>2]|4;hc=0;ic=zb;jc=Cb}else if((X|0)==250){c[k>>2]=c[k>>2]|4;hc=0;ic=zb;jc=Cb}else if((X|0)==253){hqb()}else if((X|0)==267){c[k>>2]=c[k>>2]|4;hc=0;ic=zb;jc=Cb}else if((X|0)==269){h:do{if(($|0)!=0){ha=$+1|0;ga=$+8|0;ea=$+4|0;da=1;i:while(1){S=a[$]|0;if((S&1)==0){kc=(S&255)>>>1}else{kc=c[ea>>2]|0}if(!(da>>>0<kc>>>0)){break h}S=c[h>>2]|0;do{if((S|0)==0){lc=0}else{if((c[S+12>>2]|0)!=(c[S+16>>2]|0)){lc=S;break}if((pe[c[(c[S>>2]|0)+36>>2]&127](S)|0)==-1){c[h>>2]=0;lc=0;break}else{lc=c[h>>2]|0;break}}}while(0);S=(lc|0)==0;U=c[e>>2]|0;do{if((U|0)==0){X=285}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){if(S){break}else{break i}}if((pe[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[e>>2]=0;X=285;break}else{if(S){break}else{break i}}}}while(0);if((X|0)==285){X=0;if(S){break}}U=c[h>>2]|0;p=c[U+12>>2]|0;if((p|0)==(c[U+16>>2]|0)){mc=(pe[c[(c[U>>2]|0)+36>>2]&127](U)|0)&255}else{mc=a[p]|0}if((a[$]&1)==0){nc=ha}else{nc=c[ga>>2]|0}if(!(mc<<24>>24==(a[nc+da|0]|0))){break}p=da+1|0;U=c[h>>2]|0;ca=U+12|0;D=c[ca>>2]|0;if((D|0)==(c[U+16>>2]|0)){pe[c[(c[U>>2]|0)+40>>2]&127](U)|0;da=p;continue}else{c[ca>>2]=D+1;da=p;continue}}c[k>>2]=c[k>>2]|4;hc=0;ic=Z;jc=aa;break g}}while(0);if((Z|0)==(_|0)){hc=1;ic=_;jc=aa;break}c[C>>2]=0;Nlb(w,Z,_,C);if((c[C>>2]|0)==0){hc=1;ic=Z;jc=aa;break}c[k>>2]=c[k>>2]|4;hc=0;ic=Z;jc=aa}}while(0);Rfb(A);Rfb(z);Rfb(y);Rfb(x);Rfb(w);if((ic|0)==0){i=q;return hc|0}me[jc&2047](ic);i=q;return hc|0}function Jlb(a){a=a|0;var b=0;b=Hc(8)|0;nfb(b,a);_d(b|0,311120,43)}function Klb(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=i;i=i+168|0;l=d;m=d+8|0;n=d+24|0;o=d+128|0;p=d+136|0;q=d+144|0;r=d+152|0;s=d+160|0;t=o;c[t>>2]=n;u=o+4|0;c[u>>2]=1433;v=n+100|0;Ngb(q,h);n=q;w=c[n>>2]|0;if(!((c[78532]|0)==-1)){c[m>>2]=314128;c[m+4>>2]=1431;c[m+8>>2]=0;Cfb(314128,m,1432)}m=(c[314132>>2]|0)+ -1|0;x=c[w+8>>2]|0;if(!((c[w+12>>2]|0)-x>>2>>>0>m>>>0)){y=Hc(4)|0;z=y;Bpb(z);A=329688;B=128;_d(y|0,A|0,B|0)}w=c[x+(m<<2)>>2]|0;if((w|0)==0){y=Hc(4)|0;z=y;Bpb(z);A=329688;B=128;_d(y|0,A|0,B|0)}B=w;a[r]=0;A=f;f=c[A>>2]|0;c[s>>2]=f;y=c[h+4>>2]|0;h=l;z=s;c[h+0>>2]=c[z+0>>2];z=Ilb(e,l,g,q,y,j,r,B,o,p,v)|0;if(z){if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}if((a[r]|0)!=0){hgb(k,Ee[c[(c[w>>2]|0)+28>>2]&63](B,45)|0)}r=Ee[c[(c[w>>2]|0)+28>>2]&63](B,48)|0;B=c[t>>2]|0;w=c[p>>2]|0;p=w+ -1|0;a:do{if(B>>>0<p>>>0){z=B;while(1){v=z+1|0;if(!((a[z]|0)==r<<24>>24)){C=z;break a}if(v>>>0<p>>>0){z=v}else{C=v;break}}}else{C=B}}while(0);Llb(k,C,w)|0}w=e;e=c[w>>2]|0;do{if((e|0)==0){D=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){D=e;break}if(!((pe[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){D=e;break}c[w>>2]=0;D=0}}while(0);w=(D|0)==0;do{if((f|0)==0){E=25}else{if((c[f+12>>2]|0)!=(c[f+16>>2]|0)){if(w){break}else{E=27;break}}if((pe[c[(c[f>>2]|0)+36>>2]&127](f)|0)==-1){c[A>>2]=0;E=25;break}else{if(w^(f|0)==0){break}else{E=27;break}}}}while(0);if((E|0)==25){if(w){E=27}}if((E|0)==27){c[j>>2]=c[j>>2]|2}c[b>>2]=D;hfb(c[n>>2]|0)|0;n=c[t>>2]|0;c[t>>2]=0;if((n|0)==0){i=d;return}me[c[u>>2]&2047](n);i=d;return}function Llb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=d;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1;k=h;l=10}else{h=c[b>>2]|0;j=c[b+4>>2]|0;k=h&255;l=(h&-2)+ -1|0}h=e-g|0;if((e|0)==(d|0)){i=f;return b|0}if((l-j|0)>>>0<h>>>0){kgb(b,l,j+h-l|0,j,j,0,0);m=a[b]|0}else{m=k}if((m&1)==0){n=b+1|0}else{n=c[b+8>>2]|0}m=e+(j-g)|0;g=d;d=n+j|0;while(1){a[d]=a[g]|0;k=g+1|0;if((k|0)==(e|0)){break}else{d=d+1|0;g=k}}a[n+m|0]=0;m=j+h|0;if((a[b]&1)==0){a[b]=m<<1;i=f;return b|0}else{c[b+4>>2]=m;i=f;return b|0}return 0}function Mlb(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;n=i;i=i+176|0;o=n;p=n+16|0;q=n+32|0;r=n+40|0;s=n+56|0;t=n+72|0;u=n+88|0;v=n+104|0;w=n+112|0;x=n+128|0;y=n+144|0;z=n+160|0;if(b){b=c[d>>2]|0;if(!((c[78392]|0)==-1)){c[p>>2]=313568;c[p+4>>2]=1431;c[p+8>>2]=0;Cfb(313568,p,1432)}p=(c[313572>>2]|0)+ -1|0;A=c[b+8>>2]|0;if(!((c[b+12>>2]|0)-A>>2>>>0>p>>>0)){B=Hc(4)|0;C=B;Bpb(C);D=329688;E=128;_d(B|0,D|0,E|0)}b=c[A+(p<<2)>>2]|0;if((b|0)==0){B=Hc(4)|0;C=B;Bpb(C);D=329688;E=128;_d(B|0,D|0,E|0)}E=b;ne[c[(c[b>>2]|0)+44>>2]&255](q,E);D=e;B=c[q>>2]|0;a[D]=B;a[D+1|0]=B>>8;a[D+2|0]=B>>16;a[D+3|0]=B>>24;ne[c[(c[b>>2]|0)+32>>2]&255](r,E);B=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}bgb(l,0);D=r;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;Rfb(r);ne[c[(c[b>>2]|0)+28>>2]&255](s,E);r=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}bgb(k,0);D=s;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;Rfb(s);a[f]=pe[c[(c[b>>2]|0)+12>>2]&127](E)|0;a[g]=pe[c[(c[b>>2]|0)+16>>2]&127](E)|0;ne[c[(c[b>>2]|0)+20>>2]&255](t,E);s=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}bgb(h,0);D=t;c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;Rfb(t);ne[c[(c[b>>2]|0)+24>>2]&255](u,E);t=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}bgb(j,0);D=u;c[t+0>>2]=c[D+0>>2];c[t+4>>2]=c[D+4>>2];c[t+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;Rfb(u);F=pe[c[(c[b>>2]|0)+36>>2]&127](E)|0;c[m>>2]=F;i=n;return}else{E=c[d>>2]|0;if(!((c[78376]|0)==-1)){c[o>>2]=313504;c[o+4>>2]=1431;c[o+8>>2]=0;Cfb(313504,o,1432)}o=(c[313508>>2]|0)+ -1|0;d=c[E+8>>2]|0;if(!((c[E+12>>2]|0)-d>>2>>>0>o>>>0)){G=Hc(4)|0;H=G;Bpb(H);I=329688;J=128;_d(G|0,I|0,J|0)}E=c[d+(o<<2)>>2]|0;if((E|0)==0){G=Hc(4)|0;H=G;Bpb(H);I=329688;J=128;_d(G|0,I|0,J|0)}J=E;ne[c[(c[E>>2]|0)+44>>2]&255](v,J);I=e;e=c[v>>2]|0;a[I]=e;a[I+1|0]=e>>8;a[I+2|0]=e>>16;a[I+3|0]=e>>24;ne[c[(c[E>>2]|0)+32>>2]&255](w,J);e=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}bgb(l,0);l=w;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;Rfb(w);ne[c[(c[E>>2]|0)+28>>2]&255](x,J);w=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}bgb(k,0);k=x;c[w+0>>2]=c[k+0>>2];c[w+4>>2]=c[k+4>>2];c[w+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;Rfb(x);a[f]=pe[c[(c[E>>2]|0)+12>>2]&127](J)|0;a[g]=pe[c[(c[E>>2]|0)+16>>2]&127](J)|0;ne[c[(c[E>>2]|0)+20>>2]&255](y,J);g=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}bgb(h,0);h=y;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;Rfb(y);ne[c[(c[E>>2]|0)+24>>2]&255](z,J);y=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}bgb(j,0);j=z;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;Rfb(z);F=pe[c[(c[E>>2]|0)+36>>2]&127](J)|0;c[m>>2]=F;i=n;return}}function Nlb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1}else{j=c[b+4>>2]|0}if((j|0)==0){i=g;return}do{if((d|0)==(e|0)){k=h}else{j=e+ -4|0;if(j>>>0>d>>>0){l=d;m=j}else{k=h;break}do{j=c[l>>2]|0;c[l>>2]=c[m>>2];c[m>>2]=j;l=l+4|0;m=m+ -4|0;}while(l>>>0<m>>>0);k=a[b]|0}}while(0);if((k&1)==0){n=b+1|0;o=(k&255)>>>1}else{n=c[b+8>>2]|0;o=c[b+4>>2]|0}b=e+ -4|0;e=a[n]|0;k=e<<24>>24<1|e<<24>>24==127;a:do{if(b>>>0>d>>>0){m=n+o|0;l=e;h=n;j=d;p=k;while(1){if(!p){if((l<<24>>24|0)!=(c[j>>2]|0)){break}}q=(m-h|0)>1?h+1|0:h;r=j+4|0;s=a[q]|0;t=s<<24>>24<1|s<<24>>24==127;if(r>>>0<b>>>0){l=s;h=q;j=r;p=t}else{u=s;v=t;break a}}c[f>>2]=4;i=g;return}else{u=e;v=k}}while(0);if(v){i=g;return}v=c[b>>2]|0;if(!(u<<24>>24>>>0<v>>>0|(v|0)==0)){i=g;return}c[f>>2]=4;i=g;return}function Olb(a){a=a|0;var b=0;b=i;cqb(a);i=b;return}function Plb(a){a=a|0;i=i;return}function Qlb(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+400|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+40|0;v=i;i=i+104|0;w=p;c[w>>2]=o;x=p+4|0;c[x>>2]=1433;y=o+400|0;Ngb(r,h);o=r;z=c[o>>2]|0;if(!((c[78530]|0)==-1)){c[n>>2]=314120;c[n+4>>2]=1431;c[n+8>>2]=0;Cfb(314120,n,1432)}n=(c[314124>>2]|0)+ -1|0;A=c[z+8>>2]|0;if(!((c[z+12>>2]|0)-A>>2>>>0>n>>>0)){B=Hc(4)|0;C=B;Bpb(C);D=329688;E=128;_d(B|0,D|0,E|0)}z=c[A+(n<<2)>>2]|0;if((z|0)==0){B=Hc(4)|0;C=B;Bpb(C);D=329688;E=128;_d(B|0,D|0,E|0)}E=z;a[s]=0;D=f;c[t>>2]=c[D>>2];f=c[h+4>>2]|0;h=l;B=t;c[h+0>>2]=c[B+0>>2];B=Rlb(e,l,g,r,f,j,s,E,p,q,y)|0;do{if(B){y=u;Oe[c[(c[z>>2]|0)+48>>2]&63](E,313824,313834|0,y)|0;p=v;f=c[q>>2]|0;r=c[w>>2]|0;g=f-r|0;do{if((g|0)>392){l=Wpb((g>>2)+2|0)|0;if((l|0)!=0){F=l;G=l;break}hqb()}else{F=0;G=p}}while(0);if((a[s]|0)==0){H=G}else{a[G]=45;H=G+1|0}if(r>>>0<f>>>0){g=u+40|0;l=u;h=H;t=r;while(1){C=c[t>>2]|0;n=y;while(1){A=n+4|0;if((c[n>>2]|0)==(C|0)){I=n;break}if((A|0)==(g|0)){I=g;break}else{n=A}}a[h]=a[313824+(I-l>>2)|0]|0;n=t+4|0;C=h+1|0;if(n>>>0<(c[q>>2]|0)>>>0){h=C;t=n}else{J=C;break}}}else{J=H}a[J]=0;c[m>>2]=k;if((Ed(p|0,313760,m|0)|0)!=1){t=Hc(8)|0;nfb(t,313768);_d(t|0,311120,43)}if((F|0)==0){break}Xpb(F)}}while(0);F=e;e=c[F>>2]|0;do{if((e|0)==0){K=1}else{m=c[e+12>>2]|0;if((m|0)==(c[e+16>>2]|0)){L=pe[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{L=c[m>>2]|0}if((L|0)==-1){c[F>>2]=0;K=1;break}else{K=(c[F>>2]|0)==0;break}}}while(0);L=c[D>>2]|0;do{if((L|0)==0){M=35}else{e=c[L+12>>2]|0;if((e|0)==(c[L+16>>2]|0)){N=pe[c[(c[L>>2]|0)+36>>2]&127](L)|0}else{N=c[e>>2]|0}if((N|0)==-1){c[D>>2]=0;M=35;break}else{if(K){break}else{M=37;break}}}}while(0);if((M|0)==35){if(K){M=37}}if((M|0)==37){c[j>>2]=c[j>>2]|2}c[b>>2]=c[F>>2];hfb(c[o>>2]|0)|0;o=c[w>>2]|0;c[w>>2]=0;if((o|0)==0){i=d;return}me[c[x>>2]&2047](o);i=d;return}function Rlb(b,e,f,g,h,j,k,l,m,n,o){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0;p=i;i=i+416|0;q=p;r=p+8|0;s=p+408|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;c[q>>2]=o;o=r;c[s>>2]=0;D=w;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=x;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=y;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=z;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=A;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;Ulb(f,g,t,u,v,w,x,y,z,B);t=m;c[n>>2]=c[t>>2];g=b;b=e;e=z+4|0;f=z+8|0;D=y+4|0;E=y+8|0;F=(h&512|0)!=0;h=x+4|0;G=x+8|0;H=A+4|0;I=A+8|0;J=s+3|0;K=w+4|0;L=r+400|0;r=o;M=o;o=0;N=0;O=1433;a:while(1){P=c[g>>2]|0;do{if((P|0)==0){Q=1}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){S=pe[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{S=c[R>>2]|0}if((S|0)==-1){c[g>>2]=0;Q=1;break}else{Q=(c[g>>2]|0)==0;break}}}while(0);P=c[b>>2]|0;do{if((P|0)==0){T=15}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){U=pe[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{U=c[R>>2]|0}if((U|0)==-1){c[b>>2]=0;T=15;break}else{if(Q){V=P;break}else{W=M;X=r;Y=N;Z=O;T=276;break a}}}}while(0);if((T|0)==15){T=0;if(Q){W=M;X=r;Y=N;Z=O;T=276;break}else{V=0}}b:do{switch(a[s+o|0]|0){case 1:{if((o|0)==3){W=M;X=r;Y=N;Z=O;T=276;break a}P=c[g>>2]|0;R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){_=pe[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{_=c[R>>2]|0}if(!(se[c[(c[l>>2]|0)+12>>2]&63](l,8192,_)|0)){T=27;break a}R=c[g>>2]|0;P=R+12|0;$=c[P>>2]|0;if(($|0)==(c[R+16>>2]|0)){aa=pe[c[(c[R>>2]|0)+40>>2]&127](R)|0}else{c[P>>2]=$+4;aa=c[$>>2]|0}xgb(A,aa);T=28;break};case 4:{$=M;P=r;R=L;ba=0;ca=O;c:while(1){da=c[g>>2]|0;do{if((da|0)==0){ea=1}else{fa=c[da+12>>2]|0;if((fa|0)==(c[da+16>>2]|0)){ga=pe[c[(c[da>>2]|0)+36>>2]&127](da)|0}else{ga=c[fa>>2]|0}if((ga|0)==-1){c[g>>2]=0;ea=1;break}else{ea=(c[g>>2]|0)==0;break}}}while(0);da=c[b>>2]|0;do{if((da|0)==0){T=188}else{fa=c[da+12>>2]|0;if((fa|0)==(c[da+16>>2]|0)){ha=pe[c[(c[da>>2]|0)+36>>2]&127](da)|0}else{ha=c[fa>>2]|0}if((ha|0)==-1){c[b>>2]=0;T=188;break}else{if(ea){break}else{break c}}}}while(0);if((T|0)==188){T=0;if(ea){break}}da=c[g>>2]|0;fa=c[da+12>>2]|0;if((fa|0)==(c[da+16>>2]|0)){ia=pe[c[(c[da>>2]|0)+36>>2]&127](da)|0}else{ia=c[fa>>2]|0}if(se[c[(c[l>>2]|0)+12>>2]&63](l,2048,ia)|0){fa=c[n>>2]|0;if((fa|0)==(c[q>>2]|0)){Vlb(m,n,q);ja=c[n>>2]|0}else{ja=fa}c[n>>2]=ja+4;c[ja>>2]=ia;ka=$;la=P;ma=R;na=ba+1|0;oa=ca}else{fa=a[w]|0;if((fa&1)==0){pa=(fa&255)>>>1}else{pa=c[K>>2]|0}if((pa|0)==0|(ba|0)==0){break}if((ia|0)!=(c[v>>2]|0)){break}if((P|0)==(R|0)){fa=P-$|0;da=fa>>>0<2147483647?fa<<1:-1;if((ca|0)!=1433){qa=$}else{qa=0}ra=Zpb(qa,da)|0;if((ra|0)==0){T=206;break a}sa=ra;ta=ra+(fa>>2<<2)|0;ua=ra+(da>>>2<<2)|0;va=1408}else{sa=$;ta=P;ua=R;va=ca}c[ta>>2]=ba;ka=sa;la=ta+4|0;ma=ua;na=0;oa=va}da=c[g>>2]|0;ra=da+12|0;fa=c[ra>>2]|0;if((fa|0)==(c[da+16>>2]|0)){pe[c[(c[da>>2]|0)+40>>2]&127](da)|0;$=ka;P=la;R=ma;ba=na;ca=oa;continue}else{c[ra>>2]=fa+4;$=ka;P=la;R=ma;ba=na;ca=oa;continue}}if(($|0)==(P|0)|(ba|0)==0){wa=$;xa=P;ya=R;za=ca}else{if((P|0)==(R|0)){fa=P-$|0;ra=fa>>>0<2147483647?fa<<1:-1;if((ca|0)!=1433){Aa=$}else{Aa=0}da=Zpb(Aa,ra)|0;if((da|0)==0){T=217;break a}Ba=da;Ca=da+(fa>>2<<2)|0;Da=da+(ra>>>2<<2)|0;Ea=1408}else{Ba=$;Ca=P;Da=R;Ea=ca}c[Ca>>2]=ba;wa=Ba;xa=Ca+4|0;ya=Da;za=Ea}ra=c[B>>2]|0;if((ra|0)>0){da=c[g>>2]|0;do{if((da|0)==0){Fa=1}else{fa=c[da+12>>2]|0;if((fa|0)==(c[da+16>>2]|0)){Ga=pe[c[(c[da>>2]|0)+36>>2]&127](da)|0}else{Ga=c[fa>>2]|0}if((Ga|0)==-1){c[g>>2]=0;Fa=1;break}else{Fa=(c[g>>2]|0)==0;break}}}while(0);da=c[b>>2]|0;do{if((da|0)==0){T=234}else{ba=c[da+12>>2]|0;if((ba|0)==(c[da+16>>2]|0)){Ha=pe[c[(c[da>>2]|0)+36>>2]&127](da)|0}else{Ha=c[ba>>2]|0}if((Ha|0)==-1){c[b>>2]=0;T=234;break}else{if(Fa){Ia=da;break}else{T=240;break a}}}}while(0);if((T|0)==234){T=0;if(Fa){T=240;break a}else{Ia=0}}da=c[g>>2]|0;ba=c[da+12>>2]|0;if((ba|0)==(c[da+16>>2]|0)){Ja=pe[c[(c[da>>2]|0)+36>>2]&127](da)|0}else{Ja=c[ba>>2]|0}if((Ja|0)!=(c[u>>2]|0)){T=240;break a}ba=c[g>>2]|0;da=ba+12|0;ca=c[da>>2]|0;if((ca|0)==(c[ba+16>>2]|0)){pe[c[(c[ba>>2]|0)+40>>2]&127](ba)|0;Ka=Ia;La=ra;Ma=Ia}else{c[da>>2]=ca+4;Ka=Ia;La=ra;Ma=Ia}while(1){ca=c[g>>2]|0;do{if((ca|0)==0){Na=1}else{da=c[ca+12>>2]|0;if((da|0)==(c[ca+16>>2]|0)){Oa=pe[c[(c[ca>>2]|0)+36>>2]&127](ca)|0}else{Oa=c[da>>2]|0}if((Oa|0)==-1){c[g>>2]=0;Na=1;break}else{Na=(c[g>>2]|0)==0;break}}}while(0);do{if((Ma|0)==0){Pa=Ka;T=257}else{ca=c[Ma+12>>2]|0;if((ca|0)==(c[Ma+16>>2]|0)){Qa=pe[c[(c[Ma>>2]|0)+36>>2]&127](Ma)|0}else{Qa=c[ca>>2]|0}if((Qa|0)==-1){c[b>>2]=0;Pa=0;T=257;break}else{if(Na^(Ka|0)==0){Ra=Ka;Sa=Ka;break}else{T=263;break a}}}}while(0);if((T|0)==257){T=0;if(Na){T=263;break a}else{Ra=Pa;Sa=0}}ca=c[g>>2]|0;da=c[ca+12>>2]|0;if((da|0)==(c[ca+16>>2]|0)){Ta=pe[c[(c[ca>>2]|0)+36>>2]&127](ca)|0}else{Ta=c[da>>2]|0}if(!(se[c[(c[l>>2]|0)+12>>2]&63](l,2048,Ta)|0)){T=263;break a}if((c[n>>2]|0)==(c[q>>2]|0)){Vlb(m,n,q)}da=c[g>>2]|0;ca=c[da+12>>2]|0;if((ca|0)==(c[da+16>>2]|0)){Ua=pe[c[(c[da>>2]|0)+36>>2]&127](da)|0}else{Ua=c[ca>>2]|0}ca=c[n>>2]|0;c[n>>2]=ca+4;c[ca>>2]=Ua;ca=La+ -1|0;c[B>>2]=ca;da=c[g>>2]|0;ba=da+12|0;R=c[ba>>2]|0;if((R|0)==(c[da+16>>2]|0)){pe[c[(c[da>>2]|0)+40>>2]&127](da)|0}else{c[ba>>2]=R+4}if((ca|0)>0){Ka=Ra;La=ca;Ma=Sa}else{break}}}if((c[n>>2]|0)==(c[t>>2]|0)){T=274;break a}else{Va=wa;Wa=xa;Xa=ya;Ya=N;Za=za}break};case 2:{if(!((N|0)!=0|o>>>0<2)){if((o|0)==2){_a=(a[J]|0)!=0}else{_a=0}if(!(F|_a)){Va=M;Wa=r;Xa=L;Ya=0;Za=O;break b}}ra=a[x]|0;ca=(ra&1)==0?h:c[G>>2]|0;d:do{if((o|0)==0){$a=V;ab=V;bb=ra;cb=ca}else{if((d[s+(o+ -1)|0]|0)<2){db=ra;eb=ca}else{$a=V;ab=V;bb=ra;cb=ca;break}while(1){if((db&1)==0){fb=h;gb=(db&255)>>>1}else{fb=c[G>>2]|0;gb=c[h>>2]|0}if((eb|0)==(fb+(gb<<2)|0)){hb=db;break}if(!(se[c[(c[l>>2]|0)+12>>2]&63](l,8192,c[eb>>2]|0)|0)){T=129;break}db=a[x]|0;eb=eb+4|0}if((T|0)==129){T=0;hb=a[x]|0}R=(hb&1)==0;ba=eb-(R?h:c[G>>2]|0)>>2;da=a[A]|0;P=(da&1)==0;if(P){ib=(da&255)>>>1}else{ib=c[H>>2]|0}e:do{if(!(ba>>>0>ib>>>0)){if(P){jb=H+(((da&255)>>>1)-ba<<2)|0;kb=H;lb=(da&255)>>>1}else{$=c[I>>2]|0;fa=c[H>>2]|0;jb=$+(fa-ba<<2)|0;kb=$;lb=fa}fa=kb+(lb<<2)|0;if((jb|0)==(fa|0)){$a=V;ab=V;bb=hb;cb=eb;break d}else{mb=R?h:c[G>>2]|0;nb=jb}while(1){if((c[nb>>2]|0)!=(c[mb>>2]|0)){break e}$=nb+4|0;if(($|0)==(fa|0)){$a=V;ab=V;bb=hb;cb=eb;break d}mb=mb+4|0;nb=$}}}while(0);$a=V;ab=V;bb=hb;cb=R?h:c[G>>2]|0}}while(0);f:while(1){if((bb&1)==0){ob=h;pb=(bb&255)>>>1}else{ob=c[G>>2]|0;pb=c[h>>2]|0}if((cb|0)==(ob+(pb<<2)|0)){break}ca=c[g>>2]|0;do{if((ca|0)==0){qb=1}else{ra=c[ca+12>>2]|0;if((ra|0)==(c[ca+16>>2]|0)){rb=pe[c[(c[ca>>2]|0)+36>>2]&127](ca)|0}else{rb=c[ra>>2]|0}if((rb|0)==-1){c[g>>2]=0;qb=1;break}else{qb=(c[g>>2]|0)==0;break}}}while(0);do{if((ab|0)==0){sb=$a;T=159}else{ca=c[ab+12>>2]|0;if((ca|0)==(c[ab+16>>2]|0)){tb=pe[c[(c[ab>>2]|0)+36>>2]&127](ab)|0}else{tb=c[ca>>2]|0}if((tb|0)==-1){c[b>>2]=0;sb=0;T=159;break}else{if(qb^($a|0)==0){ub=$a;vb=$a;break}else{break f}}}}while(0);if((T|0)==159){T=0;if(qb){break}else{ub=sb;vb=0}}ca=c[g>>2]|0;R=c[ca+12>>2]|0;if((R|0)==(c[ca+16>>2]|0)){wb=pe[c[(c[ca>>2]|0)+36>>2]&127](ca)|0}else{wb=c[R>>2]|0}if((wb|0)!=(c[cb>>2]|0)){break}R=c[g>>2]|0;ca=R+12|0;ra=c[ca>>2]|0;if((ra|0)==(c[R+16>>2]|0)){pe[c[(c[R>>2]|0)+40>>2]&127](R)|0}else{c[ca>>2]=ra+4}$a=ub;ab=vb;bb=a[x]|0;cb=cb+4|0}if(!F){Va=M;Wa=r;Xa=L;Ya=N;Za=O;break b}ra=a[x]|0;if((ra&1)==0){xb=h;yb=(ra&255)>>>1}else{xb=c[G>>2]|0;yb=c[h>>2]|0}if((cb|0)==(xb+(yb<<2)|0)){Va=M;Wa=r;Xa=L;Ya=N;Za=O}else{T=174;break a}break};case 0:{T=28;break};case 3:{ra=a[y]|0;ca=(ra&1)==0;if(ca){zb=(ra&255)>>>1}else{zb=c[D>>2]|0}R=a[z]|0;ba=(R&1)==0;if(ba){Ab=(R&255)>>>1}else{Ab=c[e>>2]|0}if((zb|0)==(0-Ab|0)){Va=M;Wa=r;Xa=L;Ya=N;Za=O;break b}if(ca){Bb=(ra&255)>>>1}else{Bb=c[D>>2]|0}do{if((Bb|0)!=0){if(ba){Cb=(R&255)>>>1}else{Cb=c[e>>2]|0}if((Cb|0)==0){break}da=c[g>>2]|0;P=c[da+12>>2]|0;if((P|0)==(c[da+16>>2]|0)){fa=pe[c[(c[da>>2]|0)+36>>2]&127](da)|0;Db=fa;Eb=a[y]|0}else{Db=c[P>>2]|0;Eb=ra}P=c[g>>2]|0;fa=P+12|0;da=c[fa>>2]|0;$=(da|0)==(c[P+16>>2]|0);if((Db|0)==(c[((Eb&1)==0?D:c[E>>2]|0)>>2]|0)){if($){pe[c[(c[P>>2]|0)+40>>2]&127](P)|0}else{c[fa>>2]=da+4}fa=a[y]|0;if((fa&1)==0){Fb=(fa&255)>>>1}else{Fb=c[D>>2]|0}Va=M;Wa=r;Xa=L;Ya=Fb>>>0>1?y:N;Za=O;break b}if($){Gb=pe[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{Gb=c[da>>2]|0}if((Gb|0)!=(c[((a[z]&1)==0?e:c[f>>2]|0)>>2]|0)){T=116;break a}da=c[g>>2]|0;P=da+12|0;$=c[P>>2]|0;if(($|0)==(c[da+16>>2]|0)){pe[c[(c[da>>2]|0)+40>>2]&127](da)|0}else{c[P>>2]=$+4}a[k]=1;$=a[z]|0;if(($&1)==0){Hb=($&255)>>>1}else{Hb=c[e>>2]|0}Va=M;Wa=r;Xa=L;Ya=Hb>>>0>1?z:N;Za=O;break b}}while(0);if(ca){Ib=(ra&255)>>>1}else{Ib=c[D>>2]|0}ba=c[g>>2]|0;$=c[ba+12>>2]|0;P=($|0)==(c[ba+16>>2]|0);if((Ib|0)==0){if(P){da=pe[c[(c[ba>>2]|0)+36>>2]&127](ba)|0;Jb=da;Kb=a[z]|0}else{Jb=c[$>>2]|0;Kb=R}if((Jb|0)!=(c[((Kb&1)==0?e:c[f>>2]|0)>>2]|0)){Va=M;Wa=r;Xa=L;Ya=N;Za=O;break b}da=c[g>>2]|0;fa=da+12|0;Lb=c[fa>>2]|0;if((Lb|0)==(c[da+16>>2]|0)){pe[c[(c[da>>2]|0)+40>>2]&127](da)|0}else{c[fa>>2]=Lb+4}a[k]=1;Lb=a[z]|0;if((Lb&1)==0){Mb=(Lb&255)>>>1}else{Mb=c[e>>2]|0}Va=M;Wa=r;Xa=L;Ya=Mb>>>0>1?z:N;Za=O;break b}if(P){P=pe[c[(c[ba>>2]|0)+36>>2]&127](ba)|0;Nb=P;Ob=a[y]|0}else{Nb=c[$>>2]|0;Ob=ra}if((Nb|0)!=(c[((Ob&1)==0?D:c[E>>2]|0)>>2]|0)){a[k]=1;Va=M;Wa=r;Xa=L;Ya=N;Za=O;break b}$=c[g>>2]|0;P=$+12|0;ba=c[P>>2]|0;if((ba|0)==(c[$+16>>2]|0)){pe[c[(c[$>>2]|0)+40>>2]&127]($)|0}else{c[P>>2]=ba+4}ba=a[y]|0;if((ba&1)==0){Pb=(ba&255)>>>1}else{Pb=c[D>>2]|0}Va=M;Wa=r;Xa=L;Ya=Pb>>>0>1?y:N;Za=O;break};default:{Va=M;Wa=r;Xa=L;Ya=N;Za=O}}}while(0);g:do{if((T|0)==28){T=0;if((o|0)==3){W=M;X=r;Y=N;Z=O;T=276;break a}else{Qb=V;Rb=V}while(1){ba=c[g>>2]|0;do{if((ba|0)==0){Sb=1}else{P=c[ba+12>>2]|0;if((P|0)==(c[ba+16>>2]|0)){Tb=pe[c[(c[ba>>2]|0)+36>>2]&127](ba)|0}else{Tb=c[P>>2]|0}if((Tb|0)==-1){c[g>>2]=0;Sb=1;break}else{Sb=(c[g>>2]|0)==0;break}}}while(0);do{if((Rb|0)==0){Ub=Qb;T=42}else{ba=c[Rb+12>>2]|0;if((ba|0)==(c[Rb+16>>2]|0)){Vb=pe[c[(c[Rb>>2]|0)+36>>2]&127](Rb)|0}else{Vb=c[ba>>2]|0}if((Vb|0)==-1){c[b>>2]=0;Ub=0;T=42;break}else{if(Sb^(Qb|0)==0){Wb=Qb;Xb=Qb;break}else{Va=M;Wa=r;Xa=L;Ya=N;Za=O;break g}}}}while(0);if((T|0)==42){T=0;if(Sb){Va=M;Wa=r;Xa=L;Ya=N;Za=O;break g}else{Wb=Ub;Xb=0}}ba=c[g>>2]|0;P=c[ba+12>>2]|0;if((P|0)==(c[ba+16>>2]|0)){Yb=pe[c[(c[ba>>2]|0)+36>>2]&127](ba)|0}else{Yb=c[P>>2]|0}if(!(se[c[(c[l>>2]|0)+12>>2]&63](l,8192,Yb)|0)){Va=M;Wa=r;Xa=L;Ya=N;Za=O;break g}P=c[g>>2]|0;ba=P+12|0;$=c[ba>>2]|0;if(($|0)==(c[P+16>>2]|0)){Zb=pe[c[(c[P>>2]|0)+40>>2]&127](P)|0}else{c[ba>>2]=$+4;Zb=c[$>>2]|0}xgb(A,Zb);Qb=Wb;Rb=Xb}}}while(0);ra=o+1|0;if(ra>>>0<4){L=Xa;r=Wa;M=Va;o=ra;N=Ya;O=Za}else{W=Va;X=Wa;Y=Ya;Z=Za;T=276;break}}h:do{if((T|0)==27){c[j>>2]=c[j>>2]|4;_b=0;$b=M;ac=O}else if((T|0)==116){c[j>>2]=c[j>>2]|4;_b=0;$b=M;ac=O}else if((T|0)==174){c[j>>2]=c[j>>2]|4;_b=0;$b=M;ac=O}else if((T|0)==206){hqb()}else if((T|0)==217){hqb()}else if((T|0)==240){c[j>>2]=c[j>>2]|4;_b=0;$b=wa;ac=za}else if((T|0)==263){c[j>>2]=c[j>>2]|4;_b=0;$b=wa;ac=za}else if((T|0)==274){c[j>>2]=c[j>>2]|4;_b=0;$b=wa;ac=za}else if((T|0)==276){i:do{if((Y|0)!=0){Za=Y+4|0;Ya=Y+8|0;Wa=1;j:while(1){Va=a[Y]|0;if((Va&1)==0){bc=(Va&255)>>>1}else{bc=c[Za>>2]|0}if(!(Wa>>>0<bc>>>0)){break i}Va=c[g>>2]|0;do{if((Va|0)==0){cc=1}else{N=c[Va+12>>2]|0;if((N|0)==(c[Va+16>>2]|0)){dc=pe[c[(c[Va>>2]|0)+36>>2]&127](Va)|0}else{dc=c[N>>2]|0}if((dc|0)==-1){c[g>>2]=0;cc=1;break}else{cc=(c[g>>2]|0)==0;break}}}while(0);Va=c[b>>2]|0;do{if((Va|0)==0){T=295}else{N=c[Va+12>>2]|0;if((N|0)==(c[Va+16>>2]|0)){ec=pe[c[(c[Va>>2]|0)+36>>2]&127](Va)|0}else{ec=c[N>>2]|0}if((ec|0)==-1){c[b>>2]=0;T=295;break}else{if(cc){break}else{break j}}}}while(0);if((T|0)==295){T=0;if(cc){break}}Va=c[g>>2]|0;N=c[Va+12>>2]|0;if((N|0)==(c[Va+16>>2]|0)){fc=pe[c[(c[Va>>2]|0)+36>>2]&127](Va)|0}else{fc=c[N>>2]|0}if((a[Y]&1)==0){gc=Za}else{gc=c[Ya>>2]|0}if((fc|0)!=(c[gc+(Wa<<2)>>2]|0)){break}N=Wa+1|0;Va=c[g>>2]|0;o=Va+12|0;r=c[o>>2]|0;if((r|0)==(c[Va+16>>2]|0)){pe[c[(c[Va>>2]|0)+40>>2]&127](Va)|0;Wa=N;continue}else{c[o>>2]=r+4;Wa=N;continue}}c[j>>2]=c[j>>2]|4;_b=0;$b=W;ac=Z;break h}}while(0);if((W|0)==(X|0)){_b=1;$b=X;ac=Z;break}c[C>>2]=0;Nlb(w,W,X,C);if((c[C>>2]|0)==0){_b=1;$b=W;ac=Z;break}c[j>>2]=c[j>>2]|4;_b=0;$b=W;ac=Z}}while(0);tgb(A);tgb(z);tgb(y);tgb(x);Rfb(w);if(($b|0)==0){i=p;return _b|0}me[ac&2047]($b);i=p;return _b|0}function Slb(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=i;i=i+464|0;l=d;m=d+8|0;n=d+24|0;o=d+424|0;p=d+432|0;q=d+440|0;r=d+448|0;s=d+456|0;t=o;c[t>>2]=n;u=o+4|0;c[u>>2]=1433;v=n+400|0;Ngb(q,h);n=q;w=c[n>>2]|0;if(!((c[78530]|0)==-1)){c[m>>2]=314120;c[m+4>>2]=1431;c[m+8>>2]=0;Cfb(314120,m,1432)}m=(c[314124>>2]|0)+ -1|0;x=c[w+8>>2]|0;if(!((c[w+12>>2]|0)-x>>2>>>0>m>>>0)){y=Hc(4)|0;z=y;Bpb(z);A=329688;B=128;_d(y|0,A|0,B|0)}w=c[x+(m<<2)>>2]|0;if((w|0)==0){y=Hc(4)|0;z=y;Bpb(z);A=329688;B=128;_d(y|0,A|0,B|0)}B=w;a[r]=0;A=f;f=c[A>>2]|0;c[s>>2]=f;y=c[h+4>>2]|0;h=l;z=s;c[h+0>>2]=c[z+0>>2];z=Rlb(e,l,g,q,y,j,r,B,o,p,v)|0;if(z){if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}if((a[r]|0)!=0){xgb(k,Ee[c[(c[w>>2]|0)+44>>2]&63](B,45)|0)}r=Ee[c[(c[w>>2]|0)+44>>2]&63](B,48)|0;B=c[t>>2]|0;w=c[p>>2]|0;p=w+ -4|0;a:do{if(B>>>0<p>>>0){z=B;while(1){v=z+4|0;if((c[z>>2]|0)!=(r|0)){C=z;break a}if(v>>>0<p>>>0){z=v}else{C=v;break}}}else{C=B}}while(0);Tlb(k,C,w)|0}w=e;e=c[w>>2]|0;do{if((e|0)==0){D=1}else{C=c[e+12>>2]|0;if((C|0)==(c[e+16>>2]|0)){E=pe[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{E=c[C>>2]|0}if((E|0)==-1){c[w>>2]=0;D=1;break}else{D=(c[w>>2]|0)==0;break}}}while(0);do{if((f|0)==0){F=29}else{E=c[f+12>>2]|0;if((E|0)==(c[f+16>>2]|0)){G=pe[c[(c[f>>2]|0)+36>>2]&127](f)|0}else{G=c[E>>2]|0}if((G|0)==-1){c[A>>2]=0;F=29;break}else{if(D){break}else{F=31;break}}}}while(0);if((F|0)==29){if(D){F=31}}if((F|0)==31){c[j>>2]=c[j>>2]|2}c[b>>2]=c[w>>2];hfb(c[n>>2]|0)|0;n=c[t>>2]|0;c[t>>2]=0;if((n|0)==0){i=d;return}me[c[u>>2]&2047](n);i=d;return}function Tlb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=d;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1;k=h;l=1}else{h=c[b>>2]|0;j=c[b+4>>2]|0;k=h&255;l=(h&-2)+ -1|0}h=e-g>>2;if((h|0)==0){i=f;return b|0}if((l-j|0)>>>0<h>>>0){zgb(b,l,j+h-l|0,j,j,0,0);m=a[b]|0}else{m=k}if((m&1)==0){n=b+4|0}else{n=c[b+8>>2]|0}m=n+(j<<2)|0;if((d|0)==(e|0)){o=m}else{k=j+((e+ -4+(0-g)|0)>>>2)+1|0;g=d;d=m;while(1){c[d>>2]=c[g>>2];m=g+4|0;if((m|0)==(e|0)){break}else{d=d+4|0;g=m}}o=n+(k<<2)|0}c[o>>2]=0;o=j+h|0;if((a[b]&1)==0){a[b]=o<<1;i=f;return b|0}else{c[b+4>>2]=o;i=f;return b|0}return 0}function Ulb(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;n=i;i=i+176|0;o=n;p=n+16|0;q=n+32|0;r=n+40|0;s=n+56|0;t=n+72|0;u=n+88|0;v=n+104|0;w=n+112|0;x=n+128|0;y=n+144|0;z=n+160|0;if(b){b=c[d>>2]|0;if(!((c[78424]|0)==-1)){c[p>>2]=313696;c[p+4>>2]=1431;c[p+8>>2]=0;Cfb(313696,p,1432)}p=(c[313700>>2]|0)+ -1|0;A=c[b+8>>2]|0;if(!((c[b+12>>2]|0)-A>>2>>>0>p>>>0)){B=Hc(4)|0;C=B;Bpb(C);D=329688;E=128;_d(B|0,D|0,E|0)}b=c[A+(p<<2)>>2]|0;if((b|0)==0){B=Hc(4)|0;C=B;Bpb(C);D=329688;E=128;_d(B|0,D|0,E|0)}E=b;ne[c[(c[b>>2]|0)+44>>2]&255](q,E);D=e;B=c[q>>2]|0;a[D]=B;a[D+1|0]=B>>8;a[D+2|0]=B>>16;a[D+3|0]=B>>24;ne[c[(c[b>>2]|0)+32>>2]&255](r,E);B=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}wgb(l,0);D=r;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;tgb(r);ne[c[(c[b>>2]|0)+28>>2]&255](s,E);r=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}wgb(k,0);D=s;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;tgb(s);c[f>>2]=pe[c[(c[b>>2]|0)+12>>2]&127](E)|0;c[g>>2]=pe[c[(c[b>>2]|0)+16>>2]&127](E)|0;ne[c[(c[b>>2]|0)+20>>2]&255](t,E);s=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}bgb(h,0);D=t;c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;Rfb(t);ne[c[(c[b>>2]|0)+24>>2]&255](u,E);t=j;if((a[j]&1)==0){c[j+4>>2]=0;a[j]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}wgb(j,0);D=u;c[t+0>>2]=c[D+0>>2];c[t+4>>2]=c[D+4>>2];c[t+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;tgb(u);F=pe[c[(c[b>>2]|0)+36>>2]&127](E)|0;c[m>>2]=F;i=n;return}else{E=c[d>>2]|0;if(!((c[78408]|0)==-1)){c[o>>2]=313632;c[o+4>>2]=1431;c[o+8>>2]=0;Cfb(313632,o,1432)}o=(c[313636>>2]|0)+ -1|0;d=c[E+8>>2]|0;if(!((c[E+12>>2]|0)-d>>2>>>0>o>>>0)){G=Hc(4)|0;H=G;Bpb(H);I=329688;J=128;_d(G|0,I|0,J|0)}E=c[d+(o<<2)>>2]|0;if((E|0)==0){G=Hc(4)|0;H=G;Bpb(H);I=329688;J=128;_d(G|0,I|0,J|0)}J=E;ne[c[(c[E>>2]|0)+44>>2]&255](v,J);I=e;e=c[v>>2]|0;a[I]=e;a[I+1|0]=e>>8;a[I+2|0]=e>>16;a[I+3|0]=e>>24;ne[c[(c[E>>2]|0)+32>>2]&255](w,J);e=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}wgb(l,0);l=w;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;tgb(w);ne[c[(c[E>>2]|0)+28>>2]&255](x,J);w=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}wgb(k,0);k=x;c[w+0>>2]=c[k+0>>2];c[w+4>>2]=c[k+4>>2];c[w+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;tgb(x);c[f>>2]=pe[c[(c[E>>2]|0)+12>>2]&127](J)|0;c[g>>2]=pe[c[(c[E>>2]|0)+16>>2]&127](J)|0;ne[c[(c[E>>2]|0)+20>>2]&255](y,J);g=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}bgb(h,0);h=y;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;Rfb(y);ne[c[(c[E>>2]|0)+24>>2]&255](z,J);y=j;if((a[j]&1)==0){c[j+4>>2]=0;a[j]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}wgb(j,0);j=z;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;tgb(z);F=pe[c[(c[E>>2]|0)+36>>2]&127](J)|0;c[m>>2]=F;i=n;return}}function Vlb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=a+4|0;g=(c[f>>2]|0)!=1433;h=a;a=c[h>>2]|0;j=a;k=(c[d>>2]|0)-j|0;l=k>>>0<2147483647?k<<1:-1;k=(c[b>>2]|0)-j>>2;if(g){m=a}else{m=0}a=Zpb(m,l)|0;m=a;if((a|0)==0){hqb()}do{if(g){c[h>>2]=m;n=m}else{a=c[h>>2]|0;c[h>>2]=m;if((a|0)==0){n=m;break}me[c[f>>2]&2047](a);n=c[h>>2]|0}}while(0);c[f>>2]=1408;c[b>>2]=n+(k<<2);c[d>>2]=(c[h>>2]|0)+(l>>>2<<2);i=e;return}function Wlb(a){a=a|0;var b=0;b=i;cqb(a);i=b;return}function Xlb(a){a=a|0;i=i;return}function Ylb(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+16|0;m=d;n=d+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+104|0;r=i;i=i+8|0;s=i;i=i+104|0;t=i;i=i+8|0;u=i;i=i+8|0;v=u;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+104|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=q;c[r>>2]=G;q=s;s=o;h[k>>3]=l;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=Pc(G|0,100,313880,o|0)|0;do{if(s>>>0>99){do{if((a[314024]|0)==0){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);o=c[78504]|0;G=n;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=Qjb(r,o,313880,n)|0;o=c[r>>2]|0;if((o|0)==0){hqb()}H=Wpb(G)|0;if((H|0)!=0){I=o;J=H;K=H;L=G;break}hqb()}else{I=0;J=0;K=q;L=s}}while(0);Ngb(t,g);s=t;q=c[s>>2]|0;if(!((c[78532]|0)==-1)){c[p>>2]=314128;c[p+4>>2]=1431;c[p+8>>2]=0;Cfb(314128,p,1432)}p=(c[314132>>2]|0)+ -1|0;n=c[q+8>>2]|0;if(!((c[q+12>>2]|0)-n>>2>>>0>p>>>0)){M=Hc(4)|0;N=M;Bpb(N);O=329688;P=128;_d(M|0,O|0,P|0)}q=c[n+(p<<2)>>2]|0;if((q|0)==0){M=Hc(4)|0;N=M;Bpb(N);O=329688;P=128;_d(M|0,O|0,P|0)}P=q;O=c[r>>2]|0;Oe[c[(c[q>>2]|0)+32>>2]&63](P,O,O+L|0,K)|0;if((L|0)==0){Q=0}else{Q=(a[c[r>>2]|0]|0)==45}c[u>>2]=0;u=y;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=z;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=A;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Zlb(f,Q,t,v,w,x,y,z,A,B);t=C;C=c[B>>2]|0;if((L|0)>(C|0)){B=a[A]|0;if((B&1)==0){R=(B&255)>>>1}else{R=c[A+4>>2]|0}B=a[z]|0;if((B&1)==0){S=(B&255)>>>1}else{S=c[z+4>>2]|0}T=R+(L-C<<1|1)+S|0}else{S=a[A]|0;if((S&1)==0){U=(S&255)>>>1}else{U=c[A+4>>2]|0}S=a[z]|0;if((S&1)==0){V=(S&255)>>>1}else{V=c[z+4>>2]|0}T=U+2+V|0}V=T+C|0;do{if(V>>>0>100){T=Wpb(V)|0;if((T|0)!=0){W=T;X=T;break}hqb()}else{W=0;X=t}}while(0);_lb(X,D,E,c[g+4>>2]|0,K,K+L|0,P,Q,v,a[w]|0,a[x]|0,y,z,A,C);c[F>>2]=c[e>>2];e=c[D>>2]|0;D=c[E>>2]|0;E=m;C=F;c[E+0>>2]=c[C+0>>2];ncb(b,m,X,e,D,g,j);if((W|0)!=0){Xpb(W)}Rfb(A);Rfb(z);Rfb(y);hfb(c[s>>2]|0)|0;if((J|0)!=0){Xpb(J)}if((I|0)==0){i=d;return}Xpb(I);i=d;return}function Zlb(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+40|0;o=n;p=n+16|0;q=n+32|0;r=q;s=i;i=i+16|0;t=i;i=i+8|0;u=t;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=B;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[e>>2]|0;if(b){if(!((c[78392]|0)==-1)){c[p>>2]=313568;c[p+4>>2]=1431;c[p+8>>2]=0;Cfb(313568,p,1432)}p=(c[313572>>2]|0)+ -1|0;b=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-b>>2>>>0>p>>>0)){H=Hc(4)|0;I=H;Bpb(I);J=329688;K=128;_d(H|0,J|0,K|0)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){H=Hc(4)|0;I=H;Bpb(I);J=329688;K=128;_d(H|0,J|0,K|0)}K=e;J=c[e>>2]|0;if(d){ne[c[J+44>>2]&255](r,K);r=f;H=c[q>>2]|0;a[r]=H;a[r+1|0]=H>>8;a[r+2|0]=H>>16;a[r+3|0]=H>>24;ne[c[(c[e>>2]|0)+32>>2]&255](s,K);H=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}bgb(l,0);r=s;c[H+0>>2]=c[r+0>>2];c[H+4>>2]=c[r+4>>2];c[H+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;Rfb(s)}else{ne[c[J+40>>2]&255](u,K);u=f;J=c[t>>2]|0;a[u]=J;a[u+1|0]=J>>8;a[u+2|0]=J>>16;a[u+3|0]=J>>24;ne[c[(c[e>>2]|0)+28>>2]&255](v,K);J=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}bgb(l,0);u=v;c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Rfb(v)}a[g]=pe[c[(c[e>>2]|0)+12>>2]&127](K)|0;a[h]=pe[c[(c[e>>2]|0)+16>>2]&127](K)|0;ne[c[(c[e>>2]|0)+20>>2]&255](w,K);v=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}bgb(j,0);u=w;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Rfb(w);ne[c[(c[e>>2]|0)+24>>2]&255](x,K);w=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}bgb(k,0);u=x;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Rfb(x);L=pe[c[(c[e>>2]|0)+36>>2]&127](K)|0;c[m>>2]=L;i=n;return}else{if(!((c[78376]|0)==-1)){c[o>>2]=313504;c[o+4>>2]=1431;c[o+8>>2]=0;Cfb(313504,o,1432)}o=(c[313508>>2]|0)+ -1|0;K=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-K>>2>>>0>o>>>0)){M=Hc(4)|0;N=M;Bpb(N);O=329688;P=128;_d(M|0,O|0,P|0)}G=c[K+(o<<2)>>2]|0;if((G|0)==0){M=Hc(4)|0;N=M;Bpb(N);O=329688;P=128;_d(M|0,O|0,P|0)}P=G;O=c[G>>2]|0;if(d){ne[c[O+44>>2]&255](z,P);z=f;d=c[y>>2]|0;a[z]=d;a[z+1|0]=d>>8;a[z+2|0]=d>>16;a[z+3|0]=d>>24;ne[c[(c[G>>2]|0)+32>>2]&255](A,P);d=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}bgb(l,0);z=A;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;Rfb(A)}else{ne[c[O+40>>2]&255](C,P);C=f;f=c[B>>2]|0;a[C]=f;a[C+1|0]=f>>8;a[C+2|0]=f>>16;a[C+3|0]=f>>24;ne[c[(c[G>>2]|0)+28>>2]&255](D,P);f=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}bgb(l,0);l=D;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;Rfb(D)}a[g]=pe[c[(c[G>>2]|0)+12>>2]&127](P)|0;a[h]=pe[c[(c[G>>2]|0)+16>>2]&127](P)|0;ne[c[(c[G>>2]|0)+20>>2]&255](E,P);h=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}bgb(j,0);j=E;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;Rfb(E);ne[c[(c[G>>2]|0)+24>>2]&255](F,P);E=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}bgb(k,0);k=F;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;Rfb(F);L=pe[c[(c[G>>2]|0)+36>>2]&127](P)|0;c[m>>2]=L;i=n;return}}



function $bb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0;b=i;i=i+8|0;a=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[296948>>2]|0;H=c[297076>>2]|0;I=c[2]|0;if((c[240180>>2]|0)==0){if(!((c[296896>>2]|0)==0|(I|0)!=0)){J=3}}else{J=3}if((J|0)==3){c[2]=1}J=d+248|0;K=d+240|0;L=~~+Eb(+((+h[J>>3]- +h[K>>3])/+h[d+264>>3]));c[d+256>>2]=L;c[l>>2]=L;kXa(23,0,287632,l);l=c[297020>>2]|0;do{if((l|0)==0){M=0}else{if((uqb(l,287656)|0)==0){M=1;break}if((uqb(l,287664)|0)==0){M=0;break}if((uqb(l,287672)|0)==0){M=2;break}c[j>>2]=l;mXa(1,0,287680,j);M=0}}while(0);if((BYa(M)|0)!=0){c[g>>2]=l;mXa(1,0,287752,g)}if((c[2]|0)!=0){jdb(d+56|0);GYa((c[d+64>>2]|0)+13+(c[d+68>>2]|0)+(c[d+72>>2]|0)|0);CYa(0);CYa(6);DYa(3);DYa(4);DYa(1)}g=(G|0)!=0;if(g){if((H|0)==0){N=+h[K>>3]}else{N=+qqb(H)}h[J>>3]=N;J=f;h[k>>3]=N;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];kXa(1,0,287840,f)}do{if((c[297004>>2]|0)!=0){f=aqb(12)|0;J=f;Lfb(J,c[297132>>2]|0);if((f|0)==0){break}f=mgb(J)|0;c[d+280>>2]=f;c[e>>2]=f;kXa(23,0,287896,e)}}while(0);e=c[297128>>2]|0;Ffb(m);if((e|0)==0){Lfb(p,c[d+88>>2]|0);Lfb(q,287944);acb(o,p,q);I4a(n,o,c[d+284>>2]|0);Sfb(m,n)|0;Rfb(n);Rfb(o);Rfb(q);Rfb(p)}else{Tfb(m,e)|0}Lfb(r,287952);Lfb(s,287952);Lfb(t,287952);Lfb(u,287952);Lfb(v,287952);Lfb(w,287952);e=c[296896>>2]|0;if((c[296916>>2]|0)!=0){Tfb(r,c[297044>>2]|0)|0}if((c[296932>>2]|0)!=0){Tfb(s,c[297060>>2]|0)|0}if((c[296912>>2]|0)!=0){Tfb(t,c[297040>>2]|0)|0}if((c[296920>>2]|0)==0){O=0.0}else{Tfb(u,c[297048>>2]|0)|0;O=+qqb(mgb(u)|0)}if((c[296924>>2]|0)==0){P=1}else{Tfb(v,c[297052>>2]|0)|0;P=Ic(mgb(v)|0)|0}if((c[296984>>2]|0)!=0){Tfb(w,c[297112>>2]|0)|0}Hfb(x,m);Hfb(y,r);Hfb(z,s);Hfb(A,t);Hfb(B,w);p=bcb(d,x,y,z,A,O,P,B,e)|0;Rfb(B);Rfb(A);Rfb(z);Rfb(y);Rfb(x);if((p|0)!=0|g^1){Q=p}else{CYa(5);p=Acb(d)|0;FYa(5);kXa(1,0,287960,a);Q=p}c[2]=I;if(!((Q|0)==0&(I|0)!=0)){R=Q;Rfb(w);Rfb(v);Rfb(u);Rfb(t);Rfb(s);Rfb(r);Rfb(m);i=b;return R|0}Q=d+88|0;Lfb(D,c[Q>>2]|0);I4a(C,D,287992);Rfb(D);Lfb(F,c[Q>>2]|0);I4a(E,F,288008);Rfb(F);FYa(0);F=c[297096>>2]|0;Q=mgb(C)|0;D=mgb(E)|0;I=c[d+280>>2]|0;p=c[d+284>>2]|0;Zcb(d,Q,D,(F|0)!=0?F:288024,I,p,mgb(m)|0)|0;Rfb(E);Rfb(C);R=0;Rfb(w);Rfb(v);Rfb(u);Rfb(t);Rfb(s);Rfb(r);Rfb(m);i=b;return R|0}function acb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+8|0;Gfb(a,d);e=Pfb(b)|0;f=Pfb(c)|0;qgb(a,Qfb(b)|0,e,f+e|0);igb(a,Qfb(c)|0,f)|0;i=d;return}function bcb(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;l=i;i=i+8|0;m=l;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;if((Pfb(j)|0)==0){u=0}else{u=mgb(j)|0}Hfb(r,b);b=(ccb(a,r,k)|0)==0;Rfb(r);if(!b){v=-1;i=l;return v|0}Lfb(s,287952);b=a+280|0;r=Wbb(s,c[b>>2]|0)|0;Rfb(s);do{if(r){w=3}else{s=1;k=0;do{Lfb(t,c[288168+(s<<2)>>2]|0);j=Wbb(t,c[b>>2]|0)|0;Rfb(t);k=j?s:k;s=s+1|0;}while((s|0)<20);if((k|0)!=0){w=k;break}c[q>>2]=c[b>>2];mXa(1,0,288248,q);mXa(1,0,287248,p);s=1;do{j=c[288280+(s<<2)>>2]|0;c[o>>2]=c[288168+(s<<2)>>2];c[o+4>>2]=j;mXa(1,0,287272,o);s=s+1|0;}while((s|0)<20);oXa(c[a+536>>2]|0,287376,n)}}while(0);c[m>>2]=c[288168+(w<<2)>>2];kXa(23,0,288360,m);m=mgb(d)|0;d=mgb(e)|0;e=z$a(a,m,d,mgb(f)|0,g,h,w,u)|0;ne[c[281612>>2]&255](281584,a);v=e;i=l;return v|0}function ccb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=c[a+256>>2]<<2;c[70396]=Hd(mgb(b)|0)|0;c[281588>>2]=g;c[281592>>2]=d;d=a+284|0;do{if((c[71806]|0)==0){g=c[d>>2]|0;if((uqb(288032,g)|0)==0){h=0;break}if((uqb(288040,g)|0)==0){c[281600>>2]=186;c[281604>>2]=187;c[281612>>2]=188;h=0;break}if((uqb(288048,g)|0)==0){c[281600>>2]=189;c[281604>>2]=190;c[281608>>2]=191;c[281612>>2]=192;h=1;break}if((uqb(288056,g)|0)==0){c[281600>>2]=193;c[281604>>2]=194;c[281608>>2]=195;c[281612>>2]=196;h=1;break}if((uqb(288064,g)|0)==0){c[281600>>2]=197;c[281604>>2]=198;c[281612>>2]=199;h=0;break}g=Ybb(309488,288072)|0;cib(Ybb(g,c[d>>2]|0)|0,103)|0;j=1;i=e;return j|0}else{h=0}}while(0);_bb(a+8|0,c[a+288>>2]|0,h);ne[c[281600>>2]&255](281584,a);a=c[70396]|0;c[f>>2]=c[d>>2];c[f+4>>2]=a;kXa(23,0,288096,f);j=0;i=e;return j|0}function dcb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+16|0;bXa();do{if((rdb(a,b)|0)==0){if((tdb(a,b)|0)!=0){break}do{if((c[296952>>2]|0)!=0){w=c[297080>>2]|0;if((uqb(w,288480)|0)==0){hXa(1);break}if((uqb(w,288488)|0)==0){hXa(0);break}else{c[p>>2]=w;mXa(1,0,288496,p);Bd(0)|0;Jd(0)}}}while(0);if((c[296908>>2]|0)==0){Tbb(0,0);x_a(d);if((d|0)==0){cib(Ybb(309488,288864)|0,103)|0}c[d+300>>2]=Vbb(0,0)|0;c[d+292>>2]=Xbb(0,0)|0;F4a(d+8|0,d+240|0);F_a(d)|0;N_a(d)|0;Z_a(d)|0;do{if((c[d+116>>2]|0)==0){if((c[d+124>>2]|0)==0){break}if((c[d+128>>2]|0)==0){break}cib(Ybb(309488,288928)|0,103)|0;x=1;i=e;return x|0}}while(0);c[71806]=c[296976>>2];x=0;i=e;return x|0}Lfb(u,c[297036>>2]|0);w=1;while(1){y=244872+(w<<2)|0;Lfb(v,c[y>>2]|0);z=Ubb(u,v)|0;Rfb(v);A=w+1|0;if(z){break}if((A|0)<31){w=A}else{B=33;break}}if((B|0)==33){c[g>>2]=mgb(u)|0;mXa(1,0,288768,g);c[f>>2]=c[b>>2];mXa(1,0,288808,f);Bd(0)|0;Jd(0)}A=c[248896+(w<<2)>>2]|0;do{if((A|0)==1){z=c[248768+(w<<2)>>2]|0;c[o>>2]=c[y>>2];c[o+4>>2]=z;kXa(1,1,288568,o)}else{z=c[y>>2]|0;if((A|0)==2){C=c[248768+(w<<2)>>2]|0;c[n>>2]=z;c[n+4>>2]=z;c[n+8>>2]=C;kXa(1,1,288608,n);break}else{c[m>>2]=z;mXa(1,1,288448,m);break}}}while(0);if((w|0)==19){A=c[59592]|0;if((A|0)<28){D=A}else{E=240632;F=c[60158]|0;me[F&2047](1);G=Bd(0)|0;Jd(0)}do{A=c[239952+(D<<2)>>2]|0;c[l>>2]=c[238784+(D<<2)>>2];c[l+4>>2]=A;kXa(1,0,287272,l);D=D+1|0;}while((D|0)<28);E=240632;F=c[60158]|0;me[F&2047](1);G=Bd(0)|0;Jd(0)}else if((w|0)==29){A=1;do{z=c[288280+(A<<2)>>2]|0;c[h>>2]=c[288168+(A<<2)>>2];c[h+4>>2]=z;kXa(1,0,287272,h);A=A+1|0;}while((A|0)<20);E=240632;F=c[60158]|0;me[F&2047](1);G=Bd(0)|0;Jd(0)}else if((w|0)==11){A=1;do{z=c[288736+(A<<2)>>2]|0;c[j>>2]=c[288704+(A<<2)>>2];c[j+4>>2]=z;kXa(1,0,287272,j);A=A+1|0;}while((A|0)<7);E=240632;F=c[60158]|0;me[F&2047](1);G=Bd(0)|0;Jd(0)}else if((w|0)==7){A=1;do{z=c[288688+(A<<2)>>2]|0;c[k>>2]=c[288672+(A<<2)>>2];c[k+4>>2]=z;kXa(1,0,287272,k);A=A+1|0;}while((A|0)<4);E=240632;F=c[60158]|0;me[F&2047](1);G=Bd(0)|0;Jd(0)}else{E=240632;F=c[60158]|0;me[F&2047](1);G=Bd(0)|0;Jd(0)}}}while(0);c[t>>2]=c[b>>2];kXa(1,1,288384,t);t=1;do{b=c[248896+(t<<2)>>2]|0;do{if((b|0)==1){G=c[246776+(t<<2)>>2]|0;c[s>>2]=c[244872+(t<<2)>>2];c[s+4>>2]=G;kXa(1,0,288400,s)}else{G=c[244872+(t<<2)>>2]|0;if((b|0)==2){F=c[246776+(t<<2)>>2]|0;c[r>>2]=G;c[r+4>>2]=G;c[r+8>>2]=F;kXa(1,0,288416,r);break}else{c[q>>2]=G;mXa(1,0,288448,q);break}}}while(0);t=t+1|0;}while((t|0)<31);me[c[60158]&2047](1);Bd(0)|0;Jd(0);return 0}function ecb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0;a=i;i=i+8|0;b=a;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=c[72240]|0;wb(290608)|0;c[l>>2]=c[m+88>>2];kc(288968,l|0)|0;wb(290624)|0;l=j;h[k>>3]=+h[m+264>>3];c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];kc(288992,j|0)|0;j=m+4|0;m=g;h[k>>3]=+h[c[(c[j>>2]|0)+4>>2]>>3];c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];kc(289032,g|0)|0;g=f;h[k>>3]=+h[c[(c[j>>2]|0)+8>>2]>>3];c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];kc(289064,f|0)|0;f=c[j>>2]|0;g=e;h[k>>3]=+h[c[f+4>>2]>>3]- +h[c[f+8>>2]>>3];c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];kc(289096,e|0)|0;e=d;h[k>>3]=+h[c[c[j>>2]>>2]>>3];c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];kc(289128,d|0)|0;d=c[j>>2]|0;j=b;h[k>>3]=+h[c[d>>2]>>3]- +h[c[d+4>>2]>>3];c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];kc(289160,b|0)|0;wb(290648)|0;i=a;return}function fcb(a,b){a=a|0;b=+b;i=i;return}function gcb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0;e=i;f=i;i=i+168|0;c[f>>2]=0;g=i;i=i+160|0;h=(c[d+536>>2]|0)+76|0;j=c[h>>2]|0;c[h>>2]=g;xqb(g,1,f|0)|0;u=0;g=u;u=0;if((g|0)!=0&(v|0)!=0){k=Lqb(c[g>>2]|0,f)|0;if((k|0)==0){fb(g|0,v|0)}J=v}else{k=-1}if((k|0)==1){l=J}else{l=0}while(1){if((l|0)==0){u=0;k=va(42,a|0,b|0,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){m=Lqb(c[g>>2]|0,f)|0;if((m|0)==0){fb(g|0,v|0)}J=v}else{m=-1}if((m|0)==1){l=J;continue}if((k|0)!=0){n=1;o=17;break}c[72240]=d;u=0;Ha(61,10,1427)|0;k=u;u=0;if((k|0)!=0&(v|0)!=0){p=Lqb(c[k>>2]|0,f)|0;if((p|0)==0){fb(k|0,v|0)}J=v}else{p=-1}if((p|0)==1){l=J;continue}u=0;k=va(43,0,0,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){q=Lqb(c[g>>2]|0,f)|0;if((q|0)==0){fb(g|0,v|0)}J=v}else{q=-1}if((q|0)==1){l=J;continue}u=0;sa(108,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){r=Lqb(c[g>>2]|0,f)|0;if((r|0)==0){fb(g|0,v|0)}J=v}else{r=-1}if((r|0)==1){l=J;continue}u=0;sa(109,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){s=Lqb(c[g>>2]|0,f)|0;if((s|0)==0){fb(g|0,v|0)}J=v}else{s=-1}if((s|0)==1){l=J;continue}u=0;sa(110,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){t=Lqb(c[g>>2]|0,f)|0;if((t|0)==0){fb(g|0,v|0)}J=v}else{t=-1}if((t|0)==1){l=J;continue}u=0;pa(c[(c[d+540>>2]|0)+8>>2]|0,d|0);g=u;u=0;if((g|0)!=0&(v|0)!=0){w=Lqb(c[g>>2]|0,f)|0;if((w|0)==0){fb(g|0,v|0)}J=v}else{w=-1}if((w|0)==1){l=J;continue}u=0;pa(1428,d|0);g=u;u=0;if((g|0)!=0&(v|0)!=0){x=Lqb(c[g>>2]|0,f)|0;if((x|0)==0){fb(g|0,v|0)}J=v}else{x=-1}if((x|0)==1){l=J;continue}u=0;sa(99,0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){y=Lqb(c[g>>2]|0,f)|0;if((y|0)==0){fb(g|0,v|0)}J=v}else{y=-1}if((y|0)==1){l=J;continue}z=k}else{z=-1}c[h>>2]=j;u=0;k=u;u=0;if((k|0)!=0&(v|0)!=0){A=Lqb(c[k>>2]|0,f)|0;if((A|0)==0){fb(k|0,v|0)}J=v}else{A=-1}if((A|0)==1){l=J}else{break}}if((o|0)==17){i=e;return n|0}n=z;i=e;return n|0}function hcb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;f=i;i=i+16|0;if((a|0)==0){g=rd(c[59490]|0)|0}else{g=a}switch(c[g+84>>2]|0){case 2:{if((c[240092>>2]|0)==0){h=g;j=h+80|0;k=j;l=c[k>>2]|0;m=l;n=m;fb(n|0,1)}c[f>>2]=e;a=c[r>>2]|0;uc(289296,7,1,a|0)|0;Gc(a|0,d|0,f|0)|0;Zd(10,a|0)|0;Bd(0)|0;h=g;j=h+80|0;k=j;l=c[k>>2]|0;m=l;n=m;fb(n|0,1);break};case 1:{c[f>>2]=e;n=c[r>>2]|0;uc(289296,7,1,n|0)|0;Gc(n|0,d|0,f|0)|0;Zd(10,n|0)|0;Bd(0)|0;fb(c[g+80>>2]|0,1);break};case 3:{if((c[240148>>2]|0)==0){i=b;return}c[f>>2]=e;e=c[r>>2]|0;uc(289296,7,1,e|0)|0;Gc(e|0,d|0,f|0)|0;Zd(10,e|0)|0;Bd(0)|0;i=b;return};case 5:case 4:{i=b;return};default:{oXa(g,289304,b)}}}function icb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;i=i+16|0;e=a;c[e>>2]=d;d=c[r>>2]|0;uc(289280,9,1,d|0)|0;Gc(d|0,b|0,e|0)|0;Zd(10,d|0)|0;Bd(0)|0;i=a;return}function jcb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;qcb(289224,b);c[71798]=287952;b=287196|0;c[b+0>>2]=-1;c[b+4>>2]=-1;c[b+8>>2]=-1;c[b+12>>2]=-1;c[287212>>2]=1;if((a|0)!=0){d=a;e=d;f=e+76|0;g=f;h=c[g>>2]|0;j=h;k=j;fb(k|0,1)}d=rd(c[59490]|0)|0;e=d;f=e+76|0;g=f;h=c[g>>2]|0;j=h;k=j;fb(k|0,1)}function kcb(a,b){a=a|0;b=b|0;var c=0;c=i;mcb(a,b);i=c;return}function lcb(a){a=a|0;i=i;return(c[a>>2]|0)==0|0}function mcb(a,b){a=a|0;b=b|0;var d=0;d=i;c[a>>2]=Kgb(b+(c[(c[b>>2]|0)+ -12>>2]|0)|0)|0;i=d;return}function ncb(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i;i=i+48|0;k=j+8|0;l=j+16|0;m=j+32|0;n=j+40|0;o=b;b=c[o>>2]|0;g1a(j);if((b|0)==0){c[a>>2]=0;i=j;return}p=f;f=d;q=p-f|0;r=ocb(g)|0;s=(r|0)>(q|0)?r-q|0:0;q=e;r=q-f|0;do{if((r|0)>0){if((Wgb(b,d,r)|0)==(r|0)){break}g1a(k);c[o>>2]=0;c[a>>2]=0;i=j;return}}while(0);do{if((s|0)>0){Mfb(l,s,h);if((Wgb(b,Qfb(l)|0,s)|0)==(s|0)){Rfb(l);break}g1a(m);c[o>>2]=0;c[a>>2]=0;Rfb(l);i=j;return}}while(0);l=p-q|0;do{if((l|0)>0){if((Wgb(b,e,l)|0)==(l|0)){break}g1a(n);c[o>>2]=0;c[a>>2]=0;i=j;return}}while(0);pcb(g,0)|0;c[a>>2]=b;i=j;return}function ocb(a){a=a|0;i=i;return c[a+12>>2]|0}function pcb(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;a=c[d>>2]|0;c[d>>2]=b;i=i;return a|0}function qcb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=d+8|0;g=c[71804]|0;if((g|0)==0){c[e>>2]=(yqb(a|0)|0)<<1|1;c[f>>2]=2048;h=c[(w5a(e,f)|0)>>2]|0;c[72318]=h;f=Wpb(h)|0;c[71804]=f;j=h;k=f}else{j=c[72318]|0;k=g}g=bd(k|0,j|0,a|0,b|0)|0;if(g>>>0<(c[72318]|0)>>>0){i=d;return}Xpb(c[71804]|0);j=g<<1|1;c[72318]=j;g=Wpb(j)|0;c[71804]=g;bd(g|0,j|0,a|0,b|0)|0;i=d;return}function rcb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+136|0;g=f;scb(g,16);tcb(g+(c[(c[g>>2]|0)+ -12>>2]|0)|0,16)|0;if((d|0)<=0){ucb(a,g);vcb(g);i=f;return}j=e+ -1|0;k=(j|0)>0;l=(e|0)>0;m=g;n=(e|0)==0;e=0;do{if(k){o=0;p=e;while(1){Ybb(dib(m,+h[b+(p<<3)>>3])|0,290664)|0;q=p+d|0;r=o+1|0;if((r|0)<(j|0)){p=q;o=r}else{s=q;break}}}else{s=e}if(l){dib(m,+h[b+(s<<3)>>3])|0}e=e+1|0;if(!((e|0)==(d|0)|n)){Ybb(m,290672)|0}}while((e|0)<(d|0));ucb(a,g);vcb(g);i=f;return}function scb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=a+56|0;Ogb(e);f=a;c[f>>2]=291044;g=e;c[g>>2]=291064;e=a+4|0;Vhb(a,291076|0,e);c[f>>2]=291044;c[g>>2]=291064;Hcb(e,b|16);i=d;return}function tcb(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;a=c[d>>2]|0;c[d>>2]=b;i=i;return a|0}function ucb(a,b){a=a|0;b=b|0;var c=0;c=i;Bcb(a,b+4|0);i=c;return}function vcb(a){a=a|0;var b=0;b=i;Lcb(a,291072);Jgb(a+56|0);i=b;return}function wcb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+120>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[240136>>2]|0)!=0){wb(291368)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];kXa(14,0,290680,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);pe[c[(c[l>>2]|0)+160>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];kXa(14,0,290752,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[240136>>2]|0)==0){i=d;return 0}kXa(14,0,290800,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];kc(290816,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}hc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function xcb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+124>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[240136>>2]|0)!=0){wb(291368)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];kXa(14,0,290680,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);pe[c[(c[l>>2]|0)+164>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];kXa(14,0,290752,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[240136>>2]|0)==0){i=d;return 0}kXa(14,0,290800,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];kc(290816,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}hc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function ycb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+128>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[240136>>2]|0)!=0){wb(291368)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];kXa(14,0,290680,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);pe[c[(c[l>>2]|0)+168>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];kXa(14,0,290752,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[240136>>2]|0)==0){i=d;return 0}kXa(14,0,290800,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];kc(290816,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}hc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function zcb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+132>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[240136>>2]|0)!=0){wb(291368)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];kXa(14,0,290680,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);pe[c[(c[l>>2]|0)+172>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];kXa(14,0,290752,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[240136>>2]|0)==0){i=d;return 0}kXa(14,0,290800,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];kc(290816,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}hc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function Acb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;b=i;i=i+24|0;d=b;e=i;i=i+24|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=c[a+112>>2]|0;G=c[a+152>>2]|0;H=c[a+156>>2]|0;I=Ypb(fa(F,F)|0,8)|0;J=I;K=Ypb(fa(G,F)|0,8)|0;L=K;M=Ypb(fa(H,F)|0,8)|0;N=M;O=Ypb(fa(H,G)|0,8)|0;P=O;Ffb(p);Ffb(q);Ffb(r);Ffb(s);Ffb(t);Ffb(u);Ffb(v);Q=a+536|0;nXa(c[Q>>2]|0,(I|0)!=0|0,290824,o);nXa(c[Q>>2]|0,(K|0)!=0|0,290824,n);nXa(c[Q>>2]|0,(M|0)!=0|0,290824,m);nXa(c[Q>>2]|0,(O|0)!=0|0,290824,l);l=a+540|0;m=a;if((pe[c[(c[l>>2]|0)+140>>2]&127](m)|0)==0){n=c[Q>>2]|0;wcb(a,J)|0;nXa(n,1,290840,k)}rcb(w,J,F,F);Sfb(p,w)|0;Rfb(w);if((pe[c[(c[l>>2]|0)+144>>2]&127](m)|0)==0){w=c[Q>>2]|0;xcb(a,L)|0;nXa(w,1,290872,j)}rcb(x,L,F,G);Sfb(q,x)|0;Rfb(x);if((pe[c[(c[l>>2]|0)+148>>2]&127](m)|0)==0){x=c[Q>>2]|0;ycb(a,N)|0;nXa(x,1,290904,h)}rcb(y,N,H,F);Sfb(r,y)|0;Rfb(y);if((pe[c[(c[l>>2]|0)+152>>2]&127](m)|0)==0){m=c[Q>>2]|0;zcb(a,P)|0;nXa(m,1,290936,g)}rcb(z,P,H,G);Sfb(s,z)|0;Rfb(z);if((F|0)==0){Tfb(t,290968)|0}else{rcb(A,c[(c[c[a+4>>2]>>2]|0)+8>>2]|0,1,F);Sfb(t,A)|0;Rfb(A)}if((G|0)==0){Tfb(u,290968)|0}else{rcb(B,c[a+432>>2]|0,1,G);Sfb(u,B)|0;Rfb(B)}Xpb(I);Xpb(K);Xpb(M);Xpb(O);Lfb(E,c[a+84>>2]|0);Agb(D,290984,E);I4a(C,D,290992);Sfb(v,C)|0;Rfb(C);Rfb(D);Rfb(E);E=mc(mgb(v)|0,291e3)|0;D=c[Q>>2]|0;c[f>>2]=mgb(v)|0;nXa(D,(E|0)!=0|0,291008,f);f=Je[c[(c[l>>2]|0)+176>>2]&7]()|0;D=mgb(t)|0;Q=mgb(u)|0;C=mgb(p)|0;a=mgb(q)|0;O=mgb(r)|0;M=mgb(s)|0;c[e>>2]=D;c[e+4>>2]=Q;c[e+8>>2]=C;c[e+12>>2]=a;c[e+16>>2]=O;c[e+20>>2]=M;Dd(E|0,f|0,e|0)|0;if((c[240180>>2]|0)==0){R=Bd(E|0)|0;S=ad(E|0)|0;Rfb(v);Rfb(u);Rfb(t);Rfb(s);Rfb(r);Rfb(q);Rfb(p);i=b;return 0}e=Je[c[(c[l>>2]|0)+176>>2]&7]()|0;l=mgb(t)|0;f=mgb(u)|0;M=mgb(p)|0;O=mgb(q)|0;a=mgb(r)|0;C=mgb(s)|0;c[d>>2]=l;c[d+4>>2]=f;c[d+8>>2]=M;c[d+12>>2]=O;c[d+16>>2]=a;c[d+20>>2]=C;kXa(25,0,e,d);R=Bd(E|0)|0;S=ad(E|0)|0;Rfb(v);Rfb(u);Rfb(t);Rfb(s);Rfb(r);Rfb(q);Rfb(p);i=b;return 0}function Bcb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;h=c[b+48>>2]|0;if((h&16|0)!=0){j=b+44|0;k=c[j>>2]|0;l=b;m=chb(l)|0;if(k>>>0<m>>>0){c[j>>2]=m;n=m}else{n=k}Ccb(a,bhb(l)|0,n,e);i=d;return}if((h&8|0)==0){Gfb(a,g);i=d;return}else{g=b;b=Ygb(g)|0;Ccb(a,b,_gb(g)|0,f);i=d;return}}function Ccb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;Dcb(a,b,c,0);i=d;return}function Dcb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;Ecb(a,b,c);i=d;return}function Ecb(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=Fcb(c,d)|0;if(g>>>0>4294967279){Dfb(0)}if(g>>>0<11){Xfb(b,g);h=Wfb(b)|0}else{j=cgb(g)|0;k=j+1|0;j=s5a(Kfb(b)|0,k)|0;egb(b,j);dgb(b,k);Vfb(b,g);h=j}if((c|0)==(d|0)){l=h;a[f]=0;t5a(l,f);i=e;return}j=d+(0-c)|0;g=c;c=h;while(1){t5a(c,g);b=g+1|0;if((b|0)==(d|0)){break}else{c=c+1|0;g=b}}l=h+j|0;a[f]=0;t5a(l,f);i=e;return}function Fcb(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=Gcb(b,c,e)|0;i=d;return g|0}function Gcb(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return b-a|0}function Hcb(a,b){a=a|0;b=b|0;var c=0;c=i;Xcb(a,b);i=c;return}function Icb(a){a=a|0;var b=0;b=i;vcb(a);cqb(a);i=b;return}function Jcb(a){a=a|0;var b=0;b=i;vcb(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function Kcb(a){a=a|0;var b=0;b=i;Icb(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function Lcb(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];Mcb(a+4|0);i=d;return}function Mcb(a){a=a|0;var b=0;b=i;Ncb(a);i=b;return}function Ncb(a){a=a|0;var b=0;b=i;c[a>>2]=291224;Rfb(a+32|0);Sgb(a);i=b;return}function Ocb(a){a=a|0;var b=0;b=i;Mcb(a);cqb(a);i=b;return}function Pcb(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;j=b+44|0;k=c[j>>2]|0;l=b;m=chb(l)|0;if(k>>>0<m>>>0){c[j>>2]=m;n=m}else{n=k}k=g&24;do{if((k|0)==0){u0a(a,-1,-1);i=h;return}else if((k|0)==24){if((f|0)==2){o=11;break}else if((f|0)==0){p=0;q=0;break}else if((f|0)!=1){o=12;break}u0a(a,-1,-1);i=h;return}else{if((f|0)==2){o=11;break}else if((f|0)==0){p=0;q=0;break}else if((f|0)!=1){o=12;break}if((g&8|0)==0){m=chb(l)|0;j=m-(bhb(l)|0)|0;p=j;q=((j|0)<0)<<31>>31;break}else{j=Zgb(l)|0;m=j-(Ygb(l)|0)|0;p=m;q=((m|0)<0)<<31>>31;break}}}while(0);if((o|0)==11){f=n-(Qfb(b+32|0)|0)|0;p=f;q=((f|0)<0)<<31>>31}else if((o|0)==12){u0a(a,-1,-1);i=h;return}o=Iqb(p|0,q|0,d|0,e|0)|0;e=J;do{if(!((e|0)<0|(e|0)==0&o>>>0<0)){d=n-(Qfb(b+32|0)|0)|0;q=((d|0)<0)<<31>>31;if((q|0)<(e|0)|(q|0)==(e|0)&d>>>0<o>>>0){break}d=g&8;do{if(!((o|0)==0&(e|0)==0)){do{if((d|0)!=0){if((Zgb(l)|0)!=0){break}u0a(a,-1,-1);i=h;return}}while(0);if((g&16|0)==0){break}if((chb(l)|0)!=0){break}u0a(a,-1,-1);i=h;return}}while(0);if((d|0)!=0){q=Ygb(l)|0;ahb(l,q,q+o|0,n)}if((g&16|0)!=0){q=bhb(l)|0;fhb(l,q,dhb(l)|0);ehb(l,o)}u0a(a,o,e);i=h;return}}while(0);u0a(a,-1,-1);i=h;return}function Qcb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=c[(c[b>>2]|0)+16>>2]|0;h=I1a(d)|0;ye[g&31](a,b,h,J,0,e);i=f;return}function Rcb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=b+44|0;f=c[e>>2]|0;g=b;h=chb(g)|0;if(f>>>0<h>>>0){c[e>>2]=h;j=h}else{j=f}if((c[b+48>>2]&8|0)==0){k=-1;i=d;return k|0}if((_gb(g)|0)>>>0<j>>>0){b=Ygb(g)|0;ahb(g,b,Zgb(g)|0,j)}j=Zgb(g)|0;if(!(j>>>0<(_gb(g)|0)>>>0)){k=-1;i=d;return k|0}k=e2a(a[j]|0)|0;i=d;return k|0}function Scb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=b+44|0;g=c[f>>2]|0;h=b;j=chb(h)|0;if(g>>>0<j>>>0){c[f>>2]=j;k=j}else{k=g}g=Ygb(h)|0;j=Zgb(h)|0;if(!(g>>>0<j>>>0)){l=-1;i=e;return l|0}if(a2a(d,-1)|0){ahb(h,g,j+ -1|0,k);l=d2a(d)|0;i=e;return l|0}g=(c[b+48>>2]&16|0)==0;b=b2a(d)|0;do{if(g){if(f2a(b,a[j+ -1|0]|0)|0){break}else{l=-1}i=e;return l|0}}while(0);j=Ygb(h)|0;ahb(h,j,(Zgb(h)|0)+ -1|0,k);a[Zgb(h)|0]=b;l=d;i=e;return l|0}function Tcb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+8|0;e=d;if(a2a(b,-1)|0){f=d2a(b)|0;i=d;return f|0}g=a;h=Zgb(g)|0;j=h-(Ygb(g)|0)|0;h=chb(g)|0;do{if((h|0)==(dhb(g)|0)){k=a+48|0;if((c[k>>2]&16|0)==0){f=-1;i=d;return f|0}else{l=bhb(g)|0;m=a+44|0;n=(c[m>>2]|0)-l|0;o=a+32|0;hgb(o,0);agb(o,Zfb(o)|0);p=Qfb(o)|0;fhb(g,p,p+(Pfb(o)|0)|0);ehb(g,h-l|0);c[m>>2]=(bhb(g)|0)+n;q=k;r=m;break}}else{q=a+48|0;r=a+44|0}}while(0);c[e>>2]=(chb(g)|0)+1;h=c[(Ucb(e,r)|0)>>2]|0;c[r>>2]=h;if((c[q>>2]&8|0)!=0){q=Qfb(a+32|0)|0;ahb(g,q,q+j|0,h)}f=Vgb(g,b&255)|0;i=d;return f|0}function Ucb(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=Vcb(b,c,e)|0;i=d;return g|0}function Vcb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=Wcb(0,a,b)|0;i=c;return(d?b:a)|0}function Wcb(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)>>>0<(c[d>>2]|0)>>>0|0}function Xcb(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;Xgb(a);c[a>>2]=291224;Ffb(a+32|0);c[a+44>>2]=0;c[a+48>>2]=b;Ffb(e);Ycb(a,e);Rfb(e);i=d;return}function Ycb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+32|0;Sfb(e,b)|0;b=a+44|0;c[b>>2]=0;f=a+48|0;g=c[f>>2]|0;if((g&8|0)==0){h=g}else{g=Qfb(e)|0;j=g+(Pfb(e)|0)|0;c[b>>2]=j;g=Qfb(e)|0;ahb(a,g,g,j);h=c[f>>2]|0}if((h&16|0)==0){i=d;return}h=Pfb(e)|0;c[b>>2]=(Qfb(e)|0)+h;agb(e,Zfb(e)|0);b=a;a=Qfb(e)|0;fhb(b,a,a+(Pfb(e)|0)|0);if((c[f>>2]&3|0)==0){i=d;return}ehb(b,h);i=d;return}function Zcb(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0;j=i;i=i+8|0;g=j;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=mc(d|0,291648)|0;J=fd(291656,291648)|0;K=(J|0)!=0;L=Qc()|0;if(K){M=c[b+536>>2]|0;N=be(c[L>>2]|0)|0;c[E>>2]=d;c[E+4>>2]=N;nXa(M,(I|0)!=0|0,291712,E);uc(291736,17,1,J|0)|0;uc(291760,10,1,J|0)|0;uc(291776,18,1,J|0)|0;_cb(J,f,291800,c[b+88>>2]|0,(c[b+72>>2]|0)+(c[b+64>>2]|0)|0,-1,999,291832)}else{c[G>>2]=be(c[L>>2]|0)|0;mXa(26,0,291664,G);G=c[b+536>>2]|0;E=be(c[L>>2]|0)|0;c[F>>2]=d;c[F+4>>2]=E;nXa(G,(I|0)!=0|0,291712,F)}uc(291840,348,1,I|0)|0;if((vc(H|0)|0)<0){c[D>>2]=be(c[L>>2]|0)|0;mXa(26,0,292192,D);ad(I|0)|0;bb(J|0)|0;O=1;i=j;return O|0}if((Vc(291392,250,292216,pd(H|0)|0)|0)==0){mXa(26,0,292240,C);ad(I|0)|0;O=1;i=j;return O|0}uc(292264,13,1,I|0)|0;uc(292280,12,1,I|0)|0;$cb(I,2);uc(292296,6,1,I|0)|0;adb(I,c[b+84>>2]|0);uc(292304,8,1,I|0)|0;$cb(I,2);uc(292320,8,1,I|0)|0;C=b+88|0;adb(I,c[C>>2]|0);uc(292336,10,1,I|0)|0;$cb(I,2);uc(292352,6,1,I|0)|0;adb(I,291392);uc(292360,8,1,I|0)|0;$cb(I,2);uc(292376,8,1,I|0)|0;adb(I,c[b+280>>2]|0);uc(292392,10,1,I|0)|0;$cb(I,2);uc(292408,14,1,I|0)|0;adb(I,c[b+284>>2]|0);uc(292424,16,1,I|0)|0;$cb(I,2);uc(292448,16,1,I|0)|0;adb(I,l);uc(292472,18,1,I|0)|0;$cb(I,2);c[B>>2]=bdb(l)|0;Dd(I|0,292496,B|0)|0;$cb(I,2);P=+xYa(7);B=A;h[k>>3]=P;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];Dd(I|0,292536,A|0)|0;$cb(I,2);P=+xYa(6);A=z;h[k>>3]=P;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];Dd(I|0,292576,z|0)|0;$cb(I,2);P=+xYa(1);z=y;h[k>>3]=P;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Dd(I|0,292608,y|0)|0;$cb(I,2);P=+xYa(4);y=x;h[k>>3]=P;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];Dd(I|0,292640,x|0)|0;$cb(I,2);P=+xYa(3);x=w;h[k>>3]=P;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];Dd(I|0,292672,w|0)|0;$cb(I,2);P=+xYa(5);w=v;h[k>>3]=P;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];Dd(I|0,292704,v|0)|0;$cb(I,2);P=+xYa(0);v=u;h[k>>3]=P;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];Dd(I|0,292744,u|0)|0;$cb(I,2);P=+AYa(2);u=t;h[k>>3]=P;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];Dd(I|0,292776,t|0)|0;$cb(I,2);c[s>>2]=vYa(2)|0;Dd(I|0,292816,s|0)|0;$cb(I,2);P=+zYa(2);s=r;h[k>>3]=P;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];Dd(I|0,292840,r|0)|0;uc(292872,13,1,I|0)|0;uc(292888,16,1,I|0)|0;$cb(I,2);P=+xYa(8);r=q;h[k>>3]=P;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];Dd(I|0,292912,q|0)|0;$cb(I,2);c[p>>2]=sYa(8)|0;Dd(I|0,292936,p|0)|0;uc(292976,17,1,I|0)|0;uc(293e3,22,1,I|0)|0;cdb(I,b);uc(293024,23,1,I|0)|0;uc(293048,12,1,I|0)|0;p=b+116|0;if((c[p>>2]|0)>0){q=b+8|0;r=0;do{ddb(I,(c[q>>2]|0)+(r*112|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+136|0;if((c[p>>2]|0)>0){r=b+24|0;q=0;do{ddb(I,(c[r>>2]|0)+(q*112|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+124|0;if((c[p>>2]|0)>0){q=b+12|0;r=0;do{ddb(I,(c[q>>2]|0)+(r*60|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+140|0;if((c[p>>2]|0)>0){r=b+28|0;q=0;do{ddb(I,(c[r>>2]|0)+(q*60|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+128|0;if((c[p>>2]|0)>0){q=b+16|0;r=0;do{ddb(I,(c[q>>2]|0)+(r*48|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+144|0;if((c[p>>2]|0)>0){r=b+32|0;q=0;do{ddb(I,(c[r>>2]|0)+(q*48|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+132|0;if((c[p>>2]|0)>0){q=b+20|0;r=0;do{ddb(I,(c[q>>2]|0)+(r*52|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+148|0;if((c[p>>2]|0)>0){r=b+36|0;q=0;do{ddb(I,(c[r>>2]|0)+(q*52|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}uc(293064,13,1,I|0)|0;uc(293080,12,1,I|0)|0;edb(I,J,f,c[C>>2]|0,b);uc(293096,13,1,I|0)|0;uc(293112,12,1,I|0)|0;fdb(I,c[b+68>>2]|0,b+56|0);uc(293128,13,1,I|0)|0;uc(293144,16,1,I|0)|0;gdb(I,J,f,b);uc(293168,17,1,I|0)|0;uc(293192,14,1,I|0)|0;ad(I|0)|0;if(!K){O=0;i=j;return O|0}K=c[b+508>>2]|0;b=((yqb(e|0)|0)<<1)+230|0;e=(K|0)!=0;if(e){Q=(yqb(K|0)|0)<<1}else{Q=0}I=Wpb(b+Q|0)|0;if((I|0)==0){db(293208,293216,404,293240)}if((bb(J|0)|0)!=0){mXa(26,0,293256,o)}if(e){e=c[C>>2]|0;c[n>>2]=293288;c[n+4>>2]=e;c[n+8>>2]=K;c[n+12>>2]=e;lc(I|0,293304,n|0)|0;if((yd(I|0)|0)!=0){R=42}}else{n=I+0|0;e=293384|0;K=n+25|0;do{a[n]=a[e]|0;n=n+1|0;e=e+1|0}while((n|0)<(K|0));R=42}if((R|0)==42){c[m>>2]=I;mXa(1,0,293416,m)}m=c[C>>2]|0;c[g>>2]=m;c[g+4>>2]=m;kXa(1,0,293480,g);Xpb(I);O=0;i=j;return O|0}function _cb(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0.0,N=0.0,O=0.0;m=i;i=i+24|0;n=m;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+24|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+24|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+24|0;C=i;i=i+8|0;D=i;i=i+16|0;if((a|0)==0){i=m;return}E=(g|0)>-1;if(E){F=g+9|0;G=tYa(F)|0;H=uYa(F)|0;if((G|0)==0){I=-.01}else{I=+(G>>>0)*.95}if((H|0)==0){J=.01}else{J=+(H>>>0)*1.05}K=H;L=G;M=+zYa(F)*1.01+1.0e-30;N=J;O=I}else{K=0;L=0;M=0.0;N=0.0;O=0.0}uc(291736,17,1,a|0)|0;uc(294648,12,1,a|0)|0;uc(294664,12,1,a|0)|0;uc(294680,13,1,a|0)|0;c[D>>2]=e;c[D+4>>2]=l;c[D+8>>2]=j;Dd(a|0,294696,D|0)|0;uc(294736,10,1,a|0)|0;uc(294752,11,1,a|0)|0;uc(294768,11,1,a|0)|0;uc(294784,10,1,a|0)|0;if(E){D=C;h[k>>3]=M;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];Dd(a|0,294800,C|0)|0}else{uc(294824,17,1,a|0)|0}C=g+3|0;c[B>>2]=e;c[B+4>>2]=f;c[B+8>>2]=f;c[B+12>>2]=C;c[B+16>>2]=C;c[B+20>>2]=4;Dd(a|0,294424,B|0)|0;uc(294848,13,1,a|0)|0;if(E){uc(294664,12,1,a|0)|0;if((L|0)==(K|0)){B=A;h[k>>3]=O;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=N;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];Dd(a|0,294864,A|0)|0}else{uc(294824,17,1,a|0)|0}c[z>>2]=e;c[z+4>>2]=l;c[z+8>>2]=j;Dd(a|0,294888,z|0)|0;c[y>>2]=e;c[y+4>>2]=f;c[y+8>>2]=f;c[y+12>>2]=g+1;c[y+16>>2]=4;Dd(a|0,294544,y|0)|0;uc(294936,10,1,a|0)|0;uc(294952,10,1,a|0)|0;uc(294936,10,1,a|0)|0;uc(294968,11,1,a|0)|0;c[x>>2]=b;Dd(a|0,294984,x|0)|0;c[w>>2]=d;Dd(a|0,295008,w|0)|0;uc(295024,33,1,a|0)|0;uc(295064,32,1,a|0)|0;c[v>>2]=e;c[v+4>>2]=l;c[v+8>>2]=j;c[v+12>>2]=b;Dd(a|0,295104,v|0)|0;uc(294784,10,1,a|0)|0;v=u;h[k>>3]=M;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];Dd(a|0,294800,u|0)|0}else{uc(294952,10,1,a|0)|0;uc(294936,10,1,a|0)|0;uc(294968,11,1,a|0)|0;c[t>>2]=b;Dd(a|0,294984,t|0)|0;c[s>>2]=d;Dd(a|0,295008,s|0)|0;uc(295024,33,1,a|0)|0;uc(295064,32,1,a|0)|0;c[r>>2]=e;c[r+4>>2]=l;c[r+8>>2]=j;c[r+12>>2]=b;Dd(a|0,295104,r|0)|0;uc(294784,10,1,a|0)|0;uc(294824,17,1,a|0)|0}c[q>>2]=e;c[q+4>>2]=f;c[q+8>>2]=f;c[q+12>>2]=C;c[q+16>>2]=C;c[q+20>>2]=2;Dd(a|0,294424,q|0)|0;uc(294848,13,1,a|0)|0;if(!E){i=m;return}if((L|0)==(K|0)){K=p;h[k>>3]=O;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];K=p+8|0;h[k>>3]=N;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];Dd(a|0,294864,p|0)|0}else{uc(294824,17,1,a|0)|0}uc(295136,32,1,a|0)|0;uc(295176,29,1,a|0)|0;c[o>>2]=e;c[o+4>>2]=l;c[o+8>>2]=j;c[o+12>>2]=b;Dd(a|0,295208,o|0)|0;c[n>>2]=e;c[n+4>>2]=f;c[n+8>>2]=f;c[n+12>>2]=g+1;c[n+16>>2]=2;Dd(a|0,294544,n|0)|0;i=m;return}function $cb(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((b|0)==0){i=c;return}else{d=b}do{d=d+ -1|0;Zd(32,a|0)|0;}while((d|0)!=0);i=c;return}function adb(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;e=a[c]|0;if(e<<24>>24==0){i=d;return}else{f=c;g=e}do{e=g<<24>>24;if((e|0)==60){uc(294392,4,1,b|0)|0}else if((e|0)==62){uc(294400,4,1,b|0)|0}else if((e|0)==39){uc(294408,6,1,b|0)|0}else if((e|0)==34){uc(294416,6,1,b|0)|0}else{Zd(e|0,b|0)|0}f=f+1|0;g=a[f]|0;}while(!(g<<24>>24==0));i=d;return}function bdb(a){a=a|0;var b=0,c=0,d=0;b=i;c=mc(a|0,294384)|0;if((c|0)==0){d=-1;i=b;return d|0}Zc(c|0,0,2)|0;a=Bb(c|0)|0;ad(c|0)|0;d=a;i=b;return d|0}function cdb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;h=i;i=i+24|0;j=i;i=i+32|0;k=i;i=i+24|0;l=c[b+88>>2]|0;m=Wpb((yqb(l|0)|0)+15|0)|0;c[f>>2]=l;lc(m|0,294112,f|0)|0;$cb(a,2);uc(294128,10,1,a|0)|0;adb(a,m);uc(294144,12,1,a|0)|0;$cb(a,2);c[e>>2]=bdb(m)|0;Dd(a|0,294160,e|0)|0;Xpb(m);$cb(a,2);uc(294192,9,1,a|0)|0;$cb(a,4);uc(294208,22,1,a|0)|0;$cb(a,4);uc(294232,22,1,a|0)|0;$cb(a,4);uc(294256,26,1,a|0)|0;m=b+56|0;e=b+64|0;f=c[e>>2]|0;if((f|0)>0){l=g+4|0;n=0;while(1){idb(g,m,n);o=c[l>>2]|0;$cb(a,4);uc(294288,8,1,a|0)|0;adb(a,o);uc(294304,18,1,a|0)|0;o=n+1|0;p=c[e>>2]|0;if((o|0)<(p|0)){n=o}else{q=p;break}}}else{q=f}f=b+72|0;b=c[f>>2]|0;if((b|0)>0){n=h+8|0;l=0;do{ndb(h,m,l);g=c[n>>2]|0;$cb(a,4);uc(294288,8,1,a|0)|0;adb(a,g);uc(294304,18,1,a|0)|0;l=l+1|0;r=c[f>>2]|0;}while((l|0)<(r|0));s=r;t=c[e>>2]|0}else{s=b;t=q}if((t|0)>0){t=j+4|0;q=0;do{idb(j,m,q);b=c[t>>2]|0;$cb(a,4);uc(294328,8,1,a|0)|0;adb(a,b);uc(294344,21,1,a|0)|0;q=q+1|0;}while((q|0)<(c[e>>2]|0));u=c[f>>2]|0}else{u=s}if((u|0)<=0){$cb(a,2);v=294368;w=v;x=uc(w|0,10,1,a|0)|0;i=d;return}u=k+8|0;s=0;do{ndb(k,m,s);e=c[u>>2]|0;$cb(a,4);uc(294328,8,1,a|0)|0;adb(a,e);uc(294344,21,1,a|0)|0;s=s+1|0;}while((s|0)<(c[f>>2]|0));$cb(a,2);v=294368;w=v;x=uc(w|0,10,1,a|0)|0;i=d;return}function ddb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=d;f=d+24|0;$cb(a,2);c[f>>2]=c[b>>2];Dd(a|0,294048,f|0)|0;adb(a,c[b+4>>2]|0);uc(294080,11,1,a|0)|0;adb(a,c[b+8>>2]|0);uc(293752,3,1,a|0)|0;f=e;g=b+12|0;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[f+12>>2]=c[g+12>>2];c[f+16>>2]=c[g+16>>2];c[f+20>>2]=c[g+20>>2];hdb(a,4,e);$cb(a,2);uc(294096,12,1,a|0)|0;i=d;return}function edb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+32|0;q=f+64|0;if((c[q>>2]|0)<=0){i=g;return}r=f+56|0;s=p+4|0;t=f+72|0;f=p;u=p+8|0;v=0;do{idb(p,r,v);_cb(b,d,c[s>>2]|0,e,(c[t>>2]|0)+(c[q>>2]|0)|0,v,c[f>>2]|0,293864);w=v+9|0;DYa(w);$cb(a,2);c[o>>2]=c[f>>2];Dd(a|0,293872,o|0)|0;$cb(a,4);uc(292296,6,1,a|0)|0;adb(a,c[s>>2]|0);uc(292304,8,1,a|0)|0;$cb(a,4);c[n>>2]=vYa(w)|0;Dd(a|0,293648,n|0)|0;$cb(a,4);x=+AYa(w);y=m;h[k>>3]=x;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];Dd(a|0,293672,m|0)|0;$cb(a,4);x=+zYa(w);w=l;h[k>>3]=x;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];Dd(a|0,292840,l|0)|0;w=j;y=u;c[w+0>>2]=c[y+0>>2];c[w+4>>2]=c[y+4>>2];c[w+8>>2]=c[y+8>>2];c[w+12>>2]=c[y+12>>2];c[w+16>>2]=c[y+16>>2];c[w+20>>2]=c[y+20>>2];hdb(a,6,j);$cb(a,2);uc(293896,12,1,a|0)|0;v=v+1|0;}while((v|0)<(c[q>>2]|0));i=g;return}function fdb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+24|0;m=i;i=i+24|0;n=i;i=i+24|0;o=i;i=i+24|0;p=i;i=i+24|0;if((b|0)<=0){i=e;return}q=l;r=m+8|0;s=n+12|0;t=d+8|0;u=d+16|0;v=o;w=p;x=0;do{$cb(a,2);mdb(l,d,x);c[j>>2]=c[q>>2];Dd(a|0,293720,j|0)|0;mdb(m,d,x);adb(a,c[r>>2]|0);uc(293752,3,1,a|0)|0;$cb(a,4);uc(293760,7,1,a|0)|0;mdb(n,d,x);if((c[s>>2]|0)>0){y=0;do{$cb(a,6);c[g>>2]=0;Dd(a|0,293768,g|0)|0;y=y+1|0;mdb(n,d,x);}while((y|0)<(c[s>>2]|0))}$cb(a,4);uc(293792,8,1,a|0)|0;$cb(a,4);y=(c[t>>2]|0)+9+(c[u>>2]|0)|0;mdb(o,d,x);z=+xYa(y+(c[v>>2]|0)|0);y=(c[t>>2]|0)+9+(c[u>>2]|0)|0;mdb(p,d,x);A=sYa(y+(c[w>>2]|0)|0)|0;y=f;h[k>>3]=z;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];c[f+8>>2]=A;Dd(a|0,293808,f|0)|0;$cb(a,2);uc(293848,12,1,a|0)|0;x=x+1|0;}while((x|0)<(b|0));i=e;return}function gdb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=e+56|0;p=e+64|0;q=c[p>>2]|0;r=e+72|0;if((c[r>>2]|0)<=0){i=f;return}s=n+8|0;t=e+88|0;e=n;u=q;v=q;do{ndb(n,o,v-u|0);_cb(b,d,c[s>>2]|0,c[t>>2]|0,(c[r>>2]|0)+(c[p>>2]|0)|0,v,c[e>>2]|0,293600);q=v+9|0;DYa(q);$cb(a,2);uc(293608,15,1,a|0)|0;$cb(a,4);c[m>>2]=c[e>>2];Dd(a|0,293624,m|0)|0;$cb(a,4);c[l>>2]=vYa(q)|0;Dd(a|0,293648,l|0)|0;$cb(a,4);w=+AYa(q);x=j;h[k>>3]=w;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];Dd(a|0,293672,j|0)|0;$cb(a,4);w=+zYa(q);q=g;h[k>>3]=w;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];Dd(a|0,292840,g|0)|0;$cb(a,2);uc(293696,16,1,a|0)|0;v=v+1|0;u=c[p>>2]|0;}while((v|0)<((c[r>>2]|0)+u|0));i=f;return}function hdb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;$cb(a,b);uc(293912,16,1,a|0)|0;adb(a,c[d>>2]|0);b=c[d+8>>2]|0;g=c[d+12>>2]|0;h=c[d+16>>2]|0;j=(c[d+20>>2]|0)!=0?294016:294032;c[f>>2]=c[d+4>>2];c[f+4>>2]=b;c[f+8>>2]=g;c[f+12>>2]=h;c[f+16>>2]=j;Dd(a|0,293936,f|0)|0;i=e;return}function idb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((c[b+24>>2]|0)==0){jdb(b)}f=a;a=(c[b+20>>2]|0)+(d<<5)|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];i=e;return}function jdb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+16|0;j=i;i=i+1024|0;c[h>>2]=a;k=h+4|0;c[k>>2]=1;l=h+8|0;c[l>>2]=0;m=h+12|0;c[m>>2]=0;n=a+4|0;do{if((c[n>>2]|0)==0){o=a;p=mc(c[o>>2]|0,295248)|0;if((p|0)!=0){q=p;break}p=be(c[(Qc()|0)>>2]|0)|0;c[g>>2]=c[o>>2];c[g+4>>2]=p;oXa(0,295256,g)}else{q=0}}while(0);g=fSa(0)|0;if((g|0)==0){oXa(0,295288,f)}f=a+8|0;c[a+20>>2]=Ypb(c[f>>2]|0,32)|0;p=a+12|0;o=Ypb((c[p>>2]|0)+1|0,20)|0;c[a+24>>2]=o;c[o>>2]=0;c[o+4>>2]=-1;c[o+8>>2]=295320;c[o+12>>2]=0;c[o+16>>2]=0;qSa(g,h);rSa(g,9,200);h=c[n>>2]|0;do{if((h|0)==0){o=j;Cqb(o|0,0,1024)|0;while(1){r=vb(o|0,1,1024,q|0)|0;s=r>>>0<1024;if((sSa(g,o,r,s&1)|0)==0){t=9;break}if(s){t=11;break}}if((t|0)==9){o=ASa(xSa(g)|0)|0;s=ySa(g)|0;ad(q|0)|0;mSa(g);r=c[a>>2]|0;c[e>>2]=295424;c[e+4>>2]=r;c[e+8>>2]=o;c[e+12>>2]=s;oXa(0,295360,e)}else if((t|0)==11){ad(q|0)|0;break}}else{if((sSa(g,h,yqb(h|0)|0,1)|0)!=0){break}s=ASa(xSa(g)|0)|0;o=ySa(g)|0;mSa(g);r=c[n>>2]|0;c[d>>2]=295424;c[d+4>>2]=r;c[d+8>>2]=s;c[d+12>>2]=o;oXa(0,295464,d)}}while(0);if((c[p>>2]|0)!=(c[k>>2]|0)){db(295528,295424,295,295568)}c[a+16>>2]=c[l>>2];if((c[f>>2]|0)==(c[m>>2]|0)){i=b;return}else{db(295592,295424,297,295568)}}function kdb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+8|0;m=c[a>>2]|0;n=c[a+4>>2]|0;o=c[a+12>>2]|0;if((uqb(296e3,b)|0)==0){if((uqb(c[d>>2]|0,296008)|0)==0){p=(c[d+8>>2]|0)==0|0}else{p=0}nXa(0,p,296016,l);l=c[73964]|0;p=c[74018]|0;do{if((l|0)==0|(p|0)==0){c[74018]=32;a=Wpb(1152)|0;c[73964]=a;q=m+24|0;r=a}else{a=m+24|0;s=a;if(((c[(c[a>>2]|0)+(n*20|0)+12>>2]|0)+2|0)<(p|0)){q=s;r=l;break}c[74018]=p<<1;a=Zpb(l,p*72|0)|0;c[73964]=a;q=s;r=a}}while(0);p=(c[q>>2]|0)+(n*20|0)+12|0;q=c[p>>2]|0;c[p>>2]=q+1;p=r+(q*36|0)+0|0;q=(qdb(c[d+4>>2]|0)|0)+0|0;r=p+36|0;do{c[p>>2]=c[q>>2];p=p+4|0;q=q+4|0}while((p|0)<(r|0));i=e;return}if((uqb(296080,b)|0)==0){q=c[d>>2]|0;if((q|0)==0){i=e;return}else{t=d;u=q}a:while(1){do{if((uqb(296088,u)|0)==0){c[74024]=Hd(c[t+4>>2]|0)|0}else{if((uqb(296120,u)|0)==0){c[296100>>2]=Yb(c[t+4>>2]|0,0,10)|0;break}if((uqb(296136,u)|0)==0){c[296108>>2]=Yb(c[t+4>>2]|0,0,10)|0;break}if((uqb(296144,u)|0)==0){c[296104>>2]=Yb(c[t+4>>2]|0,0,10)|0;break}if((uqb(296160,u)|0)==0){c[296112>>2]=Yb(c[t+4>>2]|0,0,10)|0;break}if((uqb(296168,u)|0)!=0){v=23;break a}c[296116>>2]=(uqb(c[t+4>>2]|0,296184)|0)==0}}while(0);q=t+8|0;p=c[q>>2]|0;if((p|0)==0){v=45;break}else{t=q;u=p}}if((v|0)==23){c[k>>2]=c[m>>2];oXa(0,296192,k)}else if((v|0)==45){i=e;return}}if((uqb(295840,b)|0)==0){v=c[m+12>>2]|0;if((n|0)>(v|0)){k=c[m>>2]|0;c[j>>2]=295424;c[j+4>>2]=k;c[j+8>>2]=v;oXa(0,296224,j)}if((uqb(296288,c[d>>2]|0)|0)!=0){j=c[m>>2]|0;c[h>>2]=295424;c[h+4>>2]=j;oXa(0,296296,h)}h=Yb(c[d+4>>2]|0,0,10)|0;if((n|0)!=(h|0)){j=c[m>>2]|0;c[g>>2]=295424;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=n;oXa(0,296352,g)}g=m+24|0;h=c[g>>2]|0;c[h+(n*20|0)>>2]=n;c[h+(n*20|0)+4>>2]=-1;c[h+(n*20|0)+8>>2]=296416;h=c[g>>2]|0;c[h+(n*20|0)+12>>2]=0;c[h+(n*20|0)+16>>2]=0;i=e;return}if((uqb(295784,b)|0)!=0){if((uqb(295976,b)|0)!=0){i=e;return}b=m+20|0;m=c[b>>2]|0;c[m+(o<<5)>>2]=o;c[m+(o<<5)+4>>2]=296520;m=Hd(c[d+4>>2]|0)|0;c[(c[b>>2]|0)+(o<<5)+4>>2]=m;c[(c[b>>2]|0)+(o<<5)+8>>2]=296528;i=e;return}c[295804>>2]=0;c[295808>>2]=0;o=c[d>>2]|0;do{if((o|0)==0){w=0}else{b=d;m=o;do{do{if((uqb(m,296008)|0)==0){c[295804>>2]=Hd(c[b+4>>2]|0)|0}else{if((uqb(m,296472)|0)!=0){break}c[295808>>2]=Hd(c[b+4>>2]|0)|0}}while(0);b=b+8|0;m=c[b>>2]|0;}while((m|0)!=0);if((c[295804>>2]|0)==0){w=0;break}w=(c[295808>>2]|0)!=0|0}}while(0);nXa(0,w,296480,f);c[73950]=-1;f=295812|0;w=296096;c[f+0>>2]=c[w+0>>2];c[f+4>>2]=c[w+4>>2];c[f+8>>2]=c[w+8>>2];c[f+12>>2]=c[w+12>>2];c[f+16>>2]=c[w+16>>2];c[f+20>>2]=c[w+20>>2];i=e;return}function ldb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+48|0;e=d;f=d+40|0;g=i;i=i+8|0;h=c[a>>2]|0;j=a+4|0;k=c[j>>2]|0;l=a+8|0;m=c[l>>2]|0;n=a+12|0;a=c[n>>2]|0;if((uqb(295784,b)|0)==0){o=e+0|0;p=295800|0;q=o+36|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));pdb(e);i=d;return}if((uqb(295840,b)|0)==0){e=h+24|0;r=Wpb((c[(c[e>>2]|0)+(k*20|0)+12>>2]|0)*36|0)|0;c[(c[e>>2]|0)+(k*20|0)+16>>2]=r;if((c[(c[e>>2]|0)+(k*20|0)+12>>2]|0)>0){r=0;do{s=Wpb(36)|0;t=s;o=s+0|0;p=(c[73964]|0)+(r*36|0)+0|0;q=o+36|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));c[(c[(c[e>>2]|0)+(k*20|0)+16>>2]|0)+(r<<2)>>2]=t;r=r+1|0;}while((r|0)<(c[(c[e>>2]|0)+(k*20|0)+12>>2]|0))}c[j>>2]=k+1;i=d;return}if((uqb(295864,b)|0)==0){j=h+24|0;e=c[j>>2]|0;r=c[e+(k*20|0)+12>>2]|0;c[g>>2]=k;c[g+4>>2]=r;Id(e+(k*20|0)+8|0,295872,g|0)|0;c[(c[j>>2]|0)+(k*20|0)+4>>2]=m;c[l>>2]=m+1;i=d;return}if((uqb(295912,b)|0)==0){j=h+24|0;h=c[j>>2]|0;g=c[h+(k*20|0)+12>>2]|0;c[f>>2]=k;c[f+4>>2]=g;Id(h+(k*20|0)+8|0,295928,f|0)|0;c[(c[j>>2]|0)+(k*20|0)+4>>2]=m;c[l>>2]=m+1;i=d;return}if((uqb(295976,b)|0)!=0){i=d;return}c[n>>2]=a+1;i=d;return}function mdb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b+24|0;g=c[f>>2]|0;if((g|0)==0){jdb(b);h=c[f>>2]|0}else{h=g}g=a;a=h+(d*20|0)|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];i=e;return}function ndb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=b+24|0;if((c[h>>2]|0)==0){jdb(b)}j=c[b+16>>2]|0;if(j>>>0<d>>>0){c[g>>2]=d;c[g+4>>2]=j;oXa(0,295632,g)}g=c[b+12>>2]|0;if((g|0)<=0){k=f;l=k;c[l>>2]=d;m=5;n=m;o=295712;p=o;oXa(0,p,f)}b=c[h>>2]|0;h=0;while(1){j=h+1|0;if((c[b+(h*20|0)+4>>2]|0)==(d|0)){q=9;break}if((j|0)<(g|0)){h=j}else{q=10;break}}if((q|0)==9){g=a;a=b+(h*20|0)|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];i=e;return}else if((q|0)==10){k=f;l=k;c[l>>2]=d;m=5;n=m;o=295712;p=o;oXa(0,p,f)}}function odb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=a+20|0;e=c[d>>2]|0;if((e|0)!=0){Xpb(e);c[d>>2]=0}d=a+24|0;e=c[d>>2]|0;if((e|0)==0){i=b;return}f=a+12|0;if((c[f>>2]|0)>0){a=e;g=0;while(1){Xpb(c[a+(g*20|0)+16>>2]|0);c[(c[d>>2]|0)+(g*20|0)+16>>2]=0;h=g+1|0;j=c[d>>2]|0;if((h|0)<(c[f>>2]|0)){g=h;a=j}else{k=j;break}}}else{k=e}Xpb(k);c[d>>2]=0;i=b;return}function pdb(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;b=i;e=Wpb(72)|0;f=c[a+4>>2]|0;c[e>>2]=f;g=e+4|0;h=a+0|0;a=g+36|0;do{c[g>>2]=c[h>>2];g=g+4|0;h=h+4|0}while((g|0)<(a|0));h=e+40|0;j=h;c[e+48>>2]=0;c[e+60>>2]=f;k=yqb(f|0)|0;c[e+64>>2]=k;k=c[73998]|0;do{if((k|0)==0){c[73998]=e;c[e+44>>2]=0;l=Wpb(44)|0;m=l;c[e+40>>2]=m;if((l|0)==0){yc(-1)}g=l+0|0;a=g+44|0;do{c[g>>2]=0;g=g+4|0}while((g|0)<(a|0));c[l+16>>2]=e+40;c[l+4>>2]=32;c[l+8>>2]=5;c[l+20>>2]=40;n=Wpb(384)|0;c[l>>2]=n;if((n|0)==0){yc(-1)}else{Cqb(n|0,0,384)|0;c[l+40>>2]=-1609490463;o=f;p=m;break}}else{c[(c[(c[k+40>>2]|0)+16>>2]|0)+8>>2]=e;n=(c[73998]|0)+40|0;q=c[n>>2]|0;c[e+44>>2]=(c[q+16>>2]|0)+(0-(c[q+20>>2]|0));c[(c[n>>2]|0)+16>>2]=j;o=c[e>>2]|0;p=c[(c[73998]|0)+40>>2]|0}}while(0);k=p+12|0;c[k>>2]=(c[k>>2]|0)+1;c[h>>2]=p;p=e+68|0;c[p>>2]=-17973521;k=yqb(o|0)|0;if(k>>>0>11){f=-17973521;g=-1640531527;a=-1640531527;n=k;q=o;do{r=((d[q+5|0]|0)<<8|(d[q+4|0]|0)|(d[q+6|0]|0)<<16|(d[q+7|0]|0)<<24)+a|0;s=((d[q+9|0]|0)<<8|(d[q+8|0]|0)|(d[q+10|0]|0)<<16|(d[q+11|0]|0)<<24)+f|0;t=((d[q+1|0]|0)<<8|(d[q]|0)|(d[q+2|0]|0)<<16|(d[q+3|0]|0)<<24)+g-r-s^s>>>13;u=r-s-t^t<<8;r=s-t-u^u>>>13;s=t-u-r^r>>>12;t=u-r-s^s<<16;u=r-s-t^t>>>5;g=s-t-u^u>>>3;a=t-u-g^g<<10;f=u-g-a^a>>>15;c[p>>2]=f;q=q+12|0;n=n+ -12|0;}while(n>>>0>11);v=f;w=c[e>>2]|0;x=g;y=a;z=n;A=q}else{v=-17973521;w=o;x=-1640531527;y=-1640531527;z=k;A=o}o=v+(yqb(w|0)|0)|0;c[p>>2]=o;switch(z|0){case 5:{B=o;C=y;D=18;break};case 9:{E=o;D=14;break};case 6:{F=o;G=y;D=17;break};case 2:{H=o;I=x;J=y;D=21;break};case 7:{K=o;L=y;D=16;break};case 10:{M=o;D=13;break};case 3:{N=o;O=x;P=y;D=20;break};case 4:{Q=o;R=y;D=19;break};case 11:{z=((d[A+10|0]|0)<<24)+o|0;c[p>>2]=z;M=z;D=13;break};case 8:{S=o;D=15;break};case 1:{T=o;U=x;V=y;D=22;break};default:{W=o;X=x;Y=y}}if((D|0)==13){o=((d[A+9|0]|0)<<16)+M|0;c[p>>2]=o;E=o;D=14}if((D|0)==14){o=((d[A+8|0]|0)<<8)+E|0;c[p>>2]=o;S=o;D=15}if((D|0)==15){K=S;L=((d[A+7|0]|0)<<24)+y|0;D=16}if((D|0)==16){F=K;G=((d[A+6|0]|0)<<16)+L|0;D=17}if((D|0)==17){B=F;C=((d[A+5|0]|0)<<8)+G|0;D=18}if((D|0)==18){Q=B;R=(d[A+4|0]|0)+C|0;D=19}if((D|0)==19){N=Q;O=((d[A+3|0]|0)<<24)+x|0;P=R;D=20}if((D|0)==20){H=N;I=((d[A+2|0]|0)<<16)+O|0;J=P;D=21}if((D|0)==21){T=H;U=((d[A+1|0]|0)<<8)+I|0;V=J;D=22}if((D|0)==22){W=T;X=(d[A]|0)+U|0;Y=V}V=X-Y-W^W>>>13;X=Y-W-V^V<<8;Y=W-V-X^X>>>13;W=V-X-Y^Y>>>12;V=X-Y-W^W<<16;X=Y-W-V^V>>>5;Y=W-V-X^X>>>3;W=V-X-Y^Y<<10;V=X-Y-W^W>>>15;c[p>>2]=V;p=(c[73998]|0)+40|0;W=c[p>>2]|0;Y=V&(c[W+4>>2]|0)+ -1;V=c[W>>2]|0;W=V+(Y*12|0)+4|0;c[W>>2]=(c[W>>2]|0)+1;c[e+56>>2]=c[V+(Y*12|0)>>2];c[e+52>>2]=0;e=c[c[p>>2]>>2]|0;p=c[e+(Y*12|0)>>2]|0;if((p|0)==0){Z=e}else{c[p+12>>2]=j;Z=c[c[(c[73998]|0)+40>>2]>>2]|0}c[Z+(Y*12|0)>>2]=j;j=c[c[(c[73998]|0)+40>>2]>>2]|0;if((c[j+(Y*12|0)+4>>2]|0)>>>0<(((c[j+(Y*12|0)+8>>2]|0)*10|0)+10|0)>>>0){i=b;return}Y=c[h>>2]|0;if((c[Y+36>>2]|0)==1){i=b;return}j=Y+4|0;Z=Wpb((c[j>>2]|0)*24|0)|0;p=Z;if((Z|0)==0){yc(-1)}Cqb(Z|0,0,(c[j>>2]|0)*24|0)|0;e=c[Y+12>>2]|0;V=c[j>>2]|0;c[Y+24>>2]=(((V<<1)+ -1&e|0)!=0)+(e>>>((c[Y+8>>2]|0)+1|0));c[Y+28>>2]=0;e=c[Y>>2]|0;if((V|0)==0){_=e}else{V=Y;Y=e;e=0;while(1){j=c[Y+(e*12|0)>>2]|0;if((j|0)==0){$=V}else{W=V;X=j;while(1){j=X+16|0;U=c[j>>2]|0;A=(c[W+4>>2]<<1)+ -1&c[X+28>>2];T=Z+(A*12|0)+4|0;D=(c[T>>2]|0)+1|0;c[T>>2]=D;J=c[W+24>>2]|0;if(D>>>0>J>>>0){D=W+28|0;c[D>>2]=(c[D>>2]|0)+1;c[Z+(A*12|0)+8>>2]=((c[T>>2]|0)>>>0)/(J>>>0)|0}c[X+12>>2]=0;J=Z+(A*12|0)|0;c[j>>2]=c[J>>2];j=c[J>>2]|0;if((j|0)!=0){c[j+12>>2]=X}c[J>>2]=X;J=c[h>>2]|0;if((U|0)==0){$=J;break}else{W=J;X=U}}}X=e+1|0;W=c[$>>2]|0;if(X>>>0<(c[$+4>>2]|0)>>>0){V=$;Y=W;e=X}else{_=W;break}}}Xpb(_);_=c[h>>2]|0;e=_+4|0;c[e>>2]=c[e>>2]<<1;e=_+8|0;c[e>>2]=(c[e>>2]|0)+1;c[_>>2]=p;p=c[h>>2]|0;h=p+32|0;if(!((c[p+28>>2]|0)>>>0>(c[p+12>>2]|0)>>>1>>>0)){c[h>>2]=0;i=b;return}_=(c[h>>2]|0)+1|0;c[h>>2]=_;if(!(_>>>0>1)){i=b;return}c[p+36>>2]=1;i=b;return}function qdb(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;b=i;i=i+8|0;e=b;a:do{if((c[73998]|0)==0){f=24}else{g=yqb(a|0)|0;if(g>>>0>11){h=-17973521;j=-1640531527;k=-1640531527;l=g;m=a;while(1){n=((d[m+5|0]|0)<<8|(d[m+4|0]|0)|(d[m+6|0]|0)<<16|(d[m+7|0]|0)<<24)+k|0;o=((d[m+9|0]|0)<<8|(d[m+8|0]|0)|(d[m+10|0]|0)<<16|(d[m+11|0]|0)<<24)+h|0;p=((d[m+1|0]|0)<<8|(d[m]|0)|(d[m+2|0]|0)<<16|(d[m+3|0]|0)<<24)+j-n-o^o>>>13;q=n-o-p^p<<8;n=o-p-q^q>>>13;o=p-q-n^n>>>12;p=q-n-o^o<<16;q=n-o-p^p>>>5;n=o-p-q^q>>>3;o=p-q-n^n<<10;p=q-n-o^o>>>15;q=m+12|0;r=l+ -12|0;if(r>>>0>11){m=q;l=r;k=o;j=n;h=p}else{s=p;t=n;u=o;v=r;w=q;break}}}else{s=-17973521;t=-1640531527;u=-1640531527;v=g;w=a}h=(yqb(a|0)|0)+s|0;switch(v|0){case 1:{x=h;y=t;z=u;f=15;break};case 4:{A=h;B=u;f=12;break};case 10:{C=h;f=6;break};case 5:{D=h;E=u;f=11;break};case 8:{F=h;f=8;break};case 11:{C=((d[w+10|0]|0)<<24)+h|0;f=6;break};case 3:{G=h;H=t;I=u;f=13;break};case 6:{J=h;K=u;f=10;break};case 7:{L=h;M=u;f=9;break};case 9:{N=h;f=7;break};case 2:{O=h;P=t;Q=u;f=14;break};default:{R=h;S=t;T=u}}if((f|0)==6){N=((d[w+9|0]|0)<<16)+C|0;f=7}if((f|0)==7){F=((d[w+8|0]|0)<<8)+N|0;f=8}if((f|0)==8){L=F;M=((d[w+7|0]|0)<<24)+u|0;f=9}if((f|0)==9){J=L;K=((d[w+6|0]|0)<<16)+M|0;f=10}if((f|0)==10){D=J;E=((d[w+5|0]|0)<<8)+K|0;f=11}if((f|0)==11){A=D;B=(d[w+4|0]|0)+E|0;f=12}if((f|0)==12){G=A;H=((d[w+3|0]|0)<<24)+t|0;I=B;f=13}if((f|0)==13){O=G;P=((d[w+2|0]|0)<<16)+H|0;Q=I;f=14}if((f|0)==14){x=O;y=((d[w+1|0]|0)<<8)+P|0;z=Q;f=15}if((f|0)==15){R=x;S=(d[w]|0)+y|0;T=z}h=S-R-T^R>>>13;j=T-R-h^h<<8;k=R-h-j^j>>>13;l=h-j-k^k>>>12;h=j-k-l^l<<16;j=k-l-h^h>>>5;k=l-h-j^j>>>3;l=h-j-k^k<<10;h=c[(c[73998]|0)+40>>2]|0;m=c[(c[h>>2]|0)+(((j-k-l^l>>>15)&(c[h+4>>2]|0)+ -1)*12|0)>>2]|0;if((m|0)==0){f=24;break}l=m+(0-(c[h+20>>2]|0))|0;if((l|0)==0){f=24;break}m=yqb(a|0)|0;k=l;while(1){U=k;if((c[k+64>>2]|0)==(m|0)){if((tqb(c[k+60>>2]|0,a,m)|0)==0){break}}l=c[k+56>>2]|0;if((l|0)==0){f=24;break a}j=l+(0-(c[h+20>>2]|0))|0;if((j|0)==0){f=24;break a}else{k=j}}if((k|0)==0){f=24}else{V=U}}}while(0);do{if((f|0)==24){if((Hb(a|0,296552)|0)==0){V=0;break}else{W=296576}i=b;return W|0}}while(0);c[e>>2]=a;nXa(0,(V|0)!=0|0,296624,e);W=V+4|0;i=b;return W|0}function rdb(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((sdb(296680,a,b)|0)!=0){d=1;i=c;return d|0}d=(sdb(296688,a,b)|0)!=0|0;i=c;return d|0}function sdb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((d|0)>0){g=0}else{h=0;i=f;return h|0}while(1){j=c[e+(g<<2)>>2]|0;if((a[j]|0)==45){if((uqb(b,j+1|0)|0)==0){h=1;k=5;break}}j=g+1|0;if((j|0)<(d|0)){g=j}else{h=0;k=5;break}}if((k|0)==5){i=f;return h|0}return 0}function tdb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=(uqb(c[244996>>2]|0,296696)|0)==0|0;nXa(0,m,296712,l);l=(uqb(c[246900>>2]|0,296696)|0)==0|0;nXa(0,l,296768,k);k=(uqb(c[248892>>2]|0,296696)|0)==0|0;nXa(0,k,296824,j);j=296888|0;k=j+124|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));j=297016|0;k=j+124|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));if((a|0)>1){n=1}else{o=0;i=d;return o|0}a:while(1){p=b+(n<<2)|0;j=n+1|0;k=1;while(1){l=c[248896+(k<<2)>>2]|0;if((l|0)==2){q=c[244872+(k<<2)>>2]|0;if(!((sdb(q,1,p)|0)==0|(j|0)>=(a|0))){r=9;break}s=c[244872+(k<<2)>>2]|0;if((vdb(s,p)|0)!=0){r=13;break}}else if((l|0)==1){if((sdb(c[244872+(k<<2)>>2]|0,1,p)|0)!=0){r=5;break}}l=k+1|0;if((l|0)<31){k=l}else{r=17;break a}}if((r|0)==5){r=0;l=296888+(k<<2)|0;if((c[l>>2]|0)!=0){r=6;break}c[l>>2]=1;t=n}else if((r|0)==9){r=0;l=296888+(k<<2)|0;if((c[l>>2]|0)!=0){r=10;break}c[l>>2]=1;c[297016+(k<<2)>>2]=udb(q,p)|0;t=j}else if((r|0)==13){r=0;l=296888+(k<<2)|0;if((c[l>>2]|0)!=0){r=14;break}c[l>>2]=1;c[297016+(k<<2)>>2]=wdb(s,p)|0;t=n}l=t+1|0;if((l|0)<(a|0)){n=l}else{o=0;r=19;break}}if((r|0)==6){c[h>>2]=c[p>>2];mXa(1,0,297144,h);o=1;i=d;return o|0}else if((r|0)==10){c[g>>2]=c[p>>2];mXa(1,0,297144,g);o=1;i=d;return o|0}else if((r|0)==14){c[f>>2]=c[p>>2];mXa(1,0,297144,f);o=1;i=d;return o|0}else if((r|0)==17){c[e>>2]=c[p>>2];mXa(1,0,297200,e);o=1;i=d;return o|0}else if((r|0)==19){i=d;return o|0}return 0}function udb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[d>>2]|0;do{if((a[f]|0)==45){if((uqb(b,f+1|0)|0)!=0){g=0;break}g=c[d+4>>2]|0}else{g=0}}while(0);i=e;return g|0}function vdb(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(wdb(a,b)|0)!=0|0;i=c;return d|0}function wdb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=yqb(b|0)|0;g=c[d>>2]|0;if((a[g]|0)!=45){h=0;i=e;return h|0}if((vqb(b,g+1|0,f)|0)!=0){h=0;i=e;return h|0}if((a[g+(f+1)|0]|0)!=61){h=0;i=e;return h|0}h=g+(f+2)|0;i=e;return h|0}function xdb(){i=i;return}function ydb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;if((d|0)<=0){yc(0)}e=c[r>>2]|0;uc(297232,5,1,e|0)|0;f=b;b=0;while(1){Zd(a[f]|0,e|0)|0;g=b+1|0;if((g|0)<(d|0)){b=g;f=f+1|0}else{break}}uc(297240,20,1,e|0)|0;yc(0);return 0}function zdb(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;e=d;d=c[r>>2]|0;c[e>>2]=a;Dd(d|0,297264,e|0)|0;if((b|0)==0){yc(1)}else{Bd(d|0)|0;Hdb();Bd(d|0)|0;jb(6,0)|0;md()}}function Adb(a,b){a=a|0;b=b|0;var c=0.0;c=+W(+(+h[a>>3]),+(+h[b>>3]));i=i;return+c}function Bdb(a,b){a=a|0;b=b|0;var d=0,e=0.0,f=0.0,g=0.0,j=0,k=0.0,l=0.0;d=i;e=+h[a>>3];a=c[b>>2]|0;if((a|0)==0){f=1.0;i=d;return+f}if((a|0)<0){g=1.0;j=0-a|0;k=1.0/e}else{g=1.0;j=a;k=e}while(1){if((j&1|0)==0){l=g}else{l=g*k}a=j>>>1;if((a|0)==0){f=l;break}g=l;j=a;k=k*k}i=d;return+f}function Cdb(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0.0,f=0.0;c=i;d=+h[a>>3];if(!(d>=0.0)){e=-d}else{e=d}if(+h[b>>3]>=0.0){f=e;i=c;return+f}f=-e;i=c;return+f}function Ddb(a){a=a|0;var b=0.0,c=0.0,d=0.0;b=+g[a>>2];c=b;if(!(b>=0.0)){d=-+T(+(.5-c))}else{d=+T(+(c+.5))}i=i;return~~d|0}function Edb(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;g=b+d|0;h=c+e|0;if((d|0)>(e|0)){a:do{if((e|0)>0){j=b;k=c;while(1){l=a[j]|0;m=a[k]|0;if(!(l<<24>>24==m<<24>>24)){break}n=j+1|0;o=k+1|0;if(o>>>0<h>>>0){j=n;k=o}else{p=n;break a}}q=(l&255)-(m&255)|0;i=f;return q|0}else{p=b}}while(0);if(p>>>0<g>>>0){r=p}else{q=0;i=f;return q|0}while(1){s=a[r]|0;p=r+1|0;if(!(s<<24>>24==32)){break}if(p>>>0<g>>>0){r=p}else{q=0;t=18;break}}if((t|0)==18){i=f;return q|0}q=(s&255)+ -32|0;i=f;return q|0}else{b:do{if((d|0)>0){s=b;r=c;while(1){u=a[s]|0;v=a[r]|0;if(!(u<<24>>24==v<<24>>24)){break}p=s+1|0;m=r+1|0;if(p>>>0<g>>>0){s=p;r=m}else{w=m;break b}}q=(u&255)-(v&255)|0;i=f;return q|0}else{w=c}}while(0);if(w>>>0<h>>>0){x=w}else{q=0;i=f;return q|0}while(1){y=a[x]|0;w=x+1|0;if(!(y<<24>>24==32)){break}if(w>>>0<h>>>0){x=w}else{q=0;t=18;break}}if((t|0)==18){i=f;return q|0}q=32-(y&255)|0;i=f;return q|0}return 0}function Fdb(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;g=c;h=b+d|0;if((d|0)<=(e|0)){do{if(b>>>0>c>>>0){j=c+d|0;if(!(j>>>0>b>>>0)){break}if((d|0)>0){k=j;l=h}else{i=f;return}do{k=k+ -1|0;l=l+ -1|0;a[l]=a[k]|0;}while(l>>>0>b>>>0);i=f;return}}while(0);if((d|0)>0){m=c;n=b}else{i=f;return}while(1){l=n+1|0;a[n]=a[m]|0;if(l>>>0<h>>>0){n=l;m=m+1|0}else{break}}i=f;return}m=c+e|0;do{if(b>>>0>c>>>0&m>>>0>b>>>0){n=b+e|0;if((e|0)>0){l=0-g-e|0;k=~g;j=~(c+(l>>>0>k>>>0?l:k));k=n;l=m;do{l=l+ -1|0;k=k+ -1|0;a[k]=a[l]|0;}while(l>>>0>c>>>0);o=b+j|0}else{o=n}p=o+e|0}else{if((e|0)<=0){p=b;break}l=c+1|0;k=(m>>>0>l>>>0?m:l)+(0-g)|0;l=b;q=c;while(1){r=q+1|0;a[l]=a[q]|0;if(r>>>0<m>>>0){q=r;l=l+1|0}else{break}}p=b+k|0}}while(0);if(!(p>>>0<h>>>0)){i=f;return}Cqb(p|0,32,b+(d-p)|0)|0;i=f;return}function Gdb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+4>>2]|0;if((e|0)>99){i=d;return 0}f=298304+(e*48|0)|0;g=c[f>>2]|0;if((g|0)!=0){do{if((c[298348+(e*48|0)>>2]|0)==1){h=10}else{j=c[b+8>>2]|0;if((j|0)!=0){k=a[j]|0;if((k|0)==100|(k|0)==68){h=10;break}}if((c[298344+(e*48|0)>>2]|0)==1){Idb(b)|0}k=298308+(e*48|0)|0;if((c[k>>2]|0)==0){break}ad(c[f>>2]|0)|0;Xpb(c[k>>2]|0)}}while(0);do{if((h|0)==10){ad(g|0)|0;b=298308+(e*48|0)|0;k=c[b>>2]|0;if((k|0)==0){break}Qd(k|0)|0;Xpb(c[b>>2]|0)}}while(0);c[f>>2]=0}c[298340+(e*48|0)>>2]=0;c[298308+(e*48|0)>>2]=0;i=d;return 0}function Hdb(){var a=0,b=0;a=i;if((c[74318]|0)!=0){i=a;return}c[74318]=1;c[297280>>2]=0;b=0;do{c[297276>>2]=b;Gdb(297272)|0;b=b+1|0;}while((b|0)<100);i=a;return}function Idb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=c[a+4>>2]|0;if((c[298320+(d*48|0)>>2]|0)!=0){e=0;i=b;return e|0}f=298304+(d*48|0)|0;g=c[f>>2]|0;h=Bb(g|0)|0;Zc(g|0,0,2)|0;if((h|0)>=(Bb(g|0)|0)){e=0;i=b;return e|0}if((c[298324+(d*48|0)>>2]|0)==0){e=0;i=b;return e|0}if((c[298332+(d*48|0)>>2]&2|0)!=0){Bd(c[f>>2]|0)|0}d=Wc(tb(c[f>>2]|0)|0,h|0)|0;Zc(c[f>>2]|0,0,2)|0;if((d|0)==0){e=0;i=b;return e|0}if((c[a>>2]|0)==0){Kdb(111,297288);e=111;i=b;return e|0}else{c[(Qc()|0)>>2]=111;e=111;i=b;return e|0}return 0}function Jdb(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+80|0;d=b;do{if((ab(tb(a|0)|0,d|0)|0)<0){e=0}else{f=c[d+12>>2]&61440;if((f|0)==24576){e=1;break}else if((f|0)==32768|(f|0)==16384){e=(c[d+16>>2]|0)!=0|0;break}else if((f|0)==8192){e=(xb(tb(a|0)|0)|0)==0|0;break}else{e=0;break}}}while(0);i=b;return e|0}function Kdb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;d=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;do{if(a>>>0<100){Tc(b|0);l=c[r>>2]|0}else{if((a+1|0)>>>0>132){m=c[r>>2]|0;c[k>>2]=b;c[k+4>>2]=a;Dd(m|0,298200,k|0)|0;l=m;break}m=c[r>>2]|0;if((a|0)==-1){c[j>>2]=b;Dd(m|0,298232,j|0)|0;l=m;break}else{n=c[298072+(a+ -100<<2)>>2]|0;c[h>>2]=b;c[h+4>>2]=n;Dd(m|0,298256,h|0)|0;l=m;break}}}while(0);h=c[74566]|0;do{if((h|0)==0){uc(303136,29,1,l|0)|0}else{c[g>>2]=(h-298304|0)/48|0;Dd(l|0,298272,g|0)|0;b=c[(c[74566]|0)+4>>2]|0;if((b|0)==0){uc(303120,10,1,l|0)|0;break}else{c[f>>2]=b;Dd(l|0,303104,f|0)|0;break}}}while(0);f=c[75792]|0;if((f|0)!=0){c[d>>2]=f;Dd(l|0,303176,d|0)|0}d=(c[75812]|0)!=0?303256:303272;f=(c[75820]|0)!=0?303288:303304;g=(c[75830]|0)!=0?303328:303344;c[e>>2]=(c[75806]|0)!=0?303232:303240;c[e+4>>2]=d;c[e+8>>2]=f;c[e+12>>2]=g;Dd(l|0,303200,e|0)|0;zdb(303360,1)}function Ldb(){var a=0,b=0;a=i;c[75842]=1;b=c[r>>2]|0;c[74576]=b;c[298324>>2]=Jdb(b)|0;c[298328>>2]=1;c[298344>>2]=1;b=c[s>>2]|0;c[298544>>2]=b;c[298564>>2]=Jdb(b)|0;c[298568>>2]=1;c[298584>>2]=0;b=c[t>>2]|0;c[298592>>2]=b;c[298612>>2]=Jdb(b)|0;c[298616>>2]=1;c[298632>>2]=1;i=a;return}function Mdb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;d=a+28|0;e=c[d>>2]|0;a:do{if((e&2|0)==0){f=a+4|0;g=c[f>>2]|0;do{if((g|0)!=0){if((c[a+16>>2]|0)==0){h=c[a+24>>2]|0}else{h=0}if((c[a+40>>2]|0)==3){j=a;k=Ac(g|0,c[308616+(h<<2)>>2]|0,c[j>>2]|0)|0;c[j>>2]=k;c[75844]=k;if((k|0)==0){break}c[d>>2]=2;break a}k=a;j=Bb(c[k>>2]|0)|0;l=Ac(c[f>>2]|0,c[308616+((h|2)<<2)>>2]|0,c[k>>2]|0)|0;c[k>>2]=l;c[75844]=l;if((l|0)==0){c[k>>2]=0;break}else{c[d>>2]=3;Zc(c[k>>2]|0,j|0,0)|0;break a}}}while(0);c[(Qc()|0)>>2]=127;m=1;i=b;return m|0}else{if((e&1|0)==0){break}Zc(c[a>>2]|0,0,1)|0}}while(0);c[a+40>>2]=1;m=0;i=b;return m|0}function Ndb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if((a|0)==0){Kdb(b,d)}d=c[75846]|0;if((d|0)!=0){Je[d&7]()|0}c[(Qc()|0)>>2]=b;i=e;return b|0}function Odb(a){a=a|0;var b=0,d=0;b=i;c[75876]=0;c[75878]=0;c[75880]=0;d=((Pdb(a,0)|0)==0)<<31>>31;i=b;return d|0}function Pdb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b;while(1){b=a[f]|0;g=f+1|0;if(b<<24>>24==32){f=g}else if(b<<24>>24==40){break}else{h=0;j=8;break}}if((j|0)==8){i=e;return h|0}j=c[75880]|0;c[75880]=j+1;if((j|0)==1){c[75878]=d}if((Udb(1,d,0,0)|0)<0){h=0;i=e;return h|0}d=Vdb(g)|0;if((d|0)==0){h=0;i=e;return h|0}else{k=d}while(1){if((a[k]|0)==32){k=k+1|0}else{h=k;break}}i=e;return h|0}function Qdb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;e=i;i=i+8|0;f=e;if((c[a>>2]|0)>0){g=b;h=0}else{j=0;i=e;return j|0}a:while(1){b=(g|0)==0;b:while(1){k=c[75876]|0;l=303528+(k<<4)|0;m=c[l>>2]|0;switch(Rdb(m)|0){case 19:case 17:{c[75852]=0;c[75876]=k+1;continue b;break};case 20:{c[75872]=c[303532+(k<<4)>>2];c[75876]=k+1;continue b;break};case 3:{n=c[77092]|0;o=308376+(n<<2)|0;p=c[o>>2]|0;c[o>>2]=p+ -1;if((p|0)<2){c[77092]=n+ -1;c[77108]=(c[77108]|0)+ -1;c[75876]=k+1;continue b}else{n=c[77108]|0;c[77108]=n+ -1;c[75876]=(c[308440+(n<<2)>>2]|0)+1;continue b}break};case 9:{n=(pe[c[75860]&127](l)|0)==0;c[75876]=(c[75876]|0)+1;if(n){break b}else{continue b}break};case 21:{c[75854]=0;c[75876]=k+1;continue b;break};case 1:{n=c[303532+(k<<4)>>2]|0;p=(c[77108]|0)+1|0;c[77108]=p;c[308440+(p<<2)>>2]=n;c[75876]=k+1;continue b;break};case 8:{n=c[77092]|0;q=308376+(n<<2)|0;s=c[q>>2]|0;if((s|0)>=1){t=10;break b}c[77092]=n+ -1;c[75876]=k+1;continue b;break};case 6:{n=c[303532+(k<<4)>>2]|0;p=(c[77092]|0)+1|0;c[77092]=p;c[308376+(p<<2)>>2]=n;c[75876]=k+1;continue b;break};case 16:{if(b){t=28;break a}c[75876]=k+1;continue b;break};case 33:{c[77120]=1;c[75876]=k+1;continue b;break};case 2:{c[77092]=0;c[77108]=0;c[75876]=c[303532+(k<<4)>>2];if(b){t=24;break a}if((c[77104]|0)==0){j=0;t=37;break a}n=Je[c[75862]&7]()|0;if((n|0)==0){continue b}else{j=n;t=37;break a}break};case 22:{c[75854]=1;c[75876]=k+1;continue b;break};case 18:{c[75852]=1;c[75876]=k+1;continue b;break};default:{t=4;break a}}}if((t|0)==10){t=0;if(b){t=11;break}c[q>>2]=s+ -1;c[77104]=1;k=se[c[75858]&63](l,g,d)|0;if((k|0)>0){t=13;break}if((k|0)<0){t=15;break}}k=h+1|0;if((k|0)<(c[a>>2]|0)){g=g+d|0;h=k}else{j=0;t=37;break}}if((t|0)==4){h=c[r>>2]|0;d=c[75792]|0;c[f>>2]=m;c[f+4>>2]=d;Dd(h|0,308328,f|0)|0;if((c[c[75848]>>2]|0)==0){Kdb(100,308360);j=100;i=e;return j|0}else{c[(Qc()|0)>>2]=100;j=100;i=e;return j|0}}else if((t|0)==11){j=Je[c[75846]&7]()|0;i=e;return j|0}else if((t|0)==13){f=c[c[75848]>>2]|0;j=Ndb(f,c[(Qc()|0)>>2]|0,308424)|0;i=e;return j|0}else if((t|0)==15){if((c[(c[75848]|0)+8>>2]|0)==0){Kdb(-1,308424);j=-1;i=e;return j|0}else{c[(Qc()|0)>>2]=-1;j=-1;i=e;return j|0}}else if((t|0)==24){j=Je[c[75846]&7]()|0;i=e;return j|0}else if((t|0)==28){j=Je[c[75846]&7]()|0;i=e;return j|0}else if((t|0)==37){i=e;return j|0}return 0}function Rdb(a){a=a|0;var b=0;switch(a|0){case 14:case 13:case 15:case 12:case 11:case 5:case 4:{b=9;break};case 26:case 25:case 24:case 29:case 34:case 32:case 31:case 30:case 10:case 7:case 23:case 27:case 28:case 35:case 36:{b=8;break};default:{b=a}}i=i;return b|0}function Sdb(){var a=0,b=0,d=0;a=i;i=i+8|0;b=a;c[b>>2]=1;d=Qdb(b,0,0)|0;i=a;return d|0}function Tdb(){c[75868]=0;c[75876]=0;c[77108]=0;c[77092]=0;c[77104]=0;c[77110]=0;c[77094]=0;i=i;return}function Udb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=c[75876]|0;if((g|0)>299){uc(308504,24,1,c[r>>2]|0)|0;zdb(c[75792]|0,1)}else{c[303528+(g<<4)>>2]=a;c[303532+(g<<4)>>2]=b;c[303536+(g<<4)>>2]=d;c[303540+(g<<4)>>2]=e;c[75876]=g+1;i=f;return g|0}return 0}function Vdb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=a[b]|0;if(e<<24>>24==0){f=0;i=d;return f|0}else{g=b;h=e}a:while(1){e=g+1|0;if(h<<24>>24==32){h=a[e]|0;g=e;continue}e=Wdb(g)|0;if((e|0)==0){f=0;j=12;break}else{k=e}while(1){e=a[k]|0;if(e<<24>>24==41){j=9;break a}else if(e<<24>>24==44){j=7;break}else if(!(e<<24>>24==32)){l=k;break}k=k+1|0}if((j|0)==7){j=0;l=k+1|0}e=a[l]|0;if(e<<24>>24==0){f=0;j=12;break}else{g=l;h=e}}if((j|0)==9){h=(c[75880]|0)+ -1|0;c[75880]=h;if((h|0)==0){Udb(2,c[75878]|0,0,0)|0;f=k+1|0;i=d;return f|0}else{Udb(3,0,0,0)|0;f=k+1|0;i=d;return f|0}}else if((j|0)==12){i=d;return f|0}return 0}function Wdb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;do{if((a[b]|0)==41){g=b}else{if((Xdb(b,e)|0)!=0){g=c[e>>2]|0;break}if((Ydb(b,e)|0)!=0){g=c[e>>2]|0;break}h=Zdb(b,f,1)|0;j=Udb(6,c[f>>2]|0,0,0)|0;if((j|0)<0){g=0;break}g=Pdb(h,j)|0}}while(0);i=d;return g|0}function Xdb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+8|0;f=e;a:do{switch(a[b]|0){case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{g=b;h=0;j=14;break};case 58:{Udb(16,0,0,0)|0;k=b;j=30;break};case 45:{l=1;j=13;break};case 43:{l=0;j=13;break};case 98:case 66:{m=b+1|0;n=a[m]|0;if(n<<24>>24==90|n<<24>>24==122){Udb(22,0,0,0)|0;k=m;j=30;break a}else{Udb(21,0,0,0)|0;k=m;j=30;break a}break};case 36:{Udb(33,0,0,0)|0;k=b;j=30;break};case 120:case 88:{Udb(4,1,0,0)|0;k=b;j=30;break};case 39:case 34:case 2:{c[303536+((Udb(11,0,0,0)|0)<<4)>>2]=b;m=_db(b)|0;c[d>>2]=m;o=(m|0)!=0|0;i=e;return o|0};case 112:case 80:{Udb(20,1,0,0)|0;k=b;j=30;break};case 115:case 83:{m=b+1|0;n=a[m]|0;if(n<<24>>24==83|n<<24>>24==115){p=m;q=19}else if(n<<24>>24==80|n<<24>>24==112){p=m;q=18}else{p=b;q=17}Udb(q,0,0,0)|0;k=p;j=30;break};case 47:{Udb(5,0,0,0)|0;k=b;j=30;break};case 116:case 84:{m=b+1|0;n=a[m]|0;if(n<<24>>24==76|n<<24>>24==108){r=m;s=13}else if(n<<24>>24==82|n<<24>>24==114){r=m;s=14}else{r=b;s=15}m=Zdb(r+1|0,f,0)|0;if((m|0)==0){j=15;break a}Udb(s,c[f>>2]|0,0,0)|0;k=m+ -1|0;j=30;break};default:{o=0;i=e;return o|0}}}while(0);if((j|0)==13){g=b+1|0;h=l;j=14}b:do{if((j|0)==14){l=Zdb(g,f,0)|0;if((l|0)==0){j=15;break}switch(a[l]|0){case 120:case 88:{Udb(4,c[f>>2]|0,0,0)|0;k=l;j=30;break b;break};case 104:case 72:{b=c[f>>2]|0;c[303536+((Udb(12,b,0,0)|0)<<4)>>2]=l+1;k=l+b|0;j=30;break b;break};case 112:case 80:{b=c[f>>2]|0;if((h|0)==0){t=b}else{s=0-b|0;c[f>>2]=s;t=s}Udb(20,t,0,0)|0;k=l;j=30;break b;break};default:{o=0;i=e;return o|0}}}}while(0);if((j|0)==15){c[d>>2]=0;o=1;i=e;return o|0}else if((j|0)==30){c[d>>2]=k+1;o=1;i=e;return o|0}return 0}function Ydb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=Zdb(b,f,1)|0;Udb(6,c[f>>2]|0,0,0)|0;f=k+1|0;a:do{switch(a[k]|0){case 108:case 76:{l=Zdb(f,g,0)|0;if((l|0)==0){m=4;break a}n=c[g>>2]|0;if((n|0)==0){o=l;m=45;break a}Udb(29,n,0,0)|0;o=l;m=45;break};case 100:case 68:{l=Zdb(f,g,0)|0;if((l|0)==0){m=4;break a}n=c[g>>2]|0;if((n|0)==0){o=l;m=45;break a}if((a[l]|0)==46){p=Zdb(l+1|0,h,0)|0;if((p|0)==0){m=4;break a}q=p;r=c[h>>2]|0}else{c[h>>2]=0;q=l;r=0}Udb(26,n,r,0)|0;o=q;m=45;break};case 105:case 73:{s=7;t=10;m=38;break};case 102:case 70:{n=Zdb(f,g,0)|0;if((n|0)==0){m=4;break a}l=c[g>>2]|0;if((l|0)==0){o=n;m=45;break a}if((a[n]|0)==46){p=Zdb(n+1|0,h,0)|0;if((p|0)==0){m=4;break a}u=p;v=c[h>>2]|0}else{c[h>>2]=0;u=n;v=0}Udb(23,l,v,0)|0;o=u;m=45;break};case 97:case 65:{l=f;while(1){w=a[l]|0;if(w<<24>>24==32){l=l+1|0}else{break}}if(!((w+ -48<<24>>24&255)<10)){Udb(30,0,0,0)|0;o=l;m=45;break a}n=Zdb(l,g,1)|0;p=c[g>>2]|0;if((p|0)==0){o=n;m=45;break a}Udb(31,p,0,0)|0;o=n;m=45;break};case 111:case 79:{s=32;t=34;m=38;break};case 122:case 90:{s=35;t=36;m=38;break};case 103:case 71:{x=0;m=3;break};case 101:case 69:{x=1;m=3;break};default:{c[75876]=(c[75876]|0)+ -1;c[d>>2]=b;y=0;i=e;return y|0}}}while(0);do{if((m|0)==3){b=Zdb(f,g,0)|0;if((b|0)==0){m=4;break}w=c[g>>2]|0;if((w|0)==0){o=b;m=45;break}u=a[b]|0;if(u<<24>>24==46){v=Zdb(b+1|0,h,0)|0;if((v|0)==0){m=4;break}z=v;A=a[v]|0}else{c[h>>2]=0;z=b;A=u}if(!(A<<24>>24==101|A<<24>>24==69)){Udb((x|0)==1?24:27,w,c[h>>2]|0,0)|0;o=z;m=45;break}u=Zdb(z+1|0,j,0)|0;if((u|0)==0){m=4;break}Udb((x|0)==1?25:28,w,c[h>>2]|0,c[j>>2]|0)|0;o=u;m=45}else if((m|0)==38){u=Zdb(f,g,0)|0;if((u|0)==0){m=4;break}w=c[g>>2]|0;if((w|0)==0){o=u;m=45;break}if((a[u]|0)!=46){Udb(s,w,0,0)|0;o=u;m=45;break}b=Zdb(u+1|0,h,0)|0;if((b|0)==0){m=4;break}Udb(t,w,c[h>>2]|0,0)|0;o=b;m=45}}while(0);if((m|0)==4){c[d>>2]=0;y=1;i=e;return y|0}else if((m|0)==45){c[d>>2]=o;y=1;i=e;return y|0}return 0}function Zdb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=b;b=0;h=0;while(1){j=a[g]|0;k=j<<24>>24;if(j<<24>>24==32){l=b;m=h}else{if((j+ -48<<24>>24&255)>9){break}l=b+1|0;m=(h*10|0)+ -48+k|0}g=g+1|0;b=l;h=m}if((b|0)!=0){n=g;o=h;c[d>>2]=o;i=f;return n|0}n=(e|0)==0?0:g;o=e;c[d>>2]=o;i=f;return n|0}function _db(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;e=a[b]|0;f=b+1|0;g=a[f]|0;a:do{if(!(g<<24>>24==0)){h=f;j=g;k=b;while(1){if(j<<24>>24==e<<24>>24){l=k+2|0;if((a[l]|0)==e<<24>>24){m=l}else{n=l;break}}else{m=h}l=m+1|0;o=a[l]|0;if(o<<24>>24==0){break a}else{h=l;j=o;k=m}}i=d;return n|0}}while(0);if((c[c[75848]>>2]|0)==0){Kdb(100,308488);n=0;i=d;return n|0}else{c[(Qc()|0)>>2]=100;n=0;i=d;return n|0}return 0}function $db(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;do{if((b|0)>0){h=0;j=b}else{if((b|0)<0){h=1;j=0-b|0;break}c[e>>2]=0;c[d>>2]=1;a[308558|0]=48;k=308558|0;i=g;return k|0}}while(0);c[e>>2]=h;h=23;e=j;while(1){j=h+ -1|0;l=308536+j|0;a[l]=((e>>>0)%(f>>>0)|0)+48;b=(e>>>0)/(f>>>0)|0;if((b|0)==0){break}else{e=b;h=j}}c[d>>2]=24-h;k=l;i=g;return k|0}function aeb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[75870]|0;f=c[75866]|0;if((e|0)>(f|0)){c[75866]=e;g=e}else{g=f}f=g+1|0;if((f|0)<(c[77158]|0)){h=g}else{beb(f,g);h=c[75866]|0}g=c[77160]|0;f=g+h|0;if((b|0)==0){j=f}else{a[f]=b;j=g+(h+1)|0}a[j]=0;Rd(g|0,c[75844]|0)|0;h=yqb(g|0)|0;b=g+h|0;if(b>>>0<j>>>0){k=b;l=h;m=g}else{i=d;return 0}while(1){g=l+1|0;h=m+g|0;Zd(a[k]|0,c[75844]|0)|0;Rd(h|0,c[75844]|0)|0;b=yqb(h|0)|0;f=m+(g+b)|0;if(f>>>0<j>>>0){m=h;l=b;k=f}else{break}}i=d;return 0}function beb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=c[77160]|0;if((f|0)==308720){c[77158]=1024;g=1024}else{g=c[77158]|0}if((g|0)>(b|0)){h=g}else{j=g;do{j=j<<1;}while((j|0)<=(b|0));c[77158]=j;h=j}j=Wpb(h)|0;if((j|0)==0){Kdb(113,309120);k=c[77160]|0}else{k=f}f=k+d|0;if((d|0)>0){d=j;h=k;while(1){b=h+1|0;a[d]=a[h]|0;if(b>>>0<f>>>0){h=b;d=d+1|0}else{break}}l=c[77160]|0}else{l=k}if((l|0)==308720){m=308640;c[77160]=j;i=e;return}Xpb(l);m=308640;c[77160]=j;i=e;return}function ceb(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[75866]|0;f=c[77158]|0;if((e|0)<(f|0)){g=e}else{beb(e,f);g=c[75866]|0}c[75866]=g+1;a[(c[77160]|0)+g|0]=b;i=d;return}function deb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+8|0;e=d;f=i;i=i+256|0;g=i;i=i+16|0;h=i;i=i+8|0;j=f;c[75830]=1;f=b+4|0;k=c[f>>2]|0;if(k>>>0>99){if((c[b>>2]|0)==0){Kdb(101,308648);l=101;i=d;return l|0}else{c[(Qc()|0)>>2]=101;l=101;i=d;return l|0}}if((c[75842]|0)==0){Ldb();m=c[f>>2]|0}else{m=k}k=298304+(m*48|0)|0;c[74566]=k;n=k;a:do{if((c[n>>2]|0)!=0){k=c[b+8>>2]|0;do{if((k|0)!=0){ieb(k,c[b+12>>2]|0,j);o=jeb(j,h)|0;if((o|0)==(c[298312+(m*48|0)>>2]|0)){if((c[h>>2]|0)==(c[298316+(m*48|0)>>2]|0)){break}}c[g+4>>2]=c[f>>2];c[g+8>>2]=0;c[g>>2]=c[b>>2];o=Gdb(g)|0;if((o|0)==0){break a}else{l=o}i=d;return l|0}}while(0);k=c[b+32>>2]|0;if((k|0)==0){l=0;i=d;return l|0}o=a[k]|0;if(o<<24>>24==122){p=1}else{p=o<<24>>24==90|0}c[298336+(m*48|0)>>2]=p;l=0;i=d;return l|0}}while(0);p=b+28|0;g=c[p>>2]|0;h=298320+(m*48|0)|0;c[h>>2]=g;o=c[b+32>>2]|0;do{if((o|0)==0){q=0}else{k=a[o]|0;if(k<<24>>24==122){q=1;break}q=k<<24>>24==90|0}}while(0);c[298336+(m*48|0)>>2]=q;q=c[b+24>>2]|0;do{if((q|0)==0){o=298328+(m*48|0)|0;if((g|0)>0){c[o>>2]=0;r=0;break}else{c[o>>2]=1;r=1;break}}else{o=a[q]|0;if(o<<24>>24==70|o<<24>>24==102){c[298328+(m*48|0)>>2]=1;r=1;break}else{c[298328+(m*48|0)>>2]=0;r=0;break}}}while(0);q=c[b+8>>2]|0;do{if((q|0)==0){c[e>>2]=c[f>>2];lc(j|0,308656,e|0)|0}else{ieb(q,c[b+12>>2]|0,j);if((a[j]|0)!=0){break}if((c[b>>2]|0)==0){eeb(107,308648,b);l=107;i=d;return l|0}else{c[(Qc()|0)>>2]=107;l=107;i=d;return l|0}}}while(0);q=298348+(m*48|0)|0;c[q>>2]=0;c[298340+(m*48|0)>>2]=0;e=298344+(m*48|0)|0;c[e>>2]=0;c[n>>2]=0;f=298332+(m*48|0)|0;c[f>>2]=3;g=c[b+16>>2]|0;b:do{if((g|0)!=0){c:do{switch(a[g]|0){case 83:case 115:{c[q>>2]=1;o=Pb()|0;c[n>>2]=o;if((o|0)!=0){c[298308+(m*48|0)>>2]=0;c[298316+(m*48|0)>>2]=-1;c[298312+(m*48|0)>>2]=-1;c[298324+(m*48|0)>>2]=1;l=0;i=d;return l|0}o=(c[b>>2]|0)==0;k=Qc()|0;s=c[k>>2]|0;if(o){eeb(s,308648,b);l=c[k>>2]|0;i=d;return l|0}else{c[k>>2]=s;l=s;i=d;return l|0}break};case 79:case 111:{if((Fc(j|0,0)|0)==0){break b}s=(c[b>>2]|0)==0;k=Qc()|0;o=c[k>>2]|0;if(s){eeb(o,308648,b);l=c[k>>2]|0;i=d;return l|0}else{c[k>>2]=o;l=o;i=d;return l|0}break};case 78:case 110:{if((Fc(j|0,0)|0)!=0){break c}if((c[b>>2]|0)==0){eeb(128,308648,b);l=128;i=d;return l|0}else{c[(Qc()|0)>>2]=128;l=128;i=d;return l|0}break};case 82:case 114:{break};default:{break b}}}while(0);o=mc(j|0,c[77154]|0)|0;if((o|0)==0){break}ad(o|0)|0}}while(0);q=Wpb((yqb(j|0)|0)+1|0)|0;c[298308+(m*48|0)>>2]=q;if((q|0)==0){if((c[b>>2]|0)==0){eeb(113,308672,b);l=113;i=d;return l|0}else{c[(Qc()|0)>>2]=113;l=113;i=d;return l|0}}Eqb(q|0,j|0)|0;q=b+20|0;if((c[q>>2]|0)==0){t=r}else{t=(c[h>>2]|0)==0?r:0}r=mc(j|0,c[308616+((t|2)<<2)>>2]|0)|0;do{if((r|0)==0){h=mc(j|0,c[308576+(t<<2)>>2]|0)|0;if((h|0)!=0){c[f>>2]=1;u=h;break}h=mc(j|0,c[308616+(t<<2)>>2]|0)|0;if((h|0)!=0){c[e>>2]=1;c[f>>2]=2;u=h;break}h=(c[b>>2]|0)==0;g=Qc()|0;o=c[g>>2]|0;if(h){Kdb(o,308648);l=c[g>>2]|0;i=d;return l|0}else{c[g>>2]=o;l=o;i=d;return l|0}}else{u=r}}while(0);c[n>>2]=u;r=298324+(m*48|0)|0;c[r>>2]=Jdb(u)|0;u=jeb(j,298316+(m*48|0)|0)|0;c[298312+(m*48|0)>>2]=u;if((u|0)==-1){if((c[b>>2]|0)==0){eeb(108,308648,b);l=108;i=d;return l|0}else{c[(Qc()|0)>>2]=108;l=108;i=d;return l|0}}if((c[r>>2]|0)==0){l=0;i=d;return l|0}if((c[p>>2]|0)!=0){rb(c[n>>2]|0);l=0;i=d;return l|0}p=c[q>>2]|0;if((p|0)==0){l=0;i=d;return l|0}q=a[p]|0;if(!(q<<24>>24==65|q<<24>>24==97)){l=0;i=d;return l|0}if((Zc(c[n>>2]|0,0,2)|0)==0){l=0;i=d;return l|0}if((c[b>>2]|0)==0){eeb(129,308648,b);l=129;i=d;return l|0}else{c[(Qc()|0)>>2]=129;l=129;i=d;return l|0}return 0}function eeb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=d+8|0;g=c[f>>2]|0;if((g|0)==0){Kdb(a,b);i=e;return}h=d+12|0;d=c[h>>2]|0;if((d|0)<(c[77158]|0)){j=d;k=g}else{beb(d,0);j=c[h>>2]|0;k=c[f>>2]|0}f=c[77160]|0;c[(c[74566]|0)+4>>2]=f;ieb(k,j,f);Kdb(a,b);i=e;return}function feb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+40|0;j=g;c[f>>2]=d;lc(j|0,308656,f|0)|0;c[h>>2]=1;c[h+4>>2]=d;c[h+8>>2]=j;c[h+12>>2]=yqb(j|0)|0;c[h+16>>2]=0;c[h+20>>2]=(a|0)==3?308688:308696;c[h+24>>2]=(b|0)==5?308704:308712;c[h+28>>2]=(a|0)==4;c[h+32>>2]=0;a=deb(h)|0;i=e;return a|0}function geb(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a+4>>2]|0;e=298304+(d*48|0)|0;c[74566]=e;if(d>>>0>99){if((c[a>>2]|0)==0){Kdb(101,309136);f=101;i=b;return f|0}else{c[(Qc()|0)>>2]=101;f=101;i=b;return f|0}}do{if((c[e>>2]|0)==0){if((feb(3,5,d)|0)==0){break}if((c[a>>2]|0)==0){Kdb(114,309144);f=114;i=b;return f|0}else{c[(Qc()|0)>>2]=114;f=114;i=b;return f|0}}}while(0);if((c[298328+(d*48|0)>>2]|0)!=0){f=0;i=b;return f|0}if((c[a>>2]|0)==0){Kdb(102,309144);f=102;i=b;return f|0}else{c[(Qc()|0)>>2]=102;f=102;i=b;return f|0}return 0}function heb(){var a=0,b=0;a=i;b=Sdb()|0;c[75792]=0;i=a;return b|0}function ieb(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b+c|0;g=d+c|0;while(1){if(!(f>>>0>b>>>0)){h=3;break}j=f+ -1|0;k=g+ -1|0;if((a[j]|0)==32){f=j;g=k}else{break}}if((h|0)==3){a[d]=0;i=e;return}a[g]=0;g=j;j=k;while(1){a[j]=a[g]|0;if(g>>>0>b>>>0){j=j+ -1|0;g=g+ -1|0}else{break}}i=e;return}function jeb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+80|0;e=d;if((pc(a|0,e|0)|0)<0){f=-1;i=d;return f|0}c[b>>2]=c[e>>2];f=c[e+72>>2]|0;i=d;return f|0}function keb(b,d,e,f,j){b=b|0;d=d|0;e=e|0;f=f|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;l=i;i=i+8|0;m=l;n=i;i=i+16|0;o=i;i=i+56|0;p=o;q=(f|0)<1?2:f;r=c[75872]|0;if((r|0)==0){s=3}else{if((r|0)<(e+2|0)&(r|0)>(0-e|0)){s=3}}a:do{if((s|0)==3){t=(((r|0)<1)<<31>>31)+e|0;if((j|0)==4){u=+g[b>>2]}else{u=+h[b>>3]}do{if(u<0.0){v=-u;w=1;x=1}else{y=c[75852]|0;if(u!=0.0){v=u;w=0;x=y;break}v=0.0;w=0;x=y}}while(0);y=d+ -4-q-t-x|0;if((y|0)<0){break}z=((r|0)<0?r:0)+t|0;A=(z|0)>40;B=A?40:z;C=A?z+ -40|0:0;c[n>>2]=B;z=n+4|0;h[k>>3]=v;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];lc(p|0,309152,n|0)|0;z=a[p]|0;if(!((z+ -48|0)>>>0<10)){if((z|0)==78|(z|0)==110){D=0}else{D=x}z=d-(yqb(p|0)|0)-D|0;if((z|0)<0){break}if((z|0)>0){A=z;do{A=A+ -1|0;me[c[75856]&2047](32);}while((A|0)>0)}if((D|0)!=0){me[c[75856]&2047]((w|0)!=0?45:43)}A=a[p]|0;if(A<<24>>24==0){i=l;return 0}else{E=A;F=p}do{me[c[75856]&2047](E<<24>>24);F=F+1|0;E=a[F]|0;}while(!(E<<24>>24==0));i=l;return 0}A=o+(B+3)|0;if(v!=0.0){t=(Ic(A|0)|0)+1|0;c[m>>2]=t-(c[75872]|0);lc(A|0,309160,m|0)|0}else{t=A;a[t]=3158059;a[t+1|0]=12336;a[t+2|0]=48;a[t+3|0]=0}t=o+(B+4)|0;A=(q|0)<2;if(A){if((a[t]|0)!=48){break}}z=o+(B+6)|0;G=(a[z]|0)==0;b:do{if(G){H=2}else{if((f|0)==0){I=o+(B+2)|0;while(1){J=I+1|0;K=a[J]|0;a[I]=K;if(K<<24>>24==0){H=2;break b}else{I=J}}}I=(f|0)<0;if(I|G){H=I?q:2;break}else{L=2;M=z}while(1){if((L|0)>=(q|0)){break a}I=L+1|0;J=M+1|0;if((a[J]|0)==0){H=I;break}else{L=I;M=J}}}}while(0);if((y|0)>0){z=y;do{z=z+ -1|0;me[c[75856]&2047](32);}while((z|0)>0)}if((x|0)!=0){me[c[75856]&2047]((w|0)!=0?45:43)}z=c[75872]|0;do{if((z|0)<1){me[c[75856]&2047](46);y=c[75856]|0;if((z|0)<0){G=y;J=z;while(1){me[G&2047](48);I=J+1|0;K=c[75856]|0;if((I|0)<0){J=I;G=K}else{N=K;break}}}else{N=y}me[N&2047](a[p]|0);O=o+2|0}else{if((z|0)<=1){O=p;break}me[c[75856]&2047](a[p]|0);G=o+2|0;J=z+ -1|0;K=c[75856]|0;if((J|0)>0){I=z+1|0;P=K;Q=J;J=G;while(1){me[P&2047](a[J]|0);R=Q+ -1|0;S=c[75856]|0;if((R|0)>0){J=J+1|0;Q=R;P=S}else{break}}T=S;U=o+I|0}else{T=K;U=G}me[T&2047](46);O=U}}while(0);if((C|0)==0){V=O}else{z=o+(B+2)|0;if(O>>>0<z>>>0){P=O;while(1){Q=P+1|0;me[c[75856]&2047](a[P]|0);if(Q>>>0<z>>>0){P=Q}else{W=Q;break}}}else{W=O}P=C;while(1){me[c[75856]&2047](48);z=P+ -1|0;if((z|0)>0){P=z}else{V=W;break}}}if(V>>>0<t>>>0){P=V;while(1){C=P+1|0;me[c[75856]&2047](a[P]|0);if(C>>>0<t>>>0){P=C}else{X=C;break}}}else{X=V}if(A){me[c[75856]&2047](a[X+1|0]|0);i=l;return 0}if((H|0)<(q|0)){P=H;do{P=P+1|0;me[c[75856]&2047](48);}while((P|0)<(q|0))}P=a[X]|0;if(P<<24>>24==0){i=l;return 0}else{Y=P;Z=X}do{Z=Z+1|0;me[c[75856]&2047](Y<<24>>24);Y=a[Z]|0;}while(!(Y<<24>>24==0));i=l;return 0}}while(0);if((d|0)>0){_=d}else{i=l;return 0}do{_=_+ -1|0;me[c[75856]&2047](42);}while((_|0)>0);i=l;return 0}function leb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0;j=i;i=i+16|0;l=j;m=i;i=i+656|0;n=m;if((f|0)==4){o=+g[b>>2]}else{o=+h[b>>3]}b=(e|0)<344;f=b?e:344;p=b?0:e+ -344|0;do{if(o<0.0){q=1;r=-o}else{if(o!=0.0){q=0;r=o;break}q=0;r=0.0}}while(0);e=c[75872]|0;if((e|0)==0){s=r}else{if((e|0)>0){b=e;o=r;while(1){t=o*10.0;u=b+ -1|0;if((u|0)>0){o=t;b=u}else{s=t;break}}}else{b=e;o=r;while(1){r=o*.1;e=b+1|0;if((e|0)<0){o=r;b=e}else{s=r;break}}}}c[l>>2]=f;b=l+4|0;h[k>>3]=s;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=(lc(n|0,309168,l|0)|0)+p|0;if((a[n]|0)!=48|(f|0)==0){v=n;w=b}else{v=m+1|0;w=b+ -1|0}a:do{if((q|0)==1){b=v;while(1){m=a[b]|0;if(!(m<<24>>24==48)){n=m<<24>>24;if((n|0)==0){x=0;break a}else if((n|0)!=46){break}}b=b+1|0}x=1}else{x=q}}while(0);q=(x|0)==0;b=((c[75852]|x|0)!=0)+w|0;if((b|0)>(d|0)){if((d|0)>0){y=d}else{i=j;return 0}do{y=y+ -1|0;me[c[75856]&2047](42);}while((y|0)>0);i=j;return 0}y=d-b|0;if((y|0)>0){b=y;do{b=b+ -1|0;me[c[75856]&2047](32);}while((b|0)>0)}do{if(q){if((c[75852]|0)==0){break}me[c[75856]&2047](43)}else{me[c[75856]&2047](45)}}while(0);q=a[v]|0;if(!(q<<24>>24==0)){b=q;q=v;do{q=q+1|0;me[c[75856]&2047](b<<24>>24);b=a[q]|0;}while(!(b<<24>>24==0))}if((p|0)>0){z=p}else{i=j;return 0}do{z=z+ -1|0;me[c[75856]&2047](48);}while((z|0)>0);i=j;return 0}function meb(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((f|0)==1){h=a[d]|0}else if((f|0)==4){h=c[d>>2]|0}else{h=b[d>>1]|0}d=e+ -1|0;if((d|0)>0){e=0;do{me[c[75856]&2047](32);e=e+1|0;}while((e|0)<(d|0))}d=c[75856]|0;if((h|0)==0){me[d&2047](70);i=g;return 0}else{me[d&2047](84);i=g;return 0}return 0}function neb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;do{if((c[75868]|0)!=0){g=oeb()|0;if((g|0)==0){break}else{h=g}i=e;return h|0}}while(0);g=c[a>>2]|0;switch(g|0){case 35:{ueb(b,c[a+4>>2]|0,0,d);h=0;i=e;return h|0};case 28:case 27:{h=teb(b,c[a+4>>2]|0,c[a+8>>2]|0,c[a+12>>2]|0,d)|0;i=e;return h|0};case 32:{peb(b,c[a+4>>2]|0,d,8);h=0;i=e;return h|0};case 31:{seb(b,c[a+4>>2]|0,d);h=0;i=e;return h|0};case 29:{meb(b,c[a+4>>2]|0,d)|0;h=0;i=e;return h|0};case 30:{reb(b,d);h=0;i=e;return h|0};case 25:case 24:case 26:{h=keb(b,c[a+4>>2]|0,c[a+8>>2]|0,c[a+12>>2]|0,d)|0;i=e;return h|0};case 23:{h=leb(b,c[a+4>>2]|0,c[a+8>>2]|0,d)|0;i=e;return h|0};case 34:{qeb(b,c[a+4>>2]|0,c[a+8>>2]|0,d,8);h=0;i=e;return h|0};case 7:{peb(b,c[a+4>>2]|0,d,10);h=0;i=e;return h|0};case 36:{ueb(b,c[a+4>>2]|0,c[a+8>>2]|0,d);h=0;i=e;return h|0};case 10:{qeb(b,c[a+4>>2]|0,c[a+8>>2]|0,d,10);h=0;i=e;return h|0};default:{h=c[r>>2]|0;c[f>>2]=g;Dd(h|0,309176,f|0)|0;zdb(c[75792]|0,1)}}return 0}function oeb(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;a=i;b=c[75868]|0;c[75868]=0;if((c[75830]|0)!=0){if((b|0)>0){d=c[75870]|0;e=c[75866]|0;if((d|0)<=(e|0)){f=b;while(1){me[c[75856]&2047](32);g=f+ -1|0;if((g|0)>0){f=g}else{h=0;break}}i=a;return h|0}f=e+b|0;if((d|0)>(f|0)){c[75866]=f;h=0;i=a;return h|0}f=b-d+e|0;c[75866]=d;if((f|0)>0){j=f}else{h=0;i=a;return h|0}while(1){me[c[75856]&2047](32);f=j+ -1|0;if((f|0)>0){j=f}else{h=0;break}}i=a;return h|0}if((b|0)>=0){h=0;i=a;return h|0}j=c[75866]|0;f=j+b|0;if((f|0)>=0){if((c[75870]|0)<(j|0)){c[75870]=j}c[75866]=f;h=0;i=a;return h|0}if((c[c[75848]>>2]|0)==0){Kdb(110,309264);h=110;i=a;return h|0}else{c[(Qc()|0)>>2]=110;h=110;i=a;return h|0}}if((b|0)<0){f=c[75866]|0;if((c[75870]|0)<(f|0)){c[75870]=f}j=f+b|0;c[75866]=j;c[75874]=(c[75874]|0)+b;if((j|0)>=0){h=0;i=a;return h|0}if((c[c[75848]>>2]|0)==0){Kdb(110,309264);h=110;i=a;return h|0}else{c[(Qc()|0)>>2]=110;h=110;i=a;return h|0}}if((b|0)<=0){h=0;i=a;return h|0}j=c[75866]|0;f=j+b|0;if((f|0)>=(c[(c[75850]|0)+16>>2]|0)){if((c[c[75848]>>2]|0)==0){Kdb(110,309280);h=110;i=a;return h|0}else{c[(Qc()|0)>>2]=110;h=110;i=a;return h|0}}d=c[75870]|0;if((d|0)<=(j|0)){e=b;while(1){me[c[75856]&2047](32);g=e+ -1|0;if((g|0)>0){e=g}else{h=0;break}}i=a;return h|0}if((d|0)>(f|0)){c[75874]=(c[75874]|0)+b;c[75866]=f;h=0;i=a;return h|0}f=d-j|0;j=b-f|0;c[75874]=(c[75874]|0)+f;c[75866]=d;if((j|0)>0){k=j}else{h=0;i=a;return h|0}while(1){me[c[75856]&2047](32);j=k+ -1|0;if((j|0)>0){k=j}else{h=0;break}}i=a;return h|0}function peb(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+16|0;j=h;k=h+8|0;if((f|0)==1){l=a[d]|0}else if((f|0)==4){l=c[d>>2]|0}else{l=b[d>>1]|0}d=$db(l,j,k,g)|0;g=c[k>>2]|0;l=(((c[75852]|g|0)!=0)<<31>>31)+(e-(c[j>>2]|0))|0;if((l|0)<0){if((e|0)>0){m=0}else{i=h;return}do{me[c[75856]&2047](42);m=m+1|0;}while((m|0)<(e|0));i=h;return}if((l|0)>0){e=0;do{me[c[75856]&2047](32);e=e+1|0;}while((e|0)<(l|0));n=c[k>>2]|0}else{n=g}do{if((n|0)==0){if((c[75852]|0)==0){break}me[c[75856]&2047](43)}else{me[c[75856]&2047](45)}}while(0);if((c[j>>2]|0)>0){o=d;p=0}else{i=h;return}while(1){me[c[75856]&2047](a[o]|0);d=p+1|0;if((d|0)<(c[j>>2]|0)){p=d;o=o+1|0}else{break}}i=h;return}function qeb(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;j=i;i=i+16|0;k=j;l=j+8|0;if((g|0)==1){m=a[d]|0}else if((g|0)==4){m=c[d>>2]|0}else{m=b[d>>1]|0}d=$db(m,k,l,h)|0;h=c[l>>2]|0;g=(c[75852]|h|0)!=0;n=g&1;o=c[k>>2]|0;do{if((n+o|0)<=(e|0)){if((n+f|0)>(e|0)){break}if((m|f|0)==0){if((e|0)>0){p=0}else{i=j;return}do{me[c[75856]&2047](32);p=p+1|0;}while((p|0)<(e|0));i=j;return}q=e-((o|0)<(f|0)?f:o)+(g<<31>>31)|0;if((q|0)>0){r=0;do{me[c[75856]&2047](32);r=r+1|0;}while((r|0)<(q|0));s=c[l>>2]|0}else{s=h}do{if((s|0)==0){if((c[75852]|0)==0){break}me[c[75856]&2047](43)}else{me[c[75856]&2047](45)}}while(0);q=c[k>>2]|0;if((f-q|0)>0){r=0;while(1){me[c[75856]&2047](48);t=r+1|0;u=c[k>>2]|0;if((t|0)<(f-u|0)){r=t}else{v=u;break}}}else{v=q}if((v|0)>0){w=d;x=0}else{i=j;return}while(1){me[c[75856]&2047](a[w]|0);r=x+1|0;if((r|0)<(c[k>>2]|0)){x=r;w=w+1|0}else{break}}i=j;return}}while(0);if((e|0)>0){y=0}else{i=j;return}do{me[c[75856]&2047](42);y=y+1|0;}while((y|0)<(e|0));i=j;return}function reb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((d|0)>0){f=b;g=d}else{i=e;return}while(1){d=g+ -1|0;me[c[75856]&2047](a[f]|0);if((d|0)>0){g=d;f=f+1|0}else{break}}i=e;return}function seb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;if((d|0)>(e|0)){g=d;while(1){h=g+ -1|0;me[c[75856]&2047](32);if((h|0)>(e|0)){g=h}else{j=e;break}}}else{j=d}if((j|0)>0){k=b;l=j}else{i=f;return}while(1){j=l+ -1|0;me[c[75856]&2047](a[k]|0);if((j|0)>0){l=j;k=k+1|0}else{break}}i=f;return}function teb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0.0,l=0.0,m=0,n=0,o=0,p=0;j=i;if((f|0)==4){k=+g[a>>2]}else{k=+h[a>>3]}if(k<0.0){l=-k}else{l=k}a:do{if(l<.1){if(!(l!=0.0)){m=1;break}n=keb(a,b,d,e,f)|0;i=j;return n|0}else{if((d|0)>=0){o=0;k=1.0;while(1){if(!(l>=k)){m=o;break a}if((o|0)<(d|0)){o=o+1|0;k=k*10.0}else{break}}}n=keb(a,b,d,e,f)|0;i=j;return n|0}}while(0);o=c[75872]|0;c[75872]=0;p=(e|0)==0?4:e+2|0;e=leb(a,b-p|0,d-m|0,f)|0;if((p|0)>0){f=0;do{me[c[75856]&2047](32);f=f+1|0;}while((f|0)<(p|0))}c[75872]=o;n=e;i=j;return n|0}function ueb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b;k=b+(g+ -1)|0;a:do{if((k|0)==(j|0)){l=1;m=j}else{g=k;while(1){n=g+ -1|0;if((a[g]|0)!=0){l=0;m=g;break a}if((n|0)==(j|0)){l=1;m=j;break}else{g=n}}}}while(0);k=((d[m]|0)>15)+(m-b<<1|1)|0;if((k|0)>(e|0)){if((e|0)>0){o=0}else{i=h;return}do{me[c[75856]&2047](42);o=o+1|0;}while((o|0)<(e|0));i=h;return}o=f-k|0;b=(o|0)>0;g=b?f:k;if((g|0)<(e|0)){k=e;do{k=k+ -1|0;me[c[75856]&2047](32);}while((k|0)>(g|0))}if(b){b=o;do{b=b+ -1|0;me[c[75856]&2047](48);}while((b|0)>0)}b=a[m]|0;do{if((b&240|0)==0){me[c[75856]&2047](a[309240+(b&15)|0]|0);if(l){i=h;return}else{p=m+ -1|0;break}}else{p=m}}while(0);while(1){me[c[75856]&2047](a[309240+((d[p]|0)>>>4)|0]|0);me[c[75856]&2047](a[309240+(a[p]&15)|0]|0);if((p|0)==(j|0)){break}p=p+ -1|0}i=h;return}function veb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=c[a>>2]|0;switch(e|0){case 12:{f=xeb(c[a+4>>2]|0,c[a+8>>2]|0)|0;i=b;return f|0};case 13:{g=(c[75868]|0)-(c[a+4>>2]|0)|0;h=0-(c[75866]|0)|0;c[75868]=(g|0)<(h|0)?h:g;f=1;i=b;return f|0};case 11:{f=web(c[a+8>>2]|0)|0;i=b;return f|0};case 5:{f=Je[c[75864]&7]()|0;i=b;return f|0};case 15:{c[75868]=(c[a+4>>2]|0)+ -1-(c[75866]|0);f=1;i=b;return f|0};case 4:case 14:{c[75868]=(c[75868]|0)+(c[a+4>>2]|0);f=1;i=b;return f|0};default:{f=c[r>>2]|0;c[d>>2]=e;Dd(f|0,309208,d|0)|0;zdb(c[75792]|0,1)}}return 0}function web(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;do{if((c[75868]|0)!=0){e=oeb()|0;if((e|0)==0){break}else{f=e}i=d;return f|0}}while(0);e=a[b]|0;g=b+1|0;h=a[g]|0;if(h<<24>>24==0){f=1;i=d;return f|0}else{j=g;k=h;l=b}while(1){if(k<<24>>24==e<<24>>24){b=l+2|0;if(!((a[b]|0)==e<<24>>24)){f=1;m=9;break}me[c[75856]&2047](e<<24>>24);n=b}else{me[c[75856]&2047](k<<24>>24);n=j}b=n+1|0;h=a[b]|0;if(h<<24>>24==0){f=1;m=9;break}else{j=b;k=h;l=n}}if((m|0)==9){i=d;return f|0}return 0}function xeb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;do{if((c[75868]|0)!=0){f=oeb()|0;if((f|0)==0){break}else{g=f}i=e;return g|0}}while(0);if((b|0)==0){g=1;i=e;return g|0}else{h=d;j=b}while(1){b=j+ -1|0;me[c[75856]&2047](a[h]|0);if((b|0)==0){g=1;break}else{j=b;h=h+1|0}}i=e;return g|0}function yeb(){var a=0,b=0;a=i;b=aeb(10)|0;c[75868]=0;c[75866]=0;c[75870]=0;i=a;return(b|0)==0|0}function zeb(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((c[75842]|0)==0){Ldb()}c[75806]=0;c[75812]=1;c[75820]=1;c[75830]=1;d=geb(a)|0;if((d|0)!=0){e=d;i=b;return e|0}c[75848]=a;c[75866]=0;c[75868]=0;c[75870]=0;c[77120]=0;c[75872]=0;d=c[a+12>>2]|0;c[75792]=d;c[75844]=c[c[74566]>>2];if((Odb(d)|0)<0){if((c[a>>2]|0)==0){Kdb(100,309288);e=100;i=b;return e|0}else{c[(Qc()|0)>>2]=100;e=100;i=b;return e|0}}c[75856]=1429;c[75858]=45;c[75860]=111;c[75846]=4;c[75862]=5;c[75864]=6;Tdb();c[75852]=0;d=c[74566]|0;c[75854]=c[d+32>>2];if((c[d+40>>2]|0)==1){e=0;i=b;return e|0}if((Mdb(d)|0)==0){e=0;i=b;return e|0}d=(c[a>>2]|0)==0;a=Qc()|0;f=c[a>>2]|0;if(d){Kdb(f,309296);e=c[a>>2]|0;i=b;return e|0}else{c[a>>2]=f;e=f;i=b;return e|0}return 0}function Aeb(){var a=0,b=0;a=i;if((c[77120]|0)==0){b=aeb(10)|0}else{aeb(0)|0;Bd(c[75844]|0)|0;b=0}c[75868]=0;c[75866]=0;c[75870]=0;i=a;return b|0}function Beb(){var a=0,b=0,d=0;a=i;if((c[77104]|0)==0){b=0}else{d=aeb(10)|0;c[77104]=0;b=d}c[75868]=0;c[75866]=0;c[75870]=0;i=a;return b|0}function Ceb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+32|0;d=b;e=b+8|0;f=b+16|0;g=b+24|0;h=c[s>>2]|0;Yeb(310024,h,310080);c[77328]=311532;c[309320>>2]=311552;c[309316>>2]=0;Pgb(309320|0,310024);c[309392>>2]=0;c[309396>>2]=-1;j=c[t>>2]|0;c[77532]=311400;xmb(310132|0);k=310136|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[77532]=310640;c[310160>>2]=j;ymb(g,310132|0);k=Bmb(g,314192)|0;l=k;zmb(g);c[310164>>2]=l;c[310168>>2]=310088;a[310172|0]=(pe[c[(c[k>>2]|0)+28>>2]&127](l)|0)&1;c[77350]=311612;c[309404>>2]=311632;Pgb(309404|0,310128);c[309476>>2]=0;c[309480>>2]=-1;l=c[r>>2]|0;c[77544]=311400;xmb(310180|0);k=310184|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[77544]=310640;c[310208>>2]=l;ymb(f,310180|0);k=Bmb(f,314192)|0;g=k;zmb(f);c[310212>>2]=g;c[310216>>2]=310096;a[310220|0]=(pe[c[(c[k>>2]|0)+28>>2]&127](g)|0)&1;c[77372]=311612;c[309492>>2]=311632;Pgb(309492|0,310176);c[309564>>2]=0;c[309568>>2]=-1;g=c[(c[(c[77372]|0)+ -12>>2]|0)+309512>>2]|0;c[77394]=311612;c[309580>>2]=311632;Pgb(309580|0,g);c[309652>>2]=0;c[309656>>2]=-1;c[(c[(c[77328]|0)+ -12>>2]|0)+309384>>2]=309400;g=(c[(c[77372]|0)+ -12>>2]|0)+309492|0;c[g>>2]=c[g>>2]|8192;c[(c[(c[77372]|0)+ -12>>2]|0)+309560>>2]=309400;Keb(310224,h,310104|0);c[77416]=311572;c[309672>>2]=311592;c[309668>>2]=0;Pgb(309672|0,310224);c[309744>>2]=0;c[309748>>2]=-1;c[77570]=311464;xmb(310284|0);h=310288|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[77570]=310384;c[310312>>2]=j;ymb(e,310284|0);j=Bmb(e,314200)|0;h=j;zmb(e);c[310316>>2]=h;c[310320>>2]=310112;a[310324|0]=(pe[c[(c[j>>2]|0)+28>>2]&127](h)|0)&1;c[77438]=311652;c[309756>>2]=311672;Pgb(309756|0,310280);c[309828>>2]=0;c[309832>>2]=-1;c[77582]=311464;xmb(310332|0);h=310336|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[77582]=310384;c[310360>>2]=l;ymb(d,310332|0);l=Bmb(d,314200)|0;h=l;zmb(d);c[310364>>2]=h;c[310368>>2]=310120;a[310372|0]=(pe[c[(c[l>>2]|0)+28>>2]&127](h)|0)&1;c[77460]=311652;c[309844>>2]=311672;Pgb(309844|0,310328);c[309916>>2]=0;c[309920>>2]=-1;h=c[(c[(c[77460]|0)+ -12>>2]|0)+309864>>2]|0;c[77482]=311652;c[309932>>2]=311672;Pgb(309932|0,h);c[310004>>2]=0;c[310008>>2]=-1;c[(c[(c[77416]|0)+ -12>>2]|0)+309736>>2]=309752;h=(c[(c[77460]|0)+ -12>>2]|0)+309844|0;c[h>>2]=c[h>>2]|8192;c[(c[(c[77460]|0)+ -12>>2]|0)+309912>>2]=309752;i=b;return}function Deb(a){a=a|0;a=i;Nhb(309400)|0;Nhb(309576)|0;Uhb(309752)|0;Uhb(309928)|0;i=a;return}function Eeb(a){a=a|0;var b=0;b=i;c[a>>2]=311464;zmb(a+4|0);i=b;return}function Feb(a){a=a|0;var b=0;b=i;c[a>>2]=311464;zmb(a+4|0);cqb(a);i=b;return}function Geb(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;pe[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=Bmb(d,314200)|0;d=f;c[b+36>>2]=d;a[b+44|0]=(pe[c[(c[f>>2]|0)+28>>2]&127](d)|0)&1;i=e;return}function Heb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+36|0;g=a+40|0;h=d;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=Fe[c[(c[a>>2]|0)+20>>2]&63](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((uc(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((Bd(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}function Ieb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((a[b+44|0]|0)!=0){g=uc(d|0,4,e|0,c[b+32>>2]|0)|0;i=f;return g|0}if((e|0)>0){h=d;j=0}else{g=0;i=f;return g|0}while(1){if((Ee[c[(c[b>>2]|0)+52>>2]&63](b,c[h>>2]|0)|0)==-1){g=j;k=6;break}d=j+1|0;if((d|0)<(e|0)){h=h+4|0;j=d}else{g=d;k=6;break}}if((k|0)==6){i=f;return g|0}return 0}function Jeb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;a:do{if(!k){c[g>>2]=d;if((a[b+44|0]|0)!=0){if((uc(g|0,4,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f;c[h>>2]=m;n=g+4|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=Ne[c[(c[u>>2]|0)+12>>2]&15](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=12;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(!(v>>>0<2)){l=-1;w=12;break}v=(c[h>>2]|0)-r|0;if((uc(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=12;break}if(u){t=u?c[j>>2]|0:t}else{break a}}if((w|0)==7){if((uc(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==12){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function Keb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=b;c[h>>2]=311464;j=b+4|0;xmb(j);k=b+8|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[h>>2]=310496;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;ymb(g,j);j=Bmb(g,314200)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=pe[c[(c[j>>2]|0)+24>>2]&127](e)|0;e=c[d>>2]|0;a[b+53|0]=(pe[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[h>>2]|0)>8){Jlb(310592)}else{zmb(g);i=f;return}}function Leb(a){a=a|0;var b=0;b=i;c[a>>2]=311464;zmb(a+4|0);i=b;return}function Meb(a){a=a|0;var b=0;b=i;c[a>>2]=311464;zmb(a+4|0);cqb(a);i=b;return}function Neb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=Bmb(d,314200)|0;d=f;g=b+36|0;c[g>>2]=d;h=b+44|0;c[h>>2]=pe[c[(c[f>>2]|0)+24>>2]&127](d)|0;d=c[g>>2]|0;a[b+53|0]=(pe[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[h>>2]|0)>8){Jlb(310592)}else{i=e;return}}function Oeb(a){a=a|0;var b=0,c=0;b=i;c=Reb(a,0)|0;i=b;return c|0}function Peb(a){a=a|0;var b=0,c=0;b=i;c=Reb(a,1)|0;i=b;return c|0}function Qeb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;a:do{if(l){c[h>>2]=c[n>>2];o=c[b+36>>2]|0;p=f;q=Ne[c[(c[o>>2]|0)+12>>2]&15](o,c[b+40>>2]|0,h,h+4|0,j,p,f+8|0,g)|0;if((q|0)==1|(q|0)==2){m=-1;i=e;return m|0}else if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}q=b+32|0;while(1){o=c[g>>2]|0;if(!(o>>>0>p>>>0)){break a}r=o+ -1|0;c[g>>2]=r;if((xd(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}function Reb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;if((a[k]|0)!=0){l=b+48|0;m=c[l>>2]|0;if(!d){n=m;i=e;return n|0}c[l>>2]=-1;a[k]=0;n=m;i=e;return n|0}m=c[b+44>>2]|0;k=(m|0)>1?m:1;a:do{if((k|0)>0){m=b+32|0;l=0;while(1){o=Yd(c[m>>2]|0)|0;if((o|0)==-1){n=-1;break}a[f+l|0]=o;l=l+1|0;if((l|0)>=(k|0)){break a}}i=e;return n|0}}while(0);b:do{if((a[b+53|0]|0)==0){l=b+40|0;m=b+36|0;o=f;p=g+4|0;q=b+32|0;r=k;while(1){s=c[l>>2]|0;t=s;u=c[t>>2]|0;v=c[t+4>>2]|0;t=c[m>>2]|0;w=f+r|0;x=Ne[c[(c[t>>2]|0)+16>>2]&15](t,s,o,w,h,g,p,j)|0;if((x|0)==3){y=14;break}else if((x|0)==2){n=-1;y=22;break}else if((x|0)!=1){z=r;break b}x=c[l>>2]|0;c[x>>2]=u;c[x+4>>2]=v;if((r|0)==8){n=-1;y=22;break}v=Yd(c[q>>2]|0)|0;if((v|0)==-1){n=-1;y=22;break}a[w]=v;r=r+1|0}if((y|0)==14){c[g>>2]=a[o]|0;z=r;break}else if((y|0)==22){i=e;return n|0}}else{c[g>>2]=a[f]|0;z=k}}while(0);if(d){d=c[g>>2]|0;c[b+48>>2]=d;n=d;i=e;return n|0}d=b+32|0;b=z;while(1){if((b|0)<=0){break}z=b+ -1|0;if((xd(a[f+z|0]|0,c[d>>2]|0)|0)==-1){n=-1;y=22;break}else{b=z}}if((y|0)==22){i=e;return n|0}n=c[g>>2]|0;i=e;return n|0}function Seb(a){a=a|0;var b=0;b=i;c[a>>2]=311400;zmb(a+4|0);i=b;return}function Teb(a){a=a|0;var b=0;b=i;c[a>>2]=311400;zmb(a+4|0);cqb(a);i=b;return}function Ueb(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;pe[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=Bmb(d,314192)|0;d=f;c[b+36>>2]=d;a[b+44|0]=(pe[c[(c[f>>2]|0)+28>>2]&127](d)|0)&1;i=e;return}function Veb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+36|0;g=a+40|0;h=d;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=Fe[c[(c[a>>2]|0)+20>>2]&63](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((uc(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((Bd(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}function Web(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;if((a[b+44|0]|0)!=0){h=uc(e|0,1,f|0,c[b+32>>2]|0)|0;i=g;return h|0}if((f|0)>0){j=e;k=0}else{h=0;i=g;return h|0}while(1){if((Ee[c[(c[b>>2]|0)+52>>2]&63](b,d[j]|0)|0)==-1){h=k;l=6;break}e=k+1|0;if((e|0)<(f|0)){j=j+1|0;k=e}else{h=e;l=6;break}}if((l|0)==6){i=g;return h|0}return 0}function Xeb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;a:do{if(!k){a[g]=d;if((a[b+44|0]|0)!=0){if((uc(g|0,1,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f;c[h>>2]=m;n=g+1|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=Ne[c[(c[u>>2]|0)+12>>2]&15](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=12;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(!(v>>>0<2)){l=-1;w=12;break}v=(c[h>>2]|0)-r|0;if((uc(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=12;break}if(u){t=u?c[j>>2]|0:t}else{break a}}if((w|0)==7){if((uc(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==12){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function Yeb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=b;c[h>>2]=311400;j=b+4|0;xmb(j);k=b+8|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[h>>2]=310752;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;ymb(g,j);j=Bmb(g,314192)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=pe[c[(c[j>>2]|0)+24>>2]&127](e)|0;e=c[d>>2]|0;a[b+53|0]=(pe[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[h>>2]|0)>8){Jlb(310592)}else{zmb(g);i=f;return}}function Zeb(a){a=a|0;var b=0;b=i;c[a>>2]=311400;zmb(a+4|0);i=b;return}function _eb(a){a=a|0;var b=0;b=i;c[a>>2]=311400;zmb(a+4|0);cqb(a);i=b;return}function $eb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=Bmb(d,314192)|0;d=f;g=b+36|0;c[g>>2]=d;h=b+44|0;c[h>>2]=pe[c[(c[f>>2]|0)+24>>2]&127](d)|0;d=c[g>>2]|0;a[b+53|0]=(pe[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[h>>2]|0)>8){Jlb(310592)}else{i=e;return}}function afb(a){a=a|0;var b=0,c=0;b=i;c=dfb(a,0)|0;i=b;return c|0}function bfb(a){a=a|0;var b=0,c=0;b=i;c=dfb(a,1)|0;i=b;return c|0}function cfb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;a:do{if(l){a[h]=c[n>>2];o=c[b+36>>2]|0;p=f;q=Ne[c[(c[o>>2]|0)+12>>2]&15](o,c[b+40>>2]|0,h,h+1|0,j,p,f+8|0,g)|0;if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}else if((q|0)==1|(q|0)==2){m=-1;i=e;return m|0}q=b+32|0;while(1){o=c[g>>2]|0;if(!(o>>>0>p>>>0)){break a}r=o+ -1|0;c[g>>2]=r;if((xd(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}function dfb(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+32|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=b+52|0;if((a[l]|0)!=0){m=b+48|0;n=c[m>>2]|0;if(!e){o=n;i=f;return o|0}c[m>>2]=-1;a[l]=0;o=n;i=f;return o|0}n=c[b+44>>2]|0;l=(n|0)>1?n:1;a:do{if((l|0)>0){n=b+32|0;m=0;while(1){p=Yd(c[n>>2]|0)|0;if((p|0)==-1){o=-1;break}a[g+m|0]=p;m=m+1|0;if((m|0)>=(l|0)){break a}}i=f;return o|0}}while(0);b:do{if((a[b+53|0]|0)==0){m=b+40|0;n=b+36|0;p=g;q=h+1|0;r=b+32|0;s=l;while(1){t=c[m>>2]|0;u=t;v=c[u>>2]|0;w=c[u+4>>2]|0;u=c[n>>2]|0;x=g+s|0;y=Ne[c[(c[u>>2]|0)+16>>2]&15](u,t,p,x,j,h,q,k)|0;if((y|0)==3){z=14;break}else if((y|0)==2){o=-1;z=23;break}else if((y|0)!=1){A=s;break b}y=c[m>>2]|0;c[y>>2]=v;c[y+4>>2]=w;if((s|0)==8){o=-1;z=23;break}w=Yd(c[r>>2]|0)|0;if((w|0)==-1){o=-1;z=23;break}a[x]=w;s=s+1|0}if((z|0)==14){a[h]=a[p]|0;A=s;break}else if((z|0)==23){i=f;return o|0}}else{a[h]=a[g]|0;A=l}}while(0);do{if(e){l=a[h]|0;c[b+48>>2]=l&255;B=l}else{l=b+32|0;k=A;while(1){if((k|0)<=0){z=21;break}j=k+ -1|0;if((xd(d[g+j|0]|0,c[l>>2]|0)|0)==-1){o=-1;z=23;break}else{k=j}}if((z|0)==21){B=a[h]|0;break}else if((z|0)==23){i=f;return o|0}}}while(0);o=B&255;i=f;return o|0}function efb(){var a=0;a=i;Ceb(0);ee(1430,310016,q|0)|0;i=a;return}function ffb(a){a=a|0;i=i;return}function gfb(a){a=a|0;var b=0;b=a+4|0;c[b>>2]=1+(c[b>>2]|0);i=i;return}function hfb(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+4|0;e=c[d>>2]|0;c[d>>2]=-1+e;if((e|0)!=0){f=0;i=b;return f|0}me[c[(c[a>>2]|0)+8>>2]&2047](a);f=1;i=b;return f|0}function ifb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=310896;e=yqb(b|0)|0;f=bqb(e+13|0)|0;c[f+4>>2]=e;c[f>>2]=e;g=f+12|0;c[a+4>>2]=g;c[f+8>>2]=0;Aqb(g|0,b|0,e+1|0)|0;i=d;return}function jfb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=310896;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;Cb(h|0);j=a;cqb(j);i=b;return}dqb((c[d>>2]|0)+ -12|0);g=a;h=g;Cb(h|0);j=a;cqb(j);i=b;return}function kfb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=310896;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;Cb(h|0);i=b;return}dqb((c[d>>2]|0)+ -12|0);g=a;h=g;Cb(h|0);i=b;return}function lfb(a){a=a|0;i=i;return c[a+4>>2]|0}function mfb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;c[b>>2]=310920;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=yqb(f|0)|0;g=bqb(d+13|0)|0;c[g+4>>2]=d;c[g>>2]=d;h=g+12|0;c[b+4>>2]=h;c[g+8>>2]=0;Aqb(h|0,f|0,d+1|0)|0;i=e;return}function nfb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=310920;e=yqb(b|0)|0;f=bqb(e+13|0)|0;c[f+4>>2]=e;c[f>>2]=e;g=f+12|0;c[a+4>>2]=g;c[f+8>>2]=0;Aqb(g|0,b|0,e+1|0)|0;i=d;return}function ofb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=310920;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;Cb(h|0);j=a;cqb(j);i=b;return}dqb((c[d>>2]|0)+ -12|0);g=a;h=g;Cb(h|0);j=a;cqb(j);i=b;return}function pfb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=310920;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;Cb(h|0);i=b;return}dqb((c[d>>2]|0)+ -12|0);g=a;h=g;Cb(h|0);i=b;return}function qfb(a){a=a|0;i=i;return c[a+4>>2]|0}function rfb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=310896;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;Cb(h|0);j=a;cqb(j);i=b;return}dqb((c[d>>2]|0)+ -12|0);g=a;h=g;Cb(h|0);j=a;cqb(j);i=b;return}function sfb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=310896;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;Cb(h|0);j=a;cqb(j);i=b;return}dqb((c[d>>2]|0)+ -12|0);g=a;h=g;Cb(h|0);j=a;cqb(j);i=b;return}function tfb(a){a=a|0;i=i;return}function ufb(a,b,d){a=a|0;b=b|0;d=d|0;c[a>>2]=d;c[a+4>>2]=b;i=i;return}function vfb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e;Le[c[(c[a>>2]|0)+12>>2]&15](f,a,b);if((c[f+4>>2]|0)!=(c[d+4>>2]|0)){g=0;i=e;return g|0}g=(c[f>>2]|0)==(c[d>>2]|0);i=e;return g|0}function wfb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((c[b+4>>2]|0)!=(a|0)){f=0;i=e;return f|0}f=(c[b>>2]|0)==(d|0);i=e;return f|0}function xfb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;f=be(e|0)|0;e=yqb(f|0)|0;if(e>>>0>4294967279){Dfb(0)}if(e>>>0<11){a[b]=e<<1;g=b+1|0;Aqb(g|0,f|0,e|0)|0;h=g;j=h+e|0;k=j;a[k]=0;i=d;return}else{l=e+16&-16;m=aqb(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=e;g=m;Aqb(g|0,f|0,e|0)|0;h=g;j=h+e|0;k=j;a[k]=0;i=d;return}}function yfb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;g=f;h=d;j=c[h>>2]|0;k=e;do{if((j|0)!=0){l=a[e]|0;if((l&1)==0){m=(l&255)>>>1}else{m=c[e+4>>2]|0}if((m|0)==0){n=j}else{igb(e,311136,2)|0;n=c[h>>2]|0}l=c[d+4>>2]|0;Le[c[(c[l>>2]|0)+24>>2]&15](g,l,n);l=a[g]|0;if((l&1)==0){o=g+1|0;p=(l&255)>>>1}else{o=c[g+8>>2]|0;p=c[g+4>>2]|0}igb(e,o,p)|0;if((a[g]&1)==0){break}cqb(c[g+8>>2]|0)}}while(0);g=b;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;i=f;return}function zfb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f;h=f+16|0;j=yqb(e|0)|0;if(j>>>0>4294967279){Dfb(0)}if(j>>>0<11){a[h]=j<<1;k=h+1|0}else{l=j+16&-16;m=aqb(l)|0;c[h+8>>2]=m;c[h>>2]=l|1;c[h+4>>2]=j;k=m}Aqb(k|0,e|0,j|0)|0;a[k+j|0]=0;yfb(g,d,h);mfb(b,g);if(!((a[g]&1)==0)){cqb(c[g+8>>2]|0)}if(!((a[h]&1)==0)){cqb(c[h+8>>2]|0)}c[b>>2]=311152;h=d;d=c[h+4>>2]|0;g=b+8|0;c[g>>2]=c[h>>2];c[g+4>>2]=d;i=f;return}function Afb(a){a=a|0;var b=0;b=i;pfb(a);cqb(a);i=b;return}function Bfb(a){a=a|0;var b=0;b=i;pfb(a);i=b;return}function Cfb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;wc(311288)|0;if((c[a>>2]|0)==1){do{sd(311312,311288)|0;}while((c[a>>2]|0)==1)}if((c[a>>2]|0)==0){c[a>>2]=1;jc(311288)|0;me[d&2047](b);wc(311288)|0;c[a>>2]=-1;jc(311288)|0;ed(311312)|0;i=e;return}else{jc(311288)|0;i=e;return}}function Dfb(a){a=a|0;a=Hc(8)|0;ifb(a,311360);c[a>>2]=310976;_d(a|0,311016,41)}function Efb(a){a=a|0;a=Hc(8)|0;ifb(a,311360);c[a>>2]=311040;_d(a|0,311080,41)}function Ffb(a){a=a|0;var b=0,d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function Gfb(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function Hfb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=d;if((a[d]&1)==0){g=b;c[g+0>>2]=c[f+0>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];i=e;return}f=c[d+8>>2]|0;g=c[d+4>>2]|0;if(g>>>0>4294967279){Dfb(0)}if(g>>>0<11){a[b]=g<<1;h=b+1|0}else{d=g+16&-16;j=aqb(d)|0;c[b+8>>2]=j;c[b>>2]=d|1;c[b+4>>2]=g;h=j}Aqb(h|0,f|0,g|0)|0;a[h+g|0]=0;i=e;return}function Ifb(b){b=b|0;i=i;return(a[b]&1)!=0|0}function Jfb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>4294967279){Dfb(0)}if(e>>>0<11){a[b]=e<<1;g=b+1|0}else{h=e+16&-16;j=aqb(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}Aqb(g|0,d|0,e|0)|0;a[g+e|0]=0;i=f;return}function Kfb(a){a=a|0;i=i;return a|0}function Lfb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=yqb(d|0)|0;if(f>>>0>4294967279){Dfb(0)}if(f>>>0<11){a[b]=f<<1;g=b+1|0;Aqb(g|0,d|0,f|0)|0;h=g;j=h+f|0;k=j;a[k]=0;i=e;return}else{l=f+16&-16;m=aqb(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=f;g=m;Aqb(g|0,d|0,f|0)|0;h=g;j=h+f|0;k=j;a[k]=0;i=e;return}}function Mfb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>4294967279){Dfb(0)}if(d>>>0<11){a[b]=d<<1;g=b+1|0}else{h=d+16&-16;j=aqb(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}Cqb(g|0,e|0,d|0)|0;a[g+d|0]=0;i=f;return}function Nfb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if(d>>>0>4294967279){Dfb(0)}if(d>>>0<11){a[b]=d<<1;g=b+1|0;Cqb(g|0,e|0,d|0)|0;h=g;j=h+d|0;k=j;a[k]=0;i=f;return}else{l=d+16&-16;m=aqb(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=d;g=m;Cqb(g|0,e|0,d|0)|0;h=g;j=h+d|0;k=j;a[k]=0;i=f;return}}function Ofb(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;h=a[d]|0;j=(h&1)==0;if(j){k=(h&255)>>>1}else{k=c[d+4>>2]|0}if(k>>>0<e>>>0){Efb(0)}if(j){l=d+1|0}else{l=c[d+8>>2]|0}d=l+e|0;l=k-e|0;e=l>>>0<f>>>0?l:f;if(e>>>0>4294967279){Dfb(0)}if(e>>>0<11){a[b]=e<<1;m=b+1|0;Aqb(m|0,d|0,e|0)|0;n=m;o=n+e|0;p=o;a[p]=0;i=g;return}else{f=e+16&-16;l=aqb(f)|0;c[b+8>>2]=l;c[b>>2]=f|1;c[b+4>>2]=e;m=l;Aqb(m|0,d|0,e|0)|0;n=m;o=n+e|0;p=o;a[p]=0;i=g;return}}function Pfb(b){b=b|0;var d=0,e=0,f=0;d=i;e=a[b]|0;if((e&1)==0){f=(e&255)>>>1;i=d;return f|0}else{f=c[b+4>>2]|0;i=d;return f|0}return 0}function Qfb(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=b+1|0;i=d;return e|0}else{e=c[b+8>>2]|0;i=d;return e|0}return 0}function Rfb(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){i=d;return}cqb(c[b+8>>2]|0);i=d;return}



function iF(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0,da=0,ea=0,fa=0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0.0,Ka=0,La=0,Ma=0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0;j=i;i=i+536|0;k=j;l=j+24|0;m=j+48|0;n=j+112|0;o=j+176|0;p=j+264|0;q=j+352|0;r=j+440|0;s=j+528|0;t=i;i=i+8|0;u=i;i=i+64|0;v=i;i=i+64|0;w=i;i=i+88|0;x=i;i=i+88|0;y=i;i=i+88|0;z=i;i=i+88|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+88|0;D=i;i=i+8|0;E=i;i=i+88|0;F=i;i=i+24|0;G=i;i=i+88|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+88|0;M=i;i=i+88|0;N=i;i=i+64|0;O=i;i=i+64|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+88|0;T=i;i=i+88|0;V=i;i=i+64|0;W=i;i=i+64|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+16|0;_=i;i=i+88|0;do{if((g|0)==0){if((f|0)==2){$=+Ad(+d,611.657);aa=+Ad(+e,1.0e3);ba=$;ca=2;da=11;break}else{ZE(A,b,d,e,f,0);ea=c[A>>2]|0;da=5;break}}else{ea=g;da=5}}while(0);a:do{if((da|0)==5){if((f|0)==0){fa=(ea|0)==4?2:1}else{fa=f}$=+Ad(+d,611.657);ga=+Ad(+e,1.0e3);switch(ea|0){case 3:{HE(F,b,$,ga,1.0e-7,1.0e-6);ha=+h[F>>3];ia=+h[F+8>>3];pE(G,b,ha,ia);ja=+h[G+24>>3];ka=+h[G+32>>3];la=+h[G+48>>3];ma=ka*+h[G+64>>3];na=ia*ja*(la*2.0+ja*+h[G+56>>3])*461.526;oa=ha*ja*(la-ka*+h[G+80>>3])*461.526;pa=+U(+(ka*ka*+h[G+72>>3]*-461.526));ka=ha*ha;qa=$;ra=fa;sa=oa;ta=na;ua=0.0;va=0.0;wa=0.0;xa=oa;ya=ia;za=ia*(ja*la+ma)*461.526;Aa=(ka*pa*na+ia*oa*oa)/(ka*na);Ba=pa;Ca=ha;Da=(ma- +h[G+40>>3])*461.526;Ea=3;break a;break};case 1:{wE(B,b,$,ga);ma=+h[B>>3];rE(C,b,d,ma);ha=+h[C+24>>3];pa=+h[C+32>>3];na=+h[C+48>>3];ka=+h[C+56>>3];oa=+h[C+72>>3];ia=+h[C+80>>3];la=(pa*+h[C+64>>3]- +h[C+40>>3])*461.526;ja=ha*na;Fa=(ja-pa*ha*ia)/d*461.526;Ga=ma*ha*ha*ka*+OYa(d,-2)*461.526;ha=pa*pa*oa;oa=na-pa*ia;qa=$;ra=fa;sa=0.0;ta=0.0;ua=Fa;va=Ga;wa=0.0;xa=-Fa/Ga;ya=ma;za=ga;Aa=ha*-461.526;Ba=(oa*oa/ka-ha)*461.526;Ca=d/(ma*ja*461.526);Da=la;Ea=1;break a;break};case 2:{zE(D,0,$,ga);la=+h[D>>3];vE(E,b,d,la);ja=+h[E+24>>3];ma=+h[E+32>>3];ha=+h[E+48>>3];ka=+h[E+56>>3];oa=+h[E+72>>3];Ga=+h[E+80>>3];Fa=(ma*+h[E+64>>3]- +h[E+40>>3])*461.526;ia=ja*ha;pa=(ia-ma*ja*Ga)/d*461.526;na=la*ja*ja*ka*+OYa(d,-2)*461.526;ja=ma*ma*oa;oa=ha-ma*Ga;qa=$;ra=fa;sa=0.0;ta=0.0;ua=pa;va=na;wa=1.0;xa=-pa/na;ya=la;za=ga;Aa=ja*-461.526;Ba=(oa*oa/ka-ja)*461.526;Ca=d/(la*ia*461.526);Da=Fa;Ea=2;break a;break};case 4:{aa=ga;ba=$;ca=fa;da=11;break a;break};case 5:{KE(Z,b,$,ga,1.0e-7);Fa=+h[Z>>3];if((c[Z+8>>2]|0)!=0){g=c[72300]|0;A=l;Ha=28176;c[A+0>>2]=c[Ha+0>>2];c[A+4>>2]=c[Ha+4>>2];c[A+8>>2]=c[Ha+8>>2];c[A+12>>2]=c[Ha+12>>2];c[A+16>>2]=c[Ha+16>>2];c[A+20>>2]=c[Ha+20>>2];Pe[g&127](b,l,28200,t);}qE(_,b,$,Fa);ia=+h[_+24>>3];la=+h[_+32>>3];ja=+h[_+48>>3];ka=+h[_+56>>3];oa=+h[_+72>>3];na=+h[_+80>>3];pa=(la*+h[_+64>>3]- +h[_+40>>3])*461.526;Ga=ia*ja;ma=(Ga-la*ia*na)/d*461.526;ha=Fa*ia*ia*ka*+OYa(d,-2)*461.526;ia=la*la*oa;oa=ja-la*na;qa=$;ra=fa;sa=0.0;ta=0.0;ua=ma;va=ha;wa=0.0;xa=-ma/ha;ya=Fa;za=ga;Aa=ia*-461.526;Ba=(oa*oa/ka-ia)*461.526;Ca=d/(Fa*Ga*461.526);Da=pa;Ea=5;break a;break};default:{g=RXa(RXa(RXa(RXa(27528,PXa(d,0,1,6)|0)|0,28248)|0,PXa(e,0,1,6)|0)|0,27592)|0;Ha=c[72300]|0;A=k;Ia=28256;c[A+0>>2]=c[Ia+0>>2];c[A+4>>2]=c[Ia+4>>2];c[A+8>>2]=c[Ia+8>>2];c[A+12>>2]=c[Ia+12>>2];c[A+16>>2]=c[Ia+16>>2];c[A+20>>2]=c[Ia+20>>2];Pe[Ha&127](b,k,g,s);qa=$;ra=fa;sa=0.0;ta=0.0;ua=0.0;va=0.0;wa=0.0;xa=0.0;ya=0.0;za=ga;Aa=0.0;Ba=0.0;Ca=0.0;Da=0.0;Ea=ea;break a}}}}while(0);if((da|0)==11){ME(H,b,d);ga=+h[H>>3];eF(I,b,d);$=+h[I>>3];if($!=ga){Ja=(e-ga)/($-ga)}else{Ja=1.0}if(d<16529200.0){wE(J,b,ba,ga);ga=+h[J>>3];zE(K,0,ba,$);$=+h[K>>3];rE(L,b,ba,ga);e=+h[L+8>>3];pa=+h[L+16>>3];Ga=+h[L+24>>3];Fa=+h[L+32>>3];ia=+h[L+40>>3];ka=+h[L+48>>3];oa=+h[L+56>>3];ha=+h[L+64>>3];ma=+h[L+72>>3];na=+h[L+80>>3];h[w>>3]=+h[L>>3];h[w+8>>3]=e;h[w+16>>3]=pa;h[w+24>>3]=Ga;h[w+32>>3]=Fa;h[w+40>>3]=ia;h[w+48>>3]=ka;h[w+56>>3]=oa;h[w+64>>3]=ha;h[w+72>>3]=ma;h[w+80>>3]=na;vE(M,b,ba,$);na=+h[M+8>>3];ma=+h[M+16>>3];ha=+h[M+24>>3];oa=+h[M+32>>3];ka=+h[M+40>>3];ia=+h[M+48>>3];Fa=+h[M+56>>3];Ga=+h[M+64>>3];pa=+h[M+72>>3];e=+h[M+80>>3];h[x>>3]=+h[M>>3];h[x+8>>3]=na;h[x+16>>3]=ma;h[x+24>>3]=ha;h[x+32>>3]=oa;h[x+40>>3]=ka;h[x+48>>3]=ia;h[x+56>>3]=Fa;h[x+64>>3]=Ga;h[x+72>>3]=pa;h[x+80>>3]=e;Ka=r+0|0;La=w+0|0;Ma=Ka+88|0;do{c[Ka>>2]=c[La>>2];Ka=Ka+4|0;La=La+4|0}while((Ka|0)<(Ma|0));cE(N,0,r);e=+h[N+8>>3];pa=+h[N+16>>3];Ga=+h[N+24>>3];Fa=+h[N+32>>3];ia=+h[N+40>>3];ka=+h[N+48>>3];oa=+h[N+56>>3];h[u>>3]=+h[N>>3];h[u+8>>3]=e;h[u+16>>3]=pa;h[u+24>>3]=Ga;h[u+32>>3]=Fa;h[u+40>>3]=ia;h[u+48>>3]=ka;h[u+56>>3]=oa;Ka=q+0|0;La=x+0|0;Ma=Ka+88|0;do{c[Ka>>2]=c[La>>2];Ka=Ka+4|0;La=La+4|0}while((Ka|0)<(Ma|0));cE(O,0,q);oa=+h[O>>3];ka=+h[O+8>>3];ia=+h[O+16>>3];Fa=+h[O+24>>3];Ga=+h[O+32>>3];pa=+h[O+40>>3];e=+h[O+48>>3];ha=+h[O+56>>3];h[v>>3]=oa;h[v+8>>3]=ka;h[v+16>>3]=ia;h[v+24>>3]=Fa;h[v+32>>3]=Ga;h[v+40>>3]=pa;h[v+48>>3]=e;h[v+56>>3]=ha;Na=Fa;Oa=oa;Pa=ga+Ja*($-ga)}else{kE(P,b,ba);ga=+h[P>>3];cF(Q,b,ga);$=+h[Q>>3];hF(R,b,ga);oa=+h[R>>3];pE(S,b,$,ga);$=+h[S+8>>3];Fa=+h[S+16>>3];ha=+h[S+24>>3];e=+h[S+32>>3];pa=+h[S+40>>3];Ga=+h[S+48>>3];ia=+h[S+56>>3];ka=+h[S+64>>3];ma=+h[S+72>>3];na=+h[S+80>>3];h[y>>3]=+h[S>>3];h[y+8>>3]=$;h[y+16>>3]=Fa;h[y+24>>3]=ha;h[y+32>>3]=e;h[y+40>>3]=pa;h[y+48>>3]=Ga;h[y+56>>3]=ia;h[y+64>>3]=ka;h[y+72>>3]=ma;h[y+80>>3]=na;pE(T,b,oa,ga);oa=+h[T+8>>3];na=+h[T+16>>3];ma=+h[T+24>>3];ka=+h[T+32>>3];ia=+h[T+40>>3];Ga=+h[T+48>>3];pa=+h[T+56>>3];e=+h[T+64>>3];ha=+h[T+72>>3];Fa=+h[T+80>>3];h[z>>3]=+h[T>>3];h[z+8>>3]=oa;h[z+16>>3]=na;h[z+24>>3]=ma;h[z+32>>3]=ka;h[z+40>>3]=ia;h[z+48>>3]=Ga;h[z+56>>3]=pa;h[z+64>>3]=e;h[z+72>>3]=ha;h[z+80>>3]=Fa;Ka=p+0|0;La=y+0|0;Ma=Ka+88|0;do{c[Ka>>2]=c[La>>2];Ka=Ka+4|0;La=La+4|0}while((Ka|0)<(Ma|0));eE(V,0,p);Fa=+h[V+8>>3];ha=+h[V+16>>3];e=+h[V+24>>3];pa=+h[V+32>>3];Ga=+h[V+40>>3];ia=+h[V+48>>3];ka=+h[V+56>>3];h[u>>3]=+h[V>>3];h[u+8>>3]=Fa;h[u+16>>3]=ha;h[u+24>>3]=e;h[u+32>>3]=pa;h[u+40>>3]=Ga;h[u+48>>3]=ia;h[u+56>>3]=ka;Ka=o+0|0;La=z+0|0;Ma=Ka+88|0;do{c[Ka>>2]=c[La>>2];Ka=Ka+4|0;La=La+4|0}while((Ka|0)<(Ma|0));eE(W,0,o);ka=+h[W>>3];ia=+h[W+8>>3];Ga=+h[W+16>>3];pa=+h[W+24>>3];e=+h[W+32>>3];ha=+h[W+40>>3];Fa=+h[W+48>>3];ma=+h[W+56>>3];h[v>>3]=ka;h[v+8>>3]=ia;h[v+16>>3]=Ga;h[v+24>>3]=pa;h[v+32>>3]=e;h[v+40>>3]=ha;h[v+48>>3]=Fa;h[v+56>>3]=ma;Na=pa;Oa=ka;Pa=ga}W=u;ga=+h[W>>3];if(ga!=Oa){ka=+h[u+24>>3];Qa=Oa;Ra=ga;Sa=Na;Ta=ka;Ua=(Na-ka)*ga*(Oa/(ga-Oa))}else{uE(X,b,Pa);Qa=+h[v>>3];Ra=+h[W>>3];Sa=+h[v+24>>3];Ta=+h[u+24>>3];Ua=+h[X>>3]}Oa=Ta+Ja*(Sa-Ta);Ta=Ra*(Qa/(Qa+Ja*(Ra-Qa)));Ka=n+0|0;La=u+0|0;Ma=Ka+64|0;do{c[Ka>>2]=c[La>>2];Ka=Ka+4|0;La=La+4|0}while((Ka|0)<(Ma|0));Ka=m+0|0;La=v+0|0;Ma=Ka+64|0;do{c[Ka>>2]=c[La>>2];Ka=Ka+4|0;La=La+4|0}while((Ka|0)<(Ma|0));dE(Y,0,n,m,Ja,Pa,d);d=+h[u+32>>3];Qa=+h[u+48>>3];Ra=+h[u+56>>3];qa=ba;ra=ca;sa=Qa+Ja*(+h[v+48>>3]-Qa);ta=Ra+Ja*(+h[v+56>>3]-Ra);ua=0.0;va=0.0;wa=Ja;xa=Ua;ya=Pa;za=aa;Aa=d+Ja*(+h[v+32>>3]-d);Ba=+h[Y>>3];Ca=Ta;Da=Oa;Ea=4}c[a>>2]=ra;c[a+4>>2]=Ea;h[a+8>>3]=qa;h[a+16>>3]=ya;h[a+24>>3]=za;h[a+32>>3]=461.526;h[a+40>>3]=Aa;h[a+48>>3]=Ba;h[a+56>>3]=Ca;h[a+64>>3]=Da;h[a+72>>3]=sa;h[a+80>>3]=ta;h[a+88>>3]=ua;h[a+96>>3]=va;h[a+104>>3]=wa;h[a+112>>3]=xa;i=j;return}function jF(a){a=a|0;var b=0;a=i;i=i+8|0;b=i;i=i+8|0;kXa(4,0,32232,b);kXa(4,0,32272,a);i=a;return}function kF(a){a=a|0;var b=0,d=0;b=i;d=a+320|0;a=c[d>>2]|0;if((a|0)==0){i=b;return}Xpb(a);c[d>>2]=0;i=b;return}function lF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+8>>3],+h[a>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+8>>3];l=+h[g>>3];m=+h[g+808>>3];n=+h[g+800>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));bF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+14648>>3]=+h[f>>3];i=b;return}function mF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+8>>3],+h[a>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+8>>3];l=+h[g>>3];m=+h[g+808>>3];n=+h[g+800>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));fF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10840>>3]=+h[f>>3];i=b;return}function nF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4168>>3]=+h[b+14136>>3]*+h[b+10840>>3];i=i;return}function oF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3376>>3]=+h[b+4168>>3]- +h[b+14464>>3];i=i;return}function pF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+24>>3],+h[a+16>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+24>>3];l=+h[g+16>>3];m=+h[g+824>>3];n=+h[g+816>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));bF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10680>>3]=+h[f>>3];i=b;return}function qF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+24>>3],+h[a+16>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+24>>3];l=+h[g+16>>3];m=+h[g+824>>3];n=+h[g+816>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));fF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10832>>3]=+h[f>>3];i=b;return}function rF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4160>>3]=+h[b+14128>>3]*+h[b+10832>>3];i=i;return}function sF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3384>>3]=+h[b+4160>>3]+ +h[b+3376>>3];i=i;return}function tF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+40>>3],+h[a+32>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+40>>3];l=+h[g+32>>3];m=+h[g+840>>3];n=+h[g+832>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));bF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10672>>3]=+h[f>>3];i=b;return}function uF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+600>>3],+h[a+592>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+600>>3];l=+h[g+592>>3];m=+h[g+1400>>3];n=+h[g+1392>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));bF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10248>>3]=+h[f>>3];i=b;return}function vF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+600>>3],+h[a+592>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+600>>3];l=+h[g+592>>3];m=+h[g+1400>>3];n=+h[g+1392>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));fF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10400>>3]=+h[f>>3];i=b;return}function wF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8672>>3]=+h[b+13360>>3]*+h[b+10400>>3];i=i;return}function xF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+616>>3],+h[a+608>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+616>>3];l=+h[g+608>>3];m=+h[g+1416>>3];n=+h[g+1408>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));bF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10240>>3]=+h[f>>3];i=b;return}function yF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+616>>3],+h[a+608>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+616>>3];l=+h[g+608>>3];m=+h[g+1416>>3];n=+h[g+1408>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));fF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10392>>3]=+h[f>>3];i=b;return}function zF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8664>>3]=+h[b+13352>>3]*+h[b+10392>>3];i=i;return}function AF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+632>>3],+h[a+624>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+632>>3];l=+h[g+624>>3];m=+h[g+1432>>3];n=+h[g+1424>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));bF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+14640>>3]=+h[f>>3];i=b;return}function BF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+584>>3],+h[a+576>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+584>>3];l=+h[g+576>>3];m=+h[g+1384>>3];n=+h[g+1376>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));fF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10408>>3]=+h[f>>3];i=b;return}function CF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8680>>3]=+h[b+13368>>3]*+h[b+10408>>3];i=i;return}function DF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+584>>3],+h[a+576>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+584>>3];l=+h[g+576>>3];m=+h[g+1384>>3];n=+h[g+1376>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));bF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10256>>3]=+h[f>>3];i=b;return}function EF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+568>>3],+h[a+560>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+568>>3];l=+h[g+560>>3];m=+h[g+1368>>3];n=+h[g+1360>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));bF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10264>>3]=+h[f>>3];i=b;return}function FF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+568>>3],+h[a+560>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+568>>3];l=+h[g+560>>3];m=+h[g+1368>>3];n=+h[g+1360>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));fF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10416>>3]=+h[f>>3];i=b;return}function GF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8688>>3]=+h[b+13376>>3]*+h[b+10416>>3];i=i;return}function HF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+552>>3],+h[a+544>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+552>>3];l=+h[g+544>>3];m=+h[g+1352>>3];n=+h[g+1344>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));bF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10272>>3]=+h[f>>3];i=b;return}function IF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+552>>3],+h[a+544>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+552>>3];l=+h[g+544>>3];m=+h[g+1352>>3];n=+h[g+1344>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));fF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10424>>3]=+h[f>>3];i=b;return}function JF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8696>>3]=+h[b+13384>>3]*+h[b+10424>>3];i=i;return}function KF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+168>>3],+h[a+160>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+168>>3];l=+h[g+160>>3];m=+h[g+968>>3];n=+h[g+960>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));bF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10608>>3]=+h[f>>3];i=b;return}function LF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+168>>3],+h[a+160>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+168>>3];l=+h[g+160>>3];m=+h[g+968>>3];n=+h[g+960>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));fF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10760>>3]=+h[f>>3];i=b;return}function MF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4088>>3]=+h[b+14056>>3]*+h[b+10760>>3];i=i;return}function NF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+184>>3],+h[a+176>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+184>>3];l=+h[g+176>>3];m=+h[g+984>>3];n=+h[g+976>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));bF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10600>>3]=+h[f>>3];i=b;return}function OF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+216>>3],+h[a+208>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+216>>3];l=+h[g+208>>3];m=+h[g+1016>>3];n=+h[g+1008>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));bF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10584>>3]=+h[f>>3];i=b;return}function PF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+216>>3],+h[a+208>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+216>>3];l=+h[g+208>>3];m=+h[g+1016>>3];n=+h[g+1008>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));fF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10736>>3]=+h[f>>3];i=b;return}function QF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4064>>3]=+h[b+14032>>3]*+h[b+10736>>3];i=i;return}function RF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+296>>3],+h[a+288>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+296>>3];l=+h[g+288>>3];m=+h[g+1096>>3];n=+h[g+1088>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));bF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10544>>3]=+h[f>>3];i=b;return}function SF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+296>>3],+h[a+288>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+296>>3];l=+h[g+288>>3];m=+h[g+1096>>3];n=+h[g+1088>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));fF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10696>>3]=+h[f>>3];i=b;return}function TF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4024>>3]=+h[b+13992>>3]*+h[b+10696>>3];i=i;return}function UF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+360>>3],+h[a+352>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+360>>3];l=+h[g+352>>3];m=+h[g+1160>>3];n=+h[g+1152>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));fF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10520>>3]=+h[f>>3];i=b;return}function VF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8792>>3]=+h[b+13480>>3]*+h[b+10520>>3];i=i;return}function WF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+360>>3],+h[a+352>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+360>>3];l=+h[g+352>>3];m=+h[g+1160>>3];n=+h[g+1152>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));bF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10368>>3]=+h[f>>3];i=b;return}function XF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+376>>3],+h[a+368>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+376>>3];l=+h[g+368>>3];m=+h[g+1176>>3];n=+h[g+1168>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));bF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10360>>3]=+h[f>>3];i=b;return}function YF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+376>>3],+h[a+368>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+376>>3];l=+h[g+368>>3];m=+h[g+1176>>3];n=+h[g+1168>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));fF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10512>>3]=+h[f>>3];i=b;return}function ZF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8784>>3]=+h[b+13472>>3]*+h[b+10512>>3];i=i;return}function _F(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+456>>3],+h[a+448>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+456>>3];l=+h[g+448>>3];m=+h[g+1256>>3];n=+h[g+1248>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));bF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10320>>3]=+h[f>>3];i=b;return}function $F(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+456>>3],+h[a+448>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+456>>3];l=+h[g+448>>3];m=+h[g+1256>>3];n=+h[g+1248>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));fF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10472>>3]=+h[f>>3];i=b;return}function aG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8744>>3]=+h[b+13432>>3]*+h[b+10472>>3];i=i;return}function bG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+520>>3],+h[a+512>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+520>>3];l=+h[g+512>>3];m=+h[g+1320>>3];n=+h[g+1312>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));bF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10288>>3]=+h[f>>3];i=b;return}function cG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+536>>3],+h[a+528>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+536>>3];l=+h[g+528>>3];m=+h[g+1336>>3];n=+h[g+1328>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));bF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10280>>3]=+h[f>>3];i=b;return}function dG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+536>>3],+h[a+528>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+536>>3];l=+h[g+528>>3];m=+h[g+1336>>3];n=+h[g+1328>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));fF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10432>>3]=+h[f>>3];i=b;return}function eG(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7248>>3]=(+h[b+552>>3]+ +h[b+560>>3])*(+h[d+520>>3]- +h[d+536>>3])*+h[b+2840>>3]*.5;i=i;return}function fG(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2840>>3]*(+h[e+552>>3]+ +h[e+560>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7248>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+7088|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+7088|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,32336,32328,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+7088|0;q=p;h[q>>3]=n;i=d;return}function gG(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7240>>3]=(+h[b+544>>3]+ +h[b+552>>3])*(+h[d+536>>3]- +h[d+552>>3])*+h[b+2840>>3]*.5;i=i;return}function hG(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2840>>3]*(+h[e+544>>3]+ +h[e+552>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7240>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+7080|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+7080|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,32432,32424,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+7080|0;q=p;h[q>>3]=n;i=d;return}function iG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+536>>3],+h[a+528>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+536>>3];l=+h[g+528>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+9232>>3]=+h[f>>3];i=b;return}function jG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+536>>3],+h[a+528>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+536>>3];l=+h[g+528>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12264>>3]=+h[f>>3];i=b;return}function kG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9232>>3];k=+h[g+12264>>3];l=+h[g+536>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,32528,32520,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6840>>3]=j-n;i=d;return}function lG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+88|0;d=b;e=b+40|0;f=b+80|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ID(e,c[g>>2]|0,1,+h[a+9232>>3],+h[a+12264>>3],+h[a+528>>3],+h[a+536>>3]);a=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+40|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));SD(f,a,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5968>>3]=+h[f>>3];i=b;return}function mG(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;WD(d,c[a+536>>2]|0,+h[f+12264>>3],+h[f+528>>3],+h[f+536>>3],1,1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5488>>3]=+h[d>>3];i=b;return}function nG(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;HD(d,c[a+536>>2]|0,+h[f+4688>>3],+h[(c[a+416>>2]|0)+712>>3],+h[f+5488>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5808>>3]=+h[d>>3];i=b;return}function oG(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12264>>3],+h[f+528>>3],+h[f+536>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5648>>3]=+h[d>>3];i=b;return}function pG(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12264>>3],+h[f+528>>3],+h[f+536>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+10896>>3]=+h[d>>3];i=b;return}function qG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+12264>>3];k=+h[g+10280>>3];l=j*j;m=+h[g+536>>3]*+h[g+10432>>3]-j*+h[g+1336>>3];if(l!=0.0){n=g;o=m/l;p=k+o;q=n;r=q+9648|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=k+o;q=n;r=q+9648|0;s=r;h[s>>3]=p;i=d;return}j=m/+qXa(c[b+536>>2]|0,l,32568,32560,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=k+o;q=n;r=q+9648|0;s=r;h[s>>3]=p;i=d;return}function rG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8864>>3]=+h[b+13392>>3]*+h[b+12264>>3];i=i;return}function sG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+520>>3],+h[a+512>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+520>>3];l=+h[g+512>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12272>>3]=+h[f>>3];i=b;return}function tG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8872>>3]=+h[b+13400>>3]*+h[b+12272>>3];i=i;return}function uG(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;WD(d,c[a+536>>2]|0,+h[f+12272>>3],+h[f+512>>3],+h[f+520>>3],1,1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5496>>3]=+h[d>>3];i=b;return}function vG(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12272>>3],+h[f+512>>3],+h[f+520>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5656>>3]=+h[d>>3];i=b;return}function wG(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12272>>3],+h[f+512>>3],+h[f+520>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+10904>>3]=+h[d>>3];i=b;return}function xG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+520>>3],+h[a+512>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+520>>3];l=+h[g+512>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+9224>>3]=+h[f>>3];i=b;return}function yG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9224>>3];k=+h[g+12272>>3];l=+h[g+520>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,32616,32608,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6808>>3]=j-n;i=d;return}function zG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+88|0;d=b;e=b+40|0;f=b+80|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ID(e,c[g>>2]|0,1,+h[a+9224>>3],+h[a+12272>>3],+h[a+512>>3],+h[a+520>>3]);a=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+40|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));SD(f,a,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5976>>3]=+h[f>>3];i=b;return}function AG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+520>>3],+h[a+512>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+520>>3];l=+h[g+512>>3];m=+h[g+1320>>3];n=+h[g+1312>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));fF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10440>>3]=+h[f>>3];i=b;return}function BG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+12272>>3];k=+h[g+10288>>3];l=j*j;m=+h[g+520>>3]*+h[g+10440>>3]-j*+h[g+1320>>3];if(l!=0.0){n=g;o=m/l;p=k+o;q=n;r=q+9656|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=k+o;q=n;r=q+9656|0;s=r;h[s>>3]=p;i=d;return}j=m/+qXa(c[b+536>>2]|0,l,32656,32648,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=k+o;q=n;r=q+9656|0;s=r;h[s>>3]=p;i=d;return}function CG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8712>>3]=+h[b+13400>>3]*+h[b+10440>>3];i=i;return}function DG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9976>>3]=+h[b+8872>>3]*+h[b+9656>>3]+ +h[b+8712>>3]*+h[b+6808>>3];i=i;return}function EG(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7256>>3]=(+h[b+560>>3]+ +h[b+568>>3])*(+h[d+504>>3]- +h[d+520>>3])*+h[b+2840>>3]*.5;i=i;return}function FG(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2840>>3]*(+h[e+560>>3]+ +h[e+568>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7256>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+7096|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+7096|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,32704,32696,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+7096|0;q=p;h[q>>3]=n;i=d;return}function GG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+504>>3],+h[a+496>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+504>>3];l=+h[g+496>>3];m=+h[g+1304>>3];n=+h[g+1296>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));bF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10296>>3]=+h[f>>3];i=b;return}function HG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+504>>3],+h[a+496>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+504>>3];l=+h[g+496>>3];m=+h[g+1304>>3];n=+h[g+1296>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));fF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10448>>3]=+h[f>>3];i=b;return}function IG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8720>>3]=+h[b+13408>>3]*+h[b+10448>>3];i=i;return}function JG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+488>>3],+h[a+480>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+488>>3];l=+h[g+480>>3];m=+h[g+1288>>3];n=+h[g+1280>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));bF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10304>>3]=+h[f>>3];i=b;return}function KG(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7264>>3]=(+h[b+568>>3]+ +h[b+576>>3])*(+h[d+488>>3]- +h[d+504>>3])*+h[b+2840>>3]*.5;i=i;return}function LG(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2840>>3]*(+h[e+568>>3]+ +h[e+576>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7264>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+7104|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+7104|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,32800,32792,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+7104|0;q=p;h[q>>3]=n;i=d;return}function MG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+488>>3],+h[a+480>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+488>>3];l=+h[g+480>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12288>>3]=+h[f>>3];i=b;return}function NG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8888>>3]=+h[b+13416>>3]*+h[b+12288>>3];i=i;return}function OG(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;WD(d,c[a+536>>2]|0,+h[f+12288>>3],+h[f+480>>3],+h[f+488>>3],1,1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5512>>3]=+h[d>>3];i=b;return}function PG(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12288>>3],+h[f+480>>3],+h[f+488>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5672>>3]=+h[d>>3];i=b;return}function QG(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12288>>3],+h[f+480>>3],+h[f+488>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+10920>>3]=+h[d>>3];i=b;return}function RG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+504>>3],+h[a+496>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+504>>3];l=+h[g+496>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12280>>3]=+h[f>>3];i=b;return}function SG(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;WD(d,c[a+536>>2]|0,+h[f+12280>>3],+h[f+496>>3],+h[f+504>>3],1,1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5504>>3]=+h[d>>3];i=b;return}function TG(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;HD(d,c[a+536>>2]|0,+h[f+4704>>3],+h[(c[a+416>>2]|0)+728>>3],+h[f+5504>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5824>>3]=+h[d>>3];i=b;return}function UG(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12280>>3],+h[f+496>>3],+h[f+504>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5664>>3]=+h[d>>3];i=b;return}function VG(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12280>>3],+h[f+496>>3],+h[f+504>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+10912>>3]=+h[d>>3];i=b;return}function WG(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0,y=0.0;d=i;i=i+8|0;e=d;f=b+304|0;g=+h[f>>3];j=b+536|0;k=b+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;m=b+416|0;n=c[m>>2]|0;JD(e,c[j>>2]|0,+h[l+7104>>3],+h[l+12280>>3],+h[l+12288>>3],+h[l+10912>>3],+h[l+10920>>3],+h[n+408>>3],+h[l+13112>>3],+h[l+12624>>3]*+h[n+2904>>3],(+h[n+888>>3]+ +h[n+896>>3])*.5,+h[n+2896>>3]*.05,+h[n+2864>>3]);n=c[m>>2]|0;o=g*+h[e>>3]*+h[n+2840>>3];g=1.0- +h[f>>3];p=+h[n+2872>>3];f=c[c[k>>2]>>2]|0;e=c[f+8>>2]|0;q=+h[e+7104>>3]- +h[e+12624>>3]*+h[n+2904>>3]*+h[n+2920>>3];if(p!=0.0){r=e;s=q/p;t=g*s;u=o+t;v=r;w=v+8104|0;x=w;h[x>>3]=u;i=d;return}if(q==0.0){r=e;s=q;t=g*s;u=o+t;v=r;w=v+8104|0;x=w;h[x>>3]=u;i=d;return}y=q/+qXa(c[j>>2]|0,p,32896,32888,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[(c[c[k>>2]>>2]|0)+8>>2]|0;s=y;t=g*s;u=o+t;v=r;w=v+8104|0;x=w;h[x>>3]=u;i=d;return}function XG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8112>>3]=+h[b+8720>>3]+ +h[b+8104>>3];i=i;return}function YG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8120>>3]=+h[b+8712>>3]+ +h[b+8112>>3];i=i;return}function ZG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+560>>3]*+h[j+12272>>3]*+h[e+2736>>3];l=+h[j+8120>>3]+ +h[j+8112>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6296|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6296|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,32936,32928,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6296|0;r=q;h[r>>3]=o;i=d;return}function _G(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+8232>>3]=+h[b+6296>>3]*+h[d+560>>3]*+h[d+2736>>3]*(+h[b+504>>3]*.5+(+h[b+536>>3]*-.5+(+h[b+7088>>3]+ +h[b+7096>>3])*.5));i=i;return}function $G(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;GD(d,c[a+536>>2]|0,+h[f+6296>>3],+h[f+12272>>3],+h[f+5656>>3],+h[(c[a+416>>2]|0)+720>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6136>>3]=+h[d>>3];i=b;return}function aH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6296>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+6136>>3]));l=+h[j+5976>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?7.5:12.5)*+h[m+400>>3];o=+h[m+720>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+qXa(c[b+536>>2]|0,n,33024,33016,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+5016>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function bH(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+5016>>3]+-.7;h[b+5176>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function cH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+Ad(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6136>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4856|0;w=v;h[w>>3]=n;i=b;return}x=c[72300]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=48728;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Pe[a&127](y,d,33096,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4856|0;w=v;h[w>>3]=n;i=b;return}function dH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6296>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4856>>3];l=+U(+(+h[j+6136>>3]));m=+h[j+5976>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?7.5:12.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+400>>3];q=n*p;r=q!=0.0;s=+h[o+720>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+qXa(c[b+536>>2]|0,q,33024,33192,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+5976>>3];u=+h[j+4856>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5336|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+qXa(c[b+536>>2]|0,q,33024,33192,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+720>>3];M=+h[j+400>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+qXa(c[b+536>>2]|0,q,33024,33192,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5336|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+qXa(c[b+536>>2]|0,q,33024,33192,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4856>>3]*.125));L=P*(+W(+(+h[g+5976>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+qXa(c[b+536>>2]|0,L,33200,33192,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5336|0;K=J;h[K>>3]=B;i=d;return}}function eH(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;_D(d,c[a+536>>2]|0,+h[f+5336>>3],+h[f+5176>>3],+h[f+6136>>3]+-6150.0,3850.0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5816>>3]=+h[d>>3];i=b;return}function fH(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+8120>>3];h[b+7904>>3]=d*+h[(!(d>=0.0)?b+9224|0:b+9232|0)>>3];i=i;return}function gH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8880>>3]=+h[b+13408>>3]*+h[b+12280>>3];i=i;return}function hH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+568>>3]*+h[j+12280>>3]*+h[e+2736>>3];l=+h[j+8112>>3]+ +h[j+8104>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6304|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6304|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,33336,33328,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6304|0;r=q;h[r>>3]=o;i=d;return}function iH(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;GD(d,c[a+536>>2]|0,+h[f+6304>>3],+h[f+12280>>3],+h[f+5664>>3],+h[(c[a+416>>2]|0)+728>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6144>>3]=+h[d>>3];i=b;return}function jH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+Ad(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6144>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4864|0;w=v;h[w>>3]=n;i=b;return}x=c[72300]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=48728;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Pe[a&127](y,d,33416,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4864|0;w=v;h[w>>3]=n;i=b;return}function kH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+8240>>3]=+h[b+6304>>3]*+h[d+568>>3]*+h[d+2736>>3]*(+h[b+488>>3]*.5+(+h[b+520>>3]*-.5+(+h[b+7096>>3]+ +h[b+7104>>3])*.5));i=i;return}function lH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+12280>>3];k=+h[g+10296>>3];l=j*j;m=+h[g+504>>3]*+h[g+10448>>3]-j*+h[g+1304>>3];if(l!=0.0){n=g;o=m/l;p=k+o;q=n;r=q+9664|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=k+o;q=n;r=q+9664|0;s=r;h[s>>3]=p;i=d;return}j=m/+qXa(c[b+536>>2]|0,l,33520,33512,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=k+o;q=n;r=q+9664|0;s=r;h[s>>3]=p;i=d;return}function mH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+504>>3],+h[a+496>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+504>>3];l=+h[g+496>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+9216>>3]=+h[f>>3];i=b;return}function nH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+88|0;d=b;e=b+40|0;f=b+80|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ID(e,c[g>>2]|0,1,+h[a+9216>>3],+h[a+12280>>3],+h[a+496>>3],+h[a+504>>3]);a=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+40|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));SD(f,a,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5984>>3]=+h[f>>3];i=b;return}function oH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6304>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4864>>3];l=+U(+(+h[j+6144>>3]));m=+h[j+5984>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?8.5:11.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+408>>3];q=n*p;r=q!=0.0;s=+h[o+728>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+qXa(c[b+536>>2]|0,q,33568,33560,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+5984>>3];u=+h[j+4864>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5344|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+qXa(c[b+536>>2]|0,q,33568,33560,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+728>>3];M=+h[j+408>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+qXa(c[b+536>>2]|0,q,33568,33560,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5344|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+qXa(c[b+536>>2]|0,q,33568,33560,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4864>>3]*.125));L=P*(+W(+(+h[g+5984>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+qXa(c[b+536>>2]|0,L,33640,33560,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5344|0;K=J;h[K>>3]=B;i=d;return}}function pH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6304>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+6144>>3]));l=+h[j+5984>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?8.5:11.5)*+h[m+408>>3];o=+h[m+728>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+qXa(c[b+536>>2]|0,n,33568,33768,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+5024>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function qH(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+5024>>3]+-.7;h[b+5184>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function rH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9216>>3];k=+h[g+12280>>3];l=+h[g+504>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,33784,33776,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6776>>3]=j-n;i=d;return}function sH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9984>>3]=+h[b+8880>>3]*+h[b+9664>>3]+ +h[b+8720>>3]*+h[b+6776>>3];i=i;return}function tH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+488>>3],+h[a+480>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+488>>3];l=+h[g+480>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+9208>>3]=+h[f>>3];i=b;return}function uH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9208>>3];k=+h[g+12288>>3];l=+h[g+488>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,33824,33816,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6744>>3]=j-n;i=d;return}function vH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+88|0;d=b;e=b+40|0;f=b+80|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ID(e,c[g>>2]|0,1,+h[a+9208>>3],+h[a+12288>>3],+h[a+480>>3],+h[a+488>>3]);a=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+40|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));SD(f,a,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5992>>3]=+h[f>>3];i=b;return}function wH(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+8104>>3];h[b+7920>>3]=d*+h[(!(d>=0.0)?b+9208|0:b+9216|0)>>3];i=i;return}function xH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+488>>3],+h[a+480>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+488>>3];l=+h[g+480>>3];m=+h[g+1288>>3];n=+h[g+1280>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));fF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10456>>3]=+h[f>>3];i=b;return}function yH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+12288>>3];k=+h[g+10304>>3];l=j*j;m=+h[g+488>>3]*+h[g+10456>>3]-j*+h[g+1288>>3];if(l!=0.0){n=g;o=m/l;p=k+o;q=n;r=q+9672|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=k+o;q=n;r=q+9672|0;s=r;h[s>>3]=p;i=d;return}j=m/+qXa(c[b+536>>2]|0,l,33864,33856,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=k+o;q=n;r=q+9672|0;s=r;h[s>>3]=p;i=d;return}function zH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8728>>3]=+h[b+13416>>3]*+h[b+10456>>3];i=i;return}function AH(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;HD(d,c[a+536>>2]|0,+h[f+4712>>3],+h[(c[a+416>>2]|0)+736>>3],+h[f+5512>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5832>>3]=+h[d>>3];i=b;return}function BH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+472>>3],+h[a+464>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+472>>3];l=+h[g+464>>3];m=+h[g+1272>>3];n=+h[g+1264>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));bF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10312>>3]=+h[f>>3];i=b;return}function CH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+472>>3],+h[a+464>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+472>>3];l=+h[g+464>>3];m=+h[g+1272>>3];n=+h[g+1264>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));fF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10464>>3]=+h[f>>3];i=b;return}function DH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8736>>3]=+h[b+13424>>3]*+h[b+10464>>3];i=i;return}function EH(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7272>>3]=(+h[b+576>>3]+ +h[b+584>>3])*(+h[d+472>>3]- +h[d+488>>3])*+h[b+2840>>3]*.5;i=i;return}function FH(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2840>>3]*(+h[e+576>>3]+ +h[e+584>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7272>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+7112|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+7112|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,33912,33904,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+7112|0;q=p;h[q>>3]=n;i=d;return}function GH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9992>>3]=+h[b+8888>>3]*+h[b+9672>>3]+ +h[b+8728>>3]*+h[b+6744>>3];i=i;return}function HH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+472>>3],+h[a+464>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+472>>3];l=+h[g+464>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+9200>>3]=+h[f>>3];i=b;return}function IH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+472>>3],+h[a+464>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+472>>3];l=+h[g+464>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12296>>3]=+h[f>>3];i=b;return}function JH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9200>>3];k=+h[g+12296>>3];l=+h[g+472>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,34016,34008,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6712>>3]=j-n;i=d;return}function KH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+88|0;d=b;e=b+40|0;f=b+80|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ID(e,c[g>>2]|0,1,+h[a+9200>>3],+h[a+12296>>3],+h[a+464>>3],+h[a+472>>3]);a=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+40|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));SD(f,a,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+6e3>>3]=+h[f>>3];i=b;return}function LH(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12296>>3],+h[f+464>>3],+h[f+472>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+10928>>3]=+h[d>>3];i=b;return}function MH(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;WD(d,c[a+536>>2]|0,+h[f+12296>>3],+h[f+464>>3],+h[f+472>>3],1,1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5520>>3]=+h[d>>3];i=b;return}function NH(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;HD(d,c[a+536>>2]|0,+h[f+4720>>3],+h[(c[a+416>>2]|0)+744>>3],+h[f+5520>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5840>>3]=+h[d>>3];i=b;return}function OH(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12296>>3],+h[f+464>>3],+h[f+472>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5680>>3]=+h[d>>3];i=b;return}function PH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+12296>>3];k=+h[g+10312>>3];l=j*j;m=+h[g+472>>3]*+h[g+10464>>3]-j*+h[g+1272>>3];if(l!=0.0){n=g;o=m/l;p=k+o;q=n;r=q+9680|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=k+o;q=n;r=q+9680|0;s=r;h[s>>3]=p;i=d;return}j=m/+qXa(c[b+536>>2]|0,l,34056,34048,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=k+o;q=n;r=q+9680|0;s=r;h[s>>3]=p;i=d;return}function QH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8896>>3]=+h[b+13424>>3]*+h[b+12296>>3];i=i;return}function RH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1e4>>3]=+h[b+8896>>3]*+h[b+9680>>3]+ +h[b+8736>>3]*+h[b+6712>>3];i=i;return}function SH(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7280>>3]=(+h[b+584>>3]+ +h[b+592>>3])*(+h[d+456>>3]- +h[d+472>>3])*+h[b+2840>>3]*.5;i=i;return}function TH(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2840>>3]*(+h[e+584>>3]+ +h[e+592>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7280>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+7120|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+7120|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,34104,34096,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+7120|0;q=p;h[q>>3]=n;i=d;return}function UH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+440>>3],+h[a+432>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+440>>3];l=+h[g+432>>3];m=+h[g+1240>>3];n=+h[g+1232>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));bF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10328>>3]=+h[f>>3];i=b;return}function VH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+440>>3],+h[a+432>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+440>>3];l=+h[g+432>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12312>>3]=+h[f>>3];i=b;return}function WH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8912>>3]=+h[b+13440>>3]*+h[b+12312>>3];i=i;return}function XH(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;WD(d,c[a+536>>2]|0,+h[f+12312>>3],+h[f+432>>3],+h[f+440>>3],1,1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5536>>3]=+h[d>>3];i=b;return}function YH(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12312>>3],+h[f+432>>3],+h[f+440>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5696>>3]=+h[d>>3];i=b;return}function ZH(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12312>>3],+h[f+432>>3],+h[f+440>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+10944>>3]=+h[d>>3];i=b;return}function _H(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7288>>3]=(+h[b+592>>3]+ +h[b+600>>3])*(+h[d+440>>3]- +h[d+456>>3])*+h[b+2840>>3]*.5;i=i;return}function $H(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2840>>3]*(+h[e+592>>3]+ +h[e+600>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7288>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+7128|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+7128|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,34208,34200,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+7128|0;q=p;h[q>>3]=n;i=d;return}function aI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+456>>3],+h[a+448>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+456>>3];l=+h[g+448>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12304>>3]=+h[f>>3];i=b;return}function bI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8904>>3]=+h[b+13432>>3]*+h[b+12304>>3];i=i;return}function cI(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;WD(d,c[a+536>>2]|0,+h[f+12304>>3],+h[f+448>>3],+h[f+456>>3],1,1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5528>>3]=+h[d>>3];i=b;return}function dI(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;HD(d,c[a+536>>2]|0,+h[f+4728>>3],+h[(c[a+416>>2]|0)+752>>3],+h[f+5528>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5848>>3]=+h[d>>3];i=b;return}function eI(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12304>>3],+h[f+448>>3],+h[f+456>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5688>>3]=+h[d>>3];i=b;return}function fI(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12304>>3],+h[f+448>>3],+h[f+456>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+10936>>3]=+h[d>>3];i=b;return}function gI(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0,y=0.0;d=i;i=i+8|0;e=d;f=b+304|0;g=+h[f>>3];j=b+536|0;k=b+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;m=b+416|0;n=c[m>>2]|0;JD(e,c[j>>2]|0,+h[l+7128>>3],+h[l+12304>>3],+h[l+12312>>3],+h[l+10936>>3],+h[l+10944>>3],+h[n+432>>3],+h[l+13088>>3],+h[l+12648>>3]*+h[n+2904>>3],(+h[n+912>>3]+ +h[n+920>>3])*.5,+h[n+2896>>3]*.05,+h[n+2864>>3]);n=c[m>>2]|0;o=g*+h[e>>3]*+h[n+2840>>3];g=1.0- +h[f>>3];p=+h[n+2872>>3];f=c[c[k>>2]>>2]|0;e=c[f+8>>2]|0;q=+h[e+7128>>3]- +h[e+12648>>3]*+h[n+2904>>3]*+h[n+2920>>3];if(p!=0.0){r=e;s=q/p;t=g*s;u=o+t;v=r;w=v+8080|0;x=w;h[x>>3]=u;i=d;return}if(q==0.0){r=e;s=q;t=g*s;u=o+t;v=r;w=v+8080|0;x=w;h[x>>3]=u;i=d;return}y=q/+qXa(c[j>>2]|0,p,32896,34304,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[(c[c[k>>2]>>2]|0)+8>>2]|0;s=y;t=g*s;u=o+t;v=r;w=v+8080|0;x=w;h[x>>3]=u;i=d;return}function hI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8088>>3]=+h[b+8744>>3]+ +h[b+8080>>3];i=i;return}function iI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8096>>3]=+h[b+8736>>3]+ +h[b+8088>>3];i=i;return}function jI(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+8096>>3];h[b+7928>>3]=d*+h[(!(d>=0.0)?b+9200|0:b+9208|0)>>3];i=i;return}function kI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8568>>3]=+h[b+7920>>3]- +h[b+7928>>3];i=i;return}function lI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+576>>3]*+h[j+12288>>3]*+h[e+2736>>3];l=+h[j+8104>>3]+ +h[j+8096>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6312|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6312|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,34320,34312,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6312|0;r=q;h[r>>3]=o;i=d;return}function mI(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+8248>>3]=+h[b+6312>>3]*+h[d+576>>3]*+h[d+2736>>3]*(+h[b+472>>3]*.5+(+h[b+504>>3]*-.5+(+h[b+7104>>3]+ +h[b+7112>>3])*.5));i=i;return}function nI(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;GD(d,c[a+536>>2]|0,+h[f+6312>>3],+h[f+12288>>3],+h[f+5672>>3],+h[(c[a+416>>2]|0)+736>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6152>>3]=+h[d>>3];i=b;return}function oI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+Ad(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6152>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4872|0;w=v;h[w>>3]=n;i=b;return}x=c[72300]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=48728;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Pe[a&127](y,d,34408,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4872|0;w=v;h[w>>3]=n;i=b;return}function pI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6312>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4872>>3];l=+U(+(+h[j+6152>>3]));m=+h[j+5992>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?9.5:10.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+416>>3];q=n*p;r=q!=0.0;s=+h[o+736>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+qXa(c[b+536>>2]|0,q,34520,34512,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+5992>>3];u=+h[j+4872>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5352|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+qXa(c[b+536>>2]|0,q,34520,34512,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+736>>3];M=+h[j+416>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+qXa(c[b+536>>2]|0,q,34520,34512,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5352|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+qXa(c[b+536>>2]|0,q,34520,34512,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4872>>3]*.125));L=P*(+W(+(+h[g+5992>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+qXa(c[b+536>>2]|0,L,34600,34512,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5352|0;K=J;h[K>>3]=B;i=d;return}}function qI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6312>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+6152>>3]));l=+h[j+5992>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?9.5:10.5)*+h[m+416>>3];o=+h[m+736>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+qXa(c[b+536>>2]|0,n,34520,34728,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+5032>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function rI(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+5032>>3]+-.7;h[b+5192>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function sI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+584>>3]*+h[j+12296>>3]*+h[e+2736>>3];l=+h[j+8096>>3]+ +h[j+8088>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6320|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6320|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,34744,34736,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6320|0;r=q;h[r>>3]=o;i=d;return}function tI(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+8256>>3]=+h[b+6320>>3]*+h[d+584>>3]*+h[d+2736>>3]*(+h[b+456>>3]*.5+(+h[b+488>>3]*-.5+(+h[b+7112>>3]+ +h[b+7120>>3])*.5));i=i;return}function uI(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;GD(d,c[a+536>>2]|0,+h[f+6320>>3],+h[f+12296>>3],+h[f+5680>>3],+h[(c[a+416>>2]|0)+744>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6160>>3]=+h[d>>3];i=b;return}function vI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6320>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+6160>>3]));l=+h[j+6e3>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?10.5:9.5)*+h[m+424>>3];o=+h[m+744>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+qXa(c[b+536>>2]|0,n,34840,34832,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+5040>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function wI(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+5040>>3]+-.7;h[b+5200>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function xI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+Ad(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6160>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4880|0;w=v;h[w>>3]=n;i=b;return}x=c[72300]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=48728;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Pe[a&127](y,d,34920,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4880|0;w=v;h[w>>3]=n;i=b;return}function yI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6320>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4880>>3];l=+U(+(+h[j+6160>>3]));m=+h[j+6e3>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?10.5:9.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+424>>3];q=n*p;r=q!=0.0;s=+h[o+744>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+qXa(c[b+536>>2]|0,q,34840,35024,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+6e3>>3];u=+h[j+4880>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5360|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+qXa(c[b+536>>2]|0,q,34840,35024,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+744>>3];M=+h[j+424>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+qXa(c[b+536>>2]|0,q,34840,35024,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5360|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+qXa(c[b+536>>2]|0,q,34840,35024,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4880>>3]*.125));L=P*(+W(+(+h[g+6e3>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+qXa(c[b+536>>2]|0,L,35032,35024,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5360|0;K=J;h[K>>3]=B;i=d;return}}function zI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+592>>3]*+h[j+12304>>3]*+h[e+2736>>3];l=+h[j+8088>>3]+ +h[j+8080>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6328|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6328|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,35168,35160,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6328|0;r=q;h[r>>3]=o;i=d;return}function AI(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;GD(d,c[a+536>>2]|0,+h[f+6328>>3],+h[f+12304>>3],+h[f+5688>>3],+h[(c[a+416>>2]|0)+752>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6168>>3]=+h[d>>3];i=b;return}function BI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+Ad(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6168>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4888|0;w=v;h[w>>3]=n;i=b;return}x=c[72300]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=48728;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Pe[a&127](y,d,35256,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4888|0;w=v;h[w>>3]=n;i=b;return}function CI(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+8264>>3]=+h[b+6328>>3]*+h[d+592>>3]*+h[d+2736>>3]*(+h[b+440>>3]*.5+(+h[b+472>>3]*-.5+(+h[b+7120>>3]+ +h[b+7128>>3])*.5));i=i;return}function DI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+12304>>3];k=+h[g+10320>>3];l=j*j;m=+h[g+456>>3]*+h[g+10472>>3]-j*+h[g+1256>>3];if(l!=0.0){n=g;o=m/l;p=k+o;q=n;r=q+9688|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=k+o;q=n;r=q+9688|0;s=r;h[s>>3]=p;i=d;return}j=m/+qXa(c[b+536>>2]|0,l,35368,35360,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=k+o;q=n;r=q+9688|0;s=r;h[s>>3]=p;i=d;return}function EI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+456>>3],+h[a+448>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+456>>3];l=+h[g+448>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+9192>>3]=+h[f>>3];i=b;return}function FI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9192>>3];k=+h[g+12304>>3];l=+h[g+456>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,35416,35408,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6680>>3]=j-n;i=d;return}function GI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10008>>3]=+h[b+8904>>3]*+h[b+9688>>3]+ +h[b+8744>>3]*+h[b+6680>>3];i=i;return}function HI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+88|0;d=b;e=b+40|0;f=b+80|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ID(e,c[g>>2]|0,1,+h[a+9192>>3],+h[a+12304>>3],+h[a+448>>3],+h[a+456>>3]);a=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+40|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));SD(f,a,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+6008>>3]=+h[f>>3];i=b;return}function II(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6328>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4888>>3];l=+U(+(+h[j+6168>>3]));m=+h[j+6008>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?11.5:8.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+432>>3];q=n*p;r=q!=0.0;s=+h[o+752>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+qXa(c[b+536>>2]|0,q,35456,35448,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+6008>>3];u=+h[j+4888>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5368|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+qXa(c[b+536>>2]|0,q,35456,35448,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+752>>3];M=+h[j+432>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+qXa(c[b+536>>2]|0,q,35456,35448,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5368|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+qXa(c[b+536>>2]|0,q,35456,35448,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4888>>3]*.125));L=P*(+W(+(+h[g+6008>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+qXa(c[b+536>>2]|0,L,35536,35448,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5368|0;K=J;h[K>>3]=B;i=d;return}}function JI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6328>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+6168>>3]));l=+h[j+6008>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?11.5:8.5)*+h[m+432>>3];o=+h[m+752>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+qXa(c[b+536>>2]|0,n,35456,35664,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+5048>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function KI(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+5048>>3]+-.7;h[b+5208>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function LI(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+8088>>3];h[b+7936>>3]=d*+h[(!(d>=0.0)?b+9192|0:b+9200|0)>>3];i=i;return}function MI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8576>>3]=+h[b+7928>>3]- +h[b+7936>>3];i=i;return}function NI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+440>>3],+h[a+432>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+440>>3];l=+h[g+432>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+9184>>3]=+h[f>>3];i=b;return}function OI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9184>>3];k=+h[g+12312>>3];l=+h[g+440>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,35680,35672,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6648>>3]=j-n;i=d;return}function PI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+88|0;d=b;e=b+40|0;f=b+80|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ID(e,c[g>>2]|0,1,+h[a+9184>>3],+h[a+12312>>3],+h[a+432>>3],+h[a+440>>3]);a=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+40|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));SD(f,a,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+6016>>3]=+h[f>>3];i=b;return}function QI(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+8080>>3];h[b+7944>>3]=d*+h[(!(d>=0.0)?b+9184|0:b+9192|0)>>3];i=i;return}function RI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8584>>3]=+h[b+7936>>3]- +h[b+7944>>3];i=i;return}function SI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+440>>3],+h[a+432>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+440>>3];l=+h[g+432>>3];m=+h[g+1240>>3];n=+h[g+1232>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));fF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10480>>3]=+h[f>>3];i=b;return}function TI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+12312>>3];k=+h[g+10328>>3];l=j*j;m=+h[g+440>>3]*+h[g+10480>>3]-j*+h[g+1240>>3];if(l!=0.0){n=g;o=m/l;p=k+o;q=n;r=q+9696|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=k+o;q=n;r=q+9696|0;s=r;h[s>>3]=p;i=d;return}j=m/+qXa(c[b+536>>2]|0,l,35720,35712,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=k+o;q=n;r=q+9696|0;s=r;h[s>>3]=p;i=d;return}function UI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8752>>3]=+h[b+13440>>3]*+h[b+10480>>3];i=i;return}function VI(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;HD(d,c[a+536>>2]|0,+h[f+4736>>3],+h[(c[a+416>>2]|0)+760>>3],+h[f+5536>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5856>>3]=+h[d>>3];i=b;return}function WI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+424>>3],+h[a+416>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+424>>3];l=+h[g+416>>3];m=+h[g+1224>>3];n=+h[g+1216>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));bF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10336>>3]=+h[f>>3];i=b;return}function XI(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7296>>3]=(+h[b+600>>3]+ +h[b+608>>3])*(+h[d+424>>3]- +h[d+440>>3])*+h[b+2840>>3]*.5;i=i;return}function YI(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2840>>3]*(+h[e+600>>3]+ +h[e+608>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7296>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+7136|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+7136|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,35768,35760,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+7136|0;q=p;h[q>>3]=n;i=d;return}function ZI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+424>>3],+h[a+416>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+424>>3];l=+h[g+416>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12320>>3]=+h[f>>3];i=b;return}function _I(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8920>>3]=+h[b+13448>>3]*+h[b+12320>>3];i=i;return}function $I(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;WD(d,c[a+536>>2]|0,+h[f+12320>>3],+h[f+416>>3],+h[f+424>>3],1,1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5544>>3]=+h[d>>3];i=b;return}function aJ(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12320>>3],+h[f+416>>3],+h[f+424>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5704>>3]=+h[d>>3];i=b;return}function bJ(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12320>>3],+h[f+416>>3],+h[f+424>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+10952>>3]=+h[d>>3];i=b;return}function cJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10016>>3]=+h[b+8912>>3]*+h[b+9696>>3]+ +h[b+8752>>3]*+h[b+6648>>3];i=i;return}function dJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+424>>3],+h[a+416>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+424>>3];l=+h[g+416>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+9176>>3]=+h[f>>3];i=b;return}function eJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9176>>3];k=+h[g+12320>>3];l=+h[g+424>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,35872,35864,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6616>>3]=j-n;i=d;return}function fJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+88|0;d=b;e=b+40|0;f=b+80|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ID(e,c[g>>2]|0,1,+h[a+9176>>3],+h[a+12320>>3],+h[a+416>>3],+h[a+424>>3]);a=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+40|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));SD(f,a,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+6024>>3]=+h[f>>3];i=b;return}function gJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+424>>3],+h[a+416>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+424>>3];l=+h[g+416>>3];m=+h[g+1224>>3];n=+h[g+1216>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));fF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10488>>3]=+h[f>>3];i=b;return}function hJ(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;HD(d,c[a+536>>2]|0,+h[f+4744>>3],+h[(c[a+416>>2]|0)+768>>3],+h[f+5544>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5864>>3]=+h[d>>3];i=b;return}function iJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+408>>3],+h[a+400>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+408>>3];l=+h[g+400>>3];m=+h[g+1208>>3];n=+h[g+1200>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));bF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10344>>3]=+h[f>>3];i=b;return}function jJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+408>>3],+h[a+400>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+408>>3];l=+h[g+400>>3];m=+h[g+1208>>3];n=+h[g+1200>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));fF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10496>>3]=+h[f>>3];i=b;return}function kJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8768>>3]=+h[b+13456>>3]*+h[b+10496>>3];i=i;return}function lJ(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7304>>3]=(+h[b+608>>3]+ +h[b+616>>3])*(+h[d+408>>3]- +h[d+424>>3])*+h[b+2840>>3]*.5;i=i;return}function mJ(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2840>>3]*(+h[e+608>>3]+ +h[e+616>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7304>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+7144|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+7144|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,35912,35904,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+7144|0;q=p;h[q>>3]=n;i=d;return}function nJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+392>>3],+h[a+384>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+392>>3];l=+h[g+384>>3];m=+h[g+1192>>3];n=+h[g+1184>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));bF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10352>>3]=+h[f>>3];i=b;return}function oJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+392>>3],+h[a+384>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+392>>3];l=+h[g+384>>3];m=+h[g+1192>>3];n=+h[g+1184>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));fF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10504>>3]=+h[f>>3];i=b;return}function pJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8776>>3]=+h[b+13464>>3]*+h[b+10504>>3];i=i;return}function qJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+392>>3],+h[a+384>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+392>>3];l=+h[g+384>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12336>>3]=+h[f>>3];i=b;return}function rJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8936>>3]=+h[b+13464>>3]*+h[b+12336>>3];i=i;return}function sJ(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;WD(d,c[a+536>>2]|0,+h[f+12336>>3],+h[f+384>>3],+h[f+392>>3],1,1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5560>>3]=+h[d>>3];i=b;return}function tJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+12336>>3];k=+h[g+10352>>3];l=j*j;m=+h[g+392>>3]*+h[g+10504>>3]-j*+h[g+1192>>3];if(l!=0.0){n=g;o=m/l;p=k+o;q=n;r=q+9720|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=k+o;q=n;r=q+9720|0;s=r;h[s>>3]=p;i=d;return}j=m/+qXa(c[b+536>>2]|0,l,36016,36008,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=k+o;q=n;r=q+9720|0;s=r;h[s>>3]=p;i=d;return}function uJ(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12336>>3],+h[f+384>>3],+h[f+392>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+10968>>3]=+h[d>>3];i=b;return}function vJ(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7312>>3]=(+h[b+616>>3]+ +h[b+624>>3])*(+h[d+392>>3]- +h[d+408>>3])*+h[b+2840>>3]*.5;i=i;return}function wJ(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2840>>3]*(+h[e+616>>3]+ +h[e+624>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7312>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+7152|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+7152|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,36064,36056,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+7152|0;q=p;h[q>>3]=n;i=d;return}function xJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8760>>3]=+h[b+13448>>3]*+h[b+10488>>3];i=i;return}function yJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+12320>>3];k=+h[g+10336>>3];l=j*j;m=+h[g+424>>3]*+h[g+10488>>3]-j*+h[g+1224>>3];if(l!=0.0){n=g;o=m/l;p=k+o;q=n;r=q+9704|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=k+o;q=n;r=q+9704|0;s=r;h[s>>3]=p;i=d;return}j=m/+qXa(c[b+536>>2]|0,l,36168,36160,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=k+o;q=n;r=q+9704|0;s=r;h[s>>3]=p;i=d;return}function zJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10024>>3]=+h[b+8920>>3]*+h[b+9704>>3]+ +h[b+8760>>3]*+h[b+6616>>3];i=i;return}function AJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+408>>3],+h[a+400>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+408>>3];l=+h[g+400>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+9168>>3]=+h[f>>3];i=b;return}function BJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+408>>3],+h[a+400>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+408>>3];l=+h[g+400>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12328>>3]=+h[f>>3];i=b;return}function CJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+88|0;d=b;e=b+40|0;f=b+80|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ID(e,c[g>>2]|0,1,+h[a+9168>>3],+h[a+12328>>3],+h[a+400>>3],+h[a+408>>3]);a=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+40|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));SD(f,a,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+6032>>3]=+h[f>>3];i=b;return}function DJ(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12328>>3],+h[f+400>>3],+h[f+408>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+10960>>3]=+h[d>>3];i=b;return}function EJ(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;WD(d,c[a+536>>2]|0,+h[f+12328>>3],+h[f+400>>3],+h[f+408>>3],1,1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5552>>3]=+h[d>>3];i=b;return}function FJ(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;HD(d,c[a+536>>2]|0,+h[f+4752>>3],+h[(c[a+416>>2]|0)+776>>3],+h[f+5552>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5872>>3]=+h[d>>3];i=b;return}function GJ(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12328>>3],+h[f+400>>3],+h[f+408>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5712>>3]=+h[d>>3];i=b;return}function HJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+12328>>3];k=+h[g+10344>>3];l=j*j;m=+h[g+408>>3]*+h[g+10496>>3]-j*+h[g+1208>>3];if(l!=0.0){n=g;o=m/l;p=k+o;q=n;r=q+9712|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=k+o;q=n;r=q+9712|0;s=r;h[s>>3]=p;i=d;return}j=m/+qXa(c[b+536>>2]|0,l,36216,36208,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=k+o;q=n;r=q+9712|0;s=r;h[s>>3]=p;i=d;return}function IJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8928>>3]=+h[b+13456>>3]*+h[b+12328>>3];i=i;return}function JJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9168>>3];k=+h[g+12328>>3];l=+h[g+408>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,36264,36256,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6584>>3]=j-n;i=d;return}function KJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10032>>3]=+h[b+8928>>3]*+h[b+9712>>3]+ +h[b+8768>>3]*+h[b+6584>>3];i=i;return}function LJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+392>>3],+h[a+384>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+392>>3];l=+h[g+384>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+9160>>3]=+h[f>>3];i=b;return}function MJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9160>>3];k=+h[g+12336>>3];l=+h[g+392>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,36304,36296,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6552>>3]=j-n;i=d;return}function NJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10040>>3]=+h[b+8936>>3]*+h[b+9720>>3]+ +h[b+8776>>3]*+h[b+6552>>3];i=i;return}function OJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+88|0;d=b;e=b+40|0;f=b+80|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ID(e,c[g>>2]|0,1,+h[a+9160>>3],+h[a+12336>>3],+h[a+384>>3],+h[a+392>>3]);a=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+40|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));SD(f,a,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+6040>>3]=+h[f>>3];i=b;return}function PJ(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12336>>3],+h[f+384>>3],+h[f+392>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5720>>3]=+h[d>>3];i=b;return}function QJ(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;HD(d,c[a+536>>2]|0,+h[f+4760>>3],+h[(c[a+416>>2]|0)+784>>3],+h[f+5560>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5880>>3]=+h[d>>3];i=b;return}function RJ(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7320>>3]=(+h[b+624>>3]+ +h[b+632>>3])*(+h[d+376>>3]- +h[d+392>>3])*+h[b+2840>>3]*.5;i=i;return}function SJ(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2840>>3]*(+h[e+624>>3]+ +h[e+632>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7320>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+7160|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+7160|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,36344,36336,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+7160|0;q=p;h[q>>3]=n;i=d;return}function TJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+376>>3],+h[a+368>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+376>>3];l=+h[g+368>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12344>>3]=+h[f>>3];i=b;return}function UJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8944>>3]=+h[b+13472>>3]*+h[b+12344>>3];i=i;return}function VJ(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;WD(d,c[a+536>>2]|0,+h[f+12344>>3],+h[f+368>>3],+h[f+376>>3],1,1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5568>>3]=+h[d>>3];i=b;return}function WJ(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;HD(d,c[a+536>>2]|0,+h[f+4768>>3],+h[(c[a+416>>2]|0)+792>>3],+h[f+5568>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5888>>3]=+h[d>>3];i=b;return}function XJ(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12344>>3],+h[f+368>>3],+h[f+376>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5728>>3]=+h[d>>3];i=b;return}function YJ(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12344>>3],+h[f+368>>3],+h[f+376>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+10976>>3]=+h[d>>3];i=b;return}function ZJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+12344>>3];k=+h[g+10360>>3];l=j*j;m=+h[g+376>>3]*+h[g+10512>>3]-j*+h[g+1176>>3];if(l!=0.0){n=g;o=m/l;p=k+o;q=n;r=q+9728|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=k+o;q=n;r=q+9728|0;s=r;h[s>>3]=p;i=d;return}j=m/+qXa(c[b+536>>2]|0,l,36448,36440,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=k+o;q=n;r=q+9728|0;s=r;h[s>>3]=p;i=d;return}function _J(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+376>>3],+h[a+368>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+376>>3];l=+h[g+368>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+9152>>3]=+h[f>>3];i=b;return}function $J(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9152>>3];k=+h[g+12344>>3];l=+h[g+376>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,36496,36488,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6520>>3]=j-n;i=d;return}function aK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10048>>3]=+h[b+8944>>3]*+h[b+9728>>3]+ +h[b+8784>>3]*+h[b+6520>>3];i=i;return}function bK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+88|0;d=b;e=b+40|0;f=b+80|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ID(e,c[g>>2]|0,1,+h[a+9152>>3],+h[a+12344>>3],+h[a+368>>3],+h[a+376>>3]);a=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+40|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));SD(f,a,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+6048>>3]=+h[f>>3];i=b;return}function cK(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7328>>3]=(+h[b+632>>3]+ +h[b+640>>3])*(+h[d+360>>3]- +h[d+376>>3])*+h[b+2840>>3]*.5;i=i;return}function dK(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2840>>3]*(+h[e+632>>3]+ +h[e+640>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7328>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+7168|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+7168|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,36536,36528,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+7168|0;q=p;h[q>>3]=n;i=d;return}function eK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+344>>3],+h[a+336>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+344>>3];l=+h[g+336>>3];m=+h[g+1144>>3];n=+h[g+1136>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));fF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10528>>3]=+h[f>>3];i=b;return}function fK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8800>>3]=+h[b+13488>>3]*+h[b+10528>>3];i=i;return}function gK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+344>>3],+h[a+336>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+344>>3];l=+h[g+336>>3];m=+h[g+1144>>3];n=+h[g+1136>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));bF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10376>>3]=+h[f>>3];i=b;return}function hK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+328>>3],+h[a+320>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+328>>3];l=+h[g+320>>3];m=+h[g+1128>>3];n=+h[g+1120>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));bF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+14632>>3]=+h[f>>3];i=b;return}function iK(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7344>>3]=(+h[b+648>>3]+ +h[b+656>>3])*(+h[d+328>>3]- +h[d+344>>3])*+h[b+2840>>3]*.5;i=i;return}function jK(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2840>>3]*(+h[e+648>>3]+ +h[e+656>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7344>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+7184|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+7184|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,36640,36632,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+7184|0;q=p;h[q>>3]=n;i=d;return}function kK(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7352>>3]=+h[b+656>>3]*(1.0e5- +h[d+328>>3])*+h[b+2840>>3];i=i;return}



function lK(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=c[b+416>>2]|0;f=+h[e+656>>3]*+h[e+2840>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7352>>3];l=-k;if(f!=0.0){m=j;n=l/f;o=m;p=o+7192|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+7192|0;q=p;h[q>>3]=n;i=d;return}k=l/+qXa(c[b+536>>2]|0,f,36744,36736,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+7192|0;q=p;h[q>>3]=n;i=d;return}function mK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+328>>3],+h[a+320>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+328>>3];l=+h[g+320>>3];m=+h[g+1128>>3];n=+h[g+1120>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));fF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10536>>3]=+h[f>>3];i=b;return}function nK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8808>>3]=+h[b+13496>>3]*+h[b+10536>>3];i=i;return}function oK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+312>>3],+h[a+304>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+312>>3];l=+h[g+304>>3];m=+h[g+1112>>3];n=+h[g+1104>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));bF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+14656>>3]=+h[f>>3];i=b;return}function pK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+312>>3],+h[a+304>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+312>>3];l=+h[g+304>>3];m=+h[g+1112>>3];n=+h[g+1104>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));fF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10688>>3]=+h[f>>3];i=b;return}function qK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4016>>3]=+h[b+13984>>3]*+h[b+10688>>3];i=i;return}function rK(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2560>>3]=+h[b+1632>>3]*(+h[d+312>>3]+-1.0e5)*+h[b+3072>>3];i=i;return}function sK(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=c[b+416>>2]|0;f=+h[e+1632>>3]*+h[e+3072>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2560>>3];l=-k;if(f!=0.0){m=j;n=l/f;o=m;p=o+2400|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+2400|0;q=p;h[q>>3]=n;i=d;return}k=l/+qXa(c[b+536>>2]|0,f,36816,36808,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+2400|0;q=p;h[q>>3]=n;i=d;return}function tK(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2568>>3]=(+h[b+1632>>3]+ +h[b+1640>>3])*(+h[d+296>>3]- +h[d+312>>3])*+h[b+3072>>3]*.5;i=i;return}function uK(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3072>>3]*(+h[e+1632>>3]+ +h[e+1640>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2568>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+2408|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+2408|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,36888,36880,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+2408|0;q=p;h[q>>3]=n;i=d;return}function vK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+312>>3],+h[a+304>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+312>>3];l=+h[g+304>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12400>>3]=+h[f>>3];i=b;return}function wK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4176>>3]=+h[b+13984>>3]*+h[b+12400>>3];i=i;return}function xK(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12400>>3],+h[f+304>>3],+h[f+312>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11024>>3]=+h[d>>3];i=b;return}function yK(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0,y=0.0;d=i;i=i+8|0;e=d;f=b+304|0;g=+h[f>>3];j=b+536|0;k=b+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;m=b+416|0;n=c[m>>2]|0;o=+h[n+1952>>3];JD(e,c[j>>2]|0,+h[l+2400>>3],+h[l+12392>>3],+h[l+12400>>3],+h[l+11016>>3],+h[l+11024>>3],+h[n+1472>>3],+h[n+1792>>3],+h[l+12720>>3]*+h[n+3136>>3],(o+o)*.5,+h[n+3128>>3]*.05,+h[n+3096>>3]);n=c[m>>2]|0;o=g*+h[e>>3]*+h[n+3072>>3];g=1.0- +h[f>>3];p=+h[n+3104>>3];f=c[c[k>>2]>>2]|0;e=c[f+8>>2]|0;q=+h[e+2400>>3]- +h[e+12720>>3]*+h[n+3136>>3]*+h[n+3152>>3];if(p!=0.0){r=e;s=q/p;t=g*s;u=o+t;v=r;w=v+3528|0;x=w;h[x>>3]=u;i=d;return}if(q==0.0){r=e;s=q;t=g*s;u=o+t;v=r;w=v+3528|0;x=w;h[x>>3]=u;i=d;return}y=q/+qXa(c[j>>2]|0,p,36984,36976,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[(c[c[k>>2]>>2]|0)+8>>2]|0;s=y;t=g*s;u=o+t;v=r;w=v+3528|0;x=w;h[x>>3]=u;i=d;return}function zK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+12400>>3];k=+h[g+14656>>3];l=j*j;m=+h[g+312>>3]*+h[g+10688>>3]-j*+h[g+1112>>3];if(l!=0.0){n=g;o=m/l;p=k+o;q=n;r=q+9760|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=k+o;q=n;r=q+9760|0;s=r;h[s>>3]=p;i=d;return}j=m/+qXa(c[b+536>>2]|0,l,37024,37016,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=k+o;q=n;r=q+9760|0;s=r;h[s>>3]=p;i=d;return}function AK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+312>>3],+h[a+304>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+312>>3];l=+h[g+304>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+14584>>3]=+h[f>>3];i=b;return}function BK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+14584>>3];k=+h[g+12400>>3];l=+h[g+312>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,37072,37064,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+2392>>3]=j-n;i=d;return}function CK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10080>>3]=+h[b+4176>>3]*+h[b+9760>>3]+ +h[b+4016>>3]*+h[b+2392>>3];i=i;return}function DK(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3528>>3];h[b+3208>>3]=d*+h[(!(d>=0.0)?b+14584|0:b+14800|0)>>3];i=i;return}function EK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8488>>3]=+h[b+4792>>3]*+h[b+13656>>3]*(+h[b+9592>>3]- +h[b+320>>3])*+h[(c[a+416>>2]|0)+2944>>3];i=i;return}function FK(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3696>>3]=-(+h[b+2696>>3]*+h[b+152>>3]*+h[d+1592>>3])- +h[d+8488>>3];i=i;return}function GK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+328>>3],+h[a+320>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+328>>3];l=+h[g+320>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+14608>>3]=+h[f>>3];i=b;return}function HK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+328>>3],+h[a+320>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+328>>3];l=+h[g+320>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12368>>3]=+h[f>>3];i=b;return}function IK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+14608>>3];k=+h[g+12368>>3];l=+h[g+328>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,37112,37104,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6424>>3]=j-n;i=d;return}function JK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+88|0;d=b;e=b+40|0;f=b+80|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ID(e,c[g>>2]|0,1,+h[a+14608>>3],+h[a+12368>>3],+h[a+320>>3],+h[a+328>>3]);a=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+40|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));SD(f,a,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+6072>>3]=+h[f>>3];i=b;return}function KK(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;WD(d,c[a+536>>2]|0,+h[f+12368>>3],+h[f+320>>3],+h[f+328>>3],1,1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5592>>3]=+h[d>>3];i=b;return}function LK(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;HD(d,c[a+536>>2]|0,+h[f+4792>>3],+h[(c[a+416>>2]|0)+816>>3],+h[f+5592>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5912>>3]=+h[d>>3];i=b;return}function MK(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12368>>3],+h[f+320>>3],+h[f+328>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5752>>3]=+h[d>>3];i=b;return}function NK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+12368>>3];k=+h[g+14632>>3];l=j*j;m=+h[g+328>>3]*+h[g+10536>>3]-j*+h[g+1128>>3];if(l!=0.0){n=g;o=m/l;p=k+o;q=n;r=q+9752|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=k+o;q=n;r=q+9752|0;s=r;h[s>>3]=p;i=d;return}j=m/+qXa(c[b+536>>2]|0,l,37152,37144,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=k+o;q=n;r=q+9752|0;s=r;h[s>>3]=p;i=d;return}function OK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8968>>3]=+h[b+13496>>3]*+h[b+12368>>3];i=i;return}function PK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10072>>3]=+h[b+8968>>3]*+h[b+9752>>3]+ +h[b+8808>>3]*+h[b+6424>>3];i=i;return}function QK(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12368>>3],+h[f+320>>3],+h[f+328>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11e3>>3]=+h[d>>3];i=b;return}function RK(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0,y=0.0;d=i;i=i+8|0;e=d;f=b+304|0;g=+h[f>>3];j=b+536|0;k=b+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;m=b+416|0;n=c[m>>2]|0;o=+h[n+976>>3];JD(e,c[j>>2]|0,+h[l+7192>>3],+h[l+12368>>3],+h[l+12376>>3],+h[l+11e3>>3],+h[l+11008>>3],+h[n+496>>3],+h[n+816>>3],+h[l+12712>>3]*+h[n+2904>>3],(o+o)*.5,+h[n+2896>>3]*.05,+h[n+2864>>3]);n=c[m>>2]|0;o=g*+h[e>>3]*+h[n+2840>>3];g=1.0- +h[f>>3];p=+h[n+2872>>3];f=c[c[k>>2]>>2]|0;e=c[f+8>>2]|0;q=+h[e+7192>>3]- +h[e+12712>>3]*+h[n+2904>>3]*+h[n+2920>>3];if(p!=0.0){r=e;s=q/p;t=g*s;u=o+t;v=r;w=v+8016|0;x=w;h[x>>3]=u;i=d;return}if(q==0.0){r=e;s=q;t=g*s;u=o+t;v=r;w=v+8016|0;x=w;h[x>>3]=u;i=d;return}y=q/+qXa(c[j>>2]|0,p,32896,37192,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[(c[c[k>>2]>>2]|0)+8>>2]|0;s=y;t=g*s;u=o+t;v=r;w=v+8016|0;x=w;h[x>>3]=u;i=d;return}function SK(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+8016>>3];h[b+8008>>3]=d*+h[(!(d>=0.0)?b+14776|0:b+14608|0)>>3];i=i;return}function TK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+344>>3],+h[a+336>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+344>>3];l=+h[g+336>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12360>>3]=+h[f>>3];i=b;return}function UK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8960>>3]=+h[b+13488>>3]*+h[b+12360>>3];i=i;return}function VK(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;WD(d,c[a+536>>2]|0,+h[f+12360>>3],+h[f+336>>3],+h[f+344>>3],1,1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5584>>3]=+h[d>>3];i=b;return}function WK(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;HD(d,c[a+536>>2]|0,+h[f+4784>>3],+h[(c[a+416>>2]|0)+808>>3],+h[f+5584>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5904>>3]=+h[d>>3];i=b;return}function XK(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12360>>3],+h[f+336>>3],+h[f+344>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5744>>3]=+h[d>>3];i=b;return}function YK(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12360>>3],+h[f+336>>3],+h[f+344>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+10992>>3]=+h[d>>3];i=b;return}function ZK(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0,y=0.0;d=i;i=i+8|0;e=d;f=b+304|0;g=+h[f>>3];j=b+536|0;k=b+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;m=b+416|0;n=c[m>>2]|0;JD(e,c[j>>2]|0,+h[l+7184>>3],+h[l+12360>>3],+h[l+12368>>3],+h[l+10992>>3],+h[l+11e3>>3],+h[n+488>>3],+h[l+13032>>3],+h[l+12704>>3]*+h[n+2904>>3],(+h[n+968>>3]+ +h[n+976>>3])*.5,+h[n+2896>>3]*.05,+h[n+2864>>3]);n=c[m>>2]|0;o=g*+h[e>>3]*+h[n+2840>>3];g=1.0- +h[f>>3];p=+h[n+2872>>3];f=c[c[k>>2]>>2]|0;e=c[f+8>>2]|0;q=+h[e+7184>>3]- +h[e+12704>>3]*+h[n+2904>>3]*+h[n+2920>>3];if(p!=0.0){r=e;s=q/p;t=g*s;u=o+t;v=r;w=v+8024|0;x=w;h[x>>3]=u;i=d;return}if(q==0.0){r=e;s=q;t=g*s;u=o+t;v=r;w=v+8024|0;x=w;h[x>>3]=u;i=d;return}y=q/+qXa(c[j>>2]|0,p,32896,37200,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[(c[c[k>>2]>>2]|0)+8>>2]|0;s=y;t=g*s;u=o+t;v=r;w=v+8024|0;x=w;h[x>>3]=u;i=d;return}function _K(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+656>>3]*+h[j+12368>>3]*+h[e+2736>>3];l=+h[j+8024>>3]+ +h[j+8016>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6392|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6392|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,37216,37208,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6392|0;r=q;h[r>>3]=o;i=d;return}function $K(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;GD(d,c[a+536>>2]|0,+h[f+6392>>3],+h[f+12368>>3],+h[f+5752>>3],+h[(c[a+416>>2]|0)+816>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6232>>3]=+h[d>>3];i=b;return}function aL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6392>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+6232>>3]));l=+h[j+6072>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?19.5:.5)*+h[m+496>>3];o=+h[m+816>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+qXa(c[b+536>>2]|0,n,37312,37304,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+5112>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function bL(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+5112>>3]+-.7;h[b+5272>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function cL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+Ad(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6232>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4952|0;w=v;h[w>>3]=n;i=b;return}x=c[72300]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=48728;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Pe[a&127](y,d,37392,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4952|0;w=v;h[w>>3]=n;i=b;return}function dL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6392>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4952>>3];l=+U(+(+h[j+6232>>3]));m=+h[j+6072>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?19.5:.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+496>>3];q=n*p;r=q!=0.0;s=+h[o+816>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+qXa(c[b+536>>2]|0,q,37312,37496,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+6072>>3];u=+h[j+4952>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5432|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+qXa(c[b+536>>2]|0,q,37312,37496,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+816>>3];M=+h[j+496>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+qXa(c[b+536>>2]|0,q,37312,37496,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5432|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+qXa(c[b+536>>2]|0,q,37312,37496,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4952>>3]*.125));L=P*(+W(+(+h[g+6072>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+qXa(c[b+536>>2]|0,L,37504,37496,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5432|0;K=J;h[K>>3]=B;i=d;return}}function eL(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+8328>>3]=+h[b+6392>>3]*+h[d+656>>3]*+h[d+2736>>3]*(+h[b+7184>>3]*.5+(+h[b+7192>>3]- +h[b+344>>3]/1.5)+66666.66666666667);i=i;return}function fL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8032>>3]=+h[b+8800>>3]+ +h[b+8024>>3];i=i;return}function gL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8040>>3]=+h[b+8792>>3]+ +h[b+8032>>3];i=i;return}function hL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8048>>3]=+h[b+8784>>3]+ +h[b+8040>>3];i=i;return}function iL(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+8048>>3];h[b+7976>>3]=d*+h[(!(d>=0.0)?b+9152|0:b+9160|0)>>3];i=i;return}function jL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8056>>3]=+h[b+8776>>3]+ +h[b+8048>>3];i=i;return}function kL(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+8056>>3];h[b+7968>>3]=d*+h[(!(d>=0.0)?b+9160|0:b+9168|0)>>3];i=i;return}function lL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8616>>3]=+h[b+7968>>3]- +h[b+7976>>3];i=i;return}function mL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+624>>3]*+h[j+12336>>3]*+h[e+2736>>3];l=+h[j+8056>>3]+ +h[j+8048>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6360|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6360|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,37640,37632,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6360|0;r=q;h[r>>3]=o;i=d;return}function nL(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+8296>>3]=+h[b+6360>>3]*+h[d+624>>3]*+h[d+2736>>3]*(+h[b+376>>3]*.5+(+h[b+408>>3]*-.5+(+h[b+7152>>3]+ +h[b+7160>>3])*.5));i=i;return}function oL(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;GD(d,c[a+536>>2]|0,+h[f+6360>>3],+h[f+12336>>3],+h[f+5720>>3],+h[(c[a+416>>2]|0)+784>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6200>>3]=+h[d>>3];i=b;return}function pL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6360>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+6200>>3]));l=+h[j+6040>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?15.5:4.5)*+h[m+464>>3];o=+h[m+784>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+qXa(c[b+536>>2]|0,n,37736,37728,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+5080>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function qL(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+5080>>3]+-.7;h[b+5240>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function rL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+Ad(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6200>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4920|0;w=v;h[w>>3]=n;i=b;return}x=c[72300]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=48728;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Pe[a&127](y,d,37816,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4920|0;w=v;h[w>>3]=n;i=b;return}function sL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6360>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4920>>3];l=+U(+(+h[j+6200>>3]));m=+h[j+6040>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?15.5:4.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+464>>3];q=n*p;r=q!=0.0;s=+h[o+784>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+qXa(c[b+536>>2]|0,q,37736,37920,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+6040>>3];u=+h[j+4920>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5400|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+qXa(c[b+536>>2]|0,q,37736,37920,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+784>>3];M=+h[j+464>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+qXa(c[b+536>>2]|0,q,37736,37920,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5400|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+qXa(c[b+536>>2]|0,q,37736,37920,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4920>>3]*.125));L=P*(+W(+(+h[g+6040>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+qXa(c[b+536>>2]|0,L,37928,37920,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5400|0;K=J;h[K>>3]=B;i=d;return}}function tL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8064>>3]=+h[b+8768>>3]+ +h[b+8056>>3];i=i;return}function uL(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+8064>>3];h[b+7960>>3]=d*+h[(!(d>=0.0)?b+9168|0:b+9176|0)>>3];i=i;return}function vL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8608>>3]=+h[b+7960>>3]- +h[b+7968>>3];i=i;return}function wL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8072>>3]=+h[b+8760>>3]+ +h[b+8064>>3];i=i;return}function xL(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+8072>>3];h[b+7952>>3]=d*+h[(!(d>=0.0)?b+9176|0:b+9184|0)>>3];i=i;return}function yL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8600>>3]=+h[b+7952>>3]- +h[b+7960>>3];i=i;return}function zL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8592>>3]=+h[b+7944>>3]- +h[b+7952>>3];i=i;return}function AL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+600>>3]*+h[j+12312>>3]*+h[e+2736>>3];l=+h[j+8080>>3]+ +h[j+8072>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6336|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6336|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,38064,38056,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6336|0;r=q;h[r>>3]=o;i=d;return}function BL(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+8272>>3]=+h[b+6336>>3]*+h[d+600>>3]*+h[d+2736>>3]*(+h[b+424>>3]*.5+(+h[b+456>>3]*-.5+(+h[b+7128>>3]+ +h[b+7136>>3])*.5));i=i;return}function CL(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;GD(d,c[a+536>>2]|0,+h[f+6336>>3],+h[f+12312>>3],+h[f+5696>>3],+h[(c[a+416>>2]|0)+760>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6176>>3]=+h[d>>3];i=b;return}function DL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+Ad(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6176>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4896|0;w=v;h[w>>3]=n;i=b;return}x=c[72300]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=48728;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Pe[a&127](y,d,38152,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4896|0;w=v;h[w>>3]=n;i=b;return}function EL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6336>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4896>>3];l=+U(+(+h[j+6176>>3]));m=+h[j+6016>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?12.5:7.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+440>>3];q=n*p;r=q!=0.0;s=+h[o+760>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+qXa(c[b+536>>2]|0,q,38264,38256,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+6016>>3];u=+h[j+4896>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5376|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+qXa(c[b+536>>2]|0,q,38264,38256,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+760>>3];M=+h[j+440>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+qXa(c[b+536>>2]|0,q,38264,38256,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5376|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+qXa(c[b+536>>2]|0,q,38264,38256,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4896>>3]*.125));L=P*(+W(+(+h[g+6016>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+qXa(c[b+536>>2]|0,L,38344,38256,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5376|0;K=J;h[K>>3]=B;i=d;return}}function FL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6336>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+6176>>3]));l=+h[j+6016>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?12.5:7.5)*+h[m+440>>3];o=+h[m+760>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+qXa(c[b+536>>2]|0,n,38264,38472,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+5056>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function GL(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+5056>>3]+-.7;h[b+5216>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function HL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+608>>3]*+h[j+12320>>3]*+h[e+2736>>3];l=+h[j+8072>>3]+ +h[j+8064>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6344|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6344|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,38488,38480,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6344|0;r=q;h[r>>3]=o;i=d;return}function IL(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+8280>>3]=+h[b+6344>>3]*+h[d+608>>3]*+h[d+2736>>3]*(+h[b+408>>3]*.5+(+h[b+440>>3]*-.5+(+h[b+7136>>3]+ +h[b+7144>>3])*.5));i=i;return}function JL(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;GD(d,c[a+536>>2]|0,+h[f+6344>>3],+h[f+12320>>3],+h[f+5704>>3],+h[(c[a+416>>2]|0)+768>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6184>>3]=+h[d>>3];i=b;return}function KL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+Ad(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6184>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4904|0;w=v;h[w>>3]=n;i=b;return}x=c[72300]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=48728;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Pe[a&127](y,d,38576,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4904|0;w=v;h[w>>3]=n;i=b;return}function LL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6344>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4904>>3];l=+U(+(+h[j+6184>>3]));m=+h[j+6024>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?13.5:6.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+448>>3];q=n*p;r=q!=0.0;s=+h[o+768>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+qXa(c[b+536>>2]|0,q,38688,38680,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+6024>>3];u=+h[j+4904>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5384|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+qXa(c[b+536>>2]|0,q,38688,38680,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+768>>3];M=+h[j+448>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+qXa(c[b+536>>2]|0,q,38688,38680,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5384|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+qXa(c[b+536>>2]|0,q,38688,38680,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4904>>3]*.125));L=P*(+W(+(+h[g+6024>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+qXa(c[b+536>>2]|0,L,38768,38680,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5384|0;K=J;h[K>>3]=B;i=d;return}}function ML(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6344>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+6184>>3]));l=+h[j+6024>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?13.5:6.5)*+h[m+448>>3];o=+h[m+768>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+qXa(c[b+536>>2]|0,n,38688,38896,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+5064>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function NL(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+5064>>3]+-.7;h[b+5224>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function OL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+616>>3]*+h[j+12328>>3]*+h[e+2736>>3];l=+h[j+8064>>3]+ +h[j+8056>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6352|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6352|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,38912,38904,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6352|0;r=q;h[r>>3]=o;i=d;return}function PL(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;GD(d,c[a+536>>2]|0,+h[f+6352>>3],+h[f+12328>>3],+h[f+5712>>3],+h[(c[a+416>>2]|0)+776>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6192>>3]=+h[d>>3];i=b;return}function QL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6352>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+6192>>3]));l=+h[j+6032>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?14.5:5.5)*+h[m+456>>3];o=+h[m+776>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+qXa(c[b+536>>2]|0,n,39008,39e3,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+5072>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function RL(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+5072>>3]+-.7;h[b+5232>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function SL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+Ad(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6192>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4912|0;w=v;h[w>>3]=n;i=b;return}x=c[72300]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=48728;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Pe[a&127](y,d,39088,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4912|0;w=v;h[w>>3]=n;i=b;return}function TL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6352>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4912>>3];l=+U(+(+h[j+6192>>3]));m=+h[j+6032>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?14.5:5.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+456>>3];q=n*p;r=q!=0.0;s=+h[o+776>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+qXa(c[b+536>>2]|0,q,39008,39192,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+6032>>3];u=+h[j+4912>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5392|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+qXa(c[b+536>>2]|0,q,39008,39192,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+776>>3];M=+h[j+456>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+qXa(c[b+536>>2]|0,q,39008,39192,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5392|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+qXa(c[b+536>>2]|0,q,39008,39192,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4912>>3]*.125));L=P*(+W(+(+h[g+6032>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+qXa(c[b+536>>2]|0,L,39200,39192,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5392|0;K=J;h[K>>3]=B;i=d;return}}function UL(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+8288>>3]=+h[b+6352>>3]*+h[d+616>>3]*+h[d+2736>>3]*(+h[b+392>>3]*.5+(+h[b+424>>3]*-.5+(+h[b+7144>>3]+ +h[b+7152>>3])*.5));i=i;return}function VL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+632>>3]*+h[j+12344>>3]*+h[e+2736>>3];l=+h[j+8048>>3]+ +h[j+8040>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6368|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6368|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,39336,39328,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6368|0;r=q;h[r>>3]=o;i=d;return}function WL(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+8304>>3]=+h[b+6368>>3]*+h[d+632>>3]*+h[d+2736>>3]*(+h[b+360>>3]*.5+(+h[b+392>>3]*-.5+(+h[b+7160>>3]+ +h[b+7168>>3])*.5));i=i;return}function XL(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;GD(d,c[a+536>>2]|0,+h[f+6368>>3],+h[f+12344>>3],+h[f+5728>>3],+h[(c[a+416>>2]|0)+792>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6208>>3]=+h[d>>3];i=b;return}function YL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6368>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+6208>>3]));l=+h[j+6048>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?16.5:3.5)*+h[m+472>>3];o=+h[m+792>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+qXa(c[b+536>>2]|0,n,39432,39424,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+5088>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function ZL(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+5088>>3]+-.7;h[b+5248>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function _L(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+Ad(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6208>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4928|0;w=v;h[w>>3]=n;i=b;return}x=c[72300]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=48728;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Pe[a&127](y,d,39512,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4928|0;w=v;h[w>>3]=n;i=b;return}function $L(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6368>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4928>>3];l=+U(+(+h[j+6208>>3]));m=+h[j+6048>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?16.5:3.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+472>>3];q=n*p;r=q!=0.0;s=+h[o+792>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+qXa(c[b+536>>2]|0,q,39432,39616,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+6048>>3];u=+h[j+4928>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5408|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+qXa(c[b+536>>2]|0,q,39432,39616,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+792>>3];M=+h[j+472>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+qXa(c[b+536>>2]|0,q,39432,39616,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5408|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+qXa(c[b+536>>2]|0,q,39432,39616,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4928>>3]*.125));L=P*(+W(+(+h[g+6048>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+qXa(c[b+536>>2]|0,L,39624,39616,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5408|0;K=J;h[K>>3]=B;i=d;return}}function aM(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+648>>3]*+h[j+12360>>3]*+h[e+2736>>3];l=+h[j+8032>>3]+ +h[j+8024>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6384|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6384|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,39760,39752,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6384|0;r=q;h[r>>3]=o;i=d;return}function bM(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;GD(d,c[a+536>>2]|0,+h[f+6384>>3],+h[f+12360>>3],+h[f+5744>>3],+h[(c[a+416>>2]|0)+808>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6224>>3]=+h[d>>3];i=b;return}function cM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+Ad(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6224>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4944|0;w=v;h[w>>3]=n;i=b;return}x=c[72300]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=48728;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Pe[a&127](y,d,39848,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4944|0;w=v;h[w>>3]=n;i=b;return}function dM(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+12360>>3];k=+h[g+10376>>3];l=j*j;m=+h[g+344>>3]*+h[g+10528>>3]-j*+h[g+1144>>3];if(l!=0.0){n=g;o=m/l;p=k+o;q=n;r=q+9744|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=k+o;q=n;r=q+9744|0;s=r;h[s>>3]=p;i=d;return}j=m/+qXa(c[b+536>>2]|0,l,39960,39952,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=k+o;q=n;r=q+9744|0;s=r;h[s>>3]=p;i=d;return}function eM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+344>>3],+h[a+336>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+344>>3];l=+h[g+336>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+9136>>3]=+h[f>>3];i=b;return}function fM(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9136>>3];k=+h[g+12360>>3];l=+h[g+344>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,40008,4e4,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6456>>3]=j-n;i=d;return}function gM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10064>>3]=+h[b+8960>>3]*+h[b+9744>>3]+ +h[b+8800>>3]*+h[b+6456>>3];i=i;return}function hM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+88|0;d=b;e=b+40|0;f=b+80|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ID(e,c[g>>2]|0,1,+h[a+9136>>3],+h[a+12360>>3],+h[a+336>>3],+h[a+344>>3]);a=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+40|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));SD(f,a,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+6064>>3]=+h[f>>3];i=b;return}function iM(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6384>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4944>>3];l=+U(+(+h[j+6224>>3]));m=+h[j+6064>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?18.5:1.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+488>>3];q=n*p;r=q!=0.0;s=+h[o+808>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+qXa(c[b+536>>2]|0,q,40048,40040,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+6064>>3];u=+h[j+4944>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5424|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+qXa(c[b+536>>2]|0,q,40048,40040,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+808>>3];M=+h[j+488>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+qXa(c[b+536>>2]|0,q,40048,40040,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5424|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+qXa(c[b+536>>2]|0,q,40048,40040,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4944>>3]*.125));L=P*(+W(+(+h[g+6064>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+qXa(c[b+536>>2]|0,L,40128,40040,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5424|0;K=J;h[K>>3]=B;i=d;return}}function jM(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6384>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+6224>>3]));l=+h[j+6064>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?18.5:1.5)*+h[m+488>>3];o=+h[m+808>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+qXa(c[b+536>>2]|0,n,40048,40256,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+5104>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function kM(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+5104>>3]+-.7;h[b+5264>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function lM(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+8024>>3];h[b+8e3>>3]=d*+h[(!(d>=0.0)?b+14608|0:b+9136|0)>>3];i=i;return}function mM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8648>>3]=+h[b+8e3>>3]- +h[b+8008>>3];i=i;return}function nM(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7336>>3]=(+h[b+640>>3]+ +h[b+648>>3])*(+h[d+344>>3]- +h[d+360>>3])*+h[b+2840>>3]*.5;i=i;return}function oM(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2840>>3]*(+h[e+640>>3]+ +h[e+648>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7336>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+7176|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+7176|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,40272,40264,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+7176|0;q=p;h[q>>3]=n;i=d;return}function pM(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+8320>>3]=+h[b+6384>>3]*+h[d+648>>3]*+h[d+2736>>3]*(+h[b+328>>3]*.5+(+h[b+360>>3]*-.5+(+h[b+7176>>3]+ +h[b+7184>>3])*.5));i=i;return}function qM(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2704>>3];g=b+4|0;j=c[c[g>>2]>>2]|0;k=c[j+8>>2]|0;l=+h[k+9416>>3]- +h[k+776>>3];m=+h[e+2672>>3];n=+h[e+2680>>3];do{if(m!=0.0){o=k;p=n/m}else{if(n==0.0){o=k;p=n;break}q=n/+qXa(c[b+536>>2]|0,m,40376,40368,+h[j>>3],(a[b+319|0]|0)!=0|0);o=c[(c[c[g>>2]>>2]|0)+8>>2]|0;p=q}}while(0);h[o+3712>>3]=f*l*p*-.05;i=d;return}function rM(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+8472>>3]=-(+h[b+2696>>3]*+h[b+136>>3]*+h[d+1576>>3])- +h[d+3712>>3];i=i;return}function sM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+360>>3],+h[a+352>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+360>>3];l=+h[g+352>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12352>>3]=+h[f>>3];i=b;return}function tM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8952>>3]=+h[b+13480>>3]*+h[b+12352>>3];i=i;return}function uM(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;WD(d,c[a+536>>2]|0,+h[f+12352>>3],+h[f+352>>3],+h[f+360>>3],1,1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5576>>3]=+h[d>>3];i=b;return}function vM(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;HD(d,c[a+536>>2]|0,+h[f+4776>>3],+h[(c[a+416>>2]|0)+800>>3],+h[f+5576>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5896>>3]=+h[d>>3];i=b;return}function wM(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12352>>3],+h[f+352>>3],+h[f+360>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5736>>3]=+h[d>>3];i=b;return}function xM(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12352>>3],+h[f+352>>3],+h[f+360>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+10984>>3]=+h[d>>3];i=b;return}function yM(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+640>>3]*+h[j+12352>>3]*+h[e+2736>>3];l=+h[j+8040>>3]+ +h[j+8032>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6376|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6376|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,40400,40392,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6376|0;r=q;h[r>>3]=o;i=d;return}function zM(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;GD(d,c[a+536>>2]|0,+h[f+6376>>3],+h[f+12352>>3],+h[f+5736>>3],+h[(c[a+416>>2]|0)+800>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6216>>3]=+h[d>>3];i=b;return}function AM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+Ad(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6216>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4936|0;w=v;h[w>>3]=n;i=b;return}x=c[72300]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=48728;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Pe[a&127](y,d,40488,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4936|0;w=v;h[w>>3]=n;i=b;return}function BM(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+8312>>3]=+h[b+6376>>3]*+h[d+640>>3]*+h[d+2736>>3]*(+h[b+344>>3]*.5+(+h[b+376>>3]*-.5+(+h[b+7168>>3]+ +h[b+7176>>3])*.5));i=i;return}function CM(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+12352>>3];k=+h[g+10368>>3];l=j*j;m=+h[g+360>>3]*+h[g+10520>>3]-j*+h[g+1160>>3];if(l!=0.0){n=g;o=m/l;p=k+o;q=n;r=q+9736|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=k+o;q=n;r=q+9736|0;s=r;h[s>>3]=p;i=d;return}j=m/+qXa(c[b+536>>2]|0,l,40600,40592,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=k+o;q=n;r=q+9736|0;s=r;h[s>>3]=p;i=d;return}function DM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+360>>3],+h[a+352>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+360>>3];l=+h[g+352>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+9144>>3]=+h[f>>3];i=b;return}function EM(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9144>>3];k=+h[g+12352>>3];l=+h[g+360>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,40648,40640,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6488>>3]=j-n;i=d;return}function FM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10056>>3]=+h[b+8952>>3]*+h[b+9736>>3]+ +h[b+8792>>3]*+h[b+6488>>3];i=i;return}function GM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+88|0;d=b;e=b+40|0;f=b+80|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ID(e,c[g>>2]|0,1,+h[a+9144>>3],+h[a+12352>>3],+h[a+352>>3],+h[a+360>>3]);a=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+40|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));SD(f,a,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+6056>>3]=+h[f>>3];i=b;return}function HM(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6376>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4936>>3];l=+U(+(+h[j+6216>>3]));m=+h[j+6056>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?17.5:2.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+480>>3];q=n*p;r=q!=0.0;s=+h[o+800>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+qXa(c[b+536>>2]|0,q,40688,40680,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+6056>>3];u=+h[j+4936>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5416|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+qXa(c[b+536>>2]|0,q,40688,40680,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+800>>3];M=+h[j+480>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+qXa(c[b+536>>2]|0,q,40688,40680,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5416|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+qXa(c[b+536>>2]|0,q,40688,40680,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4936>>3]*.125));L=P*(+W(+(+h[g+6056>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+qXa(c[b+536>>2]|0,L,40768,40680,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5416|0;K=J;h[K>>3]=B;i=d;return}}function IM(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6376>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+6216>>3]));l=+h[j+6056>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?17.5:2.5)*+h[m+480>>3];o=+h[m+800>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+qXa(c[b+536>>2]|0,n,40688,40896,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+5096>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function JM(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+5096>>3]+-.7;h[b+5256>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function KM(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+8040>>3];h[b+7984>>3]=d*+h[(!(d>=0.0)?b+9144|0:b+9152|0)>>3];i=i;return}function LM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8624>>3]=+h[b+7976>>3]- +h[b+7984>>3];i=i;return}function MM(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+8032>>3];h[b+7992>>3]=d*+h[(!(d>=0.0)?b+9136|0:b+9144|0)>>3];i=i;return}function NM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8632>>3]=+h[b+7984>>3]- +h[b+7992>>3];i=i;return}function OM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8640>>3]=+h[b+7992>>3]- +h[b+8e3>>3];i=i;return}function PM(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3704>>3]=+h[b+3184>>3]*+h[d+14152>>3]*(+h[d+9424>>3]- +h[d+288>>3])*+h[b+3176>>3];i=i;return}function QM(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+8480>>3]=-(+h[b+2696>>3]*+h[b+144>>3]*+h[d+1584>>3])- +h[d+3704>>3];i=i;return}function RM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+296>>3],+h[a+288>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+296>>3];l=+h[g+288>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12408>>3]=+h[f>>3];i=b;return}function SM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4184>>3]=+h[b+13992>>3]*+h[b+12408>>3];i=i;return}function TM(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+12408>>3];k=+h[g+10544>>3];l=j*j;m=+h[g+296>>3]*+h[g+10696>>3]-j*+h[g+1096>>3];if(l!=0.0){n=g;o=m/l;p=k+o;q=n;r=q+9768|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=k+o;q=n;r=q+9768|0;s=r;h[s>>3]=p;i=d;return}j=m/+qXa(c[b+536>>2]|0,l,40912,40904,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=k+o;q=n;r=q+9768|0;s=r;h[s>>3]=p;i=d;return}function UM(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12408>>3],+h[f+288>>3],+h[f+296>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11032>>3]=+h[d>>3];i=b;return}function VM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+280>>3],+h[a+272>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+280>>3];l=+h[g+272>>3];m=+h[g+1080>>3];n=+h[g+1072>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));bF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10552>>3]=+h[f>>3];i=b;return}function WM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+280>>3],+h[a+272>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+280>>3];l=+h[g+272>>3];m=+h[g+1080>>3];n=+h[g+1072>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));fF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10704>>3]=+h[f>>3];i=b;return}function XM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4032>>3]=+h[b+14e3>>3]*+h[b+10704>>3];i=i;return}function YM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+264>>3],+h[a+256>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+264>>3];l=+h[g+256>>3];m=+h[g+1064>>3];n=+h[g+1056>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));bF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10560>>3]=+h[f>>3];i=b;return}function ZM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+264>>3],+h[a+256>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+264>>3];l=+h[g+256>>3];m=+h[g+1064>>3];n=+h[g+1056>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));fF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10712>>3]=+h[f>>3];i=b;return}function _M(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4040>>3]=+h[b+14008>>3]*+h[b+10712>>3];i=i;return}function $M(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2584>>3]=(+h[b+1648>>3]+ +h[b+1656>>3])*(+h[d+264>>3]- +h[d+280>>3])*+h[b+3072>>3]*.5;i=i;return}function aN(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3072>>3]*(+h[e+1648>>3]+ +h[e+1656>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2584>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+2424|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+2424|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,40960,40952,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+2424|0;q=p;h[q>>3]=n;i=d;return}function bN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+248>>3],+h[a+240>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+248>>3];l=+h[g+240>>3];m=+h[g+1048>>3];n=+h[g+1040>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));bF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10568>>3]=+h[f>>3];i=b;return}function cN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+248>>3],+h[a+240>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+248>>3];l=+h[g+240>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12432>>3]=+h[f>>3];i=b;return}function dN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4208>>3]=+h[b+14016>>3]*+h[b+12432>>3];i=i;return}function eN(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12432>>3],+h[f+240>>3],+h[f+248>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11056>>3]=+h[d>>3];i=b;return}function fN(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2592>>3]=(+h[b+1656>>3]+ +h[b+1664>>3])*(+h[d+248>>3]- +h[d+264>>3])*+h[b+3072>>3]*.5;i=i;return}function gN(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3072>>3]*(+h[e+1656>>3]+ +h[e+1664>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2592>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+2432|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+2432|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,41056,41048,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+2432|0;q=p;h[q>>3]=n;i=d;return}function hN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+264>>3],+h[a+256>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+264>>3];l=+h[g+256>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12424>>3]=+h[f>>3];i=b;return}function iN(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+12424>>3];k=+h[g+10560>>3];l=j*j;m=+h[g+264>>3]*+h[g+10712>>3]-j*+h[g+1064>>3];if(l!=0.0){n=g;o=m/l;p=k+o;q=n;r=q+9784|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=k+o;q=n;r=q+9784|0;s=r;h[s>>3]=p;i=d;return}j=m/+qXa(c[b+536>>2]|0,l,41152,41144,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=k+o;q=n;r=q+9784|0;s=r;h[s>>3]=p;i=d;return}function jN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4200>>3]=+h[b+14008>>3]*+h[b+12424>>3];i=i;return}function kN(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12424>>3],+h[f+256>>3],+h[f+264>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11048>>3]=+h[d>>3];i=b;return}function lN(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0,y=0.0;d=i;i=i+8|0;e=d;f=b+304|0;g=+h[f>>3];j=b+536|0;k=b+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;m=b+416|0;n=c[m>>2]|0;JD(e,c[j>>2]|0,+h[l+2432>>3],+h[l+12424>>3],+h[l+12432>>3],+h[l+11048>>3],+h[l+11056>>3],+h[n+1504>>3],+h[l+13e3>>3],+h[l+12752>>3]*+h[n+3136>>3],(+h[n+1976>>3]+ +h[n+1984>>3])*.5,+h[n+3128>>3]*.05,+h[n+3096>>3]);n=c[m>>2]|0;o=g*+h[e>>3]*+h[n+3072>>3];g=1.0- +h[f>>3];p=+h[n+3104>>3];f=c[c[k>>2]>>2]|0;e=c[f+8>>2]|0;q=+h[e+2432>>3]- +h[e+12752>>3]*+h[n+3136>>3]*+h[n+3152>>3];if(p!=0.0){r=e;s=q/p;t=g*s;u=o+t;v=r;w=v+3496|0;x=w;h[x>>3]=u;i=d;return}if(q==0.0){r=e;s=q;t=g*s;u=o+t;v=r;w=v+3496|0;x=w;h[x>>3]=u;i=d;return}y=q/+qXa(c[j>>2]|0,p,36984,41192,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[(c[c[k>>2]>>2]|0)+8>>2]|0;s=y;t=g*s;u=o+t;v=r;w=v+3496|0;x=w;h[x>>3]=u;i=d;return}function mN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3504>>3]=+h[b+4040>>3]+ +h[b+3496>>3];i=i;return}function nN(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1656>>3]*+h[j+12424>>3]*+h[e+2968>>3];l=+h[j+3504>>3]+ +h[j+3496>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1624|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1624|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,41208,41200,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1624|0;r=q;h[r>>3]=o;i=d;return}function oN(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3560>>3]=+h[b+1624>>3]*+h[d+1656>>3]*+h[d+2968>>3]*(+h[b+248>>3]*.5+(+h[b+280>>3]*-.5+(+h[b+2424>>3]+ +h[b+2432>>3])*.5));i=i;return}function pN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+280>>3],+h[a+272>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+280>>3];l=+h[g+272>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12416>>3]=+h[f>>3];i=b;return}function qN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4192>>3]=+h[b+14e3>>3]*+h[b+12416>>3];i=i;return}function rN(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+12416>>3];k=+h[g+10552>>3];l=j*j;m=+h[g+280>>3]*+h[g+10704>>3]-j*+h[g+1080>>3];if(l!=0.0){n=g;o=m/l;p=k+o;q=n;r=q+9776|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=k+o;q=n;r=q+9776|0;s=r;h[s>>3]=p;i=d;return}j=m/+qXa(c[b+536>>2]|0,l,41296,41288,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=k+o;q=n;r=q+9776|0;s=r;h[s>>3]=p;i=d;return}function sN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+280>>3],+h[a+272>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+280>>3];l=+h[g+272>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4624>>3]=+h[f>>3];i=b;return}function tN(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4624>>3];k=+h[g+12416>>3];l=+h[g+280>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,41344,41336,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+2328>>3]=j-n;i=d;return}function uN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10096>>3]=+h[b+4192>>3]*+h[b+9776>>3]+ +h[b+4032>>3]*+h[b+2328>>3];i=i;return}function vN(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12416>>3],+h[f+272>>3],+h[f+280>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11040>>3]=+h[d>>3];i=b;return}function wN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+296>>3],+h[a+288>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+296>>3];l=+h[g+288>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4632>>3]=+h[f>>3];i=b;return}function xN(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4632>>3];k=+h[g+12408>>3];l=+h[g+296>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,41384,41376,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+2360>>3]=j-n;i=d;return}function yN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10088>>3]=+h[b+4184>>3]*+h[b+9768>>3]+ +h[b+4024>>3]*+h[b+2360>>3];i=i;return}function zN(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2576>>3]=(+h[b+1640>>3]+ +h[b+1648>>3])*(+h[d+280>>3]- +h[d+296>>3])*+h[b+3072>>3]*.5;i=i;return}function AN(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3072>>3]*(+h[e+1640>>3]+ +h[e+1648>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2576>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+2416|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+2416|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,41424,41416,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+2416|0;q=p;h[q>>3]=n;i=d;return}function BN(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0,y=0.0;d=i;i=i+8|0;e=d;f=b+304|0;g=+h[f>>3];j=b+536|0;k=b+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;m=b+416|0;n=c[m>>2]|0;JD(e,c[j>>2]|0,+h[l+2416>>3],+h[l+12408>>3],+h[l+12416>>3],+h[l+11032>>3],+h[l+11040>>3],+h[n+1488>>3],+h[l+13016>>3],+h[l+12736>>3]*+h[n+3136>>3],(+h[n+1960>>3]+ +h[n+1968>>3])*.5,+h[n+3128>>3]*.05,+h[n+3096>>3]);n=c[m>>2]|0;o=g*+h[e>>3]*+h[n+3072>>3];g=1.0- +h[f>>3];p=+h[n+3104>>3];f=c[c[k>>2]>>2]|0;e=c[f+8>>2]|0;q=+h[e+2416>>3]- +h[e+12736>>3]*+h[n+3136>>3]*+h[n+3152>>3];if(p!=0.0){r=e;s=q/p;t=g*s;u=o+t;v=r;w=v+3512|0;x=w;h[x>>3]=u;i=d;return}if(q==0.0){r=e;s=q;t=g*s;u=o+t;v=r;w=v+3512|0;x=w;h[x>>3]=u;i=d;return}y=q/+qXa(c[j>>2]|0,p,36984,41512,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[(c[c[k>>2]>>2]|0)+8>>2]|0;s=y;t=g*s;u=o+t;v=r;w=v+3512|0;x=w;h[x>>3]=u;i=d;return}function CN(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3512>>3];h[b+3224>>3]=d*+h[(!(d>=0.0)?b+4624|0:b+4632|0)>>3];i=i;return}function DN(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1648>>3]*+h[j+12416>>3]*+h[e+2968>>3];l=+h[j+3512>>3]+ +h[j+3504>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1616|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1616|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,41528,41520,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1616|0;r=q;h[r>>3]=o;i=d;return}function EN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3520>>3]=+h[b+4024>>3]+ +h[b+3512>>3];i=i;return}function FN(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1640>>3]*+h[j+12408>>3]*+h[e+2968>>3];l=+h[j+3520>>3]+ +h[j+3512>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1608|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1608|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,41616,41608,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1608|0;r=q;h[r>>3]=o;i=d;return}function GN(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3520>>3];h[b+3216>>3]=d*+h[(!(d>=0.0)?b+4632|0:b+14584|0)>>3];i=i;return}function HN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3864>>3]=+h[b+3216>>3]- +h[b+3224>>3];i=i;return}function IN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3856>>3]=+h[b+3208>>3]- +h[b+3216>>3];i=i;return}function JN(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1632>>3]*+h[j+12400>>3]*+h[e+2968>>3];l=+h[j+3528>>3]+ +h[j+3520>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1600|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1600|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,41704,41696,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1600|0;r=q;h[r>>3]=o;i=d;return}function KN(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3536>>3]=+h[b+1600>>3]*+h[d+1632>>3]*+h[d+2968>>3]*(+h[b+296>>3]/1.5+(+h[b+2400>>3]+ +h[b+2408>>3]*.5)+-66666.66666666667);i=i;return}function LN(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3544>>3]=+h[b+1608>>3]*+h[d+1640>>3]*+h[d+2968>>3]*(+h[b+280>>3]*.5+(+h[b+312>>3]*-.5+(+h[b+2408>>3]+ +h[b+2416>>3])*.5));i=i;return}function MN(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3552>>3]=+h[b+1616>>3]*+h[d+1648>>3]*+h[d+2968>>3]*(+h[b+264>>3]*.5+(+h[b+296>>3]*-.5+(+h[b+2416>>3]+ +h[b+2424>>3])*.5));i=i;return}function NN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+264>>3],+h[a+256>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+264>>3];l=+h[g+256>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4616>>3]=+h[f>>3];i=b;return}function ON(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4616>>3];k=+h[g+12424>>3];l=+h[g+264>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,41792,41784,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+2296>>3]=j-n;i=d;return}function PN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10104>>3]=+h[b+4200>>3]*+h[b+9784>>3]+ +h[b+4040>>3]*+h[b+2296>>3];i=i;return}function QN(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3720>>3]=+h[b+3184>>3]*+h[d+14168>>3]*(+h[d+9408>>3]- +h[d+256>>3])*+h[b+3176>>3];i=i;return}function RN(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+8464>>3]=-(+h[b+2696>>3]*+h[b+128>>3]*+h[d+1568>>3])- +h[d+3720>>3];i=i;return}function SN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3880>>3]=+h[b+10104>>3]+(-+h[b+3560>>3]- +h[b+3720>>3]);i=i;return}function TN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+248>>3],+h[a+240>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+248>>3];l=+h[g+240>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4608>>3]=+h[f>>3];i=b;return}function UN(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4608>>3];k=+h[g+12432>>3];l=+h[g+248>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,41832,41824,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+2264>>3]=j-n;i=d;return}function VN(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3496>>3];h[b+3240>>3]=d*+h[(!(d>=0.0)?b+4608|0:b+4616|0)>>3];i=i;return}function WN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3232>>3]=+h[b+3880>>3]+ +h[b+3240>>3];i=i;return}function XN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3872>>3]=+h[b+3224>>3]- +h[b+3232>>3];i=i;return}function YN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+248>>3],+h[a+240>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+248>>3];l=+h[g+240>>3];m=+h[g+1048>>3];n=+h[g+1040>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));fF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10720>>3]=+h[f>>3];i=b;return}function ZN(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+12432>>3];k=+h[g+10568>>3];l=j*j;m=+h[g+248>>3]*+h[g+10720>>3]-j*+h[g+1048>>3];if(l!=0.0){n=g;o=m/l;p=k+o;q=n;r=q+9792|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=k+o;q=n;r=q+9792|0;s=r;h[s>>3]=p;i=d;return}j=m/+qXa(c[b+536>>2]|0,l,41872,41864,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=k+o;q=n;r=q+9792|0;s=r;h[s>>3]=p;i=d;return}function _N(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4048>>3]=+h[b+14016>>3]*+h[b+10720>>3];i=i;return}function $N(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+232>>3],+h[a+224>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+232>>3];l=+h[g+224>>3];m=+h[g+1032>>3];n=+h[g+1024>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));bF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10576>>3]=+h[f>>3];i=b;return}function aO(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2600>>3]=(+h[b+1664>>3]+ +h[b+1672>>3])*(+h[d+232>>3]- +h[d+248>>3])*+h[b+3072>>3]*.5;i=i;return}function bO(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3072>>3]*(+h[e+1664>>3]+ +h[e+1672>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2600>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+2440|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+2440|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,41920,41912,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+2440|0;q=p;h[q>>3]=n;i=d;return}function cO(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2608>>3]=(+h[b+1672>>3]+ +h[b+1680>>3])*(+h[d+216>>3]- +h[d+232>>3])*+h[b+3072>>3]*.5;i=i;return}function dO(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3072>>3]*(+h[e+1672>>3]+ +h[e+1680>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2608>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+2448|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+2448|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,42016,42008,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+2448|0;q=p;h[q>>3]=n;i=d;return}function eO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+232>>3],+h[a+224>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+232>>3];l=+h[g+224>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12440>>3]=+h[f>>3];i=b;return}function fO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4216>>3]=+h[b+14024>>3]*+h[b+12440>>3];i=i;return}function gO(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12440>>3],+h[f+224>>3],+h[f+232>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11064>>3]=+h[d>>3];i=b;return}function hO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10112>>3]=+h[b+4208>>3]*+h[b+9792>>3]+ +h[b+4048>>3]*+h[b+2264>>3];i=i;return}function iO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+232>>3],+h[a+224>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+232>>3];l=+h[g+224>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4600>>3]=+h[f>>3];i=b;return}function jO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4600>>3];k=+h[g+12440>>3];l=+h[g+232>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,42112,42104,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+2232>>3]=j-n;i=d;return}function kO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+232>>3],+h[a+224>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+232>>3];l=+h[g+224>>3];m=+h[g+1032>>3];n=+h[g+1024>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));fF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10728>>3]=+h[f>>3];i=b;return}function lO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+12440>>3];k=+h[g+10576>>3];l=j*j;m=+h[g+232>>3]*+h[g+10728>>3]-j*+h[g+1032>>3];if(l!=0.0){n=g;o=m/l;p=k+o;q=n;r=q+9800|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=k+o;q=n;r=q+9800|0;s=r;h[s>>3]=p;i=d;return}j=m/+qXa(c[b+536>>2]|0,l,42152,42144,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=k+o;q=n;r=q+9800|0;s=r;h[s>>3]=p;i=d;return}function mO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4056>>3]=+h[b+14024>>3]*+h[b+10728>>3];i=i;return}function nO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10120>>3]=+h[b+4216>>3]*+h[b+9800>>3]+ +h[b+4056>>3]*+h[b+2232>>3];i=i;return}function oO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+200>>3],+h[a+192>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+200>>3];l=+h[g+192>>3];m=+h[g+1e3>>3];n=+h[g+992>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));bF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10592>>3]=+h[f>>3];i=b;return}function pO(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2616>>3]=(+h[b+1680>>3]+ +h[b+1688>>3])*(+h[d+200>>3]- +h[d+216>>3])*+h[b+3072>>3]*.5;i=i;return}function qO(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3072>>3]*(+h[e+1680>>3]+ +h[e+1688>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2616>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+2456|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+2456|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,42200,42192,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+2456|0;q=p;h[q>>3]=n;i=d;return}function rO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+200>>3],+h[a+192>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+200>>3];l=+h[g+192>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12456>>3]=+h[f>>3];i=b;return}function sO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4232>>3]=+h[b+14040>>3]*+h[b+12456>>3];i=i;return}function tO(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12456>>3],+h[f+192>>3],+h[f+200>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11080>>3]=+h[d>>3];i=b;return}function uO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+216>>3],+h[a+208>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+216>>3];l=+h[g+208>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4592>>3]=+h[f>>3];i=b;return}function vO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+216>>3],+h[a+208>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+216>>3];l=+h[g+208>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12448>>3]=+h[f>>3];i=b;return}function wO(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12448>>3],+h[f+208>>3],+h[f+216>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11072>>3]=+h[d>>3];i=b;return}function xO(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0,y=0.0;d=i;i=i+8|0;e=d;f=b+304|0;g=+h[f>>3];j=b+536|0;k=b+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;m=b+416|0;n=c[m>>2]|0;JD(e,c[j>>2]|0,+h[l+2456>>3],+h[l+12448>>3],+h[l+12456>>3],+h[l+11072>>3],+h[l+11080>>3],+h[n+1528>>3],+h[l+12976>>3],+h[l+12776>>3]*+h[n+3136>>3],(+h[n+2e3>>3]+ +h[n+2008>>3])*.5,+h[n+3128>>3]*.05,+h[n+3096>>3]);n=c[m>>2]|0;o=g*+h[e>>3]*+h[n+3072>>3];g=1.0- +h[f>>3];p=+h[n+3104>>3];f=c[c[k>>2]>>2]|0;e=c[f+8>>2]|0;q=+h[e+2456>>3]- +h[e+12776>>3]*+h[n+3136>>3]*+h[n+3152>>3];if(p!=0.0){r=e;s=q/p;t=g*s;u=o+t;v=r;w=v+3472|0;x=w;h[x>>3]=u;i=d;return}if(q==0.0){r=e;s=q;t=g*s;u=o+t;v=r;w=v+3472|0;x=w;h[x>>3]=u;i=d;return}y=q/+qXa(c[j>>2]|0,p,36984,42288,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[(c[c[k>>2]>>2]|0)+8>>2]|0;s=y;t=g*s;u=o+t;v=r;w=v+3472|0;x=w;h[x>>3]=u;i=d;return}function yO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3480>>3]=+h[b+4064>>3]+ +h[b+3472>>3];i=i;return}function zO(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3480>>3];h[b+3256>>3]=d*+h[(!(d>=0.0)?b+4592|0:b+4600|0)>>3];i=i;return}function AO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3488>>3]=+h[b+4056>>3]+ +h[b+3480>>3];i=i;return}function BO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1672>>3]*+h[j+12440>>3]*+h[e+2968>>3];l=+h[j+3488>>3]+ +h[j+3480>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1640|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1640|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,42304,42296,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1640|0;r=q;h[r>>3]=o;i=d;return}function CO(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3576>>3]=+h[b+1640>>3]*+h[d+1672>>3]*+h[d+2968>>3]*(+h[b+216>>3]*.5+(+h[b+248>>3]*-.5+(+h[b+2440>>3]+ +h[b+2448>>3])*.5));i=i;return}function DO(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3488>>3];h[b+3248>>3]=d*+h[(!(d>=0.0)?b+4600|0:b+4608|0)>>3];i=i;return}function EO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3896>>3]=+h[b+3248>>3]- +h[b+3256>>3];i=i;return}function FO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3736>>3]=+h[b+10120>>3]+(-+h[b+3896>>3]- +h[b+3576>>3]);i=i;return}function GO(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+8448>>3]=-(+h[b+2696>>3]*+h[b+112>>3]*+h[d+1552>>3])- +h[d+3736>>3];i=i;return}function HO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3888>>3]=+h[b+3240>>3]- +h[b+3248>>3];i=i;return}function IO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1664>>3]*+h[j+12432>>3]*+h[e+2968>>3];l=+h[j+3496>>3]+ +h[j+3488>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1632|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1632|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,42392,42384,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1632|0;r=q;h[r>>3]=o;i=d;return}function JO(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3568>>3]=+h[b+1632>>3]*+h[d+1664>>3]*+h[d+2968>>3]*(+h[b+232>>3]*.5+(+h[b+264>>3]*-.5+(+h[b+2432>>3]+ +h[b+2440>>3])*.5));i=i;return}function KO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3728>>3]=+h[b+10112>>3]+(-+h[b+3888>>3]- +h[b+3568>>3]);i=i;return}function LO(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+8456>>3]=-(+h[b+2696>>3]*+h[b+120>>3]*+h[d+1560>>3])- +h[d+3728>>3];i=i;return}function MO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1680>>3]*+h[j+12448>>3]*+h[e+2968>>3];l=+h[j+3480>>3]+ +h[j+3472>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1648|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1648|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,42480,42472,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1648|0;r=q;h[r>>3]=o;i=d;return}function NO(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3584>>3]=+h[b+1648>>3]*+h[d+1680>>3]*+h[d+2968>>3]*(+h[b+200>>3]*.5+(+h[b+232>>3]*-.5+(+h[b+2448>>3]+ +h[b+2456>>3])*.5));i=i;return}function OO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4592>>3];k=+h[g+12448>>3];l=+h[g+216>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,42568,42560,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+2200>>3]=j-n;i=d;return}function PO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+12448>>3];k=+h[g+10584>>3];l=j*j;m=+h[g+216>>3]*+h[g+10736>>3]-j*+h[g+1016>>3];if(l!=0.0){n=g;o=m/l;p=k+o;q=n;r=q+9808|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=k+o;q=n;r=q+9808|0;s=r;h[s>>3]=p;i=d;return}j=m/+qXa(c[b+536>>2]|0,l,42608,42600,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=k+o;q=n;r=q+9808|0;s=r;h[s>>3]=p;i=d;return}function QO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4224>>3]=+h[b+14032>>3]*+h[b+12448>>3];i=i;return}function RO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10128>>3]=+h[b+4224>>3]*+h[b+9808>>3]+ +h[b+4064>>3]*+h[b+2200>>3];i=i;return}function SO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+200>>3],+h[a+192>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+200>>3];l=+h[g+192>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4584>>3]=+h[f>>3];i=b;return}function TO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4584>>3];k=+h[g+12456>>3];l=+h[g+200>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,42656,42648,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+2168>>3]=j-n;i=d;return}function UO(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3472>>3];h[b+3264>>3]=d*+h[(!(d>=0.0)?b+4584|0:b+4592|0)>>3];i=i;return}function VO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3904>>3]=+h[b+3256>>3]- +h[b+3264>>3];i=i;return}function WO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3744>>3]=+h[b+10128>>3]+(-+h[b+3904>>3]- +h[b+3584>>3]);i=i;return}function XO(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+8440>>3]=-(+h[b+2696>>3]*+h[b+104>>3]*+h[d+1544>>3])- +h[d+3744>>3];i=i;return}function YO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+200>>3],+h[a+192>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+200>>3];l=+h[g+192>>3];m=+h[g+1e3>>3];n=+h[g+992>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));fF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10744>>3]=+h[f>>3];i=b;return}function ZO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+12456>>3];k=+h[g+10592>>3];l=j*j;m=+h[g+200>>3]*+h[g+10744>>3]-j*+h[g+1e3>>3];if(l!=0.0){n=g;o=m/l;p=k+o;q=n;r=q+9816|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=k+o;q=n;r=q+9816|0;s=r;h[s>>3]=p;i=d;return}j=m/+qXa(c[b+536>>2]|0,l,42696,42688,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=k+o;q=n;r=q+9816|0;s=r;h[s>>3]=p;i=d;return}function _O(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4072>>3]=+h[b+14040>>3]*+h[b+10744>>3];i=i;return}function $O(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10136>>3]=+h[b+4232>>3]*+h[b+9816>>3]+ +h[b+4072>>3]*+h[b+2168>>3];i=i;return}function aP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+184>>3],+h[a+176>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+184>>3];l=+h[g+176>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12464>>3]=+h[f>>3];i=b;return}function bP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4240>>3]=+h[b+14048>>3]*+h[b+12464>>3];i=i;return}function cP(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12464>>3],+h[f+176>>3],+h[f+184>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11088>>3]=+h[d>>3];i=b;return}function dP(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2624>>3]=(+h[b+1688>>3]+ +h[b+1696>>3])*(+h[d+184>>3]- +h[d+200>>3])*+h[b+3072>>3]*.5;i=i;return}function eP(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3072>>3]*(+h[e+1688>>3]+ +h[e+1696>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2624>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+2464|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+2464|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,42744,42736,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+2464|0;q=p;h[q>>3]=n;i=d;return}function fP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+184>>3],+h[a+176>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+184>>3];l=+h[g+176>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4576>>3]=+h[f>>3];i=b;return}function gP(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4576>>3];k=+h[g+12464>>3];l=+h[g+184>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,42840,42832,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+2136>>3]=j-n;i=d;return}function hP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+184>>3],+h[a+176>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+184>>3];l=+h[g+176>>3];m=+h[g+984>>3];n=+h[g+976>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));fF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10752>>3]=+h[f>>3];i=b;return}function iP(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+12464>>3];k=+h[g+10600>>3];l=j*j;m=+h[g+184>>3]*+h[g+10752>>3]-j*+h[g+984>>3];if(l!=0.0){n=g;o=m/l;p=k+o;q=n;r=q+9824|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=k+o;q=n;r=q+9824|0;s=r;h[s>>3]=p;i=d;return}j=m/+qXa(c[b+536>>2]|0,l,42880,42872,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=k+o;q=n;r=q+9824|0;s=r;h[s>>3]=p;i=d;return}function jP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4080>>3]=+h[b+14048>>3]*+h[b+10752>>3];i=i;return}function kP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10144>>3]=+h[b+4240>>3]*+h[b+9824>>3]+ +h[b+4080>>3]*+h[b+2136>>3];i=i;return}function lP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+152>>3],+h[a+144>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+152>>3];l=+h[g+144>>3];m=+h[g+952>>3];n=+h[g+944>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));bF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10616>>3]=+h[f>>3];i=b;return}function mP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+152>>3],+h[a+144>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+152>>3];l=+h[g+144>>3];m=+h[g+952>>3];n=+h[g+944>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));fF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10768>>3]=+h[f>>3];i=b;return}function nP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4096>>3]=+h[b+14064>>3]*+h[b+10768>>3];i=i;return}function oP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+136>>3],+h[a+128>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+136>>3];l=+h[g+128>>3];m=+h[g+936>>3];n=+h[g+928>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));fF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10776>>3]=+h[f>>3];i=b;return}function pP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4104>>3]=+h[b+14072>>3]*+h[b+10776>>3];i=i;return}function qP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+120>>3],+h[a+112>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+120>>3];l=+h[g+112>>3];m=+h[g+920>>3];n=+h[g+912>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));bF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10632>>3]=+h[f>>3];i=b;return}function rP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+120>>3],+h[a+112>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+120>>3];l=+h[g+112>>3];m=+h[g+920>>3];n=+h[g+912>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));fF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10784>>3]=+h[f>>3];i=b;return}function sP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4112>>3]=+h[b+14080>>3]*+h[b+10784>>3];i=i;return}function tP(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2656>>3]=(+h[b+1720>>3]+ +h[b+1728>>3])*(+h[d+120>>3]- +h[d+136>>3])*+h[b+3072>>3]*.5;i=i;return}function uP(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3072>>3]*(+h[e+1720>>3]+ +h[e+1728>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2656>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+2496|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+2496|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,42928,42920,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+2496|0;q=p;h[q>>3]=n;i=d;return}function vP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+104>>3],+h[a+96>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+104>>3];l=+h[g+96>>3];m=+h[g+904>>3];n=+h[g+896>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));bF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10640>>3]=+h[f>>3];i=b;return}function wP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+104>>3],+h[a+96>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+104>>3];l=+h[g+96>>3];m=+h[g+904>>3];n=+h[g+896>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));fF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10792>>3]=+h[f>>3];i=b;return}function xP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4120>>3]=+h[b+14088>>3]*+h[b+10792>>3];i=i;return}function yP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+88>>3],+h[a+80>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+88>>3];l=+h[g+80>>3];m=+h[g+888>>3];n=+h[g+880>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));bF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10648>>3]=+h[f>>3];i=b;return}function zP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+88>>3],+h[a+80>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+88>>3];l=+h[g+80>>3];m=+h[g+888>>3];n=+h[g+880>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));fF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10800>>3]=+h[f>>3];i=b;return}function AP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4128>>3]=+h[b+14096>>3]*+h[b+10800>>3];i=i;return}function BP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+56>>3],+h[a+48>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+56>>3];l=+h[g+48>>3];m=+h[g+856>>3];n=+h[g+848>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));bF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10664>>3]=+h[f>>3];i=b;return}



function CP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+72>>3],+h[a+64>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+72>>3];l=+h[g+64>>3];m=+h[g+872>>3];n=+h[g+864>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));bF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10656>>3]=+h[f>>3];i=b;return}function DP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+72>>3],+h[a+64>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+72>>3];l=+h[g+64>>3];m=+h[g+872>>3];n=+h[g+864>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));fF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10808>>3]=+h[f>>3];i=b;return}function EP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+56>>3],+h[a+48>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+56>>3];l=+h[g+48>>3];m=+h[g+856>>3];n=+h[g+848>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));fF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10816>>3]=+h[f>>3];i=b;return}function FP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4144>>3]=+h[b+14112>>3]*+h[b+10816>>3];i=i;return}function GP(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2688>>3]=(+h[b+1752>>3]+ +h[b+1760>>3])*(+h[d+56>>3]- +h[d+72>>3])*+h[b+3072>>3]*.5;i=i;return}function HP(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3072>>3]*(+h[e+1752>>3]+ +h[e+1760>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2688>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+2528|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+2528|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,43032,43024,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+2528|0;q=p;h[q>>3]=n;i=d;return}function IP(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2696>>3]=(+h[b+1760>>3]+ +h[b+1768>>3])*(+h[d+40>>3]- +h[d+56>>3])*+h[b+3072>>3]*.5;i=i;return}function JP(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3072>>3]*(+h[e+1760>>3]+ +h[e+1768>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2696>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+2536|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+2536|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,43136,43128,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+2536|0;q=p;h[q>>3]=n;i=d;return}function KP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+56>>3],+h[a+48>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+56>>3];l=+h[g+48>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4512>>3]=+h[f>>3];i=b;return}function LP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+56>>3],+h[a+48>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+56>>3];l=+h[g+48>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12528>>3]=+h[f>>3];i=b;return}function MP(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4512>>3];k=+h[g+12528>>3];l=+h[g+56>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,43240,43232,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+1880>>3]=j-n;i=d;return}function NP(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12528>>3],+h[f+48>>3],+h[f+56>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11152>>3]=+h[d>>3];i=b;return}function OP(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+12528>>3];k=+h[g+10664>>3];l=j*j;m=+h[g+56>>3]*+h[g+10816>>3]-j*+h[g+856>>3];if(l!=0.0){n=g;o=m/l;p=k+o;q=n;r=q+9888|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=k+o;q=n;r=q+9888|0;s=r;h[s>>3]=p;i=d;return}j=m/+qXa(c[b+536>>2]|0,l,43280,43272,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=k+o;q=n;r=q+9888|0;s=r;h[s>>3]=p;i=d;return}function PP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4304>>3]=+h[b+14112>>3]*+h[b+12528>>3];i=i;return}function QP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10208>>3]=+h[b+4304>>3]*+h[b+9888>>3]+ +h[b+4144>>3]*+h[b+1880>>3];i=i;return}function RP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+72>>3],+h[a+64>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+72>>3];l=+h[g+64>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4520>>3]=+h[f>>3];i=b;return}function SP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+72>>3],+h[a+64>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+72>>3];l=+h[g+64>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12520>>3]=+h[f>>3];i=b;return}function TP(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4520>>3];k=+h[g+12520>>3];l=+h[g+72>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,43328,43320,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+1912>>3]=j-n;i=d;return}function UP(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+12520>>3];k=+h[g+10656>>3];l=j*j;m=+h[g+72>>3]*+h[g+10808>>3]-j*+h[g+872>>3];if(l!=0.0){n=g;o=m/l;p=k+o;q=n;r=q+9880|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=k+o;q=n;r=q+9880|0;s=r;h[s>>3]=p;i=d;return}j=m/+qXa(c[b+536>>2]|0,l,43368,43360,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=k+o;q=n;r=q+9880|0;s=r;h[s>>3]=p;i=d;return}function VP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4296>>3]=+h[b+14104>>3]*+h[b+12520>>3];i=i;return}function WP(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12520>>3],+h[f+64>>3],+h[f+72>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11144>>3]=+h[d>>3];i=b;return}function XP(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2680>>3]=(+h[b+1744>>3]+ +h[b+1752>>3])*(+h[d+72>>3]- +h[d+88>>3])*+h[b+3072>>3]*.5;i=i;return}function YP(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3072>>3]*(+h[e+1744>>3]+ +h[e+1752>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2680>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+2520|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+2520|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,43416,43408,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+2520|0;q=p;h[q>>3]=n;i=d;return}function ZP(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2672>>3]=(+h[b+1736>>3]+ +h[b+1744>>3])*(+h[d+88>>3]- +h[d+104>>3])*+h[b+3072>>3]*.5;i=i;return}function _P(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3072>>3]*(+h[e+1736>>3]+ +h[e+1744>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2672>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+2512|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+2512|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,43520,43512,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+2512|0;q=p;h[q>>3]=n;i=d;return}function $P(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2664>>3]=(+h[b+1728>>3]+ +h[b+1736>>3])*(+h[d+104>>3]- +h[d+120>>3])*+h[b+3072>>3]*.5;i=i;return}function aQ(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3072>>3]*(+h[e+1728>>3]+ +h[e+1736>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2664>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+2504|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+2504|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,43624,43616,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+2504|0;q=p;h[q>>3]=n;i=d;return}function bQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+136>>3],+h[a+128>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+136>>3];l=+h[g+128>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12488>>3]=+h[f>>3];i=b;return}function cQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4264>>3]=+h[b+14072>>3]*+h[b+12488>>3];i=i;return}function dQ(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12488>>3],+h[f+128>>3],+h[f+136>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11112>>3]=+h[d>>3];i=b;return}function eQ(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2648>>3]=(+h[b+1712>>3]+ +h[b+1720>>3])*(+h[d+136>>3]- +h[d+152>>3])*+h[b+3072>>3]*.5;i=i;return}function fQ(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3072>>3]*(+h[e+1712>>3]+ +h[e+1720>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2648>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+2488|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+2488|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,43728,43720,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+2488|0;q=p;h[q>>3]=n;i=d;return}function gQ(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2640>>3]=(+h[b+1704>>3]+ +h[b+1712>>3])*(+h[d+152>>3]- +h[d+168>>3])*+h[b+3072>>3]*.5;i=i;return}function hQ(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3072>>3]*(+h[e+1704>>3]+ +h[e+1712>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2640>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+2480|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+2480|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,43832,43824,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+2480|0;q=p;h[q>>3]=n;i=d;return}function iQ(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2632>>3]=(+h[b+1696>>3]+ +h[b+1704>>3])*(+h[d+168>>3]- +h[d+184>>3])*+h[b+3072>>3]*.5;i=i;return}function jQ(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3072>>3]*(+h[e+1696>>3]+ +h[e+1704>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2632>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+2472|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+2472|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,43936,43928,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+2472|0;q=p;h[q>>3]=n;i=d;return}function kQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+168>>3],+h[a+160>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+168>>3];l=+h[g+160>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4568>>3]=+h[f>>3];i=b;return}function lQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+168>>3],+h[a+160>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+168>>3];l=+h[g+160>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12472>>3]=+h[f>>3];i=b;return}function mQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4568>>3];k=+h[g+12472>>3];l=+h[g+168>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,44032,44024,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+2104>>3]=j-n;i=d;return}function nQ(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12472>>3],+h[f+160>>3],+h[f+168>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11096>>3]=+h[d>>3];i=b;return}function oQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+12472>>3];k=+h[g+10608>>3];l=j*j;m=+h[g+168>>3]*+h[g+10760>>3]-j*+h[g+968>>3];if(l!=0.0){n=g;o=m/l;p=k+o;q=n;r=q+9832|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=k+o;q=n;r=q+9832|0;s=r;h[s>>3]=p;i=d;return}j=m/+qXa(c[b+536>>2]|0,l,44072,44064,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=k+o;q=n;r=q+9832|0;s=r;h[s>>3]=p;i=d;return}function pQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4248>>3]=+h[b+14056>>3]*+h[b+12472>>3];i=i;return}function qQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10152>>3]=+h[b+4248>>3]*+h[b+9832>>3]+ +h[b+4088>>3]*+h[b+2104>>3];i=i;return}function rQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+152>>3],+h[a+144>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+152>>3];l=+h[g+144>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4560>>3]=+h[f>>3];i=b;return}function sQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+152>>3],+h[a+144>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+152>>3];l=+h[g+144>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12480>>3]=+h[f>>3];i=b;return}function tQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4560>>3];k=+h[g+12480>>3];l=+h[g+152>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,44120,44112,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+2072>>3]=j-n;i=d;return}function uQ(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12480>>3],+h[f+144>>3],+h[f+152>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11104>>3]=+h[d>>3];i=b;return}function vQ(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0,y=0.0;d=i;i=i+8|0;e=d;f=b+304|0;g=+h[f>>3];j=b+536|0;k=b+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;m=b+416|0;n=c[m>>2]|0;JD(e,c[j>>2]|0,+h[l+2480>>3],+h[l+12472>>3],+h[l+12480>>3],+h[l+11096>>3],+h[l+11104>>3],+h[n+1552>>3],+h[l+12952>>3],+h[l+12800>>3]*+h[n+3136>>3],(+h[n+2024>>3]+ +h[n+2032>>3])*.5,+h[n+3128>>3]*.05,+h[n+3096>>3]);n=c[m>>2]|0;o=g*+h[e>>3]*+h[n+3072>>3];g=1.0- +h[f>>3];p=+h[n+3104>>3];f=c[c[k>>2]>>2]|0;e=c[f+8>>2]|0;q=+h[e+2480>>3]- +h[e+12800>>3]*+h[n+3136>>3]*+h[n+3152>>3];if(p!=0.0){r=e;s=q/p;t=g*s;u=o+t;v=r;w=v+3448|0;x=w;h[x>>3]=u;i=d;return}if(q==0.0){r=e;s=q;t=g*s;u=o+t;v=r;w=v+3448|0;x=w;h[x>>3]=u;i=d;return}y=q/+qXa(c[j>>2]|0,p,36984,44152,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[(c[c[k>>2]>>2]|0)+8>>2]|0;s=y;t=g*s;u=o+t;v=r;w=v+3448|0;x=w;h[x>>3]=u;i=d;return}function wQ(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3448>>3];h[b+3288>>3]=d*+h[(!(d>=0.0)?b+4560|0:b+4568|0)>>3];i=i;return}function xQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3440>>3]=+h[b+3448>>3]- +h[b+4096>>3];i=i;return}function yQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3432>>3]=+h[b+3440>>3]- +h[b+4104>>3];i=i;return}function zQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3424>>3]=+h[b+3432>>3]- +h[b+4112>>3];i=i;return}function AQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3416>>3]=+h[b+3424>>3]- +h[b+4120>>3];i=i;return}function BQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3408>>3]=+h[b+3416>>3]- +h[b+4128>>3];i=i;return}function CQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1720>>3]*+h[j+12488>>3]*+h[e+2968>>3];l=+h[j+3440>>3]+ +h[j+3432>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1688|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1688|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,44168,44160,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1688|0;r=q;h[r>>3]=o;i=d;return}function DQ(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3624>>3]=+h[b+1688>>3]*+h[d+1720>>3]*+h[d+2968>>3]*(+h[b+120>>3]*.5+(+h[b+152>>3]*-.5+(+h[b+2488>>3]+ +h[b+2496>>3])*.5));i=i;return}function EQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3456>>3]=+h[b+4088>>3]+ +h[b+3448>>3];i=i;return}function FQ(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3456>>3];h[b+3280>>3]=d*+h[(!(d>=0.0)?b+4568|0:b+4576|0)>>3];i=i;return}function GQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3928>>3]=+h[b+3280>>3]- +h[b+3288>>3];i=i;return}function HQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1704>>3]*+h[j+12472>>3]*+h[e+2968>>3];l=+h[j+3456>>3]+ +h[j+3448>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1672|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1672|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,44264,44256,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1672|0;r=q;h[r>>3]=o;i=d;return}function IQ(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3608>>3]=+h[b+1672>>3]*+h[d+1704>>3]*+h[d+2968>>3]*(+h[b+152>>3]*.5+(+h[b+184>>3]*-.5+(+h[b+2472>>3]+ +h[b+2480>>3])*.5));i=i;return}function JQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3768>>3]=+h[b+10152>>3]+(-+h[b+3928>>3]- +h[b+3608>>3]);i=i;return}function KQ(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+8416>>3]=-(+h[b+2696>>3]*+h[b+80>>3]*+h[d+1520>>3])- +h[d+3768>>3];i=i;return}function LQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3464>>3]=+h[b+4080>>3]+ +h[b+3456>>3];i=i;return}function MQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1696>>3]*+h[j+12464>>3]*+h[e+2968>>3];l=+h[j+3464>>3]+ +h[j+3456>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1664|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1664|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,44360,44352,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1664|0;r=q;h[r>>3]=o;i=d;return}function NQ(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3600>>3]=+h[b+1664>>3]*+h[d+1696>>3]*+h[d+2968>>3]*(+h[b+168>>3]*.5+(+h[b+200>>3]*-.5+(+h[b+2464>>3]+ +h[b+2472>>3])*.5));i=i;return}function OQ(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3464>>3];h[b+3272>>3]=d*+h[(!(d>=0.0)?b+4576|0:b+4584|0)>>3];i=i;return}function PQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3920>>3]=+h[b+3272>>3]- +h[b+3280>>3];i=i;return}function QQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3760>>3]=+h[b+10144>>3]+(-+h[b+3920>>3]- +h[b+3600>>3]);i=i;return}function RQ(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+8424>>3]=-(+h[b+2696>>3]*+h[b+88>>3]*+h[d+1528>>3])- +h[d+3760>>3];i=i;return}function SQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3912>>3]=+h[b+3264>>3]- +h[b+3272>>3];i=i;return}function TQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1688>>3]*+h[j+12456>>3]*+h[e+2968>>3];l=+h[j+3472>>3]+ +h[j+3464>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1656|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1656|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,44448,44440,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1656|0;r=q;h[r>>3]=o;i=d;return}function UQ(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3592>>3]=+h[b+1656>>3]*+h[d+1688>>3]*+h[d+2968>>3]*(+h[b+184>>3]*.5+(+h[b+216>>3]*-.5+(+h[b+2456>>3]+ +h[b+2464>>3])*.5));i=i;return}function VQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3752>>3]=+h[b+10136>>3]+(-+h[b+3912>>3]- +h[b+3592>>3]);i=i;return}function WQ(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+8432>>3]=-(+h[b+2696>>3]*+h[b+96>>3]*+h[d+1536>>3])- +h[d+3752>>3];i=i;return}function XQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+12480>>3];k=+h[g+10616>>3];l=j*j;m=+h[g+152>>3]*+h[g+10768>>3]-j*+h[g+952>>3];if(l!=0.0){n=g;o=m/l;p=k+o;q=n;r=q+9840|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=k+o;q=n;r=q+9840|0;s=r;h[s>>3]=p;i=d;return}j=m/+qXa(c[b+536>>2]|0,l,44536,44528,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=k+o;q=n;r=q+9840|0;s=r;h[s>>3]=p;i=d;return}function YQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1712>>3]*+h[j+12480>>3]*+h[e+2968>>3];l=+h[j+3448>>3]+ +h[j+3440>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1680|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1680|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,44584,44576,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1680|0;r=q;h[r>>3]=o;i=d;return}function ZQ(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3616>>3]=+h[b+1680>>3]*+h[d+1712>>3]*+h[d+2968>>3]*(+h[b+136>>3]*.5+(+h[b+168>>3]*-.5+(+h[b+2480>>3]+ +h[b+2488>>3])*.5));i=i;return}function _Q(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4256>>3]=+h[b+14064>>3]*+h[b+12480>>3];i=i;return}function $Q(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10160>>3]=+h[b+4256>>3]*+h[b+9840>>3]+ +h[b+4096>>3]*+h[b+2072>>3];i=i;return}function aR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+136>>3],+h[a+128>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+136>>3];l=+h[g+128>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4552>>3]=+h[f>>3];i=b;return}function bR(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4552>>3];k=+h[g+12488>>3];l=+h[g+136>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,44680,44672,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+2040>>3]=j-n;i=d;return}function cR(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3440>>3];h[b+3296>>3]=d*+h[(!(d>=0.0)?b+4552|0:b+4560|0)>>3];i=i;return}function dR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3936>>3]=+h[b+3288>>3]- +h[b+3296>>3];i=i;return}function eR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3776>>3]=+h[b+10160>>3]+(-+h[b+3936>>3]- +h[b+3616>>3]);i=i;return}function fR(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+8408>>3]=-(+h[b+2696>>3]*+h[b+72>>3]*+h[d+1512>>3])- +h[d+3776>>3];i=i;return}function gR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+136>>3],+h[a+128>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+136>>3];l=+h[g+128>>3];m=+h[g+936>>3];n=+h[g+928>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));bF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10624>>3]=+h[f>>3];i=b;return}function hR(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+12488>>3];k=+h[g+10624>>3];l=j*j;m=+h[g+136>>3]*+h[g+10776>>3]-j*+h[g+936>>3];if(l!=0.0){n=g;o=m/l;p=k+o;q=n;r=q+9848|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=k+o;q=n;r=q+9848|0;s=r;h[s>>3]=p;i=d;return}j=m/+qXa(c[b+536>>2]|0,l,44720,44712,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=k+o;q=n;r=q+9848|0;s=r;h[s>>3]=p;i=d;return}function iR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10168>>3]=+h[b+4264>>3]*+h[b+9848>>3]+ +h[b+4104>>3]*+h[b+2040>>3];i=i;return}function jR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+120>>3],+h[a+112>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+120>>3];l=+h[g+112>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4544>>3]=+h[f>>3];i=b;return}function kR(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3432>>3];h[b+3304>>3]=d*+h[(!(d>=0.0)?b+4544|0:b+4552|0)>>3];i=i;return}function lR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3944>>3]=+h[b+3296>>3]- +h[b+3304>>3];i=i;return}function mR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3784>>3]=+h[b+10168>>3]+(-+h[b+3944>>3]- +h[b+3624>>3]);i=i;return}function nR(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+8400>>3]=-(+h[b+2696>>3]*+h[b+64>>3]*+h[d+1504>>3])- +h[d+3784>>3];i=i;return}function oR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8560>>3]=+h[b+9984>>3]+(-+h[b+8240>>3]- +h[b+8400>>3]);i=i;return}function pR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7912>>3]=+h[b+8560>>3]+ +h[b+7920>>3];i=i;return}function qR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8552>>3]=+h[b+7904>>3]- +h[b+7912>>3];i=i;return}function rR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+120>>3],+h[a+112>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+120>>3];l=+h[g+112>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12496>>3]=+h[f>>3];i=b;return}function sR(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12496>>3],+h[f+112>>3],+h[f+120>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11120>>3]=+h[d>>3];i=b;return}function tR(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+12496>>3];k=+h[g+10632>>3];l=j*j;m=+h[g+120>>3]*+h[g+10784>>3]-j*+h[g+920>>3];if(l!=0.0){n=g;o=m/l;p=k+o;q=n;r=q+9856|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=k+o;q=n;r=q+9856|0;s=r;h[s>>3]=p;i=d;return}j=m/+qXa(c[b+536>>2]|0,l,44768,44760,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=k+o;q=n;r=q+9856|0;s=r;h[s>>3]=p;i=d;return}function uR(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1728>>3]*+h[j+12496>>3]*+h[e+2968>>3];l=+h[j+3432>>3]+ +h[j+3424>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1696|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1696|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,44816,44808,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1696|0;r=q;h[r>>3]=o;i=d;return}function vR(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3632>>3]=+h[b+1696>>3]*+h[d+1728>>3]*+h[d+2968>>3]*(+h[b+104>>3]*.5+(+h[b+136>>3]*-.5+(+h[b+2496>>3]+ +h[b+2504>>3])*.5));i=i;return}function wR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4272>>3]=+h[b+14080>>3]*+h[b+12496>>3];i=i;return}function xR(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4544>>3];k=+h[g+12496>>3];l=+h[g+120>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,44912,44904,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+2008>>3]=j-n;i=d;return}function yR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10176>>3]=+h[b+4272>>3]*+h[b+9856>>3]+ +h[b+4112>>3]*+h[b+2008>>3];i=i;return}function zR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+104>>3],+h[a+96>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+104>>3];l=+h[g+96>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4536>>3]=+h[f>>3];i=b;return}function AR(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3424>>3];h[b+3312>>3]=d*+h[(!(d>=0.0)?b+4536|0:b+4544|0)>>3];i=i;return}function BR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3952>>3]=+h[b+3304>>3]- +h[b+3312>>3];i=i;return}function CR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3792>>3]=+h[b+10176>>3]+(-+h[b+3952>>3]- +h[b+3632>>3]);i=i;return}function DR(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+8392>>3]=-(+h[b+2696>>3]*+h[b+56>>3]*+h[d+1496>>3])- +h[d+3792>>3];i=i;return}function ER(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+104>>3],+h[a+96>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+104>>3];l=+h[g+96>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12504>>3]=+h[f>>3];i=b;return}function FR(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4536>>3];k=+h[g+12504>>3];l=+h[g+104>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,44952,44944,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+1976>>3]=j-n;i=d;return}function GR(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12504>>3],+h[f+96>>3],+h[f+104>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11128>>3]=+h[d>>3];i=b;return}function HR(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+12504>>3];k=+h[g+10640>>3];l=j*j;m=+h[g+104>>3]*+h[g+10792>>3]-j*+h[g+904>>3];if(l!=0.0){n=g;o=m/l;p=k+o;q=n;r=q+9864|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=k+o;q=n;r=q+9864|0;s=r;h[s>>3]=p;i=d;return}j=m/+qXa(c[b+536>>2]|0,l,44992,44984,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=k+o;q=n;r=q+9864|0;s=r;h[s>>3]=p;i=d;return}function IR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4280>>3]=+h[b+14088>>3]*+h[b+12504>>3];i=i;return}function JR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10184>>3]=+h[b+4280>>3]*+h[b+9864>>3]+ +h[b+4120>>3]*+h[b+1976>>3];i=i;return}function KR(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1736>>3]*+h[j+12504>>3]*+h[e+2968>>3];l=+h[j+3424>>3]+ +h[j+3416>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1704|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1704|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,45040,45032,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1704|0;r=q;h[r>>3]=o;i=d;return}function LR(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3640>>3]=+h[b+1704>>3]*+h[d+1736>>3]*+h[d+2968>>3]*(+h[b+88>>3]*.5+(+h[b+120>>3]*-.5+(+h[b+2504>>3]+ +h[b+2512>>3])*.5));i=i;return}function MR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+88>>3],+h[a+80>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+88>>3];l=+h[g+80>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4528>>3]=+h[f>>3];i=b;return}function NR(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3408>>3];h[b+3328>>3]=d*+h[(!(d>=0.0)?b+4520|0:b+4528|0)>>3];i=i;return}function OR(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3416>>3];h[b+3320>>3]=d*+h[(!(d>=0.0)?b+4528|0:b+4536|0)>>3];i=i;return}function PR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3968>>3]=+h[b+3320>>3]- +h[b+3328>>3];i=i;return}function QR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3960>>3]=+h[b+3312>>3]- +h[b+3320>>3];i=i;return}function RR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3800>>3]=+h[b+10184>>3]+(-+h[b+3960>>3]- +h[b+3640>>3]);i=i;return}function SR(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+8384>>3]=-(+h[b+2696>>3]*+h[b+48>>3]*+h[d+1488>>3])- +h[d+3800>>3];i=i;return}function TR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+88>>3],+h[a+80>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+88>>3];l=+h[g+80>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12512>>3]=+h[f>>3];i=b;return}function UR(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4528>>3];k=+h[g+12512>>3];l=+h[g+88>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,45136,45128,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+1944>>3]=j-n;i=d;return}function VR(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12512>>3],+h[f+80>>3],+h[f+88>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11136>>3]=+h[d>>3];i=b;return}function WR(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+12512>>3];k=+h[g+10648>>3];l=j*j;m=+h[g+88>>3]*+h[g+10800>>3]-j*+h[g+888>>3];if(l!=0.0){n=g;o=m/l;p=k+o;q=n;r=q+9872|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=k+o;q=n;r=q+9872|0;s=r;h[s>>3]=p;i=d;return}j=m/+qXa(c[b+536>>2]|0,l,45176,45168,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=k+o;q=n;r=q+9872|0;s=r;h[s>>3]=p;i=d;return}function XR(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1744>>3]*+h[j+12512>>3]*+h[e+2968>>3];l=+h[j+3416>>3]+ +h[j+3408>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1712|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1712|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,45224,45216,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1712|0;r=q;h[r>>3]=o;i=d;return}function YR(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3648>>3]=+h[b+1712>>3]*+h[d+1744>>3]*+h[d+2968>>3]*(+h[b+72>>3]*.5+(+h[b+104>>3]*-.5+(+h[b+2512>>3]+ +h[b+2520>>3])*.5));i=i;return}function ZR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4288>>3]=+h[b+14096>>3]*+h[b+12512>>3];i=i;return}function _R(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10192>>3]=+h[b+4288>>3]*+h[b+9872>>3]+ +h[b+4128>>3]*+h[b+1944>>3];i=i;return}function $R(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8376>>3]=+h[b+4680>>3]*+h[b+13544>>3]*(+h[b+9480>>3]- +h[b+544>>3])*+h[(c[a+416>>2]|0)+2944>>3];i=i;return}function aS(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3808>>3]=-(+h[b+2696>>3]*+h[b+40>>3]*+h[d+1480>>3])- +h[d+8376>>3];i=i;return}function bS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+552>>3],+h[a+544>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+552>>3];l=+h[g+544>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12256>>3]=+h[f>>3];i=b;return}function cS(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;WD(d,c[a+536>>2]|0,+h[f+12256>>3],+h[f+544>>3],+h[f+552>>3],1,1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5480>>3]=+h[d>>3];i=b;return}function dS(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12256>>3],+h[f+544>>3],+h[f+552>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5640>>3]=+h[d>>3];i=b;return}function eS(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12256>>3],+h[f+544>>3],+h[f+552>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+10888>>3]=+h[d>>3];i=b;return}function fS(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+12256>>3];k=+h[g+10272>>3];l=j*j;m=+h[g+552>>3]*+h[g+10424>>3]-j*+h[g+1352>>3];if(l!=0.0){n=g;o=m/l;p=k+o;q=n;r=q+9640|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=k+o;q=n;r=q+9640|0;s=r;h[s>>3]=p;i=d;return}j=m/+qXa(c[b+536>>2]|0,l,45320,45312,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=k+o;q=n;r=q+9640|0;s=r;h[s>>3]=p;i=d;return}function gS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8856>>3]=+h[b+13384>>3]*+h[b+12256>>3];i=i;return}function hS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+552>>3],+h[a+544>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+552>>3];l=+h[g+544>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+9240>>3]=+h[f>>3];i=b;return}function iS(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9240>>3];k=+h[g+12256>>3];l=+h[g+552>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,45368,45360,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6872>>3]=j-n;i=d;return}function jS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9960>>3]=+h[b+8856>>3]*+h[b+9640>>3]+ +h[b+8696>>3]*+h[b+6872>>3];i=i;return}function kS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+88|0;d=b;e=b+40|0;f=b+80|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ID(e,c[g>>2]|0,1,+h[a+9240>>3],+h[a+12256>>3],+h[a+544>>3],+h[a+552>>3]);a=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+40|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));SD(f,a,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5960>>3]=+h[f>>3];i=b;return}function lS(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7232>>3]=(+h[b+536>>3]+ +h[b+544>>3])*(+h[d+552>>3]- +h[d+568>>3])*+h[b+2840>>3]*.5;i=i;return}function mS(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2840>>3]*(+h[e+536>>3]+ +h[e+544>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7232>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+7072|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+7072|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,45408,45400,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+7072|0;q=p;h[q>>3]=n;i=d;return}function nS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+568>>3],+h[a+560>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+568>>3];l=+h[g+560>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12248>>3]=+h[f>>3];i=b;return}function oS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8848>>3]=+h[b+13376>>3]*+h[b+12248>>3];i=i;return}function pS(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;WD(d,c[a+536>>2]|0,+h[f+12248>>3],+h[f+560>>3],+h[f+568>>3],1,1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5472>>3]=+h[d>>3];i=b;return}function qS(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12248>>3],+h[f+560>>3],+h[f+568>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5632>>3]=+h[d>>3];i=b;return}function rS(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12248>>3],+h[f+560>>3],+h[f+568>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+10880>>3]=+h[d>>3];i=b;return}function sS(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+12248>>3];k=+h[g+10264>>3];l=j*j;m=+h[g+568>>3]*+h[g+10416>>3]-j*+h[g+1368>>3];if(l!=0.0){n=g;o=m/l;p=k+o;q=n;r=q+9632|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=k+o;q=n;r=q+9632|0;s=r;h[s>>3]=p;i=d;return}j=m/+qXa(c[b+536>>2]|0,l,45504,45496,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=k+o;q=n;r=q+9632|0;s=r;h[s>>3]=p;i=d;return}function tS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+568>>3],+h[a+560>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+568>>3];l=+h[g+560>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+9248>>3]=+h[f>>3];i=b;return}function uS(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9248>>3];k=+h[g+12248>>3];l=+h[g+568>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,45552,45544,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6904>>3]=j-n;i=d;return}function vS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9952>>3]=+h[b+8848>>3]*+h[b+9632>>3]+ +h[b+8688>>3]*+h[b+6904>>3];i=i;return}function wS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+88|0;d=b;e=b+40|0;f=b+80|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ID(e,c[g>>2]|0,1,+h[a+9248>>3],+h[a+12248>>3],+h[a+560>>3],+h[a+568>>3]);a=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+40|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));SD(f,a,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5952>>3]=+h[f>>3];i=b;return}function xS(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7224>>3]=(+h[b+528>>3]+ +h[b+536>>3])*(+h[d+568>>3]- +h[d+584>>3])*+h[b+2840>>3]*.5;i=i;return}function yS(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2840>>3]*(+h[e+528>>3]+ +h[e+536>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7224>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+7064|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+7064|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,45592,45584,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+7064|0;q=p;h[q>>3]=n;i=d;return}function zS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+584>>3],+h[a+576>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+584>>3];l=+h[g+576>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12240>>3]=+h[f>>3];i=b;return}function AS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8840>>3]=+h[b+13368>>3]*+h[b+12240>>3];i=i;return}function BS(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;WD(d,c[a+536>>2]|0,+h[f+12240>>3],+h[f+576>>3],+h[f+584>>3],1,1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5464>>3]=+h[d>>3];i=b;return}function CS(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12240>>3],+h[f+576>>3],+h[f+584>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5624>>3]=+h[d>>3];i=b;return}function DS(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12240>>3],+h[f+576>>3],+h[f+584>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+10872>>3]=+h[d>>3];i=b;return}function ES(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+12240>>3];k=+h[g+10256>>3];l=j*j;m=+h[g+584>>3]*+h[g+10408>>3]-j*+h[g+1384>>3];if(l!=0.0){n=g;o=m/l;p=k+o;q=n;r=q+9624|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=k+o;q=n;r=q+9624|0;s=r;h[s>>3]=p;i=d;return}j=m/+qXa(c[b+536>>2]|0,l,45688,45680,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=k+o;q=n;r=q+9624|0;s=r;h[s>>3]=p;i=d;return}function FS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+584>>3],+h[a+576>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+584>>3];l=+h[g+576>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+9256>>3]=+h[f>>3];i=b;return}function GS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+88|0;d=b;e=b+40|0;f=b+80|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ID(e,c[g>>2]|0,1,+h[a+9256>>3],+h[a+12240>>3],+h[a+576>>3],+h[a+584>>3]);a=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+40|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));SD(f,a,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5944>>3]=+h[f>>3];i=b;return}function HS(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9256>>3];k=+h[g+12240>>3];l=+h[g+584>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,45736,45728,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6936>>3]=j-n;i=d;return}function IS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9944>>3]=+h[b+8840>>3]*+h[b+9624>>3]+ +h[b+8680>>3]*+h[b+6936>>3];i=i;return}function JS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8360>>3]=+h[b+4664>>3]*+h[b+13528>>3]*(+h[b+9464>>3]- +h[b+576>>3])*+h[(c[a+416>>2]|0)+2944>>3];i=i;return}function KS(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3824>>3]=-(+h[b+2696>>3]*+h[b+24>>3]*+h[d+1464>>3])- +h[d+8360>>3];i=i;return}function LS(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;HD(d,c[a+536>>2]|0,+h[f+4664>>3],+h[(c[a+416>>2]|0)+688>>3],+h[f+5464>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5784>>3]=+h[d>>3];i=b;return}function MS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+632>>3],+h[a+624>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+632>>3];l=+h[g+624>>3];m=+h[g+1432>>3];n=+h[g+1424>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));fF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10384>>3]=+h[f>>3];i=b;return}function NS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;XE(e,c[g>>2]|0,+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+632>>3],300.0,0);a=c[g>>2]|0;k=+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+632>>3];g=d+0|0;l=e+0|0;e=g+120|0;do{c[g>>2]=c[l>>2];g=g+4|0;l=l+4|0}while((g|0)<(e|0));aF(f,a,k,300.0,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+14504>>3]=+h[f>>3];i=b;return}function OS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+632>>3],+h[a+624>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+632>>3];l=+h[g+624>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12216>>3]=+h[f>>3];i=b;return}function PS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8816>>3]=+h[b+13344>>3]*+h[b+12216>>3];i=i;return}function QS(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;WD(d,c[a+536>>2]|0,+h[f+12216>>3],+h[f+624>>3],+h[f+632>>3],1,1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5440>>3]=+h[d>>3];i=b;return}function RS(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12216>>3],+h[f+624>>3],+h[f+632>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5600>>3]=+h[d>>3];i=b;return}function SS(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+12216>>3];k=+h[g+14640>>3];l=j*j;m=+h[g+632>>3]*+h[g+10384>>3]-j*+h[g+1432>>3];if(l!=0.0){n=g;o=m/l;p=k+o;q=n;r=q+9600|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=k+o;q=n;r=q+9600|0;s=r;h[s>>3]=p;i=d;return}j=m/+qXa(c[b+536>>2]|0,l,45776,45768,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=k+o;q=n;r=q+9600|0;s=r;h[s>>3]=p;i=d;return}function TS(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7200>>3]=(+h[b+504>>3]+ +h[b+512>>3])*(+h[d+616>>3]- +h[d+632>>3])*+h[b+2840>>3]*.5;i=i;return}function US(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2840>>3]*(+h[e+504>>3]+ +h[e+512>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7200>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+7040|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+7040|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,45824,45816,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+7040|0;q=p;h[q>>3]=n;i=d;return}function VS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+632>>3],+h[a+624>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+632>>3];l=+h[g+624>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+14600>>3]=+h[f>>3];i=b;return}function WS(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+14600>>3];k=+h[g+12216>>3];l=+h[g+632>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,45920,45912,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+7032>>3]=j-n;i=d;return}function XS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+88|0;d=b;e=b+40|0;f=b+80|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ID(e,c[g>>2]|0,1,+h[a+14600>>3],+h[a+12216>>3],+h[a+624>>3],+h[a+632>>3]);a=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+40|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));SD(f,a,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5920>>3]=+h[f>>3];i=b;return}function YS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7848>>3]=+h[b+14504>>3]*.5;i=i;return}function ZS(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12216>>3],+h[f+624>>3],+h[f+632>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+10848>>3]=+h[d>>3];i=b;return}function _S(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+616>>3],+h[a+608>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+616>>3];l=+h[g+608>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12224>>3]=+h[f>>3];i=b;return}function $S(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8824>>3]=+h[b+13352>>3]*+h[b+12224>>3];i=i;return}function aT(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;WD(d,c[a+536>>2]|0,+h[f+12224>>3],+h[f+608>>3],+h[f+616>>3],1,1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5448>>3]=+h[d>>3];i=b;return}function bT(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12224>>3],+h[f+608>>3],+h[f+616>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5608>>3]=+h[d>>3];i=b;return}function cT(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+12224>>3];k=+h[g+10240>>3];l=j*j;m=+h[g+616>>3]*+h[g+10392>>3]-j*+h[g+1416>>3];if(l!=0.0){n=g;o=m/l;p=k+o;q=n;r=q+9608|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=k+o;q=n;r=q+9608|0;s=r;h[s>>3]=p;i=d;return}j=m/+qXa(c[b+536>>2]|0,l,45960,45952,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=k+o;q=n;r=q+9608|0;s=r;h[s>>3]=p;i=d;return}function dT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+616>>3],+h[a+608>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+616>>3];l=+h[g+608>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+9272>>3]=+h[f>>3];i=b;return}function eT(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9272>>3];k=+h[g+12224>>3];l=+h[g+616>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,46008,46e3,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+7e3>>3]=j-n;i=d;return}function fT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9928>>3]=+h[b+8824>>3]*+h[b+9608>>3]+ +h[b+8664>>3]*+h[b+7e3>>3];i=i;return}function gT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+88|0;d=b;e=b+40|0;f=b+80|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ID(e,c[g>>2]|0,1,+h[a+9272>>3],+h[a+12224>>3],+h[a+608>>3],+h[a+616>>3]);a=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+40|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));SD(f,a,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5928>>3]=+h[f>>3];i=b;return}function hT(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12224>>3],+h[f+608>>3],+h[f+616>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+10856>>3]=+h[d>>3];i=b;return}function iT(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7208>>3]=(+h[b+512>>3]+ +h[b+520>>3])*(+h[d+600>>3]- +h[d+616>>3])*+h[b+2840>>3]*.5;i=i;return}function jT(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2840>>3]*(+h[e+512>>3]+ +h[e+520>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7208>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+7048|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+7048|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,46048,46040,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+7048|0;q=p;h[q>>3]=n;i=d;return}function kT(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7216>>3]=(+h[b+520>>3]+ +h[b+528>>3])*(+h[d+584>>3]- +h[d+600>>3])*+h[b+2840>>3]*.5;i=i;return}function lT(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2840>>3]*(+h[e+520>>3]+ +h[e+528>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7216>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+7056|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+7056|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,46144,46136,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+7056|0;q=p;h[q>>3]=n;i=d;return}function mT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+600>>3],+h[a+592>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+600>>3];l=+h[g+592>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12232>>3]=+h[f>>3];i=b;return}function nT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8832>>3]=+h[b+13360>>3]*+h[b+12232>>3];i=i;return}function oT(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;WD(d,c[a+536>>2]|0,+h[f+12232>>3],+h[f+592>>3],+h[f+600>>3],1,1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5456>>3]=+h[d>>3];i=b;return}function pT(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;HD(d,c[a+536>>2]|0,+h[f+4656>>3],+h[(c[a+416>>2]|0)+680>>3],+h[f+5456>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5776>>3]=+h[d>>3];i=b;return}function qT(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12232>>3],+h[f+592>>3],+h[f+600>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5616>>3]=+h[d>>3];i=b;return}function rT(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12232>>3],+h[f+592>>3],+h[f+600>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+10864>>3]=+h[d>>3];i=b;return}function sT(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0,y=0.0;d=i;i=i+8|0;e=d;f=b+304|0;g=+h[f>>3];j=b+536|0;k=b+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;m=b+416|0;n=c[m>>2]|0;JD(e,c[j>>2]|0,+h[l+7048>>3],+h[l+12224>>3],+h[l+12232>>3],+h[l+10856>>3],+h[l+10864>>3],+h[n+352>>3],+h[l+13168>>3],+h[l+12568>>3]*+h[n+2904>>3],(+h[n+832>>3]+ +h[n+840>>3])*.5,+h[n+2896>>3]*.05,+h[n+2864>>3]);n=c[m>>2]|0;o=g*+h[e>>3]*+h[n+2840>>3];g=1.0- +h[f>>3];p=+h[n+2872>>3];f=c[c[k>>2]>>2]|0;e=c[f+8>>2]|0;q=+h[e+7048>>3]- +h[e+12568>>3]*+h[n+2904>>3]*+h[n+2920>>3];if(p!=0.0){r=e;s=q/p;t=g*s;u=o+t;v=r;w=v+8160|0;x=w;h[x>>3]=u;i=d;return}if(q==0.0){r=e;s=q;t=g*s;u=o+t;v=r;w=v+8160|0;x=w;h[x>>3]=u;i=d;return}y=q/+qXa(c[j>>2]|0,p,32896,46232,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[(c[c[k>>2]>>2]|0)+8>>2]|0;s=y;t=g*s;u=o+t;v=r;w=v+8160|0;x=w;h[x>>3]=u;i=d;return}function tT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8168>>3]=+h[b+8664>>3]+ +h[b+8160>>3];i=i;return}function uT(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+504>>3]*+h[j+12216>>3]*+h[e+2736>>3];l=+h[j+8168>>3]+.5;if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6240|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6240|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,46248,46240,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6240|0;r=q;h[r>>3]=o;i=d;return}function vT(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+8176>>3]=+h[b+6240>>3]*+h[d+504>>3]*+h[d+2736>>3]*(+h[b+616>>3]*.5+(+h[b+632>>3]*-.5+ +h[b+7040>>3]*.5));i=i;return}function wT(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;GD(d,c[a+536>>2]|0,+h[f+6240>>3],+h[f+12216>>3],+h[f+5600>>3],+h[(c[a+416>>2]|0)+664>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6080>>3]=+h[d>>3];i=b;return}function xT(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6240>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+6080>>3]));l=+h[j+5920>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?.5:19.5)*+h[m+344>>3];o=+h[m+664>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+qXa(c[b+536>>2]|0,n,46336,46328,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+4960>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function yT(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+4960>>3]+-.7;h[b+5120>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function zT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+Ad(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6080>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4800|0;w=v;h[w>>3]=n;i=b;return}x=c[72300]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=48728;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Pe[a&127](y,d,46408,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4800|0;w=v;h[w>>3]=n;i=b;return}function AT(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6240>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4800>>3];l=+U(+(+h[j+6080>>3]));m=+h[j+5920>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?.5:19.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+344>>3];q=n*p;r=q!=0.0;s=+h[o+664>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+qXa(c[b+536>>2]|0,q,46336,46504,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+5920>>3];u=+h[j+4800>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5280|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+qXa(c[b+536>>2]|0,q,46336,46504,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+664>>3];M=+h[j+344>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+qXa(c[b+536>>2]|0,q,46336,46504,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5280|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+qXa(c[b+536>>2]|0,q,46336,46504,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4800>>3]*.125));L=P*(+W(+(+h[g+5920>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+qXa(c[b+536>>2]|0,L,46512,46504,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5280|0;K=J;h[K>>3]=B;i=d;return}}function BT(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;_D(d,c[a+536>>2]|0,+h[f+5280>>3],+h[f+5120>>3],+h[f+6080>>3]+-6150.0,3850.0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5760>>3]=+h[d>>3];i=b;return}function CT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8656>>3]=.5- +h[b+8168>>3];i=i;return}function DT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9920>>3]=+h[b+8816>>3]*+h[b+9600>>3]+ +h[b+8656>>3]*+h[b+7032>>3];i=i;return}function ET(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+512>>3]*+h[j+12224>>3]*+h[e+2736>>3];l=+h[j+8168>>3]+ +h[j+8160>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6248|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6248|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,46648,46640,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6248|0;r=q;h[r>>3]=o;i=d;return}function FT(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;GD(d,c[a+536>>2]|0,+h[f+6248>>3],+h[f+12224>>3],+h[f+5608>>3],+h[(c[a+416>>2]|0)+672>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6088>>3]=+h[d>>3];i=b;return}function GT(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6248>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+6088>>3]));l=+h[j+5928>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?1.5:18.5)*+h[m+352>>3];o=+h[m+672>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+qXa(c[b+536>>2]|0,n,46736,46728,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+4968>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function HT(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+4968>>3]+-.7;h[b+5128>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function IT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+Ad(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6088>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4808|0;w=v;h[w>>3]=n;i=b;return}x=c[72300]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=48728;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Pe[a&127](y,d,46808,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4808|0;w=v;h[w>>3]=n;i=b;return}function JT(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6248>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4808>>3];l=+U(+(+h[j+6088>>3]));m=+h[j+5928>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?1.5:18.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+352>>3];q=n*p;r=q!=0.0;s=+h[o+672>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+qXa(c[b+536>>2]|0,q,46736,46904,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+5928>>3];u=+h[j+4808>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5288|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+qXa(c[b+536>>2]|0,q,46736,46904,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+672>>3];M=+h[j+352>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+qXa(c[b+536>>2]|0,q,46736,46904,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5288|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+qXa(c[b+536>>2]|0,q,46736,46904,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4808>>3]*.125));L=P*(+W(+(+h[g+5928>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+qXa(c[b+536>>2]|0,L,46912,46904,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5288|0;K=J;h[K>>3]=B;i=d;return}}function KT(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;_D(d,c[a+536>>2]|0,+h[f+5288>>3],+h[f+5128>>3],+h[f+6088>>3]+-6150.0,3850.0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5768>>3]=+h[d>>3];i=b;return}function LT(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+8184>>3]=+h[b+6248>>3]*+h[d+512>>3]*+h[d+2736>>3]*(+h[b+600>>3]*.5+(+h[b+632>>3]*-.5+(+h[b+7040>>3]+ +h[b+7048>>3])*.5));i=i;return}function MT(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+8168>>3];h[b+7856>>3]=d*+h[(!(d>=0.0)?b+9272|0:b+14600|0)>>3];i=i;return}function NT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8496>>3]=+h[b+7848>>3]- +h[b+7856>>3];i=i;return}function OT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8152>>3]=+h[b+8160>>3]- +h[b+8672>>3];i=i;return}function PT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8144>>3]=+h[b+8152>>3]- +h[b+8680>>3];i=i;return}function QT(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+528>>3]*+h[j+12240>>3]*+h[e+2736>>3];l=+h[j+8152>>3]+ +h[j+8144>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6264|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6264|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,47048,47040,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6264|0;r=q;h[r>>3]=o;i=d;return}function RT(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;GD(d,c[a+536>>2]|0,+h[f+6264>>3],+h[f+12240>>3],+h[f+5624>>3],+h[(c[a+416>>2]|0)+688>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6104>>3]=+h[d>>3];i=b;return}function ST(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+Ad(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6104>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4824|0;w=v;h[w>>3]=n;i=b;return}x=c[72300]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=48728;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Pe[a&127](y,d,47128,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4824|0;w=v;h[w>>3]=n;i=b;return}function TT(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6264>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4824>>3];l=+U(+(+h[j+6104>>3]));m=+h[j+5944>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?3.5:16.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+368>>3];q=n*p;r=q!=0.0;s=+h[o+688>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+qXa(c[b+536>>2]|0,q,47232,47224,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+5944>>3];u=+h[j+4824>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5304|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+qXa(c[b+536>>2]|0,q,47232,47224,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+688>>3];M=+h[j+368>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+qXa(c[b+536>>2]|0,q,47232,47224,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5304|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+qXa(c[b+536>>2]|0,q,47232,47224,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4824>>3]*.125));L=P*(+W(+(+h[g+5944>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+qXa(c[b+536>>2]|0,L,47304,47224,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5304|0;K=J;h[K>>3]=B;i=d;return}}function UT(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6264>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+6104>>3]));l=+h[j+5944>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?3.5:16.5)*+h[m+368>>3];o=+h[m+688>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+qXa(c[b+536>>2]|0,n,47232,47432,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+4984>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function VT(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+4984>>3]+-.7;h[b+5144>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function WT(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+8200>>3]=+h[b+6264>>3]*+h[d+528>>3]*+h[d+2736>>3]*(+h[b+568>>3]*.5+(+h[b+600>>3]*-.5+(+h[b+7056>>3]+ +h[b+7064>>3])*.5));i=i;return}function XT(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+8144>>3];h[b+7880>>3]=d*+h[(!(d>=0.0)?b+9248|0:b+9256|0)>>3];i=i;return}function YT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8136>>3]=+h[b+8144>>3]- +h[b+8688>>3];i=i;return}function ZT(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+536>>3]*+h[j+12248>>3]*+h[e+2736>>3];l=+h[j+8144>>3]+ +h[j+8136>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6272|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6272|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,47448,47440,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6272|0;r=q;h[r>>3]=o;i=d;return}function _T(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+8208>>3]=+h[b+6272>>3]*+h[d+536>>3]*+h[d+2736>>3]*(+h[b+552>>3]*.5+(+h[b+584>>3]*-.5+(+h[b+7064>>3]+ +h[b+7072>>3])*.5));i=i;return}function $T(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;GD(d,c[a+536>>2]|0,+h[f+6272>>3],+h[f+12248>>3],+h[f+5632>>3],+h[(c[a+416>>2]|0)+696>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6112>>3]=+h[d>>3];i=b;return}function aU(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6272>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+6112>>3]));l=+h[j+5952>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?4.5:15.5)*+h[m+376>>3];o=+h[m+696>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+qXa(c[b+536>>2]|0,n,47536,47528,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+4992>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function bU(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+4992>>3]+-.7;h[b+5152>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function cU(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+Ad(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6112>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4832|0;w=v;h[w>>3]=n;i=b;return}x=c[72300]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=48728;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Pe[a&127](y,d,47608,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4832|0;w=v;h[w>>3]=n;i=b;return}function dU(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6272>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4832>>3];l=+U(+(+h[j+6112>>3]));m=+h[j+5952>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?4.5:15.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+376>>3];q=n*p;r=q!=0.0;s=+h[o+696>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+qXa(c[b+536>>2]|0,q,47536,47704,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+5952>>3];u=+h[j+4832>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5312|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+qXa(c[b+536>>2]|0,q,47536,47704,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+696>>3];M=+h[j+376>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+qXa(c[b+536>>2]|0,q,47536,47704,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5312|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+qXa(c[b+536>>2]|0,q,47536,47704,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4832>>3]*.125));L=P*(+W(+(+h[g+5952>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+qXa(c[b+536>>2]|0,L,47712,47704,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5312|0;K=J;h[K>>3]=B;i=d;return}}function eU(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;_D(d,c[a+536>>2]|0,+h[f+5312>>3],+h[f+5152>>3],+h[f+6112>>3]+-6150.0,3850.0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5792>>3]=+h[d>>3];i=b;return}function fU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8128>>3]=+h[b+8136>>3]- +h[b+8696>>3];i=i;return}function gU(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+8128>>3];h[b+7896>>3]=d*+h[(!(d>=0.0)?b+9232|0:b+9240|0)>>3];i=i;return}function hU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8544>>3]=+h[b+7896>>3]- +h[b+7904>>3];i=i;return}function iU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8704>>3]=+h[b+8128>>3]- +h[b+8120>>3];i=i;return}function jU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9968>>3]=+h[b+8864>>3]*+h[b+9648>>3]+ +h[b+8704>>3]*+h[b+6840>>3];i=i;return}function kU(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+552>>3]*+h[j+12264>>3]*+h[e+2736>>3];l=+h[j+8128>>3]+ +h[j+8120>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6288|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6288|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,47848,47840,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6288|0;r=q;h[r>>3]=o;i=d;return}function lU(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;GD(d,c[a+536>>2]|0,+h[f+6288>>3],+h[f+12264>>3],+h[f+5648>>3],+h[(c[a+416>>2]|0)+712>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6128>>3]=+h[d>>3];i=b;return}function mU(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6288>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+6128>>3]));l=+h[j+5968>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?6.5:13.5)*+h[m+392>>3];o=+h[m+712>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+qXa(c[b+536>>2]|0,n,47936,47928,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+5008>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function nU(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+5008>>3]+-.7;h[b+5168>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function oU(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+Ad(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6128>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4848|0;w=v;h[w>>3]=n;i=b;return}x=c[72300]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=48728;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Pe[a&127](y,d,48008,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4848|0;w=v;h[w>>3]=n;i=b;return}function pU(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6288>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4848>>3];l=+U(+(+h[j+6128>>3]));m=+h[j+5968>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?6.5:13.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+392>>3];q=n*p;r=q!=0.0;s=+h[o+712>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+qXa(c[b+536>>2]|0,q,47936,48104,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+5968>>3];u=+h[j+4848>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5328|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+qXa(c[b+536>>2]|0,q,47936,48104,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+712>>3];M=+h[j+392>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+qXa(c[b+536>>2]|0,q,47936,48104,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5328|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+qXa(c[b+536>>2]|0,q,47936,48104,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4848>>3]*.125));L=P*(+W(+(+h[g+5968>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+qXa(c[b+536>>2]|0,L,48112,48104,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5328|0;K=J;h[K>>3]=B;i=d;return}}function qU(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+8224>>3]=+h[b+6288>>3]*+h[d+552>>3]*+h[d+2736>>3]*(+h[b+520>>3]*.5+(+h[b+552>>3]*-.5+(+h[b+7080>>3]+ +h[b+7088>>3])*.5));i=i;return}function rU(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+544>>3]*+h[j+12256>>3]*+h[e+2736>>3];l=+h[j+8136>>3]+ +h[j+8128>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6280|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6280|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,48248,48240,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6280|0;r=q;h[r>>3]=o;i=d;return}function sU(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+8216>>3]=+h[b+6280>>3]*+h[d+544>>3]*+h[d+2736>>3]*(+h[b+536>>3]*.5+(+h[b+568>>3]*-.5+(+h[b+7072>>3]+ +h[b+7080>>3])*.5));i=i;return}function tU(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;GD(d,c[a+536>>2]|0,+h[f+6280>>3],+h[f+12256>>3],+h[f+5640>>3],+h[(c[a+416>>2]|0)+704>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6120>>3]=+h[d>>3];i=b;return}function uU(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6280>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+6120>>3]));l=+h[j+5960>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?5.5:14.5)*+h[m+384>>3];o=+h[m+704>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+qXa(c[b+536>>2]|0,n,48336,48328,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+5e3>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function vU(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+5e3>>3]+-.7;h[b+5160>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function wU(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+Ad(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6120>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4840|0;w=v;h[w>>3]=n;i=b;return}x=c[72300]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=48728;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Pe[a&127](y,d,48408,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4840|0;w=v;h[w>>3]=n;i=b;return}function xU(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6280>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4840>>3];l=+U(+(+h[j+6120>>3]));m=+h[j+5960>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?5.5:14.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+384>>3];q=n*p;r=q!=0.0;s=+h[o+704>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+qXa(c[b+536>>2]|0,q,48336,48504,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+5960>>3];u=+h[j+4840>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5320|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+qXa(c[b+536>>2]|0,q,48336,48504,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+704>>3];M=+h[j+384>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+qXa(c[b+536>>2]|0,q,48336,48504,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5320|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+qXa(c[b+536>>2]|0,q,48336,48504,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4840>>3]*.125));L=P*(+W(+(+h[g+5960>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+qXa(c[b+536>>2]|0,L,48512,48504,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5320|0;K=J;h[K>>3]=B;i=d;return}}function yU(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;_D(d,c[a+536>>2]|0,+h[f+5320>>3],+h[f+5160>>3],+h[f+6120>>3]+-6150.0,3850.0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5800>>3]=+h[d>>3];i=b;return}function zU(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+8136>>3];h[b+7888>>3]=d*+h[(!(d>=0.0)?b+9240|0:b+9248|0)>>3];i=i;return}function AU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8528>>3]=+h[b+7880>>3]- +h[b+7888>>3];i=i;return}function BU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8368>>3]=+h[b+9952>>3]+(-+h[b+8528>>3]- +h[b+8208>>3]);i=i;return}function CU(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3816>>3]=-(+h[b+2696>>3]*+h[b+32>>3]*+h[d+1472>>3])- +h[d+8368>>3];i=i;return}function DU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8536>>3]=+h[b+7888>>3]- +h[b+7896>>3];i=i;return}function EU(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+520>>3]*+h[j+12232>>3]*+h[e+2736>>3];l=+h[j+8160>>3]+ +h[j+8152>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6256|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6256|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,48648,48640,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6256|0;r=q;h[r>>3]=o;i=d;return}function FU(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;GD(d,c[a+536>>2]|0,+h[f+6256>>3],+h[f+12232>>3],+h[f+5616>>3],+h[(c[a+416>>2]|0)+680>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6096>>3]=+h[d>>3];i=b;return}function GU(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+Ad(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6096>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4816|0;w=v;h[w>>3]=n;i=b;return}x=c[72300]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=48728;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Pe[a&127](y,d,48752,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4816|0;w=v;h[w>>3]=n;i=b;return}function HU(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+8192>>3]=+h[b+6256>>3]*+h[d+520>>3]*+h[d+2736>>3]*(+h[b+584>>3]*.5+(+h[b+616>>3]*-.5+(+h[b+7048>>3]+ +h[b+7056>>3])*.5));i=i;return}function IU(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+12232>>3];k=+h[g+10248>>3];l=j*j;m=+h[g+600>>3]*+h[g+10400>>3]-j*+h[g+1400>>3];if(l!=0.0){n=g;o=m/l;p=k+o;q=n;r=q+9616|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=k+o;q=n;r=q+9616|0;s=r;h[s>>3]=p;i=d;return}j=m/+qXa(c[b+536>>2]|0,l,48856,48848,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=k+o;q=n;r=q+9616|0;s=r;h[s>>3]=p;i=d;return}function JU(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+600>>3],+h[a+592>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+600>>3];l=+h[g+592>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+9264>>3]=+h[f>>3];i=b;return}function KU(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9264>>3];k=+h[g+12232>>3];l=+h[g+600>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,48904,48896,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6968>>3]=j-n;i=d;return}function LU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9936>>3]=+h[b+8832>>3]*+h[b+9616>>3]+ +h[b+8672>>3]*+h[b+6968>>3];i=i;return}function MU(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+88|0;d=b;e=b+40|0;f=b+80|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ID(e,c[g>>2]|0,1,+h[a+9264>>3],+h[a+12232>>3],+h[a+592>>3],+h[a+600>>3]);a=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+40|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));SD(f,a,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5936>>3]=+h[f>>3];i=b;return}function NU(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6256>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4816>>3];l=+U(+(+h[j+6096>>3]));m=+h[j+5936>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?2.5:17.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+360>>3];q=n*p;r=q!=0.0;s=+h[o+680>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+qXa(c[b+536>>2]|0,q,48944,48936,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+5936>>3];u=+h[j+4816>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5296|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+qXa(c[b+536>>2]|0,q,48944,48936,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+680>>3];M=+h[j+360>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+qXa(c[b+536>>2]|0,q,48944,48936,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5296|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+qXa(c[b+536>>2]|0,q,48944,48936,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4816>>3]*.125));L=P*(+W(+(+h[g+5936>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+qXa(c[b+536>>2]|0,L,49016,48936,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5296|0;K=J;h[K>>3]=B;i=d;return}}function OU(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6256>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+6096>>3]));l=+h[j+5936>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?2.5:17.5)*+h[m+360>>3];o=+h[m+680>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+qXa(c[b+536>>2]|0,n,48944,49144,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+4976>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function PU(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+4976>>3]+-.7;h[b+5136>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function QU(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+8160>>3];h[b+7864>>3]=d*+h[(!(d>=0.0)?b+9264|0:b+9272|0)>>3];i=i;return}function RU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8504>>3]=+h[b+7856>>3]- +h[b+7864>>3];i=i;return}function SU(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+8152>>3];h[b+7872>>3]=d*+h[(!(d>=0.0)?b+9256|0:b+9264|0)>>3];i=i;return}function TU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8520>>3]=+h[b+7872>>3]- +h[b+7880>>3];i=i;return}function UU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8512>>3]=+h[b+7864>>3]- +h[b+7872>>3];i=i;return}function VU(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3832>>3]=+h[b+3184>>3]*+h[d+14280>>3]*(+h[d+9296>>3]- +h[d+32>>3])*+h[b+3176>>3];i=i;return}function WU(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+8352>>3]=-(+h[b+2696>>3]*+h[b+16>>3]*+h[d+1456>>3])- +h[d+3832>>3];i=i;return}function XU(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+40>>3],+h[a+32>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+40>>3];l=+h[g+32>>3];m=+h[g+840>>3];n=+h[g+832>>3];g=d+0|0;o=e+0|0;e=g+120|0;do{c[g>>2]=c[o>>2];g=g+4|0;o=o+4|0}while((g|0)<(e|0));fF(f,a,k,l,d,m,n);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+10824>>3]=+h[f>>3];i=b;return}function YU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4152>>3]=+h[b+14120>>3]*+h[b+10824>>3];i=i;return}function ZU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3392>>3]=+h[b+4152>>3]+ +h[b+3384>>3];i=i;return}function _U(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3400>>3]=+h[b+4144>>3]+ +h[b+3392>>3];i=i;return}function $U(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3400>>3];h[b+3336>>3]=d*+h[(!(d>=0.0)?b+4512|0:b+4520|0)>>3];i=i;return}function aV(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3976>>3]=+h[b+3328>>3]- +h[b+3336>>3];i=i;return}function bV(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1752>>3]*+h[j+12520>>3]*+h[e+2968>>3];l=+h[j+3408>>3]+ +h[j+3400>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1720|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1720|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,49160,49152,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1720|0;r=q;h[r>>3]=o;i=d;return}function cV(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3656>>3]=+h[b+1720>>3]*+h[d+1752>>3]*+h[d+2968>>3]*(+h[b+56>>3]*.5+(+h[b+88>>3]*-.5+(+h[b+2520>>3]+ +h[b+2528>>3])*.5));i=i;return}function dV(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4136>>3]=+h[b+3408>>3]- +h[b+3400>>3];i=i;return}function eV(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10200>>3]=+h[b+4296>>3]*+h[b+9880>>3]+ +h[b+4136>>3]*+h[b+1912>>3];i=i;return}function fV(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1760>>3]*+h[j+12528>>3]*+h[e+2968>>3];l=+h[j+3400>>3]+ +h[j+3392>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1728|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1728|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,49256,49248,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1728|0;r=q;h[r>>3]=o;i=d;return}function gV(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3664>>3]=+h[b+1728>>3]*+h[d+1760>>3]*+h[d+2968>>3]*(+h[b+40>>3]*.5+(+h[b+72>>3]*-.5+(+h[b+2528>>3]+ +h[b+2536>>3])*.5));i=i;return}function hV(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+40>>3],+h[a+32>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+40>>3];l=+h[g+32>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12536>>3]=+h[f>>3];i=b;return}function iV(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4312>>3]=+h[b+14120>>3]*+h[b+12536>>3];i=i;return}function jV(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12536>>3],+h[f+32>>3],+h[f+40>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11160>>3]=+h[d>>3];i=b;return}function kV(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1768>>3]*+h[j+12536>>3]*+h[e+2968>>3];l=+h[j+3392>>3]+ +h[j+3384>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1736|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1736|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,49352,49344,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1736|0;r=q;h[r>>3]=o;i=d;return}function lV(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+12536>>3];k=+h[g+10672>>3];l=j*j;m=+h[g+40>>3]*+h[g+10824>>3]-j*+h[g+840>>3];if(l!=0.0){n=g;o=m/l;p=k+o;q=n;r=q+9896|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=k+o;q=n;r=q+9896|0;s=r;h[s>>3]=p;i=d;return}j=m/+qXa(c[b+536>>2]|0,l,49448,49440,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=k+o;q=n;r=q+9896|0;s=r;h[s>>3]=p;i=d;return}function mV(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+40>>3],+h[a+32>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+40>>3];l=+h[g+32>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4504>>3]=+h[f>>3];i=b;return}function nV(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4504>>3];k=+h[g+12536>>3];l=+h[g+40>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,49496,49488,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+1848>>3]=j-n;i=d;return}function oV(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10216>>3]=+h[b+4312>>3]*+h[b+9896>>3]+ +h[b+4152>>3]*+h[b+1848>>3];i=i;return}function pV(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3392>>3];h[b+3344>>3]=d*+h[(!(d>=0.0)?b+4504|0:b+4512|0)>>3];i=i;return}function qV(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3984>>3]=+h[b+3336>>3]- +h[b+3344>>3];i=i;return}



function WXa(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+88|0;f=e;j=e+24|0;k=e+72|0;l=d+0|0;m=l+48|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(m|0));l=mc(b|0,241232)|0;m=d;c[m>>2]=l;if((l|0)==0){n=be(c[(Qc()|0)>>2]|0)|0;i=e;return n|0}c[d+4>>2]=Hd(b|0)|0;c[d+36>>2]=0;b=f;l=d+44|0;o=f;p=f+12|0;q=f+16|0;r=f+4|0;s=f+8|0;f=j;t=k;u=d+8|0;v=d+12|0;w=d+16|0;x=d+20|0;y=d+28|0;z=d+24|0;A=d+32|0;B=d+40|0;d=1;C=0;a:while(1){D=vb(b|0,20,1,c[m>>2]|0)|0;a[l]=1;if((D|0)!=1){n=241240;E=131;break}D=c[o>>2]|0;if((D|0)!=(c[241208+(C<<2)>>2]|0)){if(!((C|0)>3&(D|0)==10)){n=241264;E=131;break}a[l]=0}F=c[p>>2]|0;if(F>>>0>1){n=241288;E=131;break}G=TXa(D)|0;if((G|0)==-1){n=241320;E=131;break}D=c[q>>2]|0;H=Wpb(D)|0;if((vb(H|0,D|0,1,c[m>>2]|0)|0)!=1){n=241368;E=131;break}if((a[H+(D+ -1)|0]|0)!=0){n=241392;E=131;break}D=c[r>>2]|0;I=c[s>>2]|0;J=fa(fa(fa(D,G)|0,I)|0,F+1|0)|0;if((uqb(H,c[241184+(C<<2)>>2]|0)|0)!=0){n=241416;E=131;break}Xpb(H);H=241992;b:do{switch(C|0){case 3:{F=fa(I<<2,D)|0;K=Wpb(F)|0;if((vb(K|0,F|0,1,c[m>>2]|0)|0)!=1){E=52;break a}do{if(d<<24>>24==0){if((D|0)==0){break}F=c[v>>2]|0;G=0;do{c[F+(G<<4)+8>>2]=(c[K+(G<<2)>>2]|0)==1;c[F+(G<<4)+12>>2]=c[K+(D+G<<2)>>2];G=G+1|0;}while(G>>>0<D>>>0)}else if(d<<24>>24==1){if((I|0)==0){break}G=c[v>>2]|0;F=0;do{L=fa(D,F)|0;c[G+(F<<4)+8>>2]=(c[K+(L<<2)>>2]|0)==1;c[G+(F<<4)+12>>2]=c[K+(L+1<<2)>>2];F=F+1|0;}while(F>>>0<I>>>0)}}while(0);Xpb(K);gc(c[v>>2]|0,c[u>>2]|0,16,54);M=d;E=130;break};case 4:{if(d<<24>>24==1){if((D|0)==0){n=241680;E=131;break a}if(!((I+ -1|0)>>>0<2)){n=241736;E=131;break a}c[w>>2]=D;F=fa(I,D)|0;if((a[l]|0)==1){G=Wpb(F<<3)|0;c[x>>2]=G;if((vb(G|0,J|0,1,c[m>>2]|0)|0)!=1){n=241776;E=131;break a}}else{G=Wpb(F<<2)|0;c[x>>2]=Wpb(fa(D<<3,I)|0)|0;if((vb(G|0,J|0,1,c[m>>2]|0)|0)!=1){n=241776;E=131;break a}if((F|0)!=0){L=c[x>>2]|0;N=0;do{h[L+(N<<3)>>3]=+g[G+(N<<2)>>2];N=N+1|0;}while(N>>>0<F>>>0)}Xpb(G)}F=c[w>>2]|0;if(!(F>>>0>1)){M=1;E=130;break b}N=(I|0)==2;L=1;while(1){if(N){O=c[x>>2]|0;if(+h[O+(L<<3)>>3]!=+h[O+(F+L<<3)>>3]){n=241808;E=131;break a}}O=L+1|0;if(O>>>0<F>>>0){L=O}else{M=1;E=130;break b}}}else if(!(d<<24>>24==0)){P=d;E=129;break b}if((I|0)==0){n=241680;E=131;break a}if(!((D+ -1|0)>>>0<2)){n=241888;E=131;break a}c[w>>2]=I;L=fa(I,D)|0;if((a[l]|0)==1){F=Wpb(L<<3)|0;c[x>>2]=Wpb(fa(D<<3,I)|0)|0;if((vb(F|0,J|0,1,c[m>>2]|0)|0)!=1){n=241776;E=131;break a}if((D|0)!=0){N=0;do{G=c[x>>2]|0;O=0;do{h[G+((fa(I,N)|0)+O<<3)>>3]=+h[F+((fa(D,O)|0)+N<<3)>>3];O=O+1|0;}while(O>>>0<I>>>0);N=N+1|0;}while(N>>>0<D>>>0)}Xpb(F)}else{N=Wpb(L<<2)|0;c[x>>2]=Wpb(fa(D<<3,I)|0)|0;if((vb(N|0,J|0,1,c[m>>2]|0)|0)!=1){n=241776;E=131;break a}if((D|0)!=0){O=0;do{G=c[x>>2]|0;Q=0;do{h[G+((fa(I,O)|0)+Q<<3)>>3]=+g[N+((fa(D,Q)|0)+O<<2)>>2];Q=Q+1|0;}while(Q>>>0<I>>>0);O=O+1|0;}while(O>>>0<D>>>0)}Xpb(N)}O=c[w>>2]|0;if(!(O>>>0>1)){M=d;E=130;break b}L=(D|0)==2;F=1;while(1){if(L){Q=c[x>>2]|0;if(+h[Q+(F<<3)>>3]!=+h[Q+(O+F<<3)>>3]){n=241808;E=131;break a}}Q=F+1|0;if(Q>>>0<O>>>0){F=Q}else{M=d;E=130;break}}break};case 5:{if(d<<24>>24==1){c[y>>2]=I;if(I>>>0<2){n=241928;E=131;break a}c[z>>2]=D;c[A>>2]=Bb(c[m>>2]|0)|0;c[B>>2]=Ypb(c[z>>2]<<1,4)|0;if((Zc(c[m>>2]|0,J|0,1)|0)==-1){n=241960;E=131;break a}else{M=1;E=130;break b}}else if(!(d<<24>>24==0)){n=0;E=131;break a}c[y>>2]=D;if(D>>>0<2){n=241928;E=131;break a}c[z>>2]=I;c[A>>2]=Bb(c[m>>2]|0)|0;c[B>>2]=Ypb(c[z>>2]<<1,4)|0;F=fa(I,D)|0;if((a[l]|0)==1){O=Wpb(F<<3)|0;if((vb(O|0,J|0,1,c[m>>2]|0)|0)!=1){n=241960;E=131;break a}if((I|0)!=0){L=D<<3;N=(D|0)==0;Q=D<<3;G=0;do{R=Wpb(L)|0;c[(c[B>>2]|0)+(G<<2)>>2]=R;if(!N){R=O+(fa(Q,G)|0)|0;Aqb(c[(c[B>>2]|0)+(G<<2)>>2]|0,R|0,Q|0)|0}G=G+1|0;}while(G>>>0<I>>>0)}G=c[z>>2]|0;Q=G<<1;if(G>>>0<Q>>>0){N=D<<3;L=(D|0)==0;R=G;do{S=Wpb(N)|0;c[(c[B>>2]|0)+(R<<2)>>2]=S;if(!L){S=c[B>>2]|0;T=c[S+(R-G<<2)>>2]|0;U=c[S+(R<<2)>>2]|0;S=0;do{h[U+(S<<3)>>3]=-+h[T+(S<<3)>>3];S=S+1|0;}while(S>>>0<D>>>0)}R=R+1|0;}while(R>>>0<Q>>>0)}Xpb(O)}else{Q=Wpb(F<<2)|0;if((vb(Q|0,J|0,1,c[m>>2]|0)|0)!=1){n=241960;E=131;break a}if((I|0)!=0){R=D<<3;G=(D|0)==0;L=0;do{N=Wpb(R)|0;c[(c[B>>2]|0)+(L<<2)>>2]=N;if(!G){N=c[(c[B>>2]|0)+(L<<2)>>2]|0;S=0;do{h[N+(S<<3)>>3]=+g[Q+((fa(D,L)|0)+S<<2)>>2];S=S+1|0;}while(S>>>0<D>>>0)}L=L+1|0;}while(L>>>0<I>>>0)}L=c[z>>2]|0;G=L<<1;if(L>>>0<G>>>0){R=D<<3;F=(D|0)==0;O=L;do{S=Wpb(R)|0;c[(c[B>>2]|0)+(O<<2)>>2]=S;if(!F){S=c[B>>2]|0;N=c[S+(O-L<<2)>>2]|0;T=c[S+(O<<2)>>2]|0;S=0;do{h[T+(S<<3)>>3]=-+h[N+(S<<3)>>3];S=S+1|0;}while(S>>>0<D>>>0)}O=O+1|0;}while(O>>>0<G>>>0)}Xpb(Q)}if((Zc(c[m>>2]|0,J|0,1)|0)==-1){n=241960;E=131;break a}else{M=d;E=130}break};case 1:{G=d<<24>>24==0;c[u>>2]=G?D:I;O=Wpb((G?D:I)<<4)|0;c[v>>2]=O;c:do{if(d<<24>>24==1){if((I|0)==0){V=0;break}L=D+1|0;F=O;R=0;while(1){c[F+(R<<4)>>2]=Wpb(L)|0;if((vb(c[(c[v>>2]|0)+(R<<4)>>2]|0,D|0,1,c[m>>2]|0)|0)!=1){n=241616;E=131;break a}a[(c[(c[v>>2]|0)+(R<<4)>>2]|0)+D|0]=0;S=c[v>>2]|0;c[S+(R<<4)+8>>2]=-1;c[S+(R<<4)+12>>2]=-1;VXa(c[S+(R<<4)>>2]|0);S=R+1|0;if(!(S>>>0<I>>>0)){V=I;break c}F=c[v>>2]|0;R=S}}else{V=I}}while(0);if(!G){M=d;E=130;break b}O=fa(D,V)|0;W=Wpb(O+1|0)|0;if((vb(W|0,O|0,1,c[m>>2]|0)|0)!=1){E=33;break a}if((D|0)!=0){O=V+1|0;Q=(V|0)==0;R=0;do{F=Wpb(O)|0;c[(c[v>>2]|0)+(R<<4)>>2]=F;if(!Q){F=0;do{L=a[W+((fa(D,F)|0)+R)|0]|0;a[(c[(c[v>>2]|0)+(R<<4)>>2]|0)+F|0]=L;F=F+1|0;}while(F>>>0<V>>>0)}a[(c[(c[v>>2]|0)+(R<<4)>>2]|0)+V|0]=0;F=c[v>>2]|0;c[F+(R<<4)+8>>2]=-1;c[F+(R<<4)+12>>2]=-1;VXa(c[F+(R<<4)>>2]|0);R=R+1|0;}while(R>>>0<D>>>0)}Xpb(W);M=0;E=130;break};case 0:{if((D|0)!=4){n=241440;E=131;break a}if((I|0)!=11){n=241480;E=131;break a}if((vb(f|0,44,1,c[m>>2]|0)|0)==1){X=0}else{n=241520;E=131;break a}while(1){R=0;do{a[k+R|0]=a[j+((R<<2)+X)|0]|0;R=R+1|0;}while(R>>>0<11);a[k+11|0]=0;if((X|0)==3){break}R=X+1|0;if(R>>>0<4){X=R}else{M=d;E=130;break b}}if((vqb(t,c[60272]|0,8)|0)==0){M=1;E=130;break b}if((vqb(t,c[60278]|0,9)|0)==0){M=0;E=130}else{n=241552;E=131;break a}break};case 2:{if(d<<24>>24==1){if((I|0)==0){P=1;E=129;break b}R=D+1|0;Q=0;while(1){O=Wpb(R)|0;c[(c[v>>2]|0)+(Q<<4)+4>>2]=O;if((vb(c[(c[v>>2]|0)+(Q<<4)+4>>2]|0,D|0,1,c[m>>2]|0)|0)!=1){n=241616;E=131;break a}a[(c[(c[v>>2]|0)+(Q<<4)+4>>2]|0)+D|0]=0;O=Q+1|0;if(O>>>0<I>>>0){Q=O}else{M=1;E=130;break b}}}else if(!(d<<24>>24==0)){P=d;E=129;break b}Q=fa(D,I)|0;Y=Wpb(Q+1|0)|0;if((vb(Y|0,Q|0,1,c[m>>2]|0)|0)!=1){E=46;break a}if((D|0)!=0){Q=I+1|0;R=(I|0)==0;O=0;do{G=Wpb(Q)|0;c[(c[v>>2]|0)+(O<<4)+4>>2]=G;if(!R){G=0;do{F=a[Y+((fa(D,G)|0)+O)|0]|0;a[(c[(c[v>>2]|0)+(O<<4)+4>>2]|0)+G|0]=F;G=G+1|0;}while(G>>>0<I>>>0)}a[(c[(c[v>>2]|0)+(O<<4)+4>>2]|0)+I|0]=0;O=O+1|0;}while(O>>>0<D>>>0)}Xpb(Y);M=0;E=130;break};default:{n=H;E=131;break a}}}while(0);if((E|0)==129){E=0;d=P;C=C+1|0;continue}else if((E|0)==130){E=0;H=C+1|0;if((H|0)<6){d=M;C=H;continue}else{n=0;E=131;break}}}if((E|0)==33){Xpb(W);n=241616;i=e;return n|0}else if((E|0)==46){Xpb(Y);n=241616;i=e;return n|0}else if((E|0)==52){Xpb(K);n=241648;i=e;return n|0}else if((E|0)==131){i=e;return n|0}return 0}function XXa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;b=Ld(e|0,c[a+12>>2]|0,c[a+8>>2]|0,16,54)|0;i=d;return b|0}function YXa(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;f=(d|0)>-1?d:0-d|0;j=(d|0)<0;do{if(j){k=c[b+24>>2]|0;l=k+f|0;m=k}else{if((d|0)==0){n=242032;o=n;p=242080;q=p;r=242104;s=r;db(o|0,q|0,399,s|0)}else{l=f;m=c[b+24>>2]|0;break}}}while(0);d=l+ -1|0;l=b+24|0;if(f>>>0>m>>>0){n=242032;o=n;p=242080;q=p;r=242104;s=r;db(o|0,q|0,399,s|0)}s=b+40|0;q=c[(c[s>>2]|0)+(d<<2)>>2]|0;if((q|0)!=0){t=q;i=e;return t|0}q=b+28|0;o=c[q>>2]|0;r=Wpb(o<<3)|0;p=r;a:do{if((a[b+44|0]|0)==1){if((o|0)==0){break}n=b;m=b+32|0;k=0;while(1){Zc(c[n>>2]|0,(c[m>>2]|0)+ -8+((fa(c[l>>2]|0,k)|0)+f<<3)|0,0)|0;u=r+(k<<3)|0;if((vb(u|0,8,1,c[n>>2]|0)|0)!=1){break}if(j){h[u>>3]=-+h[u>>3]}k=k+1|0;if(!(k>>>0<(c[q>>2]|0)>>>0)){break a}}Xpb(r);t=0;i=e;return t|0}else{k=Wpb(o<<2)|0;b:do{if((o|0)==0){v=0}else{n=b;m=b+32|0;u=0;while(1){Zc(c[n>>2]|0,(c[m>>2]|0)+ -4+((fa(c[l>>2]|0,u)|0)+f<<2)|0,0)|0;w=u+1|0;if((vb(k+(u<<2)|0,4,1,c[n>>2]|0)|0)!=1){break}x=c[q>>2]|0;if(w>>>0<x>>>0){u=w}else{v=x;break b}}Xpb(k);Xpb(r);t=0;i=e;return t|0}}while(0);u=(v|0)==0;do{if(j){if(u){break}else{y=0}do{h[r+(y<<3)>>3]=-+g[k+(y<<2)>>2];y=y+1|0;}while(y>>>0<v>>>0)}else{if(u){break}else{z=0}do{h[r+(z<<3)>>3]=+g[k+(z<<2)>>2];z=z+1|0;}while(z>>>0<v>>>0)}}while(0);Xpb(k)}}while(0);c[(c[s>>2]|0)+(d<<2)>>2]=p;t=c[(c[s>>2]|0)+(d<<2)>>2]|0;i=e;return t|0}function ZXa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0;j=i;i=i+8|0;k=j;l=(e|0)>-1?e:0-e|0;m=(e|0)<0;do{if(m){n=c[d+24>>2]|0;o=n+l|0;p=n}else{if((e|0)==0){q=242032;r=q;s=242080;t=s;u=242128;v=u;db(r|0,t|0,519,v|0)}else{o=l;p=c[d+24>>2]|0;break}}}while(0);if(l>>>0>p>>>0){q=242032;r=q;s=242080;t=s;u=242128;v=u;db(r|0,t|0,519,v|0)}v=c[(c[d+40>>2]|0)+(o+ -1<<2)>>2]|0;if((v|0)!=0){h[b>>3]=+h[v+(f<<3)>>3];w=0.0;i=j;return+w}v=d;o=c[v>>2]|0;t=c[d+32>>2]|0;r=l+ -1+(fa(p,f)|0)|0;do{if((a[d+44|0]|0)==1){Zc(o|0,t+(r<<3)|0,0)|0;f=(vb(b|0,8,1,c[v>>2]|0)|0)!=1;if(f|m^1){w=f?1.0:0.0;i=j;return+w}else{x=+h[b>>3];break}}else{Zc(o|0,t+(r<<2)|0,0)|0;if((vb(k|0,4,1,c[v>>2]|0)|0)!=1){w=1.0;i=j;return+w}y=+g[k>>2];h[b>>3]=y;if(m){x=y;break}else{w=0.0}i=j;return+w}}while(0);h[b>>3]=-x;w=0.0;i=j;return+w}function _Xa(a,b,d,e,f,g,j){a=+a;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0;k=i;l=d+ -1|0;d=0;while(1){m=((l-d|0)/2|0)+d|0;n=+h[b+(m<<3)>>3];if(n==a){o=n;p=m;q=3;break}r=n<a;s=r?m+1|0:d;t=r?l:m+ -1|0;if((t|0)>(s|0)){l=t;d=s}else{break}}if((q|0)==3){while(1){q=0;if((p|0)>=(l|0)){break}d=p+1|0;n=+h[b+(d<<3)>>3];if(o==n){o=n;p=d;q=3}else{break}}c[e>>2]=p;h[f>>3]=1.0;c[g>>2]=-1;u=0.0;h[j>>3]=u;i=k;return}do{if((t|0)==(s|0)){if(+h[b+(s<<3)>>3]<a){v=s+1|0;w=s;break}else{v=s;w=s+ -1|0;break}}else{v=t;w=s}}while(0);c[e>>2]=v;c[g>>2]=w;o=+h[b+(w<<3)>>3];n=(a-o)/(+h[b+(v<<3)>>3]-o);h[f>>3]=n;u=1.0-n;h[j>>3]=u;i=k;return}function $Xa(a){a=a|0;i=i;return+(+h[c[a+20>>2]>>3])}function aYa(a){a=a|0;i=i;return+(+h[(c[a+20>>2]|0)+(c[a+16>>2]<<3)>>3])}function bYa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0;f=i;i=i+48|0;g=f;j=f+8|0;k=f+16|0;l=f+24|0;m=f+32|0;n=f+40|0;if((c[d+8>>2]|0)!=0){o=c[d+12>>2]|0;if((o|0)<0){p=-+h[(c[b+20>>2]|0)+(~o<<3)>>3]}else{p=+h[(c[b+20>>2]|0)+(o+ -1<<3)>>3]}h[a>>3]=p;q=0;i=f;return q|0}if(+aYa(b)<e){q=1;i=f;return q|0}if(+$Xa(b)>e){q=1;i=f;return q|0}if((YXa(b,1)|0)==0){q=1;i=f;return q|0}_Xa(e,c[c[b+40>>2]>>2]|0,c[b+28>>2]|0,m,g,n,j);o=c[n>>2]|0;if((o|0)==-1){q=~~+ZXa(a,b,c[d+12>>2]|0,c[m>>2]|0);i=f;return q|0}n=c[m>>2]|0;m=d+12|0;d=c[m>>2]|0;if((n|0)==-1){q=~~+ZXa(a,b,d,o);i=f;return q|0}if(+ZXa(k,b,d,n)!=0.0){q=1;i=f;return q|0}if(+ZXa(l,b,c[m>>2]|0,o)!=0.0){q=1;i=f;return q|0}h[a>>3]=+h[g>>3]*+h[k>>3]+ +h[j>>3]*+h[l>>3];q=0;i=f;return q|0}function cYa(a,b){a=a|0;b=b|0;i=i;return+(+h[(c[a+8>>2]|0)+(b<<3)>>3])}function dYa(a,b){a=a|0;b=b|0;var c=0;c=i;ZWa(a,b,EXa(b)|0);i=c;return}function eYa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;c[a+8>>2]=EXa(_Wa(a,b,f)|0)|0;i=e;return}function fYa(a,b,c){a=a|0;b=b|0;c=+c;h[a+(b<<3)>>3]=c;i=i;return}function gYa(a,b){a=a|0;b=b|0;i=i;return a+(b<<3)|0}function hYa(a,b,d){a=+a;b=b|0;d=d|0;var e=0;e=i;fYa(c[d+8>>2]|0,b,a);i=e;return}function iYa(a,b,d,e){a=a|0;b=b|0;d=+d;e=e|0;var f=0,g=0,j=0,k=0;f=i;i=i+16|0;g=f;dYa(a,b);j=g;c[g>>2]=e;hYa(d,0,a);if((b|0)>1){k=1}else{i=f;return}do{e=c[j>>2]|0;d=+h[e>>3];c[j>>2]=e+8;hYa(d,k,a);k=k+1|0;}while((k|0)<(b|0));i=f;return}function jYa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;d=$Wa(a,b,f)|0;f=gYa(c[a+8>>2]|0,d)|0;i=e;return f|0}function kYa(a){a=a|0;var b=0,c=0,d=0.0,e=0,f=0.0,g=0.0,h=0;b=i;if((XWa(a)|0)==0){db(242184,242160,1547,242208)}c=YWa(a)|0;if((c|0)==0){d=0.0;i=b;return+d}else{e=0;f=0.0}while(1){g=f+ +cYa(a,e);h=e+1|0;if(h>>>0<c>>>0){f=g;e=h}else{d=g;break}}i=b;return+d}function lYa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=i;i=i+8|0;f=Wpb(20)|0;nXa(0,(f|0)!=0|0,242224,e);c[f+8>>2]=0;c[f+12>>2]=0;e=(a|0)<1?1:a;c[f+16>>2]=e;c[f+4>>2]=b;a=Ypb(e,b)|0;c[f>>2]=a;nXa(0,(a|0)!=0|0,242224,d);i=d;return f|0}function mYa(a){a=a|0;var b=0;b=i;Xpb(c[a>>2]|0);Xpb(a);i=b;return}function nYa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=i;i=i+16|0;g=i;i=i+8|0;h=a+12|0;nXa(0,(c[h>>2]|0)>0|0,242240,g);g=c[h>>2]|0;c[f>>2]=b;c[f+4>>2]=1-g;c[f+8>>2]=g+ -1;nXa(0,(g|0)>(b|0)|0,242264,f);f=c[h>>2]|0;c[e>>2]=b;c[e+4>>2]=1-f;c[e+8>>2]=f+ -1;nXa(0,(0-f|0)<(b|0)|0,242264,e);e=(c[a>>2]|0)+(fa(c[a+4>>2]|0,((c[a+8>>2]|0)+b|0)%(c[a+16>>2]|0)|0)|0)|0;i=d;return e|0}function oYa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;d=a+16|0;e=a+4|0;f=Ypb(c[d>>2]<<1,c[e>>2]|0)|0;nXa(0,(f|0)!=0|0,242224,b);g=a+12|0;if((c[g>>2]|0)>0){h=c[e>>2]|0;j=0;do{k=f+(fa(h,j)|0)|0;l=nYa(a,j)|0;h=c[e>>2]|0;Aqb(k|0,l|0,h|0)|0;j=j+1|0;}while((j|0)<(c[g>>2]|0))}g=a;Xpb(c[g>>2]|0);c[g>>2]=f;c[d>>2]=c[d>>2]<<1;c[a+8>>2]=0;i=b;return}function pYa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=a+16|0;f=c[e>>2]|0;g=a+12|0;h=c[g>>2]|0;if((f|0)<(h+1|0)){oYa(a);j=c[e>>2]|0;k=c[g>>2]|0}else{j=f;k=h}h=c[a+4>>2]|0;Aqb((c[a>>2]|0)+(fa(h,(k+(c[a+8>>2]|0)|0)%(j|0)|0)|0)|0,b|0,h|0)|0;c[g>>2]=(c[g>>2]|0)+1;i=d;return}function qYa(a){a=a|0;i=i;return c[a+12>>2]|0}function rYa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;h=i;i=i+8|0;j=a+12|0;nXa(0,(c[j>>2]|0)>0|0,242240,h);h=c[j>>2]|0;c[g>>2]=b;c[g+4>>2]=0;c[g+8>>2]=h+ -1;nXa(0,(h|0)>(b|0)|0,242264,g);g=(c[j>>2]|0)+ -1|0;c[f>>2]=b;c[f+4>>2]=0;c[f+8>>2]=g;nXa(0,b>>>31^1,242264,f);f=a+8|0;g=c[a+16>>2]|0;c[f>>2]=((fa(g+ -1|0,b)|0)+(c[f>>2]|0)|0)%(g|0)|0;if((d|0)==0){i=e;return}if((c[j>>2]|0)>0){k=0}else{i=e;return}do{c[d+(k<<2)>>2]=nYa(a,k)|0;k=k+1|0;}while((k|0)<(c[j>>2]|0));i=e;return}function sYa(a){a=a|0;i=i;return c[(c[60574]|0)+(a<<2)>>2]|0}function tYa(a){a=a|0;i=i;return c[(c[60576]|0)+(a<<2)>>2]|0}function uYa(a){a=a|0;i=i;return c[(c[60578]|0)+(a<<2)>>2]|0}function vYa(a){a=a|0;i=i;return c[(c[60580]|0)+(a<<2)>>2]|0}function wYa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=(c[60576]|0)+(a<<2)|0;e=c[d>>2]|0;f=(c[60578]|0)+(a<<2)|0;g=c[f>>2]|0;h=c[(c[60574]|0)+(a<<2)>>2]|0;if((h|0)==0){i=b;return}c[d>>2]=(e|0)!=0&e>>>0<h>>>0?e:h;c[f>>2]=g>>>0>h>>>0?g:h;i=b;return}function xYa(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[60582]|0;e=+yYa(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function yYa(a,b){a=a|0;b=b|0;i=i;return+(+(a|0)+ +(b|0)*1.0e-9)}function zYa(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[60584]|0;e=+yYa(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function AYa(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[60586]|0;e=+yYa(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function BYa(a){a=a|0;i=i;return 0}function CYa(a){a=a|0;var b=0,d=0;b=i;hb(4,(c[60588]|0)+(a<<3)|0)|0;d=(c[60574]|0)+(a<<2)|0;c[d>>2]=(c[d>>2]|0)+1;i=b;return}function DYa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=c[60582]|0;f=e+(a<<3)|0;g=c[60586]|0;h=g+(a<<3)|0;c[h>>2]=(c[h>>2]|0)+(c[f>>2]|0);h=e+(a<<3)+4|0;e=g+(a<<3)+4|0;c[e>>2]=(c[e>>2]|0)+(c[h>>2]|0);e=(c[60580]|0)+(a<<2)|0;c[e>>2]=(c[e>>2]|0)+(c[(c[60574]|0)+(a<<2)>>2]|0);e=c[60584]|0;g=e+(a<<3)|0;EYa(d,c[g>>2]|0,c[e+(a<<3)+4>>2]|0,c[f>>2]|0,c[h>>2]|0);h=d;d=c[h+4>>2]|0;f=g;c[f>>2]=c[h>>2];c[f+4>>2]=d;wYa(a);d=c[60582]|0;c[d+(a<<3)>>2]=0;c[d+(a<<3)+4>>2]=0;c[(c[60574]|0)+(a<<2)>>2]=0;i=b;return}function EYa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;h=(HYa(b,d,e,f)|0)<0;if(h){j=e;k=f}else{j=b;k=d}d=a;c[d>>2]=j;c[d+4>>2]=k;i=g;return}function FYa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+8|0;d=b;e=d;c[e>>2]=0;c[e+4>>2]=0;hb(4,d|0)|0;e=c[60588]|0;f=c[60582]|0;g=f+(a<<3)|0;h=(c[d>>2]|0)-(c[e+(a<<3)>>2]|0)+(c[g>>2]|0)|0;c[g>>2]=h;j=f+(a<<3)+4|0;f=(c[d+4>>2]|0)-(c[e+(a<<3)+4>>2]|0)+(c[j>>2]|0)|0;c[j>>2]=f;if((f|0)<=999999999){i=b;return}c[g>>2]=h+1;c[j>>2]=~~(+(f|0)+-1.0e9);i=b;return}function GYa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;if((a|0)<33){i=b;return}d=Ypb(a,8)|0;c[60582]=d;e=Ypb(a,8)|0;c[60584]=e;f=Ypb(a,8)|0;c[60586]=f;g=Ypb(a,8)|0;c[60588]=g;h=Ypb(a,4)|0;c[60574]=h;j=Ypb(a,4)|0;c[60580]=j;k=a<<2;l=Wpb(k)|0;c[60576]=l;m=Ypb(a,4)|0;c[60578]=m;Cqb(l|0,-1,k|0)|0;if((d|0)==0){db(242360,242376,393,242392)}if((e|0)==0){db(242400,242376,394,242392)}if((f|0)==0){db(242416,242376,395,242392)}if((g|0)==0){db(242432,242376,396,242392)}if((h|0)==0){db(242448,242376,397,242392)}if((l|0)==0){db(242472,242376,398,242392)}if((m|0)==0){db(242496,242376,399,242392)}if((j|0)==0){db(242520,242376,400,242392)}else{i=b;return}}function HYa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;i=i;return((a|0)==(c|0)?b-d|0:a-c|0)|0}function IYa(a,b){a=a|0;b=b|0;var c=0;c=i;ZWa(a,b,FXa(b)|0);i=c;return}function JYa(a,b,d){a=a|0;b=b|0;d=d|0;c[a+(b<<2)>>2]=d;i=i;return}function KYa(a,b){a=a|0;b=b|0;i=i;return a+(b<<2)|0}function LYa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;JYa(c[d+8>>2]|0,b,a);i=e;return}function MYa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f;IYa(a,b);h=g;c[g>>2]=e;LYa(d,0,a);if((b|0)>1){j=1}else{i=f;return}do{d=c[h>>2]|0;e=c[d>>2]|0;c[h>>2]=d+4;LYa(e,j,a);j=j+1|0;}while((j|0)<(b|0));i=f;return}function NYa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;d=$Wa(a,b,f)|0;f=KYa(c[a+8>>2]|0,d)|0;i=e;return f|0}function OYa(a,b){a=+a;b=b|0;var c=0,d=0,e=0,f=0.0,g=0.0,h=0,j=0.0,k=0.0;c=i;d=(b|0)<0;e=d?0-b|0:b;if((e|0)==0){f=1.0}else{b=e;g=a;a=1.0;while(1){if((b&1|0)==0){h=b;j=a}else{h=b+ -1|0;j=a*g}if((h+1|0)>>>0<3){f=j;break}else{b=(h|0)/2|0;g=g*g;a=j}}}if(!d){k=f;i=c;return+k}k=1.0/f;i=c;return+k}function PYa(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+8|0;o=n;c[o>>2]=1;c[n+4>>2]=c[b>>2];if((a|0)==1){c[l>>2]=c[b+8>>2];n=l+4|0;h[k>>3]=d;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];lXa(17,0,o,244200,l);i=e;return}else if((a|0)==2){c[j>>2]=c[b+8>>2];l=j+4|0;h[k>>3]=d;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];lXa(17,0,o,244304,j);i=e;return}else if((a|0)==3){c[g>>2]=c[b+8>>2];j=g+4|0;h[k>>3]=d;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];lXa(17,0,o,244400,g);i=e;return}else if((a|0)==0){c[m>>2]=c[b+8>>2];g=m+4|0;h[k>>3]=d;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];lXa(17,0,o,244152,m);i=e;return}else{m=c[b+8>>2]|0;c[f>>2]=a;c[f+4>>2]=m;m=f+8|0;h[k>>3]=d;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];lXa(17,0,o,244464,f);i=e;return}}function QYa(a){a=a|0;var b=0;b=i;Xpb(c[a+12>>2]|0);Xpb(c[a+4>>2]|0);Xpb(c[a+8>>2]|0);i=b;return}function RYa(a){a=a|0;var b=0,d=0;b=i;d=c[r>>2]|0;Rd(a|0,d|0)|0;Bd(d|0)|0;me[c[72304]&2047](0);i=b;return}function SYa(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0,W=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0.0,Ha=0,Ia=0.0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0.0,ib=0.0,jb=0.0,kb=0.0,lb=0,mb=0.0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0.0,ub=0.0,vb=0;v=i;w=c[d>>2]|0;x=~w;y=c[l>>2]|0;z=~y;h[31161]=.5;h[31147]=1.0;h[31184]=.25;h[31159]=2.0;h[31186]=6.283185307179586;A=w+ -1-(c[b>>2]|0)|0;c[62330]=A;B=c[d>>2]|0;c[62260]=1;if((B|0)>=1){C=1;while(1){h[p+(C+ -1+(c[b>>2]|0)<<3)>>3]=0.0;D=C+1|0;c[62260]=D;if((C|0)<(B|0)){C=D}else{break}}}c[62258]=1;if((A|0)>=1){C=1;while(1){B=fa(C,w)|0;E=+h[j+(B+x+(c[n>>2]|0)<<3)>>3];h[31162]=E;if((C|0)<(c[k>>2]|0)){F=-E;h[31162]=F;G=F}else{G=E}D=c[d>>2]|0;c[62260]=1;a:do{if((D|0)>=1){E=G;H=1;while(1){I=p+(H+ -1+(c[b>>2]|0)<<3)|0;h[I>>3]=E*+h[j+(H+x+B<<3)>>3]+ +h[I>>3];I=H+1|0;c[62260]=I;if((H|0)>=(D|0)){break a}E=+h[31162];H=I}}}while(0);D=C+1|0;c[62258]=D;if((C|0)<(A|0)){C=D}else{break}}}C=c[b>>2]|0;h[31166]=+h[p+(C+ -1+(c[n>>2]|0)<<3)>>3];h[31131]=0.0;h[31133]=0.0;h[31137]=0.0;h[31194]=0.0;c[62256]=1;if((C|0)<1){J=0.0;K=0.0;L=0.0}else{G=0.0;A=1;while(1){D=A+ -1|0;B=o+(D<<3)|0;E=+h[B>>3];h[31131]=G+E*E;E=+h[f+((c[n>>2]|0)+x+(fa(A,w)|0)<<3)>>3];H=e+(D<<3)|0;F=E- +h[H>>3];I=s+(D<<3)|0;h[I>>3]=F;E=+h[31133]+ +h[B>>3]*F;h[31133]=E;F=+h[I>>3];M=+h[31137]+F*F;h[31137]=M;F=+h[H>>3];h[31194]=+h[31194]+F*F;H=A+1|0;c[62256]=H;F=+h[31131];if((A|0)<(C|0)){A=H;G=F}else{J=M;K=F;L=E;break}}}G=L*L;do{if(G>K*.99*J){A=c[n>>2]|0;c[62326]=A;E=G/J;h[31183]=E;C=c[d>>2]|0;c[62260]=1;if((C|0)<1){N=J;O=L;P=A}else{F=J;M=L;Q=E;H=A;A=1;while(1){do{if((A|0)==(c[m>>2]|0)){R=F;S=M;T=Q;U=H}else{h[31191]=0.0;h[31193]=0.0;I=c[b>>2]|0;c[62256]=1;if((I|0)<1){W=0.0;Z=0.0}else{E=0.0;_=0.0;B=1;while(1){$=+h[f+((fa(B,w)|0)+x+A<<3)>>3];aa=$- +h[e+(B+ -1<<3)>>3];h[31160]=aa;ba=_+aa*+h[o+(B+ -1<<3)>>3];h[31191]=ba;ca=E+aa*aa;h[31193]=ca;if((B|0)<(I|0)){B=B+1|0;_=ba;E=ca}else{break}}c[62256]=I+1;W=ca;Z=ba}E=Z*Z/W;if(!(E<Q)){R=F;S=M;T=Q;U=H;break}c[62326]=A;h[31183]=E;h[31133]=Z;h[31137]=W;R=W;S=Z;T=E;U=A}}while(0);B=A+1|0;c[62260]=B;if((A|0)<(C|0)){F=R;M=S;Q=T;H=U;A=B}else{N=R;O=S;P=U;break}}}A=c[b>>2]|0;c[62256]=1;if((A|0)<1){da=O;ea=N;ga=K;break}else{ha=1}while(1){Q=+h[f+((fa(ha,w)|0)+x+P<<3)>>3];H=ha+ -1|0;h[s+(H<<3)>>3]=Q- +h[e+(H<<3)>>3];if((ha|0)<(A|0)){ha=ha+1|0}else{break}}c[62256]=A+1;da=+h[31133];ea=+h[31137];ga=+h[31131]}else{da=L;ea=J;ga=K}}while(0);K=ga*ea-da*da;h[31182]=K;c[62354]=0;h[31190]=0.0;ha=(y<<1)+z|0;P=(y<<2)+z|0;U=(y*3|0)+z|0;H=(y*5|0)+z|0;ea=da;da=ga;ga=K;C=1;while(1){c[62354]=C;K=+h[31147]/+V(+ga);h[31162]=K;h[31185]=0.0;h[31187]=0.0;B=c[b>>2]|0;c[62256]=1;if((B|0)<1){ia=da;ja=0.0;ka=0.0}else{J=ea;L=da;N=K;D=1;la=0;while(1){ma=s+(la<<3)|0;h[ma>>3]=N*(L*+h[ma>>3]-J*+h[o+(la<<3)>>3]);ma=D+ -1|0;na=e+(ma<<3)|0;oa=+h[31185]+ +h[na>>3]*+h[o+(ma<<3)>>3];h[31185]=oa;pa=+h[31187]+ +h[na>>3]*+h[s+(ma<<3)>>3];h[31187]=pa;if((D|0)>=(B|0)){break}ma=D;J=+h[31133];L=+h[31131];N=+h[31162];D=D+1|0;la=ma}c[62256]=B+1;ia=+h[31131];ja=pa;ka=oa}N=+h[31161];L=ka*N*ka;h[31178]=L;J=ja*N*ja;h[31179]=J;h[31138]=J+(L+ia*(+h[31194]+ia*N));N=+h[31159];h[249112>>3]=N*ka*ia;h[249120>>3]=N*ja*ia;h[249128>>3]=L-J;h[249136>>3]=ka*ja;la=249144|0;c[la+0>>2]=0;c[la+4>>2]=0;c[la+8>>2]=0;c[la+12>>2]=0;c[la+16>>2]=0;c[la+20>>2]=0;c[la+24>>2]=0;c[la+28>>2]=0;c[62256]=10;la=c[d>>2]|0;c[62260]=1;if((la|0)>=1){D=1;while(1){h[31178]=0.0;h[31179]=0.0;h[31180]=0.0;A=c[b>>2]|0;c[62256]=1;if((A|0)<1){qa=0.0;ra=0.0}else{ma=D+x|0;J=0.0;L=0.0;N=0.0;na=1;while(1){K=+h[f+((fa(na,w)|0)+x+D<<3)>>3];sa=N+K*+h[o+(na+ -1<<3)>>3];h[31178]=sa;ta=f+(ma+(fa(na,w)|0)<<3)|0;ua=na+ -1|0;va=L+ +h[ta>>3]*+h[s+(ua<<3)>>3];h[31179]=va;K=J+ +h[ta>>3]*+h[e+(ua<<3)>>3];h[31180]=K;if((na|0)<(A|0)){na=na+1|0;N=sa;L=va;J=K}else{break}}c[62256]=A+1;qa=va;ra=sa}h[t+(D+ -1<<3)>>3]=+h[31184]*(ra*ra+qa*qa);h[t+(ha+D<<3)>>3]=+h[31178]*+h[31180];h[t+(U+D<<3)>>3]=+h[31179]*+h[31180];J=+h[31178];L=+h[31179];h[t+(P+D<<3)>>3]=+h[31184]*(J*J-L*L);h[t+(H+D<<3)>>3]=+h[31161]*+h[31178]*+h[31179];na=D+1|0;c[62260]=na;if((D|0)<(la|0)){D=na}else{break}}}D=c[b>>2]|0;c[62256]=1;if((D|0)>=1){la=1;while(1){B=(c[d>>2]|0)+la|0;c[62268]=B;h[t+(B+ -1<<3)>>3]=0.0;na=la+ -1|0;h[t+(ha+B<<3)>>3]=+h[o+(na<<3)>>3];h[t+(U+B<<3)>>3]=+h[s+(na<<3)>>3];h[t+(P+B<<3)>>3]=0.0;h[t+(H+B<<3)>>3]=0.0;B=la+1|0;c[62256]=B;if((la|0)<(D|0)){la=B}else{break}}}c[62264]=1;la=1;do{D=c[d>>2]|0;c[62272]=D;if((la&-2|0)==2){B=c[l>>2]|0;c[62272]=B;wa=B}else{wa=D}D=c[d>>2]|0;c[62260]=1;if((D|0)>=1){B=fa(la,y)|0;na=1;while(1){h[u+(na+z+B<<3)>>3]=0.0;if((na|0)<(D|0)){na=na+1|0}else{break}}c[62260]=D+1}na=c[62330]|0;c[62258]=1;if((na|0)<1){xa=la}else{B=1;A=la;while(1){h[31158]=0.0;ma=c[d>>2]|0;c[62260]=1;if((ma|0)<1){ya=0.0;za=A}else{ua=fa(la,y)|0;L=0.0;ta=1;while(1){J=+h[j+(ta+x+(fa(B,w)|0)<<3)>>3];Aa=L+J*+h[t+(ta+z+ua<<3)>>3];h[31158]=Aa;if((ta|0)<(ma|0)){ta=ta+1|0;L=Aa}else{break}}c[62260]=ma+1;ya=Aa;za=la}if((B|0)<(c[k>>2]|0)){L=-ya;h[31158]=L;Ba=L}else{Ba=ya}ta=c[d>>2]|0;c[62260]=1;if((ta|0)>=1){ua=fa(B,w)|0;I=fa(za,y)|0;L=Ba;Ca=1;while(1){Da=u+(Ca+z+I<<3)|0;h[Da>>3]=L*+h[j+(Ca+x+ua<<3)>>3]+ +h[Da>>3];if((Ca|0)>=(ta|0)){break}L=+h[31158];Ca=Ca+1|0}c[62260]=ta+1}Ca=B+1|0;c[62258]=Ca;if((B|0)<(na|0)){B=Ca;A=za}else{xa=za;break}}}do{if((wa|0)==(c[l>>2]|0)){A=c[d>>2]|0;c[62260]=1;if((A|0)<1){break}else{Ea=1}while(1){h[31158]=0.0;B=c[b>>2]|0;c[62258]=1;if((B|0)<1){Fa=fa(xa,y)|0;Ga=0.0}else{L=0.0;na=1;while(1){J=+h[g+((fa(na,y)|0)+z+Ea<<3)>>3];D=fa(xa,y)|0;N=L+J*+h[t+(na+z+(c[d>>2]|0)+D<<3)>>3];h[31158]=N;Ca=na+1|0;c[62258]=Ca;if((na|0)<(B|0)){na=Ca;L=N}else{Fa=D;Ga=N;break}}}na=u+(Ea+z+Fa<<3)|0;h[na>>3]=Ga+ +h[na>>3];na=Ea+1|0;c[62260]=na;if((Ea|0)<(A|0)){Ea=na}else{break}}}}while(0);A=c[b>>2]|0;c[62258]=1;if((A|0)>=1){ta=1;while(1){h[31158]=0.0;c[62256]=1;if((wa|0)<1){Ha=fa(xa,y)|0;Ia=0.0}else{na=fa(ta,y)|0;B=fa(xa,y)|0;L=0.0;D=1;while(1){Ca=D+z|0;Ja=L+ +h[g+(Ca+na<<3)>>3]*+h[t+(Ca+B<<3)>>3];h[31158]=Ja;if((D|0)<(wa|0)){D=D+1|0;L=Ja}else{break}}c[62256]=wa+1;Ha=B;Ia=Ja}h[u+((c[d>>2]|0)+z+ta+Ha<<3)>>3]=Ia;D=ta+1|0;c[62258]=D;if((ta|0)<(A|0)){ta=D}else{break}}}la=xa+1|0;c[62264]=la;}while((la|0)<6);la=c[l>>2]|0;c[62260]=1;h[31158]=0.0;c[62256]=1;L=+h[31161];if((la|0)<1){Ka=L}else{N=L;ta=1;while(1){L=0.0;A=1;do{D=(fa(A,y)|0)+z+ta|0;h[249184+(A+ -1<<3)>>3]=N*+h[u+(D<<3)>>3]*+h[t+(D<<3)>>3];L=+h[249184+(A+ -1<<3)>>3]+L;h[31158]=L;A=A+1|0;}while((A|0)<6);h[31138]=+h[31138]- +h[31148]-L;A=ta+ -1|0;D=u+(A<<3)|0;na=ha+ta|0;Ca=t+(na<<3)|0;ua=u+(na<<3)|0;na=t+(A<<3)|0;J=+h[D>>3]*+h[Ca>>3]+ +h[ua>>3]*+h[na>>3];h[31178]=J;A=P+ta|0;I=t+(A<<3)|0;ma=u+(A<<3)|0;K=+h[ua>>3]*+h[I>>3]+ +h[ma>>3]*+h[Ca>>3];h[31179]=K;A=U+ta|0;Da=u+(A<<3)|0;La=H+ta|0;Ma=t+(La<<3)|0;Na=u+(La<<3)|0;La=t+(A<<3)|0;O=+h[Da>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[La>>3];h[31180]=O;h[249112>>3]=+h[249112>>3]-J-N*(O+K);h[249144>>3]=+h[249144>>3]-N*(K-O);O=+h[D>>3]*+h[La>>3]+ +h[Da>>3]*+h[na>>3];h[31178]=O;K=+h[ua>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[Ca>>3];h[31179]=K;J=+h[Da>>3]*+h[I>>3]+ +h[ma>>3]*+h[La>>3];h[31180]=J;h[249120>>3]=+h[249120>>3]-O-N*(K-J);h[249152>>3]=+h[249152>>3]-N*(K+J);J=+h[D>>3]*+h[I>>3]+ +h[ma>>3]*+h[na>>3];h[31178]=J;h[249128>>3]=+h[249200>>3]+(+h[249128>>3]-J- +h[249192>>3]);J=+h[D>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[na>>3];h[31178]=J;K=+h[ua>>3]*+h[La>>3]+ +h[Da>>3]*+h[Ca>>3];h[31179]=K;Oa=+h[31161];h[249136>>3]=+h[249136>>3]-J-K*Oa;h[249160>>3]=+h[249160>>3]- +h[249208>>3]+ +h[249216>>3];K=+h[ma>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[I>>3];h[31178]=K;h[249168>>3]=+h[249168>>3]-Oa*K;h[31158]=0.0;if((ta|0)<(la|0)){N=Oa;ta=ta+1|0}else{break}}c[62260]=la+1;c[62256]=1;Ka=Oa}N=0.0;ta=1;do{K=+h[u+((fa(ta,y)|0)+z+(c[n>>2]|0)<<3)>>3];h[249184+(ta+ -1<<3)>>3]=Ka*K*K;N=+h[249184+(ta+ -1<<3)>>3]+N;h[31158]=N;ta=ta+1|0;c[62256]=ta;}while((ta|0)<6);K=+h[31166];h[31168]=K*+h[31138]+ +h[31148]+N;J=+h[31159];ta=c[n>>2]|0;la=u+(ta+ -1<<3)|0;I=u+(ha+ta<<3)|0;O=J*+h[la>>3]*+h[I>>3];h[31178]=O;Na=u+(P+ta<<3)|0;S=+h[I>>3]*+h[Na>>3];h[31179]=S;Ma=u+(U+ta<<3)|0;ma=u+(H+ta<<3)|0;R=+h[Ma>>3]*+h[ma>>3];h[31180]=R;T=R+(K*+h[249112>>3]+O+S);h[249352>>3]=T;O=K*+h[249144>>3]+S-R;h[249384>>3]=O;R=J*+h[la>>3]*+h[Ma>>3];h[31178]=R;S=+h[I>>3]*+h[ma>>3];h[31179]=S;Z=+h[Ma>>3]*+h[Na>>3];h[31180]=Z;h[249360>>3]=K*+h[249120>>3]+R+S-Z;h[249392>>3]=K*+h[249152>>3]+S+Z;Z=J*+h[la>>3]*+h[Na>>3];h[31178]=Z;R=+h[249192>>3]+(Z+K*+h[249128>>3])- +h[249200>>3];h[249368>>3]=R;Z=J*+h[la>>3]*+h[ma>>3];h[31178]=Z;h[249376>>3]=Z+K*+h[249136>>3]+ +h[I>>3]*+h[Ma>>3];J=K*+h[249160>>3]+ +h[249208>>3]- +h[249216>>3];h[249400>>3]=J;h[249408>>3]=+h[31166]*+h[249168>>3]+ +h[Na>>3]*+h[ma>>3];K=+h[31168]+T+R+O+J;h[31158]=K;h[31188]=K;h[31189]=K;c[62362]=0;J=+h[31186]/50.0;h[31162]=J;h[31148]=+h[31147];c[62256]=1;O=K;ma=0;R=K;T=S;S=Z;Na=1;while(1){Pa=+(Na|0)*J;Z=+X(+Pa);h[249192>>3]=Z;W=+Y(+Pa);h[249200>>3]=W;ba=W;ca=Z;G=W;W=Z;Ma=4;while(1){Z=ca*W-ba*G;h[249184+(Ma+ -1<<3)>>3]=Z;Q=+h[249192>>3]*G+ +h[249200>>3]*W;h[249184+(Ma<<3)>>3]=Q;I=Ma+2|0;if((I|0)>=9){Qa=1;Ra=0.0;break}ba=+h[249200>>3];ca=+h[249192>>3];Ma=I;W=Z;G=Q}do{Ma=Qa+ -1|0;Ra=Ra+ +h[249344+(Ma<<3)>>3]*+h[249184+(Ma<<3)>>3];Qa=Qa+1|0;}while((Qa|0)<10);if(!(Ra>=0.0)){Sa=-Ra}else{Sa=Ra}if(!(R>=0.0)){Ta=-R}else{Ta=R}do{if(Sa>Ta){h[31189]=Ra;c[62362]=Na;h[31178]=O;Ua=Ra;Va=T;Wa=O;Xa=Na}else{if((Na|0)!=(ma+1|0)){Ua=R;Va=T;Wa=S;Xa=ma;break}h[31179]=Ra;Ua=R;Va=Ra;Wa=S;Xa=ma}}while(0);if((Na|0)>48){break}else{O=Ra;ma=Xa;R=Ua;T=Va;S=Wa;Na=Na+1|0}}c[62258]=10;h[31158]=Ra;h[31167]=Pa;h[31192]=O;c[62256]=50;if((Xa|0)==0){h[31178]=Ra;Ya=Ra;Za=Va}else if((Xa|0)==49){h[31179]=K;Ya=Wa;Za=K}else{Ya=Wa;Za=Va}h[31164]=0.0;if(Ya!=Za){S=Ya-Ua;h[31178]=S;T=Za-Ua;h[31179]=T;R=+h[31161]*(S-T)/(S+T);h[31164]=R;_a=R}else{_a=0.0}R=J*(+(Xa|0)+_a);h[31167]=R;T=+X(+R);h[249192>>3]=T;S=+Y(+R);h[249200>>3]=S;c[62258]=4;R=S;N=T;G=S;S=T;Na=4;while(1){T=N*S-R*G;h[249184+(Na+ -1<<3)>>3]=T;W=+h[249192>>3]*G+ +h[249200>>3]*S;h[249184+(Na<<3)>>3]=W;ma=Na+2|0;if((ma|0)>=9){break}R=+h[249200>>3];N=+h[249192>>3];Na=ma;S=T;G=W}h[r>>3]=0.0;h[31189]=0.0;c[62258]=1;Na=1;do{ma=Na+ -1|0;Ma=249184+(ma<<3)|0;h[r>>3]=+h[r>>3]+ +h[249104+(ma<<3)>>3]*+h[Ma>>3];h[31189]=+h[31189]+ +h[249344+(ma<<3)>>3]*+h[Ma>>3];Na=Na+1|0;}while((Na|0)<10);c[62258]=10;Na=c[l>>2]|0;c[62260]=1;if((Na|0)>=1){Ma=1;while(1){h[q+(Ma+ -1<<3)>>3]=0.0;ma=1;do{G=+h[u+((fa(ma,y)|0)+z+Ma<<3)>>3];I=q+(Ma+ -1<<3)|0;h[I>>3]=+h[I>>3]+G*+h[249184+(ma+ -1<<3)>>3];ma=ma+1|0;}while((ma|0)<6);if((Ma|0)<(Na|0)){Ma=Ma+1|0}else{break}}c[62258]=6;c[62260]=Na+1}h[31157]=+h[q+((c[n>>2]|0)+ -1<<3)>>3];h[31131]=0.0;h[31178]=0.0;h[31179]=0.0;Ma=c[b>>2]|0;c[62256]=1;if((Ma|0)<1){$a=0.0;ab=0.0}else{ma=1;while(1){I=ma+ -1|0;la=o+(I<<3)|0;h[la>>3]=+h[249192>>3]*+h[la>>3]+ +h[249200>>3]*+h[s+(I<<3)>>3];I=ma+ -1|0;la=o+(I<<3)|0;ta=p+(I<<3)|0;h[ta>>3]=+h[e+(I<<3)>>3]+ +h[la>>3];G=+h[la>>3];h[31131]=+h[31131]+G*G;bb=+h[31178]+ +h[la>>3]*+h[ta>>3];h[31178]=bb;G=+h[ta>>3];cb=+h[31179]+G*G;h[31179]=cb;if((ma|0)<(Ma|0)){ma=ma+1|0}else{break}}c[62256]=Ma+1;$a=cb;ab=bb}ma=c[62354]|0;Na=c[b>>2]|0;if((ma|0)>=(Na|0)){break}if((ma|0)>1){G=+h[31190];S=+h[31188];h[31190]=G>=S?G:S}S=+h[31189];if(!(S>=0.0)){db=-S}else{db=S}G=+h[31190];if(!(G>=0.0)){eb=-G}else{eb=G}if(db<=eb*1.1){break}h[31190]=S;c[62256]=1;b:do{if((Na|0)>=1){S=$a;G=ab;ta=1;while(1){la=ta+ -1|0;N=G*+h[e+(la<<3)>>3]+S*+h[o+(la<<3)>>3]- +h[q+(la+(c[d>>2]|0)<<3)>>3];h[31162]=N;R=+h[31157]*+h[g+((c[n>>2]|0)+z+(fa(ta,y)|0)<<3)>>3];h[s+(la<<3)>>3]=R+N*+h[31166];la=ta+1|0;c[62256]=la;if((ta|0)>=(Na|0)){break b}S=+h[31179];G=+h[31178];ta=la}}}while(0);Na=c[d>>2]|0;c[62260]=1;if((Na|0)>=1){Ma=1;while(1){h[31158]=0.0;ta=c[b>>2]|0;c[62258]=1;if((ta|0)<1){fb=0.0}else{G=0.0;la=1;while(1){S=+h[f+((fa(la,w)|0)+x+Ma<<3)>>3];gb=G+S*+h[p+(la+ -1<<3)>>3];h[31158]=gb;if((la|0)<(ta|0)){la=la+1|0;G=gb}else{break}}c[62258]=ta+1;fb=gb}la=c[b>>2]|0;G=fb*(+h[31157]*+h[p+(la+ -1+Ma<<3)>>3]- +h[31166]*+h[q+(Ma+ -1<<3)>>3]);h[31162]=G;c[62256]=1;if((la|0)>=1){S=G;I=1;while(1){G=S*+h[f+((fa(I,w)|0)+x+Ma<<3)>>3];Ca=s+(I+ -1<<3)|0;h[Ca>>3]=+h[Ca>>3]+G;if((I|0)>=(la|0)){break}S=+h[31162];I=I+1|0}c[62256]=la+1}I=Ma+1|0;c[62260]=I;if((Ma|0)<(Na|0)){Ma=I}else{break}}}h[31137]=0.0;h[31133]=0.0;Ma=c[b>>2]|0;c[62256]=1;if((Ma|0)<1){hb=0.0;ib=0.0}else{S=0.0;G=0.0;Na=1;while(1){N=+h[s+(Na+ -1<<3)>>3];jb=G+N*N;h[31137]=jb;I=Na+ -1|0;kb=S+ +h[o+(I<<3)>>3]*+h[s+(I<<3)>>3];h[31133]=kb;if((Na|0)<(Ma|0)){Na=Na+1|0;G=jb;S=kb}else{break}}c[62256]=Ma+1;hb=kb;ib=jb}S=+h[31131];G=S*ib-hb*hb;h[31182]=G;if(!(G>=S*1.0e-8*ib)){break}ea=hb;da=S;ga=G;C=ma+1|0}a[249080]=1;C=c[l>>2]|0;c[62260]=1;if((C|0)<1){lb=249176;mb=+h[31147];nb=c[m>>2]|0;ob=nb+ -1|0;pb=q;qb=ob<<3;rb=pb+qb|0;sb=rb;tb=+h[sb>>3];ub=mb+tb;h[sb>>3]=ub;i=v;return 0}else{vb=1}while(1){h[p+(vb+ -1<<3)>>3]=0.0;l=1;do{ga=+h[t+((fa(l,y)|0)+z+vb<<3)>>3];s=p+(vb+ -1<<3)|0;h[s>>3]=+h[s>>3]+ga*+h[249184+(l+ -1<<3)>>3];l=l+1|0;}while((l|0)<6);if((vb|0)<(C|0)){vb=vb+1|0}else{break}}c[62258]=6;c[62260]=C+1;lb=249176;mb=+h[31147];nb=c[m>>2]|0;ob=nb+ -1|0;pb=q;qb=ob<<3;rb=pb+qb|0;sb=rb;tb=+h[sb>>3];ub=mb+tb;h[sb>>3]=ub;i=v;return 0}function TYa(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,W=0.0,Z=0.0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0;v=i;w=c[d>>2]|0;x=~w;y=c[l>>2]|0;l=~y;h[31214]=.5;h[31210]=1.0;h[31226]=6.283185307179586;z=+h[n>>3];h[31223]=z*z;A=w+ -1-(c[b>>2]|0)|0;c[62434]=A;c[62442]=0;B=c[d>>2]|0;c[62394]=1;if((B|0)>=1){C=1;while(1){h[q+(C+ -1<<3)>>3]=0.0;if((C|0)<(B|0)){C=C+1|0}else{break}}c[62394]=B+1}c[62392]=1;B=c[m>>2]|0;if((A|0)<1){D=B}else{C=B;B=1;while(1){E=fa(B,w)|0;z=+h[j+(E+x+C<<3)>>3];h[31215]=z;if((B|0)<(c[k>>2]|0)){F=-z;h[31215]=F;G=F}else{G=z}H=c[d>>2]|0;c[62394]=1;if((H|0)>=1){z=G;I=1;while(1){J=q+(I+ -1<<3)|0;h[J>>3]=+h[J>>3]+z*+h[j+(I+x+E<<3)>>3];if((I|0)>=(H|0)){break}z=+h[31215];I=I+1|0}c[62394]=H+1}I=B+1|0;c[62392]=I;E=c[m>>2]|0;if((B|0)<(A|0)){C=E;B=I}else{D=E;break}}}h[p>>3]=+h[q+(D+ -1<<3)>>3];h[31198]=0.0;D=c[b>>2]|0;c[62390]=1;if((D|0)>=1){p=1;while(1){B=c[m>>2]|0;G=+h[f+((fa(p,w)|0)+x+B<<3)>>3];C=p+ -1|0;A=o+(C<<3)|0;h[A>>3]=G- +h[e+(C<<3)>>3];h[r+(C<<3)>>3]=+h[g+(B+l+(fa(p,y)|0)<<3)>>3];h[s+(C<<3)>>3]=0.0;G=+h[A>>3];h[31198]=+h[31198]+G*G;A=p+1|0;c[62390]=A;if((p|0)<(D|0)){p=A}else{break}}}p=c[d>>2]|0;c[62394]=1;if((p|0)>=1){D=1;while(1){h[31215]=0.0;h[31213]=0.0;y=c[b>>2]|0;c[62392]=1;if((y|0)<1){K=0.0;L=0.0}else{l=D+x|0;G=0.0;z=0.0;g=1;while(1){F=+h[f+((fa(g,w)|0)+x+D<<3)>>3];M=z+F*+h[e+(g+ -1<<3)>>3];h[31215]=M;F=+h[f+(l+(fa(g,w)|0)<<3)>>3];N=G+F*+h[o+(g+ -1<<3)>>3];h[31213]=N;if((g|0)<(y|0)){g=g+1|0;z=M;G=N}else{break}}c[62392]=y+1;K=M;L=N}g=q+(D+ -1<<3)|0;G=+h[g>>3]*K;h[31215]=G;h[31213]=+h[g>>3]*L;g=c[b>>2]|0;c[62390]=1;if((g|0)>=1){l=D+x|0;z=G;H=1;while(1){G=z*+h[f+((fa(H,w)|0)+x+D<<3)>>3];m=r+(H+ -1<<3)|0;h[m>>3]=+h[m>>3]+G;G=+h[31213]*+h[f+(l+(fa(H,w)|0)<<3)>>3];m=s+(H+ -1<<3)|0;h[m>>3]=+h[m>>3]+G;if((H|0)>=(g|0)){break}z=+h[31215];H=H+1|0}c[62390]=g+1}H=D+1|0;c[62394]=H;if((D|0)<(p|0)){D=H}else{break}}}h[31199]=0.0;h[31201]=0.0;h[31208]=0.0;D=c[b>>2]|0;c[62390]=1;if((D|0)<1){O=0.0;P=0.0;Q=0.0}else{L=0.0;K=0.0;N=0.0;p=1;while(1){M=+h[r+(p+ -1<<3)>>3];R=N+M*M;h[31199]=R;e=p+ -1|0;H=o+(e<<3)|0;S=K+ +h[H>>3]*+h[r+(e<<3)>>3];h[31201]=S;T=L+ +h[H>>3]*+h[s+(e<<3)>>3];h[31208]=T;if((p|0)<(D|0)){p=p+1|0;N=R;K=S;L=T}else{break}}c[62390]=D+1;O=R;P=T;Q=S}S=+h[31198];T=+h[n>>3]/+V(+S);if(Q*P<0.0){U=-T}else{U=T}h[31219]=U;h[31215]=0.0;if(Q*Q>S*.99*O){h[31215]=+h[31210]}if(!(Q>=0.0)){W=-Q}else{W=Q}if(!(P>=0.0)){Z=-P}else{Z=P}P=U*(W+ +h[31214]*U*Z);h[31211]=P;if(O*+h[31223]<P*P*.01){h[31215]=+h[31210]}n=c[b>>2]|0;c[62390]=1;if((n|0)<1){_=0}else{P=U;D=1;p=0;while(1){e=o+(p<<3)|0;h[e>>3]=P*+h[e>>3];e=D+ -1|0;H=s+(e<<3)|0;U=+h[31219]*+h[H>>3];h[H>>3]=U;h[t+(e<<3)>>3]=+h[r+(e<<3)>>3]+ +h[31215]*U;if((D|0)>=(n|0)){break}e=D;P=+h[31219];D=D+1|0;p=e}c[62390]=n+1;_=0}while(1){n=_+1|0;c[62442]=n;h[31198]=0.0;h[31201]=0.0;h[31202]=0.0;p=c[b>>2]|0;c[62390]=1;if((p|0)<1){$=0.0;aa=0.0;ba=0.0}else{P=0.0;U=0.0;O=0.0;D=1;while(1){Z=+h[o+(D+ -1<<3)>>3];ca=O+Z*Z;h[31198]=ca;e=D+ -1|0;H=t+(e<<3)|0;da=U+ +h[o+(e<<3)>>3]*+h[H>>3];h[31201]=da;Z=+h[H>>3];ea=P+Z*Z;h[31202]=ea;if((D|0)<(p|0)){D=D+1|0;O=ca;U=da;P=ea}else{break}}c[62390]=p+1;$=da;aa=ea;ba=ca}P=ba*aa-$*$;h[31215]=P;if(P<=ba*1.0e-8*aa){ga=88;break}U=+V(+P);h[31220]=U;D=c[b>>2]|0;c[62390]=1;if((D|0)>=1){P=U;U=$;O=ba;g=1;H=0;while(1){e=t+(H<<3)|0;h[e>>3]=(O*+h[e>>3]-U*+h[o+(H<<3)>>3])/P;h[u+(g+ -1<<3)>>3]=0.0;if((g|0)>=(D|0)){break}e=g;P=+h[31220];U=+h[31201];O=+h[31198];g=g+1|0;H=e}c[62390]=D+1}H=c[d>>2]|0;c[62394]=1;if((H|0)>=1){g=1;while(1){h[31213]=0.0;p=c[b>>2]|0;c[62392]=1;if((p|0)<1){ha=0.0}else{O=0.0;e=1;while(1){U=+h[f+((fa(e,w)|0)+x+g<<3)>>3];ia=O+U*+h[t+(e+ -1<<3)>>3];h[31213]=ia;if((e|0)<(p|0)){e=e+1|0;O=ia}else{break}}c[62392]=p+1;ha=ia}O=+h[q+(g+ -1<<3)>>3]*ha;h[31213]=O;e=c[b>>2]|0;c[62390]=1;if((e|0)>=1){U=O;l=1;while(1){O=U*+h[f+((fa(l,w)|0)+x+g<<3)>>3];y=u+(l+ -1<<3)|0;h[y>>3]=+h[y>>3]+O;if((l|0)>=(e|0)){break}U=+h[31213];l=l+1|0}c[62390]=e+1}l=g+1|0;c[62394]=l;if((g|0)<(H|0)){g=l}else{break}}}h[31203]=0.0;h[31204]=0.0;h[31205]=0.0;h[31206]=0.0;h[31207]=0.0;g=c[b>>2]|0;c[62390]=1;if((g|0)<1){ja=0.0;ka=0.0;la=0.0;ma=0.0;na=0.0}else{U=0.0;O=0.0;P=0.0;Z=0.0;W=0.0;H=1;while(1){D=H+ -1|0;oa=W+ +h[t+(D<<3)>>3]*+h[u+(D<<3)>>3];h[31203]=oa;D=H+ -1|0;l=o+(D<<3)|0;p=r+(D<<3)|0;pa=Z+ +h[l>>3]*+h[p>>3];h[31204]=pa;y=t+(D<<3)|0;qa=P+ +h[y>>3]*+h[p>>3];h[31205]=qa;p=s+(D<<3)|0;ra=O+ +h[l>>3]*+h[p>>3];h[31206]=ra;sa=U+ +h[y>>3]*+h[p>>3];h[31207]=sa;if((H|0)<(g|0)){H=H+1|0;W=oa;Z=pa;P=qa;O=ra;U=sa}else{break}}c[62390]=g+1;ja=sa;ka=qa;la=pa;ma=ra;na=oa}U=+h[31214];O=U*na;h[31203]=O;P=U*ma-O;h[31206]=P;Z=O+la+P;h[31227]=Z;h[31229]=Z;h[31228]=Z;c[62444]=0;a[249600]=1;W=+h[31226]/50.0;h[31215]=W;c[62390]=1;H=0;Q=Z;S=Z;p=1;while(1){ta=+(p|0)*W;ua=+X(+ta);va=+Y(+ta);wa=O+ua*(la+ua*P)+va*(ka+ua*ja);if(!(wa>=0.0)){xa=-wa}else{xa=wa}if(!(Q>=0.0)){ya=-Q}else{ya=Q}do{if(xa>ya){h[31229]=wa;c[62444]=p;h[31224]=S;za=p;Aa=wa}else{if((p|0)!=(H+1|0)){za=H;Aa=Q;break}h[31225]=wa;za=H;Aa=Q}}while(0);e=p+1|0;if((e|0)<50){H=za;Q=Aa;p=e;S=wa}else{break}}h[31218]=ta;h[31209]=ua;h[31212]=va;h[31211]=wa;c[62390]=50;h[31228]=wa;if((za|0)==0){h[31224]=wa;ga=74}else if((za|0)==49){h[31225]=Z;Ba=Z}else{ga=74}if((ga|0)==74){ga=0;Ba=+h[31225]}h[31216]=0.0;S=+h[31224];if(S!=Ba){Q=S-Aa;h[31224]=Q;S=Ba-Aa;h[31225]=S;T=U*(Q-S)/(Q+S);h[31216]=T;Ca=T}else{Ca=0.0}T=W*(+(za|0)+Ca);h[31218]=T;S=+X(+T);h[31209]=S;Q=+Y(+T);h[31212]=Q;T=O+S*(la+S*P)+Q*(ka+S*ja);h[31211]=T;p=c[b>>2]|0;c[62390]=1;if((p|0)<1){Da=T}else{T=Q;Q=S;H=1;g=0;while(1){e=o+(g<<3)|0;h[e>>3]=Q*+h[e>>3]+T*+h[t+(g<<3)>>3];e=H+ -1|0;y=s+(e<<3)|0;S=+h[31209]*+h[y>>3]+ +h[31212]*+h[u+(e<<3)>>3];h[y>>3]=S;h[t+(e<<3)>>3]=+h[r+(e<<3)>>3]+S;if((H|0)>=(p|0)){break}e=H;T=+h[31212];Q=+h[31209];H=H+1|0;g=e}c[62390]=p+1;Da=+h[31211]}if(!(Da>=0.0)){Ea=-Da}else{Ea=Da}Q=+h[31227];if(!(Q>=0.0)){Fa=-Q}else{Fa=Q}if(Ea<=Fa*1.1){ga=88;break}if((n|0)<(c[b>>2]|0)){_=n}else{ga=88;break}}if((ga|0)==88){i=v;return 0}return 0}function UYa(b,d,e,f,g,h,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0;n=i;a[250056]=1;a[250048]=1;c[250068>>2]=6;zeb(250064)|0;e=c[d>>2]|0;c[62510]=1;if((e|0)>=1){d=1;do{Qdb(250184,b+(d+ -1)|0,1)|0;o=c[62510]|0;d=o+1|0;c[62510]=d;}while((o|0)<(e|0))}heb()|0;e=c[g>>2]|0;if((e|0)==1){c[250092>>2]=a[250048]&1?6:0;zeb(250088)|0;Qdb(250184,h,4)|0;heb()|0;p=c[g>>2]|0}else{p=e}if((p|0)==2){c[250116>>2]=a[250048]&1?6:0;zeb(250112)|0;Qdb(250184,h,4)|0;Qdb(250184,j,4)|0;heb()|0}j=c[k>>2]|0;if((j|0)==1){c[250140>>2]=a[250048]&1?6:0;zeb(250136)|0;Qdb(250184,l,8)|0;heb()|0;q=c[k>>2]|0}else{q=j}if((q|0)==2){c[250164>>2]=a[250048]&1?6:0;zeb(250160)|0;Qdb(250184,l,8)|0;Qdb(250184,m,8)|0;heb()|0}if((c[f>>2]|0)==2){ydb(250192,0)|0}else{i=n;return 0}return 0}function VYa(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0.0,U=0.0,V=0.0,W=0.0,X=0,Y=0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0;y=i;i=i+8|0;z=y;A=c[k>>2]|0;a:do{if((A|0)==-1){Fdb(250264,250496,80,49);B=250568;C=250576;UYa(250264,250552,250560,B,B,B,B,B,C,C,80)|0;Fdb(250264,250584,80,47);C=250568;B=250576;UYa(250264,250632,250640,C,250648,n,C,C,B,B,80)|0;Fdb(250264,250656,80,41);B=250568;C=250576;UYa(250264,250704,250712,250648,B,B,B,B,C,C,80)|0;i=y;return 0}else if((A|0)==0){c[62552]=2;C=2;while(1){B=C+1|0;if(!((c[k+(C+ -1<<2)>>2]|0)>>>0<2)){D=210;break a}c[62552]=B;if((B|0)<12){C=B}else{break}}if((c[d>>2]|0)<1){Fdb(250264,251960,80,25);C=250568;B=250576;UYa(250264,251992,250744,C,250648,d,C,C,B,B,80)|0;break}c[62616]=5;B=q+8|0;do{if((c[k+32>>2]|0)==0){E=5}else{C=c[B>>2]|0;c[62616]=C;if(!((C+ -1|0)>>>0>4)){E=C;break}Fdb(250264,252e3,80,34);C=250568;F=250576;UYa(250264,252040,250736,C,250648,250464,C,C,F,F,80)|0;break a}}while(0);c[B>>2]=E;b:do{if((c[k+20>>2]|0)==0){F=c[d>>2]|0;C=fa(F,F)|0;c[62602]=C;c[62614]=C+50+(fa((c[B>>2]|0)+4|0,c[d>>2]|0)|0);C=q+12|0;if((c[k+16>>2]|0)==0){c[C>>2]=2;break}else{c[C>>2]=1;break}}else{C=c[q>>2]|0;do{if((C|0)>=0){F=c[d>>2]|0;if((C|0)>=(F|0)){break}G=q+4|0;H=c[G>>2]|0;if(!((H|0)>-1&(H|0)<(F|0))){Fdb(250264,252824,80,52);I=250568;J=250576;UYa(250264,252808,252880,I,250648,G,I,I,J,J,80)|0;break a}c[62602]=fa((C<<1|1)+H|0,F)|0;F=q+12|0;if((c[k+16>>2]|0)==0){c[F>>2]=5;H=c[d>>2]|0;J=fa((c[B>>2]|0)+4|0,H)|0;c[62614]=(((H|0)/((c[q>>2]|0)+1+(c[G>>2]|0)|0)|0)<<1)+52+(c[62602]|0)+J;break b}else{c[F>>2]=4;F=(fa((c[B>>2]|0)+4|0,c[d>>2]|0)|0)+50|0;c[62614]=F+(c[62602]|0);break b}}}while(0);Fdb(250264,252752,80,52);C=250568;F=250576;UYa(250264,252808,252816,C,250648,q,C,C,F,F,80)|0;break a}}while(0);c[62606]=(c[d>>2]|0)+20;c[q+64>>2]=c[62602];if((c[p>>2]|0)<(c[62614]|0)){Fdb(250264,252048,80,60);B=250568;F=250576;UYa(250264,252112,252120,B,250744,250456,p,B,F,F,80)|0;break}if((c[r>>2]|0)<(c[62606]|0)){Fdb(250264,252128,80,60);F=250568;B=250576;UYa(250264,252112,252192,F,250744,250424,r,F,B,B,80)|0;break}if(+h[j>>3]==+h[e>>3]){D=227;break}if((c[w>>2]|0)<0){Fdb(250264,252936,80,24);B=250648;F=250568;C=250576;UYa(250264,252968,252976,B,B,w,F,F,C,C,80)|0;break}do{if((c[k+24>>2]|0)!=0){K=+h[o+8>>3];h[31298]=K;if(!(K<=0.0)){break}Fdb(250264,252432,80,28);C=250568;UYa(250264,251144,252464,C,C,C,C,250648,250384,250576,80)|0;break a}}while(0);c[q+60>>2]=0;C=q+36|0;c[C+0>>2]=0;c[C+4>>2]=0;c[C+8>>2]=0;c[C+12>>2]=0;c[n>>2]=1;D=27}else if((A|0)==1){c[q+36>>2]=c[q+40>>2];D=27}else{D=210}}while(0);c:do{if((D|0)==27){a[250440]=0;K=+h[l>>3];h[31309]=K;L=+h[m>>3];h[31302]=L;A=c[d>>2]|0;c[62552]=1;do{if((A|0)>=1){r=k+4|0;p=0;E=1;M=L;N=K;while(1){if((c[r>>2]|0)==1){C=E+ -1|0;O=+h[l+(C<<3)>>3];h[31309]=O;P=+h[m+(C<<3)>>3];h[31302]=P;Q=O;R=P}else{Q=N;R=M}if(Q>0.0|R>0.0){a[250440]=1;S=1}else{S=p}if(Q<0.0){D=215;break}if(R<0.0){D=216;break}C=E+1|0;c[62552]=C;if((E|0)<(A|0)){p=S;E=C;M=R;N=Q}else{D=36;break}}if((D|0)==36){if(!S){break}E=c[d>>2]|0;p=E+51|0;c[62562]=p;r=p+(c[w>>2]|0)|0;c[62564]=r;p=r+(c[w>>2]|0)|0;c[62586]=p;C=p+(c[w>>2]|0)|0;c[62556]=C;F=C+(c[d>>2]|0)|0;c[62592]=F;B=F+(c[d>>2]|0)|0;c[62598]=B;c[62588]=(fa((c[q+8>>2]|0)+1|0,c[d>>2]|0)|0)+B;c[62612]=(c[q+64>>2]|0)+1;d:do{if((c[k>>2]|0)==1){F=o+64|0;h[31311]=+h[F>>3];a[250376]=0;h[31280]=+h[o+24>>3];J=o+16|0;h[31275]=+h[J>>3];do{if((c[w>>2]|0)!=0){WYa(250744,v,w,d,250240,j,f,o+(C+ -1<<3)|0,o+(B+ -1<<3)|0,o+224|0,q+28|0,o+(E+50<<3)|0,o+(r+ -1<<3)|0,o+(p+ -1<<3)|0,x,250360,F,0,o,q,s,t)|0;if((c[62682]|0)>0){i=y;return 0}if((c[62590]|0)!=1){break}c[q+68>>2]=1;c[n>>2]=4;h[e>>3]=+h[o+320>>3];G=250648;rZa(d,o+((c[62556]|0)+ -1<<3)|0,G,g,G)|0;a[250376]=1;D=197;break d}}while(0);do{if((c[k+24>>2]|0)!=0){N=+h[31275];if(!(N>=0.0)){T=-N}else{T=N}M=T/+h[o+8>>3];if(!(M>1.0)){break}h[31275]=N/M}}while(0);M=+h[e>>3];N=+h[j>>3];if(M==N){D=227;break c}P=+h[31275];if((M-N)*P>0.0){D=220;break}F=(c[k+8>>2]|0)==1;do{if((c[k+12>>2]|0)==1){O=+h[o>>3];h[31310]=O;U=+h[31280];V=U-O;G=V*P>0.0;do{if(F){if(G){D=224;break d}W=+h[j>>3];if(P*(O-W)<0.0){D=218;break d}if(P*(U- +h[e>>3])<=0.0){break}H=q+28|0;I=o+((c[62598]|0)+ -1<<3)|0;X=o+224|0;if(P*(U-W)>0.0){$Ya(250240,j,f,g,d,H,I,X)|0;if((c[62682]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[250376]=1;D=197;break d}}else{Y=250240;$Ya(Y,Y,f,g,d,H,I,X)|0;if((c[62682]|0)>0){i=y;return 0}else{h[e>>3]=+h[31280];c[n>>2]=1;a[250376]=1;D=197;break d}}}else{if(G){D=224;break d}W=+h[j>>3];if(P*(O-W)<0.0){D=218;break d}if(P*(U-W)<0.0){break}$Ya(250240,j,f,g,d,q+28|0,o+((c[62598]|0)+ -1<<3)|0,o+224|0)|0;if((c[62682]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[250376]=1;D=197;break d}}}while(0);h[z>>3]=V;if(!(V>=0.0)){Z=-V}else{Z=V}if(!(U>=0.0)){_=-U}else{_=U}if(!(P>=0.0)){$=-P}else{$=P}if(Z>+h[31311]*100.0*(_+$)){if(P*(U+P-O)<=0.0){break}W=O-U;h[31275]=W;h[J>>3]=W;break}$Ya(250240,250480,f,g,d,q+28|0,o+((c[62598]|0)+ -1<<3)|0,o+224|0)|0;if((c[62682]|0)>0){i=y;return 0}else{c[n>>2]=2;h[e>>3]=+h[31310];a[250376]=1;D=197;break d}}else{W=+h[31280];if(!F){if(P*(W-N)<0.0){break}$Ya(250240,j,f,g,d,q+28|0,o+((c[62598]|0)+ -1<<3)|0,o+224|0)|0;if((c[62682]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[250376]=1;D=197;break d}}if(P*(W-M)<=0.0){break}G=q+28|0;X=o+((c[62598]|0)+ -1<<3)|0;I=o+224|0;if(P*(W-N)>0.0){$Ya(250240,j,f,g,d,G,X,I)|0;if((c[62682]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[250376]=1;D=197;break d}}else{H=250240;$Ya(H,H,f,g,d,G,X,I)|0;if((c[62682]|0)>0){i=y;return 0}else{h[e>>3]=+h[31280];c[n>>2]=1;a[250376]=1;D=197;break d}}}}while(0);if(a[250376]&1){D=197}else{D=128}}else{h[31280]=+h[e>>3];c[n>>2]=1;YYa(d,k+4|0,l,m,f,o+((c[62592]|0)+ -1<<3)|0,s,t)|0;F=c[d>>2]|0;c[62552]=1;e:do{if((F|0)>=1){J=c[62592]|0;I=1;while(1){X=I+1|0;if(+h[o+(I+ -2+J<<3)>>3]<=0.0){break}c[62552]=X;if((I|0)<(F|0)){I=X}else{break e}}Fdb(250264,252568,80,39);I=250568;J=250576;UYa(250264,252240,252608,I,I,I,I,I,J,J,80)|0;break c}}while(0);U=+dZa(250720,1);h[31311]=U;F=o+64|0;h[F>>3]=U;U=+h[e>>3];if(!(U>=0.0)){aa=-U}else{aa=U}h[z>>3]=aa;U=+h[j>>3];if(!(U>=0.0)){ba=-U}else{ba=U}U=+h[31311]*4.0*(aa>=ba?aa:ba);h[31300]=U;O=+h[j>>3]- +h[e>>3];h[z>>3]=O;if(!(O>=0.0)){ca=-O}else{ca=O}if(ca<U){Fdb(250264,252616,80,60);J=250568;UYa(250264,252112,252680,J,J,J,J,250744,j,e,80)|0;break c}do{if((c[k+28>>2]|0)==0){h[31279]=ca*.001;U=+ZYa(d,g,o+((c[62592]|0)+ -1<<3)|0,s,t);if(U>.5/+h[31279]){h[31279]=.5/U}h[z>>3]=+h[j>>3]- +h[e>>3];U=+Cdb(250232,z);h[31279]=U;da=U}else{U=+h[o+16>>3];h[31279]=U;if(U*(+h[j>>3]- +h[e>>3])<0.0){D=220;break d}if(!(U==0.0)){da=U;break}Fdb(250264,252520,80,29);J=250568;I=250576;UYa(250264,252552,252560,J,J,J,J,J,I,I,80)|0;break c}}while(0);do{if((c[k+24>>2]|0)==0){ea=da}else{if(!(da>=0.0)){ga=-da}else{ga=da}U=ga/+h[o+8>>3];if(!(U>1.0)){ea=da;break}O=da/U;h[31279]=O;ea=O}}while(0);if((c[k+12>>2]|0)==0){ha=ea}else{O=+h[o>>3];h[31310]=O;U=+h[e>>3];V=O-U;if(V*ea<0.0){D=224;break}if(ea*(U+ea-O)>0.0){h[31279]=V;ia=V}else{ia=ea}if((O- +h[j>>3])*ia<0.0){D=218;break}else{ha=ia}}I=k+40|0;if((c[I>>2]|0)==0){ja=ha}else{_Ya(250240,f,g,d,b,u,250232,o+((c[62592]|0)+ -1<<3)|0,n,s,t,o+((c[62598]|0)+ -1<<3)|0,o+400|0,o+((c[62556]|0)+ -1<<3)|0,o+((c[62588]|0)+ -1<<3)|0,q,250400,F,k+36|0,250448)|0;if((c[62682]|0)>0){i=y;return 0}J=c[n>>2]|0;if((J|0)<0){ka=J;D=129;break}ja=+h[31279]}h[31275]=ja;h[o+16>>3]=ja;J=c[62598]|0;X=(c[d>>2]|0)+J|0;c[62608]=X;G=c[d>>2]|0;c[62552]=1;if((G|0)>=1){H=1;while(1){h[o+(H+ -2+J<<3)>>3]=+h[f+(H+ -1<<3)>>3];h[o+(H+ -2+X<<3)>>3]=+h[31275]*+h[g+(H+ -1<<3)>>3];if((H|0)<(G|0)){H=H+1|0}else{break}}c[62552]=G+1}H=o+320|0;h[H>>3]=+h[e>>3];X=q+68|0;c[X>>2]=0;J=o+224|0;h[J>>3]=+h[31275];h[o+232>>3]=+h[31275]*2.0;Y=q+28|0;c[Y>>2]=1;if((c[w>>2]|0)==0){D=128;break}WYa(250648,v,w,d,e,j,f,o+((c[62556]|0)+ -1<<3)|0,o+((c[62598]|0)+ -1<<3)|0,J,Y,o+((c[62562]|0)+ -1<<3)|0,o+((c[62564]|0)+ -1<<3)|0,o+((c[62586]|0)+ -1<<3)|0,x,250360,F,0,o,q,s,t)|0;if((c[62682]|0)>0){i=y;return 0}if((c[62590]|0)!=0){Fdb(250264,252984,80,47);la=250568;ma=250576;UYa(250264,250632,253032,250648,la,la,la,la,ma,ma,80)|0;Fdb(250264,253040,80,38);ma=250568;la=250576;UYa(250264,250792,253032,250648,ma,ma,ma,ma,la,la,80)|0;break c}if((c[w>>2]|0)==0){D=128;break}if((c[I>>2]|0)==0){D=128;break}WYa(250736,v,w,d,250240,j,f,o+((c[62556]|0)+ -1<<3)|0,o+((c[62598]|0)+ -1<<3)|0,J,Y,o+((c[62562]|0)+ -1<<3)|0,o+((c[62564]|0)+ -1<<3)|0,o+((c[62586]|0)+ -1<<3)|0,x,250360,F,0,o,q,s,t)|0;if((c[62682]|0)>0){i=y;return 0}if((c[62590]|0)!=1){D=128;break}c[X>>2]=1;c[n>>2]=4;h[e>>3]=+h[H>>3];H=250648;rZa(d,o+((c[62556]|0)+ -1<<3)|0,H,g,H)|0;D=197}}while(0);if((D|0)==218){Fdb(250264,252360,80,54);p=250568;UYa(250264,252416,252424,p,p,p,p,250744,250480,j,80)|0;break c}else if((D|0)==220){Fdb(250264,252472,80,34);p=250568;UYa(250264,252040,252512,p,p,p,p,250744,j,e,80)|0;break c}else if((D|0)==224){Fdb(250264,252688,80,49);p=250568;UYa(250264,250552,252744,p,p,p,p,250744,250480,e,80)|0;break c}f:while(1){if((D|0)==128){D=0;ka=c[n>>2]|0;D=129;continue}else if((D|0)==129){D=0;if((ka|0)==-12){na=-12;break}if(((c[q+40>>2]|0)-(c[q+36>>2]|0)|0)>=500){D=131;break}oa=k+4|0;YYa(d,oa,l,m,o+((c[62598]|0)+ -1<<3)|0,o+((c[62592]|0)+ -1<<3)|0,s,t)|0;if((c[62682]|0)>0){D=233;break}p=c[d>>2]|0;c[62552]=1;r=c[62592]|0;if((p|0)>=1){E=1;while(1){B=E+1|0;if(!(+h[o+(E+ -2+r<<3)>>3]>0.0)){D=136;break f}c[62552]=B;if((E|0)<(p|0)){E=B}else{break}}}O=+ZYa(d,o+((c[62598]|0)+ -1<<3)|0,o+(r+ -1<<3)|0,s,t)*100.0;V=+h[31311];pa=O*V;h[31277]=pa;if(!(pa<=1.0)){D=138;break}O=+h[31280];if(!(O>=0.0)){qa=-O}else{qa=O}h[z>>3]=qa;O=+h[j>>3];if(!(O>=0.0)){ra=-O}else{ra=O}h[31300]=V*4.0*(qa>=ra?qa:ra);do{if((c[k+24>>2]|0)!=0){V=+h[31275];if(!(V>=0.0)){sa=-V}else{sa=V}O=sa/+h[o+8>>3];if(!(O>1.0)){break}h[31275]=V/O}}while(0);aZa(250240,f,g,d,b,u,250200,o+((c[62592]|0)+ -1<<3)|0,k,n,s,t,o+((c[62598]|0)+ -1<<3)|0,o+400|0,o+((c[62556]|0)+ -1<<3)|0,o+((c[62588]|0)+ -1<<3)|0,q,o+80|0,o+128|0,o+176|0,o+224|0,o+272|0,o+32|0,o+40|0,o+48|0,o+56|0,250400,o+64|0,q+20|0,q+16|0,q+24|0,q+28|0,q+32|0,k+36|0,250448)|0;if((c[62682]|0)>0){D=233;break}r=c[n>>2]|0;if((r|0)<0){na=r;break}do{if((c[w>>2]|0)!=0){WYa(250736,v,w,d,250240,j,f,o+((c[62556]|0)+ -1<<3)|0,o+((c[62598]|0)+ -1<<3)|0,o+224|0,q+28|0,o+((c[62562]|0)+ -1<<3)|0,o+((c[62564]|0)+ -1<<3)|0,o+((c[62586]|0)+ -1<<3)|0,x,250360,o+64|0,0,o,q,s,t)|0;if((c[62682]|0)>0){D=233;break f}if((c[62590]|0)!=1){break}c[q+68>>2]=1;c[n>>2]=4;h[e>>3]=+h[o+320>>3];r=250648;rZa(d,o+((c[62556]|0)+ -1<<3)|0,r,g,r)|0;D=197;continue f}}while(0);r=(c[k+8>>2]|0)!=0;O=+h[31280];V=+h[31275];U=(O- +h[j>>3])*V;if((c[k+12>>2]|0)==0){if(!r){if(U<0.0){D=128;continue}$Ya(250240,j,f,g,d,q+28|0,o+((c[62598]|0)+ -1<<3)|0,o+224|0)|0;if((c[62682]|0)>0){D=233;break}c[n>>2]=3;h[e>>3]=+h[j>>3];D=197;continue}if(!(U>=0.0)){h[e>>3]=O;c[n>>2]=1;D=197;continue}$Ya(250240,j,f,g,d,q+28|0,o+((c[62598]|0)+ -1<<3)|0,o+224|0)|0;if((c[62682]|0)>0){D=233;break}c[n>>2]=3;h[e>>3]=+h[j>>3];D=197;continue}if(r){if(U>=0.0){$Ya(250240,j,f,g,d,q+28|0,o+((c[62598]|0)+ -1<<3)|0,o+224|0)|0;if((c[62682]|0)>0){D=233;break}h[e>>3]=+h[j>>3];c[n>>2]=3;D=197;continue}N=O- +h[31310];h[z>>3]=N;if(!(N>=0.0)){ta=-N}else{ta=N}if(!(O>=0.0)){ua=-O}else{ua=O}if(!(V>=0.0)){va=-V}else{va=V}if(!(ta<=+h[31311]*100.0*(ua+va))){h[e>>3]=O;c[n>>2]=1;D=197;continue}$Ya(250240,250480,f,g,d,q+28|0,o+((c[62598]|0)+ -1<<3)|0,o+224|0)|0;if((c[62682]|0)>0){D=233;break}c[n>>2]=2;h[e>>3]=+h[31310];D=197;continue}if(!(U<0.0)){$Ya(250240,j,f,g,d,q+28|0,o+((c[62598]|0)+ -1<<3)|0,o+224|0)|0;if((c[62682]|0)>0){D=233;break}h[e>>3]=+h[j>>3];c[n>>2]=3;D=197;continue}U=+h[31310];N=O-U;h[z>>3]=N;if(!(N>=0.0)){wa=-N}else{wa=N}if(!(O>=0.0)){xa=-O}else{xa=O}if(!(V>=0.0)){ya=-V}else{ya=V}if(!(wa<=+h[31311]*100.0*(xa+ya))){if(V*(O+V-U)<=0.0){D=128;continue}h[31275]=U-O;D=128;continue}else{$Ya(250240,250480,f,g,d,q+28|0,o+((c[62598]|0)+ -1<<3)|0,o+224|0)|0;if((c[62682]|0)>0){D=233;break}c[n>>2]=2;h[e>>3]=+h[31310];D=197;continue}}else if((D|0)==197){D=0;h[o+24>>3]=+h[31280];h[o+16>>3]=+h[31275];h[o+328>>3]=+h[e>>3];D=233;break}}do{if((D|0)==131){c[n>>2]=-1;na=-1}else if((D|0)==136){c[n>>2]=-3;na=-3}else if((D|0)==138){if((c[oa>>2]|0)!=1){h[l>>3]=pa*+h[l>>3];h[m>>3]=+h[31277]*+h[m>>3];c[n>>2]=-2;na=-2;break}r=c[d>>2]|0;c[62552]=1;if((r|0)>=1){O=pa;E=1;p=0;while(1){F=l+(p<<3)|0;h[F>>3]=O*+h[F>>3];F=m+(E+ -1<<3)|0;h[F>>3]=+h[31277]*+h[F>>3];if((E|0)>=(r|0)){break}F=E;O=+h[31277];E=E+1|0;p=F}c[62552]=r+1}c[n>>2]=-2;na=-2}else if((D|0)==233){i=y;return 0}}while(0);p=0-na|0;c[62608]=p;switch(p|0){case 12:{Fdb(250264,251160,80,44);p=250568;UYa(250264,251208,251832,p,p,p,p,250744,250240,250232,80)|0;Fdb(250264,251840,80,45);p=250568;E=250576;UYa(250264,251048,251888,p,p,p,p,p,E,E,80)|0;break};case 5:case 4:{break};case 2:{Fdb(250264,250880,80,47);E=250568;UYa(250264,250632,250928,E,E,E,E,250648,250240,250576,80)|0;Fdb(250264,250936,80,48);E=250568;p=250576;UYa(250264,250864,250992,E,E,E,E,E,p,p,80)|0;Fdb(250264,251e3,80,45);p=250568;E=250576;UYa(250264,251048,251056,p,p,p,p,p,E,E,80)|0;break};case 8:{Fdb(250264,251160,80,44);E=250568;UYa(250264,251208,251416,E,E,E,E,250744,250240,250200,80)|0;Fdb(250264,251424,80,37);E=250568;p=250576;UYa(250264,251464,251472,E,E,E,E,E,p,p,80)|0;break};case 9:{Fdb(250264,251160,80,44);p=250568;UYa(250264,251208,251480,p,p,p,p,250744,250240,250200,80)|0;Fdb(250264,251488,80,49);p=250568;E=250576;UYa(250264,250552,251544,p,p,p,p,p,E,E,80)|0;Fdb(250264,251552,80,38);E=250568;p=250576;UYa(250264,250792,251592,E,E,E,E,E,p,p,80)|0;break};case 10:{Fdb(250264,251160,80,44);p=250568;UYa(250264,251208,251600,p,p,p,p,250744,250240,250200,80)|0;Fdb(250264,251608,80,45);p=250568;E=250576;UYa(250264,251048,251656,p,p,p,p,p,E,E,80)|0;Fdb(250264,251664,80,36);E=250568;p=250576;UYa(250264,251704,251712,E,E,E,E,E,p,p,80)|0;break};case 11:{Fdb(250264,251720,80,40);p=250568;UYa(250264,251768,251776,p,p,p,p,250744,250240,250200,80)|0;Fdb(250264,251784,80,36);p=250568;E=250576;UYa(250264,251704,251824,p,p,p,p,p,E,E,80)|0;break};case 3:{Fdb(250264,251064,80,38);E=250568;UYa(250264,250792,251104,E,E,E,E,250648,250240,250576,80)|0;Fdb(250264,251112,80,28);E=250568;p=250576;UYa(250264,251144,251152,E,E,E,E,E,p,p,80)|0;break};case 6:{Fdb(250264,251160,80,44);p=250568;UYa(250264,251208,251216,p,p,p,p,250744,250240,250200,80)|0;Fdb(250264,251224,80,57);p=250568;E=250576;UYa(250264,251288,251296,p,p,p,p,p,E,E,80)|0;break};case 7:{Fdb(250264,251160,80,44);E=250568;UYa(250264,251208,251304,E,E,E,E,250744,250240,250200,80)|0;Fdb(250264,251312,80,48);E=250568;p=250576;UYa(250264,250864,251368,E,E,E,E,E,p,p,80)|0;Fdb(250264,251376,80,28);p=250568;E=250576;UYa(250264,251144,251408,p,p,p,p,p,E,E,80)|0;break};default:{Fdb(250264,250752,80,38);E=250568;UYa(250264,250792,250800,E,E,E,E,250648,250240,250576,80)|0;Fdb(250264,250808,80,48);E=250568;p=250576;UYa(250264,250864,250872,E,E,E,E,E,p,p,80)|0}}c[k>>2]=-1;h[e>>3]=+h[31280];h[o+24>>3]=+h[31280];h[o+16>>3]=+h[31275];i=y;return 0}else if((D|0)==215){Fdb(250264,252200,80,39);p=250568;E=250576;UYa(250264,252240,252248,p,p,p,p,p,E,E,80)|0;break c}else if((D|0)==216){Fdb(250264,252256,80,39);E=250568;p=250576;UYa(250264,252240,252296,E,E,E,E,E,p,p,80)|0;break c}}}while(0);Fdb(250264,252304,80,47);A=250568;p=250576;UYa(250264,250632,252352,A,A,A,A,A,p,p,80)|0}else if((D|0)==210){Fdb(250264,251896,80,55);p=250568;A=250576;UYa(250264,251952,250648,p,p,p,p,p,A,A,80)|0}}while(0);if((D|0)==227){Fdb(250264,252888,80,39);D=250568;UYa(250264,252240,252928,D,D,D,D,250744,j,e,80)|0}if((c[k>>2]|0)==-1){Fdb(250264,253080,80,46);e=250568;j=250576;UYa(250264,253128,253136,e,e,e,e,e,j,j,80)|0;Fdb(250264,253144,80,47);j=250568;e=250576;UYa(250264,250632,253192,250648,j,j,j,j,e,e,80)|0;i=y;return 0}else{c[k>>2]=-1;c[n>>2]=-33;i=y;return 0}return 0}function WYa(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;var A=0,B=0,C=0.0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0,N=0.0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0.0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0,ga=0,ha=0;v=i;A=c[f>>2]|0;B=~A;C=+h[n>>3];h[31650]=C;c[t>>2]=0;D=c[e>>2]|0;c[63302]=1;if((D|0)>=1){E=1;do{c[s+(E+ -1<<2)>>2]=0;F=c[63302]|0;E=F+1|0;c[63302]=E;}while((F|0)<(D|0))}G=+h[g>>3];if(!(G>=0.0)){H=-G}else{H=G}if(!(C>=0.0)){I=-C}else{I=C}h[31657]=(H+I)*+h[u>>3]*100.0;u=c[b>>2]|0;do{if((u|0)==3){J=C;K=+h[g>>3]}else if((u|0)==2){do{if((c[x+68>>2]|0)!=0){b=w+320|0;$Ya(g,b,k,l,f,o,m,n)|0;if((c[62682]|0)>0){i=v;return 0}D=d;ie[D&7](f,b,k,e,p,y,z)|0;if((c[62682]|0)>0){i=v;return 0}E=x+60|0;c[E>>2]=(c[E>>2]|0)+1;a[253264]=0;F=c[e>>2]|0;c[63302]=1;if((F|0)<1){break}else{L=0;M=1}while(1){I=+h[p+(M+ -1<<3)>>3];if(!(I>=0.0)){N=-I}else{N=I}if(!(N<=0.0)){O=L}else{a[253264]=1;O=1}if((M|0)<(F|0)){L=O;M=M+1|0}else{break}}c[63302]=F+1;if(!O){break}I=+Cdb(253256,253200);h[31654]=I;H=I+ +h[b>>3];h[b>>3]=H;I=+h[31650];do{if((H- +h[g>>3])*I<0.0){$Ya(g,b,k,l,f,o,m,n)|0;if((c[62682]|0)<=0){break}i=v;return 0}else{G=+h[31654]/I;h[31655]=G;P=c[f>>2]|0;c[63302]=1;if((P|0)<1){break}Q=(A<<1)+B|0;R=G;S=1;while(1){T=k+(S+ -1<<3)|0;h[T>>3]=+h[T>>3]+R*+h[m+(Q+S<<3)>>3];if((S|0)>=(P|0)){break}R=+h[31655];S=S+1|0}c[63302]=P+1}}while(0);ie[D&7](f,b,k,e,p,y,z)|0;if((c[62682]|0)>0){i=v;return 0}c[E>>2]=(c[E>>2]|0)+1;a[253264]=0;F=c[e>>2]|0;c[63302]=1;if((F|0)<1){break}else{U=0;V=1}while(1){S=V+ -1|0;I=+h[p+(S<<3)>>3];if(!(I>=0.0)){W=-I}else{W=I}if(W>0.0){X=U;Y=V}else{c[s+(S<<2)>>2]=1;a[253264]=1;X=1;Y=c[63302]|0}S=Y+1|0;c[63302]=S;if((Y|0)<(F|0)){U=X;V=S}else{break}}if(!X){break}c[t>>2]=1;i=v;return 0}}while(0);I=+h[g>>3];if(I==+h[w+328>>3]){i=v;return 0}else{J=+h[31650];K=I;break}}else{F=w+320|0;$Ya(g,F,k,l,f,o,m,n)|0;if((c[62682]|0)>0){i=v;return 0}E=d;ie[E&7](f,F,k,e,p,y,z)|0;if((c[62682]|0)>0){i=v;return 0}b=x+60|0;c[b>>2]=1;a[253264]=0;D=c[e>>2]|0;c[63302]=1;if((D|0)<1){i=v;return 0}else{Z=0;_=1}while(1){I=+h[p+(_+ -1<<3)>>3];if(!(I>=0.0)){$=-I}else{$=I}if(!($<=0.0)){aa=Z}else{a[253264]=1;aa=1}if((_|0)<(D|0)){Z=aa;_=_+1|0}else{break}}c[63302]=D+1;if(!aa){i=v;return 0}I=+Cdb(253256,253200);h[31654]=I;h[F>>3]=I+ +h[F>>3];I=+h[31654]/+h[31650];h[31655]=I;S=c[f>>2]|0;c[63302]=1;if((S|0)>=1){Q=(A<<1)+B|0;H=I;T=1;while(1){ba=k+(T+ -1<<3)|0;h[ba>>3]=+h[ba>>3]+H*+h[m+(Q+T<<3)>>3];if((T|0)>=(S|0)){break}H=+h[31655];T=T+1|0}c[63302]=S+1}ie[E&7](f,F,k,e,p,y,z)|0;if((c[62682]|0)>0){i=v;return 0}c[b>>2]=(c[b>>2]|0)+1;a[253264]=0;T=c[e>>2]|0;c[63302]=1;if((T|0)<1){i=v;return 0}else{ca=0;da=1}while(1){H=+h[p+(da+ -1<<3)>>3];if(!(H>=0.0)){ea=-H}else{ea=H}if(!(ea<=0.0)){fa=ca}else{a[253264]=1;fa=1}if((da|0)<(T|0)){ca=fa;da=da+1|0}else{break}}c[63302]=T+1;if(!fa){i=v;return 0}c[t>>2]=-1;i=v;return 0}}while(0);ea=+h[j>>3];do{if(!((ea-K)*J>=0.0)){h[31653]=ea;if((ea- +h[w+320>>3])*J<=0.0){i=v;return 0}$Ya(g,253224,k,l,f,o,m,n)|0;if((c[62682]|0)<=0){break}i=v;return 0}else{h[31653]=K;j=c[f>>2]|0;c[63302]=1;if((j|0)<1){break}else{ga=1}while(1){fa=ga+ -1|0;h[k+(fa<<3)>>3]=+h[m+(fa<<3)>>3];if((ga|0)<(j|0)){ga=ga+1|0}else{break}}c[63302]=j+1}}while(0);ga=d;ie[ga&7](f,253224,k,e,q,y,z)|0;if((c[62682]|0)>0){i=v;return 0}d=x+60|0;c[d>>2]=(c[d>>2]|0)+1;c[63312]=0;T=w+320|0;fa=x+76|0;da=x+72|0;x=w+336|0;ca=w+344|0;while(1){XYa(e,253256,253248,T,253224,p,q,r,253216,s,fa,da,x,ca)|0;if((c[62682]|0)>0){ha=76;break}if((c[63312]|0)>1){ha=73;break}$Ya(g,253216,k,l,f,o,m,n)|0;if((c[62682]|0)>0){ha=76;break}ie[ga&7](f,253216,k,e,r,y,z)|0;if((c[62682]|0)>0){ha=76;break}c[d>>2]=(c[d>>2]|0)+1}if((ha|0)==73){h[T>>3]=+h[31652];T=250648;rZa(e,r,T,p,T)|0;if((c[63312]|0)==4){i=v;return 0}$Ya(g,253216,k,l,f,o,m,n)|0;if((c[62682]|0)>0){i=v;return 0}c[t>>2]=1;i=v;return 0}else if((ha|0)==76){i=v;return 0}return 0}function XYa(b,d,e,f,g,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,L=0.0,M=0.0,N=0.0,O=0.0;s=i;do{if((c[e>>2]|0)==1){c[63328]=c[o>>2];c[o>>2]=0;h[31660]=0.0;a[253296]=0;t=c[b>>2]|0;c[63318]=1;if((t|0)>=1){u=1;do{v=u+ -1|0;w=+h[l+(v<<3)>>3];if(!(w>=0.0)){x=-w}else{x=w}do{if(x>0.0){w=+Cdb(253328,j+(v<<3)|0);if(w==+Cdb(253328,l+((c[63318]|0)+ -1<<3)|0)){break}y=c[63318]|0;z=y+ -1|0;w=+h[l+(z<<3)>>3];A=w/(w- +h[j+(z<<3)>>3]);if(!(A>=0.0)){B=-A}else{B=A}if(B<=+h[31660]){break}h[31660]=B;c[o>>2]=y}else{a[253296]=1}}while(0);v=c[63318]|0;u=v+1|0;c[63318]=u;}while((v|0)<(t|0))}do{if((c[o>>2]|0)>0){a[253304]=1;c[63330]=c[p>>2];h[g>>3]=+h[r>>3];t=250648;rZa(b,l,t,k,t)|0;c[p>>2]=1;a[253288]=0;C=0}else{a[253304]=0;c[o>>2]=c[63328];c[63330]=c[p>>2];if(a[253296]&1){h[g>>3]=+h[r>>3];t=250648;rZa(b,l,t,k,t)|0;a[253288]=1;C=1;break}else{t=250648;rZa(b,l,t,j,t)|0;h[f>>3]=+h[r>>3];c[p>>2]=0;a[253288]=0;C=0;break}}}while(0);A=+h[g>>3];w=A- +h[f>>3];if(!(w>=0.0)){D=-w}else{D=w}if(!(D<=+h[d>>3])){if(!C){break}E=+h[g>>3]}else{a[253288]=1;E=A}c[e>>2]=2;h[m>>3]=E;t=250648;rZa(b,k,t,l,t)|0;t=c[b>>2]|0;c[63318]=1;if((t|0)<1){i=s;return 0}else{F=1}do{c[n+(F+ -1<<2)>>2]=0;u=(c[63318]|0)+ -1|0;A=+h[k+(u<<3)>>3];if(!(A>=0.0)){G=-A}else{G=A}do{if(G>0.0){A=+Cdb(253328,j+(u<<3)|0);if(!(A!=+Cdb(253328,k+((c[63318]|0)+ -1<<3)|0))){break}c[n+((c[63318]|0)+ -1<<2)>>2]=1}else{c[n+(u<<2)>>2]=1}}while(0);u=c[63318]|0;F=u+1|0;c[63318]=F;}while((u|0)<(t|0));i=s;return 0}else{c[o>>2]=0;h[31660]=0.0;a[253296]=0;t=c[b>>2]|0;c[63318]=1;if((t|0)>=1){u=1;do{v=u+ -1|0;A=+h[k+(v<<3)>>3];if(!(A>=0.0)){H=-A}else{H=A}do{if(H>0.0){A=+Cdb(253328,j+(v<<3)|0);if(A==+Cdb(253328,k+((c[63318]|0)+ -1<<3)|0)){break}y=c[63318]|0;z=y+ -1|0;A=+h[k+(z<<3)>>3];w=A/(A- +h[j+(z<<3)>>3]);if(!(w>=0.0)){I=-w}else{I=w}if(I<=+h[31660]){break}h[31660]=I;c[o>>2]=y}else{a[253296]=1}}while(0);v=c[63318]|0;u=v+1|0;c[63318]=u;}while((v|0)<(t|0))}t=(c[o>>2]|0)>0;a[253304]=t&1;if(t){a[253288]=0;c[63330]=0;c[p>>2]=1;break}if(!(a[253296]&1)){t=250648;rZa(b,k,t,l,t)|0;h[m>>3]=+h[g>>3];c[e>>2]=4;i=s;return 0}h[m>>3]=+h[g>>3];t=250648;rZa(b,k,t,l,t)|0;t=c[b>>2]|0;c[63318]=1;if((t|0)>=1){u=1;do{c[n+(u+ -1<<2)>>2]=0;v=c[63318]|0;y=v+ -1|0;w=+h[k+(y<<3)>>3];if(!(w>=0.0)){J=-w}else{J=w}if(!(J<=0.0)){K=v}else{c[n+(y<<2)>>2]=1;K=c[63318]|0}u=K+1|0;c[63318]=u;}while((K|0)<(t|0))}c[e>>2]=3;i=s;return 0}}while(0);K=c[63330]|0;do{if((K|0)==(c[p>>2]|0)){J=+h[q>>3];if((K|0)==0){I=J*2.0;h[q>>3]=I;L=I;break}else{I=J*.5;h[q>>3]=I;L=I;break}}else{h[q>>3]=1.0;L=1.0}}while(0);I=+h[g>>3];q=(c[o>>2]|0)+ -1|0;J=+h[k+(q<<3)>>3];H=I-(I- +h[f>>3])*J/(J-L*+h[j+(q<<3)>>3]);h[r>>3]=H;L=+h[f>>3];J=H-L;if(!(J>=0.0)){M=-J}else{M=J}J=+h[d>>3];do{if(M<J){I=+h[g>>3]-L;if(!(I>=0.0)){N=-I}else{N=I}if(!(N>J*10.0)){O=H;break}G=L+I*.1;h[r>>3]=G;O=G}else{O=H}}while(0);c[e>>2]=1;h[m>>3]=O;i=s;return 0}function YYa(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0.0,o=0.0,p=0.0;k=i;h[31669]=+h[d>>3];h[31668]=+h[e>>3];j=c[a>>2]|0;c[63334]=1;if((j|0)<1){i=k;return 0}else{l=1}while(1){if((c[b>>2]|0)==0){m=l+ -1|0;n=+h[31669]}else{a=l+ -1|0;o=+h[d+(a<<3)>>3];h[31669]=o;h[31668]=+h[e+(a<<3)>>3];m=a;n=o}o=+h[f+(m<<3)>>3];if(!(o>=0.0)){p=-o}else{p=o}h[g+(m<<3)>>3]=n*p+ +h[31668];a=l+1|0;c[63334]=a;if((l|0)<(j|0)){l=a}else{break}}i=k;return 0}function ZYa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0.0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;f=i;h[31672]=0.0;e=c[a>>2]|0;c[63340]=1;if((e|0)<1){g=0.0;i=f;return+g}else{j=0.0;k=1}while(1){l=k+ -1|0;m=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3];if(!(m>=0.0)){n=-m}else{n=m}if(n>j){l=k+ -1|0;m=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3];if(!(m>=0.0)){o=-m}else{o=m}h[31672]=o;p=o}else{p=j}if((k|0)<(e|0)){j=p;k=k+1|0}else{break}}c[63340]=e+1;if(p<=0.0){g=0.0;i=f;return+g}h[31671]=0.0;e=c[a>>2]|0;c[63340]=1;if((e|0)<1){q=0.0}else{j=0.0;k=1;while(1){l=k+ -1|0;o=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3]/p;r=j+o*o;h[31671]=r;if((k|0)<(e|0)){k=k+1|0;j=r}else{break}}c[63340]=e+1;q=r}g=p*+V(+(q/+(c[a>>2]|0)));i=f;return+g}function _Ya(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,V=0.0,W=0.0;y=i;i=i+16|0;z=y;A=y+8|0;B=c[f>>2]|0;c[m>>2]=1;c[63358]=0;c[63356]=0;c[63362]=0;h[31684]=+h[b>>3];h[31686]=+ZYa(f,d,l,0,0);C=c[f>>2]|0;c[63346]=1;D=(B<<1)+~B|0;if((C|0)>=1){B=1;while(1){E=B+ -1|0;h[p+(E<<3)>>3]=+h[d+(E<<3)>>3];h[p+(D+B<<3)>>3]=+h[e+(B+ -1<<3)>>3];if((B|0)<(C|0)){B=B+1|0}else{break}}c[63346]=C+1}C=t+44|0;B=g;E=t+48|0;F=+h[k>>3];a:while(1){h[31677]=1.0/F;h[b>>3]=+h[k>>3]+ +h[b>>3];G=c[f>>2]|0;c[63346]=1;if((G|0)>=1){H=1;while(1){I=H+ -1|0;J=d+(I<<3)|0;h[J>>3]=+h[J>>3]+ +h[k>>3]*+h[e+(I<<3)>>3];if((H|0)<(G|0)){H=H+1|0}else{break}}c[63346]=G+1}a[253480]=1;c[63348]=0;a[253496]=1;c[C>>2]=(c[C>>2]|0)+1;c[63366]=0;ie[B&7](b,d,e,q,253464,n,o)|0;b:do{if((c[63366]|0)<0){K=35}else{while(1){if(a[253480]&1){c[E>>2]=(c[E>>2]|0)+1;a[253480]=0;bZa(f,b,d,e,q,253416,k,253440,l,r,s,t,g,253464,v,j,n,o,x)|0;h[31676]=1.0e6;if((c[63366]|0)<0|(c[63360]|0)!=0){K=35;break b}c[63362]=0}H=c[f>>2]|0;c[63346]=1;if((H|0)>=1){I=1;while(1){J=q+(I+ -1<<3)|0;h[J>>3]=+h[J>>3]*.75;if((I|0)<(H|0)){I=I+1|0}else{break}}c[63346]=H+1}cZa(f,q,s,t)|0;I=c[f>>2]|0;c[63346]=1;if((I|0)>=1){J=1;while(1){L=J+ -1|0;M=d+(L<<3)|0;h[M>>3]=+h[M>>3]- +h[q+(L<<3)>>3];L=J+ -1|0;M=e+(L<<3)|0;h[M>>3]=+h[M>>3]- +h[31677]*+h[q+(L<<3)>>3];if((J|0)<(I|0)){J=J+1|0}else{break}}c[63346]=I+1}N=+ZYa(f,q,l,0,0);h[31688]=N;if(N<=+h[v>>3]*100.0*+h[31686]){break}J=c[63348]|0;if((J|0)>0){h[z>>3]=N/+h[31689];h[A>>3]=1.0/+(J|0);O=+Adb(z,A);if(O>.9){K=35;break b}P=O/(1.0-O);h[31676]=P;Q=+h[31688];R=P}else{h[31689]=N;Q=N;R=+h[31676]}if(R*Q<=.33){break}J=c[63348]|0;H=J+1|0;c[63348]=H;if((J|0)>8){K=35;break b}if(((H|0)%5|0|0)==0){a[253480]=1}c[C>>2]=(c[C>>2]|0)+1;c[63366]=0;ie[B&7](b,d,e,q,253464,n,o)|0;if((c[63366]|0)<0){K=35;break b}}do{if((c[w>>2]|0)!=0){H=c[f>>2]|0;c[63346]=1;if((H|0)>=1){J=1;while(1){S=+h[d+(J+ -1<<3)>>3];h[q+(J+ -1<<3)>>3]=S<=0.0?S:0.0;if((J|0)<(H|0)){J=J+1|0}else{break}}h[z>>3]=S;c[63346]=H+1}N=+ZYa(f,q,l,0,0);h[31688]=N;if(N>.33){K=35;break b}J=c[f>>2]|0;c[63346]=1;if((J|0)<1){break}else{T=1}while(1){I=T+ -1|0;L=d+(I<<3)|0;h[L>>3]=+h[L>>3]- +h[q+(I<<3)>>3];I=T+ -1|0;L=e+(I<<3)|0;h[L>>3]=+h[L>>3]- +h[31677]*+h[q+(I<<3)>>3];if((T|0)<(J|0)){T=T+1|0}else{break}}c[63346]=J+1}}while(0);if(!(a[253496]&1)){break}H=c[f>>2]|0;c[63346]=1;if((H|0)>=1){I=1;while(1){L=I+ -1|0;h[r+(L<<3)>>3]=+h[d+(L<<3)>>3]- +h[p+(L<<3)>>3];if((I|0)<(H|0)){I=I+1|0}else{break}}c[63346]=H+1}N=+ZYa(f,r,l,0,0);h[31682]=N;if(N<=1.0){K=63;break a}}}while(0);if((K|0)==35){K=0;a[253496]=0}h[b>>3]=+h[31684];G=c[f>>2]|0;c[63346]=1;if((G|0)>=1){I=1;while(1){L=I+ -1|0;h[d+(L<<3)>>3]=+h[p+(L<<3)>>3];h[e+(I+ -1<<3)>>3]=+h[p+(D+I<<3)>>3];if((I|0)<(G|0)){I=I+1|0}else{break}}c[63346]=G+1}if(a[253496]&1){I=(c[63358]|0)+1|0;c[63358]=I;N=.9/(+h[31682]*2.0+1.0e-4);h[z>>3]=.1;P=N>=.5?.5:N;h[A>>3]=P;N=P<=.1?.1:P;h[31675]=N;P=+h[k>>3]*N;h[k>>3]=P;if(!(P>=0.0)){U=-P}else{U=P}if(U>=+h[u>>3]&(I|0)<10){F=P;continue}else{K=62;break}}if((c[63360]|0)!=0){I=(c[63362]|0)+1|0;c[63362]=I;P=+h[k>>3]*.25;h[k>>3]=P;if((I|0)>=3){K=51;break}if(!(P>=0.0)){V=-P}else{V=P}if(!(V>=+h[u>>3])){K=51;break}else{F=P;continue}}if(!((c[63366]|0)>-2)){K=53;break}I=(c[63356]|0)+1|0;c[63356]=I;P=+h[k>>3]*.25;h[k>>3]=P;if((I|0)>=10){K=58;break}if(!(P>=0.0)){W=-P}else{W=P}if(!(W>=+h[u>>3])){K=58;break}else{F=P}}if((K|0)==51){c[m>>2]=-12;i=y;return 0}else if((K|0)==53){c[m>>2]=-12;i=y;return 0}else if((K|0)==58){c[m>>2]=-12;i=y;return 0}else if((K|0)==62){c[m>>2]=-12;i=y;return 0}else if((K|0)==63){i=y;return 0}return 0}function $Ya(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0;l=i;m=c[f>>2]|0;n=~m;o=(c[g>>2]|0)+1|0;c[63392]=o;p=+h[b>>3]- +h[a>>3];h[31694]=p;a=c[f>>2]|0;c[63384]=1;if((a|0)<1){q=p}else{b=1;while(1){g=b+ -1|0;h[d+(g<<3)>>3]=+h[j+(g<<3)>>3];h[e+(b+ -1<<3)>>3]=0.0;if((b|0)<(a|0)){b=b+1|0}else{break}}c[63384]=a+1;q=+h[31694]}h[31690]=1.0;h[31691]=0.0;p=q/+h[k>>3];h[31695]=p;c[63386]=2;if((o|0)<2){i=l;return 0}else{r=q;s=1.0;t=p;u=0.0;v=2}while(1){a=k+(v+ -2<<3)|0;h[31691]=u*t+s/+h[a>>3];p=t*s;h[31690]=p;h[31695]=(r+ +h[a>>3])/+h[k+(v+ -1<<3)>>3];a=c[f>>2]|0;c[63384]=1;if((a|0)>=1){b=fa(v,m)|0;q=p;g=1;while(1){w=d+(g+ -1<<3)|0;h[w>>3]=+h[w>>3]+q*+h[j+(g+n+b<<3)>>3];w=e+(g+ -1<<3)|0;h[w>>3]=+h[w>>3]+ +h[31691]*+h[j+(g+n+b<<3)>>3];if((g|0)>=(a|0)){break}q=+h[31690];g=g+1|0}c[63384]=a+1}g=v+1|0;c[63386]=g;if((v|0)>=(o|0)){break}r=+h[31694];s=+h[31690];t=+h[31695];u=+h[31691];v=g}i=l;return 0}function aZa(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A,B,C,D,E,F,G,H,I,J,K,L,M){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;B=B|0;C=C|0;D=D|0;E=E|0;F=F|0;G=G|0;H=H|0;I=I|0;J=J|0;K=K|0;L=L|0;M=M|0;var N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0,pa=0.0,qa=0,ra=0,sa=0.0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0,Ca=0,Da=0.0,Ea=0,Fa=0,Ga=0.0,Ha=0;N=i;i=i+16|0;O=N;P=N+8|0;Q=c[f>>2]|0;R=~Q;c[n>>2]=1;h[31717]=+h[b>>3];c[63412]=0;c[63420]=0;c[63414]=0;S=u+52|0;if((c[m>>2]|0)==0){c[S>>2]=0;T=u+56|0;c[T>>2]=0;c[I>>2]=1;c[J>>2]=0;h[C>>3]=0.0;c[m>>2]=1;h[y>>3]=+h[k>>3];U=1.0/+h[k>>3];h[B>>3]=U;h[A>>3]=U;h[D>>3]=100.0;c[H>>2]=-1;h[31729]=1.0;c[G>>2]=0;c[K>>2]=0;V=T}else{V=u+56|0}T=u+44|0;m=g;W=u+48|0;while(1){c[63408]=(c[I>>2]|0)+1;c[63410]=(c[I>>2]|0)+2;c[63406]=(c[I>>2]|0)+ -1;h[31717]=+h[b>>3];do{if(+h[k>>3]!=+h[C>>3]){X=8}else{Y=c[I>>2]|0;if((Y|0)!=(c[J>>2]|0)){X=8;break}Z=(c[K>>2]|0)+1|0;_=Y}}while(0);if((X|0)==8){X=0;c[K>>2]=0;Z=1;_=c[J>>2]|0}Y=_+2|0;$=(Z|0)<=(Y|0)?Z:Y;c[K>>2]=$;c[63424]=$+1;$=c[63408]|0;if(($|0)>=(c[K>>2]|0)){h[w>>3]=1.0;h[v>>3]=1.0;h[31720]=+h[k>>3];h[x>>3]=0.0;h[z>>3]=1.0;c[63394]=2;if(($|0)>=2){Y=2;while(1){h[31721]=+h[y+(Y+ -2<<3)>>3];U=+h[31720];aa=Y+ -2|0;h[y+(aa<<3)>>3]=U;ba=Y+ -1|0;h[w+(ba<<3)>>3]=+h[w+(aa<<3)>>3]*U/+h[31721];U=+h[31721]+ +h[k>>3];h[31720]=U;ca=+h[k>>3]/U;h[v+(ba<<3)>>3]=ca;h[z+(ba<<3)>>3]=ca*+h[z+(aa<<3)>>3]*+(ba|0);h[x+(ba<<3)>>3]=+h[x+(aa<<3)>>3]+ +h[v+(aa<<3)>>3]/+h[k>>3];if((Y|0)<($|0)){Y=Y+1|0}else{break}}c[63394]=$+1}h[y+($+ -1<<3)>>3]=+h[31720]}h[31727]=0.0;h[31725]=0.0;Y=c[I>>2]|0;c[63394]=1;if((Y|0)<1){da=0.0}else{ca=0.0;U=0.0;aa=1;while(1){ea=U-1.0/+(aa|0);h[31727]=ea;ga=ca- +h[v+(aa+ -1<<3)>>3];h[31725]=ga;if((aa|0)<(Y|0)){aa=aa+1|0;U=ea;ca=ga}else{break}}c[63394]=Y+1;da=ea}h[31728]=+h[A>>3];h[A>>3]=-da/+h[k>>3];aa=v+($+ -1<<3)|0;ca=+h[aa>>3]+ +h[31727]- +h[31725];h[O>>3]=ca;if(!(ca>=0.0)){ha=-ca}else{ha=ca}h[31702]=ha;h[O>>3]=ha;ca=+h[aa>>3];h[P>>3]=ca;h[31702]=ha>=ca?ha:ca;h[31720]=.6;h[31721]=1.6666666666666667;ca=+h[A>>3];U=ca/+h[B>>3];if(U<.6|U>1.6666666666666667){c[H>>2]=-1}if(ca!=+h[31728]){h[D>>3]=100.0}aa=c[63408]|0;ba=c[63424]|0;if((aa|0)>=(ba|0)){c[63396]=ba;ia=ba;while(1){ba=c[f>>2]|0;c[63394]=1;if((ba|0)>=1){ja=1;while(1){ka=q+(ja+R+(fa(ia,Q)|0)<<3)|0;h[ka>>3]=+h[w+(ia+ -1<<3)>>3]*+h[ka>>3];if((ja|0)<(ba|0)){ja=ja+1|0}else{break}}c[63394]=ba+1}ja=ia+1|0;c[63396]=ja;if((ia|0)<(aa|0)){ia=ja}else{break}}}h[b>>3]=+h[k>>3]+ +h[b>>3];a:while(1){ia=c[f>>2]|0;c[63394]=1;if((ia|0)>=1){aa=1;while(1){$=aa+ -1|0;h[d+($<<3)>>3]=+h[q+($<<3)>>3];h[e+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ia|0)){aa=aa+1|0}else{break}}c[63394]=ia+1}aa=c[63408]|0;c[63396]=2;if((aa|0)>=2){ba=2;while(1){$=c[f>>2]|0;c[63394]=1;if(($|0)>=1){Y=x+(ba+ -1<<3)|0;ja=fa(ba,Q)|0;ka=ja+R|0;la=1;while(1){ma=d+(la+ -1<<3)|0;h[ma>>3]=+h[q+(la+R+ja<<3)>>3]+ +h[ma>>3];ma=e+(la+ -1<<3)|0;h[ma>>3]=+h[ma>>3]+ +h[Y>>3]*+h[q+(ka+la<<3)>>3];if((la|0)<($|0)){la=la+1|0}else{break}}c[63394]=$+1}la=ba+1|0;c[63396]=la;if((ba|0)<(aa|0)){ba=la}else{break}}}h[31724]=+ZYa(f,d,l,0,0);a[253840]=1;c[63398]=0;c[T>>2]=(c[T>>2]|0)+1;c[63428]=0;ie[m&7](b,d,e,r,253712,o,p)|0;if((c[63428]|0)<0){X=70;break}if((c[H>>2]|0)==-1){c[W>>2]=(c[W>>2]|0)+1;c[H>>2]=0;bZa(f,b,d,e,r,A,k,253664,l,s,t,u,g,253712,F,j,o,p,M)|0;h[B>>3]=+h[A>>3];h[D>>3]=100.0;if((c[63428]|0)<0|(c[63416]|0)!=0){X=70;break}c[63420]=0}ba=c[f>>2]|0;c[63394]=1;if((ba|0)>=1){aa=1;while(1){h[s+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ba|0)){aa=aa+1|0}else{break}}c[63394]=ba+1}while(1){ca=2.0/(+h[A>>3]/+h[B>>3]+1.0);h[31720]=ca;aa=c[f>>2]|0;c[63394]=1;if((aa|0)>=1){U=ca;ia=1;la=0;while(1){ka=r+(la<<3)|0;h[ka>>3]=U*+h[ka>>3];if((ia|0)>=(aa|0)){break}ka=ia;U=+h[31720];ia=ia+1|0;la=ka}c[63394]=aa+1}cZa(f,r,t,u)|0;la=c[f>>2]|0;c[63394]=1;if((la|0)>=1){ia=1;while(1){$=ia+ -1|0;ka=d+($<<3)|0;h[ka>>3]=+h[ka>>3]- +h[r+($<<3)>>3];$=ia+ -1|0;ka=r+($<<3)|0;Y=s+($<<3)|0;h[Y>>3]=+h[Y>>3]- +h[ka>>3];Y=e+($<<3)|0;h[Y>>3]=+h[Y>>3]- +h[A>>3]*+h[ka>>3];if((ia|0)<(la|0)){ia=ia+1|0}else{break}}c[63394]=la+1}U=+ZYa(f,r,l,0,0);h[31729]=U;if(U<=+h[F>>3]*100.0*+h[31724]){X=63;break a}ia=c[63398]|0;if((ia|0)>0){h[O>>3]=U/+h[31731];h[P>>3]=1.0/+(ia|0);ca=+Adb(O,P);if(ca>.9){break}ga=ca/(1.0-ca);h[D>>3]=ga;na=+h[31729];oa=ga}else{h[31731]=U;na=U;oa=+h[D>>3]}if(oa*na<=.33){X=63;break a}ia=c[63398]|0;c[63398]=ia+1;if((ia|0)>2){break}c[T>>2]=(c[T>>2]|0)+1;c[63428]=0;ie[m&7](b,d,e,r,253712,o,p)|0;if((c[63428]|0)<0){X=70;break a}}if((c[H>>2]|0)==0){X=70;break}c[H>>2]=-1}do{if((X|0)==63){X=0;if((c[L>>2]|0)==0){break}ba=c[f>>2]|0;c[63394]=1;if((ba|0)>=1){ia=1;while(1){pa=+h[d+(ia+ -1<<3)>>3];h[r+(ia+ -1<<3)>>3]=pa<=0.0?pa:0.0;if((ia|0)<(ba|0)){ia=ia+1|0}else{break}}h[O>>3]=pa;c[63394]=ba+1}U=+ZYa(f,r,l,0,0);h[31729]=U;if(U>.33){X=70;break}ia=c[f>>2]|0;c[63394]=1;if((ia|0)<1){break}else{qa=1}while(1){aa=qa+ -1|0;ka=s+(aa<<3)|0;h[ka>>3]=+h[ka>>3]- +h[r+(aa<<3)>>3];if((qa|0)<(ia|0)){qa=qa+1|0}else{break}}c[63394]=ia+1}}while(0);if((X|0)==70){X=0;a[253840]=0}c[H>>2]=1;if(a[253840]&1){U=+ZYa(f,s,l,0,0);h[31723]=U;ba=c[I>>2]|0;ga=U*+h[z+(ba<<3)>>3];h[31709]=ga;h[31716]=ga*+(ba+1|0);h[31711]=ga;c[63430]=ba;do{if((c[I>>2]|0)!=1){ba=c[f>>2]|0;c[63394]=1;if((ba|0)>=1){aa=fa(c[63408]|0,Q)|0;ka=1;while(1){Y=ka+ -1|0;h[r+(Y<<3)>>3]=+h[q+(ka+R+aa<<3)>>3]+ +h[s+(Y<<3)>>3];if((ka|0)<(ba|0)){ka=ka+1|0}else{break}}c[63394]=ba+1}ga=+h[z+((c[I>>2]|0)+ -1<<3)>>3];U=ga*+ZYa(f,r,l,0,0);h[31718]=U;ka=c[I>>2]|0;ga=U*+(ka|0);h[31726]=ga;if((ka|0)>2){aa=c[f>>2]|0;c[63394]=1;ia=c[I>>2]|0;if((aa|0)<1){ra=ia}else{Y=ia;ia=1;while(1){ca=+h[q+(ia+R+(fa(Y,Q)|0)<<3)>>3];$=r+(ia+ -1<<3)|0;h[$>>3]=ca+ +h[$>>3];$=ia+1|0;c[63394]=$;ja=c[I>>2]|0;if((ia|0)<(aa|0)){ia=$;Y=ja}else{ra=ja;break}}}ca=+h[z+(ra+ -2<<3)>>3];sa=ca*+ZYa(f,r,l,0,0);Y=c[I>>2]|0;ca=sa*+(Y+ -1|0);sa=+h[31726];if((sa>=ca?sa:ca)>+h[31716]){break}ta=+h[31718];ua=Y}else{if(!(ga<=+h[31716]*.5)){break}else{ta=U;ua=ka}}c[63430]=ua+ -1;h[31711]=ta}}while(0);if(!(+h[31702]*+h[31723]>1.0)){X=86;break}}c[G>>2]=1;h[b>>3]=+h[31717];Y=c[63408]|0;ia=c[63424]|0;if((Y|0)>=(ia|0)){c[63396]=ia;aa=ia;while(1){ca=1.0/+h[w+(aa+ -1<<3)>>3];h[31720]=ca;ia=c[f>>2]|0;c[63394]=1;if((ia|0)>=1){ba=fa(aa,Q)|0;sa=ca;ja=1;while(1){$=q+(ja+R+ba<<3)|0;h[$>>3]=sa*+h[$>>3];if((ja|0)>=(ia|0)){break}sa=+h[31720];ja=ja+1|0}c[63394]=ia+1}ja=aa+1|0;c[63396]=ja;if((aa|0)<(Y|0)){aa=ja}else{break}}}c[63394]=2;if((Y|0)>=2){aa=2;while(1){h[y+(aa+ -2<<3)>>3]=+h[y+(aa+ -1<<3)>>3]- +h[k>>3];if((aa|0)<(Y|0)){aa=aa+1|0}else{break}}c[63394]=Y+1}if(!(a[253840]&1)){c[V>>2]=(c[V>>2]|0)+1;if((c[63416]|0)!=0){aa=(c[63420]|0)+1|0;c[63420]=aa;h[31700]=.25;sa=+h[k>>3]*.25;h[k>>3]=sa;if((aa|0)>=3){X=144;break}if(!(sa>=0.0)){va=-sa}else{va=sa}if(!(va>=+h[E>>3])){X=144;break}else{continue}}if(!((c[63428]|0)>-2)){X=146;break}aa=(c[63412]|0)+1|0;c[63412]=aa;h[31700]=.25;sa=+h[k>>3]*.25;h[k>>3]=sa;if((aa|0)>=10){X=151;break}if(!(sa>=0.0)){wa=-sa}else{wa=sa}if(!(wa>=+h[E>>3])){X=151;break}else{continue}}c[63414]=(c[63414]|0)+1;c[S>>2]=(c[S>>2]|0)+1;aa=c[63414]|0;if((aa|0)<=1){ja=c[63430]|0;c[I>>2]=ja;sa=+(ja+1|0);h[31721]=sa;h[O>>3]=+h[31711]*2.0+1.0e-4;h[P>>3]=-1.0/sa;sa=+Adb(O,P)*.9;h[O>>3]=.25;U=sa>=.9?.9:sa;h[P>>3]=U;sa=U<=.25?.25:U;h[31700]=sa;U=+h[k>>3]*sa;h[k>>3]=U;if(!(U>=0.0)){xa=-U}else{xa=U}if(!(xa>=+h[E>>3])){X=156;break}else{continue}}if((aa|0)>2){c[I>>2]=1;U=+h[k>>3]*.25;h[k>>3]=U;if(!(U>=0.0)){ya=-U}else{ya=U}if(!(ya>=+h[E>>3])){X=165;break}else{continue}}else{c[I>>2]=c[63430];U=+h[k>>3]*.25;h[k>>3]=U;if(!(U>=0.0)){za=-U}else{za=U}if(!(za>=+h[E>>3])){X=161;break}else{continue}}}if((X|0)==86){c[n>>2]=1;E=u+40|0;c[E>>2]=(c[E>>2]|0)+1;c[63444]=(c[I>>2]|0)-(c[J>>2]|0);c[J>>2]=c[I>>2];h[C>>3]=+h[k>>3];C=c[63430]|0;E=c[63406]|0;do{if((C|0)==(E|0)){X=88}else{S=u+8|0;if((c[I>>2]|0)==(c[S>>2]|0)){X=88;break}if((c[G>>2]|0)!=0){Aa=E;Ba=C;X=90;break}c[I>>2]=c[63408];za=+h[k>>3]*2.0;h[31713]=za;Ca=S;Da=za}}while(0);if((X|0)==88){c[G>>2]=1;Aa=c[63406]|0;Ba=c[63430]|0;X=90}if((X|0)==90){do{if((Ba|0)==(Aa|0)){Ea=Aa;X=104}else{G=c[I>>2]|0;C=u+8|0;if((G|0)==(c[C>>2]|0)){Fa=G;break}if((c[63408]|0)>=(c[K>>2]|0)|(c[63444]|0)==1){Fa=G;break}G=c[f>>2]|0;c[63394]=1;if((G|0)>=1){E=fa(c[63410]|0,Q)|0;S=1;while(1){V=S+ -1|0;h[r+(V<<3)>>3]=+h[s+(V<<3)>>3]- +h[q+(S+R+E<<3)>>3];if((S|0)<(G|0)){S=S+1|0}else{break}}c[63394]=G+1}za=1.0/+((c[I>>2]|0)+2|0);ya=za*+ZYa(f,r,l,0,0);h[31719]=ya;S=c[I>>2]|0;za=ya*+(S+2|0);if((S|0)>1){xa=+h[31716];E=xa<=za;if(+h[31726]<=(E?xa:za)){Ea=c[63406]|0;X=104;break}if(E){Fa=S;break}if((S|0)==(c[C>>2]|0)){Fa=S;break}}else{if(za>=+h[31716]*.5){Fa=S;break}}S=c[63408]|0;c[I>>2]=S;h[31711]=ya;Fa=S}}while(0);if((X|0)==104){c[I>>2]=Ea;h[31711]=+h[31718];Fa=Ea}h[31713]=+h[k>>3];ya=+(Fa+1|0);h[31721]=ya;h[O>>3]=+h[31711]*2.0+1.0e-4;h[P>>3]=-1.0/ya;ya=+Adb(O,P);h[31700]=ya;do{if(ya<2.0){if(ya>1.0){Ga=+h[31713];break}else{h[O>>3]=.5;za=ya>=.9?.9:ya;h[P>>3]=za;xa=za<=.5?.5:za;h[31700]=xa;za=+h[k>>3]*xa;h[31713]=za;Ga=za;break}}else{za=+h[k>>3]*2.0;h[31713]=za;Ga=za}}while(0);Ca=u+8|0;Da=Ga}h[k>>3]=Da;do{if((c[J>>2]|0)!=(c[Ca>>2]|0)){k=c[f>>2]|0;c[63394]=1;if((k|0)<1){break}u=fa(c[63410]|0,Q)|0;P=1;while(1){h[q+(P+R+u<<3)>>3]=+h[s+(P+ -1<<3)>>3];if((P|0)<(k|0)){P=P+1|0}else{break}}c[63394]=k+1}}while(0);Ca=c[f>>2]|0;c[63394]=1;if((Ca|0)>=1){J=fa(c[63408]|0,Q)|0;P=1;while(1){u=q+(P+R+J<<3)|0;h[u>>3]=+h[s+(P+ -1<<3)>>3]+ +h[u>>3];if((P|0)<(Ca|0)){P=P+1|0}else{break}}c[63394]=Ca+1}Ca=c[63408]|0;c[63402]=2;if((Ca|0)<2){i=N;return 0}else{Ha=2}while(1){P=1-Ha+Ca|0;c[63396]=P;s=c[f>>2]|0;c[63394]=1;if((s|0)>=1){J=fa(P+1|0,Q)|0;u=fa(P,Q)|0;P=1;while(1){C=P+R|0;G=q+(C+u<<3)|0;h[G>>3]=+h[q+(C+J<<3)>>3]+ +h[G>>3];if((P|0)<(s|0)){P=P+1|0}else{break}}c[63394]=s+1}P=Ha+1|0;c[63402]=P;if((Ha|0)<(Ca|0)){Ha=P}else{break}}i=N;return 0}else if((X|0)==144){c[n>>2]=-8}else if((X|0)==146){c[n>>2]=-11}else if((X|0)==151){c[n>>2]=-7;Ha=(c[63428]>>31&-3)+ -7|0;c[n>>2]=Ha;c[n>>2]=(c[63414]|0)>2?-9:Ha}else if((X|0)==156){c[n>>2]=-6}else if((X|0)==161){c[n>>2]=-6}else if((X|0)==165){c[n>>2]=-6}$Ya(b,b,d,e,f,I,q,y)|0;i=N;return 0}function bZa(b,d,e,f,g,j,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0.0,ta=0.0,ua=0.0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+16|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+16|0;I=i;i=i+8|0;J=i;i=i+16|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;c[m>>2]=0;O=c[q+12>>2]|0;a:do{if((O|0)==5){P=q+4|0;Q=(c[P>>2]|0)+(c[q>>2]|0)|0;R=Q+1|0;c[63490]=R;S=c[b>>2]|0;c[63480]=(Q|0)<(S|0)?R:S;S=c[q>>2]|0;c[63498]=R+S;c[63484]=S+Q;Q=(c[b>>2]|0)/(R|0)|0;c[63494]=Q+1;R=c[x>>2]|0;c[63492]=R+ -1;c[63502]=R+Q;c[s>>2]=0;h[31744]=+V(+(+h[t>>3]));Q=c[63480]|0;c[63466]=1;if((Q|0)<1){T=75;break}R=r;S=1;while(1){U=c[b>>2]|0;W=c[63490]|0;c[63472]=S;X=(W|0)<0;b:do{if(X?(S|0)>=(U|0):(S|0)<=(U|0)){Y=W;Z=S;_=S;while(1){$=(_-Z|0)/(Y|0)|0;c[63468]=$+1;aa=_+ -1|0;ba=e+(aa<<3)|0;h[p+((c[63492]|0)+$<<3)>>3]=+h[ba>>3];ca=f+(aa<<3)|0;h[p+((c[63502]|0)+$<<3)>>3]=+h[ca>>3];da=+h[ba>>3];h[N>>3]=da;if(!(da>=0.0)){ea=-da}else{ea=da}da=+h[l>>3]*+h[ca>>3];if(!(da>=0.0)){ga=-da}else{ga=da}da=ea>=ga?ea:ga;ha=+h[n+(aa<<3)>>3];if(!(ha>=0.0)){ia=-ha}else{ia=ha}h[31741]=+h[31744]*(da>=ia?da:ia);h[N>>3]=+h[l>>3]*+h[ca>>3];da=+Cdb(253928,N);h[31741]=da;ca=c[63472]|0;aa=ca+ -1|0;ba=e+(aa<<3)|0;ha=+h[ba>>3];ja=da+ha-ha;h[31741]=ja;h[ba>>3]=+h[ba>>3]+ja;ba=f+(aa<<3)|0;h[ba>>3]=+h[j>>3]*+h[31741]+ +h[ba>>3];ba=ca+W|0;c[63472]=ba;if(!(X?(ba|0)>=(U|0):(ba|0)<=(U|0))){break b}Y=c[63490]|0;Z=c[63466]|0;_=ba}}}while(0);ie[R&7](d,e,f,o,s,v,w)|0;if((c[s>>2]|0)<0){break}U=c[b>>2]|0;X=c[63490]|0;W=c[63466]|0;c[63472]=W;_=(X|0)<0;c:do{if(_?(W|0)>=(U|0):(W|0)<=(U|0)){Z=X;Y=W;ba=W;while(1){ca=(ba-Y|0)/(Z|0)|0;c[63468]=ca+1;aa=ba+ -1|0;$=e+(aa<<3)|0;h[$>>3]=+h[p+((c[63492]|0)+ca<<3)>>3];ja=+h[p+((c[63502]|0)+ca<<3)>>3];ca=f+(aa<<3)|0;h[ca>>3]=ja;ha=+h[$>>3];h[N>>3]=ha;if(!(ha>=0.0)){ka=-ha}else{ka=ha}ha=+h[l>>3]*ja;if(!(ha>=0.0)){la=-ha}else{la=ha}ha=ka>=la?ka:la;ja=+h[n+(aa<<3)>>3];if(!(ja>=0.0)){ma=-ja}else{ma=ja}h[31741]=+h[31744]*(ha>=ma?ha:ma);h[N>>3]=+h[l>>3]*+h[ca>>3];ha=+Cdb(253928,N);h[31741]=ha;ca=c[63472]|0;ja=+h[e+(ca+ -1<<3)>>3];da=ha+ja-ja;h[31741]=da;ja=1.0/da;h[31750]=ja;aa=ca-(c[P>>2]|0)|0;$=(aa|0)>1?aa:1;c[63474]=$;aa=c[b>>2]|0;na=(c[q>>2]|0)+ca|0;oa=(aa|0)<=(na|0)?aa:na;c[63476]=oa;pa=fa(c[63484]|0,ca)|0;qa=pa-(c[q>>2]|0)|0;c[63478]=qa;c[63464]=$;if(($|0)<=(oa|0)){pa=~aa;aa=~na;na=~((pa|0)>(aa|0)?pa:aa);aa=($|0)>(na|0)?$:na;da=ja;na=$;while(1){$=na+ -1|0;h[p+($+qa<<3)>>3]=(+h[o+($<<3)>>3]- +h[g+($<<3)>>3])*da;if((na|0)>=(oa|0)){break}da=+h[31750];na=na+1|0}c[63464]=aa+1}na=ca+X|0;c[63472]=na;oa=c[63466]|0;if(!(_?(na|0)>=(U|0):(na|0)<=(U|0))){ra=oa;break c}Z=c[63490]|0;Y=oa;ba=na}}else{ra=W}}while(0);W=ra+1|0;c[63466]=W;if((ra|0)<(Q|0)){S=W}else{T=75;break a}}i=y;return 0}else if((O|0)==4){S=c[q>>2]|0;Q=q+4|0;P=c[Q>>2]|0;R=c[b>>2]|0;W=fa(P+1+(S<<1)|0,R)|0;c[63464]=1;if((W|0)>=1){U=fa(R,P+(S<<1)+1|0)|0;S=(U|0)<1;P=1;while(1){h[p+(P+ -1<<3)>>3]=0.0;if((P|0)<(W|0)){P=P+1|0}else{break}}c[63464]=S?2:U+1|0}oe[u&7](d,e,f,g,p,j,l,n,v,w)|0;c[63498]=(c[Q>>2]|0)+1+(c[q>>2]<<1);T=75}else if((O|0)==2){c[s>>2]=0;c[63486]=0;h[31744]=+V(+(+h[t>>3]));P=c[b>>2]|0;c[63464]=1;d:do{if((P|0)>=1){W=r;R=1;while(1){_=R+ -1|0;da=+h[e+(_<<3)>>3];h[N>>3]=da;if(!(da>=0.0)){sa=-da}else{sa=da}X=f+(_<<3)|0;da=+h[l>>3]*+h[X>>3];if(!(da>=0.0)){ta=-da}else{ta=da}da=sa>=ta?sa:ta;ja=+h[n+(_<<3)>>3];if(!(ja>=0.0)){ua=-ja}else{ua=ja}h[31741]=+h[31744]*(da>=ua?da:ua);h[N>>3]=+h[l>>3]*+h[X>>3];da=+Cdb(253928,N);h[31741]=da;X=(c[63464]|0)+ -1|0;_=e+(X<<3)|0;ja=+h[_>>3];ha=da+ja-ja;h[31741]=ha;h[31748]=+h[_>>3];ba=f+(X<<3)|0;h[31752]=+h[ba>>3];h[_>>3]=ha+ +h[_>>3];h[ba>>3]=+h[j>>3]*+h[31741]+ +h[ba>>3];ie[W&7](d,e,f,o,s,v,w)|0;if((c[s>>2]|0)<0){break}ha=1.0/+h[31741];h[31750]=ha;ba=c[b>>2]|0;c[63470]=1;_=c[63486]|0;if((ba|0)>=1){ja=ha;X=1;Y=0;while(1){h[p+(Y+_<<3)>>3]=(+h[o+(Y<<3)>>3]- +h[g+(Y<<3)>>3])*ja;if((X|0)>=(ba|0)){break}Z=X;ja=+h[31750];X=X+1|0;Y=Z}c[63470]=ba+1}c[63486]=_+(c[b>>2]|0);Y=c[63464]|0;X=Y+ -1|0;h[e+(X<<3)>>3]=+h[31748];h[f+(X<<3)>>3]=+h[31752];R=Y+1|0;c[63464]=R;if((Y|0)>=(P|0)){break d}}i=y;return 0}}while(0);if((c[w>>2]|0)==0){T=42;break}c[63486]=0;P=c[b>>2]|0;if((c[240136>>2]|0)==0){T=42;break}Q=Wpb(P*20|0)|0;U=F;h[k>>3]=+h[d>>3];c[U>>2]=c[k>>2];c[U+4>>2]=c[k+4>>2];kXa(14,1,254024,F);U=E;h[k>>3]=+h[j>>3];c[U>>2]=c[k>>2];c[U+4>>2]=c[k+4>>2];kXa(14,0,254048,E);kXa(14,1,254056,D);c[63468]=0;if((c[b>>2]|0)>0){U=0;do{ja=+h[e+(U<<3)>>3];c[C>>2]=U+1;S=C+4|0;h[k>>3]=ja;c[S>>2]=c[k>>2];c[S+4>>2]=c[k+4>>2];kXa(14,0,254064,C);U=(c[63468]|0)+1|0;c[63468]=U;}while((U|0)<(c[b>>2]|0))}me[c[60158]&2047](14);kXa(14,1,254120,B);c[63464]=1;if((P|0)>=1){U=Q+1|0;S=c[63486]|0;R=1;do{W=p+(R+ -1+S<<3)|0;h[W>>3]=+h[j>>3]+ +h[W>>3];a[Q]=0;a[U]=0;c[63470]=1;W=S;Y=0;while(1){ja=+h[p+(Y+W<<3)>>3];c[A>>2]=Q;X=A+4|0;h[k>>3]=ja;c[X>>2]=c[k>>2];c[X+4>>2]=c[k+4>>2];lc(Q|0,254104,A|0)|0;X=c[63470]|0;c[63470]=X+1;if((X|0)>=(P|0)){break}W=c[63486]|0;Y=X}c[z>>2]=Q;kXa(14,0,254112,z);Y=c[63486]|0;W=c[63464]|0;X=p+(Y+ -1+W<<3)|0;h[X>>3]=+h[X>>3]- +h[j>>3];S=Y+(c[b>>2]|0)|0;c[63486]=S;R=W+1|0;c[63464]=R;}while((W|0)<(P|0))}me[c[60158]&2047](14);me[c[60158]&2047](14);Xpb(Q);T=42}else if((O|0)==3){i=y;return 0}else{P=c[b>>2]|0;R=fa(P,P)|0;c[63464]=1;if((R|0)!=0){P=(R|0)<1;S=1;while(1){h[p+(S+ -1<<3)>>3]=0.0;if((S|0)<(R|0)){S=S+1|0}else{break}}c[63464]=P?2:R+1|0}oe[u&7](d,e,f,g,p,j,l,n,v,w)|0;if((c[w>>2]|0)==0){T=42;break}c[63486]=0;S=c[b>>2]|0;if((c[240136>>2]|0)==0){T=42;break}Q=Wpb(S*20|0)|0;U=M;h[k>>3]=+h[d>>3];c[U>>2]=c[k>>2];c[U+4>>2]=c[k+4>>2];kXa(14,1,254024,M);U=L;h[k>>3]=+h[j>>3];c[U>>2]=c[k>>2];c[U+4>>2]=c[k+4>>2];kXa(14,0,254048,L);kXa(14,1,254056,K);c[63468]=0;if((c[b>>2]|0)>0){U=0;do{ja=+h[e+(U<<3)>>3];c[J>>2]=U+1;W=J+4|0;h[k>>3]=ja;c[W>>2]=c[k>>2];c[W+4>>2]=c[k+4>>2];kXa(14,0,254064,J);U=(c[63468]|0)+1|0;c[63468]=U;}while((U|0)<(c[b>>2]|0))}me[c[60158]&2047](14);kXa(14,1,254080,I);c[63464]=1;if((S|0)>=1){U=Q+1|0;R=c[63486]|0;P=1;do{W=p+(P+ -1+R<<3)|0;h[W>>3]=+h[j>>3]+ +h[W>>3];a[Q]=0;a[U]=0;c[63470]=1;W=R;Y=0;while(1){ja=+h[p+(Y+W<<3)>>3];c[H>>2]=Q;X=H+4|0;h[k>>3]=ja;c[X>>2]=c[k>>2];c[X+4>>2]=c[k+4>>2];lc(Q|0,254104,H|0)|0;X=c[63470]|0;c[63470]=X+1;if((X|0)>=(S|0)){break}W=c[63486]|0;Y=X}c[G>>2]=Q;kXa(14,0,254112,G);Y=c[63486]|0;W=c[63464]|0;X=p+(Y+ -1+W<<3)|0;h[X>>3]=+h[X>>3]- +h[j>>3];R=Y+(c[b>>2]|0)|0;c[63486]=R;P=W+1|0;c[63464]=P;}while((W|0)<(S|0))}me[c[60158]&2047](14);me[c[60158]&2047](14);Xpb(Q);T=42}}while(0);if((T|0)==42){jZa(p,b,b,q+80|0,m)|0;i=y;return 0}else if((T|0)==75){pZa(p,253992,b,q,q+4|0,q+80|0,m)|0;i=y;return 0}return 0}function cZa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=c[e+12>>2]|0;if((g|0)==4|(g|0)==5){h=e+4|0;c[63536]=(c[h>>2]|0)+1+(c[e>>2]<<1);qZa(d,254144,a,e,h,e+80|0,b,254152)|0;i=f;return 0}else if((g|0)==3){i=f;return 0}else{nZa(d,a,a,e+80|0,b,254152)|0;i=f;return 0}return 0}function dZa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0.0;d=i;i=i+8|0;e=d;do{if(!(a[254160]&1)){a[254160]=1;eZa(254208,254176,254256,254192,254240,254264,254248,254272)|0;h[31775]=+(c[63552]|0);f=c[63544]|0;h[31771]=+(f|0);if((c[63564]|0)==0){h[31773]=0.0;c[e>>2]=1-f;g=+Bdb(254200,e)}else{h[31773]=1.0;c[e>>2]=1-f;g=+Bdb(254200,e)*.5}h[31774]=g;h[31778]=g*+h[31775];h[31777]=+(c[63560]|0);h[31779]=+(c[63562]|0);j=+h[31783];h[31786]=j;k=1.0/+h[31784];if(!(k>=j)){break}h[31786]=k*(g+1.0)}}while(0);if((wZa(b,254296,1,1)|0)!=0){g=+h[31774];h[31785]=g;l=g;i=d;return+l}if((wZa(b,254304,1,1)|0)!=0){g=+h[31786];h[31785]=g;l=g;i=d;return+l}if((wZa(b,254312,1,1)|0)!=0){g=+h[31775];h[31785]=g;l=g;i=d;return+l}if((wZa(b,254320,1,1)|0)!=0){g=+h[31778];h[31785]=g;l=g;i=d;return+l}if((wZa(b,254328,1,1)|0)!=0){g=+h[31771];h[31785]=g;l=g;i=d;return+l}if((wZa(b,254336,1,1)|0)!=0){g=+h[31773];h[31785]=g;l=g;i=d;return+l}if((wZa(b,254344,1,1)|0)!=0){g=+h[31777];h[31785]=g;l=g;i=d;return+l}if((wZa(b,254352,1,1)|0)!=0){g=+h[31783];h[31785]=g;l=g;i=d;return+l}if((wZa(b,254360,1,1)|0)!=0){g=+h[31779];h[31785]=g;l=g;i=d;return+l}if((wZa(b,254368,1,1)|0)==0){l=+h[31785];i=d;return+l}else{g=+h[31784];h[31785]=g;l=g;i=d;return+l}return 0.0}function eZa(b,d,e,f,g,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;m=i;i=i+24|0;n=m;o=m+8|0;p=m+16|0;if(a[254480]&1){q=254848;r=c[63712]|0;c[b>>2]=r;s=254784;t=c[63696]|0;c[d>>2]=t;u=254824;v=c[63706]|0;c[e>>2]=v;w=254832;x=+h[31854];h[f>>3]=x;y=254864;z=c[63716]|0;c[g>>2]=z;A=254912;B=+h[31864];h[j>>3]=B;C=254872;D=c[63718]|0;c[k>>2]=D;E=254920;F=+h[31865];h[l>>3]=F;i=m;return 0}a[254480]=1;h[31855]=0.0;h[31849]=1.0;h[31850]=2.0;fZa(254848,254784,254824,254936)|0;h[31845]=+(c[63712]|0);c[n>>2]=0-(c[63696]|0);G=+Bdb(254760,n);h[31844]=G;h[31854]=G;H=+h[31850];h[31845]=H/3.0;I=+h[31849];J=I*.5;h[31852]=J;K=-J;h[o>>3]=K;h[31866]=+gZa(254760,o);L=254928;h[31863]=+gZa(L,L);h[o>>3]=K;h[31845]=+gZa(254904,o);K=+gZa(254760,254928);h[31845]=K;if(!(K>=0.0)){M=-K}else{M=K}K=M<G?G:M;h[31845]=K;h[31854]=1.0;M=+h[31855];if(K<1.0&K>M){N=K;while(1){h[31854]=N;h[o>>3]=N*J;K=H*H;h[p>>3]=N*N*H*K*K;K=+gZa(o,p);h[31846]=K;h[o>>3]=-K;h[31846]=+gZa(254816,o);K=+gZa(254816,254768);h[31845]=K;h[o>>3]=-K;h[31846]=+gZa(254816,o);K=+gZa(254816,254768);h[31845]=K;if(N>K&K>M){N=K}else{O=N;break}}}else{O=1.0}if(G<O){h[31854]=G}G=I/+(c[63712]|0);h[31857]=G;h[31861]=I;c[63694]=1;p=1;O=I;do{h[o>>3]=O*G;O=+gZa(o,254840);h[31861]=O;p=p+1|0;c[63694]=p;}while((p|0)<4);h[31844]=+gZa(254792,254888);hZa(254952,254792,254848)|0;h[o>>3]=-+h[31849];hZa(254944,o,254848)|0;hZa(254896,254752,254848)|0;h[o>>3]=-+h[31844];hZa(254880,o,254848)|0;c[63702]=0;p=c[63738]|0;L=c[63736]|0;P=c[63724]|0;Q=(p|0)==(P|0);do{if((p|0)==(L|0)&(P|0)==(c[63720]|0)){if(Q){c[63716]=p;R=0;S=25;break}if((P-p|0)==3){c[63716]=p+ -1+(c[63696]|0);c[63702]=1;R=1;S=25;break}else{c[63716]=(p|0)<=(P|0)?p:P;a[254488]=1;S=26;break}}else{T=Q&(L|0)==(c[63720]|0);U=p-L|0;c[n>>2]=U;V=(((U|0)>-1?U:0-U|0)|0)==1;if(T){if(V){c[63716]=(p|0)>=(L|0)?p:L;R=0;S=25;break}else{c[63716]=(p|0)<=(L|0)?p:L;a[254488]=1;S=26;break}}T=c[63720]|0;U=(p|0)<=(L|0)?p:L;if(!(V&(P|0)==(T|0))){V=(U|0)<=(P|0)?U:P;c[n>>2]=V;c[63716]=(V|0)<=(T|0)?V:T;a[254488]=1;S=26;break}if((P-U|0)==3){c[63716]=((p|0)>=(L|0)?p:L)+ -1+(c[63696]|0);R=0;S=25;break}else{c[63716]=U;a[254488]=1;S=26;break}}}while(0);if((S|0)==25){if(a[254488]&1){S=26}else{W=R}}if((S|0)==26){a[254480]=0;zeb(254960)|0;Qdb(254984,254864,4)|0;heb()|0;W=c[63702]|0}if((W|0)==0){X=(c[63734]|0)!=0|0}else{X=1}c[63702]=X;h[31864]=1.0;X=c[63716]|0;W=1-X|0;c[n>>2]=W;c[63694]=1;if((X|0)<=0){O=+h[31857];X=1;G=1.0;while(1){h[o>>3]=G*O;I=+gZa(o,254840);h[31864]=I;n=X+1|0;c[63694]=n;if((X|0)<(W|0)){G=I;X=n}else{break}}}iZa(254848,254784,254864,254808,254872,254920)|0;q=254848;r=c[63712]|0;c[b>>2]=r;s=254784;t=c[63696]|0;c[d>>2]=t;u=254824;v=c[63706]|0;c[e>>2]=v;w=254832;x=+h[31854];h[f>>3]=x;y=254864;z=c[63716]|0;c[g>>2]=z;A=254912;B=+h[31864];h[j>>3]=B;C=254872;D=c[63718]|0;c[k>>2]=D;E=254920;F=+h[31865];h[l>>3]=F;i=m;return 0}function fZa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0;g=i;i=i+16|0;j=g;k=g+8|0;if(a[254376]&1){l=a[254448]&1;m=c[63614]|0;c[b>>2]=m;n=254424;o=c[63606]|0;c[d>>2]=o;p=l&1;c[e>>2]=p;q=254472;r=c[63618]|0;c[f>>2]=r;i=g;return 0}a[254376]=1;h[31804]=1.0;h[31798]=1.0;h[31800]=1.0;s=1.0;do{s=s*2.0;h[31798]=s;h[31800]=+gZa(254384,254432);h[j>>3]=-s;t=+gZa(254400,j);h[31800]=t;}while(t==1.0);h[31799]=1.0;t=+gZa(254384,254392);h[31800]=t;if(t==s){u=1.0;while(1){v=u*2.0;h[31799]=v;w=+gZa(254384,254392);h[31800]=w;if(w==s){u=v}else{x=w;break}}}else{x=t}h[31805]=.25;h[31808]=x;h[j>>3]=-s;t=+gZa(254400,j);h[31800]=t;y=~~(t+.25);c[63614]=y;t=+(y|0);h[31799]=t;u=t*.5;h[j>>3]=u;h[k>>3]=-t/100.0;h[31801]=+gZa(j,k);w=+gZa(254408,254384);h[31800]=w;z=w==s;a[254448]=z&1;h[j>>3]=u;h[k>>3]=t/100.0;h[31801]=+gZa(j,k);w=+gZa(254408,254384);h[31800]=w;if(z&w==s){a[254448]=0;A=0}else{A=z}h[j>>3]=u;w=+gZa(j,254384);h[31802]=w;h[j>>3]=u;z=w==s&+gZa(j,254464)>x;c[63618]=z?A&1:0;c[63606]=0;h[31798]=1.0;h[31800]=1.0;x=1.0;z=0;while(1){k=z+1|0;c[63606]=k;s=x*t;h[31798]=s;h[31800]=+gZa(254384,254432);h[j>>3]=-s;w=+gZa(254400,j);h[31800]=w;if(w==1.0){z=k;x=s}else{l=A;m=y;break}}c[b>>2]=m;n=254424;o=c[63606]|0;c[d>>2]=o;p=l&1;c[e>>2]=p;q=254472;r=c[63618]|0;c[f>>2]=r;i=g;return 0}function gZa(a,b){a=a|0;b=b|0;i=i;return+(+h[a>>3]+ +h[b>>3])}function hZa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0,v=0.0;e=i;i=i+8|0;f=e;g=+h[b>>3];h[31874]=g;j=1.0/+(c[d>>2]|0);h[31883]=j;h[31882]=0.0;c[a>>2]=1;h[f>>3]=g*j;k=+gZa(f,255056);h[31876]=k;h[31878]=g;h[31879]=g;h[31880]=g;h[31881]=g;if(g==g&0.0==0.0){l=0;m=k}else{i=e;return 0}while(1){c[a>>2]=l;h[31874]=m;b=c[d>>2]|0;k=+(b|0);h[f>>3]=m/k;g=+gZa(f,255056);h[31876]=g;h[f>>3]=g*k;k=+gZa(f,255056);h[31878]=k;h[31880]=0.0;c[63750]=1;if((b|0)<1){n=0.0}else{o=1;p=0.0;while(1){q=g+p;if((o|0)<(b|0)){p=q;o=o+1|0}else{break}}h[31880]=q;c[63750]=b+1;n=q}h[f>>3]=m*j;p=+gZa(f,255056);h[31877]=p;h[f>>3]=p/j;r=+gZa(f,255056);h[31879]=r;h[31881]=0.0;o=c[d>>2]|0;c[63750]=1;if((o|0)<1){s=0.0}else{t=1;u=0.0;while(1){v=p+u;if((t|0)<(o|0)){u=v;t=t+1|0}else{break}}h[31881]=v;c[63750]=o+1;s=v}if(!(k==m&r==m&n==m&s==m)){break}l=(c[a>>2]|0)+ -1|0;m=g}i=e;return 0}function iZa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0.0;j=i;i=i+8|0;k=j;c[63774]=1;c[63782]=1;l=0-(c[d>>2]|0)|0;if((l|0)<2){m=2;n=l;o=2;p=1}else{l=1;q=2;while(1){c[63774]=q;r=l+1|0;c[63782]=r;s=q<<1;t=0-(c[d>>2]|0)|0;if((s|0)>(t|0)){break}else{q=s;l=r}}m=s;n=t;o=l+2|0;p=q}if((p|0)==(n|0)){c[63778]=n;u=n}else{c[63778]=m;c[63782]=o;u=m}m=c[d>>2]|0;o=((m+u|0)>(0-(p+m)|0)?p:u)<<1;c[63784]=o;u=o+(c[d>>2]|0)|0;d=u+ -1|0;c[f>>2]=d;do{if((((c[63782]|0)+1+(c[b>>2]|0)|0)%2|0|0)==1){if((c[a>>2]|0)!=2){v=d;break}o=u+ -2|0;c[f>>2]=o;v=o}else{v=d}}while(0);if((c[e>>2]|0)!=0){c[f>>2]=v+ -1}w=+(c[a>>2]|0);x=1.0/w;h[31890]=x;y=w+-1.0;h[31886]=y;h[31885]=0.0;v=c[b>>2]|0;c[63768]=1;do{if((v|0)<1){z=0.0}else{b=1;w=0.0;A=y;while(1){B=x*A;h[31886]=B;if(w<1.0){h[31888]=w}C=+gZa(255080,255088);h[31885]=C;e=b+1|0;c[63768]=e;if((b|0)<(v|0)){b=e;w=C;A=B}else{break}}if(!(C>=1.0)){z=C;break}A=+h[31888];h[31885]=A;z=A}}while(0);v=c[f>>2]|0;c[63768]=1;if((v|0)<1){D=z;h[g>>3]=D;i=j;return 0}else{E=1;F=z}while(1){h[k>>3]=F*+(c[a>>2]|0);z=+gZa(k,255144);h[31885]=z;f=E+1|0;c[63768]=f;if((E|0)<(v|0)){F=z;E=f}else{D=z;break}}h[g>>3]=D;i=j;return 0}function jZa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=i;i=i+16|0;j=g;k=g+8|0;l=c[b>>2]|0;b=~l;c[f>>2]=0;m=c[d>>2]|0;n=m+ -1|0;if((m|0)<2){o=m}else{c[63790]=1;m=1;do{c[63796]=m+1;c[j>>2]=(c[d>>2]|0)+1-m;p=kZa(j,a+(m+b+(fa(m,l)|0)<<3)|0,255192)|0;q=c[63790]|0;r=p+ -1+q|0;c[63792]=r;c[e+(q+ -1<<2)>>2]=r;r=c[63792]|0;q=c[63790]|0;p=fa(q,l)|0;s=+h[a+(r+b+p<<3)>>3];do{if(s==0.0){c[f>>2]=q}else{if((r|0)==(q|0)){t=r}else{h[31897]=s;u=a+(q+b+p<<3)|0;h[a+(p+b+r<<3)>>3]=+h[u>>3];h[u>>3]=+h[31897];t=q}u=fa(t,l)|0;h[31897]=-1.0/+h[a+(t+b+u<<3)>>3];c[j>>2]=(c[d>>2]|0)-t;lZa(j,255176,a+(t-l+u<<3)|0,255192)|0;u=c[d>>2]|0;c[j>>2]=u;v=c[63796]|0;c[63788]=v;if((v|0)>(u|0)){break}else{w=v}do{v=c[63792]|0;x=fa(w,l)|0;h[31897]=+h[a+(x+b+v<<3)>>3];y=c[63790]|0;if((v|0)==(y|0)){z=v}else{A=a+(y+b+x<<3)|0;h[a+(v+b+x<<3)>>3]=+h[A>>3];h[A>>3]=+h[31897];z=y}c[k>>2]=(c[d>>2]|0)-z;y=z+1|0;A=255192;mZa(k,255176,a+((fa(z,l)|0)+b+y<<3)|0,A,a+(y+b+x<<3)|0,A)|0;A=c[63788]|0;w=A+1|0;c[63788]=w;}while((A|0)<(u|0))}}while(0);q=c[63790]|0;m=q+1|0;c[63790]=m;}while((q|0)<(n|0));o=c[d>>2]|0}c[e+(o+ -1<<2)>>2]=o;o=c[d>>2]|0;if(!(+h[a+(o+b+(fa(o,l)|0)<<3)>>3]==0.0)){i=g;return 0}c[f>>2]=o;i=g;return 0}function kZa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0;e=i;f=c[a>>2]|0;if((f|0)<1){g=0;i=e;return g|0}if((f|0)==1){g=1;i=e;return g|0}if((c[d>>2]|0)!=1){c[63888]=1;j=+h[b>>3];if(!(j>=0.0)){k=-j}else{k=j}h[31945]=k;l=(c[d>>2]|0)+1|0;c[63888]=l;m=c[a>>2]|0;c[63886]=2;if((m|0)<2){g=1;i=e;return g|0}else{n=2;o=k;p=l;q=1}while(1){k=+h[b+(p+ -1<<3)>>3];l=!(k>=0.0);if(l){r=-k}else{r=k}if(!(r<=o)){if(l){s=-k}else{s=k}h[31945]=s;t=s;u=n}else{t=o;u=q}l=p+(c[d>>2]|0)|0;c[63888]=l;a=n+1|0;c[63886]=a;if((n|0)<(m|0)){n=a;o=t;p=l;q=u}else{g=u;break}}i=e;return g|0}t=+h[b>>3];if(!(t>=0.0)){v=-t}else{v=t}h[31945]=v;c[63886]=2;if((f|0)<2){g=1;i=e;return g|0}else{w=v;x=2;y=1}while(1){v=+h[b+(x+ -1<<3)>>3];if(!(v>=0.0)){z=-v}else{z=v}if(!(z<=w)){v=+h[b+(x+ -1<<3)>>3];if(!(v>=0.0)){A=-v}else{A=v}h[31945]=A;B=A;C=x}else{B=w;C=y}if((x|0)<(f|0)){w=B;x=x+1|0;y=C}else{break}}c[63886]=f+1;g=C;i=e;return g|0}function lZa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[a>>2]|0;if((g|0)<1){i=f;return 0}j=c[e>>2]|0;if((j|0)!=1){e=fa(j,g)|0;c[63872]=1;k=(j|0)<0;if(k?(e|0)<2:(e|0)>0){l=1}else{i=f;return 0}do{m=d+(l+ -1<<3)|0;h[m>>3]=+h[b>>3]*+h[m>>3];l=l+j|0;}while(k?(l|0)>=(e|0):(l|0)<=(e|0));c[63872]=l;i=f;return 0}l=(g|0)%5|0;c[63874]=l;do{if((l|0)==0){n=c[a>>2]|0}else{c[63872]=1;if((l|0)>=1){g=1;while(1){e=d+(g+ -1<<3)|0;h[e>>3]=+h[b>>3]*+h[e>>3];if((g|0)<(l|0)){g=g+1|0}else{break}}c[63872]=l+1}g=c[a>>2]|0;if((g|0)>=5){n=g;break}i=f;return 0}}while(0);a=l+1|0;c[63872]=a;if((l|0)<(n|0)){o=a}else{i=f;return 0}do{a=d+(o+ -1<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+1<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+2<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+3<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];o=o+5|0;}while((o|0)<=(n|0));c[63872]=o;i=f;return 0}function mZa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0.0,m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0;j=i;k=c[a>>2]|0;if((k|0)<1){i=j;return 0}l=+h[b>>3];if(l==0.0){i=j;return 0}do{if((c[e>>2]|0)==1){if((c[g>>2]|0)!=1){break}m=(k|0)%4|0;c[63858]=m;do{if((m|0)==0){n=c[a>>2]|0}else{c[63856]=1;if((m|0)>=1){o=l;p=1;q=0;while(1){r=f+(q<<3)|0;h[r>>3]=+h[r>>3]+o*+h[d+(q<<3)>>3];if((p|0)>=(m|0)){break}r=p;o=+h[b>>3];p=p+1|0;q=r}c[63856]=m+1}q=c[a>>2]|0;if((q|0)>=4){n=q;break}i=j;return 0}}while(0);q=m+1|0;c[63856]=q;if((m|0)<(n|0)){s=q}else{i=j;return 0}do{q=s+ -1|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];q=f+(s<<3)|0;h[q>>3]=+h[q>>3]+ +h[b>>3]*+h[d+(s<<3)>>3];q=s+1|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];q=s+2|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];s=s+4|0;}while((s|0)<=(n|0));c[63856]=s;i=j;return 0}}while(0);c[63860]=1;c[63862]=1;s=c[e>>2]|0;if((s|0)<0){n=(fa(1-(c[a>>2]|0)|0,s)|0)+1|0;c[63860]=n;t=n}else{t=1}n=c[g>>2]|0;if((n|0)<0){s=(fa(1-(c[a>>2]|0)|0,n)|0)+1|0;c[63862]=s;u=s}else{u=1}s=c[a>>2]|0;c[63856]=1;if((s|0)<1){i=j;return 0}else{v=l;w=1;x=u;y=t}while(1){t=f+(x+ -1<<3)|0;h[t>>3]=v*+h[d+(y+ -1<<3)>>3]+ +h[t>>3];t=y+(c[e>>2]|0)|0;c[63860]=t;u=x+(c[g>>2]|0)|0;c[63862]=u;a=w+1|0;c[63856]=a;if((w|0)>=(s|0)){break}v=+h[b>>3];y=t;x=u;w=a}i=j;return 0}function nZa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0;j=i;i=i+8|0;k=j;l=c[b>>2]|0;b=~l;m=c[d>>2]|0;n=m+ -1|0;c[63808]=n;if((c[g>>2]|0)==0){if((m|0)>=2){c[63800]=1;m=1;do{g=m+ -1|0;o=c[e+(g<<2)>>2]|0;c[63802]=o;p=f+(o+ -1<<3)|0;h[31902]=+h[p>>3];if((o|0)!=(m|0)){o=f+(g<<3)|0;h[p>>3]=+h[o>>3];h[o>>3]=+h[31902]}c[k>>2]=(c[d>>2]|0)-m;o=255192;mZa(k,255216,a+(m-l+(fa(m,l)|0)<<3)|0,o,f+(m<<3)|0,o)|0;o=c[63800]|0;m=o+1|0;c[63800]=m;}while((o|0)<(n|0))}m=c[d>>2]|0;c[63806]=1;if((m|0)<1){i=j;return 0}else{q=1}do{o=1-q+(c[d>>2]|0)|0;c[63800]=o;p=fa(o,l)|0;g=o+ -1|0;r=f+(g<<3)|0;s=+h[r>>3]/+h[a+(o+b+p<<3)>>3];h[r>>3]=s;h[31902]=-s;c[k>>2]=g;g=255192;mZa(k,255216,a+(p-l<<3)|0,g,f,g)|0;g=c[63806]|0;q=g+1|0;c[63806]=q;}while((g|0)<(m|0));i=j;return 0}m=c[d>>2]|0;c[63800]=1;if((m|0)<1){t=n}else{n=1;do{c[k>>2]=n+ -1;q=255192;s=+oZa(k,a+((fa(n,l)|0)-l<<3)|0,q,f,q);h[31902]=s;q=c[63800]|0;g=f+(q+ -1<<3)|0;h[g>>3]=(+h[g>>3]-s)/+h[a+(q+b+(fa(q,l)|0)<<3)>>3];n=q+1|0;c[63800]=n;}while((q|0)<(m|0));t=c[63808]|0}if((t|0)<1){i=j;return 0}c[63806]=1;m=1;do{n=(c[d>>2]|0)-m|0;c[63800]=n;c[k>>2]=(c[d>>2]|0)-n;b=255192;s=+oZa(k,a+(n-l+(fa(n,l)|0)<<3)|0,b,f+(n<<3)|0,b);b=c[63800]|0;n=b+ -1|0;q=f+(n<<3)|0;h[q>>3]=s+ +h[q>>3];g=c[e+(n<<2)>>2]|0;c[63802]=g;if((g|0)!=(b|0)){b=f+(g+ -1<<3)|0;h[31902]=+h[b>>3];h[b>>3]=+h[q>>3];h[q>>3]=+h[31902]}q=c[63806]|0;m=q+1|0;c[63806]=m;}while((q|0)<(t|0));i=j;return 0}function oZa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0;g=i;h[31942]=0.0;j=c[a>>2]|0;if((j|0)<1){k=0.0;i=g;return+k}do{if((c[d>>2]|0)==1){if((c[f>>2]|0)!=1){break}l=(j|0)%5|0;c[63878]=l;do{if((l|0)==0){m=c[a>>2]|0;n=0.0}else{c[63876]=1;if((l|0)<1){o=0.0}else{p=0.0;q=1;while(1){r=q+ -1|0;s=p+ +h[b+(r<<3)>>3]*+h[e+(r<<3)>>3];h[31942]=s;if((q|0)<(l|0)){q=q+1|0;p=s}else{break}}c[63876]=l+1;o=s}q=c[a>>2]|0;if((q|0)<5){k=o}else{m=q;n=o;break}i=g;return+k}}while(0);q=l+1|0;c[63876]=q;if((l|0)<(m|0)){t=n;u=q}else{k=n;i=g;return+k}do{q=u+ -1|0;r=u+1|0;v=u+2|0;w=u+3|0;t=t+ +h[b+(q<<3)>>3]*+h[e+(q<<3)>>3]+ +h[b+(u<<3)>>3]*+h[e+(u<<3)>>3]+ +h[b+(r<<3)>>3]*+h[e+(r<<3)>>3]+ +h[b+(v<<3)>>3]*+h[e+(v<<3)>>3]+ +h[b+(w<<3)>>3]*+h[e+(w<<3)>>3];h[31942]=t;u=u+5|0;}while((u|0)<=(m|0));c[63876]=u;k=t;i=g;return+k}}while(0);c[63880]=1;c[63882]=1;u=c[d>>2]|0;if((u|0)<0){m=(fa(1-(c[a>>2]|0)|0,u)|0)+1|0;c[63880]=m;x=m}else{x=1}m=c[f>>2]|0;if((m|0)<0){u=(fa(1-(c[a>>2]|0)|0,m)|0)+1|0;c[63882]=u;y=u}else{y=1}u=c[a>>2]|0;c[63876]=1;if((u|0)<1){k=0.0;i=g;return+k}else{z=1;A=0.0;B=y;C=x}while(1){t=A+ +h[b+(C+ -1<<3)>>3]*+h[e+(B+ -1<<3)>>3];h[31942]=t;x=C+(c[d>>2]|0)|0;c[63880]=x;y=B+(c[f>>2]|0)|0;c[63882]=y;a=z+1|0;c[63876]=a;if((z|0)<(u|0)){C=x;B=y;A=t;z=a}else{k=t;break}}i=g;return+k}



function P$a(b,d,e){b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+16|0;A=i;i=i+48|0;B=i;i=i+8|0;c[z>>2]=d;C=z+4|0;h[k>>3]=e;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];kXa(9,0,279728,z);z=WXa(d,A)|0;if((z|0)!=0){C=c[b+536>>2]|0;c[y>>2]=d;c[y+4>>2]=z;oXa(C,279768,y)}kXa(9,0,279808,x);x=b+116|0;if((c[x>>2]|0)>0){y=b+8|0;C=0;do{z=XXa(A,c[(c[y>>2]|0)+(C*112|0)+4>>2]|0)|0;d=c[y>>2]|0;do{if((z|0)==0){D=U$a(c[d+(C*112|0)+4>>2]|0)|0;E=XXa(A,D)|0;Xpb(D);D=c[y>>2]|0;if((E|0)!=0){F=D;G=E;H=7;break}E=c[D+(C*112|0)+4>>2]|0;if((vqb(E,279848,6)|0)==0){if((c[240116>>2]|0)==0){break}}else{D=vqb(E,279856,6)|0;if((c[240116>>2]|D|0)==0){break}}c[v>>2]=E;mXa(9,0,279864,v)}else{F=d;G=z;H=7}}while(0);if((H|0)==7){H=0;bYa(F+(C*112|0)+96|0,A,G,e)|0;z=c[y>>2]|0;I=+h[z+(C*112|0)+96>>3];c[w>>2]=c[z+(C*112|0)+4>>2];z=w+4|0;h[k>>3]=I;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];kXa(9,0,279832,w)}C=C+1|0;}while((C|0)<(c[x>>2]|0))}kXa(9,0,279920,u);u=b+136|0;if((c[u>>2]|0)>0){C=b+24|0;w=0;do{y=XXa(A,c[(c[C>>2]|0)+(w*112|0)+4>>2]|0)|0;G=c[C>>2]|0;do{if((y|0)==0){F=U$a(c[G+(w*112|0)+4>>2]|0)|0;v=XXa(A,F)|0;Xpb(F);F=c[C>>2]|0;if((v|0)!=0){J=F;K=v;H=17;break}c[s>>2]=c[F+(w*112|0)+4>>2];mXa(9,0,279944,s)}else{J=G;K=y;H=17}}while(0);if((H|0)==17){H=0;bYa(J+(w*112|0)+96|0,A,K,e)|0;y=c[C>>2]|0;I=+h[y+(w*112|0)+96>>3];c[t>>2]=c[y+(w*112|0)+4>>2];y=t+4|0;h[k>>3]=I;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];kXa(9,0,279832,t)}w=w+1|0;}while((w|0)<(c[u>>2]|0))}kXa(9,0,28e4,r);r=b+120|0;u=c[r>>2]|0;w=(c[x>>2]|0)-u|0;if((w|0)<(u|0)){u=b+24|0;x=w;do{w=XXa(A,c[(c[u>>2]|0)+(x*112|0)+4>>2]|0)|0;t=c[u>>2]|0;do{if((w|0)==0){C=U$a(c[t+(x*112|0)+4>>2]|0)|0;K=XXa(A,C)|0;Xpb(C);C=c[u>>2]|0;if((K|0)!=0){L=C;M=K;H=24;break}c[p>>2]=c[C+(x*112|0)+4>>2];mXa(9,0,279944,p)}else{L=t;M=w;H=24}}while(0);if((H|0)==24){H=0;bYa(L+(x*112|0)+96|0,A,M,e)|0;w=c[u>>2]|0;I=+h[w+(x*112|0)+96>>3];c[q>>2]=c[w+(x*112|0)+4>>2];w=q+4|0;h[k>>3]=I;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];kXa(9,0,279832,q)}x=x+1|0;}while((x|0)<(c[r>>2]|0))}kXa(9,0,280024,o);o=b+140|0;if((c[o>>2]|0)>0){r=b+28|0;x=0;do{q=XXa(A,c[(c[r>>2]|0)+(x*60|0)+4>>2]|0)|0;do{if((q|0)==0){u=U$a(c[(c[r>>2]|0)+(x*60|0)+4>>2]|0)|0;M=XXa(A,u)|0;Xpb(u);if((M|0)!=0){N=M;H=31;break}c[m>>2]=c[(c[r>>2]|0)+(x*60|0)+4>>2];mXa(9,0,280072,m)}else{N=q;H=31}}while(0);if((H|0)==31){H=0;bYa(B,A,N,e)|0;q=~~+h[B>>3];M=c[r>>2]|0;c[M+(x*60|0)+52>>2]=q;c[n>>2]=c[M+(x*60|0)+4>>2];c[n+4>>2]=q;kXa(9,0,280056,n)}x=x+1|0;}while((x|0)<(c[o>>2]|0))}kXa(9,0,280128,l);l=b+144|0;if((c[l>>2]|0)<=0){UXa(A);i=f;return}o=b+32|0;b=0;do{x=XXa(A,c[(c[o>>2]|0)+(b*48|0)+4>>2]|0)|0;do{if((x|0)==0){n=U$a(c[(c[o>>2]|0)+(b*48|0)+4>>2]|0)|0;r=XXa(A,n)|0;Xpb(n);if((r|0)!=0){O=r;H=38;break}c[g>>2]=c[(c[o>>2]|0)+(b*48|0)+4>>2];mXa(9,0,280176,g)}else{O=x;H=38}}while(0);if((H|0)==38){H=0;bYa(B,A,O,e)|0;a[(c[o>>2]|0)+(b*48|0)+42|0]=~~+h[B>>3];x=c[o>>2]|0;r=(a[x+(b*48|0)+42|0]|0)!=0?278120:278128;c[j>>2]=c[x+(b*48|0)+4>>2];c[j+4>>2]=r;kXa(9,0,280160,j)}b=b+1|0;}while((b|0)<(c[l>>2]|0));UXa(A);i=f;return}function Q$a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;_Za(a,+h[a+240>>3]);n_a(a);s_a(a);i_a(a);u_a(a);B$a(a);j_a(a);n_a(a);e=S$a(a,b,c)|0;s_a(a);i_a(a);o_a(a);s_a(a);i=d;return e|0}function R$a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+4096|0;_Za(b,+h[b+240>>3]);n_a(b);s_a(b);D$a(b,0,1)|0;v=b+540|0;w=c[v>>2]|0;if((c[w+76>>2]|0)!=0&(d|0)>1){x=u;u=b+8|0;y=b+116|0;z=Ypb(c[y>>2]|0,8)|0;A=b+124|0;B=Ypb(c[A>>2]|0,4)|0;C=b+128|0;D=Ypb(c[C>>2]|0,1)|0;E=b+132|0;F=Ypb(c[E>>2]|0,4)|0;G=b+536|0;nXa(c[G>>2]|0,(z|0)!=0|0,278600,t);nXa(c[G>>2]|0,(B|0)!=0|0,278600,s);nXa(c[G>>2]|0,(D|0)!=0|0,278600,r);nXa(c[G>>2]|0,(F|0)!=0|0,278600,q);q=c[y>>2]|0;if((q|0)>0){G=c[u>>2]|0;r=0;do{h[z+(r<<3)>>3]=+h[G+(r*112|0)+96>>3];r=r+1|0;}while((r|0)<(q|0))}q=c[A>>2]|0;if((q|0)>0){r=c[b+12>>2]|0;G=0;do{c[B+(G<<2)>>2]=c[r+(G*60|0)+52>>2];G=G+1|0;}while((G|0)<(q|0))}q=c[C>>2]|0;if((q|0)>0){G=c[b+16>>2]|0;r=0;do{a[D+r|0]=a[G+(r*48|0)+42|0]|0;r=r+1|0;}while((r|0)<(q|0))}q=c[E>>2]|0;if((q|0)>0){r=c[b+20>>2]|0;G=0;do{c[F+(G<<2)>>2]=c[r+(G*52|0)+44>>2];G=G+1|0;}while((G|0)<(q|0))}if((c[240116>>2]|0)==0){H=0}else{c[p>>2]=c[b+88>>2];lc(x|0,278616,p|0)|0;p=mc(x|0,278632)|0;c[o>>2]=278648;Dd(p|0,278640,o|0)|0;if((c[y>>2]|0)>0){o=u;x=0;do{c[n>>2]=c[(c[o>>2]|0)+(x*112|0)+4>>2];Dd(p|0,278640,n|0)|0;x=x+1|0;}while((x|0)<(c[y>>2]|0))}Zd(10,p|0)|0;H=p}kXa(9,1,278656,m);a:do{if((d|0)>0){I=+(d+ -1|0);m=b+304|0;p=b+4|0;x=0;do{J=+(x|0)/I;h[m>>3]=J>1.0?1.0:J;pe[c[(c[v>>2]|0)+80>>2]&127](b)|0;n=l;h[k>>3]=+h[m>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];kXa(9,0,278680,l);if((c[240116>>2]|0)!=0){n=j;h[k>>3]=+h[m>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Dd(H|0,278704,j|0)|0;if((c[y>>2]|0)>0){n=0;do{o=g;h[k>>3]=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+(n<<3)>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];Dd(H|0,278704,g|0)|0;n=n+1|0;}while((n|0)<(c[y>>2]|0))}Zd(10,H|0)|0}if((a$a(b,0)|0)!=0){break a}if((S_a(b,0)|0)!=0){break a}if((H_a(b,0)|0)!=0){break a}v_a(b);x=x+1|0;}while((x|0)<(d|0))}}while(0);me[c[60158]&2047](9);if((c[240116>>2]|0)!=0){ad(H|0)|0}H=c[y>>2]|0;if((H|0)>0){y=c[u>>2]|0;u=0;do{h[y+(u*112|0)+96>>3]=+h[z+(u<<3)>>3];u=u+1|0;}while((u|0)<(H|0))}if((c[A>>2]|0)>0){H=c[b+12>>2]|0;u=0;do{c[H+(u*60|0)+52>>2]=c[B+(u<<2)>>2];u=u+1|0;}while((u|0)<(c[A>>2]|0))}if((c[C>>2]|0)>0){A=b+16|0;u=0;do{a[(c[A>>2]|0)+(u*48|0)+42|0]=a[D+u|0]|0;u=u+1|0;}while((u|0)<(c[C>>2]|0))}C=c[E>>2]|0;if((C|0)>0){E=b+20|0;u=0;do{c[(c[E>>2]|0)+(u*52|0)+44>>2]=c[F+(u<<2)>>2];u=u+1|0;}while((u|0)<(C|0))}Xpb(z);Xpb(B);Xpb(D);Xpb(F)}else{h[b+304>>3]=1.0;pe[c[w+80>>2]&127](b)|0}k_a(b);if((D$a(b,1,1)|0)!=1){i=e;return}pe[c[(c[v>>2]|0)+80>>2]&127](b)|0;k_a(b);if((D$a(b,1,1)|0)!=1){i=e;return}mXa(1,0,278712,f);i=e;return}function S$a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=V$a(b)|0;w=v;x=c[w>>2]|0;if((x|0)==0){kXa(9,0,278816,u);if((c[b+184>>2]|0)==0){Ee[c[(c[b+540>>2]|0)+68>>2]&63](b,c[v+48>>2]|0)|0}Xpb(v);y=0;i=f;return y|0}u=b+184|0;z=c[u>>2]|0;if((z|0)==0){kXa(9,0,278848,t);Ee[c[(c[b+540>>2]|0)+68>>2]&63](b,c[v+48>>2]|0)|0;Xpb(v);y=0;i=f;return y|0}do{if((c[v+16>>2]|0)<(x|0)){kXa(9,1,278920,s);t=Wpb(c[w>>2]<<3)|0;A=v+40|0;B=c[A>>2]|0;c[A>>2]=0;C=+L$a(v,1.0);c[A>>2]=B;D=c[w>>2]|0;if((D|0)>0){E=v+24|0;F=c[E>>2]|0;G=0;while(1){H=F+(G<<3)|0;h[H>>3]=+h[H>>3]+1.0e-6;c[A>>2]=0;h[t+(G<<3)>>3]=+U(+(+L$a(v,1.0)-C))/1.0e-6;c[A>>2]=B;H=c[E>>2]|0;I=H+(G<<3)|0;h[I>>3]=+h[I>>3]+-1.0e-6;I=G+1|0;J=c[w>>2]|0;if((I|0)<(J|0)){G=I;F=H}else{K=J;break}}}else{K=D}F=c[u>>2]|0;if((F|0)>0){G=(K|0)>1;E=0;do{if(G){B=1;A=0;while(1){J=+h[t+(B<<3)>>3]>+h[t+(A<<3)>>3]?B:A;H=B+1|0;if((H|0)<(K|0)){A=J;B=H}else{L=J;break}}}else{L=0}h[t+(L<<3)>>3]=-1.0;E=E+1|0;}while((E|0)<(F|0))}kXa(9,1,278944,r);F=b+112|0;E=c[F>>2]|0;if((E|0)>0){G=b+8|0;D=v+44|0;B=v+24|0;A=E;E=0;J=0;while(1){H=(c[G>>2]|0)+(E*112|0)+72|0;if((a[H]|0)==0){if(!(+h[t+(J<<3)>>3]>=0.0)){M=A}else{a[H]=1;C=+h[(c[B>>2]|0)+(J<<3)>>3];c[q>>2]=c[(c[D>>2]|0)+(J<<2)>>2];H=q+4|0;h[k>>3]=C;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];kXa(9,0,278968,q);M=c[F>>2]|0}N=M;O=J+1|0}else{N=A;O=J}H=E+1|0;if((H|0)<(N|0)){A=N;E=H;J=O}else{P=O;break}}}else{P=0}J=b+136|0;if((c[J>>2]|0)>0){E=b+24|0;A=v+44|0;F=v+24|0;D=b+116|0;B=b+120|0;G=0;H=P;while(1){I=(c[E>>2]|0)+(G*112|0)+72|0;if((a[I]|0)==0){if(+h[t+(H<<3)>>3]>=0.0){a[I]=1;C=+h[(c[F>>2]|0)+(H<<3)>>3];c[p>>2]=c[(c[A>>2]|0)+(H<<2)>>2];I=p+4|0;h[k>>3]=C;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];kXa(9,0,278968,p)}Q=H+1|0}else{Q=H}I=c[B>>2]|0;R=(c[D>>2]|0)-I|0;if((R|0)<(I|0)){S=I;I=R;T=Q;while(1){V=(c[E>>2]|0)+(I*112|0)+72|0;if((a[V]|0)==0){if(!(+h[t+(T<<3)>>3]>=0.0)){W=S}else{a[V]=1;C=+h[(c[F>>2]|0)+(T<<3)>>3];c[o>>2]=c[(c[A>>2]|0)+(T<<2)>>2];V=o+4|0;h[k>>3]=C;c[V>>2]=c[k>>2];c[V+4>>2]=c[k+4>>2];kXa(9,0,278968,o);W=c[B>>2]|0}X=W;Y=T+1|0}else{X=S;Y=T}V=I+1|0;if((V|0)<(X|0)){S=X;I=V;T=Y}else{Z=V;_=Y;break}}}else{Z=R;_=Q}T=Z+1|0;if((T|0)<(c[J>>2]|0)){G=T;H=_}else{break}}}if((c[240116>>2]|0)!=0){me[c[60158]&2047](9);me[c[60158]&2047](9)}Xpb(t);W$a(v);H=V$a(b)|0;if((c[H>>2]|0)!=0){$=H;break}kXa(9,0,278992,n);Xpb(H);y=0;i=f;return y|0}else{if((z|0)<=(x|0)){$=v;break}kXa(9,0,279024,m);$=v}}while(0);do{if((d|0)==3|(d|0)==5){kXa(9,0,279040,l);T$a($,d,1,e);M$a(b,$);v=c[$>>2]|0;if((v|0)<=0){break}m=c[$+24>>2]|0;x=c[$+28>>2]|0;z=0;do{h[x+(z<<3)>>3]=+h[m+(z<<3)>>3];z=z+1|0;}while((z|0)<(v|0))}}while(0);if(+L$a($,1.0)>1.0e-9){l=$+40|0;v=c[l>>2]|0;if((v|0)!=0){Xpb(v);c[l>>2]=0}l=$+52|0;v=c[l>>2]|0;if((v|0)!=0){Xpb(v);c[l>>2]=0}l=$+56|0;v=c[l>>2]|0;if((v|0)!=0){Xpb(v);c[l>>2]=0}T$a($,d,0,e);M$a(b,$);+L$a($,1.0)}else{kXa(9,0,279064,j)}kXa(9,1,279088,g);M$a(b,$);b=K$a($)|0;if((c[240116>>2]|0)!=0){me[c[60158]&2047](9)}W$a($);y=b;i=f;return y|0}function T$a(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=c[a+60>>2]|0;h[n>>3]=0.0;p=a;q=Wpb(c[p>>2]<<3)|0;r=q;s=+L$a(a,1.0);t=c[p>>2]|0;if((t|0)>0){u=c[a+28>>2]|0;v=c[a+24>>2]|0;w=0;do{x=+h[u+(w<<3)>>3];h[v+(w<<3)>>3]=x;h[q+(w<<3)>>3]=x;w=w+1|0;}while((w|0)<(t|0))}if(!(s>1.0e-12)){y=1;Y$a(a,r);Xpb(q);z=y+ -1|0;A=g;B=A;c[B>>2]=z;C=15;D=C;E=279216;F=E;kXa(9,0,F,g);i=f;return}t=(d|0)==0;d=a+24|0;x=s;w=1;a:while(1){c[m>>2]=w;kXa(9,0,279128,m);if(!t){X$a(a)}switch(b|0){case 3:{G=f0a(a,n,e)|0;break};case 5:{H=13;break a;break};case 2:{G=b0a(a)|0;break};case 4:{H=12;break a;break};case 6:{H=14;break a;break};case 1:{G=d0a(a)|0;break};default:{H=15;break a}}s_a(o);i_a(o);o_a(o);s_a(o);s=+L$a(a,1.0);v=(G|0)>-1;if(v&s<x){u=c[p>>2]|0;if((u|0)>0){I=c[d>>2]|0;J=0;do{h[q+(J<<3)>>3]=+h[I+(J<<3)>>3];J=J+1|0;}while((J|0)<(u|0))}kXa(9,0,279176,k);M$a(o,a);K=s}else{kXa(9,0,279192,j);if(v&s==x){y=w;H=23;break}else{K=x}}u=w+1|0;if((u|0)<201&s>1.0e-12){x=K;w=u}else{y=u;H=23;break}}if((H|0)==12){a0a(a)|0}else if((H|0)==13){a0a(a)|0}else if((H|0)==14){$$a(o,a,0)|0}else if((H|0)==15){oXa(c[o+536>>2]|0,279152,l)}else if((H|0)==23){Y$a(a,r);Xpb(q);z=y+ -1|0;A=g;B=A;c[B>>2]=z;C=15;D=C;E=279216;F=E;kXa(9,0,F,g);i=f;return}}function U$a(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=i;d=yqb(b|0)|0;do{if((d|0)==0){e=Wpb(1)|0;f=0}else{g=0;h=0;j=d;while(1){k=a[b+g|0]|0;if(k<<24>>24==91){l=h+1|0}else if(k<<24>>24==93){l=h+ -1|0}else{l=h}if((l|0)!=0&k<<24>>24==44){m=((a[b+(g+1)|0]|0)!=32)+j|0}else{m=j}k=g+1|0;if(k>>>0<d>>>0){g=k;h=l;j=m}else{break}}j=Wpb(m+1|0)|0;if((m|0)==0){e=j;f=0;break}else{n=0;o=0;p=l}while(1){h=a[b+o|0]|0;if(h<<24>>24==91){q=p+1|0}else if(h<<24>>24==93){q=p+ -1|0}else{q=p}a[j+n|0]=h;do{if((q|0)!=0&h<<24>>24==44){if((a[b+(o+1)|0]|0)==32){r=n;break}g=n+1|0;a[j+g|0]=32;r=g}else{r=n}}while(0);h=r+1|0;if(h>>>0<m>>>0){n=h;o=o+1|0;p=q}else{e=j;f=m;break}}}}while(0);a[e+f|0]=0;if((tqb(e,280232,4)|0)!=0){i=c;return e|0}m=f>>>0>3;q=e+4|0;while(1){a:do{if(m){p=f;while(1){o=p+ -1|0;if((a[e+p|0]|0)==46){s=p;break a}if(o>>>0>3){p=o}else{s=o;break}}}else{s=f}}while(0);if((s|0)==3){t=24;break}p=s+ -3|0;Aqb(e|0,q|0,p|0)|0;o=e+p|0;a[o]=678585700;a[o+1|0]=2650725;a[o+2|0]=10354;a[o+3|0]=40;if((tqb(e,280232,4)|0)!=0){t=24;break}}if((t|0)==24){i=c;return e|0}return 0}function V$a(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+32|0;n=i;i=i+32|0;o=i;i=i+32|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=Wpb(64)|0;z=y;nXa(0,(y|0)!=0|0,280240,x);x=y+4|0;A=y+8|0;B=y+12|0;C=y+16|0;D=y+20|0;E=y+24|0;F=y+28|0;G=y+32|0;H=y+36|0;I=y+40|0;J=y+44|0;K=y+48|0;L=y+52|0;M=y+56|0;N=y+60|0;O=y+0|0;P=O+60|0;do{c[O>>2]=0;O=O+4|0}while((O|0)<(P|0));c[N>>2]=b;N=b+8|0;O=b+112|0;P=c[O>>2]|0;if((P|0)>0){Q=c[N>>2]|0;R=0;S=0;while(1){if((a[Q+(S*112|0)+72|0]|0)==0){T=R+1|0;c[x>>2]=T;V=T}else{V=R}T=S+1|0;if((T|0)<(P|0)){R=V;S=T}else{W=V;break}}}else{W=0}V=b+136|0;S=c[V>>2]|0;if((S|0)>0){R=c[b+24>>2]|0;P=0;x=0;while(1){if((a[R+(x*112|0)+72|0]|0)==0){Q=P+1|0;c[A>>2]=Q;X=Q}else{X=P}Q=x+1|0;if((Q|0)<(S|0)){P=X;x=Q}else{Y=X;break}}}else{Y=0}X=b+116|0;x=b+120|0;P=c[x>>2]|0;if((P|0)>0){S=c[X>>2]|0;A=c[N>>2]|0;R=0;Q=S-P|0;while(1){if((a[A+(Q*112|0)+72|0]|0)==0){P=R+1|0;c[B>>2]=P;Z=P}else{Z=R}P=Q+1|0;if((P|0)<(S|0)){R=Z;Q=P}else{_=Z;break}}}else{_=0}Z=Y+W+_|0;c[y>>2]=Z;if((Z|0)==0){i=d;return z|0}y=Ypb(Z,8)|0;c[E>>2]=y;nXa(0,(y|0)!=0|0,280240,w);w=Ypb(Z,8)|0;c[F>>2]=w;nXa(0,(w|0)!=0|0,280240,v);v=Ypb(Z,8)|0;c[G>>2]=v;nXa(0,(v|0)!=0|0,280240,u);u=Ypb(Z,8)|0;c[H>>2]=u;nXa(0,(u|0)!=0|0,280240,t);t=Ypb(Z,8)|0;c[I>>2]=t;nXa(0,(t|0)!=0|0,280240,s);s=Ypb(Z,4)|0;t=s;c[J>>2]=t;nXa(0,(s|0)!=0|0,280240,r);kXa(9,0,280256,q);c[p>>2]=Z;c[p+4>>2]=W;c[p+8>>2]=Y;c[p+12>>2]=_;kXa(9,0,280280,p);p=c[O>>2]|0;if((p|0)>0){_=N;Y=p;p=t;W=0;Z=0;while(1){q=c[_>>2]|0;if((a[q+(W*112|0)+72|0]|0)==0){c[p+(Z<<2)>>2]=c[q+(W*112|0)+4>>2];q=c[_>>2]|0;do{if((a[q+(W*112|0)+73|0]|0)==0){$=(c[I>>2]|0)+(Z<<3)|0;aa=1.0}else{ba=+h[q+(W*112|0)+80>>3];ca=+U(+ba);r=(c[I>>2]|0)+(Z<<3)|0;if(!(ba==0.0)){$=r;aa=ca;break}$=r;aa=1.0}}while(0);h[$>>3]=aa;r=q+(W*112|0)+96|0;s=(c[E>>2]|0)+(Z<<3)|0;h[s>>3]=+h[r>>3];u=(c[F>>2]|0)+(Z<<3)|0;h[u>>3]=+h[r>>3];h[(c[G>>2]|0)+(Z<<3)>>3]=+h[q+(W*112|0)+56>>3];h[(c[H>>2]|0)+(Z<<3)>>3]=+h[q+(W*112|0)+64>>3];r=Z+1|0;v=c[J>>2]|0;w=c[v+(Z<<2)>>2]|0;ca=+h[u>>3];ba=+h[$>>3];da=+h[s>>3];c[o>>2]=r;c[o+4>>2]=w;w=o+8|0;h[k>>3]=ca;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=o+16|0;h[k>>3]=ba;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=o+24|0;h[k>>3]=da;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];kXa(9,0,280368,o);ea=c[O>>2]|0;fa=v;ga=r}else{ea=Y;fa=p;ga=Z}r=W+1|0;if((r|0)<(ea|0)){Y=ea;p=fa;W=r;Z=ga}else{ha=fa;ia=ga;break}}}else{ha=t;ia=0}t=c[V>>2]|0;if((t|0)>0){ga=b+24|0;fa=t;t=ha;Z=0;W=ia;while(1){p=c[ga>>2]|0;if((a[p+(Z*112|0)+72|0]|0)==0){c[t+(W<<2)>>2]=c[p+(Z*112|0)+4>>2];p=c[ga>>2]|0;aa=+h[p+(Z*112|0)+80>>3];da=+U(+aa);ea=(c[I>>2]|0)+(W<<3)|0;h[ea>>3]=aa==0.0?1.0:da;Y=p+(Z*112|0)+96|0;O=(c[E>>2]|0)+(W<<3)|0;h[O>>3]=+h[Y>>3];o=(c[F>>2]|0)+(W<<3)|0;h[o>>3]=+h[Y>>3];h[(c[G>>2]|0)+(W<<3)>>3]=+h[p+(Z*112|0)+56>>3];h[(c[H>>2]|0)+(W<<3)>>3]=+h[p+(Z*112|0)+64>>3];p=W+1|0;Y=c[J>>2]|0;$=c[Y+(W<<2)>>2]|0;da=+h[o>>3];aa=+h[ea>>3];ba=+h[O>>3];c[n>>2]=p;c[n+4>>2]=$;$=n+8|0;h[k>>3]=da;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=n+16|0;h[k>>3]=aa;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=n+24|0;h[k>>3]=ba;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];kXa(9,0,280416,n);ja=c[V>>2]|0;ka=Y;la=p}else{ja=fa;ka=t;la=W}p=Z+1|0;if((p|0)<(ja|0)){fa=ja;t=ka;Z=p;W=la}else{ma=ka;na=la;break}}}else{ma=ha;na=ia}ia=c[x>>2]|0;if((ia|0)>0){ha=c[X>>2]|0;la=N;ka=ha;W=ma;ma=ha-ia|0;ia=na;while(1){na=c[la>>2]|0;if((a[na+(ma*112|0)+72|0]|0)==0){c[W+(ia<<2)>>2]=c[na+(ma*112|0)+4>>2];na=c[la>>2]|0;do{if((a[na+(ma*112|0)+73|0]|0)==0){oa=(c[I>>2]|0)+(ia<<3)|0;pa=1.0}else{ba=+h[na+(ma*112|0)+80>>3];aa=+U(+ba);ha=(c[I>>2]|0)+(ia<<3)|0;if(!(ba==0.0)){oa=ha;pa=aa;break}oa=ha;pa=1.0}}while(0);h[oa>>3]=pa;q=na+(ma*112|0)+96|0;ha=(c[E>>2]|0)+(ia<<3)|0;h[ha>>3]=+h[q>>3];Z=(c[F>>2]|0)+(ia<<3)|0;h[Z>>3]=+h[q>>3];h[(c[G>>2]|0)+(ia<<3)>>3]=+h[na+(ma*112|0)+56>>3];h[(c[H>>2]|0)+(ia<<3)>>3]=+h[na+(ma*112|0)+64>>3];q=ia+1|0;t=c[J>>2]|0;ja=c[t+(ia<<2)>>2]|0;aa=+h[Z>>3];ba=+h[oa>>3];da=+h[ha>>3];c[m>>2]=q;c[m+4>>2]=ja;ja=m+8|0;h[k>>3]=aa;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=m+16|0;h[k>>3]=ba;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=m+24|0;h[k>>3]=da;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];kXa(9,0,280472,m);qa=c[X>>2]|0;ra=t;sa=q}else{qa=ka;ra=W;sa=ia}q=ma+1|0;if((q|0)<(qa|0)){ka=qa;W=ra;ma=q;ia=sa}else{break}}}sa=c[b+184>>2]|0;c[C>>2]=sa;c[D>>2]=0;C=c[X>>2]|0;if((C|0)>0){X=c[N>>2]|0;ia=0;ma=0;while(1){if((a[X+(ma*112|0)+88|0]|0)==0){ta=ia}else{ra=ia+1|0;c[D>>2]=ra;ta=ra}ra=ma+1|0;if((ra|0)<(C|0)){ia=ta;ma=ra}else{ua=ta;break}}}else{ua=0}ta=c[V>>2]|0;if((ta|0)>0){V=c[b+24>>2]|0;ma=ua;ia=0;while(1){do{if((a[V+(ia*112|0)+88|0]|0)==0){va=ma}else{if((a[V+(ia*112|0)+72|0]|0)!=0){va=ma;break}X=ma+1|0;c[D>>2]=X;va=X}}while(0);na=ia+1|0;if((na|0)<(ta|0)){ma=va;ia=na}else{wa=va;break}}}else{wa=ua}ua=c[x>>2]|0;if((ua|0)>0){x=c[N>>2]|0;N=wa;va=C-ua|0;while(1){do{if((a[x+(va*112|0)+88|0]|0)==0){xa=N}else{if((a[x+(va*112|0)+72|0]|0)!=0){xa=N;break}ua=N+1|0;c[D>>2]=ua;xa=ua}}while(0);ua=va+1|0;if((ua|0)<(C|0)){N=xa;va=ua}else{ya=xa;break}}}else{ya=wa}wa=c[b+176>>2]|0;xa=c[b+180>>2]|0;c[l>>2]=sa;c[l+4>>2]=wa;c[l+8>>2]=xa;kXa(9,0,280528,l);c[j>>2]=ya;kXa(9,0,280600,j);j=Ypb(sa,8)|0;c[K>>2]=j;nXa(0,(j|0)!=0|0,280240,g);g=Wpb(sa<<3)|0;c[L>>2]=g;nXa(0,(g|0)!=0|0,280240,f);f=Wpb(ya<<3)|0;c[M>>2]=f;nXa(0,(f|0)!=0|0,280240,e);if((sa|0)>0){e=0;do{h[g+(e<<3)>>3]=1.0;e=e+1|0;}while((e|0)<(sa|0))}if((ya|0)>0){za=0}else{i=d;return z|0}do{h[f+(za<<3)>>3]=1.0;za=za+1|0;}while((za|0)<(ya|0));i=d;return z|0}function W$a(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+24>>2]|0;if((d|0)!=0){Xpb(d)}d=c[a+28>>2]|0;if((d|0)!=0){Xpb(d)}d=c[a+32>>2]|0;if((d|0)!=0){Xpb(d)}d=c[a+36>>2]|0;if((d|0)!=0){Xpb(d)}d=c[a+40>>2]|0;if((d|0)!=0){Xpb(d)}d=c[a+44>>2]|0;if((d|0)!=0){Xpb(d)}d=c[a+48>>2]|0;if((d|0)!=0){Xpb(d)}d=c[a+52>>2]|0;if((d|0)!=0){Xpb(d)}d=c[a+56>>2]|0;if((d|0)==0){e=a;Xpb(e);i=b;return}Xpb(d);e=a;Xpb(e);i=b;return}function X$a(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0.0,T=0,V=0,W=0;d=i;i=i+8|0;e=d;f=c[b+60>>2]|0;g=b+40|0;if((c[g>>2]|0)==0){i=d;return}j=b+52|0;k=c[j>>2]|0;if((k|0)==0){i=d;return}l=b+56|0;m=c[l>>2]|0;if((m|0)==0){i=d;return}n=b+16|0;o=c[n>>2]|0;p=Ypb(o,8)|0;q=Ypb(o,8)|0;r=b+20|0;s=c[r>>2]|0;t=Ypb(s,8)|0;u=Ypb(s,8)|0;v=Ypb(o,8)|0;w=Ypb(s,8)|0;if((o|0)>0){x=0;do{h[k+(x<<3)>>3]=1.0;x=x+1|0;}while((x|0)<(o|0))}if((s|0)>0){o=0;do{h[m+(o<<3)>>3]=1.0;o=o+1|0;}while((o|0)<(s|0))}+L$a(b,1.0);s=c[n>>2]|0;if((s|0)>0){Aqb(p|0,c[b+48>>2]|0,((s|0)>1?s<<3:8)|0)|0}o=f+8|0;m=f+116|0;x=c[m>>2]|0;if((x|0)>0){k=c[o>>2]|0;y=f+4|0;z=0;A=0;while(1){if((a[k+(z*112|0)+88|0]|0)==0){B=A}else{h[t+(A<<3)>>3]=+h[k+(z*112|0)+96>>3]- +h[(c[(c[c[y>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];B=A+1|0}C=z+1|0;if((C|0)<(x|0)){z=C;A=B}else{D=B;break}}}else{D=0}B=f+136|0;A=c[B>>2]|0;if((A|0)>0){z=c[f+24>>2]|0;y=f+4|0;k=0;C=D;while(1){do{if((a[z+(k*112|0)+88|0]|0)==0){E=C}else{if((a[z+(k*112|0)+72|0]|0)!=0){E=C;break}h[t+(C<<3)>>3]=+h[z+(k*112|0)+96>>3]- +h[(c[(c[c[y>>2]>>2]|0)+8>>2]|0)+(k<<3)>>3];E=C+1|0}}while(0);F=k+1|0;if((F|0)<(A|0)){k=F;C=E}else{G=E;break}}}else{G=D}D=f+120|0;E=c[D>>2]|0;if((E|0)>0){C=c[o>>2]|0;k=f+4|0;A=x-E|0;E=G;while(1){do{if((a[C+(A*112|0)+88|0]|0)==0){H=E}else{if((a[C+(A*112|0)+72|0]|0)!=0){H=E;break}h[t+(E<<3)>>3]=+h[C+(A*112|0)+96>>3]- +h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+(A<<3)>>3];H=E+1|0}}while(0);G=A+1|0;if((G|0)<(x|0)){A=G;E=H}else{break}}}H=b;if((c[H>>2]|0)>0){E=b+24|0;A=o;o=f+4|0;x=f+24|0;f=b+48|0;k=c[E>>2]|0;C=0;while(1){G=k+(C<<3)|0;h[G>>3]=+h[G>>3]+1.0e-6;+L$a(b,1.0);G=c[n>>2]|0;y=(G|0)>0;if(y){Aqb(q|0,c[f>>2]|0,((G|0)>1?G<<3:8)|0)|0}z=c[m>>2]|0;if((z|0)>0){F=c[A>>2]|0;I=0;J=0;while(1){if((a[F+(J*112|0)+88|0]|0)==0){K=I}else{h[u+(I<<3)>>3]=+h[F+(J*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(J<<3)>>3];K=I+1|0}L=J+1|0;if((L|0)<(z|0)){I=K;J=L}else{M=K;break}}}else{M=0}J=c[B>>2]|0;if((J|0)>0){I=c[x>>2]|0;F=M;L=0;while(1){do{if((a[I+(L*112|0)+88|0]|0)==0){N=F}else{if((a[I+(L*112|0)+72|0]|0)!=0){N=F;break}h[u+(F<<3)>>3]=+h[I+(L*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(L<<3)>>3];N=F+1|0}}while(0);O=L+1|0;if((O|0)<(J|0)){F=N;L=O}else{P=N;break}}}else{P=M}L=c[D>>2]|0;if((L|0)>0){F=c[A>>2]|0;J=P;I=z-L|0;while(1){do{if((a[F+(I*112|0)+88|0]|0)==0){Q=J}else{if((a[F+(I*112|0)+72|0]|0)!=0){Q=J;break}h[u+(J<<3)>>3]=+h[F+(I*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(I<<3)>>3];Q=J+1|0}}while(0);L=I+1|0;if((L|0)<(z|0)){J=Q;I=L}else{break}}}if(y){R=+h[(c[g>>2]|0)+(C<<3)>>3];I=0;do{S=+U(+(R*(+h[q+(I<<3)>>3]- +h[p+(I<<3)>>3])/1.0e-6));J=v+(I<<3)|0;if(S>+h[J>>3]){h[J>>3]=S}I=I+1|0;}while((I|0)<(G|0))}I=c[r>>2]|0;if((I|0)>0){R=+h[(c[g>>2]|0)+(C<<3)>>3];y=0;do{S=+U(+(R*(+h[u+(y<<3)>>3]- +h[t+(y<<3)>>3])/1.0e-6));J=w+(y<<3)|0;if(S>+h[J>>3]){h[J>>3]=S}y=y+1|0;}while((y|0)<(I|0))}I=c[E>>2]|0;y=I+(C<<3)|0;h[y>>3]=+h[y>>3]+-1.0e-6;y=C+1|0;if((y|0)<(c[H>>2]|0)){k=I;C=y}else{T=G;break}}}else{T=s}if((T|0)>0){s=T;T=0;while(1){R=+h[v+(T<<3)>>3];C=(c[j>>2]|0)+(T<<3)|0;if(R<1.0e-42){h[C>>3]=1.0;k=T+1|0;c[e>>2]=k;kXa(9,0,280640,e);V=k;W=c[n>>2]|0}else{h[C>>3]=R;V=T+1|0;W=s}if((V|0)<(W|0)){s=W;T=V}else{break}}}V=c[r>>2]|0;if((V|0)>0){r=c[l>>2]|0;l=0;do{R=+h[w+(l<<3)>>3];h[r+(l<<3)>>3]=R<1.0e-42?1.0:R;l=l+1|0;}while((l|0)<(V|0))}Xpb(p);Xpb(q);Xpb(t);Xpb(u);Xpb(v);Xpb(w);i=d;return}function Y$a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a>>2]|0;if((e|0)<=0){i=d;return}f=c[a+24>>2]|0;a=0;do{h[f+(a<<3)>>3]=+h[b+(a<<3)>>3];a=a+1|0;}while((a|0)<(e|0));i=d;return}function Z$a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0;d=i;e=c[a>>2]|0;if((e|0)<=0){i=d;return}f=c[a+40>>2]|0;g=(f|0)==0;j=c[a+24>>2]|0;a=0;do{k=+h[b+(a<<3)>>3];if(g){l=k}else{l=k*+h[f+(a<<3)>>3]}h[j+(a<<3)>>3]=l;a=a+1|0;}while((a|0)<(e|0));i=d;return}function _$a(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;e=c[b+60>>2]|0;f=c[e+112>>2]|0;if((f|0)>0){g=b+24|0;j=c[e+8>>2]|0;k=0;l=0;while(1){if((a[j+(k*112|0)+72|0]|0)==0){h[(c[(c[c[e+4>>2]>>2]|0)+8>>2]|0)+(k<<3)>>3]=+h[(c[g>>2]|0)+(l<<3)>>3];m=l+1|0}else{m=l}n=k+1|0;if((n|0)<(f|0)){k=n;l=m}else{o=m;break}}}else{o=0}m=c[e+136>>2]|0;if((m|0)>0){l=b+24|0;k=c[e+24>>2]|0;f=0;g=o;while(1){if((a[k+(f*112|0)+72|0]|0)==0){h[(c[e+416>>2]|0)+(f<<3)>>3]=+h[(c[l>>2]|0)+(g<<3)>>3];p=g+1|0}else{p=g}j=f+1|0;if((j|0)<(m|0)){f=j;g=p}else{q=p;break}}}else{q=o}o=c[e+116>>2]|0;p=c[e+120>>2]|0;if((p|0)<=0){i=d;return}g=b+24|0;b=c[e+8>>2]|0;f=o-p|0;p=q;while(1){if((a[b+(f*112|0)+72|0]|0)==0){h[(c[e+400>>2]|0)+(f<<3)>>3]=+h[(c[g>>2]|0)+(p<<3)>>3];r=p+1|0}else{r=p}q=f+1|0;if((q|0)<(o|0)){f=q;p=r}else{break}}i=d;return}function $$a(a,b,d){a=a|0;b=b|0;d=d|0;d=i;i=i+8|0;oXa(c[a+536>>2]|0,280712,d);return 0}function a0a(a){a=a|0;a=i;i=i+8|0;oXa(0,280744,a);return 0}function b0a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;c[d>>2]=(c[240116>>2]|0)!=0?1e3:0;k=a;l=c[k>>2]|0;c[e>>2]=l*1e3;h[f>>3]=1.0e-12;h[g>>3]=10.0;m=l<<1|1;c[j>>2]=m;n=Ypb((fa(m+13|0,m+l|0)|0)+((fa(l*3|0,l+3|0)|0)/2|0)|0,8)|0;nXa(0,(n|0)!=0|0,280784,b);c[70200]=c[a+60>>2];c[70202]=c[a+48>>2];AZa(k,j,c[a+24>>2]|0,g,f,d,e,n,6)|0;Xpb(n);c[70200]=0;c[70202]=0;n=K$a(a)|0;i=b;return n|0}function c0a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=-1;c[f+8>>2]=-1;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=b;b=f+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[f+48>>2]=c[70202];c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=c[70200];h[d>>3]=+L$a(f,1.0);i=e;return}function d0a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;h[o>>3]=0.0;h[p>>3]=0.0;h[q>>3]=0.0;c[r>>2]=0;c[s>>2]=0;c[t>>2]=0;c[u>>2]=0;c[v>>2]=0;w=a;x=c[w>>2]<<3;y=Wpb(x)|0;z=y;A=Wpb(x)|0;x=A;nXa(0,(y|0)!=0|0,280816,n);nXa(0,(A|0)!=0|0,280816,m);m=c[w>>2]|0;if((m|0)>0){n=c[a+24>>2]|0;B=0;do{C=+h[n+(B<<3)>>3];if(C!=0.0){D=+U(+C)/1.0e3}else{D=1.0}h[y+(B<<3)>>3]=D;h[A+(B<<3)>>3]=0.0;B=B+1|0;}while((B|0)<(m|0))}B=m*1e3|0;c[v>>2]=B;if((c[240116>>2]|0)==0){E=-1}else{E=(B|0)/10|0}c[r>>2]=E;h[p>>3]=1.0e-12;c[s>>2]=m;c[t>>2]=0;h[q>>3]=1.0e-12;D=+L$a(a,1.0);h[o>>3]=D;if(D!=0.0){c[70208]=c[a+60>>2];c[70210]=c[a+48>>2];xZa(c[a+24>>2]|0,z,w,o,v,r,p,s,t,q,x,7,u)|0;c[70208]=0;c[70210]=0}else{x=l;h[k>>3]=D;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];kXa(9,0,280848,l)}D=+L$a(a,1.0);h[o>>3]=D;l=j;h[k>>3]=D;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];kXa(9,0,280952,j);j=c[u>>2]|0;do{if((j|0)==1){if(!(+h[q>>3]<+h[o>>3])){break}c[g>>2]=c[v>>2];mXa(9,0,280968,g);F=-1;i=b;return F|0}else if((j|0)==2){mXa(9,0,281048,f);F=-2;i=b;return F|0}else if((j|0)==3){mXa(9,0,281112,e);F=-3;i=b;return F|0}else if((j|0)==4){mXa(9,0,281184,d);F=-4;i=b;return F|0}}while(0);F=K$a(a)|0;i=b;return F|0}function e0a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=-1;c[f+8>>2]=-1;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=b;b=f+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[f+48>>2]=c[70210];c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=c[70208];h[d>>3]=+L$a(f,1.0);i=e;return}function f0a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=fa(d*1e3|0,c[a>>2]|0)|0;c[j>>2]=0;kXa(9,1,281240,g);if((c[240116>>2]|0)==0){l=0}else{l=(k|0)/10|0}g0a(a,d,k,l,b,j);c[f>>2]=c[j>>2];kXa(9,0,281264,f);me[c[60158]&2047](9);if(+h[b>>3]<1.0){m=-1;i=e;return m|0}b=K$a(a)|0;if((b|0)==0){m=0;i=e;return m|0}mXa(9,0,281280,e);m=b;i=e;return m|0}function g0a(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0.0,Z=0,_=0,$=0,aa=0.0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0.0,Ca=0;j=i;i=i+8|0;l=j;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+24|0;v=i;i=i+32|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+4096|0;K=a;L=c[K>>2]|0;M=L+1|0;N=L<<3;O=Wpb(fa(N,M)|0)|0;P=Wpb(M<<3)|0;Q=Wpb(N)|0;R=Q;S=Wpb(N)|0;T=S;V=Wpb(N)|0;W=V;X=Wpb(N)|0;Y=+h[f>>3];if((c[240116>>2]|0)!=0&Y<1.0){N=J;c[I>>2]=c[(c[a+60>>2]|0)+88>>2];lc(N|0,281328,I|0)|0;I=mc(N|0,281344)|0;c[H>>2]=281360;Dd(I|0,281352,H|0)|0;c[G>>2]=281376;Dd(I|0,281352,G|0)|0;if((c[K>>2]|0)>0){G=a+44|0;H=0;do{c[F>>2]=c[(c[G>>2]|0)+(H<<2)>>2];Dd(I|0,281352,F|0)|0;H=H+1|0;}while((H|0)<(c[K>>2]|0))}Zd(10,I|0)|0;c[E>>2]=0;Dd(I|0,281384,E|0)|0;E=D;h[k>>3]=Y;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];Dd(I|0,281392,D|0)|0;if((c[K>>2]|0)>0){D=a+24|0;E=0;do{H=C;h[k>>3]=+h[(c[D>>2]|0)+(E<<3)>>3];c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];Dd(I|0,281392,C|0)|0;E=E+1|0;}while((E|0)<(c[K>>2]|0))}Zd(10,I|0)|0;Z=I}else{Z=0}nXa(0,(O|0)!=0|0,281400,B);nXa(0,(P|0)!=0|0,281400,A);nXa(0,(Q|0)!=0|0,281400,z);nXa(0,(S|0)!=0|0,281400,y);nXa(0,(V|0)!=0|0,281400,x);nXa(0,(X|0)!=0|0,281400,w);w=c[a+40>>2]|0;x=(L|0)>0;do{if((w|0)==0){if(!x){_=0;break}y=a+24|0;z=0;while(1){A=(c[y>>2]|0)+(z<<3)|0;B=0;do{h[O+((fa(B,L)|0)+z<<3)>>3]=+h[A>>3];B=B+1|0;}while((B|0)<(M|0));B=z+1|0;if((B|0)<(L|0)){z=B}else{$=14;break}}}else{if(!x){_=0;break}z=c[a+24>>2]|0;y=0;while(1){aa=+h[z+(y<<3)>>3]/+h[w+(y<<3)>>3];B=0;do{h[O+((fa(B,L)|0)+y<<3)>>3]=aa;B=B+1|0;}while((B|0)<(M|0));B=y+1|0;if((B|0)<(L|0)){y=B}else{$=14;break}}}}while(0);do{if(($|0)==14){w=(L|0)>0;if(w){ba=0}else{_=0;break}while(1){x=O+((fa(ba,L)|0)+ba<<3)|0;h[x>>3]=+h[x>>3]+1.0;x=ba+1|0;if((x|0)<(L|0)){ba=x}else{_=w;break}}}}while(0);ba=(L|0)>-1;w=a+16|0;aa=+(M|0);ca=+(L|0);x=(e|0)==0;y=a+48|0;da=1.0/+(b+ -1|0);b=(Z|0)==0;z=a+24|0;B=L<<3;ea=0.0;A=0;ga=Y;a:while(1){I=!(ga>=1.0);E=ga<1.0;ha=ea;C=A;b:while(1){D=C;c:while(1){ia=D+1|0;if(ba){H=0;do{Z$a(a,O+((fa(H,L)|0)<<3)|0);h[P+(H<<3)>>3]=+L$a(a,ga);H=H+1|0;}while((H|0)<(M|0))}if(_){H=1;F=0;while(1){G=+h[P+(H<<3)>>3]<+h[P+(F<<3)>>3]?H:F;N=H+1|0;if((N|0)<(M|0)){F=G;H=N}else{ja=G;break}}}else{ja=0}ka=fa(ja,L)|0;la=O+(ka<<3)|0;Z$a(a,la);+L$a(a,ga);H=c[w>>2]|0;if((H|0)>0){F=c[y>>2]|0;Y=0.0;G=0;do{ma=+U(+(+h[F+(G<<3)>>3]));Y=ma>Y?ma:Y;G=G+1|0;}while((G|0)<(H|0));na=!(Y<1.0e-12)}else{na=0}if(!((na|I)&(D|0)<(d|0))){break a}do{if(ba){H=0;G=ja;F=ja;while(1){ma=+h[P+(H<<3)>>3];N=ma>+h[P+(G<<3)>>3];oa=N?H:G;J=N?G:F;pa=!(ma>+h[P+(J<<3)>>3])|(H|0)==(oa|0)?J:H;J=H+1|0;if((J|0)<(M|0)){F=pa;G=oa;H=J}else{break}}if(ba){qa=0.0;ra=0}else{sa=0.0;ta=oa;ua=pa;break}do{qa=qa+ +h[P+(ra<<3)>>3];ra=ra+1|0;}while((ra|0)<(M|0));ma=qa/aa;if(ba){va=0.0;wa=0}else{sa=0.0;ta=oa;ua=pa;break}while(1){xa=+h[P+(wa<<3)>>3]-ma;ya=va+xa*xa;H=wa+1|0;if((H|0)<(M|0)){wa=H;va=ya}else{sa=ya;ta=oa;ua=pa;break}}}else{sa=0.0;ta=ja;ua=ja}}while(0);Y=sa/ca;do{if(!x){if(((ia|0)%(e|0)|0|0)!=0){break}ma=+h[P+(ja<<3)>>3];ya=+h[P+(ta<<3)>>3];H=v;h[k>>3]=ga;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];c[v+8>>2]=ia;H=v+12|0;h[k>>3]=ma;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=v+20|0;h[k>>3]=ya;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];kXa(9,0,281416,v)}}while(0);if(Y<1.0e-8&E){break b}if(_){Cqb(X|0,0,B|0)|0}if(ba){H=0;do{if(!((H|0)==(ta|0)|_^1)){G=fa(H,L)|0;F=0;do{J=X+(F<<3)|0;h[J>>3]=+h[O+(F+G<<3)>>3]+ +h[J>>3];F=F+1|0;}while((F|0)<(L|0))}H=H+1|0;}while((H|0)<(M|0))}do{if(_){H=0;do{F=X+(H<<3)|0;h[F>>3]=+h[F>>3]/ca;H=H+1|0;}while((H|0)<(L|0));if(!_){break}H=fa(ta,L)|0;F=0;do{Y=+h[X+(F<<3)>>3];h[Q+(F<<3)>>3]=Y+(Y- +h[O+(F+H<<3)>>3]);F=F+1|0;}while((F|0)<(L|0))}}while(0);Z$a(a,R);za=+L$a(a,ga);Y=+h[P+(ja<<3)>>3];do{if(Y<=za){if(!(za<=+h[P+(ua<<3)>>3])){break}if(!_){Aa=ia;D=Aa;continue c}Aqb(O+(fa(B,ta)|0)|0,Q|0,B|0)|0;Aa=ia;D=Aa;continue c}}while(0);if(!(za<=Y)){break}if(_){F=0;do{ya=+h[X+(F<<3)>>3];h[S+(F<<3)>>3]=ya+(+h[Q+(F<<3)>>3]-ya)*2.0;F=F+1|0;}while((F|0)<(L|0))}Z$a(a,T);if(+L$a(a,ga)<za){if(!_){Aa=ia;D=Aa;continue}Aqb(O+(fa(B,ta)|0)|0,S|0,B|0)|0;Aa=ia;D=Aa;continue}else{if(!_){Aa=ia;D=Aa;continue}Aqb(O+(fa(B,ta)|0)|0,Q|0,B|0)|0;Aa=ia;D=Aa;continue}}if(!(+h[P+(ua<<3)>>3]<=za)){$=89;break a}Y=+h[P+(ta<<3)>>3];if(!(za>=Y)){if(_){D=0;do{ya=+h[X+(D<<3)>>3];h[V+(D<<3)>>3]=ya+(+h[Q+(D<<3)>>3]-ya)*.5;D=D+1|0;}while((D|0)<(L|0))}Z$a(a,W);Ba=+L$a(a,ga)}else{if(_){D=fa(ta,L)|0;F=0;do{ya=+h[X+(F<<3)>>3];h[V+(F<<3)>>3]=ya+(+h[O+(F+D<<3)>>3]-ya)*.5;F=F+1|0;}while((F|0)<(L|0))}Z$a(a,W);Ba=+L$a(a,ga)}if(Ba<Y){if(!_){ha=Ba;C=ia;continue}Aqb(O+(fa(B,ta)|0)|0,V|0,B|0)|0;ha=Ba;C=ia;continue}if(ba){Ca=0}else{ha=Ba;C=ia;continue}while(1){if(_){F=fa(Ca,L)|0;D=0;do{H=O+(D+F<<3)|0;h[H>>3]=(+h[H>>3]+ +h[O+(D+ka<<3)>>3])*.5;D=D+1|0;}while((D|0)<(L|0))}D=Ca+1|0;if((D|0)<(M|0)){Ca=D}else{ha=Ba;C=ia;continue b}}}Y=ga+da;ya=Y>1.0?1.0:Y;Y=+h[P+(ja<<3)>>3];C=u;h[k>>3]=ya;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[u+8>>2]=ia;C=u+12|0;h[k>>3]=Y;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];kXa(9,0,281456,u);if(b){ea=ha;A=ia;ga=ya;continue}c[t>>2]=ia;Dd(Z|0,281384,t|0)|0;C=s;h[k>>3]=ya;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];Dd(Z|0,281392,s|0)|0;if((c[K>>2]|0)>0){C=0;do{E=r;h[k>>3]=+h[(c[z>>2]|0)+(C<<3)>>3];c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];Dd(Z|0,281392,r|0)|0;C=C+1|0;}while((C|0)<(c[K>>2]|0))}Zd(10,Z|0)|0;ea=ha;A=ia;ga=ya}if(($|0)==89){$=q;h[k>>3]=za;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];mXa(9,0,281504,q);q=p;h[k>>3]=ha;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];mXa(9,0,281520,p);oXa(0,281536,o)}Z$a(a,la);if((f|0)!=0){h[f>>3]=ga}if((g|0)!=0){c[g>>2]=ia}if(b){Xpb(S);Xpb(Q);Xpb(V);Xpb(X);Xpb(P);Xpb(O);i=j;return}c[n>>2]=ia;Dd(Z|0,281384,n|0)|0;n=m;h[k>>3]=ga;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Dd(Z|0,281392,m|0)|0;if((c[K>>2]|0)>0){m=0;do{n=l;h[k>>3]=+h[(c[z>>2]|0)+(m<<3)>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Dd(Z|0,281392,l|0)|0;m=m+1|0;}while((m|0)<(c[K>>2]|0))}Zd(10,Z|0)|0;ad(Z|0)|0;Xpb(S);Xpb(Q);Xpb(V);Xpb(X);Xpb(P);Xpb(O);i=j;return}function h0a(a,b){a=a|0;b=b|0;i=i;return}function i0a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=c[b+12>>2]|0;CYa(3);FYa(0);w=+xYa(0);CYa(0);x=d+4|0;y=u;h[k>>3]=+h[c[c[x>>2]>>2]>>3];c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];Dd(v|0,281616,u|0)|0;if((c[b+8>>2]|0)!=0){b=t;h[k>>3]=w;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];Dd(v|0,281616,t|0)|0}t=d+116|0;b=c[t>>2]|0;if((b|0)>0){u=d+8|0;y=b;b=0;while(1){if((a[(c[u>>2]|0)+(b*112|0)+104|0]|0)==0){z=s;h[k>>3]=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(b<<3)>>3];c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Dd(v|0,281616,s|0)|0;A=c[t>>2]|0}else{A=y}z=b+1|0;if((z|0)<(A|0)){y=A;b=z}else{break}}}b=d+124|0;A=c[b>>2]|0;if((A|0)>0){y=d+12|0;t=A;A=0;while(1){if((a[(c[y>>2]|0)+(A*60|0)+56|0]|0)==0){c[r>>2]=c[(c[(c[c[x>>2]>>2]|0)+12>>2]|0)+(A<<2)>>2];Dd(v|0,281624,r|0)|0;B=c[b>>2]|0}else{B=t}s=A+1|0;if((s|0)<(B|0)){t=B;A=s}else{break}}}A=d+128|0;B=c[A>>2]|0;if((B|0)>0){t=d+16|0;b=B;B=0;while(1){if((a[(c[t>>2]|0)+(B*48|0)+44|0]|0)==0){c[q>>2]=a[(c[(c[c[x>>2]>>2]|0)+16>>2]|0)+B|0]|0;Dd(v|0,281624,q|0)|0;C=c[A>>2]|0}else{C=b}r=B+1|0;if((r|0)<(C|0)){b=C;B=r}else{break}}}B=d+132|0;C=c[B>>2]|0;if((C|0)>0){b=d+20|0;A=C;C=0;while(1){if((a[(c[b>>2]|0)+(C*52|0)+48|0]|0)==0){c[p>>2]=c[(c[(c[c[x>>2]>>2]|0)+20>>2]|0)+(C<<2)>>2];Dd(v|0,281632,p|0)|0;D=c[B>>2]|0}else{D=A}q=C+1|0;if((q|0)<(D|0)){A=D;C=q}else{break}}}C=d+216|0;if((c[C>>2]|0)>0){D=d+40|0;A=0;do{B=c[D>>2]|0;do{if((a[B+(A*52|0)+48|0]|0)==0){p=a[B+(A*52|0)+8|0]|0;if(p<<24>>24==2){E=c[c[x>>2]>>2]|0}else if(p<<24>>24==1){break}else{E=(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(c[B+(A*52|0)+4>>2]<<3)|0}w=+h[E>>3];if((c[B+(A*52|0)>>2]|0)==0){p=n;h[k>>3]=w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];Dd(v|0,281616,n|0)|0;break}else{p=o;h[k>>3]=-w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];Dd(v|0,281616,o|0)|0;break}}}while(0);A=A+1|0;}while((A|0)<(c[C>>2]|0))}C=d+220|0;if((c[C>>2]|0)>0){A=d+44|0;o=0;do{n=c[A>>2]|0;do{if((a[n+(o*52|0)+48|0]|0)==0){if((a[n+(o*52|0)+8|0]|0)==1){break}E=c[(c[(c[c[x>>2]>>2]|0)+12>>2]|0)+(c[n+(o*52|0)+4>>2]<<2)>>2]|0;if((c[n+(o*52|0)>>2]|0)==0){c[l>>2]=E;Dd(v|0,281624,l|0)|0;break}else{c[m>>2]=0-E;Dd(v|0,281624,m|0)|0;break}}}while(0);o=o+1|0;}while((o|0)<(c[C>>2]|0))}C=d+224|0;if((c[C>>2]|0)>0){o=d+48|0;m=0;do{l=c[o>>2]|0;do{if((a[l+(m*52|0)+48|0]|0)==0){if((a[l+(m*52|0)+8|0]|0)==1){break}A=a[(c[(c[c[x>>2]>>2]|0)+16>>2]|0)+(c[l+(m*52|0)+4>>2]|0)|0]|0;if((c[l+(m*52|0)>>2]|0)==0){c[g>>2]=A<<24>>24;Dd(v|0,281624,g|0)|0;break}else{c[j>>2]=A<<24>>24!=1;Dd(v|0,281624,j|0)|0;break}}}while(0);m=m+1|0;}while((m|0)<(c[C>>2]|0))}C=d+228|0;m=c[C>>2]|0;if((m|0)<=0){F=Zd(10,v|0)|0;FYa(3);i=e;return}j=d+52|0;d=m;m=0;while(1){g=c[j>>2]|0;do{if((a[g+(m*52|0)+48|0]|0)==0){if((a[g+(m*52|0)+8|0]|0)==1){G=d;break}c[f>>2]=c[(c[(c[c[x>>2]>>2]|0)+20>>2]|0)+(c[g+(m*52|0)+4>>2]<<2)>>2];Dd(v|0,281632,f|0)|0;G=c[C>>2]|0}else{G=d}}while(0);g=m+1|0;if((g|0)<(G|0)){d=G;m=g}else{break}}F=Zd(10,v|0)|0;FYa(3);i=e;return}function j0a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=b;s=mc(c[r>>2]|0,281640)|0;t=c[d+536>>2]|0;u=c[r>>2]|0;r=be(c[(Qc()|0)>>2]|0)|0;c[q>>2]=u;c[q+4>>2]=r;nXa(t,(s|0)!=0|0,281648,q);c[p>>2]=281704;Dd(s|0,281632,p|0)|0;if((c[b+8>>2]|0)!=0){c[o>>2]=281712;Dd(s|0,281632,o|0)|0}o=d+116|0;p=c[o>>2]|0;if((p|0)>0){q=d+8|0;t=p;p=0;while(1){r=c[q>>2]|0;if((a[r+(p*112|0)+104|0]|0)==0){c[n>>2]=c[r+(p*112|0)+4>>2];Dd(s|0,281632,n|0)|0;v=c[o>>2]|0}else{v=t}r=p+1|0;if((r|0)<(v|0)){t=v;p=r}else{break}}}p=d+124|0;v=c[p>>2]|0;if((v|0)>0){t=d+12|0;o=v;v=0;while(1){n=c[t>>2]|0;if((a[n+(v*60|0)+56|0]|0)==0){c[m>>2]=c[n+(v*60|0)+4>>2];Dd(s|0,281632,m|0)|0;w=c[p>>2]|0}else{w=o}n=v+1|0;if((n|0)<(w|0)){o=w;v=n}else{break}}}v=d+128|0;w=c[v>>2]|0;if((w|0)>0){o=d+16|0;p=w;w=0;while(1){m=c[o>>2]|0;if((a[m+(w*48|0)+44|0]|0)==0){c[l>>2]=c[m+(w*48|0)+4>>2];Dd(s|0,281632,l|0)|0;x=c[v>>2]|0}else{x=p}m=w+1|0;if((m|0)<(x|0)){p=x;w=m}else{break}}}w=d+132|0;x=c[w>>2]|0;if((x|0)>0){p=d+20|0;v=x;x=0;while(1){l=c[p>>2]|0;if((a[l+(x*52|0)+48|0]|0)==0){c[k>>2]=c[l+(x*52|0)+4>>2];Dd(s|0,281632,k|0)|0;y=c[w>>2]|0}else{y=v}l=x+1|0;if((l|0)<(y|0)){v=y;x=l}else{break}}}x=d+216|0;y=c[x>>2]|0;if((y|0)>0){v=d+40|0;w=y;y=0;while(1){k=c[v>>2]|0;do{if((a[k+(y*52|0)+48|0]|0)==0){if((a[k+(y*52|0)+8|0]|0)==1){z=w;break}c[j>>2]=c[k+(y*52|0)+16>>2];Dd(s|0,281632,j|0)|0;z=c[x>>2]|0}else{z=w}}while(0);k=y+1|0;if((k|0)<(z|0)){w=z;y=k}else{break}}}y=d+220|0;z=c[y>>2]|0;if((z|0)>0){w=d+44|0;x=z;z=0;while(1){j=c[w>>2]|0;do{if((a[j+(z*52|0)+48|0]|0)==0){if((a[j+(z*52|0)+8|0]|0)==1){A=x;break}c[h>>2]=c[j+(z*52|0)+16>>2];Dd(s|0,281632,h|0)|0;A=c[y>>2]|0}else{A=x}}while(0);j=z+1|0;if((j|0)<(A|0)){x=A;z=j}else{break}}}z=d+224|0;A=c[z>>2]|0;if((A|0)>0){x=d+48|0;y=A;A=0;while(1){h=c[x>>2]|0;do{if((a[h+(A*52|0)+48|0]|0)==0){if((a[h+(A*52|0)+8|0]|0)==1){B=y;break}c[g>>2]=c[h+(A*52|0)+16>>2];Dd(s|0,281632,g|0)|0;B=c[z>>2]|0}else{B=y}}while(0);h=A+1|0;if((h|0)<(B|0)){y=B;A=h}else{break}}}A=d+228|0;B=c[A>>2]|0;if((B|0)<=0){C=Zd(10,s|0)|0;D=s;E=b;F=E+12|0;G=F;c[G>>2]=D;i=e;return}y=d+52|0;d=B;B=0;while(1){z=c[y>>2]|0;do{if((a[z+(B*52|0)+48|0]|0)==0){if((a[z+(B*52|0)+8|0]|0)==1){H=d;break}c[f>>2]=c[z+(B*52|0)+16>>2];Dd(s|0,281632,f|0)|0;H=c[A>>2]|0}else{H=d}}while(0);z=B+1|0;if((z|0)<(H|0)){d=H;B=z}else{break}}C=Zd(10,s|0)|0;D=s;E=b;F=E+12|0;G=F;c[G>>2]=D;i=e;return}function k0a(a,b){a=a|0;b=b|0;var d=0;b=i;d=c[a+12>>2]|0;CYa(3);ad(d|0)|0;FYa(3);i=b;return}function l0a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+104|0;e=d;f=d+16|0;g=d+32|0;j=d+40|0;k=d+48|0;l=d+56|0;m=d+72|0;n=d+88|0;o=c[a+12>>2]|0;c[k>>2]=0;p=o;gib(l,p);q=o+184|0;r=m;c[r+0>>2]=c[q+0>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2];c[r+12>>2]=c[q+12>>2];q=f;r=m;c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];hib(p,f)|0;m0a(b,k,g,j,+h[o+224>>3],+h[o+232>>3]);o=c[k>>2]|0;n0a(a,b,281728,c[j>>2]|0,c[g>>2]|0,o,8);Xpb(o);c[k>>2]=0;k=n;o=l;c[k+0>>2]=c[o+0>>2];c[k+4>>2]=c[o+4>>2];c[k+8>>2]=c[o+8>>2];c[k+12>>2]=c[o+12>>2];o=e;k=n;c[o+0>>2]=c[k+0>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];c[o+12>>2]=c[k+12>>2];hib(p,e)|0;i=d;return}function m0a(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=+j;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+8|0;c[e>>2]=2;l=b+136|0;m=b+140|0;n=b+144|0;o=(c[l>>2]|0)+1+(c[m>>2]|0)+(c[n>>2]|0)|0;c[f>>2]=o;p=Ypb(fa(c[e>>2]|0,o)|0,8)|0;c[d>>2]=p;nXa(c[b+536>>2]|0,(p|0)!=0|0,282008,k);p=c[d>>2]|0;h[p>>3]=g;d=c[f>>2]|0;h[p+(d<<3)>>3]=j;f=c[l>>2]|0;if((f|0)>0){l=c[b+416>>2]|0;o=0;do{e=l+(o<<3)|0;o=o+1|0;h[p+(o<<3)>>3]=+h[e>>3];h[p+(d+o<<3)>>3]=+h[e>>3];}while((o|0)<(f|0))}o=f+1|0;f=c[m>>2]|0;if((f|0)>0){m=c[b+420>>2]|0;l=0;do{j=+(c[m+(l<<2)>>2]|0);e=l+o|0;h[p+(e<<3)>>3]=j;h[p+(d+e<<3)>>3]=j;l=l+1|0;}while((l|0)<(f|0))}l=f+o|0;o=c[n>>2]|0;if((o|0)<=0){i=k;return}n=c[b+424>>2]|0;b=0;do{f=n+b|0;m=l+b|0;h[p+(m<<3)>>3]=+(a[f]|0);h[p+(d+m<<3)>>3]=+(a[f]|0);b=b+1|0;}while((b|0)<(o|0));i=k;return}function n0a(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;i=i+8|0;k=j;l=c[a+12>>2]|0;y0a(a,b,d,e,f,h);fib(l,g,fa(fa(f,e)|0,h)|0)|0;if(Cgb(l+(c[(c[l>>2]|0)+ -12>>2]|0)|0)|0){l=c[b+536>>2]|0;c[k>>2]=c[a>>2];oXa(l,281960,k)}else{i=j;return}}function o0a(a){a=a|0;var b=0;b=i;if((q1a(a+4|0)|0)!=0){i=b;return}Fgb(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,4);i=b;return}function p0a(a){a=a|0;Uc(a|0)|0;_c()}function q0a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=aqb(320)|0;Cqb(q|0,0,320)|0;r0a(q);r=a+12|0;c[r>>2]=q;s=(c[b+140>>2]|0)+(c[b+136>>2]|0)+(c[b+144>>2]|0)|0;c[f>>2]=0;c[k>>2]=0;c[l>>2]=0;CYa(3);t=a+8|0;u=s0a(c[t>>2]|0,c[r>>2]|0,b)|0;r=q+316|0;c[r>>2]=u;v=t0a(a,b,u+s|0)|0;u=q+184|0;u0a(m,-1,-1);w=m;c[u+0>>2]=c[w+0>>2];c[u+4>>2]=c[w+4>>2];c[u+8>>2]=c[w+8>>2];c[u+12>>2]=c[w+12>>2];w=q+200|0;u0a(n,-1,-1);m=n;c[w+0>>2]=c[m+0>>2];c[w+4>>2]=c[m+4>>2];c[w+8>>2]=c[m+8>>2];c[w+12>>2]=c[m+12>>2];c[q+216>>2]=0;m=q+224|0;h[m>>3]=+h[b+240>>3];n=q+232|0;h[n>>3]=+h[b+248>>3];x=a;v0a(q,c[x>>2]|0,36);if(Cgb(q+(c[(c[q>>2]|0)+ -12>>2]|0)|0)|0){y=c[b+536>>2]|0;c[e>>2]=c[x>>2];oXa(y,281784,e)}else{n0a(a,b,281816,4,11,281736,1);w0a((c[r>>2]|0)+s|0,v,f,g,j,0,0)|0;e=c[f>>2]|0;n0a(a,b,281824,c[g>>2]|0,c[j>>2]|0,e,1);Xpb(e);c[f>>2]=0;w0a((c[r>>2]|0)+s|0,v,f,g,j,0,1)|0;e=c[f>>2]|0;n0a(a,b,281832,c[g>>2]|0,c[j>>2]|0,e,1);Xpb(e);c[f>>2]=0;x0a(a,b,k,g,j,c[r>>2]|0,s);n0a(a,b,281848,c[j>>2]|0,c[g>>2]|0,c[k>>2]|0,4);s=q;gib(o,s);r=o;c[u+0>>2]=c[r+0>>2];c[u+4>>2]=c[r+4>>2];c[u+8>>2]=c[r+8>>2];c[u+12>>2]=c[r+12>>2];m0a(b,l,g,j,+h[m>>3],+h[n>>3]);n=c[l>>2]|0;n0a(a,b,281728,c[j>>2]|0,c[g>>2]|0,n,8);gib(p,s);g=p;c[w+0>>2]=c[g+0>>2];c[w+4>>2]=c[g+4>>2];c[w+8>>2]=c[g+8>>2];c[w+12>>2]=c[g+12>>2];g=z0a(q+240|0)|0;w=z0a(q+264|0)|0;p=z0a(q+288|0)|0;y0a(a,b,281864,g+1+w+p+(c[q+312>>2]|0)+(c[t>>2]|0)|0,0,8);Xpb(n);Xpb(c[k>>2]|0);c[l>>2]=0;c[k>>2]=0;Nhb(s)|0;Xpb(v);FYa(3);i=d;return}}function r0a(a){a=a|0;var b=0;b=i;A3a(a);i=b;return}function s0a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;i=i+24|0;g=f;h=f+8|0;j=f+16|0;k=(b|0)==0?1:2;c[g>>2]=0;b=e+116|0;l=c[b>>2]|0;if((l|0)>0){m=e+8|0;n=d+240|0;o=l;l=0;p=k;while(1){if((a[(c[m>>2]|0)+(l*112|0)+104|0]|0)==0){c[(E2a(n,g)|0)>>2]=p;q=c[b>>2]|0;r=c[g>>2]|0;s=p+1|0}else{q=o;r=l;s=p}t=r+1|0;c[g>>2]=t;if((t|0)<(q|0)){o=q;l=t;p=s}else{u=s;break}}}else{u=k}c[h>>2]=0;k=e+124|0;s=c[k>>2]|0;if((s|0)>0){p=e+12|0;l=d+264|0;q=s;s=0;o=u;while(1){if((a[(c[p>>2]|0)+(s*60|0)+56|0]|0)==0){c[(E2a(l,h)|0)>>2]=o;v=c[k>>2]|0;w=c[h>>2]|0;x=o+1|0}else{v=q;w=s;x=o}g=w+1|0;c[h>>2]=g;if((g|0)<(v|0)){q=v;s=g;o=x}else{y=x;break}}}else{y=u}c[j>>2]=0;u=e+128|0;x=c[u>>2]|0;if((x|0)>0){o=e+16|0;s=d+288|0;v=x;x=0;q=y;while(1){if((a[(c[o>>2]|0)+(x*48|0)+44|0]|0)==0){c[(E2a(s,j)|0)>>2]=q;z=c[u>>2]|0;A=c[j>>2]|0;B=q+1|0}else{z=v;A=x;B=q}h=A+1|0;c[j>>2]=h;if((h|0)<(z|0)){v=z;x=h;q=B}else{C=B;break}}}else{C=y}y=c[e+216>>2]|0;if((y|0)>0){B=c[e+40>>2]|0;q=0;x=C;while(1){z=((a[B+(q*52|0)+48|0]|0)==0)+x|0;v=q+1|0;if((v|0)<(y|0)){x=z;q=v}else{D=z;break}}}else{D=C}C=c[e+220>>2]|0;if((C|0)>0){q=c[e+44>>2]|0;x=0;y=D;while(1){B=((a[q+(x*52|0)+48|0]|0)==0)+y|0;z=x+1|0;if((z|0)<(C|0)){y=B;x=z}else{E=B;break}}}else{E=D}D=d+312|0;c[D>>2]=0;d=c[e+224>>2]|0;if((d|0)<=0){F=E;i=f;return F|0}x=c[e+48>>2]|0;e=0;y=0;C=E;while(1){if((a[x+(y*52|0)+48|0]|0)==0){if((c[x+(y*52|0)>>2]|0)==0){G=e}else{E=e+1|0;c[D>>2]=E;G=E}H=G;I=C+1|0}else{H=e;I=C}E=y+1|0;if((E|0)<(d|0)){e=H;y=E;C=I}else{F=I;break}}i=f;return F|0}function t0a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+24|0;g=f;h=f+8|0;j=f+16|0;k=c[b+12>>2]|0;l=Wpb(e<<2)|0;e=l;c[l>>2]=282416;if((c[b+8>>2]|0)==0){m=1}else{c[l+4>>2]=282456;m=2}b=c[d+116>>2]|0;if((b|0)>0){n=c[d+8>>2]|0;o=m;p=0;while(1){if((a[n+(p*112|0)+104|0]|0)==0){c[l+(o<<2)>>2]=n+(p*112|0);q=o+1|0}else{q=o}r=p+1|0;if((r|0)<(b|0)){o=q;p=r}else{s=q;break}}}else{s=m}m=c[d+124>>2]|0;if((m|0)>0){q=c[d+12>>2]|0;p=s;o=0;while(1){if((a[q+(o*60|0)+56|0]|0)==0){c[l+(p<<2)>>2]=q+(o*60|0);t=p+1|0}else{t=p}b=o+1|0;if((b|0)<(m|0)){p=t;o=b}else{u=t;break}}}else{u=s}s=c[d+128>>2]|0;if((s|0)>0){t=c[d+16>>2]|0;o=u;p=0;while(1){if((a[t+(p*48|0)+44|0]|0)==0){c[l+(o<<2)>>2]=t+(p*48|0);v=o+1|0}else{v=o}m=p+1|0;if((m|0)<(s|0)){o=v;p=m}else{w=v;break}}}else{w=u}u=c[d+216>>2]|0;if((u|0)>0){v=c[d+40>>2]|0;p=w;o=0;while(1){if((a[v+(o*52|0)+48|0]|0)==0){c[l+(p<<2)>>2]=v+(o*52|0)+12;x=p+1|0}else{x=p}s=o+1|0;if((s|0)<(u|0)){p=x;o=s}else{y=x;break}}}else{y=w}w=c[d+220>>2]|0;if((w|0)>0){x=c[d+44>>2]|0;o=y;p=0;while(1){if((a[x+(p*52|0)+48|0]|0)==0){c[l+(o<<2)>>2]=x+(p*52|0)+12;z=o+1|0}else{z=o}u=p+1|0;if((u|0)<(w|0)){o=z;p=u}else{A=z;break}}}else{A=y}y=c[d+224>>2]|0;if((y|0)>0){z=c[d+48>>2]|0;p=A;o=0;while(1){if((a[z+(o*52|0)+48|0]|0)==0){c[l+(p<<2)>>2]=z+(o*52|0)+12;B=p+1|0}else{B=p}w=o+1|0;if((w|0)<(y|0)){p=B;o=w}else{C=B;break}}}else{C=A}c[g>>2]=0;A=d+136|0;if((c[A>>2]|0)>0){B=d+24|0;o=k+252|0;p=C;y=0;z=1;while(1){w=p+1|0;c[l+(p<<2)>>2]=(c[B>>2]|0)+(y*112|0);c[(E2a(o,g)|0)>>2]=z;x=z+1|0;u=(c[g>>2]|0)+1|0;c[g>>2]=u;if((u|0)<(c[A>>2]|0)){z=x;y=u;p=w}else{D=w;E=x;break}}}else{D=C;E=1}c[h>>2]=0;C=d+140|0;if((c[C>>2]|0)>0){p=d+28|0;y=k+276|0;z=D;A=0;g=E;while(1){o=z+1|0;c[l+(z<<2)>>2]=(c[p>>2]|0)+(A*60|0);c[(E2a(y,h)|0)>>2]=g;B=g+1|0;x=(c[h>>2]|0)+1|0;c[h>>2]=x;if((x|0)<(c[C>>2]|0)){g=B;A=x;z=o}else{F=o;G=B;break}}}else{F=D;G=E}c[j>>2]=0;E=d+144|0;if((c[E>>2]|0)<=0){i=f;return e|0}D=d+32|0;d=k+300|0;k=F;F=0;z=G;while(1){c[l+(k<<2)>>2]=(c[D>>2]|0)+(F*48|0);c[(E2a(d,j)|0)>>2]=z;G=(c[j>>2]|0)+1|0;c[j>>2]=G;if((G|0)<(c[E>>2]|0)){z=z+1|0;F=G;k=k+1|0}else{break}}i=f;return e|0}function u0a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;p1a(a,b,c);i=d;return}function v0a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=(o1a(a+4|0,b,d|16)|0)==0;d=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;if(f){Fgb(d,4);i=e;return}else{Dgb(d,0);i=e;return}}function w0a(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;j=i;i=i+8|0;k=j;l=i;i=i+8|0;c[f>>2]=a;c[e>>2]=0;m=(a|0)>0;do{if(m){n=0;o=0;while(1){p=c[b+(o<<2)>>2]|0;q=yqb(c[(h?p+8|0:p+4|0)>>2]|0)|0;if((q|0)>(n|0)){c[e>>2]=q;r=q}else{r=n}q=o+1|0;if((q|0)<(a|0)){n=r;o=q}else{break}}o=Ypb((fa(c[f>>2]|0,r)|0)+1|0,1)|0;c[d>>2]=o;nXa(0,(o|0)!=0|0,281936,l);if(!m){break}o=c[e>>2]|0;n=0;q=c[d>>2]|0;while(1){p=b+(n<<2)|0;s=c[p>>2]|0;Jqb(q|0,c[(h?s+8|0:s+4|0)>>2]|0,o+1|0)|0;if(g){s=c[p>>2]|0;D0a(q,yqb(c[(h?s+8|0:s+4|0)>>2]|0)|0)}s=c[e>>2]|0;p=n+1|0;if((p|0)<(a|0)){o=s;n=p;q=q+s|0}else{t=s;break}}u=c[f>>2]|0;v=fa(u,t)|0;i=j;return v|0}else{q=Ypb(1,1)|0;c[d>>2]=q;nXa(0,(q|0)!=0|0,281936,k)}}while(0);t=c[e>>2]|0;u=c[f>>2]|0;v=fa(u,t)|0;i=j;return v|0}function x0a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=c[b+12>>2]|0;c[f>>2]=j+h;c[g>>2]=4;g=Ypb(c[f>>2]<<2,4)|0;c[e>>2]=g;nXa(c[d+536>>2]|0,(g|0)!=0|0,281984,k);g=s+240|0;f=z0a(g)|0;h=s+264|0;t=z0a(h)|0;u=s+288|0;v=z0a(u)|0;w=b+8|0;if((f+1+t+v|0)==(0-(c[w>>2]|0)|0)){x=0;y=1}else{v=c[e>>2]|0;t=0;f=0;b=1;while(1){c[v+(t<<2)>>2]=2;c[v+((t|1)<<2)>>2]=b;c[v+((t|2)<<2)>>2]=0;z=t+4|0;c[v+((t|3)<<2)>>2]=-1;A=b+1|0;B=f+1|0;C=z0a(g)|0;D=z0a(h)|0;E=z0a(u)|0;if(B>>>0<(C+1+D+E+(c[w>>2]|0)|0)>>>0){b=A;f=B;t=z}else{x=z;y=A;break}}}t=d+216|0;if((c[t>>2]|0)>0){f=d+40|0;b=s+252|0;w=x;v=0;while(1){A=c[f>>2]|0;do{if((a[A+(v*52|0)+48|0]|0)==0){z=a[A+(v*52|0)+8|0]|0;if(z<<24>>24==2){F=1;G=2}else if(z<<24>>24==0){E0a(l,g,A+(v*52|0)+4|0);G0a(m,g);if(!(F0a(l,m)|0)){H=w;break}F=(c[(H0a(l)|0)+4>>2]|0)+1|0;G=2}else if(z<<24>>24==1){E0a(l,b,A+(v*52|0)+4|0);G0a(n,b);if(!(F0a(l,n)|0)){H=w;break}F=(c[(H0a(l)|0)+4>>2]|0)+1|0;G=1}else{H=w;break}z=c[e>>2]|0;c[z+(w<<2)>>2]=G;if((c[(c[f>>2]|0)+(v*52|0)>>2]|0)==0){c[z+(w+1<<2)>>2]=F}else{c[z+(w+1<<2)>>2]=0-F}c[z+(w+2<<2)>>2]=0;c[z+(w+3<<2)>>2]=-1;H=w+4|0}else{H=w}}while(0);A=v+1|0;if((A|0)<(c[t>>2]|0)){w=H;v=A}else{I=H;break}}}else{I=x}x=d+220|0;if((c[x>>2]|0)>0){H=d+44|0;v=s+276|0;w=I;t=0;while(1){F=c[H>>2]|0;do{if((a[F+(t*52|0)+48|0]|0)==0){f=a[F+(t*52|0)+8|0]|0;if(f<<24>>24==0){E0a(l,h,F+(t*52|0)+4|0);G0a(o,h);G=F0a(l,o)|0;J=G?2:0}else if(f<<24>>24==1){E0a(l,v,F+(t*52|0)+4|0);G0a(p,v);J=(F0a(l,p)|0)&1}else{K=w;break}if((J|0)==0){K=w;break}f=c[e>>2]|0;c[f+(w<<2)>>2]=J;G=(c[(c[H>>2]|0)+(t*52|0)>>2]|0)==0;n=c[(H0a(l)|0)+4>>2]|0;if(G){c[f+(w+1<<2)>>2]=n+1}else{c[f+(w+1<<2)>>2]=~n}c[f+(w+2<<2)>>2]=0;c[f+(w+3<<2)>>2]=-1;K=w+4|0}else{K=w}}while(0);F=t+1|0;if((F|0)<(c[x>>2]|0)){w=K;t=F}else{L=K;break}}}else{L=I}I=d+224|0;if((c[I>>2]|0)>0){K=d+48|0;d=s+300|0;s=L;t=0;w=y;while(1){y=c[K>>2]|0;do{if((a[y+(t*52|0)+48|0]|0)==0){if((c[y+(t*52|0)>>2]|0)==0){x=a[y+(t*52|0)+8|0]|0;if(x<<24>>24==0){E0a(l,u,y+(t*52|0)+4|0);G0a(q,u);H=F0a(l,q)|0;M=H?2:0}else if(x<<24>>24==1){E0a(l,d,y+(t*52|0)+4|0);G0a(r,d);M=(F0a(l,r)|0)&1}else{N=s;O=w;break}if((M|0)==0){N=s;O=w;break}P=c[K>>2]|0;Q=M}else{P=y;Q=2}x=c[e>>2]|0;c[x+(s<<2)>>2]=Q;if((c[P+(t*52|0)>>2]|0)==0){c[x+(s+1<<2)>>2]=(c[(H0a(l)|0)+4>>2]|0)+1;R=w}else{c[x+(s+1<<2)>>2]=w;R=w+1|0}c[x+(s+2<<2)>>2]=0;c[x+(s+3<<2)>>2]=-1;N=s+4|0;O=R}else{N=s;O=w}}while(0);y=t+1|0;if((y|0)<(c[I>>2]|0)){s=N;t=y;w=O}else{S=N;break}}}else{S=L}if((j|0)==0){i=k;return}L=c[e>>2]|0;e=0;do{N=(e<<2)+S|0;c[L+(N<<2)>>2]=1;c[L+(N+1<<2)>>2]=e+2;c[L+(N+2<<2)>>2]=0;c[L+(N+3<<2)>>2]=0;e=e+1|0;}while(e>>>0<j>>>0);i=k;return}function y0a(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+24|0;m=c[a+12>>2]|0;c[l>>2]=(g|0)==4?20:(g|0)==1?51:0;c[l+4>>2]=e;c[l+8>>2]=f;c[l+12>>2]=0;f=l+16|0;c[f>>2]=(yqb(d|0)|0)+1;e=m;fib(e,l,20)|0;if(Cgb(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){l=c[b+536>>2]|0;c[k>>2]=c[a>>2];oXa(l,281960,k)}fib(e,d,c[f>>2]|0)|0;if(Cgb(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){m=c[b+536>>2]|0;c[j>>2]=c[a>>2];oXa(m,281960,j)}else{i=h;return}}function z0a(a){a=a|0;var b=0,d=0;b=i;d=c[(l1a(a)|0)>>2]|0;i=b;return d|0}function A0a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d;f=d+16|0;g=a+12|0;h=c[g>>2]|0;j=h;CYa(3);do{if(Bgb(h+(c[(c[h>>2]|0)+ -12>>2]|0)|0)|0){k=h;l=h+200|0;m=f;c[m+0>>2]=c[l+0>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];c[m+12>>2]=c[l+12>>2];l=e;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[l+12>>2]=c[m+12>>2];hib(k,e)|0;k=z0a(h+240|0)|0;m=z0a(h+264|0)|0;l=z0a(h+288|0)|0;y0a(a,b,281864,k+1+m+l+(c[h+312>>2]|0)+(c[a+8>>2]|0)|0,c[h+216>>2]|0,8);o0a(h)}else{if((h|0)!=0){break}c[g>>2]=0;FYa(3);i=d;return}}while(0);B0a(j);cqb(h);c[g>>2]=0;FYa(3);i=d;return}function B0a(a){a=a|0;var b=0;b=i;J1a(a);i=b;return}function C0a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;k=c[b+12>>2]|0;h[g>>3]=0.0;CYa(3);FYa(0);h[j>>3]=+xYa(0);CYa(0);l=k;m=d+4|0;fib(l,c[c[m>>2]>>2]|0,8)|0;if((c[b+8>>2]|0)!=0){fib(l,j,8)|0}j=d+116|0;n=c[j>>2]|0;if((n|0)>0){o=d+8|0;p=n;n=0;while(1){if((a[(c[o>>2]|0)+(n*112|0)+104|0]|0)==0){fib(l,(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+(n<<3)|0,8)|0;q=c[j>>2]|0}else{q=p}r=n+1|0;if((r|0)<(q|0)){p=q;n=r}else{break}}}n=d+124|0;q=c[n>>2]|0;if((q|0)>0){p=d+12|0;j=g;o=q;q=0;while(1){if((a[(c[p>>2]|0)+(q*60|0)+56|0]|0)==0){h[g>>3]=+(c[(c[(c[c[m>>2]>>2]|0)+12>>2]|0)+(q<<2)>>2]|0);fib(l,j,8)|0;s=c[n>>2]|0}else{s=o}r=q+1|0;if((r|0)<(s|0)){o=s;q=r}else{break}}}q=d+128|0;s=c[q>>2]|0;if((s|0)>0){o=d+16|0;n=g;j=s;s=0;while(1){if((a[(c[o>>2]|0)+(s*48|0)+44|0]|0)==0){h[g>>3]=+(a[(c[(c[c[m>>2]>>2]|0)+16>>2]|0)+s|0]|0);fib(l,n,8)|0;t=c[q>>2]|0}else{t=j}p=s+1|0;if((p|0)<(t|0)){j=t;s=p}else{break}}}s=d+224|0;t=c[s>>2]|0;if((t|0)>0){j=d+48|0;q=g;n=t;t=0;while(1){o=c[j>>2]|0;do{if((a[o+(t*52|0)+48|0]|0)==0){if((c[o+(t*52|0)>>2]|0)==0){u=n;break}h[g>>3]=+((a[(c[(c[c[m>>2]>>2]|0)+16>>2]|0)+(c[o+(t*52|0)+4>>2]|0)|0]|0)!=1|0);fib(l,q,8)|0;u=c[s>>2]|0}else{u=n}}while(0);o=t+1|0;if((o|0)<(u|0)){n=u;t=o}else{break}}}if(Cgb(k+(c[(c[k>>2]|0)+ -12>>2]|0)|0)|0){t=c[d+536>>2]|0;c[f>>2]=c[b>>2];oXa(t,281904,f)}else{f=k+216|0;c[f>>2]=(c[f>>2]|0)+1;FYa(3);i=e;return}}function D0a(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;if(c>>>0<6){i=d;return}if((vqb(b,282120,4)|0)!=0){i=d;return}c=b;while(1){e=Wa(b|0,46)|0;if((e|0)==0){f=8;break}g=e-c|0;e=g+1|0;if(e>>>0>4){h=4;do{a[b+(h+ -4)|0]=a[b+h|0]|0;h=h+1|0;}while(h>>>0<e>>>0)}e=b+(g+ -3)|0;a[e]=678585700;a[e+1|0]=2650725;a[e+2|0]=10354;a[e+3|0]=40;if((vqb(b,282120,4)|0)!=0){f=8;break}}if((f|0)==8){i=d;return}}function E0a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;Z0a(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];P0a(a,f);i=e;return}function F0a(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=N0a(a,b)|0;i=c;return d|0}function G0a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;Q0a(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];P0a(a,e);i=d;return}function H0a(a){a=a|0;var b=0,c=0;b=i;c=I0a(J0a(a)|0)|0;i=b;return c|0}function I0a(a){a=a|0;var b=0,c=0;b=i;c=M0a(a)|0;i=b;return c|0}function J0a(a){a=a|0;var b=0,d=0;b=i;d=K0a((c[a>>2]|0)+16|0)|0;i=b;return d|0}function K0a(a){a=a|0;var b=0,c=0;b=i;c=L0a(a)|0;i=b;return c|0}function L0a(a){a=a|0;i=i;return a|0}function M0a(a){a=a|0;i=i;return a|0}function N0a(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(O0a(a,b)|0)^1;i=c;return d|0}function O0a(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function P0a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];Y0a(a,e);i=d;return}function Q0a(a,b){a=a|0;b=b|0;var c=0;c=i;R0a(a,S0a(b)|0);i=c;return}function R0a(a,b){a=a|0;b=b|0;var c=0;c=i;X0a(a,b);i=c;return}function S0a(a){a=a|0;var b=0,c=0;b=i;c=T0a(U0a(a+4|0)|0)|0;i=b;return c|0}function T0a(a){a=a|0;var b=0,c=0;b=i;c=W0a(a)|0;i=b;return c|0}function U0a(a){a=a|0;var b=0,c=0;b=i;c=V0a(a)|0;i=b;return c|0}function V0a(a){a=a|0;i=i;return a|0}function W0a(a){a=a|0;i=i;return a|0}function X0a(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function Y0a(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function Z0a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=$0a(b)|0;_0a(f,b,d,h,S0a(b)|0);Q0a(g,b);do{if(N0a(f,g)|0){h=a1a(b)|0;if(b1a(h,d,c1a(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);Q0a(a,b);i=e;return}function _0a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;g1a(h);a:do{if((e|0)==0){j=f}else{k=a1a(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(h1a(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;g1a(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;g1a(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);R0a(a,j);i=g;return}function $0a(a){a=a|0;var b=0,d=0;b=i;d=c[(S0a(a)|0)>>2]|0;i=b;return d|0}function a1a(a){a=a|0;var b=0,c=0;b=i;c=e1a(a+8|0)|0;i=b;return c|0}function b1a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=d1a(0,b,c)|0;i=a;return d|0}function c1a(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function d1a(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)<(c[d>>2]|0)|0}function e1a(a){a=a|0;var b=0,c=0;b=i;c=f1a(a)|0;i=b;return c|0}function f1a(a){a=a|0;i=i;return a|0}function g1a(a){a=a|0;var b=0;b=i;i1a(a,-1);i=b;return}function h1a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=d1a(0,b,c)|0;i=a;return d|0}function i1a(a,b){a=a|0;b=b|0;b=i;j1a(a,0);i=b;return}function j1a(a,b){a=a|0;b=b|0;c[a>>2]=0;i=i;return}function k1a(a){a=a|0;i=i;return c[a+4>>2]|0}function l1a(a){a=a|0;var b=0,c=0;b=i;c=m1a(a+8|0)|0;i=b;return c|0}function m1a(a){a=a|0;var b=0,c=0;b=i;c=n1a(a)|0;i=b;return c|0}function n1a(a){a=a|0;i=i;return a|0}function o1a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=a+64|0;if((c[f>>2]|0)!=0){g=0;i=e;return g|0}switch(d&-3|0){case 28:{h=282096;break};case 52:case 20:{h=282072;break};case 24:{h=282048;break};case 56:{h=282056;break};case 5:case 21:{h=282080;break};case 1:case 17:{h=282032;break};case 8:{h=282040;break};case 60:{h=282104;break};case 12:{h=282088;break};case 9:case 25:{h=282064;break};case 48:case 16:{h=282024;break};case 13:case 29:{h=282112;break};default:{g=0;i=e;return g|0}}if((a|0)==0){g=0;i=e;return g|0}j=mc(b|0,h|0)|0;c[f>>2]=j;if((j|0)==0){g=0;i=e;return g|0}c[a+88>>2]=d;if((d&2|0)==0){g=a;i=e;return g|0}if((Zc(j|0,0,2)|0)==0){g=a;i=e;return g|0}ad(c[f>>2]|0)|0;c[f>>2]=0;g=0;i=e;return g|0}function p1a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=b;c[e+4>>2]=d;i=i;return}function q1a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a+64|0;f=c[e>>2]|0;if((f|0)==0){g=0;i=b;return g|0}r1a(d,f,102);f=pe[c[(c[a>>2]|0)+24>>2]&127](a)|0;if((ad(s1a(d)|0)|0)==0){c[e>>2]=0;h=(f|0)==0?a:0}else{h=0}t1a(d);g=h;i=b;return g|0}function r1a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;A1a(a,b,c);i=d;return}function s1a(a){a=a|0;var b=0,d=0;b=i;d=w1a(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function t1a(a){a=a|0;var b=0;b=i;u1a(a);i=b;return}function u1a(a){a=a|0;var b=0;b=i;v1a(a,0);i=b;return}function v1a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=w1a(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}pe[c[(x1a(e)|0)>>2]&127](f)|0;i=d;return}function w1a(a){a=a|0;var b=0,c=0;b=i;c=z1a(a)|0;i=b;return c|0}function x1a(a){a=a|0;var b=0,c=0;b=i;c=y1a(a)|0;i=b;return c|0}function y1a(a){a=a|0;i=i;return a+4|0}function z1a(a){a=a|0;i=i;return a|0}function A1a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;d=c[(C1a(f)|0)>>2]|0;B1a(a,d,c[(D1a(g)|0)>>2]|0);i=e;return}function B1a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;E1a(a,b,c);i=d;return}function C1a(a){a=a|0;i=i;return a|0}function D1a(a){a=a|0;i=i;return a|0}function E1a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;d=c[(G1a(f)|0)>>2]|0;F1a(a,d,c[(H1a(g)|0)>>2]|0);i=e;return}function F1a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;c[a>>2]=c[(G1a(f)|0)>>2];c[a+4>>2]=c[(H1a(g)|0)>>2];i=e;return}function G1a(a){a=a|0;i=i;return a|0}function H1a(a){a=a|0;i=i;return a|0}function I1a(a){a=a|0;var b=0,d=0;b=i;d=a+8|0;J=c[d+4>>2]|0;i=b;return c[d>>2]|0}function J1a(a){a=a|0;var b=0;b=i;K1a(a+300|0);K1a(a+288|0);K1a(a+276|0);K1a(a+264|0);K1a(a+252|0);K1a(a+240|0);L1a(a);i=b;return}function K1a(a){a=a|0;var b=0;b=i;v2a(a);i=b;return}function L1a(a){a=a|0;var b=0;b=i;M1a(a,282168);Jgb(a+104|0);i=b;return}function M1a(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];Q1a(a+4|0);i=d;return}function N1a(a){a=a|0;var b=0;b=i;L1a(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function O1a(a){a=a|0;var b=0;b=i;L1a(a);cqb(a);i=b;return}function P1a(a){a=a|0;var b=0;b=i;O1a(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function Q1a(a){a=a|0;var b=0;b=i;R1a(a);i=b;return}function R1a(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=282296;q1a(b)|0;do{if((a[b+96|0]|0)!=0){e=c[b+32>>2]|0;if((e|0)==0){break}dqb(e)}}while(0);do{if((a[b+97|0]|0)!=0){e=c[b+56>>2]|0;if((e|0)==0){break}dqb(e)}}while(0);Sgb(b);i=d;return}function S1a(a){a=a|0;var b=0;b=i;Q1a(a);cqb(a);i=b;return}function T1a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;pe[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=t2a(d)|0;c[b+68>>2]=f;d=b+98|0;g=a[d]|0;h=u2a(f)|0;a[d]=h&1;if((g&255|0)==(h&1|0)){i=e;return}h=b;ahb(h,0,0,0);fhb(h,0,0);h=b+96|0;g=(a[h]|0)!=0;if((a[d]|0)!=0){d=b+32|0;do{if(g){f=c[d>>2]|0;if((f|0)==0){break}dqb(f)}}while(0);f=b+97|0;a[h]=a[f]|0;j=b+60|0;c[b+52>>2]=c[j>>2];k=b+56|0;c[d>>2]=c[k>>2];c[j>>2]=0;c[k>>2]=0;a[f]=0;i=e;return}do{if(!g){f=b+32|0;k=c[f>>2]|0;if((k|0)==(b+44|0)){break}j=c[b+52>>2]|0;c[b+60>>2]=j;c[b+56>>2]=k;a[b+97|0]=0;c[f>>2]=bqb(j)|0;a[h]=1;i=e;return}}while(0);h=c[b+52>>2]|0;c[b+60>>2]=h;c[b+56>>2]=bqb(h)|0;a[b+97|0]=1;i=e;return}function U1a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=f;h=f+8|0;c[g>>2]=e;e=b;ahb(e,0,0,0);fhb(e,0,0);j=b+96|0;do{if((a[j]|0)!=0){k=c[b+32>>2]|0;if((k|0)==0){break}dqb(k)}}while(0);k=b+97|0;do{if((a[k]|0)!=0){l=c[b+56>>2]|0;if((l|0)==0){break}dqb(l)}}while(0);l=c[g>>2]|0;m=b+52|0;c[m>>2]=l;do{if(l>>>0>8){n=a[b+98|0]|0;if(n<<24>>24==0|(d|0)==0){c[b+32>>2]=bqb(l)|0;a[j]=1;o=n;break}else{c[b+32>>2]=d;a[j]=0;o=n;break}}else{c[b+32>>2]=b+44;c[m>>2]=8;a[j]=0;o=a[b+98|0]|0}}while(0);if(!(o<<24>>24==0)){c[b+60>>2]=0;c[b+56>>2]=0;a[k]=0;i=f;return e|0}c[h>>2]=8;o=c[(q2a(g,h)|0)>>2]|0;c[b+60>>2]=o;if((d|0)!=0&o>>>0>7){c[b+56>>2]=d;a[k]=0;i=f;return e|0}else{c[b+56>>2]=bqb(o)|0;a[k]=1;i=f;return e|0}return 0}function V1a(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+32|0;h=g;j=g+8|0;k=g+24|0;l=k;m=c[b+68>>2]|0;if((m|0)==0){n=Hc(4)|0;Bpb(n);_d(n|0,329688,128)}n=m2a(m)|0;m=b+64|0;do{if((c[m>>2]|0)!=0){o=(n|0)>0;if(!(o|(d|0)==0&(e|0)==0)){break}if((pe[c[(c[b>>2]|0)+24>>2]&127](b)|0)!=0){break}if(!(f>>>0<3)){u0a(a,-1,-1);i=g;return}p=c[m>>2]|0;if(o){o=Rqb(n|0,((n|0)<0)<<31>>31|0,d|0,e|0)|0;q=o}else{q=0}if((Zc(p|0,q|0,f|0)|0)==0){p=Bb(c[m>>2]|0)|0;u0a(j,p,((p|0)<0)<<31>>31);p=b+72|0;o=c[p+4>>2]|0;r=k;c[r>>2]=c[p>>2];c[r+4>>2]=o;o=h;r=l;c[o+0>>2]=c[r+0>>2];c[o+4>>2]=c[r+4>>2];p2a(j,h);r=a;o=j;c[r+0>>2]=c[o+0>>2];c[r+4>>2]=c[o+4>>2];c[r+8>>2]=c[o+8>>2];c[r+12>>2]=c[o+12>>2];i=g;return}else{u0a(a,-1,-1);i=g;return}}}while(0);u0a(a,-1,-1);i=g;return}function W1a(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=f;h=b+64|0;do{if((c[h>>2]|0)!=0){if((pe[c[(c[b>>2]|0)+24>>2]&127](b)|0)!=0){break}j=c[h>>2]|0;k=I1a(d)|0;if((Zc(j|0,k|0,0)|0)==0){o2a(g,d);k=f;j=c[k+4>>2]|0;l=b+72|0;c[l>>2]=c[k>>2];c[l+4>>2]=j;j=a;l=d;c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];c[j+12>>2]=c[l+12>>2];i=e;return}else{u0a(a,-1,-1);i=e;return}}}while(0);u0a(a,-1,-1);i=e;return}function X1a(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d;f=d+8|0;g=f;h=b+64|0;if((c[h>>2]|0)==0){j=0;i=d;return j|0}k=b+68|0;l=c[k>>2]|0;if((l|0)==0){m=Hc(4)|0;Bpb(m);_d(m|0,329688,128)}m=b+92|0;n=c[m>>2]|0;do{if((n&16|0)==0){if((n&8|0)==0){break}o=b+80|0;p=c[o+4>>2]|0;q=f;c[q>>2]=c[o>>2];c[q+4>>2]=p;do{if((a[b+98|0]|0)==0){p=m2a(l)|0;q=b+36|0;o=c[q>>2]|0;r=(c[b+40>>2]|0)-o|0;s=b;if((p|0)>0){t=_gb(s)|0;u=(fa(t-(Zgb(s)|0)|0,p)|0)+r|0;v=0;break}p=Zgb(s)|0;if((p|0)==(_gb(s)|0)){u=r;v=0;break}t=c[k>>2]|0;w=b+32|0;x=c[w>>2]|0;y=n2a(t,g,x,o,p-(Ygb(s)|0)|0)|0;u=r-y+(c[q>>2]|0)-(c[w>>2]|0)|0;v=1}else{w=b;q=_gb(w)|0;u=q-(Zgb(w)|0)|0;v=0}}while(0);if((Zc(c[h>>2]|0,0-u|0,1)|0)!=0){j=-1;i=d;return j|0}if(v){w=f;q=c[w+4>>2]|0;y=b+72|0;c[y>>2]=c[w>>2];c[y+4>>2]=q}q=c[b+32>>2]|0;c[b+40>>2]=q;c[b+36>>2]=q;ahb(b,0,0,0);c[m>>2]=0}else{q=b;y=chb(q)|0;do{if((y|0)!=(bhb(q)|0)){if((Ee[c[(c[b>>2]|0)+52>>2]&63](b,-1)|0)==-1){j=-1}else{break}i=d;return j|0}}while(0);q=b+72|0;y=b+32|0;w=b+52|0;while(1){r=c[y>>2]|0;s=l2a(c[k>>2]|0,q,r,r+(c[w>>2]|0)|0,e)|0;r=c[y>>2]|0;p=(c[e>>2]|0)-r|0;if((uc(r|0,1,p|0,c[h>>2]|0)|0)!=(p|0)){j=-1;z=23;break}if((s|0)==2){j=-1;z=23;break}else if((s|0)!=1){z=10;break}}if((z|0)==10){if((Bd(c[h>>2]|0)|0)==0){break}else{j=-1}i=d;return j|0}else if((z|0)==23){i=d;return j|0}}}while(0);j=0;i=d;return j|0}function Y1a(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+32|0;k=d+40|0;l=b+64|0;if((c[l>>2]|0)==0){m=-1;i=d;return m|0}n=g2a(b)|0;o=b;if((Zgb(o)|0)==0){p=e+1|0;ahb(o,e,p,p)}if(n){q=0}else{n=_gb(o)|0;c[f>>2]=(n-(Ygb(o)|0)|0)/2|0;c[g>>2]=4;q=c[(h2a(f,g)|0)>>2]|0}g=Zgb(o)|0;do{if((g|0)==(_gb(o)|0)){Bqb(Ygb(o)|0,g+(0-q)|0,q|0)|0;if((a[b+98|0]|0)!=0){f=_gb(o)|0;n=Ygb(o)|0;p=vb(n+q|0,1,f-q-n|0,c[l>>2]|0)|0;if((p|0)==0){r=-1;break}n=Ygb(o)|0;ahb(o,n,n+q|0,n+(p+q)|0);r=e2a(a[Zgb(o)|0]|0)|0;break}p=b+32|0;n=b+36|0;f=c[n>>2]|0;s=b+40|0;Bqb(c[p>>2]|0,f|0,(c[s>>2]|0)-f|0)|0;f=c[p>>2]|0;t=f+((c[s>>2]|0)-(c[n>>2]|0))|0;c[n>>2]=t;if((f|0)==(b+44|0)){u=8}else{u=c[b+52>>2]|0}v=f+u|0;c[s>>2]=v;f=b+60|0;c[h>>2]=(c[f>>2]|0)-q;c[j>>2]=v-t;v=c[(h2a(h,j)|0)>>2]|0;w=b+72|0;x=w;y=c[x+4>>2]|0;z=b+80|0;c[z>>2]=c[x>>2];c[z+4>>2]=y;y=vb(t|0,1,v|0,c[l>>2]|0)|0;if((y|0)==0){r=-1;break}v=c[b+68>>2]|0;if((v|0)==0){t=Hc(4)|0;Bpb(t);_d(t|0,329688,128)}t=(c[n>>2]|0)+y|0;c[s>>2]=t;y=c[p>>2]|0;z=Ygb(o)|0;if((i2a(v,w,y,t,n,z+q|0,z+(c[f>>2]|0)|0,k)|0)==3){f=c[p>>2]|0;ahb(o,f,f,c[s>>2]|0);r=e2a(a[Zgb(o)|0]|0)|0;break}s=c[k>>2]|0;f=Ygb(o)|0;p=f+q|0;if((s|0)==(p|0)){r=-1;break}ahb(o,f,p,s);r=e2a(a[Zgb(o)|0]|0)|0}else{r=e2a(a[g]|0)|0}}while(0);if((Ygb(o)|0)!=(e|0)){m=r;i=d;return m|0}ahb(o,0,0,0);m=r;i=d;return m|0}function Z1a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[b+64>>2]|0)==0){f=-1;i=e;return f|0}g=b;h=Ygb(g)|0;j=Zgb(g)|0;if(!(h>>>0<j>>>0)){f=-1;i=e;return f|0}if(a2a(d,-1)|0){$gb(g,-1);f=d2a(d)|0;i=e;return f|0}h=(c[b+88>>2]&16|0)==0;b=b2a(d)|0;do{if(h){if(f2a(b,a[j+ -1|0]|0)|0){break}else{f=-1}i=e;return f|0}}while(0);$gb(g,-1);a[Zgb(g)|0]=b;f=d;i=e;return f|0}function _1a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;j=b+64|0;if((c[j>>2]|0)==0){k=-1;i=e;return k|0}$1a(b);l=b;m=bhb(l)|0;n=dhb(l)|0;if(!(a2a(d,-1)|0)){if((chb(l)|0)==0){fhb(l,f,f+1|0)}f=b2a(d)|0;a[chb(l)|0]=f;ehb(l,1)}f=chb(l)|0;o=bhb(l)|0;if((f|0)!=(o|0)){a:do{if((a[b+98|0]|0)==0){p=b+32|0;q=c[p>>2]|0;c[g>>2]=q;r=b+68|0;s=c[r>>2]|0;if((s|0)==0){t=Hc(4)|0;u=t;Bpb(u);v=329688;w=128;_d(t|0,v|0,w|0)}x=b+72|0;y=b+52|0;z=q;q=s;while(1){s=bhb(l)|0;A=chb(l)|0;B=c2a(q,x,s,A,h,z,z+(c[y>>2]|0)|0,g)|0;A=c[h>>2]|0;C=bhb(l)|0;if((A|0)==(C|0)){k=-1;D=22;break}if((B|0)==3){D=14;break}if(!(B>>>0<2)){k=-1;D=22;break}A=c[p>>2]|0;s=(c[g>>2]|0)-A|0;if((uc(A|0,1,s|0,c[j>>2]|0)|0)!=(s|0)){k=-1;D=22;break}if((B|0)!=1){break a}B=c[h>>2]|0;fhb(l,B,chb(l)|0);B=dhb(l)|0;ehb(l,B-(bhb(l)|0)|0);B=c[r>>2]|0;if((B|0)==0){D=11;break}z=c[p>>2]|0;q=B}if((D|0)==11){t=Hc(4)|0;u=t;Bpb(u);v=329688;w=128;_d(t|0,v|0,w|0)}else if((D|0)==14){q=(chb(l)|0)-C|0;if((uc(C|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}else if((D|0)==22){i=e;return k|0}}else{q=f-o|0;if((uc(o|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}}while(0);fhb(l,m,n)}k=d2a(d)|0;i=e;return k|0}function $1a(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=b+92|0;if((c[e>>2]&16|0)!=0){i=d;return}f=b;ahb(f,0,0,0);g=c[b+52>>2]|0;do{if(g>>>0>8){if((a[b+98|0]|0)==0){h=c[b+56>>2]|0;fhb(f,h,h+((c[b+60>>2]|0)+ -1)|0);break}else{h=c[b+32>>2]|0;fhb(f,h,h+(g+ -1)|0);break}}else{fhb(f,0,0)}}while(0);c[e>>2]=16;i=d;return}function a2a(a,b){a=a|0;b=b|0;i=i;return(a|0)==(b|0)|0}function b2a(a){a=a|0;i=i;return a&255|0}function c2a(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=Ne[c[(c[a>>2]|0)+12>>2]&15](a,b,d,e,f,g,h,j)|0;i=k;return l|0}function d2a(a){a=a|0;var b=0,c=0;b=i;c=a2a(a,-1)|0;i=b;return(c?0:a)|0}function e2a(a){a=a|0;i=i;return a&255|0}function f2a(a,b){a=a|0;b=b|0;i=i;return a<<24>>24==b<<24>>24|0}function g2a(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+92|0;if((c[e>>2]&8|0)!=0){f=0;i=d;return f|0}g=b;fhb(g,0,0);if((a[b+98|0]|0)==0){h=c[b+56>>2]|0;j=h+(c[b+60>>2]|0)|0;ahb(g,h,j,j)}else{j=c[b+32>>2]|0;h=j+(c[b+52>>2]|0)|0;ahb(g,j,h,h)}c[e>>2]=8;f=1;i=d;return f|0}function h2a(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=j2a(b,c,e)|0;i=d;return g|0}function i2a(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=Ne[c[(c[a>>2]|0)+16>>2]&15](a,b,d,e,f,g,h,j)|0;i=k;return l|0}function j2a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=k2a(0,b,a)|0;i=c;return(d?b:a)|0}function k2a(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)>>>0<(c[d>>2]|0)>>>0|0}function l2a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=Fe[c[(c[a>>2]|0)+20>>2]&63](a,b,d,e,f)|0;i=g;return h|0}function m2a(a){a=a|0;var b=0,d=0;b=i;d=pe[c[(c[a>>2]|0)+24>>2]&127](a)|0;i=b;return d|0}function n2a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=Fe[c[(c[a>>2]|0)+32>>2]&63](a,b,d,e,f)|0;i=g;return h|0}function o2a(a,b){a=a|0;b=b|0;var d=0,e=0;d=b;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;i=i;return}function p2a(a,b){a=a|0;b=b|0;var d=0,e=0;d=b;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;i=i;return}function q2a(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=r2a(b,c,e)|0;i=d;return g|0}function r2a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=s2a(0,a,b)|0;i=c;return(d?b:a)|0}function s2a(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)<(c[d>>2]|0)|0}function t2a(a){a=a|0;var b=0,c=0;b=i;c=Bmb(a,314192)|0;i=b;return c|0}function u2a(a){a=a|0;var b=0,d=0;b=i;d=pe[c[(c[a>>2]|0)+28>>2]&127](a)|0;i=b;return d|0}function v2a(a){a=a|0;var b=0;b=i;w2a(a);i=b;return}function w2a(a){a=a|0;var b=0;b=i;x2a(a);i=b;return}function x2a(a){a=a|0;var b=0;b=i;y2a(a,$0a(a)|0);i=b;return}function y2a(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+8|0;g1a(d);if((b|0)==0){i=d;return}y2a(a,c[b>>2]|0);y2a(a,c[b+4>>2]|0);A2a(z2a(a)|0,b,1);i=d;return}function z2a(a){a=a|0;var b=0,c=0;b=i;c=C2a(a+4|0)|0;i=b;return c|0}function A2a(a,b,c){a=a|0;b=b|0;c=c|0;c=i;B2a(0,b,0);i=c;return}function B2a(a,b,c){a=a|0;b=b|0;c=c|0;c=i;cqb(b);i=c;return}function C2a(a){a=a|0;var b=0,c=0;b=i;c=D2a(a)|0;i=b;return c|0}function D2a(a){a=a|0;i=i;return a|0}function E2a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=F2a(a,f,b)|0;l=c[k>>2]|0;g1a(d+16|0);if((l|0)!=0){m=l;n=m;o=n+20|0;p=o;i=d;return p|0}H2a(j,a,b);I2a(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];G2a(g,e);J2a(j);j=c[f>>2]|0;K2a(a,j,k,L2a(g)|0);k=M2a(g)|0;J2a(g);m=k;n=m;o=n+20|0;p=o;i=d;return p|0}function F2a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=$0a(h)|0;g1a(e);if((a|0)==0){j=S0a(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(d1a(0,d,a)|0){m=l;j=c[m>>2]|0;g1a(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(d1a(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;g1a(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function G2a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];y3a(a,e);i=d;return}function H2a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=z2a(d)|0;d=h3a(n,1)|0;i3a(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];g3a(j,d,h);j3a(0,c3a((k3a(j)|0)+16|0)|0,e);e=l3a(j)|0;a[e+4|0]=1;m3a(0,b3a((k3a(j)|0)+20|0)|0);a[e+5|0]=1;n3a(m,j);I2a(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];G2a(b,g);J2a(m);J2a(j);i=f;return}function I2a(a,b){a=a|0;b=b|0;var c=0;c=i;e3a(a,b);i=c;return}function J2a(a){a=a|0;var b=0;b=i;Z2a(a);i=b;return}function K2a(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;g1a(f);c[e>>2]=0;g1a(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=R2a(a)|0;b=c[c[e>>2]>>2]|0;g1a(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(S0a(a)|0)>>2]|0;S2a(e,c[d>>2]|0);d=T2a(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function L2a(a){a=a|0;var b=0,d=0;b=i;d=c[(P2a(a)|0)>>2]|0;i=b;return d|0}function M2a(a){a=a|0;var b=0,d=0;b=i;d=N2a(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function N2a(a){a=a|0;var b=0,c=0;b=i;c=O2a(a)|0;i=b;return c|0}function O2a(a){a=a|0;i=i;return a|0}function P2a(a){a=a|0;var b=0,c=0;b=i;c=Q2a(a)|0;i=b;return c|0}function Q2a(a){a=a|0;i=i;return a|0}function R2a(a){a=a|0;i=i;return a|0}function S2a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=e+8|0;h=(d|0)==(b|0);a[d+12|0]=h&1;if(h){i=e;return}else{j=d}while(1){k=j+8|0;d=c[k>>2]|0;if((a[d+12|0]|0)!=0){l=17;break}h=W2a(d)|0;m=c[d+8>>2]|0;if(h){h=c[m+4>>2]|0;g1a(f);if((h|0)==0){l=7;break}d=h+12|0;if((a[d]|0)!=0){l=7;break}h=c[k>>2]|0;a[h+12|0]=1;n=c[h+8>>2]|0;a[n+12|0]=(n|0)==(b|0)|0;a[d]=1;o=n}else{n=c[m>>2]|0;g1a(g);if((n|0)==0){l=14;break}m=n+12|0;if((a[m]|0)!=0){l=14;break}n=c[k>>2]|0;a[n+12|0]=1;d=c[n+8>>2]|0;a[d+12|0]=(d|0)==(b|0)|0;a[m]=1;o=d}if((o|0)==(b|0)){l=17;break}else{j=o}}if((l|0)==7){if(W2a(j)|0){p=j}else{o=c[k>>2]|0;X2a(o);p=o}o=c[p+8>>2]|0;a[o+12|0]=1;p=c[o+8>>2]|0;a[p+12|0]=0;Y2a(p);i=e;return}else if((l|0)==14){if(W2a(j)|0){p=c[k>>2]|0;Y2a(p);q=p}else{q=j}j=c[q+8>>2]|0;a[j+12|0]=1;q=c[j+8>>2]|0;a[q+12|0]=0;X2a(q);i=e;return}else if((l|0)==17){i=e;return}}function T2a(a){a=a|0;var b=0,c=0;b=i;c=U2a(a+8|0)|0;i=b;return c|0}function U2a(a){a=a|0;var b=0,c=0;b=i;c=V2a(a)|0;i=b;return c|0}function V2a(a){a=a|0;i=i;return a|0}function W2a(a){a=a|0;i=i;return(c[c[a+8>>2]>>2]|0)==(a|0)|0}function X2a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=a+4|0;e=c[d>>2]|0;f=e;g=c[f>>2]|0;c[d>>2]=g;g1a(b);if((g|0)!=0){c[(c[d>>2]|0)+8>>2]=a}d=a+8|0;c[e+8>>2]=c[d>>2];g=W2a(a)|0;h=c[d>>2]|0;if(g){c[h>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}else{c[h+4>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}}function Y2a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=a;e=c[d>>2]|0;f=e+4|0;g=c[f>>2]|0;c[d>>2]=g;g1a(b);if((g|0)!=0){c[(c[d>>2]|0)+8>>2]=a}d=a+8|0;c[e+8>>2]=c[d>>2];g=W2a(a)|0;h=c[d>>2]|0;if(g){c[h>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}else{c[h+4>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}}function Z2a(a){a=a|0;var b=0;b=i;_2a(a,0);i=b;return}function _2a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=N2a(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}a3a($2a(e)|0,f);i=d;return}function $2a(a){a=a|0;var b=0,c=0;b=i;c=d3a(a)|0;i=b;return c|0}function a3a(a,b){a=a|0;b=b|0;var d=0;d=i;if((b|0)==0){i=d;return}A2a(c[a>>2]|0,b,1);i=d;return}function b3a(a){a=a|0;i=i;return a|0}function c3a(a){a=a|0;i=i;return a|0}function d3a(a){a=a|0;i=i;return a+4|0}function e3a(a,b){a=a|0;b=b|0;var c=0;c=i;f3a(a,b);i=c;return}function f3a(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function g3a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];q3a(a,b,f);i=e;return}function h3a(a,b){a=a|0;b=b|0;var c=0;a=i;c=p3a(0,b,0)|0;i=a;return c|0}function i3a(a,b){a=a|0;b=b|0;var c=0;c=i;o3a(a,b);i=c;return}function j3a(a,b,d){a=a|0;b=b|0;d=d|0;if((b|0)!=0){c[b>>2]=c[d>>2]}i=i;return}function k3a(a){a=a|0;var b=0,d=0;b=i;d=c[(P2a(a)|0)>>2]|0;i=b;return d|0}function l3a(a){a=a|0;var b=0,c=0;b=i;c=$2a(a)|0;i=b;return c|0}function m3a(a,b){a=a|0;b=b|0;if((b|0)!=0){c[b>>2]=0}i=i;return}function n3a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;e3a(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];G2a(h,f);I2a(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];G2a(a,e);J2a(h);i=d;return}function o3a(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function p3a(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=aqb(b*24|0)|0;i=c;return a|0}function q3a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(s3a(g)|0)>>2]|0;g=t3a(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];r3a(b,a,f);i=e;return}function r3a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];u3a(a,b,f);i=e;return}function s3a(a){a=a|0;i=i;return a|0}function t3a(a){a=a|0;i=i;return a|0}function u3a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(w3a(g)|0)>>2]|0;g=x3a(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];v3a(b,a,f);i=e;return}function v3a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(w3a(f)|0)>>2];f=x3a(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function w3a(a){a=a|0;i=i;return a|0}function x3a(a){a=a|0;i=i;return a|0}function y3a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=M2a(z3a(b)|0)|0;h=x3a(l3a(z3a(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];r3a(g,a,e);i=d;return}function z3a(a){a=a|0;i=i;return c[a>>2]|0}function A3a(a){a=a|0;var b=0;b=i;i=i+48|0;B3a(a);u0a(a+184|0,0,0);u0a(a+200|0,0,0);C3a(a+240|0,b);C3a(a+252|0,b+8|0);C3a(a+264|0,b+16|0);C3a(a+276|0,b+24|0);C3a(a+288|0,b+32|0);C3a(a+300|0,b+40|0);i=b;return}function B3a(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+104|0;Ogb(d);e=a;c[e>>2]=282140;f=d;c[f>>2]=282160;d=a+4|0;Vhb(a,282172|0,d);c[e>>2]=282140;c[f>>2]=282160;P3a(d);i=b;return}function C3a(a,b){a=a|0;b=b|0;b=i;D3a(a,0);i=b;return}function D3a(a,b){a=a|0;b=b|0;b=i;i=i+8|0;E3a(a,b);i=b;return}function E3a(a,b){a=a|0;b=b|0;b=i;F3a(a,0);i=b;return}function F3a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;G3a(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;H3a(f,0,e);e=S0a(b)|0;c[(R2a(b)|0)>>2]=e;i=d;return}function G3a(a){a=a|0;var b=0;b=i;L3a(a);i=b;return}function H3a(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;I3a(b,c,f);i=e;return}function I3a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(K3a(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;J3a(d,b,f);i=e;return}function J3a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(K3a(e)|0)>>2];i=d;return}function K3a(a){a=a|0;i=i;return a|0}function L3a(a){a=a|0;var b=0;b=i;M3a(a);i=b;return}function M3a(a){a=a|0;var b=0;b=i;N3a(a);i=b;return}function N3a(a){a=a|0;var b=0;b=i;O3a(a);i=b;return}function O3a(a){a=a|0;c[a>>2]=0;i=i;return}function P3a(a){a=a|0;var b=0;b=i;Q3a(a);i=b;return}function Q3a(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;j=d;Xgb(j);c[d>>2]=282296;c[d+32>>2]=0;c[d+36>>2]=0;c[d+40>>2]=0;k=d+68|0;l=d+52|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;g1a(f);f=d+98|0;l=k;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[l+20>>2]=0;c[l+24>>2]=0;b[l+28>>1]=0;a[l+30|0]=0;Tgb(g,j);l=R3a(g)|0;zmb(g);if(!l){m=d;n=c[d>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=se[r&63](d,0,4096)|0;i=e;return}Tgb(h,j);c[k>>2]=t2a(h)|0;zmb(h);a[f]=(u2a(c[k>>2]|0)|0)&1;m=d;n=c[d>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=se[r&63](d,0,4096)|0;i=e;return}function R3a(a){a=a|0;var b=0,c=0;b=i;c=Amb(a,314192)|0;i=b;return c|0}function S3a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+8|0;e=d;f=c[a+12>>2]|0;CYa(3);g=f+8|0;h=g;j=c[g>>2]|0;g=f+12|0;k=c[g>>2]|0;if((j|0)<(k|0)){T3a(a,b,c[f>>2]|0,h);FYa(3);i=d;return}l=~~(+(k|0)*1.4+ +(k-j|0)+2.0e3);c[g>>2]=l;j=f+16|0;k=Zpb(c[f>>2]|0,fa(l<<3,c[j>>2]|0)|0)|0;l=k;c[f>>2]=l;if((k|0)==0){k=c[b+536>>2]|0;c[e>>2]=fa(c[j>>2]|0,c[g>>2]|0)|0;oXa(k,282568,e)}T3a(a,b,l,h);FYa(3);i=d;return}function T3a(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;g=i;j=c[b+12>>2]|0;FYa(0);k=+xYa(0);CYa(0);l=c[c[d+4>>2]>>2]|0;m=l;n=+h[m>>3];o=j+4|0;j=c[o>>2]|0;p=j+1|0;c[o>>2]=p;h[e+(j<<3)>>3]=n;if((c[b+8>>2]|0)==0){q=p}else{b=j+2|0;c[o>>2]=b;h[e+(p<<3)>>3]=k;q=b}b=d+116|0;p=c[b>>2]|0;if((p|0)>0){j=c[d+8>>2]|0;r=p;p=q;s=0;while(1){if((a[j+(s*112|0)+104|0]|0)==0){k=+h[(c[l+8>>2]|0)+(s<<3)>>3];t=p+1|0;c[o>>2]=t;h[e+(p<<3)>>3]=k;u=c[b>>2]|0;v=t}else{u=r;v=p}t=s+1|0;if((t|0)<(u|0)){r=u;p=v;s=t}else{w=v;break}}}else{w=q}q=d+124|0;v=c[q>>2]|0;if((v|0)>0){s=c[d+12>>2]|0;p=v;v=w;u=0;while(1){if((a[s+(u*60|0)+56|0]|0)==0){k=+(c[(c[l+12>>2]|0)+(u<<2)>>2]|0);r=v+1|0;c[o>>2]=r;h[e+(v<<3)>>3]=k;x=c[q>>2]|0;y=r}else{x=p;y=v}r=u+1|0;if((r|0)<(x|0)){p=x;v=y;u=r}else{z=y;break}}}else{z=w}w=d+128|0;y=c[w>>2]|0;if((y|0)>0){u=c[d+16>>2]|0;v=y;y=z;x=0;while(1){if((a[u+(x*48|0)+44|0]|0)==0){k=+(a[(c[l+16>>2]|0)+x|0]|0);p=y+1|0;c[o>>2]=p;h[e+(y<<3)>>3]=k;A=c[w>>2]|0;B=p}else{A=v;B=y}p=x+1|0;if((p|0)<(A|0)){v=A;y=B;x=p}else{C=B;break}}}else{C=z}z=d+216|0;if((c[z>>2]|0)>0){B=d+416|0;x=c[d+40>>2]|0;y=C;A=0;while(1){do{if((a[x+(A*52|0)+48|0]|0)==0){v=a[x+(A*52|0)+8|0]|0;do{if(v<<24>>24==2){D=m}else{w=c[x+(A*52|0)+4>>2]|0;if(v<<24>>24==1){D=(c[B>>2]|0)+(w<<3)|0;break}else{D=(c[l+8>>2]|0)+(w<<3)|0;break}}}while(0);k=+h[D>>3];if((c[x+(A*52|0)>>2]|0)==0){v=y+1|0;c[o>>2]=v;h[e+(y<<3)>>3]=k;E=v;break}else{v=y+1|0;c[o>>2]=v;h[e+(y<<3)>>3]=-k;E=v;break}}else{E=y}}while(0);v=A+1|0;if((v|0)<(c[z>>2]|0)){y=E;A=v}else{F=E;break}}}else{F=C}C=d+220|0;if((c[C>>2]|0)>0){E=d+40|0;A=d+420|0;y=c[d+44>>2]|0;z=F;x=0;while(1){do{if((a[y+(x*52|0)+48|0]|0)==0){D=c[(c[((a[y+(x*52|0)+8|0]|0)==1?A:l+12|0)>>2]|0)+(c[(c[E>>2]|0)+(x*52|0)+4>>2]<<2)>>2]|0;if((c[y+(x*52|0)>>2]|0)==0){B=z+1|0;c[o>>2]=B;h[e+(z<<3)>>3]=+(D|0);G=B;break}else{B=z+1|0;c[o>>2]=B;h[e+(z<<3)>>3]=+(0-D|0);G=B;break}}else{G=z}}while(0);B=x+1|0;if((B|0)<(c[C>>2]|0)){z=G;x=B}else{H=G;break}}}else{H=F}F=d+224|0;if((c[F>>2]|0)<=0){I=c[f>>2]|0;J=I+1|0;c[f>>2]=J;i=g;return}G=d+44|0;x=d+40|0;z=d+424|0;C=c[d+48>>2]|0;d=H;H=0;while(1){do{if((a[C+(H*52|0)+48|0]|0)==0){y=a[(c[((a[(c[G>>2]|0)+(H*52|0)+8|0]|0)==1?z:l+16|0)>>2]|0)+(c[(c[x>>2]|0)+(H*52|0)+4>>2]|0)|0]|0;if((c[C+(H*52|0)>>2]|0)==0){E=d+1|0;c[o>>2]=E;h[e+(d<<3)>>3]=+(y<<24>>24);K=E;break}else{E=d+1|0;c[o>>2]=E;h[e+(d<<3)>>3]=+(y<<24>>24!=1|0);K=E;break}}else{K=d}}while(0);E=H+1|0;if((E|0)<(c[F>>2]|0)){d=K;H=E}else{break}}I=c[f>>2]|0;J=I+1|0;c[f>>2]=J;i=g;return}function U3a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=Wpb(24)|0;CYa(3);c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;j=g+16|0;c[j>>2]=0;k=a+4|0;l=c[k>>2]|0;c[g+12>>2]=l;m=b+536|0;nXa(c[m>>2]|0,l>>>31^1,282624,f);f=b+8|0;b=c[a+8>>2]|0;l=V3a(b,f)|0;c[g+20>>2]=l;l=V3a(b,f)|0;c[j>>2]=l;j=c[k>>2]|0;k=Wpb(fa(l<<3,j)|0)|0;c[g>>2]=k;if((k|0)==0){k=c[m>>2]|0;c[e>>2]=fa(l,j)|0;oXa(k,282704,e)}else{c[h>>2]=0;c[a+12>>2]=g;FYa(3);i=d;return}}function V3a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;f=(b|0)==0?1:2;b=c[d+108>>2]|0;if((b|0)>0){g=c[d>>2]|0;h=0;j=f;while(1){k=((a[g+(h*112|0)+104|0]|0)==0)+j|0;l=h+1|0;if((l|0)<(b|0)){j=k;h=l}else{m=k;break}}}else{m=f}f=c[d+116>>2]|0;if((f|0)>0){h=c[d+4>>2]|0;j=0;b=m;while(1){g=((a[h+(j*60|0)+56|0]|0)==0)+b|0;k=j+1|0;if((k|0)<(f|0)){b=g;j=k}else{n=g;break}}}else{n=m}m=c[d+120>>2]|0;if((m|0)>0){j=c[d+8>>2]|0;b=0;f=n;while(1){h=((a[j+(b*48|0)+44|0]|0)==0)+f|0;g=b+1|0;if((g|0)<(m|0)){f=h;b=g}else{o=h;break}}}else{o=n}n=c[d+208>>2]|0;if((n|0)>0){b=c[d+32>>2]|0;f=0;m=o;while(1){j=((a[b+(f*52|0)+48|0]|0)==0)+m|0;h=f+1|0;if((h|0)<(n|0)){m=j;f=h}else{p=j;break}}}else{p=o}o=c[d+212>>2]|0;if((o|0)>0){f=c[d+36>>2]|0;m=0;n=p;while(1){b=((a[f+(m*52|0)+48|0]|0)==0)+n|0;j=m+1|0;if((j|0)<(o|0)){n=b;m=j}else{q=b;break}}}else{q=p}p=c[d+216>>2]|0;if((p|0)<=0){r=q;i=e;return r|0}m=c[d+40>>2]|0;d=0;n=q;while(1){q=((a[m+(d*52|0)+48|0]|0)==0)+n|0;o=d+1|0;if((o|0)<(p|0)){n=q;d=o}else{r=q;break}}i=e;return r|0}function W3a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=b+12|0;s=c[r>>2]|0;t=s;CYa(3);u=b;v=mc(c[u>>2]|0,282768)|0;if((v|0)==0){X3a(t);w=c[d+536>>2]|0;x=c[u>>2]|0;y=be(c[(Qc()|0)>>2]|0)|0;c[q>>2]=x;c[q+4>>2]=y;oXa(w,282776,q)}uc(282832,46,1,v|0)|0;q=s+20|0;c[p>>2]=c[q>>2];Dd(v|0,282880,p|0)|0;p=s+8|0;c[o>>2]=c[p>>2];Dd(v|0,282904,o|0)|0;uc(282928,40,1,v|0)|0;uc(282976,11,1,v|0)|0;uc(282992,14,1,v|0)|0;if((c[p>>2]|0)>0){o=0;do{w=fa(c[q>>2]|0,o)|0;z=+h[(c[s>>2]|0)+(w<<3)>>3];Y3a(v,z,z);o=o+1|0;}while((o|0)<(c[p>>2]|0))}Zd(10,v|0)|0;if((c[b+8>>2]|0)==0){A=1}else{uc(283008,18,1,v|0)|0;if((c[p>>2]|0)>0){b=0;do{o=fa(c[q>>2]|0,b)|0;w=c[s>>2]|0;Y3a(v,+h[w+(o<<3)>>3],+h[w+(o+1<<3)>>3]);b=b+1|0;}while((b|0)<(c[p>>2]|0))}Zd(10,v|0)|0;A=2}b=d+116|0;o=c[b>>2]|0;if((o|0)>0){w=d+8|0;y=o;o=0;x=A;while(1){B=c[w>>2]|0;if((a[B+(o*112|0)+104|0]|0)==0){c[n>>2]=c[B+(o*112|0)+4>>2];Dd(v|0,283032,n|0)|0;if((c[p>>2]|0)>0){B=0;do{C=fa(c[q>>2]|0,B)|0;D=c[s>>2]|0;Y3a(v,+h[D+(C<<3)>>3],+h[D+(C+x<<3)>>3]);B=B+1|0;}while((B|0)<(c[p>>2]|0))}Zd(10,v|0)|0;E=c[b>>2]|0;F=x+1|0}else{E=y;F=x}B=o+1|0;if((B|0)<(E|0)){y=E;o=B;x=F}else{G=F;break}}}else{G=A}A=d+124|0;F=c[A>>2]|0;if((F|0)>0){x=d+12|0;o=F;F=0;E=G;while(1){y=c[x>>2]|0;if((a[y+(F*60|0)+56|0]|0)==0){c[m>>2]=c[y+(F*60|0)+4>>2];Dd(v|0,283032,m|0)|0;if((c[p>>2]|0)>0){y=0;do{b=fa(c[q>>2]|0,y)|0;n=c[s>>2]|0;Y3a(v,+h[n+(b<<3)>>3],+h[n+(b+E<<3)>>3]);y=y+1|0;}while((y|0)<(c[p>>2]|0))}Zd(10,v|0)|0;H=c[A>>2]|0;I=E+1|0}else{H=o;I=E}y=F+1|0;if((y|0)<(H|0)){o=H;F=y;E=I}else{J=I;break}}}else{J=G}G=d+128|0;I=c[G>>2]|0;if((I|0)>0){E=d+16|0;F=I;I=0;H=J;while(1){o=c[E>>2]|0;if((a[o+(I*48|0)+44|0]|0)==0){c[l>>2]=c[o+(I*48|0)+4>>2];Dd(v|0,283032,l|0)|0;if((c[p>>2]|0)>0){o=0;do{A=fa(c[q>>2]|0,o)|0;m=c[s>>2]|0;Y3a(v,+h[m+(A<<3)>>3],+h[m+(A+H<<3)>>3]);o=o+1|0;}while((o|0)<(c[p>>2]|0))}Zd(10,v|0)|0;K=c[G>>2]|0;L=H+1|0}else{K=F;L=H}o=I+1|0;if((o|0)<(K|0)){F=K;I=o;H=L}else{M=L;break}}}else{M=J}J=d+216|0;L=c[J>>2]|0;if((L|0)>0){H=d+40|0;I=L;L=0;K=M;while(1){F=c[H>>2]|0;if((a[F+(L*52|0)+48|0]|0)==0){c[k>>2]=c[F+(L*52|0)+16>>2];Dd(v|0,283032,k|0)|0;if((c[p>>2]|0)>0){F=0;do{G=fa(c[q>>2]|0,F)|0;l=c[s>>2]|0;Y3a(v,+h[l+(G<<3)>>3],+h[l+(G+K<<3)>>3]);F=F+1|0;}while((F|0)<(c[p>>2]|0))}Zd(10,v|0)|0;N=c[J>>2]|0;O=K+1|0}else{N=I;O=K}F=L+1|0;if((F|0)<(N|0)){I=N;L=F;K=O}else{P=O;break}}}else{P=M}M=d+220|0;O=c[M>>2]|0;if((O|0)>0){K=d+44|0;L=O;O=0;N=P;while(1){I=c[K>>2]|0;if((a[I+(O*52|0)+48|0]|0)==0){c[j>>2]=c[I+(O*52|0)+16>>2];Dd(v|0,283032,j|0)|0;if((c[p>>2]|0)>0){I=0;do{J=fa(c[q>>2]|0,I)|0;k=c[s>>2]|0;Y3a(v,+h[k+(J<<3)>>3],+h[k+(J+N<<3)>>3]);I=I+1|0;}while((I|0)<(c[p>>2]|0))}Zd(10,v|0)|0;Q=c[M>>2]|0;R=N+1|0}else{Q=L;R=N}I=O+1|0;if((I|0)<(Q|0)){L=Q;O=I;N=R}else{S=R;break}}}else{S=P}P=d+224|0;R=c[P>>2]|0;if((R|0)>0){N=d+48|0;O=R;R=0;Q=S;while(1){S=c[N>>2]|0;if((a[S+(R*52|0)+48|0]|0)==0){c[g>>2]=c[S+(R*52|0)+16>>2];Dd(v|0,283032,g|0)|0;if((c[p>>2]|0)>0){S=0;do{L=fa(c[q>>2]|0,S)|0;M=c[s>>2]|0;Y3a(v,+h[M+(L<<3)>>3],+h[M+(L+Q<<3)>>3]);S=S+1|0;}while((S|0)<(c[p>>2]|0))}Zd(10,v|0)|0;T=c[P>>2]|0;U=Q+1|0}else{T=O;U=Q}S=R+1|0;if((S|0)<(T|0)){O=T;R=S;Q=U}else{break}}}X3a(t);if((ad(v|0)|0)==0){Xpb(c[r>>2]|0);c[r>>2]=0;FYa(3);i=e;return}else{e=c[d+536>>2]|0;c[f>>2]=c[u>>2];oXa(e,283048,f)}}function X3a(a){a=a|0;var b=0,d=0;b=i;d=a;a=c[d>>2]|0;if((a|0)==0){i=b;return}Xpb(a);c[d>>2]=0;i=b;return}function Y3a(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=f;h[k>>3]=b;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=f+8|0;h[k>>3]=d;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];Dd(a|0,283096,f|0)|0;i=e;return}function Z3a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=aqb(192)|0;Cqb(m|0,0,192)|0;_3a(m);c[a+12>>2]=m;n=m;o=a;v0a(n,c[o>>2]|0,36);if(Cgb(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){a=c[b+536>>2]|0;c[g>>2]=c[o>>2];oXa(a,283136,g)}else{g=m;fib(g,283112,14)|0;gib(h,g);a=I1a(h)|0;h=m+184|0;c[h>>2]=a;fib(g,283128,4)|0;$3a(n,b+8|0);gib(j,g);b=I1a(j)|0;j=m+188|0;c[j>>2]=b;m=c[h>>2]|0;u0a(k,m,((m|0)<0)<<31>>31);h=f;a=k;c[h+0>>2]=c[a+0>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[h+12>>2]=c[a+12>>2];hib(g,f)|0;a4a(n,-4-m+b|0);b=c[j>>2]|0;u0a(l,b,((b|0)<0)<<31>>31);b=e;j=l;c[b+0>>2]=c[j+0>>2];c[b+4>>2]=c[j+4>>2];c[b+8>>2]=c[j+8>>2];c[b+12>>2]=c[j+12>>2];hib(g,e)|0;FYa(3);i=d;return}}function _3a(a){a=a|0;var b=0;b=i;t4a(a);i=b;return}function $3a(a,b){a=a|0;b=b|0;var c=0;c=i;c4a(a,3);d4a(a,283312);c4a(a,0);d4a(a,283320);c4a(a,2);o4a(a,b);p4a(a,b);d4a(a,283328);c4a(a,0);i=c;return}function a4a(a,b){a=a|0;b=b|0;var d=0;d=i;c[70826]=Od(b|0)|0;fib(a,283304,4)|0;i=d;return}function b4a(b,d,e,f){b=b|0;d=+d;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+112|0;j=g;k=g+16|0;l=g+32|0;m=g+48|0;n=g+64|0;o=g+80|0;p=g+96|0;q=b;gib(l,q);r=I1a(l)|0;a4a(b,0);gib(m,q);l=I1a(m)|0;c4a(b,1);d4a(b,283200);m=e+128|0;s=e+132|0;t=e+136|0;u=e+140|0;e4a(b,(c[m>>2]|0)+1+(c[s>>2]|0)+(c[t>>2]|0)+(c[u>>2]|0)|0);f4a(b,d);if((c[m>>2]|0)>0){e=f+176|0;v=0;do{f4a(b,+h[(c[e>>2]|0)+(v<<3)>>3]);v=v+1|0;}while((v|0)<(c[m>>2]|0))}if((c[s>>2]|0)>0){m=f+180|0;v=0;do{g4a(b,c[(c[m>>2]|0)+(v<<2)>>2]|0);v=v+1|0;}while((v|0)<(c[s>>2]|0))}if((c[t>>2]|0)>0){s=f+184|0;v=0;do{h4a(b,(a[(c[s>>2]|0)+v|0]|0)!=0);v=v+1|0;}while((v|0)<(c[t>>2]|0))}if((c[u>>2]|0)>0){t=f+188|0;f=0;do{d4a(b,c[(c[t>>2]|0)+(f<<2)>>2]|0);f=f+1|0;}while((f|0)<(c[u>>2]|0))}gib(n,q);u=I1a(n)|0;n=zqb(0,r|0,32)|0;u0a(o,n,J);n=k;r=o;c[n+0>>2]=c[r+0>>2];c[n+4>>2]=c[r+4>>2];c[n+8>>2]=c[r+8>>2];c[n+12>>2]=c[r+12>>2];hib(q,k)|0;a4a(b,u-l|0);u0a(p,u,((u|0)<0)<<31>>31);u=j;l=p;c[u+0>>2]=c[l+0>>2];c[u+4>>2]=c[l+4>>2];c[u+8>>2]=c[l+8>>2];c[u+12>>2]=c[l+12>>2];hib(q,j)|0;i=g;return}function c4a(b,d){b=b|0;d=d|0;var e=0;e=i;a[283288]=-33;c[70824]=Od(d|0)|0;d=b;fib(d,283288,1)|0;fib(d,283296,4)|0;i=e;return}function d4a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e;c[f>>2]=Od(yqb(d|0)|0)|0;a[283280]=-37;g=b;fib(g,283280,1)|0;fib(g,f,4)|0;fib(g,d,yqb(d|0)|0)|0;i=e;return}function e4a(b,d){b=b|0;d=d|0;var e=0;e=i;a[283264]=-35;c[70818]=Od(d|0)|0;d=b;fib(d,283264,1)|0;fib(d,283272,4)|0;i=e;return}function f4a(b,c){b=b|0;c=+c;var d=0,e=0;d=i;a[283248]=-53;n4a(c);e=b;fib(e,283248,1)|0;fib(e,283256,8)|0;i=d;return}function g4a(b,d){b=b|0;d=d|0;var e=0;e=i;a[283232]=-46;c[70810]=Od(d|0)|0;d=b;fib(d,283232,1)|0;fib(d,283240,4)|0;i=e;return}function h4a(b,c){b=b|0;c=c|0;var d=0;d=i;a[283224]=c?-61:-62;fib(b,283224,1)|0;i=d;return}function i4a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a+12>>2]|0;a=b+8|0;f=b+240|0;b4a(e,+h[f>>3],a,f);b4a(e,+h[b+248>>3],a,f);i=d;return}function j4a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+112|0;f=e;g=e+16|0;j=e+32|0;k=e+48|0;l=e+64|0;m=e+80|0;n=e+96|0;o=c[b+12>>2]|0;b=o;p=o;gib(j,p);o=I1a(j)|0;a4a(b,0);gib(k,p);j=I1a(k)|0;c4a(b,1);d4a(b,283208);k=d+116|0;q=d+124|0;r=d+128|0;s=d+132|0;e4a(b,(c[k>>2]|0)+1+(c[q>>2]|0)+(c[r>>2]|0)+(c[s>>2]|0)|0);t=d+4|0;f4a(b,+h[c[c[t>>2]>>2]>>3]);if((c[k>>2]|0)>0){d=0;do{f4a(b,+h[(c[(c[c[t>>2]>>2]|0)+8>>2]|0)+(d<<3)>>3]);d=d+1|0;}while((d|0)<(c[k>>2]|0))}if((c[q>>2]|0)>0){k=0;do{g4a(b,c[(c[(c[c[t>>2]>>2]|0)+12>>2]|0)+(k<<2)>>2]|0);k=k+1|0;}while((k|0)<(c[q>>2]|0))}if((c[r>>2]|0)>0){q=0;do{h4a(b,(a[(c[(c[c[t>>2]>>2]|0)+16>>2]|0)+q|0]|0)!=0);q=q+1|0;}while((q|0)<(c[r>>2]|0))}if((c[s>>2]|0)>0){r=0;do{d4a(b,c[(c[(c[c[t>>2]>>2]|0)+20>>2]|0)+(r<<2)>>2]|0);r=r+1|0;}while((r|0)<(c[s>>2]|0))}gib(l,p);s=I1a(l)|0;l=zqb(0,o|0,32)|0;u0a(m,l,J);l=g;o=m;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];hib(p,g)|0;a4a(b,s-j|0);u0a(n,s,((s|0)<0)<<31>>31);s=f;j=n;c[s+0>>2]=c[j+0>>2];c[s+4>>2]=c[j+4>>2];c[s+8>>2]=c[j+8>>2];c[s+12>>2]=c[j+12>>2];hib(p,f)|0;i=e;return}function k4a(a,b){a=a|0;b=b|0;var d=0;b=i;d=a+12|0;a=c[d>>2]|0;o0a(a);CYa(3);if((a|0)!=0){l4a(a);cqb(a)}c[d>>2]=0;FYa(3);i=b;return}function l4a(a){a=a|0;var b=0;b=i;m4a(a);i=b;return}function m4a(a){a=a|0;var b=0;b=i;L1a(a);i=b;return}function n4a(b){b=+b;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+8|0;e=d;h[e>>3]=b;if((Od(1)|0)==1){f=e;g=c[f+4>>2]|0;j=283256;c[j>>2]=c[f>>2];c[j+4>>2]=g;i=d;return}h[k>>3]=b;g=c[k>>2]&255;j=0;while(1){a[283256+(7-j)|0]=g;f=j+1|0;if((f|0)>=8){break}g=a[e+f|0]|0;j=f}i=d;return}function o4a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;d4a(a,283200);c4a(a,4);d4a(a,283336);c4a(a,0);d4a(a,283344);f=b+128|0;g=b+132|0;h=b+136|0;j=b+140|0;e4a(a,(c[f>>2]|0)+1+(c[g>>2]|0)+(c[h>>2]|0)+(c[j>>2]|0)|0);d4a(a,283352);if((c[f>>2]|0)>0){k=b+16|0;l=0;do{d4a(a,c[(c[k>>2]|0)+(l*112|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){l=b+20|0;k=0;do{d4a(a,c[(c[l>>2]|0)+(k*60|0)+4>>2]|0);k=k+1|0;}while((k|0)<(c[g>>2]|0))}if((c[h>>2]|0)>0){k=b+24|0;l=0;do{d4a(a,c[(c[k>>2]|0)+(l*48|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[h>>2]|0))}if((c[j>>2]|0)>0){l=b+28|0;k=0;do{d4a(a,c[(c[l>>2]|0)+(k*52|0)+4>>2]|0);k=k+1|0;}while((k|0)<(c[j>>2]|0))}k=e;l=283440;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];q4a(a,b,e);d4a(a,283376);c4a(a,(c[f>>2]|0)+1+(c[g>>2]|0)+(c[h>>2]|0)+(c[j>>2]|0)|0);r4a(a,283352,283384);if((c[f>>2]|0)>0){e=b+16|0;l=0;do{k=c[e>>2]|0;r4a(a,c[k+(l*112|0)+4>>2]|0,c[k+(l*112|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){f=b+20|0;l=0;do{e=c[f>>2]|0;r4a(a,c[e+(l*60|0)+4>>2]|0,c[e+(l*60|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[g>>2]|0))}if((c[h>>2]|0)>0){g=b+24|0;l=0;do{f=c[g>>2]|0;r4a(a,c[f+(l*48|0)+4>>2]|0,c[f+(l*48|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[h>>2]|0))}if((c[j>>2]|0)<=0){i=d;return}h=b+28|0;b=0;do{l=c[h>>2]|0;r4a(a,c[l+(b*52|0)+4>>2]|0,c[l+(b*52|0)+8>>2]|0);b=b+1|0;}while((b|0)<(c[j>>2]|0));i=d;return}function p4a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d;f=b+108|0;g=c[f>>2]|0;h=b+116|0;j=c[h>>2]|0;k=b+120|0;l=c[k>>2]|0;m=b+124|0;n=c[m>>2]|0;d4a(a,283208);c4a(a,4);d4a(a,283336);c4a(a,0);d4a(a,283344);o=g+1+j+l+n|0;e4a(a,o);d4a(a,283352);if((c[f>>2]|0)>0){n=b;l=0;do{d4a(a,c[(c[n>>2]|0)+(l*112|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[h>>2]|0)>0){l=b+4|0;n=0;do{d4a(a,c[(c[l>>2]|0)+(n*60|0)+4>>2]|0);n=n+1|0;}while((n|0)<(c[h>>2]|0))}if((c[k>>2]|0)>0){n=b+8|0;l=0;do{d4a(a,c[(c[n>>2]|0)+(l*48|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[k>>2]|0))}if((c[m>>2]|0)>0){l=b+12|0;n=0;do{d4a(a,c[(c[l>>2]|0)+(n*52|0)+4>>2]|0);n=n+1|0;}while((n|0)<(c[m>>2]|0))}n=e;l=283360;c[n+0>>2]=c[l+0>>2];c[n+4>>2]=c[l+4>>2];c[n+8>>2]=c[l+8>>2];q4a(a,b,e);d4a(a,283376);c4a(a,o);r4a(a,283352,283384);if((c[f>>2]|0)>0){o=b;e=0;do{l=c[o>>2]|0;r4a(a,c[l+(e*112|0)+4>>2]|0,c[l+(e*112|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[f>>2]|0))}if((c[h>>2]|0)>0){f=b+4|0;e=0;do{o=c[f>>2]|0;r4a(a,c[o+(e*60|0)+4>>2]|0,c[o+(e*60|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[h>>2]|0))}if((c[k>>2]|0)>0){h=b+8|0;e=0;do{f=c[h>>2]|0;r4a(a,c[f+(e*48|0)+4>>2]|0,c[f+(e*48|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[k>>2]|0))}if((c[m>>2]|0)<=0){i=d;return}k=b+12|0;b=0;do{e=c[k>>2]|0;r4a(a,c[e+(b*52|0)+4>>2]|0,c[e+(b*52|0)+8>>2]|0);b=b+1|0;}while((b|0)<(c[m>>2]|0));i=d;return}function q4a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;d4a(b,283408);g=d+208|0;h=c[g>>2]|0;if((h|0)>0){j=c[d+32>>2]|0;k=0;l=0;while(1){m=(c[e+(a[j+(k*52|0)+8|0]<<2)>>2]|0)+l|0;n=k+1|0;if((n|0)<(h|0)){l=m;k=n}else{o=m;break}}}else{o=0}k=d+212|0;l=c[k>>2]|0;if((l|0)>0){h=c[d+36>>2]|0;j=0;m=o;while(1){n=(c[e+(a[h+(j*52|0)+8|0]<<2)>>2]|0)+m|0;p=j+1|0;if((p|0)<(l|0)){m=n;j=p}else{q=n;break}}}else{q=o}o=d+216|0;j=c[o>>2]|0;if((j|0)>0){m=c[d+40>>2]|0;l=0;h=q;while(1){n=(c[e+(a[m+(l*52|0)+8|0]<<2)>>2]|0)+h|0;p=l+1|0;if((p|0)<(j|0)){h=n;l=p}else{r=n;break}}}else{r=q}q=d+220|0;l=c[q>>2]|0;if((l|0)>0){h=c[d+44>>2]|0;j=0;m=r;while(1){n=(c[e+(a[h+(j*52|0)+8|0]<<2)>>2]|0)+m|0;p=j+1|0;if((p|0)<(l|0)){m=n;j=p}else{s=n;break}}}else{s=r}c4a(b,s);s=c[g>>2]|0;if((s|0)>0){r=d+32|0;j=d+16|0;m=d;l=s;s=0;h=0;while(1){n=c[r>>2]|0;p=a[n+(s*52|0)+8|0]|0;if((c[e+(p<<24>>24<<2)>>2]|0)==0){t=l;u=h}else{v=p<<24>>24==2?283352:h;if(p<<24>>24==1){w=c[(c[j>>2]|0)+((c[n+(s*52|0)+4>>2]|0)*112|0)+4>>2]|0}else if(p<<24>>24==0){w=c[(c[m>>2]|0)+((c[n+(s*52|0)+4>>2]|0)*112|0)+4>>2]|0}else{w=v}s4a(b,c[n+(s*52|0)+16>>2]|0,w,(c[n+(s*52|0)>>2]|0)!=0);t=c[g>>2]|0;u=w}n=s+1|0;if((n|0)<(t|0)){l=t;s=n;h=u}else{x=u;break}}}else{x=0}u=c[k>>2]|0;if((u|0)>0){h=d+36|0;s=d+20|0;t=d+4|0;l=u;u=0;w=x;while(1){g=c[h>>2]|0;m=a[g+(u*52|0)+8|0]|0;if((c[e+(m<<24>>24<<2)>>2]|0)==0){y=l;z=w}else{j=m<<24>>24==2?283352:w;if(m<<24>>24==0){A=c[(c[t>>2]|0)+((c[g+(u*52|0)+4>>2]|0)*60|0)+4>>2]|0}else if(m<<24>>24==1){A=c[(c[s>>2]|0)+((c[g+(u*52|0)+4>>2]|0)*60|0)+4>>2]|0}else{A=j}s4a(b,c[g+(u*52|0)+16>>2]|0,A,(c[g+(u*52|0)>>2]|0)!=0);y=c[k>>2]|0;z=A}g=u+1|0;if((g|0)<(y|0)){l=y;u=g;w=z}else{B=z;break}}}else{B=x}x=c[o>>2]|0;if((x|0)>0){z=d+40|0;w=d+24|0;u=d+8|0;y=x;x=0;l=B;while(1){A=c[z>>2]|0;k=a[A+(x*52|0)+8|0]|0;if((c[e+(k<<24>>24<<2)>>2]|0)==0){C=y;D=l}else{s=k<<24>>24==2?283352:l;if(k<<24>>24==0){E=c[(c[u>>2]|0)+((c[A+(x*52|0)+4>>2]|0)*48|0)+4>>2]|0}else if(k<<24>>24==1){E=c[(c[w>>2]|0)+((c[A+(x*52|0)+4>>2]|0)*48|0)+4>>2]|0}else{E=s}s4a(b,c[A+(x*52|0)+16>>2]|0,E,(c[A+(x*52|0)>>2]|0)!=0);C=c[o>>2]|0;D=E}A=x+1|0;if((A|0)<(C|0)){y=C;x=A;l=D}else{F=D;break}}}else{F=B}B=c[q>>2]|0;if((B|0)<=0){i=f;return}D=d+44|0;l=d+28|0;x=d+12|0;d=B;B=0;C=F;while(1){F=c[D>>2]|0;y=a[F+(B*52|0)+8|0]|0;if((c[e+(y<<24>>24<<2)>>2]|0)==0){G=d;H=C}else{E=y<<24>>24==2?283352:C;if(y<<24>>24==1){I=c[(c[l>>2]|0)+((c[F+(B*52|0)+4>>2]|0)*52|0)+4>>2]|0}else if(y<<24>>24==0){I=c[(c[x>>2]|0)+((c[F+(B*52|0)+4>>2]|0)*52|0)+4>>2]|0}else{I=E}s4a(b,c[F+(B*52|0)+16>>2]|0,I,(c[F+(B*52|0)>>2]|0)!=0);G=c[q>>2]|0;H=I}F=B+1|0;if((F|0)<(G|0)){d=G;B=F;C=H}else{break}}i=f;return}function r4a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;d4a(a,b);c4a(a,1);d4a(a,283392);d4a(a,c);i=d;return}function s4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;d4a(a,b);c4a(a,d?2:1);d4a(a,283416);d4a(a,c);if(!d){i=e;return}d4a(a,283424);d4a(a,283432);i=e;return}function t4a(a){a=a|0;var b=0;b=i;B3a(a);i=b;return}function u4a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=i;i=i+288|0;d=c;e=c+16|0;f=c+32|0;g=c+48|0;h=c+64|0;j=c+80|0;k=c+96|0;l=c+112|0;m=c+128|0;n=c+144|0;o=c+160|0;p=c+176|0;q=c+192|0;r=c+208|0;s=c+224|0;t=c+240|0;u=c+256|0;v=c+272|0;Lfb(e,283456);Hfb(d,w4a(a,e)|0);v4a(d,b+4|0);Rfb(d);Rfb(e);Lfb(g,283464);Hfb(f,w4a(a,g)|0);x4a(f,b);Rfb(f);Rfb(g);Lfb(j,283480);Hfb(h,w4a(a,j)|0);v4a(h,b+8|0);Rfb(h);Rfb(j);Lfb(l,283496);Hfb(k,w4a(a,l)|0);v4a(k,b+12|0);Rfb(k);Rfb(l);Lfb(n,283512);Hfb(m,w4a(a,n)|0);y4a(m,b+16|0,0);Rfb(m);Rfb(n);Lfb(p,283528);Hfb(o,w4a(a,p)|0);y4a(o,b+20|0,0);Rfb(o);Rfb(p);Lfb(r,283544);Hfb(q,w4a(a,r)|0);y4a(q,b+24|0,0);Rfb(q);Rfb(r);Lfb(t,283552);Hfb(s,w4a(a,t)|0);y4a(s,b+28|0,0);Rfb(s);Rfb(t);Lfb(v,283568);Hfb(u,w4a(a,v)|0);y4a(u,b+32|0,0);Rfb(u);Rfb(v);i=c;return}function v4a(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+8|0;if((b|0)==0){mXa(22,0,286776,d);i=d;return}else{c[b>>2]=Hd(mgb(a)|0)|0;i=d;return}}function w4a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=H8a(a,f,b)|0;l=c[k>>2]|0;g1a(d+16|0);if((l|0)!=0){m=l;n=m;o=n+28|0;p=o;i=d;return p|0}J8a(j,a,b);K8a(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];I8a(g,e);L8a(j);j=c[f>>2]|0;M8a(a,j,k,N8a(g)|0);k=O8a(g)|0;L8a(g);m=k;n=m;o=n+28|0;p=o;i=d;return p|0}function x4a(a,b){a=a|0;b=b|0;var d=0;d=i;if((pgb(a,283744)|0)==0){c[b>>2]=1;i=d;return}if((pgb(a,283752)|0)==0){c[b>>2]=0;i=d;return}else{c[b>>2]=Ic(mgb(a)|0)|0;i=d;return}}function y4a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if((pgb(a,283720)|0)==0){c[b>>2]=d}if((pgb(a,283744)|0)==0){c[b>>2]=1;i=e;return}if((pgb(a,283752)|0)==0){c[b>>2]=0;i=e;return}else{c[b>>2]=Ic(mgb(a)|0)|0;i=e;return}}function z4a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0;e=i;i=i+56|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;Lfb(j,283584);Hfb(g,w4a(b,j)|0);y=d+48|0;A4a(g,y);Rfb(g);Rfb(j);Lfb(m,283600);Hfb(l,w4a(b,m)|0);j=d+56|0;B4a(l,j,0.0);Rfb(l);Rfb(m);Lfb(o,283608);Hfb(n,w4a(b,o)|0);m=d+32|0;A4a(n,m);Rfb(n);Rfb(o);Lfb(q,283616);Hfb(p,w4a(b,q)|0);o=d+33|0;A4a(p,o);Rfb(p);Rfb(q);Lfb(s,283632);Hfb(r,w4a(b,s)|0);q=d+40|0;B4a(r,q,1.0);Rfb(r);Rfb(s);Lfb(u,283640);Hfb(t,w4a(b,u)|0);s=d+16|0;B4a(t,s,-1.7976931348623157e+308);Rfb(t);Rfb(u);Lfb(w,283648);Hfb(v,w4a(b,w)|0);u=d+24|0;B4a(v,u,1.7976931348623157e+308);Rfb(v);Rfb(w);Lfb(x,283456);w=mgb(w4a(b,x)|0)|0;b=(a[y]|0)!=0;z=+h[j>>3];j=(a[m]|0)!=0?283744:283752;m=(a[o]|0)!=0;A=+h[q>>3];B=+h[s>>3];C=+h[u>>3];c[f>>2]=w;c[f+4>>2]=b?283720:283728;w=f+8|0;h[k>>3]=z;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[f+16>>2]=b?283720:283736;c[f+20>>2]=j;c[f+24>>2]=m?283720:283728;j=f+28|0;h[k>>3]=A;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];c[f+36>>2]=m?283720:283736;m=f+40|0;h[k>>3]=B;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=f+48|0;h[k>>3]=C;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];kXa(4,0,283656,f);Rfb(x);i=e;return}function A4a(b,c){b=b|0;c=c|0;var d=0;d=i;a[c]=(pgb(b,283744)|0)==0|0;i=d;return}function B4a(a,b,c){a=a|0;b=b|0;c=+c;var d=0;d=i;if((pgb(a,283720)|0)==0){h[b>>3]=c;i=d;return}if((pgb(a,283744)|0)==0){h[b>>3]=1.0;i=d;return}if((pgb(a,283752)|0)==0){h[b>>3]=0.0;i=d;return}else{h[b>>3]=+qqb(mgb(a)|0);i=d;return}}



function Pr(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;_D(d,c[a+536>>2]|0,+h[f+5424>>3],+h[f+5264>>3],+h[f+6224>>3]+-6150.0,3850.0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5904>>3]=+h[d>>3];i=b;return}function Qr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1884>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4784>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+4784|0;h[c[g+1888>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4784>>3]);h[c[(c[f>>2]|0)+1892>>2]>>3]=k;$_a(a,23)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+4784>>3]=+h[c[(c[f>>2]|0)+1884>>2]>>3];i=b;return}function Rr(a){a=a|0;var b=0,d=0,e=0;b=i;R_a(a,21)|0;d=c[(c[a+476>>2]|0)+1372>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+8480>>3]=+h[d>>3];h[e+9584>>3]=+h[d+8>>3];i=b;return}function Sr(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2696>>3]*+h[e+144>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=-+h[j+8480>>3]- +h[j+3704>>3];if(f!=0.0){l=j;m=k/f;n=l;o=n+1584|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+1584|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,f,10240,10232,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1584|0;p=o;h[p>>3]=m;i=d;return}function Tr(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+8320>>3]=+h[b+6384>>3]*+h[d+648>>3]*+h[d+2736>>3]*(+h[b+328>>3]*.5+(+h[b+360>>3]*-.5+(+h[b+7176>>3]+ +h[b+7184>>3])*.5));i=i;return}function Ur(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8800>>3]=+h[b+8032>>3]- +h[b+8024>>3];i=i;return}function Vr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+13488>>3];k=+h[g+8800>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+10528|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+10528|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,10288,10280,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+10528|0;p=o;h[p>>3]=m;i=d;return}function Wr(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8032>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7656>>3]=+h[(a?e+10992|0:e+10984|0)>>3];i=b;return}function Xr(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8032>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7816>>3]=+h[(a?e+12360|0:e+12352|0)>>3];i=b;return}function Yr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+360>>3],+h[a+352>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+360>>3];l=+h[g+352>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+9144>>3]=+h[f>>3];i=b;return}function Zr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9144>>3];k=+h[g+12352>>3];l=+h[g+360>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,10328,10320,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6488>>3]=j-n;i=d;return}function _r(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9112>>3]=+h[b+8952>>3]*+h[b+6488>>3];i=i;return}function $r(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+88|0;d=b;e=b+40|0;f=b+80|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ID(e,c[g>>2]|0,1,+h[a+9144>>3],+h[a+12352>>3],+h[a+352>>3],+h[a+360>>3]);a=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+40|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));SD(f,a,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+6056>>3]=+h[f>>3];i=b;return}function as(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+8032>>3];h[b+7992>>3]=d*+h[(!(d>=0.0)?b+9136|0:b+9144|0)>>3];i=i;return}function bs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8640>>3]=+h[b+7992>>3]- +h[b+8e3>>3];i=i;return}function cs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10064>>3]=+h[b+8640>>3]+(+h[b+8320>>3]+ +h[b+8480>>3]);i=i;return}function ds(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8960>>3];k=+h[g+10064>>3]- +h[g+8800>>3]*+h[g+6456>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9744|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9744|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,10368,10360,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9744|0;p=o;h[p>>3]=m;i=d;return}function es(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1964>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1144>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1144|0;h[c[g+1968>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1144>>3]);e=c[f>>2]|0;h[c[e+1972>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+1964>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+1136>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+1136|0;h[(c[e+1968>>2]|0)+8>>3]=+h[g>>3];k=+b$a(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+1136>>3]);j=c[f>>2]|0;h[(c[j+1972>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+1964>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+10376>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+10376|0;h[(c[j+1968>>2]|0)+16>>3]=+h[e>>3];k=+b$a(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+10376>>3]);h[(c[(c[f>>2]|0)+1972>>2]|0)+16>>3]=k;$_a(a,24)|0;a=c[(c[f>>2]|0)+1964>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1144>>3]=+h[a>>3];h[f+1136>>3]=+h[a+8>>3];h[f+10376>>3]=+h[a+16>>3];i=b;return}function fs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+376>>3],+h[a+368>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+376>>3];l=+h[g+368>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12344>>3]=+h[f>>3];i=b;return}function gs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8944>>3]=+h[b+13472>>3]*+h[b+12344>>3];i=i;return}function hs(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;WD(d,c[a+536>>2]|0,+h[f+12344>>3],+h[f+368>>3],+h[f+376>>3],1,1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5568>>3]=+h[d>>3];i=b;return}function is(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12344>>3],+h[f+368>>3],+h[f+376>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5728>>3]=+h[d>>3];i=b;return}function js(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12344>>3],+h[f+368>>3],+h[f+376>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+10976>>3]=+h[d>>3];i=b;return}function ks(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;JD(d,c[a+536>>2]|0,+h[f+7168>>3],+h[f+12344>>3],+h[f+12352>>3],+h[f+10976>>3],+h[f+10984>>3],+h[j+472>>3],+h[f+13048>>3],+h[f+12688>>3]*+h[j+2904>>3],(+h[j+952>>3]+ +h[j+960>>3])*.5,+h[j+2896>>3]*.05,+h[j+2864>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+8040>>3]=+h[d>>3]*+h[(c[g>>2]|0)+2840>>3];i=b;return}function ls(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7488>>3]=+h[b+8040>>3]*+h[(c[a+416>>2]|0)+472>>3];i=i;return}function ms(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+640>>3]*+h[j+12352>>3]*+h[e+2736>>3];l=+h[j+8040>>3]+ +h[j+8032>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6376|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6376|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,10400,10392,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6376|0;r=q;h[r>>3]=o;i=d;return}function ns(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;GD(d,c[a+536>>2]|0,+h[f+6376>>3],+h[f+12352>>3],+h[f+5736>>3],+h[(c[a+416>>2]|0)+800>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6216>>3]=+h[d>>3];i=b;return}function os(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+Ad(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6216>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4936|0;w=v;h[w>>3]=n;i=b;return}x=c[72300]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=20120;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Pe[a&127](y,d,10488,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4936|0;w=v;h[w>>3]=n;i=b;return}function ps(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6376>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4936>>3];l=+U(+(+h[j+6216>>3]));m=+h[j+6056>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?17.5:2.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+480>>3];q=n*p;r=q!=0.0;s=+h[o+800>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+qXa(c[b+536>>2]|0,q,10600,10592,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+6056>>3];u=+h[j+4936>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5416|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+qXa(c[b+536>>2]|0,q,10600,10592,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+800>>3];M=+h[j+480>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+qXa(c[b+536>>2]|0,q,10600,10592,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5416|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+qXa(c[b+536>>2]|0,q,10600,10592,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4936>>3]*.125));L=P*(+W(+(+h[g+6056>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+qXa(c[b+536>>2]|0,L,10680,10592,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5416|0;K=J;h[K>>3]=B;i=d;return}}function qs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6376>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+6216>>3]));l=+h[j+6056>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?17.5:2.5)*+h[m+480>>3];o=+h[m+800>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+qXa(c[b+536>>2]|0,n,10600,10808,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+5096>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function rs(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+5096>>3]+-.7;h[b+5256>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function ss(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;_D(d,c[a+536>>2]|0,+h[f+5416>>3],+h[f+5256>>3],+h[f+6216>>3]+-6150.0,3850.0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5896>>3]=+h[d>>3];i=b;return}function ts(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+2044>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4776>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+4776|0;h[c[g+2048>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4776>>3]);h[c[(c[f>>2]|0)+2052>>2]>>3]=k;$_a(a,25)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+4776>>3]=+h[c[(c[f>>2]|0)+2044>>2]>>3];i=b;return}function us(a){a=a|0;var b=0,d=0,e=0;b=i;R_a(a,22)|0;d=c[(c[a+476>>2]|0)+1436>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+9576>>3]=+h[d>>3];h[e+8472>>3]=+h[d+8>>3];i=b;return}function vs(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2696>>3]*+h[e+136>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=-+h[j+8472>>3]- +h[j+3712>>3];if(f!=0.0){l=j;m=k/f;n=l;o=n+1576|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+1576|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,f,10824,10816,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1576|0;p=o;h[p>>3]=m;i=d;return}function ws(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+8312>>3]=+h[b+6376>>3]*+h[d+640>>3]*+h[d+2736>>3]*(+h[b+344>>3]*.5+(+h[b+376>>3]*-.5+(+h[b+7168>>3]+ +h[b+7176>>3])*.5));i=i;return}function xs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8792>>3]=+h[b+8040>>3]- +h[b+8032>>3];i=i;return}function ys(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+13480>>3];k=+h[g+8792>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+10520|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+10520|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,10872,10864,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+10520|0;p=o;h[p>>3]=m;i=d;return}function zs(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8040>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7648>>3]=+h[(a?e+10984|0:e+10976|0)>>3];i=b;return}function As(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8040>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7808>>3]=+h[(a?e+12352|0:e+12344|0)>>3];i=b;return}function Bs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+376>>3],+h[a+368>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+376>>3];l=+h[g+368>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+9152>>3]=+h[f>>3];i=b;return}function Cs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9152>>3];k=+h[g+12344>>3];l=+h[g+376>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,10912,10904,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6520>>3]=j-n;i=d;return}function Ds(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9104>>3]=+h[b+8944>>3]*+h[b+6520>>3];i=i;return}function Es(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+88|0;d=b;e=b+40|0;f=b+80|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ID(e,c[g>>2]|0,1,+h[a+9152>>3],+h[a+12344>>3],+h[a+368>>3],+h[a+376>>3]);a=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+40|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));SD(f,a,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+6048>>3]=+h[f>>3];i=b;return}function Fs(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+8040>>3];h[b+7984>>3]=d*+h[(!(d>=0.0)?b+9144|0:b+9152|0)>>3];i=i;return}function Gs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8632>>3]=+h[b+7984>>3]- +h[b+7992>>3];i=i;return}function Hs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10056>>3]=+h[b+8632>>3]+(+h[b+8312>>3]+ +h[b+8472>>3]);i=i;return}function Is(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8952>>3];k=+h[g+10056>>3]- +h[g+8792>>3]*+h[g+6488>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9736|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9736|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,10952,10944,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9736|0;p=o;h[p>>3]=m;i=d;return}function Js(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+2124>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1160>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1160|0;h[c[g+2128>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1160>>3]);e=c[f>>2]|0;h[c[e+2132>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+2124>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+1152>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+1152|0;h[(c[e+2128>>2]|0)+8>>3]=+h[g>>3];k=+b$a(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+1152>>3]);j=c[f>>2]|0;h[(c[j+2132>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+2124>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+10368>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+10368|0;h[(c[j+2128>>2]|0)+16>>3]=+h[e>>3];k=+b$a(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+10368>>3]);h[(c[(c[f>>2]|0)+2132>>2]|0)+16>>3]=k;$_a(a,26)|0;a=c[(c[f>>2]|0)+2124>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1160>>3]=+h[a>>3];h[f+1152>>3]=+h[a+8>>3];h[f+10368>>3]=+h[a+16>>3];i=b;return}function Ks(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+392>>3],+h[a+384>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+392>>3];l=+h[g+384>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12336>>3]=+h[f>>3];i=b;return}function Ls(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8936>>3]=+h[b+13464>>3]*+h[b+12336>>3];i=i;return}function Ms(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;WD(d,c[a+536>>2]|0,+h[f+12336>>3],+h[f+384>>3],+h[f+392>>3],1,1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5560>>3]=+h[d>>3];i=b;return}function Ns(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12336>>3],+h[f+384>>3],+h[f+392>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5720>>3]=+h[d>>3];i=b;return}function Os(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12336>>3],+h[f+384>>3],+h[f+392>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+10968>>3]=+h[d>>3];i=b;return}function Ps(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;JD(d,c[a+536>>2]|0,+h[f+7160>>3],+h[f+12336>>3],+h[f+12344>>3],+h[f+10968>>3],+h[f+10976>>3],+h[j+464>>3],+h[f+13056>>3],+h[f+12680>>3]*+h[j+2904>>3],(+h[j+944>>3]+ +h[j+952>>3])*.5,+h[j+2896>>3]*.05,+h[j+2864>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+8048>>3]=+h[d>>3]*+h[(c[g>>2]|0)+2840>>3];i=b;return}function Qs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7480>>3]=+h[b+8048>>3]*+h[(c[a+416>>2]|0)+464>>3];i=i;return}function Rs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+632>>3]*+h[j+12344>>3]*+h[e+2736>>3];l=+h[j+8048>>3]+ +h[j+8040>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6368|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6368|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,10984,10976,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6368|0;r=q;h[r>>3]=o;i=d;return}function Ss(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;GD(d,c[a+536>>2]|0,+h[f+6368>>3],+h[f+12344>>3],+h[f+5728>>3],+h[(c[a+416>>2]|0)+792>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6208>>3]=+h[d>>3];i=b;return}function Ts(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+Ad(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6208>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4928|0;w=v;h[w>>3]=n;i=b;return}x=c[72300]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=20120;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Pe[a&127](y,d,11072,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4928|0;w=v;h[w>>3]=n;i=b;return}function Us(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6368>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4928>>3];l=+U(+(+h[j+6208>>3]));m=+h[j+6048>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?16.5:3.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+472>>3];q=n*p;r=q!=0.0;s=+h[o+792>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+qXa(c[b+536>>2]|0,q,11184,11176,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+6048>>3];u=+h[j+4928>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5408|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+qXa(c[b+536>>2]|0,q,11184,11176,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+792>>3];M=+h[j+472>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+qXa(c[b+536>>2]|0,q,11184,11176,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5408|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+qXa(c[b+536>>2]|0,q,11184,11176,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4928>>3]*.125));L=P*(+W(+(+h[g+6048>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+qXa(c[b+536>>2]|0,L,11264,11176,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5408|0;K=J;h[K>>3]=B;i=d;return}}function Vs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6368>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+6208>>3]));l=+h[j+6048>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?16.5:3.5)*+h[m+472>>3];o=+h[m+792>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+qXa(c[b+536>>2]|0,n,11184,11392,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+5088>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function Ws(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+5088>>3]+-.7;h[b+5248>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function Xs(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;_D(d,c[a+536>>2]|0,+h[f+5408>>3],+h[f+5248>>3],+h[f+6208>>3]+-6150.0,3850.0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5888>>3]=+h[d>>3];i=b;return}function Ys(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+2204>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4768>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+4768|0;h[c[g+2208>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4768>>3]);h[c[(c[f>>2]|0)+2212>>2]>>3]=k;$_a(a,27)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+4768>>3]=+h[c[(c[f>>2]|0)+2204>>2]>>3];i=b;return}function Zs(a){a=a|0;var b=0,d=0,e=0;b=i;R_a(a,23)|0;d=c[(c[a+476>>2]|0)+1500>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+9568>>3]=+h[d>>3];h[e+8464>>3]=+h[d+8>>3];i=b;return}function _s(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2696>>3]*+h[e+128>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=-+h[j+8464>>3]- +h[j+3720>>3];if(f!=0.0){l=j;m=k/f;n=l;o=n+1568|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+1568|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,f,11408,11400,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1568|0;p=o;h[p>>3]=m;i=d;return}function $s(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+8304>>3]=+h[b+6368>>3]*+h[d+632>>3]*+h[d+2736>>3]*(+h[b+360>>3]*.5+(+h[b+392>>3]*-.5+(+h[b+7160>>3]+ +h[b+7168>>3])*.5));i=i;return}function at(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8784>>3]=+h[b+8048>>3]- +h[b+8040>>3];i=i;return}function bt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+13472>>3];k=+h[g+8784>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+10512|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+10512|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,11456,11448,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+10512|0;p=o;h[p>>3]=m;i=d;return}function ct(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8048>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7640>>3]=+h[(a?e+10976|0:e+10968|0)>>3];i=b;return}function dt(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8048>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7800>>3]=+h[(a?e+12344|0:e+12336|0)>>3];i=b;return}function et(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+392>>3],+h[a+384>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+392>>3];l=+h[g+384>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+9160>>3]=+h[f>>3];i=b;return}function ft(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9160>>3];k=+h[g+12336>>3];l=+h[g+392>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,11496,11488,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6552>>3]=j-n;i=d;return}function gt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9096>>3]=+h[b+8936>>3]*+h[b+6552>>3];i=i;return}function ht(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+88|0;d=b;e=b+40|0;f=b+80|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ID(e,c[g>>2]|0,1,+h[a+9160>>3],+h[a+12336>>3],+h[a+384>>3],+h[a+392>>3]);a=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+40|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));SD(f,a,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+6040>>3]=+h[f>>3];i=b;return}function it(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+8048>>3];h[b+7976>>3]=d*+h[(!(d>=0.0)?b+9152|0:b+9160|0)>>3];i=i;return}function jt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8624>>3]=+h[b+7976>>3]- +h[b+7984>>3];i=i;return}function kt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10048>>3]=+h[b+8624>>3]+(+h[b+8304>>3]+ +h[b+8464>>3]);i=i;return}function lt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8944>>3];k=+h[g+10048>>3]- +h[g+8784>>3]*+h[g+6520>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9728|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9728|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,11536,11528,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9728|0;p=o;h[p>>3]=m;i=d;return}function mt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+2284>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1176>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1176|0;h[c[g+2288>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1176>>3]);e=c[f>>2]|0;h[c[e+2292>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+2284>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+10360>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+10360|0;h[(c[e+2288>>2]|0)+8>>3]=+h[g>>3];k=+b$a(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+10360>>3]);j=c[f>>2]|0;h[(c[j+2292>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+2284>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+1168>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+1168|0;h[(c[j+2288>>2]|0)+16>>3]=+h[e>>3];k=+b$a(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+1168>>3]);h[(c[(c[f>>2]|0)+2292>>2]|0)+16>>3]=k;$_a(a,28)|0;a=c[(c[f>>2]|0)+2284>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1176>>3]=+h[a>>3];h[f+10360>>3]=+h[a+8>>3];h[f+1168>>3]=+h[a+16>>3];i=b;return}function nt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+408>>3],+h[a+400>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+408>>3];l=+h[g+400>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12328>>3]=+h[f>>3];i=b;return}function ot(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8928>>3]=+h[b+13456>>3]*+h[b+12328>>3];i=i;return}function pt(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;WD(d,c[a+536>>2]|0,+h[f+12328>>3],+h[f+400>>3],+h[f+408>>3],1,1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5552>>3]=+h[d>>3];i=b;return}function qt(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12328>>3],+h[f+400>>3],+h[f+408>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5712>>3]=+h[d>>3];i=b;return}function rt(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12328>>3],+h[f+400>>3],+h[f+408>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+10960>>3]=+h[d>>3];i=b;return}function st(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;JD(d,c[a+536>>2]|0,+h[f+7152>>3],+h[f+12328>>3],+h[f+12336>>3],+h[f+10960>>3],+h[f+10968>>3],+h[j+456>>3],+h[f+13064>>3],+h[f+12672>>3]*+h[j+2904>>3],(+h[j+936>>3]+ +h[j+944>>3])*.5,+h[j+2896>>3]*.05,+h[j+2864>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+8056>>3]=+h[d>>3]*+h[(c[g>>2]|0)+2840>>3];i=b;return}function tt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7472>>3]=+h[b+8056>>3]*+h[(c[a+416>>2]|0)+456>>3];i=i;return}function ut(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+624>>3]*+h[j+12336>>3]*+h[e+2736>>3];l=+h[j+8056>>3]+ +h[j+8048>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6360|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6360|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,11568,11560,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6360|0;r=q;h[r>>3]=o;i=d;return}function vt(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;GD(d,c[a+536>>2]|0,+h[f+6360>>3],+h[f+12336>>3],+h[f+5720>>3],+h[(c[a+416>>2]|0)+784>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6200>>3]=+h[d>>3];i=b;return}function wt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+Ad(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6200>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4920|0;w=v;h[w>>3]=n;i=b;return}x=c[72300]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=20120;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Pe[a&127](y,d,11656,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4920|0;w=v;h[w>>3]=n;i=b;return}function xt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6360>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4920>>3];l=+U(+(+h[j+6200>>3]));m=+h[j+6040>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?15.5:4.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+464>>3];q=n*p;r=q!=0.0;s=+h[o+784>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+qXa(c[b+536>>2]|0,q,11768,11760,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+6040>>3];u=+h[j+4920>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5400|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+qXa(c[b+536>>2]|0,q,11768,11760,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+784>>3];M=+h[j+464>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+qXa(c[b+536>>2]|0,q,11768,11760,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5400|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+qXa(c[b+536>>2]|0,q,11768,11760,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4920>>3]*.125));L=P*(+W(+(+h[g+6040>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+qXa(c[b+536>>2]|0,L,11848,11760,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5400|0;K=J;h[K>>3]=B;i=d;return}}function yt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6360>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+6200>>3]));l=+h[j+6040>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?15.5:4.5)*+h[m+464>>3];o=+h[m+784>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+qXa(c[b+536>>2]|0,n,11768,11976,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+5080>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function zt(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+5080>>3]+-.7;h[b+5240>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function At(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;_D(d,c[a+536>>2]|0,+h[f+5400>>3],+h[f+5240>>3],+h[f+6200>>3]+-6150.0,3850.0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5880>>3]=+h[d>>3];i=b;return}function Bt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+2364>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4760>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+4760|0;h[c[g+2368>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4760>>3]);h[c[(c[f>>2]|0)+2372>>2]>>3]=k;$_a(a,29)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+4760>>3]=+h[c[(c[f>>2]|0)+2364>>2]>>3];i=b;return}function Ct(a){a=a|0;var b=0,d=0,e=0;b=i;R_a(a,24)|0;d=c[(c[a+476>>2]|0)+1564>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+9560>>3]=+h[d>>3];h[e+8456>>3]=+h[d+8>>3];i=b;return}function Dt(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2696>>3]*+h[e+120>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=-+h[j+8456>>3]- +h[j+3728>>3];if(f!=0.0){l=j;m=k/f;n=l;o=n+1560|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+1560|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,f,11992,11984,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1560|0;p=o;h[p>>3]=m;i=d;return}function Et(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+8296>>3]=+h[b+6360>>3]*+h[d+624>>3]*+h[d+2736>>3]*(+h[b+376>>3]*.5+(+h[b+408>>3]*-.5+(+h[b+7152>>3]+ +h[b+7160>>3])*.5));i=i;return}function Ft(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8776>>3]=+h[b+8056>>3]- +h[b+8048>>3];i=i;return}function Gt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+13464>>3];k=+h[g+8776>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+10504|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+10504|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,12040,12032,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+10504|0;p=o;h[p>>3]=m;i=d;return}function Ht(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8056>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7632>>3]=+h[(a?e+10968|0:e+10960|0)>>3];i=b;return}function It(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8056>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7792>>3]=+h[(a?e+12336|0:e+12328|0)>>3];i=b;return}function Jt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+408>>3],+h[a+400>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+408>>3];l=+h[g+400>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+9168>>3]=+h[f>>3];i=b;return}function Kt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9168>>3];k=+h[g+12328>>3];l=+h[g+408>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,12080,12072,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6584>>3]=j-n;i=d;return}function Lt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9088>>3]=+h[b+8928>>3]*+h[b+6584>>3];i=i;return}function Mt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+88|0;d=b;e=b+40|0;f=b+80|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ID(e,c[g>>2]|0,1,+h[a+9168>>3],+h[a+12328>>3],+h[a+400>>3],+h[a+408>>3]);a=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+40|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));SD(f,a,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+6032>>3]=+h[f>>3];i=b;return}function Nt(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+8056>>3];h[b+7968>>3]=d*+h[(!(d>=0.0)?b+9160|0:b+9168|0)>>3];i=i;return}function Ot(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8616>>3]=+h[b+7968>>3]- +h[b+7976>>3];i=i;return}function Pt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10040>>3]=+h[b+8616>>3]+(+h[b+8296>>3]+ +h[b+8456>>3]);i=i;return}function Qt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8936>>3];k=+h[g+10040>>3]- +h[g+8776>>3]*+h[g+6552>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9720|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9720|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,12120,12112,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9720|0;p=o;h[p>>3]=m;i=d;return}function Rt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+2444>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1192>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1192|0;h[c[g+2448>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1192>>3]);e=c[f>>2]|0;h[c[e+2452>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+2444>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+10352>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+10352|0;h[(c[e+2448>>2]|0)+8>>3]=+h[g>>3];k=+b$a(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+10352>>3]);j=c[f>>2]|0;h[(c[j+2452>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+2444>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+1184>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+1184|0;h[(c[j+2448>>2]|0)+16>>3]=+h[e>>3];k=+b$a(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+1184>>3]);h[(c[(c[f>>2]|0)+2452>>2]|0)+16>>3]=k;$_a(a,30)|0;a=c[(c[f>>2]|0)+2444>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1192>>3]=+h[a>>3];h[f+10352>>3]=+h[a+8>>3];h[f+1184>>3]=+h[a+16>>3];i=b;return}function St(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+424>>3],+h[a+416>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+424>>3];l=+h[g+416>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12320>>3]=+h[f>>3];i=b;return}function Tt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8920>>3]=+h[b+13448>>3]*+h[b+12320>>3];i=i;return}function Ut(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;WD(d,c[a+536>>2]|0,+h[f+12320>>3],+h[f+416>>3],+h[f+424>>3],1,1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5544>>3]=+h[d>>3];i=b;return}function Vt(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12320>>3],+h[f+416>>3],+h[f+424>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5704>>3]=+h[d>>3];i=b;return}function Wt(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12320>>3],+h[f+416>>3],+h[f+424>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+10952>>3]=+h[d>>3];i=b;return}function Xt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;JD(d,c[a+536>>2]|0,+h[f+7144>>3],+h[f+12320>>3],+h[f+12328>>3],+h[f+10952>>3],+h[f+10960>>3],+h[j+448>>3],+h[f+13072>>3],+h[f+12664>>3]*+h[j+2904>>3],(+h[j+928>>3]+ +h[j+936>>3])*.5,+h[j+2896>>3]*.05,+h[j+2864>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+8064>>3]=+h[d>>3]*+h[(c[g>>2]|0)+2840>>3];i=b;return}function Yt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7464>>3]=+h[b+8064>>3]*+h[(c[a+416>>2]|0)+448>>3];i=i;return}function Zt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+616>>3]*+h[j+12328>>3]*+h[e+2736>>3];l=+h[j+8064>>3]+ +h[j+8056>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6352|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6352|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,12152,12144,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6352|0;r=q;h[r>>3]=o;i=d;return}function _t(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;GD(d,c[a+536>>2]|0,+h[f+6352>>3],+h[f+12328>>3],+h[f+5712>>3],+h[(c[a+416>>2]|0)+776>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6192>>3]=+h[d>>3];i=b;return}function $t(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+Ad(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6192>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4912|0;w=v;h[w>>3]=n;i=b;return}x=c[72300]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=20120;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Pe[a&127](y,d,12240,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4912|0;w=v;h[w>>3]=n;i=b;return}function au(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6352>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4912>>3];l=+U(+(+h[j+6192>>3]));m=+h[j+6032>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?14.5:5.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+456>>3];q=n*p;r=q!=0.0;s=+h[o+776>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+qXa(c[b+536>>2]|0,q,12352,12344,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+6032>>3];u=+h[j+4912>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5392|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+qXa(c[b+536>>2]|0,q,12352,12344,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+776>>3];M=+h[j+456>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+qXa(c[b+536>>2]|0,q,12352,12344,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5392|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+qXa(c[b+536>>2]|0,q,12352,12344,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4912>>3]*.125));L=P*(+W(+(+h[g+6032>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+qXa(c[b+536>>2]|0,L,12432,12344,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5392|0;K=J;h[K>>3]=B;i=d;return}}function bu(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6352>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+6192>>3]));l=+h[j+6032>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?14.5:5.5)*+h[m+456>>3];o=+h[m+776>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+qXa(c[b+536>>2]|0,n,12352,12560,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+5072>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function cu(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+5072>>3]+-.7;h[b+5232>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function du(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;_D(d,c[a+536>>2]|0,+h[f+5392>>3],+h[f+5232>>3],+h[f+6192>>3]+-6150.0,3850.0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5872>>3]=+h[d>>3];i=b;return}function eu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+2524>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4752>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+4752|0;h[c[g+2528>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4752>>3]);h[c[(c[f>>2]|0)+2532>>2]>>3]=k;$_a(a,31)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+4752>>3]=+h[c[(c[f>>2]|0)+2524>>2]>>3];i=b;return}function fu(a){a=a|0;var b=0,d=0,e=0;b=i;R_a(a,25)|0;d=c[(c[a+476>>2]|0)+1628>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+9552>>3]=+h[d>>3];h[e+8448>>3]=+h[d+8>>3];i=b;return}function gu(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2696>>3]*+h[e+112>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=-+h[j+8448>>3]- +h[j+3736>>3];if(f!=0.0){l=j;m=k/f;n=l;o=n+1552|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+1552|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,f,12576,12568,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1552|0;p=o;h[p>>3]=m;i=d;return}function hu(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+8288>>3]=+h[b+6352>>3]*+h[d+616>>3]*+h[d+2736>>3]*(+h[b+392>>3]*.5+(+h[b+424>>3]*-.5+(+h[b+7144>>3]+ +h[b+7152>>3])*.5));i=i;return}function iu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8768>>3]=+h[b+8064>>3]- +h[b+8056>>3];i=i;return}function ju(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+13456>>3];k=+h[g+8768>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+10496|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+10496|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,12624,12616,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+10496|0;p=o;h[p>>3]=m;i=d;return}function ku(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8064>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7624>>3]=+h[(a?e+10960|0:e+10952|0)>>3];i=b;return}function lu(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8064>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7784>>3]=+h[(a?e+12328|0:e+12320|0)>>3];i=b;return}function mu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+424>>3],+h[a+416>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+424>>3];l=+h[g+416>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+9176>>3]=+h[f>>3];i=b;return}function nu(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9176>>3];k=+h[g+12320>>3];l=+h[g+424>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,12664,12656,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6616>>3]=j-n;i=d;return}function ou(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9080>>3]=+h[b+8920>>3]*+h[b+6616>>3];i=i;return}function pu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+88|0;d=b;e=b+40|0;f=b+80|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ID(e,c[g>>2]|0,1,+h[a+9176>>3],+h[a+12320>>3],+h[a+416>>3],+h[a+424>>3]);a=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+40|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));SD(f,a,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+6024>>3]=+h[f>>3];i=b;return}function qu(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+8064>>3];h[b+7960>>3]=d*+h[(!(d>=0.0)?b+9168|0:b+9176|0)>>3];i=i;return}function ru(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8608>>3]=+h[b+7960>>3]- +h[b+7968>>3];i=i;return}function su(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10032>>3]=+h[b+8608>>3]+(+h[b+8288>>3]+ +h[b+8448>>3]);i=i;return}function tu(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8928>>3];k=+h[g+10032>>3]- +h[g+8768>>3]*+h[g+6584>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9712|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9712|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,12704,12696,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9712|0;p=o;h[p>>3]=m;i=d;return}function uu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+2604>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1208>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1208|0;h[c[g+2608>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1208>>3]);e=c[f>>2]|0;h[c[e+2612>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+2604>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+10344>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+10344|0;h[(c[e+2608>>2]|0)+8>>3]=+h[g>>3];k=+b$a(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+10344>>3]);j=c[f>>2]|0;h[(c[j+2612>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+2604>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+1200>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+1200|0;h[(c[j+2608>>2]|0)+16>>3]=+h[e>>3];k=+b$a(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+1200>>3]);h[(c[(c[f>>2]|0)+2612>>2]|0)+16>>3]=k;$_a(a,32)|0;a=c[(c[f>>2]|0)+2604>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1208>>3]=+h[a>>3];h[f+10344>>3]=+h[a+8>>3];h[f+1200>>3]=+h[a+16>>3];i=b;return}function vu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+440>>3],+h[a+432>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+440>>3];l=+h[g+432>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12312>>3]=+h[f>>3];i=b;return}function wu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8912>>3]=+h[b+13440>>3]*+h[b+12312>>3];i=i;return}function xu(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;WD(d,c[a+536>>2]|0,+h[f+12312>>3],+h[f+432>>3],+h[f+440>>3],1,1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5536>>3]=+h[d>>3];i=b;return}function yu(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12312>>3],+h[f+432>>3],+h[f+440>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5696>>3]=+h[d>>3];i=b;return}function zu(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12312>>3],+h[f+432>>3],+h[f+440>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+10944>>3]=+h[d>>3];i=b;return}function Au(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;JD(d,c[a+536>>2]|0,+h[f+7136>>3],+h[f+12312>>3],+h[f+12320>>3],+h[f+10944>>3],+h[f+10952>>3],+h[j+440>>3],+h[f+13080>>3],+h[f+12656>>3]*+h[j+2904>>3],(+h[j+920>>3]+ +h[j+928>>3])*.5,+h[j+2896>>3]*.05,+h[j+2864>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+8072>>3]=+h[d>>3]*+h[(c[g>>2]|0)+2840>>3];i=b;return}function Bu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7456>>3]=+h[b+8072>>3]*+h[(c[a+416>>2]|0)+440>>3];i=i;return}function Cu(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+608>>3]*+h[j+12320>>3]*+h[e+2736>>3];l=+h[j+8072>>3]+ +h[j+8064>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6344|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6344|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,12736,12728,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6344|0;r=q;h[r>>3]=o;i=d;return}function Du(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;GD(d,c[a+536>>2]|0,+h[f+6344>>3],+h[f+12320>>3],+h[f+5704>>3],+h[(c[a+416>>2]|0)+768>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6184>>3]=+h[d>>3];i=b;return}function Eu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+Ad(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6184>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4904|0;w=v;h[w>>3]=n;i=b;return}x=c[72300]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=20120;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Pe[a&127](y,d,12824,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4904|0;w=v;h[w>>3]=n;i=b;return}function Fu(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6344>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4904>>3];l=+U(+(+h[j+6184>>3]));m=+h[j+6024>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?13.5:6.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+448>>3];q=n*p;r=q!=0.0;s=+h[o+768>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+qXa(c[b+536>>2]|0,q,12936,12928,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+6024>>3];u=+h[j+4904>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5384|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+qXa(c[b+536>>2]|0,q,12936,12928,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+768>>3];M=+h[j+448>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+qXa(c[b+536>>2]|0,q,12936,12928,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5384|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+qXa(c[b+536>>2]|0,q,12936,12928,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4904>>3]*.125));L=P*(+W(+(+h[g+6024>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+qXa(c[b+536>>2]|0,L,13016,12928,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5384|0;K=J;h[K>>3]=B;i=d;return}}function Gu(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6344>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+6184>>3]));l=+h[j+6024>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?13.5:6.5)*+h[m+448>>3];o=+h[m+768>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+qXa(c[b+536>>2]|0,n,12936,13144,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+5064>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function Hu(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+5064>>3]+-.7;h[b+5224>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function Iu(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;_D(d,c[a+536>>2]|0,+h[f+5384>>3],+h[f+5224>>3],+h[f+6184>>3]+-6150.0,3850.0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5864>>3]=+h[d>>3];i=b;return}function Ju(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+2684>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4744>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+4744|0;h[c[g+2688>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4744>>3]);h[c[(c[f>>2]|0)+2692>>2]>>3]=k;$_a(a,33)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+4744>>3]=+h[c[(c[f>>2]|0)+2684>>2]>>3];i=b;return}function Ku(a){a=a|0;var b=0,d=0,e=0;b=i;R_a(a,26)|0;d=c[(c[a+476>>2]|0)+1692>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+8440>>3]=+h[d>>3];h[e+9544>>3]=+h[d+8>>3];i=b;return}function Lu(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2696>>3]*+h[e+104>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=-+h[j+8440>>3]- +h[j+3744>>3];if(f!=0.0){l=j;m=k/f;n=l;o=n+1544|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+1544|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,f,13160,13152,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1544|0;p=o;h[p>>3]=m;i=d;return}function Mu(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+8280>>3]=+h[b+6344>>3]*+h[d+608>>3]*+h[d+2736>>3]*(+h[b+408>>3]*.5+(+h[b+440>>3]*-.5+(+h[b+7136>>3]+ +h[b+7144>>3])*.5));i=i;return}function Nu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8760>>3]=+h[b+8072>>3]- +h[b+8064>>3];i=i;return}function Ou(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+13448>>3];k=+h[g+8760>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+10488|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+10488|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,13208,13200,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+10488|0;p=o;h[p>>3]=m;i=d;return}function Pu(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8072>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7616>>3]=+h[(a?e+10952|0:e+10944|0)>>3];i=b;return}function Qu(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8072>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7776>>3]=+h[(a?e+12320|0:e+12312|0)>>3];i=b;return}function Ru(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+440>>3],+h[a+432>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+440>>3];l=+h[g+432>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+9184>>3]=+h[f>>3];i=b;return}function Su(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9184>>3];k=+h[g+12312>>3];l=+h[g+440>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,13248,13240,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6648>>3]=j-n;i=d;return}function Tu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9072>>3]=+h[b+8912>>3]*+h[b+6648>>3];i=i;return}function Uu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+88|0;d=b;e=b+40|0;f=b+80|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ID(e,c[g>>2]|0,1,+h[a+9184>>3],+h[a+12312>>3],+h[a+432>>3],+h[a+440>>3]);a=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+40|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));SD(f,a,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+6016>>3]=+h[f>>3];i=b;return}function Vu(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+8072>>3];h[b+7952>>3]=d*+h[(!(d>=0.0)?b+9176|0:b+9184|0)>>3];i=i;return}function Wu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8600>>3]=+h[b+7952>>3]- +h[b+7960>>3];i=i;return}function Xu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10024>>3]=+h[b+8600>>3]+(+h[b+8280>>3]+ +h[b+8440>>3]);i=i;return}function Yu(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8920>>3];k=+h[g+10024>>3]- +h[g+8760>>3]*+h[g+6616>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9704|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9704|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,13288,13280,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9704|0;p=o;h[p>>3]=m;i=d;return}function Zu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+2764>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1224>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1224|0;h[c[g+2768>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1224>>3]);e=c[f>>2]|0;h[c[e+2772>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+2764>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+10336>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+10336|0;h[(c[e+2768>>2]|0)+8>>3]=+h[g>>3];k=+b$a(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+10336>>3]);j=c[f>>2]|0;h[(c[j+2772>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+2764>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+1216>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+1216|0;h[(c[j+2768>>2]|0)+16>>3]=+h[e>>3];k=+b$a(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+1216>>3]);h[(c[(c[f>>2]|0)+2772>>2]|0)+16>>3]=k;$_a(a,34)|0;a=c[(c[f>>2]|0)+2764>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1224>>3]=+h[a>>3];h[f+10336>>3]=+h[a+8>>3];h[f+1216>>3]=+h[a+16>>3];i=b;return}function _u(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+456>>3],+h[a+448>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+456>>3];l=+h[g+448>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12304>>3]=+h[f>>3];i=b;return}function $u(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8904>>3]=+h[b+13432>>3]*+h[b+12304>>3];i=i;return}function av(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;WD(d,c[a+536>>2]|0,+h[f+12304>>3],+h[f+448>>3],+h[f+456>>3],1,1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5528>>3]=+h[d>>3];i=b;return}function bv(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12304>>3],+h[f+448>>3],+h[f+456>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5688>>3]=+h[d>>3];i=b;return}function cv(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12304>>3],+h[f+448>>3],+h[f+456>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+10936>>3]=+h[d>>3];i=b;return}function dv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;JD(d,c[a+536>>2]|0,+h[f+7128>>3],+h[f+12304>>3],+h[f+12312>>3],+h[f+10936>>3],+h[f+10944>>3],+h[j+432>>3],+h[f+13088>>3],+h[f+12648>>3]*+h[j+2904>>3],(+h[j+912>>3]+ +h[j+920>>3])*.5,+h[j+2896>>3]*.05,+h[j+2864>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+8080>>3]=+h[d>>3]*+h[(c[g>>2]|0)+2840>>3];i=b;return}function ev(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7448>>3]=+h[b+8080>>3]*+h[(c[a+416>>2]|0)+432>>3];i=i;return}function fv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+600>>3]*+h[j+12312>>3]*+h[e+2736>>3];l=+h[j+8080>>3]+ +h[j+8072>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6336|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6336|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,13320,13312,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6336|0;r=q;h[r>>3]=o;i=d;return}function gv(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;GD(d,c[a+536>>2]|0,+h[f+6336>>3],+h[f+12312>>3],+h[f+5696>>3],+h[(c[a+416>>2]|0)+760>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6176>>3]=+h[d>>3];i=b;return}function hv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+Ad(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6176>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4896|0;w=v;h[w>>3]=n;i=b;return}x=c[72300]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=20120;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Pe[a&127](y,d,13408,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4896|0;w=v;h[w>>3]=n;i=b;return}function iv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6336>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4896>>3];l=+U(+(+h[j+6176>>3]));m=+h[j+6016>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?12.5:7.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+440>>3];q=n*p;r=q!=0.0;s=+h[o+760>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+qXa(c[b+536>>2]|0,q,13520,13512,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+6016>>3];u=+h[j+4896>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5376|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+qXa(c[b+536>>2]|0,q,13520,13512,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+760>>3];M=+h[j+440>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+qXa(c[b+536>>2]|0,q,13520,13512,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5376|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+qXa(c[b+536>>2]|0,q,13520,13512,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4896>>3]*.125));L=P*(+W(+(+h[g+6016>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+qXa(c[b+536>>2]|0,L,13600,13512,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5376|0;K=J;h[K>>3]=B;i=d;return}}function jv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6336>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+6176>>3]));l=+h[j+6016>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?12.5:7.5)*+h[m+440>>3];o=+h[m+760>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+qXa(c[b+536>>2]|0,n,13520,13728,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+5056>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function kv(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+5056>>3]+-.7;h[b+5216>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function lv(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;_D(d,c[a+536>>2]|0,+h[f+5376>>3],+h[f+5216>>3],+h[f+6176>>3]+-6150.0,3850.0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5856>>3]=+h[d>>3];i=b;return}function mv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+2844>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4736>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+4736|0;h[c[g+2848>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4736>>3]);h[c[(c[f>>2]|0)+2852>>2]>>3]=k;$_a(a,35)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+4736>>3]=+h[c[(c[f>>2]|0)+2844>>2]>>3];i=b;return}function nv(a){a=a|0;var b=0,d=0,e=0;b=i;R_a(a,27)|0;d=c[(c[a+476>>2]|0)+1756>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+9536>>3]=+h[d>>3];h[e+8432>>3]=+h[d+8>>3];i=b;return}function ov(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2696>>3]*+h[e+96>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=-+h[j+8432>>3]- +h[j+3752>>3];if(f!=0.0){l=j;m=k/f;n=l;o=n+1536|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+1536|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,f,13744,13736,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1536|0;p=o;h[p>>3]=m;i=d;return}function pv(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+8272>>3]=+h[b+6336>>3]*+h[d+600>>3]*+h[d+2736>>3]*(+h[b+424>>3]*.5+(+h[b+456>>3]*-.5+(+h[b+7128>>3]+ +h[b+7136>>3])*.5));i=i;return}function qv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8752>>3]=+h[b+8080>>3]- +h[b+8072>>3];i=i;return}function rv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+13440>>3];k=+h[g+8752>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+10480|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+10480|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,13792,13784,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+10480|0;p=o;h[p>>3]=m;i=d;return}function sv(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8080>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7608>>3]=+h[(a?e+10944|0:e+10936|0)>>3];i=b;return}function tv(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8080>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7768>>3]=+h[(a?e+12312|0:e+12304|0)>>3];i=b;return}function uv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+456>>3],+h[a+448>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+456>>3];l=+h[g+448>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+9192>>3]=+h[f>>3];i=b;return}function vv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9192>>3];k=+h[g+12304>>3];l=+h[g+456>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,13832,13824,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6680>>3]=j-n;i=d;return}function wv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9064>>3]=+h[b+8904>>3]*+h[b+6680>>3];i=i;return}function xv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+88|0;d=b;e=b+40|0;f=b+80|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ID(e,c[g>>2]|0,1,+h[a+9192>>3],+h[a+12304>>3],+h[a+448>>3],+h[a+456>>3]);a=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+40|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));SD(f,a,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+6008>>3]=+h[f>>3];i=b;return}function yv(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+8080>>3];h[b+7944>>3]=d*+h[(!(d>=0.0)?b+9184|0:b+9192|0)>>3];i=i;return}function zv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8592>>3]=+h[b+7944>>3]- +h[b+7952>>3];i=i;return}function Av(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10016>>3]=+h[b+8592>>3]+(+h[b+8272>>3]+ +h[b+8432>>3]);i=i;return}function Bv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8912>>3];k=+h[g+10016>>3]- +h[g+8752>>3]*+h[g+6648>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9696|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9696|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,13872,13864,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9696|0;p=o;h[p>>3]=m;i=d;return}function Cv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+2924>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1240>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1240|0;h[c[g+2928>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1240>>3]);e=c[f>>2]|0;h[c[e+2932>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+2924>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+10328>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+10328|0;h[(c[e+2928>>2]|0)+8>>3]=+h[g>>3];k=+b$a(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+10328>>3]);j=c[f>>2]|0;h[(c[j+2932>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+2924>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+1232>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+1232|0;h[(c[j+2928>>2]|0)+16>>3]=+h[e>>3];k=+b$a(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+1232>>3]);h[(c[(c[f>>2]|0)+2932>>2]|0)+16>>3]=k;$_a(a,36)|0;a=c[(c[f>>2]|0)+2924>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1240>>3]=+h[a>>3];h[f+10328>>3]=+h[a+8>>3];h[f+1232>>3]=+h[a+16>>3];i=b;return}function Dv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+472>>3],+h[a+464>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+472>>3];l=+h[g+464>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12296>>3]=+h[f>>3];i=b;return}function Ev(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8896>>3]=+h[b+13424>>3]*+h[b+12296>>3];i=i;return}function Fv(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;WD(d,c[a+536>>2]|0,+h[f+12296>>3],+h[f+464>>3],+h[f+472>>3],1,1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5520>>3]=+h[d>>3];i=b;return}function Gv(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12296>>3],+h[f+464>>3],+h[f+472>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5680>>3]=+h[d>>3];i=b;return}function Hv(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12296>>3],+h[f+464>>3],+h[f+472>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+10928>>3]=+h[d>>3];i=b;return}function Iv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;JD(d,c[a+536>>2]|0,+h[f+7120>>3],+h[f+12296>>3],+h[f+12304>>3],+h[f+10928>>3],+h[f+10936>>3],+h[j+424>>3],+h[f+13096>>3],+h[f+12640>>3]*+h[j+2904>>3],(+h[j+904>>3]+ +h[j+912>>3])*.5,+h[j+2896>>3]*.05,+h[j+2864>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+8088>>3]=+h[d>>3]*+h[(c[g>>2]|0)+2840>>3];i=b;return}function Jv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7440>>3]=+h[b+8088>>3]*+h[(c[a+416>>2]|0)+424>>3];i=i;return}function Kv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+592>>3]*+h[j+12304>>3]*+h[e+2736>>3];l=+h[j+8088>>3]+ +h[j+8080>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6328|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6328|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,13904,13896,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6328|0;r=q;h[r>>3]=o;i=d;return}function Lv(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;GD(d,c[a+536>>2]|0,+h[f+6328>>3],+h[f+12304>>3],+h[f+5688>>3],+h[(c[a+416>>2]|0)+752>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6168>>3]=+h[d>>3];i=b;return}function Mv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+Ad(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6168>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4888|0;w=v;h[w>>3]=n;i=b;return}x=c[72300]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=20120;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Pe[a&127](y,d,13992,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4888|0;w=v;h[w>>3]=n;i=b;return}function Nv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6328>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4888>>3];l=+U(+(+h[j+6168>>3]));m=+h[j+6008>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?11.5:8.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+432>>3];q=n*p;r=q!=0.0;s=+h[o+752>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+qXa(c[b+536>>2]|0,q,14104,14096,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+6008>>3];u=+h[j+4888>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5368|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+qXa(c[b+536>>2]|0,q,14104,14096,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+752>>3];M=+h[j+432>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+qXa(c[b+536>>2]|0,q,14104,14096,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5368|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+qXa(c[b+536>>2]|0,q,14104,14096,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4888>>3]*.125));L=P*(+W(+(+h[g+6008>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+qXa(c[b+536>>2]|0,L,14184,14096,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5368|0;K=J;h[K>>3]=B;i=d;return}}function Ov(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6328>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+6168>>3]));l=+h[j+6008>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?11.5:8.5)*+h[m+432>>3];o=+h[m+752>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+qXa(c[b+536>>2]|0,n,14104,14312,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+5048>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function Pv(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+5048>>3]+-.7;h[b+5208>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function Qv(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;_D(d,c[a+536>>2]|0,+h[f+5368>>3],+h[f+5208>>3],+h[f+6168>>3]+-6150.0,3850.0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5848>>3]=+h[d>>3];i=b;return}function Rv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+3004>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4728>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+4728|0;h[c[g+3008>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4728>>3]);h[c[(c[f>>2]|0)+3012>>2]>>3]=k;$_a(a,37)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+4728>>3]=+h[c[(c[f>>2]|0)+3004>>2]>>3];i=b;return}function Sv(a){a=a|0;var b=0,d=0,e=0;b=i;R_a(a,28)|0;d=c[(c[a+476>>2]|0)+1820>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+8424>>3]=+h[d>>3];h[e+9528>>3]=+h[d+8>>3];i=b;return}function Tv(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2696>>3]*+h[e+88>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=-+h[j+8424>>3]- +h[j+3760>>3];if(f!=0.0){l=j;m=k/f;n=l;o=n+1528|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+1528|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,f,14328,14320,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1528|0;p=o;h[p>>3]=m;i=d;return}function Uv(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+8264>>3]=+h[b+6328>>3]*+h[d+592>>3]*+h[d+2736>>3]*(+h[b+440>>3]*.5+(+h[b+472>>3]*-.5+(+h[b+7120>>3]+ +h[b+7128>>3])*.5));i=i;return}function Vv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8744>>3]=+h[b+8088>>3]- +h[b+8080>>3];i=i;return}function Wv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+13432>>3];k=+h[g+8744>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+10472|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+10472|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,14376,14368,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+10472|0;p=o;h[p>>3]=m;i=d;return}function Xv(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8088>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7600>>3]=+h[(a?e+10936|0:e+10928|0)>>3];i=b;return}function Yv(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8088>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7760>>3]=+h[(a?e+12304|0:e+12296|0)>>3];i=b;return}function Zv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+472>>3],+h[a+464>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+472>>3];l=+h[g+464>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+9200>>3]=+h[f>>3];i=b;return}function _v(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9200>>3];k=+h[g+12296>>3];l=+h[g+472>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,14416,14408,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6712>>3]=j-n;i=d;return}function $v(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9056>>3]=+h[b+8896>>3]*+h[b+6712>>3];i=i;return}function aw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+88|0;d=b;e=b+40|0;f=b+80|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ID(e,c[g>>2]|0,1,+h[a+9200>>3],+h[a+12296>>3],+h[a+464>>3],+h[a+472>>3]);a=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+40|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));SD(f,a,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+6e3>>3]=+h[f>>3];i=b;return}function bw(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+8088>>3];h[b+7936>>3]=d*+h[(!(d>=0.0)?b+9192|0:b+9200|0)>>3];i=i;return}function cw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8584>>3]=+h[b+7936>>3]- +h[b+7944>>3];i=i;return}function dw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10008>>3]=+h[b+8584>>3]+(+h[b+8264>>3]+ +h[b+8424>>3]);i=i;return}function ew(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8904>>3];k=+h[g+10008>>3]- +h[g+8744>>3]*+h[g+6680>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9688|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9688|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,14456,14448,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9688|0;p=o;h[p>>3]=m;i=d;return}function fw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+3084>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1256>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1256|0;h[c[g+3088>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1256>>3]);e=c[f>>2]|0;h[c[e+3092>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+3084>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+10320>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+10320|0;h[(c[e+3088>>2]|0)+8>>3]=+h[g>>3];k=+b$a(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+10320>>3]);j=c[f>>2]|0;h[(c[j+3092>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+3084>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+1248>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+1248|0;h[(c[j+3088>>2]|0)+16>>3]=+h[e>>3];k=+b$a(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+1248>>3]);h[(c[(c[f>>2]|0)+3092>>2]|0)+16>>3]=k;$_a(a,38)|0;a=c[(c[f>>2]|0)+3084>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1256>>3]=+h[a>>3];h[f+10320>>3]=+h[a+8>>3];h[f+1248>>3]=+h[a+16>>3];i=b;return}function gw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+488>>3],+h[a+480>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+488>>3];l=+h[g+480>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12288>>3]=+h[f>>3];i=b;return}function hw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8888>>3]=+h[b+13416>>3]*+h[b+12288>>3];i=i;return}function iw(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;WD(d,c[a+536>>2]|0,+h[f+12288>>3],+h[f+480>>3],+h[f+488>>3],1,1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5512>>3]=+h[d>>3];i=b;return}function jw(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12288>>3],+h[f+480>>3],+h[f+488>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5672>>3]=+h[d>>3];i=b;return}function kw(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12288>>3],+h[f+480>>3],+h[f+488>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+10920>>3]=+h[d>>3];i=b;return}function lw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;JD(d,c[a+536>>2]|0,+h[f+7112>>3],+h[f+12288>>3],+h[f+12296>>3],+h[f+10920>>3],+h[f+10928>>3],+h[j+416>>3],+h[f+13104>>3],+h[f+12632>>3]*+h[j+2904>>3],(+h[j+896>>3]+ +h[j+904>>3])*.5,+h[j+2896>>3]*.05,+h[j+2864>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+8096>>3]=+h[d>>3]*+h[(c[g>>2]|0)+2840>>3];i=b;return}function mw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7432>>3]=+h[b+8096>>3]*+h[(c[a+416>>2]|0)+416>>3];i=i;return}function nw(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+584>>3]*+h[j+12296>>3]*+h[e+2736>>3];l=+h[j+8096>>3]+ +h[j+8088>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6320|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6320|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,14488,14480,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6320|0;r=q;h[r>>3]=o;i=d;return}function ow(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;GD(d,c[a+536>>2]|0,+h[f+6320>>3],+h[f+12296>>3],+h[f+5680>>3],+h[(c[a+416>>2]|0)+744>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6160>>3]=+h[d>>3];i=b;return}function pw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+Ad(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6160>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4880|0;w=v;h[w>>3]=n;i=b;return}x=c[72300]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=20120;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Pe[a&127](y,d,14576,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4880|0;w=v;h[w>>3]=n;i=b;return}function qw(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6320>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4880>>3];l=+U(+(+h[j+6160>>3]));m=+h[j+6e3>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?10.5:9.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+424>>3];q=n*p;r=q!=0.0;s=+h[o+744>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+qXa(c[b+536>>2]|0,q,14688,14680,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+6e3>>3];u=+h[j+4880>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5360|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+qXa(c[b+536>>2]|0,q,14688,14680,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+744>>3];M=+h[j+424>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+qXa(c[b+536>>2]|0,q,14688,14680,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5360|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+qXa(c[b+536>>2]|0,q,14688,14680,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4880>>3]*.125));L=P*(+W(+(+h[g+6e3>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+qXa(c[b+536>>2]|0,L,14768,14680,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5360|0;K=J;h[K>>3]=B;i=d;return}}function rw(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6320>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+6160>>3]));l=+h[j+6e3>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?10.5:9.5)*+h[m+424>>3];o=+h[m+744>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+qXa(c[b+536>>2]|0,n,14688,14896,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+5040>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function sw(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+5040>>3]+-.7;h[b+5200>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function tw(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;_D(d,c[a+536>>2]|0,+h[f+5360>>3],+h[f+5200>>3],+h[f+6160>>3]+-6150.0,3850.0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5840>>3]=+h[d>>3];i=b;return}function uw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+3164>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4720>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+4720|0;h[c[g+3168>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4720>>3]);h[c[(c[f>>2]|0)+3172>>2]>>3]=k;$_a(a,39)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+4720>>3]=+h[c[(c[f>>2]|0)+3164>>2]>>3];i=b;return}function vw(a){a=a|0;var b=0,d=0,e=0;b=i;R_a(a,29)|0;d=c[(c[a+476>>2]|0)+1884>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+9520>>3]=+h[d>>3];h[e+8416>>3]=+h[d+8>>3];i=b;return}function ww(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2696>>3]*+h[e+80>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=-+h[j+8416>>3]- +h[j+3768>>3];if(f!=0.0){l=j;m=k/f;n=l;o=n+1520|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+1520|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,f,14912,14904,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1520|0;p=o;h[p>>3]=m;i=d;return}function xw(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+8256>>3]=+h[b+6320>>3]*+h[d+584>>3]*+h[d+2736>>3]*(+h[b+456>>3]*.5+(+h[b+488>>3]*-.5+(+h[b+7112>>3]+ +h[b+7120>>3])*.5));i=i;return}function yw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8736>>3]=+h[b+8096>>3]- +h[b+8088>>3];i=i;return}function zw(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+13424>>3];k=+h[g+8736>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+10464|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+10464|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,14960,14952,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+10464|0;p=o;h[p>>3]=m;i=d;return}function Aw(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8096>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7592>>3]=+h[(a?e+10928|0:e+10920|0)>>3];i=b;return}function Bw(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8096>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7752>>3]=+h[(a?e+12296|0:e+12288|0)>>3];i=b;return}function Cw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+488>>3],+h[a+480>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+488>>3];l=+h[g+480>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+9208>>3]=+h[f>>3];i=b;return}function Dw(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9208>>3];k=+h[g+12288>>3];l=+h[g+488>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,15e3,14992,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6744>>3]=j-n;i=d;return}function Ew(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9048>>3]=+h[b+8888>>3]*+h[b+6744>>3];i=i;return}function Fw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+88|0;d=b;e=b+40|0;f=b+80|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ID(e,c[g>>2]|0,1,+h[a+9208>>3],+h[a+12288>>3],+h[a+480>>3],+h[a+488>>3]);a=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+40|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));SD(f,a,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5992>>3]=+h[f>>3];i=b;return}function Gw(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+8096>>3];h[b+7928>>3]=d*+h[(!(d>=0.0)?b+9200|0:b+9208|0)>>3];i=i;return}function Hw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8576>>3]=+h[b+7928>>3]- +h[b+7936>>3];i=i;return}function Iw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1e4>>3]=+h[b+8576>>3]+(+h[b+8256>>3]+ +h[b+8416>>3]);i=i;return}function Jw(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8896>>3];k=+h[g+1e4>>3]- +h[g+8736>>3]*+h[g+6712>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9680|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9680|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,15040,15032,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9680|0;p=o;h[p>>3]=m;i=d;return}function Kw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+3244>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1272>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1272|0;h[c[g+3248>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1272>>3]);e=c[f>>2]|0;h[c[e+3252>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+3244>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+10312>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+10312|0;h[(c[e+3248>>2]|0)+8>>3]=+h[g>>3];k=+b$a(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+10312>>3]);j=c[f>>2]|0;h[(c[j+3252>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+3244>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+1264>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+1264|0;h[(c[j+3248>>2]|0)+16>>3]=+h[e>>3];k=+b$a(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+1264>>3]);h[(c[(c[f>>2]|0)+3252>>2]|0)+16>>3]=k;$_a(a,40)|0;a=c[(c[f>>2]|0)+3244>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1272>>3]=+h[a>>3];h[f+10312>>3]=+h[a+8>>3];h[f+1264>>3]=+h[a+16>>3];i=b;return}function Lw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+504>>3],+h[a+496>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+504>>3];l=+h[g+496>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12280>>3]=+h[f>>3];i=b;return}function Mw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8880>>3]=+h[b+13408>>3]*+h[b+12280>>3];i=i;return}function Nw(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;WD(d,c[a+536>>2]|0,+h[f+12280>>3],+h[f+496>>3],+h[f+504>>3],1,1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5504>>3]=+h[d>>3];i=b;return}function Ow(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12280>>3],+h[f+496>>3],+h[f+504>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5664>>3]=+h[d>>3];i=b;return}function Pw(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12280>>3],+h[f+496>>3],+h[f+504>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+10912>>3]=+h[d>>3];i=b;return}function Qw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;JD(d,c[a+536>>2]|0,+h[f+7104>>3],+h[f+12280>>3],+h[f+12288>>3],+h[f+10912>>3],+h[f+10920>>3],+h[j+408>>3],+h[f+13112>>3],+h[f+12624>>3]*+h[j+2904>>3],(+h[j+888>>3]+ +h[j+896>>3])*.5,+h[j+2896>>3]*.05,+h[j+2864>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+8104>>3]=+h[d>>3]*+h[(c[g>>2]|0)+2840>>3];i=b;return}function Rw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7424>>3]=+h[b+8104>>3]*+h[(c[a+416>>2]|0)+408>>3];i=i;return}function Sw(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+576>>3]*+h[j+12288>>3]*+h[e+2736>>3];l=+h[j+8104>>3]+ +h[j+8096>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6312|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6312|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,15072,15064,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6312|0;r=q;h[r>>3]=o;i=d;return}function Tw(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;GD(d,c[a+536>>2]|0,+h[f+6312>>3],+h[f+12288>>3],+h[f+5672>>3],+h[(c[a+416>>2]|0)+736>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6152>>3]=+h[d>>3];i=b;return}function Uw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+Ad(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6152>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4872|0;w=v;h[w>>3]=n;i=b;return}x=c[72300]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=20120;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Pe[a&127](y,d,15160,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4872|0;w=v;h[w>>3]=n;i=b;return}



function Vw(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6312>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4872>>3];l=+U(+(+h[j+6152>>3]));m=+h[j+5992>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?9.5:10.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+416>>3];q=n*p;r=q!=0.0;s=+h[o+736>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+qXa(c[b+536>>2]|0,q,15272,15264,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+5992>>3];u=+h[j+4872>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5352|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+qXa(c[b+536>>2]|0,q,15272,15264,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+736>>3];M=+h[j+416>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+qXa(c[b+536>>2]|0,q,15272,15264,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5352|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+qXa(c[b+536>>2]|0,q,15272,15264,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4872>>3]*.125));L=P*(+W(+(+h[g+5992>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+qXa(c[b+536>>2]|0,L,15352,15264,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5352|0;K=J;h[K>>3]=B;i=d;return}}function Ww(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6312>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+6152>>3]));l=+h[j+5992>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?9.5:10.5)*+h[m+416>>3];o=+h[m+736>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+qXa(c[b+536>>2]|0,n,15272,15480,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+5032>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function Xw(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+5032>>3]+-.7;h[b+5192>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function Yw(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;_D(d,c[a+536>>2]|0,+h[f+5352>>3],+h[f+5192>>3],+h[f+6152>>3]+-6150.0,3850.0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5832>>3]=+h[d>>3];i=b;return}function Zw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+3324>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4712>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+4712|0;h[c[g+3328>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4712>>3]);h[c[(c[f>>2]|0)+3332>>2]>>3]=k;$_a(a,41)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+4712>>3]=+h[c[(c[f>>2]|0)+3324>>2]>>3];i=b;return}function _w(a){a=a|0;var b=0,d=0,e=0;b=i;R_a(a,30)|0;d=c[(c[a+476>>2]|0)+1948>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+8408>>3]=+h[d>>3];h[e+9512>>3]=+h[d+8>>3];i=b;return}function $w(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2696>>3]*+h[e+72>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=-+h[j+8408>>3]- +h[j+3776>>3];if(f!=0.0){l=j;m=k/f;n=l;o=n+1512|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+1512|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,f,15496,15488,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1512|0;p=o;h[p>>3]=m;i=d;return}function ax(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+8248>>3]=+h[b+6312>>3]*+h[d+576>>3]*+h[d+2736>>3]*(+h[b+472>>3]*.5+(+h[b+504>>3]*-.5+(+h[b+7104>>3]+ +h[b+7112>>3])*.5));i=i;return}function bx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8728>>3]=+h[b+8104>>3]- +h[b+8096>>3];i=i;return}function cx(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+13416>>3];k=+h[g+8728>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+10456|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+10456|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,15544,15536,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+10456|0;p=o;h[p>>3]=m;i=d;return}function dx(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8104>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7584>>3]=+h[(a?e+10920|0:e+10912|0)>>3];i=b;return}function ex(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8104>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7744>>3]=+h[(a?e+12288|0:e+12280|0)>>3];i=b;return}function fx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+504>>3],+h[a+496>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+504>>3];l=+h[g+496>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+9216>>3]=+h[f>>3];i=b;return}function gx(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9216>>3];k=+h[g+12280>>3];l=+h[g+504>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,15584,15576,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6776>>3]=j-n;i=d;return}function hx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9040>>3]=+h[b+8880>>3]*+h[b+6776>>3];i=i;return}function ix(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+88|0;d=b;e=b+40|0;f=b+80|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ID(e,c[g>>2]|0,1,+h[a+9216>>3],+h[a+12280>>3],+h[a+496>>3],+h[a+504>>3]);a=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+40|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));SD(f,a,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5984>>3]=+h[f>>3];i=b;return}function jx(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+8104>>3];h[b+7920>>3]=d*+h[(!(d>=0.0)?b+9208|0:b+9216|0)>>3];i=i;return}function kx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8568>>3]=+h[b+7920>>3]- +h[b+7928>>3];i=i;return}function lx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9992>>3]=+h[b+8568>>3]+(+h[b+8248>>3]+ +h[b+8408>>3]);i=i;return}function mx(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8888>>3];k=+h[g+9992>>3]- +h[g+8728>>3]*+h[g+6744>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9672|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9672|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,15624,15616,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9672|0;p=o;h[p>>3]=m;i=d;return}function nx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+3404>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1288>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1288|0;h[c[g+3408>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1288>>3]);e=c[f>>2]|0;h[c[e+3412>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+3404>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+10304>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+10304|0;h[(c[e+3408>>2]|0)+8>>3]=+h[g>>3];k=+b$a(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+10304>>3]);j=c[f>>2]|0;h[(c[j+3412>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+3404>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+1280>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+1280|0;h[(c[j+3408>>2]|0)+16>>3]=+h[e>>3];k=+b$a(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+1280>>3]);h[(c[(c[f>>2]|0)+3412>>2]|0)+16>>3]=k;$_a(a,42)|0;a=c[(c[f>>2]|0)+3404>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1288>>3]=+h[a>>3];h[f+10304>>3]=+h[a+8>>3];h[f+1280>>3]=+h[a+16>>3];i=b;return}function ox(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+520>>3],+h[a+512>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+520>>3];l=+h[g+512>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12272>>3]=+h[f>>3];i=b;return}function px(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8872>>3]=+h[b+13400>>3]*+h[b+12272>>3];i=i;return}function qx(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;WD(d,c[a+536>>2]|0,+h[f+12272>>3],+h[f+512>>3],+h[f+520>>3],1,1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5496>>3]=+h[d>>3];i=b;return}function rx(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12272>>3],+h[f+512>>3],+h[f+520>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5656>>3]=+h[d>>3];i=b;return}function sx(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12272>>3],+h[f+512>>3],+h[f+520>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+10904>>3]=+h[d>>3];i=b;return}function tx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;JD(d,c[a+536>>2]|0,+h[f+7096>>3],+h[f+12272>>3],+h[f+12280>>3],+h[f+10904>>3],+h[f+10912>>3],+h[j+400>>3],+h[f+13120>>3],+h[f+12616>>3]*+h[j+2904>>3],(+h[j+880>>3]+ +h[j+888>>3])*.5,+h[j+2896>>3]*.05,+h[j+2864>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+8112>>3]=+h[d>>3]*+h[(c[g>>2]|0)+2840>>3];i=b;return}function ux(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7416>>3]=+h[b+8112>>3]*+h[(c[a+416>>2]|0)+400>>3];i=i;return}function vx(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+568>>3]*+h[j+12280>>3]*+h[e+2736>>3];l=+h[j+8112>>3]+ +h[j+8104>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6304|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6304|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,15656,15648,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6304|0;r=q;h[r>>3]=o;i=d;return}function wx(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;GD(d,c[a+536>>2]|0,+h[f+6304>>3],+h[f+12280>>3],+h[f+5664>>3],+h[(c[a+416>>2]|0)+728>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6144>>3]=+h[d>>3];i=b;return}function xx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+Ad(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6144>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4864|0;w=v;h[w>>3]=n;i=b;return}x=c[72300]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=20120;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Pe[a&127](y,d,15736,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4864|0;w=v;h[w>>3]=n;i=b;return}function yx(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6304>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4864>>3];l=+U(+(+h[j+6144>>3]));m=+h[j+5984>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?8.5:11.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+408>>3];q=n*p;r=q!=0.0;s=+h[o+728>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+qXa(c[b+536>>2]|0,q,15840,15832,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+5984>>3];u=+h[j+4864>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5344|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+qXa(c[b+536>>2]|0,q,15840,15832,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+728>>3];M=+h[j+408>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+qXa(c[b+536>>2]|0,q,15840,15832,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5344|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+qXa(c[b+536>>2]|0,q,15840,15832,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4864>>3]*.125));L=P*(+W(+(+h[g+5984>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+qXa(c[b+536>>2]|0,L,15912,15832,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5344|0;K=J;h[K>>3]=B;i=d;return}}function zx(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6304>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+6144>>3]));l=+h[j+5984>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?8.5:11.5)*+h[m+408>>3];o=+h[m+728>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+qXa(c[b+536>>2]|0,n,15840,16040,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+5024>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function Ax(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+5024>>3]+-.7;h[b+5184>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function Bx(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;_D(d,c[a+536>>2]|0,+h[f+5344>>3],+h[f+5184>>3],+h[f+6144>>3]+-6150.0,3850.0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5824>>3]=+h[d>>3];i=b;return}function Cx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+3484>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4704>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+4704|0;h[c[g+3488>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4704>>3]);h[c[(c[f>>2]|0)+3492>>2]>>3]=k;$_a(a,43)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+4704>>3]=+h[c[(c[f>>2]|0)+3484>>2]>>3];i=b;return}function Dx(a){a=a|0;var b=0,d=0,e=0;b=i;R_a(a,31)|0;d=c[(c[a+476>>2]|0)+2012>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+9504>>3]=+h[d>>3];h[e+8400>>3]=+h[d+8>>3];i=b;return}function Ex(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2696>>3]*+h[e+64>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=-+h[j+8400>>3]- +h[j+3784>>3];if(f!=0.0){l=j;m=k/f;n=l;o=n+1504|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+1504|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,f,16056,16048,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1504|0;p=o;h[p>>3]=m;i=d;return}function Fx(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+8240>>3]=+h[b+6304>>3]*+h[d+568>>3]*+h[d+2736>>3]*(+h[b+488>>3]*.5+(+h[b+520>>3]*-.5+(+h[b+7096>>3]+ +h[b+7104>>3])*.5));i=i;return}function Gx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8720>>3]=+h[b+8112>>3]- +h[b+8104>>3];i=i;return}function Hx(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+13408>>3];k=+h[g+8720>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+10448|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+10448|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,16096,16088,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+10448|0;p=o;h[p>>3]=m;i=d;return}function Ix(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8112>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7576>>3]=+h[(a?e+10912|0:e+10904|0)>>3];i=b;return}function Jx(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8112>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7736>>3]=+h[(a?e+12280|0:e+12272|0)>>3];i=b;return}function Kx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+520>>3],+h[a+512>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+520>>3];l=+h[g+512>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+9224>>3]=+h[f>>3];i=b;return}function Lx(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9224>>3];k=+h[g+12272>>3];l=+h[g+520>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,16136,16128,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6808>>3]=j-n;i=d;return}function Mx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9032>>3]=+h[b+8872>>3]*+h[b+6808>>3];i=i;return}function Nx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+88|0;d=b;e=b+40|0;f=b+80|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ID(e,c[g>>2]|0,1,+h[a+9224>>3],+h[a+12272>>3],+h[a+512>>3],+h[a+520>>3]);a=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+40|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));SD(f,a,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5976>>3]=+h[f>>3];i=b;return}function Ox(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+8112>>3];h[b+7912>>3]=d*+h[(!(d>=0.0)?b+9216|0:b+9224|0)>>3];i=i;return}function Px(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8560>>3]=+h[b+7912>>3]- +h[b+7920>>3];i=i;return}function Qx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9984>>3]=+h[b+8560>>3]+(+h[b+8240>>3]+ +h[b+8400>>3]);i=i;return}function Rx(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8880>>3];k=+h[g+9984>>3]- +h[g+8720>>3]*+h[g+6776>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9664|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9664|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,16176,16168,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9664|0;p=o;h[p>>3]=m;i=d;return}function Sx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+3564>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1304>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1304|0;h[c[g+3568>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1304>>3]);e=c[f>>2]|0;h[c[e+3572>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+3564>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+10296>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+10296|0;h[(c[e+3568>>2]|0)+8>>3]=+h[g>>3];k=+b$a(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+10296>>3]);j=c[f>>2]|0;h[(c[j+3572>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+3564>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+1296>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+1296|0;h[(c[j+3568>>2]|0)+16>>3]=+h[e>>3];k=+b$a(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+1296>>3]);h[(c[(c[f>>2]|0)+3572>>2]|0)+16>>3]=k;$_a(a,44)|0;a=c[(c[f>>2]|0)+3564>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1304>>3]=+h[a>>3];h[f+10296>>3]=+h[a+8>>3];h[f+1296>>3]=+h[a+16>>3];i=b;return}function Tx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+536>>3],+h[a+528>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+536>>3];l=+h[g+528>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12264>>3]=+h[f>>3];i=b;return}function Ux(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8864>>3]=+h[b+13392>>3]*+h[b+12264>>3];i=i;return}function Vx(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;WD(d,c[a+536>>2]|0,+h[f+12264>>3],+h[f+528>>3],+h[f+536>>3],1,1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5488>>3]=+h[d>>3];i=b;return}function Wx(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12264>>3],+h[f+528>>3],+h[f+536>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5648>>3]=+h[d>>3];i=b;return}function Xx(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12264>>3],+h[f+528>>3],+h[f+536>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+10896>>3]=+h[d>>3];i=b;return}function Yx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;JD(d,c[a+536>>2]|0,+h[f+7088>>3],+h[f+12264>>3],+h[f+12272>>3],+h[f+10896>>3],+h[f+10904>>3],+h[j+392>>3],+h[f+13128>>3],+h[f+12608>>3]*+h[j+2904>>3],(+h[j+872>>3]+ +h[j+880>>3])*.5,+h[j+2896>>3]*.05,+h[j+2864>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+8120>>3]=+h[d>>3]*+h[(c[g>>2]|0)+2840>>3];i=b;return}function Zx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7408>>3]=+h[b+8120>>3]*+h[(c[a+416>>2]|0)+392>>3];i=i;return}function _x(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+560>>3]*+h[j+12272>>3]*+h[e+2736>>3];l=+h[j+8120>>3]+ +h[j+8112>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6296|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6296|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,16208,16200,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6296|0;r=q;h[r>>3]=o;i=d;return}function $x(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;GD(d,c[a+536>>2]|0,+h[f+6296>>3],+h[f+12272>>3],+h[f+5656>>3],+h[(c[a+416>>2]|0)+720>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6136>>3]=+h[d>>3];i=b;return}function ay(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+Ad(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6136>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4856|0;w=v;h[w>>3]=n;i=b;return}x=c[72300]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=20120;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Pe[a&127](y,d,16288,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4856|0;w=v;h[w>>3]=n;i=b;return}function by(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6296>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4856>>3];l=+U(+(+h[j+6136>>3]));m=+h[j+5976>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?7.5:12.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+400>>3];q=n*p;r=q!=0.0;s=+h[o+720>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+qXa(c[b+536>>2]|0,q,16392,16384,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+5976>>3];u=+h[j+4856>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5336|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+qXa(c[b+536>>2]|0,q,16392,16384,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+720>>3];M=+h[j+400>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+qXa(c[b+536>>2]|0,q,16392,16384,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5336|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+qXa(c[b+536>>2]|0,q,16392,16384,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4856>>3]*.125));L=P*(+W(+(+h[g+5976>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+qXa(c[b+536>>2]|0,L,16464,16384,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5336|0;K=J;h[K>>3]=B;i=d;return}}function cy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6296>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+6136>>3]));l=+h[j+5976>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?7.5:12.5)*+h[m+400>>3];o=+h[m+720>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+qXa(c[b+536>>2]|0,n,16392,16592,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+5016>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function dy(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+5016>>3]+-.7;h[b+5176>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function ey(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;_D(d,c[a+536>>2]|0,+h[f+5336>>3],+h[f+5176>>3],+h[f+6136>>3]+-6150.0,3850.0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5816>>3]=+h[d>>3];i=b;return}function fy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+3644>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4696>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+4696|0;h[c[g+3648>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4696>>3]);h[c[(c[f>>2]|0)+3652>>2]>>3]=k;$_a(a,45)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+4696>>3]=+h[c[(c[f>>2]|0)+3644>>2]>>3];i=b;return}function gy(a){a=a|0;var b=0,d=0,e=0;b=i;R_a(a,32)|0;d=c[(c[a+476>>2]|0)+2076>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+8392>>3]=+h[d>>3];h[e+9496>>3]=+h[d+8>>3];i=b;return}function hy(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2696>>3]*+h[e+56>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=-+h[j+8392>>3]- +h[j+3792>>3];if(f!=0.0){l=j;m=k/f;n=l;o=n+1496|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+1496|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,f,16608,16600,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1496|0;p=o;h[p>>3]=m;i=d;return}function iy(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+8232>>3]=+h[b+6296>>3]*+h[d+560>>3]*+h[d+2736>>3]*(+h[b+504>>3]*.5+(+h[b+536>>3]*-.5+(+h[b+7088>>3]+ +h[b+7096>>3])*.5));i=i;return}function jy(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8712>>3]=+h[b+8120>>3]- +h[b+8112>>3];i=i;return}function ky(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+13400>>3];k=+h[g+8712>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+10440|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+10440|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,16648,16640,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+10440|0;p=o;h[p>>3]=m;i=d;return}function ly(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8120>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7568>>3]=+h[(a?e+10904|0:e+10896|0)>>3];i=b;return}function my(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8120>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7728>>3]=+h[(a?e+12272|0:e+12264|0)>>3];i=b;return}function ny(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+536>>3],+h[a+528>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+536>>3];l=+h[g+528>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+9232>>3]=+h[f>>3];i=b;return}function oy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9232>>3];k=+h[g+12264>>3];l=+h[g+536>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,16688,16680,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6840>>3]=j-n;i=d;return}function py(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9024>>3]=+h[b+8864>>3]*+h[b+6840>>3];i=i;return}function qy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+88|0;d=b;e=b+40|0;f=b+80|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ID(e,c[g>>2]|0,1,+h[a+9232>>3],+h[a+12264>>3],+h[a+528>>3],+h[a+536>>3]);a=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+40|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));SD(f,a,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5968>>3]=+h[f>>3];i=b;return}function ry(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+8120>>3];h[b+7904>>3]=d*+h[(!(d>=0.0)?b+9224|0:b+9232|0)>>3];i=i;return}function sy(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8552>>3]=+h[b+7904>>3]- +h[b+7912>>3];i=i;return}function ty(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9976>>3]=+h[b+8552>>3]+(+h[b+8232>>3]+ +h[b+8392>>3]);i=i;return}function uy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8872>>3];k=+h[g+9976>>3]- +h[g+8712>>3]*+h[g+6808>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9656|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9656|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,16728,16720,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9656|0;p=o;h[p>>3]=m;i=d;return}function vy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+3724>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1320>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1320|0;h[c[g+3728>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1320>>3]);e=c[f>>2]|0;h[c[e+3732>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+3724>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+10288>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+10288|0;h[(c[e+3728>>2]|0)+8>>3]=+h[g>>3];k=+b$a(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+10288>>3]);j=c[f>>2]|0;h[(c[j+3732>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+3724>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+1312>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+1312|0;h[(c[j+3728>>2]|0)+16>>3]=+h[e>>3];k=+b$a(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+1312>>3]);h[(c[(c[f>>2]|0)+3732>>2]|0)+16>>3]=k;$_a(a,46)|0;a=c[(c[f>>2]|0)+3724>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1320>>3]=+h[a>>3];h[f+10288>>3]=+h[a+8>>3];h[f+1312>>3]=+h[a+16>>3];i=b;return}function wy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+552>>3],+h[a+544>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+552>>3];l=+h[g+544>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12256>>3]=+h[f>>3];i=b;return}function xy(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8856>>3]=+h[b+13384>>3]*+h[b+12256>>3];i=i;return}function yy(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;WD(d,c[a+536>>2]|0,+h[f+12256>>3],+h[f+544>>3],+h[f+552>>3],1,1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5480>>3]=+h[d>>3];i=b;return}function zy(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12256>>3],+h[f+544>>3],+h[f+552>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5640>>3]=+h[d>>3];i=b;return}function Ay(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12256>>3],+h[f+544>>3],+h[f+552>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+10888>>3]=+h[d>>3];i=b;return}function By(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;JD(d,c[a+536>>2]|0,+h[f+7080>>3],+h[f+12256>>3],+h[f+12264>>3],+h[f+10888>>3],+h[f+10896>>3],+h[j+384>>3],+h[f+13136>>3],+h[f+12600>>3]*+h[j+2904>>3],(+h[j+864>>3]+ +h[j+872>>3])*.5,+h[j+2896>>3]*.05,+h[j+2864>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+8128>>3]=+h[d>>3]*+h[(c[g>>2]|0)+2840>>3];i=b;return}function Cy(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7400>>3]=+h[b+8128>>3]*+h[(c[a+416>>2]|0)+384>>3];i=i;return}function Dy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+552>>3]*+h[j+12264>>3]*+h[e+2736>>3];l=+h[j+8128>>3]+ +h[j+8120>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6288|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6288|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,16760,16752,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6288|0;r=q;h[r>>3]=o;i=d;return}function Ey(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;GD(d,c[a+536>>2]|0,+h[f+6288>>3],+h[f+12264>>3],+h[f+5648>>3],+h[(c[a+416>>2]|0)+712>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6128>>3]=+h[d>>3];i=b;return}function Fy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+Ad(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6128>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4848|0;w=v;h[w>>3]=n;i=b;return}x=c[72300]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=20120;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Pe[a&127](y,d,16840,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4848|0;w=v;h[w>>3]=n;i=b;return}function Gy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6288>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4848>>3];l=+U(+(+h[j+6128>>3]));m=+h[j+5968>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?6.5:13.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+392>>3];q=n*p;r=q!=0.0;s=+h[o+712>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+qXa(c[b+536>>2]|0,q,16944,16936,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+5968>>3];u=+h[j+4848>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5328|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+qXa(c[b+536>>2]|0,q,16944,16936,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+712>>3];M=+h[j+392>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+qXa(c[b+536>>2]|0,q,16944,16936,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5328|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+qXa(c[b+536>>2]|0,q,16944,16936,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4848>>3]*.125));L=P*(+W(+(+h[g+5968>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+qXa(c[b+536>>2]|0,L,17016,16936,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5328|0;K=J;h[K>>3]=B;i=d;return}}function Hy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6288>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+6128>>3]));l=+h[j+5968>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?6.5:13.5)*+h[m+392>>3];o=+h[m+712>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+qXa(c[b+536>>2]|0,n,16944,17144,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+5008>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function Iy(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+5008>>3]+-.7;h[b+5168>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function Jy(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;_D(d,c[a+536>>2]|0,+h[f+5328>>3],+h[f+5168>>3],+h[f+6128>>3]+-6150.0,3850.0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5808>>3]=+h[d>>3];i=b;return}function Ky(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+3804>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4688>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+4688|0;h[c[g+3808>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4688>>3]);h[c[(c[f>>2]|0)+3812>>2]>>3]=k;$_a(a,47)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+4688>>3]=+h[c[(c[f>>2]|0)+3804>>2]>>3];i=b;return}function Ly(a){a=a|0;var b=0,d=0,e=0;b=i;R_a(a,33)|0;d=c[(c[a+476>>2]|0)+2140>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+9488>>3]=+h[d>>3];h[e+8384>>3]=+h[d+8>>3];i=b;return}function My(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2696>>3]*+h[e+48>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=-+h[j+8384>>3]- +h[j+3800>>3];if(f!=0.0){l=j;m=k/f;n=l;o=n+1488|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+1488|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,f,17160,17152,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1488|0;p=o;h[p>>3]=m;i=d;return}function Ny(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+8224>>3]=+h[b+6288>>3]*+h[d+552>>3]*+h[d+2736>>3]*(+h[b+520>>3]*.5+(+h[b+552>>3]*-.5+(+h[b+7080>>3]+ +h[b+7088>>3])*.5));i=i;return}function Oy(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8704>>3]=+h[b+8128>>3]- +h[b+8120>>3];i=i;return}function Py(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+13392>>3];k=+h[g+8704>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+10432|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+10432|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,17200,17192,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+10432|0;p=o;h[p>>3]=m;i=d;return}function Qy(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8128>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7560>>3]=+h[(a?e+10896|0:e+10888|0)>>3];i=b;return}function Ry(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8128>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7720>>3]=+h[(a?e+12264|0:e+12256|0)>>3];i=b;return}function Sy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+552>>3],+h[a+544>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+552>>3];l=+h[g+544>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+9240>>3]=+h[f>>3];i=b;return}function Ty(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9240>>3];k=+h[g+12256>>3];l=+h[g+552>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,17240,17232,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6872>>3]=j-n;i=d;return}function Uy(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9016>>3]=+h[b+8856>>3]*+h[b+6872>>3];i=i;return}function Vy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+88|0;d=b;e=b+40|0;f=b+80|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ID(e,c[g>>2]|0,1,+h[a+9240>>3],+h[a+12256>>3],+h[a+544>>3],+h[a+552>>3]);a=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+40|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));SD(f,a,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5960>>3]=+h[f>>3];i=b;return}function Wy(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+8128>>3];h[b+7896>>3]=d*+h[(!(d>=0.0)?b+9232|0:b+9240|0)>>3];i=i;return}function Xy(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8544>>3]=+h[b+7896>>3]- +h[b+7904>>3];i=i;return}function Yy(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9968>>3]=+h[b+8544>>3]+(+h[b+8224>>3]+ +h[b+8384>>3]);i=i;return}function Zy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8864>>3];k=+h[g+9968>>3]- +h[g+8704>>3]*+h[g+6840>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9648|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9648|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,17280,17272,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9648|0;p=o;h[p>>3]=m;i=d;return}function _y(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+3884>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1336>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1336|0;h[c[g+3888>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1336>>3]);e=c[f>>2]|0;h[c[e+3892>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+3884>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+10280>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+10280|0;h[(c[e+3888>>2]|0)+8>>3]=+h[g>>3];k=+b$a(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+10280>>3]);j=c[f>>2]|0;h[(c[j+3892>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+3884>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+1328>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+1328|0;h[(c[j+3888>>2]|0)+16>>3]=+h[e>>3];k=+b$a(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+1328>>3]);h[(c[(c[f>>2]|0)+3892>>2]|0)+16>>3]=k;$_a(a,48)|0;a=c[(c[f>>2]|0)+3884>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1336>>3]=+h[a>>3];h[f+10280>>3]=+h[a+8>>3];h[f+1328>>3]=+h[a+16>>3];i=b;return}function $y(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+568>>3],+h[a+560>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+568>>3];l=+h[g+560>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12248>>3]=+h[f>>3];i=b;return}function az(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8848>>3]=+h[b+13376>>3]*+h[b+12248>>3];i=i;return}function bz(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;WD(d,c[a+536>>2]|0,+h[f+12248>>3],+h[f+560>>3],+h[f+568>>3],1,1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5472>>3]=+h[d>>3];i=b;return}function cz(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12248>>3],+h[f+560>>3],+h[f+568>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5632>>3]=+h[d>>3];i=b;return}function dz(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12248>>3],+h[f+560>>3],+h[f+568>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+10880>>3]=+h[d>>3];i=b;return}function ez(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;JD(d,c[a+536>>2]|0,+h[f+7072>>3],+h[f+12248>>3],+h[f+12256>>3],+h[f+10880>>3],+h[f+10888>>3],+h[j+376>>3],+h[f+13144>>3],+h[f+12592>>3]*+h[j+2904>>3],(+h[j+856>>3]+ +h[j+864>>3])*.5,+h[j+2896>>3]*.05,+h[j+2864>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+8136>>3]=+h[d>>3]*+h[(c[g>>2]|0)+2840>>3];i=b;return}function fz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7392>>3]=+h[b+8136>>3]*+h[(c[a+416>>2]|0)+376>>3];i=i;return}function gz(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+544>>3]*+h[j+12256>>3]*+h[e+2736>>3];l=+h[j+8136>>3]+ +h[j+8128>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6280|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6280|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,17312,17304,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6280|0;r=q;h[r>>3]=o;i=d;return}function hz(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;GD(d,c[a+536>>2]|0,+h[f+6280>>3],+h[f+12256>>3],+h[f+5640>>3],+h[(c[a+416>>2]|0)+704>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6120>>3]=+h[d>>3];i=b;return}function iz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+Ad(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6120>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4840|0;w=v;h[w>>3]=n;i=b;return}x=c[72300]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=20120;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Pe[a&127](y,d,17392,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4840|0;w=v;h[w>>3]=n;i=b;return}function jz(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6280>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4840>>3];l=+U(+(+h[j+6120>>3]));m=+h[j+5960>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?5.5:14.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+384>>3];q=n*p;r=q!=0.0;s=+h[o+704>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+qXa(c[b+536>>2]|0,q,17496,17488,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+5960>>3];u=+h[j+4840>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5320|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+qXa(c[b+536>>2]|0,q,17496,17488,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+704>>3];M=+h[j+384>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+qXa(c[b+536>>2]|0,q,17496,17488,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5320|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+qXa(c[b+536>>2]|0,q,17496,17488,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4840>>3]*.125));L=P*(+W(+(+h[g+5960>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+qXa(c[b+536>>2]|0,L,17568,17488,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5320|0;K=J;h[K>>3]=B;i=d;return}}function kz(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6280>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+6120>>3]));l=+h[j+5960>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?5.5:14.5)*+h[m+384>>3];o=+h[m+704>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+qXa(c[b+536>>2]|0,n,17496,17696,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+5e3>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function lz(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+5e3>>3]+-.7;h[b+5160>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function mz(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;_D(d,c[a+536>>2]|0,+h[f+5320>>3],+h[f+5160>>3],+h[f+6120>>3]+-6150.0,3850.0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5800>>3]=+h[d>>3];i=b;return}function nz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+3964>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4680>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+4680|0;h[c[g+3968>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4680>>3]);h[c[(c[f>>2]|0)+3972>>2]>>3]=k;$_a(a,49)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+4680>>3]=+h[c[(c[f>>2]|0)+3964>>2]>>3];i=b;return}function oz(a){a=a|0;var b=0,d=0,e=0;b=i;R_a(a,34)|0;d=c[(c[a+476>>2]|0)+2204>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+9480>>3]=+h[d>>3];h[e+8376>>3]=+h[d+8>>3];i=b;return}function pz(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2696>>3]*+h[e+40>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=-+h[j+8376>>3]- +h[j+3808>>3];if(f!=0.0){l=j;m=k/f;n=l;o=n+1480|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+1480|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,f,17712,17704,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1480|0;p=o;h[p>>3]=m;i=d;return}function qz(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+8216>>3]=+h[b+6280>>3]*+h[d+544>>3]*+h[d+2736>>3]*(+h[b+536>>3]*.5+(+h[b+568>>3]*-.5+(+h[b+7072>>3]+ +h[b+7080>>3])*.5));i=i;return}function rz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8696>>3]=+h[b+8136>>3]- +h[b+8128>>3];i=i;return}function sz(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+13384>>3];k=+h[g+8696>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+10424|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+10424|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,17752,17744,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+10424|0;p=o;h[p>>3]=m;i=d;return}function tz(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8136>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7552>>3]=+h[(a?e+10888|0:e+10880|0)>>3];i=b;return}function uz(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8136>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7712>>3]=+h[(a?e+12256|0:e+12248|0)>>3];i=b;return}function vz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+568>>3],+h[a+560>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+568>>3];l=+h[g+560>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+9248>>3]=+h[f>>3];i=b;return}function wz(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9248>>3];k=+h[g+12248>>3];l=+h[g+568>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,17792,17784,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6904>>3]=j-n;i=d;return}function xz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9008>>3]=+h[b+8848>>3]*+h[b+6904>>3];i=i;return}function yz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+88|0;d=b;e=b+40|0;f=b+80|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ID(e,c[g>>2]|0,1,+h[a+9248>>3],+h[a+12248>>3],+h[a+560>>3],+h[a+568>>3]);a=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+40|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));SD(f,a,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5952>>3]=+h[f>>3];i=b;return}function zz(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+8136>>3];h[b+7888>>3]=d*+h[(!(d>=0.0)?b+9240|0:b+9248|0)>>3];i=i;return}function Az(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8536>>3]=+h[b+7888>>3]- +h[b+7896>>3];i=i;return}function Bz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9960>>3]=+h[b+8536>>3]+(+h[b+8216>>3]+ +h[b+8376>>3]);i=i;return}function Cz(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8856>>3];k=+h[g+9960>>3]- +h[g+8696>>3]*+h[g+6872>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9640|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9640|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,17832,17824,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9640|0;p=o;h[p>>3]=m;i=d;return}function Dz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+4044>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1352>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1352|0;h[c[g+4048>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1352>>3]);e=c[f>>2]|0;h[c[e+4052>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+4044>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+10272>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+10272|0;h[(c[e+4048>>2]|0)+8>>3]=+h[g>>3];k=+b$a(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+10272>>3]);j=c[f>>2]|0;h[(c[j+4052>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+4044>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+1344>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+1344|0;h[(c[j+4048>>2]|0)+16>>3]=+h[e>>3];k=+b$a(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+1344>>3]);h[(c[(c[f>>2]|0)+4052>>2]|0)+16>>3]=k;$_a(a,50)|0;a=c[(c[f>>2]|0)+4044>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1352>>3]=+h[a>>3];h[f+10272>>3]=+h[a+8>>3];h[f+1344>>3]=+h[a+16>>3];i=b;return}function Ez(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+584>>3],+h[a+576>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+584>>3];l=+h[g+576>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12240>>3]=+h[f>>3];i=b;return}function Fz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8840>>3]=+h[b+13368>>3]*+h[b+12240>>3];i=i;return}function Gz(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;WD(d,c[a+536>>2]|0,+h[f+12240>>3],+h[f+576>>3],+h[f+584>>3],1,1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5464>>3]=+h[d>>3];i=b;return}function Hz(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12240>>3],+h[f+576>>3],+h[f+584>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5624>>3]=+h[d>>3];i=b;return}function Iz(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12240>>3],+h[f+576>>3],+h[f+584>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+10872>>3]=+h[d>>3];i=b;return}function Jz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;JD(d,c[a+536>>2]|0,+h[f+7064>>3],+h[f+12240>>3],+h[f+12248>>3],+h[f+10872>>3],+h[f+10880>>3],+h[j+368>>3],+h[f+13152>>3],+h[f+12584>>3]*+h[j+2904>>3],(+h[j+848>>3]+ +h[j+856>>3])*.5,+h[j+2896>>3]*.05,+h[j+2864>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+8144>>3]=+h[d>>3]*+h[(c[g>>2]|0)+2840>>3];i=b;return}function Kz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7384>>3]=+h[b+8144>>3]*+h[(c[a+416>>2]|0)+368>>3];i=i;return}function Lz(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+536>>3]*+h[j+12248>>3]*+h[e+2736>>3];l=+h[j+8144>>3]+ +h[j+8136>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6272|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6272|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,17864,17856,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6272|0;r=q;h[r>>3]=o;i=d;return}function Mz(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;GD(d,c[a+536>>2]|0,+h[f+6272>>3],+h[f+12248>>3],+h[f+5632>>3],+h[(c[a+416>>2]|0)+696>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6112>>3]=+h[d>>3];i=b;return}function Nz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+Ad(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6112>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4832|0;w=v;h[w>>3]=n;i=b;return}x=c[72300]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=20120;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Pe[a&127](y,d,17944,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4832|0;w=v;h[w>>3]=n;i=b;return}function Oz(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6272>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4832>>3];l=+U(+(+h[j+6112>>3]));m=+h[j+5952>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?4.5:15.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+376>>3];q=n*p;r=q!=0.0;s=+h[o+696>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+qXa(c[b+536>>2]|0,q,18048,18040,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+5952>>3];u=+h[j+4832>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5312|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+qXa(c[b+536>>2]|0,q,18048,18040,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+696>>3];M=+h[j+376>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+qXa(c[b+536>>2]|0,q,18048,18040,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5312|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+qXa(c[b+536>>2]|0,q,18048,18040,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4832>>3]*.125));L=P*(+W(+(+h[g+5952>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+qXa(c[b+536>>2]|0,L,18120,18040,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5312|0;K=J;h[K>>3]=B;i=d;return}}function Pz(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6272>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+6112>>3]));l=+h[j+5952>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?4.5:15.5)*+h[m+376>>3];o=+h[m+696>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+qXa(c[b+536>>2]|0,n,18048,18248,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+4992>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function Qz(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+4992>>3]+-.7;h[b+5152>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function Rz(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;_D(d,c[a+536>>2]|0,+h[f+5312>>3],+h[f+5152>>3],+h[f+6112>>3]+-6150.0,3850.0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5792>>3]=+h[d>>3];i=b;return}function Sz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+4124>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4672>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+4672|0;h[c[g+4128>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4672>>3]);h[c[(c[f>>2]|0)+4132>>2]>>3]=k;$_a(a,51)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+4672>>3]=+h[c[(c[f>>2]|0)+4124>>2]>>3];i=b;return}function Tz(a){a=a|0;var b=0,d=0,e=0;b=i;R_a(a,35)|0;d=c[(c[a+476>>2]|0)+2268>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+8368>>3]=+h[d>>3];h[e+9472>>3]=+h[d+8>>3];i=b;return}function Uz(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2696>>3]*+h[e+32>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=-+h[j+8368>>3]- +h[j+3816>>3];if(f!=0.0){l=j;m=k/f;n=l;o=n+1472|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+1472|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,f,18264,18256,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1472|0;p=o;h[p>>3]=m;i=d;return}function Vz(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+8208>>3]=+h[b+6272>>3]*+h[d+536>>3]*+h[d+2736>>3]*(+h[b+552>>3]*.5+(+h[b+584>>3]*-.5+(+h[b+7064>>3]+ +h[b+7072>>3])*.5));i=i;return}function Wz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8688>>3]=+h[b+8144>>3]- +h[b+8136>>3];i=i;return}function Xz(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+13376>>3];k=+h[g+8688>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+10416|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+10416|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,18304,18296,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+10416|0;p=o;h[p>>3]=m;i=d;return}function Yz(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8144>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7544>>3]=+h[(a?e+10880|0:e+10872|0)>>3];i=b;return}function Zz(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8144>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7704>>3]=+h[(a?e+12248|0:e+12240|0)>>3];i=b;return}function _z(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+584>>3],+h[a+576>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+584>>3];l=+h[g+576>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+9256>>3]=+h[f>>3];i=b;return}function $z(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9256>>3];k=+h[g+12240>>3];l=+h[g+584>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,18344,18336,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6936>>3]=j-n;i=d;return}function aA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9e3>>3]=+h[b+8840>>3]*+h[b+6936>>3];i=i;return}function bA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+88|0;d=b;e=b+40|0;f=b+80|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ID(e,c[g>>2]|0,1,+h[a+9256>>3],+h[a+12240>>3],+h[a+576>>3],+h[a+584>>3]);a=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+40|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));SD(f,a,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5944>>3]=+h[f>>3];i=b;return}function cA(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+8144>>3];h[b+7880>>3]=d*+h[(!(d>=0.0)?b+9248|0:b+9256|0)>>3];i=i;return}function dA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8528>>3]=+h[b+7880>>3]- +h[b+7888>>3];i=i;return}function eA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9952>>3]=+h[b+8528>>3]+(+h[b+8208>>3]+ +h[b+8368>>3]);i=i;return}function fA(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8848>>3];k=+h[g+9952>>3]- +h[g+8688>>3]*+h[g+6904>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9632|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9632|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,18384,18376,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9632|0;p=o;h[p>>3]=m;i=d;return}function gA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+4204>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1368>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1368|0;h[c[g+4208>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1368>>3]);e=c[f>>2]|0;h[c[e+4212>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+4204>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+10264>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+10264|0;h[(c[e+4208>>2]|0)+8>>3]=+h[g>>3];k=+b$a(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+10264>>3]);j=c[f>>2]|0;h[(c[j+4212>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+4204>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+1360>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+1360|0;h[(c[j+4208>>2]|0)+16>>3]=+h[e>>3];k=+b$a(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+1360>>3]);h[(c[(c[f>>2]|0)+4212>>2]|0)+16>>3]=k;$_a(a,52)|0;a=c[(c[f>>2]|0)+4204>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1368>>3]=+h[a>>3];h[f+10264>>3]=+h[a+8>>3];h[f+1360>>3]=+h[a+16>>3];i=b;return}function hA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+600>>3],+h[a+592>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+600>>3];l=+h[g+592>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12232>>3]=+h[f>>3];i=b;return}function iA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8832>>3]=+h[b+13360>>3]*+h[b+12232>>3];i=i;return}function jA(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;WD(d,c[a+536>>2]|0,+h[f+12232>>3],+h[f+592>>3],+h[f+600>>3],1,1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5456>>3]=+h[d>>3];i=b;return}function kA(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12232>>3],+h[f+592>>3],+h[f+600>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5616>>3]=+h[d>>3];i=b;return}function lA(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12232>>3],+h[f+592>>3],+h[f+600>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+10864>>3]=+h[d>>3];i=b;return}function mA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;JD(d,c[a+536>>2]|0,+h[f+7056>>3],+h[f+12232>>3],+h[f+12240>>3],+h[f+10864>>3],+h[f+10872>>3],+h[j+360>>3],+h[f+13160>>3],+h[f+12576>>3]*+h[j+2904>>3],(+h[j+840>>3]+ +h[j+848>>3])*.5,+h[j+2896>>3]*.05,+h[j+2864>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+8152>>3]=+h[d>>3]*+h[(c[g>>2]|0)+2840>>3];i=b;return}function nA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7376>>3]=+h[b+8152>>3]*+h[(c[a+416>>2]|0)+360>>3];i=i;return}function oA(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+528>>3]*+h[j+12240>>3]*+h[e+2736>>3];l=+h[j+8152>>3]+ +h[j+8144>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6264|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6264|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,18416,18408,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6264|0;r=q;h[r>>3]=o;i=d;return}function pA(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;GD(d,c[a+536>>2]|0,+h[f+6264>>3],+h[f+12240>>3],+h[f+5624>>3],+h[(c[a+416>>2]|0)+688>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6104>>3]=+h[d>>3];i=b;return}function qA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+Ad(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6104>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4824|0;w=v;h[w>>3]=n;i=b;return}x=c[72300]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=20120;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Pe[a&127](y,d,18496,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4824|0;w=v;h[w>>3]=n;i=b;return}function rA(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6264>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4824>>3];l=+U(+(+h[j+6104>>3]));m=+h[j+5944>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?3.5:16.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+368>>3];q=n*p;r=q!=0.0;s=+h[o+688>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+qXa(c[b+536>>2]|0,q,18600,18592,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+5944>>3];u=+h[j+4824>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5304|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+qXa(c[b+536>>2]|0,q,18600,18592,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+688>>3];M=+h[j+368>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+qXa(c[b+536>>2]|0,q,18600,18592,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5304|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+qXa(c[b+536>>2]|0,q,18600,18592,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4824>>3]*.125));L=P*(+W(+(+h[g+5944>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+qXa(c[b+536>>2]|0,L,18672,18592,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5304|0;K=J;h[K>>3]=B;i=d;return}}function sA(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6264>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+6104>>3]));l=+h[j+5944>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?3.5:16.5)*+h[m+368>>3];o=+h[m+688>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+qXa(c[b+536>>2]|0,n,18600,18800,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+4984>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function tA(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+4984>>3]+-.7;h[b+5144>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function uA(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;_D(d,c[a+536>>2]|0,+h[f+5304>>3],+h[f+5144>>3],+h[f+6104>>3]+-6150.0,3850.0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5784>>3]=+h[d>>3];i=b;return}function vA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+4284>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4664>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+4664|0;h[c[g+4288>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4664>>3]);h[c[(c[f>>2]|0)+4292>>2]>>3]=k;$_a(a,53)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+4664>>3]=+h[c[(c[f>>2]|0)+4284>>2]>>3];i=b;return}function wA(a){a=a|0;var b=0,d=0,e=0;b=i;R_a(a,36)|0;d=c[(c[a+476>>2]|0)+2332>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+8360>>3]=+h[d>>3];h[e+9464>>3]=+h[d+8>>3];i=b;return}function xA(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2696>>3]*+h[e+24>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=-+h[j+8360>>3]- +h[j+3824>>3];if(f!=0.0){l=j;m=k/f;n=l;o=n+1464|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+1464|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,f,18816,18808,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1464|0;p=o;h[p>>3]=m;i=d;return}function yA(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+8200>>3]=+h[b+6264>>3]*+h[d+528>>3]*+h[d+2736>>3]*(+h[b+568>>3]*.5+(+h[b+600>>3]*-.5+(+h[b+7056>>3]+ +h[b+7064>>3])*.5));i=i;return}function zA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8680>>3]=+h[b+8152>>3]- +h[b+8144>>3];i=i;return}function AA(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+13368>>3];k=+h[g+8680>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+10408|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+10408|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,18856,18848,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+10408|0;p=o;h[p>>3]=m;i=d;return}function BA(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8152>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7536>>3]=+h[(a?e+10872|0:e+10864|0)>>3];i=b;return}function CA(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8152>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7696>>3]=+h[(a?e+12240|0:e+12232|0)>>3];i=b;return}function DA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+600>>3],+h[a+592>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+600>>3];l=+h[g+592>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+9264>>3]=+h[f>>3];i=b;return}function EA(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9264>>3];k=+h[g+12232>>3];l=+h[g+600>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,18896,18888,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6968>>3]=j-n;i=d;return}function FA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8992>>3]=+h[b+8832>>3]*+h[b+6968>>3];i=i;return}function GA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+88|0;d=b;e=b+40|0;f=b+80|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ID(e,c[g>>2]|0,1,+h[a+9264>>3],+h[a+12232>>3],+h[a+592>>3],+h[a+600>>3]);a=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+40|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));SD(f,a,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5936>>3]=+h[f>>3];i=b;return}function HA(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+8152>>3];h[b+7872>>3]=d*+h[(!(d>=0.0)?b+9256|0:b+9264|0)>>3];i=i;return}function IA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8520>>3]=+h[b+7872>>3]- +h[b+7880>>3];i=i;return}function JA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9944>>3]=+h[b+8520>>3]+(+h[b+8200>>3]+ +h[b+8360>>3]);i=i;return}function KA(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8840>>3];k=+h[g+9944>>3]- +h[g+8680>>3]*+h[g+6936>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9624|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9624|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,18936,18928,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9624|0;p=o;h[p>>3]=m;i=d;return}function LA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+4364>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1384>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1384|0;h[c[g+4368>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1384>>3]);e=c[f>>2]|0;h[c[e+4372>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+4364>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+1376>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+1376|0;h[(c[e+4368>>2]|0)+8>>3]=+h[g>>3];k=+b$a(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+1376>>3]);j=c[f>>2]|0;h[(c[j+4372>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+4364>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+10256>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+10256|0;h[(c[j+4368>>2]|0)+16>>3]=+h[e>>3];k=+b$a(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+10256>>3]);h[(c[(c[f>>2]|0)+4372>>2]|0)+16>>3]=k;$_a(a,54)|0;a=c[(c[f>>2]|0)+4364>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1384>>3]=+h[a>>3];h[f+1376>>3]=+h[a+8>>3];h[f+10256>>3]=+h[a+16>>3];i=b;return}function MA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+616>>3],+h[a+608>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+616>>3];l=+h[g+608>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12224>>3]=+h[f>>3];i=b;return}function NA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8824>>3]=+h[b+13352>>3]*+h[b+12224>>3];i=i;return}function OA(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;WD(d,c[a+536>>2]|0,+h[f+12224>>3],+h[f+608>>3],+h[f+616>>3],1,1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5448>>3]=+h[d>>3];i=b;return}function PA(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12224>>3],+h[f+608>>3],+h[f+616>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5608>>3]=+h[d>>3];i=b;return}function QA(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12224>>3],+h[f+608>>3],+h[f+616>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+10856>>3]=+h[d>>3];i=b;return}function RA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;JD(d,c[a+536>>2]|0,+h[f+7048>>3],+h[f+12224>>3],+h[f+12232>>3],+h[f+10856>>3],+h[f+10864>>3],+h[j+352>>3],+h[f+13168>>3],+h[f+12568>>3]*+h[j+2904>>3],(+h[j+832>>3]+ +h[j+840>>3])*.5,+h[j+2896>>3]*.05,+h[j+2864>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+8160>>3]=+h[d>>3]*+h[(c[g>>2]|0)+2840>>3];i=b;return}function SA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7368>>3]=+h[b+8160>>3]*+h[(c[a+416>>2]|0)+352>>3];i=i;return}function TA(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+520>>3]*+h[j+12232>>3]*+h[e+2736>>3];l=+h[j+8160>>3]+ +h[j+8152>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6256|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6256|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,18968,18960,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6256|0;r=q;h[r>>3]=o;i=d;return}function UA(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;GD(d,c[a+536>>2]|0,+h[f+6256>>3],+h[f+12232>>3],+h[f+5616>>3],+h[(c[a+416>>2]|0)+680>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6096>>3]=+h[d>>3];i=b;return}function VA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+Ad(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6096>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4816|0;w=v;h[w>>3]=n;i=b;return}x=c[72300]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=20120;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Pe[a&127](y,d,19048,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4816|0;w=v;h[w>>3]=n;i=b;return}function WA(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6256>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4816>>3];l=+U(+(+h[j+6096>>3]));m=+h[j+5936>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?2.5:17.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+360>>3];q=n*p;r=q!=0.0;s=+h[o+680>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+qXa(c[b+536>>2]|0,q,19152,19144,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+5936>>3];u=+h[j+4816>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5296|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+qXa(c[b+536>>2]|0,q,19152,19144,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+680>>3];M=+h[j+360>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+qXa(c[b+536>>2]|0,q,19152,19144,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5296|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+qXa(c[b+536>>2]|0,q,19152,19144,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4816>>3]*.125));L=P*(+W(+(+h[g+5936>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+qXa(c[b+536>>2]|0,L,19224,19144,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5296|0;K=J;h[K>>3]=B;i=d;return}}function XA(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6256>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+6096>>3]));l=+h[j+5936>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?2.5:17.5)*+h[m+360>>3];o=+h[m+680>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+qXa(c[b+536>>2]|0,n,19152,19352,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+4976>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function YA(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+4976>>3]+-.7;h[b+5136>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function ZA(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;_D(d,c[a+536>>2]|0,+h[f+5296>>3],+h[f+5136>>3],+h[f+6096>>3]+-6150.0,3850.0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5776>>3]=+h[d>>3];i=b;return}function _A(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+4444>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4656>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+4656|0;h[c[g+4448>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4656>>3]);h[c[(c[f>>2]|0)+4452>>2]>>3]=k;$_a(a,55)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+4656>>3]=+h[c[(c[f>>2]|0)+4444>>2]>>3];i=b;return}function $A(a){a=a|0;var b=0,d=0,e=0;b=i;R_a(a,37)|0;d=c[(c[a+476>>2]|0)+2396>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+9456>>3]=+h[d>>3];h[e+8352>>3]=+h[d+8>>3];i=b;return}function aB(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2696>>3]*+h[e+16>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=-+h[j+8352>>3]- +h[j+3832>>3];if(f!=0.0){l=j;m=k/f;n=l;o=n+1456|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+1456|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,f,19368,19360,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1456|0;p=o;h[p>>3]=m;i=d;return}function bB(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+8192>>3]=+h[b+6256>>3]*+h[d+520>>3]*+h[d+2736>>3]*(+h[b+584>>3]*.5+(+h[b+616>>3]*-.5+(+h[b+7048>>3]+ +h[b+7056>>3])*.5));i=i;return}function cB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8672>>3]=+h[b+8160>>3]- +h[b+8152>>3];i=i;return}function dB(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+13360>>3];k=+h[g+8672>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+10400|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+10400|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,19408,19400,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+10400|0;p=o;h[p>>3]=m;i=d;return}function eB(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8160>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7528>>3]=+h[(a?e+10864|0:e+10856|0)>>3];i=b;return}function fB(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8160>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7688>>3]=+h[(a?e+12232|0:e+12224|0)>>3];i=b;return}function gB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+616>>3],+h[a+608>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+616>>3];l=+h[g+608>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+9272>>3]=+h[f>>3];i=b;return}function hB(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9272>>3];k=+h[g+12224>>3];l=+h[g+616>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,19448,19440,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+7e3>>3]=j-n;i=d;return}function iB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8984>>3]=+h[b+8824>>3]*+h[b+7e3>>3];i=i;return}function jB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+88|0;d=b;e=b+40|0;f=b+80|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ID(e,c[g>>2]|0,1,+h[a+9272>>3],+h[a+12224>>3],+h[a+608>>3],+h[a+616>>3]);a=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+40|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));SD(f,a,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5928>>3]=+h[f>>3];i=b;return}function kB(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+8160>>3];h[b+7864>>3]=d*+h[(!(d>=0.0)?b+9264|0:b+9272|0)>>3];i=i;return}function lB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8512>>3]=+h[b+7864>>3]- +h[b+7872>>3];i=i;return}function mB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9936>>3]=+h[b+8512>>3]+(+h[b+8192>>3]+ +h[b+8352>>3]);i=i;return}function nB(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8832>>3];k=+h[g+9936>>3]- +h[g+8672>>3]*+h[g+6968>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9616|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9616|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,19488,19480,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9616|0;p=o;h[p>>3]=m;i=d;return}function oB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+4524>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1400>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1400|0;h[c[g+4528>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1400>>3]);e=c[f>>2]|0;h[c[e+4532>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+4524>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+10248>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+10248|0;h[(c[e+4528>>2]|0)+8>>3]=+h[g>>3];k=+b$a(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+10248>>3]);j=c[f>>2]|0;h[(c[j+4532>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+4524>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+1392>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+1392|0;h[(c[j+4528>>2]|0)+16>>3]=+h[e>>3];k=+b$a(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+1392>>3]);h[(c[(c[f>>2]|0)+4532>>2]|0)+16>>3]=k;$_a(a,56)|0;a=c[(c[f>>2]|0)+4524>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1400>>3]=+h[a>>3];h[f+10248>>3]=+h[a+8>>3];h[f+1392>>3]=+h[a+16>>3];i=b;return}function pB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+632>>3],+h[a+624>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+632>>3];l=+h[g+624>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12216>>3]=+h[f>>3];i=b;return}function qB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8816>>3]=+h[b+13344>>3]*+h[b+12216>>3];i=i;return}function rB(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;WD(d,c[a+536>>2]|0,+h[f+12216>>3],+h[f+624>>3],+h[f+632>>3],1,1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5440>>3]=+h[d>>3];i=b;return}function sB(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12216>>3],+h[f+624>>3],+h[f+632>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5600>>3]=+h[d>>3];i=b;return}function tB(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12216>>3],+h[f+624>>3],+h[f+632>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+10848>>3]=+h[d>>3];i=b;return}function uB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;JD(d,c[a+536>>2]|0,+h[f+7040>>3],+h[f+12216>>3],+h[f+12224>>3],+h[f+10848>>3],+h[f+10856>>3],+h[j+344>>3],+h[f+13176>>3],+h[f+12560>>3]*+h[j+2904>>3],(+h[j+824>>3]+ +h[j+832>>3])*.5,+h[j+2896>>3]*.05,+h[j+2864>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+8168>>3]=+h[d>>3]*+h[(c[g>>2]|0)+2840>>3];i=b;return}function vB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7360>>3]=+h[b+8168>>3]*+h[(c[a+416>>2]|0)+344>>3];i=i;return}function wB(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+512>>3]*+h[j+12224>>3]*+h[e+2736>>3];l=+h[j+8168>>3]+ +h[j+8160>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6248|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6248|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,19520,19512,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6248|0;r=q;h[r>>3]=o;i=d;return}function xB(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;GD(d,c[a+536>>2]|0,+h[f+6248>>3],+h[f+12224>>3],+h[f+5608>>3],+h[(c[a+416>>2]|0)+672>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6088>>3]=+h[d>>3];i=b;return}function yB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+Ad(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6088>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4808|0;w=v;h[w>>3]=n;i=b;return}x=c[72300]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=20120;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Pe[a&127](y,d,19600,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4808|0;w=v;h[w>>3]=n;i=b;return}function zB(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6248>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4808>>3];l=+U(+(+h[j+6088>>3]));m=+h[j+5928>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?1.5:18.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+352>>3];q=n*p;r=q!=0.0;s=+h[o+672>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+qXa(c[b+536>>2]|0,q,19704,19696,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+5928>>3];u=+h[j+4808>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5288|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+qXa(c[b+536>>2]|0,q,19704,19696,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+672>>3];M=+h[j+352>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+qXa(c[b+536>>2]|0,q,19704,19696,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5288|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+qXa(c[b+536>>2]|0,q,19704,19696,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4808>>3]*.125));L=P*(+W(+(+h[g+5928>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+qXa(c[b+536>>2]|0,L,19776,19696,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5288|0;K=J;h[K>>3]=B;i=d;return}}function AB(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6248>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+6088>>3]));l=+h[j+5928>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?1.5:18.5)*+h[m+352>>3];o=+h[m+672>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+qXa(c[b+536>>2]|0,n,19704,19904,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+4968>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function BB(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+4968>>3]+-.7;h[b+5128>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function CB(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;_D(d,c[a+536>>2]|0,+h[f+5288>>3],+h[f+5128>>3],+h[f+6088>>3]+-6150.0,3850.0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5768>>3]=+h[d>>3];i=b;return}function DB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+4604>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4648>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+4648|0;h[c[g+4608>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4648>>3]);h[c[(c[f>>2]|0)+4612>>2]>>3]=k;$_a(a,57)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+4648>>3]=+h[c[(c[f>>2]|0)+4604>>2]>>3];i=b;return}function EB(a){a=a|0;var b=0,d=0,e=0;b=i;R_a(a,38)|0;d=c[(c[a+476>>2]|0)+2460>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+9448>>3]=+h[d>>3];h[e+8344>>3]=+h[d+8>>3];i=b;return}function FB(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2696>>3]*+h[e+8>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=-+h[j+8344>>3]- +h[j+3840>>3];if(f!=0.0){l=j;m=k/f;n=l;o=n+1448|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+1448|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,f,19920,19912,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1448|0;p=o;h[p>>3]=m;i=d;return}function GB(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+8184>>3]=+h[b+6248>>3]*+h[d+512>>3]*+h[d+2736>>3]*(+h[b+600>>3]*.5+(+h[b+632>>3]*-.5+(+h[b+7040>>3]+ +h[b+7048>>3])*.5));i=i;return}function HB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8656>>3]=.5- +h[b+8168>>3];i=i;return}function IB(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+13344>>3];k=+h[g+8656>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+10384|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+10384|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,19960,19952,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+10384|0;p=o;h[p>>3]=m;i=d;return}function JB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8664>>3]=+h[b+8168>>3]- +h[b+8160>>3];i=i;return}function KB(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+13352>>3];k=+h[g+8664>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+10392|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+10392|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,2e4,19992,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+10392|0;p=o;h[p>>3]=m;i=d;return}function LB(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8168>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7520>>3]=+h[(a?e+10856|0:e+10848|0)>>3];i=b;return}function MB(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8168>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7680>>3]=+h[(a?e+12224|0:e+12216|0)>>3];i=b;return}function NB(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+504>>3]*+h[j+12216>>3]*+h[e+2736>>3];l=+h[j+8168>>3]+.5;if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6240|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6240|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,20040,20032,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6240|0;r=q;h[r>>3]=o;i=d;return}function OB(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+8176>>3]=+h[b+6240>>3]*+h[d+504>>3]*+h[d+2736>>3]*(+h[b+616>>3]*.5+(+h[b+632>>3]*-.5+ +h[b+7040>>3]*.5));i=i;return}function PB(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;GD(d,c[a+536>>2]|0,+h[f+6240>>3],+h[f+12216>>3],+h[f+5600>>3],+h[(c[a+416>>2]|0)+664>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6080>>3]=+h[d>>3];i=b;return}function QB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+Ad(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6080>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4800|0;w=v;h[w>>3]=n;i=b;return}x=c[72300]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=20120;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Pe[a&127](y,d,20144,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4800|0;w=v;h[w>>3]=n;i=b;return}function RB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+632>>3],+h[a+624>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+632>>3];l=+h[g+624>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+14600>>3]=+h[f>>3];i=b;return}function SB(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+14600>>3];k=+h[g+12216>>3];l=+h[g+632>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,20248,20240,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+7032>>3]=j-n;i=d;return}function TB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8976>>3]=+h[b+8816>>3]*+h[b+7032>>3];i=i;return}function UB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7848>>3]=+h[b+14504>>3]*.5;i=i;return}function VB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+88|0;d=b;e=b+40|0;f=b+80|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ID(e,c[g>>2]|0,1,+h[a+14600>>3],+h[a+12216>>3],+h[a+624>>3],+h[a+632>>3]);a=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+40|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));SD(f,a,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5920>>3]=+h[f>>3];i=b;return}



function vE(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,B=0,C=0,D=0,E=0,F=0,G=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=0,vf=0,wf=0,xf=0,yf=0,zf=0,Af=0,Bf=0,Cf=0,Df=0,Ef=0,Ff=0,Gf=0,Hf=0,If=0,Jf=0,Kf=0,Lf=0,Mf=0,Nf=0,Of=0,Pf=0,Qf=0,Rf=0,Sf=0,Tf=0,Uf=0,Vf=0,Wf=0,Xf=0,Yf=0,Zf=0,_f=0,$f=0,ag=0,bg=0,cg=0,dg=0.0,eg=0.0,fg=0.0,gg=0.0;f=i;i=i+5696|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+8|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;ob=i;i=i+8|0;pb=i;i=i+8|0;qb=i;i=i+8|0;rb=i;i=i+8|0;sb=i;i=i+8|0;tb=i;i=i+8|0;ub=i;i=i+8|0;vb=i;i=i+8|0;wb=i;i=i+8|0;xb=i;i=i+8|0;yb=i;i=i+8|0;zb=i;i=i+8|0;Ab=i;i=i+8|0;Bb=i;i=i+8|0;Cb=i;i=i+8|0;Db=i;i=i+8|0;Eb=i;i=i+8|0;Fb=i;i=i+8|0;Gb=i;i=i+8|0;Hb=i;i=i+8|0;Ib=i;i=i+8|0;Jb=i;i=i+8|0;Kb=i;i=i+8|0;Lb=i;i=i+8|0;Mb=i;i=i+8|0;Nb=i;i=i+8|0;Ob=i;i=i+8|0;Pb=i;i=i+8|0;Qb=i;i=i+8|0;Rb=i;i=i+8|0;Sb=i;i=i+8|0;Tb=i;i=i+8|0;Ub=i;i=i+8|0;Vb=i;i=i+8|0;Wb=i;i=i+8|0;Xb=i;i=i+8|0;Yb=i;i=i+8|0;Zb=i;i=i+8|0;_b=i;i=i+8|0;$b=i;i=i+8|0;ac=i;i=i+8|0;bc=i;i=i+8|0;cc=i;i=i+8|0;dc=i;i=i+8|0;ec=i;i=i+8|0;fc=i;i=i+8|0;gc=i;i=i+8|0;hc=i;i=i+8|0;ic=i;i=i+8|0;jc=i;i=i+8|0;kc=i;i=i+8|0;lc=i;i=i+8|0;mc=i;i=i+8|0;nc=i;i=i+8|0;oc=i;i=i+8|0;pc=i;i=i+8|0;qc=i;i=i+8|0;rc=i;i=i+8|0;sc=i;i=i+8|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+8|0;wc=i;i=i+8|0;xc=i;i=i+8|0;yc=i;i=i+8|0;zc=i;i=i+8|0;Ac=i;i=i+8|0;Bc=i;i=i+8|0;Cc=i;i=i+8|0;Dc=i;i=i+8|0;Ec=i;i=i+8|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+8|0;Ic=i;i=i+8|0;Jc=i;i=i+8|0;Kc=i;i=i+8|0;Lc=i;i=i+8|0;Mc=i;i=i+8|0;Nc=i;i=i+8|0;Oc=i;i=i+8|0;Pc=i;i=i+8|0;Qc=i;i=i+8|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+8|0;Uc=i;i=i+8|0;Vc=i;i=i+8|0;Wc=i;i=i+8|0;Xc=i;i=i+8|0;Yc=i;i=i+8|0;Zc=i;i=i+8|0;_c=i;i=i+8|0;$c=i;i=i+8|0;ad=i;i=i+8|0;bd=i;i=i+8|0;cd=i;i=i+8|0;dd=i;i=i+8|0;ed=i;i=i+8|0;fd=i;i=i+8|0;gd=i;i=i+8|0;hd=i;i=i+8|0;id=i;i=i+8|0;jd=i;i=i+8|0;kd=i;i=i+8|0;ld=i;i=i+8|0;md=i;i=i+8|0;nd=i;i=i+8|0;od=i;i=i+8|0;pd=i;i=i+8|0;qd=i;i=i+8|0;rd=i;i=i+8|0;sd=i;i=i+8|0;td=i;i=i+8|0;ud=i;i=i+8|0;vd=i;i=i+8|0;wd=i;i=i+8|0;xd=i;i=i+8|0;yd=i;i=i+8|0;zd=i;i=i+8|0;Ad=i;i=i+8|0;Bd=i;i=i+8|0;Cd=i;i=i+8|0;Dd=i;i=i+8|0;Ed=i;i=i+8|0;Fd=i;i=i+8|0;Gd=i;i=i+8|0;Hd=i;i=i+8|0;Id=i;i=i+8|0;Jd=i;i=i+8|0;Kd=i;i=i+8|0;Ld=i;i=i+8|0;Md=i;i=i+8|0;Nd=i;i=i+8|0;Od=i;i=i+8|0;Pd=i;i=i+8|0;Qd=i;i=i+8|0;Rd=i;i=i+8|0;Sd=i;i=i+8|0;Td=i;i=i+8|0;Ud=i;i=i+8|0;Vd=i;i=i+8|0;Wd=i;i=i+8|0;Xd=i;i=i+8|0;Yd=i;i=i+8|0;Zd=i;i=i+8|0;_d=i;i=i+8|0;$d=i;i=i+8|0;ae=i;i=i+8|0;be=i;i=i+8|0;ce=i;i=i+8|0;de=i;i=i+8|0;ee=i;i=i+8|0;fe=i;i=i+8|0;ge=i;i=i+8|0;he=i;i=i+8|0;ie=i;i=i+8|0;je=i;i=i+8|0;ke=i;i=i+8|0;le=i;i=i+8|0;me=i;i=i+8|0;ne=i;i=i+8|0;oe=i;i=i+8|0;pe=i;i=i+8|0;qe=i;i=i+8|0;re=i;i=i+8|0;se=i;i=i+8|0;te=i;i=i+8|0;ue=i;i=i+8|0;ve=i;i=i+8|0;we=i;i=i+8|0;xe=i;i=i+8|0;ye=i;i=i+8|0;ze=i;i=i+8|0;Ae=i;i=i+8|0;Be=i;i=i+8|0;Ce=i;i=i+8|0;De=i;i=i+8|0;Ee=i;i=i+8|0;Fe=i;i=i+8|0;Ge=i;i=i+8|0;He=i;i=i+8|0;Ie=i;i=i+8|0;Je=i;i=i+8|0;Ke=i;i=i+8|0;Le=i;i=i+8|0;Me=i;i=i+8|0;Ne=i;i=i+8|0;Oe=i;i=i+8|0;Qe=i;i=i+8|0;Re=i;i=i+8|0;Se=i;i=i+8|0;Te=i;i=i+8|0;Ue=i;i=i+8|0;Ve=i;i=i+8|0;We=i;i=i+8|0;Xe=i;i=i+8|0;Ye=i;i=i+8|0;Ze=i;i=i+8|0;_e=i;i=i+8|0;$e=i;i=i+8|0;af=i;i=i+8|0;bf=i;i=i+8|0;cf=i;i=i+8|0;df=i;i=i+8|0;ef=i;i=i+8|0;ff=i;i=i+8|0;gf=i;i=i+8|0;hf=i;i=i+8|0;jf=i;i=i+8|0;kf=i;i=i+8|0;lf=i;i=i+8|0;mf=i;i=i+8|0;nf=i;i=i+8|0;of=i;i=i+8|0;pf=i;i=i+8|0;qf=i;i=i+8|0;rf=i;i=i+8|0;sf=i;i=i+8|0;tf=i;i=i+8|0;uf=i;i=i+8|0;vf=i;i=i+8|0;wf=i;i=i+8|0;xf=i;i=i+8|0;yf=i;i=i+8|0;zf=i;i=i+8|0;Af=i;i=i+8|0;Bf=i;i=i+8|0;Cf=i;i=i+8|0;Df=i;i=i+8|0;Ef=i;i=i+8|0;Ff=i;i=i+8|0;Gf=i;i=i+8|0;Hf=i;i=i+8|0;If=i;i=i+8|0;Jf=i;i=i+8|0;Kf=i;i=i+8|0;Lf=i;i=i+8|0;Mf=i;i=i+8|0;Nf=i;i=i+8|0;Of=i;i=i+8|0;Pf=i;i=i+8|0;Qf=i;i=i+8|0;Rf=i;i=i+8|0;Sf=i;i=i+8|0;Tf=i;i=i+8|0;Uf=i;i=i+8|0;Vf=i;i=i+8|0;Wf=i;i=i+8|0;Xf=i;i=i+8|0;Yf=i;i=i+8|0;Zf=i;i=i+8|0;_f=i;i=i+8|0;$f=i;i=i+8|0;ag=i;i=i+16|0;c[$f>>2]=55;eYa(ag,1,$f);if(!(d>0.0)){$f=RXa(RXa(25392,PXa(d,0,1,6)|0)|0,24536)|0;bg=c[72300]|0;cg=f+96|0;c[cg+0>>2]=c[25456+0>>2];c[cg+4>>2]=c[25456+4>>2];c[cg+8>>2]=c[25456+8>>2];c[cg+12>>2]=c[25456+12>>2];c[cg+16>>2]=c[25456+16>>2];c[cg+20>>2]=c[25456+20>>2];Pe[bg&127](b,f+96|0,$f,_f);}if(!(d<=1.0e8)){_f=RXa(RXa(25480,PXa(d,0,1,6)|0)|0,25008)|0;$f=c[72300]|0;bg=f+72|0;c[bg+0>>2]=c[25528+0>>2];c[bg+4>>2]=c[25528+4>>2];c[bg+8>>2]=c[25528+8>>2];c[bg+12>>2]=c[25528+12>>2];c[bg+16>>2]=c[25528+16>>2];c[bg+20>>2]=c[25528+20>>2];Pe[$f&127](b,f+72|0,_f,Zf);}if(!(e>=273.15)){Zf=RXa(RXa(25552,PXa(e,0,1,6)|0)|0,25112)|0;_f=c[72300]|0;$f=f+48|0;c[$f+0>>2]=c[25600+0>>2];c[$f+4>>2]=c[25600+4>>2];c[$f+8>>2]=c[25600+8>>2];c[$f+12>>2]=c[25600+12>>2];c[$f+16>>2]=c[25600+16>>2];c[$f+20>>2]=c[25600+20>>2];Pe[_f&127](b,f+48|0,Zf,Yf);}if(!(e<=1073.15)){Yf=RXa(RXa(25624,PXa(e,0,1,6)|0)|0,25680)|0;Zf=c[72300]|0;_f=f+24|0;c[_f+0>>2]=c[25728+0>>2];c[_f+4>>2]=c[25728+4>>2];c[_f+8>>2]=c[25728+8>>2];c[_f+12>>2]=c[25728+12>>2];c[_f+16>>2]=c[25728+16>>2];c[_f+20>>2]=c[25728+20>>2];Pe[Zf&127](b,f+24|0,Yf,Xf);}dg=540.0/e+-.5;c[Wf>>2]=1;h[(jYa(ag,1,Wf)|0)>>3]=dg*dg;c[Vf>>2]=1;eg=dg*+h[(jYa(ag,1,Vf)|0)>>3];c[Uf>>2]=2;h[(jYa(ag,1,Uf)|0)>>3]=eg;c[Tf>>2]=2;eg=+h[(jYa(ag,1,Tf)|0)>>3]*-.05032527872793;c[Sf>>2]=3;h[(jYa(ag,1,Sf)|0)>>3]=eg;c[Rf>>2]=3;eg=+h[(jYa(ag,1,Rf)|0)>>3]+-.057581259083432;c[Qf>>2]=4;h[(jYa(ag,1,Qf)|0)>>3]=eg;c[Pf>>2]=4;eg=dg*+h[(jYa(ag,1,Pf)|0)>>3];c[Of>>2]=5;h[(jYa(ag,1,Of)|0)>>3]=eg;c[Nf>>2]=5;eg=+h[(jYa(ag,1,Nf)|0)>>3]+-.045996013696365;c[Mf>>2]=6;h[(jYa(ag,1,Mf)|0)>>3]=eg;c[Lf>>2]=6;eg=dg*+h[(jYa(ag,1,Lf)|0)>>3];c[Kf>>2]=7;h[(jYa(ag,1,Kf)|0)>>3]=eg;c[Jf>>2]=7;eg=+h[(jYa(ag,1,Jf)|0)>>3]+-.017834862292358;c[If>>2]=8;h[(jYa(ag,1,If)|0)>>3]=eg;c[Hf>>2]=8;eg=dg*+h[(jYa(ag,1,Hf)|0)>>3];c[Gf>>2]=9;h[(jYa(ag,1,Gf)|0)>>3]=eg;c[Ff>>2]=1;eg=+h[(jYa(ag,1,Ff)|0)>>3];c[Ef>>2]=10;h[(jYa(ag,1,Ef)|0)>>3]=eg*eg;c[Df>>2]=10;eg=+h[(jYa(ag,1,Df)|0)>>3];c[Cf>>2]=11;h[(jYa(ag,1,Cf)|0)>>3]=eg*eg;c[Bf>>2]=11;eg=+h[(jYa(ag,1,Bf)|0)>>3];c[Af>>2]=12;h[(jYa(ag,1,Af)|0)>>3]=eg*eg;c[zf>>2]=10;eg=+h[(jYa(ag,1,zf)|0)>>3];c[yf>>2]=11;fg=+h[(jYa(ag,1,yf)|0)>>3];c[xf>>2]=12;gg=eg*fg*dg*+h[(jYa(ag,1,xf)|0)>>3];c[wf>>2]=13;h[(jYa(ag,1,wf)|0)>>3]=gg;c[vf>>2]=1;gg=+h[(jYa(ag,1,vf)|0)>>3];c[uf>>2]=10;fg=gg*dg*+h[(jYa(ag,1,uf)|0)>>3];c[tf>>2]=14;h[(jYa(ag,1,tf)|0)>>3]=fg;c[sf>>2]=10;fg=+h[(jYa(ag,1,sf)|0)>>3];c[rf>>2]=11;gg=fg*dg*+h[(jYa(ag,1,rf)|0)>>3];c[qf>>2]=15;h[(jYa(ag,1,qf)|0)>>3]=gg;c[pf>>2]=1;gg=+h[(jYa(ag,1,pf)|0)>>3];c[of>>2]=12;fg=gg*dg*+h[(jYa(ag,1,of)|0)>>3];c[nf>>2]=16;h[(jYa(ag,1,nf)|0)>>3]=fg;c[mf>>2]=1;fg=+h[(jYa(ag,1,mf)|0)>>3];c[lf>>2]=11;gg=fg*dg*+h[(jYa(ag,1,lf)|0)>>3];c[kf>>2]=17;h[(jYa(ag,1,kf)|0)>>3]=gg;c[jf>>2]=1;gg=+h[(jYa(ag,1,jf)|0)>>3];c[hf>>2]=10;fg=+h[(jYa(ag,1,hf)|0)>>3];c[gf>>2]=11;eg=gg*fg*+h[(jYa(ag,1,gf)|0)>>3];c[ff>>2]=18;h[(jYa(ag,1,ff)|0)>>3]=eg;c[ef>>2]=10;eg=+h[(jYa(ag,1,ef)|0)>>3];c[df>>2]=11;fg=+h[(jYa(ag,1,df)|0)>>3];c[cf>>2]=12;gg=eg*fg*+h[(jYa(ag,1,cf)|0)>>3];c[bf>>2]=19;h[(jYa(ag,1,bf)|0)>>3]=gg;c[af>>2]=1;gg=+h[(jYa(ag,1,af)|0)>>3];c[$e>>2]=10;fg=gg*+h[(jYa(ag,1,$e)|0)>>3];c[_e>>2]=20;h[(jYa(ag,1,_e)|0)>>3]=fg;c[Ze>>2]=21;h[(jYa(ag,1,Ze)|0)>>3]=d/1.0e6*(d/1.0e6);c[Ye>>2]=21;fg=+h[(jYa(ag,1,Ye)|0)>>3];c[Xe>>2]=22;h[(jYa(ag,1,Xe)|0)>>3]=fg*fg;c[We>>2]=21;fg=+h[(jYa(ag,1,We)|0)>>3];c[Ve>>2]=22;gg=fg*+h[(jYa(ag,1,Ve)|0)>>3];c[Ue>>2]=23;h[(jYa(ag,1,Ue)|0)>>3]=gg;c[Te>>2]=10;gg=+h[(jYa(ag,1,Te)|0)>>3];c[Se>>2]=12;fg=gg*dg*+h[(jYa(ag,1,Se)|0)>>3];c[Re>>2]=24;h[(jYa(ag,1,Re)|0)>>3]=fg;c[Qe>>2]=12;fg=+h[(jYa(ag,1,Qe)|0)>>3];c[Oe>>2]=25;h[(jYa(ag,1,Oe)|0)>>3]=fg*fg;c[Ne>>2]=11;fg=+h[(jYa(ag,1,Ne)|0)>>3];c[Me>>2]=12;gg=+h[(jYa(ag,1,Me)|0)>>3];c[Le>>2]=25;eg=fg*gg*dg*+h[(jYa(ag,1,Le)|0)>>3];c[Ke>>2]=26;h[(jYa(ag,1,Ke)|0)>>3]=eg;c[Je>>2]=10;eg=+h[(jYa(ag,1,Je)|0)>>3];c[Ie>>2]=12;gg=eg*+h[(jYa(ag,1,Ie)|0)>>3];c[He>>2]=27;h[(jYa(ag,1,He)|0)>>3]=gg;c[Ge>>2]=1;gg=+h[(jYa(ag,1,Ge)|0)>>3];c[Fe>>2]=10;eg=+h[(jYa(ag,1,Fe)|0)>>3];c[Ee>>2]=11;fg=gg*eg*dg*+h[(jYa(ag,1,Ee)|0)>>3];c[De>>2]=28;h[(jYa(ag,1,De)|0)>>3]=fg;c[Ce>>2]=10;fg=+h[(jYa(ag,1,Ce)|0)>>3];c[Be>>2]=12;eg=+h[(jYa(ag,1,Be)|0)>>3];c[Ae>>2]=25;gg=fg*eg*dg*+h[(jYa(ag,1,Ae)|0)>>3];c[ze>>2]=29;h[(jYa(ag,1,ze)|0)>>3]=gg;c[ye>>2]=1;gg=+h[(jYa(ag,1,ye)|0)>>3];c[xe>>2]=10;eg=+h[(jYa(ag,1,xe)|0)>>3];c[we>>2]=25;fg=gg*eg*dg*+h[(jYa(ag,1,we)|0)>>3];c[ve>>2]=30;h[(jYa(ag,1,ve)|0)>>3]=fg;c[ue>>2]=1;fg=+h[(jYa(ag,1,ue)|0)>>3];c[te>>2]=11;eg=+h[(jYa(ag,1,te)|0)>>3];c[se>>2]=12;gg=fg*eg*+h[(jYa(ag,1,se)|0)>>3];c[re>>2]=31;h[(jYa(ag,1,re)|0)>>3]=gg;c[qe>>2]=1;gg=+h[(jYa(ag,1,qe)|0)>>3];c[pe>>2]=12;eg=gg*+h[(jYa(ag,1,pe)|0)>>3];c[oe>>2]=32;h[(jYa(ag,1,oe)|0)>>3]=eg;c[ne>>2]=33;h[(jYa(ag,1,ne)|0)>>3]=540.0/e*(540.0/e);c[me>>2]=33;eg=+h[(jYa(ag,1,me)|0)>>3];c[le>>2]=34;h[(jYa(ag,1,le)|0)>>3]=eg*eg;c[ke>>2]=13;eg=+h[(jYa(ag,1,ke)|0)>>3]*-53349095828174.0e-18;c[je>>2]=35;h[(jYa(ag,1,je)|0)>>3]=eg;c[ie>>2]=35;eg=+h[(jYa(ag,1,ie)|0)>>3]+-.087594591301146;c[he>>2]=36;h[(jYa(ag,1,he)|0)>>3]=eg;c[ge>>2]=2;eg=+h[(jYa(ag,1,ge)|0)>>3];c[fe>>2]=36;gg=eg*+h[(jYa(ag,1,fe)|0)>>3];c[ee>>2]=37;h[(jYa(ag,1,ee)|0)>>3]=gg;c[de>>2]=37;gg=+h[(jYa(ag,1,de)|0)>>3]+-.007878555448671;c[ce>>2]=38;h[(jYa(ag,1,ce)|0)>>3]=gg;c[be>>2]=1;gg=+h[(jYa(ag,1,be)|0)>>3];c[ae>>2]=38;eg=gg*+h[(jYa(ag,1,ae)|0)>>3];c[$d>>2]=39;h[(jYa(ag,1,$d)|0)>>3]=eg;c[_d>>2]=39;eg=+h[(jYa(ag,1,_d)|0)>>3]+-.0003789797503263;c[Zd>>2]=40;h[(jYa(ag,1,Zd)|0)>>3]=eg;c[Yd>>2]=40;eg=dg*+h[(jYa(ag,1,Yd)|0)>>3];c[Xd>>2]=41;h[(jYa(ag,1,Xd)|0)>>3]=eg;c[Wd>>2]=41;eg=+h[(jYa(ag,1,Wd)|0)>>3]+-66065283340406.0e-18;c[Vd>>2]=42;h[(jYa(ag,1,Vd)|0)>>3]=eg;c[Ud>>2]=42;eg=dg*+h[(jYa(ag,1,Ud)|0)>>3];c[Td>>2]=43;h[(jYa(ag,1,Td)|0)>>3]=eg;c[Sd>>2]=44;h[(jYa(ag,1,Sd)|0)>>3]=dg*57870447262208.0e-19;c[Rd>>2]=2;eg=+h[(jYa(ag,1,Rd)|0)>>3]*-.30195167236758;c[Qd>>2]=45;h[(jYa(ag,1,Qd)|0)>>3]=eg;c[Pd>>2]=45;eg=+h[(jYa(ag,1,Pd)|0)>>3]+-.172743777250296;c[Od>>2]=46;h[(jYa(ag,1,Od)|0)>>3]=eg;c[Nd>>2]=46;eg=dg*+h[(jYa(ag,1,Nd)|0)>>3];c[Md>>2]=47;h[(jYa(ag,1,Md)|0)>>3]=eg;c[Ld>>2]=47;eg=+h[(jYa(ag,1,Ld)|0)>>3]+-.09199202739273;c[Kd>>2]=48;h[(jYa(ag,1,Kd)|0)>>3]=eg;c[Jd>>2]=48;eg=dg*+h[(jYa(ag,1,Jd)|0)>>3];c[Id>>2]=49;h[(jYa(ag,1,Id)|0)>>3]=eg;c[Hd>>2]=1;eg=+h[(jYa(ag,1,Hd)|0)>>3];c[Gd>>2]=11;gg=eg*+h[(jYa(ag,1,Gd)|0)>>3];c[Fd>>2]=50;h[(jYa(ag,1,Fd)|0)>>3]=gg;c[Ed>>2]=10;gg=+h[(jYa(ag,1,Ed)|0)>>3];c[Dd>>2]=11;eg=gg*+h[(jYa(ag,1,Dd)|0)>>3];c[Cd>>2]=51;h[(jYa(ag,1,Cd)|0)>>3]=eg;c[Bd>>2]=11;c[f+136>>2]=a;c[f+144>>2]=b;g[f+152>>2]=d;g[f+160>>2]=e;g[f+1512>>2]=dg;c[f+2688>>2]=ag;c[f+2720>>2]=pb;c[f+2728>>2]=ob;c[f+2736>>2]=nb;c[f+2752>>2]=mb;c[f+2760>>2]=lb;c[f+2768>>2]=kb;c[f+2776>>2]=jb;c[f+2784>>2]=ib;c[f+2792>>2]=hb;c[f+2800>>2]=gb;c[f+2808>>2]=fb;c[f+2816>>2]=eb;c[f+2824>>2]=db;c[f+2840>>2]=cb;c[f+2848>>2]=bb;c[f+2856>>2]=ab;c[f+2864>>2]=$a;c[f+2872>>2]=_a;c[f+2880>>2]=Za;c[f+2888>>2]=Ya;c[f+2896>>2]=Xa;c[f+2904>>2]=Wa;c[f+2912>>2]=Va;c[f+2928>>2]=Ua;c[f+2936>>2]=Ta;c[f+2944>>2]=Sa;c[f+2952>>2]=Ra;c[f+2960>>2]=Qa;c[f+2968>>2]=Pa;c[f+2976>>2]=Oa;c[f+2984>>2]=Na;c[f+2992>>2]=Ma;c[f+3e3>>2]=La;c[f+3016>>2]=Ka;c[f+3024>>2]=Ja;c[f+3032>>2]=Ia;c[f+3040>>2]=Ha;c[f+3048>>2]=Ga;c[f+3056>>2]=Fa;c[f+3064>>2]=Ea;c[f+3072>>2]=Da;c[f+3080>>2]=Ca;c[f+3088>>2]=Ba;c[f+3104>>2]=Aa;c[f+3112>>2]=za;c[f+3120>>2]=ya;c[f+3128>>2]=xa;c[f+3136>>2]=wa;c[f+3144>>2]=va;c[f+3152>>2]=ua;c[f+3160>>2]=ta;c[f+3168>>2]=sa;c[f+3176>>2]=ra;c[f+3192>>2]=qa;c[f+3200>>2]=pa;c[f+3208>>2]=oa;c[f+3216>>2]=na;c[f+3224>>2]=ma;c[f+3232>>2]=la;c[f+3240>>2]=ka;c[f+3248>>2]=ja;c[f+3256>>2]=ia;c[f+3264>>2]=ha;c[f+3280>>2]=ga;c[f+3288>>2]=fa;c[f+3296>>2]=ea;c[f+3304>>2]=da;c[f+3312>>2]=ca;c[f+3320>>2]=ba;c[f+3328>>2]=aa;c[f+3336>>2]=$;c[f+3344>>2]=_;c[f+3352>>2]=Z;c[f+3368>>2]=Y;c[f+3376>>2]=X;c[f+3392>>2]=W;c[f+3400>>2]=V;c[f+3408>>2]=U;c[f+3416>>2]=T;c[f+3424>>2]=S;c[f+3432>>2]=R;c[f+3440>>2]=Q;c[f+3448>>2]=P;c[f+3464>>2]=O;c[f+3472>>2]=N;c[f+3480>>2]=M;c[f+3488>>2]=L;c[f+3496>>2]=K;c[f+3504>>2]=J;c[f+3512>>2]=G;c[f+3520>>2]=F;c[f+3528>>2]=E;c[f+3536>>2]=D;c[f+3552>>2]=C;c[f+3560>>2]=B;c[f+3568>>2]=z;c[f+3576>>2]=y;c[f+3584>>2]=x;c[f+3592>>2]=w;c[f+3600>>2]=v;c[f+3608>>2]=u;c[f+3616>>2]=t;c[f+3624>>2]=s;c[f+3640>>2]=r;c[f+3648>>2]=q;c[f+3656>>2]=p;c[f+3664>>2]=o;c[f+3672>>2]=n;c[f+3680>>2]=m;c[f+3688>>2]=l;c[f+3696>>2]=k;c[f+3704>>2]=j;c[f+4544>>2]=Bd;c[f+4552>>2]=Ad;c[f+4560>>2]=zd;c[f+4576>>2]=yd;c[f+4584>>2]=xd;c[f+4592>>2]=wd;c[f+4600>>2]=vd;c[f+4608>>2]=ud;c[f+4616>>2]=td;c[f+4624>>2]=sd;c[f+4632>>2]=rd;c[f+4640>>2]=qd;c[f+4648>>2]=pd;c[f+4664>>2]=od;c[f+4672>>2]=nd;c[f+4680>>2]=md;c[f+4688>>2]=ld;c[f+4696>>2]=kd;c[f+4704>>2]=jd;c[f+4712>>2]=id;c[f+4720>>2]=hd;c[f+4728>>2]=gd;c[f+4736>>2]=fd;c[f+4752>>2]=ed;c[f+4760>>2]=dd;c[f+4768>>2]=cd;c[f+4776>>2]=bd;c[f+4784>>2]=ad;c[f+4792>>2]=$c;c[f+4800>>2]=_c;c[f+4808>>2]=Zc;c[f+4816>>2]=Yc;c[f+4824>>2]=Xc;c[f+4840>>2]=Wc;c[f+4848>>2]=Vc;c[f+4856>>2]=Uc;c[f+4864>>2]=Tc;c[f+4872>>2]=Sc;c[f+4880>>2]=Rc;c[f+4888>>2]=Qc;c[f+4896>>2]=Pc;c[f+4904>>2]=Oc;c[f+4912>>2]=Nc;c[f+4928>>2]=Mc;c[f+4936>>2]=Lc;c[f+4952>>2]=Kc;c[f+4960>>2]=Jc;c[f+4968>>2]=Ic;c[f+4976>>2]=Hc;c[f+4984>>2]=Gc;c[f+4992>>2]=Fc;c[f+5e3>>2]=Ec;c[f+5008>>2]=Dc;c[f+5024>>2]=Cc;c[f+5032>>2]=Bc;c[f+5040>>2]=Ac;c[f+5048>>2]=zc;c[f+5056>>2]=yc;c[f+5064>>2]=xc;c[f+5072>>2]=wc;c[f+5080>>2]=vc;c[f+5088>>2]=uc;c[f+5096>>2]=tc;c[f+5112>>2]=sc;c[f+5120>>2]=rc;c[f+5128>>2]=qc;c[f+5136>>2]=pc;c[f+5144>>2]=oc;c[f+5152>>2]=nc;c[f+5160>>2]=mc;c[f+5168>>2]=lc;c[f+5176>>2]=kc;c[f+5184>>2]=jc;c[f+5200>>2]=ic;c[f+5208>>2]=hc;c[f+5216>>2]=gc;c[f+5224>>2]=fc;c[f+5232>>2]=ec;c[f+5240>>2]=dc;c[f+5248>>2]=cc;c[f+5256>>2]=bc;c[f+5264>>2]=ac;c[f+5272>>2]=$b;c[f+5288>>2]=_b;c[f+5296>>2]=Zb;c[f+5304>>2]=Yb;c[f+5312>>2]=Xb;c[f+5320>>2]=Wb;c[f+5328>>2]=Vb;c[f+5336>>2]=Ub;c[f+5344>>2]=Tb;c[f+5352>>2]=Sb;c[f+5360>>2]=Rb;c[f+5376>>2]=Qb;c[f+5384>>2]=Pb;c[f+5392>>2]=Ob;c[f+5400>>2]=Nb;c[f+5408>>2]=Mb;c[f+5416>>2]=Lb;c[f+5424>>2]=Kb;c[f+5432>>2]=Jb;c[f+5440>>2]=Ib;c[f+5448>>2]=Hb;c[f+5464>>2]=Gb;c[f+5472>>2]=Fb;c[f+5480>>2]=Eb;c[f+5488>>2]=Db;c[f+5496>>2]=Cb;c[f+5504>>2]=Bb;c[f+5512>>2]=Ab;c[f+5520>>2]=zb;c[f+5528>>2]=yb;c[f+5536>>2]=xb;c[f+5552>>2]=wb;c[f+5560>>2]=vb;c[f+5568>>2]=ub;c[f+5576>>2]=tb;c[f+5584>>2]=sb;c[f+5592>>2]=rb;c[f+5600>>2]=qb;c[f+5648>>2]=0;c[f+5652>>2]=0;_omc_Modelica_Media_Water_IF97__Utilities_BaseIF97_Basic_g2$0(f);H=c[f+5648>>2]|0;A=c[f+5652>>2]|0;I=+g[f+5652>>2];c[f+5648>>2]=0;c[f+5652>>2]=0;if((H|0)==5){return}}function wE(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0;f=i;i=i+32|0;g=f;j=f+24|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;c[v>>2]=3;eYa(w,1,v);if(!(d>611.657)){v=RXa(RXa(25776,PXa(d,0,1,6)|0)|0,24408)|0;x=RXa(RXa(v,PXa(611.657,0,1,6)|0)|0,24416)|0;v=c[72300]|0;y=g;z=25840;c[y+0>>2]=c[z+0>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];c[y+12>>2]=c[z+12>>2];c[y+16>>2]=c[z+16>>2];c[y+20>>2]=c[z+20>>2];Pe[v&127](b,g,x,u);}A=d/1.0e6;d=e/25.0e5+1.0;c[t>>2]=1;h[(jYa(w,1,t)|0)>>3]=d*d;c[s>>2]=1;e=+h[(jYa(w,1,s)|0)>>3];c[r>>2]=2;h[(jYa(w,1,r)|0)>>3]=e*e;c[q>>2]=2;e=+h[(jYa(w,1,q)|0)>>3];c[p>>2]=3;h[(jYa(w,1,p)|0)>>3]=e*e;c[o>>2]=1;e=+h[(jYa(w,1,o)|0)>>3];c[n>>2]=2;B=+h[(jYa(w,1,n)|0)>>3];c[m>>2]=2;C=+h[(jYa(w,1,m)|0)>>3];c[l>>2]=3;D=+h[(jYa(w,1,l)|0)>>3];c[k>>2]=1;E=+h[(jYa(w,1,k)|0)>>3];c[j>>2]=3;h[a>>3]=A*-13.391744872602+d*(A*43.211039183559+d*(A*-54.010067170506+d*(A*30.535892203916+d*(A*-6.5964749423638+e*(B*(A*(A*(A*6.6456186191635e-8+-25858641282073.0e-18)+.0093965400878363)+C*D*(E*(A*(A*(A*(A*(A*(A*-1.5020185953503e-17+5.8265442020601e-15)+-9.3477771213947e-13)+8.0670734103027e-11)+-4.0644363084799e-9)+1.157364750534e-7)+-10866707695377.0e-19)*+h[(jYa(w,1,j)|0)>>3]+-.0001528548241314))+-5.8457616048039)))+113.49746881718)+404.21188637945)+-238.72489924521;i=f;return}function xE(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0.0,N=0.0,O=0.0,P=0.0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+16|0;c[H>>2]=8;eYa(I,1,H);J=+zd(+d,647.096);if(!(d>=273.16)){H=c[72300]|0;K=f;L=25864;c[K+0>>2]=c[L+0>>2];c[K+4>>2]=c[L+4>>2];c[K+8>>2]=c[L+8>>2];c[K+12>>2]=c[L+12>>2];c[K+16>>2]=c[L+16>>2];c[K+20>>2]=c[L+20>>2];Pe[H&127](b,f,25888,G);}c[F>>2]=1;h[(jYa(I,1,F)|0)>>3]=J+-650.17534844798;c[E>>2]=1;d=1.0/+h[(jYa(I,1,E)|0)>>3];c[D>>2]=2;h[(jYa(I,1,D)|0)>>3]=d;c[C>>2]=2;d=+h[(jYa(I,1,C)|0)>>3]*-.23855557567849;c[B>>2]=3;h[(jYa(I,1,B)|0)>>3]=d;c[A>>2]=3;d=J+ +h[(jYa(I,1,A)|0)>>3];c[z>>2]=4;h[(jYa(I,1,z)|0)>>3]=d;c[y>>2]=4;d=+h[(jYa(I,1,y)|0)>>3]*-4823.2657361591;c[x>>2]=5;h[(jYa(I,1,x)|0)>>3]=d;c[w>>2]=4;d=+h[(jYa(I,1,w)|0)>>3];c[v>>2]=6;h[(jYa(I,1,v)|0)>>3]=d*d;c[u>>2]=6;d=+h[(jYa(I,1,u)|0)>>3]*14.91510861353;c[t>>2]=7;h[(jYa(I,1,t)|0)>>3]=d;c[s>>2]=5;d=+h[(jYa(I,1,s)|0)>>3];c[r>>2]=7;J=d+ +h[(jYa(I,1,r)|0)>>3]+405113.40542057;c[q>>2]=8;h[(jYa(I,1,q)|0)>>3]=J;c[p>>2]=4;J=+h[(jYa(I,1,p)|0)>>3]*12020.82470247;c[o>>2]=6;d=J+ +h[(jYa(I,1,o)|0)>>3]*-17.073846940092+-3232555.0322333;c[n>>2]=8;J=+h[(jYa(I,1,n)|0)>>3];c[m>>2]=4;M=+h[(jYa(I,1,m)|0)>>3]*-12020.82470247;c[l>>2]=6;N=+h[(jYa(I,1,l)|0)>>3]*17.073846940092;c[k>>2]=4;O=+h[(jYa(I,1,k)|0)>>3]*1167.0521452767;c[j>>2]=6;P=O+ +h[(jYa(I,1,j)|0)>>3]+-724213.16703206;c[g>>2]=8;O=J/(M+(N+ +V(+(d*d+P*+h[(jYa(I,1,g)|0)>>3]*-4.0)))+3232555.0322333);P=O*O;h[a>>3]=P*P*16.0e6;i=e;return}function yE(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0.0;b=i;i=i+8|0;e=b;f=i;i=i+16|0;c[e>>2]=4;eYa(f,1,e);g=d/1.0e6;d=g*g;h[a>>3]=(g*3.74696550136983+(d*-.0219921901054187+g*d*87513168600995.0e-18)+2014.64004206875)*1.0e3;i=b;return}function zE(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0.0,lb=0.0,mb=0.0,nb=0.0,ob=0.0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0.0,ub=0.0,vb=0.0,wb=0.0,xb=0.0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0,Mb=0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+16|0;c[ib>>2]=8;eYa(jb,1,ib);kb=d*1.0e-6;d=e*5.0e-7;lb=e*.001;if(kb<4.0){e=d+-2.1;c[hb>>2]=1;h[(jYa(jb,1,hb)|0)>>3]=e*e;c[gb>>2]=1;mb=+h[(jYa(jb,1,gb)|0)>>3];c[fb>>2]=2;h[(jYa(jb,1,fb)|0)>>3]=mb*mb;c[eb>>2]=3;h[(jYa(jb,1,eb)|0)>>3]=kb*kb;c[db>>2]=3;mb=+h[(jYa(jb,1,db)|0)>>3];c[cb>>2]=4;h[(jYa(jb,1,cb)|0)>>3]=mb*mb;c[bb>>2]=3;mb=kb*+h[(jYa(jb,1,bb)|0)>>3];c[ab>>2]=5;h[(jYa(jb,1,ab)|0)>>3]=mb;c[$a>>2]=2;mb=+h[(jYa(jb,1,$a)|0)>>3];c[_a>>2]=1;nb=+h[(jYa(jb,1,_a)|0)>>3];c[Za>>2]=1;ob=+h[(jYa(jb,1,Za)|0)>>3];c[Ya>>2]=4;pb=+h[(jYa(jb,1,Ya)|0)>>3]*1.3865724283226;c[Xa>>2]=1;qb=+h[(jYa(jb,1,Xa)|0)>>3];c[Wa>>2]=2;rb=+h[(jYa(jb,1,Wa)|0)>>3];c[Va>>2]=1;sb=+h[(jYa(jb,1,Va)|0)>>3];c[Ua>>2]=2;tb=+h[(jYa(jb,1,Ua)|0)>>3];c[Ta>>2]=5;ub=+h[(jYa(jb,1,Ta)|0)>>3]*-13551.334240775;c[Sa>>2]=2;vb=+h[(jYa(jb,1,Sa)|0)>>3];c[Ra>>2]=3;wb=+h[(jYa(jb,1,Ra)|0)>>3];c[Qa>>2]=4;xb=wb*kb*+h[(jYa(jb,1,Qa)|0)>>3]*-62.459855192507;c[Pa>>2]=2;wb=+h[(jYa(jb,1,Pa)|0)>>3];c[Oa>>2]=4;yb=(kb*7399.9835474766+235988.32556514)*+h[(jYa(jb,1,Oa)|0)>>3];c[Na>>2]=1;zb=+h[(jYa(jb,1,Na)|0)>>3];c[Ma>>2]=3;Ab=+h[(jYa(jb,1,Ma)|0)>>3];c[La>>2]=4;Bb=Ab*+h[(jYa(jb,1,La)|0)>>3]*19127.72923966;c[Ka>>2]=1;Ab=+h[(jYa(jb,1,Ka)|0)>>3];c[Ja>>2]=3;Cb=+h[(jYa(jb,1,Ja)|0)>>3];c[Ia>>2]=5;Db=Cb*(+h[(jYa(jb,1,Ia)|0)>>3]*-551966.9703006+128127984.04046);c[Ha>>2]=1;Cb=+h[(jYa(jb,1,Ha)|0)>>3];c[Ga>>2]=3;Eb=+h[(jYa(jb,1,Ga)|0)>>3]*-985549096.23276;c[Fa>>2]=1;Fb=+h[(jYa(jb,1,Fa)|0)>>3];c[Ea>>2]=3;Gb=+h[(jYa(jb,1,Ea)|0)>>3]*2822454697.3002;c[Da>>2]=1;Hb=+h[(jYa(jb,1,Da)|0)>>3];c[Ca>>2]=3;Ib=+h[(jYa(jb,1,Ca)|0)>>3];c[Ba>>2]=5;Jb=Ib*(+h[(jYa(jb,1,Ba)|0)>>3]*3715408.5996233+-3594897141.0703);c[Aa>>2]=1;Ib=+h[(jYa(jb,1,Aa)|0)>>3];c[za>>2]=3;Kb=kb*(kb*-.0061707422868339+1.844574935579)+e*(kb*-4.1792700549624+e*(kb*(kb*-.31078046629583+6.2478196935812)+e*(kb*-17.344563108114+mb*(kb*(kb*11.670873077107+-200.58176862096)+nb*(kb*271.96065473796+ob*(kb*-455.11318285818+e*(pb+qb*rb*(kb*3091.9688604755+sb*(tb*(ub+vb*(xb+wb*(yb+zb*(Bb+Ab*(Db+Cb*(Eb+Fb*(Gb+Hb*(Jb+Ib*kb*(kb*(kb*(kb*(+h[(jYa(jb,1,za)|0)>>3]*-415351.64835634+-13105236.545054)+12848734.66465)+1722734991.3197)+252266.40357872)))))))))+11.765048724356)))))+-7.4232016790248)+33.153654801263)+-107.81748091826)+849.51654495535)+1089.8952318288;Lb=a;Mb=Lb;h[Mb>>3]=Kb;i=b;return}if(kb<lb*(lb*.00012809002730136+-.67955786399241)+905.84278514723){lb=d+-2.6;Ib=kb+-2.0;c[ya>>2]=1;h[(jYa(jb,1,ya)|0)>>3]=Ib*Ib;c[xa>>2]=1;Jb=Ib*+h[(jYa(jb,1,xa)|0)>>3];c[wa>>2]=2;h[(jYa(jb,1,wa)|0)>>3]=Jb;c[va>>2]=1;Jb=+h[(jYa(jb,1,va)|0)>>3];c[ua>>2]=3;h[(jYa(jb,1,ua)|0)>>3]=Jb*Jb;c[ta>>2]=4;h[(jYa(jb,1,ta)|0)>>3]=lb*lb;c[sa>>2]=4;Jb=+h[(jYa(jb,1,sa)|0)>>3];c[ra>>2]=5;h[(jYa(jb,1,ra)|0)>>3]=Jb*Jb;c[qa>>2]=4;Jb=+h[(jYa(jb,1,qa)|0)>>3];c[pa>>2]=5;Hb=Jb*+h[(jYa(jb,1,pa)|0)>>3];c[oa>>2]=6;h[(jYa(jb,1,oa)|0)>>3]=Hb;c[na>>2]=5;Hb=+h[(jYa(jb,1,na)|0)>>3];c[ma>>2]=7;h[(jYa(jb,1,ma)|0)>>3]=Hb*Hb;c[la>>2]=2;Hb=+h[(jYa(jb,1,la)|0)>>3];c[ka>>2]=1;Jb=+h[(jYa(jb,1,ka)|0)>>3];c[ja>>2]=3;Gb=Hb*(Jb*+h[(jYa(jb,1,ja)|0)>>3]*-1.7565233969407e-18+.00011032831789999);c[ia>>2]=2;Jb=Ib*(Ib*(Ib*(Ib*(+h[(jYa(jb,1,ia)|0)>>3]*-8.1456365207833e-14+2.8640237477456e-7)+.00018955248387902)+-.021810755324761)+3.3593118604916);c[ha>>2]=5;Hb=+h[(jYa(jb,1,ha)|0)>>3];c[ga>>2]=4;Fb=+h[(jYa(jb,1,ga)|0)>>3];c[fa>>2]=1;Eb=+h[(jYa(jb,1,fa)|0)>>3]*-.10829784403677;c[ea>>2]=5;Cb=+h[(jYa(jb,1,ea)|0)>>3];c[da>>2]=1;Db=Ib*((Ib*-10779857357512.0e-18+.0030891541160537)*+h[(jYa(jb,1,da)|0)>>3]+.16844539671904);c[ca>>2]=6;Ab=+h[(jYa(jb,1,ca)|0)>>3];c[ba>>2]=1;Bb=Ib*(Ib*((Ib*2.821728163504e-7+-76462712454814.0e-18)*+h[(jYa(jb,1,ba)|0)>>3]+-.046333324635812)+.73875745236695);c[aa>>2]=6;zb=+h[(jYa(jb,1,aa)|0)>>3];c[$>>2]=1;yb=Ib*((Ib*(Ib*12704902271945.0e-19+14052392818316.0e-18)+.0013555504554949)*+h[(jYa(jb,1,$)|0)>>3]+-.47128737436186);c[_>>2]=5;wb=+h[(jYa(jb,1,_)|0)>>3];c[Z>>2]=2;xb=+h[(jYa(jb,1,Z)|0)>>3];c[Y>>2]=1;vb=Ib*(xb*((Ib*-2.5180545682962e-11+-1.1030139238909e-8)*+h[(jYa(jb,1,Y)|0)>>3]+-31083814331434.0e-18)+.15020273139707);c[X>>2]=5;xb=+h[(jYa(jb,1,X)|0)>>3];c[W>>2]=7;ub=+h[(jYa(jb,1,W)|0)>>3];c[V>>2]=1;tb=+h[(jYa(jb,1,V)|0)>>3];c[U>>2]=3;Kb=Ib*.93747147377932+lb*(Gb+lb*(Jb+Hb*(Ib*3.3809355601454+Fb*(Eb+Cb*(Db+Ab*(Bb+zb*(yb+wb*(vb+xb*ub*(Ib*(Ib*(tb*(Ib*(+h[(jYa(jb,1,U)|0)>>3]*8.6934156344163e-15+7.3803353468292e-8)+-10302738212103.0e-19)+71280351959551.0e-18)+-.002176411421975)+.0085208123431544)+-.47811863648625)+1.1385952129658)+-.63281320016026)+2.4742464705674)))+-97.708318797837)+743.07798314034)+1489.5041079516;Lb=a;Mb=Lb;h[Mb>>3]=Kb;i=b;return}else{Ib=d+-1.8;d=kb+25.0;c[T>>2]=1;h[(jYa(jb,1,T)|0)>>3]=d*d;c[S>>2]=1;kb=+h[(jYa(jb,1,S)|0)>>3];c[R>>2]=2;h[(jYa(jb,1,R)|0)>>3]=kb*kb;c[Q>>2]=1;kb=+h[(jYa(jb,1,Q)|0)>>3];c[P>>2]=2;tb=kb*d*+h[(jYa(jb,1,P)|0)>>3];c[O>>2]=3;h[(jYa(jb,1,O)|0)>>3]=tb;c[N>>2]=3;tb=1.0/+h[(jYa(jb,1,N)|0)>>3];c[M>>2]=4;h[(jYa(jb,1,M)|0)>>3]=tb;c[L>>2]=1;tb=+h[(jYa(jb,1,L)|0)>>3];c[K>>2]=2;kb=tb*+h[(jYa(jb,1,K)|0)>>3];c[J>>2]=5;h[(jYa(jb,1,J)|0)>>3]=kb;c[I>>2]=6;h[(jYa(jb,1,I)|0)>>3]=Ib*Ib;c[H>>2]=2;kb=+h[(jYa(jb,1,H)|0)>>3];c[G>>2]=7;h[(jYa(jb,1,G)|0)>>3]=kb*kb;c[F>>2]=6;kb=+h[(jYa(jb,1,F)|0)>>3];c[E>>2]=8;h[(jYa(jb,1,E)|0)>>3]=kb*kb;c[D>>2]=1;kb=+h[(jYa(jb,1,D)|0)>>3];c[C>>2]=5;tb=kb*(+h[(jYa(jb,1,C)|0)>>3]*1.126159740723e-12+482.19755109255)+859777.2253558;c[B>>2]=1;kb=tb/+h[(jYa(jb,1,B)|0)>>3];c[A>>2]=2;tb=d*(+h[(jYa(jb,1,A)|0)>>3]*31081.088422714+20825544563.171)+-583401318515.9;c[z>>2]=5;ub=tb/+h[(jYa(jb,1,z)|0)>>3];c[y>>2]=6;tb=+h[(jYa(jb,1,y)|0)>>3];c[x>>2]=8;xb=+h[(jYa(jb,1,x)|0)>>3];c[w>>2]=6;vb=+h[(jYa(jb,1,w)|0)>>3];c[v>>2]=5;wb=+h[(jYa(jb,1,v)|0)>>3]*1.2324579690832e-7;c[u>>2]=6;yb=+h[(jYa(jb,1,u)|0)>>3];c[t>>2]=5;zb=+h[(jYa(jb,1,t)|0)>>3]*-11606921130984.0e-19;c[s>>2]=8;Bb=+h[(jYa(jb,1,s)|0)>>3];c[r>>2]=5;Ab=+h[(jYa(jb,1,r)|0)>>3]*27846367088554.0e-18;c[q>>2]=5;Db=+h[(jYa(jb,1,q)|0)>>3]*-.00059270038474176;c[p>>2]=5;Cb=+h[(jYa(jb,1,p)|0)>>3];c[o>>2]=6;Eb=Db+Cb*+h[(jYa(jb,1,o)|0)>>3]*.0012918582991878;c[n>>2]=8;Cb=xb*(d*-10.842984880077+vb*(wb+yb*(zb+Bb*(Ab+ +h[(jYa(jb,1,n)|0)>>3]*Eb))));c[m>>2]=4;Eb=+h[(jYa(jb,1,m)|0)>>3];c[l>>2]=7;Ab=+h[(jYa(jb,1,l)|0)>>3];c[k>>2]=2;Bb=Ib*(kb+Ib*(ub+tb*(Cb+Eb*(Ab*(d*(+h[(jYa(jb,1,k)|0)>>3]*-1.7804982240686e-11+-.04536417267666)+3.7966001272486)+7326335090218.1))));c[j>>2]=4;Ab=+h[(jYa(jb,1,j)|0)>>3];c[g>>2]=1;Eb=+h[(jYa(jb,1,g)|0)>>3];c[f>>2]=5;Kb=Bb+Ab*(d*(d*(Eb*d*(d*(d*(+h[(jYa(jb,1,f)|0)>>3]*1.4559115658698e-13+1208.2315865936)+-25745.72360417)+610747.83564516)+-10783068217.47)+358250899454.47)+-3236839855524.2);Lb=a;Mb=Lb;h[Mb>>3]=Kb;i=b;return}}function AE(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;c[j>>2]=30;eYa(k,1,j);j=k;k=26e3;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[g>>2]=30;eYa(l,1,g);g=l;l=26016;c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];c[f>>2]=30;eYa(m,1,f);f=m;m=26032;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];n=e/28.0e5+-.72;e=d/1.0e8+.0661;d=n*n;o=e*n;p=-2.25196934336318e-9/+OYa(e,12);q=n*+OYa(e,-12)*1.40674363313486e-8;r=23378408528056.0e-19/+OYa(e,8);s=n*+OYa(e,-8)*-331833715229001.0e-19;t=n*d;u=t*+OYa(e,-8)*.00107956778514318;v=+OYa(e,-8);w=v*+OYa(n,6)*-.271382067378863;v=+OYa(e,-8);x=v*+OYa(n,7)*1.07202262490333;v=+OYa(e,-8);y=v*+OYa(n,8)*-.853821329075382;v=-215214194340526.0e-19/+OYa(e,6);z=n*+OYa(e,-6)*.00076965608822273;A=d*+OYa(e,-6)*-.00431136580433864;B=+OYa(e,-6);C=B*+OYa(n,5)*.453342167309331;B=+OYa(e,-6);D=B*+OYa(n,6)*-.507749535873652;B=+OYa(e,-6);E=B*+OYa(n,10)*-100.475154528389;B=t*+OYa(e,-4)*-.219201924648793;t=+OYa(e,-4);F=t*+OYa(n,6)*-3.21087965668917;t=+OYa(e,-4);G=t*+OYa(n,10)*607.567815637771;t=e*e;H=d*+OYa(e,-3)*.18749904002955;I=n*+OYa(e,-2)*.00905368030448107;J=d*+OYa(e,-2)*.285417173048685;K=+OYa(n,5)/e*-11.8035753702231;h[a>>3]=(p+(q+(r+(s+(u+(w+(x+(y+(v+(z+(A+(C+(D+(E+(B+(F+(G+(.000557686450685932/(e*t)+(H+(I+(J+(.0329924030996098/e+(n/e*.239897419685483+(d*d/e*4.82754995951394+(K+(e*-.0179967222507787+(o*.0371810116332674+(o*o*-.0536288335065096+t*+OYa(n,6)*1.6069710109252)))))))))))))))))))))))))))+.169490044091791)*.0088;i=b;return}function BE(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;c[j>>2]=32;eYa(k,1,j);j=k;k=26048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[g>>2]=32;eYa(l,1,g);g=l;l=26064;c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];c[f>>2]=32;eYa(m,1,f);f=m;m=26080;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];n=e/21.0e5+-.727;e=n*n;o=d/1.0e8+.128;d=o*n;p=o*o;q=+OYa(o,-12);r=q*+OYa(n,6)*.00529944062966028;q=+OYa(o,-12);s=q*+OYa(n,8)*-.170099690234461;q=+OYa(o,-12);t=q*+OYa(n,12)*11.1323814312927;q=+OYa(o,-12);u=q*+OYa(n,18)*-2178.98123145125;q=e*e;v=q*+OYa(o,-10)*-.000506061827980875;w=+OYa(o,-10);x=w*+OYa(n,7)*.556495239685324;w=+OYa(o,-10);y=w*+OYa(n,10)*-9.43672726094016;w=+OYa(o,-8);z=w*+OYa(n,5)*-.297856807561527;w=+OYa(o,-8);A=w*+OYa(n,12)*93.9353943717186;w=n*e;B=w*+OYa(o,-6)*.0192944939465981;C=q*+OYa(o,-6)*.421740664704763;q=+OYa(o,-6);D=q*+OYa(n,22)*-3689141.2628233;q=e*+OYa(o,-4)*-.00737566847600639;E=w*+OYa(o,-4)*-.354753242424366;F=+OYa(o,-3);G=F*+OYa(n,7)*-1.99768169338727;F=w*+OYa(o,-2)*1.15456297059049;H=+OYa(o,-2);I=H*+OYa(n,16)*5683.6687581596;H=e*+OYa(o,5)*1.10533464706142;h[a>>3]=(r+(s+(t+(u+(v+(x+(y+(z+(A+(B+(C+(D+(q+(E+(G+(F+(I+(.00808169540124668/o+(n/o*.172416341519307+(e/o*1.04270175292927+(w/o*-.297691372792847+(n*.275234661176914+(o*-.148347894866012+(d*-.0651142513478515+(o*e*-2.92468715386302+(p*.0664876096952665+(d*d*3.52335014263844+(o*p*-.0146340792313332+(p*p*e*-2.24503486668184+(H+e*+OYa(o,8)*-.0408757344495612)))))))))))))))))))))))))))))+.560394465163593)*.0028;i=b;return}function CE(b,c,d){b=b|0;c=c|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0;e=i;i=i+216|0;f=e+8|0;g=e+16|0;j=e+24|0;k=e+112|0;l=e+120|0;m=e+208|0;n=e;o=+zd(+d,22063999.9999999);kE(f,c,o);p=+h[f>>3];uE(g,c,p);q=+h[g>>3];g=p>623.15;f=g&1;if(g){lE(k,0,o);r=+h[k>>3];pE(l,c,r,p);s=+h[l+16>>3];t=+h[l+24>>3];u=+h[l+32>>3];v=+h[l+40>>3];w=+h[l+48>>3];x=+h[l+56>>3];y=+h[l+64>>3];z=+h[l+72>>3];A=+h[l+80>>3];DE(m,0,o);B=r*t*(w-u*A)*461.526;C=p*t*(w*2.0+t*x)*461.526;D=0.0;E=0.0;F=r;G=+h[m>>3];H=s*(u*y-v);I=0.0;J=u*u*z*-461.526}else{rE(j,c,d,p);z=+h[j+24>>3];u=+h[j+32>>3];v=+h[j+48>>3];y=+h[j+56>>3];s=+h[j+80>>3];r=z*v;x=u*+h[j+64>>3];if(o<d){K=2087546.84511715}else{K=p*x*461.526}o=+h[j+16>>3]*(x- +h[j+40>>3]);x=u*u*+h[j+72>>3]*-461.526;B=-((v-u*s)/(p*z*y)*d);C=p*(v*v/y)*-461.526;D=(r-u*z*s)/d*461.526;E=p*z*z*y*+OYa(d,-2)*461.526;F=d/(p*r*461.526);G=K;H=o;I=x;J=0.0}j=b;a[j]=f;f=j+1|0;a[f+0|0]=a[n+0|0]|0;a[f+1|0]=a[n+1|0]|0;a[f+2|0]=a[n+2|0]|0;a[f+3|0]=a[n+3|0]|0;a[f+4|0]=a[n+4|0]|0;a[f+5|0]=a[n+5|0]|0;a[f+6|0]=a[n+6|0]|0;h[b+8>>3]=461.526;h[b+16>>3]=p;h[b+24>>3]=F;h[b+32>>3]=G;h[b+40>>3]=H;h[b+48>>3]=I;h[b+56>>3]=J;h[b+64>>3]=q;h[b+72>>3]=B;h[b+80>>3]=C;h[b+88>>3]=D;h[b+96>>3]=E;i=e;return}function DE(a,b,c){a=a|0;b=b|0;c=+c;var d=0.0;d=+_(+(c/22064.0e3));h[a>>3]=(d*(d*(d*(d*(d*(d*(d*(d*-.0001152032945617821+-.717981855497894)+3.558919744656498)+-6.75820241066552)+6.679385472887931)+-3.889388153209752)+1.346800016564904)+-.4945586958175176)+1.0)*2087546.84511715;i=i;return}function EE(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0.0,ib=0.0,jb=0.0,kb=0.0,lb=0.0,mb=0.0,nb=0.0,ob=0.0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0.0,ub=0.0,vb=0.0,wb=0.0,xb=0.0;f=i;i=i+32|0;g=f;j=f+24|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+16|0;c[Va>>2]=16;eYa(Wa,1,Va);if(!(d>611.657)){Va=RXa(RXa(26208,PXa(d,0,1,6)|0)|0,24408)|0;Xa=RXa(RXa(Va,PXa(611.657,0,1,6)|0)|0,24416)|0;Va=c[72300]|0;Ya=g;Za=26272;c[Ya+0>>2]=c[Za+0>>2];c[Ya+4>>2]=c[Za+4>>2];c[Ya+8>>2]=c[Za+8>>2];c[Ya+12>>2]=c[Za+12>>2];c[Ya+16>>2]=c[Za+16>>2];c[Ya+20>>2]=c[Za+20>>2];Pe[Va&127](b,g,Xa,Ua);}_a=d/1.0e6;d=540.0/e;$a=d+-.5;c[Ta>>2]=1;h[(jYa(Wa,1,Ta)|0)>>3]=d*d;c[Sa>>2]=1;ab=+h[(jYa(Wa,1,Sa)|0)>>3];c[Ra>>2]=2;h[(jYa(Wa,1,Ra)|0)>>3]=ab*ab;c[Qa>>2]=3;h[(jYa(Wa,1,Qa)|0)>>3]=$a*$a;c[Pa>>2]=3;ab=$a*+h[(jYa(Wa,1,Pa)|0)>>3];c[Oa>>2]=4;h[(jYa(Wa,1,Oa)|0)>>3]=ab;c[Na>>2]=3;ab=+h[(jYa(Wa,1,Na)|0)>>3];c[Ma>>2]=5;h[(jYa(Wa,1,Ma)|0)>>3]=ab*ab;c[La>>2]=5;ab=+h[(jYa(Wa,1,La)|0)>>3];c[Ka>>2]=6;h[(jYa(Wa,1,Ka)|0)>>3]=ab*ab;c[Ja>>2]=6;ab=+h[(jYa(Wa,1,Ja)|0)>>3];c[Ia>>2]=7;h[(jYa(Wa,1,Ia)|0)>>3]=ab*ab;c[Ha>>2]=5;ab=+h[(jYa(Wa,1,Ha)|0)>>3];c[Ga>>2]=6;bb=+h[(jYa(Wa,1,Ga)|0)>>3];c[Fa>>2]=7;cb=ab*bb*$a*+h[(jYa(Wa,1,Fa)|0)>>3];c[Ea>>2]=8;h[(jYa(Wa,1,Ea)|0)>>3]=cb;c[Da>>2]=3;cb=+h[(jYa(Wa,1,Da)|0)>>3];c[Ca>>2]=5;bb=cb*+h[(jYa(Wa,1,Ca)|0)>>3];c[Ba>>2]=9;h[(jYa(Wa,1,Ba)|0)>>3]=bb;c[Aa>>2]=5;bb=+h[(jYa(Wa,1,Aa)|0)>>3];c[za>>2]=6;cb=bb*$a*+h[(jYa(Wa,1,za)|0)>>3];c[ya>>2]=10;h[(jYa(Wa,1,ya)|0)>>3]=cb;c[xa>>2]=3;cb=+h[(jYa(Wa,1,xa)|0)>>3];c[wa>>2]=7;bb=cb*$a*+h[(jYa(Wa,1,wa)|0)>>3];c[va>>2]=11;h[(jYa(Wa,1,va)|0)>>3]=bb;c[ua>>2]=3;bb=+h[(jYa(Wa,1,ua)|0)>>3];c[ta>>2]=5;cb=+h[(jYa(Wa,1,ta)|0)>>3];c[sa>>2]=6;ab=bb*cb*+h[(jYa(Wa,1,sa)|0)>>3];c[ra>>2]=12;h[(jYa(Wa,1,ra)|0)>>3]=ab;c[qa>>2]=5;ab=+h[(jYa(Wa,1,qa)|0)>>3];c[pa>>2]=6;cb=+h[(jYa(Wa,1,pa)|0)>>3];c[oa>>2]=7;bb=ab*cb*+h[(jYa(Wa,1,oa)|0)>>3];c[na>>2]=13;h[(jYa(Wa,1,na)|0)>>3]=bb;c[ma>>2]=14;h[(jYa(Wa,1,ma)|0)>>3]=_a*_a;c[la>>2]=14;bb=+h[(jYa(Wa,1,la)|0)>>3];c[ka>>2]=15;h[(jYa(Wa,1,ka)|0)>>3]=bb*bb;c[ja>>2]=7;bb=+h[(jYa(Wa,1,ja)|0)>>3];c[ia>>2]=16;h[(jYa(Wa,1,ia)|0)>>3]=bb*bb;c[ha>>2]=1;bb=d*(d*(d*(d*((d*(d*.06380539059921+-.5681726521544)+10.08665568018)*+h[(jYa(Wa,1,ha)|0)>>3]+4.38395111945)+-2.848163942888)+1.2213149471784)+-.2858109552582)+.0280439559151;c[ga>>2]=2;cb=+h[(jYa(Wa,1,ga)|0)>>3];c[fa>>2]=1;ab=bb/(cb*+h[(jYa(Wa,1,fa)|0)>>3]);c[ea>>2]=4;cb=$a*($a*(+h[(jYa(Wa,1,ea)|0)>>3]*-.30195167236758+-.172743777250296)+-.09199202739273);c[da>>2]=3;bb=+h[(jYa(Wa,1,da)|0)>>3];c[ca>>2]=4;db=+h[(jYa(Wa,1,ca)|0)>>3];c[ba>>2]=8;eb=$a*(bb*(db*(+h[(jYa(Wa,1,ba)|0)>>3]*-.000960283724907132+-.306581069554011)+-.015757110897342)+-.0003789797503263);c[aa>>2]=3;db=+h[(jYa(Wa,1,aa)|0)>>3];c[$>>2]=4;bb=+h[(jYa(Wa,1,$)|0)>>3];c[_>>2]=8;fb=db*(bb*(+h[(jYa(Wa,1,_)|0)>>3]*-1.42338887469272+-.0090203547252888)+-9683303171571.0e-17);c[Z>>2]=9;bb=+h[(jYa(Wa,1,Z)|0)>>3]*160454534363627.0e-19;c[Y>>2]=10;db=+h[(jYa(Wa,1,Y)|0)>>3];c[X>>2]=11;gb=db*(+h[(jYa(Wa,1,X)|0)>>3]*-836.35096769364+-.033874355714168)+-5.0144299353183e-11;c[W>>2]=3;db=+h[(jYa(Wa,1,W)|0)>>3]*gb;c[V>>2]=12;gb=+h[(jYa(Wa,1,V)|0)>>3]*-.973671060893475+-138839897890111.0e-19;c[U>>2]=3;hb=+h[(jYa(Wa,1,U)|0)>>3];c[T>>2]=6;ib=gb*hb*+h[(jYa(Wa,1,T)|0)>>3];c[S>>2]=13;hb=+h[(jYa(Wa,1,S)|0)>>3]*-296.320827232793+9.0049690883672e-11;c[R>>2]=3;gb=+h[(jYa(Wa,1,R)|0)>>3];c[Q>>2]=5;jb=hb*gb*$a*+h[(jYa(Wa,1,Q)|0)>>3];c[P>>2]=5;gb=+h[(jYa(Wa,1,P)|0)>>3];c[O>>2]=6;hb=gb*+h[(jYa(Wa,1,O)|0)>>3]*2.57526266427144e-7;c[N>>2]=4;gb=+h[(jYa(Wa,1,N)|0)>>3];c[M>>2]=5;kb=+h[(jYa(Wa,1,M)|0)>>3]*-1.40254511313154e-8+-1.0234747095929e-12;c[L>>2]=9;lb=gb*(kb*+h[(jYa(Wa,1,L)|0)>>3]+4.1627860840696e-19);c[K>>2]=14;kb=+h[(jYa(Wa,1,K)|0)>>3];c[J>>2]=15;gb=+h[(jYa(Wa,1,J)|0)>>3];c[I>>2]=13;mb=+h[(jYa(Wa,1,I)|0)>>3];c[H>>2]=5;nb=+h[(jYa(Wa,1,H)|0)>>3];c[G>>2]=7;ob=mb*(nb*$a*+h[(jYa(Wa,1,G)|0)>>3]*5.3465159397045+-2.34560435076256e-9);c[F>>2]=14;nb=+h[(jYa(Wa,1,F)|0)>>3];c[E>>2]=16;mb=+h[(jYa(Wa,1,E)|0)>>3];c[D>>2]=6;pb=+h[(jYa(Wa,1,D)|0)>>3];c[C>>2]=7;qb=mb*pb*+h[(jYa(Wa,1,C)|0)>>3]*-19.1874828272775;c[B>>2]=14;pb=+h[(jYa(Wa,1,B)|0)>>3];c[A>>2]=11;mb=+h[(jYa(Wa,1,A)|0)>>3];c[z>>2]=10;rb=+h[(jYa(Wa,1,z)|0)>>3]*-.000201611844951398+1.07202609066812e-11;c[y>>2]=3;sb=+h[(jYa(Wa,1,y)|0)>>3];c[x>>2]=5;tb=+h[(jYa(Wa,1,x)|0)>>3];c[w>>2]=6;ub=mb*(rb*sb*tb*$a*+h[(jYa(Wa,1,w)|0)>>3]+1.78371690710842e-23);c[v>>2]=5;tb=+h[(jYa(Wa,1,v)|0)>>3];c[u>>2]=7;sb=tb*+h[(jYa(Wa,1,u)|0)>>3]*-1.24017662339842e-24;c[t>>2]=16;tb=+h[(jYa(Wa,1,t)|0)>>3];c[s>>2]=5;rb=+h[(jYa(Wa,1,s)|0)>>3];c[r>>2]=7;mb=tb*rb*+h[(jYa(Wa,1,r)|0)>>3]*.000200482822351322;c[q>>2]=16;rb=+h[(jYa(Wa,1,q)|0)>>3];c[p>>2]=3;tb=+h[(jYa(Wa,1,p)|0)>>3];c[o>>2]=5;vb=rb*tb*+h[(jYa(Wa,1,o)|0)>>3]*-4.97975748452559e-14;c[n>>2]=6;tb=+h[(jYa(Wa,1,n)|0)>>3];c[m>>2]=7;rb=+h[(jYa(Wa,1,m)|0)>>3];c[l>>2]=12;wb=+h[(jYa(Wa,1,l)|0)>>3];c[k>>2]=3;xb=+h[(jYa(Wa,1,k)|0)>>3];c[j>>2]=7;h[a>>3]=d*(ab+_a*(cb+_a*(eb+_a*(fb+_a*($a*($a*144676118155521.0e-20+2.558143570457e-8)+_a*(bb+_a*(db+_a*(ib+_a*(jb+_a*(hb+_a*(lb+kb*gb*(ob+nb*(qb+pb*(ub+_a*(sb+_a*(mb+_a*(vb+tb*rb*_a*$a*(wb*(xb*+h[(jYa(Wa,1,j)|0)>>3]*-547344301999018.0e-19+2.21658861403112e-15)+1.90027787547159e-27)))))))))))))+-7.8847309559367e-10)+4.3870667284435e-7)+-33032641670203.0e-18)+-.017834862292358))*e*461.526;i=f;return}function FE(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0.0,Ca=0.0,Da=0,Ea=0,Fa=0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0.0,Ka=0.0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0;f=i;i=i+32|0;g=f;j=f+24|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+16|0;c[za>>2]=13;eYa(Aa,1,za);Ba=1386.0/e;Ca=7.1-d/1653.0e4;if(!(d>611.657)){za=RXa(RXa(26296,PXa(d,0,1,6)|0)|0,24408)|0;Da=RXa(RXa(za,PXa(611.657,0,1,6)|0)|0,24416)|0;za=c[72300]|0;Ea=g;Fa=26360;c[Ea+0>>2]=c[Fa+0>>2];c[Ea+4>>2]=c[Fa+4>>2];c[Ea+8>>2]=c[Fa+8>>2];c[Ea+12>>2]=c[Fa+12>>2];c[Ea+16>>2]=c[Fa+16>>2];c[Ea+20>>2]=c[Fa+20>>2];Pe[za&127](b,g,Da,ya);}d=Ba+-1.222;c[xa>>2]=1;h[(jYa(Aa,1,xa)|0)>>3]=d*d;c[wa>>2]=1;Ga=d*+h[(jYa(Aa,1,wa)|0)>>3];c[va>>2]=2;h[(jYa(Aa,1,va)|0)>>3]=Ga;c[ua>>2]=1;Ga=+h[(jYa(Aa,1,ua)|0)>>3];c[ta>>2]=3;h[(jYa(Aa,1,ta)|0)>>3]=Ga*Ga;c[sa>>2]=3;Ga=+h[(jYa(Aa,1,sa)|0)>>3];c[ra>>2]=4;h[(jYa(Aa,1,ra)|0)>>3]=Ga*Ga;c[qa>>2]=1;Ga=+h[(jYa(Aa,1,qa)|0)>>3];c[pa>>2]=4;Ha=Ga*+h[(jYa(Aa,1,pa)|0)>>3];c[oa>>2]=5;h[(jYa(Aa,1,oa)|0)>>3]=Ha;c[na>>2]=1;Ha=+h[(jYa(Aa,1,na)|0)>>3];c[ma>>2]=3;Ga=Ha*+h[(jYa(Aa,1,ma)|0)>>3];c[la>>2]=6;h[(jYa(Aa,1,la)|0)>>3]=Ga;c[ka>>2]=3;Ga=d*+h[(jYa(Aa,1,ka)|0)>>3];c[ja>>2]=7;h[(jYa(Aa,1,ja)|0)>>3]=Ga;c[ia>>2]=3;Ga=+h[(jYa(Aa,1,ia)|0)>>3];c[ha>>2]=4;Ha=Ga*+h[(jYa(Aa,1,ha)|0)>>3];c[ga>>2]=8;h[(jYa(Aa,1,ga)|0)>>3]=Ha;c[fa>>2]=9;h[(jYa(Aa,1,fa)|0)>>3]=Ca*Ca;c[ea>>2]=9;Ha=+h[(jYa(Aa,1,ea)|0)>>3];c[da>>2]=10;h[(jYa(Aa,1,da)|0)>>3]=Ha*Ha;c[ca>>2]=10;Ha=+h[(jYa(Aa,1,ca)|0)>>3];c[ba>>2]=11;h[(jYa(Aa,1,ba)|0)>>3]=Ha*Ha;c[aa>>2]=4;Ha=+h[(jYa(Aa,1,aa)|0)>>3];c[$>>2]=12;h[(jYa(Aa,1,$)|0)>>3]=Ha*Ha;c[_>>2]=12;Ha=+h[(jYa(Aa,1,_)|0)>>3];c[Z>>2]=13;h[(jYa(Aa,1,Z)|0)>>3]=Ha*Ha;c[Y>>2]=1;Ha=+h[(jYa(Aa,1,Y)|0)>>3];c[X>>2]=1;Ga=+h[(jYa(Aa,1,X)|0)>>3]*-.00015851507390979+-.021841717175414;c[W>>2]=1;Ia=Ga*+h[(jYa(Aa,1,W)|0)>>3]+.018990068218419;c[V>>2]=6;Ga=Ha*(Ia*+h[(jYa(Aa,1,V)|0)>>3]+.00424944110961118)+-.00254871721114236;c[U>>2]=5;Ia=Ga/+h[(jYa(Aa,1,U)|0)>>3];c[T>>2]=3;Ga=+h[(jYa(Aa,1,T)|0)>>3];c[S>>2]=1;Ha=+h[(jYa(Aa,1,S)|0)>>3];c[R>>2]=1;Ja=+h[(jYa(Aa,1,R)|0)>>3];c[Q>>2]=3;Ka=+h[(jYa(Aa,1,Q)|0)>>3];c[P>>2]=4;La=Ga*(Ha*(Ja*Ka*+h[(jYa(Aa,1,P)|0)>>3]*-1.2358149370591e-14+-132425535992538.0e-19)+47661393906987.0e-18)+.00141552963219801;c[O>>2]=3;Ka=La/+h[(jYa(Aa,1,O)|0)>>3];c[N>>2]=5;La=+h[(jYa(Aa,1,N)|0)>>3]*-5.11230768720618e-9+.000126718579380216;c[M>>2]=7;Ja=La/+h[(jYa(Aa,1,M)|0)>>3];c[L>>2]=2;La=+h[(jYa(Aa,1,L)|0)>>3];c[K>>2]=8;Ha=La*(+h[(jYa(Aa,1,K)|0)>>3]*-1.4341729937924e-12+130342445791202.0e-20)+11212640954.0e-15;c[J>>2]=6;La=Ha/+h[(jYa(Aa,1,J)|0)>>3];c[I>>2]=9;Ha=+h[(jYa(Aa,1,I)|0)>>3];c[H>>2]=7;Ga=+h[(jYa(Aa,1,H)|0)>>3]*1.04549227383804e-9+1.40077319158051e-8;c[G>>2]=8;Ma=Ga/+h[(jYa(Aa,1,G)|0)>>3];c[F>>2]=10;Ga=+h[(jYa(Aa,1,F)|0)>>3];c[E>>2]=11;Na=+h[(jYa(Aa,1,E)|0)>>3];c[D>>2]=4;Oa=+h[(jYa(Aa,1,D)|0)>>3];c[C>>2]=3;Pa=Oa*+h[(jYa(Aa,1,C)|0)>>3];c[B>>2]=12;Oa=Pa*+h[(jYa(Aa,1,B)|0)>>3];c[A>>2]=1;Pa=1.9941018075704e-17/(Oa*+h[(jYa(Aa,1,A)|0)>>3]);c[z>>2]=9;Oa=+h[(jYa(Aa,1,z)|0)>>3];c[y>>2]=10;Qa=+h[(jYa(Aa,1,y)|0)>>3];c[x>>2]=9;Ra=+h[(jYa(Aa,1,x)|0)>>3];c[w>>2]=4;Sa=+h[(jYa(Aa,1,w)|0)>>3];c[v>>2]=13;Ta=4.65957282962769e-22/(Sa*+h[(jYa(Aa,1,v)|0)>>3]);c[u>>2]=4;Sa=+h[(jYa(Aa,1,u)|0)>>3];c[t>>2]=13;Ua=Sa*+h[(jYa(Aa,1,t)|0)>>3];c[s>>2]=1;Sa=Ca/(Ua*+h[(jYa(Aa,1,s)|0)>>3])*3.83502057899078e-24;c[r>>2]=4;Ua=d*+h[(jYa(Aa,1,r)|0)>>3];c[q>>2]=13;Va=Ca*(Ta+Ca*(Sa+-7.2912378325616e-23/(Ua*+h[(jYa(Aa,1,q)|0)>>3])));c[p>>2]=3;Ua=d*+h[(jYa(Aa,1,p)|0)>>3];c[o>>2]=13;Sa=Ua*+h[(jYa(Aa,1,o)|0)>>3];c[n>>2]=1;Ua=Qa*Ra*(Va+-1.00075970318621e-21/(Sa*+h[(jYa(Aa,1,n)|0)>>3]));c[m>>2]=13;Sa=Ha*Ca*(Ma+Ga*Na*Ca*(Pa+Oa*(Ua+-4.48827542684151e-19/+h[(jYa(Aa,1,m)|0)>>3])));c[l>>2]=4;Ua=Ca*(Ia+Ca*(Ka+Ca*(Ja+Ca*(La+Ca*(324135974880936.0e-20/(d*+h[(jYa(Aa,1,l)|0)>>3])+Sa)))));c[k>>2]=1;Sa=d*((d*(d*(d*(d*.0040607314991784+-.066465668798004)+.47316115539684)+-1.91583926775744)+3.3855169168385)*+h[(jYa(Aa,1,k)|0)>>3]+.84548187169114)+-.29265942426334;c[j>>2]=2;h[a>>3]=Ba*(Sa/+h[(jYa(Aa,1,j)|0)>>3]+Ua)*e*461.526;i=f;return}function GE(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0.0,f=0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0;b=i;do{if(c>765.0){e=765.0;f=4}else{g=c<110.0?110.0:c;if(!(g<390.0)){e=g;f=4;break}j=g*.809344262+554.3557377;k=g}}while(0);if((f|0)==4){j=e*-.632948717+1116.85;k=e}e=k+-322.0;c=e*e;if(k<322.0){l=c/1.0e6}else{l=c/144.0e4}c=(1.0-l)*647.096;if(c>d){m=c}else{m=j<d?j:d}h[a>>3]=k;h[a+8>>3]=m;i=b;return}function HE(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=+g;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0;j=i;i=i+144|0;k=j;l=j+24|0;m=j+112|0;n=j+136|0;o=i;i=i+8|0;p=i;i=i+88|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+88|0;y=i;i=i+48|0;z=i;i=i+16|0;do{if(d<22064.0e3){IE(q,b,d);if(+h[q>>3]+10.0>e){A=6;break}JE(r,b,d);if(+h[r>>3]+-10.0<e){A=7;break}B=c[72300]|0;C=m;D=26384;c[C+0>>2]=c[D+0>>2];c[C+4>>2]=c[D+4>>2];c[C+8>>2]=c[D+8>>2];c[C+12>>2]=c[D+12>>2];c[C+16>>2]=c[D+16>>2];c[C+20>>2]=c[D+20>>2];Pe[B&127](b,m,26408,o);A=7}else{yE(s,0,d);if(+h[s>>3]>e){A=6}else{A=7}}}while(0);if((A|0)==6){tE(t,0,d,e);E=+h[t>>3];BE(v,0,d,e);F=+h[v>>3];G=E}else if((A|0)==7){sE(u,0,d,e);E=+h[u>>3];AE(w,0,d,e);F=+h[w>>3];G=E}w=x;u=x+8|0;A=x+16|0;v=x+24|0;t=x+32|0;s=x+40|0;o=x+48|0;m=x+56|0;r=x+64|0;q=x+72|0;B=x+80|0;D=p;C=p+8|0;H=p+16|0;I=p+24|0;J=p+32|0;K=p+40|0;L=p+48|0;M=p+56|0;N=p+64|0;O=p+72|0;P=p+80|0;Q=y;R=y+8|0;S=y+16|0;T=y+24|0;V=y+32|0;W=y+40|0;X=z;Y=z+8|0;E=G;G=1.0/F;Z=0;do{pE(x,b,G,E);F=+h[u>>3];_=+h[A>>3];$=+h[v>>3];aa=+h[t>>3];ba=+h[s>>3];ca=+h[o>>3];da=+h[m>>3];ea=+h[r>>3];fa=+h[q>>3];ga=+h[B>>3];h[D>>3]=+h[w>>3];h[C>>3]=F;h[H>>3]=_;h[I>>3]=$;h[J>>3]=aa;h[K>>3]=ba;h[L>>3]=ca;h[M>>3]=da;h[N>>3]=ea;h[O>>3]=fa;h[P>>3]=ga;ha=l+0|0;ia=p+0|0;ja=ha+88|0;do{c[ha>>2]=c[ia>>2];ha=ha+4|0;ia=ia+4|0}while((ha|0)<(ja|0));aE(y,0,l);ga=+h[S>>3];fa=+h[T>>3];ea=+h[V>>3];da=+h[W>>3];ca=+h[R>>3]-e;ba=+h[Q>>3]-d;do{if(!(+U(+(ca/e))<=g)){ka=1}else{if(!(+U(+(ba/d))<=f)){ka=1;break}ka=0}}while(0);aa=ga*da-fa*ea;Z=Z+1|0;GE(z,0,G-(ba*da-ca*fa)/aa,E-(ga*ca-ba*ea)/aa);G=+h[X>>3];E=+h[Y>>3];}while((Z|0)<50&ka);Z=ka&1;if(!ka){la=a;ma=la;h[ma>>3]=G;na=a;oa=na+8|0;pa=oa;h[pa>>3]=E;qa=a;ra=qa+16|0;sa=ra;c[sa>>2]=Z;i=j;return}ka=c[72300]|0;Y=k;X=26488;c[Y+0>>2]=c[X+0>>2];c[Y+4>>2]=c[X+4>>2];c[Y+8>>2]=c[X+8>>2];c[Y+12>>2]=c[X+12>>2];c[Y+16>>2]=c[X+16>>2];c[Y+20>>2]=c[X+20>>2];Pe[ka&127](b,k,26512,n);la=a;ma=la;h[ma>>3]=G;na=a;oa=na+8|0;pa=oa;h[pa>>3]=E;qa=a;ra=qa+16|0;sa=ra;c[sa>>2]=Z;i=j;return}function IE(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,h=0;e=i;i=i+208|0;f=e;g=e+104|0;CE(g,b,d);b=a;a=f+0|0;h=g+0|0;g=a+104|0;do{c[a>>2]=c[h>>2];a=a+4|0;h=h+4|0}while((a|0)<(g|0));NE(b,0,0.0,f);i=e;return}function JE(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,h=0;e=i;i=i+208|0;f=e;g=e+104|0;QE(g,b,d);b=a;a=f+0|0;h=g+0|0;g=a+104|0;do{c[a>>2]=c[h>>2];a=a+4|0;h=h+4|0}while((a|0)<(g|0));NE(b,0,0.0,f);i=e;return}function KE(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=+f;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;g=i;i=i+32|0;j=g;k=g+24|0;l=i;i=i+88|0;m=l+32|0;n=l+64|0;o=l+72|0;p=1500.0;q=0;do{qE(l,b,d,p);r=+h[m>>3];s=p*r*+h[n>>3]*461.526-e;t=+U(+(s/e))<f;p=p-s/(r*r*+h[o>>3]*-461.526);q=q+1|0;u=t^1;}while((q|0)<50&u);q=u&1;if(t){v=a;w=v;h[w>>3]=p;x=a;y=x+8|0;z=y;c[z>>2]=q;i=g;return}t=c[72300]|0;u=j;o=26568;c[u+0>>2]=c[o+0>>2];c[u+4>>2]=c[o+4>>2];c[u+8>>2]=c[o+8>>2];c[u+12>>2]=c[o+12>>2];c[u+16>>2]=c[o+16>>2];c[u+20>>2]=c[o+20>>2];Pe[t&127](b,j,26592,k);v=a;w=v;h[w>>3]=p;x=a;y=x+8|0;z=y;c[z>>2]=q;i=g;return}function LE(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+16|0;c[sa>>2]=11;eYa(ta,1,sa);ua=d/1653.0e4;va=7.1-ua;wa=1386.0/e+-1.222;c[ra>>2]=1;h[(jYa(ta,1,ra)|0)>>3]=wa*wa;c[qa>>2]=1;xa=+h[(jYa(ta,1,qa)|0)>>3];c[pa>>2]=2;h[(jYa(ta,1,pa)|0)>>3]=xa*xa;c[oa>>2]=2;xa=+h[(jYa(ta,1,oa)|0)>>3];c[na>>2]=3;h[(jYa(ta,1,na)|0)>>3]=xa*xa;c[ma>>2]=1;xa=+h[(jYa(ta,1,ma)|0)>>3];c[la>>2]=2;ya=xa*+h[(jYa(ta,1,la)|0)>>3];c[ka>>2]=4;h[(jYa(ta,1,ka)|0)>>3]=ya;c[ja>>2]=1;ya=wa*+h[(jYa(ta,1,ja)|0)>>3];c[ia>>2]=5;h[(jYa(ta,1,ia)|0)>>3]=ya;c[ha>>2]=2;ya=wa*+h[(jYa(ta,1,ha)|0)>>3];c[ga>>2]=6;h[(jYa(ta,1,ga)|0)>>3]=ya;c[fa>>2]=7;h[(jYa(ta,1,fa)|0)>>3]=va*va;c[ea>>2]=7;ya=+h[(jYa(ta,1,ea)|0)>>3];c[da>>2]=8;h[(jYa(ta,1,da)|0)>>3]=ya*ya;c[ca>>2]=8;ya=+h[(jYa(ta,1,ca)|0)>>3];c[ba>>2]=9;h[(jYa(ta,1,ba)|0)>>3]=ya*ya;c[aa>>2]=3;ya=+h[(jYa(ta,1,aa)|0)>>3];c[$>>2]=10;h[(jYa(ta,1,$)|0)>>3]=ya*ya;c[_>>2]=10;ya=+h[(jYa(ta,1,_)|0)>>3];c[Z>>2]=11;h[(jYa(ta,1,Z)|0)>>3]=ya*ya;c[Y>>2]=2;ya=+h[(jYa(ta,1,Y)|0)>>3];c[X>>2]=4;xa=ya*(+h[(jYa(ta,1,X)|0)>>3]*2.55615384360309e-9+84812393955936.0e-19)+95038934535162.0e-18;c[W>>2]=2;ya=xa/+h[(jYa(ta,1,W)|0)>>3];c[V>>2]=2;xa=+h[(jYa(ta,1,V)|0)>>3];c[U>>2]=3;za=xa*+h[(jYa(ta,1,U)|0)>>3]*5.7366919751696e-13+260684891582404.0e-20;c[T>>2]=5;xa=+h[(jYa(ta,1,T)|0)>>3]*za+89701127632.0e-16;c[S>>2]=6;za=xa/+h[(jYa(ta,1,S)|0)>>3];c[R>>2]=3;xa=202584984300585.0e-20/+h[(jYa(ta,1,R)|0)>>3];c[Q>>2]=7;Aa=+h[(jYa(ta,1,Q)|0)>>3];c[P>>2]=8;Ba=+h[(jYa(ta,1,P)|0)>>3];c[O>>2]=9;Ca=+h[(jYa(ta,1,O)|0)>>3];c[N>>2]=7;Da=+h[(jYa(ta,1,N)|0)>>3];c[M>>2]=7;Ea=+h[(jYa(ta,1,M)|0)>>3];c[L>>2]=8;Fa=+h[(jYa(ta,1,L)|0)>>3];c[K>>2]=11;Ga=+h[(jYa(ta,1,K)|0)>>3];c[J>>2]=3;Ha=va/(wa*Ga*+h[(jYa(ta,1,J)|0)>>3])*2.99318679335866e-24;c[I>>2]=11;Ga=+h[(jYa(ta,1,I)|0)>>3];c[H>>2]=3;Ia=va*(Ha+-5.65070932023524e-23/(Ga*+h[(jYa(ta,1,H)|0)>>3]));c[G>>2]=1;Ga=+h[(jYa(ta,1,G)|0)>>3];c[F>>2]=11;Ha=Ga*+h[(jYa(ta,1,F)|0)>>3];c[E>>2]=2;Ga=va*(Ia+3.5842867920213e-22/(wa*Ha*+h[(jYa(ta,1,E)|0)>>3]));c[D>>2]=1;Ha=+h[(jYa(ta,1,D)|0)>>3];c[C>>2]=11;Ia=Ha*+h[(jYa(ta,1,C)|0)>>3];c[B>>2]=2;Ha=Ea*Fa*(Ga+-7.63737668221055e-22/(Ia*+h[(jYa(ta,1,B)|0)>>3]));c[A>>2]=1;Ia=+h[(jYa(ta,1,A)|0)>>3];c[z>>2]=10;Ga=Ia*+h[(jYa(ta,1,z)|0)>>3];c[y>>2]=2;Ia=Ga*+h[(jYa(ta,1,y)|0)>>3];c[x>>2]=3;Ga=Da*(Ha+-3.33001080055983e-19/(wa*Ia*+h[(jYa(ta,1,x)|0)>>3]));c[w>>2]=10;Ia=+h[(jYa(ta,1,w)|0)>>3];c[v>>2]=2;Ha=Ia*+h[(jYa(ta,1,v)|0)>>3];c[u>>2]=3;Ia=Ba*Ca*va*(Ga+1.44400475720615e-17/(wa*Ha*+h[(jYa(ta,1,u)|0)>>3]));c[t>>2]=6;Ha=+h[(jYa(ta,1,t)|0)>>3]*1.39398969845072e-9+1.01874413933128e-8;c[s>>2]=1;Ga=+h[(jYa(ta,1,s)|0)>>3];c[r>>2]=3;Ca=va*(ya+va*(za+va*(xa+Aa*va*(Ia+Ha/(wa*Ga*+h[(jYa(ta,1,r)|0)>>3])))));c[q>>2]=5;Ga=+h[(jYa(ta,1,q)|0)>>3];c[p>>2]=1;Ha=+h[(jYa(ta,1,p)|0)>>3];c[o>>2]=1;Ia=+h[(jYa(ta,1,o)|0)>>3];c[n>>2]=2;Aa=+h[(jYa(ta,1,n)|0)>>3];c[m>>2]=3;xa=Ga*(wa*(Ha*(Ia*Aa*+h[(jYa(ta,1,m)|0)>>3]*1.45389992595188e-15+88283690661692.0e-19)+-95322787813974.0e-18)+.00060003561586052)+.00094368642146534;c[l>>2]=5;Aa=va*(Ca+xa/+h[(jYa(ta,1,l)|0)>>3]);c[k>>2]=1;xa=+h[(jYa(ta,1,k)|0)>>3];c[j>>2]=4;Ca=+h[(jYa(ta,1,j)|0)>>3];c[g>>2]=1;va=xa*(Ca*(wa*(wa*(+h[(jYa(ta,1,g)|0)>>3]*5283835796993.0e-17+.021841717175414)+.032529748770505)+.018990068218419)+.00060706301565874)+-.00028319080123804;c[f>>2]=3;h[a>>3]=d/(ua*(Aa+va/(wa*+h[(jYa(ta,1,f)|0)>>3]))*e*461.526);i=b;return}function ME(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,h=0;e=i;i=i+208|0;f=e;g=e+104|0;CE(g,b,d);b=a;a=f+0|0;h=g+0|0;g=a+104|0;do{c[a>>2]=c[h>>2];a=a+4|0;h=h+4|0}while((a|0)<(g|0));NE(b,0,0.0,f);i=e;return}function NE(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;h[a>>3]=+h[d+32>>3];i=i;return}function OE(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0;g=i;i=i+16|0;j=g;k=g+8|0;do{if((f|0)==0){if(d<16529200.0){if(e>1073.15){l=5;break}kE(j,b,d);l=+h[j>>3]<e?2:1;break}else{if(e<623.15){l=1;break}hE(k,b,d);l=+h[k>>3]>e?3:2;break}}else{l=f}}while(0);c[a>>2]=l;i=g;return}function PE(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0.0,B=0.0,C=0.0,D=0.0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;c[u>>2]=3;eYa(v,1,u);w=7.1-d/1653.0e4;if(!(d>611.657)){u=RXa(RXa(26648,PXa(d,0,1,6)|0)|0,24408)|0;x=RXa(RXa(u,PXa(611.657,0,1,6)|0)|0,24416)|0;u=c[72300]|0;y=f;z=26720;c[y+0>>2]=c[z+0>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];c[y+12>>2]=c[z+12>>2];c[y+16>>2]=c[z+16>>2];c[y+20>>2]=c[z+20>>2];Pe[u&127](b,f,x,t);}c[s>>2]=1;h[(jYa(v,1,s)|0)>>3]=w*w;c[r>>2]=1;d=+h[(jYa(v,1,r)|0)>>3];c[q>>2]=2;h[(jYa(v,1,q)|0)>>3]=d*d;c[p>>2]=2;d=+h[(jYa(v,1,p)|0)>>3];c[o>>2]=3;h[(jYa(v,1,o)|0)>>3]=d*d;c[n>>2]=1;d=+h[(jYa(v,1,n)|0)>>3];c[m>>2]=2;A=+h[(jYa(v,1,m)|0)>>3];c[l>>2]=3;B=+h[(jYa(v,1,l)|0)>>3];c[k>>2]=1;C=+h[(jYa(v,1,k)|0)>>3];c[j>>2]=1;D=+h[(jYa(v,1,j)|0)>>3];c[g>>2]=2;h[a>>3]=(w*(w*(w*(w*(w*(d*w*(A*B*w*(C*(D*(w*(w*(w*3.49930466305574e-24+-6.66749357417962e-23)+4.27026404402408e-22)+-9.19148577641497e-22)*+h[(jYa(v,1,g)|0)>>3]+-4.18568363667416e-19)+1.86779322717506e-17)+1.46754947271665e-8)+317834967400818.0e-20)+123617764767172.0e-19)+.000125338925082983)+.00143759406818289)+-.00141131225285294)+2.42896927729349)*639675.036;i=e;return}function QE(b,c,d){b=b|0;c=c|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0;e=i;i=i+216|0;f=e+8|0;g=e+16|0;j=e+24|0;k=e+112|0;l=e+120|0;m=e+208|0;n=e;o=+zd(+d,22063999.9999999);kE(f,c,o);p=+h[f>>3];uE(g,c,p);q=+h[g>>3];g=p>623.15;f=g&1;if(g){nE(k,0,o);r=+h[k>>3];pE(l,c,r,p);s=+h[l+16>>3];t=+h[l+24>>3];u=+h[l+32>>3];v=+h[l+40>>3];w=+h[l+48>>3];x=+h[l+56>>3];y=+h[l+64>>3];z=+h[l+72>>3];A=+h[l+80>>3];RE(m,0,o);B=r*t*(w-u*A)*461.526;C=p*t*(w*2.0+t*x)*461.526;D=0.0;E=0.0;F=r;G=+h[m>>3];H=s*(u*y-v);I=0.0;J=u*u*z*-461.526}else{vE(j,c,d,p);z=+h[j+24>>3];u=+h[j+32>>3];v=+h[j+48>>3];y=+h[j+56>>3];s=+h[j+80>>3];r=z*v;x=u*+h[j+64>>3];if(o<d){K=2087546.84511715}else{K=p*x*461.526}o=+h[j+16>>3]*(x- +h[j+40>>3]);x=u*u*+h[j+72>>3]*-461.526;B=-((v-u*s)/(p*z*y)*d);C=p*(v*v/y)*-461.526;D=(r-u*z*s)/d*461.526;E=p*z*z*y*+OYa(d,-2)*461.526;F=d/(p*r*461.526);G=K;H=o;I=x;J=0.0}j=b;a[j]=f;f=j+1|0;a[f+0|0]=a[n+0|0]|0;a[f+1|0]=a[n+1|0]|0;a[f+2|0]=a[n+2|0]|0;a[f+3|0]=a[n+3|0]|0;a[f+4|0]=a[n+4|0]|0;a[f+5|0]=a[n+5|0]|0;a[f+6|0]=a[n+6|0]|0;h[b+8>>3]=461.526;h[b+16>>3]=p;h[b+24>>3]=F;h[b+32>>3]=G;h[b+40>>3]=H;h[b+48>>3]=I;h[b+56>>3]=J;h[b+64>>3]=q;h[b+72>>3]=B;h[b+80>>3]=C;h[b+88>>3]=D;h[b+96>>3]=E;i=e;return}function RE(a,b,c){a=a|0;b=b|0;c=+c;var d=0.0;d=+_(+(c/22064.0e3));h[a>>3]=(d*(d*(d*(d*(d*(d*(d*(d*.0006616936460057692+-16.98555442961553)+45.66489164833212)+-48.38215180269516)+25.08887602293532)+-6.084122698421623)+.2079670746250689)+.4880153718655694)+1.0)*2087546.84511715;i=i;return}function SE(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0.0,Hb=0,Ib=0,Jb=0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0.0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0.0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0.0,Zb=0.0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0.0,dc=0.0,ec=0.0,fc=0.0,gc=0.0,hc=0.0,ic=0.0,jc=0.0,kc=0.0,lc=0.0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+8|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;ob=i;i=i+8|0;pb=i;i=i+8|0;qb=i;i=i+8|0;rb=i;i=i+8|0;sb=i;i=i+8|0;tb=i;i=i+8|0;ub=i;i=i+8|0;vb=i;i=i+8|0;wb=i;i=i+8|0;xb=i;i=i+8|0;yb=i;i=i+8|0;zb=i;i=i+8|0;Ab=i;i=i+8|0;Bb=i;i=i+8|0;Cb=i;i=i+8|0;Db=i;i=i+8|0;Eb=i;i=i+8|0;Fb=i;i=i+16|0;c[Eb>>2]=18;eYa(Fb,1,Eb);Gb=d/1.0e6;if(!(d>611.657)){Eb=RXa(RXa(26744,PXa(d,0,1,6)|0)|0,24408)|0;Hb=RXa(RXa(Eb,PXa(611.657,0,1,6)|0)|0,24416)|0;Eb=c[72300]|0;Ib=f;Jb=26816;c[Ib+0>>2]=c[Jb+0>>2];c[Ib+4>>2]=c[Jb+4>>2];c[Ib+8>>2]=c[Jb+8>>2];c[Ib+12>>2]=c[Jb+12>>2];c[Ib+16>>2]=c[Jb+16>>2];c[Ib+20>>2]=c[Jb+20>>2];Pe[Eb&127](b,f,Hb,Db);}d=+V(+(Gb+-13.91883977887))*31.3220101646784+572.54459862746;Kb=540.0/d+-.5;c[Cb>>2]=1;h[(jYa(Fb,1,Cb)|0)>>3]=d*d;c[Bb>>2]=1;Lb=+h[(jYa(Fb,1,Bb)|0)>>3];c[Ab>>2]=2;h[(jYa(Fb,1,Ab)|0)>>3]=Lb*Lb;c[zb>>2]=2;Lb=+h[(jYa(Fb,1,zb)|0)>>3];c[yb>>2]=3;h[(jYa(Fb,1,yb)|0)>>3]=Lb*Lb;c[xb>>2]=4;h[(jYa(Fb,1,xb)|0)>>3]=Gb*Gb;c[wb>>2]=4;Lb=+h[(jYa(Fb,1,wb)|0)>>3];c[vb>>2]=5;h[(jYa(Fb,1,vb)|0)>>3]=Lb*Lb;c[ub>>2]=6;h[(jYa(Fb,1,ub)|0)>>3]=Kb*Kb;c[tb>>2]=6;Lb=+h[(jYa(Fb,1,tb)|0)>>3];c[sb>>2]=7;h[(jYa(Fb,1,sb)|0)>>3]=Lb*Lb;c[rb>>2]=6;Lb=+h[(jYa(Fb,1,rb)|0)>>3];c[qb>>2]=7;Mb=Lb*+h[(jYa(Fb,1,qb)|0)>>3];c[pb>>2]=8;h[(jYa(Fb,1,pb)|0)>>3]=Mb;c[ob>>2]=5;Mb=+h[(jYa(Fb,1,ob)|0)>>3];c[nb>>2]=9;h[(jYa(Fb,1,nb)|0)>>3]=Mb*Mb;c[mb>>2]=7;Mb=+h[(jYa(Fb,1,mb)|0)>>3];c[lb>>2]=10;h[(jYa(Fb,1,lb)|0)>>3]=Mb*Mb;c[kb>>2]=9;Mb=+h[(jYa(Fb,1,kb)|0)>>3];c[jb>>2]=11;h[(jYa(Fb,1,jb)|0)>>3]=Mb*Mb;c[ib>>2]=10;Mb=+h[(jYa(Fb,1,ib)|0)>>3];c[hb>>2]=12;h[(jYa(Fb,1,hb)|0)>>3]=Mb*Mb;c[gb>>2]=12;Mb=+h[(jYa(Fb,1,gb)|0)>>3];c[fb>>2]=13;h[(jYa(Fb,1,fb)|0)>>3]=Mb*Mb;c[eb>>2]=7;Mb=Kb*+h[(jYa(Fb,1,eb)|0)>>3];c[db>>2]=14;h[(jYa(Fb,1,db)|0)>>3]=Mb;c[cb>>2]=6;Mb=Kb*+h[(jYa(Fb,1,cb)|0)>>3];c[bb>>2]=15;h[(jYa(Fb,1,bb)|0)>>3]=Mb;c[ab>>2]=10;Mb=+h[(jYa(Fb,1,ab)|0)>>3];c[$a>>2]=6;Lb=Mb*+h[(jYa(Fb,1,$a)|0)>>3];c[_a>>2]=16;h[(jYa(Fb,1,_a)|0)>>3]=Lb;c[Za>>2]=13;Lb=+h[(jYa(Fb,1,Za)|0)>>3];c[Ya>>2]=6;Mb=Lb*+h[(jYa(Fb,1,Ya)|0)>>3];c[Xa>>2]=17;h[(jYa(Fb,1,Xa)|0)>>3]=Mb;c[Wa>>2]=13;Mb=+h[(jYa(Fb,1,Wa)|0)>>3];c[Va>>2]=6;Lb=Mb*Kb*+h[(jYa(Fb,1,Va)|0)>>3];c[Ua>>2]=18;h[(jYa(Fb,1,Ua)|0)>>3]=Lb;c[Ta>>2]=2;Lb=+h[(jYa(Fb,1,Ta)|0)>>3]*3.74686560065793;c[Sa>>2]=1;Mb=+h[(jYa(Fb,1,Sa)|0)>>3];c[Ra>>2]=2;Nb=Mb*+h[(jYa(Fb,1,Ra)|0)>>3]*357966647812489.0e-20;c[Qa>>2]=3;Mb=+h[(jYa(Fb,1,Qa)|0)>>3]*2.81881548488163e-13;c[Pa>>2]=2;Ob=d*+h[(jYa(Fb,1,Pa)|0)>>3]*-.00450789338787835;c[Oa>>2]=1;Pb=+h[(jYa(Fb,1,Oa)|0)>>3];c[Na>>2]=2;Qb=Pb*d*+h[(jYa(Fb,1,Na)|0)>>3]*-1.55131504410292e-9;c[Ma>>2]=1;Pb=+h[(jYa(Fb,1,Ma)|0)>>3];c[La>>2]=10;Rb=+h[(jYa(Fb,1,La)|0)>>3];c[Ka>>2]=11;Sb=+h[(jYa(Fb,1,Ka)|0)>>3];c[Ja>>2]=12;Tb=+h[(jYa(Fb,1,Ja)|0)>>3];c[Ia>>2]=13;Ub=+h[(jYa(Fb,1,Ia)|0)>>3];c[Ha>>2]=4;Vb=Rb*Sb*Tb*Ub*+h[(jYa(Fb,1,Ha)|0)>>3]*-4781981.98764471;c[Ga>>2]=11;Ub=+h[(jYa(Fb,1,Ga)|0)>>3];c[Fa>>2]=12;Tb=+h[(jYa(Fb,1,Fa)|0)>>3];c[Ea>>2]=13;Sb=+h[(jYa(Fb,1,Ea)|0)>>3];c[Da>>2]=4;Rb=+h[(jYa(Fb,1,Da)|0)>>3];c[Ca>>2]=5;Wb=+h[(jYa(Fb,1,Ca)|0)>>3];c[Ba>>2]=7;Xb=Ub*Tb*Sb*Rb*Wb*+h[(jYa(Fb,1,Ba)|0)>>3]*49.9651389369988;c[Aa>>2]=15;Wb=+h[(jYa(Fb,1,Aa)|0)>>3];c[za>>2]=4;Rb=+h[(jYa(Fb,1,za)|0)>>3];c[ya>>2]=16;Sb=+h[(jYa(Fb,1,ya)|0)>>3]*-.00349547959376899;c[xa>>2]=8;Tb=Sb+ +h[(jYa(Fb,1,xa)|0)>>3]*-2.55074501962569e-7+1.03746636552761e-13;c[wa>>2]=9;Sb=Wb*Rb*+h[(jYa(Fb,1,wa)|0)>>3]*Tb;c[va>>2]=10;Tb=+h[(jYa(Fb,1,va)|0)>>3];c[ua>>2]=12;Rb=Tb*+h[(jYa(Fb,1,ua)|0)>>3]*-242662.235426958;c[ta>>2]=16;Tb=Rb+ +h[(jYa(Fb,1,ta)|0)>>3]*-3.46022402653609;c[sa>>2]=4;Rb=+h[(jYa(Fb,1,sa)|0)>>3];c[ra>>2]=5;Wb=Tb*Rb*Gb*+h[(jYa(Fb,1,ra)|0)>>3];c[qa>>2]=4;Rb=+h[(jYa(Fb,1,qa)|0)>>3];c[pa>>2]=14;Tb=+h[(jYa(Fb,1,pa)|0)>>3]*-2248.08924686956;c[oa>>2]=17;Ub=+h[(jYa(Fb,1,oa)|0)>>3]*-354742.725841972;c[na>>2]=6;Yb=Rb*Gb*(Tb+(Ub+ +h[(jYa(Fb,1,na)|0)>>3]*-24.1331193696374)+.109336249381227);c[ma>>2]=11;Ub=+h[(jYa(Fb,1,ma)|0)>>3];c[la>>2]=12;Tb=+h[(jYa(Fb,1,la)|0)>>3];c[ka>>2]=5;Rb=+h[(jYa(Fb,1,ka)|0)>>3];c[ja>>2]=7;Zb=Ub*Tb*Rb*Gb*+h[(jYa(Fb,1,ja)|0)>>3]*-3.09081828396912e-19;c[ia>>2]=11;Rb=+h[(jYa(Fb,1,ia)|0)>>3];c[ha>>2]=13;Tb=+h[(jYa(Fb,1,ha)|0)>>3];c[ga>>2]=4;Ub=+h[(jYa(Fb,1,ga)|0)>>3];c[fa>>2]=5;_b=+h[(jYa(Fb,1,fa)|0)>>3];c[ea>>2]=6;$b=+h[(jYa(Fb,1,ea)|0)>>3];c[da>>2]=7;ac=Rb*Tb*Ub*_b*$b*Gb*+h[(jYa(Fb,1,da)|0)>>3]*-1.24107527851371e-8;c[ca>>2]=5;$b=+h[(jYa(Fb,1,ca)|0)>>3];c[ba>>2]=8;_b=$b*Gb*+h[(jYa(Fb,1,ba)|0)>>3]*3.99891272904219;c[aa>>2]=10;$b=+h[(jYa(Fb,1,aa)|0)>>3];c[$>>2]=7;Ub=+h[(jYa(Fb,1,$)|0)>>3];c[_>>2]=9;Tb=$b*Ub*Gb*+h[(jYa(Fb,1,_)|0)>>3]*.0641817365250892;c[Z>>2]=14;Ub=+h[(jYa(Fb,1,Z)|0)>>3]*-75253.6156722047;c[Y>>2]=6;$b=Gb*(Ub+(Kb*-22926.6247146068+ +h[(jYa(Fb,1,Y)|0)>>3]*-43051.9020511789)+-4444.87643334512);c[X>>2]=4;Ub=+h[(jYa(Fb,1,X)|0)>>3];c[W>>2]=15;Gb=+h[(jYa(Fb,1,W)|0)>>3]*-3927.0508365636;c[U>>2]=18;Rb=+h[(jYa(Fb,1,U)|0)>>3]*-239.325789467604;c[T>>2]=8;bc=Ub*(Gb+(Rb+(Kb*-94.4508644545118+ +h[(jYa(Fb,1,T)|0)>>3]*-76407.3727417716))+-8.23252840892034);c[S>>2]=5;Rb=(Kb+-.0161221195808321)*(Kb+.0338039844460968)*+h[(jYa(Fb,1,S)|0)>>3]*.360567666582363;c[R>>2]=11;Gb=+h[(jYa(Fb,1,R)|0)>>3];c[Q>>2]=10;Ub=+h[(jYa(Fb,1,Q)|0)>>3];c[P>>2]=12;cc=+h[(jYa(Fb,1,P)|0)>>3];c[O>>2]=7;dc=Ub*cc*+h[(jYa(Fb,1,O)|0)>>3]*-.000584580992538624;c[N>>2]=12;cc=+h[(jYa(Fb,1,N)|0)>>3];c[M>>2]=13;Ub=Gb*(dc+cc*Kb*+h[(jYa(Fb,1,M)|0)>>3]*1332480.30241755);c[L>>2]=9;cc=+h[(jYa(Fb,1,L)|0)>>3];c[K>>2]=18;dc=+h[(jYa(Fb,1,K)|0)>>3]*-73850273.6990986;c[J>>2]=6;Gb=+h[(jYa(Fb,1,J)|0)>>3];c[I>>2]=7;ec=cc*(dc+Gb*Kb*+h[(jYa(Fb,1,I)|0)>>3]*224425477627799.0e-19);c[H>>2]=4;Gb=+h[(jYa(Fb,1,H)|0)>>3];c[G>>2]=5;dc=+h[(jYa(Fb,1,G)|0)>>3];c[F>>2]=17;cc=+h[(jYa(Fb,1,F)|0)>>3]*-208438767.026518;c[E>>2]=6;fc=+h[(jYa(Fb,1,E)|0)>>3]*-124971648677697.0e-19;c[D>>2]=10;gc=+h[(jYa(Fb,1,D)|0)>>3];c[C>>2]=6;hc=+h[(jYa(Fb,1,C)|0)>>3];c[B>>2]=7;ic=Gb*dc*(cc+(fc+gc*hc*Kb*+h[(jYa(Fb,1,B)|0)>>3]*-8442.30378348203));c[A>>2]=11;hc=+h[(jYa(Fb,1,A)|0)>>3];c[z>>2]=9;gc=+h[(jYa(Fb,1,z)|0)>>3];c[y>>2]=10;fc=+h[(jYa(Fb,1,y)|0)>>3];c[x>>2]=12;cc=fc*Kb*+h[(jYa(Fb,1,x)|0)>>3]*4.73594929247646e-22;c[w>>2]=10;fc=+h[(jYa(Fb,1,w)|0)>>3];c[v>>2]=12;dc=+h[(jYa(Fb,1,v)|0)>>3];c[u>>2]=13;Gb=fc*dc*Kb*+h[(jYa(Fb,1,u)|0)>>3]*-13.6411358215175;c[t>>2]=13;dc=+h[(jYa(Fb,1,t)|0)>>3];c[s>>2]=6;fc=+h[(jYa(Fb,1,s)|0)>>3];c[r>>2]=7;jc=gc*(cc+(Gb+dc*fc*Kb*+h[(jYa(Fb,1,r)|0)>>3]*5.52427169406836e-10));c[q>>2]=5;fc=+h[(jYa(Fb,1,q)|0)>>3];c[p>>2]=17;dc=+h[(jYa(Fb,1,p)|0)>>3]*267174673301715.0e-20;c[o>>2]=12;Gb=+h[(jYa(Fb,1,o)|0)>>3];c[n>>2]=6;cc=Gb*Kb*+h[(jYa(Fb,1,n)|0)>>3]*4.44545133805865e-18;c[m>>2]=10;Gb=+h[(jYa(Fb,1,m)|0)>>3];c[l>>2]=13;gc=+h[(jYa(Fb,1,l)|0)>>3];c[k>>2]=6;kc=+h[(jYa(Fb,1,k)|0)>>3];c[j>>2]=7;lc=Lb+(Nb+(Mb+(d*-76465233.2452145+(Ob+(Qb+Pb*(Vb+(Xb+(Sb+(Wb+(Yb+(Zb+(ac+(_b+(Tb+($b+(bc+(Rb+(Ub+(ec+(ic+hc*(jc+fc*(dc+(cc+Gb*gc*kc*Kb*+h[(jYa(Fb,1,j)|0)>>3]*-50.2465185106411)))))))))))))))))+2513837.07870341))))))+4636975733.03507;c[g>>2]=1;h[a>>3]=lc/+h[(jYa(Fb,1,g)|0)>>3];i=e;return}function TE(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0.0,B=0.0,C=0.0,D=0.0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;c[u>>2]=3;eYa(v,1,u);w=7.1-d/1653.0e4;if(!(d>611.657)){u=RXa(RXa(26840,PXa(d,0,1,6)|0)|0,24408)|0;x=RXa(RXa(u,PXa(611.657,0,1,6)|0)|0,24416)|0;u=c[72300]|0;y=f;z=26912;c[y+0>>2]=c[z+0>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];c[y+12>>2]=c[z+12>>2];c[y+16>>2]=c[z+16>>2];c[y+20>>2]=c[z+20>>2];Pe[u&127](b,f,x,t);}c[s>>2]=1;h[(jYa(v,1,s)|0)>>3]=w*w;c[r>>2]=1;d=+h[(jYa(v,1,r)|0)>>3];c[q>>2]=2;h[(jYa(v,1,q)|0)>>3]=d*d;c[p>>2]=2;d=+h[(jYa(v,1,p)|0)>>3];c[o>>2]=3;h[(jYa(v,1,o)|0)>>3]=d*d;c[n>>2]=1;d=+h[(jYa(v,1,n)|0)>>3];c[m>>2]=2;A=+h[(jYa(v,1,m)|0)>>3];c[l>>2]=3;B=+h[(jYa(v,1,l)|0)>>3];c[k>>2]=1;C=+h[(jYa(v,1,k)|0)>>3];c[j>>2]=1;D=+h[(jYa(v,1,j)|0)>>3];c[g>>2]=2;h[a>>3]=(w*(w*(w*(w*(w*(d*w*(A*B*w*(C*(D*(w*(w*(w*9.64504638626269e-49+-7.06381628462585e-47)+1.73894459122923e-45)+-1.43870236842915e-44)*+h[(jYa(v,1,g)|0)>>3]+-8.12140581014818e-38)+5.35429206228374e-35)+8.43755552264362e-14)+1.73545618580828e-11)+-2.41630417490008e-7)+-418695814670391.0e-20)+-.00017146768241932)+-.022914084306349)+.173379420894777)*639675.036;i=e;return}function UE(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+24|0;j=d/1.0e6;if(d>611.657){k=j*3.36540214679088e-7;l=k+-203245575263501.0e-19;m=j*l;n=m+-.00979043490246092;o=j*n;p=o+9.01505286876203;q=p*461526.0;r=a;s=r;h[s>>3]=q;i=e;return}t=RXa(RXa(26936,PXa(d,0,1,6)|0)|0,24408)|0;u=RXa(RXa(t,PXa(611.657,0,1,6)|0)|0,24416)|0;t=c[72300]|0;v=f;w=27008;c[v+0>>2]=c[w+0>>2];c[v+4>>2]=c[w+4>>2];c[v+8>>2]=c[w+8>>2];c[v+12>>2]=c[w+12>>2];c[v+16>>2]=c[w+16>>2];c[v+20>>2]=c[w+20>>2];Pe[t&127](b,f,u,g);k=j*3.36540214679088e-7;l=k+-203245575263501.0e-19;m=j*l;n=m+-.00979043490246092;o=j*n;p=o+9.01505286876203;q=p*461526.0;r=a;s=r;h[s>>3]=q;i=e;return}function VE(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+24|0;j=d/1.0e6;if(d>611.657){k=j*7.5006972718273e-8;l=k+-5.01510211858761e-8;m=j*l;n=m+-.000489898813722568;o=j*n;p=o+15.9838891400332;q=p*461526.0;r=a;s=r;h[s>>3]=q;i=e;return}t=RXa(RXa(27032,PXa(d,0,1,6)|0)|0,24408)|0;u=RXa(RXa(t,PXa(611.657,0,1,6)|0)|0,24416)|0;t=c[72300]|0;v=f;w=27104;c[v+0>>2]=c[w+0>>2];c[v+4>>2]=c[w+4>>2];c[v+8>>2]=c[w+8>>2];c[v+12>>2]=c[w+12>>2];c[v+16>>2]=c[w+16>>2];c[v+20>>2]=c[w+20>>2];Pe[t&127](b,f,u,g);k=j*7.5006972718273e-8;l=k+-5.01510211858761e-8;m=j*l;n=m+-.000489898813722568;o=j*n;p=o+15.9838891400332;q=p*461526.0;r=a;s=r;h[s>>3]=q;i=e;return}function WE(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0,u=0,v=0.0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+16|0;c[p>>2]=2;eYa(q,1,p);r=d/1.0e6;if(!(d>611.657)){p=RXa(RXa(27128,PXa(d,0,1,6)|0)|0,24408)|0;s=RXa(RXa(p,PXa(611.657,0,1,6)|0)|0,24416)|0;p=c[72300]|0;t=f;u=27200;c[t+0>>2]=c[u+0>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];c[t+12>>2]=c[u+12>>2];c[t+16>>2]=c[u+16>>2];c[t+20>>2]=c[u+20>>2];Pe[p&127](b,f,s,o);}c[n>>2]=1;h[(jYa(q,1,n)|0)>>3]=r*r;c[m>>2]=1;d=+h[(jYa(q,1,m)|0)>>3];c[l>>2]=2;h[(jYa(q,1,l)|0)>>3]=d*d*d;c[k>>2]=1;d=+h[(jYa(q,1,k)|0)>>3];c[j>>2]=1;v=d*((r*(r*(r*(r*1.88543121025106e-84+-1.76117969553159e-103)+8.06630589170884e-129)+-3.71600586812966e-69)+1.6746290980312e-65)*+h[(jYa(q,1,j)|0)>>3]+-8.00969737237617e-134)+-7.5656940729795e-74;c[g>>2]=2;h[a>>3]=r*(r*(r*(r*(r*(r*(r*(r*(r*(r*(+h[(jYa(q,1,g)|0)>>3]*v+3.37267475986401e-21)+7.16825117265975e-32)+7.56960433802525e-23)+-3.79407294691742e-25)+-1.27295130636232e-10)+4.2261295097284e-15)+-.000172486052272327)+.109090430596056)+-8.53409968320258)+-4518.48617188327)+4160663.37647071;i=e;return}function XE(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0;g=i;i=i+32|0;j=g;k=g+24|0;l=i;i=i+8|0;m=i;i=i+88|0;n=i;i=i+88|0;o=i;i=i+16|0;p=i;i=i+88|0;q=i;i=i+88|0;if((f|0)==0){OE(l,b,d,e,0);r=c[l>>2]|0}else{r=f}if((r|0)==3){fE(o,b,d,e,1.0e-7);s=+h[o>>3];pE(p,b,s,e);t=+h[p+24>>3];u=+h[p+32>>3];v=+h[p+48>>3];w=u*+h[p+64>>3];x=s*t*(v-u*+h[p+80>>3])*461.526;y=x;z=t*(v*2.0+t*+h[p+56>>3])*e*461.526;A=0.0;B=0.0;C=0.0;D=x;E=(t*v+w)*e*461.526;F=0.0;G=u*u*+h[p+72>>3]*-461.526;H=s;I=(w- +h[p+40>>3])*461.526}else if((r|0)==2){vE(n,b,d,e);w=+h[n+24>>3];s=+h[n+32>>3];u=+h[n+48>>3];v=+h[n+56>>3];t=+h[n+72>>3];x=+h[n+80>>3];J=s*+h[n+64>>3];K=(J- +h[n+40>>3])*461.526;L=w*u;M=(L-s*w*x)/d*461.526;N=w*w*v*+OYa(d,-2)*e*461.526;w=s*s*t;t=u-s*x;y=0.0;z=0.0;A=M;B=N;C=1.0;D=-M/N;E=J*e*461.526;F=w*-461.526;G=(t*t/v-w)*461.526;H=d/(L*e*461.526);I=K}else if((r|0)==5){qE(q,b,d,e);K=+h[q+24>>3];L=+h[q+32>>3];w=+h[q+48>>3];v=+h[q+56>>3];t=+h[q+72>>3];J=+h[q+80>>3];N=L*+h[q+64>>3];M=(N- +h[q+40>>3])*461.526;x=K*w;s=(x-L*K*J)/d*461.526;u=K*K*v*+OYa(d,-2)*e*461.526;K=L*L*t;t=w-L*J;y=0.0;z=0.0;A=s;B=u;C=1.0;D=-s/u;E=N*e*461.526;F=K*-461.526;G=(t*t/v-K)*461.526;H=d/(x*e*461.526);I=M}else if((r|0)==1){rE(m,b,d,e);M=+h[m+24>>3];x=+h[m+32>>3];K=+h[m+48>>3];v=+h[m+56>>3];t=+h[m+72>>3];N=+h[m+80>>3];u=x*+h[m+64>>3];s=(u- +h[m+40>>3])*461.526;J=M*K;L=(J-x*M*N)/d*461.526;w=M*M*v*+OYa(d,-2)*e*461.526;M=x*x*t;t=K-x*N;y=0.0;z=0.0;A=L;B=w;C=0.0;D=-L/w;E=u*e*461.526;F=M*-461.526;G=(t*t/v-M)*461.526;H=d/(J*e*461.526);I=s}else{m=RXa(RXa(27528,PXa(d,0,1,6)|0)|0,27584)|0;q=RXa(RXa(m,PXa(e,0,1,6)|0)|0,27592)|0;m=c[72300]|0;n=j;p=27600;c[n+0>>2]=c[p+0>>2];c[n+4>>2]=c[p+4>>2];c[n+8>>2]=c[p+8>>2];c[n+12>>2]=c[p+12>>2];c[n+16>>2]=c[p+16>>2];c[n+20>>2]=c[p+20>>2];Pe[m&127](b,j,q,k);y=0.0;z=0.0;A=0.0;B=0.0;C=0.0;D=0.0;E=0.0;F=0.0;G=0.0;H=0.0;I=0.0}c[a>>2]=1;c[a+4>>2]=r;h[a+8>>3]=d;h[a+16>>3]=e;h[a+24>>3]=E;h[a+32>>3]=461.526;h[a+40>>3]=F;h[a+48>>3]=G;h[a+56>>3]=H;h[a+64>>3]=I;h[a+72>>3]=y;h[a+80>>3]=z;h[a+88>>3]=A;h[a+96>>3]=B;h[a+104>>3]=C;h[a+112>>3]=D;i=g;return}function YE(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0.0,j=0.0,k=0,l=0;b=i;if((c[f+4>>2]|0)==3){e=+h[f+56>>3];d=+h[f+72>>3];g=e*e;e=+h[f+80>>3];j=(g*e*+h[f+48>>3]+d*d*+h[f+16>>3])/(g*e);k=a;l=k;h[l>>3]=j;i=b;return}else{j=+h[f+40>>3];k=a;l=k;h[l>>3]=j;i=b;return}}function ZE(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0,A=0.0,B=0.0,C=0,D=0;j=i;i=i+104|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;o=j+32|0;p=j+40|0;q=j+48|0;r=j+56|0;s=j+64|0;t=j+72|0;u=j+80|0;v=j+88|0;w=j+96|0;do{if((g|0)==0){IE(k,b,d);x=+h[k>>3];JE(l,b,d);y=+h[l>>3];if((f|0)==2){z=4;break}TE(m,b,d);A=+h[m>>3];VE(n,b,d);B=+h[n>>3];WE(o,b,d);if(d<611.657|d>1.0e8|A>e){z=-1;break}C=d<1.0e7;if(C&B<e){z=-1;break}if(d>=1.0e7&+h[o>>3]<e){z=-1;break}D=e<2087546.84511715;if(!(d<16529200.0)){if(D){PE(v,b,d);if(+h[v>>3]>e){z=1;break}z=x>e|d>22064.0e3?3:4;break}else{SE(w,b,d);if(+h[w>>3]<e){z=2;break}z=y<e|d>22064.0e3?3:4;break}}if(D){if((f|0)==1){z=1;break}kE(p,b,d);FE(q,b,d,+h[p>>3]);z=+h[q>>3]>e?1:4;break}UE(r,b,d);if(!(+h[r>>3]<e)){if((f|0)==1){z=2;break}kE(t,b,d);EE(u,b,d,+h[t>>3]);z=+h[u>>3]<e?2:4;break}VE(s,b,d);if(C){if(+h[s>>3]>e){z=5;break}}z=-2}else{z=g}}while(0);c[a>>2]=z;i=j;return}function _E(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;h[a>>3]=+h[e+16>>3];i=i;return}function $E(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0;g=i;i=i+56|0;j=g;k=g+24|0;l=g+48|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;c[n>>2]=42;eYa(o,1,n);n=o;o=27224;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];p=e+-273.15;q=d/317.763;if(!(d>.004854575724778614)){o=RXa(RXa(27240,PXa(d,0,1,6)|0)|0,27320)|0;n=RXa(RXa(o,PXa(.004854575724778614,0,1,6)|0)|0,27328)|0;o=c[72300]|0;r=k;s=27480;c[r+0>>2]=c[s+0>>2];c[r+4>>2]=c[s+4>>2];c[r+8>>2]=c[s+8>>2];c[r+12>>2]=c[s+12>>2];c[r+16>>2]=c[s+16>>2];c[r+20>>2]=c[s+20>>2];Pe[o&127](b,k,n,m);}if(!(f<=5.0e8)){t=5}else{if(!(p>=0.0&p<=150.0)){t=5}}do{if((t|0)==5){if(f<=35.0e7){if(p>150.0&p<=600.0){break}}if(f<=3.0e8){if(p>600.0&p<=900.0){break}}m=RXa(RXa(27352,PXa(f,0,1,6)|0)|0,27464)|0;n=RXa(RXa(m,PXa(p,0,1,6)|0)|0,24120)|0;m=c[72300]|0;k=j;o=27504;c[k+0>>2]=c[o+0>>2];c[k+4>>2]=c[o+4>>2];c[k+8>>2]=c[o+8>>2];c[k+12>>2]=c[o+12>>2];c[k+16>>2]=c[o+16>>2];c[k+20>>2]=c[o+20>>2];Pe[m&127](b,j,n,l);}}while(0);p=q+-1.0;f=647.226/e;e=f+-1.0;d=+W(+f,-.5)/(f*(f*(f*-.202354+.579829)+.978197)+1.0);if((YD(1,1,6)|0)==0){u=0.0;v=q*u;w=+ca(+v);x=d*w;y=x*55071.0e-9;z=a;A=z;h[A>>3]=y;i=g;return}l=(YD(0,0,6)|0)==0;f=0.0;j=1;B=1.0;while(1){if((j|0)==1){C=B}else{C=e*B}if(l){D=f}else{b=j+ -1|0;E=f;t=0;F=1.0;while(1){if((t|0)==0){G=F}else{G=p*F}H=E+ +cYa(27224,b+(t*6|0)|0)*C*G;n=t+1|0;if((YD(n,0,6)|0)==0){D=H;break}else{E=H;t=n;F=G}}}t=j+1|0;if((YD(t,1,6)|0)==0){u=D;break}else{f=D;j=t;B=C}}v=q*u;w=+ca(+v);x=d*w;y=x*55071.0e-9;z=a;A=z;h[A>>3]=y;i=g;return}function aF(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;h[a>>3]=+h[e+24>>3];i=i;return}function bF(a,b,d,e,f,g,j){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=+g;j=+j;var k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0;b=i;d=+h[f+56>>3];if((c[f+4>>2]|0)==3){k=+h[f+72>>3];l=+h[f+80>>3];m=(k*e-d*l)*+OYa(d,-2)*(g/l);e=d*d*l*+h[f+48>>3]+k*k*+h[f+16>>3];n=m+e*+OYa(d,-2)*(j/l);o=a;p=o;h[p>>3]=n;i=b;return}else{n=+h[f+40>>3]*j+(1.0/d- +h[f+16>>3]*+h[f+88>>3])*g;o=a;p=o;h[p>>3]=n;i=b;return}}function cF(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0,g=0,j=0.0,k=0.0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;xE(e,b,c);j=+h[e>>3];do{if(c<623.15){LE(f,0,j,c);k=+h[f>>3]}else{if(!(c<647.096)){k=322.0;break}lE(g,0,j);k=+h[g>>3]}}while(0);h[a>>3]=k;i=d;return}function dF(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;h[a>>3]=+h[e+56>>3];i=i;return}function eF(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,h=0;e=i;i=i+208|0;f=e;g=e+104|0;QE(g,b,d);b=a;a=f+0|0;h=g+0|0;g=a+104|0;do{c[a>>2]=c[h>>2];a=a+4|0;h=h+4|0}while((a|0)<(g|0));NE(b,0,0.0,f);i=e;return}function fF(a,b,d,e,f,g,j){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=+g;j=+j;var k=0.0,l=0,m=0;b=i;if((c[f+4>>2]|0)==3){e=+h[f+80>>3];k=g/e- +h[f+72>>3]*(j/e);l=a;m=l;h[m>>3]=k;i=b;return}else{e=+h[f+56>>3];k=-(e*e*(+h[f+96>>3]*g+ +h[f+88>>3]*j));l=a;m=l;h[m>>3]=k;i=b;return}}function gF(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;h[a>>3]=+h[e+56>>3];i=i;return}function hF(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0,g=0,j=0.0,k=0.0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;xE(e,b,c);j=+h[e>>3];do{if(c<623.15){$D(f,0,j,c);k=+h[f>>3]}else{if(!(c<647.096)){k=322.0;break}nE(g,0,j);k=+h[g>>3]}}while(0);h[a>>3]=k;i=d;return}function _omc_Modelica_Media_Water_IF97__Utilities_BaseIF97_Basic_g2$0(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0.0,Ed=0.0,Fd=0.0,Gd=0,Hd=0.0,Id=0.0,Jd=0.0,Kd=0.0,Ld=0.0,Md=0.0,Nd=0.0,Od=0.0,Pd=0.0,Qd=0.0,Rd=0.0,Sd=0.0,Td=0.0,Ud=0.0,Vd=0.0,Wd=0.0,Xd=0.0,Yd=0.0,Zd=0.0,_d=0.0,$d=0.0,ae=0.0,be=0.0;b=c[a+136>>2]|0;d=c[a+144>>2]|0;e=+g[a+152>>2];f=+g[a+160>>2];j=+g[a+1512>>2];l=c[a+2688>>2]|0;m=c[a+2720>>2]|0;n=c[a+2728>>2]|0;o=c[a+2736>>2]|0;p=c[a+2752>>2]|0;q=c[a+2760>>2]|0;r=c[a+2768>>2]|0;s=c[a+2776>>2]|0;t=c[a+2784>>2]|0;u=c[a+2792>>2]|0;v=c[a+2800>>2]|0;w=c[a+2808>>2]|0;x=c[a+2816>>2]|0;y=c[a+2824>>2]|0;z=c[a+2840>>2]|0;A=c[a+2848>>2]|0;B=c[a+2856>>2]|0;C=c[a+2864>>2]|0;D=c[a+2872>>2]|0;E=c[a+2880>>2]|0;F=c[a+2888>>2]|0;G=c[a+2896>>2]|0;H=c[a+2904>>2]|0;I=c[a+2912>>2]|0;J=c[a+2928>>2]|0;K=c[a+2936>>2]|0;L=c[a+2944>>2]|0;M=c[a+2952>>2]|0;N=c[a+2960>>2]|0;O=c[a+2968>>2]|0;P=c[a+2976>>2]|0;Q=c[a+2984>>2]|0;R=c[a+2992>>2]|0;S=c[a+3e3>>2]|0;T=c[a+3016>>2]|0;U=c[a+3024>>2]|0;V=c[a+3032>>2]|0;W=c[a+3040>>2]|0;X=c[a+3048>>2]|0;Y=c[a+3056>>2]|0;Z=c[a+3064>>2]|0;_=c[a+3072>>2]|0;$=c[a+3080>>2]|0;aa=c[a+3088>>2]|0;ba=c[a+3104>>2]|0;ca=c[a+3112>>2]|0;ea=c[a+3120>>2]|0;fa=c[a+3128>>2]|0;ga=c[a+3136>>2]|0;ha=c[a+3144>>2]|0;ia=c[a+3152>>2]|0;ja=c[a+3160>>2]|0;ka=c[a+3168>>2]|0;la=c[a+3176>>2]|0;ma=c[a+3192>>2]|0;na=c[a+3200>>2]|0;oa=c[a+3208>>2]|0;pa=c[a+3216>>2]|0;qa=c[a+3224>>2]|0;ra=c[a+3232>>2]|0;sa=c[a+3240>>2]|0;ta=c[a+3248>>2]|0;ua=c[a+3256>>2]|0;va=c[a+3264>>2]|0;wa=c[a+3280>>2]|0;xa=c[a+3288>>2]|0;ya=c[a+3296>>2]|0;za=c[a+3304>>2]|0;Aa=c[a+3312>>2]|0;Ba=c[a+3320>>2]|0;Ca=c[a+3328>>2]|0;Da=c[a+3336>>2]|0;Ea=c[a+3344>>2]|0;Fa=c[a+3352>>2]|0;Ga=c[a+3368>>2]|0;Ha=c[a+3376>>2]|0;Ia=c[a+3392>>2]|0;Ja=c[a+3400>>2]|0;Ka=c[a+3408>>2]|0;La=c[a+3416>>2]|0;Ma=c[a+3424>>2]|0;Na=c[a+3432>>2]|0;Oa=c[a+3440>>2]|0;Pa=c[a+3448>>2]|0;Qa=c[a+3464>>2]|0;Ra=c[a+3472>>2]|0;Sa=c[a+3480>>2]|0;Ta=c[a+3488>>2]|0;Ua=c[a+3496>>2]|0;Va=c[a+3504>>2]|0;Wa=c[a+3512>>2]|0;Xa=c[a+3520>>2]|0;Ya=c[a+3528>>2]|0;Za=c[a+3536>>2]|0;_a=c[a+3552>>2]|0;$a=c[a+3560>>2]|0;ab=c[a+3568>>2]|0;bb=c[a+3576>>2]|0;cb=c[a+3584>>2]|0;db=c[a+3592>>2]|0;eb=c[a+3600>>2]|0;fb=c[a+3608>>2]|0;gb=c[a+3616>>2]|0;hb=c[a+3624>>2]|0;ib=c[a+3640>>2]|0;jb=c[a+3648>>2]|0;kb=c[a+3656>>2]|0;lb=c[a+3664>>2]|0;mb=c[a+3672>>2]|0;nb=c[a+3680>>2]|0;ob=c[a+3688>>2]|0;pb=c[a+3696>>2]|0;qb=c[a+3704>>2]|0;rb=c[a+4544>>2]|0;sb=c[a+4552>>2]|0;tb=c[a+4560>>2]|0;ub=c[a+4576>>2]|0;vb=c[a+4584>>2]|0;wb=c[a+4592>>2]|0;xb=c[a+4600>>2]|0;yb=c[a+4608>>2]|0;zb=c[a+4616>>2]|0;Ab=c[a+4624>>2]|0;Bb=c[a+4632>>2]|0;Cb=c[a+4640>>2]|0;Db=c[a+4648>>2]|0;Eb=c[a+4664>>2]|0;Fb=c[a+4672>>2]|0;Gb=c[a+4680>>2]|0;Hb=c[a+4688>>2]|0;Ib=c[a+4696>>2]|0;Jb=c[a+4704>>2]|0;Kb=c[a+4712>>2]|0;Lb=c[a+4720>>2]|0;Mb=c[a+4728>>2]|0;Nb=c[a+4736>>2]|0;Ob=c[a+4752>>2]|0;Pb=c[a+4760>>2]|0;Qb=c[a+4768>>2]|0;Rb=c[a+4776>>2]|0;Sb=c[a+4784>>2]|0;Tb=c[a+4792>>2]|0;Ub=c[a+4800>>2]|0;Vb=c[a+4808>>2]|0;Wb=c[a+4816>>2]|0;Xb=c[a+4824>>2]|0;Yb=c[a+4840>>2]|0;Zb=c[a+4848>>2]|0;_b=c[a+4856>>2]|0;$b=c[a+4864>>2]|0;ac=c[a+4872>>2]|0;bc=c[a+4880>>2]|0;cc=c[a+4888>>2]|0;dc=c[a+4896>>2]|0;ec=c[a+4904>>2]|0;fc=c[a+4912>>2]|0;gc=c[a+4928>>2]|0;hc=c[a+4936>>2]|0;ic=c[a+4952>>2]|0;jc=c[a+4960>>2]|0;kc=c[a+4968>>2]|0;lc=c[a+4976>>2]|0;mc=c[a+4984>>2]|0;nc=c[a+4992>>2]|0;oc=c[a+5e3>>2]|0;pc=c[a+5008>>2]|0;qc=c[a+5024>>2]|0;rc=c[a+5032>>2]|0;sc=c[a+5040>>2]|0;tc=c[a+5048>>2]|0;uc=c[a+5056>>2]|0;vc=c[a+5064>>2]|0;wc=c[a+5072>>2]|0;xc=c[a+5080>>2]|0;yc=c[a+5088>>2]|0;zc=c[a+5096>>2]|0;Ac=c[a+5112>>2]|0;Bc=c[a+5120>>2]|0;Cc=c[a+5128>>2]|0;Dc=c[a+5136>>2]|0;Ec=c[a+5144>>2]|0;Fc=c[a+5152>>2]|0;Gc=c[a+5160>>2]|0;Hc=c[a+5168>>2]|0;Ic=c[a+5176>>2]|0;Jc=c[a+5184>>2]|0;Kc=c[a+5200>>2]|0;Lc=c[a+5208>>2]|0;Mc=c[a+5216>>2]|0;Nc=c[a+5224>>2]|0;Oc=c[a+5232>>2]|0;Pc=c[a+5240>>2]|0;Qc=c[a+5248>>2]|0;Rc=c[a+5256>>2]|0;Sc=c[a+5264>>2]|0;Tc=c[a+5272>>2]|0;Uc=c[a+5288>>2]|0;Vc=c[a+5296>>2]|0;Wc=c[a+5304>>2]|0;Xc=c[a+5312>>2]|0;Yc=c[a+5320>>2]|0;Zc=c[a+5328>>2]|0;_c=c[a+5336>>2]|0;$c=c[a+5344>>2]|0;ad=c[a+5352>>2]|0;bd=c[a+5360>>2]|0;cd=c[a+5376>>2]|0;dd=c[a+5384>>2]|0;ed=c[a+5392>>2]|0;fd=c[a+5400>>2]|0;gd=c[a+5408>>2]|0;hd=c[a+5416>>2]|0;id=c[a+5424>>2]|0;jd=c[a+5432>>2]|0;kd=c[a+5440>>2]|0;ld=c[a+5448>>2]|0;md=c[a+5464>>2]|0;nd=c[a+5472>>2]|0;od=c[a+5480>>2]|0;pd=c[a+5488>>2]|0;qd=c[a+5496>>2]|0;rd=c[a+5504>>2]|0;sd=c[a+5512>>2]|0;td=c[a+5520>>2]|0;ud=c[a+5528>>2]|0;vd=c[a+5536>>2]|0;wd=c[a+5552>>2]|0;xd=c[a+5560>>2]|0;yd=c[a+5568>>2]|0;zd=c[a+5576>>2]|0;Ad=c[a+5584>>2]|0;Bd=c[a+5592>>2]|0;Cd=c[a+5600>>2]|0;a:do{Dd=+h[(jYa(l,1,rb)|0)>>3];c[sb>>2]=12;Ed=+h[(jYa(l,1,sb)|0)>>3];c[tb>>2]=25;Fd=Dd*Ed*+h[(jYa(l,1,tb)|0)>>3];c[ub>>2]=52;h[(jYa(l,1,ub)|0)>>3]=Fd;c[vb>>2]=10;Fd=+h[(jYa(l,1,vb)|0)>>3];c[wb>>2]=12;Ed=+h[(jYa(l,1,wb)|0)>>3];c[xb>>2]=25;Dd=Fd*Ed*+h[(jYa(l,1,xb)|0)>>3];c[yb>>2]=53;h[(jYa(l,1,yb)|0)>>3]=Dd;c[zb>>2]=1;Dd=+h[(jYa(l,1,zb)|0)>>3];c[Ab>>2]=10;Ed=+h[(jYa(l,1,Ab)|0)>>3];c[Bb>>2]=25;Fd=Dd*Ed*+h[(jYa(l,1,Bb)|0)>>3];c[Cb>>2]=54;h[(jYa(l,1,Cb)|0)>>3]=Fd;c[Db>>2]=11;Fd=+h[(jYa(l,1,Db)|0)>>3];c[Eb>>2]=12;Ed=Fd*j*+h[(jYa(l,1,Eb)|0)>>3];c[Fb>>2]=55;h[(jYa(l,1,Fb)|0)>>3]=Ed;if(!(e/1.0e6>0.0)){Gd=c[72300]|0;h[k>>3]=e/1.0e6;c[Gb>>2]=c[k>>2];c[Gb+4>>2]=c[k+4>>2];c[a+0>>2]=c[25752+0>>2];c[a+4>>2]=c[25752+4>>2];c[a+8>>2]=c[25752+8>>2];c[a+12>>2]=c[25752+12>>2];c[a+16>>2]=c[25752+16>>2];c[a+20>>2]=c[25752+20>>2];Pe[Gd&127](d,a,24816,Gb);}c[Hb>>2]=9;Ed=+h[(jYa(l,1,Hb)|0)>>3];c[Ib>>2]=1;Fd=+h[(jYa(l,1,Ib)|0)>>3];c[Jb>>2]=13;Dd=+h[(jYa(l,1,Jb)|0)>>3]*-26674547914087.0e-18+-.043797295650573;c[Kb>>2]=2;Hd=j*(j*(Fd*(Dd*+h[(jYa(l,1,Kb)|0)>>3]+-.0039392777243355)+-.00018948987516315)+-33032641670203.0e-18);c[Lb>>2]=1;Dd=+h[(jYa(l,1,Lb)|0)>>3];c[Mb>>2]=13;Fd=+h[(jYa(l,1,Mb)|0)>>3]*-.040668253562649+-.0015033924542148;c[Nb>>2]=2;Id=j*(Dd*(Fd*+h[(jYa(l,1,Nb)|0)>>3]+-3227767723857.0e-17)+4.3870667284435e-7);c[Ob>>2]=14;Fd=+h[(jYa(l,1,Ob)|0)>>3]*22922076337661.0e-19;c[Pb>>2]=15;Dd=+h[(jYa(l,1,Pb)|0)>>3];c[Qb>>2]=16;Jd=Dd*(+h[(jYa(l,1,Qb)|0)>>3]*-23.895741934104+-.0021171472321355)+-1.6714766451061e-11;c[Rb>>2]=2;Dd=+h[(jYa(l,1,Rb)|0)>>3]*Jd;c[Sb>>2]=17;Jd=+h[(jYa(l,1,Sb)|0)>>3];c[Tb>>2]=18;Kd=Jd*(+h[(jYa(l,1,Tb)|0)>>3]*-.038946842435739+-12621808899101.0e-19);c[Ub>>2]=11;Jd=+h[(jYa(l,1,Ub)|0)>>3];c[Vb>>2]=19;Ld=Jd*(+h[(jYa(l,1,Vb)|0)>>3]*-8.2311340897998+1.1256211360459e-11);c[Wb>>2]=15;Jd=+h[(jYa(l,1,Wb)|0)>>3]*1.9809712802088e-8;c[Xb>>2]=10;Md=+h[(jYa(l,1,Xb)|0)>>3];c[Yb>>2]=10;Nd=+h[(jYa(l,1,Yb)|0)>>3]*-1.0018179379511e-9+-1.0234747095929e-13;c[Zb>>2]=20;Od=Md*(Nd*+h[(jYa(l,1,Zb)|0)>>3]+1.0406965210174e-19);c[_b>>2]=23;Nd=+h[(jYa(l,1,_b)|0)>>3];c[$b>>2]=13;Md=+h[(jYa(l,1,$b)|0)>>3];c[ac>>2]=24;Pd=Md*(+h[(jYa(l,1,ac)|0)>>3]*.10693031879409+-8.0882908646985e-11);c[bc>>2]=21;Md=+h[(jYa(l,1,bc)|0)>>3];c[cc>>2]=26;Qd=+h[(jYa(l,1,cc)|0)>>3]*-.33662250574171;c[dc>>2]=21;Rd=+h[(jYa(l,1,dc)|0)>>3];c[ec>>2]=27;Sd=+h[(jYa(l,1,ec)|0)>>3];c[fc>>2]=15;Td=+h[(jYa(l,1,fc)|0)>>3]*-42002467698208.0e-19+3.0629316876232e-13;c[gc>>2]=28;Ud=Sd*(Td*+h[(jYa(l,1,gc)|0)>>3]+8.9185845355421e-25);c[hc>>2]=24;Td=+h[(jYa(l,1,hc)|0)>>3]*-5.9056029685639e-26;c[ic>>2]=29;Sd=+h[(jYa(l,1,ic)|0)>>3]*37826947613457.0e-19;c[jc>>2]=30;Vd=+h[(jYa(l,1,jc)|0)>>3]*-1.2768608934681e-15;c[kc>>2]=31;Wd=+h[(jYa(l,1,kc)|0)>>3];c[lc>>2]=18;Xd=+h[(jYa(l,1,lc)|0)>>3];c[mc>>2]=32;Yd=e/1.0e6*(Ed+e/1.0e6*(Hd+e/1.0e6*(Id+e/1.0e6*(j*(j*(j*4.8225372718507e-7+1.2790717852285e-8)+-7.8847309559367e-10)+e/1.0e6*(Fd+e/1.0e6*(Dd+e/1.0e6*(Kd+e/1.0e6*(Ld+e/1.0e6*(Jd+e/1.0e6*(Od+Nd*(Pd+Md*(Qd+Rd*(Ud+e/1.0e6*(Td+e/1.0e6*(Sd+e/1.0e6*(Vd+Wd*e/1.0e6*(Xd*(+h[(jYa(l,1,mc)|0)>>3]*-9.436970724121e-7+5.5414715350778e-17)+7.3087610595061e-29))))))))))+-5.905956432427e-18))))+2.0481737692309e-8))+-.0017731742473213);Xd=540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*.02126846353307+-.2840863260772)+10.08665568018)+ +da(+(e/1.0e6))+-9.692768600217)+-4.38395111945)+1.424081971444)+-.4071049823928)+.07145273881455)+-.00560879118302;c[nc>>2]=34;Wd=Xd/(540.0/f*+h[(jYa(l,1,nc)|0)>>3])+Yd;c[oc>>2]=9;Yd=+h[(jYa(l,1,oc)|0)>>3];c[pc>>2]=43;Xd=+h[(jYa(l,1,pc)|0)>>3];c[qc>>2]=1;Vd=+h[(jYa(l,1,qc)|0)>>3];c[rc>>2]=13;Sd=+h[(jYa(l,1,rc)|0)>>3]*-.122004760687947+-.0045101773626444;c[sc>>2]=2;Td=j*(Vd*(Sd*+h[(jYa(l,1,sc)|0)>>3]+-9683303171571.0e-17)+131612001853305.0e-20);c[tc>>2]=14;Sd=+h[(jYa(l,1,tc)|0)>>3]*114610381688305.0e-19;c[uc>>2]=15;Vd=+h[(jYa(l,1,uc)|0)>>3];c[vc>>2]=16;Ud=Vd*(+h[(jYa(l,1,vc)|0)>>3]*-143.374451604624+-.012702883392813)+-1.00288598706366e-10;c[wc>>2]=2;Vd=+h[(jYa(l,1,wc)|0)>>3]*Ud;c[xc>>2]=17;Ud=+h[(jYa(l,1,xc)|0)>>3];c[yc>>2]=18;Rd=Ud*(+h[(jYa(l,1,yc)|0)>>3]*-.272627897050173+-88352662293707.0e-19);c[zc>>2]=11;Ud=+h[(jYa(l,1,zc)|0)>>3];c[Ac>>2]=19;Qd=Ud*(+h[(jYa(l,1,Ac)|0)>>3]*-65.849072718398+9.0049690883672e-11);c[Bc>>2]=15;Ud=+h[(jYa(l,1,Bc)|0)>>3]*1.78287415218792e-7;c[Cc>>2]=10;Md=+h[(jYa(l,1,Cc)|0)>>3];c[Dc>>2]=10;Pd=+h[(jYa(l,1,Dc)|0)>>3]*-1.0018179379511e-8+-1.0234747095929e-12;c[Ec>>2]=20;Nd=Md*(Pd*+h[(jYa(l,1,Ec)|0)>>3]+1.0406965210174e-18);c[Fc>>2]=23;Pd=+h[(jYa(l,1,Fc)|0)>>3];c[Gc>>2]=13;Md=+h[(jYa(l,1,Gc)|0)>>3];c[Hc>>2]=24;Od=Md*(+h[(jYa(l,1,Hc)|0)>>3]*1.71088510070544+-1.29412653835176e-9);c[Ic>>2]=21;Md=+h[(jYa(l,1,Ic)|0)>>3];c[Jc>>2]=26;Jd=+h[(jYa(l,1,Jc)|0)>>3]*-6.0592051033508;c[Kc>>2]=21;Ld=+h[(jYa(l,1,Kc)|0)>>3];c[Lc>>2]=27;Kd=+h[(jYa(l,1,Lc)|0)>>3];c[Mc>>2]=15;Dd=+h[(jYa(l,1,Mc)|0)>>3]*-84004935396416.0e-18+6.1258633752464e-12;c[Nc>>2]=28;Fd=Kd*(Dd*+h[(jYa(l,1,Nc)|0)>>3]+1.78371690710842e-23);c[Oc>>2]=24;Dd=+h[(jYa(l,1,Oc)|0)>>3]*-1.24017662339842e-24;c[Pc>>2]=29;Kd=+h[(jYa(l,1,Pc)|0)>>3]*83219284749605.0e-18;c[Qc>>2]=30;Id=+h[(jYa(l,1,Qc)|0)>>3]*-2.93678005497663e-14;c[Rc>>2]=31;Hd=+h[(jYa(l,1,Rc)|0)>>3];c[Sc>>2]=18;Ed=+h[(jYa(l,1,Sc)|0)>>3];c[Tc>>2]=32;Zd=(e/1.0e6*(Yd+e/1.0e6*(Xd+e/1.0e6*(Td+e/1.0e6*(j*(j*(j*192901490874028.0e-20+5.116287140914e-8)+-3.15389238237468e-9)+e/1.0e6*(Sd+e/1.0e6*(Vd+e/1.0e6*(Rd+e/1.0e6*(Qd+e/1.0e6*(Ud+e/1.0e6*(Nd+Pd*(Od+Md*(Jd+Ld*(Fd+e/1.0e6*(Dd+e/1.0e6*(Kd+e/1.0e6*(Id+Hd*e/1.0e6*(Ed*(+h[(jYa(l,1,Tc)|0)>>3]*-226487297378904.0e-19+1.32995316841867e-15)+1.75410265428146e-27))))))))))+-4.1341695026989e-17))))+6.1445213076927e-8))+-.0017731742473213)+1.0)/(e/1.0e6);c[Uc>>2]=21;Ed=+h[(jYa(l,1,Uc)|0)>>3];c[Vc>>2]=43;Hd=+h[(jYa(l,1,Vc)|0)>>3];c[Wc>>2]=1;Id=+h[(jYa(l,1,Wc)|0)>>3];c[Xc>>2]=13;Kd=+h[(jYa(l,1,Xc)|0)>>3]*-.244009521375894+-.0090203547252888;c[Yc>>2]=2;Dd=j*(Id*(Kd*+h[(jYa(l,1,Yc)|0)>>3]+-.00019366606343142)+26322400370661.0e-19);c[Zc>>2]=14;Kd=+h[(jYa(l,1,Zc)|0)>>3]*45844152675322.0e-18;c[_c>>2]=15;Id=+h[(jYa(l,1,_c)|0)>>3];c[$c>>2]=16;Fd=Id*(+h[(jYa(l,1,$c)|0)>>3]*-716.87225802312+-.063514416964065)+-5.0144299353183e-10;c[ad>>2]=2;Id=+h[(jYa(l,1,ad)|0)>>3]*Fd;c[bd>>2]=17;Fd=+h[(jYa(l,1,bd)|0)>>3];c[cd>>2]=18;Ld=Fd*(+h[(jYa(l,1,cd)|0)>>3]*-1.63576738230104+-53011597376224.0e-18);c[dd>>2]=11;Fd=+h[(jYa(l,1,dd)|0)>>3];c[ed>>2]=19;Jd=Fd*(+h[(jYa(l,1,ed)|0)>>3]*-460.94350902879+6.303478361857e-10);c[fd>>2]=15;Fd=+h[(jYa(l,1,fd)|0)>>3]*142629932175034.0e-20;c[gd>>2]=10;Md=+h[(jYa(l,1,gd)|0)>>3];c[hd>>2]=10;Od=+h[(jYa(l,1,hd)|0)>>3]*-9.0163614415599e-8+-9.2112723863361e-12;c[id>>2]=20;Pd=Md*(Od*+h[(jYa(l,1,id)|0)>>3]+9.3662686891566e-18);c[jd>>2]=23;Od=+h[(jYa(l,1,jd)|0)>>3];c[kd>>2]=13;Md=+h[(jYa(l,1,kd)|0)>>3];c[ld>>2]=24;Nd=Md*(+h[(jYa(l,1,ld)|0)>>3]*25.6632765105816+-1.94118980752764e-8);c[md>>2]=21;Md=+h[(jYa(l,1,md)|0)>>3];c[nd>>2]=26;Ud=+h[(jYa(l,1,nd)|0)>>3]*-103.006486756963;c[od>>2]=21;Qd=+h[(jYa(l,1,od)|0)>>3];c[pd>>2]=27;Rd=+h[(jYa(l,1,pd)|0)>>3];c[qd>>2]=15;Vd=+h[(jYa(l,1,qd)|0)>>3]*-.0015960937725319+1.16391404129682e-10;c[rd>>2]=28;Sd=Rd*(Vd*+h[(jYa(l,1,rd)|0)>>3]+3.389062123506e-22);c[sd>>2]=24;Vd=+h[(jYa(l,1,sd)|0)>>3]*-2.48035324679684e-23;c[td>>2]=29;Rd=+h[(jYa(l,1,td)|0)>>3]*.00174760497974171;c[ud>>2]=30;Td=+h[(jYa(l,1,ud)|0)>>3]*-6.4609161209486e-13;c[vd>>2]=31;Xd=+h[(jYa(l,1,vd)|0)>>3];c[wd>>2]=18;Yd=+h[(jYa(l,1,wd)|0)>>3];c[xd>>2]=32;_d=e/1.0e6*(Kd+e/1.0e6*(Id+e/1.0e6*(Ld+e/1.0e6*(Jd+e/1.0e6*(Fd+e/1.0e6*(Pd+Od*(Nd+Md*(Ud+Qd*(Sd+e/1.0e6*(Vd+e/1.0e6*(Rd+e/1.0e6*(Td+Xd*e/1.0e6*(Yd*(+h[(jYa(l,1,xd)|0)>>3]*-.00052092078397148+3.05889228736295e-14)+4.0344361048474e-26))))))))))+-2.48050170161934e-16)));c[yd>>2]=44;Yd=Ed*(Hd+e/1.0e6*(Dd+e/1.0e6*(j*(j*(+h[(jYa(l,1,yd)|0)>>3]+1.5348861422742e-7)+-9.461677147124e-9)+_d)+1.22890426153854e-7))+-1.0;c[zd>>2]=21;_d=Yd/+h[(jYa(l,1,zd)|0)>>3];c[Ad>>2]=33;Yd=540.0/f*(540.0/f*(540.0/f*(540.0/f*((540.0/f*(540.0/f*.06380539059921+-.5681726521544)+10.08665568018)*+h[(jYa(l,1,Ad)|0)>>3]+4.38395111945)+-2.848163942888)+1.2213149471784)+-.2858109552582)+.0280439559151;c[Bd>>2]=33;Dd=+h[(jYa(l,1,Bd)|0)>>3];c[Cd>>2]=34;Hd=Yd/(Dd*+h[(jYa(l,1,Cd)|0)>>3]);c[m>>2]=49;Dd=+h[(jYa(l,1,m)|0)>>3];c[n>>2]=1;Yd=+h[(jYa(l,1,n)|0)>>3];c[o>>2]=13;Ed=+h[(jYa(l,1,o)|0)>>3]*-.00096028372490713+-.306581069554011;c[p>>2]=2;Xd=j*(Yd*(Ed*+h[(jYa(l,1,p)|0)>>3]+-.015757110897342)+-.0003789797503263);c[q>>2]=1;Ed=+h[(jYa(l,1,q)|0)>>3];c[r>>2]=13;Yd=+h[(jYa(l,1,r)|0)>>3]*-1.42338887469272+-.0090203547252888;c[s>>2]=2;Td=Ed*(Yd*+h[(jYa(l,1,s)|0)>>3]+-9683303171571.0e-17);c[t>>2]=20;Yd=+h[(jYa(l,1,t)|0)>>3]*160454534363627.0e-19;c[u>>2]=1;Ed=+h[(jYa(l,1,u)|0)>>3];c[v>>2]=15;Rd=+h[(jYa(l,1,v)|0)>>3];c[w>>2]=16;Vd=Ed*(Rd*(+h[(jYa(l,1,w)|0)>>3]*-836.35096769364+-.033874355714168)+-5.0144299353183e-11);c[x>>2]=18;Rd=+h[(jYa(l,1,x)|0)>>3]*-.97367106089347+-138839897890111.0e-19;c[y>>2]=50;Ed=Rd*+h[(jYa(l,1,y)|0)>>3];c[z>>2]=14;Rd=+h[(jYa(l,1,z)|0)>>3];c[A>>2]=19;Sd=Rd*(+h[(jYa(l,1,A)|0)>>3]*-296.320827232793+9.0049690883672e-11);c[B>>2]=51;Rd=+h[(jYa(l,1,B)|0)>>3]*2.57526266427144e-7;c[C>>2]=2;Qd=+h[(jYa(l,1,C)|0)>>3];c[D>>2]=10;Ud=+h[(jYa(l,1,D)|0)>>3]*-1.40254511313154e-8+-1.0234747095929e-12;c[E>>2]=20;Md=Qd*(Ud*+h[(jYa(l,1,E)|0)>>3]+4.1627860840696e-19);c[F>>2]=23;Ud=+h[(jYa(l,1,F)|0)>>3];c[G>>2]=19;Qd=+h[(jYa(l,1,G)|0)>>3];c[H>>2]=24;Nd=Qd*(+h[(jYa(l,1,H)|0)>>3]*5.3465159397045+-2.34560435076256e-9);c[I>>2]=21;Qd=+h[(jYa(l,1,I)|0)>>3];c[J>>2]=52;Od=+h[(jYa(l,1,J)|0)>>3]*-19.1874828272775;c[K>>2]=21;Pd=+h[(jYa(l,1,K)|0)>>3];c[L>>2]=16;Fd=+h[(jYa(l,1,L)|0)>>3];c[M>>2]=15;Jd=+h[(jYa(l,1,M)|0)>>3]*-.000201611844951398+1.07202609066812e-11;c[N>>2]=28;Ld=Fd*(Jd*+h[(jYa(l,1,N)|0)>>3]+1.78371690710842e-23);c[O>>2]=27;Jd=+h[(jYa(l,1,O)|0)>>3]*-1.24017662339842e-24;c[P>>2]=53;Fd=+h[(jYa(l,1,P)|0)>>3]*.000200482822351322;c[Q>>2]=54;Id=+h[(jYa(l,1,Q)|0)>>3]*-4.9797574845256e-14;c[R>>2]=18;Kd=+h[(jYa(l,1,R)|0)>>3];c[S>>2]=32;$d=Kd*(+h[(jYa(l,1,S)|0)>>3]*-54734430199902.0e-18+2.21658861403112e-15)+1.90027787547159e-27;c[T>>2]=55;Kd=Hd+e/1.0e6*(Dd+e/1.0e6*(Xd+e/1.0e6*(Td+e/1.0e6*(j*(j*144676118155521.0e-20+2.558143570457e-8)+e/1.0e6*(Yd+e/1.0e6*(Vd+e/1.0e6*(Ed+e/1.0e6*(Sd+e/1.0e6*(Rd+e/1.0e6*(Md+Ud*(Nd+Qd*(Od+Pd*(Ld+e/1.0e6*(Jd+e/1.0e6*(Fd+e/1.0e6*(Id+e/1.0e6*+h[(jYa(l,1,T)|0)>>3]*$d))))))))))))+-7.8847309559367e-10)+4.3870667284435e-7)+-33032641670203.0e-18)+-.017834862292358);c[U>>2]=33;$d=540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*.12761078119842+-.5681726521544)*+h[(jYa(l,1,U)|0)>>3]+-8.7679022389)+8.544491828664)+-4.8852597887136)+1.429054776291)+-.1682637354906;c[V>>2]=33;Id=+h[(jYa(l,1,V)|0)>>3];c[W>>2]=34;Fd=$d/(540.0/f*Id*+h[(jYa(l,1,W)|0)>>3]);c[X>>2]=2;Id=j*(+h[(jYa(l,1,X)|0)>>3]*-1.5097583618379+-.34548755450059);c[Y>>2]=1;$d=+h[(jYa(l,1,Y)|0)>>3];c[Z>>2]=13;Jd=+h[(jYa(l,1,Z)|0)>>3]*-.03360993037175+-1.83948641732407;c[_>>2]=2;Ld=$d*(Jd*+h[(jYa(l,1,_)|0)>>3]+-.047271332692026);c[$>>2]=13;Jd=+h[(jYa(l,1,$)|0)>>3]*-48.395221739552+-.045101773626444;c[aa>>2]=2;$d=j*(Jd*+h[(jYa(l,1,aa)|0)>>3]+-.00019366606343142);c[ba>>2]=10;Jd=j*+h[(jYa(l,1,ba)|0)>>3]*96272720618176.0e-18;c[ca>>2]=15;Pd=+h[(jYa(l,1,ca)|0)>>3];c[ea>>2]=16;Od=j*(Pd*(+h[(jYa(l,1,ea)|0)>>3]*-28435.9329015838+-.50811533571252)+-1.00288598706366e-10);c[fa>>2]=11;Pd=+h[(jYa(l,1,fa)|0)>>3];c[ga>>2]=18;Qd=Pd*j*(+h[(jYa(l,1,ga)|0)>>3]*-23.3681054614434+-.000138839897890111);c[ha>>2]=19;Pd=+h[(jYa(l,1,ha)|0)>>3]*-10371.2289531477+6.303478361857e-10;c[ia>>2]=20;Nd=Pd*+h[(jYa(l,1,ia)|0)>>3];c[ja>>2]=17;Pd=+h[(jYa(l,1,ja)|0)>>3]*309031519712573.0e-20;c[ka>>2]=1;Ud=+h[(jYa(l,1,ka)|0)>>3];c[la>>2]=10;Md=+h[(jYa(l,1,la)|0)>>3]*-1.823308647071e-7+-9.2112723863361e-12;c[ma>>2]=20;Rd=Ud*(Md*+h[(jYa(l,1,ma)|0)>>3]+1.24883582522088e-18);c[na>>2]=23;Md=+h[(jYa(l,1,na)|0)>>3];c[oa>>2]=1;Ud=+h[(jYa(l,1,oa)|0)>>3];c[pa>>2]=11;Sd=+h[(jYa(l,1,pa)|0)>>3];c[qa>>2]=12;Ed=+h[(jYa(l,1,qa)|0)>>3];c[ra>>2]=24;Vd=Ud*Sd*Ed*j*(+h[(jYa(l,1,ra)|0)>>3]*261.979281045521+-6.5676921821352e-8);c[sa>>2]=21;Ed=+h[(jYa(l,1,sa)|0)>>3];c[ta>>2]=1;Sd=+h[(jYa(l,1,ta)|0)>>3];c[ua>>2]=10;Ud=+h[(jYa(l,1,ua)|0)>>3];c[va>>2]=12;Yd=+h[(jYa(l,1,va)|0)>>3];c[wa>>2]=25;Td=Sd*Ud*Yd*j*+h[(jYa(l,1,wa)|0)>>3]*-1074.49903832754;c[xa>>2]=21;Yd=+h[(jYa(l,1,xa)|0)>>3];c[ya>>2]=15;Ud=+h[(jYa(l,1,ya)|0)>>3]*-.0094757567127157+3.6448887082716e-10;c[za>>2]=28;Sd=Ud*+h[(jYa(l,1,za)|0)>>3]+3.389062123506e-22;c[Aa>>2]=32;Ud=Sd*+h[(jYa(l,1,Aa)|0)>>3];c[Ba>>2]=16;Sd=+h[(jYa(l,1,Ba)|0)>>3]*-2.48035324679684e-23;c[Ca>>2]=1;Xd=+h[(jYa(l,1,Ca)|0)>>3];c[Da>>2]=12;Dd=+h[(jYa(l,1,Da)|0)>>3];c[Ea>>2]=25;Hd=Xd*Dd*j*+h[(jYa(l,1,Ea)|0)>>3]*.0104251067622687;c[Fa>>2]=11;Dd=+h[(jYa(l,1,Fa)|0)>>3];c[Ga>>2]=12;Xd=+h[(jYa(l,1,Ga)|0)>>3];c[Ha>>2]=18;ae=+h[(jYa(l,1,Ha)|0)>>3];c[Ia>>2]=32;be=Dd*Xd*e/1.0e6*(ae*(+h[(jYa(l,1,Ia)|0)>>3]*-.0031198625213944+8.6446955947214e-14)+4.750694688679e-26);c[Ja>>2]=10;ae=+h[(jYa(l,1,Ja)|0)>>3];c[Ka>>2]=25;Xd=Fd+e/1.0e6*(Id+e/1.0e6*(Ld+e/1.0e6*($d+e/1.0e6*(j*289352236311042.0e-20+e/1.0e6*(Jd+e/1.0e6*(Od+e/1.0e6*(Qd+e/1.0e6*(Nd+e/1.0e6*(Pd+e/1.0e6*(Rd+Md*(Vd+Ed*(Td+Yd*(Ud+e/1.0e6*(Sd+e/1.0e6*(Hd+e/1.0e6*(be+ae*j*+h[(jYa(l,1,Ka)|0)>>3]*-1.89230784411972e-12))))))))))))+2.558143570457e-8))+-.0003789797503263)+-.09199202739273);c[La>>2]=49;ae=+h[(jYa(l,1,La)|0)>>3];c[Ma>>2]=1;be=+h[(jYa(l,1,Ma)|0)>>3];c[Na>>2]=13;Hd=+h[(jYa(l,1,Na)|0)>>3]*-.00192056744981426+-.61316213910802;c[Oa>>2]=2;Sd=j*(be*(Hd*+h[(jYa(l,1,Oa)|0)>>3]+-.031514221794684)+-.0007579595006526);c[Pa>>2]=1;Hd=+h[(jYa(l,1,Pa)|0)>>3];c[Qa>>2]=13;be=+h[(jYa(l,1,Qa)|0)>>3]*-4.2701666240781+-.0270610641758664;c[Ra>>2]=2;Ud=Hd*(be*+h[(jYa(l,1,Ra)|0)>>3]+-.00029049909514713);c[Sa>>2]=20;be=+h[(jYa(l,1,Sa)|0)>>3]*80227267181813.0e-18;c[Ta>>2]=1;Hd=+h[(jYa(l,1,Ta)|0)>>3];c[Ua>>2]=15;Yd=+h[(jYa(l,1,Ua)|0)>>3];c[Va>>2]=16;Td=Hd*(Yd*(+h[(jYa(l,1,Va)|0)>>3]*-5018.1058061618+-.203246134285008)+-3.00865796119098e-10);c[Wa>>2]=18;Yd=+h[(jYa(l,1,Wa)|0)>>3]*-6.8156974262543+-97187928523078.0e-18;c[Xa>>2]=50;Hd=Yd*+h[(jYa(l,1,Xa)|0)>>3];c[Ya>>2]=14;Yd=+h[(jYa(l,1,Ya)|0)>>3];c[Za>>2]=19;Ed=Yd*(+h[(jYa(l,1,Za)|0)>>3]*-2370.56661786234+7.2039752706938e-10);c[_a>>2]=51;Yd=+h[(jYa(l,1,_a)|0)>>3]*23177363978443.0e-19;c[$a>>2]=2;Vd=+h[(jYa(l,1,$a)|0)>>3];c[ab>>2]=10;Md=+h[(jYa(l,1,ab)|0)>>3]*-1.40254511313154e-7+-1.0234747095929e-11;c[bb>>2]=20;Rd=Vd*(Md*+h[(jYa(l,1,bb)|0)>>3]+4.1627860840696e-18);c[cb>>2]=23;Md=+h[(jYa(l,1,cb)|0)>>3];c[db>>2]=19;Vd=+h[(jYa(l,1,db)|0)>>3];c[eb>>2]=24;Pd=Vd*(+h[(jYa(l,1,eb)|0)>>3]*85.544255035272+-3.7529669612201e-8);c[fb>>2]=21;Vd=+h[(jYa(l,1,fb)|0)>>3];c[gb>>2]=52;Nd=+h[(jYa(l,1,gb)|0)>>3]*-345.37469089099;c[hb>>2]=21;Qd=+h[(jYa(l,1,hb)|0)>>3];c[ib>>2]=16;Od=+h[(jYa(l,1,ib)|0)>>3];c[jb>>2]=15;Jd=+h[(jYa(l,1,jb)|0)>>3]*-.004032236899028+2.14405218133624e-10;c[kb>>2]=28;$d=Od*(Jd*+h[(jYa(l,1,kb)|0)>>3]+3.5674338142168e-22);c[lb>>2]=27;Jd=+h[(jYa(l,1,lb)|0)>>3]*-2.60437090913668e-23;c[mb>>2]=53;Od=+h[(jYa(l,1,mb)|0)>>3]*.0044106220917291;c[nb>>2]=54;Ld=+h[(jYa(l,1,nb)|0)>>3]*-1.14534422144089e-12;c[ob>>2]=18;Id=+h[(jYa(l,1,ob)|0)>>3];c[pb>>2]=32;Fd=Id*(+h[(jYa(l,1,pb)|0)>>3]*-.00131362632479764+5.3198126736747e-14)+4.5606669011318e-26;c[qb>>2]=55;Id=e/1.0e6*(be+e/1.0e6*(Td+e/1.0e6*(Hd+e/1.0e6*(Ed+e/1.0e6*(Yd+e/1.0e6*(Rd+Md*(Pd+Vd*(Nd+Qd*($d+e/1.0e6*(Jd+e/1.0e6*(Od+e/1.0e6*(Ld+e/1.0e6*+h[(jYa(l,1,qb)|0)>>3]*Fd))))))))))));c[(a+120|0)>>2]=44;Fd=ae+e/1.0e6*(Sd+e/1.0e6*(Ud+e/1.0e6*(j*(+h[(jYa(l,1,a+120|0)|0)>>3]+1.0232574281828e-7)+Id+-3.15389238237468e-9)+131612001853305.0e-20)+-66065283340406.0e-18)+-.017834862292358;h[b>>3]=e;h[b+8>>3]=f;h[b+16>>3]=461.526;h[b+24>>3]=e/1.0e6;h[b+32>>3]=540.0/f;h[b+40>>3]=Wd;h[b+48>>3]=Zd;h[b+56>>3]=_d;h[b+64>>3]=Kd;h[b+72>>3]=Xd;h[b+80>>3]=Fd;i=a;c[a+5648>>2]=5;break a}while(0)}



function eTa(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;l=i;i=i+392|0;m=l+32|0;n=l+88|0;o=l+104|0;p=l+128|0;q=l+168|0;r=l+184|0;s=l+232|0;t=l+248|0;u=l+344|0;v=l+352|0;w=l+368|0;x=l+384|0;y=b;b=e;e=f;c[m>>2]=g;g=h;h=j;j=k;k=c[y+356>>2]|0;f=y;if((e|0)==(c[y+144>>2]|0)){z=f+288|0;A=y+292|0}else{z=c[f+300>>2]|0;A=(c[y+300>>2]|0)+4|0}c[z>>2]=c[m>>2];a:while(1){c[n>>2]=c[m>>2];f=Oe[c[e+4>>2]&63](e,c[m>>2]|0,g,n)|0;c[A>>2]=c[n>>2];b:do{switch(f|0){case-2:{B=28;break a;break};case-3:{B=6;break a;break};case 6:{C=c[y+60>>2]|0;if((C|0)==0){if((c[y+80>>2]|0)==0){break b}zSa(y,e,c[m>>2]|0,c[n>>2]|0);break b}if((a[e+72|0]|0)!=0){Le[C&15](c[y+4>>2]|0,c[m>>2]|0,(c[n>>2]|0)-(c[m>>2]|0)|0);break b}while(1){c[x>>2]=c[y+44>>2];je[c[e+60>>2]&31](e,m,c[n>>2]|0,x,c[y+48>>2]|0);c[A>>2]=c[m>>2];Le[C&15](c[y+4>>2]|0,c[y+44>>2]|0,(c[x>>2]|0)-(c[y+44>>2]|0)|0);if((c[m>>2]|0)==(c[n>>2]|0)){break b}c[z>>2]=c[m>>2]}break};case 1:case 2:{C=y;if((c[y+368>>2]|0)!=0){D=c[C+368>>2]|0;c[y+368>>2]=c[c[y+368>>2]>>2]}else{D=pe[c[C+12>>2]&127](48)|0;if((D|0)==0){B=72;break a}c[D+36>>2]=pe[c[y+12>>2]&127](32)|0;if((c[D+36>>2]|0)==0){B=74;break a}c[D+40>>2]=(c[D+36>>2]|0)+32}c[D+44>>2]=0;c[D>>2]=c[y+364>>2];c[y+364>>2]=D;c[D+16>>2]=0;c[D+20>>2]=0;c[D+4>>2]=(c[m>>2]|0)+(c[e+68>>2]|0);c[D+8>>2]=Ee[c[e+32>>2]&63](e,c[D+4>>2]|0)|0;C=y+312|0;c[C>>2]=(c[C>>2]|0)+1;C=(c[D+4>>2]|0)+(c[D+8>>2]|0)|0;c[r>>2]=c[D+4>>2];c[q>>2]=c[D+36>>2];while(1){je[c[e+60>>2]&31](e,r,C,q,(c[D+40>>2]|0)+ -1|0);E=(c[q>>2]|0)-(c[D+36>>2]|0)|0;if((c[r>>2]|0)==(C|0)){break}F=(c[D+40>>2]|0)-(c[D+36>>2]|0)<<1;G=Ee[c[y+16>>2]&63](c[D+36>>2]|0,F)|0;if((G|0)==0){B=80;break a}c[D+36>>2]=G;c[D+40>>2]=G+F;c[q>>2]=G+E}c[D+24>>2]=E;c[D+12>>2]=c[D+36>>2];a[c[q>>2]|0]=0;H=hTa(y,e,c[m>>2]|0,D+12|0,D+44|0)|0;if((H|0)!=0){B=82;break a}C=y;do{if((c[y+52>>2]|0)!=0){Le[c[C+52>>2]&15](c[y+4>>2]|0,c[D+12>>2]|0,c[y+392>>2]|0)}else{if((c[C+80>>2]|0)==0){break}zSa(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);iSa(y+416|0);break};case-4:{B=17;break a;break};case 5:{if((c[y+312>>2]|0)==(b|0)){B=109;break a}C=c[y+364>>2]|0;c[y+364>>2]=c[C>>2];c[C>>2]=c[y+368>>2];c[y+368>>2]=C;I=(c[m>>2]|0)+(c[e+68>>2]<<1)|0;G=Ee[c[e+32>>2]&63](e,I)|0;if((G|0)!=(c[C+8>>2]|0)){B=112;break a}if((tqb(c[C+4>>2]|0,I,G)|0)!=0){B=112;break a}G=y+312|0;c[G>>2]=(c[G>>2]|0)+ -1;do{if((c[y+56>>2]|0)!=0){G=c[C+16>>2]|0;do{if((d[y+236|0]|0)!=0){if((G|0)==0){break}F=(c[C+12>>2]|0)+(c[C+28>>2]|0)|0;while(1){if((a[G]|0)==0){break}J=G;G=J+1|0;K=F;F=K+1|0;a[K]=a[J]|0}J=c[C+20>>2]|0;c:do{if((d[y+237|0]|0)!=0){if((J|0)==0){break}K=F;F=K+1|0;a[K]=a[y+472|0]|0;while(1){if((a[J]|0)==0){break c}K=J;J=K+1|0;L=F;F=L+1|0;a[L]=a[K]|0}}}while(0);a[F]=0}}while(0);ne[c[y+56>>2]&255](c[y+4>>2]|0,c[C+12>>2]|0)}else{if((c[y+80>>2]|0)==0){break}zSa(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);while(1){if((c[C+44>>2]|0)==0){break}G=c[C+44>>2]|0;if((c[y+104>>2]|0)!=0){ne[c[y+104>>2]&255](c[y+4>>2]|0,c[c[G>>2]>>2]|0)}c[C+44>>2]=c[(c[C+44>>2]|0)+4>>2];c[G+4>>2]=c[y+376>>2];c[y+376>>2]=G;c[(c[G>>2]|0)+4>>2]=c[G+8>>2]}if((c[y+312>>2]|0)==0){B=133;break a}break};case 8:{C=y;do{if((c[y+72>>2]|0)!=0){me[c[C+72>>2]&2047](c[y+4>>2]|0)}else{if((c[C+80>>2]|0)==0){break}zSa(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);M=jTa(y,e,n,g,h,j)|0;if((M|0)!=0){B=150;break a}if((c[n>>2]|0)==0){B=152;break a}break};case 12:{B=140;break a;break};case 9:{a[p]=se[c[e+48>>2]&63](e,(c[m>>2]|0)+(c[e+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[e+68>>2]|0))|0)|0;if((a[p]|0)!=0){C=y;if((c[y+60>>2]|0)!=0){Le[c[C+60>>2]&15](c[y+4>>2]|0,p,1);break b}if((c[C+80>>2]|0)==0){break b}zSa(y,e,c[m>>2]|0,c[n>>2]|0);break b}C=NSa(k+80|0,e,(c[m>>2]|0)+(c[e+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[e+68>>2]|0))|0)|0;if((C|0)==0){B=37;break a}G=ESa(y,k,C,0)|0;c[k+92>>2]=c[k+96>>2];do{if((a[k+129|0]|0)!=0){if((d[k+130|0]|0)!=0){B=40;break}if((G|0)!=0){break}J=y;if((c[y+120>>2]|0)!=0){Le[c[J+120>>2]&15](c[y+4>>2]|0,C,0);break b}if((c[J+80>>2]|0)==0){break b}zSa(y,e,c[m>>2]|0,c[n>>2]|0);break b}else{B=40}}while(0);if((B|0)==40){B=0;if((G|0)==0){B=41;break a}if((a[G+34|0]|0)==0){B=43;break a}}if((a[G+32|0]|0)!=0){B=50;break a}if((c[G+28>>2]|0)!=0){B=52;break a}C=y;if((c[G+4>>2]|0)!=0){J=y;if((a[C+308|0]|0)!=0){N=_Sa(J,G,0)|0;if((N|0)!=0){B=60;break a}else{break b}}K=y;if((c[J+120>>2]|0)!=0){Le[c[K+120>>2]&15](c[y+4>>2]|0,c[G>>2]|0,0);break b}if((c[K+80>>2]|0)==0){break b}zSa(y,e,c[m>>2]|0,c[n>>2]|0);break b}else{if((c[C+112>>2]|0)==0){if((c[y+80>>2]|0)==0){break b}zSa(y,e,c[m>>2]|0,c[n>>2]|0);break b}a[G+32|0]=1;C=gTa(y)|0;a[G+32|0]=0;if((C|0)==0){B=63;break a}if((Fe[c[y+112>>2]&63](c[y+116>>2]|0,C,c[G+20>>2]|0,c[G+16>>2]|0,c[G+24>>2]|0)|0)==0){B=65;break a}c[y+428>>2]=c[y+432>>2];break b}break};case 0:{B=24;break a;break};case 13:{if((bTa(y,e,c[m>>2]|0,c[n>>2]|0)|0)==0){B=176;break a}break};case-5:{B=153;break a;break};case 10:{C=Ee[c[e+44>>2]&63](e,c[m>>2]|0)|0;if((C|0)<0){B=135;break a}K=y;if((c[y+60>>2]|0)!=0){J=c[K+60>>2]|0;L=c[y+4>>2]|0;O=vTa(C,u)|0;Le[J&15](L,u,O);break b}if((c[K+80>>2]|0)==0){break b}zSa(y,e,c[m>>2]|0,c[n>>2]|0);break};case 7:{if((c[y+60>>2]|0)!=0){a[v]=10;Le[c[y+60>>2]&15](c[y+4>>2]|0,v,1);break b}if((c[y+80>>2]|0)==0){break b}zSa(y,e,c[m>>2]|0,c[n>>2]|0);break};case-1:{B=25;break a;break};case 3:case 4:{K=(c[m>>2]|0)+(c[e+68>>2]|0)|0;c[s>>2]=0;O=1;c[t>>2]=NSa(y+416|0,e,K,K+(Ee[c[e+32>>2]&63](e,K)|0)|0)|0;if((c[t>>2]|0)==0){B=89;break a}c[y+432>>2]=c[y+428>>2];P=hTa(y,e,c[m>>2]|0,t,s)|0;if((P|0)!=0){B=91;break a}c[y+432>>2]=c[y+428>>2];if((c[y+52>>2]|0)!=0){Le[c[y+52>>2]&15](c[y+4>>2]|0,c[t>>2]|0,c[y+392>>2]|0);O=0}if((c[y+56>>2]|0)!=0){if((c[y+52>>2]|0)!=0){c[z>>2]=c[A>>2]}ne[c[y+56>>2]&255](c[y+4>>2]|0,c[t>>2]|0);O=0}do{if((O&255|0)!=0){if((c[y+80>>2]|0)==0){break}zSa(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);iSa(y+416|0);while(1){if((c[s>>2]|0)==0){break}O=c[s>>2]|0;if((c[y+104>>2]|0)!=0){ne[c[y+104>>2]&255](c[y+4>>2]|0,c[c[O>>2]>>2]|0)}c[s>>2]=c[(c[s>>2]|0)+4>>2];c[O+4>>2]=c[y+376>>2];c[y+376>>2]=O;c[(c[O>>2]|0)+4>>2]=c[O+8>>2]}if((c[y+312>>2]|0)==0){B=107;break a}break};case 11:{if((aTa(y,e,c[m>>2]|0,c[n>>2]|0)|0)==0){B=174;break a}break};default:{if((c[y+80>>2]|0)==0){break b}zSa(y,e,c[m>>2]|0,c[n>>2]|0)}}}while(0);f=c[n>>2]|0;c[m>>2]=f;c[z>>2]=f;f=c[y+480>>2]|0;if((f|0)==3){B=180;break}else if((f|0)==2){B=181;break}}if((B|0)==6){if(j<<24>>24!=0){c[h>>2]=c[m>>2];Q=0;R=Q;i=l;return R|0}c[A>>2]=g;do{if((c[y+60>>2]|0)!=0){a[o]=10;Le[c[y+60>>2]&15](c[y+4>>2]|0,o,1)}else{if((c[y+80>>2]|0)==0){break}zSa(y,e,c[m>>2]|0,g)}}while(0);if((b|0)==0){Q=3;R=Q;i=l;return R|0}if((c[y+312>>2]|0)!=(b|0)){Q=13;R=Q;i=l;return R|0}else{c[h>>2]=g;Q=0;R=Q;i=l;return R|0}}else if((B|0)==17){if(j<<24>>24!=0){c[h>>2]=c[m>>2];Q=0;R=Q;i=l;return R|0}if((b|0)<=0){Q=3;R=Q;i=l;return R|0}if((c[y+312>>2]|0)!=(b|0)){Q=13;R=Q;i=l;return R|0}else{c[h>>2]=c[m>>2];Q=0;R=Q;i=l;return R|0}}else if((B|0)==24){c[z>>2]=c[n>>2];Q=4;R=Q;i=l;return R|0}else if((B|0)==25){if(j<<24>>24!=0){c[h>>2]=c[m>>2];Q=0;R=Q;i=l;return R|0}else{Q=5;R=Q;i=l;return R|0}}else if((B|0)==28){if(j<<24>>24!=0){c[h>>2]=c[m>>2];Q=0;R=Q;i=l;return R|0}else{Q=6;R=Q;i=l;return R|0}}else if((B|0)==37){Q=1;R=Q;i=l;return R|0}else if((B|0)==41){Q=11;R=Q;i=l;return R|0}else if((B|0)==43){Q=24;R=Q;i=l;return R|0}else if((B|0)==50){Q=12;R=Q;i=l;return R|0}else if((B|0)==52){Q=15;R=Q;i=l;return R|0}else if((B|0)==60){Q=N;R=Q;i=l;return R|0}else if((B|0)==63){Q=1;R=Q;i=l;return R|0}else if((B|0)==65){Q=21;R=Q;i=l;return R|0}else if((B|0)==72){Q=1;R=Q;i=l;return R|0}else if((B|0)==74){me[c[y+20>>2]&2047](D);Q=1;R=Q;i=l;return R|0}else if((B|0)==80){Q=1;R=Q;i=l;return R|0}else if((B|0)==82){Q=H;R=Q;i=l;return R|0}else if((B|0)==89){Q=1;R=Q;i=l;return R|0}else if((B|0)==91){Q=P;R=Q;i=l;return R|0}else if((B|0)==107){Q=iTa(y,c[n>>2]|0,g,h)|0;R=Q;i=l;return R|0}else if((B|0)==109){Q=13;R=Q;i=l;return R|0}else if((B|0)==112){c[z>>2]=I;Q=7;R=Q;i=l;return R|0}else if((B|0)==133){Q=iTa(y,c[n>>2]|0,g,h)|0;R=Q;i=l;return R|0}else if((B|0)==135){Q=14;R=Q;i=l;return R|0}else if((B|0)==140){Q=17;R=Q;i=l;return R|0}else if((B|0)==150){Q=M;R=Q;i=l;return R|0}else if((B|0)==152){c[y+280>>2]=42;Q=M;R=Q;i=l;return R|0}else if((B|0)==153){if(j<<24>>24!=0){c[h>>2]=c[m>>2];Q=0;R=Q;i=l;return R|0}do{if((c[y+60>>2]|0)!=0){j=y;if((a[e+72|0]|0)!=0){Le[c[j+60>>2]&15](c[y+4>>2]|0,c[m>>2]|0,g-(c[m>>2]|0)|0);break}else{c[w>>2]=c[j+44>>2];je[c[e+60>>2]&31](e,m,g,w,c[y+48>>2]|0);Le[c[y+60>>2]&15](c[y+4>>2]|0,c[y+44>>2]|0,(c[w>>2]|0)-(c[y+44>>2]|0)|0);break}}else{if((c[y+80>>2]|0)==0){break}zSa(y,e,c[m>>2]|0,g)}}while(0);if((b|0)==0){c[z>>2]=g;Q=3;R=Q;i=l;return R|0}m=g;if((c[y+312>>2]|0)!=(b|0)){c[z>>2]=m;Q=13;R=Q;i=l;return R|0}else{c[h>>2]=m;Q=0;R=Q;i=l;return R|0}}else if((B|0)==174){Q=1;R=Q;i=l;return R|0}else if((B|0)==176){Q=1;R=Q;i=l;return R|0}else if((B|0)==180){c[h>>2]=c[n>>2];Q=0;R=Q;i=l;return R|0}else if((B|0)==181){Q=35;R=Q;i=l;return R|0}return 0}function fTa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+104|0;h=g+64|0;j=b;b=d;d=e;e=f;f=c[j+300>>2]|0;if((f|0)==0){k=23;l=k;i=g;return l|0}m=c[f+12>>2]|0;n=(c[m+4>>2]|0)+(c[m+12>>2]|0)|0;o=(c[m+4>>2]|0)+(c[m+8>>2]|0)|0;p=j;if((a[m+33|0]|0)!=0){q=Oe[c[c[p+228>>2]>>2]&63](c[j+228>>2]|0,n,o,h)|0;r=LSa(j,c[j+228>>2]|0,n,o,q,c[h>>2]|0,h,0)|0}else{r=eTa(p,c[f+16>>2]|0,c[j+228>>2]|0,n,o,h,0)|0}if((r|0)!=0){k=r;l=k;i=g;return l|0}do{if((o|0)!=(c[h>>2]|0)){if((c[j+480>>2]|0)!=3){break}c[m+12>>2]=(c[h>>2]|0)-(c[m+4>>2]|0);k=r;l=k;i=g;return l|0}}while(0);a[m+32|0]=0;c[j+300>>2]=c[f+8>>2];c[f+8>>2]=c[j+304>>2];c[j+304>>2]=f;f=j+280|0;if((a[m+33|0]|0)!=0){c[f>>2]=40;m=Oe[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;k=LSa(j,c[j+144>>2]|0,b,d,m,c[h>>2]|0,e,((a[j+484|0]|0)!=0^1)&1)|0;l=k;i=g;return l|0}else{c[f>>2]=38;k=eTa(j,(c[j+476>>2]|0)!=0?1:0,c[j+144>>2]|0,b,d,e,((a[j+484|0]|0)!=0^1)&1)|0;l=k;i=g;return l|0}return 0}function gTa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+104|0;e=d+24|0;f=b;b=c[f+356>>2]|0;g=0;do{if((c[b+156>>2]|0)!=0){do{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if((BSa(f+416|0)|0)<<24>>24!=0){break}h=0;j=h;i=d;return j|0}}while(0);k=f+428|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=61;l=c[(c[b+156>>2]|0)+20>>2]|0;if((a[f+472|0]|0)!=0){l=l+ -1|0}k=0;while(1){if((k|0)>=(l|0)){m=13;break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((BSa(f+416|0)|0)<<24>>24!=0)){break}}n=a[(c[(c[b+156>>2]|0)+16>>2]|0)+k|0]|0;o=f+428|0;p=c[o>>2]|0;c[o>>2]=p+1;a[p]=n;k=k+1|0}if((m|0)==13){g=1;break}h=0;j=h;i=d;return j|0}}while(0);CSa(e,b+60|0);a:while(1){k=DSa(e)|0;if((k|0)==0){m=40;break}if((c[k+4>>2]|0)==0){continue}if((g&255|0)!=0){if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((BSa(f+416|0)|0)<<24>>24!=0)){m=21;break}}l=f+428|0;n=c[l>>2]|0;c[l>>2]=n+1;a[n]=12}n=c[k>>2]|0;while(1){q=(c[f+428>>2]|0)==(c[f+424>>2]|0);if((a[n]|0)==0){break}if(q){if(!((BSa(f+416|0)|0)<<24>>24!=0)){m=27;break a}}l=a[n]|0;p=f+428|0;o=c[p>>2]|0;c[p>>2]=o+1;a[o]=l;n=n+1|0}if(q){if(!((BSa(f+416|0)|0)<<24>>24!=0)){m=31;break}}n=f+428|0;l=c[n>>2]|0;c[n>>2]=l+1;a[l]=61;l=c[(c[k+4>>2]|0)+20>>2]|0;if((a[f+472|0]|0)!=0){l=l+ -1|0}n=0;while(1){if((n|0)>=(l|0)){break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((BSa(f+416|0)|0)<<24>>24!=0)){m=38;break a}}o=a[(c[(c[k+4>>2]|0)+16>>2]|0)+n|0]|0;p=f+428|0;r=c[p>>2]|0;c[p>>2]=r+1;a[r]=o;n=n+1|0}g=1}if((m|0)==21){h=0;j=h;i=d;return j|0}else if((m|0)==27){h=0;j=h;i=d;return j|0}else if((m|0)==31){h=0;j=h;i=d;return j|0}else if((m|0)==38){h=0;j=h;i=d;return j|0}else if((m|0)==40){CSa(e,b);b:while(1){b=DSa(e)|0;if((b|0)==0){m=55;break}if((a[b+32|0]|0)==0){continue}if((g&255|0)!=0){if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((BSa(f+416|0)|0)<<24>>24!=0)){m=47;break}}q=f+428|0;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=12}n=c[b>>2]|0;while(1){if((a[n]|0)==0){break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((BSa(f+416|0)|0)<<24>>24!=0)){m=53;break b}}b=a[n]|0;q=f+428|0;k=c[q>>2]|0;c[q>>2]=k+1;a[k]=b;n=n+1|0}g=1}if((m|0)==47){h=0;j=h;i=d;return j|0}else if((m|0)==53){h=0;j=h;i=d;return j|0}else if((m|0)==55){do{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if((BSa(f+416|0)|0)<<24>>24!=0){break}h=0;j=h;i=d;return j|0}}while(0);m=f+428|0;g=c[m>>2]|0;c[m>>2]=g+1;a[g]=0;h=c[f+432>>2]|0;j=h;i=d;return j|0}}return 0}function hTa(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;j=i;i=i+352|0;k=b;b=e;e=f;f=g;g=h;h=c[k+356>>2]|0;l=0;m=0;n=ESa(k,h+20|0,c[f>>2]|0,0)|0;do{if((n|0)==0){o=kSa(h+80|0,c[f>>2]|0)|0;if((o|0)==0){p=1;q=p;i=j;return q|0}n=ESa(k,h+20|0,o,24)|0;if((n|0)==0){p=1;q=p;i=j;return q|0}if((d[k+236|0]|0)==0){break}if((nTa(k,n)|0)!=0){break}p=1;q=p;i=j;return q|0}}while(0);o=c[n+12>>2]|0;r=Oe[c[b+40>>2]&63](b,e,c[k+380>>2]|0,c[k+392>>2]|0)|0;do{if((r+o|0)>(c[k+380>>2]|0)){s=c[k+380>>2]|0;c[k+380>>2]=r+o+16;t=Ee[c[k+16>>2]&63](c[k+392>>2]|0,c[k+380>>2]<<4)|0;if((t|0)==0){p=1;q=p;i=j;return q|0}else{c[k+392>>2]=t;if((r|0)<=(s|0)){break}Oe[c[b+40>>2]&63](b,e,r,c[k+392>>2]|0)|0;break}}}while(0);e=c[k+392>>2]|0;s=0;a:while(1){if((s|0)>=(r|0)){u=43;break}t=(c[k+392>>2]|0)+(s<<4)|0;v=c[t>>2]|0;w=c[t>>2]|0;x=RSa(k,b,v,w+(Ee[c[b+32>>2]&63](b,c[t>>2]|0)|0)|0)|0;if((x|0)==0){u=17;break}if((a[(c[x>>2]|0)+ -1|0]|0)!=0){u=19;break}a[(c[x>>2]|0)+ -1|0]=1;t=l;l=t+1|0;c[e+(t<<2)>>2]=c[x>>2];if((a[(c[k+392>>2]|0)+(s<<4)+12|0]|0)!=0){c[e+(l<<2)>>2]=NSa(k+416|0,b,c[(c[k+392>>2]|0)+(s<<4)+4>>2]|0,c[(c[k+392>>2]|0)+(s<<4)+8>>2]|0)|0;if((c[e+(l<<2)>>2]|0)==0){u=33;break}c[k+432>>2]=c[k+428>>2]}else{t=1;b:do{if((a[x+8|0]|0)!=0){w=0;while(1){if((w|0)>=(o|0)){break b}y=w;if((x|0)==(c[(c[n+20>>2]|0)+(w*12|0)>>2]|0)){break}w=y+1|0}t=a[(c[n+20>>2]|0)+(y*12|0)+4|0]|0}}while(0);z=VSa(k,b,t,c[(c[k+392>>2]|0)+(s<<4)+4>>2]|0,c[(c[k+392>>2]|0)+(s<<4)+8>>2]|0,k+416|0)|0;if((z|0)!=0){u=30;break}c[e+(l<<2)>>2]=c[k+432>>2];c[k+432>>2]=c[k+428>>2]}do{if((c[x+4>>2]|0)!=0){if((a[x+9|0]|0)==0){l=l+1|0;m=m+1|0;a[(c[x>>2]|0)+ -1|0]=2;break}A=ISa(k,c[x+4>>2]|0,x,c[e+(l<<2)>>2]|0,g)|0;if((A|0)!=0){u=38;break a}l=l+ -1|0}else{l=l+1|0}}while(0);s=s+1|0}if((u|0)==17){p=1;q=p;i=j;return q|0}else if((u|0)==19){if((b|0)==(c[k+144>>2]|0)){c[k+288>>2]=c[(c[k+392>>2]|0)+(s<<4)>>2]}p=8;q=p;i=j;return q|0}else if((u|0)==30){p=z;q=p;i=j;return q|0}else if((u|0)==33){p=1;q=p;i=j;return q|0}else if((u|0)==38){p=A;q=p;i=j;return q|0}else if((u|0)==43){c[k+384>>2]=l;c:do{if((c[n+8>>2]|0)!=0){if((a[(c[c[n+8>>2]>>2]|0)+ -1|0]|0)==0){u=50;break}s=0;while(1){if((s|0)>=(l|0)){break c}B=s;if((c[e+(s<<2)>>2]|0)==(c[c[n+8>>2]>>2]|0)){break}s=B+2|0}c[k+388>>2]=B}else{u=50}}while(0);if((u|0)==50){c[k+388>>2]=-1}s=0;d:while(1){if((s|0)>=(o|0)){break}B=(c[n+20>>2]|0)+(s*12|0)|0;do{if((a[(c[c[B>>2]>>2]|0)+ -1|0]|0)==0){if((c[B+8>>2]|0)==0){break}A=c[B>>2]|0;if((c[(c[B>>2]|0)+4>>2]|0)==0){a[(c[A>>2]|0)+ -1|0]=1;z=l;l=z+1|0;c[e+(z<<2)>>2]=c[c[B>>2]>>2];z=l;l=z+1|0;c[e+(z<<2)>>2]=c[B+8>>2];break}if((a[A+9|0]|0)!=0){C=ISa(k,c[(c[B>>2]|0)+4>>2]|0,c[B>>2]|0,c[B+8>>2]|0,g)|0;if((C|0)!=0){u=58;break d}else{break}}else{a[(c[c[B>>2]>>2]|0)+ -1|0]=2;m=m+1|0;A=l;l=A+1|0;c[e+(A<<2)>>2]=c[c[B>>2]>>2];A=l;l=A+1|0;c[e+(A<<2)>>2]=c[B+8>>2];break}}}while(0);s=s+1|0}if((u|0)==58){p=C;q=p;i=j;return q|0}c[e+(l<<2)>>2]=0;s=0;e:do{if((m|0)!=0){C=c[k+400>>2]|0;o=1<<d[k+404|0];do{if((m<<1>>d[k+404|0]|0)!=0){do{B=k+404|0;A=a[B]|0;a[B]=A+1<<24>>24;}while((m>>(A&255)|0)!=0);if((d[k+404|0]|0)<3){a[k+404|0]=3}o=1<<d[k+404|0];A=Ee[c[k+16>>2]&63](c[k+396>>2]|0,o*12|0)|0;if((A|0)!=0){c[k+396>>2]=A;C=0;break}p=1;q=p;i=j;return q|0}}while(0);f:do{if((C|0)==0){C=-1;D=o;while(1){if((D|0)==0){break f}A=D+ -1|0;D=A;c[(c[k+396>>2]|0)+(A*12|0)>>2]=C}}}while(0);A=C+ -1|0;C=A;c[k+400>>2]=A;g:while(1){if((s|0)>=(l|0)){break e}A=c[e+(s<<2)>>2]|0;if((a[A+ -1|0]|0)==2){B=c[k+496>>2]|0;a[A+ -1|0]=0;z=c[(c[(ESa(k,h+40|0,A,0)|0)+4>>2]|0)+4>>2]|0;if((z|0)==0){u=78;break}D=0;while(1){if((D|0)>=(c[z+20>>2]|0)){break}b=a[(c[z+16>>2]|0)+D|0]|0;if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((BSa(k+416|0)|0)<<24>>24!=0)){u=84;break g}}y=k+428|0;x=c[y>>2]|0;c[y>>2]=x+1;a[x]=b;B=B*1000003^b&255;D=D+1|0}do{b=A;A=b+1|0;}while((a[b]|0)!=58);do{b=a[A]|0;if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((BSa(k+416|0)|0)<<24>>24!=0)){u=89;break g}}x=a[A]|0;y=k+428|0;t=c[y>>2]|0;c[y>>2]=t+1;a[t]=x;B=B*1000003^b&255;b=A;A=b+1|0;}while((a[b]|0)!=0);b=0;x=o-1|0;D=B&x;while(1){if((c[(c[k+396>>2]|0)+(D*12|0)>>2]|0)!=(C|0)){break}if((B|0)==(c[(c[k+396>>2]|0)+(D*12|0)+4>>2]|0)){t=c[k+432>>2]|0;y=c[(c[k+396>>2]|0)+(D*12|0)+8>>2]|0;while(1){if((a[t]|0)!=(a[y]|0)){break}if((a[t]|0)==0){break}t=t+1|0;y=y+1|0}if((a[t]|0)==0){u=98;break g}}if(!(b<<24>>24!=0)){b=((B&~x)>>>((d[k+404|0]|0)-1|0)&x>>>2|1)&255}if((D|0)<(b&255|0)){D=D+(o-(b&255))|0;continue}else{D=D-(b&255)|0;continue}}if((a[k+237|0]|0)!=0){a[(c[k+428>>2]|0)+ -1|0]=a[k+472|0]|0;A=c[c[z>>2]>>2]|0;do{if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((BSa(k+416|0)|0)<<24>>24!=0)){u=109;break g}}b=a[A]|0;x=k+428|0;y=c[x>>2]|0;c[x>>2]=y+1;a[y]=b;b=A;A=b+1|0;}while((a[b]|0)!=0)}A=c[k+432>>2]|0;c[k+432>>2]=c[k+428>>2];c[e+(s<<2)>>2]=A;c[(c[k+396>>2]|0)+(D*12|0)>>2]=C;c[(c[k+396>>2]|0)+(D*12|0)+4>>2]=B;c[(c[k+396>>2]|0)+(D*12|0)+8>>2]=A;z=m+ -1|0;m=z;if((z|0)==0){u=111;break}}else{a[A+ -1|0]=0}s=s+2|0}if((u|0)==78){p=27;q=p;i=j;return q|0}else if((u|0)==84){p=1;q=p;i=j;return q|0}else if((u|0)==89){p=1;q=p;i=j;return q|0}else if((u|0)==98){p=8;q=p;i=j;return q|0}else if((u|0)==109){p=1;q=p;i=j;return q|0}else if((u|0)==111){s=s+2|0;break}}}while(0);while(1){if((s|0)>=(l|0)){break}a[(c[e+(s<<2)>>2]|0)+ -1|0]=0;s=s+2|0}e=c[g>>2]|0;while(1){if((e|0)==0){break}a[(c[c[e+12>>2]>>2]|0)+ -1|0]=0;e=c[e+4>>2]|0}if((a[k+236|0]|0)==0){p=0;q=p;i=j;return q|0}do{if((c[n+4>>2]|0)!=0){e=c[(c[n+4>>2]|0)+4>>2]|0;if((e|0)!=0){E=c[f>>2]|0;do{g=E;E=g+1|0;}while((a[g]|0)!=58)}else{p=27;q=p;i=j;return q|0}}else{if((c[h+156>>2]|0)!=0){e=c[h+156>>2]|0;E=c[f>>2]|0;break}p=0;q=p;i=j;return q|0}}while(0);h=0;do{if((d[k+237|0]|0)!=0){if((c[c[e>>2]>>2]|0)==0){break}do{n=h;h=n+1|0;}while((a[(c[c[e>>2]>>2]|0)+n|0]|0)!=0)}}while(0);c[f+4>>2]=E;c[f+16>>2]=c[e+20>>2];c[f+8>>2]=c[c[e>>2]>>2];c[f+20>>2]=h;s=0;do{n=s;s=n+1|0;}while((a[E+n|0]|0)!=0);r=s+(c[e+20>>2]|0)+h|0;if((r|0)>(c[e+24>>2]|0)){F=pe[c[k+12>>2]&127](r+24|0)|0;if((F|0)==0){p=1;q=p;i=j;return q|0}c[e+24>>2]=r+24;Aqb(F|0,c[e+16>>2]|0,c[e+20>>2]|0)|0;r=c[k+364>>2]|0;while(1){if((r|0)==0){break}if((c[r+12>>2]|0)==(c[e+16>>2]|0)){c[r+12>>2]=F}r=c[r>>2]|0}me[c[k+20>>2]&2047](c[e+16>>2]|0);c[e+16>>2]=F}F=(c[e+16>>2]|0)+(c[e+20>>2]|0)|0;Aqb(F|0,E|0,s|0)|0;if((h|0)!=0){F=F+(s-1)|0;a[F]=a[k+472|0]|0;Aqb(F+1|0,c[c[e>>2]>>2]|0,h|0)|0}c[f>>2]=c[e+16>>2];p=0;q=p;i=j;return q|0}return 0}function iTa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+56|0;h=g+40|0;j=b;b=d;d=e;e=f;c[j+280>>2]=43;c[j+288>>2]=b;a:while(1){c[h>>2]=0;f=Oe[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;c[j+292>>2]=c[h>>2];b:do{switch(f|0){case-15:{k=3;break a;break};case-2:{k=18;break a;break};case-1:{k=15;break a;break};case 0:{k=14;break a;break};case-4:{k=7;break a;break};case 15:{if((c[j+80>>2]|0)==0){break b}zSa(j,c[j+144>>2]|0,b,c[h>>2]|0);break};case 11:{if((aTa(j,c[j+144>>2]|0,b,c[h>>2]|0)|0)==0){k=11;break a}break};case 13:{if((bTa(j,c[j+144>>2]|0,b,c[h>>2]|0)|0)==0){k=13;break a}break};default:{k=21;break a}}}while(0);f=c[h>>2]|0;b=f;c[j+288>>2]=f;f=c[j+480>>2]|0;if((f|0)==3){k=23;break}else if((f|0)==2){k=24;break}}if((k|0)==3){do{if((c[j+80>>2]|0)!=0){zSa(j,c[j+144>>2]|0,b,c[h>>2]|0);if((c[j+480>>2]|0)!=2){break}l=35;m=l;i=g;return m|0}}while(0);c[e>>2]=c[h>>2];l=0;m=l;i=g;return m|0}else if((k|0)==7){c[e>>2]=b;l=0;m=l;i=g;return m|0}else if((k|0)==11){l=1;m=l;i=g;return m|0}else if((k|0)==13){l=1;m=l;i=g;return m|0}else if((k|0)==14){c[j+288>>2]=c[h>>2];l=4;m=l;i=g;return m|0}else if((k|0)==15){if((a[j+484|0]|0)!=0){l=5;m=l;i=g;return m|0}else{c[e>>2]=b;l=0;m=l;i=g;return m|0}}else if((k|0)==18){if((a[j+484|0]|0)!=0){l=6;m=l;i=g;return m|0}else{c[e>>2]=b;l=0;m=l;i=g;return m|0}}else if((k|0)==21){l=9;m=l;i=g;return m|0}else if((k|0)==23){c[e>>2]=c[h>>2];l=0;m=l;i=g;return m|0}else if((k|0)==24){l=35;m=l;i=g;return m|0}return 0}function jTa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;i=i+120|0;k=j+56|0;l=j+80|0;m=j+96|0;n=j+112|0;o=b;b=d;d=e;e=f;f=g;g=h;c[k>>2]=c[d>>2];h=o;if((b|0)==(c[o+144>>2]|0)){p=h+288|0;c[p>>2]=c[k>>2];q=o+292|0}else{p=c[h+300>>2]|0;q=(c[o+300>>2]|0)+4|0}c[p>>2]=c[k>>2];c[d>>2]=0;a:while(1){h=Oe[c[b+8>>2]&63](b,c[k>>2]|0,e,l)|0;c[q>>2]=c[l>>2];b:do{switch(h|0){case 0:{r=24;break a;break};case-2:{r=25;break a;break};case 7:{if((c[o+60>>2]|0)!=0){a[m]=10;Le[c[o+60>>2]&15](c[o+4>>2]|0,m,1);break b}if((c[o+80>>2]|0)==0){break b}zSa(o,b,c[k>>2]|0,c[l>>2]|0);break};case 40:{r=6;break a;break};case 6:{s=c[o+60>>2]|0;if((s|0)==0){if((c[o+80>>2]|0)==0){break b}zSa(o,b,c[k>>2]|0,c[l>>2]|0);break b}if((a[b+72|0]|0)!=0){Le[s&15](c[o+4>>2]|0,c[k>>2]|0,(c[l>>2]|0)-(c[k>>2]|0)|0);break b}while(1){c[n>>2]=c[o+44>>2];je[c[b+60>>2]&31](b,k,c[l>>2]|0,n,c[o+48>>2]|0);c[q>>2]=c[l>>2];Le[s&15](c[o+4>>2]|0,c[o+44>>2]|0,(c[n>>2]|0)-(c[o+44>>2]|0)|0);if((c[k>>2]|0)==(c[l>>2]|0)){break b}c[p>>2]=c[k>>2]}break};case-4:case-1:{r=28;break a;break};default:{r=31;break a}}}while(0);h=c[l>>2]|0;c[k>>2]=h;c[p>>2]=h;h=c[o+480>>2]|0;if((h|0)==2){r=34;break}else if((h|0)==3){r=33;break}}if((r|0)==6){n=o;do{if((c[o+76>>2]|0)!=0){me[c[n+76>>2]&2047](c[o+4>>2]|0)}else{if((c[n+80>>2]|0)==0){break}zSa(o,b,c[k>>2]|0,c[l>>2]|0)}}while(0);c[d>>2]=c[l>>2];c[f>>2]=c[l>>2];if((c[o+480>>2]|0)==2){t=35;u=t;i=j;return u|0}else{t=0;u=t;i=j;return u|0}}else if((r|0)==24){c[p>>2]=c[l>>2];t=4;u=t;i=j;return u|0}else if((r|0)==25){if(g<<24>>24!=0){c[f>>2]=c[k>>2];t=0;u=t;i=j;return u|0}else{t=6;u=t;i=j;return u|0}}else if((r|0)==28){if(g<<24>>24!=0){c[f>>2]=c[k>>2];t=0;u=t;i=j;return u|0}else{t=20;u=t;i=j;return u|0}}else if((r|0)==31){c[p>>2]=c[l>>2];t=23;u=t;i=j;return u|0}else if((r|0)==33){c[f>>2]=c[l>>2];t=0;u=t;i=j;return u|0}else if((r|0)==34){t=35;u=t;i=j;return u|0}return 0}function kTa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=g+16|0;j=b;c[h>>2]=d;d=e;e=f;f=jTa(j,c[j+144>>2]|0,h,d,e,((a[j+484|0]|0)!=0^1)&1)|0;if((f|0)!=0){k=f;l=k;i=g;return l|0}if((c[h>>2]|0)==0){k=f;l=k;i=g;return l|0}f=j+280|0;if((c[j+476>>2]|0)!=0){c[f>>2]=44;k=lTa(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}else{c[f>>2]=38;k=PSa(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}return 0}function lTa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=eTa(h,1,c[h+144>>2]|0,d,e,f,((a[h+484|0]|0)!=0^1)&1)|0;do{if((b|0)==0){if((mTa(h)|0)<<24>>24!=0){break}j=1;k=j;i=g;return k|0}}while(0);j=b;k=j;i=g;return k|0}function mTa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+56|0;d=a;a=c[d+364>>2]|0;while(1){if((a|0)==0){e=13;break}f=(c[a+24>>2]|0)+1|0;g=(c[a+36>>2]|0)+f|0;if((c[a+4>>2]|0)==(g|0)){e=13;break}h=f+((c[a+8>>2]|0)+0)|0;if((h|0)>((c[a+40>>2]|0)-(c[a+36>>2]|0)|0)){j=Ee[c[d+16>>2]&63](c[a+36>>2]|0,h)|0;if((j|0)==0){e=6;break}if((c[a+12>>2]|0)==(c[a+36>>2]|0)){c[a+12>>2]=j}if((c[a+16>>2]|0)!=0){c[a+16>>2]=j+((c[a+16>>2]|0)-(c[a+36>>2]|0))}c[a+36>>2]=j;c[a+40>>2]=j+h;g=j+f|0}Aqb(g|0,c[a+4>>2]|0,c[a+8>>2]|0)|0;c[a+4>>2]=g;a=c[a>>2]|0}if((e|0)==6){k=0;l=k;i=b;return l|0}else if((e|0)==13){k=1;l=k;i=b;return l|0}return 0}function nTa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+56|0;f=b;b=d;d=c[f+356>>2]|0;g=c[b>>2]|0;a:while(1){if((a[g]|0)==0){h=20;break}if((a[g]|0)==58){j=c[b>>2]|0;while(1){k=(c[d+92>>2]|0)==(c[d+88>>2]|0);if((j|0)==(g|0)){break}if(k){if(!((BSa(d+80|0)|0)<<24>>24!=0)){h=9;break a}}l=a[j]|0;m=d+92|0;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;j=j+1|0}if(k){if(!((BSa(d+80|0)|0)<<24>>24!=0)){h=13;break}}j=d+92|0;l=c[j>>2]|0;c[j>>2]=l+1;a[l]=0;l=ESa(f,d+60|0,c[d+96>>2]|0,8)|0;if((l|0)==0){h=14;break}j=d+80|0;if((c[l>>2]|0)==(c[d+96>>2]|0)){c[d+96>>2]=c[j+12>>2]}else{c[d+92>>2]=c[j+16>>2]}c[b+4>>2]=l}g=g+1|0}if((h|0)==9){o=0;p=o;i=e;return p|0}else if((h|0)==13){o=0;p=o;i=e;return p|0}else if((h|0)==14){o=0;p=o;i=e;return p|0}else if((h|0)==20){o=1;p=o;i=e;return p|0}return 0}function oTa(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;k=i;i=i+152|0;l=k+64|0;m=k+80|0;n=b;b=e;e=f;f=g;g=h;h=j;j=c[n+356>>2]|0;a:while(1){b:do{switch(Oe[c[b+16>>2]&63](b,f,g,l)|0){case-3:{c[l>>2]=f+(c[b+68>>2]|0);o=31;break};case-4:{o=3;break a;break};case 7:case 39:{o=31;break};case 10:{p=Ee[c[b+44>>2]&63](b,f)|0;if((p|0)<0){o=11;break a}do{if(!(e<<24>>24!=0)){if((p|0)!=32){break}if(((c[h+12>>2]|0)-(c[h+16>>2]|0)|0)==0){break b}if((a[(c[h+12>>2]|0)+ -1|0]|0)==32){break b}}}while(0);p=vTa(p,m)|0;if((p|0)==0){o=19;break a}q=0;while(1){if((q|0)>=(p|0)){break b}if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((BSa(h)|0)<<24>>24!=0)){o=27;break a}}r=a[m+q|0]|0;s=h+12|0;t=c[s>>2]|0;c[s>>2]=t+1;a[t]=r;q=q+1|0}break};case 9:{q=(se[c[b+48>>2]&63](b,f+(c[b+68>>2]|0)|0,(c[l>>2]|0)+(0-(c[b+68>>2]|0))|0)|0)&255;if(q<<24>>24!=0){if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((BSa(h)|0)<<24>>24!=0)){o=42;break a}}p=h+12|0;r=c[p>>2]|0;c[p>>2]=r+1;a[r]=q;break b}q=NSa(n+440|0,b,f+(c[b+68>>2]|0)|0,(c[l>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((q|0)==0){o=44;break a}r=ESa(n,j,q,0)|0;c[n+452>>2]=c[n+456>>2];if((h|0)==(j+80|0)){if((c[n+272>>2]|0)!=0){if((d[j+130|0]|0)!=0){u=(c[n+300>>2]|0)!=0}else{u=(a[j+129|0]|0)!=0}v=((u^1)&1|0)!=0}else{v=0}w=v&1}else{if((a[j+129|0]|0)!=0){x=(d[j+130|0]|0)!=0}else{x=1}w=x&1}q=(r|0)!=0;if(w<<24>>24!=0){if(!q){o=57;break a}if((a[r+34|0]|0)==0){o=59;break a}}else{if(!q){break b}}if((a[r+32|0]|0)!=0){o=62;break a}if((c[r+28>>2]|0)!=0){o=66;break a}if((c[r+4>>2]|0)==0){o=70;break a}q=(c[r+4>>2]|0)+(c[r+8>>2]|0)|0;a[r+32|0]=1;y=oTa(n,c[n+228>>2]|0,e,c[r+4>>2]|0,q,h)|0;a[r+32|0]=0;if((y|0)!=0){o=74;break a}break};case-1:{o=7;break a;break};case 0:{o=4;break a;break};case 6:{if((TSa(h,b,f,c[l>>2]|0)|0)==0){o=29;break a}break};default:{o=75;break a}}}while(0);do{if((o|0)==31){o=0;if(!(e<<24>>24!=0)){if(((c[h+12>>2]|0)-(c[h+16>>2]|0)|0)==0){break}if((a[(c[h+12>>2]|0)+ -1|0]|0)==32){break}}if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((BSa(h)|0)<<24>>24!=0)){o=37;break a}}r=h+12|0;q=c[r>>2]|0;c[r>>2]=q+1;a[q]=32}}while(0);f=c[l>>2]|0}if((o|0)==3){z=0;A=z;i=k;return A|0}else if((o|0)==4){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=c[l>>2]}z=4;A=z;i=k;return A|0}else if((o|0)==7){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=4;A=z;i=k;return A|0}else if((o|0)==11){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=14;A=z;i=k;return A|0}else if((o|0)==19){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=14;A=z;i=k;return A|0}else if((o|0)==27){z=1;A=z;i=k;return A|0}else if((o|0)==29){z=1;A=z;i=k;return A|0}else if((o|0)==37){z=1;A=z;i=k;return A|0}else if((o|0)==42){z=1;A=z;i=k;return A|0}else if((o|0)==44){z=1;A=z;i=k;return A|0}else if((o|0)==57){z=11;A=z;i=k;return A|0}else if((o|0)==59){z=24;A=z;i=k;return A|0}else if((o|0)==62){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=12;A=z;i=k;return A|0}else if((o|0)==66){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=15;A=z;i=k;return A|0}else if((o|0)==70){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=16;A=z;i=k;return A|0}else if((o|0)==74){z=y;A=z;i=k;return A|0}else if((o|0)==75){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=23;A=z;i=k;return A|0}return 0}function pTa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+1080|0;f=e+24|0;g=b;b=d;do{if((c[g+124>>2]|0)!=0){d=0;while(1){if((d|0)>=256){break}c[f+(d<<2)>>2]=-1;d=d+1|0}c[f+1028>>2]=0;c[f+1024>>2]=0;c[f+1032>>2]=0;do{if((se[c[g+124>>2]&63](c[g+248>>2]|0,b,f)|0)!=0){d=c[g+12>>2]|0;h=wTa()|0;c[g+240>>2]=pe[d&127](h)|0;if((c[g+240>>2]|0)!=0){h=Oe[((a[g+236|0]&255|0)!=0?45:46)&63](c[g+240>>2]|0,f,c[f+1028>>2]|0,c[f+1024>>2]|0)|0;if((h|0)==0){break}c[g+244>>2]=c[f+1024>>2];c[g+252>>2]=c[f+1032>>2];c[g+144>>2]=h;j=0;k=j;i=e;return k|0}if((c[f+1032>>2]|0)!=0){me[c[f+1032>>2]&2047](c[f+1024>>2]|0)}j=1;k=j;i=e;return k|0}}while(0);if((c[f+1032>>2]|0)==0){break}me[c[f+1032>>2]&2047](c[f+1024>>2]|0)}}while(0);j=18;k=j;i=e;return k|0}function qTa(){var a=0,b=0;a=i;i=i+8|0;fc(((vc(0)|0)>>>0)%4294967295|0|0);b=Gqb()|0;i=a;return b|0}function rTa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+48|0;g=a;a=JSa(g)|0;if((a|0)!=0){h=a;j=h;i=f;return j|0}else{c[g+280>>2]=40;h=KSa(g,b,d,e)|0;j=h;i=f;return j|0}return 0}function sTa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=pe[c[e>>2]&127](188)|0;f=b;if((b|0)==0){g=f;h=g;i=d;return h|0}else{tTa(f+80|0,e);tTa(b+104|0,e);uTa(b,e);uTa(b+20|0,e);uTa(b+40|0,e);uTa(b+60|0,e);a[b+131|0]=0;uTa(b+132|0,e);c[b+152>>2]=0;c[b+156>>2]=0;a[b+160|0]=0;c[b+184>>2]=0;c[b+164>>2]=0;c[b+180>>2]=0;c[b+172>>2]=0;c[b+176>>2]=0;c[b+168>>2]=0;a[b+128|0]=1;a[b+129|0]=0;a[b+130|0]=0;g=b;h=g;i=d;return h|0}return 0}function tTa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=a;c[e>>2]=0;c[e+4>>2]=0;c[e+16>>2]=0;c[e+12>>2]=0;c[e+8>>2]=0;c[e+20>>2]=b;i=d;return}function uTa(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=b;a[f+4|0]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f>>2]=0;c[f+16>>2]=d;i=e;return}function vTa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=c;if((e|0)<0){f=0;g=f;i=d;return g|0}c=e;if((e|0)<128){a[b]=c;f=1;g=f;i=d;return g|0}h=e;if((c|0)<2048){a[b]=h>>6|192;a[b+1|0]=e&63|128;f=2;g=f;i=d;return g|0}c=e;if((h|0)<65536){a[b]=c>>12|224;a[b+1|0]=e>>6&63|128;a[b+2|0]=e&63|128;f=3;g=f;i=d;return g|0}if((c|0)<1114112){a[b]=e>>18|240;a[b+1|0]=e>>12&63|128;a[b+2|0]=e>>6&63|128;a[b+3|0]=e&63|128;f=4;g=f;i=d;return g|0}else{f=0;g=f;i=d;return g|0}return 0}function wTa(){i=i;return 1912}function xTa(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+64|0;k=e;e=f;f=g;g=h;h=k;l=0;while(1){if((l|0)>=368){break}a[k+l|0]=a[237344+l|0]|0;l=l+1|0}l=0;a:while(1){if((l|0)>=128){break}do{if((d[237420+l|0]|0|0)!=28){if((d[237420+l|0]|0|0)==0){break}if((c[e+(l<<2)>>2]|0)!=(l|0)){m=9;break a}}}while(0);l=l+1|0}if((m|0)==9){n=0;o=n;i=j;return o|0}l=0;b:while(1){if((l|0)>=256){m=36;break}k=c[e+(l<<2)>>2]|0;do{if((k|0)==-1){a[h+76+l|0]=1;b[h+376+(l<<1)>>1]=-1;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=0}else{p=k;if((k|0)<0){if((p|0)<-4){m=17;break b}a[h+76+l|0]=5-(k+2);a[h+888+(l<<2)|0]=0;b[h+376+(l<<1)>>1]=0;break}q=k;if((p|0)<128){do{if((d[237420+q|0]|0|0)!=28){if((d[237420+k|0]|0|0)==0){break}if((k|0)!=(l|0)){m=23;break b}}}while(0);a[h+76+l|0]=a[237420+k|0]|0;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=k;b[h+376+(l<<1)>>1]=(k|0)==0?65535:k;break}if((yTa(q)|0)<0){a[h+76+l|0]=0;b[h+376+(l<<1)>>1]=-1;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=0;break}if((k|0)>65535){m=28;break b}do{if((c[231512+(((d[231256+(k>>8)|0]|0)<<3)+((k&255)>>5)<<2)>>2]&1<<(k&31)|0)!=0){a[h+76+l|0]=22}else{p=h+76+l|0;if((c[231512+(((d[232792+(k>>8)|0]|0)<<3)+((k&255)>>5)<<2)>>2]&1<<(k&31)|0)!=0){a[p]=26;break}else{a[p]=28;break}}}while(0);a[h+888+(l<<2)|0]=vTa(k,h+888+(l<<2)+1|0)|0;b[h+376+(l<<1)>>1]=k}}while(0);l=l+1|0}if((m|0)==17){n=0;o=n;i=j;return o|0}else if((m|0)==23){n=0;o=n;i=j;return o|0}else if((m|0)==28){n=0;o=n;i=j;return o|0}else if((m|0)==36){c[h+372>>2]=g;c[h+368>>2]=f;if((f|0)!=0){c[h+332>>2]=50;c[h+336>>2]=50;c[h+340>>2]=50;c[h+344>>2]=51;c[h+348>>2]=51;c[h+352>>2]=51;c[h+356>>2]=52;c[h+360>>2]=52;c[h+364>>2]=52}c[h+60>>2]=13;c[h+64>>2]=14;n=h;o=n;i=j;return o|0}return 0}function yTa(a){a=a|0;var b=0,c=0,e=0,f=0;b=i;i=i+16|0;c=a;a:do{switch(c>>8|0){case 223:case 222:case 221:case 220:case 219:case 218:case 217:case 216:{e=-1;break};case 0:{if((d[237420+c|0]|0|0)!=0){f=7;break a}e=-1;break};case 255:{if(!((c|0)==65534|(c|0)==65535)){f=7;break a}e=-1;break};default:{f=7}}}while(0);if((f|0)==7){e=c}i=b;return e|0}function zTa(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+40|0;f=a;a=Ee[c[f+368>>2]&63](c[f+372>>2]|0,b)|0;if((a&-65536|0)!=0){g=0;h=g;i=e;return h|0}else{g=c[231512+(((d[232792+(a>>8)|0]|0)<<3)+((a&255)>>5)<<2)>>2]&1<<(a&31);h=g;i=e;return h|0}return 0}function ATa(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+40|0;f=a;a=Ee[c[f+368>>2]&63](c[f+372>>2]|0,b)|0;if((a&-65536|0)!=0){g=0;h=g;i=e;return h|0}else{g=c[231512+(((d[231256+(a>>8)|0]|0)<<3)+((a&255)>>5)<<2)>>2]&1<<(a&31);h=g;i=e;return h|0}return 0}function BTa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=a;a=Ee[c[e+368>>2]&63](c[e+372>>2]|0,b)|0;if((a&-65536|0)!=0){f=1;g=f&1;i=d;return g|0}f=(yTa(a)|0)<0;g=f&1;i=d;return g|0}function CTa(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i;i=i+80|0;k=j+48|0;l=b;b=e;e=f;f=g;g=h;h=l;a:while(1){if((c[b>>2]|0)==(e|0)){m=9;break}n=h+888+(d[c[b>>2]|0]<<2)|0;o=n;n=o+1|0;p=a[o]|0;if((p|0)==0){p=vTa(Ee[c[h+368>>2]&63](c[h+372>>2]|0,c[b>>2]|0)|0,k)|0;if((p|0)>(g-(c[f>>2]|0)|0)){m=9;break}n=k;o=b;c[o>>2]=(c[o>>2]|0)+((d[l+76+(d[c[b>>2]|0]|0)|0]|0)-3)}else{if((p|0)>(g-(c[f>>2]|0)|0)){m=9;break}o=b;c[o>>2]=(c[o>>2]|0)+1}while(1){o=n;n=o+1|0;q=a[o]|0;o=f;r=c[o>>2]|0;c[o>>2]=r+1;a[r]=q;q=p+ -1|0;p=q;if((q|0)==0){continue a}}}if((m|0)==9){i=j;return}}function DTa(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+56|0;k=a;a=e;e=f;f=g;g=h;h=k;while(1){if((c[a>>2]|0)==(e|0)){l=8;break}if((c[f>>2]|0)==(g|0)){l=8;break}m=b[h+376+((d[c[a>>2]|0]|0)<<1)>>1]|0;if((m&65535|0)==0){m=(Ee[c[h+368>>2]&63](c[h+372>>2]|0,c[a>>2]|0)|0)&65535;n=a;c[n>>2]=(c[n>>2]|0)+((d[k+76+(d[c[a>>2]|0]|0)|0]|0)-3)}else{n=a;c[n>>2]=(c[n>>2]|0)+1}n=f;o=c[n>>2]|0;c[n>>2]=o+2;b[o>>1]=m}if((l|0)==8){i=j;return}}function ETa(){i=i;return 236976}function FTa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+40|0;g=b;b=d;d=GTa(e)|0;if((d|0)==-1){h=0;j=h;i=f;return j|0}else{a[g+73|0]=d;c[g>>2]=47;c[g+4>>2]=48;c[g+52>>2]=81;c[g+76>>2]=b;c[b>>2]=g;h=1;j=h;i=f;return j|0}return 0}function GTa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+24|0;d=a;if((d|0)==0){e=6;f=e;i=b;return f|0}a=0;while(1){if((a|0)>=6){g=8;break}h=a;if((UTa(d,c[236880+(a<<2)>>2]|0)|0)!=0){g=6;break}a=h+1|0}if((g|0)==6){e=h;f=e;i=b;return f|0}else if((g|0)==8){e=-1;f=e;i=b;return f|0}return 0}function HTa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=SVa(235320,a,0,b,c,d)|0;i=e;return f|0}function ITa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=SVa(235320,a,1,b,c,d)|0;i=e;return f|0}function JTa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=i;i=i+32|0;pVa(236088,b,c,d);i=a;return}function KTa(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+80|0;m=LTa(36,a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function LTa(a,b,d,e,f,g,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;n=i;i=i+128|0;o=n+32|0;p=n+96|0;q=n+104|0;r=n+112|0;s=a;a=b;b=d;c[o>>2]=e;e=f;f=g;g=h;h=j;j=k;k=l;l=m;c[p>>2]=0;c[q>>2]=0;c[r>>2]=0;c[o>>2]=(c[o>>2]|0)+((c[b+68>>2]|0)*5|0);e=e+(0-(c[b+68>>2]<<1))|0;m=(TVa(b,c[o>>2]|0,e,q,r,p,o)|0)!=0;if(!(m&(c[q>>2]|0)!=0)){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}do{if((Oe[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,236824)|0)!=0){if((g|0)!=0){c[g>>2]=c[p>>2]}if((h|0)!=0){c[h>>2]=c[o>>2]}if((TVa(b,c[o>>2]|0,e,q,r,p,o)|0)==0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}if((c[q>>2]|0)!=0){break}if((a|0)!=0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}else{t=1;u=t;i=n;return u|0}}else{if((a|0)!=0){break}c[f>>2]=c[q>>2];t=0;u=t;i=n;return u|0}}while(0);do{if((Oe[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,236832)|0)!=0){h=UVa(b,c[p>>2]|0,e)|0;do{if(!(97<=(h|0)&(h|0)<=122)){if(65<=(h|0)&(h|0)<=90){break}c[f>>2]=c[p>>2];t=0;u=t;i=n;return u|0}}while(0);if((j|0)!=0){c[j>>2]=c[p>>2]}if((k|0)!=0){c[k>>2]=se[s&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0)|0}if((TVa(b,c[o>>2]|0,e,q,r,p,o)|0)==0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}if((c[q>>2]|0)!=0){break}t=1;u=t;i=n;return u|0}}while(0);do{if((Oe[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,236848)|0)!=0){if((a|0)!=0){break}do{if((Oe[c[b+28>>2]&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0,236864)|0)!=0){if((l|0)==0){break}c[l>>2]=1}else{if((Oe[c[b+28>>2]&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0,236872)|0)!=0){if((l|0)==0){break}c[l>>2]=0;break}else{c[f>>2]=c[p>>2];t=0;u=t;i=n;return u|0}}}while(0);while(1){if((VVa(UVa(b,c[o>>2]|0,e)|0)|0)==0){break}c[o>>2]=(c[o>>2]|0)+(c[b+68>>2]|0)}if((c[o>>2]|0)!=(e|0)){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}else{t=1;u=t;i=n;return u|0}}}while(0);c[f>>2]=c[q>>2];t=0;u=t;i=n;return u|0}function MTa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+176|0;g=f+16|0;h=f+32|0;j=f+160|0;k=b;c[g>>2]=d;d=e;c[j>>2]=h;je[c[k+60>>2]&31](k,g,d,j,(c[j>>2]|0)+128+ -1|0);if((c[g>>2]|0)!=(d|0)){l=0;m=l;i=f;return m|0}a[c[j>>2]|0]=0;do{if((UTa(h,233048)|0)!=0){if((c[k+68>>2]|0)!=2){break}l=k;m=l;i=f;return m|0}}while(0);k=GTa(h)|0;if((k|0)==-1){l=0;m=l;i=f;return m|0}else{l=c[235320+(k<<2)>>2]|0;m=l;i=f;return m|0}return 0}function NTa(){i=i;return 234952}function OTa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+40|0;g=b;b=d;d=GTa(e)|0;if((d|0)==-1){h=0;j=h;i=f;return j|0}else{a[g+73|0]=d;c[g>>2]=49;c[g+4>>2]=50;c[g+52>>2]=81;c[g+76>>2]=b;c[b>>2]=g;h=1;j=h;i=f;return j|0}return 0}function PTa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=SVa(233056,a,0,b,c,d)|0;i=e;return f|0}function QTa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=SVa(233056,a,1,b,c,d)|0;i=e;return f|0}function RTa(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+80|0;m=LTa(37,a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function STa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+176|0;g=f+16|0;h=f+32|0;j=f+160|0;k=b;c[g>>2]=d;d=e;c[j>>2]=h;je[c[k+60>>2]&31](k,g,d,j,(c[j>>2]|0)+128+ -1|0);if((c[g>>2]|0)!=(d|0)){l=0;m=l;i=f;return m|0}a[c[j>>2]|0]=0;do{if((UTa(h,233048)|0)!=0){if((c[k+68>>2]|0)!=2){break}l=k;m=l;i=f;return m|0}}while(0);k=GTa(h)|0;if((k|0)==-1){l=0;m=l;i=f;return m|0}else{l=c[233056+(k<<2)>>2]|0;m=l;i=f;return m|0}return 0}function TTa(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+40|0;g=xTa(b,c,d,e)|0;if((g|0)==0){h=g;i=f;return h|0}a[g+134|0]=23;h=g;i=f;return h|0}function UTa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+40|0;e=b;b=c;while(1){c=e;e=c+1|0;f=a[c]|0;c=b;b=c+1|0;g=a[c]|0;do{if(97<=(f<<24>>24|0)){if((f<<24>>24|0)>122){break}f=(f<<24>>24)+ -32&255}}while(0);do{if(97<=(g<<24>>24|0)){if((g<<24>>24|0)>122){break}g=(g<<24>>24)+ -32&255}}while(0);if((f<<24>>24|0)!=(g<<24>>24|0)){h=9;break}if(!(f<<24>>24!=0)){h=11;break}}if((h|0)==9){j=0;k=j;i=d;return k|0}else if((h|0)==11){j=1;k=j;i=d;return k|0}return 0}function VTa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=kUa(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 36:{c[f>>2]=b+2;k=21;l=k;i=h;return l|0};case 19:{k=yUa(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 23:case 27:case 26:case 25:{n=19;b=b+2|0;o=77;break};case 24:case 22:{n=18;b=b+2|0;o=77;break};case 30:{k=mUa(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 9:{if((b+2|0)!=(e|0)){o=25;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 32:{b=b+2|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[g]|0)|0]|0}else{p=kUa(a[g+1|0]|0,a[b]|0)|0}switch(p|0){case 34:{c[f>>2]=b+2;k=37;l=k;i=h;return l|0};case 15:{c[f>>2]=b+2;k=35;l=k;i=h;return l|0};case 33:{c[f>>2]=b+2;k=36;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 35:{c[f>>2]=b+2;k=38;l=k;i=h;return l|0};case 31:{c[f>>2]=b+2;k=23;l=k;i=h;return l|0};case 13:{k=wUa(13,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 10:case 21:{o=25;break};case 2:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[g]|0)|0]|0}else{q=kUa(a[g+1|0]|0,a[b]|0)|0}switch(q|0){case 16:{k=xUa(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 15:{k=sUa(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -2;k=29;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 29:{g=b;if((c[231512+((d[231256+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){b=g+2|0;n=18;o=77;break a}if((c[231512+((d[232792+(d[g+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=76;break a}b=b+2|0;n=19;o=77;break};case 11:{c[f>>2]=b+2;k=17;l=k;i=h;return l|0};case 12:{k=wUa(12,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 20:{c[f>>2]=b+2;k=25;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=93){break}if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+3|0]|0)!=0){break}if((a[b+2|0]|0)!=62){break}c[f>>2]=b+4;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};default:{o=76}}}while(0);if((o|0)==25){while(1){o=0;b=b+2|0;r=b;if((b|0)==(e|0)){o=32;break}q=b;if((a[r+1|0]|0)==0){s=d[j+76+(d[q]|0)|0]|0}else{s=kUa(a[q+1|0]|0,a[b]|0)|0}if((s|0)==10|(s|0)==21){o=25;continue}else if((s|0)!=9){o=31;break}if((b+2|0)!=(e|0)){o=25}else{o=31;break}}if((o|0)==31){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((o|0)==32){c[f>>2]=r;k=15;l=k;i=h;return l|0}}else if((o|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==77){b:while(1){o=0;if((b|0)==(e|0)){o=126;break}r=b;if((a[b+1|0]|0)==0){t=d[j+76+(d[r]|0)|0]|0}else{t=kUa(a[r+1|0]|0,a[b]|0)|0}switch(t|0){case 5:{o=85;break b;break};case 29:{if((c[231512+((d[232792+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=83;break b}break};case 34:{o=116;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{o=91;break b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{o=94;break b;break};case 15:{o=122;break b;break};case 23:{b=b+2|0;r=n;if((r|0)==41){n=19;o=77;continue b}else if((r|0)!=18){o=77;continue b}if((b|0)==(e|0)){o=97;break b}n=41;r=b;if((a[b+1|0]|0)==0){u=d[j+76+(d[r]|0)|0]|0}else{u=kUa(a[r+1|0]|0,a[b]|0)|0}switch(u|0){case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[231512+((d[232792+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=103;break b}break};case 6:{o=108;break b;break};case 5:{o=105;break b;break};case 7:{o=111;break b;break};default:{n=19;o=77;continue b}}b=b+2|0;o=77;continue b;break};case 6:{o=88;break b;break};case 33:{o=119;break b;break};default:{o=125;break b}}b=b+2|0;o=77}if((o|0)==83){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==85){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==91){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==94){c[f>>2]=b;k=n;l=k;i=h;return l|0}else if((o|0)==97){k=-1;l=k;i=h;return l|0}else if((o|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==105){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==108){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==111){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==116){e=b;if((n|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=32;l=k;i=h;return l|0}}else if((o|0)==119){e=b;if((n|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=31;l=k;i=h;return l|0}}else if((o|0)==122){e=b;if((n|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=30;l=k;i=h;return l|0}}else if((o|0)==125){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==126){k=0-n|0;l=k;i=h;return l|0}}return 0}function WTa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=kUa(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=kUa(a[g+1|0]|0,a[b]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 2:{k=pUa(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 3:{k=lUa(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b+1|0]|0)!=0){break a}if((a[b]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=68;break}n=b;if((a[o+1|0]|0)==0){q=d[j+76+(d[n]|0)|0]|0}else{q=kUa(a[n+1|0]|0,a[b]|0)|0}switch(q|0){case 5:{r=b;if((e-b|0)<2){p=49;break b}b=r+2|0;continue b;break};case 6:{s=b;if((e-b|0)<3){p=52;break b}b=s+3|0;continue b;break};case 7:{t=b;if((e-b|0)<4){p=55;break b}b=t+4|0;continue b;break};case 4:{if((b+2|0)==(e|0)){p=66;break b}do{if((a[b+3|0]|0)==0){if((a[b+2|0]|0)!=93){break}if((b+4|0)==(e|0)){p=66;break b}if((a[b+5|0]|0)==0){if((a[b+4|0]|0)==62){p=65;break b}}b=b+2|0;continue b}}while(0);b=b+2|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{p=66;break b;break};default:{b=b+2|0;continue b}}}if((p|0)==49){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==52){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==65){c[f>>2]=b+4;k=0;l=k;i=h;return l|0}else if((p|0)==66){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==68){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function XTa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=kUa(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+1|0]|0)!=0){break a}if((a[b]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;k=40;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=kUa(a[g+1|0]|0,a[b]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=57;break}n=b;if((a[o+1|0]|0)==0){q=d[j+76+(d[n]|0)|0]|0}else{q=kUa(a[n+1|0]|0,a[b]|0)|0}switch(q|0){case 6:{r=b;if((e-b|0)<3){p=50;break b}b=r+3|0;continue b;break};case 5:{s=b;if((e-b|0)<2){p=47;break b}b=s+2|0;continue b;break};case 4:case 10:case 9:case 8:case 1:case 0:{p=55;break b;break};case 7:{t=b;if((e-b|0)<4){p=53;break b}b=t+4|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==47){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==50){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==53){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==57){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function YTa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=0;k=e-b|0;if((k&1|0)!=0){k=k&-2;e=b+k|0}a:while(1){if((b|0)==(e|0)){l=39;break}k=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[k]|0)|0]|0}else{m=kUa(a[k+1|0]|0,a[b]|0)|0}switch(m|0){case 8:case 1:case 0:{l=17;break a;break};case 2:{k=b+2|0;b=k;if((k|0)==(e|0)){l=19;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=33){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=23;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=91){continue a}g=g+1|0;b=b+2|0;continue a;break};case 6:{if((e-b|0)<3){l=12;break a}b=b+3|0;continue a;break};case 7:{if((e-b|0)<4){l=15;break a}b=b+4|0;continue a;break};case 4:{k=b+2|0;b=k;if((k|0)==(e|0)){l=28;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=93){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=32;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=62){continue a}b=b+2|0;if((g|0)==0){l=36;break a}g=g+ -1|0;continue a;break};case 5:{if((e-b|0)<2){l=9;break a}b=b+2|0;continue a;break};default:{b=b+2|0;continue a}}}if((l|0)==9){n=-2;o=n;i=h;return o|0}else if((l|0)==12){n=-2;o=n;i=h;return o|0}else if((l|0)==15){n=-2;o=n;i=h;return o|0}else if((l|0)==17){c[f>>2]=b;n=0;o=n;i=h;return o|0}else if((l|0)==19){n=-1;o=n;i=h;return o|0}else if((l|0)==23){n=-1;o=n;i=h;return o|0}else if((l|0)==28){n=-1;o=n;i=h;return o|0}else if((l|0)==32){n=-1;o=n;i=h;return o|0}else if((l|0)==36){c[f>>2]=b;n=42;o=n;i=h;return o|0}else if((l|0)==39){n=-1;o=n;i=h;return o|0}return 0}function ZTa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=33;break}o=b;if((a[m+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=kUa(a[o+1|0]|0,a[b]|0)|0}switch(p|0){case 6:{b=b+3|0;continue a;break};case 7:{b=b+4|0;continue a;break};case 2:{n=15;break a;break};case 21:{n=29;break a;break};case 9:{n=19;break a;break};case 10:{n=16;break a;break};case 5:{b=b+2|0;continue a;break};case 3:{n=12;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=lUa(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==16){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==19){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[e]|0)|0]|0}else{q=kUa(a[e+1|0]|0,a[b]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==29){q=b;if((b|0)==(g|0)){c[f>>2]=q+2;k=39;l=k;i=h;return l|0}else{c[f>>2]=q;k=6;l=k;i=h;return l|0}}else if((n|0)==33){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function _Ta(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=32;break}o=b;if((a[m+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=kUa(a[o+1|0]|0,a[b]|0)|0}switch(p|0){case 6:{b=b+3|0;continue a;break};case 7:{b=b+4|0;continue a;break};case 3:{n=12;break a;break};case 5:{b=b+2|0;continue a;break};case 30:{n=15;break a;break};case 10:{n=18;break a;break};case 9:{n=21;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=lUa(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){if((b|0)==(g|0)){p=mUa(j,b+2|0,e,f)|0;k=(p|0)==22?0:p;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==18){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==21){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[e]|0)|0]|0}else{q=kUa(a[e+1|0]|0,a[b]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function $Ta(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){e=b;if((a[b+1|0]|0)==0){h=d[g+76+(d[e]|0)|0]|0}else{h=kUa(a[e+1|0]|0,a[b]|0)|0}switch(h|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:{e=c;c=e+1|0;j=b;b=j+1|0;if((a[e]|0)!=(a[j]|0)){k=15;break a}j=c;c=j+1|0;e=b;b=e+1|0;if((a[j]|0)!=(a[e]|0)){k=17;break a}else{continue a}break};case 5:{break};case 6:{k=8;break};case 7:{e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=7;break a}else{k=8}break};default:{k=18;break a}}if((k|0)==8){k=0;j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=9;break}}e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=11;break}j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=13;break}}if((k|0)==7){l=0;m=l;i=f;return m|0}else if((k|0)==9){l=0;m=l;i=f;return m|0}else if((k|0)==11){l=0;m=l;i=f;return m|0}else if((k|0)==13){l=0;m=l;i=f;return m|0}else if((k|0)==15){l=0;m=l;i=f;return m|0}else if((k|0)==17){l=0;m=l;i=f;return m|0}else if((k|0)==18){k=c;if((a[c+1|0]|0)==0){n=d[g+76+(d[k]|0)|0]|0}else{n=kUa(a[k+1|0]|0,a[c]|0)|0}switch(n|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{l=0;m=l;i=f;return m|0};default:{l=1;m=l;i=f;return m|0}}}return 0}function aUa(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=9;break}if(g){h=4;break}if((a[f+1|0]|0)!=0){h=7;break}if((a[f]|0)!=(a[d]|0)){h=7;break}f=f+2|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==7){j=0;k=j;i=b;return k|0}else if((h|0)==9){j=g&1;k=j;i=b;return k|0}return 0}function bUa(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;e=i;i=i+24|0;f=b;b=c;c=b;a:while(1){g=b;if((a[b+1|0]|0)==0){h=d[f+76+(d[g]|0)|0]|0}else{h=kUa(a[g+1|0]|0,a[b]|0)|0}switch(h|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:{b=b+2|0;continue a;break};case 6:{b=b+3|0;continue a;break};case 7:{b=b+4|0;continue a;break};case 5:{b=b+2|0;continue a;break};default:{break a}}}i=e;return b-c|0}function cUa(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=c;while(1){c=b;if((a[b+1|0]|0)==0){g=d[f+76+(d[c]|0)|0]|0}else{g=kUa(a[c+1|0]|0,a[b]|0)|0}if(!((g|0)==21|(g|0)==9|(g|0)==10)){break}b=b+2|0}i=e;return b|0}function dUa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+2|0;a:while(1){m=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[m]|0)|0]|0}else{n=kUa(a[m+1|0]|0,a[b]|0)|0}b:do{switch(n|0){case 17:case 11:{if((g|0)!=2){break a}break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b+1|0]|0)==0){o=a[b]|0}else{o=-1}if((o|0)!=32){break}if((a[b+3|0]|0)==0){p=a[b+2|0]|0}else{p=-1}if((p|0)==32){break}m=b+2|0;if((a[b+3|0]|0)==0){q=d[j+76+(d[m]|0)|0]|0}else{q=kUa(a[m+1|0]|0,a[b+2|0]|0)|0}if((q|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};default:{}}}while(0);b=b+2|0}i=h;return k|0}function eUa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=c;c=0;d=d+4|0;a:do{if((a[d+1|0]|0)==0){if((a[d]|0)!=120){e=16;break}d=d+2|0;while(1){if((a[d+1|0]|0)==0){f=(a[d]|0)==59}else{f=0}if(!(f^1)){break a}if((a[d+1|0]|0)==0){g=a[d]|0}else{g=-1}h=g;switch(h|0){case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(h-97))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|h-48;break};case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(h-65))|0;break};default:{}}if((c|0)>=1114112){break}d=d+2|0}j=-1;k=j;i=b;return k|0}else{e=16}}while(0);b:do{if((e|0)==16){while(1){e=0;if((a[d+1|0]|0)==0){l=(a[d]|0)==59}else{l=0}if(!(l^1)){break b}if((a[d+1|0]|0)==0){m=a[d]|0}else{m=-1}c=c*10|0;c=c+(m-48)|0;if((c|0)>=1114112){break}d=d+2|0;e=16}j=-1;k=j;i=b;return k|0}}while(0);j=yTa(c)|0;k=j;i=b;return k|0}function fUa(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;e=c;c=(d-e|0)/2|0;do{if((c|0)==2){if((a[e+3|0]|0)!=0){break}if((a[e+2|0]|0)!=116){break}if((a[e+1|0]|0)==0){f=a[e]|0}else{f=-1}if((f|0)==108){g=60;h=g;i=b;return h|0}else if((f|0)==103){g=62;h=g;i=b;return h|0}else{break}}else if((c|0)==3){if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=97){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=109){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=112){break}g=38;h=g;i=b;return h|0}else if((c|0)==4){if((a[e+1|0]|0)==0){j=a[e]|0}else{j=-1}if((j|0)==113){e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=117){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=111){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=116){break}g=34;h=g;i=b;return h|0}else if((j|0)==97){e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=112){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=111){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=115){break}g=39;h=g;i=b;return h|0}else{break}}}while(0);g=0;h=g;i=b;return h|0}function gUa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=b;b=e;e=f;f=g;while(1){if(!(b>>>0<e>>>0)){break}g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=kUa(a[g+1|0]|0,a[b]|0)|0}switch(k|0){case 9:{g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;do{if((b|0)!=(e|0)){g=b;if((a[b+1|0]|0)==0){l=d[j+76+(d[g]|0)|0]|0}else{l=kUa(a[g+1|0]|0,a[b]|0)|0}if((l|0)!=10){break}b=b+2|0}}while(0);c[f+4>>2]=-1;break};case 7:{b=b+4|0;break};case 6:{b=b+3|0;break};case 5:{b=b+2|0;break};case 10:{c[f+4>>2]=-1;g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;break};default:{b=b+2|0}}g=f+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}function hUa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+2|0;e=e+ -2|0;a:while(1){if((b|0)==(e|0)){k=18;break}g=b;if((a[b+1|0]|0)==0){l=d[j+76+(d[g]|0)|0]|0}else{l=kUa(a[g+1|0]|0,a[b]|0)|0}b:do{switch(l|0){case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};case 21:{if((a[b+1|0]|0)!=0){break b}if((a[b]|0)==9){k=9;break a}break};case 22:case 26:{if((a[b+1|0]|0)==0){m=a[b]|0}else{m=-1}if((m&-128|0)!=0){k=13}break};default:{k=13}}}while(0);if((k|0)==13){k=0;if((a[b+1|0]|0)==0){n=a[b]|0}else{n=-1}if(!((n|0)==64|(n|0)==36)){k=16;break}}b=b+2|0}if((k|0)==9){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==16){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==18){o=1;p=o;i=h;return p|0}return 0}function iUa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+80|0;h=d;d=e;e=f;f=g;g=c[h>>2]|0;a:while(1){j=g;if((g|0)==(d|0)){k=18;break}l=a[j]|0;m=a[g+1|0]|0;b:do{switch(m&255|0){case 219:case 218:case 217:case 216:{if((f-(c[e>>2]|0)|0)<4){k=15;break a}n=((m&3)<<2|(l&255)>>6&3)+1|0;o=e;p=c[o>>2]|0;c[o>>2]=p+1;a[p]=n>>2|240;p=e;o=c[p>>2]|0;c[p>>2]=o+1;a[o]=(l&255)>>2&15|(n&3)<<4|128;g=g+2|0;n=a[g]|0;o=((l&3)<<4|(a[g+1|0]&3)<<2|(n&255)>>6|128)&255;p=e;q=c[p>>2]|0;c[p>>2]=q+1;a[q]=o;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=n&63|128;break};case 7:case 6:case 5:case 4:case 3:case 2:case 1:{k=8;break};case 0:{if((l&255|0)>=128){k=8;break b}if((c[e>>2]|0)==(f|0)){k=6;break a}n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=l;break};default:{if((f-(c[e>>2]|0)|0)<3){k=12;break a}q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=(m&255)>>4|224;n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=(m&15)<<2|(l&255)>>6|128;q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=l&63|128}}}while(0);if((k|0)==8){k=0;if((f-(c[e>>2]|0)|0)<2){k=9;break}n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=(l&255)>>6|(m&255)<<2|192;q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=l&63|128}g=g+2|0}if((k|0)==6){c[h>>2]=g;i=b;return}else if((k|0)==9){c[h>>2]=g;i=b;return}else if((k|0)==12){c[h>>2]=g;i=b;return}else if((k|0)==15){c[h>>2]=g;i=b;return}else if((k|0)==18){c[h>>2]=j;i=b;return}}function jUa(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;e=i;i=i+40|0;k=f;f=g;g=h;h=j;do{if((f-(c[k>>2]|0)|0)>(((h-(c[g>>2]|0)|0)/2|0)<<1|0)){if((a[f+ -2+1|0]&248|0)!=216){break}f=f+ -2|0}}while(0);while(1){if((c[k>>2]|0)==(f|0)){l=7;break}if((c[g>>2]|0)==(h|0)){l=7;break}j=((d[(c[k>>2]|0)+1|0]|0)<<8|(d[c[k>>2]|0]|0))&65535;m=g;n=c[m>>2]|0;c[m>>2]=n+2;b[n>>1]=j;j=k;c[j>>2]=(c[j>>2]|0)+2}if((l|0)==7){i=e;return}}function kUa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;i=i+24|0;a:do{switch(a&255|0){case 255:{if(!(((b&255)+ -254|0)>>>0<2)){d=6;break a}e=0;break};case 223:case 222:case 221:case 220:{e=8;break};case 219:case 218:case 217:case 216:{e=7;break};default:{d=6}}}while(0);if((d|0)==6){e=29}i=c;return e|0}function lUa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=kUa(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 19:{k=nUa(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 24:case 22:{break};case 29:{if((c[231512+((d[231256+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=kUa(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 7:{n=35;break b;break};case 29:{if((c[231512+((d[232792+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=27;break b}break};case 6:{n=32;break b;break};case 18:{n=38;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{n=29;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=9;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function mUa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=kUa(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 30:case 9:case 10:case 21:{c[f>>2]=b;k=22;l=k;i=h;return l|0};case 24:case 22:{break};case 29:{if((c[231512+((d[231256+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=kUa(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 5:{n=29;break b;break};case 7:{n=35;break b;break};case 6:{n=32;break b;break};case 18:{n=38;break b;break};case 29:{if((c[231512+((d[232792+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=27;break b}break};case 27:case 26:case 25:case 24:case 22:{break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=28;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function nUa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b+1|0]|0)==0){if((a[b]|0)!=120){break}k=oUa(j,b+2|0,e,f)|0;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=kUa(a[g+1|0]|0,a[b]|0)|0}g=b;if((m|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=kUa(a[g+1|0]|0,a[b]|0)|0}if((n|0)==18){o=16;break}else if((n|0)!=25){o=17;break}b=b+2|0}if((o|0)==16){c[f>>2]=b+2;k=10;l=k;i=h;return l|0}else if((o|0)==17){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function oUa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=kUa(a[g+1|0]|0,a[b]|0)|0}g=b;if(!((k+ -24|0)>>>0<2)){c[f>>2]=g;l=0;m=l;i=h;return m|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=kUa(a[g+1|0]|0,a[b]|0)|0}if((n|0)==18){o=13;break}else if(!((n|0)==24|(n|0)==25)){o=14;break}b=b+2|0}if((o|0)==13){c[f>>2]=b+2;l=10;m=l;i=h;return m|0}else if((o|0)==14){c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);l=-1;m=l;i=h;return m|0}function pUa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=kUa(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 17:{k=tUa(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[231512+((d[231256+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 24:case 22:{break};case 16:{g=b+2|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=kUa(a[g+1|0]|0,a[b]|0)|0}if((n|0)==20){k=rUa(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((n|0)==27){k=qUa(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 15:{k=sUa(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;n=0;b:while(1){if((b|0)==(e|0)){o=98;break}m=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[m]|0)|0]|0}else{p=kUa(a[m+1|0]|0,a[b]|0)|0}switch(p|0){case 7:{o=45;break b;break};case 17:{break b;break};case 11:{o=90;break b;break};case 5:{o=39;break b;break};case 23:{if((n|0)!=0){o=49;break b}n=1;b=b+2|0;if((b|0)==(e|0)){o=51;break b}m=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[m]|0)|0]|0}else{q=kUa(a[m+1|0]|0,a[b]|0)|0}switch(q|0){case 29:{if((c[231512+((d[231256+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=57;break b}break};case 24:case 22:{break};case 7:{o=65;break b;break};case 6:{o=62;break b;break};case 5:{o=59;break b;break};default:{o=68;break b}}b=b+2|0;continue b;break};case 29:{if((c[231512+((d[232792+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=37;break b}break};case 6:{o=42;break b;break};case 10:case 9:case 21:{o=69;break b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{o=97;break b}}b=b+2|0}c:do{if((o|0)==37){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==39){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==42){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==45){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==51){k=-1;l=k;i=h;return l|0}else if((o|0)==57){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==59){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==62){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==65){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==68){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==69){b=b+2|0;d:while(1){if((b|0)==(e|0)){o=89;break}q=b;if((a[b+1|0]|0)==0){r=d[j+76+(d[q]|0)|0]|0}else{r=kUa(a[q+1|0]|0,a[b]|0)|0}switch(r|0){case 10:case 9:case 21:{break};case 7:{o=84;break d;break};case 24:case 22:{break d;break};case 6:{o=81;break d;break};case 5:{o=78;break d;break};case 17:{break c;break};case 11:{o=90;break c;break};case 29:{o=75;break d;break};default:{o=88;break d}}b=b+2|0}do{if((o|0)==75){if((c[231512+((d[231256+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==81){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==84){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==89){k=-1;l=k;i=h;return l|0}}while(0);b=b+2|0;k=uUa(j,b,e,f)|0;l=k;i=h;return l|0}else if((o|0)==97){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==98){k=-1;l=k;i=h;return l|0}}while(0);if((o|0)==90){c[f>>2]=b+2;k=2;l=k;i=h;return l|0}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;k=4;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=0;l=k;i=h;return l|0}function qUa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b+1|0]|0)==0){if((a[b]|0)!=45){break}b=b+2|0;b:while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=kUa(a[g+1|0]|0,a[b]|0)|0}switch(k|0){case 5:{if((e-b|0)<2){l=12;break b}b=b+2|0;continue b;break};case 7:{if((e-b|0)<4){l=18;break b}b=b+4|0;continue b;break};case 27:{g=b+2|0;b=g;if((g|0)==(e|0)){l=22;break b}if((a[b+1|0]|0)!=0){continue b}if((a[b]|0)==45){l=25;break b}else{continue b}break};case 8:case 1:case 0:{l=20;break b;break};case 6:{if((e-b|0)<3){l=15;break b}b=b+3|0;continue b;break};default:{b=b+2|0;continue b}}}if((l|0)==12){m=-2;n=m;i=h;return n|0}else if((l|0)==15){m=-2;n=m;i=h;return n|0}else if((l|0)==18){m=-2;n=m;i=h;return n|0}else if((l|0)==20){c[f>>2]=b;m=0;n=m;i=h;return n|0}else if((l|0)==22){m=-1;n=m;i=h;return n|0}else if((l|0)==25){g=b+2|0;b=g;if((g|0)==(e|0)){m=-1;n=m;i=h;return n|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;m=13;n=m;i=h;return n|0}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}while(0);m=-1;n=m;i=h;return n|0}function rUa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<12){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=9;break}if((a[k+1|0]|0)!=0){l=7;break}if((a[g]|0)!=(a[233456+e|0]|0)){l=7;break}e=e+1|0;g=g+2|0}if((l|0)==7){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==9){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function sUa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}n=b;if((a[b+1|0]|0)==0){o=d[k+76+(d[n]|0)|0]|0}else{o=kUa(a[n+1|0]|0,a[b]|0)|0}a:do{switch(o|0){case 24:case 22:{break};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 29:{if((c[231512+((d[231256+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;l=0;m=l;i=h;return m|0};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){p=70;break}o=b;if((a[b+1|0]|0)==0){q=d[k+76+(d[o]|0)|0]|0}else{q=kUa(a[o+1|0]|0,a[b]|0)|0}switch(q|0){case 5:{p=28;break b;break};case 6:{p=31;break b;break};case 29:{if((c[231512+((d[232792+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){p=26;break b}break};case 10:case 9:case 21:{p=37;break b;break};case 7:{p=34;break b;break};case 15:{p=62;break b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{break b}}b=b+2|0}do{if((p|0)==26){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==28){if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==31){if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==34){if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==37){q=b;if((vUa(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;c:while(1){if((b|0)==(e|0)){p=61;break}q=b;if((a[b+1|0]|0)==0){r=d[k+76+(d[q]|0)|0]|0}else{r=kUa(a[q+1|0]|0,a[b]|0)|0}switch(r|0){case 7:{if((e-b|0)<4){p=52;break c}b=b+4|0;continue c;break};case 5:{if((e-b|0)<2){p=46;break c}b=b+2|0;continue c;break};case 8:case 1:case 0:{p=54;break c;break};case 15:{b=b+2|0;if((b|0)==(e|0)){p=56;break c}if((a[b+1|0]|0)!=0){continue c}if((a[b]|0)==62){p=59;break c}else{continue c}break};case 6:{if((e-b|0)<3){p=49;break c}b=b+3|0;continue c;break};default:{b=b+2|0;continue c}}}if((p|0)==46){l=-2;m=l;i=h;return m|0}else if((p|0)==49){l=-2;m=l;i=h;return m|0}else if((p|0)==52){l=-2;m=l;i=h;return m|0}else if((p|0)==54){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==56){l=-1;m=l;i=h;return m|0}else if((p|0)==59){c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==61){l=-1;m=l;i=h;return m|0}}else if((p|0)==62){q=b;if((vUa(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b+1|0]|0)!=0){break}if((a[b]|0)!=62){break}c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==70){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function tUa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=kUa(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 24:case 22:{break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[231512+((d[231256+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=50;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=kUa(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 27:case 26:case 25:case 24:case 22:{break};case 23:{b=b+2|0;continue b;break};case 6:{n=31;break b;break};case 5:{n=28;break b;break};case 7:{n=34;break b;break};case 10:case 9:case 21:{n=37;break b;break};case 11:{n=48;break b;break};case 29:{if((c[231512+((d[232792+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=26;break b}break};default:{n=49;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){b=b+2|0;while(1){if((b|0)==(e|0)){n=46;break}o=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=kUa(a[o+1|0]|0,a[b]|0)|0}if((p|0)==11){n=43;break}else if(!((p|0)==10|(p|0)==9|(p|0)==21)){n=44;break}b=b+2|0}if((n|0)==43){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==44){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==46){k=-1;l=k;i=h;return l|0}}else if((n|0)==48){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==50){k=-1;l=k;i=h;return l|0}return 0}function uUa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=115;break}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){m=d[k+76+(d[b]|0)|0]|0}else{m=kUa(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}b:do{switch(m|0){case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=41;break a}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){n=d[k+76+(d[b]|0)|0]|0}else{n=kUa(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}b=n;if((b|0)==14){break b}o=b;if(!((o|0)==9|(o|0)==10|(o|0)==21)){l=47;break a}}break};case 6:{l=13;break a;break};case 27:case 26:case 25:case 24:case 22:{l=9;break};case 7:{l=16;break a;break};case 14:{break};case 23:{if((g|0)!=0){l=20;break a}g=1;c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=22;break a}o=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){p=d[k+76+(d[o]|0)|0]|0}else{p=kUa(a[o+1|0]|0,a[c[j>>2]|0]|0)|0}switch(p|0){case 24:case 22:{break};case 5:{l=30;break a;break};case 29:{if((c[231512+((d[231256+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)==0){l=28;break a}break};case 6:{l=33;break a;break};case 7:{l=36;break a;break};default:{l=39;break a}}c[j>>2]=(c[j>>2]|0)+2;continue a;break};case 5:{l=10;break a;break};case 29:{if((c[231512+((d[232792+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)!=0){l=9}else{l=8;break a}break};default:{l=114;break a}}}while(0);if((l|0)==9){l=0;c[j>>2]=(c[j>>2]|0)+2;continue}g=0;while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=50;break a}o=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){q=d[k+76+(d[o]|0)|0]|0}else{q=kUa(a[o+1|0]|0,a[c[j>>2]|0]|0)|0}r=q;if((r|0)==12|(r|0)==13){break}o=r;if(!((o|0)==9|(o|0)==10|(o|0)==21)){l=56;break a}}c[j>>2]=(c[j>>2]|0)+2;c:while(1){if((c[j>>2]|0)==(e|0)){l=59;break a}o=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){s=d[k+76+(d[o]|0)|0]|0}else{s=kUa(a[o+1|0]|0,a[c[j>>2]|0]|0)|0}o=s;if((o|0)==(r|0)){break}switch(o|0){case 3:{t=lUa(k,(c[j>>2]|0)+2|0,e,j)|0;if((t|0)<=0){l=76;break a}else{continue c}break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=72;break a}c[j>>2]=(c[j>>2]|0)+4;continue c;break};case 2:{l=79;break a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=66;break a}c[j>>2]=(c[j>>2]|0)+2;continue c;break};case 8:case 1:case 0:{l=74;break a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=69;break a}c[j>>2]=(c[j>>2]|0)+3;continue c;break};default:{c[j>>2]=(c[j>>2]|0)+2;continue c}}}c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=82;break}o=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){u=d[k+76+(d[o]|0)|0]|0}else{u=kUa(a[o+1|0]|0,a[c[j>>2]|0]|0)|0}switch(u|0){case 17:{l=107;break a;break};case 11:{l=106;break a;break};case 10:case 9:case 21:{break};default:{l=87;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=89;break a}o=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){v=d[k+76+(d[o]|0)|0]|0}else{v=kUa(a[o+1|0]|0,a[c[j>>2]|0]|0)|0}switch(v|0){case 7:{l=103;break a;break};case 6:{l=100;break a;break};case 29:{l=94;break d;break};case 17:{l=107;break a;break};case 11:{l=106;break a;break};case 10:case 9:case 21:{break};case 5:{l=97;break a;break};case 24:case 22:{break d;break};default:{l=113;break a}}}if((l|0)==94){l=0;if((c[231512+((d[231256+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)==0){l=95;break}}c[j>>2]=(c[j>>2]|0)+2}if((l|0)==8){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==10){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==13){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==16){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==20){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==22){w=-1;x=w;i=h;return x|0}else if((l|0)==28){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==30){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==33){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==36){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==39){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==41){w=-1;x=w;i=h;return x|0}else if((l|0)==47){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==50){w=-1;x=w;i=h;return x|0}else if((l|0)==56){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==59){w=-1;x=w;i=h;return x|0}else if((l|0)==66){w=-2;x=w;i=h;return x|0}else if((l|0)==69){w=-2;x=w;i=h;return x|0}else if((l|0)==72){w=-2;x=w;i=h;return x|0}else if((l|0)==74){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==76){if((t|0)==0){c[f>>2]=c[j>>2]}w=t;x=w;i=h;return x|0}else if((l|0)==79){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==82){w=-1;x=w;i=h;return x|0}else if((l|0)==87){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==89){w=-1;x=w;i=h;return x|0}else if((l|0)==95){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==97){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==100){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==103){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+2;w=1;x=w;i=h;return x|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){w=-1;x=w;i=h;return x|0}do{if((a[(c[j>>2]|0)+1|0]|0)==0){if((a[c[j>>2]|0]|0)!=62){break}c[f>>2]=(c[j>>2]|0)+2;w=3;x=w;i=h;return x|0}}while(0);c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==113){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==114){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==115){w=-1;x=w;i=h;return x|0}return 0}function vUa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;if((e-g|0)!=6){h=1;j=h;i=b;return j|0}if((a[g+1|0]|0)==0){k=a[g]|0}else{k=-1}if((k|0)==88){f=1}else if((k|0)!=120){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g+1|0]|0)==0){l=a[g]|0}else{l=-1}if((l|0)==77){f=1}else if((l|0)!=109){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g+1|0]|0)==0){m=a[g]|0}else{m=-1}if((m|0)==76){f=1}else if((m|0)!=108){h=1;j=h;i=b;return j|0}if((f|0)!=0){h=0;j=h;i=b;return j|0}else{c[d>>2]=12;h=1;j=h;i=b;return j|0}return 0}function wUa(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+56|0;k=b;b=e;e=f;f=g;g=h;a:while(1){if((e|0)==(f|0)){l=27;break}h=e;if((a[e+1|0]|0)==0){m=d[b+76+(d[h]|0)|0]|0}else{m=kUa(a[h+1|0]|0,a[e]|0)|0}h=m;switch(h|0){case 13:case 12:{e=e+2|0;if((h|0)!=(k|0)){continue a}else{l=18;break a}break};case 7:{if((f-e|0)<4){l=14;break a}e=e+4|0;continue a;break};case 8:case 1:case 0:{l=16;break a;break};case 5:{if((f-e|0)<2){l=8;break a}e=e+2|0;continue a;break};case 6:{if((f-e|0)<3){l=11;break a}e=e+3|0;continue a;break};default:{e=e+2|0;continue a}}}if((l|0)==8){n=-2;o=n;i=j;return o|0}else if((l|0)==11){n=-2;o=n;i=j;return o|0}else if((l|0)==14){n=-2;o=n;i=j;return o|0}else if((l|0)==16){c[g>>2]=e;n=0;o=n;i=j;return o|0}else if((l|0)==18){if((e|0)==(f|0)){n=-27;o=n;i=j;return o|0}c[g>>2]=e;g=e;if((a[e+1|0]|0)==0){p=d[b+76+(d[g]|0)|0]|0}else{p=kUa(a[g+1|0]|0,a[e]|0)|0}switch(p|0){case 20:case 30:case 11:case 10:case 9:case 21:{n=27;o=n;i=j;return o|0};default:{n=0;o=n;i=j;return o|0}}}else if((l|0)==27){n=-1;o=n;i=j;return o|0}return 0}function xUa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=kUa(a[g+1|0]|0,a[b]|0)|0}if((m|0)==24|(m|0)==22){b=b+2|0;a:while(1){if((b|0)==(e|0)){n=26;break}g=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[g]|0)|0]|0}else{o=kUa(a[g+1|0]|0,a[b]|0)|0}switch(o|0){case 30:{n=16;break a;break};case 10:case 9:case 21:{break a;break};case 24:case 22:{break};default:{n=25;break a}}b=b+2|0}do{if((n|0)==16){if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}o=b+2|0;if((a[b+3|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=kUa(a[o+1|0]|0,a[b+2|0]|0)|0}if(!((p|0)==30|(p|0)==10|(p|0)==9|(p|0)==21)){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==25){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==26){k=-1;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=16;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=b+2;k=33;l=k;i=h;return l|0}else if((m|0)==27){k=qUa(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}return 0}function yUa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=kUa(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 29:{if((c[231512+((d[231256+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=39;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=kUa(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 27:case 26:case 25:case 24:case 22:{break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{n=37;break b;break};case 7:{n=34;break b;break};case 6:{n=31;break b;break};case 5:{n=28;break b;break};case 29:{if((c[231512+((d[232792+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=26;break b}break};default:{n=38;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){c[f>>2]=b;k=20;l=k;i=h;return l|0}else if((n|0)==38){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==39){k=-20;l=k;i=h;return l|0}return 0}function zUa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=kUa(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 23:case 27:case 26:case 25:{n=19;b=b+2|0;o=77;break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 11:{c[f>>2]=b+2;k=17;l=k;i=h;return l|0};case 29:{g=b;if((c[231512+((d[231256+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){b=g+2|0;n=18;o=77;break a}if((c[231512+((d[232792+(d[g]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=76;break a}b=b+2|0;n=19;o=77;break};case 36:{c[f>>2]=b+2;k=21;l=k;i=h;return l|0};case 24:case 22:{n=18;b=b+2|0;o=77;break};case 32:{b=b+2|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){p=d[j+76+(d[g+1|0]|0)|0]|0}else{p=kUa(a[g]|0,a[b+1|0]|0)|0}switch(p|0){case 34:{c[f>>2]=b+2;k=37;l=k;i=h;return l|0};case 15:{c[f>>2]=b+2;k=35;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 33:{c[f>>2]=b+2;k=36;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 9:{if((b+2|0)!=(e|0)){o=25;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 31:{c[f>>2]=b+2;k=23;l=k;i=h;return l|0};case 12:{k=$Ua(12,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 35:{c[f>>2]=b+2;k=38;l=k;i=h;return l|0};case 20:{c[f>>2]=b+2;k=25;l=k;i=h;return l|0};case 19:{k=bVa(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 13:{k=$Ua(13,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 2:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){q=d[j+76+(d[g+1|0]|0)|0]|0}else{q=kUa(a[g]|0,a[b+1|0]|0)|0}switch(q|0){case 16:{k=aVa(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -2;k=29;l=k;i=h;return l|0};case 15:{k=XUa(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=93){break}if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+2|0]|0)!=0){break}if((a[b+3|0]|0)!=62){break}c[f>>2]=b+4;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 10:case 21:{o=25;break};case 30:{k=RUa(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{o=76}}}while(0);if((o|0)==25){while(1){o=0;b=b+2|0;r=b;if((b|0)==(e|0)){o=32;break}q=b;if((a[r]|0)==0){s=d[j+76+(d[q+1|0]|0)|0]|0}else{s=kUa(a[q]|0,a[b+1|0]|0)|0}if((s|0)==10|(s|0)==21){o=25;continue}else if((s|0)!=9){o=31;break}if((b+2|0)!=(e|0)){o=25}else{o=31;break}}if((o|0)==31){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((o|0)==32){c[f>>2]=r;k=15;l=k;i=h;return l|0}}else if((o|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==77){b:while(1){o=0;if((b|0)==(e|0)){o=126;break}r=b;if((a[b]|0)==0){t=d[j+76+(d[r+1|0]|0)|0]|0}else{t=kUa(a[r]|0,a[b+1|0]|0)|0}switch(t|0){case 34:{o=116;break b;break};case 33:{o=119;break b;break};case 7:{o=91;break b;break};case 15:{o=122;break b;break};case 6:{o=88;break b;break};case 5:{o=85;break b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{o=94;break b;break};case 29:{if((c[231512+((d[232792+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=83;break b}break};case 23:{b=b+2|0;r=n;if((r|0)==41){n=19;o=77;continue b}else if((r|0)!=18){o=77;continue b}if((b|0)==(e|0)){o=97;break b}n=41;r=b;if((a[b]|0)==0){u=d[j+76+(d[r+1|0]|0)|0]|0}else{u=kUa(a[r]|0,a[b+1|0]|0)|0}switch(u|0){case 27:case 26:case 25:case 24:case 22:{break};case 7:{o=111;break b;break};case 5:{o=105;break b;break};case 6:{o=108;break b;break};case 29:{if((c[231512+((d[232792+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=103;break b}break};default:{n=19;o=77;continue b}}b=b+2|0;o=77;continue b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{o=125;break b}}b=b+2|0;o=77}if((o|0)==83){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==85){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==91){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==94){c[f>>2]=b;k=n;l=k;i=h;return l|0}else if((o|0)==97){k=-1;l=k;i=h;return l|0}else if((o|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==105){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==108){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==111){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==116){e=b;if((n|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=32;l=k;i=h;return l|0}}else if((o|0)==119){e=b;if((n|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=31;l=k;i=h;return l|0}}else if((o|0)==122){e=b;if((n|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=30;l=k;i=h;return l|0}}else if((o|0)==125){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==126){k=0-n|0;l=k;i=h;return l|0}}return 0}function AUa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=kUa(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 4:{b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b]|0)!=0){break a}if((a[b+1|0]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 2:{k=UUa(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 3:{k=QUa(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=kUa(a[g]|0,a[b+1|0]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=68;break}n=b;if((a[o]|0)==0){q=d[j+76+(d[n+1|0]|0)|0]|0}else{q=kUa(a[n]|0,a[b+1|0]|0)|0}switch(q|0){case 6:{r=b;if((e-b|0)<3){p=52;break b}b=r+3|0;continue b;break};case 4:{if((b+2|0)==(e|0)){p=66;break b}do{if((a[b+2|0]|0)==0){if((a[b+3|0]|0)!=93){break}if((b+4|0)==(e|0)){p=66;break b}if((a[b+4|0]|0)==0){if((a[b+5|0]|0)==62){p=65;break b}}b=b+2|0;continue b}}while(0);b=b+2|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{p=66;break b;break};case 7:{s=b;if((e-b|0)<4){p=55;break b}b=s+4|0;continue b;break};case 5:{t=b;if((e-b|0)<2){p=49;break b}b=t+2|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==49){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==52){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==65){c[f>>2]=b+4;k=0;l=k;i=h;return l|0}else if((p|0)==66){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==68){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function BUa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=kUa(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b]|0)!=0){break a}if((a[b+1|0]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=40;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=kUa(a[g]|0,a[b+1|0]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=57;break}n=b;if((a[o]|0)==0){q=d[j+76+(d[n+1|0]|0)|0]|0}else{q=kUa(a[n]|0,a[b+1|0]|0)|0}switch(q|0){case 6:{r=b;if((e-b|0)<3){p=50;break b}b=r+3|0;continue b;break};case 4:case 10:case 9:case 8:case 1:case 0:{p=55;break b;break};case 7:{s=b;if((e-b|0)<4){p=53;break b}b=s+4|0;continue b;break};case 5:{t=b;if((e-b|0)<2){p=47;break b}b=t+2|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==47){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==50){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==53){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==57){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function CUa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=0;k=e-b|0;if((k&1|0)!=0){k=k&-2;e=b+k|0}a:while(1){if((b|0)==(e|0)){l=39;break}k=b;if((a[b]|0)==0){m=d[j+76+(d[k+1|0]|0)|0]|0}else{m=kUa(a[k]|0,a[b+1|0]|0)|0}switch(m|0){case 5:{if((e-b|0)<2){l=9;break a}b=b+2|0;continue a;break};case 4:{k=b+2|0;b=k;if((k|0)==(e|0)){l=28;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=93){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=32;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=62){continue a}b=b+2|0;if((g|0)==0){l=36;break a}g=g+ -1|0;continue a;break};case 6:{if((e-b|0)<3){l=12;break a}b=b+3|0;continue a;break};case 8:case 1:case 0:{l=17;break a;break};case 7:{if((e-b|0)<4){l=15;break a}b=b+4|0;continue a;break};case 2:{k=b+2|0;b=k;if((k|0)==(e|0)){l=19;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=33){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=23;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=91){continue a}g=g+1|0;b=b+2|0;continue a;break};default:{b=b+2|0;continue a}}}if((l|0)==9){n=-2;o=n;i=h;return o|0}else if((l|0)==12){n=-2;o=n;i=h;return o|0}else if((l|0)==15){n=-2;o=n;i=h;return o|0}else if((l|0)==17){c[f>>2]=b;n=0;o=n;i=h;return o|0}else if((l|0)==19){n=-1;o=n;i=h;return o|0}else if((l|0)==23){n=-1;o=n;i=h;return o|0}else if((l|0)==28){n=-1;o=n;i=h;return o|0}else if((l|0)==32){n=-1;o=n;i=h;return o|0}else if((l|0)==36){c[f>>2]=b;n=42;o=n;i=h;return o|0}else if((l|0)==39){n=-1;o=n;i=h;return o|0}return 0}



function pZa(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;k=i;i=i+8|0;l=k;m=c[b>>2]|0;b=~m;c[63818]=(c[e>>2]|0)+1+(c[f>>2]|0);c[j>>2]=0;n=(c[f>>2]|0)+2|0;c[63824]=n;o=c[d>>2]|0;p=c[63818]|0;q=(o|0)>(p|0)?p:o;o=q+ -1|0;c[63826]=o;do{if((q|0)>(n|0)){c[63834]=n;if((n|0)>(o|0)){break}else{r=n}while(1){s=1-r+p|0;c[63822]=s;t=c[e>>2]|0;c[63810]=s;if((s|0)<=(t|0)){u=s;while(1){h[a+(u+b+(fa(r,m)|0)<<3)>>3]=0.0;if((u|0)<(t|0)){u=u+1|0}else{break}}c[63810]=t+1}u=r+1|0;c[63834]=u;if((r|0)<(o|0)){r=u}else{break}}c[l>>2]=t}}while(0);c[63834]=o;c[63832]=0;t=c[d>>2]|0;r=t+ -1|0;if((t|0)<2){v=t}else{c[63814]=1;t=o;o=1;while(1){c[63836]=o+1;p=t+1|0;c[63834]=p;n=c[d>>2]|0;do{if((t|0)<(n|0)){q=c[e>>2]|0;if((q|0)<1){w=n;break}c[l>>2]=q;c[63810]=1;u=fa(p,m)|0;s=1;while(1){h[a+(s+b+u<<3)>>3]=0.0;if((s|0)<(q|0)){s=s+1|0}else{break}}c[63810]=q+1;w=c[d>>2]|0}else{w=n}}while(0);n=c[e>>2]|0;p=w-o|0;s=(n|0)<=(p|0)?n:p;c[63828]=s;c[l>>2]=s+1;s=kZa(l,a+((c[63818]|0)+b+(fa(o,m)|0)<<3)|0,255192)|0;p=s+ -1|0;c[63816]=p+(c[63818]|0);s=c[63814]|0;c[g+(s+ -1<<2)>>2]=p+s;s=c[63816]|0;p=c[63814]|0;n=fa(p,m)|0;x=+h[a+(s+b+n<<3)>>3];a:do{if(x==0.0){c[j>>2]=p}else{u=c[63818]|0;if((s|0)==(u|0)){y=s}else{h[31910]=x;z=a+(u+b+n<<3)|0;h[a+(n+b+s<<3)>>3]=+h[z>>3];h[z>>3]=+h[31910];y=u}h[31910]=-1.0/+h[a+(y+b+n<<3)>>3];lZa(255312,255280,a+(y-m+n<<3)|0,255192)|0;u=c[63832]|0;z=(c[g+((c[63814]|0)+ -1<<2)>>2]|0)+(c[f>>2]|0)|0;A=(u|0)>=(z|0)?u:z;c[l>>2]=A;z=c[d>>2]|0;u=(A|0)>(z|0)?z:A;c[63832]=u;A=c[63818]|0;c[63830]=A;z=c[63836]|0;if((u|0)<(z|0)){break}c[l>>2]=u;c[63812]=z;B=z;z=A;while(1){A=(c[63816]|0)+ -1|0;c[63816]=A;C=z+ -1|0;c[63830]=C;D=fa(B,m)|0;E=a+(A+b+D<<3)|0;h[31910]=+h[E>>3];if((A|0)==(C|0)){F=A}else{A=a+(C+b+D<<3)|0;h[E>>3]=+h[A>>3];h[A>>3]=+h[31910];F=C}C=255192;mZa(255312,255280,a+((c[63818]|0)-m+(fa(c[63814]|0,m)|0)<<3)|0,C,a+(F-m+D<<3)|0,C)|0;C=c[63812]|0;D=C+1|0;c[63812]=D;if((C|0)>=(u|0)){break a}B=D;z=c[63830]|0}}}while(0);n=c[63814]|0;s=n+1|0;c[63814]=s;if((n|0)>=(r|0)){break}t=c[63834]|0;o=s}v=c[d>>2]|0}c[g+(v+ -1<<2)>>2]=v;v=c[d>>2]|0;if(!(+h[a+((c[63818]|0)+b+(fa(v,m)|0)<<3)>>3]==0.0)){i=k;return 0}c[j>>2]=v;i=k;return 0}function qZa(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0;l=i;m=c[b>>2]|0;b=~m;n=(c[f>>2]|0)+1+(c[e>>2]|0)|0;c[63842]=n;f=c[d>>2]|0;o=f+ -1|0;c[63854]=o;if((c[k>>2]|0)==0){if(!((c[e>>2]|0)==0|(f|0)<2)){c[63838]=1;f=1;do{k=c[e>>2]|0;p=(c[d>>2]|0)-f|0;c[63852]=(k|0)<=(p|0)?k:p;p=f+ -1|0;k=c[g+(p<<2)>>2]|0;c[63840]=k;q=j+(k+ -1<<3)|0;h[31922]=+h[q>>3];if((k|0)!=(f|0)){k=j+(p<<3)|0;h[q>>3]=+h[k>>3];h[k>>3]=+h[31922]}k=255192;mZa(255408,255376,a+((c[63842]|0)-m+(fa(f,m)|0)<<3)|0,k,j+(f<<3)|0,k)|0;k=c[63838]|0;f=k+1|0;c[63838]=f;}while((k|0)<(o|0))}f=c[d>>2]|0;c[63846]=1;if((f|0)<1){i=l;return 0}else{r=1}do{k=1-r+(c[d>>2]|0)|0;c[63838]=k;q=c[63842]|0;p=fa(k,m)|0;s=j+(k+ -1<<3)|0;t=+h[s>>3]/+h[a+(q+b+p<<3)>>3];h[s>>3]=t;s=((k|0)<=(q|0)?k:q)+ -1|0;c[63852]=s;u=q-s|0;c[63848]=u;q=k-s|0;c[63850]=q;h[31922]=-t;s=255192;mZa(255408,255376,a+(u+b+p<<3)|0,s,j+(q+ -1<<3)|0,s)|0;s=c[63846]|0;r=s+1|0;c[63846]=r;}while((s|0)<(f|0));i=l;return 0}f=c[d>>2]|0;c[63838]=1;if((f|0)<1){v=n;w=o}else{o=n;n=1;do{r=((n|0)<=(o|0)?n:o)+ -1|0;c[63852]=r;s=o-r|0;c[63848]=s;q=n-r|0;c[63850]=q;r=255192;t=+oZa(255408,a+((fa(n,m)|0)+b+s<<3)|0,r,j+(q+ -1<<3)|0,r);h[31922]=t;r=c[63838]|0;q=j+(r+ -1<<3)|0;o=c[63842]|0;h[q>>3]=(+h[q>>3]-t)/+h[a+((fa(r,m)|0)+b+o<<3)>>3];n=r+1|0;c[63838]=n;}while((r|0)<(f|0));v=o;w=c[63854]|0}if((c[e>>2]|0)==0|(w|0)<1){i=l;return 0}c[63846]=1;o=v;v=1;while(1){f=(c[d>>2]|0)-v|0;c[63838]=f;n=c[e>>2]|0;b=(c[d>>2]|0)-f|0;c[63852]=(n|0)<=(b|0)?n:b;b=255192;t=+oZa(255408,a+(o-m+(fa(f,m)|0)<<3)|0,b,j+(f<<3)|0,b);b=c[63838]|0;f=b+ -1|0;n=j+(f<<3)|0;h[n>>3]=t+ +h[n>>3];r=c[g+(f<<2)>>2]|0;c[63840]=r;if((r|0)!=(b|0)){b=j+(r+ -1<<3)|0;h[31922]=+h[b>>3];h[b>>3]=+h[n>>3];h[n>>3]=+h[31922]}n=c[63846]|0;b=n+1|0;c[63846]=b;if((n|0)>=(w|0)){break}o=c[63842]|0;v=b}i=l;return 0}function rZa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;j=c[a>>2]|0;if((j|0)<1){i=g;return 0}do{if((c[d>>2]|0)==1){if((c[f>>2]|0)!=1){break}k=(j|0)%7|0;c[63866]=k;do{if((k|0)==0){l=c[a>>2]|0}else{c[63864]=1;if((k|0)>=1){m=1;while(1){n=m+ -1|0;h[e+(n<<3)>>3]=+h[b+(n<<3)>>3];if((m|0)<(k|0)){m=m+1|0}else{break}}c[63864]=k+1}m=c[a>>2]|0;if((m|0)>=7){l=m;break}i=g;return 0}}while(0);m=k+1|0;c[63864]=m;if((k|0)<(l|0)){o=m}else{i=g;return 0}do{m=o+ -1|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];h[e+(o<<3)>>3]=+h[b+(o<<3)>>3];m=o+1|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+2|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+3|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+4|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+5|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];o=o+7|0;}while((o|0)<=(l|0));c[63864]=o;i=g;return 0}}while(0);c[63868]=1;c[63870]=1;o=c[d>>2]|0;if((o|0)<0){l=(fa(1-(c[a>>2]|0)|0,o)|0)+1|0;c[63868]=l;p=l}else{p=1}l=c[f>>2]|0;if((l|0)<0){o=(fa(1-(c[a>>2]|0)|0,l)|0)+1|0;c[63870]=o;q=o}else{q=1}o=c[a>>2]|0;c[63864]=1;if((o|0)<1){i=g;return 0}else{r=1;s=q;t=p}while(1){h[e+(s+ -1<<3)>>3]=+h[b+(t+ -1<<3)>>3];p=t+(c[d>>2]|0)|0;c[63868]=p;q=s+(c[f>>2]|0)|0;c[63870]=q;a=r+1|0;c[63864]=a;if((r|0)<(o|0)){t=p;s=q;r=a}else{break}}i=g;return 0}function sZa(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0;d=i;m=+tZa(255568);n=c[a>>2]|0;o=(n|0)<1;do{if(!o){p=((fa(n+1|0,n)|0)/2|0)+1|0;q=1;while(1){r=n-q|0;s=r+1|0;t=r+2|0;u=p-q|0;if((n|0)<(t|0)){v=0.0}else{w=t;t=u;x=0.0;while(1){y=x+ +h[b+(t<<3)>>3]*+h[j+(w+ -1<<3)>>3];if((w|0)<(n|0)){x=y;t=t+1|0;w=w+1|0}else{v=y;break}}}x=+h[b+(u+ -1<<3)>>3];do{if(x!=0.0){z=x}else{if((r|0)<0){A=x}else{w=1;t=s;y=x;while(1){B=+h[b+(t+ -1<<3)>>3];if(!(B>=0.0)){C=-B}else{C=B}B=y>=C?y:C;D=t-w+n|0;if((w|0)<(s|0)){w=w+1|0;t=D;y=B}else{A=B;break}}}y=m*A;if(!(y==0.0)){z=y;break}z=m}}while(0);h[j+(r<<3)>>3]=(+h[f+(r<<3)>>3]-v)/z;if((q|0)<(n|0)){q=q+1|0;p=u}else{break}}if(o){break}else{E=1}while(1){p=E+ -1|0;h[k+(p<<3)>>3]=0.0;h[l+(p<<3)>>3]=+h[e+(p<<3)>>3]*+h[j+(p<<3)>>3];if((E|0)<(n|0)){E=E+1|0}else{break}}}}while(0);z=+uZa(a,l);if(z<=+h[g>>3]){i=d;return 0}E=c[a>>2]|0;if((E|0)>=1){n=E;o=1;p=1;while(1){q=o+ -1|0;v=+h[f+(q<<3)>>3];if((o|0)>(E|0)){F=p}else{s=o;t=p;while(1){w=k+(s+ -1<<3)|0;h[w>>3]=+h[w>>3]+v*+h[b+(t+ -1<<3)>>3];if((s|0)<(E|0)){t=t+1|0;s=s+1|0}else{break}}F=p+n|0}s=k+(q<<3)|0;h[s>>3]=+h[s>>3]/+h[e+(q<<3)>>3];if((o|0)<(E|0)){n=n+ -1|0;o=o+1|0;p=F}else{break}}}v=+uZa(a,k);m=+h[g>>3];do{if(v==0.0){G=m;H=m/z;I=0.0}else{F=c[a>>2]|0;p=(F|0)<1;do{if(!p){o=1;while(1){n=o+ -1|0;E=k+(n<<3)|0;h[E>>3]=+h[E>>3]/v/+h[e+(n<<3)>>3];if((o|0)<(F|0)){o=o+1|0}else{break}}if(p){break}else{J=F;K=1;L=1}while(1){if((K|0)>(F|0)){M=L;N=0.0}else{o=K;u=L;A=0.0;while(1){O=A+ +h[b+(u+ -1<<3)>>3]*+h[k+(o+ -1<<3)>>3];if((o|0)<(F|0)){A=O;u=u+1|0;o=o+1|0}else{break}}M=L+J|0;N=O}h[l+(K+ -1<<3)>>3]=N;if((K|0)<(F|0)){J=J+ -1|0;K=K+1|0;L=M}else{break}}}}while(0);A=+uZa(a,l);C=v/A/A;A=+h[g>>3];if(C>=A){G=A;H=0.0;I=C;break}A=+uZa(a,f);x=+h[g>>3];y=C/x;B=A/v*(A/z)*y;A=x/z;P=B-A;Q=y*y;y=1.0-Q;G=x;H=A*y/(+V(+(P*P+y*(1.0-A*A)))+(B-A*Q));I=C}}while(0);z=(1.0-H)*(!(I<=G)?G:I);g=c[a>>2]|0;if((g|0)<1){i=d;return 0}else{R=1}while(1){a=R+ -1|0;f=j+(a<<3)|0;h[f>>3]=z*+h[k+(a<<3)>>3]+H*+h[f>>3];if((R|0)<(g|0)){R=R+1|0}else{break}}i=d;return 0}function tZa(a){a=a|0;i=i;return+(+h[255576+((((c[a>>2]<<3)+ -8|0)/8|0)<<3)>>3])}function uZa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0;d=i;e=c[a>>2]|0;f=1304.0e16/+(e|0);do{if((e|0)<1){g=0.0;j=0.0}else{a=1;k=0.0;l=0.0;m=0.0;n=0.0;o=0.0;while(1){p=+h[b+(a+ -1<<3)>>3];if(!(p>=0.0)){q=-p}else{q=p}do{if(q>3.834e-20&q<f){r=k;s=l+q*q;t=m;u=n;v=o}else{if(!(q<=3.834e-20)){if(!(q<=n)){p=n/q;r=k*p*p+1.0;s=l;t=m;u=q;v=o;break}else{p=q/n;r=k+p*p;s=l;t=m;u=n;v=o;break}}if(!(q<=o)){p=o/q;r=k;s=l;t=m*p*p+1.0;u=n;v=q;break}if(!(q!=0.0)){r=k;s=l;t=m;u=n;v=o;break}p=q/o;r=k;s=l;t=m+p*p;u=n;v=o}}while(0);if((a|0)<(e|0)){a=a+1|0;k=r;l=s;m=t;n=u;o=v}else{break}}if(!(r==0.0)){w=u*+V(+(r+s/u/u));i=d;return+w}if(s==0.0){g=t;j=v;break}if(!(s>=v)){x=0.0}else{x=+V(+(s*(t*v*(v/s)+1.0)))}if(!(s<v)){w=x;i=d;return+w}w=+V(+(v*(t*v+s/v)));i=d;return+w}}while(0);w=j*+V(+g);i=d;return+w}function vZa(a,b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;var B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,ga=0,ha=0,ia=0.0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0.0,wa=0,xa=0.0,ya=0,za=0.0,Aa=0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0.0,Ka=0.0,La=0,Ma=0.0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0.0;B=i;i=i+32|0;C=B;D=B+8|0;E=B+16|0;F=B+24|0;G=c[g>>2]|0;H=~G;I=+tZa(255608);c[p>>2]=0;c[E>>2]=0;c[q>>2]=0;c[r>>2]=0;K=c[b>>2]|0;a:do{if((K|0)<1){L=97}else{if((c[g>>2]|0)<(K|0)){L=97;break}if(+h[j>>3]<0.0){L=97;break}if((c[k>>2]|0)<1){L=97;break}if(+h[n>>3]<=0.0){L=97;break}if((c[t>>2]|0)<((fa(K+1|0,K)|0)/2|0|0)){L=97;break}if((c[m>>2]|0)==2){M=1;while(1){if(+h[l+(M+ -1<<3)>>3]<=0.0){L=97;break a}if((M|0)<(K|0)){M=M+1|0}else{break}}}c[E>>2]=1;M=a;Ne[M&15](b,d,e,f,g,E,z,A)|0;c[q>>2]=1;N=c[E>>2]|0;if((N|0)<0){O=N;L=98;break}P=+uZa(b,e);c[E>>2]=2;Ne[M&15](b,d,e,f,g,E,z,A)|0;c[r>>2]=(c[r>>2]|0)+1;N=c[E>>2]|0;if((N|0)<0){O=N;L=98;break}N=C;Q=P;R=1;S=0;T=0;U=0;V=0;P=0.0;b:while(1){DZa(b,b,f,g,255616,N,255608,v,w,x)|0;do{if((R|0)==1){W=c[b>>2]|0;do{if((c[m>>2]|0)==2){L=20}else{if((W|0)<1){break}else{X=1}while(1){Y=X+ -1|0;Z=w+(Y<<3)|0;_=l+(Y<<3)|0;h[_>>3]=+h[Z>>3];if(+h[Z>>3]==0.0){h[_>>3]=1.0}if((X|0)<(W|0)){X=X+1|0}else{L=20;break}}}}while(0);do{if((L|0)==20){L=0;if((W|0)<1){break}else{$=1}while(1){_=$+ -1|0;h[x+(_<<3)>>3]=+h[l+(_<<3)>>3]*+h[d+(_<<3)>>3];if(($|0)<(W|0)){$=$+1|0}else{break}}}}while(0);aa=+uZa(b,x);ba=+h[n>>3];ca=aa*ba;h[F>>3]=ca;if(!(ca==0.0)){da=aa;break}h[F>>3]=ba;da=aa}else{da=P}}while(0);W=c[b>>2]|0;_=(W|0)<1;do{if(_){L=35}else{Z=1;while(1){Y=Z+ -1|0;h[u+(Y<<3)>>3]=+h[e+(Y<<3)>>3];if((Z|0)<(W|0)){Z=Z+1|0}else{break}}if(_){L=35;break}else{ea=1}while(1){Z=fa(ea,G)|0;aa=+h[f+(ea+H+Z<<3)>>3];do{if(!(aa==0.0)){Y=(ea|0)>(W|0);if(Y){break}ga=Z+H|0;ha=ea;ba=0.0;while(1){ia=ba+ +h[f+(ga+ha<<3)>>3]*+h[u+(ha+ -1<<3)>>3];if((ha|0)<(W|0)){ba=ia;ha=ha+1|0}else{break}}ba=-ia/aa;if(Y){break}ha=Z+H|0;ga=ea;while(1){ja=u+(ga+ -1<<3)|0;h[ja>>3]=+h[ja>>3]+ba*+h[f+(ha+ga<<3)>>3];if((ga|0)<(W|0)){ga=ga+1|0}else{break}}}}while(0);if((ea|0)<(W|0)){ea=ea+1|0}else{break}}c[D>>2]=0;if(_){break}else{ka=0;la=1}while(1){Z=(ka|0)>1?ka:1;ga=Z+ -1|0;ha=Rqb(ga|0,0,Z+ -2|0,0)|0;Z=Kqb(ha|0,J&1|0,1)|0;ha=la+ -1|0;if((la|0)<2){ma=la}else{Y=(fa(la,G)|0)+H|0;ja=W+ka+(fa(ga,W+ -2|0)|0)|0;ga=1;na=la;while(1){h[s+(na+ -1<<3)>>3]=+h[f+(Y+ga<<3)>>3];if((ga|0)<(ha|0)){na=na-ga+W|0;ga=ga+1|0}else{break}}ma=ja-Z|0}ga=v+(ha<<3)|0;h[s+(ma+ -1<<3)>>3]=+h[ga>>3];if(+h[ga>>3]==0.0){c[D>>2]=1}if((la|0)<(W|0)){ka=ka+1|0;la=la+1|0}else{break}}}}while(0);if((L|0)==35){L=0;c[D>>2]=0}CZa(b,b,f,g,v)|0;do{if((c[m>>2]|0)==2){oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da}else{W=c[b>>2]|0;if((W|0)<1){oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da;break}else{wa=1}while(1){_=wa+ -1|0;ga=l+(_<<3)|0;aa=+h[ga>>3];ba=+h[w+(_<<3)>>3];h[ga>>3]=aa>=ba?aa:ba;if((wa|0)<(W|0)){wa=wa+1|0}else{oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da;break}}}}while(0);while(1){W=c[o>>2]|0;do{if((W|0)>=1){c[E>>2]=0;if(((pa+ -1|0)%(W|0)|0|0)!=0){break}Ne[M&15](b,d,e,f,g,E,z,A)|0;ga=c[E>>2]|0;if((ga|0)<0){O=ga;L=98;break a}}}while(0);sZa(b,s,t,l,u,F,v,w,x)|0;W=c[b>>2]|0;if((W|0)>=1){ga=1;while(1){_=ga+ -1|0;na=v+(_<<3)|0;ba=+h[na>>3];h[na>>3]=-ba;h[w+(_<<3)>>3]=+h[d+(_<<3)>>3]-ba;h[x+(_<<3)>>3]=+h[l+(_<<3)>>3]*+h[na>>3];if((ga|0)<(W|0)){ga=ga+1|0}else{break}}}ba=+uZa(b,x);if((pa|0)==1){aa=+h[F>>3];h[F>>3]=aa<=ba?aa:ba}c[E>>2]=1;Ne[M&15](b,w,y,f,g,E,z,A)|0;c[q>>2]=(c[q>>2]|0)+1;ga=c[E>>2]|0;if((ga|0)<0){O=ga;L=98;break a}aa=+uZa(b,y);if(aa<oa){ca=aa/oa;xa=1.0-ca*ca}else{xa=-1.0}ga=c[b>>2]|0;if((ga|0)>=1){W=1;na=ga;_=1;while(1){if((W|0)>(ga|0)){ya=_;za=0.0}else{Y=W;Aa=_;ca=0.0;while(1){Ba=ca+ +h[s+(Aa+ -1<<3)>>3]*+h[v+(Y+ -1<<3)>>3];if((Y|0)<(ga|0)){ca=Ba;Aa=Aa+1|0;Y=Y+1|0}else{break}}ya=_+na|0;za=Ba}Y=W+ -1|0;h[x+(Y<<3)>>3]=za+ +h[u+(Y<<3)>>3];if((W|0)<(ga|0)){W=W+1|0;na=na+ -1|0;_=ya}else{break}}}ca=+uZa(b,x);do{if(ca<oa){Ca=ca/oa;Da=1.0-Ca*Ca;if(!(Da>0.0)){Ea=0.0;L=65;break}Ca=xa/Da;if(!(Ca>=.1)){Ea=Ca;L=65;break}_=sa+1|0;if(Ca>=.5|(sa|0)>0){Da=+h[F>>3];Fa=ba*2.0;h[F>>3]=Da>=Fa?Da:Fa}Fa=Ca+-1.0;if(!(Fa>=0.0)){Ga=-Fa}else{Ga=Fa}if(!(Ga<=.1)){Ha=0;Ia=_;Ja=Ca;break}h[F>>3]=ba*2.0;Ha=0;Ia=_;Ja=Ca}else{Ea=0.0;L=65}}while(0);if((L|0)==65){L=0;h[F>>3]=+h[F>>3]*.5;Ha=ra+1|0;Ia=0;Ja=Ea}if(Ja<1.0e-4){Ka=oa;La=pa;Ma=va}else{_=c[b>>2]|0;if((_|0)>=1){na=1;while(1){W=na+ -1|0;ga=w+(W<<3)|0;ca=+h[ga>>3];h[d+(W<<3)>>3]=ca;h[ga>>3]=ca*+h[l+(W<<3)>>3];h[e+(W<<3)>>3]=+h[y+(W<<3)>>3];if((na|0)<(_|0)){na=na+1|0}else{break}}}Ka=aa;La=pa+1|0;Ma=+uZa(b,w)}Na=!(xa>=.001)?ta+1|0:0;Oa=!(xa>=.1)?ua+qa|0:0;ca=+h[F>>3];if(ca<=Ma*+h[j>>3]|Ka==0.0){L=77;break b}if((c[p>>2]|0)!=0){L=97;break a}if((c[q>>2]|0)<(c[k>>2]|0)){Pa=0}else{c[p>>2]=2;Pa=2}Ca=ca*.1;if(!((Ca>=ba?Ca:ba)*.1<=I*Ma)){Qa=Pa}else{c[p>>2]=3;Qa=3}if((Oa|0)==5){c[p>>2]=4;Ra=4}else{Ra=Qa}if((Na|0)==10){L=86;break b}if((Ra|0)!=0){L=97;break a}if((Ha|0)==2){break}na=c[b>>2]|0;if((na|0)>=1){_=!(Ja>=1.0e-4);W=1;while(1){ga=(fa(W,G)|0)+H|0;Y=1;Ca=0.0;while(1){Sa=Ca+ +h[f+(ga+Y<<3)>>3]*+h[y+(Y+ -1<<3)>>3];if((Y|0)<(na|0)){Ca=Sa;Y=Y+1|0}else{break}}Y=W+ -1|0;h[w+(Y<<3)>>3]=(Sa- +h[x+(Y<<3)>>3])/ba;Ca=+h[l+(Y<<3)>>3];ga=v+(Y<<3)|0;h[ga>>3]=Ca*(Ca*+h[ga>>3]/ba);if(!_){h[u+(Y<<3)>>3]=Sa}if((W|0)<(na|0)){W=W+1|0}else{break}}}FZa(b,b,s,t,v,w,x,D)|0;EZa(b,b,f,g,w,x)|0;W=255608;EZa(W,b,u,W,w,x)|0;oa=Ka;pa=La;qa=0;ra=Ha;sa=Ia;ta=Na;ua=Oa;va=Ma}c[E>>2]=2;Ne[M&15](b,d,e,f,g,E,z,A)|0;c[r>>2]=(c[r>>2]|0)+1;W=c[E>>2]|0;if((W|0)<0){O=W;L=98;break a}else{Q=Ka;R=La;S=2;T=Ia;U=Na;V=Oa;P=Ma}}if((L|0)==77){c[p>>2]=1;L=97;break}else if((L|0)==86){c[p>>2]=5;L=97;break}}}while(0);if((L|0)==97){Oa=c[E>>2]|0;if((Oa|0)<0){O=Oa;L=98}}if((L|0)==98){c[p>>2]=O}c[E>>2]=0;if((c[o>>2]|0)<=0){i=B;return 0}Ne[a&15](b,d,e,f,g,E,z,A)|0;i=B;return 0}function wZa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;g=i;if((a[b]|0)==(a[e]|0)){h=1;i=g;return h|0}a[255640]=1;f=d[b]|0;c[63906]=f;b=d[e]|0;c[63908]=b;if((f+ -97|0)>>>0<26){e=f+ -32|0;c[63906]=e;j=e}else{j=f}if((b+ -97|0)>>>0<26){f=b+ -32|0;c[63908]=f;k=f}else{k=b}h=(j|0)==(k|0)|0;i=g;return h|0}function xZa(b,d,e,f,g,j,k,l,m,n,o,p,q){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0.0,X=0.0,Y=0.0,Z=0,_=0.0,$=0.0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0,ha=0.0,ia=0,ja=0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0,ya=0.0,za=0,Aa=0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0.0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0;r=i;if((c[j>>2]|0)>0){c[265172>>2]=6;zeb(265168)|0;Qdb(265912,j,4)|0;heb()|0}c[q>>2]=0;s=(c[e>>2]|0)<1?3:0;c[q>>2]=s;t=(c[l>>2]|0)<1?4:s;c[q>>2]=t;if((t|0)!=0){i=r;return 0}c[65594]=0;c[66200]=0;c[66188]=0;a[264776]=0;t=c[e>>2]|0;c[65148]=1;do{if((t|0)>=1){s=0;u=1;while(1){if(+h[d+(u+ -1<<3)>>3]!=0.0){v=s+1|0;c[65594]=v;w=v}else{w=s}if((u|0)<(t|0)){s=w;u=u+1|0}else{break}}c[65148]=t+1;if((w|0)<=0){break}u=p;s=f;a:while(1){v=c[e>>2]|0;c[65148]=1;if((v|0)>=1){x=1;while(1){h[257064+((x*21|0)+ -21<<3)>>3]=+h[b+(x+ -1<<3)>>3];if((x|0)<(v|0)){x=x+1|0}else{break}}c[65148]=v+1}c[66192]=2;x=c[e>>2]|0;c[65148]=1;if((x|0)>=1){y=2;z=1;while(1){A=z+ -1|0;B=d+(A<<3)|0;C=+h[B>>3];if(C==0.0){D=y}else{E=c[e>>2]|0;c[65150]=1;if((E|0)<1){F=C}else{G=1;while(1){h[257064+((G*21|0)+ -22+y<<3)>>3]=+h[b+(G+ -1<<3)>>3];if((G|0)<(E|0)){G=G+1|0}else{break}}c[65150]=E+1;F=+h[B>>3]}h[257064+((z*21|0)+ -22+y<<3)>>3]=+h[b+(A<<3)>>3]+F;G=y+1|0;c[66192]=G;D=G}G=z+1|0;c[65148]=G;if((z|0)<(x|0)){y=D;z=G}else{break}}}z=c[65594]|0;y=z+1|0;c[65590]=y;c[65148]=1;if((z|0)>=0){z=1;do{x=c[e>>2]|0;c[65150]=1;if((x|0)>=1){v=1;while(1){h[b+(v+ -1<<3)>>3]=+h[257064+((v*21|0)+ -22+z<<3)>>3];if((v|0)<(x|0)){v=v+1|0}else{break}}c[65150]=x+1}se[u&63](e,b,260424+(z+ -1<<3)|0)|0;c[66200]=(c[66200]|0)+1;if((c[j>>2]|0)>=1){c[265196>>2]=6;zeb(265192)|0;Qdb(265912,264800,4)|0;Qdb(265912,260424+((c[65148]|0)+ -1<<3)|0,8)|0;v=c[e>>2]|0;c[65150]=1;if((v|0)>=1){A=1;do{Qdb(265912,b+(A+ -1<<3)|0,8)|0;B=c[65150]|0;A=B+1|0;c[65150]=A;}while((B|0)<(v|0))}heb()|0}v=c[65148]|0;z=v+1|0;c[65148]=z;}while((v|0)<(y|0))}y=c[66188]|0;b:while(1){c[66188]=y+1;c[66100]=1;c[66096]=1;C=+h[32553];h[33049]=C;h[33051]=C;z=c[65590]|0;c[65148]=2;if((z|0)<2){H=1}else{I=C;K=C;v=1;A=2;while(1){C=+h[260424+(A+ -1<<3)>>3];do{if(!(C<=K)){c[66100]=A;L=+h[260424+(A+ -1<<3)>>3];h[33049]=L;M=I;N=L;O=A}else{if(C>=I){M=I;N=K;O=v;break}c[66096]=A;L=+h[260424+(A+ -1<<3)>>3];h[33051]=L;M=L;N=K;O=v}}while(0);if((A|0)<(z|0)){I=M;K=N;v=O;A=A+1|0}else{break}}c[65148]=z+1;H=O}A=c[e>>2]|0;c[65148]=1;if((A|0)>=1){v=1;while(1){h[262544+(v+ -1<<3)>>3]=0.0;if((v|0)<(A|0)){v=v+1|0}else{break}}c[65148]=A+1}c[65148]=1;if((z|0)>=1){v=1;do{do{if((v|0)==(H|0)){P=H}else{x=c[e>>2]|0;c[65150]=1;if((x|0)<1){P=v;break}else{Q=1}while(1){B=262544+(Q+ -1<<3)|0;h[B>>3]=+h[257064+((Q*21|0)+ -22+v<<3)>>3]+ +h[B>>3];if((Q|0)<(x|0)){Q=Q+1|0}else{break}}c[65150]=x+1;P=v}}while(0);v=P+1|0;c[65148]=v;}while((P|0)<(z|0))}z=c[e>>2]|0;c[65150]=1;if((z|0)>=1){K=+(c[65594]|0);v=1;while(1){A=262544+(v+ -1<<3)|0;h[A>>3]=+h[A>>3]/K;if((v|0)<(z|0)){v=v+1|0}else{break}}c[65150]=z+1}v=c[e>>2]|0;c[65148]=1;if((v|0)>=1){A=1;while(1){B=A+ -1|0;K=+h[262544+(B<<3)>>3];h[264824+(B<<3)>>3]=K+(K- +h[257064+((A*21|0)+ -22+H<<3)>>3]);if((A|0)<(v|0)){A=A+1|0}else{break}}c[65148]=v+1}se[u&63](e,264824,264816)|0;A=(c[66200]|0)+1|0;c[66200]=A;z=c[j>>2]|0;do{if((z|0)>=1){if(((A|0)%(z|0)|0|0)!=0){break}c[265220>>2]=6;zeb(265216)|0;Qdb(265912,264800,4)|0;Qdb(265912,264816,8)|0;B=c[e>>2]|0;c[65150]=1;if((B|0)>=1){E=1;do{Qdb(265912,264824+(E+ -1<<3)|0,8)|0;G=c[65150]|0;E=G+1|0;c[65150]=E;}while((G|0)<(B|0))}heb()|0}}while(0);K=+h[33102];c:do{if(!(K>=+h[33051])){z=c[e>>2]|0;c[65148]=1;if((z|0)>=1){A=1;while(1){v=A+ -1|0;I=+h[262544+(v<<3)>>3];h[264992+(v<<3)>>3]=I+(+h[264824+(v<<3)>>3]-I)*2.0;if((A|0)<(z|0)){A=A+1|0}else{break}}c[65148]=z+1}se[u&63](e,264992,264984)|0;A=(c[66200]|0)+1|0;c[66200]=A;v=c[j>>2]|0;do{if((v|0)>=1){if(((A|0)%(v|0)|0|0)!=0){break}c[265244>>2]=6;zeb(265240)|0;Qdb(265912,264800,4)|0;Qdb(265912,264984,8)|0;B=c[e>>2]|0;c[65150]=1;if((B|0)>=1){E=1;do{Qdb(265912,264992+(E+ -1<<3)|0,8)|0;G=c[65150]|0;E=G+1|0;c[65150]=E;}while((G|0)<(B|0))}heb()|0}}while(0);I=+h[33123];if(I>=+h[33051]){R=118;break}v=c[e>>2]|0;c[65148]=1;A=c[66100]|0;if((v|0)>=1){z=1;while(1){B=z+ -1|0;if(+h[d+(B<<3)>>3]!=0.0){h[257064+((z*21|0)+ -22+A<<3)>>3]=+h[264992+(B<<3)>>3]}if((z|0)<(v|0)){z=z+1|0}else{break}}c[65148]=v+1}h[260424+(A+ -1<<3)>>3]=I}else{z=c[65590]|0;c[65148]=1;if((z|0)>=1){B=c[66100]|0;E=1;while(1){if((E|0)!=(B|0)){if(K<+h[260424+(E+ -1<<3)>>3]){R=118;break c}}x=E+1|0;c[65148]=x;if((E|0)<(z|0)){E=x}else{break}}}if(!(K>+h[33049])){E=c[e>>2]|0;c[65148]=1;z=c[66100]|0;if((E|0)>=1){B=1;while(1){A=B+ -1|0;if(+h[d+(A<<3)>>3]!=0.0){h[257064+((B*21|0)+ -22+z<<3)>>3]=+h[264824+(A<<3)>>3]}if((B|0)<(E|0)){B=B+1|0}else{break}}c[65148]=E+1}h[33049]=K;h[260424+(z+ -1<<3)>>3]=K}B=c[e>>2]|0;c[65148]=1;if((B|0)>=1){A=c[66100]|0;v=1;while(1){x=v+ -1|0;h[264992+(x<<3)>>3]=+h[257064+((v*21|0)+ -22+A<<3)>>3]*.5+ +h[262544+(x<<3)>>3]*.5;if((v|0)<(B|0)){v=v+1|0}else{break}}c[65148]=B+1}se[u&63](e,264992,264984)|0;v=(c[66200]|0)+1|0;c[66200]=v;A=c[j>>2]|0;do{if((A|0)>=1){if(((v|0)%(A|0)|0|0)!=0){break}c[265268>>2]=6;zeb(265264)|0;Qdb(265912,264800,4)|0;Qdb(265912,264984,8)|0;z=c[e>>2]|0;c[65150]=1;if((z|0)>=1){E=1;do{Qdb(265912,264992+(E+ -1<<3)|0,8)|0;x=c[65150]|0;E=x+1|0;c[65150]=E;}while((x|0)<(z|0))}heb()|0}}while(0);I=+h[33123];if(!(I>+h[33049])){A=c[e>>2]|0;c[65148]=1;v=c[66100]|0;if((A|0)>=1){B=1;while(1){z=B+ -1|0;if(+h[d+(z<<3)>>3]!=0.0){h[257064+((B*21|0)+ -22+v<<3)>>3]=+h[264992+(z<<3)>>3]}if((B|0)<(A|0)){B=B+1|0}else{break}}c[65148]=A+1}h[260424+(v+ -1<<3)>>3]=I;break}B=c[65590]|0;c[65148]=1;if((B|0)<1){break}else{S=1}do{z=c[66096]|0;do{if((S|0)!=(z|0)){E=c[e>>2]|0;c[65150]=1;if((E|0)>=1){x=S+ -22|0;G=1;while(1){if(+h[d+(G+ -1<<3)>>3]!=0.0){T=(G*21|0)+ -22|0;U=257064+(T+S<<3)|0;h[U>>3]=(+h[U>>3]+ +h[257064+(T+z<<3)>>3])*.5}h[b+(G+ -1<<3)>>3]=+h[257064+(x+(G*21|0)<<3)>>3];if((G|0)<(E|0)){G=G+1|0}else{break}}c[65150]=E+1}se[u&63](e,b,260424+(S+ -1<<3)|0)|0;G=(c[66200]|0)+1|0;c[66200]=G;x=c[j>>2]|0;if((x|0)<1){break}if(((G|0)%(x|0)|0|0)!=0){break}c[265292>>2]=6;zeb(265288)|0;Qdb(265912,264800,4)|0;Qdb(265912,260424+((c[65148]|0)+ -1<<3)|0,8)|0;x=c[e>>2]|0;c[65150]=1;if((x|0)>=1){G=1;do{Qdb(265912,b+(G+ -1<<3)|0,8)|0;T=c[65150]|0;G=T+1|0;c[65150]=G;}while((T|0)<(x|0))}heb()|0}}while(0);z=c[65148]|0;S=z+1|0;c[65148]=S;}while((z|0)<(B|0))}}while(0);if((R|0)==118){R=0;B=c[e>>2]|0;c[65148]=1;v=c[66100]|0;if((B|0)>=1){A=1;while(1){z=A+ -1|0;if(+h[d+(z<<3)>>3]!=0.0){h[257064+((A*21|0)+ -22+v<<3)>>3]=+h[264824+(z<<3)>>3]}if((A|0)<(B|0)){A=A+1|0}else{break}}c[65148]=B+1}h[260424+(v+ -1<<3)>>3]=+h[33102]}A=c[66188]|0;if((A|0)<(c[l>>2]|0)){y=A;continue}h[33052]=0.0;h[33098]=0.0;A=c[65590]|0;c[65148]=1;z=(A|0)<1;do{if(z){K=+(A|0);h[33098]=0.0/K;c[65148]=1;W=K;X=0.0}else{x=1;K=0.0;while(1){Y=+h[260424+(x+ -1<<3)>>3]+K;if((x|0)<(A|0)){K=Y;x=x+1|0}else{break}}K=+(A|0);I=Y/K;h[33098]=I;c[65148]=1;if(z){W=K;X=0.0;break}else{Z=1;_=0.0}while(1){C=+h[260424+(Z+ -1<<3)>>3]-I;$=_+C*C;if((Z|0)<(A|0)){_=$;Z=Z+1|0}else{break}}h[33052]=$;c[65148]=A+1;W=K;X=$}}while(0);I=+V(+(X/W));h[33052]=I;do{if(!(I<=+h[k>>3])){if((c[66200]|0)>(c[g>>2]|0)){break}a[264776]=0;c[66188]=0;y=0;continue b}}while(0);v=c[e>>2]|0;c[65148]=1;if((v|0)>=1){B=1;while(1){x=B+ -1|0;if(!(+h[d+(x<<3)>>3]==0.0)){h[b+(x<<3)>>3]=0.0;c[65150]=1;if(z){aa=b+(B+ -1<<3)|0}else{x=B*21|0;G=b+(B+ -1<<3)|0;I=+h[G>>3];E=1;while(1){C=+h[257064+(E+ -22+x<<3)>>3]+I;h[G>>3]=C;if((E|0)<(A|0)){E=E+1|0;I=C}else{break}}c[65150]=A+1;aa=G}h[aa>>3]=+h[aa>>3]/W}if((B|0)<(v|0)){B=B+1|0}else{break}}c[65148]=v+1}se[u&63](e,b,f)|0;B=(c[66200]|0)+1|0;c[66200]=B;A=c[j>>2]|0;do{if((A|0)<1){ba=B}else{if(((B|0)%(A|0)|0|0)!=0){ba=B;break}c[265316>>2]=6;zeb(265312)|0;Qdb(265912,264800,4)|0;Qdb(265912,s,8)|0;z=c[e>>2]|0;c[65150]=1;if((z|0)>=1){E=1;do{Qdb(265912,b+(E+ -1<<3)|0,8)|0;x=c[65150]|0;E=x+1|0;c[65150]=E;}while((x|0)<(z|0))}heb()|0;ba=c[66200]|0}}while(0);if((ba|0)>(c[g>>2]|0)){R=150;break a}if((c[j>>2]|0)>=0){c[265436>>2]=6;zeb(265432)|0;heb()|0;c[265460>>2]=6;zeb(265456)|0;B=c[e>>2]|0;c[65148]=1;if((B|0)>=1){A=1;do{Qdb(265912,b+(A+ -1<<3)|0,8)|0;v=c[65148]|0;A=v+1|0;c[65148]=A;}while((v|0)<(B|0))}heb()|0;c[265484>>2]=6;zeb(265480)|0;Qdb(265912,s,8)|0;heb()|0}if(a[264776]&1){I=+h[33098];K=+h[33144]-I;if(!(K>=0.0)){ca=-K}else{ca=K}if(!(ca>=+h[k>>3])){break}else{da=I}}else{a[264776]=1;da=+h[33098]}h[33144]=da;c[66188]=0;y=0}if((c[j>>2]|0)>=0){c[265508>>2]=6;zeb(265504)|0;Qdb(265912,264800,4)|0;heb()|0;c[265532>>2]=6;zeb(265528)|0;y=c[e>>2]|0;c[65148]=1;if((y|0)>=1){B=1;do{Qdb(265912,b+(B+ -1<<3)|0,8)|0;A=c[65148]|0;B=A+1|0;c[65148]=B;}while((A|0)<(y|0))}heb()|0;c[265556>>2]=6;zeb(265552)|0;Qdb(265912,s,8)|0;heb()|0}if((c[m>>2]|0)<1){R=312;break}if((c[j>>2]|0)>-1){c[265580>>2]=6;zeb(265576)|0;heb()|0}h[33051]=+h[f>>3];c[66202]=0;y=c[65590]|0;c[65148]=1;if((y|0)>=1){B=1;while(1){A=260424+(B+ -1<<3)|0;I=+h[A>>3]- +h[f>>3];if(!(I>=0.0)){ea=-I}else{ea=I}if(ea>=+h[n>>3]){v=B+1|0;c[65148]=v;if((B|0)<(y|0)){B=v;continue}else{break}}v=c[e>>2]|0;c[65150]=1;if((v|0)>=1){z=B+ -22|0;E=1;while(1){G=E+ -1|0;if(+h[d+(G<<3)>>3]!=0.0){x=257064+((E*21|0)+ -22+B<<3)|0;I=+h[x>>3];h[x>>3]=I+(I- +h[b+(G<<3)>>3])}h[264992+(E+ -1<<3)>>3]=+h[257064+(z+(E*21|0)<<3)>>3];if((E|0)<(v|0)){E=E+1|0}else{break}}c[65150]=v+1}se[u&63](e,264992,A)|0;c[66202]=(c[66202]|0)+1;c[66200]=(c[66200]|0)+1;E=c[65148]|0;I=+h[260424+(E+ -1<<3)>>3];if(I>=+h[33051]){B=E;continue}h[33051]=I;if(!((c[j>>2]|0)>-1)){B=E;continue}c[265604>>2]=6;zeb(265600)|0;Qdb(265912,264800,4)|0;Qdb(265912,264408,8)|0;E=c[e>>2]|0;c[65150]=1;if((E|0)>=1){z=1;do{Qdb(265912,264992+(z+ -1<<3)|0,8)|0;G=c[65150]|0;z=G+1|0;c[65150]=z;}while((G|0)<(E|0))}heb()|0;B=c[65148]|0}}B=c[65594]|0;c[65148]=1;do{if((B|0)<1){h[32578]=+h[32553];c[65148]=1;ga=B;R=202}else{y=1;do{E=y+1|0;c[65158]=E;z=c[e>>2]|0;c[65150]=1;if((z|0)>=1){A=1;while(1){v=A*21|0;h[264824+(A+ -1<<3)>>3]=(+h[257064+(v+ -21<<3)>>3]+ +h[257064+(v+ -22+E<<3)>>3])*.5;if((A|0)<(z|0)){A=A+1|0}else{break}}c[65150]=z+1}se[u&63](e,264824,262384+(y+ -1<<3)|0)|0;c[66202]=(c[66202]|0)+1;c[66200]=(c[66200]|0)+1;A=c[65148]|0;y=A+1|0;c[65148]=y;}while((A|0)<(B|0));y=c[65594]|0;I=+h[32553];h[32578]=I;c[65148]=1;if((y|0)<1){ga=y;R=202;break}else{ha=I;ia=1}while(1){A=ia+ -1|0;c[65158]=A;c[65160]=ia+1;if((ia|0)<2){ja=ia;ka=ha}else{c[65150]=1;E=1;while(1){v=E+1|0;c[65162]=v;G=c[e>>2]|0;c[65152]=1;if((G|0)>=1){x=c[65160]|0;T=1;while(1){U=(T*21|0)+ -22|0;h[264992+(T+ -1<<3)>>3]=(+h[257064+(U+x<<3)>>3]+ +h[257064+(U+v<<3)>>3])*.5;if((T|0)<(G|0)){T=T+1|0}else{break}}c[65152]=G+1}se[u&63](e,264992,264984)|0;c[66202]=(c[66202]|0)+1;c[66200]=(c[66200]|0)+1;T=c[65148]|0;v=T+ -1|0;x=(fa(v,T)|0)/2|0;U=c[65150]|0;la=U+x|0;c[65154]=la;I=+h[32578];h[262704+(la+ -1<<3)>>3]=(+h[33123]+I- +h[262384+(v<<3)>>3]- +h[262384+(U+ -1<<3)>>3])*2.0;v=U+1|0;c[65150]=v;if((U|0)<(A|0)){E=v}else{ja=T;ka=I;break}}}E=ja+1|0;c[65148]=E;if((ja|0)<(y|0)){ha=ka;ia=E}else{break}}y=c[65594]|0;c[65154]=0;c[65148]=1;E=(y|0)<1;if(E){c[65148]=1;ma=1;na=y;break}A=y+ -1|0;z=A<<1;T=Rqb(A|0,0,y+ -2|0,0)|0;A=Kqb(T|0,J&1|0,1)|0;T=0;v=1;while(1){U=T+v|0;h[262704+(U+ -1<<3)>>3]=(+h[260424+(v<<3)>>3]+ka- +h[262384+(v+ -1<<3)>>3]*2.0)*2.0;if((v|0)<(y|0)){v=v+1|0;T=U}else{break}}c[65158]=v+1;c[65154]=(z|1)+A;c[65148]=1;if(E){ma=1;na=y;break}I=ka*3.0;T=1;while(1){U=262384+(T+ -1<<3)|0;h[U>>3]=+h[U>>3]*2.0-(+h[260424+(T<<3)>>3]+I)*.5;if((T|0)<(y|0)){T=T+1|0}else{break}}c[65158]=T+1;c[65148]=y+1;ma=E;na=y}}while(0);if((R|0)==202){R=0;c[65154]=0;c[65148]=1;ma=(ga|0)<1;na=ga}B=c[e>>2]|0;c[65148]=1;if((B|0)>=1){A=1;while(1){h[264424+(A+ -1<<3)>>3]=+h[257064+((A*21|0)+ -21<<3)>>3];if((A|0)<(B|0)){A=A+1|0}else{break}}c[65148]=B+1}c[65148]=1;do{if(ma){c[65148]=1}else{A=1;while(1){z=A+1|0;c[65158]=z;v=c[e>>2]|0;c[65150]=1;if((v|0)>=1){U=1;while(1){la=U*21|0;x=257064+(la+ -22+z<<3)|0;h[x>>3]=+h[x>>3]- +h[257064+(la+ -21<<3)>>3];if((U|0)<(v|0)){U=U+1|0}else{break}}c[65150]=v+1}c[65148]=z;if((A|0)<(na|0)){A=z}else{break}}c[65148]=1;if(ma){break}else{oa=1}while(1){A=oa+1|0;c[65158]=A;y=c[e>>2]|0;c[65150]=1;if((y|0)>=1){E=1;while(1){T=(E*21|0)+ -22|0;h[257064+(T+oa<<3)>>3]=+h[257064+(T+A<<3)>>3];if((E|0)<(y|0)){E=E+1|0}else{break}}c[65150]=y+1}c[65148]=A;if((oa|0)<(na|0)){oa=A}else{break}}}}while(0);B=262704;yZa(B,262376,B,264584,265160,q,264744)|0;if((c[q>>2]|0)==0){R=226;break}if((c[j>>2]|0)>-1){c[265628>>2]=6;zeb(265624)|0;heb()|0}c[q>>2]=2;if((c[66200]|0)>(c[g>>2]|0)){R=312;break}c[265652>>2]=6;zeb(265648)|0;heb()|0;B=c[e>>2]|0;c[65148]=1;if((B|0)<1){continue}else{pa=1}while(1){E=d+(pa+ -1<<3)|0;h[E>>3]=+h[E>>3]*.5;if((pa|0)<(B|0)){pa=pa+1|0}else{break}}c[65148]=B+1}if((R|0)==150){c[q>>2]=1;if((c[j>>2]|0)<0){i=r;return 0}c[265340>>2]=6;zeb(265336)|0;Qdb(265912,g,4)|0;heb()|0;c[265364>>2]=6;zeb(265360)|0;Qdb(265912,264416,8)|0;heb()|0;c[265388>>2]=6;zeb(265384)|0;u=c[e>>2]|0;c[65148]=1;if((u|0)>=1){E=1;do{Qdb(265912,b+(E+ -1<<3)|0,8)|0;z=c[65148]|0;E=z+1|0;c[65148]=E;}while((z|0)<(u|0))}heb()|0;c[265412>>2]=6;zeb(265408)|0;Qdb(265912,s,8)|0;heb()|0;i=r;return 0}else if((R|0)==226){u=c[65594]|0;c[66198]=u-(c[66290]|0);c[65148]=1;E=(u|0)<1;do{if(E){h[33095]=0.0;c[65148]=1;qa=0.0}else{z=u+1|0;v=1;while(1){h[260424+(v+ -1<<3)>>3]=0.0;T=v+ -1|0;U=260424+(T<<3)|0;I=+h[U>>3];la=1;while(1){if((la|0)>(v|0)){x=la+ -1|0;ra=x;sa=((fa(x,la)|0)/2|0)+v|0}else{ra=la+ -1|0;sa=((fa(T,v)|0)/2|0)+la|0}ta=+h[262704+(sa+ -1<<3)>>3]*+h[262384+(ra<<3)>>3]+I;if((la|0)<(u|0)){I=ta;la=la+1|0}else{break}}c[65154]=sa;h[U>>3]=ta;if((v|0)<(u|0)){v=v+1|0}else{break}}c[65150]=z;h[33095]=0.0;c[65148]=1;if(E){qa=0.0;break}else{ua=1;va=0.0}while(1){v=ua+ -1|0;wa=va+ +h[260424+(v<<3)>>3]*+h[262384+(v<<3)>>3];if((ua|0)<(u|0)){va=wa;ua=ua+1|0}else{break}}h[33095]=wa;c[65148]=u+1;qa=wa}}while(0);h[33095]=+h[32578]-qa;s=c[e>>2]|0;c[65148]=1;if((s|0)>=1){z=u+1|0;v=1;while(1){h[264992+(v+ -1<<3)>>3]=0.0;if(E){xa=1}else{B=v*21|0;la=264992+(v+ -1<<3)|0;T=1;I=+h[la>>3];while(1){ya=I+ +h[260424+(T+ -1<<3)>>3]*+h[257064+(T+ -22+B<<3)>>3];if((T|0)<(u|0)){I=ya;T=T+1|0}else{break}}h[la>>3]=ya;xa=z}if((v|0)<(s|0)){v=v+1|0}else{break}}c[65148]=s+1;c[65150]=xa}v=c[e>>2]|0;c[65148]=1;if((v|0)>=1){z=1;while(1){u=z+ -1|0;E=264424+(u<<3)|0;h[E>>3]=+h[E>>3]- +h[264992+(u<<3)>>3];if((z|0)<(v|0)){z=z+1|0}else{break}}c[65148]=v+1}if((c[j>>2]|0)>=0){c[265676>>2]=6;zeb(265672)|0;Qdb(265912,264760,8)|0;z=c[e>>2]|0;c[65148]=1;if((z|0)>=1){s=1;do{Qdb(265912,264424+(s+ -1<<3)|0,8)|0;u=c[65148]|0;s=u+1|0;c[65148]=s;}while((u|0)<(z|0))}heb()|0;c[265700>>2]=6;zeb(265696)|0;heb()|0}z=c[e>>2]|0;c[65148]=1;if((z|0)>=1){s=c[65594]|0;v=1;while(1){c[65150]=1;if((s|0)>=1){u=v*21|0;E=s+1|0;T=1;while(1){h[260424+(T+ -1<<3)>>3]=0.0;B=T+ -1|0;x=260424+(B<<3)|0;I=+h[x>>3];za=1;while(1){if((za|0)>(T|0)){Aa=((fa(za+ -1|0,za)|0)/2|0)+T|0}else{Aa=((fa(B,T)|0)/2|0)+za|0}Ba=I+ +h[262704+(Aa+ -1<<3)>>3]*+h[257064+(za+ -22+u<<3)>>3]*.5;if((za|0)<(s|0)){I=Ba;za=za+1|0}else{break}}c[65154]=Aa;h[x>>3]=Ba;if((T|0)<(s|0)){T=T+1|0}else{break}}c[65152]=E;c[65150]=s+1}T=c[e>>2]|0;c[65150]=v;if((v|0)<=(T|0)){u=(s|0)<1;la=s+1|0;za=v;while(1){Ca=v+((fa(za+ -1|0,za)|0)/2|0)|0;B=260680+(Ca+ -1<<3)|0;h[B>>3]=0.0;if(u){Da=1}else{U=za*21|0;Ea=1;I=0.0;while(1){Fa=+h[260424+(Ea+ -1<<3)>>3]*+h[257064+(Ea+ -22+U<<3)>>3]+I;if((Ea|0)<(s|0)){I=Fa;Ea=Ea+1|0}else{break}}h[B>>3]=Fa;Da=la}if((za|0)<(T|0)){za=za+1|0}else{break}}c[65150]=T+1;c[65154]=Ca;c[65152]=Da}za=v+1|0;c[65148]=za;if((v|0)<(z|0)){v=za}else{break}}}c[65150]=0;v=c[e>>2]|0;c[65148]=1;if((v|0)>=1){z=1;s=0;while(1){Ga=s+z|0;h[o+(z+ -1<<3)>>3]=+h[260680+(Ga+ -1<<3)>>3];if((z|0)<(v|0)){s=Ga;z=z+1|0}else{break}}c[65150]=Ga;c[65148]=v+1}if((c[j>>2]|0)<0){i=r;return 0}c[265724>>2]=6;zeb(265720)|0;Qdb(265912,264792,4)|0;heb()|0;c[65592]=1;z=1;d:while(1){c[65154]=z;do{if((z|0)>(c[e>>2]|0)){s=c[65592]|0;if((s|0)==1){c[265748>>2]=6;zeb(265744)|0;heb()|0;yZa(260680,262376,262704,264584,265160,q,264744)|0;c[265772>>2]=6;zeb(265768)|0;heb()|0;c[65592]=3;z=1;continue d}else if((s|0)==2){break d}else if((s|0)!=3){break}c[65592]=2;c[65164]=0;c[65166]=0;s=c[e>>2]|0;c[65148]=1;if((s|0)>=1){za=0;la=1;u=0;E=0;while(1){Ea=(E|0)>1?E:1;U=Ea+1|0;x=Rqb(Ea+ -1|0,0,Ea+ -2|0,0)|0;Ha=Kqb(x|0,J&1|0,1)|0;x=(Ea<<1)+ -1+Ha|0;Ia=u+la|0;Ha=260680+(Ia+ -1<<3)|0;I=+h[Ha>>3];if(I>0.0){Ja=1.0/+V(+I)}else{Ja=0.0}h[Ha>>3]=Ja;Ka=la+ -1|0;if((la|0)<2){La=za;Ma=1;Na=0}else{I=Ja;Oa=1;Pa=za;Qa=0;while(1){Ra=Qa+Oa|0;Sa=260680+(Pa<<3)|0;h[Sa>>3]=+h[Sa>>3]*I*+h[260680+(Ra+ -1<<3)>>3];if((Oa|0)>=(Ka|0)){break}I=+h[Ha>>3];Oa=Oa+1|0;Pa=Pa+1|0;Qa=Ra}La=za+Ea|0;Ma=U;Na=x}Ta=La+1|0;if((la|0)<(s|0)){za=Ta;la=la+1|0;E=E+1|0;u=Ia}else{break}}c[65168]=Na;c[65166]=Ta;c[65164]=Ia;c[65150]=Ma;c[65148]=s+1}c[265796>>2]=6;zeb(265792)|0;heb()|0;c[65164]=0;u=c[e>>2]|0;c[65148]=1;if((u|0)<1){z=1;continue d}else{Ua=1;Va=0}while(1){Wa=Va+Ua|0;E=260680+(Wa+ -1<<3)|0;if(+h[E>>3]!=0.0){h[E>>3]=1.0}if((Ua|0)<(u|0)){Ua=Ua+1|0;Va=Wa}else{break}}c[65164]=Wa;c[65148]=u+1;z=1;continue d}}while(0);T=(fa(z+ -1|0,z)|0)/2|0;c[65164]=T;s=c[e>>2]|0;c[65148]=z;e:do{if((z|0)<=(s|0)){E=z;la=T;za=z;while(1){B=E+la|0;c[65158]=B;Qa=za+la|0;c[65164]=Qa;Pa=B+5|0;c[65160]=(Qa|0)<=(Pa|0)?Qa:Pa;if((c[65592]|0)==3){c[265868>>2]=6;zeb(265864)|0;Pa=c[65160]|0;Qa=c[65158]|0;c[65150]=Qa;if((Qa|0)<=(Pa|0)){B=Qa;do{Qdb(265912,262704+(B+ -1<<3)|0,8)|0;Qa=c[65150]|0;B=Qa+1|0;c[65150]=B;}while((Qa|0)<(Pa|0))}heb()|0}else{c[265844>>2]=6;zeb(265840)|0;Pa=c[65160]|0;B=c[65158]|0;c[65150]=B;if((B|0)<=(Pa|0)){x=B;do{Qdb(265912,260680+(x+ -1<<3)|0,8)|0;B=c[65150]|0;x=B+1|0;c[65150]=x;}while((B|0)<(Pa|0))}heb()|0}Pa=c[65148]|0;x=Pa+1|0;c[65148]=x;if((Pa|0)>=(s|0)){break e}E=c[65154]|0;la=c[65164]|0;za=x}}}while(0);c[265892>>2]=6;zeb(265888)|0;heb()|0;z=(c[65154]|0)+6|0}c[265820>>2]=6;zeb(265816)|0;Qdb(265912,264808,4)|0;heb()|0;i=r;return 0}else if((R|0)==312){i=r;return 0}}}while(0);se[p&63](e,b,f)|0;i=r;return 0}function yZa(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0.0,I=0;k=i;c[66498]=c[b>>2];c[g>>2]=1;if((c[66498]|0)<1){i=k;return 0}c[g>>2]=0;zZa(a,265992,d,f,g,j,e)|0;if((c[g>>2]|0)!=0){i=k;return 0}g=c[66498]|0;j=g+1|0;f=(fa(j,g)|0)/2|0;c[66490]=f;c[66496]=g;c[66502]=f;a=g+ -1|0;b=f+(fa(a,1-g|0)|0)|0;l=Rqb(a|0,0,g+ -2|0,0)|0;m=Kqb(l|0,J&1|0,1)|0;l=b+m|0;m=0-g|0;b=f;n=g;while(1){if(+h[d+(b+ -1<<3)>>3]==0.0){c[66482]=n;if((n|0)>(g|0)){o=b}else{p=g-n|0;q=fa(p,n+1|0)|0;r=Rqb(p|0,0,a-n|0,0)|0;p=Kqb(r|0,J&1|0,1)|0;r=n;s=b;while(1){h[d+(s+ -1<<3)>>3]=0.0;if((r|0)<(g|0)){s=s+r|0;r=r+1|0}else{break}}c[66482]=j;o=n+b+q+p|0}t=o;u=n+ -1|0}else{c[66480]=n;if((n|0)<=(g|0)){r=n;s=b;while(1){h[e+(r+ -1<<3)>>3]=+h[d+(s+ -1<<3)>>3];if((r|0)>=(g|0)){break}v=s+r|0;r=r+1|0;s=v}c[66480]=j}c[66492]=g;c[66494]=f;c[66500]=f;s=n+ -1|0;r=e+(s<<3)|0;p=(g|0)==(n|0);q=f;v=g;w=f;while(1){h[33244]=0.0;x=(v|0)==(n|0);if(x){y=1.0/+h[r>>3];h[33244]=y;z=y}else{z=0.0}if(p){A=g;B=w;C=z}else{y=z;D=g;E=w;while(1){F=D+ -1|0;G=E+ -1|0;H=y- +h[e+(F<<3)>>3]*+h[d+(G<<3)>>3];h[33244]=H;if((G|0)>(q|0)){I=E+(1-D)|0}else{I=G}if((F|0)==(n|0)){A=n;B=I;C=H;break}else{E=I;D=F;y=H}}}h[d+(B+ -1<<3)>>3]=C/+h[r>>3];if(x){break}D=q-v|0;c[66500]=D;E=v+ -1|0;c[66492]=E;F=w+ -1|0;c[66494]=F;q=D;v=E;w=F}c[66484]=A;t=B;u=s}w=b+m|0;if((u|0)==0){break}else{m=m+1|0;b=w;n=u}}c[66486]=t;c[66496]=0;c[66502]=l-g;i=k;return 0}function zZa(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0.0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0,O=0;k=i;h[33258]=.5;l=.5;do{l=l*.5;}while(l+1.0>1.0);m=l*2.0;h[33258]=m;c[f>>2]=1;if((c[b>>2]|0)<1){i=k;return 0}c[f>>2]=2;c[e>>2]=0;h[g>>3]=m;h[j>>3]=+h[33258];c[66506]=1;c[66508]=0;n=c[b>>2]|0;c[66520]=1;a:do{if((n|0)>=1){b=1;o=1;b:while(1){c[66510]=0;c[66522]=1;do{if((o|0)>=1){p=1;q=c[66508]|0;r=0;while(1){s=q+1|0;t=a+(q<<3)|0;m=+h[t>>3];h[33257]=m;u=(p|0)==(o|0);if(u){l=m*+h[33258];h[33259]=l*l}do{if((p|0)<1){v=m;w=r;x=b;y=1}else{l=m;z=b;A=1;B=r;while(1){C=B+1|0;if((A|0)==(p|0)){D=14;break}E=d+(B<<3)|0;F=l- +h[E>>3]*+h[d+(z+ -1<<3)>>3];h[33257]=F;if(u){G=+h[E>>3];H=G*G*+h[j+(A+ -1<<3)>>3];h[33259]=+h[33259]+H*H}I=z+1|0;J=A+1|0;if((A|0)<(p|0)){l=F;z=I;A=J;B=C}else{D=15;break}}if((D|0)==14){D=0;c[66510]=C;v=l;w=C;x=z;y=p;break}else if((D|0)==15){D=0;c[66510]=C;v=F;w=C;x=I;y=J;break}}}while(0);if(u){D=25;break}m=+h[d+(w+ -1<<3)>>3];if(m==0.0){h[d+(q<<3)>>3]=0.0;H=+h[33257];if(!(H>=0.0)){K=-H}else{K=H}H=+h[g>>3]*+h[t>>3];if(!(H>=0.0)){L=-H}else{L=H}if(K>L){break b}}else{h[d+(q<<3)>>3]=v/m}B=p+1|0;c[66522]=B;if((p|0)<(o|0)){p=B;r=w;q=s}else{D=26;break}}if((D|0)==25){D=0;c[66504]=y;c[66512]=x;c[66508]=s;break}else if((D|0)==26){D=0;c[66504]=y;c[66512]=x;c[66508]=s;break}}}while(0);m=+V(+(+h[33259]));h[33259]=m;H=+h[33257];if(!(H>=0.0)){M=-H}else{M=H}do{if(!(M<=m*5.0)){if(H<0.0){D=37;break b}G=+V(+H);h[d+((c[66508]|0)+ -1<<3)>>3]=G;G=+h[33259]/+h[33257];h[j+((c[66504]|0)+ -1<<3)>>3]=G;if(!(G>+h[g>>3])){N=b;O=o;break}h[g>>3]=G;N=b;O=o}else{h[d+((c[66508]|0)+ -1<<3)>>3]=0.0;c[e>>2]=(c[e>>2]|0)+1;N=c[66506]|0;O=c[66520]|0}}while(0);b=N+O|0;c[66506]=b;o=O+1|0;c[66520]=o;if((O|0)>=(n|0)){break a}}if((D|0)==37){i=k;return 0}c[66504]=y;c[66512]=x;c[66508]=s;i=k;return 0}}while(0);c[f>>2]=0;i=k;return 0}function AZa(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;m=i;n=(c[b>>2]|0)+1|0;c[66546]=n;o=(c[d>>2]|0)-n|0;c[66568]=o;p=c[d>>2]|0;q=c[b>>2]|0;r=q+2|0;do{if((p|0)>=(r|0)){if((p|0)>((fa(n,r)|0)/2|0|0)){break}s=q+p|0;c[66566]=s;a[266208]=1;t=c[b>>2]|0;u=t+1|0;c[66562]=u;v=c[b>>2]|0;w=u+v|0;c[66560]=w;u=w+(c[b>>2]|0)|0;c[66564]=u;w=(fa(c[d>>2]|0,c[b>>2]|0)|0)+u|0;c[66554]=w;x=w+(c[d>>2]|0)|0;c[66548]=x;y=x+(c[b>>2]|0)|0;c[66550]=y;z=((fa(n,c[b>>2]|0)|0)/2|0)+y|0;c[66556]=z;A=z+(c[d>>2]|0)|0;c[66570]=A;B=(fa(c[b>>2]|0,s)|0)+A|0;c[66572]=B;C=(fa(o,c[d>>2]|0)|0)+B|0;c[66544]=C;D=C+(c[b>>2]|0)|0;c[66558]=D;BZa(b,d,e,f,g,h,j,k,k+(t<<3)|0,k+(t+v<<3)|0,k+(u+ -1<<3)|0,k+(w+ -1<<3)|0,k+(x+ -1<<3)|0,k+(y+ -1<<3)|0,k+(z+ -1<<3)|0,k+(A+ -1<<3)|0,k+(B+ -1<<3)|0,266264,k+(C+ -1<<3)|0,k+(D+ -1<<3)|0,k+(s+ -1+D<<3)|0,l)|0;i=m;return 0}}while(0);zeb(266296)|0;heb()|0;i=m;return 0}function BZa(a,b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;var z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0.0,S=0,T=0,U=0,W=0.0,X=0,Y=0,Z=0.0,_=0,$=0,aa=0,ba=0.0,ca=0,da=0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0,Wa=0.0,Xa=0,Ya=0,Za=0,_a=0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0,gb=0.0,hb=0.0,ib=0,jb=0.0,kb=0.0,lb=0.0,mb=0.0,nb=0,ob=0.0,pb=0.0,qb=0.0,rb=0,sb=0.0,tb=0.0,ub=0.0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0.0;z=i;i=i+8|0;A=z;B=c[b>>2]|0;C=~B;D=c[u>>2]|0;E=~D;h[33372]=.5;h[33363]=1.0;h[33403]=.1;F=(c[a>>2]|0)+1|0;c[66722]=F;G=fa(c[a>>2]|0,F)|0;H=(G|0)/2|0;c[66714]=H;I=(c[b>>2]|0)-F|0;c[66768]=I;F=c[j>>2]|0;c[66822]=(F|0)<1?1:F;F=c[a>>2]|0;c[66706]=1;if((F|0)>=1){j=1;while(1){J=j+ -1|0;h[k+(J<<3)>>3]=+h[d+(J<<3)>>3];J=c[b>>2]|0;c[66708]=1;if((J|0)>=1){K=fa(j,B)|0;L=1;while(1){h[n+(L+C+K<<3)>>3]=0.0;if((L|0)<(J|0)){L=L+1|0}else{break}}c[66708]=J+1}L=c[u>>2]|0;c[66704]=1;if((L|0)>=1){K=1;while(1){h[s+(K+E+(fa(j,D)|0)<<3)>>3]=0.0;if((K|0)<(L|0)){K=K+1|0}else{break}}c[66704]=L+1}K=j+1|0;c[66706]=K;if((j|0)<(F|0)){j=K}else{break}}}c[66710]=1;if((G|0)>=2){G=1;while(1){h[q+(G+ -1<<3)>>3]=0.0;if((G|0)<(H|0)){G=G+1|0}else{break}}c[66710]=H+1}H=c[b>>2]|0;c[66708]=1;if((H|0)>=1){G=(I|0)<1;j=I+1|0;F=1;while(1){h[r+(F+ -1<<3)>>3]=0.0;if(G){M=1}else{K=1;while(1){h[t+((fa(K,B)|0)+C+F<<3)>>3]=0.0;if((K|0)<(I|0)){K=K+1|0}else{M=j;break}}}if((F|0)<(H|0)){F=F+1|0}else{break}}c[66706]=M;c[66708]=H+1}N=+h[e>>3];O=N*N;h[33408]=O;h[33394]=+h[33363]/O;h[33395]=+V(+(+h[33372]))/O;c[66712]=0;H=y;y=A;M=0;a:while(1){c[66724]=M;F=M-(c[a>>2]|0)|0;c[66748]=F;j=M+1|0;c[66712]=j;I=c[a>>2]|0;do{if((M|0)>(I<<1|0)){G=(F+ -1|0)/(I|0)|0;c[66798]=G;K=c[a>>2]|0;L=M-(fa(K,G)|0)-K|0;c[66736]=L;K=L+G|0;c[66734]=K;if((K|0)>(c[a>>2]|0)){c[66798]=L;G=K-(c[a>>2]|0)|0;c[66736]=G;c[66734]=L;P=L;Q=G}else{P=K;Q=L}O=+h[e>>3];h[33385]=O;L=c[66722]|0;if(+h[o+(P+ -1+L<<3)>>3]<+h[o+(P<<3)>>3]){N=-O;h[33385]=N;R=N}else{R=O}O=+h[e>>3];h[33386]=O;if(+h[o+(Q+ -1+L<<3)>>3]<+h[o+(Q<<3)>>3]){h[33386]=-O}L=j+C|0;h[n+(L+(fa(P,B)|0)<<3)>>3]=R;h[n+(L+(fa(Q,B)|0)<<3)>>3]=+h[33386];S=c[a>>2]|0}else{L=(M|0)>(I|0);if(!((M|0)<1|L)){h[n+((fa(M,B)|0)+C+j<<3)>>3]=+h[e>>3];S=I;break}if(!L){S=I;break}h[n+(j+C+(fa(F,B)|0)<<3)>>3]=-+h[e>>3];S=I}}while(0);c[66706]=1;if((S|0)>=1){I=1;while(1){O=+h[n+((fa(I,B)|0)+C+j<<3)>>3];F=I+ -1|0;h[d+(F<<3)>>3]=O+ +h[k+(F<<3)>>3];if((I|0)<(S|0)){I=I+1|0}else{break}}c[66706]=S+1}if((M|0)>=(c[66822]|0)){T=j;U=159;break}while(1){se[H&63](a,d,266808)|0;if((c[g>>2]|0)==3){zeb(267336)|0;Qdb(267504,266848,4)|0;Qdb(267504,266808,8)|0;I=c[a>>2]|0;c[66704]=1;if((I|0)>=1){F=1;do{Qdb(267504,d+(F+ -1<<3)|0,8)|0;L=c[66704]|0;F=L+1|0;c[66704]=F;}while((L|0)<(I|0))}heb()|0}I=c[66712]|0;do{if((I|0)>(c[b>>2]|0)){F=c[66752]|0;if((F|0)==-1){break a}h[33404]=0.0;c[66710]=0;L=c[a>>2]|0;c[66706]=1;if((L|0)<1){W=0.0}else{O=0.0;K=2;G=1;J=0;while(1){X=G+ -1|0;N=O+ +h[v+(X<<3)>>3]*+h[p+(X<<3)>>3];h[33404]=N;if((G|0)<1){Y=1;Z=N;_=J}else{X=G+ -1|0;$=m+(X<<3)|0;aa=v+(X<<3)|0;ba=N;X=1;ca=J;while(1){da=X+ -1|0;N=+h[v+(da<<3)>>3]*+h[$>>3]+ +h[aa>>3]*+h[l+(da<<3)>>3];h[33377]=N;if((X|0)==(G|0)){ea=N*+h[33372];h[33377]=ea;ga=ea}else{ga=N}ha=ba+ga*+h[q+(ca<<3)>>3];h[33404]=ha;if((X|0)<(G|0)){ba=ha;X=X+1|0;ca=ca+1|0}else{break}}ca=J+G|0;c[66710]=ca;Y=K;Z=ha;_=ca}if((G|0)<(L|0)){O=Z;K=K+1|0;G=G+1|0;J=_}else{break}}c[66704]=Y;c[66706]=L+1;W=Z}J=c[b>>2]|0;c[66708]=1;if((J|0)<1){ia=W}else{O=W;G=1;while(1){K=G+ -1|0;ja=O+ +h[r+(K<<3)>>3]*+h[x+(K<<3)>>3];h[33404]=ja;if((G|0)<(J|0)){G=G+1|0;O=ja}else{break}}c[66708]=J+1;ia=ja}O=+h[33351];ba=+h[33380];N=O-ba-ia;h[33371]=N;h[33390]=+h[33389];h[33389]=+h[33388];if(!(N>=0.0)){ka=-N}else{ka=N}h[33388]=ka;if(+h[33400]>+h[33366]){c[66796]=I}h[33396]=ba;do{if(O<ba){h[33380]=O;h[33413]=0.0;G=c[a>>2]|0;c[66704]=1;if((G|0)<1){break}else{la=1}while(1){L=la+ -1|0;h[l+(L<<3)>>3]=+h[m+(L<<3)>>3];ma=+h[l+(la+ -1<<3)>>3];h[33413]=+h[33413]+ma*ma;if((la|0)<(G|0)){la=la+1|0}else{break}}c[66704]=G+1;h[A>>3]=ma}}while(0);c[66794]=F;if((F|0)<=0){O=+h[33404];if(O>=0.0){U=190;break a}ba=+h[33351];N=+h[33396];ea=(ba-N)/O;h[33401]=ea;O=+h[33403];do{if(!(ea<=O)){na=+h[33372]*+h[33393];h[A>>3]=na;oa=+h[33400];if(!(ea<=.7)){pa=oa+oa;qa=na>=pa?na:pa;h[33393]=qa;ra=qa;break}else{qa=na>=oa?na:oa;h[33393]=qa;ra=qa;break}}else{qa=+h[33372]*+h[33400];h[33393]=qa;ra=qa}}while(0);ea=+h[33366];if(!(ra<=ea*1.5)){sa=ra}else{h[33393]=ea;sa=ea}qa=O*sa;oa=qa>=ea?qa:ea;h[A>>3]=oa;ea=oa*oa;h[33408]=ea;c[66810]=0;h[33409]=0.0;if(!(ba>=N)){ta=0;ua=0.0}else{J=c[66766]|0;c[66810]=J;oa=+h[33363];h[33409]=oa;ta=J;ua=oa}J=c[b>>2]|0;c[66708]=1;if((J|0)<1){va=F}else{L=c[66768]|0;oa=ua;K=1;ca=F;while(1){h[33391]=0.0;c[66706]=1;if((L|0)<1){wa=0.0}else{X=c[66728]|0;aa=K+C|0;qa=+h[33363];na=0.0;$=1;while(1){if(($|0)<(X|0)){xa=-qa}else{xa=qa}h[33377]=xa;pa=+h[t+(aa+(fa($,B)|0)<<3)>>3];ya=na+xa*pa*pa;h[33391]=ya;if(($|0)<(L|0)){na=ya;$=$+1|0}else{break}}c[66706]=L+1;wa=ya}na=+h[w+(K+ -1<<3)>>3];qa=na*na+ +h[33373]*wa;if(!(qa>=0.0)){za=-qa}else{za=qa}h[33377]=za;h[33412]=0.0;$=c[a>>2]|0;c[66706]=1;if(($|0)<1){Aa=qa;Ba=0.0}else{qa=0.0;aa=1;while(1){na=+h[n+((fa(aa,B)|0)+C+K<<3)>>3];Ca=na- +h[l+(aa+ -1<<3)>>3];Da=qa+Ca*Ca;h[33412]=Da;if((aa|0)<($|0)){aa=aa+1|0;qa=Da}else{break}}c[66706]=$+1;Aa=Ca;Ba=Da}if(Ba>ea){qa=Ba/ea;na=za*qa*qa*qa;h[33377]=na;Ea=qa;Fa=na}else{Ea=Aa;Fa=za}if(!(Fa>oa)|(K|0)==(ta|0)){Ga=oa;Ha=ca}else{h[33409]=Fa;c[66752]=K;Ga=Fa;Ha=K}aa=K+1|0;c[66708]=aa;if((K|0)<(J|0)){oa=Ga;K=aa;ca=Ha}else{break}}h[A>>3]=Ea;va=Ha}if((va|0)==0){Ia=0;Ja=sa;Ka=O;U=286;break}}HZa(a,b,s,t,266912,u,w,266984,267008,x)|0;ca=c[66752]|0;K=ca+ -1|0;h[o+(K<<3)>>3]=+h[33351];c[66710]=0;J=c[a>>2]|0;c[66704]=1;L=r+(K<<3)|0;if((J|0)>=1){K=ca+C|0;F=2;aa=1;X=0;while(1){oa=+h[L>>3]*+h[n+((fa(aa,B)|0)+C+ca<<3)>>3];h[33377]=oa;if((aa|0)<1){La=1;Ma=X}else{ea=oa;G=1;da=X;while(1){oa=ea*+h[n+(K+(fa(G,B)|0)<<3)>>3];Na=q+(da<<3)|0;h[Na>>3]=+h[Na>>3]+oa;if((G|0)>=(aa|0)){break}ea=+h[33377];G=G+1|0;da=da+1|0}da=X+aa|0;c[66710]=da;La=F;Ma=da}if((aa|0)<(J|0)){F=F+1|0;aa=aa+1|0;X=Ma}else{break}}c[66706]=La;c[66704]=J+1}h[L>>3]=0.0;X=c[66768]|0;c[66706]=1;aa=(X|0)<1;if(!aa){F=c[66728]|0;K=1;while(1){da=fa(K,B)|0;O=+h[33371]*+h[t+(da+C+ca<<3)>>3];if((K|0)<(F|0)){Oa=-O}else{Oa=O}h[33377]=Oa;G=c[b>>2]|0;c[66708]=1;if((G|0)>=1){O=Oa;$=1;while(1){Na=r+($+ -1<<3)|0;h[Na>>3]=+h[Na>>3]+O*+h[t+($+C+da<<3)>>3];if(($|0)>=(G|0)){break}O=+h[33377];$=$+1|0}c[66708]=G+1}$=K+1|0;c[66706]=$;if((K|0)<(X|0)){K=$}else{break}}}h[33382]=0.0;K=c[a>>2]|0;c[66704]=1;if((K|0)>=1){F=1;while(1){O=+h[33371]*+h[s+((fa(F,D)|0)+E+ca<<3)>>3];L=p+(F+ -1<<3)|0;h[L>>3]=+h[L>>3]+O;L=F+ -1|0;Pa=+h[p+(L<<3)>>3];h[33382]=+h[33382]+Pa*Pa;h[n+((fa(F,B)|0)+C+ca<<3)>>3]=+h[m+(L<<3)>>3];if((F|0)<(K|0)){F=F+1|0}else{break}}c[66704]=K+1;h[A>>3]=Pa}F=c[66794]|0;do{if((F|0)==0){if(!(+h[33393]==+h[33366])){break}O=+h[33401];if(!(O>=0.0)){Qa=-O}else{Qa=O}if(Qa>.01){c[66814]=0;break}L=c[b>>2]|0;c[66708]=1;if((L|0)>=1){J=o+((c[66766]|0)+ -1<<3)|0;$=1;while(1){da=$+ -1|0;h[w+(da<<3)>>3]=+h[o+(da<<3)>>3]- +h[J>>3];if(($|0)<(L|0)){$=$+1|0}else{break}}c[66708]=L+1}h[33375]=0.0;$=c[a>>2]|0;c[66704]=1;if(($|0)<1){Ra=0.0}else{J=1;while(1){h[33369]=0.0;G=c[b>>2]|0;c[66708]=1;if((G|0)<1){Sa=0.0}else{da=fa(J,D)|0;O=0.0;Na=1;while(1){Ta=O+ +h[s+(Na+E+da<<3)>>3]*+h[w+(Na+ -1<<3)>>3];h[33369]=Ta;if((Na|0)<(G|0)){Na=Na+1|0;O=Ta}else{break}}c[66708]=G+1;Sa=Ta}h[33375]=+h[33375]+Sa*Sa;h[x+(J+ -1<<3)>>3]=Sa;Na=J+1|0;c[66704]=Na;if((J|0)<($|0)){J=Na}else{break}}Ra=+h[33375]*100.0}J=c[66814]|0;c[66814]=J+1;if(+h[33382]<Ra){c[66814]=0;break}if((J|0)<=1){break}J=c[a>>2]|0;c[66704]=1;if((J|0)>=1){$=1;while(1){L=$+ -1|0;h[p+(L<<3)>>3]=+h[x+(L<<3)>>3];if(($|0)<(J|0)){$=$+1|0}else{break}}c[66704]=J+1}$=c[66714]|0;c[66710]=1;if(($|0)>=1){L=1;while(1){h[q+(L+ -1<<3)>>3]=0.0;if((L|0)<($|0)){L=L+1|0}else{break}}c[66710]=$+1}c[66706]=1;if(!aa){L=1;while(1){J=x+(L+ -1<<3)|0;h[J>>3]=0.0;Na=c[b>>2]|0;c[66708]=1;if((Na|0)<1){Ua=0.0}else{da=fa(L,B)|0;O=0.0;Va=1;while(1){Wa=O+ +h[w+(Va+ -1<<3)>>3]*+h[t+(Va+C+da<<3)>>3];h[J>>3]=Wa;if((Va|0)<(Na|0)){Va=Va+1|0;O=Wa}else{break}}c[66708]=Na+1;Ua=Wa}if((L|0)<(c[66728]|0)){h[J>>3]=-Ua}Va=L+1|0;c[66706]=Va;if((L|0)<(X|0)){L=Va}else{break}}}L=c[b>>2]|0;c[66708]=1;if((L|0)>=1){$=X+1|0;Va=1;while(1){h[r+(Va+ -1<<3)>>3]=0.0;if(aa){Xa=1}else{da=1;while(1){O=+h[t+((fa(da,B)|0)+C+Va<<3)>>3];G=r+(Va+ -1<<3)|0;h[G>>3]=+h[G>>3]+O*+h[x+(da+ -1<<3)>>3];if((da|0)<(X|0)){da=da+1|0}else{Xa=$;break}}}if((Va|0)<(L|0)){Va=Va+1|0}else{break}}c[66706]=Xa;c[66708]=L+1}c[66814]=0}}while(0);O=+h[33351];ea=+h[33396];if(O<ea){c[66766]=ca}oa=+h[33403];if(O<=ea+oa*+h[33404]|(F|0)>0){U=54;break}c[66752]=0;Ia=0;Ja=+h[33393];Ka=oa;U=286}else{h[o+(I+ -1<<3)>>3]=+h[33351];oa=+h[33351];do{if((I|0)==1){h[33370]=oa;h[33380]=oa;c[66766]=1;Ya=1}else{if(!(oa<+h[33380])){Ya=I;break}h[33380]=oa;c[66766]=I;Ya=I}}while(0);F=c[66724]|0;ca=c[a>>2]|0;do{if((F|0)>(ca<<1|0)){X=c[66734]|0;aa=(fa(X+ -1|0,X)|0)/2|0;K=c[66736]|0;Va=K+aa|0;c[66710]=Va;if(+h[33385]<0.0){aa=X+(c[a>>2]|0)|0;c[66734]=aa;Za=aa}else{Za=X}if(+h[33386]<0.0){X=K+(c[a>>2]|0)|0;c[66736]=X;_a=X}else{_a=K}K=fa(c[66748]|0,B)|0;h[t+(K-B<<3)>>3]=+h[33394];h[t+(Ya+C+K<<3)>>3]=+h[33394];h[t+(Za-B+K<<3)>>3]=-+h[33394];h[t+(_a-B+K<<3)>>3]=-+h[33394];h[q+(Va+ -1<<3)>>3]=(+h[33370]- +h[o+(Za<<3)>>3]- +h[o+(_a<<3)>>3]+ +h[33351])/(+h[33385]*+h[33386])}else{Va=(F|0)>(ca|0);if((F|0)<1|Va){if(!Va){break}Va=c[66748]|0;K=fa(Va,D)|0;h[s+(E-ca+Ya+K<<3)>>3]=+h[33372]/+h[e>>3];h[s+(Ya+E+K<<3)>>3]=-+h[33372]/+h[e>>3];ea=+h[33395];K=fa(Va,B)|0;h[t+(K-B<<3)>>3]=-ea-ea;X=Ya+C|0;h[t+(X-ca+K<<3)>>3]=+h[33395];h[t+(X+K<<3)>>3]=+h[33395];K=(fa(Va+1|0,Va)|0)/2|0;c[66710]=K;ea=(+h[33370]- +h[33351])/+h[e>>3];h[33377]=ea;X=p+(Va+ -1<<3)|0;h[q+(K+ -1<<3)>>3]=(+h[X>>3]-ea)/+h[e>>3];h[X>>3]=+h[33372]*(+h[X>>3]+ +h[33377]);break}else{h[p+(F+ -1<<3)>>3]=(oa- +h[33370])/+h[e>>3];X=c[b>>2]|0;if((X|0)>=(ca+Ya|0)){break}K=fa(F,D)|0;h[s+(K-D<<3)>>3]=-+h[33363]/+h[e>>3];h[s+(Ya+E+K<<3)>>3]=+h[33363]/+h[e>>3];h[s+(X+E+F+K<<3)>>3]=-(+h[33372]*+h[33408]);break}}}while(0);if((Ya|0)<(c[b>>2]|0)){M=Ya;continue a}oa=+h[e>>3];h[33366]=oa;h[33393]=oa;c[66728]=1;h[33388]=0.0;h[33389]=0.0;c[66814]=0;h[33413]=0.0;F=c[a>>2]|0;c[66704]=1;if((F|0)<1){U=53;break}ca=c[66766]|0;K=1;while(1){h[l+(K+ -1<<3)>>3]=+h[n+((fa(K,B)|0)+C+ca<<3)>>3];$a=+h[l+(K+ -1<<3)>>3];h[33413]=+h[33413]+$a*$a;if((K|0)<(F|0)){K=K+1|0}else{break}}c[66704]=F+1;h[A>>3]=$a;U=53}}while(0);while(1){if((U|0)==53){U=0;c[66796]=c[66712];U=54;continue}else if((U|0)==54){U=0;c[66752]=0;I=(c[66722]|0)+ -1|0;K=c[a>>2]|0;GZa(a,b,l,n,p,q,r,267144,v,x,x+(I<<3)|0,x+(I+K<<3)|0,x+(I+(K<<1)<<3)|0,267280)|0;h[33365]=0.0;K=c[a>>2]|0;c[66704]=1;if((K|0)<1){ab=0.0}else{oa=0.0;I=1;while(1){bb=+h[v+(I+ -1<<3)>>3];cb=oa+bb*bb;h[33365]=cb;if((I|0)<(K|0)){I=I+1|0;oa=cb}else{break}}h[A>>3]=bb;c[66704]=K+1;ab=cb}oa=+h[33393];h[A>>3]=oa;ea=+V(+ab);O=oa<=ea?oa:ea;h[33400]=O;ea=+h[33366];if(!(O<+h[33372]*ea)){db=ab;U=62;break}c[66752]=-1;O=+h[33403];N=O*oa;h[33393]=N;h[33401]=-1.0;if(!(N<=ea*1.5)){eb=N}else{h[33393]=ea;eb=ea}if((c[66712]|0)<=((c[66796]|0)+2|0)){Ia=-1;Ja=eb;Ka=O;U=286;continue}N=ea*+h[33410]*.125*ea;h[33377]=N;oa=+h[33388];ba=+h[33389];na=oa>=ba?oa:ba;h[A>>3]=na;ba=+h[33390];if(!(N<=(na>=ba?na:ba))){fb=-1;gb=O;hb=ea}else{Ia=-1;Ja=eb;Ka=O;U=286;continue}}else if((U|0)==286){U=0;O=Ja*Ja*4.0;h[33412]=O;I=c[b>>2]|0;c[66708]=1;if((I|0)<1){ib=Ia}else{F=1;ea=O;ca=Ia;while(1){h[33369]=0.0;X=c[a>>2]|0;c[66706]=1;if((X|0)<1){jb=0.0}else{O=0.0;Va=1;while(1){ba=+h[n+((fa(Va,B)|0)+C+F<<3)>>3];kb=ba- +h[l+(Va+ -1<<3)>>3];lb=O+kb*kb;h[33369]=lb;if((Va|0)<(X|0)){Va=Va+1|0;O=lb}else{break}}h[A>>3]=kb;c[66706]=X+1;jb=lb}if(jb>ea){c[66752]=F;h[33412]=jb;mb=jb;nb=F}else{mb=ea;nb=ca}Va=F+1|0;c[66708]=Va;if((F|0)<(I|0)){F=Va;ea=mb;ca=nb}else{break}}if((nb|0)>0){U=294;break}else{ib=nb}}if(+h[33401]>0.0){U=54;continue}ea=+h[33400];O=+h[33366];if((Ja>=ea?Ja:ea)>O){U=54;continue}else{fb=ib;gb=Ka;hb=O}}if(!(hb>+h[f>>3])){U=309;break}O=hb*+h[33372];h[33393]=O;ea=hb/+h[f>>3];h[33401]=ea;do{if(!(ea<=16.0)){if(!(ea<=250.0)){ba=gb*hb;h[33366]=ba;ob=ba;break}else{ba=+V(+ea);na=ba*+h[f>>3];h[33366]=na;ob=na;break}}else{na=+h[f>>3];h[33366]=na;ob=na}}while(0);h[33393]=O>=ob?O:ob;ca=c[g>>2]|0;if((ca|0)<=1){U=53;continue}if((ca|0)>2){zeb(267384)|0;heb()|0}zeb(267408)|0;Qdb(267504,266928,8)|0;Qdb(267504,266848,4)|0;heb()|0;zeb(267432)|0;Qdb(267504,267040,8)|0;ca=c[a>>2]|0;c[66704]=1;if((ca|0)>=1){F=1;do{I=F+ -1|0;h[A>>3]=+h[k+(I<<3)>>3]+ +h[l+(I<<3)>>3];Qdb(267504,y,8)|0;I=c[66704]|0;F=I+1|0;c[66704]=F;}while((I|0)<(ca|0))}heb()|0;U=53}if((U|0)==294){U=0;O=Ka*+V(+mb);ea=+h[33372]*Ja;na=O<=ea?O:ea;h[A>>3]=na;ea=+h[33366];O=na>=ea?na:ea;h[33402]=O;ea=O*O;h[33365]=ea;db=ea;U=62}else if((U|0)==309){U=0;if(!((fb|0)==-1)){break a}}do{if((U|0)==62){U=0;ea=+h[33413];if(db<=ea*.001){h[33406]=ea*.25;ca=c[b>>2]|0;c[66708]=1;if((ca|0)>=1){F=1;while(1){h[33369]=0.0;I=c[a>>2]|0;c[66704]=1;if((I|0)<1){pb=0.0}else{ea=0.0;K=1;while(1){O=+h[n+((fa(K,B)|0)+C+F<<3)>>3];qb=ea+O*+h[l+(K+ -1<<3)>>3];h[33369]=qb;if((K|0)<(I|0)){K=K+1|0;ea=qb}else{break}}c[66704]=I+1;pb=qb}h[33377]=+h[r+(F+ -1<<3)>>3]*pb;ea=pb- +h[33372]*+h[33413];h[33369]=ea;h[x+((c[b>>2]|0)+ -1+F<<3)>>3]=ea;K=c[a>>2]|0;c[66704]=1;if((K|0)>=1){X=1;while(1){Va=fa(X,B)|0;L=n+(Va+C+F<<3)|0;aa=X+ -1|0;$=p+(aa<<3)|0;h[$>>3]=+h[$>>3]+ +h[33377]*+h[L>>3];$=l+(aa<<3)|0;h[L>>3]=+h[L>>3]- +h[33372]*+h[$>>3];L=w+(aa<<3)|0;h[L>>3]=+h[s+(F+E+(fa(X,D)|0)<<3)>>3];ea=+h[33369]*+h[n+(F+C+Va<<3)>>3]+ +h[33406]*+h[$>>3];$=x+(aa<<3)|0;h[$>>3]=ea;aa=X+(c[b>>2]|0)|0;c[66716]=aa;c[66706]=1;if((X|0)<1){rb=X+1|0}else{O=ea;Va=1;while(1){da=s+((fa(Va,D)|0)+E+aa<<3)|0;J=Va+ -1|0;h[da>>3]=+h[da>>3]+ +h[L>>3]*+h[x+(J<<3)>>3]+O*+h[w+(J<<3)>>3];if((Va|0)>=(X|0)){break}O=+h[$>>3];Va=Va+1|0}Va=X+1|0;c[66706]=Va;rb=Va}c[66704]=rb;if((X|0)<(K|0)){X=rb}else{break}}}X=F+1|0;c[66708]=X;if((F|0)<(ca|0)){F=X}else{break}}}F=c[66768]|0;c[66708]=1;if((F|0)>=1){ca=1;while(1){h[33387]=0.0;X=c[b>>2]|0;c[66704]=1;b:do{if((X|0)>=1){O=0.0;K=1;while(1){I=t+(K+C+(fa(ca,B)|0)<<3)|0;h[33387]=+h[I>>3]+O;h[x+(K+ -1<<3)>>3]=+h[x+((c[b>>2]|0)+ -1+K<<3)>>3]*+h[I>>3];I=K+1|0;c[66704]=I;if((K|0)>=(X|0)){break b}O=+h[33387];K=I}}}while(0);X=c[a>>2]|0;c[66706]=1;if((X|0)>=1){K=1;while(1){I=K+ -1|0;O=+h[33406]*+h[33387]*+h[l+(I<<3)>>3];h[33369]=O;Va=c[b>>2]|0;c[66704]=1;if((Va|0)<1){sb=O}else{$=fa(K,B)|0;ea=O;L=1;while(1){tb=ea+ +h[x+(L+ -1<<3)>>3]*+h[n+(L+C+$<<3)>>3];h[33369]=tb;if((L|0)<(Va|0)){L=L+1|0;ea=tb}else{break}}c[66704]=Va+1;sb=tb}h[w+(I<<3)>>3]=sb;if((ca|0)<(c[66728]|0)){h[33369]=-+h[33369]}L=c[b>>2]|0;c[66704]=1;if((L|0)>=1){$=fa(ca,B)|0;aa=fa(K,D)|0;J=1;while(1){da=s+(J+E+aa<<3)|0;h[da>>3]=+h[33369]*+h[t+(J+C+$<<3)>>3]+ +h[da>>3];if((J|0)<(L|0)){J=J+1|0}else{break}}c[66704]=L+1}J=K+1|0;c[66706]=J;if((K|0)<(X|0)){K=J}else{break}}}K=c[a>>2]|0;c[66704]=1;if((K|0)>=1){X=c[66728]|0;J=1;while(1){$=(c[b>>2]|0)+J|0;c[66716]=$;ea=+h[w+(J+ -1<<3)>>3];if((ca|0)<(X|0)){ub=-ea}else{ub=ea}h[33377]=ub;c[66706]=1;if((J|0)<1){vb=J+1|0}else{ea=ub;aa=1;while(1){I=s+((fa(aa,D)|0)+E+$<<3)|0;h[I>>3]=ea*+h[w+(aa+ -1<<3)>>3]+ +h[I>>3];if((aa|0)>=(J|0)){break}ea=+h[33377];aa=aa+1|0}aa=J+1|0;c[66706]=aa;vb=aa}c[66704]=vb;if((J|0)<(K|0)){J=vb}else{break}}}J=ca+1|0;c[66708]=J;if((ca|0)<(F|0)){ca=J}else{break}}}c[66710]=0;ca=c[a>>2]|0;c[66706]=1;if((ca|0)>=1){F=0;J=1;while(1){K=J+ -1|0;X=x+(K<<3)|0;h[X>>3]=0.0;aa=c[b>>2]|0;c[66708]=1;if((aa|0)>=1){$=fa(J,B)|0;L=l+(K<<3)|0;I=$+C|0;ea=0.0;Va=1;while(1){h[X>>3]=ea+ +h[r+(Va+ -1<<3)>>3]*+h[n+(Va+C+$<<3)>>3];da=n+(I+Va<<3)|0;h[da>>3]=+h[da>>3]- +h[33372]*+h[L>>3];if((Va|0)>=(aa|0)){break}ea=+h[X>>3];Va=Va+1|0}c[66708]=aa+1}c[66704]=1;if((J|0)<1){wb=F}else{Va=1;L=F;while(1){I=L+1|0;c[66710]=I;$=(Va|0)<(J|0);da=q+(L<<3)|0;if($){Na=Va+ -1|0;G=l+(Na<<3)|0;xb=p+(K<<3)|0;h[xb>>3]=+h[xb>>3]+ +h[da>>3]*+h[G>>3];yb=G;zb=Na}else{Na=Va+ -1|0;yb=l+(Na<<3)|0;zb=Na}Na=l+(K<<3)|0;G=p+(zb<<3)|0;h[G>>3]=+h[da>>3]*+h[Na>>3]+ +h[G>>3];h[da>>3]=+h[da>>3]+ +h[x+(zb<<3)>>3]*+h[Na>>3]+ +h[yb>>3]*+h[X>>3];Na=(c[b>>2]|0)+E|0;h[s+(Na+Va+(fa(J,D)|0)<<3)>>3]=+h[s+(Na+J+(fa(Va,D)|0)<<3)>>3];Na=Va+1|0;c[66704]=Na;if($){Va=Na;L=I}else{wb=I;break}}}L=J+1|0;c[66706]=L;if((J|0)<(ca|0)){F=wb;J=L}else{break}}}J=c[a>>2]|0;c[66706]=1;if((J|0)>=1){F=1;while(1){ca=F+ -1|0;L=k+(ca<<3)|0;h[L>>3]=+h[l+(ca<<3)>>3]+ +h[L>>3];h[l+(F+ -1<<3)>>3]=0.0;if((F|0)<(J|0)){F=F+1|0}else{break}}c[66706]=J+1}h[33413]=0.0}if((c[66752]|0)>0){F=(c[66722]|0)+ -1|0;TYa(a,b,l,n,s,t,266912,u,267008,267216,v,267136,w,w+(c[b>>2]<<3)|0,x,x+(F<<3)|0,x+(F+(c[a>>2]|0)<<3)|0)|0}F=c[b>>2]|0;c[66708]=1;if((F|0)>=1){L=1;while(1){h[33378]=0.0;h[33379]=0.0;h[33369]=0.0;ca=c[a>>2]|0;c[66706]=1;if((ca|0)<1){Ab=0.0;Bb=0.0}else{Va=L+C|0;X=L+E|0;ea=0.0;O=0.0;na=0.0;K=1;while(1){ba=+h[n+((fa(K,B)|0)+C+L<<3)>>3];Cb=na+ba*+h[v+(K+ -1<<3)>>3];h[33378]=Cb;ba=+h[n+(Va+(fa(K,B)|0)<<3)>>3];aa=K+ -1|0;Db=O+ba*+h[l+(aa<<3)>>3];h[33379]=Db;ba=+h[s+(X+(fa(K,D)|0)<<3)>>3];N=ea+ba*+h[v+(aa<<3)>>3];h[33369]=N;if((K|0)<(ca|0)){K=K+1|0;na=Cb;O=Db;ea=N}else{break}}c[66706]=ca+1;Ab=Db;Bb=Cb}K=L+ -1|0;h[x+(K<<3)>>3]=Bb*(Bb*+h[33372]+Ab);h[w+(K<<3)>>3]=+h[33369];K=L+1|0;c[66708]=K;if((L|0)<(F|0)){L=K}else{break}}}h[33373]=0.0;L=c[66768]|0;c[66708]=1;if((L|0)>=1){F=1;while(1){h[33369]=0.0;J=c[b>>2]|0;c[66704]=1;if((J|0)<1){Eb=0.0}else{ea=0.0;K=1;while(1){O=+h[t+(K+C+(fa(F,B)|0)<<3)>>3];Fb=ea+O*+h[x+(K+ -1<<3)>>3];h[33369]=Fb;if((K|0)<(J|0)){K=K+1|0;ea=Fb}else{break}}c[66704]=J+1;Eb=Fb}ea=Eb*Eb;O=+h[33373];if((F|0)<(c[66728]|0)){h[33373]=O+ea;na=-Eb;h[33369]=na;Gb=na}else{h[33373]=O-ea;Gb=Eb}K=c[b>>2]|0;c[66704]=1;if((K|0)>=1){ca=fa(F,B)|0;ea=Gb;X=1;while(1){Va=w+(X+ -1<<3)|0;h[Va>>3]=+h[Va>>3]+ea*+h[t+(X+C+ca<<3)>>3];if((X|0)>=(K|0)){break}ea=+h[33369];X=X+1|0}c[66704]=K+1}X=F+1|0;c[66708]=X;if((F|0)<(L|0)){F=X}else{break}}}h[33381]=0.0;h[33360]=0.0;F=c[a>>2]|0;c[66706]=1;if((F|0)<1){Hb=0.0;Ib=0.0}else{ea=0.0;L=1;while(1){h[33369]=0.0;X=c[b>>2]|0;c[66704]=1;if((X|0)<1){Jb=0.0}else{ca=fa(L,D)|0;O=0.0;J=1;while(1){Kb=O+ +h[x+(J+ -1<<3)>>3]*+h[s+(J+E+ca<<3)>>3];h[33369]=Kb;if((J|0)<(X|0)){J=J+1|0;O=Kb}else{break}}c[66704]=X+1;Jb=Kb}J=L+ -1|0;ca=v+(J<<3)|0;h[33381]=ea+Jb*+h[ca>>3];K=L+(c[b>>2]|0)|0;c[66718]=K;Va=c[a>>2]|0;c[66708]=1;if((Va|0)<1){Lb=Jb}else{O=Jb;aa=1;while(1){na=+h[s+((fa(aa,D)|0)+E+K<<3)>>3];Mb=O+na*+h[v+(aa+ -1<<3)>>3];h[33369]=Mb;if((aa|0)<(Va|0)){aa=aa+1|0;O=Mb}else{break}}c[66708]=Va+1;Lb=Mb}h[w+(K+ -1<<3)>>3]=Lb;O=+h[33381]+ +h[33369]*+h[ca>>3];h[33381]=O;na=+h[33360]+ +h[ca>>3]*+h[l+(J<<3)>>3];h[33360]=na;aa=L+1|0;c[66706]=aa;if((L|0)<(F|0)){ea=O;L=aa}else{Hb=O;Ib=na;break}}}ea=+h[33365];h[33373]=+h[33373]+(Ib*Ib+ea*(Ib+(Ib+ +h[33413])+ea*+h[33372]))-Hb;L=w+((c[66766]|0)+ -1<<3)|0;h[L>>3]=+h[33363]+ +h[L>>3];L=c[66752]|0;if((L|0)<=0){break}ea=+h[w+(L+ -1<<3)>>3];h[A>>3]=ea;na=+h[33363]+ +h[33392]*+h[33373]/(ea*ea);h[33377]=na;if(!(na>=0.0)){Nb=-na}else{Nb=na}if(!(Nb<=.8)){break}L=c[u>>2]|0;SYa(a,b,l,n,s,t,266912,u,267064,267008,v,x,w,266984,m,x+(L<<3)|0,x+((L*6|1)+ -1<<3)|0)|0}}while(0);L=c[a>>2]|0;c[66704]=1;if((L|0)>=1){F=1;while(1){aa=F+ -1|0;h[m+(aa<<3)>>3]=+h[l+(aa<<3)>>3]+ +h[v+(aa<<3)>>3];aa=F+ -1|0;h[d+(aa<<3)>>3]=+h[k+(aa<<3)>>3]+ +h[m+(aa<<3)>>3];if((F|0)<(L|0)){F=F+1|0}else{break}}c[66704]=L+1}F=c[66712]|0;aa=F+1|0;c[66712]=aa;if((F|0)>=(c[66822]|0)){T=aa;U=159;break a}}}do{if((U|0)==159){c[66712]=T+ -1;if((c[g>>2]|0)<=0){break}zeb(267312)|0;heb()|0}else if((U|0)==190){if((c[g>>2]|0)<=0){break}zeb(267360)|0;heb()|0}}while(0);Nb=+h[33380];if(Nb<=+h[33351]){U=c[a>>2]|0;c[66704]=1;if((U|0)<1){Ob=Nb}else{T=1;while(1){m=T+ -1|0;h[d+(m<<3)>>3]=+h[k+(m<<3)>>3]+ +h[l+(m<<3)>>3];if((T|0)<(U|0)){T=T+1|0}else{break}}c[66704]=U+1;Ob=+h[33380]}h[33351]=Ob}if((c[g>>2]|0)<=0){i=z;return 0}zeb(267456)|0;Qdb(267504,266848,4)|0;heb()|0;zeb(267480)|0;Qdb(267504,266808,8)|0;g=c[a>>2]|0;c[66704]=1;if((g|0)>=1){a=1;do{Qdb(267504,d+(a+ -1<<3)|0,8)|0;U=c[66704]|0;a=U+1|0;c[66704]=a;}while((U|0)<(g|0))}heb()|0;i=z;return 0}function CZa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0;g=i;j=c[e>>2]|0;e=~j;k=c[a>>2]|0;l=c[b>>2]|0;m=(k|0)>(l|0)?l:k;if((m|0)<2){n=k;o=l}else{l=0;k=2;while(1){if((k|0)>=2){Cqb(d+(j+(fa(j,l)|0)<<3)|0,0,(l<<3)+8|0)|0}if((k|0)<(m|0)){l=l+1|0;k=k+1|0}else{break}}n=c[a>>2]|0;o=c[b>>2]|0}b=o+1|0;if((n|0)>=(b|0)&(o|0)<(n|0)){k=(n|0)<1;l=n<<3;p=0;q=b;while(1){b=fa(q,j)|0;if(!k){Cqb(d+((fa(o+p|0,j)|0)<<3)|0,0,l|0)|0}h[d+(q+e+b<<3)>>3]=1.0;if((q|0)<(n|0)){p=p+1|0;q=q+1|0}else{break}}}if((m|0)<1){i=g;return 0}q=c[a>>2]|0;a=1;while(1){p=m-a|0;n=p+1|0;l=(p|0)<(q|0);o=fa(n,j)|0;if(l){k=o+e|0;b=n;while(1){r=d+(k+b<<3)|0;h[f+(b+ -1<<3)>>3]=+h[r>>3];h[r>>3]=0.0;if((b|0)<(q|0)){b=b+1|0}else{break}}}h[d+(n+e+o<<3)>>3]=1.0;b=f+(p<<3)|0;if(!(+h[b>>3]==0.0|l^1)){k=n;while(1){r=(fa(k,j)|0)+e|0;s=n;t=0.0;while(1){u=t+ +h[d+(r+s<<3)>>3]*+h[f+(s+ -1<<3)>>3];if((s|0)>=(q|0)){break}s=s+1|0;t=u}t=+h[b>>3];v=u/t;s=(fa(k,j)|0)+e|0;w=t;r=n;while(1){x=d+(s+r<<3)|0;h[x>>3]=+h[x>>3]-v*w;if((r|0)>=(q|0)){break}w=+h[f+(r<<3)>>3];r=r+1|0}if((k|0)<(q|0)){k=k+1|0}else{break}}}if((a|0)<(m|0)){a=a+1|0}else{break}}i=g;return 0}function DZa(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0,R=0.0,S=0.0;j=i;i=i+16|0;n=j;o=j+8|0;p=c[e>>2]|0;e=~p;q=+tZa(267512);r=c[b>>2]|0;if((r|0)<1){s=r}else{t=1;while(1){u=+uZa(a,d+((fa(t,p)|0)-p<<3)|0);v=t+ -1|0;h[l+(v<<3)>>3]=u;h[k+(v<<3)>>3]=u;h[m+(v<<3)>>3]=u;if((c[f>>2]|0)!=0){c[g+(v<<2)>>2]=t}if((t|0)<(r|0)){t=t+1|0}else{break}}s=c[b>>2]|0}t=c[a>>2]|0;r=(t|0)>(s|0)?s:t;if((r|0)<1){i=j;return 0}else{w=1}while(1){do{if((c[f>>2]|0)!=0){t=c[b>>2]|0;c[n>>2]=t;if((w|0)>(t|0)){break}else{x=w;y=w}while(1){z=+h[k+(x+ -1<<3)>>3]>+h[k+(y+ -1<<3)>>3]?x:y;if((x|0)<(t|0)){y=z;x=x+1|0}else{break}}if((z|0)==(w|0)){break}t=c[a>>2]|0;c[n>>2]=t;if((t|0)>=1){s=(fa(w,p)|0)+e|0;l=(fa(z,p)|0)+e|0;v=1;while(1){A=d+(s+v<<3)|0;u=+h[A>>3];B=d+(l+v<<3)|0;h[A>>3]=+h[B>>3];h[B>>3]=u;if((v|0)<(t|0)){v=v+1|0}else{break}}}v=w+ -1|0;t=z+ -1|0;h[k+(t<<3)>>3]=+h[k+(v<<3)>>3];h[m+(t<<3)>>3]=+h[m+(v<<3)>>3];l=g+(v<<2)|0;v=c[l>>2]|0;s=g+(t<<2)|0;c[l>>2]=c[s>>2];c[s>>2]=v}}while(0);c[n>>2]=1-w+(c[a>>2]|0);v=fa(w,p)|0;s=w+e|0;l=d+(s+v<<3)|0;u=+uZa(n,l);a:do{if(u==0.0){C=w+1|0;D=u}else{E=+h[l>>3];if(E<0.0){F=-u}else{F=u}t=c[a>>2]|0;c[n>>2]=t;if((w|0)>(t|0)){G=E}else{B=v+e|0;A=w;while(1){H=d+(B+A<<3)|0;h[H>>3]=+h[H>>3]/F;if((A|0)<(t|0)){A=A+1|0}else{break}}G=+h[l>>3]}h[l>>3]=G+1.0;A=w+1|0;B=c[b>>2]|0;if((B|0)<(A|0)){C=A;D=F;break}c[n>>2]=B;if((w|0)>=(B|0)){C=A;D=F;break}H=A+e|0;I=v+e|0;J=t;K=B;B=A;while(1){c[o>>2]=J;L=(w|0)>(J|0);do{if(L){c[o>>2]=J}else{M=(fa(B,p)|0)+e|0;N=w;E=0.0;while(1){O=E+ +h[d+(I+N<<3)>>3]*+h[d+(M+N<<3)>>3];if((N|0)<(J|0)){E=O;N=N+1|0}else{break}}E=O/+h[l>>3];c[o>>2]=J;if(L){break}N=(fa(B,p)|0)+e|0;M=w;while(1){P=d+(N+M<<3)|0;h[P>>3]=+h[P>>3]-E*+h[d+(I+M<<3)>>3];if((M|0)<(J|0)){M=M+1|0}else{break}}}}while(0);do{if((c[f>>2]|0)==0){Q=K}else{L=B+ -1|0;M=k+(L<<3)|0;E=+h[M>>3];if(E==0.0){Q=K;break}N=fa(B,p)|0;R=+h[d+(s+N<<3)>>3]/E;S=1.0-R*R;R=E*+V(+(S<=0.0?0.0:S));h[M>>3]=R;P=m+(L<<3)|0;S=R/+h[P>>3];if(S*S*.05>q){Q=K;break}c[o>>2]=J-w;S=+uZa(o,d+(H+N<<3)|0);h[M>>3]=S;h[P>>3]=S;Q=c[n>>2]|0}}while(0);if((B|0)>=(Q|0)){C=A;D=F;break a}J=c[a>>2]|0;K=Q;B=B+1|0}}}while(0);h[k+(w+ -1<<3)>>3]=-D;if((w|0)<(r|0)){w=C}else{break}}i=j;return 0}function EZa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0;j=i;k=c[e>>2]|0;e=~k;l=c[b>>2]|0;b=l+ -1|0;if((l|0)<2){i=j;return 0}m=c[a>>2]|0;n=(m|0)<1;o=0.0;p=1;q=0.0;while(1){r=l-p|0;s=+h[f+(r+ -1<<3)>>3];t=!(s>=0.0);if(t){u=-s}else{u=s}if(u>1.0){v=1.0/s}else{v=o}if(t){w=-s}else{w=s}if(w>1.0){x=+V(+(1.0-v*v))}else{x=q}if(t){y=-s;z=!(s>=-1.0)?x:s}else{y=s;z=!(s<=1.0)?x:s}if(!(y<=1.0)){A=v}else{A=+V(+(1.0-z*z))}if(!n){t=(fa(r,k)|0)+e|0;r=fa(l,k)|0;B=1;while(1){C=d+(t+B<<3)|0;s=+h[C>>3];D=d+(B+e+r<<3)|0;E=+h[D>>3];h[D>>3]=z*s+A*E;h[C>>3]=A*s-z*E;if((B|0)<(m|0)){B=B+1|0}else{break}}}if((p|0)<(b|0)){o=A;p=p+1|0;q=z}else{break}}p=c[a>>2]|0;a=(p|0)<1;q=A;m=1;A=z;while(1){z=+h[g+(m+ -1<<3)>>3];n=!(z>=0.0);if(n){F=-z}else{F=z}if(F>1.0){G=1.0/z}else{G=q}if(n){H=-z}else{H=z}if(H>1.0){I=+V(+(1.0-G*G))}else{I=A}if(n){J=-z;K=!(z>=-1.0)?I:z}else{J=z;K=!(z<=1.0)?I:z}if(!(J<=1.0)){L=G}else{L=+V(+(1.0-K*K))}if(!a){n=(fa(m,k)|0)+e|0;f=fa(l,k)|0;B=1;while(1){r=d+(n+B<<3)|0;z=+h[r>>3];t=d+(B+e+f<<3)|0;o=+h[t>>3];h[t>>3]=L*o-K*z;h[r>>3]=L*z+K*o;if((B|0)<(p|0)){B=B+1|0}else{break}}}if((m|0)<(b|0)){q=L;m=m+1|0;A=K}else{break}}i=j;return 0}function FZa(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,W=0.0;e=i;l=+tZa(267520);m=c[b>>2]|0;n=c[a>>2]|0;o=(fa(1-m+(n<<1)|0,m)|0)/2|0;p=o+(m-n)|0;if((m|0)<=(n|0)){q=m;r=p;while(1){h[j+(q+ -1<<3)>>3]=+h[d+(r+ -1<<3)>>3];if((q|0)<(n|0)){r=r+1|0;q=q+1|0}else{break}}}q=m+ -1|0;r=(m|0)<2;if(r){s=p}else{t=(q|0)>1?q:1;u=t+ -1|0;v=(m<<1)+o+(fa(u,m+ -3-n|0)|0)+ -2-n|0;o=Rqb(u|0,0,t+ -2|0,0)|0;t=Kqb(o|0,J&1|0,1)|0;o=p;p=1;while(1){u=m-p|0;w=o+ -1+u-n|0;x=u+ -1|0;h[j+(x<<3)>>3]=0.0;y=g+(x<<3)|0;z=+h[y>>3];do{if(!(z==0.0)){x=g+(q<<3)|0;A=+h[x>>3];if(!(A>=0.0)){B=-A}else{B=A}if(!(z>=0.0)){C=-z}else{C=z}do{if(!(B>=C)){D=A/z;E=.5/+V(+(D*D*.25+.25));F=D*E;if(!(F>=0.0)){G=-F}else{G=F}if(!(l*G>1.0)){H=F;I=E;K=1.0;break}H=F;I=E;K=1.0/F}else{F=z/A;E=.5/+V(+(F*F*.25+.25));D=F*E;H=E;I=D;K=D}}while(0);h[x>>3]=I*z+H*A;h[y>>3]=K;if((u|0)>(n|0)){break}else{L=u;M=w}while(1){N=d+(M+ -1<<3)|0;D=+h[N>>3];O=j+(L+ -1<<3)|0;E=+h[O>>3];h[O>>3]=I*D+H*E;h[N>>3]=H*D-I*E;if((L|0)<(n|0)){M=M+1|0;L=L+1|0}else{break}}}}while(0);if((p|0)<(q|0)){p=p+1|0;o=w}else{break}}s=v-n-t|0}if((n|0)>=1){t=g+(q<<3)|0;g=1;while(1){v=g+ -1|0;o=j+(v<<3)|0;h[o>>3]=+h[o>>3]+ +h[t>>3]*+h[f+(v<<3)>>3];if((g|0)<(n|0)){g=g+1|0}else{break}}}c[k>>2]=0;if(r){P=s}else{r=1;g=s;while(1){s=j+(r+ -1<<3)|0;I=+h[s>>3];n=d+(g+ -1<<3)|0;if(!(I==0.0)){H=+h[n>>3];if(!(H>=0.0)){Q=-H}else{Q=H}if(!(I>=0.0)){R=-I}else{R=I}do{if(!(Q>=R)){K=H/I;G=.5/+V(+(K*K*.25+.25));C=K*G;if(!(C>=0.0)){S=-C}else{S=C}if(!(l*S>1.0)){T=C;U=G;W=1.0;break}T=C;U=G;W=1.0/C}else{C=I/H;G=.5/+V(+(C*C*.25+.25));K=C*G;T=G;U=K;W=K}}while(0);w=c[a>>2]|0;a:do{if((r|0)<=(w|0)){K=I;G=H;f=r;t=g;while(1){h[j+(f+ -1<<3)>>3]=T*K-U*G;h[d+(t+ -1<<3)>>3]=T*G+U*K;if((f|0)>=(w|0)){break a}K=+h[j+(f<<3)>>3];G=+h[d+(t<<3)>>3];f=f+1|0;t=t+1|0}}}while(0);h[s>>3]=W}if(+h[n>>3]==0.0){c[k>>2]=1}w=1-r+g+(c[a>>2]|0)|0;if((r|0)<(q|0)){r=r+1|0;g=w}else{P=w;break}}}g=c[a>>2]|0;a=c[b>>2]|0;if((a|0)<=(g|0)){b=a;a=P;while(1){h[d+(a+ -1<<3)>>3]=+h[j+(b+ -1<<3)>>3];if((b|0)<(g|0)){a=a+1|0;b=b+1|0}else{break}}}if(!(+h[d+(P+ -1<<3)>>3]==0.0)){i=e;return 0}c[k>>2]=1;i=e;return 0}function GZa(b,d,e,f,g,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,W=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0,Ka=0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0,Va=0;s=i;t=c[d>>2]|0;u=~t;h[33460]=.5;h[33478]=6.283185307179586;v=+h[l>>3];h[33473]=v*v;c[66942]=0;l=c[b>>2]|0;c[66960]=l;c[66958]=l;w=c[b>>2]|0;c[66882]=1;if((w|0)<1){x=l;y=0}else{z=1;while(1){A=z+ -1|0;h[n+(A<<3)>>3]=+h[e+(A<<3)>>3];if((z|0)<(w|0)){z=z+1|0}else{break}}c[66882]=w+1;x=l;y=0}a:while(1){w=c[b>>2]|0;c[66882]=1;if((w|0)>=1){z=1;while(1){h[p+(z+ -1<<3)>>3]=0.0;if((z|0)<(w|0)){z=z+1|0}else{break}}c[66882]=w+1}z=c[d>>2]|0;c[66886]=1;if((z|0)>=1){e=1;while(1){h[33464]=0.0;A=c[b>>2]|0;c[66884]=1;if((A|0)<1){B=0.0}else{v=0.0;C=1;while(1){D=+h[f+((fa(C,t)|0)+u+e<<3)>>3];E=v+D*+h[n+(C+ -1<<3)>>3];h[33464]=E;if((C|0)<(A|0)){C=C+1|0;v=E}else{break}}c[66884]=A+1;B=E}v=+h[k+(e+ -1<<3)>>3]*B;h[33464]=v;C=c[b>>2]|0;c[66882]=1;if((C|0)>=1){D=v;F=1;while(1){v=D*+h[f+((fa(F,t)|0)+u+e<<3)>>3];G=p+(F+ -1<<3)|0;h[G>>3]=+h[G>>3]+v;if((F|0)>=(C|0)){break}D=+h[33464];F=F+1|0}c[66882]=C+1}F=e+1|0;c[66886]=F;if((e|0)<(z|0)){e=F}else{break}}}c[66896]=0;e=c[b>>2]|0;c[66884]=1;if((e|0)>=1){z=1;w=0;while(1){if((z|0)<1){H=1;I=w}else{F=z+ -1|0;A=p+(F<<3)|0;G=n+(F<<3)|0;F=z+1|0;J=1;K=w;while(1){L=j+(K<<3)|0;if((J|0)<(z|0)){M=J+ -1|0;h[A>>3]=+h[A>>3]+ +h[L>>3]*+h[n+(M<<3)>>3];N=M}else{N=J+ -1|0}M=p+(N<<3)|0;h[M>>3]=+h[L>>3]*+h[G>>3]+ +h[M>>3];if((J|0)<(z|0)){J=J+1|0;K=K+1|0}else{break}}K=z+w|0;c[66896]=K;H=F;I=K}if((z|0)<(e|0)){z=z+1|0;w=I}else{break}}c[66882]=H;c[66884]=e+1}do{if((y|0)==0){h[33462]=0.0;h[33444]=0.0;w=c[b>>2]|0;c[66882]=1;if((w|0)>=1){z=1;while(1){h[m+(z+ -1<<3)>>3]=0.0;K=z+ -1|0;h[q+(K<<3)>>3]=0.0;D=+h[g+(K<<3)>>3]+ +h[p+(K<<3)>>3];h[o+(K<<3)>>3]=D;h[n+(K<<3)>>3]=-D;h[33444]=+h[33444]+D*D;if((z|0)<(w|0)){z=z+1|0}else{break}}c[66882]=w+1}h[r>>3]=0.0;D=+h[33444];if(D==0.0){O=55;break a}h[33449]=0.0;h[33452]=0.0;h[33447]=D;h[33467]=D;P=D;Q=0.0;R=0.0;S=+h[33473];T=0}else{if((y|0)>(x|0)){h[33446]=0.0;h[33453]=0.0;h[33454]=0.0;z=c[b>>2]|0;c[66882]=1;if((z|0)<1){U=0.0;W=0.0;Z=0.0}else{D=0.0;v=0.0;_=0.0;F=1;while(1){K=F+ -1|0;$=_+ +h[n+(K<<3)>>3]*+h[o+(K<<3)>>3];h[33446]=$;K=F+ -1|0;J=p+(K<<3)|0;aa=v+ +h[J>>3]*+h[n+(K<<3)>>3];h[33453]=aa;ba=D+ +h[J>>3]*+h[m+(K<<3)>>3];h[33454]=ba;if((F|0)<(z|0)){F=F+1|0;_=$;v=aa;D=ba}else{break}}c[66882]=z+1;U=ba;W=$;Z=aa}D=+h[33460];v=D*(+h[33457]-Z);h[33445]=v;_=+h[33450];ca=_+v;h[33461]=ca;h[33465]=ca;h[33463]=ca;c[66952]=0;a[267608]=1;da=+h[33478]/50.0;h[33464]=da;c[66882]=1;F=0;ea=ca;ga=ca;w=1;while(1){ha=+(w|0)*da;ia=+X(+ha);ja=+Y(+ha);ka=ia*(_+ia*v)+ja*(W+ia*U);do{if(ka<ea){h[33463]=ka;c[66952]=w;h[33474]=ga;la=w;ma=ka}else{if((w|0)!=(F+1|0)){la=F;ma=ea;break}h[33475]=ka;la=F;ma=ea}}while(0);K=w+1|0;if((K|0)<50){F=la;ea=ma;w=K;ga=ka}else{break}}h[33469]=ha;h[33455]=ia;h[33458]=ja;h[33466]=ka;c[66882]=50;h[33465]=ka;if((la|0)==0){h[33474]=ka;O=46}else if((la|0)==49){h[33475]=ca;na=ca}else{O=46}if((O|0)==46){O=0;na=+h[33475]}h[33469]=0.0;ga=+h[33474];if(ga!=na){ea=ga-ma;h[33474]=ea;ga=na-ma;h[33475]=ga;oa=D*(ea-ga)/(ea+ga);h[33469]=oa;pa=oa}else{pa=0.0}oa=da*(+(la|0)+pa);h[33469]=oa;ga=+X(+oa);h[33455]=ga;ea=+Y(+oa);h[33458]=ea;oa=ca-ga*(_+ga*v)-ea*(W+ga*U);h[33470]=oa;h[33447]=0.0;w=c[b>>2]|0;c[66882]=1;if((w|0)<1){qa=0.0;ra=oa}else{oa=ea;ea=ga;F=1;z=0;while(1){K=m+(z<<3)|0;h[K>>3]=ea*+h[K>>3]+oa*+h[n+(z<<3)>>3];K=F+ -1|0;J=q+(K<<3)|0;ga=+h[33455]*+h[J>>3]+ +h[33458]*+h[p+(K<<3)>>3];h[J>>3]=ga;sa=+h[o+(K<<3)>>3]+ga;ta=+h[33447]+sa*sa;h[33447]=ta;if((F|0)>=(w|0)){break}K=F;oa=+h[33458];ea=+h[33455];F=F+1|0;z=K}c[66882]=w+1;qa=ta;ra=+h[33470]}ea=ra+ +h[33462];h[33462]=ea;if((y|0)<(l|0)&ra/ea>.01){ua=qa;va=x}else{O=55;break a}}else{h[33453]=0.0;z=c[b>>2]|0;c[66884]=1;do{if((z|0)<1){ea=+h[33477];h[33468]=ea;wa=ea;xa=0.0;O=11}else{ea=0.0;F=1;while(1){K=F+ -1|0;ya=ea+ +h[n+(K<<3)>>3]*+h[p+(K<<3)>>3];h[33453]=ya;if((F|0)<(z|0)){F=F+1|0;ea=ya}else{break}}c[66884]=z+1;ea=+h[33477];h[33468]=ea;if(!(ya>0.0)){wa=ea;xa=ya;O=11;break}ea=ya/+h[33444];h[33464]=ea;if((y|0)==1){h[r>>3]=ea;za=ea;Aa=+h[33464]}else{za=+h[r>>3];Aa=ea}h[r>>3]=!(za<=Aa)?Aa:za;ea=+h[33468];oa=+h[33447];v=+h[33453];_=oa/v;ca=ea<=_?ea:_;h[33468]=ca;Ba=oa;Ca=v;Da=ca}}while(0);if((O|0)==11){O=0;Ba=+h[33447];Ca=xa;Da=wa}ca=Da*(Ba-Da*+h[33460]*Ca);h[33459]=ca;h[33462]=+h[33462]+ca;h[33472]=Ba;h[33447]=0.0;z=c[b>>2]|0;c[66882]=1;if((z|0)<1){Ea=Da;Fa=0.0}else{w=1;ca=Da;while(1){F=w+ -1|0;K=m+(F<<3)|0;h[K>>3]=+h[K>>3]+ca*+h[n+(F<<3)>>3];F=w+ -1|0;K=q+(F<<3)|0;v=+h[K>>3]+ +h[33468]*+h[p+(F<<3)>>3];h[K>>3]=v;oa=+h[o+(F<<3)>>3]+v;Ga=+h[33447]+oa*oa;h[33447]=Ga;Ha=+h[33468];if((w|0)<(z|0)){ca=Ha;w=w+1|0}else{break}}c[66882]=z+1;Ea=Ha;Fa=Ga}if(Ea<+h[33477]){if(+h[33459]<=+h[33462]*.01){O=55;break a}if(Fa<=+h[33467]*1.0e-4|(y|0)==(l|0)){O=55;break a}ca=Fa/+h[33472];h[33464]=ca;h[33444]=0.0;h[33449]=0.0;h[33452]=0.0;w=c[b>>2]|0;c[66882]=1;if((w|0)<1){O=55;break a}else{Ia=ca;Ja=1;Ka=0}while(1){F=n+(Ka<<3)|0;h[F>>3]=Ia*+h[F>>3]- +h[o+(Ka<<3)>>3]- +h[q+(Ka<<3)>>3];F=Ja+ -1|0;K=n+(F<<3)|0;ca=+h[K>>3];La=+h[33444]+ca*ca;h[33444]=La;J=m+(F<<3)|0;Ma=+h[33449]+ +h[K>>3]*+h[J>>3];h[33449]=Ma;ca=+h[J>>3];Na=+h[33452]+ca*ca;h[33452]=Na;if((Ja|0)>=(w|0)){break}J=Ja;Ia=+h[33464];Ja=Ja+1|0;Ka=J}c[66882]=w+1;if(Ma<=0.0){O=55;break a}ca=+h[33473];if(Na<ca){P=La;Q=Ma;R=Na;S=ca;T=y;break}}h[r>>3]=0.0;c[66958]=y;ua=+h[33447];va=y}if(ua<=+h[33467]*1.0e-4){O=55;break a}h[33450]=0.0;h[33457]=0.0;z=c[b>>2]|0;c[66882]=1;if((z|0)<1){Oa=0.0;Pa=0.0}else{ca=0.0;oa=0.0;J=1;while(1){K=J+ -1|0;Qa=oa+ +h[m+(K<<3)>>3]*+h[o+(K<<3)>>3];h[33450]=Qa;K=J+ -1|0;Ra=ca+ +h[m+(K<<3)>>3]*+h[q+(K<<3)>>3];h[33457]=Ra;if((J|0)<(z|0)){J=J+1|0;oa=Qa;ca=Ra}else{break}}c[66882]=z+1;Oa=Ra;Pa=Qa}ca=Pa+Oa;h[33456]=ca;oa=+h[33473];v=ua*oa;if(ca/+V(+v)<=-.99){O=55;break a}J=y+1|0;c[66942]=J;_=+V(+(v-ca*ca));h[33464]=_;v=oa/_;h[33474]=v;oa=ca/_;h[33475]=oa;w=c[b>>2]|0;c[66882]=1;if((w|0)<1){x=va;y=J;continue a}else{Sa=oa;Ta=v;Ua=1;Va=0}while(1){h[n+(Va<<3)>>3]=Ta*(+h[o+(Va<<3)>>3]+ +h[q+(Va<<3)>>3])-Sa*+h[m+(Va<<3)>>3];if((Ua|0)>=(w|0)){break}K=Ua;Sa=+h[33475];Ta=+h[33474];Ua=Ua+1|0;Va=K}c[66882]=w+1;x=va;y=J;continue a}}while(0);e=T+1|0;c[66942]=e;v=S-R;h[33464]=v;h[33477]=v/(Q+ +V(+(Q*Q+v*P)));y=e;x=x}if((O|0)==55){i=s;return 0}return 0}function HZa(b,d,e,f,g,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0,R=0;o=i;p=c[d>>2]|0;q=~p;r=c[j>>2]|0;j=~r;h[33487]=1.0;s=p-(c[b>>2]|0)|0;t=s+ -1|0;c[66980]=t;c[66970]=1;c[66964]=2;if((s|0)<3){u=1}else{s=2;v=1;while(1){do{if((s|0)==(c[g>>2]|0)){c[66970]=s;w=s}else{x=c[m>>2]|0;y=fa(s,p)|0;z=+h[f+(y+q+x<<3)>>3];if(!(z!=0.0)){w=v;break}A=fa(v,p)|0;B=x+q|0;x=f+(B+A<<3)|0;C=+h[x>>3];D=+V(+(z*z+C*C));h[33489]=D;C=+h[x>>3]/D;h[33496]=C;z=+h[f+(B+y<<3)>>3]/D;h[33497]=z;B=c[d>>2]|0;c[66962]=1;if((B|0)>=1){D=z;z=C;x=1;while(1){E=x+q|0;h[33489]=z*+h[f+(E+A<<3)>>3]+D*+h[f+(E+y<<3)>>3];E=x+q|0;F=f+(E+y<<3)|0;G=f+(E+A<<3)|0;h[F>>3]=z*+h[F>>3]-D*+h[G>>3];h[G>>3]=+h[33489];if((x|0)>=(B|0)){break}D=+h[33497];z=+h[33496];x=x+1|0}c[66962]=B+1}h[f+((c[m>>2]|0)+q+y<<3)>>3]=0.0;w=v}}while(0);x=s+1|0;c[66964]=x;if((s|0)<(t|0)){s=x;v=w}else{u=w;break}}}w=c[m>>2]|0;z=+h[f+(w+ -1<<3)>>3];h[33496]=z;if((c[g>>2]|0)>1){D=-z;h[33496]=D;H=D}else{H=z}v=(u|0)>1;if(v){h[33497]=+h[f+((fa(u,p)|0)+q+w<<3)>>3]}w=c[d>>2]|0;c[66962]=1;if((w|0)>=1){s=(fa(u,p)|0)+q|0;z=H;t=1;x=0;while(1){h[n+(x<<3)>>3]=z*+h[f+(x<<3)>>3];if(v){A=n+(t+ -1<<3)|0;h[A>>3]=+h[A>>3]+ +h[33497]*+h[f+(s+t<<3)>>3]}if((t|0)>=(w|0)){break}A=t;z=+h[33496];t=t+1|0;x=A}c[66962]=w+1}w=(c[m>>2]|0)+ -1|0;z=+h[n+(w<<3)>>3];h[33494]=z;x=k+(w<<3)|0;H=+h[x>>3];h[33488]=H;D=H*H;h[33498]=D;h[33495]=D+z*+h[l>>3];h[x>>3]=+h[x>>3]- +h[33487];a[267928]=0;do{if((u|0)==1){z=+h[33495];if(!(z>=0.0)){I=-z}else{I=z}z=+V(+I);h[33489]=z;D=+h[33496]/z;h[33497]=D;H=+h[33488]/z;h[33496]=H;x=c[d>>2]|0;c[66962]=1;if((x|0)<1){J=z}else{z=D;D=H;w=1;t=0;while(1){s=f+(t<<3)|0;h[s>>3]=D*+h[s>>3]-z*+h[k+(t<<3)>>3];if((w|0)>=(x|0)){break}s=w;z=+h[33497];D=+h[33496];w=w+1|0;t=s}c[66962]=x+1;J=+h[33489]}t=c[g>>2]|0;if((t|0)==1&J<0.0){c[g>>2]=2;K=2}else{K=t}if(!((K|0)<2|!(J>=0.0))){L=46}}else{c[66966]=1;if(!(+h[l>>3]>=0.0)){M=1}else{c[66966]=u;M=u}t=u+1-M|0;c[66968]=t;w=fa(t,p)|0;t=(c[m>>2]|0)+q|0;D=+h[33495];z=+h[f+(t+w<<3)>>3]/D;h[33489]=z;h[33496]=z*+h[l>>3];H=+h[33488];h[33497]=z*H;s=fa(M,p)|0;z=+h[f+(t+s<<3)>>3];h[33489]=z;C=+h[l>>3];if(!(C>=0.0)){N=-C}else{N=C}C=+h[33487]/+V(+(+h[33498]+z*N*z));h[33492]=C;if(!(D>=0.0)){O=-D}else{O=D}h[33493]=C*+V(+O);t=c[d>>2]|0;c[66962]=1;if((t|0)<1){P=D}else{D=z;z=H;H=C;v=1;while(1){A=f+(v+q+s<<3)|0;h[A>>3]=H*(z*+h[A>>3]-D*+h[k+(v+ -1<<3)>>3]);A=f+(v+q+w<<3)|0;G=v+ -1|0;h[A>>3]=+h[33493]*(+h[A>>3]- +h[33496]*+h[n+(G<<3)>>3]- +h[33497]*+h[k+(G<<3)>>3]);if((v|0)>=(t|0)){break}D=+h[33489];z=+h[33488];H=+h[33492];v=v+1|0}c[66962]=t+1;P=+h[33495]}if(!(P<=0.0)){break}H=+h[l>>3];if(H<0.0){c[g>>2]=(c[g>>2]|0)+1}if(H>=0.0){L=46}}}while(0);do{if((L|0)==46){a[267928]=1;c[g>>2]=(c[g>>2]|0)+ -1;M=c[d>>2]|0;c[66962]=1;if((M|0)<1){break}else{Q=1}while(1){u=f+(Q+ -1<<3)|0;h[33489]=+h[u>>3];K=f+(Q+q+(fa(c[g>>2]|0,p)|0)<<3)|0;h[u>>3]=+h[K>>3];h[K>>3]=+h[33489];K=Q+1|0;c[66962]=K;if((Q|0)<(M|0)){Q=K}else{break}}}}while(0);Q=c[b>>2]|0;c[66964]=1;if((Q|0)<1){i=o;return 0}else{R=1}while(1){b=(c[d>>2]|0)+R|0;c[66972]=b;p=fa(R,r)|0;P=+h[e+((c[m>>2]|0)+j+p<<3)>>3];g=b+ -1|0;q=n+(g<<3)|0;h[q>>3]=P;f=k+(g<<3)|0;O=+h[33488];N=+h[33495];J=(+h[33494]*+h[f>>3]-O*P)/N;h[33496]=J;P=(-(+h[l>>3]*+h[q>>3])-O*+h[f>>3])/N;h[33497]=P;c[66962]=1;a:do{if((b|0)>=1){N=P;O=J;f=1;while(1){q=e+(f+j+p<<3)|0;g=f+ -1|0;I=+h[q>>3]+O*+h[k+(g<<3)>>3]+N*+h[n+(g<<3)>>3];h[q>>3]=I;q=c[d>>2]|0;if((f|0)>(q|0)){h[e+((fa(f-q|0,r)|0)+j+b<<3)>>3]=I}q=f+1|0;c[66962]=q;if((f|0)>=(b|0)){break a}N=+h[33497];O=+h[33496];f=q}}}while(0);b=R+1|0;c[66964]=b;if((R|0)<(Q|0)){R=b}else{break}}i=o;return 0}function IZa(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0;m=i;if((b|0)<(d|0)){n=(b|0)<(e|0);o=0.0;p=-1;q=-1;r=b;while(1){if(n){s=c[f+(r<<2)>>2]|0;t=b;u=o;v=p;w=q;while(1){x=+U(+(+h[a+((fa(c[g+(t<<2)>>2]|0,d)|0)+s<<3)>>3]));y=x>u;z=y?r:w;A=y?t:v;B=y?x:u;y=t+1|0;if((y|0)<(e|0)){w=z;v=A;u=B;t=y}else{C=B;D=A;E=z;break}}}else{C=o;D=p;E=q}t=r+1|0;if((t|0)<(d|0)){o=C;p=D;q=E;r=t}else{F=C;G=D;H=E;break}}}else{F=0.0;G=-1;H=-1}if((G|H|0)<0){I=-1;i=m;return I|0}c[j>>2]=H;c[k>>2]=G;h[l>>3]=F;I=0;i=m;return I|0}function JZa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0;g=i;i=i+24|0;j=g;k=g+8|0;l=g+16|0;m=(b|0)<=(d|0)?b:d;if((m|0)>0){n=0}else{o=0;i=g;return o|0}while(1){p=e+(n<<2)|0;q=f+(n<<2)|0;r=+h[a+((fa(c[q>>2]|0,b)|0)+(c[p>>2]|0)<<3)>>3];if((IZa(a,n,b,d,e,f,j,k,l)|0)!=0){o=-1;s=14;break}t=+U(+r);if(+h[l>>3]>t*1.125){u=c[p>>2]|0;v=e+(c[j>>2]<<2)|0;c[p>>2]=c[v>>2];c[v>>2]=u;u=c[q>>2]|0;v=f+(c[k>>2]<<2)|0;c[q>>2]=c[v>>2];c[v>>2]=u}u=c[p>>2]|0;p=fa(c[q>>2]|0,b)|0;t=+h[a+(p+u<<3)>>3];if(!(t!=0.0)){s=7;break}q=n+1|0;if((q|0)<(b|0)){v=(q|0)<(d|0);w=q;do{x=c[e+(w<<2)>>2]|0;y=a+(p+x<<3)|0;r=+h[y>>3];do{if(r!=0.0){z=-r/t;h[y>>3]=0.0;if(v){A=q}else{break}do{B=fa(c[f+(A<<2)>>2]|0,b)|0;C=a+(B+x<<3)|0;h[C>>3]=+h[C>>3]+z*+h[a+(u+B<<3)>>3];A=A+1|0;}while((A|0)<(d|0))}}while(0);w=w+1|0;}while((w|0)<(b|0))}if((q|0)<(m|0)){n=q}else{o=0;s=14;break}}if((s|0)==7){db(267992,268008,116,268032)}else if((s|0)==14){i=g;return o|0}return 0}function KZa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=e;c[u>>2]=0;v=b+280|0;w=c[v>>2]|0;x=1;while(1){y=x+1|0;if((uqb(w,c[268040+(x<<2)>>2]|0)|0)==0){z=4;break}if((y|0)<8){x=y}else{break}}do{if((z|0)==4){c[u>>2]=x;if((x|0)==0){break}y=c[268144+(x<<2)>>2]|0;c[q>>2]=c[268040+(x<<2)>>2];c[q+4>>2]=y;kXa(23,0,268216,q);y=b+112|0;A=e+28|0;c[A>>2]=(c[y>>2]|0)+20;B=c[y>>2]|0;C=b+160|0;D=((c[C>>2]|0)*3|0)+50+(fa(B+9|0,B)|0)|0;c[e+32>>2]=D;B=Ypb(D,8)|0;c[e+40>>2]=B;D=b+536|0;nXa(c[D>>2]|0,(B|0)!=0|0,268256,p);B=Ypb(c[A>>2]|0,4)|0;c[e+36>>2]=B;nXa(c[D>>2]|0,(B|0)!=0|0,268256,o);c[e+56>>2]=c[C>>2];c[e+52>>2]=0;c[e+60>>2]=Ypb(c[C>>2]|0,4)|0;c[e+24>>2]=Wpb(8)|0;C=Wpb(4)|0;c[e+20>>2]=C;c[C>>2]=c[240136>>2];nXa(c[D>>2]|0,(C|0)!=0|0,268256,n);C=c[y>>2]<<3;B=e+48|0;c[B>>2]=Wpb(C)|0;A=e+44|0;c[A>>2]=Wpb(C)|0;C=Ypb(15,4)|0;E=e+12|0;c[E>>2]=C;nXa(c[D>>2]|0,(C|0)!=0|0,268256,m);C=Ypb(5,4)|0;c[e+4>>2]=C;nXa(c[D>>2]|0,(C|0)!=0|0,268256,l);C=Ypb(5,4)|0;c[e+8>>2]=C;nXa(c[D>>2]|0,(C|0)!=0|0,268256,k);c[e+16>>2]=0;h[e+64>>3]=1.4901161193847656e-8;C=c[y>>2]<<3;c[e+72>>2]=Wpb(C)|0;c[e+76>>2]=Wpb(C)|0;c[e+80>>2]=Wpb(C)|0;C=c[E>>2]|0;c[C+8>>2]=1;D=c[u>>2]|0;a:do{switch(D|0){case 7:case 1:case 2:case 4:case 5:case 3:{if((pe[c[(c[b+540>>2]|0)+140>>2]&127](b)|0)==0){F=c[E>>2]|0;c[F+16>>2]=1;G=F;H=c[u>>2]|0;z=17;break a}if((c[y>>2]|0)==1){kXa(23,0,268272,j)}else{kXa(1,0,268344,g)}c[u>>2]=6;z=18;break};default:{G=C;H=D;z=17}}}while(0);if((z|0)==17){if((H|0)==2){I=G}else{z=18}}if((z|0)==18){a[d+28|0]=1;I=c[E>>2]|0}c[I+4>>2]=1;D=c[y>>2]|0;if((D|0)<=0){i=f;return 0}C=b+272|0;F=c[A>>2]|0;J=c[b+8>>2]|0;K=c[B>>2]|0;L=0;do{h[F+(L<<3)>>3]=+h[C>>3];h[K+(L<<3)>>3]=+h[C>>3]*+h[J+(L*112|0)+80>>3];L=L+1|0;}while((L|0)<(D|0));i=f;return 0}}while(0);if((c[240172>>2]|c[60018]|0)==0){M=w;N=b;O=N+536|0;P=O;Q=c[P>>2]|0;R=r;S=R;c[S>>2]=M;T=5;U=T;V=268176;W=V;oXa(Q,W,r)}c[t>>2]=w;mXa(23,1,268072,t);t=1;do{w=c[268144+(t<<2)>>2]|0;c[s>>2]=c[268040+(t<<2)>>2];c[s+4>>2]=w;mXa(23,0,268128,s);t=t+1|0;}while((t|0)<8);me[c[60158]&2047](23);M=c[v>>2]|0;N=b;O=N+536|0;P=O;Q=c[P>>2]|0;R=r;S=R;c[S>>2]=M;T=5;U=T;V=268176;W=V;oXa(Q,W,r);return 0}function LZa(a){a=a|0;var b=0;b=i;Xpb(c[a+40>>2]|0);Xpb(c[a+36>>2]|0);Xpb(c[a+20>>2]|0);Xpb(c[a+12>>2]|0);Xpb(c[a+4>>2]|0);Xpb(c[a+8>>2]|0);Xpb(a);i=b;return 0}function MZa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;s=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;h[D>>3]=0.0;E=a+4|0;F=c[E>>2]|0;G=c[F>>2]|0;H=c[b+48>>2]|0;I=(c[F+4>>2]|0)+8|0;F=c[I>>2]|0;J=a+112|0;K=c[J>>2]|0;L=F+(K<<3)|0;M=H+24|0;c[c[M>>2]>>2]=a;c[(c[M>>2]|0)+4>>2]=H;N=a+536|0;nXa(c[N>>2]|0,(c[M>>2]|0)!=0|0,268440,C);if((c[b+36>>2]|0)!=0){c[c[H+12>>2]>>2]=0;c[H+16>>2]=0}C=b;O=+h[C>>3];P=b+8|0;Q=O+ +h[P>>3];h[D>>3]=Q;if(O-Q>=-1.0e-13){kXa(3,0,268472,B);kXa(3,0,268512,A);A=c[J>>2]|0;if((A|0)>0){B=c[I>>2]|0;I=c[G+8>>2]|0;R=0;do{h[I+(R<<3)>>3]=+h[B+(R<<3)>>3]+ +h[F+(R+K<<3)>>3]*+h[P>>3];R=R+1|0;}while((R|0)<(A|0))}h[G>>3]=+h[D>>3];pe[c[(c[a+540>>2]|0)+28>>2]&127](a)|0;h[C>>3]=+h[D>>3];S=0;i=d;return S|0}A=z;h[k>>3]=O;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=Q;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];kXa(3,0,268536,z);z=H+16|0;A=z;R=a;P=b+24|0;b=H+12|0;K=H+44|0;F=H+48|0;B=H+40|0;I=H+32|0;T=H+36|0;U=H+28|0;V=U;W=H+20|0;X=H+52|0;Y=H+56|0;Z=H+60|0;_=c[r>>2]|0;$=c[t>>2]|0;aa=a+248|0;ba=a+540|0;ca=G;G=L;a:while(1){Q=+h[D>>3];L=y;h[k>>3]=+h[C>>3];c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];L=y+8|0;h[k>>3]=Q;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];kXa(23,0,268576,y);if((c[z>>2]|0)==1){rYa(c[R>>2]|0,1,c[E>>2]|0);L=c[E>>2]|0;da=c[L>>2]|0;ea=(c[(c[L+4>>2]|0)+8>>2]|0)+(c[J>>2]<<3)|0;h[da>>3]=+h[C>>3];fa=da;ga=ea}else{fa=ca;ga=G}if((c[P>>2]|0)!=5){J$a(a)|0;pe[c[(c[ba>>2]|0)+40>>2]&127](a)|0}ea=c[H>>2]|0;b:do{switch(ea|0){case 4:{VYa(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,4,2,Y,c[Z>>2]|0)|0;break};case 6:{VYa(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,6,2,Y,c[Z>>2]|0)|0;break};case 7:{VYa(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,7,3,X,0)|0;break};case 5:{VYa(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,5,2,Y,c[Z>>2]|0)|0;break};case 3:{VYa(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,3,2,Y,c[Z>>2]|0)|0;break};default:{da=c[fa+8>>2]|0;L=c[b>>2]|0;ha=c[K>>2]|0;ia=c[F>>2]|0;ja=c[B>>2]|0;ka=c[T>>2]|0;la=c[M>>2]|0;ma=c[W>>2]|0;if((ea|0)==2){VYa(1,J,C,da,ga,D,L,ha,ia,A,ja,I,ka,V,la,ma,7,3,X,0)|0;break b}else{VYa(1,J,C,da,ga,D,L,ha,ia,A,ja,I,ka,V,la,ma,7,2,Y,c[Z>>2]|0)|0;break b}}}}while(0);ea=c[z>>2]|0;do{if((ea|0)==-1){Bd(_|0)|0;Bd($|0)|0;mXa(3,0,268608,x);kXa(3,0,268696,w);c[c[b>>2]>>2]=1}else{if((ea|0)<0){na=25;break a}if((ea|0)!=4){break}c[(c[N>>2]|0)+84>>2]=4}}while(0);ea=c[z>>2]|0;if((ea|0)==1){ca=fa;G=ga;continue}else if(!((ea|0)==-1)){na=31;break}Q=+h[C>>3];if(!(Q<=+h[aa>>3])){oa=Q;break}else{ca=fa;G=ga}}if((na|0)==25){Bd(_|0)|0;Bd($|0)|0;$=VZa(c[z>>2]|0)|0;if((c[P>>2]|0)!=5){J$a(a)|0;pe[c[(c[ba>>2]|0)+40>>2]&127](a)|0}pe[c[(c[ba>>2]|0)+28>>2]&127](a)|0;a=v;h[k>>3]=+h[fa>>3];c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];mXa(1,0,268720,v);S=$;i=d;return S|0}else if((na|0)==31){oa=+h[C>>3]}h[fa>>3]=oa;if((c[240092>>2]|0)!=0){kXa(3,1,268752,u);c[s>>2]=c[z>>2];kXa(3,0,268776,s);s=q;h[k>>3]=+h[C>>3];c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];kXa(3,0,268800,q);q=p;h[k>>3]=+h[(c[B>>2]|0)+24>>3];c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];kXa(3,0,268832,p);p=o;h[k>>3]=+h[(c[B>>2]|0)+16>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];kXa(3,0,268872,o);o=n;h[k>>3]=+h[(c[B>>2]|0)+48>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];kXa(3,0,268920,n);c[m>>2]=c[(c[T>>2]|0)+40>>2];kXa(3,0,268968,m);c[l>>2]=c[(c[T>>2]|0)+44>>2];kXa(3,0,269008,l);c[j>>2]=c[(c[T>>2]|0)+48>>2];kXa(3,0,269048,j);c[g>>2]=c[(c[T>>2]|0)+52>>2];kXa(3,0,269088,g);c[f>>2]=c[(c[T>>2]|0)+56>>2];kXa(3,0,269136,f);me[c[60158]&2047](3)}f=c[U>>2]|0;U=H+8|0;H=0;do{g=H+10|0;if(!(g>>>0<f>>>0)){na=37;break}c[(c[U>>2]|0)+(H<<2)>>2]=c[(c[T>>2]|0)+(g<<2)>>2];H=H+1|0;}while(H>>>0<5);if((na|0)==37){db(269176,269208,410,269240)}kXa(3,0,269256,e);S=0;i=d;return S|0}function NZa(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;f=c[g>>2]|0;g=f;b=f+536|0;k=f+4|0;l=c[c[k>>2]>>2]|0;m=+h[l>>3];h[l>>3]=+h[a>>3];a=(c[b>>2]|0)+84|0;l=c[a>>2]|0;c[a>>2]=2;J$a(g)|0;a=f+540|0;pe[c[(c[a>>2]|0)+40>>2]&127](g)|0;pe[c[(c[a>>2]|0)+28>>2]&127](g)|0;g=c[f+112>>2]|0;if((g|0)<=0){n=c[b>>2]|0;o=n;p=o+84|0;q=p;c[q>>2]=l;r=c[k>>2]|0;s=c[r>>2]|0;t=s;u=t;h[u>>3]=m;i=j;return 0}f=c[(c[c[k>>2]>>2]|0)+8>>2]|0;a=0;do{h[e+(a<<3)>>3]=+h[f+(g+a<<3)>>3]- +h[d+(a<<3)>>3];a=a+1|0;}while((a|0)<(g|0));n=c[b>>2]|0;o=n;p=o+84|0;q=p;c[q>>2]=l;r=c[k>>2]|0;s=c[r>>2]|0;t=s;u=t;h[u>>3]=m;i=j;return 0}function OZa(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;k=c[l>>2]|0;l=k;j=k+4|0;e=c[c[j>>2]>>2]|0;d=e+8|0;n=c[d>>2]|0;o=e;p=+h[o>>3];h[o>>3]=+h[a>>3];c[d>>2]=b;J$a(l)|0;b=k+540|0;pe[c[(c[b>>2]|0)+40>>2]&127](l)|0;pe[c[(c[b>>2]|0)+28>>2]&127](l)|0;XZa(l,f)|0;l=c[k+112>>2]|0;if((l|0)>0){q=0;r=0}else{s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}while(1){k=f+(r<<3)|0;h[k>>3]=+h[k>>3]- +h[g>>3];k=q+1|0;if((k|0)<(l|0)){r=r+1+l|0;q=k}else{break}}s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}function PZa(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0.0;j=i;e=c[g>>2]|0;g=e;d=e+536|0;a=(c[d>>2]|0)+84|0;k=c[a>>2]|0;c[a>>2]=4;a=e+4|0;l=c[c[a>>2]>>2]|0;m=+h[l>>3];h[l>>3]=+h[b>>3];J$a(g)|0;l=e+540|0;pe[c[(c[l>>2]|0)+40>>2]&127](g)|0;pe[c[(c[l>>2]|0)+28>>2]&127](g)|0;pe[c[(c[l>>2]|0)+32>>2]&127](g)|0;se[c[(c[l>>2]|0)+92>>2]&63](g,f,b)|0;c[(c[d>>2]|0)+84>>2]=k;h[c[c[a>>2]>>2]>>3]=m;i=j;return 0}function QZa(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;m=i;n=c[l>>2]|0;YZa(n,a,b,d,e,f,0,j,k,l,0)|0;l=c[n+112>>2]|0;if((l|0)>0){o=0;p=0}else{i=m;return 0}while(1){n=f+(p<<3)|0;h[n>>3]=+h[n>>3]- +h[g>>3];n=o+1|0;if((n|0)<(l|0)){p=p+1+l|0;o=n}else{break}}i=m;return 0}function RZa(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;k=c[l>>2]|0;l=k;j=k+4|0;e=c[c[j>>2]>>2]|0;d=e+8|0;n=c[d>>2]|0;o=e;p=+h[o>>3];h[o>>3]=+h[a>>3];c[d>>2]=b;J$a(l)|0;b=k+540|0;pe[c[(c[b>>2]|0)+40>>2]&127](l)|0;pe[c[(c[b>>2]|0)+28>>2]&127](l)|0;WZa(l,f)|0;l=c[k+112>>2]|0;if((l|0)>0){q=0;r=0}else{s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}while(1){k=f+(r<<3)|0;h[k>>3]=+h[k>>3]- +h[g>>3];k=q+1|0;if((k|0)<(l|0)){r=r+1+l|0;q=k}else{break}}s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}function SZa(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;i=i;return 0}function TZa(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;m=i;n=c[l>>2]|0;ZZa(n,a,b,d,e,f,0,j,k,l,0)|0;l=c[n+112>>2]|0;if((l|0)>0){o=0;p=0}else{i=m;return 0}while(1){n=f+(p<<3)|0;h[n>>3]=+h[n>>3]- +h[g>>3];n=o+1|0;if((n|0)<(l|0)){p=p+1+l|0;o=n}else{break}}i=m;return 0}function UZa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i;return 0}function VZa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+8|0;c=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;switch(a|0){case-33:{mXa(1,0,269800,b);m=-33;i=b;return m|0};case-11:{mXa(1,0,269664,d);m=-11;i=b;return m|0};case-3:{m=-3;i=b;return m|0};case-8:{mXa(1,0,269432,g);m=-8;i=b;return m|0};case-1:{mXa(3,0,268608,l);m=1;i=b;return m|0};case-7:{mXa(1,0,269392,h);m=-7;i=b;return m|0};case-2:{mXa(1,0,269280,k);m=-2;i=b;return m|0};case-9:{mXa(1,0,269480,f);m=-9;i=b;return m|0};case-10:{mXa(1,0,269568,e);m=-10;i=b;return m|0};case-12:{mXa(1,0,269752,c);m=-12;i=b;return m|0};case-6:{mXa(1,0,269320,j);m=-6;i=b;return m|0};default:{m=-1;i=b;return m|0}}return 0}function WZa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;e=a+540|0;f=c[(c[e>>2]|0)+120>>2]|0;g=a+464|0;j=c[g>>2]|0;if((c[j+(f*44|0)+24>>2]|0)==0){i=d;return 0}k=a;a=c[j+(f*44|0)>>2]|0;l=j;j=0;do{if((a|0)!=0){m=0;do{if(((c[(c[l+(f*44|0)+20>>2]|0)+(m<<2)>>2]|0)+ -1|0)==(j|0)){h[(c[l+(f*44|0)+28>>2]|0)+(m<<3)>>3]=1.0}m=m+1|0;}while(m>>>0<a>>>0)}pe[c[(c[e>>2]|0)+160>>2]&127](k)|0;l=c[g>>2]|0;a=c[l+(f*44|0)>>2]|0;do{if((a|0)!=0){m=c[l+(f*44|0)+28>>2]|0;n=0;do{do{if(+h[m+(n<<3)>>3]==1.0){if((n|0)==0){o=l+(f*44|0)+8|0;p=0}else{q=l+(f*44|0)+8|0;o=q;p=c[(c[q>>2]|0)+(n+ -1<<2)>>2]|0}q=c[(c[o>>2]|0)+(n<<2)>>2]|0;if(!(p>>>0<q>>>0)){break}r=c[l+(f*44|0)+12>>2]|0;s=c[l+(f*44|0)+4>>2]|0;t=c[l+(f*44|0)+36>>2]|0;u=p;do{v=c[r+(u<<2)>>2]|0;w=(fa(s,n)|0)+v|0;h[b+(w<<3)>>3]=+h[t+(v<<3)>>3];u=u+1|0;}while(u>>>0<q>>>0)}}while(0);n=n+1|0;}while(n>>>0<a>>>0);if((a|0)==0){break}n=c[l+(f*44|0)+20>>2]|0;m=0;do{if(((c[n+(m<<2)>>2]|0)+ -1|0)==(j|0)){h[(c[l+(f*44|0)+28>>2]|0)+(m<<3)>>3]=0.0}m=m+1|0;}while(m>>>0<a>>>0)}}while(0);j=j+1|0;}while(j>>>0<(c[l+(f*44|0)+24>>2]|0)>>>0);i=d;return 0}function XZa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=a+540|0;f=c[e>>2]|0;g=c[f+120>>2]|0;j=a+464|0;k=c[j>>2]|0;if((c[k+(g*44|0)>>2]|0)==0){i=d;return 0}l=a;a=f;f=c[k+(g*44|0)+28>>2]|0;k=0;m=0;while(1){h[f+(k<<3)>>3]=1.0;pe[c[a+160>>2]&127](l)|0;n=c[j>>2]|0;o=c[n+(g*44|0)+4>>2]|0;if((o|0)==0){p=m}else{q=o>>>0>1?o:1;r=c[n+(g*44|0)+36>>2]|0;s=0;t=m;while(1){h[b+(t<<3)>>3]=+h[r+(s<<3)>>3];u=s+1|0;if(u>>>0<o>>>0){t=t+1|0;s=u}else{break}}p=m+q|0}s=c[n+(g*44|0)+28>>2]|0;h[s+(k<<3)>>3]=0.0;t=k+1|0;if(!(t>>>0<(c[n+(g*44|0)>>2]|0)>>>0)){break}a=c[e>>2]|0;f=s;k=t;m=p}i=d;return 0}function YZa(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0;n=i;j=c[m+4>>2]|0;o=+h[j+64>>3];p=a+112|0;a=c[p>>2]|0;if((a|0)<=0){i=n;return 0}q=j+80|0;j=a;do{j=j+ -1|0;r=+h[k>>3]*+h[e+(j<<3)>>3];a=d+(j<<3)|0;s=+h[a>>3];if(!(s>=0.0)){t=-s}else{t=s}u=r>=0.0;if(u){v=r}else{v=-r}r=+Ad(+t,+v);w=+h[l+(j<<3)>>3];if(!(w>=0.0)){x=-w}else{x=w}w=o*+Ad(+r,+x);if(u){y=w}else{y=-w}w=y+s-s;r=1.0/w;h[a>>3]=s+w;NZa(b,0,e,c[q>>2]|0,0,m,0)|0;u=c[p>>2]|0;if((u|0)>0){z=c[q>>2]|0;A=fa(u,j)|0;B=u;do{B=B+ -1|0;h[g+(A+B<<3)>>3]=r*(+h[z+(B<<3)>>3]- +h[f+(B<<3)>>3]);}while((B|0)>0)}h[a>>3]=s;}while((j|0)>0);i=n;return 0}function ZZa(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;n=i;j=c[(c[a+540>>2]|0)+120>>2]|0;o=c[m+4>>2]|0;p=+h[o+64>>3];q=c[o+76>>2]|0;r=c[o+72>>2]|0;s=a+464|0;a=c[s>>2]|0;if((c[a+(j*44|0)+24>>2]|0)==0){i=n;return 0}t=o+80|0;o=c[a+(j*44|0)>>2]|0;u=a;a=0;do{if((o|0)!=0){v=0;do{if(((c[(c[u+(j*44|0)+20>>2]|0)+(v<<2)>>2]|0)+ -1|0)==(a|0)){w=+h[k>>3]*+h[e+(v<<3)>>3];x=d+(v<<3)|0;y=+h[x>>3];if(!(y>=0.0)){z=-y}else{z=y}A=w>=0.0;if(A){B=w}else{B=-w}w=+Ad(+z,+B);y=+h[l+(v<<3)>>3];if(!(y>=0.0)){C=-y}else{C=y}y=p*+Ad(+w,+C);D=q+(v<<3)|0;h[D>>3]=y;if(A){E=y}else{E=-y}h[D>>3]=E;y=+h[x>>3];h[D>>3]=E+y-y;h[r+(v<<3)>>3]=+h[x>>3];h[x>>3]=+h[D>>3]+ +h[x>>3];h[D>>3]=1.0/+h[D>>3]}v=v+1|0;}while(v>>>0<o>>>0)}NZa(b,0,e,c[t>>2]|0,0,m,0)|0;u=c[s>>2]|0;o=c[u+(j*44|0)>>2]|0;if((o|0)!=0){v=c[u+(j*44|0)+20>>2]|0;D=0;do{if(((c[v+(D<<2)>>2]|0)+ -1|0)==(a|0)){if((D|0)==0){F=u+(j*44|0)+8|0;G=0}else{x=u+(j*44|0)+8|0;F=x;G=c[(c[x>>2]|0)+(D+ -1<<2)>>2]|0}x=c[(c[F>>2]|0)+(D<<2)>>2]|0;if(G>>>0<x>>>0){A=c[t>>2]|0;H=q+(D<<3)|0;I=c[u+(j*44|0)+12>>2]|0;J=c[u+(j*44|0)+4>>2]|0;K=G;do{L=c[I+(K<<2)>>2]|0;M=(fa(J,D)|0)+L|0;h[g+(M<<3)>>3]=(+h[A+(L<<3)>>3]- +h[f+(L<<3)>>3])*+h[H>>3];K=K+1|0;}while(K>>>0<x>>>0)}h[d+(D<<3)>>3]=+h[r+(D<<3)>>3]}D=D+1|0;}while(D>>>0<o>>>0)}a=a+1|0;}while(a>>>0<(c[u+(j*44|0)+24>>2]|0)>>>0);i=n;return 0}function _Za(a,b){a=a|0;b=+b;h[a+496>>3]=b;i=i;return}function $Za(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0;e=i;me[c[(c[a+540>>2]|0)+112>>2]&2047](a);f=a+328|0;h[f>>3]=d+1.0;g=c[a+104>>2]|0;if((g|0)<=0){i=e;return}j=c[a+108>>2]|0;k=a+336|0;a=0;do{d=+h[j+(a*24|0)+8>>3];if(d>b){h[(c[k>>2]|0)+(a<<3)>>3]=d;l=d}else{m=+h[j+(a*24|0)+16>>3];n=d+m*+ea(+((b-d)/m));h[(c[k>>2]|0)+(a<<3)>>3]=n;l=n}if((a|0)==0){o=8}else{if(l<+h[f>>3]){o=8}}if((o|0)==8){o=0;h[f>>3]=l}a=a+1|0;}while((a|0)<(g|0));i=e;return}function a_a(b,c){b=b|0;c=c|0;var d=0,e=0.0,f=0,g=0.0;d=i;e=+h[c>>3];f=c+8|0;g=+h[b+328>>3];if(!(g<=e+ +h[f>>3]+1.0e-14)){i=d;return}h[f>>3]=g-e;a[b+317|0]=1;i=d;return}function b_a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0;d=i;i=i+8|0;e=d;f=a+160|0;if((c[f>>2]|0)<=0){g=vXa(b)|0;j=(g|0)>0;k=j&1;i=d;return k|0}l=a+540|0;m=a+344|0;n=a+348|0;o=a+368|0;a=0;do{Ee[c[(c[l>>2]|0)+104>>2]&63](a,e)|0;p=+h[(c[m>>2]|0)+(a<<3)>>3];if(p==1.0){if(+h[(c[n>>2]|0)+(a<<3)>>3]==-1.0){q=7}else{q=5}}else{q=5}do{if((q|0)==5){q=0;if(!(p==-1.0)){break}if(+h[(c[n>>2]|0)+(a<<3)>>3]==1.0){q=7}}}while(0);if((q|0)==7){q=0;tXa(b,(c[o>>2]|0)+(a<<2)|0)}a=a+1|0;}while((a|0)<(c[f>>2]|0));g=vXa(b)|0;j=(g|0)>0;k=j&1;i=d;return k|0}function c_a(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;e=i;g=f+32|0;do{if((b_a(b,c[g>>2]|0)|0)!=0){if((a[f+28|0]|0)!=0){break}d_a(b,c[g>>2]|0,f)}}while(0);if((a[b+317|0]|0)==1){h=1;i=e;return h|0}b=(vXa(d)|0)>0;h=b?2:0;i=e;return h|0}function d_a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=a+112|0;q=c[p>>2]<<3;r=Wpb(q)|0;s=r;t=Wpb(q)|0;q=t;h[n>>3]=+h[a+376>>3];u=a+4|0;h[o>>3]=+h[c[c[u>>2]>>2]>>3];c[67640]=rXa(4)|0;if((r|0)==0){db(270568,270584,308,270616)}if((t|0)==0){db(270632,270584,309,270616)}v=yXa(b)|0;if((v|0)!=0){w=v;do{v=AXa(w)|0;c[l>>2]=c[v>>2];kXa(27,0,270648,l);w=zXa(w)|0;}while((w|0)!=0)}w=c[p>>2]|0;if((w|0)>0){l=c[(c[c[u>>2]>>2]|0)+8>>2]|0;v=(w|0)>1?w<<3:8;Aqb(t|0,c[a+384>>2]|0,v|0)|0;Aqb(r|0,l|0,v|0)|0}h[d>>3]=+g_a(a,n,o,q,s,c[67640]|0,b);do{if((vXa(c[67640]|0)|0)==0){s=wXa(b)|0;q=a+344|0;x=+U(+(+h[(c[q>>2]|0)+(c[s>>2]<<3)>>3]));s=yXa(b)|0;if((s|0)==0){y=x}else{v=s;z=x;while(1){s=AXa(v)|0;x=+U(+(+h[(c[q>>2]|0)+(c[s>>2]<<3)>>3]));A=z>x?x:z;s=zXa(v)|0;if((s|0)==0){y=A;break}else{z=A;v=s}}}v=j;h[k>>3]=y;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];kXa(27,0,270696,j);v=yXa(b)|0;if((v|0)==0){break}else{B=v}do{v=AXa(B)|0;if(y==+U(+(+h[(c[q>>2]|0)+(c[v>>2]<<3)>>3]))){v=c[67640]|0;uXa(v,AXa(B)|0);v=AXa(B)|0;c[g>>2]=c[v>>2];kXa(27,0,270720,g)}B=zXa(B)|0;}while((B|0)!=0)}}while(0);sXa(b);if((c[240108>>2]|0)!=0){vXa(c[67640]|0)|0}if((vXa(c[67640]|0)|0)>0){B=m;do{g=wXa(c[67640]|0)|0;c[m>>2]=c[g>>2];xXa(c[67640]|0);c[f>>2]=c[m>>2];kXa(7,0,270744,f);tXa(b,B);}while((vXa(c[67640]|0)|0)>0)}h[d>>3]=+h[o>>3];o=c[c[u>>2]>>2]|0;h[o>>3]=+h[n>>3];n=c[p>>2]|0;if((n|0)>0){Aqb(c[o+8>>2]|0,t|0,((n|0)>1?n<<3:8)|0)|0}ef(a);j_a(a);a=c[c[u>>2]>>2]|0;h[a>>3]=+h[d>>3];d=c[p>>2]|0;if((d|0)<=0){Xpb(t);Xpb(r);i=e;return}Aqb(c[a+8>>2]|0,r|0,((d|0)>1?d<<3:8)|0)|0;Xpb(t);Xpb(r);i=e;return}function e_a(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0;g=i;i=i+32|0;j=g;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+8|0;p=b+4|0;q=+h[c[c[p>>2]>>2]>>3];r=b+317|0;do{if((a[r]|0)!=0){n_a(b);s=b+104|0;t=c[s>>2]|0;if((t|0)<=0){break}u=b+336|0;v=q+1.0e-14;w=b+340|0;x=b+108|0;y=t;t=0;while(1){if(!(+h[(c[u>>2]|0)+(t<<3)>>3]<=v)){z=y}else{a[(c[w>>2]|0)+t|0]=1;A=c[x>>2]|0;B=+h[A+(t*24|0)+8>>3];C=+h[A+(t*24|0)+16>>3];c[m>>2]=c[A+(t*24|0)>>2];A=m+4|0;h[k>>3]=B;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=m+12|0;h[k>>3]=C;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];kXa(7,0,270288,m);z=c[s>>2]|0}A=t+1|0;if((A|0)<(z|0)){y=z;t=A}else{break}}}}while(0);z=b+512|0;m=b+524|0;t=b+516|0;y=b+528|0;c[y>>2]=(c[y>>2]|0)-(c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]|0);if((vXa(d)|0)>0){h[c[c[p>>2]>>2]>>3]=+h[e>>3];do{if((c[240108>>2]|0)!=0){e=yXa(d)|0;if((e|0)==0){break}p=b+540|0;s=e;do{e=AXa(s)|0;x=c[e>>2]|0;e=Ee[c[(c[p>>2]|0)+104>>2]&63](x,n)|0;w=c[n>>2]|0;c[l>>2]=x;c[l+4>>2]=e;jXa(7,0,w,270312,l);s=zXa(s)|0;}while((s|0)!=0)}}while(0);l=f+40|0;c[l>>2]=(c[l>>2]|0)+1;c[y>>2]=(c[y>>2]|0)+1;c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]=1;l=c[m>>2]|0;n=c[b+520>>2]|0;h[n+(l<<3)>>3]=q;s=b+532|0;do{if((c[s>>2]|0)==0){p=c[y>>2]|0;if((p|0)!=(c[z>>2]|0)){break}v=+h[n+(((l+1|0)%(p|0)|0)<<3)>>3];w=b+264|0;if(!(q-v<+h[w>>3])){break}e=AXa(yXa(d)|0)|0;x=Ee[c[(c[b+540>>2]|0)+104>>2]&63](c[e>>2]|0,o)|0;e=c[o>>2]|0;C=+h[w>>3];w=j;h[k>>3]=v;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=j+8|0;h[k>>3]=q;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[j+16>>2]=p;p=j+20|0;h[k>>3]=C;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];c[j+28>>2]=x;jXa(1,0,e,270328,j);c[s>>2]=1}}while(0);sXa(d)}else{c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]=0}c[m>>2]=((c[m>>2]|0)+1|0)%(c[z>>2]|0)|0;i_a(b);f_a(b);if((a[r]|0)==0){i=g;return}z=b+104|0;m=c[z>>2]|0;do{if((m|0)>0){t=b+340|0;d=b+108|0;s=b+336|0;j=m;o=0;while(1){l=(c[t>>2]|0)+o|0;if((a[l]|0)==0){D=j}else{a[l]=0;l=(c[s>>2]|0)+(o<<3)|0;h[l>>3]=+h[(c[d>>2]|0)+(o*24|0)+16>>3]+ +h[l>>3];D=c[z>>2]|0}l=o+1|0;if((l|0)<(D|0)){j=D;o=l}else{break}}if((D|0)<=0){break}o=b+336|0;j=b+328|0;d=0;do{s=c[o>>2]|0;if((d|0)==0){E=+h[s>>3];F=29}else{q=+h[s+(d<<3)>>3];if(q<+h[j>>3]){E=q;F=29}}if((F|0)==29){F=0;h[j>>3]=E}d=d+1|0;}while((d|0)<(D|0))}}while(0);a[r]=0;r=f+44|0;c[r>>2]=(c[r>>2]|0)+1;i=g;return}function f_a(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;kXa(27,0,270936,b);d=a+344|0;se[c[(c[a+540>>2]|0)+92>>2]&63](a,c[d>>2]|0,c[c[a+4>>2]>>2]|0)|0;e=c[a+160>>2]|0;if((e|0)<=0){i=b;return}f=c[d>>2]|0;d=c[a+348>>2]|0;a=0;do{h[d+(a<<3)>>3]=+h[f+(a<<3)>>3];a=a+1|0;}while((a|0)<(e|0));i=b;return}



function Qe(a){a=a|0;var b=0;b=i;i=i+a|0;i=i+7&-8;return b|0}function Re(){return i|0}function Se(a){a=a|0;i=a}function Te(a,b){a=a|0;b=b|0;if((u|0)==0){u=a;v=b}}function Ue(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0]}function Ve(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0];a[k+4|0]=a[b+4|0];a[k+5|0]=a[b+5|0];a[k+6|0]=a[b+6|0];a[k+7|0]=a[b+7|0]}function We(a){a=a|0;J=a}function Xe(a){a=a|0;K=a}function Ye(a){a=a|0;L=a}function Ze(a){a=a|0;M=a}function _e(a){a=a|0;N=a}function $e(a){a=a|0;O=a}function af(a){a=a|0;P=a}function bf(a){a=a|0;Q=a}function cf(a){a=a|0;R=a}function df(a){a=a|0;S=a}function ef(a){a=a|0;var b=0,d=0;b=i;J$a(a)|0;d=a+540|0;pe[c[(c[d>>2]|0)+40>>2]&127](a)|0;pe[c[(c[d>>2]|0)+28>>2]&127](a)|0;pe[c[(c[d>>2]|0)+32>>2]&127](a)|0;pe[c[(c[d>>2]|0)+48>>2]&127](a)|0;pe[c[(c[d>>2]|0)+52>>2]&127](a)|0;n_a(a);i=b;return}function ff(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+24|0;s=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;c[v>>2]=0;y=b+240|0;z=d;h[z>>3]=+h[y>>3];if((c[2]|0)==0){A=0}else{B=c[b+88>>2]|0;C=yqb(B|0)|0;D=Wpb(C+11|0)|0;Jqb(D|0,B|0,C|0)|0;B=D+C+0|0;C=16|0;E=B+11|0;do{a[B]=a[C]|0;B=B+1|0;C=C+1|0}while((B|0)<(E|0));C=mc(D|0,32)|0;if((C|0)==0){B=be(c[(Qc()|0)>>2]|0)|0;c[u>>2]=D;c[u+4>>2]=B;mXa(23,0,40,u);ad(0)|0;F=0}else{F=C}Xpb(D);A=F}F=b+248|0;D=b+536|0;C=b;u=b+4|0;B=d+36|0;E=d+16|0;G=b+256|0;H=d+8|0;I=d+24|0;J=d+32|0;K=b+540|0;L=d+48|0;M=c[t>>2]|0;N=v;O=w;P=b+64|0;Q=b+72|0;R=x;S=0;T=A;while(1){if(!(+h[z>>3]<+h[F>>3])){U=T;V=0;break}Je[c[240980>>2]&7]()|0;c[(c[D>>2]|0)+84>>2]=1;if((c[2]|0)!=0){if(((c[Q>>2]|0)+(c[P>>2]|0)|0)>0){A=0;do{DYa(A+9|0);A=A+1|0;}while((A|0)<((c[Q>>2]|0)+(c[P>>2]|0)|0))}DYa(2);CYa(2)}rYa(c[C>>2]|0,1,c[u>>2]|0);if((c[B>>2]|0)==1){A=s;h[k>>3]=+h[z>>3]- +h[E>>3];c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];kXa(23,0,104,s);W=S}else{W=S+1|0}X=+h[y>>3];h[H>>3]=X+ +(W>>>0)*(+h[F>>3]-X)/+(c[G>>2]|0)- +h[z>>3];a_a(b,d);X=+h[z>>3];Y=+h[H>>3];A=r;h[k>>3]=X;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r+8|0;h[k>>3]=X+Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r+16|0;h[k>>3]=Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];kXa(23,1,144,r);Z=r$a(b,d)|0;if((c[I>>2]|0)==5){U=T;V=0;break}ef(b);o_a(b);if((c[240172>>2]|0)!=0){me[c[60158]&2047](23)}if((c[2]|0)!=0){CYa(4)}A=c_a(b,c[J>>2]|0,z,d)|0;if((A|0)>0){c[(c[D>>2]|0)+84>>2]=4;Y=+h[z>>3];c[q>>2]=(A|0)==1?224:232;A=q+4|0;h[k>>3]=Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];kXa(7,1,200,q);if((c[296980>>2]|0)==0){ne[c[281604>>2]&255](281584,b)}e_a(b,c[J>>2]|0,z,d);if((c[240108>>2]|0)!=0){me[c[60158]&2047](7)}c[(c[D>>2]|0)+84>>2]=1;c[B>>2]=1;s_a(b)}else{h[E>>3]=+h[z>>3];c[B>>2]=0}if((c[2]|0)!=0){FYa(4)}if((D$a(b,1,1)|0)!=0){c[B>>2]=1;s_a(b)}pe[c[(c[K>>2]|0)+88>>2]&127](b)|0;n_a(b);w_a(b);o_a(b);do{if((T|0)==0){_=0}else{CYa(7);FYa(2);A=(uc(N|0,4,1,T|0)|0)==1;c[v>>2]=(c[v>>2]|0)+1;do{if(A){$=(uc(c[c[u>>2]>>2]|0,8,1,T|0)|0)==1;h[w>>3]=+xYa(2);if(!$){aa=0;break}aa=(uc(O|0,8,1,T|0)|0)==1|0}else{h[w>>3]=+xYa(2);aa=0}}while(0);A=c[P>>2]|0;$=c[Q>>2]|0;if(($+A|0)>0){ba=aa;ca=0;while(1){c[x>>2]=sYa(ca+9|0)|0;if((ba|0)==0){da=0}else{da=(uc(R|0,4,1,T|0)|0)==1|0}ea=ca+1|0;fa=c[P>>2]|0;ga=c[Q>>2]|0;if((ea|0)<(ga+fa|0)){ba=da;ca=ea}else{ha=ga;ia=fa;ja=da;break}}}else{ha=$;ia=A;ja=aa}if((ha+ia|0)>0){ca=ja;ba=0;while(1){h[w>>3]=+xYa(ba+9|0);if((ca|0)==0){ka=0}else{ka=(uc(O|0,8,1,T|0)|0)==1|0}fa=ba+1|0;if((fa|0)<((c[Q>>2]|0)+(c[P>>2]|0)|0)){ca=ka;ba=fa}else{la=ka;break}}}else{la=ja}FYa(7);if((la|0)!=0){_=T;break}c[p>>2]=be(c[(Qc()|0)>>2]|0)|0;mXa(23,0,240,p);ad(T|0)|0;_=0}}while(0);if((c[296980>>2]|0)==0){ma=47}else{ba=c[B>>2]|0;if((ba|0)==0){ma=47}else{na=ba}}if((ma|0)==47){ma=0;ne[c[281604>>2]&255](281584,b);na=c[B>>2]|0}do{if((na|0)==1){if((c[I>>2]|0)!=3){break}ba=c[L>>2]|0;ca=c[ba+8>>2]|0;A=c[ba+4>>2]|0;c[A>>2]=(c[A>>2]|0)+(c[ca>>2]|0);ba=A+4|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+4>>2]|0);ba=A+8|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+8>>2]|0);ba=A+12|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+12>>2]|0);ba=A+16|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+16>>2]|0)}}while(0);if((c[71796]|0)!=0){ca=f;ba=287192;c[ca+0>>2]=c[ba+0>>2];c[ca+4>>2]=c[ba+4>>2];c[ca+8>>2]=c[ba+8>>2];c[ca+12>>2]=c[ba+12>>2];c[ca+16>>2]=c[ba+16>>2];c[ca+20>>2]=c[ba+20>>2];cXa(M,f);Zd(10,M|0)|0;ba=c[71804]|0;ca=o;h[k>>3]=+h[c[c[u>>2]>>2]>>3];c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];c[o+8>>2]=ba;kXa(1,0,320,o);h[F>>3]=+h[z>>3]}if((Z|0)!=0){ma=57;break}if((a$a(b,0)|0)!=0){ma=58;break}if((S_a(b,0)|0)!=0){ma=58;break}if((H_a(b,0)|0)==0){S=W;T=_}else{ma=58;break}}do{if((ma|0)==57){T=n;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];kXa(1,0,376,n);U=_;V=Z+ -1|0}else if((ma|0)==58){if((a$a(b,0)|0)!=0){T=m;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];kXa(1,0,448,m);U=_;V=-2;break}if((S_a(b,0)|0)!=0){T=l;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];kXa(1,0,536,l);U=_;V=-3;break}T=(H_a(b,0)|0)==0;Y=+h[z>>3];if(T){T=g;h[k>>3]=Y;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];kXa(1,0,712,g);U=_;V=-1;break}else{T=j;h[k>>3]=Y;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];kXa(1,0,624,j);U=_;V=-3;break}}}while(0);if((U|0)==0){i=e;return V|0}ad(U|0)|0;i=e;return V|0}function gf(a){a=a|0;i=i;return 0}function hf(a){a=a|0;i=i;return 0}function jf(a){a=a|0;i=i;return 0}function kf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7016>>3]=+h[b+632>>3]*1.0e-5;i=i;return}function lf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7008>>3]=+h[b+624>>3]+-273.15;i=i;return}function mf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6984>>3]=+h[b+616>>3]*1.0e-5;i=i;return}function nf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6976>>3]=+h[b+608>>3]+-273.15;i=i;return}function of(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6952>>3]=+h[b+600>>3]*1.0e-5;i=i;return}function pf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6944>>3]=+h[b+592>>3]+-273.15;i=i;return}function qf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6920>>3]=+h[b+584>>3]*1.0e-5;i=i;return}function rf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6912>>3]=+h[b+576>>3]+-273.15;i=i;return}function sf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6888>>3]=+h[b+568>>3]*1.0e-5;i=i;return}function tf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6880>>3]=+h[b+560>>3]+-273.15;i=i;return}function uf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6856>>3]=+h[b+552>>3]*1.0e-5;i=i;return}function vf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6848>>3]=+h[b+544>>3]+-273.15;i=i;return}function wf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6824>>3]=+h[b+536>>3]*1.0e-5;i=i;return}function xf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6816>>3]=+h[b+528>>3]+-273.15;i=i;return}function yf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6792>>3]=+h[b+520>>3]*1.0e-5;i=i;return}function zf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6784>>3]=+h[b+512>>3]+-273.15;i=i;return}function Af(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6760>>3]=+h[b+504>>3]*1.0e-5;i=i;return}function Bf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6752>>3]=+h[b+496>>3]+-273.15;i=i;return}function Cf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6728>>3]=+h[b+488>>3]*1.0e-5;i=i;return}function Df(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6720>>3]=+h[b+480>>3]+-273.15;i=i;return}function Ef(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6696>>3]=+h[b+472>>3]*1.0e-5;i=i;return}function Ff(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6688>>3]=+h[b+464>>3]+-273.15;i=i;return}function Gf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6664>>3]=+h[b+456>>3]*1.0e-5;i=i;return}function Hf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6656>>3]=+h[b+448>>3]+-273.15;i=i;return}function If(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6632>>3]=+h[b+440>>3]*1.0e-5;i=i;return}function Jf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6624>>3]=+h[b+432>>3]+-273.15;i=i;return}function Kf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6600>>3]=+h[b+424>>3]*1.0e-5;i=i;return}function Lf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6592>>3]=+h[b+416>>3]+-273.15;i=i;return}function Mf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6568>>3]=+h[b+408>>3]*1.0e-5;i=i;return}function Nf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6560>>3]=+h[b+400>>3]+-273.15;i=i;return}function Of(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6536>>3]=+h[b+392>>3]*1.0e-5;i=i;return}function Pf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6528>>3]=+h[b+384>>3]+-273.15;i=i;return}function Qf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6504>>3]=+h[b+376>>3]*1.0e-5;i=i;return}function Rf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6496>>3]=+h[b+368>>3]+-273.15;i=i;return}function Sf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6472>>3]=+h[b+360>>3]*1.0e-5;i=i;return}function Tf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6464>>3]=+h[b+352>>3]+-273.15;i=i;return}function Uf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6440>>3]=+h[b+344>>3]*1.0e-5;i=i;return}function Vf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6432>>3]=+h[b+336>>3]+-273.15;i=i;return}function Wf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6408>>3]=+h[b+328>>3]*1.0e-5;i=i;return}function Xf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6400>>3]=+h[b+320>>3]+-273.15;i=i;return}function Yf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2376>>3]=+h[b+312>>3]*1.0e-5;i=i;return}function Zf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2368>>3]=+h[b+304>>3]+-273.15;i=i;return}function _f(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2344>>3]=+h[b+296>>3]*1.0e-5;i=i;return}function $f(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2336>>3]=+h[b+288>>3]+-273.15;i=i;return}function ag(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2312>>3]=+h[b+280>>3]*1.0e-5;i=i;return}function bg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2304>>3]=+h[b+272>>3]+-273.15;i=i;return}function cg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2280>>3]=+h[b+264>>3]*1.0e-5;i=i;return}function dg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2272>>3]=+h[b+256>>3]+-273.15;i=i;return}function eg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2248>>3]=+h[b+248>>3]*1.0e-5;i=i;return}function fg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2240>>3]=+h[b+240>>3]+-273.15;i=i;return}function gg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2216>>3]=+h[b+232>>3]*1.0e-5;i=i;return}function hg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2208>>3]=+h[b+224>>3]+-273.15;i=i;return}function ig(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2184>>3]=+h[b+216>>3]*1.0e-5;i=i;return}function jg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2176>>3]=+h[b+208>>3]+-273.15;i=i;return}function kg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2152>>3]=+h[b+200>>3]*1.0e-5;i=i;return}function lg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2144>>3]=+h[b+192>>3]+-273.15;i=i;return}function mg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2120>>3]=+h[b+184>>3]*1.0e-5;i=i;return}function ng(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2112>>3]=+h[b+176>>3]+-273.15;i=i;return}function og(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2088>>3]=+h[b+168>>3]*1.0e-5;i=i;return}function pg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2080>>3]=+h[b+160>>3]+-273.15;i=i;return}function qg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2056>>3]=+h[b+152>>3]*1.0e-5;i=i;return}function rg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2048>>3]=+h[b+144>>3]+-273.15;i=i;return}function sg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2024>>3]=+h[b+136>>3]*1.0e-5;i=i;return}function tg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2016>>3]=+h[b+128>>3]+-273.15;i=i;return}function ug(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1992>>3]=+h[b+120>>3]*1.0e-5;i=i;return}function vg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1984>>3]=+h[b+112>>3]+-273.15;i=i;return}function wg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1960>>3]=+h[b+104>>3]*1.0e-5;i=i;return}function xg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1952>>3]=+h[b+96>>3]+-273.15;i=i;return}function yg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1928>>3]=+h[b+88>>3]*1.0e-5;i=i;return}function zg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1920>>3]=+h[b+80>>3]+-273.15;i=i;return}function Ag(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1896>>3]=+h[b+72>>3]*1.0e-5;i=i;return}function Bg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1888>>3]=+h[b+64>>3]+-273.15;i=i;return}function Cg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1864>>3]=+h[b+56>>3]*1.0e-5;i=i;return}function Dg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1856>>3]=+h[b+48>>3]+-273.15;i=i;return}function Eg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1832>>3]=+h[b+40>>3]*1.0e-5;i=i;return}function Fg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1824>>3]=+h[b+32>>3]+-273.15;i=i;return}function Gg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1800>>3]=+h[b+24>>3]*1.0e-5;i=i;return}function Hg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1792>>3]=+h[b+16>>3]+-273.15;i=i;return}function Ig(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1768>>3]=+h[b+8>>3]*1.0e-5;i=i;return}function Jg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1760>>3]=+h[b>>3]+-273.15;i=i;return}function Kg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14512>>3]=+h[b+8>>3]*1.0e-5;i=i;return}function Lg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14472>>3]=+h[b+632>>3]*1.0e-5;i=i;return}function Mg(a){a=a|0;var b=0,d=0,e=0;b=i;R_a(a,0)|0;d=c[(c[a+476>>2]|0)+28>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+3848>>3]=+h[d>>3];h[e+9280>>3]=+h[d+8>>3];i=b;return}function Ng(a){a=a|0;var b=0,d=0,e=0;b=i;R_a(a,1)|0;d=c[(c[a+476>>2]|0)+92>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+3840>>3]=+h[d>>3];h[e+9288>>3]=+h[d+8>>3];i=b;return}function Og(a){a=a|0;var b=0,d=0,e=0;b=i;R_a(a,2)|0;d=c[(c[a+476>>2]|0)+156>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+9296>>3]=+h[d>>3];h[e+3832>>3]=+h[d+8>>3];i=b;return}function Pg(a){a=a|0;var b=0,d=0,e=0;b=i;R_a(a,3)|0;d=c[(c[a+476>>2]|0)+220>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+3824>>3]=+h[d>>3];h[e+9304>>3]=+h[d+8>>3];i=b;return}function Qg(a){a=a|0;var b=0,d=0,e=0;b=i;R_a(a,4)|0;d=c[(c[a+476>>2]|0)+284>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+3816>>3]=+h[d>>3];h[e+9312>>3]=+h[d+8>>3];i=b;return}function Rg(a){a=a|0;var b=0,d=0,e=0;b=i;R_a(a,5)|0;d=c[(c[a+476>>2]|0)+348>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+9320>>3]=+h[d>>3];h[e+3808>>3]=+h[d+8>>3];i=b;return}function Sg(a){a=a|0;var b=0,d=0,e=0;b=i;R_a(a,6)|0;d=c[(c[a+476>>2]|0)+412>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+3800>>3]=+h[d>>3];h[e+9328>>3]=+h[d+8>>3];i=b;return}function Tg(a){a=a|0;var b=0,d=0,e=0;b=i;R_a(a,7)|0;d=c[(c[a+476>>2]|0)+476>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+3792>>3]=+h[d>>3];h[e+9336>>3]=+h[d+8>>3];i=b;return}function Ug(a){a=a|0;var b=0,d=0,e=0;b=i;R_a(a,8)|0;d=c[(c[a+476>>2]|0)+540>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+3784>>3]=+h[d>>3];h[e+9344>>3]=+h[d+8>>3];i=b;return}function Vg(a){a=a|0;var b=0,d=0,e=0;b=i;R_a(a,9)|0;d=c[(c[a+476>>2]|0)+604>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+3776>>3]=+h[d>>3];h[e+9352>>3]=+h[d+8>>3];i=b;return}function Wg(a){a=a|0;var b=0,d=0,e=0;b=i;R_a(a,10)|0;d=c[(c[a+476>>2]|0)+668>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+3768>>3]=+h[d>>3];h[e+9360>>3]=+h[d+8>>3];i=b;return}function Xg(a){a=a|0;var b=0,d=0,e=0;b=i;R_a(a,11)|0;d=c[(c[a+476>>2]|0)+732>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+3760>>3]=+h[d>>3];h[e+9368>>3]=+h[d+8>>3];i=b;return}function Yg(a){a=a|0;var b=0,d=0,e=0;b=i;R_a(a,12)|0;d=c[(c[a+476>>2]|0)+796>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+3752>>3]=+h[d>>3];h[e+9376>>3]=+h[d+8>>3];i=b;return}function Zg(a){a=a|0;var b=0,d=0,e=0;b=i;R_a(a,13)|0;d=c[(c[a+476>>2]|0)+860>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+3744>>3]=+h[d>>3];h[e+9384>>3]=+h[d+8>>3];i=b;return}function _g(a){a=a|0;var b=0,d=0,e=0;b=i;R_a(a,14)|0;d=c[(c[a+476>>2]|0)+924>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+9392>>3]=+h[d>>3];h[e+3736>>3]=+h[d+8>>3];i=b;return}function $g(a){a=a|0;var b=0,d=0,e=0;b=i;R_a(a,15)|0;d=c[(c[a+476>>2]|0)+988>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+3728>>3]=+h[d>>3];h[e+9400>>3]=+h[d+8>>3];i=b;return}function ah(a){a=a|0;var b=0,d=0,e=0;b=i;R_a(a,16)|0;d=c[(c[a+476>>2]|0)+1052>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+3720>>3]=+h[d>>3];h[e+9408>>3]=+h[d+8>>3];i=b;return}function bh(a){a=a|0;var b=0,d=0,e=0;b=i;R_a(a,17)|0;d=c[(c[a+476>>2]|0)+1116>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+3712>>3]=+h[d>>3];h[e+9416>>3]=+h[d+8>>3];i=b;return}function ch(a){a=a|0;var b=0,d=0,e=0;b=i;R_a(a,18)|0;d=c[(c[a+476>>2]|0)+1180>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+3704>>3]=+h[d>>3];h[e+9424>>3]=+h[d+8>>3];i=b;return}function dh(a){a=a|0;var b=0,d=0,e=0;b=i;R_a(a,19)|0;d=c[(c[a+476>>2]|0)+1244>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+9432>>3]=+h[d>>3];h[e+3696>>3]=+h[d+8>>3];i=b;return}function eh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14616>>3]=+h[b+3696>>3]+(+h[b+3704>>3]+(+h[b+3712>>3]+(+h[b+3720>>3]+(+h[b+3728>>3]+(+h[b+3736>>3]+(+h[b+3744>>3]+(+h[b+3752>>3]+(+h[b+3760>>3]+(+h[b+3768>>3]+(+h[b+3776>>3]+(+h[b+3784>>3]+(+h[b+3792>>3]+(+h[b+3800>>3]+(+h[b+3808>>3]+(+h[b+3816>>3]+(+h[b+3824>>3]+(+h[b+3832>>3]+(+h[b+3840>>3]+ +h[b+3848>>3]))))))))))))))))));i=i;return}function fh(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7200>>3]=(+h[b+504>>3]+ +h[b+512>>3])*(+h[d+616>>3]- +h[d+632>>3])*+h[b+2840>>3]*.5;i=i;return}function gh(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2840>>3]*(+h[e+504>>3]+ +h[e+512>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7200>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+7040|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+7040|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,880,872,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+7040|0;q=p;h[q>>3]=n;i=d;return}function hh(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7208>>3]=(+h[b+512>>3]+ +h[b+520>>3])*(+h[d+600>>3]- +h[d+616>>3])*+h[b+2840>>3]*.5;i=i;return}function ih(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2840>>3]*(+h[e+512>>3]+ +h[e+520>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7208>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+7048|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+7048|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,976,968,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+7048|0;q=p;h[q>>3]=n;i=d;return}function jh(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7216>>3]=(+h[b+520>>3]+ +h[b+528>>3])*(+h[d+584>>3]- +h[d+600>>3])*+h[b+2840>>3]*.5;i=i;return}function kh(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2840>>3]*(+h[e+520>>3]+ +h[e+528>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7216>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+7056|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+7056|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,1072,1064,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+7056|0;q=p;h[q>>3]=n;i=d;return}function lh(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7224>>3]=(+h[b+528>>3]+ +h[b+536>>3])*(+h[d+568>>3]- +h[d+584>>3])*+h[b+2840>>3]*.5;i=i;return}function mh(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2840>>3]*(+h[e+528>>3]+ +h[e+536>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7224>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+7064|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+7064|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,1168,1160,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+7064|0;q=p;h[q>>3]=n;i=d;return}function nh(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7232>>3]=(+h[b+536>>3]+ +h[b+544>>3])*(+h[d+552>>3]- +h[d+568>>3])*+h[b+2840>>3]*.5;i=i;return}function oh(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2840>>3]*(+h[e+536>>3]+ +h[e+544>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7232>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+7072|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+7072|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,1264,1256,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+7072|0;q=p;h[q>>3]=n;i=d;return}function ph(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7240>>3]=(+h[b+544>>3]+ +h[b+552>>3])*(+h[d+536>>3]- +h[d+552>>3])*+h[b+2840>>3]*.5;i=i;return}function qh(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2840>>3]*(+h[e+544>>3]+ +h[e+552>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7240>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+7080|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+7080|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,1360,1352,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+7080|0;q=p;h[q>>3]=n;i=d;return}function rh(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7248>>3]=(+h[b+552>>3]+ +h[b+560>>3])*(+h[d+520>>3]- +h[d+536>>3])*+h[b+2840>>3]*.5;i=i;return}function sh(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2840>>3]*(+h[e+552>>3]+ +h[e+560>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7248>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+7088|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+7088|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,1456,1448,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+7088|0;q=p;h[q>>3]=n;i=d;return}function th(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7256>>3]=(+h[b+560>>3]+ +h[b+568>>3])*(+h[d+504>>3]- +h[d+520>>3])*+h[b+2840>>3]*.5;i=i;return}function uh(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2840>>3]*(+h[e+560>>3]+ +h[e+568>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7256>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+7096|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+7096|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,1552,1544,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+7096|0;q=p;h[q>>3]=n;i=d;return}function vh(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7264>>3]=(+h[b+568>>3]+ +h[b+576>>3])*(+h[d+488>>3]- +h[d+504>>3])*+h[b+2840>>3]*.5;i=i;return}function wh(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2840>>3]*(+h[e+568>>3]+ +h[e+576>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7264>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+7104|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+7104|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,1648,1640,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+7104|0;q=p;h[q>>3]=n;i=d;return}function xh(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7272>>3]=(+h[b+576>>3]+ +h[b+584>>3])*(+h[d+472>>3]- +h[d+488>>3])*+h[b+2840>>3]*.5;i=i;return}function yh(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2840>>3]*(+h[e+576>>3]+ +h[e+584>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7272>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+7112|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+7112|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,1744,1736,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+7112|0;q=p;h[q>>3]=n;i=d;return}function zh(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7280>>3]=(+h[b+584>>3]+ +h[b+592>>3])*(+h[d+456>>3]- +h[d+472>>3])*+h[b+2840>>3]*.5;i=i;return}function Ah(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2840>>3]*(+h[e+584>>3]+ +h[e+592>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7280>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+7120|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+7120|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,1848,1840,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+7120|0;q=p;h[q>>3]=n;i=d;return}function Bh(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7288>>3]=(+h[b+592>>3]+ +h[b+600>>3])*(+h[d+440>>3]- +h[d+456>>3])*+h[b+2840>>3]*.5;i=i;return}function Ch(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2840>>3]*(+h[e+592>>3]+ +h[e+600>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7288>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+7128|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+7128|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,1952,1944,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+7128|0;q=p;h[q>>3]=n;i=d;return}function Dh(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7296>>3]=(+h[b+600>>3]+ +h[b+608>>3])*(+h[d+424>>3]- +h[d+440>>3])*+h[b+2840>>3]*.5;i=i;return}function Eh(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2840>>3]*(+h[e+600>>3]+ +h[e+608>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7296>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+7136|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+7136|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,2056,2048,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+7136|0;q=p;h[q>>3]=n;i=d;return}function Fh(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7304>>3]=(+h[b+608>>3]+ +h[b+616>>3])*(+h[d+408>>3]- +h[d+424>>3])*+h[b+2840>>3]*.5;i=i;return}function Gh(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2840>>3]*(+h[e+608>>3]+ +h[e+616>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7304>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+7144|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+7144|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,2160,2152,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+7144|0;q=p;h[q>>3]=n;i=d;return}function Hh(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7312>>3]=(+h[b+616>>3]+ +h[b+624>>3])*(+h[d+392>>3]- +h[d+408>>3])*+h[b+2840>>3]*.5;i=i;return}function Ih(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2840>>3]*(+h[e+616>>3]+ +h[e+624>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7312>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+7152|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+7152|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,2264,2256,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+7152|0;q=p;h[q>>3]=n;i=d;return}function Jh(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7320>>3]=(+h[b+624>>3]+ +h[b+632>>3])*(+h[d+376>>3]- +h[d+392>>3])*+h[b+2840>>3]*.5;i=i;return}function Kh(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2840>>3]*(+h[e+624>>3]+ +h[e+632>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7320>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+7160|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+7160|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,2368,2360,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+7160|0;q=p;h[q>>3]=n;i=d;return}function Lh(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7328>>3]=(+h[b+632>>3]+ +h[b+640>>3])*(+h[d+360>>3]- +h[d+376>>3])*+h[b+2840>>3]*.5;i=i;return}function Mh(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2840>>3]*(+h[e+632>>3]+ +h[e+640>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7328>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+7168|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+7168|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,2472,2464,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+7168|0;q=p;h[q>>3]=n;i=d;return}function Nh(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7336>>3]=(+h[b+640>>3]+ +h[b+648>>3])*(+h[d+344>>3]- +h[d+360>>3])*+h[b+2840>>3]*.5;i=i;return}function Oh(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2840>>3]*(+h[e+640>>3]+ +h[e+648>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7336>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+7176|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+7176|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,2576,2568,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+7176|0;q=p;h[q>>3]=n;i=d;return}function Ph(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7344>>3]=(+h[b+648>>3]+ +h[b+656>>3])*(+h[d+328>>3]- +h[d+344>>3])*+h[b+2840>>3]*.5;i=i;return}function Qh(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2840>>3]*(+h[e+648>>3]+ +h[e+656>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7344>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+7184|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+7184|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,2680,2672,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+7184|0;q=p;h[q>>3]=n;i=d;return}function Rh(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+7352>>3]=+h[b+656>>3]*(1.0e5- +h[d+328>>3])*+h[b+2840>>3];i=i;return}function Sh(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=c[b+416>>2]|0;f=+h[e+656>>3]*+h[e+2840>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7352>>3];l=-k;if(f!=0.0){m=j;n=l/f;o=m;p=o+7192|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+7192|0;q=p;h[q>>3]=n;i=d;return}k=l/+qXa(c[b+536>>2]|0,f,2784,2776,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+7192|0;q=p;h[q>>3]=n;i=d;return}function Th(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+632>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+7024>>3]=+h[d>>3];i=b;return}function Uh(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+616>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6992>>3]=+h[d>>3];i=b;return}function Vh(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+600>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6960>>3]=+h[d>>3];i=b;return}function Wh(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+584>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6928>>3]=+h[d>>3];i=b;return}function Xh(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+568>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6896>>3]=+h[d>>3];i=b;return}function Yh(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+552>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6864>>3]=+h[d>>3];i=b;return}function Zh(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+536>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6832>>3]=+h[d>>3];i=b;return}function _h(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+520>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6800>>3]=+h[d>>3];i=b;return}function $h(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+504>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6768>>3]=+h[d>>3];i=b;return}function ai(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+488>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6736>>3]=+h[d>>3];i=b;return}function bi(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+472>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6704>>3]=+h[d>>3];i=b;return}function ci(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+456>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6672>>3]=+h[d>>3];i=b;return}function di(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+440>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6640>>3]=+h[d>>3];i=b;return}function ei(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+424>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6608>>3]=+h[d>>3];i=b;return}function fi(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+408>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6576>>3]=+h[d>>3];i=b;return}function gi(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+392>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6544>>3]=+h[d>>3];i=b;return}function hi(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+376>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6512>>3]=+h[d>>3];i=b;return}function ii(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+360>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6480>>3]=+h[d>>3];i=b;return}function ji(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+344>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6448>>3]=+h[d>>3];i=b;return}function ki(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+328>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6416>>3]=+h[d>>3];i=b;return}function li(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2560>>3]=+h[b+1632>>3]*(+h[d+312>>3]+-1.0e5)*+h[b+3072>>3];i=i;return}function mi(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=c[b+416>>2]|0;f=+h[e+1632>>3]*+h[e+3072>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2560>>3];l=-k;if(f!=0.0){m=j;n=l/f;o=m;p=o+2400|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+2400|0;q=p;h[q>>3]=n;i=d;return}k=l/+qXa(c[b+536>>2]|0,f,2856,2848,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+2400|0;q=p;h[q>>3]=n;i=d;return}function ni(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2568>>3]=(+h[b+1632>>3]+ +h[b+1640>>3])*(+h[d+296>>3]- +h[d+312>>3])*+h[b+3072>>3]*.5;i=i;return}function oi(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3072>>3]*(+h[e+1632>>3]+ +h[e+1640>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2568>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+2408|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+2408|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,2928,2920,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+2408|0;q=p;h[q>>3]=n;i=d;return}function pi(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2576>>3]=(+h[b+1640>>3]+ +h[b+1648>>3])*(+h[d+280>>3]- +h[d+296>>3])*+h[b+3072>>3]*.5;i=i;return}function qi(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3072>>3]*(+h[e+1640>>3]+ +h[e+1648>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2576>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+2416|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+2416|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,3024,3016,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+2416|0;q=p;h[q>>3]=n;i=d;return}function ri(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2584>>3]=(+h[b+1648>>3]+ +h[b+1656>>3])*(+h[d+264>>3]- +h[d+280>>3])*+h[b+3072>>3]*.5;i=i;return}function si(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3072>>3]*(+h[e+1648>>3]+ +h[e+1656>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2584>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+2424|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+2424|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,3120,3112,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+2424|0;q=p;h[q>>3]=n;i=d;return}function ti(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2592>>3]=(+h[b+1656>>3]+ +h[b+1664>>3])*(+h[d+248>>3]- +h[d+264>>3])*+h[b+3072>>3]*.5;i=i;return}function ui(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3072>>3]*(+h[e+1656>>3]+ +h[e+1664>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2592>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+2432|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+2432|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,3216,3208,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+2432|0;q=p;h[q>>3]=n;i=d;return}function vi(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2600>>3]=(+h[b+1664>>3]+ +h[b+1672>>3])*(+h[d+232>>3]- +h[d+248>>3])*+h[b+3072>>3]*.5;i=i;return}function wi(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3072>>3]*(+h[e+1664>>3]+ +h[e+1672>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2600>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+2440|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+2440|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,3312,3304,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+2440|0;q=p;h[q>>3]=n;i=d;return}function xi(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2608>>3]=(+h[b+1672>>3]+ +h[b+1680>>3])*(+h[d+216>>3]- +h[d+232>>3])*+h[b+3072>>3]*.5;i=i;return}function yi(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3072>>3]*(+h[e+1672>>3]+ +h[e+1680>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2608>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+2448|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+2448|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,3408,3400,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+2448|0;q=p;h[q>>3]=n;i=d;return}function zi(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2616>>3]=(+h[b+1680>>3]+ +h[b+1688>>3])*(+h[d+200>>3]- +h[d+216>>3])*+h[b+3072>>3]*.5;i=i;return}function Ai(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3072>>3]*(+h[e+1680>>3]+ +h[e+1688>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2616>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+2456|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+2456|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,3504,3496,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+2456|0;q=p;h[q>>3]=n;i=d;return}function Bi(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2624>>3]=(+h[b+1688>>3]+ +h[b+1696>>3])*(+h[d+184>>3]- +h[d+200>>3])*+h[b+3072>>3]*.5;i=i;return}function Ci(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3072>>3]*(+h[e+1688>>3]+ +h[e+1696>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2624>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+2464|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+2464|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,3600,3592,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+2464|0;q=p;h[q>>3]=n;i=d;return}function Di(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2632>>3]=(+h[b+1696>>3]+ +h[b+1704>>3])*(+h[d+168>>3]- +h[d+184>>3])*+h[b+3072>>3]*.5;i=i;return}function Ei(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3072>>3]*(+h[e+1696>>3]+ +h[e+1704>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2632>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+2472|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+2472|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,3696,3688,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+2472|0;q=p;h[q>>3]=n;i=d;return}function Fi(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2640>>3]=(+h[b+1704>>3]+ +h[b+1712>>3])*(+h[d+152>>3]- +h[d+168>>3])*+h[b+3072>>3]*.5;i=i;return}function Gi(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3072>>3]*(+h[e+1704>>3]+ +h[e+1712>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2640>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+2480|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+2480|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,3792,3784,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+2480|0;q=p;h[q>>3]=n;i=d;return}function Hi(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2648>>3]=(+h[b+1712>>3]+ +h[b+1720>>3])*(+h[d+136>>3]- +h[d+152>>3])*+h[b+3072>>3]*.5;i=i;return}function Ii(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3072>>3]*(+h[e+1712>>3]+ +h[e+1720>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2648>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+2488|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+2488|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,3896,3888,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+2488|0;q=p;h[q>>3]=n;i=d;return}function Ji(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2656>>3]=(+h[b+1720>>3]+ +h[b+1728>>3])*(+h[d+120>>3]- +h[d+136>>3])*+h[b+3072>>3]*.5;i=i;return}function Ki(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3072>>3]*(+h[e+1720>>3]+ +h[e+1728>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2656>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+2496|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+2496|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,4e3,3992,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+2496|0;q=p;h[q>>3]=n;i=d;return}function Li(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2664>>3]=(+h[b+1728>>3]+ +h[b+1736>>3])*(+h[d+104>>3]- +h[d+120>>3])*+h[b+3072>>3]*.5;i=i;return}function Mi(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3072>>3]*(+h[e+1728>>3]+ +h[e+1736>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2664>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+2504|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+2504|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,4104,4096,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+2504|0;q=p;h[q>>3]=n;i=d;return}function Ni(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2672>>3]=(+h[b+1736>>3]+ +h[b+1744>>3])*(+h[d+88>>3]- +h[d+104>>3])*+h[b+3072>>3]*.5;i=i;return}function Oi(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3072>>3]*(+h[e+1736>>3]+ +h[e+1744>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2672>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+2512|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+2512|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,4208,4200,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+2512|0;q=p;h[q>>3]=n;i=d;return}function Pi(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2680>>3]=(+h[b+1744>>3]+ +h[b+1752>>3])*(+h[d+72>>3]- +h[d+88>>3])*+h[b+3072>>3]*.5;i=i;return}function Qi(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3072>>3]*(+h[e+1744>>3]+ +h[e+1752>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2680>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+2520|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+2520|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,4312,4304,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+2520|0;q=p;h[q>>3]=n;i=d;return}function Ri(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2688>>3]=(+h[b+1752>>3]+ +h[b+1760>>3])*(+h[d+56>>3]- +h[d+72>>3])*+h[b+3072>>3]*.5;i=i;return}function Si(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3072>>3]*(+h[e+1752>>3]+ +h[e+1760>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2688>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+2528|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+2528|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,4416,4408,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+2528|0;q=p;h[q>>3]=n;i=d;return}function Ti(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2696>>3]=(+h[b+1760>>3]+ +h[b+1768>>3])*(+h[d+40>>3]- +h[d+56>>3])*+h[b+3072>>3]*.5;i=i;return}function Ui(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3072>>3]*(+h[e+1760>>3]+ +h[e+1768>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2696>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+2536|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+2536|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,4520,4512,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+2536|0;q=p;h[q>>3]=n;i=d;return}function Vi(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2704>>3]=(+h[b+1768>>3]+ +h[b+1776>>3])*(+h[d+24>>3]- +h[d+40>>3])*+h[b+3072>>3]*.5;i=i;return}function Wi(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3072>>3]*(+h[e+1768>>3]+ +h[e+1776>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2704>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+2544|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+2544|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,4624,4616,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+2544|0;q=p;h[q>>3]=n;i=d;return}function Xi(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2712>>3]=(+h[b+1776>>3]+ +h[b+1784>>3])*(+h[d+8>>3]- +h[d+24>>3])*+h[b+3072>>3]*.5;i=i;return}function Yi(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3072>>3]*(+h[e+1776>>3]+ +h[e+1784>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2712>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+2552|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+2552|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,4728,4720,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+2552|0;q=p;h[q>>3]=n;i=d;return}function Zi(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+312>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2384>>3]=+h[d>>3];i=b;return}function _i(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+296>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2352>>3]=+h[d>>3];i=b;return}function $i(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+280>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2320>>3]=+h[d>>3];i=b;return}function aj(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+264>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2288>>3]=+h[d>>3];i=b;return}function bj(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+248>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2256>>3]=+h[d>>3];i=b;return}function cj(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+232>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2224>>3]=+h[d>>3];i=b;return}function dj(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+216>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2192>>3]=+h[d>>3];i=b;return}function ej(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+200>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2160>>3]=+h[d>>3];i=b;return}function fj(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+184>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2128>>3]=+h[d>>3];i=b;return}function gj(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+168>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2096>>3]=+h[d>>3];i=b;return}function hj(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+152>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2064>>3]=+h[d>>3];i=b;return}function ij(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+136>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2032>>3]=+h[d>>3];i=b;return}function jj(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+120>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2e3>>3]=+h[d>>3];i=b;return}function kj(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+104>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1968>>3]=+h[d>>3];i=b;return}function lj(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+88>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1936>>3]=+h[d>>3];i=b;return}function mj(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+72>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1904>>3]=+h[d>>3];i=b;return}function nj(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+56>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1872>>3]=+h[d>>3];i=b;return}function oj(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+40>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1840>>3]=+h[d>>3];i=b;return}function pj(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+24>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1808>>3]=+h[d>>3];i=b;return}function qj(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+8>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1776>>3]=+h[d>>3];i=b;return}function rj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;XE(e,c[g>>2]|0,+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+8>>3],360.0,0);a=c[g>>2]|0;k=+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+8>>3];g=d+0|0;l=e+0|0;e=g+120|0;do{c[g>>2]=c[l>>2];g=g+4|0;l=l+4|0}while((g|0)<(e|0));aF(f,a,k,360.0,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+14544>>3]=+h[f>>3];i=b;return}function sj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;iF(e,c[g>>2]|0,+h[a+8>>3],+h[a+14544>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+8>>3];l=+h[g+14544>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));gF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+14560>>3]=+h[f>>3];i=b;return}function tj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;iF(e,c[g>>2]|0,+h[a+8>>3],+h[a+14544>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+8>>3];l=+h[g+14544>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));_E(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+14552>>3]=+h[f>>3];i=b;return}function uj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;XE(e,c[g>>2]|0,+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+8>>3],360.0,0);a=c[g>>2]|0;k=+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+8>>3];g=d+0|0;l=e+0|0;e=g+120|0;do{c[g>>2]=c[l>>2];g=g+4|0;l=l+4|0}while((g|0)<(e|0));dF(f,a,k,360.0,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+14536>>3]=+h[f>>3];i=b;return}function vj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+14544>>3];k=+h[g+14536>>3];l=+h[g+8>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,4832,4824,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+14528>>3]=j-n;i=d;return}function wj(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+8>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+14520>>3]=+h[d>>3];i=b;return}function xj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;XE(e,c[g>>2]|0,+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+632>>3],300.0,0);a=c[g>>2]|0;k=+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+632>>3];g=d+0|0;l=e+0|0;e=g+120|0;do{c[g>>2]=c[l>>2];g=g+4|0;l=l+4|0}while((g|0)<(e|0));aF(f,a,k,300.0,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+14504>>3]=+h[f>>3];i=b;return}function yj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;iF(e,c[g>>2]|0,+h[a+632>>3],+h[a+14504>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+632>>3];l=+h[g+14504>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));gF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+14576>>3]=+h[f>>3];i=b;return}function zj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;iF(e,c[g>>2]|0,+h[a+632>>3],+h[a+14504>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+632>>3];l=+h[g+14504>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));_E(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+14568>>3]=+h[f>>3];i=b;return}function Aj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;XE(e,c[g>>2]|0,+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+632>>3],300.0,0);a=c[g>>2]|0;k=+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+632>>3];g=d+0|0;l=e+0|0;e=g+120|0;do{c[g>>2]=c[l>>2];g=g+4|0;l=l+4|0}while((g|0)<(e|0));dF(f,a,k,300.0,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+14496>>3]=+h[f>>3];i=b;return}function Bj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+14504>>3];k=+h[g+14496>>3];l=+h[g+632>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,4864,4856,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+14488>>3]=j-n;i=d;return}function Cj(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+632>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+14480>>3]=+h[d>>3];i=b;return}function Dj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[c[b+356>>2]|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[c[b+356>>2]|0]|0;k=A_a(+h[c[c[b+4>>2]>>2]>>3],+h[(c[b+416>>2]|0)+3288>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=k;f=j;break}else{j=A_a(+h[c[c[b+4>>2]>>2]>>3],+h[(c[b+416>>2]|0)+3288>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=j;f=j;break}}else{if(g){g=a[c[b+356>>2]|0]|0;j=B_a(+h[c[c[b+4>>2]>>2]>>3],+h[(c[b+416>>2]|0)+3288>>3])|0;a[c[b+352>>2]|0]=j;f=g;break}else{g=B_a(+h[c[c[b+4>>2]>>2]>>3],+h[(c[b+416>>2]|0)+3288>>3])|0;a[c[b+352>>2]|0]=g;f=g;break}}}}while(0);if(!(f<<24>>24==0)){l=b+416|0;m=0.0;n=c[l>>2]|0;o=n;p=o+3280|0;q=p;r=+h[q>>3];s=m+r;t=b;u=t+4|0;v=u;w=c[v>>2]|0;x=c[w>>2]|0;y=x;z=y+8|0;A=z;B=c[A>>2]|0;C=B;D=C+14464|0;E=D;h[E>>3]=s;i=d;return}do{if((a[e]|0)==0){F=a[(c[b+356>>2]|0)+1|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){g=a[(c[b+356>>2]|0)+1|0]|0;j=c[b+416>>2]|0;k=A_a(+h[c[c[b+4>>2]>>2]>>3],+h[j+3288>>3]+ +h[j+3272>>3],a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=k;F=g;break}else{g=c[b+416>>2]|0;k=A_a(+h[c[c[b+4>>2]>>2]>>3],+h[g+3288>>3]+ +h[g+3272>>3],a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=k;F=k;break}}else{if(f){f=a[(c[b+356>>2]|0)+1|0]|0;k=c[b+416>>2]|0;g=B_a(+h[c[c[b+4>>2]>>2]>>3],+h[k+3288>>3]+ +h[k+3272>>3])|0;a[(c[b+352>>2]|0)+1|0]=g;F=f;break}else{f=c[b+416>>2]|0;g=B_a(+h[c[c[b+4>>2]>>2]>>3],+h[f+3288>>3]+ +h[f+3272>>3])|0;a[(c[b+352>>2]|0)+1|0]=g;F=g;break}}}}while(0);if(F<<24>>24==0){F=b+416|0;l=F;m=+h[(c[F>>2]|0)+3264>>3];n=c[l>>2]|0;o=n;p=o+3280|0;q=p;r=+h[q>>3];s=m+r;t=b;u=t+4|0;v=u;w=c[v>>2]|0;x=c[w>>2]|0;y=x;z=y+8|0;A=z;B=c[A>>2]|0;C=B;D=C+14464|0;E=D;h[E>>3]=s;i=d;return}G=+h[c[c[b+4>>2]>>2]>>3];F=b+416|0;e=c[F>>2]|0;H=G- +h[e+3288>>3];I=+h[e+3272>>3];J=+h[e+3264>>3];do{if(I!=0.0){K=J/I}else{if(J==0.0){K=J;break}K=J/+qXa(c[b+536>>2]|0,I,4896,4888,G,(a[b+319|0]|0)!=0|0)}}while(0);l=F;m=H*K;n=c[l>>2]|0;o=n;p=o+3280|0;q=p;r=+h[q>>3];s=m+r;t=b;u=t+4|0;v=u;w=c[v>>2]|0;x=c[w>>2]|0;y=x;z=y+8|0;A=z;B=c[A>>2]|0;C=B;D=C+14464|0;E=D;h[E>>3]=s;i=d;return}function Ej(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+8>>3],+h[a>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+8>>3];l=+h[g>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12552>>3]=+h[f>>3];i=b;return}function Fj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4328>>3]=+h[b+14136>>3]*+h[b+12552>>3];i=i;return}function Gj(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12552>>3],+h[f>>3],+h[f+8>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11176>>3]=+h[d>>3];i=b;return}function Hj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+8>>3],+h[a>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+8>>3];l=+h[g>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+14592>>3]=+h[f>>3];i=b;return}function Ij(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+14592>>3];k=+h[g+12552>>3];l=+h[g+8>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,4920,4912,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+1784>>3]=j-n;i=d;return}function Jj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4488>>3]=+h[b+4328>>3]*+h[b+1784>>3];i=i;return}function Kj(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+14464>>3];h[b+3368>>3]=-(d*+h[(!(d>=0.0)?b+14592|0:b+14544|0)>>3]);i=i;return}function Lj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+24>>3],+h[a+16>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+24>>3];l=+h[g+16>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12544>>3]=+h[f>>3];i=b;return}function Mj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4320>>3]=+h[b+14128>>3]*+h[b+12544>>3];i=i;return}function Nj(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12544>>3],+h[f+16>>3],+h[f+24>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11168>>3]=+h[d>>3];i=b;return}function Oj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;JD(d,c[a+536>>2]|0,+h[f+2552>>3],+h[f+12544>>3],+h[f+12552>>3],+h[f+11168>>3],+h[f+11176>>3],+h[j+1624>>3],+h[f+12880>>3],+h[f+12872>>3]*+h[j+3136>>3],(+h[j+2096>>3]+ +h[j+2104>>3])*.5,+h[j+3128>>3]*.05,+h[j+3096>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+3376>>3]=+h[d>>3]*+h[(c[g>>2]|0)+3072>>3];i=b;return}function Pj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2872>>3]=+h[b+3376>>3]*+h[(c[a+416>>2]|0)+1624>>3];i=i;return}function Qj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1784>>3]*+h[j+12552>>3]*+h[e+2968>>3];l=+h[j+3376>>3]- +h[j+14464>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1752|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1752|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,4960,4952,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1752|0;r=q;h[r>>3]=o;i=d;return}function Rj(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3688>>3]=+h[b+1752>>3]*+h[d+1784>>3]*+h[d+2968>>3]*(+h[b+8>>3]*.5+(+h[b+24>>3]*-.5+ +h[b+2552>>3]*.5));i=i;return}function Sj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4168>>3]=+h[b+3376>>3]+ +h[b+14464>>3];i=i;return}function Tj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+14136>>3];k=+h[g+4168>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+10840|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+10840|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,5056,5048,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+10840|0;p=o;h[p>>3]=m;i=d;return}function Uj(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3376>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3032>>3]=+h[(a?e+11176|0:e+11168|0)>>3];i=b;return}function Vj(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3376>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3192>>3]=+h[(a?e+12552|0:e+12544|0)>>3];i=b;return}function Wj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+24>>3],+h[a+16>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+24>>3];l=+h[g+16>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4496>>3]=+h[f>>3];i=b;return}function Xj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4496>>3];k=+h[g+12544>>3];l=+h[g+24>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,5096,5088,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+1816>>3]=j-n;i=d;return}function Yj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4480>>3]=+h[b+4320>>3]*+h[b+1816>>3];i=i;return}function Zj(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3376>>3];h[b+3360>>3]=d*+h[(!(d>=0.0)?b+14592|0:b+4496|0)>>3];i=i;return}function _j(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4008>>3]=+h[b+3360>>3]- +h[b+3368>>3];i=i;return}function $j(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10232>>3]=+h[b+4008>>3]+(+h[b+3688>>3]+ +h[b+3848>>3]);i=i;return}function ak(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4328>>3];k=+h[g+10232>>3]- +h[g+4168>>3]*+h[g+1784>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9912|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9912|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,5136,5128,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9912|0;p=o;h[p>>3]=m;i=d;return}function bk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+124>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+808>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+808|0;h[c[g+128>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+808>>3]);e=c[f>>2]|0;h[c[e+132>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+124>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+14648>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+14648|0;h[(c[e+128>>2]|0)+8>>3]=+h[g>>3];k=+b$a(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+14648>>3]);j=c[f>>2]|0;h[(c[j+132>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+124>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+800>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+800|0;h[(c[j+128>>2]|0)+16>>3]=+h[e>>3];k=+b$a(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+800>>3]);h[(c[(c[f>>2]|0)+132>>2]|0)+16>>3]=k;$_a(a,1)|0;a=c[(c[f>>2]|0)+124>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+808>>3]=+h[a>>3];h[f+14648>>3]=+h[a+8>>3];h[f+800>>3]=+h[a+16>>3];i=b;return}function ck(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+40>>3],+h[a+32>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+40>>3];l=+h[g+32>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12536>>3]=+h[f>>3];i=b;return}function dk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4312>>3]=+h[b+14120>>3]*+h[b+12536>>3];i=i;return}function ek(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12536>>3],+h[f+32>>3],+h[f+40>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11160>>3]=+h[d>>3];i=b;return}function fk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;JD(d,c[a+536>>2]|0,+h[f+2544>>3],+h[f+12536>>3],+h[f+12544>>3],+h[f+11160>>3],+h[f+11168>>3],+h[j+1616>>3],+h[f+12888>>3],+h[f+12864>>3]*+h[j+3136>>3],(+h[j+2088>>3]+ +h[j+2096>>3])*.5,+h[j+3128>>3]*.05,+h[j+3096>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+3384>>3]=+h[d>>3]*+h[(c[g>>2]|0)+3072>>3];i=b;return}function gk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2864>>3]=+h[b+3384>>3]*+h[(c[a+416>>2]|0)+1616>>3];i=i;return}function hk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1776>>3]*+h[j+12544>>3]*+h[e+2968>>3];l=+h[j+3384>>3]+ +h[j+3376>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1744|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1744|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,5168,5160,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1744|0;r=q;h[r>>3]=o;i=d;return}function ik(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3680>>3]=+h[b+1744>>3]*+h[d+1776>>3]*+h[d+2968>>3]*(+h[b+8>>3]*.5+(+h[b+40>>3]*-.5+(+h[b+2544>>3]+ +h[b+2552>>3])*.5));i=i;return}function jk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4160>>3]=+h[b+3384>>3]- +h[b+3376>>3];i=i;return}function kk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+14128>>3];k=+h[g+4160>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+10832|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+10832|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,5264,5256,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+10832|0;p=o;h[p>>3]=m;i=d;return}function lk(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3384>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3024>>3]=+h[(a?e+11168|0:e+11160|0)>>3];i=b;return}function mk(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3384>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3184>>3]=+h[(a?e+12544|0:e+12536|0)>>3];i=b;return}function nk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+40>>3],+h[a+32>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+40>>3];l=+h[g+32>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4504>>3]=+h[f>>3];i=b;return}function ok(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4504>>3];k=+h[g+12536>>3];l=+h[g+40>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,5304,5296,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+1848>>3]=j-n;i=d;return}function pk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4472>>3]=+h[b+4312>>3]*+h[b+1848>>3];i=i;return}function qk(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3384>>3];h[b+3352>>3]=d*+h[(!(d>=0.0)?b+4496|0:b+4504|0)>>3];i=i;return}function rk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4e3>>3]=+h[b+3352>>3]- +h[b+3360>>3];i=i;return}function sk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10224>>3]=+h[b+4e3>>3]+(+h[b+3680>>3]+ +h[b+3840>>3]);i=i;return}function tk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4320>>3];k=+h[g+10224>>3]- +h[g+4160>>3]*+h[g+1816>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9904|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9904|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,5344,5336,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9904|0;p=o;h[p>>3]=m;i=d;return}function uk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+204>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+824>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+824|0;h[c[g+208>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+824>>3]);e=c[f>>2]|0;h[c[e+212>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+204>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+10680>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+10680|0;h[(c[e+208>>2]|0)+8>>3]=+h[g>>3];k=+b$a(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+10680>>3]);j=c[f>>2]|0;h[(c[j+212>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+204>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+816>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+816|0;h[(c[j+208>>2]|0)+16>>3]=+h[e>>3];k=+b$a(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+816>>3]);h[(c[(c[f>>2]|0)+212>>2]|0)+16>>3]=k;$_a(a,2)|0;a=c[(c[f>>2]|0)+204>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+824>>3]=+h[a>>3];h[f+10680>>3]=+h[a+8>>3];h[f+816>>3]=+h[a+16>>3];i=b;return}function vk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+56>>3],+h[a+48>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+56>>3];l=+h[g+48>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12528>>3]=+h[f>>3];i=b;return}function wk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4304>>3]=+h[b+14112>>3]*+h[b+12528>>3];i=i;return}function xk(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12528>>3],+h[f+48>>3],+h[f+56>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11152>>3]=+h[d>>3];i=b;return}function yk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;JD(d,c[a+536>>2]|0,+h[f+2536>>3],+h[f+12528>>3],+h[f+12536>>3],+h[f+11152>>3],+h[f+11160>>3],+h[j+1608>>3],+h[f+12896>>3],+h[f+12856>>3]*+h[j+3136>>3],(+h[j+2080>>3]+ +h[j+2088>>3])*.5,+h[j+3128>>3]*.05,+h[j+3096>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+3392>>3]=+h[d>>3]*+h[(c[g>>2]|0)+3072>>3];i=b;return}function zk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2856>>3]=+h[b+3392>>3]*+h[(c[a+416>>2]|0)+1608>>3];i=i;return}function Ak(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1768>>3]*+h[j+12536>>3]*+h[e+2968>>3];l=+h[j+3392>>3]+ +h[j+3384>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1736|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1736|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,5376,5368,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1736|0;r=q;h[r>>3]=o;i=d;return}function Bk(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3672>>3]=+h[b+1736>>3]*+h[d+1768>>3]*+h[d+2968>>3]*(+h[b+24>>3]*.5+(+h[b+56>>3]*-.5+(+h[b+2536>>3]+ +h[b+2544>>3])*.5));i=i;return}function Ck(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4152>>3]=+h[b+3392>>3]- +h[b+3384>>3];i=i;return}function Dk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+14120>>3];k=+h[g+4152>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+10824|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+10824|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,5472,5464,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+10824|0;p=o;h[p>>3]=m;i=d;return}function Ek(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3392>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3016>>3]=+h[(a?e+11160|0:e+11152|0)>>3];i=b;return}function Fk(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3392>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3176>>3]=+h[(a?e+12536|0:e+12528|0)>>3];i=b;return}function Gk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+56>>3],+h[a+48>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+56>>3];l=+h[g+48>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4512>>3]=+h[f>>3];i=b;return}function Hk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4512>>3];k=+h[g+12528>>3];l=+h[g+56>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,5512,5504,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+1880>>3]=j-n;i=d;return}function Ik(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4464>>3]=+h[b+4304>>3]*+h[b+1880>>3];i=i;return}function Jk(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3392>>3];h[b+3344>>3]=d*+h[(!(d>=0.0)?b+4504|0:b+4512|0)>>3];i=i;return}function Kk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3992>>3]=+h[b+3344>>3]- +h[b+3352>>3];i=i;return}function Lk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10216>>3]=+h[b+3992>>3]+(+h[b+3672>>3]+ +h[b+3832>>3]);i=i;return}function Mk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4312>>3];k=+h[g+10216>>3]- +h[g+4152>>3]*+h[g+1848>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9896|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9896|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,5552,5544,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9896|0;p=o;h[p>>3]=m;i=d;return}function Nk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+284>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+840>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+840|0;h[c[g+288>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+840>>3]);e=c[f>>2]|0;h[c[e+292>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+284>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+10672>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+10672|0;h[(c[e+288>>2]|0)+8>>3]=+h[g>>3];k=+b$a(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+10672>>3]);j=c[f>>2]|0;h[(c[j+292>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+284>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+832>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+832|0;h[(c[j+288>>2]|0)+16>>3]=+h[e>>3];k=+b$a(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+832>>3]);h[(c[(c[f>>2]|0)+292>>2]|0)+16>>3]=k;$_a(a,3)|0;a=c[(c[f>>2]|0)+284>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+840>>3]=+h[a>>3];h[f+10672>>3]=+h[a+8>>3];h[f+832>>3]=+h[a+16>>3];i=b;return}function Ok(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+72>>3],+h[a+64>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+72>>3];l=+h[g+64>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12520>>3]=+h[f>>3];i=b;return}function Pk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4296>>3]=+h[b+14104>>3]*+h[b+12520>>3];i=i;return}function Qk(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12520>>3],+h[f+64>>3],+h[f+72>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11144>>3]=+h[d>>3];i=b;return}function Rk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;JD(d,c[a+536>>2]|0,+h[f+2528>>3],+h[f+12520>>3],+h[f+12528>>3],+h[f+11144>>3],+h[f+11152>>3],+h[j+1600>>3],+h[f+12904>>3],+h[f+12848>>3]*+h[j+3136>>3],(+h[j+2072>>3]+ +h[j+2080>>3])*.5,+h[j+3128>>3]*.05,+h[j+3096>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+3400>>3]=+h[d>>3]*+h[(c[g>>2]|0)+3072>>3];i=b;return}function Sk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2848>>3]=+h[b+3400>>3]*+h[(c[a+416>>2]|0)+1600>>3];i=i;return}function Tk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1760>>3]*+h[j+12528>>3]*+h[e+2968>>3];l=+h[j+3400>>3]+ +h[j+3392>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1728|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1728|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,5584,5576,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1728|0;r=q;h[r>>3]=o;i=d;return}function Uk(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3664>>3]=+h[b+1728>>3]*+h[d+1760>>3]*+h[d+2968>>3]*(+h[b+40>>3]*.5+(+h[b+72>>3]*-.5+(+h[b+2528>>3]+ +h[b+2536>>3])*.5));i=i;return}function Vk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4144>>3]=+h[b+3400>>3]- +h[b+3392>>3];i=i;return}function Wk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+14112>>3];k=+h[g+4144>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+10816|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+10816|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,5680,5672,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+10816|0;p=o;h[p>>3]=m;i=d;return}function Xk(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3400>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3008>>3]=+h[(a?e+11152|0:e+11144|0)>>3];i=b;return}function Yk(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3400>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3168>>3]=+h[(a?e+12528|0:e+12520|0)>>3];i=b;return}function Zk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+72>>3],+h[a+64>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+72>>3];l=+h[g+64>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4520>>3]=+h[f>>3];i=b;return}function _k(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4520>>3];k=+h[g+12520>>3];l=+h[g+72>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,5720,5712,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+1912>>3]=j-n;i=d;return}function $k(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4456>>3]=+h[b+4296>>3]*+h[b+1912>>3];i=i;return}function al(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3400>>3];h[b+3336>>3]=d*+h[(!(d>=0.0)?b+4512|0:b+4520|0)>>3];i=i;return}function bl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3984>>3]=+h[b+3336>>3]- +h[b+3344>>3];i=i;return}function cl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10208>>3]=+h[b+3984>>3]+(+h[b+3664>>3]+ +h[b+3824>>3]);i=i;return}function dl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4304>>3];k=+h[g+10208>>3]- +h[g+4144>>3]*+h[g+1880>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9888|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9888|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,5760,5752,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9888|0;p=o;h[p>>3]=m;i=d;return}function el(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+364>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+856>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+856|0;h[c[g+368>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+856>>3]);e=c[f>>2]|0;h[c[e+372>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+364>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+10664>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+10664|0;h[(c[e+368>>2]|0)+8>>3]=+h[g>>3];k=+b$a(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+10664>>3]);j=c[f>>2]|0;h[(c[j+372>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+364>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+848>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+848|0;h[(c[j+368>>2]|0)+16>>3]=+h[e>>3];k=+b$a(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+848>>3]);h[(c[(c[f>>2]|0)+372>>2]|0)+16>>3]=k;$_a(a,4)|0;a=c[(c[f>>2]|0)+364>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+856>>3]=+h[a>>3];h[f+10664>>3]=+h[a+8>>3];h[f+848>>3]=+h[a+16>>3];i=b;return}function fl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+88>>3],+h[a+80>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+88>>3];l=+h[g+80>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12512>>3]=+h[f>>3];i=b;return}function gl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4288>>3]=+h[b+14096>>3]*+h[b+12512>>3];i=i;return}function hl(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12512>>3],+h[f+80>>3],+h[f+88>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11136>>3]=+h[d>>3];i=b;return}function il(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;JD(d,c[a+536>>2]|0,+h[f+2520>>3],+h[f+12512>>3],+h[f+12520>>3],+h[f+11136>>3],+h[f+11144>>3],+h[j+1592>>3],+h[f+12912>>3],+h[f+12840>>3]*+h[j+3136>>3],(+h[j+2064>>3]+ +h[j+2072>>3])*.5,+h[j+3128>>3]*.05,+h[j+3096>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+3408>>3]=+h[d>>3]*+h[(c[g>>2]|0)+3072>>3];i=b;return}function jl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2840>>3]=+h[b+3408>>3]*+h[(c[a+416>>2]|0)+1592>>3];i=i;return}function kl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1752>>3]*+h[j+12520>>3]*+h[e+2968>>3];l=+h[j+3408>>3]+ +h[j+3400>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1720|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1720|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,5792,5784,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1720|0;r=q;h[r>>3]=o;i=d;return}function ll(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3656>>3]=+h[b+1720>>3]*+h[d+1752>>3]*+h[d+2968>>3]*(+h[b+56>>3]*.5+(+h[b+88>>3]*-.5+(+h[b+2520>>3]+ +h[b+2528>>3])*.5));i=i;return}function ml(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4136>>3]=+h[b+3408>>3]- +h[b+3400>>3];i=i;return}function nl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+14104>>3];k=+h[g+4136>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+10808|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+10808|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,5888,5880,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+10808|0;p=o;h[p>>3]=m;i=d;return}function ol(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3408>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3e3>>3]=+h[(a?e+11144|0:e+11136|0)>>3];i=b;return}function pl(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3408>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3160>>3]=+h[(a?e+12520|0:e+12512|0)>>3];i=b;return}function ql(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+88>>3],+h[a+80>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+88>>3];l=+h[g+80>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4528>>3]=+h[f>>3];i=b;return}function rl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4528>>3];k=+h[g+12512>>3];l=+h[g+88>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,5928,5920,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+1944>>3]=j-n;i=d;return}function sl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4448>>3]=+h[b+4288>>3]*+h[b+1944>>3];i=i;return}function tl(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3408>>3];h[b+3328>>3]=d*+h[(!(d>=0.0)?b+4520|0:b+4528|0)>>3];i=i;return}function ul(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3976>>3]=+h[b+3328>>3]- +h[b+3336>>3];i=i;return}function vl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10200>>3]=+h[b+3976>>3]+(+h[b+3656>>3]+ +h[b+3816>>3]);i=i;return}function wl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4296>>3];k=+h[g+10200>>3]- +h[g+4136>>3]*+h[g+1912>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9880|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9880|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,5968,5960,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9880|0;p=o;h[p>>3]=m;i=d;return}function xl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+444>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+872>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+872|0;h[c[g+448>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+872>>3]);e=c[f>>2]|0;h[c[e+452>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+444>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+10656>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+10656|0;h[(c[e+448>>2]|0)+8>>3]=+h[g>>3];k=+b$a(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+10656>>3]);j=c[f>>2]|0;h[(c[j+452>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+444>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+864>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+864|0;h[(c[j+448>>2]|0)+16>>3]=+h[e>>3];k=+b$a(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+864>>3]);h[(c[(c[f>>2]|0)+452>>2]|0)+16>>3]=k;$_a(a,5)|0;a=c[(c[f>>2]|0)+444>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+872>>3]=+h[a>>3];h[f+10656>>3]=+h[a+8>>3];h[f+864>>3]=+h[a+16>>3];i=b;return}function yl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+104>>3],+h[a+96>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+104>>3];l=+h[g+96>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12504>>3]=+h[f>>3];i=b;return}function zl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4280>>3]=+h[b+14088>>3]*+h[b+12504>>3];i=i;return}function Al(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12504>>3],+h[f+96>>3],+h[f+104>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11128>>3]=+h[d>>3];i=b;return}function Bl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;JD(d,c[a+536>>2]|0,+h[f+2512>>3],+h[f+12504>>3],+h[f+12512>>3],+h[f+11128>>3],+h[f+11136>>3],+h[j+1584>>3],+h[f+12920>>3],+h[f+12832>>3]*+h[j+3136>>3],(+h[j+2056>>3]+ +h[j+2064>>3])*.5,+h[j+3128>>3]*.05,+h[j+3096>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+3416>>3]=+h[d>>3]*+h[(c[g>>2]|0)+3072>>3];i=b;return}function Cl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2832>>3]=+h[b+3416>>3]*+h[(c[a+416>>2]|0)+1584>>3];i=i;return}function Dl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1744>>3]*+h[j+12512>>3]*+h[e+2968>>3];l=+h[j+3416>>3]+ +h[j+3408>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1712|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1712|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,6e3,5992,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1712|0;r=q;h[r>>3]=o;i=d;return}function El(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3648>>3]=+h[b+1712>>3]*+h[d+1744>>3]*+h[d+2968>>3]*(+h[b+72>>3]*.5+(+h[b+104>>3]*-.5+(+h[b+2512>>3]+ +h[b+2520>>3])*.5));i=i;return}function Fl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4128>>3]=+h[b+3416>>3]- +h[b+3408>>3];i=i;return}function Gl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+14096>>3];k=+h[g+4128>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+10800|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+10800|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,6096,6088,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+10800|0;p=o;h[p>>3]=m;i=d;return}function Hl(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3416>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2992>>3]=+h[(a?e+11136|0:e+11128|0)>>3];i=b;return}function Il(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3416>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3152>>3]=+h[(a?e+12512|0:e+12504|0)>>3];i=b;return}function Jl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+104>>3],+h[a+96>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+104>>3];l=+h[g+96>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4536>>3]=+h[f>>3];i=b;return}function Kl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4536>>3];k=+h[g+12504>>3];l=+h[g+104>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,6136,6128,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+1976>>3]=j-n;i=d;return}function Ll(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4440>>3]=+h[b+4280>>3]*+h[b+1976>>3];i=i;return}function Ml(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3416>>3];h[b+3320>>3]=d*+h[(!(d>=0.0)?b+4528|0:b+4536|0)>>3];i=i;return}function Nl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3968>>3]=+h[b+3320>>3]- +h[b+3328>>3];i=i;return}function Ol(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10192>>3]=+h[b+3968>>3]+(+h[b+3648>>3]+ +h[b+3808>>3]);i=i;return}function Pl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4288>>3];k=+h[g+10192>>3]- +h[g+4128>>3]*+h[g+1944>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9872|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9872|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,6176,6168,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9872|0;p=o;h[p>>3]=m;i=d;return}function Ql(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+524>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+888>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+888|0;h[c[g+528>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+888>>3]);e=c[f>>2]|0;h[c[e+532>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+524>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+10648>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+10648|0;h[(c[e+528>>2]|0)+8>>3]=+h[g>>3];k=+b$a(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+10648>>3]);j=c[f>>2]|0;h[(c[j+532>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+524>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+880>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+880|0;h[(c[j+528>>2]|0)+16>>3]=+h[e>>3];k=+b$a(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+880>>3]);h[(c[(c[f>>2]|0)+532>>2]|0)+16>>3]=k;$_a(a,6)|0;a=c[(c[f>>2]|0)+524>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+888>>3]=+h[a>>3];h[f+10648>>3]=+h[a+8>>3];h[f+880>>3]=+h[a+16>>3];i=b;return}function Rl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+120>>3],+h[a+112>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+120>>3];l=+h[g+112>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12496>>3]=+h[f>>3];i=b;return}function Sl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4272>>3]=+h[b+14080>>3]*+h[b+12496>>3];i=i;return}function Tl(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12496>>3],+h[f+112>>3],+h[f+120>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11120>>3]=+h[d>>3];i=b;return}function Ul(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;JD(d,c[a+536>>2]|0,+h[f+2504>>3],+h[f+12496>>3],+h[f+12504>>3],+h[f+11120>>3],+h[f+11128>>3],+h[j+1576>>3],+h[f+12928>>3],+h[f+12824>>3]*+h[j+3136>>3],(+h[j+2048>>3]+ +h[j+2056>>3])*.5,+h[j+3128>>3]*.05,+h[j+3096>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+3424>>3]=+h[d>>3]*+h[(c[g>>2]|0)+3072>>3];i=b;return}function Vl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2824>>3]=+h[b+3424>>3]*+h[(c[a+416>>2]|0)+1576>>3];i=i;return}function Wl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1736>>3]*+h[j+12504>>3]*+h[e+2968>>3];l=+h[j+3424>>3]+ +h[j+3416>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1704|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1704|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,6208,6200,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1704|0;r=q;h[r>>3]=o;i=d;return}function Xl(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3640>>3]=+h[b+1704>>3]*+h[d+1736>>3]*+h[d+2968>>3]*(+h[b+88>>3]*.5+(+h[b+120>>3]*-.5+(+h[b+2504>>3]+ +h[b+2512>>3])*.5));i=i;return}function Yl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4120>>3]=+h[b+3424>>3]- +h[b+3416>>3];i=i;return}function Zl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+14088>>3];k=+h[g+4120>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+10792|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+10792|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,6304,6296,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+10792|0;p=o;h[p>>3]=m;i=d;return}function _l(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3424>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2984>>3]=+h[(a?e+11128|0:e+11120|0)>>3];i=b;return}function $l(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3424>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3144>>3]=+h[(a?e+12504|0:e+12496|0)>>3];i=b;return}



function am(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+120>>3],+h[a+112>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+120>>3];l=+h[g+112>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4544>>3]=+h[f>>3];i=b;return}function bm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4544>>3];k=+h[g+12496>>3];l=+h[g+120>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,6344,6336,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+2008>>3]=j-n;i=d;return}function cm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4432>>3]=+h[b+4272>>3]*+h[b+2008>>3];i=i;return}function dm(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3424>>3];h[b+3312>>3]=d*+h[(!(d>=0.0)?b+4536|0:b+4544|0)>>3];i=i;return}function em(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3960>>3]=+h[b+3312>>3]- +h[b+3320>>3];i=i;return}function fm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10184>>3]=+h[b+3960>>3]+(+h[b+3640>>3]+ +h[b+3800>>3]);i=i;return}function gm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4280>>3];k=+h[g+10184>>3]- +h[g+4120>>3]*+h[g+1976>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9864|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9864|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,6384,6376,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9864|0;p=o;h[p>>3]=m;i=d;return}function hm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+604>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+904>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+904|0;h[c[g+608>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+904>>3]);e=c[f>>2]|0;h[c[e+612>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+604>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+10640>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+10640|0;h[(c[e+608>>2]|0)+8>>3]=+h[g>>3];k=+b$a(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+10640>>3]);j=c[f>>2]|0;h[(c[j+612>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+604>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+896>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+896|0;h[(c[j+608>>2]|0)+16>>3]=+h[e>>3];k=+b$a(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+896>>3]);h[(c[(c[f>>2]|0)+612>>2]|0)+16>>3]=k;$_a(a,7)|0;a=c[(c[f>>2]|0)+604>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+904>>3]=+h[a>>3];h[f+10640>>3]=+h[a+8>>3];h[f+896>>3]=+h[a+16>>3];i=b;return}function im(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+136>>3],+h[a+128>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+136>>3];l=+h[g+128>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12488>>3]=+h[f>>3];i=b;return}function jm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4264>>3]=+h[b+14072>>3]*+h[b+12488>>3];i=i;return}function km(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12488>>3],+h[f+128>>3],+h[f+136>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11112>>3]=+h[d>>3];i=b;return}function lm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;JD(d,c[a+536>>2]|0,+h[f+2496>>3],+h[f+12488>>3],+h[f+12496>>3],+h[f+11112>>3],+h[f+11120>>3],+h[j+1568>>3],+h[f+12936>>3],+h[f+12816>>3]*+h[j+3136>>3],(+h[j+2040>>3]+ +h[j+2048>>3])*.5,+h[j+3128>>3]*.05,+h[j+3096>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+3432>>3]=+h[d>>3]*+h[(c[g>>2]|0)+3072>>3];i=b;return}function mm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2816>>3]=+h[b+3432>>3]*+h[(c[a+416>>2]|0)+1568>>3];i=i;return}function nm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1728>>3]*+h[j+12496>>3]*+h[e+2968>>3];l=+h[j+3432>>3]+ +h[j+3424>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1696|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1696|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,6416,6408,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1696|0;r=q;h[r>>3]=o;i=d;return}function om(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3632>>3]=+h[b+1696>>3]*+h[d+1728>>3]*+h[d+2968>>3]*(+h[b+104>>3]*.5+(+h[b+136>>3]*-.5+(+h[b+2496>>3]+ +h[b+2504>>3])*.5));i=i;return}function pm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4112>>3]=+h[b+3432>>3]- +h[b+3424>>3];i=i;return}function qm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+14080>>3];k=+h[g+4112>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+10784|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+10784|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,6512,6504,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+10784|0;p=o;h[p>>3]=m;i=d;return}function rm(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3432>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2976>>3]=+h[(a?e+11120|0:e+11112|0)>>3];i=b;return}function sm(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3432>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3136>>3]=+h[(a?e+12496|0:e+12488|0)>>3];i=b;return}function tm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+136>>3],+h[a+128>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+136>>3];l=+h[g+128>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4552>>3]=+h[f>>3];i=b;return}function um(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4552>>3];k=+h[g+12488>>3];l=+h[g+136>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,6552,6544,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+2040>>3]=j-n;i=d;return}function vm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4424>>3]=+h[b+4264>>3]*+h[b+2040>>3];i=i;return}function wm(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3432>>3];h[b+3304>>3]=d*+h[(!(d>=0.0)?b+4544|0:b+4552|0)>>3];i=i;return}function xm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3952>>3]=+h[b+3304>>3]- +h[b+3312>>3];i=i;return}function ym(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10176>>3]=+h[b+3952>>3]+(+h[b+3632>>3]+ +h[b+3792>>3]);i=i;return}function zm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4272>>3];k=+h[g+10176>>3]- +h[g+4112>>3]*+h[g+2008>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9856|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9856|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,6592,6584,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9856|0;p=o;h[p>>3]=m;i=d;return}function Am(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+684>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+920>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+920|0;h[c[g+688>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+920>>3]);e=c[f>>2]|0;h[c[e+692>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+684>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+10632>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+10632|0;h[(c[e+688>>2]|0)+8>>3]=+h[g>>3];k=+b$a(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+10632>>3]);j=c[f>>2]|0;h[(c[j+692>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+684>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+912>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+912|0;h[(c[j+688>>2]|0)+16>>3]=+h[e>>3];k=+b$a(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+912>>3]);h[(c[(c[f>>2]|0)+692>>2]|0)+16>>3]=k;$_a(a,8)|0;a=c[(c[f>>2]|0)+684>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+920>>3]=+h[a>>3];h[f+10632>>3]=+h[a+8>>3];h[f+912>>3]=+h[a+16>>3];i=b;return}function Bm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+152>>3],+h[a+144>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+152>>3];l=+h[g+144>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12480>>3]=+h[f>>3];i=b;return}function Cm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4256>>3]=+h[b+14064>>3]*+h[b+12480>>3];i=i;return}function Dm(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12480>>3],+h[f+144>>3],+h[f+152>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11104>>3]=+h[d>>3];i=b;return}function Em(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;JD(d,c[a+536>>2]|0,+h[f+2488>>3],+h[f+12480>>3],+h[f+12488>>3],+h[f+11104>>3],+h[f+11112>>3],+h[j+1560>>3],+h[f+12944>>3],+h[f+12808>>3]*+h[j+3136>>3],(+h[j+2032>>3]+ +h[j+2040>>3])*.5,+h[j+3128>>3]*.05,+h[j+3096>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+3440>>3]=+h[d>>3]*+h[(c[g>>2]|0)+3072>>3];i=b;return}function Fm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2808>>3]=+h[b+3440>>3]*+h[(c[a+416>>2]|0)+1560>>3];i=i;return}function Gm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1720>>3]*+h[j+12488>>3]*+h[e+2968>>3];l=+h[j+3440>>3]+ +h[j+3432>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1688|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1688|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,6624,6616,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1688|0;r=q;h[r>>3]=o;i=d;return}function Hm(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3624>>3]=+h[b+1688>>3]*+h[d+1720>>3]*+h[d+2968>>3]*(+h[b+120>>3]*.5+(+h[b+152>>3]*-.5+(+h[b+2488>>3]+ +h[b+2496>>3])*.5));i=i;return}function Im(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4104>>3]=+h[b+3440>>3]- +h[b+3432>>3];i=i;return}function Jm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+14072>>3];k=+h[g+4104>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+10776|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+10776|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,6720,6712,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+10776|0;p=o;h[p>>3]=m;i=d;return}function Km(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3440>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2968>>3]=+h[(a?e+11112|0:e+11104|0)>>3];i=b;return}function Lm(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3440>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3128>>3]=+h[(a?e+12488|0:e+12480|0)>>3];i=b;return}function Mm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+152>>3],+h[a+144>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+152>>3];l=+h[g+144>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4560>>3]=+h[f>>3];i=b;return}function Nm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4560>>3];k=+h[g+12480>>3];l=+h[g+152>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,6760,6752,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+2072>>3]=j-n;i=d;return}function Om(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4416>>3]=+h[b+4256>>3]*+h[b+2072>>3];i=i;return}function Pm(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3440>>3];h[b+3296>>3]=d*+h[(!(d>=0.0)?b+4552|0:b+4560|0)>>3];i=i;return}function Qm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3944>>3]=+h[b+3296>>3]- +h[b+3304>>3];i=i;return}function Rm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10168>>3]=+h[b+3944>>3]+(+h[b+3624>>3]+ +h[b+3784>>3]);i=i;return}function Sm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4264>>3];k=+h[g+10168>>3]- +h[g+4104>>3]*+h[g+2040>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9848|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9848|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,6800,6792,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9848|0;p=o;h[p>>3]=m;i=d;return}function Tm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+764>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+936>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+936|0;h[c[g+768>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+936>>3]);e=c[f>>2]|0;h[c[e+772>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+764>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+10624>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+10624|0;h[(c[e+768>>2]|0)+8>>3]=+h[g>>3];k=+b$a(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+10624>>3]);j=c[f>>2]|0;h[(c[j+772>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+764>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+928>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+928|0;h[(c[j+768>>2]|0)+16>>3]=+h[e>>3];k=+b$a(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+928>>3]);h[(c[(c[f>>2]|0)+772>>2]|0)+16>>3]=k;$_a(a,9)|0;a=c[(c[f>>2]|0)+764>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+936>>3]=+h[a>>3];h[f+10624>>3]=+h[a+8>>3];h[f+928>>3]=+h[a+16>>3];i=b;return}function Um(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+168>>3],+h[a+160>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+168>>3];l=+h[g+160>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12472>>3]=+h[f>>3];i=b;return}function Vm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4248>>3]=+h[b+14056>>3]*+h[b+12472>>3];i=i;return}function Wm(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12472>>3],+h[f+160>>3],+h[f+168>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11096>>3]=+h[d>>3];i=b;return}function Xm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;JD(d,c[a+536>>2]|0,+h[f+2480>>3],+h[f+12472>>3],+h[f+12480>>3],+h[f+11096>>3],+h[f+11104>>3],+h[j+1552>>3],+h[f+12952>>3],+h[f+12800>>3]*+h[j+3136>>3],(+h[j+2024>>3]+ +h[j+2032>>3])*.5,+h[j+3128>>3]*.05,+h[j+3096>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+3448>>3]=+h[d>>3]*+h[(c[g>>2]|0)+3072>>3];i=b;return}function Ym(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2800>>3]=+h[b+3448>>3]*+h[(c[a+416>>2]|0)+1552>>3];i=i;return}function Zm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1712>>3]*+h[j+12480>>3]*+h[e+2968>>3];l=+h[j+3448>>3]+ +h[j+3440>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1680|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1680|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,6832,6824,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1680|0;r=q;h[r>>3]=o;i=d;return}function _m(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3616>>3]=+h[b+1680>>3]*+h[d+1712>>3]*+h[d+2968>>3]*(+h[b+136>>3]*.5+(+h[b+168>>3]*-.5+(+h[b+2480>>3]+ +h[b+2488>>3])*.5));i=i;return}function $m(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4096>>3]=+h[b+3448>>3]- +h[b+3440>>3];i=i;return}function an(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+14064>>3];k=+h[g+4096>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+10768|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+10768|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,6928,6920,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+10768|0;p=o;h[p>>3]=m;i=d;return}function bn(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3448>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2960>>3]=+h[(a?e+11104|0:e+11096|0)>>3];i=b;return}function cn(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3448>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3120>>3]=+h[(a?e+12480|0:e+12472|0)>>3];i=b;return}function dn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+168>>3],+h[a+160>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+168>>3];l=+h[g+160>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4568>>3]=+h[f>>3];i=b;return}function en(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4568>>3];k=+h[g+12472>>3];l=+h[g+168>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,6968,6960,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+2104>>3]=j-n;i=d;return}function fn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4408>>3]=+h[b+4248>>3]*+h[b+2104>>3];i=i;return}function gn(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3448>>3];h[b+3288>>3]=d*+h[(!(d>=0.0)?b+4560|0:b+4568|0)>>3];i=i;return}function hn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3936>>3]=+h[b+3288>>3]- +h[b+3296>>3];i=i;return}function jn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10160>>3]=+h[b+3936>>3]+(+h[b+3616>>3]+ +h[b+3776>>3]);i=i;return}function kn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4256>>3];k=+h[g+10160>>3]- +h[g+4096>>3]*+h[g+2072>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9840|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9840|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,7008,7e3,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9840|0;p=o;h[p>>3]=m;i=d;return}function ln(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+844>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+952>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+952|0;h[c[g+848>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+952>>3]);e=c[f>>2]|0;h[c[e+852>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+844>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+10616>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+10616|0;h[(c[e+848>>2]|0)+8>>3]=+h[g>>3];k=+b$a(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+10616>>3]);j=c[f>>2]|0;h[(c[j+852>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+844>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+944>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+944|0;h[(c[j+848>>2]|0)+16>>3]=+h[e>>3];k=+b$a(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+944>>3]);h[(c[(c[f>>2]|0)+852>>2]|0)+16>>3]=k;$_a(a,10)|0;a=c[(c[f>>2]|0)+844>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+952>>3]=+h[a>>3];h[f+10616>>3]=+h[a+8>>3];h[f+944>>3]=+h[a+16>>3];i=b;return}function mn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+184>>3],+h[a+176>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+184>>3];l=+h[g+176>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12464>>3]=+h[f>>3];i=b;return}function nn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4240>>3]=+h[b+14048>>3]*+h[b+12464>>3];i=i;return}function on(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12464>>3],+h[f+176>>3],+h[f+184>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11088>>3]=+h[d>>3];i=b;return}function pn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;JD(d,c[a+536>>2]|0,+h[f+2472>>3],+h[f+12464>>3],+h[f+12472>>3],+h[f+11088>>3],+h[f+11096>>3],+h[j+1544>>3],+h[f+12960>>3],+h[f+12792>>3]*+h[j+3136>>3],(+h[j+2016>>3]+ +h[j+2024>>3])*.5,+h[j+3128>>3]*.05,+h[j+3096>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+3456>>3]=+h[d>>3]*+h[(c[g>>2]|0)+3072>>3];i=b;return}function qn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2792>>3]=+h[b+3456>>3]*+h[(c[a+416>>2]|0)+1544>>3];i=i;return}function rn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1704>>3]*+h[j+12472>>3]*+h[e+2968>>3];l=+h[j+3456>>3]+ +h[j+3448>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1672|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1672|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,7040,7032,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1672|0;r=q;h[r>>3]=o;i=d;return}function sn(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3608>>3]=+h[b+1672>>3]*+h[d+1704>>3]*+h[d+2968>>3]*(+h[b+152>>3]*.5+(+h[b+184>>3]*-.5+(+h[b+2472>>3]+ +h[b+2480>>3])*.5));i=i;return}function tn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4088>>3]=+h[b+3456>>3]- +h[b+3448>>3];i=i;return}function un(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+14056>>3];k=+h[g+4088>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+10760|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+10760|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,7136,7128,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+10760|0;p=o;h[p>>3]=m;i=d;return}function vn(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3456>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2952>>3]=+h[(a?e+11096|0:e+11088|0)>>3];i=b;return}function wn(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3456>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3112>>3]=+h[(a?e+12472|0:e+12464|0)>>3];i=b;return}function xn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+184>>3],+h[a+176>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+184>>3];l=+h[g+176>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4576>>3]=+h[f>>3];i=b;return}function yn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4576>>3];k=+h[g+12464>>3];l=+h[g+184>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,7176,7168,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+2136>>3]=j-n;i=d;return}function zn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4400>>3]=+h[b+4240>>3]*+h[b+2136>>3];i=i;return}function An(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3456>>3];h[b+3280>>3]=d*+h[(!(d>=0.0)?b+4568|0:b+4576|0)>>3];i=i;return}function Bn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3928>>3]=+h[b+3280>>3]- +h[b+3288>>3];i=i;return}function Cn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10152>>3]=+h[b+3928>>3]+(+h[b+3608>>3]+ +h[b+3768>>3]);i=i;return}function Dn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4248>>3];k=+h[g+10152>>3]- +h[g+4088>>3]*+h[g+2104>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9832|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9832|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,7216,7208,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9832|0;p=o;h[p>>3]=m;i=d;return}function En(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+924>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+968>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+968|0;h[c[g+928>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+968>>3]);e=c[f>>2]|0;h[c[e+932>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+924>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+10608>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+10608|0;h[(c[e+928>>2]|0)+8>>3]=+h[g>>3];k=+b$a(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+10608>>3]);j=c[f>>2]|0;h[(c[j+932>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+924>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+960>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+960|0;h[(c[j+928>>2]|0)+16>>3]=+h[e>>3];k=+b$a(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+960>>3]);h[(c[(c[f>>2]|0)+932>>2]|0)+16>>3]=k;$_a(a,11)|0;a=c[(c[f>>2]|0)+924>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+968>>3]=+h[a>>3];h[f+10608>>3]=+h[a+8>>3];h[f+960>>3]=+h[a+16>>3];i=b;return}function Fn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+200>>3],+h[a+192>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+200>>3];l=+h[g+192>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12456>>3]=+h[f>>3];i=b;return}function Gn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4232>>3]=+h[b+14040>>3]*+h[b+12456>>3];i=i;return}function Hn(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12456>>3],+h[f+192>>3],+h[f+200>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11080>>3]=+h[d>>3];i=b;return}function In(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;JD(d,c[a+536>>2]|0,+h[f+2464>>3],+h[f+12456>>3],+h[f+12464>>3],+h[f+11080>>3],+h[f+11088>>3],+h[j+1536>>3],+h[f+12968>>3],+h[f+12784>>3]*+h[j+3136>>3],(+h[j+2008>>3]+ +h[j+2016>>3])*.5,+h[j+3128>>3]*.05,+h[j+3096>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+3464>>3]=+h[d>>3]*+h[(c[g>>2]|0)+3072>>3];i=b;return}function Jn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2784>>3]=+h[b+3464>>3]*+h[(c[a+416>>2]|0)+1536>>3];i=i;return}function Kn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1696>>3]*+h[j+12464>>3]*+h[e+2968>>3];l=+h[j+3464>>3]+ +h[j+3456>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1664|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1664|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,7248,7240,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1664|0;r=q;h[r>>3]=o;i=d;return}function Ln(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3600>>3]=+h[b+1664>>3]*+h[d+1696>>3]*+h[d+2968>>3]*(+h[b+168>>3]*.5+(+h[b+200>>3]*-.5+(+h[b+2464>>3]+ +h[b+2472>>3])*.5));i=i;return}function Mn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4080>>3]=+h[b+3464>>3]- +h[b+3456>>3];i=i;return}function Nn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+14048>>3];k=+h[g+4080>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+10752|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+10752|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,7336,7328,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+10752|0;p=o;h[p>>3]=m;i=d;return}function On(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3464>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2944>>3]=+h[(a?e+11088|0:e+11080|0)>>3];i=b;return}function Pn(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3464>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3104>>3]=+h[(a?e+12464|0:e+12456|0)>>3];i=b;return}function Qn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+200>>3],+h[a+192>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+200>>3];l=+h[g+192>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4584>>3]=+h[f>>3];i=b;return}function Rn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4584>>3];k=+h[g+12456>>3];l=+h[g+200>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,7376,7368,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+2168>>3]=j-n;i=d;return}function Sn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4392>>3]=+h[b+4232>>3]*+h[b+2168>>3];i=i;return}function Tn(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3464>>3];h[b+3272>>3]=d*+h[(!(d>=0.0)?b+4576|0:b+4584|0)>>3];i=i;return}function Un(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3920>>3]=+h[b+3272>>3]- +h[b+3280>>3];i=i;return}function Vn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10144>>3]=+h[b+3920>>3]+(+h[b+3600>>3]+ +h[b+3760>>3]);i=i;return}function Wn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4240>>3];k=+h[g+10144>>3]- +h[g+4080>>3]*+h[g+2136>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9824|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9824|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,7416,7408,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9824|0;p=o;h[p>>3]=m;i=d;return}function Xn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1004>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+984>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+984|0;h[c[g+1008>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+984>>3]);e=c[f>>2]|0;h[c[e+1012>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+1004>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+10600>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+10600|0;h[(c[e+1008>>2]|0)+8>>3]=+h[g>>3];k=+b$a(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+10600>>3]);j=c[f>>2]|0;h[(c[j+1012>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+1004>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+976>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+976|0;h[(c[j+1008>>2]|0)+16>>3]=+h[e>>3];k=+b$a(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+976>>3]);h[(c[(c[f>>2]|0)+1012>>2]|0)+16>>3]=k;$_a(a,12)|0;a=c[(c[f>>2]|0)+1004>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+984>>3]=+h[a>>3];h[f+10600>>3]=+h[a+8>>3];h[f+976>>3]=+h[a+16>>3];i=b;return}function Yn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+216>>3],+h[a+208>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+216>>3];l=+h[g+208>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12448>>3]=+h[f>>3];i=b;return}function Zn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4224>>3]=+h[b+14032>>3]*+h[b+12448>>3];i=i;return}function _n(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12448>>3],+h[f+208>>3],+h[f+216>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11072>>3]=+h[d>>3];i=b;return}function $n(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;JD(d,c[a+536>>2]|0,+h[f+2456>>3],+h[f+12448>>3],+h[f+12456>>3],+h[f+11072>>3],+h[f+11080>>3],+h[j+1528>>3],+h[f+12976>>3],+h[f+12776>>3]*+h[j+3136>>3],(+h[j+2e3>>3]+ +h[j+2008>>3])*.5,+h[j+3128>>3]*.05,+h[j+3096>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+3472>>3]=+h[d>>3]*+h[(c[g>>2]|0)+3072>>3];i=b;return}function ao(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2776>>3]=+h[b+3472>>3]*+h[(c[a+416>>2]|0)+1528>>3];i=i;return}function bo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1688>>3]*+h[j+12456>>3]*+h[e+2968>>3];l=+h[j+3472>>3]+ +h[j+3464>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1656|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1656|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,7448,7440,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1656|0;r=q;h[r>>3]=o;i=d;return}function co(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3592>>3]=+h[b+1656>>3]*+h[d+1688>>3]*+h[d+2968>>3]*(+h[b+184>>3]*.5+(+h[b+216>>3]*-.5+(+h[b+2456>>3]+ +h[b+2464>>3])*.5));i=i;return}function eo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4072>>3]=+h[b+3472>>3]- +h[b+3464>>3];i=i;return}function fo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+14040>>3];k=+h[g+4072>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+10744|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+10744|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,7536,7528,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+10744|0;p=o;h[p>>3]=m;i=d;return}function go(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3472>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2936>>3]=+h[(a?e+11080|0:e+11072|0)>>3];i=b;return}function ho(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3472>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3096>>3]=+h[(a?e+12456|0:e+12448|0)>>3];i=b;return}function io(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+216>>3],+h[a+208>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+216>>3];l=+h[g+208>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4592>>3]=+h[f>>3];i=b;return}function jo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4592>>3];k=+h[g+12448>>3];l=+h[g+216>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,7576,7568,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+2200>>3]=j-n;i=d;return}function ko(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4384>>3]=+h[b+4224>>3]*+h[b+2200>>3];i=i;return}function lo(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3472>>3];h[b+3264>>3]=d*+h[(!(d>=0.0)?b+4584|0:b+4592|0)>>3];i=i;return}function mo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3912>>3]=+h[b+3264>>3]- +h[b+3272>>3];i=i;return}function no(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10136>>3]=+h[b+3912>>3]+(+h[b+3592>>3]+ +h[b+3752>>3]);i=i;return}function oo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4232>>3];k=+h[g+10136>>3]- +h[g+4072>>3]*+h[g+2168>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9816|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9816|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,7616,7608,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9816|0;p=o;h[p>>3]=m;i=d;return}function po(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1084>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1e3>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1e3|0;h[c[g+1088>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1e3>>3]);e=c[f>>2]|0;h[c[e+1092>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+1084>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+10592>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+10592|0;h[(c[e+1088>>2]|0)+8>>3]=+h[g>>3];k=+b$a(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+10592>>3]);j=c[f>>2]|0;h[(c[j+1092>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+1084>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+992>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+992|0;h[(c[j+1088>>2]|0)+16>>3]=+h[e>>3];k=+b$a(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+992>>3]);h[(c[(c[f>>2]|0)+1092>>2]|0)+16>>3]=k;$_a(a,13)|0;a=c[(c[f>>2]|0)+1084>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1e3>>3]=+h[a>>3];h[f+10592>>3]=+h[a+8>>3];h[f+992>>3]=+h[a+16>>3];i=b;return}function qo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+232>>3],+h[a+224>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+232>>3];l=+h[g+224>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12440>>3]=+h[f>>3];i=b;return}function ro(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4216>>3]=+h[b+14024>>3]*+h[b+12440>>3];i=i;return}function so(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12440>>3],+h[f+224>>3],+h[f+232>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11064>>3]=+h[d>>3];i=b;return}function to(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;JD(d,c[a+536>>2]|0,+h[f+2448>>3],+h[f+12440>>3],+h[f+12448>>3],+h[f+11064>>3],+h[f+11072>>3],+h[j+1520>>3],+h[f+12984>>3],+h[f+12768>>3]*+h[j+3136>>3],(+h[j+1992>>3]+ +h[j+2e3>>3])*.5,+h[j+3128>>3]*.05,+h[j+3096>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+3480>>3]=+h[d>>3]*+h[(c[g>>2]|0)+3072>>3];i=b;return}function uo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2768>>3]=+h[b+3480>>3]*+h[(c[a+416>>2]|0)+1520>>3];i=i;return}function vo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1680>>3]*+h[j+12448>>3]*+h[e+2968>>3];l=+h[j+3480>>3]+ +h[j+3472>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1648|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1648|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,7648,7640,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1648|0;r=q;h[r>>3]=o;i=d;return}function wo(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3584>>3]=+h[b+1648>>3]*+h[d+1680>>3]*+h[d+2968>>3]*(+h[b+200>>3]*.5+(+h[b+232>>3]*-.5+(+h[b+2448>>3]+ +h[b+2456>>3])*.5));i=i;return}function xo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4064>>3]=+h[b+3480>>3]- +h[b+3472>>3];i=i;return}function yo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+14032>>3];k=+h[g+4064>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+10736|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+10736|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,7736,7728,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+10736|0;p=o;h[p>>3]=m;i=d;return}function zo(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3480>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2928>>3]=+h[(a?e+11072|0:e+11064|0)>>3];i=b;return}function Ao(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3480>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3088>>3]=+h[(a?e+12448|0:e+12440|0)>>3];i=b;return}function Bo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+232>>3],+h[a+224>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+232>>3];l=+h[g+224>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4600>>3]=+h[f>>3];i=b;return}function Co(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4600>>3];k=+h[g+12440>>3];l=+h[g+232>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,7776,7768,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+2232>>3]=j-n;i=d;return}function Do(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4376>>3]=+h[b+4216>>3]*+h[b+2232>>3];i=i;return}function Eo(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3480>>3];h[b+3256>>3]=d*+h[(!(d>=0.0)?b+4592|0:b+4600|0)>>3];i=i;return}function Fo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3904>>3]=+h[b+3256>>3]- +h[b+3264>>3];i=i;return}function Go(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10128>>3]=+h[b+3904>>3]+(+h[b+3584>>3]+ +h[b+3744>>3]);i=i;return}function Ho(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4224>>3];k=+h[g+10128>>3]- +h[g+4064>>3]*+h[g+2200>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9808|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9808|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,7816,7808,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9808|0;p=o;h[p>>3]=m;i=d;return}function Io(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1164>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1016>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1016|0;h[c[g+1168>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1016>>3]);e=c[f>>2]|0;h[c[e+1172>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+1164>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+10584>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+10584|0;h[(c[e+1168>>2]|0)+8>>3]=+h[g>>3];k=+b$a(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+10584>>3]);j=c[f>>2]|0;h[(c[j+1172>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+1164>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+1008>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+1008|0;h[(c[j+1168>>2]|0)+16>>3]=+h[e>>3];k=+b$a(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+1008>>3]);h[(c[(c[f>>2]|0)+1172>>2]|0)+16>>3]=k;$_a(a,14)|0;a=c[(c[f>>2]|0)+1164>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1016>>3]=+h[a>>3];h[f+10584>>3]=+h[a+8>>3];h[f+1008>>3]=+h[a+16>>3];i=b;return}function Jo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+248>>3],+h[a+240>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+248>>3];l=+h[g+240>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12432>>3]=+h[f>>3];i=b;return}function Ko(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4208>>3]=+h[b+14016>>3]*+h[b+12432>>3];i=i;return}function Lo(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12432>>3],+h[f+240>>3],+h[f+248>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11056>>3]=+h[d>>3];i=b;return}function Mo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;JD(d,c[a+536>>2]|0,+h[f+2440>>3],+h[f+12432>>3],+h[f+12440>>3],+h[f+11056>>3],+h[f+11064>>3],+h[j+1512>>3],+h[f+12992>>3],+h[f+12760>>3]*+h[j+3136>>3],(+h[j+1984>>3]+ +h[j+1992>>3])*.5,+h[j+3128>>3]*.05,+h[j+3096>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+3488>>3]=+h[d>>3]*+h[(c[g>>2]|0)+3072>>3];i=b;return}function No(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2760>>3]=+h[b+3488>>3]*+h[(c[a+416>>2]|0)+1512>>3];i=i;return}function Oo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1672>>3]*+h[j+12440>>3]*+h[e+2968>>3];l=+h[j+3488>>3]+ +h[j+3480>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1640|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1640|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,7848,7840,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1640|0;r=q;h[r>>3]=o;i=d;return}function Po(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3576>>3]=+h[b+1640>>3]*+h[d+1672>>3]*+h[d+2968>>3]*(+h[b+216>>3]*.5+(+h[b+248>>3]*-.5+(+h[b+2440>>3]+ +h[b+2448>>3])*.5));i=i;return}function Qo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4056>>3]=+h[b+3488>>3]- +h[b+3480>>3];i=i;return}function Ro(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+14024>>3];k=+h[g+4056>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+10728|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+10728|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,7936,7928,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+10728|0;p=o;h[p>>3]=m;i=d;return}function So(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3488>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2920>>3]=+h[(a?e+11064|0:e+11056|0)>>3];i=b;return}function To(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3488>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3080>>3]=+h[(a?e+12440|0:e+12432|0)>>3];i=b;return}function Uo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+248>>3],+h[a+240>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+248>>3];l=+h[g+240>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4608>>3]=+h[f>>3];i=b;return}function Vo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4608>>3];k=+h[g+12432>>3];l=+h[g+248>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,7976,7968,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+2264>>3]=j-n;i=d;return}function Wo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4368>>3]=+h[b+4208>>3]*+h[b+2264>>3];i=i;return}function Xo(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3488>>3];h[b+3248>>3]=d*+h[(!(d>=0.0)?b+4600|0:b+4608|0)>>3];i=i;return}function Yo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3896>>3]=+h[b+3248>>3]- +h[b+3256>>3];i=i;return}function Zo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10120>>3]=+h[b+3896>>3]+(+h[b+3576>>3]+ +h[b+3736>>3]);i=i;return}function _o(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4216>>3];k=+h[g+10120>>3]- +h[g+4056>>3]*+h[g+2232>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9800|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9800|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,8016,8008,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9800|0;p=o;h[p>>3]=m;i=d;return}function $o(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1244>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1032>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1032|0;h[c[g+1248>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1032>>3]);e=c[f>>2]|0;h[c[e+1252>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+1244>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+10576>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+10576|0;h[(c[e+1248>>2]|0)+8>>3]=+h[g>>3];k=+b$a(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+10576>>3]);j=c[f>>2]|0;h[(c[j+1252>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+1244>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+1024>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+1024|0;h[(c[j+1248>>2]|0)+16>>3]=+h[e>>3];k=+b$a(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+1024>>3]);h[(c[(c[f>>2]|0)+1252>>2]|0)+16>>3]=k;$_a(a,15)|0;a=c[(c[f>>2]|0)+1244>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1032>>3]=+h[a>>3];h[f+10576>>3]=+h[a+8>>3];h[f+1024>>3]=+h[a+16>>3];i=b;return}function ap(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+264>>3],+h[a+256>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+264>>3];l=+h[g+256>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12424>>3]=+h[f>>3];i=b;return}function bp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4200>>3]=+h[b+14008>>3]*+h[b+12424>>3];i=i;return}function cp(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12424>>3],+h[f+256>>3],+h[f+264>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11048>>3]=+h[d>>3];i=b;return}function dp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;JD(d,c[a+536>>2]|0,+h[f+2432>>3],+h[f+12424>>3],+h[f+12432>>3],+h[f+11048>>3],+h[f+11056>>3],+h[j+1504>>3],+h[f+13e3>>3],+h[f+12752>>3]*+h[j+3136>>3],(+h[j+1976>>3]+ +h[j+1984>>3])*.5,+h[j+3128>>3]*.05,+h[j+3096>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+3496>>3]=+h[d>>3]*+h[(c[g>>2]|0)+3072>>3];i=b;return}function ep(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2752>>3]=+h[b+3496>>3]*+h[(c[a+416>>2]|0)+1504>>3];i=i;return}function fp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1664>>3]*+h[j+12432>>3]*+h[e+2968>>3];l=+h[j+3496>>3]+ +h[j+3488>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1632|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1632|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,8048,8040,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1632|0;r=q;h[r>>3]=o;i=d;return}function gp(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3568>>3]=+h[b+1632>>3]*+h[d+1664>>3]*+h[d+2968>>3]*(+h[b+232>>3]*.5+(+h[b+264>>3]*-.5+(+h[b+2432>>3]+ +h[b+2440>>3])*.5));i=i;return}function hp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4048>>3]=+h[b+3496>>3]- +h[b+3488>>3];i=i;return}function ip(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+14016>>3];k=+h[g+4048>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+10720|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+10720|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,8136,8128,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+10720|0;p=o;h[p>>3]=m;i=d;return}function jp(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3496>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2912>>3]=+h[(a?e+11056|0:e+11048|0)>>3];i=b;return}function kp(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3496>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3072>>3]=+h[(a?e+12432|0:e+12424|0)>>3];i=b;return}function lp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+264>>3],+h[a+256>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+264>>3];l=+h[g+256>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4616>>3]=+h[f>>3];i=b;return}function mp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4616>>3];k=+h[g+12424>>3];l=+h[g+264>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,8176,8168,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+2296>>3]=j-n;i=d;return}function np(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4360>>3]=+h[b+4200>>3]*+h[b+2296>>3];i=i;return}function op(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3496>>3];h[b+3240>>3]=d*+h[(!(d>=0.0)?b+4608|0:b+4616|0)>>3];i=i;return}function pp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3888>>3]=+h[b+3240>>3]- +h[b+3248>>3];i=i;return}function qp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10112>>3]=+h[b+3888>>3]+(+h[b+3568>>3]+ +h[b+3728>>3]);i=i;return}function rp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4208>>3];k=+h[g+10112>>3]- +h[g+4048>>3]*+h[g+2264>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9792|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9792|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,8216,8208,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9792|0;p=o;h[p>>3]=m;i=d;return}function sp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1324>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1048>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1048|0;h[c[g+1328>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1048>>3]);e=c[f>>2]|0;h[c[e+1332>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+1324>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+10568>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+10568|0;h[(c[e+1328>>2]|0)+8>>3]=+h[g>>3];k=+b$a(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+10568>>3]);j=c[f>>2]|0;h[(c[j+1332>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+1324>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+1040>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+1040|0;h[(c[j+1328>>2]|0)+16>>3]=+h[e>>3];k=+b$a(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+1040>>3]);h[(c[(c[f>>2]|0)+1332>>2]|0)+16>>3]=k;$_a(a,16)|0;a=c[(c[f>>2]|0)+1324>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1048>>3]=+h[a>>3];h[f+10568>>3]=+h[a+8>>3];h[f+1040>>3]=+h[a+16>>3];i=b;return}function tp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+280>>3],+h[a+272>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+280>>3];l=+h[g+272>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12416>>3]=+h[f>>3];i=b;return}function up(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4192>>3]=+h[b+14e3>>3]*+h[b+12416>>3];i=i;return}function vp(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12416>>3],+h[f+272>>3],+h[f+280>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11040>>3]=+h[d>>3];i=b;return}function wp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;JD(d,c[a+536>>2]|0,+h[f+2424>>3],+h[f+12416>>3],+h[f+12424>>3],+h[f+11040>>3],+h[f+11048>>3],+h[j+1496>>3],+h[f+13008>>3],+h[f+12744>>3]*+h[j+3136>>3],(+h[j+1968>>3]+ +h[j+1976>>3])*.5,+h[j+3128>>3]*.05,+h[j+3096>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+3504>>3]=+h[d>>3]*+h[(c[g>>2]|0)+3072>>3];i=b;return}function xp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2744>>3]=+h[b+3504>>3]*+h[(c[a+416>>2]|0)+1496>>3];i=i;return}function yp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1656>>3]*+h[j+12424>>3]*+h[e+2968>>3];l=+h[j+3504>>3]+ +h[j+3496>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1624|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1624|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,8248,8240,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1624|0;r=q;h[r>>3]=o;i=d;return}function zp(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3560>>3]=+h[b+1624>>3]*+h[d+1656>>3]*+h[d+2968>>3]*(+h[b+248>>3]*.5+(+h[b+280>>3]*-.5+(+h[b+2424>>3]+ +h[b+2432>>3])*.5));i=i;return}function Ap(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4040>>3]=+h[b+3504>>3]- +h[b+3496>>3];i=i;return}function Bp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+14008>>3];k=+h[g+4040>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+10712|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+10712|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,8336,8328,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+10712|0;p=o;h[p>>3]=m;i=d;return}function Cp(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3504>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2904>>3]=+h[(a?e+11048|0:e+11040|0)>>3];i=b;return}function Dp(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3504>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3064>>3]=+h[(a?e+12424|0:e+12416|0)>>3];i=b;return}function Ep(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+280>>3],+h[a+272>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+280>>3];l=+h[g+272>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4624>>3]=+h[f>>3];i=b;return}function Fp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4624>>3];k=+h[g+12416>>3];l=+h[g+280>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,8376,8368,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+2328>>3]=j-n;i=d;return}function Gp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4352>>3]=+h[b+4192>>3]*+h[b+2328>>3];i=i;return}function Hp(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3504>>3];h[b+3232>>3]=d*+h[(!(d>=0.0)?b+4616|0:b+4624|0)>>3];i=i;return}function Ip(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3880>>3]=+h[b+3232>>3]- +h[b+3240>>3];i=i;return}function Jp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10104>>3]=+h[b+3880>>3]+(+h[b+3560>>3]+ +h[b+3720>>3]);i=i;return}function Kp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4200>>3];k=+h[g+10104>>3]- +h[g+4040>>3]*+h[g+2296>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9784|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9784|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,8416,8408,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9784|0;p=o;h[p>>3]=m;i=d;return}function Lp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1404>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1064>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1064|0;h[c[g+1408>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1064>>3]);e=c[f>>2]|0;h[c[e+1412>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+1404>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+10560>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+10560|0;h[(c[e+1408>>2]|0)+8>>3]=+h[g>>3];k=+b$a(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+10560>>3]);j=c[f>>2]|0;h[(c[j+1412>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+1404>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+1056>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+1056|0;h[(c[j+1408>>2]|0)+16>>3]=+h[e>>3];k=+b$a(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+1056>>3]);h[(c[(c[f>>2]|0)+1412>>2]|0)+16>>3]=k;$_a(a,17)|0;a=c[(c[f>>2]|0)+1404>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1064>>3]=+h[a>>3];h[f+10560>>3]=+h[a+8>>3];h[f+1056>>3]=+h[a+16>>3];i=b;return}function Mp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+296>>3],+h[a+288>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+296>>3];l=+h[g+288>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12408>>3]=+h[f>>3];i=b;return}function Np(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4184>>3]=+h[b+13992>>3]*+h[b+12408>>3];i=i;return}function Op(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12408>>3],+h[f+288>>3],+h[f+296>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11032>>3]=+h[d>>3];i=b;return}function Pp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;JD(d,c[a+536>>2]|0,+h[f+2416>>3],+h[f+12408>>3],+h[f+12416>>3],+h[f+11032>>3],+h[f+11040>>3],+h[j+1488>>3],+h[f+13016>>3],+h[f+12736>>3]*+h[j+3136>>3],(+h[j+1960>>3]+ +h[j+1968>>3])*.5,+h[j+3128>>3]*.05,+h[j+3096>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+3512>>3]=+h[d>>3]*+h[(c[g>>2]|0)+3072>>3];i=b;return}function Qp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2736>>3]=+h[b+3512>>3]*+h[(c[a+416>>2]|0)+1488>>3];i=i;return}function Rp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1648>>3]*+h[j+12416>>3]*+h[e+2968>>3];l=+h[j+3512>>3]+ +h[j+3504>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1616|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1616|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,8448,8440,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1616|0;r=q;h[r>>3]=o;i=d;return}function Sp(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3552>>3]=+h[b+1616>>3]*+h[d+1648>>3]*+h[d+2968>>3]*(+h[b+264>>3]*.5+(+h[b+296>>3]*-.5+(+h[b+2416>>3]+ +h[b+2424>>3])*.5));i=i;return}function Tp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4032>>3]=+h[b+3512>>3]- +h[b+3504>>3];i=i;return}function Up(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+14e3>>3];k=+h[g+4032>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+10704|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+10704|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,8536,8528,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+10704|0;p=o;h[p>>3]=m;i=d;return}function Vp(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3512>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2896>>3]=+h[(a?e+11040|0:e+11032|0)>>3];i=b;return}function Wp(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3512>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3056>>3]=+h[(a?e+12416|0:e+12408|0)>>3];i=b;return}function Xp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+296>>3],+h[a+288>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+296>>3];l=+h[g+288>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4632>>3]=+h[f>>3];i=b;return}function Yp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4632>>3];k=+h[g+12408>>3];l=+h[g+296>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,8576,8568,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+2360>>3]=j-n;i=d;return}function Zp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4344>>3]=+h[b+4184>>3]*+h[b+2360>>3];i=i;return}function _p(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3512>>3];h[b+3224>>3]=d*+h[(!(d>=0.0)?b+4624|0:b+4632|0)>>3];i=i;return}function $p(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3872>>3]=+h[b+3224>>3]- +h[b+3232>>3];i=i;return}function aq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10096>>3]=+h[b+3872>>3]+(+h[b+3552>>3]+ +h[b+3712>>3]);i=i;return}function bq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4192>>3];k=+h[g+10096>>3]- +h[g+4032>>3]*+h[g+2328>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9776|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9776|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,8616,8608,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9776|0;p=o;h[p>>3]=m;i=d;return}function cq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1484>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1080>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1080|0;h[c[g+1488>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1080>>3]);e=c[f>>2]|0;h[c[e+1492>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+1484>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+10552>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+10552|0;h[(c[e+1488>>2]|0)+8>>3]=+h[g>>3];k=+b$a(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+10552>>3]);j=c[f>>2]|0;h[(c[j+1492>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+1484>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+1072>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+1072|0;h[(c[j+1488>>2]|0)+16>>3]=+h[e>>3];k=+b$a(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+1072>>3]);h[(c[(c[f>>2]|0)+1492>>2]|0)+16>>3]=k;$_a(a,18)|0;a=c[(c[f>>2]|0)+1484>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1080>>3]=+h[a>>3];h[f+10552>>3]=+h[a+8>>3];h[f+1072>>3]=+h[a+16>>3];i=b;return}function dq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+312>>3],+h[a+304>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+312>>3];l=+h[g+304>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12400>>3]=+h[f>>3];i=b;return}function eq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4176>>3]=+h[b+13984>>3]*+h[b+12400>>3];i=i;return}function fq(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12400>>3],+h[f+304>>3],+h[f+312>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11024>>3]=+h[d>>3];i=b;return}function gq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;JD(d,c[a+536>>2]|0,+h[f+2408>>3],+h[f+12400>>3],+h[f+12408>>3],+h[f+11024>>3],+h[f+11032>>3],+h[j+1480>>3],+h[f+13024>>3],+h[f+12728>>3]*+h[j+3136>>3],(+h[j+1952>>3]+ +h[j+1960>>3])*.5,+h[j+3128>>3]*.05,+h[j+3096>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+3520>>3]=+h[d>>3]*+h[(c[g>>2]|0)+3072>>3];i=b;return}function hq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2728>>3]=+h[b+3520>>3]*+h[(c[a+416>>2]|0)+1480>>3];i=i;return}function iq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1640>>3]*+h[j+12408>>3]*+h[e+2968>>3];l=+h[j+3520>>3]+ +h[j+3512>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1608|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1608|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,8648,8640,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1608|0;r=q;h[r>>3]=o;i=d;return}function jq(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3544>>3]=+h[b+1608>>3]*+h[d+1640>>3]*+h[d+2968>>3]*(+h[b+280>>3]*.5+(+h[b+312>>3]*-.5+(+h[b+2408>>3]+ +h[b+2416>>3])*.5));i=i;return}function kq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4024>>3]=+h[b+3520>>3]- +h[b+3512>>3];i=i;return}function lq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+13992>>3];k=+h[g+4024>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+10696|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+10696|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,8736,8728,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+10696|0;p=o;h[p>>3]=m;i=d;return}function mq(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3520>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2888>>3]=+h[(a?e+11032|0:e+11024|0)>>3];i=b;return}function nq(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3520>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3048>>3]=+h[(a?e+12408|0:e+12400|0)>>3];i=b;return}function oq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;k=+h[j+1952>>3];JD(d,c[a+536>>2]|0,+h[f+2400>>3],+h[f+12392>>3],+h[f+12400>>3],+h[f+11016>>3],+h[f+11024>>3],+h[j+1472>>3],+h[j+1792>>3],+h[f+12720>>3]*+h[j+3136>>3],(k+k)*.5,+h[j+3128>>3]*.05,+h[j+3096>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+3528>>3]=+h[d>>3]*+h[(c[g>>2]|0)+3072>>3];i=b;return}function pq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2720>>3]=+h[b+3528>>3]*+h[(c[a+416>>2]|0)+1472>>3];i=i;return}function qq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4016>>3]=+h[b+3528>>3]- +h[b+3520>>3];i=i;return}function rq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+13984>>3];k=+h[g+4016>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+10688|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+10688|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,8776,8768,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+10688|0;p=o;h[p>>3]=m;i=d;return}function sq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+2968>>3]*+h[j+12392>>3]*+h[e+1632>>3];l=+h[j+3528>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+3200|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+3200|0;q=p;h[q>>3]=n;i=d;return}r=l/+qXa(c[b+536>>2]|0,k,8816,8808,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+3200|0;q=p;h[q>>3]=n;i=d;return}function tq(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3528>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2880>>3]=+h[(a?e+11024|0:e+11016|0)>>3];i=b;return}function uq(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3528>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3040>>3]=+h[(a?e+12400|0:e+12392|0)>>3];i=b;return}function vq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1632>>3]*+h[j+12400>>3]*+h[e+2968>>3];l=+h[j+3528>>3]+ +h[j+3520>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1600|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1600|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,8904,8896,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1600|0;r=q;h[r>>3]=o;i=d;return}function wq(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3536>>3]=+h[b+1600>>3]*+h[d+1632>>3]*+h[d+2968>>3]*(+h[b+296>>3]/1.5+(+h[b+2400>>3]+ +h[b+2408>>3]*.5)+-66666.66666666667);i=i;return}function xq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+312>>3],+h[a+304>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+312>>3];l=+h[g+304>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+14584>>3]=+h[f>>3];i=b;return}function yq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+14584>>3];k=+h[g+12400>>3];l=+h[g+312>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,8992,8984,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+2392>>3]=j-n;i=d;return}function zq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4336>>3]=+h[b+4176>>3]*+h[b+2392>>3];i=i;return}function Aq(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3520>>3];h[b+3216>>3]=d*+h[(!(d>=0.0)?b+4632|0:b+14584|0)>>3];i=i;return}function Bq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3864>>3]=+h[b+3216>>3]- +h[b+3224>>3];i=i;return}function Cq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10088>>3]=+h[b+3864>>3]+(+h[b+3544>>3]+ +h[b+3704>>3]);i=i;return}function Dq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4184>>3];k=+h[g+10088>>3]- +h[g+4024>>3]*+h[g+2360>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9768|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9768|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,9032,9024,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9768|0;p=o;h[p>>3]=m;i=d;return}function Eq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1564>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1096>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1096|0;h[c[g+1568>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1096>>3]);e=c[f>>2]|0;h[c[e+1572>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+1564>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+10544>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+10544|0;h[(c[e+1568>>2]|0)+8>>3]=+h[g>>3];k=+b$a(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+10544>>3]);j=c[f>>2]|0;h[(c[j+1572>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+1564>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+1088>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+1088|0;h[(c[j+1568>>2]|0)+16>>3]=+h[e>>3];k=+b$a(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+1088>>3]);h[(c[(c[f>>2]|0)+1572>>2]|0)+16>>3]=k;$_a(a,19)|0;a=c[(c[f>>2]|0)+1564>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1096>>3]=+h[a>>3];h[f+10544>>3]=+h[a+8>>3];h[f+1088>>3]=+h[a+16>>3];i=b;return}function Fq(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3528>>3];h[b+3208>>3]=d*+h[(!(d>=0.0)?b+14584|0:b+14800|0)>>3];i=i;return}function Gq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3856>>3]=+h[b+3208>>3]- +h[b+3216>>3];i=i;return}function Hq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10080>>3]=+h[b+3856>>3]+(+h[b+3536>>3]+ +h[b+3696>>3]);i=i;return}function Iq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4176>>3];k=+h[g+10080>>3]- +h[g+4016>>3]*+h[g+2392>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9760|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9760|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,9064,9056,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9760|0;p=o;h[p>>3]=m;i=d;return}function Jq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1644>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1112>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1112|0;h[c[g+1648>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1112>>3]);e=c[f>>2]|0;h[c[e+1652>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+1644>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+14656>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+14656|0;h[(c[e+1648>>2]|0)+8>>3]=+h[g>>3];k=+b$a(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+14656>>3]);j=c[f>>2]|0;h[(c[j+1652>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+1644>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+1104>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+1104|0;h[(c[j+1648>>2]|0)+16>>3]=+h[e>>3];k=+b$a(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+1104>>3]);h[(c[(c[f>>2]|0)+1652>>2]|0)+16>>3]=k;$_a(a,20)|0;a=c[(c[f>>2]|0)+1644>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1112>>3]=+h[a>>3];h[f+14656>>3]=+h[a+8>>3];h[f+1104>>3]=+h[a+16>>3];i=b;return}function Kq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+328>>3],+h[a+320>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+328>>3];l=+h[g+320>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12368>>3]=+h[f>>3];i=b;return}function Lq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8968>>3]=+h[b+13496>>3]*+h[b+12368>>3];i=i;return}function Mq(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;WD(d,c[a+536>>2]|0,+h[f+12368>>3],+h[f+320>>3],+h[f+328>>3],1,1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5592>>3]=+h[d>>3];i=b;return}function Nq(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12368>>3],+h[f+320>>3],+h[f+328>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5752>>3]=+h[d>>3];i=b;return}function Oq(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12368>>3],+h[f+320>>3],+h[f+328>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11e3>>3]=+h[d>>3];i=b;return}function Pq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;k=+h[j+976>>3];JD(d,c[a+536>>2]|0,+h[f+7192>>3],+h[f+12368>>3],+h[f+12376>>3],+h[f+11e3>>3],+h[f+11008>>3],+h[j+496>>3],+h[j+816>>3],+h[f+12712>>3]*+h[j+2904>>3],(k+k)*.5,+h[j+2896>>3]*.05,+h[j+2864>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+8016>>3]=+h[d>>3]*+h[(c[g>>2]|0)+2840>>3];i=b;return}function Qq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7512>>3]=+h[b+8016>>3]*+h[(c[a+416>>2]|0)+496>>3];i=i;return}function Rq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+2736>>3]*+h[j+12376>>3]*+h[e+656>>3];l=+h[j+8016>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+7840|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+7840|0;q=p;h[q>>3]=n;i=d;return}r=l/+qXa(c[b+536>>2]|0,k,9096,9088,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+7840|0;q=p;h[q>>3]=n;i=d;return}function Sq(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8016>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7672>>3]=+h[(a?e+11008|0:e+11e3|0)>>3];i=b;return}function Tq(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8016>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7832>>3]=+h[(a?e+12376|0:e+12368|0)>>3];i=b;return}function Uq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+328>>3],+h[a+320>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+328>>3];l=+h[g+320>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+14608>>3]=+h[f>>3];i=b;return}function Vq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+14608>>3];k=+h[g+12368>>3];l=+h[g+328>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,9192,9184,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6424>>3]=j-n;i=d;return}function Wq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9128>>3]=+h[b+8968>>3]*+h[b+6424>>3];i=i;return}function Xq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+88|0;d=b;e=b+40|0;f=b+80|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ID(e,c[g>>2]|0,1,+h[a+14608>>3],+h[a+12368>>3],+h[a+320>>3],+h[a+328>>3]);a=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+40|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));SD(f,a,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+6072>>3]=+h[f>>3];i=b;return}function Yq(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+8016>>3];h[b+8008>>3]=d*+h[(!(d>=0.0)?b+14776|0:b+14608|0)>>3];i=i;return}function Zq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+344>>3],+h[a+336>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+344>>3];l=+h[g+336>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12360>>3]=+h[f>>3];i=b;return}function _q(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8960>>3]=+h[b+13488>>3]*+h[b+12360>>3];i=i;return}function $q(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;WD(d,c[a+536>>2]|0,+h[f+12360>>3],+h[f+336>>3],+h[f+344>>3],1,1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5584>>3]=+h[d>>3];i=b;return}function ar(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12360>>3],+h[f+336>>3],+h[f+344>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5744>>3]=+h[d>>3];i=b;return}function br(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12360>>3],+h[f+336>>3],+h[f+344>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+10992>>3]=+h[d>>3];i=b;return}function cr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;JD(d,c[a+536>>2]|0,+h[f+7184>>3],+h[f+12360>>3],+h[f+12368>>3],+h[f+10992>>3],+h[f+11e3>>3],+h[j+488>>3],+h[f+13032>>3],+h[f+12704>>3]*+h[j+2904>>3],(+h[j+968>>3]+ +h[j+976>>3])*.5,+h[j+2896>>3]*.05,+h[j+2864>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+8024>>3]=+h[d>>3]*+h[(c[g>>2]|0)+2840>>3];i=b;return}function dr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7504>>3]=+h[b+8024>>3]*+h[(c[a+416>>2]|0)+488>>3];i=i;return}function er(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+656>>3]*+h[j+12368>>3]*+h[e+2736>>3];l=+h[j+8024>>3]+ +h[j+8016>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6392|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6392|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,9232,9224,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6392|0;r=q;h[r>>3]=o;i=d;return}function fr(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;GD(d,c[a+536>>2]|0,+h[f+6392>>3],+h[f+12368>>3],+h[f+5752>>3],+h[(c[a+416>>2]|0)+816>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6232>>3]=+h[d>>3];i=b;return}function gr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+Ad(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6232>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4952|0;w=v;h[w>>3]=n;i=b;return}x=c[72300]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=20120;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Pe[a&127](y,d,9320,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4952|0;w=v;h[w>>3]=n;i=b;return}function hr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6392>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4952>>3];l=+U(+(+h[j+6232>>3]));m=+h[j+6072>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?19.5:.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+496>>3];q=n*p;r=q!=0.0;s=+h[o+816>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+qXa(c[b+536>>2]|0,q,9432,9424,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+6072>>3];u=+h[j+4952>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5432|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+qXa(c[b+536>>2]|0,q,9432,9424,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+816>>3];M=+h[j+496>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+qXa(c[b+536>>2]|0,q,9432,9424,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5432|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+qXa(c[b+536>>2]|0,q,9432,9424,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4952>>3]*.125));L=P*(+W(+(+h[g+6072>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+qXa(c[b+536>>2]|0,L,9512,9424,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5432|0;K=J;h[K>>3]=B;i=d;return}}function ir(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6392>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+6232>>3]));l=+h[j+6072>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?19.5:.5)*+h[m+496>>3];o=+h[m+816>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+qXa(c[b+536>>2]|0,n,9432,9640,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+5112>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function jr(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+5112>>3]+-.7;h[b+5272>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function kr(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;_D(d,c[a+536>>2]|0,+h[f+5432>>3],+h[f+5272>>3],+h[f+6232>>3]+-6150.0,3850.0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5912>>3]=+h[d>>3];i=b;return}function lr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1724>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4792>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+4792|0;h[c[g+1728>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4792>>3]);h[c[(c[f>>2]|0)+1732>>2]>>3]=k;$_a(a,21)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+4792>>3]=+h[c[(c[f>>2]|0)+1724>>2]>>3];i=b;return}function mr(a){a=a|0;var b=0,d=0,e=0;b=i;R_a(a,20)|0;d=c[(c[a+476>>2]|0)+1308>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+9592>>3]=+h[d>>3];h[e+8488>>3]=+h[d+8>>3];i=b;return}function nr(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2696>>3]*+h[e+152>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=-+h[j+8488>>3]- +h[j+3696>>3];if(f!=0.0){l=j;m=k/f;n=l;o=n+1592|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+1592|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,f,9656,9648,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1592|0;p=o;h[p>>3]=m;i=d;return}function or(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+8328>>3]=+h[b+6392>>3]*+h[d+656>>3]*+h[d+2736>>3]*(+h[b+7184>>3]*.5+(+h[b+7192>>3]- +h[b+344>>3]/1.5)+66666.66666666667);i=i;return}function pr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8808>>3]=+h[b+8024>>3]- +h[b+8016>>3];i=i;return}function qr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+13496>>3];k=+h[g+8808>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+10536|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+10536|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,9704,9696,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+10536|0;p=o;h[p>>3]=m;i=d;return}function rr(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8024>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7664>>3]=+h[(a?e+11e3|0:e+10992|0)>>3];i=b;return}function sr(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8024>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7824>>3]=+h[(a?e+12368|0:e+12360|0)>>3];i=b;return}function tr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+344>>3],+h[a+336>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+344>>3];l=+h[g+336>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+9136>>3]=+h[f>>3];i=b;return}function ur(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+9136>>3];k=+h[g+12360>>3];l=+h[g+344>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,9744,9736,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+6456>>3]=j-n;i=d;return}function vr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9120>>3]=+h[b+8960>>3]*+h[b+6456>>3];i=i;return}function wr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+88|0;d=b;e=b+40|0;f=b+80|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ID(e,c[g>>2]|0,1,+h[a+9136>>3],+h[a+12360>>3],+h[a+336>>3],+h[a+344>>3]);a=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+40|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));SD(f,a,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+6064>>3]=+h[f>>3];i=b;return}function xr(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+8024>>3];h[b+8e3>>3]=d*+h[(!(d>=0.0)?b+14608|0:b+9136|0)>>3];i=i;return}function yr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8648>>3]=+h[b+8e3>>3]- +h[b+8008>>3];i=i;return}function zr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10072>>3]=+h[b+8648>>3]+(+h[b+8328>>3]+ +h[b+8488>>3]);i=i;return}function Ar(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8968>>3];k=+h[g+10072>>3]- +h[g+8808>>3]*+h[g+6424>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9752|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9752|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,9784,9776,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9752|0;p=o;h[p>>3]=m;i=d;return}function Br(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1804>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1128>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1128|0;h[c[g+1808>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1128>>3]);e=c[f>>2]|0;h[c[e+1812>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+1804>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+14632>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+14632|0;h[(c[e+1808>>2]|0)+8>>3]=+h[g>>3];k=+b$a(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+14632>>3]);j=c[f>>2]|0;h[(c[j+1812>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+1804>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+1120>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+1120|0;h[(c[j+1808>>2]|0)+16>>3]=+h[e>>3];k=+b$a(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+1120>>3]);h[(c[(c[f>>2]|0)+1812>>2]|0)+16>>3]=k;$_a(a,22)|0;a=c[(c[f>>2]|0)+1804>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1128>>3]=+h[a>>3];h[f+14632>>3]=+h[a+8>>3];h[f+1120>>3]=+h[a+16>>3];i=b;return}function Cr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+360>>3],+h[a+352>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+360>>3];l=+h[g+352>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12352>>3]=+h[f>>3];i=b;return}function Dr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8952>>3]=+h[b+13480>>3]*+h[b+12352>>3];i=i;return}function Er(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;WD(d,c[a+536>>2]|0,+h[f+12352>>3],+h[f+352>>3],+h[f+360>>3],1,1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5576>>3]=+h[d>>3];i=b;return}function Fr(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12352>>3],+h[f+352>>3],+h[f+360>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5736>>3]=+h[d>>3];i=b;return}function Gr(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12352>>3],+h[f+352>>3],+h[f+360>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+10984>>3]=+h[d>>3];i=b;return}function Hr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;JD(d,c[a+536>>2]|0,+h[f+7176>>3],+h[f+12352>>3],+h[f+12360>>3],+h[f+10984>>3],+h[f+10992>>3],+h[j+480>>3],+h[f+13040>>3],+h[f+12696>>3]*+h[j+2904>>3],(+h[j+960>>3]+ +h[j+968>>3])*.5,+h[j+2896>>3]*.05,+h[j+2864>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+8032>>3]=+h[d>>3]*+h[(c[g>>2]|0)+2840>>3];i=b;return}function Ir(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7496>>3]=+h[b+8032>>3]*+h[(c[a+416>>2]|0)+480>>3];i=i;return}function Jr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+648>>3]*+h[j+12360>>3]*+h[e+2736>>3];l=+h[j+8032>>3]+ +h[j+8024>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+6384|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+6384|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,9816,9808,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+6384|0;r=q;h[r>>3]=o;i=d;return}function Kr(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;GD(d,c[a+536>>2]|0,+h[f+6384>>3],+h[f+12360>>3],+h[f+5744>>3],+h[(c[a+416>>2]|0)+808>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6224>>3]=+h[d>>3];i=b;return}function Lr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=+Ad(1.0e-10,+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6224>>3]));if(g>0.0){j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4944|0;w=v;h[w>>3]=n;i=b;return}x=c[72300]|0;y=c[a+536>>2]|0;a=e;h[k>>3]=g;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=x;x=d;z=20120;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Pe[a&127](y,d,9904,e);j=+$a(+g);l=j*1.8;m=l+-1.5;n=+OYa(m,-2);o=c[f>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4944|0;w=v;h[w>>3]=n;i=b;return}function Mr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6384>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4944>>3];l=+U(+(+h[j+6224>>3]));m=+h[j+6064>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?18.5:1.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+488>>3];q=n*p;r=q!=0.0;s=+h[o+808>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+qXa(c[b+536>>2]|0,q,10016,10008,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+6064>>3];u=+h[j+4944>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5424|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+qXa(c[b+536>>2]|0,q,10016,10008,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+808>>3];M=+h[j+488>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+qXa(c[b+536>>2]|0,q,10016,10008,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5424|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+qXa(c[b+536>>2]|0,q,10016,10008,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4944>>3]*.125));L=P*(+W(+(+h[g+6064>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+qXa(c[b+536>>2]|0,L,10096,10008,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5424|0;K=J;h[K>>3]=B;i=d;return}}function Nr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6384>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+6224>>3]));l=+h[j+6064>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?18.5:1.5)*+h[m+488>>3];o=+h[m+808>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+qXa(c[b+536>>2]|0,n,10016,10224,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+5104>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function Or(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+5104>>3]+-.7;h[b+5264>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}



function vta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0.0,H=0.0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0,V=0.0,W=0.0,X=0.0,Y=0,Z=0,_=0.0,$=0.0,aa=0.0,ba=0,ca=0,da=0.0,ea=0.0,fa=0.0,ga=0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0.0,oa=0.0,pa=0.0,qa=0,ra=0,sa=0.0,ta=0.0,ua=0.0,va=0,wa=0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0,Ga=0,Ha=0.0,Ia=0.0,Ja=0.0,Ka=0,La=0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0,Qa=0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0,Va=0,Wa=0.0,Xa=0.0,Ya=0.0,Za=0,_a=0,$a=0.0,ab=0.0,bb=0.0,cb=0,db=0,eb=0.0,fb=0.0,gb=0.0,hb=0,ib=0,jb=0.0,kb=0.0,lb=0.0,mb=0,nb=0,ob=0.0,pb=0.0,qb=0.0,rb=0,sb=0,tb=0.0,ub=0.0,vb=0.0,wb=0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0,Cb=0,Db=0.0,Eb=0,Fb=0,Gb=0,Hb=0.0,Ib=0,Jb=0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0.0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0.0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0.0,Zb=0.0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0;d=i;i=i+160|0;e=d;f=d+8|0;g=d+16|0;j=d+24|0;k=d+32|0;l=d+40|0;m=d+48|0;n=d+56|0;o=d+64|0;p=d+72|0;q=d+80|0;r=d+88|0;s=d+96|0;t=d+104|0;u=d+112|0;v=d+120|0;w=d+128|0;x=d+136|0;y=d+144|0;z=d+152|0;A=b+536|0;B=c[A>>2]|0;C=b+416|0;D=c[C>>2]|0;E=+h[D+2840>>3];F=b+4|0;if(E!=0.0){G=E;H=E;I=D}else{J=+qXa(B,E,57480,57472,+h[c[c[F>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);D=c[C>>2]|0;G=J;H=+h[D+2840>>3];I=D}J=1.0/G;G=+h[I+2920>>3];E=+h[I+2928>>3];K=+h[I+344>>3];D=c[c[F>>2]>>2]|0;L=+h[(c[D+8>>2]|0)+13176>>3];M=(+h[I+824>>3]+ +h[I+832>>3])*.5;N=+h[I+2888>>3];do{if(H!=0.0){O=I;P=N/H}else{if(N==0.0){O=I;P=N;break}Q=N/+qXa(c[A>>2]|0,H,57480,57472,+h[D>>3],(a[b+319|0]|0)!=0|0);O=c[C>>2]|0;P=Q}}while(0);PD(e,B,J,G,G,E,E,K,L,M,P,+h[O+2864>>3]);P=+h[e>>3];e=c[A>>2]|0;O=c[C>>2]|0;M=+h[O+2840>>3];if(M!=0.0){R=M;S=M;T=O}else{L=+qXa(e,M,57480,57472,+h[c[c[F>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);O=c[C>>2]|0;R=L;S=+h[O+2840>>3];T=O}L=1.0/R;R=+h[T+2920>>3];M=+h[T+2928>>3];K=+h[T+352>>3];O=c[c[F>>2]>>2]|0;E=+h[(c[O+8>>2]|0)+13168>>3];G=(+h[T+832>>3]+ +h[T+840>>3])*.5;J=+h[T+2888>>3];do{if(S!=0.0){U=T;V=J/S}else{if(J==0.0){U=T;V=J;break}H=J/+qXa(c[A>>2]|0,S,57480,57472,+h[O>>3],(a[b+319|0]|0)!=0|0);U=c[C>>2]|0;V=H}}while(0);PD(f,e,L,R,R,M,M,K,E,G,V,+h[U+2864>>3]);V=+h[f>>3];f=c[A>>2]|0;U=c[C>>2]|0;G=+h[U+2840>>3];if(G!=0.0){W=G;X=G;Y=U}else{E=+qXa(f,G,57480,57472,+h[c[c[F>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);U=c[C>>2]|0;W=E;X=+h[U+2840>>3];Y=U}E=1.0/W;W=+h[Y+2920>>3];G=+h[Y+2928>>3];K=+h[Y+360>>3];U=c[c[F>>2]>>2]|0;M=+h[(c[U+8>>2]|0)+13160>>3];R=(+h[Y+840>>3]+ +h[Y+848>>3])*.5;L=+h[Y+2888>>3];do{if(X!=0.0){Z=Y;_=L/X}else{if(L==0.0){Z=Y;_=L;break}S=L/+qXa(c[A>>2]|0,X,57480,57472,+h[U>>3],(a[b+319|0]|0)!=0|0);Z=c[C>>2]|0;_=S}}while(0);PD(g,f,E,W,W,G,G,K,M,R,_,+h[Z+2864>>3]);_=+h[g>>3];g=c[A>>2]|0;Z=c[C>>2]|0;R=+h[Z+2840>>3];if(R!=0.0){$=R;aa=R;ba=Z}else{M=+qXa(g,R,57480,57472,+h[c[c[F>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);Z=c[C>>2]|0;$=M;aa=+h[Z+2840>>3];ba=Z}M=1.0/$;$=+h[ba+2920>>3];R=+h[ba+2928>>3];K=+h[ba+368>>3];Z=c[c[F>>2]>>2]|0;G=+h[(c[Z+8>>2]|0)+13152>>3];W=(+h[ba+848>>3]+ +h[ba+856>>3])*.5;E=+h[ba+2888>>3];do{if(aa!=0.0){ca=ba;da=E/aa}else{if(E==0.0){ca=ba;da=E;break}X=E/+qXa(c[A>>2]|0,aa,57480,57472,+h[Z>>3],(a[b+319|0]|0)!=0|0);ca=c[C>>2]|0;da=X}}while(0);PD(j,g,M,$,$,R,R,K,G,W,da,+h[ca+2864>>3]);da=+h[j>>3];j=c[A>>2]|0;ca=c[C>>2]|0;W=+h[ca+2840>>3];if(W!=0.0){ea=W;fa=W;ga=ca}else{G=+qXa(j,W,57480,57472,+h[c[c[F>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);ca=c[C>>2]|0;ea=G;fa=+h[ca+2840>>3];ga=ca}G=1.0/ea;ea=+h[ga+2920>>3];W=+h[ga+2928>>3];K=+h[ga+376>>3];ca=c[c[F>>2]>>2]|0;R=+h[(c[ca+8>>2]|0)+13144>>3];$=(+h[ga+856>>3]+ +h[ga+864>>3])*.5;M=+h[ga+2888>>3];do{if(fa!=0.0){ha=ga;ia=M/fa}else{if(M==0.0){ha=ga;ia=M;break}aa=M/+qXa(c[A>>2]|0,fa,57480,57472,+h[ca>>3],(a[b+319|0]|0)!=0|0);ha=c[C>>2]|0;ia=aa}}while(0);PD(k,j,G,ea,ea,W,W,K,R,$,ia,+h[ha+2864>>3]);ia=+h[k>>3];k=c[A>>2]|0;ha=c[C>>2]|0;$=+h[ha+2840>>3];if($!=0.0){ja=$;ka=$;la=ha}else{R=+qXa(k,$,57480,57472,+h[c[c[F>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);ha=c[C>>2]|0;ja=R;ka=+h[ha+2840>>3];la=ha}R=1.0/ja;ja=+h[la+2920>>3];$=+h[la+2928>>3];K=+h[la+384>>3];ha=c[c[F>>2]>>2]|0;W=+h[(c[ha+8>>2]|0)+13136>>3];ea=(+h[la+864>>3]+ +h[la+872>>3])*.5;G=+h[la+2888>>3];do{if(ka!=0.0){ma=la;na=G/ka}else{if(G==0.0){ma=la;na=G;break}fa=G/+qXa(c[A>>2]|0,ka,57480,57472,+h[ha>>3],(a[b+319|0]|0)!=0|0);ma=c[C>>2]|0;na=fa}}while(0);PD(l,k,R,ja,ja,$,$,K,W,ea,na,+h[ma+2864>>3]);na=+h[l>>3];l=c[A>>2]|0;ma=c[C>>2]|0;ea=+h[ma+2840>>3];if(ea!=0.0){oa=ea;pa=ea;qa=ma}else{W=+qXa(l,ea,57480,57472,+h[c[c[F>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);ma=c[C>>2]|0;oa=W;pa=+h[ma+2840>>3];qa=ma}W=1.0/oa;oa=+h[qa+2920>>3];ea=+h[qa+2928>>3];K=+h[qa+392>>3];ma=c[c[F>>2]>>2]|0;$=+h[(c[ma+8>>2]|0)+13128>>3];ja=(+h[qa+872>>3]+ +h[qa+880>>3])*.5;R=+h[qa+2888>>3];do{if(pa!=0.0){ra=qa;sa=R/pa}else{if(R==0.0){ra=qa;sa=R;break}ka=R/+qXa(c[A>>2]|0,pa,57480,57472,+h[ma>>3],(a[b+319|0]|0)!=0|0);ra=c[C>>2]|0;sa=ka}}while(0);PD(m,l,W,oa,oa,ea,ea,K,$,ja,sa,+h[ra+2864>>3]);sa=+h[m>>3];m=c[A>>2]|0;ra=c[C>>2]|0;ja=+h[ra+2840>>3];if(ja!=0.0){ta=ja;ua=ja;va=ra}else{$=+qXa(m,ja,57480,57472,+h[c[c[F>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);ra=c[C>>2]|0;ta=$;ua=+h[ra+2840>>3];va=ra}$=1.0/ta;ta=+h[va+2920>>3];ja=+h[va+2928>>3];K=+h[va+400>>3];ra=c[c[F>>2]>>2]|0;ea=+h[(c[ra+8>>2]|0)+13120>>3];oa=(+h[va+880>>3]+ +h[va+888>>3])*.5;W=+h[va+2888>>3];do{if(ua!=0.0){wa=va;xa=W/ua}else{if(W==0.0){wa=va;xa=W;break}pa=W/+qXa(c[A>>2]|0,ua,57480,57472,+h[ra>>3],(a[b+319|0]|0)!=0|0);wa=c[C>>2]|0;xa=pa}}while(0);PD(n,m,$,ta,ta,ja,ja,K,ea,oa,xa,+h[wa+2864>>3]);xa=+h[n>>3];n=c[A>>2]|0;wa=c[C>>2]|0;oa=+h[wa+2840>>3];if(oa!=0.0){ya=oa;za=oa;Aa=wa}else{ea=+qXa(n,oa,57480,57472,+h[c[c[F>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);wa=c[C>>2]|0;ya=ea;za=+h[wa+2840>>3];Aa=wa}ea=1.0/ya;ya=+h[Aa+2920>>3];oa=+h[Aa+2928>>3];K=+h[Aa+408>>3];wa=c[c[F>>2]>>2]|0;ja=+h[(c[wa+8>>2]|0)+13112>>3];ta=(+h[Aa+888>>3]+ +h[Aa+896>>3])*.5;$=+h[Aa+2888>>3];do{if(za!=0.0){Ba=Aa;Ca=$/za}else{if($==0.0){Ba=Aa;Ca=$;break}ua=$/+qXa(c[A>>2]|0,za,57480,57472,+h[wa>>3],(a[b+319|0]|0)!=0|0);Ba=c[C>>2]|0;Ca=ua}}while(0);PD(o,n,ea,ya,ya,oa,oa,K,ja,ta,Ca,+h[Ba+2864>>3]);Ca=+h[o>>3];o=c[A>>2]|0;Ba=c[C>>2]|0;ta=+h[Ba+2840>>3];if(ta!=0.0){Da=ta;Ea=ta;Fa=Ba}else{ja=+qXa(o,ta,57480,57472,+h[c[c[F>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);Ba=c[C>>2]|0;Da=ja;Ea=+h[Ba+2840>>3];Fa=Ba}ja=1.0/Da;Da=+h[Fa+2920>>3];ta=+h[Fa+2928>>3];K=+h[Fa+416>>3];Ba=c[c[F>>2]>>2]|0;oa=+h[(c[Ba+8>>2]|0)+13104>>3];ya=(+h[Fa+896>>3]+ +h[Fa+904>>3])*.5;ea=+h[Fa+2888>>3];do{if(Ea!=0.0){Ga=Fa;Ha=ea/Ea}else{if(ea==0.0){Ga=Fa;Ha=ea;break}za=ea/+qXa(c[A>>2]|0,Ea,57480,57472,+h[Ba>>3],(a[b+319|0]|0)!=0|0);Ga=c[C>>2]|0;Ha=za}}while(0);PD(p,o,ja,Da,Da,ta,ta,K,oa,ya,Ha,+h[Ga+2864>>3]);Ha=+h[p>>3];p=c[A>>2]|0;Ga=c[C>>2]|0;ya=+h[Ga+2840>>3];if(ya!=0.0){Ia=ya;Ja=ya;Ka=Ga}else{oa=+qXa(p,ya,57480,57472,+h[c[c[F>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);Ga=c[C>>2]|0;Ia=oa;Ja=+h[Ga+2840>>3];Ka=Ga}oa=1.0/Ia;Ia=+h[Ka+2920>>3];ya=+h[Ka+2928>>3];K=+h[Ka+424>>3];Ga=c[c[F>>2]>>2]|0;ta=+h[(c[Ga+8>>2]|0)+13096>>3];Da=(+h[Ka+904>>3]+ +h[Ka+912>>3])*.5;ja=+h[Ka+2888>>3];do{if(Ja!=0.0){La=Ka;Ma=ja/Ja}else{if(ja==0.0){La=Ka;Ma=ja;break}Ea=ja/+qXa(c[A>>2]|0,Ja,57480,57472,+h[Ga>>3],(a[b+319|0]|0)!=0|0);La=c[C>>2]|0;Ma=Ea}}while(0);PD(q,p,oa,Ia,Ia,ya,ya,K,ta,Da,Ma,+h[La+2864>>3]);Ma=+h[q>>3];q=c[A>>2]|0;La=c[C>>2]|0;Da=+h[La+2840>>3];if(Da!=0.0){Na=Da;Oa=Da;Pa=La}else{ta=+qXa(q,Da,57480,57472,+h[c[c[F>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);La=c[C>>2]|0;Na=ta;Oa=+h[La+2840>>3];Pa=La}ta=1.0/Na;Na=+h[Pa+2920>>3];Da=+h[Pa+2928>>3];K=+h[Pa+432>>3];La=c[c[F>>2]>>2]|0;ya=+h[(c[La+8>>2]|0)+13088>>3];Ia=(+h[Pa+912>>3]+ +h[Pa+920>>3])*.5;oa=+h[Pa+2888>>3];do{if(Oa!=0.0){Qa=Pa;Ra=oa/Oa}else{if(oa==0.0){Qa=Pa;Ra=oa;break}Ja=oa/+qXa(c[A>>2]|0,Oa,57480,57472,+h[La>>3],(a[b+319|0]|0)!=0|0);Qa=c[C>>2]|0;Ra=Ja}}while(0);PD(r,q,ta,Na,Na,Da,Da,K,ya,Ia,Ra,+h[Qa+2864>>3]);Ra=+h[r>>3];r=c[A>>2]|0;Qa=c[C>>2]|0;Ia=+h[Qa+2840>>3];if(Ia!=0.0){Sa=Ia;Ta=Ia;Ua=Qa}else{ya=+qXa(r,Ia,57480,57472,+h[c[c[F>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);Qa=c[C>>2]|0;Sa=ya;Ta=+h[Qa+2840>>3];Ua=Qa}ya=1.0/Sa;Sa=+h[Ua+2920>>3];Ia=+h[Ua+2928>>3];K=+h[Ua+440>>3];Qa=c[c[F>>2]>>2]|0;Da=+h[(c[Qa+8>>2]|0)+13080>>3];Na=(+h[Ua+920>>3]+ +h[Ua+928>>3])*.5;ta=+h[Ua+2888>>3];do{if(Ta!=0.0){Va=Ua;Wa=ta/Ta}else{if(ta==0.0){Va=Ua;Wa=ta;break}Oa=ta/+qXa(c[A>>2]|0,Ta,57480,57472,+h[Qa>>3],(a[b+319|0]|0)!=0|0);Va=c[C>>2]|0;Wa=Oa}}while(0);PD(s,r,ya,Sa,Sa,Ia,Ia,K,Da,Na,Wa,+h[Va+2864>>3]);Wa=+h[s>>3];s=c[A>>2]|0;Va=c[C>>2]|0;Na=+h[Va+2840>>3];if(Na!=0.0){Xa=Na;Ya=Na;Za=Va}else{Da=+qXa(s,Na,57480,57472,+h[c[c[F>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);Va=c[C>>2]|0;Xa=Da;Ya=+h[Va+2840>>3];Za=Va}Da=1.0/Xa;Xa=+h[Za+2920>>3];Na=+h[Za+2928>>3];K=+h[Za+448>>3];Va=c[c[F>>2]>>2]|0;Ia=+h[(c[Va+8>>2]|0)+13072>>3];Sa=(+h[Za+928>>3]+ +h[Za+936>>3])*.5;ya=+h[Za+2888>>3];do{if(Ya!=0.0){_a=Za;$a=ya/Ya}else{if(ya==0.0){_a=Za;$a=ya;break}Ta=ya/+qXa(c[A>>2]|0,Ya,57480,57472,+h[Va>>3],(a[b+319|0]|0)!=0|0);_a=c[C>>2]|0;$a=Ta}}while(0);PD(t,s,Da,Xa,Xa,Na,Na,K,Ia,Sa,$a,+h[_a+2864>>3]);$a=+h[t>>3];t=c[A>>2]|0;_a=c[C>>2]|0;Sa=+h[_a+2840>>3];if(Sa!=0.0){ab=Sa;bb=Sa;cb=_a}else{Ia=+qXa(t,Sa,57480,57472,+h[c[c[F>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);_a=c[C>>2]|0;ab=Ia;bb=+h[_a+2840>>3];cb=_a}Ia=1.0/ab;ab=+h[cb+2920>>3];Sa=+h[cb+2928>>3];K=+h[cb+456>>3];_a=c[c[F>>2]>>2]|0;Na=+h[(c[_a+8>>2]|0)+13064>>3];Xa=(+h[cb+936>>3]+ +h[cb+944>>3])*.5;Da=+h[cb+2888>>3];do{if(bb!=0.0){db=cb;eb=Da/bb}else{if(Da==0.0){db=cb;eb=Da;break}Ya=Da/+qXa(c[A>>2]|0,bb,57480,57472,+h[_a>>3],(a[b+319|0]|0)!=0|0);db=c[C>>2]|0;eb=Ya}}while(0);PD(u,t,Ia,ab,ab,Sa,Sa,K,Na,Xa,eb,+h[db+2864>>3]);eb=+h[u>>3];u=c[A>>2]|0;db=c[C>>2]|0;Xa=+h[db+2840>>3];if(Xa!=0.0){fb=Xa;gb=Xa;hb=db}else{Na=+qXa(u,Xa,57480,57472,+h[c[c[F>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);db=c[C>>2]|0;fb=Na;gb=+h[db+2840>>3];hb=db}Na=1.0/fb;fb=+h[hb+2920>>3];Xa=+h[hb+2928>>3];K=+h[hb+464>>3];db=c[c[F>>2]>>2]|0;Sa=+h[(c[db+8>>2]|0)+13056>>3];ab=(+h[hb+944>>3]+ +h[hb+952>>3])*.5;Ia=+h[hb+2888>>3];do{if(gb!=0.0){ib=hb;jb=Ia/gb}else{if(Ia==0.0){ib=hb;jb=Ia;break}bb=Ia/+qXa(c[A>>2]|0,gb,57480,57472,+h[db>>3],(a[b+319|0]|0)!=0|0);ib=c[C>>2]|0;jb=bb}}while(0);PD(v,u,Na,fb,fb,Xa,Xa,K,Sa,ab,jb,+h[ib+2864>>3]);jb=+h[v>>3];v=c[A>>2]|0;ib=c[C>>2]|0;ab=+h[ib+2840>>3];if(ab!=0.0){kb=ab;lb=ab;mb=ib}else{Sa=+qXa(v,ab,57480,57472,+h[c[c[F>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);ib=c[C>>2]|0;kb=Sa;lb=+h[ib+2840>>3];mb=ib}Sa=1.0/kb;kb=+h[mb+2920>>3];ab=+h[mb+2928>>3];K=+h[mb+472>>3];ib=c[c[F>>2]>>2]|0;Xa=+h[(c[ib+8>>2]|0)+13048>>3];fb=(+h[mb+952>>3]+ +h[mb+960>>3])*.5;Na=+h[mb+2888>>3];do{if(lb!=0.0){nb=mb;ob=Na/lb}else{if(Na==0.0){nb=mb;ob=Na;break}gb=Na/+qXa(c[A>>2]|0,lb,57480,57472,+h[ib>>3],(a[b+319|0]|0)!=0|0);nb=c[C>>2]|0;ob=gb}}while(0);PD(w,v,Sa,kb,kb,ab,ab,K,Xa,fb,ob,+h[nb+2864>>3]);ob=+h[w>>3];w=c[A>>2]|0;nb=c[C>>2]|0;fb=+h[nb+2840>>3];if(fb!=0.0){pb=fb;qb=fb;rb=nb}else{Xa=+qXa(w,fb,57480,57472,+h[c[c[F>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);nb=c[C>>2]|0;pb=Xa;qb=+h[nb+2840>>3];rb=nb}Xa=1.0/pb;pb=+h[rb+2920>>3];fb=+h[rb+2928>>3];K=+h[rb+480>>3];nb=c[c[F>>2]>>2]|0;ab=+h[(c[nb+8>>2]|0)+13040>>3];kb=(+h[rb+960>>3]+ +h[rb+968>>3])*.5;Sa=+h[rb+2888>>3];do{if(qb!=0.0){sb=rb;tb=Sa/qb}else{if(Sa==0.0){sb=rb;tb=Sa;break}lb=Sa/+qXa(c[A>>2]|0,qb,57480,57472,+h[nb>>3],(a[b+319|0]|0)!=0|0);sb=c[C>>2]|0;tb=lb}}while(0);PD(x,w,Xa,pb,pb,fb,fb,K,ab,kb,tb,+h[sb+2864>>3]);tb=+h[x>>3];x=c[A>>2]|0;sb=c[C>>2]|0;kb=+h[sb+2840>>3];if(kb!=0.0){ub=kb;vb=kb;wb=sb}else{ab=+qXa(x,kb,57480,57472,+h[c[c[F>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);sb=c[C>>2]|0;ub=ab;vb=+h[sb+2840>>3];wb=sb}ab=1.0/ub;ub=+h[wb+2920>>3];kb=+h[wb+2928>>3];K=+h[wb+488>>3];sb=c[c[F>>2]>>2]|0;fb=+h[(c[sb+8>>2]|0)+13032>>3];pb=(+h[wb+968>>3]+ +h[wb+976>>3])*.5;Xa=+h[wb+2888>>3];do{if(vb!=0.0){xb=wb;yb=Xa/vb}else{if(Xa==0.0){xb=wb;yb=Xa;break}qb=Xa/+qXa(c[A>>2]|0,vb,57480,57472,+h[sb>>3],(a[b+319|0]|0)!=0|0);xb=c[C>>2]|0;yb=qb}}while(0);PD(y,x,ab,ub,ub,kb,kb,K,fb,pb,yb,+h[xb+2864>>3]);yb=+h[y>>3];y=c[A>>2]|0;xb=c[C>>2]|0;pb=+h[xb+2840>>3];if(pb!=0.0){zb=pb;Ab=pb;Bb=xb}else{fb=+qXa(y,pb,57480,57472,+h[c[c[F>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);xb=c[C>>2]|0;zb=fb;Ab=+h[xb+2840>>3];Bb=xb}fb=1.0/zb;zb=+h[Bb+2920>>3];pb=+h[Bb+2928>>3];K=+h[Bb+496>>3];kb=+h[Bb+816>>3];ub=+h[Bb+976>>3];ab=(ub+ub)*.5;ub=+h[Bb+2888>>3];if(Ab!=0.0){Cb=Bb;Db=ub/Ab;Eb=Cb;Fb=Eb+2864|0;Gb=Fb;Hb=+h[Gb>>3];PD(z,y,fb,zb,zb,pb,pb,K,kb,ab,Db,Hb);Ib=z;Jb=Ib;Kb=+h[Jb>>3];Lb=yb+Kb;Mb=tb+Lb;Nb=ob+Mb;Ob=jb+Nb;Pb=eb+Ob;Qb=$a+Pb;Rb=Wa+Qb;Sb=Ra+Rb;Tb=Ma+Sb;Ub=Ha+Tb;Vb=Ca+Ub;Wb=xa+Vb;Xb=sa+Wb;Yb=na+Xb;Zb=ia+Yb;_b=da+Zb;$b=_+_b;ac=V+$b;bc=P+ac;cc=c[F>>2]|0;dc=c[cc>>2]|0;ec=dc;fc=ec+8|0;gc=fc;hc=c[gc>>2]|0;ic=hc;jc=ic+14728|0;kc=jc;h[kc>>3]=bc;i=d;return}if(ub==0.0){Cb=Bb;Db=ub;Eb=Cb;Fb=Eb+2864|0;Gb=Fb;Hb=+h[Gb>>3];PD(z,y,fb,zb,zb,pb,pb,K,kb,ab,Db,Hb);Ib=z;Jb=Ib;Kb=+h[Jb>>3];Lb=yb+Kb;Mb=tb+Lb;Nb=ob+Mb;Ob=jb+Nb;Pb=eb+Ob;Qb=$a+Pb;Rb=Wa+Qb;Sb=Ra+Rb;Tb=Ma+Sb;Ub=Ha+Tb;Vb=Ca+Ub;Wb=xa+Vb;Xb=sa+Wb;Yb=na+Xb;Zb=ia+Yb;_b=da+Zb;$b=_+_b;ac=V+$b;bc=P+ac;cc=c[F>>2]|0;dc=c[cc>>2]|0;ec=dc;fc=ec+8|0;gc=fc;hc=c[gc>>2]|0;ic=hc;jc=ic+14728|0;kc=jc;h[kc>>3]=bc;i=d;return}vb=ub/+qXa(c[A>>2]|0,Ab,57480,57472,+h[c[c[F>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);Cb=c[C>>2]|0;Db=vb;Eb=Cb;Fb=Eb+2864|0;Gb=Fb;Hb=+h[Gb>>3];PD(z,y,fb,zb,zb,pb,pb,K,kb,ab,Db,Hb);Ib=z;Jb=Ib;Kb=+h[Jb>>3];Lb=yb+Kb;Mb=tb+Lb;Nb=ob+Mb;Ob=jb+Nb;Pb=eb+Ob;Qb=$a+Pb;Rb=Wa+Qb;Sb=Ra+Rb;Tb=Ma+Sb;Ub=Ha+Tb;Vb=Ca+Ub;Wb=xa+Vb;Xb=sa+Wb;Yb=na+Xb;Zb=ia+Yb;_b=da+Zb;$b=_+_b;ac=V+$b;bc=P+ac;cc=c[F>>2]|0;dc=c[cc>>2]|0;ec=dc;fc=ec+8|0;gc=fc;hc=c[gc>>2]|0;ic=hc;jc=ic+14728|0;kc=jc;h[kc>>3]=bc;i=d;return}function wta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2944>>3]=+h[b+2736>>3];i=i;return}function xta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2960>>3]=+h[b+3304>>3];i=i;return}function yta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2976>>3]=+h[b+2464>>3];i=i;return}function zta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2992>>3]=+h[b+2608>>3];i=i;return}function Ata(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3024>>3]=+h[b+2640>>3];i=i;return}function Bta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3040>>3]=+h[b+2480>>3];i=i;return}function Cta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3048>>3]=+h[b+2496>>3];i=i;return}function Dta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1304>>3]=+h[b+168>>3];i=i;return}function Eta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3056>>3]=+h[b+2664>>3];i=i;return}function Fta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3072>>3]=+h[b+2968>>3];i=i;return}function Gta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3080>>3]=+h[b+3024>>3];i=i;return}function Hta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3088>>3]=+h[b+3056>>3];i=i;return}function Ita(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3120>>3]=+h[b+3336>>3];i=i;return}function Jta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3136>>3]=+h[b+3312>>3];i=i;return}function Kta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1472>>3]=+h[b+2976>>3]*.05;i=i;return}function Lta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14144>>3]=+h[b+1472>>3]*+h[b+3048>>3];i=i;return}function Mta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1480>>3]=+h[b+2976>>3]*.05;i=i;return}function Nta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14152>>3]=+h[b+1480>>3]*+h[b+3048>>3];i=i;return}function Ota(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1488>>3]=+h[b+2976>>3]*.05;i=i;return}function Pta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14160>>3]=+h[b+1488>>3]*+h[b+3048>>3];i=i;return}function Qta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1496>>3]=+h[b+2976>>3]*.05;i=i;return}function Rta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14168>>3]=+h[b+1496>>3]*+h[b+3048>>3];i=i;return}function Sta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1504>>3]=+h[b+2976>>3]*.05;i=i;return}function Tta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14176>>3]=+h[b+1504>>3]*+h[b+3048>>3];i=i;return}function Uta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1512>>3]=+h[b+2976>>3]*.05;i=i;return}function Vta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14184>>3]=+h[b+1512>>3]*+h[b+3048>>3];i=i;return}function Wta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1520>>3]=+h[b+2976>>3]*.05;i=i;return}function Xta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14192>>3]=+h[b+1520>>3]*+h[b+3048>>3];i=i;return}function Yta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1528>>3]=+h[b+2976>>3]*.05;i=i;return}function Zta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14200>>3]=+h[b+1528>>3]*+h[b+3048>>3];i=i;return}function _ta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1536>>3]=+h[b+2976>>3]*.05;i=i;return}function $ta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14208>>3]=+h[b+1536>>3]*+h[b+3048>>3];i=i;return}function aua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1544>>3]=+h[b+2976>>3]*.05;i=i;return}function bua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14216>>3]=+h[b+1544>>3]*+h[b+3048>>3];i=i;return}function cua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1552>>3]=+h[b+2976>>3]*.05;i=i;return}function dua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14224>>3]=+h[b+1552>>3]*+h[b+3048>>3];i=i;return}function eua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1560>>3]=+h[b+2976>>3]*.05;i=i;return}function fua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14232>>3]=+h[b+1560>>3]*+h[b+3048>>3];i=i;return}function gua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1568>>3]=+h[b+2976>>3]*.05;i=i;return}function hua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14240>>3]=+h[b+1568>>3]*+h[b+3048>>3];i=i;return}function iua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1576>>3]=+h[b+2976>>3]*.05;i=i;return}function jua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14248>>3]=+h[b+1576>>3]*+h[b+3048>>3];i=i;return}function kua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1584>>3]=+h[b+2976>>3]*.05;i=i;return}function lua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14256>>3]=+h[b+1584>>3]*+h[b+3048>>3];i=i;return}function mua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1592>>3]=+h[b+2976>>3]*.05;i=i;return}function nua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14264>>3]=+h[b+1592>>3]*+h[b+3048>>3];i=i;return}function oua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1600>>3]=+h[b+2976>>3]*.05;i=i;return}function pua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14272>>3]=+h[b+1600>>3]*+h[b+3048>>3];i=i;return}function qua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1608>>3]=+h[b+2976>>3]*.05;i=i;return}function rua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14280>>3]=+h[b+1608>>3]*+h[b+3048>>3];i=i;return}function sua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1616>>3]=+h[b+2976>>3]*.05;i=i;return}function tua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14288>>3]=+h[b+1616>>3]*+h[b+3048>>3];i=i;return}function uua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1624>>3]=+h[b+2976>>3]*.05;i=i;return}function vua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14296>>3]=+h[b+1624>>3]*+h[b+3048>>3];i=i;return}function wua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1632>>3]=+h[b+3040>>3];i=i;return}function xua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13984>>3]=+h[b+1632>>3]*+h[b+1472>>3]*+h[b+2968>>3];i=i;return}function yua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1640>>3]=+h[b+3040>>3];i=i;return}function zua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13992>>3]=+h[b+1640>>3]*+h[b+1480>>3]*+h[b+2968>>3];i=i;return}function Aua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1648>>3]=+h[b+3040>>3];i=i;return}function Bua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14e3>>3]=+h[b+1648>>3]*+h[b+1488>>3]*+h[b+2968>>3];i=i;return}function Cua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1656>>3]=+h[b+3040>>3];i=i;return}function Dua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14008>>3]=+h[b+1656>>3]*+h[b+1496>>3]*+h[b+2968>>3];i=i;return}function Eua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1664>>3]=+h[b+3040>>3];i=i;return}function Fua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14016>>3]=+h[b+1664>>3]*+h[b+1504>>3]*+h[b+2968>>3];i=i;return}function Gua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1672>>3]=+h[b+3040>>3];i=i;return}function Hua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14024>>3]=+h[b+1672>>3]*+h[b+1512>>3]*+h[b+2968>>3];i=i;return}function Iua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1680>>3]=+h[b+3040>>3];i=i;return}function Jua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14032>>3]=+h[b+1680>>3]*+h[b+1520>>3]*+h[b+2968>>3];i=i;return}function Kua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1688>>3]=+h[b+3040>>3];i=i;return}function Lua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14040>>3]=+h[b+1688>>3]*+h[b+1528>>3]*+h[b+2968>>3];i=i;return}function Mua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1696>>3]=+h[b+3040>>3];i=i;return}function Nua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14048>>3]=+h[b+1696>>3]*+h[b+1536>>3]*+h[b+2968>>3];i=i;return}function Oua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1704>>3]=+h[b+3040>>3];i=i;return}function Pua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14056>>3]=+h[b+1704>>3]*+h[b+1544>>3]*+h[b+2968>>3];i=i;return}function Qua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1712>>3]=+h[b+3040>>3];i=i;return}function Rua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14064>>3]=+h[b+1712>>3]*+h[b+1552>>3]*+h[b+2968>>3];i=i;return}function Sua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1720>>3]=+h[b+3040>>3];i=i;return}function Tua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14072>>3]=+h[b+1720>>3]*+h[b+1560>>3]*+h[b+2968>>3];i=i;return}function Uua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1728>>3]=+h[b+3040>>3];i=i;return}function Vua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14080>>3]=+h[b+1728>>3]*+h[b+1568>>3]*+h[b+2968>>3];i=i;return}function Wua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1736>>3]=+h[b+3040>>3];i=i;return}function Xua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14088>>3]=+h[b+1736>>3]*+h[b+1576>>3]*+h[b+2968>>3];i=i;return}function Yua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1744>>3]=+h[b+3040>>3];i=i;return}function Zua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14096>>3]=+h[b+1744>>3]*+h[b+1584>>3]*+h[b+2968>>3];i=i;return}function _ua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1752>>3]=+h[b+3040>>3];i=i;return}function $ua(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14104>>3]=+h[b+1752>>3]*+h[b+1592>>3]*+h[b+2968>>3];i=i;return}function ava(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1760>>3]=+h[b+3040>>3];i=i;return}function bva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14112>>3]=+h[b+1760>>3]*+h[b+1600>>3]*+h[b+2968>>3];i=i;return}function cva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1768>>3]=+h[b+3040>>3];i=i;return}function dva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14120>>3]=+h[b+1768>>3]*+h[b+1608>>3]*+h[b+2968>>3];i=i;return}function eva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1776>>3]=+h[b+3040>>3];i=i;return}function fva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14128>>3]=+h[b+1776>>3]*+h[b+1616>>3]*+h[b+2968>>3];i=i;return}function gva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1784>>3]=+h[b+3040>>3];i=i;return}function hva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14136>>3]=+h[b+1784>>3]*+h[b+1624>>3]*+h[b+2968>>3];i=i;return}function iva(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+3048>>3];j=+h[f+3040>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,57520,57512,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1792>>3]=l*4.0;i=d;return}function jva(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+3048>>3];j=+h[f+3040>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,57520,57544,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1800>>3]=l*4.0;i=d;return}function kva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13024>>3]=(+h[b+1792>>3]+ +h[b+1800>>3])*.5;i=i;return}function lva(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+3048>>3];j=+h[f+3040>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,57520,57552,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1808>>3]=l*4.0;i=d;return}function mva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13016>>3]=(+h[b+1800>>3]+ +h[b+1808>>3])*.5;i=i;return}function nva(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+3048>>3];j=+h[f+3040>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,57520,57560,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1816>>3]=l*4.0;i=d;return}function ova(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13008>>3]=(+h[b+1808>>3]+ +h[b+1816>>3])*.5;i=i;return}function pva(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+3048>>3];j=+h[f+3040>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,57520,57568,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1824>>3]=l*4.0;i=d;return}function qva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13e3>>3]=(+h[b+1816>>3]+ +h[b+1824>>3])*.5;i=i;return}function rva(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+3048>>3];j=+h[f+3040>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,57520,57576,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1832>>3]=l*4.0;i=d;return}function sva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12992>>3]=(+h[b+1824>>3]+ +h[b+1832>>3])*.5;i=i;return}function tva(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+3048>>3];j=+h[f+3040>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,57520,57584,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1840>>3]=l*4.0;i=d;return}function uva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12984>>3]=(+h[b+1832>>3]+ +h[b+1840>>3])*.5;i=i;return}function vva(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+3048>>3];j=+h[f+3040>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,57520,57592,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1848>>3]=l*4.0;i=d;return}function wva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12976>>3]=(+h[b+1840>>3]+ +h[b+1848>>3])*.5;i=i;return}function xva(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+3048>>3];j=+h[f+3040>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,57520,57600,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1856>>3]=l*4.0;i=d;return}function yva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12968>>3]=(+h[b+1848>>3]+ +h[b+1856>>3])*.5;i=i;return}function zva(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+3048>>3];j=+h[f+3040>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,57520,57608,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1864>>3]=l*4.0;i=d;return}function Ava(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12960>>3]=(+h[b+1856>>3]+ +h[b+1864>>3])*.5;i=i;return}function Bva(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+3048>>3];j=+h[f+3040>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,57520,57616,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1872>>3]=l*4.0;i=d;return}function Cva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12952>>3]=(+h[b+1864>>3]+ +h[b+1872>>3])*.5;i=i;return}function Dva(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+3048>>3];j=+h[f+3040>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,57520,57624,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1880>>3]=l*4.0;i=d;return}function Eva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12944>>3]=(+h[b+1872>>3]+ +h[b+1880>>3])*.5;i=i;return}function Fva(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+3048>>3];j=+h[f+3040>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,57520,57632,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1888>>3]=l*4.0;i=d;return}function Gva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12936>>3]=(+h[b+1880>>3]+ +h[b+1888>>3])*.5;i=i;return}function Hva(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+3048>>3];j=+h[f+3040>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,57520,57640,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1896>>3]=l*4.0;i=d;return}function Iva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12928>>3]=(+h[b+1888>>3]+ +h[b+1896>>3])*.5;i=i;return}function Jva(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+3048>>3];j=+h[f+3040>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,57520,57648,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1904>>3]=l*4.0;i=d;return}function Kva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12920>>3]=(+h[b+1896>>3]+ +h[b+1904>>3])*.5;i=i;return}function Lva(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+3048>>3];j=+h[f+3040>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,57520,57656,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1912>>3]=l*4.0;i=d;return}function Mva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12912>>3]=(+h[b+1904>>3]+ +h[b+1912>>3])*.5;i=i;return}function Nva(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+3048>>3];j=+h[f+3040>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,57520,57664,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1920>>3]=l*4.0;i=d;return}function Ova(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12904>>3]=(+h[b+1912>>3]+ +h[b+1920>>3])*.5;i=i;return}function Pva(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+3048>>3];j=+h[f+3040>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,57520,57672,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1928>>3]=l*4.0;i=d;return}function Qva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12896>>3]=(+h[b+1920>>3]+ +h[b+1928>>3])*.5;i=i;return}function Rva(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+3048>>3];j=+h[f+3040>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,57520,57680,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1936>>3]=l*4.0;i=d;return}function Sva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12888>>3]=(+h[b+1928>>3]+ +h[b+1936>>3])*.5;i=i;return}function Tva(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+3048>>3];j=+h[f+3040>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,57520,57688,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1944>>3]=l*4.0;i=d;return}function Uva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12880>>3]=(+h[b+1936>>3]+ +h[b+1944>>3])*.5;i=i;return}function Vva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1952>>3]=+h[b+2992>>3];i=i;return}function Wva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1960>>3]=+h[b+2992>>3];i=i;return}function Xva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1968>>3]=+h[b+2992>>3];i=i;return}function Yva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1976>>3]=+h[b+2992>>3];i=i;return}function Zva(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1984>>3]=+h[b+2992>>3];i=i;return}function _va(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1992>>3]=+h[b+2992>>3];i=i;return}function $va(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2e3>>3]=+h[b+2992>>3];i=i;return}function awa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2008>>3]=+h[b+2992>>3];i=i;return}function bwa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2016>>3]=+h[b+2992>>3];i=i;return}function cwa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2024>>3]=+h[b+2992>>3];i=i;return}function dwa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2032>>3]=+h[b+2992>>3];i=i;return}function ewa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2040>>3]=+h[b+2992>>3];i=i;return}function fwa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2048>>3]=+h[b+2992>>3];i=i;return}function gwa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2056>>3]=+h[b+2992>>3];i=i;return}function hwa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2064>>3]=+h[b+2992>>3];i=i;return}function iwa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2072>>3]=+h[b+2992>>3];i=i;return}function jwa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2080>>3]=+h[b+2992>>3];i=i;return}function kwa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2088>>3]=+h[b+2992>>3];i=i;return}function lwa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2096>>3]=+h[b+2992>>3];i=i;return}function mwa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2104>>3]=+h[b+2992>>3];i=i;return}function nwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,U=0.0,V=0.0,W=0.0,X=0,Y=0,Z=0.0,_=0.0,$=0.0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,fa=0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0,qa=0,ra=0.0,sa=0.0,ta=0.0,ua=0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0,Aa=0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0,Fa=0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0,Ka=0,La=0.0,Ma=0.0,Na=0.0,Oa=0,Pa=0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0,Ua=0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0,Za=0,_a=0.0,$a=0.0,ab=0.0,bb=0,cb=0,db=0.0,eb=0.0,fb=0.0,gb=0,hb=0,ib=0.0,jb=0.0,kb=0.0,lb=0,mb=0,nb=0.0,ob=0.0,pb=0.0,qb=0,rb=0,sb=0.0,tb=0.0,ub=0.0,vb=0,wb=0,xb=0.0,yb=0.0,zb=0.0,Ab=0,Bb=0,Cb=0.0,Db=0,Eb=0,Fb=0,Gb=0.0,Hb=0,Ib=0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0.0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0.0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0.0,Zb=0.0,_b=0.0,$b=0.0,ac=0.0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0;d=i;i=i+160|0;e=d;f=d+8|0;g=d+16|0;j=d+24|0;k=d+32|0;l=d+40|0;m=d+48|0;n=d+56|0;o=d+64|0;p=d+72|0;q=d+80|0;r=d+88|0;s=d+96|0;t=d+104|0;u=d+112|0;v=d+120|0;w=d+128|0;x=d+136|0;y=d+144|0;z=d+152|0;A=b+536|0;B=c[A>>2]|0;C=b+416|0;D=c[C>>2]|0;E=+h[D+3072>>3];if(E!=0.0){F=E;G=E;H=D}else{I=+qXa(B,E,57704,57696,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);D=c[C>>2]|0;F=I;G=+h[D+3072>>3];H=D}I=1.0/F;F=+h[H+3152>>3];E=+h[H+3160>>3];J=+h[H+1472>>3];K=+h[H+1792>>3];L=+h[H+1952>>3];M=(L+L)*.5;L=+h[H+3120>>3];do{if(G!=0.0){N=H;O=L/G}else{if(L==0.0){N=H;O=L;break}P=L/+qXa(c[A>>2]|0,G,57704,57696,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);N=c[C>>2]|0;O=P}}while(0);PD(e,B,I,F,F,E,E,J,K,M,O,+h[N+3096>>3]);O=+h[e>>3];e=c[A>>2]|0;N=c[C>>2]|0;M=+h[N+3072>>3];B=b+4|0;if(M!=0.0){Q=M;R=M;S=N}else{K=+qXa(e,M,57704,57696,+h[c[c[B>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);N=c[C>>2]|0;Q=K;R=+h[N+3072>>3];S=N}K=1.0/Q;Q=+h[S+3152>>3];M=+h[S+3160>>3];J=+h[S+1480>>3];N=c[c[B>>2]>>2]|0;E=+h[(c[N+8>>2]|0)+13024>>3];F=(+h[S+1952>>3]+ +h[S+1960>>3])*.5;I=+h[S+3120>>3];do{if(R!=0.0){T=S;U=I/R}else{if(I==0.0){T=S;U=I;break}G=I/+qXa(c[A>>2]|0,R,57704,57696,+h[N>>3],(a[b+319|0]|0)!=0|0);T=c[C>>2]|0;U=G}}while(0);PD(f,e,K,Q,Q,M,M,J,E,F,U,+h[T+3096>>3]);U=+h[f>>3];f=c[A>>2]|0;T=c[C>>2]|0;F=+h[T+3072>>3];if(F!=0.0){V=F;W=F;X=T}else{E=+qXa(f,F,57704,57696,+h[c[c[B>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);T=c[C>>2]|0;V=E;W=+h[T+3072>>3];X=T}E=1.0/V;V=+h[X+3152>>3];F=+h[X+3160>>3];J=+h[X+1488>>3];T=c[c[B>>2]>>2]|0;M=+h[(c[T+8>>2]|0)+13016>>3];Q=(+h[X+1960>>3]+ +h[X+1968>>3])*.5;K=+h[X+3120>>3];do{if(W!=0.0){Y=X;Z=K/W}else{if(K==0.0){Y=X;Z=K;break}R=K/+qXa(c[A>>2]|0,W,57704,57696,+h[T>>3],(a[b+319|0]|0)!=0|0);Y=c[C>>2]|0;Z=R}}while(0);PD(g,f,E,V,V,F,F,J,M,Q,Z,+h[Y+3096>>3]);Z=+h[g>>3];g=c[A>>2]|0;Y=c[C>>2]|0;Q=+h[Y+3072>>3];if(Q!=0.0){_=Q;$=Q;aa=Y}else{M=+qXa(g,Q,57704,57696,+h[c[c[B>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);Y=c[C>>2]|0;_=M;$=+h[Y+3072>>3];aa=Y}M=1.0/_;_=+h[aa+3152>>3];Q=+h[aa+3160>>3];J=+h[aa+1496>>3];Y=c[c[B>>2]>>2]|0;F=+h[(c[Y+8>>2]|0)+13008>>3];V=(+h[aa+1968>>3]+ +h[aa+1976>>3])*.5;E=+h[aa+3120>>3];do{if($!=0.0){ba=aa;ca=E/$}else{if(E==0.0){ba=aa;ca=E;break}W=E/+qXa(c[A>>2]|0,$,57704,57696,+h[Y>>3],(a[b+319|0]|0)!=0|0);ba=c[C>>2]|0;ca=W}}while(0);PD(j,g,M,_,_,Q,Q,J,F,V,ca,+h[ba+3096>>3]);ca=+h[j>>3];j=c[A>>2]|0;ba=c[C>>2]|0;V=+h[ba+3072>>3];if(V!=0.0){da=V;ea=V;fa=ba}else{F=+qXa(j,V,57704,57696,+h[c[c[B>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);ba=c[C>>2]|0;da=F;ea=+h[ba+3072>>3];fa=ba}F=1.0/da;da=+h[fa+3152>>3];V=+h[fa+3160>>3];J=+h[fa+1504>>3];ba=c[c[B>>2]>>2]|0;Q=+h[(c[ba+8>>2]|0)+13e3>>3];_=(+h[fa+1976>>3]+ +h[fa+1984>>3])*.5;M=+h[fa+3120>>3];do{if(ea!=0.0){ga=fa;ha=M/ea}else{if(M==0.0){ga=fa;ha=M;break}$=M/+qXa(c[A>>2]|0,ea,57704,57696,+h[ba>>3],(a[b+319|0]|0)!=0|0);ga=c[C>>2]|0;ha=$}}while(0);PD(k,j,F,da,da,V,V,J,Q,_,ha,+h[ga+3096>>3]);ha=+h[k>>3];k=c[A>>2]|0;ga=c[C>>2]|0;_=+h[ga+3072>>3];if(_!=0.0){ia=_;ja=_;ka=ga}else{Q=+qXa(k,_,57704,57696,+h[c[c[B>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);ga=c[C>>2]|0;ia=Q;ja=+h[ga+3072>>3];ka=ga}Q=1.0/ia;ia=+h[ka+3152>>3];_=+h[ka+3160>>3];J=+h[ka+1512>>3];ga=c[c[B>>2]>>2]|0;V=+h[(c[ga+8>>2]|0)+12992>>3];da=(+h[ka+1984>>3]+ +h[ka+1992>>3])*.5;F=+h[ka+3120>>3];do{if(ja!=0.0){la=ka;ma=F/ja}else{if(F==0.0){la=ka;ma=F;break}ea=F/+qXa(c[A>>2]|0,ja,57704,57696,+h[ga>>3],(a[b+319|0]|0)!=0|0);la=c[C>>2]|0;ma=ea}}while(0);PD(l,k,Q,ia,ia,_,_,J,V,da,ma,+h[la+3096>>3]);ma=+h[l>>3];l=c[A>>2]|0;la=c[C>>2]|0;da=+h[la+3072>>3];if(da!=0.0){na=da;oa=da;pa=la}else{V=+qXa(l,da,57704,57696,+h[c[c[B>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);la=c[C>>2]|0;na=V;oa=+h[la+3072>>3];pa=la}V=1.0/na;na=+h[pa+3152>>3];da=+h[pa+3160>>3];J=+h[pa+1520>>3];la=c[c[B>>2]>>2]|0;_=+h[(c[la+8>>2]|0)+12984>>3];ia=(+h[pa+1992>>3]+ +h[pa+2e3>>3])*.5;Q=+h[pa+3120>>3];do{if(oa!=0.0){qa=pa;ra=Q/oa}else{if(Q==0.0){qa=pa;ra=Q;break}ja=Q/+qXa(c[A>>2]|0,oa,57704,57696,+h[la>>3],(a[b+319|0]|0)!=0|0);qa=c[C>>2]|0;ra=ja}}while(0);PD(m,l,V,na,na,da,da,J,_,ia,ra,+h[qa+3096>>3]);ra=+h[m>>3];m=c[A>>2]|0;qa=c[C>>2]|0;ia=+h[qa+3072>>3];if(ia!=0.0){sa=ia;ta=ia;ua=qa}else{_=+qXa(m,ia,57704,57696,+h[c[c[B>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);qa=c[C>>2]|0;sa=_;ta=+h[qa+3072>>3];ua=qa}_=1.0/sa;sa=+h[ua+3152>>3];ia=+h[ua+3160>>3];J=+h[ua+1528>>3];qa=c[c[B>>2]>>2]|0;da=+h[(c[qa+8>>2]|0)+12976>>3];na=(+h[ua+2e3>>3]+ +h[ua+2008>>3])*.5;V=+h[ua+3120>>3];do{if(ta!=0.0){va=ua;wa=V/ta}else{if(V==0.0){va=ua;wa=V;break}oa=V/+qXa(c[A>>2]|0,ta,57704,57696,+h[qa>>3],(a[b+319|0]|0)!=0|0);va=c[C>>2]|0;wa=oa}}while(0);PD(n,m,_,sa,sa,ia,ia,J,da,na,wa,+h[va+3096>>3]);wa=+h[n>>3];n=c[A>>2]|0;va=c[C>>2]|0;na=+h[va+3072>>3];if(na!=0.0){xa=na;ya=na;za=va}else{da=+qXa(n,na,57704,57696,+h[c[c[B>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);va=c[C>>2]|0;xa=da;ya=+h[va+3072>>3];za=va}da=1.0/xa;xa=+h[za+3152>>3];na=+h[za+3160>>3];J=+h[za+1536>>3];va=c[c[B>>2]>>2]|0;ia=+h[(c[va+8>>2]|0)+12968>>3];sa=(+h[za+2008>>3]+ +h[za+2016>>3])*.5;_=+h[za+3120>>3];do{if(ya!=0.0){Aa=za;Ba=_/ya}else{if(_==0.0){Aa=za;Ba=_;break}ta=_/+qXa(c[A>>2]|0,ya,57704,57696,+h[va>>3],(a[b+319|0]|0)!=0|0);Aa=c[C>>2]|0;Ba=ta}}while(0);PD(o,n,da,xa,xa,na,na,J,ia,sa,Ba,+h[Aa+3096>>3]);Ba=+h[o>>3];o=c[A>>2]|0;Aa=c[C>>2]|0;sa=+h[Aa+3072>>3];if(sa!=0.0){Ca=sa;Da=sa;Ea=Aa}else{ia=+qXa(o,sa,57704,57696,+h[c[c[B>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);Aa=c[C>>2]|0;Ca=ia;Da=+h[Aa+3072>>3];Ea=Aa}ia=1.0/Ca;Ca=+h[Ea+3152>>3];sa=+h[Ea+3160>>3];J=+h[Ea+1544>>3];Aa=c[c[B>>2]>>2]|0;na=+h[(c[Aa+8>>2]|0)+12960>>3];xa=(+h[Ea+2016>>3]+ +h[Ea+2024>>3])*.5;da=+h[Ea+3120>>3];do{if(Da!=0.0){Fa=Ea;Ga=da/Da}else{if(da==0.0){Fa=Ea;Ga=da;break}ya=da/+qXa(c[A>>2]|0,Da,57704,57696,+h[Aa>>3],(a[b+319|0]|0)!=0|0);Fa=c[C>>2]|0;Ga=ya}}while(0);PD(p,o,ia,Ca,Ca,sa,sa,J,na,xa,Ga,+h[Fa+3096>>3]);Ga=+h[p>>3];p=c[A>>2]|0;Fa=c[C>>2]|0;xa=+h[Fa+3072>>3];if(xa!=0.0){Ha=xa;Ia=xa;Ja=Fa}else{na=+qXa(p,xa,57704,57696,+h[c[c[B>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);Fa=c[C>>2]|0;Ha=na;Ia=+h[Fa+3072>>3];Ja=Fa}na=1.0/Ha;Ha=+h[Ja+3152>>3];xa=+h[Ja+3160>>3];J=+h[Ja+1552>>3];Fa=c[c[B>>2]>>2]|0;sa=+h[(c[Fa+8>>2]|0)+12952>>3];Ca=(+h[Ja+2024>>3]+ +h[Ja+2032>>3])*.5;ia=+h[Ja+3120>>3];do{if(Ia!=0.0){Ka=Ja;La=ia/Ia}else{if(ia==0.0){Ka=Ja;La=ia;break}Da=ia/+qXa(c[A>>2]|0,Ia,57704,57696,+h[Fa>>3],(a[b+319|0]|0)!=0|0);Ka=c[C>>2]|0;La=Da}}while(0);PD(q,p,na,Ha,Ha,xa,xa,J,sa,Ca,La,+h[Ka+3096>>3]);La=+h[q>>3];q=c[A>>2]|0;Ka=c[C>>2]|0;Ca=+h[Ka+3072>>3];if(Ca!=0.0){Ma=Ca;Na=Ca;Oa=Ka}else{sa=+qXa(q,Ca,57704,57696,+h[c[c[B>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);Ka=c[C>>2]|0;Ma=sa;Na=+h[Ka+3072>>3];Oa=Ka}sa=1.0/Ma;Ma=+h[Oa+3152>>3];Ca=+h[Oa+3160>>3];J=+h[Oa+1560>>3];Ka=c[c[B>>2]>>2]|0;xa=+h[(c[Ka+8>>2]|0)+12944>>3];Ha=(+h[Oa+2032>>3]+ +h[Oa+2040>>3])*.5;na=+h[Oa+3120>>3];do{if(Na!=0.0){Pa=Oa;Qa=na/Na}else{if(na==0.0){Pa=Oa;Qa=na;break}Ia=na/+qXa(c[A>>2]|0,Na,57704,57696,+h[Ka>>3],(a[b+319|0]|0)!=0|0);Pa=c[C>>2]|0;Qa=Ia}}while(0);PD(r,q,sa,Ma,Ma,Ca,Ca,J,xa,Ha,Qa,+h[Pa+3096>>3]);Qa=+h[r>>3];r=c[A>>2]|0;Pa=c[C>>2]|0;Ha=+h[Pa+3072>>3];if(Ha!=0.0){Ra=Ha;Sa=Ha;Ta=Pa}else{xa=+qXa(r,Ha,57704,57696,+h[c[c[B>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);Pa=c[C>>2]|0;Ra=xa;Sa=+h[Pa+3072>>3];Ta=Pa}xa=1.0/Ra;Ra=+h[Ta+3152>>3];Ha=+h[Ta+3160>>3];J=+h[Ta+1568>>3];Pa=c[c[B>>2]>>2]|0;Ca=+h[(c[Pa+8>>2]|0)+12936>>3];Ma=(+h[Ta+2040>>3]+ +h[Ta+2048>>3])*.5;sa=+h[Ta+3120>>3];do{if(Sa!=0.0){Ua=Ta;Va=sa/Sa}else{if(sa==0.0){Ua=Ta;Va=sa;break}Na=sa/+qXa(c[A>>2]|0,Sa,57704,57696,+h[Pa>>3],(a[b+319|0]|0)!=0|0);Ua=c[C>>2]|0;Va=Na}}while(0);PD(s,r,xa,Ra,Ra,Ha,Ha,J,Ca,Ma,Va,+h[Ua+3096>>3]);Va=+h[s>>3];s=c[A>>2]|0;Ua=c[C>>2]|0;Ma=+h[Ua+3072>>3];if(Ma!=0.0){Wa=Ma;Xa=Ma;Ya=Ua}else{Ca=+qXa(s,Ma,57704,57696,+h[c[c[B>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);Ua=c[C>>2]|0;Wa=Ca;Xa=+h[Ua+3072>>3];Ya=Ua}Ca=1.0/Wa;Wa=+h[Ya+3152>>3];Ma=+h[Ya+3160>>3];J=+h[Ya+1576>>3];Ua=c[c[B>>2]>>2]|0;Ha=+h[(c[Ua+8>>2]|0)+12928>>3];Ra=(+h[Ya+2048>>3]+ +h[Ya+2056>>3])*.5;xa=+h[Ya+3120>>3];do{if(Xa!=0.0){Za=Ya;_a=xa/Xa}else{if(xa==0.0){Za=Ya;_a=xa;break}Sa=xa/+qXa(c[A>>2]|0,Xa,57704,57696,+h[Ua>>3],(a[b+319|0]|0)!=0|0);Za=c[C>>2]|0;_a=Sa}}while(0);PD(t,s,Ca,Wa,Wa,Ma,Ma,J,Ha,Ra,_a,+h[Za+3096>>3]);_a=+h[t>>3];t=c[A>>2]|0;Za=c[C>>2]|0;Ra=+h[Za+3072>>3];if(Ra!=0.0){$a=Ra;ab=Ra;bb=Za}else{Ha=+qXa(t,Ra,57704,57696,+h[c[c[B>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);Za=c[C>>2]|0;$a=Ha;ab=+h[Za+3072>>3];bb=Za}Ha=1.0/$a;$a=+h[bb+3152>>3];Ra=+h[bb+3160>>3];J=+h[bb+1584>>3];Za=c[c[B>>2]>>2]|0;Ma=+h[(c[Za+8>>2]|0)+12920>>3];Wa=(+h[bb+2056>>3]+ +h[bb+2064>>3])*.5;Ca=+h[bb+3120>>3];do{if(ab!=0.0){cb=bb;db=Ca/ab}else{if(Ca==0.0){cb=bb;db=Ca;break}Xa=Ca/+qXa(c[A>>2]|0,ab,57704,57696,+h[Za>>3],(a[b+319|0]|0)!=0|0);cb=c[C>>2]|0;db=Xa}}while(0);PD(u,t,Ha,$a,$a,Ra,Ra,J,Ma,Wa,db,+h[cb+3096>>3]);db=+h[u>>3];u=c[A>>2]|0;cb=c[C>>2]|0;Wa=+h[cb+3072>>3];if(Wa!=0.0){eb=Wa;fb=Wa;gb=cb}else{Ma=+qXa(u,Wa,57704,57696,+h[c[c[B>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);cb=c[C>>2]|0;eb=Ma;fb=+h[cb+3072>>3];gb=cb}Ma=1.0/eb;eb=+h[gb+3152>>3];Wa=+h[gb+3160>>3];J=+h[gb+1592>>3];cb=c[c[B>>2]>>2]|0;Ra=+h[(c[cb+8>>2]|0)+12912>>3];$a=(+h[gb+2064>>3]+ +h[gb+2072>>3])*.5;Ha=+h[gb+3120>>3];do{if(fb!=0.0){hb=gb;ib=Ha/fb}else{if(Ha==0.0){hb=gb;ib=Ha;break}ab=Ha/+qXa(c[A>>2]|0,fb,57704,57696,+h[cb>>3],(a[b+319|0]|0)!=0|0);hb=c[C>>2]|0;ib=ab}}while(0);PD(v,u,Ma,eb,eb,Wa,Wa,J,Ra,$a,ib,+h[hb+3096>>3]);ib=+h[v>>3];v=c[A>>2]|0;hb=c[C>>2]|0;$a=+h[hb+3072>>3];if($a!=0.0){jb=$a;kb=$a;lb=hb}else{Ra=+qXa(v,$a,57704,57696,+h[c[c[B>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);hb=c[C>>2]|0;jb=Ra;kb=+h[hb+3072>>3];lb=hb}Ra=1.0/jb;jb=+h[lb+3152>>3];$a=+h[lb+3160>>3];J=+h[lb+1600>>3];hb=c[c[B>>2]>>2]|0;Wa=+h[(c[hb+8>>2]|0)+12904>>3];eb=(+h[lb+2072>>3]+ +h[lb+2080>>3])*.5;Ma=+h[lb+3120>>3];do{if(kb!=0.0){mb=lb;nb=Ma/kb}else{if(Ma==0.0){mb=lb;nb=Ma;break}fb=Ma/+qXa(c[A>>2]|0,kb,57704,57696,+h[hb>>3],(a[b+319|0]|0)!=0|0);mb=c[C>>2]|0;nb=fb}}while(0);PD(w,v,Ra,jb,jb,$a,$a,J,Wa,eb,nb,+h[mb+3096>>3]);nb=+h[w>>3];w=c[A>>2]|0;mb=c[C>>2]|0;eb=+h[mb+3072>>3];if(eb!=0.0){ob=eb;pb=eb;qb=mb}else{Wa=+qXa(w,eb,57704,57696,+h[c[c[B>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);mb=c[C>>2]|0;ob=Wa;pb=+h[mb+3072>>3];qb=mb}Wa=1.0/ob;ob=+h[qb+3152>>3];eb=+h[qb+3160>>3];J=+h[qb+1608>>3];mb=c[c[B>>2]>>2]|0;$a=+h[(c[mb+8>>2]|0)+12896>>3];jb=(+h[qb+2080>>3]+ +h[qb+2088>>3])*.5;Ra=+h[qb+3120>>3];do{if(pb!=0.0){rb=qb;sb=Ra/pb}else{if(Ra==0.0){rb=qb;sb=Ra;break}kb=Ra/+qXa(c[A>>2]|0,pb,57704,57696,+h[mb>>3],(a[b+319|0]|0)!=0|0);rb=c[C>>2]|0;sb=kb}}while(0);PD(x,w,Wa,ob,ob,eb,eb,J,$a,jb,sb,+h[rb+3096>>3]);sb=+h[x>>3];x=c[A>>2]|0;rb=c[C>>2]|0;jb=+h[rb+3072>>3];if(jb!=0.0){tb=jb;ub=jb;vb=rb}else{$a=+qXa(x,jb,57704,57696,+h[c[c[B>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);rb=c[C>>2]|0;tb=$a;ub=+h[rb+3072>>3];vb=rb}$a=1.0/tb;tb=+h[vb+3152>>3];jb=+h[vb+3160>>3];J=+h[vb+1616>>3];rb=c[c[B>>2]>>2]|0;eb=+h[(c[rb+8>>2]|0)+12888>>3];ob=(+h[vb+2088>>3]+ +h[vb+2096>>3])*.5;Wa=+h[vb+3120>>3];do{if(ub!=0.0){wb=vb;xb=Wa/ub}else{if(Wa==0.0){wb=vb;xb=Wa;break}pb=Wa/+qXa(c[A>>2]|0,ub,57704,57696,+h[rb>>3],(a[b+319|0]|0)!=0|0);wb=c[C>>2]|0;xb=pb}}while(0);PD(y,x,$a,tb,tb,jb,jb,J,eb,ob,xb,+h[wb+3096>>3]);xb=+h[y>>3];y=c[A>>2]|0;wb=c[C>>2]|0;ob=+h[wb+3072>>3];if(ob!=0.0){yb=ob;zb=ob;Ab=wb}else{eb=+qXa(y,ob,57704,57696,+h[c[c[B>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);wb=c[C>>2]|0;yb=eb;zb=+h[wb+3072>>3];Ab=wb}eb=1.0/yb;yb=+h[Ab+3152>>3];ob=+h[Ab+3160>>3];J=+h[Ab+1624>>3];wb=c[c[B>>2]>>2]|0;jb=+h[(c[wb+8>>2]|0)+12880>>3];tb=(+h[Ab+2096>>3]+ +h[Ab+2104>>3])*.5;$a=+h[Ab+3120>>3];if(zb!=0.0){Bb=Ab;Cb=$a/zb;Db=Bb;Eb=Db+3096|0;Fb=Eb;Gb=+h[Fb>>3];PD(z,y,eb,yb,yb,ob,ob,J,jb,tb,Cb,Gb);Hb=z;Ib=Hb;Jb=+h[Ib>>3];Kb=xb+Jb;Lb=sb+Kb;Mb=nb+Lb;Nb=ib+Mb;Ob=db+Nb;Pb=_a+Ob;Qb=Va+Pb;Rb=Qa+Qb;Sb=La+Rb;Tb=Ga+Sb;Ub=Ba+Tb;Vb=wa+Ub;Wb=ra+Vb;Xb=ma+Wb;Yb=ha+Xb;Zb=ca+Yb;_b=Z+Zb;$b=U+_b;ac=O+$b;bc=c[B>>2]|0;cc=c[bc>>2]|0;dc=cc;ec=dc+8|0;fc=ec;gc=c[fc>>2]|0;hc=gc;ic=hc+14736|0;jc=ic;h[jc>>3]=ac;i=d;return}if($a==0.0){Bb=Ab;Cb=$a;Db=Bb;Eb=Db+3096|0;Fb=Eb;Gb=+h[Fb>>3];PD(z,y,eb,yb,yb,ob,ob,J,jb,tb,Cb,Gb);Hb=z;Ib=Hb;Jb=+h[Ib>>3];Kb=xb+Jb;Lb=sb+Kb;Mb=nb+Lb;Nb=ib+Mb;Ob=db+Nb;Pb=_a+Ob;Qb=Va+Pb;Rb=Qa+Qb;Sb=La+Rb;Tb=Ga+Sb;Ub=Ba+Tb;Vb=wa+Ub;Wb=ra+Vb;Xb=ma+Wb;Yb=ha+Xb;Zb=ca+Yb;_b=Z+Zb;$b=U+_b;ac=O+$b;bc=c[B>>2]|0;cc=c[bc>>2]|0;dc=cc;ec=dc+8|0;fc=ec;gc=c[fc>>2]|0;hc=gc;ic=hc+14736|0;jc=ic;h[jc>>3]=ac;i=d;return}ub=$a/+qXa(c[A>>2]|0,zb,57704,57696,+h[wb>>3],(a[b+319|0]|0)!=0|0);Bb=c[C>>2]|0;Cb=ub;Db=Bb;Eb=Db+3096|0;Fb=Eb;Gb=+h[Fb>>3];PD(z,y,eb,yb,yb,ob,ob,J,jb,tb,Cb,Gb);Hb=z;Ib=Hb;Jb=+h[Ib>>3];Kb=xb+Jb;Lb=sb+Kb;Mb=nb+Lb;Nb=ib+Mb;Ob=db+Nb;Pb=_a+Ob;Qb=Va+Pb;Rb=Qa+Qb;Sb=La+Rb;Tb=Ga+Sb;Ub=Ba+Tb;Vb=wa+Ub;Wb=ra+Vb;Xb=ma+Wb;Yb=ha+Xb;Zb=ca+Yb;_b=Z+Zb;$b=U+_b;ac=O+$b;bc=c[B>>2]|0;cc=c[bc>>2]|0;dc=cc;ec=dc+8|0;fc=ec;gc=c[fc>>2]|0;hc=gc;ic=hc+14736|0;jc=ic;h[jc>>3]=ac;i=d;return}function owa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3176>>3]=+h[b+2968>>3];i=i;return}function pwa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3192>>3]=+h[b+3304>>3];i=i;return}function qwa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3360>>3]=+h[b+3296>>3];i=i;return}function rwa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2792>>3]=+h[b+3360>>3];i=i;return}function swa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2848>>3]=+h[b+2792>>3];i=i;return}function twa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2824>>3]=+h[b+2792>>3];i=i;return}function uwa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2856>>3]=+h[b+2824>>3];i=i;return}function vwa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3368>>3]=+h[b+3304>>3];i=i;return}function wwa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[57736]&1){i=d;return}g=b+420|0;b=E_a(+(c[(c[g>>2]|0)+208>>2]|0),1.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[g>>2]|0)+208>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=RXa(57752,NXa(c[(c[g>>2]|0)+208>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=58040;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[57736]=1;i=d;return}function xwa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[58064]&1){i=d;return}g=b+420|0;b=E_a(+(c[(c[g>>2]|0)+204>>2]|0),1.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[g>>2]|0)+204>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=RXa(58072,NXa(c[(c[g>>2]|0)+204>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=58304;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[58064]=1;i=d;return}function ywa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[58328]&1){i=d;return}g=b+420|0;b=E_a(+(c[(c[g>>2]|0)+200>>2]|0),1.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[g>>2]|0)+200>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=RXa(58336,NXa(c[(c[g>>2]|0)+200>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=58552;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[58328]=1;i=d;return}function zwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[58576]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+3368>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(58592,LXa(+h[(c[g>>2]|0)+3368>>3],58584)|0)|0;g=c[72302]|0;j=e;k=58680;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[58576]=1;i=d;return}function Awa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[58704]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+3360>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(58712,LXa(+h[(c[g>>2]|0)+3360>>3],58584)|0)|0;g=c[72302]|0;j=e;k=58800;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[58704]=1;i=d;return}function Bwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[58824]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+3352>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(58832,LXa(+h[(c[g>>2]|0)+3352>>3],58584)|0)|0;g=c[72302]|0;j=e;k=58928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[58824]=1;i=d;return}function Cwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[58952]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+3344>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(58960,LXa(+h[(c[g>>2]|0)+3344>>3],58584)|0)|0;g=c[72302]|0;j=e;k=59048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[58952]=1;i=d;return}function Dwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[59072]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+3336>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(59080,LXa(+h[(c[g>>2]|0)+3336>>3],58584)|0)|0;g=c[72302]|0;j=e;k=59176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[59072]=1;i=d;return}function Ewa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[59200]&1){i=d;return}g=b+420|0;b=E_a(+(c[(c[g>>2]|0)+196>>2]|0),1.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[g>>2]|0)+196>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=RXa(59208,NXa(c[(c[g>>2]|0)+196>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=59432;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[59200]=1;i=d;return}function Fwa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[59456]&1){i=d;return}g=b+420|0;b=E_a(+(c[(c[g>>2]|0)+192>>2]|0),1.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[g>>2]|0)+192>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=RXa(59464,NXa(c[(c[g>>2]|0)+192>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=59680;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[59456]=1;i=d;return}function Gwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[59704]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+3304>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(59712,LXa(+h[(c[g>>2]|0)+3304>>3],58584)|0)|0;g=c[72302]|0;j=e;k=59808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[59704]=1;i=d;return}function Hwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[59832]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+3296>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(59840,LXa(+h[(c[g>>2]|0)+3296>>3],58584)|0)|0;g=c[72302]|0;j=e;k=59936;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[59832]=1;i=d;return}function Iwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[59960]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+3272>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(59968,LXa(+h[(c[g>>2]|0)+3272>>3],58584)|0)|0;g=c[72302]|0;j=e;k=60128;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[59960]=1;i=d;return}function Jwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[60152]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+2456>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+2456>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(60160,LXa(+h[(c[g>>2]|0)+2456>>3],58584)|0)|0;g=c[72302]|0;j=e;k=61032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[60152]=1;i=d;return}function Kwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[60360]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+3256>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+3256>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(60368,LXa(+h[(c[g>>2]|0)+3256>>3],58584)|0)|0;g=c[72302]|0;j=e;k=61184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[60360]=1;i=d;return}function Lwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[60488]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+3248>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+3248>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(60496,LXa(+h[(c[g>>2]|0)+3248>>3],58584)|0)|0;g=c[72302]|0;j=e;k=61360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[60488]=1;i=d;return}function Mwa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[60640]&1){i=d;return}g=b+420|0;b=E_a(+(c[(c[g>>2]|0)+188>>2]|0),1.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[g>>2]|0)+188>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=RXa(60648,NXa(c[(c[g>>2]|0)+188>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=61640;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[60640]=1;i=d;return}function Nwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[60896]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+2448>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+2448>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(60904,LXa(+h[(c[g>>2]|0)+2448>>3],58584)|0)|0;g=c[72302]|0;j=e;k=61032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[60896]=1;i=d;return}function Owa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[61056]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+3240>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+3240>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(61064,LXa(+h[(c[g>>2]|0)+3240>>3],58584)|0)|0;g=c[72302]|0;j=e;k=61184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[61056]=1;i=d;return}function Pwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[61208]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+3232>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+3232>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(61216,LXa(+h[(c[g>>2]|0)+3232>>3],58584)|0)|0;g=c[72302]|0;j=e;k=61360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[61208]=1;i=d;return}function Qwa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[61384]&1){i=d;return}g=b+420|0;b=E_a(+(c[(c[g>>2]|0)+180>>2]|0),1.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[g>>2]|0)+180>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=RXa(61392,NXa(c[(c[g>>2]|0)+180>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=61640;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[61384]=1;i=d;return}function Rwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[61664]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+2440>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+2440>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(61672,LXa(+h[(c[g>>2]|0)+2440>>3],58584)|0)|0;g=c[72302]|0;j=e;k=62376;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[61664]=1;i=d;return}function Swa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[61784]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+3224>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+3224>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(61792,LXa(+h[(c[g>>2]|0)+3224>>3],58584)|0)|0;g=c[72302]|0;j=e;k=62512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[61784]=1;i=d;return}function Twa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[61896]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+3216>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+3216>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(61904,LXa(+h[(c[g>>2]|0)+3216>>3],58584)|0)|0;g=c[72302]|0;j=e;k=62656;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[61896]=1;i=d;return}function Uwa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[62016]&1){i=d;return}g=b+420|0;b=E_a(+(c[(c[g>>2]|0)+172>>2]|0),1.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[g>>2]|0)+172>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=RXa(62024,NXa(c[(c[g>>2]|0)+172>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=62920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[62016]=1;i=d;return}function Vwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[62256]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+2432>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+2432>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(62264,LXa(+h[(c[g>>2]|0)+2432>>3],58584)|0)|0;g=c[72302]|0;j=e;k=62376;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[62256]=1;i=d;return}function Wwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[62400]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+3208>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+3208>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(62408,LXa(+h[(c[g>>2]|0)+3208>>3],58584)|0)|0;g=c[72302]|0;j=e;k=62512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[62400]=1;i=d;return}function Xwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[62536]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+3200>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+3200>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(62544,LXa(+h[(c[g>>2]|0)+3200>>3],58584)|0)|0;g=c[72302]|0;j=e;k=62656;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[62536]=1;i=d;return}function Ywa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[62680]&1){i=d;return}g=b+420|0;b=E_a(+(c[(c[g>>2]|0)+164>>2]|0),1.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[g>>2]|0)+164>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=RXa(62688,NXa(c[(c[g>>2]|0)+164>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=62920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[62680]=1;i=d;return}function Zwa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[62944]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+3192>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(62952,LXa(+h[(c[g>>2]|0)+3192>>3],58584)|0)|0;g=c[72302]|0;j=e;k=73008;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[62944]=1;i=d;return}function _wa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[63160]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+2104>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(63168,LXa(+h[(c[g>>2]|0)+2104>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[63160]=1;i=d;return}function $wa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[63352]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+2096>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(63360,LXa(+h[(c[g>>2]|0)+2096>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[63352]=1;i=d;return}function axa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[63472]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+2088>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(63480,LXa(+h[(c[g>>2]|0)+2088>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[63472]=1;i=d;return}function bxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[63592]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+2080>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(63600,LXa(+h[(c[g>>2]|0)+2080>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[63592]=1;i=d;return}function cxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[63712]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+2072>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(63720,LXa(+h[(c[g>>2]|0)+2072>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[63712]=1;i=d;return}function dxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[63832]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+2064>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(63840,LXa(+h[(c[g>>2]|0)+2064>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[63832]=1;i=d;return}function exa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[63952]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+2056>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(63960,LXa(+h[(c[g>>2]|0)+2056>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[63952]=1;i=d;return}function fxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[64072]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+2048>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(64080,LXa(+h[(c[g>>2]|0)+2048>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[64072]=1;i=d;return}function gxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[64192]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+2040>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(64200,LXa(+h[(c[g>>2]|0)+2040>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[64192]=1;i=d;return}function hxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[64312]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+2032>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(64320,LXa(+h[(c[g>>2]|0)+2032>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[64312]=1;i=d;return}function ixa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[64432]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+2024>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(64440,LXa(+h[(c[g>>2]|0)+2024>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[64432]=1;i=d;return}function jxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[64552]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+2016>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(64560,LXa(+h[(c[g>>2]|0)+2016>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[64552]=1;i=d;return}function kxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[64672]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+2008>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(64680,LXa(+h[(c[g>>2]|0)+2008>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[64672]=1;i=d;return}function lxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[64792]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+2e3>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(64800,LXa(+h[(c[g>>2]|0)+2e3>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[64792]=1;i=d;return}function mxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[64912]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+1992>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(64920,LXa(+h[(c[g>>2]|0)+1992>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[64912]=1;i=d;return}function nxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[65032]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+1984>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(65040,LXa(+h[(c[g>>2]|0)+1984>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[65032]=1;i=d;return}function oxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[65152]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+1976>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(65160,LXa(+h[(c[g>>2]|0)+1976>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[65152]=1;i=d;return}function pxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[65272]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+1968>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(65280,LXa(+h[(c[g>>2]|0)+1968>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[65272]=1;i=d;return}function qxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[65392]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+1960>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(65400,LXa(+h[(c[g>>2]|0)+1960>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[65392]=1;i=d;return}function rxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[65512]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+1952>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(65520,LXa(+h[(c[g>>2]|0)+1952>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[65512]=1;i=d;return}function sxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[65632]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+3160>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(65640,LXa(+h[(c[g>>2]|0)+3160>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75584;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[65632]=1;i=d;return}function txa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[65760]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+3152>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(65768,LXa(+h[(c[g>>2]|0)+3152>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75744;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[65760]=1;i=d;return}function uxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[65896]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+3144>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+3144>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(65904,LXa(+h[(c[g>>2]|0)+3144>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75960;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[65896]=1;i=d;return}function vxa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[66088]&1){i=d;return}g=b+420|0;b=E_a(+(c[(c[g>>2]|0)+152>>2]|0),1.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[g>>2]|0)+152>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=RXa(66096,NXa(c[(c[g>>2]|0)+152>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=76256;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[66088]=1;i=d;return}function wxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[66360]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+3128>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(66368,LXa(+h[(c[g>>2]|0)+3128>>3],58584)|0)|0;g=c[72302]|0;j=e;k=76408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[66360]=1;i=d;return}function xxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[66488]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+3104>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(66496,LXa(+h[(c[g>>2]|0)+3104>>3],58584)|0)|0;g=c[72302]|0;j=e;k=76560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[66488]=1;i=d;return}function yxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[66616]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+3088>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+3088>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(66624,LXa(+h[(c[g>>2]|0)+3088>>3],58584)|0)|0;g=c[72302]|0;j=e;k=76760;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[66616]=1;i=d;return}function zxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[66792]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+3080>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+3080>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(66800,LXa(+h[(c[g>>2]|0)+3080>>3],58584)|0)|0;g=c[72302]|0;j=e;k=76960;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[66792]=1;i=d;return}function Axa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[66968]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+1464>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+1464>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(66976,LXa(+h[(c[g>>2]|0)+1464>>3],58584)|0)|0;g=c[72302]|0;j=e;k=80112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[66968]=1;i=d;return}function Bxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[67128]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+1456>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+1456>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(67136,LXa(+h[(c[g>>2]|0)+1456>>3],58584)|0)|0;g=c[72302]|0;j=e;k=80112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[67128]=1;i=d;return}function Cxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[67288]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+1448>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+1448>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(67296,LXa(+h[(c[g>>2]|0)+1448>>3],58584)|0)|0;g=c[72302]|0;j=e;k=80112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[67288]=1;i=d;return}function Dxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[67448]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+1440>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+1440>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(67456,LXa(+h[(c[g>>2]|0)+1440>>3],58584)|0)|0;g=c[72302]|0;j=e;k=80112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[67448]=1;i=d;return}function Exa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[67608]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+1432>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+1432>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(67616,LXa(+h[(c[g>>2]|0)+1432>>3],58584)|0)|0;g=c[72302]|0;j=e;k=80112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[67608]=1;i=d;return}function Fxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[67768]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+1424>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+1424>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(67776,LXa(+h[(c[g>>2]|0)+1424>>3],58584)|0)|0;g=c[72302]|0;j=e;k=80112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[67768]=1;i=d;return}function Gxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[67928]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+1416>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+1416>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(67936,LXa(+h[(c[g>>2]|0)+1416>>3],58584)|0)|0;g=c[72302]|0;j=e;k=80112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[67928]=1;i=d;return}function Hxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[68088]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+1408>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+1408>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(68096,LXa(+h[(c[g>>2]|0)+1408>>3],58584)|0)|0;g=c[72302]|0;j=e;k=80112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[68088]=1;i=d;return}function Ixa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[68248]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+1400>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+1400>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(68256,LXa(+h[(c[g>>2]|0)+1400>>3],58584)|0)|0;g=c[72302]|0;j=e;k=80112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[68248]=1;i=d;return}function Jxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[68408]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+1392>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+1392>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(68416,LXa(+h[(c[g>>2]|0)+1392>>3],58584)|0)|0;g=c[72302]|0;j=e;k=80112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[68408]=1;i=d;return}function Kxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[68568]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+1384>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+1384>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(68576,LXa(+h[(c[g>>2]|0)+1384>>3],58584)|0)|0;g=c[72302]|0;j=e;k=80112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[68568]=1;i=d;return}function Lxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[68728]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+1376>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+1376>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(68736,LXa(+h[(c[g>>2]|0)+1376>>3],58584)|0)|0;g=c[72302]|0;j=e;k=80112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[68728]=1;i=d;return}function Mxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[68880]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+1368>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+1368>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(68888,LXa(+h[(c[g>>2]|0)+1368>>3],58584)|0)|0;g=c[72302]|0;j=e;k=80112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[68880]=1;i=d;return}function Nxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[69032]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+1360>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+1360>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(69040,LXa(+h[(c[g>>2]|0)+1360>>3],58584)|0)|0;g=c[72302]|0;j=e;k=80112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[69032]=1;i=d;return}function Oxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[69184]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+1352>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+1352>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(69192,LXa(+h[(c[g>>2]|0)+1352>>3],58584)|0)|0;g=c[72302]|0;j=e;k=80112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[69184]=1;i=d;return}function Pxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[69336]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+1344>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+1344>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(69344,LXa(+h[(c[g>>2]|0)+1344>>3],58584)|0)|0;g=c[72302]|0;j=e;k=80112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[69336]=1;i=d;return}function Qxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[69488]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+1336>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+1336>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(69496,LXa(+h[(c[g>>2]|0)+1336>>3],58584)|0)|0;g=c[72302]|0;j=e;k=80112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[69488]=1;i=d;return}function Rxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[69640]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+1328>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+1328>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(69648,LXa(+h[(c[g>>2]|0)+1328>>3],58584)|0)|0;g=c[72302]|0;j=e;k=80112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[69640]=1;i=d;return}function Sxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[69792]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+1320>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+1320>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(69800,LXa(+h[(c[g>>2]|0)+1320>>3],58584)|0)|0;g=c[72302]|0;j=e;k=80112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[69792]=1;i=d;return}function Txa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[69944]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+1312>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+1312>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(69952,LXa(+h[(c[g>>2]|0)+1312>>3],58584)|0)|0;g=c[72302]|0;j=e;k=80112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[69944]=1;i=d;return}function Uxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[70096]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+3056>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+3056>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(70104,LXa(+h[(c[g>>2]|0)+3056>>3],58584)|0)|0;g=c[72302]|0;j=e;k=80288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[70096]=1;i=d;return}function Vxa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[70248]&1){i=d;return}g=b+420|0;b=E_a(+(c[(c[g>>2]|0)+136>>2]|0),1.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[g>>2]|0)+136>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=RXa(70256,NXa(c[(c[g>>2]|0)+136>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=80552;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[70248]=1;i=d;return}function Wxa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[70488]&1){i=d;return}g=b+420|0;b=E_a(+(c[(c[g>>2]|0)+132>>2]|0),1.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[g>>2]|0)+132>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=RXa(70496,NXa(c[(c[g>>2]|0)+132>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=80824;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[70488]=1;i=d;return}function Xxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[70736]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+1304>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+1304>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(70744,LXa(+h[(c[g>>2]|0)+1304>>3],58584)|0)|0;g=c[72302]|0;j=e;k=80992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[70736]=1;i=d;return}function Yxa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[70880]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+3032>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+3032>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(70888,LXa(+h[(c[g>>2]|0)+3032>>3],58584)|0)|0;g=c[72302]|0;j=e;k=81176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[70880]=1;i=d;return}function Zxa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[71040]&1){i=d;return}g=b+420|0;b=E_a(+(c[(c[g>>2]|0)+124>>2]|0),1.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[g>>2]|0)+124>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=RXa(71048,NXa(c[(c[g>>2]|0)+124>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=81448;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[71040]=1;i=d;return}function _xa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[71288]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+3024>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+3024>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(71296,LXa(+h[(c[g>>2]|0)+3024>>3],58584)|0)|0;g=c[72302]|0;j=e;k=81624;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[71288]=1;i=d;return}function $xa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[71440]&1){i=d;return}g=b+420|0;b=E_a(+(c[(c[g>>2]|0)+120>>2]|0),1.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[g>>2]|0)+120>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=RXa(71448,NXa(c[(c[g>>2]|0)+120>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=81880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[71440]=1;i=d;return}function aya(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[71672]&1){i=d;return}g=b+420|0;b=E_a(+(c[(c[g>>2]|0)+116>>2]|0),1.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[g>>2]|0)+116>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=RXa(71680,NXa(c[(c[g>>2]|0)+116>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=82144;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[71672]=1;i=d;return}function bya(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[71912]&1){i=d;return}g=b+420|0;b=E_a(+(c[(c[g>>2]|0)+100>>2]|0),1.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[g>>2]|0)+100>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=RXa(71920,NXa(c[(c[g>>2]|0)+100>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=82400;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[71912]=1;i=d;return}function cya(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72144]&1){i=d;return}g=b+420|0;if(!((E_a(+(c[(c[g>>2]|0)+96>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=RXa(72152,NXa(c[(c[g>>2]|0)+96>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=82528;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[72144]=1;i=d;return}function dya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72248]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+3016>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+3016>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(72256,LXa(+h[(c[g>>2]|0)+3016>>3],58584)|0)|0;g=c[72302]|0;j=e;k=82712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[72248]=1;i=d;return}function eya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72408]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+3008>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+3008>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(72416,LXa(+h[(c[g>>2]|0)+3008>>3],58584)|0)|0;g=c[72302]|0;j=e;k=82872;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[72408]=1;i=d;return}function fya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72544]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+2992>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(72552,LXa(+h[(c[g>>2]|0)+2992>>3],58584)|0)|0;g=c[72302]|0;j=e;k=83008;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[72544]=1;i=d;return}function gya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72656]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+2984>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(72664,LXa(+h[(c[g>>2]|0)+2984>>3],58584)|0)|0;g=c[72302]|0;j=e;k=83136;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[72656]=1;i=d;return}function hya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72760]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+2968>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(72768,LXa(+h[(c[g>>2]|0)+2968>>3],58584)|0)|0;g=c[72302]|0;j=e;k=83272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[72760]=1;i=d;return}function iya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72872]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+2960>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(72880,LXa(+h[(c[g>>2]|0)+2960>>3],58584)|0)|0;g=c[72302]|0;j=e;k=73008;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[72872]=1;i=d;return}function jya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73032]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+976>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(73040,LXa(+h[(c[g>>2]|0)+976>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[73032]=1;i=d;return}function kya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73152]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+968>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(73160,LXa(+h[(c[g>>2]|0)+968>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[73152]=1;i=d;return}function lya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73272]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+960>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(73280,LXa(+h[(c[g>>2]|0)+960>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[73272]=1;i=d;return}function mya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73392]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+952>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(73400,LXa(+h[(c[g>>2]|0)+952>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[73392]=1;i=d;return}function nya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73512]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+944>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(73520,LXa(+h[(c[g>>2]|0)+944>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[73512]=1;i=d;return}function oya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73632]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+936>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(73640,LXa(+h[(c[g>>2]|0)+936>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[73632]=1;i=d;return}function pya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73752]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+928>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(73760,LXa(+h[(c[g>>2]|0)+928>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[73752]=1;i=d;return}function qya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73872]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+920>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(73880,LXa(+h[(c[g>>2]|0)+920>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[73872]=1;i=d;return}function rya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73992]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+912>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(74e3,LXa(+h[(c[g>>2]|0)+912>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[73992]=1;i=d;return}function sya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[74112]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+904>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(74120,LXa(+h[(c[g>>2]|0)+904>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[74112]=1;i=d;return}



function g_a(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0;l=i;i=i+8|0;m=l;n=i;i=i+16|0;o=a+160|0;p=c[o>>2]|0;q=Wpb(p<<3)|0;if((q|0)==0){db(270752,270584,409,270768)}if((p|0)>0){Aqb(q|0,c[a+344>>2]|0,((p|0)>1?p<<3:8)|0)|0}r=+h[d>>3];p=n;h[k>>3]=+h[b>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n+8|0;h[k>>3]=r;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];kXa(27,0,270784,n);n=m;h[k>>3]=1.0e-9;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];kXa(27,0,270832,m);r=+h[d>>3];s=+h[b>>3];if(!(+U(+(r-s))>1.0e-9)){Xpb(q);t=+h[b>>3];u=+h[d>>3];v=t+u;w=v*.5;i=l;return+w}m=a+4|0;n=a+112|0;p=a+540|0;x=a+344|0;y=a+348|0;z=c[n>>2]|0;A=s;s=r;while(1){r=(s+A)*.5;B=c[c[m>>2]>>2]|0;h[B>>3]=r;if((z|0)>0){C=c[B+8>>2]|0;B=0;do{h[C+(B<<3)>>3]=(+h[e+(B<<3)>>3]+ +h[f+(B<<3)>>3])*.5;B=B+1|0;}while((B|0)<(z|0))}J$a(a)|0;pe[c[(c[p>>2]|0)+40>>2]&127](a)|0;pe[c[(c[p>>2]|0)+28>>2]&127](a)|0;pe[c[(c[p>>2]|0)+32>>2]&127](a)|0;se[c[(c[p>>2]|0)+92>>2]&63](a,c[x>>2]|0,c[c[m>>2]>>2]|0)|0;B=(h_a(a,g,j)|0)==0;C=c[n>>2]|0;D=(C|0)>0;do{if(B){if(D){E=c[(c[c[m>>2]>>2]|0)+8>>2]|0;F=0;do{h[e+(F<<3)>>3]=+h[E+(F<<3)>>3];F=F+1|0;}while((F|0)<(C|0))}h[b>>3]=r;F=c[o>>2]|0;if((F|0)>0){E=c[x>>2]|0;G=c[y>>2]|0;H=0;do{I=E+(H<<3)|0;h[G+(H<<3)>>3]=+h[I>>3];h[I>>3]=+h[q+(H<<3)>>3];H=H+1|0;}while((H|0)<(F|0))}J=+h[d>>3]}else{if(D){F=c[(c[c[m>>2]>>2]|0)+8>>2]|0;H=0;do{h[f+(H<<3)>>3]=+h[F+(H<<3)>>3];H=H+1|0;}while((H|0)<(C|0))}h[d>>3]=r;H=c[o>>2]|0;if((H|0)<=0){J=r;break}Aqb(q|0,c[x>>2]|0,((H|0)>1?H<<3:8)|0)|0;J=r}}while(0);r=+h[b>>3];if(+U(+(J-r))>1.0e-9){z=C;A=r;s=J}else{break}}Xpb(q);t=+h[b>>3];u=+h[d>>3];v=t+u;w=v*.5;i=l;return+w}function h_a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;sXa(b);kXa(27,0,270856,g);g=yXa(d)|0;if((g|0)==0){j=vXa(b)|0;k=(j|0)>0;l=k&1;i=e;return l|0}d=a+344|0;m=a+348|0;a=g;do{g=AXa(a)|0;if(+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]==-1.0){g=AXa(a)|0;if(+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]==1.0){n=7}else{n=5}}else{n=5}do{if((n|0)==5){n=0;g=AXa(a)|0;if(!(+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]==1.0)){break}g=AXa(a)|0;if(+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]==-1.0){n=7}}}while(0);if((n|0)==7){n=0;g=AXa(a)|0;o=c[g>>2]|0;g=AXa(a)|0;p=+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]>0.0?270272:270280;g=AXa(a)|0;q=+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]>0.0?270272:270280;c[f>>2]=o;c[f+4>>2]=p;c[f+8>>2]=q;kXa(27,0,270896,f);tXa(b,AXa(a)|0)}a=zXa(a)|0;}while((a|0)!=0);j=vXa(b)|0;k=(j|0)>0;l=k&1;i=e;return l|0}function i_a(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+8|0;e=d;f=b+315|0;a[f]=0;g=b+540|0;Ee[c[(c[g>>2]|0)+96>>2]&63](b,1)|0;j_a(b);k_a(b);pe[c[(c[g>>2]|0)+36>>2]&127](b)|0;l_a(b,8);h=m_a(b)|0;j=pe[c[(c[g>>2]|0)+100>>2]&127](b)|0;k=b+312|0;if((a[k]|0)==0){l=1;m=j;n=h}else{k_a(b);i=d;return}while(1){if((m|0)==0){if((a[f]|n)<<24>>24==0){o=7;break}}n_a(b);j_a(b);l_a(b,8);pe[c[(c[g>>2]|0)+36>>2]&127](b)|0;if((l|0)>200){o=5;break}h=m_a(b)|0;j=pe[c[(c[g>>2]|0)+100>>2]&127](b)|0;if((a[k]|0)==0){l=l+1|0;m=j;n=h}else{o=7;break}}if((o|0)==5){oXa(c[b+536>>2]|0,270976,e)}else if((o|0)==7){k_a(b);i=d;return}}function j_a(a){a=a|0;var b=0;b=i;Aqb(c[a+356>>2]|0,c[a+352>>2]|0,c[a+164>>2]|0)|0;i=b;return}function k_a(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+164|0;if((c[e>>2]|0)<=0){i=d;return}f=b+352|0;g=b+360|0;b=0;do{a[(c[g>>2]|0)+b|0]=(a[(c[f>>2]|0)+b|0]|0)!=0|0;b=b+1|0;}while((b|0)<(c[e>>2]|0));i=d;return}function l_a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+24|0;f=e;g=i;i=i+8|0;if((c[240080+(d<<2)>>2]|0)==0){i=e;return}kXa(d,1,271400,g);g=b+164|0;if((c[g>>2]|0)>0){h=b+540|0;j=b+352|0;k=b+356|0;b=0;do{l=pe[c[(c[h>>2]|0)+108>>2]&127](b)|0;m=(a[(c[j>>2]|0)+b|0]|0)!=0?84:70;n=pe[c[(c[h>>2]|0)+108>>2]&127](b)|0;o=(a[(c[k>>2]|0)+b|0]|0)!=0?84:70;c[f>>2]=b;c[f+4>>2]=l;c[f+8>>2]=m;c[f+12>>2]=n;c[f+16>>2]=o;kXa(d,0,271424,f);b=b+1|0;}while((b|0)<(c[g>>2]|0))}me[c[60158]&2047](d);i=e;return}function m_a(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+164>>2]|0;if((e|0)<=0){f=0;i=d;return f|0}g=c[b+356>>2]|0;h=c[b+352>>2]|0;b=0;while(1){j=b+1|0;if((a[g+b|0]|0)!=(a[h+b|0]|0)){f=1;k=5;break}if((j|0)<(e|0)){b=j}else{f=0;k=5;break}}if((k|0)==5){i=d;return f|0}return 0}function n_a(a){a=a|0;var b=0,d=0;b=i;d=c[c[a+4>>2]>>2]|0;Aqb(c[a+400>>2]|0,c[d+8>>2]|0,c[a+116>>2]<<3|0)|0;Aqb(c[a+404>>2]|0,c[d+12>>2]|0,c[a+124>>2]<<2|0)|0;Aqb(c[a+408>>2]|0,c[d+16>>2]|0,c[a+128>>2]|0)|0;Aqb(c[a+412>>2]|0,c[d+20>>2]|0,c[a+132>>2]<<2|0)|0;i=b;return}function o_a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=c[a+160>>2]|0;e=c[a+344>>2]|0;if((d|0)>0){f=c[a+348>>2]|0;g=0;do{h[f+(g<<3)>>3]=+h[e+(g<<3)>>3];g=g+1|0;}while((g|0)<(d|0))}se[c[(c[a+540>>2]|0)+92>>2]&63](a,e,c[c[a+4>>2]>>2]|0)|0;i=b;return}function p_a(a){a=a|0;var b=0;b=i;q_a(a);r_a(a);n_a(a);s_a(a);i=b;return}function q_a(b){b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=c[b+136>>2]|0;if((e|0)>0){f=c[b+24>>2]|0;g=c[b+416>>2]|0;j=0;do{h[g+(j<<3)>>3]=+h[f+(j*112|0)+96>>3];j=j+1|0;}while((j|0)<(e|0))}e=b+140|0;if((c[e>>2]|0)>0){j=c[b+28>>2]|0;f=c[b+420>>2]|0;g=0;do{c[f+(g<<2)>>2]=c[j+(g*60|0)+52>>2];g=g+1|0;}while((g|0)<(c[e>>2]|0))}e=b+144|0;if((c[e>>2]|0)>0){g=b+32|0;j=b+424|0;f=0;do{a[(c[j>>2]|0)+f|0]=a[(c[g>>2]|0)+(f*48|0)+42|0]|0;f=f+1|0;}while((f|0)<(c[e>>2]|0))}e=c[b+148>>2]|0;if((e|0)<=0){i=d;return}f=b+36|0;g=b+428|0;b=0;do{c[(c[g>>2]|0)+(b<<2)>>2]=c[(c[f>>2]|0)+(b*52|0)+44>>2];b=b+1|0;}while((b|0)<(e|0));i=d;return}function r_a(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[b+116>>2]|0;if((f|0)>0){g=c[b+8>>2]|0;j=c[e+8>>2]|0;k=0;do{h[j+(k<<3)>>3]=+h[g+(k*112|0)+96>>3];k=k+1|0;}while((k|0)<(f|0))}f=b+124|0;if((c[f>>2]|0)>0){k=c[b+12>>2]|0;g=c[e+12>>2]|0;j=0;do{c[g+(j<<2)>>2]=c[k+(j*60|0)+52>>2];j=j+1|0;}while((j|0)<(c[f>>2]|0))}f=b+128|0;if((c[f>>2]|0)>0){j=b+16|0;k=e+16|0;g=0;do{a[(c[k>>2]|0)+g|0]=a[(c[j>>2]|0)+(g*48|0)+42|0]|0;g=g+1|0;}while((g|0)<(c[f>>2]|0))}f=c[b+132>>2]|0;if((f|0)<=0){i=d;return}g=b+20|0;b=e+20|0;e=0;do{c[(c[b>>2]|0)+(e<<2)>>2]=c[(c[g>>2]|0)+(e*52|0)+44>>2];e=e+1|0;}while((e|0)<(f|0));i=d;return}function s_a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a;if((qYa(c[d>>2]|0)|0)<=1){i=b;return}e=a+4|0;f=a+116|0;g=a+124|0;j=a+128|0;k=a+132|0;a=1;do{l=a+ -1|0;m=c[e>>2]|0;n=c[m+(l<<2)>>2]|0;o=c[m+(a<<2)>>2]|0;h[o>>3]=+h[n>>3];Aqb(c[o+8>>2]|0,c[n+8>>2]|0,c[f>>2]<<3|0)|0;n=c[e>>2]|0;Aqb(c[(c[n+(a<<2)>>2]|0)+12>>2]|0,c[(c[n+(l<<2)>>2]|0)+12>>2]|0,c[g>>2]<<2|0)|0;n=c[e>>2]|0;Aqb(c[(c[n+(a<<2)>>2]|0)+16>>2]|0,c[(c[n+(l<<2)>>2]|0)+16>>2]|0,c[j>>2]|0)|0;n=c[e>>2]|0;Aqb(c[(c[n+(a<<2)>>2]|0)+20>>2]|0,c[(c[n+(l<<2)>>2]|0)+20>>2]|0,c[k>>2]<<2|0)|0;a=a+1|0;}while((a|0)<(qYa(c[d>>2]|0)|0));i=b;return}function t_a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+24|0;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+32|0;p=i;i=i+8|0;q=i;i=i+8|0;if((c[240080+(d<<2)>>2]|0)==0){i=e;return}kXa(d,1,271072,q);q=b+136|0;if((c[q>>2]|0)>0){kXa(d,1,271096,p);if((c[q>>2]|0)>0){p=b+24|0;r=b+416|0;s=0;while(1){t=s+1|0;u=c[p>>2]|0;v=c[u+(s*112|0)+4>>2]|0;w=+h[u+(s*112|0)+96>>3];x=(a[u+(s*112|0)+72|0]|0)!=0?271056:271064;y=+h[(c[r>>2]|0)+(s<<3)>>3];c[o>>2]=t;c[o+4>>2]=v;v=o+8|0;h[k>>3]=w;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];c[o+16>>2]=x;x=o+20|0;h[k>>3]=y;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];kXa(d,0,271112,o);if((t|0)<(c[q>>2]|0)){s=t}else{break}}}me[c[60158]&2047](d)}s=b+140|0;if((c[s>>2]|0)>0){kXa(d,1,271168,n);if((c[s>>2]|0)>0){n=b+28|0;q=b+420|0;o=0;while(1){r=o+1|0;p=c[n>>2]|0;t=c[p+(o*60|0)+4>>2]|0;x=c[p+(o*60|0)+52>>2]|0;v=(a[p+(o*60|0)+48|0]|0)!=0?271056:271064;p=c[(c[q>>2]|0)+(o<<2)>>2]|0;c[m>>2]=r;c[m+4>>2]=t;c[m+8>>2]=x;c[m+12>>2]=v;c[m+16>>2]=p;kXa(d,0,271192,m);if((r|0)<(c[s>>2]|0)){o=r}else{break}}}me[c[60158]&2047](d)}o=b+144|0;if((c[o>>2]|0)>0){kXa(d,1,271248,l);if((c[o>>2]|0)>0){l=b+32|0;s=b+424|0;m=0;while(1){q=m+1|0;n=c[l>>2]|0;r=c[n+(m*48|0)+4>>2]|0;p=(a[n+(m*48|0)+42|0]|0)!=0?271056:271064;v=(a[n+(m*48|0)+40|0]|0)!=0?271056:271064;n=(a[(c[s>>2]|0)+m|0]|0)!=0?271056:271064;c[j>>2]=q;c[j+4>>2]=r;c[j+8>>2]=p;c[j+12>>2]=v;c[j+16>>2]=n;kXa(d,0,271272,j);if((q|0)<(c[o>>2]|0)){m=q}else{break}}}me[c[60158]&2047](d)}m=b+148|0;if((c[m>>2]|0)>0){kXa(d,1,271328,g);if((c[m>>2]|0)>0){g=b+36|0;o=b+428|0;b=0;while(1){j=b+1|0;s=c[g>>2]|0;l=c[s+(b*52|0)+4>>2]|0;q=c[s+(b*52|0)+44>>2]|0;s=c[(c[o>>2]|0)+(b<<2)>>2]|0;c[f>>2]=j;c[f+4>>2]=l;c[f+8>>2]=q;c[f+12>>2]=s;kXa(d,0,271352,f);if((j|0)<(c[m>>2]|0)){b=j}else{break}}}me[c[60158]&2047](d)}me[c[60158]&2047](d);i=e;return}function u_a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a;if((qYa(c[d>>2]|0)|0)<=1){i=b;return}e=a+4|0;f=a+116|0;g=a+124|0;j=a+128|0;k=a+132|0;a=1;do{l=c[e>>2]|0;m=c[l+(a<<2)>>2]|0;n=a+ -1|0;o=c[l+(n<<2)>>2]|0;h[o>>3]=+h[m>>3];Aqb(c[o+8>>2]|0,c[m+8>>2]|0,c[f>>2]<<3|0)|0;m=c[e>>2]|0;Aqb(c[(c[m+(n<<2)>>2]|0)+12>>2]|0,c[(c[m+(a<<2)>>2]|0)+12>>2]|0,c[g>>2]<<2|0)|0;m=c[e>>2]|0;Aqb(c[(c[m+(n<<2)>>2]|0)+16>>2]|0,c[(c[m+(a<<2)>>2]|0)+16>>2]|0,c[j>>2]|0)|0;m=c[e>>2]|0;Aqb(c[(c[m+(n<<2)>>2]|0)+20>>2]|0,c[(c[m+(a<<2)>>2]|0)+20>>2]|0,c[k>>2]<<2|0)|0;a=a+1|0;}while((a|0)<(qYa(c[d>>2]|0)|0));i=b;return}function v_a(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[b+116>>2]|0;if((f|0)>0){g=c[e+8>>2]|0;j=c[b+8>>2]|0;k=0;do{h[j+(k*112|0)+96>>3]=+h[g+(k<<3)>>3];k=k+1|0;}while((k|0)<(f|0))}f=b+124|0;if((c[f>>2]|0)>0){k=c[e+12>>2]|0;g=c[b+12>>2]|0;j=0;do{c[g+(j*60|0)+52>>2]=c[k+(j<<2)>>2];j=j+1|0;}while((j|0)<(c[f>>2]|0))}f=b+128|0;if((c[f>>2]|0)>0){j=e+16|0;k=b+16|0;g=0;do{a[(c[k>>2]|0)+(g*48|0)+42|0]=a[(c[j>>2]|0)+g|0]|0;g=g+1|0;}while((g|0)<(c[f>>2]|0))}f=c[b+132>>2]|0;if((f|0)<=0){i=d;return}g=e+20|0;e=b+20|0;b=0;do{c[(c[e>>2]|0)+(b*52|0)+44>>2]=c[(c[g>>2]|0)+(b<<2)>>2];b=b+1|0;}while((b|0)<(f|0));i=d;return}function w_a(a){a=a|0;var b=0,d=0;b=i;d=c[c[a+4>>2]>>2]|0;h[a+376>>3]=+h[d>>3];Aqb(c[a+384>>2]|0,c[d+8>>2]|0,c[a+116>>2]<<3|0)|0;Aqb(c[a+388>>2]|0,c[d+12>>2]|0,c[a+124>>2]<<2|0)|0;Aqb(c[a+392>>2]|0,c[d+16>>2]|0,c[a+128>>2]|0)|0;Aqb(c[a+396>>2]|0,c[d+20>>2]|0,c[a+132>>2]<<2|0)|0;i=b;return}function x_a(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+32|0;o=b;c[o>>2]=0;p=lYa(3,32)|0;c[o>>2]=p;if((p|0)==0){oXa(c[b+536>>2]|0,271456,m)}m=n;p=b+116|0;q=n+8|0;r=b+536|0;s=b+124|0;t=n+12|0;u=b+128|0;v=n+16|0;w=b+132|0;x=n+20|0;y=n;n=0;do{h[m>>3]=0.0;z=Ypb(c[p>>2]|0,8)|0;c[q>>2]=z;nXa(c[r>>2]|0,(z|0)!=0|0,271512,l);z=Ypb(c[s>>2]|0,4)|0;c[t>>2]=z;nXa(c[r>>2]|0,(z|0)!=0|0,271512,k);z=Ypb(c[u>>2]|0,1)|0;c[v>>2]=z;nXa(c[r>>2]|0,(z|0)!=0|0,271512,j);z=Ypb(c[w>>2]|0,4)|0;c[x>>2]=z;nXa(c[r>>2]|0,(z|0)!=0|0,271512,g);pYa(c[o>>2]|0,y);n=n+1|0;}while(n>>>0<3);n=Ypb(3,4)|0;c[b+4>>2]=n;rYa(c[o>>2]|0,0,n);c[b+8>>2]=Ypb(c[p>>2]|0,112)|0;c[b+12>>2]=Ypb(c[s>>2]|0,60)|0;c[b+16>>2]=Ypb(c[u>>2]|0,48)|0;c[b+20>>2]=Ypb(c[w>>2]|0,52)|0;n=b+136|0;c[b+24>>2]=Ypb(c[n>>2]|0,112)|0;o=c[b+140>>2]|0;c[b+28>>2]=Ypb(o,60)|0;y=c[b+144>>2]|0;c[b+32>>2]=Ypb(y,48)|0;g=c[b+148>>2]|0;c[b+36>>2]=Ypb(g,52)|0;c[b+40>>2]=Ypb(c[b+216>>2]|0,52)|0;c[b+44>>2]=Ypb(c[b+220>>2]|0,52)|0;c[b+48>>2]=Ypb(c[b+224>>2]|0,52)|0;c[b+52>>2]=Ypb(c[b+228>>2]|0,52)|0;x=c[b+104>>2]|0;c[b+108>>2]=Ypb(x,24)|0;h[b+328>>3]=+h[b+240>>3];c[b+336>>2]=Ypb(x,8)|0;c[b+340>>2]=Ypb(x,1)|0;c[b+300>>2]=1;c[b+292>>2]=1;c[b+296>>2]=1;x=c[b+160>>2]|0;c[b+344>>2]=Ypb(x,8)|0;c[b+348>>2]=Ypb(x,8)|0;j=c[b+164>>2]|0;c[b+352>>2]=Ypb(j,1)|0;c[b+356>>2]=Ypb(j,1)|0;c[b+360>>2]=Ypb(j,1)|0;j=Wpb(x<<2)|0;c[b+368>>2]=j;c[b+364>>2]=Wpb(c[b+168>>2]<<3)|0;if((x|0)!=0){v=0;do{c[j+(v<<2)>>2]=v;v=v+1|0;}while(v>>>0<x>>>0)}x=c[p>>2]|0;c[b+384>>2]=Ypb(x,8)|0;p=c[s>>2]|0;c[b+388>>2]=Ypb(p,4)|0;s=c[u>>2]|0;c[b+392>>2]=Ypb(s,1)|0;u=c[w>>2]|0;c[b+396>>2]=Ypb(u,4)|0;c[b+400>>2]=Ypb(x,8)|0;c[b+404>>2]=Ypb(p,4)|0;c[b+408>>2]=Ypb(s,1)|0;c[b+412>>2]=Ypb(u,4)|0;c[b+416>>2]=Ypb(c[n>>2]|0,8)|0;c[b+420>>2]=Ypb(o,4)|0;c[b+424>>2]=Ypb(y,1)|0;c[b+428>>2]=Ypb(g,4)|0;c[b+432>>2]=Ypb(c[b+152>>2]|0,8)|0;c[b+436>>2]=Ypb(c[b+156>>2]|0,8)|0;g=Wpb((c[b+192>>2]|0)*40|0)|0;c[b+484>>2]=g;y=b+540|0;me[c[(c[y>>2]|0)+20>>2]&2047](g);g=Wpb((c[b+196>>2]|0)*80|0)|0;c[b+476>>2]=g;me[c[(c[y>>2]|0)+16>>2]&2047](g);g=Wpb((c[b+200>>2]|0)*80|0)|0;c[b+468>>2]=g;me[c[(c[y>>2]|0)+12>>2]&2047](g);g=Wpb((c[b+204>>2]|0)*48|0)|0;c[b+488>>2]=g;ne[c[(c[y>>2]|0)+24>>2]&255](g,b);c[b+464>>2]=Wpb((c[b+232>>2]|0)*44|0)|0;c[b+76>>2]=0;c[b+80>>2]=0;g=Ypb(c[b+188>>2]|0,4)|0;c[b+320>>2]=g;nXa(c[r>>2]|0,(g|0)!=0|0,271528,f);c[b+512>>2]=100;c[b+516>>2]=Ypb(100,4)|0;c[b+520>>2]=Ypb(100,8)|0;c[b+524>>2]=0;c[b+528>>2]=0;c[b+532>>2]=0;h[b+304>>3]=1.0;a[b+313|0]=0;a[b+312|0]=0;a[b+314|0]=0;f=b+172|0;g=b+316|0;a[g]=0;a[g+1|0]=0;a[g+2|0]=0;a[g+3|0]=0;g=Wpb(c[f>>2]<<2)|0;y=b+504|0;c[y>>2]=g;nXa(c[r>>2]|0,(g|0)!=0|0,271512,e);if((c[f>>2]|0)==0){i=d;return}else{A=0}do{e=lYa(1024,16)|0;c[(c[y>>2]|0)+(A<<2)>>2]=e;A=A+1|0;}while(A>>>0<(c[f>>2]|0)>>>0);i=d;return}function y_a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;d=a+4|0;e=c[d>>2]|0;f=0;do{g=c[e+(f<<2)>>2]|0;Xpb(c[g+8>>2]|0);Xpb(c[g+12>>2]|0);Xpb(c[g+16>>2]|0);Xpb(c[g+20>>2]|0);f=f+1|0;e=c[d>>2]|0}while(f>>>0<3);Xpb(e);mYa(c[a>>2]|0);e=a+116|0;f=a+8|0;d=c[f>>2]|0;if((c[e>>2]|0)==0){h=d}else{g=d;d=0;while(1){QYa(g+(d*112|0)|0);j=d+1|0;k=c[f>>2]|0;if(j>>>0<(c[e>>2]|0)>>>0){d=j;g=k}else{h=k;break}}}Xpb(h);h=a+124|0;g=a+12|0;d=c[g>>2]|0;if((c[h>>2]|0)==0){l=d}else{e=d;d=0;while(1){QYa(e+(d*60|0)|0);f=d+1|0;k=c[g>>2]|0;if(f>>>0<(c[h>>2]|0)>>>0){d=f;e=k}else{l=k;break}}}Xpb(l);l=a+128|0;e=a+16|0;d=c[e>>2]|0;if((c[l>>2]|0)==0){m=d}else{h=d;d=0;while(1){QYa(h+(d*48|0)|0);g=d+1|0;k=c[e>>2]|0;if(g>>>0<(c[l>>2]|0)>>>0){d=g;h=k}else{m=k;break}}}Xpb(m);m=a+132|0;h=a+20|0;d=c[h>>2]|0;if((c[m>>2]|0)==0){n=d}else{l=d;d=0;while(1){QYa(l+(d*52|0)|0);e=d+1|0;k=c[h>>2]|0;if(e>>>0<(c[m>>2]|0)>>>0){d=e;l=k}else{n=k;break}}}Xpb(n);n=a+136|0;l=a+24|0;d=c[l>>2]|0;if((c[n>>2]|0)==0){o=d}else{m=d;d=0;while(1){QYa(m+(d*112|0)|0);h=d+1|0;k=c[l>>2]|0;if(h>>>0<(c[n>>2]|0)>>>0){d=h;m=k}else{o=k;break}}}Xpb(o);o=a+140|0;m=a+28|0;d=c[m>>2]|0;if((c[o>>2]|0)==0){p=d}else{n=d;d=0;while(1){QYa(n+(d*60|0)|0);l=d+1|0;k=c[m>>2]|0;if(l>>>0<(c[o>>2]|0)>>>0){d=l;n=k}else{p=k;break}}}Xpb(p);p=a+144|0;n=a+32|0;d=c[n>>2]|0;if((c[p>>2]|0)==0){q=d}else{o=d;d=0;while(1){QYa(o+(d*48|0)|0);m=d+1|0;k=c[n>>2]|0;if(m>>>0<(c[p>>2]|0)>>>0){d=m;o=k}else{q=k;break}}}Xpb(q);q=a+148|0;o=a+36|0;d=c[o>>2]|0;if((c[q>>2]|0)==0){r=d}else{p=d;d=0;while(1){QYa(p+(d*52|0)|0);n=d+1|0;k=c[o>>2]|0;if(n>>>0<(c[q>>2]|0)>>>0){d=n;p=k}else{r=k;break}}}Xpb(r);r=a+216|0;p=a+40|0;d=c[p>>2]|0;if((c[r>>2]|0)==0){s=d}else{q=d;d=0;while(1){QYa(q+(d*52|0)+12|0);o=d+1|0;k=c[p>>2]|0;if(o>>>0<(c[r>>2]|0)>>>0){d=o;q=k}else{s=k;break}}}Xpb(s);s=a+220|0;q=a+44|0;d=c[q>>2]|0;if((c[s>>2]|0)==0){t=d}else{r=d;d=0;while(1){QYa(r+(d*52|0)+12|0);p=d+1|0;k=c[q>>2]|0;if(p>>>0<(c[s>>2]|0)>>>0){d=p;r=k}else{t=k;break}}}Xpb(t);t=a+224|0;r=a+48|0;d=c[r>>2]|0;if((c[t>>2]|0)==0){u=d}else{s=d;d=0;while(1){QYa(s+(d*52|0)+12|0);q=d+1|0;k=c[r>>2]|0;if(q>>>0<(c[t>>2]|0)>>>0){d=q;s=k}else{u=k;break}}}Xpb(u);u=a+228|0;s=a+52|0;d=c[s>>2]|0;if((c[u>>2]|0)==0){v=d}else{t=d;d=0;while(1){QYa(t+(d*52|0)+12|0);r=d+1|0;k=c[s>>2]|0;if(r>>>0<(c[u>>2]|0)>>>0){d=r;t=k}else{v=k;break}}}Xpb(v);Xpb(c[a+108>>2]|0);Xpb(c[a+336>>2]|0);Xpb(c[a+340>>2]|0);Xpb(c[a+344>>2]|0);Xpb(c[a+348>>2]|0);Xpb(c[a+352>>2]|0);Xpb(c[a+356>>2]|0);Xpb(c[a+360>>2]|0);Xpb(c[a+368>>2]|0);Xpb(c[a+384>>2]|0);Xpb(c[a+388>>2]|0);Xpb(c[a+392>>2]|0);Xpb(c[a+396>>2]|0);Xpb(c[a+400>>2]|0);Xpb(c[a+404>>2]|0);Xpb(c[a+408>>2]|0);Xpb(c[a+412>>2]|0);Xpb(c[a+416>>2]|0);Xpb(c[a+420>>2]|0);Xpb(c[a+424>>2]|0);Xpb(c[a+428>>2]|0);Xpb(c[a+488>>2]|0);Xpb(c[a+484>>2]|0);Xpb(c[a+476>>2]|0);Xpb(c[a+468>>2]|0);Xpb(c[a+464>>2]|0);Xpb(c[a+432>>2]|0);Xpb(c[a+436>>2]|0);Xpb(c[a+320>>2]|0);Xpb(c[a+516>>2]|0);Xpb(c[a+520>>2]|0);odb(a+56|0);v=a+172|0;t=a+504|0;a=c[t>>2]|0;if((c[v>>2]|0)==0){w=a;x=w;Xpb(x);i=b;return}else{y=a;z=0}while(1){mYa(c[y+(z<<2)>>2]|0);a=z+1|0;d=c[t>>2]|0;if(a>>>0<(c[v>>2]|0)>>>0){z=a;y=d}else{w=d;break}}x=w;Xpb(x);i=b;return}function z_a(a){a=+a;var b=0,d=0,e=0.0,f=0;b=i;i=i+8|0;d=b;e=a*1.0e-4;h[33946]=e;f=d;h[k>>3]=e;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];kXa(8,0,271576,d);i=b;return}function A_a(a,b,c){a=+a;b=+b;c=c|0;var d=0,e=0.0,f=0.0,g=0.0;d=c<<24>>24!=0;e=+h[33946];f=e+e*+U(+(d?b:a));if(d){g=f}else{g=-f}i=i;return a-b<=g|0}function B_a(a,b){a=+a;b=+b;i=i;return a<b|0}function C_a(a,b){a=+a;b=+b;i=i;return a<=b|0}function D_a(a,b){a=+a;b=+b;i=i;return a>b|0}function E_a(a,b){a=+a;b=+b;i=i;return a>=b|0}function F_a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;d=b;e=c[a+484>>2]|0;f=a+192|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+296|0;h=0;while(1){j=c[e+(h*40|0)>>2]|0;k=j<<2;c[e+(h*40|0)+20>>2]=Wpb(k)|0;c[e+(h*40|0)+24>>2]=Wpb(k)|0;if((c[g>>2]|0)!=1){l=5;break}I_a(j,e+(h*40|0)+28|0)|0;j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{l=6;break}}if((l|0)==5){oXa(c[a+536>>2]|0,271632,d)}else if((l|0)==6){i=b;return 0}return 0}function G_a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=c[a+484>>2]|0;f=a+192|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+296|0;h=0;while(1){Xpb(c[e+(h*40|0)+20>>2]|0);Xpb(c[e+(h*40|0)+24>>2]|0);if((c[g>>2]|0)!=1){j=5;break}k=e+(h*40|0)+28|0;J_a(k)|0;Xpb(c[k>>2]|0);k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{j=6;break}}if((j|0)==5){oXa(c[a+536>>2]|0,271632,d)}else if((j|0)==6){i=b;return 0}return 0}function H_a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;j=i;i=i+24|0;l=i;i=i+24|0;m=i;i=i+24|0;n=c[b+484>>2]|0;o=b+192|0;p=c[o>>2]|0;if((p|0)<=0){q=0;i=e;return q|0}r=(d|0)==0;d=b+56|0;s=n+4|0;t=j+8|0;u=b+4|0;b=l+12|0;v=m+16|0;w=p;p=0;x=0;while(1){y=(a[n+(p*40|0)+36|0]|0)!=0;do{if(y|r){z=w;A=y?x:1}else{if((c[240148>>2]|c[60018]|0)==0){z=w;A=1;break}mdb(j,d,c[s>>2]|0);B=+h[c[c[u>>2]>>2]>>3];c[g>>2]=c[t>>2];C=g+4|0;h[k>>3]=B;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];mXa(17,1,271664,g);mdb(l,d,c[s>>2]|0);if((c[b>>2]|0)>0){C=0;while(1){D=C+1|0;mdb(m,d,c[s>>2]|0);E=c[(c[(c[v>>2]|0)+(C<<2)>>2]|0)+4>>2]|0;c[f>>2]=D;c[f+4>>2]=E;mXa(17,0,271696,f);mdb(l,d,c[s>>2]|0);if((D|0)<(c[b>>2]|0)){C=D}else{break}}}me[c[60158]&2047](17);z=c[o>>2]|0;A=1}}while(0);y=p+1|0;if((y|0)<(z|0)){w=z;p=y;x=A}else{q=A;break}}i=e;return q|0}function I_a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=i;i=i+8|0;f=Wpb(20)|0;c[b>>2]=f;nXa(0,(f|0)!=0|0,271704,e);e=Wpb(a)|0;c[f>>2]=e;e=Wpb(a)|0;c[f+4>>2]=e;e=Wpb(a)|0;c[f+8>>2]=e;e=Wpb(a)|0;c[f+16>>2]=e;nXa(0,(c[b>>2]|0)!=0|0,271736,d);i=d;return 0}function J_a(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;Xpb(c[d>>2]|0);Xpb(c[d+4>>2]|0);Xpb(c[d+8>>2]|0);Xpb(c[d+16>>2]|0);i=b;return 0}function K_a(a,b){a=a|0;b=b|0;b=i;i=i+8|0;oXa(c[a+536>>2]|0,271784,b);return 0}function L_a(a){a=a|0;a=i;i=i+8|0;oXa(0,271784,a);return 0}function M_a(a,b){a=a|0;b=b|0;b=i;i=i+8|0;oXa(c[a+536>>2]|0,271784,b);return 0}function N_a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=b;e=c[a+476>>2]|0;f=a+196|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+292|0;h=0;while(1){j=c[e+(h<<6)+16>>2]|0;k=c[e+(h<<6)+12>>2]|0;l=j<<3;c[e+(h<<6)+28>>2]=Wpb(l)|0;c[e+(h<<6)+36>>2]=Wpb(l)|0;m=c[g>>2]|0;if((m|0)==1){c[e+(h<<6)+32>>2]=Wpb(fa(l,j)|0)|0;c[e+(h<<6)+8>>2]=1;T_a(j,e+(h<<6)+24|0)|0}else if((m|0)==2){c[e+(h<<6)+8>>2]=2;W_a(j,j,k,e+(h<<6)+24|0)|0}else{n=6;break}k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{n=8;break}}if((n|0)==6){oXa(c[a+536>>2]|0,271824,d)}else if((n|0)==8){i=b;return 0}return 0}function O_a(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;e=(fa(c[f+16>>2]|0,b)|0)+a|0;h[(c[f+32>>2]|0)+(e<<3)>>3]=d;i=i;return}function P_a(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;e=i;yb(0,a|0,b|0,+d,c[c[f+24>>2]>>2]|0)|0;i=e;return}function Q_a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=c[a+476>>2]|0;f=a+196|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+292|0;h=0;while(1){Xpb(c[e+(h<<6)+28>>2]|0);Xpb(c[e+(h<<6)+36>>2]|0);j=c[g>>2]|0;if((j|0)==1){U_a(e+(h<<6)+24|0)|0;Xpb(c[e+(h<<6)+32>>2]|0)}else if((j|0)==2){X_a(e+(h<<6)+24|0)|0}else{k=6;break}Xpb(c[e+(h<<6)+24>>2]|0);j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{k=8;break}}if((k|0)==6){oXa(c[a+536>>2]|0,271824,d)}else if((k|0)==8){i=b;return 0}return 0}function R_a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=c[b+476>>2]|0;h=c[b+292>>2]|0;if((h|0)==1){j=V_a(b,d)|0}else if((h|0)==2){j=Y_a(b,d)|0}else{oXa(c[b+536>>2]|0,271824,f)}a[g+(d<<6)+56|0]=j;i=e;return 0}function S_a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;j=i;i=i+24|0;l=i;i=i+24|0;m=i;i=i+24|0;n=c[b+476>>2]|0;o=b+196|0;p=c[o>>2]|0;if((p|0)<=0){q=0;i=e;return q|0}r=(d|0)==0;d=b+56|0;s=n+20|0;t=j+8|0;u=b+4|0;b=l+12|0;v=m+16|0;w=p;p=0;x=0;while(1){y=(a[n+(p<<6)+56|0]|0)!=0;do{if(y|r){z=w;A=y?x:1}else{if((c[240140>>2]|c[60018]|0)==0){z=w;A=1;break}mdb(j,d,c[s>>2]|0);B=+h[c[c[u>>2]>>2]>>3];c[g>>2]=c[t>>2];C=g+4|0;h[k>>3]=B;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];mXa(15,1,271856,g);mdb(l,d,c[s>>2]|0);if((c[b>>2]|0)>0){C=0;while(1){D=C+1|0;mdb(m,d,c[s>>2]|0);E=c[(c[(c[v>>2]|0)+(C<<2)>>2]|0)+4>>2]|0;c[f>>2]=D;c[f+4>>2]=E;mXa(15,0,271888,f);mdb(l,d,c[s>>2]|0);if((D|0)<(c[b>>2]|0)){C=D}else{break}}}me[c[60158]&2047](15);z=c[o>>2]|0;A=1}}while(0);y=p+1|0;if((y|0)<(z|0)){w=z;p=y;x=A}else{q=A;break}}i=e;return q|0}function T_a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=Wpb(12)|0;f=Wpb(a<<2)|0;c[e>>2]=f;nXa(0,(f|0)!=0|0,271896,d);c[e+4>>2]=1;c[e+8>>2]=0;c[b>>2]=e;i=d;return 0}function U_a(a){a=a|0;var b=0;b=i;Xpb(c[c[a>>2]>>2]|0);i=b;return 0}function V_a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+24|0;m=i;i=i+16|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16384|0;v=i;i=i+4096|0;w=c[b+476>>2]|0;x=w+(d<<6)|0;y=c[w+(d<<6)+24>>2]|0;z=w+(d<<6)+16|0;A=c[z>>2]|0;B=w+(d<<6)+32|0;Cqb(c[B>>2]|0,0,fa(A<<3,A)|0)|0;C=b;D=x;ne[c[x>>2]&255](C,D);ne[c[w+(d<<6)+4>>2]&255](C,D);if((c[240144>>2]|0)!=0){D=u;c[t>>2]=A;c[t+4>>2]=A;kXa(16,1,271952,t);t=(A|0)>0;do{if(t){u=0;do{a[D]=0;C=0;do{x=(fa(C,A)|0)+u|0;E=+h[(c[B>>2]|0)+(x<<3)>>3];c[r>>2]=D;x=r+4|0;h[k>>3]=E;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];lc(D|0,271976,r|0)|0;C=C+1|0;}while((C|0)<(A|0));c[q>>2]=D;kXa(16,0,271992,q);u=u+1|0;}while((u|0)<(A|0));c[p>>2]=A;kXa(16,1,272e3,p);if(!t){break}u=w+(d<<6)+36|0;C=0;do{a[D]=0;E=+h[(c[u>>2]|0)+(C<<3)>>3];c[o>>2]=D;x=o+4|0;h[k>>3]=E;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];lc(D|0,271976,o|0)|0;c[n>>2]=D;kXa(16,0,271992,n);C=C+1|0;}while((C|0)<(A|0))}else{c[s>>2]=A;kXa(16,1,272e3,s)}}while(0);me[c[60158]&2047](16)}s=w+(d<<6)+36|0;A=y+8|0;ZRa(z,y+4|0,c[B>>2]|0,z,c[y>>2]|0,c[s>>2]|0,z,A)|0;y=c[A>>2]|0;if((y|0)<0){E=+h[c[c[b+4>>2]>>2]>>3];c[m>>2]=c[w+(d<<6)+20>>2];A=m+4|0;h[k>>3]=E;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];c[m+12>>2]=y;mXa(1,0,272016,m);F=0;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;Aqb(M|0,O|0,Q|0)|0;i=e;return F|0}if((y|0)<=0){F=1;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;Aqb(M|0,O|0,Q|0)|0;i=e;return F|0}E=+h[c[c[b+4>>2]>>2]>>3];b=y+1|0;c[l>>2]=c[w+(d<<6)+20>>2];y=l+4|0;h[k>>3]=E;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];c[l+12>>2]=b;c[l+16>>2]=b;mXa(1,0,272104,l);if((c[240140>>2]|0)==0){F=0;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;Aqb(M|0,O|0,Q|0)|0;i=e;return F|0}l=v;v=(c[z>>2]|0)>0;a[l]=0;if(v){v=0;do{b=c[z>>2]|0;if((b|0)>0){y=b;m=0;while(1){A=(fa(y,m)|0)+v|0;E=+h[(c[B>>2]|0)+(A<<3)>>3];c[j>>2]=l;A=j+4|0;h[k>>3]=E;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];lc(l|0,272208,j|0)|0;A=m+1|0;n=c[z>>2]|0;if((A|0)<(n|0)){m=A;y=n}else{R=n;break}}}else{R=b}v=v+1|0;a[l]=0}while((v|0)<(R|0))}if((c[z>>2]|0)>0){R=0;do{E=+h[(c[s>>2]|0)+(R<<3)>>3];c[g>>2]=l;v=g+4|0;h[k>>3]=E;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];lc(l|0,272208,g|0)|0;R=R+1|0;}while((R|0)<(c[z>>2]|0))}a[l]=0;if((c[z>>2]|0)>0){S=0}else{F=0;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;Aqb(M|0,O|0,Q|0)|0;i=e;return F|0}while(1){E=+h[(c[s>>2]|0)+(S<<3)>>3];c[f>>2]=l;R=f+4|0;h[k>>3]=E;c[R>>2]=c[k>>2];c[R+4>>2]=c[k+4>>2];lc(l|0,272208,f|0)|0;R=S+1|0;if((R|0)<(c[z>>2]|0)){S=R}else{F=0;break}}G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;Aqb(M|0,O|0,Q|0)|0;i=e;return F|0}function W_a(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=Wpb(32)|0;nXa(0,(g|0)!=0|0,272216,f);c[g+20>>2]=b;b=g+24|0;c[b>>2]=a;c[g+28>>2]=d;d=g+8|0;de(0,d|0)|0;Ud(c[d>>2]|0,c[b>>2]|0,0)|0;de(0,g+4|0)|0;Ud(c[d>>2]|0,c[b>>2]|0,0)|0;b=g+12|0;cb(b|0)|0;Ob(272264,c[b>>2]|0)|0;c[e>>2]=g;i=f;return 0}function X_a(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;Gd(c[d+12>>2]|0)|0;Nb(c[d+8>>2]|0)|0;Nb(c[d+4>>2]|0)|0;i=b;return 0}function Y_a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;d=i;e=c[a+476>>2]|0;f=e+(b<<6)|0;g=c[e+(b<<6)+24>>2]|0;qd(c[g>>2]|0)|0;$d(0,g|0)|0;j=g+24|0;Sb(c[g>>2]|0,c[j>>2]|0,0)|0;k=a;a=f;ne[c[f>>2]&255](k,a);Yc(c[g>>2]|0,1)|0;Va(c[g>>2]|0)|0;ne[c[e+(b<<6)+4>>2]&255](k,a);if((c[j>>2]|0)>0){a=e+(b<<6)+36|0;k=g+8|0;f=k;l=0;while(1){ld(0,l|0,+(+h[(c[a>>2]|0)+(l<<3)>>3]),c[k>>2]|0)|0;m=l+1|0;if((m|0)<(c[j>>2]|0)){l=m}else{n=f;break}}}else{n=g+8|0}f=g+4|0;l=(qc(c[g>>2]|0,c[n>>2]|0,c[f>>2]|0,c[g+12>>2]|0)|0)==0|0;Mb(c[f>>2]|0,0,c[g+20>>2]|0,c[e+(b<<6)+28>>2]|0)|0;qd(c[g>>2]|0)|0;i=d;return l|0}function Z_a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=c[a+468>>2]|0;h=a+200|0;if((c[h>>2]|0)<=0){i=b;return 0}j=a+536|0;k=a;l=a+300|0;m=0;a:while(1){n=g+(m*80|0)|0;o=c[n>>2]|0;nXa(c[j>>2]|0,(c[g+(m*80|0)+32>>2]|0)!=0|0,272432,f);p=g+(m*80|0)+28|0;do{if(!((c[p>>2]|0)==-1)){nXa(c[j>>2]|0,(c[g+(m*80|0)+20>>2]|0)!=0|0,272472,e);if((pe[c[g+(m*80|0)+24>>2]&127](k)|0)==0){break}c[p>>2]=-1}}while(0);p=o<<3;c[g+(m*80|0)+44>>2]=Wpb(p)|0;c[g+(m*80|0)+52>>2]=Wpb(p)|0;c[g+(m*80|0)+48>>2]=Wpb(p)|0;c[g+(m*80|0)+16>>2]=Wpb(p)|0;c[g+(m*80|0)+8>>2]=Wpb(p)|0;c[g+(m*80|0)+12>>2]=Wpb(p)|0;ne[c[g+(m*80|0)+36>>2]&255](k,n);do{if((c[g+(m*80|0)+56>>2]|0)==1){k$a(o,g+(m*80|0)+40|0)|0}else{p=c[l>>2]|0;if((p|0)==2){K_a(a,n)|0;break}else if((p|0)==1){c$a(o,g+(m*80|0)+40|0)|0;break}else if((p|0)==3){k$a(o,g+(m*80|0)+40|0)|0;break}else{q=12;break a}}}while(0);o=m+1|0;if((o|0)<(c[h>>2]|0)){m=o}else{q=14;break}}if((q|0)==12){oXa(c[j>>2]|0,272512,d)}else if((q|0)==14){i=b;return 0}return 0}function __a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=b;e=c[a+468>>2]|0;f=a+200|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+300|0;h=0;a:while(1){j=e+(h*80|0)|0;Xpb(c[e+(h*80|0)+44>>2]|0);Xpb(c[e+(h*80|0)+52>>2]|0);Xpb(c[e+(h*80|0)+48>>2]|0);Xpb(c[e+(h*80|0)+16>>2]|0);Xpb(c[e+(h*80|0)+8>>2]|0);Xpb(c[e+(h*80|0)+12>>2]|0);do{if((c[e+(h*80|0)+56>>2]|0)==1){k=e+(h*80|0)+40|0;l$a(k)|0;l=k}else{k=c[g>>2]|0;if((k|0)==1){m=e+(h*80|0)+40|0;d$a(m)|0;l=m;break}else if((k|0)==2){n=7;break a}else if((k|0)==3){k=e+(h*80|0)+40|0;l$a(k)|0;l=k;break}else{n=9;break a}}}while(0);Xpb(c[l>>2]|0);k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{n=11;break}}if((n|0)==7){L_a(j)|0}else if((n|0)==9){oXa(c[a+536>>2]|0,272512,d)}else if((n|0)==11){i=b;return 0}return 0}function $_a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+8|0;f=e;g=c[b+468>>2]|0;c[b+472>>2]=d;h=b+319|0;a[h]=1;do{if((c[g+(d*80|0)+56>>2]|0)==1){j=(n$a(b,d)|0)&255}else{k=c[b+300>>2]|0;if((k|0)==1){l=b+536|0;m=(c[l>>2]|0)+84|0;n=c[m>>2]|0;c[m>>2]=3;m=e$a(b,d)|0;c[(c[l>>2]|0)+84>>2]=n;j=m&255;break}else if((k|0)==3){j=(n$a(b,d)|0)&255;break}else if((k|0)==2){j=(M_a(b,d)|0)&255;break}else{oXa(c[b+536>>2]|0,272512,f)}}}while(0);a[g+(d*80|0)+72|0]=j;a[h]=0;i=e;return 0}function a$a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0.0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+24|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+8|0;o=i;i=i+24|0;p=i;i=i+24|0;q=i;i=i+24|0;r=i;i=i+24|0;s=i;i=i+24|0;t=i;i=i+24|0;u=c[b+468>>2]|0;v=c[b+200>>2]|0;if((v|0)>0){w=0}else{x=0;i=e;return x|0}while(1){y=w+1|0;if((a[u+(w*80|0)+72|0]|0)==0){break}if((y|0)<(v|0)){w=y}else{x=0;z=22;break}}if((z|0)==22){i=e;return x|0}v=u+(w*80|0)+4|0;w=c[v>>2]|0;u=n;c[u>>2]=1;c[n+4>>2]=w;if((d|0)==0){x=1;i=e;return x|0}d=b+56|0;mdb(o,d,w);A=+h[c[c[b+4>>2]>>2]>>3];c[m>>2]=c[o+8>>2];o=m+4|0;h[k>>3]=A;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];lXa(17,1,u,272544,m);do{if((a[b+312|0]|0)==0){mdb(s,d,c[v>>2]|0);m=s+12|0;if((c[m>>2]|0)<=0){break}u=t+16|0;o=0;while(1){w=o+1|0;mdb(t,d,c[v>>2]|0);n=c[(c[(c[u>>2]|0)+(o<<2)>>2]|0)+4>>2]|0;c[f>>2]=w;c[f+4>>2]=n;mXa(17,0,272744,f);mdb(s,d,c[v>>2]|0);if((w|0)<(c[m>>2]|0)){o=w}else{break}}}else{mXa(17,1,272584,l);mdb(p,d,c[v>>2]|0);o=p+12|0;if((c[o>>2]|0)>0){m=b+116|0;u=r+16|0;w=b+8|0;n=q+16|0;y=0;while(1){a:do{if((c[m>>2]|0)>0){B=y+1|0;C=0;while(1){D=c[(c[w>>2]|0)+(C*112|0)+4>>2]|0;mdb(q,d,c[v>>2]|0);if((uqb(D,c[(c[(c[n>>2]|0)+(y<<2)>>2]|0)+4>>2]|0)|0)==0){break}D=C+1|0;if((D|0)<(c[m>>2]|0)){C=D}else{z=15;break a}}D=c[w>>2]|0;E=c[D+(C*112|0)+4>>2]|0;A=+h[D+(C*112|0)+96>>3];F=+h[D+(C*112|0)+80>>3];c[j>>2]=B;c[j+4>>2]=E;E=j+8|0;h[k>>3]=A;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=j+16|0;h[k>>3]=F;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];mXa(17,0,272664,j);G=y+1|0}else{z=15}}while(0);if((z|0)==15){z=0;E=y+1|0;mdb(r,d,c[v>>2]|0);D=c[(c[(c[u>>2]|0)+(y<<2)>>2]|0)+4>>2]|0;c[g>>2]=E;c[g+4>>2]=D;mXa(17,0,272704,g);G=E}mdb(p,d,c[v>>2]|0);if((G|0)<(c[o>>2]|0)){y=G}else{break}}}if((c[240148>>2]|c[60018]|0)==0){break}me[c[60158]&2047](17)}}while(0);if((c[240148>>2]|c[60018]|0)==0){x=1;i=e;return x|0}me[c[60158]&2047](17);x=1;i=e;return x|0}function b$a(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0.0,j=0.0,k=0.0;e=i;f=c[a+4>>2]|0;g=+h[c[f+4>>2]>>3];j=+h[c[f+8>>2]>>3];if(g==j){k=b;i=e;return+k}k=(b-d)*((+h[c[f>>2]>>3]-j)/(g-j))+d;i=e;return+k}function c$a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+8|0;e=i;i=i+8|0;f=Wpb(144)|0;c[b>>2]=f;nXa(0,(f|0)!=0|0,272760,e);c[f>>2]=0;e=a<<3;g=Wpb(e)|0;c[f+4>>2]=g;g=Wpb(e)|0;c[f+16>>2]=g;c[f+8>>2]=1;g=Wpb(e)|0;c[f+12>>2]=g;c[f+20>>2]=a;g=Wpb(e)|0;c[f+24>>2]=g;g=Ypb(a,8)|0;c[f+28>>2]=g;h[f+32>>3]=1.0e-12;c[f+40>>2]=a*1e4;g=a+ -1|0;c[f+44>>2]=g;c[f+48>>2]=g;h[f+56>>3]=1.0e-12;g=Wpb(e)|0;c[f+64>>2]=g;g=Wpb(e)|0;c[f+68>>2]=g;c[f+72>>2]=1;h[f+80>>3]=100.0;c[f+88>>2]=-1;c[f+92>>2]=0;c[f+96>>2]=0;c[f+100>>2]=0;g=fa(a,a)|0;j=Ypb(g,8)|0;c[f+104>>2]=j;j=Ypb(g,8)|0;c[f+108>>2]=j;c[f+112>>2]=a;j=(fa(a+1|0,a)|0)/2|0;a=Wpb(j<<3)|0;c[f+116>>2]=a;c[f+120>>2]=j;j=Wpb(e)|0;c[f+124>>2]=j;j=Wpb(e)|0;c[f+128>>2]=j;j=Wpb(e)|0;c[f+132>>2]=j;j=Wpb(e)|0;c[f+136>>2]=j;j=Wpb(e)|0;c[f+140>>2]=j;nXa(0,(c[b>>2]|0)!=0|0,272792,d);i=d;return 0}function d$a(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;Xpb(c[d+4>>2]|0);Xpb(c[d+16>>2]|0);Xpb(c[d+12>>2]|0);Xpb(c[d+24>>2]|0);Xpb(c[d+28>>2]|0);Xpb(c[d+64>>2]|0);Xpb(c[d+68>>2]|0);Xpb(c[d+104>>2]|0);Xpb(c[d+108>>2]|0);Xpb(c[d+116>>2]|0);Xpb(c[d+124>>2]|0);Xpb(c[d+128>>2]|0);Xpb(c[d+132>>2]|0);Xpb(c[d+136>>2]|0);Xpb(c[d+140>>2]|0);i=b;return 0}function e$a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0.0,Y=0,Z=0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0.0,ab=0.0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0,kb=0;e=i;i=i+56|0;f=e;g=e+24|0;j=e+48|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+8|0;F=i;i=i+24|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+24|0;N=i;i=i+24|0;O=i;i=i+4096|0;P=i;i=i+24|0;Q=c[b+468>>2]|0;R=c[Q+(d*80|0)+40>>2]|0;S=R;T=c[Q+(d*80|0)+4>>2]|0;c[I>>2]=1;V=R+80|0;W=V;X=+h[V>>3];c[L>>2]=0;Y=b+164|0;Z=Wpb(c[Y>>2]|0)|0;if((c[240148>>2]|0)!=0){mdb(M,b+56|0,T);_=+h[c[c[b+4>>2]>>2]>>3];c[H>>2]=c[M+8>>2];M=H+4|0;h[k>>3]=_;c[M>>2]=c[k>>2];c[M+4>>2]=c[k+4>>2];kXa(17,1,272832,H);H=R+20|0;if((c[H>>2]|0)>0){M=Q+(d*80|0)+44|0;$=Q+(d*80|0)+16|0;aa=Q+(d*80|0)+48|0;ba=Q+(d*80|0)+52|0;ca=0;do{_=+h[(c[M>>2]|0)+(ca<<3)>>3];c[G>>2]=ca;da=G+4|0;h[k>>3]=_;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];kXa(17,1,272888,G);_=+h[(c[aa>>2]|0)+(ca<<3)>>3];ea=+h[(c[ba>>2]|0)+(ca<<3)>>3];da=F;h[k>>3]=+h[(c[$>>2]|0)+(ca<<3)>>3];c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];da=F+8|0;h[k>>3]=_;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];da=F+16|0;h[k>>3]=ea;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];kXa(17,0,272904,F);me[c[60158]&2047](17);ca=ca+1|0;}while((ca|0)<(c[H>>2]|0))}me[c[60158]&2047](17)}H=b+314|0;ca=R+24|0;F=c[ca>>2]|0;if((a[H]|0)==0){Aqb(F|0,c[Q+(d*80|0)+52>>2]|0,c[R+20>>2]<<3|0)|0}else{Aqb(F|0,c[Q+(d*80|0)+44>>2]|0,c[R+20>>2]<<3|0)|0}F=R+20|0;$=F;ba=c[F>>2]|0;if((ba|0)>0){aa=c[ca>>2]|0;G=c[Q+(d*80|0)+16>>2]|0;M=c[R+12>>2]|0;da=0;do{ea=+U(+(+h[aa+(da<<3)>>3]));h[M+(da<<3)>>3]=+Ad(+ea,+(+h[G+(da<<3)>>3]));da=da+1|0;}while((da|0)<(ba|0))}ba=R+8|0;da=(c[ba>>2]|0)!=0;if(da){c[ba>>2]=0}G=R+28|0;M=R+104|0;aa=R+112|0;ga=b;f$a($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;if(da){c[ba>>2]=1}da=b+318|0;ha=R+32|0;ia=R+40|0;ja=R+64|0;ka=R+72|0;la=ka;ma=R+88|0;na=R+92|0;oa=na;pa=R+96|0;qa=pa;ra=R+100|0;sa=R+116|0;ta=R+120|0;ua=R+124|0;va=R+128|0;wa=R+132|0;xa=R+136|0;ya=R+140|0;za=b+56|0;Aa=b+4|0;Ba=Q+(d*80|0)+52|0;Ca=Q+(d*80|0)+44|0;Da=Q+(d*80|0)+48|0;Ea=Q+(d*80|0)+16|0;Q=R+12|0;Fa=b+356|0;Ga=R+4|0;Ha=b+312|0;Ia=R+16|0;Ja=O;O=R+108|0;R=1;ea=1.0e-12;Ka=0;La=0;Ma=0;Na=0;a:while(1){Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[ca>>2]|0;Qa=c[Ea>>2]|0;Ra=c[Q>>2]|0;Sa=0;do{_=+U(+(+h[Pa+(Sa<<3)>>3]));h[Ra+(Sa<<3)>>3]=+Ad(+_,+(+h[Qa+(Sa<<3)>>3]));Sa=Sa+1|0;}while((Sa|0)<(Oa|0))}if((c[240152>>2]|0)!=0){g$a(c[Q>>2]|0,$,18,272944);g$a(c[ca>>2]|0,$,18,272976)}do{if((c[ba>>2]|0)!=0){Oa=c[F>>2]|0;if((Oa|0)<=0){break}Sa=c[Q>>2]|0;Qa=c[ca>>2]|0;Ra=0;do{Pa=Qa+(Ra<<3)|0;h[Pa>>3]=1.0/+h[Sa+(Ra<<3)>>3]*+h[Pa>>3];Ra=Ra+1|0;}while((Ra|0)<(Oa|0))}}while(0);if((c[240152>>2]|0)!=0){g$a(c[ca>>2]|0,$,18,273008)}a[da]=R;vZa(10,$,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,ha,ia,c[ja>>2]|0,la,W,ma,oa,qa,ra,c[sa>>2]|0,ta,c[ua>>2]|0,c[va>>2]|0,c[wa>>2]|0,c[xa>>2]|0,c[ya>>2]|0,ga,d)|0;a[da]=R^1;do{if((c[ba>>2]|0)!=0){Oa=c[F>>2]|0;if((Oa|0)<=0){break}Ra=c[ca>>2]|0;Sa=c[Q>>2]|0;Qa=0;do{Pa=Ra+(Qa<<3)|0;h[Pa>>3]=+h[Pa>>3]*+h[Sa+(Qa<<3)>>3];Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}}while(0);Oa=c[na>>2]|0;if((Oa|0)==0){mdb(N,za,T);_=+h[c[c[Aa>>2]>>2]>>3];Qa=g;Sa=N;c[Qa+0>>2]=c[Sa+0>>2];c[Qa+4>>2]=c[Sa+4>>2];c[Qa+8>>2]=c[Sa+8>>2];c[Qa+12>>2]=c[Sa+12>>2];c[Qa+16>>2]=c[Sa+16>>2];PYa(3,g,_);Ta=c[na>>2]|0}else{Ta=Oa}do{if(!((Ta|0)==-1)){if((a[H]|0)==0){Ua=Ta}else{if((c[ba>>2]|0)==0){a[da]=0;f$a($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0}else{c[ba>>2]=0;a[da]=0;f$a($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;c[ba>>2]=1}j_a(b);Ua=c[na>>2]|0}if((Ua|0)==-1){break}Oa=c[F>>2]|0;if((Oa|0)>0){Sa=c[Ga>>2]|0;Qa=c[G>>2]|0;Ra=c[Ia>>2]|0;Pa=0;Va=0;while(1){Wa=Sa+(Pa<<3)|0;h[Wa>>3]=1.0e-16;Xa=c[O>>2]|0;Ya=(Oa|0)>1?Oa:1;_=1.0e-16;Za=0;_a=Va;while(1){$a=+U(+(+h[Xa+(_a<<3)>>3]));ab=$a>_?$a:_;h[Wa>>3]=ab;bb=Za+1|0;if((bb|0)<(Oa|0)){_a=_a+1|0;Za=bb;_=ab}else{break}}h[Ra+(Pa<<3)>>3]=+h[Qa+(Pa<<3)>>3]*(1.0/ab);Za=Pa+1|0;if((Za|0)<(Oa|0)){Pa=Za;Va=Va+Ya|0}else{break}}}if((c[240152>>2]|0)!=0){kXa(18,1,273048,E);if((c[F>>2]|0)>0){Va=0;do{_=+h[(c[Ia>>2]|0)+(Va<<3)>>3];c[D>>2]=Va;Pa=D+4|0;h[k>>3]=_;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];kXa(18,1,273088,D);_=+h[(c[Ga>>2]|0)+(Va<<3)>>3];c[C>>2]=Va;Pa=C+4|0;h[k>>3]=_;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];kXa(18,0,273120,C);me[c[60158]&2047](18);Va=Va+1|0;}while((Va|0)<(c[F>>2]|0))}me[c[60158]&2047](18)}if((c[240156>>2]|0)!=0){Va=c[F>>2]|0;c[B>>2]=Va;c[B+4>>2]=Va;kXa(19,1,273152,B);if((c[F>>2]|0)>0){Va=0;do{a[Ja]=0;Pa=c[F>>2]|0;if((Pa|0)>0){Oa=Pa;Pa=0;do{Qa=(fa(Oa,Va)|0)+Pa|0;_=+h[(c[O>>2]|0)+(Qa<<3)>>3];c[A>>2]=Ja;Qa=A+4|0;h[k>>3]=_;c[Qa>>2]=c[k>>2];c[Qa+4>>2]=c[k+4>>2];lc(Ja|0,273176,A|0)|0;Pa=Pa+1|0;Oa=c[F>>2]|0;}while((Pa|0)<(Oa|0))}c[z>>2]=Ja;kXa(19,0,273184,z);Va=Va+1|0;}while((Va|0)<(c[F>>2]|0))}me[c[60158]&2047](19)}h[K>>3]=+uZa($,c[Ia>>2]|0);h[J>>3]=+uZa($,c[G>>2]|0)}}while(0);do{if((Ka|0)==0){cb=0}else{if(!(+h[J>>3]>ea)){cb=Ka;break}if(!(+h[K>>3]>ea)){cb=Ka;break}Aqb(c[Fa>>2]|0,Z|0,c[Y>>2]|0)|0;cb=0}}while(0);Va=c[na>>2]|0;_=+h[J>>3];b:do{if((Va|0)<4){do{if(_>ea){if(!(+h[K>>3]>ea)){break}c[na>>2]=4;db=4;break b}}while(0);if((Va|0)==1){eb=68;break a}else{db=Va}}else{db=Va}}while(0);if(_<=ea){eb=68;break}if(+h[K>>3]<=ea){eb=68;break}Va=(db+ -4|0)>>>0<2;if(Va&(La|0)<3){Oa=c[ca>>2]|0;if((a[H]|0)==0){Aqb(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{Aqb(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}$a=+h[V>>3]/10.0;h[V>>3]=$a;Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[240148>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}Pa=w;h[k>>3]=$a;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];kXa(17,0,273232,w);h$a(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<4){Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[Ea>>2]|0;Ya=c[ca>>2]|0;Qa=0;do{Ra=Ya+(Qa<<3)|0;h[Ra>>3]=+h[Pa+(Qa<<3)>>3]*.1+ +h[Ra>>3];Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}h[V>>3]=X;Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[240148>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}kXa(17,0,273304,v);h$a(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<5){Oa=c[ca>>2]|0;if((a[H]|0)==0){Aqb(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{Aqb(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[Da>>2]|0;Pa=c[Ea>>2]|0;Ya=c[Q>>2]|0;Ra=0;do{_=+U(+(+h[Qa+(Ra<<3)>>3]));h[Ya+(Ra<<3)>>3]=+Ad(+_,+(+h[Pa+(Ra<<3)>>3]));Ra=Ra+1|0;}while((Ra|0)<(Oa|0))}Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[240148>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}kXa(17,0,273368,u);h$a(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<6){Oa=c[ca>>2]|0;if((a[H]|0)==0){Aqb(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{Aqb(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}if((c[ba>>2]|0)!=0){c[ba>>2]=0}Oa=c[F>>2]|0;if((Oa|0)>0){Ra=c[ca>>2]|0;Pa=c[Ea>>2]|0;Ya=c[Q>>2]|0;Qa=0;do{_=+U(+(+h[Ra+(Qa<<3)>>3]));h[Ya+(Qa<<3)>>3]=+Ad(+_,+(+h[Pa+(Qa<<3)>>3]));Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[240148>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}kXa(17,0,273440,t);h$a(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}do{if(Va&(La|0)<7){if((a[H]|0)==0){break}Aqb(c[ca>>2]|0,c[Da>>2]|0,c[F>>2]<<3|0)|0;Oa=La+1|0;Aqb(Z|0,c[Fa>>2]|0,c[Y>>2]|0)|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[240148>>2]|0)==0){fb=Na;gb=Ma;hb=ea;R=0;Ka=1;La=Oa;Na=fb;Ma=gb;ea=hb;continue a}kXa(17,0,273504,s);h$a(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;R=0;Ka=1;La=Oa;Na=fb;Ma=gb;ea=hb;continue a}}while(0);if(Va&(Ma|0)<1){Aqb(c[ca>>2]|0,c[Da>>2]|0,c[F>>2]<<3|0)|0;if((c[ba>>2]|0)==0){c[ba>>2]=1}h[V>>3]=X;Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[240148>>2]|0)==0){fb=Na;hb=ea;R=1;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;continue}kXa(17,0,273576,r);h$a(S,L,J,K,18);fb=Na;hb=ea;R=1;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;continue}if(Va&(Ma|0)<2){Oa=c[ca>>2]|0;if((a[H]|0)==0){Aqb(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{Aqb(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[ca>>2]|0;Pa=0;do{Ya=Qa+(Pa<<3)|0;h[Ya>>3]=+h[Ya>>3]*1.01;Pa=Pa+1|0;}while((Pa|0)<(Oa|0))}Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[240148>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}kXa(17,0,273648,q);h$a(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<3){Oa=c[ca>>2]|0;if((a[H]|0)==0){Aqb(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{Aqb(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[ca>>2]|0;Qa=0;do{Ya=Pa+(Qa<<3)|0;h[Ya>>3]=+h[Ya>>3]*.99;Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[240148>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}kXa(17,0,273720,p);h$a(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<4){Aqb(c[ca>>2]|0,c[Ea>>2]|0,c[F>>2]<<3|0)|0;Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[240148>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}kXa(17,0,273784,o);h$a(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<5){Oa=c[ca>>2]|0;if((a[H]|0)==0){Aqb(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{Aqb(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[Ga>>2]|0;Pa=c[ja>>2]|0;Ya=0;do{_=+U(+(+h[Qa+(Ya<<3)>>3]));h[Pa+(Ya<<3)>>3]=!(_<=1.0e-16)?_:1.0e-16;Ya=Ya+1|0;}while((Ya|0)<(Oa|0))}Oa=Ma+1|0;c[ka>>2]=2;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[240148>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}kXa(17,0,273856,n);h$a(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(!(Va&(Na|0)<1)){if(!(Va&(Na|0)<6)){eb=160;break}Oa=c[ca>>2]|0;if((a[H]|0)==0){Aqb(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{Aqb(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}_=ea*10.0;h[V>>3]=X;c[ka>>2]=1;Oa=Na+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[240148>>2]|0)==0){ib=R;ea=_;Ka=cb;La=0;Ma=0;Na=Oa;R=ib;continue}Ya=l;h[k>>3]=_;c[Ya>>2]=c[k>>2];c[Ya+4>>2]=c[k+4>>2];kXa(17,0,273992,l);h$a(S,L,J,K,18);ib=R;ea=_;Ka=cb;La=0;Ma=0;Na=Oa;R=ib;continue}Oa=c[ca>>2]|0;if((a[H]|0)==0){Aqb(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{Aqb(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Ya=c[ja>>2]|0;Pa=0;do{h[Ya+(Pa<<3)>>3]=1.0;Pa=Pa+1|0;}while((Pa|0)<(Oa|0))}c[ba>>2]=1;Oa=Na+1|0;c[ka>>2]=2;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[240148>>2]|0)==0){hb=ea;ib=R;Ka=cb;La=0;Ma=0;Na=Oa;ea=hb;R=ib;continue}kXa(17,0,273920,m);h$a(S,L,J,K,18);hb=ea;ib=R;Ka=cb;La=0;Ma=0;Na=Oa;ea=hb;R=ib}if((eb|0)==68){c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[240148>>2]|0)!=0){kXa(17,1,273192,y);c[x>>2]=La;c[x+4>>2]=Na+Ma;kXa(17,0,273208,x);me[c[60158]&2047](17);h$a(S,L,J,K,17)}x=(c[ba>>2]|0)!=0;if(x){c[ba>>2]=0;jb=x}else{jb=0}Aqb(c[Ca>>2]|0,c[ca>>2]|0,c[F>>2]<<3|0)|0;f$a($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;if(!jb){kb=1;h[V>>3]=X;c[ka>>2]=1;Xpb(Z);i=e;return kb|0}c[ba>>2]=1;kb=1;h[V>>3]=X;c[ka>>2]=1;Xpb(Z);i=e;return kb|0}else if((eb|0)==160){if(!((db+ -2|0)>>>0<4)){kb=0;h[V>>3]=X;c[ka>>2]=1;Xpb(Z);i=e;return kb|0}if((a[Ha]|0)==0){mdb(P,za,T);hb=+h[c[c[Aa>>2]>>2]>>3];Aa=f;T=P;c[Aa+0>>2]=c[T+0>>2];c[Aa+4>>2]=c[T+4>>2];c[Aa+8>>2]=c[T+8>>2];c[Aa+12>>2]=c[T+12>>2];c[Aa+16>>2]=c[T+16>>2];PYa(0,f,hb);}if((c[240148>>2]|0)!=0){c[j>>2]=fa(fa(Ma,La)|0,Na)|0;kXa(17,0,274064,j);h$a(S,L,J,K,17)}Aqb(c[Ca>>2]|0,c[ca>>2]|0,c[F>>2]<<3|0)|0;kb=0;h[V>>3]=X;c[ka>>2]=1;Xpb(Z);i=e;return kb|0}return 0}function f$a(b,d,e,f,g,j,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0;g=i;i=i+8|0;n=g;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16384|0;w=l;x=c[l+468>>2]|0;y=c[x+(m*80|0)+40>>2]|0;z=l+318|0;A=c[j>>2]|0;if((A|0)==1){B=y+8|0;do{if((c[B>>2]|0)!=0){C=c[b>>2]|0;if((C|0)<=0){break}D=c[y+12>>2]|0;E=0;do{F=d+(E<<3)|0;h[F>>3]=+h[F>>3]*+h[D+(E<<3)>>3];E=E+1|0;}while((E|0)<(C|0))}}while(0);if((c[240160>>2]|0)!=0){c[u>>2]=c[y+96>>2];kXa(20,0,274312,u);g$a(d,b,20,274344)}Pe[c[x+(m*80|0)+32>>2]&127](l,d,e,j);if((c[240160>>2]|0)!=0){g$a(e,b,20,274360);c[t>>2]=c[y+96>>2];kXa(20,0,274376,t)}if((c[B>>2]|0)==0){i=g;return 0}B=c[b>>2]|0;if((B|0)<=0){i=g;return 0}t=c[y+12>>2]|0;j=0;do{u=d+(j<<3)|0;h[u>>3]=1.0/+h[t+(j<<3)>>3]*+h[u>>3];j=j+1|0;}while((j|0)<(B|0));i=g;return 0}else if((A|0)==2){B=(a[z]|0)!=0;if(B){a[z]=0}if((c[240160>>2]|0)!=0){kXa(20,0,274416,s)}if((c[x+(m*80|0)+28>>2]|0)==-1){j$a(w,f,d,e,m)}else{i$a(w,f,m)}do{if((c[240160>>2]|0)!=0){kXa(20,0,274456,r);if((c[240156>>2]|0)==0){break}m=v;w=c[b>>2]|0;c[q>>2]=w;c[q+4>>2]=w;kXa(19,1,273152,q);w=c[b>>2]|0;if((w|0)>0){e=y+20|0;d=w;w=0;do{a[m]=0;if((d|0)>0){x=0;do{G=+h[f+((fa(c[e>>2]|0,w)|0)+x<<3)>>3];c[p>>2]=m;s=p+4|0;h[k>>3]=G;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];lc(m|0,274488,p|0)|0;x=x+1|0;}while((x|0)<(c[b>>2]|0))}c[o>>2]=m;kXa(19,0,273184,o);w=w+1|0;d=c[b>>2]|0;}while((w|0)<(d|0))}me[c[60158]&2047](19)}}while(0);if(!B){i=g;return 0}a[z]=1;i=g;return 0}else{g=c[l+536>>2]|0;c[n>>2]=A;oXa(g,274504,n)}return 0}function g$a(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0.0;f=i;i=i+16|0;g=f;j=i;i=i+8|0;if((c[240080+(d<<2)>>2]|0)==0){i=f;return}c[j>>2]=e;kXa(d,1,273184,j);if((c[b>>2]|0)>0){j=0;do{l=+h[a+(j<<3)>>3];c[g>>2]=j;e=g+4|0;h[k>>3]=l;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];kXa(d,0,274296,g);j=j+1|0;}while((j|0)<(c[b>>2]|0))}me[c[60158]&2047](d);i=f;return}function h$a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0;g=i;i=i+24|0;j=g;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+24|0;p=i;i=i+8|0;q=i;i=i+8|0;if((c[240080+(f<<2)>>2]|0)==0){i=g;return}kXa(f,1,274104,q);kXa(f,1,274120,p);p=a+20|0;if((c[p>>2]|0)>0){q=a+24|0;r=a+64|0;s=0;do{t=+h[(c[q>>2]|0)+(s<<3)>>3];u=+h[(c[r>>2]|0)+(s<<3)>>3];c[o>>2]=s;v=o+4|0;h[k>>3]=t;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];v=o+12|0;h[k>>3]=u;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];kXa(f,0,274136,o);s=s+1|0;}while((s|0)<(c[p>>2]|0))}me[c[60158]&2047](f);kXa(f,1,274176,n);if((c[p>>2]|0)>0){n=a+28|0;s=a+4|0;a=0;do{u=+h[(c[n>>2]|0)+(a<<3)>>3];t=+h[(c[s>>2]|0)+(a<<3)>>3];c[m>>2]=a;o=m+4|0;h[k>>3]=u;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=m+12|0;h[k>>3]=t;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];kXa(f,0,274192,m);a=a+1|0;}while((a|0)<(c[p>>2]|0))}me[c[60158]&2047](f);kXa(f,1,274232,l);t=+h[d>>3];u=+h[e>>3];c[j>>2]=c[b>>2];b=j+4|0;h[k>>3]=t;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=j+12|0;h[k>>3]=u;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];kXa(f,0,274248,j);me[c[60158]&2047](f);me[c[60158]&2047](f);i=g;return}function i$a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0;e=i;f=c[a+468>>2]|0;g=c[f+(d*80|0)+40>>2]|0;j=c[f+(d*80|0)+28>>2]|0;k=g+20|0;l=c[k>>2]|0;Cqb(b|0,0,fa(l<<3,l)|0)|0;l=g+108|0;g=c[k>>2]|0;Cqb(c[l>>2]|0,0,fa(g<<3,g)|0)|0;g=a+464|0;k=c[g>>2]|0;if((c[k+(j*44|0)+24>>2]|0)==0){i=e;return}m=f+(d*80|0)+20|0;d=a;a=c[k+(j*44|0)>>2]|0;f=k;k=0;do{if((a|0)!=0){n=0;do{if(((c[(c[f+(j*44|0)+20>>2]|0)+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[f+(j*44|0)+28>>2]|0)+(n<<3)>>3]=1.0}n=n+1|0;}while(n>>>0<a>>>0)}pe[c[m>>2]&127](d)|0;f=c[g>>2]|0;a=c[f+(j*44|0)>>2]|0;if((a|0)!=0){n=c[f+(j*44|0)+20>>2]|0;o=c[f+(j*44|0)+28>>2]|0;p=0;do{q=o+(p<<3)|0;do{if(+h[q>>3]==1.0){if((p|0)==0){r=f+(j*44|0)+8|0;s=0}else{t=f+(j*44|0)+8|0;r=t;s=c[(c[t>>2]|0)+(p+ -1<<2)>>2]|0}t=c[(c[r>>2]|0)+(p<<2)>>2]|0;if(!(s>>>0<t>>>0)){break}u=c[l>>2]|0;v=c[f+(j*44|0)+12>>2]|0;w=c[f+(j*44|0)+4>>2]|0;x=c[f+(j*44|0)+36>>2]|0;y=s;do{z=c[v+(y<<2)>>2]|0;A=(fa(w,p)|0)+z|0;B=+h[x+(z<<3)>>3];h[b+(A<<3)>>3]=B;h[u+(A<<3)>>3]=B;y=y+1|0;}while(y>>>0<t>>>0)}}while(0);if(((c[n+(p<<2)>>2]|0)+ -1|0)==(k|0)){h[q>>3]=0.0}p=p+1|0;}while(p>>>0<a>>>0)}k=k+1|0;}while(k>>>0<(c[f+(j*44|0)+24>>2]|0)>>>0);i=e;return}function j$a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0;g=i;i=i+8|0;j=g;k=c[(c[a+468>>2]|0)+(f*80|0)+40>>2]|0;l=k+56|0;m=+h[l>>3];n=+V(+m);c[j>>2]=1;o=k+20|0;p=o;if((c[o>>2]|0)<=0){i=g;return}q=k+128|0;r=k+108|0;s=k+112|0;k=a;t=m;a=0;while(1){m=+h[e+(a<<3)>>3];u=t*m;v=d+(a<<3)|0;w=+h[v>>3];if(!(w>=0.0)){x=-w}else{x=w}if(!(u>=0.0)){y=-u}else{y=u}u=+Ad(+(n*+Ad(+x,+y)),+n);if(!(m>=0.0)){z=-u}else{z=u}u=z+w-w;m=1.0/u;h[v>>3]=w+u;f$a(p,d,c[q>>2]|0,c[r>>2]|0,s,j,k,f)|0;A=c[o>>2]|0;if((A|0)>0){B=c[q>>2]|0;C=c[r>>2]|0;D=0;do{E=(fa(A,a)|0)+D|0;u=m*(+h[B+(D<<3)>>3]- +h[e+(D<<3)>>3]);h[b+(E<<3)>>3]=u;h[C+(E<<3)>>3]=u;D=D+1|0;}while((D|0)<(A|0))}h[v>>3]=w;D=a+1|0;if((D|0)>=(A|0)){break}t=+h[l>>3];a=D}i=g;return}function k$a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=i;i=i+8|0;f=Wpb(80)|0;c[b>>2]=f;nXa(0,(f|0)!=0|0,274584,e);c[f>>2]=0;e=a<<3;g=Wpb(e)|0;c[f+4>>2]=g;g=Wpb(e)|0;c[f+8>>2]=g;c[f+12>>2]=a;g=Wpb(e)|0;c[f+16>>2]=g;g=Ypb(a,8)|0;c[f+20>>2]=g;h[f+24>>3]=1.0e-8;h[f+32>>3]=1.0e-8;c[f+44>>2]=a*100;h[f+56>>3]=2.220446049250313e-16;g=Wpb(fa(e,a)|0)|0;c[f+64>>2]=g;g=Wpb(e)|0;c[f+68>>2]=g;g=Wpb(a<<2)|0;c[f+72>>2]=g;nXa(0,(c[b>>2]|0)!=0|0,274616,d);i=d;return 0}function l$a(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;Xpb(c[d+4>>2]|0);Xpb(c[d+8>>2]|0);Xpb(c[d+16>>2]|0);Xpb(c[d+20>>2]|0);Xpb(c[d+64>>2]|0);Xpb(c[d+68>>2]|0);Xpb(c[d+72>>2]|0);i=b;return 0}function m$a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=c[a+468>>2]|0;g=c[f+(d*80|0)+28>>2]|0;j=c[(c[f+(d*80|0)+40>>2]|0)+12>>2]|0;Cqb(b|0,0,fa(j<<3,j)|0)|0;j=a+464|0;k=c[j>>2]|0;if((c[k+(g*44|0)+24>>2]|0)==0){i=e;return 0}l=f+(d*80|0)+20|0;d=a;a=c[k+(g*44|0)>>2]|0;f=k;k=0;do{if((a|0)!=0){m=0;do{if(((c[(c[f+(g*44|0)+20>>2]|0)+(m<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[f+(g*44|0)+28>>2]|0)+(m<<3)>>3]=1.0}m=m+1|0;}while(m>>>0<a>>>0)}pe[c[l>>2]&127](d)|0;f=c[j>>2]|0;a=c[f+(g*44|0)>>2]|0;if((a|0)!=0){m=c[f+(g*44|0)+20>>2]|0;n=c[f+(g*44|0)+28>>2]|0;o=0;do{p=n+(o<<3)|0;do{if(+h[p>>3]==1.0){if((o|0)==0){q=f+(g*44|0)+8|0;r=0}else{s=f+(g*44|0)+8|0;q=s;r=c[(c[s>>2]|0)+(o+ -1<<2)>>2]|0}s=c[(c[q>>2]|0)+(o<<2)>>2]|0;if(!(r>>>0<s>>>0)){break}t=c[f+(g*44|0)+12>>2]|0;u=c[f+(g*44|0)+4>>2]|0;v=c[f+(g*44|0)+36>>2]|0;w=r;do{x=c[t+(w<<2)>>2]|0;y=(fa(u,o)|0)+x|0;h[b+(y<<3)>>3]=+h[v+(x<<3)>>3];w=w+1|0;}while(w>>>0<s>>>0)}}while(0);if(((c[m+(o<<2)>>2]|0)+ -1|0)==(k|0)){h[p>>3]=0.0}o=o+1|0;}while(o>>>0<a>>>0)}k=k+1|0;}while(k>>>0<(c[f+(g*44|0)+24>>2]|0)>>>0);i=e;return 0}function n$a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0.0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;e=i;i=i+72|0;f=e;g=e+24|0;j=e+48|0;l=i;i=i+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+24|0;r=i;i=i+24|0;s=i;i=i+8|0;t=i;i=i+24|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+24|0;x=i;i=i+24|0;y=i;i=i+24|0;z=c[b+468>>2]|0;A=c[z+(d*80|0)+40>>2]|0;B=c[z+(d*80|0)+4>>2]|0;C=A+40|0;D=C;c[C>>2]=0;E=A+16|0;F=z+(d*80|0)+52|0;G=A+12|0;H=G;Aqb(c[E>>2]|0,c[F>>2]|0,c[G>>2]<<3|0)|0;I=b+56|0;if((c[240148>>2]|0)==0){J=b+4|0}else{mdb(w,I,B);K=b+4|0;L=+h[c[c[K>>2]>>2]>>3];c[v>>2]=c[w+8>>2];w=v+4|0;h[k>>3]=L;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];kXa(17,1,274656,v);if((c[G>>2]|0)>0){v=z+(d*80|0)+44|0;w=z+(d*80|0)+16|0;M=z+(d*80|0)+48|0;N=0;do{L=+h[(c[v>>2]|0)+(N<<3)>>3];c[u>>2]=N;O=u+4|0;h[k>>3]=L;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];kXa(17,1,274728,u);L=+h[(c[M>>2]|0)+(N<<3)>>3];P=+h[(c[F>>2]|0)+(N<<3)>>3];O=t;h[k>>3]=+h[(c[w>>2]|0)+(N<<3)>>3];c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=t+8|0;h[k>>3]=L;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=t+16|0;h[k>>3]=P;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];kXa(17,0,274744,t);me[c[60158]&2047](17);N=N+1|0;}while((N|0)<(c[G>>2]|0))}me[c[60158]&2047](17);J=K}K=b+318|0;N=A+20|0;t=A+24|0;w=A+56|0;F=A+44|0;M=A+64|0;u=A+68|0;v=A+72|0;O=A+48|0;Q=O;R=b;b=A+4|0;S=A+32|0;A=z+(d*80|0)+48|0;T=z+(d*80|0)+16|0;U=0;V=0;a:while(1){a[K]=1;W=c[E>>2]|0;X=c[N>>2]|0;Y=c[M>>2]|0;Z=c[u>>2]|0;_=c[v>>2]|0;c[k>>2]=c[t>>2];c[k+4>>2]=c[t+4>>2];o$a(H,W,X,+h[k>>3],w,c[F>>2]|0,D,Y,Z,_,Q,R,d);a[K]=0;if((c[O>>2]|0)==0){mdb(x,I,B);P=+h[c[c[J>>2]>>2]>>3];_=g;Z=x;c[_+0>>2]=c[Z+0>>2];c[_+4>>2]=c[Z+4>>2];c[_+8>>2]=c[Z+8>>2];c[_+12>>2]=c[Z+12>>2];c[_+16>>2]=c[Z+16>>2];PYa(3,g,P);}$=+uZa(H,c[b>>2]|0);aa=+uZa(H,c[N>>2]|0);P=+h[S>>3];if(!(!(aa<=P)&!($<=P))){if((c[O>>2]|0)>0){ba=12;break}}do{if((V|0)<1){Aqb(c[E>>2]|0,c[A>>2]|0,c[G>>2]<<3|0)|0;Z=c[C>>2]|0;kXa(17,0,274920,p);ca=Z}else{if((V|0)<2){Z=c[G>>2]|0;if((Z|0)>0){_=c[T>>2]|0;Y=c[E>>2]|0;X=0;do{W=Y+(X<<3)|0;h[W>>3]=+h[_+(X<<3)>>3]*.01+ +h[W>>3];X=X+1|0;}while((X|0)<(Z|0))}Z=c[C>>2]|0;kXa(17,0,274976,o);ca=Z;break}if((V|0)>=3){ba=28;break a}Z=c[G>>2]|0;if((Z|0)>0){X=c[T>>2]|0;_=c[E>>2]|0;Y=0;do{h[_+(Y<<3)>>3]=+h[X+(Y<<3)>>3];Y=Y+1|0;}while((Y|0)<(Z|0))}Z=c[C>>2]|0;kXa(17,0,275040,n);ca=Z}}while(0);U=ca+U|0;V=V+1|0}do{if((ba|0)==12){if((c[240148>>2]|0)==0){da=1;break}ca=(c[C>>2]|0)+U|0;c[s>>2]=V;kXa(17,0,274792,s);c[r>>2]=ca;ca=r+4|0;h[k>>3]=aa;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];ca=r+12|0;h[k>>3]=$;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];kXa(17,0,274832,r);if((c[G>>2]|0)>0){ea=0}else{da=1;break}while(1){P=+h[(c[E>>2]|0)+(ea<<3)>>3];L=+h[(c[N>>2]|0)+(ea<<3)>>3];c[q>>2]=ea;ca=q+4|0;h[k>>3]=P;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];ca=q+12|0;h[k>>3]=L;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];kXa(17,0,274888,q);ca=ea+1|0;if((ca|0)<(c[G>>2]|0)){ea=ca}else{da=1;break}}}else if((ba|0)==28){mdb(y,I,B);L=+h[c[c[J>>2]>>2]>>3];ca=f;n=y;c[ca+0>>2]=c[n+0>>2];c[ca+4>>2]=c[n+4>>2];c[ca+8>>2]=c[n+8>>2];c[ca+12>>2]=c[n+12>>2];c[ca+16>>2]=c[n+16>>2];PYa(0,f,L);if((c[240148>>2]|0)==0){da=0;break}c[m>>2]=V;kXa(17,0,275120,m);c[l>>2]=U;n=l+4|0;h[k>>3]=aa;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=l+12|0;h[k>>3]=$;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];kXa(17,0,274832,l);if((c[240148>>2]|0)==0){da=0;break}if((c[G>>2]|0)>0){fa=0}else{da=0;break}while(1){L=+h[(c[E>>2]|0)+(fa<<3)>>3];P=+h[(c[N>>2]|0)+(fa<<3)>>3];c[j>>2]=fa;n=j+4|0;h[k>>3]=L;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=j+12|0;h[k>>3]=P;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];kXa(17,0,274888,j);n=fa+1|0;if((n|0)<(c[G>>2]|0)){fa=n}else{da=0;break}}}}while(0);if((c[240148>>2]|0)==0){ga=z;ha=d*80|0;ia=ga+ha|0;ja=ia+44|0;ka=ja;la=c[ka>>2]|0;ma=la;na=c[E>>2]|0;oa=na;pa=c[G>>2]|0;qa=pa<<3;Aqb(ma|0,oa|0,qa|0)|0;i=e;return da|0}me[c[60158]&2047](17);ga=z;ha=d*80|0;ia=ga+ha|0;ja=ia+44|0;ka=ja;la=c[ka>>2]|0;ma=la;na=c[E>>2]|0;oa=na;pa=c[G>>2]|0;qa=pa<<3;Aqb(ma|0,oa|0,qa|0)|0;i=e;return da|0}function o$a(b,d,e,f,g,j,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0;s=i;i=i+8|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+4096|0;E=q;F=c[q+468>>2]|0;G=c[F+(r*80|0)+40>>2]|0;H=+h[G+32>>3];c[B>>2]=1;c[C>>2]=1;do{if((c[240152>>2]|0)!=0){c[z>>2]=j;kXa(18,0,275160,z);if((c[b>>2]|0)>0){I=0}else{break}do{J=+h[d+(I<<3)>>3];c[y>>2]=I;K=y+4|0;h[k>>3]=J;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];kXa(18,0,275208,y);I=I+1|0;}while((I|0)<(c[b>>2]|0))}}while(0);c[p>>2]=1;I=F+(r*80|0)+28|0;F=D;D=G+12|0;y=G+8|0;z=G+4|0;K=G+20|0;L=G+64|0;G=j;a:while(1){p$a(d,e,A,q,r)|0;c[l>>2]=(c[l>>2]|0)+1;if((c[I>>2]|0)==-1){q$a(b,d,e,m,+h[g>>3],A,n,q,r);c[l>>2]=(c[b>>2]|0)+(c[l>>2]|0)}else{m$a(E,m,r)|0}if((c[240156>>2]|0)!=0){j=c[b>>2]|0;c[x>>2]=j;c[x+4>>2]=j;kXa(19,1,275224,x);if((c[D>>2]|0)>0){j=0;do{a[F]=0;if((c[D>>2]|0)>0){M=0;do{J=+h[m+((fa(c[b>>2]|0,j)|0)+M<<3)>>3];c[w>>2]=F;N=w+4|0;h[k>>3]=J;c[N>>2]=c[k>>2];c[N+4>>2]=c[k+4>>2];lc(F|0,275248,w|0)|0;M=M+1|0;}while((M|0)<(c[D>>2]|0))}c[v>>2]=F;kXa(19,0,275256,v);j=j+1|0;}while((j|0)<(c[D>>2]|0))}me[c[60158]&2047](19)}j=c[D>>2]|0;if((j|0)>0){M=c[z>>2]|0;N=c[K>>2]|0;O=c[y>>2]|0;P=0;Q=0;while(1){R=M+(P<<3)|0;h[R>>3]=1.0e-16;S=c[L>>2]|0;T=(j|0)>1?j:1;J=1.0e-16;V=0;W=Q;while(1){X=+U(+(+h[S+(W<<3)>>3]));Y=X>J?X:J;h[R>>3]=Y;Z=V+1|0;if((Z|0)<(j|0)){W=W+1|0;V=Z;J=Y}else{break}}h[O+(P<<3)>>3]=+h[N+(P<<3)>>3]*(1.0/Y);V=P+1|0;if((V|0)<(j|0)){P=V;Q=Q+T|0}else{_=O;break}}}else{_=c[y>>2]|0}J=+uZa(b,_);if(!(!(J<=H)&!(+uZa(b,e)<=H))){$=31;break}ZRa(b,B,m,b,o,e,b,C)|0;O=c[C>>2]|0;do{if((O|0)>0){c[p>>2]=-1;mXa(17,0,275264,u)}else{if((O|0)<0){c[p>>2]=-1;c[t>>2]=O;mXa(17,0,275296,t);break}Q=c[b>>2]|0;if((Q|0)>0){P=0;do{j=d+(P<<3)|0;h[j>>3]=+h[j>>3]- +h[e+(P<<3)>>3];P=P+1|0;}while((P|0)<(Q|0))}if(+uZa(b,e)<=f){$=31;break a}}}while(0);if((G|0)<1){$=30;break}if((c[p>>2]|0)>-1){G=G+ -1|0}else{$=31;break}}if(($|0)==30){c[p>>2]=-1;i=s;return}else if(($|0)==31){i=s;return}}function p$a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;g=i;Pe[c[(c[e+468>>2]|0)+(f*80|0)+32>>2]&127](e,a,b,d);i=g;return 0}function q$a(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0;m=i;n=+V(+f);if((c[a>>2]|0)<=0){i=m;return}o=(c[(c[k+468>>2]|0)+(l*80|0)+56>>2]|0)==0;p=0;do{f=+h[b+(p<<3)>>3];if(o){if(!(f>=0.0)){q=-f}else{q=f}r=n*+Ad(1.0,+q);if(!(+h[d+(p<<3)>>3]>=0.0)){s=-r}else{s=r}t=s+f-f}else{t=1.0}u=b+(p<<3)|0;h[u>>3]=t+f;r=1.0/t;p$a(b,j,g,k,l)|0;v=c[a>>2]|0;if((v|0)>0){w=0;do{x=(fa(v,p)|0)+w|0;h[e+(x<<3)>>3]=r*(+h[j+(w<<3)>>3]- +h[d+(w<<3)>>3]);w=w+1|0;}while((w|0)<(v|0))}h[u>>3]=f;p=p+1|0;}while((p|0)<(v|0));i=m;return}function r$a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=c[b+24>>2]|0;if((e|0)==3){f=MZa(a,b)|0;i=d;return f|0}else if((e|0)==1){g=c[a+4>>2]|0;j=c[g+4>>2]|0;t$a(c[g>>2]|0,+h[j>>3],c[j+8>>2]|0,c[a+112>>2]|0,b);f=0;i=d;return f|0}else if((e|0)==4){Ae[c[(c[a+540>>2]|0)+56>>2]&1](a,+h[b+8>>3])|0;h[b>>3]=+h[c[c[a+4>>2]>>2]>>3];f=0;i=d;return f|0}else if((e|0)==2){s$a(a,b);f=0;i=d;return f|0}else{f=1;i=d;return f|0}return 0}function s$a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0;d=i;e=c[c[b+48>>2]>>2]|0;f=c[a+4>>2]|0;g=c[f>>2]|0;j=c[f+4>>2]|0;f=g+8|0;k=c[f>>2]|0;l=a+112|0;m=c[l>>2]|0;n=j+8|0;o=c[n>>2]|0;p=j;j=b+8|0;q=b;h[q>>3]=+h[p>>3]+ +h[j>>3];if((m|0)>0){b=c[e>>2]|0;r=0;do{h[b+(r<<3)>>3]=+h[o+(r+m<<3)>>3];r=r+1|0;}while((r|0)<(m|0))}r=g;g=a+540|0;o=m;b=1;do{if((o|0)>0){s=c[n>>2]|0;t=+h[275328+(b<<3)>>3];u=c[e+(b+ -1<<2)>>2]|0;v=c[f>>2]|0;w=0;while(1){h[v+(w<<3)>>3]=+h[s+(w<<3)>>3]+ +h[j>>3]*t*+h[u+(w<<3)>>3];x=w+1|0;if((x|0)<(o|0)){w=x}else{y=t;break}}}else{y=+h[275328+(b<<3)>>3]}h[r>>3]=+h[p>>3]+y*+h[j>>3];pe[c[(c[g>>2]|0)+28>>2]&127](a)|0;o=c[l>>2]|0;z=(o|0)>0;if(z){w=c[e+(b<<2)>>2]|0;u=0;do{h[w+(u<<3)>>3]=+h[k+(u+m<<3)>>3];u=u+1|0;}while((u|0)<(o|0))}b=b+1|0;}while((b|0)<4);if(!z){A=+h[q>>3];h[r>>3]=A;i=d;return}z=c[n>>2]|0;n=c[f>>2]|0;f=c[e>>2]|0;b=c[e+4>>2]|0;m=c[e+8>>2]|0;k=c[e+12>>2]|0;e=0;do{h[n+(e<<3)>>3]=+h[z+(e<<3)>>3]+(+h[f+(e<<3)>>3]*.16666666666666666+0.0+ +h[b+(e<<3)>>3]*.3333333333333333+ +h[m+(e<<3)>>3]*.3333333333333333+ +h[k+(e<<3)>>3]*.16666666666666666)*+h[j>>3];e=e+1|0;}while((e|0)<(o|0));A=+h[q>>3];h[r>>3]=A;i=d;return}function t$a(a,b,d,e,f){a=a|0;b=+b;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0;g=i;j=f+8|0;k=+h[j>>3];l=k+b;m=f;h[m>>3]=l;if((e|0)<=0){n=l;o=a;p=o;h[p>>3]=n;i=g;return}f=c[a+8>>2]|0;l=k;q=0;while(1){h[f+(q<<3)>>3]=+h[d+(q<<3)>>3]+ +h[d+(q+e<<3)>>3]*l;r=q+1|0;if((r|0)>=(e|0)){break}l=+h[j>>3];q=r}n=+h[m>>3];o=a;p=o;h[p>>3]=n;i=g;return}function u$a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+8|0;f=e;h[d>>3]=+h[b+240>>3];h[d+8>>3]=+h[b+264>>3];h[d+16>>3]=0.0;a[d+28|0]=0;c[d+32>>2]=rXa(4)|0;c[d+36>>2]=0;c[d+40>>2]=0;c[d+44>>2]=0;g=c[d+24>>2]|0;a:do{if((g|0)==2){j=Wpb(8)|0;c[j+4>>2]=4;k=Wpb(20)|0;c[j>>2]=k;l=c[b+112>>2]|0;m=k;k=0;while(1){c[m+(k<<2)>>2]=Ypb(l,8)|0;if((k|0)>=4){break}m=c[j>>2]|0;k=k+1|0}c[d+48>>2]=j;n=0}else if((g|0)==3){k=Wpb(88)|0;kXa(23,0,275360,f);m=KZa(b,d,k)|0;c[d+48>>2]=k;n=m}else if((g|0)==4){m=c[5286]|0;k=Wpb(m<<2)|0;c[68846]=k;if((m|0)<=0){n=0;break}l=c[b+116>>2]|0;o=k;k=0;while(1){c[o+(k<<2)>>2]=Ypb(l,8)|0;p=k+1|0;if((p|0)>=(m|0)){n=0;break a}o=c[68846]|0;k=p}}else{n=0}}while(0);H$a(b)|0;if((c[2]|0)==0){i=e;return n|0}FYa(6);CYa(1);i=e;return n|0}function v$a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=c[b+24>>2]|0;if((e|0)==4){f=c[5286]|0;g=c[68846]|0;if((f|0)>0){h=g;j=0;while(1){Xpb(c[h+(j<<2)>>2]|0);k=j+1|0;l=c[68846]|0;if((k|0)<(f|0)){j=k;h=l}else{m=l;break}}}else{m=g}Xpb(m)}else if((e|0)==3){LZa(c[b+48>>2]|0)|0}else if((e|0)==2){e=b+48|0;b=c[e>>2]|0;m=c[b>>2]|0;if((c[b+4>>2]|0)>-1){b=m;g=0;while(1){Xpb(c[b+(g<<2)>>2]|0);h=c[e>>2]|0;j=c[h>>2]|0;if((g|0)<(c[h+4>>2]|0)){g=g+1|0;b=j}else{n=j;break}}}else{n=m}Xpb(n);Xpb(c[e>>2]|0)}I$a(a)|0;C$a(a);i=d;return 0}function w$a(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;k=i;i=i+8|0;l=k;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+168|0;c[o>>2]=0;p=i;i=i+160|0;q=b+536|0;r=c[q>>2]|0;u=0;pa(1415,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){t=Lqb(c[s>>2]|0,o)|0;if((t|0)==0){fb(s|0,v|0)}J=v}else{t=-1}do{if((t|0)==1){w=0;x=0;y=0;z=0;A=J}else{u=0;sa(97,b|0)|0;s=u;u=0;if((s|0)!=0&(v|0)!=0){B=Lqb(c[s>>2]|0,o)|0;if((B|0)==0){fb(s|0,v|0)}J=v}else{B=-1}if((B|0)==1){w=0;x=0;y=0;z=0;A=J;break}s=b+540|0;u=0;sa(c[(c[s>>2]|0)+40>>2]|0,b|0)|0;C=u;u=0;if((C|0)!=0&(v|0)!=0){D=Lqb(c[C>>2]|0,o)|0;if((D|0)==0){fb(C|0,v|0)}J=v}else{D=-1}if((D|0)==1){w=0;x=0;y=0;z=0;A=J;break}if((a[b+440|0]|0)!=0){u=0;sa(c[(c[s>>2]|0)+44>>2]|0,b|0)|0;C=u;u=0;if((C|0)!=0&(v|0)!=0){E=Lqb(c[C>>2]|0,o)|0;if((E|0)==0){fb(C|0,v|0)}J=v}else{E=-1}if((E|0)==1){w=0;x=0;y=0;z=0;A=J;break}}C=b+240|0;h[c[c[b+4>>2]>>2]>>3]=+h[C>>3];u=0;pa(c[(c[s>>2]|0)+4>>2]|0,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){F=Lqb(c[s>>2]|0,o)|0;if((F|0)==0){fb(s|0,v|0)}J=v}else{F=-1}if((F|0)==1){w=0;x=0;y=0;z=C;A=J;break}u=0;pa(1416,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){G=Lqb(c[s>>2]|0,o)|0;if((G|0)==0){fb(s|0,v|0)}J=v}else{G=-1}if((G|0)==1){w=0;x=0;y=0;z=C;A=J;break}u=0;oa(1,+(+h[b+272>>3]));s=u;u=0;if((s|0)!=0&(v|0)!=0){H=Lqb(c[s>>2]|0,o)|0;if((H|0)==0){fb(s|0,v|0)}J=v}else{H=-1}if((H|0)==1){w=0;x=0;y=0;z=C;A=J;break}c[(c[q>>2]|0)+84>>2]=1;s=p;I=r+80|0;K=c[I>>2]|0;c[I>>2]=p;xqb(p,1,o|0)|0;u=0;L=u;u=0;if((L|0)!=0&(v|0)!=0){M=Lqb(c[L>>2]|0,o)|0;if((M|0)==0){fb(L|0,v|0)}J=v}else{M=-1}if((M|0)==1){w=K;x=I;y=s;z=C;A=J;break}w=K;x=I;y=s;z=C;A=0}}while(0);a:while(1){do{if((A|0)==0){u=0;M=Ja(1,b|0,d|0,e|0,f|0,+g,j|0)|0;p=u;u=0;if((p|0)!=0&(v|0)!=0){N=Lqb(c[p>>2]|0,o)|0;if((N|0)==0){fb(p|0,v|0)}J=v}else{N=-1}if((N|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue a}if((M|0)==0){S=0;T=1;break}u=0;Sa(14,1,0,275392,n|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){U=Lqb(c[M>>2]|0,o)|0;if((U|0)==0){fb(M|0,v|0)}J=v}else{U=-1}if((U|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue a}h[b+248>>3]=+h[z>>3];S=-1;T=1}else{S=0;T=0}}while(0);c[x>>2]=w;u=0;M=u;u=0;if((M|0)!=0&(v|0)!=0){V=Lqb(c[M>>2]|0,o)|0;if((V|0)==0){fb(M|0,v|0)}J=v}else{V=-1}if((V|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}if(T){W=S}else{u=0;Sa(15,2,0,275488,m|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){X=Lqb(c[M>>2]|0,o)|0;if((X|0)==0){fb(M|0,v|0)}J=v}else{X=-1}if((X|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}W=-1}u=0;qa(c[281608>>2]|0,281584,b|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){Y=Lqb(c[M>>2]|0,o)|0;if((Y|0)==0){fb(M|0,v|0)}J=v}else{Y=-1}if((Y|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}u=0;Sa(15,23,0,275544,l|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){Z=Lqb(c[M>>2]|0,o)|0;if((Z|0)==0){fb(M|0,v|0)}J=v}else{Z=-1}if((Z|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}if((c[2]|0)==0){_=26;break}u=0;pa(1417,1);M=u;u=0;if((M|0)!=0&(v|0)!=0){$=Lqb(c[M>>2]|0,o)|0;if(($|0)==0){fb(M|0,v|0)}J=v}else{$=-1}if(($|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R}else{break}}if((_|0)==26){i=k;return W|0}i=k;return W|0}function x$a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0.0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=+h[d>>3];do{if(H>=+h[b+248>>3]){if((c[d+24>>2]|0)==5){break}I=G;h[k>>3]=H;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];kXa(8,0,275640,G);I=b+313|0;a[I]=1;i_a(b);if((c[296980>>2]|0)==0){ne[c[281604>>2]&255](281584,b)}a[I]=0}}while(0);if((e|0)!=0){y$a(Hd(e|0)|0,b)}if((c[240180>>2]|0)==0){i=f;return 0}FYa(0);kXa(25,0,275688,F);kXa(25,1,275712,E);H=+xYa(6);J=+xYa(6);K=J/+xYa(0)*100.0;E=D;h[k>>3]=H;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D+8|0;h[k>>3]=K;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];kXa(25,0,275720,D);K=+xYa(1);H=+xYa(1);J=H/+xYa(0)*100.0;D=C;h[k>>3]=K;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];D=C+8|0;h[k>>3]=J;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];kXa(25,0,275760,C);J=+xYa(2);K=+xYa(2);H=K/+xYa(0)*100.0;C=B;h[k>>3]=J;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=B+8|0;h[k>>3]=H;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];kXa(25,0,275792,B);H=+xYa(3);J=+xYa(3);K=J/+xYa(0)*100.0;B=A;h[k>>3]=H;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=K;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];kXa(25,0,275816,A);K=+xYa(4);H=+xYa(4);J=H/+xYa(0)*100.0;A=z;h[k>>3]=K;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=J;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];kXa(25,0,275856,z);J=+xYa(7);K=+xYa(7);H=K/+xYa(0)*100.0;z=y;h[k>>3]=J;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+8|0;h[k>>3]=H;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];kXa(25,0,275888,y);y=d+24|0;z=(c[y>>2]|0)==5;H=+xYa(0);J=H- +xYa(7);H=J- +xYa(4);J=H- +xYa(3);H=J- +xYa(2);J=H- +xYa(1);H=J- +xYa(6);J=+xYa(0);K=J- +xYa(7);J=K- +xYa(4);K=J- +xYa(3);J=K- +xYa(2);K=J- +xYa(1);J=K- +xYa(6);K=J/+xYa(0)*100.0;if(z){z=w;h[k>>3]=H;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=w+8|0;h[k>>3]=K;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];kXa(25,0,275952,w)}else{w=x;h[k>>3]=H;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=x+8|0;h[k>>3]=K;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];kXa(25,0,275920,x)}K=+xYa(0);H=+xYa(0);J=H/+xYa(0)*100.0;x=v;h[k>>3]=K;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];x=v+8|0;h[k>>3]=J;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];kXa(25,0,275984,v);me[c[60158]&2047](25);kXa(25,1,276008,u);c[t>>2]=c[d+40>>2];kXa(25,0,276016,t);c[s>>2]=c[d+44>>2];kXa(25,0,276040,s);me[c[60158]&2047](25);s=c[y>>2]|0;if((s|0)==3){y=d+48|0;d=c[y>>2]|0;t=c[d+8>>2]|0;u=c[d+4>>2]|0;c[u>>2]=(c[u>>2]|0)+(c[t>>2]|0);d=u+4|0;c[d>>2]=(c[d>>2]|0)+(c[t+4>>2]|0);d=u+8|0;c[d>>2]=(c[d>>2]|0)+(c[t+8>>2]|0);d=u+12|0;c[d>>2]=(c[d>>2]|0)+(c[t+12>>2]|0);d=u+16|0;c[d>>2]=(c[d>>2]|0)+(c[t+16>>2]|0);kXa(25,1,276064,r);c[q>>2]=c[c[(c[y>>2]|0)+4>>2]>>2];kXa(25,0,276080,q);c[p>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+4>>2];kXa(25,0,276096,p);c[o>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+8>>2];kXa(25,0,276128,o);c[n>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+12>>2];kXa(25,0,276160,n);c[m>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+16>>2];kXa(25,0,276184,m);me[c[60158]&2047](25)}else if((s|0)!=5){kXa(25,1,276216,l);kXa(25,0,276224,j);me[c[60158]&2047](25)}kXa(25,0,276288,g);CYa(0);i=f;return 0}function y$a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+16|0;y=i;i=i+8|0;z=$b(b|0,276760)|0;b=c[t>>2]|0;A=d+4|0;B=y;h[k>>3]=+h[c[c[A>>2]>>2]>>3];c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];Dd(b|0,276768,y|0)|0;if((z|0)==0){C=Zd(10,b|0)|0;D=Bd(b|0)|0;i=e;return}y=d+116|0;B=d+124|0;E=d+128|0;F=d+132|0;G=d+216|0;H=d+220|0;I=d+224|0;J=d+228|0;K=d+136|0;L=d+140|0;M=d+144|0;N=d+148|0;O=d+36|0;P=d+428|0;Q=d+32|0;R=d+424|0;S=d+28|0;T=d+420|0;U=d+24|0;V=d+416|0;W=d+52|0;X=d+48|0;Y=d+44|0;Z=d+40|0;_=d+20|0;$=d+16|0;aa=d+12|0;ba=d+8|0;d=z;do{z=c[y>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((uqb(d,c[(c[ba>>2]|0)+(z*112|0)+4>>2]|0)|0)==0){da=+h[(c[(c[c[A>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];c[x>>2]=d;ea=x+4|0;h[k>>3]=da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];Dd(b|0,276784,x|0)|0;fa=c[y>>2]|0}else{fa=ca}ea=z+1|0;if((ea|0)<(fa|0)){ca=fa;z=ea}else{break}}}z=c[B>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((uqb(d,c[(c[aa>>2]|0)+(z*60|0)+4>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(z<<2)>>2]|0;c[w>>2]=d;c[w+4>>2]=ea;Dd(b|0,276800,w|0)|0;ga=c[B>>2]|0}else{ga=ca}ea=z+1|0;if((ea|0)<(ga|0)){ca=ga;z=ea}else{break}}}z=c[E>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((uqb(d,c[(c[$>>2]|0)+(z*48|0)+4>>2]|0)|0)==0){ea=a[(c[(c[c[A>>2]>>2]|0)+16>>2]|0)+z|0]|0;c[v>>2]=d;c[v+4>>2]=ea;Dd(b|0,276808,v|0)|0;ha=c[E>>2]|0}else{ha=ca}ea=z+1|0;if((ea|0)<(ha|0)){ca=ha;z=ea}else{break}}}z=c[F>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((uqb(d,c[(c[_>>2]|0)+(z*52|0)+4>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+20>>2]|0)+(z<<2)>>2]|0;c[u>>2]=d;c[u+4>>2]=ea;Dd(b|0,276816,u|0)|0;ia=c[F>>2]|0}else{ia=ca}ea=z+1|0;if((ea|0)<(ia|0)){ca=ia;z=ea}else{break}}}if((c[G>>2]|0)>0){z=0;do{ca=c[Z>>2]|0;do{if((uqb(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){da=+h[(c[(c[c[A>>2]>>2]|0)+8>>2]|0)+(c[ca+(z*52|0)+4>>2]<<3)>>3];if((c[ca+(z*52|0)>>2]|0)==0){c[r>>2]=d;ea=r+4|0;h[k>>3]=da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];Dd(b|0,276784,r|0)|0;break}else{c[s>>2]=d;ea=s+4|0;h[k>>3]=-da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];Dd(b|0,276784,s|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[G>>2]|0))}if((c[H>>2]|0)>0){z=0;do{ca=c[Y>>2]|0;do{if((uqb(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(c[ca+(z*52|0)+4>>2]<<2)>>2]|0;if((c[ca+(z*52|0)>>2]|0)==0){c[p>>2]=d;c[p+4>>2]=ea;Dd(b|0,276800,p|0)|0;break}else{c[q>>2]=d;c[q+4>>2]=0-ea;Dd(b|0,276800,q|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[H>>2]|0))}if((c[I>>2]|0)>0){z=0;do{ca=c[X>>2]|0;do{if((uqb(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){ea=a[(c[(c[c[A>>2]>>2]|0)+16>>2]|0)+(c[ca+(z*52|0)+4>>2]|0)|0]|0;if((c[ca+(z*52|0)>>2]|0)==0){c[n>>2]=d;c[n+4>>2]=ea;Dd(b|0,276808,n|0)|0;break}else{c[o>>2]=d;c[o+4>>2]=0-ea;Dd(b|0,276808,o|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[I>>2]|0))}z=c[J>>2]|0;if((z|0)>0){ca=z;z=0;while(1){ea=c[W>>2]|0;if((uqb(d,c[ea+(z*52|0)+16>>2]|0)|0)==0){ja=c[(c[(c[c[A>>2]>>2]|0)+20>>2]|0)+(c[ea+(z*52|0)+4>>2]<<2)>>2]|0;c[m>>2]=d;c[m+4>>2]=ja;Dd(b|0,276816,m|0)|0;ka=c[J>>2]|0}else{ka=ca}ja=z+1|0;if((ja|0)<(ka|0)){ca=ka;z=ja}else{break}}}z=c[K>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((uqb(d,c[(c[U>>2]|0)+(z*112|0)+4>>2]|0)|0)==0){da=+h[(c[V>>2]|0)+(z<<3)>>3];c[l>>2]=d;ja=l+4|0;h[k>>3]=da;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];Dd(b|0,276784,l|0)|0;la=c[K>>2]|0}else{la=ca}ja=z+1|0;if((ja|0)<(la|0)){ca=la;z=ja}else{break}}}z=c[L>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((uqb(d,c[(c[S>>2]|0)+(z*60|0)+4>>2]|0)|0)==0){ja=c[(c[T>>2]|0)+(z<<2)>>2]|0;c[j>>2]=d;c[j+4>>2]=ja;Dd(b|0,276800,j|0)|0;ma=c[L>>2]|0}else{ma=ca}ja=z+1|0;if((ja|0)<(ma|0)){ca=ma;z=ja}else{break}}}z=c[M>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((uqb(d,c[(c[Q>>2]|0)+(z*48|0)+4>>2]|0)|0)==0){ja=a[(c[R>>2]|0)+z|0]|0;c[g>>2]=d;c[g+4>>2]=ja;Dd(b|0,276808,g|0)|0;na=c[M>>2]|0}else{na=ca}ja=z+1|0;if((ja|0)<(na|0)){ca=na;z=ja}else{break}}}z=c[N>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((uqb(d,c[(c[O>>2]|0)+(z*52|0)+4>>2]|0)|0)==0){ja=c[(c[P>>2]|0)+(z<<2)>>2]|0;c[f>>2]=d;c[f+4>>2]=ja;Dd(b|0,276816,f|0)|0;oa=c[N>>2]|0}else{oa=ca}ja=z+1|0;if((ja|0)<(oa|0)){ca=oa;z=ja}else{break}}}d=$b(0,276760)|0;}while((d|0)!=0);C=Zd(10,b|0)|0;D=Bd(b|0)|0;i=e;return}function z$a(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0;m=i;i=i+16|0;n=m;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+56|0;t=s;u=s+24|0;c[u>>2]=j;a:do{switch(j|0){case 11:case 10:case 9:case 6:case 7:case 8:{mXa(1,0,276312,r);v=1;i=m;return v|0};case 4:{w=c[5284]|0;if((w|0)!=0){if((uqb(w,276424)|0)==0){break a}}kXa(23,0,276440,p);v=1;i=m;return v|0};case 17:case 16:case 15:case 14:case 13:case 12:{c[u>>2]=3;break};case 5:{mXa(1,0,276384,q);v=1;i=m;return v|0};case 18:{w=c[5284]|0;do{if((w|0)!=0){if((uqb(w,276568)|0)!=0){break}c[u>>2]=4;break a}}while(0);kXa(23,0,276592,o);v=1;i=m;return v|0};default:{}}}while(0);o=u$a(a,s)|0;Je[c[240980>>2]&7]()|0;do{if((o|0)==0){q=w$a(a,b,d,e,f,g)|0;Je[c[240980>>2]&7]()|0;if((q|0)!=0){x=q;break}if((c[u>>2]|0)!=5){ne[c[281604>>2]&255](281584,a);s_a(a)}y=+h[a+248>>3];q=n;h[k>>3]=+h[a+240>>3];c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];q=n+8|0;h[k>>3]=y;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];kXa(23,0,276720,n);q=Ee[c[c[a+540>>2]>>2]&63](a,t)|0;Je[c[240980>>2]&7]()|0;x$a(a,s,l)|0;Je[c[240980>>2]&7]()|0;x=q}else{Je[c[240980>>2]&7]()|0;x=o}}while(0);v$a(a,s)|0;v=x;i=m;return v|0}function A$a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=a+204|0;if((c[e>>2]|0)<=0){B$a(a);i=b;return}f=a+488|0;g=a;h=0;while(1){j=h+1|0;if((pe[c[(c[f>>2]|0)+(h*48|0)+40>>2]&127](g)|0)!=0){k=5;break}if((j|0)<(c[e>>2]|0)){h=j}else{k=6;break}}if((k|0)==5){oXa(c[a+536>>2]|0,276832,d)}else if((k|0)==6){B$a(a);i=b;return}}function B$a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;d=a+204|0;if((c[d>>2]|0)<=0){i=b;return}e=a+488|0;f=a+12|0;g=a+4|0;a=0;do{h=c[e>>2]|0;j=(c[c[h+(a*48|0)+12>>2]>>2]|0)-(c[c[f>>2]>>2]|0)|0;k=c[(c[c[g>>2]>>2]|0)+12>>2]|0;l=h+(a*48|0)|0;m=h+(a*48|0)+4|0;Cqb(k+(j<<2)|0,0,fa(c[l>>2]<<2,c[m>>2]|0)|0)|0;n=h+(a*48|0)+8|0;if((c[n>>2]|0)>0){o=c[h+(a*48|0)+16>>2]|0;p=0;do{c[o+(p<<2)>>2]=p;p=p+1|0;}while((p|0)<(c[n>>2]|0))}n=c[l>>2]|0;if((n|0)>0){p=c[h+(a*48|0)+20>>2]|0;o=n;n=0;do{c[p+(n<<2)>>2]=o+~n;n=n+1|0;o=c[l>>2]|0;}while((n|0)<(o|0))}o=c[m>>2]|0;if((o|0)>0){n=o;o=0;do{c[k+(o+j+(fa(n,o)|0)<<2)>>2]=1;o=o+1|0;n=c[m>>2]|0;}while((o|0)<(n|0))}a=a+1|0;}while((a|0)<(c[d>>2]|0));i=b;return}function C$a(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+204|0;if((c[d>>2]|0)<=0){i=b;return}e=a+488|0;a=0;do{f=c[e>>2]|0;Xpb(c[f+(a*48|0)+28>>2]|0);Xpb(c[f+(a*48|0)+32>>2]|0);Xpb(c[f+(a*48|0)+16>>2]|0);Xpb(c[f+(a*48|0)+20>>2]|0);Xpb(c[f+(a*48|0)+24>>2]|0);a=a+1|0;}while((a|0)<(c[d>>2]|0));i=b;return}function D$a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+4096|0;p=b+204|0;if((c[p>>2]|0)<=0){q=0;i=f;return q|0}r=b+488|0;s=d<<24>>24==0;d=(e|0)==0;t=0;u=0;while(1){v=c[r>>2]|0;w=v+(u*48|0)|0;x=Wpb(c[w>>2]<<2)|0;y=v+(u*48|0)+8|0;z=Wpb(c[y>>2]<<2)|0;E$a(b,u);A=v+(u*48|0)+20|0;B=c[A>>2]|0;C=c[w>>2]|0;Aqb(x|0,B|0,C<<2|0)|0;D=v+(u*48|0)+16|0;E=c[D>>2]|0;F=c[y>>2]|0;Aqb(z|0,E|0,F<<2|0)|0;G=v+(u*48|0)+24|0;if(!((JZa(c[G>>2]|0,F,C,E,B)|0)==0|s)){break}B=F$a(x,c[A>>2]|0,c[w>>2]|0,c[y>>2]|0,c[v+(u*48|0)+4>>2]|0,c[v+(u*48|0)+12>>2]|0,c[v+(u*48|0)+28>>2]|0,c[v+(u*48|0)+32>>2]|0,b,e)|0;if(d){Aqb(c[A>>2]|0,x|0,c[w>>2]<<2|0)|0;Aqb(c[D>>2]|0,z|0,c[y>>2]<<2|0)|0}y=(B|0)==0?t:1;Xpb(x);Xpb(z);z=u+1|0;if((z|0)<(c[p>>2]|0)){t=y;u=z}else{q=y;H=15;break}}if((H|0)==15){i=f;return q|0}q=o;o=v+(u*48|0)+44|0;f=c[o>>2]|0;H=b+464|0;t=c[H>>2]|0;p=c[t+(f*44|0)>>2]|0;c[n>>2]=c[t+(f*44|0)+4>>2];c[n+4>>2]=p;c[n+8>>2]=f;mXa(5,1,276888,n);n=c[H>>2]|0;if((c[n+((c[o>>2]|0)*44|0)+4>>2]|0)!=0){f=n;n=0;do{a[q]=0;p=c[f+((c[o>>2]|0)*44|0)>>2]|0;if((p|0)!=0){t=p;p=0;do{d=(fa(t,n)|0)+p|0;I=+h[(c[G>>2]|0)+(d<<3)>>3];c[m>>2]=q;d=m+4|0;h[k>>3]=I;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];lc(q|0,276920,m|0)|0;p=p+1|0;t=c[(c[H>>2]|0)+((c[o>>2]|0)*44|0)>>2]|0;}while(p>>>0<t>>>0)}c[l>>2]=q;mXa(5,0,276928,l);n=n+1|0;f=c[H>>2]|0;}while(n>>>0<(c[f+((c[o>>2]|0)*44|0)+4>>2]|0)>>>0)}if((c[w>>2]|0)<=0){J=240632;K=c[60158]|0;me[K&2047](5);L=b;M=L+536|0;N=M;O=c[N>>2]|0;P=b;Q=P+4|0;R=Q;S=c[R>>2]|0;T=c[S>>2]|0;U=T;V=U;W=+h[V>>3];X=g;Y=X;h[k>>3]=W;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Z=5;_=Z;$=276936;aa=$;oXa(O,aa,g)}o=v+(u*48|0)+32|0;u=0;do{c[j>>2]=c[(c[(c[o>>2]|0)+(u<<2)>>2]|0)+4>>2];mXa(5,0,276928,j);u=u+1|0;}while((u|0)<(c[w>>2]|0));J=240632;K=c[60158]|0;me[K&2047](5);L=b;M=L+536|0;N=M;O=c[N>>2]|0;P=b;Q=P+4|0;R=Q;S=c[R>>2]|0;T=c[S>>2]|0;U=T;V=U;W=+h[V>>3];X=g;Y=X;h[k>>3]=W;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Z=5;_=Z;$=276936;aa=$;oXa(O,aa,g);return 0}function E$a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;e=a+488|0;f=c[e>>2]|0;g=c[f+(b*48|0)+44>>2]|0;j=a+464|0;k=c[j>>2]|0;l=c[f+(b*48|0)+24>>2]|0;Cqb(l|0,0,fa(c[k+(g*44|0)+4>>2]<<3,c[k+(g*44|0)>>2]|0)|0)|0;k=c[j>>2]|0;if((c[k+(g*44|0)+24>>2]|0)==0){i=d;return}f=a;a=c[k+(g*44|0)>>2]|0;m=k;k=0;do{if((a|0)!=0){n=0;do{if(((c[(c[m+(g*44|0)+20>>2]|0)+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[m+(g*44|0)+28>>2]|0)+(n<<3)>>3]=1.0}n=n+1|0;}while(n>>>0<a>>>0)}pe[c[(c[e>>2]|0)+(b*48|0)+36>>2]&127](f)|0;m=c[j>>2]|0;a=c[m+(g*44|0)>>2]|0;do{if((a|0)!=0){n=c[m+(g*44|0)+28>>2]|0;o=0;do{do{if(+h[n+(o<<3)>>3]==1.0){if((o|0)==0){p=m+(g*44|0)+8|0;q=0}else{r=m+(g*44|0)+8|0;p=r;q=c[(c[r>>2]|0)+(o+ -1<<2)>>2]|0}r=c[(c[p>>2]|0)+(o<<2)>>2]|0;if(!(q>>>0<r>>>0)){break}s=c[m+(g*44|0)+12>>2]|0;t=c[m+(g*44|0)+4>>2]|0;u=c[m+(g*44|0)+36>>2]|0;v=q;do{w=c[s+(v<<2)>>2]|0;x=(fa(t,o)|0)+w|0;h[l+(x<<3)>>3]=+h[u+(w<<3)>>3];v=v+1|0;}while(v>>>0<r>>>0)}}while(0);o=o+1|0;}while(o>>>0<a>>>0);if((a|0)==0){break}o=c[m+(g*44|0)+20>>2]|0;n=0;do{if(((c[o+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[m+(g*44|0)+28>>2]|0)+(n<<3)>>3]=0.0}n=n+1|0;}while(n>>>0<a>>>0)}}while(0);k=k+1|0;}while(k>>>0<(c[m+(g*44|0)+24>>2]|0)>>>0);i=d;return}function F$a(a,b,d,e,f,g,j,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;o=i;i=i+8|0;p=o;q=Ypb(d,4)|0;r=Ypb(d,4)|0;s=r;t=(d|0)>0;if(t){u=0}else{v=0;Xpb(q);Xpb(r);i=o;return v|0}do{w=(u|0)<(e|0)?1:2;c[r+(c[b+(u<<2)>>2]<<2)>>2]=w;c[q+(c[a+(u<<2)>>2]<<2)>>2]=w;u=u+1|0;}while((u|0)<(d|0));if(t){x=0}else{v=0;Xpb(q);Xpb(r);i=o;return v|0}while(1){t=x+1|0;if((c[r+(x<<2)>>2]|0)!=(c[q+(x<<2)>>2]|0)){break}if((t|0)<(d|0)){x=t}else{v=0;y=9;break}}if((y|0)==9){Xpb(q);Xpb(r);i=o;return v|0}if((n|0)==0){v=-1;Xpb(q);Xpb(r);i=o;return v|0}n=p;h[k>>3]=+h[c[c[m+4>>2]>>2]>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];kXa(5,1,277040,p);G$a(s,d,f,c[g>>2]|0,j,l,m);if((c[240100>>2]|0)==0){v=-1;Xpb(q);Xpb(r);i=o;return v|0}me[c[60158]&2047](5);v=-1;Xpb(q);Xpb(r);i=o;return v|0}function G$a(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;k=i;i=i+8|0;l=k;m=e-(c[c[j+12>>2]>>2]|0)|0;e=j+4|0;n=c[(c[c[e>>2]>>2]|0)+12>>2]|0;Cqb(n+(m<<2)|0,0,fa(b<<2,d)|0)|0;if((b|0)<=0){i=k;return}o=j+8|0;j=0;p=0;while(1){if((c[a+(j<<2)>>2]|0)==2){q=c[c[o>>2]>>2]|0;r=c[g+(j<<2)>>2]|0;s=(c[r>>2]|0)-q|0;t=(c[c[f+(p<<2)>>2]>>2]|0)-q|0;c[l>>2]=c[r+4>>2];kXa(5,0,277072,l);c[n+(p+m+(fa(j,d)|0)<<2)>>2]=1;r=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[r+(t<<3)>>3]=+h[r+(s<<3)>>3];u=p+1|0}else{u=p}s=j+1|0;if((s|0)<(b|0)){j=s;p=u}else{break}}i=k;return}function H$a(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0;d=i;i=i+16|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=mc(277088,277112)|0;o=(n|0)!=0;a[b+440|0]=o&1;if(o){p=0}else{i=d;return 0}a:while(1){while(1){o=Yd(n|0)|0;if((o|0)==-1){break a}else if((o|0)==10){break}}p=p+1|0}o=p+ -1|0;p=b+456|0;c[p>>2]=o;c[b+452>>2]=o;rb(n|0);do{}while((Yd(n|0)|0)!=10);q=c[b+152>>2]|0;r=Ypb(o,4)|0;o=b+444|0;c[o>>2]=r;s=c[p>>2]|0;t=(s|0)>0;b:do{if(t){u=r;v=0;while(1){c[u+(v<<2)>>2]=Ypb(q,8)|0;w=v+1|0;if((w|0)>=(s|0)){break}u=c[o>>2]|0;v=w}v=Ypb(s,8)|0;u=b+448|0;c[u>>2]=v;if(!t){x=u;break}w=(q|0)>0;y=v;v=0;while(1){c[m>>2]=y+(v<<3);z=Za(n|0,277120,m|0)|0;if(w){A=0;while(1){c[l>>2]=(c[(c[o>>2]|0)+(v<<2)>>2]|0)+(A<<3);B=Za(n|0,277120,l|0)|0;C=A+1|0;if((C|0)<(q|0)){A=C}else{D=B;break}}}else{D=z}if((D|0)<0){c[p>>2]=v;E=v}else{E=c[p>>2]|0}A=v+1|0;if((A|0)>=(E|0)){x=u;break b}y=c[u>>2]|0;v=A}}else{v=b+448|0;c[v>>2]=Ypb(s,8)|0;x=v}}while(0);kc(277128,j|0)|0;kc(277184,g|0)|0;if((c[p>>2]|0)>0){g=(q|0)>0;j=0;do{s=f;h[k>>3]=+h[(c[x>>2]|0)+(j<<3)>>3];c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];kc(277144,f|0)|0;if(g){s=0;while(1){E=s+1|0;F=+h[(c[(c[o>>2]|0)+(j<<2)>>2]|0)+(s<<3)>>3];c[e>>2]=E;D=e+4|0;h[k>>3]=F;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];kc(277168,e|0)|0;if((E|0)<(q|0)){s=E}else{break}}}j=j+1|0;}while((j|0)<(c[p>>2]|0))}wb(277184)|0;ad(n|0)|0;c[b+460>>2]=0;i=d;return 0}function I$a(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;if((a[b+440|0]|0)==0){i=d;return 0}Xpb(c[b+448>>2]|0);e=b+452|0;f=b+444|0;b=c[f>>2]|0;if((c[e>>2]|0)>0){g=b;h=0;while(1){Xpb(c[g+(h<<2)>>2]|0);j=h+1|0;k=c[f>>2]|0;if((j|0)<(c[e>>2]|0)){h=j;g=k}else{l=k;break}}}else{l=b}Xpb(l);i=d;return 0}function J$a(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0;d=i;if((a[b+440|0]|0)==0){e=-1;i=d;return e|0}f=+h[c[c[b+4>>2]>>2]>>3];g=b+460|0;j=c[g>>2]|0;k=c[b+448>>2]|0;l=+h[k+(j<<3)>>3];if(f==l){m=c[b+152>>2]|0;if((m|0)<=0){e=1;i=d;return e|0}n=c[(c[b+444>>2]|0)+(j<<2)>>2]|0;o=c[b+432>>2]|0;p=0;while(1){h[o+(p<<3)>>3]=+h[n+(p<<3)>>3];q=p+1|0;if((q|0)<(m|0)){p=q}else{e=1;break}}i=d;return e|0}p=j+1|0;r=+h[k+(p<<3)>>3];if(f==r){m=c[b+152>>2]|0;if((m|0)<=0){e=1;i=d;return e|0}n=c[(c[b+444>>2]|0)+(j<<2)>>2]|0;o=c[b+432>>2]|0;q=0;while(1){s=q+1|0;h[o+(q<<3)>>3]=+h[n+(s<<3)>>3];if((s|0)<(m|0)){q=s}else{e=1;break}}i=d;return e|0}a:do{if(f>r){q=(c[b+456>>2]|0)+ -1|0;m=j;n=p;while(1){if((n|0)>=(q|0)){t=m;break a}c[g>>2]=n;o=n+1|0;if(f>+h[k+(o<<3)>>3]){s=n;n=o;m=s}else{t=n;break}}}else{t=j}}while(0);j=t+1|0;r=+h[k+(j<<3)>>3]- +h[k+(t<<3)>>3];k=c[b+152>>2]|0;if((k|0)<=0){e=0;i=d;return e|0}g=c[b+444>>2]|0;p=c[g+(t<<2)>>2]|0;t=c[g+(j<<2)>>2]|0;u=l+r;j=b+432|0;v=u-f;w=f-l;b=0;while(1){x=+h[p+(b<<3)>>3];y=+h[t+(b<<3)>>3];do{if(x!=y){if(x>0.0){z=1}else{z=(x<0.0)<<31>>31}if(y>0.0){A=1}else{A=(y<0.0)<<31>>31}if((z|0)==(A|0)){h[(c[j>>2]|0)+(b<<3)>>3]=(u*x+f*y-(f*x+l*y))/r;break}else{h[(c[j>>2]|0)+(b<<3)>>3]=(v*x+w*y)/r;break}}else{h[(c[j>>2]|0)+(b<<3)>>3]=x}}while(0);g=b+1|0;if((g|0)<(k|0)){b=g}else{e=0;break}}i=d;return e|0}function K$a(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;d=b;e=i;i=i+8|0;f=+L$a(a,1.0);if(!(f>1.0e-5)){g=0;i=b;return g|0}if((c[240116>>2]|0)==0){g=1;i=b;return g|0}j=e;h[k>>3]=f;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];kXa(9,1,277248,e);e=a+16|0;j=c[e>>2]|0;if((j|0)>0){l=a+48|0;a=j;j=0;while(1){f=+h[(c[l>>2]|0)+(j<<3)>>3];m=j+1|0;if(+U(+f)>1.0e-5){c[d>>2]=m;n=d+4|0;h[k>>3]=f;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];kXa(9,0,277360,d);o=c[e>>2]|0}else{o=a}if((m|0)<(o|0)){a=o;j=m}else{break}}}me[c[60158]&2047](9);g=1;i=b;return g|0}function L$a(b,d){b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0,z=0.0,A=0.0,B=0,C=0.0,D=0,E=0,F=0.0,G=0.0,H=0,I=0.0,J=0,K=0,L=0.0;e=i;f=c[b+60>>2]|0;_$a(b);g=f+540|0;pe[c[(c[g>>2]|0)+84>>2]&127](f)|0;pe[c[(c[g>>2]|0)+36>>2]&127](f)|0;pe[c[(c[g>>2]|0)+32>>2]&127](f)|0;j=b+48|0;Ee[c[(c[g>>2]|0)+68>>2]&63](f,c[j>>2]|0)|0;g=f+8|0;k=c[f+184>>2]|0;if((k|0)>0){l=c[b+52>>2]|0;m=(l|0)==0;n=c[j>>2]|0;o=0.0;j=0;while(1){if(m){p=1.0}else{p=+h[l+(j<<3)>>3]}q=+h[n+(j<<3)>>3]/p;r=o+q*q;s=j+1|0;if((s|0)<(k|0)){o=r;j=s}else{t=r;break}}}else{t=0.0}if(!(d<1.0)){u=t;i=e;return+u}o=t*d;j=c[f+116>>2]|0;if((j|0)>0){k=c[g>>2]|0;n=b+56|0;t=1.0-d;l=f+4|0;p=o;m=0;s=0;while(1){if((a[k+(m*112|0)+88|0]|0)==0){v=p;w=s}else{x=c[n>>2]|0;if((x|0)==0){y=s;z=1.0}else{y=s+1|0;z=+h[x+(s<<3)>>3]}r=(+h[k+(m*112|0)+96>>3]- +h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+(m<<3)>>3])/z;v=p+r*t*r;w=y}x=m+1|0;if((x|0)<(j|0)){p=v;m=x;s=w}else{A=v;B=w;break}}}else{A=o;B=0}w=c[f+136>>2]|0;if((w|0)>0){s=c[f+24>>2]|0;m=b+56|0;o=1.0-d;y=f+416|0;v=A;l=0;k=B;while(1){do{if((a[s+(l*112|0)+88|0]|0)==0){C=v;D=k}else{if((a[s+(l*112|0)+72|0]|0)!=0){C=v;D=k;break}n=c[m>>2]|0;if((n|0)==0){E=k;F=1.0}else{E=k+1|0;F=+h[n+(k<<3)>>3]}p=(+h[s+(l*112|0)+96>>3]- +h[(c[y>>2]|0)+(l<<3)>>3])/F;C=v+p*o*p;D=E}}while(0);n=l+1|0;if((n|0)<(w|0)){v=C;l=n;k=D}else{G=C;H=D;break}}}else{G=A;H=B}B=c[f+120>>2]|0;D=j-B|0;if((D|0)>=(B|0)){u=G;i=e;return+u}j=c[g>>2]|0;g=b+56|0;A=1.0-d;b=f+416|0;d=G;f=D;D=H;while(1){do{if((a[j+(f*112|0)+88|0]|0)==0){I=d;J=D}else{if((a[j+(f*112|0)+72|0]|0)!=0){I=d;J=D;break}H=c[g>>2]|0;if((H|0)==0){K=D;L=1.0}else{K=D+1|0;L=+h[H+(D<<3)>>3]}G=(+h[j+(f*112|0)+96>>3]- +h[(c[b>>2]|0)+(f<<3)>>3])/L;I=d+G*A*G;J=K}}while(0);H=f+1|0;if((H|0)<(B|0)){d=I;f=H;D=J}else{u=I;break}}i=e;return+u}function M$a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+16|0;e=d;f=i;i=i+24|0;g=i;i=i+8|0;j=i;i=i+16|0;l=i;i=i+24|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+16|0;p=i;i=i+24|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+16|0;t=i;i=i+8|0;u=+L$a(b,1.0);if((c[240116>>2]|0)==0){i=d;return}v=b+16|0;w=c[v>>2]|0;if((w|0)>0){x=c[b+48>>2]|0;y=0.0;z=0;while(1){A=+h[x+(z<<3)>>3];B=y+A*A;C=z+1|0;if((C|0)<(w|0)){z=C;y=B}else{D=B;break}}}else{D=0.0}kXa(9,1,277384,t);t=b+52|0;if((c[t>>2]|0)==0){z=r;h[k>>3]=D;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];kXa(9,0,277448,r)}else{r=s;h[k>>3]=D;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=s+8|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];kXa(9,0,277408,s)}kXa(9,1,277472,q);q=b+4|0;s=c[q>>2]|0;if((s|0)>0){r=b+40|0;z=b+24|0;w=b+44|0;x=0;while(1){C=c[r>>2]|0;E=x+1|0;u=+h[(c[z>>2]|0)+(x<<3)>>3];F=c[(c[w>>2]|0)+(x<<2)>>2]|0;if((C|0)==0){c[o>>2]=E;G=o+4|0;h[k>>3]=u;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];c[o+12>>2]=F;kXa(9,0,277544,o)}else{D=+h[C+(x<<3)>>3];c[p>>2]=E;C=p+4|0;h[k>>3]=u;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[p+12>>2]=F;F=p+16|0;h[k>>3]=D;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];kXa(9,0,277496,p)}F=c[q>>2]|0;if((E|0)<(F|0)){x=E}else{H=F;I=E;break}}}else{H=s;I=0}s=b+8|0;if((I|0)<((c[s>>2]|0)+H|0)){H=b+40|0;x=b+24|0;p=b+44|0;o=I;while(1){w=c[H>>2]|0;z=o+1|0;D=+h[(c[x>>2]|0)+(o<<3)>>3];r=c[(c[p>>2]|0)+(o<<2)>>2]|0;if((w|0)==0){c[m>>2]=z;E=m+4|0;h[k>>3]=D;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];c[m+12>>2]=r;kXa(9,0,277632,m)}else{u=+h[w+(o<<3)>>3];c[n>>2]=z;w=n+4|0;h[k>>3]=D;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[n+12>>2]=r;r=n+16|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];kXa(9,0,277568,n)}if((z|0)<((c[s>>2]|0)+(c[q>>2]|0)|0)){o=z}else{J=z;break}}}else{J=I}I=b;if((J|0)<(c[I>>2]|0)){o=b+40|0;q=b+24|0;s=b+44|0;n=J;while(1){J=c[o>>2]|0;m=n+1|0;u=+h[(c[q>>2]|0)+(n<<3)>>3];p=c[(c[s>>2]|0)+(n<<2)>>2]|0;if((J|0)==0){c[j>>2]=m;x=j+4|0;h[k>>3]=u;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];c[j+12>>2]=p;kXa(9,0,277720,j)}else{D=+h[J+(n<<3)>>3];c[l>>2]=m;J=l+4|0;h[k>>3]=u;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];c[l+12>>2]=p;p=l+16|0;h[k>>3]=D;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];kXa(9,0,277664,l)}if((m|0)<(c[I>>2]|0)){n=m}else{break}}}me[c[60158]&2047](9);kXa(9,1,277752,g);if((c[v>>2]|0)>0){g=b+48|0;b=a+540|0;a=0;while(1){n=(c[t>>2]|0)==0;I=a+1|0;D=+h[(c[g>>2]|0)+(a<<3)>>3];l=pe[c[(c[b>>2]|0)+64>>2]&127](a)|0;if(n){c[e>>2]=I;n=e+4|0;h[k>>3]=D;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[e+12>>2]=l;kXa(9,0,277544,e)}else{u=+h[(c[t>>2]|0)+(a<<3)>>3];c[f>>2]=I;n=f+4|0;h[k>>3]=D;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[f+12>>2]=l;l=f+16|0;h[k>>3]=u;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];kXa(9,0,277496,f)}if((I|0)<(c[v>>2]|0)){a=I}else{break}}}me[c[60158]&2047](9);me[c[60158]&2047](9);i=d;return}function N$a(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0;d=i;i=i+24|0;e=d;f=i;i=i+8|0;g=i;i=i+24|0;j=i;i=i+8|0;l=i;i=i+24|0;m=i;i=i+8|0;n=i;i=i+40|0;o=i;i=i+8|0;p=i;i=i+24|0;q=i;i=i+8|0;r=i;i=i+40|0;s=i;i=i+8|0;t=i;i=i+8|0;u=b+8|0;if((c[240116>>2]|0)!=0){t_a(b,9)}if((c[240176>>2]|0)==0){i=d;return}kXa(24,1,277776,t);t=b+112|0;v=c[t>>2]|0;do{if((v|0)>0){kXa(24,1,277816,s);if((c[t>>2]|0)>0){w=u;x=b+4|0;y=b+400|0;z=0;while(1){A=z+1|0;B=c[w>>2]|0;C=c[B+(z*112|0)+4>>2]|0;D=+h[B+(z*112|0)+96>>3];E=+h[B+(z*112|0)+80>>3];F=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];G=+h[(c[y>>2]|0)+(z<<3)>>3];c[r>>2]=A;c[r+4>>2]=C;C=r+8|0;h[k>>3]=D;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+16|0;h[k>>3]=E;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+24|0;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+32|0;h[k>>3]=G;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];kXa(24,0,277840,r);if((A|0)<(c[t>>2]|0)){z=A}else{break}}}me[c[60158]&2047](24);z=c[t>>2]|0;if((z|0)<=0){H=z;break}kXa(24,1,277896,q);z=c[t>>2]|0;if((z|0)<(z<<1|0)){y=u;x=b+4|0;w=b+400|0;A=z;while(1){z=A+1|0;C=c[(c[y>>2]|0)+(A*112|0)+4>>2]|0;G=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(A<<3)>>3];F=+h[(c[w>>2]|0)+(A<<3)>>3];c[p>>2]=z;c[p+4>>2]=C;C=p+8|0;h[k>>3]=G;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=p+16|0;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];kXa(24,0,277920,p);if((z|0)<(c[t>>2]<<1|0)){A=z}else{break}}}me[c[60158]&2047](24);H=c[t>>2]|0}else{H=v}}while(0);v=b+116|0;if((H<<1|0)<(c[v>>2]|0)){kXa(24,1,277952,o);o=c[t>>2]<<1;if((o|0)<(c[v>>2]|0)){t=u;u=b+4|0;H=b+400|0;p=o;while(1){o=p+1|0;q=c[t>>2]|0;r=c[q+(p*112|0)+4>>2]|0;F=+h[q+(p*112|0)+96>>3];G=+h[q+(p*112|0)+80>>3];E=+h[(c[(c[c[u>>2]>>2]|0)+8>>2]|0)+(p<<3)>>3];D=+h[(c[H>>2]|0)+(p<<3)>>3];c[n>>2]=o;c[n+4>>2]=r;r=n+8|0;h[k>>3]=F;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+16|0;h[k>>3]=G;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+24|0;h[k>>3]=E;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+32|0;h[k>>3]=D;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];kXa(24,0,277840,n);if((o|0)<(c[v>>2]|0)){p=o}else{break}}}me[c[60158]&2047](24)}p=b+124|0;if((c[p>>2]|0)>0){kXa(24,1,277976,m);if((c[p>>2]|0)>0){m=b+12|0;v=b+4|0;n=b+404|0;H=0;while(1){u=H+1|0;t=c[m>>2]|0;o=c[t+(H*60|0)+4>>2]|0;r=c[t+(H*60|0)+52>>2]|0;t=c[(c[(c[c[v>>2]>>2]|0)+12>>2]|0)+(H<<2)>>2]|0;q=c[(c[n>>2]|0)+(H<<2)>>2]|0;c[l>>2]=u;c[l+4>>2]=o;c[l+8>>2]=r;c[l+12>>2]=t;c[l+16>>2]=q;kXa(24,0,278e3,l);if((u|0)<(c[p>>2]|0)){H=u}else{break}}}me[c[60158]&2047](24)}H=b+128|0;if((c[H>>2]|0)>0){kXa(24,1,278048,j);if((c[H>>2]|0)>0){j=b+16|0;p=b+4|0;l=b+408|0;n=0;while(1){v=n+1|0;m=c[j>>2]|0;u=c[m+(n*48|0)+4>>2]|0;q=(a[m+(n*48|0)+42|0]|0)!=0?278120:278128;m=(a[(c[(c[c[p>>2]>>2]|0)+16>>2]|0)+n|0]|0)!=0?278120:278128;t=(a[(c[l>>2]|0)+n|0]|0)!=0?278120:278128;c[g>>2]=v;c[g+4>>2]=u;c[g+8>>2]=q;c[g+12>>2]=m;c[g+16>>2]=t;kXa(24,0,278072,g);if((v|0)<(c[H>>2]|0)){n=v}else{break}}}me[c[60158]&2047](24)}n=b+132|0;if((c[n>>2]|0)>0){kXa(24,1,278136,f);if((c[n>>2]|0)>0){f=b+20|0;H=b+4|0;g=b+412|0;b=0;while(1){l=b+1|0;p=c[f>>2]|0;j=c[p+(b*52|0)+4>>2]|0;v=c[p+(b*52|0)+44>>2]|0;p=c[(c[(c[c[H>>2]>>2]|0)+20>>2]|0)+(b<<2)>>2]|0;t=c[(c[g>>2]|0)+(b<<2)>>2]|0;c[e>>2]=l;c[e+4>>2]=j;c[e+8>>2]=v;c[e+12>>2]=p;c[e+16>>2]=t;kXa(24,0,278160,e);if((l|0)<(c[n>>2]|0)){b=l}else{break}}}me[c[60158]&2047](24)}me[c[60158]&2047](24);i=d;return}function O$a(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0.0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;k=i;i=i+8|0;l=k;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=b+540|0;B=(c[(c[A>>2]|0)+72>>2]|0)!=0?3:2;kXa(9,0,278208,z);if((f|0)==0){q_a(b);r_a(b);C=6}else{if((a[f]|0)!=0){P$a(b,f,g)}q_a(b);r_a(b);if((a[f]|0)==0){C=6}}if((C|0)==6){pe[c[(c[A>>2]|0)+84>>2]&127](b)|0;pe[c[(c[A>>2]|0)+60>>2]&127](b)|0}do{if((d|0)==0){D=B}else{if((a[d]|0)==0){D=B;break}C=(uqb(d,279696)|0)==0|0;f=(uqb(d,279704)|0)==0;z=(uqb(d,279712)|0)==0;E=z?3:f?2:C;if((E|0)!=0){D=E;break}c[y>>2]=d;mXa(1,0,278256,y);mXa(1,0,278288,x);c[w>>2]=279696;c[w+4>>2]=279504;mXa(1,0,278312,w);c[v>>2]=279704;c[v+4>>2]=279584;mXa(1,0,278312,v);c[u>>2]=279712;c[u+4>>2]=279632;mXa(1,0,278312,u);oXa(c[b+536>>2]|0,278344,t)}}while(0);do{if((e|0)==0){F=3}else{if((a[e]|0)==0){F=3;break}else{G=1;H=0}do{t=(uqb(e,c[278368+(G<<2)>>2]|0)|0)==0;H=t?G:H;G=G+1|0;}while((G|0)<7);if((H|0)!=0){F=H;break}c[s>>2]=e;mXa(1,0,278400,s);mXa(1,0,278288,r);t=1;do{u=c[278432+(t<<2)>>2]|0;c[q>>2]=c[278368+(t<<2)>>2];c[q+4>>2]=u;mXa(1,0,278312,q);t=t+1|0;}while((t|0)<7);oXa(c[b+536>>2]|0,278344,p)}}while(0);p=c[278328+(D<<2)>>2]|0;c[o>>2]=c[278240+(D<<2)>>2];c[o+4>>2]=p;kXa(9,0,278464,o);o=(D|0)==2;if(o){p=c[278432+(F<<2)>>2]|0;c[n>>2]=c[278368+(F<<2)>>2];c[n+4>>2]=p;kXa(9,0,278504,n)}n=b+312|0;a[n]=1;p=b+200|0;if((c[p>>2]|0)>0){q=b+468|0;r=0;do{a[(c[q>>2]|0)+(r*80|0)+72|0]=1;r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+196|0;if((c[p>>2]|0)>0){r=b+476|0;q=0;do{a[(c[r>>2]|0)+(q<<6)+56|0]=1;q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+192|0;if((c[p>>2]|0)>0){q=b+484|0;r=0;do{a[(c[q>>2]|0)+(r*40|0)+36|0]=1;r=r+1|0;}while((r|0)<(c[p>>2]|0))}do{if((D|0)==1){I=0}else{if(o){I=Q$a(b,F,j)|0;break}if((D|0)==3){R$a(b,j);I=0;break}else{oXa(c[b+536>>2]|0,278544,m)}}}while(0);if((a$a(b,1)|0)!=0){J=-2;N$a(b);K=15;L=K;M=278568;N=M;kXa(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];$Za(b,R,V);W=1412;n_a(b);X=1418;s_a(b);Y=1413;i_a(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=pe[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=Ee[ha&63](b,1)|0;ja=1421;o_a(b);i=k;return J|0}if((S_a(b,1)|0)!=0){J=-3;N$a(b);K=15;L=K;M=278568;N=M;kXa(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];$Za(b,R,V);W=1412;n_a(b);X=1418;s_a(b);Y=1413;i_a(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=pe[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=Ee[ha&63](b,1)|0;ja=1421;o_a(b);i=k;return J|0}m=(H_a(b,1)|0)==0;J=m?I:-4;N$a(b);K=15;L=K;M=278568;N=M;kXa(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];$Za(b,R,V);W=1412;n_a(b);X=1418;s_a(b);Y=1413;i_a(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=pe[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=Ee[ha&63](b,1)|0;ja=1421;o_a(b);i=k;return J|0}



function AW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0;e=i;i=i+496|0;f=e;g=e+120|0;j=e+240|0;k=e+360|0;l=e+480|0;m=e+488|0;n=+h[b>>3];o=a+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[p+1016>>3]=n;q=+h[b+8>>3];h[p+10584>>3]=q;h[p+1008>>3]=+h[b+16>>3];r=+h[p+12448>>3];s=r*r;b=p+216|0;h[d>>3]=+h[p+9808>>3]*s+(r*n+(-(s*q)- +h[b>>3]*+h[p+10736>>3]));t=a+536|0;XE(j,c[t>>2]|0,+h[b>>3],+h[p+208>>3],0);p=c[t>>2]|0;b=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[b+216>>3];s=+h[b+208>>3];n=+h[b+1016>>3];r=+h[b+1008>>3];b=g+0|0;a=j+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));bF(l,p,q,s,g,n,r);g=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[d+8>>3]=+h[g+10584>>3]- +h[l>>3];XE(k,c[t>>2]|0,+h[g+216>>3],+h[g+208>>3],0);g=c[t>>2]|0;t=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[t+216>>3];n=+h[t+208>>3];s=+h[t+1016>>3];q=+h[t+1008>>3];b=f+0|0;a=k+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));fF(m,g,r,n,f,s,q);h[d+16>>3]=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+10736>>3]- +h[m>>3];i=e;return}function BW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+14528>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+14504>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+14512>>3];h[a+8>>3]=+h[d+148144>>3];h[e+8>>3]=+h[d+148120>>3];h[f+8>>3]=+h[d+148128>>3];h[a+16>>3]=+h[d+14416>>3];h[e+16>>3]=+h[d+14392>>3];h[f+16>>3]=+h[d+14400>>3];i=i;return}function CW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0;e=i;i=i+496|0;f=e;g=e+120|0;j=e+240|0;k=e+360|0;l=e+480|0;m=e+488|0;n=+h[b>>3];o=a+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[p+1032>>3]=n;q=+h[b+8>>3];h[p+10576>>3]=q;h[p+1024>>3]=+h[b+16>>3];r=+h[p+12440>>3];s=r*r;b=p+232|0;h[d>>3]=+h[p+9800>>3]*s+(r*n+(-(s*q)- +h[b>>3]*+h[p+10728>>3]));t=a+536|0;XE(j,c[t>>2]|0,+h[b>>3],+h[p+224>>3],0);p=c[t>>2]|0;b=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[b+232>>3];s=+h[b+224>>3];n=+h[b+1032>>3];r=+h[b+1024>>3];b=g+0|0;a=j+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));bF(l,p,q,s,g,n,r);g=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[d+8>>3]=+h[g+10576>>3]- +h[l>>3];XE(k,c[t>>2]|0,+h[g+232>>3],+h[g+224>>3],0);g=c[t>>2]|0;t=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[t+232>>3];n=+h[t+224>>3];s=+h[t+1032>>3];q=+h[t+1024>>3];b=f+0|0;a=k+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));fF(m,g,r,n,f,s,q);h[d+16>>3]=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+10728>>3]- +h[m>>3];i=e;return}function DW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+14752>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+14728>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+14736>>3];h[a+8>>3]=+h[d+148032>>3];h[e+8>>3]=+h[d+148008>>3];h[f+8>>3]=+h[d+148016>>3];h[a+16>>3]=+h[d+14640>>3];h[e+16>>3]=+h[d+14616>>3];h[f+16>>3]=+h[d+14624>>3];i=i;return}function EW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0;e=i;i=i+496|0;f=e;g=e+120|0;j=e+240|0;k=e+360|0;l=e+480|0;m=e+488|0;n=+h[b>>3];o=a+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[p+1048>>3]=n;q=+h[b+8>>3];h[p+10568>>3]=q;h[p+1040>>3]=+h[b+16>>3];r=+h[p+12432>>3];s=r*r;b=p+248|0;h[d>>3]=+h[p+9792>>3]*s+(r*n+(-(s*q)- +h[b>>3]*+h[p+10720>>3]));t=a+536|0;XE(j,c[t>>2]|0,+h[b>>3],+h[p+240>>3],0);p=c[t>>2]|0;b=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[b+248>>3];s=+h[b+240>>3];n=+h[b+1048>>3];r=+h[b+1040>>3];b=g+0|0;a=j+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));bF(l,p,q,s,g,n,r);g=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[d+8>>3]=+h[g+10568>>3]- +h[l>>3];XE(k,c[t>>2]|0,+h[g+248>>3],+h[g+240>>3],0);g=c[t>>2]|0;t=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[t+248>>3];n=+h[t+240>>3];s=+h[t+1048>>3];q=+h[t+1040>>3];b=f+0|0;a=k+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));fF(m,g,r,n,f,s,q);h[d+16>>3]=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+10720>>3]- +h[m>>3];i=e;return}function FW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+14976>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+14952>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+14960>>3];h[a+8>>3]=+h[d+147920>>3];h[e+8>>3]=+h[d+147896>>3];h[f+8>>3]=+h[d+147904>>3];h[a+16>>3]=+h[d+14864>>3];h[e+16>>3]=+h[d+14840>>3];h[f+16>>3]=+h[d+14848>>3];i=i;return}function GW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0;e=i;i=i+496|0;f=e;g=e+120|0;j=e+240|0;k=e+360|0;l=e+480|0;m=e+488|0;n=+h[b>>3];o=a+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[p+1064>>3]=n;q=+h[b+8>>3];h[p+10560>>3]=q;h[p+1056>>3]=+h[b+16>>3];r=+h[p+12424>>3];s=r*r;b=p+264|0;h[d>>3]=+h[p+9784>>3]*s+(r*n+(-(s*q)- +h[b>>3]*+h[p+10712>>3]));t=a+536|0;XE(j,c[t>>2]|0,+h[b>>3],+h[p+256>>3],0);p=c[t>>2]|0;b=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[b+264>>3];s=+h[b+256>>3];n=+h[b+1064>>3];r=+h[b+1056>>3];b=g+0|0;a=j+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));bF(l,p,q,s,g,n,r);g=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[d+8>>3]=+h[g+10560>>3]- +h[l>>3];XE(k,c[t>>2]|0,+h[g+264>>3],+h[g+256>>3],0);g=c[t>>2]|0;t=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[t+264>>3];n=+h[t+256>>3];s=+h[t+1064>>3];q=+h[t+1056>>3];b=f+0|0;a=k+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));fF(m,g,r,n,f,s,q);h[d+16>>3]=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+10712>>3]- +h[m>>3];i=e;return}function HW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+15200>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+15176>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+15184>>3];h[a+8>>3]=+h[d+147808>>3];h[e+8>>3]=+h[d+147784>>3];h[f+8>>3]=+h[d+147792>>3];h[a+16>>3]=+h[d+15088>>3];h[e+16>>3]=+h[d+15064>>3];h[f+16>>3]=+h[d+15072>>3];i=i;return}function IW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0;e=i;i=i+496|0;f=e;g=e+120|0;j=e+240|0;k=e+360|0;l=e+480|0;m=e+488|0;n=+h[b>>3];o=a+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[p+1080>>3]=n;q=+h[b+8>>3];h[p+10552>>3]=q;h[p+1072>>3]=+h[b+16>>3];r=+h[p+12416>>3];s=r*r;b=p+280|0;h[d>>3]=+h[p+9776>>3]*s+(r*n+(-(s*q)- +h[b>>3]*+h[p+10704>>3]));t=a+536|0;XE(j,c[t>>2]|0,+h[b>>3],+h[p+272>>3],0);p=c[t>>2]|0;b=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[b+280>>3];s=+h[b+272>>3];n=+h[b+1080>>3];r=+h[b+1072>>3];b=g+0|0;a=j+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));bF(l,p,q,s,g,n,r);g=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[d+8>>3]=+h[g+10552>>3]- +h[l>>3];XE(k,c[t>>2]|0,+h[g+280>>3],+h[g+272>>3],0);g=c[t>>2]|0;t=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[t+280>>3];n=+h[t+272>>3];s=+h[t+1080>>3];q=+h[t+1072>>3];b=f+0|0;a=k+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));fF(m,g,r,n,f,s,q);h[d+16>>3]=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+10704>>3]- +h[m>>3];i=e;return}function JW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+15424>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+15400>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+15408>>3];h[a+8>>3]=+h[d+147696>>3];h[e+8>>3]=+h[d+147672>>3];h[f+8>>3]=+h[d+147680>>3];h[a+16>>3]=+h[d+15312>>3];h[e+16>>3]=+h[d+15288>>3];h[f+16>>3]=+h[d+15296>>3];i=i;return}function KW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0;e=i;i=i+496|0;f=e;g=e+120|0;j=e+240|0;k=e+360|0;l=e+480|0;m=e+488|0;n=+h[b>>3];o=a+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[p+1096>>3]=n;q=+h[b+8>>3];h[p+10544>>3]=q;h[p+1088>>3]=+h[b+16>>3];r=+h[p+12408>>3];s=r*r;b=p+296|0;h[d>>3]=+h[p+9768>>3]*s+(r*n+(-(s*q)- +h[b>>3]*+h[p+10696>>3]));t=a+536|0;XE(j,c[t>>2]|0,+h[b>>3],+h[p+288>>3],0);p=c[t>>2]|0;b=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[b+296>>3];s=+h[b+288>>3];n=+h[b+1096>>3];r=+h[b+1088>>3];b=g+0|0;a=j+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));bF(l,p,q,s,g,n,r);g=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[d+8>>3]=+h[g+10544>>3]- +h[l>>3];XE(k,c[t>>2]|0,+h[g+296>>3],+h[g+288>>3],0);g=c[t>>2]|0;t=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[t+296>>3];n=+h[t+288>>3];s=+h[t+1096>>3];q=+h[t+1088>>3];b=f+0|0;a=k+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));fF(m,g,r,n,f,s,q);h[d+16>>3]=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+10696>>3]- +h[m>>3];i=e;return}function LW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+15648>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+15624>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+15632>>3];h[a+8>>3]=+h[d+205264>>3];h[e+8>>3]=+h[d+205240>>3];h[f+8>>3]=+h[d+205248>>3];h[a+16>>3]=+h[d+15536>>3];h[e+16>>3]=+h[d+15512>>3];h[f+16>>3]=+h[d+15520>>3];i=i;return}function MW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0;e=i;i=i+496|0;f=e;g=e+120|0;j=e+240|0;k=e+360|0;l=e+480|0;m=e+488|0;n=+h[b>>3];o=a+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[p+1112>>3]=n;q=+h[b+8>>3];h[p+14656>>3]=q;h[p+1104>>3]=+h[b+16>>3];r=+h[p+12400>>3];s=r*r;b=p+312|0;h[d>>3]=+h[p+9760>>3]*s+(r*n+(-(s*q)- +h[b>>3]*+h[p+10688>>3]));t=a+536|0;XE(j,c[t>>2]|0,+h[b>>3],+h[p+304>>3],0);p=c[t>>2]|0;b=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[b+312>>3];s=+h[b+304>>3];n=+h[b+1112>>3];r=+h[b+1104>>3];b=g+0|0;a=j+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));bF(l,p,q,s,g,n,r);g=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[d+8>>3]=+h[g+14656>>3]- +h[l>>3];XE(k,c[t>>2]|0,+h[g+312>>3],+h[g+304>>3],0);g=c[t>>2]|0;t=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[t+312>>3];n=+h[t+304>>3];s=+h[t+1112>>3];q=+h[t+1104>>3];b=f+0|0;a=k+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));fF(m,g,r,n,f,s,q);h[d+16>>3]=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+10688>>3]- +h[m>>3];i=e;return}function NW(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+67168>>3];h[c[b+8>>2]>>3]=+h[d+67144>>3];h[c[b+12>>2]>>3]=+h[d+67152>>3];i=i;return}function OW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+4792>>3]=g;HD(f,c[a+536>>2]|0,g,+h[(c[a+416>>2]|0)+816>>3],+h[j+5592>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+5912>>3]- +h[f>>3];i=e;return}function PW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+15872>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+15848>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+15856>>3];h[a+8>>3]=+h[d+204928>>3];h[e+8>>3]=+h[d+204904>>3];h[f+8>>3]=+h[d+204912>>3];h[a+16>>3]=+h[d+15760>>3];h[e+16>>3]=+h[d+15736>>3];h[f+16>>3]=+h[d+15744>>3];i=i;return}function QW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0;e=i;i=i+496|0;f=e;g=e+120|0;j=e+240|0;k=e+360|0;l=e+480|0;m=e+488|0;n=+h[b>>3];o=a+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[p+1128>>3]=n;q=+h[b+8>>3];h[p+14632>>3]=q;h[p+1120>>3]=+h[b+16>>3];r=+h[p+12368>>3];s=r*r;b=p+328|0;h[d>>3]=+h[p+9752>>3]*s+(r*n+(-(s*q)- +h[b>>3]*+h[p+10536>>3]));t=a+536|0;XE(j,c[t>>2]|0,+h[b>>3],+h[p+320>>3],0);p=c[t>>2]|0;b=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[b+328>>3];s=+h[b+320>>3];n=+h[b+1128>>3];r=+h[b+1120>>3];b=g+0|0;a=j+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));bF(l,p,q,s,g,n,r);g=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[d+8>>3]=+h[g+14632>>3]- +h[l>>3];XE(k,c[t>>2]|0,+h[g+328>>3],+h[g+320>>3],0);g=c[t>>2]|0;t=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[t+328>>3];n=+h[t+320>>3];s=+h[t+1128>>3];q=+h[t+1120>>3];b=f+0|0;a=k+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));fF(m,g,r,n,f,s,q);h[d+16>>3]=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+10536>>3]- +h[m>>3];i=e;return}function RW(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+67056>>3];h[c[b+8>>2]>>3]=+h[d+67032>>3];h[c[b+12>>2]>>3]=+h[d+67040>>3];i=i;return}function SW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+4784>>3]=g;HD(f,c[a+536>>2]|0,g,+h[(c[a+416>>2]|0)+808>>3],+h[j+5584>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+5904>>3]- +h[f>>3];i=e;return}function TW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+16096>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+16072>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+16080>>3];h[a+8>>3]=+h[d+15984>>3];h[e+8>>3]=+h[d+15960>>3];h[f+8>>3]=+h[d+15968>>3];h[a+16>>3]=+h[d+145344>>3];h[e+16>>3]=+h[d+145320>>3];h[f+16>>3]=+h[d+145328>>3];i=i;return}function UW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0;e=i;i=i+496|0;f=e;g=e+120|0;j=e+240|0;k=e+360|0;l=e+480|0;m=e+488|0;n=+h[b>>3];o=a+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[p+1144>>3]=n;h[p+1136>>3]=+h[b+8>>3];q=+h[b+16>>3];h[p+10376>>3]=q;r=+h[p+12360>>3];s=r*r;b=p+344|0;h[d>>3]=+h[p+9744>>3]*s+(r*n+(-(s*q)- +h[b>>3]*+h[p+10528>>3]));t=a+536|0;XE(j,c[t>>2]|0,+h[b>>3],+h[p+336>>3],0);p=c[t>>2]|0;b=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[b+344>>3];s=+h[b+336>>3];n=+h[b+1144>>3];r=+h[b+1136>>3];b=g+0|0;a=j+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));fF(l,p,q,s,g,n,r);g=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[d+8>>3]=+h[g+10528>>3]- +h[l>>3];XE(k,c[t>>2]|0,+h[g+344>>3],+h[g+336>>3],0);g=c[t>>2]|0;t=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[t+344>>3];n=+h[t+336>>3];s=+h[t+1144>>3];q=+h[t+1136>>3];b=f+0|0;a=k+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));bF(m,g,r,n,f,s,q);h[d+16>>3]=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+10376>>3]- +h[m>>3];i=e;return}function VW(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+66944>>3];h[c[b+8>>2]>>3]=+h[d+66920>>3];h[c[b+12>>2]>>3]=+h[d+66928>>3];i=i;return}function WW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+4776>>3]=g;HD(f,c[a+536>>2]|0,g,+h[(c[a+416>>2]|0)+800>>3],+h[j+5576>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+5896>>3]- +h[f>>3];i=e;return}function XW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+16320>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+16296>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+16304>>3];h[a+8>>3]=+h[d+16208>>3];h[e+8>>3]=+h[d+16184>>3];h[f+8>>3]=+h[d+16192>>3];h[a+16>>3]=+h[d+145232>>3];h[e+16>>3]=+h[d+145208>>3];h[f+16>>3]=+h[d+145216>>3];i=i;return}function YW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0;e=i;i=i+496|0;f=e;g=e+120|0;j=e+240|0;k=e+360|0;l=e+480|0;m=e+488|0;n=+h[b>>3];o=a+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[p+1160>>3]=n;h[p+1152>>3]=+h[b+8>>3];q=+h[b+16>>3];h[p+10368>>3]=q;r=+h[p+12352>>3];s=r*r;b=p+360|0;h[d>>3]=+h[p+9736>>3]*s+(r*n+(-(s*q)- +h[b>>3]*+h[p+10520>>3]));t=a+536|0;XE(j,c[t>>2]|0,+h[b>>3],+h[p+352>>3],0);p=c[t>>2]|0;b=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[b+360>>3];s=+h[b+352>>3];n=+h[b+1160>>3];r=+h[b+1152>>3];b=g+0|0;a=j+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));fF(l,p,q,s,g,n,r);g=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[d+8>>3]=+h[g+10520>>3]- +h[l>>3];XE(k,c[t>>2]|0,+h[g+360>>3],+h[g+352>>3],0);g=c[t>>2]|0;t=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[t+360>>3];n=+h[t+352>>3];s=+h[t+1160>>3];q=+h[t+1152>>3];b=f+0|0;a=k+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));bF(m,g,r,n,f,s,q);h[d+16>>3]=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+10368>>3]- +h[m>>3];i=e;return}function ZW(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+66832>>3];h[c[b+8>>2]>>3]=+h[d+66808>>3];h[c[b+12>>2]>>3]=+h[d+66816>>3];i=i;return}function _W(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+4768>>3]=g;HD(f,c[a+536>>2]|0,g,+h[(c[a+416>>2]|0)+792>>3],+h[j+5568>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+5888>>3]- +h[f>>3];i=e;return}function $W(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+16544>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+16520>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+16528>>3];h[a+8>>3]=+h[d+145120>>3];h[e+8>>3]=+h[d+145096>>3];h[f+8>>3]=+h[d+145104>>3];h[a+16>>3]=+h[d+16432>>3];h[e+16>>3]=+h[d+16408>>3];h[f+16>>3]=+h[d+16416>>3];i=i;return}function aX(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0;e=i;i=i+496|0;f=e;g=e+120|0;j=e+240|0;k=e+360|0;l=e+480|0;m=e+488|0;n=+h[b>>3];o=a+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[p+1176>>3]=n;q=+h[b+8>>3];h[p+10360>>3]=q;h[p+1168>>3]=+h[b+16>>3];r=+h[p+12344>>3];s=r*r;b=p+376|0;h[d>>3]=+h[p+9728>>3]*s+(r*n+(-(s*q)- +h[b>>3]*+h[p+10512>>3]));t=a+536|0;XE(j,c[t>>2]|0,+h[b>>3],+h[p+368>>3],0);p=c[t>>2]|0;b=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[b+376>>3];s=+h[b+368>>3];n=+h[b+1176>>3];r=+h[b+1168>>3];b=g+0|0;a=j+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));bF(l,p,q,s,g,n,r);g=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[d+8>>3]=+h[g+10360>>3]- +h[l>>3];XE(k,c[t>>2]|0,+h[g+376>>3],+h[g+368>>3],0);g=c[t>>2]|0;t=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[t+376>>3];n=+h[t+368>>3];s=+h[t+1176>>3];q=+h[t+1168>>3];b=f+0|0;a=k+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));fF(m,g,r,n,f,s,q);h[d+16>>3]=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+10512>>3]- +h[m>>3];i=e;return}function bX(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+66720>>3];h[c[b+8>>2]>>3]=+h[d+66696>>3];h[c[b+12>>2]>>3]=+h[d+66704>>3];i=i;return}function cX(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+4760>>3]=g;HD(f,c[a+536>>2]|0,g,+h[(c[a+416>>2]|0)+784>>3],+h[j+5560>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+5880>>3]- +h[f>>3];i=e;return}function dX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+16768>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+16744>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+16752>>3];h[a+8>>3]=+h[d+145008>>3];h[e+8>>3]=+h[d+144984>>3];h[f+8>>3]=+h[d+144992>>3];h[a+16>>3]=+h[d+16656>>3];h[e+16>>3]=+h[d+16632>>3];h[f+16>>3]=+h[d+16640>>3];i=i;return}function eX(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0;e=i;i=i+496|0;f=e;g=e+120|0;j=e+240|0;k=e+360|0;l=e+480|0;m=e+488|0;n=+h[b>>3];o=a+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[p+1192>>3]=n;q=+h[b+8>>3];h[p+10352>>3]=q;h[p+1184>>3]=+h[b+16>>3];r=+h[p+12336>>3];s=r*r;b=p+392|0;h[d>>3]=+h[p+9720>>3]*s+(r*n+(-(s*q)- +h[b>>3]*+h[p+10504>>3]));t=a+536|0;XE(j,c[t>>2]|0,+h[b>>3],+h[p+384>>3],0);p=c[t>>2]|0;b=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[b+392>>3];s=+h[b+384>>3];n=+h[b+1192>>3];r=+h[b+1184>>3];b=g+0|0;a=j+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));bF(l,p,q,s,g,n,r);g=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[d+8>>3]=+h[g+10352>>3]- +h[l>>3];XE(k,c[t>>2]|0,+h[g+392>>3],+h[g+384>>3],0);g=c[t>>2]|0;t=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[t+392>>3];n=+h[t+384>>3];s=+h[t+1192>>3];q=+h[t+1184>>3];b=f+0|0;a=k+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));fF(m,g,r,n,f,s,q);h[d+16>>3]=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+10504>>3]- +h[m>>3];i=e;return}function fX(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+66608>>3];h[c[b+8>>2]>>3]=+h[d+66584>>3];h[c[b+12>>2]>>3]=+h[d+66592>>3];i=i;return}function gX(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+4752>>3]=g;HD(f,c[a+536>>2]|0,g,+h[(c[a+416>>2]|0)+776>>3],+h[j+5552>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+5872>>3]- +h[f>>3];i=e;return}function hX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+16992>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+16968>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+16976>>3];h[a+8>>3]=+h[d+144896>>3];h[e+8>>3]=+h[d+144872>>3];h[f+8>>3]=+h[d+144880>>3];h[a+16>>3]=+h[d+16880>>3];h[e+16>>3]=+h[d+16856>>3];h[f+16>>3]=+h[d+16864>>3];i=i;return}function iX(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0;e=i;i=i+496|0;f=e;g=e+120|0;j=e+240|0;k=e+360|0;l=e+480|0;m=e+488|0;n=+h[b>>3];o=a+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[p+1208>>3]=n;q=+h[b+8>>3];h[p+10344>>3]=q;h[p+1200>>3]=+h[b+16>>3];r=+h[p+12328>>3];s=r*r;b=p+408|0;h[d>>3]=+h[p+9712>>3]*s+(r*n+(-(s*q)- +h[b>>3]*+h[p+10496>>3]));t=a+536|0;XE(j,c[t>>2]|0,+h[b>>3],+h[p+400>>3],0);p=c[t>>2]|0;b=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[b+408>>3];s=+h[b+400>>3];n=+h[b+1208>>3];r=+h[b+1200>>3];b=g+0|0;a=j+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));bF(l,p,q,s,g,n,r);g=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[d+8>>3]=+h[g+10344>>3]- +h[l>>3];XE(k,c[t>>2]|0,+h[g+408>>3],+h[g+400>>3],0);g=c[t>>2]|0;t=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[t+408>>3];n=+h[t+400>>3];s=+h[t+1208>>3];q=+h[t+1200>>3];b=f+0|0;a=k+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));fF(m,g,r,n,f,s,q);h[d+16>>3]=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+10496>>3]- +h[m>>3];i=e;return}function jX(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+66496>>3];h[c[b+8>>2]>>3]=+h[d+66472>>3];h[c[b+12>>2]>>3]=+h[d+66480>>3];i=i;return}function kX(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+4744>>3]=g;HD(f,c[a+536>>2]|0,g,+h[(c[a+416>>2]|0)+768>>3],+h[j+5544>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+5864>>3]- +h[f>>3];i=e;return}function lX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+17216>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+17192>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+17200>>3];h[a+8>>3]=+h[d+144784>>3];h[e+8>>3]=+h[d+144760>>3];h[f+8>>3]=+h[d+144768>>3];h[a+16>>3]=+h[d+17104>>3];h[e+16>>3]=+h[d+17080>>3];h[f+16>>3]=+h[d+17088>>3];i=i;return}function mX(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0;e=i;i=i+496|0;f=e;g=e+120|0;j=e+240|0;k=e+360|0;l=e+480|0;m=e+488|0;n=+h[b>>3];o=a+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[p+1224>>3]=n;q=+h[b+8>>3];h[p+10336>>3]=q;h[p+1216>>3]=+h[b+16>>3];r=+h[p+12320>>3];s=r*r;b=p+424|0;h[d>>3]=+h[p+9704>>3]*s+(r*n+(-(s*q)- +h[b>>3]*+h[p+10488>>3]));t=a+536|0;XE(j,c[t>>2]|0,+h[b>>3],+h[p+416>>3],0);p=c[t>>2]|0;b=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[b+424>>3];s=+h[b+416>>3];n=+h[b+1224>>3];r=+h[b+1216>>3];b=g+0|0;a=j+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));bF(l,p,q,s,g,n,r);g=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[d+8>>3]=+h[g+10336>>3]- +h[l>>3];XE(k,c[t>>2]|0,+h[g+424>>3],+h[g+416>>3],0);g=c[t>>2]|0;t=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[t+424>>3];n=+h[t+416>>3];s=+h[t+1224>>3];q=+h[t+1216>>3];b=f+0|0;a=k+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));fF(m,g,r,n,f,s,q);h[d+16>>3]=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+10488>>3]- +h[m>>3];i=e;return}function nX(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+66384>>3];h[c[b+8>>2]>>3]=+h[d+66360>>3];h[c[b+12>>2]>>3]=+h[d+66368>>3];i=i;return}function oX(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+4736>>3]=g;HD(f,c[a+536>>2]|0,g,+h[(c[a+416>>2]|0)+760>>3],+h[j+5536>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+5856>>3]- +h[f>>3];i=e;return}function pX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+17440>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+17416>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+17424>>3];h[a+8>>3]=+h[d+144672>>3];h[e+8>>3]=+h[d+144648>>3];h[f+8>>3]=+h[d+144656>>3];h[a+16>>3]=+h[d+17328>>3];h[e+16>>3]=+h[d+17304>>3];h[f+16>>3]=+h[d+17312>>3];i=i;return}function qX(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0;e=i;i=i+496|0;f=e;g=e+120|0;j=e+240|0;k=e+360|0;l=e+480|0;m=e+488|0;n=+h[b>>3];o=a+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[p+1240>>3]=n;q=+h[b+8>>3];h[p+10328>>3]=q;h[p+1232>>3]=+h[b+16>>3];r=+h[p+12312>>3];s=r*r;b=p+440|0;h[d>>3]=+h[p+9696>>3]*s+(r*n+(-(s*q)- +h[b>>3]*+h[p+10480>>3]));t=a+536|0;XE(j,c[t>>2]|0,+h[b>>3],+h[p+432>>3],0);p=c[t>>2]|0;b=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[b+440>>3];s=+h[b+432>>3];n=+h[b+1240>>3];r=+h[b+1232>>3];b=g+0|0;a=j+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));bF(l,p,q,s,g,n,r);g=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[d+8>>3]=+h[g+10328>>3]- +h[l>>3];XE(k,c[t>>2]|0,+h[g+440>>3],+h[g+432>>3],0);g=c[t>>2]|0;t=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[t+440>>3];n=+h[t+432>>3];s=+h[t+1240>>3];q=+h[t+1232>>3];b=f+0|0;a=k+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));fF(m,g,r,n,f,s,q);h[d+16>>3]=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+10480>>3]- +h[m>>3];i=e;return}function rX(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+66272>>3];h[c[b+8>>2]>>3]=+h[d+66248>>3];h[c[b+12>>2]>>3]=+h[d+66256>>3];i=i;return}function sX(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+4728>>3]=g;HD(f,c[a+536>>2]|0,g,+h[(c[a+416>>2]|0)+752>>3],+h[j+5528>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+5848>>3]- +h[f>>3];i=e;return}function tX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+17664>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+17640>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+17648>>3];h[a+8>>3]=+h[d+144560>>3];h[e+8>>3]=+h[d+144536>>3];h[f+8>>3]=+h[d+144544>>3];h[a+16>>3]=+h[d+17552>>3];h[e+16>>3]=+h[d+17528>>3];h[f+16>>3]=+h[d+17536>>3];i=i;return}function uX(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0;e=i;i=i+496|0;f=e;g=e+120|0;j=e+240|0;k=e+360|0;l=e+480|0;m=e+488|0;n=+h[b>>3];o=a+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[p+1256>>3]=n;q=+h[b+8>>3];h[p+10320>>3]=q;h[p+1248>>3]=+h[b+16>>3];r=+h[p+12304>>3];s=r*r;b=p+456|0;h[d>>3]=+h[p+9688>>3]*s+(r*n+(-(s*q)- +h[b>>3]*+h[p+10472>>3]));t=a+536|0;XE(j,c[t>>2]|0,+h[b>>3],+h[p+448>>3],0);p=c[t>>2]|0;b=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[b+456>>3];s=+h[b+448>>3];n=+h[b+1256>>3];r=+h[b+1248>>3];b=g+0|0;a=j+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));bF(l,p,q,s,g,n,r);g=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[d+8>>3]=+h[g+10320>>3]- +h[l>>3];XE(k,c[t>>2]|0,+h[g+456>>3],+h[g+448>>3],0);g=c[t>>2]|0;t=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[t+456>>3];n=+h[t+448>>3];s=+h[t+1256>>3];q=+h[t+1248>>3];b=f+0|0;a=k+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));fF(m,g,r,n,f,s,q);h[d+16>>3]=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+10472>>3]- +h[m>>3];i=e;return}function vX(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+66160>>3];h[c[b+8>>2]>>3]=+h[d+66136>>3];h[c[b+12>>2]>>3]=+h[d+66144>>3];i=i;return}function wX(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+4720>>3]=g;HD(f,c[a+536>>2]|0,g,+h[(c[a+416>>2]|0)+744>>3],+h[j+5520>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+5840>>3]- +h[f>>3];i=e;return}function xX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+17888>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+17864>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+17872>>3];h[a+8>>3]=+h[d+144448>>3];h[e+8>>3]=+h[d+144424>>3];h[f+8>>3]=+h[d+144432>>3];h[a+16>>3]=+h[d+17776>>3];h[e+16>>3]=+h[d+17752>>3];h[f+16>>3]=+h[d+17760>>3];i=i;return}function yX(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0;e=i;i=i+496|0;f=e;g=e+120|0;j=e+240|0;k=e+360|0;l=e+480|0;m=e+488|0;n=+h[b>>3];o=a+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[p+1272>>3]=n;q=+h[b+8>>3];h[p+10312>>3]=q;h[p+1264>>3]=+h[b+16>>3];r=+h[p+12296>>3];s=r*r;b=p+472|0;h[d>>3]=+h[p+9680>>3]*s+(r*n+(-(s*q)- +h[b>>3]*+h[p+10464>>3]));t=a+536|0;XE(j,c[t>>2]|0,+h[b>>3],+h[p+464>>3],0);p=c[t>>2]|0;b=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[b+472>>3];s=+h[b+464>>3];n=+h[b+1272>>3];r=+h[b+1264>>3];b=g+0|0;a=j+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));bF(l,p,q,s,g,n,r);g=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[d+8>>3]=+h[g+10312>>3]- +h[l>>3];XE(k,c[t>>2]|0,+h[g+472>>3],+h[g+464>>3],0);g=c[t>>2]|0;t=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[t+472>>3];n=+h[t+464>>3];s=+h[t+1272>>3];q=+h[t+1264>>3];b=f+0|0;a=k+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));fF(m,g,r,n,f,s,q);h[d+16>>3]=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+10464>>3]- +h[m>>3];i=e;return}function zX(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+66048>>3];h[c[b+8>>2]>>3]=+h[d+66024>>3];h[c[b+12>>2]>>3]=+h[d+66032>>3];i=i;return}function AX(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+4712>>3]=g;HD(f,c[a+536>>2]|0,g,+h[(c[a+416>>2]|0)+736>>3],+h[j+5512>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+5832>>3]- +h[f>>3];i=e;return}function BX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+18112>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+18088>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+18096>>3];h[a+8>>3]=+h[d+144336>>3];h[e+8>>3]=+h[d+144312>>3];h[f+8>>3]=+h[d+144320>>3];h[a+16>>3]=+h[d+18e3>>3];h[e+16>>3]=+h[d+17976>>3];h[f+16>>3]=+h[d+17984>>3];i=i;return}function CX(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0;e=i;i=i+496|0;f=e;g=e+120|0;j=e+240|0;k=e+360|0;l=e+480|0;m=e+488|0;n=+h[b>>3];o=a+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[p+1288>>3]=n;q=+h[b+8>>3];h[p+10304>>3]=q;h[p+1280>>3]=+h[b+16>>3];r=+h[p+12288>>3];s=r*r;b=p+488|0;h[d>>3]=+h[p+9672>>3]*s+(r*n+(-(s*q)- +h[b>>3]*+h[p+10456>>3]));t=a+536|0;XE(j,c[t>>2]|0,+h[b>>3],+h[p+480>>3],0);p=c[t>>2]|0;b=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[b+488>>3];s=+h[b+480>>3];n=+h[b+1288>>3];r=+h[b+1280>>3];b=g+0|0;a=j+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));bF(l,p,q,s,g,n,r);g=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[d+8>>3]=+h[g+10304>>3]- +h[l>>3];XE(k,c[t>>2]|0,+h[g+488>>3],+h[g+480>>3],0);g=c[t>>2]|0;t=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[t+488>>3];n=+h[t+480>>3];s=+h[t+1288>>3];q=+h[t+1280>>3];b=f+0|0;a=k+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));fF(m,g,r,n,f,s,q);h[d+16>>3]=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+10456>>3]- +h[m>>3];i=e;return}function DX(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+65936>>3];h[c[b+8>>2]>>3]=+h[d+65912>>3];h[c[b+12>>2]>>3]=+h[d+65920>>3];i=i;return}function EX(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+4704>>3]=g;HD(f,c[a+536>>2]|0,g,+h[(c[a+416>>2]|0)+728>>3],+h[j+5504>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+5824>>3]- +h[f>>3];i=e;return}function FX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+18336>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+18312>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+18320>>3];h[a+8>>3]=+h[d+144224>>3];h[e+8>>3]=+h[d+144200>>3];h[f+8>>3]=+h[d+144208>>3];h[a+16>>3]=+h[d+18224>>3];h[e+16>>3]=+h[d+18200>>3];h[f+16>>3]=+h[d+18208>>3];i=i;return}function GX(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0;e=i;i=i+496|0;f=e;g=e+120|0;j=e+240|0;k=e+360|0;l=e+480|0;m=e+488|0;n=+h[b>>3];o=a+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[p+1304>>3]=n;q=+h[b+8>>3];h[p+10296>>3]=q;h[p+1296>>3]=+h[b+16>>3];r=+h[p+12280>>3];s=r*r;b=p+504|0;h[d>>3]=+h[p+9664>>3]*s+(r*n+(-(s*q)- +h[b>>3]*+h[p+10448>>3]));t=a+536|0;XE(j,c[t>>2]|0,+h[b>>3],+h[p+496>>3],0);p=c[t>>2]|0;b=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[b+504>>3];s=+h[b+496>>3];n=+h[b+1304>>3];r=+h[b+1296>>3];b=g+0|0;a=j+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));bF(l,p,q,s,g,n,r);g=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[d+8>>3]=+h[g+10296>>3]- +h[l>>3];XE(k,c[t>>2]|0,+h[g+504>>3],+h[g+496>>3],0);g=c[t>>2]|0;t=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[t+504>>3];n=+h[t+496>>3];s=+h[t+1304>>3];q=+h[t+1296>>3];b=f+0|0;a=k+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));fF(m,g,r,n,f,s,q);h[d+16>>3]=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+10448>>3]- +h[m>>3];i=e;return}function HX(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+65824>>3];h[c[b+8>>2]>>3]=+h[d+65800>>3];h[c[b+12>>2]>>3]=+h[d+65808>>3];i=i;return}function IX(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+4696>>3]=g;HD(f,c[a+536>>2]|0,g,+h[(c[a+416>>2]|0)+720>>3],+h[j+5496>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+5816>>3]- +h[f>>3];i=e;return}function JX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+18560>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+18536>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+18544>>3];h[a+8>>3]=+h[d+144112>>3];h[e+8>>3]=+h[d+144088>>3];h[f+8>>3]=+h[d+144096>>3];h[a+16>>3]=+h[d+18448>>3];h[e+16>>3]=+h[d+18424>>3];h[f+16>>3]=+h[d+18432>>3];i=i;return}function KX(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0;e=i;i=i+496|0;f=e;g=e+120|0;j=e+240|0;k=e+360|0;l=e+480|0;m=e+488|0;n=+h[b>>3];o=a+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[p+1320>>3]=n;q=+h[b+8>>3];h[p+10288>>3]=q;h[p+1312>>3]=+h[b+16>>3];r=+h[p+12272>>3];s=r*r;b=p+520|0;h[d>>3]=+h[p+9656>>3]*s+(r*n+(-(s*q)- +h[b>>3]*+h[p+10440>>3]));t=a+536|0;XE(j,c[t>>2]|0,+h[b>>3],+h[p+512>>3],0);p=c[t>>2]|0;b=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[b+520>>3];s=+h[b+512>>3];n=+h[b+1320>>3];r=+h[b+1312>>3];b=g+0|0;a=j+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));bF(l,p,q,s,g,n,r);g=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[d+8>>3]=+h[g+10288>>3]- +h[l>>3];XE(k,c[t>>2]|0,+h[g+520>>3],+h[g+512>>3],0);g=c[t>>2]|0;t=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[t+520>>3];n=+h[t+512>>3];s=+h[t+1320>>3];q=+h[t+1312>>3];b=f+0|0;a=k+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));fF(m,g,r,n,f,s,q);h[d+16>>3]=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+10440>>3]- +h[m>>3];i=e;return}function LX(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+65712>>3];h[c[b+8>>2]>>3]=+h[d+65688>>3];h[c[b+12>>2]>>3]=+h[d+65696>>3];i=i;return}function MX(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+4688>>3]=g;HD(f,c[a+536>>2]|0,g,+h[(c[a+416>>2]|0)+712>>3],+h[j+5488>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+5808>>3]- +h[f>>3];i=e;return}function NX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+18784>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+18760>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+18768>>3];h[a+8>>3]=+h[d+144e3>>3];h[e+8>>3]=+h[d+143976>>3];h[f+8>>3]=+h[d+143984>>3];h[a+16>>3]=+h[d+18672>>3];h[e+16>>3]=+h[d+18648>>3];h[f+16>>3]=+h[d+18656>>3];i=i;return}function OX(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0;e=i;i=i+496|0;f=e;g=e+120|0;j=e+240|0;k=e+360|0;l=e+480|0;m=e+488|0;n=+h[b>>3];o=a+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[p+1336>>3]=n;q=+h[b+8>>3];h[p+10280>>3]=q;h[p+1328>>3]=+h[b+16>>3];r=+h[p+12264>>3];s=r*r;b=p+536|0;h[d>>3]=+h[p+9648>>3]*s+(r*n+(-(s*q)- +h[b>>3]*+h[p+10432>>3]));t=a+536|0;XE(j,c[t>>2]|0,+h[b>>3],+h[p+528>>3],0);p=c[t>>2]|0;b=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[b+536>>3];s=+h[b+528>>3];n=+h[b+1336>>3];r=+h[b+1328>>3];b=g+0|0;a=j+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));bF(l,p,q,s,g,n,r);g=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[d+8>>3]=+h[g+10280>>3]- +h[l>>3];XE(k,c[t>>2]|0,+h[g+536>>3],+h[g+528>>3],0);g=c[t>>2]|0;t=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[t+536>>3];n=+h[t+528>>3];s=+h[t+1336>>3];q=+h[t+1328>>3];b=f+0|0;a=k+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));fF(m,g,r,n,f,s,q);h[d+16>>3]=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+10432>>3]- +h[m>>3];i=e;return}function PX(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+65600>>3];h[c[b+8>>2]>>3]=+h[d+65576>>3];h[c[b+12>>2]>>3]=+h[d+65584>>3];i=i;return}function QX(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+4680>>3]=g;HD(f,c[a+536>>2]|0,g,+h[(c[a+416>>2]|0)+704>>3],+h[j+5480>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+5800>>3]- +h[f>>3];i=e;return}function RX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+19008>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+18984>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+18992>>3];h[a+8>>3]=+h[d+143888>>3];h[e+8>>3]=+h[d+143864>>3];h[f+8>>3]=+h[d+143872>>3];h[a+16>>3]=+h[d+18896>>3];h[e+16>>3]=+h[d+18872>>3];h[f+16>>3]=+h[d+18880>>3];i=i;return}function SX(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0;e=i;i=i+496|0;f=e;g=e+120|0;j=e+240|0;k=e+360|0;l=e+480|0;m=e+488|0;n=+h[b>>3];o=a+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[p+1352>>3]=n;q=+h[b+8>>3];h[p+10272>>3]=q;h[p+1344>>3]=+h[b+16>>3];r=+h[p+12256>>3];s=r*r;b=p+552|0;h[d>>3]=+h[p+9640>>3]*s+(r*n+(-(s*q)- +h[b>>3]*+h[p+10424>>3]));t=a+536|0;XE(j,c[t>>2]|0,+h[b>>3],+h[p+544>>3],0);p=c[t>>2]|0;b=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[b+552>>3];s=+h[b+544>>3];n=+h[b+1352>>3];r=+h[b+1344>>3];b=g+0|0;a=j+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));bF(l,p,q,s,g,n,r);g=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[d+8>>3]=+h[g+10272>>3]- +h[l>>3];XE(k,c[t>>2]|0,+h[g+552>>3],+h[g+544>>3],0);g=c[t>>2]|0;t=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[t+552>>3];n=+h[t+544>>3];s=+h[t+1352>>3];q=+h[t+1344>>3];b=f+0|0;a=k+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));fF(m,g,r,n,f,s,q);h[d+16>>3]=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+10424>>3]- +h[m>>3];i=e;return}function TX(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+65488>>3];h[c[b+8>>2]>>3]=+h[d+65464>>3];h[c[b+12>>2]>>3]=+h[d+65472>>3];i=i;return}function UX(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+4672>>3]=g;HD(f,c[a+536>>2]|0,g,+h[(c[a+416>>2]|0)+696>>3],+h[j+5472>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+5792>>3]- +h[f>>3];i=e;return}function VX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+19232>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+19208>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+19216>>3];h[a+8>>3]=+h[d+143776>>3];h[e+8>>3]=+h[d+143752>>3];h[f+8>>3]=+h[d+143760>>3];h[a+16>>3]=+h[d+19120>>3];h[e+16>>3]=+h[d+19096>>3];h[f+16>>3]=+h[d+19104>>3];i=i;return}function WX(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0;e=i;i=i+496|0;f=e;g=e+120|0;j=e+240|0;k=e+360|0;l=e+480|0;m=e+488|0;n=+h[b>>3];o=a+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[p+1368>>3]=n;q=+h[b+8>>3];h[p+10264>>3]=q;h[p+1360>>3]=+h[b+16>>3];r=+h[p+12248>>3];s=r*r;b=p+568|0;h[d>>3]=+h[p+9632>>3]*s+(r*n+(-(s*q)- +h[b>>3]*+h[p+10416>>3]));t=a+536|0;XE(j,c[t>>2]|0,+h[b>>3],+h[p+560>>3],0);p=c[t>>2]|0;b=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[b+568>>3];s=+h[b+560>>3];n=+h[b+1368>>3];r=+h[b+1360>>3];b=g+0|0;a=j+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));bF(l,p,q,s,g,n,r);g=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[d+8>>3]=+h[g+10264>>3]- +h[l>>3];XE(k,c[t>>2]|0,+h[g+568>>3],+h[g+560>>3],0);g=c[t>>2]|0;t=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[t+568>>3];n=+h[t+560>>3];s=+h[t+1368>>3];q=+h[t+1360>>3];b=f+0|0;a=k+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));fF(m,g,r,n,f,s,q);h[d+16>>3]=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+10416>>3]- +h[m>>3];i=e;return}function XX(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+65376>>3];h[c[b+8>>2]>>3]=+h[d+65352>>3];h[c[b+12>>2]>>3]=+h[d+65360>>3];i=i;return}function YX(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+4664>>3]=g;HD(f,c[a+536>>2]|0,g,+h[(c[a+416>>2]|0)+688>>3],+h[j+5464>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+5784>>3]- +h[f>>3];i=e;return}function ZX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+19456>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+19432>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+19440>>3];h[a+8>>3]=+h[d+19344>>3];h[e+8>>3]=+h[d+19320>>3];h[f+8>>3]=+h[d+19328>>3];h[a+16>>3]=+h[d+143664>>3];h[e+16>>3]=+h[d+143640>>3];h[f+16>>3]=+h[d+143648>>3];i=i;return}function _X(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0;e=i;i=i+496|0;f=e;g=e+120|0;j=e+240|0;k=e+360|0;l=e+480|0;m=e+488|0;n=+h[b>>3];o=a+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[p+1384>>3]=n;h[p+1376>>3]=+h[b+8>>3];q=+h[b+16>>3];h[p+10256>>3]=q;r=+h[p+12240>>3];s=r*r;b=p+584|0;h[d>>3]=+h[p+9624>>3]*s+(r*n+(-(s*q)- +h[b>>3]*+h[p+10408>>3]));t=a+536|0;XE(j,c[t>>2]|0,+h[b>>3],+h[p+576>>3],0);p=c[t>>2]|0;b=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[b+584>>3];s=+h[b+576>>3];n=+h[b+1384>>3];r=+h[b+1376>>3];b=g+0|0;a=j+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));fF(l,p,q,s,g,n,r);g=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[d+8>>3]=+h[g+10408>>3]- +h[l>>3];XE(k,c[t>>2]|0,+h[g+584>>3],+h[g+576>>3],0);g=c[t>>2]|0;t=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[t+584>>3];n=+h[t+576>>3];s=+h[t+1384>>3];q=+h[t+1376>>3];b=f+0|0;a=k+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));bF(m,g,r,n,f,s,q);h[d+16>>3]=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+10256>>3]- +h[m>>3];i=e;return}function $X(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+65264>>3];h[c[b+8>>2]>>3]=+h[d+65240>>3];h[c[b+12>>2]>>3]=+h[d+65248>>3];i=i;return}function aY(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+4656>>3]=g;HD(f,c[a+536>>2]|0,g,+h[(c[a+416>>2]|0)+680>>3],+h[j+5456>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+5776>>3]- +h[f>>3];i=e;return}function bY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+19680>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+19656>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+19664>>3];h[a+8>>3]=+h[d+143552>>3];h[e+8>>3]=+h[d+143528>>3];h[f+8>>3]=+h[d+143536>>3];h[a+16>>3]=+h[d+19568>>3];h[e+16>>3]=+h[d+19544>>3];h[f+16>>3]=+h[d+19552>>3];i=i;return}function cY(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0;e=i;i=i+496|0;f=e;g=e+120|0;j=e+240|0;k=e+360|0;l=e+480|0;m=e+488|0;n=+h[b>>3];o=a+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[p+1400>>3]=n;q=+h[b+8>>3];h[p+10248>>3]=q;h[p+1392>>3]=+h[b+16>>3];r=+h[p+12232>>3];s=r*r;b=p+600|0;h[d>>3]=+h[p+9616>>3]*s+(r*n+(-(s*q)- +h[b>>3]*+h[p+10400>>3]));t=a+536|0;XE(j,c[t>>2]|0,+h[b>>3],+h[p+592>>3],0);p=c[t>>2]|0;b=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[b+600>>3];s=+h[b+592>>3];n=+h[b+1400>>3];r=+h[b+1392>>3];b=g+0|0;a=j+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));bF(l,p,q,s,g,n,r);g=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[d+8>>3]=+h[g+10248>>3]- +h[l>>3];XE(k,c[t>>2]|0,+h[g+600>>3],+h[g+592>>3],0);g=c[t>>2]|0;t=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[t+600>>3];n=+h[t+592>>3];s=+h[t+1400>>3];q=+h[t+1392>>3];b=f+0|0;a=k+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));fF(m,g,r,n,f,s,q);h[d+16>>3]=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+10400>>3]- +h[m>>3];i=e;return}function dY(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+65152>>3];h[c[b+8>>2]>>3]=+h[d+65128>>3];h[c[b+12>>2]>>3]=+h[d+65136>>3];i=i;return}function eY(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+4648>>3]=g;HD(f,c[a+536>>2]|0,g,+h[(c[a+416>>2]|0)+672>>3],+h[j+5448>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+5768>>3]- +h[f>>3];i=e;return}function fY(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+65040>>3];h[c[b+8>>2]>>3]=+h[d+65016>>3];h[c[b+12>>2]>>3]=+h[d+65024>>3];i=i;return}function gY(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0.0,j=0;e=i;i=i+8|0;f=e;g=+h[b>>3];b=a+4|0;j=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[j+4640>>3]=g;HD(f,c[a+536>>2]|0,g,+h[(c[a+416>>2]|0)+664>>3],+h[j+5440>>3]);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+5760>>3]- +h[f>>3];i=e;return}function hY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+20128>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+20104>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+20112>>3];h[a+8>>3]=+h[d+205040>>3];h[e+8>>3]=+h[d+205016>>3];h[f+8>>3]=+h[d+205024>>3];h[a+16>>3]=+h[d+20016>>3];h[e+16>>3]=+h[d+19992>>3];h[f+16>>3]=+h[d+2e4>>3];i=i;return}function iY(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0;e=i;i=i+496|0;f=e;g=e+120|0;j=e+240|0;k=e+360|0;l=e+480|0;m=e+488|0;n=+h[b>>3];o=a+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[p+1432>>3]=n;q=+h[b+8>>3];h[p+14640>>3]=q;h[p+1424>>3]=+h[b+16>>3];r=+h[p+12216>>3];s=r*r;b=p+632|0;h[d>>3]=+h[p+9600>>3]*s+(r*n+(-(s*q)- +h[b>>3]*+h[p+10384>>3]));t=a+536|0;XE(j,c[t>>2]|0,+h[b>>3],+h[p+624>>3],0);p=c[t>>2]|0;b=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[b+632>>3];s=+h[b+624>>3];n=+h[b+1432>>3];r=+h[b+1424>>3];b=g+0|0;a=j+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));bF(l,p,q,s,g,n,r);g=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[d+8>>3]=+h[g+14640>>3]- +h[l>>3];XE(k,c[t>>2]|0,+h[g+632>>3],+h[g+624>>3],0);g=c[t>>2]|0;t=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[t+632>>3];n=+h[t+624>>3];s=+h[t+1432>>3];q=+h[t+1424>>3];b=f+0|0;a=k+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));fF(m,g,r,n,f,s,q);h[d+16>>3]=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+10384>>3]- +h[m>>3];i=e;return}function jY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+19904>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+19880>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+19888>>3];h[a+8>>3]=+h[d+143440>>3];h[e+8>>3]=+h[d+143416>>3];h[f+8>>3]=+h[d+143424>>3];h[a+16>>3]=+h[d+19792>>3];h[e+16>>3]=+h[d+19768>>3];h[f+16>>3]=+h[d+19776>>3];i=i;return}function kY(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0;e=i;i=i+496|0;f=e;g=e+120|0;j=e+240|0;k=e+360|0;l=e+480|0;m=e+488|0;n=+h[b>>3];o=a+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[p+1416>>3]=n;q=+h[b+8>>3];h[p+10240>>3]=q;h[p+1408>>3]=+h[b+16>>3];r=+h[p+12224>>3];s=r*r;b=p+616|0;h[d>>3]=+h[p+9608>>3]*s+(r*n+(-(s*q)- +h[b>>3]*+h[p+10392>>3]));t=a+536|0;XE(j,c[t>>2]|0,+h[b>>3],+h[p+608>>3],0);p=c[t>>2]|0;b=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[b+616>>3];s=+h[b+608>>3];n=+h[b+1416>>3];r=+h[b+1408>>3];b=g+0|0;a=j+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));bF(l,p,q,s,g,n,r);g=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[d+8>>3]=+h[g+10240>>3]- +h[l>>3];XE(k,c[t>>2]|0,+h[g+616>>3],+h[g+608>>3],0);g=c[t>>2]|0;t=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[t+616>>3];n=+h[t+608>>3];s=+h[t+1416>>3];q=+h[t+1408>>3];b=f+0|0;a=k+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));fF(m,g,r,n,f,s,q);h[d+16>>3]=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+10392>>3]- +h[m>>3];i=e;return}function lY(a){a=a|0;c[a+4>>2]=1550;c[a>>2]=160;c[a+56>>2]=0;c[a+32>>2]=19;c[a+20>>2]=0;c[a+24>>2]=0;c[a+28>>2]=-1;c[a+36>>2]=43;c[a+84>>2]=2504;c[a+80>>2]=3;c[a+136>>2]=0;c[a+112>>2]=20;c[a+100>>2]=0;c[a+104>>2]=0;c[a+108>>2]=-1;c[a+116>>2]=44;c[a+164>>2]=2526;c[a+160>>2]=3;c[a+216>>2]=0;c[a+192>>2]=21;c[a+180>>2]=0;c[a+184>>2]=0;c[a+188>>2]=-1;c[a+196>>2]=45;c[a+244>>2]=2548;c[a+240>>2]=3;c[a+296>>2]=0;c[a+272>>2]=22;c[a+260>>2]=0;c[a+264>>2]=0;c[a+268>>2]=-1;c[a+276>>2]=46;c[a+324>>2]=2570;c[a+320>>2]=3;c[a+376>>2]=0;c[a+352>>2]=23;c[a+340>>2]=0;c[a+344>>2]=0;c[a+348>>2]=-1;c[a+356>>2]=47;c[a+404>>2]=2592;c[a+400>>2]=3;c[a+456>>2]=0;c[a+432>>2]=24;c[a+420>>2]=0;c[a+424>>2]=0;c[a+428>>2]=-1;c[a+436>>2]=48;c[a+484>>2]=2614;c[a+480>>2]=3;c[a+536>>2]=0;c[a+512>>2]=25;c[a+500>>2]=0;c[a+504>>2]=0;c[a+508>>2]=-1;c[a+516>>2]=49;c[a+564>>2]=2636;c[a+560>>2]=3;c[a+616>>2]=0;c[a+592>>2]=26;c[a+580>>2]=0;c[a+584>>2]=0;c[a+588>>2]=-1;c[a+596>>2]=50;c[a+644>>2]=2658;c[a+640>>2]=3;c[a+696>>2]=0;c[a+672>>2]=27;c[a+660>>2]=0;c[a+664>>2]=0;c[a+668>>2]=-1;c[a+676>>2]=51;c[a+724>>2]=2680;c[a+720>>2]=3;c[a+776>>2]=0;c[a+752>>2]=28;c[a+740>>2]=0;c[a+744>>2]=0;c[a+748>>2]=-1;c[a+756>>2]=52;c[a+804>>2]=2702;c[a+800>>2]=3;c[a+856>>2]=0;c[a+832>>2]=29;c[a+820>>2]=0;c[a+824>>2]=0;c[a+828>>2]=-1;c[a+836>>2]=53;c[a+884>>2]=2724;c[a+880>>2]=3;c[a+936>>2]=0;c[a+912>>2]=30;c[a+900>>2]=0;c[a+904>>2]=0;c[a+908>>2]=-1;c[a+916>>2]=54;c[a+964>>2]=2746;c[a+960>>2]=3;c[a+1016>>2]=0;c[a+992>>2]=31;c[a+980>>2]=0;c[a+984>>2]=0;c[a+988>>2]=-1;c[a+996>>2]=55;c[a+1044>>2]=2768;c[a+1040>>2]=3;c[a+1096>>2]=0;c[a+1072>>2]=32;c[a+1060>>2]=0;c[a+1064>>2]=0;c[a+1068>>2]=-1;c[a+1076>>2]=56;c[a+1124>>2]=2790;c[a+1120>>2]=3;c[a+1176>>2]=0;c[a+1152>>2]=33;c[a+1140>>2]=0;c[a+1144>>2]=0;c[a+1148>>2]=-1;c[a+1156>>2]=57;c[a+1204>>2]=2812;c[a+1200>>2]=3;c[a+1256>>2]=0;c[a+1232>>2]=34;c[a+1220>>2]=0;c[a+1224>>2]=0;c[a+1228>>2]=-1;c[a+1236>>2]=58;c[a+1284>>2]=2834;c[a+1280>>2]=3;c[a+1336>>2]=0;c[a+1312>>2]=35;c[a+1300>>2]=0;c[a+1304>>2]=0;c[a+1308>>2]=-1;c[a+1316>>2]=59;c[a+1364>>2]=2856;c[a+1360>>2]=3;c[a+1416>>2]=0;c[a+1392>>2]=36;c[a+1380>>2]=0;c[a+1384>>2]=0;c[a+1388>>2]=-1;c[a+1396>>2]=60;c[a+1444>>2]=2878;c[a+1440>>2]=3;c[a+1496>>2]=0;c[a+1472>>2]=37;c[a+1460>>2]=0;c[a+1464>>2]=0;c[a+1468>>2]=-1;c[a+1476>>2]=61;c[a+1524>>2]=2909;c[a+1520>>2]=3;c[a+1576>>2]=0;c[a+1552>>2]=38;c[a+1540>>2]=0;c[a+1544>>2]=0;c[a+1548>>2]=-1;c[a+1556>>2]=62;c[a+1604>>2]=2917;c[a+1600>>2]=3;c[a+1656>>2]=0;c[a+1632>>2]=39;c[a+1620>>2]=0;c[a+1624>>2]=0;c[a+1628>>2]=-1;c[a+1636>>2]=63;c[a+1684>>2]=2948;c[a+1680>>2]=1;c[a+1736>>2]=0;c[a+1712>>2]=40;c[a+1700>>2]=0;c[a+1704>>2]=0;c[a+1708>>2]=-1;c[a+1716>>2]=64;c[a+1764>>2]=2967;c[a+1760>>2]=3;c[a+1816>>2]=0;c[a+1792>>2]=41;c[a+1780>>2]=0;c[a+1784>>2]=0;c[a+1788>>2]=-1;c[a+1796>>2]=65;c[a+1844>>2]=2983;c[a+1840>>2]=1;c[a+1896>>2]=0;c[a+1872>>2]=42;c[a+1860>>2]=0;c[a+1864>>2]=0;c[a+1868>>2]=-1;c[a+1876>>2]=66;c[a+1924>>2]=3002;c[a+1920>>2]=3;c[a+1976>>2]=0;c[a+1952>>2]=43;c[a+1940>>2]=0;c[a+1944>>2]=0;c[a+1948>>2]=-1;c[a+1956>>2]=67;c[a+2004>>2]=3018;c[a+2e3>>2]=1;c[a+2056>>2]=0;c[a+2032>>2]=44;c[a+2020>>2]=0;c[a+2024>>2]=0;c[a+2028>>2]=-1;c[a+2036>>2]=68;c[a+2084>>2]=3037;c[a+2080>>2]=3;c[a+2136>>2]=0;c[a+2112>>2]=45;c[a+2100>>2]=0;c[a+2104>>2]=0;c[a+2108>>2]=-1;c[a+2116>>2]=69;c[a+2164>>2]=3053;c[a+2160>>2]=1;c[a+2216>>2]=0;c[a+2192>>2]=46;c[a+2180>>2]=0;c[a+2184>>2]=0;c[a+2188>>2]=-1;c[a+2196>>2]=70;c[a+2244>>2]=3072;c[a+2240>>2]=3;c[a+2296>>2]=0;c[a+2272>>2]=47;c[a+2260>>2]=0;c[a+2264>>2]=0;c[a+2268>>2]=-1;c[a+2276>>2]=71;c[a+2324>>2]=3088;c[a+2320>>2]=1;c[a+2376>>2]=0;c[a+2352>>2]=48;c[a+2340>>2]=0;c[a+2344>>2]=0;c[a+2348>>2]=-1;c[a+2356>>2]=72;c[a+2404>>2]=3107;c[a+2400>>2]=3;c[a+2456>>2]=0;c[a+2432>>2]=49;c[a+2420>>2]=0;c[a+2424>>2]=0;c[a+2428>>2]=-1;c[a+2436>>2]=73;c[a+2484>>2]=3123;c[a+2480>>2]=1;c[a+2536>>2]=0;c[a+2512>>2]=50;c[a+2500>>2]=0;c[a+2504>>2]=0;c[a+2508>>2]=-1;c[a+2516>>2]=74;c[a+2564>>2]=3142;c[a+2560>>2]=3;c[a+2616>>2]=0;c[a+2592>>2]=51;c[a+2580>>2]=0;c[a+2584>>2]=0;c[a+2588>>2]=-1;c[a+2596>>2]=75;c[a+2644>>2]=3158;c[a+2640>>2]=1;c[a+2696>>2]=0;c[a+2672>>2]=52;c[a+2660>>2]=0;c[a+2664>>2]=0;c[a+2668>>2]=-1;c[a+2676>>2]=76;c[a+2724>>2]=3177;c[a+2720>>2]=3;c[a+2776>>2]=0;c[a+2752>>2]=53;c[a+2740>>2]=0;c[a+2744>>2]=0;c[a+2748>>2]=-1;c[a+2756>>2]=77;c[a+2804>>2]=3193;c[a+2800>>2]=1;c[a+2856>>2]=0;c[a+2832>>2]=54;c[a+2820>>2]=0;c[a+2824>>2]=0;c[a+2828>>2]=-1;c[a+2836>>2]=78;c[a+2884>>2]=3212;c[a+2880>>2]=3;c[a+2936>>2]=0;c[a+2912>>2]=55;c[a+2900>>2]=0;c[a+2904>>2]=0;c[a+2908>>2]=-1;c[a+2916>>2]=79;c[a+2964>>2]=3228;c[a+2960>>2]=1;c[a+3016>>2]=0;c[a+2992>>2]=56;c[a+2980>>2]=0;c[a+2984>>2]=0;c[a+2988>>2]=-1;c[a+2996>>2]=80;c[a+3044>>2]=3247;c[a+3040>>2]=3;c[a+3096>>2]=0;c[a+3072>>2]=57;c[a+3060>>2]=0;c[a+3064>>2]=0;c[a+3068>>2]=-1;c[a+3076>>2]=81;c[a+3124>>2]=3263;c[a+3120>>2]=1;c[a+3176>>2]=0;c[a+3152>>2]=58;c[a+3140>>2]=0;c[a+3144>>2]=0;c[a+3148>>2]=-1;c[a+3156>>2]=82;c[a+3204>>2]=3282;c[a+3200>>2]=3;c[a+3256>>2]=0;c[a+3232>>2]=59;c[a+3220>>2]=0;c[a+3224>>2]=0;c[a+3228>>2]=-1;c[a+3236>>2]=83;c[a+3284>>2]=3298;c[a+3280>>2]=1;c[a+3336>>2]=0;c[a+3312>>2]=60;c[a+3300>>2]=0;c[a+3304>>2]=0;c[a+3308>>2]=-1;c[a+3316>>2]=84;c[a+3364>>2]=3317;c[a+3360>>2]=3;c[a+3416>>2]=0;c[a+3392>>2]=61;c[a+3380>>2]=0;c[a+3384>>2]=0;c[a+3388>>2]=-1;c[a+3396>>2]=85;c[a+3444>>2]=3333;c[a+3440>>2]=1;c[a+3496>>2]=0;c[a+3472>>2]=62;c[a+3460>>2]=0;c[a+3464>>2]=0;c[a+3468>>2]=-1;c[a+3476>>2]=86;c[a+3524>>2]=3352;c[a+3520>>2]=3;c[a+3576>>2]=0;c[a+3552>>2]=63;c[a+3540>>2]=0;c[a+3544>>2]=0;c[a+3548>>2]=-1;c[a+3556>>2]=87;c[a+3604>>2]=3368;c[a+3600>>2]=1;c[a+3656>>2]=0;c[a+3632>>2]=64;c[a+3620>>2]=0;c[a+3624>>2]=0;c[a+3628>>2]=-1;c[a+3636>>2]=88;c[a+3684>>2]=3387;c[a+3680>>2]=3;c[a+3736>>2]=0;c[a+3712>>2]=65;c[a+3700>>2]=0;c[a+3704>>2]=0;c[a+3708>>2]=-1;c[a+3716>>2]=89;c[a+3764>>2]=3403;c[a+3760>>2]=1;c[a+3816>>2]=0;c[a+3792>>2]=66;c[a+3780>>2]=0;c[a+3784>>2]=0;c[a+3788>>2]=-1;c[a+3796>>2]=90;c[a+3844>>2]=3422;c[a+3840>>2]=3;c[a+3896>>2]=0;c[a+3872>>2]=67;c[a+3860>>2]=0;c[a+3864>>2]=0;c[a+3868>>2]=-1;c[a+3876>>2]=91;c[a+3924>>2]=3438;c[a+3920>>2]=1;c[a+3976>>2]=0;c[a+3952>>2]=68;c[a+3940>>2]=0;c[a+3944>>2]=0;c[a+3948>>2]=-1;c[a+3956>>2]=92;c[a+4004>>2]=3457;c[a+4e3>>2]=3;c[a+4056>>2]=0;c[a+4032>>2]=69;c[a+4020>>2]=0;c[a+4024>>2]=0;c[a+4028>>2]=-1;c[a+4036>>2]=93;c[a+4084>>2]=3473;c[a+4080>>2]=1;c[a+4136>>2]=0;c[a+4112>>2]=70;c[a+4100>>2]=0;c[a+4104>>2]=0;c[a+4108>>2]=-1;c[a+4116>>2]=94;c[a+4164>>2]=3492;c[a+4160>>2]=3;c[a+4216>>2]=0;c[a+4192>>2]=71;c[a+4180>>2]=0;c[a+4184>>2]=0;c[a+4188>>2]=-1;c[a+4196>>2]=95;c[a+4244>>2]=3508;c[a+4240>>2]=1;c[a+4296>>2]=0;c[a+4272>>2]=72;c[a+4260>>2]=0;c[a+4264>>2]=0;c[a+4268>>2]=-1;c[a+4276>>2]=96;c[a+4324>>2]=3527;c[a+4320>>2]=3;c[a+4376>>2]=0;c[a+4352>>2]=73;c[a+4340>>2]=0;c[a+4344>>2]=0;c[a+4348>>2]=-1;c[a+4356>>2]=97;c[a+4404>>2]=3543;c[a+4400>>2]=1;c[a+4456>>2]=0;c[a+4432>>2]=74;c[a+4420>>2]=0;c[a+4424>>2]=0;c[a+4428>>2]=-1;c[a+4436>>2]=98;c[a+4484>>2]=3562;c[a+4480>>2]=3;c[a+4536>>2]=0;c[a+4512>>2]=75;c[a+4500>>2]=0;c[a+4504>>2]=0;c[a+4508>>2]=-1;c[a+4516>>2]=99;c[a+4564>>2]=3578;c[a+4560>>2]=1;c[a+4616>>2]=0;c[a+4592>>2]=76;c[a+4580>>2]=0;c[a+4584>>2]=0;c[a+4588>>2]=-1;c[a+4596>>2]=100;c[a+4644>>2]=3602;c[a+4640>>2]=1;c[a+4696>>2]=0;c[a+4672>>2]=77;c[a+4660>>2]=0;c[a+4664>>2]=0;c[a+4668>>2]=-1;c[a+4676>>2]=101;c[a+4724>>2]=3613;c[a+4720>>2]=3;c[a+4776>>2]=0;c[a+4752>>2]=78;c[a+4740>>2]=0;c[a+4744>>2]=0;c[a+4748>>2]=-1;c[a+4756>>2]=102;c[a+4804>>2]=3620;c[a+4800>>2]=3;c[a+4856>>2]=0;c[a+4832>>2]=79;c[a+4820>>2]=0;c[a+4824>>2]=0;c[a+4828>>2]=-1;c[a+4836>>2]=103;i=i;return}function mY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0;e=i;f=d+8|0;ze[c[f>>2]&3](0,0,-1.0,0,d);g=c[f>>2]|0;j=b+416|0;k=c[j>>2]|0;l=+h[k+2704>>3];m=+h[k+2672>>3];n=+h[k+2680>>3];do{if(m!=0.0){o=n/m}else{if(n==0.0){o=n;break}o=n/+qXa(c[b+536>>2]|0,m,50128,50120,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);ze[g&3](0,1,l*o*-.05,1,d);ze[c[f>>2]&3](1,0,1.0,2,d);g=c[j>>2]|0;ze[c[f>>2]&3](1,1,-(+h[g+3184>>3]*+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+14296>>3]*+h[g+3176>>3]),3,d);i=e;return}function nY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0;e=i;f=b+416|0;g=c[f>>2]|0;j=+h[g+2704>>3];k=b+4|0;l=c[c[k>>2]>>2]|0;m=c[l+8>>2]|0;n=+h[m+640>>3];o=+h[g+2672>>3];p=+h[g+2680>>3];do{if(o!=0.0){q=m;r=g;s=p/o}else{if(p==0.0){q=m;r=g;s=p;break}t=p/+qXa(c[b+536>>2]|0,o,50128,50144,+h[l>>3],(a[b+319|0]|0)!=0|0);q=c[(c[c[k>>2]>>2]|0)+8>>2]|0;r=c[f>>2]|0;s=t}}while(0);f=c[d+36>>2]|0;h[f>>3]=j*n*s*-.05;h[f+8>>3]=-(+h[r+3184>>3]*+h[q+14296>>3]*+h[q>>3]*+h[r+3176>>3]);i=e;return}function oY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0;e=i;f=d+8|0;ze[c[f>>2]&3](0,0,-1.0,0,d);g=c[f>>2]|0;j=b+416|0;k=c[j>>2]|0;l=+h[k+2704>>3];m=+h[k+2672>>3];n=+h[k+2680>>3];do{if(m!=0.0){o=n/m}else{if(n==0.0){o=n;break}o=n/+qXa(c[b+536>>2]|0,m,50128,50152,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);ze[g&3](0,1,l*o*-.05,1,d);ze[c[f>>2]&3](1,0,1.0,2,d);g=c[j>>2]|0;ze[c[f>>2]&3](1,1,-(+h[g+3184>>3]*+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+14288>>3]*+h[g+3176>>3]),3,d);i=e;return}function pY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0;e=i;f=b+416|0;g=c[f>>2]|0;j=+h[g+2704>>3];k=b+4|0;l=c[c[k>>2]>>2]|0;m=c[l+8>>2]|0;n=+h[m+648>>3];o=+h[g+2672>>3];p=+h[g+2680>>3];do{if(o!=0.0){q=m;r=g;s=p/o}else{if(p==0.0){q=m;r=g;s=p;break}t=p/+qXa(c[b+536>>2]|0,o,50128,50160,+h[l>>3],(a[b+319|0]|0)!=0|0);q=c[(c[c[k>>2]>>2]|0)+8>>2]|0;r=c[f>>2]|0;s=t}}while(0);f=c[d+36>>2]|0;h[f>>3]=j*n*s*-.05;h[f+8>>3]=-(+h[r+3184>>3]*+h[q+14288>>3]*+h[q+16>>3]*+h[r+3176>>3]);i=e;return}function qY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0;e=i;f=d+8|0;g=c[f>>2]|0;j=b+416|0;k=c[j>>2]|0;l=+h[k+2704>>3];m=+h[k+2672>>3];n=+h[k+2680>>3];do{if(m!=0.0){o=n/m}else{if(n==0.0){o=n;break}o=n/+qXa(c[b+536>>2]|0,m,50128,50168,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);ze[g&3](0,0,l*o*-.05,0,d);ze[c[f>>2]&3](0,1,-1.0,1,d);g=c[j>>2]|0;ze[c[f>>2]&3](1,0,-(+h[g+3184>>3]*+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+14280>>3]*+h[g+3176>>3]),2,d);ze[c[f>>2]&3](1,1,1.0,3,d);i=e;return}function rY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0;e=i;f=b+416|0;g=c[f>>2]|0;j=+h[g+2704>>3];k=b+4|0;l=c[c[k>>2]>>2]|0;m=c[l+8>>2]|0;n=+h[m+656>>3];o=+h[g+2672>>3];p=+h[g+2680>>3];do{if(o!=0.0){q=m;r=g;s=p/o}else{if(p==0.0){q=m;r=g;s=p;break}t=p/+qXa(c[b+536>>2]|0,o,50128,50176,+h[l>>3],(a[b+319|0]|0)!=0|0);q=c[(c[c[k>>2]>>2]|0)+8>>2]|0;r=c[f>>2]|0;s=t}}while(0);f=c[d+36>>2]|0;h[f>>3]=j*n*s*-.05;h[f+8>>3]=-(+h[r+3184>>3]*+h[q+14280>>3]*+h[q+32>>3]*+h[r+3176>>3]);i=e;return}function sY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0;e=i;f=d+8|0;ze[c[f>>2]&3](0,0,-1.0,0,d);g=c[f>>2]|0;j=b+416|0;k=c[j>>2]|0;l=+h[k+2704>>3];m=+h[k+2672>>3];n=+h[k+2680>>3];do{if(m!=0.0){o=n/m}else{if(n==0.0){o=n;break}o=n/+qXa(c[b+536>>2]|0,m,50128,50184,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);ze[g&3](0,1,l*o*-.05,1,d);ze[c[f>>2]&3](1,0,1.0,2,d);g=c[j>>2]|0;ze[c[f>>2]&3](1,1,-(+h[g+3184>>3]*+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+14272>>3]*+h[g+3176>>3]),3,d);i=e;return}function tY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0;e=i;f=b+416|0;g=c[f>>2]|0;j=+h[g+2704>>3];k=b+4|0;l=c[c[k>>2]>>2]|0;m=c[l+8>>2]|0;n=+h[m+664>>3];o=+h[g+2672>>3];p=+h[g+2680>>3];do{if(o!=0.0){q=m;r=g;s=p/o}else{if(p==0.0){q=m;r=g;s=p;break}t=p/+qXa(c[b+536>>2]|0,o,50128,50192,+h[l>>3],(a[b+319|0]|0)!=0|0);q=c[(c[c[k>>2]>>2]|0)+8>>2]|0;r=c[f>>2]|0;s=t}}while(0);f=c[d+36>>2]|0;h[f>>3]=j*n*s*-.05;h[f+8>>3]=-(+h[r+3184>>3]*+h[q+14272>>3]*+h[q+48>>3]*+h[r+3176>>3]);i=e;return}function uY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0;e=i;f=d+8|0;ze[c[f>>2]&3](0,0,-1.0,0,d);g=c[f>>2]|0;j=b+416|0;k=c[j>>2]|0;l=+h[k+2704>>3];m=+h[k+2672>>3];n=+h[k+2680>>3];do{if(m!=0.0){o=n/m}else{if(n==0.0){o=n;break}o=n/+qXa(c[b+536>>2]|0,m,50128,50200,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);ze[g&3](0,1,l*o*-.05,1,d);ze[c[f>>2]&3](1,0,1.0,2,d);g=c[j>>2]|0;ze[c[f>>2]&3](1,1,-(+h[g+3184>>3]*+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+14264>>3]*+h[g+3176>>3]),3,d);i=e;return}function vY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0;e=i;f=b+416|0;g=c[f>>2]|0;j=+h[g+2704>>3];k=b+4|0;l=c[c[k>>2]>>2]|0;m=c[l+8>>2]|0;n=+h[m+672>>3];o=+h[g+2672>>3];p=+h[g+2680>>3];do{if(o!=0.0){q=m;r=g;s=p/o}else{if(p==0.0){q=m;r=g;s=p;break}t=p/+qXa(c[b+536>>2]|0,o,50128,50208,+h[l>>3],(a[b+319|0]|0)!=0|0);q=c[(c[c[k>>2]>>2]|0)+8>>2]|0;r=c[f>>2]|0;s=t}}while(0);f=c[d+36>>2]|0;h[f>>3]=j*n*s*-.05;h[f+8>>3]=-(+h[r+3184>>3]*+h[q+14264>>3]*+h[q+64>>3]*+h[r+3176>>3]);i=e;return}function wY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0;e=i;f=d+8|0;g=c[f>>2]|0;j=b+416|0;k=c[j>>2]|0;l=+h[k+2704>>3];m=+h[k+2672>>3];n=+h[k+2680>>3];do{if(m!=0.0){o=n/m}else{if(n==0.0){o=n;break}o=n/+qXa(c[b+536>>2]|0,m,50128,50216,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);ze[g&3](0,0,l*o*-.05,0,d);ze[c[f>>2]&3](0,1,-1.0,1,d);g=c[j>>2]|0;ze[c[f>>2]&3](1,0,-(+h[g+3184>>3]*+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+14256>>3]*+h[g+3176>>3]),2,d);ze[c[f>>2]&3](1,1,1.0,3,d);i=e;return}function xY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0;e=i;f=b+416|0;g=c[f>>2]|0;j=+h[g+2704>>3];k=b+4|0;l=c[c[k>>2]>>2]|0;m=c[l+8>>2]|0;n=+h[m+680>>3];o=+h[g+2672>>3];p=+h[g+2680>>3];do{if(o!=0.0){q=m;r=g;s=p/o}else{if(p==0.0){q=m;r=g;s=p;break}t=p/+qXa(c[b+536>>2]|0,o,50128,50224,+h[l>>3],(a[b+319|0]|0)!=0|0);q=c[(c[c[k>>2]>>2]|0)+8>>2]|0;r=c[f>>2]|0;s=t}}while(0);f=c[d+36>>2]|0;h[f>>3]=j*n*s*-.05;h[f+8>>3]=-(+h[r+3184>>3]*+h[q+14256>>3]*+h[q+80>>3]*+h[r+3176>>3]);i=e;return}function yY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0;e=i;f=d+8|0;ze[c[f>>2]&3](0,0,-1.0,0,d);g=c[f>>2]|0;j=b+416|0;k=c[j>>2]|0;l=+h[k+2704>>3];m=+h[k+2672>>3];n=+h[k+2680>>3];do{if(m!=0.0){o=n/m}else{if(n==0.0){o=n;break}o=n/+qXa(c[b+536>>2]|0,m,50128,50232,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);ze[g&3](0,1,l*o*-.05,1,d);ze[c[f>>2]&3](1,0,1.0,2,d);g=c[j>>2]|0;ze[c[f>>2]&3](1,1,-(+h[g+3184>>3]*+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+14248>>3]*+h[g+3176>>3]),3,d);i=e;return}function zY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0;e=i;f=b+416|0;g=c[f>>2]|0;j=+h[g+2704>>3];k=b+4|0;l=c[c[k>>2]>>2]|0;m=c[l+8>>2]|0;n=+h[m+688>>3];o=+h[g+2672>>3];p=+h[g+2680>>3];do{if(o!=0.0){q=m;r=g;s=p/o}else{if(p==0.0){q=m;r=g;s=p;break}t=p/+qXa(c[b+536>>2]|0,o,50128,50240,+h[l>>3],(a[b+319|0]|0)!=0|0);q=c[(c[c[k>>2]>>2]|0)+8>>2]|0;r=c[f>>2]|0;s=t}}while(0);f=c[d+36>>2]|0;h[f>>3]=j*n*s*-.05;h[f+8>>3]=-(+h[r+3184>>3]*+h[q+14248>>3]*+h[q+96>>3]*+h[r+3176>>3]);i=e;return}function AY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0;e=i;f=d+8|0;ze[c[f>>2]&3](0,0,-1.0,0,d);g=c[f>>2]|0;j=b+416|0;k=c[j>>2]|0;l=+h[k+2704>>3];m=+h[k+2672>>3];n=+h[k+2680>>3];do{if(m!=0.0){o=n/m}else{if(n==0.0){o=n;break}o=n/+qXa(c[b+536>>2]|0,m,50128,50248,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);ze[g&3](0,1,l*o*-.05,1,d);ze[c[f>>2]&3](1,0,1.0,2,d);g=c[j>>2]|0;ze[c[f>>2]&3](1,1,-(+h[g+3184>>3]*+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+14240>>3]*+h[g+3176>>3]),3,d);i=e;return}function BY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0;e=i;f=b+416|0;g=c[f>>2]|0;j=+h[g+2704>>3];k=b+4|0;l=c[c[k>>2]>>2]|0;m=c[l+8>>2]|0;n=+h[m+696>>3];o=+h[g+2672>>3];p=+h[g+2680>>3];do{if(o!=0.0){q=m;r=g;s=p/o}else{if(p==0.0){q=m;r=g;s=p;break}t=p/+qXa(c[b+536>>2]|0,o,50128,50256,+h[l>>3],(a[b+319|0]|0)!=0|0);q=c[(c[c[k>>2]>>2]|0)+8>>2]|0;r=c[f>>2]|0;s=t}}while(0);f=c[d+36>>2]|0;h[f>>3]=j*n*s*-.05;h[f+8>>3]=-(+h[r+3184>>3]*+h[q+14240>>3]*+h[q+112>>3]*+h[r+3176>>3]);i=e;return}function CY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0;e=i;f=d+8|0;ze[c[f>>2]&3](0,0,-1.0,0,d);g=c[f>>2]|0;j=b+416|0;k=c[j>>2]|0;l=+h[k+2704>>3];m=+h[k+2672>>3];n=+h[k+2680>>3];do{if(m!=0.0){o=n/m}else{if(n==0.0){o=n;break}o=n/+qXa(c[b+536>>2]|0,m,50128,50264,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);ze[g&3](0,1,l*o*-.05,1,d);ze[c[f>>2]&3](1,0,1.0,2,d);g=c[j>>2]|0;ze[c[f>>2]&3](1,1,-(+h[g+3184>>3]*+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+14232>>3]*+h[g+3176>>3]),3,d);i=e;return}function DY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0;e=i;f=b+416|0;g=c[f>>2]|0;j=+h[g+2704>>3];k=b+4|0;l=c[c[k>>2]>>2]|0;m=c[l+8>>2]|0;n=+h[m+704>>3];o=+h[g+2672>>3];p=+h[g+2680>>3];do{if(o!=0.0){q=m;r=g;s=p/o}else{if(p==0.0){q=m;r=g;s=p;break}t=p/+qXa(c[b+536>>2]|0,o,50128,50272,+h[l>>3],(a[b+319|0]|0)!=0|0);q=c[(c[c[k>>2]>>2]|0)+8>>2]|0;r=c[f>>2]|0;s=t}}while(0);f=c[d+36>>2]|0;h[f>>3]=j*n*s*-.05;h[f+8>>3]=-(+h[r+3184>>3]*+h[q+14232>>3]*+h[q+128>>3]*+h[r+3176>>3]);i=e;return}function EY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0;e=i;f=d+8|0;ze[c[f>>2]&3](0,0,-1.0,0,d);g=c[f>>2]|0;j=b+416|0;k=c[j>>2]|0;l=+h[k+2704>>3];m=+h[k+2672>>3];n=+h[k+2680>>3];do{if(m!=0.0){o=n/m}else{if(n==0.0){o=n;break}o=n/+qXa(c[b+536>>2]|0,m,50128,50280,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);ze[g&3](0,1,l*o*-.05,1,d);ze[c[f>>2]&3](1,0,1.0,2,d);g=c[j>>2]|0;ze[c[f>>2]&3](1,1,-(+h[g+3184>>3]*+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+14224>>3]*+h[g+3176>>3]),3,d);i=e;return}function FY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0;e=i;f=b+416|0;g=c[f>>2]|0;j=+h[g+2704>>3];k=b+4|0;l=c[c[k>>2]>>2]|0;m=c[l+8>>2]|0;n=+h[m+712>>3];o=+h[g+2672>>3];p=+h[g+2680>>3];do{if(o!=0.0){q=m;r=g;s=p/o}else{if(p==0.0){q=m;r=g;s=p;break}t=p/+qXa(c[b+536>>2]|0,o,50128,50288,+h[l>>3],(a[b+319|0]|0)!=0|0);q=c[(c[c[k>>2]>>2]|0)+8>>2]|0;r=c[f>>2]|0;s=t}}while(0);f=c[d+36>>2]|0;h[f>>3]=j*n*s*-.05;h[f+8>>3]=-(+h[r+3184>>3]*+h[q+14224>>3]*+h[q+144>>3]*+h[r+3176>>3]);i=e;return}function GY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0;e=i;f=d+8|0;ze[c[f>>2]&3](0,0,-1.0,0,d);g=c[f>>2]|0;j=b+416|0;k=c[j>>2]|0;l=+h[k+2704>>3];m=+h[k+2672>>3];n=+h[k+2680>>3];do{if(m!=0.0){o=n/m}else{if(n==0.0){o=n;break}o=n/+qXa(c[b+536>>2]|0,m,50128,50296,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);ze[g&3](0,1,l*o*-.05,1,d);ze[c[f>>2]&3](1,0,1.0,2,d);g=c[j>>2]|0;ze[c[f>>2]&3](1,1,-(+h[g+3184>>3]*+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+14216>>3]*+h[g+3176>>3]),3,d);i=e;return}function HY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0;e=i;f=b+416|0;g=c[f>>2]|0;j=+h[g+2704>>3];k=b+4|0;l=c[c[k>>2]>>2]|0;m=c[l+8>>2]|0;n=+h[m+720>>3];o=+h[g+2672>>3];p=+h[g+2680>>3];do{if(o!=0.0){q=m;r=g;s=p/o}else{if(p==0.0){q=m;r=g;s=p;break}t=p/+qXa(c[b+536>>2]|0,o,50128,50304,+h[l>>3],(a[b+319|0]|0)!=0|0);q=c[(c[c[k>>2]>>2]|0)+8>>2]|0;r=c[f>>2]|0;s=t}}while(0);f=c[d+36>>2]|0;h[f>>3]=j*n*s*-.05;h[f+8>>3]=-(+h[r+3184>>3]*+h[q+14216>>3]*+h[q+160>>3]*+h[r+3176>>3]);i=e;return}function IY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0;e=i;f=d+8|0;ze[c[f>>2]&3](0,0,-1.0,0,d);g=c[f>>2]|0;j=b+416|0;k=c[j>>2]|0;l=+h[k+2704>>3];m=+h[k+2672>>3];n=+h[k+2680>>3];do{if(m!=0.0){o=n/m}else{if(n==0.0){o=n;break}o=n/+qXa(c[b+536>>2]|0,m,50128,50312,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);ze[g&3](0,1,l*o*-.05,1,d);ze[c[f>>2]&3](1,0,1.0,2,d);g=c[j>>2]|0;ze[c[f>>2]&3](1,1,-(+h[g+3184>>3]*+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+14208>>3]*+h[g+3176>>3]),3,d);i=e;return}function JY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0;e=i;f=b+416|0;g=c[f>>2]|0;j=+h[g+2704>>3];k=b+4|0;l=c[c[k>>2]>>2]|0;m=c[l+8>>2]|0;n=+h[m+728>>3];o=+h[g+2672>>3];p=+h[g+2680>>3];do{if(o!=0.0){q=m;r=g;s=p/o}else{if(p==0.0){q=m;r=g;s=p;break}t=p/+qXa(c[b+536>>2]|0,o,50128,50320,+h[l>>3],(a[b+319|0]|0)!=0|0);q=c[(c[c[k>>2]>>2]|0)+8>>2]|0;r=c[f>>2]|0;s=t}}while(0);f=c[d+36>>2]|0;h[f>>3]=j*n*s*-.05;h[f+8>>3]=-(+h[r+3184>>3]*+h[q+14208>>3]*+h[q+176>>3]*+h[r+3176>>3]);i=e;return}function KY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0;e=i;f=d+8|0;ze[c[f>>2]&3](0,0,-1.0,0,d);g=c[f>>2]|0;j=b+416|0;k=c[j>>2]|0;l=+h[k+2704>>3];m=+h[k+2672>>3];n=+h[k+2680>>3];do{if(m!=0.0){o=n/m}else{if(n==0.0){o=n;break}o=n/+qXa(c[b+536>>2]|0,m,50128,50328,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);ze[g&3](0,1,l*o*-.05,1,d);ze[c[f>>2]&3](1,0,1.0,2,d);g=c[j>>2]|0;ze[c[f>>2]&3](1,1,-(+h[g+3184>>3]*+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+14200>>3]*+h[g+3176>>3]),3,d);i=e;return}function LY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0;e=i;f=b+416|0;g=c[f>>2]|0;j=+h[g+2704>>3];k=b+4|0;l=c[c[k>>2]>>2]|0;m=c[l+8>>2]|0;n=+h[m+736>>3];o=+h[g+2672>>3];p=+h[g+2680>>3];do{if(o!=0.0){q=m;r=g;s=p/o}else{if(p==0.0){q=m;r=g;s=p;break}t=p/+qXa(c[b+536>>2]|0,o,50128,50336,+h[l>>3],(a[b+319|0]|0)!=0|0);q=c[(c[c[k>>2]>>2]|0)+8>>2]|0;r=c[f>>2]|0;s=t}}while(0);f=c[d+36>>2]|0;h[f>>3]=j*n*s*-.05;h[f+8>>3]=-(+h[r+3184>>3]*+h[q+14200>>3]*+h[q+192>>3]*+h[r+3176>>3]);i=e;return}function MY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0;e=i;f=d+8|0;ze[c[f>>2]&3](0,0,-1.0,0,d);g=c[f>>2]|0;j=b+416|0;k=c[j>>2]|0;l=+h[k+2704>>3];m=+h[k+2672>>3];n=+h[k+2680>>3];do{if(m!=0.0){o=n/m}else{if(n==0.0){o=n;break}o=n/+qXa(c[b+536>>2]|0,m,50128,50344,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);ze[g&3](0,1,l*o*-.05,1,d);ze[c[f>>2]&3](1,0,1.0,2,d);g=c[j>>2]|0;ze[c[f>>2]&3](1,1,-(+h[g+3184>>3]*+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+14192>>3]*+h[g+3176>>3]),3,d);i=e;return}function NY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0;e=i;f=b+416|0;g=c[f>>2]|0;j=+h[g+2704>>3];k=b+4|0;l=c[c[k>>2]>>2]|0;m=c[l+8>>2]|0;n=+h[m+744>>3];o=+h[g+2672>>3];p=+h[g+2680>>3];do{if(o!=0.0){q=m;r=g;s=p/o}else{if(p==0.0){q=m;r=g;s=p;break}t=p/+qXa(c[b+536>>2]|0,o,50128,50352,+h[l>>3],(a[b+319|0]|0)!=0|0);q=c[(c[c[k>>2]>>2]|0)+8>>2]|0;r=c[f>>2]|0;s=t}}while(0);f=c[d+36>>2]|0;h[f>>3]=j*n*s*-.05;h[f+8>>3]=-(+h[r+3184>>3]*+h[q+14192>>3]*+h[q+208>>3]*+h[r+3176>>3]);i=e;return}function OY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0;e=i;f=d+8|0;g=c[f>>2]|0;j=b+416|0;k=c[j>>2]|0;l=+h[k+2704>>3];m=+h[k+2672>>3];n=+h[k+2680>>3];do{if(m!=0.0){o=n/m}else{if(n==0.0){o=n;break}o=n/+qXa(c[b+536>>2]|0,m,50128,50360,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);ze[g&3](0,0,l*o*-.05,0,d);ze[c[f>>2]&3](0,1,-1.0,1,d);g=c[j>>2]|0;ze[c[f>>2]&3](1,0,-(+h[g+3184>>3]*+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+14184>>3]*+h[g+3176>>3]),2,d);ze[c[f>>2]&3](1,1,1.0,3,d);i=e;return}function PY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0;e=i;f=b+416|0;g=c[f>>2]|0;j=+h[g+2704>>3];k=b+4|0;l=c[c[k>>2]>>2]|0;m=c[l+8>>2]|0;n=+h[m+752>>3];o=+h[g+2672>>3];p=+h[g+2680>>3];do{if(o!=0.0){q=m;r=g;s=p/o}else{if(p==0.0){q=m;r=g;s=p;break}t=p/+qXa(c[b+536>>2]|0,o,50128,50368,+h[l>>3],(a[b+319|0]|0)!=0|0);q=c[(c[c[k>>2]>>2]|0)+8>>2]|0;r=c[f>>2]|0;s=t}}while(0);f=c[d+36>>2]|0;h[f>>3]=j*n*s*-.05;h[f+8>>3]=-(+h[r+3184>>3]*+h[q+14184>>3]*+h[q+224>>3]*+h[r+3176>>3]);i=e;return}function QY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0;e=i;f=d+8|0;ze[c[f>>2]&3](0,0,-1.0,0,d);g=c[f>>2]|0;j=b+416|0;k=c[j>>2]|0;l=+h[k+2704>>3];m=+h[k+2672>>3];n=+h[k+2680>>3];do{if(m!=0.0){o=n/m}else{if(n==0.0){o=n;break}o=n/+qXa(c[b+536>>2]|0,m,50128,50376,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);ze[g&3](0,1,l*o*-.05,1,d);ze[c[f>>2]&3](1,0,1.0,2,d);g=c[j>>2]|0;ze[c[f>>2]&3](1,1,-(+h[g+3184>>3]*+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+14176>>3]*+h[g+3176>>3]),3,d);i=e;return}function RY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0;e=i;f=b+416|0;g=c[f>>2]|0;j=+h[g+2704>>3];k=b+4|0;l=c[c[k>>2]>>2]|0;m=c[l+8>>2]|0;n=+h[m+760>>3];o=+h[g+2672>>3];p=+h[g+2680>>3];do{if(o!=0.0){q=m;r=g;s=p/o}else{if(p==0.0){q=m;r=g;s=p;break}t=p/+qXa(c[b+536>>2]|0,o,50128,50384,+h[l>>3],(a[b+319|0]|0)!=0|0);q=c[(c[c[k>>2]>>2]|0)+8>>2]|0;r=c[f>>2]|0;s=t}}while(0);f=c[d+36>>2]|0;h[f>>3]=j*n*s*-.05;h[f+8>>3]=-(+h[r+3184>>3]*+h[q+14176>>3]*+h[q+240>>3]*+h[r+3176>>3]);i=e;return}function SY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0;e=i;f=d+8|0;ze[c[f>>2]&3](0,0,-1.0,0,d);g=c[f>>2]|0;j=b+416|0;k=c[j>>2]|0;l=+h[k+2704>>3];m=+h[k+2672>>3];n=+h[k+2680>>3];do{if(m!=0.0){o=n/m}else{if(n==0.0){o=n;break}o=n/+qXa(c[b+536>>2]|0,m,50128,50392,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);ze[g&3](0,1,l*o*-.05,1,d);ze[c[f>>2]&3](1,0,1.0,2,d);g=c[j>>2]|0;ze[c[f>>2]&3](1,1,-(+h[g+3184>>3]*+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+14168>>3]*+h[g+3176>>3]),3,d);i=e;return}function TY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0;e=i;f=b+416|0;g=c[f>>2]|0;j=+h[g+2704>>3];k=b+4|0;l=c[c[k>>2]>>2]|0;m=c[l+8>>2]|0;n=+h[m+768>>3];o=+h[g+2672>>3];p=+h[g+2680>>3];do{if(o!=0.0){q=m;r=g;s=p/o}else{if(p==0.0){q=m;r=g;s=p;break}t=p/+qXa(c[b+536>>2]|0,o,50128,50400,+h[l>>3],(a[b+319|0]|0)!=0|0);q=c[(c[c[k>>2]>>2]|0)+8>>2]|0;r=c[f>>2]|0;s=t}}while(0);f=c[d+36>>2]|0;h[f>>3]=j*n*s*-.05;h[f+8>>3]=-(+h[r+3184>>3]*+h[q+14168>>3]*+h[q+256>>3]*+h[r+3176>>3]);i=e;return}function UY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0;e=i;f=d+8|0;ze[c[f>>2]&3](0,0,-1.0,0,d);g=c[f>>2]|0;j=b+416|0;k=c[j>>2]|0;l=+h[k+2704>>3];m=+h[k+2672>>3];n=+h[k+2680>>3];do{if(m!=0.0){o=n/m}else{if(n==0.0){o=n;break}o=n/+qXa(c[b+536>>2]|0,m,50128,50408,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);ze[g&3](0,1,l*o*-.05,1,d);ze[c[f>>2]&3](1,0,1.0,2,d);g=c[j>>2]|0;ze[c[f>>2]&3](1,1,-(+h[g+3184>>3]*+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+14160>>3]*+h[g+3176>>3]),3,d);i=e;return}function VY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0;e=i;f=b+416|0;g=c[f>>2]|0;j=+h[g+2704>>3];k=b+4|0;l=c[c[k>>2]>>2]|0;m=c[l+8>>2]|0;n=+h[m+776>>3];o=+h[g+2672>>3];p=+h[g+2680>>3];do{if(o!=0.0){q=m;r=g;s=p/o}else{if(p==0.0){q=m;r=g;s=p;break}t=p/+qXa(c[b+536>>2]|0,o,50128,50416,+h[l>>3],(a[b+319|0]|0)!=0|0);q=c[(c[c[k>>2]>>2]|0)+8>>2]|0;r=c[f>>2]|0;s=t}}while(0);f=c[d+36>>2]|0;h[f>>3]=j*n*s*-.05;h[f+8>>3]=-(+h[r+3184>>3]*+h[q+14160>>3]*+h[q+272>>3]*+h[r+3176>>3]);i=e;return}function WY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0;e=i;f=d+8|0;ze[c[f>>2]&3](0,0,-1.0,0,d);g=c[f>>2]|0;j=b+416|0;k=c[j>>2]|0;l=+h[k+2704>>3];m=+h[k+2672>>3];n=+h[k+2680>>3];do{if(m!=0.0){o=n/m}else{if(n==0.0){o=n;break}o=n/+qXa(c[b+536>>2]|0,m,50128,50424,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);ze[g&3](0,1,l*o*-.05,1,d);ze[c[f>>2]&3](1,0,1.0,2,d);g=c[j>>2]|0;ze[c[f>>2]&3](1,1,-(+h[g+3184>>3]*+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+14152>>3]*+h[g+3176>>3]),3,d);i=e;return}function XY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0;e=i;f=b+416|0;g=c[f>>2]|0;j=+h[g+2704>>3];k=b+4|0;l=c[c[k>>2]>>2]|0;m=c[l+8>>2]|0;n=+h[m+784>>3];o=+h[g+2672>>3];p=+h[g+2680>>3];do{if(o!=0.0){q=m;r=g;s=p/o}else{if(p==0.0){q=m;r=g;s=p;break}t=p/+qXa(c[b+536>>2]|0,o,50128,50432,+h[l>>3],(a[b+319|0]|0)!=0|0);q=c[(c[c[k>>2]>>2]|0)+8>>2]|0;r=c[f>>2]|0;s=t}}while(0);f=c[d+36>>2]|0;h[f>>3]=j*n*s*-.05;h[f+8>>3]=-(+h[r+3184>>3]*+h[q+14152>>3]*+h[q+288>>3]*+h[r+3176>>3]);i=e;return}function YY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0;e=i;f=d+8|0;g=c[f>>2]|0;j=b+416|0;k=c[j>>2]|0;l=+h[k+2704>>3];m=+h[k+2672>>3];n=+h[k+2680>>3];do{if(m!=0.0){o=n/m}else{if(n==0.0){o=n;break}o=n/+qXa(c[b+536>>2]|0,m,50128,50440,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);ze[g&3](0,0,l*o*-.05,0,d);ze[c[f>>2]&3](0,1,-1.0,1,d);g=c[j>>2]|0;ze[c[f>>2]&3](1,0,-(+h[g+3184>>3]*+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+14144>>3]*+h[g+3176>>3]),2,d);ze[c[f>>2]&3](1,1,1.0,3,d);i=e;return}function ZY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0;e=i;f=b+416|0;g=c[f>>2]|0;j=+h[g+2704>>3];k=b+4|0;l=c[c[k>>2]>>2]|0;m=c[l+8>>2]|0;n=+h[m+792>>3];o=+h[g+2672>>3];p=+h[g+2680>>3];do{if(o!=0.0){q=m;r=g;s=p/o}else{if(p==0.0){q=m;r=g;s=p;break}t=p/+qXa(c[b+536>>2]|0,o,50128,50448,+h[l>>3],(a[b+319|0]|0)!=0|0);q=c[(c[c[k>>2]>>2]|0)+8>>2]|0;r=c[f>>2]|0;s=t}}while(0);f=c[d+36>>2]|0;h[f>>3]=j*n*s*-.05;h[f+8>>3]=-(+h[r+3184>>3]*+h[q+14144>>3]*+h[q+304>>3]*+h[r+3176>>3]);i=e;return}function _Y(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0;e=i;f=d+8|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=b+416|0;ze[c[f>>2]&3](0,0,-(+h[j+4792>>3]*+h[j+13656>>3]*+h[(c[k>>2]|0)+2944>>3]),0,d);ze[c[f>>2]&3](0,1,1.0,1,d);j=c[f>>2]|0;l=c[k>>2]|0;m=+h[l+2704>>3];n=+h[l+2672>>3];o=+h[l+2680>>3];do{if(n!=0.0){p=o/n}else{if(o==0.0){p=o;break}p=o/+qXa(c[b+536>>2]|0,n,50128,50456,+h[c[c[g>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);ze[j&3](1,0,m*p*-.05,2,d);ze[c[f>>2]&3](1,1,-1.0,3,d);i=e;return}function $Y(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0.0;e=i;f=c[c[b+4>>2]>>2]|0;g=c[f+8>>2]|0;j=c[b+416>>2]|0;k=d+36|0;d=c[k>>2]|0;h[d>>3]=-(+h[g+4792>>3]*+h[g+13656>>3]*+h[g+320>>3]*+h[j+2944>>3]);l=+h[j+2704>>3];m=+h[g+792>>3];n=+h[j+2672>>3];o=+h[j+2680>>3];if(n!=0.0){p=d;q=o/n;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}if(o==0.0){p=d;q=o;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}x=o/+qXa(c[b+536>>2]|0,n,50128,50464,+h[f>>3],(a[b+319|0]|0)!=0|0);p=c[k>>2]|0;q=x;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}function aZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0;e=i;f=d+8|0;ze[c[f>>2]&3](0,0,1.0,0,d);g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=b+416|0;ze[c[f>>2]&3](0,1,-(+h[j+4784>>3]*+h[j+13648>>3]*+h[(c[k>>2]|0)+2944>>3]),1,d);ze[c[f>>2]&3](1,0,-1.0,2,d);j=c[f>>2]|0;f=c[k>>2]|0;l=+h[f+2704>>3];m=+h[f+2672>>3];n=+h[f+2680>>3];if(m!=0.0){o=n/m;p=l*o;q=p*-.05;ze[j&3](1,1,q,3,d);i=e;return}if(n==0.0){o=n;p=l*o;q=p*-.05;ze[j&3](1,1,q,3,d);i=e;return}o=n/+qXa(c[b+536>>2]|0,m,50128,50472,+h[c[c[g>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);p=l*o;q=p*-.05;ze[j&3](1,1,q,3,d);i=e;return}function bZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0.0;e=i;f=c[c[b+4>>2]>>2]|0;g=c[f+8>>2]|0;j=c[b+416>>2]|0;k=d+36|0;d=c[k>>2]|0;h[d>>3]=-(+h[g+4784>>3]*+h[g+13648>>3]*+h[g+336>>3]*+h[j+2944>>3]);l=+h[j+2704>>3];m=+h[g+784>>3];n=+h[j+2672>>3];o=+h[j+2680>>3];if(n!=0.0){p=d;q=o/n;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}if(o==0.0){p=d;q=o;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}x=o/+qXa(c[b+536>>2]|0,n,50128,50480,+h[f>>3],(a[b+319|0]|0)!=0|0);p=c[k>>2]|0;q=x;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}function cZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0;e=i;f=d+8|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=b+416|0;ze[c[f>>2]&3](0,0,-(+h[j+4776>>3]*+h[j+13640>>3]*+h[(c[k>>2]|0)+2944>>3]),0,d);ze[c[f>>2]&3](0,1,1.0,1,d);j=c[f>>2]|0;l=c[k>>2]|0;m=+h[l+2704>>3];n=+h[l+2672>>3];o=+h[l+2680>>3];do{if(n!=0.0){p=o/n}else{if(o==0.0){p=o;break}p=o/+qXa(c[b+536>>2]|0,n,50128,50488,+h[c[c[g>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);ze[j&3](1,0,m*p*-.05,2,d);ze[c[f>>2]&3](1,1,-1.0,3,d);i=e;return}function dZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0.0;e=i;f=c[c[b+4>>2]>>2]|0;g=c[f+8>>2]|0;j=c[b+416>>2]|0;k=d+36|0;d=c[k>>2]|0;h[d>>3]=-(+h[g+4776>>3]*+h[g+13640>>3]*+h[g+352>>3]*+h[j+2944>>3]);l=+h[j+2704>>3];m=+h[g+776>>3];n=+h[j+2672>>3];o=+h[j+2680>>3];if(n!=0.0){p=d;q=o/n;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}if(o==0.0){p=d;q=o;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}x=o/+qXa(c[b+536>>2]|0,n,50128,50496,+h[f>>3],(a[b+319|0]|0)!=0|0);p=c[k>>2]|0;q=x;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}function eZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0;e=i;f=d+8|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=b+416|0;ze[c[f>>2]&3](0,0,-(+h[j+4768>>3]*+h[j+13632>>3]*+h[(c[k>>2]|0)+2944>>3]),0,d);ze[c[f>>2]&3](0,1,1.0,1,d);j=c[f>>2]|0;l=c[k>>2]|0;m=+h[l+2704>>3];n=+h[l+2672>>3];o=+h[l+2680>>3];do{if(n!=0.0){p=o/n}else{if(o==0.0){p=o;break}p=o/+qXa(c[b+536>>2]|0,n,50128,50504,+h[c[c[g>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);ze[j&3](1,0,m*p*-.05,2,d);ze[c[f>>2]&3](1,1,-1.0,3,d);i=e;return}function fZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0.0;e=i;f=c[c[b+4>>2]>>2]|0;g=c[f+8>>2]|0;j=c[b+416>>2]|0;k=d+36|0;d=c[k>>2]|0;h[d>>3]=-(+h[g+4768>>3]*+h[g+13632>>3]*+h[g+368>>3]*+h[j+2944>>3]);l=+h[j+2704>>3];m=+h[g+768>>3];n=+h[j+2672>>3];o=+h[j+2680>>3];if(n!=0.0){p=d;q=o/n;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}if(o==0.0){p=d;q=o;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}x=o/+qXa(c[b+536>>2]|0,n,50128,50512,+h[f>>3],(a[b+319|0]|0)!=0|0);p=c[k>>2]|0;q=x;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}function gZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0;e=i;f=d+8|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=b+416|0;ze[c[f>>2]&3](0,0,-(+h[j+4760>>3]*+h[j+13624>>3]*+h[(c[k>>2]|0)+2944>>3]),0,d);ze[c[f>>2]&3](0,1,1.0,1,d);j=c[f>>2]|0;l=c[k>>2]|0;m=+h[l+2704>>3];n=+h[l+2672>>3];o=+h[l+2680>>3];do{if(n!=0.0){p=o/n}else{if(o==0.0){p=o;break}p=o/+qXa(c[b+536>>2]|0,n,50128,50520,+h[c[c[g>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);ze[j&3](1,0,m*p*-.05,2,d);ze[c[f>>2]&3](1,1,-1.0,3,d);i=e;return}function hZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0.0;e=i;f=c[c[b+4>>2]>>2]|0;g=c[f+8>>2]|0;j=c[b+416>>2]|0;k=d+36|0;d=c[k>>2]|0;h[d>>3]=-(+h[g+4760>>3]*+h[g+13624>>3]*+h[g+384>>3]*+h[j+2944>>3]);l=+h[j+2704>>3];m=+h[g+760>>3];n=+h[j+2672>>3];o=+h[j+2680>>3];if(n!=0.0){p=d;q=o/n;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}if(o==0.0){p=d;q=o;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}x=o/+qXa(c[b+536>>2]|0,n,50128,50528,+h[f>>3],(a[b+319|0]|0)!=0|0);p=c[k>>2]|0;q=x;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}function iZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0;e=i;f=d+8|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=b+416|0;ze[c[f>>2]&3](0,0,-(+h[j+4752>>3]*+h[j+13616>>3]*+h[(c[k>>2]|0)+2944>>3]),0,d);ze[c[f>>2]&3](0,1,1.0,1,d);j=c[f>>2]|0;l=c[k>>2]|0;m=+h[l+2704>>3];n=+h[l+2672>>3];o=+h[l+2680>>3];do{if(n!=0.0){p=o/n}else{if(o==0.0){p=o;break}p=o/+qXa(c[b+536>>2]|0,n,50128,50536,+h[c[c[g>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);ze[j&3](1,0,m*p*-.05,2,d);ze[c[f>>2]&3](1,1,-1.0,3,d);i=e;return}function jZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0.0;e=i;f=c[c[b+4>>2]>>2]|0;g=c[f+8>>2]|0;j=c[b+416>>2]|0;k=d+36|0;d=c[k>>2]|0;h[d>>3]=-(+h[g+4752>>3]*+h[g+13616>>3]*+h[g+400>>3]*+h[j+2944>>3]);l=+h[j+2704>>3];m=+h[g+752>>3];n=+h[j+2672>>3];o=+h[j+2680>>3];if(n!=0.0){p=d;q=o/n;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}if(o==0.0){p=d;q=o;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}x=o/+qXa(c[b+536>>2]|0,n,50128,50544,+h[f>>3],(a[b+319|0]|0)!=0|0);p=c[k>>2]|0;q=x;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}function kZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0;e=i;f=d+8|0;ze[c[f>>2]&3](0,0,1.0,0,d);g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=b+416|0;ze[c[f>>2]&3](0,1,-(+h[j+4744>>3]*+h[j+13608>>3]*+h[(c[k>>2]|0)+2944>>3]),1,d);ze[c[f>>2]&3](1,0,-1.0,2,d);j=c[f>>2]|0;f=c[k>>2]|0;l=+h[f+2704>>3];m=+h[f+2672>>3];n=+h[f+2680>>3];if(m!=0.0){o=n/m;p=l*o;q=p*-.05;ze[j&3](1,1,q,3,d);i=e;return}if(n==0.0){o=n;p=l*o;q=p*-.05;ze[j&3](1,1,q,3,d);i=e;return}o=n/+qXa(c[b+536>>2]|0,m,50128,50552,+h[c[c[g>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);p=l*o;q=p*-.05;ze[j&3](1,1,q,3,d);i=e;return}function lZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0.0;e=i;f=c[c[b+4>>2]>>2]|0;g=c[f+8>>2]|0;j=c[b+416>>2]|0;k=d+36|0;d=c[k>>2]|0;h[d>>3]=-(+h[g+4744>>3]*+h[g+13608>>3]*+h[g+416>>3]*+h[j+2944>>3]);l=+h[j+2704>>3];m=+h[g+744>>3];n=+h[j+2672>>3];o=+h[j+2680>>3];if(n!=0.0){p=d;q=o/n;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}if(o==0.0){p=d;q=o;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}x=o/+qXa(c[b+536>>2]|0,n,50128,50560,+h[f>>3],(a[b+319|0]|0)!=0|0);p=c[k>>2]|0;q=x;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}function mZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0;e=i;f=d+8|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=b+416|0;ze[c[f>>2]&3](0,0,-(+h[j+4736>>3]*+h[j+13600>>3]*+h[(c[k>>2]|0)+2944>>3]),0,d);ze[c[f>>2]&3](0,1,1.0,1,d);j=c[f>>2]|0;l=c[k>>2]|0;m=+h[l+2704>>3];n=+h[l+2672>>3];o=+h[l+2680>>3];do{if(n!=0.0){p=o/n}else{if(o==0.0){p=o;break}p=o/+qXa(c[b+536>>2]|0,n,50128,50568,+h[c[c[g>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);ze[j&3](1,0,m*p*-.05,2,d);ze[c[f>>2]&3](1,1,-1.0,3,d);i=e;return}function nZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0.0;e=i;f=c[c[b+4>>2]>>2]|0;g=c[f+8>>2]|0;j=c[b+416>>2]|0;k=d+36|0;d=c[k>>2]|0;h[d>>3]=-(+h[g+4736>>3]*+h[g+13600>>3]*+h[g+432>>3]*+h[j+2944>>3]);l=+h[j+2704>>3];m=+h[g+736>>3];n=+h[j+2672>>3];o=+h[j+2680>>3];if(n!=0.0){p=d;q=o/n;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}if(o==0.0){p=d;q=o;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}x=o/+qXa(c[b+536>>2]|0,n,50128,50576,+h[f>>3],(a[b+319|0]|0)!=0|0);p=c[k>>2]|0;q=x;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}function oZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0;e=i;f=d+8|0;ze[c[f>>2]&3](0,0,1.0,0,d);g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=b+416|0;ze[c[f>>2]&3](0,1,-(+h[j+4728>>3]*+h[j+13592>>3]*+h[(c[k>>2]|0)+2944>>3]),1,d);ze[c[f>>2]&3](1,0,-1.0,2,d);j=c[f>>2]|0;f=c[k>>2]|0;l=+h[f+2704>>3];m=+h[f+2672>>3];n=+h[f+2680>>3];if(m!=0.0){o=n/m;p=l*o;q=p*-.05;ze[j&3](1,1,q,3,d);i=e;return}if(n==0.0){o=n;p=l*o;q=p*-.05;ze[j&3](1,1,q,3,d);i=e;return}o=n/+qXa(c[b+536>>2]|0,m,50128,50584,+h[c[c[g>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);p=l*o;q=p*-.05;ze[j&3](1,1,q,3,d);i=e;return}function pZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0.0;e=i;f=c[c[b+4>>2]>>2]|0;g=c[f+8>>2]|0;j=c[b+416>>2]|0;k=d+36|0;d=c[k>>2]|0;h[d>>3]=-(+h[g+4728>>3]*+h[g+13592>>3]*+h[g+448>>3]*+h[j+2944>>3]);l=+h[j+2704>>3];m=+h[g+728>>3];n=+h[j+2672>>3];o=+h[j+2680>>3];if(n!=0.0){p=d;q=o/n;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}if(o==0.0){p=d;q=o;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}x=o/+qXa(c[b+536>>2]|0,n,50128,50592,+h[f>>3],(a[b+319|0]|0)!=0|0);p=c[k>>2]|0;q=x;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}function qZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0;e=i;f=d+8|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=b+416|0;ze[c[f>>2]&3](0,0,-(+h[j+4720>>3]*+h[j+13584>>3]*+h[(c[k>>2]|0)+2944>>3]),0,d);ze[c[f>>2]&3](0,1,1.0,1,d);j=c[f>>2]|0;l=c[k>>2]|0;m=+h[l+2704>>3];n=+h[l+2672>>3];o=+h[l+2680>>3];do{if(n!=0.0){p=o/n}else{if(o==0.0){p=o;break}p=o/+qXa(c[b+536>>2]|0,n,50128,50600,+h[c[c[g>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);ze[j&3](1,0,m*p*-.05,2,d);ze[c[f>>2]&3](1,1,-1.0,3,d);i=e;return}function rZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0.0;e=i;f=c[c[b+4>>2]>>2]|0;g=c[f+8>>2]|0;j=c[b+416>>2]|0;k=d+36|0;d=c[k>>2]|0;h[d>>3]=-(+h[g+4720>>3]*+h[g+13584>>3]*+h[g+464>>3]*+h[j+2944>>3]);l=+h[j+2704>>3];m=+h[g+720>>3];n=+h[j+2672>>3];o=+h[j+2680>>3];if(n!=0.0){p=d;q=o/n;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}if(o==0.0){p=d;q=o;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}x=o/+qXa(c[b+536>>2]|0,n,50128,50608,+h[f>>3],(a[b+319|0]|0)!=0|0);p=c[k>>2]|0;q=x;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}function sZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0;e=i;f=d+8|0;ze[c[f>>2]&3](0,0,1.0,0,d);g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=b+416|0;ze[c[f>>2]&3](0,1,-(+h[j+4712>>3]*+h[j+13576>>3]*+h[(c[k>>2]|0)+2944>>3]),1,d);ze[c[f>>2]&3](1,0,-1.0,2,d);j=c[f>>2]|0;f=c[k>>2]|0;l=+h[f+2704>>3];m=+h[f+2672>>3];n=+h[f+2680>>3];if(m!=0.0){o=n/m;p=l*o;q=p*-.05;ze[j&3](1,1,q,3,d);i=e;return}if(n==0.0){o=n;p=l*o;q=p*-.05;ze[j&3](1,1,q,3,d);i=e;return}o=n/+qXa(c[b+536>>2]|0,m,50128,50616,+h[c[c[g>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);p=l*o;q=p*-.05;ze[j&3](1,1,q,3,d);i=e;return}function tZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0.0;e=i;f=c[c[b+4>>2]>>2]|0;g=c[f+8>>2]|0;j=c[b+416>>2]|0;k=d+36|0;d=c[k>>2]|0;h[d>>3]=-(+h[g+4712>>3]*+h[g+13576>>3]*+h[g+480>>3]*+h[j+2944>>3]);l=+h[j+2704>>3];m=+h[g+712>>3];n=+h[j+2672>>3];o=+h[j+2680>>3];if(n!=0.0){p=d;q=o/n;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}if(o==0.0){p=d;q=o;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}x=o/+qXa(c[b+536>>2]|0,n,50128,50624,+h[f>>3],(a[b+319|0]|0)!=0|0);p=c[k>>2]|0;q=x;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}function uZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0;e=i;f=d+8|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=b+416|0;ze[c[f>>2]&3](0,0,-(+h[j+4704>>3]*+h[j+13568>>3]*+h[(c[k>>2]|0)+2944>>3]),0,d);ze[c[f>>2]&3](0,1,1.0,1,d);j=c[f>>2]|0;l=c[k>>2]|0;m=+h[l+2704>>3];n=+h[l+2672>>3];o=+h[l+2680>>3];do{if(n!=0.0){p=o/n}else{if(o==0.0){p=o;break}p=o/+qXa(c[b+536>>2]|0,n,50128,50632,+h[c[c[g>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);ze[j&3](1,0,m*p*-.05,2,d);ze[c[f>>2]&3](1,1,-1.0,3,d);i=e;return}function vZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0.0;e=i;f=c[c[b+4>>2]>>2]|0;g=c[f+8>>2]|0;j=c[b+416>>2]|0;k=d+36|0;d=c[k>>2]|0;h[d>>3]=-(+h[g+4704>>3]*+h[g+13568>>3]*+h[g+496>>3]*+h[j+2944>>3]);l=+h[j+2704>>3];m=+h[g+704>>3];n=+h[j+2672>>3];o=+h[j+2680>>3];if(n!=0.0){p=d;q=o/n;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}if(o==0.0){p=d;q=o;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}x=o/+qXa(c[b+536>>2]|0,n,50128,50640,+h[f>>3],(a[b+319|0]|0)!=0|0);p=c[k>>2]|0;q=x;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}function wZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0;e=i;f=d+8|0;ze[c[f>>2]&3](0,0,1.0,0,d);g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=b+416|0;ze[c[f>>2]&3](0,1,-(+h[j+4696>>3]*+h[j+13560>>3]*+h[(c[k>>2]|0)+2944>>3]),1,d);ze[c[f>>2]&3](1,0,-1.0,2,d);j=c[f>>2]|0;f=c[k>>2]|0;l=+h[f+2704>>3];m=+h[f+2672>>3];n=+h[f+2680>>3];if(m!=0.0){o=n/m;p=l*o;q=p*-.05;ze[j&3](1,1,q,3,d);i=e;return}if(n==0.0){o=n;p=l*o;q=p*-.05;ze[j&3](1,1,q,3,d);i=e;return}o=n/+qXa(c[b+536>>2]|0,m,50128,50648,+h[c[c[g>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);p=l*o;q=p*-.05;ze[j&3](1,1,q,3,d);i=e;return}function xZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0.0;e=i;f=c[c[b+4>>2]>>2]|0;g=c[f+8>>2]|0;j=c[b+416>>2]|0;k=d+36|0;d=c[k>>2]|0;h[d>>3]=-(+h[g+4696>>3]*+h[g+13560>>3]*+h[g+512>>3]*+h[j+2944>>3]);l=+h[j+2704>>3];m=+h[g+696>>3];n=+h[j+2672>>3];o=+h[j+2680>>3];if(n!=0.0){p=d;q=o/n;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}if(o==0.0){p=d;q=o;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}x=o/+qXa(c[b+536>>2]|0,n,50128,50656,+h[f>>3],(a[b+319|0]|0)!=0|0);p=c[k>>2]|0;q=x;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}function yZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0;e=i;f=d+8|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=b+416|0;ze[c[f>>2]&3](0,0,-(+h[j+4688>>3]*+h[j+13552>>3]*+h[(c[k>>2]|0)+2944>>3]),0,d);ze[c[f>>2]&3](0,1,1.0,1,d);j=c[f>>2]|0;l=c[k>>2]|0;m=+h[l+2704>>3];n=+h[l+2672>>3];o=+h[l+2680>>3];do{if(n!=0.0){p=o/n}else{if(o==0.0){p=o;break}p=o/+qXa(c[b+536>>2]|0,n,50128,50664,+h[c[c[g>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);ze[j&3](1,0,m*p*-.05,2,d);ze[c[f>>2]&3](1,1,-1.0,3,d);i=e;return}function zZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0.0;e=i;f=c[c[b+4>>2]>>2]|0;g=c[f+8>>2]|0;j=c[b+416>>2]|0;k=d+36|0;d=c[k>>2]|0;h[d>>3]=-(+h[g+4688>>3]*+h[g+13552>>3]*+h[g+528>>3]*+h[j+2944>>3]);l=+h[j+2704>>3];m=+h[g+688>>3];n=+h[j+2672>>3];o=+h[j+2680>>3];if(n!=0.0){p=d;q=o/n;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}if(o==0.0){p=d;q=o;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}x=o/+qXa(c[b+536>>2]|0,n,50128,50672,+h[f>>3],(a[b+319|0]|0)!=0|0);p=c[k>>2]|0;q=x;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}function AZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0;e=i;f=d+8|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=b+416|0;ze[c[f>>2]&3](0,0,-(+h[j+4680>>3]*+h[j+13544>>3]*+h[(c[k>>2]|0)+2944>>3]),0,d);ze[c[f>>2]&3](0,1,1.0,1,d);j=c[f>>2]|0;l=c[k>>2]|0;m=+h[l+2704>>3];n=+h[l+2672>>3];o=+h[l+2680>>3];do{if(n!=0.0){p=o/n}else{if(o==0.0){p=o;break}p=o/+qXa(c[b+536>>2]|0,n,50128,50680,+h[c[c[g>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);ze[j&3](1,0,m*p*-.05,2,d);ze[c[f>>2]&3](1,1,-1.0,3,d);i=e;return}function BZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0.0;e=i;f=c[c[b+4>>2]>>2]|0;g=c[f+8>>2]|0;j=c[b+416>>2]|0;k=d+36|0;d=c[k>>2]|0;h[d>>3]=-(+h[g+4680>>3]*+h[g+13544>>3]*+h[g+544>>3]*+h[j+2944>>3]);l=+h[j+2704>>3];m=+h[g+680>>3];n=+h[j+2672>>3];o=+h[j+2680>>3];if(n!=0.0){p=d;q=o/n;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}if(o==0.0){p=d;q=o;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}x=o/+qXa(c[b+536>>2]|0,n,50128,50688,+h[f>>3],(a[b+319|0]|0)!=0|0);p=c[k>>2]|0;q=x;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}function CZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0;e=i;f=d+8|0;ze[c[f>>2]&3](0,0,1.0,0,d);g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=b+416|0;ze[c[f>>2]&3](0,1,-(+h[j+4672>>3]*+h[j+13536>>3]*+h[(c[k>>2]|0)+2944>>3]),1,d);ze[c[f>>2]&3](1,0,-1.0,2,d);j=c[f>>2]|0;f=c[k>>2]|0;l=+h[f+2704>>3];m=+h[f+2672>>3];n=+h[f+2680>>3];if(m!=0.0){o=n/m;p=l*o;q=p*-.05;ze[j&3](1,1,q,3,d);i=e;return}if(n==0.0){o=n;p=l*o;q=p*-.05;ze[j&3](1,1,q,3,d);i=e;return}o=n/+qXa(c[b+536>>2]|0,m,50128,50696,+h[c[c[g>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);p=l*o;q=p*-.05;ze[j&3](1,1,q,3,d);i=e;return}function DZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0.0;e=i;f=c[c[b+4>>2]>>2]|0;g=c[f+8>>2]|0;j=c[b+416>>2]|0;k=d+36|0;d=c[k>>2]|0;h[d>>3]=-(+h[g+4672>>3]*+h[g+13536>>3]*+h[g+560>>3]*+h[j+2944>>3]);l=+h[j+2704>>3];m=+h[g+672>>3];n=+h[j+2672>>3];o=+h[j+2680>>3];if(n!=0.0){p=d;q=o/n;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}if(o==0.0){p=d;q=o;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}x=o/+qXa(c[b+536>>2]|0,n,50128,50704,+h[f>>3],(a[b+319|0]|0)!=0|0);p=c[k>>2]|0;q=x;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}function EZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0;e=i;f=d+8|0;ze[c[f>>2]&3](0,0,1.0,0,d);g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=b+416|0;ze[c[f>>2]&3](0,1,-(+h[j+4664>>3]*+h[j+13528>>3]*+h[(c[k>>2]|0)+2944>>3]),1,d);ze[c[f>>2]&3](1,0,-1.0,2,d);j=c[f>>2]|0;f=c[k>>2]|0;l=+h[f+2704>>3];m=+h[f+2672>>3];n=+h[f+2680>>3];if(m!=0.0){o=n/m;p=l*o;q=p*-.05;ze[j&3](1,1,q,3,d);i=e;return}if(n==0.0){o=n;p=l*o;q=p*-.05;ze[j&3](1,1,q,3,d);i=e;return}o=n/+qXa(c[b+536>>2]|0,m,50128,50712,+h[c[c[g>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);p=l*o;q=p*-.05;ze[j&3](1,1,q,3,d);i=e;return}



function tya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[74232]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+896>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(74240,LXa(+h[(c[g>>2]|0)+896>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[74232]=1;i=d;return}function uya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[74352]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+888>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(74360,LXa(+h[(c[g>>2]|0)+888>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[74352]=1;i=d;return}function vya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[74472]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+880>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(74480,LXa(+h[(c[g>>2]|0)+880>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[74472]=1;i=d;return}function wya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[74592]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+872>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(74600,LXa(+h[(c[g>>2]|0)+872>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[74592]=1;i=d;return}function xya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[74712]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+864>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(74720,LXa(+h[(c[g>>2]|0)+864>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[74712]=1;i=d;return}function yya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[74832]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+856>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(74840,LXa(+h[(c[g>>2]|0)+856>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[74832]=1;i=d;return}function zya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[74952]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+848>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(74960,LXa(+h[(c[g>>2]|0)+848>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[74952]=1;i=d;return}function Aya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[75072]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+840>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(75080,LXa(+h[(c[g>>2]|0)+840>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[75072]=1;i=d;return}function Bya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[75192]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+832>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(75200,LXa(+h[(c[g>>2]|0)+832>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[75192]=1;i=d;return}function Cya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[75312]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+824>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(75320,LXa(+h[(c[g>>2]|0)+824>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[75312]=1;i=d;return}function Dya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[75456]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+2928>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(75464,LXa(+h[(c[g>>2]|0)+2928>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75584;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[75456]=1;i=d;return}function Eya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[75608]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+2920>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(75616,LXa(+h[(c[g>>2]|0)+2920>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75744;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[75608]=1;i=d;return}function Fya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[75768]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+2912>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+2912>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(75776,LXa(+h[(c[g>>2]|0)+2912>>3],58584)|0)|0;g=c[72302]|0;j=e;k=75960;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[75768]=1;i=d;return}function Gya(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[75984]&1){i=d;return}g=b+420|0;b=E_a(+(c[(c[g>>2]|0)+88>>2]|0),1.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[g>>2]|0)+88>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=RXa(75992,NXa(c[(c[g>>2]|0)+88>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=76256;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[75984]=1;i=d;return}function Hya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76280]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+2896>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(76288,LXa(+h[(c[g>>2]|0)+2896>>3],58584)|0)|0;g=c[72302]|0;j=e;k=76408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[76280]=1;i=d;return}function Iya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76432]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+2872>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(76440,LXa(+h[(c[g>>2]|0)+2872>>3],58584)|0)|0;g=c[72302]|0;j=e;k=76560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[76432]=1;i=d;return}function Jya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76584]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+2856>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+2856>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(76592,LXa(+h[(c[g>>2]|0)+2856>>3],58584)|0)|0;g=c[72302]|0;j=e;k=76760;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[76584]=1;i=d;return}function Kya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76784]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+2848>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+2848>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(76792,LXa(+h[(c[g>>2]|0)+2848>>3],58584)|0)|0;g=c[72302]|0;j=e;k=76960;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[76784]=1;i=d;return}function Lya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76984]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+336>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+336>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(76992,LXa(+h[(c[g>>2]|0)+336>>3],58584)|0)|0;g=c[72302]|0;j=e;k=80112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[76984]=1;i=d;return}function Mya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77144]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+328>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+328>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(77152,LXa(+h[(c[g>>2]|0)+328>>3],58584)|0)|0;g=c[72302]|0;j=e;k=80112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[77144]=1;i=d;return}function Nya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77304]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+320>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+320>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(77312,LXa(+h[(c[g>>2]|0)+320>>3],58584)|0)|0;g=c[72302]|0;j=e;k=80112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[77304]=1;i=d;return}function Oya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77464]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+312>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+312>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(77472,LXa(+h[(c[g>>2]|0)+312>>3],58584)|0)|0;g=c[72302]|0;j=e;k=80112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[77464]=1;i=d;return}function Pya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77624]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+304>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+304>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(77632,LXa(+h[(c[g>>2]|0)+304>>3],58584)|0)|0;g=c[72302]|0;j=e;k=80112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[77624]=1;i=d;return}function Qya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77784]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+296>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+296>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(77792,LXa(+h[(c[g>>2]|0)+296>>3],58584)|0)|0;g=c[72302]|0;j=e;k=80112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[77784]=1;i=d;return}function Rya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77944]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+288>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+288>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(77952,LXa(+h[(c[g>>2]|0)+288>>3],58584)|0)|0;g=c[72302]|0;j=e;k=80112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[77944]=1;i=d;return}function Sya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[78104]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+280>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+280>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(78112,LXa(+h[(c[g>>2]|0)+280>>3],58584)|0)|0;g=c[72302]|0;j=e;k=80112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[78104]=1;i=d;return}function Tya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[78264]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+272>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+272>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(78272,LXa(+h[(c[g>>2]|0)+272>>3],58584)|0)|0;g=c[72302]|0;j=e;k=80112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[78264]=1;i=d;return}function Uya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[78424]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+264>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+264>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(78432,LXa(+h[(c[g>>2]|0)+264>>3],58584)|0)|0;g=c[72302]|0;j=e;k=80112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[78424]=1;i=d;return}function Vya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[78584]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+256>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+256>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(78592,LXa(+h[(c[g>>2]|0)+256>>3],58584)|0)|0;g=c[72302]|0;j=e;k=80112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[78584]=1;i=d;return}function Wya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[78744]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+248>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+248>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(78752,LXa(+h[(c[g>>2]|0)+248>>3],58584)|0)|0;g=c[72302]|0;j=e;k=80112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[78744]=1;i=d;return}function Xya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[78896]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+240>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+240>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(78904,LXa(+h[(c[g>>2]|0)+240>>3],58584)|0)|0;g=c[72302]|0;j=e;k=80112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[78896]=1;i=d;return}function Yya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[79048]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+232>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+232>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(79056,LXa(+h[(c[g>>2]|0)+232>>3],58584)|0)|0;g=c[72302]|0;j=e;k=80112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[79048]=1;i=d;return}function Zya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[79200]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+224>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+224>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(79208,LXa(+h[(c[g>>2]|0)+224>>3],58584)|0)|0;g=c[72302]|0;j=e;k=80112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[79200]=1;i=d;return}function _ya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[79352]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+216>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+216>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(79360,LXa(+h[(c[g>>2]|0)+216>>3],58584)|0)|0;g=c[72302]|0;j=e;k=80112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[79352]=1;i=d;return}function $ya(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[79504]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+208>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+208>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(79512,LXa(+h[(c[g>>2]|0)+208>>3],58584)|0)|0;g=c[72302]|0;j=e;k=80112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[79504]=1;i=d;return}function aza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[79656]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+200>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+200>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(79664,LXa(+h[(c[g>>2]|0)+200>>3],58584)|0)|0;g=c[72302]|0;j=e;k=80112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[79656]=1;i=d;return}function bza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[79808]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+192>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+192>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(79816,LXa(+h[(c[g>>2]|0)+192>>3],58584)|0)|0;g=c[72302]|0;j=e;k=80112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[79808]=1;i=d;return}function cza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[79960]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+184>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+184>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(79968,LXa(+h[(c[g>>2]|0)+184>>3],58584)|0)|0;g=c[72302]|0;j=e;k=80112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[79960]=1;i=d;return}function dza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[80136]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+2824>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+2824>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(80144,LXa(+h[(c[g>>2]|0)+2824>>3],58584)|0)|0;g=c[72302]|0;j=e;k=80288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[80136]=1;i=d;return}function eza(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[80312]&1){i=d;return}g=b+420|0;b=E_a(+(c[(c[g>>2]|0)+72>>2]|0),1.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[g>>2]|0)+72>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=RXa(80320,NXa(c[(c[g>>2]|0)+72>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=80552;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[80312]=1;i=d;return}function fza(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[80576]&1){i=d;return}g=b+420|0;b=E_a(+(c[(c[g>>2]|0)+68>>2]|0),1.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[g>>2]|0)+68>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=RXa(80584,NXa(c[(c[g>>2]|0)+68>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=80824;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[80576]=1;i=d;return}function gza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[80848]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+176>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+176>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(80856,LXa(+h[(c[g>>2]|0)+176>>3],58584)|0)|0;g=c[72302]|0;j=e;k=80992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[80848]=1;i=d;return}function hza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[81016]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+2800>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+2800>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(81024,LXa(+h[(c[g>>2]|0)+2800>>3],58584)|0)|0;g=c[72302]|0;j=e;k=81176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[81016]=1;i=d;return}function iza(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[81200]&1){i=d;return}g=b+420|0;b=E_a(+(c[(c[g>>2]|0)+60>>2]|0),1.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[g>>2]|0)+60>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=RXa(81208,NXa(c[(c[g>>2]|0)+60>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=81448;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[81200]=1;i=d;return}function jza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[81472]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+2792>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+2792>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(81480,LXa(+h[(c[g>>2]|0)+2792>>3],58584)|0)|0;g=c[72302]|0;j=e;k=81624;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[81472]=1;i=d;return}function kza(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[81648]&1){i=d;return}g=b+420|0;b=E_a(+(c[(c[g>>2]|0)+56>>2]|0),1.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[g>>2]|0)+56>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=RXa(81656,NXa(c[(c[g>>2]|0)+56>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=81880;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[81648]=1;i=d;return}function lza(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[81904]&1){i=d;return}g=b+420|0;b=E_a(+(c[(c[g>>2]|0)+52>>2]|0),1.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[g>>2]|0)+52>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=RXa(81912,NXa(c[(c[g>>2]|0)+52>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=82144;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[81904]=1;i=d;return}function mza(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82168]&1){i=d;return}g=b+420|0;b=E_a(+(c[(c[g>>2]|0)+36>>2]|0),1.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[g>>2]|0)+36>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=RXa(82176,NXa(c[(c[g>>2]|0)+36>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=82400;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[82168]=1;i=d;return}function nza(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82424]&1){i=d;return}g=b+420|0;if(!((E_a(+(c[(c[g>>2]|0)+32>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=RXa(82432,NXa(c[(c[g>>2]|0)+32>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=82528;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[82424]=1;i=d;return}function oza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82552]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+2784>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+2784>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(82560,LXa(+h[(c[g>>2]|0)+2784>>3],58584)|0)|0;g=c[72302]|0;j=e;k=82712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[82552]=1;i=d;return}function pza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82736]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+2776>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+2776>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(82744,LXa(+h[(c[g>>2]|0)+2776>>3],58584)|0)|0;g=c[72302]|0;j=e;k=82872;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[82736]=1;i=d;return}function qza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82896]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+2760>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(82904,LXa(+h[(c[g>>2]|0)+2760>>3],58584)|0)|0;g=c[72302]|0;j=e;k=83008;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[82896]=1;i=d;return}function rza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83032]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+2752>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(83040,LXa(+h[(c[g>>2]|0)+2752>>3],58584)|0)|0;g=c[72302]|0;j=e;k=83136;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[83032]=1;i=d;return}function sza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83160]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+2736>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(83168,LXa(+h[(c[g>>2]|0)+2736>>3],58584)|0)|0;g=c[72302]|0;j=e;k=83272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[83160]=1;i=d;return}function tza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83296]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+168>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+168>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(83304,LXa(+h[(c[g>>2]|0)+168>>3],58584)|0)|0;g=c[72302]|0;j=e;k=83512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[83296]=1;i=d;return}function uza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83536]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+160>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+160>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(83544,LXa(+h[(c[g>>2]|0)+160>>3],58584)|0)|0;g=c[72302]|0;j=e;k=83664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[83536]=1;i=d;return}function vza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83688]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+2728>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(83696,LXa(+h[(c[g>>2]|0)+2728>>3],58584)|0)|0;g=c[72302]|0;j=e;k=83776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[83688]=1;i=d;return}function wza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83800]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+152>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(83808,LXa(+h[(c[g>>2]|0)+152>>3],58584)|0)|0;g=c[72302]|0;j=e;k=85720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[83800]=1;i=d;return}function xza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83896]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+144>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(83904,LXa(+h[(c[g>>2]|0)+144>>3],58584)|0)|0;g=c[72302]|0;j=e;k=85720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[83896]=1;i=d;return}function yza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83992]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+136>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(84e3,LXa(+h[(c[g>>2]|0)+136>>3],58584)|0)|0;g=c[72302]|0;j=e;k=85720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[83992]=1;i=d;return}function zza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84088]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+128>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(84096,LXa(+h[(c[g>>2]|0)+128>>3],58584)|0)|0;g=c[72302]|0;j=e;k=85720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[84088]=1;i=d;return}function Aza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84184]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+120>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(84192,LXa(+h[(c[g>>2]|0)+120>>3],58584)|0)|0;g=c[72302]|0;j=e;k=85720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[84184]=1;i=d;return}function Bza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84280]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+112>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(84288,LXa(+h[(c[g>>2]|0)+112>>3],58584)|0)|0;g=c[72302]|0;j=e;k=85720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[84280]=1;i=d;return}function Cza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84376]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+104>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(84384,LXa(+h[(c[g>>2]|0)+104>>3],58584)|0)|0;g=c[72302]|0;j=e;k=85720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[84376]=1;i=d;return}function Dza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84472]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+96>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(84480,LXa(+h[(c[g>>2]|0)+96>>3],58584)|0)|0;g=c[72302]|0;j=e;k=85720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[84472]=1;i=d;return}function Eza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84568]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+88>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(84576,LXa(+h[(c[g>>2]|0)+88>>3],58584)|0)|0;g=c[72302]|0;j=e;k=85720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[84568]=1;i=d;return}function Fza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84664]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+80>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(84672,LXa(+h[(c[g>>2]|0)+80>>3],58584)|0)|0;g=c[72302]|0;j=e;k=85720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[84664]=1;i=d;return}function Gza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84760]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+72>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(84768,LXa(+h[(c[g>>2]|0)+72>>3],58584)|0)|0;g=c[72302]|0;j=e;k=85720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[84760]=1;i=d;return}function Hza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84856]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+64>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(84864,LXa(+h[(c[g>>2]|0)+64>>3],58584)|0)|0;g=c[72302]|0;j=e;k=85720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[84856]=1;i=d;return}function Iza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84952]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+56>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(84960,LXa(+h[(c[g>>2]|0)+56>>3],58584)|0)|0;g=c[72302]|0;j=e;k=85720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[84952]=1;i=d;return}function Jza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[85048]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+48>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(85056,LXa(+h[(c[g>>2]|0)+48>>3],58584)|0)|0;g=c[72302]|0;j=e;k=85720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[85048]=1;i=d;return}function Kza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[85144]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+40>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(85152,LXa(+h[(c[g>>2]|0)+40>>3],58584)|0)|0;g=c[72302]|0;j=e;k=85720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[85144]=1;i=d;return}function Lza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[85240]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+32>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(85248,LXa(+h[(c[g>>2]|0)+32>>3],58584)|0)|0;g=c[72302]|0;j=e;k=85720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[85240]=1;i=d;return}function Mza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[85336]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+24>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(85344,LXa(+h[(c[g>>2]|0)+24>>3],58584)|0)|0;g=c[72302]|0;j=e;k=85720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[85336]=1;i=d;return}function Nza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[85432]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+16>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(85440,LXa(+h[(c[g>>2]|0)+16>>3],58584)|0)|0;g=c[72302]|0;j=e;k=85720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[85432]=1;i=d;return}function Oza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[85528]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+8>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(85536,LXa(+h[(c[g>>2]|0)+8>>3],58584)|0)|0;g=c[72302]|0;j=e;k=85720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[85528]=1;i=d;return}function Pza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[85624]&1){i=d;return}g=b+416|0;if(!((E_a(+h[c[g>>2]>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(85632,LXa(+h[c[g>>2]>>3],58584)|0)|0;g=c[72302]|0;j=e;k=85720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[85624]=1;i=d;return}function Qza(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[85744]&1){i=d;return}g=b+420|0;b=E_a(+(c[(c[g>>2]|0)+28>>2]|0),1.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[g>>2]|0)+28>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=RXa(85752,NXa(c[(c[g>>2]|0)+28>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=85976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[85744]=1;i=d;return}function Rza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[86e3]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+2720>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(86008,LXa(+h[(c[g>>2]|0)+2720>>3],58584)|0)|0;g=c[72302]|0;j=e;k=86088;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[86e3]=1;i=d;return}function Sza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[86112]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+2712>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(86120,LXa(+h[(c[g>>2]|0)+2712>>3],58584)|0)|0;g=c[72302]|0;j=e;k=86216;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[86112]=1;i=d;return}function Tza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[86240]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+2688>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(86248,LXa(+h[(c[g>>2]|0)+2688>>3],58584)|0)|0;g=c[72302]|0;j=e;k=86344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[86240]=1;i=d;return}function Uza(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[86368]&1){i=d;return}g=b+420|0;if(!((E_a(+(c[(c[g>>2]|0)+24>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=RXa(86376,NXa(c[(c[g>>2]|0)+24>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=86456;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[86368]=1;i=d;return}function Vza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[86480]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+2664>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+2664>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(86488,LXa(+h[(c[g>>2]|0)+2664>>3],58584)|0)|0;g=c[72302]|0;j=e;k=86608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[86480]=1;i=d;return}function Wza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[86632]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+2656>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+2656>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(86640,LXa(+h[(c[g>>2]|0)+2656>>3],58584)|0)|0;g=c[72302]|0;j=e;k=86760;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[86632]=1;i=d;return}function Xza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[86784]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+2648>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+2648>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(86792,LXa(+h[(c[g>>2]|0)+2648>>3],58584)|0)|0;g=c[72302]|0;j=e;k=86912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[86784]=1;i=d;return}function Yza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[86936]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+2640>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+2640>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(86944,LXa(+h[(c[g>>2]|0)+2640>>3],58584)|0)|0;g=c[72302]|0;j=e;k=87064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[86936]=1;i=d;return}function Zza(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87088]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+2624>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+2624>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(87096,LXa(+h[(c[g>>2]|0)+2624>>3],58584)|0)|0;g=c[72302]|0;j=e;k=87232;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[87088]=1;i=d;return}function _za(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87256]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+2616>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+2616>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(87264,LXa(+h[(c[g>>2]|0)+2616>>3],58584)|0)|0;g=c[72302]|0;j=e;k=87400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[87256]=1;i=d;return}function $za(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87424]&1){i=d;return}g=b+420|0;b=E_a(+(c[(c[g>>2]|0)+20>>2]|0),1.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[g>>2]|0)+20>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=RXa(87432,NXa(c[(c[g>>2]|0)+20>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=87648;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[87424]=1;i=d;return}function aAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87672]&1){i=d;return}g=b+420|0;b=E_a(+(c[(c[g>>2]|0)+16>>2]|0),1.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[g>>2]|0)+16>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=RXa(87680,NXa(c[(c[g>>2]|0)+16>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=87888;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[87672]=1;i=d;return}function bAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87912]&1){i=d;return}g=b+420|0;b=E_a(+(c[(c[g>>2]|0)+12>>2]|0),1.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[g>>2]|0)+12>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=RXa(87920,NXa(c[(c[g>>2]|0)+12>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=88128;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[87912]=1;i=d;return}function cAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[88152]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+2592>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+2592>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(88160,LXa(+h[(c[g>>2]|0)+2592>>3],58584)|0)|0;g=c[72302]|0;j=e;k=88296;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[88152]=1;i=d;return}function dAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[88320]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+2584>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+2584>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(88328,LXa(+h[(c[g>>2]|0)+2584>>3],58584)|0)|0;g=c[72302]|0;j=e;k=88448;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[88320]=1;i=d;return}function eAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[88472]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+2576>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+2576>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(88480,LXa(+h[(c[g>>2]|0)+2576>>3],58584)|0)|0;g=c[72302]|0;j=e;k=88616;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[88472]=1;i=d;return}function fAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[88640]&1){i=d;return}g=b+416|0;b=E_a(+h[(c[g>>2]|0)+2568>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[g>>2]|0)+2568>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(88648,LXa(+h[(c[g>>2]|0)+2568>>3],58584)|0)|0;g=c[72302]|0;j=e;k=88768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[88640]=1;i=d;return}function gAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[88792]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+2560>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(88800,LXa(+h[(c[g>>2]|0)+2560>>3],58584)|0)|0;g=c[72302]|0;j=e;k=88872;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[88792]=1;i=d;return}function hAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[88896]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+2552>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(88904,LXa(+h[(c[g>>2]|0)+2552>>3],58584)|0)|0;g=c[72302]|0;j=e;k=88992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[88896]=1;i=d;return}function iAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[89016]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+2544>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(89024,LXa(+h[(c[g>>2]|0)+2544>>3],58584)|0)|0;g=c[72302]|0;j=e;k=89112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[89016]=1;i=d;return}function jAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[89136]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+2520>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(89144,LXa(+h[(c[g>>2]|0)+2520>>3],58584)|0)|0;g=c[72302]|0;j=e;k=89224;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[89136]=1;i=d;return}function kAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[89248]&1){i=d;return}g=b+420|0;b=E_a(+(c[(c[g>>2]|0)+8>>2]|0),1.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[g>>2]|0)+8>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=RXa(89256,NXa(c[(c[g>>2]|0)+8>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=89464;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[89248]=1;i=d;return}function lAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[89488]&1){i=d;return}g=b+420|0;b=E_a(+(c[(c[g>>2]|0)+4>>2]|0),1.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[g>>2]|0)+4>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=RXa(89496,NXa(c[(c[g>>2]|0)+4>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=89704;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[89488]=1;i=d;return}function mAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[89728]&1){i=d;return}g=b+420|0;if(!((E_a(+(c[c[g>>2]>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=RXa(89736,NXa(c[c[g>>2]>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=89816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[89728]=1;i=d;return}function nAa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[89840]&1){i=d;return}g=b+416|0;if(!((E_a(+h[(c[g>>2]|0)+2464>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(89848,LXa(+h[(c[g>>2]|0)+2464>>3],58584)|0)|0;g=c[72302]|0;j=e;k=89928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[89840]=1;i=d;return}function oAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[89952]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+156>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+156>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(89960,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+156>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=101208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[89952]=1;i=d;return}function pAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[90192]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+152>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+152>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(90200,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+152>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=101208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[90192]=1;i=d;return}function qAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[90352]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+148>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+148>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(90360,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+148>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=101208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[90352]=1;i=d;return}function rAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[90512]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+144>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+144>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(90520,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+144>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=101208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[90512]=1;i=d;return}function sAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[90672]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+140>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+140>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(90680,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+140>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=101208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[90672]=1;i=d;return}function tAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[90832]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+136>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+136>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(90840,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+136>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=101208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[90832]=1;i=d;return}function uAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[90992]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+132>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+132>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(91e3,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+132>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=101208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[90992]=1;i=d;return}function vAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[91152]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+128>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+128>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(91160,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+128>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=101208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[91152]=1;i=d;return}function wAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[91312]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+124>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+124>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(91320,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+124>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=101208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[91312]=1;i=d;return}function xAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[91472]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+120>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+120>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(91480,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+120>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=101208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[91472]=1;i=d;return}function yAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[91632]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+116>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+116>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(91640,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+116>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=101208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[91632]=1;i=d;return}function zAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[91792]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+112>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+112>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(91800,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+112>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=101208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[91792]=1;i=d;return}function AAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[91952]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+108>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+108>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(91960,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+108>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=101208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[91952]=1;i=d;return}function BAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[92112]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+104>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+104>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(92120,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+104>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=101208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[92112]=1;i=d;return}function CAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[92272]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+100>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+100>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(92280,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+100>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=101208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[92272]=1;i=d;return}function DAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[92432]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+96>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+96>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(92440,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+96>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=101208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[92432]=1;i=d;return}function EAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[92592]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+92>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+92>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(92600,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+92>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=101208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[92592]=1;i=d;return}function FAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[92752]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+88>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+88>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(92760,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+88>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=101208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[92752]=1;i=d;return}function GAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[92912]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+84>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+84>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(92920,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+84>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=101208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[92912]=1;i=d;return}function HAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[93072]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+80>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+80>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(93080,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+80>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=101208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[93072]=1;i=d;return}function IAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[93232]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+188>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+188>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(93240,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+188>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=111408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[93232]=1;i=d;return}function JAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[93456]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+184>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+184>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(93464,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+184>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=111408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[93456]=1;i=d;return}function KAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[93608]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+76>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+76>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(93616,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+76>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=101208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[93608]=1;i=d;return}function LAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[93768]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+72>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+72>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(93776,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+72>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=101208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[93768]=1;i=d;return}function MAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[93928]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+68>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+68>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(93936,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+68>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=101208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[93928]=1;i=d;return}function NAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[94088]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+64>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+64>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(94096,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+64>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=101208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[94088]=1;i=d;return}function OAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[94248]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+60>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+60>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(94256,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+60>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=101208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[94248]=1;i=d;return}function PAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[94408]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+56>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+56>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(94416,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+56>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=101208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[94408]=1;i=d;return}function QAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[94568]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+52>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+52>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(94576,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+52>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=101208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[94568]=1;i=d;return}function RAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[94728]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+48>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+48>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(94736,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+48>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=101208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[94728]=1;i=d;return}function SAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[94888]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+44>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+44>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(94896,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+44>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=101208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[94888]=1;i=d;return}function TAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[95048]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+40>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+40>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(95056,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+40>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=101208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[95048]=1;i=d;return}function UAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[95208]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+36>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+36>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(95216,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+36>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=101208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[95208]=1;i=d;return}function VAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[95368]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+32>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+32>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(95376,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+32>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=101208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[95368]=1;i=d;return}function WAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[95528]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+28>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+28>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(95536,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+28>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=101208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[95528]=1;i=d;return}function XAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[95688]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+24>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+24>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(95696,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+24>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=101208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[95688]=1;i=d;return}function YAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[95848]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+20>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+20>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(95856,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+20>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=101208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[95848]=1;i=d;return}function ZAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[96008]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+16>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+16>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(96016,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+16>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=101208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[96008]=1;i=d;return}function _Aa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[96168]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+12>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+12>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(96176,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+12>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=101208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[96168]=1;i=d;return}function $Aa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[96328]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+8>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+8>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(96336,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+8>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=101208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[96328]=1;i=d;return}function aBa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[96488]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+4>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+4>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(96496,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+4>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=101208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[96488]=1;i=d;return}function bBa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[96648]&1){i=d;return}g=b+4|0;b=E_a(+(c[c[(c[c[g>>2]>>2]|0)+12>>2]>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[c[(c[c[g>>2]>>2]|0)+12>>2]>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(96656,NXa(c[c[(c[c[g>>2]>>2]|0)+12>>2]>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=101208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[96648]=1;i=d;return}function cBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[96808]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14800>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14800>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(96816,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14800>>3],58584)|0)|0;g=c[72302]|0;j=e;k=97408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[96808]=1;i=d;return}function dBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[96960]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14792>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14792>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(96968,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14792>>3],58584)|0)|0;g=c[72302]|0;j=e;k=97568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[96960]=1;i=d;return}function eBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[97096]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14784>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14784>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(97104,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14784>>3],58584)|0)|0;g=c[72302]|0;j=e;k=97752;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[97096]=1;i=d;return}function fBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[97256]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14776>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14776>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(97264,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14776>>3],58584)|0)|0;g=c[72302]|0;j=e;k=97408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[97256]=1;i=d;return}function gBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[97432]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14768>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14768>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(97440,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14768>>3],58584)|0)|0;g=c[72302]|0;j=e;k=97568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[97432]=1;i=d;return}function hBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[97592]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14760>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14760>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(97600,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14760>>3],58584)|0)|0;g=c[72302]|0;j=e;k=97752;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[97592]=1;i=d;return}function iBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[97776]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14752>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14752>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(97784,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14752>>3],58584)|0)|0;g=c[72302]|0;j=e;k=98080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[97776]=1;i=d;return}function jBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[97928]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14744>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14744>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(97936,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14744>>3],58584)|0)|0;g=c[72302]|0;j=e;k=98080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[97928]=1;i=d;return}function kBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[98104]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12392>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12392>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(98112,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12392>>3],58584)|0)|0;g=c[72302]|0;j=e;k=98608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[98104]=1;i=d;return}function lBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[98272]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12384>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12384>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(98280,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12384>>3],58584)|0)|0;g=c[72302]|0;j=e;k=98792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[98272]=1;i=d;return}function mBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[98432]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12376>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12376>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(98440,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12376>>3],58584)|0)|0;g=c[72302]|0;j=e;k=98608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[98432]=1;i=d;return}function nBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[98632]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12208>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12208>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(98640,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12208>>3],58584)|0)|0;g=c[72302]|0;j=e;k=98792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[98632]=1;i=d;return}function oBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[98816]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14736>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(98824,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14736>>3],58584)|0)|0;g=c[72302]|0;j=e;k=99104;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[98816]=1;i=d;return}function pBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[98960]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14728>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(98968,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14728>>3],58584)|0)|0;g=c[72302]|0;j=e;k=99104;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[98960]=1;i=d;return}function qBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[99128]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12192>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12192>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(99136,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12192>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[99128]=1;i=d;return}function rBa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[99288]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+180>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+180>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(99296,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+180>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=101208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[99288]=1;i=d;return}function sBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[99440]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14720>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14720>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=RXa(99448,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14720>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[99440]=1;i=d;return}function tBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[99592]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14712>>3],.001)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14712>>3],.25)|0)<<24>>24==0)){i=d;return}b=RXa(99600,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14712>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[99592]=1;i=d;return}function uBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[99744]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12176>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12176>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(99752,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12176>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[99744]=1;i=d;return}function vBa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[99904]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+176>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+176>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(99912,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+176>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=101208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[99904]=1;i=d;return}function wBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[100056]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14704>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14704>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=RXa(100064,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14704>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[100056]=1;i=d;return}function xBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[100208]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14696>>3],.001)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14696>>3],.25)|0)<<24>>24==0)){i=d;return}b=RXa(100216,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14696>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[100208]=1;i=d;return}function yBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[100360]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12160>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12160>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(100368,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12160>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[100360]=1;i=d;return}function zBa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[100504]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+172>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+172>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(100512,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+172>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=101208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[100504]=1;i=d;return}function ABa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[100648]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14688>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14688>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=RXa(100656,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14688>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[100648]=1;i=d;return}function BBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[100784]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14680>>3],.001)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14680>>3],.25)|0)<<24>>24==0)){i=d;return}b=RXa(100792,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14680>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[100784]=1;i=d;return}function CBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[100920]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12144>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12144>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(100928,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12144>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[100920]=1;i=d;return}function DBa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[101064]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+168>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+168>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(101072,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+168>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=101208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[101064]=1;i=d;return}function EBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[101232]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14672>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14672>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=RXa(101240,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14672>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[101232]=1;i=d;return}function FBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[101368]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14664>>3],.001)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14664>>3],.25)|0)<<24>>24==0)){i=d;return}b=RXa(101376,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14664>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[101368]=1;i=d;return}function GBa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[101504]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+164>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+164>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(101512,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+164>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=111408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[101504]=1;i=d;return}function HBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[101656]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12136>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12136>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(101664,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12136>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[101656]=1;i=d;return}function IBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[101816]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12128>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12128>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=RXa(101824,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12128>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[101816]=1;i=d;return}function JBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[101976]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12120>>3],.001)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12120>>3],.25)|0)<<24>>24==0)){i=d;return}b=RXa(101984,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12120>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[101976]=1;i=d;return}function KBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[102136]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12112>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12112>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(102144,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12112>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[102136]=1;i=d;return}function LBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[102296]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12104>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12104>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=RXa(102304,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12104>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[102296]=1;i=d;return}function MBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[102456]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12096>>3],.001)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12096>>3],.25)|0)<<24>>24==0)){i=d;return}b=RXa(102464,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12096>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[102456]=1;i=d;return}function NBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[102616]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12088>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12088>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(102624,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12088>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[102616]=1;i=d;return}function OBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[102776]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12080>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12080>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=RXa(102784,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12080>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[102776]=1;i=d;return}function PBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[102936]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12072>>3],.001)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12072>>3],.25)|0)<<24>>24==0)){i=d;return}b=RXa(102944,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12072>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[102936]=1;i=d;return}function QBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[103096]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12064>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12064>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(103104,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12064>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[103096]=1;i=d;return}function RBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[103256]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12056>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12056>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=RXa(103264,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12056>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[103256]=1;i=d;return}function SBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[103416]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12048>>3],.001)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12048>>3],.25)|0)<<24>>24==0)){i=d;return}b=RXa(103424,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12048>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[103416]=1;i=d;return}function TBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[103576]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12040>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12040>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(103584,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12040>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[103576]=1;i=d;return}function UBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[103736]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12032>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12032>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=RXa(103744,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12032>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[103736]=1;i=d;return}function VBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[103896]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12024>>3],.001)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12024>>3],.25)|0)<<24>>24==0)){i=d;return}b=RXa(103904,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12024>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[103896]=1;i=d;return}function WBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[104056]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12016>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12016>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(104064,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12016>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[104056]=1;i=d;return}



function FEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[125248]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9360>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(125256,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9360>>3],121480)|0)|0;g=c[72302]|0;j=e;k=126208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[125248]=1;i=d;return}function GEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[125344]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9368>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(125352,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9368>>3],121480)|0)|0;g=c[72302]|0;j=e;k=126208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[125344]=1;i=d;return}function HEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[125440]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9376>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(125448,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9376>>3],121480)|0)|0;g=c[72302]|0;j=e;k=126208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[125440]=1;i=d;return}function IEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[125536]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9384>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(125544,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9384>>3],121480)|0)|0;g=c[72302]|0;j=e;k=126208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[125536]=1;i=d;return}function JEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[125632]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9392>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(125640,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9392>>3],121480)|0)|0;g=c[72302]|0;j=e;k=126208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[125632]=1;i=d;return}function KEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[125728]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9400>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(125736,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9400>>3],121480)|0)|0;g=c[72302]|0;j=e;k=126208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[125728]=1;i=d;return}function LEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[125824]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9408>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(125832,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9408>>3],121480)|0)|0;g=c[72302]|0;j=e;k=126208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[125824]=1;i=d;return}function MEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[125920]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9416>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(125928,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9416>>3],121480)|0)|0;g=c[72302]|0;j=e;k=126208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[125920]=1;i=d;return}function NEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[126016]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9424>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(126024,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9424>>3],121480)|0)|0;g=c[72302]|0;j=e;k=126208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[126016]=1;i=d;return}function OEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[126112]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9432>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(126120,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9432>>3],121480)|0)|0;g=c[72302]|0;j=e;k=126208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[126112]=1;i=d;return}function PEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[126232]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+640>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(126240,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+640>>3],121480)|0)|0;g=c[72302]|0;j=e;k=128152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[126232]=1;i=d;return}function QEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[126328]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+648>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(126336,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+648>>3],121480)|0)|0;g=c[72302]|0;j=e;k=128152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[126328]=1;i=d;return}function REa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[126424]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+656>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(126432,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+656>>3],121480)|0)|0;g=c[72302]|0;j=e;k=128152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[126424]=1;i=d;return}function SEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[126520]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+664>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(126528,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+664>>3],121480)|0)|0;g=c[72302]|0;j=e;k=128152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[126520]=1;i=d;return}function TEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[126616]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+672>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(126624,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+672>>3],121480)|0)|0;g=c[72302]|0;j=e;k=128152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[126616]=1;i=d;return}function UEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[126712]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+680>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(126720,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+680>>3],121480)|0)|0;g=c[72302]|0;j=e;k=128152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[126712]=1;i=d;return}function VEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[126808]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+688>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(126816,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+688>>3],121480)|0)|0;g=c[72302]|0;j=e;k=128152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[126808]=1;i=d;return}function WEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[126904]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+696>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(126912,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+696>>3],121480)|0)|0;g=c[72302]|0;j=e;k=128152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[126904]=1;i=d;return}function XEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[127e3]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+704>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(127008,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+704>>3],121480)|0)|0;g=c[72302]|0;j=e;k=128152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[127e3]=1;i=d;return}function YEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[127096]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+712>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(127104,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+712>>3],121480)|0)|0;g=c[72302]|0;j=e;k=128152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[127096]=1;i=d;return}function ZEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[127192]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+720>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(127200,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+720>>3],121480)|0)|0;g=c[72302]|0;j=e;k=128152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[127192]=1;i=d;return}function _Ea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[127288]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+728>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(127296,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+728>>3],121480)|0)|0;g=c[72302]|0;j=e;k=128152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[127288]=1;i=d;return}function $Ea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[127384]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+736>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(127392,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+736>>3],121480)|0)|0;g=c[72302]|0;j=e;k=128152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[127384]=1;i=d;return}function aFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[127480]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+744>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(127488,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+744>>3],121480)|0)|0;g=c[72302]|0;j=e;k=128152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[127480]=1;i=d;return}function bFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[127576]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+752>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(127584,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+752>>3],121480)|0)|0;g=c[72302]|0;j=e;k=128152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[127576]=1;i=d;return}function cFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[127672]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+760>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(127680,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+760>>3],121480)|0)|0;g=c[72302]|0;j=e;k=128152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[127672]=1;i=d;return}function dFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[127768]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+768>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(127776,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+768>>3],121480)|0)|0;g=c[72302]|0;j=e;k=128152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[127768]=1;i=d;return}function eFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[127864]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+776>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(127872,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+776>>3],121480)|0)|0;g=c[72302]|0;j=e;k=128152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[127864]=1;i=d;return}function fFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[127960]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+784>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(127968,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+784>>3],121480)|0)|0;g=c[72302]|0;j=e;k=128152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[127960]=1;i=d;return}function gFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[128056]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+792>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(128064,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+792>>3],121480)|0)|0;g=c[72302]|0;j=e;k=128152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[128056]=1;i=d;return}function hFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[128176]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14576>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14576>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(128184,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14576>>3],121480)|0)|0;g=c[72302]|0;j=e;k=178976;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[128176]=1;i=d;return}function iFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[128400]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14568>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14568>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(128408,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14568>>3],121480)|0)|0;g=c[72302]|0;j=e;k=179144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[128400]=1;i=d;return}function jFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[128544]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9272>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9272>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(128552,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9272>>3],121480)|0)|0;g=c[72302]|0;j=e;k=182336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[128544]=1;i=d;return}function kFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[128720]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9264>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9264>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(128728,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9264>>3],121480)|0)|0;g=c[72302]|0;j=e;k=182336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[128720]=1;i=d;return}function lFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[128896]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9256>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9256>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(128904,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9256>>3],121480)|0)|0;g=c[72302]|0;j=e;k=182336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[128896]=1;i=d;return}function mFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[129072]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9248>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9248>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(129080,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9248>>3],121480)|0)|0;g=c[72302]|0;j=e;k=182336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[129072]=1;i=d;return}function nFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[129248]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9240>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9240>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(129256,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9240>>3],121480)|0)|0;g=c[72302]|0;j=e;k=182336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[129248]=1;i=d;return}function oFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[129424]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9232>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9232>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(129432,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9232>>3],121480)|0)|0;g=c[72302]|0;j=e;k=182336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[129424]=1;i=d;return}function pFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[129600]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9224>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9224>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(129608,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9224>>3],121480)|0)|0;g=c[72302]|0;j=e;k=182336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[129600]=1;i=d;return}function qFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[129776]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9216>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9216>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(129784,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9216>>3],121480)|0)|0;g=c[72302]|0;j=e;k=182336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[129776]=1;i=d;return}function rFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[129952]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9208>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9208>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(129960,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9208>>3],121480)|0)|0;g=c[72302]|0;j=e;k=182336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[129952]=1;i=d;return}function sFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[130128]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9200>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9200>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(130136,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9200>>3],121480)|0)|0;g=c[72302]|0;j=e;k=182336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[130128]=1;i=d;return}function tFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[130304]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9192>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9192>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(130312,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9192>>3],121480)|0)|0;g=c[72302]|0;j=e;k=182336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[130304]=1;i=d;return}function uFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[130480]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9184>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9184>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(130488,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9184>>3],121480)|0)|0;g=c[72302]|0;j=e;k=182336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[130480]=1;i=d;return}function vFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[130656]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9176>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9176>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(130664,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9176>>3],121480)|0)|0;g=c[72302]|0;j=e;k=182336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[130656]=1;i=d;return}function wFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[130832]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9168>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9168>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(130840,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9168>>3],121480)|0)|0;g=c[72302]|0;j=e;k=182336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[130832]=1;i=d;return}function xFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[131008]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9160>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9160>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(131016,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9160>>3],121480)|0)|0;g=c[72302]|0;j=e;k=182336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[131008]=1;i=d;return}function yFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[131184]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9152>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9152>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(131192,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9152>>3],121480)|0)|0;g=c[72302]|0;j=e;k=182336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[131184]=1;i=d;return}function zFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[131360]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9144>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9144>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(131368,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9144>>3],121480)|0)|0;g=c[72302]|0;j=e;k=182336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[131360]=1;i=d;return}function AFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[131536]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9136>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9136>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(131544,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9136>>3],121480)|0)|0;g=c[72302]|0;j=e;k=182336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[131536]=1;i=d;return}function BFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[131712]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8816>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(131720,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8816>>3],121480)|0)|0;g=c[72302]|0;j=e;k=184440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[131712]=1;i=d;return}function CFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[131816]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8824>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(131824,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8824>>3],121480)|0)|0;g=c[72302]|0;j=e;k=184440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[131816]=1;i=d;return}function DFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[131920]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8832>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(131928,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8832>>3],121480)|0)|0;g=c[72302]|0;j=e;k=184440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[131920]=1;i=d;return}function EFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[132024]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8840>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(132032,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8840>>3],121480)|0)|0;g=c[72302]|0;j=e;k=184440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[132024]=1;i=d;return}function FFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[132128]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8848>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(132136,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8848>>3],121480)|0)|0;g=c[72302]|0;j=e;k=184440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[132128]=1;i=d;return}function GFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[132232]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8856>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(132240,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8856>>3],121480)|0)|0;g=c[72302]|0;j=e;k=184440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[132232]=1;i=d;return}function HFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[132336]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8864>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(132344,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8864>>3],121480)|0)|0;g=c[72302]|0;j=e;k=184440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[132336]=1;i=d;return}function IFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[132440]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8872>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(132448,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8872>>3],121480)|0)|0;g=c[72302]|0;j=e;k=184440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[132440]=1;i=d;return}function JFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[132544]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8880>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(132552,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8880>>3],121480)|0)|0;g=c[72302]|0;j=e;k=184440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[132544]=1;i=d;return}function KFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[132648]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8888>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(132656,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8888>>3],121480)|0)|0;g=c[72302]|0;j=e;k=184440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[132648]=1;i=d;return}function LFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[132752]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8896>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(132760,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8896>>3],121480)|0)|0;g=c[72302]|0;j=e;k=184440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[132752]=1;i=d;return}function MFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[132856]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8904>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(132864,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8904>>3],121480)|0)|0;g=c[72302]|0;j=e;k=184440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[132856]=1;i=d;return}function NFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[132960]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8912>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(132968,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8912>>3],121480)|0)|0;g=c[72302]|0;j=e;k=184440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[132960]=1;i=d;return}function OFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[133064]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8920>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(133072,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8920>>3],121480)|0)|0;g=c[72302]|0;j=e;k=184440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[133064]=1;i=d;return}function PFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[133168]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8928>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(133176,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8928>>3],121480)|0)|0;g=c[72302]|0;j=e;k=184440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[133168]=1;i=d;return}function QFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[133272]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8936>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(133280,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8936>>3],121480)|0)|0;g=c[72302]|0;j=e;k=184440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[133272]=1;i=d;return}function RFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[133376]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8944>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(133384,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8944>>3],121480)|0)|0;g=c[72302]|0;j=e;k=184440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[133376]=1;i=d;return}function SFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[133480]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8952>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(133488,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8952>>3],121480)|0)|0;g=c[72302]|0;j=e;k=184440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[133480]=1;i=d;return}function TFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[133584]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8960>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(133592,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8960>>3],121480)|0)|0;g=c[72302]|0;j=e;k=184440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[133584]=1;i=d;return}function UFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[133688]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8968>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(133696,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8968>>3],121480)|0)|0;g=c[72302]|0;j=e;k=184440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[133688]=1;i=d;return}function VFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[133792]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8656>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8656>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(133800,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8656>>3],121480)|0)|0;g=c[72302]|0;j=e;k=187664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[133792]=1;i=d;return}function WFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[133952]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8664>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8664>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(133960,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8664>>3],121480)|0)|0;g=c[72302]|0;j=e;k=187664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[133952]=1;i=d;return}function XFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[134112]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8672>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8672>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(134120,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8672>>3],121480)|0)|0;g=c[72302]|0;j=e;k=187664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[134112]=1;i=d;return}function YFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[134272]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8680>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8680>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(134280,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8680>>3],121480)|0)|0;g=c[72302]|0;j=e;k=187664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[134272]=1;i=d;return}function ZFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[134432]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8688>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8688>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(134440,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8688>>3],121480)|0)|0;g=c[72302]|0;j=e;k=187664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[134432]=1;i=d;return}function _Fa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[134592]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8696>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8696>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(134600,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8696>>3],121480)|0)|0;g=c[72302]|0;j=e;k=187664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[134592]=1;i=d;return}function $Fa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[134752]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8704>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8704>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(134760,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8704>>3],121480)|0)|0;g=c[72302]|0;j=e;k=187664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[134752]=1;i=d;return}function aGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[134912]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8712>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8712>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(134920,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8712>>3],121480)|0)|0;g=c[72302]|0;j=e;k=187664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[134912]=1;i=d;return}function bGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[135072]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8720>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8720>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(135080,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8720>>3],121480)|0)|0;g=c[72302]|0;j=e;k=187664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[135072]=1;i=d;return}function cGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[135232]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8728>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8728>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(135240,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8728>>3],121480)|0)|0;g=c[72302]|0;j=e;k=187664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[135232]=1;i=d;return}function dGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[135392]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8736>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8736>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(135400,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8736>>3],121480)|0)|0;g=c[72302]|0;j=e;k=187664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[135392]=1;i=d;return}function eGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[135552]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8744>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8744>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(135560,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8744>>3],121480)|0)|0;g=c[72302]|0;j=e;k=187664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[135552]=1;i=d;return}function fGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[135712]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8752>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8752>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(135720,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8752>>3],121480)|0)|0;g=c[72302]|0;j=e;k=187664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[135712]=1;i=d;return}function gGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[135872]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8760>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8760>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(135880,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8760>>3],121480)|0)|0;g=c[72302]|0;j=e;k=187664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[135872]=1;i=d;return}function hGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[136032]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8768>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8768>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(136040,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8768>>3],121480)|0)|0;g=c[72302]|0;j=e;k=187664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[136032]=1;i=d;return}function iGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[136192]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8776>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8776>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(136200,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8776>>3],121480)|0)|0;g=c[72302]|0;j=e;k=187664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[136192]=1;i=d;return}function jGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[136352]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8784>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8784>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(136360,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8784>>3],121480)|0)|0;g=c[72302]|0;j=e;k=187664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[136352]=1;i=d;return}function kGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[136512]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8792>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8792>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(136520,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8792>>3],121480)|0)|0;g=c[72302]|0;j=e;k=187664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[136512]=1;i=d;return}function lGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[136672]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8800>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8800>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(136680,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8800>>3],121480)|0)|0;g=c[72302]|0;j=e;k=187664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[136672]=1;i=d;return}function mGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[136832]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8808>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8808>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(136840,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8808>>3],121480)|0)|0;g=c[72302]|0;j=e;k=187664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[136832]=1;i=d;return}function nGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[136992]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8168>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8168>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(137e3,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8168>>3],121480)|0)|0;g=c[72302]|0;j=e;k=191032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[136992]=1;i=d;return}function oGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[137232]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8160>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8160>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(137240,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8160>>3],121480)|0)|0;g=c[72302]|0;j=e;k=191032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[137232]=1;i=d;return}function pGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[137400]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8152>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8152>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(137408,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8152>>3],121480)|0)|0;g=c[72302]|0;j=e;k=191032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[137400]=1;i=d;return}function qGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[137568]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8144>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8144>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(137576,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8144>>3],121480)|0)|0;g=c[72302]|0;j=e;k=191032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[137568]=1;i=d;return}function rGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[137736]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8136>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8136>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(137744,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8136>>3],121480)|0)|0;g=c[72302]|0;j=e;k=191032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[137736]=1;i=d;return}function sGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[137904]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8128>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8128>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(137912,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8128>>3],121480)|0)|0;g=c[72302]|0;j=e;k=191032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[137904]=1;i=d;return}function tGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[138072]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8120>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8120>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(138080,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8120>>3],121480)|0)|0;g=c[72302]|0;j=e;k=191032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[138072]=1;i=d;return}function uGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[138240]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8112>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8112>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(138248,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8112>>3],121480)|0)|0;g=c[72302]|0;j=e;k=191032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[138240]=1;i=d;return}function vGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[138408]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8104>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8104>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(138416,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8104>>3],121480)|0)|0;g=c[72302]|0;j=e;k=191032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[138408]=1;i=d;return}function wGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[138576]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8096>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8096>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(138584,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8096>>3],121480)|0)|0;g=c[72302]|0;j=e;k=191032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[138576]=1;i=d;return}function xGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[138744]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8088>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8088>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(138752,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8088>>3],121480)|0)|0;g=c[72302]|0;j=e;k=191032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[138744]=1;i=d;return}function yGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[138912]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8080>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8080>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(138920,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8080>>3],121480)|0)|0;g=c[72302]|0;j=e;k=191032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[138912]=1;i=d;return}function zGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[139080]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8072>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8072>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(139088,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8072>>3],121480)|0)|0;g=c[72302]|0;j=e;k=191032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[139080]=1;i=d;return}function AGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[139248]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8064>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8064>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(139256,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8064>>3],121480)|0)|0;g=c[72302]|0;j=e;k=191032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[139248]=1;i=d;return}function BGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[139416]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8056>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8056>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(139424,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8056>>3],121480)|0)|0;g=c[72302]|0;j=e;k=191032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[139416]=1;i=d;return}function CGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[139584]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8048>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8048>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(139592,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8048>>3],121480)|0)|0;g=c[72302]|0;j=e;k=191032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[139584]=1;i=d;return}function DGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[139752]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8040>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8040>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(139760,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8040>>3],121480)|0)|0;g=c[72302]|0;j=e;k=191032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[139752]=1;i=d;return}function EGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[139920]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8032>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8032>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(139928,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8032>>3],121480)|0)|0;g=c[72302]|0;j=e;k=191032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[139920]=1;i=d;return}function FGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[140088]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8024>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8024>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(140096,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8024>>3],121480)|0)|0;g=c[72302]|0;j=e;k=191032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[140088]=1;i=d;return}function GGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[140256]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8016>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8016>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(140264,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8016>>3],121480)|0)|0;g=c[72302]|0;j=e;k=191032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[140256]=1;i=d;return}function HGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[140416]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7848>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7848>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(140424,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7848>>3],121480)|0)|0;g=c[72302]|0;j=e;k=194512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[140416]=1;i=d;return}function IGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[140576]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7856>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7856>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(140584,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7856>>3],121480)|0)|0;g=c[72302]|0;j=e;k=194512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[140576]=1;i=d;return}function JGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[140736]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7864>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7864>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(140744,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7864>>3],121480)|0)|0;g=c[72302]|0;j=e;k=194512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[140736]=1;i=d;return}function KGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[140896]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7872>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7872>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(140904,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7872>>3],121480)|0)|0;g=c[72302]|0;j=e;k=194512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[140896]=1;i=d;return}function LGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[141056]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7880>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7880>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(141064,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7880>>3],121480)|0)|0;g=c[72302]|0;j=e;k=194512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[141056]=1;i=d;return}function MGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[141216]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7888>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7888>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(141224,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7888>>3],121480)|0)|0;g=c[72302]|0;j=e;k=194512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[141216]=1;i=d;return}function NGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[141376]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7896>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7896>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(141384,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7896>>3],121480)|0)|0;g=c[72302]|0;j=e;k=194512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[141376]=1;i=d;return}function OGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[141536]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7904>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7904>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(141544,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7904>>3],121480)|0)|0;g=c[72302]|0;j=e;k=194512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[141536]=1;i=d;return}function PGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[141696]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7912>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7912>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(141704,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7912>>3],121480)|0)|0;g=c[72302]|0;j=e;k=194512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[141696]=1;i=d;return}function QGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[141856]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7920>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7920>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(141864,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7920>>3],121480)|0)|0;g=c[72302]|0;j=e;k=194512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[141856]=1;i=d;return}function RGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[142024]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7928>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7928>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(142032,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7928>>3],121480)|0)|0;g=c[72302]|0;j=e;k=194512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[142024]=1;i=d;return}function SGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[142192]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7936>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7936>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(142200,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7936>>3],121480)|0)|0;g=c[72302]|0;j=e;k=194512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[142192]=1;i=d;return}function TGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[142360]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7944>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7944>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(142368,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7944>>3],121480)|0)|0;g=c[72302]|0;j=e;k=194512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[142360]=1;i=d;return}function UGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[142528]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7952>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7952>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(142536,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7952>>3],121480)|0)|0;g=c[72302]|0;j=e;k=194512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[142528]=1;i=d;return}function VGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[142696]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7960>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7960>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(142704,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7960>>3],121480)|0)|0;g=c[72302]|0;j=e;k=194512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[142696]=1;i=d;return}function WGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[142864]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7968>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7968>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(142872,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7968>>3],121480)|0)|0;g=c[72302]|0;j=e;k=194512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[142864]=1;i=d;return}function XGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[143032]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7976>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7976>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(143040,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7976>>3],121480)|0)|0;g=c[72302]|0;j=e;k=194512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[143032]=1;i=d;return}function YGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[143200]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7984>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7984>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(143208,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7984>>3],121480)|0)|0;g=c[72302]|0;j=e;k=194512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[143200]=1;i=d;return}function ZGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[143368]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7992>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7992>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(143376,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7992>>3],121480)|0)|0;g=c[72302]|0;j=e;k=194512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[143368]=1;i=d;return}function _Ga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[143536]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8e3>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8e3>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(143544,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8e3>>3],121480)|0)|0;g=c[72302]|0;j=e;k=194512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[143536]=1;i=d;return}function $Ga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[143704]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8008>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8008>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(143712,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8008>>3],121480)|0)|0;g=c[72302]|0;j=e;k=194512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[143704]=1;i=d;return}function aHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[143872]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12216>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12216>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(143880,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12216>>3],121480)|0)|0;g=c[72302]|0;j=e;k=197992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[143872]=1;i=d;return}function bHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[144040]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12224>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12224>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(144048,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12224>>3],121480)|0)|0;g=c[72302]|0;j=e;k=197992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[144040]=1;i=d;return}function cHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[144208]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12232>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12232>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(144216,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12232>>3],121480)|0)|0;g=c[72302]|0;j=e;k=197992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[144208]=1;i=d;return}function dHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[144376]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12240>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12240>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(144384,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12240>>3],121480)|0)|0;g=c[72302]|0;j=e;k=197992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[144376]=1;i=d;return}function eHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[144544]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12248>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12248>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(144552,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12248>>3],121480)|0)|0;g=c[72302]|0;j=e;k=197992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[144544]=1;i=d;return}function fHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[144712]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12256>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12256>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(144720,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12256>>3],121480)|0)|0;g=c[72302]|0;j=e;k=197992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[144712]=1;i=d;return}function gHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[144880]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12264>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12264>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(144888,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12264>>3],121480)|0)|0;g=c[72302]|0;j=e;k=197992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[144880]=1;i=d;return}function hHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[145048]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12272>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12272>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(145056,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12272>>3],121480)|0)|0;g=c[72302]|0;j=e;k=197992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[145048]=1;i=d;return}function iHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[145216]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12280>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12280>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(145224,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12280>>3],121480)|0)|0;g=c[72302]|0;j=e;k=197992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[145216]=1;i=d;return}function jHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[145384]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12288>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12288>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(145392,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12288>>3],121480)|0)|0;g=c[72302]|0;j=e;k=197992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[145384]=1;i=d;return}function kHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[145560]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12296>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12296>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(145568,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12296>>3],121480)|0)|0;g=c[72302]|0;j=e;k=197992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[145560]=1;i=d;return}function lHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[145736]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12304>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12304>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(145744,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12304>>3],121480)|0)|0;g=c[72302]|0;j=e;k=197992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[145736]=1;i=d;return}function mHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[145912]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12312>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12312>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(145920,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12312>>3],121480)|0)|0;g=c[72302]|0;j=e;k=197992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[145912]=1;i=d;return}function nHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[146088]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12320>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12320>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(146096,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12320>>3],121480)|0)|0;g=c[72302]|0;j=e;k=197992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[146088]=1;i=d;return}function oHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[146264]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12328>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12328>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(146272,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12328>>3],121480)|0)|0;g=c[72302]|0;j=e;k=197992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[146264]=1;i=d;return}function pHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[146440]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12336>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12336>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(146448,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12336>>3],121480)|0)|0;g=c[72302]|0;j=e;k=197992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[146440]=1;i=d;return}function qHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[146616]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12344>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12344>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(146624,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12344>>3],121480)|0)|0;g=c[72302]|0;j=e;k=197992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[146616]=1;i=d;return}function rHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[146792]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12352>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12352>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(146800,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12352>>3],121480)|0)|0;g=c[72302]|0;j=e;k=197992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[146792]=1;i=d;return}function sHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[146968]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12360>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12360>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(146976,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12360>>3],121480)|0)|0;g=c[72302]|0;j=e;k=197992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[146968]=1;i=d;return}function tHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[147144]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12368>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12368>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(147152,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12368>>3],121480)|0)|0;g=c[72302]|0;j=e;k=197992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[147144]=1;i=d;return}function uHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[147320]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7680>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7680>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(147328,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7680>>3],121480)|0)|0;g=c[72302]|0;j=e;k=201696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[147320]=1;i=d;return}function vHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[147504]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7688>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7688>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(147512,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7688>>3],121480)|0)|0;g=c[72302]|0;j=e;k=201696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[147504]=1;i=d;return}function wHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[147688]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7696>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7696>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(147696,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7696>>3],121480)|0)|0;g=c[72302]|0;j=e;k=201696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[147688]=1;i=d;return}function xHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[147872]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7704>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7704>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(147880,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7704>>3],121480)|0)|0;g=c[72302]|0;j=e;k=201696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[147872]=1;i=d;return}function yHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[148056]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7712>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7712>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(148064,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7712>>3],121480)|0)|0;g=c[72302]|0;j=e;k=201696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[148056]=1;i=d;return}function zHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[148240]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7720>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7720>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(148248,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7720>>3],121480)|0)|0;g=c[72302]|0;j=e;k=201696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[148240]=1;i=d;return}function AHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[148424]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7728>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7728>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(148432,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7728>>3],121480)|0)|0;g=c[72302]|0;j=e;k=201696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[148424]=1;i=d;return}function BHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[148608]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7736>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7736>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(148616,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7736>>3],121480)|0)|0;g=c[72302]|0;j=e;k=201696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[148608]=1;i=d;return}function CHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[148792]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7744>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7744>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(148800,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7744>>3],121480)|0)|0;g=c[72302]|0;j=e;k=201696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[148792]=1;i=d;return}function DHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[148976]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7752>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7752>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(148984,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7752>>3],121480)|0)|0;g=c[72302]|0;j=e;k=201696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[148976]=1;i=d;return}function EHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[149160]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7760>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7760>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(149168,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7760>>3],121480)|0)|0;g=c[72302]|0;j=e;k=201696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[149160]=1;i=d;return}function FHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[149344]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7768>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7768>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(149352,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7768>>3],121480)|0)|0;g=c[72302]|0;j=e;k=201696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[149344]=1;i=d;return}function GHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[149528]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7776>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7776>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(149536,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7776>>3],121480)|0)|0;g=c[72302]|0;j=e;k=201696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[149528]=1;i=d;return}function HHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[149712]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7784>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7784>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(149720,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7784>>3],121480)|0)|0;g=c[72302]|0;j=e;k=201696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[149712]=1;i=d;return}function IHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[149896]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7792>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7792>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(149904,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7792>>3],121480)|0)|0;g=c[72302]|0;j=e;k=201696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[149896]=1;i=d;return}function JHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[150080]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7800>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7800>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(150088,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7800>>3],121480)|0)|0;g=c[72302]|0;j=e;k=201696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[150080]=1;i=d;return}function KHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[150264]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7808>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7808>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(150272,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7808>>3],121480)|0)|0;g=c[72302]|0;j=e;k=201696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[150264]=1;i=d;return}function LHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[150448]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7816>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7816>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(150456,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7816>>3],121480)|0)|0;g=c[72302]|0;j=e;k=201696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[150448]=1;i=d;return}function MHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[150632]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7824>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7824>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(150640,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7824>>3],121480)|0)|0;g=c[72302]|0;j=e;k=201696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[150632]=1;i=d;return}function NHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[150816]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7832>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7832>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(150824,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7832>>3],121480)|0)|0;g=c[72302]|0;j=e;k=201696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[150816]=1;i=d;return}function OHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[151e3]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10848>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10848>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(151008,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10848>>3],121480)|0)|0;g=c[72302]|0;j=e;k=205176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[151e3]=1;i=d;return}function PHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[151168]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10856>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10856>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(151176,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10856>>3],121480)|0)|0;g=c[72302]|0;j=e;k=205176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[151168]=1;i=d;return}function QHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[151336]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10864>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10864>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(151344,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10864>>3],121480)|0)|0;g=c[72302]|0;j=e;k=205176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[151336]=1;i=d;return}function RHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[151504]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10872>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10872>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(151512,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10872>>3],121480)|0)|0;g=c[72302]|0;j=e;k=205176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[151504]=1;i=d;return}function SHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[151672]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10880>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10880>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(151680,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10880>>3],121480)|0)|0;g=c[72302]|0;j=e;k=205176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[151672]=1;i=d;return}function THa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[151840]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10888>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10888>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(151848,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10888>>3],121480)|0)|0;g=c[72302]|0;j=e;k=205176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[151840]=1;i=d;return}function UHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[152008]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10896>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10896>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(152016,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10896>>3],121480)|0)|0;g=c[72302]|0;j=e;k=205176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[152008]=1;i=d;return}function VHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[152176]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10904>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10904>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(152184,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10904>>3],121480)|0)|0;g=c[72302]|0;j=e;k=205176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[152176]=1;i=d;return}function WHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[152344]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10912>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10912>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(152352,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10912>>3],121480)|0)|0;g=c[72302]|0;j=e;k=205176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[152344]=1;i=d;return}function XHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[152512]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10920>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10920>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(152520,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10920>>3],121480)|0)|0;g=c[72302]|0;j=e;k=205176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[152512]=1;i=d;return}



function jLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[182880]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4216>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(182888,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4216>>3],121480)|0)|0;g=c[72302]|0;j=e;k=184440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[182880]=1;i=d;return}function kLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[182984]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4224>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(182992,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4224>>3],121480)|0)|0;g=c[72302]|0;j=e;k=184440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[182984]=1;i=d;return}function lLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[183088]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4232>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(183096,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4232>>3],121480)|0)|0;g=c[72302]|0;j=e;k=184440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[183088]=1;i=d;return}function mLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[183192]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4240>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(183200,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4240>>3],121480)|0)|0;g=c[72302]|0;j=e;k=184440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[183192]=1;i=d;return}function nLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[183296]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4248>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(183304,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4248>>3],121480)|0)|0;g=c[72302]|0;j=e;k=184440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[183296]=1;i=d;return}function oLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[183400]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4256>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(183408,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4256>>3],121480)|0)|0;g=c[72302]|0;j=e;k=184440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[183400]=1;i=d;return}function pLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[183504]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4264>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(183512,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4264>>3],121480)|0)|0;g=c[72302]|0;j=e;k=184440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[183504]=1;i=d;return}function qLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[183608]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4272>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(183616,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4272>>3],121480)|0)|0;g=c[72302]|0;j=e;k=184440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[183608]=1;i=d;return}function rLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[183712]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4280>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(183720,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4280>>3],121480)|0)|0;g=c[72302]|0;j=e;k=184440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[183712]=1;i=d;return}function sLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[183816]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4288>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(183824,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4288>>3],121480)|0)|0;g=c[72302]|0;j=e;k=184440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[183816]=1;i=d;return}function tLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[183920]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4296>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(183928,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4296>>3],121480)|0)|0;g=c[72302]|0;j=e;k=184440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[183920]=1;i=d;return}function uLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[184024]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4304>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(184032,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4304>>3],121480)|0)|0;g=c[72302]|0;j=e;k=184440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[184024]=1;i=d;return}function vLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[184128]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4312>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(184136,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4312>>3],121480)|0)|0;g=c[72302]|0;j=e;k=184440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[184128]=1;i=d;return}function wLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[184232]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4320>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(184240,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4320>>3],121480)|0)|0;g=c[72302]|0;j=e;k=184440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[184232]=1;i=d;return}function xLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[184336]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4328>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(184344,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4328>>3],121480)|0)|0;g=c[72302]|0;j=e;k=184440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[184336]=1;i=d;return}function yLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[184464]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4016>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4016>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(184472,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4016>>3],121480)|0)|0;g=c[72302]|0;j=e;k=187664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[184464]=1;i=d;return}function zLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[184624]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4024>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4024>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(184632,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4024>>3],121480)|0)|0;g=c[72302]|0;j=e;k=187664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[184624]=1;i=d;return}function ALa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[184784]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4032>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4032>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(184792,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4032>>3],121480)|0)|0;g=c[72302]|0;j=e;k=187664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[184784]=1;i=d;return}function BLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[184944]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4040>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4040>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(184952,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4040>>3],121480)|0)|0;g=c[72302]|0;j=e;k=187664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[184944]=1;i=d;return}function CLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[185104]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4048>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4048>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(185112,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4048>>3],121480)|0)|0;g=c[72302]|0;j=e;k=187664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[185104]=1;i=d;return}function DLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[185264]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4056>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4056>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(185272,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4056>>3],121480)|0)|0;g=c[72302]|0;j=e;k=187664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[185264]=1;i=d;return}function ELa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[185424]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4064>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4064>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(185432,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4064>>3],121480)|0)|0;g=c[72302]|0;j=e;k=187664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[185424]=1;i=d;return}function FLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[185584]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4072>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4072>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(185592,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4072>>3],121480)|0)|0;g=c[72302]|0;j=e;k=187664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[185584]=1;i=d;return}function GLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[185744]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4080>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4080>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(185752,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4080>>3],121480)|0)|0;g=c[72302]|0;j=e;k=187664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[185744]=1;i=d;return}function HLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[185904]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4088>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4088>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(185912,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4088>>3],121480)|0)|0;g=c[72302]|0;j=e;k=187664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[185904]=1;i=d;return}function ILa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[186064]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4096>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4096>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(186072,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4096>>3],121480)|0)|0;g=c[72302]|0;j=e;k=187664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[186064]=1;i=d;return}function JLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[186224]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4104>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4104>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(186232,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4104>>3],121480)|0)|0;g=c[72302]|0;j=e;k=187664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[186224]=1;i=d;return}function KLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[186384]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4112>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4112>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(186392,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4112>>3],121480)|0)|0;g=c[72302]|0;j=e;k=187664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[186384]=1;i=d;return}function LLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[186544]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4120>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4120>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(186552,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4120>>3],121480)|0)|0;g=c[72302]|0;j=e;k=187664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[186544]=1;i=d;return}function MLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[186704]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4128>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4128>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(186712,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4128>>3],121480)|0)|0;g=c[72302]|0;j=e;k=187664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[186704]=1;i=d;return}function NLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[186864]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4136>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4136>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(186872,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4136>>3],121480)|0)|0;g=c[72302]|0;j=e;k=187664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[186864]=1;i=d;return}function OLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[187024]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4144>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4144>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(187032,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4144>>3],121480)|0)|0;g=c[72302]|0;j=e;k=187664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[187024]=1;i=d;return}function PLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[187184]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4152>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4152>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(187192,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4152>>3],121480)|0)|0;g=c[72302]|0;j=e;k=187664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[187184]=1;i=d;return}function QLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[187344]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4160>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4160>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(187352,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4160>>3],121480)|0)|0;g=c[72302]|0;j=e;k=187664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[187344]=1;i=d;return}function RLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[187504]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4168>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4168>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(187512,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4168>>3],121480)|0)|0;g=c[72302]|0;j=e;k=187664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[187504]=1;i=d;return}function SLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[187688]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3528>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3528>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(187696,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3528>>3],121480)|0)|0;g=c[72302]|0;j=e;k=191032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[187688]=1;i=d;return}function TLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[187840]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3520>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3520>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(187848,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3520>>3],121480)|0)|0;g=c[72302]|0;j=e;k=191032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[187840]=1;i=d;return}function ULa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[188008]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3512>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3512>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(188016,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3512>>3],121480)|0)|0;g=c[72302]|0;j=e;k=191032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[188008]=1;i=d;return}function VLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[188176]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3504>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3504>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(188184,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3504>>3],121480)|0)|0;g=c[72302]|0;j=e;k=191032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[188176]=1;i=d;return}function WLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[188344]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3496>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3496>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(188352,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3496>>3],121480)|0)|0;g=c[72302]|0;j=e;k=191032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[188344]=1;i=d;return}function XLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[188512]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3488>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3488>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(188520,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3488>>3],121480)|0)|0;g=c[72302]|0;j=e;k=191032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[188512]=1;i=d;return}function YLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[188680]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3480>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3480>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(188688,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3480>>3],121480)|0)|0;g=c[72302]|0;j=e;k=191032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[188680]=1;i=d;return}function ZLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[188848]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3472>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3472>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(188856,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3472>>3],121480)|0)|0;g=c[72302]|0;j=e;k=191032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[188848]=1;i=d;return}function _La(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[189016]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3464>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3464>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(189024,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3464>>3],121480)|0)|0;g=c[72302]|0;j=e;k=191032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[189016]=1;i=d;return}function $La(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[189184]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3456>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3456>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(189192,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3456>>3],121480)|0)|0;g=c[72302]|0;j=e;k=191032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[189184]=1;i=d;return}function aMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[189352]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3448>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3448>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(189360,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3448>>3],121480)|0)|0;g=c[72302]|0;j=e;k=191032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[189352]=1;i=d;return}function bMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[189520]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3440>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3440>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(189528,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3440>>3],121480)|0)|0;g=c[72302]|0;j=e;k=191032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[189520]=1;i=d;return}function cMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[189688]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3432>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3432>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(189696,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3432>>3],121480)|0)|0;g=c[72302]|0;j=e;k=191032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[189688]=1;i=d;return}function dMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[189856]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3424>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3424>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(189864,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3424>>3],121480)|0)|0;g=c[72302]|0;j=e;k=191032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[189856]=1;i=d;return}function eMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[190024]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3416>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3416>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(190032,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3416>>3],121480)|0)|0;g=c[72302]|0;j=e;k=191032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[190024]=1;i=d;return}function fMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[190192]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3408>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3408>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(190200,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3408>>3],121480)|0)|0;g=c[72302]|0;j=e;k=191032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[190192]=1;i=d;return}function gMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[190360]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3400>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3400>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(190368,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3400>>3],121480)|0)|0;g=c[72302]|0;j=e;k=191032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[190360]=1;i=d;return}function hMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[190528]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3392>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3392>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(190536,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3392>>3],121480)|0)|0;g=c[72302]|0;j=e;k=191032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[190528]=1;i=d;return}function iMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[190696]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3384>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3384>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(190704,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3384>>3],121480)|0)|0;g=c[72302]|0;j=e;k=191032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[190696]=1;i=d;return}function jMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[190864]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3376>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3376>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(190872,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3376>>3],121480)|0)|0;g=c[72302]|0;j=e;k=191032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[190864]=1;i=d;return}function kMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[191056]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3208>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3208>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(191064,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3208>>3],121480)|0)|0;g=c[72302]|0;j=e;k=194512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[191056]=1;i=d;return}function lMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[191216]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3216>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3216>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(191224,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3216>>3],121480)|0)|0;g=c[72302]|0;j=e;k=194512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[191216]=1;i=d;return}function mMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[191376]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3224>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3224>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(191384,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3224>>3],121480)|0)|0;g=c[72302]|0;j=e;k=194512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[191376]=1;i=d;return}function nMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[191536]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3232>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3232>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(191544,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3232>>3],121480)|0)|0;g=c[72302]|0;j=e;k=194512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[191536]=1;i=d;return}function oMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[191696]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3240>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3240>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(191704,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3240>>3],121480)|0)|0;g=c[72302]|0;j=e;k=194512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[191696]=1;i=d;return}function pMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[191856]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3248>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3248>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(191864,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3248>>3],121480)|0)|0;g=c[72302]|0;j=e;k=194512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[191856]=1;i=d;return}function qMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[192016]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3256>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3256>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(192024,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3256>>3],121480)|0)|0;g=c[72302]|0;j=e;k=194512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[192016]=1;i=d;return}function rMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[192176]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3264>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3264>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(192184,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3264>>3],121480)|0)|0;g=c[72302]|0;j=e;k=194512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[192176]=1;i=d;return}function sMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[192336]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3272>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3272>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(192344,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3272>>3],121480)|0)|0;g=c[72302]|0;j=e;k=194512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[192336]=1;i=d;return}function tMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[192496]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3280>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3280>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(192504,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3280>>3],121480)|0)|0;g=c[72302]|0;j=e;k=194512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[192496]=1;i=d;return}function uMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[192664]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3288>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3288>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(192672,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3288>>3],121480)|0)|0;g=c[72302]|0;j=e;k=194512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[192664]=1;i=d;return}function vMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[192832]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3296>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3296>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(192840,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3296>>3],121480)|0)|0;g=c[72302]|0;j=e;k=194512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[192832]=1;i=d;return}function wMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[193e3]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3304>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3304>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(193008,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3304>>3],121480)|0)|0;g=c[72302]|0;j=e;k=194512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[193e3]=1;i=d;return}function xMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[193168]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3312>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3312>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(193176,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3312>>3],121480)|0)|0;g=c[72302]|0;j=e;k=194512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[193168]=1;i=d;return}function yMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[193336]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3320>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3320>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(193344,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3320>>3],121480)|0)|0;g=c[72302]|0;j=e;k=194512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[193336]=1;i=d;return}function zMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[193504]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3328>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3328>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(193512,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3328>>3],121480)|0)|0;g=c[72302]|0;j=e;k=194512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[193504]=1;i=d;return}function AMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[193672]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3336>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3336>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(193680,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3336>>3],121480)|0)|0;g=c[72302]|0;j=e;k=194512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[193672]=1;i=d;return}function BMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[193840]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3344>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3344>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(193848,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3344>>3],121480)|0)|0;g=c[72302]|0;j=e;k=194512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[193840]=1;i=d;return}function CMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[194008]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3352>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3352>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(194016,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3352>>3],121480)|0)|0;g=c[72302]|0;j=e;k=194512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[194008]=1;i=d;return}function DMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[194176]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3360>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3360>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(194184,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3360>>3],121480)|0)|0;g=c[72302]|0;j=e;k=194512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[194176]=1;i=d;return}function EMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[194344]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3368>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3368>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(194352,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3368>>3],121480)|0)|0;g=c[72302]|0;j=e;k=194512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[194344]=1;i=d;return}function FMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[194536]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12400>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12400>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(194544,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12400>>3],121480)|0)|0;g=c[72302]|0;j=e;k=197992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[194536]=1;i=d;return}function GMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[194704]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12408>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12408>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(194712,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12408>>3],121480)|0)|0;g=c[72302]|0;j=e;k=197992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[194704]=1;i=d;return}function HMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[194872]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12416>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12416>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(194880,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12416>>3],121480)|0)|0;g=c[72302]|0;j=e;k=197992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[194872]=1;i=d;return}function IMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[195040]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12424>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12424>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(195048,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12424>>3],121480)|0)|0;g=c[72302]|0;j=e;k=197992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[195040]=1;i=d;return}function JMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[195208]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12432>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12432>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(195216,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12432>>3],121480)|0)|0;g=c[72302]|0;j=e;k=197992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[195208]=1;i=d;return}function KMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[195376]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12440>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12440>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(195384,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12440>>3],121480)|0)|0;g=c[72302]|0;j=e;k=197992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[195376]=1;i=d;return}function LMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[195544]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12448>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12448>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(195552,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12448>>3],121480)|0)|0;g=c[72302]|0;j=e;k=197992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[195544]=1;i=d;return}function MMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[195712]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12456>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12456>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(195720,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12456>>3],121480)|0)|0;g=c[72302]|0;j=e;k=197992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[195712]=1;i=d;return}function NMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[195880]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12464>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12464>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(195888,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12464>>3],121480)|0)|0;g=c[72302]|0;j=e;k=197992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[195880]=1;i=d;return}function OMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[196056]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12472>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12472>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(196064,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12472>>3],121480)|0)|0;g=c[72302]|0;j=e;k=197992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[196056]=1;i=d;return}function PMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[196232]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12480>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12480>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(196240,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12480>>3],121480)|0)|0;g=c[72302]|0;j=e;k=197992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[196232]=1;i=d;return}function QMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[196408]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12488>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12488>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(196416,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12488>>3],121480)|0)|0;g=c[72302]|0;j=e;k=197992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[196408]=1;i=d;return}function RMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[196584]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12496>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12496>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(196592,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12496>>3],121480)|0)|0;g=c[72302]|0;j=e;k=197992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[196584]=1;i=d;return}function SMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[196760]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12504>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12504>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(196768,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12504>>3],121480)|0)|0;g=c[72302]|0;j=e;k=197992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[196760]=1;i=d;return}function TMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[196936]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12512>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12512>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(196944,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12512>>3],121480)|0)|0;g=c[72302]|0;j=e;k=197992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[196936]=1;i=d;return}function UMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[197112]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12520>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12520>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(197120,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12520>>3],121480)|0)|0;g=c[72302]|0;j=e;k=197992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[197112]=1;i=d;return}function VMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[197288]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12528>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12528>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(197296,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12528>>3],121480)|0)|0;g=c[72302]|0;j=e;k=197992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[197288]=1;i=d;return}function WMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[197464]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12536>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12536>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(197472,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12536>>3],121480)|0)|0;g=c[72302]|0;j=e;k=197992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[197464]=1;i=d;return}function XMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[197640]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12544>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12544>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(197648,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12544>>3],121480)|0)|0;g=c[72302]|0;j=e;k=197992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[197640]=1;i=d;return}function YMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[197816]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12552>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12552>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(197824,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12552>>3],121480)|0)|0;g=c[72302]|0;j=e;k=197992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[197816]=1;i=d;return}function ZMa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[198016]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3040>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3040>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(198024,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3040>>3],121480)|0)|0;g=c[72302]|0;j=e;k=201696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[198016]=1;i=d;return}function _Ma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[198200]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3048>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3048>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(198208,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3048>>3],121480)|0)|0;g=c[72302]|0;j=e;k=201696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[198200]=1;i=d;return}function $Ma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[198384]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3056>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3056>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(198392,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3056>>3],121480)|0)|0;g=c[72302]|0;j=e;k=201696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[198384]=1;i=d;return}function aNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[198568]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3064>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3064>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(198576,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3064>>3],121480)|0)|0;g=c[72302]|0;j=e;k=201696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[198568]=1;i=d;return}function bNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[198752]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3072>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3072>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(198760,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3072>>3],121480)|0)|0;g=c[72302]|0;j=e;k=201696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[198752]=1;i=d;return}function cNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[198936]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3080>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3080>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(198944,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3080>>3],121480)|0)|0;g=c[72302]|0;j=e;k=201696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[198936]=1;i=d;return}function dNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[199120]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3088>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3088>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(199128,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3088>>3],121480)|0)|0;g=c[72302]|0;j=e;k=201696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[199120]=1;i=d;return}function eNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[199304]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3096>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3096>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(199312,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3096>>3],121480)|0)|0;g=c[72302]|0;j=e;k=201696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[199304]=1;i=d;return}function fNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[199488]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3104>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3104>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(199496,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3104>>3],121480)|0)|0;g=c[72302]|0;j=e;k=201696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[199488]=1;i=d;return}function gNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[199672]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3112>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3112>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(199680,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3112>>3],121480)|0)|0;g=c[72302]|0;j=e;k=201696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[199672]=1;i=d;return}function hNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[199856]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3120>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3120>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(199864,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3120>>3],121480)|0)|0;g=c[72302]|0;j=e;k=201696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[199856]=1;i=d;return}function iNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[200040]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3128>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3128>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(200048,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3128>>3],121480)|0)|0;g=c[72302]|0;j=e;k=201696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[200040]=1;i=d;return}function jNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[200224]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3136>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3136>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(200232,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3136>>3],121480)|0)|0;g=c[72302]|0;j=e;k=201696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[200224]=1;i=d;return}function kNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[200408]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3144>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3144>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(200416,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3144>>3],121480)|0)|0;g=c[72302]|0;j=e;k=201696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[200408]=1;i=d;return}function lNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[200592]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3152>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3152>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(200600,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3152>>3],121480)|0)|0;g=c[72302]|0;j=e;k=201696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[200592]=1;i=d;return}function mNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[200776]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3160>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3160>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(200784,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3160>>3],121480)|0)|0;g=c[72302]|0;j=e;k=201696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[200776]=1;i=d;return}function nNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[200960]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3168>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3168>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(200968,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3168>>3],121480)|0)|0;g=c[72302]|0;j=e;k=201696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[200960]=1;i=d;return}function oNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[201144]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3176>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3176>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(201152,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3176>>3],121480)|0)|0;g=c[72302]|0;j=e;k=201696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[201144]=1;i=d;return}function pNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[201328]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3184>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3184>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(201336,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3184>>3],121480)|0)|0;g=c[72302]|0;j=e;k=201696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[201328]=1;i=d;return}function qNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[201512]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3192>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3192>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(201520,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3192>>3],121480)|0)|0;g=c[72302]|0;j=e;k=201696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[201512]=1;i=d;return}function rNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[201720]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11024>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11024>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(201728,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11024>>3],121480)|0)|0;g=c[72302]|0;j=e;k=205176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[201720]=1;i=d;return}function sNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[201888]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11032>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11032>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(201896,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11032>>3],121480)|0)|0;g=c[72302]|0;j=e;k=205176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[201888]=1;i=d;return}function tNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[202056]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11040>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11040>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(202064,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11040>>3],121480)|0)|0;g=c[72302]|0;j=e;k=205176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[202056]=1;i=d;return}function uNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[202224]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11048>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11048>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(202232,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11048>>3],121480)|0)|0;g=c[72302]|0;j=e;k=205176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[202224]=1;i=d;return}function vNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[202392]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11056>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11056>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(202400,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11056>>3],121480)|0)|0;g=c[72302]|0;j=e;k=205176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[202392]=1;i=d;return}function wNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[202560]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11064>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11064>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(202568,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11064>>3],121480)|0)|0;g=c[72302]|0;j=e;k=205176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[202560]=1;i=d;return}function xNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[202728]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11072>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11072>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(202736,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11072>>3],121480)|0)|0;g=c[72302]|0;j=e;k=205176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[202728]=1;i=d;return}function yNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[202896]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11080>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11080>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(202904,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11080>>3],121480)|0)|0;g=c[72302]|0;j=e;k=205176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[202896]=1;i=d;return}function zNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[203064]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11088>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11088>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(203072,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11088>>3],121480)|0)|0;g=c[72302]|0;j=e;k=205176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[203064]=1;i=d;return}function ANa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[203240]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11096>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11096>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(203248,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11096>>3],121480)|0)|0;g=c[72302]|0;j=e;k=205176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[203240]=1;i=d;return}function BNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[203416]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11104>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11104>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(203424,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11104>>3],121480)|0)|0;g=c[72302]|0;j=e;k=205176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[203416]=1;i=d;return}function CNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[203592]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11112>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11112>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(203600,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11112>>3],121480)|0)|0;g=c[72302]|0;j=e;k=205176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[203592]=1;i=d;return}function DNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[203768]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11120>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11120>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(203776,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11120>>3],121480)|0)|0;g=c[72302]|0;j=e;k=205176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[203768]=1;i=d;return}function ENa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[203944]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11128>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11128>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(203952,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11128>>3],121480)|0)|0;g=c[72302]|0;j=e;k=205176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[203944]=1;i=d;return}function FNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[204120]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11136>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11136>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(204128,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11136>>3],121480)|0)|0;g=c[72302]|0;j=e;k=205176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[204120]=1;i=d;return}function GNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[204296]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11144>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11144>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(204304,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11144>>3],121480)|0)|0;g=c[72302]|0;j=e;k=205176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[204296]=1;i=d;return}function HNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[204472]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11152>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11152>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(204480,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11152>>3],121480)|0)|0;g=c[72302]|0;j=e;k=205176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[204472]=1;i=d;return}function INa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[204648]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11160>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11160>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(204656,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11160>>3],121480)|0)|0;g=c[72302]|0;j=e;k=205176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[204648]=1;i=d;return}function JNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[204824]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11168>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11168>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(204832,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11168>>3],121480)|0)|0;g=c[72302]|0;j=e;k=205176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[204824]=1;i=d;return}function KNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[205e3]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11176>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11176>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(205008,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11176>>3],121480)|0)|0;g=c[72302]|0;j=e;k=205176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[205e3]=1;i=d;return}function LNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[205200]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2880>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2880>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(205208,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2880>>3],121480)|0)|0;g=c[72302]|0;j=e;k=208880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[205200]=1;i=d;return}function MNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[205384]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2888>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2888>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(205392,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2888>>3],121480)|0)|0;g=c[72302]|0;j=e;k=208880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[205384]=1;i=d;return}function NNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[205568]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2896>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2896>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(205576,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2896>>3],121480)|0)|0;g=c[72302]|0;j=e;k=208880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[205568]=1;i=d;return}function ONa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[205752]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2904>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2904>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(205760,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2904>>3],121480)|0)|0;g=c[72302]|0;j=e;k=208880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[205752]=1;i=d;return}function PNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[205936]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2912>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2912>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(205944,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2912>>3],121480)|0)|0;g=c[72302]|0;j=e;k=208880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[205936]=1;i=d;return}function QNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[206120]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2920>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2920>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(206128,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2920>>3],121480)|0)|0;g=c[72302]|0;j=e;k=208880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[206120]=1;i=d;return}function RNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[206304]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2928>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2928>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(206312,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2928>>3],121480)|0)|0;g=c[72302]|0;j=e;k=208880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[206304]=1;i=d;return}function SNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[206488]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2936>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2936>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(206496,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2936>>3],121480)|0)|0;g=c[72302]|0;j=e;k=208880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[206488]=1;i=d;return}function TNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[206672]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2944>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2944>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(206680,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2944>>3],121480)|0)|0;g=c[72302]|0;j=e;k=208880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[206672]=1;i=d;return}function UNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[206856]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2952>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2952>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(206864,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2952>>3],121480)|0)|0;g=c[72302]|0;j=e;k=208880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[206856]=1;i=d;return}function VNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[207040]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2960>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2960>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(207048,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2960>>3],121480)|0)|0;g=c[72302]|0;j=e;k=208880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[207040]=1;i=d;return}function WNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[207224]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2968>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2968>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(207232,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2968>>3],121480)|0)|0;g=c[72302]|0;j=e;k=208880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[207224]=1;i=d;return}function XNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[207408]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2976>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2976>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(207416,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2976>>3],121480)|0)|0;g=c[72302]|0;j=e;k=208880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[207408]=1;i=d;return}function YNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[207592]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2984>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2984>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(207600,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2984>>3],121480)|0)|0;g=c[72302]|0;j=e;k=208880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[207592]=1;i=d;return}function ZNa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[207776]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2992>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2992>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(207784,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2992>>3],121480)|0)|0;g=c[72302]|0;j=e;k=208880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[207776]=1;i=d;return}function _Na(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[207960]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3e3>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3e3>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(207968,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3e3>>3],121480)|0)|0;g=c[72302]|0;j=e;k=208880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[207960]=1;i=d;return}function $Na(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[208144]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3008>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3008>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(208152,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3008>>3],121480)|0)|0;g=c[72302]|0;j=e;k=208880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[208144]=1;i=d;return}function aOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[208328]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3016>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3016>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(208336,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3016>>3],121480)|0)|0;g=c[72302]|0;j=e;k=208880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[208328]=1;i=d;return}function bOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[208512]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3024>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3024>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(208520,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3024>>3],121480)|0)|0;g=c[72302]|0;j=e;k=208880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[208512]=1;i=d;return}function cOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[208696]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3032>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3032>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(208704,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3032>>3],121480)|0)|0;g=c[72302]|0;j=e;k=208880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[208696]=1;i=d;return}function dOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[208904]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+312>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+312>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(208912,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+312>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[208904]=1;i=d;return}function eOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[209064]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+304>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+304>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(209072,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+304>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[209064]=1;i=d;return}function fOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[209216]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2392>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2392>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(209224,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2392>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[209216]=1;i=d;return}function gOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[209384]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2384>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2384>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(209392,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2384>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[209384]=1;i=d;return}function hOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[209560]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+296>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+296>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(209568,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+296>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[209560]=1;i=d;return}function iOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[209720]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+288>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+288>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(209728,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+288>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[209720]=1;i=d;return}function jOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[209872]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2360>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2360>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(209880,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2360>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[209872]=1;i=d;return}function kOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[210040]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2352>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2352>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(210048,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2352>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[210040]=1;i=d;return}function lOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[210216]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+280>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+280>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(210224,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+280>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[210216]=1;i=d;return}function mOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[210376]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+272>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+272>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(210384,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+272>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[210376]=1;i=d;return}function nOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[210528]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2328>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2328>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(210536,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2328>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[210528]=1;i=d;return}function oOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[210696]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2320>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2320>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(210704,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2320>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[210696]=1;i=d;return}function pOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[210872]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+264>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+264>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(210880,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+264>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[210872]=1;i=d;return}function qOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[211032]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+256>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+256>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(211040,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+256>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[211032]=1;i=d;return}function rOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[211184]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2296>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2296>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(211192,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2296>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[211184]=1;i=d;return}function sOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[211352]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2288>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2288>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(211360,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2288>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[211352]=1;i=d;return}function tOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[211528]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+248>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+248>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(211536,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+248>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[211528]=1;i=d;return}function uOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[211688]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+240>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+240>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(211696,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+240>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[211688]=1;i=d;return}function vOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[211840]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2264>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2264>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(211848,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2264>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[211840]=1;i=d;return}function wOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[212008]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2256>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2256>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(212016,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2256>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[212008]=1;i=d;return}



function YHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[152688]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10928>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10928>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(152696,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10928>>3],121480)|0)|0;g=c[72302]|0;j=e;k=205176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[152688]=1;i=d;return}function ZHa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[152864]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10936>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10936>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(152872,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10936>>3],121480)|0)|0;g=c[72302]|0;j=e;k=205176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[152864]=1;i=d;return}function _Ha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[153040]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10944>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10944>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(153048,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10944>>3],121480)|0)|0;g=c[72302]|0;j=e;k=205176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[153040]=1;i=d;return}function $Ha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[153216]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10952>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10952>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(153224,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10952>>3],121480)|0)|0;g=c[72302]|0;j=e;k=205176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[153216]=1;i=d;return}function aIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[153392]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10960>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10960>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(153400,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10960>>3],121480)|0)|0;g=c[72302]|0;j=e;k=205176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[153392]=1;i=d;return}function bIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[153568]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10968>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10968>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(153576,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10968>>3],121480)|0)|0;g=c[72302]|0;j=e;k=205176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[153568]=1;i=d;return}function cIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[153744]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10976>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10976>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(153752,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10976>>3],121480)|0)|0;g=c[72302]|0;j=e;k=205176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[153744]=1;i=d;return}function dIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[153920]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10984>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10984>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(153928,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10984>>3],121480)|0)|0;g=c[72302]|0;j=e;k=205176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[153920]=1;i=d;return}function eIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[154096]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10992>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10992>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(154104,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+10992>>3],121480)|0)|0;g=c[72302]|0;j=e;k=205176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[154096]=1;i=d;return}function fIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[154272]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11e3>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11e3>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(154280,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11e3>>3],121480)|0)|0;g=c[72302]|0;j=e;k=205176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[154272]=1;i=d;return}function gIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[154448]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7520>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7520>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(154456,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7520>>3],121480)|0)|0;g=c[72302]|0;j=e;k=208880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[154448]=1;i=d;return}function hIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[154632]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7528>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7528>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(154640,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7528>>3],121480)|0)|0;g=c[72302]|0;j=e;k=208880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[154632]=1;i=d;return}function iIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[154816]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7536>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7536>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(154824,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7536>>3],121480)|0)|0;g=c[72302]|0;j=e;k=208880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[154816]=1;i=d;return}function jIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[155e3]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7544>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7544>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(155008,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7544>>3],121480)|0)|0;g=c[72302]|0;j=e;k=208880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[155e3]=1;i=d;return}function kIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[155184]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7552>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7552>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(155192,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7552>>3],121480)|0)|0;g=c[72302]|0;j=e;k=208880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[155184]=1;i=d;return}function lIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[155368]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7560>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7560>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(155376,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7560>>3],121480)|0)|0;g=c[72302]|0;j=e;k=208880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[155368]=1;i=d;return}function mIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[155552]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7568>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7568>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(155560,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7568>>3],121480)|0)|0;g=c[72302]|0;j=e;k=208880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[155552]=1;i=d;return}function nIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[155736]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7576>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7576>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(155744,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7576>>3],121480)|0)|0;g=c[72302]|0;j=e;k=208880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[155736]=1;i=d;return}function oIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[155920]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7584>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7584>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(155928,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7584>>3],121480)|0)|0;g=c[72302]|0;j=e;k=208880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[155920]=1;i=d;return}function pIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[156104]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7592>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7592>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(156112,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7592>>3],121480)|0)|0;g=c[72302]|0;j=e;k=208880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[156104]=1;i=d;return}function qIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[156288]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7600>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7600>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(156296,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7600>>3],121480)|0)|0;g=c[72302]|0;j=e;k=208880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[156288]=1;i=d;return}function rIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[156472]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7608>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7608>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(156480,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7608>>3],121480)|0)|0;g=c[72302]|0;j=e;k=208880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[156472]=1;i=d;return}function sIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[156656]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7616>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7616>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(156664,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7616>>3],121480)|0)|0;g=c[72302]|0;j=e;k=208880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[156656]=1;i=d;return}function tIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[156840]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7624>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7624>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(156848,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7624>>3],121480)|0)|0;g=c[72302]|0;j=e;k=208880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[156840]=1;i=d;return}function uIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[157024]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7632>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7632>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(157032,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7632>>3],121480)|0)|0;g=c[72302]|0;j=e;k=208880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[157024]=1;i=d;return}function vIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[157208]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7640>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7640>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(157216,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7640>>3],121480)|0)|0;g=c[72302]|0;j=e;k=208880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[157208]=1;i=d;return}function wIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[157392]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7648>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7648>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(157400,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7648>>3],121480)|0)|0;g=c[72302]|0;j=e;k=208880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[157392]=1;i=d;return}function xIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[157576]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7656>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7656>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(157584,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7656>>3],121480)|0)|0;g=c[72302]|0;j=e;k=208880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[157576]=1;i=d;return}function yIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[157760]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7664>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7664>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(157768,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7664>>3],121480)|0)|0;g=c[72302]|0;j=e;k=208880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[157760]=1;i=d;return}function zIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[157944]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7672>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7672>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(157952,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7672>>3],121480)|0)|0;g=c[72302]|0;j=e;k=208880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[157944]=1;i=d;return}function AIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[158128]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+632>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+632>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(158136,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+632>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[158128]=1;i=d;return}function BIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[158360]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+624>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+624>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(158368,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+624>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[158360]=1;i=d;return}function CIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[158512]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7032>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7032>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(158520,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7032>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[158512]=1;i=d;return}function DIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[158680]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7024>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7024>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(158688,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7024>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[158680]=1;i=d;return}function EIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[158856]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+616>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+616>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(158864,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+616>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[158856]=1;i=d;return}function FIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[159016]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+608>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+608>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(159024,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+608>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[159016]=1;i=d;return}function GIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[159168]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7e3>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7e3>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(159176,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7e3>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[159168]=1;i=d;return}function HIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[159336]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6992>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6992>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(159344,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6992>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[159336]=1;i=d;return}function IIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[159512]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+600>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+600>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(159520,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+600>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[159512]=1;i=d;return}function JIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[159672]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+592>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+592>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(159680,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+592>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[159672]=1;i=d;return}function KIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[159824]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6968>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6968>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(159832,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6968>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[159824]=1;i=d;return}function LIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[159992]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6960>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6960>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(16e4,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6960>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[159992]=1;i=d;return}function MIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[160168]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+584>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+584>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(160176,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+584>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[160168]=1;i=d;return}function NIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[160328]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+576>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+576>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(160336,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+576>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[160328]=1;i=d;return}function OIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[160480]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6936>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6936>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(160488,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6936>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[160480]=1;i=d;return}function PIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[160648]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6928>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6928>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(160656,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6928>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[160648]=1;i=d;return}function QIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[160824]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+568>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+568>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(160832,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+568>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[160824]=1;i=d;return}function RIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[160984]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+560>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+560>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(160992,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+560>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[160984]=1;i=d;return}function SIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[161136]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6904>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6904>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(161144,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6904>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[161136]=1;i=d;return}function TIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[161304]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6896>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6896>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(161312,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6896>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[161304]=1;i=d;return}function UIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[161480]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+552>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+552>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(161488,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+552>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[161480]=1;i=d;return}function VIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[161640]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+544>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+544>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(161648,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+544>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[161640]=1;i=d;return}function WIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[161792]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6872>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6872>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(161800,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6872>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[161792]=1;i=d;return}function XIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[161960]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6864>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6864>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(161968,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6864>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[161960]=1;i=d;return}function YIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[162136]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+536>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+536>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(162144,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+536>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[162136]=1;i=d;return}function ZIa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[162296]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+528>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+528>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(162304,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+528>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[162296]=1;i=d;return}function _Ia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[162448]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6840>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6840>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(162456,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6840>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[162448]=1;i=d;return}function $Ia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[162616]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6832>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6832>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(162624,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6832>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[162616]=1;i=d;return}function aJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[162792]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+520>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+520>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(162800,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+520>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[162792]=1;i=d;return}function bJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[162952]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+512>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+512>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(162960,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+512>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[162952]=1;i=d;return}function cJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[163104]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6808>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6808>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(163112,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6808>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[163104]=1;i=d;return}function dJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[163272]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6800>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6800>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(163280,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6800>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[163272]=1;i=d;return}function eJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[163448]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+504>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+504>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(163456,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+504>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[163448]=1;i=d;return}function fJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[163608]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+496>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+496>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(163616,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+496>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[163608]=1;i=d;return}function gJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[163760]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6776>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6776>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(163768,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6776>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[163760]=1;i=d;return}function hJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[163928]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6768>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6768>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(163936,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6768>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[163928]=1;i=d;return}function iJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[164104]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+488>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+488>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(164112,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+488>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[164104]=1;i=d;return}function jJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[164264]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+480>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+480>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(164272,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+480>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[164264]=1;i=d;return}function kJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[164424]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6744>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6744>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(164432,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6744>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[164424]=1;i=d;return}function lJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[164592]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6736>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6736>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(164600,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6736>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[164592]=1;i=d;return}function mJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[164768]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+472>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+472>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(164776,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+472>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[164768]=1;i=d;return}function nJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[164928]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+464>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+464>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(164936,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+464>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[164928]=1;i=d;return}function oJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[165088]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6712>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6712>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(165096,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6712>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[165088]=1;i=d;return}function pJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[165256]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6704>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6704>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(165264,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6704>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[165256]=1;i=d;return}function qJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[165432]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+456>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+456>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(165440,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+456>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[165432]=1;i=d;return}function rJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[165592]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+448>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+448>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(165600,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+448>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[165592]=1;i=d;return}function sJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[165752]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6680>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6680>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(165760,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6680>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[165752]=1;i=d;return}function tJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[165920]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6672>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6672>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(165928,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6672>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[165920]=1;i=d;return}function uJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[166096]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+440>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+440>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(166104,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+440>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[166096]=1;i=d;return}function vJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[166256]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+432>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+432>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(166264,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+432>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[166256]=1;i=d;return}function wJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[166416]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6648>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6648>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(166424,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6648>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[166416]=1;i=d;return}function xJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[166584]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6640>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6640>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(166592,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6640>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[166584]=1;i=d;return}function yJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[166760]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+424>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+424>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(166768,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+424>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[166760]=1;i=d;return}function zJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[166920]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+416>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+416>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(166928,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+416>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[166920]=1;i=d;return}function AJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[167080]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6616>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6616>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(167088,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6616>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[167080]=1;i=d;return}function BJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[167248]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6608>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6608>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(167256,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6608>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[167248]=1;i=d;return}function CJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[167424]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+408>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+408>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(167432,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+408>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[167424]=1;i=d;return}function DJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[167584]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+400>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+400>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(167592,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+400>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[167584]=1;i=d;return}function EJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[167744]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6584>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6584>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(167752,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6584>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[167744]=1;i=d;return}function FJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[167912]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6576>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6576>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(167920,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6576>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[167912]=1;i=d;return}function GJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[168088]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+392>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+392>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(168096,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+392>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[168088]=1;i=d;return}function HJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[168248]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+384>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+384>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(168256,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+384>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[168248]=1;i=d;return}function IJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[168408]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6552>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6552>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(168416,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6552>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[168408]=1;i=d;return}function JJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[168576]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6544>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6544>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(168584,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6544>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[168576]=1;i=d;return}function KJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[168752]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+376>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+376>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(168760,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+376>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[168752]=1;i=d;return}function LJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[168912]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+368>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+368>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(168920,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+368>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[168912]=1;i=d;return}function MJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[169072]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6520>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6520>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(169080,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6520>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[169072]=1;i=d;return}function NJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[169240]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6512>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6512>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(169248,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6512>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[169240]=1;i=d;return}function OJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[169416]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+360>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+360>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(169424,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+360>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[169416]=1;i=d;return}function PJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[169576]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+352>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+352>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(169584,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+352>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[169576]=1;i=d;return}function QJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[169736]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6488>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6488>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(169744,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6488>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[169736]=1;i=d;return}function RJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[169904]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6480>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6480>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(169912,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6480>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[169904]=1;i=d;return}function SJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[170080]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+344>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+344>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(170088,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+344>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[170080]=1;i=d;return}function TJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[170240]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+336>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+336>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(170248,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+336>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[170240]=1;i=d;return}function UJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[170400]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6456>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6456>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(170408,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6456>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[170400]=1;i=d;return}function VJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[170568]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6448>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6448>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(170576,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6448>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[170568]=1;i=d;return}function WJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[170744]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+328>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+328>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(170752,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+328>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[170744]=1;i=d;return}function XJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[170904]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+320>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+320>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(170912,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+320>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[170904]=1;i=d;return}function YJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[171064]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6424>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6424>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(171072,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6424>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[171064]=1;i=d;return}function ZJa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[171232]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6416>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6416>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(171240,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6416>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[171232]=1;i=d;return}function _Ja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[171408]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5600>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5600>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(171416,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5600>>3],121480)|0)|0;g=c[72302]|0;j=e;k=175016;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[171408]=1;i=d;return}function $Ja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[171584]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5608>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5608>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(171592,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5608>>3],121480)|0)|0;g=c[72302]|0;j=e;k=175016;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[171584]=1;i=d;return}function aKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[171760]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5616>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5616>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(171768,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5616>>3],121480)|0)|0;g=c[72302]|0;j=e;k=175016;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[171760]=1;i=d;return}function bKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[171936]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5624>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5624>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(171944,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5624>>3],121480)|0)|0;g=c[72302]|0;j=e;k=175016;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[171936]=1;i=d;return}function cKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[172112]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5632>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5632>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(172120,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5632>>3],121480)|0)|0;g=c[72302]|0;j=e;k=175016;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[172112]=1;i=d;return}function dKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[172288]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5640>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5640>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(172296,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5640>>3],121480)|0)|0;g=c[72302]|0;j=e;k=175016;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[172288]=1;i=d;return}function eKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[172464]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5648>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5648>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(172472,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5648>>3],121480)|0)|0;g=c[72302]|0;j=e;k=175016;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[172464]=1;i=d;return}function fKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[172640]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5656>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5656>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(172648,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5656>>3],121480)|0)|0;g=c[72302]|0;j=e;k=175016;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[172640]=1;i=d;return}function gKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[172816]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5664>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5664>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(172824,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5664>>3],121480)|0)|0;g=c[72302]|0;j=e;k=175016;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[172816]=1;i=d;return}function hKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[172992]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5672>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5672>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(173e3,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5672>>3],121480)|0)|0;g=c[72302]|0;j=e;k=175016;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[172992]=1;i=d;return}function iKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[173176]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5680>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5680>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(173184,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5680>>3],121480)|0)|0;g=c[72302]|0;j=e;k=175016;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[173176]=1;i=d;return}function jKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[173360]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5688>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5688>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(173368,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5688>>3],121480)|0)|0;g=c[72302]|0;j=e;k=175016;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[173360]=1;i=d;return}function kKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[173544]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5696>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5696>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(173552,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5696>>3],121480)|0)|0;g=c[72302]|0;j=e;k=175016;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[173544]=1;i=d;return}function lKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[173728]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5704>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5704>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(173736,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5704>>3],121480)|0)|0;g=c[72302]|0;j=e;k=175016;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[173728]=1;i=d;return}function mKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[173912]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5712>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5712>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(173920,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5712>>3],121480)|0)|0;g=c[72302]|0;j=e;k=175016;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[173912]=1;i=d;return}function nKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[174096]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5720>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5720>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(174104,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5720>>3],121480)|0)|0;g=c[72302]|0;j=e;k=175016;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[174096]=1;i=d;return}function oKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[174280]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5728>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5728>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(174288,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5728>>3],121480)|0)|0;g=c[72302]|0;j=e;k=175016;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[174280]=1;i=d;return}function pKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[174464]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5736>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5736>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(174472,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5736>>3],121480)|0)|0;g=c[72302]|0;j=e;k=175016;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[174464]=1;i=d;return}function qKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[174648]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5744>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5744>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(174656,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5744>>3],121480)|0)|0;g=c[72302]|0;j=e;k=175016;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[174648]=1;i=d;return}function rKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[174832]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5752>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5752>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(174840,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5752>>3],121480)|0)|0;g=c[72302]|0;j=e;k=175016;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[174832]=1;i=d;return}function sKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[175040]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5440>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5440>>3],500.0)|0)<<24>>24==0)){i=d;return}b=RXa(175048,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5440>>3],121480)|0)|0;g=c[72302]|0;j=e;k=178808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[175040]=1;i=d;return}function tKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[175224]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5448>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5448>>3],500.0)|0)<<24>>24==0)){i=d;return}b=RXa(175232,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5448>>3],121480)|0)|0;g=c[72302]|0;j=e;k=178808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[175224]=1;i=d;return}function uKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[175408]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5456>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5456>>3],500.0)|0)<<24>>24==0)){i=d;return}b=RXa(175416,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5456>>3],121480)|0)|0;g=c[72302]|0;j=e;k=178808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[175408]=1;i=d;return}function vKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[175592]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5464>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5464>>3],500.0)|0)<<24>>24==0)){i=d;return}b=RXa(175600,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5464>>3],121480)|0)|0;g=c[72302]|0;j=e;k=178808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[175592]=1;i=d;return}function wKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[175776]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5472>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5472>>3],500.0)|0)<<24>>24==0)){i=d;return}b=RXa(175784,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5472>>3],121480)|0)|0;g=c[72302]|0;j=e;k=178808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[175776]=1;i=d;return}function xKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[175960]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5480>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5480>>3],500.0)|0)<<24>>24==0)){i=d;return}b=RXa(175968,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5480>>3],121480)|0)|0;g=c[72302]|0;j=e;k=178808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[175960]=1;i=d;return}function yKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[176144]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5488>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5488>>3],500.0)|0)<<24>>24==0)){i=d;return}b=RXa(176152,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5488>>3],121480)|0)|0;g=c[72302]|0;j=e;k=178808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[176144]=1;i=d;return}function zKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[176328]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5496>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5496>>3],500.0)|0)<<24>>24==0)){i=d;return}b=RXa(176336,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5496>>3],121480)|0)|0;g=c[72302]|0;j=e;k=178808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[176328]=1;i=d;return}function AKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[176512]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5504>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5504>>3],500.0)|0)<<24>>24==0)){i=d;return}b=RXa(176520,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5504>>3],121480)|0)|0;g=c[72302]|0;j=e;k=178808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[176512]=1;i=d;return}function BKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[176696]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5512>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5512>>3],500.0)|0)<<24>>24==0)){i=d;return}b=RXa(176704,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5512>>3],121480)|0)|0;g=c[72302]|0;j=e;k=178808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[176696]=1;i=d;return}function CKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[176888]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5520>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5520>>3],500.0)|0)<<24>>24==0)){i=d;return}b=RXa(176896,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5520>>3],121480)|0)|0;g=c[72302]|0;j=e;k=178808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[176888]=1;i=d;return}function DKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[177080]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5528>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5528>>3],500.0)|0)<<24>>24==0)){i=d;return}b=RXa(177088,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5528>>3],121480)|0)|0;g=c[72302]|0;j=e;k=178808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[177080]=1;i=d;return}function EKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[177272]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5536>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5536>>3],500.0)|0)<<24>>24==0)){i=d;return}b=RXa(177280,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5536>>3],121480)|0)|0;g=c[72302]|0;j=e;k=178808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[177272]=1;i=d;return}function FKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[177464]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5544>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5544>>3],500.0)|0)<<24>>24==0)){i=d;return}b=RXa(177472,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5544>>3],121480)|0)|0;g=c[72302]|0;j=e;k=178808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[177464]=1;i=d;return}function GKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[177656]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5552>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5552>>3],500.0)|0)<<24>>24==0)){i=d;return}b=RXa(177664,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5552>>3],121480)|0)|0;g=c[72302]|0;j=e;k=178808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[177656]=1;i=d;return}function HKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[177848]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5560>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5560>>3],500.0)|0)<<24>>24==0)){i=d;return}b=RXa(177856,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5560>>3],121480)|0)|0;g=c[72302]|0;j=e;k=178808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[177848]=1;i=d;return}function IKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[178040]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5568>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5568>>3],500.0)|0)<<24>>24==0)){i=d;return}b=RXa(178048,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5568>>3],121480)|0)|0;g=c[72302]|0;j=e;k=178808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[178040]=1;i=d;return}function JKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[178232]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5576>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5576>>3],500.0)|0)<<24>>24==0)){i=d;return}b=RXa(178240,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5576>>3],121480)|0)|0;g=c[72302]|0;j=e;k=178808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[178232]=1;i=d;return}function KKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[178424]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5584>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5584>>3],500.0)|0)<<24>>24==0)){i=d;return}b=RXa(178432,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5584>>3],121480)|0)|0;g=c[72302]|0;j=e;k=178808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[178424]=1;i=d;return}function LKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[178616]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5592>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5592>>3],500.0)|0)<<24>>24==0)){i=d;return}b=RXa(178624,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5592>>3],121480)|0)|0;g=c[72302]|0;j=e;k=178808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[178616]=1;i=d;return}function MKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[178832]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14560>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14560>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(178840,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14560>>3],121480)|0)|0;g=c[72302]|0;j=e;k=178976;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[178832]=1;i=d;return}function NKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[179e3]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14552>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14552>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(179008,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14552>>3],121480)|0)|0;g=c[72302]|0;j=e;k=179144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[179e3]=1;i=d;return}function OKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[179168]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4632>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4632>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(179176,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4632>>3],121480)|0)|0;g=c[72302]|0;j=e;k=182336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[179168]=1;i=d;return}function PKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[179344]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4624>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4624>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(179352,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4624>>3],121480)|0)|0;g=c[72302]|0;j=e;k=182336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[179344]=1;i=d;return}function QKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[179520]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4616>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4616>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(179528,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4616>>3],121480)|0)|0;g=c[72302]|0;j=e;k=182336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[179520]=1;i=d;return}function RKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[179696]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4608>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4608>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(179704,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4608>>3],121480)|0)|0;g=c[72302]|0;j=e;k=182336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[179696]=1;i=d;return}function SKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[179872]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4600>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4600>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(179880,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4600>>3],121480)|0)|0;g=c[72302]|0;j=e;k=182336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[179872]=1;i=d;return}function TKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[180048]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4592>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4592>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(180056,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4592>>3],121480)|0)|0;g=c[72302]|0;j=e;k=182336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[180048]=1;i=d;return}function UKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[180224]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4584>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4584>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(180232,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4584>>3],121480)|0)|0;g=c[72302]|0;j=e;k=182336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[180224]=1;i=d;return}function VKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[180400]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4576>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4576>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(180408,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4576>>3],121480)|0)|0;g=c[72302]|0;j=e;k=182336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[180400]=1;i=d;return}function WKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[180576]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4568>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4568>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(180584,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4568>>3],121480)|0)|0;g=c[72302]|0;j=e;k=182336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[180576]=1;i=d;return}function XKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[180752]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4560>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4560>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(180760,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4560>>3],121480)|0)|0;g=c[72302]|0;j=e;k=182336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[180752]=1;i=d;return}function YKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[180928]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4552>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4552>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(180936,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4552>>3],121480)|0)|0;g=c[72302]|0;j=e;k=182336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[180928]=1;i=d;return}function ZKa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[181104]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4544>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4544>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(181112,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4544>>3],121480)|0)|0;g=c[72302]|0;j=e;k=182336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[181104]=1;i=d;return}function _Ka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[181280]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4536>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4536>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(181288,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4536>>3],121480)|0)|0;g=c[72302]|0;j=e;k=182336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[181280]=1;i=d;return}function $Ka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[181456]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4528>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4528>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(181464,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4528>>3],121480)|0)|0;g=c[72302]|0;j=e;k=182336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[181456]=1;i=d;return}function aLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[181632]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4520>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4520>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(181640,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4520>>3],121480)|0)|0;g=c[72302]|0;j=e;k=182336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[181632]=1;i=d;return}function bLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[181808]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4512>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4512>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(181816,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4512>>3],121480)|0)|0;g=c[72302]|0;j=e;k=182336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[181808]=1;i=d;return}function cLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[181984]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4504>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4504>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(181992,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4504>>3],121480)|0)|0;g=c[72302]|0;j=e;k=182336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[181984]=1;i=d;return}function dLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[182160]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4496>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4496>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(182168,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4496>>3],121480)|0)|0;g=c[72302]|0;j=e;k=182336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[182160]=1;i=d;return}function eLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[182360]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4176>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(182368,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4176>>3],121480)|0)|0;g=c[72302]|0;j=e;k=184440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[182360]=1;i=d;return}function fLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[182464]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4184>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(182472,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4184>>3],121480)|0)|0;g=c[72302]|0;j=e;k=184440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[182464]=1;i=d;return}function gLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[182568]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4192>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(182576,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4192>>3],121480)|0)|0;g=c[72302]|0;j=e;k=184440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[182568]=1;i=d;return}function hLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[182672]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4200>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(182680,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4200>>3],121480)|0)|0;g=c[72302]|0;j=e;k=184440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[182672]=1;i=d;return}function iLa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[182776]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4208>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(182784,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4208>>3],121480)|0)|0;g=c[72302]|0;j=e;k=184440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[182776]=1;i=d;return}



function dpb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0;d=i;i=i+424|0;e=d;f=d+8|0;g=d+72|0;h=d+328|0;j=d+336|0;k=d+384|0;l=d+392|0;m=c[b+4>>2]|0;n=m+12|0;o=c[n>>2]|0;if((c[b+40>>2]|0)==0){p=b+20|0;kpb(m,c[p>>2]|0)|0;kpb(m,2)|0;c[p>>2]=(c[p>>2]|0)+1}p=kpb(m,0)|0;q=b+12|0;r=b+16|0;c[r>>2]=c[q>>2];s=c[n>>2]|0;t=(p|0)==0;a:do{if((s|0)>(o|0)&t){u=m+16|0;v=b+36|0;w=b;x=b+24|0;y=b+20|0;z=g;A=f;B=b+28|0;C=l;D=k;E=k+1|0;F=j;G=b;H=j+12|0;I=j+40|0;J=j+24|0;K=j+8|0;L=s;M=0;N=0;b:while(1){O=L+ -1|0;c[n>>2]=O;P=c[u>>2]|0;c:do{switch(c[P+(O<<2)>>2]|0){case 5:{Q=c[q>>2]|0;R=a[Q]|0;if(R<<24>>24==0){S=M;T=N;U=0;break c}V=c[v>>2]&1;W=(V|0)!=0;if(W&R<<24>>24==124){S=M;T=N;U=0;break c}do{if(!(W&R<<24>>24==41&(M|0)>0)){if((V|0)==0&R<<24>>24==92){if((a[Q+1|0]|0)==41){break}}X=kpb(m,5)|0;if((X|0)!=0){Y=M;Z=X;_=6;break b}X=kpb(m,N)|0;if((X|0)!=0){Y=M;Z=X;_=6;break b}X=kpb(m,6)|0;if((X|0)!=0){Y=M;Z=X;_=6;break b}S=M;T=N;U=kpb(m,4)|0;break c}}while(0);R=(V|M|0)==0?8:0;W=M+ -1|0;if((V|0)!=0){S=W;T=N;U=R;break c}c[q>>2]=Q+2;S=W;T=N;U=R;break};case 9:{R=c[q>>2]|0;W=a[R]|0;switch(W<<24>>24|0){case 123:{X=c[v>>2]|0;if((X&1|0)==0){S=M;T=N;U=0;break c}else{$=X;aa=R}break};case 63:case 43:{if((c[v>>2]&1|0)==0){S=M;T=N;U=0;break c}else{_=41}break};case 42:{_=41;break};case 92:{X=c[v>>2]|0;if((X&1|0)!=0){S=M;T=N;U=0;break c}ba=R+1|0;if((a[ba]|0)!=123){S=M;T=N;U=0;break c}c[q>>2]=ba;$=X;aa=ba;break};default:{S=M;T=N;U=0;break c}}if((_|0)==41){_=0;c[q>>2]=R+1;R=c[w>>2]|0;ba=upb(R,0,0,1,32)|0;if((ba|0)==0){ca=12;_=294;break b}X=upb(R,0,0,1,16)|0;c[ba+4>>2]=X;if((X|0)==0){ca=12;_=294;break b}c[ba>>2]=2;c[ba+8>>2]=-1;c[ba+12>>2]=-1;c[X>>2]=N;c[X+4>>2]=W<<24>>24==43;c[X+8>>2]=W<<24>>24==63?1:-1;W=X+12|0;a[W]=a[W]&-2;c[ba+16>>2]=c[N+16>>2];S=M;T=ba;U=kpb(m,9)|0;break c}ba=aa+1|0;c[q>>2]=ba;W=a[ba]|0;if((W+ -48<<24>>24&255)<10){X=W<<24>>24;if((X+ -48|0)>>>0<10){da=X;ea=-1;fa=ba}else{ca=10;_=294;break b}while(1){X=((ea|0)<0?-48:(ea*10|0)+ -48|0)+da|0;R=fa+1|0;ga=a[R]|0;ha=ga<<24>>24;if((ha+ -48|0)>>>0<10){fa=R;ea=X;da=ha}else{ia=ga;ja=X;ka=R;break}}}else{ia=W;ja=-1;ka=ba}do{if(ia<<24>>24==44){Q=ka+1|0;V=a[Q]|0;R=V<<24>>24;if((R+ -48|0)>>>0<10){la=R;ma=-1;na=Q}else{oa=V;pa=-1;qa=Q;break}while(1){Q=((ma|0)<0?-48:(ma*10|0)+ -48|0)+la|0;V=na+1|0;R=a[V]|0;X=R<<24>>24;if((X+ -48|0)>>>0<10){na=V;ma=Q;la=X}else{ra=R;sa=Q;ta=V;_=54;break}}}else{ra=ia;sa=ja;ta=ka;_=54}}while(0);do{if((_|0)==54){_=0;if(!((sa|0)>-1)){oa=ra;pa=sa;qa=ta;break}if((ja|0)>(sa|0)|(sa|0)>255){ca=10;_=294;break b}else{oa=ra;pa=sa;qa=ta}}}while(0);if(oa<<24>>24==0){ca=9;_=294;break b}if((qa|0)==(ba|0)){ca=10;_=294;break b}if(($&1|0)==0){if(!(oa<<24>>24==92)){ca=10;_=294;break b}if((a[qa+1|0]|0)!=125){ca=10;_=294;break b}ua=qa+2|0}else{if(!(oa<<24>>24==125)){ca=10;_=294;break b}ua=qa+1|0}if((pa|ja|0)==0){W=c[w>>2]|0;V=upb(W,0,0,1,32)|0;if((V|0)==0){ca=12;_=294;break b}Q=upb(W,0,0,1,20)|0;c[V+4>>2]=Q;if((Q|0)==0){ca=12;_=294;break b}c[V>>2]=0;c[V+8>>2]=-1;c[V+12>>2]=-1;c[Q>>2]=-1;c[Q+4>>2]=-1;c[Q+8>>2]=-1;va=V}else{V=(pa&ja|0)<0;Q=c[w>>2]|0;W=upb(Q,0,0,1,32)|0;if((W|0)==0){ca=12;_=294;break b}R=upb(Q,0,0,1,16)|0;c[W+4>>2]=R;if((R|0)==0){ca=12;_=294;break b}c[W>>2]=2;c[W+8>>2]=-1;c[W+12>>2]=-1;c[R>>2]=N;c[R+4>>2]=V?1:ja;c[R+8>>2]=V?1:pa;V=R+12|0;a[V]=a[V]&-2;c[W+16>>2]=c[N+16>>2];va=W}c[q>>2]=ua;S=M;T=va;U=kpb(m,9)|0;break};case 3:{W=kpb(m,5)|0;if((W|0)!=0){Y=M;Z=W;_=6;break b}S=M;T=N;U=kpb(m,4)|0;break};case 0:{if((c[v>>2]&1|0)!=0){W=kpb(m,7)|0;if((W|0)!=0){Y=M;Z=W;_=6;break b}}S=M;T=N;U=kpb(m,3)|0;break};case 7:{W=c[q>>2]|0;V=a[W]|0;if((V|0)==41){c[q>>2]=W+1;S=M;T=N;U=0;break c}else if((V|0)!=124){S=M;T=N;U=0;break c}V=kpb(m,7)|0;if((V|0)!=0){Y=M;Z=V;_=6;break b}V=kpb(m,N)|0;if((V|0)!=0){Y=M;Z=V;_=6;break b}V=kpb(m,8)|0;if((V|0)!=0){Y=M;Z=V;_=6;break b}V=kpb(m,3)|0;if((V|0)!=0){Y=M;Z=V;_=6;break b}c[q>>2]=(c[q>>2]|0)+1;S=M;T=N;U=0;break};case 6:{V=L+ -2|0;c[n>>2]=V;W=c[P+(V<<2)>>2]|0;V=c[w>>2]|0;R=upb(V,0,0,1,32)|0;if((R|0)==0){ca=12;_=294;break b}Q=upb(V,0,0,1,8)|0;V=R+4|0;c[V>>2]=Q;if((Q|0)==0){ca=12;_=294;break b}c[R>>2]=1;c[R+8>>2]=-1;c[R+12>>2]=-1;c[Q>>2]=W;c[(c[V>>2]|0)+4>>2]=N;c[R+16>>2]=(c[N+16>>2]|0)+(c[W+16>>2]|0);S=M;T=R;U=0;break};case 8:{R=L+ -2|0;c[n>>2]=R;W=c[P+(R<<2)>>2]|0;R=c[w>>2]|0;V=upb(R,0,0,1,32)|0;if((V|0)==0){ca=12;_=294;break b}Q=upb(R,0,0,1,8)|0;R=V+4|0;c[R>>2]=Q;if((Q|0)==0){ca=12;_=294;break b}c[V>>2]=3;c[V+8>>2]=-1;c[V+12>>2]=-1;c[Q>>2]=W;c[(c[R>>2]|0)+4>>2]=N;c[V+16>>2]=(c[N+16>>2]|0)+(c[W+16>>2]|0);S=M;T=V;U=0;break};case 1:{V=c[q>>2]|0;d:do{switch(a[V]|0){case 91:{W=V+1|0;c[q>>2]=W;R=Wpb(128)|0;if((R|0)==0){ca=12;_=294;break b}if((a[W]|0)==94){Q=V+2|0;c[q>>2]=Q;wa=Q;xa=1}else{wa=W;xa=0}W=(xa|0)==0;Q=R;R=0;X=0;ga=32;ha=wa;e:while(1){ya=a[ha]|0;if(ya<<24>>24==93){if(ha>>>0>(c[q>>2]|0)>>>0){_=85;break}}else if(ya<<24>>24==0){za=Q;Aa=ha;Ba=7;_=140;break}ya=_ob(e,ha,-1)|0;if((ya|0)<0){c[e>>2]=-1;Ca=1}else{Ca=ya}ya=ha+Ca|0;do{if((a[ya]|0)==45){Da=Ca+1|0;Ea=ha+Da|0;if((a[Ea]|0)==93){_=94;break}Fa=c[e>>2]|0;Ga=_ob(e,Ea,-1)|0;if((Ga|0)<0){c[e>>2]=-1;Ha=-1;Ia=1}else{Ha=c[e>>2]|0;Ia=Ga}Ja=0;Ka=Ha;La=Fa;Ma=ha+(Ia+Da)|0;Na=Fa>>>0>Ha>>>0?11:0}else{_=94}}while(0);f:do{if((_|0)==94){_=0;Fa=a[ha]|0;do{if(Fa<<24>>24==91){Da=a[ha+1|0]|0;if(Da<<24>>24==61|Da<<24>>24==46){za=Q;Aa=ha;Ba=3;_=140;break e}else if(!(Da<<24>>24==58)){Oa=0;break}Da=ha+2|0;Ga=Da;while(1){Ea=a[Ga]|0;Pa=Ea<<24>>24==0;if(Ea<<24>>24!=58&(Pa^1)){Ga=Ga+1|0}else{break}}if(Pa){za=Q;Aa=ha;Ba=4;_=140;break e}Ea=Ga-ha+ -2|0;Qa=(Ea|0)>63?63:Ea;Jqb(A|0,Da|0,Qa|0)|0;a[f+Qa|0]=0;Qa=Kob(A)|0;Ja=Qa;Ka=1114111;La=0;Ma=Ga+2|0;Na=(Qa|0)==0?4:0;break f}else if(Fa<<24>>24==45){if((a[ha+1|0]|0)==93){Oa=0;break}Oa=(c[q>>2]|0)==(ha|0)?0:11}else{Oa=0}}while(0);Fa=c[e>>2]|0;Ja=0;Ka=Fa;La=Fa;Ma=ya;Na=Oa}}while(0);if((Na|0)!=0){za=Q;Aa=Ma;Ba=Na;_=140;break}ya=(Ja|0)!=0;do{if(W|ya^1){Fa=c[w>>2]|0;if((X|0)<(ga|0)){Ra=Q;Sa=ga}else{if((ga|0)>1024){za=Q;Aa=Ma;Ba=12;_=140;break e}Qa=Zpb(Q,ga<<3)|0;if((Qa|0)==0){za=Q;Aa=Ma;Ba=12;_=140;break e}else{Ra=Qa;Sa=ga<<1}}Qa=upb(Fa,0,0,1,32)|0;if((Qa|0)==0){_=112;break e}Ea=upb(Fa,0,0,1,20)|0;Fa=Qa+4|0;c[Fa>>2]=Ea;if((Ea|0)==0){_=112;break e}c[Qa>>2]=0;c[Qa+8>>2]=-1;c[Qa+12>>2]=-1;c[Ea>>2]=La;c[Ea+4>>2]=Ka;c[Ea+8>>2]=-1;c[Ra+(X<<2)>>2]=Qa;c[(c[Fa>>2]|0)+12>>2]=Ja;Ta=Ra;Ua=R;Va=X+1|0;Wa=Sa;Xa=0}else{if((R|0)>63){Ta=Q;Ua=R;Va=X;Wa=ga;Xa=12;break}c[g+(R<<2)>>2]=Ja;Ta=Q;Ua=R+1|0;Va=X;Wa=ga;Xa=0}}while(0);Fa=(Xa|0)==0;if(Fa&(((c[v>>2]&2|0)==0|ya)^1)){Ya=Ta;Za=Va;_a=Wa;$a=La}else{if(Fa){Q=Ta;R=Ua;X=Va;ga=Wa;ha=Ma;continue}else{za=Ta;Aa=Ma;Ba=Xa;_=140;break}}while(1){Fa=$a;while(1){if(Fa>>>0>Ka>>>0){Q=Ya;R=Ua;X=Za;ga=_a;ha=Ma;continue e}if((Nob(Fa)|0)!=0){_=118;break}ab=Fa+1|0;if((Rob(Fa)|0)==0){Fa=ab}else{_=129;break}}if((_|0)==118){_=0;Qa=Tob(Fa)|0;Ea=Fa+1|0;g:do{if((Nob(Ea)|0)==0){bb=Qa;cb=Ea}else{db=Qa;eb=Ea;while(1){if((Tob(eb)|0)!=(db+1|0)|eb>>>0>Ka>>>0){bb=db;cb=eb;break g}fb=Tob(eb)|0;gb=eb+1|0;if((Nob(gb)|0)==0){bb=fb;cb=gb;break}else{db=fb;eb=gb}}}}while(0);Ea=c[w>>2]|0;if((Za|0)<(_a|0)){hb=Ya;ib=_a}else{if((_a|0)>1024){za=Ya;Aa=Ma;Ba=12;_=140;break e}eb=Zpb(Ya,_a<<3)|0;if((eb|0)==0){za=Ya;Aa=Ma;Ba=12;_=140;break e}else{hb=eb;ib=_a<<1}}eb=upb(Ea,0,0,1,32)|0;db=eb;do{if((eb|0)==0){jb=0}else{Ga=upb(Ea,0,0,1,20)|0;c[eb+4>>2]=Ga;if((Ga|0)==0){jb=0;break}c[eb>>2]=0;c[eb+8>>2]=-1;c[eb+12>>2]=-1;c[Ga>>2]=Qa;c[Ga+4>>2]=bb;c[Ga+8>>2]=-1;jb=db}}while(0);c[hb+(Za<<2)>>2]=jb;kb=jb;lb=hb;mb=ib;nb=cb}else if((_|0)==129){_=0;db=Vob(Fa)|0;h:do{if((Rob(ab)|0)==0){ob=db;pb=ab}else{Qa=db;eb=ab;while(1){if((Vob(eb)|0)!=(Qa+1|0)|eb>>>0>Ka>>>0){ob=Qa;pb=eb;break h}Ea=eb+1|0;Ga=Vob(eb)|0;if((Rob(Ea)|0)==0){ob=Ga;pb=Ea;break}else{Qa=Ga;eb=Ea}}}}while(0);Fa=c[w>>2]|0;if((Za|0)<(_a|0)){qb=Ya;rb=_a}else{if((_a|0)>1024){za=Ya;Aa=Ma;Ba=12;_=140;break e}eb=Zpb(Ya,_a<<3)|0;if((eb|0)==0){za=Ya;Aa=Ma;Ba=12;_=140;break e}else{qb=eb;rb=_a<<1}}eb=upb(Fa,0,0,1,32)|0;Qa=eb;do{if((eb|0)==0){sb=0}else{Ea=upb(Fa,0,0,1,20)|0;c[eb+4>>2]=Ea;if((Ea|0)==0){sb=0;break}c[eb>>2]=0;c[eb+8>>2]=-1;c[eb+12>>2]=-1;c[Ea>>2]=db;c[Ea+4>>2]=ob;c[Ea+8>>2]=-1;sb=Qa}}while(0);c[qb+(Za<<2)>>2]=sb;kb=sb;lb=qb;mb=rb;nb=pb}if((kb|0)==0){_=141;break e}else{Ya=lb;Za=Za+1|0;_a=mb;$a=nb}}}i:do{if((_|0)==85){_=0;c[q>>2]=ha+1;ga=(xa|0)!=0;if(ga){gc(Q|0,X|0,4,62)}j:do{if((X|0)>0){W=(R|0)>0;ya=R<<2;Qa=ya+4|0;if(ga){tb=0;ub=0;vb=0;wb=0}else{db=0;eb=0;while(1){Fa=Q+(db<<2)|0;Ea=c[(c[Fa>>2]|0)+4>>2]|0;do{if((Ea|0)==0){xb=eb;yb=0}else{c[Ea+8>>2]=c[x>>2];if(W){Ga=upb(c[w>>2]|0,0,0,0,Qa)|0;Da=Ea+16|0;c[Da>>2]=Ga;if((Ga|0)==0){zb=Q;Ab=eb;Bb=12;break i}Aqb(Ga|0,z|0,ya|0)|0;c[(c[Da>>2]|0)+(R<<2)>>2]=0}else{c[Ea+16>>2]=0}if((eb|0)==0){xb=c[Fa>>2]|0;yb=0;break}Da=c[w>>2]|0;Ga=c[Fa>>2]|0;gb=upb(Da,0,0,1,32)|0;fb=gb;do{if((gb|0)==0){Cb=0}else{Db=upb(Da,0,0,1,8)|0;Eb=gb+4|0;c[Eb>>2]=Db;if((Db|0)==0){Cb=0;break}c[gb>>2]=3;c[gb+8>>2]=-1;c[gb+12>>2]=-1;c[Db>>2]=eb;c[(c[Eb>>2]|0)+4>>2]=Ga;c[gb+16>>2]=(c[Ga+16>>2]|0)+(c[eb+16>>2]|0);Cb=fb}}while(0);xb=Cb;yb=(Cb|0)==0?12:0}}while(0);Fa=db+1|0;if((Fa|0)<(X|0)&(yb|0)==0){db=Fa;eb=xb}else{Fb=0;Gb=xb;Hb=yb;break j}}}while(1){eb=Q+(vb<<2)|0;db=c[(c[eb>>2]|0)+4>>2]|0;Fa=c[db>>2]|0;Ea=db+4|0;fb=c[Ea>>2]|0;do{if((Fa|0)<(tb|0)){Ga=fb+1|0;Ib=(Ga|0)<(tb|0)?tb:Ga;Jb=ub;Kb=wb;Lb=0}else{if((Fa|0)<=(ub|0)){Ga=fb+1|0;Ib=Ga;Jb=Ga;Kb=wb;Lb=0;break}c[db>>2]=ub;c[Ea>>2]=Fa+ -1;Ga=fb+1|0;if((db|0)==0){Ib=Ga;Jb=Ga;Kb=wb;Lb=0;break}c[db+8>>2]=c[x>>2];if(W){gb=upb(c[w>>2]|0,0,0,0,Qa)|0;Da=db+16|0;c[Da>>2]=gb;if((gb|0)==0){zb=Q;Ab=wb;Bb=12;break i}Aqb(gb|0,z|0,ya|0)|0;c[(c[Da>>2]|0)+(R<<2)>>2]=0}else{c[db+16>>2]=0}if((wb|0)==0){Ib=Ga;Jb=Ga;Kb=c[eb>>2]|0;Lb=0;break}Da=c[w>>2]|0;gb=c[eb>>2]|0;Eb=upb(Da,0,0,1,32)|0;Db=Eb;do{if((Eb|0)==0){Mb=0}else{Nb=upb(Da,0,0,1,8)|0;Ob=Eb+4|0;c[Ob>>2]=Nb;if((Nb|0)==0){Mb=0;break}c[Eb>>2]=3;c[Eb+8>>2]=-1;c[Eb+12>>2]=-1;c[Nb>>2]=wb;c[(c[Ob>>2]|0)+4>>2]=gb;c[Eb+16>>2]=(c[gb+16>>2]|0)+(c[wb+16>>2]|0);Mb=Db}}while(0);Ib=Ga;Jb=Ga;Kb=Mb;Lb=(Mb|0)==0?12:0}}while(0);eb=vb+1|0;if((eb|0)<(X|0)&(Lb|0)==0){tb=Ib;ub=Jb;vb=eb;wb=Kb}else{Fb=Jb;Gb=Kb;Hb=Lb;break}}}else{Fb=0;Gb=0;Hb=0}}while(0);if((Hb|0)!=0|ga^1){zb=Q;Ab=Gb;Bb=Hb;break}ya=c[w>>2]|0;Qa=c[x>>2]|0;W=upb(ya,0,0,1,32)|0;eb=W;if((W|0)==0){zb=Q;Ab=Gb;Bb=12;break}db=upb(ya,0,0,1,20)|0;c[W+4>>2]=db;if((db|0)==0){zb=Q;Ab=Gb;Bb=12;break}c[W>>2]=0;c[W+8>>2]=-1;c[W+12>>2]=-1;c[db>>2]=Fb;c[db+4>>2]=1114111;c[db+8>>2]=Qa;if((R|0)>0){Qa=R<<2;ya=upb(c[w>>2]|0,0,0,0,Qa+4|0)|0;fb=db+16|0;c[fb>>2]=ya;if((ya|0)==0){zb=Q;Ab=Gb;Bb=12;break}Aqb(ya|0,z|0,Qa|0)|0;c[(c[fb>>2]|0)+(R<<2)>>2]=0}else{c[db+16>>2]=0}if((Gb|0)==0){zb=Q;Ab=eb;Bb=0;break}db=c[w>>2]|0;fb=upb(db,0,0,1,32)|0;Qa=fb;do{if((fb|0)==0){Pb=0}else{ya=upb(db,0,0,1,8)|0;Fa=fb+4|0;c[Fa>>2]=ya;if((ya|0)==0){Pb=0;break}c[fb>>2]=3;c[fb+8>>2]=-1;c[fb+12>>2]=-1;c[ya>>2]=Gb;c[(c[Fa>>2]|0)+4>>2]=eb;c[fb+16>>2]=(c[W+16>>2]|0)+(c[Gb+16>>2]|0);Pb=Qa}}while(0);zb=Q;Ab=Pb;Bb=(Pb|0)==0?12:0}else if((_|0)==112){_=0;c[Ra+(X<<2)>>2]=0;za=Ra;Aa=Ma;Ba=12;_=140}else if((_|0)==141){_=0;c[q>>2]=Ma;zb=lb;Ab=0;Bb=12}}while(0);if((_|0)==140){_=0;c[q>>2]=Aa;zb=za;Ab=0;Bb=Ba}Xpb(zb);c[x>>2]=(c[x>>2]|0)+1;if((Bb|0)==0){S=M;T=Ab;U=0;break c}else{ca=Bb;_=294;break b}break};case 40:{if((c[v>>2]&1|0)!=0){Qb=V;_=74}break};case 36:{if((c[v>>2]&1|0)==0){if((a[V+1|0]|0)!=0){break d}}X=c[w>>2]|0;Q=upb(X,0,0,1,32)|0;if((Q|0)==0){ca=12;_=294;break b}R=upb(X,0,0,1,20)|0;c[Q+4>>2]=R;if((R|0)==0){ca=12;_=294;break b}c[Q>>2]=0;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[R>>2]=-2;c[R+4>>2]=2;c[R+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;S=M;T=Q;U=0;break c;break};case 63:case 43:case 123:case 124:case 42:{_=264;break};case 0:{_=265;break};case 41:{if((M|0)!=0){_=264}break};case 46:{Q=(c[v>>2]&4|0)==0;R=c[w>>2]|0;X=c[x>>2]|0;ha=upb(R,0,0,1,32)|0;Qa=ha;W=(ha|0)==0;if(Q){if(W){ca=12;_=294;break b}Q=upb(R,0,0,1,20)|0;c[ha+4>>2]=Q;if((Q|0)==0){ca=12;_=294;break b}c[ha>>2]=0;c[ha+8>>2]=-1;c[ha+12>>2]=-1;c[Q>>2]=0;c[Q+4>>2]=1114111;c[Q+8>>2]=X;Rb=Qa;Sb=(c[x>>2]|0)+1|0}else{if(W){ca=12;_=294;break b}W=upb(R,0,0,1,20)|0;c[ha+4>>2]=W;if((W|0)==0){ca=12;_=294;break b}c[ha>>2]=0;c[ha+8>>2]=-1;c[ha+12>>2]=-1;c[W>>2]=0;c[W+4>>2]=9;c[W+8>>2]=X;X=c[w>>2]|0;W=(c[x>>2]|0)+1|0;R=upb(X,0,0,1,32)|0;if((R|0)==0){ca=12;_=294;break b}Q=upb(X,0,0,1,20)|0;c[R+4>>2]=Q;if((Q|0)==0){ca=12;_=294;break b}c[R>>2]=0;c[R+8>>2]=-1;c[R+12>>2]=-1;c[Q>>2]=11;c[Q+4>>2]=1114111;c[Q+8>>2]=W;W=c[w>>2]|0;Q=upb(W,0,0,1,32)|0;if((Q|0)==0){ca=12;_=294;break b}X=upb(W,0,0,1,8)|0;W=Q+4|0;c[W>>2]=X;if((X|0)==0){ca=12;_=294;break b}c[Q>>2]=3;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[X>>2]=Qa;c[(c[W>>2]|0)+4>>2]=R;c[Q+16>>2]=(c[R+16>>2]|0)+(c[ha+16>>2]|0);Rb=Q;Sb=(c[x>>2]|0)+2|0}c[x>>2]=Sb;c[q>>2]=(c[q>>2]|0)+1;S=M;T=Rb;U=0;break c;break};case 94:{if((c[v>>2]&1|0)==0){if((V|0)!=(c[r>>2]|0)){break d}Q=kpb(m,5)|0;if((Q|0)!=0){Y=M;Z=Q;_=6;break b}}Q=c[w>>2]|0;ha=upb(Q,0,0,1,32)|0;if((ha|0)==0){ca=12;_=294;break b}R=upb(Q,0,0,1,20)|0;c[ha+4>>2]=R;if((R|0)==0){ca=12;_=294;break b}c[ha>>2]=0;c[ha+8>>2]=-1;c[ha+12>>2]=-1;c[R>>2]=-2;c[R+4>>2]=1;c[R+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;S=M;T=ha;U=0;break c;break};case 92:{ha=V+1|0;R=a[ha]|0;do{if((c[v>>2]&1|0)==0){if(R<<24>>24==40){c[q>>2]=ha;Qb=ha;_=74;break d}else{Q=a[V+1|0]|0;if(Q<<24>>24==41){_=265;break d}else{Tb=Q;break}}}else{Tb=R}}while(0);R=V+1|0;ha=Tb<<24>>24==0;if(ha){ca=5;_=294;break b}else{Ub=329068|0;Vb=0}while(1){Q=Vb+1|0;if((a[329064+(Vb<<3)|0]|0)==Tb<<24>>24){Wb=Ub;break}W=329068+(Q<<3)|0;if((Q|0)==12){Wb=W;break}else{Ub=W;Vb=Q}}Q=c[Wb>>2]|0;if((Q|0)!=0){W=F+0|0;Qa=G+0|0;X=W+40|0;do{c[W>>2]=c[Qa>>2];W=W+4|0;Qa=Qa+4|0}while((W|0)<(X|0));c[H>>2]=Q;c[I>>2]=1;Qa=dpb(j)|0;if((Qa|0)!=0){ca=Qa;_=294;break b}c[q>>2]=(c[q>>2]|0)+2;c[x>>2]=c[J>>2];S=M;T=c[K>>2]|0;U=0;break c}if(ha){ca=5;_=294;break b}c[q>>2]=R;Qa=a[R]|0;k:do{switch(Qa|0){case 66:{W=c[w>>2]|0;X=upb(W,0,0,1,32)|0;fb=X;do{if((X|0)==0){Xb=0}else{eb=upb(W,0,0,1,20)|0;c[X+4>>2]=eb;if((eb|0)==0){Xb=0;break}c[X>>2]=0;c[X+8>>2]=-1;c[X+12>>2]=-1;c[eb>>2]=-2;c[eb+4>>2]=128;c[eb+8>>2]=-1;Xb=fb}}while(0);c[q>>2]=(c[q>>2]|0)+1;Zb=Xb;break};case 60:{fb=c[w>>2]|0;X=upb(fb,0,0,1,32)|0;W=X;do{if((X|0)==0){_b=0}else{eb=upb(fb,0,0,1,20)|0;c[X+4>>2]=eb;if((eb|0)==0){_b=0;break}c[X>>2]=0;c[X+8>>2]=-1;c[X+12>>2]=-1;c[eb>>2]=-2;c[eb+4>>2]=16;c[eb+8>>2]=-1;_b=W}}while(0);c[q>>2]=(c[q>>2]|0)+1;Zb=_b;break};case 62:{W=c[w>>2]|0;X=upb(W,0,0,1,32)|0;fb=X;do{if((X|0)==0){$b=0}else{eb=upb(W,0,0,1,20)|0;c[X+4>>2]=eb;if((eb|0)==0){$b=0;break}c[X>>2]=0;c[X+8>>2]=-1;c[X+12>>2]=-1;c[eb>>2]=-2;c[eb+4>>2]=32;c[eb+8>>2]=-1;$b=fb}}while(0);c[q>>2]=(c[q>>2]|0)+1;Zb=$b;break};case 120:{fb=V+2|0;c[q>>2]=fb;X=a[fb]|0;if(X<<24>>24==123){fb=V+3|0;c[q>>2]=fb;W=fb;fb=0;while(1){eb=a[W]|0;if(eb<<24>>24==0|eb<<24>>24==125){ac=fb;bc=W;break}if((Sob(eb<<24>>24)|0)==0){ca=9;_=294;break b}eb=c[q>>2]|0;a[l+fb|0]=a[eb]|0;db=fb+1|0;ga=eb+1|0;c[q>>2]=ga;if(db>>>0>31){ac=db;bc=ga;break}else{W=ga;fb=db}}c[q>>2]=bc+1;a[l+ac|0]=0;fb=Yb(C|0,0,16)|0;W=c[w>>2]|0;db=c[x>>2]|0;ga=upb(W,0,0,1,32)|0;eb=ga;do{if((ga|0)==0){cc=0}else{Fa=upb(W,0,0,1,20)|0;c[ga+4>>2]=Fa;if((Fa|0)==0){cc=0;break}c[ga>>2]=0;c[ga+8>>2]=-1;c[ga+12>>2]=-1;c[Fa>>2]=fb;c[Fa+4>>2]=fb;c[Fa+8>>2]=db;cc=eb}}while(0);c[x>>2]=(c[x>>2]|0)+1;Zb=cc;break k}else{a[D+0|0]=0;a[D+1|0]=0;a[D+2|0]=0;eb=(Sob(X<<24>>24)|0)==0;db=c[q>>2]|0;if(eb){dc=db}else{a[D]=a[db]|0;eb=db+1|0;c[q>>2]=eb;dc=eb}if((Sob(a[dc]|0)|0)!=0){eb=c[q>>2]|0;a[E]=a[eb]|0;c[q>>2]=eb+1}eb=Yb(D|0,0,16)|0;db=c[w>>2]|0;fb=c[x>>2]|0;ga=upb(db,0,0,1,32)|0;W=ga;do{if((ga|0)==0){ec=0}else{Fa=upb(db,0,0,1,20)|0;c[ga+4>>2]=Fa;if((Fa|0)==0){ec=0;break}c[ga>>2]=0;c[ga+8>>2]=-1;c[ga+12>>2]=-1;c[Fa>>2]=eb;c[Fa+4>>2]=eb;c[Fa+8>>2]=fb;ec=W}}while(0);c[x>>2]=(c[x>>2]|0)+1;Zb=ec;break k}break};case 98:{W=c[w>>2]|0;fb=upb(W,0,0,1,32)|0;eb=fb;do{if((fb|0)==0){fc=0}else{ga=upb(W,0,0,1,20)|0;c[fb+4>>2]=ga;if((ga|0)==0){fc=0;break}c[fb>>2]=0;c[fb+8>>2]=-1;c[fb+12>>2]=-1;c[ga>>2]=-2;c[ga+4>>2]=64;c[ga+8>>2]=-1;fc=eb}}while(0);c[q>>2]=(c[q>>2]|0)+1;Zb=fc;break};default:{if((Lob(Qa)|0)!=0){eb=(a[c[q>>2]|0]|0)+ -48|0;fb=c[w>>2]|0;W=c[x>>2]|0;ga=upb(fb,0,0,1,32)|0;if((ga|0)==0){ca=12;_=294;break b}db=upb(fb,0,0,1,20)|0;c[ga+4>>2]=db;if((db|0)==0){ca=12;_=294;break b}c[ga>>2]=0;c[ga+8>>2]=-1;c[ga+12>>2]=-1;c[db>>2]=-4;c[db+4>>2]=eb;c[db+8>>2]=W;c[x>>2]=(c[x>>2]|0)+1;W=c[B>>2]|0;c[B>>2]=(eb|0)<(W|0)?W:eb;c[q>>2]=(c[q>>2]|0)+1;S=M;T=ga;U=0;break c}ga=c[w>>2]|0;eb=a[c[q>>2]|0]|0;W=c[x>>2]|0;db=upb(ga,0,0,1,32)|0;fb=db;do{if((db|0)==0){hc=0}else{X=upb(ga,0,0,1,20)|0;c[db+4>>2]=X;if((X|0)==0){hc=0;break}c[db>>2]=0;c[db+8>>2]=-1;c[db+12>>2]=-1;c[X>>2]=eb;c[X+4>>2]=eb;c[X+8>>2]=W;hc=fb}}while(0);c[x>>2]=(c[x>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+1;Zb=hc}}}while(0);if((Zb|0)==0){ca=12;_=294;break b}else{S=M;T=Zb;U=0;break c}break};default:{}}}while(0);if((_|0)==74){_=0;ba=M+1|0;c[q>>2]=Qb+1;Qa=kpb(m,c[y>>2]|0)|0;if((Qa|0)!=0){Y=ba;Z=Qa;_=6;break b}Qa=kpb(m,2)|0;if((Qa|0)!=0){Y=ba;Z=Qa;_=6;break b}Qa=kpb(m,0)|0;if((Qa|0)!=0){Y=ba;Z=Qa;_=6;break b}c[y>>2]=(c[y>>2]|0)+1;S=ba;T=N;U=0;break c}else if((_|0)==264){_=0;if((c[v>>2]&1|0)!=0){_=265}}if((_|0)==265){_=0;ba=c[w>>2]|0;Qa=upb(ba,0,0,1,32)|0;if((Qa|0)==0){ca=12;_=294;break b}R=upb(ba,0,0,1,20)|0;c[Qa+4>>2]=R;if((R|0)==0){ca=12;_=294;break b}c[Qa>>2]=0;c[Qa+8>>2]=-1;c[Qa+12>>2]=-1;c[R>>2]=-1;c[R+4>>2]=-1;c[R+8>>2]=-1;S=M;T=Qa;U=0;break c}Qa=_ob(h,V,-1)|0;if((Qa|0)<0){c[h>>2]=-1;ic=1}else{ic=Qa}do{if((c[v>>2]&2|0)==0){_=280}else{if((Rob(c[h>>2]|0)|0)==0){if((Nob(c[h>>2]|0)|0)==0){_=280;break}}Qa=c[w>>2]|0;R=Tob(c[h>>2]|0)|0;ba=Tob(c[h>>2]|0)|0;ha=c[x>>2]|0;Q=upb(Qa,0,0,1,32)|0;if((Q|0)==0){ca=12;_=294;break b}fb=upb(Qa,0,0,1,20)|0;c[Q+4>>2]=fb;if((fb|0)==0){ca=12;_=294;break b}c[Q>>2]=0;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[fb>>2]=R;c[fb+4>>2]=ba;c[fb+8>>2]=ha;ha=c[w>>2]|0;fb=Vob(c[h>>2]|0)|0;ba=Vob(c[h>>2]|0)|0;R=c[x>>2]|0;Qa=upb(ha,0,0,1,32)|0;if((Qa|0)==0){ca=12;_=294;break b}W=upb(ha,0,0,1,20)|0;c[Qa+4>>2]=W;if((W|0)==0){ca=12;_=294;break b}c[Qa>>2]=0;c[Qa+8>>2]=-1;c[Qa+12>>2]=-1;c[W>>2]=fb;c[W+4>>2]=ba;c[W+8>>2]=R;R=c[w>>2]|0;W=upb(R,0,0,1,32)|0;if((W|0)==0){ca=12;_=294;break b}ba=upb(R,0,0,1,8)|0;R=W+4|0;c[R>>2]=ba;if((ba|0)==0){ca=12;_=294;break b}c[W>>2]=3;c[W+8>>2]=-1;c[W+12>>2]=-1;c[ba>>2]=Q;c[(c[R>>2]|0)+4>>2]=Qa;c[W+16>>2]=(c[Qa+16>>2]|0)+(c[Q+16>>2]|0);jc=W}}while(0);if((_|0)==280){_=0;V=c[w>>2]|0;W=c[h>>2]|0;Q=c[x>>2]|0;Qa=upb(V,0,0,1,32)|0;if((Qa|0)==0){ca=12;_=294;break b}R=upb(V,0,0,1,20)|0;c[Qa+4>>2]=R;if((R|0)==0){ca=12;_=294;break b}c[Qa>>2]=0;c[Qa+8>>2]=-1;c[Qa+12>>2]=-1;c[R>>2]=W;c[R+4>>2]=W;c[R+8>>2]=Q;jc=Qa}c[x>>2]=(c[x>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+ic;S=M;T=jc;U=0;break};case 4:{Qa=kpb(m,9)|0;if((Qa|0)!=0){Y=M;Z=Qa;_=6;break b}S=M;T=N;U=kpb(m,1)|0;break};case 2:{Qa=L+ -2|0;c[n>>2]=Qa;Q=c[P+(Qa<<2)>>2]|0;if((c[N+12>>2]|0)>-1){Qa=c[w>>2]|0;R=upb(Qa,0,0,1,32)|0;if((R|0)==0){ca=12;_=294;break b}W=upb(Qa,0,0,1,20)|0;c[R+4>>2]=W;if((W|0)==0){ca=12;_=294;break b}c[R>>2]=0;c[R+8>>2]=-1;c[R+12>>2]=-1;c[W>>2]=-1;c[W+4>>2]=-1;c[W+8>>2]=-1;W=c[w>>2]|0;Qa=upb(W,0,0,1,32)|0;if((Qa|0)==0){ca=12;_=294;break b}V=upb(W,0,0,1,8)|0;W=Qa+4|0;c[W>>2]=V;if((V|0)==0){ca=12;_=294;break b}c[Qa>>2]=1;c[Qa+8>>2]=-1;c[Qa+12>>2]=-1;c[V>>2]=R;c[(c[W>>2]|0)+4>>2]=N;W=N+16|0;V=Qa+16|0;c[V>>2]=(c[W>>2]|0)+(c[R+16>>2]|0);c[V>>2]=c[W>>2];kc=Qa}else{kc=N}c[kc+12>>2]=Q;Q=kc+16|0;c[Q>>2]=(c[Q>>2]|0)+1;S=M;T=kc;U=0;break};case 10:{Q=L+ -2|0;c[n>>2]=Q;c[v>>2]=c[P+(Q<<2)>>2];S=M;T=N;U=0;break};default:{S=M;T=N;U=0}}}while(0);P=c[n>>2]|0;O=(U|0)==0;if((P|0)>(o|0)&O){L=P;M=S;N=T}else{lc=O;mc=S;nc=T;oc=U;break a}}if((_|0)==6){lc=(Z|0)==0;mc=Y;nc=N;oc=Z;break}else if((_|0)==294){i=d;return ca|0}}else{lc=t;mc=0;nc=0;oc=p}}while(0);p=(mc|0)>0;if(p|lc^1){ca=p?8:oc;i=d;return ca|0}c[b+8>>2]=nc;ca=0;i=d;return ca|0}function epb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0;g=i;h=d+12|0;j=c[h>>2]|0;k=(b|0)==0|(f|0)==0;if(!k){c[f+48>>2]=0;c[c[f+36>>2]>>2]=-1}l=c[f+28>>2]|0;m=Wpb((l<<3)+8|0)|0;n=m;if((m|0)==0){o=12;i=g;return o|0}c[m>>2]=-1;p=Wpb((l<<2)+4|0)|0;if((p|0)==0){Xpb(m);o=12;i=g;return o|0}c[p>>2]=-1;q=0;while(1){if(q>>>0>l>>>0){break}else{q=q+1|0}}kpb(d,e)|0;e=kpb(d,0)|0;q=c[h>>2]|0;a:do{if((q|0)>(j|0)&(e|0)==0){l=d+16|0;r=f+32|0;s=f+16|0;t=f+36|0;u=q;v=0;w=-1;x=1;y=0;z=0;A=n;B=0;while(1){C=u+ -1|0;c[h>>2]=C;D=c[l>>2]|0;b:do{switch(c[D+(C<<2)>>2]|0){case 1:{E=u+ -2|0;c[h>>2]=E;F=c[D+(E<<2)>>2]|0;if(k){E=c[(c[c[F+4>>2]>>2]|0)+20>>2]|0;G=u+ -3|0;c[h>>2]=G;c[F+20>>2]=(c[D+(G<<2)>>2]|0)+E;H=v;I=-1;J=x;K=y;L=z;M=A;N=0;O=B;break b}else{E=u+ -3|0;c[h>>2]=E;G=c[D+(E<<2)>>2]|0;E=u+ -4|0;c[h>>2]=E;F=(G|0)==0;H=F&1;I=F?w:c[D+(E<<2)>>2]|0;J=x;K=y;L=z;M=A;N=0;O=B;break b}break};case 3:{E=c[D+(u+ -2<<2)>>2]|0;F=c[D+(u+ -3<<2)>>2]|0;G=c[D+(u+ -4<<2)>>2]|0;P=u+ -5|0;c[h>>2]=P;if(k){Q=c[G+4>>2]|0;R=G+16|0;c[G+20>>2]=(c[(c[Q>>2]|0)+20>>2]|0)+(c[D+(P<<2)>>2]|0)+(c[(c[Q+4>>2]|0)+20>>2]|0)+((c[R>>2]|0)>0?2:0);S=R;T=c[h>>2]|0}else{S=G+16|0;T=P}P=c[D+(T+ -1<<2)>>2]|0;G=T+ -2|0;c[h>>2]=G;R=c[D+(G<<2)>>2]|0;G=T+ -3|0;c[h>>2]=G;Q=c[D+(G<<2)>>2]|0;if((c[S>>2]|0)<=0){H=1;I=w;J=x;K=y;L=z;M=P;N=0;O=B;break b}if(k){U=0}else{npb(b,E,R)|0;c[(c[r>>2]|0)+(R<<2)>>2]=1;R=npb(b,F,Q)|0;c[(c[r>>2]|0)+(Q<<2)>>2]=1;U=R}H=1;I=w;J=x;K=y;L=z+2|0;M=P;N=U;O=B;break};case 5:{P=u+ -2|0;c[h>>2]=P;R=c[D+(P<<2)>>2]|0;if(!k){H=v;I=w;J=x;K=y;L=z;M=A;N=0;O=B;break b}P=c[R+4>>2]|0;c[R+20>>2]=(c[(c[P+4>>2]|0)+20>>2]|0)+(c[(c[P>>2]|0)+20>>2]|0);H=v;I=w;J=x;K=y;L=z;M=A;N=0;O=B;break};case 6:{P=u+ -2|0;c[h>>2]=P;R=c[D+(P<<2)>>2]|0;P=0;do{V=A+(P<<2)|0;P=P+1|0}while((c[V>>2]|0)>-1);c[V>>2]=R<<1|1;c[A+(P<<2)>>2]=-1;Q=0;while(1){if((c[p+(Q<<2)>>2]|0)>-1){Q=Q+1|0}else{break}}c[p+(Q+ -1<<2)>>2]=-1;H=v;I=w;J=x;K=y;L=z;M=A;N=0;O=B;break};case 4:{P=u+ -2|0;c[h>>2]=P;R=c[D+(P<<2)>>2]|0;P=u+ -3|0;c[h>>2]=P;H=v;I=w;J=c[D+(P<<2)>>2]|0;K=y;L=z;M=A;N=0;O=(R|0)>-1?R:B;break};case 2:{R=A;while(1){if((c[R>>2]|0)>-1){R=R+4|0}else{H=v;I=w;J=x;K=y;L=z;M=R;N=0;O=B;break}}break};case 0:{R=u+ -2|0;c[h>>2]=R;Q=c[D+(R<<2)>>2]|0;R=Q;P=Q+12|0;F=c[P>>2]|0;if((F|0)>-1){E=0;do{W=A+(E<<2)|0;E=E+1|0}while((c[W>>2]|0)>-1);c[W>>2]=F<<1;c[A+(E<<2)>>2]=-1;do{if(!k){G=0;while(1){if((c[p+(G<<2)>>2]|0)>-1){G=G+1|0}else{break}}c[(c[s>>2]|0)+(F*12|0)+8>>2]=0;if((G|0)<=0){break}X=Wpb((G<<2)+4|0)|0;Y=X;if((X|0)==0){Z=w;_=y;$=z;aa=A;ba=12;ca=B;break a}c[(c[s>>2]|0)+(F*12|0)+8>>2]=Y;da=c[p>>2]|0;if((da|0)>-1){ea=Y;fa=da;da=0;while(1){c[ea>>2]=fa;ga=da+1|0;ha=c[p+(ga<<2)>>2]|0;ia=X+(ga<<2)|0;if((ha|0)>-1){da=ga;fa=ha;ea=ia}else{ja=ia;break}}}else{ja=Y}c[ja>>2]=-1}}while(0);F=kpb(d,c[P>>2]|0)|0;if((F|0)!=0){Z=w;_=y;$=z;aa=A;ba=F;ca=B;break a}F=kpb(d,6)|0;if((F|0)!=0){Z=w;_=y;$=z;aa=A;ba=F;ca=B;break a}}F=c[Q>>2]|0;do{if((F|0)==1){E=c[Q+4>>2]|0;ea=c[E>>2]|0;fa=c[E+4>>2]|0;E=kpb(d,Q)|0;if((E|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=E;qa=B;break}E=kpb(d,5)|0;if((E|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=E;qa=B;break}E=kpb(d,fa)|0;if((E|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=E;qa=B;break}E=kpb(d,0)|0;if((E|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=E;qa=B;break}E=ea+20|0;da=kpb(d,(c[E>>2]|0)+x|0)|0;if((da|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=da;qa=B;break}if((c[E>>2]|0)>0){E=(c[fa+20>>2]|0)>0;ra=(E&1)+x|0;sa=E?x:-1}else{ra=x;sa=-1}E=kpb(d,sa)|0;if((E|0)!=0){ka=v;la=w;ma=ra;na=y;oa=z;pa=E;qa=B;break}E=kpb(d,4)|0;if((E|0)!=0){ka=v;la=w;ma=ra;na=y;oa=z;pa=E;qa=B;break}E=kpb(d,ea)|0;if((E|0)!=0){ka=v;la=w;ma=ra;na=y;oa=z;pa=E;qa=B;break}ka=v;la=w;ma=ra;na=y;oa=z;pa=kpb(d,0)|0;qa=B}else if((F|0)==2){E=c[Q+4>>2]|0;if(k){if((c[A>>2]|0)>-1){ta=1}else{ta=a[E+12|0]&1}ea=kpb(d,ta)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}}else{ea=kpb(d,B)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=kpb(d,a[E+12|0]&1)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}}ea=kpb(d,Q)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=kpb(d,1)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=kpb(d,c[E>>2]|0)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=kpb(d,0)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}if(!((c[A>>2]|0)>-1)){if((a[E+12|0]&1)==0){ka=0;la=w;ma=x;na=y;oa=z;pa=0;qa=B;break}}if(k){ua=w;va=y;wa=0}else{ea=mpb(b,R,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=(a[E+12|0]&1)==0?v:1;if((w|0)>-1){E=c[t>>2]|0;fa=0;while(1){xa=E+(fa<<2)|0;ya=fa+1|0;if((c[xa>>2]|0)>-1){fa=ya}else{break}}c[xa>>2]=B;c[E+(ya<<2)>>2]=w;c[E+(fa+2<<2)>>2]=-1;za=-1;Aa=y+1|0}else{za=w;Aa=y}Y=c[A>>2]|0;if((Y|0)>-1){da=c[s>>2]|0;X=Y;Y=0;do{G=(X|0)/2|0;if((X&1|0)==0){c[da+(G*12|0)>>2]=B}else{c[da+(G*12|0)+4>>2]=B}Y=Y+1|0;X=c[A+(Y<<2)>>2]|0;}while((X|0)>-1)}c[A>>2]=-1;ua=za;va=Aa;wa=ea}c[A>>2]=-1;ka=0;la=ua;ma=x+1|0;na=va;oa=z+1|0;pa=wa;qa=x}else if((F|0)==3){X=c[Q+4>>2]|0;Y=c[X>>2]|0;da=c[X+4>>2]|0;X=(c[A>>2]|0)>-1;fa=x+1|0;E=kpb(d,X?fa:x)|0;if((E|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=E;qa=B;break}E=kpb(d,X?x:B)|0;if((E|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=E;qa=B;break}E=kpb(d,A)|0;if((E|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=E;qa=B;break}E=kpb(d,(c[A>>2]|0)>>>31^1)|0;if((E|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=E;qa=B;break}E=kpb(d,Q)|0;if((E|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=E;qa=B;break}E=da;da=kpb(d,E)|0;if((da|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=da;qa=B;break}da=Y;Y=kpb(d,da)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}Y=kpb(d,3)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}Y=kpb(d,E)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}Y=kpb(d,0)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}Y=kpb(d,2)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}Y=kpb(d,da)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}Y=kpb(d,0)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}if((c[A>>2]|0)>-1){if(k){Ba=w;Ca=y;Da=0}else{Y=mpb(b,R,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=v;if((w|0)>-1){da=c[t>>2]|0;E=0;while(1){Ea=da+(E<<2)|0;Fa=E+1|0;if((c[Ea>>2]|0)>-1){E=Fa}else{break}}c[Ea>>2]=B;c[da+(Fa<<2)>>2]=w;c[da+(E+2<<2)>>2]=-1;Ga=-1;Ha=y+1|0}else{Ga=w;Ha=y}ea=c[A>>2]|0;if((ea|0)>-1){X=c[s>>2]|0;G=ea;ea=0;do{ia=(G|0)/2|0;if((G&1|0)==0){c[X+(ia*12|0)>>2]=B}else{c[X+(ia*12|0)+4>>2]=B}ea=ea+1|0;G=c[A+(ea<<2)>>2]|0;}while((G|0)>-1)}c[A>>2]=-1;Ba=Ga;Ca=Ha;Da=Y}c[A>>2]=-1;Ia=Ba;Ja=fa;Ka=Ca;La=z+1|0;Ma=Da;Na=x}else{Ia=w;Ja=x;Ka=y;La=z;Ma=0;Na=B}if((c[Q+16>>2]|0)<=0){ka=v;la=Ia;ma=Ja;na=Ka;oa=La;pa=Ma;qa=Na;break}ka=v;la=Ia;ma=Ja+2|0;na=Ka;oa=La;pa=Ma;qa=Ja+1|0}else if((F|0)==0){G=c[c[Q+4>>2]>>2]|0;if(!((G|0)>-1|(G|0)==-4)){ka=v;la=w;ma=x;na=y;oa=z;pa=0;qa=B;break}if(!((c[A>>2]|0)>-1)){ka=v;la=w;ma=x;na=y;oa=z;pa=0;qa=B;break}if(k){c[Q+20>>2]=1;Oa=w;Pa=y;Qa=0}else{G=mpb(b,R,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=v;if((w|0)>-1){ea=c[t>>2]|0;X=0;while(1){Ra=ea+(X<<2)|0;Sa=X+1|0;if((c[Ra>>2]|0)>-1){X=Sa}else{break}}c[Ra>>2]=B;c[ea+(Sa<<2)>>2]=w;c[ea+(X+2<<2)>>2]=-1;Ta=-1;Ua=y+1|0}else{Ta=w;Ua=y}fa=c[A>>2]|0;if((fa|0)>-1){Y=c[s>>2]|0;E=fa;fa=0;do{da=(E|0)/2|0;if((E&1|0)==0){c[Y+(da*12|0)>>2]=B}else{c[Y+(da*12|0)+4>>2]=B}fa=fa+1|0;E=c[A+(fa<<2)>>2]|0;}while((E|0)>-1)}c[A>>2]=-1;Oa=Ta;Pa=Ua;Qa=G}c[A>>2]=-1;ka=v;la=Oa;ma=x+1|0;na=Pa;oa=z+1|0;pa=Qa;qa=x}else{ka=v;la=w;ma=x;na=y;oa=z;pa=0;qa=B}}while(0);R=c[P>>2]|0;if((R|0)>-1){Va=0}else{H=ka;I=la;J=ma;K=na;L=oa;M=A;N=pa;O=qa;break b}do{Wa=p+(Va<<2)|0;Va=Va+1|0}while((c[Wa>>2]|0)>-1);c[Wa>>2]=R;c[p+(Va<<2)>>2]=-1;H=ka;I=la;J=ma;K=na;L=oa;M=A;N=pa;O=qa;break};default:{H=v;I=w;J=x;K=y;L=z;M=A;N=0;O=B}}}while(0);D=c[h>>2]|0;if((D|0)>(j|0)&(N|0)==0){u=D;v=H;w=I;x=J;y=K;z=L;A=M;B=O}else{Z=I;_=K;$=L;aa=M;ba=N;ca=O;break a}}}else{Z=-1;_=0;$=0;aa=n;ba=e;ca=0}}while(0);do{if(k){Xa=_}else{e=c[aa>>2]|0;if((e|0)>-1){n=c[f+16>>2]|0;O=e;e=0;do{N=(O|0)/2|0;if((O&1|0)==0){c[n+(N*12|0)>>2]=ca}else{c[n+(N*12|0)+4>>2]=ca}e=e+1|0;O=c[aa+(e<<2)>>2]|0;}while((O|0)>-1)}c[aa>>2]=-1;if(!((Z|0)>-1)){Xa=_;break}O=c[f+36>>2]|0;e=0;while(1){Ya=O+(e<<2)|0;Za=e+1|0;if((c[Ya>>2]|0)>-1){e=Za}else{break}}c[Ya>>2]=ca;c[O+(Za<<2)>>2]=Z;c[O+(e+2<<2)>>2]=-1;Xa=_+1|0}}while(0);c[f+48>>2]=$;c[f+40>>2]=$;c[f+44>>2]=Xa;Xpb(m);Xpb(p);o=ba;i=g;return o|0}function fpb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=a;a:while(1){a=c[g>>2]|0;do{if((a|0)==3){h=c[g+4>>2]|0;j=fpb(c[h>>2]|0,b,d,e)|0;if((j|0)!=0){k=j;l=10;break a}m=h+4|0}else if((a|0)==2){h=c[g+4>>2]|0;j=h;if(!((c[h+8>>2]|0)==-1)){m=j;break}n=c[h>>2]|0;h=hpb(c[n+28>>2]|0,c[n+24>>2]|0,b,d,e)|0;if((h|0)==0){m=j}else{k=h;l=10;break a}}else if((a|0)==1){h=c[g+4>>2]|0;j=h+4|0;n=hpb(c[(c[h>>2]|0)+28>>2]|0,c[(c[j>>2]|0)+24>>2]|0,b,d,e)|0;if((n|0)!=0){k=n;l=10;break a}n=fpb(c[h>>2]|0,b,d,e)|0;if((n|0)==0){m=j}else{k=n;l=10;break a}}else{k=0;l=10;break a}}while(0);g=c[m>>2]|0}if((l|0)==10){i=f;return k|0}return 0}function gpb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=c[a+4>>2]|0;if((d|0)==0){i=b;return}a=d+4|0;e=c[d>>2]|0;if((c[a>>2]|0)==0){f=e}else{g=e;e=0;while(1){do{if((c[g+(e<<5)+8>>2]|0)==0){h=g}else{j=c[g+(e<<5)+16>>2]|0;if((j|0)==0){k=g}else{Xpb(j);k=c[d>>2]|0}j=c[k+(e<<5)+28>>2]|0;if((j|0)==0){h=k;break}Xpb(j);h=c[d>>2]|0}}while(0);j=e+1|0;if(j>>>0<(c[a>>2]|0)>>>0){g=h;e=j}else{f=h;break}}}if((f|0)!=0){Xpb(f)}f=d+8|0;h=c[f>>2]|0;if((h|0)!=0){if((c[h+8>>2]|0)==0){l=h}else{e=h;while(1){h=c[e+16>>2]|0;if((h|0)!=0){Xpb(h)}if((c[e+40>>2]|0)==0){break}else{e=e+32|0}}l=c[f>>2]|0}Xpb(l)}l=d+16|0;f=c[l>>2]|0;if((f|0)!=0){e=d+28|0;h=c[e>>2]|0;if((h|0)==0){m=f}else{g=h;h=f;f=0;while(1){a=c[h+(f*12|0)+8>>2]|0;if((a|0)==0){n=h;o=g}else{Xpb(a);n=c[l>>2]|0;o=c[e>>2]|0}a=f+1|0;if(a>>>0<o>>>0){g=o;h=n;f=a}else{m=n;break}}}Xpb(m)}m=c[d+32>>2]|0;if((m|0)!=0){Xpb(m)}m=c[d+20>>2]|0;if((m|0)!=0){Xpb(m)}m=c[d+36>>2]|0;if((m|0)!=0){Xpb(m)}Xpb(d);i=b;return}function hpb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;g=i;h=a;a=c[h>>2]|0;j=(a|0)>-1;if((d|0)==0){if(!j){k=0;i=g;return k|0}l=b;m=a;a=h;while(1){a:do{if((c[l>>2]|0)>-1){n=b;o=m;while(1){p=e+(o<<2)|0;c[p>>2]=(c[p>>2]|0)+1;p=n+32|0;if(!((c[p>>2]|0)>-1)){break a}o=c[a>>2]|0;n=p}}}while(0);n=a+32|0;o=c[n>>2]|0;if((o|0)>-1){m=o;a=n}else{k=0;break}}i=g;return k|0}if(!j){k=0;i=g;return k|0}j=b;a=h;b:while(1){h=c[j>>2]|0;c:do{if((h|0)>-1){m=a+4|0;e=a+8|0;l=a+16|0;n=a+20|0;o=a+24|0;p=a+28|0;q=a+12|0;r=b;s=h;t=j;u=-1;while(1){v=r;w=s;x=t;while(1){y=v+32|0;if((w|0)!=(u|0)){break}z=y;A=c[z>>2]|0;if((A|0)>-1){w=A;x=z;v=y}else{break c}}z=d+(c[f+(c[a>>2]<<2)>>2]<<5)|0;while(1){B=z+8|0;if((c[B>>2]|0)==0){break}else{z=z+32|0}}c[z+40>>2]=0;c[z>>2]=c[m>>2];c[z+4>>2]=c[e>>2];A=c[x>>2]|0;c[B>>2]=d+(c[f+(A<<2)>>2]<<5);c[z+12>>2]=A;A=c[n>>2]|0;C=c[o>>2]|0;D=c[v+16>>2]|c[l>>2]|((A|0)!=0?4:0)|((C|0)!=0?8:0);E=z+20|0;c[E>>2]=D;F=c[p>>2]|0;G=z+24|0;if((F|0)>-1){c[G>>2]=F;c[E>>2]=D|256}else{c[G>>2]=A}if((C|0)==0){c[z+28>>2]=0}else{A=0;while(1){H=A+1|0;if((c[C+(A<<2)>>2]|0)==0){break}else{A=H}}A=Wpb(H<<2)|0;C=A;c[z+28>>2]=C;if((A|0)==0){k=12;I=49;break b}x=c[o>>2]|0;G=c[x>>2]|0;if((G|0)==0){J=C}else{D=C;C=G;G=0;while(1){c[D>>2]=C;E=G+1|0;F=c[x+(E<<2)>>2]|0;K=A+(E<<2)|0;if((F|0)==0){J=K;break}else{G=E;C=F;D=K}}}c[J>>2]=0}D=c[q>>2]|0;if((D|0)==0){L=0}else{C=0;while(1){if((c[D+(C<<2)>>2]|0)>-1){C=C+1|0}else{L=C;break}}}C=v+12|0;D=c[C>>2]|0;if((D|0)==0){M=0}else{G=0;while(1){if((c[D+(G<<2)>>2]|0)>-1){G=G+1|0}else{M=G;break}}}G=z+16|0;D=c[G>>2]|0;if((D|0)!=0){Xpb(D)}c[G>>2]=0;D=M+L|0;if((D|0)>0){v=Wpb((D<<2)+4|0)|0;c[G>>2]=v;if((v|0)==0){k=12;I=49;break b}G=c[q>>2]|0;do{if((G|0)==0){N=0}else{D=c[G>>2]|0;if((D|0)>-1){O=D;P=0}else{N=0;break}while(1){c[v+(P<<2)>>2]=O;D=P+1|0;A=c[G+(D<<2)>>2]|0;if((A|0)>-1){P=D;O=A}else{N=D;break}}}}while(0);G=c[C>>2]|0;do{if((G|0)==0){Q=N}else{z=c[G>>2]|0;if(!((z|0)>-1)){Q=N;break}D=(N|0)>0;A=z;z=0;x=N;while(1){d:do{if(D){K=0;while(1){F=K+1|0;if((c[v+(K<<2)>>2]|0)==(A|0)){R=x;break d}if((F|0)<(N|0)){K=F}else{I=40;break}}}else{I=40}}while(0);if((I|0)==40){I=0;c[v+(x<<2)>>2]=A;R=x+1|0}K=z+1|0;F=c[G+(K<<2)>>2]|0;if((F|0)>-1){A=F;z=K;x=R}else{Q=R;break}}}}while(0);c[v+(Q<<2)>>2]=-1}G=y;C=c[G>>2]|0;if((C|0)>-1){r=y;s=C;t=G;u=w}else{break}}}}while(0);h=a+32|0;if((c[h>>2]|0)>-1){a=h}else{k=0;I=49;break}}if((I|0)==49){i=g;return k|0}return 0}function ipb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=i;h=(e|0)==0;a:do{if(h){j=0}else{k=0;while(1){if(!((c[e+(k<<2)>>2]|0)>-1)){j=k;break a}k=k+1|0}}}while(0);k=0;while(1){if((c[b+(k<<5)>>2]|0)>-1){k=k+1|0}else{l=0;break}}while(1){if((c[d+(l<<5)>>2]|0)>-1){l=l+1|0}else{break}}m=upb(a,0,0,1,(l+k<<5)+32|0)|0;k=m;if((m|0)==0){n=0;i=g;return n|0}l=c[b>>2]|0;b:do{if((l|0)>-1){o=(j|0)>0;p=l;q=0;while(1){c[m+(q<<5)>>2]=p;c[m+(q<<5)+4>>2]=c[b+(q<<5)+4>>2];c[m+(q<<5)+8>>2]=c[b+(q<<5)+8>>2];c[m+(q<<5)+16>>2]=c[b+(q<<5)+16>>2]|f;c[m+(q<<5)+20>>2]=c[b+(q<<5)+20>>2];c[m+(q<<5)+24>>2]=c[b+(q<<5)+24>>2];c[m+(q<<5)+28>>2]=c[b+(q<<5)+28>>2];r=b+(q<<5)+12|0;s=c[r>>2]|0;t=(s|0)==0;if(t&h){c[m+(q<<5)+12>>2]=0}else{c:do{if(t){u=0}else{v=0;while(1){if(!((c[s+(v<<2)>>2]|0)>-1)){u=v;break c}v=v+1|0}}}while(0);s=upb(a,0,0,0,(u+j<<2)+4|0)|0;t=s;if((s|0)==0){n=0;break}if((u|0)>0){v=c[r>>2]|0;w=0;while(1){c[s+(w<<2)>>2]=c[v+(w<<2)>>2];x=w+1|0;if((x|0)<(u|0)){w=x}else{y=u;break}}}else{y=0}if(o){w=0;while(1){c[s+(w+y<<2)>>2]=c[e+(w<<2)>>2];v=w+1|0;if((v|0)<(j|0)){w=v}else{z=j;break}}}else{z=0}c[s+(z+y<<2)>>2]=-1;c[m+(q<<5)+12>>2]=t}w=q+1|0;v=c[b+(w<<5)>>2]|0;if((v|0)>-1){p=v;q=w}else{A=w;break b}}i=g;return n|0}else{A=0}}while(0);b=c[d>>2]|0;y=m+(A<<5)|0;d:do{if((b|0)>-1){z=y;j=A;e=b;u=0;while(1){c[z>>2]=e;c[m+(j<<5)+4>>2]=c[d+(u<<5)+4>>2];c[m+(j<<5)+8>>2]=c[d+(u<<5)+8>>2];c[m+(j<<5)+16>>2]=c[d+(u<<5)+16>>2];c[m+(j<<5)+20>>2]=c[d+(u<<5)+20>>2];c[m+(j<<5)+24>>2]=c[d+(u<<5)+24>>2];c[m+(j<<5)+28>>2]=c[d+(u<<5)+28>>2];h=d+(u<<5)+12|0;f=c[h>>2]|0;if((f|0)==0){c[m+(j<<5)+12>>2]=0}else{l=0;while(1){if((c[f+(l<<2)>>2]|0)>-1){l=l+1|0}else{break}}f=upb(a,0,0,0,(l<<2)+4|0)|0;t=f;if((f|0)==0){n=0;break}if((l|0)>0){s=c[h>>2]|0;q=0;while(1){c[f+(q<<2)>>2]=c[s+(q<<2)>>2];p=q+1|0;if((p|0)<(l|0)){q=p}else{B=l;break}}}else{B=0}c[f+(B<<2)>>2]=-1;c[m+(j<<5)+12>>2]=t}l=u+1|0;q=c[d+(l<<5)>>2]|0;s=l+A|0;h=m+(s<<5)|0;if((q|0)>-1){z=h;j=s;e=q;u=l}else{C=h;break d}}i=g;return n|0}else{C=y}}while(0);c[C>>2]=-1;n=k;i=g;return n|0}function jpb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=i;h=a+12|0;j=c[h>>2]|0;k=(f|0)!=0;if(k){c[f>>2]=0}l=kpb(a,b)|0;if((l|0)!=0){m=l;i=g;return m|0}l=a+16|0;b=(d|0)==0;n=(e|0)==0;a:while(1){o=c[h>>2]|0;if((o|0)<=(j|0)){m=0;p=28;break}q=o+ -1|0;c[h>>2]=q;o=c[(c[l>>2]|0)+(q<<2)>>2]|0;q=c[o>>2]|0;do{if((q|0)==1){r=c[o+4>>2]|0;s=kpb(a,c[r>>2]|0)|0;if((s|0)!=0){m=s;p=28;break a}t=kpb(a,c[r+4>>2]|0)|0}else if((q|0)==3){r=c[o+4>>2]|0;s=c[r>>2]|0;if((c[s+8>>2]|0)!=0){t=kpb(a,s)|0;break}s=c[r+4>>2]|0;if((c[s+8>>2]|0)==0){continue a}t=kpb(a,s)|0}else if((q|0)==0){s=c[o+4>>2]|0;r=c[s>>2]|0;if((r|0)==-2){if(n){continue a}c[e>>2]=c[e>>2]|c[s+4>>2];continue a}else if(!((r|0)==-3)){continue a}r=c[s+4>>2]|0;if(!((r|0)>-1)){continue a}b:do{if(!b){s=c[d>>2]|0;c:do{if((s|0)>-1){u=s;v=d;w=0;while(1){x=w+1|0;if((u|0)==(r|0)){break}y=d+(x<<2)|0;z=c[y>>2]|0;if((z|0)>-1){u=z;v=y;w=x}else{A=y;B=x;break c}}if((r|0)<0){A=v;B=w}else{break b}}else{A=d;B=0}}while(0);c[A>>2]=r;c[d+(B+1<<2)>>2]=-1}}while(0);if(!k){continue a}c[f>>2]=(c[f>>2]|0)+1;continue a}else if((q|0)==2){r=c[c[o+4>>2]>>2]|0;if((c[r+8>>2]|0)==0){continue a}t=kpb(a,r)|0}else{continue a}}while(0);if((t|0)!=0){m=t;p=28;break}}if((p|0)==28){i=g;return m|0}return 0}function kpb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+12|0;f=c[e>>2]|0;g=a;h=c[g>>2]|0;if((f|0)<(h|0)){c[(c[a+16>>2]|0)+(f<<2)>>2]=b;c[e>>2]=(c[e>>2]|0)+1;j=0;i=d;return j|0}e=c[a+4>>2]|0;if((h|0)>=(e|0)){j=12;i=d;return j|0}f=(c[a+8>>2]|0)+h|0;h=(f|0)>(e|0)?e:f;f=a+16|0;e=Zpb(c[f>>2]|0,h<<2)|0;if((e|0)==0){j=12;i=d;return j|0}else{c[g>>2]=h;c[f>>2]=e;kpb(a,b)|0;i=d;return 0}return 0}function lpb(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;l=i;m=d+12|0;n=c[m>>2]|0;kpb(d,e)|0;e=kpb(d,0)|0;a:do{if((e|0)==0){o=d+16|0;p=(f&1|0)==0;q=(f&2|0)==0;r=1;s=0;t=j;b:while(1){u=c[m>>2]|0;if((u|0)<=(n|0)){v=s;w=0;break a}x=u+ -1|0;c[m>>2]=x;y=c[o>>2]|0;z=c[y+(x<<2)>>2]|0;if((z|0)==1){x=u+ -2|0;c[m>>2]=x;A=s;B=r;t=c[y+(x<<2)>>2]|0;s=A;r=B;continue}else if((z|0)!=0){C=t;A=s;B=r;t=C;s=A;r=B;continue}z=u+ -2|0;c[m>>2]=z;u=c[y+(z<<2)>>2]|0;z=c[u>>2]|0;do{if((z|0)==0){y=c[u+4>>2]|0;x=c[y+8>>2]|0;D=c[y>>2]|0;E=c[y+4>>2]|0;do{if((D|0)>-1|(D|0)==-4){F=r;G=E;H=D;I=s+1|0;J=(c[g>>2]|0)+x|0}else{if(!((D|0)==-3)){F=r;G=E;H=D;I=s;J=x;break}if(!p){F=r;G=-1;H=-1;I=s;J=-1;break}if(q|(r|0)==0){F=r;G=E;H=-3;I=s;J=x;break}c[h+(E<<2)>>2]=1;F=0;G=E;H=-3;I=s;J=x}}while(0);x=upb(b,0,0,1,32)|0;E=x;do{if((x|0)==0){K=0}else{D=upb(b,0,0,1,20)|0;c[x+4>>2]=D;if((D|0)==0){K=0;break}c[x>>2]=0;c[x+8>>2]=-1;c[x+12>>2]=-1;c[D>>2]=H;c[D+4>>2]=G;c[D+8>>2]=J;K=E}}while(0);c[t>>2]=K;E=(K|0)==0?12:0;if((J|0)<=(c[k>>2]|0)){L=F;M=I;N=t;O=E;break}c[k>>2]=J;L=F;M=I;N=t;O=E}else if((z|0)==2){E=c[u+4>>2]|0;x=kpb(d,c[E>>2]|0)|0;if((x|0)!=0){v=s;w=x;break a}x=kpb(d,0)|0;if((x|0)!=0){v=s;w=x;break a}x=c[E>>2]|0;D=c[E+4>>2]|0;y=c[E+8>>2]|0;P=a[E+12|0]|0;E=upb(b,0,0,1,32)|0;if((E|0)==0){Q=40;break b}R=upb(b,0,0,1,16)|0;S=E+4|0;c[S>>2]=R;if((R|0)==0){Q=40;break b}c[E>>2]=2;c[E+8>>2]=-1;c[E+12>>2]=-1;c[R>>2]=x;c[R+4>>2]=D;c[R+8>>2]=y;y=R+12|0;a[y]=a[y]&-2|P&1;c[E+16>>2]=c[x+16>>2];c[t>>2]=E;A=s;B=r;t=c[S>>2]|0;s=A;r=B;continue b}else if((z|0)==1){S=c[u+4>>2]|0;E=c[S>>2]|0;x=S+4|0;P=c[x>>2]|0;y=upb(b,0,0,1,32)|0;if((y|0)==0){Q=29;break b}R=upb(b,0,0,1,8)|0;D=y+4|0;c[D>>2]=R;if((R|0)==0){Q=29;break b}c[y>>2]=1;c[y+8>>2]=-1;c[y+12>>2]=-1;c[R>>2]=E;c[(c[D>>2]|0)+4>>2]=P;c[y+16>>2]=(c[P+16>>2]|0)+(c[E+16>>2]|0);c[t>>2]=y;y=c[D>>2]|0;c[y>>2]=0;D=y+4|0;c[D>>2]=0;E=kpb(d,c[x>>2]|0)|0;if((E|0)!=0){v=s;w=E;break a}E=kpb(d,0)|0;if((E|0)!=0){v=s;w=E;break a}E=kpb(d,D)|0;if((E|0)!=0){v=s;w=E;break a}E=kpb(d,1)|0;if((E|0)!=0){v=s;w=E;break a}E=kpb(d,c[S>>2]|0)|0;if((E|0)!=0){v=s;w=E;break a}L=r;M=s;N=y;O=kpb(d,0)|0}else if((z|0)==3){y=c[u+4>>2]|0;E=c[y>>2]|0;S=y+4|0;D=c[S>>2]|0;x=upb(b,0,0,1,32)|0;if((x|0)==0){Q=20;break b}P=upb(b,0,0,1,8)|0;R=x+4|0;c[R>>2]=P;if((P|0)==0){Q=20;break b}c[x>>2]=3;c[x+8>>2]=-1;c[x+12>>2]=-1;c[P>>2]=E;c[(c[R>>2]|0)+4>>2]=D;c[x+16>>2]=(c[D+16>>2]|0)+(c[E+16>>2]|0);c[t>>2]=x;x=c[R>>2]|0;R=kpb(d,c[S>>2]|0)|0;if((R|0)!=0){v=s;w=R;break a}R=kpb(d,0)|0;if((R|0)!=0){v=s;w=R;break a}R=kpb(d,x+4|0)|0;if((R|0)!=0){v=s;w=R;break a}R=kpb(d,1)|0;if((R|0)!=0){v=s;w=R;break a}R=kpb(d,c[y>>2]|0)|0;if((R|0)!=0){v=s;w=R;break a}L=r;M=s;N=x;O=kpb(d,0)|0}else{C=t;A=s;B=r;t=C;s=A;r=B;continue b}}while(0);if((O|0)==0){r=L;s=M;t=N}else{v=M;w=O;break a}}if((Q|0)==20){c[t>>2]=0;v=s;w=12;break}else if((Q|0)==29){c[t>>2]=0;v=s;w=12;break}else if((Q|0)==40){c[t>>2]=0;v=s;w=12;break}}else{v=0;w=e}}while(0);c[g>>2]=(c[g>>2]|0)+v;i=l;return w|0}function mpb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=upb(a,0,0,0,8)|0;if((f|0)==0){g=12;i=e;return g|0}h=upb(a,0,0,1,32)|0;j=h;do{if((h|0)!=0){k=upb(a,0,0,1,20)|0;c[h+4>>2]=k;if((k|0)==0){break}c[h>>2]=0;c[h+8>>2]=-1;c[h+12>>2]=-1;c[k>>2]=-3;c[k+4>>2]=d;c[k+8>>2]=-1;c[f>>2]=j;k=upb(a,0,0,0,32)|0;l=f+4|0;c[l>>2]=k;if((k|0)==0){g=12;i=e;return g|0}m=b+4|0;c[k+4>>2]=c[m>>2];k=b;c[c[l>>2]>>2]=c[k>>2];n=c[l>>2]|0;c[n+8>>2]=-1;c[n+12>>2]=-1;c[n+24>>2]=0;c[(c[l>>2]|0)+28>>2]=0;c[(c[l>>2]|0)+20>>2]=0;c[m>>2]=f;c[k>>2]=1;g=0;i=e;return g|0}}while(0);c[f>>2]=0;g=12;i=e;return g|0}function npb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=upb(a,0,0,0,8)|0;if((f|0)==0){g=12;i=e;return g|0}h=upb(a,0,0,1,32)|0;j=h;do{if((h|0)!=0){k=upb(a,0,0,1,20)|0;c[h+4>>2]=k;if((k|0)==0){break}c[h>>2]=0;c[h+8>>2]=-1;c[h+12>>2]=-1;c[k>>2]=-3;c[k+4>>2]=d;c[k+8>>2]=-1;c[f+4>>2]=j;k=upb(a,0,0,0,32)|0;c[f>>2]=k;if((k|0)==0){g=12;i=e;return g|0}l=b+4|0;c[k+4>>2]=c[l>>2];k=b;c[c[f>>2]>>2]=c[k>>2];m=c[f>>2]|0;c[m+8>>2]=-1;c[m+12>>2]=-1;c[m+24>>2]=0;c[(c[f>>2]|0)+28>>2]=0;c[(c[f>>2]|0)+20>>2]=0;c[l>>2]=f;c[k>>2]=1;g=0;i=e;return g|0}}while(0);c[f+4>>2]=0;g=12;i=e;return g|0}function opb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[c[(c[a>>2]|0)+4>>2]>>2]|0;a=c[c[(c[b>>2]|0)+4>>2]>>2]|0;if((e|0)<(a|0)){f=-1;i=d;return f|0}f=(e|0)>(a|0)|0;i=d;return f|0}function ppb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;g=d;a:do{if((b|0)==0){h=329312}else{j=b;k=329312;while(1){if((a[k]|0)==0){h=k;break a}l=j+ -1|0;m=k+((yqb(k|0)|0)+1)|0;if((l|0)==0){h=m;break}else{j=l;k=m}}}}while(0);c[g>>2]=(a[h]|0)==0?h+1|0:h;h=(Pc(e|0,f|0,329600,g|0)|0)+1|0;i=d;return h|0}function qpb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0;g=i;i=i+16|0;h=g;j=g+8|0;k=c[a+4>>2]|0;a=k;l=k+40|0;m=c[l>>2]|0;do{if((m|0)<1|(d|0)==0){n=0}else{o=Wpb(m<<2)|0;if((o|0)==0){p=12}else{n=o;break}i=g;return p|0}}while(0);m=n;a:do{if((c[k+60>>2]|0)==0){c[h>>2]=0;o=f&1;q=f&2;r=k+56|0;s=c[r>>2]&4;if((n|0)==0){t=0}else{t=c[l>>2]|0}u=t<<2;v=c[k+52>>2]|0;w=v<<3;x=w+8|0;y=u+12+w+(x+(fa(u,v)|0)<<1)|0;z=Wpb(y)|0;if((z|0)==0){A=12;break}Cqb(z|0,0,y|0)|0;y=z;B=z+u&3;C=((B|0)==0?0:4-B|0)+u|0;B=z+C|0;D=B;E=C+x|0;C=z+E&3;F=((C|0)==0?0:4-C|0)+E|0;E=z+F|0;C=E;G=F+x|0;x=z+G&3;F=((x|0)==0?0:4-x|0)+G|0;G=z+F|0;x=F+w|0;w=z+x&3;if((v|0)>0){F=t<<3;H=0;I=z+(((w|0)==0?0:4-w|0)+x)|0;while(1){c[E+(H<<3)+4>>2]=I;c[B+(H<<3)+4>>2]=I+u;x=H+1|0;if((x|0)<(v|0)){I=I+F|0;H=x}else{J=0;break}}do{c[G+(J<<3)>>2]=-1;J=J+1|0;}while((J|0)<(v|0))}v=_ob(h,b,4)|0;if((v|0)<1){if((v|0)<0){A=1;break}K=v+1|0}else{K=v}v=k+8|0;H=(s|0)==0;F=(o|0)==0;I=(t|0)>0;B=k+12|0;E=k+44|0;x=k+32|0;w=k+36|0;L=(t|0)==0;M=I^1;N=-1;O=0;P=0;Q=K;R=0;S=C;T=D;U=D;V=b+K|0;W=y;while(1){if((N|0)<0){X=c[v>>2]|0;Y=X+8|0;b:do{if((c[Y>>2]|0)==0){Z=N;_=O;$=U}else{aa=(P|0)==0;ba=(R|0)==95;ca=(P|0)<1&F;da=((R|0)!=10|H)^1;ea=Y;ga=N;ha=O;ia=U;ja=X;while(1){ka=ea;la=ja;c:while(1){ma=la+12|0;if((c[G+(c[ma>>2]<<3)>>2]|0)>=(P|0)){na=ga;oa=ha;pa=ia;break}qa=la+20|0;ra=c[qa>>2]|0;if((ra|0)==0){sa=260;break}d:do{if((ra&1|0)==0|ca|da){if((ra&2|0)!=0){ta=c[h>>2]|0;if((ta|q|0)!=0&((ta|0)!=10|H)){break}}do{if((ra&16|0)!=0){if(ba){break d}if((Fob(R)|0)!=0){break d}ta=c[h>>2]|0;if((ta|0)==95){break}if((Fob(ta)|0)==0){break d}}}while(0);ta=c[qa>>2]|0;if((ta&32|0)==0){ua=ta}else{if(!ba){if((Fob(R)|0)==0){break}}ta=c[h>>2]|0;if((ta|0)==95){break}if((Fob(ta)|0)!=0){break}ua=c[qa>>2]|0}do{if((ua&64|0)==0|aa){va=ua}else{ta=c[h>>2]|0;if((ta|0)==0){va=ua;break}if(ba){wa=ta;xa=1}else{ta=(Fob(R)|0)!=0|0;wa=c[h>>2]|0;xa=ta}if((wa|0)==95){ya=1}else{ya=(Fob(wa)|0)!=0|0}if((xa|0)==(ya|0)){break d}va=c[qa>>2]|0}}while(0);if((va&128|0)==0){sa=260;break c}if(aa){break}ta=c[h>>2]|0;if((ta|0)==0){break}if(ba){za=ta;Aa=1}else{ta=(Fob(R)|0)!=0|0;za=c[h>>2]|0;Aa=ta}if((za|0)==95){Ba=1}else{Ba=(Fob(za)|0)!=0|0}if((Aa|0)==(Ba|0)){sa=260;break c}}}while(0);qa=la+40|0;if((c[qa>>2]|0)==0){Z=ga;_=ha;$=ia;break b}else{ka=qa;la=la+32|0}}if((sa|0)==260){sa=0;qa=ia;c[qa>>2]=c[ka>>2];if(I){Cqb(c[ia+4>>2]|0,-1,u|0)|0}ra=c[la+16>>2]|0;do{if((ra|0)!=0){ta=c[ra>>2]|0;if(!((ta|0)>-1)){break}Ca=ia+4|0;Da=ta;ta=ra;do{if((Da|0)<(t|0)){c[(c[Ca>>2]|0)+(Da<<2)>>2]=P}ta=ta+4|0;Da=c[ta>>2]|0;}while((Da|0)>-1)}}while(0);ra=(c[qa>>2]|0)!=(c[B>>2]|0);if(ra|M){Ea=ia+4|0;Fa=ra?ga:P;Ga=ra?ha:1}else{ra=ia+4|0;ka=c[ra>>2]|0;Da=0;while(1){c[n+(Da<<2)>>2]=c[ka+(Da<<2)>>2];ta=Da+1|0;if((ta|0)<(t|0)){Da=ta}else{Ea=ra;Fa=P;Ga=1;break}}}c[G+(c[ma>>2]<<3)>>2]=P;c[G+(c[ma>>2]<<3)+4>>2]=Ea;na=Fa;oa=Ga;pa=ia+8|0}ra=la+40|0;if((c[ra>>2]|0)==0){Z=na;_=oa;$=pa;break}else{ea=ra;ga=na;ha=oa;ia=pa;ja=la+32|0}}}}while(0);c[$>>2]=0;Ha=Z;Ia=_}else{if(L|(U|0)==(T|0)){Ja=N;break}else{Ha=N;Ia=O}}X=c[h>>2]|0;if((X|0)==0){Ja=Ha;break}Y=P+Q|0;ja=_ob(h,V,4)|0;if((ja|0)<1){if((ja|0)<0){A=1;break a}Ka=ja+1|0}else{Ka=ja}ja=V+Ka|0;if((c[E>>2]|0)==0|(Ia|0)==0){La=Ia;Ma=T;Na=S}else{ia=T;ha=c[ia>>2]|0;if((ha|0)==0){Oa=S}else{ga=ha;ha=ia;ia=S;while(1){ea=c[w>>2]|0;ba=c[ea>>2]|0;aa=ha+4|0;e:do{if((ba|0)>-1){da=ba;ca=0;while(1){ra=c[ea+((ca|1)<<2)>>2]|0;if((da|0)>=(t|0)){Pa=ia;break e}Da=c[aa>>2]|0;if((c[Da+(ra<<2)>>2]|0)==(c[n+(ra<<2)>>2]|0)){if((c[Da+(da<<2)>>2]|0)<(c[n+(da<<2)>>2]|0)){Pa=ia;break e}}Da=ca+2|0;ra=c[ea+(Da<<2)>>2]|0;if((ra|0)>-1){da=ra;ca=Da}else{sa=287;break}}}else{sa=287}}while(0);if((sa|0)==287){sa=0;c[ia>>2]=ga;ea=ia+4|0;ba=c[ea>>2]|0;c[ea>>2]=c[aa>>2];c[aa>>2]=ba;Pa=ia+8|0}ba=ha+8|0;ea=c[ba>>2]|0;if((ea|0)==0){Oa=Pa;break}else{ga=ea;ha=ba;ia=Pa}}}c[Oa>>2]=0;La=0;Ma=S;Na=T}ia=c[Ma>>2]|0;if((ia|0)==0){Qa=Ha;Ra=La;Sa=Na;Ta=W}else{ha=(Y|0)==0;ga=(X|0)==95;ba=(Y|0)<1&F;ea=((X|0)!=10|H)^1;ca=ia;ia=Ha;da=La;la=Ma;Da=Na;ra=W;while(1){ka=ca+8|0;if((c[ka>>2]|0)==0){Ua=ia;Va=da;Wa=Da;Xa=ra}else{qa=la+4|0;ta=ka;ka=ia;Ca=da;Ya=Da;Za=ra;_a=ca;while(1){f:do{if((c[_a>>2]|0)>>>0>X>>>0){$a=ka;ab=Ca;bb=Ya;cb=Za}else{if((c[_a+4>>2]|0)>>>0<X>>>0){$a=ka;ab=Ca;bb=Ya;cb=Za;break}db=_a+20|0;eb=c[db>>2]|0;g:do{if((eb|0)!=0){if(!((eb&1|0)==0|ba|ea)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((eb&2|0)!=0){fb=c[h>>2]|0;if((fb|q|0)!=0&((fb|0)!=10|H)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}do{if((eb&16|0)!=0){if(ga){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((Fob(X)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}fb=c[h>>2]|0;if((fb|0)==95){break}if((Fob(fb)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}}while(0);fb=c[db>>2]|0;if((fb&32|0)==0){gb=fb}else{if(!ga){if((Fob(X)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}fb=c[h>>2]|0;if((fb|0)==95){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((Fob(fb)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}gb=c[db>>2]|0}do{if((gb&64|0)==0|ha){hb=gb}else{fb=c[h>>2]|0;if((fb|0)==0){hb=gb;break}if(ga){ib=fb;jb=1}else{fb=(Fob(X)|0)!=0|0;ib=c[h>>2]|0;jb=fb}if((ib|0)==95){kb=1}else{kb=(Fob(ib)|0)!=0|0}if((jb|0)==(kb|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}hb=c[db>>2]|0}}while(0);if((hb&128|0)==0){lb=hb}else{if(ha){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}fb=c[h>>2]|0;if((fb|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if(ga){mb=fb;nb=1}else{fb=(Fob(X)|0)!=0|0;mb=c[h>>2]|0;nb=fb}if((mb|0)==95){ob=1}else{ob=(Fob(mb)|0)!=0|0}if((nb|0)!=(ob|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}lb=c[db>>2]|0}do{if((lb&4|0)==0){pb=lb}else{if((c[r>>2]&2|0)!=0){pb=lb;break}if((Job(X,c[_a+24>>2]|0)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}pb=c[db>>2]|0}}while(0);do{if((pb&4|0)!=0){if((c[r>>2]&2|0)==0){break}fb=Vob(X)|0;qb=_a+24|0;if((Job(fb,c[qb>>2]|0)|0)!=0){break}fb=Tob(X)|0;if((Job(fb,c[qb>>2]|0)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}}while(0);if((c[db>>2]&8|0)==0){break}qb=c[_a+28>>2]|0;fb=c[qb>>2]|0;if((fb|0)==0){break}if((c[r>>2]&2|0)==0){rb=qb;sb=fb;while(1){if((Job(X,sb)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}rb=rb+4|0;sb=c[rb>>2]|0;if((sb|0)==0){break g}}}else{tb=qb}do{sb=Tob(X)|0;if((Job(sb,c[tb>>2]|0)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}sb=Vob(X)|0;if((Job(sb,c[tb>>2]|0)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}tb=tb+4|0;}while((c[tb>>2]|0)!=0)}}while(0);if(I){db=c[qa>>2]|0;eb=0;do{c[Za+(eb<<2)>>2]=c[db+(eb<<2)>>2];eb=eb+1|0;}while((eb|0)<(t|0))}eb=c[_a+16>>2]|0;do{if((eb|0)!=0){db=c[eb>>2]|0;if((db|0)>-1){ub=db;vb=eb}else{break}do{if((ub|0)<(t|0)){c[Za+(ub<<2)>>2]=Y}vb=vb+4|0;ub=c[vb>>2]|0;}while((ub|0)>-1)}}while(0);eb=_a+12|0;db=c[eb>>2]|0;qb=G+(db<<3)|0;if((c[qb>>2]|0)<(Y|0)){sb=Ya;c[sb>>2]=c[ta>>2];rb=Ya+4|0;fb=c[rb>>2]|0;c[rb>>2]=Za;c[qb>>2]=Y;c[G+(c[eb>>2]<<3)+4>>2]=rb;do{if((c[sb>>2]|0)==(c[B>>2]|0)){if((ka|0)==-1){if(!I){wb=Y;xb=1;break}yb=c[rb>>2]|0}else{if(!I){wb=ka;xb=Ca;break}eb=c[rb>>2]|0;if((c[eb>>2]|0)>(c[n>>2]|0)){wb=ka;xb=Ca;break}else{yb=eb}}eb=0;while(1){c[n+(eb<<2)>>2]=c[yb+(eb<<2)>>2];qb=eb+1|0;if((qb|0)<(t|0)){eb=qb}else{wb=Y;xb=1;break}}}else{wb=ka;xb=Ca}}while(0);$a=wb;ab=xb;bb=Ya+8|0;cb=fb;break}else{rb=c[x>>2]|0;sb=c[G+(db<<3)+4>>2]|0;eb=c[sb>>2]|0;if(I){zb=0}else{$a=ka;ab=Ca;bb=Ya;cb=Za;break}while(1){qb=c[Za+(zb<<2)>>2]|0;Ab=c[eb+(zb<<2)>>2]|0;if((c[rb+(zb<<2)>>2]|0)==0){if((qb|0)<(Ab|0)){break}if((qb|0)>(Ab|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}else{if((qb|0)>(Ab|0)){break}if((qb|0)<(Ab|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}Ab=zb+1|0;if((Ab|0)<(t|0)){zb=Ab}else{$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}c[sb>>2]=Za;if((c[ta>>2]|0)==(c[B>>2]|0)){Bb=0}else{$a=ka;ab=Ca;bb=Ya;cb=eb;break}while(1){c[n+(Bb<<2)>>2]=c[Za+(Bb<<2)>>2];rb=Bb+1|0;if((rb|0)<(t|0)){Bb=rb}else{$a=Y;ab=1;bb=Ya;cb=eb;break}}}}}while(0);eb=_a+40|0;if((c[eb>>2]|0)==0){Ua=$a;Va=ab;Wa=bb;Xa=cb;break}else{ta=eb;ka=$a;Ca=ab;Ya=bb;Za=cb;_a=_a+32|0}}}_a=la+8|0;Za=c[_a>>2]|0;if((Za|0)==0){Qa=Ua;Ra=Va;Sa=Wa;Ta=Xa;break}else{ca=Za;ia=Ua;da=Va;la=_a;Da=Wa;ra=Xa}}}c[Sa>>2]=0;N=Qa;O=Ra;P=Y;Q=Ka;R=X;S=Ma;T=Na;U=Sa;V=ja;W=Ta}Xpb(z);Cb=Ja;Db=Ja>>>31;sa=375}else{c[j>>2]=0;W=f&1;V=f&2;U=k+56|0;T=c[U>>2]&4;S=spb(0,0)|0;if((S|0)==0){A=12;break}R=upb(S,0,0,0,32)|0;Q=R;if((R|0)==0){tpb(S);A=12;break}c[R+24>>2]=0;c[R+28>>2]=0;R=c[l>>2]|0;if((R|0)==0){Eb=0;sa=9}else{P=Wpb(R<<2)|0;O=P;if((P|0)==0){Fb=0;Gb=0;Hb=12;Ib=0;Jb=O}else{Eb=O;sa=9}}do{if((sa|0)==9){O=Eb;P=c[k+28>>2]|0;if((P|0)==0){Kb=0}else{N=Wpb(P<<3)|0;P=N;if((N|0)==0){Fb=0;Gb=P;Hb=12;Ib=0;Jb=Eb;break}else{Kb=P}}P=k+52|0;N=c[P>>2]|0;if((N|0)==0){Lb=0}else{B=Wpb(N<<2)|0;N=B;if((B|0)==0){Fb=0;Gb=Kb;Hb=12;Ib=N;Jb=Eb;break}else{Lb=N}}N=Lb;B=(n|0)==0;I=k+8|0;G=k+12|0;x=k+32|0;r=(T|0)==0;H=(W|0)==0;q=R;F=-1;w=1;E=-1;L=Q;M=b;h:while(1){do{if((q|0)>0){if(B){Cqb(O|0,-1,q<<2|0)|0;break}else{u=0;do{c[Eb+(u<<2)>>2]=-1;c[n+(u<<2)>>2]=-1;u=u+1|0;}while((u|0)<(c[l>>2]|0))}}}while(0);u=c[P>>2]|0;if((u|0)>0){Cqb(N|0,0,u<<2|0)|0}u=c[j>>2]|0;v=w+E|0;y=_ob(j,M,4)|0;if((y|0)<1){if((y|0)<0){A=1;break a}Mb=y+1|0}else{Mb=y}y=M+Mb|0;D=c[j>>2]|0;C=c[I>>2]|0;o=C+8|0;if((c[o>>2]|0)==0){Nb=F;Ob=0;Pb=Mb;Qb=L;sa=196}else{s=(v|0)==0;ra=(u|0)==95;Da=(v|0)<1&H;la=((u|0)!=10|r)^1;da=o;o=0;ia=L;ca=0;ga=C;while(1){C=ga+20|0;ha=c[C>>2]|0;i:do{if((ha|0)==0){sa=56}else{if(!((ha&1|0)==0|Da|la)){Rb=o;Sb=ia;Tb=ca;break}if((ha&2|0)!=0){ea=c[j>>2]|0;if((ea|V|0)!=0&((ea|0)!=10|r)){Rb=o;Sb=ia;Tb=ca;break}}do{if((ha&16|0)!=0){if(ra){Rb=o;Sb=ia;Tb=ca;break i}if((Fob(u)|0)!=0){Rb=o;Sb=ia;Tb=ca;break i}ea=c[j>>2]|0;if((ea|0)==95){break}if((Fob(ea)|0)==0){Rb=o;Sb=ia;Tb=ca;break i}}}while(0);ea=c[C>>2]|0;if((ea&32|0)==0){Ub=ea}else{if(!ra){if((Fob(u)|0)==0){Rb=o;Sb=ia;Tb=ca;break}}ea=c[j>>2]|0;if((ea|0)==95){Rb=o;Sb=ia;Tb=ca;break}if((Fob(ea)|0)!=0){Rb=o;Sb=ia;Tb=ca;break}Ub=c[C>>2]|0}do{if((Ub&64|0)==0|s){Vb=Ub}else{ea=c[j>>2]|0;if((ea|0)==0){Vb=Ub;break}if(ra){Wb=ea;Xb=1}else{ea=(Fob(u)|0)!=0|0;Wb=c[j>>2]|0;Xb=ea}if((Wb|0)==95){Yb=1}else{Yb=(Fob(Wb)|0)!=0|0}if((Xb|0)==(Yb|0)){Rb=o;Sb=ia;Tb=ca;break i}Vb=c[C>>2]|0}}while(0);if((Vb&128|0)==0){sa=56;break}if(s){Rb=o;Sb=ia;Tb=ca;break}ea=c[j>>2]|0;if((ea|0)==0){Rb=o;Sb=ia;Tb=ca;break}if(ra){Zb=ea;_b=1}else{ea=(Fob(u)|0)!=0|0;Zb=c[j>>2]|0;_b=ea}if((Zb|0)==95){$b=1}else{$b=(Fob(Zb)|0)!=0|0}if((_b|0)==($b|0)){sa=56}else{Rb=o;Sb=ia;Tb=ca}}}while(0);do{if((sa|0)==56){sa=0;if((ca|0)==0){Rb=c[ga+16>>2]|0;Sb=ia;Tb=c[da>>2]|0;break}C=ia+28|0;ha=c[C>>2]|0;if((ha|0)==0){ea=upb(S,0,0,0,32)|0;ba=ea;if((ea|0)==0){sa=60;break h}c[ea+24>>2]=ia;c[ea+28>>2]=0;_a=upb(S,0,0,0,c[l>>2]<<2)|0;c[ea+20>>2]=_a;if((_a|0)==0){sa=67;break h}c[C>>2]=ba;ac=ba}else{ac=ha}c[ac>>2]=v;c[ac+4>>2]=y;c[ac+8>>2]=c[da>>2];c[ac+12>>2]=c[ga+12>>2];c[ac+16>>2]=c[j>>2];if((c[l>>2]|0)>0){ha=c[ac+20>>2]|0;ba=0;do{c[ha+(ba<<2)>>2]=c[Eb+(ba<<2)>>2];ba=ba+1|0;}while((ba|0)<(c[l>>2]|0))}ba=c[ga+16>>2]|0;if((ba|0)==0){Rb=o;Sb=ac;Tb=ca;break}ha=c[ba>>2]|0;if(!((ha|0)>-1)){Rb=o;Sb=ac;Tb=ca;break}C=c[ac+20>>2]|0;_a=ha;ha=ba;while(1){ba=ha+4|0;c[C+(_a<<2)>>2]=v;ea=c[ba>>2]|0;if((ea|0)>-1){ha=ba;_a=ea}else{Rb=o;Sb=ac;Tb=ca;break}}}}while(0);_a=ga+40|0;if((c[_a>>2]|0)==0){break}else{da=_a;o=Rb;ia=Sb;ca=Tb;ga=ga+32|0}}do{if((Rb|0)==0){bc=0}else{ga=c[Rb>>2]|0;if((ga|0)>-1){cc=ga;dc=Rb}else{bc=Rb;break}while(1){c[Eb+(cc<<2)>>2]=v;ga=dc+4|0;ca=c[ga>>2]|0;if((ca|0)>-1){dc=ga;cc=ca}else{bc=ga;break}}}}while(0);if((Tb|0)==0){Nb=F;Ob=bc;Pb=Mb;Qb=Sb;sa=196}else{ec=F;fc=bc;gc=v;hc=Mb;ic=Sb;jc=Tb;kc=y}}j:while(1){if((sa|0)==196){sa=0;ga=c[Qb+24>>2]|0;if((ga|0)==0){break}ca=c[Qb+8>>2]|0;if((c[ca+20>>2]&256|0)!=0){c[Lb+(c[Qb+12>>2]<<2)>>2]=0}ia=c[Qb>>2]|0;o=c[Qb+4>>2]|0;c[j>>2]=c[Qb+16>>2];da=c[l>>2]|0;if((da|0)<=0){ec=Nb;fc=Ob;gc=ia;hc=Pb;ic=ga;jc=ca;kc=o;continue}u=c[Qb+20>>2]|0;ra=0;while(1){c[Eb+(ra<<2)>>2]=c[u+(ra<<2)>>2];s=ra+1|0;if((s|0)<(da|0)){ra=s}else{ec=Nb;fc=Ob;gc=ia;hc=Pb;ic=ga;jc=ca;kc=o;continue j}}}if((jc|0)==(c[G>>2]|0)){lc=fc;mc=gc;nc=hc;oc=ic}else{o=fc;ca=gc;ga=hc;ia=ic;ra=jc;da=kc;while(1){u=ra+8|0;do{if((c[u>>2]|0)==0){sa=109}else{if((c[ra+20>>2]&256|0)==0){sa=109;break}s=c[ra+24>>2]|0;rpb(s+1|0,Kb,c[U>>2]&-9,a,Eb,ca);la=c[Kb+(s<<3)>>2]|0;Da=c[Kb+(s<<3)+4>>2]|0;s=Da-la|0;if((vqb(b+la|0,da+ -1|0,s)|0)!=0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}_a=(Da|0)==(la|0);la=_a&1;Da=Lb+(c[ra+12>>2]<<2)|0;if(_a){if((c[Da>>2]|0)!=0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}}c[Da>>2]=la;la=s+ -1|0;s=la+ca|0;Da=c[j>>2]|0;_a=_ob(j,da+la|0,4)|0;if((_a|0)<1){if((_a|0)<0){A=1;break a}pc=_a+1|0}else{pc=_a}qc=s;rc=pc+la|0;sc=pc;tc=Da}}while(0);do{if((sa|0)==109){sa=0;Da=c[j>>2]|0;if((Da|0)==0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}la=_ob(j,da,4)|0;if((la|0)>=1){qc=ca;rc=la;sc=la;tc=Da;break}if((la|0)<0){A=1;break a}s=la+1|0;qc=ca;rc=s;sc=s;tc=Da}}while(0);Da=da+rc|0;s=qc+ga|0;if((c[u>>2]|0)==0){Nb=ec;Ob=o;Pb=sc;Qb=ia;sa=196;continue j}la=(s|0)==0;_a=(tc|0)==95;ha=(s|0)<1&H;C=((tc|0)!=10|r)^1;ea=u;ba=0;Za=o;Ya=ia;Ca=ra;while(1){k:do{if((c[Ca>>2]|0)>>>0>tc>>>0){uc=ba;vc=Za;wc=Ya}else{if((c[Ca+4>>2]|0)>>>0<tc>>>0){uc=ba;vc=Za;wc=Ya;break}ka=Ca+20|0;ta=c[ka>>2]|0;l:do{if((ta|0)!=0){if(!((ta&1|0)==0|ha|C)){uc=ba;vc=Za;wc=Ya;break k}if((ta&2|0)!=0){qa=c[j>>2]|0;if((qa|V|0)!=0&((qa|0)!=10|r)){uc=ba;vc=Za;wc=Ya;break k}}do{if((ta&16|0)!=0){if(_a){uc=ba;vc=Za;wc=Ya;break k}if((Fob(tc)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}qa=c[j>>2]|0;if((qa|0)==95){break}if((Fob(qa)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}}while(0);qa=c[ka>>2]|0;if((qa&32|0)==0){xc=qa}else{if(!_a){if((Fob(tc)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}qa=c[j>>2]|0;if((qa|0)==95){uc=ba;vc=Za;wc=Ya;break k}if((Fob(qa)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}xc=c[ka>>2]|0}do{if((xc&64|0)==0|la){yc=xc}else{qa=c[j>>2]|0;if((qa|0)==0){yc=xc;break}if(_a){zc=qa;Ac=1}else{qa=(Fob(tc)|0)!=0|0;zc=c[j>>2]|0;Ac=qa}if((zc|0)==95){Bc=1}else{Bc=(Fob(zc)|0)!=0|0}if((Ac|0)==(Bc|0)){uc=ba;vc=Za;wc=Ya;break k}yc=c[ka>>2]|0}}while(0);if((yc&128|0)==0){Cc=yc}else{if(la){uc=ba;vc=Za;wc=Ya;break k}qa=c[j>>2]|0;if((qa|0)==0){uc=ba;vc=Za;wc=Ya;break k}if(_a){Dc=qa;Ec=1}else{qa=(Fob(tc)|0)!=0|0;Dc=c[j>>2]|0;Ec=qa}if((Dc|0)==95){Fc=1}else{Fc=(Fob(Dc)|0)!=0|0}if((Ec|0)!=(Fc|0)){uc=ba;vc=Za;wc=Ya;break k}Cc=c[ka>>2]|0}do{if((Cc&4|0)==0){Gc=Cc}else{if((c[U>>2]&2|0)!=0){Gc=Cc;break}if((Job(tc,c[Ca+24>>2]|0)|0)==0){uc=ba;vc=Za;wc=Ya;break k}Gc=c[ka>>2]|0}}while(0);do{if((Gc&4|0)!=0){if((c[U>>2]&2|0)==0){break}qa=Vob(tc)|0;aa=Ca+24|0;if((Job(qa,c[aa>>2]|0)|0)!=0){break}qa=Tob(tc)|0;if((Job(qa,c[aa>>2]|0)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}}while(0);if((c[ka>>2]&8|0)==0){break}aa=c[Ca+28>>2]|0;qa=c[aa>>2]|0;if((qa|0)==0){break}if((c[U>>2]&2|0)==0){eb=aa;sb=qa;while(1){if((Job(tc,sb)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}eb=eb+4|0;sb=c[eb>>2]|0;if((sb|0)==0){break l}}}else{Hc=aa}do{sb=Tob(tc)|0;if((Job(sb,c[Hc>>2]|0)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}sb=Vob(tc)|0;if((Job(sb,c[Hc>>2]|0)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}Hc=Hc+4|0;}while((c[Hc>>2]|0)!=0)}}while(0);if((ba|0)==0){uc=c[ea>>2]|0;vc=c[Ca+16>>2]|0;wc=Ya;break}ka=Ya+28|0;ta=c[ka>>2]|0;if((ta|0)==0){aa=upb(S,0,0,0,32)|0;sb=aa;if((aa|0)==0){sa=169;break h}c[aa+24>>2]=Ya;c[aa+28>>2]=0;eb=upb(S,0,0,0,c[l>>2]<<2)|0;c[aa+20>>2]=eb;if((eb|0)==0){sa=176;break h}c[ka>>2]=sb;Ic=sb}else{Ic=ta}c[Ic>>2]=s;c[Ic+4>>2]=Da;c[Ic+8>>2]=c[ea>>2];c[Ic+12>>2]=c[Ca+12>>2];c[Ic+16>>2]=c[j>>2];if((c[l>>2]|0)>0){ta=c[Ic+20>>2]|0;sb=0;do{c[ta+(sb<<2)>>2]=c[Eb+(sb<<2)>>2];sb=sb+1|0;}while((sb|0)<(c[l>>2]|0))}sb=c[Ca+16>>2]|0;if((sb|0)==0){uc=ba;vc=Za;wc=Ic;break}ta=c[sb>>2]|0;if(!((ta|0)>-1)){uc=ba;vc=Za;wc=Ic;break}ka=c[Ic+20>>2]|0;eb=ta;ta=sb;while(1){c[ka+(eb<<2)>>2]=s;sb=ta+4|0;aa=c[sb>>2]|0;if((aa|0)>-1){ta=sb;eb=aa}else{uc=ba;vc=Za;wc=Ic;break}}}}while(0);eb=Ca+40|0;if((c[eb>>2]|0)==0){break}else{ea=eb;ba=uc;Za=vc;Ya=wc;Ca=Ca+32|0}}if((uc|0)==0){Nb=ec;Ob=vc;Pb=sc;Qb=wc;sa=196;continue j}do{if((vc|0)==0){Jc=0}else{Ca=c[vc>>2]|0;if((Ca|0)>-1){Kc=Ca;Lc=vc}else{Jc=vc;break}while(1){Ca=Lc+4|0;c[Eb+(Kc<<2)>>2]=s;Ya=c[Ca>>2]|0;if((Ya|0)>-1){Lc=Ca;Kc=Ya}else{Jc=Ca;break}}}}while(0);if((uc|0)==(c[G>>2]|0)){lc=Jc;mc=s;nc=sc;oc=wc;break}else{o=Jc;ca=s;ga=sc;ia=wc;ra=uc;da=Da}}}m:do{if((ec|0)<(mc|0)){sa=96}else{if((ec|0)!=(mc|0)|B){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}da=c[l>>2]|0;ra=c[x>>2]|0;if((da|0)>0){Mc=0}else{Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}while(1){ia=c[Eb+(Mc<<2)>>2]|0;ga=c[n+(Mc<<2)>>2]|0;if((c[ra+(Mc<<2)>>2]|0)==0){if((ia|0)<(ga|0)){sa=96;break m}if((ia|0)>(ga|0)){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}else{if((ia|0)>(ga|0)){Nc=da;break m}if((ia|0)<(ga|0)){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}ga=Mc+1|0;if((ga|0)<(da|0)){Mc=ga}else{Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}}}while(0);if((sa|0)==96){sa=0;if(B){Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue}Nc=c[l>>2]|0}if((Nc|0)>0){Oc=0}else{Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue}while(1){c[n+(Oc<<2)>>2]=c[Eb+(Oc<<2)>>2];da=Oc+1|0;if((da|0)<(c[l>>2]|0)){Oc=da}else{Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}}if((Nb|0)>=0){sa=205;break}if((c[j>>2]|0)==0){sa=205;break}c[j>>2]=D;q=c[l>>2]|0;F=Nb;w=Pb;E=v;L=Qb;M=y}if((sa|0)==60){tpb(S);if((Eb|0)!=0){Xpb(O)}if((Kb|0)!=0){Xpb(Kb)}if((Lb|0)==0){A=12;break a}Xpb(N);A=12;break a}else if((sa|0)==67){tpb(S);if((Eb|0)!=0){Xpb(O)}if((Kb|0)!=0){Xpb(Kb)}if((Lb|0)==0){A=12;break a}Xpb(N);A=12;break a}else if((sa|0)==169){tpb(S);if((Eb|0)!=0){Xpb(O)}if((Kb|0)!=0){Xpb(Kb)}if((Lb|0)==0){A=12;break a}Xpb(N);A=12;break a}else if((sa|0)==176){tpb(S);if((Eb|0)!=0){Xpb(O)}if((Kb|0)!=0){Xpb(Kb)}if((Lb|0)==0){A=12;break a}Xpb(N);A=12;break a}else if((sa|0)==205){Fb=Nb;Gb=Kb;Hb=Nb>>>31;Ib=Lb;Jb=Eb;break}}}while(0);tpb(S);if((Jb|0)!=0){Xpb(Jb)}if((Gb|0)!=0){Xpb(Gb)}if((Ib|0)==0){Cb=Fb;Db=Hb;sa=375;break}Xpb(Ib);Cb=Fb;Db=Hb;sa=375}}while(0);do{if((sa|0)==375){if((Db|0)!=0){A=Db;break}rpb(d,e,c[k+56>>2]|0,a,n,Cb);A=0}}while(0);if((n|0)==0){p=A;i=g;return p|0}Xpb(m);p=A;i=g;return p|0}function rpb(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;h=i;do{if((g|0)>-1){if((d&8|0)!=0){j=0;break}k=c[e+16>>2]|0;l=e+28|0;m=c[l>>2]|0;n=(a|0)!=0;if((m|0)!=0&n){o=e+48|0;p=0;while(1){q=c[k+(p*12|0)>>2]|0;if((q|0)==(c[o>>2]|0)){c[b+(p<<3)>>2]=g;r=g}else{s=c[f+(q<<2)>>2]|0;c[b+(p<<3)>>2]=s;r=s}s=c[k+(p*12|0)+4>>2]|0;if((s|0)==(c[o>>2]|0)){c[b+(p<<3)+4>>2]=g;t=g}else{q=c[f+(s<<2)>>2]|0;c[b+(p<<3)+4>>2]=q;t=q}if((r|0)==-1|(t|0)==-1){c[b+(p<<3)+4>>2]=-1;c[b+(p<<3)>>2]=-1}q=p+1|0;s=c[l>>2]|0;if(q>>>0<s>>>0&q>>>0<a>>>0){p=q}else{u=s;break}}}else{u=m}if((u|0)!=0&n){v=u;w=0}else{j=0;break}while(1){p=b+(w<<3)+4|0;o=c[k+(w*12|0)+8>>2]|0;do{if((o|0)==0){x=v}else{s=c[o>>2]|0;if(!((s|0)>-1)){x=v;break}q=b+(w<<3)|0;y=c[q>>2]|0;z=s;s=0;while(1){if((y|0)<(c[b+(z<<3)>>2]|0)){A=21}else{if((c[p>>2]|0)>(c[b+(z<<3)+4>>2]|0)){A=21}else{B=y}}if((A|0)==21){A=0;c[p>>2]=-1;c[q>>2]=-1;B=-1}C=s+1|0;D=c[o+(C<<2)>>2]|0;if((D|0)>-1){y=B;z=D;s=C}else{break}}x=c[l>>2]|0}}while(0);o=w+1|0;if(o>>>0<x>>>0&o>>>0<a>>>0){v=x;w=o}else{j=o;break}}}else{j=0}}while(0);if(j>>>0<a>>>0){E=j}else{i=h;return}do{c[b+(E<<3)>>2]=-1;c[b+(E<<3)+4>>2]=-1;E=E+1|0;}while(E>>>0<a>>>0);i=h;return}function spb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if((a|0)==0){e=Ypb(1,24)|0}else{c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;e=b}if((e|0)==0){f=0;i=d;return f|0}f=e;i=d;return f|0}function tpb(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a>>2]|0;if((d|0)==0){e=a;Xpb(e);i=b;return}else{f=d}while(1){Xpb(c[f>>2]|0);d=c[f+4>>2]|0;Xpb(f);if((d|0)==0){break}else{f=d}}e=a;Xpb(e);i=b;return}function upb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;h=a+16|0;if((c[h>>2]|0)!=0){j=0;i=g;return j|0}k=a+12|0;l=c[k>>2]|0;do{if(l>>>0<f>>>0){if((b|0)!=0){if((d|0)!=0){c[a+8>>2]=d;c[k>>2]=1024;m=d;n=1024;break}c[h>>2]=1;j=0;i=g;return j|0}o=f<<3;p=o>>>0>1024?o:1024;o=Wpb(8)|0;q=o;if((o|0)==0){c[h>>2]=1;j=0;i=g;return j|0}r=Wpb(p)|0;c[o>>2]=r;if((r|0)==0){Xpb(o);c[h>>2]=1;j=0;i=g;return j|0}c[o+4>>2]=0;r=a+4|0;s=c[r>>2]|0;if((s|0)!=0){c[s+4>>2]=q}s=a;if((c[s>>2]|0)==0){c[s>>2]=q}c[r>>2]=q;q=c[o>>2]|0;c[a+8>>2]=q;c[k>>2]=p;m=q;n=p}else{m=c[a+8>>2]|0;n=l}}while(0);l=m+f&3;h=((l|0)==0?0:4-l|0)+f|0;c[a+8>>2]=m+h;c[k>>2]=n-h;if((e|0)==0){j=m;i=g;return j|0}Cqb(m|0,0,h|0)|0;j=m;i=g;return j|0}function vpb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;if((b|0)==0){e=a+((wpb(a)|0)<<2)|0;i=d;return e|0}else{f=a}while(1){g=c[f>>2]|0;if((g|0)==0|(g|0)==(b|0)){break}else{f=f+4|0}}e=(g|0)!=0?f:0;i=d;return e|0}function wpb(a){a=a|0;var b=0,d=0;b=i;d=a;while(1){if((c[d>>2]|0)==0){break}else{d=d+4|0}}i=b;return d-a>>2|0}function xpb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;if((d|0)==0){i=e;return a|0}else{f=d;g=b;h=a}while(1){b=f+ -1|0;c[h>>2]=c[g>>2];if((b|0)==0){break}else{h=h+4|0;g=g+4|0;f=b}}i=e;return a|0}function ypb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=(d|0)==0;if(a-b>>2>>>0<d>>>0){if(f){i=e;return a|0}else{g=d}do{g=g+ -1|0;c[a+(g<<2)>>2]=c[b+(g<<2)>>2];}while((g|0)!=0);i=e;return a|0}else{if(f){i=e;return a|0}else{h=b;j=a;k=d}while(1){d=k+ -1|0;c[j>>2]=c[h>>2];if((d|0)==0){break}else{k=d;j=j+4|0;h=h+4|0}}i=e;return a|0}return 0}function zpb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((d|0)==0){i=e;return a|0}else{f=d;g=a}while(1){d=f+ -1|0;c[g>>2]=b;if((d|0)==0){break}else{g=g+4|0;f=d}}i=e;return a|0}function Apb(a){a=a|0;i=i;return}function Bpb(a){a=a|0;c[a>>2]=329616;i=i;return}function Cpb(a){a=a|0;var b=0;b=i;Cb(a|0);cqb(a);i=b;return}function Dpb(a){a=a|0;var b=0;b=i;Cb(a|0);i=b;return}function Epb(a){a=a|0;i=i;return 329632}function Fpb(a){a=a|0;i=i;return}function Gpb(a){a=a|0;i=i;return}function Hpb(a){a=a|0;i=i;return}function Ipb(a){a=a|0;var b=0;b=i;cqb(a);i=b;return}function Jpb(a){a=a|0;var b=0;b=i;cqb(a);i=b;return}function Kpb(a){a=a|0;var b=0;b=i;cqb(a);i=b;return}function Lpb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+56|0;f=e;if((a|0)==(b|0)){g=1;i=e;return g|0}if((b|0)==0){g=0;i=e;return g|0}h=Ppb(b,329744,329800,0)|0;b=h;if((h|0)==0){g=0;i=e;return g|0}j=f+0|0;k=j+56|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));c[f>>2]=b;c[f+8>>2]=a;c[f+12>>2]=-1;c[f+48>>2]=1;Pe[c[(c[h>>2]|0)+28>>2]&127](b,f,c[d>>2]|0,1);if((c[f+24>>2]|0)!=1){g=0;i=e;return g|0}c[d>>2]=c[f+16>>2];g=1;i=e;return g|0}function Mpb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((c[d+8>>2]|0)!=(b|0)){i=g;return}b=d+16|0;h=c[b>>2]|0;if((h|0)==0){c[b>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}e=d+24|0;if((c[e>>2]|0)!=2){i=g;return}c[e>>2]=f;i=g;return}function Npb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((b|0)!=(c[d+8>>2]|0)){h=c[b+8>>2]|0;Pe[c[(c[h>>2]|0)+28>>2]&127](h,d,e,f);i=g;return}h=d+16|0;b=c[h>>2]|0;if((b|0)==0){c[h>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}e=d+24|0;if((c[e>>2]|0)!=2){i=g;return}c[e>>2]=f;i=g;return}function Opb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((b|0)==(c[d+8>>2]|0)){h=d+16|0;j=c[h>>2]|0;if((j|0)==0){c[h>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((j|0)!=(e|0)){j=d+36|0;c[j>>2]=(c[j>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}j=d+24|0;if((c[j>>2]|0)!=2){i=g;return}c[j>>2]=f;i=g;return}j=c[b+12>>2]|0;h=b+16+(j<<3)|0;k=c[b+20>>2]|0;l=k>>8;if((k&1|0)==0){m=l}else{m=c[(c[e>>2]|0)+l>>2]|0}l=c[b+16>>2]|0;Pe[c[(c[l>>2]|0)+28>>2]&127](l,d,e+m|0,(k&2|0)!=0?f:2);if((j|0)<=1){i=g;return}j=d+54|0;k=b+24|0;while(1){b=c[k+4>>2]|0;m=b>>8;if((b&1|0)==0){n=m}else{n=c[(c[e>>2]|0)+m>>2]|0}m=c[k>>2]|0;Pe[c[(c[m>>2]|0)+28>>2]&127](m,d,e+n|0,(b&2|0)!=0?f:2);if((a[j]|0)!=0){o=16;break}b=k+8|0;if(b>>>0<h>>>0){k=b}else{o=16;break}}if((o|0)==16){i=g;return}}function Ppb(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+56|0;j=h;k=c[d>>2]|0;l=d+(c[k+ -8>>2]|0)|0;m=c[k+ -4>>2]|0;k=m;c[j>>2]=f;c[j+4>>2]=d;c[j+8>>2]=e;c[j+12>>2]=g;g=j+16|0;e=j+20|0;d=j+24|0;n=j+28|0;o=j+32|0;p=j+40|0;q=(m|0)==(f|0);f=g;r=f+0|0;s=r+36|0;do{c[r>>2]=0;r=r+4|0}while((r|0)<(s|0));b[f+36>>1]=0;a[f+38|0]=0;if(q){c[j+48>>2]=1;ye[c[(c[m>>2]|0)+20>>2]&31](k,j,l,l,1,0);t=(c[d>>2]|0)==1?l:0;i=h;return t|0}je[c[(c[m>>2]|0)+24>>2]&31](k,j,l,1,0);l=c[j+36>>2]|0;if((l|0)==1){do{if((c[d>>2]|0)!=1){if((c[p>>2]|0)!=0){t=0;i=h;return t|0}if((c[n>>2]|0)!=1){t=0;i=h;return t|0}if((c[o>>2]|0)==1){break}else{t=0}i=h;return t|0}}while(0);t=c[g>>2]|0;i=h;return t|0}else if((l|0)==0){if((c[p>>2]|0)!=1){t=0;i=h;return t|0}if((c[n>>2]|0)!=1){t=0;i=h;return t|0}t=(c[o>>2]|0)==1?c[e>>2]|0:0;i=h;return t|0}else{t=0;i=h;return t|0}return 0}function Qpb(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;h=i;j=b;if((j|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}k=d+28|0;if((c[k>>2]|0)==1){i=h;return}c[k>>2]=f;i=h;return}if((j|0)==(c[d>>2]|0)){do{if((c[d+16>>2]|0)!=(e|0)){j=d+20|0;if((c[j>>2]|0)==(e|0)){break}c[d+32>>2]=f;k=d+44|0;if((c[k>>2]|0)==4){i=h;return}l=c[b+12>>2]|0;m=b+16+(l<<3)|0;a:do{if((l|0)>0){n=d+52|0;o=d+53|0;p=d+54|0;q=b+8|0;r=d+24|0;s=0;t=0;u=b+16|0;b:while(1){a[n]=0;a[o]=0;v=c[u+4>>2]|0;w=v>>8;if((v&1|0)==0){x=w}else{x=c[(c[e>>2]|0)+w>>2]|0}w=c[u>>2]|0;ye[c[(c[w>>2]|0)+20>>2]&31](w,d,e,e+x|0,2-(v>>>1&1)|0,g);if((a[p]|0)!=0){y=s;z=t;break}do{if((a[o]|0)==0){A=s;B=t}else{if((a[n]|0)==0){if((c[q>>2]&1|0)==0){y=s;z=1;break b}else{A=s;B=1;break}}if((c[r>>2]|0)==1){C=27;break a}if((c[q>>2]&2|0)==0){C=27;break a}else{A=1;B=1}}}while(0);v=u+8|0;if(v>>>0<m>>>0){s=A;t=B;u=v}else{y=A;z=B;break}}if(y){D=z;C=26}else{E=z;C=23}}else{E=0;C=23}}while(0);do{if((C|0)==23){c[j>>2]=e;m=d+40|0;c[m>>2]=(c[m>>2]|0)+1;if((c[d+36>>2]|0)!=1){D=E;C=26;break}if((c[d+24>>2]|0)!=2){D=E;C=26;break}a[d+54|0]=1;if(E){C=27}else{C=28}}}while(0);if((C|0)==26){if(D){C=27}else{C=28}}if((C|0)==27){c[k>>2]=3;i=h;return}else if((C|0)==28){c[k>>2]=4;i=h;return}}}while(0);if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}D=c[b+12>>2]|0;E=b+16+(D<<3)|0;z=c[b+20>>2]|0;y=z>>8;if((z&1|0)==0){F=y}else{F=c[(c[e>>2]|0)+y>>2]|0}y=c[b+16>>2]|0;je[c[(c[y>>2]|0)+24>>2]&31](y,d,e+F|0,(z&2|0)!=0?f:2,g);z=b+24|0;if((D|0)<=1){i=h;return}D=c[b+8>>2]|0;do{if((D&2|0)==0){b=d+36|0;if((c[b>>2]|0)==1){break}if((D&1|0)==0){F=d+54|0;y=z;while(1){if((a[F]|0)!=0){C=53;break}if((c[b>>2]|0)==1){C=53;break}B=c[y+4>>2]|0;A=B>>8;if((B&1|0)==0){G=A}else{G=c[(c[e>>2]|0)+A>>2]|0}A=c[y>>2]|0;je[c[(c[A>>2]|0)+24>>2]&31](A,d,e+G|0,(B&2|0)!=0?f:2,g);B=y+8|0;if(B>>>0<E>>>0){y=B}else{C=53;break}}if((C|0)==53){i=h;return}}y=d+24|0;F=d+54|0;k=z;while(1){if((a[F]|0)!=0){C=53;break}if((c[b>>2]|0)==1){if((c[y>>2]|0)==1){C=53;break}}B=c[k+4>>2]|0;A=B>>8;if((B&1|0)==0){H=A}else{H=c[(c[e>>2]|0)+A>>2]|0}A=c[k>>2]|0;je[c[(c[A>>2]|0)+24>>2]&31](A,d,e+H|0,(B&2|0)!=0?f:2,g);B=k+8|0;if(B>>>0<E>>>0){k=B}else{C=53;break}}if((C|0)==53){i=h;return}}}while(0);H=d+54|0;G=z;while(1){if((a[H]|0)!=0){C=53;break}z=c[G+4>>2]|0;D=z>>8;if((z&1|0)==0){I=D}else{I=c[(c[e>>2]|0)+D>>2]|0}D=c[G>>2]|0;je[c[(c[D>>2]|0)+24>>2]&31](D,d,e+I|0,(z&2|0)!=0?f:2,g);z=G+8|0;if(z>>>0<E>>>0){G=z}else{C=53;break}}if((C|0)==53){i=h;return}}function Rpb(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b;if((j|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}k=d+28|0;if((c[k>>2]|0)==1){i=h;return}c[k>>2]=f;i=h;return}if((j|0)!=(c[d>>2]|0)){j=c[b+8>>2]|0;je[c[(c[j>>2]|0)+24>>2]&31](j,d,e,f,g);i=h;return}do{if((c[d+16>>2]|0)!=(e|0)){j=d+20|0;if((c[j>>2]|0)==(e|0)){break}c[d+32>>2]=f;k=d+44|0;if((c[k>>2]|0)==4){i=h;return}l=d+52|0;a[l]=0;m=d+53|0;a[m]=0;n=c[b+8>>2]|0;ye[c[(c[n>>2]|0)+20>>2]&31](n,d,e,e,1,g);if((a[m]|0)==0){o=0;p=13}else{if((a[l]|0)==0){o=1;p=13}}a:do{if((p|0)==13){c[j>>2]=e;l=d+40|0;c[l>>2]=(c[l>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){p=16;break}a[d+54|0]=1;if(o){break a}}else{p=16}}while(0);if((p|0)==16){if(o){break}}c[k>>2]=4;i=h;return}}while(0);c[k>>2]=3;i=h;return}}while(0);if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}function Spb(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;g=i;if((c[d+8>>2]|0)==(b|0)){if((c[d+4>>2]|0)!=(e|0)){i=g;return}h=d+28|0;if((c[h>>2]|0)==1){i=g;return}c[h>>2]=f;i=g;return}if((c[d>>2]|0)!=(b|0)){i=g;return}do{if((c[d+16>>2]|0)!=(e|0)){b=d+20|0;if((c[b>>2]|0)==(e|0)){break}c[d+32>>2]=f;c[b>>2]=e;b=d+40|0;c[b>>2]=(c[b>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){break}a[d+54|0]=1}}while(0);c[d+44>>2]=4;i=g;return}}while(0);if((f|0)!=1){i=g;return}c[d+32>>2]=1;i=g;return}function Tpb(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;if((b|0)!=(c[d+8>>2]|0)){k=d+52|0;l=a[k]|0;m=d+53|0;n=a[m]|0;o=c[b+12>>2]|0;p=b+16+(o<<3)|0;a[k]=0;a[m]=0;q=c[b+20>>2]|0;r=q>>8;if((q&1|0)==0){s=r}else{s=c[(c[f>>2]|0)+r>>2]|0}r=c[b+16>>2]|0;ye[c[(c[r>>2]|0)+20>>2]&31](r,d,e,f+s|0,(q&2|0)!=0?g:2,h);a:do{if((o|0)>1){q=d+24|0;s=b+8|0;r=d+54|0;t=b+24|0;do{if((a[r]|0)!=0){break a}do{if((a[k]|0)==0){if((a[m]|0)==0){break}if((c[s>>2]&1|0)==0){break a}}else{if((c[q>>2]|0)==1){break a}if((c[s>>2]&2|0)==0){break a}}}while(0);a[k]=0;a[m]=0;u=c[t+4>>2]|0;v=u>>8;if((u&1|0)==0){w=v}else{w=c[(c[f>>2]|0)+v>>2]|0}v=c[t>>2]|0;ye[c[(c[v>>2]|0)+20>>2]&31](v,d,e,f+w|0,(u&2|0)!=0?g:2,h);t=t+8|0;}while(t>>>0<p>>>0)}}while(0);a[k]=l;a[m]=n;i=j;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=j;return}a[d+52|0]=1;f=d+16|0;n=c[f>>2]|0;if((n|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}if((n|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=j;return}e=d+24|0;n=c[e>>2]|0;if((n|0)==2){c[e>>2]=g;x=g}else{x=n}if(!((c[d+48>>2]|0)==1&(x|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}function Upb(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;if((b|0)!=(c[d+8>>2]|0)){k=c[b+8>>2]|0;ye[c[(c[k>>2]|0)+20>>2]&31](k,d,e,f,g,h);i=j;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=j;return}a[d+52|0]=1;f=d+16|0;h=c[f>>2]|0;if((h|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=j;return}e=d+24|0;h=c[e>>2]|0;if((h|0)==2){c[e>>2]=g;l=g}else{l=h}if(!((c[d+48>>2]|0)==1&(l|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}function Vpb(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0;h=i;if((c[d+8>>2]|0)!=(b|0)){i=h;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=h;return}a[d+52|0]=1;f=d+16|0;b=c[f>>2]|0;if((b|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=h;return}a[d+54|0]=1;i=h;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=h;return}e=d+24|0;b=c[e>>2]|0;if((b|0)==2){c[e>>2]=g;j=g}else{j=b}if(!((c[d+48>>2]|0)==1&(j|0)==1)){i=h;return}a[d+54|0]=1;i=h;return}function Wpb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0;b=i;do{if(a>>>0<245){if(a>>>0<11){d=16}else{d=a+11&-8}e=d>>>3;f=c[82512]|0;g=f>>>e;if((g&3|0)!=0){h=(g&1^1)+e|0;j=h<<1;k=330088+(j<<2)|0;l=330088+(j+2<<2)|0;j=c[l>>2]|0;m=j+8|0;n=c[m>>2]|0;do{if((k|0)==(n|0)){c[82512]=f&~(1<<h)}else{if(n>>>0<(c[330064>>2]|0)>>>0){md()}o=n+12|0;if((c[o>>2]|0)==(j|0)){c[o>>2]=k;c[l>>2]=n;break}else{md()}}}while(0);n=h<<3;c[j+4>>2]=n|3;l=j+(n|4)|0;c[l>>2]=c[l>>2]|1;p=m;i=b;return p|0}if(!(d>>>0>(c[330056>>2]|0)>>>0)){q=d;break}if((g|0)!=0){l=2<<e;n=g<<e&(l|0-l);l=(n&0-n)+ -1|0;n=l>>>12&16;k=l>>>n;l=k>>>5&8;o=k>>>l;k=o>>>2&4;r=o>>>k;o=r>>>1&2;s=r>>>o;r=s>>>1&1;t=(l|n|k|o|r)+(s>>>r)|0;r=t<<1;s=330088+(r<<2)|0;o=330088+(r+2<<2)|0;r=c[o>>2]|0;k=r+8|0;n=c[k>>2]|0;do{if((s|0)==(n|0)){c[82512]=f&~(1<<t)}else{if(n>>>0<(c[330064>>2]|0)>>>0){md()}l=n+12|0;if((c[l>>2]|0)==(r|0)){c[l>>2]=s;c[o>>2]=n;break}else{md()}}}while(0);n=t<<3;o=n-d|0;c[r+4>>2]=d|3;s=r+d|0;c[r+(d|4)>>2]=o|1;c[r+n>>2]=o;n=c[330056>>2]|0;if((n|0)!=0){f=c[330068>>2]|0;e=n>>>3;n=e<<1;g=330088+(n<<2)|0;m=c[82512]|0;j=1<<e;do{if((m&j|0)==0){c[82512]=m|j;u=330088+(n+2<<2)|0;v=g}else{e=330088+(n+2<<2)|0;h=c[e>>2]|0;if(!(h>>>0<(c[330064>>2]|0)>>>0)){u=e;v=h;break}md()}}while(0);c[u>>2]=f;c[v+12>>2]=f;c[f+8>>2]=v;c[f+12>>2]=g}c[330056>>2]=o;c[330068>>2]=s;p=k;i=b;return p|0}n=c[330052>>2]|0;if((n|0)==0){q=d;break}j=(n&0-n)+ -1|0;n=j>>>12&16;m=j>>>n;j=m>>>5&8;r=m>>>j;m=r>>>2&4;t=r>>>m;r=t>>>1&2;h=t>>>r;t=h>>>1&1;e=c[330352+((j|n|m|r|t)+(h>>>t)<<2)>>2]|0;t=(c[e+4>>2]&-8)-d|0;h=e;r=e;while(1){e=c[h+16>>2]|0;if((e|0)==0){m=c[h+20>>2]|0;if((m|0)==0){break}else{w=m}}else{w=e}e=(c[w+4>>2]&-8)-d|0;m=e>>>0<t>>>0;t=m?e:t;h=w;r=m?w:r}h=r;k=c[330064>>2]|0;if(h>>>0<k>>>0){md()}s=r+d|0;o=s;if(!(h>>>0<s>>>0)){md()}s=c[r+24>>2]|0;h=c[r+12>>2]|0;do{if((h|0)==(r|0)){g=r+20|0;f=c[g>>2]|0;if((f|0)==0){m=r+16|0;e=c[m>>2]|0;if((e|0)==0){x=0;break}else{y=e;z=m}}else{y=f;z=g}while(1){g=y+20|0;f=c[g>>2]|0;if((f|0)!=0){z=g;y=f;continue}f=y+16|0;g=c[f>>2]|0;if((g|0)==0){break}else{y=g;z=f}}if(z>>>0<k>>>0){md()}else{c[z>>2]=0;x=y;break}}else{f=c[r+8>>2]|0;if(f>>>0<k>>>0){md()}g=f+12|0;if((c[g>>2]|0)!=(r|0)){md()}m=h+8|0;if((c[m>>2]|0)==(r|0)){c[g>>2]=h;c[m>>2]=f;x=h;break}else{md()}}}while(0);a:do{if((s|0)!=0){h=c[r+28>>2]|0;k=330352+(h<<2)|0;do{if((r|0)==(c[k>>2]|0)){c[k>>2]=x;if((x|0)!=0){break}c[330052>>2]=c[330052>>2]&~(1<<h);break a}else{if(s>>>0<(c[330064>>2]|0)>>>0){md()}f=s+16|0;if((c[f>>2]|0)==(r|0)){c[f>>2]=x}else{c[s+20>>2]=x}if((x|0)==0){break a}}}while(0);if(x>>>0<(c[330064>>2]|0)>>>0){md()}c[x+24>>2]=s;h=c[r+16>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[330064>>2]|0)>>>0){md()}else{c[x+16>>2]=h;c[h+24>>2]=x;break}}}while(0);h=c[r+20>>2]|0;if((h|0)==0){break}if(h>>>0<(c[330064>>2]|0)>>>0){md()}else{c[x+20>>2]=h;c[h+24>>2]=x;break}}}while(0);if(t>>>0<16){s=t+d|0;c[r+4>>2]=s|3;h=r+(s+4)|0;c[h>>2]=c[h>>2]|1}else{c[r+4>>2]=d|3;c[r+(d|4)>>2]=t|1;c[r+(t+d)>>2]=t;h=c[330056>>2]|0;if((h|0)!=0){s=c[330068>>2]|0;k=h>>>3;h=k<<1;f=330088+(h<<2)|0;m=c[82512]|0;g=1<<k;do{if((m&g|0)==0){c[82512]=m|g;A=330088+(h+2<<2)|0;B=f}else{k=330088+(h+2<<2)|0;e=c[k>>2]|0;if(!(e>>>0<(c[330064>>2]|0)>>>0)){A=k;B=e;break}md()}}while(0);c[A>>2]=s;c[B+12>>2]=s;c[s+8>>2]=B;c[s+12>>2]=f}c[330056>>2]=t;c[330068>>2]=o}p=r+8|0;i=b;return p|0}else{if(a>>>0>4294967231){q=-1;break}h=a+11|0;g=h&-8;m=c[330052>>2]|0;if((m|0)==0){q=g;break}e=0-g|0;k=h>>>8;do{if((k|0)==0){C=0}else{if(g>>>0>16777215){C=31;break}h=(k+1048320|0)>>>16&8;n=k<<h;j=(n+520192|0)>>>16&4;l=n<<j;n=(l+245760|0)>>>16&2;D=14-(j|h|n)+(l<<n>>>15)|0;C=g>>>(D+7|0)&1|D<<1}}while(0);k=c[330352+(C<<2)>>2]|0;b:do{if((k|0)==0){E=e;F=0;G=0}else{if((C|0)==31){H=0}else{H=25-(C>>>1)|0}r=e;o=0;t=g<<H;f=k;s=0;while(1){D=c[f+4>>2]&-8;n=D-g|0;if(n>>>0<r>>>0){if((D|0)==(g|0)){E=n;F=f;G=f;break b}else{I=n;J=f}}else{I=r;J=s}n=c[f+20>>2]|0;D=c[f+16+(t>>>31<<2)>>2]|0;l=(n|0)==0|(n|0)==(D|0)?o:n;if((D|0)==0){E=I;F=l;G=J;break}else{r=I;o=l;t=t<<1;f=D;s=J}}}}while(0);if((F|0)==0&(G|0)==0){k=2<<C;e=m&(k|0-k);if((e|0)==0){q=g;break}k=(e&0-e)+ -1|0;e=k>>>12&16;s=k>>>e;k=s>>>5&8;f=s>>>k;s=f>>>2&4;t=f>>>s;f=t>>>1&2;o=t>>>f;t=o>>>1&1;K=c[330352+((k|e|s|f|t)+(o>>>t)<<2)>>2]|0}else{K=F}if((K|0)==0){L=E;M=G}else{t=E;o=K;f=G;while(1){s=(c[o+4>>2]&-8)-g|0;e=s>>>0<t>>>0;k=e?s:t;s=e?o:f;e=c[o+16>>2]|0;if((e|0)!=0){N=s;O=k;f=N;o=e;t=O;continue}e=c[o+20>>2]|0;if((e|0)==0){L=k;M=s;break}else{N=s;O=k;o=e;f=N;t=O}}}if((M|0)==0){q=g;break}if(!(L>>>0<((c[330056>>2]|0)-g|0)>>>0)){q=g;break}t=M;f=c[330064>>2]|0;if(t>>>0<f>>>0){md()}o=M+g|0;m=o;if(!(t>>>0<o>>>0)){md()}t=c[M+24>>2]|0;e=c[M+12>>2]|0;do{if((e|0)==(M|0)){k=M+20|0;s=c[k>>2]|0;if((s|0)==0){r=M+16|0;D=c[r>>2]|0;if((D|0)==0){P=0;break}else{Q=D;R=r}}else{Q=s;R=k}while(1){k=Q+20|0;s=c[k>>2]|0;if((s|0)!=0){R=k;Q=s;continue}s=Q+16|0;k=c[s>>2]|0;if((k|0)==0){break}else{Q=k;R=s}}if(R>>>0<f>>>0){md()}else{c[R>>2]=0;P=Q;break}}else{s=c[M+8>>2]|0;if(s>>>0<f>>>0){md()}k=s+12|0;if((c[k>>2]|0)!=(M|0)){md()}r=e+8|0;if((c[r>>2]|0)==(M|0)){c[k>>2]=e;c[r>>2]=s;P=e;break}else{md()}}}while(0);c:do{if((t|0)!=0){e=c[M+28>>2]|0;f=330352+(e<<2)|0;do{if((M|0)==(c[f>>2]|0)){c[f>>2]=P;if((P|0)!=0){break}c[330052>>2]=c[330052>>2]&~(1<<e);break c}else{if(t>>>0<(c[330064>>2]|0)>>>0){md()}s=t+16|0;if((c[s>>2]|0)==(M|0)){c[s>>2]=P}else{c[t+20>>2]=P}if((P|0)==0){break c}}}while(0);if(P>>>0<(c[330064>>2]|0)>>>0){md()}c[P+24>>2]=t;e=c[M+16>>2]|0;do{if((e|0)!=0){if(e>>>0<(c[330064>>2]|0)>>>0){md()}else{c[P+16>>2]=e;c[e+24>>2]=P;break}}}while(0);e=c[M+20>>2]|0;if((e|0)==0){break}if(e>>>0<(c[330064>>2]|0)>>>0){md()}else{c[P+20>>2]=e;c[e+24>>2]=P;break}}}while(0);d:do{if(L>>>0<16){t=L+g|0;c[M+4>>2]=t|3;e=M+(t+4)|0;c[e>>2]=c[e>>2]|1}else{c[M+4>>2]=g|3;c[M+(g|4)>>2]=L|1;c[M+(L+g)>>2]=L;e=L>>>3;if(L>>>0<256){t=e<<1;f=330088+(t<<2)|0;s=c[82512]|0;r=1<<e;do{if((s&r|0)==0){c[82512]=s|r;S=330088+(t+2<<2)|0;T=f}else{e=330088+(t+2<<2)|0;k=c[e>>2]|0;if(!(k>>>0<(c[330064>>2]|0)>>>0)){S=e;T=k;break}md()}}while(0);c[S>>2]=m;c[T+12>>2]=m;c[M+(g+8)>>2]=T;c[M+(g+12)>>2]=f;break}t=o;r=L>>>8;do{if((r|0)==0){U=0}else{if(L>>>0>16777215){U=31;break}s=(r+1048320|0)>>>16&8;k=r<<s;e=(k+520192|0)>>>16&4;D=k<<e;k=(D+245760|0)>>>16&2;l=14-(e|s|k)+(D<<k>>>15)|0;U=L>>>(l+7|0)&1|l<<1}}while(0);r=330352+(U<<2)|0;c[M+(g+28)>>2]=U;c[M+(g+20)>>2]=0;c[M+(g+16)>>2]=0;f=c[330052>>2]|0;l=1<<U;if((f&l|0)==0){c[330052>>2]=f|l;c[r>>2]=t;c[M+(g+24)>>2]=r;c[M+(g+12)>>2]=t;c[M+(g+8)>>2]=t;break}l=c[r>>2]|0;if((U|0)==31){V=0}else{V=25-(U>>>1)|0}e:do{if((c[l+4>>2]&-8|0)==(L|0)){W=l}else{r=L<<V;f=l;while(1){X=f+16+(r>>>31<<2)|0;k=c[X>>2]|0;if((k|0)==0){break}if((c[k+4>>2]&-8|0)==(L|0)){W=k;break e}else{r=r<<1;f=k}}if(X>>>0<(c[330064>>2]|0)>>>0){md()}else{c[X>>2]=t;c[M+(g+24)>>2]=f;c[M+(g+12)>>2]=t;c[M+(g+8)>>2]=t;break d}}}while(0);l=W+8|0;r=c[l>>2]|0;k=c[330064>>2]|0;if(W>>>0<k>>>0){md()}if(r>>>0<k>>>0){md()}else{c[r+12>>2]=t;c[l>>2]=t;c[M+(g+8)>>2]=r;c[M+(g+12)>>2]=W;c[M+(g+24)>>2]=0;break}}}while(0);p=M+8|0;i=b;return p|0}}while(0);M=c[330056>>2]|0;if(!(q>>>0>M>>>0)){W=M-q|0;X=c[330068>>2]|0;if(W>>>0>15){c[330068>>2]=X+q;c[330056>>2]=W;c[X+(q+4)>>2]=W|1;c[X+M>>2]=W;c[X+4>>2]=q|3}else{c[330056>>2]=0;c[330068>>2]=0;c[X+4>>2]=M|3;W=X+(M+4)|0;c[W>>2]=c[W>>2]|1}p=X+8|0;i=b;return p|0}X=c[330060>>2]|0;if(q>>>0<X>>>0){W=X-q|0;c[330060>>2]=W;X=c[330072>>2]|0;c[330072>>2]=X+q;c[X+(q+4)>>2]=W|1;c[X+4>>2]=q|3;p=X+8|0;i=b;return p|0}do{if((c[82630]|0)==0){X=pb(30)|0;if((X+ -1&X|0)==0){c[330528>>2]=X;c[330524>>2]=X;c[330532>>2]=-1;c[330536>>2]=-1;c[330540>>2]=0;c[330492>>2]=0;c[82630]=(vc(0)|0)&-16^1431655768;break}else{md()}}}while(0);X=q+48|0;W=c[330528>>2]|0;M=q+47|0;L=W+M|0;V=0-W|0;W=L&V;if(!(W>>>0>q>>>0)){p=0;i=b;return p|0}U=c[330488>>2]|0;do{if((U|0)!=0){T=c[330480>>2]|0;S=T+W|0;if(S>>>0<=T>>>0|S>>>0>U>>>0){p=0}else{break}i=b;return p|0}}while(0);f:do{if((c[330492>>2]&4|0)==0){U=c[330072>>2]|0;g:do{if((U|0)==0){Y=182}else{S=U;T=330496|0;while(1){Z=T;P=c[Z>>2]|0;if(!(P>>>0>S>>>0)){_=T+4|0;if((P+(c[_>>2]|0)|0)>>>0>S>>>0){break}}P=c[T+8>>2]|0;if((P|0)==0){Y=182;break g}else{T=P}}if((T|0)==0){Y=182;break}S=L-(c[330060>>2]|0)&V;if(!(S>>>0<2147483647)){$=0;break}t=lb(S|0)|0;P=(t|0)==((c[Z>>2]|0)+(c[_>>2]|0)|0);aa=t;ba=S;ca=P?t:-1;da=P?S:0;Y=191}}while(0);do{if((Y|0)==182){U=lb(0)|0;if((U|0)==(-1|0)){$=0;break}S=U;P=c[330524>>2]|0;t=P+ -1|0;if((t&S|0)==0){ea=W}else{ea=W-S+(t+S&0-P)|0}P=c[330480>>2]|0;S=P+ea|0;if(!(ea>>>0>q>>>0&ea>>>0<2147483647)){$=0;break}t=c[330488>>2]|0;if((t|0)!=0){if(S>>>0<=P>>>0|S>>>0>t>>>0){$=0;break}}t=lb(ea|0)|0;S=(t|0)==(U|0);aa=t;ba=ea;ca=S?U:-1;da=S?ea:0;Y=191}}while(0);h:do{if((Y|0)==191){S=0-ba|0;if((ca|0)!=(-1|0)){fa=ca;ga=da;Y=202;break f}do{if((aa|0)!=(-1|0)&ba>>>0<2147483647&ba>>>0<X>>>0){U=c[330528>>2]|0;t=M-ba+U&0-U;if(!(t>>>0<2147483647)){ha=ba;break}if((lb(t|0)|0)==(-1|0)){lb(S|0)|0;$=da;break h}else{ha=t+ba|0;break}}else{ha=ba}}while(0);if((aa|0)==(-1|0)){$=da}else{fa=aa;ga=ha;Y=202;break f}}}while(0);c[330492>>2]=c[330492>>2]|4;ia=$;Y=199}else{ia=0;Y=199}}while(0);do{if((Y|0)==199){if(!(W>>>0<2147483647)){break}$=lb(W|0)|0;ha=lb(0)|0;if(!((ha|0)!=(-1|0)&($|0)!=(-1|0)&$>>>0<ha>>>0)){break}aa=ha-$|0;ha=aa>>>0>(q+40|0)>>>0;if(ha){fa=$;ga=ha?aa:ia;Y=202}}}while(0);do{if((Y|0)==202){ia=(c[330480>>2]|0)+ga|0;c[330480>>2]=ia;if(ia>>>0>(c[330484>>2]|0)>>>0){c[330484>>2]=ia}ia=c[330072>>2]|0;W=330496|0;i:do{if((ia|0)==0){aa=c[330064>>2]|0;if((aa|0)==0|fa>>>0<aa>>>0){c[330064>>2]=fa}c[330496>>2]=fa;c[330500>>2]=ga;c[330508>>2]=0;c[330084>>2]=c[82630];c[330080>>2]=-1;aa=0;do{ha=aa<<1;$=330088+(ha<<2)|0;c[330088+(ha+3<<2)>>2]=$;c[330088+(ha+2<<2)>>2]=$;aa=aa+1|0;}while(aa>>>0<32);aa=fa+8|0;if((aa&7|0)==0){ja=0}else{ja=0-aa&7}aa=ga+ -40-ja|0;c[330072>>2]=fa+ja;c[330060>>2]=aa;c[fa+(ja+4)>>2]=aa|1;c[fa+(ga+ -36)>>2]=40;c[330076>>2]=c[330536>>2]}else{aa=W;while(1){ka=c[aa>>2]|0;la=aa+4|0;ma=c[la>>2]|0;if((fa|0)==(ka+ma|0)){Y=214;break}$=c[aa+8>>2]|0;if(($|0)==0){break}else{aa=$}}do{if((Y|0)==214){if((c[aa+12>>2]&8|0)!=0){break}$=ia;if(!($>>>0>=ka>>>0&$>>>0<fa>>>0)){break}c[la>>2]=ma+ga;$=(c[330060>>2]|0)+ga|0;ha=ia+8|0;if((ha&7|0)==0){na=0}else{na=0-ha&7}ha=$-na|0;c[330072>>2]=ia+na;c[330060>>2]=ha;c[ia+(na+4)>>2]=ha|1;c[ia+($+4)>>2]=40;c[330076>>2]=c[330536>>2];break i}}while(0);if(fa>>>0<(c[330064>>2]|0)>>>0){c[330064>>2]=fa}aa=fa+ga|0;$=330496|0;while(1){oa=$;if((c[oa>>2]|0)==(aa|0)){Y=224;break}ha=c[$+8>>2]|0;if((ha|0)==0){break}else{$=ha}}do{if((Y|0)==224){if((c[$+12>>2]&8|0)!=0){break}c[oa>>2]=fa;aa=$+4|0;c[aa>>2]=(c[aa>>2]|0)+ga;aa=fa+8|0;if((aa&7|0)==0){pa=0}else{pa=0-aa&7}aa=fa+(ga+8)|0;if((aa&7|0)==0){qa=0}else{qa=0-aa&7}aa=fa+(qa+ga)|0;ha=aa;da=pa+q|0;ba=fa+da|0;M=ba;X=aa-(fa+pa)-q|0;c[fa+(pa+4)>>2]=q|3;j:do{if((ha|0)==(c[330072>>2]|0)){ca=(c[330060>>2]|0)+X|0;c[330060>>2]=ca;c[330072>>2]=M;c[fa+(da+4)>>2]=ca|1}else{if((ha|0)==(c[330068>>2]|0)){ca=(c[330056>>2]|0)+X|0;c[330056>>2]=ca;c[330068>>2]=M;c[fa+(da+4)>>2]=ca|1;c[fa+(ca+da)>>2]=ca;break}ca=ga+4|0;ea=c[fa+(ca+qa)>>2]|0;if((ea&3|0)==1){_=ea&-8;Z=ea>>>3;k:do{if(ea>>>0<256){V=c[fa+((qa|8)+ga)>>2]|0;L=c[fa+(ga+12+qa)>>2]|0;S=330088+(Z<<1<<2)|0;do{if((V|0)!=(S|0)){if(V>>>0<(c[330064>>2]|0)>>>0){md()}if((c[V+12>>2]|0)==(ha|0)){break}md()}}while(0);if((L|0)==(V|0)){c[82512]=c[82512]&~(1<<Z);break}do{if((L|0)==(S|0)){ra=L+8|0}else{if(L>>>0<(c[330064>>2]|0)>>>0){md()}T=L+8|0;if((c[T>>2]|0)==(ha|0)){ra=T;break}md()}}while(0);c[V+12>>2]=L;c[ra>>2]=V}else{S=aa;T=c[fa+((qa|24)+ga)>>2]|0;t=c[fa+(ga+12+qa)>>2]|0;do{if((t|0)==(S|0)){U=qa|16;P=fa+(ca+U)|0;Q=P;R=c[P>>2]|0;if((R|0)==0){P=fa+(U+ga)|0;U=c[P>>2]|0;if((U|0)==0){sa=0;break}else{ta=U;ua=P}}else{ta=R;ua=Q}while(1){Q=ta+20|0;R=c[Q>>2]|0;if((R|0)!=0){ua=Q;ta=R;continue}R=ta+16|0;Q=c[R>>2]|0;if((Q|0)==0){break}else{ta=Q;ua=R}}if(ua>>>0<(c[330064>>2]|0)>>>0){md()}else{c[ua>>2]=0;sa=ta;break}}else{R=c[fa+((qa|8)+ga)>>2]|0;if(R>>>0<(c[330064>>2]|0)>>>0){md()}Q=R+12|0;if((c[Q>>2]|0)!=(S|0)){md()}P=t+8|0;if((c[P>>2]|0)==(S|0)){c[Q>>2]=t;c[P>>2]=R;sa=t;break}else{md()}}}while(0);if((T|0)==0){break}t=c[fa+(ga+28+qa)>>2]|0;V=330352+(t<<2)|0;do{if((S|0)==(c[V>>2]|0)){c[V>>2]=sa;if((sa|0)!=0){break}c[330052>>2]=c[330052>>2]&~(1<<t);break k}else{if(T>>>0<(c[330064>>2]|0)>>>0){md()}L=T+16|0;if((c[L>>2]|0)==(S|0)){c[L>>2]=sa}else{c[T+20>>2]=sa}if((sa|0)==0){break k}}}while(0);if(sa>>>0<(c[330064>>2]|0)>>>0){md()}c[sa+24>>2]=T;S=qa|16;t=c[fa+(S+ga)>>2]|0;do{if((t|0)!=0){if(t>>>0<(c[330064>>2]|0)>>>0){md()}else{c[sa+16>>2]=t;c[t+24>>2]=sa;break}}}while(0);t=c[fa+(ca+S)>>2]|0;if((t|0)==0){break}if(t>>>0<(c[330064>>2]|0)>>>0){md()}else{c[sa+20>>2]=t;c[t+24>>2]=sa;break}}}while(0);va=fa+((_|qa)+ga)|0;wa=_+X|0}else{va=ha;wa=X}ca=va+4|0;c[ca>>2]=c[ca>>2]&-2;c[fa+(da+4)>>2]=wa|1;c[fa+(wa+da)>>2]=wa;ca=wa>>>3;if(wa>>>0<256){Z=ca<<1;ea=330088+(Z<<2)|0;t=c[82512]|0;T=1<<ca;do{if((t&T|0)==0){c[82512]=t|T;xa=330088+(Z+2<<2)|0;ya=ea}else{ca=330088+(Z+2<<2)|0;V=c[ca>>2]|0;if(!(V>>>0<(c[330064>>2]|0)>>>0)){xa=ca;ya=V;break}md()}}while(0);c[xa>>2]=M;c[ya+12>>2]=M;c[fa+(da+8)>>2]=ya;c[fa+(da+12)>>2]=ea;break}Z=ba;T=wa>>>8;do{if((T|0)==0){za=0}else{if(wa>>>0>16777215){za=31;break}t=(T+1048320|0)>>>16&8;_=T<<t;V=(_+520192|0)>>>16&4;ca=_<<V;_=(ca+245760|0)>>>16&2;L=14-(V|t|_)+(ca<<_>>>15)|0;za=wa>>>(L+7|0)&1|L<<1}}while(0);T=330352+(za<<2)|0;c[fa+(da+28)>>2]=za;c[fa+(da+20)>>2]=0;c[fa+(da+16)>>2]=0;ea=c[330052>>2]|0;L=1<<za;if((ea&L|0)==0){c[330052>>2]=ea|L;c[T>>2]=Z;c[fa+(da+24)>>2]=T;c[fa+(da+12)>>2]=Z;c[fa+(da+8)>>2]=Z;break}L=c[T>>2]|0;if((za|0)==31){Aa=0}else{Aa=25-(za>>>1)|0}l:do{if((c[L+4>>2]&-8|0)==(wa|0)){Ba=L}else{T=wa<<Aa;ea=L;while(1){Ca=ea+16+(T>>>31<<2)|0;_=c[Ca>>2]|0;if((_|0)==0){break}if((c[_+4>>2]&-8|0)==(wa|0)){Ba=_;break l}else{T=T<<1;ea=_}}if(Ca>>>0<(c[330064>>2]|0)>>>0){md()}else{c[Ca>>2]=Z;c[fa+(da+24)>>2]=ea;c[fa+(da+12)>>2]=Z;c[fa+(da+8)>>2]=Z;break j}}}while(0);L=Ba+8|0;T=c[L>>2]|0;S=c[330064>>2]|0;if(Ba>>>0<S>>>0){md()}if(T>>>0<S>>>0){md()}else{c[T+12>>2]=Z;c[L>>2]=Z;c[fa+(da+8)>>2]=T;c[fa+(da+12)>>2]=Ba;c[fa+(da+24)>>2]=0;break}}}while(0);p=fa+(pa|8)|0;i=b;return p|0}}while(0);$=ia;da=330496|0;while(1){Da=c[da>>2]|0;if(!(Da>>>0>$>>>0)){Ea=c[da+4>>2]|0;Fa=Da+Ea|0;if(Fa>>>0>$>>>0){break}}da=c[da+8>>2]|0}da=Da+(Ea+ -39)|0;if((da&7|0)==0){Ga=0}else{Ga=0-da&7}da=Da+(Ea+ -47+Ga)|0;ba=da>>>0<(ia+16|0)>>>0?$:da;da=ba+8|0;M=da;X=fa+8|0;if((X&7|0)==0){Ha=0}else{Ha=0-X&7}X=ga+ -40-Ha|0;c[330072>>2]=fa+Ha;c[330060>>2]=X;c[fa+(Ha+4)>>2]=X|1;c[fa+(ga+ -36)>>2]=40;c[330076>>2]=c[330536>>2];c[ba+4>>2]=27;X=330496|0;c[da+0>>2]=c[X+0>>2];c[da+4>>2]=c[X+4>>2];c[da+8>>2]=c[X+8>>2];c[da+12>>2]=c[X+12>>2];c[330496>>2]=fa;c[330500>>2]=ga;c[330508>>2]=0;c[330504>>2]=M;M=ba+28|0;c[M>>2]=7;if((ba+32|0)>>>0<Fa>>>0){X=M;while(1){M=X+4|0;c[M>>2]=7;if((X+8|0)>>>0<Fa>>>0){X=M}else{break}}}if((ba|0)==($|0)){break}X=ba-ia|0;M=ia+(X+4)|0;c[M>>2]=c[M>>2]&-2;c[ia+4>>2]=X|1;c[ia+X>>2]=X;M=X>>>3;if(X>>>0<256){da=M<<1;ha=330088+(da<<2)|0;aa=c[82512]|0;f=1<<M;do{if((aa&f|0)==0){c[82512]=aa|f;Ia=330088+(da+2<<2)|0;Ja=ha}else{M=330088+(da+2<<2)|0;T=c[M>>2]|0;if(!(T>>>0<(c[330064>>2]|0)>>>0)){Ia=M;Ja=T;break}md()}}while(0);c[Ia>>2]=ia;c[Ja+12>>2]=ia;c[ia+8>>2]=Ja;c[ia+12>>2]=ha;break}da=ia;f=X>>>8;do{if((f|0)==0){Ka=0}else{if(X>>>0>16777215){Ka=31;break}aa=(f+1048320|0)>>>16&8;ba=f<<aa;$=(ba+520192|0)>>>16&4;T=ba<<$;ba=(T+245760|0)>>>16&2;M=14-($|aa|ba)+(T<<ba>>>15)|0;Ka=X>>>(M+7|0)&1|M<<1}}while(0);f=330352+(Ka<<2)|0;c[ia+28>>2]=Ka;c[ia+20>>2]=0;c[ia+16>>2]=0;ha=c[330052>>2]|0;M=1<<Ka;if((ha&M|0)==0){c[330052>>2]=ha|M;c[f>>2]=da;c[ia+24>>2]=f;c[ia+12>>2]=ia;c[ia+8>>2]=ia;break}M=c[f>>2]|0;if((Ka|0)==31){La=0}else{La=25-(Ka>>>1)|0}m:do{if((c[M+4>>2]&-8|0)==(X|0)){Ma=M}else{f=X<<La;ha=M;while(1){Na=ha+16+(f>>>31<<2)|0;ba=c[Na>>2]|0;if((ba|0)==0){break}if((c[ba+4>>2]&-8|0)==(X|0)){Ma=ba;break m}else{f=f<<1;ha=ba}}if(Na>>>0<(c[330064>>2]|0)>>>0){md()}else{c[Na>>2]=da;c[ia+24>>2]=ha;c[ia+12>>2]=ia;c[ia+8>>2]=ia;break i}}}while(0);X=Ma+8|0;M=c[X>>2]|0;f=c[330064>>2]|0;if(Ma>>>0<f>>>0){md()}if(M>>>0<f>>>0){md()}else{c[M+12>>2]=da;c[X>>2]=da;c[ia+8>>2]=M;c[ia+12>>2]=Ma;c[ia+24>>2]=0;break}}}while(0);ia=c[330060>>2]|0;if(!(ia>>>0>q>>>0)){break}W=ia-q|0;c[330060>>2]=W;ia=c[330072>>2]|0;c[330072>>2]=ia+q;c[ia+(q+4)>>2]=W|1;c[ia+4>>2]=q|3;p=ia+8|0;i=b;return p|0}}while(0);c[(Qc()|0)>>2]=12;p=0;i=b;return p|0}



function WB(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6240>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4800>>3];l=+U(+(+h[j+6080>>3]));m=+h[j+5920>>3];j=+V(+(k*.125))*(+W(+m,.6666666666666666)+-1.0)*12.7+1.0!=0.0;n=f<<24>>24!=0?.5:19.5;f=b+416|0;o=c[f>>2]|0;p=+h[o+344>>3];q=n*p;r=q!=0.0;s=+h[o+664>>3];if(j){do{if(r){t=m;u=k;v=s/q}else{if(s==0.0){t=m;u=k;v=s;break}w=s/+qXa(c[b+536>>2]|0,q,20288,20280,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[(c[c[e>>2]>>2]|0)+8>>2]|0;t=+h[j+5920>>3];u=+h[j+4800>>3];v=w}}while(0);x=(+W(+v,.6666666666666666)*.3333333333333333+1.0)/(+V(+(u*.125))*(+W(+t,.6666666666666666)+-1.0)*12.7+1.0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5280|0;K=J;h[K>>3]=B;i=d;return}do{if(r){L=s;M=p;N=s/q}else{if(s==0.0){L=s;M=p;N=s;break}t=s/+qXa(c[b+536>>2]|0,q,20288,20280,+h[g>>3],(a[b+319|0]|0)!=0|0);j=c[f>>2]|0;L=+h[j+664>>3];M=+h[j+344>>3];N=t}}while(0);q=n*M;f=q!=0.0;if(+W(+N,.6666666666666666)*.3333333333333333+1.0==0.0){do{if(f){O=L/q}else{if(L==0.0){O=L;break}O=L/+qXa(c[b+536>>2]|0,q,20288,20280,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=+W(+O,.6666666666666666)*.3333333333333333+1.0;y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5280|0;K=J;h[K>>3]=B;i=d;return}else{do{if(f){P=L/q}else{if(L==0.0){P=L;break}P=L/+qXa(c[b+536>>2]|0,q,20288,20280,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+W(+P,.6666666666666666)*.3333333333333333+1.0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;P=+V(+(+h[g+4800>>3]*.125));L=P*(+W(+(+h[g+5920>>3]),.6666666666666666)+-1.0)*12.7+1.0;x=q/+qXa(c[b+536>>2]|0,L,20360,20280,+h[f>>3],(a[b+319|0]|0)!=0|0);y=m*x;z=l*y;A=k*z;B=A*.125;C=c[e>>2]|0;D=c[C>>2]|0;E=D;F=E+8|0;G=F;H=c[G>>2]|0;I=H;J=I+5280|0;K=J;h[K>>3]=B;i=d;return}}function XB(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=E_a(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6240>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+U(+(+h[j+6080>>3]));l=+h[j+5920>>3];m=c[b+416>>2]|0;n=(f<<24>>24!=0?.5:19.5)*+h[m+344>>3];o=+h[m+664>>3];do{if(n!=0.0){p=j;q=o/n}else{if(o==0.0){p=j;q=o;break}r=o/+qXa(c[b+536>>2]|0,n,20288,20488,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+4960>>3]=+W(+(k*l*q),.3333333333333333)*1.077;i=d;return}function YB(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+4960>>3]+-.7;h[b+5120>>3]=+W(+(d*d*d+49.370896),.3333333333333333);i=i;return}function ZB(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;_D(d,c[a+536>>2]|0,+h[f+5280>>3],+h[f+5120>>3],+h[f+6080>>3]+-6150.0,3850.0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5760>>3]=+h[d>>3];i=b;return}function _B(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+4684>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4640>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+4640|0;h[c[g+4688>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4640>>3]);h[c[(c[f>>2]|0)+4692>>2]>>3]=k;$_a(a,58)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+4640>>3]=+h[c[(c[f>>2]|0)+4684>>2]>>3];i=b;return}function $B(a){a=a|0;var b=0,d=0,e=0;b=i;R_a(a,39)|0;d=c[(c[a+476>>2]|0)+2524>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+9440>>3]=+h[d>>3];h[e+8336>>3]=+h[d+8>>3];i=b;return}function aC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14624>>3]=+h[b+8336>>3]+(+h[b+8344>>3]+(+h[b+8352>>3]+(+h[b+8360>>3]+(+h[b+8368>>3]+(+h[b+8376>>3]+(+h[b+8384>>3]+(+h[b+8392>>3]+(+h[b+8400>>3]+(+h[b+8408>>3]+(+h[b+8416>>3]+(+h[b+8424>>3]+(+h[b+8432>>3]+(+h[b+8440>>3]+(+h[b+8448>>3]+(+h[b+8456>>3]+(+h[b+8464>>3]+(+h[b+8472>>3]+(+h[b+8480>>3]+ +h[b+8488>>3]))))))))))))))))));i=i;return}function bC(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2696>>3]*+h[e>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=-+h[j+8336>>3]- +h[j+3848>>3];if(f!=0.0){l=j;m=k/f;n=l;o=n+1440|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+1440|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,f,20504,20496,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1440|0;p=o;h[p>>3]=m;i=d;return}function cC(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+8168>>3];h[b+7856>>3]=d*+h[(!(d>=0.0)?b+9272|0:b+14600|0)>>3];i=i;return}function dC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8496>>3]=+h[b+7848>>3]- +h[b+7856>>3];i=i;return}function eC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9920>>3]=+h[b+8496>>3]+(+h[b+8176>>3]+ +h[b+8336>>3]);i=i;return}function fC(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8816>>3];k=+h[g+9920>>3]- +h[g+8656>>3]*+h[g+7032>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9600|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9600|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,20544,20536,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9600|0;p=o;h[p>>3]=m;i=d;return}function gC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+4764>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1432>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1432|0;h[c[g+4768>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1432>>3]);e=c[f>>2]|0;h[c[e+4772>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+4764>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+14640>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+14640|0;h[(c[e+4768>>2]|0)+8>>3]=+h[g>>3];k=+b$a(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+14640>>3]);j=c[f>>2]|0;h[(c[j+4772>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+4764>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+1424>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+1424|0;h[(c[j+4768>>2]|0)+16>>3]=+h[e>>3];k=+b$a(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+1424>>3]);h[(c[(c[f>>2]|0)+4772>>2]|0)+16>>3]=k;$_a(a,59)|0;a=c[(c[f>>2]|0)+4764>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1432>>3]=+h[a>>3];h[f+14640>>3]=+h[a+8>>3];h[f+1424>>3]=+h[a+16>>3];i=b;return}function hC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8504>>3]=+h[b+7856>>3]- +h[b+7864>>3];i=i;return}function iC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9928>>3]=+h[b+8504>>3]+(+h[b+8184>>3]+ +h[b+8344>>3]);i=i;return}function jC(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8824>>3];k=+h[g+9928>>3]- +h[g+8664>>3]*+h[g+7e3>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+9608|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+9608|0;p=o;h[p>>3]=m;i=d;return}q=k/+qXa(c[b+536>>2]|0,j,20576,20568,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+9608|0;p=o;h[p>>3]=m;i=d;return}function kC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+4844>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1416>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1416|0;h[c[g+4848>>2]>>3]=+h[j>>3];k=+b$a(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1416>>3]);e=c[f>>2]|0;h[c[e+4852>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+4844>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+10240>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+10240|0;h[(c[e+4848>>2]|0)+8>>3]=+h[g>>3];k=+b$a(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+10240>>3]);j=c[f>>2]|0;h[(c[j+4852>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+4844>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+1408>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+1408|0;h[(c[j+4848>>2]|0)+16>>3]=+h[e>>3];k=+b$a(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+1408>>3]);h[(c[(c[f>>2]|0)+4852>>2]|0)+16>>3]=k;$_a(a,60)|0;a=c[(c[f>>2]|0)+4844>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1416>>3]=+h[a>>3];h[f+10240>>3]=+h[a+8>>3];h[f+1408>>3]=+h[a+16>>3];i=b;return}function lC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!((D_a(+h[c[a+416>>2]>>3],0.0)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[72300]|0;g=d;j=20720;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Pe[a&127](f,d,20688,e);i=b;return}function mC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!((D_a(+h[(c[a+416>>2]|0)+8>>3],0.0)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[72300]|0;g=d;j=20720;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Pe[a&127](f,d,20688,e);i=b;return}function nC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!((D_a(+h[(c[a+416>>2]|0)+16>>3],0.0)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[72300]|0;g=d;j=20720;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Pe[a&127](f,d,20688,e);i=b;return}function oC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!((D_a(+h[(c[a+416>>2]|0)+24>>3],0.0)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[72300]|0;g=d;j=20720;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Pe[a&127](f,d,20688,e);i=b;return}function pC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!((D_a(+h[(c[a+416>>2]|0)+32>>3],0.0)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[72300]|0;g=d;j=20720;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Pe[a&127](f,d,20688,e);i=b;return}function qC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!((D_a(+h[(c[a+416>>2]|0)+40>>3],0.0)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[72300]|0;g=d;j=20720;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Pe[a&127](f,d,20688,e);i=b;return}function rC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!((D_a(+h[(c[a+416>>2]|0)+48>>3],0.0)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[72300]|0;g=d;j=20720;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Pe[a&127](f,d,20688,e);i=b;return}function sC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!((D_a(+h[(c[a+416>>2]|0)+56>>3],0.0)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[72300]|0;g=d;j=20720;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Pe[a&127](f,d,20688,e);i=b;return}function tC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!((D_a(+h[(c[a+416>>2]|0)+64>>3],0.0)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[72300]|0;g=d;j=20720;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Pe[a&127](f,d,20688,e);i=b;return}function uC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!((D_a(+h[(c[a+416>>2]|0)+72>>3],0.0)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[72300]|0;g=d;j=20720;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Pe[a&127](f,d,20688,e);i=b;return}function vC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!((D_a(+h[(c[a+416>>2]|0)+80>>3],0.0)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[72300]|0;g=d;j=20720;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Pe[a&127](f,d,20688,e);i=b;return}function wC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!((D_a(+h[(c[a+416>>2]|0)+88>>3],0.0)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[72300]|0;g=d;j=20720;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Pe[a&127](f,d,20688,e);i=b;return}function xC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!((D_a(+h[(c[a+416>>2]|0)+96>>3],0.0)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[72300]|0;g=d;j=20720;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Pe[a&127](f,d,20688,e);i=b;return}function yC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!((D_a(+h[(c[a+416>>2]|0)+104>>3],0.0)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[72300]|0;g=d;j=20720;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Pe[a&127](f,d,20688,e);i=b;return}function zC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!((D_a(+h[(c[a+416>>2]|0)+112>>3],0.0)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[72300]|0;g=d;j=20720;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Pe[a&127](f,d,20688,e);i=b;return}function AC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!((D_a(+h[(c[a+416>>2]|0)+120>>3],0.0)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[72300]|0;g=d;j=20720;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Pe[a&127](f,d,20688,e);i=b;return}function BC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!((D_a(+h[(c[a+416>>2]|0)+128>>3],0.0)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[72300]|0;g=d;j=20720;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Pe[a&127](f,d,20688,e);i=b;return}function CC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!((D_a(+h[(c[a+416>>2]|0)+136>>3],0.0)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[72300]|0;g=d;j=20720;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Pe[a&127](f,d,20688,e);i=b;return}function DC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!((D_a(+h[(c[a+416>>2]|0)+144>>3],0.0)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[72300]|0;g=d;j=20720;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Pe[a&127](f,d,20688,e);i=b;return}function EC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!((D_a(+h[(c[a+416>>2]|0)+152>>3],0.0)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[72300]|0;g=d;j=20720;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Pe[a&127](f,d,20688,e);i=b;return}function FC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((E_a(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+632>>3],0.0)|0)<<24>>24==0)){i=b;return}g=RXa(RXa(RXa(RXa(20744,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+632>>3],0,1,6)|0)|0,20760)|0,20784)|0,20800)|0;j=RXa(RXa(g,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+624>>3],0,1,6)|0)|0,20832)|0;f=c[a+536>>2]|0;a=c[72300]|0;g=d;k=21112;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Pe[a&127](f,d,j,e);i=b;return}function GC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((E_a(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+616>>3],0.0)|0)<<24>>24==0)){i=b;return}g=RXa(RXa(RXa(RXa(20744,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+616>>3],0,1,6)|0)|0,20760)|0,20784)|0,20800)|0;j=RXa(RXa(g,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+608>>3],0,1,6)|0)|0,20832)|0;f=c[a+536>>2]|0;a=c[72300]|0;g=d;k=21112;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Pe[a&127](f,d,j,e);i=b;return}function HC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((E_a(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+600>>3],0.0)|0)<<24>>24==0)){i=b;return}g=RXa(RXa(RXa(RXa(20744,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+600>>3],0,1,6)|0)|0,20760)|0,20784)|0,20800)|0;j=RXa(RXa(g,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+592>>3],0,1,6)|0)|0,20832)|0;f=c[a+536>>2]|0;a=c[72300]|0;g=d;k=21112;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Pe[a&127](f,d,j,e);i=b;return}function IC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((E_a(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+584>>3],0.0)|0)<<24>>24==0)){i=b;return}g=RXa(RXa(RXa(RXa(20744,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+584>>3],0,1,6)|0)|0,20760)|0,20784)|0,20800)|0;j=RXa(RXa(g,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+576>>3],0,1,6)|0)|0,20832)|0;f=c[a+536>>2]|0;a=c[72300]|0;g=d;k=21112;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Pe[a&127](f,d,j,e);i=b;return}function JC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((E_a(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+568>>3],0.0)|0)<<24>>24==0)){i=b;return}g=RXa(RXa(RXa(RXa(20744,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+568>>3],0,1,6)|0)|0,20760)|0,20784)|0,20800)|0;j=RXa(RXa(g,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+560>>3],0,1,6)|0)|0,20832)|0;f=c[a+536>>2]|0;a=c[72300]|0;g=d;k=21112;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Pe[a&127](f,d,j,e);i=b;return}function KC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((E_a(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+552>>3],0.0)|0)<<24>>24==0)){i=b;return}g=RXa(RXa(RXa(RXa(20744,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+552>>3],0,1,6)|0)|0,20760)|0,20784)|0,20800)|0;j=RXa(RXa(g,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+544>>3],0,1,6)|0)|0,20832)|0;f=c[a+536>>2]|0;a=c[72300]|0;g=d;k=21112;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Pe[a&127](f,d,j,e);i=b;return}function LC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((E_a(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+536>>3],0.0)|0)<<24>>24==0)){i=b;return}g=RXa(RXa(RXa(RXa(20744,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+536>>3],0,1,6)|0)|0,20760)|0,20784)|0,20800)|0;j=RXa(RXa(g,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+528>>3],0,1,6)|0)|0,20832)|0;f=c[a+536>>2]|0;a=c[72300]|0;g=d;k=21112;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Pe[a&127](f,d,j,e);i=b;return}function MC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((E_a(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+520>>3],0.0)|0)<<24>>24==0)){i=b;return}g=RXa(RXa(RXa(RXa(20744,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+520>>3],0,1,6)|0)|0,20760)|0,20784)|0,20800)|0;j=RXa(RXa(g,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+512>>3],0,1,6)|0)|0,20832)|0;f=c[a+536>>2]|0;a=c[72300]|0;g=d;k=21112;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Pe[a&127](f,d,j,e);i=b;return}function NC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((E_a(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+504>>3],0.0)|0)<<24>>24==0)){i=b;return}g=RXa(RXa(RXa(RXa(20744,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+504>>3],0,1,6)|0)|0,20760)|0,20784)|0,20800)|0;j=RXa(RXa(g,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+496>>3],0,1,6)|0)|0,20832)|0;f=c[a+536>>2]|0;a=c[72300]|0;g=d;k=21112;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Pe[a&127](f,d,j,e);i=b;return}function OC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((E_a(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+488>>3],0.0)|0)<<24>>24==0)){i=b;return}g=RXa(RXa(RXa(RXa(20744,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+488>>3],0,1,6)|0)|0,20760)|0,20784)|0,20800)|0;j=RXa(RXa(g,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+480>>3],0,1,6)|0)|0,20832)|0;f=c[a+536>>2]|0;a=c[72300]|0;g=d;k=21112;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Pe[a&127](f,d,j,e);i=b;return}function PC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((E_a(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+472>>3],0.0)|0)<<24>>24==0)){i=b;return}g=RXa(RXa(RXa(RXa(20744,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+472>>3],0,1,6)|0)|0,20760)|0,20784)|0,20800)|0;j=RXa(RXa(g,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+464>>3],0,1,6)|0)|0,20832)|0;f=c[a+536>>2]|0;a=c[72300]|0;g=d;k=21112;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Pe[a&127](f,d,j,e);i=b;return}function QC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((E_a(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+456>>3],0.0)|0)<<24>>24==0)){i=b;return}g=RXa(RXa(RXa(RXa(20744,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+456>>3],0,1,6)|0)|0,20760)|0,20784)|0,20800)|0;j=RXa(RXa(g,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+448>>3],0,1,6)|0)|0,20832)|0;f=c[a+536>>2]|0;a=c[72300]|0;g=d;k=21112;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Pe[a&127](f,d,j,e);i=b;return}function RC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((E_a(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+440>>3],0.0)|0)<<24>>24==0)){i=b;return}g=RXa(RXa(RXa(RXa(20744,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+440>>3],0,1,6)|0)|0,20760)|0,20784)|0,20800)|0;j=RXa(RXa(g,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+432>>3],0,1,6)|0)|0,20832)|0;f=c[a+536>>2]|0;a=c[72300]|0;g=d;k=21112;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Pe[a&127](f,d,j,e);i=b;return}function SC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((E_a(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+424>>3],0.0)|0)<<24>>24==0)){i=b;return}g=RXa(RXa(RXa(RXa(20744,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+424>>3],0,1,6)|0)|0,20760)|0,20784)|0,20800)|0;j=RXa(RXa(g,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+416>>3],0,1,6)|0)|0,20832)|0;f=c[a+536>>2]|0;a=c[72300]|0;g=d;k=21112;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Pe[a&127](f,d,j,e);i=b;return}function TC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((E_a(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+408>>3],0.0)|0)<<24>>24==0)){i=b;return}g=RXa(RXa(RXa(RXa(20744,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+408>>3],0,1,6)|0)|0,20760)|0,20784)|0,20800)|0;j=RXa(RXa(g,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+400>>3],0,1,6)|0)|0,20832)|0;f=c[a+536>>2]|0;a=c[72300]|0;g=d;k=21112;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Pe[a&127](f,d,j,e);i=b;return}function UC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((E_a(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+392>>3],0.0)|0)<<24>>24==0)){i=b;return}g=RXa(RXa(RXa(RXa(20744,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+392>>3],0,1,6)|0)|0,20760)|0,20784)|0,20800)|0;j=RXa(RXa(g,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+384>>3],0,1,6)|0)|0,20832)|0;f=c[a+536>>2]|0;a=c[72300]|0;g=d;k=21112;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Pe[a&127](f,d,j,e);i=b;return}function VC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((E_a(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+376>>3],0.0)|0)<<24>>24==0)){i=b;return}g=RXa(RXa(RXa(RXa(20744,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+376>>3],0,1,6)|0)|0,20760)|0,20784)|0,20800)|0;j=RXa(RXa(g,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+368>>3],0,1,6)|0)|0,20832)|0;f=c[a+536>>2]|0;a=c[72300]|0;g=d;k=21112;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Pe[a&127](f,d,j,e);i=b;return}function WC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((E_a(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+360>>3],0.0)|0)<<24>>24==0)){i=b;return}g=RXa(RXa(RXa(RXa(20744,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+360>>3],0,1,6)|0)|0,20760)|0,20784)|0,20800)|0;j=RXa(RXa(g,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+352>>3],0,1,6)|0)|0,20832)|0;f=c[a+536>>2]|0;a=c[72300]|0;g=d;k=21112;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Pe[a&127](f,d,j,e);i=b;return}function XC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((E_a(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+344>>3],0.0)|0)<<24>>24==0)){i=b;return}g=RXa(RXa(RXa(RXa(20744,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+344>>3],0,1,6)|0)|0,20760)|0,20784)|0,20800)|0;j=RXa(RXa(g,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+336>>3],0,1,6)|0)|0,20832)|0;f=c[a+536>>2]|0;a=c[72300]|0;g=d;k=21112;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Pe[a&127](f,d,j,e);i=b;return}function YC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((E_a(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+328>>3],0.0)|0)<<24>>24==0)){i=b;return}g=RXa(RXa(RXa(RXa(20744,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+328>>3],0,1,6)|0)|0,20760)|0,20784)|0,20800)|0;j=RXa(RXa(g,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+320>>3],0,1,6)|0)|0,20832)|0;f=c[a+536>>2]|0;a=c[72300]|0;g=d;k=21112;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Pe[a&127](f,d,j,e);i=b;return}function ZC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((E_a(+h[f+2744>>3],+h[f+2768>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[72300]|0;g=d;j=21040;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Pe[a&127](f,d,20984,e);i=b;return}function _C(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((E_a(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+312>>3],0.0)|0)<<24>>24==0)){i=b;return}g=RXa(RXa(RXa(RXa(20744,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+312>>3],0,1,6)|0)|0,20760)|0,20784)|0,20800)|0;j=RXa(RXa(g,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+304>>3],0,1,6)|0)|0,20832)|0;f=c[a+536>>2]|0;a=c[72300]|0;g=d;k=21112;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Pe[a&127](f,d,j,e);i=b;return}function $C(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((E_a(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+296>>3],0.0)|0)<<24>>24==0)){i=b;return}g=RXa(RXa(RXa(RXa(20744,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+296>>3],0,1,6)|0)|0,20760)|0,20784)|0,20800)|0;j=RXa(RXa(g,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+288>>3],0,1,6)|0)|0,20832)|0;f=c[a+536>>2]|0;a=c[72300]|0;g=d;k=21112;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Pe[a&127](f,d,j,e);i=b;return}function aD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((E_a(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+280>>3],0.0)|0)<<24>>24==0)){i=b;return}g=RXa(RXa(RXa(RXa(20744,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+280>>3],0,1,6)|0)|0,20760)|0,20784)|0,20800)|0;j=RXa(RXa(g,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+272>>3],0,1,6)|0)|0,20832)|0;f=c[a+536>>2]|0;a=c[72300]|0;g=d;k=21112;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Pe[a&127](f,d,j,e);i=b;return}function bD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((E_a(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+264>>3],0.0)|0)<<24>>24==0)){i=b;return}g=RXa(RXa(RXa(RXa(20744,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+264>>3],0,1,6)|0)|0,20760)|0,20784)|0,20800)|0;j=RXa(RXa(g,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+256>>3],0,1,6)|0)|0,20832)|0;f=c[a+536>>2]|0;a=c[72300]|0;g=d;k=21112;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Pe[a&127](f,d,j,e);i=b;return}function cD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((E_a(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+248>>3],0.0)|0)<<24>>24==0)){i=b;return}g=RXa(RXa(RXa(RXa(20744,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+248>>3],0,1,6)|0)|0,20760)|0,20784)|0,20800)|0;j=RXa(RXa(g,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+240>>3],0,1,6)|0)|0,20832)|0;f=c[a+536>>2]|0;a=c[72300]|0;g=d;k=21112;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Pe[a&127](f,d,j,e);i=b;return}function dD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((E_a(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+232>>3],0.0)|0)<<24>>24==0)){i=b;return}g=RXa(RXa(RXa(RXa(20744,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+232>>3],0,1,6)|0)|0,20760)|0,20784)|0,20800)|0;j=RXa(RXa(g,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+224>>3],0,1,6)|0)|0,20832)|0;f=c[a+536>>2]|0;a=c[72300]|0;g=d;k=21112;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Pe[a&127](f,d,j,e);i=b;return}function eD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((E_a(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+216>>3],0.0)|0)<<24>>24==0)){i=b;return}g=RXa(RXa(RXa(RXa(20744,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+216>>3],0,1,6)|0)|0,20760)|0,20784)|0,20800)|0;j=RXa(RXa(g,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+208>>3],0,1,6)|0)|0,20832)|0;f=c[a+536>>2]|0;a=c[72300]|0;g=d;k=21112;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Pe[a&127](f,d,j,e);i=b;return}function fD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((E_a(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+200>>3],0.0)|0)<<24>>24==0)){i=b;return}g=RXa(RXa(RXa(RXa(20744,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+200>>3],0,1,6)|0)|0,20760)|0,20784)|0,20800)|0;j=RXa(RXa(g,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+192>>3],0,1,6)|0)|0,20832)|0;f=c[a+536>>2]|0;a=c[72300]|0;g=d;k=21112;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Pe[a&127](f,d,j,e);i=b;return}function gD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((E_a(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+184>>3],0.0)|0)<<24>>24==0)){i=b;return}g=RXa(RXa(RXa(RXa(20744,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+184>>3],0,1,6)|0)|0,20760)|0,20784)|0,20800)|0;j=RXa(RXa(g,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+176>>3],0,1,6)|0)|0,20832)|0;f=c[a+536>>2]|0;a=c[72300]|0;g=d;k=21112;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Pe[a&127](f,d,j,e);i=b;return}function hD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((E_a(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+168>>3],0.0)|0)<<24>>24==0)){i=b;return}g=RXa(RXa(RXa(RXa(20744,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+168>>3],0,1,6)|0)|0,20760)|0,20784)|0,20800)|0;j=RXa(RXa(g,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+160>>3],0,1,6)|0)|0,20832)|0;f=c[a+536>>2]|0;a=c[72300]|0;g=d;k=21112;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Pe[a&127](f,d,j,e);i=b;return}function iD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((E_a(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+152>>3],0.0)|0)<<24>>24==0)){i=b;return}g=RXa(RXa(RXa(RXa(20744,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+152>>3],0,1,6)|0)|0,20760)|0,20784)|0,20800)|0;j=RXa(RXa(g,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+144>>3],0,1,6)|0)|0,20832)|0;f=c[a+536>>2]|0;a=c[72300]|0;g=d;k=21112;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Pe[a&127](f,d,j,e);i=b;return}function jD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((E_a(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+136>>3],0.0)|0)<<24>>24==0)){i=b;return}g=RXa(RXa(RXa(RXa(20744,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+136>>3],0,1,6)|0)|0,20760)|0,20784)|0,20800)|0;j=RXa(RXa(g,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+128>>3],0,1,6)|0)|0,20832)|0;f=c[a+536>>2]|0;a=c[72300]|0;g=d;k=21112;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Pe[a&127](f,d,j,e);i=b;return}function kD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((E_a(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+120>>3],0.0)|0)<<24>>24==0)){i=b;return}g=RXa(RXa(RXa(RXa(20744,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+120>>3],0,1,6)|0)|0,20760)|0,20784)|0,20800)|0;j=RXa(RXa(g,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+112>>3],0,1,6)|0)|0,20832)|0;f=c[a+536>>2]|0;a=c[72300]|0;g=d;k=21112;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Pe[a&127](f,d,j,e);i=b;return}function lD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((E_a(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+104>>3],0.0)|0)<<24>>24==0)){i=b;return}g=RXa(RXa(RXa(RXa(20744,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+104>>3],0,1,6)|0)|0,20760)|0,20784)|0,20800)|0;j=RXa(RXa(g,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+96>>3],0,1,6)|0)|0,20832)|0;f=c[a+536>>2]|0;a=c[72300]|0;g=d;k=21112;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Pe[a&127](f,d,j,e);i=b;return}function mD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((E_a(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+88>>3],0.0)|0)<<24>>24==0)){i=b;return}g=RXa(RXa(RXa(RXa(20744,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+88>>3],0,1,6)|0)|0,20760)|0,20784)|0,20800)|0;j=RXa(RXa(g,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+80>>3],0,1,6)|0)|0,20832)|0;f=c[a+536>>2]|0;a=c[72300]|0;g=d;k=21112;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Pe[a&127](f,d,j,e);i=b;return}function nD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((E_a(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+72>>3],0.0)|0)<<24>>24==0)){i=b;return}g=RXa(RXa(RXa(RXa(20744,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+72>>3],0,1,6)|0)|0,20760)|0,20784)|0,20800)|0;j=RXa(RXa(g,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+64>>3],0,1,6)|0)|0,20832)|0;f=c[a+536>>2]|0;a=c[72300]|0;g=d;k=21112;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Pe[a&127](f,d,j,e);i=b;return}function oD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((E_a(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+56>>3],0.0)|0)<<24>>24==0)){i=b;return}g=RXa(RXa(RXa(RXa(20744,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+56>>3],0,1,6)|0)|0,20760)|0,20784)|0,20800)|0;j=RXa(RXa(g,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+48>>3],0,1,6)|0)|0,20832)|0;f=c[a+536>>2]|0;a=c[72300]|0;g=d;k=21112;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Pe[a&127](f,d,j,e);i=b;return}function pD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((E_a(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+40>>3],0.0)|0)<<24>>24==0)){i=b;return}g=RXa(RXa(RXa(RXa(20744,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+40>>3],0,1,6)|0)|0,20760)|0,20784)|0,20800)|0;j=RXa(RXa(g,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+32>>3],0,1,6)|0)|0,20832)|0;f=c[a+536>>2]|0;a=c[72300]|0;g=d;k=21112;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Pe[a&127](f,d,j,e);i=b;return}function qD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((E_a(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+24>>3],0.0)|0)<<24>>24==0)){i=b;return}g=RXa(RXa(RXa(RXa(20744,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+24>>3],0,1,6)|0)|0,20760)|0,20784)|0,20800)|0;j=RXa(RXa(g,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+16>>3],0,1,6)|0)|0,20832)|0;f=c[a+536>>2]|0;a=c[72300]|0;g=d;k=21112;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Pe[a&127](f,d,j,e);i=b;return}function rD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((E_a(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8>>3],0.0)|0)<<24>>24==0)){i=b;return}g=RXa(RXa(RXa(RXa(20744,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8>>3],0,1,6)|0)|0,20760)|0,20784)|0,20800)|0;j=RXa(RXa(g,PXa(+h[c[(c[c[f>>2]>>2]|0)+8>>2]>>3],0,1,6)|0)|0,20832)|0;f=c[a+536>>2]|0;a=c[72300]|0;g=d;k=21112;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Pe[a&127](f,d,j,e);i=b;return}function sD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((E_a(+h[f+2976>>3],+h[f+3e3>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[72300]|0;g=d;j=21040;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Pe[a&127](f,d,20984,e);i=b;return}function tD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+40|0;d=b;e=b+16|0;f=i;i=i+8|0;g=i;i=i+16|0;h=i;i=i+16|0;MYa(g,1,21064,f);iYa(h,1,1.0,b+32|0);f=c[a+536>>2]|0;a=e;j=g;c[a+0>>2]=c[j+0>>2];c[a+4>>2]=c[j+4>>2];c[a+8>>2]=c[j+8>>2];j=d;a=h;c[j+0>>2]=c[a+0>>2];c[j+4>>2]=c[a+4>>2];c[j+8>>2]=c[a+8>>2];XD(f,20784,e,0,1,d,21072);i=b;return}function uD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+40|0;d=b;e=b+16|0;f=i;i=i+8|0;g=i;i=i+16|0;h=i;i=i+16|0;MYa(g,1,21064,f);iYa(h,1,1.0,b+32|0);f=c[a+536>>2]|0;a=e;j=g;c[a+0>>2]=c[j+0>>2];c[a+4>>2]=c[j+4>>2];c[a+8>>2]=c[j+8>>2];j=d;a=h;c[j+0>>2]=c[a+0>>2];c[j+4>>2]=c[a+4>>2];c[j+8>>2]=c[a+8>>2];XD(f,20784,e,0,1,d,21072);i=b;return}function vD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((E_a(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8>>3],0.0)|0)<<24>>24==0)){i=b;return}g=RXa(RXa(RXa(RXa(20744,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8>>3],0,1,6)|0)|0,20760)|0,20784)|0,20800)|0;f=RXa(RXa(g,PXa(360.0,0,1,6)|0)|0,20832)|0;g=c[a+536>>2]|0;a=c[72300]|0;j=d;k=21112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Pe[a&127](g,d,f,e);i=b;return}function wD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+40|0;d=b;e=b+16|0;f=i;i=i+8|0;g=i;i=i+16|0;h=i;i=i+16|0;MYa(g,1,21064,f);iYa(h,1,1.0,b+32|0);f=c[a+536>>2]|0;a=e;j=g;c[a+0>>2]=c[j+0>>2];c[a+4>>2]=c[j+4>>2];c[a+8>>2]=c[j+8>>2];j=d;a=h;c[j+0>>2]=c[a+0>>2];c[j+4>>2]=c[a+4>>2];c[j+8>>2]=c[a+8>>2];XD(f,20784,e,0,1,d,21088);i=b;return}function xD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((E_a(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+632>>3],0.0)|0)<<24>>24==0)){i=b;return}g=RXa(RXa(RXa(RXa(20744,PXa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+632>>3],0,1,6)|0)|0,20760)|0,20784)|0,20800)|0;f=RXa(RXa(g,PXa(300.0,0,1,6)|0)|0,20832)|0;g=c[a+536>>2]|0;a=c[72300]|0;j=d;k=21112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Pe[a&127](g,d,f,e);i=b;return}function yD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+40|0;d=b;e=b+16|0;f=i;i=i+8|0;g=i;i=i+16|0;h=i;i=i+16|0;MYa(g,1,21064,f);iYa(h,1,1.0,b+32|0);f=c[a+536>>2]|0;a=e;j=g;c[a+0>>2]=c[j+0>>2];c[a+4>>2]=c[j+4>>2];c[a+8>>2]=c[j+8>>2];j=d;a=h;c[j+0>>2]=c[a+0>>2];c[j+4>>2]=c[a+4>>2];c[j+8>>2]=c[a+8>>2];XD(f,20784,e,0,1,d,21088);i=b;return}function zD(b){b=b|0;var c=0;c=i;a[b+315|0]=0;a[b+314|0]=1;kf(b);lf(b);mf(b);nf(b);of(b);pf(b);qf(b);rf(b);sf(b);tf(b);uf(b);vf(b);wf(b);xf(b);yf(b);zf(b);Af(b);Bf(b);Cf(b);Df(b);Ef(b);Ff(b);Gf(b);Hf(b);If(b);Jf(b);Kf(b);Lf(b);Mf(b);Nf(b);Of(b);Pf(b);Qf(b);Rf(b);Sf(b);Tf(b);Uf(b);Vf(b);Wf(b);Xf(b);Yf(b);Zf(b);_f(b);$f(b);ag(b);bg(b);cg(b);dg(b);eg(b);fg(b);gg(b);hg(b);ig(b);jg(b);kg(b);lg(b);mg(b);ng(b);og(b);pg(b);qg(b);rg(b);sg(b);tg(b);ug(b);vg(b);wg(b);xg(b);yg(b);zg(b);Ag(b);Bg(b);Cg(b);Dg(b);Eg(b);Fg(b);Gg(b);Hg(b);Ig(b);Jg(b);Kg(b);Lg(b);Mg(b);Ng(b);Og(b);Pg(b);Qg(b);Rg(b);Sg(b);Tg(b);Ug(b);Vg(b);Wg(b);Xg(b);Yg(b);Zg(b);_g(b);$g(b);ah(b);bh(b);ch(b);dh(b);eh(b);fh(b);gh(b);hh(b);ih(b);jh(b);kh(b);lh(b);mh(b);nh(b);oh(b);ph(b);qh(b);rh(b);sh(b);th(b);uh(b);vh(b);wh(b);xh(b);yh(b);zh(b);Ah(b);Bh(b);Ch(b);Dh(b);Eh(b);Fh(b);Gh(b);Hh(b);Ih(b);Jh(b);Kh(b);Lh(b);Mh(b);Nh(b);Oh(b);Ph(b);Qh(b);Rh(b);Sh(b);Th(b);Uh(b);Vh(b);Wh(b);Xh(b);Yh(b);Zh(b);_h(b);$h(b);ai(b);bi(b);ci(b);di(b);ei(b);fi(b);gi(b);hi(b);ii(b);ji(b);ki(b);li(b);mi(b);ni(b);oi(b);pi(b);qi(b);ri(b);si(b);ti(b);ui(b);vi(b);wi(b);xi(b);yi(b);zi(b);Ai(b);Bi(b);Ci(b);Di(b);Ei(b);Fi(b);Gi(b);Hi(b);Ii(b);Ji(b);Ki(b);Li(b);Mi(b);Ni(b);Oi(b);Pi(b);Qi(b);Ri(b);Si(b);Ti(b);Ui(b);Vi(b);Wi(b);Xi(b);Yi(b);Zi(b);_i(b);$i(b);aj(b);bj(b);cj(b);dj(b);ej(b);fj(b);gj(b);hj(b);ij(b);jj(b);kj(b);lj(b);mj(b);nj(b);oj(b);pj(b);qj(b);rj(b);sj(b);tj(b);uj(b);vj(b);wj(b);xj(b);yj(b);zj(b);Aj(b);Bj(b);Cj(b);Dj(b);Ej(b);Fj(b);Gj(b);Hj(b);Ij(b);Jj(b);Kj(b);Lj(b);Mj(b);Nj(b);Oj(b);Pj(b);Qj(b);Rj(b);Sj(b);Tj(b);Uj(b);Vj(b);Wj(b);Xj(b);Yj(b);Zj(b);_j(b);$j(b);ak(b);bk(b);ck(b);dk(b);ek(b);fk(b);gk(b);hk(b);ik(b);jk(b);kk(b);lk(b);mk(b);nk(b);ok(b);pk(b);qk(b);rk(b);sk(b);tk(b);uk(b);vk(b);wk(b);xk(b);yk(b);zk(b);Ak(b);Bk(b);Ck(b);Dk(b);Ek(b);Fk(b);Gk(b);Hk(b);Ik(b);Jk(b);Kk(b);Lk(b);Mk(b);Nk(b);Ok(b);Pk(b);Qk(b);Rk(b);Sk(b);Tk(b);Uk(b);Vk(b);Wk(b);Xk(b);Yk(b);Zk(b);_k(b);$k(b);al(b);bl(b);cl(b);dl(b);el(b);fl(b);gl(b);hl(b);il(b);jl(b);kl(b);ll(b);ml(b);nl(b);ol(b);pl(b);ql(b);rl(b);sl(b);tl(b);ul(b);vl(b);wl(b);xl(b);yl(b);zl(b);Al(b);Bl(b);Cl(b);Dl(b);El(b);Fl(b);Gl(b);Hl(b);Il(b);Jl(b);Kl(b);Ll(b);Ml(b);Nl(b);Ol(b);Pl(b);Ql(b);Rl(b);Sl(b);Tl(b);Ul(b);Vl(b);Wl(b);Xl(b);Yl(b);Zl(b);_l(b);$l(b);am(b);bm(b);cm(b);dm(b);em(b);fm(b);gm(b);hm(b);im(b);jm(b);km(b);lm(b);mm(b);nm(b);om(b);pm(b);qm(b);rm(b);sm(b);tm(b);um(b);vm(b);wm(b);xm(b);ym(b);zm(b);Am(b);Bm(b);Cm(b);Dm(b);Em(b);Fm(b);Gm(b);Hm(b);Im(b);Jm(b);Km(b);Lm(b);Mm(b);Nm(b);Om(b);Pm(b);Qm(b);Rm(b);Sm(b);Tm(b);Um(b);Vm(b);Wm(b);Xm(b);Ym(b);Zm(b);_m(b);$m(b);an(b);bn(b);cn(b);dn(b);en(b);fn(b);gn(b);hn(b);jn(b);kn(b);ln(b);mn(b);nn(b);on(b);pn(b);qn(b);rn(b);sn(b);tn(b);un(b);vn(b);wn(b);xn(b);yn(b);zn(b);An(b);Bn(b);Cn(b);Dn(b);En(b);Fn(b);Gn(b);Hn(b);In(b);Jn(b);Kn(b);Ln(b);Mn(b);Nn(b);On(b);Pn(b);Qn(b);Rn(b);Sn(b);Tn(b);Un(b);Vn(b);Wn(b);Xn(b);Yn(b);Zn(b);_n(b);$n(b);ao(b);bo(b);co(b);eo(b);fo(b);go(b);ho(b);io(b);jo(b);ko(b);lo(b);mo(b);no(b);oo(b);po(b);qo(b);ro(b);so(b);to(b);uo(b);vo(b);wo(b);xo(b);yo(b);zo(b);Ao(b);Bo(b);Co(b);Do(b);Eo(b);Fo(b);Go(b);Ho(b);Io(b);Jo(b);Ko(b);Lo(b);Mo(b);No(b);Oo(b);Po(b);Qo(b);Ro(b);So(b);To(b);Uo(b);Vo(b);Wo(b);Xo(b);Yo(b);Zo(b);_o(b);$o(b);ap(b);bp(b);cp(b);dp(b);ep(b);fp(b);gp(b);hp(b);ip(b);jp(b);kp(b);lp(b);mp(b);np(b);op(b);pp(b);qp(b);rp(b);sp(b);tp(b);up(b);vp(b);wp(b);xp(b);yp(b);zp(b);Ap(b);Bp(b);Cp(b);Dp(b);Ep(b);Fp(b);Gp(b);Hp(b);Ip(b);Jp(b);Kp(b);Lp(b);Mp(b);Np(b);Op(b);Pp(b);Qp(b);Rp(b);Sp(b);Tp(b);Up(b);Vp(b);Wp(b);Xp(b);Yp(b);Zp(b);_p(b);$p(b);aq(b);bq(b);cq(b);dq(b);eq(b);fq(b);gq(b);hq(b);iq(b);jq(b);kq(b);lq(b);mq(b);nq(b);oq(b);pq(b);qq(b);rq(b);sq(b);tq(b);uq(b);vq(b);wq(b);xq(b);yq(b);zq(b);Aq(b);Bq(b);Cq(b);Dq(b);Eq(b);Fq(b);Gq(b);Hq(b);Iq(b);Jq(b);Kq(b);Lq(b);Mq(b);Nq(b);Oq(b);Pq(b);Qq(b);Rq(b);Sq(b);Tq(b);Uq(b);Vq(b);Wq(b);Xq(b);Yq(b);Zq(b);_q(b);$q(b);ar(b);br(b);cr(b);dr(b);er(b);fr(b);gr(b);hr(b);ir(b);jr(b);kr(b);lr(b);mr(b);nr(b);or(b);pr(b);qr(b);rr(b);sr(b);tr(b);ur(b);vr(b);wr(b);xr(b);yr(b);zr(b);Ar(b);Br(b);Cr(b);Dr(b);Er(b);Fr(b);Gr(b);Hr(b);Ir(b);Jr(b);Kr(b);Lr(b);Mr(b);Nr(b);Or(b);Pr(b);Qr(b);Rr(b);Sr(b);Tr(b);Ur(b);Vr(b);Wr(b);Xr(b);Yr(b);Zr(b);_r(b);$r(b);as(b);bs(b);cs(b);ds(b);es(b);fs(b);gs(b);hs(b);is(b);js(b);ks(b);ls(b);ms(b);ns(b);os(b);ps(b);qs(b);rs(b);ss(b);ts(b);us(b);vs(b);ws(b);xs(b);ys(b);zs(b);As(b);Bs(b);Cs(b);Ds(b);Es(b);Fs(b);Gs(b);Hs(b);Is(b);Js(b);Ks(b);Ls(b);Ms(b);Ns(b);Os(b);Ps(b);Qs(b);Rs(b);Ss(b);Ts(b);Us(b);Vs(b);Ws(b);Xs(b);Ys(b);Zs(b);_s(b);$s(b);at(b);bt(b);ct(b);dt(b);et(b);ft(b);gt(b);ht(b);it(b);jt(b);kt(b);lt(b);mt(b);nt(b);ot(b);pt(b);qt(b);rt(b);st(b);tt(b);ut(b);vt(b);wt(b);xt(b);yt(b);zt(b);At(b);Bt(b);Ct(b);Dt(b);Et(b);Ft(b);Gt(b);Ht(b);It(b);Jt(b);Kt(b);Lt(b);Mt(b);Nt(b);Ot(b);Pt(b);Qt(b);Rt(b);St(b);Tt(b);Ut(b);Vt(b);Wt(b);Xt(b);Yt(b);Zt(b);_t(b);$t(b);au(b);bu(b);cu(b);du(b);eu(b);fu(b);gu(b);hu(b);iu(b);ju(b);ku(b);lu(b);mu(b);nu(b);ou(b);pu(b);qu(b);ru(b);su(b);tu(b);uu(b);vu(b);wu(b);xu(b);yu(b);zu(b);Au(b);Bu(b);Cu(b);Du(b);Eu(b);Fu(b);Gu(b);Hu(b);Iu(b);Ju(b);Ku(b);Lu(b);Mu(b);Nu(b);Ou(b);Pu(b);Qu(b);Ru(b);Su(b);Tu(b);Uu(b);Vu(b);Wu(b);Xu(b);Yu(b);Zu(b);_u(b);$u(b);av(b);bv(b);cv(b);dv(b);ev(b);fv(b);gv(b);hv(b);iv(b);jv(b);kv(b);lv(b);mv(b);nv(b);ov(b);pv(b);qv(b);rv(b);sv(b);tv(b);uv(b);vv(b);wv(b);xv(b);yv(b);zv(b);Av(b);Bv(b);Cv(b);Dv(b);Ev(b);Fv(b);Gv(b);Hv(b);Iv(b);Jv(b);Kv(b);Lv(b);Mv(b);Nv(b);Ov(b);Pv(b);Qv(b);Rv(b);Sv(b);Tv(b);Uv(b);Vv(b);Wv(b);Xv(b);Yv(b);Zv(b);_v(b);$v(b);aw(b);bw(b);cw(b);dw(b);ew(b);fw(b);gw(b);hw(b);iw(b);jw(b);kw(b);lw(b);mw(b);nw(b);ow(b);pw(b);qw(b);rw(b);sw(b);tw(b);uw(b);vw(b);ww(b);xw(b);yw(b);zw(b);Aw(b);Bw(b);Cw(b);Dw(b);Ew(b);Fw(b);Gw(b);Hw(b);Iw(b);Jw(b);Kw(b);Lw(b);Mw(b);Nw(b);Ow(b);Pw(b);Qw(b);Rw(b);Sw(b);Tw(b);Uw(b);Vw(b);Ww(b);Xw(b);Yw(b);Zw(b);_w(b);$w(b);ax(b);bx(b);cx(b);dx(b);ex(b);fx(b);gx(b);hx(b);ix(b);jx(b);kx(b);lx(b);mx(b);nx(b);ox(b);px(b);qx(b);rx(b);sx(b);tx(b);ux(b);vx(b);wx(b);xx(b);yx(b);zx(b);Ax(b);Bx(b);Cx(b);Dx(b);Ex(b);Fx(b);Gx(b);Hx(b);Ix(b);Jx(b);Kx(b);Lx(b);Mx(b);Nx(b);Ox(b);Px(b);Qx(b);Rx(b);Sx(b);Tx(b);Ux(b);Vx(b);Wx(b);Xx(b);Yx(b);Zx(b);_x(b);$x(b);ay(b);by(b);cy(b);dy(b);ey(b);fy(b);gy(b);hy(b);iy(b);jy(b);ky(b);ly(b);my(b);ny(b);oy(b);py(b);qy(b);ry(b);sy(b);ty(b);uy(b);vy(b);wy(b);xy(b);yy(b);zy(b);Ay(b);By(b);Cy(b);Dy(b);Ey(b);Fy(b);Gy(b);Hy(b);Iy(b);Jy(b);Ky(b);Ly(b);My(b);Ny(b);Oy(b);Py(b);Qy(b);Ry(b);Sy(b);Ty(b);Uy(b);Vy(b);Wy(b);Xy(b);Yy(b);Zy(b);_y(b);$y(b);az(b);bz(b);cz(b);dz(b);ez(b);fz(b);gz(b);hz(b);iz(b);jz(b);kz(b);lz(b);mz(b);nz(b);oz(b);pz(b);qz(b);rz(b);sz(b);tz(b);uz(b);vz(b);wz(b);xz(b);yz(b);zz(b);Az(b);Bz(b);Cz(b);Dz(b);Ez(b);Fz(b);Gz(b);Hz(b);Iz(b);Jz(b);Kz(b);Lz(b);Mz(b);Nz(b);Oz(b);Pz(b);Qz(b);Rz(b);Sz(b);Tz(b);Uz(b);Vz(b);Wz(b);Xz(b);Yz(b);Zz(b);_z(b);$z(b);aA(b);bA(b);cA(b);dA(b);eA(b);fA(b);gA(b);hA(b);iA(b);jA(b);kA(b);lA(b);mA(b);nA(b);oA(b);pA(b);qA(b);rA(b);sA(b);tA(b);uA(b);vA(b);wA(b);xA(b);yA(b);zA(b);AA(b);BA(b);CA(b);DA(b);EA(b);FA(b);GA(b);HA(b);IA(b);JA(b);KA(b);LA(b);MA(b);NA(b);OA(b);PA(b);QA(b);RA(b);SA(b);TA(b);UA(b);VA(b);WA(b);XA(b);YA(b);ZA(b);_A(b);$A(b);aB(b);bB(b);cB(b);dB(b);eB(b);fB(b);gB(b);hB(b);iB(b);jB(b);kB(b);lB(b);mB(b);nB(b);oB(b);pB(b);qB(b);rB(b);sB(b);tB(b);uB(b);vB(b);wB(b);xB(b);yB(b);zB(b);AB(b);BB(b);CB(b);DB(b);EB(b);FB(b);GB(b);HB(b);IB(b);JB(b);KB(b);LB(b);MB(b);NB(b);OB(b);PB(b);QB(b);RB(b);SB(b);TB(b);UB(b);VB(b);WB(b);XB(b);YB(b);ZB(b);_B(b);$B(b);aC(b);bC(b);cC(b);dC(b);eC(b);fC(b);gC(b);hC(b);iC(b);jC(b);kC(b);lC(b);mC(b);nC(b);oC(b);pC(b);qC(b);rC(b);sC(b);tC(b);uC(b);vC(b);wC(b);xC(b);yC(b);zC(b);AC(b);BC(b);CC(b);DC(b);EC(b);FC(b);GC(b);HC(b);IC(b);JC(b);KC(b);LC(b);MC(b);NC(b);OC(b);PC(b);QC(b);RC(b);SC(b);TC(b);UC(b);VC(b);WC(b);XC(b);YC(b);ZC(b);_C(b);$C(b);aD(b);bD(b);cD(b);dD(b);eD(b);fD(b);gD(b);hD(b);iD(b);jD(b);kD(b);lD(b);mD(b);nD(b);oD(b);pD(b);qD(b);rD(b);sD(b);tD(b);uD(b);vD(b);wD(b);xD(b);yD(b);i=c;return 0}function AD(b){b=b|0;var c=0;c=i;a[b+314|0]=0;BD(b);i=c;return 0}function BD(a){a=a|0;var b=0;b=i;Mg(a);Ng(a);Og(a);Pg(a);Qg(a);Rg(a);Sg(a);Tg(a);Ug(a);Vg(a);Wg(a);Xg(a);Yg(a);Zg(a);_g(a);$g(a);ah(a);bh(a);ch(a);dh(a);fh(a);gh(a);hh(a);ih(a);jh(a);kh(a);lh(a);mh(a);nh(a);oh(a);ph(a);qh(a);rh(a);sh(a);th(a);uh(a);vh(a);wh(a);xh(a);yh(a);zh(a);Ah(a);Bh(a);Ch(a);Dh(a);Eh(a);Fh(a);Gh(a);Hh(a);Ih(a);Jh(a);Kh(a);Lh(a);Mh(a);Nh(a);Oh(a);Ph(a);Qh(a);Rh(a);Sh(a);li(a);mi(a);ni(a);oi(a);pi(a);qi(a);ri(a);si(a);ti(a);ui(a);vi(a);wi(a);xi(a);yi(a);zi(a);Ai(a);Bi(a);Ci(a);Di(a);Ei(a);Fi(a);Gi(a);Hi(a);Ii(a);Ji(a);Ki(a);Li(a);Mi(a);Ni(a);Oi(a);Pi(a);Qi(a);Ri(a);Si(a);Ti(a);Ui(a);Vi(a);Wi(a);Xi(a);Yi(a);rj(a);xj(a);Dj(a);Ej(a);Fj(a);Gj(a);Hj(a);Ij(a);Kj(a);Lj(a);Mj(a);Nj(a);Oj(a);Qj(a);Rj(a);Sj(a);Tj(a);Wj(a);Xj(a);Zj(a);_j(a);$j(a);ak(a);bk(a);ck(a);dk(a);ek(a);fk(a);hk(a);ik(a);jk(a);kk(a);nk(a);ok(a);qk(a);rk(a);sk(a);tk(a);uk(a);vk(a);wk(a);xk(a);yk(a);Ak(a);Bk(a);Ck(a);Dk(a);Gk(a);Hk(a);Jk(a);Kk(a);Lk(a);Mk(a);Nk(a);Ok(a);Pk(a);Qk(a);Rk(a);Tk(a);Uk(a);Vk(a);Wk(a);Zk(a);_k(a);al(a);bl(a);cl(a);dl(a);el(a);fl(a);gl(a);hl(a);il(a);kl(a);ll(a);ml(a);nl(a);ql(a);rl(a);tl(a);ul(a);vl(a);wl(a);xl(a);yl(a);zl(a);Al(a);Bl(a);Dl(a);El(a);Fl(a);Gl(a);Jl(a);Kl(a);Ml(a);Nl(a);Ol(a);Pl(a);Ql(a);Rl(a);Sl(a);Tl(a);Ul(a);Wl(a);Xl(a);Yl(a);Zl(a);am(a);bm(a);dm(a);em(a);fm(a);gm(a);hm(a);im(a);jm(a);km(a);lm(a);nm(a);om(a);pm(a);qm(a);tm(a);um(a);wm(a);xm(a);ym(a);zm(a);Am(a);Bm(a);Cm(a);Dm(a);Em(a);Gm(a);Hm(a);Im(a);Jm(a);Mm(a);Nm(a);Pm(a);Qm(a);Rm(a);Sm(a);Tm(a);Um(a);Vm(a);Wm(a);Xm(a);Zm(a);_m(a);$m(a);an(a);dn(a);en(a);gn(a);hn(a);jn(a);kn(a);ln(a);mn(a);nn(a);on(a);pn(a);rn(a);sn(a);tn(a);un(a);xn(a);yn(a);An(a);Bn(a);Cn(a);Dn(a);En(a);Fn(a);Gn(a);Hn(a);In(a);Kn(a);Ln(a);Mn(a);Nn(a);Qn(a);Rn(a);Tn(a);Un(a);Vn(a);Wn(a);Xn(a);Yn(a);Zn(a);_n(a);$n(a);bo(a);co(a);eo(a);fo(a);io(a);jo(a);lo(a);mo(a);no(a);oo(a);po(a);qo(a);ro(a);so(a);to(a);vo(a);wo(a);xo(a);yo(a);Bo(a);Co(a);Eo(a);Fo(a);Go(a);Ho(a);Io(a);Jo(a);Ko(a);Lo(a);Mo(a);Oo(a);Po(a);Qo(a);Ro(a);Uo(a);Vo(a);Xo(a);Yo(a);Zo(a);_o(a);$o(a);ap(a);bp(a);cp(a);dp(a);fp(a);gp(a);hp(a);ip(a);lp(a);mp(a);op(a);pp(a);qp(a);rp(a);sp(a);tp(a);up(a);vp(a);wp(a);yp(a);zp(a);Ap(a);Bp(a);Ep(a);Fp(a);Hp(a);Ip(a);Jp(a);Kp(a);Lp(a);Mp(a);Np(a);Op(a);Pp(a);Rp(a);Sp(a);Tp(a);Up(a);Xp(a);Yp(a);_p(a);$p(a);aq(a);bq(a);cq(a);dq(a);eq(a);fq(a);gq(a);iq(a);jq(a);kq(a);lq(a);oq(a);qq(a);rq(a);vq(a);wq(a);xq(a);yq(a);Aq(a);Bq(a);Cq(a);Dq(a);Eq(a);Fq(a);Gq(a);Hq(a);Iq(a);Jq(a);Kq(a);Lq(a);Mq(a);Nq(a);Oq(a);Pq(a);Uq(a);Vq(a);Xq(a);Yq(a);Zq(a);_q(a);$q(a);ar(a);br(a);cr(a);er(a);fr(a);gr(a);hr(a);ir(a);jr(a);kr(a);lr(a);mr(a);nr(a);or(a);pr(a);qr(a);tr(a);ur(a);wr(a);xr(a);yr(a);zr(a);Ar(a);Br(a);Cr(a);Dr(a);Er(a);Fr(a);Gr(a);Hr(a);Jr(a);Kr(a);Lr(a);Mr(a);Nr(a);Or(a);Pr(a);Qr(a);Rr(a);Sr(a);Tr(a);Ur(a);Vr(a);Yr(a);Zr(a);$r(a);as(a);bs(a);cs(a);ds(a);es(a);fs(a);gs(a);hs(a);is(a);js(a);ks(a);ms(a);ns(a);os(a);ps(a);qs(a);rs(a);ss(a);ts(a);us(a);vs(a);ws(a);xs(a);ys(a);Bs(a);Cs(a);Es(a);Fs(a);Gs(a);Hs(a);Is(a);Js(a);Ks(a);Ls(a);Ms(a);Ns(a);Os(a);Ps(a);Rs(a);Ss(a);Ts(a);Us(a);Vs(a);Ws(a);Xs(a);Ys(a);Zs(a);_s(a);$s(a);at(a);bt(a);et(a);ft(a);ht(a);it(a);jt(a);kt(a);lt(a);mt(a);nt(a);ot(a);pt(a);qt(a);rt(a);st(a);ut(a);vt(a);wt(a);xt(a);yt(a);zt(a);At(a);Bt(a);Ct(a);Dt(a);Et(a);Ft(a);Gt(a);Jt(a);Kt(a);Mt(a);Nt(a);Ot(a);Pt(a);Qt(a);Rt(a);St(a);Tt(a);Ut(a);Vt(a);Wt(a);Xt(a);Zt(a);_t(a);$t(a);au(a);bu(a);cu(a);du(a);eu(a);fu(a);gu(a);hu(a);iu(a);ju(a);mu(a);nu(a);pu(a);qu(a);ru(a);su(a);tu(a);uu(a);vu(a);wu(a);xu(a);yu(a);zu(a);Au(a);Cu(a);Du(a);Eu(a);Fu(a);Gu(a);Hu(a);Iu(a);Ju(a);Ku(a);Lu(a);Mu(a);Nu(a);Ou(a);Ru(a);Su(a);Uu(a);Vu(a);Wu(a);Xu(a);Yu(a);Zu(a);_u(a);$u(a);av(a);bv(a);cv(a);dv(a);fv(a);gv(a);hv(a);iv(a);jv(a);kv(a);lv(a);mv(a);nv(a);ov(a);pv(a);qv(a);rv(a);uv(a);vv(a);xv(a);yv(a);zv(a);Av(a);Bv(a);Cv(a);Dv(a);Ev(a);Fv(a);Gv(a);Hv(a);Iv(a);Kv(a);Lv(a);Mv(a);Nv(a);Ov(a);Pv(a);Qv(a);Rv(a);Sv(a);Tv(a);Uv(a);Vv(a);Wv(a);Zv(a);_v(a);aw(a);bw(a);cw(a);dw(a);ew(a);fw(a);gw(a);hw(a);iw(a);jw(a);kw(a);lw(a);nw(a);ow(a);pw(a);qw(a);rw(a);sw(a);tw(a);uw(a);vw(a);ww(a);xw(a);yw(a);zw(a);Cw(a);Dw(a);Fw(a);Gw(a);Hw(a);Iw(a);Jw(a);Kw(a);Lw(a);Mw(a);Nw(a);Ow(a);Pw(a);Qw(a);Sw(a);Tw(a);Uw(a);Vw(a);Ww(a);Xw(a);Yw(a);Zw(a);_w(a);$w(a);ax(a);bx(a);cx(a);fx(a);gx(a);ix(a);jx(a);kx(a);lx(a);mx(a);nx(a);ox(a);px(a);qx(a);rx(a);sx(a);tx(a);vx(a);wx(a);xx(a);yx(a);zx(a);Ax(a);Bx(a);Cx(a);Dx(a);Ex(a);Fx(a);Gx(a);Hx(a);Kx(a);Lx(a);Nx(a);Ox(a);Px(a);Qx(a);Rx(a);Sx(a);Tx(a);Ux(a);Vx(a);Wx(a);Xx(a);Yx(a);_x(a);$x(a);ay(a);by(a);cy(a);dy(a);ey(a);fy(a);gy(a);hy(a);iy(a);jy(a);ky(a);ny(a);oy(a);qy(a);ry(a);sy(a);ty(a);uy(a);vy(a);wy(a);xy(a);yy(a);zy(a);Ay(a);By(a);Dy(a);Ey(a);Fy(a);Gy(a);Hy(a);Iy(a);Jy(a);Ky(a);Ly(a);My(a);Ny(a);Oy(a);Py(a);Sy(a);Ty(a);Vy(a);Wy(a);Xy(a);Yy(a);Zy(a);_y(a);$y(a);az(a);bz(a);cz(a);dz(a);ez(a);gz(a);hz(a);iz(a);jz(a);kz(a);lz(a);mz(a);nz(a);oz(a);pz(a);qz(a);rz(a);sz(a);vz(a);wz(a);yz(a);zz(a);Az(a);Bz(a);Cz(a);Dz(a);Ez(a);Fz(a);Gz(a);Hz(a);Iz(a);Jz(a);Lz(a);Mz(a);Nz(a);Oz(a);Pz(a);Qz(a);Rz(a);Sz(a);Tz(a);Uz(a);Vz(a);Wz(a);Xz(a);_z(a);$z(a);bA(a);cA(a);dA(a);eA(a);fA(a);gA(a);hA(a);iA(a);jA(a);kA(a);lA(a);mA(a);oA(a);pA(a);qA(a);rA(a);sA(a);tA(a);uA(a);vA(a);wA(a);xA(a);yA(a);zA(a);AA(a);DA(a);EA(a);GA(a);HA(a);IA(a);JA(a);KA(a);LA(a);MA(a);NA(a);OA(a);PA(a);QA(a);RA(a);TA(a);UA(a);VA(a);WA(a);XA(a);YA(a);ZA(a);_A(a);$A(a);aB(a);bB(a);cB(a);dB(a);gB(a);hB(a);jB(a);kB(a);lB(a);mB(a);nB(a);oB(a);pB(a);qB(a);rB(a);sB(a);tB(a);uB(a);wB(a);xB(a);yB(a);zB(a);AB(a);BB(a);CB(a);DB(a);EB(a);FB(a);GB(a);HB(a);IB(a);JB(a);KB(a);NB(a);OB(a);PB(a);QB(a);RB(a);SB(a);UB(a);VB(a);WB(a);XB(a);YB(a);ZB(a);_B(a);$B(a);bC(a);cC(a);dC(a);eC(a);fC(a);gC(a);hC(a);iC(a);jC(a);kC(a);i=b;return}function CD(a,b){a=a|0;b=+b;i=i;return 0}function DD(a){a=a|0;var b=0;b=i;i=i+8|0;nXa(c[a+536>>2]|0,(a|0)!=0|0,21344,b);c[a+540>>2]=21152;c[a+84>>2]=21376;c[a+88>>2]=21376;c[a+92>>2]=21440;c[a+96>>2]=21512;c[a+100>>2]=0;c[a+60>>2]=0;c[a+112>>2]=100;c[a+116>>2]=1865;c[a+120>>2]=0;c[a+124>>2]=48;c[a+128>>2]=0;c[a+132>>2]=0;c[a+136>>2]=422;c[a+140>>2]=53;c[a+144>>2]=149;c[a+148>>2]=0;c[a+152>>2]=0;c[a+156>>2]=0;c[a+232>>2]=5;c[a+216>>2]=1950;c[a+220>>2]=168;c[a+224>>2]=0;c[a+228>>2]=0;c[a+160>>2]=2;c[a+104>>2]=0;c[a+164>>2]=2;c[a+168>>2]=0;c[a+176>>2]=104;c[a+180>>2]=0;c[a+184>>2]=104;c[a+188>>2]=0;c[a+56>>2]=21552;c[a+64>>2]=118;c[a+72>>2]=0;c[a+68>>2]=5517;c[a+192>>2]=0;c[a+196>>2]=40;c[a+200>>2]=61;c[a+204>>2]=0;c[a+208>>2]=0;c[a+212>>2]=0;c[a+172>>2]=0;i=b;return}function ED(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0;d=i;e=i;i=i+168|0;c[e>>2]=0;f=i;i=i+544|0;g=i;i=i+88|0;h=i;i=i+160|0;j=i;i=i+160|0;u=0;Pa(3);k=u;u=0;if((k|0)!=0&(v|0)!=0){l=Lqb(c[k>>2]|0,e)|0;if((l|0)==0){fb(k|0,v|0)}J=v}else{l=-1}k=J;do{if((l|0)==1){m=0;n=0;o=0;p=0;q=0;s=0;t=k}else if((l|0)==2){w=0;x=0;y=0;z=0;A=0;B=0;C=k;D=7}else{E=240960;F=240984;c[E+0>>2]=c[F+0>>2];c[E+4>>2]=c[F+4>>2];c[E+8>>2]=c[F+8>>2];c[E+12>>2]=c[F+12>>2];c[E+16>>2]=c[F+16>>2];c[E+20>>2]=c[F+20>>2];u=0;Pa(c[60240]|0);F=u;u=0;if((F|0)!=0&(v|0)!=0){G=Lqb(c[F>>2]|0,e)|0;if((G|0)==0){fb(F|0,v|0)}J=v}else{G=-1}F=J;if((G|0)==1){m=0;n=0;o=0;p=0;q=0;s=0;t=F;break}else if((G|0)==2){w=0;x=0;y=0;z=0;A=0;B=0;C=F;D=7;break}F=g;E=F+0|0;H=E+88|0;do{c[E>>2]=0;E=E+4|0}while((E|0)<(H|0));u=0;E=sa(98,c[59490]|0)|0;H=u;u=0;if((H|0)!=0&(v|0)!=0){I=Lqb(c[H>>2]|0,e)|0;if((I|0)==0){fb(H|0,v|0)}J=v}else{I=-1}H=J;if((I|0)==1){m=0;n=0;o=0;p=0;q=E;s=F;t=H;break}else if((I|0)==2){w=0;x=0;y=0;z=0;A=E;B=F;C=H;D=7;break}u=0;Ha(48,c[59490]|0,F|0)|0;H=u;u=0;if((H|0)!=0&(v|0)!=0){K=Lqb(c[H>>2]|0,e)|0;if((K|0)==0){fb(H|0,v|0)}J=v}else{K=-1}H=J;if((K|0)==1){m=0;n=0;o=0;p=0;q=E;s=F;t=H;break}else if((K|0)==2){w=0;x=0;y=0;z=0;A=E;B=F;C=H;D=7;break}H=h;c[g>>2]=h;xqb(h,2,e|0)|0;u=0;L=u;u=0;if((L|0)!=0&(v|0)!=0){M=Lqb(c[L>>2]|0,e)|0;if((M|0)==0){fb(L|0,v|0)}J=v}else{M=-1}L=J;if((M|0)==1){m=0;n=0;o=0;p=H;q=E;s=F;t=L;break}else if((M|0)==2){w=0;x=0;y=0;z=H;A=E;B=F;C=L;D=7;break}w=0;x=0;y=0;z=H;A=E;B=F;C=0;D=7}}while(0);while(1){if((D|0)==7){D=0;if((C|0)==0){M=j;h=g+4|0;K=c[h>>2]|0;c[h>>2]=j;xqb(j,1,e|0)|0;u=0;I=u;u=0;if((I|0)!=0&(v|0)!=0){N=Lqb(c[I>>2]|0,e)|0;if((N|0)==0){fb(I|0,v|0)}J=v}else{N=-1}I=J;if((N|0)==1){m=K;n=h;o=M;p=z;q=A;s=B;t=I;continue}else if((N|0)==2){O=B;P=A;Q=z;w=K;x=h;y=M;C=I;B=O;A=P;z=Q;D=7;continue}m=K;n=h;o=M;p=z;q=A;s=B;t=0;continue}else{u=0;Ha(48,c[59490]|0,A|0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){R=Lqb(c[M>>2]|0,e)|0;if((R|0)==0){fb(M|0,v|0)}J=v}else{R=-1}M=J;if((R|0)==1){m=w;n=x;o=y;p=z;q=A;s=B;t=M;continue}else if((R|0)==2){O=B;P=A;Q=z;S=y;T=x;U=w;C=M;B=O;A=P;z=Q;y=S;x=T;w=U;D=7;continue}u=0;Pa(4);M=u;u=0;if((M|0)!=0&(v|0)!=0){V=Lqb(c[M>>2]|0,e)|0;if((V|0)==0){fb(M|0,v|0)}J=v}else{V=-1}M=J;if((V|0)==1){m=w;n=x;o=y;p=z;q=A;s=B;t=M;continue}else if((V|0)==2){O=B;P=A;Q=z;S=y;T=x;U=w;C=M;B=O;A=P;z=Q;y=S;x=T;w=U;D=7;continue}else{D=18;break}}}if((t|0)!=0){u=0;Pa(4);M=u;u=0;if((M|0)!=0&(v|0)!=0){W=Lqb(c[M>>2]|0,e)|0;if((W|0)==0){fb(M|0,v|0)}J=v}else{W=-1}M=J;if((W|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((W|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}M=c[r>>2]|0;u=0;Ra(34,21624,154,1,M|0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){ba=Lqb(c[M>>2]|0,e)|0;if((ba|0)==0){fb(M|0,v|0)}J=v}else{ba=-1}M=J;if((ba|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ba|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}u=0;M=u;u=0;if((M|0)!=0&(v|0)!=0){ca=Lqb(c[M>>2]|0,e)|0;if((ca|0)==0){fb(M|0,v|0)}J=v}else{ca=-1}M=J;if((ca|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ca|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}u=0;sa(99,0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){da=Lqb(c[M>>2]|0,e)|0;if((da|0)==0){fb(M|0,v|0)}J=v}else{da=-1}M=J;if((da|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((da|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}else{D=15;break}}u=0;pa(138,f|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){ea=Lqb(c[M>>2]|0,e)|0;if((ea|0)==0){fb(M|0,v|0)}J=v}else{ea=-1}M=J;if((ea|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ea|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}c[f+536>>2]=g;u=0;M=va(31,a|0,b|0,f|0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){fa=Lqb(c[h>>2]|0,e)|0;if((fa|0)==0){fb(h|0,v|0)}J=v}else{fa=-1}h=J;if((fa|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((fa|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}c[n>>2]=m;u=0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ga=Lqb(c[h>>2]|0,e)|0;if((ga|0)==0){fb(h|0,v|0)}J=v}else{ga=-1}h=J;if((ga|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ga|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;Ha(48,c[59490]|0,q|0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ha=Lqb(c[h>>2]|0,e)|0;if((ha|0)==0){fb(h|0,v|0)}J=v}else{ha=-1}h=J;if((ha|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ha|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;sa(99,0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ia=Lqb(c[h>>2]|0,e)|0;if((ia|0)==0){fb(h|0,v|0)}J=v}else{ia=-1}h=J;if((ia|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ia|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;sa(99,0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ja=Lqb(c[h>>2]|0,e)|0;if((ja|0)==0){fb(h|0,v|0)}J=v}else{ja=-1}h=J;if((ja|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ja|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;pa(139,M|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){ka=Lqb(c[M>>2]|0,e)|0;if((ka|0)==0){fb(M|0,v|0)}J=v}else{ka=-1}M=J;if((ka|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa}else if((ka|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7}else{D=26;break}}if((D|0)==15){la=p;ma=s;i=d;return 1}else if((D|0)==18){la=z;ma=B;i=d;return 1}return 0}function FD(){var a=0;a=i;Bd(0)|0;uc(21784,18,1,c[r>>2]|0)|0;Bd(0)|0;i=a;return}function GD(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;h[a>>3]=+U(+c)*f/e*d;i=i;return}function HD(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=+e;h[a>>3]=d/e*c;i=i;return}function ID(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=+e;f=+f;g=+g;j=+j;c[a>>2]=d;h[a+8>>3]=e;h[a+16>>3]=f;h[a+24>>3]=g;h[a+32>>3]=j;i=i;return}function JD(a,b,c,d,e,f,g,j,k,l,m,n,o){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;g=+g;j=+j;k=+k;l=+l;m=+m;n=+n;o=+o;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0;p=i;i=i+112|0;q=p;r=p+16|0;s=p+32|0;t=p+48|0;u=p+64|0;v=p+80|0;w=p+96|0;x=m/k;if(!(x<=.0065)){y=.0065/x}else{y=1.0}m=+zd(+(+W(+(+ca(+y)*745.0),.97)),+o);y=d*l;z=e*l;l=(y+z)*.5;A=+Ad(+y,+z)+n;B=+zd(+y,+z)-n;if(A<=c){KD(q,b,c-y,d,e,f,g,j,k,m,o,x);C=+h[q>>3];D=a;E=D;h[E>>3]=C;i=p;return}if(B>=c){KD(r,b,c-z,d,e,f,g,j,k,m,o,x);C=+h[r>>3];D=a;E=D;h[E>>3]=C;i=p;return}KD(s,b,A-y,d,e,f,g,j,k,m,o,x);y=+h[s>>3];n=+h[s+8>>3];KD(t,b,B-z,d,e,f,g,j,k,m,o,x);x=+h[t>>3];o=+h[t+8>>3];LD(u,b,l,B,A,x,y,o,n);m=+h[u+8>>3];if(l<c){LD(v,b,c,l,A,0.0,y,m,n);C=+h[v>>3];D=a;E=D;h[E>>3]=C;i=p;return}else{LD(w,b,c,B,l,x,0.0,o,m);C=+h[w>>3];D=a;E=D;h[E>>3]=C;i=p;return}}function KD(a,b,d,e,f,g,j,l,m,n,o,p){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=+g;j=+j;l=+l;m=+m;n=+n;o=+o;p=+p;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,W=0,X=0,Y=0,Z=0,_=0;q=i;i=i+128|0;r=q;s=q+24|0;t=q+48|0;u=q+72|0;v=q+96|0;w=q+120|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+16|0;C=d>=0.0;D=C?g:j;j=+U(+d);g=m*m*m*((C?e:f)/(D*D*l));l=j*g*2.0;f=g*2.0;g=l*.015625;e=f*.015625;do{if(g>n){if(!(l>=0.0)){E=c[72300]|0;F=A;h[k>>3]=l;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];F=E;E=v;G=25752;c[E+0>>2]=c[G+0>>2];c[E+4>>2]=c[G+4>>2];c[E+8>>2]=c[G+8>>2];c[E+12>>2]=c[G+12>>2];c[E+16>>2]=c[G+16>>2];c[E+20>>2]=c[G+20>>2];Pe[F&127](b,v,22312,A);F=c[72300]|0;G=z;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=F;F=u;E=25752;c[F+0>>2]=c[E+0>>2];c[F+4>>2]=c[E+4>>2];c[F+8>>2]=c[E+8>>2];c[F+12>>2]=c[E+12>>2];c[F+16>>2]=c[E+16>>2];c[F+20>>2]=c[E+20>>2];Pe[G&127](b,u,22312,z);}H=+V(+l);I=p*.27;J=I+2.51/H;if(!(J>0.0)){G=c[72300]|0;E=y;h[k>>3]=J;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=G;G=t;F=25752;c[G+0>>2]=c[F+0>>2];c[G+4>>2]=c[F+4>>2];c[G+8>>2]=c[F+8>>2];c[G+12>>2]=c[F+12>>2];c[G+16>>2]=c[F+16>>2];c[G+20>>2]=c[F+20>>2];Pe[E&127](b,t,22376,y);}K=H*+$a(+J)*-2.0;J=j*f;if(!(J>=0.0)){E=c[72300]|0;F=x;h[k>>3]=J;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];F=E;E=s;G=25752;c[E+0>>2]=c[G+0>>2];c[E+4>>2]=c[G+4>>2];c[E+8>>2]=c[G+8>>2];c[E+12>>2]=c[G+12>>2];c[E+16>>2]=c[G+16>>2];c[E+20>>2]=c[G+20>>2];Pe[F&127](b,s,22472,x);}H=+V(+J);J=I+2.51/H;if(!(J>0.0)){F=c[72300]|0;G=w;h[k>>3]=J;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=F;F=r;E=25752;c[F+0>>2]=c[E+0>>2];c[F+4>>2]=c[E+4>>2];c[F+8>>2]=c[E+8>>2];c[F+12>>2]=c[E+12>>2];c[F+16>>2]=c[E+16>>2];c[F+20>>2]=c[E+20>>2];Pe[G&127](b,r,22552,w);}I=(5.02/(j*J*2.0)- +da(+J)*(f/H))*.4342944819032518;if(!(K<o)){L=K;M=I;break}MD(B,b,l,n,o,p,d);L=+h[B>>3];M=+h[B+8>>3]}else{L=g;M=e}}while(0);if(C){N=L;O=D*N;P=O*m;Q=P*.7853981633974483;R=D*M;S=R*m;T=S*.7853981633974483;W=a;X=W;h[X>>3]=Q;Y=a;Z=Y+8|0;_=Z;h[_>>3]=T;i=q;return}N=-L;O=D*N;P=O*m;Q=P*.7853981633974483;R=D*M;S=R*m;T=S*.7853981633974483;W=a;X=W;h[X>>3]=Q;Y=a;Z=Y+8|0;_=Z;h[_>>3]=T;i=q;return}function LD(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=+g;j=+j;k=+k;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,V=0.0,W=0.0,X=0.0,Y=0.0;m=i;i=i+56|0;n=m;o=m+24|0;p=m+48|0;q=i;i=i+8|0;if(!(e<f)){r=RXa(RXa(22848,PXa(e,0,1,6)|0)|0,22904)|0;s=RXa(RXa(r,PXa(f,0,1,6)|0)|0,22920)|0;r=c[72300]|0;t=o;u=23024;c[t+0>>2]=c[u+0>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];c[t+12>>2]=c[u+12>>2];c[t+16>>2]=c[u+16>>2];c[t+20>>2]=c[u+20>>2];Pe[r&127](b,o,s,q);}do{if(!(k*l>=0.0)){if(+U(+k)<1.0e-15){break}if(+U(+l)<1.0e-15){break}q=RXa(RXa(23048,PXa(k,0,1,6)|0)|0,23224)|0;s=RXa(RXa(q,PXa(l,0,1,6)|0)|0,23240)|0;q=c[72300]|0;o=n;r=23272;c[o+0>>2]=c[r+0>>2];c[o+4>>2]=c[r+4>>2];c[o+8>>2]=c[r+8>>2];c[o+12>>2]=c[r+12>>2];c[o+16>>2]=c[r+16>>2];c[o+20>>2]=c[r+20>>2];Pe[q&127](b,n,s,p);}}while(0);v=f-e;w=(j-g)/v;x=+U(+w);if(w==0.0){y=0.0;z=(d-e)*w+g;A=a;B=A;h[B>>3]=z;C=a;D=C+8|0;E=D;h[E>>3]=y;i=m;return}F=w*-2.0;G=F+k+l;if(+U(+G)<1.0e-13){H=d-e;I=k*-2.0;J=w*3.0;K=F+l+k;L=((e+f)*.5-e)/v;y=K*L*L*3.0+((I+(J-l))*L*2.0+k);z=H*(H*((I+(J+(H*(K/v)-l)))/v)+k)+g;A=a;B=A;h[B>>3]=z;C=a;D=C+8|0;E=D;h[E>>3]=y;i=m;return}K=v*k;H=-l;J=((k+l)*e*-3.0+(w*e*6.0+(K*-2.0+(v*w*3.0-v*l))))/(H-k+w*2.0)*.3333333333333333;I=J-e;L=f-J;J=I/v;M=F+l+k;F=k*-2.0;N=w*3.0;O=F+(N-l);P=M*J*J*3.0+(O*J*2.0+k);if(w>0.0){Q=1.0}else{Q=+(w<0.0|0)}J=Q*+zd(+(+U(+P)),+x)*.25;do{if(!(+U(+(k-l))<=1.0e-13)){R=(k*H+(-(l*l)-k*k)+w*(w*-1.5+k+l)*6.0)/(G*3.0);S=0}else{if(!(K+g<j)){R=k;S=0;break}R=k;S=1}}while(0);if(I>0.0&L<v){if(!(w*P<=0.0)){T=19}else{T=22}}else{T=19}do{if((T|0)==19){P=+U(+J);K=+U(+R);if(P<K){if(w*R>=0.0){T=22;break}}if(P<+U(+(w*.1))&S<<24>>24==0){V=K;W=P}else{T=34}}}while(0);do{if((T|0)==22){if(!(S<<24>>24==0)){T=34;break}V=+U(+R);W=+U(+J)}}while(0);if((T|0)==34){P=d-e;K=((e+f)*.5-e)/v;y=M*K*K*3.0+(O*K*2.0+k);z=P*(P*((F+(N+(P*(M/v)-l)))/v)+k)+g;A=a;B=A;h[B>>3]=z;C=a;D=C+8|0;E=D;h[E>>3]=y;i=m;return}do{if(W<V){if(!(w*R>=0.0)){X=J;break}X=R}else{X=J}}while(0);J=w*.1;T=+U(+X)<+U(+J);R=T?J:X;X=(I*k+L*l)/v;if(+U(+(X-R))<1.0e-6){Y=X*.999999}else{Y=R}R=(w-Y)/(X-Y)*3.0;X=I*R;I=L*R;R=X+e;L=f-I;w=(k-Y)/+Ad(+(X*X),1.0e-13);X=(l-Y)/+Ad(+(I*I),1.0e-13);I=e-R;l=w*I*I*I*-.3333333333333333-Y*e+g;g=f-L;if(R>d){e=d-R;y=Y;z=w*e*e*e*.3333333333333333+(Y*d+l);A=a;B=A;h[B>>3]=z;C=a;D=C+8|0;E=D;h[E>>3]=y;i=m;return}if(L>d){y=Y;z=Y*d+l;A=a;B=A;h[B>>3]=z;C=a;D=C+8|0;E=D;h[E>>3]=y;i=m;return}else{l=d-L;y=Y;z=X*l*l*l*.3333333333333333+(Y*d+(X*g*g*g*-.3333333333333333-Y*f+j));A=a;B=A;h[B>>3]=z;C=a;D=C+8|0;E=D;h[E>>3]=y;i=m;return}}function MD(a,b,d,e,f,g,j){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=+g;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0;l=i;i=i+224|0;m=l;n=l+24|0;o=l+48|0;p=l+72|0;q=l+96|0;r=l+120|0;s=l+144|0;t=l+168|0;u=l+192|0;v=l+216|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+16|0;F=e*64.0;if(!(F>0.0)){G=c[72300]|0;H=D;h[k>>3]=F;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=G;G=u;I=25752;c[G+0>>2]=c[I+0>>2];c[G+4>>2]=c[I+4>>2];c[G+8>>2]=c[I+8>>2];c[G+12>>2]=c[I+12>>2];c[G+16>>2]=c[I+16>>2];c[G+20>>2]=c[I+20>>2];Pe[H&127](b,u,21816,D);}J=+$a(+F);if(!(e>0.0)){D=c[72300]|0;u=C;h[k>>3]=e;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];u=D;D=t;H=25752;c[D+0>>2]=c[H+0>>2];c[D+4>>2]=c[H+4>>2];c[D+8>>2]=c[H+8>>2];c[D+12>>2]=c[H+12>>2];c[D+16>>2]=c[H+16>>2];c[D+20>>2]=c[H+20>>2];Pe[u&127](b,t,21880,C);}F=+$a(+e);e=g/3.7+5.74/+W(+f,.9);if(!(e>0.0)){C=c[72300]|0;t=B;h[k>>3]=e;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];t=C;C=s;u=25752;c[C+0>>2]=c[u+0>>2];c[C+4>>2]=c[u+4>>2];c[C+8>>2]=c[u+8>>2];c[C+12>>2]=c[u+12>>2];c[C+16>>2]=c[u+16>>2];c[C+20>>2]=c[u+20>>2];Pe[t&127](b,s,21944,B);}K=f/+$a(+e);e=K*K*.25;B=e>=0.0;if(!B){s=c[72300]|0;t=A;h[k>>3]=e;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];t=s;s=r;u=25752;c[s+0>>2]=c[u+0>>2];c[s+4>>2]=c[u+4>>2];c[s+8>>2]=c[u+8>>2];c[s+12>>2]=c[u+12>>2];c[s+16>>2]=c[u+16>>2];c[s+20>>2]=c[u+20>>2];Pe[t&127](b,r,22008,A);}K=+V(+e);f=g*.27+2.51/K;if(!B){B=c[72300]|0;A=z;h[k>>3]=e;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=B;B=q;r=25752;c[B+0>>2]=c[r+0>>2];c[B+4>>2]=c[r+4>>2];c[B+8>>2]=c[r+8>>2];c[B+12>>2]=c[r+12>>2];c[B+16>>2]=c[r+16>>2];c[B+20>>2]=c[r+20>>2];Pe[A&127](b,q,22008,z);}if(!(f>0.0)){z=c[72300]|0;q=y;h[k>>3]=f;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];q=z;z=p;A=25752;c[z+0>>2]=c[A+0>>2];c[z+4>>2]=c[A+4>>2];c[z+8>>2]=c[A+8>>2];c[z+12>>2]=c[A+12>>2];c[z+16>>2]=c[A+16>>2];c[z+20>>2]=c[A+20>>2];Pe[q&127](b,p,22064,y);}g=K*+$a(+f)*-2.0;if(!(e>0.0)){y=c[72300]|0;p=x;h[k>>3]=e;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=y;y=o;q=25752;c[y+0>>2]=c[q+0>>2];c[y+4>>2]=c[q+4>>2];c[y+8>>2]=c[q+8>>2];c[y+12>>2]=c[q+12>>2];c[y+16>>2]=c[q+16>>2];c[y+20>>2]=c[q+20>>2];Pe[p&127](b,o,22128,x);}K=+$a(+e);if(!(g>0.0)){x=c[72300]|0;o=w;h[k>>3]=g;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=x;x=n;p=25752;c[x+0>>2]=c[p+0>>2];c[x+4>>2]=c[p+4>>2];c[x+8>>2]=c[p+8>>2];c[x+12>>2]=c[p+12>>2];c[x+16>>2]=c[p+16>>2];c[x+20>>2]=c[p+20>>2];Pe[o&127](b,n,22184,w);}e=+$a(+g);L=1.090079149577162/(f*g)+.5;if(d>0.0){M=+$a(+d);ND(E,0,M,J,K,F,e,1.0,L);N=E;O=N;P=+h[O>>3];Q=E;R=Q+8|0;S=R;T=+h[S>>3];X=+W(10.0,+P);Y=+U(+j);Z=T/Y;_=X*Z;$=a;aa=$;h[aa>>3]=X;ba=a;ca=ba+8|0;da=ca;h[da>>3]=_;i=l;return}w=c[72300]|0;n=v;h[k>>3]=d;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=w;w=m;o=25752;c[w+0>>2]=c[o+0>>2];c[w+4>>2]=c[o+4>>2];c[w+8>>2]=c[o+8>>2];c[w+12>>2]=c[o+12>>2];c[w+16>>2]=c[o+16>>2];c[w+20>>2]=c[o+20>>2];Pe[n&127](b,m,22248,v);M=+$a(+d);ND(E,0,M,J,K,F,e,1.0,L);N=E;O=N;P=+h[O>>3];Q=E;R=Q+8|0;S=R;T=+h[S>>3];X=+W(10.0,+P);Y=+U(+j);Z=T/Y;_=X*Z;$=a;aa=$;h[aa>>3]=X;ba=a;ca=ba+8|0;da=ca;h[da>>3]=_;i=l;return}function ND(a,b,c,d,e,f,g,j,k){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;g=+g;j=+j;k=+k;var l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0;b=i;l=e-d;do{if(l!=l|0.0!=0.0|l==0.0){e=(f+g)*.5;m=g-f;if(m>0.0){n=1.0e+60;o=e;break}n=+(m<0.0|0)*1.0e+60;o=e}else{e=(c-d)/l;m=e*e;p=e*m;q=m*3.0;n=(m-e)*6.0/l*f+((e*-4.0+q+1.0)*j+((e-m)*6.0/l*g+(e*-2.0+q)*k));o=(m*-3.0+p*2.0+1.0)*f+(l*(p+(e+m*-2.0))*j+((q+p*-2.0)*g+l*(p-m)*k))}}while(0);h[a>>3]=o;h[a+8>>3]=n;i=b;return}function OD(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=+g;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,X=0,Y=0;j=i;i=i+224|0;l=j;m=j+24|0;n=j+48|0;o=j+72|0;p=j+96|0;q=j+120|0;r=j+144|0;s=j+168|0;t=j+192|0;u=j+216|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;if(!(e>0.0)){D=c[72300]|0;E=C;h[k>>3]=e;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D;D=t;F=25752;c[D+0>>2]=c[F+0>>2];c[D+4>>2]=c[F+4>>2];c[D+8>>2]=c[F+8>>2];c[D+12>>2]=c[F+12>>2];c[D+16>>2]=c[F+16>>2];c[D+20>>2]=c[F+20>>2];Pe[E&127](b,t,21880,C);}G=+$a(+e);H=e*64.0;if(!(H>0.0)){C=c[72300]|0;t=B;h[k>>3]=H;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];t=C;C=s;E=25752;c[C+0>>2]=c[E+0>>2];c[C+4>>2]=c[E+4>>2];c[C+8>>2]=c[E+8>>2];c[C+12>>2]=c[E+12>>2];c[C+16>>2]=c[E+16>>2];c[C+20>>2]=c[E+20>>2];Pe[t&127](b,s,21816,B);}I=+$a(+H);H=+W(+f,.9);J=g/3.7+5.74/H;if(!(J>0.0)){B=c[72300]|0;s=A;h[k>>3]=J;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=B;B=r;t=25752;c[B+0>>2]=c[t+0>>2];c[B+4>>2]=c[t+4>>2];c[B+8>>2]=c[t+8>>2];c[B+12>>2]=c[t+12>>2];c[B+16>>2]=c[t+16>>2];c[B+20>>2]=c[t+20>>2];Pe[s&127](b,r,21944,A);}K=+$a(+J);L=f/K;M=L*L*.25;A=M>=0.0;if(!A){r=c[72300]|0;s=z;h[k>>3]=M;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=r;r=q;t=25752;c[r+0>>2]=c[t+0>>2];c[r+4>>2]=c[t+4>>2];c[r+8>>2]=c[t+8>>2];c[r+12>>2]=c[t+12>>2];c[r+16>>2]=c[t+16>>2];c[r+20>>2]=c[t+20>>2];Pe[s&127](b,q,22008,z);}L=g*.27+2.51/+V(+M);if(!A){A=c[72300]|0;z=y;h[k>>3]=M;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=A;A=p;q=25752;c[A+0>>2]=c[q+0>>2];c[A+4>>2]=c[q+4>>2];c[A+8>>2]=c[q+8>>2];c[A+12>>2]=c[q+12>>2];c[A+16>>2]=c[q+16>>2];c[A+20>>2]=c[q+20>>2];Pe[z&127](b,p,22008,y);}if(!(L>0.0)){y=c[72300]|0;p=x;h[k>>3]=L;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=y;y=o;z=25752;c[y+0>>2]=c[z+0>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];c[y+12>>2]=c[z+12>>2];c[y+16>>2]=c[z+16>>2];c[y+20>>2]=c[z+20>>2];Pe[p&127](b,o,22064,x);}+$a(+L);if(!(f>0.0)){x=c[72300]|0;o=w;h[k>>3]=f;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=x;x=n;p=25752;c[x+0>>2]=c[p+0>>2];c[x+4>>2]=c[p+4>>2];c[x+8>>2]=c[p+8>>2];c[x+12>>2]=c[p+12>>2];c[x+16>>2]=c[p+16>>2];c[x+20>>2]=c[p+20>>2];Pe[o&127](b,n,22632,w);}L=+$a(+f);if(!(M>0.0)){w=c[72300]|0;n=v;h[k>>3]=M;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=w;w=m;o=25752;c[w+0>>2]=c[o+0>>2];c[w+4>>2]=c[o+4>>2];c[w+8>>2]=c[o+8>>2];c[w+12>>2]=c[o+12>>2];c[w+16>>2]=c[o+16>>2];c[w+20>>2]=c[o+20>>2];Pe[n&127](b,m,22128,v);}f=1.121782646756099/(H*J*K)*4.0+2.0;K=L-G;G=(+$a(+M)-I)/K;I=(G*3.0+(-2.0-f))/K;M=(f+G*-2.0+1.0)/(K*K);K=d/e;if(K>0.0){N=+$a(+K);O=M*N;P=I+O;Q=N*P;R=Q+1.0;S=+W(+K,+R);T=S*e;U=T*64.0;X=a;Y=X;h[Y>>3]=U;i=j;return}v=c[72300]|0;m=u;h[k>>3]=K;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=v;v=l;n=25752;c[v+0>>2]=c[n+0>>2];c[v+4>>2]=c[n+4>>2];c[v+8>>2]=c[n+8>>2];c[v+12>>2]=c[n+12>>2];c[v+16>>2]=c[n+16>>2];c[v+20>>2]=c[n+20>>2];Pe[m&127](b,l,22696,u);N=+$a(+K);O=M*N;P=I+O;Q=N*P;R=Q+1.0;S=+W(+K,+R);T=S*e;U=T*64.0;X=a;Y=X;h[Y>>3]=U;i=j;return}function PD(a,b,d,e,f,g,j,l,m,n,o,p){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=+g;j=+j;l=+l;m=+m;n=+n;o=+o;p=+p;var q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0,H=0;q=i;i=i+32|0;r=q;s=q+24|0;t=i;i=i+8|0;o=n/m;if(!(o<=.0065)){u=.0065/o}else{u=1.0}n=+zd(+(+ca(+u)*745.0),+p);v=d>=0.0;u=v?e:f;f=v?g:j;j=+U(+d)/(f*m)*1.273239544735163;do{if(!(j<=n)){if(!(j>=p)){OD(t,b,j,n,p,o);w=+h[t>>3];break}d=o/3.7+5.74/+W(+j,.9);if(!(d>0.0)){x=c[72300]|0;y=s;h[k>>3]=d;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];y=x;x=r;z=25752;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Pe[y&127](b,r,22760,s);}g=j/+$a(+d);w=g*g*.25}else{w=j*64.0}}while(0);j=f*f;f=+OYa(m,-3);if(v){A=w;B=A/u;C=f*B;D=j*C;E=D*l;F=E*.5;G=a;H=G;h[H>>3]=F;i=q;return}A=-w;B=A/u;C=f*B;D=j*C;E=D*l;F=E*.5;G=a;H=G;h[H>>3]=F;i=q;return}function QD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;RD(a,b,+h[c+32>>3],+h[c+24>>3],0);i=d;return}function RD(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,h=0,j=0;g=i;i=i+240|0;h=g;j=g+120|0;XE(j,b,d,e,f);f=a;a=h+0|0;b=j+0|0;j=a+120|0;do{c[a>>2]=c[b>>2];a=a+4|0;b=b+4|0}while((a|0)<(j|0));YE(f,0,0.0,0.0,h);i=g;return}function SD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0.0;e=i;i=i+144|0;f=e;g=e+40|0;j=e+80|0;k=e+120|0;l=e+128|0;m=e+136|0;n=j+0|0;o=d+0|0;p=n+40|0;do{c[n>>2]=c[o>>2];n=n+4|0;o=o+4|0}while((n|0)<(p|0));TD(k,b,j);q=+h[k>>3];n=g+0|0;o=d+0|0;p=n+40|0;do{c[n>>2]=c[o>>2];n=n+4|0;o=o+4|0}while((n|0)<(p|0));QD(l,b,g);r=+h[l>>3];n=f+0|0;o=d+0|0;p=n+40|0;do{c[n>>2]=c[o>>2];n=n+4|0;o=o+4|0}while((n|0)<(p|0));UD(m,b,f);h[a>>3]=q*(r/+h[m>>3]);i=e;return}function TD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;VD(a,b,+h[c+16>>3],+h[c+24>>3],+h[c+32>>3],0);i=d;return}function UD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;WD(a,b,+h[c+16>>3],+h[c+24>>3],+h[c+32>>3],0,1);i=d;return}function VD(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0;g=i;i=i+56|0;j=g;k=g+24|0;l=g+48|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;c[n>>2]=42;eYa(o,1,n);n=o;o=27224;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];p=e+-273.15;q=d/317.763;if(!(d>.004854575724778614)){o=RXa(RXa(27240,PXa(d,0,1,6)|0)|0,27320)|0;n=RXa(RXa(o,PXa(.004854575724778614,0,1,6)|0)|0,27328)|0;o=c[72300]|0;r=k;s=27480;c[r+0>>2]=c[s+0>>2];c[r+4>>2]=c[s+4>>2];c[r+8>>2]=c[s+8>>2];c[r+12>>2]=c[s+12>>2];c[r+16>>2]=c[s+16>>2];c[r+20>>2]=c[s+20>>2];Pe[o&127](b,k,n,m);}if(!(f<=5.0e8)){t=5}else{if(!(p>=0.0&p<=150.0)){t=5}}do{if((t|0)==5){if(f<=35.0e7){if(p>150.0&p<=600.0){break}}if(f<=3.0e8){if(p>600.0&p<=900.0){break}}m=RXa(RXa(27352,PXa(f,0,1,6)|0)|0,27464)|0;n=RXa(RXa(m,PXa(p,0,1,6)|0)|0,24120)|0;m=c[72300]|0;k=j;o=27504;c[k+0>>2]=c[o+0>>2];c[k+4>>2]=c[o+4>>2];c[k+8>>2]=c[o+8>>2];c[k+12>>2]=c[o+12>>2];c[k+16>>2]=c[o+16>>2];c[k+20>>2]=c[o+20>>2];Pe[m&127](b,j,n,l);}}while(0);p=q+-1.0;f=647.226/e;e=f+-1.0;d=+W(+f,-.5)/(f*(f*(f*-.202354+.579829)+.978197)+1.0);if((YD(1,1,6)|0)==0){u=0.0;v=q*u;w=+ca(+v);x=d*w;y=x*55071.0e-9;z=a;A=z;h[A>>3]=y;i=g;return}l=(YD(0,0,6)|0)==0;f=0.0;j=1;B=1.0;while(1){if((j|0)==1){C=B}else{C=e*B}if(l){D=f}else{b=j+ -1|0;E=f;t=0;F=1.0;while(1){if((t|0)==0){G=F}else{G=p*F}H=E+ +cYa(27224,b+(t*6|0)|0)*C*G;n=t+1|0;if((YD(n,0,6)|0)==0){D=H;break}else{E=H;t=n;F=G}}}t=j+1|0;if((YD(t,1,6)|0)==0){u=D;break}else{f=D;j=t;B=C}}v=q*u;w=+ca(+v);x=d*w;y=x*55071.0e-9;z=a;A=z;h[A>>3]=y;i=g;return}function WD(a,b,d,e,f,g,j){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,X=0,Y=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,da=0.0;g=i;i=i+104|0;k=g;l=g+24|0;m=g+48|0;n=g+72|0;o=g+96|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+88|0;F=i;i=i+88|0;G=i;i=i+8|0;c[x>>2]=30;eYa(y,1,x);x=y;y=27624;c[x+0>>2]=c[y+0>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];H=e+-273.15;c[w>>2]=6;eYa(z,1,w);w=z;z=27640;c[w+0>>2]=c[z+0>>2];c[w+4>>2]=c[z+4>>2];c[w+8>>2]=c[z+8>>2];c[v>>2]=4;eYa(A,1,v);v=A;A=27656;c[v+0>>2]=c[A+0>>2];c[v+4>>2]=c[A+4>>2];c[v+8>>2]=c[A+8>>2];c[u>>2]=3;eYa(B,1,u);u=B;B=27672;c[u+0>>2]=c[B+0>>2];c[u+4>>2]=c[B+4>>2];c[u+8>>2]=c[B+8>>2];c[t>>2]=2;eYa(C,1,t);t=C;C=27688;c[t+0>>2]=c[C+0>>2];c[t+4>>2]=c[C+4>>2];c[t+8>>2]=c[C+8>>2];c[s>>2]=4;eYa(D,1,s);s=D;D=27704;c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];I=d/317.7;J=e/647.25;if(!(d>.004854575724778614)){D=RXa(RXa(27720,PXa(d,0,1,6)|0)|0,27320)|0;s=RXa(RXa(D,PXa(.004854575724778614,0,1,6)|0)|0,27328)|0;D=c[72300]|0;C=n;t=27784;c[C+0>>2]=c[t+0>>2];c[C+4>>2]=c[t+4>>2];c[C+8>>2]=c[t+8>>2];c[C+12>>2]=c[t+12>>2];c[C+16>>2]=c[t+16>>2];c[C+20>>2]=c[t+20>>2];Pe[D&127](b,n,s,r);}if(!(f<=1.0e8)){K=5}else{if(!(H>=0.0&H<=500.0)){K=5}}do{if((K|0)==5){if(f<=7.0e7){if(H>500.0&H<=650.0){break}}if(f<=4.0e7){if(H>650.0&H<=800.0){break}}r=RXa(RXa(27808,PXa(f,0,1,6)|0)|0,27464)|0;s=RXa(RXa(r,PXa(H,0,1,6)|0)|0,24120)|0;r=c[72300]|0;n=m;D=27936;c[n+0>>2]=c[D+0>>2];c[n+4>>2]=c[D+4>>2];c[n+8>>2]=c[D+8>>2];c[n+12>>2]=c[D+12>>2];c[n+16>>2]=c[D+16>>2];c[n+20>>2]=c[D+20>>2];Pe[r&127](b,m,s,q);}}while(0);if(!(j<<24>>24==0)){H=+U(+(J+-1.0))+.00308976;L=+W(+H,.6);M=.0822994/L+2.0;if(!(J>=1.0)){N=10.0932/L}else{N=1.0/H}H=+ca(+((1.0- +W(+I,2.8))*.642857));L=M+1.0;O=+ca(+(M*((1.0- +W(+I,+L))/L)));L=+W(+J,1.5)*-4.11717;P=+ca(+(L+-6.17937/+OYa(I,5)));L=I+2.39219;Q=J*J;R=(J*.0299621+(Q*.0156146+J*Q*-.00422464)+.0102811)*+V(+J)+(I*.400302+ +ca(+(L*L*-.171587))*1.06+-.39707+((.0701309/+OYa(J,10)+.011852)*H*+W(+I,1.8)+(P*-1.02+N*O*+W(+I,+M)*.00169937)));S=a;T=S;h[T>>3]=R;i=g;return}if(f<16529200.0){X=d>322.0?1:2}else{j=c[72300]|0;q=l;m=27960;c[q+0>>2]=c[m+0>>2];c[q+4>>2]=c[m+4>>2];c[q+8>>2]=c[m+8>>2];c[q+12>>2]=c[m+12>>2];c[q+16>>2]=c[m+16>>2];c[q+20>>2]=c[m+20>>2];Pe[j&127](b,l,27984,p);X=0}M=647.226/e;I=d/317.763;O=I+-1.0;N=M+-1.0;P=+W(+M,-.5)/(M*(M*(M*-.998254+2.599096)+6.978267)+1.0);if((YD(1,1,5)|0)==0){Y=0.0}else{p=(YD(0,0,5)|0)==0;H=0.0;l=1;J=1.0;while(1){if((l|0)==1){Z=J}else{Z=N*J}if(p){_=H}else{j=l+ -1|0;L=H;m=0;Q=1.0;while(1){if((m|0)==0){$=Q}else{$=O*Q}aa=L+ +cYa(27624,j+(m*5|0)|0)*Z*$;q=m+1|0;if((YD(q,0,5)|0)==0){_=aa;break}else{L=aa;m=q;Q=$}}}m=l+1|0;if((YD(m,1,5)|0)==0){Y=_;break}else{H=_;l=m;J=Z}}}if((X|0)==1){rE(E,b,f,e);Z=+h[E+56>>3];ba=I*d*d*Z*e*-1.175530986746837e-7;da=(+h[E+48>>3]+ +h[E+80>>3]/e*-1386.0)/(Z*e)*-483.7732661089758}else if((X|0)==2){vE(F,b,f,e);Z=+h[F+56>>3];ba=I*d*d*Z*e*-3212031447965937.0e-20;da=(+h[F+48>>3]+ +h[F+80>>3]/e*-540.0)/(Z*e)*-29.26638028487452}else{F=RXa(RXa(28048,PXa(f,0,1,6)|0)|0,24224)|0;E=RXa(RXa(F,PXa(e,0,1,6)|0)|0,28136)|0;F=RXa(RXa(E,OXa(X,0,1)|0)|0,27592)|0;X=c[72300]|0;E=k;l=28152;c[E+0>>2]=c[l+0>>2];c[E+4>>2]=c[l+4>>2];c[E+8>>2]=c[l+8>>2];c[E+12>>2]=c[l+12>>2];c[E+16>>2]=c[l+16>>2];c[E+20>>2]=c[l+20>>2];Pe[X&127](b,k,F,o);ba=0.0;da=0.0}Z=1.0/M+-1.0;J=O*O;O=+ca(+(Z*Z*-18.66-J*J));$E(G,b,d,e,f,0);f=+h[G>>3];e=+OYa(M*I,-2);R=(P*+ca(+(I*Y))+e*da*da*+W(+(+Ad(+ba,1.0e-60)),.4678)*+V(+I)*(O/f)*7.626232080000001e-8)*.4945;S=a;T=S;h[T>>3]=R;i=g;return}function XD(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;k=i;i=i+56|0;l=k;m=k+24|0;n=k+48|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=aXa(g,1)|0;if(e<<24>>24!=0&f<<24>>24==0){f=RXa(RXa(RXa(RXa(23296,j)|0,23352)|0,b)|0,23384)|0;e=c[72300]|0;u=m;v=23504;c[u+0>>2]=c[v+0>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];c[u+12>>2]=c[v+12>>2];c[u+16>>2]=c[v+16>>2];c[u+20>>2]=c[v+20>>2];Pe[e&127](a,m,f,s);}if((t|0)<1){i=k;return}s=(YD(1,1,t)|0)==0;if(!s){f=1;do{c[r>>2]=f;if(!(+h[(jYa(g,1,r)|0)>>3]>=0.0)){m=RXa(RXa(RXa(RXa(23528,b)|0,23576)|0,j)|0,23592)|0;e=RXa(RXa(m,OXa(f,0,1)|0)|0,23632)|0;c[q>>2]=f;m=RXa(RXa(e,PXa(+h[(jYa(g,1,q)|0)>>3],0,1,6)|0)|0,23640)|0;e=c[72300]|0;v=l;u=23680;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[v+12>>2]=c[u+12>>2];c[v+16>>2]=c[u+16>>2];c[v+20>>2]=c[u+20>>2];Pe[e&127](a,l,m,p);}f=f+1|0;}while((YD(f,1,t)|0)!=0)}if((t|0)<=0){i=k;return}if(!(+U(+(+kYa(g)+-1.0))>1.0e-10)){i=k;return}if(s){w=21808}else{s=21808;f=1;while(1){p=RXa(s,23704)|0;l=RXa(RXa(p,OXa(f,0,1)|0)|0,23720)|0;c[o>>2]=f;p=RXa(RXa(l,PXa(+h[(jYa(g,1,o)|0)>>3],0,1,6)|0)|0,23728)|0;c[n>>2]=f;l=RXa(RXa(p,c[(NYa(d,1,n)|0)>>2]|0)|0,23736)|0;p=f+1|0;if((YD(p,1,t)|0)==0){w=l;break}else{f=p;s=l}}}s=RXa(RXa(RXa(RXa(RXa(23744,b)|0,23576)|0,j)|0,23736)|0,23784)|0;ZD(0,RXa(RXa(RXa(s,PXa(+kYa(g),0,1,6)|0)|0,23832)|0,w)|0);i=k;return}function YD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;if((b|0)>(c|0)){if((a|0)<(c|0)|(a|0)>(b|0)){e=4}else{f=1}}else{if((a|0)<(b|0)|(a|0)>(c|0)){e=4}else{f=1}}if((e|0)==4){f=0}i=d;return f|0}function ZD(a,b){a=a|0;b=b|0;a=i;RYa(b);i=a;return}function _D(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;var g=0.0,j=0.0;b=i;g=e/f;f=g*1.570796326794897;do{if(!(g<=-.999999999)){if(g>=.999999999){j=1.0;break}j=+ub(+(+Z(+f)))*.5+.5}else{j=0.0}}while(0);h[a>>3]=j*c+(1.0-j)*d;i=b;return}function $D(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0.0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+16|0;c[Ia>>2]=12;eYa(Ja,1,Ia);Ka=d/1.0e6;La=540.0/e+-.5;c[Ha>>2]=1;h[(jYa(Ja,1,Ha)|0)>>3]=La*La;c[Ga>>2]=1;Ma=La*+h[(jYa(Ja,1,Ga)|0)>>3];c[Fa>>2]=2;h[(jYa(Ja,1,Fa)|0)>>3]=Ma;c[Ea>>2]=1;Ma=+h[(jYa(Ja,1,Ea)|0)>>3];c[Da>>2]=3;h[(jYa(Ja,1,Da)|0)>>3]=Ma*Ma;c[Ca>>2]=3;Ma=+h[(jYa(Ja,1,Ca)|0)>>3];c[Ba>>2]=4;h[(jYa(Ja,1,Ba)|0)>>3]=Ma*Ma;c[Aa>>2]=4;Ma=+h[(jYa(Ja,1,Aa)|0)>>3];c[za>>2]=5;h[(jYa(Ja,1,za)|0)>>3]=Ma*Ma;c[ya>>2]=3;Ma=+h[(jYa(Ja,1,ya)|0)>>3];c[xa>>2]=4;Na=+h[(jYa(Ja,1,xa)|0)>>3];c[wa>>2]=5;Oa=Ma*Na*La*+h[(jYa(Ja,1,wa)|0)>>3];c[va>>2]=6;h[(jYa(Ja,1,va)|0)>>3]=Oa;c[ua>>2]=3;Oa=+h[(jYa(Ja,1,ua)|0)>>3];c[ta>>2]=4;Na=Oa*La*+h[(jYa(Ja,1,ta)|0)>>3];c[sa>>2]=7;h[(jYa(Ja,1,sa)|0)>>3]=Na;c[ra>>2]=1;Na=+h[(jYa(Ja,1,ra)|0)>>3];c[qa>>2]=3;Oa=+h[(jYa(Ja,1,qa)|0)>>3];c[pa>>2]=4;Ma=Na*Oa*+h[(jYa(Ja,1,pa)|0)>>3];c[oa>>2]=8;h[(jYa(Ja,1,oa)|0)>>3]=Ma;c[na>>2]=9;h[(jYa(Ja,1,na)|0)>>3]=Ka*Ka;c[ma>>2]=9;Ma=+h[(jYa(Ja,1,ma)|0)>>3];c[la>>2]=10;h[(jYa(Ja,1,la)|0)>>3]=Ma*Ma;c[ka>>2]=3;Ma=+h[(jYa(Ja,1,ka)|0)>>3];c[ja>>2]=5;Oa=Ma*La*+h[(jYa(Ja,1,ja)|0)>>3];c[ia>>2]=11;h[(jYa(Ja,1,ia)|0)>>3]=Oa;c[ha>>2]=5;Oa=+h[(jYa(Ja,1,ha)|0)>>3];c[ga>>2]=12;h[(jYa(Ja,1,ga)|0)>>3]=Oa*Oa;c[fa>>2]=2;Oa=La*(La*(La*(+h[(jYa(Ja,1,fa)|0)>>3]*-.05032527872793+-.057581259083432)+-.045996013696365)+-.017834862292358);c[ea>>2]=1;Ma=+h[(jYa(Ja,1,ea)|0)>>3];c[da>>2]=2;Na=+h[(jYa(Ja,1,da)|0)>>3];c[ca>>2]=6;Pa=La*(La*(Ma*(Na*(+h[(jYa(Ja,1,ca)|0)>>3]*-53349095828174.0e-18+-.087594591301146)+-.007878555448671)+-.0003789797503263)+-66065283340406.0e-18);c[ba>>2]=1;Na=+h[(jYa(Ja,1,ba)|0)>>3];c[aa>>2]=2;Ma=+h[(jYa(Ja,1,aa)|0)>>3];c[$>>2]=6;Qa=La*(Na*(Ma*(+h[(jYa(Ja,1,$)|0)>>3]*-.122004760687947+-.0045101773626444)+-9683303171571.0e-17)+131612001853305.0e-20);c[_>>2]=1;Ma=+h[(jYa(Ja,1,_)|0)>>3];c[Z>>2]=3;Na=Ma*La*+h[(jYa(Ja,1,Z)|0)>>3]*114610381688305.0e-19;c[Y>>2]=2;Ma=+h[(jYa(Ja,1,Y)|0)>>3];c[X>>2]=7;Ra=+h[(jYa(Ja,1,X)|0)>>3];c[W>>2]=1;Sa=+h[(jYa(Ja,1,W)|0)>>3];c[V>>2]=5;Ta=Ma*(Ra*(Sa*La*+h[(jYa(Ja,1,V)|0)>>3]*-143.374451604624+-.012702883392813)+-1.00288598706366e-10);c[U>>2]=1;Sa=+h[(jYa(Ja,1,U)|0)>>3];c[T>>2]=4;Ra=+h[(jYa(Ja,1,T)|0)>>3];c[S>>2]=8;Ma=Sa*Ra*La*(+h[(jYa(Ja,1,S)|0)>>3]*-.272627897050173+-88352662293707.0e-19);c[R>>2]=4;Ra=+h[(jYa(Ja,1,R)|0)>>3];c[Q>>2]=3;Sa=+h[(jYa(Ja,1,Q)|0)>>3];c[P>>2]=4;Ua=+h[(jYa(Ja,1,P)|0)>>3];c[O>>2]=5;Va=Ra*(Sa*Ua*+h[(jYa(Ja,1,O)|0)>>3]*-65.8490727183984+9.0049690883672e-11);c[N>>2]=7;Ua=+h[(jYa(Ja,1,N)|0)>>3]*1.78287415218792e-7;c[M>>2]=3;Sa=+h[(jYa(Ja,1,M)|0)>>3];c[L>>2]=1;Ra=+h[(jYa(Ja,1,L)|0)>>3];c[K>>2]=3;Wa=+h[(jYa(Ja,1,K)|0)>>3]*-1.0018179379511e-8+-1.0234747095929e-12;c[J>>2]=3;Xa=Sa*(Ra*Wa*+h[(jYa(Ja,1,J)|0)>>3]+1.0406965210174e-18);c[I>>2]=10;Wa=+h[(jYa(Ja,1,I)|0)>>3];c[H>>2]=9;Ra=+h[(jYa(Ja,1,H)|0)>>3];c[G>>2]=11;Sa=+h[(jYa(Ja,1,G)|0)>>3]*1.71088510070544+-1.29412653835176e-9;c[F>>2]=6;Ya=Sa*+h[(jYa(Ja,1,F)|0)>>3];c[E>>2]=9;Sa=+h[(jYa(Ja,1,E)|0)>>3];c[D>>2]=12;Za=+h[(jYa(Ja,1,D)|0)>>3];c[C>>2]=4;_a=+h[(jYa(Ja,1,C)|0)>>3];c[B>>2]=5;$a=Za*_a*La*+h[(jYa(Ja,1,B)|0)>>3]*-6.05920510335078;c[A>>2]=9;_a=+h[(jYa(Ja,1,A)|0)>>3];c[z>>2]=3;Za=+h[(jYa(Ja,1,z)|0)>>3];c[y>>2]=5;ab=+h[(jYa(Ja,1,y)|0)>>3];c[x>>2]=1;bb=+h[(jYa(Ja,1,x)|0)>>3];c[w>>2]=3;cb=+h[(jYa(Ja,1,w)|0)>>3];c[v>>2]=4;db=+h[(jYa(Ja,1,v)|0)>>3];c[u>>2]=7;eb=Za*ab*(bb*cb*db*La*(+h[(jYa(Ja,1,u)|0)>>3]*-84004935396416.0e-18+6.1258633752464e-12)+1.78371690710842e-23);c[t>>2]=11;db=+h[(jYa(Ja,1,t)|0)>>3]*-1.24017662339842e-24;c[s>>2]=12;cb=+h[(jYa(Ja,1,s)|0)>>3];c[r>>2]=3;bb=+h[(jYa(Ja,1,r)|0)>>3];c[q>>2]=5;ab=cb*bb*La*+h[(jYa(Ja,1,q)|0)>>3]*832192847496054.0e-19;c[p>>2]=1;bb=+h[(jYa(Ja,1,p)|0)>>3];c[o>>2]=4;cb=+h[(jYa(Ja,1,o)|0)>>3];c[n>>2]=5;Za=+h[(jYa(Ja,1,n)|0)>>3];c[m>>2]=1;fb=+h[(jYa(Ja,1,m)|0)>>3];c[l>>2]=5;gb=fb*+h[(jYa(Ja,1,l)|0)>>3]*-226487297378904.0e-19+1.32995316841867e-15;c[k>>2]=8;fb=bb*cb*Za*Ka*(+h[(jYa(Ja,1,k)|0)>>3]*gb+1.75410265428146e-27);c[j>>2]=1;gb=+h[(jYa(Ja,1,j)|0)>>3];c[g>>2]=12;Za=+h[(jYa(Ja,1,g)|0)>>3];c[f>>2]=3;h[a>>3]=d/(Ka*((Ka*(Oa+Ka*(Pa+Ka*(Qa+Ka*(La*(La*(La*192901490874028.0e-20+5.116287140914e-8)+-3.15389238237468e-9)+Ka*(Na+Ka*(Ta+Ka*(Ma+Ka*(Va+Ka*(Ua+Ka*(Xa+Wa*Ra*(Ya+Sa*($a+_a*(eb+Ka*(db+Ka*(ab+Ka*(fb+gb*Za*La*+h[(jYa(Ja,1,f)|0)>>3]*-2.93678005497663e-14)))))))))+-4.1341695026989e-17))))+6.1445213076927e-8))+-.0017731742473213)+1.0)/Ka)*e*461.526);i=b;return}function aE(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0;d=+h[c+32>>3];e=+h[c+16>>3];f=+h[c>>3];g=+h[c+8>>3];j=+h[c+24>>3];k=+h[c+48>>3];l=j*k;m=e*g*(l+d*+h[c+64>>3]);n=e*g*j*(k*2.0+j*+h[c+56>>3]);o=e*f*j*(k-d*+h[c+80>>3]);k=o/f;j=k-e*d*d*+h[c+72>>3];h[a>>3]=f*e*g*l;h[a+8>>3]=m;h[a+16>>3]=n;h[a+24>>3]=o;h[a+32>>3]=(n-g*k)/f;h[a+40>>3]=j;i=i;return}function bE(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0.0,f=0.0,g=0.0,j=0.0;d=+h[c+16>>3];e=+h[c+8>>3];f=+h[c+24>>3];g=+h[c+48>>3];j=d*e*f*(g*2.0+f*+h[c+56>>3]);h[a>>3]=+h[c>>3]*d*e*f*g;h[a+8>>3]=j;i=i;return}



function _lb(d,e,f,g,h,j,k,l,m,n,o,p,q,r,s){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;var t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;t=i;c[f>>2]=d;u=r+1|0;v=r+8|0;w=r+4|0;x=(g&512|0)==0;y=q+1|0;z=q+8|0;A=q+4|0;B=(s|0)>0;C=p+1|0;D=p+8|0;E=p+4|0;F=k+8|0;G=0-s|0;H=h;h=0;while(1){a:do{switch(a[m+h|0]|0){case 4:{I=c[f>>2]|0;J=l?H+1|0:H;b:do{if(J>>>0<j>>>0){K=J;while(1){L=a[K]|0;if(!(L<<24>>24>-1)){M=K;break b}N=K+1|0;if((b[(c[F>>2]|0)+(L<<24>>24<<1)>>1]&2048)==0){M=K;break b}if(N>>>0<j>>>0){K=N}else{M=N;break}}}else{M=J}}while(0);K=M;if(B){if(M>>>0>J>>>0){N=J+(0-K)|0;K=N>>>0<G>>>0?G:N;N=K+s|0;L=I;O=M;P=s;while(1){Q=O+ -1|0;R=a[Q]|0;c[f>>2]=L+1;a[L]=R;R=P+ -1|0;S=(R|0)>0;if(!(Q>>>0>J>>>0&S)){break}L=c[f>>2]|0;P=R;O=Q}O=M+K|0;if(S){T=O;U=N;V=32}else{W=0;X=O;Y=N}}else{T=M;U=s;V=32}if((V|0)==32){V=0;W=Ee[c[(c[k>>2]|0)+28>>2]&63](k,48)|0;X=T;Y=U}O=c[f>>2]|0;c[f>>2]=O+1;if((Y|0)>0){P=O;L=Y;while(1){a[P]=W;Q=L+ -1|0;R=c[f>>2]|0;c[f>>2]=R+1;if((Q|0)>0){L=Q;P=R}else{Z=R;break}}}else{Z=O}a[Z]=n;_=X}else{_=M}if((_|0)==(J|0)){P=Ee[c[(c[k>>2]|0)+28>>2]&63](k,48)|0;L=c[f>>2]|0;c[f>>2]=L+1;a[L]=P}else{P=a[p]|0;L=(P&1)==0;if(L){$=(P&255)>>>1}else{$=c[E>>2]|0}if(($|0)==0){aa=_;ba=-1;ca=0;da=0}else{if(L){ea=C}else{ea=c[D>>2]|0}aa=_;ba=a[ea]|0;ca=0;da=0}while(1){do{if((da|0)==(ba|0)){L=c[f>>2]|0;c[f>>2]=L+1;a[L]=o;L=ca+1|0;P=a[p]|0;N=(P&1)==0;if(N){fa=(P&255)>>>1}else{fa=c[E>>2]|0}if(!(L>>>0<fa>>>0)){ga=ba;ha=L;ia=0;break}if(N){ja=C}else{ja=c[D>>2]|0}if((a[ja+L|0]|0)==127){ga=-1;ha=L;ia=0;break}if(N){ka=C}else{ka=c[D>>2]|0}ga=a[ka+L|0]|0;ha=L;ia=0}else{ga=ba;ha=ca;ia=da}}while(0);L=aa+ -1|0;N=a[L]|0;P=c[f>>2]|0;c[f>>2]=P+1;a[P]=N;if((L|0)==(J|0)){break}else{aa=L;ba=ga;ca=ha;da=ia+1|0}}}O=c[f>>2]|0;if((I|0)==(O|0)){la=J;break a}L=O+ -1|0;if(L>>>0>I>>>0){ma=I;na=L}else{la=J;break a}while(1){L=a[ma]|0;a[ma]=a[na]|0;a[na]=L;L=ma+1|0;O=na+ -1|0;if(L>>>0<O>>>0){na=O;ma=L}else{la=J;break}}break};case 0:{c[e>>2]=c[f>>2];la=H;break};case 2:{J=a[q]|0;I=(J&1)==0;if(I){oa=(J&255)>>>1}else{oa=c[A>>2]|0}if((oa|0)==0|x){la=H;break a}if(I){pa=y;qa=(J&255)>>>1}else{pa=c[z>>2]|0;qa=c[A>>2]|0}J=pa+qa|0;I=c[f>>2]|0;if((pa|0)==(J|0)){ra=I}else{L=I;I=pa;while(1){a[L]=a[I]|0;O=I+1|0;N=L+1|0;if((O|0)==(J|0)){ra=N;break}else{I=O;L=N}}}c[f>>2]=ra;la=H;break};case 3:{L=a[r]|0;I=(L&1)==0;if(I){sa=(L&255)>>>1}else{sa=c[w>>2]|0}if((sa|0)==0){la=H;break a}if(I){ta=u}else{ta=c[v>>2]|0}I=a[ta]|0;L=c[f>>2]|0;c[f>>2]=L+1;a[L]=I;la=H;break};case 1:{c[e>>2]=c[f>>2];I=Ee[c[(c[k>>2]|0)+28>>2]&63](k,32)|0;L=c[f>>2]|0;c[f>>2]=L+1;a[L]=I;la=H;break};default:{la=H}}}while(0);I=h+1|0;if(I>>>0<4){H=la;h=I}else{break}}h=a[r]|0;r=(h&1)==0;if(r){ua=(h&255)>>>1}else{ua=c[w>>2]|0}if(ua>>>0>1){if(r){va=u;wa=(h&255)>>>1}else{va=c[v>>2]|0;wa=c[w>>2]|0}w=va+1|0;v=va+wa|0;wa=c[f>>2]|0;if((w|0)==(v|0)){xa=wa}else{va=wa;wa=w;while(1){a[va]=a[wa]|0;w=wa+1|0;h=va+1|0;if((w|0)==(v|0)){xa=h;break}else{wa=w;va=h}}}c[f>>2]=xa}xa=g&176;if((xa|0)==16){i=t;return}else if((xa|0)==32){c[e>>2]=c[f>>2];i=t;return}else{c[e>>2]=d;i=t;return}}function $lb(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;k=d;l=d+8|0;m=d+24|0;n=d+32|0;o=n;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+104|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;Ngb(m,g);z=m;A=c[z>>2]|0;if(!((c[78532]|0)==-1)){c[l>>2]=314128;c[l+4>>2]=1431;c[l+8>>2]=0;Cfb(314128,l,1432)}l=(c[314132>>2]|0)+ -1|0;B=c[A+8>>2]|0;if(!((c[A+12>>2]|0)-B>>2>>>0>l>>>0)){C=Hc(4)|0;D=C;Bpb(D);E=329688;F=128;_d(C|0,E|0,F|0)}A=c[B+(l<<2)>>2]|0;if((A|0)==0){C=Hc(4)|0;D=C;Bpb(D);E=329688;F=128;_d(C|0,E|0,F|0)}F=A;E=a[j]|0;C=(E&1)==0;if(C){G=(E&255)>>>1}else{G=c[j+4>>2]|0}if((G|0)==0){H=0}else{if(C){I=j+1|0}else{I=c[j+8>>2]|0}C=a[I]|0;H=C<<24>>24==(Ee[c[(c[A>>2]|0)+28>>2]&63](F,45)|0)<<24>>24}c[n>>2]=0;n=r;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=s;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=t;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Zlb(f,H,m,o,p,q,r,s,t,u);m=v;v=a[j]|0;f=(v&1)==0;if(f){J=(v&255)>>>1}else{J=c[j+4>>2]|0}n=c[u>>2]|0;if((J|0)>(n|0)){if(f){K=(v&255)>>>1}else{K=c[j+4>>2]|0}f=a[t]|0;if((f&1)==0){L=(f&255)>>>1}else{L=c[t+4>>2]|0}f=a[s]|0;if((f&1)==0){M=(f&255)>>>1}else{M=c[s+4>>2]|0}N=L+(K-n<<1|1)+M|0}else{M=a[t]|0;if((M&1)==0){O=(M&255)>>>1}else{O=c[t+4>>2]|0}M=a[s]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[s+4>>2]|0}N=O+2+P|0}P=N+n|0;do{if(P>>>0>100){N=Wpb(P)|0;if((N|0)!=0){Q=N;R=N;break}hqb()}else{Q=0;R=m}}while(0);if((v&1)==0){S=j+1|0;T=(v&255)>>>1}else{S=c[j+8>>2]|0;T=c[j+4>>2]|0}_lb(R,w,x,c[g+4>>2]|0,S,S+T|0,F,H,o,a[p]|0,a[q]|0,r,s,t,n);c[y>>2]=c[e>>2];e=c[w>>2]|0;w=c[x>>2]|0;x=k;n=y;c[x+0>>2]=c[n+0>>2];ncb(b,k,R,e,w,g,h);if((Q|0)==0){Rfb(t);Rfb(s);Rfb(r);U=c[z>>2]|0;V=U;W=V;X=hfb(W)|0;i=d;return}Xpb(Q);Rfb(t);Rfb(s);Rfb(r);U=c[z>>2]|0;V=U;W=V;X=hfb(W)|0;i=d;return}function amb(a){a=a|0;var b=0;b=i;cqb(a);i=b;return}function bmb(a){a=a|0;i=i;return}function cmb(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+16|0;m=d;n=d+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+104|0;r=i;i=i+8|0;s=i;i=i+400|0;t=i;i=i+8|0;u=i;i=i+8|0;v=u;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+400|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=q;c[r>>2]=G;q=s;s=o;h[k>>3]=l;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=Pc(G|0,100,313880,o|0)|0;do{if(s>>>0>99){do{if((a[314024]|0)==0){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);o=c[78504]|0;G=n;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=Qjb(r,o,313880,n)|0;o=c[r>>2]|0;if((o|0)==0){hqb()}H=Wpb(G<<2)|0;I=H;if((H|0)!=0){J=o;K=I;L=I;M=G;break}hqb()}else{J=0;K=0;L=q;M=s}}while(0);Ngb(t,g);s=t;q=c[s>>2]|0;if(!((c[78530]|0)==-1)){c[p>>2]=314120;c[p+4>>2]=1431;c[p+8>>2]=0;Cfb(314120,p,1432)}p=(c[314124>>2]|0)+ -1|0;n=c[q+8>>2]|0;if(!((c[q+12>>2]|0)-n>>2>>>0>p>>>0)){N=Hc(4)|0;O=N;Bpb(O);P=329688;Q=128;_d(N|0,P|0,Q|0)}q=c[n+(p<<2)>>2]|0;if((q|0)==0){N=Hc(4)|0;O=N;Bpb(O);P=329688;Q=128;_d(N|0,P|0,Q|0)}Q=q;P=c[r>>2]|0;Oe[c[(c[q>>2]|0)+48>>2]&63](Q,P,P+M|0,L)|0;if((M|0)==0){R=0}else{R=(a[c[r>>2]|0]|0)==45}c[u>>2]=0;u=y;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=z;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=A;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;dmb(f,R,t,v,w,x,y,z,A,B);t=C;C=c[B>>2]|0;if((M|0)>(C|0)){B=a[A]|0;if((B&1)==0){S=(B&255)>>>1}else{S=c[A+4>>2]|0}B=a[z]|0;if((B&1)==0){T=(B&255)>>>1}else{T=c[z+4>>2]|0}U=S+(M-C<<1|1)+T|0}else{T=a[A]|0;if((T&1)==0){V=(T&255)>>>1}else{V=c[A+4>>2]|0}T=a[z]|0;if((T&1)==0){W=(T&255)>>>1}else{W=c[z+4>>2]|0}U=V+2+W|0}W=U+C|0;do{if(W>>>0>100){U=Wpb(W<<2)|0;V=U;if((U|0)!=0){X=V;Y=V;break}hqb()}else{X=0;Y=t}}while(0);emb(Y,D,E,c[g+4>>2]|0,L,L+(M<<2)|0,Q,R,v,c[w>>2]|0,c[x>>2]|0,y,z,A,C);c[F>>2]=c[e>>2];e=c[D>>2]|0;D=c[E>>2]|0;E=m;C=F;c[E+0>>2]=c[C+0>>2];Zjb(b,m,Y,e,D,g,j);if((X|0)!=0){Xpb(X)}tgb(A);tgb(z);Rfb(y);hfb(c[s>>2]|0)|0;if((K|0)!=0){Xpb(K)}if((J|0)==0){i=d;return}Xpb(J);i=d;return}function dmb(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+40|0;o=n;p=n+16|0;q=n+32|0;r=q;s=i;i=i+16|0;t=i;i=i+8|0;u=t;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=B;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[e>>2]|0;if(b){if(!((c[78424]|0)==-1)){c[p>>2]=313696;c[p+4>>2]=1431;c[p+8>>2]=0;Cfb(313696,p,1432)}p=(c[313700>>2]|0)+ -1|0;b=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-b>>2>>>0>p>>>0)){H=Hc(4)|0;I=H;Bpb(I);J=329688;K=128;_d(H|0,J|0,K|0)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){H=Hc(4)|0;I=H;Bpb(I);J=329688;K=128;_d(H|0,J|0,K|0)}K=e;J=c[e>>2]|0;if(d){ne[c[J+44>>2]&255](r,K);r=f;H=c[q>>2]|0;a[r]=H;a[r+1|0]=H>>8;a[r+2|0]=H>>16;a[r+3|0]=H>>24;ne[c[(c[e>>2]|0)+32>>2]&255](s,K);H=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}wgb(l,0);r=s;c[H+0>>2]=c[r+0>>2];c[H+4>>2]=c[r+4>>2];c[H+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;tgb(s)}else{ne[c[J+40>>2]&255](u,K);u=f;J=c[t>>2]|0;a[u]=J;a[u+1|0]=J>>8;a[u+2|0]=J>>16;a[u+3|0]=J>>24;ne[c[(c[e>>2]|0)+28>>2]&255](v,K);J=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}wgb(l,0);u=v;c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;tgb(v)}c[g>>2]=pe[c[(c[e>>2]|0)+12>>2]&127](K)|0;c[h>>2]=pe[c[(c[e>>2]|0)+16>>2]&127](K)|0;ne[c[(c[e>>2]|0)+20>>2]&255](w,K);v=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}bgb(j,0);u=w;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Rfb(w);ne[c[(c[e>>2]|0)+24>>2]&255](x,K);w=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}wgb(k,0);u=x;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;tgb(x);L=pe[c[(c[e>>2]|0)+36>>2]&127](K)|0;c[m>>2]=L;i=n;return}else{if(!((c[78408]|0)==-1)){c[o>>2]=313632;c[o+4>>2]=1431;c[o+8>>2]=0;Cfb(313632,o,1432)}o=(c[313636>>2]|0)+ -1|0;K=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-K>>2>>>0>o>>>0)){M=Hc(4)|0;N=M;Bpb(N);O=329688;P=128;_d(M|0,O|0,P|0)}G=c[K+(o<<2)>>2]|0;if((G|0)==0){M=Hc(4)|0;N=M;Bpb(N);O=329688;P=128;_d(M|0,O|0,P|0)}P=G;O=c[G>>2]|0;if(d){ne[c[O+44>>2]&255](z,P);z=f;d=c[y>>2]|0;a[z]=d;a[z+1|0]=d>>8;a[z+2|0]=d>>16;a[z+3|0]=d>>24;ne[c[(c[G>>2]|0)+32>>2]&255](A,P);d=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}wgb(l,0);z=A;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;tgb(A)}else{ne[c[O+40>>2]&255](C,P);C=f;f=c[B>>2]|0;a[C]=f;a[C+1|0]=f>>8;a[C+2|0]=f>>16;a[C+3|0]=f>>24;ne[c[(c[G>>2]|0)+28>>2]&255](D,P);f=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}wgb(l,0);l=D;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;tgb(D)}c[g>>2]=pe[c[(c[G>>2]|0)+12>>2]&127](P)|0;c[h>>2]=pe[c[(c[G>>2]|0)+16>>2]&127](P)|0;ne[c[(c[G>>2]|0)+20>>2]&255](E,P);h=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}bgb(j,0);j=E;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;Rfb(E);ne[c[(c[G>>2]|0)+24>>2]&255](F,P);E=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}wgb(k,0);k=F;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;tgb(F);L=pe[c[(c[G>>2]|0)+36>>2]&127](P)|0;c[m>>2]=L;i=n;return}}function emb(b,d,e,f,g,h,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;s=i;c[e>>2]=b;t=q+4|0;u=q+8|0;v=(f&512|0)==0;w=p+4|0;x=p+8|0;y=(r|0)>0;z=o+1|0;A=o+8|0;B=o+4|0;C=g;g=0;while(1){a:do{switch(a[l+g|0]|0){case 4:{D=c[e>>2]|0;E=k?C+4|0:C;b:do{if(E>>>0<h>>>0){F=E;while(1){G=F+4|0;if(!(se[c[(c[j>>2]|0)+12>>2]&63](j,2048,c[F>>2]|0)|0)){H=F;break b}if(G>>>0<h>>>0){F=G}else{H=G;break}}}else{H=E}}while(0);if(y){do{if(H>>>0>E>>>0){F=c[e>>2]|0;G=H;I=r;while(1){J=G+ -4|0;K=F+4|0;c[F>>2]=c[J>>2];L=I+ -1|0;M=(L|0)>0;if(J>>>0>E>>>0&M){I=L;G=J;F=K}else{break}}c[e>>2]=K;if(M){N=J;O=L;P=34;break}F=c[e>>2]|0;c[e>>2]=F+4;Q=F;R=J}else{N=H;O=r;P=34}}while(0);do{if((P|0)==34){P=0;F=Ee[c[(c[j>>2]|0)+44>>2]&63](j,48)|0;G=c[e>>2]|0;I=G+4|0;c[e>>2]=I;if((O|0)>0){S=I;T=G;U=O}else{Q=G;R=N;break}while(1){c[T>>2]=F;I=U+ -1|0;if((I|0)>0){U=I;T=S;S=S+4|0}else{break}}c[e>>2]=G+(O+1<<2);Q=G+(O<<2)|0;R=N}}while(0);c[Q>>2]=m;V=R}else{V=H}if((V|0)==(E|0)){F=Ee[c[(c[j>>2]|0)+44>>2]&63](j,48)|0;I=c[e>>2]|0;W=I+4|0;c[e>>2]=W;c[I>>2]=F;X=W}else{W=a[o]|0;F=(W&1)==0;if(F){Y=(W&255)>>>1}else{Y=c[B>>2]|0}if((Y|0)==0){Z=V;_=-1;$=0;aa=0}else{if(F){ba=z}else{ba=c[A>>2]|0}Z=V;_=a[ba]|0;$=0;aa=0}while(1){F=c[e>>2]|0;do{if((aa|0)==(_|0)){W=F+4|0;c[e>>2]=W;c[F>>2]=n;I=$+1|0;ca=a[o]|0;da=(ca&1)==0;if(da){ea=(ca&255)>>>1}else{ea=c[B>>2]|0}if(!(I>>>0<ea>>>0)){fa=W;ga=_;ha=I;ia=0;break}if(da){ja=z}else{ja=c[A>>2]|0}if((a[ja+I|0]|0)==127){fa=W;ga=-1;ha=I;ia=0;break}if(da){ka=z}else{ka=c[A>>2]|0}fa=W;ga=a[ka+I|0]|0;ha=I;ia=0}else{fa=F;ga=_;ha=$;ia=aa}}while(0);F=Z+ -4|0;G=c[F>>2]|0;I=fa+4|0;c[e>>2]=I;c[fa>>2]=G;if((F|0)==(E|0)){X=I;break}else{Z=F;_=ga;$=ha;aa=ia+1|0}}}if((D|0)==(X|0)){la=E;break a}F=X+ -4|0;if(F>>>0>D>>>0){ma=D;na=F}else{la=E;break a}while(1){F=c[ma>>2]|0;c[ma>>2]=c[na>>2];c[na>>2]=F;F=ma+4|0;I=na+ -4|0;if(F>>>0<I>>>0){na=I;ma=F}else{la=E;break}}break};case 2:{E=a[p]|0;D=(E&1)==0;if(D){oa=(E&255)>>>1}else{oa=c[w>>2]|0}if((oa|0)==0|v){la=C;break a}if(D){pa=w;qa=(E&255)>>>1}else{pa=c[x>>2]|0;qa=c[w>>2]|0}E=pa+(qa<<2)|0;D=c[e>>2]|0;if((pa|0)==(E|0)){ra=D}else{F=(pa+(qa+ -1<<2)+(0-pa)|0)>>>2;I=D;G=pa;while(1){c[I>>2]=c[G>>2];W=G+4|0;if((W|0)==(E|0)){break}I=I+4|0;G=W}ra=D+(F+1<<2)|0}c[e>>2]=ra;la=C;break};case 1:{c[d>>2]=c[e>>2];G=Ee[c[(c[j>>2]|0)+44>>2]&63](j,32)|0;I=c[e>>2]|0;c[e>>2]=I+4;c[I>>2]=G;la=C;break};case 3:{G=a[q]|0;I=(G&1)==0;if(I){sa=(G&255)>>>1}else{sa=c[t>>2]|0}if((sa|0)==0){la=C;break a}if(I){ta=t}else{ta=c[u>>2]|0}I=c[ta>>2]|0;G=c[e>>2]|0;c[e>>2]=G+4;c[G>>2]=I;la=C;break};case 0:{c[d>>2]=c[e>>2];la=C;break};default:{la=C}}}while(0);I=g+1|0;if(I>>>0<4){C=la;g=I}else{break}}g=a[q]|0;q=(g&1)==0;if(q){ua=(g&255)>>>1}else{ua=c[t>>2]|0}if(ua>>>0>1){if(q){va=t;wa=(g&255)>>>1}else{va=c[u>>2]|0;wa=c[t>>2]|0}t=va+4|0;u=va+(wa<<2)|0;g=c[e>>2]|0;if((t|0)==(u|0)){xa=g}else{q=(va+(wa+ -1<<2)+(0-t)|0)>>>2;wa=g;va=t;while(1){c[wa>>2]=c[va>>2];t=va+4|0;if((t|0)==(u|0)){break}else{va=t;wa=wa+4|0}}xa=g+(q+1<<2)|0}c[e>>2]=xa}xa=f&176;if((xa|0)==32){c[d>>2]=c[e>>2];i=s;return}else if((xa|0)==16){i=s;return}else{c[d>>2]=b;i=s;return}}function fmb(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;k=d;l=d+8|0;m=d+24|0;n=d+32|0;o=n;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+400|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;Ngb(m,g);z=m;A=c[z>>2]|0;if(!((c[78530]|0)==-1)){c[l>>2]=314120;c[l+4>>2]=1431;c[l+8>>2]=0;Cfb(314120,l,1432)}l=(c[314124>>2]|0)+ -1|0;B=c[A+8>>2]|0;if(!((c[A+12>>2]|0)-B>>2>>>0>l>>>0)){C=Hc(4)|0;D=C;Bpb(D);E=329688;F=128;_d(C|0,E|0,F|0)}A=c[B+(l<<2)>>2]|0;if((A|0)==0){C=Hc(4)|0;D=C;Bpb(D);E=329688;F=128;_d(C|0,E|0,F|0)}F=A;E=a[j]|0;C=(E&1)==0;if(C){G=(E&255)>>>1}else{G=c[j+4>>2]|0}if((G|0)==0){H=0}else{if(C){I=j+4|0}else{I=c[j+8>>2]|0}C=c[I>>2]|0;H=(C|0)==(Ee[c[(c[A>>2]|0)+44>>2]&63](F,45)|0)}c[n>>2]=0;n=r;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=s;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=t;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;dmb(f,H,m,o,p,q,r,s,t,u);m=v;v=a[j]|0;f=(v&1)==0;if(f){J=(v&255)>>>1}else{J=c[j+4>>2]|0}n=c[u>>2]|0;if((J|0)>(n|0)){if(f){K=(v&255)>>>1}else{K=c[j+4>>2]|0}f=a[t]|0;if((f&1)==0){L=(f&255)>>>1}else{L=c[t+4>>2]|0}f=a[s]|0;if((f&1)==0){M=(f&255)>>>1}else{M=c[s+4>>2]|0}N=L+(K-n<<1|1)+M|0}else{M=a[t]|0;if((M&1)==0){O=(M&255)>>>1}else{O=c[t+4>>2]|0}M=a[s]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[s+4>>2]|0}N=O+2+P|0}P=N+n|0;do{if(P>>>0>100){N=Wpb(P<<2)|0;O=N;if((N|0)!=0){Q=O;R=O;break}hqb()}else{Q=0;R=m}}while(0);if((v&1)==0){S=j+4|0;T=(v&255)>>>1}else{S=c[j+8>>2]|0;T=c[j+4>>2]|0}emb(R,w,x,c[g+4>>2]|0,S,S+(T<<2)|0,F,H,o,c[p>>2]|0,c[q>>2]|0,r,s,t,n);c[y>>2]=c[e>>2];e=c[w>>2]|0;w=c[x>>2]|0;x=k;n=y;c[x+0>>2]=c[n+0>>2];Zjb(b,k,R,e,w,g,h);if((Q|0)==0){tgb(t);tgb(s);Rfb(r);U=c[z>>2]|0;V=U;W=V;X=hfb(W)|0;i=d;return}Xpb(Q);tgb(t);tgb(s);Rfb(r);U=c[z>>2]|0;V=U;W=V;X=hfb(W)|0;i=d;return}function gmb(a){a=a|0;var b=0;b=i;cqb(a);i=b;return}function hmb(a){a=a|0;i=i;return}function imb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=xc(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)|0)|0}function jmb(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;j=d;k=j;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;k=a[h]|0;if((k&1)==0){l=h+1|0;m=h+1|0;n=(k&255)>>>1}else{k=c[h+8>>2]|0;l=k;m=k;n=c[h+4>>2]|0}h=l+n|0;do{if(m>>>0<h>>>0){n=m;do{hgb(j,a[n]|0);n=n+1|0;}while(n>>>0<h>>>0);n=(e|0)==-1?-1:e<<1;if((a[j]&1)==0){o=n;p=9;break}q=n;r=c[j+8>>2]|0}else{o=(e|0)==-1?-1:e<<1;p=9}}while(0);if((p|0)==9){q=o;r=j+1|0}o=Fd(q|0,f|0,g|0,r|0)|0;r=b;c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;r=yqb(o|0)|0;g=o+r|0;if((r|0)>0){s=o}else{Rfb(j);i=d;return}do{hgb(b,a[s]|0);s=s+1|0;}while(s>>>0<g>>>0);Rfb(j);i=d;return}function kmb(a,b){a=a|0;b=b|0;a=i;Kb(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function lmb(a){a=a|0;var b=0;b=i;cqb(a);i=b;return}function mmb(a){a=a|0;i=i;return}function nmb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=xc(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)|0)|0}function omb(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=i;i=i+240|0;j=d;k=d+8|0;l=d+40|0;m=d+48|0;n=d+56|0;o=d+64|0;p=d+192|0;q=d+200|0;r=d+208|0;s=d+224|0;t=d+232|0;u=r;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[s+4>>2]=0;c[s>>2]=315784;u=a[h]|0;if((u&1)==0){v=h+4|0;w=h+4|0;x=(u&255)>>>1}else{u=c[h+8>>2]|0;v=u;w=u;x=c[h+4>>2]|0}h=v+(x<<2)|0;x=k;v=j;u=j;c[u>>2]=0;c[u+4>>2]=0;a:do{if(w>>>0<h>>>0){u=s;j=k+32|0;y=w;z=315784|0;while(1){c[m>>2]=y;A=(Ne[c[z+12>>2]&15](u,v,y,h,m,x,j,l)|0)==2;B=c[m>>2]|0;if(A|(B|0)==(y|0)){break}if(x>>>0<(c[l>>2]|0)>>>0){A=x;do{hgb(r,a[A]|0);A=A+1|0;}while(A>>>0<(c[l>>2]|0)>>>0);C=c[m>>2]|0}else{C=B}if(!(C>>>0<h>>>0)){break a}y=C;z=c[s>>2]|0}Jlb(315008)}}while(0);if((a[r]&1)==0){D=r+1|0}else{D=c[r+8>>2]|0}s=Fd(((e|0)==-1?-1:e<<1)|0,f|0,g|0,D|0)|0;D=b;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;c[t+4>>2]=0;c[t>>2]=315888;D=yqb(s|0)|0;g=s+D|0;f=n;e=n;c[e>>2]=0;c[e+4>>2]=0;if((D|0)<=0){Rfb(r);i=d;return}D=t;e=g;n=o;C=o+128|0;o=s;s=315888|0;while(1){c[q>>2]=o;h=(Ne[c[s+16>>2]&15](D,f,o,(e-o|0)>32?o+32|0:g,q,n,C,p)|0)==2;m=c[q>>2]|0;if(h|(m|0)==(o|0)){E=20;break}if(n>>>0<(c[p>>2]|0)>>>0){h=n;do{xgb(b,c[h>>2]|0);h=h+4|0;}while(h>>>0<(c[p>>2]|0)>>>0);F=c[q>>2]|0}else{F=m}if(!(F>>>0<g>>>0)){E=25;break}o=F;s=c[t>>2]|0}if((E|0)==20){Jlb(315008)}else if((E|0)==25){Rfb(r);i=d;return}}function pmb(a,b){a=a|0;b=b|0;a=i;Kb(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function qmb(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=314216;e=b+8|0;b=c[e>>2]|0;do{if((a[314024]|0)==0){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);if((b|0)==(c[78504]|0)){i=d;return}ec(c[e>>2]|0);i=d;return}function rmb(a){a=a|0;a=Hc(8)|0;ifb(a,314008);c[a>>2]=310976;_d(a|0,311016,41)}function smb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+448|0;f=e;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=e+80|0;m=e+96|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+160|0;r=e+176|0;s=e+192|0;t=e+208|0;u=e+224|0;v=e+240|0;w=e+256|0;x=e+272|0;y=e+288|0;z=e+304|0;A=e+320|0;B=e+336|0;C=e+352|0;D=e+368|0;E=e+384|0;F=e+400|0;G=e+416|0;H=e+432|0;c[b+4>>2]=d+ -1;c[b>>2]=314048;d=b+8|0;I=b+12|0;J=b+136|0;a[J]=1;K=b+24|0;c[I>>2]=K;c[d>>2]=K;c[b+16>>2]=J;J=28;L=K;do{if((L|0)==0){M=0}else{c[L>>2]=0;M=c[I>>2]|0}L=M+4|0;c[I>>2]=L;J=J+ -1|0;}while((J|0)!=0);Jfb(b+144|0,314032,1);J=c[d>>2]|0;d=c[I>>2]|0;if((d|0)!=(J|0)){c[I>>2]=d+(~((d+ -4+(0-J)|0)>>>2)<<2)}c[318940>>2]=0;c[79734]=312528;if(!((c[78138]|0)==-1)){c[G>>2]=312552;c[G+4>>2]=1431;c[G+8>>2]=0;Cfb(312552,G,1432)}tmb(b,318936,(c[312556>>2]|0)+ -1|0);c[318932>>2]=0;c[79732]=312568;if(!((c[78148]|0)==-1)){c[F>>2]=312592;c[F+4>>2]=1431;c[F+8>>2]=0;Cfb(312592,F,1432)}tmb(b,318928,(c[312596>>2]|0)+ -1|0);c[318916>>2]=0;c[79728]=314144;c[318920>>2]=0;a[318924|0]=0;F=c[(Bc()|0)>>2]|0;c[318920>>2]=F;if(!((c[78532]|0)==-1)){c[E>>2]=314128;c[E+4>>2]=1431;c[E+8>>2]=0;Cfb(314128,E,1432)}tmb(b,318912,(c[314132>>2]|0)+ -1|0);c[318908>>2]=0;c[79726]=315104;if(!((c[78530]|0)==-1)){c[D>>2]=314120;c[D+4>>2]=1431;c[D+8>>2]=0;Cfb(314120,D,1432)}tmb(b,318904,(c[314124>>2]|0)+ -1|0);c[318900>>2]=0;c[79724]=315320;if(!((c[78548]|0)==-1)){c[C>>2]=314192;c[C+4>>2]=1431;c[C+8>>2]=0;Cfb(314192,C,1432)}tmb(b,318896,(c[314196>>2]|0)+ -1|0);c[318884>>2]=0;c[79720]=314216;do{if((a[314024]|0)==0){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);c[318888>>2]=c[78504];if(!((c[78550]|0)==-1)){c[B>>2]=314200;c[B+4>>2]=1431;c[B+8>>2]=0;Cfb(314200,B,1432)}tmb(b,318880,(c[314204>>2]|0)+ -1|0);c[318876>>2]=0;c[79718]=315544;if(!((c[78564]|0)==-1)){c[A>>2]=314256;c[A+4>>2]=1431;c[A+8>>2]=0;Cfb(314256,A,1432)}tmb(b,318872,(c[314260>>2]|0)+ -1|0);c[318868>>2]=0;c[79716]=315664;if(!((c[78566]|0)==-1)){c[z>>2]=314264;c[z+4>>2]=1431;c[z+8>>2]=0;Cfb(314264,z,1432)}tmb(b,318864,(c[314268>>2]|0)+ -1|0);c[318844>>2]=0;c[79710]=314296;a[318848|0]=46;a[318849|0]=44;z=318852|0;c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;if(!((c[78568]|0)==-1)){c[y>>2]=314272;c[y+4>>2]=1431;c[y+8>>2]=0;Cfb(314272,y,1432)}tmb(b,318840,(c[314276>>2]|0)+ -1|0);c[318812>>2]=0;c[79702]=314336;c[318816>>2]=46;c[318820>>2]=44;y=318824|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;if(!((c[78570]|0)==-1)){c[x>>2]=314280;c[x+4>>2]=1431;c[x+8>>2]=0;Cfb(314280,x,1432)}tmb(b,318808,(c[314284>>2]|0)+ -1|0);c[318804>>2]=0;c[79700]=312608;if(!((c[78166]|0)==-1)){c[w>>2]=312664;c[w+4>>2]=1431;c[w+8>>2]=0;Cfb(312664,w,1432)}tmb(b,318800,(c[312668>>2]|0)+ -1|0);c[318796>>2]=0;c[79698]=312728;if(!((c[78196]|0)==-1)){c[v>>2]=312784;c[v+4>>2]=1431;c[v+8>>2]=0;Cfb(312784,v,1432)}tmb(b,318792,(c[312788>>2]|0)+ -1|0);c[318788>>2]=0;c[79696]=312800;if(!((c[78212]|0)==-1)){c[u>>2]=312848;c[u+4>>2]=1431;c[u+8>>2]=0;Cfb(312848,u,1432)}tmb(b,318784,(c[312852>>2]|0)+ -1|0);c[318780>>2]=0;c[79694]=312864;if(!((c[78228]|0)==-1)){c[t>>2]=312912;c[t+4>>2]=1431;c[t+8>>2]=0;Cfb(312912,t,1432)}tmb(b,318776,(c[312916>>2]|0)+ -1|0);c[318772>>2]=0;c[79692]=313456;if(!((c[78376]|0)==-1)){c[s>>2]=313504;c[s+4>>2]=1431;c[s+8>>2]=0;Cfb(313504,s,1432)}tmb(b,318768,(c[313508>>2]|0)+ -1|0);c[318764>>2]=0;c[79690]=313520;if(!((c[78392]|0)==-1)){c[r>>2]=313568;c[r+4>>2]=1431;c[r+8>>2]=0;Cfb(313568,r,1432)}tmb(b,318760,(c[313572>>2]|0)+ -1|0);c[318756>>2]=0;c[79688]=313584;if(!((c[78408]|0)==-1)){c[q>>2]=313632;c[q+4>>2]=1431;c[q+8>>2]=0;Cfb(313632,q,1432)}tmb(b,318752,(c[313636>>2]|0)+ -1|0);c[318748>>2]=0;c[79686]=313648;if(!((c[78424]|0)==-1)){c[p>>2]=313696;c[p+4>>2]=1431;c[p+8>>2]=0;Cfb(313696,p,1432)}tmb(b,318744,(c[313700>>2]|0)+ -1|0);c[318740>>2]=0;c[79684]=313712;if(!((c[78434]|0)==-1)){c[o>>2]=313736;c[o+4>>2]=1431;c[o+8>>2]=0;Cfb(313736,o,1432)}tmb(b,318736,(c[313740>>2]|0)+ -1|0);c[318732>>2]=0;c[79682]=313792;if(!((c[78454]|0)==-1)){c[n>>2]=313816;c[n+4>>2]=1431;c[n+8>>2]=0;Cfb(313816,n,1432)}tmb(b,318728,(c[313820>>2]|0)+ -1|0);c[318724>>2]=0;c[79680]=313848;if(!((c[78468]|0)==-1)){c[m>>2]=313872;c[m+4>>2]=1431;c[m+8>>2]=0;Cfb(313872,m,1432)}tmb(b,318720,(c[313876>>2]|0)+ -1|0);c[318716>>2]=0;c[79678]=313896;if(!((c[78480]|0)==-1)){c[l>>2]=313920;c[l+4>>2]=1431;c[l+8>>2]=0;Cfb(313920,l,1432)}tmb(b,318712,(c[313924>>2]|0)+ -1|0);c[318700>>2]=0;c[79674]=312944;c[318704>>2]=312992;if(!((c[78256]|0)==-1)){c[k>>2]=313024;c[k+4>>2]=1431;c[k+8>>2]=0;Cfb(313024,k,1432)}tmb(b,318696,(c[313028>>2]|0)+ -1|0);c[318684>>2]=0;c[79670]=313096;c[318688>>2]=313144;if(!((c[78294]|0)==-1)){c[j>>2]=313176;c[j+4>>2]=1431;c[j+8>>2]=0;Cfb(313176,j,1432)}tmb(b,318680,(c[313180>>2]|0)+ -1|0);c[318668>>2]=0;c[79666]=315040;do{if((a[314024]|0)==0){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);c[318672>>2]=c[78504];c[79666]=313392;if(!((c[78352]|0)==-1)){c[h>>2]=313408;c[h+4>>2]=1431;c[h+8>>2]=0;Cfb(313408,h,1432)}tmb(b,318664,(c[313412>>2]|0)+ -1|0);c[318652>>2]=0;c[79662]=315040;do{if((a[314024]|0)==0){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);c[318656>>2]=c[78504];c[79662]=313424;if(!((c[78360]|0)==-1)){c[g>>2]=313440;c[g+4>>2]=1431;c[g+8>>2]=0;Cfb(313440,g,1432)}tmb(b,318648,(c[313444>>2]|0)+ -1|0);c[318644>>2]=0;c[79660]=313936;if(!((c[78490]|0)==-1)){c[f>>2]=313960;c[f+4>>2]=1431;c[f+8>>2]=0;Cfb(313960,f,1432)}tmb(b,318640,(c[313964>>2]|0)+ -1|0);c[318636>>2]=0;c[79658]=313976;if((c[78500]|0)==-1){N=314e3;O=314e3;P=O+4|0;Q=P;R=c[Q>>2]|0;S=R+ -1|0;T=318632;tmb(b,T,S);i=e;return}c[H>>2]=314e3;c[H+4>>2]=1431;c[H+8>>2]=0;Cfb(314e3,H,1432);N=314e3;O=314e3;P=O+4|0;Q=P;R=c[Q>>2]|0;S=R+ -1|0;T=318632;tmb(b,T,S);i=e;return}function tmb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;gfb(b);f=a+8|0;g=a+12|0;a=c[g>>2]|0;h=f;j=c[h>>2]|0;k=a-j>>2;do{if(k>>>0>d>>>0){l=j}else{m=d+1|0;if(k>>>0<m>>>0){yob(f,m-k|0);l=c[h>>2]|0;break}if(!(k>>>0>m>>>0)){l=j;break}n=j+(m<<2)|0;if((a|0)==(n|0)){l=j;break}c[g>>2]=a+(~((a+ -4+(0-n)|0)>>>2)<<2);l=j}}while(0);j=c[l+(d<<2)>>2]|0;if((j|0)==0){o=l;p=o;q=d<<2;r=p+q|0;s=r;c[s>>2]=b;i=e;return}hfb(j)|0;o=c[h>>2]|0;p=o;q=d<<2;r=p+q|0;s=r;c[s>>2]=b;i=e;return}function umb(a){a=a|0;var b=0;b=i;vmb(a);cqb(a);i=b;return}function vmb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;c[b>>2]=314048;e=b+12|0;f=c[e>>2]|0;g=b+8|0;h=c[g>>2]|0;if((f|0)!=(h|0)){j=f;f=h;h=0;while(1){k=c[f+(h<<2)>>2]|0;if((k|0)==0){l=f;m=j}else{hfb(k)|0;l=c[g>>2]|0;m=c[e>>2]|0}k=h+1|0;if(k>>>0<m-l>>2>>>0){j=m;f=l;h=k}else{break}}}Rfb(b+144|0);h=c[g>>2]|0;if((h|0)==0){i=d;return}g=c[e>>2]|0;if((g|0)!=(h|0)){c[e>>2]=g+(~((g+ -4+(0-h)|0)>>>2)<<2)}if((b+24|0)==(h|0)){a[b+136|0]=0;i=d;return}else{cqb(h);i=d;return}}function wmb(){var b=0,d=0,e=0,f=0;b=i;if((a[314104]|0)!=0){d=314096;e=c[78524]|0;i=b;return e|0}if((_a(314104)|0)==0){d=314096;e=c[78524]|0;i=b;return e|0}do{if((a[314080]|0)==0){if((_a(314080)|0)==0){break}smb(318472,1);c[78516]=318472;c[78518]=314064;Wb(314080)}}while(0);f=c[c[78518]>>2]|0;c[78522]=f;gfb(f);c[78524]=314088;Wb(314104);d=314096;e=c[78524]|0;i=b;return e|0}function xmb(a){a=a|0;var b=0,d=0;b=i;d=c[(wmb()|0)>>2]|0;c[a>>2]=d;gfb(d);i=b;return}function ymb(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;gfb(e);i=d;return}function zmb(a){a=a|0;var b=0;b=i;hfb(c[a>>2]|0)|0;i=b;return}function Amb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;a=b;if(!((c[a>>2]|0)==-1)){c[e>>2]=b;c[e+4>>2]=1431;c[e+8>>2]=0;Cfb(a,e,1432)}e=(c[b+4>>2]|0)+ -1|0;b=c[f+8>>2]|0;if(!((c[f+12>>2]|0)-b>>2>>>0>e>>>0)){g=0;i=d;return g|0}g=(c[b+(e<<2)>>2]|0)!=0;i=d;return g|0}function Bmb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;a=b;if(!((c[a>>2]|0)==-1)){c[e>>2]=b;c[e+4>>2]=1431;c[e+8>>2]=0;Cfb(a,e,1432)}e=(c[b+4>>2]|0)+ -1|0;b=c[f+8>>2]|0;if(!((c[f+12>>2]|0)-b>>2>>>0>e>>>0)){g=Hc(4)|0;h=g;Bpb(h);j=329688;k=128;_d(g|0,j|0,k|0)}f=c[b+(e<<2)>>2]|0;if((f|0)==0){g=Hc(4)|0;h=g;Bpb(h);j=329688;k=128;_d(g|0,j|0,k|0)}else{i=d;return f|0}return 0}function Cmb(a){a=a|0;var b=0;b=i;cqb(a);i=b;return}function Dmb(a){a=a|0;var b=0;b=i;if((a|0)==0){i=b;return}me[c[(c[a>>2]|0)+4>>2]&2047](a);i=b;return}function Emb(a){a=a|0;var b=0;b=c[78528]|0;c[78528]=1+b;c[a+4>>2]=b+1;i=i;return}function Fmb(a){a=a|0;var b=0;b=i;cqb(a);i=b;return}function Gmb(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;a=i;if(!(e>>>0<128)){f=0;i=a;return f|0}f=(b[(c[(Bc()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16!=0;i=a;return f|0}function Hmb(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;if((d|0)==(e|0)){g=d;i=a;return g|0}else{h=d;j=f}while(1){f=c[h>>2]|0;if(f>>>0<128){k=b[(c[(Bc()|0)>>2]|0)+(f<<1)>>1]|0}else{k=0}b[j>>1]=k;f=h+4|0;if((f|0)==(e|0)){g=e;break}else{h=f;j=j+2|0}}i=a;return g|0}function Imb(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;a=i;if((e|0)==(f|0)){g=e;i=a;return g|0}else{h=e}while(1){e=c[h>>2]|0;if(e>>>0<128){if(!((b[(c[(Bc()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16==0)){g=h;j=5;break}}e=h+4|0;if((e|0)==(f|0)){g=f;j=5;break}else{h=e}}if((j|0)==5){i=a;return g|0}return 0}function Jmb(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;a:do{if((e|0)==(f|0)){g=e}else{h=e;while(1){j=c[h>>2]|0;if(!(j>>>0<128)){g=h;break a}k=h+4|0;if((b[(c[(Bc()|0)>>2]|0)+(j<<1)>>1]&d)<<16>>16==0){g=h;break a}if((k|0)==(f|0)){g=f;break}else{h=k}}}}while(0);i=a;return g|0}function Kmb(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b>>>0<128)){d=b;i=a;return d|0}d=c[(c[(Kd()|0)>>2]|0)+(b<<2)>>2]|0;i=a;return d|0}function Lmb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128){g=c[(c[(Kd()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}i=a;return e|0}function Mmb(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b>>>0<128)){d=b;i=a;return d|0}d=c[(c[(Pd()|0)>>2]|0)+(b<<2)>>2]|0;i=a;return d|0}function Nmb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128){g=c[(c[(Pd()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}i=a;return e|0}function Omb(a,b){a=a|0;b=b|0;i=i;return b<<24>>24|0}function Pmb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((d|0)==(e|0)){g=d;i=b;return g|0}else{h=d;j=f}while(1){c[j>>2]=a[h]|0;f=h+1|0;if((f|0)==(e|0)){g=e;break}else{j=j+4|0;h=f}}i=b;return g|0}function Qmb(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return(b>>>0<128?b&255:c)|0}function Rmb(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;if((d|0)==(e|0)){h=d;i=b;return h|0}j=((e+ -4+(0-d)|0)>>>2)+1|0;k=d;l=g;while(1){g=c[k>>2]|0;a[l]=g>>>0<128?g&255:f;g=k+4|0;if((g|0)==(e|0)){break}else{l=l+1|0;k=g}}h=d+(j<<2)|0;i=b;return h|0}function Smb(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=314144;e=c[b+8>>2]|0;do{if((e|0)!=0){if((a[b+12|0]|0)==0){break}dqb(e)}}while(0);cqb(b);i=d;return}function Tmb(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=314144;e=c[b+8>>2]|0;if((e|0)==0){i=d;return}if((a[b+12|0]|0)==0){i=d;return}dqb(e);i=d;return}function Umb(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b<<24>>24>-1)){d=b;i=a;return d|0}d=c[(c[(Kd()|0)>>2]|0)+((b&255)<<2)>>2]&255;i=a;return d|0}function Vmb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(Kd()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}i=b;return f|0}function Wmb(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b<<24>>24>-1)){d=b;i=a;return d|0}d=c[(c[(Pd()|0)>>2]|0)+(b<<24>>24<<2)>>2]&255;i=a;return d|0}function Xmb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(Pd()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}i=b;return f|0}function Ymb(a,b){a=a|0;b=b|0;i=i;return b|0}function Zmb(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((c|0)==(d|0)){f=c;i=b;return f|0}else{g=c;h=e}while(1){a[h]=a[g]|0;e=g+1|0;if((e|0)==(d|0)){f=d;break}else{h=h+1|0;g=e}}i=b;return f|0}function _mb(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return(b<<24>>24>-1?b:c)|0}function $mb(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((c|0)==(d|0)){g=c;i=b;return g|0}else{h=c;j=f}while(1){f=a[h]|0;a[j]=f<<24>>24>-1?f:e;f=h+1|0;if((f|0)==(d|0)){g=d;break}else{j=j+1|0;h=f}}i=b;return g|0}function anb(a){a=a|0;var b=0;b=i;cqb(a);i=b;return}function bnb(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;c[f>>2]=d;c[j>>2]=g;i=i;return 3}function cnb(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;c[f>>2]=d;c[j>>2]=g;i=i;return 3}function dnb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function enb(a){a=a|0;i=i;return 1}function fnb(a){a=a|0;i=i;return 1}function gnb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=d-c|0;i=i;return(b>>>0<e>>>0?b:e)|0}function hnb(a){a=a|0;i=i;return 1}function inb(a){a=a|0;var b=0;b=i;qmb(a);cqb(a);i=b;return}function jnb(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;l=i;i=i+8|0;m=l;n=m;o=i;i=i+8|0;p=(e|0)==(f|0);a:do{if(p){c[k>>2]=h;c[g>>2]=e;q=e}else{r=e;while(1){s=r+4|0;if((c[r>>2]|0)==0){t=r;break}if((s|0)==(f|0)){t=f;break}else{r=s}}c[k>>2]=h;c[g>>2]=e;if(p|(h|0)==(j|0)){q=e;break}r=j;s=b+8|0;u=o;v=e;w=h;x=t;while(1){y=d;z=c[y+4>>2]|0;A=m;c[A>>2]=c[y>>2];c[A+4>>2]=z;z=Oc(c[s>>2]|0)|0;A=apb(w,g,x-v>>2,r-w|0,d)|0;if((z|0)!=0){Oc(z|0)|0}if((A|0)==0){B=1;C=33;break}else if((A|0)==-1){C=10;break}z=(c[k>>2]|0)+A|0;c[k>>2]=z;if((z|0)==(j|0)){C=31;break}if((x|0)==(f|0)){D=c[g>>2]|0;E=z;F=f}else{z=Oc(c[s>>2]|0)|0;A=$ob(u,0,d)|0;if((z|0)!=0){Oc(z|0)|0}if((A|0)==-1){B=2;C=33;break}z=c[k>>2]|0;if(A>>>0>(r-z|0)>>>0){B=1;C=33;break}b:do{if((A|0)!=0){y=z;G=A;H=u;while(1){I=a[H]|0;c[k>>2]=y+1;a[y]=I;I=G+ -1|0;if((I|0)==0){break b}y=c[k>>2]|0;H=H+1|0;G=I}}}while(0);A=(c[g>>2]|0)+4|0;c[g>>2]=A;c:do{if((A|0)==(f|0)){J=f}else{z=A;while(1){G=z+4|0;if((c[z>>2]|0)==0){J=z;break c}if((G|0)==(f|0)){J=f;break}else{z=G}}}}while(0);D=A;E=c[k>>2]|0;F=J}if((D|0)==(f|0)|(E|0)==(j|0)){q=D;break a}else{v=D;w=E;x=F}}if((C|0)==10){c[k>>2]=w;d:do{if((v|0)==(c[g>>2]|0)){K=v}else{x=v;u=w;while(1){r=c[x>>2]|0;z=Oc(c[s>>2]|0)|0;G=$ob(u,r,n)|0;if((z|0)!=0){Oc(z|0)|0}if((G|0)==-1){K=x;break d}z=(c[k>>2]|0)+G|0;c[k>>2]=z;G=x+4|0;if((G|0)==(c[g>>2]|0)){K=G;break}else{x=G;u=z}}}}while(0);c[g>>2]=K;B=2;i=l;return B|0}else if((C|0)==31){q=c[g>>2]|0;break}else if((C|0)==33){i=l;return B|0}}}while(0);B=(q|0)!=(f|0)|0;i=l;return B|0}function knb(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;l=i;i=i+8|0;m=l;n=m;o=(e|0)==(f|0);a:do{if(o){c[k>>2]=h;c[g>>2]=e;p=e}else{q=e;while(1){r=q+1|0;if((a[q]|0)==0){s=q;break}if((r|0)==(f|0)){s=f;break}else{q=r}}c[k>>2]=h;c[g>>2]=e;if(o|(h|0)==(j|0)){p=e;break}q=j;r=b+8|0;t=e;u=h;v=s;while(1){w=d;x=c[w+4>>2]|0;y=m;c[y>>2]=c[w>>2];c[y+4>>2]=x;z=v;x=Oc(c[r>>2]|0)|0;y=Yob(u,g,z-t|0,q-u>>2,d)|0;if((x|0)!=0){Oc(x|0)|0}if((y|0)==0){A=2;B=32;break}else if((y|0)==-1){B=10;break}x=(c[k>>2]|0)+(y<<2)|0;c[k>>2]=x;if((x|0)==(j|0)){B=30;break}y=c[g>>2]|0;if((v|0)==(f|0)){C=y;D=x;E=f}else{w=Oc(c[r>>2]|0)|0;F=Xob(x,y,1,d)|0;if((w|0)!=0){Oc(w|0)|0}if((F|0)!=0){A=2;B=32;break}c[k>>2]=(c[k>>2]|0)+4;F=(c[g>>2]|0)+1|0;c[g>>2]=F;b:do{if((F|0)==(f|0)){G=f}else{w=F;while(1){y=w+1|0;if((a[w]|0)==0){G=w;break b}if((y|0)==(f|0)){G=f;break}else{w=y}}}}while(0);C=F;D=c[k>>2]|0;E=G}if((C|0)==(f|0)|(D|0)==(j|0)){p=C;break a}else{t=C;u=D;v=E}}if((B|0)==10){c[k>>2]=u;c:do{if((t|0)==(c[g>>2]|0)){H=t}else{v=t;q=u;while(1){w=Oc(c[r>>2]|0)|0;y=Xob(q,v,z-v|0,n)|0;if((w|0)!=0){Oc(w|0)|0}if((y|0)==-2){B=16;break}else if((y|0)==0){I=v+1|0}else if((y|0)==-1){B=15;break}else{I=v+y|0}y=(c[k>>2]|0)+4|0;c[k>>2]=y;if((I|0)==(c[g>>2]|0)){H=I;break c}else{v=I;q=y}}if((B|0)==15){c[g>>2]=v;A=2;i=l;return A|0}else if((B|0)==16){c[g>>2]=v;A=1;i=l;return A|0}}}while(0);c[g>>2]=H;A=(H|0)!=(f|0)|0;i=l;return A|0}else if((B|0)==30){p=c[g>>2]|0;break}else if((B|0)==32){i=l;return A|0}}}while(0);A=(p|0)!=(f|0)|0;i=l;return A|0}function lnb(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+8|0;c[g>>2]=e;e=h;j=Oc(c[b+8>>2]|0)|0;b=$ob(e,0,d)|0;if((j|0)!=0){Oc(j|0)|0}if((b|0)==0|(b|0)==-1){k=2;i=h;return k|0}j=b+ -1|0;b=c[g>>2]|0;if(j>>>0>(f-b|0)>>>0){k=1;i=h;return k|0}if((j|0)==0){k=0;i=h;return k|0}else{l=b;m=j;n=e}while(1){e=a[n]|0;c[g>>2]=l+1;a[l]=e;e=m+ -1|0;if((e|0)==0){k=0;break}l=c[g>>2]|0;n=n+1|0;m=e}i=h;return k|0}function mnb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=a+8|0;a=Oc(c[d>>2]|0)|0;e=_ob(0,0,4)|0;if((a|0)!=0){Oc(a|0)|0}do{if((e|0)==0){a=c[d>>2]|0;if((a|0)==0){f=1;break}g=Oc(a|0)|0;if((g|0)==0){f=0;break}Oc(g|0)|0;f=0}else{f=-1}}while(0);i=b;return f|0}function nnb(a){a=a|0;i=i;return 0}function onb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;if((f|0)==0|(d|0)==(e|0)){h=0;i=g;return h|0}j=e;k=a+8|0;a=d;d=0;l=0;while(1){m=Oc(c[k>>2]|0)|0;n=Wob(a,j-a|0,b)|0;if((m|0)!=0){Oc(m|0)|0}if((n|0)==0){o=a+1|0;p=1}else if((n|0)==-2|(n|0)==-1){h=d;q=9;break}else{o=a+n|0;p=n}n=p+d|0;m=l+1|0;if(m>>>0>=f>>>0|(o|0)==(e|0)){h=n;q=9;break}else{a=o;d=n;l=m}}if((q|0)==9){i=g;return h|0}return 0}function pnb(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+8>>2]|0;do{if((d|0)==0){e=1}else{a=Oc(d|0)|0;if((a|0)==0){e=4;break}Oc(a|0)|0;e=4}}while(0);i=b;return e|0}function qnb(a){a=a|0;var b=0;b=i;cqb(a);i=b;return}function rnb(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=snb(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>1<<1);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function snb(d,f,g,h,j,k,l,m){d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;c[g>>2]=d;c[k>>2]=h;do{if((m&2|0)!=0){if((j-h|0)<3){o=1;i=n;return o|0}else{c[k>>2]=h+1;a[h]=-17;d=c[k>>2]|0;c[k>>2]=d+1;a[d]=-69;d=c[k>>2]|0;c[k>>2]=d+1;a[d]=-65;break}}}while(0);h=f;m=c[g>>2]|0;if(!(m>>>0<f>>>0)){o=0;i=n;return o|0}d=j;j=m;a:while(1){m=b[j>>1]|0;p=m&65535;if(p>>>0>l>>>0){o=2;q=26;break}do{if((m&65535)<128){r=c[k>>2]|0;if((d-r|0)<1){o=1;q=26;break a}c[k>>2]=r+1;a[r]=m}else{if((m&65535)<2048){r=c[k>>2]|0;if((d-r|0)<2){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>6|192;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if((m&65535)<55296){r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if(!((m&65535)<56320)){if((m&65535)<57344){o=2;q=26;break a}r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if((h-j|0)<4){o=1;q=26;break a}r=j+2|0;s=e[r>>1]|0;if((s&64512|0)!=56320){o=2;q=26;break a}if((d-(c[k>>2]|0)|0)<4){o=1;q=26;break a}t=p&960;if(((t<<10)+65536|p<<10&64512|s&1023)>>>0>l>>>0){o=2;q=26;break a}c[g>>2]=r;r=(t>>>6)+1|0;t=c[k>>2]|0;c[k>>2]=t+1;a[t]=r>>>2|240;t=c[k>>2]|0;c[k>>2]=t+1;a[t]=p>>>2&15|r<<4&48|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p<<4&48|s>>>6&15|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=s&63|128}}while(0);p=(c[g>>2]|0)+2|0;c[g>>2]=p;if(p>>>0<f>>>0){j=p}else{o=0;q=26;break}}if((q|0)==26){i=n;return o|0}return 0}function tnb(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=unb(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>1<<1);i=b;return l|0}function unb(e,f,g,h,j,k,l,m){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;n=i;c[g>>2]=e;c[k>>2]=h;h=c[g>>2]|0;do{if((m&4|0)==0){o=h}else{if((f-h|0)<=2){o=h;break}if(!((a[h]|0)==-17)){o=h;break}if(!((a[h+1|0]|0)==-69)){o=h;break}if(!((a[h+2|0]|0)==-65)){o=h;break}e=h+3|0;c[g>>2]=e;o=e}}while(0);a:do{if(o>>>0<f>>>0){h=f;m=j;e=o;p=c[k>>2]|0;b:while(1){if(!(p>>>0<j>>>0)){q=e;break a}r=a[e]|0;s=r&255;if(s>>>0>l>>>0){t=2;u=41;break}do{if(r<<24>>24>-1){b[p>>1]=r&255;c[g>>2]=e+1}else{if((r&255)<194){t=2;u=41;break b}if((r&255)<224){if((h-e|0)<2){t=1;u=41;break b}v=d[e+1|0]|0;if((v&192|0)!=128){t=2;u=41;break b}w=v&63|s<<6&1984;if(w>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=w;c[g>>2]=e+2;break}if((r&255)<240){if((h-e|0)<3){t=1;u=41;break b}w=a[e+1|0]|0;v=a[e+2|0]|0;if((s|0)==224){if(!((w&-32)<<24>>24==-96)){t=2;u=41;break b}}else if((s|0)==237){if(!((w&-32)<<24>>24==-128)){t=2;u=41;break b}}else{if(!((w&-64)<<24>>24==-128)){t=2;u=41;break b}}x=v&255;if((x&192|0)!=128){t=2;u=41;break b}v=(w&255)<<6&4032|s<<12|x&63;if((v&65535)>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=v;c[g>>2]=e+3;break}if(!((r&255)<245)){t=2;u=41;break b}if((h-e|0)<4){t=1;u=41;break b}v=a[e+1|0]|0;x=a[e+2|0]|0;w=a[e+3|0]|0;if((s|0)==244){if(!((v&-16)<<24>>24==-128)){t=2;u=41;break b}}else if((s|0)==240){if(!((v+112<<24>>24&255)<48)){t=2;u=41;break b}}else{if(!((v&-64)<<24>>24==-128)){t=2;u=41;break b}}y=x&255;if((y&192|0)!=128){t=2;u=41;break b}x=w&255;if((x&192|0)!=128){t=2;u=41;break b}if((m-p|0)<4){t=1;u=41;break b}w=s&7;z=v&255;v=y<<6;A=x&63;if((z<<12&258048|w<<18|v&4032|A)>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=z<<2&60|y>>>4&3|((z>>>4&3|w<<2)<<6)+16320|55296;w=p+2|0;c[k>>2]=w;b[w>>1]=A|v&960|56320;c[g>>2]=(c[g>>2]|0)+4}}while(0);s=(c[k>>2]|0)+2|0;c[k>>2]=s;r=c[g>>2]|0;if(r>>>0<f>>>0){e=r;p=s}else{q=r;break a}}if((u|0)==41){i=n;return t|0}}else{q=o}}while(0);t=q>>>0<f>>>0|0;i=n;return t|0}function vnb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function wnb(a){a=a|0;i=i;return 0}function xnb(a){a=a|0;i=i;return 0}function ynb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=znb(c,d,e,1114111,0)|0;i=b;return a|0}function znb(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;h=i;do{if((g&4|0)==0){j=b}else{if((c-b|0)<=2){j=b;break}if(!((a[b]|0)==-17)){j=b;break}if(!((a[b+1|0]|0)==-69)){j=b;break}j=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);a:do{if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=0;b:while(1){m=a[k]|0;n=m&255;if(n>>>0>f>>>0){o=k;break a}do{if(m<<24>>24>-1){p=k+1|0;q=l}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}r=d[k+1|0]|0;if((r&192|0)!=128){o=k;break a}if((r&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;q=l;break}if((m&255)<240){s=k;if((g-s|0)<3){o=k;break a}r=a[k+1|0]|0;t=a[k+2|0]|0;if((n|0)==237){if(!((r&-32)<<24>>24==-128)){u=23;break b}}else if((n|0)==224){if(!((r&-32)<<24>>24==-96)){u=21;break b}}else{if(!((r&-64)<<24>>24==-128)){u=25;break b}}v=t&255;if((v&192|0)!=128){o=k;break a}if(((r&255)<<6&4032|n<<12&61440|v&63)>>>0>f>>>0){o=k;break a}p=k+3|0;q=l;break}if(!((m&255)<245)){o=k;break a}w=k;if((g-w|0)<4){o=k;break a}if((e-l|0)>>>0<2){o=k;break a}v=a[k+1|0]|0;r=a[k+2|0]|0;t=a[k+3|0]|0;if((n|0)==244){if(!((v&-16)<<24>>24==-128)){u=36;break b}}else if((n|0)==240){if(!((v+112<<24>>24&255)<48)){u=34;break b}}else{if(!((v&-64)<<24>>24==-128)){u=38;break b}}x=r&255;if((x&192|0)!=128){o=k;break a}r=t&255;if((r&192|0)!=128){o=k;break a}if(((v&255)<<12&258048|n<<18&1835008|x<<6&4032|r&63)>>>0>f>>>0){o=k;break a}p=k+4|0;q=l+1|0}}while(0);n=q+1|0;if(p>>>0<c>>>0&n>>>0<e>>>0){k=p;l=n}else{o=p;break a}}if((u|0)==21){y=s-b|0;i=h;return y|0}else if((u|0)==23){y=s-b|0;i=h;return y|0}else if((u|0)==25){y=s-b|0;i=h;return y|0}else if((u|0)==34){y=w-b|0;i=h;return y|0}else if((u|0)==36){y=w-b|0;i=h;return y|0}else if((u|0)==38){y=w-b|0;i=h;return y|0}}else{o=j}}while(0);y=o-b|0;i=h;return y|0}function Anb(a){a=a|0;i=i;return 4}function Bnb(a){a=a|0;var b=0;b=i;cqb(a);i=b;return}function Cnb(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=Dnb(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>2<<2);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function Dnb(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;l=i;c[e>>2]=b;c[h>>2]=f;do{if((k&2|0)!=0){if((g-f|0)<3){m=1;i=l;return m|0}else{c[h>>2]=f+1;a[f]=-17;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-69;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-65;break}}}while(0);f=c[e>>2]|0;if(!(f>>>0<d>>>0)){m=0;i=l;return m|0}k=g;g=f;a:while(1){f=c[g>>2]|0;if((f&-2048|0)==55296|f>>>0>j>>>0){m=2;n=19;break}do{if(f>>>0<128){b=c[h>>2]|0;if((k-b|0)<1){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f}else{if(f>>>0<2048){b=c[h>>2]|0;if((k-b|0)<2){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>6|192;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}b=c[h>>2]|0;o=k-b|0;if(f>>>0<65536){if((o|0)<3){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>12|224;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=f>>>6&63|128;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=f&63|128;break}else{if((o|0)<4){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>18|240;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>12&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>6&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}}}while(0);f=(c[e>>2]|0)+4|0;c[e>>2]=f;if(f>>>0<d>>>0){g=f}else{m=0;n=19;break}}if((n|0)==19){i=l;return m|0}return 0}function Enb(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=Fnb(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>2<<2);i=b;return l|0}function Fnb(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;m=i;c[f>>2]=b;c[j>>2]=g;g=c[f>>2]|0;do{if((l&4|0)==0){n=g}else{if((e-g|0)<=2){n=g;break}if(!((a[g]|0)==-17)){n=g;break}if(!((a[g+1|0]|0)==-69)){n=g;break}if(!((a[g+2|0]|0)==-65)){n=g;break}b=g+3|0;c[f>>2]=b;n=b}}while(0);a:do{if(n>>>0<e>>>0){g=e;l=n;b=c[j>>2]|0;b:while(1){if(!(b>>>0<h>>>0)){o=l;break a}p=a[l]|0;q=p&255;do{if(p<<24>>24>-1){if(q>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=q;c[f>>2]=l+1}else{if((p&255)<194){r=2;s=40;break b}if((p&255)<224){if((g-l|0)<2){r=1;s=40;break b}t=d[l+1|0]|0;if((t&192|0)!=128){r=2;s=40;break b}u=t&63|q<<6&1984;if(u>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=u;c[f>>2]=l+2;break}if((p&255)<240){if((g-l|0)<3){r=1;s=40;break b}u=a[l+1|0]|0;t=a[l+2|0]|0;if((q|0)==237){if(!((u&-32)<<24>>24==-128)){r=2;s=40;break b}}else if((q|0)==224){if(!((u&-32)<<24>>24==-96)){r=2;s=40;break b}}else{if(!((u&-64)<<24>>24==-128)){r=2;s=40;break b}}v=t&255;if((v&192|0)!=128){r=2;s=40;break b}t=(u&255)<<6&4032|q<<12&61440|v&63;if(t>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=t;c[f>>2]=l+3;break}if(!((p&255)<245)){r=2;s=40;break b}if((g-l|0)<4){r=1;s=40;break b}t=a[l+1|0]|0;v=a[l+2|0]|0;u=a[l+3|0]|0;if((q|0)==244){if(!((t&-16)<<24>>24==-128)){r=2;s=40;break b}}else if((q|0)==240){if(!((t+112<<24>>24&255)<48)){r=2;s=40;break b}}else{if(!((t&-64)<<24>>24==-128)){r=2;s=40;break b}}w=v&255;if((w&192|0)!=128){r=2;s=40;break b}v=u&255;if((v&192|0)!=128){r=2;s=40;break b}u=(t&255)<<12&258048|q<<18&1835008|w<<6&4032|v&63;if(u>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=u;c[f>>2]=l+4}}while(0);q=(c[j>>2]|0)+4|0;c[j>>2]=q;p=c[f>>2]|0;if(p>>>0<e>>>0){l=p;b=q}else{o=p;break a}}if((s|0)==40){i=m;return r|0}}else{o=n}}while(0);r=o>>>0<e>>>0|0;i=m;return r|0}function Gnb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function Hnb(a){a=a|0;i=i;return 0}function Inb(a){a=a|0;i=i;return 0}function Jnb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=Knb(c,d,e,1114111,0)|0;i=b;return a|0}function Knb(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;do{if((g&4|0)==0){j=b}else{if((c-b|0)<=2){j=b;break}if(!((a[b]|0)==-17)){j=b;break}if(!((a[b+1|0]|0)==-69)){j=b;break}j=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);a:do{if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=1;b:while(1){m=a[k]|0;n=m&255;do{if(m<<24>>24>-1){if(n>>>0>f>>>0){o=k;break a}p=k+1|0}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}q=d[k+1|0]|0;if((q&192|0)!=128){o=k;break a}if((q&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;break}if((m&255)<240){r=k;if((g-r|0)<3){o=k;break a}q=a[k+1|0]|0;s=a[k+2|0]|0;if((n|0)==237){if(!((q&-32)<<24>>24==-128)){t=23;break b}}else if((n|0)==224){if(!((q&-32)<<24>>24==-96)){t=21;break b}}else{if(!((q&-64)<<24>>24==-128)){t=25;break b}}u=s&255;if((u&192|0)!=128){o=k;break a}if(((q&255)<<6&4032|n<<12&61440|u&63)>>>0>f>>>0){o=k;break a}p=k+3|0;break}if(!((m&255)<245)){o=k;break a}v=k;if((g-v|0)<4){o=k;break a}u=a[k+1|0]|0;q=a[k+2|0]|0;s=a[k+3|0]|0;if((n|0)==240){if(!((u+112<<24>>24&255)<48)){t=33;break b}}else if((n|0)==244){if(!((u&-16)<<24>>24==-128)){t=35;break b}}else{if(!((u&-64)<<24>>24==-128)){t=37;break b}}w=q&255;if((w&192|0)!=128){o=k;break a}q=s&255;if((q&192|0)!=128){o=k;break a}if(((u&255)<<12&258048|n<<18&1835008|w<<6&4032|q&63)>>>0>f>>>0){o=k;break a}p=k+4|0}}while(0);if(!(p>>>0<c>>>0&l>>>0<e>>>0)){o=p;break a}k=p;l=l+1|0}if((t|0)==21){x=r-b|0;i=h;return x|0}else if((t|0)==23){x=r-b|0;i=h;return x|0}else if((t|0)==25){x=r-b|0;i=h;return x|0}else if((t|0)==33){x=v-b|0;i=h;return x|0}else if((t|0)==35){x=v-b|0;i=h;return x|0}else if((t|0)==37){x=v-b|0;i=h;return x|0}}else{o=j}}while(0);x=o-b|0;i=h;return x|0}function Lnb(a){a=a|0;i=i;return 4}function Mnb(a){a=a|0;var b=0;b=i;cqb(a);i=b;return}function Nnb(a){a=a|0;var b=0;b=i;cqb(a);i=b;return}function Onb(a){a=a|0;var b=0;b=i;c[a>>2]=314296;Rfb(a+12|0);cqb(a);i=b;return}function Pnb(a){a=a|0;var b=0;b=i;c[a>>2]=314296;Rfb(a+12|0);i=b;return}function Qnb(a){a=a|0;var b=0;b=i;c[a>>2]=314336;Rfb(a+16|0);cqb(a);i=b;return}function Rnb(a){a=a|0;var b=0;b=i;c[a>>2]=314336;Rfb(a+16|0);i=b;return}function Snb(b){b=b|0;i=i;return a[b+8|0]|0}function Tnb(a){a=a|0;i=i;return c[a+8>>2]|0}function Unb(b){b=b|0;i=i;return a[b+9|0]|0}function Vnb(a){a=a|0;i=i;return c[a+12>>2]|0}function Wnb(a,b){a=a|0;b=b|0;var c=0;c=i;Hfb(a,b+12|0);i=c;return}function Xnb(a,b){a=a|0;b=b|0;var c=0;c=i;Hfb(a,b+16|0);i=c;return}function Ynb(a,b){a=a|0;b=b|0;b=i;Jfb(a,314368,4);i=b;return}function Znb(a,b){a=a|0;b=b|0;b=i;rgb(a,314376,wpb(314376)|0);i=b;return}function _nb(a,b){a=a|0;b=b|0;b=i;Jfb(a,314400,5);i=b;return}function $nb(a,b){a=a|0;b=b|0;b=i;rgb(a,314408,wpb(314408)|0);i=b;return}function aob(b){b=b|0;var d=0,e=0;b=i;if((a[314440]|0)!=0){d=314432;e=c[78608]|0;i=b;return e|0}if((_a(314440)|0)==0){d=314432;e=c[78608]|0;i=b;return e|0}do{if((a[321640]|0)==0){if((_a(321640)|0)==0){break}Cqb(321472,0,168)|0;ee(1434,0,q|0)|0;Wb(321640)}}while(0);Ufb(321472,321648)|0;Ufb(321484|0,321656)|0;Ufb(321496|0,321664)|0;Ufb(321508|0,321672)|0;Ufb(321520|0,321688)|0;Ufb(321532|0,321704)|0;Ufb(321544|0,321712)|0;Ufb(321556|0,321728)|0;Ufb(321568|0,321736)|0;Ufb(321580|0,321744)|0;Ufb(321592|0,321752)|0;Ufb(321604|0,321760)|0;Ufb(321616|0,321768)|0;Ufb(321628|0,321776)|0;c[78608]=321472;Wb(314440);d=314432;e=c[78608]|0;i=b;return e|0}function bob(b){b=b|0;var d=0,e=0;b=i;if((a[314456]|0)!=0){d=314448;e=c[78612]|0;i=b;return e|0}if((_a(314456)|0)==0){d=314448;e=c[78612]|0;i=b;return e|0}do{if((a[321104]|0)==0){if((_a(321104)|0)==0){break}Cqb(320936,0,168)|0;ee(1435,0,q|0)|0;Wb(321104)}}while(0);ugb(320936,321112)|0;ugb(320948|0,321144)|0;ugb(320960|0,321176)|0;ugb(320972|0,321208)|0;ugb(320984|0,321248)|0;ugb(320996|0,321288)|0;ugb(321008|0,321320)|0;ugb(321020|0,321360)|0;ugb(321032|0,321376)|0;ugb(321044|0,321392)|0;ugb(321056|0,321408)|0;ugb(321068|0,321424)|0;ugb(321080|0,321440)|0;ugb(321092|0,321456)|0;c[78612]=320936;Wb(314456);d=314448;e=c[78612]|0;i=b;return e|0}function cob(b){b=b|0;var d=0,e=0;b=i;if((a[314472]|0)!=0){d=314464;e=c[78616]|0;i=b;return e|0}if((_a(314472)|0)==0){d=314464;e=c[78616]|0;i=b;return e|0}do{if((a[320712]|0)==0){if((_a(320712)|0)==0){break}Cqb(320424,0,288)|0;ee(1436,0,q|0)|0;Wb(320712)}}while(0);Ufb(320424,320720)|0;Ufb(320436|0,320728)|0;Ufb(320448|0,320744)|0;Ufb(320460|0,320752)|0;Ufb(320472|0,320760)|0;Ufb(320484|0,320768)|0;Ufb(320496|0,320776)|0;Ufb(320508|0,320784)|0;Ufb(320520|0,320792)|0;Ufb(320532|0,320808)|0;Ufb(320544|0,320816)|0;Ufb(320556|0,320832)|0;Ufb(320568|0,320848)|0;Ufb(320580|0,320856)|0;Ufb(320592|0,320864)|0;Ufb(320604|0,320872)|0;Ufb(320616|0,320760)|0;Ufb(320628|0,320880)|0;Ufb(320640|0,320888)|0;Ufb(320652|0,320896)|0;Ufb(320664|0,320904)|0;Ufb(320676|0,320912)|0;Ufb(320688|0,320920)|0;Ufb(320700|0,320928)|0;c[78616]=320424;Wb(314472);d=314464;e=c[78616]|0;i=b;return e|0}function dob(b){b=b|0;var d=0,e=0;b=i;if((a[314488]|0)!=0){d=314480;e=c[78620]|0;i=b;return e|0}if((_a(314488)|0)==0){d=314480;e=c[78620]|0;i=b;return e|0}do{if((a[319872]|0)==0){if((_a(319872)|0)==0){break}Cqb(319584,0,288)|0;ee(1437,0,q|0)|0;Wb(319872)}}while(0);ugb(319584,319880)|0;ugb(319596|0,319912)|0;ugb(319608|0,319952)|0;ugb(319620|0,319976)|0;ugb(319632|0,320296)|0;ugb(319644|0,32e4)|0;ugb(319656|0,320024)|0;ugb(319668|0,320048)|0;ugb(319680|0,320080)|0;ugb(319692|0,320120)|0;ugb(319704|0,320152)|0;ugb(319716|0,320192)|0;ugb(319728|0,320232)|0;ugb(319740|0,320248)|0;ugb(319752|0,320264)|0;ugb(319764|0,320280)|0;ugb(319776|0,320296)|0;ugb(319788|0,320312)|0;ugb(319800|0,320328)|0;ugb(319812|0,320344)|0;ugb(319824|0,320360)|0;ugb(319836|0,320376)|0;ugb(319848|0,320392)|0;ugb(319860|0,320408)|0;c[78620]=319584;Wb(314488);d=314480;e=c[78620]|0;i=b;return e|0}function eob(b){b=b|0;var d=0,e=0;b=i;if((a[314504]|0)!=0){d=314496;e=c[78624]|0;i=b;return e|0}if((_a(314504)|0)==0){d=314496;e=c[78624]|0;i=b;return e|0}do{if((a[319560]|0)==0){if((_a(319560)|0)==0){break}Cqb(319272,0,288)|0;ee(1438,0,q|0)|0;Wb(319560)}}while(0);Ufb(319272,319568)|0;Ufb(319284|0,319576)|0;c[78624]=319272;Wb(314504);d=314496;e=c[78624]|0;i=b;return e|0}function fob(b){b=b|0;var d=0,e=0;b=i;if((a[314520]|0)!=0){d=314512;e=c[78628]|0;i=b;return e|0}if((_a(314520)|0)==0){d=314512;e=c[78628]|0;i=b;return e|0}do{if((a[319232]|0)==0){if((_a(319232)|0)==0){break}Cqb(318944,0,288)|0;ee(1439,0,q|0)|0;Wb(319232)}}while(0);ugb(318944,319240)|0;ugb(318956|0,319256)|0;c[78628]=318944;Wb(314520);d=314512;e=c[78628]|0;i=b;return e|0}function gob(b){b=b|0;var c=0;b=i;if((a[314544]|0)!=0){c=314528;i=b;return c|0}if((_a(314544)|0)==0){c=314528;i=b;return c|0}Jfb(314528,314552,8);ee(1440,314528,q|0)|0;Wb(314544);c=314528;i=b;return c|0}function hob(b){b=b|0;var c=0;b=i;if((a[314584]|0)!=0){c=314568;i=b;return c|0}if((_a(314584)|0)==0){c=314568;i=b;return c|0}rgb(314568,314592,wpb(314592)|0);ee(1441,314568,q|0)|0;Wb(314584);c=314568;i=b;return c|0}function iob(b){b=b|0;var c=0;b=i;if((a[314648]|0)!=0){c=314632;i=b;return c|0}if((_a(314648)|0)==0){c=314632;i=b;return c|0}Jfb(314632,314656,8);ee(1440,314632,q|0)|0;Wb(314648);c=314632;i=b;return c|0}function job(b){b=b|0;var c=0;b=i;if((a[314688]|0)!=0){c=314672;i=b;return c|0}if((_a(314688)|0)==0){c=314672;i=b;return c|0}rgb(314672,314696,wpb(314696)|0);ee(1441,314672,q|0)|0;Wb(314688);c=314672;i=b;return c|0}function kob(b){b=b|0;var c=0;b=i;if((a[314752]|0)!=0){c=314736;i=b;return c|0}if((_a(314752)|0)==0){c=314736;i=b;return c|0}Jfb(314736,314760,20);ee(1440,314736,q|0)|0;Wb(314752);c=314736;i=b;return c|0}function lob(b){b=b|0;var c=0;b=i;if((a[314800]|0)!=0){c=314784;i=b;return c|0}if((_a(314800)|0)==0){c=314784;i=b;return c|0}rgb(314784,314808,wpb(314808)|0);ee(1441,314784,q|0)|0;Wb(314800);c=314784;i=b;return c|0}function mob(b){b=b|0;var c=0;b=i;if((a[314912]|0)!=0){c=314896;i=b;return c|0}if((_a(314912)|0)==0){c=314896;i=b;return c|0}Jfb(314896,314920,11);ee(1440,314896,q|0)|0;Wb(314912);c=314896;i=b;return c|0}function nob(b){b=b|0;var c=0;b=i;if((a[314952]|0)!=0){c=314936;i=b;return c|0}if((_a(314952)|0)==0){c=314936;i=b;return c|0}rgb(314936,314960,wpb(314960)|0);ee(1441,314936,q|0)|0;Wb(314952);c=314936;i=b;return c|0}function oob(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Qc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[314024]|0)==0){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);l=+sqb(b,g,c[78504]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function pob(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Qc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[314024]|0)==0){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);l=+sqb(b,g,c[78504]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function qob(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Qc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[314024]|0)==0){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);l=+sqb(b,g,c[78504]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)==34){c[e>>2]=4}h=l;i=f;return+h}function rob(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}l=Qc()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[314024]|0)==0){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);n=mb(b|0,h|0,f|0,c[78504]|0)|0;f=J;b=c[l>>2]|0;if((b|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((b|0)!=34){j=n;k=f;J=k;i=g;return j|0}c[e>>2]=4;j=-1;k=-1;J=k;i=g;return j|0}function sob(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Qc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[314024]|0)==0){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);m=mb(b|0,h|0,f|0,c[78504]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function tob(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Qc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[314024]|0)==0){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);m=mb(b|0,h|0,f|0,c[78504]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function uob(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Qc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[314024]|0)==0){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);m=mb(b|0,h|0,f|0,c[78504]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>65535)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m&65535;i=g;return j|0}return 0}function vob(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}l=Qc()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[314024]|0)==0){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);n=Jc(b|0,h|0,f|0,c[78504]|0)|0;f=J;b=c[l>>2]|0;if((b|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((b|0)==34){c[e>>2]=4;e=(f|0)>0|(f|0)==0&n>>>0>0;J=e?2147483647:-2147483648;i=g;return(e?-1:0)|0}else{j=n;k=f;J=k;i=g;return j|0}return 0}function wob(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}k=Qc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[314024]|0)==0){if((_a(314024)|0)==0){break}c[78504]=bc(2147483647,314032,0)|0;Wb(314024)}}while(0);m=Jc(b|0,h|0,f|0,c[78504]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}do{if((b|0)==34){c[e>>2]=4;if((f|0)>0|(f|0)==0&m>>>0>0){j=2147483647}else{break}i=g;return j|0}else{if((f|0)<-1|(f|0)==-1&m>>>0<2147483648){c[e>>2]=4;break}if((f|0)>0|(f|0)==0&m>>>0>2147483647){c[e>>2]=4;j=2147483647;i=g;return j|0}else{j=m;i=g;return j|0}}}while(0);j=-2147483648;i=g;return j|0}function xob(a){a=a|0;var b=0,e=0,f=0,g=0,h=0;b=i;e=a+4|0;f=e;g=d[f]|d[f+1|0]<<8|d[f+2|0]<<16|d[f+3|0]<<24;f=e+4|0;e=d[f]|d[f+1|0]<<8|d[f+2|0]<<16|d[f+3|0]<<24;f=(c[a>>2]|0)+(e>>1)|0;a=f;if((e&1|0)==0){h=g;me[h&2047](a);i=b;return}else{h=c[(c[f>>2]|0)+g>>2]|0;me[h&2047](a);i=b;return}}function yob(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;f=b+8|0;g=b+4|0;h=c[g>>2]|0;j=c[f>>2]|0;k=h;if(!(j-k>>2>>>0<d>>>0)){l=d;m=h;do{if((m|0)==0){n=0}else{c[m>>2]=0;n=c[g>>2]|0}m=n+4|0;c[g>>2]=m;l=l+ -1|0;}while((l|0)!=0);i=e;return}l=b+16|0;m=b;n=c[m>>2]|0;h=k-n>>2;k=h+d|0;if(k>>>0>1073741823){rmb(0)}o=j-n|0;do{if(o>>2>>>0<536870911){n=o>>1;j=n>>>0<k>>>0?k:n;if((j|0)==0){p=0;q=0;break}n=b+128|0;if(!((a[n]|0)==0&j>>>0<29)){r=j;s=11;break}a[n]=1;p=j;q=l}else{r=1073741823;s=11}}while(0);if((s|0)==11){p=r;q=aqb(r<<2)|0}r=d;d=q+(h<<2)|0;do{if((d|0)==0){t=0}else{c[d>>2]=0;t=d}d=t+4|0;r=r+ -1|0;}while((r|0)!=0);r=c[m>>2]|0;t=(c[g>>2]|0)-r|0;s=q+(h-(t>>2)<<2)|0;h=r;Aqb(s|0,h|0,t|0)|0;c[m>>2]=s;c[g>>2]=d;c[f>>2]=q+(p<<2);if((r|0)==0){i=e;return}if((l|0)==(r|0)){a[b+128|0]=0;i=e;return}else{cqb(h);i=e;return}}function zob(a){a=a|0;a=i;tgb(319220|0);tgb(319208|0);tgb(319196|0);tgb(319184|0);tgb(319172|0);tgb(319160|0);tgb(319148|0);tgb(319136|0);tgb(319124|0);tgb(319112|0);tgb(319100|0);tgb(319088|0);tgb(319076|0);tgb(319064|0);tgb(319052|0);tgb(319040|0);tgb(319028|0);tgb(319016|0);tgb(319004|0);tgb(318992|0);tgb(318980|0);tgb(318968|0);tgb(318956|0);tgb(318944);i=a;return}function Aob(a){a=a|0;a=i;Rfb(319548|0);Rfb(319536|0);Rfb(319524|0);Rfb(319512|0);Rfb(319500|0);Rfb(319488|0);Rfb(319476|0);Rfb(319464|0);Rfb(319452|0);Rfb(319440|0);Rfb(319428|0);Rfb(319416|0);Rfb(319404|0);Rfb(319392|0);Rfb(319380|0);Rfb(319368|0);Rfb(319356|0);Rfb(319344|0);Rfb(319332|0);Rfb(319320|0);Rfb(319308|0);Rfb(319296|0);Rfb(319284|0);Rfb(319272);i=a;return}function Bob(a){a=a|0;a=i;tgb(319860|0);tgb(319848|0);tgb(319836|0);tgb(319824|0);tgb(319812|0);tgb(319800|0);tgb(319788|0);tgb(319776|0);tgb(319764|0);tgb(319752|0);tgb(319740|0);tgb(319728|0);tgb(319716|0);tgb(319704|0);tgb(319692|0);tgb(319680|0);tgb(319668|0);tgb(319656|0);tgb(319644|0);tgb(319632|0);tgb(319620|0);tgb(319608|0);tgb(319596|0);tgb(319584);i=a;return}function Cob(a){a=a|0;a=i;Rfb(320700|0);Rfb(320688|0);Rfb(320676|0);Rfb(320664|0);Rfb(320652|0);Rfb(320640|0);Rfb(320628|0);Rfb(320616|0);Rfb(320604|0);Rfb(320592|0);Rfb(320580|0);Rfb(320568|0);Rfb(320556|0);Rfb(320544|0);Rfb(320532|0);Rfb(320520|0);Rfb(320508|0);Rfb(320496|0);Rfb(320484|0);Rfb(320472|0);Rfb(320460|0);Rfb(320448|0);Rfb(320436|0);Rfb(320424);i=a;return}function Dob(a){a=a|0;a=i;tgb(321092|0);tgb(321080|0);tgb(321068|0);tgb(321056|0);tgb(321044|0);tgb(321032|0);tgb(321020|0);tgb(321008|0);tgb(320996|0);tgb(320984|0);tgb(320972|0);tgb(320960|0);tgb(320948|0);tgb(320936);i=a;return}function Eob(a){a=a|0;a=i;Rfb(321628|0);Rfb(321616|0);Rfb(321604|0);Rfb(321592|0);Rfb(321580|0);Rfb(321568|0);Rfb(321556|0);Rfb(321544|0);Rfb(321532|0);Rfb(321520|0);Rfb(321508|0);Rfb(321496|0);Rfb(321484|0);Rfb(321472);i=a;return}function Fob(a){a=a|0;var b=0,c=0;b=i;if((Lob(a)|0)==0){c=(Gob(a)|0)!=0|0}else{c=1}i=b;return c|0}function Gob(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<131072){c=(d[321784+((d[321784+(a>>>8)|0]|0)<<5|a>>>3&31)|0]|0)>>>(a&7)&1;i=b;return c|0}else{c=a>>>0<196606|0;i=b;return c|0}return 0}function Hob(a){a=a|0;var b=0,c=0;b=i;c=Ab(a|0)|0;i=b;return c|0}function Iob(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<32|(a+ -127|0)>>>0<33|(a+ -8232|0)>>>0<2){c=1;i=b;return c|0}c=(a+ -65529|0)>>>0<3|0;i=b;return c|0}function Job(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;switch(b|0){case 9:{d=Pob(a)|0;break};case 1:{d=Fob(a)|0;break};case 3:{d=Hob(a)|0;break};case 6:{d=Mob(a)|0;break};case 8:{d=Oob(a)|0;break};case 11:{d=Rob(a)|0;break};case 12:{d=Sob(a)|0;break};case 5:{d=Lob(a)|0;break};case 4:{d=Iob(a)|0;break};case 2:{d=Gob(a)|0;break};case 7:{d=Nob(a)|0;break};case 10:{d=Qob(a)|0;break};default:{d=0}}i=c;return d|0}function Kob(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;c=i;d=a[b]|0;e=97;f=1;g=324760;while(1){if(d<<24>>24==e<<24>>24){if((uqb(b,g)|0)==0){h=f;j=5;break}}k=g+6|0;l=a[k]|0;if(l<<24>>24==0){h=0;j=5;break}else{e=l;f=f+1|0;g=k}}if((j|0)==5){i=c;return h|0}return 0}function Lob(a){a=a|0;i=i;return(a+ -48|0)>>>0<10|0}function Mob(a){a=a|0;var b=0,c=0;b=i;if((Qob(a)|0)==0){c=(Oob(a)|0)!=0|0}else{c=0}i=b;return c|0}function Nob(a){a=a|0;var b=0,c=0;b=i;if((Tob(a)|0)==(a|0)){c=(a|0)==223|0}else{c=1}i=b;return c|0}function Oob(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<255){c=(a+1&127)>>>0>32|0;i=b;return c|0}if(a>>>0<8232|(a+ -8234|0)>>>0<47062|(a+ -57344|0)>>>0<8185){c=1;i=b;return c|0}else{i=b;return((a+ -65532|0)>>>0>1048579|(a&65534|0)==65534)&1^1|0}return 0}function Pob(a){a=a|0;var b=0,c=0;b=i;if(!(a>>>0<131072)){c=0;i=b;return c|0}c=(d[324840+((d[324840+(a>>>8)|0]|0)<<5|a>>>3&31)|0]|0)>>>(a&7)&1;i=b;return c|0}function Qob(a){a=a|0;var b=0,c=0;b=i;c=(vpb(328008,a)|0)!=0|0;i=b;return c|0}function Rob(a){a=a|0;var b=0,c=0;b=i;c=(Vob(a)|0)!=(a|0)|0;i=b;return c|0}function Sob(a){a=a|0;var b=0,c=0;b=i;if((a+ -48|0)>>>0<10){c=1;i=b;return c|0}c=((a|32)+ -97|0)>>>0<6|0;i=b;return c|0}function Tob(a){a=a|0;var b=0,c=0;b=i;c=Uob(a,0)|0;i=b;return c|0}function Uob(c,f){c=c|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;h=(f<<1)+ -1|0;j=f+ -1|0;if((Gob(c)|0)==0|(c+ -1536|0)>>>0<2560|(c+ -11776|0)>>>0<30784|(c+ -43008|0)>>>0<22272){k=c;i=g;return k|0}do{if((f|0)==0){if(!((c+ -11520|0)>>>0<38)){l=0;break}k=c+ -7264|0;i=g;return k|0}else{if(!((c+ -4256|0)>>>0<46)){l=0;break}do{if((c|0)>4293){if((c|0)==4295|(c|0)==4301){break}else{k=c}i=g;return k|0}}while(0);k=c+7264|0;i=g;return k|0}}while(0);while(1){m=a[328098+(l<<2)|0]|0;n=m<<24>>24;o=c-(e[328096+(l<<2)>>1]|0)|0;p=l+1|0;if((o-(n&j)|0)>>>0<(d[328099+(l<<2)|0]|0)>>>0){q=12;break}if((p|0)==61){break}else{l=p}}if((q|0)==12){if(m<<24>>24==1){k=f+c-(o&1)|0;i=g;return k|0}else{k=(fa(n,h)|0)+c|0;i=g;return k|0}}h=1-f|0;n=b[328344+(h<<1)>>1]|0;a:do{if(!(n<<16>>16==0)){o=n;m=0;while(1){q=m+1|0;if((o&65535|0)==(c|0)){break}l=b[328344+(q<<2)+(h<<1)>>1]|0;if(l<<16>>16==0){break a}else{o=l;m=q}}k=e[328344+(m<<2)+(f<<1)>>1]|0;i=g;return k|0}}while(0);if(!((c+ -66600+(f*40|0)|0)>>>0<40)){k=c;i=g;return k|0}k=c+ -40+(f*80|0)|0;i=g;return k|0}function Vob(a){a=a|0;var b=0,c=0;b=i;c=Uob(a,1)|0;i=b;return c|0}function Wob(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=Xob(0,a,b,(c|0)!=0?c:329048)|0;i=d;return e|0}function Xob(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+8|0;h=g;c[h>>2]=b;j=(f|0)==0?329056:f;f=c[j>>2]|0;a:do{if((d|0)==0){if((f|0)==0){k=0}else{break}i=g;return k|0}else{if((b|0)==0){l=h;c[h>>2]=l;m=l}else{m=b}if((e|0)==0){k=-2;i=g;return k|0}do{if((f|0)==0){l=a[d]|0;n=l&255;if(l<<24>>24>-1){c[m>>2]=n;k=l<<24>>24!=0|0;i=g;return k|0}else{l=n+ -194|0;if(l>>>0>50){break a}o=e+ -1|0;p=c[328840+(l<<2)>>2]|0;q=d+1|0;break}}else{o=e;p=f;q=d}}while(0);b:do{if((o|0)==0){r=p}else{l=a[q]|0;n=(l&255)>>>3;if((n+ -16|n+(p>>26))>>>0>7){break a}else{s=o;t=l;u=p;v=q}while(1){v=v+1|0;u=(t&255)+ -128|u<<6;s=s+ -1|0;if((u|0)>=0){break}if((s|0)==0){r=u;break b}t=a[v]|0;if(((t&255)+ -128|0)>>>0>63){break a}}c[j>>2]=0;c[m>>2]=u;k=e-s|0;i=g;return k|0}}while(0);c[j>>2]=r;k=-2;i=g;return k|0}}while(0);c[j>>2]=0;c[(Qc()|0)>>2]=84;k=-1;i=g;return k|0}function Yob(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=i;i=i+1032|0;h=g+1024|0;j=c[b>>2]|0;c[h>>2]=j;k=(a|0)!=0;l=g;m=k?e:256;e=k?a:l;a:do{if((j|0)==0|(m|0)==0){n=d;o=m;p=j;q=0;r=e}else{a=d;s=m;t=j;u=0;v=e;while(1){w=a>>>2;x=w>>>0>=s>>>0;if(!(x|a>>>0>131)){n=a;o=s;p=t;q=u;r=v;break a}y=x?s:w;z=a-y|0;w=Zob(v,h,y,f)|0;if((w|0)==-1){break}if((v|0)==(l|0)){A=s;B=l}else{A=s-w|0;B=v+(w<<2)|0}y=w+u|0;w=c[h>>2]|0;if((w|0)==0|(A|0)==0){n=z;o=A;p=w;q=y;r=B;break a}else{a=z;s=A;t=w;u=y;v=B}}n=z;o=0;p=c[h>>2]|0;q=-1;r=v}}while(0);b:do{if((p|0)==0){C=q}else{if((o|0)==0|(n|0)==0){C=q;break}else{D=n;E=o;F=p;G=q;H=r}while(1){I=Xob(H,F,D,f)|0;if((I+2|0)>>>0<3){break}z=(c[h>>2]|0)+I|0;c[h>>2]=z;B=E+ -1|0;A=G+1|0;if((B|0)==0|(D|0)==(I|0)){C=A;break b}else{D=D-I|0;E=B;F=z;G=A;H=H+4|0}}if((I|0)==0){c[h>>2]=0;C=G;break}else if((I|0)==-1){C=-1;break}else{c[f>>2]=0;C=G;break}}}while(0);if(!k){i=g;return C|0}c[b>>2]=c[h>>2];i=g;return C|0}function Zob(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;h=i;j=c[e>>2]|0;do{if((g|0)==0){k=5}else{l=g;m=c[l>>2]|0;if((m|0)==0){k=5;break}if((b|0)==0){n=f;o=m;p=j;k=16;break}c[l>>2]=0;q=b;r=f;s=m;t=j;k=36}}while(0);if((k|0)==5){if((b|0)==0){u=f;v=j;k=7}else{w=b;x=f;y=j;k=6}}a:while(1){if((k|0)==6){k=0;if((x|0)==0){z=f;k=53;break}else{A=w;B=x;C=y}while(1){j=a[C]|0;do{if(((j&255)+ -1|0)>>>0<127){if((C&3|0)==0&B>>>0>3){D=A;E=B;F=C}else{G=A;H=B;I=j;J=C;break}while(1){K=c[F>>2]|0;if(((K+ -16843009|K)&-2139062144|0)!=0){k=30;break}c[D>>2]=K&255;c[D+4>>2]=d[F+1|0]|0;c[D+8>>2]=d[F+2|0]|0;L=F+4|0;M=D+16|0;c[D+12>>2]=d[F+3|0]|0;N=E+ -4|0;if(N>>>0>3){D=M;E=N;F=L}else{k=31;break}}if((k|0)==30){k=0;G=D;H=E;I=K&255;J=F;break}else if((k|0)==31){k=0;G=M;H=N;I=a[L]|0;J=L;break}}else{G=A;H=B;I=j;J=C}}while(0);O=I&255;if(!((O+ -1|0)>>>0<127)){break}c[G>>2]=O;j=H+ -1|0;if((j|0)==0){z=f;k=53;break a}else{A=G+4|0;B=j;C=J+1|0}}j=O+ -194|0;if(j>>>0>50){P=G;Q=H;R=J;k=47;break}q=G;r=H;s=c[328840+(j<<2)>>2]|0;t=J+1|0;k=36;continue}else if((k|0)==7){k=0;j=a[v]|0;do{if(((j&255)+ -1|0)>>>0<127){if((v&3|0)!=0){S=u;T=j;U=v;break}g=c[v>>2]|0;if(((g+ -16843009|g)&-2139062144|0)==0){V=u;W=v}else{S=u;T=g&255;U=v;break}do{W=W+4|0;V=V+ -4|0;X=c[W>>2]|0;}while(((X+ -16843009|X)&-2139062144|0)==0);S=V;T=X&255;U=W}else{S=u;T=j;U=v}}while(0);j=T&255;if((j+ -1|0)>>>0<127){u=S+ -1|0;v=U+1|0;k=7;continue}g=j+ -194|0;if(g>>>0>50){P=b;Q=S;R=U;k=47;break}n=S;o=c[328840+(g<<2)>>2]|0;p=U+1|0;k=16;continue}else if((k|0)==16){k=0;g=(d[p]|0)>>>3;if((g+ -16|g+(o>>26))>>>0>7){k=17;break}g=p+1|0;do{if((o&33554432|0)==0){Y=g}else{if(((d[g]|0)+ -128|0)>>>0>63){k=20;break a}j=p+2|0;if((o&524288|0)==0){Y=j;break}if(((d[j]|0)+ -128|0)>>>0>63){k=23;break a}Y=p+3|0}}while(0);u=n+ -1|0;v=Y;k=7;continue}else if((k|0)==36){k=0;g=d[t]|0;j=g>>>3;if((j+ -16|j+(s>>26))>>>0>7){k=37;break}j=t+1|0;Z=g+ -128|s<<6;do{if((Z|0)<0){g=(d[j]|0)+ -128|0;if(g>>>0>63){k=40;break a}m=t+2|0;_=g|Z<<6;if((_|0)>=0){$=_;aa=m;break}g=(d[m]|0)+ -128|0;if(g>>>0>63){k=43;break a}$=g|_<<6;aa=t+3|0}else{$=Z;aa=j}}while(0);c[q>>2]=$;w=q+4|0;x=r+ -1|0;y=aa;k=6;continue}}if((k|0)==17){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==20){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==23){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==37){ba=q;ca=r;da=s;ea=t+ -1|0;k=46}else if((k|0)==40){ba=q;ca=r;da=Z;ea=t+ -1|0;k=46}else if((k|0)==43){ba=q;ca=r;da=_;ea=t+ -1|0;k=46}else if((k|0)==53){i=h;return z|0}if((k|0)==46){if((da|0)==0){P=ba;Q=ca;R=ea;k=47}else{fa=ba;ga=ea}}do{if((k|0)==47){if((a[R]|0)!=0){fa=P;ga=R;break}if((P|0)!=0){c[P>>2]=0;c[e>>2]=0}z=f-Q|0;i=h;return z|0}}while(0);c[(Qc()|0)>>2]=84;if((fa|0)==0){z=-1;i=h;return z|0}c[e>>2]=ga;z=-1;i=h;return z|0}function _ob(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;c[h>>2]=b;if((e|0)==0){j=0;i=g;return j|0}do{if((f|0)!=0){if((b|0)==0){k=h;c[h>>2]=k;l=k}else{l=b}k=a[e]|0;m=k&255;if(k<<24>>24>-1){c[l>>2]=m;j=k<<24>>24!=0|0;i=g;return j|0}k=m+ -194|0;if(k>>>0>50){break}m=e+1|0;n=c[328840+(k<<2)>>2]|0;if(f>>>0<4){if((n&-2147483648>>>((f*6|0)+ -6|0)|0)!=0){break}}k=d[m]|0;m=k>>>3;if((m+ -16|m+(n>>26))>>>0>7){break}m=k+ -128|n<<6;if((m|0)>=0){c[l>>2]=m;j=2;i=g;return j|0}n=(d[e+2|0]|0)+ -128|0;if(n>>>0>63){break}k=n|m<<6;if((k|0)>=0){c[l>>2]=k;j=3;i=g;return j|0}m=(d[e+3|0]|0)+ -128|0;if(m>>>0>63){break}c[l>>2]=m|k<<6;j=4;i=g;return j|0}}while(0);c[(Qc()|0)>>2]=84;j=-1;i=g;return j|0}function $ob(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((b|0)==0){f=1;i=e;return f|0}if(d>>>0<128){a[b]=d;f=1;i=e;return f|0}if(d>>>0<2048){a[b]=d>>>6|192;a[b+1|0]=d&63|128;f=2;i=e;return f|0}if(d>>>0<55296|(d+ -57344|0)>>>0<8192){a[b]=d>>>12|224;a[b+1|0]=d>>>6&63|128;a[b+2|0]=d&63|128;f=3;i=e;return f|0}if((d+ -65536|0)>>>0<1048576){a[b]=d>>>18|240;a[b+1|0]=d>>>12&63|128;a[b+2|0]=d>>>6&63|128;a[b+3|0]=d&63|128;f=4;i=e;return f|0}else{c[(Qc()|0)>>2]=84;f=-1;i=e;return f|0}return 0}function apb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+264|0;g=f+256|0;h=f;j=c[b>>2]|0;c[g>>2]=j;k=(a|0)!=0;l=k?e:256;e=k?a:h;a:do{if((j|0)==0|(l|0)==0){m=d;n=l;o=j;p=0;q=e}else{a=d;r=l;s=j;t=0;u=e;while(1){v=a>>>0>=r>>>0;if(!(v|a>>>0>32)){m=a;n=r;o=s;p=t;q=u;break a}w=v?r:a;x=a-w|0;v=bpb(u,g,w,0)|0;if((v|0)==-1){break}if((u|0)==(h|0)){y=r;z=h}else{y=r-v|0;z=u+v|0}w=v+t|0;v=c[g>>2]|0;if((v|0)==0|(y|0)==0){m=x;n=y;o=v;p=w;q=z;break a}else{a=x;r=y;s=v;t=w;u=z}}m=x;n=0;o=c[g>>2]|0;p=-1;q=u}}while(0);b:do{if((o|0)==0){A=p}else{if((n|0)==0|(m|0)==0){A=p;break}else{B=m;C=n;D=o;E=p;F=q}while(1){G=$ob(F,c[D>>2]|0,0)|0;if((G+1|0)>>>0<2){break}x=(c[g>>2]|0)+4|0;c[g>>2]=x;z=B+ -1|0;y=E+1|0;if((C|0)==(G|0)|(z|0)==0){A=y;break b}else{B=z;C=C-G|0;D=x;E=y;F=F+G|0}}if((G|0)!=0){A=-1;break}c[g>>2]=0;A=E}}while(0);if(!k){i=f;return A|0}c[b>>2]=c[g>>2];i=f;return A|0}function bpb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;i=i+8|0;g=f;if((b|0)==0){h=c[d>>2]|0;j=g;k=c[h>>2]|0;if((k|0)==0){l=0;i=f;return l|0}else{m=0;n=k;o=h}while(1){if(n>>>0>127){h=$ob(j,n,0)|0;if((h|0)==-1){l=-1;p=26;break}else{q=h}}else{q=1}h=q+m|0;k=o+4|0;r=c[k>>2]|0;if((r|0)==0){l=h;p=26;break}else{m=h;n=r;o=k}}if((p|0)==26){i=f;return l|0}}a:do{if(e>>>0>3){o=b;n=e;m=c[d>>2]|0;while(1){q=c[m>>2]|0;if((q|0)==0){s=o;t=n;break a}if(q>>>0>127){j=$ob(o,q,0)|0;if((j|0)==-1){l=-1;break}u=o+j|0;v=n-j|0;w=m}else{a[o]=q;u=o+1|0;v=n+ -1|0;w=c[d>>2]|0}q=w+4|0;c[d>>2]=q;if(v>>>0>3){o=u;n=v;m=q}else{s=u;t=v;break a}}i=f;return l|0}else{s=b;t=e}}while(0);b:do{if((t|0)==0){x=0}else{b=g;v=s;u=t;w=c[d>>2]|0;while(1){m=c[w>>2]|0;if((m|0)==0){p=24;break}if(m>>>0>127){n=$ob(b,m,0)|0;if((n|0)==-1){l=-1;p=26;break}if(n>>>0>u>>>0){p=20;break}$ob(v,c[w>>2]|0,0)|0;y=v+n|0;z=u-n|0;A=w}else{a[v]=m;y=v+1|0;z=u+ -1|0;A=c[d>>2]|0}m=A+4|0;c[d>>2]=m;if((z|0)==0){x=0;break b}else{v=y;u=z;w=m}}if((p|0)==20){l=e-u|0;i=f;return l|0}else if((p|0)==24){a[v]=0;x=u;break}else if((p|0)==26){i=f;return l|0}}}while(0);c[d>>2]=0;l=e-x|0;i=f;return l|0}function cpb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0;f=i;i=i+104|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+48|0;o=f+56|0;p=Wpb(20)|0;q=p;if((p|0)==0){r=12;i=f;return r|0}s=Wpb(2048)|0;c[p+16>>2]=s;if((s|0)==0){Xpb(p);r=12;i=f;return r|0}c[p>>2]=512;c[p+4>>2]=10240;c[p+8>>2]=128;c[p+12>>2]=0;s=spb(0,0)|0;if((s|0)==0){Xpb(c[p+16>>2]|0);Xpb(p);r=12;i=f;return r|0}t=o+0|0;u=t+44|0;do{c[t>>2]=0;t=t+4|0}while((t|0)<(u|0));c[o>>2]=s;c[o+4>>2]=q;c[o+12>>2]=d;c[o+36>>2]=e;d=o+28|0;c[d>>2]=-1;t=dpb(o)|0;a:do{if((t|0)==0){u=o+20|0;v=c[u>>2]|0;w=v+ -1|0;c[b>>2]=w;x=c[o+8>>2]|0;y=c[d>>2]|0;if((y|0)>-1){if((c[o+32>>2]|0)!=0){z=0;A=2;B=0;C=0;break}}if((y|0)>(w|0)){z=0;A=6;B=0;C=0;break}w=Ypb(1,68)|0;D=w;if((w|0)==0){z=0;A=12;B=0;C=D;break}E=y>>>31;c[w+60>>2]=E^1;c[w+64>>2]=c[o+32>>2];c[w+28>>2]=v;if((E|0)==1){if((e&8|0)==0){F=13}else{G=0}}else{F=13}if((F|0)==13){E=epb(0,q,x,D)|0;if((E|0)!=0){z=0;A=E;B=0;C=D;break}E=c[w+40>>2]|0;if((E|0)>0){v=(E<<2)+4|0;y=Wpb(v)|0;H=y;if((y|0)==0){z=0;A=12;B=0;C=D;break}c[w+32>>2]=H;Cqb(y|0,-1,v|0)|0;I=H}else{I=0}H=Ypb(E<<1|1,4)|0;c[w+36>>2]=H;if((H|0)==0){z=0;A=12;B=0;C=D;break}H=Ypb(c[u>>2]|0,12)|0;if((H|0)==0){z=0;A=12;B=0;C=D;break}c[w+16>>2]=H;H=epb(s,q,x,D)|0;if((H|0)==0){G=I}else{z=0;A=H;B=0;C=D;break}}H=o+24|0;u=p+12|0;E=c[u>>2]|0;c[j>>2]=0;c[k>>2]=0;v=kpb(q,x)|0;b:do{if((v|0)==0){y=kpb(q,0)|0;if((y|0)!=0){J=y;break}y=p+16|0;K=c[u>>2]|0;c:do{if((K|0)>(E|0)){L=0;M=0;N=0;O=K;d:while(1){P=O+ -1|0;c[u>>2]=P;Q=c[y>>2]|0;R=c[Q+(P<<2)>>2]|0;P=O+ -2|0;c[u>>2]=P;S=c[Q+(P<<2)>>2]|0;do{if((R|0)==1){P=S+4|0;T=c[P>>2]|0;U=O+ -3|0;c[u>>2]=U;V=c[Q+(U<<2)>>2]|0;c[j>>2]=V;U=T+4|0;W=c[U>>2]|0;do{if((W|0)>1){c[l>>2]=0;X=T;F=51}else{if((c[T+8>>2]|0)<=1){Y=V;break}c[l>>2]=0;Z=T;if((W|0)>0){X=Z;F=51}else{_=W;$=Z;aa=V;ba=0;F=60}}}while(0);e:do{if((F|0)==51){F=0;Z=V;ca=W;da=1;ea=0;while(1){fa=lpb(s,q,c[X>>2]|0,(da|0)<(ca|0)?1:2,j,G,m,k)|0;if((fa|0)!=0){J=fa;break b}fa=c[m>>2]|0;if((ea|0)==0){ga=fa}else{ha=upb(s,0,0,1,32)|0;if((ha|0)==0){J=12;break b}ia=upb(s,0,0,1,8)|0;ja=ha+4|0;c[ja>>2]=ia;if((ia|0)==0){J=12;break b}c[ha>>2]=1;c[ha+8>>2]=-1;c[ha+12>>2]=-1;c[ia>>2]=ea;c[(c[ja>>2]|0)+4>>2]=fa;c[ha+16>>2]=(c[fa+16>>2]|0)+(c[ea+16>>2]|0);ga=ha}if((ga|0)==0){J=12;break b}ha=c[U>>2]|0;if((da|0)>=(ha|0)){_=ha;$=X;aa=Z;ba=ga;F=60;break e}Z=c[j>>2]|0;ca=ha;da=da+1|0;ea=ga}}}while(0);if((F|0)==60){F=0;U=T+8|0;W=c[U>>2]|0;do{if((W|0)==-1){ea=c[j>>2]|0;da=lpb(s,q,c[$>>2]|0,0,j,0,l,k)|0;if((da|0)!=0){J=da;break b}da=c[l>>2]|0;ca=upb(s,0,0,1,32)|0;Z=ca;if((ca|0)==0){F=65;break d}ha=upb(s,0,0,1,16)|0;c[ca+4>>2]=ha;if((ha|0)==0){F=65;break d}c[ca>>2]=2;c[ca+8>>2]=-1;c[ca+12>>2]=-1;c[ha>>2]=da;c[ha+4>>2]=0;c[ha+8>>2]=-1;fa=ha+12|0;a[fa]=a[fa]&-2;c[ca+16>>2]=c[da+16>>2];c[l>>2]=Z;ka=Z;la=ea}else{if((_|0)<(W|0)){ma=0;na=_}else{ka=0;la=aa;break}while(1){ea=c[j>>2]|0;Z=lpb(s,q,c[$>>2]|0,0,j,0,n,k)|0;if((Z|0)!=0){J=Z;break b}Z=c[n>>2]|0;if((ma|0)==0){oa=Z}else{da=upb(s,0,0,1,32)|0;if((da|0)==0){F=73;break d}ca=upb(s,0,0,1,8)|0;fa=da+4|0;c[fa>>2]=ca;if((ca|0)==0){F=73;break d}c[da>>2]=1;c[da+8>>2]=-1;c[da+12>>2]=-1;c[ca>>2]=Z;c[(c[fa>>2]|0)+4>>2]=ma;c[da+16>>2]=(c[ma+16>>2]|0)+(c[Z+16>>2]|0);oa=da}c[l>>2]=oa;if((oa|0)==0){J=12;break b}da=upb(s,0,0,1,32)|0;if((da|0)==0){J=12;break b}Z=upb(s,0,0,1,20)|0;c[da+4>>2]=Z;if((Z|0)==0){J=12;break b}c[da>>2]=0;c[da+8>>2]=-1;c[da+12>>2]=-1;c[Z>>2]=-1;c[Z+4>>2]=-1;c[Z+8>>2]=-1;Z=upb(s,0,0,1,32)|0;fa=Z;if((Z|0)==0){F=79;break d}ca=upb(s,0,0,1,8)|0;ha=Z+4|0;c[ha>>2]=ca;if((ca|0)==0){F=79;break d}c[Z>>2]=3;c[Z+8>>2]=-1;c[Z+12>>2]=-1;c[ca>>2]=da;c[(c[ha>>2]|0)+4>>2]=oa;c[Z+16>>2]=(c[oa+16>>2]|0)+(c[da+16>>2]|0);c[l>>2]=fa;da=na+1|0;if((da|0)<(c[U>>2]|0)){ma=fa;na=da}else{ka=fa;la=ea;break}}}}while(0);c[j>>2]=la;do{if((ba|0)==0){pa=ka;F=85}else{if((ka|0)==0){qa=ba;break}U=upb(s,0,0,1,32)|0;if((U|0)==0){J=12;break b}W=upb(s,0,0,1,8)|0;T=U+4|0;c[T>>2]=W;if((W|0)==0){J=12;break b}c[U>>2]=1;c[U+8>>2]=-1;c[U+12>>2]=-1;c[W>>2]=ba;c[(c[T>>2]|0)+4>>2]=ka;c[U+16>>2]=(c[ka+16>>2]|0)+(c[ba+16>>2]|0);pa=U;F=85}}while(0);if((F|0)==85){F=0;if((pa|0)==0){J=12;break b}else{qa=pa}}c[P>>2]=c[qa+4>>2];c[S>>2]=c[qa>>2];Y=la}U=M+ -1|0;T=Y-V+N|0;if((U|0)!=0){ra=Y;sa=U;ta=T;break}c[j>>2]=T;ra=T;sa=0;ta=T}else if((R|0)==0){T=c[S>>2]|0;if((T|0)==0){U=c[S+4>>2]|0;W=c[U>>2]|0;if(!((W|0)>-1|(W|0)==-4)){ra=L;sa=M;ta=N;break}W=U+8|0;U=(c[W>>2]|0)+L|0;c[W>>2]=U;if((U|0)<=(c[k>>2]|0)){ra=L;sa=M;ta=N;break}c[k>>2]=U;ra=L;sa=M;ta=N;break}else if((T|0)==1){U=c[S+4>>2]|0;W=kpb(q,c[U+4>>2]|0)|0;if((W|0)!=0){ua=N;va=W;break c}W=kpb(q,0)|0;if((W|0)!=0){ua=N;va=W;break c}W=kpb(q,c[U>>2]|0)|0;if((W|0)!=0){ua=N;va=W;break c}wa=kpb(q,0)|0}else if((T|0)==3){W=c[S+4>>2]|0;U=kpb(q,c[W+4>>2]|0)|0;if((U|0)!=0){ua=N;va=U;break c}U=kpb(q,0)|0;if((U|0)!=0){ua=N;va=U;break c}U=kpb(q,c[W>>2]|0)|0;if((U|0)!=0){ua=N;va=U;break c}wa=kpb(q,0)|0}else if((T|0)==2){T=c[S+4>>2]|0;U=kpb(q,L)|0;if((U|0)!=0){ua=N;va=U;break c}U=kpb(q,S)|0;if((U|0)!=0){ua=N;va=U;break c}U=kpb(q,1)|0;if((U|0)!=0){ua=N;va=U;break c}U=kpb(q,c[T>>2]|0)|0;if((U|0)!=0){ua=N;va=U;break c}U=kpb(q,0)|0;if((U|0)!=0){ua=N;va=U;break c}if((c[T+4>>2]|0)>1){F=45}else{if((c[T+8>>2]|0)>1){F=45}else{xa=L}}if((F|0)==45){F=0;c[j>>2]=0;xa=0}ra=xa;sa=M+1|0;ta=N;break}else{ra=L;sa=M;ta=N;break}if((wa|0)==0){ra=L;sa=M;ta=N}else{ua=N;va=wa;break c}}else{ra=L;sa=M;ta=N}}while(0);S=c[u>>2]|0;if((S|0)>(E|0)){L=ra;M=sa;N=ta;O=S}else{ua=ta;va=0;break c}}if((F|0)==65){c[l>>2]=0;J=12;break b}else if((F|0)==73){c[l>>2]=0;J=12;break b}else if((F|0)==79){c[l>>2]=0;J=12;break b}}else{ua=0;va=0}}while(0);y=(c[H>>2]|0)+ua|0;K=c[k>>2]|0;c[H>>2]=(K|0)>(y|0)?K:y;J=va}else{J=v}}while(0);if((J|0)!=0){z=0;A=J;B=0;C=D;break}v=c[H>>2]|0;c[H>>2]=v+1;E=upb(s,0,0,1,32)|0;if((E|0)==0){z=0;A=12;B=0;C=D;break}y=upb(s,0,0,1,20)|0;c[E+4>>2]=y;if((y|0)==0){z=0;A=12;B=0;C=D;break}c[E>>2]=0;c[E+8>>2]=-1;c[E+12>>2]=-1;c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=v;v=upb(s,0,0,1,32)|0;y=v;if((v|0)==0){z=0;A=12;B=0;C=D;break}K=upb(s,0,0,1,8)|0;O=v+4|0;c[O>>2]=K;if((K|0)==0){z=0;A=12;B=0;C=D;break}c[v>>2]=1;c[v+8>>2]=-1;c[v+12>>2]=-1;c[K>>2]=x;c[(c[O>>2]|0)+4>>2]=E;c[v+16>>2]=(c[E+16>>2]|0)+(c[x+16>>2]|0);E=c[u>>2]|0;O=kpb(q,v)|0;if((O|0)!=0){z=0;A=O;B=0;C=D;break}O=kpb(q,0)|0;if((O|0)!=0){z=0;A=O;B=0;C=D;break}O=c[u>>2]|0;f:do{if((O|0)>(E|0)){K=p+16|0;N=O;g:while(1){M=N+ -1|0;c[u>>2]=M;L=c[K>>2]|0;S=c[L+(M<<2)>>2]|0;M=N+ -2|0;c[u>>2]=M;ya=c[L+(M<<2)>>2]|0;do{if((S|0)==0){M=c[ya>>2]|0;if((M|0)==0){L=c[ya+4>>2]|0;R=c[L>>2]|0;if((R|0)==-4){c[ya+8>>2]=0;Q=L+8|0;T=c[Q>>2]|0;U=upb(s,0,0,1,64)|0;if((U|0)==0){F=104;break g}W=U;c[U>>2]=T;c[U+4>>2]=0;c[U+8>>2]=1114111;c[U+20>>2]=0;c[U+24>>2]=0;T=U+28|0;U=ya+24|0;c[T+0>>2]=-1;c[T+4>>2]=-1;c[T+8>>2]=-1;c[T+12>>2]=-1;c[U>>2]=W;W=c[Q>>2]|0;Q=c[L+4>>2]|0;U=upb(s,0,0,1,64)|0;if((U|0)==0){F=106;break g}c[U>>2]=W;c[U+4>>2]=0;c[U+8>>2]=1114111;c[U+20>>2]=0;c[U+24>>2]=0;c[U+28>>2]=Q;c[U+32>>2]=-1;c[U+36>>2]=-1;c[U+40>>2]=-1;c[ya+28>>2]=U;break}U=ya+8|0;if((R|0)<0){c[U>>2]=1;Q=upb(s,0,0,1,32)|0;if((Q|0)==0){F=110;break g}c[Q>>2]=-1;c[Q+4>>2]=-1;c[Q+8>>2]=-1;c[ya+24>>2]=Q;Q=upb(s,0,0,1,32)|0;if((Q|0)==0){F=112;break g}c[Q>>2]=-1;c[Q+4>>2]=-1;c[Q+8>>2]=-1;c[ya+28>>2]=Q;break}else{c[U>>2]=0;U=L+8|0;Q=c[U>>2]|0;W=L+4|0;T=c[W>>2]|0;ea=upb(s,0,0,1,64)|0;if((ea|0)==0){F=115;break g}fa=ea;c[ea>>2]=Q;c[ea+4>>2]=R;c[ea+8>>2]=T;c[ea+20>>2]=0;c[ea+24>>2]=0;T=ea+28|0;ea=ya+24|0;c[T+0>>2]=-1;c[T+4>>2]=-1;c[T+8>>2]=-1;c[T+12>>2]=-1;c[ea>>2]=fa;fa=c[U>>2]|0;U=c[L>>2]|0;ea=c[W>>2]|0;W=c[L+12>>2]|0;T=c[L+16>>2]|0;L=upb(s,0,0,1,64)|0;if((L|0)==0){F=117;break g}R=L;c[L>>2]=fa;c[L+4>>2]=U;c[L+8>>2]=ea;c[L+20>>2]=W;c[L+24>>2]=T;T=L+28|0;L=ya+28|0;c[T+0>>2]=-1;c[T+4>>2]=-1;c[T+8>>2]=-1;c[T+12>>2]=-1;c[L>>2]=R;break}}else if((M|0)==2){R=kpb(q,ya)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=kpb(q,3)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=kpb(q,c[c[ya+4>>2]>>2]|0)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=kpb(q,0)|0;if((R|0)==0){break}else{z=0;A=R;B=0;C=D;break a}}else if((M|0)==3){R=kpb(q,ya)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=kpb(q,1)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=ya+4|0;L=kpb(q,c[(c[R>>2]|0)+4>>2]|0)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=kpb(q,0)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=kpb(q,c[c[R>>2]>>2]|0)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=kpb(q,0)|0;if((L|0)==0){break}else{z=0;A=L;B=0;C=D;break a}}else if((M|0)==1){M=kpb(q,ya)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=kpb(q,2)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=ya+4|0;L=kpb(q,c[(c[M>>2]|0)+4>>2]|0)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=kpb(q,0)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=kpb(q,c[c[M>>2]>>2]|0)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=kpb(q,0)|0;if((L|0)==0){break}else{z=0;A=L;B=0;C=D;break a}}else{break}}else if((S|0)==2){L=c[ya+4>>2]|0;M=c[L>>2]|0;R=M+8|0;if((c[R>>2]|0)==0){za=0}else{za=(c[(c[L+4>>2]|0)+8>>2]|0)!=0|0}c[ya+8>>2]=za;if((c[R>>2]|0)==0){c[ya+24>>2]=c[M+24>>2];Aa=L+4|0}else{R=jpb(q,M,0,0,g)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}Ba=Wpb((c[g>>2]<<2)+4|0)|0;R=Ba;if((Ba|0)==0){z=0;A=12;B=0;C=D;break a}c[Ba>>2]=-1;c[h>>2]=0;Ca=jpb(q,c[L>>2]|0,R,h,0)|0;if((Ca|0)!=0){F=150;break g}M=L+4|0;T=ipb(s,c[(c[M>>2]|0)+24>>2]|0,c[(c[L>>2]|0)+24>>2]|0,R,c[h>>2]|0)|0;R=ya+24|0;c[R>>2]=T;Xpb(Ba);if((c[R>>2]|0)==0){z=0;A=12;B=0;C=D;break a}else{Aa=M}}M=c[Aa>>2]|0;if((c[M+8>>2]|0)==0){c[ya+28>>2]=c[M+28>>2];break}R=jpb(q,M,0,0,g)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}Da=Wpb((c[g>>2]<<2)+4|0)|0;R=Da;if((Da|0)==0){z=0;A=12;B=0;C=D;break a}c[Da>>2]=-1;c[h>>2]=0;Ea=jpb(q,c[Aa>>2]|0,R,h,0)|0;if((Ea|0)!=0){F=157;break g}M=ipb(s,c[(c[L>>2]|0)+28>>2]|0,c[(c[Aa>>2]|0)+28>>2]|0,R,c[h>>2]|0)|0;R=ya+28|0;c[R>>2]=M;Xpb(Da);if((c[R>>2]|0)==0){z=0;A=12;B=0;C=D;break a}}else if((S|0)==1){R=c[ya+4>>2]|0;M=c[R>>2]|0;L=R+4|0;T=c[L>>2]|0;if((c[M+8>>2]|0)==0){Fa=(c[T+8>>2]|0)!=0|0}else{Fa=1}c[ya+8>>2]=Fa;W=ipb(s,c[M+24>>2]|0,c[T+24>>2]|0,0,0)|0;c[ya+24>>2]=W;if((W|0)==0){z=0;A=12;B=0;C=D;break a}W=ipb(s,c[(c[R>>2]|0)+28>>2]|0,c[(c[L>>2]|0)+28>>2]|0,0,0)|0;c[ya+28>>2]=W;if((W|0)==0){z=0;A=12;B=0;C=D;break a}}else if((S|0)==3){W=c[ya+4>>2]|0;L=c[W>>2]|0;do{if((c[W+4>>2]|0)==0){F=141}else{if((c[L+8>>2]|0)!=0){F=141;break}c[ya+8>>2]=0}}while(0);if((F|0)==141){F=0;c[ya+8>>2]=1}c[ya+24>>2]=c[L+24>>2];c[ya+28>>2]=c[(c[W>>2]|0)+28>>2]}}while(0);N=c[u>>2]|0;if((N|0)<=(E|0)){break f}}if((F|0)==104){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==106){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==110){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==112){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==115){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==117){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==150){Xpb(Ba);z=0;A=Ca;B=0;C=D;break a}else if((F|0)==157){Xpb(Da);z=0;A=Ea;B=0;C=D;break a}}}while(0);E=c[H>>2]|0;u=E<<2;O=Wpb(u)|0;x=O;if((O|0)==0){z=x;A=12;B=0;C=D;break}N=Wpb(u)|0;u=N;if((N|0)==0){z=x;A=12;B=u;C=D;break}if((E|0)>0){Cqb(O|0,0,((E|0)>1?E<<2:4)|0)|0}fpb(y,0,x,0)|0;E=c[H>>2]|0;if((E|0)>0){K=0;S=0;while(1){c[N+(S<<2)>>2]=K;R=O+(S<<2)|0;T=K+1+(c[R>>2]|0)|0;c[R>>2]=0;R=S+1|0;if((R|0)<(E|0)){S=R;K=T}else{Ga=T;break}}}else{Ga=0}K=Ypb(Ga+1|0,32)|0;S=K;if((K|0)==0){z=x;A=12;B=u;C=D;break}c[w>>2]=S;E=w+4|0;c[E>>2]=Ga;T=fpb(y,S,x,u)|0;if((T|0)!=0){z=x;A=T;B=u;C=D;break}c[w+20>>2]=0;T=v+24|0;S=c[T>>2]|0;if((c[S>>2]|0)>-1){R=1;M=S;while(1){S=M+32|0;ea=R+1|0;if((c[S>>2]|0)>-1){M=S;R=ea}else{Ha=ea;break}}}else{Ha=1}R=Ypb(Ha,32)|0;if((R|0)==0){z=x;A=12;B=u;C=D;break}c[w+8>>2]=R;M=c[T>>2]|0;y=c[M>>2]|0;if((y|0)>-1){ea=y;y=M;M=0;while(1){c[R+(M<<5)+8>>2]=K+(c[N+(ea<<2)>>2]<<5);c[R+(M<<5)+12>>2]=ea;S=R+(M<<5)+16|0;c[S>>2]=0;U=y+12|0;fa=c[U>>2]|0;if((fa|0)!=0){Q=0;while(1){Ia=Q+1|0;if((c[fa+(Q<<2)>>2]|0)>-1){Q=Ia}else{break}}Q=Ia<<2;fa=Wpb(Q)|0;c[S>>2]=fa;if((fa|0)==0){z=x;A=12;B=u;C=D;break a}Aqb(fa|0,c[U>>2]|0,Q|0)|0}c[R+(M<<5)+20>>2]=c[y+16>>2];Q=M+1|0;fa=y+32|0;da=c[fa>>2]|0;if((da|0)>-1){ea=da;y=fa;M=Q}else{Ja=Q;break}}}else{Ja=0}c[R+(Ja<<5)+8>>2]=0;c[E>>2]=Ga;c[w+12>>2]=K+(c[N+(c[c[v+28>>2]>>2]<<2)>>2]<<5);c[w+52>>2]=c[H>>2];c[w+56>>2]=e;tpb(s);Xpb(c[p+16>>2]|0);Xpb(p);Xpb(O);Xpb(N);c[b+4>>2]=w;r=0;i=f;return r|0}else{z=0;A=t;B=0;C=0}}while(0);tpb(s);Xpb(c[p+16>>2]|0);Xpb(p);if((z|0)!=0){Xpb(z)}if((B|0)!=0){Xpb(B)}c[b+4>>2]=C;gpb(b);r=A;i=f;return r|0}



function aka(a){a=a|0;var b=0,d=0,e=0,f=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,B=0,C=0,D=0,E=0,F=0,G=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0.0;b=i;i=i+3008|0;d=i;i=i+16|0;e=i;i=i+16|0;f=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+16|0;S=i;i=i+16|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+16|0;X=i;i=i+16|0;Y=i;i=i+16|0;Z=i;i=i+16|0;_=i;i=i+16|0;$=i;i=i+16|0;aa=i;i=i+16|0;ba=i;i=i+16|0;ca=i;i=i+16|0;da=i;i=i+16|0;ea=i;i=i+16|0;fa=i;i=i+16|0;ga=i;i=i+16|0;ha=i;i=i+16|0;ia=i;i=i+16|0;ja=i;i=i+16|0;ka=i;i=i+16|0;la=i;i=i+16|0;ma=i;i=i+16|0;na=i;i=i+16|0;oa=i;i=i+16|0;pa=i;i=i+16|0;qa=i;i=i+16|0;ra=i;i=i+16|0;sa=i;i=i+16|0;ta=i;i=i+16|0;ua=i;i=i+16|0;va=i;i=i+16|0;wa=i;i=i+16|0;xa=i;i=i+16|0;ya=i;i=i+16|0;za=i;i=i+16|0;Aa=i;i=i+16|0;Ba=i;i=i+16|0;Ca=i;i=i+16|0;Da=i;i=i+16|0;Ea=i;i=i+16|0;Fa=i;i=i+16|0;Ga=i;i=i+16|0;Ha=i;i=i+16|0;Ia=i;i=i+16|0;Ja=i;i=i+16|0;Ka=i;i=i+16|0;La=i;i=i+16|0;Ma=i;i=i+16|0;Na=i;i=i+16|0;Oa=i;i=i+16|0;Pa=i;i=i+16|0;Qa=i;i=i+16|0;Ra=i;i=i+16|0;Sa=i;i=i+16|0;Ta=i;i=i+16|0;Ua=i;i=i+16|0;Va=i;i=i+16|0;Wa=i;i=i+16|0;Xa=i;i=i+16|0;Ya=i;i=i+16|0;Za=i;i=i+16|0;_a=i;i=i+16|0;$a=i;i=i+16|0;ab=i;i=i+16|0;bb=i;i=i+16|0;cb=i;i=i+16|0;db=i;i=i+16|0;eb=i;i=i+16|0;fb=i;i=i+16|0;gb=i;i=i+16|0;hb=i;i=i+16|0;ib=i;i=i+16|0;jb=i;i=i+16|0;kb=i;i=i+16|0;lb=i;i=i+16|0;mb=i;i=i+16|0;nb=i;i=i+16|0;ob=i;i=i+16|0;pb=i;i=i+16|0;qb=i;i=i+16|0;rb=i;i=i+16|0;sb=i;i=i+16|0;tb=i;i=i+16|0;ub=i;i=i+16|0;vb=i;i=i+8|0;wb=i;i=i+8|0;xb=i;i=i+8|0;yb=i;i=i+8|0;kXa(9,1,57112,yb);if((c[240116>>2]|0)!=0){me[c[60158]&2047](9)}kXa(9,1,57136,xb);if((c[240116>>2]|0)!=0){me[c[60158]&2047](9)}kXa(9,1,57160,wb);if((c[240116>>2]|0)!=0){me[c[60158]&2047](9)}Qha(a);Rha(a);Sha(a);Tha(a);Uha(a);Vha(a);Wha(a);Xha(a);Yha(a);Zha(a);_ha(a);$ha(a);aia(a);bia(a);cia(a);dia(a);eia(a);fia(a);gia(a);hia(a);iia(a);jia(a);kia(a);lia(a);mia(a);nia(a);oia(a);pia(a);qia(a);ria(a);sia(a);tia(a);uia(a);via(a);wia(a);xia(a);yia(a);zia(a);Aia(a);Bia(a);Cia(a);Dia(a);Eia(a);Fia(a);Gia(a);Hia(a);Iia(a);Jia(a);Kia(a);Lia(a);Mia(a);Nia(a);Oia(a);Pia(a);Qia(a);Ria(a);Sia(a);Tia(a);Uia(a);Via(a);Wia(a);Xia(a);Yia(a);Zia(a);_ia(a);$ia(a);aja(a);bja(a);cja(a);dja(a);eja(a);fja(a);gja(a);hja(a);ija(a);jja(a);kja(a);lja(a);mja(a);nja(a);oja(a);pja(a);qja(a);rja(a);sja(a);tja(a);uja(a);vja(a);wja(a);xja(a);yja(a);zja(a);Aja(a);Bja(a);Cja(a);Dja(a);Eja(a);Fja(a);Gja(a);Hja(a);Ija(a);Jja(a);Kja(a);Lja(a);Mja(a);Nja(a);Oja(a);Pja(a);Qja(a);Rja(a);Sja(a);Tja(a);Uja(a);Vja(a);Wja(a);Xja(a);Yja(a);Zja(a);_ja(a);$ja(a);kXa(9,1,57184,vb);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+2552>>3];vb=c[(a+8|0)>>2]|0;h[vb+35824>>3]=zb;c[ub>>2]=c[vb+35732>>2];h[k>>3]=zb;c[(ub+4|0)>>2]=c[k>>2];c[(ub+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,ub);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+2544>>3];ub=c[(a+8|0)>>2]|0;h[ub+35712>>3]=zb;c[tb>>2]=c[ub+35620>>2];h[k>>3]=zb;c[(tb+4|0)>>2]=c[k>>2];c[(tb+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,tb);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+2536>>3];tb=c[(a+8|0)>>2]|0;h[tb+35600>>3]=zb;c[sb>>2]=c[tb+35508>>2];h[k>>3]=zb;c[(sb+4|0)>>2]=c[k>>2];c[(sb+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,sb);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+2528>>3];sb=c[(a+8|0)>>2]|0;h[sb+35488>>3]=zb;c[rb>>2]=c[sb+35396>>2];h[k>>3]=zb;c[(rb+4|0)>>2]=c[k>>2];c[(rb+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,rb);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+2520>>3];rb=c[(a+8|0)>>2]|0;h[rb+35376>>3]=zb;c[qb>>2]=c[rb+35284>>2];h[k>>3]=zb;c[(qb+4|0)>>2]=c[k>>2];c[(qb+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,qb);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+2512>>3];qb=c[(a+8|0)>>2]|0;h[qb+35264>>3]=zb;c[pb>>2]=c[qb+35172>>2];h[k>>3]=zb;c[(pb+4|0)>>2]=c[k>>2];c[(pb+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,pb);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+2504>>3];pb=c[(a+8|0)>>2]|0;h[pb+35152>>3]=zb;c[ob>>2]=c[pb+35060>>2];h[k>>3]=zb;c[(ob+4|0)>>2]=c[k>>2];c[(ob+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,ob);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+2496>>3];ob=c[(a+8|0)>>2]|0;h[ob+35040>>3]=zb;c[nb>>2]=c[ob+34948>>2];h[k>>3]=zb;c[(nb+4|0)>>2]=c[k>>2];c[(nb+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,nb);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+2488>>3];nb=c[(a+8|0)>>2]|0;h[nb+34928>>3]=zb;c[mb>>2]=c[nb+34836>>2];h[k>>3]=zb;c[(mb+4|0)>>2]=c[k>>2];c[(mb+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,mb);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+2480>>3];mb=c[(a+8|0)>>2]|0;h[mb+34816>>3]=zb;c[lb>>2]=c[mb+34724>>2];h[k>>3]=zb;c[(lb+4|0)>>2]=c[k>>2];c[(lb+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,lb);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+2472>>3];lb=c[(a+8|0)>>2]|0;h[lb+34704>>3]=zb;c[kb>>2]=c[lb+34612>>2];h[k>>3]=zb;c[(kb+4|0)>>2]=c[k>>2];c[(kb+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,kb);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+2464>>3];kb=c[(a+8|0)>>2]|0;h[kb+34592>>3]=zb;c[jb>>2]=c[kb+34500>>2];h[k>>3]=zb;c[(jb+4|0)>>2]=c[k>>2];c[(jb+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,jb);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+2456>>3];jb=c[(a+8|0)>>2]|0;h[jb+34480>>3]=zb;c[ib>>2]=c[jb+34388>>2];h[k>>3]=zb;c[(ib+4|0)>>2]=c[k>>2];c[(ib+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,ib);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+2448>>3];ib=c[(a+8|0)>>2]|0;h[ib+34368>>3]=zb;c[hb>>2]=c[ib+34276>>2];h[k>>3]=zb;c[(hb+4|0)>>2]=c[k>>2];c[(hb+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,hb);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+2440>>3];hb=c[(a+8|0)>>2]|0;h[hb+34256>>3]=zb;c[gb>>2]=c[hb+34164>>2];h[k>>3]=zb;c[(gb+4|0)>>2]=c[k>>2];c[(gb+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,gb);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+2432>>3];gb=c[(a+8|0)>>2]|0;h[gb+34144>>3]=zb;c[fb>>2]=c[gb+34052>>2];h[k>>3]=zb;c[(fb+4|0)>>2]=c[k>>2];c[(fb+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,fb);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+2424>>3];fb=c[(a+8|0)>>2]|0;h[fb+34032>>3]=zb;c[eb>>2]=c[fb+33940>>2];h[k>>3]=zb;c[(eb+4|0)>>2]=c[k>>2];c[(eb+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,eb);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+2416>>3];eb=c[(a+8|0)>>2]|0;h[eb+33920>>3]=zb;c[db>>2]=c[eb+33828>>2];h[k>>3]=zb;c[(db+4|0)>>2]=c[k>>2];c[(db+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,db);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+2408>>3];db=c[(a+8|0)>>2]|0;h[db+33808>>3]=zb;c[cb>>2]=c[db+33716>>2];h[k>>3]=zb;c[(cb+4|0)>>2]=c[k>>2];c[(cb+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,cb);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+2400>>3];cb=c[(a+8|0)>>2]|0;h[cb+33696>>3]=zb;c[bb>>2]=c[cb+33604>>2];h[k>>3]=zb;c[(bb+4|0)>>2]=c[k>>2];c[(bb+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,bb);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+4792>>3];bb=c[(a+8|0)>>2]|0;h[bb+67184>>3]=zb;c[ab>>2]=c[bb+67092>>2];h[k>>3]=zb;c[(ab+4|0)>>2]=c[k>>2];c[(ab+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,ab);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+4784>>3];ab=c[(a+8|0)>>2]|0;h[ab+67072>>3]=zb;c[$a>>2]=c[ab+66980>>2];h[k>>3]=zb;c[($a+4|0)>>2]=c[k>>2];c[($a+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,$a);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+4776>>3];$a=c[(a+8|0)>>2]|0;h[$a+66960>>3]=zb;c[_a>>2]=c[$a+66868>>2];h[k>>3]=zb;c[(_a+4|0)>>2]=c[k>>2];c[(_a+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,_a);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+4768>>3];_a=c[(a+8|0)>>2]|0;h[_a+66848>>3]=zb;c[Za>>2]=c[_a+66756>>2];h[k>>3]=zb;c[(Za+4|0)>>2]=c[k>>2];c[(Za+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,Za);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+4760>>3];Za=c[(a+8|0)>>2]|0;h[Za+66736>>3]=zb;c[Ya>>2]=c[Za+66644>>2];h[k>>3]=zb;c[(Ya+4|0)>>2]=c[k>>2];c[(Ya+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,Ya);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+4752>>3];Ya=c[(a+8|0)>>2]|0;h[Ya+66624>>3]=zb;c[Xa>>2]=c[Ya+66532>>2];h[k>>3]=zb;c[(Xa+4|0)>>2]=c[k>>2];c[(Xa+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,Xa);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+4744>>3];Xa=c[(a+8|0)>>2]|0;h[Xa+66512>>3]=zb;c[Wa>>2]=c[Xa+66420>>2];h[k>>3]=zb;c[(Wa+4|0)>>2]=c[k>>2];c[(Wa+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,Wa);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+4736>>3];Wa=c[(a+8|0)>>2]|0;h[Wa+66400>>3]=zb;c[Va>>2]=c[Wa+66308>>2];h[k>>3]=zb;c[(Va+4|0)>>2]=c[k>>2];c[(Va+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,Va);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+4728>>3];Va=c[(a+8|0)>>2]|0;h[Va+66288>>3]=zb;c[Ua>>2]=c[Va+66196>>2];h[k>>3]=zb;c[(Ua+4|0)>>2]=c[k>>2];c[(Ua+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,Ua);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+4720>>3];Ua=c[(a+8|0)>>2]|0;h[Ua+66176>>3]=zb;c[Ta>>2]=c[Ua+66084>>2];h[k>>3]=zb;c[(Ta+4|0)>>2]=c[k>>2];c[(Ta+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,Ta);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+4712>>3];Ta=c[(a+8|0)>>2]|0;h[Ta+66064>>3]=zb;c[Sa>>2]=c[Ta+65972>>2];h[k>>3]=zb;c[(Sa+4|0)>>2]=c[k>>2];c[(Sa+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,Sa);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+4704>>3];Sa=c[(a+8|0)>>2]|0;h[Sa+65952>>3]=zb;c[Ra>>2]=c[Sa+65860>>2];h[k>>3]=zb;c[(Ra+4|0)>>2]=c[k>>2];c[(Ra+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,Ra);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+4696>>3];Ra=c[(a+8|0)>>2]|0;h[Ra+65840>>3]=zb;c[Qa>>2]=c[Ra+65748>>2];h[k>>3]=zb;c[(Qa+4|0)>>2]=c[k>>2];c[(Qa+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,Qa);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+4688>>3];Qa=c[(a+8|0)>>2]|0;h[Qa+65728>>3]=zb;c[Pa>>2]=c[Qa+65636>>2];h[k>>3]=zb;c[(Pa+4|0)>>2]=c[k>>2];c[(Pa+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,Pa);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+4680>>3];Pa=c[(a+8|0)>>2]|0;h[Pa+65616>>3]=zb;c[Oa>>2]=c[Pa+65524>>2];h[k>>3]=zb;c[(Oa+4|0)>>2]=c[k>>2];c[(Oa+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,Oa);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+4672>>3];Oa=c[(a+8|0)>>2]|0;h[Oa+65504>>3]=zb;c[Na>>2]=c[Oa+65412>>2];h[k>>3]=zb;c[(Na+4|0)>>2]=c[k>>2];c[(Na+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,Na);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+4664>>3];Na=c[(a+8|0)>>2]|0;h[Na+65392>>3]=zb;c[Ma>>2]=c[Na+65300>>2];h[k>>3]=zb;c[(Ma+4|0)>>2]=c[k>>2];c[(Ma+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,Ma);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+4656>>3];Ma=c[(a+8|0)>>2]|0;h[Ma+65280>>3]=zb;c[La>>2]=c[Ma+65188>>2];h[k>>3]=zb;c[(La+4|0)>>2]=c[k>>2];c[(La+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,La);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+4648>>3];La=c[(a+8|0)>>2]|0;h[La+65168>>3]=zb;c[Ka>>2]=c[La+65076>>2];h[k>>3]=zb;c[(Ka+4|0)>>2]=c[k>>2];c[(Ka+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,Ka);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+4640>>3];Ka=c[(a+8|0)>>2]|0;h[Ka+65056>>3]=zb;c[Ja>>2]=c[Ka+64964>>2];h[k>>3]=zb;c[(Ja+4|0)>>2]=c[k>>2];c[(Ja+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,Ja);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+7192>>3];Ja=c[(a+8|0)>>2]|0;h[Ja+100784>>3]=zb;c[Ia>>2]=c[Ja+100692>>2];h[k>>3]=zb;c[(Ia+4|0)>>2]=c[k>>2];c[(Ia+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,Ia);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+7184>>3];Ia=c[(a+8|0)>>2]|0;h[Ia+100672>>3]=zb;c[Ha>>2]=c[Ia+100580>>2];h[k>>3]=zb;c[(Ha+4|0)>>2]=c[k>>2];c[(Ha+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,Ha);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+7176>>3];Ha=c[(a+8|0)>>2]|0;h[Ha+100560>>3]=zb;c[Ga>>2]=c[Ha+100468>>2];h[k>>3]=zb;c[(Ga+4|0)>>2]=c[k>>2];c[(Ga+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,Ga);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+7168>>3];Ga=c[(a+8|0)>>2]|0;h[Ga+100448>>3]=zb;c[Fa>>2]=c[Ga+100356>>2];h[k>>3]=zb;c[(Fa+4|0)>>2]=c[k>>2];c[(Fa+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,Fa);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+7160>>3];Fa=c[(a+8|0)>>2]|0;h[Fa+100336>>3]=zb;c[Ea>>2]=c[Fa+100244>>2];h[k>>3]=zb;c[(Ea+4|0)>>2]=c[k>>2];c[(Ea+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,Ea);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+7152>>3];Ea=c[(a+8|0)>>2]|0;h[Ea+100224>>3]=zb;c[Da>>2]=c[Ea+100132>>2];h[k>>3]=zb;c[(Da+4|0)>>2]=c[k>>2];c[(Da+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,Da);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+7144>>3];Da=c[(a+8|0)>>2]|0;h[Da+100112>>3]=zb;c[Ca>>2]=c[Da+100020>>2];h[k>>3]=zb;c[(Ca+4|0)>>2]=c[k>>2];c[(Ca+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,Ca);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+7136>>3];Ca=c[(a+8|0)>>2]|0;h[Ca+1e5>>3]=zb;c[Ba>>2]=c[Ca+99908>>2];h[k>>3]=zb;c[(Ba+4|0)>>2]=c[k>>2];c[(Ba+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,Ba);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+7128>>3];Ba=c[(a+8|0)>>2]|0;h[Ba+99888>>3]=zb;c[Aa>>2]=c[Ba+99796>>2];h[k>>3]=zb;c[(Aa+4|0)>>2]=c[k>>2];c[(Aa+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,Aa);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+7120>>3];Aa=c[(a+8|0)>>2]|0;h[Aa+99776>>3]=zb;c[za>>2]=c[Aa+99684>>2];h[k>>3]=zb;c[(za+4|0)>>2]=c[k>>2];c[(za+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,za);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+7112>>3];za=c[(a+8|0)>>2]|0;h[za+99664>>3]=zb;c[ya>>2]=c[za+99572>>2];h[k>>3]=zb;c[(ya+4|0)>>2]=c[k>>2];c[(ya+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,ya);zb=+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+7104>>3];ya=c[(a+8|0)>>2]|0;h[ya+99552>>3]=zb;c[xa>>2]=c[ya+99460>>2];h[k>>3]=zb;c[b+24>>2]=a;c[b+2256>>2]=xa;c[b+2264>>2]=wa;c[b+2272>>2]=va;c[b+2280>>2]=ua;c[b+2288>>2]=ta;c[b+2296>>2]=sa;c[b+2312>>2]=ra;c[b+2320>>2]=qa;c[b+2328>>2]=pa;c[b+2336>>2]=oa;c[b+2344>>2]=na;c[b+2352>>2]=ma;c[b+2360>>2]=la;c[b+2368>>2]=ka;c[b+2376>>2]=ja;c[b+2384>>2]=ia;c[b+2400>>2]=ha;c[b+2408>>2]=ga;c[b+2416>>2]=fa;c[b+2424>>2]=ea;c[b+2432>>2]=da;c[b+2440>>2]=ca;c[b+2448>>2]=ba;c[b+2456>>2]=aa;c[b+2464>>2]=$;c[b+2472>>2]=_;c[b+2488>>2]=Z;c[b+2496>>2]=Y;c[b+2512>>2]=X;c[b+2520>>2]=W;c[b+2528>>2]=V;c[b+2536>>2]=U;c[b+2544>>2]=T;c[b+2552>>2]=S;c[b+2560>>2]=R;c[b+2568>>2]=Q;c[b+2584>>2]=P;c[b+2592>>2]=O;c[b+2600>>2]=N;c[b+2608>>2]=M;c[b+2616>>2]=L;c[b+2624>>2]=K;c[b+2632>>2]=J;c[b+2640>>2]=G;c[b+2648>>2]=F;c[b+2656>>2]=E;c[b+2672>>2]=D;c[b+2680>>2]=C;c[b+2688>>2]=B;c[b+2696>>2]=z;c[b+2704>>2]=y;c[b+2712>>2]=x;c[b+2720>>2]=w;c[b+2728>>2]=v;c[b+2736>>2]=u;c[b+2744>>2]=t;c[b+2760>>2]=s;c[b+2768>>2]=r;c[b+2776>>2]=q;c[b+2784>>2]=p;c[b+2792>>2]=o;c[b+2800>>2]=n;c[b+2808>>2]=m;c[b+2816>>2]=l;c[b+2824>>2]=j;c[b+2832>>2]=f;c[b+2848>>2]=e;c[b+2856>>2]=d;c[b+2944>>2]=0;c[b+2948>>2]=0;_Modelica_Fluid_Examples_HeatExchanger_HeatExchangerSimulation_updateBoundVariableAttributes$0(b);H=c[b+2944>>2]|0;A=c[b+2948>>2]|0;I=+g[b+2948>>2];c[b+2944>>2]=0;c[b+2948>>2]=0;if((H|0)==6){return A|0}return 0|0;return 0}function bka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11184>>3]=.018015268;i=i;return}function cka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11192>>3]=461.5236365065454;i=i;return}function dka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11200>>3]=1.0;i=i;return}function eka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11208>>3]=.018015268;i=i;return}function fka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11216>>3]=461.5236365065454;i=i;return}function gka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11224>>3]=1.0;i=i;return}function hka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11232>>3]=.018015268;i=i;return}function ika(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11240>>3]=461.5236365065454;i=i;return}function jka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11248>>3]=1.0;i=i;return}function kka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11256>>3]=.018015268;i=i;return}function lka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11264>>3]=461.5236365065454;i=i;return}function mka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11272>>3]=1.0;i=i;return}function nka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11280>>3]=.018015268;i=i;return}function oka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11288>>3]=461.5236365065454;i=i;return}function pka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11296>>3]=1.0;i=i;return}function qka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11304>>3]=.018015268;i=i;return}function rka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11312>>3]=461.5236365065454;i=i;return}function ska(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11320>>3]=1.0;i=i;return}function tka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11328>>3]=.018015268;i=i;return}function uka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11336>>3]=461.5236365065454;i=i;return}function vka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11344>>3]=1.0;i=i;return}function wka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11352>>3]=.018015268;i=i;return}function xka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11360>>3]=461.5236365065454;i=i;return}function yka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11368>>3]=1.0;i=i;return}function zka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11376>>3]=.018015268;i=i;return}function Aka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11384>>3]=461.5236365065454;i=i;return}function Bka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11392>>3]=1.0;i=i;return}function Cka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11400>>3]=.018015268;i=i;return}function Dka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11408>>3]=461.5236365065454;i=i;return}function Eka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11416>>3]=1.0;i=i;return}function Fka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11424>>3]=.018015268;i=i;return}function Gka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11432>>3]=461.5236365065454;i=i;return}function Hka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11440>>3]=1.0;i=i;return}function Ika(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11448>>3]=.018015268;i=i;return}function Jka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11456>>3]=461.5236365065454;i=i;return}function Kka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11464>>3]=1.0;i=i;return}function Lka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11472>>3]=.018015268;i=i;return}function Mka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11480>>3]=461.5236365065454;i=i;return}function Nka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11488>>3]=1.0;i=i;return}function Oka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11496>>3]=.018015268;i=i;return}function Pka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11504>>3]=461.5236365065454;i=i;return}function Qka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11512>>3]=1.0;i=i;return}function Rka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11520>>3]=.018015268;i=i;return}function Ska(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11528>>3]=461.5236365065454;i=i;return}function Tka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11536>>3]=1.0;i=i;return}function Uka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11544>>3]=.018015268;i=i;return}function Vka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11552>>3]=461.5236365065454;i=i;return}function Wka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11560>>3]=1.0;i=i;return}function Xka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11568>>3]=.018015268;i=i;return}function Yka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11576>>3]=461.5236365065454;i=i;return}function Zka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11584>>3]=1.0;i=i;return}function _ka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11592>>3]=.018015268;i=i;return}function $ka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11600>>3]=461.5236365065454;i=i;return}function ala(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11608>>3]=1.0;i=i;return}function bla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11616>>3]=.018015268;i=i;return}function cla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11624>>3]=461.5236365065454;i=i;return}function dla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11632>>3]=1.0;i=i;return}function ela(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11640>>3]=.018015268;i=i;return}function fla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11648>>3]=461.5236365065454;i=i;return}function gla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11656>>3]=1.0;i=i;return}function hla(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+160>>2]=0;i=i;return}function ila(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11664>>3]=.018015268;i=i;return}function jla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11672>>3]=461.5236365065454;i=i;return}function kla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11680>>3]=1.0;i=i;return}function lla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11688>>3]=.018015268;i=i;return}function mla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11696>>3]=461.5236365065454;i=i;return}function nla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11704>>3]=1.0;i=i;return}function ola(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11712>>3]=.018015268;i=i;return}function pla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11720>>3]=461.5236365065454;i=i;return}function qla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11728>>3]=1.0;i=i;return}function rla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11736>>3]=.018015268;i=i;return}function sla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11744>>3]=461.5236365065454;i=i;return}function tla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11752>>3]=1.0;i=i;return}function ula(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11760>>3]=.018015268;i=i;return}function vla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11768>>3]=461.5236365065454;i=i;return}function wla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11776>>3]=1.0;i=i;return}function xla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11784>>3]=.018015268;i=i;return}function yla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11792>>3]=461.5236365065454;i=i;return}function zla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11800>>3]=1.0;i=i;return}function Ala(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11808>>3]=.018015268;i=i;return}function Bla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11816>>3]=461.5236365065454;i=i;return}function Cla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11824>>3]=1.0;i=i;return}function Dla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11832>>3]=.018015268;i=i;return}function Ela(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11840>>3]=461.5236365065454;i=i;return}function Fla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11848>>3]=1.0;i=i;return}function Gla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11856>>3]=.018015268;i=i;return}function Hla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11864>>3]=461.5236365065454;i=i;return}function Ila(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11872>>3]=1.0;i=i;return}function Jla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11880>>3]=.018015268;i=i;return}function Kla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11888>>3]=461.5236365065454;i=i;return}function Lla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11896>>3]=1.0;i=i;return}function Mla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11904>>3]=.018015268;i=i;return}function Nla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11912>>3]=461.5236365065454;i=i;return}function Ola(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11920>>3]=1.0;i=i;return}function Pla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11928>>3]=.018015268;i=i;return}function Qla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11936>>3]=461.5236365065454;i=i;return}function Rla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11944>>3]=1.0;i=i;return}function Sla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11952>>3]=.018015268;i=i;return}function Tla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11960>>3]=461.5236365065454;i=i;return}function Ula(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11968>>3]=1.0;i=i;return}function Vla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11976>>3]=.018015268;i=i;return}function Wla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11984>>3]=461.5236365065454;i=i;return}function Xla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11992>>3]=1.0;i=i;return}function Yla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12e3>>3]=.018015268;i=i;return}function Zla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12008>>3]=461.5236365065454;i=i;return}function _la(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12016>>3]=1.0;i=i;return}function $la(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12024>>3]=.018015268;i=i;return}function ama(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12032>>3]=461.5236365065454;i=i;return}function bma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12040>>3]=1.0;i=i;return}function cma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12048>>3]=.018015268;i=i;return}function dma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12056>>3]=461.5236365065454;i=i;return}function ema(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12064>>3]=1.0;i=i;return}function fma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12072>>3]=.018015268;i=i;return}function gma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12080>>3]=461.5236365065454;i=i;return}function hma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12088>>3]=1.0;i=i;return}function ima(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12096>>3]=.018015268;i=i;return}function jma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12104>>3]=461.5236365065454;i=i;return}function kma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12112>>3]=1.0;i=i;return}function lma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12120>>3]=.018015268;i=i;return}function mma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12128>>3]=461.5236365065454;i=i;return}function nma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12136>>3]=1.0;i=i;return}function oma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+164>>2]=0;i=i;return}function pma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14664>>3]=.018015268;i=i;return}function qma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14672>>3]=461.5236365065454;i=i;return}function rma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+168>>2]=1;i=i;return}function sma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12144>>3]=1.0;i=i;return}function tma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12152>>3]=1.0;i=i;return}function uma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14680>>3]=.018015268;i=i;return}function vma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14688>>3]=461.5236365065454;i=i;return}function wma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+172>>2]=1;i=i;return}function xma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12160>>3]=1.0;i=i;return}function yma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12168>>3]=1.0;i=i;return}function zma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14696>>3]=.018015268;i=i;return}function Ama(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14704>>3]=461.5236365065454;i=i;return}function Bma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+176>>2]=1;i=i;return}function Cma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12176>>3]=1.0;i=i;return}function Dma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12184>>3]=1.0;i=i;return}function Ema(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14712>>3]=.018015268;i=i;return}function Fma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14720>>3]=461.5236365065454;i=i;return}function Gma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+180>>2]=1;i=i;return}function Hma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12192>>3]=1.0;i=i;return}function Ima(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12200>>3]=1.0;i=i;return}function Jma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12560>>3]=0.0;i=i;return}function Kma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12568>>3]=0.0;i=i;return}function Lma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12576>>3]=0.0;i=i;return}function Mma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12584>>3]=0.0;i=i;return}function Nma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12592>>3]=0.0;i=i;return}function Oma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12600>>3]=0.0;i=i;return}function Pma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12608>>3]=0.0;i=i;return}function Qma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12616>>3]=0.0;i=i;return}function Rma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12624>>3]=0.0;i=i;return}function Sma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12632>>3]=0.0;i=i;return}function Tma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12640>>3]=0.0;i=i;return}function Uma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12648>>3]=0.0;i=i;return}function Vma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12656>>3]=0.0;i=i;return}function Wma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12664>>3]=0.0;i=i;return}function Xma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12672>>3]=0.0;i=i;return}function Yma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12680>>3]=0.0;i=i;return}function Zma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12688>>3]=0.0;i=i;return}function _ma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12696>>3]=0.0;i=i;return}function $ma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12704>>3]=0.0;i=i;return}function ana(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12712>>3]=0.0;i=i;return}function bna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12720>>3]=0.0;i=i;return}function cna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12728>>3]=0.0;i=i;return}function dna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12736>>3]=0.0;i=i;return}function ena(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12744>>3]=0.0;i=i;return}function fna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12752>>3]=0.0;i=i;return}function gna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12760>>3]=0.0;i=i;return}function hna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12768>>3]=0.0;i=i;return}function ina(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12776>>3]=0.0;i=i;return}function jna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12784>>3]=0.0;i=i;return}function kna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12792>>3]=0.0;i=i;return}function lna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12800>>3]=0.0;i=i;return}function mna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12808>>3]=0.0;i=i;return}function nna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12816>>3]=0.0;i=i;return}function ona(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12824>>3]=0.0;i=i;return}function pna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12832>>3]=0.0;i=i;return}function qna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12840>>3]=0.0;i=i;return}function rna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12848>>3]=0.0;i=i;return}function sna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12856>>3]=0.0;i=i;return}function tna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12864>>3]=0.0;i=i;return}function una(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12872>>3]=0.0;i=i;return}function vna(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=b;kE(d,c[a+536>>2]|0,1.0e5);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14760>>3]=+h[d>>3];i=b;return}function wna(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;XE(e,c[g>>2]|0,1.0e5,300.0,0);j=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));dF(f,j,1.0e5,300.0,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14768>>3]=+h[f>>3];i=b;return}function xna(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;XE(e,c[g>>2]|0,1.0e5,300.0,0);j=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));aF(f,j,1.0e5,300.0,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14776>>3]=+h[f>>3];i=b;return}function yna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+14776>>3];k=+h[g+14768>>3];if(k!=0.0){l=k;m=g;n=-1.0e5/l;o=j+n;p=m;q=p+14752|0;r=q;h[r>>3]=o;i=d;return}s=+qXa(c[b+536>>2]|0,k,57232,57224,+h[f>>3],(a[b+319|0]|0)!=0|0);l=s;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=-1.0e5/l;o=j+n;p=m;q=p+14752|0;r=q;h[r>>3]=o;i=d;return}function zna(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;iF(e,c[g>>2]|0,1.0e5,+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+14776>>3],0,0);a=c[g>>2]|0;k=+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+14776>>3];g=d+0|0;l=e+0|0;e=g+120|0;do{c[g>>2]=c[l>>2];g=g+4|0;l=l+4|0}while((g|0)<(e|0));gF(f,a,1.0e5,k,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12376>>3]=+h[f>>3];i=b;return}function Ana(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;iF(e,c[g>>2]|0,1.0e5,+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+14776>>3],0,0);a=c[g>>2]|0;k=+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+14776>>3];g=d+0|0;l=e+0|0;e=g+120|0;do{c[g>>2]=c[l>>2];g=g+4|0;l=l+4|0}while((g|0)<(e|0));_E(f,a,1.0e5,k,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12208>>3]=+h[f>>3];i=b;return}function Bna(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12376>>3],+h[f+12208>>3],1.0e5,0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11008>>3]=+h[d>>3];i=b;return}function Cna(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=b;kE(d,c[a+536>>2]|0,1.0e5);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14784>>3]=+h[d>>3];i=b;return}function Dna(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;XE(e,c[g>>2]|0,1.0e5,280.0,0);j=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));dF(f,j,1.0e5,280.0,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14792>>3]=+h[f>>3];i=b;return}function Ena(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;XE(e,c[g>>2]|0,1.0e5,280.0,0);j=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));aF(f,j,1.0e5,280.0,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14800>>3]=+h[f>>3];i=b;return}function Fna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+14800>>3];k=+h[g+14792>>3];if(k!=0.0){l=k;m=g;n=-1.0e5/l;o=j+n;p=m;q=p+14744|0;r=q;h[r>>3]=o;i=d;return}s=+qXa(c[b+536>>2]|0,k,57264,57256,+h[f>>3],(a[b+319|0]|0)!=0|0);l=s;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=-1.0e5/l;o=j+n;p=m;q=p+14744|0;r=q;h[r>>3]=o;i=d;return}function Gna(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;iF(e,c[g>>2]|0,1.0e5,+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+14800>>3],0,0);a=c[g>>2]|0;k=+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+14800>>3];g=d+0|0;l=e+0|0;e=g+120|0;do{c[g>>2]=c[l>>2];g=g+4|0;l=l+4|0}while((g|0)<(e|0));gF(f,a,1.0e5,k,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12392>>3]=+h[f>>3];i=b;return}function Hna(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;iF(e,c[g>>2]|0,1.0e5,+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+14800>>3],0,0);a=c[g>>2]|0;k=+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+14800>>3];g=d+0|0;l=e+0|0;e=g+120|0;do{c[g>>2]=c[l>>2];g=g+4|0;l=l+4|0}while((g|0)<(e|0));_E(f,a,1.0e5,k,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12384>>3]=+h[f>>3];i=b;return}function Ina(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12392>>3],+h[f+12384>>3],1.0e5,0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11016>>3]=+h[d>>3];i=b;return}function Jna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14808>>3]=26.85000000000002;i=i;return}function Kna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14816>>3]=86.85000000000002;i=i;return}function Lna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14824>>3]=26.85000000000002;i=i;return}function Mna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14832>>3]=1.0;i=i;return}function Nna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14840>>3]=6.850000000000023;i=i;return}function Ona(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14848>>3]=1.0;i=i;return}function Pna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13184>>3]=0.0;i=i;return}function Qna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13192>>3]=0.0;i=i;return}function Rna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13200>>3]=0.0;i=i;return}function Sna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13208>>3]=0.0;i=i;return}function Tna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13216>>3]=0.0;i=i;return}function Una(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13224>>3]=0.0;i=i;return}function Vna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13232>>3]=0.0;i=i;return}function Wna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13240>>3]=0.0;i=i;return}function Xna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13248>>3]=0.0;i=i;return}function Yna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13256>>3]=0.0;i=i;return}function Zna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13264>>3]=0.0;i=i;return}function _na(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13272>>3]=0.0;i=i;return}function $na(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13280>>3]=0.0;i=i;return}function aoa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13288>>3]=0.0;i=i;return}function boa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13296>>3]=0.0;i=i;return}function coa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13304>>3]=0.0;i=i;return}function doa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13312>>3]=0.0;i=i;return}function eoa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13320>>3]=0.0;i=i;return}function foa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13328>>3]=0.0;i=i;return}function goa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13336>>3]=0.0;i=i;return}function hoa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14856>>3]=3.66;i=i;return}function ioa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13664>>3]=0.0;i=i;return}function joa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13672>>3]=0.0;i=i;return}function koa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13680>>3]=0.0;i=i;return}function loa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13688>>3]=0.0;i=i;return}function moa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13696>>3]=0.0;i=i;return}function noa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13704>>3]=0.0;i=i;return}function ooa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13712>>3]=0.0;i=i;return}function poa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13720>>3]=0.0;i=i;return}function qoa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13728>>3]=0.0;i=i;return}function roa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13736>>3]=0.0;i=i;return}function soa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13744>>3]=0.0;i=i;return}function toa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13752>>3]=0.0;i=i;return}function uoa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13760>>3]=0.0;i=i;return}function voa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13768>>3]=0.0;i=i;return}function woa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13776>>3]=0.0;i=i;return}function xoa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13784>>3]=0.0;i=i;return}function yoa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13792>>3]=0.0;i=i;return}function zoa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13800>>3]=0.0;i=i;return}function Aoa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13808>>3]=0.0;i=i;return}function Boa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13816>>3]=0.0;i=i;return}function Coa(a){a=a|0;c[c[(c[c[a+4>>2]>>2]|0)+12>>2]>>2]=1;i=i;return}function Doa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+4>>2]=1;i=i;return}function Eoa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+8>>2]=1;i=i;return}function Foa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+12>>2]=1;i=i;return}function Goa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+16>>2]=1;i=i;return}function Hoa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+20>>2]=1;i=i;return}function Ioa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+24>>2]=1;i=i;return}function Joa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+28>>2]=1;i=i;return}function Koa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+32>>2]=1;i=i;return}function Loa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+36>>2]=1;i=i;return}function Moa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+40>>2]=1;i=i;return}function Noa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+44>>2]=1;i=i;return}function Ooa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+48>>2]=1;i=i;return}function Poa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+52>>2]=1;i=i;return}function Qoa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+56>>2]=1;i=i;return}function Roa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+60>>2]=1;i=i;return}function Soa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+64>>2]=1;i=i;return}function Toa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+68>>2]=1;i=i;return}function Uoa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+72>>2]=1;i=i;return}function Voa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+76>>2]=1;i=i;return}function Woa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+184>>2]=0;i=i;return}function Xoa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13824>>3]=0.0;i=i;return}function Yoa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13832>>3]=0.0;i=i;return}function Zoa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13840>>3]=0.0;i=i;return}function _oa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13848>>3]=0.0;i=i;return}function $oa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13856>>3]=0.0;i=i;return}function apa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13864>>3]=0.0;i=i;return}function bpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13872>>3]=0.0;i=i;return}function cpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13880>>3]=0.0;i=i;return}function dpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13888>>3]=0.0;i=i;return}function epa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13896>>3]=0.0;i=i;return}function fpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13904>>3]=0.0;i=i;return}function gpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13912>>3]=0.0;i=i;return}function hpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13920>>3]=0.0;i=i;return}function ipa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13928>>3]=0.0;i=i;return}function jpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13936>>3]=0.0;i=i;return}function kpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13944>>3]=0.0;i=i;return}function lpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13952>>3]=0.0;i=i;return}function mpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13960>>3]=0.0;i=i;return}function npa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13968>>3]=0.0;i=i;return}function opa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13976>>3]=0.0;i=i;return}function ppa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14304>>3]=0.0;i=i;return}function qpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14312>>3]=0.0;i=i;return}function rpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14320>>3]=0.0;i=i;return}function spa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14328>>3]=0.0;i=i;return}function tpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14336>>3]=0.0;i=i;return}function upa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14344>>3]=0.0;i=i;return}function vpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14352>>3]=0.0;i=i;return}function wpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14360>>3]=0.0;i=i;return}function xpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14368>>3]=0.0;i=i;return}function ypa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14376>>3]=0.0;i=i;return}function zpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14384>>3]=0.0;i=i;return}function Apa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14392>>3]=0.0;i=i;return}function Bpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14400>>3]=0.0;i=i;return}function Cpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14408>>3]=0.0;i=i;return}function Dpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14416>>3]=0.0;i=i;return}function Epa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14424>>3]=0.0;i=i;return}function Fpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14432>>3]=0.0;i=i;return}function Gpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14440>>3]=0.0;i=i;return}function Hpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14448>>3]=0.0;i=i;return}function Ipa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14456>>3]=0.0;i=i;return}function Jpa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+188>>2]=0;i=i;return}function Kpa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+80>>2]=1;i=i;return}function Lpa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+84>>2]=1;i=i;return}function Mpa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+88>>2]=1;i=i;return}function Npa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+92>>2]=1;i=i;return}function Opa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+96>>2]=1;i=i;return}function Ppa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+100>>2]=1;i=i;return}function Qpa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+104>>2]=1;i=i;return}function Rpa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+108>>2]=1;i=i;return}function Spa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+112>>2]=1;i=i;return}function Tpa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+116>>2]=1;i=i;return}function Upa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+120>>2]=1;i=i;return}function Vpa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+124>>2]=1;i=i;return}function Wpa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+128>>2]=1;i=i;return}function Xpa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+132>>2]=1;i=i;return}function Ypa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+136>>2]=1;i=i;return}function Zpa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+140>>2]=1;i=i;return}function _pa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+144>>2]=1;i=i;return}function $pa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+148>>2]=1;i=i;return}function aqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+152>>2]=1;i=i;return}function bqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+156>>2]=1;i=i;return}function cqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14864>>3]=280.0;i=i;return}function dqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14872>>3]=300.0;i=i;return}function eqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14880>>3]=360.0;i=i;return}function fqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14888>>3]=300.0;i=i;return}function gqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14896>>3]=.5;i=i;return}function hqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14904>>3]=1.0e5;i=i;return}function iqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14912>>3]=1.0e5;i=i;return}function jqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2672>>3]=+h[b+2520>>3];i=i;return}function kqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2680>>3]=(+h[b+2472>>3]+ +h[b+2480>>3])*.5;i=i;return}function lqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2688>>3]=+h[b+2544>>3];i=i;return}function mqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2696>>3]=+h[b+2536>>3];i=i;return}function nqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2704>>3]=+h[b+2528>>3];i=i;return}function oqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2712>>3]=+h[b+2552>>3];i=i;return}function pqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2720>>3]=+h[b+2560>>3];i=i;return}function qqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b>>3]=+h[b+2688>>3]*+h[b+2680>>3]*+h[b+2672>>3]*.05;i=i;return}function rqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8>>3]=+h[b+2688>>3]*+h[b+2680>>3]*+h[b+2672>>3]*.05;i=i;return}function sqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16>>3]=+h[b+2688>>3]*+h[b+2680>>3]*+h[b+2672>>3]*.05;i=i;return}function tqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24>>3]=+h[b+2688>>3]*+h[b+2680>>3]*+h[b+2672>>3]*.05;i=i;return}function uqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+32>>3]=+h[b+2688>>3]*+h[b+2680>>3]*+h[b+2672>>3]*.05;i=i;return}function vqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40>>3]=+h[b+2688>>3]*+h[b+2680>>3]*+h[b+2672>>3]*.05;i=i;return}function wqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+48>>3]=+h[b+2688>>3]*+h[b+2680>>3]*+h[b+2672>>3]*.05;i=i;return}function xqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+56>>3]=+h[b+2688>>3]*+h[b+2680>>3]*+h[b+2672>>3]*.05;i=i;return}function yqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+64>>3]=+h[b+2688>>3]*+h[b+2680>>3]*+h[b+2672>>3]*.05;i=i;return}function zqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+72>>3]=+h[b+2688>>3]*+h[b+2680>>3]*+h[b+2672>>3]*.05;i=i;return}function Aqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+80>>3]=+h[b+2688>>3]*+h[b+2680>>3]*+h[b+2672>>3]*.05;i=i;return}function Bqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+88>>3]=+h[b+2688>>3]*+h[b+2680>>3]*+h[b+2672>>3]*.05;i=i;return}function Cqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+96>>3]=+h[b+2688>>3]*+h[b+2680>>3]*+h[b+2672>>3]*.05;i=i;return}function Dqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+104>>3]=+h[b+2688>>3]*+h[b+2680>>3]*+h[b+2672>>3]*.05;i=i;return}function Eqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+112>>3]=+h[b+2688>>3]*+h[b+2680>>3]*+h[b+2672>>3]*.05;i=i;return}function Fqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+120>>3]=+h[b+2688>>3]*+h[b+2680>>3]*+h[b+2672>>3]*.05;i=i;return}function Gqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+128>>3]=+h[b+2688>>3]*+h[b+2680>>3]*+h[b+2672>>3]*.05;i=i;return}function Hqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+136>>3]=+h[b+2688>>3]*+h[b+2680>>3]*+h[b+2672>>3]*.05;i=i;return}function Iqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+144>>3]=+h[b+2688>>3]*+h[b+2680>>3]*+h[b+2672>>3]*.05;i=i;return}function Jqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+152>>3]=+h[b+2688>>3]*+h[b+2680>>3]*+h[b+2672>>3]*.05;i=i;return}function Kqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2744>>3]=+h[b+2464>>3];i=i;return}function Lqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2760>>3]=+h[b+2600>>3];i=i;return}function Mqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2808>>3]=+h[b+2472>>3];i=i;return}function Nqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2816>>3]=+h[b+2488>>3];i=i;return}function Oqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+176>>3]=+h[b+160>>3];i=i;return}function Pqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2840>>3]=+h[b+2736>>3];i=i;return}function Qqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2888>>3]=+h[b+3336>>3];i=i;return}function Rqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2904>>3]=+h[b+3312>>3];i=i;return}function Sqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+344>>3]=+h[b+2744>>3]*.05;i=i;return}function Tqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13504>>3]=+h[b+344>>3]*+h[b+2816>>3];i=i;return}function Uqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+352>>3]=+h[b+2744>>3]*.05;i=i;return}function Vqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13512>>3]=+h[b+352>>3]*+h[b+2816>>3];i=i;return}function Wqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+360>>3]=+h[b+2744>>3]*.05;i=i;return}function Xqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13520>>3]=+h[b+360>>3]*+h[b+2816>>3];i=i;return}function Yqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+368>>3]=+h[b+2744>>3]*.05;i=i;return}function Zqa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13528>>3]=+h[b+368>>3]*+h[b+2816>>3];i=i;return}function _qa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+376>>3]=+h[b+2744>>3]*.05;i=i;return}function $qa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13536>>3]=+h[b+376>>3]*+h[b+2816>>3];i=i;return}function ara(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+384>>3]=+h[b+2744>>3]*.05;i=i;return}function bra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13544>>3]=+h[b+384>>3]*+h[b+2816>>3];i=i;return}function cra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+392>>3]=+h[b+2744>>3]*.05;i=i;return}function dra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13552>>3]=+h[b+392>>3]*+h[b+2816>>3];i=i;return}function era(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+400>>3]=+h[b+2744>>3]*.05;i=i;return}function fra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13560>>3]=+h[b+400>>3]*+h[b+2816>>3];i=i;return}function gra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+408>>3]=+h[b+2744>>3]*.05;i=i;return}function hra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13568>>3]=+h[b+408>>3]*+h[b+2816>>3];i=i;return}function ira(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+416>>3]=+h[b+2744>>3]*.05;i=i;return}function jra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13576>>3]=+h[b+416>>3]*+h[b+2816>>3];i=i;return}function kra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+424>>3]=+h[b+2744>>3]*.05;i=i;return}function lra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13584>>3]=+h[b+424>>3]*+h[b+2816>>3];i=i;return}function mra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+432>>3]=+h[b+2744>>3]*.05;i=i;return}function nra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13592>>3]=+h[b+432>>3]*+h[b+2816>>3];i=i;return}function ora(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+440>>3]=+h[b+2744>>3]*.05;i=i;return}function pra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13600>>3]=+h[b+440>>3]*+h[b+2816>>3];i=i;return}function qra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+448>>3]=+h[b+2744>>3]*.05;i=i;return}function rra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13608>>3]=+h[b+448>>3]*+h[b+2816>>3];i=i;return}function sra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+456>>3]=+h[b+2744>>3]*.05;i=i;return}function tra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13616>>3]=+h[b+456>>3]*+h[b+2816>>3];i=i;return}function ura(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+464>>3]=+h[b+2744>>3]*.05;i=i;return}function vra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13624>>3]=+h[b+464>>3]*+h[b+2816>>3];i=i;return}function wra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+472>>3]=+h[b+2744>>3]*.05;i=i;return}function xra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13632>>3]=+h[b+472>>3]*+h[b+2816>>3];i=i;return}function yra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+480>>3]=+h[b+2744>>3]*.05;i=i;return}function zra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13640>>3]=+h[b+480>>3]*+h[b+2816>>3];i=i;return}function Ara(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+488>>3]=+h[b+2744>>3]*.05;i=i;return}function Bra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13648>>3]=+h[b+488>>3]*+h[b+2816>>3];i=i;return}function Cra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+496>>3]=+h[b+2744>>3]*.05;i=i;return}function Dra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13656>>3]=+h[b+496>>3]*+h[b+2816>>3];i=i;return}function Era(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+504>>3]=+h[b+2808>>3];i=i;return}function Fra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13344>>3]=+h[b+504>>3]*+h[b+344>>3]*+h[b+2736>>3];i=i;return}function Gra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+512>>3]=+h[b+2808>>3];i=i;return}function Hra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13352>>3]=+h[b+512>>3]*+h[b+352>>3]*+h[b+2736>>3];i=i;return}function Ira(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+520>>3]=+h[b+2808>>3];i=i;return}function Jra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13360>>3]=+h[b+520>>3]*+h[b+360>>3]*+h[b+2736>>3];i=i;return}function Kra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+528>>3]=+h[b+2808>>3];i=i;return}function Lra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13368>>3]=+h[b+528>>3]*+h[b+368>>3]*+h[b+2736>>3];i=i;return}function Mra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+536>>3]=+h[b+2808>>3];i=i;return}function Nra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13376>>3]=+h[b+536>>3]*+h[b+376>>3]*+h[b+2736>>3];i=i;return}function Ora(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+544>>3]=+h[b+2808>>3];i=i;return}function Pra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13384>>3]=+h[b+544>>3]*+h[b+384>>3]*+h[b+2736>>3];i=i;return}function Qra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+552>>3]=+h[b+2808>>3];i=i;return}function Rra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13392>>3]=+h[b+552>>3]*+h[b+392>>3]*+h[b+2736>>3];i=i;return}function Sra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+560>>3]=+h[b+2808>>3];i=i;return}function Tra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13400>>3]=+h[b+560>>3]*+h[b+400>>3]*+h[b+2736>>3];i=i;return}function Ura(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+568>>3]=+h[b+2808>>3];i=i;return}function Vra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13408>>3]=+h[b+568>>3]*+h[b+408>>3]*+h[b+2736>>3];i=i;return}function Wra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+576>>3]=+h[b+2808>>3];i=i;return}function Xra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13416>>3]=+h[b+576>>3]*+h[b+416>>3]*+h[b+2736>>3];i=i;return}function Yra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+584>>3]=+h[b+2808>>3];i=i;return}function Zra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13424>>3]=+h[b+584>>3]*+h[b+424>>3]*+h[b+2736>>3];i=i;return}function _ra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+592>>3]=+h[b+2808>>3];i=i;return}function $ra(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13432>>3]=+h[b+592>>3]*+h[b+432>>3]*+h[b+2736>>3];i=i;return}function asa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+600>>3]=+h[b+2808>>3];i=i;return}function bsa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13440>>3]=+h[b+600>>3]*+h[b+440>>3]*+h[b+2736>>3];i=i;return}function csa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+608>>3]=+h[b+2808>>3];i=i;return}function dsa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13448>>3]=+h[b+608>>3]*+h[b+448>>3]*+h[b+2736>>3];i=i;return}function esa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+616>>3]=+h[b+2808>>3];i=i;return}function fsa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13456>>3]=+h[b+616>>3]*+h[b+456>>3]*+h[b+2736>>3];i=i;return}function gsa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+624>>3]=+h[b+2808>>3];i=i;return}function hsa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13464>>3]=+h[b+624>>3]*+h[b+464>>3]*+h[b+2736>>3];i=i;return}function isa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+632>>3]=+h[b+2808>>3];i=i;return}function jsa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13472>>3]=+h[b+632>>3]*+h[b+472>>3]*+h[b+2736>>3];i=i;return}function ksa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+640>>3]=+h[b+2808>>3];i=i;return}function lsa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13480>>3]=+h[b+640>>3]*+h[b+480>>3]*+h[b+2736>>3];i=i;return}function msa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+648>>3]=+h[b+2808>>3];i=i;return}function nsa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13488>>3]=+h[b+648>>3]*+h[b+488>>3]*+h[b+2736>>3];i=i;return}function osa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+656>>3]=+h[b+2808>>3];i=i;return}function psa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13496>>3]=+h[b+656>>3]*+h[b+496>>3]*+h[b+2736>>3];i=i;return}function qsa(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2816>>3];j=+h[f+2808>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,57296,57288,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+664>>3]=l*4.0;i=d;return}function rsa(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2816>>3];j=+h[f+2808>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,57296,57320,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+672>>3]=l*4.0;i=d;return}function ssa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13176>>3]=(+h[b+664>>3]+ +h[b+672>>3])*.5;i=i;return}function tsa(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2816>>3];j=+h[f+2808>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,57296,57328,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+680>>3]=l*4.0;i=d;return}function usa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13168>>3]=(+h[b+672>>3]+ +h[b+680>>3])*.5;i=i;return}function vsa(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2816>>3];j=+h[f+2808>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,57296,57336,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+688>>3]=l*4.0;i=d;return}function wsa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13160>>3]=(+h[b+680>>3]+ +h[b+688>>3])*.5;i=i;return}function xsa(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2816>>3];j=+h[f+2808>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,57296,57344,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+696>>3]=l*4.0;i=d;return}function ysa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13152>>3]=(+h[b+688>>3]+ +h[b+696>>3])*.5;i=i;return}function zsa(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2816>>3];j=+h[f+2808>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,57296,57352,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+704>>3]=l*4.0;i=d;return}function Asa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13144>>3]=(+h[b+696>>3]+ +h[b+704>>3])*.5;i=i;return}function Bsa(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2816>>3];j=+h[f+2808>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,57296,57360,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+712>>3]=l*4.0;i=d;return}function Csa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13136>>3]=(+h[b+704>>3]+ +h[b+712>>3])*.5;i=i;return}function Dsa(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2816>>3];j=+h[f+2808>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,57296,57368,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+720>>3]=l*4.0;i=d;return}function Esa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13128>>3]=(+h[b+712>>3]+ +h[b+720>>3])*.5;i=i;return}function Fsa(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2816>>3];j=+h[f+2808>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,57296,57376,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+728>>3]=l*4.0;i=d;return}function Gsa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13120>>3]=(+h[b+720>>3]+ +h[b+728>>3])*.5;i=i;return}function Hsa(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2816>>3];j=+h[f+2808>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,57296,57384,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+736>>3]=l*4.0;i=d;return}function Isa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13112>>3]=(+h[b+728>>3]+ +h[b+736>>3])*.5;i=i;return}function Jsa(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2816>>3];j=+h[f+2808>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,57296,57392,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+744>>3]=l*4.0;i=d;return}function Ksa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13104>>3]=(+h[b+736>>3]+ +h[b+744>>3])*.5;i=i;return}function Lsa(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2816>>3];j=+h[f+2808>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,57296,57400,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+752>>3]=l*4.0;i=d;return}function Msa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13096>>3]=(+h[b+744>>3]+ +h[b+752>>3])*.5;i=i;return}function Nsa(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2816>>3];j=+h[f+2808>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,57296,57408,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+760>>3]=l*4.0;i=d;return}function Osa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13088>>3]=(+h[b+752>>3]+ +h[b+760>>3])*.5;i=i;return}function Psa(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2816>>3];j=+h[f+2808>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,57296,57416,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+768>>3]=l*4.0;i=d;return}function Qsa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13080>>3]=(+h[b+760>>3]+ +h[b+768>>3])*.5;i=i;return}function Rsa(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2816>>3];j=+h[f+2808>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,57296,57424,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+776>>3]=l*4.0;i=d;return}function Ssa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13072>>3]=(+h[b+768>>3]+ +h[b+776>>3])*.5;i=i;return}function Tsa(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2816>>3];j=+h[f+2808>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,57296,57432,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+784>>3]=l*4.0;i=d;return}function Usa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13064>>3]=(+h[b+776>>3]+ +h[b+784>>3])*.5;i=i;return}function Vsa(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2816>>3];j=+h[f+2808>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,57296,57440,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+792>>3]=l*4.0;i=d;return}function Wsa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13056>>3]=(+h[b+784>>3]+ +h[b+792>>3])*.5;i=i;return}function Xsa(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2816>>3];j=+h[f+2808>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,57296,57448,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+800>>3]=l*4.0;i=d;return}function Ysa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13048>>3]=(+h[b+792>>3]+ +h[b+800>>3])*.5;i=i;return}function Zsa(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2816>>3];j=+h[f+2808>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,57296,57456,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+808>>3]=l*4.0;i=d;return}function _sa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13040>>3]=(+h[b+800>>3]+ +h[b+808>>3])*.5;i=i;return}function $sa(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2816>>3];j=+h[f+2808>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,57296,57464,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+816>>3]=l*4.0;i=d;return}function ata(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13032>>3]=(+h[b+808>>3]+ +h[b+816>>3])*.5;i=i;return}function bta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+824>>3]=+h[b+2760>>3];i=i;return}function cta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+832>>3]=+h[b+2760>>3];i=i;return}function dta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+840>>3]=+h[b+2760>>3];i=i;return}function eta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+848>>3]=+h[b+2760>>3];i=i;return}function fta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+856>>3]=+h[b+2760>>3];i=i;return}function gta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+864>>3]=+h[b+2760>>3];i=i;return}function hta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+872>>3]=+h[b+2760>>3];i=i;return}function ita(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+880>>3]=+h[b+2760>>3];i=i;return}function jta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+888>>3]=+h[b+2760>>3];i=i;return}function kta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+896>>3]=+h[b+2760>>3];i=i;return}function lta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+904>>3]=+h[b+2760>>3];i=i;return}function mta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+912>>3]=+h[b+2760>>3];i=i;return}function nta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+920>>3]=+h[b+2760>>3];i=i;return}function ota(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+928>>3]=+h[b+2760>>3];i=i;return}function pta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+936>>3]=+h[b+2760>>3];i=i;return}function qta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+944>>3]=+h[b+2760>>3];i=i;return}function rta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+952>>3]=+h[b+2760>>3];i=i;return}function sta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+960>>3]=+h[b+2760>>3];i=i;return}function tta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+968>>3]=+h[b+2760>>3];i=i;return}function uta(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+976>>3]=+h[b+2760>>3];i=i;return}function _Modelica_Fluid_Examples_HeatExchanger_HeatExchangerSimulation_updateBoundVariableAttributes$0(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0.0,va=0;b=c[a+24>>2]|0;d=c[a+2256>>2]|0;e=c[a+2264>>2]|0;f=c[a+2272>>2]|0;g=c[a+2280>>2]|0;j=c[a+2288>>2]|0;l=c[a+2296>>2]|0;m=c[a+2312>>2]|0;n=c[a+2320>>2]|0;o=c[a+2328>>2]|0;p=c[a+2336>>2]|0;q=c[a+2344>>2]|0;r=c[a+2352>>2]|0;s=c[a+2360>>2]|0;t=c[a+2368>>2]|0;u=c[a+2376>>2]|0;v=c[a+2384>>2]|0;w=c[a+2400>>2]|0;x=c[a+2408>>2]|0;y=c[a+2416>>2]|0;z=c[a+2424>>2]|0;A=c[a+2432>>2]|0;B=c[a+2440>>2]|0;C=c[a+2448>>2]|0;D=c[a+2456>>2]|0;E=c[a+2464>>2]|0;F=c[a+2472>>2]|0;G=c[a+2488>>2]|0;H=c[a+2496>>2]|0;I=c[a+2512>>2]|0;J=c[a+2520>>2]|0;K=c[a+2528>>2]|0;L=c[a+2536>>2]|0;M=c[a+2544>>2]|0;N=c[a+2552>>2]|0;O=c[a+2560>>2]|0;P=c[a+2568>>2]|0;Q=c[a+2584>>2]|0;R=c[a+2592>>2]|0;S=c[a+2600>>2]|0;T=c[a+2608>>2]|0;U=c[a+2616>>2]|0;V=c[a+2624>>2]|0;W=c[a+2632>>2]|0;X=c[a+2640>>2]|0;Y=c[a+2648>>2]|0;Z=c[a+2656>>2]|0;_=c[a+2672>>2]|0;$=c[a+2680>>2]|0;aa=c[a+2688>>2]|0;ba=c[a+2696>>2]|0;ca=c[a+2704>>2]|0;da=c[a+2712>>2]|0;ea=c[a+2720>>2]|0;fa=c[a+2728>>2]|0;ga=c[a+2736>>2]|0;ha=c[a+2744>>2]|0;ia=c[a+2760>>2]|0;ja=c[a+2768>>2]|0;ka=c[a+2776>>2]|0;la=c[a+2784>>2]|0;ma=c[a+2792>>2]|0;na=c[a+2800>>2]|0;oa=c[a+2808>>2]|0;pa=c[a+2816>>2]|0;qa=c[a+2824>>2]|0;ra=c[a+2832>>2]|0;sa=c[a+2848>>2]|0;ta=c[a+2856>>2]|0;a:do{c[(d+4|0)>>2]=c[k>>2];c[(d+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,d);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+7096>>3];va=c[(b+8|0)>>2]|0;h[va+99440>>3]=ua;c[e>>2]=c[va+99348>>2];h[k>>3]=ua;c[(e+4|0)>>2]=c[k>>2];c[(e+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,e);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+7088>>3];va=c[(b+8|0)>>2]|0;h[va+99328>>3]=ua;c[f>>2]=c[va+99236>>2];h[k>>3]=ua;c[(f+4|0)>>2]=c[k>>2];c[(f+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,f);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+7080>>3];va=c[(b+8|0)>>2]|0;h[va+99216>>3]=ua;c[g>>2]=c[va+99124>>2];h[k>>3]=ua;c[(g+4|0)>>2]=c[k>>2];c[(g+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,g);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+7072>>3];va=c[(b+8|0)>>2]|0;h[va+99104>>3]=ua;c[j>>2]=c[va+99012>>2];h[k>>3]=ua;c[(j+4|0)>>2]=c[k>>2];c[(j+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,j);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+7064>>3];va=c[(b+8|0)>>2]|0;h[va+98992>>3]=ua;c[l>>2]=c[va+98900>>2];h[k>>3]=ua;c[(l+4|0)>>2]=c[k>>2];c[(l+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,l);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+7056>>3];va=c[(b+8|0)>>2]|0;h[va+98880>>3]=ua;c[m>>2]=c[va+98788>>2];h[k>>3]=ua;c[(m+4|0)>>2]=c[k>>2];c[(m+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,m);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+7048>>3];va=c[(b+8|0)>>2]|0;h[va+98768>>3]=ua;c[n>>2]=c[va+98676>>2];h[k>>3]=ua;c[(n+4|0)>>2]=c[k>>2];c[(n+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,n);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+7040>>3];va=c[(b+8|0)>>2]|0;h[va+98656>>3]=ua;c[o>>2]=c[va+98564>>2];h[k>>3]=ua;c[(o+4|0)>>2]=c[k>>2];c[(o+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,o);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+792>>3];va=c[(b+8|0)>>2]|0;h[va+11184>>3]=ua;c[p>>2]=c[va+11092>>2];h[k>>3]=ua;c[(p+4|0)>>2]=c[k>>2];c[(p+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,p);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+784>>3];va=c[(b+8|0)>>2]|0;h[va+11072>>3]=ua;c[q>>2]=c[va+10980>>2];h[k>>3]=ua;c[(q+4|0)>>2]=c[k>>2];c[(q+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,q);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+776>>3];va=c[(b+8|0)>>2]|0;h[va+10960>>3]=ua;c[r>>2]=c[va+10868>>2];h[k>>3]=ua;c[(r+4|0)>>2]=c[k>>2];c[(r+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,r);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+768>>3];va=c[(b+8|0)>>2]|0;h[va+10848>>3]=ua;c[s>>2]=c[va+10756>>2];h[k>>3]=ua;c[(s+4|0)>>2]=c[k>>2];c[(s+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,s);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+760>>3];va=c[(b+8|0)>>2]|0;h[va+10736>>3]=ua;c[t>>2]=c[va+10644>>2];h[k>>3]=ua;c[(t+4|0)>>2]=c[k>>2];c[(t+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,t);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+752>>3];va=c[(b+8|0)>>2]|0;h[va+10624>>3]=ua;c[u>>2]=c[va+10532>>2];h[k>>3]=ua;c[(u+4|0)>>2]=c[k>>2];c[(u+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,u);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+744>>3];va=c[(b+8|0)>>2]|0;h[va+10512>>3]=ua;c[v>>2]=c[va+10420>>2];h[k>>3]=ua;c[(v+4|0)>>2]=c[k>>2];c[(v+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,v);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+736>>3];va=c[(b+8|0)>>2]|0;h[va+10400>>3]=ua;c[w>>2]=c[va+10308>>2];h[k>>3]=ua;c[(w+4|0)>>2]=c[k>>2];c[(w+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,w);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+728>>3];va=c[(b+8|0)>>2]|0;h[va+10288>>3]=ua;c[x>>2]=c[va+10196>>2];h[k>>3]=ua;c[(x+4|0)>>2]=c[k>>2];c[(x+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,x);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+720>>3];va=c[(b+8|0)>>2]|0;h[va+10176>>3]=ua;c[y>>2]=c[va+10084>>2];h[k>>3]=ua;c[(y+4|0)>>2]=c[k>>2];c[(y+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,y);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+712>>3];va=c[(b+8|0)>>2]|0;h[va+10064>>3]=ua;c[z>>2]=c[va+9972>>2];h[k>>3]=ua;c[(z+4|0)>>2]=c[k>>2];c[(z+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,z);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+704>>3];va=c[(b+8|0)>>2]|0;h[va+9952>>3]=ua;c[A>>2]=c[va+9860>>2];h[k>>3]=ua;c[(A+4|0)>>2]=c[k>>2];c[(A+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,A);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+696>>3];va=c[(b+8|0)>>2]|0;h[va+9840>>3]=ua;c[B>>2]=c[va+9748>>2];h[k>>3]=ua;c[(B+4|0)>>2]=c[k>>2];c[(B+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,B);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+688>>3];va=c[(b+8|0)>>2]|0;h[va+9728>>3]=ua;c[C>>2]=c[va+9636>>2];h[k>>3]=ua;c[(C+4|0)>>2]=c[k>>2];c[(C+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,C);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+680>>3];va=c[(b+8|0)>>2]|0;h[va+9616>>3]=ua;c[D>>2]=c[va+9524>>2];h[k>>3]=ua;c[(D+4|0)>>2]=c[k>>2];c[(D+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,D);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+672>>3];va=c[(b+8|0)>>2]|0;h[va+9504>>3]=ua;c[E>>2]=c[va+9412>>2];h[k>>3]=ua;c[(E+4|0)>>2]=c[k>>2];c[(E+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,E);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+664>>3];va=c[(b+8|0)>>2]|0;h[va+9392>>3]=ua;c[F>>2]=c[va+9300>>2];h[k>>3]=ua;c[(F+4|0)>>2]=c[k>>2];c[(F+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,F);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+656>>3];va=c[(b+8|0)>>2]|0;h[va+9280>>3]=ua;c[G>>2]=c[va+9188>>2];h[k>>3]=ua;c[(G+4|0)>>2]=c[k>>2];c[(G+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,G);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+648>>3];va=c[(b+8|0)>>2]|0;h[va+9168>>3]=ua;c[H>>2]=c[va+9076>>2];h[k>>3]=ua;c[(H+4|0)>>2]=c[k>>2];c[(H+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,H);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+640>>3];va=c[(b+8|0)>>2]|0;h[va+9056>>3]=ua;c[I>>2]=c[va+8964>>2];h[k>>3]=ua;c[(I+4|0)>>2]=c[k>>2];c[(I+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,I);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9432>>3];va=c[(b+8|0)>>2]|0;h[va+132144>>3]=ua;c[J>>2]=c[va+132052>>2];h[k>>3]=ua;c[(J+4|0)>>2]=c[k>>2];c[(J+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,J);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9424>>3];va=c[(b+8|0)>>2]|0;h[va+132032>>3]=ua;c[K>>2]=c[va+131940>>2];h[k>>3]=ua;c[(K+4|0)>>2]=c[k>>2];c[(K+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,K);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9416>>3];va=c[(b+8|0)>>2]|0;h[va+131920>>3]=ua;c[L>>2]=c[va+131828>>2];h[k>>3]=ua;c[(L+4|0)>>2]=c[k>>2];c[(L+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,L);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9408>>3];va=c[(b+8|0)>>2]|0;h[va+131808>>3]=ua;c[M>>2]=c[va+131716>>2];h[k>>3]=ua;c[(M+4|0)>>2]=c[k>>2];c[(M+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,M);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9400>>3];va=c[(b+8|0)>>2]|0;h[va+131696>>3]=ua;c[N>>2]=c[va+131604>>2];h[k>>3]=ua;c[(N+4|0)>>2]=c[k>>2];c[(N+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,N);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9392>>3];va=c[(b+8|0)>>2]|0;h[va+131584>>3]=ua;c[O>>2]=c[va+131492>>2];h[k>>3]=ua;c[(O+4|0)>>2]=c[k>>2];c[(O+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,O);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9384>>3];va=c[(b+8|0)>>2]|0;h[va+131472>>3]=ua;c[P>>2]=c[va+131380>>2];h[k>>3]=ua;c[(P+4|0)>>2]=c[k>>2];c[(P+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,P);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9376>>3];va=c[(b+8|0)>>2]|0;h[va+131360>>3]=ua;c[Q>>2]=c[va+131268>>2];h[k>>3]=ua;c[(Q+4|0)>>2]=c[k>>2];c[(Q+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,Q);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9368>>3];va=c[(b+8|0)>>2]|0;h[va+131248>>3]=ua;c[R>>2]=c[va+131156>>2];h[k>>3]=ua;c[(R+4|0)>>2]=c[k>>2];c[(R+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,R);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9360>>3];va=c[(b+8|0)>>2]|0;h[va+131136>>3]=ua;c[S>>2]=c[va+131044>>2];h[k>>3]=ua;c[(S+4|0)>>2]=c[k>>2];c[(S+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,S);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9352>>3];va=c[(b+8|0)>>2]|0;h[va+131024>>3]=ua;c[T>>2]=c[va+130932>>2];h[k>>3]=ua;c[(T+4|0)>>2]=c[k>>2];c[(T+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,T);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9344>>3];va=c[(b+8|0)>>2]|0;h[va+130912>>3]=ua;c[U>>2]=c[va+130820>>2];h[k>>3]=ua;c[(U+4|0)>>2]=c[k>>2];c[(U+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,U);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9336>>3];va=c[(b+8|0)>>2]|0;h[va+130800>>3]=ua;c[V>>2]=c[va+130708>>2];h[k>>3]=ua;c[(V+4|0)>>2]=c[k>>2];c[(V+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,V);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9328>>3];va=c[(b+8|0)>>2]|0;h[va+130688>>3]=ua;c[W>>2]=c[va+130596>>2];h[k>>3]=ua;c[(W+4|0)>>2]=c[k>>2];c[(W+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,W);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9320>>3];va=c[(b+8|0)>>2]|0;h[va+130576>>3]=ua;c[X>>2]=c[va+130484>>2];h[k>>3]=ua;c[(X+4|0)>>2]=c[k>>2];c[(X+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,X);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9312>>3];va=c[(b+8|0)>>2]|0;h[va+130464>>3]=ua;c[Y>>2]=c[va+130372>>2];h[k>>3]=ua;c[(Y+4|0)>>2]=c[k>>2];c[(Y+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,Y);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9304>>3];va=c[(b+8|0)>>2]|0;h[va+130352>>3]=ua;c[Z>>2]=c[va+130260>>2];h[k>>3]=ua;c[(Z+4|0)>>2]=c[k>>2];c[(Z+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,Z);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9296>>3];va=c[(b+8|0)>>2]|0;h[va+130240>>3]=ua;c[_>>2]=c[va+130148>>2];h[k>>3]=ua;c[(_+4|0)>>2]=c[k>>2];c[(_+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,_);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9288>>3];va=c[(b+8|0)>>2]|0;h[va+130128>>3]=ua;c[$>>2]=c[va+130036>>2];h[k>>3]=ua;c[($+4|0)>>2]=c[k>>2];c[($+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,$);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9280>>3];va=c[(b+8|0)>>2]|0;h[va+130016>>3]=ua;c[aa>>2]=c[va+129924>>2];h[k>>3]=ua;c[(aa+4|0)>>2]=c[k>>2];c[(aa+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,aa);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9592>>3];va=c[(b+8|0)>>2]|0;h[va+134384>>3]=ua;c[ba>>2]=c[va+134292>>2];h[k>>3]=ua;c[(ba+4|0)>>2]=c[k>>2];c[(ba+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,ba);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9584>>3];va=c[(b+8|0)>>2]|0;h[va+134272>>3]=ua;c[ca>>2]=c[va+134180>>2];h[k>>3]=ua;c[(ca+4|0)>>2]=c[k>>2];c[(ca+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,ca);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9576>>3];va=c[(b+8|0)>>2]|0;h[va+134160>>3]=ua;c[da>>2]=c[va+134068>>2];h[k>>3]=ua;c[(da+4|0)>>2]=c[k>>2];c[(da+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,da);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9568>>3];va=c[(b+8|0)>>2]|0;h[va+134048>>3]=ua;c[ea>>2]=c[va+133956>>2];h[k>>3]=ua;c[(ea+4|0)>>2]=c[k>>2];c[(ea+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,ea);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9560>>3];va=c[(b+8|0)>>2]|0;h[va+133936>>3]=ua;c[fa>>2]=c[va+133844>>2];h[k>>3]=ua;c[(fa+4|0)>>2]=c[k>>2];c[(fa+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,fa);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9552>>3];va=c[(b+8|0)>>2]|0;h[va+133824>>3]=ua;c[ga>>2]=c[va+133732>>2];h[k>>3]=ua;c[(ga+4|0)>>2]=c[k>>2];c[(ga+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,ga);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9544>>3];va=c[(b+8|0)>>2]|0;h[va+133712>>3]=ua;c[ha>>2]=c[va+133620>>2];h[k>>3]=ua;c[(ha+4|0)>>2]=c[k>>2];c[(ha+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,ha);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9536>>3];va=c[(b+8|0)>>2]|0;h[va+133600>>3]=ua;c[ia>>2]=c[va+133508>>2];h[k>>3]=ua;c[(ia+4|0)>>2]=c[k>>2];c[(ia+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,ia);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9528>>3];va=c[(b+8|0)>>2]|0;h[va+133488>>3]=ua;c[ja>>2]=c[va+133396>>2];h[k>>3]=ua;c[(ja+4|0)>>2]=c[k>>2];c[(ja+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,ja);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9520>>3];va=c[(b+8|0)>>2]|0;h[va+133376>>3]=ua;c[ka>>2]=c[va+133284>>2];h[k>>3]=ua;c[(ka+4|0)>>2]=c[k>>2];c[(ka+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,ka);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9512>>3];va=c[(b+8|0)>>2]|0;h[va+133264>>3]=ua;c[la>>2]=c[va+133172>>2];h[k>>3]=ua;c[(la+4|0)>>2]=c[k>>2];c[(la+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,la);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9504>>3];va=c[(b+8|0)>>2]|0;h[va+133152>>3]=ua;c[ma>>2]=c[va+133060>>2];h[k>>3]=ua;c[(ma+4|0)>>2]=c[k>>2];c[(ma+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,ma);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9496>>3];va=c[(b+8|0)>>2]|0;h[va+133040>>3]=ua;c[na>>2]=c[va+132948>>2];h[k>>3]=ua;c[(na+4|0)>>2]=c[k>>2];c[(na+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,na);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9488>>3];va=c[(b+8|0)>>2]|0;h[va+132928>>3]=ua;c[oa>>2]=c[va+132836>>2];h[k>>3]=ua;c[(oa+4|0)>>2]=c[k>>2];c[(oa+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,oa);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9480>>3];va=c[(b+8|0)>>2]|0;h[va+132816>>3]=ua;c[pa>>2]=c[va+132724>>2];h[k>>3]=ua;c[(pa+4|0)>>2]=c[k>>2];c[(pa+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,pa);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9472>>3];va=c[(b+8|0)>>2]|0;h[va+132704>>3]=ua;c[qa>>2]=c[va+132612>>2];h[k>>3]=ua;c[(qa+4|0)>>2]=c[k>>2];c[(qa+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,qa);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9464>>3];va=c[(b+8|0)>>2]|0;h[va+132592>>3]=ua;c[ra>>2]=c[va+132500>>2];h[k>>3]=ua;c[(ra+4|0)>>2]=c[k>>2];c[(ra+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,ra);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9456>>3];va=c[(b+8|0)>>2]|0;h[va+132480>>3]=ua;c[sa>>2]=c[va+132388>>2];h[k>>3]=ua;c[(sa+4|0)>>2]=c[k>>2];c[(sa+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,sa);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9448>>3];va=c[(b+8|0)>>2]|0;h[va+132368>>3]=ua;c[ta>>2]=c[va+132276>>2];h[k>>3]=ua;c[(ta+4|0)>>2]=c[k>>2];c[(ta+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,ta);ua=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9440>>3];va=c[(b+8|0)>>2]|0;h[va+132256>>3]=ua;c[a>>2]=c[va+132164>>2];h[k>>3]=ua;c[(a+4|0)>>2]=c[k>>2];c[(a+4|0)+4>>2]=c[k+4>>2];kXa(9,0,57208,a);if((c[240116>>2]|0)==0){i=a;c[a+2944>>2]=6;c[a+2948>>2]=0;break a}me[c[60158]&2047](9);i=a;c[a+2944>>2]=6;c[a+2948>>2]=0;break a}while(0)}



function C4a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+32|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;Lfb(h,283584);Hfb(g,w4a(b,h)|0);s=d+13|0;A4a(g,s);Rfb(g);Rfb(h);Lfb(k,283600);Hfb(j,w4a(b,k)|0);h=d+16|0;y4a(j,h,0);Rfb(j);Rfb(k);Lfb(m,283608);Hfb(l,w4a(b,m)|0);k=d+12|0;A4a(l,k);Rfb(l);Rfb(m);Lfb(o,283640);Hfb(n,w4a(b,o)|0);m=d+4|0;y4a(n,m,-2147483648);Rfb(n);Rfb(o);Lfb(q,283648);Hfb(p,w4a(b,q)|0);o=d+8|0;y4a(p,o,2147483647);Rfb(p);Rfb(q);Lfb(r,283456);q=mgb(w4a(b,r)|0)|0;b=(a[s]|0)!=0;s=c[h>>2]|0;h=(a[k]|0)!=0?283744:283752;k=c[m>>2]|0;m=c[o>>2]|0;c[f>>2]=q;c[f+4>>2]=b?283720:283728;c[f+8>>2]=s;c[f+12>>2]=b?283720:283736;c[f+16>>2]=h;c[f+20>>2]=k;c[f+24>>2]=m;kXa(4,0,283760,f);Rfb(r);i=e;return}function D4a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+24|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;Lfb(h,283584);Hfb(g,w4a(b,h)|0);o=d+5|0;A4a(g,o);Rfb(g);Rfb(h);Lfb(k,283600);Hfb(j,w4a(b,k)|0);h=d+6|0;A4a(j,h);Rfb(j);Rfb(k);Lfb(m,283608);Hfb(l,w4a(b,m)|0);k=d+4|0;A4a(l,k);Rfb(l);Rfb(m);Lfb(n,283456);m=mgb(w4a(b,n)|0)|0;b=(a[o]|0)!=0;o=(a[h]|0)!=0?283744:283752;h=(a[k]|0)!=0?283744:283752;c[f>>2]=m;c[f+4>>2]=b?283720:283728;c[f+8>>2]=o;c[f+12>>2]=b?283720:283736;c[f+16>>2]=h;kXa(4,0,283816,f);Rfb(n);i=e;return}function E4a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;Lfb(h,283584);Hfb(g,w4a(b,h)|0);m=d+4|0;A4a(g,m);Rfb(g);Rfb(h);Lfb(k,283600);Hfb(j,w4a(b,k)|0);h=d+8|0;v4a(j,h);Rfb(j);Rfb(k);Lfb(l,283456);k=mgb(w4a(b,l)|0)|0;b=(a[m]|0)!=0;m=c[h>>2]|0;c[f>>2]=k;c[f+4>>2]=b?283720:283728;c[f+8>>2]=m;c[f+12>>2]=b?283720:283736;kXa(4,0,283856,f);Rfb(l);i=e;return}function F4a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+16|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+16|0;la=i;i=i+16|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+200|0;ra=i;i=i+16|0;sa=i;i=i+16|0;ta=i;i=i+8|0;ua=i;i=i+16|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+16|0;za=i;i=i+16|0;Aa=i;i=i+1024|0;Ba=i;i=i+8|0;Ca=i;i=i+16|0;Da=i;i=i+8|0;Ea=i;i=i+16|0;Fa=i;i=i+16|0;Ga=i;i=i+16|0;Ha=i;i=i+16|0;Ia=i;i=i+16|0;Ja=i;i=i+16|0;Ka=i;i=i+16|0;La=i;i=i+16|0;Ma=i;i=i+16|0;Na=i;i=i+16|0;Oa=i;i=i+16|0;Pa=i;i=i+16|0;Qa=i;i=i+16|0;Ra=i;i=i+16|0;Sa=i;i=i+16|0;Ta=i;i=i+16|0;Ua=i;i=i+16|0;Va=i;i=i+16|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+16|0;eb=i;i=i+16|0;fb=i;i=i+16|0;gb=i;i=i+16|0;hb=i;i=i+16|0;ib=i;i=i+16|0;jb=i;i=i+16|0;kb=i;i=i+16|0;lb=i;i=i+16|0;mb=i;i=i+16|0;nb=i;i=i+16|0;ob=i;i=i+16|0;pb=i;i=i+16|0;qb=i;i=i+16|0;rb=i;i=i+16|0;sb=i;i=i+16|0;tb=i;i=i+16|0;ub=i;i=i+16|0;wb=i;i=i+8|0;xb=i;i=i+16|0;yb=i;i=i+16|0;zb=i;i=i+8|0;Ab=i;i=i+16|0;Bb=i;i=i+16|0;Cb=i;i=i+8|0;Db=i;i=i+16|0;Eb=i;i=i+16|0;Fb=i;i=i+8|0;Gb=i;i=i+16|0;Hb=i;i=i+16|0;Ib=i;i=i+8|0;Jb=i;i=i+16|0;Kb=i;i=i+16|0;Lb=i;i=i+8|0;Mb=i;i=i+16|0;Nb=i;i=i+16|0;Ob=i;i=i+8|0;Pb=i;i=i+16|0;Qb=i;i=i+16|0;Rb=i;i=i+8|0;Sb=i;i=i+16|0;Tb=i;i=i+16|0;Ub=i;i=i+8|0;Vb=i;i=i+16|0;Wb=i;i=i+16|0;Xb=i;i=i+8|0;Yb=i;i=i+16|0;Zb=i;i=i+16|0;_b=i;i=i+8|0;$b=i;i=i+16|0;ac=i;i=i+16|0;bc=i;i=i+8|0;cc=i;i=i+16|0;dc=i;i=i+16|0;ec=i;i=i+8|0;fc=i;i=i+16|0;gc=i;i=i+8|0;hc=i;i=i+8|0;ic=i;i=i+16|0;jc=i;i=i+16|0;kc=i;i=i+8|0;lc=i;i=i+16|0;nc=i;i=i+16|0;oc=i;i=i+8|0;pc=i;i=i+16|0;qc=i;i=i+16|0;rc=i;i=i+8|0;sc=i;i=i+16|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+16|0;wc=i;i=i+16|0;xc=i;i=i+8|0;yc=i;i=i+16|0;zc=i;i=i+16|0;Ac=i;i=i+8|0;Bc=i;i=i+16|0;Cc=i;i=i+16|0;Dc=i;i=i+8|0;Ec=i;i=i+16|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+16|0;Ic=i;i=i+16|0;Jc=i;i=i+8|0;Kc=i;i=i+16|0;Lc=i;i=i+16|0;Mc=i;i=i+8|0;Nc=i;i=i+16|0;Oc=i;i=i+16|0;Pc=i;i=i+8|0;Qc=i;i=i+16|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+16|0;Uc=i;i=i+16|0;Vc=qa;G4a(qa);Ffb(ra);H4a(sa,ta);H4a(ua,va);va=b+92|0;do{if((c[va>>2]|0)==0){if((c[296904>>2]|0)==0){Lfb(za,c[b+80>>2]|0);I4a(ya,za,283880);Sfb(ra,ya)|0;Rfb(ya);Rfb(za)}else{Tfb(ra,c[297032>>2]|0)|0}ta=mc(mgb(ra)|0,283896)|0;if((ta|0)!=0){Wc=ta;break}c[pa>>2]=mgb(ra)|0;oXa(0,283904,pa)}else{Wc=0}}while(0);pa=fSa(0)|0;if((pa|0)==0){ad(Wc|0)|0;oXa(0,284008,oa)}qSa(pa,Vc);rSa(pa,8,185);Vc=c[va>>2]|0;do{if((Vc|0)==0){oa=Aa;Cqb(oa|0,0,1024)|0;while(1){za=vb(oa|0,1,1024,Wc|0)|0;ya=za>>>0<1024;if((sSa(pa,oa,za,ya&1)|0)==0){Xc=12;break}if(ya){Xc=14;break}}if((Xc|0)==12){ad(Wc|0)|0;oa=mgb(ra)|0;ya=ASa(xSa(pa)|0)|0;za=ySa(pa)|0;c[na>>2]=oa;c[na+4>>2]=ya;c[na+8>>2]=za;mXa(1,0,284088,na);mSa(pa);oXa(0,284176,ma)}else if((Xc|0)==14){ad(Wc|0)|0;break}}else{if((sSa(pa,Vc,yqb(Vc|0)|0,1)|0)!=0){break}za=c[r>>2]|0;ya=c[va>>2]|0;oa=ASa(xSa(pa)|0)|0;ta=ySa(pa)|0;c[la>>2]=ya;c[la+4>>2]=oa;c[la+8>>2]=ta;Dd(za|0,284200,la|0)|0;za=c[va>>2]|0;ta=ASa(xSa(pa)|0)|0;oa=ySa(pa)|0;c[ka>>2]=za;c[ka+4>>2]=ta;c[ka+8>>2]=oa;mXa(1,0,284216,ka);mSa(pa);oXa(0,284176,ja)}}while(0);ja=qa;Lfb(Ca,284304);M4a(Ba,ja,Ca);N4a(Da,ja);ka=L4a(Ba,Da)|0;Rfb(Ca);Ca=b+88|0;Da=c[Ca>>2]|0;do{if(ka){Ba=mgb(ra)|0;c[ia>>2]=Da;c[ia+4>>2]=Ba;mXa(1,0,284312,ia)}else{Lfb(Ea,284304);Ba=uqb(Da,mgb(w4a(ja,Ea)|0)|0)|0;Rfb(Ea);if((Ba|0)==0){break}mSa(pa);Lfb(Fa,284304);Ba=mgb(w4a(ja,Fa)|0)|0;va=mgb(ra)|0;la=c[Ca>>2]|0;c[ha>>2]=Ba;c[ha+4>>2]=va;c[ha+8>>2]=la;mXa(1,0,284360,ha);Rfb(Fa);oXa(0,284176,ga)}}while(0);O4a(qa,b,c[297116>>2]|0,c[297120>>2]|0);kXa(23,1,284456,fa);fa=qa+12|0;Lfb(Ha,284496);Hfb(Ga,w4a(fa,Ha)|0);ga=d;B4a(Ga,ga,0.0);Rfb(Ga);Rfb(Ha);Ha=ea;h[k>>3]=+h[ga>>3];c[Ha>>2]=c[k>>2];c[Ha+4>>2]=c[k+4>>2];kXa(23,0,284512,ea);Lfb(Ja,284528);Hfb(Ia,w4a(fa,Ja)|0);ea=d+8|0;B4a(Ia,ea,1.0);Rfb(Ia);Rfb(Ja);Ja=da;h[k>>3]=+h[ea>>3];c[Ja>>2]=c[k>>2];c[Ja+4>>2]=c[k+4>>2];kXa(23,0,284544,da);Lfb(La,284560);Hfb(Ka,w4a(fa,La)|0);da=d+24|0;B4a(Ka,da,(+h[ea>>3]- +h[ga>>3])/500.0);Rfb(Ka);Rfb(La);La=ca;h[k>>3]=+h[da>>3];c[La>>2]=c[k>>2];c[La+4>>2]=c[k+4>>2];kXa(23,0,284576,ca);Lfb(Na,284592);Hfb(Ma,w4a(fa,Na)|0);ca=d+32|0;B4a(Ma,ca,1.0e-5);Rfb(Ma);Rfb(Na);Na=ba;h[k>>3]=+h[ca>>3];c[Na>>2]=c[k>>2];c[Na+4>>2]=c[k+4>>2];kXa(23,0,284608,ba);Lfb(Pa,284624);Hfb(Oa,w4a(fa,Pa)|0);ba=d+40|0;v4a(Oa,ba);Rfb(Oa);Rfb(Pa);c[aa>>2]=c[ba>>2];kXa(23,0,284632,aa);Lfb(Ra,284656);Hfb(Qa,w4a(fa,Ra)|0);aa=d+44|0;v4a(Qa,aa);Rfb(Qa);Rfb(Ra);c[$>>2]=c[aa>>2];kXa(23,0,284672,$);Lfb(Ta,284696);Hfb(Sa,w4a(fa,Ta)|0);fa=d+48|0;v4a(Sa,fa);Rfb(Sa);Rfb(Ta);c[_>>2]=c[fa>>2];kXa(23,0,284712,_);Lfb(Va,284736);Hfb(Ua,w4a(ja,Va)|0);_=d+268|0;v4a(Ua,_);Rfb(Ua);Rfb(Va);c[Z>>2]=c[_>>2];kXa(23,0,284760,Z);if((c[240172>>2]|0)!=0){me[c[60158]&2047](23)}Lfb(eb,284784);Hfb(db,w4a(ja,eb)|0);y4a(db,Wa,0);Rfb(db);Rfb(eb);Lfb(gb,284816);Hfb(fb,w4a(ja,gb)|0);y4a(fb,Xa,0);Rfb(fb);Rfb(gb);Lfb(ib,284848);Hfb(hb,w4a(ja,ib)|0);y4a(hb,Ya,0);Rfb(hb);Rfb(ib);Lfb(kb,284872);Hfb(jb,w4a(ja,kb)|0);y4a(jb,_a,0);Rfb(jb);Rfb(kb);Lfb(mb,284904);Hfb(lb,w4a(ja,mb)|0);y4a(lb,Za,0);Rfb(lb);Rfb(mb);Lfb(ob,284944);Hfb(nb,w4a(ja,ob)|0);y4a(nb,ab,0);Rfb(nb);Rfb(ob);Lfb(qb,284976);Hfb(pb,w4a(ja,qb)|0);y4a(pb,$a,0);Rfb(pb);Rfb(qb);Lfb(sb,285016);Hfb(rb,w4a(ja,sb)|0);y4a(rb,cb,0);Rfb(rb);Rfb(sb);Lfb(ub,285048);Hfb(tb,w4a(ja,ub)|0);y4a(tb,bb,0);Rfb(tb);Rfb(ub);ub=c[Wa>>2]|0;Wa=b+104|0;do{if((ub|0)==(c[Wa>>2]|0)){tb=b+108|0;if((c[Xa>>2]|0)!=((c[tb>>2]|0)-(ub<<1)|0)){break}ja=b+128|0;if((c[Ya>>2]|0)!=(c[ja>>2]|0)){break}sb=b+132|0;if((c[_a>>2]|0)!=(c[sb>>2]|0)){break}rb=b+116|0;if((c[Za>>2]|0)!=(c[rb>>2]|0)){break}qb=b+136|0;if((c[ab>>2]|0)!=(c[qb>>2]|0)){break}pb=b+120|0;if((c[$a>>2]|0)!=(c[pb>>2]|0)){break}ob=b+140|0;if((c[cb>>2]|0)!=(c[ob>>2]|0)){break}nb=b+124|0;if((c[bb>>2]|0)!=(c[nb>>2]|0)){break}c[O>>2]=285592;kXa(4,1,285568,O);if((c[Wa>>2]|0)>0){mb=b;lb=qa+24|0;kb=0;do{jb=c[mb>>2]|0;c[wb>>2]=kb;ib=P4a(lb,wb)|0;u4a(ib,jb+(kb*112|0)|0);z4a(ib,jb+(kb*112|0)+40|0);hb=jb+(kb*112|0)+4|0;do{if((a[c[hb>>2]|0]|0)==36){a[(c[mb>>2]|0)+(kb*112|0)+104|0]=1}else{if((c[296900>>2]|0)!=0){break}Lfb(xb,285608);jb=(pgb(w4a(ib,xb)|0,283744)|0)==0;Rfb(xb);if(!jb){break}c[N>>2]=c[hb>>2];kXa(4,0,285624,N);a[(c[mb>>2]|0)+(kb*112|0)+104|0]=1}}while(0);Lfb(yb,c[hb>>2]|0);c[(Q4a(sa,yb)|0)>>2]=kb;Rfb(yb);kb=kb+1|0;}while((kb|0)<(c[Wa>>2]|0))}if((c[240096>>2]|0)!=0){me[c[60158]&2047](4)}c[M>>2]=285656;kXa(4,1,285568,M);kb=c[Wa>>2]|0;if((kb|0)>0){mb=b;lb=qa+36|0;ib=kb;kb=0;do{jb=ib+kb|0;gb=c[mb>>2]|0;c[zb>>2]=kb;fb=P4a(lb,zb)|0;u4a(fb,gb+(jb*112|0)|0);z4a(fb,gb+(jb*112|0)+40|0);eb=gb+(jb*112|0)+4|0;do{if((a[c[eb>>2]|0]|0)==36){a[(c[mb>>2]|0)+(jb*112|0)+104|0]=1}else{if((c[296900>>2]|0)!=0){break}Lfb(Ab,285608);gb=(pgb(w4a(fb,Ab)|0,283744)|0)==0;Rfb(Ab);if(!gb){break}c[L>>2]=c[eb>>2];kXa(4,0,285624,L);a[(c[mb>>2]|0)+(jb*112|0)+104|0]=1}}while(0);Lfb(Bb,c[eb>>2]|0);c[(Q4a(sa,Bb)|0)>>2]=jb;Rfb(Bb);kb=kb+1|0;ib=c[Wa>>2]|0;}while((kb|0)<(ib|0))}if((c[240096>>2]|0)!=0){me[c[60158]&2047](4)}c[K>>2]=285680;kXa(4,1,285568,K);ib=c[Wa>>2]<<1;if(((c[tb>>2]|0)-ib|0)>0){kb=b;mb=qa+48|0;lb=ib;ib=0;do{fb=lb+ib|0;hb=c[kb>>2]|0;c[Cb>>2]=ib;gb=P4a(mb,Cb)|0;u4a(gb,hb+(fb*112|0)|0);z4a(gb,hb+(fb*112|0)+40|0);db=hb+(fb*112|0)+4|0;do{if((a[c[db>>2]|0]|0)==36){a[(c[kb>>2]|0)+(fb*112|0)+104|0]=1}else{if((c[296900>>2]|0)!=0){break}Lfb(Db,285608);hb=(pgb(w4a(gb,Db)|0,283744)|0)==0;Rfb(Db);if(!hb){break}c[J>>2]=c[db>>2];kXa(4,0,285624,J);a[(c[kb>>2]|0)+(fb*112|0)+104|0]=1}}while(0);Lfb(Eb,c[db>>2]|0);c[(Q4a(sa,Eb)|0)>>2]=fb;Rfb(Eb);ib=ib+1|0;lb=c[Wa>>2]<<1;}while((ib|0)<((c[tb>>2]|0)-lb|0))}if((c[240096>>2]|0)!=0){me[c[60158]&2047](4)}c[I>>2]=285696;kXa(4,1,285568,I);if((c[rb>>2]|0)>0){lb=b+4|0;tb=qa+84|0;ib=0;do{kb=c[lb>>2]|0;c[Fb>>2]=ib;mb=P4a(tb,Fb)|0;u4a(mb,kb+(ib*60|0)|0);C4a(mb,kb+(ib*60|0)+36|0);gb=kb+(ib*60|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[lb>>2]|0)+(ib*60|0)+56|0]=1}else{if((c[296900>>2]|0)!=0){break}Lfb(Gb,285608);kb=(pgb(w4a(mb,Gb)|0,283744)|0)==0;Rfb(Gb);if(!kb){break}c[H>>2]=c[gb>>2];kXa(4,0,285624,H);a[(c[lb>>2]|0)+(ib*60|0)+56|0]=1}}while(0);Lfb(Hb,c[gb>>2]|0);c[(Q4a(sa,Hb)|0)>>2]=ib;Rfb(Hb);ib=ib+1|0;}while((ib|0)<(c[rb>>2]|0))}if((c[240096>>2]|0)!=0){me[c[60158]&2047](4)}c[G>>2]=285720;kXa(4,1,285568,G);if((c[pb>>2]|0)>0){rb=b+8|0;ib=qa+120|0;lb=0;do{tb=c[rb>>2]|0;c[Ib>>2]=lb;mb=P4a(ib,Ib)|0;u4a(mb,tb+(lb*48|0)|0);D4a(mb,tb+(lb*48|0)+36|0);fb=tb+(lb*48|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[rb>>2]|0)+(lb*48|0)+44|0]=1}else{if((c[296900>>2]|0)!=0){break}Lfb(Jb,285608);tb=(pgb(w4a(mb,Jb)|0,283744)|0)==0;Rfb(Jb);if(!tb){break}c[F>>2]=c[fb>>2];kXa(4,0,285624,F);a[(c[rb>>2]|0)+(lb*48|0)+44|0]=1}}while(0);Lfb(Kb,c[fb>>2]|0);c[(Q4a(sa,Kb)|0)>>2]=lb;Rfb(Kb);lb=lb+1|0;}while((lb|0)<(c[pb>>2]|0))}if((c[240096>>2]|0)!=0){me[c[60158]&2047](4)}c[E>>2]=285744;kXa(4,1,285568,E);if((c[nb>>2]|0)>0){pb=b+12|0;lb=qa+156|0;rb=0;do{ib=c[pb>>2]|0;c[Lb>>2]=rb;mb=P4a(lb,Lb)|0;u4a(mb,ib+(rb*52|0)|0);E4a(mb,ib+(rb*52|0)+36|0);gb=ib+(rb*52|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[pb>>2]|0)+(rb*52|0)+48|0]=1}else{if((c[296900>>2]|0)!=0){break}Lfb(Mb,285608);ib=(pgb(w4a(mb,Mb)|0,283744)|0)==0;Rfb(Mb);if(!ib){break}c[D>>2]=c[gb>>2];kXa(4,0,285624,D);a[(c[pb>>2]|0)+(rb*52|0)+48|0]=1}}while(0);Lfb(Nb,c[gb>>2]|0);c[(Q4a(sa,Nb)|0)>>2]=rb;Rfb(Nb);rb=rb+1|0;}while((rb|0)<(c[nb>>2]|0))}if((c[240096>>2]|0)!=0){me[c[60158]&2047](4)}c[C>>2]=285768;kXa(4,1,285568,C);if((c[ja>>2]|0)>0){nb=b+16|0;rb=qa+60|0;pb=0;do{lb=c[nb>>2]|0;c[Ob>>2]=pb;mb=P4a(rb,Ob)|0;u4a(mb,lb+(pb*112|0)|0);z4a(mb,lb+(pb*112|0)+40|0);fb=lb+(pb*112|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[nb>>2]|0)+(pb*112|0)+104|0]=1}else{if((c[296900>>2]|0)!=0){break}Lfb(Pb,285608);lb=(pgb(w4a(mb,Pb)|0,283744)|0)==0;Rfb(Pb);if(!lb){break}c[B>>2]=c[fb>>2];kXa(4,0,285624,B);a[(c[nb>>2]|0)+(pb*112|0)+104|0]=1}}while(0);Lfb(Qb,c[fb>>2]|0);c[(Q4a(ua,Qb)|0)>>2]=pb;Rfb(Qb);pb=pb+1|0;}while((pb|0)<(c[ja>>2]|0))}if((c[240096>>2]|0)!=0){me[c[60158]&2047](4)}c[A>>2]=285784;kXa(4,1,285568,A);if((c[sb>>2]|0)>0){ja=b+20|0;pb=qa+96|0;nb=0;do{rb=c[ja>>2]|0;c[Rb>>2]=nb;mb=P4a(pb,Rb)|0;u4a(mb,rb+(nb*60|0)|0);C4a(mb,rb+(nb*60|0)+36|0);gb=rb+(nb*60|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[ja>>2]|0)+(nb*60|0)+56|0]=1}else{if((c[296900>>2]|0)!=0){break}Lfb(Sb,285608);rb=(pgb(w4a(mb,Sb)|0,283744)|0)==0;Rfb(Sb);if(!rb){break}c[z>>2]=c[gb>>2];kXa(4,0,285624,z);a[(c[ja>>2]|0)+(nb*60|0)+56|0]=1}}while(0);Lfb(Tb,c[gb>>2]|0);c[(Q4a(ua,Tb)|0)>>2]=nb;Rfb(Tb);nb=nb+1|0;}while((nb|0)<(c[sb>>2]|0))}if((c[240096>>2]|0)!=0){me[c[60158]&2047](4)}c[y>>2]=285808;kXa(4,1,285568,y);if((c[qb>>2]|0)>0){sb=b+24|0;nb=qa+132|0;ja=0;do{pb=c[sb>>2]|0;c[Ub>>2]=ja;mb=P4a(nb,Ub)|0;u4a(mb,pb+(ja*48|0)|0);D4a(mb,pb+(ja*48|0)+36|0);fb=pb+(ja*48|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[sb>>2]|0)+(ja*48|0)+44|0]=1}else{if((c[296900>>2]|0)!=0){break}Lfb(Vb,285608);pb=(pgb(w4a(mb,Vb)|0,283744)|0)==0;Rfb(Vb);if(!pb){break}c[x>>2]=c[fb>>2];kXa(4,0,285624,x);a[(c[sb>>2]|0)+(ja*48|0)+44|0]=1}}while(0);Lfb(Wb,c[fb>>2]|0);c[(Q4a(ua,Wb)|0)>>2]=ja;Rfb(Wb);ja=ja+1|0;}while((ja|0)<(c[qb>>2]|0))}if((c[240096>>2]|0)!=0){me[c[60158]&2047](4)}c[w>>2]=285832;kXa(4,1,285568,w);if((c[ob>>2]|0)>0){qb=b+28|0;ja=qa+168|0;sb=0;do{nb=c[qb>>2]|0;c[Xb>>2]=sb;mb=P4a(ja,Xb)|0;u4a(mb,nb+(sb*52|0)|0);E4a(mb,nb+(sb*52|0)+36|0);gb=nb+(sb*52|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[qb>>2]|0)+(sb*52|0)+48|0]=1}else{if((c[296900>>2]|0)!=0){break}Lfb(Yb,285608);nb=(pgb(w4a(mb,Yb)|0,283744)|0)==0;Rfb(Yb);if(!nb){break}c[v>>2]=c[gb>>2];kXa(4,0,285624,v);a[(c[qb>>2]|0)+(sb*52|0)+48|0]=1}}while(0);Lfb(Zb,c[gb>>2]|0);c[(Q4a(ua,Zb)|0)>>2]=sb;Rfb(Zb);sb=sb+1|0;}while((sb|0)<(c[ob>>2]|0))}if((c[240096>>2]|0)!=0){me[c[60158]&2047](4)}kXa(4,1,285856,u);ob=b+208|0;a:do{if((c[ob>>2]|0)>0){sb=qa+72|0;qb=b+32|0;ja=0;b:while(1){c[_b>>2]=ja;mb=P4a(sb,_b)|0;u4a(mb,(c[qb>>2]|0)+(ja*52|0)+12|0);Ffb($b);c[bc>>2]=ja;mb=P4a(sb,bc)|0;Lfb(cc,285896);Hfb(ac,w4a(mb,cc)|0);R4a(ac,$b);Rfb(ac);Rfb(cc);mb=(pgb($b,285904)|0)==0;fb=c[qb>>2]|0;nb=mb&1;c[fb+(ja*52|0)>>2]=nb;c[t>>2]=c[fb+(ja*52|0)+16>>2];c[t+4>>2]=nb;kXa(4,0,285920,t);nb=c[qb>>2]|0;if((a[c[nb+(ja*52|0)+16>>2]|0]|0)==36){a[nb+(ja*52|0)+48|0]=1}c[ec>>2]=ja;nb=P4a(sb,ec)|0;Lfb(fc,285960);Hfb(dc,w4a(nb,fc)|0);R4a(dc,$b);Rfb(dc);Rfb(fc);S4a(wa,sa,$b);S4a(xa,ua,$b);U4a(gc,sa);do{if(T4a(wa,gc)|0){nb=c[(V4a(wa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(ja*52|0)+4>>2]=nb;a[fb+(ja*52|0)+8|0]=0}else{U4a(hc,ua);if(T4a(xa,hc)|0){fb=c[(V4a(xa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(ja*52|0)+4>>2]=fb;a[nb+(ja*52|0)+8|0]=1;break}if((pgb($b,285976)|0)!=0){break b}a[(c[qb>>2]|0)+(ja*52|0)+8|0]=2}}while(0);Rfb($b);ja=ja+1|0;if((ja|0)>=(c[ob>>2]|0)){break a}}Agb(jc,285984,$b);I4a(ic,jc,286008);Rfb(jc);c[s>>2]=mgb(ic)|0;oXa(0,286024,s)}}while(0);if((c[240096>>2]|0)!=0){me[c[60158]&2047](4)}kXa(4,1,286032,q);ob=b+212|0;c:do{if((c[ob>>2]|0)>0){ja=qa+108|0;qb=b+36|0;sb=0;while(1){c[kc>>2]=sb;gb=P4a(ja,kc)|0;u4a(gb,(c[qb>>2]|0)+(sb*52|0)+12|0);Ffb(lc);c[oc>>2]=sb;gb=P4a(ja,oc)|0;Lfb(pc,285896);Hfb(nc,w4a(gb,pc)|0);R4a(nc,lc);Rfb(nc);Rfb(pc);gb=(pgb(lc,285904)|0)==0;nb=c[qb>>2]|0;fb=gb&1;c[nb+(sb*52|0)>>2]=fb;c[p>>2]=c[nb+(sb*52|0)+16>>2];c[p+4>>2]=fb;kXa(4,0,285920,p);fb=c[qb>>2]|0;if((a[c[fb+(sb*52|0)+16>>2]|0]|0)==36){a[fb+(sb*52|0)+48|0]=1}c[rc>>2]=sb;fb=P4a(ja,rc)|0;Lfb(sc,285960);Hfb(qc,w4a(fb,sc)|0);R4a(qc,lc);Rfb(qc);Rfb(sc);S4a(wa,sa,lc);S4a(xa,ua,lc);U4a(tc,sa);if(T4a(wa,tc)|0){fb=c[(V4a(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(sb*52|0)+4>>2]=fb;a[nb+(sb*52|0)+8|0]=0}else{U4a(uc,ua);if(!(T4a(xa,uc)|0)){break}nb=c[(V4a(xa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(sb*52|0)+4>>2]=nb;a[fb+(sb*52|0)+8|0]=1}Rfb(lc);sb=sb+1|0;if((sb|0)>=(c[ob>>2]|0)){break c}}Agb(wc,286072,lc);I4a(vc,wc,286008);Rfb(wc);c[o>>2]=mgb(vc)|0;oXa(0,286024,o)}}while(0);if((c[240096>>2]|0)!=0){me[c[60158]&2047](4)}kXa(4,1,286096,n);ob=b+216|0;d:do{if((c[ob>>2]|0)>0){sb=qa+144|0;qb=b+40|0;ja=0;while(1){c[xc>>2]=ja;fb=P4a(sb,xc)|0;u4a(fb,(c[qb>>2]|0)+(ja*52|0)+12|0);Ffb(yc);c[Ac>>2]=ja;fb=P4a(sb,Ac)|0;Lfb(Bc,285896);Hfb(zc,w4a(fb,Bc)|0);R4a(zc,yc);Rfb(zc);Rfb(Bc);fb=(pgb(yc,285904)|0)==0;nb=c[qb>>2]|0;gb=fb&1;c[nb+(ja*52|0)>>2]=gb;c[m>>2]=c[nb+(ja*52|0)+16>>2];c[m+4>>2]=gb;kXa(4,0,285920,m);gb=c[qb>>2]|0;if((a[c[gb+(ja*52|0)+16>>2]|0]|0)==36){a[gb+(ja*52|0)+48|0]=1}c[Dc>>2]=ja;gb=P4a(sb,Dc)|0;Lfb(Ec,285960);Hfb(Cc,w4a(gb,Ec)|0);R4a(Cc,yc);Rfb(Cc);Rfb(Ec);S4a(wa,sa,yc);S4a(xa,ua,yc);U4a(Fc,sa);if(T4a(wa,Fc)|0){gb=c[(V4a(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(ja*52|0)+4>>2]=gb;a[nb+(ja*52|0)+8|0]=0}else{U4a(Gc,ua);if(!(T4a(xa,Gc)|0)){break}nb=c[(V4a(xa)|0)+12>>2]|0;gb=c[qb>>2]|0;c[gb+(ja*52|0)+4>>2]=nb;a[gb+(ja*52|0)+8|0]=1}Rfb(yc);ja=ja+1|0;if((ja|0)>=(c[ob>>2]|0)){break d}}Agb(Ic,286136,yc);I4a(Hc,Ic,286008);Rfb(Ic);c[l>>2]=mgb(Hc)|0;oXa(0,286024,l)}}while(0);if((c[240096>>2]|0)!=0){me[c[60158]&2047](4)}kXa(4,1,286160,j);ob=b+220|0;e:do{if((c[ob>>2]|0)>0){ja=qa+180|0;qb=b+44|0;sb=0;while(1){c[Jc>>2]=sb;gb=P4a(ja,Jc)|0;u4a(gb,(c[qb>>2]|0)+(sb*52|0)+12|0);Ffb(Kc);c[Mc>>2]=sb;gb=P4a(ja,Mc)|0;Lfb(Nc,285896);Hfb(Lc,w4a(gb,Nc)|0);R4a(Lc,Kc);Rfb(Lc);Rfb(Nc);gb=(pgb(Kc,285904)|0)==0;nb=c[qb>>2]|0;fb=gb&1;c[nb+(sb*52|0)>>2]=fb;c[g>>2]=c[nb+(sb*52|0)+16>>2];c[g+4>>2]=fb;kXa(4,0,285920,g);fb=c[qb>>2]|0;if((a[c[fb+(sb*52|0)+16>>2]|0]|0)==36){a[fb+(sb*52|0)+48|0]=1}c[Pc>>2]=sb;fb=P4a(ja,Pc)|0;Lfb(Qc,285960);Hfb(Oc,w4a(fb,Qc)|0);R4a(Oc,Kc);Rfb(Oc);Rfb(Qc);S4a(wa,sa,Kc);S4a(xa,ua,Kc);U4a(Rc,sa);if(T4a(wa,Rc)|0){fb=c[(V4a(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(sb*52|0)+4>>2]=fb;a[nb+(sb*52|0)+8|0]=0}else{U4a(Sc,ua);if(!(T4a(xa,Sc)|0)){break}nb=c[(V4a(xa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(sb*52|0)+4>>2]=nb;a[fb+(sb*52|0)+8|0]=1}Rfb(Kc);sb=sb+1|0;if((sb|0)>=(c[ob>>2]|0)){break e}}Agb(Uc,286200,Kc);I4a(Tc,Uc,286008);Rfb(Uc);c[f>>2]=mgb(Tc)|0;oXa(0,286024,f)}}while(0);if((c[240096>>2]|0)==0){mSa(pa);W4a(ua);W4a(sa);Rfb(ra);X4a(qa);i=e;return}me[c[60158]&2047](4);mSa(pa);W4a(ua);W4a(sa);Rfb(ra);X4a(qa);i=e;return}}while(0);if((c[240168>>2]|c[60018]|0)==0){mSa(pa);Yc=Bd(0)|0;Jd(-1)}mXa(22,1,285088,Y);Y=c[Wa>>2]|0;c[X>>2]=ub;c[X+4>>2]=Y;mXa(22,0,285136,X);X=(c[b+108>>2]|0)-(c[Wa>>2]<<1)|0;c[W>>2]=c[Xa>>2];c[W+4>>2]=X;mXa(22,0,285184,W);W=c[b+128>>2]|0;c[V>>2]=c[Ya>>2];c[V+4>>2]=W;mXa(22,0,285232,V);V=c[b+132>>2]|0;c[U>>2]=c[_a>>2];c[U+4>>2]=V;mXa(22,0,285280,U);U=c[b+116>>2]|0;c[T>>2]=c[Za>>2];c[T+4>>2]=U;mXa(22,0,285328,T);T=c[b+136>>2]|0;c[S>>2]=c[ab>>2];c[S+4>>2]=T;mXa(22,0,285376,S);S=c[b+120>>2]|0;c[R>>2]=c[$a>>2];c[R+4>>2]=S;mXa(22,0,285424,R);R=c[b+140>>2]|0;c[Q>>2]=c[cb>>2];c[Q+4>>2]=R;mXa(22,0,285472,Q);Q=c[b+124>>2]|0;c[P>>2]=c[bb>>2];c[P+4>>2]=Q;mXa(22,0,285520,P);me[c[60158]&2047](22);mSa(pa);Yc=Bd(0)|0;Jd(-1)}function G4a(a){a=a|0;var b=0;b=i;Ibb(a);i=b;return}function H4a(a,b){a=a|0;b=b|0;b=i;n7a(a,0);i=b;return}function I4a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+8|0;Gfb(a,d);e=Pfb(b)|0;f=v5a(c)|0;qgb(a,Qfb(b)|0,e,f+e|0);igb(a,c,f)|0;i=d;return}function J4a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;if((uqb(b,286832)|0)==0){t=c[d>>2]|0;if((t|0)==0){i=e;return}u=a;v=t;t=0;do{Lfb(g,v);w=w4a(u,g)|0;Tfb(w,c[d+((t|1)<<2)>>2]|0)|0;Rfb(g);t=t+2|0;v=c[d+(t<<2)>>2]|0;}while((v|0)!=0);i=e;return}if((uqb(b,286856)|0)==0){v=c[d>>2]|0;if((v|0)==0){i=e;return}t=a+12|0;g=v;v=0;do{Lfb(h,g);u=w4a(t,h)|0;Tfb(u,c[d+((v|1)<<2)>>2]|0)|0;Rfb(h);v=v+2|0;g=c[d+(v<<2)>>2]|0;}while((g|0)!=0);i=e;return}if((uqb(b,286880)|0)!=0){do{if((uqb(b,287136)|0)!=0){if((uqb(b,287144)|0)==0){break}if((uqb(b,287152)|0)==0){break}if((uqb(b,287160)|0)==0){break}i=e;return}}while(0);g=(c[d>>2]|0)==0;v=a+196|0;h=a+192|0;t=P4a(c[v>>2]|0,h)|0;if(g){x=t}else{g=t;t=d;u=0;while(1){Lfb(r,c[t>>2]|0);w=w4a(g,r)|0;Tfb(w,c[d+((u|1)<<2)>>2]|0)|0;Rfb(r);w=u+2|0;y=d+(w<<2)|0;z=(c[y>>2]|0)==0;A=P4a(c[v>>2]|0,h)|0;if(z){x=A;break}else{u=w;t=y;g=A}}}Lfb(s,287168);Tfb(w4a(x,s)|0,b)|0;Rfb(s);i=e;return}Y4a(j,k);Ffb(l);Ffb(m);k=a+192|0;s=k;c[k>>2]=-1;b=a+196|0;c[b>>2]=0;x=c[d>>2]|0;if((x|0)!=0){g=x;x=0;do{Lfb(n,g);t=w4a(j,n)|0;Tfb(t,c[d+((x|1)<<2)>>2]|0)|0;Rfb(n);x=x+2|0;g=c[d+(x<<2)>>2]|0;}while((g|0)!=0)}Lfb(o,286896);Sfb(l,w4a(j,o)|0)|0;Rfb(o);Lfb(p,286912);Sfb(m,w4a(j,p)|0)|0;Rfb(p);c[k>>2]=Ic(mgb(l)|0)|0;if((pgb(m,286928)|0)==0){B=a+24|0}else{B=c[b>>2]|0}c[b>>2]=B;if((pgb(m,286936)|0)==0){C=a+36|0}else{C=c[b>>2]|0}c[b>>2]=C;if((pgb(m,286944)|0)==0){D=a+48|0}else{D=c[b>>2]|0}c[b>>2]=D;if((pgb(m,286952)|0)==0){E=a+60|0}else{E=c[b>>2]|0}c[b>>2]=E;if((pgb(m,286960)|0)==0){F=a+72|0}else{F=c[b>>2]|0}c[b>>2]=F;if((pgb(m,286968)|0)==0){G=a+84|0}else{G=c[b>>2]|0}c[b>>2]=G;if((pgb(m,286976)|0)==0){H=a+96|0}else{H=c[b>>2]|0}c[b>>2]=H;if((pgb(m,286984)|0)==0){I=a+108|0}else{I=c[b>>2]|0}c[b>>2]=I;if((pgb(m,286992)|0)==0){J=a+120|0}else{J=c[b>>2]|0}c[b>>2]=J;if((pgb(m,287e3)|0)==0){K=a+132|0}else{K=c[b>>2]|0}c[b>>2]=K;if((pgb(m,287008)|0)==0){L=a+144|0}else{L=c[b>>2]|0}c[b>>2]=L;if((pgb(m,287016)|0)==0){M=a+156|0}else{M=c[b>>2]|0}c[b>>2]=M;if((pgb(m,287024)|0)==0){N=a+168|0}else{N=c[b>>2]|0}c[b>>2]=N;if((pgb(m,287032)|0)==0){O=a+180|0}else{O=c[b>>2]|0}c[b>>2]=O;a=mgb(m)|0;Lfb(q,283456);N=mgb(w4a(j,q)|0)|0;c[f>>2]=a;c[f+4>>2]=N;nXa(0,(O|0)!=0|0,287040,f);Rfb(q);lab(P4a(c[b>>2]|0,s)|0,j)|0;Rfb(m);Rfb(l);e5a(j);i=e;return}function K4a(a,b){a=a|0;b=b|0;i=i;return}function L4a(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=Y6a(a,b)|0;i=c;return d|0}function M4a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;f7a(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];Z6a(a,f);i=e;return}function N4a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;_6a(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];Z6a(a,e);i=d;return}function O4a(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0;f=i;i=i+8|0;g=f;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+192|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+16|0;S=i;i=i+16|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+16|0;X=i;i=i+16|0;Y=i;i=i+16|0;Z=i;i=i+16|0;_=i;i=i+8|0;$=i;i=i+16|0;aa=i;i=i+8|0;ba=i;i=i+16|0;ca=i;i=i+8|0;da=i;i=i+16|0;ea=i;i=i+8|0;fa=i;i=i+16|0;ga=i;i=i+8|0;ha=i;i=i+16|0;ia=i;i=i+8|0;ja=i;i=i+16|0;ka=i;i=i+8|0;la=i;i=i+16|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+16|0;qa=i;i=i+8|0;ra=i;i=i+16|0;sa=i;i=i+8|0;ta=i;i=i+16|0;ua=i;i=i+8|0;va=i;i=i+16|0;wa=i;i=i+8|0;xa=i;i=i+16|0;ya=i;i=i+8|0;za=i;i=i+16|0;Aa=i;i=i+8|0;Ba=i;i=i+16|0;Ca=i;i=i+8|0;Da=i;i=i+16|0;Ea=i;i=i+8|0;Fa=i;i=i+16|0;Ga=i;i=i+8|0;Ha=i;i=i+16|0;Ia=i;i=i+8|0;Ja=i;i=i+16|0;Ka=i;i=i+8|0;La=i;i=i+16|0;Ma=i;i=i+8|0;Na=i;i=i+16|0;Oa=i;i=i+8|0;Pa=i;i=i+16|0;Qa=i;i=i+8|0;Ra=i;i=i+16|0;Sa=i;i=i+8|0;Ta=i;i=i+16|0;Ua=i;i=i+8|0;Va=i;i=i+16|0;Wa=i;i=i+8|0;Xa=i;i=i+16|0;Ya=i;i=i+8|0;Za=i;i=i+16|0;_a=i;i=i+8|0;$a=i;i=i+16|0;ab=i;i=i+8|0;bb=i;i=i+16|0;cb=i;i=i+8|0;db=i;i=i+16|0;eb=i;i=i+8|0;fb=i;i=i+16|0;gb=i;i=i+8|0;hb=i;i=i+16|0;ib=i;i=i+8|0;jb=i;i=i+16|0;kb=i;i=i+8|0;lb=i;i=i+16|0;mb=i;i=i+8|0;nb=i;i=i+16|0;ob=i;i=i+8|0;pb=i;i=i+16|0;qb=i;i=i+8|0;rb=i;i=i+16|0;sb=i;i=i+8|0;tb=i;i=i+16|0;ub=i;i=i+8|0;vb=i;i=i+16|0;wb=i;i=i+8|0;xb=i;i=i+16|0;yb=i;i=i+8|0;zb=i;i=i+16|0;Ab=i;i=i+8|0;Bb=i;i=i+16|0;Cb=i;i=i+8|0;Db=i;i=i+16|0;Eb=i;i=i+8|0;Fb=i;i=i+16|0;Gb=i;i=i+8|0;Hb=i;i=i+16|0;Ib=i;i=i+8|0;Jb=i;i=i+16|0;Kb=i;i=i+8|0;Lb=i;i=i+16|0;Mb=i;i=i+8|0;Nb=i;i=i+16|0;Ob=i;i=i+8|0;Pb=i;i=i+16|0;Qb=i;i=i+8|0;Rb=i;i=i+16|0;Sb=i;i=i+8|0;Tb=i;i=i+16|0;Ub=i;i=i+8|0;Vb=i;i=i+16|0;Wb=i;i=i+8|0;Xb=i;i=i+16|0;Yb=i;i=i+8|0;Zb=i;i=i+16|0;_b=i;i=i+8|0;ac=i;i=i+16|0;bc=i;i=i+8|0;cc=i;i=i+16|0;Y4a(o,p);p=(d|0)!=0;dc=(e|0)==0;if(!(dc|p^1)){oXa(0,286224,n)}if(p){ec=Hd(d|0)|0}else{ec=0}if(dc){fc=ec}else{c[m>>2]=e;kXa(23,0,286368,m);Z4a(q);_4a(q,e,8);if(!($4a(q)|0)){c[l>>2]=e;oXa(0,286408,l)}Ffb(r);l=q;a5a(l,r)|0;Hfb(s,r);while(1){e=a5a(l,r)|0;if(!(Bgb(e+(c[(c[e>>2]|0)+ -12>>2]|0)|0)|0)){break}Agb(t,286488,r);ggb(s,t)|0;Rfb(t)}t=Hd(mgb(s)|0)|0;b5a(q);Rfb(s);Rfb(r);c5a(q);fc=t}if((fc|0)==0){kXa(23,0,286576,g);e5a(o);i=f;return}Ffb(u);Ffb(v);c[k>>2]=fc;kXa(23,0,286496,k);k=$b(fc|0,286488)|0;if((k|0)!=0){g=k;do{k=aqb(12)|0;Lfb(k,g);t=ngb(k,286528,0)|0;lgb(w,k,0,t);Sfb(u,w)|0;Rfb(w);lgb(x,k,t+1|0,(Yfb(k)|0)+~t|0);Sfb(v,x)|0;Rfb(x);Sfb(w4a(o,u)|0,v)|0;t=mgb(u)|0;k=mgb(v)|0;c[j>>2]=t;c[j+4>>2]=k;kXa(23,0,286536,j);g=$b(0,286488)|0;}while((g|0)!=0)}Xpb(fc);fc=a+12|0;Lfb(y,284624);g=w4a(fc,y)|0;Lfb(z,284624);if((d5a(o,z)|0)==0){Lfb(B,284624);gc=1;hc=0;ic=w4a(fc,B)|0}else{Lfb(A,284624);gc=0;hc=1;ic=w4a(o,A)|0}Sfb(g,ic)|0;if(gc){Rfb(B)}if(hc){Rfb(A)}Rfb(z);Rfb(y);Lfb(C,284496);y=w4a(fc,C)|0;Lfb(D,284496);if((d5a(o,D)|0)==0){Lfb(F,284496);jc=1;kc=0;lc=w4a(fc,F)|0}else{Lfb(E,284496);jc=0;kc=1;lc=w4a(o,E)|0}Sfb(y,lc)|0;if(jc){Rfb(F)}if(kc){Rfb(E)}Rfb(D);Rfb(C);Lfb(G,284528);C=w4a(fc,G)|0;Lfb(H,284528);if((d5a(o,H)|0)==0){Lfb(J,284528);mc=1;nc=0;oc=w4a(fc,J)|0}else{Lfb(I,284528);mc=0;nc=1;oc=w4a(o,I)|0}Sfb(C,oc)|0;if(mc){Rfb(J)}if(nc){Rfb(I)}Rfb(H);Rfb(G);Lfb(K,284560);G=w4a(fc,K)|0;Lfb(L,284560);if((d5a(o,L)|0)==0){Lfb(N,284560);pc=0;qc=1;rc=w4a(fc,N)|0}else{Lfb(M,284560);pc=1;qc=0;rc=w4a(o,M)|0}Sfb(G,rc)|0;if(qc){Rfb(N)}if(pc){Rfb(M)}Rfb(L);Rfb(K);Lfb(O,284592);K=w4a(fc,O)|0;Lfb(P,284592);if((d5a(o,P)|0)==0){Lfb(R,284592);sc=1;tc=0;uc=w4a(fc,R)|0}else{Lfb(Q,284592);sc=0;tc=1;uc=w4a(o,Q)|0}Sfb(K,uc)|0;if(sc){Rfb(R)}if(tc){Rfb(Q)}Rfb(P);Rfb(O);Lfb(S,284656);O=w4a(fc,S)|0;Lfb(T,284656);if((d5a(o,T)|0)==0){Lfb(V,284656);vc=1;wc=0;xc=w4a(fc,V)|0}else{Lfb(U,284656);vc=0;wc=1;xc=w4a(o,U)|0}Sfb(O,xc)|0;if(vc){Rfb(V)}if(wc){Rfb(U)}Rfb(T);Rfb(S);Lfb(W,284696);S=w4a(fc,W)|0;Lfb(X,284696);if((d5a(o,X)|0)==0){Lfb(Z,284696);yc=1;zc=0;Ac=w4a(fc,Z)|0}else{Lfb(Y,284696);yc=0;zc=1;Ac=w4a(o,Y)|0}Sfb(S,Ac)|0;if(yc){Rfb(Z)}if(zc){Rfb(Y)}Rfb(X);Rfb(W);W=b+104|0;X=c[W>>2]|0;if((X|0)>0){Y=a+24|0;zc=a+36|0;Z=0;while(1){c[_>>2]=Z;yc=P4a(Y,_)|0;Lfb($,283600);Ac=w4a(yc,$)|0;c[aa>>2]=Z;yc=P4a(Y,aa)|0;Lfb(ba,283456);if((d5a(o,w4a(yc,ba)|0)|0)==0){c[ea>>2]=Z;yc=P4a(Y,ea)|0;Lfb(fa,283600);Bc=1;Cc=0;Dc=w4a(yc,fa)|0}else{c[ca>>2]=Z;yc=P4a(Y,ca)|0;Lfb(da,283456);Bc=0;Cc=1;Dc=w4a(o,w4a(yc,da)|0)|0}Sfb(Ac,Dc)|0;if(Bc){Rfb(fa)}if(Cc){Rfb(da)}Rfb(ba);Rfb($);c[ga>>2]=Z;Ac=P4a(zc,ga)|0;Lfb(ha,283600);yc=w4a(Ac,ha)|0;c[ia>>2]=Z;Ac=P4a(zc,ia)|0;Lfb(ja,283456);if((d5a(o,w4a(Ac,ja)|0)|0)==0){c[ma>>2]=Z;Ac=P4a(zc,ma)|0;Lfb(na,283600);Ec=1;Fc=0;Gc=w4a(Ac,na)|0}else{c[ka>>2]=Z;Ac=P4a(zc,ka)|0;Lfb(la,283456);Ec=0;Fc=1;Gc=w4a(o,w4a(Ac,la)|0)|0}Sfb(yc,Gc)|0;if(Ec){Rfb(na)}if(Fc){Rfb(la)}Rfb(ja);Rfb(ha);yc=Z+1|0;Ac=c[W>>2]|0;if((yc|0)<(Ac|0)){Z=yc}else{Hc=Ac;break}}}else{Hc=X}X=b+108|0;if(((c[X>>2]|0)-(Hc<<1)|0)>0){Hc=a+48|0;Z=0;do{c[oa>>2]=Z;ha=P4a(Hc,oa)|0;Lfb(pa,283600);ja=w4a(ha,pa)|0;c[qa>>2]=Z;ha=P4a(Hc,qa)|0;Lfb(ra,283456);if((d5a(o,w4a(ha,ra)|0)|0)==0){c[ua>>2]=Z;ha=P4a(Hc,ua)|0;Lfb(va,283600);Ic=1;Jc=0;Kc=w4a(ha,va)|0}else{c[sa>>2]=Z;ha=P4a(Hc,sa)|0;Lfb(ta,283456);Ic=0;Jc=1;Kc=w4a(o,w4a(ha,ta)|0)|0}Sfb(ja,Kc)|0;if(Ic){Rfb(va)}if(Jc){Rfb(ta)}Rfb(ra);Rfb(pa);Z=Z+1|0;}while((Z|0)<((c[X>>2]|0)-(c[W>>2]<<1)|0))}W=b+116|0;if((c[W>>2]|0)>0){X=a+84|0;Z=0;do{c[wa>>2]=Z;pa=P4a(X,wa)|0;Lfb(xa,283600);ra=w4a(pa,xa)|0;c[ya>>2]=Z;pa=P4a(X,ya)|0;Lfb(za,283456);if((d5a(o,w4a(pa,za)|0)|0)==0){c[Ca>>2]=Z;pa=P4a(X,Ca)|0;Lfb(Da,283600);Lc=1;Mc=0;Nc=w4a(pa,Da)|0}else{c[Aa>>2]=Z;pa=P4a(X,Aa)|0;Lfb(Ba,283456);Lc=0;Mc=1;Nc=w4a(o,w4a(pa,Ba)|0)|0}Sfb(ra,Nc)|0;if(Lc){Rfb(Da)}if(Mc){Rfb(Ba)}Rfb(za);Rfb(xa);Z=Z+1|0;}while((Z|0)<(c[W>>2]|0))}W=b+120|0;if((c[W>>2]|0)>0){Z=a+120|0;xa=0;do{c[Ea>>2]=xa;za=P4a(Z,Ea)|0;Lfb(Fa,283600);Ba=w4a(za,Fa)|0;c[Ga>>2]=xa;za=P4a(Z,Ga)|0;Lfb(Ha,283456);if((d5a(o,w4a(za,Ha)|0)|0)==0){c[Ka>>2]=xa;za=P4a(Z,Ka)|0;Lfb(La,283600);Oc=1;Pc=0;Qc=w4a(za,La)|0}else{c[Ia>>2]=xa;za=P4a(Z,Ia)|0;Lfb(Ja,283456);Oc=0;Pc=1;Qc=w4a(o,w4a(za,Ja)|0)|0}Sfb(Ba,Qc)|0;if(Oc){Rfb(La)}if(Pc){Rfb(Ja)}Rfb(Ha);Rfb(Fa);xa=xa+1|0;}while((xa|0)<(c[W>>2]|0))}W=b+124|0;if((c[W>>2]|0)>0){xa=a+156|0;Fa=0;do{c[Ma>>2]=Fa;Ha=P4a(xa,Ma)|0;Lfb(Na,283600);Ja=w4a(Ha,Na)|0;c[Oa>>2]=Fa;Ha=P4a(xa,Oa)|0;Lfb(Pa,283456);if((d5a(o,w4a(Ha,Pa)|0)|0)==0){c[Sa>>2]=Fa;Ha=P4a(xa,Sa)|0;Lfb(Ta,283600);Rc=1;Sc=0;Tc=w4a(Ha,Ta)|0}else{c[Qa>>2]=Fa;Ha=P4a(xa,Qa)|0;Lfb(Ra,283456);Rc=0;Sc=1;Tc=w4a(o,w4a(Ha,Ra)|0)|0}Sfb(Ja,Tc)|0;if(Rc){Rfb(Ta)}if(Sc){Rfb(Ra)}Rfb(Pa);Rfb(Na);Fa=Fa+1|0;}while((Fa|0)<(c[W>>2]|0))}W=b+128|0;if((c[W>>2]|0)>0){Fa=a+60|0;Na=0;do{c[Ua>>2]=Na;Pa=P4a(Fa,Ua)|0;Lfb(Va,283600);Ra=w4a(Pa,Va)|0;c[Wa>>2]=Na;Pa=P4a(Fa,Wa)|0;Lfb(Xa,283456);if((d5a(o,w4a(Pa,Xa)|0)|0)==0){c[_a>>2]=Na;Pa=P4a(Fa,_a)|0;Lfb($a,283600);Uc=1;Vc=0;Wc=w4a(Pa,$a)|0}else{c[Ya>>2]=Na;Pa=P4a(Fa,Ya)|0;Lfb(Za,283456);Uc=0;Vc=1;Wc=w4a(o,w4a(Pa,Za)|0)|0}Sfb(Ra,Wc)|0;if(Uc){Rfb($a)}if(Vc){Rfb(Za)}Rfb(Xa);Rfb(Va);Na=Na+1|0;}while((Na|0)<(c[W>>2]|0))}W=b+132|0;if((c[W>>2]|0)>0){Na=a+96|0;Va=0;do{c[ab>>2]=Va;Xa=P4a(Na,ab)|0;Lfb(bb,283600);Za=w4a(Xa,bb)|0;c[cb>>2]=Va;Xa=P4a(Na,cb)|0;Lfb(db,283456);if((d5a(o,w4a(Xa,db)|0)|0)==0){c[gb>>2]=Va;Xa=P4a(Na,gb)|0;Lfb(hb,283600);Xc=1;Yc=0;Zc=w4a(Xa,hb)|0}else{c[eb>>2]=Va;Xa=P4a(Na,eb)|0;Lfb(fb,283456);Xc=0;Yc=1;Zc=w4a(o,w4a(Xa,fb)|0)|0}Sfb(Za,Zc)|0;if(Xc){Rfb(hb)}if(Yc){Rfb(fb)}Rfb(db);Rfb(bb);Va=Va+1|0;}while((Va|0)<(c[W>>2]|0))}W=b+136|0;if((c[W>>2]|0)>0){Va=a+132|0;bb=0;do{c[ib>>2]=bb;db=P4a(Va,ib)|0;Lfb(jb,283600);fb=w4a(db,jb)|0;c[kb>>2]=bb;db=P4a(Va,kb)|0;Lfb(lb,283456);if((d5a(o,w4a(db,lb)|0)|0)==0){c[ob>>2]=bb;db=P4a(Va,ob)|0;Lfb(pb,283600);_c=1;$c=0;ad=w4a(db,pb)|0}else{c[mb>>2]=bb;db=P4a(Va,mb)|0;Lfb(nb,283456);_c=0;$c=1;ad=w4a(o,w4a(db,nb)|0)|0}Sfb(fb,ad)|0;if(_c){Rfb(pb)}if($c){Rfb(nb)}Rfb(lb);Rfb(jb);bb=bb+1|0;}while((bb|0)<(c[W>>2]|0))}W=b+140|0;if((c[W>>2]|0)>0){bb=a+168|0;jb=0;do{c[qb>>2]=jb;lb=P4a(bb,qb)|0;Lfb(rb,283600);nb=w4a(lb,rb)|0;c[sb>>2]=jb;lb=P4a(bb,sb)|0;Lfb(tb,283456);if((d5a(o,w4a(lb,tb)|0)|0)==0){c[wb>>2]=jb;lb=P4a(bb,wb)|0;Lfb(xb,283600);bd=1;cd=0;dd=w4a(lb,xb)|0}else{c[ub>>2]=jb;lb=P4a(bb,ub)|0;Lfb(vb,283456);bd=0;cd=1;dd=w4a(o,w4a(lb,vb)|0)|0}Sfb(nb,dd)|0;if(bd){Rfb(xb)}if(cd){Rfb(vb)}Rfb(tb);Rfb(rb);jb=jb+1|0;}while((jb|0)<(c[W>>2]|0))}W=b+208|0;if((c[W>>2]|0)>0){jb=a+72|0;rb=0;do{c[yb>>2]=rb;tb=P4a(jb,yb)|0;Lfb(zb,283600);vb=w4a(tb,zb)|0;c[Ab>>2]=rb;tb=P4a(jb,Ab)|0;Lfb(Bb,283456);if((d5a(o,w4a(tb,Bb)|0)|0)==0){c[Eb>>2]=rb;tb=P4a(jb,Eb)|0;Lfb(Fb,283600);ed=1;fd=0;gd=w4a(tb,Fb)|0}else{c[Cb>>2]=rb;tb=P4a(jb,Cb)|0;Lfb(Db,283456);ed=0;fd=1;gd=w4a(o,w4a(tb,Db)|0)|0}Sfb(vb,gd)|0;if(ed){Rfb(Fb)}if(fd){Rfb(Db)}Rfb(Bb);Rfb(zb);rb=rb+1|0;}while((rb|0)<(c[W>>2]|0))}W=b+212|0;if((c[W>>2]|0)>0){rb=a+108|0;zb=0;do{c[Gb>>2]=zb;Bb=P4a(rb,Gb)|0;Lfb(Hb,283600);Db=w4a(Bb,Hb)|0;c[Ib>>2]=zb;Bb=P4a(rb,Ib)|0;Lfb(Jb,283456);if((d5a(o,w4a(Bb,Jb)|0)|0)==0){c[Mb>>2]=zb;Bb=P4a(rb,Mb)|0;Lfb(Nb,283600);hd=0;id=1;jd=w4a(Bb,Nb)|0}else{c[Kb>>2]=zb;Bb=P4a(rb,Kb)|0;Lfb(Lb,283456);hd=1;id=0;jd=w4a(o,w4a(Bb,Lb)|0)|0}Sfb(Db,jd)|0;if(id){Rfb(Nb)}if(hd){Rfb(Lb)}Rfb(Jb);Rfb(Hb);zb=zb+1|0;}while((zb|0)<(c[W>>2]|0))}W=b+216|0;if((c[W>>2]|0)>0){zb=a+144|0;Hb=0;do{c[Ob>>2]=Hb;Jb=P4a(zb,Ob)|0;Lfb(Pb,283600);Lb=w4a(Jb,Pb)|0;c[Qb>>2]=Hb;Jb=P4a(zb,Qb)|0;Lfb(Rb,283456);if((d5a(o,w4a(Jb,Rb)|0)|0)==0){c[Ub>>2]=Hb;Jb=P4a(zb,Ub)|0;Lfb(Vb,283600);kd=1;ld=0;md=w4a(Jb,Vb)|0}else{c[Sb>>2]=Hb;Jb=P4a(zb,Sb)|0;Lfb(Tb,283456);kd=0;ld=1;md=w4a(o,w4a(Jb,Tb)|0)|0}Sfb(Lb,md)|0;if(kd){Rfb(Vb)}if(ld){Rfb(Tb)}Rfb(Rb);Rfb(Pb);Hb=Hb+1|0;}while((Hb|0)<(c[W>>2]|0))}W=b+220|0;if((c[W>>2]|0)>0){b=a+180|0;a=0;do{c[Wb>>2]=a;Hb=P4a(b,Wb)|0;Lfb(Xb,283600);Pb=w4a(Hb,Xb)|0;c[Yb>>2]=a;Hb=P4a(b,Yb)|0;Lfb(Zb,283456);if((d5a(o,w4a(Hb,Zb)|0)|0)==0){c[bc>>2]=a;Hb=P4a(b,bc)|0;Lfb(cc,283600);nd=1;od=0;pd=w4a(Hb,cc)|0}else{c[_b>>2]=a;Hb=P4a(b,_b)|0;Lfb(ac,283456);nd=0;od=1;pd=w4a(o,w4a(Hb,ac)|0)|0}Sfb(Pb,pd)|0;if(nd){Rfb(cc)}if(od){Rfb(ac)}Rfb(Zb);Rfb(Xb);a=a+1|0;}while((a|0)<(c[W>>2]|0))}kXa(23,0,286560,h);Rfb(v);Rfb(u);e5a(o);i=f;return}function P4a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=w7a(a,f,b)|0;l=c[k>>2]|0;g1a(d+16|0);if((l|0)!=0){m=l;n=m;o=n+20|0;p=o;i=d;return p|0}y7a(j,a,b);z7a(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];x7a(g,e);A7a(j);j=c[f>>2]|0;B7a(a,j,k,C7a(g)|0);k=D7a(g)|0;A7a(g);m=k;n=m;o=n+20|0;p=o;i=d;return p|0}function Q4a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=_5a(a,f,b)|0;l=c[k>>2]|0;g1a(d+16|0);if((l|0)!=0){m=l;n=m;o=n+28|0;p=o;i=d;return p|0}a6a(j,a,b);b6a(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];$5a(g,e);c6a(j);j=c[f>>2]|0;d6a(a,j,k,e6a(g)|0);k=f6a(g)|0;c6a(g);m=k;n=m;o=n+28|0;p=o;i=d;return p|0}function R4a(a,b){a=a|0;b=b|0;var c=0;c=i;Sfb(b,a)|0;i=c;return}function S4a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;R5a(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];J5a(a,f);i=e;return}function T4a(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=H5a(a,b)|0;i=c;return d|0}function U4a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;K5a(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];J5a(a,e);i=d;return}function V4a(a){a=a|0;var b=0,c=0;b=i;c=E5a(a)|0;i=b;return c|0}function W4a(a){a=a|0;var b=0;b=i;bab(a);i=b;return}function X4a(a){a=a|0;var b=0;b=i;Q9a(a);i=b;return}function Y4a(a,b){a=a|0;b=b|0;b=i;x8a(a,0);i=b;return}function Z4a(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+108|0;Ogb(d);e=a;c[e>>2]=286628;f=d;c[f>>2]=286648;d=a+8|0;Ghb(a,286660|0,d);c[e>>2]=286628;c[f>>2]=286648;P3a(d);i=b;return}function _4a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=(o1a(a+8|0,b,d|8)|0)==0;d=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;if(f){Fgb(d,4);i=e;return}else{Dgb(d,0);i=e;return}}function $4a(a){a=a|0;var b=0,c=0;b=i;c=z5a(a+8|0)|0;i=b;return c|0}function a5a(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=y5a(a,b,Mgb(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,10)|0)|0;i=d;return e|0}function b5a(a){a=a|0;var b=0;b=i;if((q1a(a+8|0)|0)!=0){i=b;return}Fgb(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,4);i=b;return}function c5a(a){a=a|0;var b=0;b=i;D5a(a,286656);Jgb(a+108|0);i=b;return}function d5a(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=f5a(a,b)|0;i=c;return d|0}function e5a(a){a=a|0;var b=0;b=i;F9a(a);i=b;return}function f5a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+8|0;e=d;f=h5a(a)|0;g1a(e);if((f|0)==0){g=0;i=d;return g|0}h=i5a(a)|0;a=f;while(1){f=a+16|0;if(j5a(h,b,f)|0){j=a}else{if(!(k5a(h,f,b)|0)){g=1;k=8;break}j=a+4|0}f=c[j>>2]|0;g1a(e);if((f|0)==0){g=0;k=8;break}else{a=f}}if((k|0)==8){i=d;return g|0}return 0}function g5a(a){a=a|0;var b=0,c=0;b=i;c=T0a(q5a(a+4|0)|0)|0;i=b;return c|0}function h5a(a){a=a|0;var b=0,d=0;b=i;d=c[(g5a(a)|0)>>2]|0;i=b;return d|0}function i5a(a){a=a|0;var b=0,c=0;b=i;c=o5a(a+8|0)|0;i=b;return c|0}function j5a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=l5a(0,b,c)|0;i=a;return d|0}function k5a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=l5a(0,b,c)|0;i=a;return d|0}function l5a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=m5a(b,c)|0;i=a;return d|0}function m5a(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(ogb(a,b)|0)<0;i=c;return d|0}function n5a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=tqb(a,b,c)|0;i=d;return e|0}function o5a(a){a=a|0;var b=0,c=0;b=i;c=p5a(a)|0;i=b;return c|0}function p5a(a){a=a|0;i=i;return a|0}function q5a(a){a=a|0;var b=0,c=0;b=i;c=r5a(a)|0;i=b;return c|0}function r5a(a){a=a|0;i=i;return a|0}function s5a(a,b){a=a|0;b=b|0;var c=0;a=i;c=u5a(0,b,0)|0;i=a;return c|0}function t5a(b,c){b=b|0;c=c|0;a[b]=a[c]|0;i=i;return}function u5a(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=aqb(b)|0;i=c;return a|0}function v5a(a){a=a|0;var b=0,c=0;b=i;c=yqb(a|0)|0;i=b;return c|0}function w5a(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=x5a(b,c,e)|0;i=d;return g|0}function x5a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=k2a(0,a,b)|0;i=c;return(d?b:a)|0}function y5a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;Lhb(f,a,1);if(!(Ohb(f)|0)){i=e;return a|0}fgb(b);f=0;while(1){g=Ugb(Kgb(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0)|0)|0;if(a2a(g,-1)|0){h=2;j=f;break}k=f+1|0;l=b2a(g)|0;if(f2a(l,d)|0){h=0;j=k;break}hgb(b,l);if((Pfb(b)|0)==-17){h=4;j=k;break}else{f=k}}Fgb(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,(j|0)==0?h|4:h);i=e;return a|0}function z5a(a){a=a|0;i=i;return(c[a+64>>2]|0)!=0|0}function A5a(a){a=a|0;var b=0;b=i;c5a(a);cqb(a);i=b;return}function B5a(a){a=a|0;var b=0;b=i;c5a(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function C5a(a){a=a|0;var b=0;b=i;A5a(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function D5a(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];Q1a(a+8|0);i=d;return}function E5a(a){a=a|0;var b=0,d=0;b=i;d=F5a((c[a>>2]|0)+16|0)|0;i=b;return d|0}function F5a(a){a=a|0;var b=0,c=0;b=i;c=G5a(a)|0;i=b;return c|0}function G5a(a){a=a|0;i=i;return a|0}function H5a(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(I5a(a,b)|0)^1;i=c;return d|0}function I5a(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function J5a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];Q5a(a,e);i=d;return}function K5a(a,b){a=a|0;b=b|0;var c=0;c=i;L5a(a,M5a(b)|0);i=c;return}function L5a(a,b){a=a|0;b=b|0;var c=0;c=i;P5a(a,b);i=c;return}function M5a(a){a=a|0;var b=0,c=0;b=i;c=T0a(N5a(a+4|0)|0)|0;i=b;return c|0}function N5a(a){a=a|0;var b=0,c=0;b=i;c=O5a(a)|0;i=b;return c|0}function O5a(a){a=a|0;i=i;return a|0}function P5a(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function Q5a(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function R5a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=T5a(b)|0;S5a(f,b,d,h,M5a(b)|0);K5a(g,b);do{if(H5a(f,g)|0){h=U5a(b)|0;if(V5a(h,d,W5a(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);K5a(a,b);i=e;return}function S5a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;g1a(h);a:do{if((e|0)==0){j=f}else{k=U5a(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(Z5a(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;g1a(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;g1a(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);L5a(a,j);i=g;return}function T5a(a){a=a|0;var b=0,d=0;b=i;d=c[(M5a(a)|0)>>2]|0;i=b;return d|0}function U5a(a){a=a|0;var b=0,c=0;b=i;c=X5a(a+8|0)|0;i=b;return c|0}function V5a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=l5a(0,b,c)|0;i=a;return d|0}function W5a(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function X5a(a){a=a|0;var b=0,c=0;b=i;c=Y5a(a)|0;i=b;return c|0}function Y5a(a){a=a|0;i=i;return a|0}function Z5a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=l5a(0,b,c)|0;i=a;return d|0}function _5a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=T5a(h)|0;g1a(e);if((a|0)==0){j=M5a(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(l5a(0,d,a)|0){m=l;j=c[m>>2]|0;g1a(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(l5a(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;g1a(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function $5a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];W6a(a,e);i=d;return}function a6a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=B6a(d)|0;d=D6a(n,1)|0;E6a(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];C6a(j,d,h);F6a(0,u6a((G6a(j)|0)+16|0)|0,e);e=H6a(j)|0;a[e+4|0]=1;I6a(0,s6a((G6a(j)|0)+28|0)|0);a[e+5|0]=1;J6a(m,j);b6a(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];$5a(b,g);c6a(m);c6a(j);i=f;return}function b6a(a,b){a=a|0;b=b|0;var c=0;c=i;z6a(a,b);i=c;return}function c6a(a){a=a|0;var b=0;b=i;o6a(a);i=b;return}function d6a(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;g1a(f);c[e>>2]=0;g1a(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=k6a(a)|0;b=c[c[e>>2]>>2]|0;g1a(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(M5a(a)|0)>>2]|0;S2a(e,c[d>>2]|0);d=l6a(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function e6a(a){a=a|0;var b=0,d=0;b=i;d=c[(i6a(a)|0)>>2]|0;i=b;return d|0}function f6a(a){a=a|0;var b=0,d=0;b=i;d=g6a(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function g6a(a){a=a|0;var b=0,c=0;b=i;c=h6a(a)|0;i=b;return c|0}function h6a(a){a=a|0;i=i;return a|0}function i6a(a){a=a|0;var b=0,c=0;b=i;c=j6a(a)|0;i=b;return c|0}function j6a(a){a=a|0;i=i;return a|0}function k6a(a){a=a|0;i=i;return a|0}function l6a(a){a=a|0;var b=0,c=0;b=i;c=m6a(a+8|0)|0;i=b;return c|0}function m6a(a){a=a|0;var b=0,c=0;b=i;c=n6a(a)|0;i=b;return c|0}function n6a(a){a=a|0;i=i;return a|0}function o6a(a){a=a|0;var b=0;b=i;p6a(a,0);i=b;return}function p6a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=g6a(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}r6a(q6a(e)|0,f);i=d;return}function q6a(a){a=a|0;var b=0,c=0;b=i;c=y6a(a)|0;i=b;return c|0}function r6a(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+4|0]|0)!=0){f=c[b>>2]|0;t6a(f,u6a(d+16|0)|0)}if((d|0)==0){i=e;return}v6a(c[b>>2]|0,d,1);i=e;return}function s6a(a){a=a|0;i=i;return a|0}function t6a(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;x6a(d,0,c);i=b;return}function u6a(a){a=a|0;i=i;return a|0}function v6a(a,b,c){a=a|0;b=b|0;c=c|0;c=i;w6a(0,b,0);i=c;return}function w6a(a,b,c){a=a|0;b=b|0;c=c|0;c=i;cqb(b);i=c;return}function x6a(a,b,c){a=a|0;b=b|0;c=c|0;b=i;Rfb(c);i=b;return}function y6a(a){a=a|0;i=i;return a+4|0}function z6a(a,b){a=a|0;b=b|0;var c=0;c=i;A6a(a,b);i=c;return}function A6a(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function B6a(a){a=a|0;var b=0,c=0;b=i;c=U6a(a+4|0)|0;i=b;return c|0}function C6a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];M6a(a,b,f);i=e;return}function D6a(a,b){a=a|0;b=b|0;var c=0;a=i;c=L6a(0,b,0)|0;i=a;return c|0}function E6a(a,b){a=a|0;b=b|0;var c=0;c=i;K6a(a,b);i=c;return}function F6a(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}Hfb(b,c);i=a;return}function G6a(a){a=a|0;var b=0,d=0;b=i;d=c[(i6a(a)|0)>>2]|0;i=b;return d|0}function H6a(a){a=a|0;var b=0,c=0;b=i;c=q6a(a)|0;i=b;return c|0}function I6a(a,b){a=a|0;b=b|0;if((b|0)!=0){c[b>>2]=0}i=i;return}function J6a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;z6a(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];$5a(h,f);b6a(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];$5a(a,e);c6a(h);i=d;return}function K6a(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function L6a(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=aqb(b<<5)|0;i=c;return a|0}function M6a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(O6a(g)|0)>>2]|0;g=P6a(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];N6a(b,a,f);i=e;return}function N6a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];Q6a(a,b,f);i=e;return}function O6a(a){a=a|0;i=i;return a|0}function P6a(a){a=a|0;i=i;return a|0}function Q6a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(S6a(g)|0)>>2]|0;g=T6a(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];R6a(b,a,f);i=e;return}function R6a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(S6a(f)|0)>>2];f=T6a(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function S6a(a){a=a|0;i=i;return a|0}function T6a(a){a=a|0;i=i;return a|0}function U6a(a){a=a|0;var b=0,c=0;b=i;c=V6a(a)|0;i=b;return c|0}function V6a(a){a=a|0;i=i;return a|0}function W6a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=f6a(X6a(b)|0)|0;h=T6a(H6a(X6a(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];N6a(g,a,e);i=d;return}function X6a(a){a=a|0;i=i;return c[a>>2]|0}function Y6a(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function Z6a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];e7a(a,e);i=d;return}function _6a(a,b){a=a|0;b=b|0;var c=0;c=i;$6a(a,a7a(b)|0);i=c;return}function $6a(a,b){a=a|0;b=b|0;var c=0;c=i;d7a(a,b);i=c;return}function a7a(a){a=a|0;var b=0,c=0;b=i;c=T0a(b7a(a+4|0)|0)|0;i=b;return c|0}function b7a(a){a=a|0;var b=0,c=0;b=i;c=c7a(a)|0;i=b;return c|0}function c7a(a){a=a|0;i=i;return a|0}function d7a(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function e7a(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function f7a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=h7a(b)|0;g7a(f,b,d,h,a7a(b)|0);_6a(g,b);do{if(i7a(f,g)|0){h=j7a(b)|0;if(j5a(h,d,k7a(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);_6a(a,b);i=e;return}function g7a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;g1a(h);a:do{if((e|0)==0){j=f}else{k=j7a(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(k5a(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;g1a(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;g1a(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);$6a(a,j);i=g;return}function h7a(a){a=a|0;var b=0,d=0;b=i;d=c[(a7a(a)|0)>>2]|0;i=b;return d|0}function i7a(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(Y6a(a,b)|0)^1;i=c;return d|0}function j7a(a){a=a|0;var b=0,c=0;b=i;c=l7a(a+8|0)|0;i=b;return c|0}function k7a(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function l7a(a){a=a|0;var b=0,c=0;b=i;c=m7a(a)|0;i=b;return c|0}function m7a(a){a=a|0;i=i;return a|0}function n7a(a,b){a=a|0;b=b|0;b=i;i=i+8|0;o7a(a,b);i=b;return}function o7a(a,b){a=a|0;b=b|0;b=i;p7a(a,0);i=b;return}function p7a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;q7a(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;r7a(f,0,e);e=M5a(b)|0;c[(k6a(b)|0)>>2]=e;i=d;return}function q7a(a){a=a|0;var b=0;b=i;u7a(a);i=b;return}function r7a(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;s7a(b,c,f);i=e;return}function s7a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(K3a(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;t7a(d,b,f);i=e;return}function t7a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(K3a(e)|0)>>2];i=d;return}function u7a(a){a=a|0;var b=0;b=i;v7a(a);i=b;return}function v7a(a){a=a|0;var b=0;b=i;N3a(a);i=b;return}function w7a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=w8a(h)|0;g1a(e);if((a|0)==0){j=J7a(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(d1a(0,d,a)|0){m=l;j=c[m>>2]|0;g1a(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(d1a(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;g1a(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function x7a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];u8a(a,e);i=d;return}function y7a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=$7a(d)|0;d=b8a(n,1)|0;c8a(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];a8a(j,d,h);d8a(0,c3a((e8a(j)|0)+16|0)|0,e);e=f8a(j)|0;a[e+4|0]=1;g8a(0,U7a((e8a(j)|0)+20|0)|0);a[e+5|0]=1;h8a(m,j);z7a(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];x7a(b,g);A7a(m);A7a(j);i=f;return}function z7a(a,b){a=a|0;b=b|0;var c=0;c=i;Z7a(a,b);i=c;return}function A7a(a){a=a|0;var b=0;b=i;P7a(a);i=b;return}function B7a(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;g1a(f);c[e>>2]=0;g1a(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=I7a(a)|0;b=c[c[e>>2]>>2]|0;g1a(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(J7a(a)|0)>>2]|0;S2a(e,c[d>>2]|0);d=K7a(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function C7a(a){a=a|0;var b=0,d=0;b=i;d=c[(G7a(a)|0)>>2]|0;i=b;return d|0}function D7a(a){a=a|0;var b=0,d=0;b=i;d=E7a(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function E7a(a){a=a|0;var b=0,c=0;b=i;c=F7a(a)|0;i=b;return c|0}function F7a(a){a=a|0;i=i;return a|0}function G7a(a){a=a|0;var b=0,c=0;b=i;c=H7a(a)|0;i=b;return c|0}function H7a(a){a=a|0;i=i;return a|0}function I7a(a){a=a|0;i=i;return a|0}function J7a(a){a=a|0;var b=0,c=0;b=i;c=T0a(N7a(a+4|0)|0)|0;i=b;return c|0}function K7a(a){a=a|0;var b=0,c=0;b=i;c=L7a(a+8|0)|0;i=b;return c|0}function L7a(a){a=a|0;var b=0,c=0;b=i;c=M7a(a)|0;i=b;return c|0}function M7a(a){a=a|0;i=i;return a|0}function N7a(a){a=a|0;var b=0,c=0;b=i;c=O7a(a)|0;i=b;return c|0}function O7a(a){a=a|0;i=i;return a|0}function P7a(a){a=a|0;var b=0;b=i;Q7a(a,0);i=b;return}function Q7a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=E7a(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}S7a(R7a(e)|0,f);i=d;return}function R7a(a){a=a|0;var b=0,c=0;b=i;c=Y7a(a)|0;i=b;return c|0}function S7a(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+5|0]|0)!=0){f=c[b>>2]|0;T7a(f,U7a(d+20|0)|0)}if((d|0)==0){i=e;return}V7a(c[b>>2]|0,d,1);i=e;return}function T7a(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;X7a(d,0,c);i=b;return}function U7a(a){a=a|0;i=i;return a|0}function V7a(a,b,c){a=a|0;b=b|0;c=c|0;c=i;W7a(0,b,0);i=c;return}function W7a(a,b,c){a=a|0;b=b|0;c=c|0;c=i;cqb(b);i=c;return}function X7a(a,b,c){a=a|0;b=b|0;c=c|0;b=i;e5a(c);i=b;return}function Y7a(a){a=a|0;i=i;return a+4|0}function Z7a(a,b){a=a|0;b=b|0;var c=0;c=i;_7a(a,b);i=c;return}function _7a(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function $7a(a){a=a|0;var b=0,c=0;b=i;c=s8a(a+4|0)|0;i=b;return c|0}function a8a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];k8a(a,b,f);i=e;return}function b8a(a,b){a=a|0;b=b|0;var c=0;a=i;c=j8a(0,b,0)|0;i=a;return c|0}function c8a(a,b){a=a|0;b=b|0;var c=0;c=i;i8a(a,b);i=c;return}function d8a(a,b,d){a=a|0;b=b|0;d=d|0;if((b|0)!=0){c[b>>2]=c[d>>2]}i=i;return}function e8a(a){a=a|0;var b=0,d=0;b=i;d=c[(G7a(a)|0)>>2]|0;i=b;return d|0}function f8a(a){a=a|0;var b=0,c=0;b=i;c=R7a(a)|0;i=b;return c|0}function g8a(a,b){a=a|0;b=b|0;a=i;i=i+8|0;if((b|0)==0){i=a;return}Y4a(b,a);i=a;return}function h8a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;Z7a(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];x7a(h,f);z7a(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];x7a(a,e);A7a(h);i=d;return}function i8a(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function j8a(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=aqb(b<<5)|0;i=c;return a|0}function k8a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(m8a(g)|0)>>2]|0;g=n8a(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];l8a(b,a,f);i=e;return}function l8a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];o8a(a,b,f);i=e;return}function m8a(a){a=a|0;i=i;return a|0}function n8a(a){a=a|0;i=i;return a|0}function o8a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(q8a(g)|0)>>2]|0;g=r8a(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];p8a(b,a,f);i=e;return}function p8a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(q8a(f)|0)>>2];f=r8a(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function q8a(a){a=a|0;i=i;return a|0}function r8a(a){a=a|0;i=i;return a|0}function s8a(a){a=a|0;var b=0,c=0;b=i;c=t8a(a)|0;i=b;return c|0}function t8a(a){a=a|0;i=i;return a|0}function u8a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=D7a(v8a(b)|0)|0;h=r8a(f8a(v8a(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];l8a(g,a,e);i=d;return}function v8a(a){a=a|0;i=i;return c[a>>2]|0}function w8a(a){a=a|0;var b=0,d=0;b=i;d=c[(J7a(a)|0)>>2]|0;i=b;return d|0}function x8a(a,b){a=a|0;b=b|0;b=i;i=i+8|0;y8a(a,b);i=b;return}function y8a(a,b){a=a|0;b=b|0;b=i;z8a(a,0);i=b;return}function z8a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;A8a(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;B8a(f,0,e);e=a7a(b)|0;c[(C8a(b)|0)>>2]=e;i=d;return}function A8a(a){a=a|0;var b=0;b=i;F8a(a);i=b;return}function B8a(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;D8a(b,c,f);i=e;return}function C8a(a){a=a|0;i=i;return a|0}function D8a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(K3a(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;E8a(d,b,f);i=e;return}function E8a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(K3a(e)|0)>>2];i=d;return}function F8a(a){a=a|0;var b=0;b=i;G8a(a);i=b;return}function G8a(a){a=a|0;var b=0;b=i;N3a(a);i=b;return}function H8a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=h7a(h)|0;g1a(e);if((a|0)==0){j=a7a(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(l5a(0,d,a)|0){m=l;j=c[m>>2]|0;g1a(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(l5a(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;g1a(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function I8a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];D9a(a,e);i=d;return}function J8a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=i9a(d)|0;d=k9a(n,1)|0;l9a(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];j9a(j,d,h);m9a(0,u6a((n9a(j)|0)+16|0)|0,e);e=o9a(j)|0;a[e+4|0]=1;p9a(0,$8a((n9a(j)|0)+28|0)|0);a[e+5|0]=1;q9a(m,j);K8a(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];I8a(b,g);L8a(m);L8a(j);i=f;return}function K8a(a,b){a=a|0;b=b|0;var c=0;c=i;g9a(a,b);i=c;return}function L8a(a){a=a|0;var b=0;b=i;W8a(a);i=b;return}function M8a(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;g1a(f);c[e>>2]=0;g1a(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=C8a(a)|0;b=c[c[e>>2]>>2]|0;g1a(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(a7a(a)|0)>>2]|0;S2a(e,c[d>>2]|0);d=T8a(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function N8a(a){a=a|0;var b=0,d=0;b=i;d=c[(R8a(a)|0)>>2]|0;i=b;return d|0}function O8a(a){a=a|0;var b=0,d=0;b=i;d=P8a(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function P8a(a){a=a|0;var b=0,c=0;b=i;c=Q8a(a)|0;i=b;return c|0}function Q8a(a){a=a|0;i=i;return a|0}function R8a(a){a=a|0;var b=0,c=0;b=i;c=S8a(a)|0;i=b;return c|0}function S8a(a){a=a|0;i=i;return a|0}function T8a(a){a=a|0;var b=0,c=0;b=i;c=U8a(a+8|0)|0;i=b;return c|0}function U8a(a){a=a|0;var b=0,c=0;b=i;c=V8a(a)|0;i=b;return c|0}function V8a(a){a=a|0;i=i;return a|0}function W8a(a){a=a|0;var b=0;b=i;X8a(a,0);i=b;return}function X8a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=P8a(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}Z8a(Y8a(e)|0,f);i=d;return}function Y8a(a){a=a|0;var b=0,c=0;b=i;c=f9a(a)|0;i=b;return c|0}function Z8a(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+5|0]|0)!=0){f=c[b>>2]|0;_8a(f,$8a(d+28|0)|0)}if((a[b+4|0]|0)!=0){f=c[b>>2]|0;a9a(f,u6a(d+16|0)|0)}if((d|0)==0){i=e;return}b9a(c[b>>2]|0,d,1);i=e;return}function _8a(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;e9a(d,0,c);i=b;return}function $8a(a){a=a|0;i=i;return a|0}function a9a(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;d9a(d,0,c);i=b;return}function b9a(a,b,c){a=a|0;b=b|0;c=c|0;c=i;c9a(0,b,0);i=c;return}function c9a(a,b,c){a=a|0;b=b|0;c=c|0;c=i;cqb(b);i=c;return}function d9a(a,b,c){a=a|0;b=b|0;c=c|0;b=i;Rfb(c);i=b;return}function e9a(a,b,c){a=a|0;b=b|0;c=c|0;b=i;Rfb(c);i=b;return}function f9a(a){a=a|0;i=i;return a+4|0}function g9a(a,b){a=a|0;b=b|0;var c=0;c=i;h9a(a,b);i=c;return}function h9a(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function i9a(a){a=a|0;var b=0,c=0;b=i;c=B9a(a+4|0)|0;i=b;return c|0}function j9a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];t9a(a,b,f);i=e;return}function k9a(a,b){a=a|0;b=b|0;var c=0;a=i;c=s9a(0,b,0)|0;i=a;return c|0}function l9a(a,b){a=a|0;b=b|0;var c=0;c=i;r9a(a,b);i=c;return}function m9a(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}Hfb(b,c);i=a;return}function n9a(a){a=a|0;var b=0,d=0;b=i;d=c[(R8a(a)|0)>>2]|0;i=b;return d|0}function o9a(a){a=a|0;var b=0,c=0;b=i;c=Y8a(a)|0;i=b;return c|0}function p9a(a,b){a=a|0;b=b|0;a=i;if((b|0)==0){i=a;return}Ffb(b);i=a;return}function q9a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;g9a(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];I8a(h,f);K8a(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];I8a(a,e);L8a(h);i=d;return}function r9a(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function s9a(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=aqb(b*40|0)|0;i=c;return a|0}function t9a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(v9a(g)|0)>>2]|0;g=w9a(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];u9a(b,a,f);i=e;return}function u9a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];x9a(a,b,f);i=e;return}function v9a(a){a=a|0;i=i;return a|0}function w9a(a){a=a|0;i=i;return a|0}function x9a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(z9a(g)|0)>>2]|0;g=A9a(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];y9a(b,a,f);i=e;return}function y9a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(z9a(f)|0)>>2];f=A9a(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function z9a(a){a=a|0;i=i;return a|0}function A9a(a){a=a|0;i=i;return a|0}function B9a(a){a=a|0;var b=0,c=0;b=i;c=C9a(a)|0;i=b;return c|0}function C9a(a){a=a|0;i=i;return a|0}function D9a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=O8a(E9a(b)|0)|0;h=A9a(o9a(E9a(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];u9a(g,a,e);i=d;return}function E9a(a){a=a|0;i=i;return c[a>>2]|0}function F9a(a){a=a|0;var b=0;b=i;G9a(a);i=b;return}function G9a(a){a=a|0;var b=0;b=i;H9a(a);i=b;return}function H9a(a){a=a|0;var b=0;b=i;I9a(a,h7a(a)|0);i=b;return}function I9a(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;g1a(d);if((b|0)==0){i=d;return}I9a(a,c[b>>2]|0);I9a(a,c[b+4>>2]|0);e=i9a(a)|0;J9a(e,K9a(b+16|0)|0);b9a(e,b,1);i=d;return}function J9a(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;L9a(d,0,c);i=b;return}function K9a(a){a=a|0;i=i;return a|0}function L9a(a,b,c){a=a|0;b=b|0;c=c|0;b=i;M9a(c);i=b;return}function M9a(a){a=a|0;var b=0;b=i;N9a(a);i=b;return}function N9a(a){a=a|0;var b=0;b=i;O9a(a);i=b;return}function O9a(a){a=a|0;var b=0;b=i;P9a(a);i=b;return}function P9a(a){a=a|0;var b=0;b=i;Rfb(a+12|0);Rfb(a);i=b;return}function Q9a(a){a=a|0;var b=0;b=i;R9a(a+180|0);R9a(a+168|0);R9a(a+156|0);R9a(a+144|0);R9a(a+132|0);R9a(a+120|0);R9a(a+108|0);R9a(a+96|0);R9a(a+84|0);R9a(a+72|0);R9a(a+60|0);R9a(a+48|0);R9a(a+36|0);R9a(a+24|0);e5a(a+12|0);e5a(a);i=b;return}function R9a(a){a=a|0;var b=0;b=i;S9a(a);i=b;return}function S9a(a){a=a|0;var b=0;b=i;T9a(a);i=b;return}function T9a(a){a=a|0;var b=0;b=i;U9a(a);i=b;return}function U9a(a){a=a|0;var b=0;b=i;V9a(a,w8a(a)|0);i=b;return}function V9a(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;g1a(d);if((b|0)==0){i=d;return}V9a(a,c[b>>2]|0);V9a(a,c[b+4>>2]|0);e=$7a(a)|0;W9a(e,X9a(b+16|0)|0);V7a(e,b,1);i=d;return}function W9a(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;Y9a(d,0,c);i=b;return}function X9a(a){a=a|0;i=i;return a|0}function Y9a(a,b,c){a=a|0;b=b|0;c=c|0;b=i;Z9a(c);i=b;return}function Z9a(a){a=a|0;var b=0;b=i;_9a(a);i=b;return}function _9a(a){a=a|0;var b=0;b=i;$9a(a);i=b;return}function $9a(a){a=a|0;var b=0;b=i;aab(a);i=b;return}function aab(a){a=a|0;var b=0;b=i;e5a(a+4|0);i=b;return}function bab(a){a=a|0;var b=0;b=i;cab(a);i=b;return}function cab(a){a=a|0;var b=0;b=i;dab(a);i=b;return}function dab(a){a=a|0;var b=0;b=i;eab(a,T5a(a)|0);i=b;return}function eab(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;g1a(d);if((b|0)==0){i=d;return}eab(a,c[b>>2]|0);eab(a,c[b+4>>2]|0);e=B6a(a)|0;fab(e,G5a(b+16|0)|0);v6a(e,b,1);i=d;return}function fab(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;gab(d,0,c);i=b;return}function gab(a,b,c){a=a|0;b=b|0;c=c|0;b=i;hab(c);i=b;return}function hab(a){a=a|0;var b=0;b=i;iab(a);i=b;return}function iab(a){a=a|0;var b=0;b=i;jab(a);i=b;return}function jab(a){a=a|0;var b=0;b=i;kab(a);i=b;return}function kab(a){a=a|0;var b=0;b=i;Rfb(a);i=b;return}function lab(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;mab(a);oab(g,b);pab(h,b);b=f;j=g;c[b+0>>2]=c[j+0>>2];j=e;b=h;c[j+0>>2]=c[b+0>>2];nab(a,f,e);i=d;return a|0}function mab(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;I9a(a,h7a(a)|0);c[(T8a(a)|0)>>2]=0;d=a7a(a)|0;c[(C8a(a)|0)>>2]=d;g1a(b);c[d>>2]=0;i=b;return}function nab(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+48|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;xab(h,a);if(!(yab(b,d)|0)){i=e;return}m=c[h>>2]|0;h=k;do{c[h>>2]=m;n=g;o=k;c[n+0>>2]=c[o+0>>2];qab(j,g);o=Aab(b)|0;n=f;p=j;c[n+0>>2]=c[p+0>>2];zab(l,a,f,o);Bab(b)|0;}while(yab(b,d)|0);i=e;return}function oab(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;vab(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];qab(a,e);i=d;return}function pab(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;rab(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];qab(a,e);i=d;return}function qab(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];uab(a,e);i=d;return}function rab(a,b){a=a|0;b=b|0;var c=0;c=i;sab(a,g5a(b)|0);i=c;return}function sab(a,b){a=a|0;b=b|0;var c=0;c=i;tab(a,b);i=c;return}function tab(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function uab(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function vab(a,b){a=a|0;b=b|0;var d=0;d=i;sab(a,c[(wab(b)|0)>>2]|0);i=d;return}function wab(a){a=a|0;i=i;return a|0}function xab(a,b){a=a|0;b=b|0;var c=0;c=i;pab(a,b);i=c;return}function yab(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=Hbb(a,b)|0;i=c;return d|0}function zab(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+56|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=b;c[k>>2]=c[d>>2];Jab(l,e);e=h;d=k;c[e+0>>2]=c[d+0>>2];Iab(j,m,h,l);h=g;m=j;c[h+0>>2]=c[m+0>>2];Z6a(a,g);M9a(l);i=f;return}function Aab(a){a=a|0;var b=0,c=0;b=i;c=Fab(a)|0;i=b;return c|0}function Bab(a){a=a|0;var b=0;b=i;Cab(a)|0;i=b;return a|0}function Cab(a){a=a|0;var b=0,d=0;b=i;d=a;c[d>>2]=Dab(c[d>>2]|0)|0;i=b;return a|0}function Dab(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=a+4|0;e=c[d>>2]|0;g1a(b);if((e|0)==0){e=a;while(1){a=W2a(e)|0;f=c[e+8>>2]|0;if(a){g=f;break}else{e=f}}i=b;return g|0}else{g=Eab(c[d>>2]|0)|0;i=b;return g|0}return 0}function Eab(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a;f=c[e>>2]|0;g1a(d);if((f|0)==0){g=a;i=b;return g|0}else{h=e}while(1){e=c[h>>2]|0;a=e;f=c[a>>2]|0;g1a(d);if((f|0)==0){g=e;break}else{h=a}}i=b;return g|0}function Fab(a){a=a|0;var b=0,d=0;b=i;d=Gab((c[a>>2]|0)+16|0)|0;i=b;return d|0}function Gab(a){a=a|0;var b=0,c=0;b=i;c=Hab(a)|0;i=b;return c|0}function Hab(a){a=a|0;i=i;return a|0}function Iab(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+80|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+56|0;o=f+64|0;c[k>>2]=c[d>>2];d=h;p=k;c[d+0>>2]=c[p+0>>2];p=Nab(b,h,j,e)|0;h=c[p>>2]|0;g1a(l);if((h|0)!=0){q=h;$6a(a,q);i=f;return}Pab(o,b,e);Qab(n,o);e=g;h=n;c[e+0>>2]=c[h+0>>2];Oab(m,g);Rab(o);o=c[j>>2]|0;M8a(b,o,p,Sab(m)|0);p=Tab(m)|0;Rab(m);q=p;$6a(a,q);i=f;return}function Jab(a,b){a=a|0;b=b|0;var c=0;c=i;Kab(a,b);i=c;return}function Kab(a,b){a=a|0;b=b|0;var c=0;c=i;Lab(a,b);i=c;return}function Lab(a,b){a=a|0;b=b|0;var c=0;c=i;Mab(a,b);i=c;return}function Mab(a,b){a=a|0;b=b|0;var c=0;c=i;Hfb(a,b);Hfb(a+12|0,b+12|0);i=c;return}function Nab(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+120|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+48|0;o=f+56|0;p=f+64|0;q=f+72|0;r=f+80|0;s=f+88|0;t=f+96|0;u=f+104|0;v=f+112|0;_6a(m,a);w=k;x=m;c[w+0>>2]=c[x+0>>2];vbb(l,k);do{if(!(ubb(b,l)|0)){k=j7a(a)|0;x=xbb(b)|0;if(wbb(k,e,x)|0){break}w=wbb(k,x,e)|0;x=c[b>>2]|0;if(!w){c[d>>2]=x;y=d;i=f;return y|0}c[s>>2]=x;w=h;m=s;c[w+0>>2]=c[m+0>>2];Bbb(r,h,1,0);_6a(u,a);m=g;w=u;c[m+0>>2]=c[w+0>>2];vbb(t,g);do{if(!(ubb(r,t)|0)){if(wbb(k,e,xbb(r)|0)|0){break}y=Abb(a,d,e)|0;i=f;return y|0}}while(0);k=x+4|0;w=c[k>>2]|0;g1a(v);if((w|0)==0){c[d>>2]=x;y=k;i=f;return y|0}else{k=c[r>>2]|0;c[d>>2]=k;y=k;i=f;return y|0}}}while(0);r=c[b>>2]|0;b=n;c[b>>2]=r;ybb(p,a);v=j;t=p;c[v+0>>2]=c[t+0>>2];vbb(o,j);do{if(!(ubb(n,o)|0)){j=j7a(a)|0;if(wbb(j,xbb(zbb(n)|0)|0,e)|0){break}y=Abb(a,d,e)|0;i=f;return y|0}}while(0);e=r;a=c[e>>2]|0;g1a(q);if((a|0)==0){c[d>>2]=r;y=e;i=f;return y|0}else{e=c[b>>2]|0;c[d>>2]=e;y=e+4|0;i=f;return y|0}return 0}function Oab(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];sbb(a,e);i=d;return}function Pab(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=i9a(d)|0;d=k9a(n,1)|0;ebb(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];dbb(j,d,h);fbb(0,K9a((gbb(j)|0)+16|0)|0,e);a[(hbb(j)|0)+4|0]=1;ibb(m,j);Qab(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];Oab(b,g);Rab(m);Rab(j);i=f;return}function Qab(a,b){a=a|0;b=b|0;var c=0;c=i;bbb(a,b);i=c;return}function Rab(a){a=a|0;var b=0;b=i;Yab(a);i=b;return}function Sab(a){a=a|0;var b=0,d=0;b=i;d=c[(Wab(a)|0)>>2]|0;i=b;return d|0}function Tab(a){a=a|0;var b=0,d=0;b=i;d=Uab(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function Uab(a){a=a|0;var b=0,c=0;b=i;c=Vab(a)|0;i=b;return c|0}function Vab(a){a=a|0;i=i;return a|0}function Wab(a){a=a|0;var b=0,c=0;b=i;c=Xab(a)|0;i=b;return c|0}function Xab(a){a=a|0;i=i;return a|0}function Yab(a){a=a|0;var b=0;b=i;Zab(a,0);i=b;return}function Zab(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=Uab(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}$ab(_ab(e)|0,f);i=d;return}function _ab(a){a=a|0;var b=0,c=0;b=i;c=abb(a)|0;i=b;return c|0}function $ab(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+4|0]|0)!=0){f=c[b>>2]|0;J9a(f,K9a(d+16|0)|0)}if((d|0)==0){i=e;return}b9a(c[b>>2]|0,d,1);i=e;return}function abb(a){a=a|0;i=i;return a+4|0}function bbb(a,b){a=a|0;b=b|0;var c=0;c=i;cbb(a,b);i=c;return}function cbb(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function dbb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];mbb(a,b,f);i=e;return}function ebb(a,b){a=a|0;b=b|0;var c=0;c=i;lbb(a,b);i=c;return}function fbb(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}jbb(b,c);i=a;return}function gbb(a){a=a|0;var b=0,d=0;b=i;d=c[(Wab(a)|0)>>2]|0;i=b;return d|0}function hbb(a){a=a|0;var b=0,c=0;b=i;c=_ab(a)|0;i=b;return c|0}function ibb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;bbb(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];Oab(h,f);Qab(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];Oab(a,e);Rab(h);i=d;return}function jbb(a,b){a=a|0;b=b|0;var c=0;c=i;kbb(a,b);i=c;return}function kbb(a,b){a=a|0;b=b|0;var c=0;c=i;Lab(a,b);i=c;return}function lbb(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;i=i;return}function mbb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(v9a(g)|0)>>2]|0;g=obb(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];nbb(b,a,f);i=e;return}function nbb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];pbb(a,b,f);i=e;return}function obb(a){a=a|0;i=i;return a|0}function pbb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(z9a(g)|0)>>2]|0;g=rbb(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];qbb(b,a,f);i=e;return}function qbb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(z9a(f)|0)>>2];f=rbb(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function rbb(a){a=a|0;i=i;return a|0}function sbb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=Tab(tbb(b)|0)|0;h=rbb(hbb(tbb(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];nbb(g,a,e);i=d;return}function tbb(a){a=a|0;i=i;return c[a>>2]|0}function ubb(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function vbb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];Gbb(a,e);i=d;return}function wbb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=l5a(0,b,c)|0;i=a;return d|0}function xbb(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function ybb(a,b){a=a|0;b=b|0;var d=0;d=i;$6a(a,c[(C8a(b)|0)>>2]|0);i=d;return}function zbb(a){a=a|0;var b=0,d=0;b=i;d=a;c[d>>2]=Ebb(c[d>>2]|0)|0;i=b;return a|0}function Abb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=h7a(a)|0;g1a(e);if((h|0)==0){j=a7a(a)|0;c[b>>2]=j;k=j;i=e;return k|0}j=j7a(a)|0;a=h;while(1){h=a+16|0;if(wbb(j,d,h)|0){l=a;m=c[l>>2]|0;g1a(f);if((m|0)==0){n=5;break}else{o=l}}else{p=a;if(!(wbb(j,h,d)|0)){n=10;break}q=a+4|0;h=c[q>>2]|0;g1a(g);if((h|0)==0){n=9;break}else{o=q}}a=c[o>>2]|0}if((n|0)==5){c[b>>2]=a;k=l;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==10){c[b>>2]=p;k=b;i=e;return k|0}return 0}function Bbb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;Cbb(b,d);c[a>>2]=c[b>>2];i=e;return}function Cbb(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;Dbb(b,c,e);i=d;return}function Dbb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;c=i;if(!((b|0)>-1)){d=b;do{zbb(a)|0;d=d+1|0;}while((d|0)<0);i=c;return}if((b|0)>0){e=b}else{i=c;return}do{Cab(a)|0;e=e+ -1|0;}while((e|0)>0);i=c;return}function Ebb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=a;e=c[d>>2]|0;g1a(b);if((e|0)==0){e=a;while(1){a=W2a(e)|0;f=c[e+8>>2]|0;if(a){e=f}else{g=f;break}}i=b;return g|0}else{g=Fbb(c[d>>2]|0)|0;i=b;return g|0}return 0}function Fbb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[e>>2]|0;g1a(d);if((f|0)==0){g=a;i=b;return g|0}else{h=e}while(1){e=c[h>>2]|0;a=e+4|0;f=c[a>>2]|0;g1a(d);if((f|0)==0){g=e;break}else{h=a}}i=b;return g|0}function Gbb(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function Hbb(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(ubb(a,b)|0)^1;i=c;return d|0}function Ibb(a){a=a|0;var b=0;b=i;i=i+128|0;Y4a(a,b);Y4a(a+12|0,b+8|0);Jbb(a+24|0,b+16|0);Jbb(a+36|0,b+24|0);Jbb(a+48|0,b+32|0);Jbb(a+60|0,b+40|0);Jbb(a+72|0,b+48|0);Jbb(a+84|0,b+56|0);Jbb(a+96|0,b+64|0);Jbb(a+108|0,b+72|0);Jbb(a+120|0,b+80|0);Jbb(a+132|0,b+88|0);Jbb(a+144|0,b+96|0);Jbb(a+156|0,b+104|0);Jbb(a+168|0,b+112|0);Jbb(a+180|0,b+120|0);i=b;return}function Jbb(a,b){a=a|0;b=b|0;b=i;Kbb(a,0);i=b;return}function Kbb(a,b){a=a|0;b=b|0;b=i;i=i+8|0;Lbb(a,b);i=b;return}function Lbb(a,b){a=a|0;b=b|0;b=i;Mbb(a,0);i=b;return}function Mbb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;Nbb(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;Obb(f,0,e);e=J7a(b)|0;c[(I7a(b)|0)>>2]=e;i=d;return}function Nbb(a){a=a|0;var b=0;b=i;Rbb(a);i=b;return}function Obb(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;Pbb(b,c,f);i=e;return}function Pbb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(K3a(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;Qbb(d,b,f);i=e;return}function Qbb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(K3a(e)|0)>>2];i=d;return}function Rbb(a){a=a|0;var b=0;b=i;Sbb(a);i=b;return}function Sbb(a){a=a|0;var b=0;b=i;N3a(a);i=b;return}function Tbb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;b=i;i=i+8|0;a=b;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=c[297092>>2]|0;if((m|0)==0){n=0}else{o=aqb(12)|0;Lfb(o,m);n=o}if((c[297008>>2]|0)!=0){c[60018]=1}if((n|0)==0){c[240084>>2]=1;c[240088>>2]=1;i=b;return}do{if((ngb(n,287232,0)|0)==-1){Hfb(g,n);Ffb(h);o=c[59592]|0;m=(o|0)<28;while(1){p=ngb(g,287240,0)|0;q=(p|0)!=-1;if(q){lgb(j,g,0,p);Sfb(h,j)|0;Rfb(j);lgb(k,g,p+1|0,-1);Sfb(g,k)|0;Rfb(k)}else{Sfb(h,g)|0}if(m){r=1;s=o}else{t=20;break}while(1){Lfb(l,c[238784+(s<<2)>>2]|0);p=Ubb(h,l)|0;Rfb(l);if(p){c[240080+(s<<2)>>2]=1;u=0}else{u=r}p=s+1|0;if((p|0)<28){r=u;s=p}else{break}}if((u|0)!=0){t=18;break}if(!q){t=23;break}}if((t|0)==18){mXa(1,1,287248,f);if(m){v=o}else{w=240632;x=c[60158]|0;me[x&2047](1);y=mgb(n)|0;z=a;A=z;c[A>>2]=y;B=5;C=B;D=287288;E=D;oXa(0,E,a)}do{p=c[239952+(v<<2)>>2]|0;c[e>>2]=c[238784+(v<<2)>>2];c[e+4>>2]=p;mXa(1,0,287272,e);v=v+1|0;}while((v|0)<28);w=240632;x=c[60158]|0;me[x&2047](1);y=mgb(n)|0;z=a;A=z;c[A>>2]=y;B=5;C=B;D=287288;E=D;oXa(0,E,a)}else if((t|0)==20){mXa(1,1,287248,d);w=240632;x=c[60158]|0;me[x&2047](1);y=mgb(n)|0;z=a;A=z;c[A>>2]=y;B=5;C=B;D=287288;E=D;oXa(0,E,a)}else if((t|0)==23){Rfb(h);Rfb(g);break}}else{o=1;do{c[240080+(o<<2)>>2]=1;o=o+1|0;}while((o|0)<28)}}while(0);c[240084>>2]=1;c[240088>>2]=1;if((c[240116>>2]|0)!=0){c[240176>>2]=1}if((c[240172>>2]|0)==1){c[240180>>2]=1}if((c[240152>>2]|0)!=0){c[240148>>2]=1}if((c[240160>>2]|0)!=0){c[240148>>2]=1}if((c[240112>>2]|0)!=0){c[240108>>2]=1}if((c[240156>>2]|0)!=0){c[240148>>2]=1}if((c[240104>>2]|0)!=0){c[240100>>2]=1}Rfb(n);cqb(n);i=b;return}function Ubb(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=Pfb(b)|0;if((e|0)!=(Pfb(c)|0)){f=0;i=d;return f|0}g=Qfb(b)|0;h=Qfb(c)|0;if(Ifb(b)|0){f=(n5a(g,h,e)|0)==0;i=d;return f|0}if((e|0)==0){f=1;i=d;return f|0}else{j=e;k=g;l=h}while(1){if((a[k]|0)!=(a[l]|0)){f=0;m=7;break}h=j+ -1|0;if((h|0)==0){f=1;m=7;break}else{j=h;k=k+1|0;l=l+1|0}}if((m|0)==7){i=d;return f|0}return 0}function Vbb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;a=b;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=c[297100>>2]|0;if((h|0)==0){j=1;i=b;return j|0}k=aqb(12)|0;l=k;Lfb(l,h);if((k|0)==0){j=1;i=b;return j|0}else{m=1}while(1){k=m+1|0;if(Wbb(l,c[272328+(m<<2)>>2]|0)|0){j=m;n=6;break}if((k|0)<4){m=k}else{n=5;break}}if((n|0)==5){c[g>>2]=mgb(l)|0;mXa(1,1,287320,g);g=c[272412>>2]|0;c[f>>2]=c[272332>>2];c[f+4>>2]=g;mXa(1,0,287272,f);f=c[272416>>2]|0;c[e>>2]=c[272336>>2];c[e+4>>2]=f;mXa(1,0,287272,e);e=c[272420>>2]|0;c[d>>2]=c[272340>>2];c[d+4>>2]=e;mXa(1,0,287272,d);me[c[60158]&2047](1);oXa(0,287376,a)}else if((n|0)==6){i=b;return j|0}return 0}function Wbb(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(pgb(a,b)|0)==0;i=c;return d|0}function Xbb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;a=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+16|0;g=i;i=i+16|0;h=c[297084>>2]|0;if((h|0)==0){j=1;i=b;return j|0}k=aqb(12)|0;l=k;Lfb(l,h);if((k|0)==0){j=1;i=b;return j|0}Lfb(f,287400);k=Ubb(l,f)|0;Rfb(f);if(k){j=1;i=b;return j|0}Lfb(g,287408);k=Ubb(l,g)|0;Rfb(g);if(k){j=2;i=b;return j|0}else{c[e>>2]=mgb(l)|0;mXa(1,1,287416,e);c[d>>2]=287400;c[d+4>>2]=287472;mXa(1,0,287272,d);c[a>>2]=287408;c[a+4>>2]=287488;mXa(1,0,287272,a);me[c[60158]&2047](1);oXa(0,287376,b)}return 0}function Ybb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;_hb(f,a);if(!(bib(f)|0)){$hb(f);i=d;return a|0}j=v5a(b)|0;kcb(g,a);k=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;l=k;if(((k1a(l)|0)&176|0)==32){m=b+j|0}else{m=b}n=Lgb(k)|0;k=b+j|0;j=e;o=g;c[j+0>>2]=c[o+0>>2];ncb(h,e,b,m,k,l,n);if(!(lcb(h)|0)){$hb(f);i=d;return a|0}Fgb(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,5);$hb(f);i=d;return a|0}function Zbb(a){a=a|0;var b=0;b=i;eib(a,Mgb(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,10)|0)|0;Nhb(a)|0;i=b;return a|0}function _bb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+2128|0;g=f;h=f+32|0;j=f+48|0;k=f+64|0;l=f+80|0;Lfb(h,d);Agb(k,287496,h);I4a(j,k,287504);Rfb(k);k=mgb(j)|0;d=b+104|0;do{if((c[d>>2]|0)>0){m=b;n=c[m>>2]|0;if((uqb(c[n+4>>2]|0,287512)|0)!=0){break}a[n+104|0]=1;a[(c[m>>2]|0)+((c[d>>2]|0)*112|0)+104|0]=1}}while(0);if((uqb(k,287520)|0)==0){Rfb(j);Rfb(h);i=f;return}d=cpb(g,k,1)|0;if((d|0)!=0){m=l;Cqb(m|0,0,2048)|0;ppb(d,g,m,2048)|0;cib(Ybb(Ybb(Ybb(Ybb(Ybb(309488,287528)|0,k)|0,287568)|0,m)|0,287584)|0,103)|0;Rfb(j);Rfb(h);i=f;return}m=b+108|0;k=c[m>>2]|0;if((k|0)>0){d=b;l=k;k=0;while(1){n=c[d>>2]|0;if((a[n+(k*112|0)+104|0]|0)==0){o=(qpb(g,c[n+(k*112|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[d>>2]|0)+(k*112|0)+104|0]=o;p=c[m>>2]|0}else{p=l}o=k+1|0;if((o|0)<(p|0)){l=p;k=o}else{break}}}k=b+208|0;if((c[k>>2]|0)>0){p=b+32|0;l=b;m=(e|0)==0;d=b+16|0;o=0;do{n=c[p>>2]|0;do{if((a[n+(o*52|0)+48|0]|0)==0){q=a[n+(o*52|0)+8|0]|0;if(q<<24>>24==1){r=(qpb(g,c[n+(o*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(o*52|0)+48|0]=r;r=c[p>>2]|0;if((a[r+(o*52|0)+48|0]|0)!=0|m){break}a[(c[d>>2]|0)+((c[r+(o*52|0)+4>>2]|0)*112|0)+104|0]=0;break}else if(q<<24>>24==0){q=(qpb(g,c[n+(o*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(o*52|0)+48|0]=q;q=c[p>>2]|0;if((a[q+(o*52|0)+48|0]|0)!=0){break}a[(c[l>>2]|0)+((c[q+(o*52|0)+4>>2]|0)*112|0)+104|0]=0;break}else{break}}}while(0);o=o+1|0;}while((o|0)<(c[k>>2]|0))}k=b+116|0;o=c[k>>2]|0;if((o|0)>0){l=b+4|0;p=o;o=0;while(1){d=c[l>>2]|0;if((a[d+(o*60|0)+56|0]|0)==0){m=(qpb(g,c[d+(o*60|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[l>>2]|0)+(o*60|0)+56|0]=m;s=c[k>>2]|0}else{s=p}m=o+1|0;if((m|0)<(s|0)){p=s;o=m}else{break}}}o=b+212|0;if((c[o>>2]|0)>0){s=b+36|0;p=b+4|0;k=(e|0)==0;l=b+20|0;m=0;do{d=c[s>>2]|0;do{if((a[d+(m*52|0)+48|0]|0)==0){n=a[d+(m*52|0)+8|0]|0;if(n<<24>>24==0){q=(qpb(g,c[d+(m*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(m*52|0)+48|0]=q;q=c[s>>2]|0;if((a[q+(m*52|0)+48|0]|0)!=0){break}a[(c[p>>2]|0)+((c[q+(m*52|0)+4>>2]|0)*60|0)+56|0]=0;break}else if(n<<24>>24==1){n=(qpb(g,c[d+(m*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(m*52|0)+48|0]=n;n=c[s>>2]|0;if((a[n+(m*52|0)+48|0]|0)!=0|k){break}a[(c[l>>2]|0)+((c[n+(m*52|0)+4>>2]|0)*60|0)+56|0]=0;break}else{break}}}while(0);m=m+1|0;}while((m|0)<(c[o>>2]|0))}o=b+120|0;m=c[o>>2]|0;if((m|0)>0){l=b+8|0;k=m;m=0;while(1){s=c[l>>2]|0;if((a[s+(m*48|0)+44|0]|0)==0){p=(qpb(g,c[s+(m*48|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[l>>2]|0)+(m*48|0)+44|0]=p;t=c[o>>2]|0}else{t=k}p=m+1|0;if((p|0)<(t|0)){k=t;m=p}else{break}}}m=b+216|0;if((c[m>>2]|0)>0){t=b+40|0;k=b+8|0;o=(e|0)==0;l=b+24|0;p=0;do{s=c[t>>2]|0;do{if((a[s+(p*52|0)+48|0]|0)==0){d=a[s+(p*52|0)+8|0]|0;if(d<<24>>24==1){n=(qpb(g,c[s+(p*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[t>>2]|0)+(p*52|0)+48|0]=n;n=c[t>>2]|0;if((a[n+(p*52|0)+48|0]|0)!=0|o){break}a[(c[l>>2]|0)+((c[n+(p*52|0)+4>>2]|0)*48|0)+44|0]=0;break}else if(d<<24>>24==0){d=(qpb(g,c[s+(p*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[t>>2]|0)+(p*52|0)+48|0]=d;d=c[t>>2]|0;if((a[d+(p*52|0)+48|0]|0)!=0){break}a[(c[k>>2]|0)+((c[d+(p*52|0)+4>>2]|0)*48|0)+44|0]=0;break}else{break}}}while(0);p=p+1|0;}while((p|0)<(c[m>>2]|0))}m=b+124|0;p=c[m>>2]|0;if((p|0)>0){k=b+12|0;t=p;p=0;while(1){l=c[k>>2]|0;if((a[l+(p*52|0)+48|0]|0)==0){o=(qpb(g,c[l+(p*52|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[k>>2]|0)+(p*52|0)+48|0]=o;u=c[m>>2]|0}else{u=t}o=p+1|0;if((o|0)<(u|0)){t=u;p=o}else{break}}}p=b+220|0;if((c[p>>2]|0)>0){u=b+44|0;t=b+12|0;m=(e|0)==0;e=b+28|0;b=0;do{k=c[u>>2]|0;do{if((a[k+(b*52|0)+48|0]|0)==0){o=a[k+(b*52|0)+8|0]|0;if(o<<24>>24==1){l=(qpb(g,c[k+(b*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[u>>2]|0)+(b*52|0)+48|0]=l;l=c[u>>2]|0;if((a[l+(b*52|0)+48|0]|0)!=0|m){break}a[(c[e>>2]|0)+((c[l+(b*52|0)+4>>2]|0)*52|0)+48|0]=0;break}else if(o<<24>>24==0){o=(qpb(g,c[k+(b*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[u>>2]|0)+(b*52|0)+48|0]=o;o=c[u>>2]|0;if((a[o+(b*52|0)+48|0]|0)!=0){break}a[(c[t>>2]|0)+((c[o+(b*52|0)+4>>2]|0)*52|0)+48|0]=0;break}else{break}}}while(0);b=b+1|0;}while((b|0)<(c[p>>2]|0))}gpb(g);Rfb(j);Rfb(h);i=f;return}



function XBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[104216]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12008>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12008>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=RXa(104224,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12008>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[104216]=1;i=d;return}function YBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[104376]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12e3>>3],.001)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12e3>>3],.25)|0)<<24>>24==0)){i=d;return}b=RXa(104384,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+12e3>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[104376]=1;i=d;return}function ZBa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[104536]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11992>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11992>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(104544,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11992>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[104536]=1;i=d;return}function _Ba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[104696]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11984>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11984>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=RXa(104704,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11984>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[104696]=1;i=d;return}function $Ba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[104856]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11976>>3],.001)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11976>>3],.25)|0)<<24>>24==0)){i=d;return}b=RXa(104864,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11976>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[104856]=1;i=d;return}function aCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[105016]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11968>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11968>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(105024,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11968>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[105016]=1;i=d;return}function bCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[105176]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11960>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11960>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=RXa(105184,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11960>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[105176]=1;i=d;return}function cCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[105336]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11952>>3],.001)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11952>>3],.25)|0)<<24>>24==0)){i=d;return}b=RXa(105344,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11952>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[105336]=1;i=d;return}function dCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[105496]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11944>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11944>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(105504,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11944>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[105496]=1;i=d;return}function eCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[105656]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11936>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11936>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=RXa(105664,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11936>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[105656]=1;i=d;return}function fCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[105816]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11928>>3],.001)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11928>>3],.25)|0)<<24>>24==0)){i=d;return}b=RXa(105824,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11928>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[105816]=1;i=d;return}function gCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[105976]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11920>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11920>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(105984,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11920>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[105976]=1;i=d;return}function hCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[106136]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11912>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11912>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=RXa(106144,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11912>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[106136]=1;i=d;return}function iCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[106296]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11904>>3],.001)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11904>>3],.25)|0)<<24>>24==0)){i=d;return}b=RXa(106304,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11904>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[106296]=1;i=d;return}function jCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[106456]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11896>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11896>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(106464,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11896>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[106456]=1;i=d;return}function kCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[106616]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11888>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11888>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=RXa(106624,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11888>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[106616]=1;i=d;return}function lCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[106776]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11880>>3],.001)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11880>>3],.25)|0)<<24>>24==0)){i=d;return}b=RXa(106784,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11880>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[106776]=1;i=d;return}function mCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[106936]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11872>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11872>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(106944,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11872>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[106936]=1;i=d;return}function nCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[107096]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11864>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11864>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=RXa(107104,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11864>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[107096]=1;i=d;return}function oCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[107256]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11856>>3],.001)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11856>>3],.25)|0)<<24>>24==0)){i=d;return}b=RXa(107264,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11856>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[107256]=1;i=d;return}function pCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[107416]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11848>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11848>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(107424,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11848>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[107416]=1;i=d;return}function qCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[107576]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11840>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11840>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=RXa(107584,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11840>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[107576]=1;i=d;return}function rCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[107736]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11832>>3],.001)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11832>>3],.25)|0)<<24>>24==0)){i=d;return}b=RXa(107744,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11832>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[107736]=1;i=d;return}function sCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[107896]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11824>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11824>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(107904,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11824>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[107896]=1;i=d;return}function tCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[108056]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11816>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11816>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=RXa(108064,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11816>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[108056]=1;i=d;return}function uCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[108216]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11808>>3],.001)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11808>>3],.25)|0)<<24>>24==0)){i=d;return}b=RXa(108224,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11808>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[108216]=1;i=d;return}function vCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[108376]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11800>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11800>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(108384,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11800>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[108376]=1;i=d;return}function wCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[108536]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11792>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11792>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=RXa(108544,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11792>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[108536]=1;i=d;return}function xCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[108696]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11784>>3],.001)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11784>>3],.25)|0)<<24>>24==0)){i=d;return}b=RXa(108704,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11784>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[108696]=1;i=d;return}function yCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[108856]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11776>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11776>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(108864,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11776>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[108856]=1;i=d;return}function zCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[109016]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11768>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11768>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=RXa(109024,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11768>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[109016]=1;i=d;return}function ACa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[109176]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11760>>3],.001)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11760>>3],.25)|0)<<24>>24==0)){i=d;return}b=RXa(109184,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11760>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[109176]=1;i=d;return}function BCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[109336]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11752>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11752>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(109344,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11752>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[109336]=1;i=d;return}function CCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[109496]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11744>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11744>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=RXa(109504,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11744>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[109496]=1;i=d;return}function DCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[109656]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11736>>3],.001)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11736>>3],.25)|0)<<24>>24==0)){i=d;return}b=RXa(109664,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11736>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[109656]=1;i=d;return}function ECa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[109816]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11728>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11728>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(109824,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11728>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[109816]=1;i=d;return}function FCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[109976]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11720>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11720>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=RXa(109984,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11720>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[109976]=1;i=d;return}function GCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[110136]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11712>>3],.001)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11712>>3],.25)|0)<<24>>24==0)){i=d;return}b=RXa(110144,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11712>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[110136]=1;i=d;return}function HCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[110296]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11704>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11704>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(110304,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11704>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[110296]=1;i=d;return}function ICa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[110456]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11696>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11696>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=RXa(110464,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11696>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[110456]=1;i=d;return}function JCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[110616]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11688>>3],.001)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11688>>3],.25)|0)<<24>>24==0)){i=d;return}b=RXa(110624,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11688>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[110616]=1;i=d;return}function KCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[110776]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11680>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11680>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(110784,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11680>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[110776]=1;i=d;return}function LCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[110936]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11672>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11672>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=RXa(110944,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11672>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[110936]=1;i=d;return}function MCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[111096]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11664>>3],.001)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11664>>3],.25)|0)<<24>>24==0)){i=d;return}b=RXa(111104,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11664>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[111096]=1;i=d;return}function NCa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[111256]&1){i=d;return}g=b+4|0;b=E_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+160>>2]|0),0.0)|0;if(!(b<<24>>24==0|(C_a(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+160>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=RXa(111264,NXa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+160>>2]|0,57744)|0)|0;g=c[72302]|0;h=e;j=111408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[111256]=1;i=d;return}function OCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[111432]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11656>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11656>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(111440,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11656>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[111432]=1;i=d;return}function PCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[111592]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11648>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11648>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=RXa(111600,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11648>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[111592]=1;i=d;return}function QCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[111752]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11640>>3],.001)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11640>>3],.25)|0)<<24>>24==0)){i=d;return}b=RXa(111760,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11640>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[111752]=1;i=d;return}function RCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[111912]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11632>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11632>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(111920,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11632>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[111912]=1;i=d;return}function SCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[112072]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11624>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11624>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=RXa(112080,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11624>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[112072]=1;i=d;return}function TCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[112232]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11616>>3],.001)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11616>>3],.25)|0)<<24>>24==0)){i=d;return}b=RXa(112240,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11616>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[112232]=1;i=d;return}function UCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[112392]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11608>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11608>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(112400,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11608>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[112392]=1;i=d;return}function VCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[112552]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11600>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11600>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=RXa(112560,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11600>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[112552]=1;i=d;return}function WCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[112712]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11592>>3],.001)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11592>>3],.25)|0)<<24>>24==0)){i=d;return}b=RXa(112720,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11592>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[112712]=1;i=d;return}function XCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[112872]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11584>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11584>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(112880,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11584>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[112872]=1;i=d;return}function YCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[113032]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11576>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11576>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=RXa(113040,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11576>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[113032]=1;i=d;return}function ZCa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[113192]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11568>>3],.001)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11568>>3],.25)|0)<<24>>24==0)){i=d;return}b=RXa(113200,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11568>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[113192]=1;i=d;return}function _Ca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[113352]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11560>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11560>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(113360,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11560>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[113352]=1;i=d;return}function $Ca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[113512]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11552>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11552>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=RXa(113520,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11552>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[113512]=1;i=d;return}function aDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[113672]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11544>>3],.001)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11544>>3],.25)|0)<<24>>24==0)){i=d;return}b=RXa(113680,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11544>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[113672]=1;i=d;return}function bDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[113832]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11536>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11536>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(113840,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11536>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[113832]=1;i=d;return}function cDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[113992]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11528>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11528>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=RXa(114e3,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11528>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[113992]=1;i=d;return}function dDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[114152]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11520>>3],.001)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11520>>3],.25)|0)<<24>>24==0)){i=d;return}b=RXa(114160,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11520>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[114152]=1;i=d;return}function eDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[114312]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11512>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11512>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(114320,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11512>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[114312]=1;i=d;return}function fDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[114472]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11504>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11504>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=RXa(114480,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11504>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[114472]=1;i=d;return}function gDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[114632]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11496>>3],.001)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11496>>3],.25)|0)<<24>>24==0)){i=d;return}b=RXa(114640,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11496>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[114632]=1;i=d;return}function hDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[114792]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11488>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11488>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(114800,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11488>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[114792]=1;i=d;return}function iDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[114952]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11480>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11480>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=RXa(114960,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11480>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[114952]=1;i=d;return}function jDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[115112]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11472>>3],.001)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11472>>3],.25)|0)<<24>>24==0)){i=d;return}b=RXa(115120,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11472>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[115112]=1;i=d;return}function kDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[115272]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11464>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11464>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(115280,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11464>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[115272]=1;i=d;return}function lDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[115432]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11456>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11456>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=RXa(115440,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11456>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[115432]=1;i=d;return}function mDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[115592]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11448>>3],.001)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11448>>3],.25)|0)<<24>>24==0)){i=d;return}b=RXa(115600,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11448>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[115592]=1;i=d;return}function nDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[115752]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11440>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11440>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(115760,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11440>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[115752]=1;i=d;return}function oDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[115912]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11432>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11432>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=RXa(115920,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11432>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[115912]=1;i=d;return}function pDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[116072]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11424>>3],.001)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11424>>3],.25)|0)<<24>>24==0)){i=d;return}b=RXa(116080,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11424>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[116072]=1;i=d;return}function qDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[116232]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11416>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11416>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(116240,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11416>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[116232]=1;i=d;return}function rDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[116392]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11408>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11408>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=RXa(116400,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11408>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[116392]=1;i=d;return}function sDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[116552]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11400>>3],.001)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11400>>3],.25)|0)<<24>>24==0)){i=d;return}b=RXa(116560,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11400>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[116552]=1;i=d;return}function tDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[116712]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11392>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11392>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(116720,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11392>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[116712]=1;i=d;return}function uDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[116872]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11384>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11384>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=RXa(116880,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11384>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[116872]=1;i=d;return}function vDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[117032]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11376>>3],.001)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11376>>3],.25)|0)<<24>>24==0)){i=d;return}b=RXa(117040,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11376>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[117032]=1;i=d;return}function wDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[117192]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11368>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11368>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(117200,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11368>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[117192]=1;i=d;return}function xDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[117352]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11360>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11360>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=RXa(117360,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11360>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[117352]=1;i=d;return}function yDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[117512]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11352>>3],.001)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11352>>3],.25)|0)<<24>>24==0)){i=d;return}b=RXa(117520,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11352>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[117512]=1;i=d;return}function zDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[117672]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11344>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11344>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(117680,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11344>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[117672]=1;i=d;return}function ADa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[117832]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11336>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11336>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=RXa(117840,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11336>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[117832]=1;i=d;return}function BDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[117992]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11328>>3],.001)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11328>>3],.25)|0)<<24>>24==0)){i=d;return}b=RXa(118e3,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11328>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[117992]=1;i=d;return}function CDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[118152]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11320>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11320>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(118160,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11320>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[118152]=1;i=d;return}function DDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[118312]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11312>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11312>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=RXa(118320,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11312>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[118312]=1;i=d;return}function EDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[118472]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11304>>3],.001)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11304>>3],.25)|0)<<24>>24==0)){i=d;return}b=RXa(118480,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11304>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[118472]=1;i=d;return}function FDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[118632]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11296>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11296>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(118640,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11296>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[118632]=1;i=d;return}function GDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[118792]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11288>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11288>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=RXa(118800,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11288>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[118792]=1;i=d;return}function HDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[118952]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11280>>3],.001)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11280>>3],.25)|0)<<24>>24==0)){i=d;return}b=RXa(118960,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11280>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[118952]=1;i=d;return}function IDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[119112]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11272>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11272>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(119120,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11272>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[119112]=1;i=d;return}function JDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[119272]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11264>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11264>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=RXa(119280,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11264>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[119272]=1;i=d;return}function KDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[119432]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11256>>3],.001)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11256>>3],.25)|0)<<24>>24==0)){i=d;return}b=RXa(119440,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11256>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[119432]=1;i=d;return}function LDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[119592]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11248>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11248>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(119600,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11248>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[119592]=1;i=d;return}function MDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[119752]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11240>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11240>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=RXa(119760,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11240>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[119752]=1;i=d;return}function NDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[119912]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11232>>3],.001)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11232>>3],.25)|0)<<24>>24==0)){i=d;return}b=RXa(119920,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11232>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[119912]=1;i=d;return}function ODa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[120072]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11224>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11224>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(120080,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11224>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[120072]=1;i=d;return}function PDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[120232]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11216>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11216>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=RXa(120240,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11216>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[120232]=1;i=d;return}function QDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[120392]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11208>>3],.001)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11208>>3],.25)|0)<<24>>24==0)){i=d;return}b=RXa(120400,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11208>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[120392]=1;i=d;return}function RDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[120552]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11200>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11200>>3],1.0)|0)<<24>>24==0)){i=d;return}b=RXa(120560,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11200>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[120552]=1;i=d;return}function SDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[120736]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11192>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11192>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=RXa(120744,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11192>>3],58584)|0)|0;g=c[72302]|0;j=e;k=120896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[120736]=1;i=d;return}function TDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[120920]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11184>>3],.001)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11184>>3],.25)|0)<<24>>24==0)){i=d;return}b=RXa(120928,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11184>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[120920]=1;i=d;return}function UDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[121104]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11016>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11016>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(121112,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11016>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121448;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[121104]=1;i=d;return}function VDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[121272]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11008>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11008>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(121280,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+11008>>3],58584)|0)|0;g=c[72302]|0;j=e;k=121448;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[121272]=1;i=d;return}function WDa(a){a=a|0;var b=0;b=i;bka(a);cka(a);dka(a);eka(a);fka(a);gka(a);hka(a);ika(a);jka(a);kka(a);lka(a);mka(a);nka(a);oka(a);pka(a);qka(a);rka(a);ska(a);tka(a);uka(a);vka(a);wka(a);xka(a);yka(a);zka(a);Aka(a);Bka(a);Cka(a);Dka(a);Eka(a);Fka(a);Gka(a);Hka(a);Ika(a);Jka(a);Kka(a);Lka(a);Mka(a);Nka(a);Oka(a);Pka(a);Qka(a);Rka(a);Ska(a);Tka(a);Uka(a);Vka(a);Wka(a);Xka(a);Yka(a);Zka(a);_ka(a);$ka(a);ala(a);bla(a);cla(a);dla(a);ela(a);fla(a);gla(a);hla(a);ila(a);jla(a);kla(a);lla(a);mla(a);nla(a);ola(a);pla(a);qla(a);rla(a);sla(a);tla(a);ula(a);vla(a);wla(a);xla(a);yla(a);zla(a);Ala(a);Bla(a);Cla(a);Dla(a);Ela(a);Fla(a);Gla(a);Hla(a);Ila(a);Jla(a);Kla(a);Lla(a);Mla(a);Nla(a);Ola(a);Pla(a);Qla(a);Rla(a);Sla(a);Tla(a);Ula(a);Vla(a);Wla(a);Xla(a);Yla(a);Zla(a);_la(a);$la(a);ama(a);bma(a);cma(a);dma(a);ema(a);fma(a);gma(a);hma(a);ima(a);jma(a);kma(a);lma(a);mma(a);nma(a);oma(a);pma(a);qma(a);rma(a);sma(a);tma(a);uma(a);vma(a);wma(a);xma(a);yma(a);zma(a);Ama(a);Bma(a);Cma(a);Dma(a);Ema(a);Fma(a);Gma(a);Hma(a);Ima(a);Jma(a);Kma(a);Lma(a);Mma(a);Nma(a);Oma(a);Pma(a);Qma(a);Rma(a);Sma(a);Tma(a);Uma(a);Vma(a);Wma(a);Xma(a);Yma(a);Zma(a);_ma(a);$ma(a);ana(a);bna(a);cna(a);dna(a);ena(a);fna(a);gna(a);hna(a);ina(a);jna(a);kna(a);lna(a);mna(a);nna(a);ona(a);pna(a);qna(a);rna(a);sna(a);tna(a);una(a);vna(a);wna(a);xna(a);yna(a);zna(a);Ana(a);Bna(a);Cna(a);Dna(a);Ena(a);Fna(a);Gna(a);Hna(a);Ina(a);Jna(a);Kna(a);Lna(a);Mna(a);Nna(a);Ona(a);Pna(a);Qna(a);Rna(a);Sna(a);Tna(a);Una(a);Vna(a);Wna(a);Xna(a);Yna(a);Zna(a);_na(a);$na(a);aoa(a);boa(a);coa(a);doa(a);eoa(a);foa(a);goa(a);hoa(a);ioa(a);joa(a);koa(a);loa(a);moa(a);noa(a);ooa(a);poa(a);qoa(a);roa(a);soa(a);toa(a);uoa(a);voa(a);woa(a);xoa(a);yoa(a);zoa(a);Aoa(a);Boa(a);Coa(a);Doa(a);Eoa(a);Foa(a);Goa(a);Hoa(a);Ioa(a);Joa(a);Koa(a);Loa(a);Moa(a);Noa(a);Ooa(a);Poa(a);Qoa(a);Roa(a);Soa(a);Toa(a);Uoa(a);Voa(a);Woa(a);Xoa(a);Yoa(a);Zoa(a);_oa(a);$oa(a);apa(a);bpa(a);cpa(a);dpa(a);epa(a);fpa(a);gpa(a);hpa(a);ipa(a);jpa(a);kpa(a);lpa(a);mpa(a);npa(a);opa(a);ppa(a);qpa(a);rpa(a);spa(a);tpa(a);upa(a);vpa(a);wpa(a);xpa(a);ypa(a);zpa(a);Apa(a);Bpa(a);Cpa(a);Dpa(a);Epa(a);Fpa(a);Gpa(a);Hpa(a);Ipa(a);Jpa(a);Kpa(a);Lpa(a);Mpa(a);Npa(a);Opa(a);Ppa(a);Qpa(a);Rpa(a);Spa(a);Tpa(a);Upa(a);Vpa(a);Wpa(a);Xpa(a);Ypa(a);Zpa(a);_pa(a);$pa(a);aqa(a);bqa(a);cqa(a);dqa(a);eqa(a);fqa(a);gqa(a);hqa(a);iqa(a);jqa(a);kqa(a);lqa(a);mqa(a);nqa(a);oqa(a);pqa(a);qqa(a);rqa(a);sqa(a);tqa(a);uqa(a);vqa(a);wqa(a);xqa(a);yqa(a);zqa(a);Aqa(a);Bqa(a);Cqa(a);Dqa(a);Eqa(a);Fqa(a);Gqa(a);Hqa(a);Iqa(a);Jqa(a);Kqa(a);Lqa(a);Mqa(a);Nqa(a);Oqa(a);Pqa(a);Qqa(a);Rqa(a);Sqa(a);Tqa(a);Uqa(a);Vqa(a);Wqa(a);Xqa(a);Yqa(a);Zqa(a);_qa(a);$qa(a);ara(a);bra(a);cra(a);dra(a);era(a);fra(a);gra(a);hra(a);ira(a);jra(a);kra(a);lra(a);mra(a);nra(a);ora(a);pra(a);qra(a);rra(a);sra(a);tra(a);ura(a);vra(a);wra(a);xra(a);yra(a);zra(a);Ara(a);Bra(a);Cra(a);Dra(a);Era(a);Fra(a);Gra(a);Hra(a);Ira(a);Jra(a);Kra(a);Lra(a);Mra(a);Nra(a);Ora(a);Pra(a);Qra(a);Rra(a);Sra(a);Tra(a);Ura(a);Vra(a);Wra(a);Xra(a);Yra(a);Zra(a);_ra(a);$ra(a);asa(a);bsa(a);csa(a);dsa(a);esa(a);fsa(a);gsa(a);hsa(a);isa(a);jsa(a);ksa(a);lsa(a);msa(a);nsa(a);osa(a);psa(a);qsa(a);rsa(a);ssa(a);tsa(a);usa(a);vsa(a);wsa(a);xsa(a);ysa(a);zsa(a);Asa(a);Bsa(a);Csa(a);Dsa(a);Esa(a);Fsa(a);Gsa(a);Hsa(a);Isa(a);Jsa(a);Ksa(a);Lsa(a);Msa(a);Nsa(a);Osa(a);Psa(a);Qsa(a);Rsa(a);Ssa(a);Tsa(a);Usa(a);Vsa(a);Wsa(a);Xsa(a);Ysa(a);Zsa(a);_sa(a);$sa(a);ata(a);bta(a);cta(a);dta(a);eta(a);fta(a);gta(a);hta(a);ita(a);jta(a);kta(a);lta(a);mta(a);nta(a);ota(a);pta(a);qta(a);rta(a);sta(a);tta(a);uta(a);vta(a);wta(a);xta(a);yta(a);zta(a);Ata(a);Bta(a);Cta(a);Dta(a);Eta(a);Fta(a);Gta(a);Hta(a);Ita(a);Jta(a);Kta(a);Lta(a);Mta(a);Nta(a);Ota(a);Pta(a);Qta(a);Rta(a);Sta(a);Tta(a);Uta(a);Vta(a);Wta(a);Xta(a);Yta(a);Zta(a);_ta(a);$ta(a);aua(a);bua(a);cua(a);dua(a);eua(a);fua(a);gua(a);hua(a);iua(a);jua(a);kua(a);lua(a);mua(a);nua(a);oua(a);pua(a);qua(a);rua(a);sua(a);tua(a);uua(a);vua(a);wua(a);xua(a);yua(a);zua(a);Aua(a);Bua(a);Cua(a);Dua(a);Eua(a);Fua(a);Gua(a);Hua(a);Iua(a);Jua(a);Kua(a);Lua(a);Mua(a);Nua(a);Oua(a);Pua(a);Qua(a);Rua(a);Sua(a);Tua(a);Uua(a);Vua(a);Wua(a);Xua(a);Yua(a);Zua(a);_ua(a);$ua(a);ava(a);bva(a);cva(a);dva(a);eva(a);fva(a);gva(a);hva(a);iva(a);jva(a);kva(a);lva(a);mva(a);nva(a);ova(a);pva(a);qva(a);rva(a);sva(a);tva(a);uva(a);vva(a);wva(a);xva(a);yva(a);zva(a);Ava(a);Bva(a);Cva(a);Dva(a);Eva(a);Fva(a);Gva(a);Hva(a);Iva(a);Jva(a);Kva(a);Lva(a);Mva(a);Nva(a);Ova(a);Pva(a);Qva(a);Rva(a);Sva(a);Tva(a);Uva(a);Vva(a);Wva(a);Xva(a);Yva(a);Zva(a);_va(a);$va(a);awa(a);bwa(a);cwa(a);dwa(a);ewa(a);fwa(a);gwa(a);hwa(a);iwa(a);jwa(a);kwa(a);lwa(a);mwa(a);nwa(a);owa(a);pwa(a);qwa(a);rwa(a);swa(a);twa(a);uwa(a);vwa(a);wwa(a);xwa(a);ywa(a);zwa(a);Awa(a);Bwa(a);Cwa(a);Dwa(a);Ewa(a);Fwa(a);Gwa(a);Hwa(a);Iwa(a);Jwa(a);Kwa(a);Lwa(a);Mwa(a);Nwa(a);Owa(a);Pwa(a);Qwa(a);Rwa(a);Swa(a);Twa(a);Uwa(a);Vwa(a);Wwa(a);Xwa(a);Ywa(a);Zwa(a);_wa(a);$wa(a);axa(a);bxa(a);cxa(a);dxa(a);exa(a);fxa(a);gxa(a);hxa(a);ixa(a);jxa(a);kxa(a);lxa(a);mxa(a);nxa(a);oxa(a);pxa(a);qxa(a);rxa(a);sxa(a);txa(a);uxa(a);vxa(a);wxa(a);xxa(a);yxa(a);zxa(a);Axa(a);Bxa(a);Cxa(a);Dxa(a);Exa(a);Fxa(a);Gxa(a);Hxa(a);Ixa(a);Jxa(a);Kxa(a);Lxa(a);Mxa(a);Nxa(a);Oxa(a);Pxa(a);Qxa(a);Rxa(a);Sxa(a);Txa(a);Uxa(a);Vxa(a);Wxa(a);Xxa(a);Yxa(a);Zxa(a);_xa(a);$xa(a);aya(a);bya(a);cya(a);dya(a);eya(a);fya(a);gya(a);hya(a);iya(a);jya(a);kya(a);lya(a);mya(a);nya(a);oya(a);pya(a);qya(a);rya(a);sya(a);tya(a);uya(a);vya(a);wya(a);xya(a);yya(a);zya(a);Aya(a);Bya(a);Cya(a);Dya(a);Eya(a);Fya(a);Gya(a);Hya(a);Iya(a);Jya(a);Kya(a);Lya(a);Mya(a);Nya(a);Oya(a);Pya(a);Qya(a);Rya(a);Sya(a);Tya(a);Uya(a);Vya(a);Wya(a);Xya(a);Yya(a);Zya(a);_ya(a);$ya(a);aza(a);bza(a);cza(a);dza(a);eza(a);fza(a);gza(a);hza(a);iza(a);jza(a);kza(a);lza(a);mza(a);nza(a);oza(a);pza(a);qza(a);rza(a);sza(a);tza(a);uza(a);vza(a);wza(a);xza(a);yza(a);zza(a);Aza(a);Bza(a);Cza(a);Dza(a);Eza(a);Fza(a);Gza(a);Hza(a);Iza(a);Jza(a);Kza(a);Lza(a);Mza(a);Nza(a);Oza(a);Pza(a);Qza(a);Rza(a);Sza(a);Tza(a);Uza(a);Vza(a);Wza(a);Xza(a);Yza(a);Zza(a);_za(a);$za(a);aAa(a);bAa(a);cAa(a);dAa(a);eAa(a);fAa(a);gAa(a);hAa(a);iAa(a);jAa(a);kAa(a);lAa(a);mAa(a);nAa(a);oAa(a);pAa(a);qAa(a);rAa(a);sAa(a);tAa(a);uAa(a);vAa(a);wAa(a);xAa(a);yAa(a);zAa(a);AAa(a);BAa(a);CAa(a);DAa(a);EAa(a);FAa(a);GAa(a);HAa(a);IAa(a);JAa(a);KAa(a);LAa(a);MAa(a);NAa(a);OAa(a);PAa(a);QAa(a);RAa(a);SAa(a);TAa(a);UAa(a);VAa(a);WAa(a);XAa(a);YAa(a);ZAa(a);_Aa(a);$Aa(a);aBa(a);bBa(a);cBa(a);dBa(a);eBa(a);fBa(a);gBa(a);hBa(a);iBa(a);jBa(a);kBa(a);lBa(a);mBa(a);nBa(a);oBa(a);pBa(a);qBa(a);rBa(a);sBa(a);tBa(a);uBa(a);vBa(a);wBa(a);xBa(a);yBa(a);zBa(a);ABa(a);BBa(a);CBa(a);DBa(a);EBa(a);FBa(a);GBa(a);HBa(a);IBa(a);JBa(a);KBa(a);LBa(a);MBa(a);NBa(a);OBa(a);PBa(a);QBa(a);RBa(a);SBa(a);TBa(a);UBa(a);VBa(a);WBa(a);XBa(a);YBa(a);ZBa(a);_Ba(a);$Ba(a);aCa(a);bCa(a);cCa(a);dCa(a);eCa(a);fCa(a);gCa(a);hCa(a);iCa(a);jCa(a);kCa(a);lCa(a);mCa(a);nCa(a);oCa(a);pCa(a);qCa(a);rCa(a);sCa(a);tCa(a);uCa(a);vCa(a);wCa(a);xCa(a);yCa(a);zCa(a);ACa(a);BCa(a);CCa(a);DCa(a);ECa(a);FCa(a);GCa(a);HCa(a);ICa(a);JCa(a);KCa(a);LCa(a);MCa(a);NCa(a);OCa(a);PCa(a);QCa(a);RCa(a);SCa(a);TCa(a);UCa(a);VCa(a);WCa(a);XCa(a);YCa(a);ZCa(a);_Ca(a);$Ca(a);aDa(a);bDa(a);cDa(a);dDa(a);eDa(a);fDa(a);gDa(a);hDa(a);iDa(a);jDa(a);kDa(a);lDa(a);mDa(a);nDa(a);oDa(a);pDa(a);qDa(a);rDa(a);sDa(a);tDa(a);uDa(a);vDa(a);wDa(a);xDa(a);yDa(a);zDa(a);ADa(a);BDa(a);CDa(a);DDa(a);EDa(a);FDa(a);GDa(a);HDa(a);IDa(a);JDa(a);KDa(a);LDa(a);MDa(a);NDa(a);ODa(a);PDa(a);QDa(a);RDa(a);SDa(a);TDa(a);UDa(a);VDa(a);i=b;return 0}function XDa(b){b=b|0;var c=0;c=i;a[b+314|0]=0;YDa(b);i=c;return 0}function YDa(a){a=a|0;var b=0;b=i;kf(a);lf(a);mf(a);nf(a);of(a);pf(a);qf(a);rf(a);sf(a);tf(a);uf(a);vf(a);wf(a);xf(a);yf(a);zf(a);Af(a);Bf(a);Cf(a);Df(a);Ef(a);Ff(a);Gf(a);Hf(a);If(a);Jf(a);Kf(a);Lf(a);Mf(a);Nf(a);Of(a);Pf(a);Qf(a);Rf(a);Sf(a);Tf(a);Uf(a);Vf(a);Wf(a);Xf(a);Yf(a);Zf(a);_f(a);$f(a);ag(a);bg(a);cg(a);dg(a);eg(a);fg(a);gg(a);hg(a);ig(a);jg(a);kg(a);lg(a);mg(a);ng(a);og(a);pg(a);qg(a);rg(a);sg(a);tg(a);ug(a);vg(a);wg(a);xg(a);yg(a);zg(a);Ag(a);Bg(a);Cg(a);Dg(a);Eg(a);Fg(a);Gg(a);Hg(a);Ig(a);Jg(a);Kg(a);Lg(a);eh(a);Th(a);Uh(a);Vh(a);Wh(a);Xh(a);Yh(a);Zh(a);_h(a);$h(a);ai(a);bi(a);ci(a);di(a);ei(a);fi(a);gi(a);hi(a);ii(a);ji(a);ki(a);Zi(a);_i(a);$i(a);aj(a);bj(a);cj(a);dj(a);ej(a);fj(a);gj(a);hj(a);ij(a);jj(a);kj(a);lj(a);mj(a);nj(a);oj(a);pj(a);qj(a);sj(a);tj(a);uj(a);vj(a);wj(a);yj(a);zj(a);Aj(a);Bj(a);Cj(a);Jj(a);Pj(a);Uj(a);Vj(a);Yj(a);gk(a);lk(a);mk(a);pk(a);zk(a);Ek(a);Fk(a);Ik(a);Sk(a);Xk(a);Yk(a);$k(a);jl(a);ol(a);pl(a);sl(a);Cl(a);Hl(a);Il(a);Ll(a);Vl(a);_l(a);$l(a);cm(a);mm(a);rm(a);sm(a);vm(a);Fm(a);Km(a);Lm(a);Om(a);Ym(a);bn(a);cn(a);fn(a);qn(a);vn(a);wn(a);zn(a);Jn(a);On(a);Pn(a);Sn(a);ao(a);go(a);ho(a);ko(a);uo(a);zo(a);Ao(a);Do(a);No(a);So(a);To(a);Wo(a);ep(a);jp(a);kp(a);np(a);xp(a);Cp(a);Dp(a);Gp(a);Qp(a);Vp(a);Wp(a);Zp(a);hq(a);mq(a);nq(a);pq(a);sq(a);tq(a);uq(a);zq(a);Qq(a);Rq(a);Sq(a);Tq(a);Wq(a);dr(a);rr(a);sr(a);vr(a);Ir(a);Wr(a);Xr(a);_r(a);ls(a);zs(a);As(a);Ds(a);Qs(a);ct(a);dt(a);gt(a);tt(a);Ht(a);It(a);Lt(a);Yt(a);ku(a);lu(a);ou(a);Bu(a);Pu(a);Qu(a);Tu(a);ev(a);sv(a);tv(a);wv(a);Jv(a);Xv(a);Yv(a);$v(a);mw(a);Aw(a);Bw(a);Ew(a);Rw(a);dx(a);ex(a);hx(a);ux(a);Ix(a);Jx(a);Mx(a);Zx(a);ly(a);my(a);py(a);Cy(a);Qy(a);Ry(a);Uy(a);fz(a);tz(a);uz(a);xz(a);Kz(a);Yz(a);Zz(a);aA(a);nA(a);BA(a);CA(a);FA(a);SA(a);eB(a);fB(a);iB(a);vB(a);LB(a);MB(a);TB(a);aC(a);lC(a);mC(a);nC(a);oC(a);pC(a);qC(a);rC(a);sC(a);tC(a);uC(a);vC(a);wC(a);xC(a);yC(a);zC(a);AC(a);BC(a);CC(a);DC(a);EC(a);FC(a);GC(a);HC(a);IC(a);JC(a);KC(a);LC(a);MC(a);NC(a);OC(a);PC(a);QC(a);RC(a);SC(a);TC(a);UC(a);VC(a);WC(a);XC(a);YC(a);ZC(a);_C(a);$C(a);aD(a);bD(a);cD(a);dD(a);eD(a);fD(a);gD(a);hD(a);iD(a);jD(a);kD(a);lD(a);mD(a);nD(a);oD(a);pD(a);qD(a);rD(a);sD(a);tD(a);uD(a);vD(a);wD(a);xD(a);yD(a);i=b;return}function ZDa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[121472]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14608>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14608>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(121488,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14608>>3],121480)|0)|0;g=c[72302]|0;j=e;k=122232;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[121472]=1;i=d;return}function _Da(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[121728]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14600>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14600>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(121736,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14600>>3],121480)|0)|0;g=c[72302]|0;j=e;k=122232;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[121728]=1;i=d;return}function $Da(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[121896]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14592>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14592>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(121904,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14592>>3],121480)|0)|0;g=c[72302]|0;j=e;k=122232;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[121896]=1;i=d;return}function aEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[122064]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14584>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14584>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(122072,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14584>>3],121480)|0)|0;g=c[72302]|0;j=e;k=122232;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[122064]=1;i=d;return}function bEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[122256]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9440>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(122264,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9440>>3],121480)|0)|0;g=c[72302]|0;j=e;k=124264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[122256]=1;i=d;return}function cEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[122440]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9448>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(122448,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9448>>3],121480)|0)|0;g=c[72302]|0;j=e;k=124264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[122440]=1;i=d;return}function dEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[122536]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9456>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(122544,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9456>>3],121480)|0)|0;g=c[72302]|0;j=e;k=124264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[122536]=1;i=d;return}function eEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[122632]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9464>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(122640,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9464>>3],121480)|0)|0;g=c[72302]|0;j=e;k=124264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[122632]=1;i=d;return}function fEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[122728]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9472>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(122736,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9472>>3],121480)|0)|0;g=c[72302]|0;j=e;k=124264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[122728]=1;i=d;return}function gEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[122824]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9480>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(122832,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9480>>3],121480)|0)|0;g=c[72302]|0;j=e;k=124264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[122824]=1;i=d;return}function hEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[122920]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9488>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(122928,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9488>>3],121480)|0)|0;g=c[72302]|0;j=e;k=124264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[122920]=1;i=d;return}function iEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[123016]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9496>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(123024,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9496>>3],121480)|0)|0;g=c[72302]|0;j=e;k=124264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[123016]=1;i=d;return}function jEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[123112]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9504>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(123120,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9504>>3],121480)|0)|0;g=c[72302]|0;j=e;k=124264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[123112]=1;i=d;return}function kEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[123208]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9512>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(123216,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9512>>3],121480)|0)|0;g=c[72302]|0;j=e;k=124264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[123208]=1;i=d;return}function lEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[123304]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9520>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(123312,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9520>>3],121480)|0)|0;g=c[72302]|0;j=e;k=124264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[123304]=1;i=d;return}function mEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[123400]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9528>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(123408,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9528>>3],121480)|0)|0;g=c[72302]|0;j=e;k=124264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[123400]=1;i=d;return}function nEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[123496]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9536>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(123504,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9536>>3],121480)|0)|0;g=c[72302]|0;j=e;k=124264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[123496]=1;i=d;return}function oEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[123592]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9544>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(123600,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9544>>3],121480)|0)|0;g=c[72302]|0;j=e;k=124264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[123592]=1;i=d;return}function pEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[123688]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9552>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(123696,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9552>>3],121480)|0)|0;g=c[72302]|0;j=e;k=124264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[123688]=1;i=d;return}function qEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[123784]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9560>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(123792,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9560>>3],121480)|0)|0;g=c[72302]|0;j=e;k=124264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[123784]=1;i=d;return}function rEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[123880]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9568>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(123888,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9568>>3],121480)|0)|0;g=c[72302]|0;j=e;k=124264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[123880]=1;i=d;return}function sEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[123976]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9576>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(123984,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9576>>3],121480)|0)|0;g=c[72302]|0;j=e;k=124264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[123976]=1;i=d;return}function tEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[124072]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9584>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(124080,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9584>>3],121480)|0)|0;g=c[72302]|0;j=e;k=124264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[124072]=1;i=d;return}function uEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[124168]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9592>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(124176,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9592>>3],121480)|0)|0;g=c[72302]|0;j=e;k=124264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[124168]=1;i=d;return}function vEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[124288]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9280>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(124296,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9280>>3],121480)|0)|0;g=c[72302]|0;j=e;k=126208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[124288]=1;i=d;return}function wEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[124384]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9288>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(124392,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9288>>3],121480)|0)|0;g=c[72302]|0;j=e;k=126208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[124384]=1;i=d;return}function xEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[124480]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9296>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(124488,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9296>>3],121480)|0)|0;g=c[72302]|0;j=e;k=126208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[124480]=1;i=d;return}function yEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[124576]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9304>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(124584,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9304>>3],121480)|0)|0;g=c[72302]|0;j=e;k=126208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[124576]=1;i=d;return}function zEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[124672]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9312>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(124680,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9312>>3],121480)|0)|0;g=c[72302]|0;j=e;k=126208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[124672]=1;i=d;return}function AEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[124768]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9320>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(124776,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9320>>3],121480)|0)|0;g=c[72302]|0;j=e;k=126208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[124768]=1;i=d;return}function BEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[124864]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9328>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(124872,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9328>>3],121480)|0)|0;g=c[72302]|0;j=e;k=126208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[124864]=1;i=d;return}function CEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[124960]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9336>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(124968,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9336>>3],121480)|0)|0;g=c[72302]|0;j=e;k=126208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[124960]=1;i=d;return}function DEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[125056]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9344>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(125064,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9344>>3],121480)|0)|0;g=c[72302]|0;j=e;k=126208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[125056]=1;i=d;return}function EEa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[125152]&1){i=d;return}g=b+4|0;if(!((E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9352>>3],0.0)|0)<<24>>24==0)){i=d;return}b=RXa(125160,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+9352>>3],121480)|0)|0;g=c[72302]|0;j=e;k=126208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[125152]=1;i=d;return}



function xOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[212184]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+232>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+232>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(212192,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+232>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[212184]=1;i=d;return}function yOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[212344]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+224>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+224>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(212352,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+224>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[212344]=1;i=d;return}function zOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[212496]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2232>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2232>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(212504,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2232>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[212496]=1;i=d;return}function AOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[212664]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2224>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2224>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(212672,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2224>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[212664]=1;i=d;return}function BOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[212840]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+216>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+216>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(212848,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+216>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[212840]=1;i=d;return}function COa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[213e3]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+208>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+208>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(213008,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+208>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[213e3]=1;i=d;return}function DOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[213152]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2200>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2200>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(213160,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2200>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[213152]=1;i=d;return}function EOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[213320]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2192>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2192>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(213328,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2192>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[213320]=1;i=d;return}function FOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[213496]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+200>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+200>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(213504,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+200>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[213496]=1;i=d;return}function GOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[213656]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+192>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+192>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(213664,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+192>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[213656]=1;i=d;return}function HOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[213808]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2168>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2168>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(213816,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2168>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[213808]=1;i=d;return}function IOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[213976]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2160>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2160>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(213984,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2160>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[213976]=1;i=d;return}function JOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[214152]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+184>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+184>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(214160,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+184>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[214152]=1;i=d;return}function KOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[214312]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+176>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+176>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(214320,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+176>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[214312]=1;i=d;return}function LOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[214464]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2136>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2136>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(214472,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2136>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[214464]=1;i=d;return}function MOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[214632]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2128>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2128>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(214640,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2128>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[214632]=1;i=d;return}function NOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[214808]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+168>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+168>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(214816,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+168>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[214808]=1;i=d;return}function OOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[214968]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+160>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+160>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(214976,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+160>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[214968]=1;i=d;return}function POa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[215128]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2104>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2104>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(215136,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2104>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[215128]=1;i=d;return}function QOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[215296]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2096>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2096>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(215304,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2096>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[215296]=1;i=d;return}function ROa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[215472]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+152>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+152>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(215480,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+152>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[215472]=1;i=d;return}function SOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[215632]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+144>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+144>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(215640,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+144>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[215632]=1;i=d;return}function TOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[215792]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2072>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2072>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(215800,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2072>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[215792]=1;i=d;return}function UOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[215960]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2064>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2064>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(215968,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2064>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[215960]=1;i=d;return}function VOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[216136]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+136>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+136>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(216144,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+136>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[216136]=1;i=d;return}function WOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[216296]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+128>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+128>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(216304,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+128>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[216296]=1;i=d;return}function XOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[216456]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2040>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2040>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(216464,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2040>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[216456]=1;i=d;return}function YOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[216624]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2032>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2032>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(216632,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2032>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[216624]=1;i=d;return}function ZOa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[216800]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+120>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+120>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(216808,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+120>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[216800]=1;i=d;return}function _Oa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[216960]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+112>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+112>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(216968,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+112>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[216960]=1;i=d;return}function $Oa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[217120]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2008>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2008>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(217128,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2008>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[217120]=1;i=d;return}function aPa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[217288]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2e3>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2e3>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(217296,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2e3>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[217288]=1;i=d;return}function bPa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[217464]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+104>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+104>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(217472,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+104>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[217464]=1;i=d;return}function cPa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[217624]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+96>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+96>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(217632,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+96>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[217624]=1;i=d;return}function dPa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[217784]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1976>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1976>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(217792,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1976>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[217784]=1;i=d;return}function ePa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[217952]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1968>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1968>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(217960,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1968>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[217952]=1;i=d;return}function fPa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[218128]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+88>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+88>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(218136,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+88>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[218128]=1;i=d;return}function gPa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[218288]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+80>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+80>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(218296,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+80>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[218288]=1;i=d;return}function hPa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[218448]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1944>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1944>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(218456,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1944>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[218448]=1;i=d;return}function iPa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[218616]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1936>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1936>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(218624,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1936>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[218616]=1;i=d;return}function jPa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[218792]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+72>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+72>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(218800,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+72>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[218792]=1;i=d;return}function kPa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[218952]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+64>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+64>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(218960,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+64>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[218952]=1;i=d;return}function lPa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[219112]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1912>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1912>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(219120,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1912>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[219112]=1;i=d;return}function mPa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[219280]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1904>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1904>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(219288,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1904>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[219280]=1;i=d;return}function nPa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[219456]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+56>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+56>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(219464,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+56>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[219456]=1;i=d;return}function oPa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[219616]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+48>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+48>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(219624,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+48>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[219616]=1;i=d;return}function pPa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[219776]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1880>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1880>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(219784,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1880>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[219776]=1;i=d;return}function qPa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[219944]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1872>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1872>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(219952,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1872>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[219944]=1;i=d;return}function rPa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[220120]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+40>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+40>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(220128,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+40>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[220120]=1;i=d;return}function sPa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[220280]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+32>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+32>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(220288,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+32>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[220280]=1;i=d;return}function tPa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[220440]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1848>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1848>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(220448,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1848>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[220440]=1;i=d;return}function uPa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[220608]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1840>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1840>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(220616,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1840>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[220608]=1;i=d;return}function vPa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[220784]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+24>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+24>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(220792,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+24>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[220784]=1;i=d;return}function wPa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[220944]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+16>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+16>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(220952,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+16>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[220944]=1;i=d;return}function xPa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[221104]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1816>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1816>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(221112,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1816>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[221104]=1;i=d;return}function yPa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[221272]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1808>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1808>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(221280,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1808>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[221272]=1;i=d;return}function zPa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[221448]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(221456,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[221448]=1;i=d;return}function APa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[221632]&1){i=d;return}g=b+4|0;b=E_a(+h[c[(c[c[g>>2]>>2]|0)+8>>2]>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[c[(c[c[g>>2]>>2]|0)+8>>2]>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(221640,LXa(+h[c[(c[c[g>>2]>>2]|0)+8>>2]>>3],121480)|0)|0;g=c[72302]|0;j=e;k=221792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[221632]=1;i=d;return}function BPa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[221816]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1784>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1784>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(221824,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1784>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[221816]=1;i=d;return}function CPa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[221984]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1776>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1776>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(221992,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1776>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[221984]=1;i=d;return}function DPa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[222160]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14544>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14544>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(222168,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14544>>3],121480)|0)|0;g=c[72302]|0;j=e;k=222992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[222160]=1;i=d;return}function EPa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[222328]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14536>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14536>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(222336,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14536>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[222328]=1;i=d;return}function FPa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[222480]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14528>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14528>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(222488,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14528>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[222480]=1;i=d;return}function GPa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[222648]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14520>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14520>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(222656,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14520>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[222648]=1;i=d;return}function HPa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[222824]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14504>>3],-1.0e10)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14504>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=RXa(222832,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14504>>3],121480)|0)|0;g=c[72302]|0;j=e;k=222992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[222824]=1;i=d;return}function IPa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[223016]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14496>>3],0.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14496>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(223024,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14496>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[223016]=1;i=d;return}function JPa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[223192]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14488>>3],-1.0e8)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14488>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=RXa(223200,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14488>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[223192]=1;i=d;return}function KPa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[223384]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14480>>3],1.0)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14480>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=RXa(223392,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14480>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[223384]=1;i=d;return}function LPa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[223584]&1){i=d;return}g=b+4|0;b=E_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14464>>3],-1.0e5)|0;if(!(b<<24>>24==0|(C_a(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14464>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=RXa(223592,LXa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+14464>>3],121480)|0)|0;g=c[72302]|0;j=e;k=223776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[223584]=1;i=d;return}function MPa(a){a=a|0;var b=0;b=i;ZDa(a);_Da(a);$Da(a);aEa(a);bEa(a);cEa(a);dEa(a);eEa(a);fEa(a);gEa(a);hEa(a);iEa(a);jEa(a);kEa(a);lEa(a);mEa(a);nEa(a);oEa(a);pEa(a);qEa(a);rEa(a);sEa(a);tEa(a);uEa(a);vEa(a);wEa(a);xEa(a);yEa(a);zEa(a);AEa(a);BEa(a);CEa(a);DEa(a);EEa(a);FEa(a);GEa(a);HEa(a);IEa(a);JEa(a);KEa(a);LEa(a);MEa(a);NEa(a);OEa(a);PEa(a);QEa(a);REa(a);SEa(a);TEa(a);UEa(a);VEa(a);WEa(a);XEa(a);YEa(a);ZEa(a);_Ea(a);$Ea(a);aFa(a);bFa(a);cFa(a);dFa(a);eFa(a);fFa(a);gFa(a);hFa(a);iFa(a);jFa(a);kFa(a);lFa(a);mFa(a);nFa(a);oFa(a);pFa(a);qFa(a);rFa(a);sFa(a);tFa(a);uFa(a);vFa(a);wFa(a);xFa(a);yFa(a);zFa(a);AFa(a);BFa(a);CFa(a);DFa(a);EFa(a);FFa(a);GFa(a);HFa(a);IFa(a);JFa(a);KFa(a);LFa(a);MFa(a);NFa(a);OFa(a);PFa(a);QFa(a);RFa(a);SFa(a);TFa(a);UFa(a);VFa(a);WFa(a);XFa(a);YFa(a);ZFa(a);_Fa(a);$Fa(a);aGa(a);bGa(a);cGa(a);dGa(a);eGa(a);fGa(a);gGa(a);hGa(a);iGa(a);jGa(a);kGa(a);lGa(a);mGa(a);nGa(a);oGa(a);pGa(a);qGa(a);rGa(a);sGa(a);tGa(a);uGa(a);vGa(a);wGa(a);xGa(a);yGa(a);zGa(a);AGa(a);BGa(a);CGa(a);DGa(a);EGa(a);FGa(a);GGa(a);HGa(a);IGa(a);JGa(a);KGa(a);LGa(a);MGa(a);NGa(a);OGa(a);PGa(a);QGa(a);RGa(a);SGa(a);TGa(a);UGa(a);VGa(a);WGa(a);XGa(a);YGa(a);ZGa(a);_Ga(a);$Ga(a);aHa(a);bHa(a);cHa(a);dHa(a);eHa(a);fHa(a);gHa(a);hHa(a);iHa(a);jHa(a);kHa(a);lHa(a);mHa(a);nHa(a);oHa(a);pHa(a);qHa(a);rHa(a);sHa(a);tHa(a);uHa(a);vHa(a);wHa(a);xHa(a);yHa(a);zHa(a);AHa(a);BHa(a);CHa(a);DHa(a);EHa(a);FHa(a);GHa(a);HHa(a);IHa(a);JHa(a);KHa(a);LHa(a);MHa(a);NHa(a);OHa(a);PHa(a);QHa(a);RHa(a);SHa(a);THa(a);UHa(a);VHa(a);WHa(a);XHa(a);YHa(a);ZHa(a);_Ha(a);$Ha(a);aIa(a);bIa(a);cIa(a);dIa(a);eIa(a);fIa(a);gIa(a);hIa(a);iIa(a);jIa(a);kIa(a);lIa(a);mIa(a);nIa(a);oIa(a);pIa(a);qIa(a);rIa(a);sIa(a);tIa(a);uIa(a);vIa(a);wIa(a);xIa(a);yIa(a);zIa(a);AIa(a);BIa(a);CIa(a);DIa(a);EIa(a);FIa(a);GIa(a);HIa(a);IIa(a);JIa(a);KIa(a);LIa(a);MIa(a);NIa(a);OIa(a);PIa(a);QIa(a);RIa(a);SIa(a);TIa(a);UIa(a);VIa(a);WIa(a);XIa(a);YIa(a);ZIa(a);_Ia(a);$Ia(a);aJa(a);bJa(a);cJa(a);dJa(a);eJa(a);fJa(a);gJa(a);hJa(a);iJa(a);jJa(a);kJa(a);lJa(a);mJa(a);nJa(a);oJa(a);pJa(a);qJa(a);rJa(a);sJa(a);tJa(a);uJa(a);vJa(a);wJa(a);xJa(a);yJa(a);zJa(a);AJa(a);BJa(a);CJa(a);DJa(a);EJa(a);FJa(a);GJa(a);HJa(a);IJa(a);JJa(a);KJa(a);LJa(a);MJa(a);NJa(a);OJa(a);PJa(a);QJa(a);RJa(a);SJa(a);TJa(a);UJa(a);VJa(a);WJa(a);XJa(a);YJa(a);ZJa(a);_Ja(a);$Ja(a);aKa(a);bKa(a);cKa(a);dKa(a);eKa(a);fKa(a);gKa(a);hKa(a);iKa(a);jKa(a);kKa(a);lKa(a);mKa(a);nKa(a);oKa(a);pKa(a);qKa(a);rKa(a);sKa(a);tKa(a);uKa(a);vKa(a);wKa(a);xKa(a);yKa(a);zKa(a);AKa(a);BKa(a);CKa(a);DKa(a);EKa(a);FKa(a);GKa(a);HKa(a);IKa(a);JKa(a);KKa(a);LKa(a);MKa(a);NKa(a);OKa(a);PKa(a);QKa(a);RKa(a);SKa(a);TKa(a);UKa(a);VKa(a);WKa(a);XKa(a);YKa(a);ZKa(a);_Ka(a);$Ka(a);aLa(a);bLa(a);cLa(a);dLa(a);eLa(a);fLa(a);gLa(a);hLa(a);iLa(a);jLa(a);kLa(a);lLa(a);mLa(a);nLa(a);oLa(a);pLa(a);qLa(a);rLa(a);sLa(a);tLa(a);uLa(a);vLa(a);wLa(a);xLa(a);yLa(a);zLa(a);ALa(a);BLa(a);CLa(a);DLa(a);ELa(a);FLa(a);GLa(a);HLa(a);ILa(a);JLa(a);KLa(a);LLa(a);MLa(a);NLa(a);OLa(a);PLa(a);QLa(a);RLa(a);SLa(a);TLa(a);ULa(a);VLa(a);WLa(a);XLa(a);YLa(a);ZLa(a);_La(a);$La(a);aMa(a);bMa(a);cMa(a);dMa(a);eMa(a);fMa(a);gMa(a);hMa(a);iMa(a);jMa(a);kMa(a);lMa(a);mMa(a);nMa(a);oMa(a);pMa(a);qMa(a);rMa(a);sMa(a);tMa(a);uMa(a);vMa(a);wMa(a);xMa(a);yMa(a);zMa(a);AMa(a);BMa(a);CMa(a);DMa(a);EMa(a);FMa(a);GMa(a);HMa(a);IMa(a);JMa(a);KMa(a);LMa(a);MMa(a);NMa(a);OMa(a);PMa(a);QMa(a);RMa(a);SMa(a);TMa(a);UMa(a);VMa(a);WMa(a);XMa(a);YMa(a);ZMa(a);_Ma(a);$Ma(a);aNa(a);bNa(a);cNa(a);dNa(a);eNa(a);fNa(a);gNa(a);hNa(a);iNa(a);jNa(a);kNa(a);lNa(a);mNa(a);nNa(a);oNa(a);pNa(a);qNa(a);rNa(a);sNa(a);tNa(a);uNa(a);vNa(a);wNa(a);xNa(a);yNa(a);zNa(a);ANa(a);BNa(a);CNa(a);DNa(a);ENa(a);FNa(a);GNa(a);HNa(a);INa(a);JNa(a);KNa(a);LNa(a);MNa(a);NNa(a);ONa(a);PNa(a);QNa(a);RNa(a);SNa(a);TNa(a);UNa(a);VNa(a);WNa(a);XNa(a);YNa(a);ZNa(a);_Na(a);$Na(a);aOa(a);bOa(a);cOa(a);dOa(a);eOa(a);fOa(a);gOa(a);hOa(a);iOa(a);jOa(a);kOa(a);lOa(a);mOa(a);nOa(a);oOa(a);pOa(a);qOa(a);rOa(a);sOa(a);tOa(a);uOa(a);vOa(a);wOa(a);xOa(a);yOa(a);zOa(a);AOa(a);BOa(a);COa(a);DOa(a);EOa(a);FOa(a);GOa(a);HOa(a);IOa(a);JOa(a);KOa(a);LOa(a);MOa(a);NOa(a);OOa(a);POa(a);QOa(a);ROa(a);SOa(a);TOa(a);UOa(a);VOa(a);WOa(a);XOa(a);YOa(a);ZOa(a);_Oa(a);$Oa(a);aPa(a);bPa(a);cPa(a);dPa(a);ePa(a);fPa(a);gPa(a);hPa(a);iPa(a);jPa(a);kPa(a);lPa(a);mPa(a);nPa(a);oPa(a);pPa(a);qPa(a);rPa(a);sPa(a);tPa(a);uPa(a);vPa(a);wPa(a);xPa(a);yPa(a);zPa(a);APa(a);BPa(a);CPa(a);DPa(a);EPa(a);FPa(a);GPa(a);HPa(a);IPa(a);JPa(a);KPa(a);LPa(a);i=b;return 0}function NPa(a){a=a|0;i=i;return 1}function OPa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=a+464|0;a=c[d>>2]|0;c[a+44>>2]=100;c[a+48>>2]=100;c[a+72>>2]=Ypb(100,8)|0;a=Ypb(100,8)|0;c[(c[d>>2]|0)+80>>2]=a;a=Ypb(0,8)|0;c[(c[d>>2]|0)+76>>2]=a;a=Wpb(400)|0;c[(c[d>>2]|0)+52>>2]=a;a=Wpb(2800)|0;c[(c[d>>2]|0)+56>>2]=a;a=Wpb(400)|0;c[(c[d>>2]|0)+64>>2]=a;a=c[d>>2]|0;c[a+68>>2]=10;c[a+84>>2]=0;a=c[(c[d>>2]|0)+52>>2]|0;c[a+320>>2]=5;c[a+324>>2]=5;c[a+328>>2]=5;c[a+332>>2]=5;c[a+336>>2]=5;c[a+340>>2]=5;c[a+344>>2]=5;c[a+348>>2]=5;c[a+352>>2]=5;c[a+356>>2]=5;c[a+360>>2]=5;c[a+364>>2]=5;c[a+368>>2]=5;c[a+372>>2]=5;c[a+376>>2]=5;c[a+380>>2]=5;c[a+384>>2]=5;c[a+388>>2]=5;c[a+392>>2]=5;c[a+396>>2]=5;c[a+316>>2]=6;c[a+312>>2]=6;c[a+308>>2]=9;c[a+304>>2]=9;c[a+300>>2]=9;c[a+296>>2]=9;c[a+292>>2]=9;c[a+288>>2]=9;c[a+284>>2]=9;c[a+280>>2]=9;c[a+276>>2]=9;c[a+272>>2]=9;c[a+268>>2]=9;c[a+264>>2]=9;c[a+260>>2]=9;c[a+256>>2]=9;c[a+252>>2]=9;c[a+248>>2]=9;c[a+244>>2]=9;c[a+240>>2]=9;c[a+236>>2]=9;c[a+232>>2]=9;c[a+228>>2]=9;c[a+224>>2]=9;c[a+220>>2]=9;c[a+216>>2]=9;c[a+212>>2]=9;c[a+208>>2]=9;c[a+204>>2]=9;a=c[(c[d>>2]|0)+52>>2]|0;c[a+200>>2]=9;c[a+196>>2]=9;c[a+192>>2]=9;c[a+188>>2]=9;c[a+184>>2]=9;c[a+180>>2]=9;c[a+176>>2]=9;c[a+172>>2]=9;c[a+168>>2]=9;c[a+164>>2]=6;c[a+160>>2]=6;c[a+156>>2]=4;c[a+152>>2]=5;c[a+148>>2]=6;c[a+144>>2]=7;c[a+140>>2]=6;c[a+136>>2]=7;c[a+132>>2]=6;c[a+128>>2]=7;c[a+124>>2]=6;c[a+120>>2]=7;c[a+116>>2]=6;c[a+112>>2]=7;c[a+108>>2]=6;c[a+104>>2]=7;c[a+100>>2]=6;c[a+96>>2]=7;c[a+92>>2]=6;c[a+88>>2]=7;c[a+84>>2]=6;c[a+80>>2]=7;c[a+76>>2]=6;c[a+72>>2]=7;c[a+68>>2]=6;c[a+64>>2]=7;c[a+60>>2]=6;c[a+56>>2]=7;c[a+52>>2]=6;c[a+48>>2]=7;c[a+44>>2]=6;c[a+40>>2]=7;c[a+36>>2]=6;c[a+32>>2]=7;c[a+28>>2]=6;c[a+24>>2]=7;c[a+20>>2]=6;c[a+16>>2]=7;c[a+12>>2]=6;c[a+8>>2]=7;a=c[d>>2]|0;e=c[a+52>>2]|0;c[e+4>>2]=4;c[e>>2]=5;f=4;g=5;h=1;while(1){j=f+g|0;c[e+(h<<2)>>2]=j;k=h+1|0;if((k|0)>=100){break}f=c[e+(k<<2)>>2]|0;h=k;g=j}PPa(e,c[a+56>>2]|0);a=c[d>>2]|0;QPa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;RPa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;SPa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;TPa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;UPa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;VPa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;WPa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;XPa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;YPa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;ZPa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;_Pa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;$Pa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;aQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;bQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;cQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;dQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;eQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;fQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;gQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;hQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;iQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;jQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;kQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;lQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;mQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;nQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;oQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;pQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;qQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;rQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;sQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;tQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;uQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;vQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;wQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;xQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;yQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;zQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;AQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;BQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;CQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;DQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;EQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;FQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;GQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;HQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;IQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;JQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;KQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;LQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;MQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;NQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;OQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;PQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;QQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;RQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;SQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;TQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;UQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;VQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;WQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;XQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;YQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;ZQa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;_Qa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;$Qa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;aRa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;bRa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;cRa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;dRa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;eRa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;fRa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;gRa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;hRa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;iRa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;jRa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;kRa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;lRa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;mRa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;nRa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;oRa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;pRa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;qRa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;rRa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;sRa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;tRa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;uRa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;vRa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;wRa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;xRa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;yRa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;zRa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;ARa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;BRa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;CRa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;DRa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;ERa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;FRa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;GRa(c[a+52>>2]|0,c[a+56>>2]|0);a=c[(c[d>>2]|0)+64>>2]|0;c[a+320>>2]=1;c[a+324>>2]=1;c[a+328>>2]=1;c[a+332>>2]=1;c[a+336>>2]=1;c[a+340>>2]=1;c[a+344>>2]=1;c[a+348>>2]=1;c[a+352>>2]=1;c[a+356>>2]=1;c[a+360>>2]=1;c[a+364>>2]=1;c[a+368>>2]=1;c[a+372>>2]=1;c[a+376>>2]=1;c[a+380>>2]=1;c[a+384>>2]=1;c[a+388>>2]=1;c[a+392>>2]=1;c[a+396>>2]=1;c[a+316>>2]=2;c[a+292>>2]=2;c[a+268>>2]=2;c[a+244>>2]=2;c[a+220>>2]=2;c[a+196>>2]=2;c[a+172>>2]=2;c[a+156>>2]=2;c[a+132>>2]=2;c[a+108>>2]=2;c[a+84>>2]=2;c[a+60>>2]=2;c[a+36>>2]=2;c[a+12>>2]=2;c[a+312>>2]=3;c[a+288>>2]=3;c[a+264>>2]=3;c[a+240>>2]=3;c[a+216>>2]=3;c[a+192>>2]=3;c[a+168>>2]=3;c[a+148>>2]=3;c[a+124>>2]=3;c[a+100>>2]=3;c[a+76>>2]=3;c[a+52>>2]=3;c[a+28>>2]=3;c[a+4>>2]=3;c[a+308>>2]=4;a=c[(c[d>>2]|0)+64>>2]|0;c[a+284>>2]=4;c[a+260>>2]=4;c[a+236>>2]=4;c[a+212>>2]=4;c[a+188>>2]=4;c[a+164>>2]=4;c[a+140>>2]=4;c[a+116>>2]=4;c[a+92>>2]=4;c[a+68>>2]=4;c[a+44>>2]=4;c[a+20>>2]=4;c[a+304>>2]=5;c[a+280>>2]=5;c[a+256>>2]=5;c[a+232>>2]=5;c[a+208>>2]=5;c[a+184>>2]=5;c[a+160>>2]=5;c[a+300>>2]=6;c[a+276>>2]=6;c[a+252>>2]=6;c[a+228>>2]=6;c[a+204>>2]=6;c[a+180>>2]=6;c[a+152>>2]=6;c[a>>2]=6;c[a+296>>2]=7;c[a+272>>2]=7;c[a+248>>2]=7;c[a+224>>2]=7;c[a+200>>2]=7;c[a+176>>2]=7;c[a+144>>2]=8;c[a+120>>2]=8;c[a+96>>2]=8;c[a+72>>2]=8;c[a+48>>2]=8;c[a+24>>2]=8;c[a+136>>2]=9;c[a+112>>2]=9;c[a+88>>2]=9;c[a+64>>2]=9;c[a+40>>2]=9;c[a+16>>2]=9;c[a+128>>2]=10;c[a+104>>2]=10;c[a+80>>2]=10;c[a+56>>2]=10;a=c[(c[d>>2]|0)+64>>2]|0;c[a+32>>2]=10;c[a+8>>2]=10;i=b;return 0}function PPa(a,b){a=a|0;b=b|0;var d=0;d=a+320|0;c[b+((c[d>>2]|0)+ -5<<2)>>2]=0;c[b+((c[d>>2]|0)+ -4<<2)>>2]=1;c[b+((c[d>>2]|0)+ -3<<2)>>2]=78;c[b+((c[d>>2]|0)+ -2<<2)>>2]=79;c[b+((c[d>>2]|0)+ -1<<2)>>2]=80;i=i;return}function QPa(a,b){a=a|0;b=b|0;var d=0;d=a+324|0;c[b+((c[d>>2]|0)+ -5<<2)>>2]=2;c[b+((c[d>>2]|0)+ -4<<2)>>2]=3;c[b+((c[d>>2]|0)+ -3<<2)>>2]=76;c[b+((c[d>>2]|0)+ -2<<2)>>2]=77;c[b+((c[d>>2]|0)+ -1<<2)>>2]=81;i=i;return}function RPa(a,b){a=a|0;b=b|0;var d=0;d=a+328|0;c[b+((c[d>>2]|0)+ -5<<2)>>2]=4;c[b+((c[d>>2]|0)+ -4<<2)>>2]=5;c[b+((c[d>>2]|0)+ -3<<2)>>2]=74;c[b+((c[d>>2]|0)+ -2<<2)>>2]=75;c[b+((c[d>>2]|0)+ -1<<2)>>2]=82;i=i;return}function SPa(a,b){a=a|0;b=b|0;var d=0;d=a+332|0;c[b+((c[d>>2]|0)+ -5<<2)>>2]=6;c[b+((c[d>>2]|0)+ -4<<2)>>2]=7;c[b+((c[d>>2]|0)+ -3<<2)>>2]=72;c[b+((c[d>>2]|0)+ -2<<2)>>2]=73;c[b+((c[d>>2]|0)+ -1<<2)>>2]=83;i=i;return}function TPa(a,b){a=a|0;b=b|0;var d=0;d=a+336|0;c[b+((c[d>>2]|0)+ -5<<2)>>2]=8;c[b+((c[d>>2]|0)+ -4<<2)>>2]=9;c[b+((c[d>>2]|0)+ -3<<2)>>2]=70;c[b+((c[d>>2]|0)+ -2<<2)>>2]=71;c[b+((c[d>>2]|0)+ -1<<2)>>2]=84;i=i;return}function UPa(a,b){a=a|0;b=b|0;var d=0;d=a+340|0;c[b+((c[d>>2]|0)+ -5<<2)>>2]=10;c[b+((c[d>>2]|0)+ -4<<2)>>2]=11;c[b+((c[d>>2]|0)+ -3<<2)>>2]=68;c[b+((c[d>>2]|0)+ -2<<2)>>2]=69;c[b+((c[d>>2]|0)+ -1<<2)>>2]=85;i=i;return}function VPa(a,b){a=a|0;b=b|0;var d=0;d=a+344|0;c[b+((c[d>>2]|0)+ -5<<2)>>2]=12;c[b+((c[d>>2]|0)+ -4<<2)>>2]=13;c[b+((c[d>>2]|0)+ -3<<2)>>2]=66;c[b+((c[d>>2]|0)+ -2<<2)>>2]=67;c[b+((c[d>>2]|0)+ -1<<2)>>2]=86;i=i;return}function WPa(a,b){a=a|0;b=b|0;var d=0;d=a+348|0;c[b+((c[d>>2]|0)+ -5<<2)>>2]=14;c[b+((c[d>>2]|0)+ -4<<2)>>2]=15;c[b+((c[d>>2]|0)+ -3<<2)>>2]=64;c[b+((c[d>>2]|0)+ -2<<2)>>2]=65;c[b+((c[d>>2]|0)+ -1<<2)>>2]=87;i=i;return}function XPa(a,b){a=a|0;b=b|0;var d=0;d=a+352|0;c[b+((c[d>>2]|0)+ -5<<2)>>2]=16;c[b+((c[d>>2]|0)+ -4<<2)>>2]=17;c[b+((c[d>>2]|0)+ -3<<2)>>2]=62;c[b+((c[d>>2]|0)+ -2<<2)>>2]=63;c[b+((c[d>>2]|0)+ -1<<2)>>2]=88;i=i;return}function YPa(a,b){a=a|0;b=b|0;var d=0;d=a+356|0;c[b+((c[d>>2]|0)+ -5<<2)>>2]=18;c[b+((c[d>>2]|0)+ -4<<2)>>2]=19;c[b+((c[d>>2]|0)+ -3<<2)>>2]=60;c[b+((c[d>>2]|0)+ -2<<2)>>2]=61;c[b+((c[d>>2]|0)+ -1<<2)>>2]=89;i=i;return}function ZPa(a,b){a=a|0;b=b|0;var d=0;d=a+360|0;c[b+((c[d>>2]|0)+ -5<<2)>>2]=20;c[b+((c[d>>2]|0)+ -4<<2)>>2]=21;c[b+((c[d>>2]|0)+ -3<<2)>>2]=58;c[b+((c[d>>2]|0)+ -2<<2)>>2]=59;c[b+((c[d>>2]|0)+ -1<<2)>>2]=90;i=i;return}function _Pa(a,b){a=a|0;b=b|0;var d=0;d=a+364|0;c[b+((c[d>>2]|0)+ -5<<2)>>2]=22;c[b+((c[d>>2]|0)+ -4<<2)>>2]=23;c[b+((c[d>>2]|0)+ -3<<2)>>2]=56;c[b+((c[d>>2]|0)+ -2<<2)>>2]=57;c[b+((c[d>>2]|0)+ -1<<2)>>2]=91;i=i;return}function $Pa(a,b){a=a|0;b=b|0;var d=0;d=a+368|0;c[b+((c[d>>2]|0)+ -5<<2)>>2]=24;c[b+((c[d>>2]|0)+ -4<<2)>>2]=25;c[b+((c[d>>2]|0)+ -3<<2)>>2]=54;c[b+((c[d>>2]|0)+ -2<<2)>>2]=55;c[b+((c[d>>2]|0)+ -1<<2)>>2]=92;i=i;return}function aQa(a,b){a=a|0;b=b|0;var d=0;d=a+372|0;c[b+((c[d>>2]|0)+ -5<<2)>>2]=26;c[b+((c[d>>2]|0)+ -4<<2)>>2]=27;c[b+((c[d>>2]|0)+ -3<<2)>>2]=52;c[b+((c[d>>2]|0)+ -2<<2)>>2]=53;c[b+((c[d>>2]|0)+ -1<<2)>>2]=93;i=i;return}function bQa(a,b){a=a|0;b=b|0;var d=0;d=a+376|0;c[b+((c[d>>2]|0)+ -5<<2)>>2]=28;c[b+((c[d>>2]|0)+ -4<<2)>>2]=29;c[b+((c[d>>2]|0)+ -3<<2)>>2]=50;c[b+((c[d>>2]|0)+ -2<<2)>>2]=51;c[b+((c[d>>2]|0)+ -1<<2)>>2]=94;i=i;return}function cQa(a,b){a=a|0;b=b|0;var d=0;d=a+380|0;c[b+((c[d>>2]|0)+ -5<<2)>>2]=30;c[b+((c[d>>2]|0)+ -4<<2)>>2]=31;c[b+((c[d>>2]|0)+ -3<<2)>>2]=48;c[b+((c[d>>2]|0)+ -2<<2)>>2]=49;c[b+((c[d>>2]|0)+ -1<<2)>>2]=95;i=i;return}function dQa(a,b){a=a|0;b=b|0;var d=0;d=a+384|0;c[b+((c[d>>2]|0)+ -5<<2)>>2]=32;c[b+((c[d>>2]|0)+ -4<<2)>>2]=33;c[b+((c[d>>2]|0)+ -3<<2)>>2]=46;c[b+((c[d>>2]|0)+ -2<<2)>>2]=47;c[b+((c[d>>2]|0)+ -1<<2)>>2]=96;i=i;return}function eQa(a,b){a=a|0;b=b|0;var d=0;d=a+388|0;c[b+((c[d>>2]|0)+ -5<<2)>>2]=34;c[b+((c[d>>2]|0)+ -4<<2)>>2]=35;c[b+((c[d>>2]|0)+ -3<<2)>>2]=44;c[b+((c[d>>2]|0)+ -2<<2)>>2]=45;c[b+((c[d>>2]|0)+ -1<<2)>>2]=97;i=i;return}function fQa(a,b){a=a|0;b=b|0;var d=0;d=a+392|0;c[b+((c[d>>2]|0)+ -5<<2)>>2]=36;c[b+((c[d>>2]|0)+ -4<<2)>>2]=37;c[b+((c[d>>2]|0)+ -3<<2)>>2]=42;c[b+((c[d>>2]|0)+ -2<<2)>>2]=43;c[b+((c[d>>2]|0)+ -1<<2)>>2]=98;i=i;return}function gQa(a,b){a=a|0;b=b|0;var d=0;d=a+396|0;c[b+((c[d>>2]|0)+ -5<<2)>>2]=38;c[b+((c[d>>2]|0)+ -4<<2)>>2]=39;c[b+((c[d>>2]|0)+ -3<<2)>>2]=40;c[b+((c[d>>2]|0)+ -2<<2)>>2]=41;c[b+((c[d>>2]|0)+ -1<<2)>>2]=99;i=i;return}function hQa(a,b){a=a|0;b=b|0;var d=0;d=a+316|0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=76;c[b+((c[d>>2]|0)+ -5<<2)>>2]=77;c[b+((c[d>>2]|0)+ -4<<2)>>2]=78;c[b+((c[d>>2]|0)+ -3<<2)>>2]=79;c[b+((c[d>>2]|0)+ -2<<2)>>2]=81;c[b+((c[d>>2]|0)+ -1<<2)>>2]=80;i=i;return}function iQa(a,b){a=a|0;b=b|0;var d=0;d=a+312|0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=76;c[b+((c[d>>2]|0)+ -5<<2)>>2]=77;c[b+((c[d>>2]|0)+ -4<<2)>>2]=78;c[b+((c[d>>2]|0)+ -3<<2)>>2]=79;c[b+((c[d>>2]|0)+ -2<<2)>>2]=81;c[b+((c[d>>2]|0)+ -1<<2)>>2]=80;i=i;return}function jQa(a,b){a=a|0;b=b|0;var d=0;d=a+308|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=74;c[b+((c[d>>2]|0)+ -8<<2)>>2]=75;c[b+((c[d>>2]|0)+ -7<<2)>>2]=76;c[b+((c[d>>2]|0)+ -6<<2)>>2]=77;c[b+((c[d>>2]|0)+ -5<<2)>>2]=78;c[b+((c[d>>2]|0)+ -4<<2)>>2]=79;c[b+((c[d>>2]|0)+ -3<<2)>>2]=82;c[b+((c[d>>2]|0)+ -2<<2)>>2]=81;c[b+((c[d>>2]|0)+ -1<<2)>>2]=80;i=i;return}function kQa(a,b){a=a|0;b=b|0;var d=0;d=a+304|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=74;c[b+((c[d>>2]|0)+ -8<<2)>>2]=75;c[b+((c[d>>2]|0)+ -7<<2)>>2]=76;c[b+((c[d>>2]|0)+ -6<<2)>>2]=77;c[b+((c[d>>2]|0)+ -5<<2)>>2]=78;c[b+((c[d>>2]|0)+ -4<<2)>>2]=79;c[b+((c[d>>2]|0)+ -3<<2)>>2]=82;c[b+((c[d>>2]|0)+ -2<<2)>>2]=81;c[b+((c[d>>2]|0)+ -1<<2)>>2]=80;i=i;return}function lQa(a,b){a=a|0;b=b|0;var d=0;d=a+300|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=72;c[b+((c[d>>2]|0)+ -8<<2)>>2]=73;c[b+((c[d>>2]|0)+ -7<<2)>>2]=74;c[b+((c[d>>2]|0)+ -6<<2)>>2]=75;c[b+((c[d>>2]|0)+ -5<<2)>>2]=76;c[b+((c[d>>2]|0)+ -4<<2)>>2]=77;c[b+((c[d>>2]|0)+ -3<<2)>>2]=83;c[b+((c[d>>2]|0)+ -2<<2)>>2]=82;c[b+((c[d>>2]|0)+ -1<<2)>>2]=81;i=i;return}function mQa(a,b){a=a|0;b=b|0;var d=0;d=a+296|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=72;c[b+((c[d>>2]|0)+ -8<<2)>>2]=73;c[b+((c[d>>2]|0)+ -7<<2)>>2]=74;c[b+((c[d>>2]|0)+ -6<<2)>>2]=75;c[b+((c[d>>2]|0)+ -5<<2)>>2]=76;c[b+((c[d>>2]|0)+ -4<<2)>>2]=77;c[b+((c[d>>2]|0)+ -3<<2)>>2]=83;c[b+((c[d>>2]|0)+ -2<<2)>>2]=82;c[b+((c[d>>2]|0)+ -1<<2)>>2]=81;i=i;return}function nQa(a,b){a=a|0;b=b|0;var d=0;d=a+292|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=70;c[b+((c[d>>2]|0)+ -8<<2)>>2]=71;c[b+((c[d>>2]|0)+ -7<<2)>>2]=72;c[b+((c[d>>2]|0)+ -6<<2)>>2]=73;c[b+((c[d>>2]|0)+ -5<<2)>>2]=74;c[b+((c[d>>2]|0)+ -4<<2)>>2]=75;c[b+((c[d>>2]|0)+ -3<<2)>>2]=84;c[b+((c[d>>2]|0)+ -2<<2)>>2]=83;c[b+((c[d>>2]|0)+ -1<<2)>>2]=82;i=i;return}function oQa(a,b){a=a|0;b=b|0;var d=0;d=a+288|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=70;c[b+((c[d>>2]|0)+ -8<<2)>>2]=71;c[b+((c[d>>2]|0)+ -7<<2)>>2]=72;c[b+((c[d>>2]|0)+ -6<<2)>>2]=73;c[b+((c[d>>2]|0)+ -5<<2)>>2]=74;c[b+((c[d>>2]|0)+ -4<<2)>>2]=75;c[b+((c[d>>2]|0)+ -3<<2)>>2]=84;c[b+((c[d>>2]|0)+ -2<<2)>>2]=83;c[b+((c[d>>2]|0)+ -1<<2)>>2]=82;i=i;return}function pQa(a,b){a=a|0;b=b|0;var d=0;d=a+284|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=68;c[b+((c[d>>2]|0)+ -8<<2)>>2]=69;c[b+((c[d>>2]|0)+ -7<<2)>>2]=70;c[b+((c[d>>2]|0)+ -6<<2)>>2]=71;c[b+((c[d>>2]|0)+ -5<<2)>>2]=72;c[b+((c[d>>2]|0)+ -4<<2)>>2]=73;c[b+((c[d>>2]|0)+ -3<<2)>>2]=85;c[b+((c[d>>2]|0)+ -2<<2)>>2]=84;c[b+((c[d>>2]|0)+ -1<<2)>>2]=83;i=i;return}function qQa(a,b){a=a|0;b=b|0;var d=0;d=a+280|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=68;c[b+((c[d>>2]|0)+ -8<<2)>>2]=69;c[b+((c[d>>2]|0)+ -7<<2)>>2]=70;c[b+((c[d>>2]|0)+ -6<<2)>>2]=71;c[b+((c[d>>2]|0)+ -5<<2)>>2]=72;c[b+((c[d>>2]|0)+ -4<<2)>>2]=73;c[b+((c[d>>2]|0)+ -3<<2)>>2]=85;c[b+((c[d>>2]|0)+ -2<<2)>>2]=84;c[b+((c[d>>2]|0)+ -1<<2)>>2]=83;i=i;return}function rQa(a,b){a=a|0;b=b|0;var d=0;d=a+276|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=66;c[b+((c[d>>2]|0)+ -8<<2)>>2]=67;c[b+((c[d>>2]|0)+ -7<<2)>>2]=68;c[b+((c[d>>2]|0)+ -6<<2)>>2]=69;c[b+((c[d>>2]|0)+ -5<<2)>>2]=70;c[b+((c[d>>2]|0)+ -4<<2)>>2]=71;c[b+((c[d>>2]|0)+ -3<<2)>>2]=86;c[b+((c[d>>2]|0)+ -2<<2)>>2]=85;c[b+((c[d>>2]|0)+ -1<<2)>>2]=84;i=i;return}function sQa(a,b){a=a|0;b=b|0;var d=0;d=a+272|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=66;c[b+((c[d>>2]|0)+ -8<<2)>>2]=67;c[b+((c[d>>2]|0)+ -7<<2)>>2]=68;c[b+((c[d>>2]|0)+ -6<<2)>>2]=69;c[b+((c[d>>2]|0)+ -5<<2)>>2]=70;c[b+((c[d>>2]|0)+ -4<<2)>>2]=71;c[b+((c[d>>2]|0)+ -3<<2)>>2]=86;c[b+((c[d>>2]|0)+ -2<<2)>>2]=85;c[b+((c[d>>2]|0)+ -1<<2)>>2]=84;i=i;return}function tQa(a,b){a=a|0;b=b|0;var d=0;d=a+268|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=64;c[b+((c[d>>2]|0)+ -8<<2)>>2]=65;c[b+((c[d>>2]|0)+ -7<<2)>>2]=66;c[b+((c[d>>2]|0)+ -6<<2)>>2]=67;c[b+((c[d>>2]|0)+ -5<<2)>>2]=68;c[b+((c[d>>2]|0)+ -4<<2)>>2]=69;c[b+((c[d>>2]|0)+ -3<<2)>>2]=87;c[b+((c[d>>2]|0)+ -2<<2)>>2]=86;c[b+((c[d>>2]|0)+ -1<<2)>>2]=85;i=i;return}function uQa(a,b){a=a|0;b=b|0;var d=0;d=a+264|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=64;c[b+((c[d>>2]|0)+ -8<<2)>>2]=65;c[b+((c[d>>2]|0)+ -7<<2)>>2]=66;c[b+((c[d>>2]|0)+ -6<<2)>>2]=67;c[b+((c[d>>2]|0)+ -5<<2)>>2]=68;c[b+((c[d>>2]|0)+ -4<<2)>>2]=69;c[b+((c[d>>2]|0)+ -3<<2)>>2]=87;c[b+((c[d>>2]|0)+ -2<<2)>>2]=86;c[b+((c[d>>2]|0)+ -1<<2)>>2]=85;i=i;return}function vQa(a,b){a=a|0;b=b|0;var d=0;d=a+260|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=62;c[b+((c[d>>2]|0)+ -8<<2)>>2]=63;c[b+((c[d>>2]|0)+ -7<<2)>>2]=64;c[b+((c[d>>2]|0)+ -6<<2)>>2]=65;c[b+((c[d>>2]|0)+ -5<<2)>>2]=66;c[b+((c[d>>2]|0)+ -4<<2)>>2]=67;c[b+((c[d>>2]|0)+ -3<<2)>>2]=88;c[b+((c[d>>2]|0)+ -2<<2)>>2]=87;c[b+((c[d>>2]|0)+ -1<<2)>>2]=86;i=i;return}function wQa(a,b){a=a|0;b=b|0;var d=0;d=a+256|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=62;c[b+((c[d>>2]|0)+ -8<<2)>>2]=63;c[b+((c[d>>2]|0)+ -7<<2)>>2]=64;c[b+((c[d>>2]|0)+ -6<<2)>>2]=65;c[b+((c[d>>2]|0)+ -5<<2)>>2]=66;c[b+((c[d>>2]|0)+ -4<<2)>>2]=67;c[b+((c[d>>2]|0)+ -3<<2)>>2]=88;c[b+((c[d>>2]|0)+ -2<<2)>>2]=87;c[b+((c[d>>2]|0)+ -1<<2)>>2]=86;i=i;return}function xQa(a,b){a=a|0;b=b|0;var d=0;d=a+252|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=60;c[b+((c[d>>2]|0)+ -8<<2)>>2]=61;c[b+((c[d>>2]|0)+ -7<<2)>>2]=62;c[b+((c[d>>2]|0)+ -6<<2)>>2]=63;c[b+((c[d>>2]|0)+ -5<<2)>>2]=64;c[b+((c[d>>2]|0)+ -4<<2)>>2]=65;c[b+((c[d>>2]|0)+ -3<<2)>>2]=89;c[b+((c[d>>2]|0)+ -2<<2)>>2]=88;c[b+((c[d>>2]|0)+ -1<<2)>>2]=87;i=i;return}function yQa(a,b){a=a|0;b=b|0;var d=0;d=a+248|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=60;c[b+((c[d>>2]|0)+ -8<<2)>>2]=61;c[b+((c[d>>2]|0)+ -7<<2)>>2]=62;c[b+((c[d>>2]|0)+ -6<<2)>>2]=63;c[b+((c[d>>2]|0)+ -5<<2)>>2]=64;c[b+((c[d>>2]|0)+ -4<<2)>>2]=65;c[b+((c[d>>2]|0)+ -3<<2)>>2]=89;c[b+((c[d>>2]|0)+ -2<<2)>>2]=88;c[b+((c[d>>2]|0)+ -1<<2)>>2]=87;i=i;return}function zQa(a,b){a=a|0;b=b|0;var d=0;d=a+244|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=58;c[b+((c[d>>2]|0)+ -8<<2)>>2]=59;c[b+((c[d>>2]|0)+ -7<<2)>>2]=60;c[b+((c[d>>2]|0)+ -6<<2)>>2]=61;c[b+((c[d>>2]|0)+ -5<<2)>>2]=62;c[b+((c[d>>2]|0)+ -4<<2)>>2]=63;c[b+((c[d>>2]|0)+ -3<<2)>>2]=90;c[b+((c[d>>2]|0)+ -2<<2)>>2]=89;c[b+((c[d>>2]|0)+ -1<<2)>>2]=88;i=i;return}function AQa(a,b){a=a|0;b=b|0;var d=0;d=a+240|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=58;c[b+((c[d>>2]|0)+ -8<<2)>>2]=59;c[b+((c[d>>2]|0)+ -7<<2)>>2]=60;c[b+((c[d>>2]|0)+ -6<<2)>>2]=61;c[b+((c[d>>2]|0)+ -5<<2)>>2]=62;c[b+((c[d>>2]|0)+ -4<<2)>>2]=63;c[b+((c[d>>2]|0)+ -3<<2)>>2]=90;c[b+((c[d>>2]|0)+ -2<<2)>>2]=89;c[b+((c[d>>2]|0)+ -1<<2)>>2]=88;i=i;return}function BQa(a,b){a=a|0;b=b|0;var d=0;d=a+236|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=56;c[b+((c[d>>2]|0)+ -8<<2)>>2]=57;c[b+((c[d>>2]|0)+ -7<<2)>>2]=58;c[b+((c[d>>2]|0)+ -6<<2)>>2]=59;c[b+((c[d>>2]|0)+ -5<<2)>>2]=60;c[b+((c[d>>2]|0)+ -4<<2)>>2]=61;c[b+((c[d>>2]|0)+ -3<<2)>>2]=91;c[b+((c[d>>2]|0)+ -2<<2)>>2]=90;c[b+((c[d>>2]|0)+ -1<<2)>>2]=89;i=i;return}function CQa(a,b){a=a|0;b=b|0;var d=0;d=a+232|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=56;c[b+((c[d>>2]|0)+ -8<<2)>>2]=57;c[b+((c[d>>2]|0)+ -7<<2)>>2]=58;c[b+((c[d>>2]|0)+ -6<<2)>>2]=59;c[b+((c[d>>2]|0)+ -5<<2)>>2]=60;c[b+((c[d>>2]|0)+ -4<<2)>>2]=61;c[b+((c[d>>2]|0)+ -3<<2)>>2]=91;c[b+((c[d>>2]|0)+ -2<<2)>>2]=90;c[b+((c[d>>2]|0)+ -1<<2)>>2]=89;i=i;return}function DQa(a,b){a=a|0;b=b|0;var d=0;d=a+228|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=54;c[b+((c[d>>2]|0)+ -8<<2)>>2]=55;c[b+((c[d>>2]|0)+ -7<<2)>>2]=56;c[b+((c[d>>2]|0)+ -6<<2)>>2]=57;c[b+((c[d>>2]|0)+ -5<<2)>>2]=58;c[b+((c[d>>2]|0)+ -4<<2)>>2]=59;c[b+((c[d>>2]|0)+ -3<<2)>>2]=92;c[b+((c[d>>2]|0)+ -2<<2)>>2]=91;c[b+((c[d>>2]|0)+ -1<<2)>>2]=90;i=i;return}function EQa(a,b){a=a|0;b=b|0;var d=0;d=a+224|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=54;c[b+((c[d>>2]|0)+ -8<<2)>>2]=55;c[b+((c[d>>2]|0)+ -7<<2)>>2]=56;c[b+((c[d>>2]|0)+ -6<<2)>>2]=57;c[b+((c[d>>2]|0)+ -5<<2)>>2]=58;c[b+((c[d>>2]|0)+ -4<<2)>>2]=59;c[b+((c[d>>2]|0)+ -3<<2)>>2]=92;c[b+((c[d>>2]|0)+ -2<<2)>>2]=91;c[b+((c[d>>2]|0)+ -1<<2)>>2]=90;i=i;return}function FQa(a,b){a=a|0;b=b|0;var d=0;d=a+220|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=52;c[b+((c[d>>2]|0)+ -8<<2)>>2]=53;c[b+((c[d>>2]|0)+ -7<<2)>>2]=54;c[b+((c[d>>2]|0)+ -6<<2)>>2]=55;c[b+((c[d>>2]|0)+ -5<<2)>>2]=56;c[b+((c[d>>2]|0)+ -4<<2)>>2]=57;c[b+((c[d>>2]|0)+ -3<<2)>>2]=93;c[b+((c[d>>2]|0)+ -2<<2)>>2]=92;c[b+((c[d>>2]|0)+ -1<<2)>>2]=91;i=i;return}function GQa(a,b){a=a|0;b=b|0;var d=0;d=a+216|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=52;c[b+((c[d>>2]|0)+ -8<<2)>>2]=53;c[b+((c[d>>2]|0)+ -7<<2)>>2]=54;c[b+((c[d>>2]|0)+ -6<<2)>>2]=55;c[b+((c[d>>2]|0)+ -5<<2)>>2]=56;c[b+((c[d>>2]|0)+ -4<<2)>>2]=57;c[b+((c[d>>2]|0)+ -3<<2)>>2]=93;c[b+((c[d>>2]|0)+ -2<<2)>>2]=92;c[b+((c[d>>2]|0)+ -1<<2)>>2]=91;i=i;return}function HQa(a,b){a=a|0;b=b|0;var d=0;d=a+212|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=50;c[b+((c[d>>2]|0)+ -8<<2)>>2]=51;c[b+((c[d>>2]|0)+ -7<<2)>>2]=52;c[b+((c[d>>2]|0)+ -6<<2)>>2]=53;c[b+((c[d>>2]|0)+ -5<<2)>>2]=54;c[b+((c[d>>2]|0)+ -4<<2)>>2]=55;c[b+((c[d>>2]|0)+ -3<<2)>>2]=94;c[b+((c[d>>2]|0)+ -2<<2)>>2]=93;c[b+((c[d>>2]|0)+ -1<<2)>>2]=92;i=i;return}function IQa(a,b){a=a|0;b=b|0;var d=0;d=a+208|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=50;c[b+((c[d>>2]|0)+ -8<<2)>>2]=51;c[b+((c[d>>2]|0)+ -7<<2)>>2]=52;c[b+((c[d>>2]|0)+ -6<<2)>>2]=53;c[b+((c[d>>2]|0)+ -5<<2)>>2]=54;c[b+((c[d>>2]|0)+ -4<<2)>>2]=55;c[b+((c[d>>2]|0)+ -3<<2)>>2]=94;c[b+((c[d>>2]|0)+ -2<<2)>>2]=93;c[b+((c[d>>2]|0)+ -1<<2)>>2]=92;i=i;return}function JQa(a,b){a=a|0;b=b|0;var d=0;d=a+204|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=48;c[b+((c[d>>2]|0)+ -8<<2)>>2]=49;c[b+((c[d>>2]|0)+ -7<<2)>>2]=50;c[b+((c[d>>2]|0)+ -6<<2)>>2]=51;c[b+((c[d>>2]|0)+ -5<<2)>>2]=52;c[b+((c[d>>2]|0)+ -4<<2)>>2]=53;c[b+((c[d>>2]|0)+ -3<<2)>>2]=95;c[b+((c[d>>2]|0)+ -2<<2)>>2]=94;c[b+((c[d>>2]|0)+ -1<<2)>>2]=93;i=i;return}function KQa(a,b){a=a|0;b=b|0;var d=0;d=a+200|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=48;c[b+((c[d>>2]|0)+ -8<<2)>>2]=49;c[b+((c[d>>2]|0)+ -7<<2)>>2]=50;c[b+((c[d>>2]|0)+ -6<<2)>>2]=51;c[b+((c[d>>2]|0)+ -5<<2)>>2]=52;c[b+((c[d>>2]|0)+ -4<<2)>>2]=53;c[b+((c[d>>2]|0)+ -3<<2)>>2]=95;c[b+((c[d>>2]|0)+ -2<<2)>>2]=94;c[b+((c[d>>2]|0)+ -1<<2)>>2]=93;i=i;return}function LQa(a,b){a=a|0;b=b|0;var d=0;d=a+196|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=46;c[b+((c[d>>2]|0)+ -8<<2)>>2]=47;c[b+((c[d>>2]|0)+ -7<<2)>>2]=48;c[b+((c[d>>2]|0)+ -6<<2)>>2]=49;c[b+((c[d>>2]|0)+ -5<<2)>>2]=50;c[b+((c[d>>2]|0)+ -4<<2)>>2]=51;c[b+((c[d>>2]|0)+ -3<<2)>>2]=96;c[b+((c[d>>2]|0)+ -2<<2)>>2]=95;c[b+((c[d>>2]|0)+ -1<<2)>>2]=94;i=i;return}function MQa(a,b){a=a|0;b=b|0;var d=0;d=a+192|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=46;c[b+((c[d>>2]|0)+ -8<<2)>>2]=47;c[b+((c[d>>2]|0)+ -7<<2)>>2]=48;c[b+((c[d>>2]|0)+ -6<<2)>>2]=49;c[b+((c[d>>2]|0)+ -5<<2)>>2]=50;c[b+((c[d>>2]|0)+ -4<<2)>>2]=51;c[b+((c[d>>2]|0)+ -3<<2)>>2]=96;c[b+((c[d>>2]|0)+ -2<<2)>>2]=95;c[b+((c[d>>2]|0)+ -1<<2)>>2]=94;i=i;return}function NQa(a,b){a=a|0;b=b|0;var d=0;d=a+188|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=44;c[b+((c[d>>2]|0)+ -8<<2)>>2]=45;c[b+((c[d>>2]|0)+ -7<<2)>>2]=46;c[b+((c[d>>2]|0)+ -6<<2)>>2]=47;c[b+((c[d>>2]|0)+ -5<<2)>>2]=48;c[b+((c[d>>2]|0)+ -4<<2)>>2]=49;c[b+((c[d>>2]|0)+ -3<<2)>>2]=97;c[b+((c[d>>2]|0)+ -2<<2)>>2]=96;c[b+((c[d>>2]|0)+ -1<<2)>>2]=95;i=i;return}function OQa(a,b){a=a|0;b=b|0;var d=0;d=a+184|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=44;c[b+((c[d>>2]|0)+ -8<<2)>>2]=45;c[b+((c[d>>2]|0)+ -7<<2)>>2]=46;c[b+((c[d>>2]|0)+ -6<<2)>>2]=47;c[b+((c[d>>2]|0)+ -5<<2)>>2]=48;c[b+((c[d>>2]|0)+ -4<<2)>>2]=49;c[b+((c[d>>2]|0)+ -3<<2)>>2]=97;c[b+((c[d>>2]|0)+ -2<<2)>>2]=96;c[b+((c[d>>2]|0)+ -1<<2)>>2]=95;i=i;return}function PQa(a,b){a=a|0;b=b|0;var d=0;d=a+180|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=42;c[b+((c[d>>2]|0)+ -8<<2)>>2]=43;c[b+((c[d>>2]|0)+ -7<<2)>>2]=44;c[b+((c[d>>2]|0)+ -6<<2)>>2]=45;c[b+((c[d>>2]|0)+ -5<<2)>>2]=46;c[b+((c[d>>2]|0)+ -4<<2)>>2]=47;c[b+((c[d>>2]|0)+ -3<<2)>>2]=98;c[b+((c[d>>2]|0)+ -2<<2)>>2]=97;c[b+((c[d>>2]|0)+ -1<<2)>>2]=96;i=i;return}function QQa(a,b){a=a|0;b=b|0;var d=0;d=a+176|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=42;c[b+((c[d>>2]|0)+ -8<<2)>>2]=43;c[b+((c[d>>2]|0)+ -7<<2)>>2]=44;c[b+((c[d>>2]|0)+ -6<<2)>>2]=45;c[b+((c[d>>2]|0)+ -5<<2)>>2]=46;c[b+((c[d>>2]|0)+ -4<<2)>>2]=47;c[b+((c[d>>2]|0)+ -3<<2)>>2]=98;c[b+((c[d>>2]|0)+ -2<<2)>>2]=97;c[b+((c[d>>2]|0)+ -1<<2)>>2]=96;i=i;return}function RQa(a,b){a=a|0;b=b|0;var d=0;d=a+172|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=40;c[b+((c[d>>2]|0)+ -8<<2)>>2]=41;c[b+((c[d>>2]|0)+ -7<<2)>>2]=42;c[b+((c[d>>2]|0)+ -6<<2)>>2]=43;c[b+((c[d>>2]|0)+ -5<<2)>>2]=44;c[b+((c[d>>2]|0)+ -4<<2)>>2]=45;c[b+((c[d>>2]|0)+ -3<<2)>>2]=99;c[b+((c[d>>2]|0)+ -2<<2)>>2]=98;c[b+((c[d>>2]|0)+ -1<<2)>>2]=97;i=i;return}function SQa(a,b){a=a|0;b=b|0;var d=0;d=a+168|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=40;c[b+((c[d>>2]|0)+ -8<<2)>>2]=41;c[b+((c[d>>2]|0)+ -7<<2)>>2]=42;c[b+((c[d>>2]|0)+ -6<<2)>>2]=43;c[b+((c[d>>2]|0)+ -5<<2)>>2]=44;c[b+((c[d>>2]|0)+ -4<<2)>>2]=45;c[b+((c[d>>2]|0)+ -3<<2)>>2]=99;c[b+((c[d>>2]|0)+ -2<<2)>>2]=98;c[b+((c[d>>2]|0)+ -1<<2)>>2]=97;i=i;return}function TQa(a,b){a=a|0;b=b|0;var d=0;d=a+164|0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=40;c[b+((c[d>>2]|0)+ -5<<2)>>2]=41;c[b+((c[d>>2]|0)+ -4<<2)>>2]=42;c[b+((c[d>>2]|0)+ -3<<2)>>2]=43;c[b+((c[d>>2]|0)+ -2<<2)>>2]=99;c[b+((c[d>>2]|0)+ -1<<2)>>2]=98;i=i;return}function UQa(a,b){a=a|0;b=b|0;var d=0;d=a+160|0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=40;c[b+((c[d>>2]|0)+ -5<<2)>>2]=41;c[b+((c[d>>2]|0)+ -4<<2)>>2]=42;c[b+((c[d>>2]|0)+ -3<<2)>>2]=43;c[b+((c[d>>2]|0)+ -2<<2)>>2]=99;c[b+((c[d>>2]|0)+ -1<<2)>>2]=98;i=i;return}function VQa(a,b){a=a|0;b=b|0;var d=0;d=a+156|0;c[b+((c[d>>2]|0)+ -4<<2)>>2]=36;c[b+((c[d>>2]|0)+ -3<<2)>>2]=37;c[b+((c[d>>2]|0)+ -2<<2)>>2]=38;c[b+((c[d>>2]|0)+ -1<<2)>>2]=39;i=i;return}function WQa(a,b){a=a|0;b=b|0;var d=0;d=a+152|0;c[b+((c[d>>2]|0)+ -5<<2)>>2]=36;c[b+((c[d>>2]|0)+ -4<<2)>>2]=37;c[b+((c[d>>2]|0)+ -3<<2)>>2]=38;c[b+((c[d>>2]|0)+ -2<<2)>>2]=39;c[b+((c[d>>2]|0)+ -1<<2)>>2]=99;i=i;return}function XQa(a,b){a=a|0;b=b|0;var d=0;d=a+148|0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=34;c[b+((c[d>>2]|0)+ -5<<2)>>2]=35;c[b+((c[d>>2]|0)+ -4<<2)>>2]=36;c[b+((c[d>>2]|0)+ -3<<2)>>2]=37;c[b+((c[d>>2]|0)+ -2<<2)>>2]=38;c[b+((c[d>>2]|0)+ -1<<2)>>2]=39;i=i;return}function YQa(a,b){a=a|0;b=b|0;var d=0;d=a+144|0;c[b+((c[d>>2]|0)+ -7<<2)>>2]=34;c[b+((c[d>>2]|0)+ -6<<2)>>2]=35;c[b+((c[d>>2]|0)+ -5<<2)>>2]=36;c[b+((c[d>>2]|0)+ -4<<2)>>2]=37;c[b+((c[d>>2]|0)+ -3<<2)>>2]=38;c[b+((c[d>>2]|0)+ -2<<2)>>2]=39;c[b+((c[d>>2]|0)+ -1<<2)>>2]=98;i=i;return}function ZQa(a,b){a=a|0;b=b|0;var d=0;d=a+140|0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=32;c[b+((c[d>>2]|0)+ -5<<2)>>2]=33;c[b+((c[d>>2]|0)+ -4<<2)>>2]=34;c[b+((c[d>>2]|0)+ -3<<2)>>2]=35;c[b+((c[d>>2]|0)+ -2<<2)>>2]=36;c[b+((c[d>>2]|0)+ -1<<2)>>2]=37;i=i;return}function _Qa(a,b){a=a|0;b=b|0;var d=0;d=a+136|0;c[b+((c[d>>2]|0)+ -7<<2)>>2]=32;c[b+((c[d>>2]|0)+ -6<<2)>>2]=33;c[b+((c[d>>2]|0)+ -5<<2)>>2]=34;c[b+((c[d>>2]|0)+ -4<<2)>>2]=35;c[b+((c[d>>2]|0)+ -3<<2)>>2]=36;c[b+((c[d>>2]|0)+ -2<<2)>>2]=37;c[b+((c[d>>2]|0)+ -1<<2)>>2]=97;i=i;return}function $Qa(a,b){a=a|0;b=b|0;var d=0;d=a+132|0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=30;c[b+((c[d>>2]|0)+ -5<<2)>>2]=31;c[b+((c[d>>2]|0)+ -4<<2)>>2]=32;c[b+((c[d>>2]|0)+ -3<<2)>>2]=33;c[b+((c[d>>2]|0)+ -2<<2)>>2]=34;c[b+((c[d>>2]|0)+ -1<<2)>>2]=35;i=i;return}function aRa(a,b){a=a|0;b=b|0;var d=0;d=a+128|0;c[b+((c[d>>2]|0)+ -7<<2)>>2]=30;c[b+((c[d>>2]|0)+ -6<<2)>>2]=31;c[b+((c[d>>2]|0)+ -5<<2)>>2]=32;c[b+((c[d>>2]|0)+ -4<<2)>>2]=33;c[b+((c[d>>2]|0)+ -3<<2)>>2]=34;c[b+((c[d>>2]|0)+ -2<<2)>>2]=35;c[b+((c[d>>2]|0)+ -1<<2)>>2]=96;i=i;return}function bRa(a,b){a=a|0;b=b|0;var d=0;d=a+124|0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=28;c[b+((c[d>>2]|0)+ -5<<2)>>2]=29;c[b+((c[d>>2]|0)+ -4<<2)>>2]=30;c[b+((c[d>>2]|0)+ -3<<2)>>2]=31;c[b+((c[d>>2]|0)+ -2<<2)>>2]=32;c[b+((c[d>>2]|0)+ -1<<2)>>2]=33;i=i;return}function cRa(a,b){a=a|0;b=b|0;var d=0;d=a+120|0;c[b+((c[d>>2]|0)+ -7<<2)>>2]=28;c[b+((c[d>>2]|0)+ -6<<2)>>2]=29;c[b+((c[d>>2]|0)+ -5<<2)>>2]=30;c[b+((c[d>>2]|0)+ -4<<2)>>2]=31;c[b+((c[d>>2]|0)+ -3<<2)>>2]=32;c[b+((c[d>>2]|0)+ -2<<2)>>2]=33;c[b+((c[d>>2]|0)+ -1<<2)>>2]=95;i=i;return}function dRa(a,b){a=a|0;b=b|0;var d=0;d=a+116|0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=26;c[b+((c[d>>2]|0)+ -5<<2)>>2]=27;c[b+((c[d>>2]|0)+ -4<<2)>>2]=28;c[b+((c[d>>2]|0)+ -3<<2)>>2]=29;c[b+((c[d>>2]|0)+ -2<<2)>>2]=30;c[b+((c[d>>2]|0)+ -1<<2)>>2]=31;i=i;return}function eRa(a,b){a=a|0;b=b|0;var d=0;d=a+112|0;c[b+((c[d>>2]|0)+ -7<<2)>>2]=26;c[b+((c[d>>2]|0)+ -6<<2)>>2]=27;c[b+((c[d>>2]|0)+ -5<<2)>>2]=28;c[b+((c[d>>2]|0)+ -4<<2)>>2]=29;c[b+((c[d>>2]|0)+ -3<<2)>>2]=30;c[b+((c[d>>2]|0)+ -2<<2)>>2]=31;c[b+((c[d>>2]|0)+ -1<<2)>>2]=94;i=i;return}function fRa(a,b){a=a|0;b=b|0;var d=0;d=a+108|0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=24;c[b+((c[d>>2]|0)+ -5<<2)>>2]=25;c[b+((c[d>>2]|0)+ -4<<2)>>2]=26;c[b+((c[d>>2]|0)+ -3<<2)>>2]=27;c[b+((c[d>>2]|0)+ -2<<2)>>2]=28;c[b+((c[d>>2]|0)+ -1<<2)>>2]=29;i=i;return}function gRa(a,b){a=a|0;b=b|0;var d=0;d=a+104|0;c[b+((c[d>>2]|0)+ -7<<2)>>2]=24;c[b+((c[d>>2]|0)+ -6<<2)>>2]=25;c[b+((c[d>>2]|0)+ -5<<2)>>2]=26;c[b+((c[d>>2]|0)+ -4<<2)>>2]=27;c[b+((c[d>>2]|0)+ -3<<2)>>2]=28;c[b+((c[d>>2]|0)+ -2<<2)>>2]=29;c[b+((c[d>>2]|0)+ -1<<2)>>2]=93;i=i;return}function hRa(a,b){a=a|0;b=b|0;var d=0;d=a+100|0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=22;c[b+((c[d>>2]|0)+ -5<<2)>>2]=23;c[b+((c[d>>2]|0)+ -4<<2)>>2]=24;c[b+((c[d>>2]|0)+ -3<<2)>>2]=25;c[b+((c[d>>2]|0)+ -2<<2)>>2]=26;c[b+((c[d>>2]|0)+ -1<<2)>>2]=27;i=i;return}function iRa(a,b){a=a|0;b=b|0;var d=0;d=a+96|0;c[b+((c[d>>2]|0)+ -7<<2)>>2]=22;c[b+((c[d>>2]|0)+ -6<<2)>>2]=23;c[b+((c[d>>2]|0)+ -5<<2)>>2]=24;c[b+((c[d>>2]|0)+ -4<<2)>>2]=25;c[b+((c[d>>2]|0)+ -3<<2)>>2]=26;c[b+((c[d>>2]|0)+ -2<<2)>>2]=27;c[b+((c[d>>2]|0)+ -1<<2)>>2]=92;i=i;return}function jRa(a,b){a=a|0;b=b|0;var d=0;d=a+92|0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=20;c[b+((c[d>>2]|0)+ -5<<2)>>2]=21;c[b+((c[d>>2]|0)+ -4<<2)>>2]=22;c[b+((c[d>>2]|0)+ -3<<2)>>2]=23;c[b+((c[d>>2]|0)+ -2<<2)>>2]=24;c[b+((c[d>>2]|0)+ -1<<2)>>2]=25;i=i;return}function kRa(a,b){a=a|0;b=b|0;var d=0;d=a+88|0;c[b+((c[d>>2]|0)+ -7<<2)>>2]=20;c[b+((c[d>>2]|0)+ -6<<2)>>2]=21;c[b+((c[d>>2]|0)+ -5<<2)>>2]=22;c[b+((c[d>>2]|0)+ -4<<2)>>2]=23;c[b+((c[d>>2]|0)+ -3<<2)>>2]=24;c[b+((c[d>>2]|0)+ -2<<2)>>2]=25;c[b+((c[d>>2]|0)+ -1<<2)>>2]=91;i=i;return}function lRa(a,b){a=a|0;b=b|0;var d=0;d=a+84|0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=18;c[b+((c[d>>2]|0)+ -5<<2)>>2]=19;c[b+((c[d>>2]|0)+ -4<<2)>>2]=20;c[b+((c[d>>2]|0)+ -3<<2)>>2]=21;c[b+((c[d>>2]|0)+ -2<<2)>>2]=22;c[b+((c[d>>2]|0)+ -1<<2)>>2]=23;i=i;return}function mRa(a,b){a=a|0;b=b|0;var d=0;d=a+80|0;c[b+((c[d>>2]|0)+ -7<<2)>>2]=18;c[b+((c[d>>2]|0)+ -6<<2)>>2]=19;c[b+((c[d>>2]|0)+ -5<<2)>>2]=20;c[b+((c[d>>2]|0)+ -4<<2)>>2]=21;c[b+((c[d>>2]|0)+ -3<<2)>>2]=22;c[b+((c[d>>2]|0)+ -2<<2)>>2]=23;c[b+((c[d>>2]|0)+ -1<<2)>>2]=90;i=i;return}function nRa(a,b){a=a|0;b=b|0;var d=0;d=a+76|0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=16;c[b+((c[d>>2]|0)+ -5<<2)>>2]=17;c[b+((c[d>>2]|0)+ -4<<2)>>2]=18;c[b+((c[d>>2]|0)+ -3<<2)>>2]=19;c[b+((c[d>>2]|0)+ -2<<2)>>2]=20;c[b+((c[d>>2]|0)+ -1<<2)>>2]=21;i=i;return}function oRa(a,b){a=a|0;b=b|0;var d=0;d=a+72|0;c[b+((c[d>>2]|0)+ -7<<2)>>2]=16;c[b+((c[d>>2]|0)+ -6<<2)>>2]=17;c[b+((c[d>>2]|0)+ -5<<2)>>2]=18;c[b+((c[d>>2]|0)+ -4<<2)>>2]=19;c[b+((c[d>>2]|0)+ -3<<2)>>2]=20;c[b+((c[d>>2]|0)+ -2<<2)>>2]=21;c[b+((c[d>>2]|0)+ -1<<2)>>2]=89;i=i;return}function pRa(a,b){a=a|0;b=b|0;var d=0;d=a+68|0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=14;c[b+((c[d>>2]|0)+ -5<<2)>>2]=15;c[b+((c[d>>2]|0)+ -4<<2)>>2]=16;c[b+((c[d>>2]|0)+ -3<<2)>>2]=17;c[b+((c[d>>2]|0)+ -2<<2)>>2]=18;c[b+((c[d>>2]|0)+ -1<<2)>>2]=19;i=i;return}function qRa(a,b){a=a|0;b=b|0;var d=0;d=a+64|0;c[b+((c[d>>2]|0)+ -7<<2)>>2]=14;c[b+((c[d>>2]|0)+ -6<<2)>>2]=15;c[b+((c[d>>2]|0)+ -5<<2)>>2]=16;c[b+((c[d>>2]|0)+ -4<<2)>>2]=17;c[b+((c[d>>2]|0)+ -3<<2)>>2]=18;c[b+((c[d>>2]|0)+ -2<<2)>>2]=19;c[b+((c[d>>2]|0)+ -1<<2)>>2]=88;i=i;return}function rRa(a,b){a=a|0;b=b|0;var d=0;d=a+60|0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=12;c[b+((c[d>>2]|0)+ -5<<2)>>2]=13;c[b+((c[d>>2]|0)+ -4<<2)>>2]=14;c[b+((c[d>>2]|0)+ -3<<2)>>2]=15;c[b+((c[d>>2]|0)+ -2<<2)>>2]=16;c[b+((c[d>>2]|0)+ -1<<2)>>2]=17;i=i;return}function sRa(a,b){a=a|0;b=b|0;var d=0;d=a+56|0;c[b+((c[d>>2]|0)+ -7<<2)>>2]=12;c[b+((c[d>>2]|0)+ -6<<2)>>2]=13;c[b+((c[d>>2]|0)+ -5<<2)>>2]=14;c[b+((c[d>>2]|0)+ -4<<2)>>2]=15;c[b+((c[d>>2]|0)+ -3<<2)>>2]=16;c[b+((c[d>>2]|0)+ -2<<2)>>2]=17;c[b+((c[d>>2]|0)+ -1<<2)>>2]=87;i=i;return}function tRa(a,b){a=a|0;b=b|0;var d=0;d=a+52|0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=10;c[b+((c[d>>2]|0)+ -5<<2)>>2]=11;c[b+((c[d>>2]|0)+ -4<<2)>>2]=12;c[b+((c[d>>2]|0)+ -3<<2)>>2]=13;c[b+((c[d>>2]|0)+ -2<<2)>>2]=14;c[b+((c[d>>2]|0)+ -1<<2)>>2]=15;i=i;return}function uRa(a,b){a=a|0;b=b|0;var d=0;d=a+48|0;c[b+((c[d>>2]|0)+ -7<<2)>>2]=10;c[b+((c[d>>2]|0)+ -6<<2)>>2]=11;c[b+((c[d>>2]|0)+ -5<<2)>>2]=12;c[b+((c[d>>2]|0)+ -4<<2)>>2]=13;c[b+((c[d>>2]|0)+ -3<<2)>>2]=14;c[b+((c[d>>2]|0)+ -2<<2)>>2]=15;c[b+((c[d>>2]|0)+ -1<<2)>>2]=86;i=i;return}function vRa(a,b){a=a|0;b=b|0;var d=0;d=a+44|0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=8;c[b+((c[d>>2]|0)+ -5<<2)>>2]=9;c[b+((c[d>>2]|0)+ -4<<2)>>2]=10;c[b+((c[d>>2]|0)+ -3<<2)>>2]=11;c[b+((c[d>>2]|0)+ -2<<2)>>2]=12;c[b+((c[d>>2]|0)+ -1<<2)>>2]=13;i=i;return}function wRa(a,b){a=a|0;b=b|0;var d=0;d=a+40|0;c[b+((c[d>>2]|0)+ -7<<2)>>2]=8;c[b+((c[d>>2]|0)+ -6<<2)>>2]=9;c[b+((c[d>>2]|0)+ -5<<2)>>2]=10;c[b+((c[d>>2]|0)+ -4<<2)>>2]=11;c[b+((c[d>>2]|0)+ -3<<2)>>2]=12;c[b+((c[d>>2]|0)+ -2<<2)>>2]=13;c[b+((c[d>>2]|0)+ -1<<2)>>2]=85;i=i;return}function xRa(a,b){a=a|0;b=b|0;var d=0;d=a+36|0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=6;c[b+((c[d>>2]|0)+ -5<<2)>>2]=7;c[b+((c[d>>2]|0)+ -4<<2)>>2]=8;c[b+((c[d>>2]|0)+ -3<<2)>>2]=9;c[b+((c[d>>2]|0)+ -2<<2)>>2]=10;c[b+((c[d>>2]|0)+ -1<<2)>>2]=11;i=i;return}function yRa(a,b){a=a|0;b=b|0;var d=0;d=a+32|0;c[b+((c[d>>2]|0)+ -7<<2)>>2]=6;c[b+((c[d>>2]|0)+ -6<<2)>>2]=7;c[b+((c[d>>2]|0)+ -5<<2)>>2]=8;c[b+((c[d>>2]|0)+ -4<<2)>>2]=9;c[b+((c[d>>2]|0)+ -3<<2)>>2]=10;c[b+((c[d>>2]|0)+ -2<<2)>>2]=11;c[b+((c[d>>2]|0)+ -1<<2)>>2]=84;i=i;return}function zRa(a,b){a=a|0;b=b|0;var d=0;d=a+28|0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=4;c[b+((c[d>>2]|0)+ -5<<2)>>2]=5;c[b+((c[d>>2]|0)+ -4<<2)>>2]=6;c[b+((c[d>>2]|0)+ -3<<2)>>2]=7;c[b+((c[d>>2]|0)+ -2<<2)>>2]=8;c[b+((c[d>>2]|0)+ -1<<2)>>2]=9;i=i;return}function ARa(a,b){a=a|0;b=b|0;var d=0;d=a+24|0;c[b+((c[d>>2]|0)+ -7<<2)>>2]=4;c[b+((c[d>>2]|0)+ -6<<2)>>2]=5;c[b+((c[d>>2]|0)+ -5<<2)>>2]=6;c[b+((c[d>>2]|0)+ -4<<2)>>2]=7;c[b+((c[d>>2]|0)+ -3<<2)>>2]=8;c[b+((c[d>>2]|0)+ -2<<2)>>2]=9;c[b+((c[d>>2]|0)+ -1<<2)>>2]=83;i=i;return}function BRa(a,b){a=a|0;b=b|0;var d=0;d=a+20|0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=2;c[b+((c[d>>2]|0)+ -5<<2)>>2]=3;c[b+((c[d>>2]|0)+ -4<<2)>>2]=4;c[b+((c[d>>2]|0)+ -3<<2)>>2]=5;c[b+((c[d>>2]|0)+ -2<<2)>>2]=6;c[b+((c[d>>2]|0)+ -1<<2)>>2]=7;i=i;return}function CRa(a,b){a=a|0;b=b|0;var d=0;d=a+16|0;c[b+((c[d>>2]|0)+ -7<<2)>>2]=2;c[b+((c[d>>2]|0)+ -6<<2)>>2]=3;c[b+((c[d>>2]|0)+ -5<<2)>>2]=4;c[b+((c[d>>2]|0)+ -4<<2)>>2]=5;c[b+((c[d>>2]|0)+ -3<<2)>>2]=6;c[b+((c[d>>2]|0)+ -2<<2)>>2]=7;c[b+((c[d>>2]|0)+ -1<<2)>>2]=82;i=i;return}function DRa(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=0;c[b+((c[d>>2]|0)+ -5<<2)>>2]=1;c[b+((c[d>>2]|0)+ -4<<2)>>2]=2;c[b+((c[d>>2]|0)+ -3<<2)>>2]=3;c[b+((c[d>>2]|0)+ -2<<2)>>2]=4;c[b+((c[d>>2]|0)+ -1<<2)>>2]=5;i=i;return}function ERa(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;c[b+((c[d>>2]|0)+ -7<<2)>>2]=0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=1;c[b+((c[d>>2]|0)+ -5<<2)>>2]=2;c[b+((c[d>>2]|0)+ -4<<2)>>2]=3;c[b+((c[d>>2]|0)+ -3<<2)>>2]=4;c[b+((c[d>>2]|0)+ -2<<2)>>2]=5;c[b+((c[d>>2]|0)+ -1<<2)>>2]=81;i=i;return}function FRa(a,b){a=a|0;b=b|0;var d=0;d=a+4|0;c[b+((c[d>>2]|0)+ -4<<2)>>2]=0;c[b+((c[d>>2]|0)+ -3<<2)>>2]=1;c[b+((c[d>>2]|0)+ -2<<2)>>2]=2;c[b+((c[d>>2]|0)+ -1<<2)>>2]=3;i=i;return}function GRa(a,b){a=a|0;b=b|0;c[b+((c[a>>2]|0)+ -5<<2)>>2]=0;c[b+((c[a>>2]|0)+ -4<<2)>>2]=1;c[b+((c[a>>2]|0)+ -3<<2)>>2]=2;c[b+((c[a>>2]|0)+ -2<<2)>>2]=3;c[b+((c[a>>2]|0)+ -1<<2)>>2]=80;i=i;return}function HRa(a){a=a|0;i=i;return 1}function IRa(a){a=a|0;i=i;return 1}function JRa(a){a=a|0;i=i;return 1}function KRa(a){a=a|0;i=i;return 0}function LRa(a){a=a|0;i=i;return 0}function MRa(a){a=a|0;i=i;return 0}function NRa(a){a=a|0;i=i;return 0}function ORa(a){a=a|0;i=i;return 0}function PRa(a,b){a=a|0;b=b|0;i=i;return-1}function QRa(a,b){a=a|0;b=b|0;i=i;return-1}function RRa(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i;return-1}function SRa(){i=i;return 223800}function TRa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0,o=0,p=0.0,q=0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0;e=i;f=c[a>>2]|0;if((f|0)<1){g=0;i=e;return g|0}a=c[d>>2]|0;if((a|0)<1){g=0;i=e;return g|0}if((f|0)==1){g=1;i=e;return g|0}j=+h[b>>3];d=!(j>=0.0);if((a|0)==1){if(d){k=-j}else{k=j}if((f|0)<2){g=1;i=e;return g|0}else{l=k;m=2;n=1}while(1){k=+h[b+(m+ -1<<3)>>3];o=!(k>=0.0);if(o){p=-k}else{p=k}q=p<=l;if(q|o^1){r=q?l:k;s=q?n:m}else{r=-k;s=m}q=m+1|0;if((q|0)>(f|0)){g=s;break}else{l=r;m=q;n=s}}i=e;return g|0}if(d){t=-j}else{t=j}if((f|0)<2){g=1;i=e;return g|0}j=t;d=2;s=a+1|0;n=1;while(1){t=+h[b+(s+ -1<<3)>>3];m=!(t>=0.0);if(m){u=-t}else{u=t}q=u<=j;if(q|m^1){v=q?j:t;w=q?n:d}else{v=-t;w=d}q=d+1|0;if((q|0)>(f|0)){g=w;break}else{j=v;d=q;s=a+s|0;n=w}}i=e;return g|0}function URa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[a>>2]|0;if((g|0)<1){i=f;return 0}j=c[e>>2]|0;if((j|0)<1){i=f;return 0}if((j|0)!=1){e=fa(j,g)|0;if((e|0)>0){k=1}else{i=f;return 0}do{l=d+(k+ -1<<3)|0;h[l>>3]=+h[b>>3]*+h[l>>3];k=k+j|0;}while((k|0)<=(e|0));i=f;return 0}e=(g|0)%5|0;do{if((e|0)==0){m=g}else{if((e|0)<1){n=g}else{k=1;do{j=d+(k+ -1<<3)|0;h[j>>3]=+h[b>>3]*+h[j>>3];k=k+1|0;}while((k|0)<=(e|0));n=c[a>>2]|0}if((n|0)>=5){m=n;break}i=f;return 0}}while(0);n=e+1|0;if((n|0)>(m|0)){i=f;return 0}else{o=n}do{n=d+(o+ -1<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+1<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+2<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+3<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];o=o+5|0;}while((o|0)<=(m|0));i=f;return 0}function VRa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0;g=i;j=c[a>>2]|0;if((j|0)<1){i=g;return 0}k=c[d>>2]|0;do{if((k|0)==1){l=c[f>>2]|0;if((l|0)!=1){m=l;n=1;break}l=(j|0)%3|0;do{if((l|0)==0){o=j}else{if((l|0)<1){p=j}else{q=1;do{r=q+ -1|0;s=b+(r<<3)|0;t=+h[s>>3];u=e+(r<<3)|0;h[s>>3]=+h[u>>3];h[u>>3]=t;q=q+1|0;}while((q|0)<=(l|0));p=c[a>>2]|0}if((p|0)>=3){o=p;break}i=g;return 0}}while(0);q=l+1|0;if((q|0)>(o|0)){i=g;return 0}else{v=q}do{q=v+ -1|0;u=b+(q<<3)|0;t=+h[u>>3];s=e+(q<<3)|0;h[u>>3]=+h[s>>3];h[s>>3]=t;s=b+(v<<3)|0;t=+h[s>>3];u=e+(v<<3)|0;h[s>>3]=+h[u>>3];h[u>>3]=t;u=v+1|0;s=b+(u<<3)|0;t=+h[s>>3];q=e+(u<<3)|0;h[s>>3]=+h[q>>3];h[q>>3]=t;v=v+3|0;}while((v|0)<=(o|0));i=g;return 0}else{if((k|0)<0){w=(fa(1-j|0,k)|0)+1|0}else{w=1}m=c[f>>2]|0;n=w}}while(0);if((m|0)<0){x=1;y=n;z=(fa(1-j|0,m)|0)+1|0}else{x=1;y=n;z=1}while(1){n=b+(y+ -1<<3)|0;t=+h[n>>3];m=e+(z+ -1<<3)|0;h[n>>3]=+h[m>>3];h[m>>3]=t;m=x+1|0;if((m|0)>(j|0)){break}else{z=(c[f>>2]|0)+z|0;y=(c[d>>2]|0)+y|0;x=m}}i=g;return 0}



function T8(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8088>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7760>>3]=+h[(a?e+12304|0:e+12296|0)>>3];i=b;return}function U8(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+472>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6704>>3]=+h[d>>3];i=b;return}function V8(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9056>>3]=+h[b+8896>>3]*+h[b+6712>>3];i=i;return}function W8(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8088>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7600>>3]=+h[(a?e+10936|0:e+10928|0)>>3];i=b;return}function X8(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8080>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7608>>3]=+h[(a?e+10944|0:e+10936|0)>>3];i=b;return}function Y8(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6632>>3]=+h[b+440>>3]*1.0e-5;i=i;return}function Z8(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+440>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6640>>3]=+h[d>>3];i=b;return}function _8(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8080>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7768>>3]=+h[(a?e+12312|0:e+12304|0)>>3];i=b;return}function $8(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+456>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6672>>3]=+h[d>>3];i=b;return}function a9(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9064>>3]=+h[b+8904>>3]*+h[b+6680>>3];i=i;return}function b9(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9072>>3]=+h[b+8912>>3]*+h[b+6648>>3];i=i;return}function c9(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7456>>3]=+h[b+8072>>3]*+h[(c[a+416>>2]|0)+440>>3];i=i;return}function d9(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8072>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7616>>3]=+h[(a?e+10952|0:e+10944|0)>>3];i=b;return}function e9(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6600>>3]=+h[b+424>>3]*1.0e-5;i=i;return}function f9(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+424>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6608>>3]=+h[d>>3];i=b;return}function g9(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8072>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7776>>3]=+h[(a?e+12320|0:e+12312|0)>>3];i=b;return}function h9(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9080>>3]=+h[b+8920>>3]*+h[b+6616>>3];i=i;return}function i9(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7464>>3]=+h[b+8064>>3]*+h[(c[a+416>>2]|0)+448>>3];i=i;return}function j9(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8064>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7784>>3]=+h[(a?e+12328|0:e+12320|0)>>3];i=b;return}function k9(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8064>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7624>>3]=+h[(a?e+10960|0:e+10952|0)>>3];i=b;return}function l9(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6568>>3]=+h[b+408>>3]*1.0e-5;i=i;return}function m9(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7472>>3]=+h[b+8056>>3]*+h[(c[a+416>>2]|0)+456>>3];i=i;return}function n9(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8056>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7632>>3]=+h[(a?e+10968|0:e+10960|0)>>3];i=b;return}function o9(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6536>>3]=+h[b+392>>3]*1.0e-5;i=i;return}function p9(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7496>>3]=+h[b+8032>>3]*+h[(c[a+416>>2]|0)+480>>3];i=i;return}function q9(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7488>>3]=+h[b+8040>>3]*+h[(c[a+416>>2]|0)+472>>3];i=i;return}function r9(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8040>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7808>>3]=+h[(a?e+12352|0:e+12344|0)>>3];i=b;return}function s9(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7480>>3]=+h[b+8048>>3]*+h[(c[a+416>>2]|0)+464>>3];i=i;return}function t9(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+392>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6544>>3]=+h[d>>3];i=b;return}function u9(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8056>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7792>>3]=+h[(a?e+12336|0:e+12328|0)>>3];i=b;return}function v9(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8048>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7800>>3]=+h[(a?e+12344|0:e+12336|0)>>3];i=b;return}function w9(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+408>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6576>>3]=+h[d>>3];i=b;return}function x9(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9096>>3]=+h[b+8936>>3]*+h[b+6552>>3];i=i;return}function y9(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8048>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7640>>3]=+h[(a?e+10976|0:e+10968|0)>>3];i=b;return}function z9(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8040>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7648>>3]=+h[(a?e+10984|0:e+10976|0)>>3];i=b;return}function A9(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+376>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6512>>3]=+h[d>>3];i=b;return}function B9(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9104>>3]=+h[b+8944>>3]*+h[b+6520>>3];i=i;return}function C9(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+360>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6480>>3]=+h[d>>3];i=b;return}function D9(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6440>>3]=+h[b+344>>3]*1.0e-5;i=i;return}function E9(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+344>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6448>>3]=+h[d>>3];i=b;return}function F9(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6432>>3]=+h[b+336>>3]+-273.15;i=i;return}function G9(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7504>>3]=+h[b+8024>>3]*+h[(c[a+416>>2]|0)+488>>3];i=i;return}function H9(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8032>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7816>>3]=+h[(a?e+12360|0:e+12352|0)>>3];i=b;return}function I9(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8032>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7656>>3]=+h[(a?e+10992|0:e+10984|0)>>3];i=b;return}function J9(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8024>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7664>>3]=+h[(a?e+11e3|0:e+10992|0)>>3];i=b;return}function K9(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8024>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7824>>3]=+h[(a?e+12368|0:e+12360|0)>>3];i=b;return}function L9(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6400>>3]=+h[b+320>>3]+-273.15;i=i;return}function M9(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8016>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7672>>3]=+h[(a?e+11008|0:e+11e3|0)>>3];i=b;return}function N9(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+2736>>3]*+h[j+12376>>3]*+h[e+656>>3];l=+h[j+8016>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+7840|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+7840|0;q=p;h[q>>3]=n;i=d;return}r=l/+qXa(c[b+536>>2]|0,k,56872,56864,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+7840|0;q=p;h[q>>3]=n;i=d;return}function O9(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7512>>3]=+h[b+8016>>3]*+h[(c[a+416>>2]|0)+496>>3];i=i;return}function P9(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8016>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7832>>3]=+h[(a?e+12376|0:e+12368|0)>>3];i=b;return}function Q9(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6408>>3]=+h[b+328>>3]*1.0e-5;i=i;return}function R9(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+328>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6416>>3]=+h[d>>3];i=b;return}function S9(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2368>>3]=+h[b+304>>3]+-273.15;i=i;return}function T9(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2376>>3]=+h[b+312>>3]*1.0e-5;i=i;return}function U9(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+2968>>3]*+h[j+12392>>3]*+h[e+1632>>3];l=+h[j+3528>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+3200|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+3200|0;q=p;h[q>>3]=n;i=d;return}r=l/+qXa(c[b+536>>2]|0,k,56968,56960,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+3200|0;q=p;h[q>>3]=n;i=d;return}function V9(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2720>>3]=+h[b+3528>>3]*+h[(c[a+416>>2]|0)+1472>>3];i=i;return}function W9(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3528>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3040>>3]=+h[(a?e+12400|0:e+12392|0)>>3];i=b;return}function X9(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3528>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2880>>3]=+h[(a?e+11024|0:e+11016|0)>>3];i=b;return}function Y9(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3520>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2888>>3]=+h[(a?e+11032|0:e+11024|0)>>3];i=b;return}function Z9(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+312>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2384>>3]=+h[d>>3];i=b;return}function _9(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4336>>3]=+h[b+4176>>3]*+h[b+2392>>3];i=i;return}function $9(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9128>>3]=+h[b+8968>>3]*+h[b+6424>>3];i=i;return}function aaa(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9120>>3]=+h[b+8960>>3]*+h[b+6456>>3];i=i;return}function baa(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2304>>3]=+h[b+272>>3]+-273.15;i=i;return}function caa(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9112>>3]=+h[b+8952>>3]*+h[b+6488>>3];i=i;return}function daa(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3520>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3048>>3]=+h[(a?e+12408|0:e+12400|0)>>3];i=b;return}function eaa(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2736>>3]=+h[b+3512>>3]*+h[(c[a+416>>2]|0)+1488>>3];i=i;return}function faa(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3512>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2896>>3]=+h[(a?e+11040|0:e+11032|0)>>3];i=b;return}function gaa(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2312>>3]=+h[b+280>>3]*1.0e-5;i=i;return}function haa(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2744>>3]=+h[b+3504>>3]*+h[(c[a+416>>2]|0)+1496>>3];i=i;return}function iaa(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+280>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2320>>3]=+h[d>>3];i=b;return}function jaa(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3512>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3056>>3]=+h[(a?e+12416|0:e+12408|0)>>3];i=b;return}function kaa(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3504>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2904>>3]=+h[(a?e+11048|0:e+11040|0)>>3];i=b;return}function laa(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3504>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3064>>3]=+h[(a?e+12424|0:e+12416|0)>>3];i=b;return}function maa(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2280>>3]=+h[b+264>>3]*1.0e-5;i=i;return}function naa(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2752>>3]=+h[b+3496>>3]*+h[(c[a+416>>2]|0)+1504>>3];i=i;return}function oaa(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3496>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2912>>3]=+h[(a?e+11056|0:e+11048|0)>>3];i=b;return}function paa(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2248>>3]=+h[b+248>>3]*1.0e-5;i=i;return}function qaa(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+248>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2256>>3]=+h[d>>3];i=b;return}function raa(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3496>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3072>>3]=+h[(a?e+12432|0:e+12424|0)>>3];i=b;return}function saa(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+264>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2288>>3]=+h[d>>3];i=b;return}function taa(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4352>>3]=+h[b+4192>>3]*+h[b+2328>>3];i=i;return}function uaa(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4344>>3]=+h[b+4184>>3]*+h[b+2360>>3];i=i;return}function vaa(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4360>>3]=+h[b+4200>>3]*+h[b+2296>>3];i=i;return}function waa(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4368>>3]=+h[b+4208>>3]*+h[b+2264>>3];i=i;return}function xaa(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2760>>3]=+h[b+3488>>3]*+h[(c[a+416>>2]|0)+1512>>3];i=i;return}function yaa(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3488>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2920>>3]=+h[(a?e+11064|0:e+11056|0)>>3];i=b;return}function zaa(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2216>>3]=+h[b+232>>3]*1.0e-5;i=i;return}function Aaa(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+232>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2224>>3]=+h[d>>3];i=b;return}function Baa(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3488>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3080>>3]=+h[(a?e+12440|0:e+12432|0)>>3];i=b;return}function Caa(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4376>>3]=+h[b+4216>>3]*+h[b+2232>>3];i=i;return}function Daa(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3480>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2928>>3]=+h[(a?e+11072|0:e+11064|0)>>3];i=b;return}function Eaa(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4384>>3]=+h[b+4224>>3]*+h[b+2200>>3];i=i;return}function Faa(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2776>>3]=+h[b+3472>>3]*+h[(c[a+416>>2]|0)+1528>>3];i=i;return}function Gaa(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2768>>3]=+h[b+3480>>3]*+h[(c[a+416>>2]|0)+1520>>3];i=i;return}function Haa(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3480>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3088>>3]=+h[(a?e+12448|0:e+12440|0)>>3];i=b;return}function Iaa(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3472>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2936>>3]=+h[(a?e+11080|0:e+11072|0)>>3];i=b;return}function Jaa(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2152>>3]=+h[b+200>>3]*1.0e-5;i=i;return}function Kaa(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+200>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2160>>3]=+h[d>>3];i=b;return}function Laa(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3472>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3096>>3]=+h[(a?e+12456|0:e+12448|0)>>3];i=b;return}function Maa(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4392>>3]=+h[b+4232>>3]*+h[b+2168>>3];i=i;return}function Naa(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3464>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2944>>3]=+h[(a?e+11088|0:e+11080|0)>>3];i=b;return}function Oaa(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2784>>3]=+h[b+3464>>3]*+h[(c[a+416>>2]|0)+1536>>3];i=i;return}function Paa(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3464>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3104>>3]=+h[(a?e+12464|0:e+12456|0)>>3];i=b;return}function Qaa(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4400>>3]=+h[b+4240>>3]*+h[b+2136>>3];i=i;return}function Raa(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3456>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2952>>3]=+h[(a?e+11096|0:e+11088|0)>>3];i=b;return}function Saa(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2800>>3]=+h[b+3448>>3]*+h[(c[a+416>>2]|0)+1552>>3];i=i;return}function Taa(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3448>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3120>>3]=+h[(a?e+12480|0:e+12472|0)>>3];i=b;return}function Uaa(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2792>>3]=+h[b+3456>>3]*+h[(c[a+416>>2]|0)+1544>>3];i=i;return}function Vaa(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3456>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3112>>3]=+h[(a?e+12472|0:e+12464|0)>>3];i=b;return}function Waa(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3448>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2960>>3]=+h[(a?e+11104|0:e+11096|0)>>3];i=b;return}function Xaa(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2056>>3]=+h[b+152>>3]*1.0e-5;i=i;return}function Yaa(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2808>>3]=+h[b+3440>>3]*+h[(c[a+416>>2]|0)+1560>>3];i=i;return}function Zaa(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3440>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2968>>3]=+h[(a?e+11112|0:e+11104|0)>>3];i=b;return}function _aa(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2024>>3]=+h[b+136>>3]*1.0e-5;i=i;return}function $aa(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2816>>3]=+h[b+3432>>3]*+h[(c[a+416>>2]|0)+1568>>3];i=i;return}function aba(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+136>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2032>>3]=+h[d>>3];i=b;return}function bba(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3440>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3128>>3]=+h[(a?e+12488|0:e+12480|0)>>3];i=b;return}function cba(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3432>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3136>>3]=+h[(a?e+12496|0:e+12488|0)>>3];i=b;return}function dba(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3432>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2976>>3]=+h[(a?e+11120|0:e+11112|0)>>3];i=b;return}function eba(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1992>>3]=+h[b+120>>3]*1.0e-5;i=i;return}function fba(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2824>>3]=+h[b+3424>>3]*+h[(c[a+416>>2]|0)+1576>>3];i=i;return}function gba(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3424>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3144>>3]=+h[(a?e+12504|0:e+12496|0)>>3];i=b;return}function hba(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1960>>3]=+h[b+104>>3]*1.0e-5;i=i;return}function iba(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2832>>3]=+h[b+3416>>3]*+h[(c[a+416>>2]|0)+1584>>3];i=i;return}function jba(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3416>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3152>>3]=+h[(a?e+12512|0:e+12504|0)>>3];i=b;return}function kba(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3424>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2984>>3]=+h[(a?e+11128|0:e+11120|0)>>3];i=b;return}function lba(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1928>>3]=+h[b+88>>3]*1.0e-5;i=i;return}function mba(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2840>>3]=+h[b+3408>>3]*+h[(c[a+416>>2]|0)+1592>>3];i=i;return}function nba(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3416>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2992>>3]=+h[(a?e+11136|0:e+11128|0)>>3];i=b;return}function oba(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3408>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3e3>>3]=+h[(a?e+11144|0:e+11136|0)>>3];i=b;return}function pba(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3408>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3160>>3]=+h[(a?e+12520|0:e+12512|0)>>3];i=b;return}function qba(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1888>>3]=+h[b+64>>3]+-273.15;i=i;return}function rba(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1856>>3]=+h[b+48>>3]+-273.15;i=i;return}function sba(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1864>>3]=+h[b+56>>3]*1.0e-5;i=i;return}function tba(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1896>>3]=+h[b+72>>3]*1.0e-5;i=i;return}function uba(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+72>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1904>>3]=+h[d>>3];i=b;return}function vba(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2848>>3]=+h[b+3400>>3]*+h[(c[a+416>>2]|0)+1600>>3];i=i;return}function wba(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3400>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3168>>3]=+h[(a?e+12528|0:e+12520|0)>>3];i=b;return}function xba(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3400>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3008>>3]=+h[(a?e+11152|0:e+11144|0)>>3];i=b;return}function yba(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3392>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3016>>3]=+h[(a?e+11160|0:e+11152|0)>>3];i=b;return}function zba(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+56>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1872>>3]=+h[d>>3];i=b;return}function Aba(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4464>>3]=+h[b+4304>>3]*+h[b+1880>>3];i=i;return}function Bba(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4456>>3]=+h[b+4296>>3]*+h[b+1912>>3];i=i;return}function Cba(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+88>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1936>>3]=+h[d>>3];i=b;return}function Dba(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+104>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1968>>3]=+h[d>>3];i=b;return}function Eba(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+120>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2e3>>3]=+h[d>>3];i=b;return}function Fba(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+152>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2064>>3]=+h[d>>3];i=b;return}function Gba(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+168>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2096>>3]=+h[d>>3];i=b;return}function Hba(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4408>>3]=+h[b+4248>>3]*+h[b+2104>>3];i=i;return}function Iba(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4416>>3]=+h[b+4256>>3]*+h[b+2072>>3];i=i;return}function Jba(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4424>>3]=+h[b+4264>>3]*+h[b+2040>>3];i=i;return}function Kba(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4440>>3]=+h[b+4280>>3]*+h[b+1976>>3];i=i;return}function Lba(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14616>>3]=+h[b+3696>>3]+(+h[b+3704>>3]+(+h[b+3712>>3]+(+h[b+3720>>3]+(+h[b+3728>>3]+(+h[b+3736>>3]+(+h[b+3744>>3]+(+h[b+3752>>3]+(+h[b+3760>>3]+(+h[b+3768>>3]+(+h[b+3776>>3]+(+h[b+3784>>3]+(+h[b+3792>>3]+(+h[b+3800>>3]+(+h[b+3808>>3]+(+h[b+3816>>3]+(+h[b+3824>>3]+(+h[b+3832>>3]+(+h[b+3840>>3]+ +h[b+3848>>3]))))))))))))))))));i=i;return}function Mba(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14624>>3]=+h[b+8336>>3]+(+h[b+8344>>3]+(+h[b+8352>>3]+(+h[b+8360>>3]+(+h[b+8368>>3]+(+h[b+8376>>3]+(+h[b+8384>>3]+(+h[b+8392>>3]+(+h[b+8400>>3]+(+h[b+8408>>3]+(+h[b+8416>>3]+(+h[b+8424>>3]+(+h[b+8432>>3]+(+h[b+8440>>3]+(+h[b+8448>>3]+(+h[b+8456>>3]+(+h[b+8464>>3]+(+h[b+8472>>3]+(+h[b+8480>>3]+ +h[b+8488>>3]))))))))))))))))));i=i;return}function Nba(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4448>>3]=+h[b+4288>>3]*+h[b+1944>>3];i=i;return}function Oba(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9016>>3]=+h[b+8856>>3]*+h[b+6872>>3];i=i;return}function Pba(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9008>>3]=+h[b+8848>>3]*+h[b+6904>>3];i=i;return}function Qba(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+584>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6928>>3]=+h[d>>3];i=b;return}function Rba(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9e3>>3]=+h[b+8840>>3]*+h[b+6936>>3];i=i;return}function Sba(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7376>>3]=+h[b+8152>>3]*+h[(c[a+416>>2]|0)+360>>3];i=i;return}function Tba(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8152>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7696>>3]=+h[(a?e+12240|0:e+12232|0)>>3];i=b;return}function Uba(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7368>>3]=+h[b+8160>>3]*+h[(c[a+416>>2]|0)+352>>3];i=i;return}function Vba(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7360>>3]=+h[b+8168>>3]*+h[(c[a+416>>2]|0)+344>>3];i=i;return}function Wba(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+632>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+7024>>3]=+h[d>>3];i=b;return}function Xba(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;iF(e,c[g>>2]|0,+h[a+632>>3],+h[a+14504>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+632>>3];l=+h[g+14504>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));_E(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+14568>>3]=+h[f>>3];i=b;return}function Yba(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;iF(e,c[g>>2]|0,+h[a+632>>3],+h[a+14504>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+632>>3];l=+h[g+14504>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));gF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+14576>>3]=+h[f>>3];i=b;return}function Zba(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;XE(e,c[g>>2]|0,+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+632>>3],300.0,0);a=c[g>>2]|0;k=+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+632>>3];g=d+0|0;l=e+0|0;e=g+120|0;do{c[g>>2]=c[l>>2];g=g+4|0;l=l+4|0}while((g|0)<(e|0));dF(f,a,k,300.0,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+14496>>3]=+h[f>>3];i=b;return}function _ba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+14504>>3];k=+h[g+14496>>3];l=+h[g+632>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,57056,57048,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+14488>>3]=j-n;i=d;return}function $ba(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+632>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+14480>>3]=+h[d>>3];i=b;return}function aca(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8168>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7680>>3]=+h[(a?e+12224|0:e+12216|0)>>3];i=b;return}function bca(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8976>>3]=+h[b+8816>>3]*+h[b+7032>>3];i=i;return}function cca(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8160>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7688>>3]=+h[(a?e+12232|0:e+12224|0)>>3];i=b;return}function dca(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8984>>3]=+h[b+8824>>3]*+h[b+7e3>>3];i=i;return}function eca(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+600>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6960>>3]=+h[d>>3];i=b;return}function fca(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8992>>3]=+h[b+8832>>3]*+h[b+6968>>3];i=i;return}function gca(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2856>>3]=+h[b+3392>>3]*+h[(c[a+416>>2]|0)+1608>>3];i=i;return}function hca(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3392>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3176>>3]=+h[(a?e+12536|0:e+12528|0)>>3];i=b;return}function ica(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3384>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3024>>3]=+h[(a?e+11168|0:e+11160|0)>>3];i=b;return}function jca(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4472>>3]=+h[b+4312>>3]*+h[b+1848>>3];i=i;return}function kca(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+24>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1808>>3]=+h[d>>3];i=b;return}function lca(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3376>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3032>>3]=+h[(a?e+11176|0:e+11168|0)>>3];i=b;return}function mca(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4480>>3]=+h[b+4320>>3]*+h[b+1816>>3];i=i;return}function nca(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+8>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1776>>3]=+h[d>>3];i=b;return}function oca(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;iF(e,c[g>>2]|0,+h[a+8>>3],+h[a+14544>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+8>>3];l=+h[g+14544>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));_E(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+14552>>3]=+h[f>>3];i=b;return}function pca(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;iF(e,c[g>>2]|0,+h[a+8>>3],+h[a+14544>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+8>>3];l=+h[g+14544>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));gF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+14560>>3]=+h[f>>3];i=b;return}function qca(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;XE(e,c[g>>2]|0,+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+8>>3],360.0,0);a=c[g>>2]|0;k=+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+8>>3];g=d+0|0;l=e+0|0;e=g+120|0;do{c[g>>2]=c[l>>2];g=g+4|0;l=l+4|0}while((g|0)<(e|0));dF(f,a,k,360.0,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+14536>>3]=+h[f>>3];i=b;return}function rca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+14544>>3];k=+h[g+14536>>3];l=+h[g+8>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,57088,57080,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+14528>>3]=j-n;i=d;return}function sca(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+8>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+14520>>3]=+h[d>>3];i=b;return}function tca(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4488>>3]=+h[b+4328>>3]*+h[b+1784>>3];i=i;return}function uca(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3056>>3]=+h[b+2664>>3];i=i;return}function vca(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3088>>3]=+h[b+3056>>3];i=i;return}function wca(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3024>>3]=+h[b+2640>>3];i=i;return}function xca(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3080>>3]=+h[b+3024>>3];i=i;return}function yca(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1304>>3]=+h[b+168>>3];i=i;return}function zca(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2960>>3]=+h[b+3304>>3];i=i;return}function Aca(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+176>>3]=+h[b+160>>3];i=i;return}function Bca(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2720>>3]=+h[b+2560>>3];i=i;return}function Cca(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2712>>3]=+h[b+2552>>3];i=i;return}function Dca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14912>>3]=1.0e5;i=i;return}function Eca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14904>>3]=1.0e5;i=i;return}function Fca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14896>>3]=.5;i=i;return}function Gca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14888>>3]=300.0;i=i;return}function Hca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14880>>3]=360.0;i=i;return}function Ica(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14872>>3]=300.0;i=i;return}function Jca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14864>>3]=280.0;i=i;return}function Kca(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+156>>2]=1;i=i;return}function Lca(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+152>>2]=1;i=i;return}function Mca(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+148>>2]=1;i=i;return}function Nca(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+144>>2]=1;i=i;return}function Oca(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+140>>2]=1;i=i;return}function Pca(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+136>>2]=1;i=i;return}function Qca(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+132>>2]=1;i=i;return}function Rca(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+128>>2]=1;i=i;return}function Sca(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+124>>2]=1;i=i;return}function Tca(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+120>>2]=1;i=i;return}function Uca(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+116>>2]=1;i=i;return}function Vca(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+112>>2]=1;i=i;return}function Wca(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+108>>2]=1;i=i;return}function Xca(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+104>>2]=1;i=i;return}function Yca(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+100>>2]=1;i=i;return}function Zca(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+96>>2]=1;i=i;return}function _ca(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+92>>2]=1;i=i;return}function $ca(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+88>>2]=1;i=i;return}function ada(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+84>>2]=1;i=i;return}function bda(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+80>>2]=1;i=i;return}function cda(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+188>>2]=0;i=i;return}function dda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14456>>3]=0.0;i=i;return}function eda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14448>>3]=0.0;i=i;return}function fda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14440>>3]=0.0;i=i;return}function gda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14432>>3]=0.0;i=i;return}function hda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14424>>3]=0.0;i=i;return}function ida(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14416>>3]=0.0;i=i;return}function jda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14408>>3]=0.0;i=i;return}function kda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14400>>3]=0.0;i=i;return}function lda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14392>>3]=0.0;i=i;return}function mda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14384>>3]=0.0;i=i;return}function nda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14376>>3]=0.0;i=i;return}function oda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14368>>3]=0.0;i=i;return}function pda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14360>>3]=0.0;i=i;return}function qda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14352>>3]=0.0;i=i;return}function rda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14344>>3]=0.0;i=i;return}function sda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14336>>3]=0.0;i=i;return}function tda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14328>>3]=0.0;i=i;return}function uda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14320>>3]=0.0;i=i;return}function vda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14312>>3]=0.0;i=i;return}function wda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14304>>3]=0.0;i=i;return}function xda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13976>>3]=0.0;i=i;return}function yda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13968>>3]=0.0;i=i;return}function zda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13960>>3]=0.0;i=i;return}function Ada(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13952>>3]=0.0;i=i;return}function Bda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13944>>3]=0.0;i=i;return}function Cda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13936>>3]=0.0;i=i;return}function Dda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13928>>3]=0.0;i=i;return}function Eda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13920>>3]=0.0;i=i;return}function Fda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13912>>3]=0.0;i=i;return}function Gda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13904>>3]=0.0;i=i;return}function Hda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13896>>3]=0.0;i=i;return}function Ida(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13888>>3]=0.0;i=i;return}function Jda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13880>>3]=0.0;i=i;return}function Kda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13872>>3]=0.0;i=i;return}function Lda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13864>>3]=0.0;i=i;return}function Mda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13856>>3]=0.0;i=i;return}function Nda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13848>>3]=0.0;i=i;return}function Oda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13840>>3]=0.0;i=i;return}function Pda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13832>>3]=0.0;i=i;return}function Qda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13824>>3]=0.0;i=i;return}function Rda(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+184>>2]=0;i=i;return}function Sda(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+76>>2]=1;i=i;return}function Tda(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+72>>2]=1;i=i;return}function Uda(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+68>>2]=1;i=i;return}function Vda(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+64>>2]=1;i=i;return}function Wda(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+60>>2]=1;i=i;return}function Xda(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+56>>2]=1;i=i;return}function Yda(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+52>>2]=1;i=i;return}function Zda(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+48>>2]=1;i=i;return}function _da(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+44>>2]=1;i=i;return}function $da(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+40>>2]=1;i=i;return}function aea(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+36>>2]=1;i=i;return}function bea(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+32>>2]=1;i=i;return}function cea(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+28>>2]=1;i=i;return}function dea(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+24>>2]=1;i=i;return}function eea(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+20>>2]=1;i=i;return}function fea(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+16>>2]=1;i=i;return}function gea(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+12>>2]=1;i=i;return}function hea(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+8>>2]=1;i=i;return}function iea(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+4>>2]=1;i=i;return}function jea(a){a=a|0;c[c[(c[c[a+4>>2]>>2]|0)+12>>2]>>2]=1;i=i;return}function kea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13816>>3]=0.0;i=i;return}function lea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13808>>3]=0.0;i=i;return}function mea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13800>>3]=0.0;i=i;return}function nea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13792>>3]=0.0;i=i;return}function oea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13784>>3]=0.0;i=i;return}function pea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13776>>3]=0.0;i=i;return}function qea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13768>>3]=0.0;i=i;return}function rea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13760>>3]=0.0;i=i;return}function sea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13752>>3]=0.0;i=i;return}function tea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13744>>3]=0.0;i=i;return}function uea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13736>>3]=0.0;i=i;return}function vea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13728>>3]=0.0;i=i;return}function wea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13720>>3]=0.0;i=i;return}function xea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13712>>3]=0.0;i=i;return}function yea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13704>>3]=0.0;i=i;return}function zea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13696>>3]=0.0;i=i;return}function Aea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13688>>3]=0.0;i=i;return}function Bea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13680>>3]=0.0;i=i;return}function Cea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13672>>3]=0.0;i=i;return}function Dea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13664>>3]=0.0;i=i;return}function Eea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14856>>3]=3.66;i=i;return}function Fea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13336>>3]=0.0;i=i;return}function Gea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13328>>3]=0.0;i=i;return}function Hea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13320>>3]=0.0;i=i;return}function Iea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13312>>3]=0.0;i=i;return}function Jea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13304>>3]=0.0;i=i;return}function Kea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13296>>3]=0.0;i=i;return}function Lea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13288>>3]=0.0;i=i;return}function Mea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13280>>3]=0.0;i=i;return}function Nea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13272>>3]=0.0;i=i;return}function Oea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13264>>3]=0.0;i=i;return}function Pea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13256>>3]=0.0;i=i;return}function Qea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13248>>3]=0.0;i=i;return}function Rea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13240>>3]=0.0;i=i;return}function Sea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13232>>3]=0.0;i=i;return}function Tea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13224>>3]=0.0;i=i;return}function Uea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13216>>3]=0.0;i=i;return}function Vea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13208>>3]=0.0;i=i;return}function Wea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13200>>3]=0.0;i=i;return}function Xea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13192>>3]=0.0;i=i;return}function Yea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13184>>3]=0.0;i=i;return}function Zea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14848>>3]=1.0;i=i;return}function _ea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14840>>3]=6.850000000000023;i=i;return}function $ea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14832>>3]=1.0;i=i;return}function afa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14824>>3]=26.85000000000002;i=i;return}function bfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14816>>3]=86.85000000000002;i=i;return}function cfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14808>>3]=26.85000000000002;i=i;return}function dfa(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=b;kE(d,c[a+536>>2]|0,1.0e5);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14784>>3]=+h[d>>3];i=b;return}function efa(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=b;kE(d,c[a+536>>2]|0,1.0e5);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14760>>3]=+h[d>>3];i=b;return}function ffa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12200>>3]=1.0;i=i;return}function gfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12192>>3]=1.0;i=i;return}function hfa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+180>>2]=1;i=i;return}function ifa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14720>>3]=461.5236365065454;i=i;return}function jfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14712>>3]=.018015268;i=i;return}function kfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12184>>3]=1.0;i=i;return}function lfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12176>>3]=1.0;i=i;return}function mfa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+176>>2]=1;i=i;return}function nfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14704>>3]=461.5236365065454;i=i;return}function ofa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14696>>3]=.018015268;i=i;return}function pfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12168>>3]=1.0;i=i;return}function qfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12160>>3]=1.0;i=i;return}function rfa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+172>>2]=1;i=i;return}function sfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14688>>3]=461.5236365065454;i=i;return}function tfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14680>>3]=.018015268;i=i;return}function ufa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12152>>3]=1.0;i=i;return}function vfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12144>>3]=1.0;i=i;return}function wfa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+168>>2]=1;i=i;return}function xfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14672>>3]=461.5236365065454;i=i;return}function yfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14664>>3]=.018015268;i=i;return}function zfa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+164>>2]=0;i=i;return}function Afa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12136>>3]=1.0;i=i;return}function Bfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12128>>3]=461.5236365065454;i=i;return}function Cfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12120>>3]=.018015268;i=i;return}function Dfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12112>>3]=1.0;i=i;return}function Efa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12104>>3]=461.5236365065454;i=i;return}function Ffa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12096>>3]=.018015268;i=i;return}function Gfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12088>>3]=1.0;i=i;return}function Hfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12080>>3]=461.5236365065454;i=i;return}function Ifa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12072>>3]=.018015268;i=i;return}function Jfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12064>>3]=1.0;i=i;return}function Kfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12056>>3]=461.5236365065454;i=i;return}function Lfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12048>>3]=.018015268;i=i;return}function Mfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12040>>3]=1.0;i=i;return}function Nfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12032>>3]=461.5236365065454;i=i;return}function Ofa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12024>>3]=.018015268;i=i;return}function Pfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12016>>3]=1.0;i=i;return}function Qfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12008>>3]=461.5236365065454;i=i;return}function Rfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12e3>>3]=.018015268;i=i;return}function Sfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11992>>3]=1.0;i=i;return}function Tfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11984>>3]=461.5236365065454;i=i;return}function Ufa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11976>>3]=.018015268;i=i;return}function Vfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11968>>3]=1.0;i=i;return}function Wfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11960>>3]=461.5236365065454;i=i;return}function Xfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11952>>3]=.018015268;i=i;return}function Yfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11944>>3]=1.0;i=i;return}function Zfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11936>>3]=461.5236365065454;i=i;return}function _fa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11928>>3]=.018015268;i=i;return}function $fa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11920>>3]=1.0;i=i;return}function aga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11912>>3]=461.5236365065454;i=i;return}function bga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11904>>3]=.018015268;i=i;return}function cga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11896>>3]=1.0;i=i;return}function dga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11888>>3]=461.5236365065454;i=i;return}function ega(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11880>>3]=.018015268;i=i;return}function fga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11872>>3]=1.0;i=i;return}function gga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11864>>3]=461.5236365065454;i=i;return}function hga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11856>>3]=.018015268;i=i;return}function iga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11848>>3]=1.0;i=i;return}function jga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11840>>3]=461.5236365065454;i=i;return}function kga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11832>>3]=.018015268;i=i;return}function lga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11824>>3]=1.0;i=i;return}function mga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11816>>3]=461.5236365065454;i=i;return}function nga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11808>>3]=.018015268;i=i;return}function oga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11800>>3]=1.0;i=i;return}function pga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11792>>3]=461.5236365065454;i=i;return}function qga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11784>>3]=.018015268;i=i;return}function rga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11776>>3]=1.0;i=i;return}function sga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11768>>3]=461.5236365065454;i=i;return}function tga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11760>>3]=.018015268;i=i;return}function uga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11752>>3]=1.0;i=i;return}function vga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11744>>3]=461.5236365065454;i=i;return}function wga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11736>>3]=.018015268;i=i;return}function xga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11728>>3]=1.0;i=i;return}function yga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11720>>3]=461.5236365065454;i=i;return}function zga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11712>>3]=.018015268;i=i;return}function Aga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11704>>3]=1.0;i=i;return}function Bga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11696>>3]=461.5236365065454;i=i;return}function Cga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11688>>3]=.018015268;i=i;return}function Dga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11680>>3]=1.0;i=i;return}function Ega(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11672>>3]=461.5236365065454;i=i;return}function Fga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11664>>3]=.018015268;i=i;return}function Gga(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+160>>2]=0;i=i;return}function Hga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11656>>3]=1.0;i=i;return}function Iga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11648>>3]=461.5236365065454;i=i;return}function Jga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11640>>3]=.018015268;i=i;return}function Kga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11632>>3]=1.0;i=i;return}function Lga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11624>>3]=461.5236365065454;i=i;return}function Mga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11616>>3]=.018015268;i=i;return}function Nga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11608>>3]=1.0;i=i;return}function Oga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11600>>3]=461.5236365065454;i=i;return}function Pga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11592>>3]=.018015268;i=i;return}function Qga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11584>>3]=1.0;i=i;return}function Rga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11576>>3]=461.5236365065454;i=i;return}function Sga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11568>>3]=.018015268;i=i;return}function Tga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11560>>3]=1.0;i=i;return}function Uga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11552>>3]=461.5236365065454;i=i;return}function Vga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11544>>3]=.018015268;i=i;return}function Wga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11536>>3]=1.0;i=i;return}function Xga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11528>>3]=461.5236365065454;i=i;return}function Yga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11520>>3]=.018015268;i=i;return}function Zga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11512>>3]=1.0;i=i;return}function _ga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11504>>3]=461.5236365065454;i=i;return}function $ga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11496>>3]=.018015268;i=i;return}function aha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11488>>3]=1.0;i=i;return}function bha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11480>>3]=461.5236365065454;i=i;return}function cha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11472>>3]=.018015268;i=i;return}function dha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11464>>3]=1.0;i=i;return}function eha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11456>>3]=461.5236365065454;i=i;return}function fha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11448>>3]=.018015268;i=i;return}function gha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11440>>3]=1.0;i=i;return}function hha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11432>>3]=461.5236365065454;i=i;return}function iha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11424>>3]=.018015268;i=i;return}function jha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11416>>3]=1.0;i=i;return}function kha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11408>>3]=461.5236365065454;i=i;return}function lha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11400>>3]=.018015268;i=i;return}function mha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11392>>3]=1.0;i=i;return}function nha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11384>>3]=461.5236365065454;i=i;return}function oha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11376>>3]=.018015268;i=i;return}function pha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11368>>3]=1.0;i=i;return}function qha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11360>>3]=461.5236365065454;i=i;return}function rha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11352>>3]=.018015268;i=i;return}function sha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11344>>3]=1.0;i=i;return}function tha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11336>>3]=461.5236365065454;i=i;return}function uha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11328>>3]=.018015268;i=i;return}function vha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11320>>3]=1.0;i=i;return}function wha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11312>>3]=461.5236365065454;i=i;return}function xha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11304>>3]=.018015268;i=i;return}function yha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11296>>3]=1.0;i=i;return}function zha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11288>>3]=461.5236365065454;i=i;return}function Aha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11280>>3]=.018015268;i=i;return}function Bha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11272>>3]=1.0;i=i;return}function Cha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11264>>3]=461.5236365065454;i=i;return}function Dha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11256>>3]=.018015268;i=i;return}function Eha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11248>>3]=1.0;i=i;return}function Fha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11240>>3]=461.5236365065454;i=i;return}function Gha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11232>>3]=.018015268;i=i;return}function Hha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11224>>3]=1.0;i=i;return}function Iha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11216>>3]=461.5236365065454;i=i;return}function Jha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11208>>3]=.018015268;i=i;return}function Kha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11200>>3]=1.0;i=i;return}function Lha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11192>>3]=461.5236365065454;i=i;return}function Mha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11184>>3]=.018015268;i=i;return}function Nha(b){b=b|0;var c=0,d=0;c=i;d=b+314|0;a[d]=1;WZ(b);XZ(b);YZ(b);ZZ(b);_Z(b);$Z(b);a_(b);b_(b);c_(b);d_(b);e_(b);f_(b);g_(b);h_(b);i_(b);j_(b);k_(b);l_(b);m_(b);n_(b);o_(b);p_(b);q_(b);r_(b);s_(b);t_(b);u_(b);v_(b);w_(b);x_(b);y_(b);z_(b);A_(b);B_(b);C_(b);D_(b);E_(b);F_(b);G_(b);H_(b);I_(b);J_(b);K_(b);L_(b);M_(b);N_(b);O_(b);P_(b);Q_(b);R_(b);S_(b);T_(b);U_(b);V_(b);W_(b);X_(b);Y_(b);Z_(b);__(b);$_(b);a$(b);b$(b);c$(b);d$(b);e$(b);f$(b);g$(b);h$(b);i$(b);j$(b);k$(b);l$(b);m$(b);n$(b);o$(b);p$(b);q$(b);r$(b);s$(b);t$(b);u$(b);v$(b);w$(b);x$(b);y$(b);z$(b);A$(b);B$(b);C$(b);D$(b);E$(b);F$(b);G$(b);H$(b);I$(b);J$(b);K$(b);L$(b);M$(b);N$(b);O$(b);P$(b);Q$(b);R$(b);S$(b);T$(b);U$(b);V$(b);W$(b);X$(b);Y$(b);Z$(b);_$(b);$$(b);a0(b);b0(b);c0(b);d0(b);e0(b);f0(b);g0(b);h0(b);i0(b);j0(b);k0(b);l0(b);m0(b);n0(b);o0(b);p0(b);q0(b);r0(b);s0(b);t0(b);u0(b);v0(b);w0(b);x0(b);y0(b);z0(b);A0(b);B0(b);C0(b);D0(b);E0(b);F0(b);G0(b);H0(b);I0(b);J0(b);K0(b);L0(b);M0(b);N0(b);O0(b);P0(b);Q0(b);R0(b);S0(b);T0(b);U0(b);V0(b);W0(b);X0(b);Y0(b);Z0(b);_0(b);$0(b);a1(b);b1(b);c1(b);d1(b);e1(b);f1(b);g1(b);h1(b);i1(b);j1(b);k1(b);l1(b);m1(b);n1(b);o1(b);p1(b);q1(b);r1(b);s1(b);t1(b);u1(b);v1(b);w1(b);x1(b);y1(b);z1(b);A1(b);B1(b);C1(b);D1(b);E1(b);F1(b);G1(b);H1(b);I1(b);J1(b);K1(b);L1(b);M1(b);N1(b);O1(b);P1(b);Q1(b);R1(b);S1(b);T1(b);U1(b);V1(b);W1(b);X1(b);Y1(b);Z1(b);_1(b);$1(b);a2(b);b2(b);c2(b);d2(b);e2(b);f2(b);g2(b);h2(b);i2(b);j2(b);k2(b);l2(b);m2(b);n2(b);o2(b);p2(b);q2(b);r2(b);s2(b);t2(b);u2(b);v2(b);w2(b);x2(b);y2(b);z2(b);A2(b);B2(b);C2(b);D2(b);E2(b);F2(b);G2(b);H2(b);I2(b);J2(b);K2(b);L2(b);M2(b);N2(b);O2(b);P2(b);Q2(b);R2(b);S2(b);T2(b);U2(b);V2(b);W2(b);X2(b);Y2(b);Z2(b);_2(b);$2(b);a3(b);b3(b);c3(b);d3(b);e3(b);f3(b);g3(b);h3(b);i3(b);j3(b);k3(b);l3(b);m3(b);n3(b);o3(b);p3(b);q3(b);r3(b);s3(b);t3(b);u3(b);v3(b);w3(b);x3(b);y3(b);z3(b);A3(b);B3(b);C3(b);D3(b);E3(b);F3(b);G3(b);H3(b);I3(b);J3(b);K3(b);L3(b);M3(b);N3(b);O3(b);P3(b);Q3(b);R3(b);S3(b);T3(b);U3(b);V3(b);W3(b);X3(b);Y3(b);Z3(b);_3(b);$3(b);a4(b);b4(b);c4(b);d4(b);e4(b);f4(b);g4(b);h4(b);i4(b);j4(b);k4(b);l4(b);m4(b);n4(b);o4(b);p4(b);q4(b);r4(b);s4(b);t4(b);u4(b);v4(b);w4(b);x4(b);y4(b);z4(b);A4(b);B4(b);C4(b);D4(b);E4(b);F4(b);G4(b);H4(b);I4(b);J4(b);K4(b);L4(b);M4(b);N4(b);O4(b);P4(b);Q4(b);R4(b);S4(b);T4(b);U4(b);V4(b);W4(b);X4(b);Y4(b);Z4(b);_4(b);$4(b);a5(b);b5(b);c5(b);d5(b);e5(b);f5(b);g5(b);h5(b);i5(b);j5(b);k5(b);l5(b);m5(b);n5(b);o5(b);p5(b);q5(b);r5(b);s5(b);t5(b);u5(b);v5(b);w5(b);x5(b);y5(b);z5(b);A5(b);B5(b);C5(b);D5(b);E5(b);F5(b);G5(b);H5(b);I5(b);J5(b);K5(b);L5(b);M5(b);N5(b);O5(b);P5(b);Q5(b);R5(b);S5(b);T5(b);U5(b);V5(b);W5(b);X5(b);Y5(b);Z5(b);_5(b);$5(b);a6(b);b6(b);c6(b);d6(b);e6(b);f6(b);g6(b);h6(b);i6(b);j6(b);k6(b);l6(b);m6(b);n6(b);o6(b);p6(b);q6(b);r6(b);s6(b);t6(b);u6(b);v6(b);w6(b);x6(b);y6(b);z6(b);A6(b);B6(b);C6(b);D6(b);E6(b);F6(b);G6(b);H6(b);I6(b);J6(b);K6(b);L6(b);M6(b);N6(b);O6(b);P6(b);Q6(b);R6(b);S6(b);T6(b);U6(b);V6(b);W6(b);X6(b);Y6(b);Z6(b);_6(b);$6(b);a7(b);b7(b);c7(b);d7(b);e7(b);f7(b);g7(b);h7(b);i7(b);j7(b);k7(b);l7(b);m7(b);n7(b);o7(b);p7(b);q7(b);r7(b);s7(b);t7(b);u7(b);v7(b);w7(b);x7(b);y7(b);z7(b);A7(b);B7(b);C7(b);D7(b);E7(b);F7(b);G7(b);H7(b);I7(b);J7(b);K7(b);L7(b);M7(b);N7(b);O7(b);P7(b);Q7(b);R7(b);S7(b);T7(b);U7(b);V7(b);W7(b);X7(b);Y7(b);Z7(b);_7(b);$7(b);a8(b);b8(b);c8(b);d8(b);e8(b);f8(b);g8(b);h8(b);i8(b);j8(b);k8(b);l8(b);m8(b);n8(b);o8(b);p8(b);q8(b);r8(b);s8(b);t8(b);u8(b);v8(b);w8(b);x8(b);y8(b);z8(b);A8(b);B8(b);C8(b);D8(b);E8(b);F8(b);G8(b);H8(b);I8(b);J8(b);K8(b);L8(b);M8(b);N8(b);O8(b);P8(b);Q8(b);R8(b);S8(b);T8(b);U8(b);V8(b);W8(b);X8(b);Y8(b);Z8(b);_8(b);$8(b);a9(b);b9(b);c9(b);d9(b);e9(b);f9(b);g9(b);h9(b);i9(b);j9(b);k9(b);l9(b);m9(b);n9(b);o9(b);p9(b);q9(b);r9(b);s9(b);t9(b);u9(b);v9(b);w9(b);x9(b);y9(b);z9(b);A9(b);B9(b);C9(b);D9(b);E9(b);F9(b);G9(b);H9(b);I9(b);J9(b);K9(b);L9(b);M9(b);N9(b);O9(b);P9(b);Q9(b);R9(b);S9(b);T9(b);U9(b);V9(b);W9(b);X9(b);Y9(b);Z9(b);_9(b);$9(b);aaa(b);baa(b);caa(b);daa(b);eaa(b);faa(b);gaa(b);haa(b);iaa(b);jaa(b);kaa(b);laa(b);maa(b);naa(b);oaa(b);paa(b);qaa(b);raa(b);saa(b);taa(b);uaa(b);vaa(b);waa(b);xaa(b);yaa(b);zaa(b);Aaa(b);Baa(b);Caa(b);Daa(b);Eaa(b);Faa(b);Gaa(b);Haa(b);Iaa(b);Jaa(b);Kaa(b);Laa(b);Maa(b);Naa(b);Oaa(b);Paa(b);Qaa(b);Raa(b);Saa(b);Taa(b);Uaa(b);Vaa(b);Waa(b);Xaa(b);Yaa(b);Zaa(b);_aa(b);$aa(b);aba(b);bba(b);cba(b);dba(b);eba(b);fba(b);gba(b);hba(b);iba(b);jba(b);kba(b);lba(b);mba(b);nba(b);oba(b);pba(b);qba(b);rba(b);sba(b);tba(b);uba(b);vba(b);wba(b);xba(b);yba(b);zba(b);Aba(b);Bba(b);Cba(b);Dba(b);Eba(b);Fba(b);Gba(b);Hba(b);Iba(b);Jba(b);Kba(b);Lba(b);Mba(b);Nba(b);Oba(b);Pba(b);Qba(b);Rba(b);Sba(b);Tba(b);Uba(b);Vba(b);Wba(b);Xba(b);Yba(b);Zba(b);_ba(b);$ba(b);aca(b);bca(b);cca(b);dca(b);eca(b);fca(b);gca(b);hca(b);ica(b);jca(b);kca(b);lca(b);mca(b);nca(b);oca(b);pca(b);qca(b);rca(b);sca(b);tca(b);uca(b);vca(b);wca(b);xca(b);yca(b);zca(b);Aca(b);Bca(b);Cca(b);Dca(b);Eca(b);Fca(b);Gca(b);Hca(b);Ica(b);Jca(b);Kca(b);Lca(b);Mca(b);Nca(b);Oca(b);Pca(b);Qca(b);Rca(b);Sca(b);Tca(b);Uca(b);Vca(b);Wca(b);Xca(b);Yca(b);Zca(b);_ca(b);$ca(b);ada(b);bda(b);cda(b);dda(b);eda(b);fda(b);gda(b);hda(b);ida(b);jda(b);kda(b);lda(b);mda(b);nda(b);oda(b);pda(b);qda(b);rda(b);sda(b);tda(b);uda(b);vda(b);wda(b);xda(b);yda(b);zda(b);Ada(b);Bda(b);Cda(b);Dda(b);Eda(b);Fda(b);Gda(b);Hda(b);Ida(b);Jda(b);Kda(b);Lda(b);Mda(b);Nda(b);Oda(b);Pda(b);Qda(b);Rda(b);Sda(b);Tda(b);Uda(b);Vda(b);Wda(b);Xda(b);Yda(b);Zda(b);_da(b);$da(b);aea(b);bea(b);cea(b);dea(b);eea(b);fea(b);gea(b);hea(b);iea(b);jea(b);kea(b);lea(b);mea(b);nea(b);oea(b);pea(b);qea(b);rea(b);sea(b);tea(b);uea(b);vea(b);wea(b);xea(b);yea(b);zea(b);Aea(b);Bea(b);Cea(b);Dea(b);Eea(b);Fea(b);Gea(b);Hea(b);Iea(b);Jea(b);Kea(b);Lea(b);Mea(b);Nea(b);Oea(b);Pea(b);Qea(b);Rea(b);Sea(b);Tea(b);Uea(b);Vea(b);Wea(b);Xea(b);Yea(b);Zea(b);_ea(b);$ea(b);afa(b);bfa(b);cfa(b);dfa(b);efa(b);ffa(b);gfa(b);hfa(b);ifa(b);jfa(b);kfa(b);lfa(b);mfa(b);nfa(b);ofa(b);pfa(b);qfa(b);rfa(b);sfa(b);tfa(b);ufa(b);vfa(b);wfa(b);xfa(b);yfa(b);zfa(b);Afa(b);Bfa(b);Cfa(b);Dfa(b);Efa(b);Ffa(b);Gfa(b);Hfa(b);Ifa(b);Jfa(b);Kfa(b);Lfa(b);Mfa(b);Nfa(b);Ofa(b);Pfa(b);Qfa(b);Rfa(b);Sfa(b);Tfa(b);Ufa(b);Vfa(b);Wfa(b);Xfa(b);Yfa(b);Zfa(b);_fa(b);$fa(b);aga(b);bga(b);cga(b);dga(b);ega(b);fga(b);gga(b);hga(b);iga(b);jga(b);kga(b);lga(b);mga(b);nga(b);oga(b);pga(b);qga(b);rga(b);sga(b);tga(b);uga(b);vga(b);wga(b);xga(b);yga(b);zga(b);Aga(b);Bga(b);Cga(b);Dga(b);Ega(b);Fga(b);Gga(b);Hga(b);Iga(b);Jga(b);Kga(b);Lga(b);Mga(b);Nga(b);Oga(b);Pga(b);Qga(b);Rga(b);Sga(b);Tga(b);Uga(b);Vga(b);Wga(b);Xga(b);Yga(b);Zga(b);_ga(b);$ga(b);aha(b);bha(b);cha(b);dha(b);eha(b);fha(b);gha(b);hha(b);iha(b);jha(b);kha(b);lha(b);mha(b);nha(b);oha(b);pha(b);qha(b);rha(b);sha(b);tha(b);uha(b);vha(b);wha(b);xha(b);yha(b);zha(b);Aha(b);Bha(b);Cha(b);Dha(b);Eha(b);Fha(b);Gha(b);Hha(b);Iha(b);Jha(b);Kha(b);Lha(b);Mha(b);a[d]=0;i=c;return 0}function Oha(a){a=a|0;i=i;return}function Pha(a){a=a|0;i=i;return 0}function Qha(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2552>>3]=+h[b+3080>>3]*.05+ +h[b+3088>>3]*-.05;i=i;return}function Rha(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2544>>3]=+h[b+3080>>3]*.05+ +h[b+3088>>3]*-.05;i=i;return}function Sha(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2536>>3]=+h[b+3080>>3]*.05+ +h[b+3088>>3]*-.05;i=i;return}function Tha(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2528>>3]=+h[b+3080>>3]*.05+ +h[b+3088>>3]*-.05;i=i;return}function Uha(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2520>>3]=+h[b+3080>>3]*.05+ +h[b+3088>>3]*-.05;i=i;return}function Vha(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2512>>3]=+h[b+3080>>3]*.05+ +h[b+3088>>3]*-.05;i=i;return}function Wha(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2504>>3]=+h[b+3080>>3]*.05+ +h[b+3088>>3]*-.05;i=i;return}function Xha(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2496>>3]=+h[b+3080>>3]*.05+ +h[b+3088>>3]*-.05;i=i;return}function Yha(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2488>>3]=+h[b+3080>>3]*.05+ +h[b+3088>>3]*-.05;i=i;return}function Zha(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2480>>3]=+h[b+3080>>3]*.05+ +h[b+3088>>3]*-.05;i=i;return}function _ha(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2472>>3]=+h[b+3080>>3]*.05+ +h[b+3088>>3]*-.05;i=i;return}function $ha(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2464>>3]=+h[b+3080>>3]*.05+ +h[b+3088>>3]*-.05;i=i;return}function aia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2456>>3]=+h[b+3080>>3]*.05+ +h[b+3088>>3]*-.05;i=i;return}function bia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2448>>3]=+h[b+3080>>3]*.05+ +h[b+3088>>3]*-.05;i=i;return}function cia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2440>>3]=+h[b+3080>>3]*.05+ +h[b+3088>>3]*-.05;i=i;return}function dia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2432>>3]=+h[b+3080>>3]*.05+ +h[b+3088>>3]*-.05;i=i;return}function eia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2424>>3]=+h[b+3080>>3]*.05+ +h[b+3088>>3]*-.05;i=i;return}function fia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2416>>3]=+h[b+3080>>3]*.05+ +h[b+3088>>3]*-.05;i=i;return}function gia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2408>>3]=+h[b+3080>>3]*.05+ +h[b+3088>>3]*-.05;i=i;return}function hia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2400>>3]=+h[b+3080>>3]*.05+ +h[b+3088>>3]*-.05;i=i;return}function iia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4792>>3]=+h[(c[a+416>>2]|0)+2952>>3];i=i;return}function jia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4784>>3]=+h[(c[a+416>>2]|0)+2952>>3];i=i;return}function kia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4776>>3]=+h[(c[a+416>>2]|0)+2952>>3];i=i;return}function lia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4768>>3]=+h[(c[a+416>>2]|0)+2952>>3];i=i;return}function mia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4760>>3]=+h[(c[a+416>>2]|0)+2952>>3];i=i;return}function nia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4752>>3]=+h[(c[a+416>>2]|0)+2952>>3];i=i;return}function oia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4744>>3]=+h[(c[a+416>>2]|0)+2952>>3];i=i;return}function pia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4736>>3]=+h[(c[a+416>>2]|0)+2952>>3];i=i;return}function qia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4728>>3]=+h[(c[a+416>>2]|0)+2952>>3];i=i;return}function ria(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4720>>3]=+h[(c[a+416>>2]|0)+2952>>3];i=i;return}function sia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4712>>3]=+h[(c[a+416>>2]|0)+2952>>3];i=i;return}function tia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4704>>3]=+h[(c[a+416>>2]|0)+2952>>3];i=i;return}function uia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4696>>3]=+h[(c[a+416>>2]|0)+2952>>3];i=i;return}function via(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4688>>3]=+h[(c[a+416>>2]|0)+2952>>3];i=i;return}function wia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4680>>3]=+h[(c[a+416>>2]|0)+2952>>3];i=i;return}function xia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4672>>3]=+h[(c[a+416>>2]|0)+2952>>3];i=i;return}function yia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4664>>3]=+h[(c[a+416>>2]|0)+2952>>3];i=i;return}function zia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4656>>3]=+h[(c[a+416>>2]|0)+2952>>3];i=i;return}function Aia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4648>>3]=+h[(c[a+416>>2]|0)+2952>>3];i=i;return}function Bia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4640>>3]=+h[(c[a+416>>2]|0)+2952>>3];i=i;return}function Cia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7192>>3]=+h[b+2848>>3]*.05+ +h[b+2856>>3]*-.05;i=i;return}function Dia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7184>>3]=+h[b+2848>>3]*.05+ +h[b+2856>>3]*-.05;i=i;return}function Eia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7176>>3]=+h[b+2848>>3]*.05+ +h[b+2856>>3]*-.05;i=i;return}function Fia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7168>>3]=+h[b+2848>>3]*.05+ +h[b+2856>>3]*-.05;i=i;return}function Gia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7160>>3]=+h[b+2848>>3]*.05+ +h[b+2856>>3]*-.05;i=i;return}function Hia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7152>>3]=+h[b+2848>>3]*.05+ +h[b+2856>>3]*-.05;i=i;return}function Iia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7144>>3]=+h[b+2848>>3]*.05+ +h[b+2856>>3]*-.05;i=i;return}function Jia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7136>>3]=+h[b+2848>>3]*.05+ +h[b+2856>>3]*-.05;i=i;return}function Kia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7128>>3]=+h[b+2848>>3]*.05+ +h[b+2856>>3]*-.05;i=i;return}function Lia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7120>>3]=+h[b+2848>>3]*.05+ +h[b+2856>>3]*-.05;i=i;return}function Mia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7112>>3]=+h[b+2848>>3]*.05+ +h[b+2856>>3]*-.05;i=i;return}function Nia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7104>>3]=+h[b+2848>>3]*.05+ +h[b+2856>>3]*-.05;i=i;return}function Oia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7096>>3]=+h[b+2848>>3]*.05+ +h[b+2856>>3]*-.05;i=i;return}function Pia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7088>>3]=+h[b+2848>>3]*.05+ +h[b+2856>>3]*-.05;i=i;return}function Qia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7080>>3]=+h[b+2848>>3]*.05+ +h[b+2856>>3]*-.05;i=i;return}function Ria(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7072>>3]=+h[b+2848>>3]*.05+ +h[b+2856>>3]*-.05;i=i;return}function Sia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7064>>3]=+h[b+2848>>3]*.05+ +h[b+2856>>3]*-.05;i=i;return}function Tia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7056>>3]=+h[b+2848>>3]*.05+ +h[b+2856>>3]*-.05;i=i;return}function Uia(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7048>>3]=+h[b+2848>>3]*.05+ +h[b+2856>>3]*-.05;i=i;return}function Via(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7040>>3]=+h[b+2848>>3]*.05+ +h[b+2856>>3]*-.05;i=i;return}function Wia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+792>>3]=+h[(c[a+416>>2]|0)+2712>>3];i=i;return}function Xia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+784>>3]=+h[(c[a+416>>2]|0)+2712>>3];i=i;return}function Yia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+776>>3]=+h[(c[a+416>>2]|0)+2712>>3];i=i;return}function Zia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+768>>3]=+h[(c[a+416>>2]|0)+2712>>3];i=i;return}function _ia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+760>>3]=+h[(c[a+416>>2]|0)+2712>>3];i=i;return}function $ia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+752>>3]=+h[(c[a+416>>2]|0)+2712>>3];i=i;return}function aja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+744>>3]=+h[(c[a+416>>2]|0)+2712>>3];i=i;return}function bja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+736>>3]=+h[(c[a+416>>2]|0)+2712>>3];i=i;return}function cja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+728>>3]=+h[(c[a+416>>2]|0)+2712>>3];i=i;return}function dja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+720>>3]=+h[(c[a+416>>2]|0)+2712>>3];i=i;return}function eja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+712>>3]=+h[(c[a+416>>2]|0)+2712>>3];i=i;return}function fja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+704>>3]=+h[(c[a+416>>2]|0)+2712>>3];i=i;return}function gja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+696>>3]=+h[(c[a+416>>2]|0)+2712>>3];i=i;return}function hja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+688>>3]=+h[(c[a+416>>2]|0)+2712>>3];i=i;return}function ija(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+680>>3]=+h[(c[a+416>>2]|0)+2712>>3];i=i;return}function jja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+672>>3]=+h[(c[a+416>>2]|0)+2712>>3];i=i;return}function kja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+664>>3]=+h[(c[a+416>>2]|0)+2712>>3];i=i;return}function lja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+656>>3]=+h[(c[a+416>>2]|0)+2712>>3];i=i;return}function mja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+648>>3]=+h[(c[a+416>>2]|0)+2712>>3];i=i;return}function nja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+640>>3]=+h[(c[a+416>>2]|0)+2712>>3];i=i;return}function oja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9432>>3]=+h[b+2712>>3]+ +h[b+2720>>3]*-.5;i=i;return}function pja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9424>>3]=+h[b+2712>>3]+ +h[b+2720>>3]*-.5;i=i;return}function qja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9416>>3]=+h[b+2712>>3]+ +h[b+2720>>3]*-.5;i=i;return}function rja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9408>>3]=+h[b+2712>>3]+ +h[b+2720>>3]*-.5;i=i;return}function sja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9400>>3]=+h[b+2712>>3]+ +h[b+2720>>3]*-.5;i=i;return}function tja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9392>>3]=+h[b+2712>>3]+ +h[b+2720>>3]*-.5;i=i;return}function uja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9384>>3]=+h[b+2712>>3]+ +h[b+2720>>3]*-.5;i=i;return}function vja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9376>>3]=+h[b+2712>>3]+ +h[b+2720>>3]*-.5;i=i;return}function wja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9368>>3]=+h[b+2712>>3]+ +h[b+2720>>3]*-.5;i=i;return}function xja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9360>>3]=+h[b+2712>>3]+ +h[b+2720>>3]*-.5;i=i;return}function yja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9352>>3]=+h[b+2712>>3]+ +h[b+2720>>3]*-.5;i=i;return}function zja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9344>>3]=+h[b+2712>>3]+ +h[b+2720>>3]*-.5;i=i;return}function Aja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9336>>3]=+h[b+2712>>3]+ +h[b+2720>>3]*-.5;i=i;return}function Bja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9328>>3]=+h[b+2712>>3]+ +h[b+2720>>3]*-.5;i=i;return}function Cja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9320>>3]=+h[b+2712>>3]+ +h[b+2720>>3]*-.5;i=i;return}function Dja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9312>>3]=+h[b+2712>>3]+ +h[b+2720>>3]*-.5;i=i;return}function Eja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9304>>3]=+h[b+2712>>3]+ +h[b+2720>>3]*-.5;i=i;return}function Fja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9296>>3]=+h[b+2712>>3]+ +h[b+2720>>3]*-.5;i=i;return}function Gja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9288>>3]=+h[b+2712>>3]+ +h[b+2720>>3]*-.5;i=i;return}function Hja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9280>>3]=+h[b+2712>>3]+ +h[b+2720>>3]*-.5;i=i;return}function Ija(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9592>>3]=+h[b+2712>>3]+ +h[b+2720>>3]*.5;i=i;return}function Jja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9584>>3]=+h[b+2712>>3]+ +h[b+2720>>3]*.5;i=i;return}function Kja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9576>>3]=+h[b+2712>>3]+ +h[b+2720>>3]*.5;i=i;return}function Lja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9568>>3]=+h[b+2712>>3]+ +h[b+2720>>3]*.5;i=i;return}function Mja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9560>>3]=+h[b+2712>>3]+ +h[b+2720>>3]*.5;i=i;return}function Nja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9552>>3]=+h[b+2712>>3]+ +h[b+2720>>3]*.5;i=i;return}function Oja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9544>>3]=+h[b+2712>>3]+ +h[b+2720>>3]*.5;i=i;return}function Pja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9536>>3]=+h[b+2712>>3]+ +h[b+2720>>3]*.5;i=i;return}function Qja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9528>>3]=+h[b+2712>>3]+ +h[b+2720>>3]*.5;i=i;return}function Rja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9520>>3]=+h[b+2712>>3]+ +h[b+2720>>3]*.5;i=i;return}function Sja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9512>>3]=+h[b+2712>>3]+ +h[b+2720>>3]*.5;i=i;return}function Tja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9504>>3]=+h[b+2712>>3]+ +h[b+2720>>3]*.5;i=i;return}function Uja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9496>>3]=+h[b+2712>>3]+ +h[b+2720>>3]*.5;i=i;return}function Vja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9488>>3]=+h[b+2712>>3]+ +h[b+2720>>3]*.5;i=i;return}function Wja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9480>>3]=+h[b+2712>>3]+ +h[b+2720>>3]*.5;i=i;return}function Xja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9472>>3]=+h[b+2712>>3]+ +h[b+2720>>3]*.5;i=i;return}function Yja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9464>>3]=+h[b+2712>>3]+ +h[b+2720>>3]*.5;i=i;return}function Zja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9456>>3]=+h[b+2712>>3]+ +h[b+2720>>3]*.5;i=i;return}function _ja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9448>>3]=+h[b+2712>>3]+ +h[b+2720>>3]*.5;i=i;return}function $ja(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9440>>3]=+h[b+2712>>3]+ +h[b+2720>>3]*.5;i=i;return}



function FZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0.0;e=i;f=c[c[b+4>>2]>>2]|0;g=c[f+8>>2]|0;j=c[b+416>>2]|0;k=d+36|0;d=c[k>>2]|0;h[d>>3]=-(+h[g+4664>>3]*+h[g+13528>>3]*+h[g+576>>3]*+h[j+2944>>3]);l=+h[j+2704>>3];m=+h[g+664>>3];n=+h[j+2672>>3];o=+h[j+2680>>3];if(n!=0.0){p=d;q=o/n;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}if(o==0.0){p=d;q=o;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}x=o/+qXa(c[b+536>>2]|0,n,50128,50720,+h[f>>3],(a[b+319|0]|0)!=0|0);p=c[k>>2]|0;q=x;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}function GZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0;e=i;f=d+8|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=b+416|0;ze[c[f>>2]&3](0,0,-(+h[j+4656>>3]*+h[j+13520>>3]*+h[(c[k>>2]|0)+2944>>3]),0,d);ze[c[f>>2]&3](0,1,1.0,1,d);j=c[f>>2]|0;l=c[k>>2]|0;m=+h[l+2704>>3];n=+h[l+2672>>3];o=+h[l+2680>>3];do{if(n!=0.0){p=o/n}else{if(o==0.0){p=o;break}p=o/+qXa(c[b+536>>2]|0,n,50128,50728,+h[c[c[g>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);ze[j&3](1,0,m*p*-.05,2,d);ze[c[f>>2]&3](1,1,-1.0,3,d);i=e;return}function HZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0.0;e=i;f=c[c[b+4>>2]>>2]|0;g=c[f+8>>2]|0;j=c[b+416>>2]|0;k=d+36|0;d=c[k>>2]|0;h[d>>3]=-(+h[g+4656>>3]*+h[g+13520>>3]*+h[g+592>>3]*+h[j+2944>>3]);l=+h[j+2704>>3];m=+h[g+656>>3];n=+h[j+2672>>3];o=+h[j+2680>>3];if(n!=0.0){p=d;q=o/n;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}if(o==0.0){p=d;q=o;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}x=o/+qXa(c[b+536>>2]|0,n,50128,50736,+h[f>>3],(a[b+319|0]|0)!=0|0);p=c[k>>2]|0;q=x;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}function IZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0;e=i;f=d+8|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=b+416|0;ze[c[f>>2]&3](0,0,-(+h[j+4648>>3]*+h[j+13512>>3]*+h[(c[k>>2]|0)+2944>>3]),0,d);ze[c[f>>2]&3](0,1,1.0,1,d);j=c[f>>2]|0;l=c[k>>2]|0;m=+h[l+2704>>3];n=+h[l+2672>>3];o=+h[l+2680>>3];do{if(n!=0.0){p=o/n}else{if(o==0.0){p=o;break}p=o/+qXa(c[b+536>>2]|0,n,50128,50744,+h[c[c[g>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);ze[j&3](1,0,m*p*-.05,2,d);ze[c[f>>2]&3](1,1,-1.0,3,d);i=e;return}function JZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0.0;e=i;f=c[c[b+4>>2]>>2]|0;g=c[f+8>>2]|0;j=c[b+416>>2]|0;k=d+36|0;d=c[k>>2]|0;h[d>>3]=-(+h[g+4648>>3]*+h[g+13512>>3]*+h[g+608>>3]*+h[j+2944>>3]);l=+h[j+2704>>3];m=+h[g+648>>3];n=+h[j+2672>>3];o=+h[j+2680>>3];if(n!=0.0){p=d;q=o/n;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}if(o==0.0){p=d;q=o;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}x=o/+qXa(c[b+536>>2]|0,n,50128,50752,+h[f>>3],(a[b+319|0]|0)!=0|0);p=c[k>>2]|0;q=x;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}function KZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0;e=i;f=d+8|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=b+416|0;ze[c[f>>2]&3](0,0,-(+h[j+4640>>3]*+h[j+13504>>3]*+h[(c[k>>2]|0)+2944>>3]),0,d);ze[c[f>>2]&3](0,1,1.0,1,d);j=c[f>>2]|0;l=c[k>>2]|0;m=+h[l+2704>>3];n=+h[l+2672>>3];o=+h[l+2680>>3];do{if(n!=0.0){p=o/n}else{if(o==0.0){p=o;break}p=o/+qXa(c[b+536>>2]|0,n,50128,50760,+h[c[c[g>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);ze[j&3](1,0,m*p*-.05,2,d);ze[c[f>>2]&3](1,1,-1.0,3,d);i=e;return}function LZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0.0;e=i;f=c[c[b+4>>2]>>2]|0;g=c[f+8>>2]|0;j=c[b+416>>2]|0;k=d+36|0;d=c[k>>2]|0;h[d>>3]=-(+h[g+4640>>3]*+h[g+13504>>3]*+h[g+624>>3]*+h[j+2944>>3]);l=+h[j+2704>>3];m=+h[g+640>>3];n=+h[j+2672>>3];o=+h[j+2680>>3];if(n!=0.0){p=d;q=o/n;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}if(o==0.0){p=d;q=o;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}x=o/+qXa(c[b+536>>2]|0,n,50128,50768,+h[f>>3],(a[b+319|0]|0)!=0|0);p=c[k>>2]|0;q=x;r=m*q;s=l*r;t=s*-.05;u=p;v=u+8|0;w=v;h[w>>3]=t;i=e;return}function MZ(a){a=a|0;c[a+20>>2]=2322;c[a+16>>2]=2;c[a+12>>2]=4;c[a>>2]=104;c[a+4>>2]=105;c[a+84>>2]=2323;c[a+80>>2]=2;c[a+76>>2]=4;c[a+64>>2]=106;c[a+68>>2]=107;c[a+148>>2]=2324;c[a+144>>2]=2;c[a+140>>2]=4;c[a+128>>2]=108;c[a+132>>2]=109;c[a+212>>2]=2325;c[a+208>>2]=2;c[a+204>>2]=4;c[a+192>>2]=110;c[a+196>>2]=111;c[a+276>>2]=2326;c[a+272>>2]=2;c[a+268>>2]=4;c[a+256>>2]=112;c[a+260>>2]=113;c[a+340>>2]=2327;c[a+336>>2]=2;c[a+332>>2]=4;c[a+320>>2]=114;c[a+324>>2]=115;c[a+404>>2]=2328;c[a+400>>2]=2;c[a+396>>2]=4;c[a+384>>2]=116;c[a+388>>2]=117;c[a+468>>2]=2329;c[a+464>>2]=2;c[a+460>>2]=4;c[a+448>>2]=118;c[a+452>>2]=119;c[a+532>>2]=2330;c[a+528>>2]=2;c[a+524>>2]=4;c[a+512>>2]=120;c[a+516>>2]=121;c[a+596>>2]=2331;c[a+592>>2]=2;c[a+588>>2]=4;c[a+576>>2]=122;c[a+580>>2]=123;c[a+660>>2]=2332;c[a+656>>2]=2;c[a+652>>2]=4;c[a+640>>2]=124;c[a+644>>2]=125;c[a+724>>2]=2333;c[a+720>>2]=2;c[a+716>>2]=4;c[a+704>>2]=126;c[a+708>>2]=127;c[a+788>>2]=2334;c[a+784>>2]=2;c[a+780>>2]=4;c[a+768>>2]=128;c[a+772>>2]=129;c[a+852>>2]=2335;c[a+848>>2]=2;c[a+844>>2]=4;c[a+832>>2]=130;c[a+836>>2]=131;c[a+916>>2]=2336;c[a+912>>2]=2;c[a+908>>2]=4;c[a+896>>2]=132;c[a+900>>2]=133;c[a+980>>2]=2337;c[a+976>>2]=2;c[a+972>>2]=4;c[a+960>>2]=134;c[a+964>>2]=135;c[a+1044>>2]=2338;c[a+1040>>2]=2;c[a+1036>>2]=4;c[a+1024>>2]=136;c[a+1028>>2]=137;c[a+1108>>2]=2339;c[a+1104>>2]=2;c[a+1100>>2]=4;c[a+1088>>2]=138;c[a+1092>>2]=139;c[a+1172>>2]=2340;c[a+1168>>2]=2;c[a+1164>>2]=4;c[a+1152>>2]=140;c[a+1156>>2]=141;c[a+1236>>2]=2341;c[a+1232>>2]=2;c[a+1228>>2]=4;c[a+1216>>2]=142;c[a+1220>>2]=143;c[a+1300>>2]=2949;c[a+1296>>2]=2;c[a+1292>>2]=4;c[a+1280>>2]=144;c[a+1284>>2]=145;c[a+1364>>2]=2984;c[a+1360>>2]=2;c[a+1356>>2]=4;c[a+1344>>2]=146;c[a+1348>>2]=147;c[a+1428>>2]=3019;c[a+1424>>2]=2;c[a+1420>>2]=4;c[a+1408>>2]=148;c[a+1412>>2]=149;c[a+1492>>2]=3054;c[a+1488>>2]=2;c[a+1484>>2]=4;c[a+1472>>2]=150;c[a+1476>>2]=151;c[a+1556>>2]=3089;c[a+1552>>2]=2;c[a+1548>>2]=4;c[a+1536>>2]=152;c[a+1540>>2]=153;c[a+1620>>2]=3124;c[a+1616>>2]=2;c[a+1612>>2]=4;c[a+1600>>2]=154;c[a+1604>>2]=155;c[a+1684>>2]=3159;c[a+1680>>2]=2;c[a+1676>>2]=4;c[a+1664>>2]=156;c[a+1668>>2]=157;c[a+1748>>2]=3194;c[a+1744>>2]=2;c[a+1740>>2]=4;c[a+1728>>2]=158;c[a+1732>>2]=159;c[a+1812>>2]=3229;c[a+1808>>2]=2;c[a+1804>>2]=4;c[a+1792>>2]=160;c[a+1796>>2]=161;c[a+1876>>2]=3264;c[a+1872>>2]=2;c[a+1868>>2]=4;c[a+1856>>2]=162;c[a+1860>>2]=163;c[a+1940>>2]=3299;c[a+1936>>2]=2;c[a+1932>>2]=4;c[a+1920>>2]=164;c[a+1924>>2]=165;c[a+2004>>2]=3334;c[a+2e3>>2]=2;c[a+1996>>2]=4;c[a+1984>>2]=166;c[a+1988>>2]=167;c[a+2068>>2]=3369;c[a+2064>>2]=2;c[a+2060>>2]=4;c[a+2048>>2]=168;c[a+2052>>2]=169;c[a+2132>>2]=3404;c[a+2128>>2]=2;c[a+2124>>2]=4;c[a+2112>>2]=170;c[a+2116>>2]=171;c[a+2196>>2]=3439;c[a+2192>>2]=2;c[a+2188>>2]=4;c[a+2176>>2]=172;c[a+2180>>2]=173;c[a+2260>>2]=3474;c[a+2256>>2]=2;c[a+2252>>2]=4;c[a+2240>>2]=174;c[a+2244>>2]=175;c[a+2324>>2]=3509;c[a+2320>>2]=2;c[a+2316>>2]=4;c[a+2304>>2]=176;c[a+2308>>2]=177;c[a+2388>>2]=3544;c[a+2384>>2]=2;c[a+2380>>2]=4;c[a+2368>>2]=178;c[a+2372>>2]=179;c[a+2452>>2]=3579;c[a+2448>>2]=2;c[a+2444>>2]=4;c[a+2432>>2]=180;c[a+2436>>2]=181;c[a+2516>>2]=3603;c[a+2512>>2]=2;c[a+2508>>2]=4;c[a+2496>>2]=182;c[a+2500>>2]=183;i=i;return}function NZ(a,b){a=a|0;b=b|0;i=i;return}function OZ(a){a=a|0;i=i;return}function PZ(a,b){a=a|0;b=b|0;c[b>>2]=c[50856+(a<<2)>>2];i=i;return c[50864+(a<<2)>>2]|0}function QZ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0;e=i;f=b+4|0;g=b+416|0;j=b+360|0;b=(A_a(+h[c[c[f>>2]>>2]>>3],+h[(c[g>>2]|0)+3288>>3],a[c[j>>2]|0]|0)|0)<<24>>24!=0;h[d>>3]=b?1.0:-1.0;b=c[g>>2]|0;g=(A_a(+h[c[c[f>>2]>>2]>>3],+h[b+3288>>3]+ +h[b+3272>>3],a[(c[j>>2]|0)+1|0]|0)|0)<<24>>24!=0;h[d+8>>3]=g?1.0:-1.0;i=e;return 0}function RZ(a){a=a|0;i=i;return c[50864+(a<<2)>>2]|0}function SZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0,k=0.0,l=0,m=0;e=i;f=b+4|0;g=+h[c[c[f>>2]>>2]>>3];j=b+416|0;k=+h[(c[j>>2]|0)+3288>>3];if((d|0)==0){d=b+352|0;a[c[d>>2]|0]=g<k|0;l=c[j>>2]|0;a[(c[d>>2]|0)+1|0]=+h[c[c[f>>2]>>2]>>3]<+h[l+3288>>3]+ +h[l+3272>>3]|0;i=e;return 0}else{l=b+360|0;d=A_a(g,k,a[c[l>>2]|0]|0)|0;m=b+352|0;a[c[m>>2]|0]=d;d=c[j>>2]|0;j=A_a(+h[c[c[f>>2]>>2]>>3],+h[d+3288>>3]+ +h[d+3272>>3],a[(c[l>>2]|0)+1|0]|0)|0;a[(c[m>>2]|0)+1|0]=j;i=e;return 0}return 0}function TZ(a){a=a|0;a=i;i=i+8|0;kXa(8,1,50872,a);if((c[240112>>2]|0)==0){i=a;return 0}me[c[60158]&2047](8);i=a;return 0}function UZ(a){a=a|0;i=i;return c[55864+(a<<2)>>2]|0}function VZ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0.0,fb=0;d=i;i=i+16|0;e=d;f=i;i=i+16|0;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+16|0;S=i;i=i+16|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+16|0;X=i;i=i+16|0;Y=i;i=i+16|0;Z=i;i=i+16|0;_=i;i=i+16|0;$=i;i=i+16|0;aa=i;i=i+16|0;ba=i;i=i+16|0;ca=i;i=i+16|0;da=i;i=i+16|0;ea=i;i=i+16|0;fa=i;i=i+16|0;ga=i;i=i+16|0;ha=i;i=i+16|0;ia=i;i=i+16|0;ja=i;i=i+16|0;ka=i;i=i+16|0;la=i;i=i+16|0;ma=i;i=i+16|0;na=i;i=i+16|0;oa=i;i=i+16|0;pa=i;i=i+16|0;qa=i;i=i+16|0;ra=i;i=i+16|0;sa=i;i=i+16|0;ta=i;i=i+16|0;ua=i;i=i+16|0;va=i;i=i+16|0;wa=i;i=i+16|0;xa=i;i=i+16|0;ya=i;i=i+16|0;za=i;i=i+16|0;Aa=i;i=i+16|0;Ba=i;i=i+16|0;Ca=i;i=i+16|0;Da=i;i=i+16|0;Ea=i;i=i+16|0;Fa=i;i=i+16|0;Ga=i;i=i+16|0;Ha=i;i=i+16|0;Ia=i;i=i+16|0;Ja=i;i=i+16|0;Ka=i;i=i+16|0;La=i;i=i+16|0;Ma=i;i=i+16|0;Na=i;i=i+16|0;Oa=i;i=i+16|0;Pa=i;i=i+16|0;Qa=i;i=i+16|0;Ra=i;i=i+16|0;Sa=i;i=i+16|0;Ta=i;i=i+16|0;Ua=i;i=i+16|0;Va=i;i=i+16|0;Wa=i;i=i+16|0;Xa=i;i=i+16|0;Ya=i;i=i+16|0;Za=i;i=i+16|0;_a=i;i=i+16|0;$a=i;i=i+16|0;ab=i;i=i+16|0;bb=i;i=i+16|0;cb=i;i=i+16|0;db=i;i=i+8|0;kXa(21,1,56280,db);db=a+4|0;eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1440>>3];h[b>>3]=eb;fb=UZ(0)|0;c[cb>>2]=1;c[cb+4>>2]=fb;fb=cb+8|0;h[k>>3]=eb;c[fb>>2]=c[k>>2];c[fb+4>>2]=c[k+4>>2];kXa(21,0,56312,cb);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1448>>3];h[b+8>>3]=eb;cb=UZ(1)|0;c[bb>>2]=2;c[bb+4>>2]=cb;cb=bb+8|0;h[k>>3]=eb;c[cb>>2]=c[k>>2];c[cb+4>>2]=c[k+4>>2];kXa(21,0,56312,bb);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1456>>3];h[b+16>>3]=eb;bb=UZ(2)|0;c[ab>>2]=3;c[ab+4>>2]=bb;bb=ab+8|0;h[k>>3]=eb;c[bb>>2]=c[k>>2];c[bb+4>>2]=c[k+4>>2];kXa(21,0,56312,ab);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1464>>3];h[b+24>>3]=eb;ab=UZ(3)|0;c[$a>>2]=4;c[$a+4>>2]=ab;ab=$a+8|0;h[k>>3]=eb;c[ab>>2]=c[k>>2];c[ab+4>>2]=c[k+4>>2];kXa(21,0,56312,$a);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1472>>3];h[b+32>>3]=eb;$a=UZ(4)|0;c[_a>>2]=5;c[_a+4>>2]=$a;$a=_a+8|0;h[k>>3]=eb;c[$a>>2]=c[k>>2];c[$a+4>>2]=c[k+4>>2];kXa(21,0,56312,_a);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1480>>3];h[b+40>>3]=eb;_a=UZ(5)|0;c[Za>>2]=6;c[Za+4>>2]=_a;_a=Za+8|0;h[k>>3]=eb;c[_a>>2]=c[k>>2];c[_a+4>>2]=c[k+4>>2];kXa(21,0,56312,Za);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1488>>3];h[b+48>>3]=eb;Za=UZ(6)|0;c[Ya>>2]=7;c[Ya+4>>2]=Za;Za=Ya+8|0;h[k>>3]=eb;c[Za>>2]=c[k>>2];c[Za+4>>2]=c[k+4>>2];kXa(21,0,56312,Ya);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1496>>3];h[b+56>>3]=eb;Ya=UZ(7)|0;c[Xa>>2]=8;c[Xa+4>>2]=Ya;Ya=Xa+8|0;h[k>>3]=eb;c[Ya>>2]=c[k>>2];c[Ya+4>>2]=c[k+4>>2];kXa(21,0,56312,Xa);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1504>>3];h[b+64>>3]=eb;Xa=UZ(8)|0;c[Wa>>2]=9;c[Wa+4>>2]=Xa;Xa=Wa+8|0;h[k>>3]=eb;c[Xa>>2]=c[k>>2];c[Xa+4>>2]=c[k+4>>2];kXa(21,0,56312,Wa);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1512>>3];h[b+72>>3]=eb;Wa=UZ(9)|0;c[Va>>2]=10;c[Va+4>>2]=Wa;Wa=Va+8|0;h[k>>3]=eb;c[Wa>>2]=c[k>>2];c[Wa+4>>2]=c[k+4>>2];kXa(21,0,56312,Va);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1520>>3];h[b+80>>3]=eb;Va=UZ(10)|0;c[Ua>>2]=11;c[Ua+4>>2]=Va;Va=Ua+8|0;h[k>>3]=eb;c[Va>>2]=c[k>>2];c[Va+4>>2]=c[k+4>>2];kXa(21,0,56312,Ua);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1528>>3];h[b+88>>3]=eb;Ua=UZ(11)|0;c[Ta>>2]=12;c[Ta+4>>2]=Ua;Ua=Ta+8|0;h[k>>3]=eb;c[Ua>>2]=c[k>>2];c[Ua+4>>2]=c[k+4>>2];kXa(21,0,56312,Ta);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1536>>3];h[b+96>>3]=eb;Ta=UZ(12)|0;c[Sa>>2]=13;c[Sa+4>>2]=Ta;Ta=Sa+8|0;h[k>>3]=eb;c[Ta>>2]=c[k>>2];c[Ta+4>>2]=c[k+4>>2];kXa(21,0,56312,Sa);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1544>>3];h[b+104>>3]=eb;Sa=UZ(13)|0;c[Ra>>2]=14;c[Ra+4>>2]=Sa;Sa=Ra+8|0;h[k>>3]=eb;c[Sa>>2]=c[k>>2];c[Sa+4>>2]=c[k+4>>2];kXa(21,0,56312,Ra);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1552>>3];h[b+112>>3]=eb;Ra=UZ(14)|0;c[Qa>>2]=15;c[Qa+4>>2]=Ra;Ra=Qa+8|0;h[k>>3]=eb;c[Ra>>2]=c[k>>2];c[Ra+4>>2]=c[k+4>>2];kXa(21,0,56312,Qa);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1560>>3];h[b+120>>3]=eb;Qa=UZ(15)|0;c[Pa>>2]=16;c[Pa+4>>2]=Qa;Qa=Pa+8|0;h[k>>3]=eb;c[Qa>>2]=c[k>>2];c[Qa+4>>2]=c[k+4>>2];kXa(21,0,56312,Pa);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1568>>3];h[b+128>>3]=eb;Pa=UZ(16)|0;c[Oa>>2]=17;c[Oa+4>>2]=Pa;Pa=Oa+8|0;h[k>>3]=eb;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];kXa(21,0,56312,Oa);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1576>>3];h[b+136>>3]=eb;Oa=UZ(17)|0;c[Na>>2]=18;c[Na+4>>2]=Oa;Oa=Na+8|0;h[k>>3]=eb;c[Oa>>2]=c[k>>2];c[Oa+4>>2]=c[k+4>>2];kXa(21,0,56312,Na);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1584>>3];h[b+144>>3]=eb;Na=UZ(18)|0;c[Ma>>2]=19;c[Ma+4>>2]=Na;Na=Ma+8|0;h[k>>3]=eb;c[Na>>2]=c[k>>2];c[Na+4>>2]=c[k+4>>2];kXa(21,0,56312,Ma);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1592>>3];h[b+152>>3]=eb;Ma=UZ(19)|0;c[La>>2]=20;c[La+4>>2]=Ma;Ma=La+8|0;h[k>>3]=eb;c[Ma>>2]=c[k>>2];c[Ma+4>>2]=c[k+4>>2];kXa(21,0,56312,La);La=a+416|0;a=c[La>>2]|0;Ma=c[(c[c[db>>2]>>2]|0)+8>>2]|0;eb=+h[a+2872>>3]+(-(+h[a+2904>>3]*+h[a+2920>>3]*(+h[Ma+12560>>3]+(+h[Ma+12568>>3]+(+h[Ma+12576>>3]+(+h[Ma+12584>>3]+(+h[Ma+12592>>3]+(+h[Ma+12600>>3]+(+h[Ma+12608>>3]+(+h[Ma+12616>>3]+(+h[Ma+12624>>3]+(+h[Ma+12632>>3]+(+h[Ma+12640>>3]+(+h[Ma+12648>>3]+(+h[Ma+12656>>3]+(+h[Ma+12664>>3]+(+h[Ma+12672>>3]+(+h[Ma+12680>>3]+(+h[Ma+12688>>3]+(+h[Ma+12696>>3]+(+h[Ma+12704>>3]+ +h[Ma+12712>>3]))))))))))))))))))))- +h[Ma+14728>>3]);h[b+160>>3]=eb;Ma=UZ(20)|0;c[Ka>>2]=21;c[Ka+4>>2]=Ma;Ma=Ka+8|0;h[k>>3]=eb;c[Ma>>2]=c[k>>2];c[Ma+4>>2]=c[k+4>>2];kXa(21,0,56312,Ka);Ka=c[La>>2]|0;eb=+h[Ka+2896>>3]- +h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+14728>>3]*+h[Ka+2888>>3];h[b+168>>3]=eb;Ka=UZ(21)|0;c[Ja>>2]=22;c[Ja+4>>2]=Ka;Ka=Ja+8|0;h[k>>3]=eb;c[Ka>>2]=c[k>>2];c[Ka+4>>2]=c[k+4>>2];kXa(21,0,56312,Ja);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1424>>3];h[b+176>>3]=eb;Ja=UZ(22)|0;c[Ia>>2]=23;c[Ia+4>>2]=Ja;Ja=Ia+8|0;h[k>>3]=eb;c[Ja>>2]=c[k>>2];c[Ja+4>>2]=c[k+4>>2];kXa(21,0,56312,Ia);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1408>>3];h[b+184>>3]=eb;Ia=UZ(23)|0;c[Ha>>2]=24;c[Ha+4>>2]=Ia;Ia=Ha+8|0;h[k>>3]=eb;c[Ia>>2]=c[k>>2];c[Ia+4>>2]=c[k+4>>2];kXa(21,0,56312,Ha);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1392>>3];h[b+192>>3]=eb;Ha=UZ(24)|0;c[Ga>>2]=25;c[Ga+4>>2]=Ha;Ha=Ga+8|0;h[k>>3]=eb;c[Ha>>2]=c[k>>2];c[Ha+4>>2]=c[k+4>>2];kXa(21,0,56312,Ga);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1376>>3];h[b+200>>3]=eb;Ga=UZ(25)|0;c[Fa>>2]=26;c[Fa+4>>2]=Ga;Ga=Fa+8|0;h[k>>3]=eb;c[Ga>>2]=c[k>>2];c[Ga+4>>2]=c[k+4>>2];kXa(21,0,56312,Fa);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1360>>3];h[b+208>>3]=eb;Fa=UZ(26)|0;c[Ea>>2]=27;c[Ea+4>>2]=Fa;Fa=Ea+8|0;h[k>>3]=eb;c[Fa>>2]=c[k>>2];c[Fa+4>>2]=c[k+4>>2];kXa(21,0,56312,Ea);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1344>>3];h[b+216>>3]=eb;Ea=UZ(27)|0;c[Da>>2]=28;c[Da+4>>2]=Ea;Ea=Da+8|0;h[k>>3]=eb;c[Ea>>2]=c[k>>2];c[Ea+4>>2]=c[k+4>>2];kXa(21,0,56312,Da);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1328>>3];h[b+224>>3]=eb;Da=UZ(28)|0;c[Ca>>2]=29;c[Ca+4>>2]=Da;Da=Ca+8|0;h[k>>3]=eb;c[Da>>2]=c[k>>2];c[Da+4>>2]=c[k+4>>2];kXa(21,0,56312,Ca);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1312>>3];h[b+232>>3]=eb;Ca=UZ(29)|0;c[Ba>>2]=30;c[Ba+4>>2]=Ca;Ca=Ba+8|0;h[k>>3]=eb;c[Ca>>2]=c[k>>2];c[Ca+4>>2]=c[k+4>>2];kXa(21,0,56312,Ba);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1296>>3];h[b+240>>3]=eb;Ba=UZ(30)|0;c[Aa>>2]=31;c[Aa+4>>2]=Ba;Ba=Aa+8|0;h[k>>3]=eb;c[Ba>>2]=c[k>>2];c[Ba+4>>2]=c[k+4>>2];kXa(21,0,56312,Aa);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1280>>3];h[b+248>>3]=eb;Aa=UZ(31)|0;c[za>>2]=32;c[za+4>>2]=Aa;Aa=za+8|0;h[k>>3]=eb;c[Aa>>2]=c[k>>2];c[Aa+4>>2]=c[k+4>>2];kXa(21,0,56312,za);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1264>>3];h[b+256>>3]=eb;za=UZ(32)|0;c[ya>>2]=33;c[ya+4>>2]=za;za=ya+8|0;h[k>>3]=eb;c[za>>2]=c[k>>2];c[za+4>>2]=c[k+4>>2];kXa(21,0,56312,ya);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1248>>3];h[b+264>>3]=eb;ya=UZ(33)|0;c[xa>>2]=34;c[xa+4>>2]=ya;ya=xa+8|0;h[k>>3]=eb;c[ya>>2]=c[k>>2];c[ya+4>>2]=c[k+4>>2];kXa(21,0,56312,xa);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1232>>3];h[b+272>>3]=eb;xa=UZ(34)|0;c[wa>>2]=35;c[wa+4>>2]=xa;xa=wa+8|0;h[k>>3]=eb;c[xa>>2]=c[k>>2];c[xa+4>>2]=c[k+4>>2];kXa(21,0,56312,wa);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1216>>3];h[b+280>>3]=eb;wa=UZ(35)|0;c[va>>2]=36;c[va+4>>2]=wa;wa=va+8|0;h[k>>3]=eb;c[wa>>2]=c[k>>2];c[wa+4>>2]=c[k+4>>2];kXa(21,0,56312,va);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1200>>3];h[b+288>>3]=eb;va=UZ(36)|0;c[ua>>2]=37;c[ua+4>>2]=va;va=ua+8|0;h[k>>3]=eb;c[va>>2]=c[k>>2];c[va+4>>2]=c[k+4>>2];kXa(21,0,56312,ua);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1184>>3];h[b+296>>3]=eb;ua=UZ(37)|0;c[ta>>2]=38;c[ta+4>>2]=ua;ua=ta+8|0;h[k>>3]=eb;c[ua>>2]=c[k>>2];c[ua+4>>2]=c[k+4>>2];kXa(21,0,56312,ta);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1168>>3];h[b+304>>3]=eb;ta=UZ(38)|0;c[sa>>2]=39;c[sa+4>>2]=ta;ta=sa+8|0;h[k>>3]=eb;c[ta>>2]=c[k>>2];c[ta+4>>2]=c[k+4>>2];kXa(21,0,56312,sa);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1152>>3];h[b+312>>3]=eb;sa=UZ(39)|0;c[ra>>2]=40;c[ra+4>>2]=sa;sa=ra+8|0;h[k>>3]=eb;c[sa>>2]=c[k>>2];c[sa+4>>2]=c[k+4>>2];kXa(21,0,56312,ra);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1136>>3];h[b+320>>3]=eb;ra=UZ(40)|0;c[qa>>2]=41;c[qa+4>>2]=ra;ra=qa+8|0;h[k>>3]=eb;c[ra>>2]=c[k>>2];c[ra+4>>2]=c[k+4>>2];kXa(21,0,56312,qa);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1120>>3];h[b+328>>3]=eb;qa=UZ(41)|0;c[pa>>2]=42;c[pa+4>>2]=qa;qa=pa+8|0;h[k>>3]=eb;c[qa>>2]=c[k>>2];c[qa+4>>2]=c[k+4>>2];kXa(21,0,56312,pa);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1432>>3];h[b+336>>3]=eb;pa=UZ(42)|0;c[oa>>2]=43;c[oa+4>>2]=pa;pa=oa+8|0;h[k>>3]=eb;c[pa>>2]=c[k>>2];c[pa+4>>2]=c[k+4>>2];kXa(21,0,56312,oa);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1416>>3];h[b+344>>3]=eb;oa=UZ(43)|0;c[na>>2]=44;c[na+4>>2]=oa;oa=na+8|0;h[k>>3]=eb;c[oa>>2]=c[k>>2];c[oa+4>>2]=c[k+4>>2];kXa(21,0,56312,na);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1400>>3];h[b+352>>3]=eb;na=UZ(44)|0;c[ma>>2]=45;c[ma+4>>2]=na;na=ma+8|0;h[k>>3]=eb;c[na>>2]=c[k>>2];c[na+4>>2]=c[k+4>>2];kXa(21,0,56312,ma);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1384>>3];h[b+360>>3]=eb;ma=UZ(45)|0;c[la>>2]=46;c[la+4>>2]=ma;ma=la+8|0;h[k>>3]=eb;c[ma>>2]=c[k>>2];c[ma+4>>2]=c[k+4>>2];kXa(21,0,56312,la);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1368>>3];h[b+368>>3]=eb;la=UZ(46)|0;c[ka>>2]=47;c[ka+4>>2]=la;la=ka+8|0;h[k>>3]=eb;c[la>>2]=c[k>>2];c[la+4>>2]=c[k+4>>2];kXa(21,0,56312,ka);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1352>>3];h[b+376>>3]=eb;ka=UZ(47)|0;c[ja>>2]=48;c[ja+4>>2]=ka;ka=ja+8|0;h[k>>3]=eb;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];kXa(21,0,56312,ja);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1336>>3];h[b+384>>3]=eb;ja=UZ(48)|0;c[ia>>2]=49;c[ia+4>>2]=ja;ja=ia+8|0;h[k>>3]=eb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];kXa(21,0,56312,ia);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1320>>3];h[b+392>>3]=eb;ia=UZ(49)|0;c[ha>>2]=50;c[ha+4>>2]=ia;ia=ha+8|0;h[k>>3]=eb;c[ia>>2]=c[k>>2];c[ia+4>>2]=c[k+4>>2];kXa(21,0,56312,ha);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1304>>3];h[b+400>>3]=eb;ha=UZ(50)|0;c[ga>>2]=51;c[ga+4>>2]=ha;ha=ga+8|0;h[k>>3]=eb;c[ha>>2]=c[k>>2];c[ha+4>>2]=c[k+4>>2];kXa(21,0,56312,ga);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1288>>3];h[b+408>>3]=eb;ga=UZ(51)|0;c[fa>>2]=52;c[fa+4>>2]=ga;ga=fa+8|0;h[k>>3]=eb;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];kXa(21,0,56312,fa);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1272>>3];h[b+416>>3]=eb;fa=UZ(52)|0;c[ea>>2]=53;c[ea+4>>2]=fa;fa=ea+8|0;h[k>>3]=eb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];kXa(21,0,56312,ea);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1256>>3];h[b+424>>3]=eb;ea=UZ(53)|0;c[da>>2]=54;c[da+4>>2]=ea;ea=da+8|0;h[k>>3]=eb;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];kXa(21,0,56312,da);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1240>>3];h[b+432>>3]=eb;da=UZ(54)|0;c[ca>>2]=55;c[ca+4>>2]=da;da=ca+8|0;h[k>>3]=eb;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];kXa(21,0,56312,ca);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1224>>3];h[b+440>>3]=eb;ca=UZ(55)|0;c[ba>>2]=56;c[ba+4>>2]=ca;ca=ba+8|0;h[k>>3]=eb;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];kXa(21,0,56312,ba);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1208>>3];h[b+448>>3]=eb;ba=UZ(56)|0;c[aa>>2]=57;c[aa+4>>2]=ba;ba=aa+8|0;h[k>>3]=eb;c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];kXa(21,0,56312,aa);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1192>>3];h[b+456>>3]=eb;aa=UZ(57)|0;c[$>>2]=58;c[$+4>>2]=aa;aa=$+8|0;h[k>>3]=eb;c[aa>>2]=c[k>>2];c[aa+4>>2]=c[k+4>>2];kXa(21,0,56312,$);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1176>>3];h[b+464>>3]=eb;$=UZ(58)|0;c[_>>2]=59;c[_+4>>2]=$;$=_+8|0;h[k>>3]=eb;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];kXa(21,0,56312,_);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1160>>3];h[b+472>>3]=eb;_=UZ(59)|0;c[Z>>2]=60;c[Z+4>>2]=_;_=Z+8|0;h[k>>3]=eb;c[_>>2]=c[k>>2];c[_+4>>2]=c[k+4>>2];kXa(21,0,56312,Z);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1144>>3];h[b+480>>3]=eb;Z=UZ(60)|0;c[Y>>2]=61;c[Y+4>>2]=Z;Z=Y+8|0;h[k>>3]=eb;c[Z>>2]=c[k>>2];c[Z+4>>2]=c[k+4>>2];kXa(21,0,56312,Y);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1128>>3];h[b+488>>3]=eb;Y=UZ(61)|0;c[X>>2]=62;c[X+4>>2]=Y;Y=X+8|0;h[k>>3]=eb;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];kXa(21,0,56312,X);X=c[La>>2]|0;Y=c[(c[c[db>>2]>>2]|0)+8>>2]|0;eb=+h[X+3104>>3]+(-(+h[X+3136>>3]*+h[X+3152>>3]*(+h[Y+12720>>3]+(+h[Y+12728>>3]+(+h[Y+12736>>3]+(+h[Y+12744>>3]+(+h[Y+12752>>3]+(+h[Y+12760>>3]+(+h[Y+12768>>3]+(+h[Y+12776>>3]+(+h[Y+12784>>3]+(+h[Y+12792>>3]+(+h[Y+12800>>3]+(+h[Y+12808>>3]+(+h[Y+12816>>3]+(+h[Y+12824>>3]+(+h[Y+12832>>3]+(+h[Y+12840>>3]+(+h[Y+12848>>3]+(+h[Y+12856>>3]+(+h[Y+12864>>3]+ +h[Y+12872>>3]))))))))))))))))))))- +h[Y+14736>>3]);h[b+496>>3]=eb;Y=UZ(62)|0;c[W>>2]=63;c[W+4>>2]=Y;Y=W+8|0;h[k>>3]=eb;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];kXa(21,0,56312,W);W=c[La>>2]|0;eb=+h[W+3128>>3]- +h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+14736>>3]*+h[W+3120>>3];h[b+504>>3]=eb;W=UZ(63)|0;c[V>>2]=64;c[V+4>>2]=W;W=V+8|0;h[k>>3]=eb;c[W>>2]=c[k>>2];c[W+4>>2]=c[k+4>>2];kXa(21,0,56312,V);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1104>>3];h[b+512>>3]=eb;V=UZ(64)|0;c[U>>2]=65;c[U+4>>2]=V;V=U+8|0;h[k>>3]=eb;c[V>>2]=c[k>>2];c[V+4>>2]=c[k+4>>2];kXa(21,0,56312,U);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1088>>3];h[b+520>>3]=eb;U=UZ(65)|0;c[T>>2]=66;c[T+4>>2]=U;U=T+8|0;h[k>>3]=eb;c[U>>2]=c[k>>2];c[U+4>>2]=c[k+4>>2];kXa(21,0,56312,T);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1072>>3];h[b+528>>3]=eb;T=UZ(66)|0;c[S>>2]=67;c[S+4>>2]=T;T=S+8|0;h[k>>3]=eb;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];kXa(21,0,56312,S);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1056>>3];h[b+536>>3]=eb;S=UZ(67)|0;c[R>>2]=68;c[R+4>>2]=S;S=R+8|0;h[k>>3]=eb;c[S>>2]=c[k>>2];c[S+4>>2]=c[k+4>>2];kXa(21,0,56312,R);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1040>>3];h[b+544>>3]=eb;R=UZ(68)|0;c[Q>>2]=69;c[Q+4>>2]=R;R=Q+8|0;h[k>>3]=eb;c[R>>2]=c[k>>2];c[R+4>>2]=c[k+4>>2];kXa(21,0,56312,Q);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1024>>3];h[b+552>>3]=eb;Q=UZ(69)|0;c[P>>2]=70;c[P+4>>2]=Q;Q=P+8|0;h[k>>3]=eb;c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];kXa(21,0,56312,P);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1008>>3];h[b+560>>3]=eb;P=UZ(70)|0;c[O>>2]=71;c[O+4>>2]=P;P=O+8|0;h[k>>3]=eb;c[P>>2]=c[k>>2];c[P+4>>2]=c[k+4>>2];kXa(21,0,56312,O);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+992>>3];h[b+568>>3]=eb;O=UZ(71)|0;c[N>>2]=72;c[N+4>>2]=O;O=N+8|0;h[k>>3]=eb;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];kXa(21,0,56312,N);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+976>>3];h[b+576>>3]=eb;N=UZ(72)|0;c[M>>2]=73;c[M+4>>2]=N;N=M+8|0;h[k>>3]=eb;c[N>>2]=c[k>>2];c[N+4>>2]=c[k+4>>2];kXa(21,0,56312,M);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+960>>3];h[b+584>>3]=eb;M=UZ(73)|0;c[L>>2]=74;c[L+4>>2]=M;M=L+8|0;h[k>>3]=eb;c[M>>2]=c[k>>2];c[M+4>>2]=c[k+4>>2];kXa(21,0,56312,L);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+944>>3];h[b+592>>3]=eb;L=UZ(74)|0;c[K>>2]=75;c[K+4>>2]=L;L=K+8|0;h[k>>3]=eb;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];kXa(21,0,56312,K);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+928>>3];h[b+600>>3]=eb;K=UZ(75)|0;c[J>>2]=76;c[J+4>>2]=K;K=J+8|0;h[k>>3]=eb;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];kXa(21,0,56312,J);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+912>>3];h[b+608>>3]=eb;J=UZ(76)|0;c[I>>2]=77;c[I+4>>2]=J;J=I+8|0;h[k>>3]=eb;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];kXa(21,0,56312,I);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+896>>3];h[b+616>>3]=eb;I=UZ(77)|0;c[H>>2]=78;c[H+4>>2]=I;I=H+8|0;h[k>>3]=eb;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];kXa(21,0,56312,H);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+880>>3];h[b+624>>3]=eb;H=UZ(78)|0;c[G>>2]=79;c[G+4>>2]=H;H=G+8|0;h[k>>3]=eb;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];kXa(21,0,56312,G);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+864>>3];h[b+632>>3]=eb;G=UZ(79)|0;c[F>>2]=80;c[F+4>>2]=G;G=F+8|0;h[k>>3]=eb;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];kXa(21,0,56312,F);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+848>>3];h[b+640>>3]=eb;F=UZ(80)|0;c[E>>2]=81;c[E+4>>2]=F;F=E+8|0;h[k>>3]=eb;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];kXa(21,0,56312,E);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+832>>3];h[b+648>>3]=eb;E=UZ(81)|0;c[D>>2]=82;c[D+4>>2]=E;E=D+8|0;h[k>>3]=eb;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];kXa(21,0,56312,D);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+816>>3];h[b+656>>3]=eb;D=UZ(82)|0;c[C>>2]=83;c[C+4>>2]=D;D=C+8|0;h[k>>3]=eb;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];kXa(21,0,56312,C);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+800>>3];h[b+664>>3]=eb;C=UZ(83)|0;c[B>>2]=84;c[B+4>>2]=C;C=B+8|0;h[k>>3]=eb;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];kXa(21,0,56312,B);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1112>>3];h[b+672>>3]=eb;B=UZ(84)|0;c[A>>2]=85;c[A+4>>2]=B;B=A+8|0;h[k>>3]=eb;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];kXa(21,0,56312,A);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1096>>3];h[b+680>>3]=eb;A=UZ(85)|0;c[z>>2]=86;c[z+4>>2]=A;A=z+8|0;h[k>>3]=eb;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];kXa(21,0,56312,z);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1080>>3];h[b+688>>3]=eb;z=UZ(86)|0;c[y>>2]=87;c[y+4>>2]=z;z=y+8|0;h[k>>3]=eb;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];kXa(21,0,56312,y);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1064>>3];h[b+696>>3]=eb;y=UZ(87)|0;c[x>>2]=88;c[x+4>>2]=y;y=x+8|0;h[k>>3]=eb;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];kXa(21,0,56312,x);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1048>>3];h[b+704>>3]=eb;x=UZ(88)|0;c[w>>2]=89;c[w+4>>2]=x;x=w+8|0;h[k>>3]=eb;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];kXa(21,0,56312,w);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1032>>3];h[b+712>>3]=eb;w=UZ(89)|0;c[v>>2]=90;c[v+4>>2]=w;w=v+8|0;h[k>>3]=eb;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];kXa(21,0,56312,v);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1016>>3];h[b+720>>3]=eb;v=UZ(90)|0;c[u>>2]=91;c[u+4>>2]=v;v=u+8|0;h[k>>3]=eb;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];kXa(21,0,56312,u);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+1e3>>3];h[b+728>>3]=eb;u=UZ(91)|0;c[t>>2]=92;c[t+4>>2]=u;u=t+8|0;h[k>>3]=eb;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];kXa(21,0,56312,t);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+984>>3];h[b+736>>3]=eb;t=UZ(92)|0;c[s>>2]=93;c[s+4>>2]=t;t=s+8|0;h[k>>3]=eb;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];kXa(21,0,56312,s);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+968>>3];h[b+744>>3]=eb;s=UZ(93)|0;c[r>>2]=94;c[r+4>>2]=s;s=r+8|0;h[k>>3]=eb;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];kXa(21,0,56312,r);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+952>>3];h[b+752>>3]=eb;r=UZ(94)|0;c[q>>2]=95;c[q+4>>2]=r;r=q+8|0;h[k>>3]=eb;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];kXa(21,0,56312,q);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+936>>3];h[b+760>>3]=eb;q=UZ(95)|0;c[p>>2]=96;c[p+4>>2]=q;q=p+8|0;h[k>>3]=eb;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];kXa(21,0,56312,p);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+920>>3];h[b+768>>3]=eb;p=UZ(96)|0;c[o>>2]=97;c[o+4>>2]=p;p=o+8|0;h[k>>3]=eb;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];kXa(21,0,56312,o);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+904>>3];h[b+776>>3]=eb;o=UZ(97)|0;c[n>>2]=98;c[n+4>>2]=o;o=n+8|0;h[k>>3]=eb;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];kXa(21,0,56312,n);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+888>>3];h[b+784>>3]=eb;n=UZ(98)|0;c[m>>2]=99;c[m+4>>2]=n;n=m+8|0;h[k>>3]=eb;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];kXa(21,0,56312,m);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+872>>3];h[b+792>>3]=eb;m=UZ(99)|0;c[l>>2]=100;c[l+4>>2]=m;m=l+8|0;h[k>>3]=eb;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];kXa(21,0,56312,l);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+856>>3];h[b+800>>3]=eb;l=UZ(100)|0;c[j>>2]=101;c[j+4>>2]=l;l=j+8|0;h[k>>3]=eb;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];kXa(21,0,56312,j);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+840>>3];h[b+808>>3]=eb;j=UZ(101)|0;c[g>>2]=102;c[g+4>>2]=j;j=g+8|0;h[k>>3]=eb;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];kXa(21,0,56312,g);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+824>>3];h[b+816>>3]=eb;g=UZ(102)|0;c[f>>2]=103;c[f+4>>2]=g;g=f+8|0;h[k>>3]=eb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];kXa(21,0,56312,f);eb=+h[(c[(c[c[db>>2]>>2]|0)+8>>2]|0)+808>>3];h[b+824>>3]=eb;b=UZ(103)|0;c[e>>2]=104;c[e+4>>2]=b;b=e+8|0;h[k>>3]=eb;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];kXa(21,0,56312,e);if((c[240164>>2]|0)==0){i=d;return 0}me[c[60158]&2047](21);i=d;return 0}function WZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3368>>3]=+h[b+3304>>3];i=i;return}function XZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3360>>3]=+h[b+3296>>3];i=i;return}function YZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2792>>3]=+h[b+3360>>3];i=i;return}function ZZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2824>>3]=+h[b+2792>>3];i=i;return}function _Z(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2856>>3]=+h[b+2824>>3];i=i;return}function $Z(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2848>>3]=+h[b+2792>>3];i=i;return}function a_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3192>>3]=+h[b+3304>>3];i=i;return}function b_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3176>>3]=+h[b+2968>>3];i=i;return}function c_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3136>>3]=+h[b+3312>>3];i=i;return}function d_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3120>>3]=+h[b+3336>>3];i=i;return}function e_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3072>>3]=+h[b+2968>>3];i=i;return}function f_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3048>>3]=+h[b+2496>>3];i=i;return}function g_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3040>>3]=+h[b+2480>>3];i=i;return}function h_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1632>>3]=+h[b+3040>>3];i=i;return}function i_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1640>>3]=+h[b+3040>>3];i=i;return}function j_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1648>>3]=+h[b+3040>>3];i=i;return}function k_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1656>>3]=+h[b+3040>>3];i=i;return}function l_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1664>>3]=+h[b+3040>>3];i=i;return}function m_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1672>>3]=+h[b+3040>>3];i=i;return}function n_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1680>>3]=+h[b+3040>>3];i=i;return}function o_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1688>>3]=+h[b+3040>>3];i=i;return}function p_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1696>>3]=+h[b+3040>>3];i=i;return}function q_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1704>>3]=+h[b+3040>>3];i=i;return}function r_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1712>>3]=+h[b+3040>>3];i=i;return}function s_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1720>>3]=+h[b+3040>>3];i=i;return}function t_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1728>>3]=+h[b+3040>>3];i=i;return}function u_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1736>>3]=+h[b+3040>>3];i=i;return}function v_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1744>>3]=+h[b+3040>>3];i=i;return}function w_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1752>>3]=+h[b+3040>>3];i=i;return}function x_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1760>>3]=+h[b+3040>>3];i=i;return}function y_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1768>>3]=+h[b+3040>>3];i=i;return}function z_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1776>>3]=+h[b+3040>>3];i=i;return}function A_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1784>>3]=+h[b+3040>>3];i=i;return}function B_(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+3048>>3];j=+h[f+3040>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,56336,56328,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1792>>3]=l*4.0;i=d;return}function C_(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+3048>>3];j=+h[f+3040>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,56336,56360,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1800>>3]=l*4.0;i=d;return}function D_(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+3048>>3];j=+h[f+3040>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,56336,56368,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1808>>3]=l*4.0;i=d;return}function E_(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+3048>>3];j=+h[f+3040>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,56336,56376,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1816>>3]=l*4.0;i=d;return}function F_(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+3048>>3];j=+h[f+3040>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,56336,56384,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1824>>3]=l*4.0;i=d;return}function G_(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+3048>>3];j=+h[f+3040>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,56336,56392,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1832>>3]=l*4.0;i=d;return}function H_(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+3048>>3];j=+h[f+3040>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,56336,56400,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1840>>3]=l*4.0;i=d;return}function I_(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+3048>>3];j=+h[f+3040>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,56336,56408,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1848>>3]=l*4.0;i=d;return}function J_(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+3048>>3];j=+h[f+3040>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,56336,56416,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1856>>3]=l*4.0;i=d;return}function K_(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+3048>>3];j=+h[f+3040>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,56336,56424,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1864>>3]=l*4.0;i=d;return}function L_(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+3048>>3];j=+h[f+3040>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,56336,56432,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1872>>3]=l*4.0;i=d;return}function M_(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+3048>>3];j=+h[f+3040>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,56336,56440,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1880>>3]=l*4.0;i=d;return}function N_(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+3048>>3];j=+h[f+3040>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,56336,56448,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1888>>3]=l*4.0;i=d;return}function O_(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+3048>>3];j=+h[f+3040>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,56336,56456,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1896>>3]=l*4.0;i=d;return}function P_(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+3048>>3];j=+h[f+3040>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,56336,56464,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1904>>3]=l*4.0;i=d;return}function Q_(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+3048>>3];j=+h[f+3040>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,56336,56472,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1912>>3]=l*4.0;i=d;return}function R_(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+3048>>3];j=+h[f+3040>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,56336,56480,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1920>>3]=l*4.0;i=d;return}function S_(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+3048>>3];j=+h[f+3040>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,56336,56488,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1928>>3]=l*4.0;i=d;return}function T_(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+3048>>3];j=+h[f+3040>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,56336,56496,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1936>>3]=l*4.0;i=d;return}function U_(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+3048>>3];j=+h[f+3040>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,56336,56504,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1944>>3]=l*4.0;i=d;return}function V_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2992>>3]=+h[b+2608>>3];i=i;return}function W_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1952>>3]=+h[b+2992>>3];i=i;return}function X_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1960>>3]=+h[b+2992>>3];i=i;return}function Y_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1968>>3]=+h[b+2992>>3];i=i;return}function Z_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1976>>3]=+h[b+2992>>3];i=i;return}function __(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1984>>3]=+h[b+2992>>3];i=i;return}function $_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1992>>3]=+h[b+2992>>3];i=i;return}function a$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2e3>>3]=+h[b+2992>>3];i=i;return}function b$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2008>>3]=+h[b+2992>>3];i=i;return}function c$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2016>>3]=+h[b+2992>>3];i=i;return}function d$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2024>>3]=+h[b+2992>>3];i=i;return}function e$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2032>>3]=+h[b+2992>>3];i=i;return}function f$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2040>>3]=+h[b+2992>>3];i=i;return}function g$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2048>>3]=+h[b+2992>>3];i=i;return}function h$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2056>>3]=+h[b+2992>>3];i=i;return}function i$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2064>>3]=+h[b+2992>>3];i=i;return}function j$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2072>>3]=+h[b+2992>>3];i=i;return}function k$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2080>>3]=+h[b+2992>>3];i=i;return}function l$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2088>>3]=+h[b+2992>>3];i=i;return}function m$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2096>>3]=+h[b+2992>>3];i=i;return}function n$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2104>>3]=+h[b+2992>>3];i=i;return}function o$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2976>>3]=+h[b+2464>>3];i=i;return}function p$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1472>>3]=+h[b+2976>>3]*.05;i=i;return}function q$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1480>>3]=+h[b+2976>>3]*.05;i=i;return}function r$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1488>>3]=+h[b+2976>>3]*.05;i=i;return}function s$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1496>>3]=+h[b+2976>>3]*.05;i=i;return}function t$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1504>>3]=+h[b+2976>>3]*.05;i=i;return}function u$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1512>>3]=+h[b+2976>>3]*.05;i=i;return}function v$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1520>>3]=+h[b+2976>>3]*.05;i=i;return}function w$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1528>>3]=+h[b+2976>>3]*.05;i=i;return}function x$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1536>>3]=+h[b+2976>>3]*.05;i=i;return}function y$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1544>>3]=+h[b+2976>>3]*.05;i=i;return}function z$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1552>>3]=+h[b+2976>>3]*.05;i=i;return}function A$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1560>>3]=+h[b+2976>>3]*.05;i=i;return}function B$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1568>>3]=+h[b+2976>>3]*.05;i=i;return}function C$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1576>>3]=+h[b+2976>>3]*.05;i=i;return}function D$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1584>>3]=+h[b+2976>>3]*.05;i=i;return}function E$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1592>>3]=+h[b+2976>>3]*.05;i=i;return}function F$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1600>>3]=+h[b+2976>>3]*.05;i=i;return}function G$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1608>>3]=+h[b+2976>>3]*.05;i=i;return}function H$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1616>>3]=+h[b+2976>>3]*.05;i=i;return}function I$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1624>>3]=+h[b+2976>>3]*.05;i=i;return}function J$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2944>>3]=+h[b+2736>>3];i=i;return}function K$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2904>>3]=+h[b+3312>>3];i=i;return}function L$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2888>>3]=+h[b+3336>>3];i=i;return}function M$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2840>>3]=+h[b+2736>>3];i=i;return}function N$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2816>>3]=+h[b+2488>>3];i=i;return}function O$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2808>>3]=+h[b+2472>>3];i=i;return}function P$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+504>>3]=+h[b+2808>>3];i=i;return}function Q$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+512>>3]=+h[b+2808>>3];i=i;return}function R$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+520>>3]=+h[b+2808>>3];i=i;return}function S$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+528>>3]=+h[b+2808>>3];i=i;return}function T$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+536>>3]=+h[b+2808>>3];i=i;return}function U$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+544>>3]=+h[b+2808>>3];i=i;return}function V$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+552>>3]=+h[b+2808>>3];i=i;return}function W$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+560>>3]=+h[b+2808>>3];i=i;return}function X$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+568>>3]=+h[b+2808>>3];i=i;return}function Y$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+576>>3]=+h[b+2808>>3];i=i;return}function Z$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+584>>3]=+h[b+2808>>3];i=i;return}function _$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+592>>3]=+h[b+2808>>3];i=i;return}function $$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+600>>3]=+h[b+2808>>3];i=i;return}function a0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+608>>3]=+h[b+2808>>3];i=i;return}function b0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+616>>3]=+h[b+2808>>3];i=i;return}function c0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+624>>3]=+h[b+2808>>3];i=i;return}function d0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+632>>3]=+h[b+2808>>3];i=i;return}function e0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+640>>3]=+h[b+2808>>3];i=i;return}function f0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+648>>3]=+h[b+2808>>3];i=i;return}function g0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+656>>3]=+h[b+2808>>3];i=i;return}function h0(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2816>>3];j=+h[f+2808>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,56520,56512,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+664>>3]=l*4.0;i=d;return}function i0(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2816>>3];j=+h[f+2808>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,56520,56544,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+672>>3]=l*4.0;i=d;return}function j0(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2816>>3];j=+h[f+2808>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,56520,56552,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+680>>3]=l*4.0;i=d;return}function k0(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2816>>3];j=+h[f+2808>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,56520,56560,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+688>>3]=l*4.0;i=d;return}function l0(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2816>>3];j=+h[f+2808>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,56520,56568,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+696>>3]=l*4.0;i=d;return}function m0(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2816>>3];j=+h[f+2808>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,56520,56576,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+704>>3]=l*4.0;i=d;return}function n0(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2816>>3];j=+h[f+2808>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,56520,56584,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+712>>3]=l*4.0;i=d;return}function o0(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2816>>3];j=+h[f+2808>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,56520,56592,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+720>>3]=l*4.0;i=d;return}function p0(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2816>>3];j=+h[f+2808>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,56520,56600,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+728>>3]=l*4.0;i=d;return}function q0(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2816>>3];j=+h[f+2808>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,56520,56608,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+736>>3]=l*4.0;i=d;return}function r0(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2816>>3];j=+h[f+2808>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,56520,56616,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+744>>3]=l*4.0;i=d;return}function s0(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2816>>3];j=+h[f+2808>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,56520,56624,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+752>>3]=l*4.0;i=d;return}function t0(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2816>>3];j=+h[f+2808>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,56520,56632,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+760>>3]=l*4.0;i=d;return}function u0(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2816>>3];j=+h[f+2808>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,56520,56640,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+768>>3]=l*4.0;i=d;return}function v0(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2816>>3];j=+h[f+2808>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,56520,56648,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+776>>3]=l*4.0;i=d;return}function w0(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2816>>3];j=+h[f+2808>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,56520,56656,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+784>>3]=l*4.0;i=d;return}function x0(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2816>>3];j=+h[f+2808>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,56520,56664,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+792>>3]=l*4.0;i=d;return}function y0(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2816>>3];j=+h[f+2808>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,56520,56672,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+800>>3]=l*4.0;i=d;return}function z0(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2816>>3];j=+h[f+2808>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,56520,56680,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+808>>3]=l*4.0;i=d;return}function A0(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2816>>3];j=+h[f+2808>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+qXa(c[b+536>>2]|0,g,56520,56688,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+816>>3]=l*4.0;i=d;return}function B0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2760>>3]=+h[b+2600>>3];i=i;return}function C0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+824>>3]=+h[b+2760>>3];i=i;return}function D0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+832>>3]=+h[b+2760>>3];i=i;return}function E0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+840>>3]=+h[b+2760>>3];i=i;return}function F0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+848>>3]=+h[b+2760>>3];i=i;return}function G0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+856>>3]=+h[b+2760>>3];i=i;return}function H0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+864>>3]=+h[b+2760>>3];i=i;return}function I0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+872>>3]=+h[b+2760>>3];i=i;return}function J0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+880>>3]=+h[b+2760>>3];i=i;return}function K0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+888>>3]=+h[b+2760>>3];i=i;return}function L0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+896>>3]=+h[b+2760>>3];i=i;return}function M0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+904>>3]=+h[b+2760>>3];i=i;return}function N0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+912>>3]=+h[b+2760>>3];i=i;return}function O0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+920>>3]=+h[b+2760>>3];i=i;return}function P0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+928>>3]=+h[b+2760>>3];i=i;return}function Q0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+936>>3]=+h[b+2760>>3];i=i;return}function R0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+944>>3]=+h[b+2760>>3];i=i;return}function S0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+952>>3]=+h[b+2760>>3];i=i;return}function T0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+960>>3]=+h[b+2760>>3];i=i;return}function U0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+968>>3]=+h[b+2760>>3];i=i;return}function V0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+976>>3]=+h[b+2760>>3];i=i;return}function W0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2744>>3]=+h[b+2464>>3];i=i;return}function X0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+344>>3]=+h[b+2744>>3]*.05;i=i;return}function Y0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+352>>3]=+h[b+2744>>3]*.05;i=i;return}function Z0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+360>>3]=+h[b+2744>>3]*.05;i=i;return}function _0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+368>>3]=+h[b+2744>>3]*.05;i=i;return}function $0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+376>>3]=+h[b+2744>>3]*.05;i=i;return}function a1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+384>>3]=+h[b+2744>>3]*.05;i=i;return}function b1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+392>>3]=+h[b+2744>>3]*.05;i=i;return}function c1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+400>>3]=+h[b+2744>>3]*.05;i=i;return}function d1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+408>>3]=+h[b+2744>>3]*.05;i=i;return}function e1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+416>>3]=+h[b+2744>>3]*.05;i=i;return}function f1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+424>>3]=+h[b+2744>>3]*.05;i=i;return}function g1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+432>>3]=+h[b+2744>>3]*.05;i=i;return}function h1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+440>>3]=+h[b+2744>>3]*.05;i=i;return}function i1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+448>>3]=+h[b+2744>>3]*.05;i=i;return}function j1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+456>>3]=+h[b+2744>>3]*.05;i=i;return}function k1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+464>>3]=+h[b+2744>>3]*.05;i=i;return}function l1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+472>>3]=+h[b+2744>>3]*.05;i=i;return}function m1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+480>>3]=+h[b+2744>>3]*.05;i=i;return}function n1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+488>>3]=+h[b+2744>>3]*.05;i=i;return}function o1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+496>>3]=+h[b+2744>>3]*.05;i=i;return}function p1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2704>>3]=+h[b+2528>>3];i=i;return}function q1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2696>>3]=+h[b+2536>>3];i=i;return}function r1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2688>>3]=+h[b+2544>>3];i=i;return}function s1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2680>>3]=(+h[b+2472>>3]+ +h[b+2480>>3])*.5;i=i;return}function t1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2672>>3]=+h[b+2520>>3];i=i;return}function u1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b>>3]=+h[b+2688>>3]*+h[b+2680>>3]*+h[b+2672>>3]*.05;i=i;return}function v1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8>>3]=+h[b+2688>>3]*+h[b+2680>>3]*+h[b+2672>>3]*.05;i=i;return}function w1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16>>3]=+h[b+2688>>3]*+h[b+2680>>3]*+h[b+2672>>3]*.05;i=i;return}function x1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24>>3]=+h[b+2688>>3]*+h[b+2680>>3]*+h[b+2672>>3]*.05;i=i;return}function y1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+32>>3]=+h[b+2688>>3]*+h[b+2680>>3]*+h[b+2672>>3]*.05;i=i;return}function z1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40>>3]=+h[b+2688>>3]*+h[b+2680>>3]*+h[b+2672>>3]*.05;i=i;return}function A1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+48>>3]=+h[b+2688>>3]*+h[b+2680>>3]*+h[b+2672>>3]*.05;i=i;return}function B1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+56>>3]=+h[b+2688>>3]*+h[b+2680>>3]*+h[b+2672>>3]*.05;i=i;return}function C1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+64>>3]=+h[b+2688>>3]*+h[b+2680>>3]*+h[b+2672>>3]*.05;i=i;return}function D1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+72>>3]=+h[b+2688>>3]*+h[b+2680>>3]*+h[b+2672>>3]*.05;i=i;return}function E1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+80>>3]=+h[b+2688>>3]*+h[b+2680>>3]*+h[b+2672>>3]*.05;i=i;return}function F1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+88>>3]=+h[b+2688>>3]*+h[b+2680>>3]*+h[b+2672>>3]*.05;i=i;return}function G1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+96>>3]=+h[b+2688>>3]*+h[b+2680>>3]*+h[b+2672>>3]*.05;i=i;return}function H1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+104>>3]=+h[b+2688>>3]*+h[b+2680>>3]*+h[b+2672>>3]*.05;i=i;return}function I1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+112>>3]=+h[b+2688>>3]*+h[b+2680>>3]*+h[b+2672>>3]*.05;i=i;return}function J1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+120>>3]=+h[b+2688>>3]*+h[b+2680>>3]*+h[b+2672>>3]*.05;i=i;return}function K1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+128>>3]=+h[b+2688>>3]*+h[b+2680>>3]*+h[b+2672>>3]*.05;i=i;return}function L1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+136>>3]=+h[b+2688>>3]*+h[b+2680>>3]*+h[b+2672>>3]*.05;i=i;return}function M1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+144>>3]=+h[b+2688>>3]*+h[b+2680>>3]*+h[b+2672>>3]*.05;i=i;return}function N1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+152>>3]=+h[b+2688>>3]*+h[b+2680>>3]*+h[b+2672>>3]*.05;i=i;return}function O1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14296>>3]=+h[b+1624>>3]*+h[b+3048>>3];i=i;return}function P1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14288>>3]=+h[b+1616>>3]*+h[b+3048>>3];i=i;return}function Q1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14280>>3]=+h[b+1608>>3]*+h[b+3048>>3];i=i;return}function R1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14272>>3]=+h[b+1600>>3]*+h[b+3048>>3];i=i;return}function S1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14264>>3]=+h[b+1592>>3]*+h[b+3048>>3];i=i;return}function T1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14256>>3]=+h[b+1584>>3]*+h[b+3048>>3];i=i;return}function U1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14248>>3]=+h[b+1576>>3]*+h[b+3048>>3];i=i;return}function V1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14240>>3]=+h[b+1568>>3]*+h[b+3048>>3];i=i;return}function W1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14232>>3]=+h[b+1560>>3]*+h[b+3048>>3];i=i;return}function X1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14224>>3]=+h[b+1552>>3]*+h[b+3048>>3];i=i;return}function Y1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14216>>3]=+h[b+1544>>3]*+h[b+3048>>3];i=i;return}function Z1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14208>>3]=+h[b+1536>>3]*+h[b+3048>>3];i=i;return}function _1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14200>>3]=+h[b+1528>>3]*+h[b+3048>>3];i=i;return}function $1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14192>>3]=+h[b+1520>>3]*+h[b+3048>>3];i=i;return}function a2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14184>>3]=+h[b+1512>>3]*+h[b+3048>>3];i=i;return}function b2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14176>>3]=+h[b+1504>>3]*+h[b+3048>>3];i=i;return}function c2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14168>>3]=+h[b+1496>>3]*+h[b+3048>>3];i=i;return}function d2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14160>>3]=+h[b+1488>>3]*+h[b+3048>>3];i=i;return}function e2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14152>>3]=+h[b+1480>>3]*+h[b+3048>>3];i=i;return}function f2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14144>>3]=+h[b+1472>>3]*+h[b+3048>>3];i=i;return}function g2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14136>>3]=+h[b+1784>>3]*+h[b+1624>>3]*+h[b+2968>>3];i=i;return}function h2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14128>>3]=+h[b+1776>>3]*+h[b+1616>>3]*+h[b+2968>>3];i=i;return}function i2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14120>>3]=+h[b+1768>>3]*+h[b+1608>>3]*+h[b+2968>>3];i=i;return}function j2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14112>>3]=+h[b+1760>>3]*+h[b+1600>>3]*+h[b+2968>>3];i=i;return}function k2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14104>>3]=+h[b+1752>>3]*+h[b+1592>>3]*+h[b+2968>>3];i=i;return}function l2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14096>>3]=+h[b+1744>>3]*+h[b+1584>>3]*+h[b+2968>>3];i=i;return}function m2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14088>>3]=+h[b+1736>>3]*+h[b+1576>>3]*+h[b+2968>>3];i=i;return}function n2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14080>>3]=+h[b+1728>>3]*+h[b+1568>>3]*+h[b+2968>>3];i=i;return}function o2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14072>>3]=+h[b+1720>>3]*+h[b+1560>>3]*+h[b+2968>>3];i=i;return}function p2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14064>>3]=+h[b+1712>>3]*+h[b+1552>>3]*+h[b+2968>>3];i=i;return}function q2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14056>>3]=+h[b+1704>>3]*+h[b+1544>>3]*+h[b+2968>>3];i=i;return}function r2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14048>>3]=+h[b+1696>>3]*+h[b+1536>>3]*+h[b+2968>>3];i=i;return}function s2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14040>>3]=+h[b+1688>>3]*+h[b+1528>>3]*+h[b+2968>>3];i=i;return}function t2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14032>>3]=+h[b+1680>>3]*+h[b+1520>>3]*+h[b+2968>>3];i=i;return}function u2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14024>>3]=+h[b+1672>>3]*+h[b+1512>>3]*+h[b+2968>>3];i=i;return}function v2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14016>>3]=+h[b+1664>>3]*+h[b+1504>>3]*+h[b+2968>>3];i=i;return}function w2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14008>>3]=+h[b+1656>>3]*+h[b+1496>>3]*+h[b+2968>>3];i=i;return}function x2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14e3>>3]=+h[b+1648>>3]*+h[b+1488>>3]*+h[b+2968>>3];i=i;return}function y2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13992>>3]=+h[b+1640>>3]*+h[b+1480>>3]*+h[b+2968>>3];i=i;return}function z2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13984>>3]=+h[b+1632>>3]*+h[b+1472>>3]*+h[b+2968>>3];i=i;return}function A2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13656>>3]=+h[b+496>>3]*+h[b+2816>>3];i=i;return}function B2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13648>>3]=+h[b+488>>3]*+h[b+2816>>3];i=i;return}function C2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13640>>3]=+h[b+480>>3]*+h[b+2816>>3];i=i;return}function D2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13632>>3]=+h[b+472>>3]*+h[b+2816>>3];i=i;return}function E2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13624>>3]=+h[b+464>>3]*+h[b+2816>>3];i=i;return}function F2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13616>>3]=+h[b+456>>3]*+h[b+2816>>3];i=i;return}function G2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13608>>3]=+h[b+448>>3]*+h[b+2816>>3];i=i;return}function H2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13600>>3]=+h[b+440>>3]*+h[b+2816>>3];i=i;return}function I2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13592>>3]=+h[b+432>>3]*+h[b+2816>>3];i=i;return}function J2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13584>>3]=+h[b+424>>3]*+h[b+2816>>3];i=i;return}function K2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13576>>3]=+h[b+416>>3]*+h[b+2816>>3];i=i;return}function L2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13568>>3]=+h[b+408>>3]*+h[b+2816>>3];i=i;return}function M2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13560>>3]=+h[b+400>>3]*+h[b+2816>>3];i=i;return}function N2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13552>>3]=+h[b+392>>3]*+h[b+2816>>3];i=i;return}function O2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13544>>3]=+h[b+384>>3]*+h[b+2816>>3];i=i;return}function P2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13536>>3]=+h[b+376>>3]*+h[b+2816>>3];i=i;return}function Q2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13528>>3]=+h[b+368>>3]*+h[b+2816>>3];i=i;return}function R2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13520>>3]=+h[b+360>>3]*+h[b+2816>>3];i=i;return}function S2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13512>>3]=+h[b+352>>3]*+h[b+2816>>3];i=i;return}function T2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13504>>3]=+h[b+344>>3]*+h[b+2816>>3];i=i;return}function U2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13496>>3]=+h[b+656>>3]*+h[b+496>>3]*+h[b+2736>>3];i=i;return}function V2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13488>>3]=+h[b+648>>3]*+h[b+488>>3]*+h[b+2736>>3];i=i;return}function W2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13480>>3]=+h[b+640>>3]*+h[b+480>>3]*+h[b+2736>>3];i=i;return}function X2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13472>>3]=+h[b+632>>3]*+h[b+472>>3]*+h[b+2736>>3];i=i;return}function Y2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13464>>3]=+h[b+624>>3]*+h[b+464>>3]*+h[b+2736>>3];i=i;return}function Z2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13456>>3]=+h[b+616>>3]*+h[b+456>>3]*+h[b+2736>>3];i=i;return}function _2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13448>>3]=+h[b+608>>3]*+h[b+448>>3]*+h[b+2736>>3];i=i;return}function $2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13440>>3]=+h[b+600>>3]*+h[b+440>>3]*+h[b+2736>>3];i=i;return}function a3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13432>>3]=+h[b+592>>3]*+h[b+432>>3]*+h[b+2736>>3];i=i;return}function b3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13424>>3]=+h[b+584>>3]*+h[b+424>>3]*+h[b+2736>>3];i=i;return}function c3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13416>>3]=+h[b+576>>3]*+h[b+416>>3]*+h[b+2736>>3];i=i;return}function d3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13408>>3]=+h[b+568>>3]*+h[b+408>>3]*+h[b+2736>>3];i=i;return}function e3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13400>>3]=+h[b+560>>3]*+h[b+400>>3]*+h[b+2736>>3];i=i;return}function f3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13392>>3]=+h[b+552>>3]*+h[b+392>>3]*+h[b+2736>>3];i=i;return}function g3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13384>>3]=+h[b+544>>3]*+h[b+384>>3]*+h[b+2736>>3];i=i;return}function h3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13376>>3]=+h[b+536>>3]*+h[b+376>>3]*+h[b+2736>>3];i=i;return}function i3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13368>>3]=+h[b+528>>3]*+h[b+368>>3]*+h[b+2736>>3];i=i;return}function j3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13360>>3]=+h[b+520>>3]*+h[b+360>>3]*+h[b+2736>>3];i=i;return}function k3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13352>>3]=+h[b+512>>3]*+h[b+352>>3]*+h[b+2736>>3];i=i;return}function l3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13344>>3]=+h[b+504>>3]*+h[b+344>>3]*+h[b+2736>>3];i=i;return}function m3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13176>>3]=(+h[b+664>>3]+ +h[b+672>>3])*.5;i=i;return}function n3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13168>>3]=(+h[b+672>>3]+ +h[b+680>>3])*.5;i=i;return}function o3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13160>>3]=(+h[b+680>>3]+ +h[b+688>>3])*.5;i=i;return}function p3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13152>>3]=(+h[b+688>>3]+ +h[b+696>>3])*.5;i=i;return}function q3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13144>>3]=(+h[b+696>>3]+ +h[b+704>>3])*.5;i=i;return}function r3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13136>>3]=(+h[b+704>>3]+ +h[b+712>>3])*.5;i=i;return}function s3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13128>>3]=(+h[b+712>>3]+ +h[b+720>>3])*.5;i=i;return}function t3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13120>>3]=(+h[b+720>>3]+ +h[b+728>>3])*.5;i=i;return}function u3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13112>>3]=(+h[b+728>>3]+ +h[b+736>>3])*.5;i=i;return}function v3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13104>>3]=(+h[b+736>>3]+ +h[b+744>>3])*.5;i=i;return}function w3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13096>>3]=(+h[b+744>>3]+ +h[b+752>>3])*.5;i=i;return}function x3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13088>>3]=(+h[b+752>>3]+ +h[b+760>>3])*.5;i=i;return}function y3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13080>>3]=(+h[b+760>>3]+ +h[b+768>>3])*.5;i=i;return}function z3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13072>>3]=(+h[b+768>>3]+ +h[b+776>>3])*.5;i=i;return}function A3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13064>>3]=(+h[b+776>>3]+ +h[b+784>>3])*.5;i=i;return}function B3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13056>>3]=(+h[b+784>>3]+ +h[b+792>>3])*.5;i=i;return}function C3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13048>>3]=(+h[b+792>>3]+ +h[b+800>>3])*.5;i=i;return}function D3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13040>>3]=(+h[b+800>>3]+ +h[b+808>>3])*.5;i=i;return}function E3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13032>>3]=(+h[b+808>>3]+ +h[b+816>>3])*.5;i=i;return}function F3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13024>>3]=(+h[b+1792>>3]+ +h[b+1800>>3])*.5;i=i;return}function G3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13016>>3]=(+h[b+1800>>3]+ +h[b+1808>>3])*.5;i=i;return}function H3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13008>>3]=(+h[b+1808>>3]+ +h[b+1816>>3])*.5;i=i;return}function I3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13e3>>3]=(+h[b+1816>>3]+ +h[b+1824>>3])*.5;i=i;return}function J3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12992>>3]=(+h[b+1824>>3]+ +h[b+1832>>3])*.5;i=i;return}function K3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12984>>3]=(+h[b+1832>>3]+ +h[b+1840>>3])*.5;i=i;return}function L3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12976>>3]=(+h[b+1840>>3]+ +h[b+1848>>3])*.5;i=i;return}function M3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12968>>3]=(+h[b+1848>>3]+ +h[b+1856>>3])*.5;i=i;return}function N3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12960>>3]=(+h[b+1856>>3]+ +h[b+1864>>3])*.5;i=i;return}function O3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12952>>3]=(+h[b+1864>>3]+ +h[b+1872>>3])*.5;i=i;return}function P3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12944>>3]=(+h[b+1872>>3]+ +h[b+1880>>3])*.5;i=i;return}function Q3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12936>>3]=(+h[b+1880>>3]+ +h[b+1888>>3])*.5;i=i;return}function R3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12928>>3]=(+h[b+1888>>3]+ +h[b+1896>>3])*.5;i=i;return}function S3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12920>>3]=(+h[b+1896>>3]+ +h[b+1904>>3])*.5;i=i;return}function T3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12912>>3]=(+h[b+1904>>3]+ +h[b+1912>>3])*.5;i=i;return}function U3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12904>>3]=(+h[b+1912>>3]+ +h[b+1920>>3])*.5;i=i;return}function V3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12896>>3]=(+h[b+1920>>3]+ +h[b+1928>>3])*.5;i=i;return}function W3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12888>>3]=(+h[b+1928>>3]+ +h[b+1936>>3])*.5;i=i;return}function X3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12880>>3]=(+h[b+1936>>3]+ +h[b+1944>>3])*.5;i=i;return}function Y3(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;XE(e,c[g>>2]|0,1.0e5,280.0,0);j=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));aF(f,j,1.0e5,280.0,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14800>>3]=+h[f>>3];i=b;return}function Z3(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;XE(e,c[g>>2]|0,1.0e5,280.0,0);j=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));dF(f,j,1.0e5,280.0,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14792>>3]=+h[f>>3];i=b;return}function _3(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;XE(e,c[g>>2]|0,1.0e5,300.0,0);j=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));aF(f,j,1.0e5,300.0,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14776>>3]=+h[f>>3];i=b;return}function $3(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;XE(e,c[g>>2]|0,1.0e5,300.0,0);j=c[g>>2]|0;g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));dF(f,j,1.0e5,300.0,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14768>>3]=+h[f>>3];i=b;return}function a4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12872>>3]=0.0;i=i;return}function b4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12864>>3]=0.0;i=i;return}function c4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12856>>3]=0.0;i=i;return}function d4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12848>>3]=0.0;i=i;return}function e4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12840>>3]=0.0;i=i;return}function f4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12832>>3]=0.0;i=i;return}function g4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12824>>3]=0.0;i=i;return}function h4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12816>>3]=0.0;i=i;return}function i4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12808>>3]=0.0;i=i;return}function j4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12800>>3]=0.0;i=i;return}function k4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12792>>3]=0.0;i=i;return}function l4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12784>>3]=0.0;i=i;return}function m4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12776>>3]=0.0;i=i;return}function n4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12768>>3]=0.0;i=i;return}function o4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12760>>3]=0.0;i=i;return}function p4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12752>>3]=0.0;i=i;return}function q4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12744>>3]=0.0;i=i;return}function r4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12736>>3]=0.0;i=i;return}function s4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12728>>3]=0.0;i=i;return}function t4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12720>>3]=0.0;i=i;return}function u4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12712>>3]=0.0;i=i;return}function v4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12704>>3]=0.0;i=i;return}function w4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12696>>3]=0.0;i=i;return}function x4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12688>>3]=0.0;i=i;return}function y4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12680>>3]=0.0;i=i;return}function z4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12672>>3]=0.0;i=i;return}function A4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12664>>3]=0.0;i=i;return}function B4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12656>>3]=0.0;i=i;return}function C4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12648>>3]=0.0;i=i;return}function D4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12640>>3]=0.0;i=i;return}function E4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12632>>3]=0.0;i=i;return}function F4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12624>>3]=0.0;i=i;return}function G4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12616>>3]=0.0;i=i;return}function H4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12608>>3]=0.0;i=i;return}function I4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12600>>3]=0.0;i=i;return}function J4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12592>>3]=0.0;i=i;return}function K4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12584>>3]=0.0;i=i;return}function L4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12576>>3]=0.0;i=i;return}function M4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12568>>3]=0.0;i=i;return}function N4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12560>>3]=0.0;i=i;return}function O4(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+14776>>3];k=+h[g+14768>>3];if(k!=0.0){l=k;m=g;n=-1.0e5/l;o=j+n;p=m;q=p+14752|0;r=q;h[r>>3]=o;i=d;return}s=+qXa(c[b+536>>2]|0,k,56704,56696,+h[f>>3],(a[b+319|0]|0)!=0|0);l=s;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=-1.0e5/l;o=j+n;p=m;q=p+14752|0;r=q;h[r>>3]=o;i=d;return}function P4(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+14800>>3];k=+h[g+14792>>3];if(k!=0.0){l=k;m=g;n=-1.0e5/l;o=j+n;p=m;q=p+14744|0;r=q;h[r>>3]=o;i=d;return}s=+qXa(c[b+536>>2]|0,k,56736,56728,+h[f>>3],(a[b+319|0]|0)!=0|0);l=s;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=-1.0e5/l;o=j+n;p=m;q=p+14744|0;r=q;h[r>>3]=o;i=d;return}function Q4(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;iF(e,c[g>>2]|0,1.0e5,+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+14800>>3],0,0);a=c[g>>2]|0;k=+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+14800>>3];g=d+0|0;l=e+0|0;e=g+120|0;do{c[g>>2]=c[l>>2];g=g+4|0;l=l+4|0}while((g|0)<(e|0));gF(f,a,1.0e5,k,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12392>>3]=+h[f>>3];i=b;return}function R4(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;iF(e,c[g>>2]|0,1.0e5,+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+14800>>3],0,0);a=c[g>>2]|0;k=+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+14800>>3];g=d+0|0;l=e+0|0;e=g+120|0;do{c[g>>2]=c[l>>2];g=g+4|0;l=l+4|0}while((g|0)<(e|0));_E(f,a,1.0e5,k,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12384>>3]=+h[f>>3];i=b;return}function S4(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;iF(e,c[g>>2]|0,1.0e5,+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+14776>>3],0,0);a=c[g>>2]|0;k=+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+14776>>3];g=d+0|0;l=e+0|0;e=g+120|0;do{c[g>>2]=c[l>>2];g=g+4|0;l=l+4|0}while((g|0)<(e|0));gF(f,a,1.0e5,k,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12376>>3]=+h[f>>3];i=b;return}function T4(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;iF(e,c[g>>2]|0,1.0e5,+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+14776>>3],0,0);a=c[g>>2]|0;k=+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+14776>>3];g=d+0|0;l=e+0|0;e=g+120|0;do{c[g>>2]=c[l>>2];g=g+4|0;l=l+4|0}while((g|0)<(e|0));_E(f,a,1.0e5,k,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12208>>3]=+h[f>>3];i=b;return}



function WRa(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;m=i;i=i+8|0;n=m;o=c[l>>2]|0;l=~o;c[n>>2]=0;p=c[a>>2]|0;do{if((p|0)<0){c[n>>2]=1}else{q=c[b>>2]|0;if((q|0)<0){c[n>>2]=2;break}r=c[f>>2]|0;if((r|0)==0){c[n>>2]=5;break}s=c[j>>2]|0;if((s|0)==0){c[n>>2]=7;break}if((o|0)<(((p|0)>1?p:1)|0)){c[n>>2]=9;break}if((p|0)==0|(q|0)==0){i=m;return 0}if(+h[d>>3]==0.0){i=m;return 0}if((s|0)>0){t=1}else{t=1-(fa(s,q+ -1|0)|0)|0}if((r|0)==1){if((q|0)<1){i=m;return 0}else{u=s;v=1;w=t}while(1){x=+h[g+(w+ -1<<3)>>3];do{if(x!=0.0){y=x*+h[d>>3];z=c[a>>2]|0;if((z|0)<1){A=u;break}B=(fa(v,o)|0)+l|0;C=1;do{D=k+(B+C<<3)|0;h[D>>3]=+h[D>>3]+y*+h[e+(C+ -1<<3)>>3];C=C+1|0;}while((C|0)<=(z|0));A=c[j>>2]|0}else{A=u}}while(0);z=v+1|0;if((z|0)>(q|0)){break}else{u=A;v=z;w=A+w|0}}i=m;return 0}if((r|0)>0){E=1}else{E=1-(fa(p+ -1|0,r)|0)|0}if((q|0)<1){i=m;return 0}else{F=s;G=1;H=t}while(1){x=+h[g+(H+ -1<<3)>>3];do{if(x!=0.0){y=x*+h[d>>3];z=c[a>>2]|0;if((z|0)<1){I=F;break}C=(fa(G,o)|0)+l|0;B=1;D=E;while(1){J=k+(C+B<<3)|0;h[J>>3]=+h[J>>3]+y*+h[e+(D+ -1<<3)>>3];J=B+1|0;if((J|0)>(z|0)){break}else{D=(c[f>>2]|0)+D|0;B=J}}I=c[j>>2]|0}else{I=F}}while(0);B=G+1|0;if((B|0)>(q|0)){break}else{F=I;G=B;H=I+H|0}}i=m;return 0}}while(0);Db(228792,n|0)|0;i=m;return 0}function XRa(a,b,d,e,f,g,j,k,l,m,n,o,p){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0.0,U=0.0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0,da=0;q=i;i=i+8|0;r=q;s=c[k>>2]|0;t=~s;u=c[m>>2]|0;v=~u;w=c[p>>2]|0;x=~w;y=wZa(a,228800)|0;z=wZa(b,228800)|0;A=(y|0)!=0;y=c[(A?d:f)>>2]|0;B=(z|0)!=0;z=c[(B?f:e)>>2]|0;c[r>>2]=0;do{if(A){C=5}else{if((wZa(a,228808)|0)!=0){C=5;break}if((wZa(a,228816)|0)!=0){C=5;break}c[r>>2]=1}}while(0);a:do{if((C|0)==5){do{if(!B){if((wZa(b,228808)|0)!=0){break}if((wZa(b,228816)|0)!=0){break}c[r>>2]=2;break a}}while(0);a=c[d>>2]|0;if((a|0)<0){c[r>>2]=3;break}D=c[e>>2]|0;if((D|0)<0){c[r>>2]=4;break}E=c[f>>2]|0;if((E|0)<0){c[r>>2]=5;break}if((c[k>>2]|0)<(((y|0)>1?y:1)|0)){c[r>>2]=8;break}if((c[m>>2]|0)<(((z|0)>1?z:1)|0)){c[r>>2]=10;break}if((c[p>>2]|0)<(((a|0)>1?a:1)|0)){c[r>>2]=13;break}if((c[r>>2]|0)!=0){break}if((a|0)==0|(D|0)==0){i=q;return 0}F=+h[g>>3]==0.0;do{if(F|(E|0)==0){if(+h[n>>3]==1.0){i=q;return 0}if(!F){break}G=(D|0)<1;if(+h[n>>3]==0.0){if(G){i=q;return 0}else{H=a;I=0;J=2}while(1){if((H|0)>=1){Cqb(o+((fa(w,I)|0)<<3)|0,0,H<<3|0)|0}if((J|0)>(D|0)){break}H=c[d>>2]|0;I=I+1|0;J=J+1|0}i=q;return 0}if(G){i=q;return 0}else{K=a;L=1}while(1){if((K|0)>=1){M=(fa(L,w)|0)+x|0;N=1;do{O=o+(M+N<<3)|0;h[O>>3]=+h[n>>3]*+h[O>>3];N=N+1|0;}while((N|0)<=(K|0))}N=L+1|0;if((N|0)>(D|0)){break}K=c[d>>2]|0;L=N}i=q;return 0}}while(0);F=(D|0)<1;if(B){if(!A){if(F){i=q;return 0}else{P=a;Q=1}while(1){if((P|0)>=1){E=(fa(Q,w)|0)+x|0;G=(fa(Q,u)|0)+v|0;N=1;do{M=c[f>>2]|0;if((M|0)<1){R=0.0}else{O=(fa(N,s)|0)+t|0;S=1;T=0.0;while(1){U=T+ +h[j+(O+S<<3)>>3]*+h[l+(G+S<<3)>>3];V=S+1|0;if((V|0)>(M|0)){R=U;break}else{T=U;S=V}}}T=+h[n>>3];U=R*+h[g>>3];S=o+(E+N<<3)|0;if(T==0.0){W=U}else{W=U+T*+h[S>>3]}h[S>>3]=W;N=N+1|0;}while((N|0)<=(P|0))}N=Q+1|0;if((N|0)>(D|0)){break}P=c[d>>2]|0;Q=N}i=q;return 0}if(F){i=q;return 0}else{X=0;Y=1}while(1){N=o+((fa(w,X)|0)<<3)|0;T=+h[n>>3];b:do{if(T==0.0){E=c[d>>2]|0;if((E|0)<1){break}Cqb(N|0,0,E<<3|0)|0}else{if(!(T!=1.0)){break}E=c[d>>2]|0;if((E|0)<1){break}G=(fa(Y,w)|0)+x|0;U=T;S=1;while(1){M=o+(G+S<<3)|0;h[M>>3]=U*+h[M>>3];M=S+1|0;if((M|0)>(E|0)){break b}U=+h[n>>3];S=M}}}while(0);N=c[f>>2]|0;if((N|0)>=1){S=(fa(Y,u)|0)+v|0;E=(fa(Y,w)|0)+x|0;G=1;do{T=+h[l+(S+G<<3)>>3];do{if(T!=0.0){U=T*+h[g>>3];M=c[d>>2]|0;if((M|0)<1){break}O=(fa(G,s)|0)+t|0;V=1;do{Z=o+(E+V<<3)|0;h[Z>>3]=+h[Z>>3]+U*+h[j+(O+V<<3)>>3];V=V+1|0;}while((V|0)<=(M|0))}}while(0);G=G+1|0;}while((G|0)<=(N|0))}N=Y+1|0;if((N|0)>(D|0)){break}X=X+1|0;Y=N}i=q;return 0}else{if(!A){if(F){i=q;return 0}else{_=a;$=1}while(1){if((_|0)>=1){N=(fa($,w)|0)+x|0;G=$+v|0;E=1;do{S=c[f>>2]|0;if((S|0)<1){aa=0.0}else{M=(fa(E,s)|0)+t|0;V=1;T=0.0;while(1){U=T+ +h[j+(M+V<<3)>>3]*+h[l+(G+(fa(V,u)|0)<<3)>>3];O=V+1|0;if((O|0)>(S|0)){aa=U;break}else{T=U;V=O}}}T=+h[n>>3];U=aa*+h[g>>3];V=o+(N+E<<3)|0;if(T==0.0){ba=U}else{ba=U+T*+h[V>>3]}h[V>>3]=ba;E=E+1|0;}while((E|0)<=(_|0))}E=$+1|0;if((E|0)>(D|0)){break}_=c[d>>2]|0;$=E}i=q;return 0}if(F){i=q;return 0}else{ca=0;da=1}while(1){a=o+((fa(w,ca)|0)<<3)|0;T=+h[n>>3];c:do{if(T==0.0){E=c[d>>2]|0;if((E|0)<1){break}Cqb(a|0,0,E<<3|0)|0}else{if(!(T!=1.0)){break}E=c[d>>2]|0;if((E|0)<1){break}N=(fa(da,w)|0)+x|0;U=T;G=1;while(1){V=o+(N+G<<3)|0;h[V>>3]=U*+h[V>>3];V=G+1|0;if((V|0)>(E|0)){break c}U=+h[n>>3];G=V}}}while(0);a=c[f>>2]|0;if((a|0)>=1){G=da+v|0;E=(fa(da,w)|0)+x|0;N=1;do{T=+h[l+(G+(fa(N,u)|0)<<3)>>3];do{if(T!=0.0){U=T*+h[g>>3];V=c[d>>2]|0;if((V|0)<1){break}S=(fa(N,s)|0)+t|0;M=1;do{O=o+(E+M<<3)|0;h[O>>3]=+h[O>>3]+U*+h[j+(S+M<<3)>>3];M=M+1|0;}while((M|0)<=(V|0))}}while(0);N=N+1|0;}while((N|0)<=(a|0))}a=da+1|0;if((a|0)>(D|0)){break}ca=ca+1|0;da=a}i=q;return 0}}}while(0);Db(228824,r|0)|0;i=q;return 0}function YRa(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0.0,O=0,P=0,Q=0.0,R=0,S=0.0,T=0.0,U=0,V=0.0,W=0,X=0.0,Y=0,Z=0,_=0;o=i;i=i+8|0;p=o;q=c[l>>2]|0;r=~q;s=c[n>>2]|0;t=~s;u=(wZa(a,228832)|0)!=0;v=c[(u?f:g)>>2]|0;w=wZa(e,228840)|0;x=wZa(b,228848)|0;c[p>>2]=0;do{if(u){y=4}else{if((wZa(a,228856)|0)!=0){y=4;break}c[p>>2]=1}}while(0);a:do{if((y|0)==4){do{if((x|0)==0){if((wZa(b,228832)|0)!=0){break}c[p>>2]=2;break a}}while(0);do{if((wZa(d,228840)|0)==0){if((wZa(d,228864)|0)!=0){break}if((wZa(d,228872)|0)!=0){break}c[p>>2]=3;break a}}while(0);do{if((wZa(e,228848)|0)==0){if((wZa(e,228840)|0)!=0){break}c[p>>2]=4;break a}}while(0);a=c[f>>2]|0;if((a|0)<0){c[p>>2]=5;break}z=c[g>>2]|0;if((z|0)<0){c[p>>2]=6;break}if((c[l>>2]|0)<(((v|0)>1?v:1)|0)){c[p>>2]=9;break}if((c[n>>2]|0)<(((a|0)>1?a:1)|0)){c[p>>2]=11;break}if((c[p>>2]|0)!=0){break}if((a|0)==0|(z|0)==0){i=o;return 0}if(+h[j>>3]==0.0){if((z|0)<1){i=o;return 0}else{A=a;B=0;C=2}while(1){if((A|0)>=1){Cqb(m+((fa(s,B)|0)<<3)|0,0,A<<3|0)|0}if((C|0)>(z|0)){break}A=c[f>>2]|0;B=B+1|0;C=C+1|0}i=o;return 0}z=(wZa(d,228840)|0)!=0;a=(x|0)!=0;D=c[g>>2]|0;if(u){E=(D|0)<1;if(!z){if(a){if(E){i=o;return 0}F=(w|0)==0;G=1;do{H=c[f>>2]|0;if((H|0)>=1){I=(fa(G,s)|0)+t|0;J=1;do{K=m+(I+J<<3)|0;L=+h[j>>3]*+h[K>>3];M=J+ -1|0;if((M|0)<1){N=L}else{O=(fa(J,q)|0)+r|0;P=1;Q=L;while(1){L=Q- +h[k+(O+P<<3)>>3]*+h[m+(I+P<<3)>>3];R=P+1|0;if((R|0)>(M|0)){N=L;break}else{Q=L;P=R}}}if(F){S=N}else{S=N/+h[k+(J+r+(fa(J,q)|0)<<3)>>3]}h[K>>3]=S;J=J+1|0;}while((J|0)<=(H|0))}G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}if(E){i=o;return 0}G=(w|0)==0;F=1;do{H=c[f>>2]|0;b:do{if((H|0)>0){J=(fa(F,s)|0)+t|0;I=H;P=H;while(1){M=m+(J+P<<3)|0;Q=+h[j>>3]*+h[M>>3];O=P+1|0;if((O|0)>(I|0)){T=Q}else{R=(fa(P,q)|0)+r|0;U=O;L=Q;while(1){Q=L- +h[k+(R+U<<3)>>3]*+h[m+(J+U<<3)>>3];O=U+1|0;if((O|0)>(I|0)){T=Q;break}else{L=Q;U=O}}}if(G){V=T}else{V=T/+h[k+(P+r+(fa(P,q)|0)<<3)>>3]}h[M>>3]=V;U=P+ -1|0;if((U|0)<=0){break b}I=c[f>>2]|0;P=U}}}while(0);F=F+1|0;}while((F|0)<=(D|0));i=o;return 0}if(a){if(E){i=o;return 0}F=(w|0)==0;G=1;do{L=+h[j>>3];c:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}P=(fa(G,s)|0)+t|0;Q=L;I=1;while(1){J=m+(P+I<<3)|0;h[J>>3]=Q*+h[J>>3];J=I+1|0;if((J|0)>(H|0)){y=43;break c}Q=+h[j>>3];I=J}}else{y=43}}while(0);d:do{if((y|0)==43){y=0;I=c[f>>2]|0;if((I|0)<=0){break}H=(fa(G,s)|0)+t|0;if(F){P=I;while(1){J=m+(H+P<<3)|0;L=+h[J>>3];K=P+ -1|0;e:do{if(L!=0.0){if((K|0)<1){break d}U=(fa(P,q)|0)+r|0;Q=L;R=1;while(1){O=m+(H+R<<3)|0;h[O>>3]=+h[O>>3]-Q*+h[k+(U+R<<3)>>3];O=R+1|0;if((O|0)>(K|0)){break e}Q=+h[J>>3];R=O}}}while(0);if((K|0)>0){P=K}else{break d}}}else{W=I}while(1){P=m+(H+W<<3)|0;L=+h[P>>3];f:do{if(L!=0.0){Q=L/+h[k+(W+r+(fa(W,q)|0)<<3)>>3];h[P>>3]=Q;J=W+ -1|0;if((J|0)<1){break d}M=(fa(W,q)|0)+r|0;X=Q;R=1;while(1){U=m+(H+R<<3)|0;h[U>>3]=+h[U>>3]-X*+h[k+(M+R<<3)>>3];U=R+1|0;if((U|0)>(J|0)){Y=J;break f}X=+h[P>>3];R=U}}else{Y=W+ -1|0}}while(0);if((Y|0)>0){W=Y}else{break}}}}while(0);G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}if(E){i=o;return 0}G=(w|0)==0;F=1;do{L=+h[j>>3];g:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}I=(fa(F,s)|0)+t|0;X=L;P=1;while(1){K=m+(I+P<<3)|0;h[K>>3]=X*+h[K>>3];K=P+1|0;if((K|0)>(H|0)){y=64;break g}X=+h[j>>3];P=K}}else{y=64}}while(0);do{if((y|0)==64){y=0;P=c[f>>2]|0;if((P|0)<1){break}H=(fa(F,s)|0)+t|0;if(G){I=1;while(1){K=m+(H+I<<3)|0;L=+h[K>>3];h:do{if(L!=0.0){R=c[f>>2]|0;J=I+1|0;if((J|0)>(R|0)){Z=J;break}M=(fa(I,q)|0)+r|0;X=L;U=J;while(1){O=m+(H+U<<3)|0;h[O>>3]=+h[O>>3]-X*+h[k+(M+U<<3)>>3];O=U+1|0;if((O|0)>(R|0)){Z=J;break h}X=+h[K>>3];U=O}}else{Z=I+1|0}}while(0);if((Z|0)>(P|0)){break}else{I=Z}}}else{I=1;while(1){K=m+(H+I<<3)|0;L=+h[K>>3];i:do{if(L!=0.0){X=L/+h[k+(I+r+(fa(I,q)|0)<<3)>>3];h[K>>3]=X;U=c[f>>2]|0;J=I+1|0;if((J|0)>(U|0)){_=J;break}R=(fa(I,q)|0)+r|0;Q=X;M=J;while(1){O=m+(H+M<<3)|0;h[O>>3]=+h[O>>3]-Q*+h[k+(R+M<<3)>>3];O=M+1|0;if((O|0)>(U|0)){_=J;break i}Q=+h[K>>3];M=O}}else{_=I+1|0}}while(0);if((_|0)>(P|0)){break}else{I=_}}}}}while(0);F=F+1|0;}while((F|0)<=(D|0));i=o;return 0}if(!z){if(a){if((D|0)<=0){i=o;return 0}F=(w|0)==0;G=D;while(1){do{if(!F){L=1.0/+h[k+(G+r+(fa(G,q)|0)<<3)>>3];E=c[f>>2]|0;if((E|0)<1){break}I=(fa(G,s)|0)+t|0;P=1;do{H=m+(I+P<<3)|0;h[H>>3]=L*+h[H>>3];P=P+1|0;}while((P|0)<=(E|0))}}while(0);E=G+ -1|0;if((E|0)>=1){P=(fa(G,q)|0)+r|0;I=(fa(G,s)|0)+t|0;H=1;do{L=+h[k+(P+H<<3)>>3];do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}M=(fa(H,s)|0)+t|0;J=1;do{U=m+(M+J<<3)|0;h[U>>3]=+h[U>>3]-L*+h[m+(I+J<<3)>>3];J=J+1|0;}while((J|0)<=(K|0))}}while(0);H=H+1|0;}while((H|0)<=(E|0))}L=+h[j>>3];j:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}I=(fa(G,s)|0)+t|0;Q=L;P=1;while(1){K=m+(I+P<<3)|0;h[K>>3]=Q*+h[K>>3];K=P+1|0;if((K|0)>(H|0)){break j}Q=+h[j>>3];P=K}}}while(0);if((E|0)>0){G=E}else{break}}i=o;return 0}else{if((D|0)<1){i=o;return 0}G=(w|0)==0;F=1;while(1){do{if(!G){L=1.0/+h[k+(F+r+(fa(F,q)|0)<<3)>>3];z=c[f>>2]|0;if((z|0)<1){break}P=(fa(F,s)|0)+t|0;H=1;do{I=m+(P+H<<3)|0;h[I>>3]=L*+h[I>>3];H=H+1|0;}while((H|0)<=(z|0))}}while(0);E=c[g>>2]|0;z=F+1|0;if((z|0)<=(E|0)){H=(fa(F,q)|0)+r|0;P=(fa(F,s)|0)+t|0;I=z;do{L=+h[k+(H+I<<3)>>3];do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}J=(fa(I,s)|0)+t|0;M=1;do{U=m+(J+M<<3)|0;h[U>>3]=+h[U>>3]-L*+h[m+(P+M<<3)>>3];M=M+1|0;}while((M|0)<=(K|0))}}while(0);I=I+1|0;}while((I|0)<=(E|0))}L=+h[j>>3];k:do{if(L!=1.0){E=c[f>>2]|0;if((E|0)<1){break}I=(fa(F,s)|0)+t|0;Q=L;P=1;while(1){H=m+(I+P<<3)|0;h[H>>3]=Q*+h[H>>3];H=P+1|0;if((H|0)>(E|0)){break k}Q=+h[j>>3];P=H}}}while(0);if((z|0)>(D|0)){break}else{F=z}}i=o;return 0}}if(a){if((D|0)<1){i=o;return 0}F=(w|0)==0;G=1;do{L=+h[j>>3];l:do{if(L!=1.0){P=c[f>>2]|0;if((P|0)<1){break}E=(fa(G,s)|0)+t|0;Q=L;I=1;while(1){H=m+(E+I<<3)|0;h[H>>3]=Q*+h[H>>3];H=I+1|0;if((H|0)>(P|0)){break l}Q=+h[j>>3];I=H}}}while(0);z=G+ -1|0;if((z|0)>=1){I=(fa(G,q)|0)+r|0;P=(fa(G,s)|0)+t|0;E=1;do{H=k+(I+E<<3)|0;L=+h[H>>3];m:do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}M=(fa(E,s)|0)+t|0;Q=L;J=1;while(1){U=m+(P+J<<3)|0;h[U>>3]=+h[U>>3]-Q*+h[m+(M+J<<3)>>3];U=J+1|0;if((U|0)>(K|0)){break m}Q=+h[H>>3];J=U}}}while(0);E=E+1|0;}while((E|0)<=(z|0))}do{if(!F){L=1.0/+h[k+(G+r+(fa(G,q)|0)<<3)>>3];z=c[f>>2]|0;if((z|0)<1){break}E=(fa(G,s)|0)+t|0;P=1;do{I=m+(E+P<<3)|0;h[I>>3]=L*+h[I>>3];P=P+1|0;}while((P|0)<=(z|0))}}while(0);G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}else{if((D|0)<=0){i=o;return 0}G=(w|0)==0;F=D;do{L=+h[j>>3];n:do{if(L!=1.0){a=c[f>>2]|0;if((a|0)<1){break}z=(fa(F,s)|0)+t|0;Q=L;P=1;while(1){E=m+(z+P<<3)|0;h[E>>3]=Q*+h[E>>3];E=P+1|0;if((E|0)>(a|0)){break n}Q=+h[j>>3];P=E}}}while(0);P=c[g>>2]|0;a=F+1|0;if((a|0)<=(P|0)){z=(fa(F,q)|0)+r|0;E=(fa(F,s)|0)+t|0;I=a;do{a=k+(z+I<<3)|0;L=+h[a>>3];o:do{if(L!=0.0){H=c[f>>2]|0;if((H|0)<1){break}J=(fa(I,s)|0)+t|0;Q=L;K=1;while(1){M=m+(E+K<<3)|0;h[M>>3]=+h[M>>3]-Q*+h[m+(J+K<<3)>>3];M=K+1|0;if((M|0)>(H|0)){break o}Q=+h[a>>3];K=M}}}while(0);I=I+1|0;}while((I|0)<=(P|0))}do{if(!G){L=1.0/+h[k+(F+r+(fa(F,q)|0)<<3)>>3];P=c[f>>2]|0;if((P|0)<1){break}I=(fa(F,s)|0)+t|0;E=1;do{z=m+(I+E<<3)|0;h[z>>3]=L*+h[z>>3];E=E+1|0;}while((E|0)<=(P|0))}}while(0);F=F+ -1|0;}while((F|0)>0);i=o;return 0}}}while(0);Db(228880,p|0)|0;i=o;return 0}function ZRa(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;k=i;i=i+8|0;l=k;c[j>>2]=0;m=c[a>>2]|0;do{if((m|0)<0){c[j>>2]=-1;n=-1}else{if((c[b>>2]|0)<0){c[j>>2]=-2;n=-2;break}o=(m|0)>1?m:1;if((c[e>>2]|0)<(o|0)){c[j>>2]=-4;n=-4;break}if((c[h>>2]|0)<(o|0)){c[j>>2]=-7;n=-7;break}$Ra(a,a,d,e,f,j)|0;if((c[j>>2]|0)!=0){i=k;return 0}aSa(228896,a,b,d,e,f,g,h,j)|0;i=k;return 0}}while(0);c[l>>2]=0-n;Db(228888,l|0)|0;i=k;return 0}function _Ra(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0,I=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;o=c[e>>2]|0;p=~o;c[g>>2]=0;q=c[a>>2]|0;do{if((q|0)<0){c[g>>2]=-1;r=-1}else{s=c[b>>2]|0;if((s|0)<0){c[g>>2]=-2;r=-2;break}if((c[e>>2]|0)<(((q|0)>1?q:1)|0)){c[g>>2]=-4;r=-4;break}if((q|0)==0|(s|0)==0){i=j;return 0}t=+dZa(228920);s=c[a>>2]|0;u=c[b>>2]|0;v=(s|0)>(u|0)?u:s;c[k>>2]=v;if((v|0)<1){i=j;return 0}else{w=s;x=1}while(1){c[l>>2]=1-x+w;s=x+ -1|0;v=fa(x,o)|0;u=x+p|0;y=u+v|0;z=d+(y<<3)|0;A=s+(TRa(l,z,228928)|0)|0;c[f+(s<<2)>>2]=A;B=v+p|0;a:do{if(+h[d+(B+A<<3)>>3]!=0.0){if((A|0)!=(x|0)){VRa(b,d+(s<<3)|0,e,d+(A+ -1<<3)|0,e)|0}C=c[a>>2]|0;if((x|0)>=(C|0)){break}D=+h[z>>3];h[n>>3]=D;if(!(D>=0.0)){E=-D}else{E=D}F=C-x|0;c[l>>2]=F;if(E>=t){h[n>>3]=1.0/D;URa(l,n,d+(x-o+v<<3)|0,228928)|0;break}if((F|0)<1){break}else{G=D;H=1}while(1){C=d+(y+H<<3)|0;h[C>>3]=+h[C>>3]/G;C=H+1|0;if((C|0)>(F|0)){break a}G=+h[z>>3];H=C}}else{if((c[g>>2]|0)!=0){break}c[g>>2]=x}}while(0);z=c[a>>2]|0;y=c[b>>2]|0;if((x|0)<(((z|0)>(y|0)?y:z)|0)){c[l>>2]=z-x;c[m>>2]=y-x;y=x+1|0;z=fa(y,o)|0;WRa(l,m,228936,d+(B+y<<3)|0,228928,d+(u+z<<3)|0,e,d+(y+p+z<<3)|0,e)|0;I=y}else{I=x+1|0}if((I|0)>(c[k>>2]|0)){break}w=c[a>>2]|0;x=I}i=j;return 0}}while(0);c[k>>2]=0-r;Db(228912,k|0)|0;i=j;return 0}function $Ra(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;h=i;i=i+48|0;j=h;k=h+8|0;l=h+16|0;m=h+24|0;n=h+32|0;o=h+40|0;p=c[e>>2]|0;q=~p;c[g>>2]=0;r=c[a>>2]|0;do{if((r|0)<0){c[g>>2]=-1;s=-1}else{t=c[b>>2]|0;if((t|0)<0){c[g>>2]=-2;s=-2;break}if((c[e>>2]|0)<(((r|0)>1?r:1)|0)){c[g>>2]=-4;s=-4;break}if((r|0)==0|(t|0)==0){i=h;return 0}t=228968;u=cSa(228952,228944,228960,a,b,t,t)|0;do{if((u|0)>=2){t=c[a>>2]|0;v=c[b>>2]|0;w=(t|0)>(v|0)?v:t;if((u|0)>=(w|0)){break}c[j>>2]=w;c[m>>2]=1;if((w|0)>0){x=v;y=t;z=1}else{i=h;return 0}while(1){t=((y|0)>(x|0)?x:y)-z+1|0;c[n>>2]=(t|0)<=(u|0)?t:u;c[k>>2]=y+1-z;_Ra(k,n,d+(z+q+(fa(z,p)|0)<<3)|0,e,f+(z+ -1<<2)|0,o)|0;do{if((c[g>>2]|0)==0){t=c[o>>2]|0;if((t|0)<=0){break}c[g>>2]=t+ -1+(c[m>>2]|0)}}while(0);t=c[a>>2]|0;c[l>>2]=t;v=c[m>>2]|0;w=v+ -1|0;A=w+(c[n>>2]|0)|0;B=(t|0)<=(A|0)?t:A;c[k>>2]=B;if((v|0)<=(B|0)){t=v;do{v=f+(t+ -1<<2)|0;c[v>>2]=(c[v>>2]|0)+w;t=t+1|0;}while((t|0)<=(B|0))}c[k>>2]=w;c[l>>2]=A;bSa(k,d,e,m,l,f,228952)|0;B=c[m>>2]|0;t=c[n>>2]|0;v=t+B|0;C=c[b>>2]|0;do{if((v|0)>(C|0)){D=B}else{c[k>>2]=1-B-t+C;c[l>>2]=v+ -1;bSa(k,d+((fa(v,p)|0)-p<<3)|0,e,m,l,f,228952)|0;E=c[m>>2]|0;F=c[n>>2]|0;c[k>>2]=(c[b>>2]|0)+1-E-F;G=E+q|0;YRa(228976,228984,228992,229008,n,k,229016,d+(G+(fa(E,p)|0)<<3)|0,e,d+(G+(fa(F+E|0,p)|0)<<3)|0,e)|0;E=c[m>>2]|0;F=c[n>>2]|0;G=F+E|0;H=c[a>>2]|0;if((G|0)>(H|0)){D=E;break}c[k>>2]=1-E-F+H;c[l>>2]=(c[b>>2]|0)+1-E-F;F=fa(G,p)|0;H=228992;XRa(H,H,k,l,n,229024,d+((fa(E,p)|0)+q+G<<3)|0,e,d+(E+q+F<<3)|0,e,229016,d+(G+q+F<<3)|0,e)|0;D=c[m>>2]|0}}while(0);v=D+u|0;c[m>>2]=v;if((v|0)>(c[j>>2]|0)){break}x=c[b>>2]|0;y=c[a>>2]|0;z=v}i=h;return 0}}while(0);_Ra(a,b,d,e,f,g)|0;i=h;return 0}}while(0);c[j>>2]=0-s;Db(228944,j|0)|0;i=h;return 0}function aSa(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0;l=i;i=i+8|0;m=l;c[k>>2]=0;n=(wZa(a,229032)|0)!=0;do{if(n){o=5}else{if((wZa(a,229040)|0)!=0){o=5;break}if((wZa(a,229048)|0)!=0){o=5;break}c[k>>2]=-1;p=-1}}while(0);do{if((o|0)==5){a=c[b>>2]|0;if((a|0)<0){c[k>>2]=-2;p=-2;break}q=c[d>>2]|0;if((q|0)<0){c[k>>2]=-3;p=-3;break}r=(a|0)>1?a:1;if((c[f>>2]|0)<(r|0)){c[k>>2]=-5;p=-5;break}if((c[j>>2]|0)<(r|0)){c[k>>2]=-8;p=-8;break}r=c[k>>2]|0;if((r|0)!=0){p=r;break}if((a|0)==0|(q|0)==0){i=l;return 0}if(n){q=229064;bSa(d,h,j,q,b,g,q)|0;YRa(229072,229080,229088,229104,b,d,229112,e,f,h,j)|0;YRa(229072,229120,229088,229128,b,d,229112,e,f,h,j)|0;i=l;return 0}else{YRa(229072,229120,229144,229128,b,d,229112,e,f,h,j)|0;YRa(229072,229080,229144,229104,b,d,229112,e,f,h,j)|0;bSa(d,h,j,229064,b,g,229160)|0;i=l;return 0}}}while(0);c[m>>2]=0-p;Db(229056,m|0)|0;i=l;return 0}function bSa(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0;k=i;l=c[d>>2]|0;d=~l;m=c[j>>2]|0;do{if((m|0)>0){n=c[e>>2]|0;o=n;p=f;q=1;r=n}else{if((m|0)<0){n=c[f>>2]|0;o=n;p=e;q=-1;r=(fa(1-n|0,m)|0)+1|0;break}else{i=k;return 0}}}while(0);e=c[p>>2]|0;p=c[a>>2]|0;f=((p|0)/32|0)<<5;if((f|0)<1){s=m;t=p}else{p=(q|0)<0;n=p?(o|0)>=(e|0):(o|0)<=(e|0);u=m;m=1;while(1){if(n){v=m+31|0;if(p){w=u;x=o;y=r;while(1){z=c[g+(y+ -1<<2)>>2]|0;if((z|0)==(x|0)){A=w}else{B=x+d|0;C=z+d|0;z=m;do{D=fa(z,l)|0;E=b+(B+D<<3)|0;F=+h[E>>3];G=b+(C+D<<3)|0;h[E>>3]=+h[G>>3];h[G>>3]=F;z=z+1|0;}while((z|0)<=(v|0));A=c[j>>2]|0}z=x+q|0;if((z|0)<(e|0)){H=A;break}else{w=A;x=z;y=A+y|0}}}else{y=u;x=o;w=r;while(1){z=c[g+(w+ -1<<2)>>2]|0;if((z|0)==(x|0)){I=y}else{C=x+d|0;B=z+d|0;z=m;do{G=fa(z,l)|0;E=b+(C+G<<3)|0;F=+h[E>>3];D=b+(B+G<<3)|0;h[E>>3]=+h[D>>3];h[D>>3]=F;z=z+1|0;}while((z|0)<=(v|0));I=c[j>>2]|0}z=x+q|0;if((z|0)>(e|0)){H=I;break}else{y=I;x=z;w=I+w|0}}}}else{H=u}w=m+32|0;if((w|0)>(f|0)){break}else{u=H;m=w}}s=H;t=c[a>>2]|0}if((f|0)==(t|0)){i=k;return 0}t=f|1;f=(q|0)<0;if(!(f?(o|0)>=(e|0):(o|0)<=(e|0))){i=k;return 0}if(f){f=s;H=o;m=r;while(1){u=c[g+(m+ -1<<2)>>2]|0;do{if((u|0)==(H|0)){J=f}else{I=c[a>>2]|0;if((t|0)>(I|0)){J=f;break}A=H+d|0;p=u+d|0;n=t;do{w=fa(n,l)|0;x=b+(A+w<<3)|0;F=+h[x>>3];y=b+(p+w<<3)|0;h[x>>3]=+h[y>>3];h[y>>3]=F;n=n+1|0;}while((n|0)<=(I|0));J=c[j>>2]|0}}while(0);u=H+q|0;if((u|0)<(e|0)){break}else{f=J;H=u;m=J+m|0}}i=k;return 0}else{m=s;s=o;o=r;while(1){r=c[g+(o+ -1<<2)>>2]|0;do{if((r|0)==(s|0)){K=m}else{J=c[a>>2]|0;if((t|0)>(J|0)){K=m;break}H=s+d|0;f=r+d|0;u=t;do{I=fa(u,l)|0;n=b+(H+I<<3)|0;F=+h[n>>3];p=b+(f+I<<3)|0;h[n>>3]=+h[p>>3];h[p>>3]=F;u=u+1|0;}while((u|0)<=(J|0));K=c[j>>2]|0}}while(0);r=s+q|0;if((r|0)>(e|0)){break}else{m=K;s=r;o=K+o|0}}i=k;return 0}return 0}function cSa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=yqb(d|0)|0;switch(c[b>>2]|0){case 11:{q=dSa(229424,229408,229416)|0;i=k;return q|0};case 16:case 15:case 14:case 13:case 12:{q=eSa(b,d,e,f,g,h,j)|0;i=k;return q|0};case 5:{q=2;i=k;return q|0};case 6:{h=c[f>>2]|0;f=c[g>>2]|0;q=~~(+(((h|0)>(f|0)?f:h)|0)*1.600000023841858);i=k;return q|0};case 7:{q=1;i=k;return q|0};case 8:{q=50;i=k;return q|0};case 10:{q=dSa(229400,229408,229416)|0;i=k;return q|0};case 9:{q=25;i=k;return q|0};case 4:{q=6;i=k;return q|0};case 3:case 2:case 1:{h=o;Fdb(h,d,1,p);p=a[h]|0;do{if((p+ -97<<24>>24&255)<26){d=p+ -32<<24>>24;a[h]=d;f=o+1|0;e=a[f]|0;if((e+ -97<<24>>24&255)<26){a[f]=e+ -32<<24>>24}e=o+2|0;f=a[e]|0;if((f+ -97<<24>>24&255)<26){a[e]=f+ -32<<24>>24}f=o+3|0;e=a[f]|0;if((e+ -97<<24>>24&255)<26){a[f]=e+ -32<<24>>24}e=o+4|0;f=a[e]|0;if((f+ -97<<24>>24&255)<26){a[e]=f+ -32<<24>>24}f=o+5|0;e=a[f]|0;if(!((e+ -97<<24>>24&255)<26)){r=d;break}a[f]=e+ -32<<24>>24;r=d}else{r=p}}while(0);p=r<<24>>24==83;h=r<<24>>24==68;d=p|h;if(!(r<<24>>24==67|r<<24>>24==68|r<<24>>24==83|r<<24>>24==90)){q=1;i=k;return q|0}e=l;Fdb(e,o+1|0,1,2);l=m;Fdb(l,o+3|0,1,3);o=n;Fdb(o,m+1|0,1,2);m=c[b>>2]|0;if((m|0)==3){if((Edb(e,229168,1,2)|0)==0){if((Edb(l,229184,1,3)|0)==0){q=128;i=k;return q|0}if((Edb(l,229192,1,3)|0)==0){q=128;i=k;return q|0}if((Edb(l,229200,1,3)|0)==0){q=128;i=k;return q|0}if((Edb(l,229208,1,3)|0)==0){q=128;i=k;return q|0}if((Edb(l,229216,1,3)|0)==0){q=128;i=k;return q|0}b=(Edb(l,229224,1,3)|0)==0;q=b?128:0;i=k;return q|0}if((Edb(e,229248,1,2)|0)==0){if(!(r<<24>>24==68|r<<24>>24==83)){q=0;i=k;return q|0}b=(Edb(l,229256,1,3)|0)==0;q=b?32:0;i=k;return q|0}if(r<<24>>24==67|r<<24>>24==90){s=138}else if(r<<24>>24==68|r<<24>>24==83){s=141}else{q=0;i=k;return q|0}do{if((s|0)==138){if((Edb(e,229272,1,2)|0)==0){b=(Edb(l,229256,1,3)|0)==0;q=b?32:0;i=k;return q|0}else{if(r<<24>>24==68|r<<24>>24==83){s=141;break}else if(r<<24>>24==67|r<<24>>24==90){break}else{q=0}i=k;return q|0}}}while(0);do{if((s|0)==141){if((Edb(e,229280,1,2)|0)!=0){if(r<<24>>24==67|r<<24>>24==90){break}else{q=0}i=k;return q|0}if((a[l]|0)!=71){q=0;i=k;return q|0}do{if((Edb(o,229288,1,2)|0)!=0){if((Edb(o,229296,1,2)|0)==0){break}if((Edb(o,229304,1,2)|0)==0){break}if((Edb(o,229312,1,2)|0)==0){break}if((Edb(o,229320,1,2)|0)==0){break}if((Edb(o,229328,1,2)|0)==0){break}if((Edb(o,229336,1,2)|0)==0){break}else{q=0}i=k;return q|0}}while(0);q=128;i=k;return q|0}}while(0);if((Edb(e,229344,1,2)|0)!=0){q=0;i=k;return q|0}if((a[l]|0)!=71){q=0;i=k;return q|0}do{if((Edb(o,229288,1,2)|0)!=0){if((Edb(o,229296,1,2)|0)==0){break}if((Edb(o,229304,1,2)|0)==0){break}if((Edb(o,229312,1,2)|0)==0){break}if((Edb(o,229320,1,2)|0)==0){break}if((Edb(o,229328,1,2)|0)==0){break}if((Edb(o,229336,1,2)|0)==0){break}else{q=0}i=k;return q|0}}while(0);q=128;i=k;return q|0}else if((m|0)==2){if((Edb(e,229168,1,2)|0)==0){if((Edb(l,229184,1,3)|0)==0){q=2;i=k;return q|0}if((Edb(l,229192,1,3)|0)==0){q=2;i=k;return q|0}if((Edb(l,229200,1,3)|0)==0){q=2;i=k;return q|0}if((Edb(l,229208,1,3)|0)==0){q=2;i=k;return q|0}if((Edb(l,229216,1,3)|0)==0){q=2;i=k;return q|0}if((Edb(l,229224,1,3)|0)==0){q=2;i=k;return q|0}q=2;i=k;return q|0}if((Edb(e,229248,1,2)|0)==0){m=(Edb(l,229176,1,3)|0)==0;if(m|(p|h)^1){q=m?8:2;i=k;return q|0}q=2;i=k;return q|0}if(r<<24>>24==67|r<<24>>24==90){s=91}else if(r<<24>>24==68|r<<24>>24==83){s=94}else{q=2;i=k;return q|0}do{if((s|0)==91){if((Edb(e,229272,1,2)|0)==0){q=2;i=k;return q|0}else{if(r<<24>>24==67|r<<24>>24==90){break}else if(r<<24>>24==68|r<<24>>24==83){s=94;break}else{q=2}i=k;return q|0}}}while(0);do{if((s|0)==94){if((Edb(e,229280,1,2)|0)!=0){if(r<<24>>24==67|r<<24>>24==90){break}else{q=2}i=k;return q|0}m=a[l]|0;if(m<<24>>24==71){if((Edb(o,229288,1,2)|0)==0){q=2;i=k;return q|0}if((Edb(o,229296,1,2)|0)==0){q=2;i=k;return q|0}if((Edb(o,229304,1,2)|0)==0){q=2;i=k;return q|0}if((Edb(o,229312,1,2)|0)==0){q=2;i=k;return q|0}if((Edb(o,229320,1,2)|0)==0){q=2;i=k;return q|0}if((Edb(o,229328,1,2)|0)==0){q=2;i=k;return q|0}q=2;i=k;return q|0}else if(m<<24>>24==77){if((Edb(o,229288,1,2)|0)==0){q=2;i=k;return q|0}if((Edb(o,229296,1,2)|0)==0){q=2;i=k;return q|0}if((Edb(o,229304,1,2)|0)==0){q=2;i=k;return q|0}if((Edb(o,229312,1,2)|0)==0){q=2;i=k;return q|0}if((Edb(o,229320,1,2)|0)==0){q=2;i=k;return q|0}if((Edb(o,229328,1,2)|0)==0){q=2;i=k;return q|0}q=2;i=k;return q|0}else{q=2;i=k;return q|0}}}while(0);if((Edb(e,229344,1,2)|0)!=0){q=2;i=k;return q|0}m=a[l]|0;if(m<<24>>24==77){if((Edb(o,229288,1,2)|0)==0){q=2;i=k;return q|0}if((Edb(o,229296,1,2)|0)==0){q=2;i=k;return q|0}if((Edb(o,229304,1,2)|0)==0){q=2;i=k;return q|0}if((Edb(o,229312,1,2)|0)==0){q=2;i=k;return q|0}if((Edb(o,229320,1,2)|0)==0){q=2;i=k;return q|0}if((Edb(o,229328,1,2)|0)==0){q=2;i=k;return q|0}q=2;i=k;return q|0}else if(m<<24>>24==71){if((Edb(o,229288,1,2)|0)==0){q=2;i=k;return q|0}if((Edb(o,229296,1,2)|0)==0){q=2;i=k;return q|0}if((Edb(o,229304,1,2)|0)==0){q=2;i=k;return q|0}if((Edb(o,229312,1,2)|0)==0){q=2;i=k;return q|0}if((Edb(o,229320,1,2)|0)==0){q=2;i=k;return q|0}if((Edb(o,229328,1,2)|0)==0){q=2;i=k;return q|0}q=2;i=k;return q|0}else{q=2;i=k;return q|0}}else{if((Edb(e,229168,1,2)|0)==0){if((Edb(l,229176,1,3)|0)==0){q=64;i=k;return q|0}if((Edb(l,229184,1,3)|0)==0){q=32;i=k;return q|0}if((Edb(l,229192,1,3)|0)==0){q=32;i=k;return q|0}if((Edb(l,229200,1,3)|0)==0){q=32;i=k;return q|0}if((Edb(l,229208,1,3)|0)==0){q=32;i=k;return q|0}if((Edb(l,229216,1,3)|0)==0){q=32;i=k;return q|0}if((Edb(l,229224,1,3)|0)==0){q=32;i=k;return q|0}m=(Edb(l,229232,1,3)|0)==0;q=m?64:1;i=k;return q|0}if((Edb(e,229240,1,2)|0)==0){m=(Edb(l,229176,1,3)|0)==0;q=m?64:1;i=k;return q|0}if((Edb(e,229248,1,2)|0)==0){m=(Edb(l,229176,1,3)|0)==0;if(m|d^1){q=m?64:1;i=k;return q|0}m=(Edb(l,229256,1,3)|0)==0;if(m){q=m?32:1;i=k;return q|0}m=(Edb(l,229264,1,3)|0)==0;q=m?64:1;i=k;return q|0}do{if(r<<24>>24==68|r<<24>>24==83){s=29}else if(r<<24>>24==67|r<<24>>24==90){if((Edb(e,229272,1,2)|0)!=0){if(r<<24>>24==67|r<<24>>24==90){s=48;break}else if(r<<24>>24==68|r<<24>>24==83){s=29;break}else{break}}if((Edb(l,229176,1,3)|0)==0){q=64;i=k;return q|0}if((Edb(l,229256,1,3)|0)==0){q=32;i=k;return q|0}m=(Edb(l,229264,1,3)|0)==0;q=m?64:1;i=k;return q|0}}while(0);do{if((s|0)==29){if((Edb(e,229280,1,2)|0)!=0){if(r<<24>>24==67|r<<24>>24==90){s=48;break}else{break}}m=a[l]|0;if(m<<24>>24==77){do{if((Edb(o,229288,1,2)|0)!=0){if((Edb(o,229296,1,2)|0)==0){break}if((Edb(o,229304,1,2)|0)==0){break}if((Edb(o,229312,1,2)|0)==0){break}if((Edb(o,229320,1,2)|0)==0){break}if((Edb(o,229328,1,2)|0)==0){break}if((Edb(o,229336,1,2)|0)==0){break}else{q=1}i=k;return q|0}}while(0);q=32;i=k;return q|0}else if(m<<24>>24==71){do{if((Edb(o,229288,1,2)|0)!=0){if((Edb(o,229296,1,2)|0)==0){break}if((Edb(o,229304,1,2)|0)==0){break}if((Edb(o,229312,1,2)|0)==0){break}if((Edb(o,229320,1,2)|0)==0){break}if((Edb(o,229328,1,2)|0)==0){break}if((Edb(o,229336,1,2)|0)==0){break}else{q=1}i=k;return q|0}}while(0);q=32;i=k;return q|0}else{q=1;i=k;return q|0}}}while(0);do{if((s|0)==48){if((Edb(e,229344,1,2)|0)!=0){break}m=a[l]|0;if(m<<24>>24==71){do{if((Edb(o,229288,1,2)|0)!=0){if((Edb(o,229296,1,2)|0)==0){break}if((Edb(o,229304,1,2)|0)==0){break}if((Edb(o,229312,1,2)|0)==0){break}if((Edb(o,229320,1,2)|0)==0){break}if((Edb(o,229328,1,2)|0)==0){break}if((Edb(o,229336,1,2)|0)==0){break}else{q=1}i=k;return q|0}}while(0);q=32;i=k;return q|0}else if(m<<24>>24==77){do{if((Edb(o,229288,1,2)|0)!=0){if((Edb(o,229296,1,2)|0)==0){break}if((Edb(o,229304,1,2)|0)==0){break}if((Edb(o,229312,1,2)|0)==0){break}if((Edb(o,229320,1,2)|0)==0){break}if((Edb(o,229328,1,2)|0)==0){break}if((Edb(o,229336,1,2)|0)==0){break}else{q=1}i=k;return q|0}}while(0);q=32;i=k;return q|0}else{q=1;i=k;return q|0}}}while(0);if((Edb(e,229352,1,2)|0)==0){if((Edb(l,229176,1,3)|0)!=0){q=1;i=k;return q|0}q=(c[j>>2]|0)<65?1:32;i=k;return q|0}if((Edb(e,229360,1,2)|0)==0){if((Edb(l,229176,1,3)|0)!=0){q=1;i=k;return q|0}q=(c[g>>2]|0)<65?1:32;i=k;return q|0}if((Edb(e,229328,1,2)|0)==0){g=(Edb(l,229232,1,3)|0)==0;q=g?64:1;i=k;return q|0}if((Edb(e,229368,1,2)|0)==0){g=(Edb(l,229376,1,3)|0)==0;q=g?64:1;i=k;return q|0}if(!(r<<24>>24==68|r<<24>>24==83)){q=1;i=k;return q|0}if((Edb(e,229384,1,2)|0)==0){i=k;return 1}else{q=1;i=k;return q|0}}break};default:{q=-1;i=k;return q|0}}return 0}function dSa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0.0,h=0.0,j=0.0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0;e=i;f=+g[d>>2];h=+g[b>>2];do{if(!(f/h<=f)){j=-f/h;if(j>=h){k=0;break}l=f/(f+j);if(l!=h){k=0;break}j=f/l;if(j>=h){k=0;break}m=h+l;if(m!=h){k=0;break}n=f/m;if(n<=f){k=0;break}m=j*n;if(m>=h){k=0;break}j=n*n;if(j<=f){k=0;break}if((c[a>>2]|0)==0){k=1;break}n=j+m;o=j/j;p=h*j;q=l*m;l=j/m;if(n==n&0.0==0.0|l==l&0.0==0.0|o==o&0.0==0.0|p==p&0.0==0.0|q==q&0.0==0.0){k=0;break}p=q*0.0;k=(p!=p|0.0!=0.0)&1}else{k=0}}while(0);i=e;return k|0}function eSa(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+8|0;e=j;d=c[a>>2]|0;if((d|0)==16|(d|0)==13|(d|0)==15){b=(c[h>>2]|0)-(c[f>>2]|0)+1|0;if((b|0)>149){g[e>>2]=+da(+(+(b|0)))/.6931471805599453;f=(b|0)/(Ddb(e)|0)|0;k=c[a>>2]|0;l=(f|0)>10?f:10}else{k=d;l=(b|0)>59?10:(b|0)>29?4:2}f=(b|0)>5999?256:(b|0)>2999?128:(b|0)>589?64:l;l=f-((f|0)%2|0)|0;m=k;n=b;o=(l|0)>2?l:2}else{m=d;n=0;o=0}switch(m|0){case 12:{p=75;i=j;return p|0};case 13:{if((n|0)<501){p=o;i=j;return p|0}p=(o*3|0)/2|0;i=j;return p|0};case 15:{p=o;i=j;return p|0};case 14:{p=14;i=j;return p|0};case 16:{n=(o|0)>13;i=j;return(n?2:n&1)|0};default:{p=-1;i=j;return p|0}}return 0}function fSa(a){a=a|0;var b=0,c=0;b=i;i=i+8|0;c=gSa(a,0,0)|0;i=b;return c|0}function gSa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;i=i+24|0;e=hSa(a,b,c,0)|0;i=d;return e|0}function hSa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+64|0;h=b;b=d;d=e;e=f;do{if((b|0)!=0){j=pe[c[b>>2]&127](500)|0;if((j|0)==0){break}f=j+12|0;c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2]}else{j=Wpb(500)|0;if((j|0)==0){break}f=j+12|0;c[f>>2]=29;c[f+4>>2]=49;c[f+8>>2]=1408}}while(0);b=j;if((j|0)==0){k=b;l=k;i=g;return l|0}c[b+8>>2]=0;c[j+32>>2]=0;c[j+380>>2]=16;c[j+392>>2]=pe[c[j+12>>2]&127](c[j+380>>2]<<4)|0;b=j+12|0;if((c[j+392>>2]|0)==0){me[c[b+8>>2]&2047](j);k=0;l=k;i=g;return l|0}c[j+44>>2]=pe[c[b>>2]&127](1024)|0;b=j;if((c[j+44>>2]|0)==0){me[c[b+20>>2]&2047](c[j+392>>2]|0);me[c[j+20>>2]&2047](j);k=0;l=k;i=g;return l|0}c[j+48>>2]=(c[b+44>>2]|0)+1024;do{if((e|0)!=0){c[j+356>>2]=e}else{c[j+356>>2]=sTa(j+12|0)|0;if((c[j+356>>2]|0)!=0){break}me[c[j+20>>2]&2047](c[j+44>>2]|0);me[c[j+20>>2]&2047](c[j+392>>2]|0);me[c[j+20>>2]&2047](j);k=0;l=k;i=g;return l|0}}while(0);c[j+376>>2]=0;c[j+368>>2]=0;c[j+304>>2]=0;c[j+468>>2]=0;c[j+464>>2]=0;c[j+124>>2]=0;c[j+248>>2]=0;a[j+472|0]=33;a[j+236|0]=0;a[j+237|0]=0;c[j+396>>2]=0;c[j+400>>2]=0;a[j+404|0]=0;tTa(j+416|0,j+12|0);tTa(j+440|0,j+12|0);jSa(j,h);do{if((h|0)!=0){if((c[j+232>>2]|0)!=0){break}mSa(j);k=0;l=k;i=g;return l|0}}while(0);if((d|0)!=0){a[j+236|0]=1;c[j+228>>2]=NTa()|0;a[j+472|0]=a[d]|0}else{c[j+228>>2]=ETa()|0}k=j;l=k;i=g;return l|0}function iSa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+24|0;d=a;a=c[d>>2]|0;a:do{if((c[d+4>>2]|0)!=0){e=a;while(1){if((e|0)==0){break a}f=c[e>>2]|0;c[e>>2]=c[d+4>>2];c[d+4>>2]=e;e=f}}else{c[d+4>>2]=a}}while(0);c[d>>2]=0;c[d+16>>2]=0;c[d+12>>2]=0;c[d+8>>2]=0;i=b;return}function jSa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=d;c[f+280>>2]=36;WVa(f+256|0);if((b|0)!=0){g=kSa(f+416|0,b)|0}else{g=0}c[f+232>>2]=g;c[f+360>>2]=0;FTa(f+148|0,f+144|0,0)|0;c[f>>2]=0;c[f+4>>2]=0;c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=0;c[f+64>>2]=0;c[f+68>>2]=0;c[f+72>>2]=0;c[f+76>>2]=0;c[f+80>>2]=0;c[f+84>>2]=0;c[f+88>>2]=0;c[f+92>>2]=0;c[f+96>>2]=0;c[f+100>>2]=0;c[f+104>>2]=0;c[f+108>>2]=0;c[f+112>>2]=0;c[f+116>>2]=f;c[f+120>>2]=0;c[f+128>>2]=0;c[f+132>>2]=0;c[f+136>>2]=0;c[f+140>>2]=0;c[f+24>>2]=c[f+8>>2];c[f+28>>2]=c[f+8>>2];c[f+36>>2]=0;c[f+40>>2]=0;c[f+344>>2]=0;c[f+348>>2]=0;c[f+316>>2]=0;c[f+320>>2]=0;c[f+324>>2]=0;c[f+328>>2]=0;c[f+332>>2]=0;c[f+336>>2]=0;c[f+340>>2]=0;a[f+352|0]=0;a[f+353|0]=0;g=f+408|0;c[g+0>>2]=0;c[g+4>>2]=0;c[f+284>>2]=0;c[f+288>>2]=0;c[f+292>>2]=0;c[f+296>>2]=0;c[f+300>>2]=0;a[f+308|0]=1;c[f+312>>2]=0;c[f+364>>2]=0;c[f+372>>2]=0;c[f+384>>2]=0;c[f+240>>2]=0;c[f+252>>2]=0;c[f+244>>2]=0;c[f+476>>2]=0;c[f+480>>2]=0;a[f+488|0]=0;a[f+489|0]=0;c[f+492>>2]=0;c[f+496>>2]=0;i=e;return}function kSa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+24|0;f=b;b=d;while(1){if((c[f+12>>2]|0)==(c[f+8>>2]|0)){if(!((BSa(f)|0)<<24>>24!=0)){g=5;break}}d=a[b]|0;h=f+12|0;j=c[h>>2]|0;c[h>>2]=j+1;a[j]=d;d=b;b=d+1|0;if((a[d]|0)==0){g=6;break}}if((g|0)==5){k=0;l=k;i=e;return l|0}else if((g|0)==6){b=c[f+16>>2]|0;c[f+16>>2]=c[f+12>>2];k=b;l=k;i=e;return l|0}return 0}function lSa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+56|0;f=b;b=d;d=c[f+356>>2]|0;g=b;a:while(1){if((a[b]|0)==0){h=45;break}do{if((a[g]|0)!=12){if((a[g]|0)==0){break}j=c[f+428>>2]|0;k=f+416|0;if((a[g]|0)!=61){if((j|0)==(c[k+8>>2]|0)){if(!((BSa(f+416|0)|0)<<24>>24!=0)){h=44;break a}}l=a[g]|0;m=f+428|0;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;g=g+1|0;continue a}if((j-(c[k+16>>2]|0)|0)==0){o=d+152|0}else{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((BSa(f+416|0)|0)<<24>>24!=0)){h=19;break a}}k=f+428|0;j=c[k>>2]|0;c[k>>2]=j+1;a[j]=0;o=ESa(f,d+60|0,c[f+432>>2]|0,8)|0;if((o|0)==0){h=20;break a}if((c[o>>2]|0)==(c[f+432>>2]|0)){c[o>>2]=kSa(d+80|0,c[o>>2]|0)|0;if((c[o>>2]|0)==0){h=23;break a}}c[f+428>>2]=c[f+432>>2]}b=g+1|0;while(1){if((a[b]|0)!=12){p=(a[b]|0)!=0}else{p=0}q=(c[f+428>>2]|0)==(c[f+424>>2]|0);if(!p){break}if(q){if(!((BSa(f+416|0)|0)<<24>>24!=0)){h=32;break a}}j=a[b]|0;k=f+428|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=j;b=b+1|0}if(q){if(!((BSa(f+416|0)|0)<<24>>24!=0)){h=36;break a}}j=f+428|0;l=c[j>>2]|0;c[j>>2]=l+1;a[l]=0;if((ISa(f,o,0,c[f+432>>2]|0,f+372|0)|0)!=0){h=37;break a}c[f+428>>2]=c[f+432>>2];if((a[b]|0)!=0){b=b+1|0}g=b;continue a}}while(0);if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((BSa(f+416|0)|0)<<24>>24!=0)){h=8;break}}l=f+428|0;j=c[l>>2]|0;c[l>>2]=j+1;a[j]=0;j=ESa(f,d,c[f+432>>2]|0,0)|0;if((j|0)!=0){a[j+32|0]=1}if((a[g]|0)!=0){g=g+1|0}b=g;c[f+428>>2]=c[f+432>>2]}if((h|0)==8){r=0;s=r;i=e;return s|0}else if((h|0)==19){r=0;s=r;i=e;return s|0}else if((h|0)==20){r=0;s=r;i=e;return s|0}else if((h|0)==23){r=0;s=r;i=e;return s|0}else if((h|0)==32){r=0;s=r;i=e;return s|0}else if((h|0)==36){r=0;s=r;i=e;return s|0}else if((h|0)==37){r=0;s=r;i=e;return s|0}else if((h|0)==44){r=0;s=r;i=e;return s|0}else if((h|0)==45){r=1;s=r;i=e;return s|0}return 0}function mSa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+40|0;e=b;if((e|0)==0){i=d;return}b=c[e+364>>2]|0;while(1){if((b|0)==0){f=e;if((c[e+368>>2]|0)==0){break}b=c[f+368>>2]|0;c[e+368>>2]=0}g=b;b=c[b>>2]|0;me[c[e+20>>2]&2047](c[g+36>>2]|0);nSa(c[g+44>>2]|0,e);me[c[e+20>>2]&2047](g)}b=c[f+300>>2]|0;while(1){if((b|0)==0){h=e;if((c[e+304>>2]|0)==0){break}b=c[h+304>>2]|0;c[e+304>>2]=0}f=b;b=c[b+8>>2]|0;me[c[e+20>>2]&2047](f)}nSa(c[h+376>>2]|0,e);nSa(c[e+372>>2]|0,e);oSa(e+416|0);oSa(e+440|0);do{if((a[e+488|0]|0)==0){if((c[e+356>>2]|0)==0){break}pSa(c[e+356>>2]|0,((c[e+476>>2]|0)!=0^1)&1,e+12|0)}}while(0);me[c[e+20>>2]&2047](c[e+392>>2]|0);me[c[e+20>>2]&2047](c[e+464>>2]|0);me[c[e+20>>2]&2047](c[e+8>>2]|0);me[c[e+20>>2]&2047](c[e+44>>2]|0);me[c[e+20>>2]&2047](c[e+396>>2]|0);me[c[e+20>>2]&2047](c[e+240>>2]|0);if((c[e+252>>2]|0)!=0){me[c[e+252>>2]&2047](c[e+244>>2]|0)}me[c[e+20>>2]&2047](e);i=d;return}function nSa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+24|0;e=a;a=b;while(1){b=e;if((b|0)==0){break}e=c[b+4>>2]|0;me[c[a+20>>2]&2047](c[b+16>>2]|0);me[c[a+20>>2]&2047](b)}i=d;return}function oSa(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+32|0;d=a;a=c[d>>2]|0;while(1){if((a|0)==0){break}e=c[a>>2]|0;me[c[(c[d+20>>2]|0)+8>>2]&2047](a);a=e}a=c[d+4>>2]|0;while(1){if((a|0)==0){break}e=c[a>>2]|0;me[c[(c[d+20>>2]|0)+8>>2]&2047](a);a=e}i=b;return}function pSa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+40|0;f=e+24|0;g=a;a=b;b=d;CSa(f,g+20|0);while(1){d=DSa(f)|0;if((d|0)==0){break}if((c[d+16>>2]|0)==0){continue}me[c[b+8>>2]&2047](c[d+20>>2]|0)}HSa(g);HSa(g+132|0);HSa(g+20|0);HSa(g+40|0);HSa(g+60|0);oSa(g+80|0);oSa(g+104|0);if(!(a<<24>>24!=0)){h=b;j=h;k=j+8|0;l=k;m=c[l>>2]|0;n=g;o=n;me[m&2047](o);i=e;return}me[c[b+8>>2]&2047](c[g+184>>2]|0);me[c[b+8>>2]&2047](c[g+164>>2]|0);h=b;j=h;k=j+8|0;l=k;m=c[l>>2]|0;n=g;o=n;me[m&2047](o);i=e;return}function qSa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=a;a=(c[e+4>>2]|0)==(c[e>>2]|0);f=b;c[e>>2]=f;if(!a){i=d;return}c[e+4>>2]=f;i=d;return}function rSa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+24|0;f=a;c[f+52>>2]=b;c[f+56>>2]=d;i=e;return}function sSa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=d;d=e;e=f;f=c[h+480>>2]|0;do{if((f|0)==0){if((c[h+476>>2]|0)!=0){break}if((tSa(h)|0)<<24>>24!=0){break}c[h+284>>2]=1;j=0;k=j;i=g;return k|0}else if((f|0)==3){c[h+284>>2]=33;j=0;k=j;i=g;return k|0}else if((f|0)==2){c[h+284>>2]=36;j=0;k=j;i=g;return k|0}}while(0);c[h+480>>2]=1;if((d|0)!=0){f=vSa(h,d)|0;if((f|0)==0){j=0;k=j;i=g;return k|0}else{Aqb(f|0,b|0,d|0)|0;j=wSa(h,d,e)|0;k=j;i=g;return k|0}}a[h+484|0]=e;if((e|0)==0){j=1;k=j;i=g;return k|0}c[h+296>>2]=c[h+24>>2];c[h+40>>2]=c[h+28>>2];c[h+284>>2]=Oe[c[h+280>>2]&63](h,c[h+24>>2]|0,c[h+40>>2]|0,h+24|0)|0;e=h;if((c[h+284>>2]|0)!=0){c[h+292>>2]=c[e+288>>2];c[h+280>>2]=37;j=0;k=j;i=g;return k|0}d=c[e+480>>2]|0;if((d|0)==3){Pe[c[(c[h+144>>2]|0)+52>>2]&127](c[h+144>>2]|0,c[h+296>>2]|0,c[h+24>>2]|0,h+408|0);c[h+296>>2]=c[h+24>>2];j=2;k=j;i=g;return k|0}else if((d|0)==1|(d|0)==0){c[h+480>>2]=2}j=1;k=j;i=g;return k|0}function tSa(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=b;if((c[e+496>>2]|0)==0){c[e+496>>2]=qTa()|0}if((a[e+236|0]|0)!=0){f=lSa(e,231208)|0;g=f;i=d;return g|0}else{f=1;g=f;i=d;return g|0}return 0}function uSa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;i=i+32|0;i=e;return c[a+284>>2]|0}function vSa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+72|0;e=a;a=b;b=c[e+480>>2]|0;if((b|0)==3){c[e+284>>2]=33;f=0;g=f;i=d;return g|0}else if((b|0)==2){c[e+284>>2]=36;f=0;g=f;i=d;return g|0}else{if((a|0)>((c[e+32>>2]|0)-(c[e+28>>2]|0)|0)){b=a+((c[e+28>>2]|0)-(c[e+24>>2]|0))|0;a=(c[e+24>>2]|0)-(c[e+8>>2]|0)|0;h=a;h=(h|0)>1024?1024:a;b=b+h|0;do{if((b|0)<=((c[e+32>>2]|0)-(c[e+8>>2]|0)|0)){if((h|0)>=((c[e+24>>2]|0)-(c[e+8>>2]|0)|0)){break}a=(c[e+24>>2]|0)-(c[e+8>>2]|0)-h|0;Bqb(c[e+8>>2]|0,(c[e+8>>2]|0)+a|0,(c[e+28>>2]|0)-(c[e+24>>2]|0)+h|0)|0;j=e+28|0;c[j>>2]=(c[j>>2]|0)+(0-a);j=e+24|0;c[j>>2]=(c[j>>2]|0)+(0-a)}else{a=(c[e+32>>2]|0)-(c[e+24>>2]|0)|0;j=a;j=(j|0)==0?1024:a;do{j=j<<1;}while((j|0)<(b|0));a=pe[c[e+12>>2]&127](j)|0;if((a|0)==0){c[e+284>>2]=1;f=0;g=f;i=d;return g|0}c[e+32>>2]=a+j;if((c[e+24>>2]|0)!=0){k=(c[e+24>>2]|0)-(c[e+8>>2]|0)|0;l=k;l=(l|0)>1024?1024:k;Aqb(a|0,(c[e+24>>2]|0)+(0-l)|0,(c[e+28>>2]|0)-(c[e+24>>2]|0)+l|0)|0;me[c[e+20>>2]&2047](c[e+8>>2]|0);c[e+8>>2]=a;c[e+28>>2]=(c[e+8>>2]|0)+((c[e+28>>2]|0)-(c[e+24>>2]|0))+l;c[e+24>>2]=(c[e+8>>2]|0)+l;break}else{c[e+28>>2]=a+((c[e+28>>2]|0)-(c[e+24>>2]|0));l=a;c[e+8>>2]=l;c[e+24>>2]=l;break}}}while(0);c[e+292>>2]=0;c[e+288>>2]=0;c[e+296>>2]=0}f=c[e+28>>2]|0;g=f;i=d;return g|0}return 0}function wSa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+48|0;g=b;b=d;d=e;e=1;h=c[g+480>>2]|0;do{if((h|0)==3){c[g+284>>2]=33;j=0;k=j;i=f;return k|0}else if((h|0)==2){c[g+284>>2]=36;j=0;k=j;i=f;return k|0}else if((h|0)==0){if((c[g+476>>2]|0)!=0){break}if((tSa(g)|0)<<24>>24!=0){break}c[g+284>>2]=1;j=0;k=j;i=f;return k|0}}while(0);c[g+480>>2]=1;h=c[g+24>>2]|0;c[g+296>>2]=h;l=g+28|0;c[l>>2]=(c[l>>2]|0)+b;c[g+40>>2]=c[g+28>>2];l=g+36|0;c[l>>2]=(c[l>>2]|0)+b;a[g+484|0]=d;c[g+284>>2]=Oe[c[g+280>>2]&63](g,h,c[g+40>>2]|0,g+24|0)|0;h=g;if((c[g+284>>2]|0)!=0){c[g+292>>2]=c[h+288>>2];c[g+280>>2]=37;j=0;k=j;i=f;return k|0}b=c[h+480>>2]|0;do{if((b|0)==3){e=2}else if((b|0)==1|(b|0)==0){if((d|0)==0){break}c[g+480>>2]=2;j=e;k=j;i=f;return k|0}}while(0);Pe[c[(c[g+144>>2]|0)+52>>2]&127](c[g+144>>2]|0,c[g+296>>2]|0,c[g+24>>2]|0,g+408|0);c[g+296>>2]=c[g+24>>2];j=e;k=j;i=f;return k|0}function xSa(a){a=a|0;var b=0;b=i;i=i+8|0;i=b;return c[a+284>>2]|0}function ySa(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;do{if((c[d+288>>2]|0)!=0){if(!((c[d+288>>2]|0)>>>0>=(c[d+296>>2]|0)>>>0)){break}Pe[c[(c[d+144>>2]|0)+52>>2]&127](c[d+144>>2]|0,c[d+296>>2]|0,c[d+288>>2]|0,d+408|0);c[d+296>>2]=c[d+288>>2]}}while(0);i=b;return(c[d+408>>2]|0)+1|0}function zSa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+56|0;h=g+16|0;j=g+48|0;k=b;b=d;c[h>>2]=e;e=f;if((a[b+72|0]|0)!=0){Le[c[k+80>>2]&15](c[k+4>>2]|0,c[h>>2]|0,e-(c[h>>2]|0)|0);i=g;return}f=k;if((b|0)==(c[k+144>>2]|0)){l=f+288|0;m=k+292|0}else{l=c[f+300>>2]|0;m=(c[k+300>>2]|0)+4|0}do{c[j>>2]=c[k+44>>2];je[c[b+60>>2]&31](b,h,e,j,c[k+48>>2]|0);c[m>>2]=c[h>>2];Le[c[k+80>>2]&15](c[k+4>>2]|0,c[k+44>>2]|0,(c[j>>2]|0)-(c[k+44>>2]|0)|0);c[l>>2]=c[h>>2];}while((c[h>>2]|0)!=(e|0));i=g;return}function ASa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=a;if(d>>>0>0&d>>>0<41){e=c[229432+(d<<2)>>2]|0;f=e;i=b;return f|0}else{e=0;f=e;i=b;return f|0}return 0}function BSa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+56|0;d=a;do{if((c[d+4>>2]|0)!=0){a=d;if((c[d+16>>2]|0)==0){c[d>>2]=c[a+4>>2];c[d+4>>2]=c[c[d+4>>2]>>2];c[c[d>>2]>>2]=0;c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+(c[(c[d>>2]|0)+4>>2]|0);c[d+12>>2]=c[d+16>>2];e=1;f=e;i=b;return f|0}if(((c[a+8>>2]|0)-(c[d+16>>2]|0)|0)>=(c[(c[d+4>>2]|0)+4>>2]|0)){break}a=c[c[d+4>>2]>>2]|0;c[c[d+4>>2]>>2]=c[d>>2];c[d>>2]=c[d+4>>2];c[d+4>>2]=a;Aqb((c[d>>2]|0)+8|0,c[d+16>>2]|0,(c[d+8>>2]|0)-(c[d+16>>2]|0)|0)|0;c[d+12>>2]=(c[d>>2]|0)+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+(c[(c[d>>2]|0)+4>>2]|0);e=1;f=e;i=b;return f|0}}while(0);do{if((c[d>>2]|0)!=0){if((c[d+16>>2]|0)!=((c[d>>2]|0)+8|0)){g=11;break}a=(c[d+8>>2]|0)-(c[d+16>>2]|0)<<1;h=Ee[c[(c[d+20>>2]|0)+4>>2]&63](c[d>>2]|0,8+a|0)|0;if((h|0)!=0){c[d>>2]=h;c[(c[d>>2]|0)+4>>2]=a;c[d+12>>2]=(c[d>>2]|0)+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+a;break}e=0;f=e;i=b;return f|0}else{g=11}}while(0);if((g|0)==11){g=(c[d+8>>2]|0)-(c[d+16>>2]|0)|0;if((g|0)<1024){g=1024}else{g=g<<1}a=pe[c[c[d+20>>2]>>2]&127](8+g|0)|0;if((a|0)==0){e=0;f=e;i=b;return f|0}c[a+4>>2]=g;c[a>>2]=c[d>>2];c[d>>2]=a;if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){Aqb(a+8|0,c[d+16>>2]|0,(c[d+12>>2]|0)-(c[d+16>>2]|0)|0)|0}c[d+12>>2]=a+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=a+8;c[d+8>>2]=a+8+g}e=1;f=e;i=b;return f|0}function CSa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=a;a=b;c[e>>2]=c[a>>2];c[e+4>>2]=(c[e>>2]|0)+(c[a+8>>2]<<2);i=d;return}function DSa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+24|0;d=a;while(1){if((c[d>>2]|0)==(c[d+4>>2]|0)){e=5;break}a=d;f=c[a>>2]|0;c[a>>2]=f+4;g=c[f>>2]|0;if((g|0)!=0){e=4;break}}if((e|0)==4){h=g;j=h;i=b;return j|0}else if((e|0)==5){h=0;j=h;i=b;return j|0}return 0}function ESa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+136|0;j=b;b=e;e=f;f=g;a:do{if((c[b+8>>2]|0)==0){if((f|0)==0){k=0;l=k;i=h;return l|0}a[b+4|0]=6;c[b+8>>2]=64;g=c[b+8>>2]<<2;c[b>>2]=pe[c[c[b+16>>2]>>2]&127](g)|0;m=b;if((c[b>>2]|0)!=0){Cqb(c[m>>2]|0,0,g|0)|0;g=FSa(j,e)|0;n=g&(c[b+8>>2]|0)-1;break}c[m+8>>2]=0;k=0;l=k;i=h;return l|0}else{m=FSa(j,e)|0;g=(c[b+8>>2]|0)-1|0;o=0;n=m&g;while(1){if((c[(c[b>>2]|0)+(n<<2)>>2]|0)==0){break}if((GSa(e,c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]|0)|0)<<24>>24!=0){p=10;break}if(!(o<<24>>24!=0)){o=((m&~g)>>>((d[b+4|0]|0)-1|0)&g>>>2|1)&255}if(n>>>0<(o&255)>>>0){n=n+((c[b+8>>2]|0)-(o&255))|0;continue}else{n=n-(o&255)|0;continue}}if((p|0)==10){k=c[(c[b>>2]|0)+(n<<2)>>2]|0;l=k;i=h;return l|0}if((f|0)==0){k=0;l=k;i=h;return l|0}if(((c[b+12>>2]|0)>>>((d[b+4|0]|0)-1|0)|0)==0){break}g=(d[b+4|0]|0)+1&255;q=1<<(g&255);r=q-1|0;s=q<<2;t=pe[c[c[b+16>>2]>>2]&127](s)|0;if((t|0)==0){k=0;l=k;i=h;return l|0}Cqb(t|0,0,s|0)|0;n=0;while(1){if(!(n>>>0<(c[b+8>>2]|0)>>>0)){break}if((c[(c[b>>2]|0)+(n<<2)>>2]|0)!=0){s=FSa(j,c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]|0)|0;u=s&r;o=0;while(1){if((c[t+(u<<2)>>2]|0)==0){break}if(!(o<<24>>24!=0)){o=((s&~r)>>>((g&255)-1|0)&r>>>2|1)&255}if(u>>>0<(o&255)>>>0){u=u+(q-(o&255))|0;continue}else{u=u-(o&255)|0;continue}}c[t+(u<<2)>>2]=c[(c[b>>2]|0)+(n<<2)>>2]}n=n+1|0}me[c[(c[b+16>>2]|0)+8>>2]&2047](c[b>>2]|0);c[b>>2]=t;a[b+4|0]=g;c[b+8>>2]=q;n=m&r;o=0;while(1){if((c[(c[b>>2]|0)+(n<<2)>>2]|0)==0){break a}if(!(o<<24>>24!=0)){o=((m&~r)>>>((g&255)-1|0)&r>>>2|1)&255}if(n>>>0<(o&255)>>>0){n=n+(q-(o&255))|0;continue}else{n=n-(o&255)|0;continue}}}}while(0);j=pe[c[c[b+16>>2]>>2]&127](f)|0;c[(c[b>>2]|0)+(n<<2)>>2]=j;if((c[(c[b>>2]|0)+(n<<2)>>2]|0)!=0){Cqb(c[(c[b>>2]|0)+(n<<2)>>2]|0,0,f|0)|0;c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]=e;e=b+12|0;c[e>>2]=(c[e>>2]|0)+1;k=c[(c[b>>2]|0)+(n<<2)>>2]|0;l=k;i=h;return l|0}else{k=0;l=k;i=h;return l|0}return 0}function FSa(b,e){b=b|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+24|0;g=e;e=c[b+496>>2]|0;while(1){h=e;if((a[g]|0)==0){break}b=g;g=b+1|0;e=h*1000003^d[b]}i=f;return h|0}function GSa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=c;while(1){if((a[e]|0)!=(a[b]|0)){f=6;break}if((a[e]|0)==0){f=4;break}e=e+1|0;b=b+1|0}if((f|0)==4){g=1;h=g;i=d;return h|0}else if((f|0)==6){g=0;h=g;i=d;return h|0}return 0}function HSa(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=a;a=0;while(1){e=c[(c[d+16>>2]|0)+8>>2]|0;if(!(a>>>0<(c[d+8>>2]|0)>>>0)){break}me[e&2047](c[(c[d>>2]|0)+(a<<2)>>2]|0);a=a+1|0}me[e&2047](c[d>>2]|0);i=b;return}function ISa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+96|0;j=b;b=d;d=e;e=f;f=g;g=0;k=1;l=1;do{if((a[e]|0)==0){if((c[b>>2]|0)==0){break}m=28;n=m;i=h;return n|0}}while(0);do{if((c[b>>2]|0)!=0){if((a[c[b>>2]|0]|0)!=120){break}if((a[(c[b>>2]|0)+1|0]|0)!=109){break}if((a[(c[b>>2]|0)+2|0]|0)!=108){break}do{if((a[(c[b>>2]|0)+3|0]|0)==110){if((a[(c[b>>2]|0)+4|0]|0)!=115){break}if((a[(c[b>>2]|0)+5|0]|0)!=0){break}m=39;n=m;i=h;return n|0}}while(0);if((a[(c[b>>2]|0)+3|0]|0)!=0){break}g=1}}while(0);o=0;while(1){p=(k&255|0)!=0;if((a[e+o|0]|0)==0){break}do{if(p){if((o|0)<=36){if((a[e+o|0]|0)==(a[231016+o|0]|0)){break}}k=0}}while(0);do{if(!(g<<24>>24!=0)){if((l&255|0)==0){break}if((o|0)<=29){if((a[e+o|0]|0)==(a[231056+o|0]|0)){break}}l=0}}while(0);o=o+1|0}if(p){q=(o|0)==36}else{q=0}k=q&1;if((l&255|0)!=0){r=(o|0)==29}else{r=0}l=r&1;if((g&255|0)!=(k&255|0)){m=(g&255|0)!=0?38:40;n=m;i=h;return n|0}if(l<<24>>24!=0){m=40;n=m;i=h;return n|0}if((a[j+472|0]|0)!=0){o=o+1|0}l=j;do{if((c[j+376>>2]|0)!=0){s=c[l+376>>2]|0;do{if((o|0)>(c[s+24>>2]|0)){g=Ee[c[j+16>>2]&63](c[s+16>>2]|0,o+24|0)|0;if((g|0)!=0){c[s+16>>2]=g;c[s+24>>2]=o+24;break}m=1;n=m;i=h;return n|0}}while(0);c[j+376>>2]=c[s+4>>2]}else{s=pe[c[l+12>>2]&127](28)|0;if((s|0)==0){m=1;n=m;i=h;return n|0}c[s+16>>2]=pe[c[j+12>>2]&127](o+24|0)|0;if((c[s+16>>2]|0)!=0){c[s+24>>2]=o+24;break}me[c[j+20>>2]&2047](s);m=1;n=m;i=h;return n|0}}while(0);c[s+20>>2]=o;Aqb(c[s+16>>2]|0,e|0,o|0)|0;if((a[j+472|0]|0)!=0){a[(c[s+16>>2]|0)+(o-1)|0]=a[j+472|0]|0}c[s>>2]=b;c[s+12>>2]=d;c[s+8>>2]=c[b+4>>2];do{if((a[e]|0)==0){if((b|0)!=((c[j+356>>2]|0)+152|0)){t=52;break}c[b+4>>2]=0}else{t=52}}while(0);if((t|0)==52){c[b+4>>2]=s}c[s+4>>2]=c[f>>2];c[f>>2]=s;do{if((d|0)!=0){if((c[j+100>>2]|0)==0){break}Le[c[j+100>>2]&15](c[j+4>>2]|0,c[b>>2]|0,(c[b+4>>2]|0)!=0?e:0)}}while(0);m=0;n=m;i=h;return n|0}function JSa(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+24|0;e=b;if((se[((a[e+236|0]&255|0)!=0?34:35)&63](e+148|0,e+144|0,c[e+232>>2]|0)|0)!=0){f=0;g=f;i=d;return g|0}else{f=pTa(e,c[e+232>>2]|0)|0;g=f;i=d;return g|0}return 0}function KSa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=g+32|0;j=b;b=d;d=e;c[h>>2]=b;e=Oe[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;k=LSa(j,c[j+144>>2]|0,b,d,e,c[h>>2]|0,f,((a[j+484|0]|0)!=0^1)&1)|0;i=g;return k|0}function LSa(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;m=i;i=i+368|0;n=m+48|0;o=b;b=e;e=f;f=g;g=h;c[n>>2]=j;j=k;k=l;l=c[o+356>>2]|0;h=o;if((b|0)==(c[o+144>>2]|0)){p=h+288|0;q=o+292|0}else{p=c[h+300>>2]|0;q=(c[o+300>>2]|0)+4|0}a:while(1){h=1;c[p>>2]=e;c[q>>2]=c[n>>2];b:do{if((g|0)<=0){if((k&255|0)!=0){if((g|0)!=0){r=7;break a}}switch(g|0){case-15:{g=0-g|0;break b;break};case-4:{r=13;break a;break};case 0:{r=9;break a;break};case-1:{r=10;break a;break};case-2:{r=11;break a;break};default:{g=0-g|0;c[n>>2]=f;break b}}}}while(0);s=Fe[c[o+256>>2]&63](o+256|0,g,e,c[n>>2]|0,b)|0;c:do{switch(s|0){case 22:{c[o+348>>2]=RSa(o,b,e,c[n>>2]|0)|0;if((c[o+348>>2]|0)==0){r=92;break a}a[o+352|0]=0;c[o+332>>2]=0;a[o+353|0]=0;r=102;break};case 57:{t=MSa(o,1,e,c[n>>2]|0)|0;if((t|0)!=0){r=35;break a}b=c[o+144>>2]|0;h=0;break};case 32:case 31:{if((d[l+128|0]|0)==0){break c}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)!=0){u=231192}else{u=(s|0)==32?231176:231200}if((SSa(o+416|0,u)|0)==0){r=111;break a}if((TSa(o+416|0,b,e,c[n>>2]|0)|0)==0){r=113;break a}c[o+332>>2]=c[o+432>>2];h=0;break};case 23:{a[o+352|0]=1;c[o+332>>2]=231096;r=102;break};case 24:{a[o+353|0]=1;c[o+332>>2]=231104;r=102;break};case 25:{c[o+332>>2]=231112;r=102;break};case 26:{c[o+332>>2]=231120;r=102;break};case 27:{c[o+332>>2]=231128;r=102;break};case 28:{c[o+332>>2]=231136;r=102;break};case 29:{c[o+332>>2]=231152;r=102;break};case 8:{if((c[o+320>>2]|0)!=0){je[c[o+84>>2]&31](c[o+4>>2]|0,c[o+320>>2]|0,c[o+324>>2]|0,c[o+328>>2]|0,0);iSa(o+416|0);h=0}if((c[o+324>>2]|0)!=0){r=57}else{if((d[o+489|0]|0)!=0){r=57}}if((r|0)==57){r=0;v=a[l+129|0]|0;a[l+129|0]=1;do{if((c[o+492>>2]|0)!=0){if((c[o+112>>2]|0)==0){break}w=ESa(o,l+132|0,231088,36)|0;if((w|0)==0){r=60;break a}if((a[o+489|0]|0)!=0){c[w+20>>2]=c[o+360>>2]}a[l+131|0]=0;if((Fe[c[o+112>>2]&63](c[o+116>>2]|0,0,c[w+20>>2]|0,c[w+16>>2]|0,c[w+24>>2]|0)|0)==0){r=64;break a}if((a[l+131|0]|0)==0){if((c[o+324>>2]|0)!=0){break}a[l+129|0]=v;break}if((a[l+130|0]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((pe[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=69;break a}}}while(0);a[o+489|0]=0}if((c[o+88>>2]|0)==0){break c}me[c[o+88>>2]&2047](c[o+4>>2]|0);h=0;break};case 6:{a[o+489|0]=0;c[o+316>>2]=ESa(o,l+132|0,231088,36)|0;if((c[o+316>>2]|0)==0){r=38;break a}a[l+129|0]=1;if((c[o+84>>2]|0)==0){r=45;break c}if((Oe[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)==0){r=41;break a}v=NSa(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((v|0)==0){r=43;break a}OSa(v);c[o+432>>2]=c[o+428>>2];c[o+328>>2]=v;h=0;r=47;break};case 1:{x=MSa(o,0,e,c[n>>2]|0)|0;if((x|0)!=0){r=25;break a}b=c[o+144>>2]|0;h=0;break};case 2:{r=75;break a;break};case 4:{if((c[o+84>>2]|0)!=0){c[o+320>>2]=NSa(o+416|0,b,e,c[n>>2]|0)|0;if((c[o+320>>2]|0)==0){r=29;break a}c[o+432>>2]=c[o+428>>2];c[o+328>>2]=0;h=0}c[o+324>>2]=0;break};case 34:{c[o+344>>2]=QSa(o,b,e,c[n>>2]|0)|0;if((c[o+344>>2]|0)!=0){r=102}else{r=90;break a}break};case 7:{if((c[o+84>>2]|0)==0){break c}je[c[o+84>>2]&31](c[o+4>>2]|0,c[o+320>>2]|0,c[o+324>>2]|0,c[o+328>>2]|0,1);c[o+320>>2]=0;iSa(o+416|0);h=0;break};case 14:{r=45;break};case 30:{c[o+332>>2]=231160;r=102;break};case 36:case 35:{if((a[l+128|0]|0)==0){break c}if((USa(c[o+344>>2]|0,c[o+348>>2]|0,a[o+352|0]|0,a[o+353|0]|0,0,o)|0)==0){r=117;break a}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)==0){break c}do{if((a[c[o+332>>2]|0]|0)==40){r=123}else{if((a[c[o+332>>2]|0]|0)!=78){break}if((a[(c[o+332>>2]|0)+1|0]|0)==79){r=123}}}while(0);if((r|0)==123){r=0;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((BSa(o+416|0)|0)<<24>>24!=0)){r=128;break a}}v=o+428|0;w=c[v>>2]|0;c[v>>2]=w+1;a[w]=41;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((BSa(o+416|0)|0)<<24>>24!=0)){r=128;break a}}w=o+428|0;v=c[w>>2]|0;c[w>>2]=v+1;a[v]=0;c[o+332>>2]=c[o+432>>2];c[o+432>>2]=c[o+428>>2]}c[q>>2]=e;ye[c[o+132>>2]&31](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,c[c[o+348>>2]>>2]|0,c[o+332>>2]|0,0,(s|0)==36|0);iSa(o+416|0);h=0;break};case 5:{a[o+489|0]=0;a[l+129|0]=1;v=o;if((c[o+84>>2]|0)!=0){c[o+324>>2]=NSa(v+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((c[o+324>>2]|0)==0){r=156;break a}c[o+432>>2]=c[o+428>>2];h=0}else{c[v+324>>2]=231088}do{if((a[l+130|0]|0)==0){if((c[o+492>>2]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((pe[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=163;break a}}}while(0);if((c[o+316>>2]|0)!=0){r=168;break c}c[o+316>>2]=ESa(o,l+132|0,231088,36)|0;if((c[o+316>>2]|0)==0){r=166;break a}c[(c[o+316>>2]|0)+24>>2]=0;r=168;break};case 38:case 37:{if((a[l+128|0]|0)==0){break c}y=VSa(o,b,a[o+352|0]|0,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0,l+80|0)|0;if((y|0)!=0){r=132;break a}v=c[l+96>>2]|0;c[l+96>>2]=c[l+92>>2];if((USa(c[o+344>>2]|0,c[o+348>>2]|0,a[o+352|0]|0,0,v,o)|0)==0){r=134;break a}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)==0){break c}do{if((a[c[o+332>>2]|0]|0)==40){r=140}else{if((a[c[o+332>>2]|0]|0)!=78){break}if((a[(c[o+332>>2]|0)+1|0]|0)==79){r=140}}}while(0);if((r|0)==140){r=0;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((BSa(o+416|0)|0)<<24>>24!=0)){r=145;break a}}w=o+428|0;z=c[w>>2]|0;c[w>>2]=z+1;a[z]=41;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((BSa(o+416|0)|0)<<24>>24!=0)){r=145;break a}}z=o+428|0;w=c[z>>2]|0;c[z>>2]=w+1;a[w]=0;c[o+332>>2]=c[o+432>>2];c[o+432>>2]=c[o+428>>2]}c[q>>2]=e;ye[c[o+132>>2]&31](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,c[c[o+348>>2]>>2]|0,c[o+332>>2]|0,v,(s|0)==38|0);iSa(o+416|0);h=0;break};case 12:{if((a[l+128|0]|0)==0){break c}A=WSa(o,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;w=c[l+120>>2]|0;do{if((c[o+316>>2]|0)!=0){c[(c[o+316>>2]|0)+4>>2]=w;c[(c[o+316>>2]|0)+8>>2]=(c[l+116>>2]|0)-(c[l+120>>2]|0);c[l+120>>2]=c[l+116>>2];if((c[o+136>>2]|0)==0){break}c[q>>2]=e;De[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,d[(c[o+316>>2]|0)+33|0]|0,c[(c[o+316>>2]|0)+4>>2]|0,c[(c[o+316>>2]|0)+8>>2]|0,c[o+360>>2]|0,0,0,0);h=0}else{c[l+116>>2]=w}}while(0);if((A|0)!=0){r=153;break a}break};case 13:{r=168;break};case 15:{if((d[l+128|0]|0)==0){break c}if((c[o+316>>2]|0)==0){break c}if((c[o+136>>2]|0)==0){break c}c[q>>2]=e;De[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,d[(c[o+316>>2]|0)+33|0]|0,0,0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,0);h=0;break};case 16:{if((d[l+128|0]|0)==0){break c}if((c[o+316>>2]|0)==0){break c}w=NSa(l+80|0,b,e,c[n>>2]|0)|0;c[(c[o+316>>2]|0)+28>>2]=w;if((c[(c[o+316>>2]|0)+28>>2]|0)==0){r=181;break a}c[l+96>>2]=c[l+92>>2];if((c[o+92>>2]|0)!=0){c[q>>2]=e;ye[c[o+92>>2]&31](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,c[(c[o+316>>2]|0)+28>>2]|0);h=0;break c}if((c[o+136>>2]|0)==0){break c}c[q>>2]=e;De[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,0,0,0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,c[(c[o+316>>2]|0)+28>>2]|0);h=0;break};case 9:{if((se[c[b+48>>2]&63](b,e,c[n>>2]|0)|0)!=0){c[o+316>>2]=0;break c}w=l+80|0;if((a[l+128|0]|0)==0){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}v=NSa(w,b,e,c[n>>2]|0)|0;if((v|0)==0){r=190;break a}c[o+316>>2]=ESa(o,l,v,36)|0;if((c[o+316>>2]|0)==0){r=192;break a}w=l+80|0;if((c[c[o+316>>2]>>2]|0)!=(v|0)){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}c[l+96>>2]=c[w+12>>2];c[(c[o+316>>2]|0)+24>>2]=0;a[(c[o+316>>2]|0)+33|0]=0;if((c[o+476>>2]|0)!=0){B=1}else{B=(c[o+300>>2]|0)!=0}a[(c[o+316>>2]|0)+34|0]=(B^1)&1;if((c[o+136>>2]|0)==0){break c}h=0;break};case 10:{w=l+80|0;if((a[l+128|0]|0)==0){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}v=NSa(w,b,e,c[n>>2]|0)|0;if((v|0)==0){r=202;break a}c[o+316>>2]=ESa(o,l+132|0,v,36)|0;if((c[o+316>>2]|0)==0){r=204;break a}w=l+80|0;if((c[c[o+316>>2]>>2]|0)!=(v|0)){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}c[l+96>>2]=c[w+12>>2];c[(c[o+316>>2]|0)+24>>2]=0;a[(c[o+316>>2]|0)+33|0]=1;if((c[o+476>>2]|0)!=0){C=1}else{C=(c[o+300>>2]|0)!=0}a[(c[o+316>>2]|0)+34|0]=(C^1)&1;if((c[o+136>>2]|0)==0){break c}h=0;break};case 58:{if((c[o+80>>2]|0)!=0){zSa(o,b,e,c[n>>2]|0)}h=0;D=XSa(o,b,n,f,j,k)|0;if((D|0)!=0){r=239;break a}if((c[n>>2]|0)==0){r=241;break a}break};case 18:{c[o+340>>2]=0;c[o+336>>2]=0;if((c[o+96>>2]|0)==0){break c}c[o+336>>2]=NSa(o+416|0,b,e,c[n>>2]|0)|0;if((c[o+336>>2]|0)==0){r=214;break a}c[o+432>>2]=c[o+428>>2];h=0;break};case 21:{if((Oe[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)==0){r=217;break a}if((c[o+336>>2]|0)==0){break c}w=NSa(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((w|0)==0){r=220;break a}OSa(w);c[o+340>>2]=w;c[o+432>>2]=c[o+428>>2];h=0;break};case 19:{do{if((c[o+336>>2]|0)!=0){if((c[o+96>>2]|0)==0){break}w=NSa(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((w|0)==0){r=225;break a}c[q>>2]=e;je[c[o+96>>2]&31](c[o+4>>2]|0,c[o+336>>2]|0,c[o+360>>2]|0,w,c[o+340>>2]|0);h=0}}while(0);iSa(o+416|0);break};case 20:{do{if((c[o+340>>2]|0)!=0){if((c[o+96>>2]|0)==0){break}c[q>>2]=e;je[c[o+96>>2]&31](c[o+4>>2]|0,c[o+336>>2]|0,c[o+360>>2]|0,0,c[o+340>>2]|0);h=0}}while(0);iSa(o+416|0);break};case-1:{r=232;break a;break};case 44:{do{if((c[o+260>>2]|0)>>>0>=(c[o+468>>2]|0)>>>0){w=o+12|0;if((c[o+468>>2]|0)==0){v=c[w>>2]|0;c[o+468>>2]=32;c[o+464>>2]=pe[v&127](32)|0;if((c[o+464>>2]|0)!=0){break}else{r=251;break a}}v=c[w+4>>2]|0;w=c[o+464>>2]|0;z=o+468|0;E=c[z>>2]<<1;c[z>>2]=E;z=Ee[v&63](w,E)|0;if((z|0)==0){r=245;break a}c[o+464>>2]=z;if((c[l+184>>2]|0)==0){break}z=Ee[c[o+16>>2]&63](c[l+184>>2]|0,c[o+468>>2]<<2)|0;if((z|0)==0){r=248;break a}c[l+184>>2]=z}}while(0);a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=0;if((a[l+160|0]|0)==0){break c}z=ZSa(o)|0;if((z|0)<0){r=254;break a}c[(c[l+184>>2]|0)+(c[l+180>>2]<<2)>>2]=z;E=l+180|0;c[E>>2]=(c[E>>2]|0)+1;c[(c[l+164>>2]|0)+(z*28|0)>>2]=6;if((c[o+128>>2]|0)==0){break c}h=0;break};case 50:{if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)==124){r=258;break a}a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=44;if((d[l+160|0]|0)==0){break c}if((c[o+128>>2]|0)==0){break c}h=0;break};case 49:{if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)==44){r=263;break a}do{if((d[l+160|0]|0)!=0){if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)!=0){break}if((c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]|0)==3){break}c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=5;if((c[o+128>>2]|0)==0){break}h=0}}while(0);a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=124;break};case 59:case 60:{a[l+129|0]=1;z=l;do{if((c[o+492>>2]|0)!=0){E=NSa(z+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((E|0)==0){r=273;break a}w=ESa(o,l+132|0,E,0)|0;c[l+92>>2]=c[l+96>>2];do{if((c[o+272>>2]|0)!=0){if((d[l+130|0]|0)!=0){if((c[o+300>>2]|0)!=0){r=282;break}}else{if((a[l+129|0]|0)!=0){r=282;break}}if((w|0)==0){r=279;break a}if((a[w+34|0]|0)==0){r=281;break a}}else{r=282}}while(0);do{if((r|0)==282){r=0;if((w|0)!=0){break}a[l+128|0]=a[l+130|0]|0;if((s|0)!=60){break c}if((c[o+120>>2]|0)==0){break c}Le[c[o+120>>2]&15](c[o+4>>2]|0,E,1);h=0;break c}}while(0);if((a[w+32|0]|0)!=0){r=287;break a}if((c[w+4>>2]|0)!=0){F=_Sa(o,w,((s|0)==60?1:0)&255)|0;if((F|0)!=0){r=290;break a}h=0;break c}E=l;if((c[o+112>>2]|0)==0){a[l+128|0]=a[E+130|0]|0;break c}a[E+131|0]=0;a[w+32|0]=1;E=(Fe[c[o+112>>2]&63](c[o+116>>2]|0,0,c[w+20>>2]|0,c[w+16>>2]|0,c[w+24>>2]|0)|0)!=0;a[w+32|0]=0;if(!E){r=294;break a}h=0;if((a[l+131|0]|0)!=0){break}a[l+128|0]=a[l+130|0]|0;break c}else{a[l+128|0]=a[z+130|0]|0}}while(0);if((a[l+130|0]|0)!=0){break c}if((c[o+108>>2]|0)==0){break c}if((pe[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=301;break a}break};case 53:{G=1;r=319;break};case 52:{G=2;r=319;break};case 54:{G=3;r=319;break};case 40:{if((c[o+128>>2]|0)==0){break c}c[o+344>>2]=QSa(o,b,e,c[n>>2]|0)|0;if((c[o+344>>2]|0)==0){r=304;break a}c[l+180>>2]=0;c[l+176>>2]=0;a[l+160|0]=1;h=0;break};case 42:case 41:{if((a[l+160|0]|0)==0){break c}if((c[o+128>>2]|0)!=0){z=pe[c[o+12>>2]&127](20)|0;if((z|0)==0){r=309;break a}c[z+4>>2]=0;c[z+8>>2]=0;c[z+12>>2]=0;c[z+16>>2]=0;c[z>>2]=(s|0)==41?2:1;c[q>>2]=e;Le[c[o+128>>2]&15](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,z);h=0}a[l+160|0]=0;break};case 43:{if((a[l+160|0]|0)==0){break c}c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=3;if((c[o+128>>2]|0)==0){break c}h=0;break};case 51:{G=0;r=319;break};case 47:{G=1;r=334;break};case 46:{G=2;r=334;break};case 48:{G=3;r=334;break};case 45:{G=0;r=334;break};case 56:{if((bTa(o,b,e,c[n>>2]|0)|0)==0){r=347;break a}h=0;break};case 0:{if((g|0)!=14){break c}h=0;break};case 3:{if((c[o+84>>2]|0)==0){break c}h=0;break};case 11:{if((d[l+128|0]|0)==0){break c}if((c[o+136>>2]|0)==0){break c}h=0;break};case 55:{if((aTa(o,b,e,c[n>>2]|0)|0)==0){r=344;break a}h=0;break};case 17:{if((c[o+96>>2]|0)==0){break c}h=0;break};case 33:{if((d[l+128|0]|0)==0){break c}if((c[o+132>>2]|0)==0){break c}h=0;break};case 39:{if((c[o+128>>2]|0)==0){break c}h=0;break};default:{}}}while(0);do{if((r|0)==45){r=0;if((Oe[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)!=0){r=47}else{r=46;break a}}else if((r|0)==102){r=0;if((d[l+128|0]|0)==0){break}if((c[o+132>>2]|0)==0){break}h=0}else if((r|0)==168){r=0;if((d[l+128|0]|0)==0){break}if((c[o+316>>2]|0)==0){break}s=NSa(l+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;c[(c[o+316>>2]|0)+16>>2]=s;if((c[(c[o+316>>2]|0)+16>>2]|0)==0){r=171;break a}c[(c[o+316>>2]|0)+20>>2]=c[o+360>>2];c[l+96>>2]=c[l+92>>2];if((c[o+136>>2]|0)==0){break}h=0}else if((r|0)==319){r=0;if((a[l+160|0]|0)==0){break}s=c[n>>2]|0;if((G|0)==0){H=s}else{H=s+(0-(c[b+68>>2]|0))|0}s=ZSa(o)|0;if((s|0)<0){r=323;break a}c[(c[l+164>>2]|0)+(s*28|0)>>2]=4;c[(c[l+164>>2]|0)+(s*28|0)+4>>2]=G;z=QSa(o,b,e,H)|0;if((z|0)==0){r=325;break a}E=c[z>>2]|0;c[(c[l+164>>2]|0)+(s*28|0)+8>>2]=E;s=0;do{z=s;s=z+1|0;}while((a[E+z|0]|0)!=0);E=l+168|0;c[E>>2]=(c[E>>2]|0)+s;if((c[o+128>>2]|0)==0){break}h=0}else if((r|0)==334){r=0;if((a[l+160|0]|0)==0){break}if((c[o+128>>2]|0)!=0){h=0}E=l+180|0;c[E>>2]=(c[E>>2]|0)+ -1;c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+(c[l+180>>2]<<2)>>2]|0)*28|0)+4>>2]=G;if((c[l+180>>2]|0)!=0){break}if(!(h<<24>>24!=0)){E=$Sa(o)|0;if((E|0)==0){r=340;break a}c[q>>2]=e;Le[c[o+128>>2]&15](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,E)}a[l+160|0]=0;c[l+168>>2]=0}}while(0);do{if((r|0)==47){r=0;if((d[l+128|0]|0)==0){break}if((c[o+316>>2]|0)==0){break}E=NSa(l+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((E|0)==0){r=50;break a}OSa(E);c[(c[o+316>>2]|0)+24>>2]=E;c[l+96>>2]=c[l+92>>2];if((c[o+136>>2]|0)==0){break}h=0}}while(0);do{if((h&255|0)!=0){if((c[o+80>>2]|0)==0){break}zSa(o,b,e,c[n>>2]|0)}}while(0);h=c[o+480>>2]|0;if((h|0)==3){r=367;break}else if((h|0)==2){r=368;break}e=c[n>>2]|0;g=Oe[c[b>>2]&63](b,e,f,n)|0}if((r|0)==7){c[j>>2]=e;I=0;J=I;i=m;return J|0}else if((r|0)==9){c[p>>2]=c[n>>2];I=4;J=I;i=m;return J|0}else if((r|0)==10){I=5;J=I;i=m;return J|0}else if((r|0)==11){I=6;J=I;i=m;return J|0}else if((r|0)==13){do{if((b|0)!=(c[o+144>>2]|0)){if((a[(c[o+300>>2]|0)+20|0]|0)!=0){break}c[j>>2]=e;I=0;J=I;i=m;return J|0}}while(0);do{if((d[o+488|0]|0)==0){if((b|0)!=(c[o+144>>2]|0)){break}I=3;J=I;i=m;return J|0}}while(0);if((Fe[c[o+256>>2]&63](o+256|0,-4,f,f,b)|0)==-1){I=29;J=I;i=m;return J|0}else{c[j>>2]=e;I=0;J=I;i=m;return J|0}}else if((r|0)==25){I=x;J=I;i=m;return J|0}else if((r|0)==29){I=1;J=I;i=m;return J|0}else if((r|0)==35){I=t;J=I;i=m;return J|0}else if((r|0)==38){I=1;J=I;i=m;return J|0}else if((r|0)==41){I=32;J=I;i=m;return J|0}else if((r|0)==43){I=1;J=I;i=m;return J|0}else if((r|0)==46){I=32;J=I;i=m;return J|0}else if((r|0)==50){I=1;J=I;i=m;return J|0}else if((r|0)==60){I=1;J=I;i=m;return J|0}else if((r|0)==64){I=21;J=I;i=m;return J|0}else if((r|0)==69){I=22;J=I;i=m;return J|0}else if((r|0)==75){do{if((a[o+489|0]|0)!=0){t=a[l+129|0]|0;a[l+129|0]=1;if((c[o+492>>2]|0)==0){break}if((c[o+112>>2]|0)==0){break}x=ESa(o,l+132|0,231088,36)|0;if((x|0)==0){I=1;J=I;i=m;return J|0}c[x+20>>2]=c[o+360>>2];a[l+131|0]=0;if((Fe[c[o+112>>2]&63](c[o+116>>2]|0,0,c[x+20>>2]|0,c[x+16>>2]|0,c[x+24>>2]|0)|0)==0){I=21;J=I;i=m;return J|0}if((a[l+131|0]|0)==0){a[l+129|0]=t;break}if((a[l+130|0]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((pe[c[o+108>>2]&127](c[o+4>>2]|0)|0)!=0){break}I=22;J=I;i=m;return J|0}}while(0);c[o+280>>2]=38;I=PSa(o,e,f,j)|0;J=I;i=m;return J|0}else if((r|0)==90){I=1;J=I;i=m;return J|0}else if((r|0)==92){I=1;J=I;i=m;return J|0}else if((r|0)==111){I=1;J=I;i=m;return J|0}else if((r|0)==113){I=1;J=I;i=m;return J|0}else if((r|0)==117){I=1;J=I;i=m;return J|0}else if((r|0)==128){I=1;J=I;i=m;return J|0}else if((r|0)==132){I=y;J=I;i=m;return J|0}else if((r|0)==134){I=1;J=I;i=m;return J|0}else if((r|0)==145){I=1;J=I;i=m;return J|0}else if((r|0)==153){I=A;J=I;i=m;return J|0}else if((r|0)==156){I=1;J=I;i=m;return J|0}else if((r|0)==163){I=22;J=I;i=m;return J|0}else if((r|0)==166){I=1;J=I;i=m;return J|0}else if((r|0)==171){I=1;J=I;i=m;return J|0}else if((r|0)==181){I=1;J=I;i=m;return J|0}else if((r|0)==190){I=1;J=I;i=m;return J|0}else if((r|0)==192){I=1;J=I;i=m;return J|0}else if((r|0)==202){I=1;J=I;i=m;return J|0}else if((r|0)==204){I=1;J=I;i=m;return J|0}else if((r|0)==214){I=1;J=I;i=m;return J|0}else if((r|0)==217){I=32;J=I;i=m;return J|0}else if((r|0)==220){I=1;J=I;i=m;return J|0}else if((r|0)==225){I=1;J=I;i=m;return J|0}else if((r|0)==232){A=g;if((A|0)==28){I=10;J=I;i=m;return J|0}else if((A|0)==12){I=17;J=I;i=m;return J|0}else{I=2;J=I;i=m;return J|0}}else if((r|0)==239){I=D;J=I;i=m;return J|0}else if((r|0)==241){c[o+280>>2]=39;I=D;J=I;i=m;return J|0}else if((r|0)==245){I=1;J=I;i=m;return J|0}else if((r|0)==248){I=1;J=I;i=m;return J|0}else if((r|0)==251){I=1;J=I;i=m;return J|0}else if((r|0)==254){I=1;J=I;i=m;return J|0}else if((r|0)==258){I=2;J=I;i=m;return J|0}else if((r|0)==263){I=2;J=I;i=m;return J|0}else if((r|0)==273){I=1;J=I;i=m;return J|0}else if((r|0)==279){I=11;J=I;i=m;return J|0}else if((r|0)==281){I=24;J=I;i=m;return J|0}else if((r|0)==287){I=12;J=I;i=m;return J|0}else if((r|0)==290){I=F;J=I;i=m;return J|0}else if((r|0)==294){I=21;J=I;i=m;return J|0}else if((r|0)==301){I=22;J=I;i=m;return J|0}else if((r|0)==304){I=1;J=I;i=m;return J|0}else if((r|0)==309){I=1;J=I;i=m;return J|0}else if((r|0)==323){I=1;J=I;i=m;return J|0}else if((r|0)==325){I=1;J=I;i=m;return J|0}else if((r|0)==340){I=1;J=I;i=m;return J|0}else if((r|0)==344){I=1;J=I;i=m;return J|0}else if((r|0)==347){I=1;J=I;i=m;return J|0}else if((r|0)==367){c[j>>2]=c[n>>2];I=0;J=I;i=m;return J|0}else if((r|0)==368){I=35;J=I;i=m;return J|0}return 0}function MSa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+104|0;h=g+40|0;j=g+56|0;k=g+64|0;l=g+72|0;m=g+88|0;n=b;b=d;d=e;e=f;c[h>>2]=0;f=0;c[j>>2]=0;c[k>>2]=0;o=0;c[m>>2]=-1;p=(b|0)!=0;if((oe[((a[n+236|0]&255|0)!=0?1:2)&7](b,c[n+144>>2]|0,d,e,n+288|0,k,l,h,j,m)|0)==0){if(p){q=31;r=q;i=g;return r|0}else{q=30;r=q;i=g;return r|0}}do{if(!p){if((c[m>>2]|0)!=1){break}a[(c[n+356>>2]|0)+130|0]=1;if((c[n+492>>2]|0)!=1){break}c[n+492>>2]=0}}while(0);do{if((c[n+140>>2]|0)!=0){do{if((c[h>>2]|0)!=0){p=c[n+144>>2]|0;b=c[h>>2]|0;s=c[h>>2]|0;f=NSa(n+440|0,p,b,s+(Ee[c[(c[n+144>>2]|0)+32>>2]&63](c[n+144>>2]|0,c[h>>2]|0)|0)|0)|0;if((f|0)!=0){c[n+456>>2]=c[n+452>>2];break}q=1;r=q;i=g;return r|0}}while(0);do{if((c[k>>2]|0)!=0){o=NSa(n+440|0,c[n+144>>2]|0,c[k>>2]|0,(c[l>>2]|0)+(0-(c[(c[n+144>>2]|0)+68>>2]|0))|0)|0;if((o|0)!=0){break}q=1;r=q;i=g;return r|0}}while(0);Pe[c[n+140>>2]&127](c[n+4>>2]|0,o,f,c[m>>2]|0)}else{if((c[n+80>>2]|0)==0){break}zSa(n,c[n+144>>2]|0,d,e)}}while(0);do{if((c[n+232>>2]|0)==0){if((c[j>>2]|0)!=0){if((c[(c[j>>2]|0)+68>>2]|0)==(c[(c[n+144>>2]|0)+68>>2]|0)){c[n+144>>2]=c[j>>2];break}c[n+288>>2]=c[h>>2];q=19;r=q;i=g;return r|0}if((c[h>>2]|0)==0){break}do{if((f|0)==0){e=c[n+144>>2]|0;d=c[h>>2]|0;m=c[h>>2]|0;f=NSa(n+440|0,e,d,m+(Ee[c[(c[n+144>>2]|0)+32>>2]&63](c[n+144>>2]|0,c[h>>2]|0)|0)|0)|0;if((f|0)!=0){break}q=1;r=q;i=g;return r|0}}while(0);m=pTa(n,f)|0;iSa(n+440|0);if((m|0)==18){c[n+288>>2]=c[h>>2]}q=m;r=q;i=g;return r|0}}while(0);if((f|0)!=0){t=34}else{if((o|0)!=0){t=34}}if((t|0)==34){iSa(n+440|0)}q=0;r=q;i=g;return r|0}function NSa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+40|0;h=b;if((TSa(h,d,e,f)|0)==0){j=0;k=j;i=g;return k|0}do{if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if((BSa(h)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);f=h+12|0;e=c[f>>2]|0;c[f>>2]=e+1;a[e]=0;j=c[h+16>>2]|0;k=j;i=g;return k|0}function OSa(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=i;i=i+24|0;d=b;b=d;e=d;while(1){if((a[e]|0)==0){break}f=a[e]|0;do{if((f|0)==10|(f|0)==13|(f|0)==32){if((b|0)==(d|0)){break}if((a[b+ -1|0]|0)==32){break}g=b;b=g+1|0;a[g]=32}else{g=b;b=g+1|0;a[g]=a[e]|0}}while(0);e=e+1|0}if((b|0)==(d|0)){h=b;a[h]=0;i=c;return}if((a[b+ -1|0]|0)!=32){h=b;a[h]=0;i=c;return}b=b+ -1|0;h=b;a[h]=0;i=c;return}function PSa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=eTa(h,0,c[h+144>>2]|0,d,e,f,((a[h+484|0]|0)!=0^1)&1)|0;do{if((b|0)==0){if((mTa(h)|0)<<24>>24!=0){break}j=1;k=j;i=g;return k|0}}while(0);j=b;k=j;i=g;return k|0}function QSa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=a;a=c[g+356>>2]|0;h=NSa(a+80|0,b,d,e)|0;if((h|0)==0){j=0;k=j;i=f;return k|0}e=ESa(g,a+20|0,h,24)|0;if((e|0)==0){j=0;k=j;i=f;return k|0}d=a+80|0;do{if((c[e>>2]|0)!=(h|0)){c[a+92>>2]=c[d+16>>2]}else{c[a+96>>2]=c[d+12>>2];if((nTa(g,e)|0)!=0){break}j=0;k=j;i=f;return k|0}}while(0);j=e;k=j;i=f;return k|0}function RSa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+80|0;h=b;b=d;d=e;e=f;f=c[h+356>>2]|0;do{if((c[f+92>>2]|0)==(c[f+88>>2]|0)){if((BSa(f+80|0)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);l=f+92|0;m=c[l>>2]|0;c[l>>2]=m+1;a[m]=0;m=NSa(f+80|0,b,d,e)|0;if((m|0)==0){j=0;k=j;i=g;return k|0}m=m+1|0;e=ESa(h,f+40|0,m,12)|0;if((e|0)==0){j=0;k=j;i=g;return k|0}d=f+80|0;a:do{if((c[e>>2]|0)!=(m|0)){c[f+92>>2]=c[d+16>>2]}else{c[f+96>>2]=c[d+12>>2];if((a[h+236|0]|0)==0){break}do{if((a[m]|0)==120){if((a[m+1|0]|0)!=109){break}if((a[m+2|0]|0)!=108){break}if((a[m+3|0]|0)!=110){break}if((a[m+4|0]|0)!=115){break}if((a[m+5|0]|0)!=0){if((a[m+5|0]|0)!=58){break}}if((a[m+5|0]|0)==0){c[e+4>>2]=f+152}else{c[e+4>>2]=ESa(h,f+60|0,m+6|0,8)|0}a[e+9|0]=1;break a}}while(0);b=0;while(1){if((a[m+b|0]|0)==0){break a}if((a[m+b|0]|0)==58){break}b=b+1|0}l=0;while(1){n=(c[f+92>>2]|0)==(c[f+88>>2]|0);if((l|0)>=(b|0)){break}if(n){if(!((BSa(f+80|0)|0)<<24>>24!=0)){o=30;break}}p=a[m+l|0]|0;q=f+92|0;r=c[q>>2]|0;c[q>>2]=r+1;a[r]=p;l=l+1|0}if((o|0)==30){j=0;k=j;i=g;return k|0}do{if(n){if((BSa(f+80|0)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);l=f+92|0;b=c[l>>2]|0;c[l>>2]=b+1;a[b]=0;c[e+4>>2]=ESa(h,f+60|0,c[f+96>>2]|0,8)|0;b=f+80|0;if((c[c[e+4>>2]>>2]|0)==(c[f+96>>2]|0)){c[f+96>>2]=c[b+12>>2];break}else{c[f+92>>2]=c[b+16>>2];break}}}while(0);j=e;k=j;i=g;return k|0}function SSa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+24|0;f=b;b=d;while(1){g=f;if((a[b]|0)==0){h=7;break}if((c[g+12>>2]|0)==(c[f+8>>2]|0)){if(!((BSa(f)|0)<<24>>24!=0)){h=6;break}}d=a[b]|0;j=f+12|0;k=c[j>>2]|0;c[j>>2]=k+1;a[k]=d;b=b+1|0}if((h|0)==6){l=0;m=l;i=e;return m|0}else if((h|0)==7){l=c[g+16>>2]|0;m=l;i=e;return m|0}return 0}function TSa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+40|0;g=f+24|0;h=a;a=b;c[g>>2]=d;d=e;do{if((c[h+12>>2]|0)==0){if((BSa(h)|0)<<24>>24!=0){break}j=0;k=j;i=f;return k|0}}while(0);while(1){je[c[a+60>>2]&31](a,g,d,h+12|0,c[h+8>>2]|0);l=h;if((c[g>>2]|0)==(d|0)){m=7;break}if(!((BSa(l)|0)<<24>>24!=0)){m=6;break}}if((m|0)==6){j=0;k=j;i=f;return k|0}else if((m|0)==7){j=c[l+16>>2]|0;k=j;i=f;return k|0}return 0}function USa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+88|0;k=b;b=d;d=e;e=f;f=g;g=h;if((f|0)!=0){l=3}else{if((e&255|0)!=0){l=3}}do{if((l|0)==3){h=0;while(1){if((h|0)>=(c[k+12>>2]|0)){break}if((b|0)==(c[(c[k+20>>2]|0)+(h*12|0)>>2]|0)){l=6;break}h=h+1|0}if((l|0)==6){m=1;n=m;i=j;return n|0}if((e&255|0)==0){break}if((c[k+8>>2]|0)!=0){break}if((a[b+9|0]|0)!=0){break}c[k+8>>2]=b}}while(0);do{if((c[k+12>>2]|0)==(c[k+16>>2]|0)){e=k+16|0;if((c[k+16>>2]|0)==0){c[e>>2]=8;c[k+20>>2]=pe[c[g+12>>2]&127]((c[k+16>>2]|0)*12|0)|0;if((c[k+20>>2]|0)!=0){break}m=0;n=m;i=j;return n|0}l=c[e>>2]<<1;e=Ee[c[g+16>>2]&63](c[k+20>>2]|0,l*12|0)|0;if((e|0)!=0){c[k+16>>2]=l;c[k+20>>2]=e;break}m=0;n=m;i=j;return n|0}}while(0);g=(c[k+20>>2]|0)+((c[k+12>>2]|0)*12|0)|0;c[g>>2]=b;c[g+8>>2]=f;a[g+4|0]=d;if(!(d<<24>>24!=0)){a[b+8|0]=1}b=k+12|0;c[b>>2]=(c[b>>2]|0)+1;m=1;n=m;i=j;return n|0}function VSa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;i=i+64|0;k=e;e=h;h=oTa(b,d,k,f,g,e)|0;if((h|0)!=0){l=h;m=l;i=j;return m|0}do{if(!(k<<24>>24!=0)){if(((c[e+12>>2]|0)-(c[e+16>>2]|0)|0)==0){break}if((a[(c[e+12>>2]|0)+ -1|0]|0)!=32){break}h=e+12|0;c[h>>2]=(c[h>>2]|0)+ -1}}while(0);do{if((c[e+12>>2]|0)==(c[e+8>>2]|0)){if((BSa(e)|0)<<24>>24!=0){break}l=1;m=l;i=j;return m|0}}while(0);k=e+12|0;e=c[k>>2]|0;c[k>>2]=e+1;a[e]=0;l=0;m=l;i=j;return m|0}function WSa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=i;i=i+128|0;j=h+72|0;k=h+104|0;l=b;b=e;e=f;f=g;g=c[l+356>>2]|0;m=g+104|0;n=0;o=c[l+276>>2]|0;c[l+276>>2]=1;do{if((c[m>>2]|0)==0){if((BSa(m)|0)<<24>>24!=0){break}p=1;q=p;i=h;return q|0}}while(0);a:while(1){b:do{switch(Oe[c[b+20>>2]&63](b,e,f,j)|0){case-4:{r=24;break a;break};case 6:case 9:{if((TSa(m,b,e,c[j>>2]|0)|0)==0){r=26;break a}break};case 0:{r=49;break a;break};case 10:{s=Ee[c[b+44>>2]&63](b,e)|0;if((s|0)<0){r=33;break a}s=vTa(s,k)|0;if((s|0)==0){r=37;break a}t=0;while(1){if((t|0)>=(s|0)){break b}if((c[m+8>>2]|0)==(c[m+12>>2]|0)){if(!((BSa(m)|0)<<24>>24!=0)){r=44;break a}}u=a[k+t|0]|0;v=m+12|0;w=c[v>>2]|0;c[v>>2]=w+1;a[w]=u;t=t+1|0}break};case 7:{r=28;break};case-3:{c[j>>2]=e+(c[b+68>>2]|0);r=28;break};case-1:{r=46;break a;break};case 28:{if((d[l+488|0]|0)==0){if((b|0)==(c[l+144>>2]|0)){r=23;break a}}t=NSa(l+416|0,b,e+(c[b+68>>2]|0)|0,(c[j>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((t|0)==0){r=8;break a}s=ESa(l,g+132|0,t,0)|0;c[l+428>>2]=c[l+432>>2];if((s|0)==0){r=10;break a}if((a[s+32|0]|0)!=0){r=12;break a}if((c[s+16>>2]|0)==0){a[s+32|0]=1;n=WSa(l,c[l+228>>2]|0,c[s+4>>2]|0,(c[s+4>>2]|0)+(c[s+8>>2]|0)|0)|0;a[s+32|0]=0;if((n|0)!=0){break a}else{break b}}t=g;if((c[l+112>>2]|0)==0){a[g+128|0]=a[t+130|0]|0;break b}a[t+131|0]=0;a[s+32|0]=1;t=(Fe[c[l+112>>2]&63](c[l+116>>2]|0,0,c[s+20>>2]|0,c[s+16>>2]|0,c[s+24>>2]|0)|0)!=0;a[s+32|0]=0;if(!t){r=18;break a}if((a[g+131|0]|0)!=0){break b}a[g+128|0]=a[g+130|0]|0;break};default:{r=52;break a}}}while(0);if((r|0)==28){r=0;if((c[m+8>>2]|0)==(c[m+12>>2]|0)){if(!((BSa(m)|0)<<24>>24!=0)){r=30;break}}t=m+12|0;s=c[t>>2]|0;c[t>>2]=s+1;a[s]=10}e=c[j>>2]|0}if((r|0)==8){n=1}else if((r|0)==10){a[g+128|0]=a[g+130|0]|0}else if((r|0)==12){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=12}else if((r|0)==18){n=21}else if((r|0)==23){c[l+288>>2]=e;n=10}else if((r|0)==24){n=0}else if((r|0)==26){n=1}else if((r|0)==30){n=1}else if((r|0)==33){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=14}else if((r|0)==37){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=14}else if((r|0)==44){n=1}else if((r|0)==46){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=4}else if((r|0)==49){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=c[j>>2]}n=4}else if((r|0)==52){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=23}c[l+276>>2]=o;p=n;q=p;i=h;return q|0}function XSa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+96|0;j=h+56|0;k=a;a=b;b=d;d=f;f=g;g=c[b>>2]|0;l=k;if((a|0)==(c[k+144>>2]|0)){m=l+288|0;c[m>>2]=g;n=k+292|0}else{m=c[l+300>>2]|0;n=(c[k+300>>2]|0)+4|0}c[m>>2]=g;c[b>>2]=0;l=Oe[c[a+12>>2]&63](a,g,e,j)|0;c[n>>2]=c[j>>2];switch(l|0){case 42:{if((c[k+80>>2]|0)!=0){zSa(k,a,g,c[j>>2]|0)}c[b>>2]=c[j>>2];c[d>>2]=c[j>>2];if((c[k+480>>2]|0)==2){o=35;p=o;i=h;return p|0}else{o=0;p=o;i=h;return p|0}break};case 0:{c[m>>2]=c[j>>2];o=4;p=o;i=h;return p|0};case-4:case-1:{if(f<<24>>24!=0){c[d>>2]=g;o=0;p=o;i=h;return p|0}else{o=2;p=o;i=h;return p|0}break};case-2:{if(f<<24>>24!=0){c[d>>2]=g;o=0;p=o;i=h;return p|0}else{o=6;p=o;i=h;return p|0}break};default:{c[m>>2]=c[j>>2];o=23;p=o;i=h;return p|0}}return 0}function YSa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=g+16|0;j=b;c[h>>2]=d;d=e;e=f;f=XSa(j,c[j+144>>2]|0,h,d,e,((a[j+484|0]|0)!=0^1)&1)|0;if((f|0)!=0){k=f;l=k;i=g;return l|0}if((c[h>>2]|0)!=0){c[j+280>>2]=40;k=KSa(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}else{k=f;l=k;i=g;return l|0}return 0}function ZSa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+56|0;d=a;a=c[d+356>>2]|0;do{if((c[a+184>>2]|0)==0){c[a+184>>2]=pe[c[d+12>>2]&127](c[d+468>>2]<<2)|0;if((c[a+184>>2]|0)!=0){c[c[a+184>>2]>>2]=0;break}e=-1;f=e;i=b;return f|0}}while(0);if((c[a+176>>2]|0)>>>0>=(c[a+172>>2]|0)>>>0){g=d+12|0;do{if((c[a+164>>2]|0)!=0){h=Ee[c[g+4>>2]&63](c[a+164>>2]|0,(c[a+172>>2]<<1)*28|0)|0;if((h|0)!=0){d=a+172|0;c[d>>2]=c[d>>2]<<1;break}e=-1;f=e;i=b;return f|0}else{h=pe[c[g>>2]&127](896)|0;if((h|0)!=0){c[a+172>>2]=32;break}e=-1;f=e;i=b;return f|0}}while(0);c[a+164>>2]=h}h=a+176|0;g=c[h>>2]|0;c[h>>2]=g+1;h=g;g=(c[a+164>>2]|0)+(h*28|0)|0;if((c[a+180>>2]|0)!=0){d=(c[a+164>>2]|0)+((c[(c[a+184>>2]|0)+((c[a+180>>2]|0)-1<<2)>>2]|0)*28|0)|0;if((c[d+16>>2]|0)!=0){c[(c[a+164>>2]|0)+((c[d+16>>2]|0)*28|0)+24>>2]=h}if((c[d+20>>2]|0)==0){c[d+12>>2]=h}c[d+16>>2]=h;a=d+20|0;c[a>>2]=(c[a>>2]|0)+1}c[g+24>>2]=0;c[g+20>>2]=0;c[g+16>>2]=0;c[g+12>>2]=0;e=h;f=e;i=b;return f|0}function _Sa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+80|0;g=f+48|0;h=b;b=d;d=e;e=h;do{if((c[h+304>>2]|0)!=0){j=c[e+304>>2]|0;c[h+304>>2]=c[j+8>>2]}else{j=pe[c[e+12>>2]&127](24)|0;if((j|0)!=0){break}k=1;l=k;i=f;return l|0}}while(0);a[b+32|0]=1;c[b+12>>2]=0;c[j+8>>2]=c[h+300>>2];c[h+300>>2]=j;c[j+12>>2]=b;c[j+16>>2]=c[h+312>>2];a[j+20|0]=d;c[j>>2]=0;c[j+4>>2]=0;d=c[b+4>>2]|0;e=(c[b+4>>2]|0)+(c[b+8>>2]|0)|0;m=h;if((a[b+33|0]|0)!=0){n=Oe[c[c[m+228>>2]>>2]&63](c[h+228>>2]|0,d,e,g)|0;o=LSa(h,c[h+228>>2]|0,d,e,n,c[g>>2]|0,g,0)|0}else{o=eTa(m,c[h+312>>2]|0,c[h+228>>2]|0,d,e,g,0)|0}a:do{if((o|0)==0){do{if((e|0)!=(c[g>>2]|0)){if((c[h+480>>2]|0)!=3){break}c[b+12>>2]=(c[g>>2]|0)-d;c[h+280>>2]=41;break a}}while(0);a[b+32|0]=0;c[h+300>>2]=c[j+8>>2];c[j+8>>2]=c[h+304>>2];c[h+304>>2]=j}}while(0);k=o;l=k;i=f;return l|0}function $Sa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+56|0;d=b+32|0;e=b+40|0;f=a;a=c[f+356>>2]|0;g=pe[c[f+12>>2]&127](((c[a+176>>2]|0)*20|0)+(c[a+168>>2]|0)|0)|0;if((g|0)!=0){c[e>>2]=g+((c[a+176>>2]|0)*20|0);c[d>>2]=g+20;dTa(f,0,g,d,e);h=g;j=h;i=b;return j|0}else{h=0;j=h;i=b;return j|0}return 0}function aTa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=a;a=b;b=d;d=e;if((c[g+64>>2]|0)==0){if((c[g+80>>2]|0)!=0){zSa(g,a,b,d)}h=1;j=h;i=f;return j|0}b=b+(c[a+68>>2]<<1)|0;e=b+(Ee[c[a+32>>2]&63](a,b)|0)|0;k=NSa(g+416|0,a,b,e)|0;if((k|0)==0){h=0;j=h;i=f;return j|0}c[g+432>>2]=c[g+428>>2];b=Ee[c[a+36>>2]&63](a,e)|0;e=NSa(g+416|0,a,b,d+(0-(c[a+68>>2]<<1))|0)|0;if((e|0)!=0){cTa(e);Le[c[g+64>>2]&15](c[g+4>>2]|0,k,e);iSa(g+416|0);h=1;j=h;i=f;return j|0}else{h=0;j=h;i=f;return j|0}return 0}function bTa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+48|0;g=a;a=b;b=d;d=e;e=g;if((c[g+68>>2]|0)==0){if((c[e+80>>2]|0)!=0){zSa(g,a,b,d)}h=1;j=h;i=f;return j|0}k=NSa(e+416|0,a,b+(c[a+68>>2]<<2)|0,d+(0-((c[a+68>>2]|0)*3|0))|0)|0;if((k|0)!=0){cTa(k);ne[c[g+68>>2]&255](c[g+4>>2]|0,k);iSa(g+416|0);h=1;j=h;i=f;return j|0}else{h=0;j=h;i=f;return j|0}return 0}function cTa(b){b=b|0;var c=0,d=0,e=0,f=0;c=i;i=i+16|0;d=b;while(1){if((a[d]|0)==0){e=12;break}f=d;if((a[d]|0)==13){break}d=f+1|0}if((e|0)==12){i=c;return}e=f;do{do{if((a[d]|0)==13){f=e;e=f+1|0;a[f]=10;f=d+1|0;d=f;if((a[f]|0)!=10){break}d=d+1|0}else{f=d;d=f+1|0;b=e;e=b+1|0;a[b]=a[f]|0}}while(0);}while((a[d]|0)!=0);a[e]=0;i=c;return}function dTa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+72|0;j=b;b=d;d=e;e=f;f=g;g=c[j+356>>2]|0;c[d>>2]=c[(c[g+164>>2]|0)+(b*28|0)>>2];c[d+4>>2]=c[(c[g+164>>2]|0)+(b*28|0)+4>>2];if((c[d>>2]|0)==4){c[d+8>>2]=c[f>>2];k=c[(c[g+164>>2]|0)+(b*28|0)+8>>2]|0;while(1){l=a[k]|0;m=f;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;if((a[k]|0)==0){break}k=k+1|0}c[d+12>>2]=0;c[d+16>>2]=0;i=h;return}else{c[d+12>>2]=c[(c[g+164>>2]|0)+(b*28|0)+20>>2];c[d+16>>2]=c[e>>2];k=e;c[k>>2]=(c[k>>2]|0)+((c[d+12>>2]|0)*20|0);k=0;l=c[(c[g+164>>2]|0)+(b*28|0)+12>>2]|0;while(1){if(!(k>>>0<(c[d+12>>2]|0)>>>0)){break}dTa(j,l,(c[d+16>>2]|0)+(k*20|0)|0,e,f);k=k+1|0;l=c[(c[g+164>>2]|0)+(l*28|0)+24>>2]|0}c[d+8>>2]=0;i=h;return}}



function _V(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0,u=0,v=0,w=0.0,x=0,y=0,z=0,B=0.0,C=0,D=0,E=0,F=0.0,G=0,J=0.0,K=0,L=0,M=0.0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0.0,U=0,V=0,W=0.0,X=0,Y=0,Z=0.0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0,ea=0,fa=0.0,ga=0,ha=0.0,ia=0.0;f=i;i=i+7176|0;j=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;h[j+9288>>3]=+h[d>>3];h[j+648>>3]=+h[d+8>>3];h[j+9400>>3]=+h[d+16>>3];h[j+760>>3]=+h[d+24>>3];h[j+536>>3]=+h[d+32>>3];h[j+9328>>3]=+h[d+40>>3];h[j+688>>3]=+h[d+48>>3];h[j+9488>>3]=+h[d+56>>3];h[j+4688>>3]=+h[d+64>>3];h[j+528>>3]=+h[d+72>>3];h[j+9336>>3]=+h[d+80>>3];h[j+696>>3]=+h[d+88>>3];h[j+9496>>3]=+h[d+96>>3];h[j+4696>>3]=+h[d+104>>3];h[j+512>>3]=+h[d+112>>3];h[j+520>>3]=+h[d+120>>3];h[j+488>>3]=+h[d+128>>3];h[j+9344>>3]=+h[d+136>>3];h[j+704>>3]=+h[d+144>>3];h[j+9504>>3]=+h[d+152>>3];h[j+4704>>3]=+h[d+160>>3];h[j+496>>3]=+h[d+168>>3];h[j+504>>3]=+h[d+176>>3];h[j+480>>3]=+h[d+184>>3];j=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;h[j+9352>>3]=+h[d+192>>3];h[j+712>>3]=+h[d+200>>3];h[j+9512>>3]=+h[d+208>>3];h[j+4712>>3]=+h[d+216>>3];h[j+472>>3]=+h[d+224>>3];h[j+9360>>3]=+h[d+232>>3];h[j+720>>3]=+h[d+240>>3];h[j+9520>>3]=+h[d+248>>3];h[j+4720>>3]=+h[d+256>>3];h[j+464>>3]=+h[d+264>>3];h[j+440>>3]=+h[d+272>>3];h[j+456>>3]=+h[d+280>>3];h[j+9368>>3]=+h[d+288>>3];h[j+728>>3]=+h[d+296>>3];h[j+9528>>3]=+h[d+304>>3];h[j+4728>>3]=+h[d+312>>3];h[j+448>>3]=+h[d+320>>3];h[j+432>>3]=+h[d+328>>3];h[j+9376>>3]=+h[d+336>>3];h[j+736>>3]=+h[d+344>>3];h[j+9536>>3]=+h[d+352>>3];h[j+4736>>3]=+h[d+360>>3];h[j+424>>3]=+h[d+368>>3];h[j+416>>3]=+h[d+376>>3];j=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;h[j+9384>>3]=+h[d+384>>3];h[j+744>>3]=+h[d+392>>3];h[j+9544>>3]=+h[d+400>>3];h[j+4744>>3]=+h[d+408>>3];h[j+392>>3]=+h[d+416>>3];h[j+408>>3]=+h[d+424>>3];h[j+9392>>3]=+h[d+432>>3];h[j+752>>3]=+h[d+440>>3];h[j+9552>>3]=+h[d+448>>3];h[j+4752>>3]=+h[d+456>>3];h[j+400>>3]=+h[d+464>>3];h[j+384>>3]=+h[d+472>>3];h[j+4760>>3]=+h[d+480>>3];h[j+9560>>3]=+h[d+488>>3];h[j+376>>3]=+h[d+496>>3];h[j+768>>3]=+h[d+504>>3];h[j+9568>>3]=+h[d+512>>3];h[j+4768>>3]=+h[d+520>>3];h[j+368>>3]=+h[d+528>>3];h[j+360>>3]=+h[d+536>>3];h[j+328>>3]=+h[d+544>>3];h[j+312>>3]=+h[d+552>>3];h[j+304>>3]=+h[d+560>>3];h[j+9432>>3]=+h[d+568>>3];j=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;h[j+792>>3]=+h[d+576>>3];h[j+9592>>3]=+h[d+584>>3];h[j+4792>>3]=+h[d+592>>3];h[j+320>>3]=+h[d+600>>3];h[j+4784>>3]=+h[d+608>>3];h[j+336>>3]=+h[d+616>>3];h[j+344>>3]=+h[d+624>>3];h[j+4776>>3]=+h[d+632>>3];h[j+9576>>3]=+h[d+640>>3];h[j+272>>3]=+h[d+648>>3];h[j+9416>>3]=+h[d+656>>3];h[j+776>>3]=+h[d+664>>3];h[j+352>>3]=+h[d+672>>3];h[j+9584>>3]=+h[d+680>>3];h[j+784>>3]=+h[d+688>>3];h[j+9424>>3]=+h[d+696>>3];h[j+288>>3]=+h[d+704>>3];h[j+248>>3]=+h[d+712>>3];h[j+264>>3]=+h[d+720>>3];h[j+280>>3]=+h[d+728>>3];h[j+296>>3]=+h[d+736>>3];h[j+256>>3]=+h[d+744>>3];h[j+9408>>3]=+h[d+752>>3];h[j+240>>3]=+h[d+760>>3];j=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;h[j+232>>3]=+h[d+768>>3];h[j+224>>3]=+h[d+776>>3];h[j+200>>3]=+h[d+784>>3];h[j+208>>3]=+h[d+792>>3];h[j+216>>3]=+h[d+800>>3];h[j+192>>3]=+h[d+808>>3];h[j+184>>3]=+h[d+816>>3];h[j+176>>3]=+h[d+824>>3];h[j+664>>3]=+h[d+832>>3];h[j+9304>>3]=+h[d+840>>3];h[j+72>>3]=+h[d+848>>3];h[j+56>>3]=+h[d+856>>3];h[j+48>>3]=+h[d+864>>3];h[j+64>>3]=+h[d+872>>3];h[j+88>>3]=+h[d+880>>3];h[j+104>>3]=+h[d+888>>3];h[j+120>>3]=+h[d+896>>3];h[j+136>>3]=+h[d+904>>3];h[j+152>>3]=+h[d+912>>3];h[j+168>>3]=+h[d+920>>3];h[j+160>>3]=+h[d+928>>3];h[j+144>>3]=+h[d+936>>3];h[j+128>>3]=+h[d+944>>3];h[j+112>>3]=+h[d+952>>3];j=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;h[j+96>>3]=+h[d+960>>3];h[j+9312>>3]=+h[d+968>>3];h[j+4672>>3]=+h[d+976>>3];h[j+9472>>3]=+h[d+984>>3];h[j+672>>3]=+h[d+992>>3];h[j+80>>3]=+h[d+1e3>>3];h[j+9320>>3]=+h[d+1008>>3];h[j+680>>3]=+h[d+1016>>3];h[j+9480>>3]=+h[d+1024>>3];h[j+4680>>3]=+h[d+1032>>3];h[j+544>>3]=+h[d+1040>>3];h[j+552>>3]=+h[d+1048>>3];h[j+568>>3]=+h[d+1056>>3];h[j+560>>3]=+h[d+1064>>3];h[j+584>>3]=+h[d+1072>>3];h[j+576>>3]=+h[d+1080>>3];h[j+9464>>3]=+h[d+1088>>3];h[j+4664>>3]=+h[d+1096>>3];h[j+9440>>3]=+h[d+1104>>3];h[j+4640>>3]=+h[d+1112>>3];h[j+632>>3]=+h[d+1120>>3];h[j+624>>3]=+h[d+1128>>3];h[j+4648>>3]=+h[d+1136>>3];h[j+608>>3]=+h[d+1144>>3];j=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;h[j+9448>>3]=+h[d+1152>>3];h[j+616>>3]=+h[d+1160>>3];h[j+600>>3]=+h[d+1168>>3];h[j+4656>>3]=+h[d+1176>>3];h[j+592>>3]=+h[d+1184>>3];h[j+9456>>3]=+h[d+1192>>3];h[j+656>>3]=+h[d+1200>>3];h[j+9296>>3]=+h[d+1208>>3];h[j+32>>3]=+h[d+1216>>3];h[j+40>>3]=+h[d+1224>>3];h[j+24>>3]=+h[d+1232>>3];h[j+16>>3]=+h[d+1240>>3];h[j+8>>3]=+h[d+1248>>3];h[j>>3]=+h[d+1256>>3];h[j+9280>>3]=+h[d+1264>>3];h[j+640>>3]=+h[d+1272>>3];lF(b);mF(b);nF(b);oF(b);pF(b);qF(b);rF(b);sF(b);tF(b);uF(b);vF(b);wF(b);xF(b);yF(b);zF(b);AF(b);BF(b);CF(b);DF(b);EF(b);FF(b);GF(b);HF(b);IF(b);JF(b);KF(b);LF(b);MF(b);NF(b);OF(b);PF(b);QF(b);RF(b);SF(b);TF(b);UF(b);VF(b);WF(b);XF(b);YF(b);ZF(b);_F(b);$F(b);aG(b);bG(b);cG(b);dG(b);eG(b);fG(b);gG(b);hG(b);iG(b);jG(b);kG(b);lG(b);mG(b);nG(b);oG(b);pG(b);qG(b);rG(b);sG(b);tG(b);uG(b);vG(b);wG(b);xG(b);yG(b);zG(b);AG(b);BG(b);CG(b);DG(b);EG(b);FG(b);GG(b);HG(b);IG(b);JG(b);KG(b);LG(b);MG(b);NG(b);OG(b);PG(b);QG(b);RG(b);SG(b);TG(b);UG(b);VG(b);WG(b);XG(b);YG(b);ZG(b);_G(b);$G(b);aH(b);bH(b);cH(b);dH(b);eH(b);fH(b);gH(b);hH(b);iH(b);jH(b);kH(b);lH(b);mH(b);nH(b);oH(b);pH(b);qH(b);rH(b);sH(b);tH(b);uH(b);vH(b);wH(b);xH(b);yH(b);zH(b);AH(b);BH(b);CH(b);DH(b);EH(b);FH(b);GH(b);HH(b);IH(b);JH(b);KH(b);LH(b);MH(b);NH(b);OH(b);PH(b);QH(b);RH(b);SH(b);TH(b);UH(b);VH(b);WH(b);XH(b);YH(b);ZH(b);_H(b);$H(b);aI(b);bI(b);cI(b);dI(b);eI(b);fI(b);gI(b);hI(b);iI(b);jI(b);kI(b);lI(b);mI(b);nI(b);oI(b);pI(b);qI(b);rI(b);sI(b);tI(b);uI(b);vI(b);wI(b);xI(b);yI(b);zI(b);AI(b);BI(b);CI(b);DI(b);EI(b);FI(b);GI(b);HI(b);II(b);JI(b);KI(b);LI(b);MI(b);NI(b);OI(b);PI(b);QI(b);RI(b);SI(b);TI(b);UI(b);VI(b);WI(b);XI(b);YI(b);ZI(b);_I(b);$I(b);aJ(b);bJ(b);cJ(b);dJ(b);eJ(b);fJ(b);gJ(b);hJ(b);iJ(b);jJ(b);kJ(b);lJ(b);mJ(b);nJ(b);oJ(b);pJ(b);qJ(b);rJ(b);sJ(b);tJ(b);uJ(b);vJ(b);wJ(b);xJ(b);yJ(b);zJ(b);AJ(b);BJ(b);CJ(b);DJ(b);EJ(b);FJ(b);GJ(b);HJ(b);IJ(b);JJ(b);KJ(b);LJ(b);MJ(b);NJ(b);OJ(b);PJ(b);QJ(b);RJ(b);SJ(b);TJ(b);UJ(b);VJ(b);WJ(b);XJ(b);YJ(b);ZJ(b);_J(b);$J(b);aK(b);bK(b);cK(b);dK(b);eK(b);fK(b);gK(b);hK(b);iK(b);jK(b);kK(b);lK(b);mK(b);nK(b);oK(b);pK(b);qK(b);rK(b);sK(b);tK(b);uK(b);vK(b);wK(b);xK(b);yK(b);zK(b);AK(b);BK(b);CK(b);DK(b);EK(b);FK(b);GK(b);HK(b);IK(b);JK(b);KK(b);LK(b);MK(b);NK(b);OK(b);PK(b);QK(b);RK(b);SK(b);TK(b);UK(b);VK(b);WK(b);XK(b);YK(b);ZK(b);_K(b);$K(b);aL(b);bL(b);cL(b);dL(b);eL(b);fL(b);gL(b);hL(b);iL(b);jL(b);kL(b);lL(b);mL(b);nL(b);oL(b);pL(b);qL(b);rL(b);sL(b);tL(b);uL(b);vL(b);wL(b);xL(b);yL(b);zL(b);AL(b);BL(b);CL(b);DL(b);EL(b);FL(b);GL(b);HL(b);IL(b);JL(b);KL(b);LL(b);ML(b);NL(b);OL(b);PL(b);QL(b);RL(b);SL(b);TL(b);UL(b);VL(b);WL(b);XL(b);YL(b);ZL(b);_L(b);$L(b);aM(b);bM(b);cM(b);dM(b);eM(b);fM(b);gM(b);hM(b);iM(b);jM(b);kM(b);lM(b);mM(b);nM(b);oM(b);pM(b);qM(b);rM(b);sM(b);tM(b);uM(b);vM(b);wM(b);xM(b);yM(b);zM(b);AM(b);BM(b);CM(b);DM(b);EM(b);FM(b);GM(b);HM(b);IM(b);JM(b);KM(b);LM(b);MM(b);NM(b);OM(b);PM(b);QM(b);RM(b);SM(b);TM(b);UM(b);VM(b);WM(b);XM(b);YM(b);ZM(b);_M(b);$M(b);aN(b);bN(b);cN(b);dN(b);eN(b);fN(b);gN(b);hN(b);iN(b);jN(b);kN(b);lN(b);mN(b);nN(b);oN(b);pN(b);qN(b);rN(b);sN(b);tN(b);uN(b);vN(b);wN(b);xN(b);yN(b);zN(b);AN(b);BN(b);CN(b);DN(b);EN(b);FN(b);GN(b);HN(b);IN(b);JN(b);KN(b);LN(b);MN(b);NN(b);ON(b);PN(b);QN(b);RN(b);SN(b);TN(b);UN(b);VN(b);WN(b);XN(b);YN(b);ZN(b);_N(b);$N(b);aO(b);bO(b);cO(b);dO(b);eO(b);fO(b);gO(b);hO(b);iO(b);jO(b);kO(b);lO(b);mO(b);nO(b);oO(b);pO(b);qO(b);rO(b);sO(b);tO(b);uO(b);vO(b);wO(b);xO(b);yO(b);zO(b);AO(b);BO(b);CO(b);DO(b);EO(b);FO(b);GO(b);HO(b);IO(b);JO(b);KO(b);LO(b);MO(b);NO(b);OO(b);PO(b);QO(b);RO(b);SO(b);TO(b);UO(b);VO(b);WO(b);XO(b);YO(b);ZO(b);_O(b);$O(b);aP(b);bP(b);cP(b);dP(b);eP(b);fP(b);gP(b);hP(b);iP(b);jP(b);kP(b);lP(b);mP(b);nP(b);oP(b);pP(b);qP(b);rP(b);sP(b);tP(b);uP(b);vP(b);wP(b);xP(b);yP(b);zP(b);AP(b);BP(b);CP(b);DP(b);EP(b);FP(b);GP(b);HP(b);IP(b);JP(b);KP(b);LP(b);MP(b);NP(b);OP(b);PP(b);QP(b);RP(b);SP(b);TP(b);UP(b);VP(b);WP(b);XP(b);YP(b);ZP(b);_P(b);$P(b);aQ(b);bQ(b);cQ(b);dQ(b);eQ(b);fQ(b);gQ(b);hQ(b);iQ(b);jQ(b);kQ(b);lQ(b);mQ(b);nQ(b);oQ(b);pQ(b);qQ(b);rQ(b);sQ(b);tQ(b);uQ(b);vQ(b);wQ(b);xQ(b);yQ(b);zQ(b);AQ(b);BQ(b);CQ(b);DQ(b);EQ(b);FQ(b);GQ(b);HQ(b);IQ(b);JQ(b);KQ(b);LQ(b);MQ(b);NQ(b);OQ(b);PQ(b);QQ(b);RQ(b);SQ(b);TQ(b);UQ(b);VQ(b);WQ(b);XQ(b);YQ(b);ZQ(b);_Q(b);$Q(b);aR(b);bR(b);cR(b);dR(b);eR(b);fR(b);gR(b);hR(b);iR(b);jR(b);kR(b);lR(b);mR(b);nR(b);oR(b);pR(b);qR(b);rR(b);sR(b);tR(b);uR(b);vR(b);wR(b);xR(b);yR(b);zR(b);AR(b);BR(b);CR(b);DR(b);ER(b);FR(b);GR(b);HR(b);IR(b);JR(b);KR(b);LR(b);MR(b);NR(b);OR(b);PR(b);QR(b);RR(b);SR(b);TR(b);UR(b);VR(b);WR(b);XR(b);YR(b);ZR(b);_R(b);$R(b);aS(b);bS(b);cS(b);dS(b);eS(b);fS(b);gS(b);hS(b);iS(b);jS(b);kS(b);lS(b);mS(b);nS(b);oS(b);pS(b);qS(b);rS(b);sS(b);tS(b);uS(b);vS(b);wS(b);xS(b);yS(b);zS(b);AS(b);BS(b);CS(b);DS(b);ES(b);FS(b);GS(b);HS(b);IS(b);JS(b);KS(b);LS(b);MS(b);NS(b);OS(b);PS(b);QS(b);RS(b);SS(b);TS(b);US(b);VS(b);WS(b);XS(b);YS(b);ZS(b);_S(b);$S(b);aT(b);bT(b);cT(b);dT(b);eT(b);fT(b);gT(b);hT(b);iT(b);jT(b);kT(b);lT(b);mT(b);nT(b);oT(b);pT(b);qT(b);rT(b);sT(b);tT(b);uT(b);vT(b);wT(b);xT(b);yT(b);zT(b);AT(b);BT(b);CT(b);DT(b);ET(b);FT(b);GT(b);HT(b);IT(b);JT(b);KT(b);LT(b);MT(b);NT(b);OT(b);PT(b);QT(b);RT(b);ST(b);TT(b);UT(b);VT(b);WT(b);XT(b);YT(b);ZT(b);_T(b);$T(b);aU(b);bU(b);cU(b);dU(b);eU(b);fU(b);gU(b);hU(b);iU(b);jU(b);kU(b);lU(b);mU(b);nU(b);oU(b);pU(b);qU(b);rU(b);sU(b);tU(b);uU(b);vU(b);wU(b);xU(b);yU(b);zU(b);AU(b);BU(b);CU(b);DU(b);EU(b);FU(b);GU(b);HU(b);IU(b);JU(b);KU(b);LU(b);MU(b);NU(b);OU(b);PU(b);QU(b);RU(b);SU(b);TU(b);UU(b);VU(b);WU(b);XU(b);YU(b);ZU(b);_U(b);$U(b);aV(b);bV(b);cV(b);dV(b);eV(b);fV(b);gV(b);hV(b);iV(b);jV(b);kV(b);lV(b);mV(b);nV(b);oV(b);pV(b);qV(b);rV(b);sV(b);tV(b);uV(b);vV(b);wV(b);xV(b);yV(b);zV(b);AV(b);BV(b);CV(b);DV(b);EV(b);FV(b);GV(b);HV(b);IV(b);JV(b);KV(b);LV(b);MV(b);NV(b);OV(b);PV(b);QV(b);RV(b);SV(b);TV(b);UV(b);VV(b);WV(b);XV(b);YV(b);d=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;h[e>>3]=+h[d+9920>>3]+(-+h[d+8496>>3]- +h[d+8336>>3]- +h[d+8176>>3]);h[e+8>>3]=+h[d+10232>>3]+(-+h[d+4008>>3]- +h[(d+3848|0)>>3]- +h[d+3688>>3]);j=c[(b+416|0)>>2]|0;h[e+16>>3]=+h[(d+3848|0)>>3]- +h[j+3184>>3]*+h[d+14296>>3]*(+h[d+9280>>3]- +h[d>>3])*+h[j+3176>>3];k=+h[(b+304|0)>>3];JD(f,c[(b+536|0)>>2]|0,+h[d+2544>>3],+h[d+12536>>3],+h[d+12544>>3],+h[d+11160>>3],+h[d+11168>>3],+h[j+1616>>3],+h[d+12888>>3],+h[d+12864>>3]*+h[j+3136>>3],(+h[j+2088>>3]+ +h[j+2096>>3])*.5,+h[j+3128>>3]*.05,+h[j+3096>>3]);l=+h[f>>3];j=c[c[(b+4|0)>>2]>>2]|0;d=c[j+8>>2]|0;m=+h[d+3384>>3];n=c[(b+416|0)>>2]|0;o=+h[n+3104>>3];p=+h[d+2544>>3]- +h[d+12864>>3]*+h[n+3136>>3]*+h[n+3152>>3];do{if(o!=0.0){q=d;r=n;s=p/o}else{if(p==0.0){q=d;r=n;s=p;break}t=p/+qXa(c[(b+536|0)>>2]|0,o,36984,50112,+h[j>>3],(a[b+319|0]|0)!=0|0);q=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;r=c[(b+416|0)>>2]|0;s=t}}while(0);h[e+24>>3]=m+((k+-1.0)*s-k*l*+h[r+3072>>3]);h[e+32>>3]=+h[q+10216>>3]+(-+h[q+3992>>3]- +h[q+3832>>3]- +h[q+3672>>3]);l=+h[(b+304|0)>>3];JD(f+8|0,c[(b+536|0)>>2]|0,+h[q+2552>>3],+h[q+12544>>3],+h[q+12552>>3],+h[q+11168>>3],+h[q+11176>>3],+h[r+1624>>3],+h[q+12880>>3],+h[q+12872>>3]*+h[r+3136>>3],(+h[r+2096>>3]+ +h[r+2104>>3])*.5,+h[r+3128>>3]*.05,+h[r+3096>>3]);k=+h[(f+8|0)>>3];r=c[c[(b+4|0)>>2]>>2]|0;q=c[r+8>>2]|0;s=+h[q+3376>>3];j=c[(b+416|0)>>2]|0;m=+h[j+3104>>3];o=+h[q+2552>>3]- +h[q+12872>>3]*+h[j+3136>>3]*+h[j+3152>>3];do{if(m!=0.0){u=q;v=j;w=o/m}else{if(o==0.0){u=q;v=j;w=o;break}p=o/+qXa(c[(b+536|0)>>2]|0,m,36984,50112,+h[r>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;v=c[(b+416|0)>>2]|0;w=p}}while(0);h[e+40>>3]=s+((l+-1.0)*w-l*k*+h[v+3072>>3]);h[e+48>>3]=+h[u+9928>>3]+(-+h[u+8504>>3]- +h[u+8344>>3]- +h[u+8184>>3]);k=+h[(b+304|0)>>3];JD(f+16|0,c[(b+536|0)>>2]|0,+h[u+2536>>3],+h[u+12528>>3],+h[u+12536>>3],+h[u+11152>>3],+h[u+11160>>3],+h[v+1608>>3],+h[u+12896>>3],+h[u+12856>>3]*+h[v+3136>>3],(+h[v+2080>>3]+ +h[v+2088>>3])*.5,+h[v+3128>>3]*.05,+h[v+3096>>3]);l=+h[(f+16|0)>>3];v=c[c[(b+4|0)>>2]>>2]|0;u=c[v+8>>2]|0;w=+h[u+3392>>3];r=c[(b+416|0)>>2]|0;s=+h[r+3104>>3];m=+h[u+2536>>3]- +h[u+12856>>3]*+h[r+3136>>3]*+h[r+3152>>3];do{if(s!=0.0){x=u;y=v;z=r;B=m/s}else{if(m==0.0){x=u;y=v;z=r;B=m;break}o=m/+qXa(c[(b+536|0)>>2]|0,s,36984,50112,+h[v>>3],(a[b+319|0]|0)!=0|0);j=c[c[(b+4|0)>>2]>>2]|0;x=c[j+8>>2]|0;y=j;z=c[(b+416|0)>>2]|0;B=o}}while(0);h[e+56>>3]=w+((k+-1.0)*B-k*l*+h[z+3072>>3]);h[e+64>>3]=+h[x+9936>>3]+(-+h[x+8512>>3]- +h[x+8352>>3]- +h[x+8192>>3]);l=+h[z+2704>>3];k=+h[x+9296>>3]- +h[x+656>>3];B=+h[z+2672>>3];w=+h[z+2680>>3];do{if(B!=0.0){C=z;D=x;E=y;F=w/B}else{if(w==0.0){C=z;D=x;E=y;F=w;break}s=w/+qXa(c[(b+536|0)>>2]|0,B,40376,50112,+h[y>>3],(a[b+319|0]|0)!=0|0);v=c[c[(b+4|0)>>2]>>2]|0;C=c[(b+416|0)>>2]|0;D=c[v+8>>2]|0;E=v;F=s}}while(0);h[e+72>>3]=l*k*F*-.05- +h[D+3832>>3];F=+h[C+2704>>3];k=+h[D+9456>>3]- +h[D+656>>3];l=+h[C+2672>>3];B=+h[C+2680>>3];do{if(l!=0.0){G=D;J=B/l}else{if(B==0.0){G=D;J=B;break}w=B/+qXa(c[(b+536|0)>>2]|0,l,40376,50112,+h[E>>3],(a[b+319|0]|0)!=0|0);G=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;J=w}}while(0);h[e+80>>3]=F*k*J*-.05- +h[G+8352>>3];_D(f+24|0,c[(b+536|0)>>2]|0,+h[G+5296>>3],+h[G+5136>>3],+h[G+6096>>3]+-6150.0,3850.0);G=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;h[e+88>>3]=+h[G+5776>>3]- +h[(f+24|0)>>3];E=c[(b+416|0)>>2]|0;h[e+96>>3]=+h[G+8352>>3]- +h[G+4656>>3]*+h[G+13520>>3]*(+h[G+9456>>3]- +h[G+592>>3])*+h[E+2944>>3];HD(f+32|0,c[(b+536|0)>>2]|0,+h[G+4648>>3],+h[E+672>>3],+h[G+5448>>3]);G=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;h[e+104>>3]=+h[G+5768>>3]- +h[(f+32|0)>>3];_D(f+40|0,c[(b+536|0)>>2]|0,+h[G+5304>>3],+h[G+5144>>3],+h[G+6104>>3]+-6150.0,3850.0);G=c[c[(b+4|0)>>2]>>2]|0;E=c[G+8>>2]|0;h[e+112>>3]=+h[E+5784>>3]- +h[(f+40|0)>>3];D=c[(b+416|0)>>2]|0;J=+h[D+2704>>3];k=+h[E+9448>>3]- +h[E+648>>3];F=+h[D+2672>>3];l=+h[D+2680>>3];do{if(F!=0.0){K=D;L=E;M=l/F}else{if(l==0.0){K=D;L=E;M=l;break}B=l/+qXa(c[(b+536|0)>>2]|0,F,40376,50112,+h[G>>3],(a[b+319|0]|0)!=0|0);K=c[(b+416|0)>>2]|0;L=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;M=B}}while(0);h[e+120>>3]=J*k*M*-.05- +h[L+8344>>3];M=+h[(b+304|0)>>3];JD(f+48|0,c[(b+536|0)>>2]|0,+h[L+7040>>3],+h[L+12216>>3],+h[L+12224>>3],+h[L+10848>>3],+h[L+10856>>3],+h[K+344>>3],+h[L+13176>>3],+h[L+12560>>3]*+h[K+2904>>3],(+h[K+824>>3]+ +h[K+832>>3])*.5,+h[K+2896>>3]*.05,+h[K+2864>>3]);k=+h[(f+48|0)>>3];K=c[c[(b+4|0)>>2]>>2]|0;L=c[K+8>>2]|0;J=+h[L+8168>>3];G=c[(b+416|0)>>2]|0;F=+h[G+2872>>3];l=+h[L+7040>>3]- +h[L+12560>>3]*+h[G+2904>>3]*+h[G+2920>>3];do{if(F!=0.0){N=L;O=G;P=l/F}else{if(l==0.0){N=L;O=G;P=l;break}B=l/+qXa(c[(b+536|0)>>2]|0,F,32896,50112,+h[K>>3],(a[b+319|0]|0)!=0|0);N=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;O=c[(b+416|0)>>2]|0;P=B}}while(0);h[e+128>>3]=J+((M+-1.0)*P-M*k*+h[O+2840>>3]);K=O+2944|0;h[e+136>>3]=+h[N+8344>>3]- +h[N+4648>>3]*+h[N+13512>>3]*(+h[N+9448>>3]- +h[N+608>>3])*+h[K>>3];G=N+4640|0;h[e+144>>3]=+h[N+8336>>3]- +h[G>>3]*+h[N+13504>>3]*(+h[N+9440>>3]- +h[N+624>>3])*+h[K>>3];h[e+152>>3]=+h[N+8656>>3]- +h[N+13344>>3]*+h[N+10384>>3];HD(f+56|0,c[(b+536|0)>>2]|0,+h[G>>3],+h[O+664>>3],+h[N+5440>>3]);N=c[c[(b+4|0)>>2]>>2]|0;O=c[N+8>>2]|0;h[e+160>>3]=+h[O+5760>>3]- +h[(f+56|0)>>3];G=c[(b+416|0)>>2]|0;k=+h[G+2704>>3];M=+h[O+9440>>3]- +h[O+640>>3];P=+h[G+2672>>3];J=+h[G+2680>>3];do{if(P!=0.0){Q=G;R=O;S=N;T=J/P}else{if(J==0.0){Q=G;R=O;S=N;T=J;break}F=J/+qXa(c[(b+536|0)>>2]|0,P,40376,50112,+h[N>>3],(a[b+319|0]|0)!=0|0);K=c[c[(b+4|0)>>2]>>2]|0;Q=c[(b+416|0)>>2]|0;R=c[K+8>>2]|0;S=K;T=F}}while(0);h[e+168>>3]=k*M*T*-.05- +h[R+8336>>3];h[e+176>>3]=+h[R+9944>>3]+(-+h[R+8520>>3]- +h[R+8360>>3]- +h[R+8200>>3]);T=+h[Q+2704>>3];M=+h[R+9464>>3]- +h[R+664>>3];k=+h[Q+2672>>3];P=+h[Q+2680>>3];do{if(k!=0.0){U=Q;V=R;W=P/k}else{if(P==0.0){U=Q;V=R;W=P;break}J=P/+qXa(c[(b+536|0)>>2]|0,k,40376,50112,+h[S>>3],(a[b+319|0]|0)!=0|0);U=c[(b+416|0)>>2]|0;V=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;W=J}}while(0);h[e+184>>3]=T*M*W*-.05- +h[V+8360>>3];W=+h[(b+304|0)>>3];JD(f+64|0,c[(b+536|0)>>2]|0,+h[V+7056>>3],+h[V+12232>>3],+h[V+12240>>3],+h[V+10864>>3],+h[V+10872>>3],+h[U+360>>3],+h[V+13160>>3],+h[V+12576>>3]*+h[U+2904>>3],(+h[U+840>>3]+ +h[U+848>>3])*.5,+h[U+2896>>3]*.05,+h[U+2864>>3]);M=+h[(f+64|0)>>3];U=c[c[(b+4|0)>>2]>>2]|0;V=c[U+8>>2]|0;T=+h[V+8152>>3];S=c[(b+416|0)>>2]|0;k=+h[S+2872>>3];P=+h[V+7056>>3]- +h[V+12576>>3]*+h[S+2904>>3]*+h[S+2920>>3];do{if(k!=0.0){X=V;Y=S;Z=P/k}else{if(P==0.0){X=V;Y=S;Z=P;break}J=P/+qXa(c[(b+536|0)>>2]|0,k,32896,50112,+h[U>>3],(a[b+319|0]|0)!=0|0);X=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;Y=c[(b+416|0)>>2]|0;Z=J}}while(0);h[e+192>>3]=T+((W+-1.0)*Z-W*M*+h[Y+2840>>3]);M=+h[(b+304|0)>>3];JD(f+72|0,c[(b+536|0)>>2]|0,+h[X+7064>>3],+h[X+12240>>3],+h[X+12248>>3],+h[X+10872>>3],+h[X+10880>>3],+h[Y+368>>3],+h[X+13152>>3],+h[X+12584>>3]*+h[Y+2904>>3],(+h[Y+848>>3]+ +h[Y+856>>3])*.5,+h[Y+2896>>3]*.05,+h[Y+2864>>3]);W=+h[(f+72|0)>>3];Y=c[c[(b+4|0)>>2]>>2]|0;X=c[Y+8>>2]|0;Z=+h[X+8144>>3];U=c[(b+416|0)>>2]|0;T=+h[U+2872>>3];k=+h[X+7064>>3]- +h[X+12584>>3]*+h[U+2904>>3]*+h[U+2920>>3];do{if(T!=0.0){_=X;$=U;aa=k/T}else{if(k==0.0){_=X;$=U;aa=k;break}P=k/+qXa(c[(b+536|0)>>2]|0,T,32896,50112,+h[Y>>3],(a[b+319|0]|0)!=0|0);_=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;$=c[(b+416|0)>>2]|0;aa=P}}while(0);h[e+200>>3]=Z+((M+-1.0)*aa-M*W*+h[$+2840>>3]);h[e+208>>3]=+h[_+8368>>3]- +h[_+4672>>3]*+h[_+13536>>3]*(+h[_+9472>>3]- +h[_+560>>3])*+h[$+2944>>3];W=+h[(b+304|0)>>3];JD(f+80|0,c[(b+536|0)>>2]|0,+h[_+7072>>3],+h[_+12248>>3],+h[_+12256>>3],+h[_+10880>>3],+h[_+10888>>3],+h[$+376>>3],+h[_+13144>>3],+h[_+12592>>3]*+h[$+2904>>3],(+h[$+856>>3]+ +h[$+864>>3])*.5,+h[$+2896>>3]*.05,+h[$+2864>>3]);M=+h[(f+80|0)>>3];$=c[c[(b+4|0)>>2]>>2]|0;_=c[$+8>>2]|0;aa=+h[_+8136>>3];Y=c[(b+416|0)>>2]|0;Z=+h[Y+2872>>3];c[f+408>>2]=b;c[f+424>>2]=e;g[f+1200>>2]=W;g[f+1208>>2]=M;c[f+1216>>2]=$;c[f+1224>>2]=_;g[f+1232>>2]=aa;c[f+1240>>2]=Y;g[f+1248>>2]=Z;g[f+3560>>2]=ba;g[f+3568>>2]=ca;c[f+3576>>2]=da;c[f+3584>>2]=ea;g[f+3592>>2]=fa;c[f+3600>>2]=ga;g[f+3608>>2]=ha;g[f+3624>>2]=ia;c[f+7056>>2]=0;c[f+7060>>2]=0;_residualFunc1550$1(f);ba=+g[f+3560>>2];ca=+g[f+3568>>2];da=c[f+3576>>2]|0;ea=c[f+3584>>2]|0;fa=+g[f+3592>>2];ga=c[f+3600>>2]|0;ha=+g[f+3608>>2];ia=+g[f+3624>>2];c[f+408>>2]=b;c[f+424>>2]=e;g[f+3560>>2]=ba;g[f+3568>>2]=ca;c[f+3576>>2]=da;c[f+3584>>2]=ea;g[f+3592>>2]=fa;c[f+3600>>2]=ga;g[f+3608>>2]=ha;g[f+3624>>2]=ia;c[f+7048>>2]=0;c[f+7052>>2]=0;_residualFunc1550$0(f);H=c[f+7048>>2]|0;A=c[f+7052>>2]|0;I=+g[f+7052>>2];c[f+7048>>2]=0;c[f+7052>>2]=0;if((H|0)==5){return}}function $V(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+11392>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+11368>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+11376>>3];h[a+8>>3]=+h[d+205152>>3];h[e+8>>3]=+h[d+205128>>3];h[f+8>>3]=+h[d+205136>>3];h[a+16>>3]=+h[d+11280>>3];h[e+16>>3]=+h[d+11256>>3];h[f+16>>3]=+h[d+11264>>3];i=i;return}function aW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0;e=i;i=i+496|0;f=e;g=e+120|0;j=e+240|0;k=e+360|0;l=e+480|0;m=e+488|0;n=+h[b>>3];o=a+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[p+808>>3]=n;q=+h[b+8>>3];h[p+14648>>3]=q;h[p+800>>3]=+h[b+16>>3];r=+h[p+12552>>3];s=r*r;b=p+8|0;h[d>>3]=+h[p+9912>>3]*s+(r*n+(-(s*q)- +h[b>>3]*+h[p+10840>>3]));t=a+536|0;XE(j,c[t>>2]|0,+h[b>>3],+h[p>>3],0);p=c[t>>2]|0;b=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[b+8>>3];s=+h[b>>3];n=+h[b+808>>3];r=+h[b+800>>3];b=g+0|0;a=j+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));bF(l,p,q,s,g,n,r);g=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[d+8>>3]=+h[g+14648>>3]- +h[l>>3];XE(k,c[t>>2]|0,+h[g+8>>3],+h[g>>3],0);g=c[t>>2]|0;t=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[t+8>>3];n=+h[t>>3];s=+h[t+808>>3];q=+h[t+800>>3];b=f+0|0;a=k+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));fF(m,g,r,n,f,s,q);h[d+16>>3]=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+10840>>3]- +h[m>>3];i=e;return}function bW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+11616>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+11592>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+11600>>3];h[a+8>>3]=+h[d+149600>>3];h[e+8>>3]=+h[d+149576>>3];h[f+8>>3]=+h[d+149584>>3];h[a+16>>3]=+h[d+11504>>3];h[e+16>>3]=+h[d+11480>>3];h[f+16>>3]=+h[d+11488>>3];i=i;return}function cW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0;e=i;i=i+496|0;f=e;g=e+120|0;j=e+240|0;k=e+360|0;l=e+480|0;m=e+488|0;n=+h[b>>3];o=a+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[p+824>>3]=n;q=+h[b+8>>3];h[p+10680>>3]=q;h[p+816>>3]=+h[b+16>>3];r=+h[p+12544>>3];s=r*r;b=p+24|0;h[d>>3]=+h[p+9904>>3]*s+(r*n+(-(s*q)- +h[b>>3]*+h[p+10832>>3]));t=a+536|0;XE(j,c[t>>2]|0,+h[b>>3],+h[p+16>>3],0);p=c[t>>2]|0;b=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[b+24>>3];s=+h[b+16>>3];n=+h[b+824>>3];r=+h[b+816>>3];b=g+0|0;a=j+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));bF(l,p,q,s,g,n,r);g=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[d+8>>3]=+h[g+10680>>3]- +h[l>>3];XE(k,c[t>>2]|0,+h[g+24>>3],+h[g+16>>3],0);g=c[t>>2]|0;t=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[t+24>>3];n=+h[t+16>>3];s=+h[t+824>>3];q=+h[t+816>>3];b=f+0|0;a=k+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));fF(m,g,r,n,f,s,q);h[d+16>>3]=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+10832>>3]- +h[m>>3];i=e;return}function dW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+11840>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+11816>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+11824>>3];h[a+8>>3]=+h[d+149488>>3];h[e+8>>3]=+h[d+149464>>3];h[f+8>>3]=+h[d+149472>>3];h[a+16>>3]=+h[d+11728>>3];h[e+16>>3]=+h[d+11704>>3];h[f+16>>3]=+h[d+11712>>3];i=i;return}function eW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0;e=i;i=i+496|0;f=e;g=e+120|0;j=e+240|0;k=e+360|0;l=e+480|0;m=e+488|0;n=+h[b>>3];o=a+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[p+840>>3]=n;q=+h[b+8>>3];h[p+10672>>3]=q;h[p+832>>3]=+h[b+16>>3];r=+h[p+12536>>3];s=r*r;b=p+40|0;h[d>>3]=+h[p+9896>>3]*s+(r*n+(-(s*q)- +h[b>>3]*+h[p+10824>>3]));t=a+536|0;XE(j,c[t>>2]|0,+h[b>>3],+h[p+32>>3],0);p=c[t>>2]|0;b=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[b+40>>3];s=+h[b+32>>3];n=+h[b+840>>3];r=+h[b+832>>3];b=g+0|0;a=j+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));bF(l,p,q,s,g,n,r);g=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[d+8>>3]=+h[g+10672>>3]- +h[l>>3];XE(k,c[t>>2]|0,+h[g+40>>3],+h[g+32>>3],0);g=c[t>>2]|0;t=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[t+40>>3];n=+h[t+32>>3];s=+h[t+840>>3];q=+h[t+832>>3];b=f+0|0;a=k+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));fF(m,g,r,n,f,s,q);h[d+16>>3]=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+10824>>3]- +h[m>>3];i=e;return}function fW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+12064>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+12040>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+12048>>3];h[a+8>>3]=+h[d+149376>>3];h[e+8>>3]=+h[d+149352>>3];h[f+8>>3]=+h[d+149360>>3];h[a+16>>3]=+h[d+11952>>3];h[e+16>>3]=+h[d+11928>>3];h[f+16>>3]=+h[d+11936>>3];i=i;return}function gW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0;e=i;i=i+496|0;f=e;g=e+120|0;j=e+240|0;k=e+360|0;l=e+480|0;m=e+488|0;n=+h[b>>3];o=a+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[p+856>>3]=n;q=+h[b+8>>3];h[p+10664>>3]=q;h[p+848>>3]=+h[b+16>>3];r=+h[p+12528>>3];s=r*r;b=p+56|0;h[d>>3]=+h[p+9888>>3]*s+(r*n+(-(s*q)- +h[b>>3]*+h[p+10816>>3]));t=a+536|0;XE(j,c[t>>2]|0,+h[b>>3],+h[p+48>>3],0);p=c[t>>2]|0;b=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[b+56>>3];s=+h[b+48>>3];n=+h[b+856>>3];r=+h[b+848>>3];b=g+0|0;a=j+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));bF(l,p,q,s,g,n,r);g=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[d+8>>3]=+h[g+10664>>3]- +h[l>>3];XE(k,c[t>>2]|0,+h[g+56>>3],+h[g+48>>3],0);g=c[t>>2]|0;t=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[t+56>>3];n=+h[t+48>>3];s=+h[t+856>>3];q=+h[t+848>>3];b=f+0|0;a=k+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));fF(m,g,r,n,f,s,q);h[d+16>>3]=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+10816>>3]- +h[m>>3];i=e;return}function hW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+12288>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+12264>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+12272>>3];h[a+8>>3]=+h[d+149264>>3];h[e+8>>3]=+h[d+149240>>3];h[f+8>>3]=+h[d+149248>>3];h[a+16>>3]=+h[d+12176>>3];h[e+16>>3]=+h[d+12152>>3];h[f+16>>3]=+h[d+12160>>3];i=i;return}function iW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0;e=i;i=i+496|0;f=e;g=e+120|0;j=e+240|0;k=e+360|0;l=e+480|0;m=e+488|0;n=+h[b>>3];o=a+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[p+872>>3]=n;q=+h[b+8>>3];h[p+10656>>3]=q;h[p+864>>3]=+h[b+16>>3];r=+h[p+12520>>3];s=r*r;b=p+72|0;h[d>>3]=+h[p+9880>>3]*s+(r*n+(-(s*q)- +h[b>>3]*+h[p+10808>>3]));t=a+536|0;XE(j,c[t>>2]|0,+h[b>>3],+h[p+64>>3],0);p=c[t>>2]|0;b=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[b+72>>3];s=+h[b+64>>3];n=+h[b+872>>3];r=+h[b+864>>3];b=g+0|0;a=j+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));bF(l,p,q,s,g,n,r);g=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[d+8>>3]=+h[g+10656>>3]- +h[l>>3];XE(k,c[t>>2]|0,+h[g+72>>3],+h[g+64>>3],0);g=c[t>>2]|0;t=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[t+72>>3];n=+h[t+64>>3];s=+h[t+872>>3];q=+h[t+864>>3];b=f+0|0;a=k+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));fF(m,g,r,n,f,s,q);h[d+16>>3]=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+10808>>3]- +h[m>>3];i=e;return}function jW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+12512>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+12488>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+12496>>3];h[a+8>>3]=+h[d+149152>>3];h[e+8>>3]=+h[d+149128>>3];h[f+8>>3]=+h[d+149136>>3];h[a+16>>3]=+h[d+12400>>3];h[e+16>>3]=+h[d+12376>>3];h[f+16>>3]=+h[d+12384>>3];i=i;return}function kW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0;e=i;i=i+496|0;f=e;g=e+120|0;j=e+240|0;k=e+360|0;l=e+480|0;m=e+488|0;n=+h[b>>3];o=a+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[p+888>>3]=n;q=+h[b+8>>3];h[p+10648>>3]=q;h[p+880>>3]=+h[b+16>>3];r=+h[p+12512>>3];s=r*r;b=p+88|0;h[d>>3]=+h[p+9872>>3]*s+(r*n+(-(s*q)- +h[b>>3]*+h[p+10800>>3]));t=a+536|0;XE(j,c[t>>2]|0,+h[b>>3],+h[p+80>>3],0);p=c[t>>2]|0;b=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[b+88>>3];s=+h[b+80>>3];n=+h[b+888>>3];r=+h[b+880>>3];b=g+0|0;a=j+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));bF(l,p,q,s,g,n,r);g=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[d+8>>3]=+h[g+10648>>3]- +h[l>>3];XE(k,c[t>>2]|0,+h[g+88>>3],+h[g+80>>3],0);g=c[t>>2]|0;t=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[t+88>>3];n=+h[t+80>>3];s=+h[t+888>>3];q=+h[t+880>>3];b=f+0|0;a=k+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));fF(m,g,r,n,f,s,q);h[d+16>>3]=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+10800>>3]- +h[m>>3];i=e;return}function lW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+12736>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+12712>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+12720>>3];h[a+8>>3]=+h[d+149040>>3];h[e+8>>3]=+h[d+149016>>3];h[f+8>>3]=+h[d+149024>>3];h[a+16>>3]=+h[d+12624>>3];h[e+16>>3]=+h[d+12600>>3];h[f+16>>3]=+h[d+12608>>3];i=i;return}function mW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0;e=i;i=i+496|0;f=e;g=e+120|0;j=e+240|0;k=e+360|0;l=e+480|0;m=e+488|0;n=+h[b>>3];o=a+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[p+904>>3]=n;q=+h[b+8>>3];h[p+10640>>3]=q;h[p+896>>3]=+h[b+16>>3];r=+h[p+12504>>3];s=r*r;b=p+104|0;h[d>>3]=+h[p+9864>>3]*s+(r*n+(-(s*q)- +h[b>>3]*+h[p+10792>>3]));t=a+536|0;XE(j,c[t>>2]|0,+h[b>>3],+h[p+96>>3],0);p=c[t>>2]|0;b=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[b+104>>3];s=+h[b+96>>3];n=+h[b+904>>3];r=+h[b+896>>3];b=g+0|0;a=j+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));bF(l,p,q,s,g,n,r);g=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[d+8>>3]=+h[g+10640>>3]- +h[l>>3];XE(k,c[t>>2]|0,+h[g+104>>3],+h[g+96>>3],0);g=c[t>>2]|0;t=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[t+104>>3];n=+h[t+96>>3];s=+h[t+904>>3];q=+h[t+896>>3];b=f+0|0;a=k+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));fF(m,g,r,n,f,s,q);h[d+16>>3]=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+10792>>3]- +h[m>>3];i=e;return}function nW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+12960>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+12936>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+12944>>3];h[a+8>>3]=+h[d+148928>>3];h[e+8>>3]=+h[d+148904>>3];h[f+8>>3]=+h[d+148912>>3];h[a+16>>3]=+h[d+12848>>3];h[e+16>>3]=+h[d+12824>>3];h[f+16>>3]=+h[d+12832>>3];i=i;return}function oW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0;e=i;i=i+496|0;f=e;g=e+120|0;j=e+240|0;k=e+360|0;l=e+480|0;m=e+488|0;n=+h[b>>3];o=a+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[p+920>>3]=n;q=+h[b+8>>3];h[p+10632>>3]=q;h[p+912>>3]=+h[b+16>>3];r=+h[p+12496>>3];s=r*r;b=p+120|0;h[d>>3]=+h[p+9856>>3]*s+(r*n+(-(s*q)- +h[b>>3]*+h[p+10784>>3]));t=a+536|0;XE(j,c[t>>2]|0,+h[b>>3],+h[p+112>>3],0);p=c[t>>2]|0;b=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[b+120>>3];s=+h[b+112>>3];n=+h[b+920>>3];r=+h[b+912>>3];b=g+0|0;a=j+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));bF(l,p,q,s,g,n,r);g=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[d+8>>3]=+h[g+10632>>3]- +h[l>>3];XE(k,c[t>>2]|0,+h[g+120>>3],+h[g+112>>3],0);g=c[t>>2]|0;t=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[t+120>>3];n=+h[t+112>>3];s=+h[t+920>>3];q=+h[t+912>>3];b=f+0|0;a=k+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));fF(m,g,r,n,f,s,q);h[d+16>>3]=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+10784>>3]- +h[m>>3];i=e;return}function pW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+13184>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+13160>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+13168>>3];h[a+8>>3]=+h[d+148816>>3];h[e+8>>3]=+h[d+148792>>3];h[f+8>>3]=+h[d+148800>>3];h[a+16>>3]=+h[d+13072>>3];h[e+16>>3]=+h[d+13048>>3];h[f+16>>3]=+h[d+13056>>3];i=i;return}function qW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0;e=i;i=i+496|0;f=e;g=e+120|0;j=e+240|0;k=e+360|0;l=e+480|0;m=e+488|0;n=+h[b>>3];o=a+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[p+936>>3]=n;q=+h[b+8>>3];h[p+10624>>3]=q;h[p+928>>3]=+h[b+16>>3];r=+h[p+12488>>3];s=r*r;b=p+136|0;h[d>>3]=+h[p+9848>>3]*s+(r*n+(-(s*q)- +h[b>>3]*+h[p+10776>>3]));t=a+536|0;XE(j,c[t>>2]|0,+h[b>>3],+h[p+128>>3],0);p=c[t>>2]|0;b=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[b+136>>3];s=+h[b+128>>3];n=+h[b+936>>3];r=+h[b+928>>3];b=g+0|0;a=j+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));bF(l,p,q,s,g,n,r);g=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[d+8>>3]=+h[g+10624>>3]- +h[l>>3];XE(k,c[t>>2]|0,+h[g+136>>3],+h[g+128>>3],0);g=c[t>>2]|0;t=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[t+136>>3];n=+h[t+128>>3];s=+h[t+936>>3];q=+h[t+928>>3];b=f+0|0;a=k+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));fF(m,g,r,n,f,s,q);h[d+16>>3]=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+10776>>3]- +h[m>>3];i=e;return}function rW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+13408>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+13384>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+13392>>3];h[a+8>>3]=+h[d+148704>>3];h[e+8>>3]=+h[d+148680>>3];h[f+8>>3]=+h[d+148688>>3];h[a+16>>3]=+h[d+13296>>3];h[e+16>>3]=+h[d+13272>>3];h[f+16>>3]=+h[d+13280>>3];i=i;return}function sW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0;e=i;i=i+496|0;f=e;g=e+120|0;j=e+240|0;k=e+360|0;l=e+480|0;m=e+488|0;n=+h[b>>3];o=a+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[p+952>>3]=n;q=+h[b+8>>3];h[p+10616>>3]=q;h[p+944>>3]=+h[b+16>>3];r=+h[p+12480>>3];s=r*r;b=p+152|0;h[d>>3]=+h[p+9840>>3]*s+(r*n+(-(s*q)- +h[b>>3]*+h[p+10768>>3]));t=a+536|0;XE(j,c[t>>2]|0,+h[b>>3],+h[p+144>>3],0);p=c[t>>2]|0;b=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[b+152>>3];s=+h[b+144>>3];n=+h[b+952>>3];r=+h[b+944>>3];b=g+0|0;a=j+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));bF(l,p,q,s,g,n,r);g=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[d+8>>3]=+h[g+10616>>3]- +h[l>>3];XE(k,c[t>>2]|0,+h[g+152>>3],+h[g+144>>3],0);g=c[t>>2]|0;t=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[t+152>>3];n=+h[t+144>>3];s=+h[t+952>>3];q=+h[t+944>>3];b=f+0|0;a=k+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));fF(m,g,r,n,f,s,q);h[d+16>>3]=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+10768>>3]- +h[m>>3];i=e;return}function tW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+13632>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+13608>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+13616>>3];h[a+8>>3]=+h[d+148592>>3];h[e+8>>3]=+h[d+148568>>3];h[f+8>>3]=+h[d+148576>>3];h[a+16>>3]=+h[d+13520>>3];h[e+16>>3]=+h[d+13496>>3];h[f+16>>3]=+h[d+13504>>3];i=i;return}function uW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0;e=i;i=i+496|0;f=e;g=e+120|0;j=e+240|0;k=e+360|0;l=e+480|0;m=e+488|0;n=+h[b>>3];o=a+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[p+968>>3]=n;q=+h[b+8>>3];h[p+10608>>3]=q;h[p+960>>3]=+h[b+16>>3];r=+h[p+12472>>3];s=r*r;b=p+168|0;h[d>>3]=+h[p+9832>>3]*s+(r*n+(-(s*q)- +h[b>>3]*+h[p+10760>>3]));t=a+536|0;XE(j,c[t>>2]|0,+h[b>>3],+h[p+160>>3],0);p=c[t>>2]|0;b=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[b+168>>3];s=+h[b+160>>3];n=+h[b+968>>3];r=+h[b+960>>3];b=g+0|0;a=j+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));bF(l,p,q,s,g,n,r);g=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[d+8>>3]=+h[g+10608>>3]- +h[l>>3];XE(k,c[t>>2]|0,+h[g+168>>3],+h[g+160>>3],0);g=c[t>>2]|0;t=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[t+168>>3];n=+h[t+160>>3];s=+h[t+968>>3];q=+h[t+960>>3];b=f+0|0;a=k+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));fF(m,g,r,n,f,s,q);h[d+16>>3]=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+10760>>3]- +h[m>>3];i=e;return}function vW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+13856>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+13832>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+13840>>3];h[a+8>>3]=+h[d+148480>>3];h[e+8>>3]=+h[d+148456>>3];h[f+8>>3]=+h[d+148464>>3];h[a+16>>3]=+h[d+13744>>3];h[e+16>>3]=+h[d+13720>>3];h[f+16>>3]=+h[d+13728>>3];i=i;return}function wW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0;e=i;i=i+496|0;f=e;g=e+120|0;j=e+240|0;k=e+360|0;l=e+480|0;m=e+488|0;n=+h[b>>3];o=a+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[p+984>>3]=n;q=+h[b+8>>3];h[p+10600>>3]=q;h[p+976>>3]=+h[b+16>>3];r=+h[p+12464>>3];s=r*r;b=p+184|0;h[d>>3]=+h[p+9824>>3]*s+(r*n+(-(s*q)- +h[b>>3]*+h[p+10752>>3]));t=a+536|0;XE(j,c[t>>2]|0,+h[b>>3],+h[p+176>>3],0);p=c[t>>2]|0;b=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[b+184>>3];s=+h[b+176>>3];n=+h[b+984>>3];r=+h[b+976>>3];b=g+0|0;a=j+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));bF(l,p,q,s,g,n,r);g=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[d+8>>3]=+h[g+10600>>3]- +h[l>>3];XE(k,c[t>>2]|0,+h[g+184>>3],+h[g+176>>3],0);g=c[t>>2]|0;t=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[t+184>>3];n=+h[t+176>>3];s=+h[t+984>>3];q=+h[t+976>>3];b=f+0|0;a=k+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));fF(m,g,r,n,f,s,q);h[d+16>>3]=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+10752>>3]- +h[m>>3];i=e;return}function xW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+14080>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+14056>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+14064>>3];h[a+8>>3]=+h[d+148368>>3];h[e+8>>3]=+h[d+148344>>3];h[f+8>>3]=+h[d+148352>>3];h[a+16>>3]=+h[d+13968>>3];h[e+16>>3]=+h[d+13944>>3];h[f+16>>3]=+h[d+13952>>3];i=i;return}function yW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0;e=i;i=i+496|0;f=e;g=e+120|0;j=e+240|0;k=e+360|0;l=e+480|0;m=e+488|0;n=+h[b>>3];o=a+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[p+1e3>>3]=n;q=+h[b+8>>3];h[p+10592>>3]=q;h[p+992>>3]=+h[b+16>>3];r=+h[p+12456>>3];s=r*r;b=p+200|0;h[d>>3]=+h[p+9816>>3]*s+(r*n+(-(s*q)- +h[b>>3]*+h[p+10744>>3]));t=a+536|0;XE(j,c[t>>2]|0,+h[b>>3],+h[p+192>>3],0);p=c[t>>2]|0;b=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[b+200>>3];s=+h[b+192>>3];n=+h[b+1e3>>3];r=+h[b+992>>3];b=g+0|0;a=j+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));bF(l,p,q,s,g,n,r);g=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[d+8>>3]=+h[g+10592>>3]- +h[l>>3];XE(k,c[t>>2]|0,+h[g+200>>3],+h[g+192>>3],0);g=c[t>>2]|0;t=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[t+200>>3];n=+h[t+192>>3];s=+h[t+1e3>>3];q=+h[t+992>>3];b=f+0|0;a=k+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));fF(m,g,r,n,f,s,q);h[d+16>>3]=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+10744>>3]- +h[m>>3];i=e;return}function zW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+14304>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+14280>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+14288>>3];h[a+8>>3]=+h[d+148256>>3];h[e+8>>3]=+h[d+148232>>3];h[f+8>>3]=+h[d+148240>>3];h[a+16>>3]=+h[d+14192>>3];h[e+16>>3]=+h[d+14168>>3];h[f+16>>3]=+h[d+14176>>3];i=i;return}function _residualFunc1550$0(b){b=b|0;var d=0,e=0,f=0.0,j=0.0,k=0,l=0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0,I=0,J=0.0,K=0.0,L=0,M=0,N=0,O=0.0,P=0.0,Q=0,R=0.0,S=0,T=0,U=0,V=0.0,W=0,X=0,Y=0.0,Z=0,_=0,$=0.0,aa=0,ba=0,ca=0.0,da=0.0,ea=0,fa=0,ga=0,ha=0.0,ia=0,ja=0.0,ka=0,la=0,ma=0.0,na=0,oa=0,pa=0.0,qa=0,ra=0,sa=0,ta=0.0,ua=0,va=0,wa=0.0,xa=0,ya=0,za=0.0,Aa=0,Ba=0,Ca=0,Da=0.0,Ea=0,Fa=0,Ga=0.0,Ha=0,Ia=0,Ja=0,Ka=0.0,La=0,Ma=0,Na=0.0,Oa=0,Pa=0,Qa=0,Ra=0.0,Sa=0,Ta=0,Ua=0.0,Va=0,Wa=0,Xa=0.0,Ya=0,Za=0,_a=0,$a=0.0,ab=0,bb=0,cb=0.0,db=0,eb=0,fb=0.0,gb=0,hb=0,ib=0,jb=0.0,kb=0,lb=0,mb=0.0,nb=0,ob=0,pb=0,qb=0.0,rb=0,sb=0,tb=0,ub=0.0,vb=0,wb=0,xb=0.0,yb=0.0,zb=0.0,Ab=0.0,Bb=0,Cb=0,Db=0,Eb=0.0,Fb=0.0,Gb=0,Hb=0,Ib=0,Jb=0.0,Kb=0,Lb=0,Mb=0,Nb=0.0,Ob=0,Pb=0,Qb=0,Rb=0.0,Sb=0,Tb=0,Ub=0,Vb=0.0,Wb=0,Xb=0,Yb=0,Zb=0.0,_b=0.0,$b=0,ac=0,bc=0,cc=0.0,dc=0.0,ec=0.0,fc=0.0,gc=0.0,hc=0,ic=0,jc=0;d=c[b+408>>2]|0;e=c[b+424>>2]|0;f=+g[b+3560>>2];j=+g[b+3568>>2];k=c[b+3576>>2]|0;l=c[b+3584>>2]|0;m=+g[b+3592>>2];n=c[b+3600>>2]|0;o=+g[b+3608>>2];p=+g[b+3624>>2];a:do{do{if(o!=0.0){q=l;r=n;s=p/o}else{if(p==0.0){q=l;r=n;s=p;break}t=p/+qXa(c[(d+536|0)>>2]|0,o,32896,50112,+h[k>>3],(a[d+319|0]|0)!=0|0);q=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;r=c[(d+416|0)>>2]|0;s=t}}while(0);h[e+736>>3]=m+((f+-1.0)*s-f*j*+h[r+2840>>3]);h[e+744>>3]=+h[q+10056>>3]+(-+h[q+8632>>3]- +h[q+8472>>3]- +h[q+8312>>3]);_D(b+248|0,c[(d+536|0)>>2]|0,+h[q+5408>>3],+h[q+5248>>3],+h[q+6208>>3]+-6150.0,3850.0);u=c[c[(d+4|0)>>2]>>2]|0;v=c[u+8>>2]|0;h[e+752>>3]=+h[v+5888>>3]- +h[(b+248|0)>>3];w=c[(d+416|0)>>2]|0;t=+h[w+2704>>3];x=+h[v+9568>>3]- +h[v+768>>3];y=+h[w+2672>>3];z=+h[w+2680>>3];do{if(y!=0.0){A=w;B=v;C=u;D=z/y}else{if(z==0.0){A=w;B=v;C=u;D=z;break}E=z/+qXa(c[(d+536|0)>>2]|0,y,40376,50112,+h[u>>3],(a[d+319|0]|0)!=0|0);F=c[c[(d+4|0)>>2]>>2]|0;A=c[(d+416|0)>>2]|0;B=c[F+8>>2]|0;C=F;D=E}}while(0);h[e+760>>3]=t*x*D*-.05- +h[B+8464>>3];y=+h[A+2704>>3];z=+h[B+9408>>3]- +h[B+768>>3];E=+h[A+2672>>3];G=+h[A+2680>>3];do{if(E!=0.0){H=A;I=B;J=G/E}else{if(G==0.0){H=A;I=B;J=G;break}K=G/+qXa(c[(d+536|0)>>2]|0,E,40376,50112,+h[C>>3],(a[d+319|0]|0)!=0|0);H=c[(d+416|0)>>2]|0;I=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;J=K}}while(0);h[e+768>>3]=y*z*J*-.05- +h[I+3720>>3];E=+h[(d+304|0)>>3];JD(b+256|0,c[(d+536|0)>>2]|0,+h[I+7152>>3],+h[I+12328>>3],+h[I+12336>>3],+h[I+10960>>3],+h[I+10968>>3],+h[H+456>>3],+h[I+13064>>3],+h[I+12672>>3]*+h[H+2904>>3],(+h[H+936>>3]+ +h[H+944>>3])*.5,+h[H+2896>>3]*.05,+h[H+2864>>3]);G=+h[(b+256|0)>>3];u=c[c[(d+4|0)>>2]>>2]|0;v=c[u+8>>2]|0;x=+h[v+8056>>3];w=c[(d+416|0)>>2]|0;t=+h[w+2872>>3];K=+h[v+7152>>3]- +h[v+12672>>3]*+h[w+2904>>3]*+h[w+2920>>3];do{if(t!=0.0){L=v;M=u;N=w;O=K/t}else{if(K==0.0){L=v;M=u;N=w;O=K;break}P=K/+qXa(c[(d+536|0)>>2]|0,t,32896,50112,+h[u>>3],(a[d+319|0]|0)!=0|0);F=c[c[(d+4|0)>>2]>>2]|0;L=c[F+8>>2]|0;M=F;N=c[(d+416|0)>>2]|0;O=P}}while(0);h[e+776>>3]=x+((E+-1.0)*O-E*G*+h[N+2840>>3]);t=+h[N+2704>>3];K=+h[L+9560>>3]- +h[L+760>>3];z=+h[N+2672>>3];y=+h[N+2680>>3];do{if(z!=0.0){Q=L;R=y/z}else{if(y==0.0){Q=L;R=y;break}P=y/+qXa(c[(d+536|0)>>2]|0,z,40376,50112,+h[M>>3],(a[d+319|0]|0)!=0|0);Q=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;R=P}}while(0);h[e+784>>3]=t*K*R*-.05- +h[Q+8456>>3];_D(b+264|0,c[(d+536|0)>>2]|0,+h[Q+5400>>3],+h[Q+5240>>3],+h[Q+6200>>3]+-6150.0,3850.0);u=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;h[e+792>>3]=+h[u+5880>>3]- +h[(b+264|0)>>3];h[e+800>>3]=+h[u+10048>>3]+(-+h[u+8624>>3]- +h[u+8464>>3]- +h[u+8304>>3]);h[e+808>>3]=+h[u+10040>>3]+(-+h[u+8616>>3]- +h[u+8456>>3]- +h[u+8296>>3]);_D(b+272|0,c[(d+536|0)>>2]|0,+h[u+5392>>3],+h[u+5232>>3],+h[u+6192>>3]+-6150.0,3850.0);u=c[c[(d+4|0)>>2]>>2]|0;w=c[u+8>>2]|0;h[e+816>>3]=+h[w+5872>>3]- +h[(b+272|0)>>3];v=c[(d+416|0)>>2]|0;z=+h[v+2704>>3];y=+h[w+9552>>3]- +h[w+752>>3];G=+h[v+2672>>3];E=+h[v+2680>>3];do{if(G!=0.0){S=v;T=w;U=u;V=E/G}else{if(E==0.0){S=v;T=w;U=u;V=E;break}x=E/+qXa(c[(d+536|0)>>2]|0,G,40376,50112,+h[u>>3],(a[d+319|0]|0)!=0|0);F=c[c[(d+4|0)>>2]>>2]|0;S=c[(d+416|0)>>2]|0;T=c[F+8>>2]|0;U=F;V=x}}while(0);h[e+824>>3]=z*y*V*-.05- +h[T+8448>>3];G=+h[S+2704>>3];E=+h[T+9392>>3]- +h[T+752>>3];K=+h[S+2672>>3];t=+h[S+2680>>3];do{if(K!=0.0){W=S;X=T;Y=t/K}else{if(t==0.0){W=S;X=T;Y=t;break}x=t/+qXa(c[(d+536|0)>>2]|0,K,40376,50112,+h[U>>3],(a[d+319|0]|0)!=0|0);W=c[(d+416|0)>>2]|0;X=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;Y=x}}while(0);u=X+3736|0;h[e+832>>3]=G*E*Y*-.05- +h[u>>3];h[e+840>>3]=+h[u>>3]- +h[W+3184>>3]*+h[X+14184>>3]*(+h[X+9392>>3]- +h[X+224>>3])*+h[W+3176>>3];K=+h[(d+304|0)>>3];JD(b+280|0,c[(d+536|0)>>2]|0,+h[X+7136>>3],+h[X+12312>>3],+h[X+12320>>3],+h[X+10944>>3],+h[X+10952>>3],+h[W+440>>3],+h[X+13080>>3],+h[X+12656>>3]*+h[W+2904>>3],(+h[W+920>>3]+ +h[W+928>>3])*.5,+h[W+2896>>3]*.05,+h[W+2864>>3]);t=+h[(b+280|0)>>3];u=c[c[(d+4|0)>>2]>>2]|0;w=c[u+8>>2]|0;y=+h[w+8072>>3];v=c[(d+416|0)>>2]|0;z=+h[v+2872>>3];x=+h[w+7136>>3]- +h[w+12656>>3]*+h[v+2904>>3]*+h[v+2920>>3];do{if(z!=0.0){Z=w;_=v;$=x/z}else{if(x==0.0){Z=w;_=v;$=x;break}P=x/+qXa(c[(d+536|0)>>2]|0,z,32896,50112,+h[u>>3],(a[d+319|0]|0)!=0|0);Z=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;_=c[(d+416|0)>>2]|0;$=P}}while(0);h[e+848>>3]=y+((K+-1.0)*$-K*t*+h[_+2840>>3]);z=+h[(d+304|0)>>3];JD(b+288|0,c[(d+536|0)>>2]|0,+h[Z+7144>>3],+h[Z+12320>>3],+h[Z+12328>>3],+h[Z+10952>>3],+h[Z+10960>>3],+h[_+448>>3],+h[Z+13072>>3],+h[Z+12664>>3]*+h[_+2904>>3],(+h[_+928>>3]+ +h[_+936>>3])*.5,+h[_+2896>>3]*.05,+h[_+2864>>3]);x=+h[(b+288|0)>>3];u=c[c[(d+4|0)>>2]>>2]|0;v=c[u+8>>2]|0;E=+h[v+8064>>3];w=c[(d+416|0)>>2]|0;G=+h[w+2872>>3];P=+h[v+7144>>3]- +h[v+12664>>3]*+h[w+2904>>3]*+h[w+2920>>3];do{if(G!=0.0){aa=v;ba=w;ca=P/G}else{if(P==0.0){aa=v;ba=w;ca=P;break}da=P/+qXa(c[(d+536|0)>>2]|0,G,32896,50112,+h[u>>3],(a[d+319|0]|0)!=0|0);aa=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;ba=c[(d+416|0)>>2]|0;ca=da}}while(0);h[e+856>>3]=E+((z+-1.0)*ca-z*x*+h[ba+2840>>3]);_D(b+296|0,c[(d+536|0)>>2]|0,+h[aa+5384>>3],+h[aa+5224>>3],+h[aa+6184>>3]+-6150.0,3850.0);u=c[c[(d+4|0)>>2]>>2]|0;w=c[u+8>>2]|0;h[e+864>>3]=+h[w+5864>>3]- +h[(b+296|0)>>3];v=c[(d+416|0)>>2]|0;h[e+872>>3]=+h[w+8440>>3]- +h[w+4744>>3]*+h[w+13608>>3]*(+h[(w+9544|0)>>3]- +h[w+416>>3])*+h[v+2944>>3];G=+h[v+2704>>3];P=+h[(w+9544|0)>>3]- +h[w+744>>3];t=+h[v+2672>>3];K=+h[v+2680>>3];do{if(t!=0.0){ea=v;fa=w;ga=u;ha=K/t}else{if(K==0.0){ea=v;fa=w;ga=u;ha=K;break}y=K/+qXa(c[(d+536|0)>>2]|0,t,40376,50112,+h[u>>3],(a[d+319|0]|0)!=0|0);F=c[c[(d+4|0)>>2]>>2]|0;ea=c[(d+416|0)>>2]|0;fa=c[F+8>>2]|0;ga=F;ha=y}}while(0);h[e+880>>3]=G*P*ha*-.05- +h[fa+8440>>3];t=+h[ea+2704>>3];K=+h[fa+9384>>3]- +h[fa+744>>3];x=+h[ea+2672>>3];z=+h[ea+2680>>3];do{if(x!=0.0){ia=fa;ja=z/x}else{if(z==0.0){ia=fa;ja=z;break}E=z/+qXa(c[(d+536|0)>>2]|0,x,40376,50112,+h[ga>>3],(a[d+319|0]|0)!=0|0);ia=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;ja=E}}while(0);h[e+888>>3]=t*K*ja*-.05- +h[ia+3744>>3];h[e+896>>3]=+h[ia+10032>>3]+(-+h[ia+8608>>3]- +h[ia+8448>>3]- +h[ia+8288>>3]);h[e+904>>3]=+h[ia+8752>>3]+(+h[ia+8072>>3]- +h[ia+8080>>3]);_D(b+304|0,c[(d+536|0)>>2]|0,+h[ia+5376>>3],+h[ia+5216>>3],+h[ia+6176>>3]+-6150.0,3850.0);u=c[c[(d+4|0)>>2]>>2]|0;w=c[u+8>>2]|0;h[e+912>>3]=+h[w+5856>>3]- +h[(b+304|0)>>3];v=c[(d+416|0)>>2]|0;h[e+920>>3]=+h[w+8432>>3]- +h[w+4736>>3]*+h[w+13600>>3]*(+h[w+9536>>3]- +h[w+432>>3])*+h[v+2944>>3];x=+h[v+2704>>3];z=+h[w+9376>>3]- +h[w+736>>3];P=+h[v+2672>>3];G=+h[v+2680>>3];do{if(P!=0.0){ka=v;la=w;ma=G/P}else{if(G==0.0){ka=v;la=w;ma=G;break}E=G/+qXa(c[(d+536|0)>>2]|0,P,40376,50112,+h[u>>3],(a[d+319|0]|0)!=0|0);ka=c[(d+416|0)>>2]|0;la=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;ma=E}}while(0);u=la+3752|0;h[e+928>>3]=x*z*ma*-.05- +h[u>>3];h[e+936>>3]=+h[u>>3]- +h[ka+3184>>3]*+h[la+14200>>3]*(+h[la+9376>>3]- +h[la+192>>3])*+h[ka+3176>>3];h[e+944>>3]=+h[la+10024>>3]+(-+h[la+8600>>3]- +h[la+8440>>3]- +h[la+8280>>3]);P=+h[(d+304|0)>>3];JD(b+312|0,c[(d+536|0)>>2]|0,+h[la+7120>>3],+h[la+12296>>3],+h[la+12304>>3],+h[la+10928>>3],+h[la+10936>>3],+h[ka+424>>3],+h[la+13096>>3],+h[la+12640>>3]*+h[ka+2904>>3],(+h[ka+904>>3]+ +h[ka+912>>3])*.5,+h[ka+2896>>3]*.05,+h[ka+2864>>3]);G=+h[(b+312|0)>>3];u=c[c[(d+4|0)>>2]>>2]|0;w=c[u+8>>2]|0;K=+h[w+8088>>3];v=c[(d+416|0)>>2]|0;t=+h[v+2872>>3];E=+h[w+7120>>3]- +h[w+12640>>3]*+h[v+2904>>3]*+h[v+2920>>3];do{if(t!=0.0){na=w;oa=v;pa=E/t}else{if(E==0.0){na=w;oa=v;pa=E;break}y=E/+qXa(c[(d+536|0)>>2]|0,t,32896,50112,+h[u>>3],(a[d+319|0]|0)!=0|0);na=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;oa=c[(d+416|0)>>2]|0;pa=y}}while(0);h[e+952>>3]=K+((P+-1.0)*pa-P*G*+h[oa+2840>>3]);_D(b+320|0,c[(d+536|0)>>2]|0,+h[na+5368>>3],+h[na+5208>>3],+h[na+6168>>3]+-6150.0,3850.0);u=c[c[(d+4|0)>>2]>>2]|0;v=c[u+8>>2]|0;h[e+960>>3]=+h[v+5848>>3]- +h[(b+320|0)>>3];w=c[(d+416|0)>>2]|0;h[e+968>>3]=+h[v+8424>>3]- +h[v+4728>>3]*+h[v+13592>>3]*(+h[(v+9528|0)>>3]- +h[v+448>>3])*+h[w+2944>>3];t=+h[w+2704>>3];E=+h[(v+9528|0)>>3]- +h[v+728>>3];z=+h[w+2672>>3];x=+h[w+2680>>3];do{if(z!=0.0){qa=w;ra=v;sa=u;ta=x/z}else{if(x==0.0){qa=w;ra=v;sa=u;ta=x;break}y=x/+qXa(c[(d+536|0)>>2]|0,z,40376,50112,+h[u>>3],(a[d+319|0]|0)!=0|0);F=c[c[(d+4|0)>>2]>>2]|0;qa=c[(d+416|0)>>2]|0;ra=c[F+8>>2]|0;sa=F;ta=y}}while(0);h[e+976>>3]=t*E*ta*-.05- +h[ra+8424>>3];z=+h[qa+2704>>3];x=+h[ra+9368>>3]- +h[ra+728>>3];G=+h[qa+2672>>3];P=+h[qa+2680>>3];do{if(G!=0.0){ua=qa;va=ra;wa=P/G}else{if(P==0.0){ua=qa;va=ra;wa=P;break}K=P/+qXa(c[(d+536|0)>>2]|0,G,40376,50112,+h[sa>>3],(a[d+319|0]|0)!=0|0);ua=c[(d+416|0)>>2]|0;va=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;wa=K}}while(0);h[e+984>>3]=z*x*wa*-.05- +h[va+3760>>3];G=+h[(d+304|0)>>3];JD(b+328|0,c[(d+536|0)>>2]|0,+h[va+7112>>3],+h[va+12288>>3],+h[va+12296>>3],+h[va+10920>>3],+h[va+10928>>3],+h[ua+416>>3],+h[va+13104>>3],+h[va+12632>>3]*+h[ua+2904>>3],(+h[ua+896>>3]+ +h[ua+904>>3])*.5,+h[ua+2896>>3]*.05,+h[ua+2864>>3]);P=+h[(b+328|0)>>3];u=c[c[(d+4|0)>>2]>>2]|0;v=c[u+8>>2]|0;E=+h[v+8096>>3];w=c[(d+416|0)>>2]|0;t=+h[w+2872>>3];K=+h[v+7112>>3]- +h[v+12632>>3]*+h[w+2904>>3]*+h[w+2920>>3];do{if(t!=0.0){xa=v;ya=w;za=K/t}else{if(K==0.0){xa=v;ya=w;za=K;break}y=K/+qXa(c[(d+536|0)>>2]|0,t,32896,50112,+h[u>>3],(a[d+319|0]|0)!=0|0);xa=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;ya=c[(d+416|0)>>2]|0;za=y}}while(0);h[e+992>>3]=E+((G+-1.0)*za-G*P*+h[ya+2840>>3]);h[e+1e3>>3]=+h[xa+10016>>3]+(-+h[xa+8592>>3]- +h[xa+8432>>3]- +h[xa+8272>>3]);h[e+1008>>3]=+h[xa+10008>>3]+(-+h[xa+8584>>3]- +h[xa+8424>>3]- +h[xa+8264>>3]);_D(b+336|0,c[(d+536|0)>>2]|0,+h[xa+5360>>3],+h[xa+5200>>3],+h[xa+6160>>3]+-6150.0,3850.0);u=c[c[(d+4|0)>>2]>>2]|0;w=c[u+8>>2]|0;h[e+1016>>3]=+h[w+5840>>3]- +h[(b+336|0)>>3];v=c[(d+416|0)>>2]|0;t=+h[v+2704>>3];K=+h[w+9520>>3]- +h[w+720>>3];x=+h[v+2672>>3];z=+h[v+2680>>3];do{if(x!=0.0){Aa=v;Ba=w;Ca=u;Da=z/x}else{if(z==0.0){Aa=v;Ba=w;Ca=u;Da=z;break}y=z/+qXa(c[(d+536|0)>>2]|0,x,40376,50112,+h[u>>3],(a[d+319|0]|0)!=0|0);F=c[c[(d+4|0)>>2]>>2]|0;Aa=c[(d+416|0)>>2]|0;Ba=c[F+8>>2]|0;Ca=F;Da=y}}while(0);h[e+1024>>3]=t*K*Da*-.05- +h[Ba+8416>>3];x=+h[Aa+2704>>3];z=+h[Ba+9360>>3]- +h[Ba+720>>3];P=+h[Aa+2672>>3];G=+h[Aa+2680>>3];do{if(P!=0.0){Ea=Aa;Fa=Ba;Ga=G/P}else{if(G==0.0){Ea=Aa;Fa=Ba;Ga=G;break}E=G/+qXa(c[(d+536|0)>>2]|0,P,40376,50112,+h[Ca>>3],(a[d+319|0]|0)!=0|0);Ea=c[(d+416|0)>>2]|0;Fa=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;Ga=E}}while(0);u=Fa+3768|0;h[e+1032>>3]=x*z*Ga*-.05- +h[u>>3];h[e+1040>>3]=+h[u>>3]- +h[Ea+3184>>3]*+h[Fa+14216>>3]*(+h[Fa+9360>>3]- +h[Fa+160>>3])*+h[Ea+3176>>3];h[e+1048>>3]=+h[Fa+9992>>3]+(-+h[Fa+8568>>3]- +h[Fa+8408>>3]- +h[Fa+8248>>3]);_D(b+344|0,c[(d+536|0)>>2]|0,+h[Fa+5352>>3],+h[Fa+5192>>3],+h[Fa+6152>>3]+-6150.0,3850.0);u=c[c[(d+4|0)>>2]>>2]|0;w=c[u+8>>2]|0;h[e+1056>>3]=+h[w+5832>>3]- +h[(b+344|0)>>3];v=c[(d+416|0)>>2]|0;P=+h[v+2704>>3];G=+h[w+9512>>3]- +h[w+712>>3];K=+h[v+2672>>3];t=+h[v+2680>>3];do{if(K!=0.0){Ha=v;Ia=w;Ja=u;Ka=t/K}else{if(t==0.0){Ha=v;Ia=w;Ja=u;Ka=t;break}E=t/+qXa(c[(d+536|0)>>2]|0,K,40376,50112,+h[u>>3],(a[d+319|0]|0)!=0|0);F=c[c[(d+4|0)>>2]>>2]|0;Ha=c[(d+416|0)>>2]|0;Ia=c[F+8>>2]|0;Ja=F;Ka=E}}while(0);h[e+1064>>3]=P*G*Ka*-.05- +h[Ia+8408>>3];K=+h[Ha+2704>>3];t=+h[Ia+9352>>3]- +h[Ia+712>>3];z=+h[Ha+2672>>3];x=+h[Ha+2680>>3];do{if(z!=0.0){La=Ha;Ma=Ia;Na=x/z}else{if(x==0.0){La=Ha;Ma=Ia;Na=x;break}E=x/+qXa(c[(d+536|0)>>2]|0,z,40376,50112,+h[Ja>>3],(a[d+319|0]|0)!=0|0);La=c[(d+416|0)>>2]|0;Ma=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;Na=E}}while(0);u=Ma+3776|0;h[e+1072>>3]=K*t*Na*-.05- +h[u>>3];h[e+1080>>3]=+h[u>>3]- +h[La+3184>>3]*+h[Ma+14224>>3]*(+h[Ma+9352>>3]- +h[Ma+144>>3])*+h[La+3176>>3];h[e+1088>>3]=+h[Ma+8728>>3]+(+h[Ma+8096>>3]- +h[Ma+8104>>3]);z=+h[Ma+8112>>3];h[e+1096>>3]=+h[Ma+7912>>3]-z*+h[(!(z>=0.0)?Ma+9216|0:Ma+9224|0)>>3];h[e+1104>>3]=+h[Ma+8400>>3]- +h[Ma+4704>>3]*+h[Ma+13568>>3]*(+h[Ma+9504>>3]- +h[Ma+496>>3])*+h[La+2944>>3];_D(b+352|0,c[(d+536|0)>>2]|0,+h[Ma+5344>>3],+h[Ma+5184>>3],+h[Ma+6144>>3]+-6150.0,3850.0);u=c[c[(d+4|0)>>2]>>2]|0;w=c[u+8>>2]|0;h[e+1112>>3]=+h[w+5824>>3]- +h[(b+352|0)>>3];v=c[(d+416|0)>>2]|0;z=+h[v+2704>>3];x=+h[w+9504>>3]- +h[w+704>>3];G=+h[v+2672>>3];P=+h[v+2680>>3];do{if(G!=0.0){Oa=v;Pa=w;Qa=u;Ra=P/G}else{if(P==0.0){Oa=v;Pa=w;Qa=u;Ra=P;break}E=P/+qXa(c[(d+536|0)>>2]|0,G,40376,50112,+h[u>>3],(a[d+319|0]|0)!=0|0);F=c[c[(d+4|0)>>2]>>2]|0;Oa=c[(d+416|0)>>2]|0;Pa=c[F+8>>2]|0;Qa=F;Ra=E}}while(0);h[e+1120>>3]=z*x*Ra*-.05- +h[Pa+8400>>3];G=+h[Oa+2704>>3];P=+h[Pa+9344>>3]- +h[Pa+704>>3];t=+h[Oa+2672>>3];K=+h[Oa+2680>>3];do{if(t!=0.0){Sa=Oa;Ta=Pa;Ua=K/t}else{if(K==0.0){Sa=Oa;Ta=Pa;Ua=K;break}E=K/+qXa(c[(d+536|0)>>2]|0,t,40376,50112,+h[Qa>>3],(a[d+319|0]|0)!=0|0);Sa=c[(d+416|0)>>2]|0;Ta=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;Ua=E}}while(0);u=Ta+3784|0;h[e+1128>>3]=G*P*Ua*-.05- +h[u>>3];h[e+1136>>3]=+h[u>>3]- +h[Sa+3184>>3]*+h[Ta+14232>>3]*(+h[Ta+9344>>3]- +h[Ta+128>>3])*+h[Sa+3176>>3];t=+h[(d+304|0)>>3];JD(b+360|0,c[(d+536|0)>>2]|0,+h[Ta+7096>>3],+h[Ta+12272>>3],+h[Ta+12280>>3],+h[Ta+10904>>3],+h[Ta+10912>>3],+h[Sa+400>>3],+h[Ta+13120>>3],+h[Ta+12616>>3]*+h[Sa+2904>>3],(+h[Sa+880>>3]+ +h[Sa+888>>3])*.5,+h[Sa+2896>>3]*.05,+h[Sa+2864>>3]);K=+h[(b+360|0)>>3];u=c[c[(d+4|0)>>2]>>2]|0;w=c[u+8>>2]|0;x=+h[w+8112>>3];v=c[(d+416|0)>>2]|0;z=+h[v+2872>>3];E=+h[w+7096>>3]- +h[w+12616>>3]*+h[v+2904>>3]*+h[v+2920>>3];do{if(z!=0.0){Va=w;Wa=v;Xa=E/z}else{if(E==0.0){Va=w;Wa=v;Xa=E;break}y=E/+qXa(c[(d+536|0)>>2]|0,z,32896,50112,+h[u>>3],(a[d+319|0]|0)!=0|0);Va=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;Wa=c[(d+416|0)>>2]|0;Xa=y}}while(0);h[e+1144>>3]=x+((t+-1.0)*Xa-t*K*+h[Wa+2840>>3]);h[e+1152>>3]=+h[Va+8704>>3]- +h[Va+13392>>3]*+h[Va+10432>>3];u=Va+4696|0;h[e+1160>>3]=+h[Va+8392>>3]- +h[u>>3]*+h[Va+13560>>3]*(+h[Va+9496>>3]- +h[Va+512>>3])*+h[Wa+2944>>3];HD(b+368|0,c[(d+536|0)>>2]|0,+h[u>>3],+h[Wa+720>>3],+h[Va+5496>>3]);u=c[c[(d+4|0)>>2]>>2]|0;v=c[u+8>>2]|0;h[e+1168>>3]=+h[v+5816>>3]- +h[(b+368|0)>>3];w=c[(d+416|0)>>2]|0;z=+h[w+2704>>3];E=+h[v+9496>>3]- +h[v+696>>3];P=+h[w+2672>>3];G=+h[w+2680>>3];do{if(P!=0.0){Ya=w;Za=v;_a=u;$a=G/P}else{if(G==0.0){Ya=w;Za=v;_a=u;$a=G;break}y=G/+qXa(c[(d+536|0)>>2]|0,P,40376,50112,+h[u>>3],(a[d+319|0]|0)!=0|0);F=c[c[(d+4|0)>>2]>>2]|0;Ya=c[(d+416|0)>>2]|0;Za=c[F+8>>2]|0;_a=F;$a=y}}while(0);h[e+1176>>3]=z*E*$a*-.05- +h[Za+8392>>3];P=+h[Ya+2704>>3];G=+h[Za+9336>>3]- +h[Za+696>>3];K=+h[Ya+2672>>3];t=+h[Ya+2680>>3];do{if(K!=0.0){ab=Ya;bb=Za;cb=t/K}else{if(t==0.0){ab=Ya;bb=Za;cb=t;break}x=t/+qXa(c[(d+536|0)>>2]|0,K,40376,50112,+h[_a>>3],(a[d+319|0]|0)!=0|0);ab=c[(d+416|0)>>2]|0;bb=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;cb=x}}while(0);u=bb+3792|0;h[e+1184>>3]=P*G*cb*-.05- +h[u>>3];h[e+1192>>3]=+h[u>>3]- +h[ab+3184>>3]*+h[bb+14240>>3]*(+h[bb+9336>>3]- +h[bb+112>>3])*+h[ab+3176>>3];K=+h[(d+304|0)>>3];JD(b+376|0,c[(d+536|0)>>2]|0,+h[bb+7080>>3],+h[bb+12256>>3],+h[bb+12264>>3],+h[bb+10888>>3],+h[bb+10896>>3],+h[ab+384>>3],+h[bb+13136>>3],+h[bb+12600>>3]*+h[ab+2904>>3],(+h[ab+864>>3]+ +h[ab+872>>3])*.5,+h[ab+2896>>3]*.05,+h[ab+2864>>3]);t=+h[(b+376|0)>>3];u=c[c[(d+4|0)>>2]>>2]|0;v=c[u+8>>2]|0;E=+h[v+8128>>3];w=c[(d+416|0)>>2]|0;z=+h[w+2872>>3];x=+h[v+7080>>3]- +h[v+12600>>3]*+h[w+2904>>3]*+h[w+2920>>3];do{if(z!=0.0){db=v;eb=w;fb=x/z}else{if(x==0.0){db=v;eb=w;fb=x;break}y=x/+qXa(c[(d+536|0)>>2]|0,z,32896,50112,+h[u>>3],(a[d+319|0]|0)!=0|0);db=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;eb=c[(d+416|0)>>2]|0;fb=y}}while(0);h[e+1200>>3]=E+((K+-1.0)*fb-K*t*+h[eb+2840>>3]);_D(b+384|0,c[(d+536|0)>>2]|0,+h[db+5328>>3],+h[db+5168>>3],+h[db+6128>>3]+-6150.0,3850.0);u=c[c[(d+4|0)>>2]>>2]|0;w=c[u+8>>2]|0;h[e+1208>>3]=+h[w+5808>>3]- +h[(b+384|0)>>3];v=c[(d+416|0)>>2]|0;h[e+1216>>3]=+h[w+8384>>3]- +h[w+4688>>3]*+h[w+13552>>3]*(+h[(w+9488|0)>>3]- +h[w+528>>3])*+h[v+2944>>3];z=+h[v+2704>>3];x=+h[(w+9488|0)>>3]- +h[w+688>>3];G=+h[v+2672>>3];P=+h[v+2680>>3];do{if(G!=0.0){gb=v;hb=w;ib=u;jb=P/G}else{if(P==0.0){gb=v;hb=w;ib=u;jb=P;break}y=P/+qXa(c[(d+536|0)>>2]|0,G,40376,50112,+h[u>>3],(a[d+319|0]|0)!=0|0);F=c[c[(d+4|0)>>2]>>2]|0;gb=c[(d+416|0)>>2]|0;hb=c[F+8>>2]|0;ib=F;jb=y}}while(0);h[e+1224>>3]=z*x*jb*-.05- +h[hb+8384>>3];G=+h[gb+2704>>3];P=+h[hb+9328>>3]- +h[hb+688>>3];t=+h[gb+2672>>3];K=+h[gb+2680>>3];do{if(t!=0.0){kb=gb;lb=hb;mb=K/t}else{if(K==0.0){kb=gb;lb=hb;mb=K;break}E=K/+qXa(c[(d+536|0)>>2]|0,t,40376,50112,+h[ib>>3],(a[d+319|0]|0)!=0|0);kb=c[(d+416|0)>>2]|0;lb=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;mb=E}}while(0);h[e+1232>>3]=G*P*mb*-.05- +h[lb+3800>>3];t=+h[(d+304|0)>>3];JD(b+392|0,c[(d+536|0)>>2]|0,+h[lb+7088>>3],+h[lb+12264>>3],+h[lb+12272>>3],+h[lb+10896>>3],+h[lb+10904>>3],+h[kb+392>>3],+h[lb+13128>>3],+h[lb+12608>>3]*+h[kb+2904>>3],(+h[kb+872>>3]+ +h[kb+880>>3])*.5,+h[kb+2896>>3]*.05,+h[kb+2864>>3]);K=+h[(b+392|0)>>3];u=c[c[(d+4|0)>>2]>>2]|0;w=c[u+8>>2]|0;x=+h[w+8120>>3];v=c[(d+416|0)>>2]|0;z=+h[v+2872>>3];E=+h[w+7088>>3]- +h[w+12608>>3]*+h[v+2904>>3]*+h[v+2920>>3];do{if(z!=0.0){nb=w;ob=u;pb=v;qb=E/z}else{if(E==0.0){nb=w;ob=u;pb=v;qb=E;break}y=E/+qXa(c[(d+536|0)>>2]|0,z,32896,50112,+h[u>>3],(a[d+319|0]|0)!=0|0);F=c[c[(d+4|0)>>2]>>2]|0;nb=c[F+8>>2]|0;ob=F;pb=c[(d+416|0)>>2]|0;qb=y}}while(0);h[e+1240>>3]=x+((t+-1.0)*qb-t*K*+h[pb+2840>>3]);z=+h[pb+2704>>3];E=+h[nb+9400>>3]- +h[nb+760>>3];P=+h[pb+2672>>3];G=+h[pb+2680>>3];do{if(P!=0.0){rb=pb;sb=nb;tb=ob;ub=G/P}else{if(G==0.0){rb=pb;sb=nb;tb=ob;ub=G;break}y=G/+qXa(c[(d+536|0)>>2]|0,P,40376,50112,+h[ob>>3],(a[d+319|0]|0)!=0|0);u=c[c[(d+4|0)>>2]>>2]|0;rb=c[(d+416|0)>>2]|0;sb=c[u+8>>2]|0;tb=u;ub=y}}while(0);u=sb+3728|0;h[e+1248>>3]=z*E*ub*-.05- +h[u>>3];h[e+1256>>3]=+h[u>>3]- +h[rb+3184>>3]*+h[sb+14176>>3]*(+h[sb+9400>>3]- +h[sb+240>>3])*+h[rb+3176>>3];P=+h[rb+2704>>3];G=+h[sb+9288>>3]- +h[sb+648>>3];K=+h[rb+2672>>3];t=+h[rb+2680>>3];if(K!=0.0){vb=rb;wb=sb;xb=t/K;yb=G*xb;zb=P*yb;Ab=zb*-.05;Bb=wb;Cb=Bb+3840|0;Db=Cb;Eb=+h[Db>>3];Fb=Ab-Eb;Gb=e;Hb=Gb+1264|0;Ib=Hb;h[Ib>>3]=Fb;Jb=+h[Db>>3];Kb=vb;Lb=Kb+3184|0;Mb=Lb;Nb=+h[Mb>>3];Ob=wb;Pb=Ob+14288|0;Qb=Pb;Rb=+h[Qb>>3];Sb=wb;Tb=Sb+9288|0;Ub=Tb;Vb=+h[Ub>>3];Wb=wb;Xb=Wb+16|0;Yb=Xb;Zb=+h[Yb>>3];_b=Vb-Zb;$b=vb;ac=$b+3176|0;bc=ac;cc=+h[bc>>3];dc=_b*cc;ec=Rb*dc;fc=Nb*ec;gc=Jb-fc;hc=e;ic=hc+1272|0;jc=ic;h[jc>>3]=gc;i=b;c[b+7048>>2]=5;break a}if(t==0.0){vb=rb;wb=sb;xb=t;yb=G*xb;zb=P*yb;Ab=zb*-.05;Bb=wb;Cb=Bb+3840|0;Db=Cb;Eb=+h[Db>>3];Fb=Ab-Eb;Gb=e;Hb=Gb+1264|0;Ib=Hb;h[Ib>>3]=Fb;Jb=+h[Db>>3];Kb=vb;Lb=Kb+3184|0;Mb=Lb;Nb=+h[Mb>>3];Ob=wb;Pb=Ob+14288|0;Qb=Pb;Rb=+h[Qb>>3];Sb=wb;Tb=Sb+9288|0;Ub=Tb;Vb=+h[Ub>>3];Wb=wb;Xb=Wb+16|0;Yb=Xb;Zb=+h[Yb>>3];_b=Vb-Zb;$b=vb;ac=$b+3176|0;bc=ac;cc=+h[bc>>3];dc=_b*cc;ec=Rb*dc;fc=Nb*ec;gc=Jb-fc;hc=e;ic=hc+1272|0;jc=ic;h[jc>>3]=gc;i=b;c[b+7048>>2]=5;break a}x=t/+qXa(c[(d+536|0)>>2]|0,K,40376,50112,+h[tb>>3],(a[d+319|0]|0)!=0|0);vb=c[(d+416|0)>>2]|0;wb=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;xb=x;yb=G*xb;zb=P*yb;Ab=zb*-.05;Bb=wb;Cb=Bb+3840|0;Db=Cb;Eb=+h[Db>>3];Fb=Ab-Eb;Gb=e;Hb=Gb+1264|0;Ib=Hb;h[Ib>>3]=Fb;Jb=+h[Db>>3];Kb=vb;Lb=Kb+3184|0;Mb=Lb;Nb=+h[Mb>>3];Ob=wb;Pb=Ob+14288|0;Qb=Pb;Rb=+h[Qb>>3];Sb=wb;Tb=Sb+9288|0;Ub=Tb;Vb=+h[Ub>>3];Wb=wb;Xb=Wb+16|0;Yb=Xb;Zb=+h[Yb>>3];_b=Vb-Zb;$b=vb;ac=$b+3176|0;bc=ac;cc=+h[bc>>3];dc=_b*cc;ec=Rb*dc;fc=Nb*ec;gc=Jb-fc;hc=e;ic=hc+1272|0;jc=ic;h[jc>>3]=gc;i=b;c[b+7048>>2]=5;break a}while(0)}function _residualFunc1550$1(b){b=b|0;var d=0,e=0,f=0.0,i=0.0,j=0,k=0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0.0,A=0.0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0.0,N=0,O=0,P=0.0,Q=0,R=0,S=0.0,T=0,U=0,V=0.0,W=0,X=0,Y=0.0,Z=0,_=0,$=0.0,aa=0,ba=0,ca=0.0,da=0,ea=0,fa=0.0,ga=0,ha=0,ia=0,ja=0.0,ka=0,la=0,ma=0.0,na=0,oa=0,pa=0.0,qa=0,ra=0,sa=0,ta=0.0,ua=0,va=0,wa=0.0,xa=0,ya=0,za=0.0,Aa=0,Ba=0,Ca=0.0,Da=0,Ea=0,Fa=0,Ga=0.0,Ha=0,Ia=0,Ja=0,Ka=0.0,La=0,Ma=0,Na=0.0,Oa=0,Pa=0,Qa=0,Ra=0.0,Sa=0,Ta=0.0,Ua=0,Va=0,Wa=0.0,Xa=0,Ya=0,Za=0,_a=0.0,$a=0,ab=0,bb=0.0;d=c[b+408>>2]|0;e=c[b+424>>2]|0;f=+g[b+1200>>2];i=+g[b+1208>>2];j=c[b+1216>>2]|0;k=c[b+1224>>2]|0;l=+g[b+1232>>2];m=c[b+1240>>2]|0;n=+g[b+1248>>2];o=+g[b+3560>>2];p=+g[b+3568>>2];q=c[b+3576>>2]|0;r=c[b+3584>>2]|0;s=+g[b+3592>>2];t=c[b+3600>>2]|0;u=+g[b+3608>>2];v=+g[b+3624>>2];w=+h[k+7072>>3]- +h[k+12592>>3]*+h[m+2904>>3]*+h[m+2920>>3];do{if(n!=0.0){x=k;y=m;z=w/n}else{if(w==0.0){x=k;y=m;z=w;break}A=w/+qXa(c[(d+536|0)>>2]|0,n,32896,50112,+h[j>>3],(a[d+319|0]|0)!=0|0);x=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;y=c[(d+416|0)>>2]|0;z=A}}while(0);h[e+216>>3]=l+((f+-1.0)*z-f*i*+h[y+2840>>3]);HD(b+88|0,c[(d+536|0)>>2]|0,+h[x+4680>>3],+h[y+704>>3],+h[x+5480>>3]);x=c[c[(d+4|0)>>2]>>2]|0;y=c[x+8>>2]|0;h[e+224>>3]=+h[y+5800>>3]- +h[(b+88|0)>>3];h[e+232>>3]=+h[y+10192>>3]+(-+h[y+3968>>3]- +h[y+3808>>3]- +h[y+3648>>3]);h[e+240>>3]=+h[y+9960>>3]+(-+h[y+8536>>3]- +h[y+8376>>3]- +h[y+8216>>3]);j=c[(d+416|0)>>2]|0;i=+h[j+2704>>3];f=+h[y+9320>>3]- +h[y+680>>3];z=+h[j+2672>>3];l=+h[j+2680>>3];do{if(z!=0.0){B=j;C=y;D=x;E=l/z}else{if(l==0.0){B=j;C=y;D=x;E=l;break}n=l/+qXa(c[(d+536|0)>>2]|0,z,40376,50112,+h[x>>3],(a[d+319|0]|0)!=0|0);m=c[c[(d+4|0)>>2]>>2]|0;B=c[(d+416|0)>>2]|0;C=c[m+8>>2]|0;D=m;E=n}}while(0);h[e+248>>3]=i*f*E*-.05- +h[C+3808>>3];E=+h[B+2704>>3];f=+h[C+9480>>3]- +h[C+680>>3];i=+h[B+2672>>3];z=+h[B+2680>>3];do{if(i!=0.0){F=B;G=C;H=D;I=z/i}else{if(z==0.0){F=B;G=C;H=D;I=z;break}l=z/+qXa(c[(d+536|0)>>2]|0,i,40376,50112,+h[D>>3],(a[d+319|0]|0)!=0|0);x=c[c[(d+4|0)>>2]>>2]|0;F=c[(d+416|0)>>2]|0;G=c[x+8>>2]|0;H=x;I=l}}while(0);h[e+256>>3]=E*f*I*-.05- +h[G+8376>>3];h[e+264>>3]=+h[G+3808>>3]- +h[F+3184>>3]*+h[G+14256>>3]*(+h[G+9320>>3]- +h[G+80>>3])*+h[F+3176>>3];h[e+272>>3]=+h[G+9968>>3]+(-+h[G+8544>>3]- +h[G+8384>>3]- +h[G+8224>>3]);I=+h[F+2704>>3];f=+h[G+9312>>3]- +h[G+672>>3];E=+h[F+2672>>3];i=+h[F+2680>>3];do{if(E!=0.0){J=F;K=G;L=H;M=i/E}else{if(i==0.0){J=F;K=G;L=H;M=i;break}z=i/+qXa(c[(d+536|0)>>2]|0,E,40376,50112,+h[H>>3],(a[d+319|0]|0)!=0|0);D=c[c[(d+4|0)>>2]>>2]|0;J=c[(d+416|0)>>2]|0;K=c[D+8>>2]|0;L=D;M=z}}while(0);h[e+280>>3]=I*f*M*-.05- +h[K+3816>>3];M=+h[J+2704>>3];f=+h[K+9472>>3]- +h[K+672>>3];I=+h[J+2672>>3];E=+h[J+2680>>3];do{if(I!=0.0){N=J;O=K;P=E/I}else{if(E==0.0){N=J;O=K;P=E;break}i=E/+qXa(c[(d+536|0)>>2]|0,I,40376,50112,+h[L>>3],(a[d+319|0]|0)!=0|0);N=c[(d+416|0)>>2]|0;O=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;P=i}}while(0);h[e+288>>3]=M*f*P*-.05- +h[O+8368>>3];HD(b+96|0,c[(d+536|0)>>2]|0,+h[O+4672>>3],+h[N+696>>3],+h[O+5472>>3]);O=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;h[e+296>>3]=+h[O+5792>>3]- +h[(b+96|0)>>3];N=c[(d+416|0)>>2]|0;h[e+304>>3]=+h[O+3816>>3]- +h[(N+3184|0)>>3]*+h[O+14264>>3]*(+h[O+9312>>3]- +h[O+64>>3])*+h[(N+3176|0)>>3];h[e+312>>3]=+h[O+3800>>3]- +h[(N+3184|0)>>3]*+h[O+14248>>3]*(+h[O+9328>>3]- +h[O+96>>3])*+h[(N+3176|0)>>3];P=+h[(d+304|0)>>3];JD(b+104|0,c[(d+536|0)>>2]|0,+h[O+2496>>3],+h[O+12488>>3],+h[O+12496>>3],+h[O+11112>>3],+h[O+11120>>3],+h[N+1568>>3],+h[O+12936>>3],+h[O+12816>>3]*+h[N+3136>>3],(+h[N+2040>>3]+ +h[N+2048>>3])*.5,+h[N+3128>>3]*.05,+h[N+3096>>3]);f=+h[(b+104|0)>>3];N=c[c[(d+4|0)>>2]>>2]|0;O=c[N+8>>2]|0;M=+h[O+3432>>3];L=c[(d+416|0)>>2]|0;I=+h[L+3104>>3];E=+h[O+2496>>3]- +h[O+12816>>3]*+h[L+3136>>3]*+h[L+3152>>3];do{if(I!=0.0){Q=O;R=L;S=E/I}else{if(E==0.0){Q=O;R=L;S=E;break}i=E/+qXa(c[(d+536|0)>>2]|0,I,36984,50112,+h[N>>3],(a[d+319|0]|0)!=0|0);Q=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;R=c[(d+416|0)>>2]|0;S=i}}while(0);h[e+320>>3]=M+((P+-1.0)*S-P*f*+h[R+3072>>3]);h[e+328>>3]=+h[Q+8408>>3]- +h[Q+4712>>3]*+h[Q+13576>>3]*(+h[Q+9512>>3]- +h[Q+480>>3])*+h[R+2944>>3];f=+h[(d+304|0)>>3];JD(b+112|0,c[(d+536|0)>>2]|0,+h[Q+2464>>3],+h[Q+12456>>3],+h[Q+12464>>3],+h[Q+11080>>3],+h[Q+11088>>3],+h[R+1536>>3],+h[Q+12968>>3],+h[Q+12784>>3]*+h[R+3136>>3],(+h[R+2008>>3]+ +h[R+2016>>3])*.5,+h[R+3128>>3]*.05,+h[R+3096>>3]);P=+h[(b+112|0)>>3];R=c[c[(d+4|0)>>2]>>2]|0;Q=c[R+8>>2]|0;S=+h[Q+3464>>3];N=c[(d+416|0)>>2]|0;M=+h[N+3104>>3];I=+h[Q+2464>>3]- +h[Q+12784>>3]*+h[N+3136>>3]*+h[N+3152>>3];do{if(M!=0.0){T=Q;U=N;V=I/M}else{if(I==0.0){T=Q;U=N;V=I;break}E=I/+qXa(c[(d+536|0)>>2]|0,M,36984,50112,+h[R>>3],(a[d+319|0]|0)!=0|0);T=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;U=c[(d+416|0)>>2]|0;V=E}}while(0);h[e+336>>3]=S+((f+-1.0)*V-f*P*+h[U+3072>>3]);h[e+344>>3]=+h[T+1e4>>3]+(-+h[T+8576>>3]- +h[T+8416>>3]- +h[T+8256>>3]);P=+h[(d+304|0)>>3];JD(b+120|0,c[(d+536|0)>>2]|0,+h[T+2488>>3],+h[T+12480>>3],+h[T+12488>>3],+h[T+11104>>3],+h[T+11112>>3],+h[U+1560>>3],+h[T+12944>>3],+h[T+12808>>3]*+h[U+3136>>3],(+h[U+2032>>3]+ +h[U+2040>>3])*.5,+h[U+3128>>3]*.05,+h[U+3096>>3]);f=+h[(b+120|0)>>3];U=c[c[(d+4|0)>>2]>>2]|0;T=c[U+8>>2]|0;V=+h[T+3440>>3];R=c[(d+416|0)>>2]|0;S=+h[R+3104>>3];M=+h[T+2488>>3]- +h[T+12808>>3]*+h[R+3136>>3]*+h[R+3152>>3];do{if(S!=0.0){W=T;X=R;Y=M/S}else{if(M==0.0){W=T;X=R;Y=M;break}I=M/+qXa(c[(d+536|0)>>2]|0,S,36984,50112,+h[U>>3],(a[d+319|0]|0)!=0|0);W=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;X=c[(d+416|0)>>2]|0;Y=I}}while(0);h[e+352>>3]=V+((P+-1.0)*Y-P*f*+h[X+3072>>3]);h[e+360>>3]=+h[W+3760>>3]- +h[X+3184>>3]*+h[W+14208>>3]*(+h[W+9368>>3]- +h[W+176>>3])*+h[X+3176>>3];h[e+368>>3]=+h[W+9976>>3]+(-+h[W+8552>>3]- +h[W+8392>>3]- +h[W+8232>>3]);f=+h[(d+304|0)>>3];JD(b+128|0,c[(d+536|0)>>2]|0,+h[W+2512>>3],+h[W+12504>>3],+h[W+12512>>3],+h[W+11128>>3],+h[W+11136>>3],+h[X+1584>>3],+h[W+12920>>3],+h[W+12832>>3]*+h[X+3136>>3],(+h[X+2056>>3]+ +h[X+2064>>3])*.5,+h[X+3128>>3]*.05,+h[X+3096>>3]);P=+h[(b+128|0)>>3];X=c[c[(d+4|0)>>2]>>2]|0;W=c[X+8>>2]|0;Y=+h[W+3416>>3];U=c[(d+416|0)>>2]|0;V=+h[U+3104>>3];S=+h[W+2512>>3]- +h[W+12832>>3]*+h[U+3136>>3]*+h[U+3152>>3];do{if(V!=0.0){Z=W;_=U;$=S/V}else{if(S==0.0){Z=W;_=U;$=S;break}M=S/+qXa(c[(d+536|0)>>2]|0,V,36984,50112,+h[X>>3],(a[d+319|0]|0)!=0|0);Z=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;_=c[(d+416|0)>>2]|0;$=M}}while(0);h[e+376>>3]=Y+((f+-1.0)*$-f*P*+h[_+3072>>3]);P=+h[(d+304|0)>>3];JD(b+136|0,c[(d+536|0)>>2]|0,+h[Z+2504>>3],+h[Z+12496>>3],+h[Z+12504>>3],+h[Z+11120>>3],+h[Z+11128>>3],+h[_+1576>>3],+h[Z+12928>>3],+h[Z+12824>>3]*+h[_+3136>>3],(+h[_+2048>>3]+ +h[_+2056>>3])*.5,+h[_+3128>>3]*.05,+h[_+3096>>3]);f=+h[(b+136|0)>>3];_=c[c[(d+4|0)>>2]>>2]|0;Z=c[_+8>>2]|0;$=+h[Z+3424>>3];X=c[(d+416|0)>>2]|0;Y=+h[X+3104>>3];V=+h[Z+2504>>3]- +h[Z+12824>>3]*+h[X+3136>>3]*+h[X+3152>>3];do{if(Y!=0.0){aa=Z;ba=X;ca=V/Y}else{if(V==0.0){aa=Z;ba=X;ca=V;break}S=V/+qXa(c[(d+536|0)>>2]|0,Y,36984,50112,+h[_>>3],(a[d+319|0]|0)!=0|0);aa=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;ba=c[(d+416|0)>>2]|0;ca=S}}while(0);h[e+384>>3]=$+((P+-1.0)*ca-P*f*+h[ba+3072>>3]);h[e+392>>3]=+h[aa+4136>>3]- +h[aa+14104>>3]*+h[aa+10808>>3];f=+h[(d+304|0)>>3];JD(b+144|0,c[(d+536|0)>>2]|0,+h[aa+2520>>3],+h[aa+12512>>3],+h[aa+12520>>3],+h[aa+11136>>3],+h[aa+11144>>3],+h[ba+1592>>3],+h[aa+12912>>3],+h[aa+12840>>3]*+h[ba+3136>>3],(+h[ba+2064>>3]+ +h[ba+2072>>3])*.5,+h[ba+3128>>3]*.05,+h[ba+3096>>3]);P=+h[(b+144|0)>>3];ba=c[c[(d+4|0)>>2]>>2]|0;aa=c[ba+8>>2]|0;ca=+h[aa+3408>>3];_=c[(d+416|0)>>2]|0;$=+h[_+3104>>3];Y=+h[aa+2520>>3]- +h[aa+12840>>3]*+h[_+3136>>3]*+h[_+3152>>3];do{if($!=0.0){da=aa;ea=_;fa=Y/$}else{if(Y==0.0){da=aa;ea=_;fa=Y;break}V=Y/+qXa(c[(d+536|0)>>2]|0,$,36984,50112,+h[ba>>3],(a[d+319|0]|0)!=0|0);da=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;ea=c[(d+416|0)>>2]|0;fa=V}}while(0);h[e+400>>3]=ca+((f+-1.0)*fa-f*P*+h[ea+3072>>3]);P=+h[(d+304|0)>>3];JD(b+152|0,c[(d+536|0)>>2]|0,+h[da+2528>>3],+h[da+12520>>3],+h[da+12528>>3],+h[da+11144>>3],+h[da+11152>>3],+h[ea+1600>>3],+h[da+12904>>3],+h[da+12848>>3]*+h[ea+3136>>3],(+h[ea+2072>>3]+ +h[ea+2080>>3])*.5,+h[ea+3128>>3]*.05,+h[ea+3096>>3]);f=+h[(b+152|0)>>3];ea=c[c[(d+4|0)>>2]>>2]|0;da=c[ea+8>>2]|0;fa=+h[da+3400>>3];ba=c[(d+416|0)>>2]|0;ca=+h[ba+3104>>3];$=+h[da+2528>>3]- +h[da+12848>>3]*+h[ba+3136>>3]*+h[ba+3152>>3];do{if(ca!=0.0){ga=da;ha=ea;ia=ba;ja=$/ca}else{if($==0.0){ga=da;ha=ea;ia=ba;ja=$;break}Y=$/+qXa(c[(d+536|0)>>2]|0,ca,36984,50112,+h[ea>>3],(a[d+319|0]|0)!=0|0);_=c[c[(d+4|0)>>2]>>2]|0;ga=c[_+8>>2]|0;ha=_;ia=c[(d+416|0)>>2]|0;ja=Y}}while(0);h[e+408>>3]=fa+((P+-1.0)*ja-P*f*+h[ia+3072>>3]);ea=ga+3824|0;h[e+416>>3]=+h[ga+10208>>3]+(-+h[ga+3984>>3]- +h[ea>>3]- +h[ga+3664>>3]);h[e+424>>3]=+h[ga+10200>>3]+(-+h[ga+3976>>3]- +h[ga+3816>>3]- +h[ga+3656>>3]);ba=ga+9304|0;h[e+432>>3]=+h[ea>>3]- +h[ia+3184>>3]*+h[ga+14272>>3]*(+h[ba>>3]- +h[ga+48>>3])*+h[ia+3176>>3];f=+h[ia+2704>>3];P=+h[ba>>3]- +h[ga+664>>3];ja=+h[ia+2672>>3];fa=+h[ia+2680>>3];do{if(ja!=0.0){ka=ia;la=ga;ma=fa/ja}else{if(fa==0.0){ka=ia;la=ga;ma=fa;break}ca=fa/+qXa(c[(d+536|0)>>2]|0,ja,40376,50112,+h[ha>>3],(a[d+319|0]|0)!=0|0);ka=c[(d+416|0)>>2]|0;la=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;ma=ca}}while(0);h[e+440>>3]=f*P*ma*-.05- +h[la+3824>>3];h[e+448>>3]=+h[la+8416>>3]- +h[la+4720>>3]*+h[la+13584>>3]*(+h[la+9520>>3]- +h[la+464>>3])*+h[ka+2944>>3];ma=+h[(d+304|0)>>3];JD(b+160|0,c[(d+536|0)>>2]|0,+h[la+2472>>3],+h[la+12464>>3],+h[la+12472>>3],+h[la+11088>>3],+h[la+11096>>3],+h[ka+1544>>3],+h[la+12960>>3],+h[la+12792>>3]*+h[ka+3136>>3],(+h[ka+2016>>3]+ +h[ka+2024>>3])*.5,+h[ka+3128>>3]*.05,+h[ka+3096>>3]);P=+h[(b+160|0)>>3];ka=c[c[(d+4|0)>>2]>>2]|0;la=c[ka+8>>2]|0;f=+h[la+3456>>3];ha=c[(d+416|0)>>2]|0;ja=+h[ha+3104>>3];fa=+h[la+2472>>3]- +h[la+12792>>3]*+h[ha+3136>>3]*+h[ha+3152>>3];do{if(ja!=0.0){na=la;oa=ha;pa=fa/ja}else{if(fa==0.0){na=la;oa=ha;pa=fa;break}ca=fa/+qXa(c[(d+536|0)>>2]|0,ja,36984,50112,+h[ka>>3],(a[d+319|0]|0)!=0|0);na=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;oa=c[(d+416|0)>>2]|0;pa=ca}}while(0);h[e+456>>3]=f+((ma+-1.0)*pa-ma*P*+h[oa+3072>>3]);h[e+464>>3]=+h[na+4072>>3]+(+h[na+3464>>3]- +h[na+3472>>3]);h[e+472>>3]=+h[na+8448>>3]- +h[na+4752>>3]*+h[na+13616>>3]*(+h[na+9552>>3]- +h[na+400>>3])*+h[oa+2944>>3];P=+h[(d+304|0)>>3];JD(b+168|0,c[(d+536|0)>>2]|0,+h[na+2440>>3],+h[na+12432>>3],+h[na+12440>>3],+h[na+11056>>3],+h[na+11064>>3],+h[oa+1512>>3],+h[na+12992>>3],+h[na+12760>>3]*+h[oa+3136>>3],(+h[oa+1984>>3]+ +h[oa+1992>>3])*.5,+h[oa+3128>>3]*.05,+h[oa+3096>>3]);ma=+h[(b+168|0)>>3];oa=c[c[(d+4|0)>>2]>>2]|0;na=c[oa+8>>2]|0;pa=+h[na+3488>>3];ka=c[(d+416|0)>>2]|0;f=+h[ka+3104>>3];ja=+h[na+2440>>3]- +h[na+12760>>3]*+h[ka+3136>>3]*+h[ka+3152>>3];do{if(f!=0.0){qa=na;ra=oa;sa=ka;ta=ja/f}else{if(ja==0.0){qa=na;ra=oa;sa=ka;ta=ja;break}fa=ja/+qXa(c[(d+536|0)>>2]|0,f,36984,50112,+h[oa>>3],(a[d+319|0]|0)!=0|0);ha=c[c[(d+4|0)>>2]>>2]|0;qa=c[ha+8>>2]|0;ra=ha;sa=c[(d+416|0)>>2]|0;ta=fa}}while(0);h[e+480>>3]=pa+((P+-1.0)*ta-P*ma*+h[sa+3072>>3]);ma=+h[sa+2704>>3];P=+h[qa+9536>>3]- +h[qa+736>>3];ta=+h[sa+2672>>3];pa=+h[sa+2680>>3];do{if(ta!=0.0){ua=sa;va=qa;wa=pa/ta}else{if(pa==0.0){ua=sa;va=qa;wa=pa;break}f=pa/+qXa(c[(d+536|0)>>2]|0,ta,40376,50112,+h[ra>>3],(a[d+319|0]|0)!=0|0);ua=c[(d+416|0)>>2]|0;va=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;wa=f}}while(0);h[e+488>>3]=ma*P*wa*-.05- +h[va+8432>>3];wa=+h[(d+304|0)>>3];JD(b+176|0,c[(d+536|0)>>2]|0,+h[va+2448>>3],+h[va+12440>>3],+h[va+12448>>3],+h[va+11064>>3],+h[va+11072>>3],+h[ua+1520>>3],+h[va+12984>>3],+h[va+12768>>3]*+h[ua+3136>>3],(+h[ua+1992>>3]+ +h[ua+2e3>>3])*.5,+h[ua+3128>>3]*.05,+h[ua+3096>>3]);P=+h[(b+176|0)>>3];ua=c[c[(d+4|0)>>2]>>2]|0;va=c[ua+8>>2]|0;ma=+h[va+3480>>3];ra=c[(d+416|0)>>2]|0;ta=+h[ra+3104>>3];pa=+h[va+2448>>3]- +h[va+12768>>3]*+h[ra+3136>>3]*+h[ra+3152>>3];do{if(ta!=0.0){xa=va;ya=ra;za=pa/ta}else{if(pa==0.0){xa=va;ya=ra;za=pa;break}f=pa/+qXa(c[(d+536|0)>>2]|0,ta,36984,50112,+h[ua>>3],(a[d+319|0]|0)!=0|0);xa=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;ya=c[(d+416|0)>>2]|0;za=f}}while(0);h[e+496>>3]=ma+((wa+-1.0)*za-wa*P*+h[ya+3072>>3]);h[e+504>>3]=+h[xa+3744>>3]- +h[ya+3184>>3]*+h[xa+14192>>3]*(+h[xa+9384>>3]- +h[xa+208>>3])*+h[ya+3176>>3];h[e+512>>3]=+h[xa+4048>>3]+(+h[xa+3488>>3]- +h[xa+3496>>3]);h[e+520>>3]=+h[xa+8464>>3]- +h[xa+4768>>3]*+h[xa+13632>>3]*(+h[xa+9568>>3]- +h[xa+368>>3])*+h[ya+2944>>3];P=+h[xa+3504>>3];h[e+528>>3]=+h[xa+3232>>3]-P*+h[(!(P>=0.0)?xa+4616|0:xa+4624|0)>>3];h[e+536>>3]=+h[xa+10088>>3]+(-+h[xa+3864>>3]- +h[xa+3704>>3]- +h[xa+3544>>3]);P=+h[(d+304|0)>>3];ya=c[(d+416|0)>>2]|0;JD(b+184|0,c[(d+536|0)>>2]|0,+h[xa+2408>>3],+h[xa+12400>>3],+h[xa+12408>>3],+h[xa+11024>>3],+h[xa+11032>>3],+h[ya+1480>>3],+h[xa+13024>>3],+h[xa+12728>>3]*+h[ya+3136>>3],(+h[ya+1952>>3]+ +h[ya+1960>>3])*.5,+h[ya+3128>>3]*.05,+h[ya+3096>>3]);wa=+h[(b+184|0)>>3];ya=c[c[(d+4|0)>>2]>>2]|0;xa=c[ya+8>>2]|0;za=+h[xa+3520>>3];ua=c[(d+416|0)>>2]|0;ma=+h[ua+3104>>3];ta=+h[xa+2408>>3]- +h[xa+12728>>3]*+h[ua+3136>>3]*+h[ua+3152>>3];do{if(ma!=0.0){Aa=xa;Ba=ua;Ca=ta/ma}else{if(ta==0.0){Aa=xa;Ba=ua;Ca=ta;break}pa=ta/+qXa(c[(d+536|0)>>2]|0,ma,36984,50112,+h[ya>>3],(a[d+319|0]|0)!=0|0);Aa=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;Ba=c[(d+416|0)>>2]|0;Ca=pa}}while(0);h[e+544>>3]=za+((P+-1.0)*Ca-P*wa*+h[Ba+3072>>3]);wa=+h[(d+304|0)>>3];JD(b+192|0,c[(d+536|0)>>2]|0,+h[Aa+2424>>3],+h[Aa+12416>>3],+h[Aa+12424>>3],+h[Aa+11040>>3],+h[Aa+11048>>3],+h[Ba+1496>>3],+h[Aa+13008>>3],+h[Aa+12744>>3]*+h[Ba+3136>>3],(+h[Ba+1968>>3]+ +h[Ba+1976>>3])*.5,+h[Ba+3128>>3]*.05,+h[Ba+3096>>3]);P=+h[(b+192|0)>>3];Ba=c[c[(d+4|0)>>2]>>2]|0;Aa=c[Ba+8>>2]|0;Ca=+h[Aa+3504>>3];ya=c[(d+416|0)>>2]|0;za=+h[ya+3104>>3];ma=+h[Aa+2424>>3]- +h[Aa+12744>>3]*+h[ya+3136>>3]*+h[ya+3152>>3];do{if(za!=0.0){Da=Aa;Ea=Ba;Fa=ya;Ga=ma/za}else{if(ma==0.0){Da=Aa;Ea=Ba;Fa=ya;Ga=ma;break}ta=ma/+qXa(c[(d+536|0)>>2]|0,za,36984,50112,+h[Ba>>3],(a[d+319|0]|0)!=0|0);ua=c[c[(d+4|0)>>2]>>2]|0;Da=c[ua+8>>2]|0;Ea=ua;Fa=c[(d+416|0)>>2]|0;Ga=ta}}while(0);h[e+552>>3]=Ca+((wa+-1.0)*Ga-wa*P*+h[Fa+3072>>3]);h[e+560>>3]=+h[Da+8456>>3]- +h[Da+4760>>3]*+h[Da+13624>>3]*(+h[Da+9560>>3]- +h[Da+384>>3])*+h[Fa+2944>>3];h[e+568>>3]=+h[Da+10096>>3]+(-+h[Da+3872>>3]- +h[Da+3712>>3]- +h[Da+3552>>3]);h[e+576>>3]=+h[Da+10064>>3]+(-+h[Da+8640>>3]- +h[Da+8480>>3]- +h[Da+8320>>3]);P=+h[Fa+2704>>3];wa=+h[Da+9424>>3]- +h[Da+784>>3];Ga=+h[Fa+2672>>3];Ca=+h[Fa+2680>>3];do{if(Ga!=0.0){Ha=Fa;Ia=Da;Ja=Ea;Ka=Ca/Ga}else{if(Ca==0.0){Ha=Fa;Ia=Da;Ja=Ea;Ka=Ca;break}za=Ca/+qXa(c[(d+536|0)>>2]|0,Ga,40376,50112,+h[Ea>>3],(a[d+319|0]|0)!=0|0);Ba=c[c[(d+4|0)>>2]>>2]|0;Ha=c[(d+416|0)>>2]|0;Ia=c[Ba+8>>2]|0;Ja=Ba;Ka=za}}while(0);h[e+584>>3]=P*wa*Ka*-.05- +h[Ia+3704>>3];Ka=+h[Ha+2704>>3];wa=+h[Ia+9584>>3]- +h[Ia+784>>3];P=+h[Ha+2672>>3];Ga=+h[Ha+2680>>3];do{if(P!=0.0){La=Ha;Ma=Ia;Na=Ga/P}else{if(Ga==0.0){La=Ha;Ma=Ia;Na=Ga;break}Ca=Ga/+qXa(c[(d+536|0)>>2]|0,P,40376,50112,+h[Ja>>3],(a[d+319|0]|0)!=0|0);La=c[(d+416|0)>>2]|0;Ma=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;Na=Ca}}while(0);h[e+592>>3]=Ka*wa*Na*-.05- +h[Ma+8480>>3];Na=+h[(d+304|0)>>3];JD(b+200|0,c[(d+536|0)>>2]|0,+h[Ma+7168>>3],+h[Ma+12344>>3],+h[Ma+12352>>3],+h[Ma+10976>>3],+h[Ma+10984>>3],+h[La+472>>3],+h[Ma+13048>>3],+h[Ma+12688>>3]*+h[La+2904>>3],(+h[La+952>>3]+ +h[La+960>>3])*.5,+h[La+2896>>3]*.05,+h[La+2864>>3]);wa=+h[(b+200|0)>>3];La=c[c[(d+4|0)>>2]>>2]|0;Ma=c[La+8>>2]|0;Ka=+h[Ma+8040>>3];Ja=c[(d+416|0)>>2]|0;P=+h[Ja+2872>>3];Ga=+h[Ma+7168>>3]- +h[Ma+12688>>3]*+h[Ja+2904>>3]*+h[Ja+2920>>3];do{if(P!=0.0){Oa=Ma;Pa=La;Qa=Ja;Ra=Ga/P}else{if(Ga==0.0){Oa=Ma;Pa=La;Qa=Ja;Ra=Ga;break}Ca=Ga/+qXa(c[(d+536|0)>>2]|0,P,32896,50112,+h[La>>3],(a[d+319|0]|0)!=0|0);Ia=c[c[(d+4|0)>>2]>>2]|0;Oa=c[Ia+8>>2]|0;Pa=Ia;Qa=c[(d+416|0)>>2]|0;Ra=Ca}}while(0);h[e+600>>3]=Ka+((Na+-1.0)*Ra-Na*wa*+h[Qa+2840>>3]);h[e+608>>3]=+h[Oa+3712>>3]- +h[Qa+3184>>3]*+h[Oa+14160>>3]*(+h[Oa+9416>>3]- +h[Oa+272>>3])*+h[Qa+3176>>3];La=Oa+9576|0;h[e+616>>3]=+h[Oa+8472>>3]- +h[Oa+4776>>3]*+h[Oa+13640>>3]*(+h[La>>3]- +h[Oa+352>>3])*+h[Qa+2944>>3];h[e+624>>3]=+h[Oa+4032>>3]+(+h[Oa+3504>>3]- +h[Oa+3512>>3]);wa=+h[Qa+2704>>3];Na=+h[La>>3]- +h[Oa+776>>3];Ra=+h[Qa+2672>>3];Ka=+h[Qa+2680>>3];do{if(Ra!=0.0){Sa=Oa;Ta=Ka/Ra}else{if(Ka==0.0){Sa=Oa;Ta=Ka;break}P=Ka/+qXa(c[(d+536|0)>>2]|0,Ra,40376,50112,+h[Pa>>3],(a[d+319|0]|0)!=0|0);Sa=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;Ta=P}}while(0);h[e+632>>3]=wa*Na*Ta*-.05- +h[Sa+8472>>3];_D(b+208|0,c[(d+536|0)>>2]|0,+h[Sa+5416>>3],+h[Sa+5256>>3],+h[Sa+6216>>3]+-6150.0,3850.0);Sa=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;h[e+640>>3]=+h[Sa+5896>>3]- +h[(b+208|0)>>3];h[e+648>>3]=+h[Sa+10072>>3]+(-+h[Sa+8648>>3]- +h[Sa+8488>>3]- +h[Sa+8328>>3]);Ta=+h[(d+304|0)>>3];Pa=c[(d+416|0)>>2]|0;JD(b+216|0,c[(d+536|0)>>2]|0,+h[Sa+7176>>3],+h[Sa+12352>>3],+h[Sa+12360>>3],+h[Sa+10984>>3],+h[Sa+10992>>3],+h[Pa+480>>3],+h[Sa+13040>>3],+h[Sa+12696>>3]*+h[Pa+2904>>3],(+h[Pa+960>>3]+ +h[Pa+968>>3])*.5,+h[Pa+2896>>3]*.05,+h[Pa+2864>>3]);Na=+h[(b+216|0)>>3];Pa=c[c[(d+4|0)>>2]>>2]|0;Sa=c[Pa+8>>2]|0;wa=+h[Sa+8032>>3];Oa=c[(d+416|0)>>2]|0;Ra=+h[Oa+2872>>3];Ka=+h[Sa+7176>>3]- +h[Sa+12696>>3]*+h[Oa+2904>>3]*+h[Oa+2920>>3];do{if(Ra!=0.0){Ua=Sa;Va=Oa;Wa=Ka/Ra}else{if(Ka==0.0){Ua=Sa;Va=Oa;Wa=Ka;break}P=Ka/+qXa(c[(d+536|0)>>2]|0,Ra,32896,50112,+h[Pa>>3],(a[d+319|0]|0)!=0|0);Ua=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;Va=c[(d+416|0)>>2]|0;Wa=P}}while(0);h[e+656>>3]=wa+((Ta+-1.0)*Wa-Ta*Na*+h[Va+2840>>3]);h[e+664>>3]=+h[Ua+8480>>3]- +h[Ua+4784>>3]*+h[Ua+13648>>3]*(+h[Ua+9584>>3]- +h[Ua+336>>3])*+h[Va+2944>>3];_D(b+224|0,c[(d+536|0)>>2]|0,+h[Ua+5424>>3],+h[Ua+5264>>3],+h[Ua+6224>>3]+-6150.0,3850.0);Ua=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;h[e+672>>3]=+h[Ua+5904>>3]- +h[(b+224|0)>>3];_D(b+232|0,c[(d+536|0)>>2]|0,+h[Ua+5432>>3],+h[Ua+5272>>3],+h[Ua+6232>>3]+-6150.0,3850.0);Ua=c[c[(d+4|0)>>2]>>2]|0;Va=c[Ua+8>>2]|0;h[e+680>>3]=+h[Va+5912>>3]- +h[(b+232|0)>>3];Pa=c[(d+416|0)>>2]|0;Na=+h[Pa+2704>>3];Ta=+h[Va+9432>>3]- +h[Va+792>>3];Wa=+h[Pa+2672>>3];wa=+h[Pa+2680>>3];do{if(Wa!=0.0){Xa=Pa;Ya=Va;Za=Ua;_a=wa/Wa}else{if(wa==0.0){Xa=Pa;Ya=Va;Za=Ua;_a=wa;break}Ra=wa/+qXa(c[(d+536|0)>>2]|0,Wa,40376,50112,+h[Ua>>3],(a[d+319|0]|0)!=0|0);Oa=c[c[(d+4|0)>>2]>>2]|0;Xa=c[(d+416|0)>>2]|0;Ya=c[Oa+8>>2]|0;Za=Oa;_a=Ra}}while(0);h[e+688>>3]=Na*Ta*_a*-.05- +h[Ya+3696>>3];_a=+h[Xa+2704>>3];Ta=+h[Ya+9592>>3]- +h[Ya+792>>3];Na=+h[Xa+2672>>3];Wa=+h[Xa+2680>>3];do{if(Na!=0.0){$a=Xa;ab=Ya;bb=Wa/Na}else{if(Wa==0.0){$a=Xa;ab=Ya;bb=Wa;break}wa=Wa/+qXa(c[(d+536|0)>>2]|0,Na,40376,50112,+h[Za>>3],(a[d+319|0]|0)!=0|0);$a=c[(d+416|0)>>2]|0;ab=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;bb=wa}}while(0);h[e+696>>3]=_a*Ta*bb*-.05- +h[ab+8488>>3];Za=ab+3696|0;h[e+704>>3]=+h[Za>>3]- +h[$a+3184>>3]*+h[ab+14144>>3]*(+h[ab+9432>>3]- +h[ab+304>>3])*+h[$a+3176>>3];h[e+712>>3]=+h[ab+4016>>3]+(+h[ab+3520>>3]- +h[ab+3528>>3]);h[e+720>>3]=+h[ab+10080>>3]+(-+h[ab+3856>>3]- +h[Za>>3]- +h[ab+3536>>3]);h[e+728>>3]=+h[ab+8808>>3]+(+h[ab+8016>>3]- +h[ab+8024>>3]);o=+h[(d+304|0)>>3];JD(b+240|0,c[(d+536|0)>>2]|0,+h[ab+7160>>3],+h[ab+12336>>3],+h[ab+12344>>3],+h[ab+10968>>3],+h[ab+10976>>3],+h[$a+464>>3],+h[ab+13056>>3],+h[ab+12680>>3]*+h[$a+2904>>3],(+h[$a+944>>3]+ +h[$a+952>>3])*.5,+h[$a+2896>>3]*.05,+h[$a+2864>>3]);p=+h[(b+240|0)>>3];q=c[c[(d+4|0)>>2]>>2]|0;r=c[q+8>>2]|0;s=+h[r+8048>>3];t=c[(d+416|0)>>2]|0;u=+h[t+2872>>3];v=+h[r+7160>>3]- +h[r+12680>>3]*+h[t+2904>>3]*+h[t+2920>>3];g[b+3560>>2]=o;g[b+3568>>2]=p;c[b+3576>>2]=q;c[b+3584>>2]=r;g[b+3592>>2]=s;c[b+3600>>2]=t;g[b+3608>>2]=u;g[b+3624>>2]=v}



function cE(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0;d=+h[c>>3];e=+h[c+48>>3];f=+h[c+24>>3];g=e*f;j=+h[c+8>>3];k=+h[c+16>>3];l=+h[c+32>>3];m=l*+h[c+64>>3];n=k*(m- +h[c+40>>3]);o=l*l*+h[c+72>>3];p=e-l*+h[c+80>>3];l=+h[c+56>>3];h[a>>3]=d/(g*j*k);h[a+8>>3]=k*j*m;h[a+16>>3]=j*k*(m-g);h[a+24>>3]=n;h[a+32>>3]=-(k*o);h[a+40>>3]=k*(p*p/l-o);h[a+48>>3]=-(d*(p/(l*f*j)));h[a+56>>3]=-(k*j*(e*e/l));i=i;return}function dE(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;var j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0;j=+h[c>>3];k=+h[d>>3];if(j!=k){l=j*(k/(j-k))}else{l=0.0}m=l*(+h[d+24>>3]- +h[c+24>>3]);n=+h[c+48>>3];o=(n-m)/(j*j*+h[c+56>>3]);j=+h[d+48>>3];p=(j-m)/(k*k*+h[d+56>>3]);k=(n*f-g)*o+ +h[c+40>>3];h[a>>3]=k+(((j*f-g)*p+ +h[d+40>>3]-k)*e-l*(o+(p-o)*e)*(+h[d+16>>3]- +h[c+16>>3]));i=i;return}function eE(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0;d=+h[c+16>>3];e=+h[c>>3];f=+h[c+8>>3];g=+h[c+24>>3];j=+h[c+48>>3];k=g*j;l=+h[c+32>>3];m=l*+h[c+64>>3];n=d*(m- +h[c+40>>3]);o=g*(j-l*+h[c+80>>3]);p=l*l*+h[c+72>>3];l=+h[c+56>>3];h[a>>3]=e;h[a+8>>3]=d*f*(k+m);h[a+16>>3]=d*f*m;h[a+24>>3]=n;h[a+32>>3]=d*(o*o/(k*2.0+g*g*l)-p);h[a+40>>3]=-(d*p);h[a+48>>3]=d*e*o;h[a+56>>3]=d*f*g*(j*2.0+g*l);i=i;return}function fE(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=+f;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0,R=0,S=0,T=0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0,da=0,ea=0,fa=0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0;g=i;i=i+192|0;j=g;k=g+24|0;l=g+112|0;m=g+136|0;n=g+160|0;o=g+184|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+88|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+88|0;F=i;i=i+16|0;if(!(d>=16529200.0)){G=RXa(RXa(23840,PXa(d,0,1,6)|0)|0,23912)|0;H=RXa(RXa(G,PXa(16529200.0,0,1,6)|0)|0,23920)|0;G=c[72300]|0;I=n;J=24016;c[I+0>>2]=c[J+0>>2];c[I+4>>2]=c[J+4>>2];c[I+8>>2]=c[J+8>>2];c[I+12>>2]=c[J+12>>2];c[I+16>>2]=c[J+16>>2];c[I+20>>2]=c[J+20>>2];Pe[G&127](b,n,H,r);}if(!(e>=623.15)){r=RXa(RXa(24040,PXa(e,0,1,6)|0)|0,24112)|0;H=RXa(RXa(r,PXa(623.15,0,1,6)|0)|0,24120)|0;r=c[72300]|0;n=m;G=24128;c[n+0>>2]=c[G+0>>2];c[n+4>>2]=c[G+4>>2];c[n+8>>2]=c[G+8>>2];c[n+12>>2]=c[G+12>>2];c[n+16>>2]=c[G+16>>2];c[n+20>>2]=c[G+20>>2];Pe[r&127](b,m,H,q);}gE(t,0,e);if(!(+h[t>>3]<=d)){t=RXa(RXa(24152,PXa(d,0,1,6)|0)|0,24224)|0;q=RXa(RXa(t,PXa(e,0,1,6)|0)|0,24120)|0;t=c[72300]|0;H=l;m=24240;c[H+0>>2]=c[m+0>>2];c[H+4>>2]=c[m+4>>2];c[H+8>>2]=c[m+8>>2];c[H+12>>2]=c[m+12>>2];c[H+16>>2]=c[m+16>>2];c[H+20>>2]=c[m+20>>2];Pe[t&127](b,l,q,p);}hE(u,b,d);do{if(d>22064.0e3){K=+h[u>>3];iE(v,0,d);L=+h[v>>3];jE(w,0,d);M=+h[w>>3];N=L-(e+-623.15)*((L-M)/(623.15-K));O=L;P=M}else{kE(x,b,d);if(+h[x>>3]>e){iE(y,0,d);M=+h[y>>3];lE(z,0,d);L=+h[z>>3];mE(A,b,e);N=+h[A>>3]*1.1;O=M;P=L;break}else{nE(B,0,d);L=+h[B>>3];jE(C,0,d);M=+h[C>>3];oE(D,b,e);N=+h[D>>3]*.9;O=L;P=M;break}}}while(0);D=E;C=E+8|0;B=E+16|0;A=E+24|0;z=E+32|0;y=E+40|0;x=E+48|0;w=E+56|0;v=E+64|0;u=E+72|0;p=E+80|0;q=s;l=s+8|0;t=s+16|0;m=s+24|0;H=s+32|0;r=s+40|0;G=s+48|0;n=s+56|0;J=s+64|0;I=s+72|0;Q=s+80|0;R=F;S=F+8|0;M=O+-3.162277660168379e-8;L=P+3.162277660168379e-8;K=N;T=0;while(1){pE(E,b,K,e);N=+h[C>>3];V=+h[B>>3];W=+h[A>>3];X=+h[z>>3];Y=+h[y>>3];Z=+h[x>>3];_=+h[w>>3];$=+h[v>>3];aa=+h[u>>3];ba=+h[p>>3];h[q>>3]=+h[D>>3];h[l>>3]=N;h[t>>3]=V;h[m>>3]=W;h[H>>3]=X;h[r>>3]=Y;h[G>>3]=Z;h[n>>3]=_;h[J>>3]=$;h[I>>3]=aa;h[Q>>3]=ba;ca=k+0|0;da=s+0|0;ea=ca+88|0;do{c[ca>>2]=c[da>>2];ca=ca+4|0;da=da+4|0}while((ca|0)<(ea|0));bE(F,0,k);ba=+h[R>>3]-d;fa=!(+U(+(ba/d))<=f);ga=K-ba*(1.0/+h[S>>3]);do{if(ga>P&ga<O){ha=ga}else{if(ga>O){ha=M;break}ha=L}}while(0);da=T+1|0;if((da|0)<50&fa){K=ha;T=da}else{break}}T=fa&1;if(!fa){ia=a;ja=ia;h[ja>>3]=ga;ka=a;la=ka+8|0;ma=la;c[ma>>2]=T;i=g;return}fa=c[72300]|0;S=j;R=24264;c[S+0>>2]=c[R+0>>2];c[S+4>>2]=c[R+4>>2];c[S+8>>2]=c[R+8>>2];c[S+12>>2]=c[R+12>>2];c[S+16>>2]=c[R+16>>2];c[S+20>>2]=c[R+20>>2];Pe[fa&127](b,j,24288,o);ia=a;ja=ia;h[ja>>3]=ga;ka=a;la=ka+8|0;ma=la;c[ma>>2]=T;i=g;return}function gE(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0;b=i;i=i+8|0;e=b;f=i;i=i+16|0;c[e>>2]=5;eYa(f,1,e);h[a>>3]=((d*.0010192970039326+-1.1671859879975)*d+348.05185628969)*1.0e6;i=b;return}function hE(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0,t=0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;k=i;i=i+16|0;c[j>>2]=5;eYa(k,1,j);j=k;k=26096;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];l=d/1.0e6;if(d>611.657){m=l/.0010192970039326;n=m+-13655.33276873084;o=+V(+n);p=o+572.54459862746;q=a;r=q;h[r>>3]=p;i=e;return}k=RXa(RXa(26112,PXa(d,0,1,6)|0)|0,24408)|0;j=RXa(RXa(k,PXa(611.657,0,1,6)|0)|0,24416)|0;k=c[72300]|0;s=f;t=26184;c[s+0>>2]=c[t+0>>2];c[s+4>>2]=c[t+4>>2];c[s+8>>2]=c[t+8>>2];c[s+12>>2]=c[t+12>>2];c[s+16>>2]=c[t+16>>2];c[s+20>>2]=c[t+20>>2];Pe[k&127](b,f,j,g);m=l/.0010192970039326;n=m+-13655.33276873084;o=+V(+n);p=o+572.54459862746;q=a;r=q;h[r>>3]=p;i=e;return}function iE(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0;b=i;i=i+8|0;e=b;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+16|0;c[r>>2]=3;eYa(s,1,r);t=d*-6.04960677555959e-8+7.1;c[q>>2]=1;h[(jYa(s,1,q)|0)>>3]=t*t;c[p>>2]=1;d=+h[(jYa(s,1,p)|0)>>3];c[o>>2]=2;h[(jYa(s,1,o)|0)>>3]=d*d;c[n>>2]=2;d=+h[(jYa(s,1,n)|0)>>3];c[m>>2]=3;h[(jYa(s,1,m)|0)>>3]=d*d;c[l>>2]=1;d=+h[(jYa(s,1,l)|0)>>3];c[k>>2]=2;u=+h[(jYa(s,1,k)|0)>>3];c[j>>2]=3;v=+h[(jYa(s,1,j)|0)>>3];c[g>>2]=1;w=+h[(jYa(s,1,g)|0)>>3];c[f>>2]=1;x=+h[(jYa(s,1,f)|0)>>3];c[e>>2]=2;h[a>>3]=57.4756752485113/(t*(t*(t*(t*(d*t*(u*v*t*(w*(x*(t*(t*(t*2.73712834080283e-24+-5.17859076694812e-23)+3.29199117056433e-22)+-7.02987180039442e-22)*+h[(jYa(s,1,e)|0)>>3]+-3.11228834832975e-19)+1.35549330686006e-17)+1.13217858826367e-8)+199080616601101.0e-20)+114683182476084.0e-19)+.000102697173772229)+.00145092247736023)+.0737412153522555);i=b;return}function jE(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0.0,ib=0.0,jb=0.0;b=i;i=i+8|0;e=b;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+16|0;c[Ka>>2]=13;eYa(La,1,Ka);Ma=d/1.0e6;Na=+V(+(Ma+-13.91883977887));c[Ja>>2]=1;h[(jYa(La,1,Ja)|0)>>3]=Na;c[Ia>>2]=1;Oa=540.0/(+h[(jYa(La,1,Ia)|0)>>3]*31.3220101646784+572.54459862746)+-.5;c[Ha>>2]=2;h[(jYa(La,1,Ha)|0)>>3]=Oa*Oa;c[Ga>>2]=2;Pa=Oa*+h[(jYa(La,1,Ga)|0)>>3];c[Fa>>2]=3;h[(jYa(La,1,Fa)|0)>>3]=Pa;c[Ea>>2]=2;Pa=+h[(jYa(La,1,Ea)|0)>>3];c[Da>>2]=4;h[(jYa(La,1,Da)|0)>>3]=Pa*Pa;c[Ca>>2]=4;Pa=+h[(jYa(La,1,Ca)|0)>>3];c[Ba>>2]=5;h[(jYa(La,1,Ba)|0)>>3]=Pa*Pa;c[Aa>>2]=5;Pa=+h[(jYa(La,1,Aa)|0)>>3];c[za>>2]=6;h[(jYa(La,1,za)|0)>>3]=Pa*Pa;c[ya>>2]=4;Pa=+h[(jYa(La,1,ya)|0)>>3];c[xa>>2]=5;Qa=+h[(jYa(La,1,xa)|0)>>3];c[wa>>2]=6;Ra=Pa*Qa*Oa*+h[(jYa(La,1,wa)|0)>>3];c[va>>2]=7;h[(jYa(La,1,va)|0)>>3]=Ra;c[ua>>2]=4;Ra=+h[(jYa(La,1,ua)|0)>>3];c[ta>>2]=5;Qa=Ra*Oa*+h[(jYa(La,1,ta)|0)>>3];c[sa>>2]=8;h[(jYa(La,1,sa)|0)>>3]=Qa;c[ra>>2]=2;Qa=+h[(jYa(La,1,ra)|0)>>3];c[qa>>2]=4;Ra=+h[(jYa(La,1,qa)|0)>>3];c[pa>>2]=5;Pa=Qa*Ra*+h[(jYa(La,1,pa)|0)>>3];c[oa>>2]=9;h[(jYa(La,1,oa)|0)>>3]=Pa;c[na>>2]=10;h[(jYa(La,1,na)|0)>>3]=Ma*Ma;c[ma>>2]=10;Pa=+h[(jYa(La,1,ma)|0)>>3];c[la>>2]=11;h[(jYa(La,1,la)|0)>>3]=Pa*Pa;c[ka>>2]=4;Pa=+h[(jYa(La,1,ka)|0)>>3];c[ja>>2]=6;Ra=Pa*Oa*+h[(jYa(La,1,ja)|0)>>3];c[ia>>2]=12;h[(jYa(La,1,ia)|0)>>3]=Ra;c[ha>>2]=6;Ra=+h[(jYa(La,1,ha)|0)>>3];c[ga>>2]=13;h[(jYa(La,1,ga)|0)>>3]=Ra*Ra;c[fa>>2]=3;Ra=Oa*(Oa*(Oa*(+h[(jYa(La,1,fa)|0)>>3]*-.05032527872793+-.057581259083432)+-.045996013696365)+-.017834862292358);c[ea>>2]=2;Pa=+h[(jYa(La,1,ea)|0)>>3];c[da>>2]=3;Qa=+h[(jYa(La,1,da)|0)>>3];c[ca>>2]=7;Sa=Oa*(Oa*(Pa*(Qa*(+h[(jYa(La,1,ca)|0)>>3]*-53349095828174.0e-18+-.087594591301146)+-.007878555448671)+-.0003789797503263)+-66065283340406.0e-18);c[ba>>2]=2;Qa=+h[(jYa(La,1,ba)|0)>>3];c[aa>>2]=3;Pa=+h[(jYa(La,1,aa)|0)>>3];c[$>>2]=7;Ta=Oa*(Qa*(Pa*(+h[(jYa(La,1,$)|0)>>3]*-.122004760687947+-.0045101773626444)+-9683303171571.0e-17)+131612001853305.0e-20);c[_>>2]=2;Pa=+h[(jYa(La,1,_)|0)>>3];c[Z>>2]=4;Qa=Pa*Oa*+h[(jYa(La,1,Z)|0)>>3]*114610381688305.0e-19;c[Y>>2]=3;Pa=+h[(jYa(La,1,Y)|0)>>3];c[X>>2]=8;Ua=+h[(jYa(La,1,X)|0)>>3];c[W>>2]=2;Va=+h[(jYa(La,1,W)|0)>>3];c[U>>2]=6;Wa=Pa*(Ua*(Va*Oa*+h[(jYa(La,1,U)|0)>>3]*-143.374451604624+-.012702883392813)+-1.00288598706366e-10);c[T>>2]=2;Va=+h[(jYa(La,1,T)|0)>>3];c[S>>2]=5;Ua=+h[(jYa(La,1,S)|0)>>3];c[R>>2]=9;Pa=Va*Ua*Oa*(+h[(jYa(La,1,R)|0)>>3]*-.272627897050173+-88352662293707.0e-19);c[Q>>2]=5;Ua=+h[(jYa(La,1,Q)|0)>>3];c[P>>2]=4;Va=+h[(jYa(La,1,P)|0)>>3];c[O>>2]=5;Xa=+h[(jYa(La,1,O)|0)>>3];c[N>>2]=6;Ya=Ua*(Va*Xa*+h[(jYa(La,1,N)|0)>>3]*-65.8490727183984+9.0049690883672e-11);c[M>>2]=8;Xa=+h[(jYa(La,1,M)|0)>>3]*1.78287415218792e-7;c[L>>2]=4;Va=+h[(jYa(La,1,L)|0)>>3];c[K>>2]=2;Ua=+h[(jYa(La,1,K)|0)>>3];c[J>>2]=4;Za=+h[(jYa(La,1,J)|0)>>3]*-1.0018179379511e-8+-1.0234747095929e-12;c[I>>2]=4;_a=Va*(Ua*Za*+h[(jYa(La,1,I)|0)>>3]+1.0406965210174e-18);c[H>>2]=10;Za=+h[(jYa(La,1,H)|0)>>3];c[G>>2]=11;Ua=+h[(jYa(La,1,G)|0)>>3];c[F>>2]=12;Va=+h[(jYa(La,1,F)|0)>>3]*1.71088510070544+-1.29412653835176e-9;c[E>>2]=7;$a=Va*+h[(jYa(La,1,E)|0)>>3];c[D>>2]=10;Va=+h[(jYa(La,1,D)|0)>>3];c[C>>2]=13;ab=+h[(jYa(La,1,C)|0)>>3];c[B>>2]=5;bb=+h[(jYa(La,1,B)|0)>>3];c[A>>2]=6;cb=ab*bb*Oa*+h[(jYa(La,1,A)|0)>>3]*-6.05920510335078;c[z>>2]=10;bb=+h[(jYa(La,1,z)|0)>>3];c[y>>2]=4;ab=+h[(jYa(La,1,y)|0)>>3];c[x>>2]=6;db=+h[(jYa(La,1,x)|0)>>3];c[w>>2]=2;eb=+h[(jYa(La,1,w)|0)>>3];c[v>>2]=4;fb=+h[(jYa(La,1,v)|0)>>3];c[u>>2]=5;gb=+h[(jYa(La,1,u)|0)>>3];c[t>>2]=8;hb=ab*db*(eb*fb*gb*Oa*(+h[(jYa(La,1,t)|0)>>3]*-84004935396416.0e-18+6.1258633752464e-12)+1.78371690710842e-23);c[s>>2]=12;gb=+h[(jYa(La,1,s)|0)>>3]*-1.24017662339842e-24;c[r>>2]=13;fb=+h[(jYa(La,1,r)|0)>>3];c[q>>2]=4;eb=+h[(jYa(La,1,q)|0)>>3];c[p>>2]=6;db=fb*eb*Oa*+h[(jYa(La,1,p)|0)>>3]*832192847496054.0e-19;c[o>>2]=2;eb=+h[(jYa(La,1,o)|0)>>3];c[n>>2]=5;fb=+h[(jYa(La,1,n)|0)>>3];c[m>>2]=6;ab=+h[(jYa(La,1,m)|0)>>3];c[l>>2]=2;ib=+h[(jYa(La,1,l)|0)>>3];c[k>>2]=6;jb=ib*+h[(jYa(La,1,k)|0)>>3]*-226487297378904.0e-19+1.32995316841867e-15;c[j>>2]=9;ib=eb*fb*ab*Ma*(+h[(jYa(La,1,j)|0)>>3]*jb+1.75410265428146e-27);c[g>>2]=13;jb=+h[(jYa(La,1,g)|0)>>3];c[f>>2]=2;ab=+h[(jYa(La,1,f)|0)>>3];c[e>>2]=4;h[a>>3]=d/((Na*31.3220101646784+572.54459862746)*Ma*((Ma*(Ra+Ma*(Sa+Ma*(Ta+Ma*(Oa*(Oa*(Oa*192901490874028.0e-20+5.116287140914e-8)+-3.15389238237468e-9)+Ma*(Qa+Ma*(Wa+Ma*(Pa+Ma*(Ya+Ma*(Xa+Ma*(_a+Za*Ua*($a+Va*(cb+bb*(hb+Ma*(gb+Ma*(db+Ma*(ib+jb*ab*Oa*+h[(jYa(La,1,e)|0)>>3]*-2.93678005497663e-14)))))))))+-4.1341695026989e-17))))+6.1445213076927e-8))+-.0017731742473213)+1.0)/Ma)*461.526);i=b;return}function kE(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0.0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+16|0;c[ha>>2]=20;eYa(ia,1,ha);if(!(d>611.657)){ha=RXa(RXa(24344,PXa(d,0,1,6)|0)|0,24408)|0;ja=RXa(RXa(ha,PXa(611.657,0,1,6)|0)|0,24416)|0;ha=c[72300]|0;ka=f;la=24448;c[ka+0>>2]=c[la+0>>2];c[ka+4>>2]=c[la+4>>2];c[ka+8>>2]=c[la+8>>2];c[ka+12>>2]=c[la+12>>2];c[ka+16>>2]=c[la+16>>2];c[ka+20>>2]=c[la+20>>2];Pe[ha&127](b,f,ja,ga);}ma=+zd(+d,22064.0e3)*1.0e-6;d=+W(+ma,.25);c[fa>>2]=1;h[(jYa(ia,1,fa)|0)>>3]=d;c[ea>>2]=1;d=+h[(jYa(ia,1,ea)|0)>>3]*-3232555.0322333;c[da>>2]=2;h[(jYa(ia,1,da)|0)>>3]=d;d=+V(+ma);c[ca>>2]=3;h[(jYa(ia,1,ca)|0)>>3]=d;c[ba>>2]=3;d=+h[(jYa(ia,1,ba)|0)>>3]*-724213.16703206;c[aa>>2]=4;h[(jYa(ia,1,aa)|0)>>3]=d;c[$>>2]=2;d=+h[(jYa(ia,1,$)|0)>>3];c[_>>2]=4;ma=d+ +h[(jYa(ia,1,_)|0)>>3]+405113.40542057;c[Z>>2]=5;h[(jYa(ia,1,Z)|0)>>3]=ma;c[Y>>2]=1;ma=+h[(jYa(ia,1,Y)|0)>>3]*-17.073846940092;c[X>>2]=6;h[(jYa(ia,1,X)|0)>>3]=ma;c[U>>2]=3;ma=+h[(jYa(ia,1,U)|0)>>3];c[T>>2]=6;d=ma+ +h[(jYa(ia,1,T)|0)>>3]+14.91510861353;c[S>>2]=7;h[(jYa(ia,1,S)|0)>>3]=d;c[R>>2]=5;d=+h[(jYa(ia,1,R)|0)>>3];c[Q>>2]=7;ma=d*+h[(jYa(ia,1,Q)|0)>>3]*-4.0;c[P>>2]=8;h[(jYa(ia,1,P)|0)>>3]=ma;c[O>>2]=1;ma=+h[(jYa(ia,1,O)|0)>>3]*12020.82470247;c[N>>2]=9;h[(jYa(ia,1,N)|0)>>3]=ma;c[M>>2]=3;ma=+h[(jYa(ia,1,M)|0)>>3]*1167.0521452767;c[L>>2]=10;h[(jYa(ia,1,L)|0)>>3]=ma;c[K>>2]=10;ma=+h[(jYa(ia,1,K)|0)>>3];c[J>>2]=9;d=ma+ +h[(jYa(ia,1,J)|0)>>3]+-4823.2657361591;c[I>>2]=11;h[(jYa(ia,1,I)|0)>>3]=d;c[H>>2]=11;d=+h[(jYa(ia,1,H)|0)>>3];c[G>>2]=12;h[(jYa(ia,1,G)|0)>>3]=d*d;c[F>>2]=12;d=+h[(jYa(ia,1,F)|0)>>3];c[E>>2]=8;ma=d+ +h[(jYa(ia,1,E)|0)>>3];c[D>>2]=13;h[(jYa(ia,1,D)|0)>>3]=ma;c[C>>2]=13;ma=+V(+(+h[(jYa(ia,1,C)|0)>>3]));c[B>>2]=14;h[(jYa(ia,1,B)|0)>>3]=ma;c[A>>2]=14;ma=-+h[(jYa(ia,1,A)|0)>>3];c[z>>2]=15;h[(jYa(ia,1,z)|0)>>3]=ma;c[y>>2]=1;ma=+h[(jYa(ia,1,y)|0)>>3]*-12020.82470247;c[x>>2]=16;h[(jYa(ia,1,x)|0)>>3]=ma;c[w>>2]=3;ma=+h[(jYa(ia,1,w)|0)>>3]*-1167.0521452767;c[v>>2]=17;h[(jYa(ia,1,v)|0)>>3]=ma;c[u>>2]=15;ma=+h[(jYa(ia,1,u)|0)>>3];c[t>>2]=16;d=+h[(jYa(ia,1,t)|0)>>3];c[s>>2]=17;na=ma+(d+ +h[(jYa(ia,1,s)|0)>>3])+4823.2657361591;c[r>>2]=18;h[(jYa(ia,1,r)|0)>>3]=na;c[q>>2]=18;na=1.0/+h[(jYa(ia,1,q)|0)>>3];c[p>>2]=19;h[(jYa(ia,1,p)|0)>>3]=na;c[o>>2]=19;na=+h[(jYa(ia,1,o)|0)>>3];c[n>>2]=5;d=na*+h[(jYa(ia,1,n)|0)>>3]*2.0;c[m>>2]=20;h[(jYa(ia,1,m)|0)>>3]=d;c[l>>2]=20;d=+h[(jYa(ia,1,l)|0)>>3]+650.17534844798;c[k>>2]=20;na=+h[(jYa(ia,1,k)|0)>>3];c[j>>2]=19;ma=+h[(jYa(ia,1,j)|0)>>3];c[g>>2]=5;h[a>>3]=(na- +V(+(d*d+(ma*+h[(jYa(ia,1,g)|0)>>3]*1300.35069689596+-.23855557567849)*-4.0))+650.17534844798)*.5;i=e;return}function lE(a,b,c){a=a|0;b=b|0;c=+c;var d=0.0,e=0,f=0,g=0.0;b=i;if(!(c<22064.0e3)){d=322.0;e=a;f=e;h[f>>3]=d;i=b;return}g=+_(+(c/22064.0e3));d=(g*(g*(g*(g*(g*(g*(g*(g*(g*(g*.00052536560808895+-191.4307733640516)+673.2581177021598)+-994.5385383600702)+796.6627910598293)+-369.3676833623383)+94.34196116778385)+-8.191449323843552)+-2.531486180240112)+1.903224079094824)+1.0)*322.0;e=a;f=e;h[f>>3]=d;i=b;return}function mE(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0,g=0,j=0.0,k=0.0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;xE(e,b,c);j=+h[e>>3];do{if(c<623.15){LE(f,0,j,c);k=+h[f>>3]}else{if(!(c<647.096)){k=322.0;break}lE(g,0,j);k=+h[g>>3]}}while(0);h[a>>3]=k;i=d;return}function nE(a,b,c){a=a|0;b=b|0;c=+c;var d=0.0,e=0,f=0,g=0.0;b=i;if(!(c<22064.0e3)){d=322.0;e=a;f=e;h[f>>3]=d;i=b;return}g=+_(+(c/22064.0e3));d=(g*(g*(g*(g*(g*(g*(g*(g*(g*(g*-.001115111165833234+725.8761975803782)+-2537.375817253895)+3740.579034867006)+-3015.853540307519)+1437.200724533239)+-403.5391431811611)+59.18702203076563)+-1.144787271887849)+-1.84638508033626)+1.0)*322.0;e=a;f=e;h[f>>3]=d;i=b;return}function oE(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0,g=0,j=0.0,k=0.0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;xE(e,b,c);j=+h[e>>3];do{if(c<623.15){$D(f,0,j,c);k=+h[f>>3]}else{if(!(c<647.096)){k=322.0;break}nE(g,0,j);k=+h[g>>3]}}while(0);h[a>>3]=k;i=d;return}function pE(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0.0,qd=0.0,rd=0.0,sd=0.0,td=0.0,ud=0.0,vd=0.0,wd=0.0,xd=0.0,yd=0.0,zd=0.0,Ad=0.0,Bd=0.0,Cd=0.0,Dd=0.0,Ed=0.0;f=i;i=i+32|0;g=f;j=f+24|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+8|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;ob=i;i=i+8|0;pb=i;i=i+8|0;qb=i;i=i+8|0;rb=i;i=i+8|0;sb=i;i=i+8|0;tb=i;i=i+8|0;ub=i;i=i+8|0;vb=i;i=i+8|0;wb=i;i=i+8|0;xb=i;i=i+8|0;yb=i;i=i+8|0;zb=i;i=i+8|0;Ab=i;i=i+8|0;Bb=i;i=i+8|0;Cb=i;i=i+8|0;Db=i;i=i+8|0;Eb=i;i=i+8|0;Fb=i;i=i+8|0;Gb=i;i=i+8|0;Hb=i;i=i+8|0;Ib=i;i=i+8|0;Jb=i;i=i+8|0;Kb=i;i=i+8|0;Lb=i;i=i+8|0;Mb=i;i=i+8|0;Nb=i;i=i+8|0;Ob=i;i=i+8|0;Pb=i;i=i+8|0;Qb=i;i=i+8|0;Rb=i;i=i+8|0;Sb=i;i=i+8|0;Tb=i;i=i+8|0;Ub=i;i=i+8|0;Vb=i;i=i+8|0;Wb=i;i=i+8|0;Xb=i;i=i+8|0;Yb=i;i=i+8|0;Zb=i;i=i+8|0;_b=i;i=i+8|0;$b=i;i=i+8|0;ac=i;i=i+8|0;bc=i;i=i+8|0;cc=i;i=i+8|0;dc=i;i=i+8|0;ec=i;i=i+8|0;fc=i;i=i+8|0;gc=i;i=i+8|0;hc=i;i=i+8|0;ic=i;i=i+8|0;jc=i;i=i+8|0;kc=i;i=i+8|0;lc=i;i=i+8|0;mc=i;i=i+8|0;nc=i;i=i+8|0;oc=i;i=i+8|0;pc=i;i=i+8|0;qc=i;i=i+8|0;rc=i;i=i+8|0;sc=i;i=i+8|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+8|0;wc=i;i=i+8|0;xc=i;i=i+8|0;yc=i;i=i+8|0;zc=i;i=i+8|0;Ac=i;i=i+8|0;Bc=i;i=i+8|0;Cc=i;i=i+8|0;Dc=i;i=i+8|0;Ec=i;i=i+8|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+8|0;Ic=i;i=i+8|0;Jc=i;i=i+8|0;Kc=i;i=i+8|0;Lc=i;i=i+8|0;Mc=i;i=i+8|0;Nc=i;i=i+8|0;Oc=i;i=i+8|0;Pc=i;i=i+8|0;Qc=i;i=i+8|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+8|0;Uc=i;i=i+8|0;Vc=i;i=i+8|0;Wc=i;i=i+8|0;Xc=i;i=i+8|0;Yc=i;i=i+8|0;Zc=i;i=i+8|0;_c=i;i=i+8|0;$c=i;i=i+8|0;ad=i;i=i+8|0;bd=i;i=i+8|0;cd=i;i=i+8|0;dd=i;i=i+8|0;ed=i;i=i+8|0;fd=i;i=i+8|0;gd=i;i=i+8|0;hd=i;i=i+8|0;id=i;i=i+8|0;jd=i;i=i+8|0;kd=i;i=i+8|0;ld=i;i=i+8|0;md=i;i=i+8|0;nd=i;i=i+8|0;od=i;i=i+16|0;c[nd>>2]=40;eYa(od,1,nd);pd=647.096/e;if(d==322.0&e==647.096){qd=.999999999999999}else{qd=+U(+(d/322.0))}c[md>>2]=1;h[(jYa(od,1,md)|0)>>3]=pd*pd;c[ld>>2]=1;rd=+h[(jYa(od,1,ld)|0)>>3];c[kd>>2]=2;h[(jYa(od,1,kd)|0)>>3]=rd*rd;c[jd>>2]=2;rd=pd*+h[(jYa(od,1,jd)|0)>>3];c[id>>2]=3;h[(jYa(od,1,id)|0)>>3]=rd;c[hd>>2]=1;rd=pd*+h[(jYa(od,1,hd)|0)>>3];c[gd>>2]=4;h[(jYa(od,1,gd)|0)>>3]=rd;c[fd>>2]=2;rd=+h[(jYa(od,1,fd)|0)>>3];c[ed>>2]=5;h[(jYa(od,1,ed)|0)>>3]=rd*rd;c[dd>>2]=1;rd=+h[(jYa(od,1,dd)|0)>>3];c[cd>>2]=5;sd=rd*pd*+h[(jYa(od,1,cd)|0)>>3];c[bd>>2]=6;h[(jYa(od,1,bd)|0)>>3]=sd;c[ad>>2]=5;sd=pd*+h[(jYa(od,1,ad)|0)>>3];c[$c>>2]=7;h[(jYa(od,1,$c)|0)>>3]=sd;c[_c>>2]=1;sd=+h[(jYa(od,1,_c)|0)>>3]*-.64207765181607;c[Zc>>2]=8;h[(jYa(od,1,Zc)|0)>>3]=sd;c[Yc>>2]=8;sd=+h[(jYa(od,1,Yc)|0)>>3]+.88521043984318;c[Xc>>2]=9;h[(jYa(od,1,Xc)|0)>>3]=sd;c[Wc>>2]=7;sd=+h[(jYa(od,1,Wc)|0)>>3];c[Vc>>2]=9;rd=sd*+h[(jYa(od,1,Vc)|0)>>3];c[Uc>>2]=10;h[(jYa(od,1,Uc)|0)>>3]=rd;c[Tc>>2]=10;rd=+h[(jYa(od,1,Tc)|0)>>3]+-1.1524407806681;c[Sc>>2]=11;h[(jYa(od,1,Sc)|0)>>3]=rd;c[Rc>>2]=11;rd=+h[(jYa(od,1,Rc)|0)>>3];c[Qc>>2]=2;sd=rd*+h[(jYa(od,1,Qc)|0)>>3];c[Pc>>2]=12;h[(jYa(od,1,Pc)|0)>>3]=sd;c[Oc>>2]=12;sd=+h[(jYa(od,1,Oc)|0)>>3]+-1.2654315477714;c[Nc>>2]=13;h[(jYa(od,1,Nc)|0)>>3]=sd;c[Mc>>2]=1;sd=+h[(jYa(od,1,Mc)|0)>>3];c[Lc>>2]=13;rd=sd*+h[(jYa(od,1,Lc)|0)>>3];c[Kc>>2]=14;h[(jYa(od,1,Kc)|0)>>3]=rd;c[Jc>>2]=1;rd=+h[(jYa(od,1,Jc)|0)>>3];c[Ic>>2]=2;sd=+h[(jYa(od,1,Ic)|0)>>3];c[Hc>>2]=5;td=rd*sd*pd*+h[(jYa(od,1,Hc)|0)>>3];c[Gc>>2]=15;h[(jYa(od,1,Gc)|0)>>3]=td;c[Fc>>2]=2;td=+h[(jYa(od,1,Fc)|0)>>3];c[Ec>>2]=5;sd=td*+h[(jYa(od,1,Ec)|0)>>3];c[Dc>>2]=16;h[(jYa(od,1,Dc)|0)>>3]=sd;c[Cc>>2]=1;sd=+h[(jYa(od,1,Cc)|0)>>3];c[Bc>>2]=5;td=sd*+h[(jYa(od,1,Bc)|0)>>3];c[Ac>>2]=17;h[(jYa(od,1,Ac)|0)>>3]=td;c[zc>>2]=5;td=+h[(jYa(od,1,zc)|0)>>3];c[yc>>2]=18;h[(jYa(od,1,yc)|0)>>3]=td*td;c[xc>>2]=1;td=+h[(jYa(od,1,xc)|0)>>3];c[wc>>2]=18;sd=+h[(jYa(od,1,wc)|0)>>3];c[vc>>2]=2;rd=td*sd*+h[(jYa(od,1,vc)|0)>>3];c[uc>>2]=19;h[(jYa(od,1,uc)|0)>>3]=rd;c[tc>>2]=1;rd=+h[(jYa(od,1,tc)|0)>>3];c[sc>>2]=18;sd=+h[(jYa(od,1,sc)|0)>>3];c[rc>>2]=2;td=rd*sd*pd*+h[(jYa(od,1,rc)|0)>>3];c[qc>>2]=20;h[(jYa(od,1,qc)|0)>>3]=td;c[pc>>2]=18;td=+h[(jYa(od,1,pc)|0)>>3];c[oc>>2]=5;sd=td*+h[(jYa(od,1,oc)|0)>>3];c[nc>>2]=21;h[(jYa(od,1,nc)|0)>>3]=sd;c[mc>>2]=1;sd=+h[(jYa(od,1,mc)|0)>>3];c[lc>>2]=18;td=+h[(jYa(od,1,lc)|0)>>3];c[kc>>2]=5;rd=sd*td*+h[(jYa(od,1,kc)|0)>>3];c[jc>>2]=22;h[(jYa(od,1,jc)|0)>>3]=rd;c[ic>>2]=2;rd=+h[(jYa(od,1,ic)|0)>>3]*.25116816848616;c[hc>>2]=23;h[(jYa(od,1,hc)|0)>>3]=rd;c[gc>>2]=23;rd=+h[(jYa(od,1,gc)|0)>>3]+.078841073758308;c[fc>>2]=24;h[(jYa(od,1,fc)|0)>>3]=rd;c[ec>>2]=15;rd=+h[(jYa(od,1,ec)|0)>>3];c[dc>>2]=24;td=rd*+h[(jYa(od,1,dc)|0)>>3];c[cc>>2]=25;h[(jYa(od,1,cc)|0)>>3]=td;c[bc>>2]=25;td=+h[(jYa(od,1,bc)|0)>>3]+-6.100523451393;c[ac>>2]=26;h[(jYa(od,1,ac)|0)>>3]=td;c[$b>>2]=26;td=pd*+h[(jYa(od,1,$b)|0)>>3];c[_b>>2]=27;h[(jYa(od,1,_b)|0)>>3]=td;c[Zb>>2]=27;td=+h[(jYa(od,1,Zb)|0)>>3]+9.7944563083754;c[Yb>>2]=28;h[(jYa(od,1,Yb)|0)>>3]=td;c[Xb>>2]=2;td=+h[(jYa(od,1,Xb)|0)>>3];c[Wb>>2]=28;rd=td*+h[(jYa(od,1,Wb)|0)>>3];c[Vb>>2]=29;h[(jYa(od,1,Vb)|0)>>3]=rd;c[Ub>>2]=29;rd=+h[(jYa(od,1,Ub)|0)>>3]+-1.70429417648412;c[Tb>>2]=30;h[(jYa(od,1,Tb)|0)>>3]=rd;c[Sb>>2]=1;rd=+h[(jYa(od,1,Sb)|0)>>3];c[Rb>>2]=30;td=rd*+h[(jYa(od,1,Rb)|0)>>3];c[Qb>>2]=31;h[(jYa(od,1,Qb)|0)>>3]=td;c[Pb>>2]=32;h[(jYa(od,1,Pb)|0)>>3]=qd*qd;c[Ob>>2]=1;td=+h[(jYa(od,1,Ob)|0)>>3]*-10.9153200808732;c[Nb>>2]=33;h[(jYa(od,1,Nb)|0)>>3]=td;c[Mb>>2]=33;td=+h[(jYa(od,1,Mb)|0)>>3]+13.2781565976477;c[Lb>>2]=34;h[(jYa(od,1,Lb)|0)>>3]=td;c[Kb>>2]=34;td=+h[(jYa(od,1,Kb)|0)>>3];c[Jb>>2]=7;rd=td*+h[(jYa(od,1,Jb)|0)>>3];c[Ib>>2]=35;h[(jYa(od,1,Ib)|0)>>3]=rd;c[Hb>>2]=35;rd=+h[(jYa(od,1,Hb)|0)>>3]+-6.9146446840086;c[Gb>>2]=36;h[(jYa(od,1,Gb)|0)>>3]=rd;c[Fb>>2]=2;rd=+h[(jYa(od,1,Fb)|0)>>3];c[Eb>>2]=36;td=rd*+h[(jYa(od,1,Eb)|0)>>3];c[Db>>2]=37;h[(jYa(od,1,Db)|0)>>3]=td;c[Cb>>2]=37;td=+h[(jYa(od,1,Cb)|0)>>3]+-2.5308630955428;c[Bb>>2]=38;h[(jYa(od,1,Bb)|0)>>3]=td;c[Ab>>2]=38;td=pd*+h[(jYa(od,1,Ab)|0)>>3];c[zb>>2]=39;h[(jYa(od,1,zb)|0)>>3]=td;c[yb>>2]=18;td=+h[(jYa(od,1,yb)|0)>>3];c[xb>>2]=5;rd=td*pd*+h[(jYa(od,1,xb)|0)>>3];c[wb>>2]=40;h[(jYa(od,1,wb)|0)>>3]=rd;if(!(qd>0.0)){wb=c[72300]|0;xb=vb;h[k>>3]=qd;c[xb>>2]=c[k>>2];c[xb+4>>2]=c[k+4>>2];xb=wb;wb=g;yb=25752;c[wb+0>>2]=c[yb+0>>2];c[wb+4>>2]=c[yb+4>>2];c[wb+8>>2]=c[yb+8>>2];c[wb+12>>2]=c[yb+12>>2];c[wb+16>>2]=c[yb+16>>2];c[wb+20>>2]=c[yb+20>>2];Pe[xb&127](b,g,25168,vb);}c[ub>>2]=3;rd=+h[(jYa(od,1,ub)|0)>>3];c[tb>>2]=4;td=+h[(jYa(od,1,tb)|0)>>3];c[sb>>2]=1;sd=+h[(jYa(od,1,sb)|0)>>3];c[rb>>2]=6;ud=pd*(pd*(rd*(td*(sd*(+h[(jYa(od,1,rb)|0)>>3]*-.0084566812812502+1.2053369696517)+-2.808078114862)+2.6185947787954)+-7.6867707878716)+20.944396974307);c[qb>>2]=14;sd=+h[(jYa(od,1,qb)|0)>>3];c[pb>>2]=1;td=+h[(jYa(od,1,pb)|0)>>3];c[ob>>2]=2;rd=+h[(jYa(od,1,ob)|0)>>3];c[nb>>2]=15;vd=+h[(jYa(od,1,nb)|0)>>3];c[mb>>2]=2;wd=td*(rd*(pd*(vd*(+h[(jYa(od,1,mb)|0)>>3]*.12558408424308+.039420536879154)+-3.0502617256965)+4.8972281541877)+-.85214708824206);c[lb>>2]=1;vd=+h[(jYa(od,1,lb)|0)>>3];c[kb>>2]=1;rd=+h[(jYa(od,1,kb)|0)>>3];c[jb>>2]=16;td=+h[(jYa(od,1,jb)|0)>>3];c[ib>>2]=17;xd=vd*(rd*(td*(+h[(jYa(od,1,ib)|0)>>3]*-.47596035734923+-.0082147637173963)+-2.018991502357)+1.389979956946);c[hb>>2]=1;td=+h[(jYa(od,1,hb)|0)>>3];c[gb>>2]=1;rd=+h[(jYa(od,1,gb)|0)>>3];c[fb>>2]=19;vd=td*(rd*(+h[(jYa(od,1,fb)|0)>>3]*.70522450087967+.90572070719733)+-.44476435428739);c[eb>>2]=1;rd=+h[(jYa(od,1,eb)|0)>>3];c[db>>2]=21;td=rd*(+h[(jYa(od,1,db)|0)>>3]*.16436278447961+.094260751665092);c[cb>>2]=1;rd=+h[(jYa(od,1,cb)|0)>>3]*-.013503372241348;c[bb>>2]=22;yd=+h[(jYa(od,1,bb)|0)>>3]*-.014834345352472;c[ab>>2]=1;zd=+h[(jYa(od,1,ab)|0)>>3];c[$a>>2]=21;Ad=zd*(+h[(jYa(od,1,$a)|0)>>3]*.0032308904703711+.00057922953628084);c[_a>>2]=22;zd=qd*(td+qd*(rd+qd*(yd+qd*(Ad+qd*(pd*-.00016557679795037+qd*+h[(jYa(od,1,_a)|0)>>3]*-44923899061815.0e-18+80964802996215.0e-18))))+-.022175400873096);c[Za>>2]=1;Ad=+h[(jYa(od,1,Za)|0)>>3];c[Ya>>2]=20;yd=ud+(+da(+qd)*1.0658070028513+qd*(sd+qd*(wd+qd*(xd+qd*(vd+qd*(pd*(Ad*(+h[(jYa(od,1,Ya)|0)>>3]*-.50871062041158+-.32913623258954)+.10770512626332)+zd)+.0439840744735)+-.2799932969871)+.38493460186671)))+-15.732845290239;c[Xa>>2]=14;zd=+h[(jYa(od,1,Xa)|0)>>3];c[Wa>>2]=31;Ad=+h[(jYa(od,1,Wa)|0)>>3];c[Va>>2]=1;vd=+h[(jYa(od,1,Va)|0)>>3];c[Ua>>2]=1;xd=+h[(jYa(od,1,Ua)|0)>>3];c[Ta>>2]=16;wd=+h[(jYa(od,1,Ta)|0)>>3];c[Sa>>2]=17;sd=vd*(xd*(wd*(+h[(jYa(od,1,Sa)|0)>>3]*-1.42788107204769+-.0246442911521889)+-6.056974507071)+4.169939870838);c[Ra>>2]=1;wd=+h[(jYa(od,1,Ra)|0)>>3];c[Qa>>2]=1;xd=+h[(jYa(od,1,Qa)|0)>>3];c[Pa>>2]=19;vd=wd*(xd*(+h[(jYa(od,1,Pa)|0)>>3]*2.82089800351868+3.6228828287893)+-1.77905741714956);c[Oa>>2]=1;xd=+h[(jYa(od,1,Oa)|0)>>3];c[Na>>2]=21;wd=xd*(+h[(jYa(od,1,Na)|0)>>3]*.98617670687766+.56556450999055);c[Ma>>2]=1;xd=+h[(jYa(od,1,Ma)|0)>>3]*-.094523605689436;c[La>>2]=22;ud=+h[(jYa(od,1,La)|0)>>3]*-.118674762819776;c[Ka>>2]=1;rd=+h[(jYa(od,1,Ka)|0)>>3];c[Ja>>2]=21;td=rd*(+h[(jYa(od,1,Ja)|0)>>3]*.0290780142333399+.0052130658265276);c[Ia>>2]=22;rd=qd*(wd+qd*(xd+qd*(ud+qd*(td+qd*(pd*-.0016557679795037+qd*+h[(jYa(od,1,Ia)|0)>>3]*-.00049416288967996+.00080964802996215))))+-.133052405238576);c[Ha>>2]=1;td=+h[(jYa(od,1,Ha)|0)>>3];c[Ga>>2]=20;ud=(qd*(zd+qd*(Ad+qd*(sd+qd*(vd+qd*(pd*(td*(+h[(jYa(od,1,Ga)|0)>>3]*-2.5435531020579+-1.6456811629477)+.5385256313166)+rd)+.175936297894)+-.8399798909613)+.76986920373342))+1.0658070028513)/qd;c[Fa>>2]=32;rd=+h[(jYa(od,1,Fa)|0)>>3];c[Ea>>2]=31;td=+h[(jYa(od,1,Ea)|0)>>3];c[Da>>2]=1;vd=+h[(jYa(od,1,Da)|0)>>3];c[Ca>>2]=1;sd=+h[(jYa(od,1,Ca)|0)>>3];c[Ba>>2]=16;Ad=+h[(jYa(od,1,Ba)|0)>>3];c[Aa>>2]=17;zd=vd*(sd*(Ad*(+h[(jYa(od,1,Aa)|0)>>3]*-2.85576214409538+-.049288582304378)+-12.113949014142)+8.339879741676);c[za>>2]=1;Ad=+h[(jYa(od,1,za)|0)>>3];c[ya>>2]=1;sd=+h[(jYa(od,1,ya)|0)>>3];c[xa>>2]=19;vd=Ad*(sd*(+h[(jYa(od,1,xa)|0)>>3]*8.462694010556+10.868648486368)+-5.3371722514487);c[wa>>2]=1;sd=+h[(jYa(od,1,wa)|0)>>3];c[va>>2]=21;Ad=sd*(+h[(jYa(od,1,va)|0)>>3]*4.9308835343883+2.82782254995276);c[ua>>2]=1;sd=+h[(jYa(od,1,ua)|0)>>3]*-.56714163413662;c[ta>>2]=22;xd=+h[(jYa(od,1,ta)|0)>>3]*-.83072333973843;c[sa>>2]=1;wd=+h[(jYa(od,1,sa)|0)>>3];c[ra>>2]=21;Bd=wd*(+h[(jYa(od,1,ra)|0)>>3]*.232624113866719+.04170452661222);c[qa>>2]=22;wd=qd*(Ad+qd*(sd+qd*(xd+qd*(Bd+qd*(pd*-.0149019118155333+qd*+h[(jYa(od,1,qa)|0)>>3]*-.0049416288967996+.0072868322696594))))+-.66526202619288);c[pa>>2]=1;Bd=+h[(jYa(od,1,pa)|0)>>3];c[oa>>2]=20;xd=rd*(td+qd*(zd+qd*(vd+qd*(pd*(Bd*(+h[(jYa(od,1,oa)|0)>>3]*-10.1742124082316+-6.5827246517908)+2.1541025252664)+wd)+.527808893682)+-1.6799597819226)+.76986920373342)+-1.0658070028513;c[na>>2]=32;wd=xd/+h[(jYa(od,1,na)|0)>>3];c[ma>>2]=3;xd=+h[(jYa(od,1,ma)|0)>>3];c[la>>2]=4;Bd=+h[(jYa(od,1,la)|0)>>3];c[ka>>2]=1;vd=+h[(jYa(od,1,ka)|0)>>3];c[ja>>2]=6;zd=pd*(xd*(Bd*(vd*(+h[(jYa(od,1,ja)|0)>>3]*-.194503669468755+14.4640436358204)+-28.08078114862)+18.3301634515678)+-15.3735415757432);c[ia>>2]=39;vd=+h[(jYa(od,1,ia)|0)>>3];c[ha>>2]=2;Bd=+h[(jYa(od,1,ha)|0)>>3];c[ga>>2]=15;xd=+h[(jYa(od,1,ga)|0)>>3];c[fa>>2]=2;td=pd*(Bd*(pd*(xd*(+h[(jYa(od,1,fa)|0)>>3]*3.2651861903201+.86725181134139)+-21.3518320798755)+29.3833689251262)+-1.70429417648412);c[ea>>2]=1;xd=+h[(jYa(od,1,ea)|0)>>3];c[ca>>2]=16;Bd=+h[(jYa(od,1,ca)|0)>>3];c[ba>>2]=17;rd=pd*(xd*(Bd*(+h[(jYa(od,1,ba)|0)>>3]*-12.37496929108+-.131436219478341)+-8.075966009428)+2.779959913892);c[aa>>2]=1;Bd=+h[(jYa(od,1,aa)|0)>>3];c[$>>2]=19;xd=pd*(Bd*(+h[(jYa(od,1,$)|0)>>3]*18.3358370228714+3.6228828287893)+-.88952870857478);c[_>>2]=1;Bd=+h[(jYa(od,1,_)|0)>>3];c[Z>>2]=20;sd=Bd*(+h[(jYa(od,1,Z)|0)>>3]*-13.2264761307011+-.98740869776862);c[Y>>2]=21;Bd=pd*(+h[(jYa(od,1,Y)|0)>>3]*4.2734323964699+.188521503330184);c[X>>2]=40;Ad=+h[(jYa(od,1,X)|0)>>3]*-.38569297916427;c[W>>2]=40;Cd=qd*(qd*+h[(jYa(od,1,W)|0)>>3]*-.00116802137560719+-.00016557679795037);c[V>>2]=21;Dd=zd+qd*(vd+qd*(td+qd*(rd+qd*(xd+qd*(sd+qd*(Bd+qd*(pd*-.027006744482696+qd*(Ad+qd*(Cd+pd*(+h[(jYa(od,1,V)|0)>>3]*.084003152229649+.00115845907256168)))))+.10770512626332)))))+20.944396974307;c[T>>2]=3;Cd=+h[(jYa(od,1,T)|0)>>3];c[S>>2]=4;Ad=+h[(jYa(od,1,S)|0)>>3];c[R>>2]=1;Bd=+h[(jYa(od,1,R)|0)>>3];c[Q>>2]=6;sd=Cd*(Ad*(Bd*(+h[(jYa(od,1,Q)|0)>>3]*-4.2790807283126+159.104479994024)+-252.72703033758)+109.980980709407);c[P>>2]=2;Bd=+h[(jYa(od,1,P)|0)>>3];c[O>>2]=1;Ad=+h[(jYa(od,1,O)|0)>>3]*-174.645121293971+185.894192367068;c[N>>2]=7;Cd=Bd*(Ad*+h[(jYa(od,1,N)|0)>>3]+-34.573223420043);c[M>>2]=2;Ad=+h[(jYa(od,1,M)|0)>>3];c[L>>2]=15;Bd=+h[(jYa(od,1,L)|0)>>3];c[K>>2]=2;xd=Ad*(pd*(Bd*(+h[(jYa(od,1,K)|0)>>3]*81.629654758002+18.2122880381691)+-128.110992479253)+146.916844625631);c[J>>2]=1;Bd=+h[(jYa(od,1,J)|0)>>3];c[I>>2]=16;Ad=+h[(jYa(od,1,I)|0)>>3];c[H>>2]=17;rd=Bd*(Ad*(+h[(jYa(od,1,H)|0)>>3]*-309.374232277+-1.97154329217511)+-24.227898028284);c[G>>2]=1;Ad=+h[(jYa(od,1,G)|0)>>3];c[F>>2]=19;Bd=Ad*(+h[(jYa(od,1,F)|0)>>3]*458.39592557179+10.868648486368);c[E>>2]=21;Ad=+h[(jYa(od,1,E)|0)>>3]*106.835809911747;c[D>>2]=21;td=+h[(jYa(od,1,D)|0)>>3]*-9.6423244791068;c[C>>2]=21;vd=+h[(jYa(od,1,C)|0)>>3]*2.10007880574121;c[B>>2]=21;zd=+h[(jYa(od,1,B)|0)>>3];c[A>>2]=32;Ed=qd*(Ad+qd*(qd*(td+qd*(vd+zd*+h[(jYa(od,1,A)|0)>>3]*-.0292005343901797+.00115845907256168))+-.027006744482696)+.188521503330184);c[z>>2]=20;zd=sd+qd*(Cd+qd*(xd+qd*(rd+qd*(Bd+qd*(pd*(+h[(jYa(od,1,z)|0)>>3]*-330.66190326753+-1.97481739553724)+Ed)+-.88952870857478)+2.779959913892)+-1.70429417648412)+-2.5308630955428)+-15.3735415757432;c[y>>2]=39;Ed=+h[(jYa(od,1,y)|0)>>3];c[x>>2]=2;Bd=+h[(jYa(od,1,x)|0)>>3];c[w>>2]=15;rd=+h[(jYa(od,1,w)|0)>>3];c[v>>2]=2;xd=pd*(Bd*(pd*(rd*(+h[(jYa(od,1,v)|0)>>3]*6.5303723806402+1.73450362268278)+-42.703664159751)+58.766737850252)+-3.4085883529682);c[u>>2]=1;rd=+h[(jYa(od,1,u)|0)>>3];c[t>>2]=16;Bd=+h[(jYa(od,1,t)|0)>>3];c[s>>2]=17;Cd=pd*(rd*(Bd*(+h[(jYa(od,1,s)|0)>>3]*-37.12490787324+-.39430865843502)+-24.227898028284)+8.339879741676);c[r>>2]=1;Bd=+h[(jYa(od,1,r)|0)>>3];c[q>>2]=19;rd=pd*(Bd*(+h[(jYa(od,1,q)|0)>>3]*73.343348091486+14.4915313151573)+-3.5581148342991);c[p>>2]=1;Bd=+h[(jYa(od,1,p)|0)>>3];c[o>>2]=20;sd=Bd*(+h[(jYa(od,1,o)|0)>>3]*-66.132380653505+-4.9370434888431);c[n>>2]=21;Bd=pd*(+h[(jYa(od,1,n)|0)>>3]*25.6405943788192+1.1311290199811);c[m>>2]=40;vd=+h[(jYa(od,1,m)|0)>>3]*-3.08554383331418;c[l>>2]=40;td=qd*(qd*+h[(jYa(od,1,l)|0)>>3]*-.0128482351316791+-.0016557679795037);c[j>>2]=21;Ad=Ed+qd*(xd+qd*(Cd+qd*(rd+qd*(sd+qd*(Bd+qd*(pd*-.189047211378872+qd*(vd+qd*(td+pd*(+h[(jYa(od,1,j)|0)>>3]*.75602837006684+.0104261316530551)))))+.5385256313166))));h[a>>3]=d;h[a+8>>3]=e;h[a+16>>3]=461.526;h[a+24>>3]=qd;h[a+32>>3]=pd;h[a+40>>3]=yd;h[a+48>>3]=ud;h[a+56>>3]=wd;h[a+64>>3]=Dd;h[a+72>>3]=zd;h[a+80>>3]=Ad;i=f;return}function qE(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0;f=i;i=i+104|0;g=f;j=f+24|0;l=f+48|0;m=f+72|0;n=f+96|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+16|0;c[ha>>2]=11;eYa(ia,1,ha);if(!(d>0.0)){ha=RXa(RXa(24472,PXa(d,0,1,6)|0)|0,24536)|0;ja=c[72300]|0;ka=m;la=24552;c[ka+0>>2]=c[la+0>>2];c[ka+4>>2]=c[la+4>>2];c[ka+8>>2]=c[la+8>>2];c[ka+12>>2]=c[la+12>>2];c[ka+16>>2]=c[la+16>>2];c[ka+20>>2]=c[la+20>>2];Pe[ja&127](b,m,ha,ga);}if(!(d<=1.0e7)){ga=RXa(RXa(24576,PXa(d,0,1,6)|0)|0,24624)|0;ha=c[72300]|0;m=l;ja=24664;c[m+0>>2]=c[ja+0>>2];c[m+4>>2]=c[ja+4>>2];c[m+8>>2]=c[ja+8>>2];c[m+12>>2]=c[ja+12>>2];c[m+16>>2]=c[ja+16>>2];c[m+20>>2]=c[ja+20>>2];Pe[ha&127](b,l,ga,fa);}if(!(e<=2273.15)){fa=RXa(RXa(24688,PXa(e,0,1,6)|0)|0,24736)|0;ga=c[72300]|0;l=j;ha=24792;c[l+0>>2]=c[ha+0>>2];c[l+4>>2]=c[ha+4>>2];c[l+8>>2]=c[ha+8>>2];c[l+12>>2]=c[ha+12>>2];c[l+16>>2]=c[ha+16>>2];c[l+20>>2]=c[ha+20>>2];Pe[ga&127](b,j,fa,ea);}ma=d/1.0e6;na=1.0e3/e;c[ca>>2]=1;h[(jYa(ia,1,ca)|0)>>3]=na*na;c[ba>>2]=1;oa=+h[(jYa(ia,1,ba)|0)>>3]*-.004594282089991;c[aa>>2]=2;h[(jYa(ia,1,aa)|0)>>3]=oa;c[$>>2]=2;oa=+h[(jYa(ia,1,$)|0)>>3]+.0021774678714571;c[_>>2]=3;h[(jYa(ia,1,_)|0)>>3]=oa;c[Z>>2]=3;oa=na*+h[(jYa(ia,1,Z)|0)>>3];c[Y>>2]=4;h[(jYa(ia,1,Y)|0)>>3]=oa;c[X>>2]=1;oa=na*+h[(jYa(ia,1,X)|0)>>3];c[W>>2]=5;h[(jYa(ia,1,W)|0)>>3]=oa;c[V>>2]=1;oa=+h[(jYa(ia,1,V)|0)>>3];c[U>>2]=6;h[(jYa(ia,1,U)|0)>>3]=oa*oa;c[T>>2]=6;oa=+h[(jYa(ia,1,T)|0)>>3];c[S>>2]=7;h[(jYa(ia,1,S)|0)>>3]=oa*oa;c[R>>2]=7;oa=na*+h[(jYa(ia,1,R)|0)>>3];c[Q>>2]=8;h[(jYa(ia,1,Q)|0)>>3]=oa;c[P>>2]=8;oa=+h[(jYa(ia,1,P)|0)>>3]*-79449656719138.0e-19;c[O>>2]=9;h[(jYa(ia,1,O)|0)>>3]=oa;c[N>>2]=10;h[(jYa(ia,1,N)|0)>>3]=ma*ma;c[M>>2]=1;oa=+h[(jYa(ia,1,M)|0)>>3]*-.013782846269973;c[L>>2]=11;h[(jYa(ia,1,L)|0)>>3]=oa;if(!(ma>0.0)){L=c[72300]|0;M=K;h[k>>3]=ma;c[M>>2]=c[k>>2];c[M+4>>2]=c[k+4>>2];M=L;L=g;N=25752;c[L+0>>2]=c[N+0>>2];c[L+4>>2]=c[N+4>>2];c[L+8>>2]=c[N+8>>2];c[L+12>>2]=c[N+12>>2];c[L+16>>2]=c[N+16>>2];c[L+20>>2]=c[N+20>>2];Pe[M&127](b,g,24816,K);}c[J>>2]=4;oa=+h[(jYa(ia,1,J)|0)>>3];c[I>>2]=8;pa=+h[(jYa(ia,1,I)|0)>>3]*-39724828359569.0e-19;c[H>>2]=5;qa=ma*(oa+ma*(pa+ma*+h[(jYa(ia,1,H)|0)>>3]*1.2919228289784e-7)+-.00012563183589592);pa=na*(na*(na*(na*(na*-.32961626538917+6.8540841634434)+ +da(+ma)+-13.179983674201)+-3.1161318213925)+.36901534980333)+-.024805148933466;c[G>>2]=5;oa=pa/+h[(jYa(ia,1,G)|0)>>3]+qa;c[F>>2]=4;qa=+h[(jYa(ia,1,F)|0)>>3];c[E>>2]=9;pa=+h[(jYa(ia,1,E)|0)>>3];c[D>>2]=5;ra=(ma*(qa+ma*(pa+ma*+h[(jYa(ia,1,D)|0)>>3]*3.8757684869352e-7)+-.00012563183589592)+1.0)/ma;c[C>>2]=10;pa=+h[(jYa(ia,1,C)|0)>>3];c[B>>2]=9;qa=+h[(jYa(ia,1,B)|0)>>3];c[A>>2]=5;sa=pa*(qa+ma*+h[(jYa(ia,1,A)|0)>>3]*7.7515369738704e-7)+-1.0;c[z>>2]=10;qa=sa/+h[(jYa(ia,1,z)|0)>>3];c[y>>2]=11;sa=+h[(jYa(ia,1,y)|0)>>3];c[x>>2]=7;pa=+h[(jYa(ia,1,x)|0)>>3]*-35752345523612.0e-18;c[w>>2]=1;ta=ma*(sa+ma*(pa+ma*+h[(jYa(ia,1,w)|0)>>3]*3.8757684869352e-7)+.0021774678714571);c[v>>2]=1;pa=na*(na*((na*-.65923253077834+6.8540841634434)*+h[(jYa(ia,1,v)|0)>>3]+3.1161318213925)+-.73803069960666)+.074415446800398;c[u>>2]=6;sa=pa/+h[(jYa(ia,1,u)|0)>>3]+ta;c[t>>2]=5;ta=na*(na*(+h[(jYa(ia,1,t)|0)>>3]*-.65923253077834+-6.232263642785)+2.21409209881998)+-.297661787201592;c[s>>2]=6;pa=ta/(na*+h[(jYa(ia,1,s)|0)>>3]);c[r>>2]=1;ta=+h[(jYa(ia,1,r)|0)>>3];c[q>>2]=6;ua=pa+ma*(na*-.027565692539946+ma*(ma*na*7.7515369738704e-7+ta*na*+h[(jYa(ia,1,q)|0)>>3]*-.000286018764188897));c[p>>2]=11;ta=+h[(jYa(ia,1,p)|0)>>3];c[o>>2]=7;pa=+h[(jYa(ia,1,o)|0)>>3]*-71504691047224.0e-18;c[n>>2]=1;va=ta+ma*(pa+ma*+h[(jYa(ia,1,n)|0)>>3]*116273054608056.0e-20)+.0021774678714571;h[a>>3]=d;h[a+8>>3]=e;h[a+16>>3]=461.526;h[a+24>>3]=ma;h[a+32>>3]=na;h[a+40>>3]=oa;h[a+48>>3]=ra;h[a+56>>3]=qa;h[a+64>>3]=sa;h[a+72>>3]=ua;h[a+80>>3]=va;i=f;return}function rE(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0.0,Be=0.0,Ce=0.0,De=0.0,Ee=0.0,Fe=0.0,Ge=0.0,He=0.0,Ie=0.0,Je=0.0,Ke=0.0,Le=0.0,Me=0.0,Ne=0.0,Oe=0.0,Qe=0.0,Re=0.0,Se=0.0,Te=0.0,Ue=0.0,Ve=0.0,We=0.0,Xe=0.0,Ye=0.0;f=i;i=i+80|0;g=f;j=f+24|0;k=f+48|0;l=f+72|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+8|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;ob=i;i=i+8|0;pb=i;i=i+8|0;qb=i;i=i+8|0;rb=i;i=i+8|0;sb=i;i=i+8|0;tb=i;i=i+8|0;ub=i;i=i+8|0;vb=i;i=i+8|0;wb=i;i=i+8|0;xb=i;i=i+8|0;yb=i;i=i+8|0;zb=i;i=i+8|0;Ab=i;i=i+8|0;Bb=i;i=i+8|0;Cb=i;i=i+8|0;Db=i;i=i+8|0;Eb=i;i=i+8|0;Fb=i;i=i+8|0;Gb=i;i=i+8|0;Hb=i;i=i+8|0;Ib=i;i=i+8|0;Jb=i;i=i+8|0;Kb=i;i=i+8|0;Lb=i;i=i+8|0;Mb=i;i=i+8|0;Nb=i;i=i+8|0;Ob=i;i=i+8|0;Pb=i;i=i+8|0;Qb=i;i=i+8|0;Rb=i;i=i+8|0;Sb=i;i=i+8|0;Tb=i;i=i+8|0;Ub=i;i=i+8|0;Vb=i;i=i+8|0;Wb=i;i=i+8|0;Xb=i;i=i+8|0;Yb=i;i=i+8|0;Zb=i;i=i+8|0;_b=i;i=i+8|0;$b=i;i=i+8|0;ac=i;i=i+8|0;bc=i;i=i+8|0;cc=i;i=i+8|0;dc=i;i=i+8|0;ec=i;i=i+8|0;fc=i;i=i+8|0;gc=i;i=i+8|0;hc=i;i=i+8|0;ic=i;i=i+8|0;jc=i;i=i+8|0;kc=i;i=i+8|0;lc=i;i=i+8|0;mc=i;i=i+8|0;nc=i;i=i+8|0;oc=i;i=i+8|0;pc=i;i=i+8|0;qc=i;i=i+8|0;rc=i;i=i+8|0;sc=i;i=i+8|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+8|0;wc=i;i=i+8|0;xc=i;i=i+8|0;yc=i;i=i+8|0;zc=i;i=i+8|0;Ac=i;i=i+8|0;Bc=i;i=i+8|0;Cc=i;i=i+8|0;Dc=i;i=i+8|0;Ec=i;i=i+8|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+8|0;Ic=i;i=i+8|0;Jc=i;i=i+8|0;Kc=i;i=i+8|0;Lc=i;i=i+8|0;Mc=i;i=i+8|0;Nc=i;i=i+8|0;Oc=i;i=i+8|0;Pc=i;i=i+8|0;Qc=i;i=i+8|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+8|0;Uc=i;i=i+8|0;Vc=i;i=i+8|0;Wc=i;i=i+8|0;Xc=i;i=i+8|0;Yc=i;i=i+8|0;Zc=i;i=i+8|0;_c=i;i=i+8|0;$c=i;i=i+8|0;ad=i;i=i+8|0;bd=i;i=i+8|0;cd=i;i=i+8|0;dd=i;i=i+8|0;ed=i;i=i+8|0;fd=i;i=i+8|0;gd=i;i=i+8|0;hd=i;i=i+8|0;id=i;i=i+8|0;jd=i;i=i+8|0;kd=i;i=i+8|0;ld=i;i=i+8|0;md=i;i=i+8|0;nd=i;i=i+8|0;od=i;i=i+8|0;pd=i;i=i+8|0;qd=i;i=i+8|0;rd=i;i=i+8|0;sd=i;i=i+8|0;td=i;i=i+8|0;ud=i;i=i+8|0;vd=i;i=i+8|0;wd=i;i=i+8|0;xd=i;i=i+8|0;yd=i;i=i+8|0;zd=i;i=i+8|0;Ad=i;i=i+8|0;Bd=i;i=i+8|0;Cd=i;i=i+8|0;Dd=i;i=i+8|0;Ed=i;i=i+8|0;Fd=i;i=i+8|0;Gd=i;i=i+8|0;Hd=i;i=i+8|0;Id=i;i=i+8|0;Jd=i;i=i+8|0;Kd=i;i=i+8|0;Ld=i;i=i+8|0;Md=i;i=i+8|0;Nd=i;i=i+8|0;Od=i;i=i+8|0;Pd=i;i=i+8|0;Qd=i;i=i+8|0;Rd=i;i=i+8|0;Sd=i;i=i+8|0;Td=i;i=i+8|0;Ud=i;i=i+8|0;Vd=i;i=i+8|0;Wd=i;i=i+8|0;Xd=i;i=i+8|0;Yd=i;i=i+8|0;Zd=i;i=i+8|0;_d=i;i=i+8|0;$d=i;i=i+8|0;ae=i;i=i+8|0;be=i;i=i+8|0;ce=i;i=i+8|0;de=i;i=i+8|0;ee=i;i=i+8|0;fe=i;i=i+8|0;ge=i;i=i+8|0;he=i;i=i+8|0;ie=i;i=i+8|0;je=i;i=i+8|0;ke=i;i=i+8|0;le=i;i=i+8|0;me=i;i=i+8|0;ne=i;i=i+8|0;oe=i;i=i+8|0;pe=i;i=i+8|0;qe=i;i=i+8|0;re=i;i=i+8|0;se=i;i=i+8|0;te=i;i=i+8|0;ue=i;i=i+8|0;ve=i;i=i+8|0;we=i;i=i+16|0;c[ve>>2]=45;eYa(we,1,ve);if(!(d>611.657)){ve=RXa(RXa(24872,PXa(d,0,1,6)|0)|0,24408)|0;xe=RXa(RXa(ve,PXa(611.657,0,1,6)|0)|0,24416)|0;ve=c[72300]|0;ye=k;ze=24936;c[ye+0>>2]=c[ze+0>>2];c[ye+4>>2]=c[ze+4>>2];c[ye+8>>2]=c[ze+8>>2];c[ye+12>>2]=c[ze+12>>2];c[ye+16>>2]=c[ze+16>>2];c[ye+20>>2]=c[ze+20>>2];Pe[ve&127](b,k,xe,ue);}if(!(d<=1.0e8)){ue=RXa(RXa(24960,PXa(d,0,1,6)|0)|0,25008)|0;xe=c[72300]|0;k=j;ve=25040;c[k+0>>2]=c[ve+0>>2];c[k+4>>2]=c[ve+4>>2];c[k+8>>2]=c[ve+8>>2];c[k+12>>2]=c[ve+12>>2];c[k+16>>2]=c[ve+16>>2];c[k+20>>2]=c[ve+20>>2];Pe[xe&127](b,j,ue,te);}if(!(e>=273.15)){te=RXa(RXa(25064,PXa(e,0,1,6)|0)|0,25112)|0;ue=c[72300]|0;j=g;xe=25144;c[j+0>>2]=c[xe+0>>2];c[j+4>>2]=c[xe+4>>2];c[j+8>>2]=c[xe+8>>2];c[j+12>>2]=c[xe+12>>2];c[j+16>>2]=c[xe+16>>2];c[j+20>>2]=c[xe+20>>2];Pe[ue&127](b,g,te,se);}Ae=d/1653.0e4;Be=1386.0/e;Ce=7.1-Ae;De=Be+-1.222;c[re>>2]=1;h[(jYa(we,1,re)|0)>>3]=De*De;c[qe>>2]=1;Ee=+h[(jYa(we,1,qe)|0)>>3];c[pe>>2]=2;h[(jYa(we,1,pe)|0)>>3]=Ee*Ee;c[oe>>2]=2;Ee=+h[(jYa(we,1,oe)|0)>>3];c[ne>>2]=3;h[(jYa(we,1,ne)|0)>>3]=Ee*Ee;c[me>>2]=3;Ee=De*+h[(jYa(we,1,me)|0)>>3];c[le>>2]=4;h[(jYa(we,1,le)|0)>>3]=Ee;c[ke>>2]=4;Ee=1.0/+h[(jYa(we,1,ke)|0)>>3];c[je>>2]=5;h[(jYa(we,1,je)|0)>>3]=Ee;c[ie>>2]=1;Ee=+h[(jYa(we,1,ie)|0)>>3];c[he>>2]=2;Fe=Ee*+h[(jYa(we,1,he)|0)>>3];c[ge>>2]=6;h[(jYa(we,1,ge)|0)>>3]=Fe;c[fe>>2]=1;Fe=De*+h[(jYa(we,1,fe)|0)>>3];c[ee>>2]=7;h[(jYa(we,1,ee)|0)>>3]=Fe;c[de>>2]=7;Fe=1.0/+h[(jYa(we,1,de)|0)>>3];c[ce>>2]=8;h[(jYa(we,1,ce)|0)>>3]=Fe;c[be>>2]=1;Fe=+h[(jYa(we,1,be)|0)>>3];c[ae>>2]=2;Ee=+h[(jYa(we,1,ae)|0)>>3];c[$d>>2]=3;Ge=Fe*Ee*+h[(jYa(we,1,$d)|0)>>3];c[_d>>2]=9;h[(jYa(we,1,_d)|0)>>3]=Ge;c[Zd>>2]=2;Ge=1.0/+h[(jYa(we,1,Zd)|0)>>3];c[Yd>>2]=10;h[(jYa(we,1,Yd)|0)>>3]=Ge;c[Xd>>2]=2;Ge=De*+h[(jYa(we,1,Xd)|0)>>3];c[Wd>>2]=11;h[(jYa(we,1,Wd)|0)>>3]=Ge;c[Vd>>2]=11;Ge=1.0/+h[(jYa(we,1,Vd)|0)>>3];c[Ud>>2]=12;h[(jYa(we,1,Ud)|0)>>3]=Ge;c[Td>>2]=2;Ge=+h[(jYa(we,1,Td)|0)>>3];c[Sd>>2]=3;Ee=Ge*+h[(jYa(we,1,Sd)|0)>>3];c[Rd>>2]=13;h[(jYa(we,1,Rd)|0)>>3]=Ee;c[Qd>>2]=3;Ee=1.0/+h[(jYa(we,1,Qd)|0)>>3];c[Pd>>2]=14;h[(jYa(we,1,Pd)|0)>>3]=Ee;c[Od>>2]=15;h[(jYa(we,1,Od)|0)>>3]=Ce*Ce;c[Nd>>2]=15;Ee=Ce*+h[(jYa(we,1,Nd)|0)>>3];c[Md>>2]=16;h[(jYa(we,1,Md)|0)>>3]=Ee;c[Ld>>2]=15;Ee=+h[(jYa(we,1,Ld)|0)>>3];c[Kd>>2]=17;h[(jYa(we,1,Kd)|0)>>3]=Ee*Ee;c[Jd>>2]=17;Ee=+h[(jYa(we,1,Jd)|0)>>3];c[Id>>2]=18;h[(jYa(we,1,Id)|0)>>3]=Ee*Ee;c[Hd>>2]=17;Ee=+h[(jYa(we,1,Hd)|0)>>3];c[Gd>>2]=18;Ge=Ee*Ce*+h[(jYa(we,1,Gd)|0)>>3];c[Fd>>2]=19;h[(jYa(we,1,Fd)|0)>>3]=Ge;c[Ed>>2]=15;Ge=+h[(jYa(we,1,Ed)|0)>>3];c[Dd>>2]=17;Ee=Ge*+h[(jYa(we,1,Dd)|0)>>3];c[Cd>>2]=20;h[(jYa(we,1,Cd)|0)>>3]=Ee;c[Bd>>2]=3;Ee=+h[(jYa(we,1,Bd)|0)>>3];c[Ad>>2]=21;h[(jYa(we,1,Ad)|0)>>3]=Ee*Ee;c[zd>>2]=21;Ee=+h[(jYa(we,1,zd)|0)>>3];c[yd>>2]=22;h[(jYa(we,1,yd)|0)>>3]=Ee*Ee;c[xd>>2]=22;Ee=+h[(jYa(we,1,xd)|0)>>3];c[wd>>2]=3;Ge=Ee*De*+h[(jYa(we,1,wd)|0)>>3];c[vd>>2]=23;h[(jYa(we,1,vd)|0)>>3]=Ge;c[ud>>2]=23;Ge=1.0/+h[(jYa(we,1,ud)|0)>>3];c[td>>2]=24;h[(jYa(we,1,td)|0)>>3]=Ge;c[sd>>2]=22;Ge=+h[(jYa(we,1,sd)|0)>>3];c[rd>>2]=3;Ee=Ge*+h[(jYa(we,1,rd)|0)>>3];c[qd>>2]=25;h[(jYa(we,1,qd)|0)>>3]=Ee;c[pd>>2]=25;Ee=1.0/+h[(jYa(we,1,pd)|0)>>3];c[od>>2]=26;h[(jYa(we,1,od)|0)>>3]=Ee;c[nd>>2]=1;Ee=+h[(jYa(we,1,nd)|0)>>3];c[md>>2]=2;Ge=+h[(jYa(we,1,md)|0)>>3];c[ld>>2]=22;Fe=Ee*Ge*De*+h[(jYa(we,1,ld)|0)>>3];c[kd>>2]=27;h[(jYa(we,1,kd)|0)>>3]=Fe;c[jd>>2]=27;Fe=1.0/+h[(jYa(we,1,jd)|0)>>3];c[id>>2]=28;h[(jYa(we,1,id)|0)>>3]=Fe;c[hd>>2]=1;Fe=+h[(jYa(we,1,hd)|0)>>3];c[gd>>2]=2;Ge=+h[(jYa(we,1,gd)|0)>>3];c[fd>>2]=22;Ee=Fe*Ge*+h[(jYa(we,1,fd)|0)>>3];c[ed>>2]=29;h[(jYa(we,1,ed)|0)>>3]=Ee;c[dd>>2]=29;Ee=1.0/+h[(jYa(we,1,dd)|0)>>3];c[cd>>2]=30;h[(jYa(we,1,cd)|0)>>3]=Ee;c[bd>>2]=1;Ee=+h[(jYa(we,1,bd)|0)>>3];c[ad>>2]=2;Ge=+h[(jYa(we,1,ad)|0)>>3];c[$c>>2]=21;Fe=+h[(jYa(we,1,$c)|0)>>3];c[_c>>2]=3;He=Ee*Ge*Fe*De*+h[(jYa(we,1,_c)|0)>>3];c[Zc>>2]=31;h[(jYa(we,1,Zc)|0)>>3]=He;c[Yc>>2]=31;He=1.0/+h[(jYa(we,1,Yc)|0)>>3];c[Xc>>2]=32;h[(jYa(we,1,Xc)|0)>>3]=He;c[Wc>>2]=2;He=+h[(jYa(we,1,Wc)|0)>>3];c[Vc>>2]=21;Fe=+h[(jYa(we,1,Vc)|0)>>3];c[Uc>>2]=3;Ge=He*Fe*De*+h[(jYa(we,1,Uc)|0)>>3];c[Tc>>2]=33;h[(jYa(we,1,Tc)|0)>>3]=Ge;c[Sc>>2]=33;Ge=1.0/+h[(jYa(we,1,Sc)|0)>>3];c[Rc>>2]=34;h[(jYa(we,1,Rc)|0)>>3]=Ge;c[Qc>>2]=1;Ge=+h[(jYa(we,1,Qc)|0)>>3];c[Pc>>2]=3;Fe=Ge*De*+h[(jYa(we,1,Pc)|0)>>3];c[Oc>>2]=35;h[(jYa(we,1,Oc)|0)>>3]=Fe;c[Nc>>2]=35;Fe=1.0/+h[(jYa(we,1,Nc)|0)>>3];c[Mc>>2]=36;h[(jYa(we,1,Mc)|0)>>3]=Fe;c[Lc>>2]=1;Fe=+h[(jYa(we,1,Lc)|0)>>3];c[Kc>>2]=3;Ge=Fe*+h[(jYa(we,1,Kc)|0)>>3];c[Jc>>2]=37;h[(jYa(we,1,Jc)|0)>>3]=Ge;c[Ic>>2]=37;Ge=1.0/+h[(jYa(we,1,Ic)|0)>>3];c[Hc>>2]=38;h[(jYa(we,1,Hc)|0)>>3]=Ge;c[Gc>>2]=6;Ge=1.0/+h[(jYa(we,1,Gc)|0)>>3];c[Fc>>2]=39;h[(jYa(we,1,Fc)|0)>>3]=Ge;c[Ec>>2]=1;Ge=+h[(jYa(we,1,Ec)|0)>>3];c[Dc>>2]=22;Fe=+h[(jYa(we,1,Dc)|0)>>3];c[Cc>>2]=3;He=Ge*Fe*+h[(jYa(we,1,Cc)|0)>>3];c[Bc>>2]=40;h[(jYa(we,1,Bc)|0)>>3]=He;c[Ac>>2]=40;He=1.0/+h[(jYa(we,1,Ac)|0)>>3];c[zc>>2]=41;h[(jYa(we,1,zc)|0)>>3]=He;c[yc>>2]=22;He=1.0/+h[(jYa(we,1,yc)|0)>>3];c[xc>>2]=42;h[(jYa(we,1,xc)|0)>>3]=He;c[wc>>2]=1;He=+h[(jYa(we,1,wc)|0)>>3];c[vc>>2]=2;Fe=+h[(jYa(we,1,vc)|0)>>3];c[uc>>2]=21;Ge=+h[(jYa(we,1,uc)|0)>>3];c[tc>>2]=3;Ee=He*Fe*Ge*+h[(jYa(we,1,tc)|0)>>3];c[sc>>2]=43;h[(jYa(we,1,sc)|0)>>3]=Ee;c[rc>>2]=43;Ee=1.0/+h[(jYa(we,1,rc)|0)>>3];c[qc>>2]=44;h[(jYa(we,1,qc)|0)>>3]=Ee;c[pc>>2]=13;Ee=1.0/+h[(jYa(we,1,pc)|0)>>3];c[oc>>2]=45;h[(jYa(we,1,oc)|0)>>3]=Ee;c[nc>>2]=10;Ee=+h[(jYa(we,1,nc)|0)>>3];c[mc>>2]=2;Ge=+h[(jYa(we,1,mc)|0)>>3];c[lc>>2]=6;Fe=Ee*(Ge*(+h[(jYa(we,1,lc)|0)>>3]*-8.5205128120103e-10+-28270797985312.0e-19)+-31679644845054.0e-18);c[kc>>2]=12;Ge=+h[(jYa(we,1,kc)|0)>>3];c[jc>>2]=13;Ee=+h[(jYa(we,1,jc)|0)>>3]*-1.4341729937924e-13+-6.5171222895601e-7;c[ic>>2]=7;He=Ge*(Ee*+h[(jYa(we,1,ic)|0)>>3]+-22425281908.0e-16);c[hc>>2]=14;Ee=+h[(jYa(we,1,hc)|0)>>3]*-4.0516996860117e-7;c[gc>>2]=16;Ge=+h[(jYa(we,1,gc)|0)>>3];c[fc>>2]=11;Ie=+h[(jYa(we,1,fc)|0)>>3]*-1.7424871230634e-10+-1.2734301741641e-9;c[ec>>2]=36;Je=Ie*+h[(jYa(we,1,ec)|0)>>3];c[dc>>2]=19;Ie=+h[(jYa(we,1,dc)|0)>>3];c[cc>>2]=34;Ke=+h[(jYa(we,1,cc)|0)>>3]*-6.8762131295531e-19;c[bc>>2]=15;Le=+h[(jYa(we,1,bc)|0)>>3];c[ac>>2]=32;Me=+h[(jYa(we,1,ac)|0)>>3]*1.4478307828521e-20;c[$b>>2]=20;Ne=+h[(jYa(we,1,$b)|0)>>3];c[_b>>2]=30;Oe=+h[(jYa(we,1,_b)|0)>>3]*2.6335781662795e-23;c[Zb>>2]=28;Qe=+h[(jYa(we,1,Zb)|0)>>3]*-1.1947622640071e-23;c[Yb>>2]=26;Re=+h[(jYa(we,1,Yb)|0)>>3]*1.8228094581404e-24;c[Xb>>2]=24;Se=Ce*(Fe+Ce*(He+Ce*(Ee+Ge*(Je+Ie*(Ke+Le*(Me+Ne*(Oe+Ce*(Qe+Ce*(Re+Ce*+h[(jYa(we,1,Xb)|0)>>3]*-9.3537087292458e-26)))))))));c[Wb>>2]=8;Re=+h[(jYa(we,1,Wb)|0)>>3];c[Vb>>2]=7;Qe=+h[(jYa(we,1,Vb)|0)>>3];c[Ub>>2]=1;Oe=+h[(jYa(we,1,Ub)|0)>>3];c[Tb>>2]=9;Ne=Ce*(Re*(Qe*(De*(Oe*(+h[(jYa(we,1,Tb)|0)>>3]*-7.2694996297594e-16+-44141845330846.0e-19)+47661393906987.0e-18)+-.00030001780793026)+-.00047184321073267)+Se);c[Sb>>2]=5;Se=+h[(jYa(we,1,Sb)|0)>>3];c[Rb>>2]=1;Oe=+h[(jYa(we,1,Rb)|0)>>3];c[Qb>>2]=6;Qe=+h[(jYa(we,1,Qb)|0)>>3];c[Pb>>2]=1;Re=Ce*(Ne+Se*(Oe*(Qe*(De*(De*(+h[(jYa(we,1,Pb)|0)>>3]*-5283835796993.0e-17+-.021841717175414)+-.032529748770505)+-.018990068218419)+-.00060706301565874)+.00028319080123804));c[Ob>>2]=1;Qe=(De*(De*(De*(De*(De*(De*(De*.00081214629983568+-.016616417199501)+.15772038513228)+-.95791963387872)+3.3855169168385)+-3.756360367204)+-.84548187169114)+.14632971213167)/+h[(jYa(we,1,Ob)|0)>>3]+Re;c[Nb>>2]=10;Re=+h[(jYa(we,1,Nb)|0)>>3];c[Mb>>2]=2;Oe=+h[(jYa(we,1,Mb)|0)>>3];c[Lb>>2]=6;Se=Re*(Oe*(+h[(jYa(we,1,Lb)|0)>>3]*2.55615384360309e-9+84812393955936.0e-19)+95038934535162.0e-18);c[Kb>>2]=12;Oe=+h[(jYa(we,1,Kb)|0)>>3];c[Jb>>2]=13;Re=+h[(jYa(we,1,Jb)|0)>>3]*5.7366919751696e-13+260684891582404.0e-20;c[Ib>>2]=7;Ne=Oe*(Re*+h[(jYa(we,1,Ib)|0)>>3]+89701127632.0e-16);c[Hb>>2]=14;Re=+h[(jYa(we,1,Hb)|0)>>3]*202584984300585.0e-20;c[Gb>>2]=16;Oe=+h[(jYa(we,1,Gb)|0)>>3];c[Fb>>2]=11;Me=+h[(jYa(we,1,Fb)|0)>>3]*1.39398969845072e-9+1.01874413933128e-8;c[Eb>>2]=36;Le=Me*+h[(jYa(we,1,Eb)|0)>>3];c[Db>>2]=19;Me=+h[(jYa(we,1,Db)|0)>>3];c[Cb>>2]=34;Ke=+h[(jYa(we,1,Cb)|0)>>3]*1.44400475720615e-17;c[Bb>>2]=15;Ie=+h[(jYa(we,1,Bb)|0)>>3];c[Ab>>2]=32;Je=+h[(jYa(we,1,Ab)|0)>>3]*-3.3300108005598e-19;c[zb>>2]=20;Ge=+h[(jYa(we,1,zb)|0)>>3];c[yb>>2]=30;Ee=+h[(jYa(we,1,yb)|0)>>3]*-7.6373766822106e-22;c[xb>>2]=28;He=+h[(jYa(we,1,xb)|0)>>3]*3.5842867920213e-22;c[wb>>2]=26;Fe=+h[(jYa(we,1,wb)|0)>>3]*-5.6507093202352e-23;c[vb>>2]=24;Te=Ce*(Se+Ce*(Ne+Ce*(Re+Oe*(Le+Me*(Ke+Ie*(Je+Ge*(Ee+Ce*(He+Ce*(Fe+Ce*+h[(jYa(we,1,vb)|0)>>3]*2.99318679335866e-24)))))))));c[ub>>2]=8;Fe=+h[(jYa(we,1,ub)|0)>>3];c[tb>>2]=7;He=+h[(jYa(we,1,tb)|0)>>3];c[sb>>2]=1;Ee=+h[(jYa(we,1,sb)|0)>>3];c[rb>>2]=9;Ge=Ce*(Fe*(He*(De*(Ee*(+h[(jYa(we,1,rb)|0)>>3]*1.45389992595188e-15+88283690661692.0e-19)+-95322787813974.0e-18)+.00060003561586052)+.00094368642146534)+Te);c[qb>>2]=5;Te=+h[(jYa(we,1,qb)|0)>>3];c[pb>>2]=1;Ee=+h[(jYa(we,1,pb)|0)>>3];c[ob>>2]=6;He=+h[(jYa(we,1,ob)|0)>>3];c[nb>>2]=1;Fe=Ge+Te*(Ee*(He*(De*(De*(+h[(jYa(we,1,nb)|0)>>3]*5283835796993.0e-17+.021841717175414)+.032529748770505)+.018990068218419)+.00060706301565874)+-.00028319080123804);c[mb>>2]=10;He=+h[(jYa(we,1,mb)|0)>>3];c[lb>>2]=2;Ee=+h[(jYa(we,1,lb)|0)>>3];c[kb>>2]=6;Te=He*(Ee*(+h[(jYa(we,1,kb)|0)>>3]*-5.1123076872062e-9+-169624787911872.0e-19)+-.000190077869070324);c[jb>>2]=12;Ee=+h[(jYa(we,1,jb)|0)>>3];c[ib>>2]=13;He=+h[(jYa(we,1,ib)|0)>>3]*-1.72100759255088e-12+-78205467474721.0e-19;c[hb>>2]=7;Ge=Ee*(He*+h[(jYa(we,1,hb)|0)>>3]+-269103382896.0e-16);c[gb>>2]=14;He=+h[(jYa(we,1,gb)|0)>>3]*-81033993720234.0e-19;c[fb>>2]=16;Ee=+h[(jYa(we,1,fb)|0)>>3];c[eb>>2]=11;Je=+h[(jYa(we,1,eb)|0)>>3]*-9.757927889155e-9+-7.131208975319e-8;c[db>>2]=36;Ie=Je*+h[(jYa(we,1,db)|0)>>3];c[cb>>2]=19;Je=+h[(jYa(we,1,cb)|0)>>3];c[bb>>2]=34;Ke=+h[(jYa(we,1,bb)|0)>>3]*-2.8880095144123e-16;c[ab>>2]=15;Me=+h[(jYa(we,1,ab)|0)>>3];c[$a>>2]=32;Le=+h[(jYa(we,1,$a)|0)>>3]*7.3260237612316e-18;c[_a>>2]=20;Oe=+h[(jYa(we,1,_a)|0)>>3];c[Za>>2]=30;Re=+h[(jYa(we,1,Za)|0)>>3]*2.13846547101895e-20;c[Ya>>2]=28;Ne=+h[(jYa(we,1,Ya)|0)>>3]*-1.03944316968618e-20;c[Xa>>2]=26;Se=+h[(jYa(we,1,Xa)|0)>>3]*1.69521279607057e-21;c[Wa>>2]=24;Ue=Ce*(Te+Ce*(Ge+Ce*(He+Ee*(Ie+Je*(Ke+Me*(Le+Oe*(Re+Ce*(Ne+Ce*(Se+Ce*+h[(jYa(we,1,Wa)|0)>>3]*-9.2788790594118e-23)))))))));c[Va>>2]=8;Se=+h[(jYa(we,1,Va)|0)>>3];c[Ua>>2]=7;Ne=+h[(jYa(we,1,Ua)|0)>>3];c[Ta>>2]=1;Re=+h[(jYa(we,1,Ta)|0)>>3];c[Sa>>2]=9;Oe=Se*(Ne*(De*(Re*(+h[(jYa(we,1,Sa)|0)>>3]*-1.45389992595188e-15+-88283690661692.0e-19)+95322787813974.0e-18)+-.00060003561586052)+-.00094368642146534)+Ue;c[Ra>>2]=38;Ue=+h[(jYa(we,1,Ra)|0)>>3];c[Qa>>2]=1;Re=+h[(jYa(we,1,Qa)|0)>>3];c[Pa>>2]=1;Ne=+h[(jYa(we,1,Pa)|0)>>3]*-.00015851507390979+-.021841717175414;c[Oa>>2]=1;Se=Ne*+h[(jYa(we,1,Oa)|0)>>3]+.018990068218419;c[Na>>2]=6;Ne=Ue*(Re*(Se*+h[(jYa(we,1,Na)|0)>>3]+.0042494411096112)+-.00254871721114236);c[Ma>>2]=10;Se=+h[(jYa(we,1,Ma)|0)>>3];c[La>>2]=2;Re=+h[(jYa(we,1,La)|0)>>3];c[Ka>>2]=1;Ue=+h[(jYa(we,1,Ka)|0)>>3];c[Ja>>2]=9;Le=Se*(Re*(Ue*(+h[(jYa(we,1,Ja)|0)>>3]*-1.2358149370591e-14+-132425535992538.0e-19)+47661393906987.0e-18)+.00141552963219801);c[Ia>>2]=12;Ue=+h[(jYa(we,1,Ia)|0)>>3];c[Ha>>2]=37;Re=Ue*(+h[(jYa(we,1,Ha)|0)>>3]*-5.1123076872062e-9+.000126718579380216);c[Ga>>2]=39;Ue=+h[(jYa(we,1,Ga)|0)>>3];c[Fa>>2]=13;Se=+h[(jYa(we,1,Fa)|0)>>3]*-1.4341729937924e-12+130342445791202.0e-20;c[Ea>>2]=7;Me=Ue*(Se*+h[(jYa(we,1,Ea)|0)>>3]+11212640954.0e-15);c[Da>>2]=5;Se=+h[(jYa(we,1,Da)|0)>>3]*32413597488094.0e-19;c[Ca>>2]=16;Ue=+h[(jYa(we,1,Ca)|0)>>3];c[Ba>>2]=11;Ke=+h[(jYa(we,1,Ba)|0)>>3]*1.04549227383804e-9+1.40077319158051e-8;c[Aa>>2]=45;Je=Ke*+h[(jYa(we,1,Aa)|0)>>3];c[za>>2]=19;Ke=+h[(jYa(we,1,za)|0)>>3];c[ya>>2]=44;Ie=+h[(jYa(we,1,ya)|0)>>3]*1.9941018075704e-17;c[xa>>2]=15;Ee=+h[(jYa(we,1,xa)|0)>>3];c[wa>>2]=42;He=+h[(jYa(we,1,wa)|0)>>3]*-4.4882754268415e-19;c[va>>2]=20;Ge=+h[(jYa(we,1,va)|0)>>3];c[ua>>2]=28;Te=+h[(jYa(we,1,ua)|0)>>3]*-1.00075970318621e-21;c[ta>>2]=26;Ve=+h[(jYa(we,1,ta)|0)>>3]*4.6595728296277e-22;c[sa>>2]=24;We=+h[(jYa(we,1,sa)|0)>>3]*-7.2912378325616e-23;c[ra>>2]=41;Xe=Ce*(Ne+Ce*(Le+Ce*(Re+Ce*(Me+Ce*(Se+Ue*(Je+Ke*(Ie+Ee*(He+Ge*(Te+Ce*(Ve+Ce*(We+Ce*+h[(jYa(we,1,ra)|0)>>3]*3.8350205789908e-24)))))))))));c[qa>>2]=8;We=+h[(jYa(we,1,qa)|0)>>3];c[pa>>2]=1;Ve=We*(De*((De*(De*(De*(De*.0040607314991784+-.066465668798004)+.47316115539684)+-1.91583926775744)+3.3855169168385)*+h[(jYa(we,1,pa)|0)>>3]+.84548187169114)+-.29265942426334)+Xe;c[oa>>2]=36;Xe=+h[(jYa(we,1,oa)|0)>>3];c[na>>2]=1;We=+h[(jYa(we,1,na)|0)>>3];c[ma>>2]=2;Te=+h[(jYa(we,1,ma)|0)>>3]*-.00031703014781958+-.037980136436838;c[la>>2]=6;Ge=Xe*(We*(Te*+h[(jYa(we,1,la)|0)>>3]+-.033995528876889)+.0254871721114236);c[ka>>2]=12;Te=+h[(jYa(we,1,ka)|0)>>3];c[ja>>2]=6;We=+h[(jYa(we,1,ja)|0)>>3];c[ia>>2]=9;Xe=Te*(We*(+h[(jYa(we,1,ia)|0)>>3]*-1.97730389929456e-13+-264851071985076.0e-19)+-.005662118528792);c[ha>>2]=37;We=+h[(jYa(we,1,ha)|0)>>3]*-2.55615384360309e-8+-.00063359289690108;c[ga>>2]=39;Te=We*+h[(jYa(we,1,ga)|0)>>3];c[fa>>2]=38;We=+h[(jYa(we,1,fa)|0)>>3]*-291722377392842.0e-19;c[ea>>2]=16;He=+h[(jYa(we,1,ea)|0)>>3];c[da>>2]=19;Ee=+h[(jYa(we,1,da)|0)>>3];c[ca>>2]=32;Ie=+h[(jYa(we,1,ca)|0)>>3]*-5.9823054227112e-16;c[ba>>2]=15;Ke=+h[(jYa(we,1,ba)|0)>>3];c[aa>>2]=20;Je=+h[(jYa(we,1,aa)|0)>>3];c[$>>2]=26;Ue=+h[(jYa(we,1,$)|0)>>3]*3.9029628424262e-20;c[_>>2]=24;Se=+h[(jYa(we,1,_)|0)>>3]*-1.86382913185108e-20;c[Z>>2]=41;Me=+h[(jYa(we,1,Z)|0)>>3]*2.98940751135026e-21;c[Y>>2]=1;Re=+h[(jYa(we,1,Y)|0)>>3];c[X>>2]=22;Le=Re*+h[(jYa(we,1,X)|0)>>3];c[W>>2]=3;Re=Je*(Ue+Ce*(Se+Ce*(Me+Ce/(De*Le*+h[(jYa(we,1,W)|0)>>3])*-1.61070864317613e-22)));c[V>>2]=22;Le=Ee*(Ie+Ke*(1.43624813658928e-17/(De*+h[(jYa(we,1,V)|0)>>3])+Re));c[U>>2]=11;Re=+h[(jYa(we,1,U)|0)>>3]*-7.3184459168663e-9+-1.68092782989661e-7;c[T>>2]=2;Ke=+h[(jYa(we,1,T)|0)>>3];c[S>>2]=3;Ie=Ce*(We+He*(Re/(De*Ke*+h[(jYa(we,1,S)|0)>>3])+Le));c[R>>2]=13;Le=+h[(jYa(we,1,R)|0)>>3]*-1.29075569441316e-11+-39102733737361.0e-19;c[Q>>2]=7;Ke=Le*+h[(jYa(we,1,Q)|0)>>3]+-67275845724.0e-15;c[P>>2]=1;Le=+h[(jYa(we,1,P)|0)>>3];c[O>>2]=2;Re=Ce*(Ge+Ce*(Xe+Ce*(Te+Ce*(Ie+Ke/(De*Le*+h[(jYa(we,1,O)|0)>>3])))));c[N>>2]=10;Le=+h[(jYa(we,1,N)|0)>>3];c[M>>2]=7;Ke=Re+Le*(De*((De*(De*(De*.0162429259967136+-.199397006394012)+.94632231079368)+-1.91583926775744)*+h[(jYa(we,1,M)|0)>>3]+-1.69096374338228)+.87797827279002);c[L>>2]=38;De=+h[(jYa(we,1,L)|0)>>3];c[K>>2]=1;Le=+h[(jYa(we,1,K)|0)>>3];c[J>>2]=1;Re=+h[(jYa(we,1,J)|0)>>3]*.00015851507390979+.021841717175414;c[I>>2]=1;Ie=Re*+h[(jYa(we,1,I)|0)>>3]+-.018990068218419;c[H>>2]=6;Re=De*(Le*(Ie*+h[(jYa(we,1,H)|0)>>3]+-.0042494411096112)+.00254871721114236);c[G>>2]=10;Ie=+h[(jYa(we,1,G)|0)>>3];c[F>>2]=2;Le=+h[(jYa(we,1,F)|0)>>3];c[E>>2]=1;De=+h[(jYa(we,1,E)|0)>>3];c[D>>2]=9;Te=Ie*(Le*(De*(+h[(jYa(we,1,D)|0)>>3]*2.4716298741182e-14+264851071985076.0e-19)+-95322787813974.0e-18)+-.00283105926439602);c[C>>2]=12;De=+h[(jYa(we,1,C)|0)>>3];c[B>>2]=37;Le=De*(+h[(jYa(we,1,B)|0)>>3]*1.53369230616185e-8+-.00038015573814065);c[A>>2]=39;De=+h[(jYa(we,1,A)|0)>>3];c[z>>2]=13;Ie=+h[(jYa(we,1,z)|0)>>3]*5.7366919751696e-12+-52136978316481.0e-19;c[y>>2]=7;Xe=De*(Ie*+h[(jYa(we,1,y)|0)>>3]+-44850563816.0e-15);c[x>>2]=5;Ie=+h[(jYa(we,1,x)|0)>>3]*-162067987440468.0e-19;c[w>>2]=16;De=+h[(jYa(we,1,w)|0)>>3];c[v>>2]=11;Ge=+h[(jYa(we,1,v)|0)>>3]*-8.3639381907043e-9+-1.12061855326441e-7;c[u>>2]=45;He=Ge*+h[(jYa(we,1,u)|0)>>3];c[t>>2]=19;Ge=+h[(jYa(we,1,t)|0)>>3];c[s>>2]=44;We=+h[(jYa(we,1,s)|0)>>3]*-4.1876137958978e-16;c[r>>2]=15;Ee=+h[(jYa(we,1,r)|0)>>3];c[q>>2]=42;Me=+h[(jYa(we,1,q)|0)>>3]*1.03230334817355e-17;c[p>>2]=20;Se=+h[(jYa(we,1,p)|0)>>3];c[o>>2]=28;Ue=+h[(jYa(we,1,o)|0)>>3]*2.90220313924001e-20;c[n>>2]=26;Je=+h[(jYa(we,1,n)|0)>>3]*-1.39787184888831e-20;c[m>>2]=24;Ne=+h[(jYa(we,1,m)|0)>>3]*2.2602837280941e-21;c[l>>2]=41;Ye=Re+Ce*(Te+Ce*(Le+Ce*(Xe+Ce*(Ie+De*(He+Ge*(We+Ee*(Me+Se*(Ue+Ce*(Je+Ce*(Ne+Ce*+h[(jYa(we,1,l)|0)>>3]*-1.22720658527705e-22))))))))));h[a>>3]=d;h[a+8>>3]=e;h[a+16>>3]=461.526;h[a+24>>3]=Ae;h[a+32>>3]=Be;h[a+40>>3]=Qe;h[a+48>>3]=Fe;h[a+56>>3]=Oe;h[a+64>>3]=Ve;h[a+72>>3]=Ke;h[a+80>>3]=Ye;i=f;return}function sE(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;c[j>>2]=33;eYa(k,1,j);j=k;k=25232;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[g>>2]=33;eYa(l,1,g);g=l;l=25248;c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];c[f>>2]=33;eYa(m,1,f);f=m;m=25264;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];n=e/28.0e5+-.72;e=n*n;o=d/1.0e8+.298;d=o*o;p=32325457364492.0e-18/+OYa(o,12);q=n*+OYa(o,-12)*-.000127575556587181;r=-.000475851877356068/+OYa(o,10);s=n*+OYa(o,-10)*.00156183014181602;t=+OYa(o,-10);u=t*+OYa(n,5)*.105724860113781;t=+OYa(o,-10);v=t*+OYa(n,10)*-85.8514221132534;t=+OYa(o,-10);w=t*+OYa(n,12)*724.140095480911;t=.00296475810273257/+OYa(o,8);x=n*+OYa(o,-8)*-.00592721983365988;y=e*+OYa(o,-8)*-.0126305422818666;z=e*e;A=z*+OYa(o,-8)*-.115716196364853;B=+OYa(o,-8);C=B*+OYa(n,10)*84.9000969739595;B=-.0108602260086615/+OYa(o,6);D=n*+OYa(o,-6)*.0154304475328851;E=e*+OYa(o,-6)*.0750455441524466;F=n*+OYa(o,-4)*-.0602507901232996;G=+OYa(o,-3);H=G*+OYa(n,5)*-3.07622221350501;G=z*+OYa(o,-2)*5.03471360939849;I=+OYa(n,6)/o*-77.314600713019;J=+OYa(n,10)/o*9493.08762098587;K=+OYa(n,14)/o*-1410437.19679409;L=+OYa(n,16)/o*8491662.30819026;M=n*+OYa(o,5)*.286596714529479;N=n*+OYa(o,6)*-.131778331276228;h[a>>3]=(p+(q+(r+(s+(u+(v+(w+(t+(x+(y+(A+(C+(B+(D+(E+(.0252520973612982/(d*d)+(F+(H+(-.0574011959864879/d+(G+(e/o*-.925081888584834+(z/o*3.91733882917546+(I+(J+(K+(L+(e*.32334644281172+(o*n*.873281936020439+(n*o*d*-.436653048526683+(M+(N+n*+OYa(o,8)*.00676682064330275))))))))))))))))))))))))))))))+.861095729446704)*860.0;i=b;return}function tE(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;c[j>>2]=31;eYa(k,1,j);j=k;k=25280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[g>>2]=31;eYa(l,1,g);g=l;l=25296;c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];c[f>>2]=31;eYa(m,1,f);f=m;m=25312;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];n=e/23.0e5+-.615;e=n*n;o=d/1.0e8+.24;d=o*o;p=-1.33645667811215e-7/+OYa(o,12);q=n*+OYa(o,-12)*455912656802978.0e-20;r=e*+OYa(o,-12)*-146294640700979.0e-19;s=+OYa(o,-12);t=s*+OYa(n,6)*.0063934131297008;s=+OYa(o,-12);u=s*+OYa(n,14)*372.783927268847;s=+OYa(o,-12);v=s*+OYa(n,16)*-7186.54377460447;s=+OYa(o,-12);w=s*+OYa(n,20)*573494.7521034;s=+OYa(o,-12);x=s*+OYa(n,22)*-2675693.29111439;s=n*+OYa(o,-10)*-334066283302614.0e-19;y=+OYa(o,-10);z=y*+OYa(n,5)*-.0245479214069597;y=+OYa(o,-10);A=y*+OYa(n,12)*47.8087847764996;y=764664131818904.0e-20/+OYa(o,8);B=e*+OYa(o,-8)*.00128350627676972;C=e*e;D=C*+OYa(o,-8)*.0171219081377331;E=+OYa(o,-8);F=E*+OYa(n,10)*-8.51007304583213;E=e*+OYa(o,-5)*-.0136513461629781;G=o*d;H=n*+OYa(o,-2)*.00337423807911655;I=n*e;J=I*+OYa(o,-2)*-.551624873066791;K=C*+OYa(o,-2)*.72920227710747;L=d*d;d=C*+OYa(o,10)*.0136176427574291;C=+OYa(o,12);h[a>>3]=(p+(q+(r+(t+(u+(v+(w+(x+(s+(z+(A+(y+(B+(D+(F+(E+(-384460997596657.0e-20/G+(H+(J+(K+(-.00992522757376041/o+(e/o*-.119308831407288+(n*.454270731799386+(o*n*.20999859125991+(G*-.00642109823904738+(n*G*-.023515586860454+(L*.00252233108341612+(L*I*-.00764885133368119+(d+C*+OYa(n,5)*-.0133027883575669))))))))))))))))))))))))))))+.793929190615421)*760.0;i=b;return}function uE(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+16|0;c[Wa>>2]=31;eYa(Xa,1,Wa);Ya=+zd(+d,647.096);c[Va>>2]=1;h[(jYa(Xa,1,Va)|0)>>3]=Ya+-650.17534844798;c[Ua>>2]=1;d=1.0/+h[(jYa(Xa,1,Ua)|0)>>3];c[Ta>>2]=2;h[(jYa(Xa,1,Ta)|0)>>3]=d;c[Sa>>2]=2;d=+h[(jYa(Xa,1,Sa)|0)>>3]*-.23855557567849;c[Ra>>2]=3;h[(jYa(Xa,1,Ra)|0)>>3]=d;c[Qa>>2]=3;d=Ya+ +h[(jYa(Xa,1,Qa)|0)>>3];c[Pa>>2]=4;h[(jYa(Xa,1,Pa)|0)>>3]=d;c[Oa>>2]=4;d=+h[(jYa(Xa,1,Oa)|0)>>3]*-4823.2657361591;c[Na>>2]=5;h[(jYa(Xa,1,Na)|0)>>3]=d;c[Ma>>2]=4;d=+h[(jYa(Xa,1,Ma)|0)>>3];c[La>>2]=6;h[(jYa(Xa,1,La)|0)>>3]=d*d;c[Ka>>2]=6;d=+h[(jYa(Xa,1,Ka)|0)>>3]*14.91510861353;c[Ja>>2]=7;h[(jYa(Xa,1,Ja)|0)>>3]=d;c[Ia>>2]=5;d=+h[(jYa(Xa,1,Ia)|0)>>3];c[Ha>>2]=7;Ya=d+ +h[(jYa(Xa,1,Ha)|0)>>3]+405113.40542057;c[Ga>>2]=8;h[(jYa(Xa,1,Ga)|0)>>3]=Ya;c[Fa>>2]=8;Ya=+h[(jYa(Xa,1,Fa)|0)>>3];c[Ea>>2]=9;h[(jYa(Xa,1,Ea)|0)>>3]=Ya*Ya;c[Da>>2]=9;Ya=+h[(jYa(Xa,1,Da)|0)>>3];c[Ca>>2]=10;h[(jYa(Xa,1,Ca)|0)>>3]=Ya*Ya;c[Ba>>2]=1;Ya=+h[(jYa(Xa,1,Ba)|0)>>3];c[Aa>>2]=11;h[(jYa(Xa,1,Aa)|0)>>3]=Ya*Ya;c[za>>2]=11;Ya=1.0/+h[(jYa(Xa,1,za)|0)>>3];c[ya>>2]=12;h[(jYa(Xa,1,ya)|0)>>3]=Ya;c[xa>>2]=12;Ya=+h[(jYa(Xa,1,xa)|0)>>3]*.23855557567849;c[wa>>2]=13;h[(jYa(Xa,1,wa)|0)>>3]=Ya;c[va>>2]=13;Ya=+h[(jYa(Xa,1,va)|0)>>3]+1.0;c[ua>>2]=14;h[(jYa(Xa,1,ua)|0)>>3]=Ya;c[ta>>2]=4;Ya=+h[(jYa(Xa,1,ta)|0)>>3]*12020.82470247;c[sa>>2]=15;h[(jYa(Xa,1,sa)|0)>>3]=Ya;c[ra>>2]=6;Ya=+h[(jYa(Xa,1,ra)|0)>>3]*-17.073846940092;c[qa>>2]=16;h[(jYa(Xa,1,qa)|0)>>3]=Ya;c[pa>>2]=15;Ya=+h[(jYa(Xa,1,pa)|0)>>3];c[oa>>2]=16;d=Ya+ +h[(jYa(Xa,1,oa)|0)>>3]+-3232555.0322333;c[na>>2]=17;h[(jYa(Xa,1,na)|0)>>3]=d;c[ma>>2]=14;d=+h[(jYa(Xa,1,ma)|0)>>3]*-4823.2657361591;c[la>>2]=18;h[(jYa(Xa,1,la)|0)>>3]=d;c[ka>>2]=14;d=+h[(jYa(Xa,1,ka)|0)>>3];c[ja>>2]=4;Ya=d*+h[(jYa(Xa,1,ja)|0)>>3]*29.83021722706;c[ia>>2]=19;h[(jYa(Xa,1,ia)|0)>>3]=Ya;c[ha>>2]=18;Ya=+h[(jYa(Xa,1,ha)|0)>>3];c[ga>>2]=19;d=Ya+ +h[(jYa(Xa,1,ga)|0)>>3];c[fa>>2]=20;h[(jYa(Xa,1,fa)|0)>>3]=d;c[ea>>2]=4;d=+h[(jYa(Xa,1,ea)|0)>>3]*1167.0521452767;c[da>>2]=21;h[(jYa(Xa,1,da)|0)>>3]=d;c[ca>>2]=21;d=+h[(jYa(Xa,1,ca)|0)>>3];c[ba>>2]=6;Ya=d+ +h[(jYa(Xa,1,ba)|0)>>3]+-724213.16703206;c[aa>>2]=22;h[(jYa(Xa,1,aa)|0)>>3]=Ya;c[$>>2]=17;Ya=+h[(jYa(Xa,1,$)|0)>>3];c[_>>2]=23;h[(jYa(Xa,1,_)|0)>>3]=Ya*Ya;c[Z>>2]=22;Ya=+h[(jYa(Xa,1,Z)|0)>>3];c[Y>>2]=8;d=Ya*+h[(jYa(Xa,1,Y)|0)>>3]*-4.0;c[X>>2]=24;h[(jYa(Xa,1,X)|0)>>3]=d;c[W>>2]=23;d=+h[(jYa(Xa,1,W)|0)>>3];c[U>>2]=24;Ya=d+ +h[(jYa(Xa,1,U)|0)>>3];c[T>>2]=25;h[(jYa(Xa,1,T)|0)>>3]=Ya;c[S>>2]=25;Ya=+h[(jYa(Xa,1,S)|0)>>3];if(!(Ya>=0.0)){S=c[72300]|0;T=R;h[k>>3]=Ya;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];T=S;S=f;U=25752;c[S+0>>2]=c[U+0>>2];c[S+4>>2]=c[U+4>>2];c[S+8>>2]=c[U+8>>2];c[S+12>>2]=c[U+12>>2];c[S+16>>2]=c[U+16>>2];c[S+20>>2]=c[U+20>>2];Pe[T&127](b,f,25328,R);}d=+V(+Ya);c[Q>>2]=26;h[(jYa(Xa,1,Q)|0)>>3]=d;c[P>>2]=4;d=+h[(jYa(Xa,1,P)|0)>>3]*-12020.82470247;c[O>>2]=27;h[(jYa(Xa,1,O)|0)>>3]=d;c[N>>2]=6;d=+h[(jYa(Xa,1,N)|0)>>3]*17.073846940092;c[M>>2]=28;h[(jYa(Xa,1,M)|0)>>3]=d;c[L>>2]=26;d=+h[(jYa(Xa,1,L)|0)>>3];c[K>>2]=27;Ya=+h[(jYa(Xa,1,K)|0)>>3];c[J>>2]=28;Za=d+(Ya+ +h[(jYa(Xa,1,J)|0)>>3])+3232555.0322333;c[I>>2]=29;h[(jYa(Xa,1,I)|0)>>3]=Za;c[H>>2]=29;Za=+h[(jYa(Xa,1,H)|0)>>3];c[G>>2]=30;h[(jYa(Xa,1,G)|0)>>3]=Za*Za;c[F>>2]=30;Za=+h[(jYa(Xa,1,F)|0)>>3];c[E>>2]=31;h[(jYa(Xa,1,E)|0)>>3]=Za*Za;c[D>>2]=10;Za=+h[(jYa(Xa,1,D)|0)>>3];c[C>>2]=14;Ya=+h[(jYa(Xa,1,C)|0)>>3]*-12020.82470247;c[B>>2]=14;d=+h[(jYa(Xa,1,B)|0)>>3];c[A>>2]=4;_a=d*+h[(jYa(Xa,1,A)|0)>>3]*34.147693880184;c[z>>2]=20;d=+h[(jYa(Xa,1,z)|0)>>3];c[y>>2]=22;$a=d*+h[(jYa(Xa,1,y)|0)>>3]*-4.0;c[x>>2]=17;d=+h[(jYa(Xa,1,x)|0)>>3];c[w>>2]=14;ab=+h[(jYa(Xa,1,w)|0)>>3]*12020.82470247;c[v>>2]=14;bb=+h[(jYa(Xa,1,v)|0)>>3];c[u>>2]=4;cb=d*(ab+bb*+h[(jYa(Xa,1,u)|0)>>3]*-34.147693880184)*2.0;c[t>>2]=14;bb=+h[(jYa(Xa,1,t)|0)>>3]*1167.0521452767;c[s>>2]=14;ab=+h[(jYa(Xa,1,s)|0)>>3];c[r>>2]=4;d=bb+ab*+h[(jYa(Xa,1,r)|0)>>3]*2.0;c[q>>2]=8;ab=$a+(cb+ +h[(jYa(Xa,1,q)|0)>>3]*d*-4.0);c[p>>2]=26;d=Ya+(_a+ab/+h[(jYa(Xa,1,p)|0)>>3]*.5);c[o>>2]=31;ab=+h[(jYa(Xa,1,o)|0)>>3];c[n>>2]=29;_a=Za*(d/(ab*+h[(jYa(Xa,1,n)|0)>>3]))*-64.0;c[m>>2]=20;ab=+h[(jYa(Xa,1,m)|0)>>3];c[l>>2]=8;d=+h[(jYa(Xa,1,l)|0)>>3];c[j>>2]=9;Za=+h[(jYa(Xa,1,j)|0)>>3];c[g>>2]=31;h[a>>3]=(_a+ab*d*(Za/+h[(jYa(Xa,1,g)|0)>>3])*64.0)*1.0e6;i=e;return}



function V6(a){a=a|0;var b=0,d=0,e=0,f=0,j=0.0,k=0,l=0;b=i;d=c[(a+4|0)>>2]|0;e=c[(a+468|0)>>2]|0;h[c[e+44>>2]>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+9288>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+9288|0;h[c[e+48>>2]>>3]=+h[f>>3];j=+b$a(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+9288>>3]);d=c[(a+468|0)>>2]|0;h[c[d+52>>2]>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+44>>2]|0)+8>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+648>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+648|0;h[(c[d+48>>2]|0)+8>>3]=+h[e>>3];j=+b$a(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+648>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+52>>2]|0)+8>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+44>>2]|0)+16>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+9400>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+9400|0;h[(c[f+48>>2]|0)+16>>3]=+h[d>>3];j=+b$a(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+9400>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+52>>2]|0)+16>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+44>>2]|0)+24>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+760>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+760|0;h[(c[e+48>>2]|0)+24>>3]=+h[f>>3];j=+b$a(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+760>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+52>>2]|0)+24>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+44>>2]|0)+32>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+536>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+536|0;h[(c[d+48>>2]|0)+32>>3]=+h[e>>3];j=+b$a(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+536>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+52>>2]|0)+32>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+44>>2]|0)+40>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+9328>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+9328|0;h[(c[f+48>>2]|0)+40>>3]=+h[d>>3];j=+b$a(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+9328>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+52>>2]|0)+40>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+44>>2]|0)+48>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+688>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+688|0;h[(c[e+48>>2]|0)+48>>3]=+h[f>>3];j=+b$a(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+688>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+52>>2]|0)+48>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+44>>2]|0)+56>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+9488>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+9488|0;h[(c[d+48>>2]|0)+56>>3]=+h[e>>3];j=+b$a(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+9488>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+52>>2]|0)+56>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+44>>2]|0)+64>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4688>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+4688|0;h[(c[f+48>>2]|0)+64>>3]=+h[d>>3];j=+b$a(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4688>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+52>>2]|0)+64>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+44>>2]|0)+72>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+528>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+528|0;h[(c[e+48>>2]|0)+72>>3]=+h[f>>3];j=+b$a(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+528>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+52>>2]|0)+72>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+44>>2]|0)+80>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+9336>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+9336|0;h[(c[d+48>>2]|0)+80>>3]=+h[e>>3];j=+b$a(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+9336>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+52>>2]|0)+80>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+44>>2]|0)+88>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+696>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+696|0;h[(c[f+48>>2]|0)+88>>3]=+h[d>>3];j=+b$a(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+696>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+52>>2]|0)+88>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+44>>2]|0)+96>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+9496>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+9496|0;h[(c[e+48>>2]|0)+96>>3]=+h[f>>3];j=+b$a(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+9496>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+52>>2]|0)+96>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+44>>2]|0)+104>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+4696>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+4696|0;h[(c[d+48>>2]|0)+104>>3]=+h[e>>3];j=+b$a(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+4696>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+52>>2]|0)+104>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+44>>2]|0)+112>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+512>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+512|0;h[(c[f+48>>2]|0)+112>>3]=+h[d>>3];j=+b$a(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+512>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+52>>2]|0)+112>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+44>>2]|0)+120>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+520>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+520|0;h[(c[e+48>>2]|0)+120>>3]=+h[f>>3];j=+b$a(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+520>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+52>>2]|0)+120>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+44>>2]|0)+128>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+488>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+488|0;h[(c[d+48>>2]|0)+128>>3]=+h[e>>3];j=+b$a(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+488>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+52>>2]|0)+128>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+44>>2]|0)+136>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+9344>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+9344|0;h[(c[f+48>>2]|0)+136>>3]=+h[d>>3];j=+b$a(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+9344>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+52>>2]|0)+136>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+44>>2]|0)+144>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+704>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+704|0;h[(c[e+48>>2]|0)+144>>3]=+h[f>>3];j=+b$a(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+704>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+52>>2]|0)+144>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+44>>2]|0)+152>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+9504>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+9504|0;h[(c[d+48>>2]|0)+152>>3]=+h[e>>3];j=+b$a(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+9504>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+52>>2]|0)+152>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+44>>2]|0)+160>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4704>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+4704|0;h[(c[f+48>>2]|0)+160>>3]=+h[d>>3];j=+b$a(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4704>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+52>>2]|0)+160>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+44>>2]|0)+168>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+496>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+496|0;h[(c[e+48>>2]|0)+168>>3]=+h[f>>3];j=+b$a(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+496>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+52>>2]|0)+168>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+44>>2]|0)+176>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+504>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+504|0;h[(c[d+48>>2]|0)+176>>3]=+h[e>>3];j=+b$a(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+504>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+52>>2]|0)+176>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+44>>2]|0)+184>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+480>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+480|0;h[(c[f+48>>2]|0)+184>>3]=+h[d>>3];j=+b$a(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+480>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+52>>2]|0)+184>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+44>>2]|0)+192>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+9352>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+9352|0;h[(c[e+48>>2]|0)+192>>3]=+h[f>>3];j=+b$a(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+9352>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+52>>2]|0)+192>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+44>>2]|0)+200>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+712>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+712|0;h[(c[d+48>>2]|0)+200>>3]=+h[e>>3];j=+b$a(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+712>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+52>>2]|0)+200>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+44>>2]|0)+208>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+9512>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+9512|0;h[(c[f+48>>2]|0)+208>>3]=+h[d>>3];j=+b$a(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+9512>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+52>>2]|0)+208>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+44>>2]|0)+216>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+4712>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+4712|0;h[(c[e+48>>2]|0)+216>>3]=+h[f>>3];j=+b$a(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+4712>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+52>>2]|0)+216>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+44>>2]|0)+224>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+472>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+472|0;h[(c[d+48>>2]|0)+224>>3]=+h[e>>3];j=+b$a(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+472>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+52>>2]|0)+224>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+44>>2]|0)+232>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+9360>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+9360|0;h[(c[f+48>>2]|0)+232>>3]=+h[d>>3];j=+b$a(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+9360>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+52>>2]|0)+232>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+44>>2]|0)+240>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+720>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+720|0;h[(c[e+48>>2]|0)+240>>3]=+h[f>>3];j=+b$a(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+720>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+52>>2]|0)+240>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+44>>2]|0)+248>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+9520>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+9520|0;h[(c[d+48>>2]|0)+248>>3]=+h[e>>3];j=+b$a(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+9520>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+52>>2]|0)+248>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+44>>2]|0)+256>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4720>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+4720|0;h[(c[f+48>>2]|0)+256>>3]=+h[d>>3];j=+b$a(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4720>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+52>>2]|0)+256>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+44>>2]|0)+264>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+464>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+464|0;h[(c[e+48>>2]|0)+264>>3]=+h[f>>3];j=+b$a(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+464>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+52>>2]|0)+264>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+44>>2]|0)+272>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+440>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+440|0;h[(c[d+48>>2]|0)+272>>3]=+h[e>>3];j=+b$a(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+440>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+52>>2]|0)+272>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+44>>2]|0)+280>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+456>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+456|0;h[(c[f+48>>2]|0)+280>>3]=+h[d>>3];j=+b$a(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+456>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+52>>2]|0)+280>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+44>>2]|0)+288>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+9368>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+9368|0;h[(c[e+48>>2]|0)+288>>3]=+h[f>>3];j=+b$a(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+9368>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+52>>2]|0)+288>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+44>>2]|0)+296>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+728>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+728|0;h[(c[d+48>>2]|0)+296>>3]=+h[e>>3];j=+b$a(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+728>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+52>>2]|0)+296>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+44>>2]|0)+304>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+9528>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+9528|0;h[(c[f+48>>2]|0)+304>>3]=+h[d>>3];j=+b$a(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+9528>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+52>>2]|0)+304>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+44>>2]|0)+312>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+4728>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+4728|0;h[(c[e+48>>2]|0)+312>>3]=+h[f>>3];j=+b$a(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+4728>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+52>>2]|0)+312>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+44>>2]|0)+320>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+448>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+448|0;h[(c[d+48>>2]|0)+320>>3]=+h[e>>3];j=+b$a(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+448>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+52>>2]|0)+320>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+44>>2]|0)+328>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+432>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+432|0;h[(c[f+48>>2]|0)+328>>3]=+h[d>>3];j=+b$a(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+432>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+52>>2]|0)+328>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+44>>2]|0)+336>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+9376>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+9376|0;h[(c[e+48>>2]|0)+336>>3]=+h[f>>3];j=+b$a(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+9376>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+52>>2]|0)+336>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+44>>2]|0)+344>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+736>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+736|0;h[(c[d+48>>2]|0)+344>>3]=+h[e>>3];j=+b$a(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+736>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+52>>2]|0)+344>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+44>>2]|0)+352>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+9536>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+9536|0;h[(c[f+48>>2]|0)+352>>3]=+h[d>>3];j=+b$a(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+9536>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+52>>2]|0)+352>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+44>>2]|0)+360>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+4736>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+4736|0;h[(c[e+48>>2]|0)+360>>3]=+h[f>>3];j=+b$a(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+4736>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+52>>2]|0)+360>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+44>>2]|0)+368>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+424>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+424|0;h[(c[d+48>>2]|0)+368>>3]=+h[e>>3];j=+b$a(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+424>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+52>>2]|0)+368>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+44>>2]|0)+376>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+416>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+416|0;h[(c[f+48>>2]|0)+376>>3]=+h[d>>3];j=+b$a(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+416>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+52>>2]|0)+376>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+44>>2]|0)+384>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+9384>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+9384|0;h[(c[e+48>>2]|0)+384>>3]=+h[f>>3];j=+b$a(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+9384>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+52>>2]|0)+384>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+44>>2]|0)+392>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+744>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+744|0;h[(c[d+48>>2]|0)+392>>3]=+h[e>>3];j=+b$a(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+744>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+52>>2]|0)+392>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+44>>2]|0)+400>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+9544>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+9544|0;h[(c[f+48>>2]|0)+400>>3]=+h[d>>3];j=+b$a(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+9544>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+52>>2]|0)+400>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+44>>2]|0)+408>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+4744>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+4744|0;h[(c[e+48>>2]|0)+408>>3]=+h[f>>3];j=+b$a(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+4744>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+52>>2]|0)+408>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+44>>2]|0)+416>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+392>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+392|0;h[(c[d+48>>2]|0)+416>>3]=+h[e>>3];j=+b$a(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+392>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+52>>2]|0)+416>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+44>>2]|0)+424>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+408>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+408|0;h[(c[f+48>>2]|0)+424>>3]=+h[d>>3];j=+b$a(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+408>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+52>>2]|0)+424>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+44>>2]|0)+432>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+9392>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+9392|0;h[(c[e+48>>2]|0)+432>>3]=+h[f>>3];j=+b$a(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+9392>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+52>>2]|0)+432>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+44>>2]|0)+440>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+752>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+752|0;h[(c[d+48>>2]|0)+440>>3]=+h[e>>3];j=+b$a(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+752>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+52>>2]|0)+440>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+44>>2]|0)+448>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+9552>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+9552|0;h[(c[f+48>>2]|0)+448>>3]=+h[d>>3];j=+b$a(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+9552>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+52>>2]|0)+448>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+44>>2]|0)+456>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+4752>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+4752|0;h[(c[e+48>>2]|0)+456>>3]=+h[f>>3];j=+b$a(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+4752>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+52>>2]|0)+456>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+44>>2]|0)+464>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+400>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+400|0;h[(c[d+48>>2]|0)+464>>3]=+h[e>>3];j=+b$a(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+400>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+52>>2]|0)+464>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+44>>2]|0)+472>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+384>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+384|0;h[(c[f+48>>2]|0)+472>>3]=+h[d>>3];j=+b$a(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+384>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+52>>2]|0)+472>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+44>>2]|0)+480>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+4760>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+4760|0;h[(c[e+48>>2]|0)+480>>3]=+h[f>>3];j=+b$a(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+4760>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+52>>2]|0)+480>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+44>>2]|0)+488>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+9560>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+9560|0;h[(c[d+48>>2]|0)+488>>3]=+h[e>>3];j=+b$a(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+9560>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+52>>2]|0)+488>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+44>>2]|0)+496>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+376>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+376|0;h[(c[f+48>>2]|0)+496>>3]=+h[d>>3];j=+b$a(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+376>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+52>>2]|0)+496>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+44>>2]|0)+504>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+768>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+768|0;h[(c[e+48>>2]|0)+504>>3]=+h[f>>3];j=+b$a(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+768>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+52>>2]|0)+504>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+44>>2]|0)+512>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+9568>>3];c[b+8>>2]=a;c[b+1096>>2]=d;c[b+1104>>2]=f;c[b+3504>>2]=k;c[b+3512>>2]=l;c[b+5264>>2]=0;c[b+5268>>2]=0;_Modelica_Fluid_Examples_HeatExchanger_HeatExchangerSimulation_eqFunction_1550$1(b);k=c[b+3504>>2]|0;l=c[b+3512>>2]|0;c[b+8>>2]=a;c[b+3504>>2]=k;c[b+3512>>2]=l;c[b+5256>>2]=0;c[b+5260>>2]=0;_Modelica_Fluid_Examples_HeatExchanger_HeatExchangerSimulation_eqFunction_1550$0(b);H=c[b+5256>>2]|0;A=c[b+5260>>2]|0;I=+g[b+5260>>2];c[b+5256>>2]=0;c[b+5260>>2]=0;if((H|0)==5){return}}function W6(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1760>>3]=+h[b>>3]+-273.15;i=i;return}function X6(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1768>>3]=+h[b+8>>3]*1.0e-5;i=i;return}function Y6(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14512>>3]=+h[b+8>>3]*1.0e-5;i=i;return}function Z6(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2872>>3]=+h[b+3376>>3]*+h[(c[a+416>>2]|0)+1624>>3];i=i;return}function _6(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1792>>3]=+h[b+16>>3]+-273.15;i=i;return}function $6(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3376>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3192>>3]=+h[(a?e+12552|0:e+12544|0)>>3];i=b;return}function a7(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1800>>3]=+h[b+24>>3]*1.0e-5;i=i;return}function b7(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2864>>3]=+h[b+3384>>3]*+h[(c[a+416>>2]|0)+1616>>3];i=i;return}function c7(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1832>>3]=+h[b+40>>3]*1.0e-5;i=i;return}function d7(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+40>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1840>>3]=+h[d>>3];i=b;return}function e7(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3384>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+3184>>3]=+h[(a?e+12544|0:e+12536|0)>>3];i=b;return}function f7(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1824>>3]=+h[b+32>>3]+-273.15;i=i;return}function g7(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6944>>3]=+h[b+592>>3]+-273.15;i=i;return}function h7(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6952>>3]=+h[b+600>>3]*1.0e-5;i=i;return}function i7(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6984>>3]=+h[b+616>>3]*1.0e-5;i=i;return}function j7(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+616>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6992>>3]=+h[d>>3];i=b;return}function k7(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6976>>3]=+h[b+608>>3]+-273.15;i=i;return}function l7(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7008>>3]=+h[b+624>>3]+-273.15;i=i;return}function m7(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7016>>3]=+h[b+632>>3]*1.0e-5;i=i;return}function n7(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14472>>3]=+h[b+632>>3]*1.0e-5;i=i;return}function o7(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8168>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7520>>3]=+h[(a?e+10856|0:e+10848|0)>>3];i=b;return}function p7(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8160>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7528>>3]=+h[(a?e+10864|0:e+10856|0)>>3];i=b;return}function q7(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6912>>3]=+h[b+576>>3]+-273.15;i=i;return}function r7(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8152>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7536>>3]=+h[(a?e+10872|0:e+10864|0)>>3];i=b;return}function s7(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6920>>3]=+h[b+584>>3]*1.0e-5;i=i;return}function t7(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7384>>3]=+h[b+8144>>3]*+h[(c[a+416>>2]|0)+368>>3];i=i;return}function u7(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6880>>3]=+h[b+560>>3]+-273.15;i=i;return}function v7(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6888>>3]=+h[b+568>>3]*1.0e-5;i=i;return}function w7(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7392>>3]=+h[b+8136>>3]*+h[(c[a+416>>2]|0)+376>>3];i=i;return}function x7(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+568>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6896>>3]=+h[d>>3];i=b;return}function y7(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8144>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7704>>3]=+h[(a?e+12248|0:e+12240|0)>>3];i=b;return}function z7(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8144>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7544>>3]=+h[(a?e+10880|0:e+10872|0)>>3];i=b;return}function A7(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6856>>3]=+h[b+552>>3]*1.0e-5;i=i;return}function B7(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+552>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6864>>3]=+h[d>>3];i=b;return}function C7(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8136>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7712>>3]=+h[(a?e+12256|0:e+12248|0)>>3];i=b;return}function D7(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6848>>3]=+h[b+544>>3]+-273.15;i=i;return}function E7(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7400>>3]=+h[b+8128>>3]*+h[(c[a+416>>2]|0)+384>>3];i=i;return}function F7(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8136>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7552>>3]=+h[(a?e+10888|0:e+10880|0)>>3];i=b;return}function G7(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1920>>3]=+h[b+80>>3]+-273.15;i=i;return}function H7(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1952>>3]=+h[b+96>>3]+-273.15;i=i;return}function I7(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4432>>3]=+h[b+4272>>3]*+h[b+2008>>3];i=i;return}function J7(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1984>>3]=+h[b+112>>3]+-273.15;i=i;return}function K7(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2016>>3]=+h[b+128>>3]+-273.15;i=i;return}function L7(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2048>>3]=+h[b+144>>3]+-273.15;i=i;return}function M7(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2080>>3]=+h[b+160>>3]+-273.15;i=i;return}function N7(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2088>>3]=+h[b+168>>3]*1.0e-5;i=i;return}function O7(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2112>>3]=+h[b+176>>3]+-273.15;i=i;return}function P7(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2120>>3]=+h[b+184>>3]*1.0e-5;i=i;return}function Q7(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+184>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2128>>3]=+h[d>>3];i=b;return}function R7(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2144>>3]=+h[b+192>>3]+-273.15;i=i;return}function S7(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2184>>3]=+h[b+216>>3]*1.0e-5;i=i;return}function T7(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+216>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2192>>3]=+h[d>>3];i=b;return}function U7(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2176>>3]=+h[b+208>>3]+-273.15;i=i;return}function V7(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2208>>3]=+h[b+224>>3]+-273.15;i=i;return}function W7(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2240>>3]=+h[b+240>>3]+-273.15;i=i;return}function X7(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2272>>3]=+h[b+256>>3]+-273.15;i=i;return}function Y7(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2344>>3]=+h[b+296>>3]*1.0e-5;i=i;return}function Z7(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+296>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2352>>3]=+h[d>>3];i=b;return}function _7(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2728>>3]=+h[b+3520>>3]*+h[(c[a+416>>2]|0)+1480>>3];i=i;return}function $7(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2336>>3]=+h[b+288>>3]+-273.15;i=i;return}function a8(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6464>>3]=+h[b+352>>3]+-273.15;i=i;return}function b8(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6472>>3]=+h[b+360>>3]*1.0e-5;i=i;return}function c8(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6496>>3]=+h[b+368>>3]+-273.15;i=i;return}function d8(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6504>>3]=+h[b+376>>3]*1.0e-5;i=i;return}function e8(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6528>>3]=+h[b+384>>3]+-273.15;i=i;return}function f8(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9088>>3]=+h[b+8928>>3]*+h[b+6584>>3];i=i;return}function g8(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6560>>3]=+h[b+400>>3]+-273.15;i=i;return}function h8(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6592>>3]=+h[b+416>>3]+-273.15;i=i;return}function i8(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6624>>3]=+h[b+432>>3]+-273.15;i=i;return}function j8(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6656>>3]=+h[b+448>>3]+-273.15;i=i;return}function k8(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6664>>3]=+h[b+456>>3]*1.0e-5;i=i;return}function l8(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6688>>3]=+h[b+464>>3]+-273.15;i=i;return}function m8(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6720>>3]=+h[b+480>>3]+-273.15;i=i;return}function n8(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6760>>3]=+h[b+504>>3]*1.0e-5;i=i;return}function o8(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6792>>3]=+h[b+520>>3]*1.0e-5;i=i;return}function p8(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+520>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6800>>3]=+h[d>>3];i=b;return}function q8(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6784>>3]=+h[b+512>>3]+-273.15;i=i;return}function r8(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8128>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7720>>3]=+h[(a?e+12264|0:e+12256|0)>>3];i=b;return}function s8(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6816>>3]=+h[b+528>>3]+-273.15;i=i;return}function t8(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8128>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7560>>3]=+h[(a?e+10896|0:e+10888|0)>>3];i=b;return}function u8(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6824>>3]=+h[b+536>>3]*1.0e-5;i=i;return}function v8(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7408>>3]=+h[b+8120>>3]*+h[(c[a+416>>2]|0)+392>>3];i=i;return}function w8(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8120>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7728>>3]=+h[(a?e+12272|0:e+12264|0)>>3];i=b;return}function x8(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+536>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6832>>3]=+h[d>>3];i=b;return}function y8(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8120>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7568>>3]=+h[(a?e+10904|0:e+10896|0)>>3];i=b;return}function z8(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9024>>3]=+h[b+8864>>3]*+h[b+6840>>3];i=i;return}function A8(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9032>>3]=+h[b+8872>>3]*+h[b+6808>>3];i=i;return}function B8(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7416>>3]=+h[b+8112>>3]*+h[(c[a+416>>2]|0)+400>>3];i=i;return}function C8(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+504>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6768>>3]=+h[d>>3];i=b;return}function D8(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6752>>3]=+h[b+496>>3]+-273.15;i=i;return}function E8(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7424>>3]=+h[b+8104>>3]*+h[(c[a+416>>2]|0)+408>>3];i=i;return}function F8(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8112>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7576>>3]=+h[(a?e+10912|0:e+10904|0)>>3];i=b;return}function G8(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8112>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7736>>3]=+h[(a?e+12280|0:e+12272|0)>>3];i=b;return}function H8(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9040>>3]=+h[b+8880>>3]*+h[b+6776>>3];i=i;return}function I8(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8104>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7584>>3]=+h[(a?e+10920|0:e+10912|0)>>3];i=b;return}function J8(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6728>>3]=+h[b+488>>3]*1.0e-5;i=i;return}function K8(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;kE(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+488>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6736>>3]=+h[d>>3];i=b;return}function L8(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8104>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7744>>3]=+h[(a?e+12288|0:e+12280|0)>>3];i=b;return}function M8(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9048>>3]=+h[b+8888>>3]*+h[b+6744>>3];i=i;return}function N8(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7432>>3]=+h[b+8096>>3]*+h[(c[a+416>>2]|0)+416>>3];i=i;return}function O8(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8096>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7752>>3]=+h[(a?e+12296|0:e+12288|0)>>3];i=b;return}function P8(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(D_a(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+8096>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+7592>>3]=+h[(a?e+10928|0:e+10920|0)>>3];i=b;return}function Q8(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6696>>3]=+h[b+472>>3]*1.0e-5;i=i;return}function R8(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7448>>3]=+h[b+8080>>3]*+h[(c[a+416>>2]|0)+432>>3];i=i;return}function S8(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7440>>3]=+h[b+8088>>3]*+h[(c[a+416>>2]|0)+424>>3];i=i;return}function _Modelica_Fluid_Examples_HeatExchanger_HeatExchangerSimulation_eqFunction_1550$0(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=c[a+8>>2]|0;d=c[a+3504>>2]|0;e=c[a+3512>>2]|0;a:do{f=+b$a(b,+h[e>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+552>>3]);g=c[(b+468|0)>>2]|0;h[(c[g+52>>2]|0)+1048>>3]=f;j=c[(b+4|0)>>2]|0;h[(c[g+44>>2]|0)+1056>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+568>>3];k=(c[(c[j+4>>2]|0)+8>>2]|0)+568|0;h[(c[g+48>>2]|0)+1056>>3]=+h[k>>3];f=+b$a(b,+h[k>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+568>>3]);j=c[(b+468|0)>>2]|0;h[(c[j+52>>2]|0)+1056>>3]=f;k=c[(b+4|0)>>2]|0;h[(c[j+44>>2]|0)+1064>>3]=+h[(c[(c[k>>2]|0)+8>>2]|0)+560>>3];g=(c[(c[k+4>>2]|0)+8>>2]|0)+560|0;h[(c[j+48>>2]|0)+1064>>3]=+h[g>>3];f=+b$a(b,+h[g>>3],+h[(c[(c[k+8>>2]|0)+8>>2]|0)+560>>3]);k=c[(b+468|0)>>2]|0;h[(c[k+52>>2]|0)+1064>>3]=f;g=c[(b+4|0)>>2]|0;h[(c[k+44>>2]|0)+1072>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+584>>3];j=(c[(c[g+4>>2]|0)+8>>2]|0)+584|0;h[(c[k+48>>2]|0)+1072>>3]=+h[j>>3];f=+b$a(b,+h[j>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+584>>3]);g=c[(b+468|0)>>2]|0;h[(c[g+52>>2]|0)+1072>>3]=f;j=c[(b+4|0)>>2]|0;h[(c[g+44>>2]|0)+1080>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+576>>3];k=(c[(c[j+4>>2]|0)+8>>2]|0)+576|0;h[(c[g+48>>2]|0)+1080>>3]=+h[k>>3];f=+b$a(b,+h[k>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+576>>3]);j=c[(b+468|0)>>2]|0;h[(c[j+52>>2]|0)+1080>>3]=f;k=c[(b+4|0)>>2]|0;h[(c[j+44>>2]|0)+1088>>3]=+h[(c[(c[k>>2]|0)+8>>2]|0)+9464>>3];g=(c[(c[k+4>>2]|0)+8>>2]|0)+9464|0;h[(c[j+48>>2]|0)+1088>>3]=+h[g>>3];f=+b$a(b,+h[g>>3],+h[(c[(c[k+8>>2]|0)+8>>2]|0)+9464>>3]);k=c[(b+468|0)>>2]|0;h[(c[k+52>>2]|0)+1088>>3]=f;g=c[(b+4|0)>>2]|0;h[(c[k+44>>2]|0)+1096>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+4664>>3];j=(c[(c[g+4>>2]|0)+8>>2]|0)+4664|0;h[(c[k+48>>2]|0)+1096>>3]=+h[j>>3];f=+b$a(b,+h[j>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+4664>>3]);g=c[(b+468|0)>>2]|0;h[(c[g+52>>2]|0)+1096>>3]=f;j=c[(b+4|0)>>2]|0;h[(c[g+44>>2]|0)+1104>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+9440>>3];k=(c[(c[j+4>>2]|0)+8>>2]|0)+9440|0;h[(c[g+48>>2]|0)+1104>>3]=+h[k>>3];f=+b$a(b,+h[k>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+9440>>3]);j=c[(b+468|0)>>2]|0;h[(c[j+52>>2]|0)+1104>>3]=f;k=c[(b+4|0)>>2]|0;h[(c[j+44>>2]|0)+1112>>3]=+h[(c[(c[k>>2]|0)+8>>2]|0)+4640>>3];g=(c[(c[k+4>>2]|0)+8>>2]|0)+4640|0;h[(c[j+48>>2]|0)+1112>>3]=+h[g>>3];f=+b$a(b,+h[g>>3],+h[(c[(c[k+8>>2]|0)+8>>2]|0)+4640>>3]);k=c[(b+468|0)>>2]|0;h[(c[k+52>>2]|0)+1112>>3]=f;g=c[(b+4|0)>>2]|0;h[(c[k+44>>2]|0)+1120>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+632>>3];j=(c[(c[g+4>>2]|0)+8>>2]|0)+632|0;h[(c[k+48>>2]|0)+1120>>3]=+h[j>>3];f=+b$a(b,+h[j>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+632>>3]);g=c[(b+468|0)>>2]|0;h[(c[g+52>>2]|0)+1120>>3]=f;j=c[(b+4|0)>>2]|0;h[(c[g+44>>2]|0)+1128>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+624>>3];k=(c[(c[j+4>>2]|0)+8>>2]|0)+624|0;h[(c[g+48>>2]|0)+1128>>3]=+h[k>>3];f=+b$a(b,+h[k>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+624>>3]);j=c[(b+468|0)>>2]|0;h[(c[j+52>>2]|0)+1128>>3]=f;k=c[(b+4|0)>>2]|0;h[(c[j+44>>2]|0)+1136>>3]=+h[(c[(c[k>>2]|0)+8>>2]|0)+4648>>3];g=(c[(c[k+4>>2]|0)+8>>2]|0)+4648|0;h[(c[j+48>>2]|0)+1136>>3]=+h[g>>3];f=+b$a(b,+h[g>>3],+h[(c[(c[k+8>>2]|0)+8>>2]|0)+4648>>3]);k=c[(b+468|0)>>2]|0;h[(c[k+52>>2]|0)+1136>>3]=f;g=c[(b+4|0)>>2]|0;h[(c[k+44>>2]|0)+1144>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+608>>3];j=(c[(c[g+4>>2]|0)+8>>2]|0)+608|0;h[(c[k+48>>2]|0)+1144>>3]=+h[j>>3];f=+b$a(b,+h[j>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+608>>3]);g=c[(b+468|0)>>2]|0;h[(c[g+52>>2]|0)+1144>>3]=f;j=c[(b+4|0)>>2]|0;h[(c[g+44>>2]|0)+1152>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+9448>>3];k=(c[(c[j+4>>2]|0)+8>>2]|0)+9448|0;h[(c[g+48>>2]|0)+1152>>3]=+h[k>>3];f=+b$a(b,+h[k>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+9448>>3]);j=c[(b+468|0)>>2]|0;h[(c[j+52>>2]|0)+1152>>3]=f;k=c[(b+4|0)>>2]|0;h[(c[j+44>>2]|0)+1160>>3]=+h[(c[(c[k>>2]|0)+8>>2]|0)+616>>3];g=(c[(c[k+4>>2]|0)+8>>2]|0)+616|0;h[(c[j+48>>2]|0)+1160>>3]=+h[g>>3];f=+b$a(b,+h[g>>3],+h[(c[(c[k+8>>2]|0)+8>>2]|0)+616>>3]);k=c[(b+468|0)>>2]|0;h[(c[k+52>>2]|0)+1160>>3]=f;g=c[(b+4|0)>>2]|0;h[(c[k+44>>2]|0)+1168>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+600>>3];j=(c[(c[g+4>>2]|0)+8>>2]|0)+600|0;h[(c[k+48>>2]|0)+1168>>3]=+h[j>>3];f=+b$a(b,+h[j>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+600>>3]);g=c[(b+468|0)>>2]|0;h[(c[g+52>>2]|0)+1168>>3]=f;j=c[(b+4|0)>>2]|0;h[(c[g+44>>2]|0)+1176>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+4656>>3];k=(c[(c[j+4>>2]|0)+8>>2]|0)+4656|0;h[(c[g+48>>2]|0)+1176>>3]=+h[k>>3];f=+b$a(b,+h[k>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+4656>>3]);j=c[(b+468|0)>>2]|0;h[(c[j+52>>2]|0)+1176>>3]=f;k=c[(b+4|0)>>2]|0;h[(c[j+44>>2]|0)+1184>>3]=+h[(c[(c[k>>2]|0)+8>>2]|0)+592>>3];g=(c[(c[k+4>>2]|0)+8>>2]|0)+592|0;h[(c[j+48>>2]|0)+1184>>3]=+h[g>>3];f=+b$a(b,+h[g>>3],+h[(c[(c[k+8>>2]|0)+8>>2]|0)+592>>3]);k=c[(b+468|0)>>2]|0;h[(c[k+52>>2]|0)+1184>>3]=f;g=c[(b+4|0)>>2]|0;h[(c[k+44>>2]|0)+1192>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+9456>>3];j=(c[(c[g+4>>2]|0)+8>>2]|0)+9456|0;h[(c[k+48>>2]|0)+1192>>3]=+h[j>>3];f=+b$a(b,+h[j>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+9456>>3]);g=c[(b+468|0)>>2]|0;h[(c[g+52>>2]|0)+1192>>3]=f;j=c[(b+4|0)>>2]|0;h[(c[g+44>>2]|0)+1200>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+656>>3];k=(c[(c[j+4>>2]|0)+8>>2]|0)+656|0;h[(c[g+48>>2]|0)+1200>>3]=+h[k>>3];f=+b$a(b,+h[k>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+656>>3]);j=c[(b+468|0)>>2]|0;h[(c[j+52>>2]|0)+1200>>3]=f;k=c[(b+4|0)>>2]|0;h[(c[j+44>>2]|0)+1208>>3]=+h[(c[(c[k>>2]|0)+8>>2]|0)+9296>>3];g=(c[(c[k+4>>2]|0)+8>>2]|0)+9296|0;h[(c[j+48>>2]|0)+1208>>3]=+h[g>>3];f=+b$a(b,+h[g>>3],+h[(c[(c[k+8>>2]|0)+8>>2]|0)+9296>>3]);k=c[(b+468|0)>>2]|0;h[(c[k+52>>2]|0)+1208>>3]=f;g=c[(b+4|0)>>2]|0;h[(c[k+44>>2]|0)+1216>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+32>>3];j=(c[(c[g+4>>2]|0)+8>>2]|0)+32|0;h[(c[k+48>>2]|0)+1216>>3]=+h[j>>3];f=+b$a(b,+h[j>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+32>>3]);g=c[(b+468|0)>>2]|0;h[(c[g+52>>2]|0)+1216>>3]=f;j=c[(b+4|0)>>2]|0;h[(c[g+44>>2]|0)+1224>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+40>>3];k=(c[(c[j+4>>2]|0)+8>>2]|0)+40|0;h[(c[g+48>>2]|0)+1224>>3]=+h[k>>3];f=+b$a(b,+h[k>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+40>>3]);j=c[(b+468|0)>>2]|0;h[(c[j+52>>2]|0)+1224>>3]=f;k=c[(b+4|0)>>2]|0;h[(c[j+44>>2]|0)+1232>>3]=+h[(c[(c[k>>2]|0)+8>>2]|0)+24>>3];g=(c[(c[k+4>>2]|0)+8>>2]|0)+24|0;h[(c[j+48>>2]|0)+1232>>3]=+h[g>>3];f=+b$a(b,+h[g>>3],+h[(c[(c[k+8>>2]|0)+8>>2]|0)+24>>3]);k=c[(b+468|0)>>2]|0;h[(c[k+52>>2]|0)+1232>>3]=f;g=c[(b+4|0)>>2]|0;h[(c[k+44>>2]|0)+1240>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+16>>3];j=(c[(c[g+4>>2]|0)+8>>2]|0)+16|0;h[(c[k+48>>2]|0)+1240>>3]=+h[j>>3];f=+b$a(b,+h[j>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+16>>3]);g=c[(b+468|0)>>2]|0;h[(c[g+52>>2]|0)+1240>>3]=f;j=c[(b+4|0)>>2]|0;h[(c[g+44>>2]|0)+1248>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+8>>3];k=(c[(c[j+4>>2]|0)+8>>2]|0)+8|0;h[(c[g+48>>2]|0)+1248>>3]=+h[k>>3];f=+b$a(b,+h[k>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+8>>3]);j=c[(b+468|0)>>2]|0;h[(c[j+52>>2]|0)+1248>>3]=f;k=c[(b+4|0)>>2]|0;h[(c[j+44>>2]|0)+1256>>3]=+h[c[(c[k>>2]|0)+8>>2]>>3];g=c[(c[k+4>>2]|0)+8>>2]|0;h[(c[j+48>>2]|0)+1256>>3]=+h[g>>3];f=+b$a(b,+h[g>>3],+h[c[(c[k+8>>2]|0)+8>>2]>>3]);k=c[(b+468|0)>>2]|0;h[(c[k+52>>2]|0)+1256>>3]=f;g=c[(b+4|0)>>2]|0;h[(c[k+44>>2]|0)+1264>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+9280>>3];j=(c[(c[g+4>>2]|0)+8>>2]|0)+9280|0;h[(c[k+48>>2]|0)+1264>>3]=+h[j>>3];f=+b$a(b,+h[j>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+9280>>3]);g=c[(b+468|0)>>2]|0;h[(c[g+52>>2]|0)+1264>>3]=f;j=c[(b+4|0)>>2]|0;h[(c[g+44>>2]|0)+1272>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+640>>3];k=(c[(c[j+4>>2]|0)+8>>2]|0)+640|0;h[(c[g+48>>2]|0)+1272>>3]=+h[k>>3];f=+b$a(b,+h[k>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+640>>3]);h[(c[(c[(b+468|0)>>2]|0)+52>>2]|0)+1272>>3]=f;$_a(b,0)|0;j=c[(c[(b+468|0)>>2]|0)+44>>2]|0;k=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;h[k+9288>>3]=+h[j>>3];h[k+648>>3]=+h[j+8>>3];h[k+9400>>3]=+h[j+16>>3];h[k+760>>3]=+h[j+24>>3];h[k+536>>3]=+h[j+32>>3];h[k+9328>>3]=+h[j+40>>3];h[k+688>>3]=+h[j+48>>3];h[k+9488>>3]=+h[j+56>>3];h[k+4688>>3]=+h[j+64>>3];h[k+528>>3]=+h[j+72>>3];h[k+9336>>3]=+h[j+80>>3];h[k+696>>3]=+h[j+88>>3];h[k+9496>>3]=+h[j+96>>3];h[k+4696>>3]=+h[j+104>>3];h[k+512>>3]=+h[j+112>>3];h[k+520>>3]=+h[j+120>>3];h[k+488>>3]=+h[j+128>>3];h[k+9344>>3]=+h[j+136>>3];h[k+704>>3]=+h[j+144>>3];h[k+9504>>3]=+h[j+152>>3];h[k+4704>>3]=+h[j+160>>3];h[k+496>>3]=+h[j+168>>3];h[k+504>>3]=+h[j+176>>3];h[k+480>>3]=+h[j+184>>3];j=c[(c[(b+468|0)>>2]|0)+44>>2]|0;k=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;h[k+9352>>3]=+h[j+192>>3];h[k+712>>3]=+h[j+200>>3];h[k+9512>>3]=+h[j+208>>3];h[k+4712>>3]=+h[j+216>>3];h[k+472>>3]=+h[j+224>>3];h[k+9360>>3]=+h[j+232>>3];h[k+720>>3]=+h[j+240>>3];h[k+9520>>3]=+h[j+248>>3];h[k+4720>>3]=+h[j+256>>3];h[k+464>>3]=+h[j+264>>3];h[k+440>>3]=+h[j+272>>3];h[k+456>>3]=+h[j+280>>3];h[k+9368>>3]=+h[j+288>>3];h[k+728>>3]=+h[j+296>>3];h[k+9528>>3]=+h[j+304>>3];h[k+4728>>3]=+h[j+312>>3];h[k+448>>3]=+h[j+320>>3];h[k+432>>3]=+h[j+328>>3];h[k+9376>>3]=+h[j+336>>3];h[k+736>>3]=+h[j+344>>3];h[k+9536>>3]=+h[j+352>>3];h[k+4736>>3]=+h[j+360>>3];h[k+424>>3]=+h[j+368>>3];h[k+416>>3]=+h[j+376>>3];j=c[(c[(b+468|0)>>2]|0)+44>>2]|0;k=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;h[k+9384>>3]=+h[j+384>>3];h[k+744>>3]=+h[j+392>>3];h[k+9544>>3]=+h[j+400>>3];h[k+4744>>3]=+h[j+408>>3];h[k+392>>3]=+h[j+416>>3];h[k+408>>3]=+h[j+424>>3];h[k+9392>>3]=+h[j+432>>3];h[k+752>>3]=+h[j+440>>3];h[k+9552>>3]=+h[j+448>>3];h[k+4752>>3]=+h[j+456>>3];h[k+400>>3]=+h[j+464>>3];h[k+384>>3]=+h[j+472>>3];h[k+4760>>3]=+h[j+480>>3];h[k+9560>>3]=+h[j+488>>3];h[k+376>>3]=+h[j+496>>3];h[k+768>>3]=+h[j+504>>3];h[k+9568>>3]=+h[j+512>>3];h[k+4768>>3]=+h[j+520>>3];h[k+368>>3]=+h[j+528>>3];h[k+360>>3]=+h[j+536>>3];h[k+328>>3]=+h[j+544>>3];h[k+312>>3]=+h[j+552>>3];h[k+304>>3]=+h[j+560>>3];h[k+9432>>3]=+h[j+568>>3];j=c[(c[(b+468|0)>>2]|0)+44>>2]|0;k=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;h[k+792>>3]=+h[j+576>>3];h[k+9592>>3]=+h[j+584>>3];h[k+4792>>3]=+h[j+592>>3];h[k+320>>3]=+h[j+600>>3];h[k+4784>>3]=+h[j+608>>3];h[k+336>>3]=+h[j+616>>3];h[k+344>>3]=+h[j+624>>3];h[k+4776>>3]=+h[j+632>>3];h[k+9576>>3]=+h[j+640>>3];h[k+272>>3]=+h[j+648>>3];h[k+9416>>3]=+h[j+656>>3];h[k+776>>3]=+h[j+664>>3];h[k+352>>3]=+h[j+672>>3];h[k+9584>>3]=+h[j+680>>3];h[k+784>>3]=+h[j+688>>3];h[k+9424>>3]=+h[j+696>>3];h[k+288>>3]=+h[j+704>>3];h[k+248>>3]=+h[j+712>>3];h[k+264>>3]=+h[j+720>>3];h[k+280>>3]=+h[j+728>>3];h[k+296>>3]=+h[j+736>>3];h[k+256>>3]=+h[j+744>>3];h[k+9408>>3]=+h[j+752>>3];h[k+240>>3]=+h[j+760>>3];j=c[(c[(b+468|0)>>2]|0)+44>>2]|0;k=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;h[k+232>>3]=+h[j+768>>3];h[k+224>>3]=+h[j+776>>3];h[k+200>>3]=+h[j+784>>3];h[k+208>>3]=+h[j+792>>3];h[k+216>>3]=+h[j+800>>3];h[k+192>>3]=+h[j+808>>3];h[k+184>>3]=+h[j+816>>3];h[k+176>>3]=+h[j+824>>3];h[k+664>>3]=+h[j+832>>3];h[k+9304>>3]=+h[j+840>>3];h[k+72>>3]=+h[j+848>>3];h[k+56>>3]=+h[j+856>>3];h[k+48>>3]=+h[j+864>>3];h[k+64>>3]=+h[j+872>>3];h[k+88>>3]=+h[j+880>>3];h[k+104>>3]=+h[j+888>>3];h[k+120>>3]=+h[j+896>>3];h[k+136>>3]=+h[j+904>>3];h[k+152>>3]=+h[j+912>>3];h[k+168>>3]=+h[j+920>>3];h[k+160>>3]=+h[j+928>>3];h[k+144>>3]=+h[j+936>>3];h[k+128>>3]=+h[j+944>>3];h[k+112>>3]=+h[j+952>>3];j=c[(c[(b+468|0)>>2]|0)+44>>2]|0;k=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;h[k+96>>3]=+h[j+960>>3];h[k+9312>>3]=+h[j+968>>3];h[k+4672>>3]=+h[j+976>>3];h[k+9472>>3]=+h[j+984>>3];h[k+672>>3]=+h[j+992>>3];h[k+80>>3]=+h[j+1e3>>3];h[k+9320>>3]=+h[j+1008>>3];h[k+680>>3]=+h[j+1016>>3];h[k+9480>>3]=+h[j+1024>>3];h[k+4680>>3]=+h[j+1032>>3];h[k+544>>3]=+h[j+1040>>3];h[k+552>>3]=+h[j+1048>>3];h[k+568>>3]=+h[j+1056>>3];h[k+560>>3]=+h[j+1064>>3];h[k+584>>3]=+h[j+1072>>3];h[k+576>>3]=+h[j+1080>>3];h[k+9464>>3]=+h[j+1088>>3];h[k+4664>>3]=+h[j+1096>>3];h[k+9440>>3]=+h[j+1104>>3];h[k+4640>>3]=+h[j+1112>>3];h[k+632>>3]=+h[j+1120>>3];h[k+624>>3]=+h[j+1128>>3];h[k+4648>>3]=+h[j+1136>>3];h[k+608>>3]=+h[j+1144>>3];j=c[(c[(b+468|0)>>2]|0)+44>>2]|0;k=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;h[k+9448>>3]=+h[j+1152>>3];h[k+616>>3]=+h[j+1160>>3];h[k+600>>3]=+h[j+1168>>3];h[k+4656>>3]=+h[j+1176>>3];h[k+592>>3]=+h[j+1184>>3];h[k+9456>>3]=+h[j+1192>>3];h[k+656>>3]=+h[j+1200>>3];h[k+9296>>3]=+h[j+1208>>3];h[k+32>>3]=+h[j+1216>>3];h[k+40>>3]=+h[j+1224>>3];h[k+24>>3]=+h[j+1232>>3];h[k+16>>3]=+h[j+1240>>3];h[k+8>>3]=+h[j+1248>>3];h[k>>3]=+h[j+1256>>3];h[k+9280>>3]=+h[j+1264>>3];h[k+640>>3]=+h[j+1272>>3];lF(b);mF(b);nF(b);oF(b);pF(b);qF(b);rF(b);sF(b);tF(b);uF(b);vF(b);wF(b);xF(b);yF(b);zF(b);AF(b);BF(b);CF(b);DF(b);EF(b);FF(b);GF(b);HF(b);IF(b);JF(b);KF(b);LF(b);MF(b);NF(b);OF(b);PF(b);QF(b);RF(b);SF(b);TF(b);UF(b);VF(b);WF(b);XF(b);YF(b);ZF(b);_F(b);$F(b);aG(b);bG(b);cG(b);dG(b);eG(b);fG(b);gG(b);hG(b);iG(b);jG(b);kG(b);lG(b);mG(b);nG(b);oG(b);pG(b);qG(b);rG(b);sG(b);tG(b);uG(b);vG(b);wG(b);xG(b);yG(b);zG(b);AG(b);BG(b);CG(b);DG(b);EG(b);FG(b);GG(b);HG(b);IG(b);JG(b);KG(b);LG(b);MG(b);NG(b);OG(b);PG(b);QG(b);RG(b);SG(b);TG(b);UG(b);VG(b);WG(b);XG(b);YG(b);ZG(b);_G(b);$G(b);aH(b);bH(b);cH(b);dH(b);eH(b);fH(b);gH(b);hH(b);iH(b);jH(b);kH(b);lH(b);mH(b);nH(b);oH(b);pH(b);qH(b);rH(b);sH(b);tH(b);uH(b);vH(b);wH(b);xH(b);yH(b);zH(b);AH(b);BH(b);CH(b);DH(b);EH(b);FH(b);GH(b);HH(b);IH(b);JH(b);KH(b);LH(b);MH(b);NH(b);OH(b);PH(b);QH(b);RH(b);SH(b);TH(b);UH(b);VH(b);WH(b);XH(b);YH(b);ZH(b);_H(b);$H(b);aI(b);bI(b);cI(b);dI(b);eI(b);fI(b);gI(b);hI(b);iI(b);jI(b);kI(b);lI(b);mI(b);nI(b);oI(b);pI(b);qI(b);rI(b);sI(b);tI(b);uI(b);vI(b);wI(b);xI(b);yI(b);zI(b);AI(b);BI(b);CI(b);DI(b);EI(b);FI(b);GI(b);HI(b);II(b);JI(b);KI(b);LI(b);MI(b);NI(b);OI(b);PI(b);QI(b);RI(b);SI(b);TI(b);UI(b);VI(b);WI(b);XI(b);YI(b);ZI(b);_I(b);$I(b);aJ(b);bJ(b);cJ(b);dJ(b);eJ(b);fJ(b);gJ(b);hJ(b);iJ(b);jJ(b);kJ(b);lJ(b);mJ(b);nJ(b);oJ(b);pJ(b);qJ(b);rJ(b);sJ(b);tJ(b);uJ(b);vJ(b);wJ(b);xJ(b);yJ(b);zJ(b);AJ(b);BJ(b);CJ(b);DJ(b);EJ(b);FJ(b);GJ(b);HJ(b);IJ(b);JJ(b);KJ(b);LJ(b);MJ(b);NJ(b);OJ(b);PJ(b);QJ(b);RJ(b);SJ(b);TJ(b);UJ(b);VJ(b);WJ(b);XJ(b);YJ(b);ZJ(b);_J(b);$J(b);aK(b);bK(b);cK(b);dK(b);eK(b);fK(b);gK(b);hK(b);iK(b);jK(b);kK(b);lK(b);mK(b);nK(b);oK(b);pK(b);qK(b);rK(b);sK(b);tK(b);uK(b);vK(b);wK(b);xK(b);yK(b);zK(b);AK(b);BK(b);CK(b);DK(b);EK(b);FK(b);GK(b);HK(b);IK(b);JK(b);KK(b);LK(b);MK(b);NK(b);OK(b);PK(b);QK(b);RK(b);SK(b);TK(b);UK(b);VK(b);WK(b);XK(b);YK(b);ZK(b);_K(b);$K(b);aL(b);bL(b);cL(b);dL(b);eL(b);fL(b);gL(b);hL(b);iL(b);jL(b);kL(b);lL(b);mL(b);nL(b);oL(b);pL(b);qL(b);rL(b);sL(b);tL(b);uL(b);vL(b);wL(b);xL(b);yL(b);zL(b);AL(b);BL(b);CL(b);DL(b);EL(b);FL(b);GL(b);HL(b);IL(b);JL(b);KL(b);LL(b);ML(b);NL(b);OL(b);PL(b);QL(b);RL(b);SL(b);TL(b);UL(b);VL(b);WL(b);XL(b);YL(b);ZL(b);_L(b);$L(b);aM(b);bM(b);cM(b);dM(b);eM(b);fM(b);gM(b);hM(b);iM(b);jM(b);kM(b);lM(b);mM(b);nM(b);oM(b);pM(b);qM(b);rM(b);sM(b);tM(b);uM(b);vM(b);wM(b);xM(b);yM(b);zM(b);AM(b);BM(b);CM(b);DM(b);EM(b);FM(b);GM(b);HM(b);IM(b);JM(b);KM(b);LM(b);MM(b);NM(b);OM(b);PM(b);QM(b);RM(b);SM(b);TM(b);UM(b);VM(b);WM(b);XM(b);YM(b);ZM(b);_M(b);$M(b);aN(b);bN(b);cN(b);dN(b);eN(b);fN(b);gN(b);hN(b);iN(b);jN(b);kN(b);lN(b);mN(b);nN(b);oN(b);pN(b);qN(b);rN(b);sN(b);tN(b);uN(b);vN(b);wN(b);xN(b);yN(b);zN(b);AN(b);BN(b);CN(b);DN(b);EN(b);FN(b);GN(b);HN(b);IN(b);JN(b);KN(b);LN(b);MN(b);NN(b);ON(b);PN(b);QN(b);RN(b);SN(b);TN(b);UN(b);VN(b);WN(b);XN(b);YN(b);ZN(b);_N(b);$N(b);aO(b);bO(b);cO(b);dO(b);eO(b);fO(b);gO(b);hO(b);iO(b);jO(b);kO(b);lO(b);mO(b);nO(b);oO(b);pO(b);qO(b);rO(b);sO(b);tO(b);uO(b);vO(b);wO(b);xO(b);yO(b);zO(b);AO(b);BO(b);CO(b);DO(b);EO(b);FO(b);GO(b);HO(b);IO(b);JO(b);KO(b);LO(b);MO(b);NO(b);OO(b);PO(b);QO(b);RO(b);SO(b);TO(b);UO(b);VO(b);WO(b);XO(b);YO(b);ZO(b);_O(b);$O(b);aP(b);bP(b);cP(b);dP(b);eP(b);fP(b);gP(b);hP(b);iP(b);jP(b);kP(b);lP(b);mP(b);nP(b);oP(b);pP(b);qP(b);rP(b);sP(b);tP(b);uP(b);vP(b);wP(b);xP(b);yP(b);zP(b);AP(b);BP(b);CP(b);DP(b);EP(b);FP(b);GP(b);HP(b);IP(b);JP(b);KP(b);LP(b);MP(b);NP(b);OP(b);PP(b);QP(b);RP(b);SP(b);TP(b);UP(b);VP(b);WP(b);XP(b);YP(b);ZP(b);_P(b);$P(b);aQ(b);bQ(b);cQ(b);dQ(b);eQ(b);fQ(b);gQ(b);hQ(b);iQ(b);jQ(b);kQ(b);lQ(b);mQ(b);nQ(b);oQ(b);pQ(b);qQ(b);rQ(b);sQ(b);tQ(b);uQ(b);vQ(b);wQ(b);xQ(b);yQ(b);zQ(b);AQ(b);BQ(b);CQ(b);DQ(b);EQ(b);FQ(b);GQ(b);HQ(b);IQ(b);JQ(b);KQ(b);LQ(b);MQ(b);NQ(b);OQ(b);PQ(b);QQ(b);RQ(b);SQ(b);TQ(b);UQ(b);VQ(b);WQ(b);XQ(b);YQ(b);ZQ(b);_Q(b);$Q(b);aR(b);bR(b);cR(b);dR(b);eR(b);fR(b);gR(b);hR(b);iR(b);jR(b);kR(b);lR(b);mR(b);nR(b);oR(b);pR(b);qR(b);rR(b);sR(b);tR(b);uR(b);vR(b);wR(b);xR(b);yR(b);zR(b);AR(b);BR(b);CR(b);DR(b);ER(b);FR(b);GR(b);HR(b);IR(b);JR(b);KR(b);LR(b);MR(b);NR(b);OR(b);PR(b);QR(b);RR(b);SR(b);TR(b);UR(b);VR(b);WR(b);XR(b);YR(b);ZR(b);_R(b);$R(b);aS(b);bS(b);cS(b);dS(b);eS(b);fS(b);gS(b);hS(b);iS(b);jS(b);kS(b);lS(b);mS(b);nS(b);oS(b);pS(b);qS(b);rS(b);sS(b);tS(b);uS(b);vS(b);wS(b);xS(b);yS(b);zS(b);AS(b);BS(b);CS(b);DS(b);ES(b);FS(b);GS(b);HS(b);IS(b);JS(b);KS(b);LS(b);MS(b);NS(b);OS(b);PS(b);QS(b);RS(b);SS(b);TS(b);US(b);VS(b);WS(b);XS(b);YS(b);ZS(b);_S(b);$S(b);aT(b);bT(b);cT(b);dT(b);eT(b);fT(b);gT(b);hT(b);iT(b);jT(b);kT(b);lT(b);mT(b);nT(b);oT(b);pT(b);qT(b);rT(b);sT(b);tT(b);uT(b);vT(b);wT(b);xT(b);yT(b);zT(b);AT(b);BT(b);CT(b);DT(b);ET(b);FT(b);GT(b);HT(b);IT(b);JT(b);KT(b);LT(b);MT(b);NT(b);OT(b);PT(b);QT(b);RT(b);ST(b);TT(b);UT(b);VT(b);WT(b);XT(b);YT(b);ZT(b);_T(b);$T(b);aU(b);bU(b);cU(b);dU(b);eU(b);fU(b);gU(b);hU(b);iU(b);jU(b);kU(b);lU(b);mU(b);nU(b);oU(b);pU(b);qU(b);rU(b);sU(b);tU(b);uU(b);vU(b);wU(b);xU(b);yU(b);zU(b);AU(b);BU(b);CU(b);DU(b);EU(b);FU(b);GU(b);HU(b);IU(b);JU(b);KU(b);LU(b);MU(b);NU(b);OU(b);PU(b);QU(b);RU(b);SU(b);TU(b);UU(b);VU(b);WU(b);XU(b);YU(b);ZU(b);_U(b);$U(b);aV(b);bV(b);cV(b);dV(b);eV(b);fV(b);gV(b);hV(b);iV(b);jV(b);kV(b);lV(b);mV(b);nV(b);oV(b);pV(b);qV(b);rV(b);sV(b);tV(b);uV(b);vV(b);wV(b);xV(b);yV(b);zV(b);AV(b);BV(b);CV(b);DV(b);EV(b);FV(b);GV(b);HV(b);IV(b);JV(b);KV(b);LV(b);MV(b);NV(b);OV(b);PV(b);QV(b);RV(b);SV(b);TV(b);UV(b);VV(b);WV(b);XV(b);YV(b);i=a;c[a+5256>>2]=5;break a}while(0)}function _Modelica_Fluid_Examples_HeatExchanger_HeatExchangerSimulation_eqFunction_1550$1(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,i=0,j=0.0;b=c[a+8>>2]|0;d=c[a+1096>>2]|0;e=c[a+1104>>2]|0;f=c[a+3504>>2]|0;g=c[a+3512>>2]|0;i=(c[(c[e+4>>2]|0)+8>>2]|0)+9568|0;h[(c[d+48>>2]|0)+512>>3]=+h[i>>3];j=+b$a(b,+h[i>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+9568>>3]);e=c[(b+468|0)>>2]|0;h[(c[e+52>>2]|0)+512>>3]=j;i=c[(b+4|0)>>2]|0;h[(c[e+44>>2]|0)+520>>3]=+h[(c[(c[i>>2]|0)+8>>2]|0)+4768>>3];d=(c[(c[i+4>>2]|0)+8>>2]|0)+4768|0;h[(c[e+48>>2]|0)+520>>3]=+h[d>>3];j=+b$a(b,+h[d>>3],+h[(c[(c[i+8>>2]|0)+8>>2]|0)+4768>>3]);i=c[(b+468|0)>>2]|0;h[(c[i+52>>2]|0)+520>>3]=j;d=c[(b+4|0)>>2]|0;h[(c[i+44>>2]|0)+528>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+368>>3];e=(c[(c[d+4>>2]|0)+8>>2]|0)+368|0;h[(c[i+48>>2]|0)+528>>3]=+h[e>>3];j=+b$a(b,+h[e>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+368>>3]);d=c[(b+468|0)>>2]|0;h[(c[d+52>>2]|0)+528>>3]=j;e=c[(b+4|0)>>2]|0;h[(c[d+44>>2]|0)+536>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+360>>3];i=(c[(c[e+4>>2]|0)+8>>2]|0)+360|0;h[(c[d+48>>2]|0)+536>>3]=+h[i>>3];j=+b$a(b,+h[i>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+360>>3]);e=c[(b+468|0)>>2]|0;h[(c[e+52>>2]|0)+536>>3]=j;i=c[(b+4|0)>>2]|0;h[(c[e+44>>2]|0)+544>>3]=+h[(c[(c[i>>2]|0)+8>>2]|0)+328>>3];d=(c[(c[i+4>>2]|0)+8>>2]|0)+328|0;h[(c[e+48>>2]|0)+544>>3]=+h[d>>3];j=+b$a(b,+h[d>>3],+h[(c[(c[i+8>>2]|0)+8>>2]|0)+328>>3]);i=c[(b+468|0)>>2]|0;h[(c[i+52>>2]|0)+544>>3]=j;d=c[(b+4|0)>>2]|0;h[(c[i+44>>2]|0)+552>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+312>>3];e=(c[(c[d+4>>2]|0)+8>>2]|0)+312|0;h[(c[i+48>>2]|0)+552>>3]=+h[e>>3];j=+b$a(b,+h[e>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+312>>3]);d=c[(b+468|0)>>2]|0;h[(c[d+52>>2]|0)+552>>3]=j;e=c[(b+4|0)>>2]|0;h[(c[d+44>>2]|0)+560>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+304>>3];i=(c[(c[e+4>>2]|0)+8>>2]|0)+304|0;h[(c[d+48>>2]|0)+560>>3]=+h[i>>3];j=+b$a(b,+h[i>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+304>>3]);e=c[(b+468|0)>>2]|0;h[(c[e+52>>2]|0)+560>>3]=j;i=c[(b+4|0)>>2]|0;h[(c[e+44>>2]|0)+568>>3]=+h[(c[(c[i>>2]|0)+8>>2]|0)+9432>>3];d=(c[(c[i+4>>2]|0)+8>>2]|0)+9432|0;h[(c[e+48>>2]|0)+568>>3]=+h[d>>3];j=+b$a(b,+h[d>>3],+h[(c[(c[i+8>>2]|0)+8>>2]|0)+9432>>3]);i=c[(b+468|0)>>2]|0;h[(c[i+52>>2]|0)+568>>3]=j;d=c[(b+4|0)>>2]|0;h[(c[i+44>>2]|0)+576>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+792>>3];e=(c[(c[d+4>>2]|0)+8>>2]|0)+792|0;h[(c[i+48>>2]|0)+576>>3]=+h[e>>3];j=+b$a(b,+h[e>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+792>>3]);d=c[(b+468|0)>>2]|0;h[(c[d+52>>2]|0)+576>>3]=j;e=c[(b+4|0)>>2]|0;h[(c[d+44>>2]|0)+584>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+9592>>3];i=(c[(c[e+4>>2]|0)+8>>2]|0)+9592|0;h[(c[d+48>>2]|0)+584>>3]=+h[i>>3];j=+b$a(b,+h[i>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+9592>>3]);e=c[(b+468|0)>>2]|0;h[(c[e+52>>2]|0)+584>>3]=j;i=c[(b+4|0)>>2]|0;h[(c[e+44>>2]|0)+592>>3]=+h[(c[(c[i>>2]|0)+8>>2]|0)+4792>>3];d=(c[(c[i+4>>2]|0)+8>>2]|0)+4792|0;h[(c[e+48>>2]|0)+592>>3]=+h[d>>3];j=+b$a(b,+h[d>>3],+h[(c[(c[i+8>>2]|0)+8>>2]|0)+4792>>3]);i=c[(b+468|0)>>2]|0;h[(c[i+52>>2]|0)+592>>3]=j;d=c[(b+4|0)>>2]|0;h[(c[i+44>>2]|0)+600>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+320>>3];e=(c[(c[d+4>>2]|0)+8>>2]|0)+320|0;h[(c[i+48>>2]|0)+600>>3]=+h[e>>3];j=+b$a(b,+h[e>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+320>>3]);d=c[(b+468|0)>>2]|0;h[(c[d+52>>2]|0)+600>>3]=j;e=c[(b+4|0)>>2]|0;h[(c[d+44>>2]|0)+608>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4784>>3];i=(c[(c[e+4>>2]|0)+8>>2]|0)+4784|0;h[(c[d+48>>2]|0)+608>>3]=+h[i>>3];j=+b$a(b,+h[i>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4784>>3]);e=c[(b+468|0)>>2]|0;h[(c[e+52>>2]|0)+608>>3]=j;i=c[(b+4|0)>>2]|0;h[(c[e+44>>2]|0)+616>>3]=+h[(c[(c[i>>2]|0)+8>>2]|0)+336>>3];d=(c[(c[i+4>>2]|0)+8>>2]|0)+336|0;h[(c[e+48>>2]|0)+616>>3]=+h[d>>3];j=+b$a(b,+h[d>>3],+h[(c[(c[i+8>>2]|0)+8>>2]|0)+336>>3]);i=c[(b+468|0)>>2]|0;h[(c[i+52>>2]|0)+616>>3]=j;d=c[(b+4|0)>>2]|0;h[(c[i+44>>2]|0)+624>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+344>>3];e=(c[(c[d+4>>2]|0)+8>>2]|0)+344|0;h[(c[i+48>>2]|0)+624>>3]=+h[e>>3];j=+b$a(b,+h[e>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+344>>3]);d=c[(b+468|0)>>2]|0;h[(c[d+52>>2]|0)+624>>3]=j;e=c[(b+4|0)>>2]|0;h[(c[d+44>>2]|0)+632>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4776>>3];i=(c[(c[e+4>>2]|0)+8>>2]|0)+4776|0;h[(c[d+48>>2]|0)+632>>3]=+h[i>>3];j=+b$a(b,+h[i>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4776>>3]);e=c[(b+468|0)>>2]|0;h[(c[e+52>>2]|0)+632>>3]=j;i=c[(b+4|0)>>2]|0;h[(c[e+44>>2]|0)+640>>3]=+h[(c[(c[i>>2]|0)+8>>2]|0)+9576>>3];d=(c[(c[i+4>>2]|0)+8>>2]|0)+9576|0;h[(c[e+48>>2]|0)+640>>3]=+h[d>>3];j=+b$a(b,+h[d>>3],+h[(c[(c[i+8>>2]|0)+8>>2]|0)+9576>>3]);i=c[(b+468|0)>>2]|0;h[(c[i+52>>2]|0)+640>>3]=j;d=c[(b+4|0)>>2]|0;h[(c[i+44>>2]|0)+648>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+272>>3];e=(c[(c[d+4>>2]|0)+8>>2]|0)+272|0;h[(c[i+48>>2]|0)+648>>3]=+h[e>>3];j=+b$a(b,+h[e>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+272>>3]);d=c[(b+468|0)>>2]|0;h[(c[d+52>>2]|0)+648>>3]=j;e=c[(b+4|0)>>2]|0;h[(c[d+44>>2]|0)+656>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+9416>>3];i=(c[(c[e+4>>2]|0)+8>>2]|0)+9416|0;h[(c[d+48>>2]|0)+656>>3]=+h[i>>3];j=+b$a(b,+h[i>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+9416>>3]);e=c[(b+468|0)>>2]|0;h[(c[e+52>>2]|0)+656>>3]=j;i=c[(b+4|0)>>2]|0;h[(c[e+44>>2]|0)+664>>3]=+h[(c[(c[i>>2]|0)+8>>2]|0)+776>>3];d=(c[(c[i+4>>2]|0)+8>>2]|0)+776|0;h[(c[e+48>>2]|0)+664>>3]=+h[d>>3];j=+b$a(b,+h[d>>3],+h[(c[(c[i+8>>2]|0)+8>>2]|0)+776>>3]);i=c[(b+468|0)>>2]|0;h[(c[i+52>>2]|0)+664>>3]=j;d=c[(b+4|0)>>2]|0;h[(c[i+44>>2]|0)+672>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+352>>3];e=(c[(c[d+4>>2]|0)+8>>2]|0)+352|0;h[(c[i+48>>2]|0)+672>>3]=+h[e>>3];j=+b$a(b,+h[e>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+352>>3]);d=c[(b+468|0)>>2]|0;h[(c[d+52>>2]|0)+672>>3]=j;e=c[(b+4|0)>>2]|0;h[(c[d+44>>2]|0)+680>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+9584>>3];i=(c[(c[e+4>>2]|0)+8>>2]|0)+9584|0;h[(c[d+48>>2]|0)+680>>3]=+h[i>>3];j=+b$a(b,+h[i>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+9584>>3]);e=c[(b+468|0)>>2]|0;h[(c[e+52>>2]|0)+680>>3]=j;i=c[(b+4|0)>>2]|0;h[(c[e+44>>2]|0)+688>>3]=+h[(c[(c[i>>2]|0)+8>>2]|0)+784>>3];d=(c[(c[i+4>>2]|0)+8>>2]|0)+784|0;h[(c[e+48>>2]|0)+688>>3]=+h[d>>3];j=+b$a(b,+h[d>>3],+h[(c[(c[i+8>>2]|0)+8>>2]|0)+784>>3]);i=c[(b+468|0)>>2]|0;h[(c[i+52>>2]|0)+688>>3]=j;d=c[(b+4|0)>>2]|0;h[(c[i+44>>2]|0)+696>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+9424>>3];e=(c[(c[d+4>>2]|0)+8>>2]|0)+9424|0;h[(c[i+48>>2]|0)+696>>3]=+h[e>>3];j=+b$a(b,+h[e>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+9424>>3]);d=c[(b+468|0)>>2]|0;h[(c[d+52>>2]|0)+696>>3]=j;e=c[(b+4|0)>>2]|0;h[(c[d+44>>2]|0)+704>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+288>>3];i=(c[(c[e+4>>2]|0)+8>>2]|0)+288|0;h[(c[d+48>>2]|0)+704>>3]=+h[i>>3];j=+b$a(b,+h[i>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+288>>3]);e=c[(b+468|0)>>2]|0;h[(c[e+52>>2]|0)+704>>3]=j;i=c[(b+4|0)>>2]|0;h[(c[e+44>>2]|0)+712>>3]=+h[(c[(c[i>>2]|0)+8>>2]|0)+248>>3];d=(c[(c[i+4>>2]|0)+8>>2]|0)+248|0;h[(c[e+48>>2]|0)+712>>3]=+h[d>>3];j=+b$a(b,+h[d>>3],+h[(c[(c[i+8>>2]|0)+8>>2]|0)+248>>3]);i=c[(b+468|0)>>2]|0;h[(c[i+52>>2]|0)+712>>3]=j;d=c[(b+4|0)>>2]|0;h[(c[i+44>>2]|0)+720>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+264>>3];e=(c[(c[d+4>>2]|0)+8>>2]|0)+264|0;h[(c[i+48>>2]|0)+720>>3]=+h[e>>3];j=+b$a(b,+h[e>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+264>>3]);d=c[(b+468|0)>>2]|0;h[(c[d+52>>2]|0)+720>>3]=j;e=c[(b+4|0)>>2]|0;h[(c[d+44>>2]|0)+728>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+280>>3];i=(c[(c[e+4>>2]|0)+8>>2]|0)+280|0;h[(c[d+48>>2]|0)+728>>3]=+h[i>>3];j=+b$a(b,+h[i>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+280>>3]);e=c[(b+468|0)>>2]|0;h[(c[e+52>>2]|0)+728>>3]=j;i=c[(b+4|0)>>2]|0;h[(c[e+44>>2]|0)+736>>3]=+h[(c[(c[i>>2]|0)+8>>2]|0)+296>>3];d=(c[(c[i+4>>2]|0)+8>>2]|0)+296|0;h[(c[e+48>>2]|0)+736>>3]=+h[d>>3];j=+b$a(b,+h[d>>3],+h[(c[(c[i+8>>2]|0)+8>>2]|0)+296>>3]);i=c[(b+468|0)>>2]|0;h[(c[i+52>>2]|0)+736>>3]=j;d=c[(b+4|0)>>2]|0;h[(c[i+44>>2]|0)+744>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+256>>3];e=(c[(c[d+4>>2]|0)+8>>2]|0)+256|0;h[(c[i+48>>2]|0)+744>>3]=+h[e>>3];j=+b$a(b,+h[e>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+256>>3]);d=c[(b+468|0)>>2]|0;h[(c[d+52>>2]|0)+744>>3]=j;e=c[(b+4|0)>>2]|0;h[(c[d+44>>2]|0)+752>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+9408>>3];i=(c[(c[e+4>>2]|0)+8>>2]|0)+9408|0;h[(c[d+48>>2]|0)+752>>3]=+h[i>>3];j=+b$a(b,+h[i>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+9408>>3]);e=c[(b+468|0)>>2]|0;h[(c[e+52>>2]|0)+752>>3]=j;i=c[(b+4|0)>>2]|0;h[(c[e+44>>2]|0)+760>>3]=+h[(c[(c[i>>2]|0)+8>>2]|0)+240>>3];d=(c[(c[i+4>>2]|0)+8>>2]|0)+240|0;h[(c[e+48>>2]|0)+760>>3]=+h[d>>3];j=+b$a(b,+h[d>>3],+h[(c[(c[i+8>>2]|0)+8>>2]|0)+240>>3]);i=c[(b+468|0)>>2]|0;h[(c[i+52>>2]|0)+760>>3]=j;d=c[(b+4|0)>>2]|0;h[(c[i+44>>2]|0)+768>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+232>>3];e=(c[(c[d+4>>2]|0)+8>>2]|0)+232|0;h[(c[i+48>>2]|0)+768>>3]=+h[e>>3];j=+b$a(b,+h[e>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+232>>3]);d=c[(b+468|0)>>2]|0;h[(c[d+52>>2]|0)+768>>3]=j;e=c[(b+4|0)>>2]|0;h[(c[d+44>>2]|0)+776>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+224>>3];i=(c[(c[e+4>>2]|0)+8>>2]|0)+224|0;h[(c[d+48>>2]|0)+776>>3]=+h[i>>3];j=+b$a(b,+h[i>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+224>>3]);e=c[(b+468|0)>>2]|0;h[(c[e+52>>2]|0)+776>>3]=j;i=c[(b+4|0)>>2]|0;h[(c[e+44>>2]|0)+784>>3]=+h[(c[(c[i>>2]|0)+8>>2]|0)+200>>3];d=(c[(c[i+4>>2]|0)+8>>2]|0)+200|0;h[(c[e+48>>2]|0)+784>>3]=+h[d>>3];j=+b$a(b,+h[d>>3],+h[(c[(c[i+8>>2]|0)+8>>2]|0)+200>>3]);i=c[(b+468|0)>>2]|0;h[(c[i+52>>2]|0)+784>>3]=j;d=c[(b+4|0)>>2]|0;h[(c[i+44>>2]|0)+792>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+208>>3];e=(c[(c[d+4>>2]|0)+8>>2]|0)+208|0;h[(c[i+48>>2]|0)+792>>3]=+h[e>>3];j=+b$a(b,+h[e>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+208>>3]);d=c[(b+468|0)>>2]|0;h[(c[d+52>>2]|0)+792>>3]=j;e=c[(b+4|0)>>2]|0;h[(c[d+44>>2]|0)+800>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+216>>3];i=(c[(c[e+4>>2]|0)+8>>2]|0)+216|0;h[(c[d+48>>2]|0)+800>>3]=+h[i>>3];j=+b$a(b,+h[i>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+216>>3]);e=c[(b+468|0)>>2]|0;h[(c[e+52>>2]|0)+800>>3]=j;i=c[(b+4|0)>>2]|0;h[(c[e+44>>2]|0)+808>>3]=+h[(c[(c[i>>2]|0)+8>>2]|0)+192>>3];d=(c[(c[i+4>>2]|0)+8>>2]|0)+192|0;h[(c[e+48>>2]|0)+808>>3]=+h[d>>3];j=+b$a(b,+h[d>>3],+h[(c[(c[i+8>>2]|0)+8>>2]|0)+192>>3]);i=c[(b+468|0)>>2]|0;h[(c[i+52>>2]|0)+808>>3]=j;d=c[(b+4|0)>>2]|0;h[(c[i+44>>2]|0)+816>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+184>>3];e=(c[(c[d+4>>2]|0)+8>>2]|0)+184|0;h[(c[i+48>>2]|0)+816>>3]=+h[e>>3];j=+b$a(b,+h[e>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+184>>3]);d=c[(b+468|0)>>2]|0;h[(c[d+52>>2]|0)+816>>3]=j;e=c[(b+4|0)>>2]|0;h[(c[d+44>>2]|0)+824>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+176>>3];i=(c[(c[e+4>>2]|0)+8>>2]|0)+176|0;h[(c[d+48>>2]|0)+824>>3]=+h[i>>3];j=+b$a(b,+h[i>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+176>>3]);e=c[(b+468|0)>>2]|0;h[(c[e+52>>2]|0)+824>>3]=j;i=c[(b+4|0)>>2]|0;h[(c[e+44>>2]|0)+832>>3]=+h[(c[(c[i>>2]|0)+8>>2]|0)+664>>3];d=(c[(c[i+4>>2]|0)+8>>2]|0)+664|0;h[(c[e+48>>2]|0)+832>>3]=+h[d>>3];j=+b$a(b,+h[d>>3],+h[(c[(c[i+8>>2]|0)+8>>2]|0)+664>>3]);i=c[(b+468|0)>>2]|0;h[(c[i+52>>2]|0)+832>>3]=j;d=c[(b+4|0)>>2]|0;h[(c[i+44>>2]|0)+840>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+9304>>3];e=(c[(c[d+4>>2]|0)+8>>2]|0)+9304|0;h[(c[i+48>>2]|0)+840>>3]=+h[e>>3];j=+b$a(b,+h[e>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+9304>>3]);d=c[(b+468|0)>>2]|0;h[(c[d+52>>2]|0)+840>>3]=j;e=c[(b+4|0)>>2]|0;h[(c[d+44>>2]|0)+848>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+72>>3];i=(c[(c[e+4>>2]|0)+8>>2]|0)+72|0;h[(c[d+48>>2]|0)+848>>3]=+h[i>>3];j=+b$a(b,+h[i>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+72>>3]);e=c[(b+468|0)>>2]|0;h[(c[e+52>>2]|0)+848>>3]=j;i=c[(b+4|0)>>2]|0;h[(c[e+44>>2]|0)+856>>3]=+h[(c[(c[i>>2]|0)+8>>2]|0)+56>>3];d=(c[(c[i+4>>2]|0)+8>>2]|0)+56|0;h[(c[e+48>>2]|0)+856>>3]=+h[d>>3];j=+b$a(b,+h[d>>3],+h[(c[(c[i+8>>2]|0)+8>>2]|0)+56>>3]);i=c[(b+468|0)>>2]|0;h[(c[i+52>>2]|0)+856>>3]=j;d=c[(b+4|0)>>2]|0;h[(c[i+44>>2]|0)+864>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+48>>3];e=(c[(c[d+4>>2]|0)+8>>2]|0)+48|0;h[(c[i+48>>2]|0)+864>>3]=+h[e>>3];j=+b$a(b,+h[e>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+48>>3]);d=c[(b+468|0)>>2]|0;h[(c[d+52>>2]|0)+864>>3]=j;e=c[(b+4|0)>>2]|0;h[(c[d+44>>2]|0)+872>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+64>>3];i=(c[(c[e+4>>2]|0)+8>>2]|0)+64|0;h[(c[d+48>>2]|0)+872>>3]=+h[i>>3];j=+b$a(b,+h[i>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+64>>3]);e=c[(b+468|0)>>2]|0;h[(c[e+52>>2]|0)+872>>3]=j;i=c[(b+4|0)>>2]|0;h[(c[e+44>>2]|0)+880>>3]=+h[(c[(c[i>>2]|0)+8>>2]|0)+88>>3];d=(c[(c[i+4>>2]|0)+8>>2]|0)+88|0;h[(c[e+48>>2]|0)+880>>3]=+h[d>>3];j=+b$a(b,+h[d>>3],+h[(c[(c[i+8>>2]|0)+8>>2]|0)+88>>3]);i=c[(b+468|0)>>2]|0;h[(c[i+52>>2]|0)+880>>3]=j;d=c[(b+4|0)>>2]|0;h[(c[i+44>>2]|0)+888>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+104>>3];e=(c[(c[d+4>>2]|0)+8>>2]|0)+104|0;h[(c[i+48>>2]|0)+888>>3]=+h[e>>3];j=+b$a(b,+h[e>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+104>>3]);d=c[(b+468|0)>>2]|0;h[(c[d+52>>2]|0)+888>>3]=j;e=c[(b+4|0)>>2]|0;h[(c[d+44>>2]|0)+896>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+120>>3];i=(c[(c[e+4>>2]|0)+8>>2]|0)+120|0;h[(c[d+48>>2]|0)+896>>3]=+h[i>>3];j=+b$a(b,+h[i>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+120>>3]);e=c[(b+468|0)>>2]|0;h[(c[e+52>>2]|0)+896>>3]=j;i=c[(b+4|0)>>2]|0;h[(c[e+44>>2]|0)+904>>3]=+h[(c[(c[i>>2]|0)+8>>2]|0)+136>>3];d=(c[(c[i+4>>2]|0)+8>>2]|0)+136|0;h[(c[e+48>>2]|0)+904>>3]=+h[d>>3];j=+b$a(b,+h[d>>3],+h[(c[(c[i+8>>2]|0)+8>>2]|0)+136>>3]);i=c[(b+468|0)>>2]|0;h[(c[i+52>>2]|0)+904>>3]=j;d=c[(b+4|0)>>2]|0;h[(c[i+44>>2]|0)+912>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+152>>3];e=(c[(c[d+4>>2]|0)+8>>2]|0)+152|0;h[(c[i+48>>2]|0)+912>>3]=+h[e>>3];j=+b$a(b,+h[e>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+152>>3]);d=c[(b+468|0)>>2]|0;h[(c[d+52>>2]|0)+912>>3]=j;e=c[(b+4|0)>>2]|0;h[(c[d+44>>2]|0)+920>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+168>>3];i=(c[(c[e+4>>2]|0)+8>>2]|0)+168|0;h[(c[d+48>>2]|0)+920>>3]=+h[i>>3];j=+b$a(b,+h[i>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+168>>3]);e=c[(b+468|0)>>2]|0;h[(c[e+52>>2]|0)+920>>3]=j;i=c[(b+4|0)>>2]|0;h[(c[e+44>>2]|0)+928>>3]=+h[(c[(c[i>>2]|0)+8>>2]|0)+160>>3];d=(c[(c[i+4>>2]|0)+8>>2]|0)+160|0;h[(c[e+48>>2]|0)+928>>3]=+h[d>>3];j=+b$a(b,+h[d>>3],+h[(c[(c[i+8>>2]|0)+8>>2]|0)+160>>3]);i=c[(b+468|0)>>2]|0;h[(c[i+52>>2]|0)+928>>3]=j;d=c[(b+4|0)>>2]|0;h[(c[i+44>>2]|0)+936>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+144>>3];e=(c[(c[d+4>>2]|0)+8>>2]|0)+144|0;h[(c[i+48>>2]|0)+936>>3]=+h[e>>3];j=+b$a(b,+h[e>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+144>>3]);d=c[(b+468|0)>>2]|0;h[(c[d+52>>2]|0)+936>>3]=j;e=c[(b+4|0)>>2]|0;h[(c[d+44>>2]|0)+944>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+128>>3];i=(c[(c[e+4>>2]|0)+8>>2]|0)+128|0;h[(c[d+48>>2]|0)+944>>3]=+h[i>>3];j=+b$a(b,+h[i>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+128>>3]);e=c[(b+468|0)>>2]|0;h[(c[e+52>>2]|0)+944>>3]=j;i=c[(b+4|0)>>2]|0;h[(c[e+44>>2]|0)+952>>3]=+h[(c[(c[i>>2]|0)+8>>2]|0)+112>>3];d=(c[(c[i+4>>2]|0)+8>>2]|0)+112|0;h[(c[e+48>>2]|0)+952>>3]=+h[d>>3];j=+b$a(b,+h[d>>3],+h[(c[(c[i+8>>2]|0)+8>>2]|0)+112>>3]);i=c[(b+468|0)>>2]|0;h[(c[i+52>>2]|0)+952>>3]=j;d=c[(b+4|0)>>2]|0;h[(c[i+44>>2]|0)+960>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+96>>3];e=(c[(c[d+4>>2]|0)+8>>2]|0)+96|0;h[(c[i+48>>2]|0)+960>>3]=+h[e>>3];j=+b$a(b,+h[e>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+96>>3]);d=c[(b+468|0)>>2]|0;h[(c[d+52>>2]|0)+960>>3]=j;e=c[(b+4|0)>>2]|0;h[(c[d+44>>2]|0)+968>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+9312>>3];i=(c[(c[e+4>>2]|0)+8>>2]|0)+9312|0;h[(c[d+48>>2]|0)+968>>3]=+h[i>>3];j=+b$a(b,+h[i>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+9312>>3]);e=c[(b+468|0)>>2]|0;h[(c[e+52>>2]|0)+968>>3]=j;i=c[(b+4|0)>>2]|0;h[(c[e+44>>2]|0)+976>>3]=+h[(c[(c[i>>2]|0)+8>>2]|0)+4672>>3];d=(c[(c[i+4>>2]|0)+8>>2]|0)+4672|0;h[(c[e+48>>2]|0)+976>>3]=+h[d>>3];j=+b$a(b,+h[d>>3],+h[(c[(c[i+8>>2]|0)+8>>2]|0)+4672>>3]);i=c[(b+468|0)>>2]|0;h[(c[i+52>>2]|0)+976>>3]=j;d=c[(b+4|0)>>2]|0;h[(c[i+44>>2]|0)+984>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+9472>>3];e=(c[(c[d+4>>2]|0)+8>>2]|0)+9472|0;h[(c[i+48>>2]|0)+984>>3]=+h[e>>3];j=+b$a(b,+h[e>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+9472>>3]);d=c[(b+468|0)>>2]|0;h[(c[d+52>>2]|0)+984>>3]=j;e=c[(b+4|0)>>2]|0;h[(c[d+44>>2]|0)+992>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+672>>3];i=(c[(c[e+4>>2]|0)+8>>2]|0)+672|0;h[(c[d+48>>2]|0)+992>>3]=+h[i>>3];j=+b$a(b,+h[i>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+672>>3]);e=c[(b+468|0)>>2]|0;h[(c[e+52>>2]|0)+992>>3]=j;i=c[(b+4|0)>>2]|0;h[(c[e+44>>2]|0)+1e3>>3]=+h[(c[(c[i>>2]|0)+8>>2]|0)+80>>3];d=(c[(c[i+4>>2]|0)+8>>2]|0)+80|0;h[(c[e+48>>2]|0)+1e3>>3]=+h[d>>3];j=+b$a(b,+h[d>>3],+h[(c[(c[i+8>>2]|0)+8>>2]|0)+80>>3]);i=c[(b+468|0)>>2]|0;h[(c[i+52>>2]|0)+1e3>>3]=j;d=c[(b+4|0)>>2]|0;h[(c[i+44>>2]|0)+1008>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+9320>>3];e=(c[(c[d+4>>2]|0)+8>>2]|0)+9320|0;h[(c[i+48>>2]|0)+1008>>3]=+h[e>>3];j=+b$a(b,+h[e>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+9320>>3]);d=c[(b+468|0)>>2]|0;h[(c[d+52>>2]|0)+1008>>3]=j;e=c[(b+4|0)>>2]|0;h[(c[d+44>>2]|0)+1016>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+680>>3];i=(c[(c[e+4>>2]|0)+8>>2]|0)+680|0;h[(c[d+48>>2]|0)+1016>>3]=+h[i>>3];j=+b$a(b,+h[i>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+680>>3]);e=c[(b+468|0)>>2]|0;h[(c[e+52>>2]|0)+1016>>3]=j;i=c[(b+4|0)>>2]|0;h[(c[e+44>>2]|0)+1024>>3]=+h[(c[(c[i>>2]|0)+8>>2]|0)+9480>>3];d=(c[(c[i+4>>2]|0)+8>>2]|0)+9480|0;h[(c[e+48>>2]|0)+1024>>3]=+h[d>>3];j=+b$a(b,+h[d>>3],+h[(c[(c[i+8>>2]|0)+8>>2]|0)+9480>>3]);i=c[(b+468|0)>>2]|0;h[(c[i+52>>2]|0)+1024>>3]=j;d=c[(b+4|0)>>2]|0;h[(c[i+44>>2]|0)+1032>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+4680>>3];e=(c[(c[d+4>>2]|0)+8>>2]|0)+4680|0;h[(c[i+48>>2]|0)+1032>>3]=+h[e>>3];j=+b$a(b,+h[e>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+4680>>3]);d=c[(b+468|0)>>2]|0;h[(c[d+52>>2]|0)+1032>>3]=j;e=c[(b+4|0)>>2]|0;h[(c[d+44>>2]|0)+1040>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+544>>3];i=(c[(c[e+4>>2]|0)+8>>2]|0)+544|0;h[(c[d+48>>2]|0)+1040>>3]=+h[i>>3];j=+b$a(b,+h[i>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+544>>3]);e=c[(b+468|0)>>2]|0;h[(c[e+52>>2]|0)+1040>>3]=j;f=c[(b+4|0)>>2]|0;h[(c[e+44>>2]|0)+1048>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+552>>3];g=(c[(c[f+4>>2]|0)+8>>2]|0)+552|0;h[(c[e+48>>2]|0)+1048>>3]=+h[g>>3];c[a+3504>>2]=f;c[a+3512>>2]=g}



function Xpb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;b=i;if((a|0)==0){i=b;return}d=a+ -8|0;e=d;f=c[330064>>2]|0;if(d>>>0<f>>>0){md()}g=c[a+ -4>>2]|0;h=g&3;if((h|0)==1){md()}j=g&-8;k=a+(j+ -8)|0;l=k;a:do{if((g&1|0)==0){m=c[d>>2]|0;if((h|0)==0){i=b;return}n=-8-m|0;o=a+n|0;p=o;q=m+j|0;if(o>>>0<f>>>0){md()}if((p|0)==(c[330068>>2]|0)){r=a+(j+ -4)|0;if((c[r>>2]&3|0)!=3){s=p;t=q;break}c[330056>>2]=q;c[r>>2]=c[r>>2]&-2;c[a+(n+4)>>2]=q|1;c[k>>2]=q;i=b;return}r=m>>>3;if(m>>>0<256){m=c[a+(n+8)>>2]|0;u=c[a+(n+12)>>2]|0;v=330088+(r<<1<<2)|0;do{if((m|0)!=(v|0)){if(m>>>0<f>>>0){md()}if((c[m+12>>2]|0)==(p|0)){break}md()}}while(0);if((u|0)==(m|0)){c[82512]=c[82512]&~(1<<r);s=p;t=q;break}do{if((u|0)==(v|0)){w=u+8|0}else{if(u>>>0<f>>>0){md()}x=u+8|0;if((c[x>>2]|0)==(p|0)){w=x;break}md()}}while(0);c[m+12>>2]=u;c[w>>2]=m;s=p;t=q;break}v=o;r=c[a+(n+24)>>2]|0;x=c[a+(n+12)>>2]|0;do{if((x|0)==(v|0)){y=a+(n+20)|0;z=y;A=c[y>>2]|0;if((A|0)==0){y=a+(n+16)|0;B=c[y>>2]|0;if((B|0)==0){C=0;break}else{D=B;E=y}}else{D=A;E=z}while(1){z=D+20|0;A=c[z>>2]|0;if((A|0)!=0){E=z;D=A;continue}A=D+16|0;z=c[A>>2]|0;if((z|0)==0){break}else{D=z;E=A}}if(E>>>0<f>>>0){md()}else{c[E>>2]=0;C=D;break}}else{A=c[a+(n+8)>>2]|0;if(A>>>0<f>>>0){md()}z=A+12|0;if((c[z>>2]|0)!=(v|0)){md()}y=x+8|0;if((c[y>>2]|0)==(v|0)){c[z>>2]=x;c[y>>2]=A;C=x;break}else{md()}}}while(0);if((r|0)==0){s=p;t=q;break}x=c[a+(n+28)>>2]|0;o=330352+(x<<2)|0;do{if((v|0)==(c[o>>2]|0)){c[o>>2]=C;if((C|0)!=0){break}c[330052>>2]=c[330052>>2]&~(1<<x);s=p;t=q;break a}else{if(r>>>0<(c[330064>>2]|0)>>>0){md()}m=r+16|0;if((c[m>>2]|0)==(v|0)){c[m>>2]=C}else{c[r+20>>2]=C}if((C|0)==0){s=p;t=q;break a}}}while(0);if(C>>>0<(c[330064>>2]|0)>>>0){md()}c[C+24>>2]=r;v=c[a+(n+16)>>2]|0;do{if((v|0)!=0){if(v>>>0<(c[330064>>2]|0)>>>0){md()}else{c[C+16>>2]=v;c[v+24>>2]=C;break}}}while(0);v=c[a+(n+20)>>2]|0;if((v|0)==0){s=p;t=q;break}if(v>>>0<(c[330064>>2]|0)>>>0){md()}else{c[C+20>>2]=v;c[v+24>>2]=C;s=p;t=q;break}}else{s=e;t=j}}while(0);if(!(s>>>0<k>>>0)){md()}e=a+(j+ -4)|0;C=c[e>>2]|0;if((C&1|0)==0){md()}do{if((C&2|0)==0){if((l|0)==(c[330072>>2]|0)){f=(c[330060>>2]|0)+t|0;c[330060>>2]=f;c[330072>>2]=s;c[s+4>>2]=f|1;if((s|0)!=(c[330068>>2]|0)){i=b;return}c[330068>>2]=0;c[330056>>2]=0;i=b;return}if((l|0)==(c[330068>>2]|0)){f=(c[330056>>2]|0)+t|0;c[330056>>2]=f;c[330068>>2]=s;c[s+4>>2]=f|1;c[s+f>>2]=f;i=b;return}f=(C&-8)+t|0;D=C>>>3;b:do{if(C>>>0<256){E=c[a+j>>2]|0;w=c[a+(j|4)>>2]|0;h=330088+(D<<1<<2)|0;do{if((E|0)!=(h|0)){if(E>>>0<(c[330064>>2]|0)>>>0){md()}if((c[E+12>>2]|0)==(l|0)){break}md()}}while(0);if((w|0)==(E|0)){c[82512]=c[82512]&~(1<<D);break}do{if((w|0)==(h|0)){F=w+8|0}else{if(w>>>0<(c[330064>>2]|0)>>>0){md()}d=w+8|0;if((c[d>>2]|0)==(l|0)){F=d;break}md()}}while(0);c[E+12>>2]=w;c[F>>2]=E}else{h=k;d=c[a+(j+16)>>2]|0;g=c[a+(j|4)>>2]|0;do{if((g|0)==(h|0)){v=a+(j+12)|0;r=v;x=c[v>>2]|0;if((x|0)==0){v=a+(j+8)|0;o=c[v>>2]|0;if((o|0)==0){G=0;break}else{H=o;I=v}}else{H=x;I=r}while(1){r=H+20|0;x=c[r>>2]|0;if((x|0)!=0){I=r;H=x;continue}x=H+16|0;r=c[x>>2]|0;if((r|0)==0){break}else{H=r;I=x}}if(I>>>0<(c[330064>>2]|0)>>>0){md()}else{c[I>>2]=0;G=H;break}}else{x=c[a+j>>2]|0;if(x>>>0<(c[330064>>2]|0)>>>0){md()}r=x+12|0;if((c[r>>2]|0)!=(h|0)){md()}v=g+8|0;if((c[v>>2]|0)==(h|0)){c[r>>2]=g;c[v>>2]=x;G=g;break}else{md()}}}while(0);if((d|0)==0){break}g=c[a+(j+20)>>2]|0;E=330352+(g<<2)|0;do{if((h|0)==(c[E>>2]|0)){c[E>>2]=G;if((G|0)!=0){break}c[330052>>2]=c[330052>>2]&~(1<<g);break b}else{if(d>>>0<(c[330064>>2]|0)>>>0){md()}w=d+16|0;if((c[w>>2]|0)==(h|0)){c[w>>2]=G}else{c[d+20>>2]=G}if((G|0)==0){break b}}}while(0);if(G>>>0<(c[330064>>2]|0)>>>0){md()}c[G+24>>2]=d;h=c[a+(j+8)>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[330064>>2]|0)>>>0){md()}else{c[G+16>>2]=h;c[h+24>>2]=G;break}}}while(0);h=c[a+(j+12)>>2]|0;if((h|0)==0){break}if(h>>>0<(c[330064>>2]|0)>>>0){md()}else{c[G+20>>2]=h;c[h+24>>2]=G;break}}}while(0);c[s+4>>2]=f|1;c[s+f>>2]=f;if((s|0)!=(c[330068>>2]|0)){J=f;break}c[330056>>2]=f;i=b;return}else{c[e>>2]=C&-2;c[s+4>>2]=t|1;c[s+t>>2]=t;J=t}}while(0);t=J>>>3;if(J>>>0<256){C=t<<1;e=330088+(C<<2)|0;G=c[82512]|0;j=1<<t;do{if((G&j|0)==0){c[82512]=G|j;K=330088+(C+2<<2)|0;L=e}else{t=330088+(C+2<<2)|0;a=c[t>>2]|0;if(!(a>>>0<(c[330064>>2]|0)>>>0)){K=t;L=a;break}md()}}while(0);c[K>>2]=s;c[L+12>>2]=s;c[s+8>>2]=L;c[s+12>>2]=e;i=b;return}e=s;L=J>>>8;do{if((L|0)==0){M=0}else{if(J>>>0>16777215){M=31;break}K=(L+1048320|0)>>>16&8;C=L<<K;j=(C+520192|0)>>>16&4;G=C<<j;C=(G+245760|0)>>>16&2;a=14-(j|K|C)+(G<<C>>>15)|0;M=J>>>(a+7|0)&1|a<<1}}while(0);L=330352+(M<<2)|0;c[s+28>>2]=M;c[s+20>>2]=0;c[s+16>>2]=0;a=c[330052>>2]|0;C=1<<M;c:do{if((a&C|0)==0){c[330052>>2]=a|C;c[L>>2]=e;c[s+24>>2]=L;c[s+12>>2]=s;c[s+8>>2]=s}else{G=c[L>>2]|0;if((M|0)==31){N=0}else{N=25-(M>>>1)|0}d:do{if((c[G+4>>2]&-8|0)==(J|0)){O=G}else{K=J<<N;j=G;while(1){P=j+16+(K>>>31<<2)|0;t=c[P>>2]|0;if((t|0)==0){break}if((c[t+4>>2]&-8|0)==(J|0)){O=t;break d}else{K=K<<1;j=t}}if(P>>>0<(c[330064>>2]|0)>>>0){md()}else{c[P>>2]=e;c[s+24>>2]=j;c[s+12>>2]=s;c[s+8>>2]=s;break c}}}while(0);G=O+8|0;f=c[G>>2]|0;K=c[330064>>2]|0;if(O>>>0<K>>>0){md()}if(f>>>0<K>>>0){md()}else{c[f+12>>2]=e;c[G>>2]=e;c[s+8>>2]=f;c[s+12>>2]=O;c[s+24>>2]=0;break}}}while(0);s=(c[330080>>2]|0)+ -1|0;c[330080>>2]=s;if((s|0)==0){Q=330504|0}else{i=b;return}while(1){s=c[Q>>2]|0;if((s|0)==0){break}else{Q=s+8|0}}c[330080>>2]=-1;i=b;return}function Ypb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;do{if((a|0)==0){e=0}else{f=fa(b,a)|0;if(!((b|a)>>>0>65535)){e=f;break}e=((f>>>0)/(a>>>0)|0|0)==(b|0)?f:-1}}while(0);b=Wpb(e)|0;if((b|0)==0){i=d;return b|0}if((c[b+ -4>>2]&3|0)==0){i=d;return b|0}Cqb(b|0,0,e|0)|0;i=d;return b|0}function Zpb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;if((a|0)==0){e=Wpb(b)|0;i=d;return e|0}if(b>>>0>4294967231){c[(Qc()|0)>>2]=12;e=0;i=d;return e|0}if(b>>>0<11){f=16}else{f=b+11&-8}g=_pb(a+ -8|0,f)|0;if((g|0)!=0){e=g+8|0;i=d;return e|0}g=Wpb(b)|0;if((g|0)==0){e=0;i=d;return e|0}f=c[a+ -4>>2]|0;h=(f&-8)-((f&3|0)==0?8:4)|0;Aqb(g|0,a|0,(h>>>0<b>>>0?h:b)|0)|0;Xpb(a);e=g;i=d;return e|0}function _pb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;e=a+4|0;f=c[e>>2]|0;g=f&-8;h=a;j=a+g|0;k=j;l=c[330064>>2]|0;if(h>>>0<l>>>0){md()}m=f&3;if(!((m|0)!=1&h>>>0<j>>>0)){md()}h=a+(g|4)|0;n=c[h>>2]|0;if((n&1|0)==0){md()}if((m|0)==0){if(b>>>0<256){o=0;i=d;return o|0}do{if(!(g>>>0<(b+4|0)>>>0)){if((g-b|0)>>>0>c[330528>>2]<<1>>>0){break}else{o=a}i=d;return o|0}}while(0);o=0;i=d;return o|0}if(!(g>>>0<b>>>0)){m=g-b|0;if(!(m>>>0>15)){o=a;i=d;return o|0}c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=m|3;c[h>>2]=c[h>>2]|1;$pb(a+b|0,m);o=a;i=d;return o|0}if((k|0)==(c[330072>>2]|0)){m=(c[330060>>2]|0)+g|0;if(!(m>>>0>b>>>0)){o=0;i=d;return o|0}h=m-b|0;c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=h|1;c[330072>>2]=a+b;c[330060>>2]=h;o=a;i=d;return o|0}if((k|0)==(c[330068>>2]|0)){h=(c[330056>>2]|0)+g|0;if(h>>>0<b>>>0){o=0;i=d;return o|0}m=h-b|0;if(m>>>0>15){c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=m|1;c[a+h>>2]=m;p=a+(h+4)|0;c[p>>2]=c[p>>2]&-2;q=a+b|0;r=m}else{c[e>>2]=f&1|h|2;f=a+(h+4)|0;c[f>>2]=c[f>>2]|1;q=0;r=0}c[330056>>2]=r;c[330068>>2]=q;o=a;i=d;return o|0}if((n&2|0)!=0){o=0;i=d;return o|0}q=(n&-8)+g|0;if(q>>>0<b>>>0){o=0;i=d;return o|0}r=q-b|0;f=n>>>3;a:do{if(n>>>0<256){h=c[a+(g+8)>>2]|0;m=c[a+(g+12)>>2]|0;p=330088+(f<<1<<2)|0;do{if((h|0)!=(p|0)){if(h>>>0<l>>>0){md()}if((c[h+12>>2]|0)==(k|0)){break}md()}}while(0);if((m|0)==(h|0)){c[82512]=c[82512]&~(1<<f);break}do{if((m|0)==(p|0)){s=m+8|0}else{if(m>>>0<l>>>0){md()}t=m+8|0;if((c[t>>2]|0)==(k|0)){s=t;break}md()}}while(0);c[h+12>>2]=m;c[s>>2]=h}else{p=j;t=c[a+(g+24)>>2]|0;u=c[a+(g+12)>>2]|0;do{if((u|0)==(p|0)){v=a+(g+20)|0;w=v;x=c[v>>2]|0;if((x|0)==0){v=a+(g+16)|0;y=c[v>>2]|0;if((y|0)==0){z=0;break}else{A=y;B=v}}else{A=x;B=w}while(1){w=A+20|0;x=c[w>>2]|0;if((x|0)!=0){B=w;A=x;continue}x=A+16|0;w=c[x>>2]|0;if((w|0)==0){break}else{A=w;B=x}}if(B>>>0<l>>>0){md()}else{c[B>>2]=0;z=A;break}}else{x=c[a+(g+8)>>2]|0;if(x>>>0<l>>>0){md()}w=x+12|0;if((c[w>>2]|0)!=(p|0)){md()}v=u+8|0;if((c[v>>2]|0)==(p|0)){c[w>>2]=u;c[v>>2]=x;z=u;break}else{md()}}}while(0);if((t|0)==0){break}u=c[a+(g+28)>>2]|0;h=330352+(u<<2)|0;do{if((p|0)==(c[h>>2]|0)){c[h>>2]=z;if((z|0)!=0){break}c[330052>>2]=c[330052>>2]&~(1<<u);break a}else{if(t>>>0<(c[330064>>2]|0)>>>0){md()}m=t+16|0;if((c[m>>2]|0)==(p|0)){c[m>>2]=z}else{c[t+20>>2]=z}if((z|0)==0){break a}}}while(0);if(z>>>0<(c[330064>>2]|0)>>>0){md()}c[z+24>>2]=t;p=c[a+(g+16)>>2]|0;do{if((p|0)!=0){if(p>>>0<(c[330064>>2]|0)>>>0){md()}else{c[z+16>>2]=p;c[p+24>>2]=z;break}}}while(0);p=c[a+(g+20)>>2]|0;if((p|0)==0){break}if(p>>>0<(c[330064>>2]|0)>>>0){md()}else{c[z+20>>2]=p;c[p+24>>2]=z;break}}}while(0);if(r>>>0<16){c[e>>2]=q|c[e>>2]&1|2;z=a+(q|4)|0;c[z>>2]=c[z>>2]|1;o=a;i=d;return o|0}else{c[e>>2]=c[e>>2]&1|b|2;c[a+(b+4)>>2]=r|3;e=a+(q|4)|0;c[e>>2]=c[e>>2]|1;$pb(a+b|0,r);o=a;i=d;return o|0}return 0}function $pb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=i;e=a+b|0;f=e;g=c[a+4>>2]|0;a:do{if((g&1|0)==0){h=c[a>>2]|0;if((g&3|0)==0){i=d;return}j=a+(0-h)|0;k=j;l=h+b|0;m=c[330064>>2]|0;if(j>>>0<m>>>0){md()}if((k|0)==(c[330068>>2]|0)){n=a+(b+4)|0;if((c[n>>2]&3|0)!=3){o=k;p=l;break}c[330056>>2]=l;c[n>>2]=c[n>>2]&-2;c[a+(4-h)>>2]=l|1;c[e>>2]=l;i=d;return}n=h>>>3;if(h>>>0<256){q=c[a+(8-h)>>2]|0;r=c[a+(12-h)>>2]|0;s=330088+(n<<1<<2)|0;do{if((q|0)!=(s|0)){if(q>>>0<m>>>0){md()}if((c[q+12>>2]|0)==(k|0)){break}md()}}while(0);if((r|0)==(q|0)){c[82512]=c[82512]&~(1<<n);o=k;p=l;break}do{if((r|0)==(s|0)){t=r+8|0}else{if(r>>>0<m>>>0){md()}u=r+8|0;if((c[u>>2]|0)==(k|0)){t=u;break}md()}}while(0);c[q+12>>2]=r;c[t>>2]=q;o=k;p=l;break}s=j;n=c[a+(24-h)>>2]|0;u=c[a+(12-h)>>2]|0;do{if((u|0)==(s|0)){v=16-h|0;w=a+(v+4)|0;x=w;y=c[w>>2]|0;if((y|0)==0){w=a+v|0;v=c[w>>2]|0;if((v|0)==0){z=0;break}else{A=v;B=w}}else{A=y;B=x}while(1){x=A+20|0;y=c[x>>2]|0;if((y|0)!=0){B=x;A=y;continue}y=A+16|0;x=c[y>>2]|0;if((x|0)==0){break}else{A=x;B=y}}if(B>>>0<m>>>0){md()}else{c[B>>2]=0;z=A;break}}else{y=c[a+(8-h)>>2]|0;if(y>>>0<m>>>0){md()}x=y+12|0;if((c[x>>2]|0)!=(s|0)){md()}w=u+8|0;if((c[w>>2]|0)==(s|0)){c[x>>2]=u;c[w>>2]=y;z=u;break}else{md()}}}while(0);if((n|0)==0){o=k;p=l;break}u=c[a+(28-h)>>2]|0;m=330352+(u<<2)|0;do{if((s|0)==(c[m>>2]|0)){c[m>>2]=z;if((z|0)!=0){break}c[330052>>2]=c[330052>>2]&~(1<<u);o=k;p=l;break a}else{if(n>>>0<(c[330064>>2]|0)>>>0){md()}j=n+16|0;if((c[j>>2]|0)==(s|0)){c[j>>2]=z}else{c[n+20>>2]=z}if((z|0)==0){o=k;p=l;break a}}}while(0);if(z>>>0<(c[330064>>2]|0)>>>0){md()}c[z+24>>2]=n;s=16-h|0;u=c[a+s>>2]|0;do{if((u|0)!=0){if(u>>>0<(c[330064>>2]|0)>>>0){md()}else{c[z+16>>2]=u;c[u+24>>2]=z;break}}}while(0);u=c[a+(s+4)>>2]|0;if((u|0)==0){o=k;p=l;break}if(u>>>0<(c[330064>>2]|0)>>>0){md()}else{c[z+20>>2]=u;c[u+24>>2]=z;o=k;p=l;break}}else{o=a;p=b}}while(0);z=c[330064>>2]|0;if(e>>>0<z>>>0){md()}A=a+(b+4)|0;B=c[A>>2]|0;do{if((B&2|0)==0){if((f|0)==(c[330072>>2]|0)){t=(c[330060>>2]|0)+p|0;c[330060>>2]=t;c[330072>>2]=o;c[o+4>>2]=t|1;if((o|0)!=(c[330068>>2]|0)){i=d;return}c[330068>>2]=0;c[330056>>2]=0;i=d;return}if((f|0)==(c[330068>>2]|0)){t=(c[330056>>2]|0)+p|0;c[330056>>2]=t;c[330068>>2]=o;c[o+4>>2]=t|1;c[o+t>>2]=t;i=d;return}t=(B&-8)+p|0;g=B>>>3;b:do{if(B>>>0<256){u=c[a+(b+8)>>2]|0;h=c[a+(b+12)>>2]|0;n=330088+(g<<1<<2)|0;do{if((u|0)!=(n|0)){if(u>>>0<z>>>0){md()}if((c[u+12>>2]|0)==(f|0)){break}md()}}while(0);if((h|0)==(u|0)){c[82512]=c[82512]&~(1<<g);break}do{if((h|0)==(n|0)){C=h+8|0}else{if(h>>>0<z>>>0){md()}m=h+8|0;if((c[m>>2]|0)==(f|0)){C=m;break}md()}}while(0);c[u+12>>2]=h;c[C>>2]=u}else{n=e;m=c[a+(b+24)>>2]|0;j=c[a+(b+12)>>2]|0;do{if((j|0)==(n|0)){q=a+(b+20)|0;r=q;y=c[q>>2]|0;if((y|0)==0){q=a+(b+16)|0;w=c[q>>2]|0;if((w|0)==0){D=0;break}else{E=w;F=q}}else{E=y;F=r}while(1){r=E+20|0;y=c[r>>2]|0;if((y|0)!=0){F=r;E=y;continue}y=E+16|0;r=c[y>>2]|0;if((r|0)==0){break}else{E=r;F=y}}if(F>>>0<z>>>0){md()}else{c[F>>2]=0;D=E;break}}else{y=c[a+(b+8)>>2]|0;if(y>>>0<z>>>0){md()}r=y+12|0;if((c[r>>2]|0)!=(n|0)){md()}q=j+8|0;if((c[q>>2]|0)==(n|0)){c[r>>2]=j;c[q>>2]=y;D=j;break}else{md()}}}while(0);if((m|0)==0){break}j=c[a+(b+28)>>2]|0;u=330352+(j<<2)|0;do{if((n|0)==(c[u>>2]|0)){c[u>>2]=D;if((D|0)!=0){break}c[330052>>2]=c[330052>>2]&~(1<<j);break b}else{if(m>>>0<(c[330064>>2]|0)>>>0){md()}h=m+16|0;if((c[h>>2]|0)==(n|0)){c[h>>2]=D}else{c[m+20>>2]=D}if((D|0)==0){break b}}}while(0);if(D>>>0<(c[330064>>2]|0)>>>0){md()}c[D+24>>2]=m;n=c[a+(b+16)>>2]|0;do{if((n|0)!=0){if(n>>>0<(c[330064>>2]|0)>>>0){md()}else{c[D+16>>2]=n;c[n+24>>2]=D;break}}}while(0);n=c[a+(b+20)>>2]|0;if((n|0)==0){break}if(n>>>0<(c[330064>>2]|0)>>>0){md()}else{c[D+20>>2]=n;c[n+24>>2]=D;break}}}while(0);c[o+4>>2]=t|1;c[o+t>>2]=t;if((o|0)!=(c[330068>>2]|0)){G=t;break}c[330056>>2]=t;i=d;return}else{c[A>>2]=B&-2;c[o+4>>2]=p|1;c[o+p>>2]=p;G=p}}while(0);p=G>>>3;if(G>>>0<256){B=p<<1;A=330088+(B<<2)|0;D=c[82512]|0;b=1<<p;do{if((D&b|0)==0){c[82512]=D|b;H=330088+(B+2<<2)|0;I=A}else{p=330088+(B+2<<2)|0;a=c[p>>2]|0;if(!(a>>>0<(c[330064>>2]|0)>>>0)){H=p;I=a;break}md()}}while(0);c[H>>2]=o;c[I+12>>2]=o;c[o+8>>2]=I;c[o+12>>2]=A;i=d;return}A=o;I=G>>>8;do{if((I|0)==0){J=0}else{if(G>>>0>16777215){J=31;break}H=(I+1048320|0)>>>16&8;B=I<<H;b=(B+520192|0)>>>16&4;D=B<<b;B=(D+245760|0)>>>16&2;a=14-(b|H|B)+(D<<B>>>15)|0;J=G>>>(a+7|0)&1|a<<1}}while(0);I=330352+(J<<2)|0;c[o+28>>2]=J;c[o+20>>2]=0;c[o+16>>2]=0;a=c[330052>>2]|0;B=1<<J;if((a&B|0)==0){c[330052>>2]=a|B;c[I>>2]=A;c[o+24>>2]=I;c[o+12>>2]=o;c[o+8>>2]=o;i=d;return}B=c[I>>2]|0;if((J|0)==31){K=0}else{K=25-(J>>>1)|0}c:do{if((c[B+4>>2]&-8|0)==(G|0)){L=B}else{J=G<<K;I=B;while(1){M=I+16+(J>>>31<<2)|0;a=c[M>>2]|0;if((a|0)==0){break}if((c[a+4>>2]&-8|0)==(G|0)){L=a;break c}else{J=J<<1;I=a}}if(M>>>0<(c[330064>>2]|0)>>>0){md()}c[M>>2]=A;c[o+24>>2]=I;c[o+12>>2]=o;c[o+8>>2]=o;i=d;return}}while(0);M=L+8|0;G=c[M>>2]|0;B=c[330064>>2]|0;if(L>>>0<B>>>0){md()}if(G>>>0<B>>>0){md()}c[G+12>>2]=A;c[M>>2]=A;c[o+8>>2]=G;c[o+12>>2]=L;c[o+24>>2]=0;i=d;return}function aqb(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=(a|0)==0?1:a;while(1){e=Wpb(d)|0;if((e|0)!=0){f=6;break}a=c[82636]|0;c[82636]=0+a;if((a|0)==0){f=5;break}Me[a&7]()}if((f|0)==5){d=Hc(4)|0;c[d>>2]=330560;_d(d|0,330608,136)}else if((f|0)==6){i=b;return e|0}return 0}function bqb(a){a=a|0;var b=0,c=0;b=i;c=aqb(a)|0;i=b;return c|0}function cqb(a){a=a|0;var b=0;b=i;if((a|0)!=0){Xpb(a)}i=b;return}function dqb(a){a=a|0;var b=0;b=i;cqb(a);i=b;return}function eqb(a){a=a|0;var b=0;b=i;Cb(a|0);cqb(a);i=b;return}function fqb(a){a=a|0;var b=0;b=i;Cb(a|0);i=b;return}function gqb(a){a=a|0;i=i;return 330576}function hqb(){var a=0;a=Hc(4)|0;c[a>>2]=330560;_d(a|0,330608,136)}function iqb(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0,V=0.0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,ga=0,ha=0,ia=0.0,ja=0,ka=0.0,la=0,ma=0.0,na=0,oa=0.0,pa=0.0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0.0,ya=0,za=0.0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0.0,Fa=0,Ga=0.0,Ha=0.0,Ia=0,Ja=0.0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0.0,xc=0,yc=0,zc=0.0,Ac=0.0,Bc=0.0,Dc=0.0,Ec=0.0,Fc=0.0,Gc=0,Hc=0,Ic=0.0,Jc=0,Kc=0.0,Lc=0;g=i;i=i+512|0;h=g;if((e|0)==0){j=24;k=-149}else if((e|0)==2){j=53;k=-1074}else if((e|0)==1){j=53;k=-1074}else{l=0.0;i=g;return+l}e=b+4|0;m=b+100|0;do{n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;o=d[n]|0}else{o=lqb(b)|0}}while((od(o|0)|0)!=0);do{if((o|0)==43|(o|0)==45){n=1-(((o|0)==45)<<1)|0;p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;q=d[p]|0;r=n;break}else{q=lqb(b)|0;r=n;break}}else{q=o;r=1}}while(0);o=q;q=0;while(1){if((o|32|0)!=(a[330624+q|0]|0)){s=o;t=q;break}do{if(q>>>0<7){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;u=d[n]|0;break}else{u=lqb(b)|0;break}}else{u=o}}while(0);n=q+1|0;if(n>>>0<8){o=u;q=n}else{s=u;t=n;break}}do{if((t|0)==3){v=23}else if((t|0)!=8){u=(f|0)==0;if(!(t>>>0<4|u)){if((t|0)==8){break}else{v=23;break}}a:do{if((t|0)==0){q=s;o=0;while(1){if((q|32|0)!=(a[330640+o|0]|0)){w=q;x=o;break a}do{if(o>>>0<2){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;A=d[n]|0;break}else{A=lqb(b)|0;break}}else{A=q}}while(0);n=o+1|0;if(n>>>0<3){q=A;o=n}else{w=A;x=n;break}}}else{w=s;x=t}}while(0);if((x|0)==3){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;B=d[o]|0}else{B=lqb(b)|0}if((B|0)==40){C=1}else{if((c[m>>2]|0)==0){l=+y;i=g;return+l}c[e>>2]=(c[e>>2]|0)+ -1;l=+y;i=g;return+l}while(1){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;D=d[o]|0}else{D=lqb(b)|0}if(!((D+ -48|0)>>>0<10|(D+ -65|0)>>>0<26)){if(!((D+ -97|0)>>>0<26|(D|0)==95)){break}}C=C+1|0}if((D|0)==41){l=+y;i=g;return+l}o=(c[m>>2]|0)==0;if(!o){c[e>>2]=(c[e>>2]|0)+ -1}if(u){c[(Qc()|0)>>2]=22;kqb(b,0);l=0.0;i=g;return+l}if((C|0)==0|o){l=+y;i=g;return+l}else{E=C}while(1){o=E+ -1|0;c[e>>2]=(c[e>>2]|0)+ -1;if((o|0)==0){l=+y;break}else{E=o}}i=g;return+l}else if((x|0)==0){do{if((w|0)==48){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;F=d[o]|0}else{F=lqb(b)|0}if((F|32|0)!=120){if((c[m>>2]|0)==0){G=48;break}c[e>>2]=(c[e>>2]|0)+ -1;G=48;break}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;H=d[o]|0;I=0}else{H=lqb(b)|0;I=0}while(1){if((H|0)==46){v=70;break}else if((H|0)!=48){K=0;L=0;M=0;N=0;O=H;P=I;Q=0;R=0;S=1.0;T=0;V=0.0;break}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;H=d[o]|0;I=1;continue}else{H=lqb(b)|0;I=1;continue}}b:do{if((v|0)==70){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;W=d[o]|0}else{W=lqb(b)|0}if((W|0)==48){X=-1;Y=-1}else{K=0;L=0;M=0;N=0;O=W;P=I;Q=1;R=0;S=1.0;T=0;V=0.0;break}while(1){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;Z=d[o]|0}else{Z=lqb(b)|0}if((Z|0)!=48){K=X;L=Y;M=0;N=0;O=Z;P=1;Q=1;R=0;S=1.0;T=0;V=0.0;break b}o=Iqb(X|0,Y|0,-1,-1)|0;X=o;Y=J}}}while(0);c:while(1){o=O+ -48|0;do{if(o>>>0<10){_=o;v=84}else{q=O|32;n=(O|0)==46;if(!((q+ -97|0)>>>0<6|n)){$=O;break c}if(n){if((Q|0)==0){aa=M;ba=N;ca=M;da=N;ea=P;ga=1;ha=R;ia=S;ja=T;ka=V;break}else{$=46;break c}}else{_=(O|0)>57?q+ -87|0:o;v=84;break}}}while(0);if((v|0)==84){v=0;do{if((N|0)<0|(N|0)==0&M>>>0<8){la=R;ma=S;na=_+(T<<4)|0;oa=V}else{if((N|0)<0|(N|0)==0&M>>>0<14){pa=S*.0625;la=R;ma=pa;na=T;oa=V+pa*+(_|0);break}if(!((_|0)!=0&(R|0)==0)){la=R;ma=S;na=T;oa=V;break}la=1;ma=S;na=T;oa=V+S*.5}}while(0);o=Iqb(M|0,N|0,1,0)|0;aa=K;ba=L;ca=o;da=J;ea=1;ga=Q;ha=la;ia=ma;ja=na;ka=oa}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;K=aa;L=ba;M=ca;N=da;O=d[o]|0;P=ea;Q=ga;R=ha;S=ia;T=ja;V=ka;continue}else{K=aa;L=ba;M=ca;N=da;O=lqb(b)|0;P=ea;Q=ga;R=ha;S=ia;T=ja;V=ka;continue}}if((P|0)==0){o=(c[m>>2]|0)==0;if(!o){c[e>>2]=(c[e>>2]|0)+ -1}do{if(u){kqb(b,0)}else{if(o){break}q=c[e>>2]|0;c[e>>2]=q+ -1;if((Q|0)==0){break}c[e>>2]=q+ -2}}while(0);l=+(r|0)*0.0;i=g;return+l}o=(Q|0)==0;q=o?M:K;n=o?N:L;if((N|0)<0|(N|0)==0&M>>>0<8){o=M;p=N;qa=T;while(1){ra=qa<<4;sa=Iqb(o|0,p|0,1,0)|0;ta=J;if((ta|0)<0|(ta|0)==0&sa>>>0<8){qa=ra;p=ta;o=sa}else{ua=ra;break}}}else{ua=T}do{if(($|32|0)==112){o=jqb(b,f)|0;p=J;if(!((o|0)==0&(p|0)==-2147483648)){va=o;wa=p;break}if(u){kqb(b,0);l=0.0;i=g;return+l}else{if((c[m>>2]|0)==0){va=0;wa=0;break}c[e>>2]=(c[e>>2]|0)+ -1;va=0;wa=0;break}}else{if((c[m>>2]|0)==0){va=0;wa=0;break}c[e>>2]=(c[e>>2]|0)+ -1;va=0;wa=0}}while(0);p=Dqb(q|0,n|0,2)|0;o=Iqb(p|0,J|0,-32,-1)|0;p=Iqb(o|0,J|0,va|0,wa|0)|0;o=J;if((ua|0)==0){l=+(r|0)*0.0;i=g;return+l}if((o|0)>0|(o|0)==0&p>>>0>(0-k|0)>>>0){c[(Qc()|0)>>2]=34;l=+(r|0)*1.7976931348623157e+308*1.7976931348623157e+308;i=g;return+l}qa=k+ -106|0;ra=((qa|0)<0)<<31>>31;if((o|0)<(ra|0)|(o|0)==(ra|0)&p>>>0<qa>>>0){c[(Qc()|0)>>2]=34;l=+(r|0)*1.2882297539194267e-231*1.2882297539194267e-231;i=g;return+l}if((ua|0)>-1){qa=p;ra=o;sa=ua;pa=V;while(1){ta=sa<<1;if(!(pa>=.5)){xa=pa;ya=ta}else{xa=pa+-1.0;ya=ta|1}za=pa+xa;ta=Iqb(qa|0,ra|0,-1,-1)|0;Aa=J;if((ya|0)>-1){qa=ta;ra=Aa;sa=ya;pa=za}else{Ba=ta;Ca=Aa;Da=ya;Ea=za;break}}}else{Ba=p;Ca=o;Da=ua;Ea=V}sa=Hqb(32,0,k|0,((k|0)<0)<<31>>31|0)|0;ra=Iqb(Ba|0,Ca|0,sa|0,J|0)|0;sa=J;if(0>(sa|0)|0==(sa|0)&j>>>0>ra>>>0){Fa=(ra|0)<0?0:ra}else{Fa=j}do{if((Fa|0)<53){pa=+(r|0);za=+id(+(+mqb(1.0,84-Fa|0)),+pa);if(!((Fa|0)<32&Ea!=0.0)){Ga=pa;Ha=za;Ia=Da;Ja=Ea;break}ra=Da&1;Ga=pa;Ha=za;Ia=(ra^1)+Da|0;Ja=(ra|0)==0?0.0:Ea}else{Ga=+(r|0);Ha=0.0;Ia=Da;Ja=Ea}}while(0);za=Ga*Ja+(Ha+Ga*+(Ia>>>0))-Ha;if(!(za!=0.0)){c[(Qc()|0)>>2]=34}l=+nqb(za,Ba);i=g;return+l}else{G=w}}while(0);o=k+j|0;p=0-o|0;ra=G;sa=0;while(1){if((ra|0)==46){v=139;break}else if((ra|0)!=48){Ka=ra;La=0;Ma=0;Na=sa;Oa=0;break}qa=c[e>>2]|0;if(qa>>>0<(c[m>>2]|0)>>>0){c[e>>2]=qa+1;ra=d[qa]|0;sa=1;continue}else{ra=lqb(b)|0;sa=1;continue}}d:do{if((v|0)==139){ra=c[e>>2]|0;if(ra>>>0<(c[m>>2]|0)>>>0){c[e>>2]=ra+1;Pa=d[ra]|0}else{Pa=lqb(b)|0}if((Pa|0)==48){Qa=-1;Ra=-1}else{Ka=Pa;La=0;Ma=0;Na=sa;Oa=1;break}while(1){ra=c[e>>2]|0;if(ra>>>0<(c[m>>2]|0)>>>0){c[e>>2]=ra+1;Sa=d[ra]|0}else{Sa=lqb(b)|0}if((Sa|0)!=48){Ka=Sa;La=Qa;Ma=Ra;Na=1;Oa=1;break d}ra=Iqb(Qa|0,Ra|0,-1,-1)|0;Qa=ra;Ra=J}}}while(0);sa=h;c[sa>>2]=0;ra=Ka+ -48|0;qa=(Ka|0)==46;e:do{if(ra>>>0<10|qa){n=h+496|0;q=Ka;Aa=qa;ta=ra;Ta=0;Ua=0;Va=La;Wa=Ma;Xa=Na;Ya=Oa;Za=0;_a=0;$a=0;while(1){do{if(Aa){if((Ya|0)==0){ab=Ta;bb=Ua;cb=Ta;db=Ua;eb=Xa;fb=1;gb=Za;hb=_a;ib=$a}else{jb=q;kb=Ta;lb=Ua;mb=Va;nb=Wa;ob=Xa;pb=Za;qb=_a;rb=$a;break e}}else{sb=Iqb(Ta|0,Ua|0,1,0)|0;tb=J;ub=(q|0)!=48;if((_a|0)>=125){if(!ub){ab=Va;bb=Wa;cb=sb;db=tb;eb=Xa;fb=Ya;gb=Za;hb=_a;ib=$a;break}c[n>>2]=c[n>>2]|1;ab=Va;bb=Wa;cb=sb;db=tb;eb=Xa;fb=Ya;gb=Za;hb=_a;ib=$a;break}vb=h+(_a<<2)|0;if((Za|0)==0){wb=ta}else{wb=q+ -48+((c[vb>>2]|0)*10|0)|0}c[vb>>2]=wb;vb=Za+1|0;xb=(vb|0)==9;ab=Va;bb=Wa;cb=sb;db=tb;eb=1;fb=Ya;gb=xb?0:vb;hb=(xb&1)+_a|0;ib=ub?sb:$a}}while(0);sb=c[e>>2]|0;if(sb>>>0<(c[m>>2]|0)>>>0){c[e>>2]=sb+1;yb=d[sb]|0}else{yb=lqb(b)|0}sb=yb+ -48|0;ub=(yb|0)==46;if(sb>>>0<10|ub){q=yb;Aa=ub;ta=sb;Ta=cb;Ua=db;Va=ab;Wa=bb;Xa=eb;Ya=fb;Za=gb;_a=hb;$a=ib}else{zb=yb;Ab=cb;Bb=db;Cb=ab;Db=bb;Eb=eb;Fb=fb;Gb=gb;Hb=hb;Ib=ib;v=162;break}}}else{zb=Ka;Ab=0;Bb=0;Cb=La;Db=Ma;Eb=Na;Fb=Oa;Gb=0;Hb=0;Ib=0;v=162}}while(0);if((v|0)==162){ra=(Fb|0)==0;jb=zb;kb=Ab;lb=Bb;mb=ra?Ab:Cb;nb=ra?Bb:Db;ob=Eb;pb=Gb;qb=Hb;rb=Ib}ra=(ob|0)!=0;do{if(ra){if((jb|32|0)!=101){v=171;break}qa=jqb(b,f)|0;$a=J;do{if((qa|0)==0&($a|0)==-2147483648){if(u){kqb(b,0);l=0.0;i=g;return+l}else{if((c[m>>2]|0)==0){Jb=0;Kb=0;break}c[e>>2]=(c[e>>2]|0)+ -1;Jb=0;Kb=0;break}}else{Jb=qa;Kb=$a}}while(0);$a=Iqb(Jb|0,Kb|0,mb|0,nb|0)|0;Lb=$a;Mb=J}else{v=171}}while(0);do{if((v|0)==171){if(!((jb|0)>-1)){Lb=mb;Mb=nb;break}if((c[m>>2]|0)==0){Lb=mb;Mb=nb;break}c[e>>2]=(c[e>>2]|0)+ -1;Lb=mb;Mb=nb}}while(0);if(!ra){c[(Qc()|0)>>2]=22;kqb(b,0);l=0.0;i=g;return+l}u=c[sa>>2]|0;if((u|0)==0){l=+(r|0)*0.0;i=g;return+l}do{if((Lb|0)==(kb|0)&(Mb|0)==(lb|0)&((lb|0)<0|(lb|0)==0&kb>>>0<10)){if(!(j>>>0>30)){if((u>>>j|0)!=0){break}}l=+(r|0)*+(u>>>0);i=g;return+l}}while(0);u=(k|0)/-2|0;ra=((u|0)<0)<<31>>31;if((Mb|0)>(ra|0)|(Mb|0)==(ra|0)&Lb>>>0>u>>>0){c[(Qc()|0)>>2]=34;l=+(r|0)*1.7976931348623157e+308*1.7976931348623157e+308;i=g;return+l}u=k+ -106|0;ra=((u|0)<0)<<31>>31;if((Mb|0)<(ra|0)|(Mb|0)==(ra|0)&Lb>>>0<u>>>0){c[(Qc()|0)>>2]=34;l=+(r|0)*1.2882297539194267e-231*1.2882297539194267e-231;i=g;return+l}if((pb|0)==0){Nb=qb}else{if((pb|0)<9){u=h+(qb<<2)|0;ra=c[u>>2]|0;$a=pb;do{ra=ra*10|0;$a=$a+1|0;}while(($a|0)<9);c[u>>2]=ra}Nb=qb+1|0}do{if((rb|0)<9){if(!((rb|0)<=(Lb|0)&(Lb|0)<18)){break}if((Lb|0)==9){l=+(r|0)*+((c[sa>>2]|0)>>>0);i=g;return+l}if((Lb|0)<9){l=+(r|0)*+((c[sa>>2]|0)>>>0)/+(c[330656+(8-Lb<<2)>>2]|0);i=g;return+l}$a=j+27+(fa(Lb,-3)|0)|0;qa=c[sa>>2]|0;if(($a|0)<=30){if((qa>>>$a|0)!=0){break}}l=+(r|0)*+(qa>>>0)*+(c[330656+(Lb+ -10<<2)>>2]|0);i=g;return+l}}while(0);sa=(Lb|0)%9|0;if((sa|0)==0){Ob=0;Pb=0;Qb=Lb;Rb=Nb}else{ra=(Lb|0)>-1?sa:sa+9|0;sa=c[330656+(8-ra<<2)>>2]|0;do{if((Nb|0)==0){Sb=0;Tb=Lb;Ub=0}else{u=1e9/(sa|0)|0;qa=0;$a=0;_a=0;Za=Lb;while(1){Ya=h+(_a<<2)|0;Xa=c[Ya>>2]|0;Wa=((Xa>>>0)/(sa>>>0)|0)+$a|0;c[Ya>>2]=Wa;Vb=fa((Xa>>>0)%(sa>>>0)|0,u)|0;Xa=_a+1|0;if((_a|0)==(qa|0)&(Wa|0)==0){Wb=Xa&127;Xb=Za+ -9|0}else{Wb=qa;Xb=Za}if((Xa|0)==(Nb|0)){break}else{qa=Wb;Za=Xb;_a=Xa;$a=Vb}}if((Vb|0)==0){Sb=Wb;Tb=Xb;Ub=Nb;break}c[h+(Nb<<2)>>2]=Vb;Sb=Wb;Tb=Xb;Ub=Nb+1|0}}while(0);Ob=Sb;Pb=0;Qb=9-ra+Tb|0;Rb=Ub}f:while(1){sa=h+(Ob<<2)|0;if((Qb|0)<18){$a=Pb;_a=Rb;while(1){Za=0;qa=_a+127|0;u=_a;while(1){Xa=qa&127;Wa=h+(Xa<<2)|0;Ya=Dqb(c[Wa>>2]|0,0,29)|0;Va=Iqb(Ya|0,J|0,Za|0,0)|0;Ya=J;if(Ya>>>0>0|(Ya|0)==0&Va>>>0>1e9){Ua=Sqb(Va|0,Ya|0,1e9,0)|0;Ta=Tqb(Va|0,Ya|0,1e9,0)|0;Yb=Ta;Zb=Ua}else{Yb=Va;Zb=0}c[Wa>>2]=Yb;Wa=(Xa|0)==(Ob|0);if((Xa|0)!=(u+127&127|0)|Wa){_b=u}else{_b=(Yb|0)==0?Xa:u}if(Wa){break}else{Za=Zb;qa=Xa+ -1|0;u=_b}}u=$a+ -29|0;if((Zb|0)==0){$a=u;_a=_b}else{$b=u;ac=Zb;bc=_b;break}}}else{if((Qb|0)==18){cc=Pb;dc=Rb}else{ec=Ob;fc=Pb;gc=Qb;hc=Rb;break}while(1){if(!((c[sa>>2]|0)>>>0<9007199)){ec=Ob;fc=cc;gc=18;hc=dc;break f}_a=0;$a=dc+127|0;u=dc;while(1){qa=$a&127;Za=h+(qa<<2)|0;Xa=Dqb(c[Za>>2]|0,0,29)|0;Wa=Iqb(Xa|0,J|0,_a|0,0)|0;Xa=J;if(Xa>>>0>0|(Xa|0)==0&Wa>>>0>1e9){Va=Sqb(Wa|0,Xa|0,1e9,0)|0;Ua=Tqb(Wa|0,Xa|0,1e9,0)|0;ic=Ua;jc=Va}else{ic=Wa;jc=0}c[Za>>2]=ic;Za=(qa|0)==(Ob|0);if((qa|0)!=(u+127&127|0)|Za){kc=u}else{kc=(ic|0)==0?qa:u}if(Za){break}else{_a=jc;$a=qa+ -1|0;u=kc}}u=cc+ -29|0;if((jc|0)==0){cc=u;dc=kc}else{$b=u;ac=jc;bc=kc;break}}}sa=Ob+127&127;if((sa|0)==(bc|0)){u=bc+127&127;$a=h+((bc+126&127)<<2)|0;c[$a>>2]=c[$a>>2]|c[h+(u<<2)>>2];lc=u}else{lc=bc}c[h+(sa<<2)>>2]=ac;Ob=sa;Pb=$b;Qb=Qb+9|0;Rb=lc}g:while(1){mc=hc+1&127;ra=h+((hc+127&127)<<2)|0;sa=ec;u=fc;$a=gc;while(1){_a=($a|0)==18;qa=($a|0)>27?9:1;nc=sa;oc=u;while(1){Za=0;while(1){Wa=Za+nc&127;if((Wa|0)==(hc|0)){pc=2;break}Va=c[h+(Wa<<2)>>2]|0;Wa=c[330648+(Za<<2)>>2]|0;if(Va>>>0<Wa>>>0){pc=2;break}Ua=Za+1|0;if(Va>>>0>Wa>>>0){pc=Za;break}if((Ua|0)<2){Za=Ua}else{pc=Ua;break}}if((pc|0)==2&_a){break g}qc=qa+oc|0;if((nc|0)==(hc|0)){nc=hc;oc=qc}else{break}}_a=(1<<qa)+ -1|0;Za=1e9>>>qa;rc=nc;sc=0;Ua=nc;tc=$a;do{Wa=h+(Ua<<2)|0;Va=c[Wa>>2]|0;Xa=(Va>>>qa)+sc|0;c[Wa>>2]=Xa;sc=fa(Va&_a,Za)|0;Va=(Ua|0)==(rc|0)&(Xa|0)==0;Ua=Ua+1&127;tc=Va?tc+ -9|0:tc;rc=Va?Ua:rc;}while((Ua|0)!=(hc|0));if((sc|0)==0){sa=rc;u=qc;$a=tc;continue}if((mc|0)!=(rc|0)){break}c[ra>>2]=c[ra>>2]|1;sa=rc;u=qc;$a=tc}c[h+(hc<<2)>>2]=sc;ec=rc;fc=qc;gc=tc;hc=mc}$a=nc&127;if(($a|0)==(hc|0)){c[h+(mc+ -1<<2)>>2]=0;uc=mc}else{uc=hc}za=+((c[h+($a<<2)>>2]|0)>>>0);$a=nc+1&127;if(($a|0)==(uc|0)){u=uc+1&127;c[h+(u+ -1<<2)>>2]=0;vc=u}else{vc=uc}pa=+(r|0);wc=pa*(za*1.0e9+ +((c[h+($a<<2)>>2]|0)>>>0));$a=oc+53|0;u=$a-k|0;if((u|0)<(j|0)){xc=(u|0)<0?0:u;yc=1}else{xc=j;yc=0}if((xc|0)<53){za=+id(+(+mqb(1.0,105-xc|0)),+wc);zc=+Cc(+wc,+(+mqb(1.0,53-xc|0)));Ac=za;Bc=zc;Dc=za+(wc-zc)}else{Ac=0.0;Bc=0.0;Dc=wc}sa=nc+2&127;do{if((sa|0)==(vc|0)){Ec=Bc}else{ra=c[h+(sa<<2)>>2]|0;do{if(ra>>>0<5e8){if((ra|0)==0){if((nc+3&127|0)==(vc|0)){Fc=Bc;break}}Fc=pa*.25+Bc}else{if(ra>>>0>5e8){Fc=pa*.75+Bc;break}if((nc+3&127|0)==(vc|0)){Fc=pa*.5+Bc;break}else{Fc=pa*.75+Bc;break}}}while(0);if((53-xc|0)<=1){Ec=Fc;break}if(+Cc(+Fc,1.0)!=0.0){Ec=Fc;break}Ec=Fc+1.0}}while(0);pa=Dc+Ec-Ac;do{if(($a&2147483647|0)>(-2-o|0)){if(!(+U(+pa)>=9007199254740992.0)){Gc=yc;Hc=oc;Ic=pa}else{Gc=(yc|0)!=0&(xc|0)==(u|0)?0:yc;Hc=oc+1|0;Ic=pa*.5}if((Hc+50|0)<=(p|0)){if(!((Gc|0)!=0&Ec!=0.0)){Jc=Hc;Kc=Ic;break}}c[(Qc()|0)>>2]=34;Jc=Hc;Kc=Ic}else{Jc=oc;Kc=pa}}while(0);l=+nqb(Kc,Jc);i=g;return+l}else{if((c[m>>2]|0)!=0){c[e>>2]=(c[e>>2]|0)+ -1}c[(Qc()|0)>>2]=22;kqb(b,0);l=0.0;i=g;return+l}}}while(0);do{if((v|0)==23){b=(c[m>>2]|0)==0;if(!b){c[e>>2]=(c[e>>2]|0)+ -1}if(t>>>0<4|(f|0)==0|b){break}else{Lc=t}do{c[e>>2]=(c[e>>2]|0)+ -1;Lc=Lc+ -1|0;}while(Lc>>>0>3)}}while(0);l=+(r|0)*+z;i=g;return+l}function jqb(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=a+4|0;g=c[f>>2]|0;h=a+100|0;if(g>>>0<(c[h>>2]|0)>>>0){c[f>>2]=g+1;j=d[g]|0}else{j=lqb(a)|0}do{if((j|0)==43|(j|0)==45){g=(j|0)==45|0;k=c[f>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){c[f>>2]=k+1;l=d[k]|0}else{l=lqb(a)|0}if((l+ -48|0)>>>0<10|(b|0)==0){m=l;n=g;break}if((c[h>>2]|0)==0){m=l;n=g;break}c[f>>2]=(c[f>>2]|0)+ -1;m=l;n=g}else{m=j;n=0}}while(0);if((m+ -48|0)>>>0>9){if((c[h>>2]|0)==0){o=0;p=-2147483648;J=p;i=e;return o|0}c[f>>2]=(c[f>>2]|0)+ -1;o=0;p=-2147483648;J=p;i=e;return o|0}else{q=m;r=0}while(1){s=q+ -48+r|0;m=c[f>>2]|0;if(m>>>0<(c[h>>2]|0)>>>0){c[f>>2]=m+1;t=d[m]|0}else{t=lqb(a)|0}if(!((t+ -48|0)>>>0<10&(s|0)<214748364)){break}q=t;r=s*10|0}r=((s|0)<0)<<31>>31;if((t+ -48|0)>>>0<10){q=s;m=r;j=t;while(1){l=Rqb(q|0,m|0,10,0)|0;b=J;g=Iqb(j|0,((j|0)<0)<<31>>31|0,-48,-1)|0;k=Iqb(g|0,J|0,l|0,b|0)|0;b=J;l=c[f>>2]|0;if(l>>>0<(c[h>>2]|0)>>>0){c[f>>2]=l+1;u=d[l]|0}else{u=lqb(a)|0}if((u+ -48|0)>>>0<10&((b|0)<21474836|(b|0)==21474836&k>>>0<2061584302)){j=u;m=b;q=k}else{v=k;w=b;x=u;break}}}else{v=s;w=r;x=t}if((x+ -48|0)>>>0<10){do{x=c[f>>2]|0;if(x>>>0<(c[h>>2]|0)>>>0){c[f>>2]=x+1;y=d[x]|0}else{y=lqb(a)|0}}while((y+ -48|0)>>>0<10)}if((c[h>>2]|0)!=0){c[f>>2]=(c[f>>2]|0)+ -1}f=(n|0)!=0;n=Hqb(0,0,v|0,w|0)|0;o=f?n:v;p=f?J:w;J=p;i=e;return o|0}function kqb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a+104>>2]=b;e=c[a+8>>2]|0;f=c[a+4>>2]|0;g=e-f|0;c[a+108>>2]=g;if((b|0)!=0&(g|0)>(b|0)){c[a+100>>2]=f+b;i=d;return}else{c[a+100>>2]=e;i=d;return}}function lqb(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=b+104|0;g=c[f>>2]|0;if((g|0)==0){h=3}else{if((c[b+108>>2]|0)<(g|0)){h=3}}do{if((h|0)==3){g=pqb(b)|0;if((g|0)<0){break}j=c[f>>2]|0;k=c[b+8>>2]|0;do{if((j|0)==0){h=8}else{l=c[b+4>>2]|0;m=j-(c[b+108>>2]|0)+ -1|0;if((k-l|0)<=(m|0)){h=8;break}c[b+100>>2]=l+m}}while(0);if((h|0)==8){c[b+100>>2]=k}j=c[b+4>>2]|0;if((k|0)!=0){m=b+108|0;c[m>>2]=k+1-j+(c[m>>2]|0)}m=j+ -1|0;if((d[m]|0|0)==(g|0)){n=g;i=e;return n|0}a[m]=g;n=g;i=e;return n|0}}while(0);c[b+100>>2]=0;n=-1;i=e;return n|0}function mqb(a,b){a=+a;b=b|0;var d=0,e=0.0,f=0,g=0,j=0.0;d=i;do{if((b|0)>1023){e=a*8.98846567431158e+307;f=b+ -1023|0;if((f|0)<=1023){g=f;j=e;break}f=b+ -2046|0;g=(f|0)>1023?1023:f;j=e*8.98846567431158e+307}else{if(!((b|0)<-1022)){g=b;j=a;break}e=a*1.2882297539194267e-231;f=b+1022|0;if(!((f|0)<-1022)){g=f;j=e;break}f=b+2044|0;g=(f|0)<-1022?-1022:f;j=e*1.2882297539194267e-231}}while(0);b=Dqb(g+1023|0,0,52)|0;g=J;c[k>>2]=b;c[k+4>>2]=g;a=j*+h[k>>3];i=d;return+a}function nqb(a,b){a=+a;b=b|0;var c=0,d=0.0;c=i;d=+mqb(a,b);i=c;return+d}function oqb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+74|0;f=a[e]|0;a[e]=f+ -1<<24>>24|f;f=b+20|0;e=b+44|0;if((c[f>>2]|0)>>>0>(c[e>>2]|0)>>>0){se[c[b+36>>2]&63](b,0,0)|0}c[b+16>>2]=0;c[b+28>>2]=0;c[f>>2]=0;f=b;g=c[f>>2]|0;if((g&20|0)==0){h=c[e>>2]|0;c[b+8>>2]=h;c[b+4>>2]=h;j=0;i=d;return j|0}if((g&4|0)==0){j=-1;i=d;return j|0}c[f>>2]=g|32;j=-1;i=d;return j|0}function pqb(a){a=a|0;var b=0,e=0,f=0;b=i;i=i+8|0;e=b;do{if((c[a+8>>2]|0)==0){if((oqb(a)|0)==0){break}else{f=-1}i=b;return f|0}}while(0);if((se[c[a+32>>2]&63](a,e,1)|0)!=1){f=-1;i=b;return f|0}f=d[e]|0;i=b;return f|0}function qqb(a){a=a|0;var b=0,c=0.0;b=i;c=+rqb(a,0);i=b;return+c}function rqb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;kqb(e,0);h=+iqb(e,1,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if((b|0)==0){i=d;return+h}if((j|0)==0){k=a}else{k=a+j|0}c[b>>2]=k;i=d;return+h}function sqb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;kqb(e,0);h=+iqb(e,2,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if((b|0)==0){i=d;return+h}if((j|0)==0){k=a}else{k=a+j|0}c[b>>2]=k;i=d;return+h}function tqb(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)==0){f=0;i=e;return f|0}else{g=d;h=b;j=c}while(1){k=a[h]|0;l=a[j]|0;if(!(k<<24>>24==l<<24>>24)){break}c=g+ -1|0;if((c|0)==0){f=0;m=5;break}else{g=c;h=h+1|0;j=j+1|0}}if((m|0)==5){i=e;return f|0}f=(k&255)-(l&255)|0;i=e;return f|0}function uqb(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a[b]|0;f=a[c]|0;if(e<<24>>24!=f<<24>>24|e<<24>>24==0|f<<24>>24==0){g=e;h=f;j=g&255;k=h&255;l=j-k|0;i=d;return l|0}else{m=b;n=c}while(1){c=m+1|0;b=n+1|0;f=a[c]|0;e=a[b]|0;if(f<<24>>24!=e<<24>>24|f<<24>>24==0|e<<24>>24==0){g=f;h=e;break}else{n=b;m=c}}j=g&255;k=h&255;l=j-k|0;i=d;return l|0}function vqb(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;if((e|0)==0){g=0;i=f;return g|0}h=a[b]|0;a:do{if(h<<24>>24==0){j=0;k=c}else{l=e;m=h;n=b;o=c;while(1){p=l+ -1|0;q=a[o]|0;if(!((p|0)!=0&q<<24>>24!=0&m<<24>>24==q<<24>>24)){j=m;k=o;break a}q=n+1|0;r=o+1|0;s=a[q]|0;if(s<<24>>24==0){j=0;k=r;break}else{m=s;n=q;o=r;l=p}}}}while(0);g=(j&255)-(d[k]|0)|0;i=f;return g|0}function wqb(){c[77740]=p;c[77782]=p;c[82424]=p;c[82654]=p}function xqb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;w=w+1|0;c[a>>2]=w;while((e|0)<40){if((c[d+(e<<2)>>2]|0)==0){c[d+(e<<2)>>2]=w;c[d+((e<<2)+4)>>2]=b;c[d+((e<<2)+8)>>2]=0;return 0}e=e+2|0}hc(116);hc(111);hc(111);hc(32);hc(109);hc(97);hc(110);hc(121);hc(32);hc(115);hc(101);hc(116);hc(106);hc(109);hc(112);hc(115);hc(32);hc(105);hc(110);hc(32);hc(97);hc(32);hc(102);hc(117);hc(110);hc(99);hc(116);hc(105);hc(111);hc(110);hc(32);hc(99);hc(97);hc(108);hc(108);hc(44);hc(32);hc(98);hc(117);hc(105);hc(108);hc(100);hc(32);hc(119);hc(105);hc(116);hc(104);hc(32);hc(97);hc(32);hc(104);hc(105);hc(103);hc(104);hc(101);hc(114);hc(32);hc(118);hc(97);hc(108);hc(117);hc(101);hc(32);hc(102);hc(111);hc(114);hc(32);hc(77);hc(65);hc(88);hc(95);hc(83);hc(69);hc(84);hc(74);hc(77);hc(80);hc(83);hc(10);ga(0);return 0}function yqb(b){b=b|0;var c=0;c=b;while(a[c]|0){c=c+1|0}return c-b|0}function zqb(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=(b|0)<0?-1:0;return b>>c-32|0}function Aqb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if((e|0)>=4096)return nb(b|0,d|0,e|0)|0;f=b|0;if((b&3)==(d&3)){while(b&3){if((e|0)==0)return f|0;a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}while((e|0)>=4){c[b>>2]=c[d>>2];b=b+4|0;d=d+4|0;e=e-4|0}}while((e|0)>0){a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}return f|0}function Bqb(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;if((c|0)<(b|0)&(b|0)<(c+d|0)){e=b;c=c+d|0;b=b+d|0;while((d|0)>0){b=b-1|0;c=c-1|0;d=d-1|0;a[b]=a[c]|0}b=e}else{Aqb(b,c,d)|0}return b|0}function Cqb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=b+e|0;if((e|0)>=20){d=d&255;g=b&3;h=d|d<<8|d<<16|d<<24;i=f&~3;if(g){g=b+4-g|0;while((b|0)<(g|0)){a[b]=d;b=b+1|0}}while((b|0)<(i|0)){c[b>>2]=h;b=b+4|0}}while((b|0)<(f|0)){a[b]=d;b=b+1|0}return b-e|0}function Dqb(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b<<c|(a&(1<<c)-1<<32-c)>>>32-c;return a<<c}J=a<<c-32;return 0}function Eqb(b,c){b=b|0;c=c|0;var d=0;do{a[b+d|0]=a[c+d|0];d=d+1|0}while(a[c+(d-1)|0]|0);return b|0}function Fqb(a){a=a|0;var b=0;b=(fa(c[a>>2]|0,31010991)|0)+1735287159&2147483647;c[a>>2]=b;return b|0}function Gqb(){return Fqb(o)|0}function Hqb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=b-d>>>0;e=b-d-(c>>>0>a>>>0|0)>>>0;return(J=e,a-c>>>0|0)|0}function Iqb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=a+c>>>0;return(J=b+d+(e>>>0<a>>>0|0)>>>0,e|0)|0}function Jqb(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;while((e|0)<(d|0)){a[b+e|0]=f?0:a[c+e|0]|0;f=f?1:(a[c+e|0]|0)==0;e=e+1|0}return b|0}function Kqb(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=0;return b>>>c-32|0}function Lqb(a,b){a=a|0;b=b|0;var d=0,e=0;while((d|0)<20){e=c[b+(d<<2)>>2]|0;if((e|0)==0)break;if((e|0)==(a|0)){return c[b+((d<<2)+4)>>2]|0}d=d+2|0}return 0}function Mqb(b){b=b|0;var c=0;c=a[n+(b>>>24)|0]|0;if((c|0)<8)return c|0;c=a[n+(b>>16&255)|0]|0;if((c|0)<8)return c+8|0;c=a[n+(b>>8&255)|0]|0;if((c|0)<8)return c+16|0;return(a[n+(b&255)|0]|0)+24|0}function Nqb(b){b=b|0;var c=0;c=a[m+(b&255)|0]|0;if((c|0)<8)return c|0;c=a[m+(b>>8&255)|0]|0;if((c|0)<8)return c+8|0;c=a[m+(b>>16&255)|0]|0;if((c|0)<8)return c+16|0;return(a[m+(b>>>24)|0]|0)+24|0}function Oqb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=a&65535;d=b&65535;e=fa(d,c)|0;f=a>>>16;a=(e>>>16)+(fa(d,f)|0)|0;d=b>>>16;b=fa(d,c)|0;return(J=(a>>>16)+(fa(d,f)|0)+(((a&65535)+b|0)>>>16)|0,a+b<<16|e&65535|0)|0}function Pqb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=b>>31|((b|0)<0?-1:0)<<1;f=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;g=d>>31|((d|0)<0?-1:0)<<1;h=((d|0)<0?-1:0)>>31|((d|0)<0?-1:0)<<1;i=Hqb(e^a,f^b,e,f)|0;b=J;a=g^e;e=h^f;f=Hqb((Uqb(i,b,Hqb(g^c,h^d,g,h)|0,J,0)|0)^a,J^e,a,e)|0;return(J=J,f)|0}function Qqb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+8|0;g=f|0;h=b>>31|((b|0)<0?-1:0)<<1;j=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;k=e>>31|((e|0)<0?-1:0)<<1;l=((e|0)<0?-1:0)>>31|((e|0)<0?-1:0)<<1;m=Hqb(h^a,j^b,h,j)|0;b=J;Uqb(m,b,Hqb(k^d,l^e,k,l)|0,J,g)|0;l=Hqb(c[g>>2]^h,c[g+4>>2]^j,h,j)|0;j=J;i=f;return(J=j,l)|0}function Rqb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=a;a=c;c=Oqb(e,a)|0;f=J;return(J=(fa(b,a)|0)+(fa(d,e)|0)+f|f&0,c|0|0)|0}function Sqb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Uqb(a,b,c,d,0)|0;return(J=J,e)|0}function Tqb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=f|0;Uqb(a,b,d,e,g)|0;i=f;return(J=c[g+4>>2]|0,c[g>>2]|0)|0}function Uqb(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0;g=a;h=b;i=h;j=d;k=e;l=k;if((i|0)==0){m=(f|0)!=0;if((l|0)==0){if(m){c[f>>2]=(g>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(g>>>0)/(j>>>0)>>>0;return(J=n,o)|0}else{if(!m){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=b&0;n=0;o=0;return(J=n,o)|0}}m=(l|0)==0;do{if((j|0)==0){if(m){if((f|0)!=0){c[f>>2]=(i>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(i>>>0)/(j>>>0)>>>0;return(J=n,o)|0}if((g|0)==0){if((f|0)!=0){c[f>>2]=0;c[f+4>>2]=(i>>>0)%(l>>>0)}n=0;o=(i>>>0)/(l>>>0)>>>0;return(J=n,o)|0}p=l-1|0;if((p&l|0)==0){if((f|0)!=0){c[f>>2]=a|0;c[f+4>>2]=p&i|b&0}n=0;o=i>>>((Nqb(l|0)|0)>>>0);return(J=n,o)|0}p=(Mqb(l|0)|0)-(Mqb(i|0)|0)|0;if(p>>>0<=30){q=p+1|0;r=31-p|0;s=q;t=i<<r|g>>>(q>>>0);u=i>>>(q>>>0);v=0;w=g<<r;break}if((f|0)==0){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(J=n,o)|0}else{if(!m){r=(Mqb(l|0)|0)-(Mqb(i|0)|0)|0;if(r>>>0<=31){q=r+1|0;p=31-r|0;x=r-31>>31;s=q;t=g>>>(q>>>0)&x|i<<p;u=i>>>(q>>>0)&x;v=0;w=g<<p;break}if((f|0)==0){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(J=n,o)|0}p=j-1|0;if((p&j|0)!=0){x=(Mqb(j|0)|0)+33-(Mqb(i|0)|0)|0;q=64-x|0;r=32-x|0;y=r>>31;z=x-32|0;A=z>>31;s=x;t=r-1>>31&i>>>(z>>>0)|(i<<r|g>>>(x>>>0))&A;u=A&i>>>(x>>>0);v=g<<q&y;w=(i<<q|g>>>(z>>>0))&y|g<<r&x-33>>31;break}if((f|0)!=0){c[f>>2]=p&g;c[f+4>>2]=0}if((j|0)==1){n=h|b&0;o=a|0|0;return(J=n,o)|0}else{p=Nqb(j|0)|0;n=i>>>(p>>>0)|0;o=i<<32-p|g>>>(p>>>0)|0;return(J=n,o)|0}}}while(0);if((s|0)==0){B=w;C=v;D=u;E=t;F=0;G=0}else{g=d|0|0;d=k|e&0;e=Iqb(g,d,-1,-1)|0;k=J;i=w;w=v;v=u;u=t;t=s;s=0;while(1){H=w>>>31|i<<1;I=s|w<<1;j=u<<1|i>>>31|0;a=u>>>31|v<<1|0;Hqb(e,k,j,a)|0;b=J;h=b>>31|((b|0)<0?-1:0)<<1;K=h&1;L=Hqb(j,a,h&g,(((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1)&d)|0;M=J;b=t-1|0;if((b|0)==0){break}else{i=H;w=I;v=M;u=L;t=b;s=K}}B=H;C=I;D=M;E=L;F=0;G=K}K=C;C=0;if((f|0)!=0){c[f>>2]=E;c[f+4>>2]=D}n=(K|0)>>>31|(B|C)<<1|(C<<1|K>>>31)&0|F;o=(K<<1|0>>>31)&-2|G;return(J=n,o)|0}function Vqb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return ie[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function Wqb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;je[a&31](b|0,c|0,d|0,e|0,f|0)}function Xqb(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;return ke[a&1](b|0,c|0,d|0,e|0,+f,g|0,h|0,i|0)|0}function Yqb(a,b){a=a|0;b=+b;le[a&1](+b)}function Zqb(a,b){a=a|0;b=b|0;me[a&2047](b|0)}function _qb(a,b,c){a=a|0;b=b|0;c=c|0;ne[a&255](b|0,c|0)}function $qb(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;return oe[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)|0}function arb(a,b){a=a|0;b=b|0;return pe[a&127](b|0)|0}function brb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;qe[a&1](b|0,c|0,+d,e|0)}function crb(a,b,c,d,e,f,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;return re[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0)|0}function drb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return se[a&63](b|0,c|0,d|0)|0}function erb(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;return te[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0,v|0,w|0)|0}function frb(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;return ue[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0)|0}function grb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;ve[a&7](b|0,c|0,d|0,e|0,f|0,+g)}function hrb(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;we[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function irb(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;return xe[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0,v|0,w|0,x|0,y|0)|0}function jrb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ye[a&31](b|0,c|0,d|0,e|0,f|0,g|0)}function krb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;ze[a&3](b|0,c|0,+d,e|0,f|0)}function lrb(a,b,c){a=a|0;b=b|0;c=+c;return Ae[a&1](b|0,+c)|0}function mrb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Be[a&63](b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function nrb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;Ce[a&3](b|0,c|0,d|0,e|0,f|0,g|0,+h)}function orb(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;De[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function prb(a,b,c){a=a|0;b=b|0;c=c|0;return Ee[a&63](b|0,c|0)|0}function qrb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return Fe[a&63](b|0,c|0,d|0,e|0,f|0)|0}function rrb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;return Ge[a&1](b|0,c|0,d|0,e|0,+f,g|0)|0}function srb(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;return+He[a&1](b|0,+c,+d)}function trb(a,b,c){a=a|0;b=b|0;c=c|0;return+Ie[a&1](b|0,c|0)}function urb(a){a=a|0;return Je[a&7]()|0}function vrb(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;return Ke[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)|0}function wrb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Le[a&15](b|0,c|0,d|0)}function xrb(a){a=a|0;Me[a&7]()}function yrb(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return Ne[a&15](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)|0}function zrb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Oe[a&63](b|0,c|0,d|0,e|0)|0}function Arb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Pe[a&127](b|0,c|0,d|0,e|0)}function Brb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ga(0);return 0}function Crb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ga(1)}function Drb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;ga(2);return 0}function Erb(a){a=+a;ga(3)}function Frb(a){a=a|0;ga(4)}function Grb(a){a=a|0;Jd(a|0)}function Hrb(a,b){a=a|0;b=b|0;ga(5)}function Irb(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ga(6);return 0}function Jrb(a){a=a|0;ga(7);return 0}function Krb(a){a=a|0;return Rc(a|0)|0}function Lrb(a){a=a|0;return Sd(a|0)|0}function Mrb(a){a=a|0;return zc(a|0)|0}function Nrb(a){a=a|0;return Hd(a|0)|0}function Orb(a){a=a|0;return rd(a|0)|0}function Prb(a){a=a|0;return Bd(a|0)|0}function Qrb(a){a=a|0;return ad(a|0)|0}function Rrb(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;ga(8)}function Srb(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;ga(9);return 0}function Trb(a,b,c){a=a|0;b=b|0;c=c|0;ga(10);return 0}function Urb(a,b,c){a=a|0;b=b|0;c=c|0;return Dd(a|0,b|0,c|0)|0}function Vrb(a,b,c){a=a|0;b=b|0;c=c|0;return lc(a|0,b|0,c|0)|0}function Wrb(a,b,c){a=a|0;b=b|0;c=c|0;return Za(a|0,b|0,c|0)|0}function Xrb(a,b,c){a=a|0;b=b|0;c=c|0;return Id(a|0,b|0,c|0)|0}function Yrb(a,b,c){a=a|0;b=b|0;c=c|0;return Ed(a|0,b|0,c|0)|0}function Zrb(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;ga(11);return 0}function _rb(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;ga(12);return 0}function $rb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;ga(13)}function asb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ga(14)}function bsb(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;ga(15);return 0}function csb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ga(16)}function dsb(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;ga(17)}function esb(a,b){a=a|0;b=+b;ga(18);return 0}function fsb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ga(19)}function gsb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;ga(20)}function hsb(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ga(21)}function isb(a,b){a=a|0;b=b|0;ga(22);return 0}function jsb(a,b){a=a|0;b=b|0;return Xd(a|0,b|0)|0}function ksb(a,b){a=a|0;b=b|0;return kc(a|0,b|0)|0}function lsb(a,b){a=a|0;b=b|0;return jb(a|0,b|0)|0}function msb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ga(23);return 0}function nsb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;ga(24);return 0}function osb(a,b,c){a=a|0;b=+b;c=+c;ga(25);return 0.0}function psb(a,b){a=a|0;b=b|0;ga(26);return 0.0}function qsb(){ga(27);return 0}function rsb(){return kb()|0}function ssb(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ga(28);return 0}function tsb(a,b,c){a=a|0;b=b|0;c=c|0;ga(29)}function usb(){ga(30)}function vsb(){Xc()}function wsb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ga(31);return 0}function xsb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ga(32);return 0}function ysb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return uc(a|0,b|0,c|0,d|0)|0}function zsb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Pc(a|0,b|0,c|0,d|0)|0}function Asb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ga(33)}



function U4(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,U=0.0,V=0.0,W=0.0,X=0,Y=0,Z=0.0,_=0.0,$=0.0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,fa=0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0,qa=0,ra=0.0,sa=0.0,ta=0.0,ua=0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0,Aa=0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0,Fa=0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0,Ka=0,La=0.0,Ma=0.0,Na=0.0,Oa=0,Pa=0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0,Ua=0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0,Za=0,_a=0.0,$a=0.0,ab=0.0,bb=0,cb=0,db=0.0,eb=0.0,fb=0.0,gb=0,hb=0,ib=0.0,jb=0.0,kb=0.0,lb=0,mb=0,nb=0.0,ob=0.0,pb=0.0,qb=0,rb=0,sb=0.0,tb=0.0,ub=0.0,vb=0,wb=0,xb=0.0,yb=0.0,zb=0.0,Ab=0,Bb=0,Cb=0.0,Db=0,Eb=0,Fb=0,Gb=0.0,Hb=0,Ib=0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0.0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0.0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0.0,Zb=0.0,_b=0.0,$b=0.0,ac=0.0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0;d=i;i=i+160|0;e=d;f=d+8|0;g=d+16|0;j=d+24|0;k=d+32|0;l=d+40|0;m=d+48|0;n=d+56|0;o=d+64|0;p=d+72|0;q=d+80|0;r=d+88|0;s=d+96|0;t=d+104|0;u=d+112|0;v=d+120|0;w=d+128|0;x=d+136|0;y=d+144|0;z=d+152|0;A=b+536|0;B=c[A>>2]|0;C=b+416|0;D=c[C>>2]|0;E=+h[D+3072>>3];if(E!=0.0){F=E;G=E;H=D}else{I=+qXa(B,E,56768,56760,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);D=c[C>>2]|0;F=I;G=+h[D+3072>>3];H=D}I=1.0/F;F=+h[H+3152>>3];E=+h[H+3160>>3];J=+h[H+1472>>3];K=+h[H+1792>>3];L=+h[H+1952>>3];M=(L+L)*.5;L=+h[H+3120>>3];do{if(G!=0.0){N=H;O=L/G}else{if(L==0.0){N=H;O=L;break}P=L/+qXa(c[A>>2]|0,G,56768,56760,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);N=c[C>>2]|0;O=P}}while(0);PD(e,B,I,F,F,E,E,J,K,M,O,+h[N+3096>>3]);O=+h[e>>3];e=c[A>>2]|0;N=c[C>>2]|0;M=+h[N+3072>>3];B=b+4|0;if(M!=0.0){Q=M;R=M;S=N}else{K=+qXa(e,M,56768,56760,+h[c[c[B>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);N=c[C>>2]|0;Q=K;R=+h[N+3072>>3];S=N}K=1.0/Q;Q=+h[S+3152>>3];M=+h[S+3160>>3];J=+h[S+1480>>3];N=c[c[B>>2]>>2]|0;E=+h[(c[N+8>>2]|0)+13024>>3];F=(+h[S+1952>>3]+ +h[S+1960>>3])*.5;I=+h[S+3120>>3];do{if(R!=0.0){T=S;U=I/R}else{if(I==0.0){T=S;U=I;break}G=I/+qXa(c[A>>2]|0,R,56768,56760,+h[N>>3],(a[b+319|0]|0)!=0|0);T=c[C>>2]|0;U=G}}while(0);PD(f,e,K,Q,Q,M,M,J,E,F,U,+h[T+3096>>3]);U=+h[f>>3];f=c[A>>2]|0;T=c[C>>2]|0;F=+h[T+3072>>3];if(F!=0.0){V=F;W=F;X=T}else{E=+qXa(f,F,56768,56760,+h[c[c[B>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);T=c[C>>2]|0;V=E;W=+h[T+3072>>3];X=T}E=1.0/V;V=+h[X+3152>>3];F=+h[X+3160>>3];J=+h[X+1488>>3];T=c[c[B>>2]>>2]|0;M=+h[(c[T+8>>2]|0)+13016>>3];Q=(+h[X+1960>>3]+ +h[X+1968>>3])*.5;K=+h[X+3120>>3];do{if(W!=0.0){Y=X;Z=K/W}else{if(K==0.0){Y=X;Z=K;break}R=K/+qXa(c[A>>2]|0,W,56768,56760,+h[T>>3],(a[b+319|0]|0)!=0|0);Y=c[C>>2]|0;Z=R}}while(0);PD(g,f,E,V,V,F,F,J,M,Q,Z,+h[Y+3096>>3]);Z=+h[g>>3];g=c[A>>2]|0;Y=c[C>>2]|0;Q=+h[Y+3072>>3];if(Q!=0.0){_=Q;$=Q;aa=Y}else{M=+qXa(g,Q,56768,56760,+h[c[c[B>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);Y=c[C>>2]|0;_=M;$=+h[Y+3072>>3];aa=Y}M=1.0/_;_=+h[aa+3152>>3];Q=+h[aa+3160>>3];J=+h[aa+1496>>3];Y=c[c[B>>2]>>2]|0;F=+h[(c[Y+8>>2]|0)+13008>>3];V=(+h[aa+1968>>3]+ +h[aa+1976>>3])*.5;E=+h[aa+3120>>3];do{if($!=0.0){ba=aa;ca=E/$}else{if(E==0.0){ba=aa;ca=E;break}W=E/+qXa(c[A>>2]|0,$,56768,56760,+h[Y>>3],(a[b+319|0]|0)!=0|0);ba=c[C>>2]|0;ca=W}}while(0);PD(j,g,M,_,_,Q,Q,J,F,V,ca,+h[ba+3096>>3]);ca=+h[j>>3];j=c[A>>2]|0;ba=c[C>>2]|0;V=+h[ba+3072>>3];if(V!=0.0){da=V;ea=V;fa=ba}else{F=+qXa(j,V,56768,56760,+h[c[c[B>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);ba=c[C>>2]|0;da=F;ea=+h[ba+3072>>3];fa=ba}F=1.0/da;da=+h[fa+3152>>3];V=+h[fa+3160>>3];J=+h[fa+1504>>3];ba=c[c[B>>2]>>2]|0;Q=+h[(c[ba+8>>2]|0)+13e3>>3];_=(+h[fa+1976>>3]+ +h[fa+1984>>3])*.5;M=+h[fa+3120>>3];do{if(ea!=0.0){ga=fa;ha=M/ea}else{if(M==0.0){ga=fa;ha=M;break}$=M/+qXa(c[A>>2]|0,ea,56768,56760,+h[ba>>3],(a[b+319|0]|0)!=0|0);ga=c[C>>2]|0;ha=$}}while(0);PD(k,j,F,da,da,V,V,J,Q,_,ha,+h[ga+3096>>3]);ha=+h[k>>3];k=c[A>>2]|0;ga=c[C>>2]|0;_=+h[ga+3072>>3];if(_!=0.0){ia=_;ja=_;ka=ga}else{Q=+qXa(k,_,56768,56760,+h[c[c[B>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);ga=c[C>>2]|0;ia=Q;ja=+h[ga+3072>>3];ka=ga}Q=1.0/ia;ia=+h[ka+3152>>3];_=+h[ka+3160>>3];J=+h[ka+1512>>3];ga=c[c[B>>2]>>2]|0;V=+h[(c[ga+8>>2]|0)+12992>>3];da=(+h[ka+1984>>3]+ +h[ka+1992>>3])*.5;F=+h[ka+3120>>3];do{if(ja!=0.0){la=ka;ma=F/ja}else{if(F==0.0){la=ka;ma=F;break}ea=F/+qXa(c[A>>2]|0,ja,56768,56760,+h[ga>>3],(a[b+319|0]|0)!=0|0);la=c[C>>2]|0;ma=ea}}while(0);PD(l,k,Q,ia,ia,_,_,J,V,da,ma,+h[la+3096>>3]);ma=+h[l>>3];l=c[A>>2]|0;la=c[C>>2]|0;da=+h[la+3072>>3];if(da!=0.0){na=da;oa=da;pa=la}else{V=+qXa(l,da,56768,56760,+h[c[c[B>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);la=c[C>>2]|0;na=V;oa=+h[la+3072>>3];pa=la}V=1.0/na;na=+h[pa+3152>>3];da=+h[pa+3160>>3];J=+h[pa+1520>>3];la=c[c[B>>2]>>2]|0;_=+h[(c[la+8>>2]|0)+12984>>3];ia=(+h[pa+1992>>3]+ +h[pa+2e3>>3])*.5;Q=+h[pa+3120>>3];do{if(oa!=0.0){qa=pa;ra=Q/oa}else{if(Q==0.0){qa=pa;ra=Q;break}ja=Q/+qXa(c[A>>2]|0,oa,56768,56760,+h[la>>3],(a[b+319|0]|0)!=0|0);qa=c[C>>2]|0;ra=ja}}while(0);PD(m,l,V,na,na,da,da,J,_,ia,ra,+h[qa+3096>>3]);ra=+h[m>>3];m=c[A>>2]|0;qa=c[C>>2]|0;ia=+h[qa+3072>>3];if(ia!=0.0){sa=ia;ta=ia;ua=qa}else{_=+qXa(m,ia,56768,56760,+h[c[c[B>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);qa=c[C>>2]|0;sa=_;ta=+h[qa+3072>>3];ua=qa}_=1.0/sa;sa=+h[ua+3152>>3];ia=+h[ua+3160>>3];J=+h[ua+1528>>3];qa=c[c[B>>2]>>2]|0;da=+h[(c[qa+8>>2]|0)+12976>>3];na=(+h[ua+2e3>>3]+ +h[ua+2008>>3])*.5;V=+h[ua+3120>>3];do{if(ta!=0.0){va=ua;wa=V/ta}else{if(V==0.0){va=ua;wa=V;break}oa=V/+qXa(c[A>>2]|0,ta,56768,56760,+h[qa>>3],(a[b+319|0]|0)!=0|0);va=c[C>>2]|0;wa=oa}}while(0);PD(n,m,_,sa,sa,ia,ia,J,da,na,wa,+h[va+3096>>3]);wa=+h[n>>3];n=c[A>>2]|0;va=c[C>>2]|0;na=+h[va+3072>>3];if(na!=0.0){xa=na;ya=na;za=va}else{da=+qXa(n,na,56768,56760,+h[c[c[B>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);va=c[C>>2]|0;xa=da;ya=+h[va+3072>>3];za=va}da=1.0/xa;xa=+h[za+3152>>3];na=+h[za+3160>>3];J=+h[za+1536>>3];va=c[c[B>>2]>>2]|0;ia=+h[(c[va+8>>2]|0)+12968>>3];sa=(+h[za+2008>>3]+ +h[za+2016>>3])*.5;_=+h[za+3120>>3];do{if(ya!=0.0){Aa=za;Ba=_/ya}else{if(_==0.0){Aa=za;Ba=_;break}ta=_/+qXa(c[A>>2]|0,ya,56768,56760,+h[va>>3],(a[b+319|0]|0)!=0|0);Aa=c[C>>2]|0;Ba=ta}}while(0);PD(o,n,da,xa,xa,na,na,J,ia,sa,Ba,+h[Aa+3096>>3]);Ba=+h[o>>3];o=c[A>>2]|0;Aa=c[C>>2]|0;sa=+h[Aa+3072>>3];if(sa!=0.0){Ca=sa;Da=sa;Ea=Aa}else{ia=+qXa(o,sa,56768,56760,+h[c[c[B>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);Aa=c[C>>2]|0;Ca=ia;Da=+h[Aa+3072>>3];Ea=Aa}ia=1.0/Ca;Ca=+h[Ea+3152>>3];sa=+h[Ea+3160>>3];J=+h[Ea+1544>>3];Aa=c[c[B>>2]>>2]|0;na=+h[(c[Aa+8>>2]|0)+12960>>3];xa=(+h[Ea+2016>>3]+ +h[Ea+2024>>3])*.5;da=+h[Ea+3120>>3];do{if(Da!=0.0){Fa=Ea;Ga=da/Da}else{if(da==0.0){Fa=Ea;Ga=da;break}ya=da/+qXa(c[A>>2]|0,Da,56768,56760,+h[Aa>>3],(a[b+319|0]|0)!=0|0);Fa=c[C>>2]|0;Ga=ya}}while(0);PD(p,o,ia,Ca,Ca,sa,sa,J,na,xa,Ga,+h[Fa+3096>>3]);Ga=+h[p>>3];p=c[A>>2]|0;Fa=c[C>>2]|0;xa=+h[Fa+3072>>3];if(xa!=0.0){Ha=xa;Ia=xa;Ja=Fa}else{na=+qXa(p,xa,56768,56760,+h[c[c[B>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);Fa=c[C>>2]|0;Ha=na;Ia=+h[Fa+3072>>3];Ja=Fa}na=1.0/Ha;Ha=+h[Ja+3152>>3];xa=+h[Ja+3160>>3];J=+h[Ja+1552>>3];Fa=c[c[B>>2]>>2]|0;sa=+h[(c[Fa+8>>2]|0)+12952>>3];Ca=(+h[Ja+2024>>3]+ +h[Ja+2032>>3])*.5;ia=+h[Ja+3120>>3];do{if(Ia!=0.0){Ka=Ja;La=ia/Ia}else{if(ia==0.0){Ka=Ja;La=ia;break}Da=ia/+qXa(c[A>>2]|0,Ia,56768,56760,+h[Fa>>3],(a[b+319|0]|0)!=0|0);Ka=c[C>>2]|0;La=Da}}while(0);PD(q,p,na,Ha,Ha,xa,xa,J,sa,Ca,La,+h[Ka+3096>>3]);La=+h[q>>3];q=c[A>>2]|0;Ka=c[C>>2]|0;Ca=+h[Ka+3072>>3];if(Ca!=0.0){Ma=Ca;Na=Ca;Oa=Ka}else{sa=+qXa(q,Ca,56768,56760,+h[c[c[B>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);Ka=c[C>>2]|0;Ma=sa;Na=+h[Ka+3072>>3];Oa=Ka}sa=1.0/Ma;Ma=+h[Oa+3152>>3];Ca=+h[Oa+3160>>3];J=+h[Oa+1560>>3];Ka=c[c[B>>2]>>2]|0;xa=+h[(c[Ka+8>>2]|0)+12944>>3];Ha=(+h[Oa+2032>>3]+ +h[Oa+2040>>3])*.5;na=+h[Oa+3120>>3];do{if(Na!=0.0){Pa=Oa;Qa=na/Na}else{if(na==0.0){Pa=Oa;Qa=na;break}Ia=na/+qXa(c[A>>2]|0,Na,56768,56760,+h[Ka>>3],(a[b+319|0]|0)!=0|0);Pa=c[C>>2]|0;Qa=Ia}}while(0);PD(r,q,sa,Ma,Ma,Ca,Ca,J,xa,Ha,Qa,+h[Pa+3096>>3]);Qa=+h[r>>3];r=c[A>>2]|0;Pa=c[C>>2]|0;Ha=+h[Pa+3072>>3];if(Ha!=0.0){Ra=Ha;Sa=Ha;Ta=Pa}else{xa=+qXa(r,Ha,56768,56760,+h[c[c[B>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);Pa=c[C>>2]|0;Ra=xa;Sa=+h[Pa+3072>>3];Ta=Pa}xa=1.0/Ra;Ra=+h[Ta+3152>>3];Ha=+h[Ta+3160>>3];J=+h[Ta+1568>>3];Pa=c[c[B>>2]>>2]|0;Ca=+h[(c[Pa+8>>2]|0)+12936>>3];Ma=(+h[Ta+2040>>3]+ +h[Ta+2048>>3])*.5;sa=+h[Ta+3120>>3];do{if(Sa!=0.0){Ua=Ta;Va=sa/Sa}else{if(sa==0.0){Ua=Ta;Va=sa;break}Na=sa/+qXa(c[A>>2]|0,Sa,56768,56760,+h[Pa>>3],(a[b+319|0]|0)!=0|0);Ua=c[C>>2]|0;Va=Na}}while(0);PD(s,r,xa,Ra,Ra,Ha,Ha,J,Ca,Ma,Va,+h[Ua+3096>>3]);Va=+h[s>>3];s=c[A>>2]|0;Ua=c[C>>2]|0;Ma=+h[Ua+3072>>3];if(Ma!=0.0){Wa=Ma;Xa=Ma;Ya=Ua}else{Ca=+qXa(s,Ma,56768,56760,+h[c[c[B>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);Ua=c[C>>2]|0;Wa=Ca;Xa=+h[Ua+3072>>3];Ya=Ua}Ca=1.0/Wa;Wa=+h[Ya+3152>>3];Ma=+h[Ya+3160>>3];J=+h[Ya+1576>>3];Ua=c[c[B>>2]>>2]|0;Ha=+h[(c[Ua+8>>2]|0)+12928>>3];Ra=(+h[Ya+2048>>3]+ +h[Ya+2056>>3])*.5;xa=+h[Ya+3120>>3];do{if(Xa!=0.0){Za=Ya;_a=xa/Xa}else{if(xa==0.0){Za=Ya;_a=xa;break}Sa=xa/+qXa(c[A>>2]|0,Xa,56768,56760,+h[Ua>>3],(a[b+319|0]|0)!=0|0);Za=c[C>>2]|0;_a=Sa}}while(0);PD(t,s,Ca,Wa,Wa,Ma,Ma,J,Ha,Ra,_a,+h[Za+3096>>3]);_a=+h[t>>3];t=c[A>>2]|0;Za=c[C>>2]|0;Ra=+h[Za+3072>>3];if(Ra!=0.0){$a=Ra;ab=Ra;bb=Za}else{Ha=+qXa(t,Ra,56768,56760,+h[c[c[B>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);Za=c[C>>2]|0;$a=Ha;ab=+h[Za+3072>>3];bb=Za}Ha=1.0/$a;$a=+h[bb+3152>>3];Ra=+h[bb+3160>>3];J=+h[bb+1584>>3];Za=c[c[B>>2]>>2]|0;Ma=+h[(c[Za+8>>2]|0)+12920>>3];Wa=(+h[bb+2056>>3]+ +h[bb+2064>>3])*.5;Ca=+h[bb+3120>>3];do{if(ab!=0.0){cb=bb;db=Ca/ab}else{if(Ca==0.0){cb=bb;db=Ca;break}Xa=Ca/+qXa(c[A>>2]|0,ab,56768,56760,+h[Za>>3],(a[b+319|0]|0)!=0|0);cb=c[C>>2]|0;db=Xa}}while(0);PD(u,t,Ha,$a,$a,Ra,Ra,J,Ma,Wa,db,+h[cb+3096>>3]);db=+h[u>>3];u=c[A>>2]|0;cb=c[C>>2]|0;Wa=+h[cb+3072>>3];if(Wa!=0.0){eb=Wa;fb=Wa;gb=cb}else{Ma=+qXa(u,Wa,56768,56760,+h[c[c[B>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);cb=c[C>>2]|0;eb=Ma;fb=+h[cb+3072>>3];gb=cb}Ma=1.0/eb;eb=+h[gb+3152>>3];Wa=+h[gb+3160>>3];J=+h[gb+1592>>3];cb=c[c[B>>2]>>2]|0;Ra=+h[(c[cb+8>>2]|0)+12912>>3];$a=(+h[gb+2064>>3]+ +h[gb+2072>>3])*.5;Ha=+h[gb+3120>>3];do{if(fb!=0.0){hb=gb;ib=Ha/fb}else{if(Ha==0.0){hb=gb;ib=Ha;break}ab=Ha/+qXa(c[A>>2]|0,fb,56768,56760,+h[cb>>3],(a[b+319|0]|0)!=0|0);hb=c[C>>2]|0;ib=ab}}while(0);PD(v,u,Ma,eb,eb,Wa,Wa,J,Ra,$a,ib,+h[hb+3096>>3]);ib=+h[v>>3];v=c[A>>2]|0;hb=c[C>>2]|0;$a=+h[hb+3072>>3];if($a!=0.0){jb=$a;kb=$a;lb=hb}else{Ra=+qXa(v,$a,56768,56760,+h[c[c[B>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);hb=c[C>>2]|0;jb=Ra;kb=+h[hb+3072>>3];lb=hb}Ra=1.0/jb;jb=+h[lb+3152>>3];$a=+h[lb+3160>>3];J=+h[lb+1600>>3];hb=c[c[B>>2]>>2]|0;Wa=+h[(c[hb+8>>2]|0)+12904>>3];eb=(+h[lb+2072>>3]+ +h[lb+2080>>3])*.5;Ma=+h[lb+3120>>3];do{if(kb!=0.0){mb=lb;nb=Ma/kb}else{if(Ma==0.0){mb=lb;nb=Ma;break}fb=Ma/+qXa(c[A>>2]|0,kb,56768,56760,+h[hb>>3],(a[b+319|0]|0)!=0|0);mb=c[C>>2]|0;nb=fb}}while(0);PD(w,v,Ra,jb,jb,$a,$a,J,Wa,eb,nb,+h[mb+3096>>3]);nb=+h[w>>3];w=c[A>>2]|0;mb=c[C>>2]|0;eb=+h[mb+3072>>3];if(eb!=0.0){ob=eb;pb=eb;qb=mb}else{Wa=+qXa(w,eb,56768,56760,+h[c[c[B>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);mb=c[C>>2]|0;ob=Wa;pb=+h[mb+3072>>3];qb=mb}Wa=1.0/ob;ob=+h[qb+3152>>3];eb=+h[qb+3160>>3];J=+h[qb+1608>>3];mb=c[c[B>>2]>>2]|0;$a=+h[(c[mb+8>>2]|0)+12896>>3];jb=(+h[qb+2080>>3]+ +h[qb+2088>>3])*.5;Ra=+h[qb+3120>>3];do{if(pb!=0.0){rb=qb;sb=Ra/pb}else{if(Ra==0.0){rb=qb;sb=Ra;break}kb=Ra/+qXa(c[A>>2]|0,pb,56768,56760,+h[mb>>3],(a[b+319|0]|0)!=0|0);rb=c[C>>2]|0;sb=kb}}while(0);PD(x,w,Wa,ob,ob,eb,eb,J,$a,jb,sb,+h[rb+3096>>3]);sb=+h[x>>3];x=c[A>>2]|0;rb=c[C>>2]|0;jb=+h[rb+3072>>3];if(jb!=0.0){tb=jb;ub=jb;vb=rb}else{$a=+qXa(x,jb,56768,56760,+h[c[c[B>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);rb=c[C>>2]|0;tb=$a;ub=+h[rb+3072>>3];vb=rb}$a=1.0/tb;tb=+h[vb+3152>>3];jb=+h[vb+3160>>3];J=+h[vb+1616>>3];rb=c[c[B>>2]>>2]|0;eb=+h[(c[rb+8>>2]|0)+12888>>3];ob=(+h[vb+2088>>3]+ +h[vb+2096>>3])*.5;Wa=+h[vb+3120>>3];do{if(ub!=0.0){wb=vb;xb=Wa/ub}else{if(Wa==0.0){wb=vb;xb=Wa;break}pb=Wa/+qXa(c[A>>2]|0,ub,56768,56760,+h[rb>>3],(a[b+319|0]|0)!=0|0);wb=c[C>>2]|0;xb=pb}}while(0);PD(y,x,$a,tb,tb,jb,jb,J,eb,ob,xb,+h[wb+3096>>3]);xb=+h[y>>3];y=c[A>>2]|0;wb=c[C>>2]|0;ob=+h[wb+3072>>3];if(ob!=0.0){yb=ob;zb=ob;Ab=wb}else{eb=+qXa(y,ob,56768,56760,+h[c[c[B>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);wb=c[C>>2]|0;yb=eb;zb=+h[wb+3072>>3];Ab=wb}eb=1.0/yb;yb=+h[Ab+3152>>3];ob=+h[Ab+3160>>3];J=+h[Ab+1624>>3];wb=c[c[B>>2]>>2]|0;jb=+h[(c[wb+8>>2]|0)+12880>>3];tb=(+h[Ab+2096>>3]+ +h[Ab+2104>>3])*.5;$a=+h[Ab+3120>>3];if(zb!=0.0){Bb=Ab;Cb=$a/zb;Db=Bb;Eb=Db+3096|0;Fb=Eb;Gb=+h[Fb>>3];PD(z,y,eb,yb,yb,ob,ob,J,jb,tb,Cb,Gb);Hb=z;Ib=Hb;Jb=+h[Ib>>3];Kb=xb+Jb;Lb=sb+Kb;Mb=nb+Lb;Nb=ib+Mb;Ob=db+Nb;Pb=_a+Ob;Qb=Va+Pb;Rb=Qa+Qb;Sb=La+Rb;Tb=Ga+Sb;Ub=Ba+Tb;Vb=wa+Ub;Wb=ra+Vb;Xb=ma+Wb;Yb=ha+Xb;Zb=ca+Yb;_b=Z+Zb;$b=U+_b;ac=O+$b;bc=c[B>>2]|0;cc=c[bc>>2]|0;dc=cc;ec=dc+8|0;fc=ec;gc=c[fc>>2]|0;hc=gc;ic=hc+14736|0;jc=ic;h[jc>>3]=ac;i=d;return}if($a==0.0){Bb=Ab;Cb=$a;Db=Bb;Eb=Db+3096|0;Fb=Eb;Gb=+h[Fb>>3];PD(z,y,eb,yb,yb,ob,ob,J,jb,tb,Cb,Gb);Hb=z;Ib=Hb;Jb=+h[Ib>>3];Kb=xb+Jb;Lb=sb+Kb;Mb=nb+Lb;Nb=ib+Mb;Ob=db+Nb;Pb=_a+Ob;Qb=Va+Pb;Rb=Qa+Qb;Sb=La+Rb;Tb=Ga+Sb;Ub=Ba+Tb;Vb=wa+Ub;Wb=ra+Vb;Xb=ma+Wb;Yb=ha+Xb;Zb=ca+Yb;_b=Z+Zb;$b=U+_b;ac=O+$b;bc=c[B>>2]|0;cc=c[bc>>2]|0;dc=cc;ec=dc+8|0;fc=ec;gc=c[fc>>2]|0;hc=gc;ic=hc+14736|0;jc=ic;h[jc>>3]=ac;i=d;return}ub=$a/+qXa(c[A>>2]|0,zb,56768,56760,+h[wb>>3],(a[b+319|0]|0)!=0|0);Bb=c[C>>2]|0;Cb=ub;Db=Bb;Eb=Db+3096|0;Fb=Eb;Gb=+h[Fb>>3];PD(z,y,eb,yb,yb,ob,ob,J,jb,tb,Cb,Gb);Hb=z;Ib=Hb;Jb=+h[Ib>>3];Kb=xb+Jb;Lb=sb+Kb;Mb=nb+Lb;Nb=ib+Mb;Ob=db+Nb;Pb=_a+Ob;Qb=Va+Pb;Rb=Qa+Qb;Sb=La+Rb;Tb=Ga+Sb;Ub=Ba+Tb;Vb=wa+Ub;Wb=ra+Vb;Xb=ma+Wb;Yb=ha+Xb;Zb=ca+Yb;_b=Z+Zb;$b=U+_b;ac=O+$b;bc=c[B>>2]|0;cc=c[bc>>2]|0;dc=cc;ec=dc+8|0;fc=ec;gc=c[fc>>2]|0;hc=gc;ic=hc+14736|0;jc=ic;h[jc>>3]=ac;i=d;return}function V4(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0.0,H=0.0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0,V=0.0,W=0.0,X=0.0,Y=0,Z=0,_=0.0,$=0.0,aa=0.0,ba=0,ca=0,da=0.0,ea=0.0,fa=0.0,ga=0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0.0,oa=0.0,pa=0.0,qa=0,ra=0,sa=0.0,ta=0.0,ua=0.0,va=0,wa=0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0,Ga=0,Ha=0.0,Ia=0.0,Ja=0.0,Ka=0,La=0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0,Qa=0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0,Va=0,Wa=0.0,Xa=0.0,Ya=0.0,Za=0,_a=0,$a=0.0,ab=0.0,bb=0.0,cb=0,db=0,eb=0.0,fb=0.0,gb=0.0,hb=0,ib=0,jb=0.0,kb=0.0,lb=0.0,mb=0,nb=0,ob=0.0,pb=0.0,qb=0.0,rb=0,sb=0,tb=0.0,ub=0.0,vb=0.0,wb=0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0,Cb=0,Db=0.0,Eb=0,Fb=0,Gb=0,Hb=0.0,Ib=0,Jb=0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0.0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0.0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0.0,Zb=0.0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0;d=i;i=i+160|0;e=d;f=d+8|0;g=d+16|0;j=d+24|0;k=d+32|0;l=d+40|0;m=d+48|0;n=d+56|0;o=d+64|0;p=d+72|0;q=d+80|0;r=d+88|0;s=d+96|0;t=d+104|0;u=d+112|0;v=d+120|0;w=d+128|0;x=d+136|0;y=d+144|0;z=d+152|0;A=b+536|0;B=c[A>>2]|0;C=b+416|0;D=c[C>>2]|0;E=+h[D+2840>>3];F=b+4|0;if(E!=0.0){G=E;H=E;I=D}else{J=+qXa(B,E,56808,56800,+h[c[c[F>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);D=c[C>>2]|0;G=J;H=+h[D+2840>>3];I=D}J=1.0/G;G=+h[I+2920>>3];E=+h[I+2928>>3];K=+h[I+344>>3];D=c[c[F>>2]>>2]|0;L=+h[(c[D+8>>2]|0)+13176>>3];M=(+h[I+824>>3]+ +h[I+832>>3])*.5;N=+h[I+2888>>3];do{if(H!=0.0){O=I;P=N/H}else{if(N==0.0){O=I;P=N;break}Q=N/+qXa(c[A>>2]|0,H,56808,56800,+h[D>>3],(a[b+319|0]|0)!=0|0);O=c[C>>2]|0;P=Q}}while(0);PD(e,B,J,G,G,E,E,K,L,M,P,+h[O+2864>>3]);P=+h[e>>3];e=c[A>>2]|0;O=c[C>>2]|0;M=+h[O+2840>>3];if(M!=0.0){R=M;S=M;T=O}else{L=+qXa(e,M,56808,56800,+h[c[c[F>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);O=c[C>>2]|0;R=L;S=+h[O+2840>>3];T=O}L=1.0/R;R=+h[T+2920>>3];M=+h[T+2928>>3];K=+h[T+352>>3];O=c[c[F>>2]>>2]|0;E=+h[(c[O+8>>2]|0)+13168>>3];G=(+h[T+832>>3]+ +h[T+840>>3])*.5;J=+h[T+2888>>3];do{if(S!=0.0){U=T;V=J/S}else{if(J==0.0){U=T;V=J;break}H=J/+qXa(c[A>>2]|0,S,56808,56800,+h[O>>3],(a[b+319|0]|0)!=0|0);U=c[C>>2]|0;V=H}}while(0);PD(f,e,L,R,R,M,M,K,E,G,V,+h[U+2864>>3]);V=+h[f>>3];f=c[A>>2]|0;U=c[C>>2]|0;G=+h[U+2840>>3];if(G!=0.0){W=G;X=G;Y=U}else{E=+qXa(f,G,56808,56800,+h[c[c[F>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);U=c[C>>2]|0;W=E;X=+h[U+2840>>3];Y=U}E=1.0/W;W=+h[Y+2920>>3];G=+h[Y+2928>>3];K=+h[Y+360>>3];U=c[c[F>>2]>>2]|0;M=+h[(c[U+8>>2]|0)+13160>>3];R=(+h[Y+840>>3]+ +h[Y+848>>3])*.5;L=+h[Y+2888>>3];do{if(X!=0.0){Z=Y;_=L/X}else{if(L==0.0){Z=Y;_=L;break}S=L/+qXa(c[A>>2]|0,X,56808,56800,+h[U>>3],(a[b+319|0]|0)!=0|0);Z=c[C>>2]|0;_=S}}while(0);PD(g,f,E,W,W,G,G,K,M,R,_,+h[Z+2864>>3]);_=+h[g>>3];g=c[A>>2]|0;Z=c[C>>2]|0;R=+h[Z+2840>>3];if(R!=0.0){$=R;aa=R;ba=Z}else{M=+qXa(g,R,56808,56800,+h[c[c[F>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);Z=c[C>>2]|0;$=M;aa=+h[Z+2840>>3];ba=Z}M=1.0/$;$=+h[ba+2920>>3];R=+h[ba+2928>>3];K=+h[ba+368>>3];Z=c[c[F>>2]>>2]|0;G=+h[(c[Z+8>>2]|0)+13152>>3];W=(+h[ba+848>>3]+ +h[ba+856>>3])*.5;E=+h[ba+2888>>3];do{if(aa!=0.0){ca=ba;da=E/aa}else{if(E==0.0){ca=ba;da=E;break}X=E/+qXa(c[A>>2]|0,aa,56808,56800,+h[Z>>3],(a[b+319|0]|0)!=0|0);ca=c[C>>2]|0;da=X}}while(0);PD(j,g,M,$,$,R,R,K,G,W,da,+h[ca+2864>>3]);da=+h[j>>3];j=c[A>>2]|0;ca=c[C>>2]|0;W=+h[ca+2840>>3];if(W!=0.0){ea=W;fa=W;ga=ca}else{G=+qXa(j,W,56808,56800,+h[c[c[F>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);ca=c[C>>2]|0;ea=G;fa=+h[ca+2840>>3];ga=ca}G=1.0/ea;ea=+h[ga+2920>>3];W=+h[ga+2928>>3];K=+h[ga+376>>3];ca=c[c[F>>2]>>2]|0;R=+h[(c[ca+8>>2]|0)+13144>>3];$=(+h[ga+856>>3]+ +h[ga+864>>3])*.5;M=+h[ga+2888>>3];do{if(fa!=0.0){ha=ga;ia=M/fa}else{if(M==0.0){ha=ga;ia=M;break}aa=M/+qXa(c[A>>2]|0,fa,56808,56800,+h[ca>>3],(a[b+319|0]|0)!=0|0);ha=c[C>>2]|0;ia=aa}}while(0);PD(k,j,G,ea,ea,W,W,K,R,$,ia,+h[ha+2864>>3]);ia=+h[k>>3];k=c[A>>2]|0;ha=c[C>>2]|0;$=+h[ha+2840>>3];if($!=0.0){ja=$;ka=$;la=ha}else{R=+qXa(k,$,56808,56800,+h[c[c[F>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);ha=c[C>>2]|0;ja=R;ka=+h[ha+2840>>3];la=ha}R=1.0/ja;ja=+h[la+2920>>3];$=+h[la+2928>>3];K=+h[la+384>>3];ha=c[c[F>>2]>>2]|0;W=+h[(c[ha+8>>2]|0)+13136>>3];ea=(+h[la+864>>3]+ +h[la+872>>3])*.5;G=+h[la+2888>>3];do{if(ka!=0.0){ma=la;na=G/ka}else{if(G==0.0){ma=la;na=G;break}fa=G/+qXa(c[A>>2]|0,ka,56808,56800,+h[ha>>3],(a[b+319|0]|0)!=0|0);ma=c[C>>2]|0;na=fa}}while(0);PD(l,k,R,ja,ja,$,$,K,W,ea,na,+h[ma+2864>>3]);na=+h[l>>3];l=c[A>>2]|0;ma=c[C>>2]|0;ea=+h[ma+2840>>3];if(ea!=0.0){oa=ea;pa=ea;qa=ma}else{W=+qXa(l,ea,56808,56800,+h[c[c[F>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);ma=c[C>>2]|0;oa=W;pa=+h[ma+2840>>3];qa=ma}W=1.0/oa;oa=+h[qa+2920>>3];ea=+h[qa+2928>>3];K=+h[qa+392>>3];ma=c[c[F>>2]>>2]|0;$=+h[(c[ma+8>>2]|0)+13128>>3];ja=(+h[qa+872>>3]+ +h[qa+880>>3])*.5;R=+h[qa+2888>>3];do{if(pa!=0.0){ra=qa;sa=R/pa}else{if(R==0.0){ra=qa;sa=R;break}ka=R/+qXa(c[A>>2]|0,pa,56808,56800,+h[ma>>3],(a[b+319|0]|0)!=0|0);ra=c[C>>2]|0;sa=ka}}while(0);PD(m,l,W,oa,oa,ea,ea,K,$,ja,sa,+h[ra+2864>>3]);sa=+h[m>>3];m=c[A>>2]|0;ra=c[C>>2]|0;ja=+h[ra+2840>>3];if(ja!=0.0){ta=ja;ua=ja;va=ra}else{$=+qXa(m,ja,56808,56800,+h[c[c[F>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);ra=c[C>>2]|0;ta=$;ua=+h[ra+2840>>3];va=ra}$=1.0/ta;ta=+h[va+2920>>3];ja=+h[va+2928>>3];K=+h[va+400>>3];ra=c[c[F>>2]>>2]|0;ea=+h[(c[ra+8>>2]|0)+13120>>3];oa=(+h[va+880>>3]+ +h[va+888>>3])*.5;W=+h[va+2888>>3];do{if(ua!=0.0){wa=va;xa=W/ua}else{if(W==0.0){wa=va;xa=W;break}pa=W/+qXa(c[A>>2]|0,ua,56808,56800,+h[ra>>3],(a[b+319|0]|0)!=0|0);wa=c[C>>2]|0;xa=pa}}while(0);PD(n,m,$,ta,ta,ja,ja,K,ea,oa,xa,+h[wa+2864>>3]);xa=+h[n>>3];n=c[A>>2]|0;wa=c[C>>2]|0;oa=+h[wa+2840>>3];if(oa!=0.0){ya=oa;za=oa;Aa=wa}else{ea=+qXa(n,oa,56808,56800,+h[c[c[F>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);wa=c[C>>2]|0;ya=ea;za=+h[wa+2840>>3];Aa=wa}ea=1.0/ya;ya=+h[Aa+2920>>3];oa=+h[Aa+2928>>3];K=+h[Aa+408>>3];wa=c[c[F>>2]>>2]|0;ja=+h[(c[wa+8>>2]|0)+13112>>3];ta=(+h[Aa+888>>3]+ +h[Aa+896>>3])*.5;$=+h[Aa+2888>>3];do{if(za!=0.0){Ba=Aa;Ca=$/za}else{if($==0.0){Ba=Aa;Ca=$;break}ua=$/+qXa(c[A>>2]|0,za,56808,56800,+h[wa>>3],(a[b+319|0]|0)!=0|0);Ba=c[C>>2]|0;Ca=ua}}while(0);PD(o,n,ea,ya,ya,oa,oa,K,ja,ta,Ca,+h[Ba+2864>>3]);Ca=+h[o>>3];o=c[A>>2]|0;Ba=c[C>>2]|0;ta=+h[Ba+2840>>3];if(ta!=0.0){Da=ta;Ea=ta;Fa=Ba}else{ja=+qXa(o,ta,56808,56800,+h[c[c[F>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);Ba=c[C>>2]|0;Da=ja;Ea=+h[Ba+2840>>3];Fa=Ba}ja=1.0/Da;Da=+h[Fa+2920>>3];ta=+h[Fa+2928>>3];K=+h[Fa+416>>3];Ba=c[c[F>>2]>>2]|0;oa=+h[(c[Ba+8>>2]|0)+13104>>3];ya=(+h[Fa+896>>3]+ +h[Fa+904>>3])*.5;ea=+h[Fa+2888>>3];do{if(Ea!=0.0){Ga=Fa;Ha=ea/Ea}else{if(ea==0.0){Ga=Fa;Ha=ea;break}za=ea/+qXa(c[A>>2]|0,Ea,56808,56800,+h[Ba>>3],(a[b+319|0]|0)!=0|0);Ga=c[C>>2]|0;Ha=za}}while(0);PD(p,o,ja,Da,Da,ta,ta,K,oa,ya,Ha,+h[Ga+2864>>3]);Ha=+h[p>>3];p=c[A>>2]|0;Ga=c[C>>2]|0;ya=+h[Ga+2840>>3];if(ya!=0.0){Ia=ya;Ja=ya;Ka=Ga}else{oa=+qXa(p,ya,56808,56800,+h[c[c[F>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);Ga=c[C>>2]|0;Ia=oa;Ja=+h[Ga+2840>>3];Ka=Ga}oa=1.0/Ia;Ia=+h[Ka+2920>>3];ya=+h[Ka+2928>>3];K=+h[Ka+424>>3];Ga=c[c[F>>2]>>2]|0;ta=+h[(c[Ga+8>>2]|0)+13096>>3];Da=(+h[Ka+904>>3]+ +h[Ka+912>>3])*.5;ja=+h[Ka+2888>>3];do{if(Ja!=0.0){La=Ka;Ma=ja/Ja}else{if(ja==0.0){La=Ka;Ma=ja;break}Ea=ja/+qXa(c[A>>2]|0,Ja,56808,56800,+h[Ga>>3],(a[b+319|0]|0)!=0|0);La=c[C>>2]|0;Ma=Ea}}while(0);PD(q,p,oa,Ia,Ia,ya,ya,K,ta,Da,Ma,+h[La+2864>>3]);Ma=+h[q>>3];q=c[A>>2]|0;La=c[C>>2]|0;Da=+h[La+2840>>3];if(Da!=0.0){Na=Da;Oa=Da;Pa=La}else{ta=+qXa(q,Da,56808,56800,+h[c[c[F>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);La=c[C>>2]|0;Na=ta;Oa=+h[La+2840>>3];Pa=La}ta=1.0/Na;Na=+h[Pa+2920>>3];Da=+h[Pa+2928>>3];K=+h[Pa+432>>3];La=c[c[F>>2]>>2]|0;ya=+h[(c[La+8>>2]|0)+13088>>3];Ia=(+h[Pa+912>>3]+ +h[Pa+920>>3])*.5;oa=+h[Pa+2888>>3];do{if(Oa!=0.0){Qa=Pa;Ra=oa/Oa}else{if(oa==0.0){Qa=Pa;Ra=oa;break}Ja=oa/+qXa(c[A>>2]|0,Oa,56808,56800,+h[La>>3],(a[b+319|0]|0)!=0|0);Qa=c[C>>2]|0;Ra=Ja}}while(0);PD(r,q,ta,Na,Na,Da,Da,K,ya,Ia,Ra,+h[Qa+2864>>3]);Ra=+h[r>>3];r=c[A>>2]|0;Qa=c[C>>2]|0;Ia=+h[Qa+2840>>3];if(Ia!=0.0){Sa=Ia;Ta=Ia;Ua=Qa}else{ya=+qXa(r,Ia,56808,56800,+h[c[c[F>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);Qa=c[C>>2]|0;Sa=ya;Ta=+h[Qa+2840>>3];Ua=Qa}ya=1.0/Sa;Sa=+h[Ua+2920>>3];Ia=+h[Ua+2928>>3];K=+h[Ua+440>>3];Qa=c[c[F>>2]>>2]|0;Da=+h[(c[Qa+8>>2]|0)+13080>>3];Na=(+h[Ua+920>>3]+ +h[Ua+928>>3])*.5;ta=+h[Ua+2888>>3];do{if(Ta!=0.0){Va=Ua;Wa=ta/Ta}else{if(ta==0.0){Va=Ua;Wa=ta;break}Oa=ta/+qXa(c[A>>2]|0,Ta,56808,56800,+h[Qa>>3],(a[b+319|0]|0)!=0|0);Va=c[C>>2]|0;Wa=Oa}}while(0);PD(s,r,ya,Sa,Sa,Ia,Ia,K,Da,Na,Wa,+h[Va+2864>>3]);Wa=+h[s>>3];s=c[A>>2]|0;Va=c[C>>2]|0;Na=+h[Va+2840>>3];if(Na!=0.0){Xa=Na;Ya=Na;Za=Va}else{Da=+qXa(s,Na,56808,56800,+h[c[c[F>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);Va=c[C>>2]|0;Xa=Da;Ya=+h[Va+2840>>3];Za=Va}Da=1.0/Xa;Xa=+h[Za+2920>>3];Na=+h[Za+2928>>3];K=+h[Za+448>>3];Va=c[c[F>>2]>>2]|0;Ia=+h[(c[Va+8>>2]|0)+13072>>3];Sa=(+h[Za+928>>3]+ +h[Za+936>>3])*.5;ya=+h[Za+2888>>3];do{if(Ya!=0.0){_a=Za;$a=ya/Ya}else{if(ya==0.0){_a=Za;$a=ya;break}Ta=ya/+qXa(c[A>>2]|0,Ya,56808,56800,+h[Va>>3],(a[b+319|0]|0)!=0|0);_a=c[C>>2]|0;$a=Ta}}while(0);PD(t,s,Da,Xa,Xa,Na,Na,K,Ia,Sa,$a,+h[_a+2864>>3]);$a=+h[t>>3];t=c[A>>2]|0;_a=c[C>>2]|0;Sa=+h[_a+2840>>3];if(Sa!=0.0){ab=Sa;bb=Sa;cb=_a}else{Ia=+qXa(t,Sa,56808,56800,+h[c[c[F>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);_a=c[C>>2]|0;ab=Ia;bb=+h[_a+2840>>3];cb=_a}Ia=1.0/ab;ab=+h[cb+2920>>3];Sa=+h[cb+2928>>3];K=+h[cb+456>>3];_a=c[c[F>>2]>>2]|0;Na=+h[(c[_a+8>>2]|0)+13064>>3];Xa=(+h[cb+936>>3]+ +h[cb+944>>3])*.5;Da=+h[cb+2888>>3];do{if(bb!=0.0){db=cb;eb=Da/bb}else{if(Da==0.0){db=cb;eb=Da;break}Ya=Da/+qXa(c[A>>2]|0,bb,56808,56800,+h[_a>>3],(a[b+319|0]|0)!=0|0);db=c[C>>2]|0;eb=Ya}}while(0);PD(u,t,Ia,ab,ab,Sa,Sa,K,Na,Xa,eb,+h[db+2864>>3]);eb=+h[u>>3];u=c[A>>2]|0;db=c[C>>2]|0;Xa=+h[db+2840>>3];if(Xa!=0.0){fb=Xa;gb=Xa;hb=db}else{Na=+qXa(u,Xa,56808,56800,+h[c[c[F>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);db=c[C>>2]|0;fb=Na;gb=+h[db+2840>>3];hb=db}Na=1.0/fb;fb=+h[hb+2920>>3];Xa=+h[hb+2928>>3];K=+h[hb+464>>3];db=c[c[F>>2]>>2]|0;Sa=+h[(c[db+8>>2]|0)+13056>>3];ab=(+h[hb+944>>3]+ +h[hb+952>>3])*.5;Ia=+h[hb+2888>>3];do{if(gb!=0.0){ib=hb;jb=Ia/gb}else{if(Ia==0.0){ib=hb;jb=Ia;break}bb=Ia/+qXa(c[A>>2]|0,gb,56808,56800,+h[db>>3],(a[b+319|0]|0)!=0|0);ib=c[C>>2]|0;jb=bb}}while(0);PD(v,u,Na,fb,fb,Xa,Xa,K,Sa,ab,jb,+h[ib+2864>>3]);jb=+h[v>>3];v=c[A>>2]|0;ib=c[C>>2]|0;ab=+h[ib+2840>>3];if(ab!=0.0){kb=ab;lb=ab;mb=ib}else{Sa=+qXa(v,ab,56808,56800,+h[c[c[F>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);ib=c[C>>2]|0;kb=Sa;lb=+h[ib+2840>>3];mb=ib}Sa=1.0/kb;kb=+h[mb+2920>>3];ab=+h[mb+2928>>3];K=+h[mb+472>>3];ib=c[c[F>>2]>>2]|0;Xa=+h[(c[ib+8>>2]|0)+13048>>3];fb=(+h[mb+952>>3]+ +h[mb+960>>3])*.5;Na=+h[mb+2888>>3];do{if(lb!=0.0){nb=mb;ob=Na/lb}else{if(Na==0.0){nb=mb;ob=Na;break}gb=Na/+qXa(c[A>>2]|0,lb,56808,56800,+h[ib>>3],(a[b+319|0]|0)!=0|0);nb=c[C>>2]|0;ob=gb}}while(0);PD(w,v,Sa,kb,kb,ab,ab,K,Xa,fb,ob,+h[nb+2864>>3]);ob=+h[w>>3];w=c[A>>2]|0;nb=c[C>>2]|0;fb=+h[nb+2840>>3];if(fb!=0.0){pb=fb;qb=fb;rb=nb}else{Xa=+qXa(w,fb,56808,56800,+h[c[c[F>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);nb=c[C>>2]|0;pb=Xa;qb=+h[nb+2840>>3];rb=nb}Xa=1.0/pb;pb=+h[rb+2920>>3];fb=+h[rb+2928>>3];K=+h[rb+480>>3];nb=c[c[F>>2]>>2]|0;ab=+h[(c[nb+8>>2]|0)+13040>>3];kb=(+h[rb+960>>3]+ +h[rb+968>>3])*.5;Sa=+h[rb+2888>>3];do{if(qb!=0.0){sb=rb;tb=Sa/qb}else{if(Sa==0.0){sb=rb;tb=Sa;break}lb=Sa/+qXa(c[A>>2]|0,qb,56808,56800,+h[nb>>3],(a[b+319|0]|0)!=0|0);sb=c[C>>2]|0;tb=lb}}while(0);PD(x,w,Xa,pb,pb,fb,fb,K,ab,kb,tb,+h[sb+2864>>3]);tb=+h[x>>3];x=c[A>>2]|0;sb=c[C>>2]|0;kb=+h[sb+2840>>3];if(kb!=0.0){ub=kb;vb=kb;wb=sb}else{ab=+qXa(x,kb,56808,56800,+h[c[c[F>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);sb=c[C>>2]|0;ub=ab;vb=+h[sb+2840>>3];wb=sb}ab=1.0/ub;ub=+h[wb+2920>>3];kb=+h[wb+2928>>3];K=+h[wb+488>>3];sb=c[c[F>>2]>>2]|0;fb=+h[(c[sb+8>>2]|0)+13032>>3];pb=(+h[wb+968>>3]+ +h[wb+976>>3])*.5;Xa=+h[wb+2888>>3];do{if(vb!=0.0){xb=wb;yb=Xa/vb}else{if(Xa==0.0){xb=wb;yb=Xa;break}qb=Xa/+qXa(c[A>>2]|0,vb,56808,56800,+h[sb>>3],(a[b+319|0]|0)!=0|0);xb=c[C>>2]|0;yb=qb}}while(0);PD(y,x,ab,ub,ub,kb,kb,K,fb,pb,yb,+h[xb+2864>>3]);yb=+h[y>>3];y=c[A>>2]|0;xb=c[C>>2]|0;pb=+h[xb+2840>>3];if(pb!=0.0){zb=pb;Ab=pb;Bb=xb}else{fb=+qXa(y,pb,56808,56800,+h[c[c[F>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);xb=c[C>>2]|0;zb=fb;Ab=+h[xb+2840>>3];Bb=xb}fb=1.0/zb;zb=+h[Bb+2920>>3];pb=+h[Bb+2928>>3];K=+h[Bb+496>>3];kb=+h[Bb+816>>3];ub=+h[Bb+976>>3];ab=(ub+ub)*.5;ub=+h[Bb+2888>>3];if(Ab!=0.0){Cb=Bb;Db=ub/Ab;Eb=Cb;Fb=Eb+2864|0;Gb=Fb;Hb=+h[Gb>>3];PD(z,y,fb,zb,zb,pb,pb,K,kb,ab,Db,Hb);Ib=z;Jb=Ib;Kb=+h[Jb>>3];Lb=yb+Kb;Mb=tb+Lb;Nb=ob+Mb;Ob=jb+Nb;Pb=eb+Ob;Qb=$a+Pb;Rb=Wa+Qb;Sb=Ra+Rb;Tb=Ma+Sb;Ub=Ha+Tb;Vb=Ca+Ub;Wb=xa+Vb;Xb=sa+Wb;Yb=na+Xb;Zb=ia+Yb;_b=da+Zb;$b=_+_b;ac=V+$b;bc=P+ac;cc=c[F>>2]|0;dc=c[cc>>2]|0;ec=dc;fc=ec+8|0;gc=fc;hc=c[gc>>2]|0;ic=hc;jc=ic+14728|0;kc=jc;h[kc>>3]=bc;i=d;return}if(ub==0.0){Cb=Bb;Db=ub;Eb=Cb;Fb=Eb+2864|0;Gb=Fb;Hb=+h[Gb>>3];PD(z,y,fb,zb,zb,pb,pb,K,kb,ab,Db,Hb);Ib=z;Jb=Ib;Kb=+h[Jb>>3];Lb=yb+Kb;Mb=tb+Lb;Nb=ob+Mb;Ob=jb+Nb;Pb=eb+Ob;Qb=$a+Pb;Rb=Wa+Qb;Sb=Ra+Rb;Tb=Ma+Sb;Ub=Ha+Tb;Vb=Ca+Ub;Wb=xa+Vb;Xb=sa+Wb;Yb=na+Xb;Zb=ia+Yb;_b=da+Zb;$b=_+_b;ac=V+$b;bc=P+ac;cc=c[F>>2]|0;dc=c[cc>>2]|0;ec=dc;fc=ec+8|0;gc=fc;hc=c[gc>>2]|0;ic=hc;jc=ic+14728|0;kc=jc;h[kc>>3]=bc;i=d;return}vb=ub/+qXa(c[A>>2]|0,Ab,56808,56800,+h[c[c[F>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);Cb=c[C>>2]|0;Db=vb;Eb=Cb;Fb=Eb+2864|0;Gb=Fb;Hb=+h[Gb>>3];PD(z,y,fb,zb,zb,pb,pb,K,kb,ab,Db,Hb);Ib=z;Jb=Ib;Kb=+h[Jb>>3];Lb=yb+Kb;Mb=tb+Lb;Nb=ob+Mb;Ob=jb+Nb;Pb=eb+Ob;Qb=$a+Pb;Rb=Wa+Qb;Sb=Ra+Rb;Tb=Ma+Sb;Ub=Ha+Tb;Vb=Ca+Ub;Wb=xa+Vb;Xb=sa+Wb;Yb=na+Xb;Zb=ia+Yb;_b=da+Zb;$b=_+_b;ac=V+$b;bc=P+ac;cc=c[F>>2]|0;dc=c[cc>>2]|0;ec=dc;fc=ec+8|0;gc=fc;hc=c[gc>>2]|0;ic=hc;jc=ic+14728|0;kc=jc;h[kc>>3]=bc;i=d;return}function W4(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12392>>3],+h[f+12384>>3],1.0e5,0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11016>>3]=+h[d>>3];i=b;return}function X4(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12376>>3],+h[f+12208>>3],1.0e5,0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11008>>3]=+h[d>>3];i=b;return}function Y4(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[c[b+356>>2]|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[c[b+356>>2]|0]|0;k=A_a(+h[c[c[b+4>>2]>>2]>>3],+h[(c[b+416>>2]|0)+3288>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=k;f=j;break}else{j=A_a(+h[c[c[b+4>>2]>>2]>>3],+h[(c[b+416>>2]|0)+3288>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=j;f=j;break}}else{if(g){g=a[c[b+356>>2]|0]|0;j=B_a(+h[c[c[b+4>>2]>>2]>>3],+h[(c[b+416>>2]|0)+3288>>3])|0;a[c[b+352>>2]|0]=j;f=g;break}else{g=B_a(+h[c[c[b+4>>2]>>2]>>3],+h[(c[b+416>>2]|0)+3288>>3])|0;a[c[b+352>>2]|0]=g;f=g;break}}}}while(0);if(!(f<<24>>24==0)){l=b+416|0;m=0.0;n=c[l>>2]|0;o=n;p=o+3280|0;q=p;r=+h[q>>3];s=m+r;t=b;u=t+4|0;v=u;w=c[v>>2]|0;x=c[w>>2]|0;y=x;z=y+8|0;A=z;B=c[A>>2]|0;C=B;D=C+14464|0;E=D;h[E>>3]=s;i=d;return}do{if((a[e]|0)==0){F=a[(c[b+356>>2]|0)+1|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){g=a[(c[b+356>>2]|0)+1|0]|0;j=c[b+416>>2]|0;k=A_a(+h[c[c[b+4>>2]>>2]>>3],+h[j+3288>>3]+ +h[j+3272>>3],a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=k;F=g;break}else{g=c[b+416>>2]|0;k=A_a(+h[c[c[b+4>>2]>>2]>>3],+h[g+3288>>3]+ +h[g+3272>>3],a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=k;F=k;break}}else{if(f){f=a[(c[b+356>>2]|0)+1|0]|0;k=c[b+416>>2]|0;g=B_a(+h[c[c[b+4>>2]>>2]>>3],+h[k+3288>>3]+ +h[k+3272>>3])|0;a[(c[b+352>>2]|0)+1|0]=g;F=f;break}else{f=c[b+416>>2]|0;g=B_a(+h[c[c[b+4>>2]>>2]>>3],+h[f+3288>>3]+ +h[f+3272>>3])|0;a[(c[b+352>>2]|0)+1|0]=g;F=g;break}}}}while(0);if(F<<24>>24==0){F=b+416|0;l=F;m=+h[(c[F>>2]|0)+3264>>3];n=c[l>>2]|0;o=n;p=o+3280|0;q=p;r=+h[q>>3];s=m+r;t=b;u=t+4|0;v=u;w=c[v>>2]|0;x=c[w>>2]|0;y=x;z=y+8|0;A=z;B=c[A>>2]|0;C=B;D=C+14464|0;E=D;h[E>>3]=s;i=d;return}G=+h[c[c[b+4>>2]>>2]>>3];F=b+416|0;e=c[F>>2]|0;H=G- +h[e+3288>>3];I=+h[e+3272>>3];J=+h[e+3264>>3];do{if(I!=0.0){K=J/I}else{if(J==0.0){K=J;break}K=J/+qXa(c[b+536>>2]|0,I,56848,56840,G,(a[b+319|0]|0)!=0|0)}}while(0);l=F;m=H*K;n=c[l>>2]|0;o=n;p=o+3280|0;q=p;r=+h[q>>3];s=m+r;t=b;u=t+4|0;v=u;w=c[v>>2]|0;x=c[w>>2]|0;y=x;z=y+8|0;A=z;B=c[A>>2]|0;C=B;D=C+14464|0;E=D;h[E>>3]=s;i=d;return}function Z4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+808>>3]=0.0;i=i;return}function _4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+824>>3]=0.0;i=i;return}function $4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+840>>3]=0.0;i=i;return}function a5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+856>>3]=0.0;i=i;return}function b5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+872>>3]=0.0;i=i;return}function c5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+888>>3]=0.0;i=i;return}function d5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+904>>3]=0.0;i=i;return}function e5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+920>>3]=0.0;i=i;return}function f5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+936>>3]=0.0;i=i;return}function g5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+952>>3]=0.0;i=i;return}function h5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+968>>3]=0.0;i=i;return}function i5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+984>>3]=0.0;i=i;return}function j5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1e3>>3]=0.0;i=i;return}function k5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1016>>3]=0.0;i=i;return}function l5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1032>>3]=0.0;i=i;return}function m5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1048>>3]=0.0;i=i;return}function n5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1064>>3]=0.0;i=i;return}function o5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1080>>3]=0.0;i=i;return}function p5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1096>>3]=0.0;i=i;return}function q5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1112>>3]=0.0;i=i;return}function r5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+800>>3]=0.0;i=i;return}function s5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+816>>3]=0.0;i=i;return}function t5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+832>>3]=0.0;i=i;return}function u5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+848>>3]=0.0;i=i;return}function v5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+864>>3]=0.0;i=i;return}function w5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+880>>3]=0.0;i=i;return}function x5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+896>>3]=0.0;i=i;return}function y5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+912>>3]=0.0;i=i;return}function z5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+928>>3]=0.0;i=i;return}function A5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+944>>3]=0.0;i=i;return}function B5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+960>>3]=0.0;i=i;return}function C5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+976>>3]=0.0;i=i;return}function D5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+992>>3]=0.0;i=i;return}function E5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1008>>3]=0.0;i=i;return}function F5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1024>>3]=0.0;i=i;return}function G5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1040>>3]=0.0;i=i;return}function H5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1056>>3]=0.0;i=i;return}function I5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1072>>3]=0.0;i=i;return}function J5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1088>>3]=0.0;i=i;return}function K5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1104>>3]=0.0;i=i;return}function L5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3128>>3]=+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14736>>3]*+h[b+3120>>3];i=i;return}function M5(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[d+3104>>3]=+h[b+14736>>3]+ +h[d+3136>>3]*+h[d+3152>>3]*(+h[b+12720>>3]+(+h[b+12728>>3]+(+h[b+12736>>3]+(+h[b+12744>>3]+(+h[b+12752>>3]+(+h[b+12760>>3]+(+h[b+12768>>3]+(+h[b+12776>>3]+(+h[b+12784>>3]+(+h[b+12792>>3]+(+h[b+12800>>3]+(+h[b+12808>>3]+(+h[b+12816>>3]+(+h[b+12824>>3]+(+h[b+12832>>3]+(+h[b+12840>>3]+(+h[b+12848>>3]+(+h[b+12856>>3]+(+h[b+12864>>3]+ +h[b+12872>>3])))))))))))))))))));i=i;return}function N5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1128>>3]=0.0;i=i;return}function O5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1144>>3]=0.0;i=i;return}function P5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1160>>3]=0.0;i=i;return}function Q5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1176>>3]=0.0;i=i;return}function R5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1192>>3]=0.0;i=i;return}function S5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1208>>3]=0.0;i=i;return}function T5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1224>>3]=0.0;i=i;return}function U5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1240>>3]=0.0;i=i;return}function V5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1256>>3]=0.0;i=i;return}function W5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1272>>3]=0.0;i=i;return}function X5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1288>>3]=0.0;i=i;return}function Y5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1304>>3]=0.0;i=i;return}function Z5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1320>>3]=0.0;i=i;return}function _5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1336>>3]=0.0;i=i;return}function $5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1352>>3]=0.0;i=i;return}function a6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1368>>3]=0.0;i=i;return}function b6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1384>>3]=0.0;i=i;return}function c6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1400>>3]=0.0;i=i;return}function d6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1416>>3]=0.0;i=i;return}function e6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1432>>3]=0.0;i=i;return}function f6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1120>>3]=0.0;i=i;return}function g6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1136>>3]=0.0;i=i;return}function h6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1152>>3]=0.0;i=i;return}function i6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1168>>3]=0.0;i=i;return}function j6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1184>>3]=0.0;i=i;return}function k6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1200>>3]=0.0;i=i;return}function l6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1216>>3]=0.0;i=i;return}function m6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1232>>3]=0.0;i=i;return}function n6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1248>>3]=0.0;i=i;return}function o6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1264>>3]=0.0;i=i;return}function p6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1280>>3]=0.0;i=i;return}function q6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1296>>3]=0.0;i=i;return}function r6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1312>>3]=0.0;i=i;return}function s6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1328>>3]=0.0;i=i;return}function t6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1344>>3]=0.0;i=i;return}function u6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1360>>3]=0.0;i=i;return}function v6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1376>>3]=0.0;i=i;return}function w6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1392>>3]=0.0;i=i;return}function x6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1408>>3]=0.0;i=i;return}function y6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1424>>3]=0.0;i=i;return}function z6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2896>>3]=+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14728>>3]*+h[b+2888>>3];i=i;return}function A6(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[d+2872>>3]=+h[b+14728>>3]+ +h[d+2904>>3]*+h[d+2920>>3]*(+h[b+12560>>3]+(+h[b+12568>>3]+(+h[b+12576>>3]+(+h[b+12584>>3]+(+h[b+12592>>3]+(+h[b+12600>>3]+(+h[b+12608>>3]+(+h[b+12616>>3]+(+h[b+12624>>3]+(+h[b+12632>>3]+(+h[b+12640>>3]+(+h[b+12648>>3]+(+h[b+12656>>3]+(+h[b+12664>>3]+(+h[b+12672>>3]+(+h[b+12680>>3]+(+h[b+12688>>3]+(+h[b+12696>>3]+(+h[b+12704>>3]+ +h[b+12712>>3])))))))))))))))))));i=i;return}function B6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1592>>3]=0.0;i=i;return}function C6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1584>>3]=0.0;i=i;return}function D6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1576>>3]=0.0;i=i;return}function E6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1568>>3]=0.0;i=i;return}function F6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1560>>3]=0.0;i=i;return}function G6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1552>>3]=0.0;i=i;return}function H6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1544>>3]=0.0;i=i;return}function I6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1536>>3]=0.0;i=i;return}function J6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1528>>3]=0.0;i=i;return}function K6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1520>>3]=0.0;i=i;return}function L6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1512>>3]=0.0;i=i;return}function M6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1504>>3]=0.0;i=i;return}function N6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1496>>3]=0.0;i=i;return}function O6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1488>>3]=0.0;i=i;return}function P6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1480>>3]=0.0;i=i;return}function Q6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1472>>3]=0.0;i=i;return}function R6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1464>>3]=0.0;i=i;return}function S6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1456>>3]=0.0;i=i;return}function T6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1448>>3]=0.0;i=i;return}function U6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1440>>3]=0.0;i=i;return}



function rV(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2704>>3]=(+h[b+1768>>3]+ +h[b+1776>>3])*(+h[d+24>>3]- +h[d+40>>3])*+h[b+3072>>3]*.5;i=i;return}function sV(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3072>>3]*(+h[e+1768>>3]+ +h[e+1776>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2704>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+2544|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+2544|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,49536,49528,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+2544|0;q=p;h[q>>3]=n;i=d;return}function tV(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3672>>3]=+h[b+1736>>3]*+h[d+1768>>3]*+h[d+2968>>3]*(+h[b+24>>3]*.5+(+h[b+56>>3]*-.5+(+h[b+2536>>3]+ +h[b+2544>>3])*.5));i=i;return}function uV(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+24>>3],+h[a+16>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+24>>3];l=+h[g+16>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12544>>3]=+h[f>>3];i=b;return}function vV(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4320>>3]=+h[b+14128>>3]*+h[b+12544>>3];i=i;return}function wV(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12544>>3],+h[f+16>>3],+h[f+24>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11168>>3]=+h[d>>3];i=b;return}function xV(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+12544>>3];k=+h[g+10680>>3];l=j*j;m=+h[g+24>>3]*+h[g+10832>>3]-j*+h[g+824>>3];if(l!=0.0){n=g;o=m/l;p=k+o;q=n;r=q+9904|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=k+o;q=n;r=q+9904|0;s=r;h[s>>3]=p;i=d;return}j=m/+qXa(c[b+536>>2]|0,l,49640,49632,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=k+o;q=n;r=q+9904|0;s=r;h[s>>3]=p;i=d;return}function yV(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1776>>3]*+h[j+12544>>3]*+h[e+2968>>3];l=+h[j+3384>>3]+ +h[j+3376>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1744|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1744|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,49688,49680,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1744|0;r=q;h[r>>3]=o;i=d;return}function zV(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+24>>3],+h[a+16>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+24>>3];l=+h[g+16>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4496>>3]=+h[f>>3];i=b;return}function AV(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4496>>3];k=+h[g+12544>>3];l=+h[g+24>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,49784,49776,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+1816>>3]=j-n;i=d;return}function BV(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10224>>3]=+h[b+4320>>3]*+h[b+9904>>3]+ +h[b+4160>>3]*+h[b+1816>>3];i=i;return}function CV(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3384>>3];h[b+3352>>3]=d*+h[(!(d>=0.0)?b+4496|0:b+4504|0)>>3];i=i;return}function DV(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3992>>3]=+h[b+3344>>3]- +h[b+3352>>3];i=i;return}function EV(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;XE(e,c[g>>2]|0,+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+8>>3],360.0,0);a=c[g>>2]|0;k=+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+8>>3];g=d+0|0;l=e+0|0;e=g+120|0;do{c[g>>2]=c[l>>2];g=g+4|0;l=l+4|0}while((g|0)<(e|0));aF(f,a,k,360.0,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+14544>>3]=+h[f>>3];i=b;return}function FV(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2712>>3]=(+h[b+1776>>3]+ +h[b+1784>>3])*(+h[d+8>>3]- +h[d+24>>3])*+h[b+3072>>3]*.5;i=i;return}function GV(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3072>>3]*(+h[e+1776>>3]+ +h[e+1784>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2712>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+2552|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+2552|0;q=p;h[q>>3]=n;i=d;return}r=k/+qXa(c[b+536>>2]|0,f,49824,49816,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+2552|0;q=p;h[q>>3]=n;i=d;return}function HV(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3680>>3]=+h[b+1744>>3]*+h[d+1776>>3]*+h[d+2968>>3]*(+h[b+8>>3]*.5+(+h[b+40>>3]*-.5+(+h[b+2544>>3]+ +h[b+2552>>3])*.5));i=i;return}function IV(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+8>>3],+h[a>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+8>>3];l=+h[g>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));dF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+12552>>3]=+h[f>>3];i=b;return}function JV(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4328>>3]=+h[b+14136>>3]*+h[b+12552>>3];i=i;return}function KV(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;VD(d,c[a+536>>2]|0,+h[f+12552>>3],+h[f>>3],+h[f+8>>3],1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+11176>>3]=+h[d>>3];i=b;return}function LV(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+12552>>3];k=+h[g+14648>>3];l=j*j;m=+h[g+8>>3]*+h[g+10840>>3]-j*+h[g+808>>3];if(l!=0.0){n=g;o=m/l;p=k+o;q=n;r=q+9912|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){n=g;o=m;p=k+o;q=n;r=q+9912|0;s=r;h[s>>3]=p;i=d;return}j=m/+qXa(c[b+536>>2]|0,l,49928,49920,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=j;p=k+o;q=n;r=q+9912|0;s=r;h[s>>3]=p;i=d;return}function MV(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1784>>3]*+h[j+12552>>3]*+h[e+2968>>3];l=+h[j+3376>>3]- +h[j+14464>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1752|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1752|0;r=q;h[r>>3]=o;i=d;return}s=l/+qXa(c[b+536>>2]|0,k,49976,49968,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1752|0;r=q;h[r>>3]=o;i=d;return}function NV(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3688>>3]=+h[b+1752>>3]*+h[d+1784>>3]*+h[d+2968>>3]*(+h[b+8>>3]*.5+(+h[b+24>>3]*-.5+ +h[b+2552>>3]*.5));i=i;return}function OV(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;XE(e,c[g>>2]|0,+h[a+8>>3],+h[a>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+8>>3];l=+h[g>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));aF(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+14592>>3]=+h[f>>3];i=b;return}function PV(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+14592>>3];k=+h[g+12552>>3];l=+h[g+8>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+qXa(c[b+536>>2]|0,k,50072,50064,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+1784>>3]=j-n;i=d;return}function QV(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10232>>3]=+h[b+4328>>3]*+h[b+9912>>3]+ +h[b+4168>>3]*+h[b+1784>>3];i=i;return}function RV(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+14464>>3];h[b+3368>>3]=-(d*+h[(!(d>=0.0)?b+14592|0:b+14544|0)>>3]);i=i;return}function SV(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+3376>>3];h[b+3360>>3]=d*+h[(!(d>=0.0)?b+14592|0:b+4496|0)>>3];i=i;return}function TV(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4e3>>3]=+h[b+3352>>3]- +h[b+3360>>3];i=i;return}function UV(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3840>>3]=+h[b+10224>>3]+(-+h[b+4e3>>3]- +h[b+3680>>3]);i=i;return}function VV(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+8344>>3]=-(+h[b+2696>>3]*+h[b+8>>3]*+h[d+1448>>3])- +h[d+3840>>3];i=i;return}function WV(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4008>>3]=+h[b+3360>>3]- +h[b+3368>>3];i=i;return}function XV(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+2704>>3];g=b+4|0;j=c[c[g>>2]>>2]|0;k=c[j+8>>2]|0;l=+h[k+9280>>3]- +h[k+640>>3];m=+h[e+2672>>3];n=+h[e+2680>>3];do{if(m!=0.0){o=k;p=n/m}else{if(n==0.0){o=k;p=n;break}q=n/+qXa(c[b+536>>2]|0,m,40376,50104,+h[j>>3],(a[b+319|0]|0)!=0|0);o=c[(c[c[g>>2]>>2]|0)+8>>2]|0;p=q}}while(0);h[o+3848>>3]=f*l*p*-.05;i=d;return}function YV(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+8336>>3]=-(+h[b+2696>>3]*+h[b>>3]*+h[d+1440>>3])- +h[d+3848>>3];i=i;return}function ZV(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=a+8|0;a=c[d>>2]|0;e=b+16|0;f=c[e>>2]|0;h[f>>3]=+h[a+130112>>3];g=b+8|0;j=c[g>>2]|0;h[j>>3]=+h[a+130088>>3];k=b+12|0;b=c[k>>2]|0;h[b>>3]=+h[a+130096>>3];h[f+8>>3]=+h[a+9152>>3];h[j+8>>3]=+h[a+9128>>3];h[b+8>>3]=+h[a+9136>>3];h[f+16>>3]=+h[a+131680>>3];h[j+16>>3]=+h[a+131656>>3];h[b+16>>3]=+h[a+131664>>3];h[f+24>>3]=+h[a+10720>>3];h[j+24>>3]=+h[a+10696>>3];h[b+24>>3]=+h[a+10704>>3];h[f+32>>3]=+h[a+7584>>3];h[j+32>>3]=+h[a+7560>>3];h[b+32>>3]=+h[a+7568>>3];h[f+40>>3]=+h[a+130672>>3];h[j+40>>3]=+h[a+130648>>3];h[b+40>>3]=+h[a+130656>>3];h[f+48>>3]=+h[a+9712>>3];h[j+48>>3]=+h[a+9688>>3];h[b+48>>3]=+h[a+9696>>3];h[f+56>>3]=+h[a+132912>>3];h[j+56>>3]=+h[a+132888>>3];h[b+56>>3]=+h[a+132896>>3];a=c[d>>2]|0;j=c[e>>2]|0;h[j+64>>3]=+h[a+65712>>3];f=c[g>>2]|0;h[f+64>>3]=+h[a+65688>>3];h[b+64>>3]=+h[a+65696>>3];h[j+72>>3]=+h[a+7472>>3];h[f+72>>3]=+h[a+7448>>3];b=c[k>>2]|0;h[b+72>>3]=+h[a+7456>>3];h[j+80>>3]=+h[a+130784>>3];h[f+80>>3]=+h[a+130760>>3];h[b+80>>3]=+h[a+130768>>3];h[j+88>>3]=+h[a+9824>>3];h[f+88>>3]=+h[a+9800>>3];h[b+88>>3]=+h[a+9808>>3];h[j+96>>3]=+h[a+133024>>3];h[f+96>>3]=+h[a+133e3>>3];h[b+96>>3]=+h[a+133008>>3];h[j+104>>3]=+h[a+65824>>3];h[f+104>>3]=+h[a+65800>>3];h[b+104>>3]=+h[a+65808>>3];h[j+112>>3]=+h[a+7248>>3];h[f+112>>3]=+h[a+7224>>3];h[b+112>>3]=+h[a+7232>>3];h[j+120>>3]=+h[a+7360>>3];h[f+120>>3]=+h[a+7336>>3];h[b+120>>3]=+h[a+7344>>3];a=c[d>>2]|0;f=c[e>>2]|0;h[f+128>>3]=+h[a+6912>>3];j=c[g>>2]|0;h[j+128>>3]=+h[a+6888>>3];h[b+128>>3]=+h[a+6896>>3];h[f+136>>3]=+h[a+130896>>3];h[j+136>>3]=+h[a+130872>>3];b=c[k>>2]|0;h[b+136>>3]=+h[a+130880>>3];h[f+144>>3]=+h[a+9936>>3];h[j+144>>3]=+h[a+9912>>3];h[b+144>>3]=+h[a+9920>>3];h[f+152>>3]=+h[a+133136>>3];h[j+152>>3]=+h[a+133112>>3];h[b+152>>3]=+h[a+133120>>3];h[f+160>>3]=+h[a+65936>>3];h[j+160>>3]=+h[a+65912>>3];h[b+160>>3]=+h[a+65920>>3];h[f+168>>3]=+h[a+7024>>3];h[j+168>>3]=+h[a+7e3>>3];h[b+168>>3]=+h[a+7008>>3];h[f+176>>3]=+h[a+7136>>3];h[j+176>>3]=+h[a+7112>>3];h[b+176>>3]=+h[a+7120>>3];h[f+184>>3]=+h[a+6800>>3];h[j+184>>3]=+h[a+6776>>3];h[b+184>>3]=+h[a+6784>>3];a=c[d>>2]|0;j=c[e>>2]|0;h[j+192>>3]=+h[a+131008>>3];f=c[g>>2]|0;h[f+192>>3]=+h[a+130984>>3];h[b+192>>3]=+h[a+130992>>3];h[j+200>>3]=+h[a+10048>>3];h[f+200>>3]=+h[a+10024>>3];b=c[k>>2]|0;h[b+200>>3]=+h[a+10032>>3];h[j+208>>3]=+h[a+133248>>3];h[f+208>>3]=+h[a+133224>>3];h[b+208>>3]=+h[a+133232>>3];h[j+216>>3]=+h[a+66048>>3];h[f+216>>3]=+h[a+66024>>3];h[b+216>>3]=+h[a+66032>>3];h[j+224>>3]=+h[a+6688>>3];h[f+224>>3]=+h[a+6664>>3];h[b+224>>3]=+h[a+6672>>3];h[j+232>>3]=+h[a+131120>>3];h[f+232>>3]=+h[a+131096>>3];h[b+232>>3]=+h[a+131104>>3];h[j+240>>3]=+h[a+10160>>3];h[f+240>>3]=+h[a+10136>>3];h[b+240>>3]=+h[a+10144>>3];h[j+248>>3]=+h[a+133360>>3];h[f+248>>3]=+h[a+133336>>3];h[b+248>>3]=+h[a+133344>>3];a=c[d>>2]|0;f=c[e>>2]|0;h[f+256>>3]=+h[a+66160>>3];j=c[g>>2]|0;h[j+256>>3]=+h[a+66136>>3];h[b+256>>3]=+h[a+66144>>3];h[f+264>>3]=+h[a+6576>>3];h[j+264>>3]=+h[a+6552>>3];b=c[k>>2]|0;h[b+264>>3]=+h[a+6560>>3];h[f+272>>3]=+h[a+6240>>3];h[j+272>>3]=+h[a+6216>>3];h[b+272>>3]=+h[a+6224>>3];h[f+280>>3]=+h[a+6464>>3];h[j+280>>3]=+h[a+6440>>3];h[b+280>>3]=+h[a+6448>>3];h[f+288>>3]=+h[a+131232>>3];h[j+288>>3]=+h[a+131208>>3];h[b+288>>3]=+h[a+131216>>3];h[f+296>>3]=+h[a+10272>>3];h[j+296>>3]=+h[a+10248>>3];h[b+296>>3]=+h[a+10256>>3];h[f+304>>3]=+h[a+133472>>3];h[j+304>>3]=+h[a+133448>>3];h[b+304>>3]=+h[a+133456>>3];h[f+312>>3]=+h[a+66272>>3];h[j+312>>3]=+h[a+66248>>3];h[b+312>>3]=+h[a+66256>>3];a=c[d>>2]|0;j=c[e>>2]|0;h[j+320>>3]=+h[a+6352>>3];f=c[g>>2]|0;h[f+320>>3]=+h[a+6328>>3];h[b+320>>3]=+h[a+6336>>3];h[j+328>>3]=+h[a+6128>>3];h[f+328>>3]=+h[a+6104>>3];b=c[k>>2]|0;h[b+328>>3]=+h[a+6112>>3];h[j+336>>3]=+h[a+131344>>3];h[f+336>>3]=+h[a+131320>>3];h[b+336>>3]=+h[a+131328>>3];h[j+344>>3]=+h[a+10384>>3];h[f+344>>3]=+h[a+10360>>3];h[b+344>>3]=+h[a+10368>>3];h[j+352>>3]=+h[a+133584>>3];h[f+352>>3]=+h[a+133560>>3];h[b+352>>3]=+h[a+133568>>3];h[j+360>>3]=+h[a+66384>>3];h[f+360>>3]=+h[a+66360>>3];h[b+360>>3]=+h[a+66368>>3];h[j+368>>3]=+h[a+6016>>3];h[f+368>>3]=+h[a+5992>>3];h[b+368>>3]=+h[a+6e3>>3];h[j+376>>3]=+h[a+5904>>3];h[f+376>>3]=+h[a+5880>>3];h[b+376>>3]=+h[a+5888>>3];a=c[d>>2]|0;f=c[e>>2]|0;h[f+384>>3]=+h[a+131456>>3];j=c[g>>2]|0;h[j+384>>3]=+h[a+131432>>3];h[b+384>>3]=+h[a+131440>>3];h[f+392>>3]=+h[a+10496>>3];h[j+392>>3]=+h[a+10472>>3];b=c[k>>2]|0;h[b+392>>3]=+h[a+10480>>3];h[f+400>>3]=+h[a+133696>>3];h[j+400>>3]=+h[a+133672>>3];h[b+400>>3]=+h[a+133680>>3];h[f+408>>3]=+h[a+66496>>3];h[j+408>>3]=+h[a+66472>>3];h[b+408>>3]=+h[a+66480>>3];h[f+416>>3]=+h[a+5568>>3];h[j+416>>3]=+h[a+5544>>3];h[b+416>>3]=+h[a+5552>>3];h[f+424>>3]=+h[a+5792>>3];h[j+424>>3]=+h[a+5768>>3];h[b+424>>3]=+h[a+5776>>3];h[f+432>>3]=+h[a+131568>>3];h[j+432>>3]=+h[a+131544>>3];h[b+432>>3]=+h[a+131552>>3];h[f+440>>3]=+h[a+10608>>3];h[j+440>>3]=+h[a+10584>>3];h[b+440>>3]=+h[a+10592>>3];a=c[d>>2]|0;j=c[e>>2]|0;h[j+448>>3]=+h[a+133808>>3];f=c[g>>2]|0;h[f+448>>3]=+h[a+133784>>3];h[b+448>>3]=+h[a+133792>>3];h[j+456>>3]=+h[a+66608>>3];h[f+456>>3]=+h[a+66584>>3];b=c[k>>2]|0;h[b+456>>3]=+h[a+66592>>3];h[j+464>>3]=+h[a+5680>>3];h[f+464>>3]=+h[a+5656>>3];h[b+464>>3]=+h[a+5664>>3];h[j+472>>3]=+h[a+5456>>3];h[f+472>>3]=+h[a+5432>>3];h[b+472>>3]=+h[a+5440>>3];h[j+480>>3]=+h[a+66720>>3];h[f+480>>3]=+h[a+66696>>3];h[b+480>>3]=+h[a+66704>>3];h[j+488>>3]=+h[a+133920>>3];h[f+488>>3]=+h[a+133896>>3];h[b+488>>3]=+h[a+133904>>3];h[j+496>>3]=+h[a+5344>>3];h[f+496>>3]=+h[a+5320>>3];h[b+496>>3]=+h[a+5328>>3];h[j+504>>3]=+h[a+10832>>3];h[f+504>>3]=+h[a+10808>>3];h[b+504>>3]=+h[a+10816>>3];a=c[d>>2]|0;f=c[e>>2]|0;h[f+512>>3]=+h[a+134032>>3];j=c[g>>2]|0;h[j+512>>3]=+h[a+134008>>3];h[b+512>>3]=+h[a+134016>>3];h[f+520>>3]=+h[a+66832>>3];h[j+520>>3]=+h[a+66808>>3];b=c[k>>2]|0;h[b+520>>3]=+h[a+66816>>3];h[f+528>>3]=+h[a+5232>>3];h[j+528>>3]=+h[a+5208>>3];h[b+528>>3]=+h[a+5216>>3];h[f+536>>3]=+h[a+5120>>3];h[j+536>>3]=+h[a+5096>>3];h[b+536>>3]=+h[a+5104>>3];h[f+544>>3]=+h[a+4672>>3];h[j+544>>3]=+h[a+4648>>3];h[b+544>>3]=+h[a+4656>>3];h[f+552>>3]=+h[a+4448>>3];h[j+552>>3]=+h[a+4424>>3];h[b+552>>3]=+h[a+4432>>3];h[f+560>>3]=+h[a+4336>>3];h[j+560>>3]=+h[a+4312>>3];h[b+560>>3]=+h[a+4320>>3];h[f+568>>3]=+h[a+132128>>3];h[j+568>>3]=+h[a+132104>>3];h[b+568>>3]=+h[a+132112>>3];a=c[d>>2]|0;j=c[e>>2]|0;h[j+576>>3]=+h[a+11168>>3];f=c[g>>2]|0;h[f+576>>3]=+h[a+11144>>3];h[b+576>>3]=+h[a+11152>>3];h[j+584>>3]=+h[a+134368>>3];h[f+584>>3]=+h[a+134344>>3];b=c[k>>2]|0;h[b+584>>3]=+h[a+134352>>3];h[j+592>>3]=+h[a+67168>>3];h[f+592>>3]=+h[a+67144>>3];h[b+592>>3]=+h[a+67152>>3];h[j+600>>3]=+h[a+4560>>3];h[f+600>>3]=+h[a+4536>>3];h[b+600>>3]=+h[a+4544>>3];h[j+608>>3]=+h[a+67056>>3];h[f+608>>3]=+h[a+67032>>3];h[b+608>>3]=+h[a+67040>>3];h[j+616>>3]=+h[a+4784>>3];h[f+616>>3]=+h[a+4760>>3];h[b+616>>3]=+h[a+4768>>3];h[j+624>>3]=+h[a+4896>>3];h[f+624>>3]=+h[a+4872>>3];h[b+624>>3]=+h[a+4880>>3];h[j+632>>3]=+h[a+66944>>3];h[f+632>>3]=+h[a+66920>>3];h[b+632>>3]=+h[a+66928>>3];a=c[d>>2]|0;f=c[e>>2]|0;h[f+640>>3]=+h[a+134144>>3];j=c[g>>2]|0;h[j+640>>3]=+h[a+134120>>3];h[b+640>>3]=+h[a+134128>>3];h[f+648>>3]=+h[a+3888>>3];h[j+648>>3]=+h[a+3864>>3];b=c[k>>2]|0;h[b+648>>3]=+h[a+3872>>3];h[f+656>>3]=+h[a+131904>>3];h[j+656>>3]=+h[a+131880>>3];h[b+656>>3]=+h[a+131888>>3];h[f+664>>3]=+h[a+10944>>3];h[j+664>>3]=+h[a+10920>>3];h[b+664>>3]=+h[a+10928>>3];h[f+672>>3]=+h[a+5008>>3];h[j+672>>3]=+h[a+4984>>3];h[b+672>>3]=+h[a+4992>>3];h[f+680>>3]=+h[a+134256>>3];h[j+680>>3]=+h[a+134232>>3];h[b+680>>3]=+h[a+134240>>3];h[f+688>>3]=+h[a+11056>>3];h[j+688>>3]=+h[a+11032>>3];h[b+688>>3]=+h[a+11040>>3];h[f+696>>3]=+h[a+132016>>3];h[j+696>>3]=+h[a+131992>>3];h[b+696>>3]=+h[a+132e3>>3];a=c[d>>2]|0;j=c[e>>2]|0;h[j+704>>3]=+h[a+4112>>3];f=c[g>>2]|0;h[f+704>>3]=+h[a+4088>>3];h[b+704>>3]=+h[a+4096>>3];h[j+712>>3]=+h[a+3552>>3];h[f+712>>3]=+h[a+3528>>3];b=c[k>>2]|0;h[b+712>>3]=+h[a+3536>>3];h[j+720>>3]=+h[a+3776>>3];h[f+720>>3]=+h[a+3752>>3];h[b+720>>3]=+h[a+3760>>3];h[j+728>>3]=+h[a+4e3>>3];h[f+728>>3]=+h[a+3976>>3];h[b+728>>3]=+h[a+3984>>3];h[j+736>>3]=+h[a+4224>>3];h[f+736>>3]=+h[a+4200>>3];h[b+736>>3]=+h[a+4208>>3];h[j+744>>3]=+h[a+3664>>3];h[f+744>>3]=+h[a+3640>>3];h[b+744>>3]=+h[a+3648>>3];h[j+752>>3]=+h[a+131792>>3];h[f+752>>3]=+h[a+131768>>3];h[b+752>>3]=+h[a+131776>>3];h[j+760>>3]=+h[a+3440>>3];h[f+760>>3]=+h[a+3416>>3];h[b+760>>3]=+h[a+3424>>3];a=c[d>>2]|0;f=c[e>>2]|0;h[f+768>>3]=+h[a+3328>>3];j=c[g>>2]|0;h[j+768>>3]=+h[a+3304>>3];h[b+768>>3]=+h[a+3312>>3];h[f+776>>3]=+h[a+3216>>3];h[j+776>>3]=+h[a+3192>>3];b=c[k>>2]|0;h[b+776>>3]=+h[a+3200>>3];h[f+784>>3]=+h[a+2880>>3];h[j+784>>3]=+h[a+2856>>3];h[b+784>>3]=+h[a+2864>>3];h[f+792>>3]=+h[a+2992>>3];h[j+792>>3]=+h[a+2968>>3];h[b+792>>3]=+h[a+2976>>3];h[f+800>>3]=+h[a+3104>>3];h[j+800>>3]=+h[a+3080>>3];h[b+800>>3]=+h[a+3088>>3];h[f+808>>3]=+h[a+2768>>3];h[j+808>>3]=+h[a+2744>>3];h[b+808>>3]=+h[a+2752>>3];h[f+816>>3]=+h[a+2656>>3];h[j+816>>3]=+h[a+2632>>3];h[b+816>>3]=+h[a+2640>>3];h[f+824>>3]=+h[a+2544>>3];h[j+824>>3]=+h[a+2520>>3];h[b+824>>3]=+h[a+2528>>3];a=c[d>>2]|0;j=c[e>>2]|0;h[j+832>>3]=+h[a+9376>>3];f=c[g>>2]|0;h[f+832>>3]=+h[a+9352>>3];h[b+832>>3]=+h[a+9360>>3];h[j+840>>3]=+h[a+130336>>3];h[f+840>>3]=+h[a+130312>>3];b=c[k>>2]|0;h[b+840>>3]=+h[a+130320>>3];h[j+848>>3]=+h[a+1088>>3];h[f+848>>3]=+h[a+1064>>3];h[b+848>>3]=+h[a+1072>>3];h[j+856>>3]=+h[a+864>>3];h[f+856>>3]=+h[a+840>>3];h[b+856>>3]=+h[a+848>>3];h[j+864>>3]=+h[a+752>>3];h[f+864>>3]=+h[a+728>>3];h[b+864>>3]=+h[a+736>>3];h[j+872>>3]=+h[a+976>>3];h[f+872>>3]=+h[a+952>>3];h[b+872>>3]=+h[a+960>>3];h[j+880>>3]=+h[a+1312>>3];h[f+880>>3]=+h[a+1288>>3];h[b+880>>3]=+h[a+1296>>3];h[j+888>>3]=+h[a+1536>>3];h[f+888>>3]=+h[a+1512>>3];h[b+888>>3]=+h[a+1520>>3];a=c[d>>2]|0;f=c[e>>2]|0;h[f+896>>3]=+h[a+1760>>3];j=c[g>>2]|0;h[j+896>>3]=+h[a+1736>>3];h[b+896>>3]=+h[a+1744>>3];h[f+904>>3]=+h[a+1984>>3];h[j+904>>3]=+h[a+1960>>3];b=c[k>>2]|0;h[b+904>>3]=+h[a+1968>>3];h[f+912>>3]=+h[a+2208>>3];h[j+912>>3]=+h[a+2184>>3];h[b+912>>3]=+h[a+2192>>3];h[f+920>>3]=+h[a+2432>>3];h[j+920>>3]=+h[a+2408>>3];h[b+920>>3]=+h[a+2416>>3];h[f+928>>3]=+h[a+2320>>3];h[j+928>>3]=+h[a+2296>>3];h[b+928>>3]=+h[a+2304>>3];h[f+936>>3]=+h[a+2096>>3];h[j+936>>3]=+h[a+2072>>3];h[b+936>>3]=+h[a+2080>>3];h[f+944>>3]=+h[a+1872>>3];h[j+944>>3]=+h[a+1848>>3];h[b+944>>3]=+h[a+1856>>3];h[f+952>>3]=+h[a+1648>>3];h[j+952>>3]=+h[a+1624>>3];h[b+952>>3]=+h[a+1632>>3];a=c[d>>2]|0;j=c[e>>2]|0;h[j+960>>3]=+h[a+1424>>3];f=c[g>>2]|0;h[f+960>>3]=+h[a+1400>>3];h[b+960>>3]=+h[a+1408>>3];h[j+968>>3]=+h[a+130448>>3];h[f+968>>3]=+h[a+130424>>3];b=c[k>>2]|0;h[b+968>>3]=+h[a+130432>>3];h[j+976>>3]=+h[a+65488>>3];h[f+976>>3]=+h[a+65464>>3];h[b+976>>3]=+h[a+65472>>3];h[j+984>>3]=+h[a+132688>>3];h[f+984>>3]=+h[a+132664>>3];h[b+984>>3]=+h[a+132672>>3];h[j+992>>3]=+h[a+9488>>3];h[f+992>>3]=+h[a+9464>>3];h[b+992>>3]=+h[a+9472>>3];h[j+1e3>>3]=+h[a+1200>>3];h[f+1e3>>3]=+h[a+1176>>3];h[b+1e3>>3]=+h[a+1184>>3];h[j+1008>>3]=+h[a+130560>>3];h[f+1008>>3]=+h[a+130536>>3];h[b+1008>>3]=+h[a+130544>>3];h[j+1016>>3]=+h[a+9600>>3];h[f+1016>>3]=+h[a+9576>>3];h[b+1016>>3]=+h[a+9584>>3];a=c[d>>2]|0;f=c[e>>2]|0;h[f+1024>>3]=+h[a+132800>>3];j=c[g>>2]|0;h[j+1024>>3]=+h[a+132776>>3];h[b+1024>>3]=+h[a+132784>>3];h[f+1032>>3]=+h[a+65600>>3];h[j+1032>>3]=+h[a+65576>>3];b=c[k>>2]|0;h[b+1032>>3]=+h[a+65584>>3];h[f+1040>>3]=+h[a+7696>>3];h[j+1040>>3]=+h[a+7672>>3];h[b+1040>>3]=+h[a+7680>>3];h[f+1048>>3]=+h[a+7808>>3];h[j+1048>>3]=+h[a+7784>>3];h[b+1048>>3]=+h[a+7792>>3];h[f+1056>>3]=+h[a+8032>>3];h[j+1056>>3]=+h[a+8008>>3];h[b+1056>>3]=+h[a+8016>>3];h[f+1064>>3]=+h[a+7920>>3];h[j+1064>>3]=+h[a+7896>>3];h[b+1064>>3]=+h[a+7904>>3];h[f+1072>>3]=+h[a+8256>>3];h[j+1072>>3]=+h[a+8232>>3];h[b+1072>>3]=+h[a+8240>>3];h[f+1080>>3]=+h[a+8144>>3];h[j+1080>>3]=+h[a+8120>>3];h[b+1080>>3]=+h[a+8128>>3];a=c[d>>2]|0;j=c[e>>2]|0;h[j+1088>>3]=+h[a+132576>>3];f=c[g>>2]|0;h[f+1088>>3]=+h[a+132552>>3];h[b+1088>>3]=+h[a+132560>>3];h[j+1096>>3]=+h[a+65376>>3];h[f+1096>>3]=+h[a+65352>>3];b=c[k>>2]|0;h[b+1096>>3]=+h[a+65360>>3];h[j+1104>>3]=+h[a+132240>>3];h[f+1104>>3]=+h[a+132216>>3];h[b+1104>>3]=+h[a+132224>>3];h[j+1112>>3]=+h[a+65040>>3];h[f+1112>>3]=+h[a+65016>>3];h[b+1112>>3]=+h[a+65024>>3];h[j+1120>>3]=+h[a+8928>>3];h[f+1120>>3]=+h[a+8904>>3];h[b+1120>>3]=+h[a+8912>>3];h[j+1128>>3]=+h[a+8816>>3];h[f+1128>>3]=+h[a+8792>>3];h[b+1128>>3]=+h[a+8800>>3];h[j+1136>>3]=+h[a+65152>>3];h[f+1136>>3]=+h[a+65128>>3];h[b+1136>>3]=+h[a+65136>>3];h[j+1144>>3]=+h[a+8592>>3];h[f+1144>>3]=+h[a+8568>>3];h[b+1144>>3]=+h[a+8576>>3];a=c[d>>2]|0;f=c[e>>2]|0;h[f+1152>>3]=+h[a+132352>>3];j=c[g>>2]|0;h[j+1152>>3]=+h[a+132328>>3];h[b+1152>>3]=+h[a+132336>>3];h[f+1160>>3]=+h[a+8704>>3];h[j+1160>>3]=+h[a+8680>>3];b=c[k>>2]|0;h[b+1160>>3]=+h[a+8688>>3];h[f+1168>>3]=+h[a+8480>>3];h[j+1168>>3]=+h[a+8456>>3];h[b+1168>>3]=+h[a+8464>>3];h[f+1176>>3]=+h[a+65264>>3];h[j+1176>>3]=+h[a+65240>>3];h[b+1176>>3]=+h[a+65248>>3];h[f+1184>>3]=+h[a+8368>>3];h[j+1184>>3]=+h[a+8344>>3];h[b+1184>>3]=+h[a+8352>>3];h[f+1192>>3]=+h[a+132464>>3];h[j+1192>>3]=+h[a+132440>>3];h[b+1192>>3]=+h[a+132448>>3];h[f+1200>>3]=+h[a+9264>>3];h[j+1200>>3]=+h[a+9240>>3];h[b+1200>>3]=+h[a+9248>>3];h[f+1208>>3]=+h[a+130224>>3];h[j+1208>>3]=+h[a+130200>>3];h[b+1208>>3]=+h[a+130208>>3];a=c[d>>2]|0;d=c[e>>2]|0;h[d+1216>>3]=+h[a+528>>3];e=c[g>>2]|0;h[e+1216>>3]=+h[a+504>>3];h[b+1216>>3]=+h[a+512>>3];h[d+1224>>3]=+h[a+640>>3];h[e+1224>>3]=+h[a+616>>3];b=c[k>>2]|0;h[b+1224>>3]=+h[a+624>>3];h[d+1232>>3]=+h[a+416>>3];h[e+1232>>3]=+h[a+392>>3];h[b+1232>>3]=+h[a+400>>3];h[d+1240>>3]=+h[a+304>>3];h[e+1240>>3]=+h[a+280>>3];h[b+1240>>3]=+h[a+288>>3];h[d+1248>>3]=+h[a+192>>3];h[e+1248>>3]=+h[a+168>>3];h[b+1248>>3]=+h[a+176>>3];h[d+1256>>3]=+h[a+80>>3];h[e+1256>>3]=+h[a+56>>3];h[b+1256>>3]=+h[a+64>>3];h[d+1264>>3]=+h[a+13e4>>3];h[e+1264>>3]=+h[a+129976>>3];h[b+1264>>3]=+h[a+129984>>3];h[d+1272>>3]=+h[a+9040>>3];h[e+1272>>3]=+h[a+9016>>3];h[b+1272>>3]=+h[a+9024>>3];i=i;return}




// EMSCRIPTEN_END_FUNCS
var ie=[Brb,NZa,PZa,UZa,Zcb,Brb,Brb,Brb];var je=[Crb,iUa,jUa,OUa,PUa,rVa,sVa,PVa,QVa,RVa,Spb,Rpb,Qpb,CTa,DTa,lXa,jXa,Crb,Crb,Crb,Crb,Crb,Crb,Crb,Crb,Crb,Crb,Crb,Crb,Crb,Crb,Crb];var ke=[Drb,z$a];var le=[Erb,z_a];var me=[Frb,jF,kF,lY,MZ,Oha,OZ,gXa,L1a,O1a,N1a,P1a,Xhb,Whb,Zhb,Yhb,Q1a,S1a,c5a,A5a,B5a,C5a,Ihb,Hhb,Khb,Jhb,jcb,vcb,Icb,Jcb,Kcb,Mcb,Ocb,Eeb,Feb,Leb,Meb,Seb,Teb,Zeb,_eb,kfb,jfb,pfb,ofb,rfb,sfb,Bfb,Afb,Igb,Hgb,Rgb,Qgb,thb,shb,Rhb,Qhb,Thb,Shb,jib,iib,lib,kib,rib,qib,Ggb,sib,pib,tib,vib,uib,Dmb,Bib,Aib,Gib,Fib,djb,cjb,Hjb,Gjb,Vjb,Ujb,hkb,gkb,vkb,ukb,Ikb,Hkb,Lkb,Kkb,Pkb,Okb,_kb,Zkb,jlb,ilb,ulb,tlb,Flb,Elb,Plb,Olb,Xlb,Wlb,bmb,amb,hmb,gmb,mmb,lmb,vmb,umb,Tmb,Smb,qmb,inb,Pnb,Onb,Rnb,Qnb,wib,Cmb,Fmb,anb,qnb,Bnb,Mnb,Nnb,Dpb,Cpb,Fpb,Ipb,Gpb,Hpb,Jpb,Kpb,fqb,eqb,DD,Grb,lF,mF,nF,oF,pF,qF,rF,sF,tF,uF,vF,wF,xF,yF,zF,AF,BF,CF,DF,EF,FF,GF,HF,IF,JF,KF,LF,MF,NF,OF,PF,QF,RF,SF,TF,UF,VF,WF,XF,YF,ZF,_F,$F,aG,bG,cG,dG,eG,fG,gG,hG,iG,jG,kG,lG,mG,nG,oG,pG,qG,rG,sG,tG,uG,vG,wG,xG,yG,zG,AG,BG,CG,DG,EG,FG,GG,HG,IG,JG,KG,LG,MG,NG,OG,PG,QG,RG,SG,TG,UG,VG,WG,XG,YG,ZG,_G,$G,aH,bH,cH,dH,eH,fH,gH,hH,iH,jH,kH,lH,mH,nH,oH,pH,qH,rH,sH,tH,uH,vH,wH,xH,yH,zH,AH,BH,CH,DH,EH,FH,GH,HH,IH,JH,KH,LH,MH,NH,OH,PH,QH,RH,SH,TH,UH,VH,WH,XH,YH,ZH,_H,$H,aI,bI,cI,dI,eI,fI,gI,hI,iI,jI,kI,lI,mI,nI,oI,pI,qI,rI,sI,tI,uI,vI,wI,xI,yI,zI,AI,BI,CI,DI,EI,FI,GI,HI,II,JI,KI,LI,MI,NI,OI,PI,QI,RI,SI,TI,UI,VI,WI,XI,YI,ZI,_I,$I,aJ,bJ,cJ,dJ,eJ,fJ,gJ,hJ,iJ,jJ,kJ,lJ,mJ,nJ,oJ,pJ,qJ,rJ,sJ,tJ,uJ,vJ,wJ,xJ,yJ,zJ,AJ,BJ,CJ,DJ,EJ,FJ,GJ,HJ,IJ,JJ,KJ,LJ,MJ,NJ,OJ,PJ,QJ,RJ,SJ,TJ,UJ,VJ,WJ,XJ,YJ,ZJ,_J,$J,aK,bK,cK,dK,eK,fK,gK,hK,iK,jK,kK,lK,mK,nK,oK,pK,qK,rK,sK,tK,uK,vK,wK,xK,yK,zK,AK,BK,CK,DK,EK,FK,GK,HK,IK,JK,KK,LK,MK,NK,OK,PK,QK,RK,SK,TK,UK,VK,WK,XK,YK,ZK,_K,$K,aL,bL,cL,dL,eL,fL,gL,hL,iL,jL,kL,lL,mL,nL,oL,pL,qL,rL,sL,tL,uL,vL,wL,xL,yL,zL,AL,BL,CL,DL,EL,FL,GL,HL,IL,JL,KL,LL,ML,NL,OL,PL,QL,RL,SL,TL,UL,VL,WL,XL,YL,ZL,_L,$L,aM,bM,cM,dM,eM,fM,gM,hM,iM,jM,kM,lM,mM,nM,oM,pM,qM,rM,sM,tM,uM,vM,wM,xM,yM,zM,AM,BM,CM,DM,EM,FM,GM,HM,IM,JM,KM,LM,MM,NM,OM,PM,QM,RM,SM,TM,UM,VM,WM,XM,YM,ZM,_M,$M,aN,bN,cN,dN,eN,fN,gN,hN,iN,jN,kN,lN,mN,nN,oN,pN,qN,rN,sN,tN,uN,vN,wN,xN,yN,zN,AN,BN,CN,DN,EN,FN,GN,HN,IN,JN,KN,LN,MN,NN,ON,PN,QN,RN,SN,TN,UN,VN,WN,XN,YN,ZN,_N,$N,aO,bO,cO,dO,eO,fO,gO,hO,iO,jO,kO,lO,mO,nO,oO,pO,qO,rO,sO,tO,uO,vO,wO,xO,yO,zO,AO,BO,CO,DO,EO,FO,GO,HO,IO,JO,KO,LO,MO,NO,OO,PO,QO,RO,SO,TO,UO,VO,WO,XO,YO,ZO,_O,$O,aP,bP,cP,dP,eP,fP,gP,hP,iP,jP,kP,lP,mP,nP,oP,pP,qP,rP,sP,tP,uP,vP,wP,xP,yP,zP,AP,BP,CP,DP,EP,FP,GP,HP,IP,JP,KP,LP,MP,NP,OP,PP,QP,RP,SP,TP,UP,VP,WP,XP,YP,ZP,_P,$P,aQ,bQ,cQ,dQ,eQ,fQ,gQ,hQ,iQ,jQ,kQ,lQ,mQ,nQ,oQ,pQ,qQ,rQ,sQ,tQ,uQ,vQ,wQ,xQ,yQ,zQ,AQ,BQ,CQ,DQ,EQ,FQ,GQ,HQ,IQ,JQ,KQ,LQ,MQ,NQ,OQ,PQ,QQ,RQ,SQ,TQ,UQ,VQ,WQ,XQ,YQ,ZQ,_Q,$Q,aR,bR,cR,dR,eR,fR,gR,hR,iR,jR,kR,lR,mR,nR,oR,pR,qR,rR,sR,tR,uR,vR,wR,xR,yR,zR,AR,BR,CR,DR,ER,FR,GR,HR,IR,JR,KR,LR,MR,NR,OR,PR,QR,RR,SR,TR,UR,VR,WR,XR,YR,ZR,_R,$R,aS,bS,cS,dS,eS,fS,gS,hS,iS,jS,kS,lS,mS,nS,oS,pS,qS,rS,sS,tS,uS,vS,wS,xS,yS,zS,AS,BS,CS,DS,ES,FS,GS,HS,IS,JS,KS,LS,MS,NS,OS,PS,QS,RS,SS,TS,US,VS,WS,XS,YS,ZS,_S,$S,aT,bT,cT,dT,eT,fT,gT,hT,iT,jT,kT,lT,mT,nT,oT,pT,qT,rT,sT,tT,uT,vT,wT,xT,yT,zT,AT,BT,CT,DT,ET,FT,GT,HT,IT,JT,KT,LT,MT,NT,OT,PT,QT,RT,ST,TT,UT,VT,WT,XT,YT,ZT,_T,$T,aU,bU,cU,dU,eU,fU,gU,hU,iU,jU,kU,lU,mU,nU,oU,pU,qU,rU,sU,tU,uU,vU,wU,xU,yU,zU,AU,BU,CU,DU,EU,FU,GU,HU,IU,JU,KU,LU,MU,NU,OU,PU,QU,RU,SU,TU,UU,VU,WU,XU,YU,ZU,_U,$U,aV,bV,cV,dV,eV,fV,gV,hV,iV,jV,kV,lV,mV,nV,oV,pV,qV,rV,sV,tV,uV,vV,wV,xV,yV,zV,AV,BV,CV,DV,EV,FV,GV,HV,IV,JV,KV,LV,MV,NV,OV,PV,QV,RV,SV,TV,UV,VV,WV,XV,YV,kf,lf,mf,nf,of,pf,qf,rf,sf,tf,uf,vf,wf,xf,yf,zf,Af,Bf,Cf,Df,Ef,Ff,Gf,Hf,If,Jf,Kf,Lf,Mf,Nf,Of,Pf,Qf,Rf,Sf,Tf,Uf,Vf,Wf,Xf,Yf,Zf,_f,$f,ag,bg,cg,dg,eg,fg,gg,hg,ig,jg,kg,lg,mg,ng,og,pg,qg,rg,sg,tg,ug,vg,wg,xg,yg,zg,Ag,Bg,Cg,Dg,Eg,Fg,Gg,Hg,Ig,Jg,Kg,Lg,eh,Th,Uh,Vh,Wh,Xh,Yh,Zh,_h,$h,ai,bi,ci,di,ei,fi,gi,hi,ii,ji,ki,Zi,_i,$i,aj,bj,cj,dj,ej,fj,gj,hj,ij,jj,kj,lj,mj,nj,oj,pj,qj,sj,tj,uj,vj,wj,yj,zj,Aj,Bj,Cj,Jj,Pj,Uj,Vj,Yj,gk,lk,mk,pk,zk,Ek,Fk,Ik,Sk,Xk,Yk,$k,jl,ol,pl,sl,Cl,Hl,Il,Ll,Vl,_l,$l,cm,mm,rm,sm,vm,Fm,Km,Lm,Om,Ym,bn,cn,fn,qn,vn,wn,zn,Jn,On,Pn,Sn,ao,go,ho,ko,uo,zo,Ao,Do,No,So,To,Wo,ep,jp,kp,np,xp,Cp,Dp,Gp,Qp,Vp,Wp,Zp,hq,mq,nq,pq,sq,tq,uq,zq,Qq,Rq,Sq,Tq,Wq,dr,rr,sr,vr,Ir,Wr,Xr,_r,ls,zs,As,Ds,Qs,ct,dt,gt,tt,Ht,It,Lt,Yt,ku,lu,ou,Bu,Pu,Qu,Tu,ev,sv,tv,wv,Jv,Xv,Yv,$v,mw,Aw,Bw,Ew,Rw,dx,ex,hx,ux,Ix,Jx,Mx,Zx,ly,my,py,Cy,Qy,Ry,Uy,fz,tz,uz,xz,Kz,Yz,Zz,aA,nA,BA,CA,FA,SA,eB,fB,iB,vB,LB,MB,TB,aC,lC,mC,nC,oC,pC,qC,rC,sC,tC,uC,vC,wC,xC,yC,zC,AC,BC,CC,DC,EC,FC,GC,HC,IC,JC,KC,LC,MC,NC,OC,PC,QC,RC,SC,TC,UC,VC,WC,XC,YC,ZC,_C,$C,aD,bD,cD,dD,eD,fD,gD,hD,iD,jD,kD,lD,mD,nD,oD,pD,qD,rD,sD,tD,uD,vD,wD,xD,yD,Xpb,iXa,ef,j_a,n_a,i_a,C$a,p_a,A$a,FYa,s_a,q_a,r_a,o_a,u_a,B$a,v_a,k_a,x_a,ecb,y_a,ceb,Deb,Emb,xob,Hlb,Eob,Dob,Cob,Bob,Aob,zob,Rfb,tgb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb,Frb];var ne=[Hrb,NZ,h0a,T1a,ghb,Geb,Neb,Ueb,$eb,uhb,Skb,Tkb,Ukb,Vkb,Xkb,Ykb,blb,clb,dlb,elb,glb,hlb,mlb,nlb,olb,plb,rlb,slb,xlb,ylb,zlb,Alb,Clb,Dlb,kmb,pmb,Wnb,Ynb,_nb,Xnb,Znb,$nb,a_a,ZV,$V,bW,dW,fW,hW,jW,lW,nW,pW,rW,tW,vW,xW,zW,BW,DW,FW,HW,JW,LW,NW,PW,RW,TW,VW,XW,ZW,$W,bX,dX,fX,hX,jX,lX,nX,pX,rX,tX,vX,xX,zX,BX,DX,FX,HX,JX,LX,NX,PX,RX,TX,VX,XX,ZX,$X,bY,dY,fY,hY,jY,mY,nY,oY,pY,qY,rY,sY,tY,uY,vY,wY,xY,yY,zY,AY,BY,CY,DY,EY,FY,GY,HY,IY,JY,KY,LY,MY,NY,OY,PY,QY,RY,SY,TY,UY,VY,WY,XY,YY,ZY,_Y,$Y,aZ,bZ,cZ,dZ,eZ,fZ,gZ,hZ,iZ,jZ,kZ,lZ,mZ,nZ,oZ,pZ,qZ,rZ,sZ,tZ,uZ,vZ,wZ,xZ,yZ,zZ,AZ,BZ,CZ,DZ,EZ,FZ,GZ,HZ,IZ,JZ,KZ,LZ,t_a,K4a,j0a,i0a,k0a,q0a,C0a,l0a,A0a,Z3a,j4a,i4a,k4a,U3a,S3a,W3a,ldb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb,Hrb];var oe=[Irb,RTa,KTa,OZa,QZa,RZa,SZa,TZa];var pe=[Jrb,AD,XDa,zD,gf,hf,jf,Pha,aka,UZ,Nha,WDa,MPa,TZ,RZ,NPa,OPa,HRa,IRa,JRa,KRa,LRa,MRa,NRa,ORa,Krb,Lrb,Mrb,CXa,Wpb,Nrb,X1a,lhb,Y1a,ohb,khb,Rcb,Heb,zhb,Bhb,Chb,yhb,Oeb,Peb,Veb,nhb,afb,bfb,lfb,qfb,nib,ikb,aob,cob,eob,kob,mob,gob,iob,wkb,bob,dob,fob,lob,nob,hob,job,Qkb,Rkb,Wkb,$kb,alb,flb,klb,llb,qlb,vlb,wlb,Blb,mnb,nnb,pnb,Snb,Unb,Tnb,Vnb,enb,fnb,hnb,wnb,xnb,Anb,Hnb,Inb,Lnb,Epb,gqb,J$a,Orb,Prb,H$a,I$a,Qrb,Zbb,Acb,F_a,N_a,Z_a,G_a,Q_a,__a,veb,pqb,Jrb,Jrb,Jrb,Jrb,Jrb,Jrb,Jrb,Jrb,Jrb,Jrb,Jrb,Jrb,Jrb,Jrb,Jrb];var qe=[Rrb,iYa];var re=[Srb,xZa];var se=[Trb,QZ,$Ta,fUa,FUa,LUa,iVa,oVa,U1a,mhb,qhb,hhb,vhb,Ahb,Ieb,Ehb,Web,vfb,wfb,zib,Eib,imb,nmb,Vmb,Xmb,_mb,Gmb,Lmb,Nmb,Qmb,Lpb,gcb,jYa,NYa,OTa,FTa,MTa,STa,Urb,Vrb,Wrb,D$a,dcb,$bb,Xrb,neb,Yrb,Trb,Trb,Trb,Trb,Trb,Trb,Trb,Trb,Trb,Trb,Trb,Trb,Trb,Trb,Trb,Trb,Trb];var te=[Zrb,BZa];var ue=[_rb,VYa];var ve=[$rb,Pjb,Sjb,bkb,dkb,$rb,$rb,$rb];var we=[asb,Jkb,Mkb,Glb,Klb,Qlb,Slb,asb];var xe=[bsb,vZa];var ye=[csb,dXa,V1a,Pcb,whb,ihb,Ijb,Jjb,Njb,Tjb,Wjb,Xjb,$jb,ekb,jmb,omb,Vpb,Upb,Tpb,eXa,csb,csb,csb,csb,csb,csb,csb,csb,csb,csb,csb,csb];var ze=[dsb,O_a,P_a,dsb];var Ae=[esb,CD];var Be=[fsb,Hib,Jib,Lib,Nib,Pib,Rib,Tib,Vib,Xib,Zib,$ib,ejb,gjb,ijb,kjb,mjb,ojb,qjb,sjb,ujb,wjb,yjb,Mjb,Ojb,_jb,akb,jkb,kkb,lkb,mkb,nkb,xkb,ykb,zkb,Akb,Bkb,$lb,fmb,fsb,fsb,fsb,fsb,fsb,fsb,fsb,fsb,fsb,fsb,fsb,fsb,fsb,fsb,fsb,fsb,fsb,fsb,fsb,fsb,fsb,fsb,fsb,fsb,fsb];var Ce=[gsb,Ylb,cmb,gsb];var De=[hsb,okb,Ckb,hsb];var Ee=[isb,ff,VZ,SZ,PZ,PRa,QRa,bUa,cUa,eUa,HUa,IUa,KUa,kVa,lVa,nVa,tVa,uVa,vVa,wVa,xVa,yVa,zVa,AVa,Z1a,_1a,Scb,Tcb,Dhb,Jeb,Qeb,Fhb,phb,Xeb,cfb,rhb,Umb,Wmb,Ymb,Kmb,Mmb,Omb,r$a,a$a,S_a,H_a,R_a,$_a,jsb,Zpb,zTa,ATa,BTa,ksb,SXa,V_a,Y_a,K_a,n$a,e$a,M_a,lsb,opb,isb];var Fe=[msb,xib,Cib,$mb,lnb,onb,Rmb,dnb,gnb,vnb,ynb,Gnb,Jnb,XVa,OWa,PWa,aWa,ZVa,MWa,NWa,bWa,cWa,dWa,eWa,fWa,CWa,DWa,tWa,mWa,hWa,gWa,iWa,jWa,lWa,kWa,_Va,YVa,nWa,oWa,pWa,qWa,rWa,sWa,uWa,vWa,wWa,xWa,BWa,zWa,yWa,AWa,IWa,EWa,FWa,GWa,HWa,JWa,KWa,LWa,QWa,RWa,SWa,TWa,Kjb];var Ge=[nsb,O$a];var He=[osb,b$a];var Ie=[psb,dZa];var Je=[qsb,SRa,rsb,DXa,Aeb,Beb,yeb,qsb];var Ke=[ssb,AZa];var Le=[tsb,icb,ufb,oib,eYa,oXa,c0a,e0a,J4a,kdb,tsb,tsb,tsb,tsb,tsb,tsb];var Me=[usb,vsb,BXa,WWa,FD,usb,usb,usb];var Ne=[wsb,RRa,jnb,knb,bnb,cnb,rnb,tnb,Cnb,Enb,f$a,wsb,wsb,wsb,wsb,wsb];var Oe=[xsb,VTa,WTa,XTa,YTa,ZTa,_Ta,aUa,dUa,hUa,zUa,AUa,BUa,CUa,DUa,EUa,GUa,JUa,NUa,cVa,dVa,eVa,fVa,gVa,hVa,jVa,mVa,qVa,Zmb,Hmb,Imb,Jmb,Pmb,c_a,ysb,wZa,rTa,uSa,PSa,YSa,KSa,fTa,kTa,iTa,lTa,TTa,xTa,HTa,ITa,PTa,QTa,bjb,Qjb,zsb,xsb,xsb,xsb,xsb,xsb,xsb,xsb,xsb,xsb,xsb];var Pe=[Asb,gUa,MUa,pVa,W1a,hcb,Qcb,xhb,jhb,yib,Dib,Mpb,Npb,Opb,mXa,kXa,e_a,MYa,nXa,_V,aW,cW,eW,gW,iW,kW,mW,oW,qW,sW,uW,wW,yW,AW,CW,EW,GW,IW,KW,MW,OW,QW,SW,UW,WW,YW,_W,aX,cX,eX,gX,iX,kX,mX,oX,qX,sX,uX,wX,yX,AX,CX,EX,GX,IX,KX,MX,OX,QX,SX,UX,WX,YX,_X,aY,cY,eY,gY,iY,kY,Fdb,JTa,pXa,Asb,Asb,Asb,Asb,Asb,Asb,Asb,Asb,Asb,Asb,Asb,Asb,Asb,Asb,Asb,Asb,Asb,Asb,Asb,Asb,Asb,Asb,Asb,Asb,Asb,Asb,Asb,Asb,Asb,Asb,Asb,Asb,Asb,Asb,Asb,Asb,Asb,Asb,Asb,Asb,Asb,Asb,Asb,Asb,Asb];return{_testSetjmp:Lqb,_saveSetjmp:xqb,_free:Xpb,_main:ED,_rand_r:Fqb,_realloc:Zpb,_i64Add:Iqb,_memmove:Bqb,_bitshift64Ashr:zqb,_memset:Cqb,_malloc:Wpb,_strncpy:Jqb,_memcpy:Aqb,_strlen:yqb,_bitshift64Lshr:Kqb,_bitshift64Shl:Dqb,_i64Subtract:Hqb,_strcpy:Eqb,_calloc:Ypb,_rand:Gqb,__GLOBAL__I_a:efb,runPostSets:wqb,stackAlloc:Qe,stackSave:Re,stackRestore:Se,setThrew:Te,setTempRet0:We,setTempRet1:Xe,setTempRet2:Ye,setTempRet3:Ze,setTempRet4:_e,setTempRet5:$e,setTempRet6:af,setTempRet7:bf,setTempRet8:cf,setTempRet9:df,dynCall_iiiiiiii:Vqb,dynCall_viiiii:Wqb,dynCall_iiiiidiii:Xqb,dynCall_vd:Yqb,dynCall_vi:Zqb,dynCall_vii:_qb,dynCall_iiiiiiiiiii:$qb,dynCall_ii:arb,dynCall_viidi:brb,dynCall_iiiiiiiiiiiiii:crb,dynCall_iiii:drb,dynCall_iiiiiiiiiiiiiiiiiiiiiii:erb,dynCall_iiiiiiiiiiiiiiiiiiiii:frb,dynCall_viiiiid:grb,dynCall_viiiiiiii:hrb,dynCall_iiiiiiiiiiiiiiiiiiiiiiiii:irb,dynCall_viiiiii:jrb,dynCall_viidii:krb,dynCall_iid:lrb,dynCall_viiiiiii:mrb,dynCall_viiiiiid:nrb,dynCall_viiiiiiiii:orb,dynCall_iii:prb,dynCall_iiiiii:qrb,dynCall_iiiiidi:rrb,dynCall_didd:srb,dynCall_dii:trb,dynCall_i:urb,dynCall_iiiiiiiiii:vrb,dynCall_viii:wrb,dynCall_v:xrb,dynCall_iiiiiiiii:yrb,dynCall_iiiii:zrb,dynCall_viiii:Arb}})


// EMSCRIPTEN_END_ASM
({ "Math": Math, "Int8Array": Int8Array, "Int16Array": Int16Array, "Int32Array": Int32Array, "Uint8Array": Uint8Array, "Uint16Array": Uint16Array, "Uint32Array": Uint32Array, "Float32Array": Float32Array, "Float64Array": Float64Array }, { "abort": abort, "assert": assert, "asmPrintInt": asmPrintInt, "asmPrintFloat": asmPrintFloat, "min": Math_min, "invoke_iiiiiiii": invoke_iiiiiiii, "invoke_viiiii": invoke_viiiii, "invoke_iiiiidiii": invoke_iiiiidiii, "invoke_vd": invoke_vd, "invoke_vi": invoke_vi, "invoke_vii": invoke_vii, "invoke_iiiiiiiiiii": invoke_iiiiiiiiiii, "invoke_ii": invoke_ii, "invoke_viidi": invoke_viidi, "invoke_iiiiiiiiiiiiii": invoke_iiiiiiiiiiiiii, "invoke_iiii": invoke_iiii, "invoke_iiiiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiiiii, "invoke_iiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiii, "invoke_viiiiid": invoke_viiiiid, "invoke_viiiiiiii": invoke_viiiiiiii, "invoke_iiiiiiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiiiiiii, "invoke_viiiiii": invoke_viiiiii, "invoke_viidii": invoke_viidii, "invoke_iid": invoke_iid, "invoke_viiiiiii": invoke_viiiiiii, "invoke_viiiiiid": invoke_viiiiiid, "invoke_viiiiiiiii": invoke_viiiiiiiii, "invoke_iii": invoke_iii, "invoke_iiiiii": invoke_iiiiii, "invoke_iiiiidi": invoke_iiiiidi, "invoke_didd": invoke_didd, "invoke_dii": invoke_dii, "invoke_i": invoke_i, "invoke_iiiiiiiiii": invoke_iiiiiiiiii, "invoke_viii": invoke_viii, "invoke_v": invoke_v, "invoke_iiiiiiiii": invoke_iiiiiiiii, "invoke_iiiii": invoke_iiiii, "invoke_viiii": invoke_viiii, "_fabs": _fabs, "_exp": _exp, "_lis_matrix_assemble": _lis_matrix_assemble, "_strrchr": _strrchr, "_pthread_key_create": _pthread_key_create, "_vsscanf": _vsscanf, "_fscanf": _fscanf, "___cxa_guard_acquire": ___cxa_guard_acquire, "_log10": _log10, "_fstat": _fstat, "_pclose": _pclose, "_lis_solver_create": _lis_solver_create, "___assert_fail": ___assert_fail, "__ZSt18uncaught_exceptionv": __ZSt18uncaught_exceptionv, "_longjmp": _longjmp, "__isLeapYear": __isLeapYear, "_clock_gettime": _clock_gettime, "_fsync": _fsync, "_signal": _signal, "_GC_collect_a_little": _GC_collect_a_little, "_sbrk": _sbrk, "_strtoull": _strtoull, "_emscripten_memcpy_big": _emscripten_memcpy_big, "_sinh": _sinh, "_sysconf": _sysconf, "_close": _close, "_rewind": _rewind, "_cos": _cos, "_fileno": _fileno, "_tanh": _tanh, "_fread": _fread, "_puts": _puts, "_isatty": _isatty, "_lis_matrix_set_value": _lis_matrix_set_value, "_write": _write, "_isblank": _isblank, "_ftell": _ftell, "__ZNSt9exceptionD2Ev": __ZNSt9exceptionD2Ev, "_xerbla_": _xerbla_, "_round": _round, "___cxa_does_inherit": ___cxa_does_inherit, "_strtoll_l": _strtoll_l, "_strstr": _strstr, "___cxa_rethrow": ___cxa_rethrow, "_llvm_lifetime_end": _llvm_lifetime_end, "_catclose": _catclose, "_tmpnam": _tmpnam, "_lis_vector_get_values": _lis_vector_get_values, "_lis_vector_destroy": _lis_vector_destroy, "_lis_solver_set_option": _lis_solver_set_option, "_tmpfile": _tmpfile, "_send": _send, "_pow": _pow, "_lis_matrix_set_size": _lis_matrix_set_size, "___cxa_free_exception": ___cxa_free_exception, "___cxa_find_matching_catch": ___cxa_find_matching_catch, "_isxdigit_l": _isxdigit_l, "___cxa_guard_release": ___cxa_guard_release, "_truncate": _truncate, "_strtol": _strtol, "__reallyNegative": __reallyNegative, "_sin": _sin, "_strtok": _strtok, "___setErrNo": ___setErrNo, "_newlocale": _newlocale, "_isdigit_l": _isdigit_l, "___resumeException": ___resumeException, "_freelocale": _freelocale, "_srand": _srand, "_qsort": _qsort, "_putchar": _putchar, "_floor": _floor, "_pthread_mutex_unlock": _pthread_mutex_unlock, "_printf": _printf, "_sprintf": _sprintf, "_fopen": _fopen, "_vasprintf": _vasprintf, "_emscripten_get_now": _emscripten_get_now, "_stat": _stat, "_lis_solve": _lis_solve, "_strtoull_l": _strtoull_l, "_read": _read, "__addDays": __addDays, "_fwrite": _fwrite, "_time": _time, "_pthread_mutex_lock": _pthread_mutex_lock, "_catopen": _catopen, "_exit": _exit, "_GC_strdup": _GC_strdup, "_freopen": _freopen, "___ctype_b_loc": ___ctype_b_loc, "_fmod": _fmod, "_strtok_r": _strtok_r, "_lseek": _lseek, "_access": _access, "_vfprintf": _vfprintf, "___cxa_allocate_exception": ___cxa_allocate_exception, "_atoi": _atoi, "_strtoll": _strtoll, "_pwrite": _pwrite, "_localtime_r": _localtime_r, "_tzset": _tzset, "_open": _open, "_uselocale": _uselocale, "_snprintf": _snprintf, "___errno_location": ___errno_location, "_GC_malloc": _GC_malloc, "___cxa_end_catch": ___cxa_end_catch, "_perror": _perror, "___cxa_begin_catch": ___cxa_begin_catch, "_strftime": _strftime, "_ftruncate": _ftruncate, "_GC_init": _GC_init, "_lis_matrix_set_type": _lis_matrix_set_type, "_fseek": _fseek, "__ZSt9terminatev": __ZSt9terminatev, "_isxdigit": _isxdigit, "_fclose": _fclose, "_vsnprintf": _vsnprintf, "__parseInt": __parseInt, "_log": _log, "_pthread_cond_broadcast": _pthread_cond_broadcast, "_popen": _popen, "_recv": _recv, "_tan": _tan, "_copysign": _copysign, "__parseInt64": __parseInt64, "__getFloat": __getFloat, "_lis_vector_set_value": _lis_vector_set_value, "_abort": _abort, "_ceil": _ceil, "_isspace": _isspace, "_localtime": _localtime, "_lis_matrix_destroy": _lis_matrix_destroy, "_pthread_getspecific": _pthread_getspecific, "_pthread_cond_wait": _pthread_cond_wait, "_llvm_lifetime_start": _llvm_lifetime_start, "___cxa_is_number_type": ___cxa_is_number_type, "_acos": _acos, "_cosh": _cosh, "_ungetc": _ungetc, "_system": _system, "_fmin": _fmin, "_fmax": _fmax, "_fflush": _fflush, "_strftime_l": _strftime_l, "_fprintf": _fprintf, "_sscanf": _sscanf, "_catgets": _catgets, "_lis_solver_destroy": _lis_solver_destroy, "_strdup": _strdup, "_asprintf": _asprintf, "__exit": __exit, "___ctype_toupper_loc": ___ctype_toupper_loc, "_bsearch": _bsearch, "__arraySum": __arraySum, "__formatString": __formatString, "_htonl": _htonl, "___ctype_tolower_loc": ___ctype_tolower_loc, "_unlink": _unlink, "_fputs": _fputs, "_GC_malloc_atomic": _GC_malloc_atomic, "_pread": _pread, "_lis_vector_set_size": _lis_vector_set_size, "_mkport": _mkport, "__scanString": __scanString, "_pthread_setspecific": _pthread_setspecific, "_fgetc": _fgetc, "_fputc": _fputc, "___cxa_throw": ___cxa_throw, "_lis_matrix_create": _lis_matrix_create, "_isdigit": _isdigit, "_strerror": _strerror, "_emscripten_longjmp": _emscripten_longjmp, "_lis_vector_create": _lis_vector_create, "_atexit": _atexit, "_sqrt": _sqrt, "_strerror_r": _strerror_r, "STACKTOP": STACKTOP, "STACK_MAX": STACK_MAX, "tempDoublePtr": tempDoublePtr, "ABORT": ABORT, "cttz_i8": cttz_i8, "ctlz_i8": ctlz_i8, "___rand_seed": ___rand_seed, "NaN": NaN, "Infinity": Infinity, "__ZTISt9exception": __ZTISt9exception, "___dso_handle": ___dso_handle, "_stderr": _stderr, "_stdin": _stdin, "_stdout": _stdout }, buffer);
var _testSetjmp = Module["_testSetjmp"] = asm["_testSetjmp"];
var _saveSetjmp = Module["_saveSetjmp"] = asm["_saveSetjmp"];
var _free = Module["_free"] = asm["_free"];
var _main = Module["_main"] = asm["_main"];
var _rand_r = Module["_rand_r"] = asm["_rand_r"];
var _realloc = Module["_realloc"] = asm["_realloc"];
var _i64Add = Module["_i64Add"] = asm["_i64Add"];
var _memmove = Module["_memmove"] = asm["_memmove"];
var _bitshift64Ashr = Module["_bitshift64Ashr"] = asm["_bitshift64Ashr"];
var _memset = Module["_memset"] = asm["_memset"];
var _malloc = Module["_malloc"] = asm["_malloc"];
var _strncpy = Module["_strncpy"] = asm["_strncpy"];
var _memcpy = Module["_memcpy"] = asm["_memcpy"];
var _strlen = Module["_strlen"] = asm["_strlen"];
var _bitshift64Lshr = Module["_bitshift64Lshr"] = asm["_bitshift64Lshr"];
var _bitshift64Shl = Module["_bitshift64Shl"] = asm["_bitshift64Shl"];
var _i64Subtract = Module["_i64Subtract"] = asm["_i64Subtract"];
var _strcpy = Module["_strcpy"] = asm["_strcpy"];
var _calloc = Module["_calloc"] = asm["_calloc"];
var _rand = Module["_rand"] = asm["_rand"];
var __GLOBAL__I_a = Module["__GLOBAL__I_a"] = asm["__GLOBAL__I_a"];
var runPostSets = Module["runPostSets"] = asm["runPostSets"];
var dynCall_iiiiiiii = Module["dynCall_iiiiiiii"] = asm["dynCall_iiiiiiii"];
var dynCall_viiiii = Module["dynCall_viiiii"] = asm["dynCall_viiiii"];
var dynCall_iiiiidiii = Module["dynCall_iiiiidiii"] = asm["dynCall_iiiiidiii"];
var dynCall_vd = Module["dynCall_vd"] = asm["dynCall_vd"];
var dynCall_vi = Module["dynCall_vi"] = asm["dynCall_vi"];
var dynCall_vii = Module["dynCall_vii"] = asm["dynCall_vii"];
var dynCall_iiiiiiiiiii = Module["dynCall_iiiiiiiiiii"] = asm["dynCall_iiiiiiiiiii"];
var dynCall_ii = Module["dynCall_ii"] = asm["dynCall_ii"];
var dynCall_viidi = Module["dynCall_viidi"] = asm["dynCall_viidi"];
var dynCall_iiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiii"];
var dynCall_iiii = Module["dynCall_iiii"] = asm["dynCall_iiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiiiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiii"];
var dynCall_viiiiid = Module["dynCall_viiiiid"] = asm["dynCall_viiiiid"];
var dynCall_viiiiiiii = Module["dynCall_viiiiiiii"] = asm["dynCall_viiiiiiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"];
var dynCall_viiiiii = Module["dynCall_viiiiii"] = asm["dynCall_viiiiii"];
var dynCall_viidii = Module["dynCall_viidii"] = asm["dynCall_viidii"];
var dynCall_iid = Module["dynCall_iid"] = asm["dynCall_iid"];
var dynCall_viiiiiii = Module["dynCall_viiiiiii"] = asm["dynCall_viiiiiii"];
var dynCall_viiiiiid = Module["dynCall_viiiiiid"] = asm["dynCall_viiiiiid"];
var dynCall_viiiiiiiii = Module["dynCall_viiiiiiiii"] = asm["dynCall_viiiiiiiii"];
var dynCall_iii = Module["dynCall_iii"] = asm["dynCall_iii"];
var dynCall_iiiiii = Module["dynCall_iiiiii"] = asm["dynCall_iiiiii"];
var dynCall_iiiiidi = Module["dynCall_iiiiidi"] = asm["dynCall_iiiiidi"];
var dynCall_didd = Module["dynCall_didd"] = asm["dynCall_didd"];
var dynCall_dii = Module["dynCall_dii"] = asm["dynCall_dii"];
var dynCall_i = Module["dynCall_i"] = asm["dynCall_i"];
var dynCall_iiiiiiiiii = Module["dynCall_iiiiiiiiii"] = asm["dynCall_iiiiiiiiii"];
var dynCall_viii = Module["dynCall_viii"] = asm["dynCall_viii"];
var dynCall_v = Module["dynCall_v"] = asm["dynCall_v"];
var dynCall_iiiiiiiii = Module["dynCall_iiiiiiiii"] = asm["dynCall_iiiiiiiii"];
var dynCall_iiiii = Module["dynCall_iiiii"] = asm["dynCall_iiiii"];
var dynCall_viiii = Module["dynCall_viiii"] = asm["dynCall_viiii"];

Runtime.stackAlloc = function(size) { return asm['stackAlloc'](size) };
Runtime.stackSave = function() { return asm['stackSave']() };
Runtime.stackRestore = function(top) { asm['stackRestore'](top) };


// TODO: strip out parts of this we do not need

//======= begin closure i64 code =======

// Copyright 2009 The Closure Library Authors. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS-IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/**
 * @fileoverview Defines a Long class for representing a 64-bit two's-complement
 * integer value, which faithfully simulates the behavior of a Java "long". This
 * implementation is derived from LongLib in GWT.
 *
 */

var i64Math = (function() { // Emscripten wrapper
  var goog = { math: {} };


  /**
   * Constructs a 64-bit two's-complement integer, given its low and high 32-bit
   * values as *signed* integers.  See the from* functions below for more
   * convenient ways of constructing Longs.
   *
   * The internal representation of a long is the two given signed, 32-bit values.
   * We use 32-bit pieces because these are the size of integers on which
   * Javascript performs bit-operations.  For operations like addition and
   * multiplication, we split each number into 16-bit pieces, which can easily be
   * multiplied within Javascript's floating-point representation without overflow
   * or change in sign.
   *
   * In the algorithms below, we frequently reduce the negative case to the
   * positive case by negating the input(s) and then post-processing the result.
   * Note that we must ALWAYS check specially whether those values are MIN_VALUE
   * (-2^63) because -MIN_VALUE == MIN_VALUE (since 2^63 cannot be represented as
   * a positive number, it overflows back into a negative).  Not handling this
   * case would often result in infinite recursion.
   *
   * @param {number} low  The low (signed) 32 bits of the long.
   * @param {number} high  The high (signed) 32 bits of the long.
   * @constructor
   */
  goog.math.Long = function(low, high) {
    /**
     * @type {number}
     * @private
     */
    this.low_ = low | 0;  // force into 32 signed bits.

    /**
     * @type {number}
     * @private
     */
    this.high_ = high | 0;  // force into 32 signed bits.
  };


  // NOTE: Common constant values ZERO, ONE, NEG_ONE, etc. are defined below the
  // from* methods on which they depend.


  /**
   * A cache of the Long representations of small integer values.
   * @type {!Object}
   * @private
   */
  goog.math.Long.IntCache_ = {};


  /**
   * Returns a Long representing the given (32-bit) integer value.
   * @param {number} value The 32-bit integer in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromInt = function(value) {
    if (-128 <= value && value < 128) {
      var cachedObj = goog.math.Long.IntCache_[value];
      if (cachedObj) {
        return cachedObj;
      }
    }

    var obj = new goog.math.Long(value | 0, value < 0 ? -1 : 0);
    if (-128 <= value && value < 128) {
      goog.math.Long.IntCache_[value] = obj;
    }
    return obj;
  };


  /**
   * Returns a Long representing the given value, provided that it is a finite
   * number.  Otherwise, zero is returned.
   * @param {number} value The number in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromNumber = function(value) {
    if (isNaN(value) || !isFinite(value)) {
      return goog.math.Long.ZERO;
    } else if (value <= -goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MIN_VALUE;
    } else if (value + 1 >= goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MAX_VALUE;
    } else if (value < 0) {
      return goog.math.Long.fromNumber(-value).negate();
    } else {
      return new goog.math.Long(
          (value % goog.math.Long.TWO_PWR_32_DBL_) | 0,
          (value / goog.math.Long.TWO_PWR_32_DBL_) | 0);
    }
  };


  /**
   * Returns a Long representing the 64-bit integer that comes by concatenating
   * the given high and low bits.  Each is assumed to use 32 bits.
   * @param {number} lowBits The low 32-bits.
   * @param {number} highBits The high 32-bits.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromBits = function(lowBits, highBits) {
    return new goog.math.Long(lowBits, highBits);
  };


  /**
   * Returns a Long representation of the given string, written using the given
   * radix.
   * @param {string} str The textual representation of the Long.
   * @param {number=} opt_radix The radix in which the text is written.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromString = function(str, opt_radix) {
    if (str.length == 0) {
      throw Error('number format error: empty string');
    }

    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (str.charAt(0) == '-') {
      return goog.math.Long.fromString(str.substring(1), radix).negate();
    } else if (str.indexOf('-') >= 0) {
      throw Error('number format error: interior "-" character: ' + str);
    }

    // Do several (8) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 8));

    var result = goog.math.Long.ZERO;
    for (var i = 0; i < str.length; i += 8) {
      var size = Math.min(8, str.length - i);
      var value = parseInt(str.substring(i, i + size), radix);
      if (size < 8) {
        var power = goog.math.Long.fromNumber(Math.pow(radix, size));
        result = result.multiply(power).add(goog.math.Long.fromNumber(value));
      } else {
        result = result.multiply(radixToPower);
        result = result.add(goog.math.Long.fromNumber(value));
      }
    }
    return result;
  };


  // NOTE: the compiler should inline these constant values below and then remove
  // these variables, so there should be no runtime penalty for these.


  /**
   * Number used repeated below in calculations.  This must appear before the
   * first call to any from* function below.
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_16_DBL_ = 1 << 16;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_24_DBL_ = 1 << 24;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_32_DBL_ =
      goog.math.Long.TWO_PWR_16_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_31_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ / 2;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_48_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_64_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_32_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_63_DBL_ =
      goog.math.Long.TWO_PWR_64_DBL_ / 2;


  /** @type {!goog.math.Long} */
  goog.math.Long.ZERO = goog.math.Long.fromInt(0);


  /** @type {!goog.math.Long} */
  goog.math.Long.ONE = goog.math.Long.fromInt(1);


  /** @type {!goog.math.Long} */
  goog.math.Long.NEG_ONE = goog.math.Long.fromInt(-1);


  /** @type {!goog.math.Long} */
  goog.math.Long.MAX_VALUE =
      goog.math.Long.fromBits(0xFFFFFFFF | 0, 0x7FFFFFFF | 0);


  /** @type {!goog.math.Long} */
  goog.math.Long.MIN_VALUE = goog.math.Long.fromBits(0, 0x80000000 | 0);


  /**
   * @type {!goog.math.Long}
   * @private
   */
  goog.math.Long.TWO_PWR_24_ = goog.math.Long.fromInt(1 << 24);


  /** @return {number} The value, assuming it is a 32-bit integer. */
  goog.math.Long.prototype.toInt = function() {
    return this.low_;
  };


  /** @return {number} The closest floating-point representation to this value. */
  goog.math.Long.prototype.toNumber = function() {
    return this.high_ * goog.math.Long.TWO_PWR_32_DBL_ +
           this.getLowBitsUnsigned();
  };


  /**
   * @param {number=} opt_radix The radix in which the text should be written.
   * @return {string} The textual representation of this value.
   */
  goog.math.Long.prototype.toString = function(opt_radix) {
    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (this.isZero()) {
      return '0';
    }

    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        // We need to change the Long value before it can be negated, so we remove
        // the bottom-most digit in this base and then recurse to do the rest.
        var radixLong = goog.math.Long.fromNumber(radix);
        var div = this.div(radixLong);
        var rem = div.multiply(radixLong).subtract(this);
        return div.toString(radix) + rem.toInt().toString(radix);
      } else {
        return '-' + this.negate().toString(radix);
      }
    }

    // Do several (6) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 6));

    var rem = this;
    var result = '';
    while (true) {
      var remDiv = rem.div(radixToPower);
      var intval = rem.subtract(remDiv.multiply(radixToPower)).toInt();
      var digits = intval.toString(radix);

      rem = remDiv;
      if (rem.isZero()) {
        return digits + result;
      } else {
        while (digits.length < 6) {
          digits = '0' + digits;
        }
        result = '' + digits + result;
      }
    }
  };


  /** @return {number} The high 32-bits as a signed value. */
  goog.math.Long.prototype.getHighBits = function() {
    return this.high_;
  };


  /** @return {number} The low 32-bits as a signed value. */
  goog.math.Long.prototype.getLowBits = function() {
    return this.low_;
  };


  /** @return {number} The low 32-bits as an unsigned value. */
  goog.math.Long.prototype.getLowBitsUnsigned = function() {
    return (this.low_ >= 0) ?
        this.low_ : goog.math.Long.TWO_PWR_32_DBL_ + this.low_;
  };


  /**
   * @return {number} Returns the number of bits needed to represent the absolute
   *     value of this Long.
   */
  goog.math.Long.prototype.getNumBitsAbs = function() {
    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        return 64;
      } else {
        return this.negate().getNumBitsAbs();
      }
    } else {
      var val = this.high_ != 0 ? this.high_ : this.low_;
      for (var bit = 31; bit > 0; bit--) {
        if ((val & (1 << bit)) != 0) {
          break;
        }
      }
      return this.high_ != 0 ? bit + 33 : bit + 1;
    }
  };


  /** @return {boolean} Whether this value is zero. */
  goog.math.Long.prototype.isZero = function() {
    return this.high_ == 0 && this.low_ == 0;
  };


  /** @return {boolean} Whether this value is negative. */
  goog.math.Long.prototype.isNegative = function() {
    return this.high_ < 0;
  };


  /** @return {boolean} Whether this value is odd. */
  goog.math.Long.prototype.isOdd = function() {
    return (this.low_ & 1) == 1;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long equals the other.
   */
  goog.math.Long.prototype.equals = function(other) {
    return (this.high_ == other.high_) && (this.low_ == other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long does not equal the other.
   */
  goog.math.Long.prototype.notEquals = function(other) {
    return (this.high_ != other.high_) || (this.low_ != other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than the other.
   */
  goog.math.Long.prototype.lessThan = function(other) {
    return this.compare(other) < 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than or equal to the other.
   */
  goog.math.Long.prototype.lessThanOrEqual = function(other) {
    return this.compare(other) <= 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than the other.
   */
  goog.math.Long.prototype.greaterThan = function(other) {
    return this.compare(other) > 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than or equal to the other.
   */
  goog.math.Long.prototype.greaterThanOrEqual = function(other) {
    return this.compare(other) >= 0;
  };


  /**
   * Compares this Long with the given one.
   * @param {goog.math.Long} other Long to compare against.
   * @return {number} 0 if they are the same, 1 if the this is greater, and -1
   *     if the given one is greater.
   */
  goog.math.Long.prototype.compare = function(other) {
    if (this.equals(other)) {
      return 0;
    }

    var thisNeg = this.isNegative();
    var otherNeg = other.isNegative();
    if (thisNeg && !otherNeg) {
      return -1;
    }
    if (!thisNeg && otherNeg) {
      return 1;
    }

    // at this point, the signs are the same, so subtraction will not overflow
    if (this.subtract(other).isNegative()) {
      return -1;
    } else {
      return 1;
    }
  };


  /** @return {!goog.math.Long} The negation of this value. */
  goog.math.Long.prototype.negate = function() {
    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.MIN_VALUE;
    } else {
      return this.not().add(goog.math.Long.ONE);
    }
  };


  /**
   * Returns the sum of this and the given Long.
   * @param {goog.math.Long} other Long to add to this one.
   * @return {!goog.math.Long} The sum of this and the given Long.
   */
  goog.math.Long.prototype.add = function(other) {
    // Divide each number into 4 chunks of 16 bits, and then sum the chunks.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 + b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 + b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 + b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 + b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns the difference of this and the given Long.
   * @param {goog.math.Long} other Long to subtract from this.
   * @return {!goog.math.Long} The difference of this and the given Long.
   */
  goog.math.Long.prototype.subtract = function(other) {
    return this.add(other.negate());
  };


  /**
   * Returns the product of this and the given long.
   * @param {goog.math.Long} other Long to multiply with this.
   * @return {!goog.math.Long} The product of this and the other.
   */
  goog.math.Long.prototype.multiply = function(other) {
    if (this.isZero()) {
      return goog.math.Long.ZERO;
    } else if (other.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return other.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return this.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().multiply(other.negate());
      } else {
        return this.negate().multiply(other).negate();
      }
    } else if (other.isNegative()) {
      return this.multiply(other.negate()).negate();
    }

    // If both longs are small, use float multiplication
    if (this.lessThan(goog.math.Long.TWO_PWR_24_) &&
        other.lessThan(goog.math.Long.TWO_PWR_24_)) {
      return goog.math.Long.fromNumber(this.toNumber() * other.toNumber());
    }

    // Divide each long into 4 chunks of 16 bits, and then add up 4x4 products.
    // We can skip products that would overflow.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 * b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 * b00;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c16 += a00 * b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 * b00;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a16 * b16;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a00 * b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 * b00 + a32 * b16 + a16 * b32 + a00 * b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns this Long divided by the given one.
   * @param {goog.math.Long} other Long by which to divide.
   * @return {!goog.math.Long} This Long divided by the given one.
   */
  goog.math.Long.prototype.div = function(other) {
    if (other.isZero()) {
      throw Error('division by zero');
    } else if (this.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      if (other.equals(goog.math.Long.ONE) ||
          other.equals(goog.math.Long.NEG_ONE)) {
        return goog.math.Long.MIN_VALUE;  // recall that -MIN_VALUE == MIN_VALUE
      } else if (other.equals(goog.math.Long.MIN_VALUE)) {
        return goog.math.Long.ONE;
      } else {
        // At this point, we have |other| >= 2, so |this/other| < |MIN_VALUE|.
        var halfThis = this.shiftRight(1);
        var approx = halfThis.div(other).shiftLeft(1);
        if (approx.equals(goog.math.Long.ZERO)) {
          return other.isNegative() ? goog.math.Long.ONE : goog.math.Long.NEG_ONE;
        } else {
          var rem = this.subtract(other.multiply(approx));
          var result = approx.add(rem.div(other));
          return result;
        }
      }
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().div(other.negate());
      } else {
        return this.negate().div(other).negate();
      }
    } else if (other.isNegative()) {
      return this.div(other.negate()).negate();
    }

    // Repeat the following until the remainder is less than other:  find a
    // floating-point that approximates remainder / other *from below*, add this
    // into the result, and subtract it from the remainder.  It is critical that
    // the approximate value is less than or equal to the real value so that the
    // remainder never becomes negative.
    var res = goog.math.Long.ZERO;
    var rem = this;
    while (rem.greaterThanOrEqual(other)) {
      // Approximate the result of division. This may be a little greater or
      // smaller than the actual value.
      var approx = Math.max(1, Math.floor(rem.toNumber() / other.toNumber()));

      // We will tweak the approximate result by changing it in the 48-th digit or
      // the smallest non-fractional digit, whichever is larger.
      var log2 = Math.ceil(Math.log(approx) / Math.LN2);
      var delta = (log2 <= 48) ? 1 : Math.pow(2, log2 - 48);

      // Decrease the approximation until it is smaller than the remainder.  Note
      // that if it is too large, the product overflows and is negative.
      var approxRes = goog.math.Long.fromNumber(approx);
      var approxRem = approxRes.multiply(other);
      while (approxRem.isNegative() || approxRem.greaterThan(rem)) {
        approx -= delta;
        approxRes = goog.math.Long.fromNumber(approx);
        approxRem = approxRes.multiply(other);
      }

      // We know the answer can't be zero... and actually, zero would cause
      // infinite recursion since we would make no progress.
      if (approxRes.isZero()) {
        approxRes = goog.math.Long.ONE;
      }

      res = res.add(approxRes);
      rem = rem.subtract(approxRem);
    }
    return res;
  };


  /**
   * Returns this Long modulo the given one.
   * @param {goog.math.Long} other Long by which to mod.
   * @return {!goog.math.Long} This Long modulo the given one.
   */
  goog.math.Long.prototype.modulo = function(other) {
    return this.subtract(this.div(other).multiply(other));
  };


  /** @return {!goog.math.Long} The bitwise-NOT of this value. */
  goog.math.Long.prototype.not = function() {
    return goog.math.Long.fromBits(~this.low_, ~this.high_);
  };


  /**
   * Returns the bitwise-AND of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to AND.
   * @return {!goog.math.Long} The bitwise-AND of this and the other.
   */
  goog.math.Long.prototype.and = function(other) {
    return goog.math.Long.fromBits(this.low_ & other.low_,
                                   this.high_ & other.high_);
  };


  /**
   * Returns the bitwise-OR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to OR.
   * @return {!goog.math.Long} The bitwise-OR of this and the other.
   */
  goog.math.Long.prototype.or = function(other) {
    return goog.math.Long.fromBits(this.low_ | other.low_,
                                   this.high_ | other.high_);
  };


  /**
   * Returns the bitwise-XOR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to XOR.
   * @return {!goog.math.Long} The bitwise-XOR of this and the other.
   */
  goog.math.Long.prototype.xor = function(other) {
    return goog.math.Long.fromBits(this.low_ ^ other.low_,
                                   this.high_ ^ other.high_);
  };


  /**
   * Returns this Long with bits shifted to the left by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the left by the given amount.
   */
  goog.math.Long.prototype.shiftLeft = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var low = this.low_;
      if (numBits < 32) {
        var high = this.high_;
        return goog.math.Long.fromBits(
            low << numBits,
            (high << numBits) | (low >>> (32 - numBits)));
      } else {
        return goog.math.Long.fromBits(0, low << (numBits - 32));
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount.
   */
  goog.math.Long.prototype.shiftRight = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >> numBits);
      } else {
        return goog.math.Long.fromBits(
            high >> (numBits - 32),
            high >= 0 ? 0 : -1);
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount, with
   * the new top bits matching the current sign bit.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount, with
   *     zeros placed into the new leading bits.
   */
  goog.math.Long.prototype.shiftRightUnsigned = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >>> numBits);
      } else if (numBits == 32) {
        return goog.math.Long.fromBits(high, 0);
      } else {
        return goog.math.Long.fromBits(high >>> (numBits - 32), 0);
      }
    }
  };

  //======= begin jsbn =======

  var navigator = { appName: 'Modern Browser' }; // polyfill a little

  // Copyright (c) 2005  Tom Wu
  // All Rights Reserved.
  // http://www-cs-students.stanford.edu/~tjw/jsbn/

  /*
   * Copyright (c) 2003-2005  Tom Wu
   * All Rights Reserved.
   *
   * Permission is hereby granted, free of charge, to any person obtaining
   * a copy of this software and associated documentation files (the
   * "Software"), to deal in the Software without restriction, including
   * without limitation the rights to use, copy, modify, merge, publish,
   * distribute, sublicense, and/or sell copies of the Software, and to
   * permit persons to whom the Software is furnished to do so, subject to
   * the following conditions:
   *
   * The above copyright notice and this permission notice shall be
   * included in all copies or substantial portions of the Software.
   *
   * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
   * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
   * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
   *
   * IN NO EVENT SHALL TOM WU BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
   * INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
   * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF
   * THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT
   * OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   *
   * In addition, the following condition applies:
   *
   * All redistributions must retain an intact copy of this copyright notice
   * and disclaimer.
   */

  // Basic JavaScript BN library - subset useful for RSA encryption.

  // Bits per digit
  var dbits;

  // JavaScript engine analysis
  var canary = 0xdeadbeefcafe;
  var j_lm = ((canary&0xffffff)==0xefcafe);

  // (public) Constructor
  function BigInteger(a,b,c) {
    if(a != null)
      if("number" == typeof a) this.fromNumber(a,b,c);
      else if(b == null && "string" != typeof a) this.fromString(a,256);
      else this.fromString(a,b);
  }

  // return new, unset BigInteger
  function nbi() { return new BigInteger(null); }

  // am: Compute w_j += (x*this_i), propagate carries,
  // c is initial carry, returns final carry.
  // c < 3*dvalue, x < 2*dvalue, this_i < dvalue
  // We need to select the fastest one that works in this environment.

  // am1: use a single mult and divide to get the high bits,
  // max digit bits should be 26 because
  // max internal value = 2*dvalue^2-2*dvalue (< 2^53)
  function am1(i,x,w,j,c,n) {
    while(--n >= 0) {
      var v = x*this[i++]+w[j]+c;
      c = Math.floor(v/0x4000000);
      w[j++] = v&0x3ffffff;
    }
    return c;
  }
  // am2 avoids a big mult-and-extract completely.
  // Max digit bits should be <= 30 because we do bitwise ops
  // on values up to 2*hdvalue^2-hdvalue-1 (< 2^31)
  function am2(i,x,w,j,c,n) {
    var xl = x&0x7fff, xh = x>>15;
    while(--n >= 0) {
      var l = this[i]&0x7fff;
      var h = this[i++]>>15;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x7fff)<<15)+w[j]+(c&0x3fffffff);
      c = (l>>>30)+(m>>>15)+xh*h+(c>>>30);
      w[j++] = l&0x3fffffff;
    }
    return c;
  }
  // Alternately, set max digit bits to 28 since some
  // browsers slow down when dealing with 32-bit numbers.
  function am3(i,x,w,j,c,n) {
    var xl = x&0x3fff, xh = x>>14;
    while(--n >= 0) {
      var l = this[i]&0x3fff;
      var h = this[i++]>>14;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x3fff)<<14)+w[j]+c;
      c = (l>>28)+(m>>14)+xh*h;
      w[j++] = l&0xfffffff;
    }
    return c;
  }
  if(j_lm && (navigator.appName == "Microsoft Internet Explorer")) {
    BigInteger.prototype.am = am2;
    dbits = 30;
  }
  else if(j_lm && (navigator.appName != "Netscape")) {
    BigInteger.prototype.am = am1;
    dbits = 26;
  }
  else { // Mozilla/Netscape seems to prefer am3
    BigInteger.prototype.am = am3;
    dbits = 28;
  }

  BigInteger.prototype.DB = dbits;
  BigInteger.prototype.DM = ((1<<dbits)-1);
  BigInteger.prototype.DV = (1<<dbits);

  var BI_FP = 52;
  BigInteger.prototype.FV = Math.pow(2,BI_FP);
  BigInteger.prototype.F1 = BI_FP-dbits;
  BigInteger.prototype.F2 = 2*dbits-BI_FP;

  // Digit conversions
  var BI_RM = "0123456789abcdefghijklmnopqrstuvwxyz";
  var BI_RC = new Array();
  var rr,vv;
  rr = "0".charCodeAt(0);
  for(vv = 0; vv <= 9; ++vv) BI_RC[rr++] = vv;
  rr = "a".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;
  rr = "A".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;

  function int2char(n) { return BI_RM.charAt(n); }
  function intAt(s,i) {
    var c = BI_RC[s.charCodeAt(i)];
    return (c==null)?-1:c;
  }

  // (protected) copy this to r
  function bnpCopyTo(r) {
    for(var i = this.t-1; i >= 0; --i) r[i] = this[i];
    r.t = this.t;
    r.s = this.s;
  }

  // (protected) set from integer value x, -DV <= x < DV
  function bnpFromInt(x) {
    this.t = 1;
    this.s = (x<0)?-1:0;
    if(x > 0) this[0] = x;
    else if(x < -1) this[0] = x+DV;
    else this.t = 0;
  }

  // return bigint initialized to value
  function nbv(i) { var r = nbi(); r.fromInt(i); return r; }

  // (protected) set from string and radix
  function bnpFromString(s,b) {
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 256) k = 8; // byte array
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else { this.fromRadix(s,b); return; }
    this.t = 0;
    this.s = 0;
    var i = s.length, mi = false, sh = 0;
    while(--i >= 0) {
      var x = (k==8)?s[i]&0xff:intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-") mi = true;
        continue;
      }
      mi = false;
      if(sh == 0)
        this[this.t++] = x;
      else if(sh+k > this.DB) {
        this[this.t-1] |= (x&((1<<(this.DB-sh))-1))<<sh;
        this[this.t++] = (x>>(this.DB-sh));
      }
      else
        this[this.t-1] |= x<<sh;
      sh += k;
      if(sh >= this.DB) sh -= this.DB;
    }
    if(k == 8 && (s[0]&0x80) != 0) {
      this.s = -1;
      if(sh > 0) this[this.t-1] |= ((1<<(this.DB-sh))-1)<<sh;
    }
    this.clamp();
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) clamp off excess high words
  function bnpClamp() {
    var c = this.s&this.DM;
    while(this.t > 0 && this[this.t-1] == c) --this.t;
  }

  // (public) return string representation in given radix
  function bnToString(b) {
    if(this.s < 0) return "-"+this.negate().toString(b);
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else return this.toRadix(b);
    var km = (1<<k)-1, d, m = false, r = "", i = this.t;
    var p = this.DB-(i*this.DB)%k;
    if(i-- > 0) {
      if(p < this.DB && (d = this[i]>>p) > 0) { m = true; r = int2char(d); }
      while(i >= 0) {
        if(p < k) {
          d = (this[i]&((1<<p)-1))<<(k-p);
          d |= this[--i]>>(p+=this.DB-k);
        }
        else {
          d = (this[i]>>(p-=k))&km;
          if(p <= 0) { p += this.DB; --i; }
        }
        if(d > 0) m = true;
        if(m) r += int2char(d);
      }
    }
    return m?r:"0";
  }

  // (public) -this
  function bnNegate() { var r = nbi(); BigInteger.ZERO.subTo(this,r); return r; }

  // (public) |this|
  function bnAbs() { return (this.s<0)?this.negate():this; }

  // (public) return + if this > a, - if this < a, 0 if equal
  function bnCompareTo(a) {
    var r = this.s-a.s;
    if(r != 0) return r;
    var i = this.t;
    r = i-a.t;
    if(r != 0) return (this.s<0)?-r:r;
    while(--i >= 0) if((r=this[i]-a[i]) != 0) return r;
    return 0;
  }

  // returns bit length of the integer x
  function nbits(x) {
    var r = 1, t;
    if((t=x>>>16) != 0) { x = t; r += 16; }
    if((t=x>>8) != 0) { x = t; r += 8; }
    if((t=x>>4) != 0) { x = t; r += 4; }
    if((t=x>>2) != 0) { x = t; r += 2; }
    if((t=x>>1) != 0) { x = t; r += 1; }
    return r;
  }

  // (public) return the number of bits in "this"
  function bnBitLength() {
    if(this.t <= 0) return 0;
    return this.DB*(this.t-1)+nbits(this[this.t-1]^(this.s&this.DM));
  }

  // (protected) r = this << n*DB
  function bnpDLShiftTo(n,r) {
    var i;
    for(i = this.t-1; i >= 0; --i) r[i+n] = this[i];
    for(i = n-1; i >= 0; --i) r[i] = 0;
    r.t = this.t+n;
    r.s = this.s;
  }

  // (protected) r = this >> n*DB
  function bnpDRShiftTo(n,r) {
    for(var i = n; i < this.t; ++i) r[i-n] = this[i];
    r.t = Math.max(this.t-n,0);
    r.s = this.s;
  }

  // (protected) r = this << n
  function bnpLShiftTo(n,r) {
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<cbs)-1;
    var ds = Math.floor(n/this.DB), c = (this.s<<bs)&this.DM, i;
    for(i = this.t-1; i >= 0; --i) {
      r[i+ds+1] = (this[i]>>cbs)|c;
      c = (this[i]&bm)<<bs;
    }
    for(i = ds-1; i >= 0; --i) r[i] = 0;
    r[ds] = c;
    r.t = this.t+ds+1;
    r.s = this.s;
    r.clamp();
  }

  // (protected) r = this >> n
  function bnpRShiftTo(n,r) {
    r.s = this.s;
    var ds = Math.floor(n/this.DB);
    if(ds >= this.t) { r.t = 0; return; }
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<bs)-1;
    r[0] = this[ds]>>bs;
    for(var i = ds+1; i < this.t; ++i) {
      r[i-ds-1] |= (this[i]&bm)<<cbs;
      r[i-ds] = this[i]>>bs;
    }
    if(bs > 0) r[this.t-ds-1] |= (this.s&bm)<<cbs;
    r.t = this.t-ds;
    r.clamp();
  }

  // (protected) r = this - a
  function bnpSubTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]-a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c -= a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c -= a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c -= a.s;
    }
    r.s = (c<0)?-1:0;
    if(c < -1) r[i++] = this.DV+c;
    else if(c > 0) r[i++] = c;
    r.t = i;
    r.clamp();
  }

  // (protected) r = this * a, r != this,a (HAC 14.12)
  // "this" should be the larger one if appropriate.
  function bnpMultiplyTo(a,r) {
    var x = this.abs(), y = a.abs();
    var i = x.t;
    r.t = i+y.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < y.t; ++i) r[i+x.t] = x.am(0,y[i],r,i,0,x.t);
    r.s = 0;
    r.clamp();
    if(this.s != a.s) BigInteger.ZERO.subTo(r,r);
  }

  // (protected) r = this^2, r != this (HAC 14.16)
  function bnpSquareTo(r) {
    var x = this.abs();
    var i = r.t = 2*x.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < x.t-1; ++i) {
      var c = x.am(i,x[i],r,2*i,0,1);
      if((r[i+x.t]+=x.am(i+1,2*x[i],r,2*i+1,c,x.t-i-1)) >= x.DV) {
        r[i+x.t] -= x.DV;
        r[i+x.t+1] = 1;
      }
    }
    if(r.t > 0) r[r.t-1] += x.am(i,x[i],r,2*i,0,1);
    r.s = 0;
    r.clamp();
  }

  // (protected) divide this by m, quotient and remainder to q, r (HAC 14.20)
  // r != q, this != m.  q or r may be null.
  function bnpDivRemTo(m,q,r) {
    var pm = m.abs();
    if(pm.t <= 0) return;
    var pt = this.abs();
    if(pt.t < pm.t) {
      if(q != null) q.fromInt(0);
      if(r != null) this.copyTo(r);
      return;
    }
    if(r == null) r = nbi();
    var y = nbi(), ts = this.s, ms = m.s;
    var nsh = this.DB-nbits(pm[pm.t-1]);	// normalize modulus
    if(nsh > 0) { pm.lShiftTo(nsh,y); pt.lShiftTo(nsh,r); }
    else { pm.copyTo(y); pt.copyTo(r); }
    var ys = y.t;
    var y0 = y[ys-1];
    if(y0 == 0) return;
    var yt = y0*(1<<this.F1)+((ys>1)?y[ys-2]>>this.F2:0);
    var d1 = this.FV/yt, d2 = (1<<this.F1)/yt, e = 1<<this.F2;
    var i = r.t, j = i-ys, t = (q==null)?nbi():q;
    y.dlShiftTo(j,t);
    if(r.compareTo(t) >= 0) {
      r[r.t++] = 1;
      r.subTo(t,r);
    }
    BigInteger.ONE.dlShiftTo(ys,t);
    t.subTo(y,y);	// "negative" y so we can replace sub with am later
    while(y.t < ys) y[y.t++] = 0;
    while(--j >= 0) {
      // Estimate quotient digit
      var qd = (r[--i]==y0)?this.DM:Math.floor(r[i]*d1+(r[i-1]+e)*d2);
      if((r[i]+=y.am(0,qd,r,j,0,ys)) < qd) {	// Try it out
        y.dlShiftTo(j,t);
        r.subTo(t,r);
        while(r[i] < --qd) r.subTo(t,r);
      }
    }
    if(q != null) {
      r.drShiftTo(ys,q);
      if(ts != ms) BigInteger.ZERO.subTo(q,q);
    }
    r.t = ys;
    r.clamp();
    if(nsh > 0) r.rShiftTo(nsh,r);	// Denormalize remainder
    if(ts < 0) BigInteger.ZERO.subTo(r,r);
  }

  // (public) this mod a
  function bnMod(a) {
    var r = nbi();
    this.abs().divRemTo(a,null,r);
    if(this.s < 0 && r.compareTo(BigInteger.ZERO) > 0) a.subTo(r,r);
    return r;
  }

  // Modular reduction using "classic" algorithm
  function Classic(m) { this.m = m; }
  function cConvert(x) {
    if(x.s < 0 || x.compareTo(this.m) >= 0) return x.mod(this.m);
    else return x;
  }
  function cRevert(x) { return x; }
  function cReduce(x) { x.divRemTo(this.m,null,x); }
  function cMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }
  function cSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  Classic.prototype.convert = cConvert;
  Classic.prototype.revert = cRevert;
  Classic.prototype.reduce = cReduce;
  Classic.prototype.mulTo = cMulTo;
  Classic.prototype.sqrTo = cSqrTo;

  // (protected) return "-1/this % 2^DB"; useful for Mont. reduction
  // justification:
  //         xy == 1 (mod m)
  //         xy =  1+km
  //   xy(2-xy) = (1+km)(1-km)
  // x[y(2-xy)] = 1-k^2m^2
  // x[y(2-xy)] == 1 (mod m^2)
  // if y is 1/x mod m, then y(2-xy) is 1/x mod m^2
  // should reduce x and y(2-xy) by m^2 at each step to keep size bounded.
  // JS multiply "overflows" differently from C/C++, so care is needed here.
  function bnpInvDigit() {
    if(this.t < 1) return 0;
    var x = this[0];
    if((x&1) == 0) return 0;
    var y = x&3;		// y == 1/x mod 2^2
    y = (y*(2-(x&0xf)*y))&0xf;	// y == 1/x mod 2^4
    y = (y*(2-(x&0xff)*y))&0xff;	// y == 1/x mod 2^8
    y = (y*(2-(((x&0xffff)*y)&0xffff)))&0xffff;	// y == 1/x mod 2^16
    // last step - calculate inverse mod DV directly;
    // assumes 16 < DB <= 32 and assumes ability to handle 48-bit ints
    y = (y*(2-x*y%this.DV))%this.DV;		// y == 1/x mod 2^dbits
    // we really want the negative inverse, and -DV < y < DV
    return (y>0)?this.DV-y:-y;
  }

  // Montgomery reduction
  function Montgomery(m) {
    this.m = m;
    this.mp = m.invDigit();
    this.mpl = this.mp&0x7fff;
    this.mph = this.mp>>15;
    this.um = (1<<(m.DB-15))-1;
    this.mt2 = 2*m.t;
  }

  // xR mod m
  function montConvert(x) {
    var r = nbi();
    x.abs().dlShiftTo(this.m.t,r);
    r.divRemTo(this.m,null,r);
    if(x.s < 0 && r.compareTo(BigInteger.ZERO) > 0) this.m.subTo(r,r);
    return r;
  }

  // x/R mod m
  function montRevert(x) {
    var r = nbi();
    x.copyTo(r);
    this.reduce(r);
    return r;
  }

  // x = x/R mod m (HAC 14.32)
  function montReduce(x) {
    while(x.t <= this.mt2)	// pad x so am has enough room later
      x[x.t++] = 0;
    for(var i = 0; i < this.m.t; ++i) {
      // faster way of calculating u0 = x[i]*mp mod DV
      var j = x[i]&0x7fff;
      var u0 = (j*this.mpl+(((j*this.mph+(x[i]>>15)*this.mpl)&this.um)<<15))&x.DM;
      // use am to combine the multiply-shift-add into one call
      j = i+this.m.t;
      x[j] += this.m.am(0,u0,x,i,0,this.m.t);
      // propagate carry
      while(x[j] >= x.DV) { x[j] -= x.DV; x[++j]++; }
    }
    x.clamp();
    x.drShiftTo(this.m.t,x);
    if(x.compareTo(this.m) >= 0) x.subTo(this.m,x);
  }

  // r = "x^2/R mod m"; x != r
  function montSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  // r = "xy/R mod m"; x,y != r
  function montMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }

  Montgomery.prototype.convert = montConvert;
  Montgomery.prototype.revert = montRevert;
  Montgomery.prototype.reduce = montReduce;
  Montgomery.prototype.mulTo = montMulTo;
  Montgomery.prototype.sqrTo = montSqrTo;

  // (protected) true iff this is even
  function bnpIsEven() { return ((this.t>0)?(this[0]&1):this.s) == 0; }

  // (protected) this^e, e < 2^32, doing sqr and mul with "r" (HAC 14.79)
  function bnpExp(e,z) {
    if(e > 0xffffffff || e < 1) return BigInteger.ONE;
    var r = nbi(), r2 = nbi(), g = z.convert(this), i = nbits(e)-1;
    g.copyTo(r);
    while(--i >= 0) {
      z.sqrTo(r,r2);
      if((e&(1<<i)) > 0) z.mulTo(r2,g,r);
      else { var t = r; r = r2; r2 = t; }
    }
    return z.revert(r);
  }

  // (public) this^e % m, 0 <= e < 2^32
  function bnModPowInt(e,m) {
    var z;
    if(e < 256 || m.isEven()) z = new Classic(m); else z = new Montgomery(m);
    return this.exp(e,z);
  }

  // protected
  BigInteger.prototype.copyTo = bnpCopyTo;
  BigInteger.prototype.fromInt = bnpFromInt;
  BigInteger.prototype.fromString = bnpFromString;
  BigInteger.prototype.clamp = bnpClamp;
  BigInteger.prototype.dlShiftTo = bnpDLShiftTo;
  BigInteger.prototype.drShiftTo = bnpDRShiftTo;
  BigInteger.prototype.lShiftTo = bnpLShiftTo;
  BigInteger.prototype.rShiftTo = bnpRShiftTo;
  BigInteger.prototype.subTo = bnpSubTo;
  BigInteger.prototype.multiplyTo = bnpMultiplyTo;
  BigInteger.prototype.squareTo = bnpSquareTo;
  BigInteger.prototype.divRemTo = bnpDivRemTo;
  BigInteger.prototype.invDigit = bnpInvDigit;
  BigInteger.prototype.isEven = bnpIsEven;
  BigInteger.prototype.exp = bnpExp;

  // public
  BigInteger.prototype.toString = bnToString;
  BigInteger.prototype.negate = bnNegate;
  BigInteger.prototype.abs = bnAbs;
  BigInteger.prototype.compareTo = bnCompareTo;
  BigInteger.prototype.bitLength = bnBitLength;
  BigInteger.prototype.mod = bnMod;
  BigInteger.prototype.modPowInt = bnModPowInt;

  // "constants"
  BigInteger.ZERO = nbv(0);
  BigInteger.ONE = nbv(1);

  // jsbn2 stuff

  // (protected) convert from radix string
  function bnpFromRadix(s,b) {
    this.fromInt(0);
    if(b == null) b = 10;
    var cs = this.chunkSize(b);
    var d = Math.pow(b,cs), mi = false, j = 0, w = 0;
    for(var i = 0; i < s.length; ++i) {
      var x = intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-" && this.signum() == 0) mi = true;
        continue;
      }
      w = b*w+x;
      if(++j >= cs) {
        this.dMultiply(d);
        this.dAddOffset(w,0);
        j = 0;
        w = 0;
      }
    }
    if(j > 0) {
      this.dMultiply(Math.pow(b,j));
      this.dAddOffset(w,0);
    }
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) return x s.t. r^x < DV
  function bnpChunkSize(r) { return Math.floor(Math.LN2*this.DB/Math.log(r)); }

  // (public) 0 if this == 0, 1 if this > 0
  function bnSigNum() {
    if(this.s < 0) return -1;
    else if(this.t <= 0 || (this.t == 1 && this[0] <= 0)) return 0;
    else return 1;
  }

  // (protected) this *= n, this >= 0, 1 < n < DV
  function bnpDMultiply(n) {
    this[this.t] = this.am(0,n-1,this,0,0,this.t);
    ++this.t;
    this.clamp();
  }

  // (protected) this += n << w words, this >= 0
  function bnpDAddOffset(n,w) {
    if(n == 0) return;
    while(this.t <= w) this[this.t++] = 0;
    this[w] += n;
    while(this[w] >= this.DV) {
      this[w] -= this.DV;
      if(++w >= this.t) this[this.t++] = 0;
      ++this[w];
    }
  }

  // (protected) convert to radix string
  function bnpToRadix(b) {
    if(b == null) b = 10;
    if(this.signum() == 0 || b < 2 || b > 36) return "0";
    var cs = this.chunkSize(b);
    var a = Math.pow(b,cs);
    var d = nbv(a), y = nbi(), z = nbi(), r = "";
    this.divRemTo(d,y,z);
    while(y.signum() > 0) {
      r = (a+z.intValue()).toString(b).substr(1) + r;
      y.divRemTo(d,y,z);
    }
    return z.intValue().toString(b) + r;
  }

  // (public) return value as integer
  function bnIntValue() {
    if(this.s < 0) {
      if(this.t == 1) return this[0]-this.DV;
      else if(this.t == 0) return -1;
    }
    else if(this.t == 1) return this[0];
    else if(this.t == 0) return 0;
    // assumes 16 < DB < 32
    return ((this[1]&((1<<(32-this.DB))-1))<<this.DB)|this[0];
  }

  // (protected) r = this + a
  function bnpAddTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]+a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c += a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c += a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += a.s;
    }
    r.s = (c<0)?-1:0;
    if(c > 0) r[i++] = c;
    else if(c < -1) r[i++] = this.DV+c;
    r.t = i;
    r.clamp();
  }

  BigInteger.prototype.fromRadix = bnpFromRadix;
  BigInteger.prototype.chunkSize = bnpChunkSize;
  BigInteger.prototype.signum = bnSigNum;
  BigInteger.prototype.dMultiply = bnpDMultiply;
  BigInteger.prototype.dAddOffset = bnpDAddOffset;
  BigInteger.prototype.toRadix = bnpToRadix;
  BigInteger.prototype.intValue = bnIntValue;
  BigInteger.prototype.addTo = bnpAddTo;

  //======= end jsbn =======

  // Emscripten wrapper
  var Wrapper = {
    abs: function(l, h) {
      var x = new goog.math.Long(l, h);
      var ret;
      if (x.isNegative()) {
        ret = x.negate();
      } else {
        ret = x;
      }
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
    },
    ensureTemps: function() {
      if (Wrapper.ensuredTemps) return;
      Wrapper.ensuredTemps = true;
      Wrapper.two32 = new BigInteger();
      Wrapper.two32.fromString('4294967296', 10);
      Wrapper.two64 = new BigInteger();
      Wrapper.two64.fromString('18446744073709551616', 10);
      Wrapper.temp1 = new BigInteger();
      Wrapper.temp2 = new BigInteger();
    },
    lh2bignum: function(l, h) {
      var a = new BigInteger();
      a.fromString(h.toString(), 10);
      var b = new BigInteger();
      a.multiplyTo(Wrapper.two32, b);
      var c = new BigInteger();
      c.fromString(l.toString(), 10);
      var d = new BigInteger();
      c.addTo(b, d);
      return d;
    },
    stringify: function(l, h, unsigned) {
      var ret = new goog.math.Long(l, h).toString();
      if (unsigned && ret[0] == '-') {
        // unsign slowly using jsbn bignums
        Wrapper.ensureTemps();
        var bignum = new BigInteger();
        bignum.fromString(ret, 10);
        ret = new BigInteger();
        Wrapper.two64.addTo(bignum, ret);
        ret = ret.toString(10);
      }
      return ret;
    },
    fromString: function(str, base, min, max, unsigned) {
      Wrapper.ensureTemps();
      var bignum = new BigInteger();
      bignum.fromString(str, base);
      var bigmin = new BigInteger();
      bigmin.fromString(min, 10);
      var bigmax = new BigInteger();
      bigmax.fromString(max, 10);
      if (unsigned && bignum.compareTo(BigInteger.ZERO) < 0) {
        var temp = new BigInteger();
        bignum.addTo(Wrapper.two64, temp);
        bignum = temp;
      }
      var error = false;
      if (bignum.compareTo(bigmin) < 0) {
        bignum = bigmin;
        error = true;
      } else if (bignum.compareTo(bigmax) > 0) {
        bignum = bigmax;
        error = true;
      }
      var ret = goog.math.Long.fromString(bignum.toString()); // min-max checks should have clamped this to a range goog.math.Long can handle well
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
      if (error) throw 'range error';
    }
  };
  return Wrapper;
})();

//======= end closure i64 code =======



// === Auto-generated postamble setup entry stuff ===

if (memoryInitializer) {
  if (ENVIRONMENT_IS_NODE || ENVIRONMENT_IS_SHELL) {
    var data = Module['readBinary'](memoryInitializer);
    HEAPU8.set(data, STATIC_BASE);
  } else {
    addRunDependency('memory initializer');
    Browser.asyncLoad(memoryInitializer, function(data) {
      HEAPU8.set(data, STATIC_BASE);
      removeRunDependency('memory initializer');
    }, function(data) {
      throw 'could not load memory initializer ' + memoryInitializer;
    });
  }
}

function ExitStatus(status) {
  this.name = "ExitStatus";
  this.message = "Program terminated with exit(" + status + ")";
  this.status = status;
};
ExitStatus.prototype = new Error();
ExitStatus.prototype.constructor = ExitStatus;

var initialStackTop;
var preloadStartTime = null;
var calledMain = false;

dependenciesFulfilled = function runCaller() {
  // If run has never been called, and we should call run (INVOKE_RUN is true, and Module.noInitialRun is not false)
  if (!Module['calledRun'] && shouldRunNow) run();
  if (!Module['calledRun']) dependenciesFulfilled = runCaller; // try this again later, after new deps are fulfilled
}

Module['callMain'] = Module.callMain = function callMain(args) {
  assert(runDependencies == 0, 'cannot call main when async dependencies remain! (listen on __ATMAIN__)');
  assert(__ATPRERUN__.length == 0, 'cannot call main when preRun functions remain to be called');

  args = args || [];

  if (ENVIRONMENT_IS_WEB && preloadStartTime !== null) {
    Module.printErr('preload time: ' + (Date.now() - preloadStartTime) + ' ms');
  }

  ensureInitRuntime();

  var argc = args.length+1;
  function pad() {
    for (var i = 0; i < 4-1; i++) {
      argv.push(0);
    }
  }
  var argv = [allocate(intArrayFromString("/bin/this.program"), 'i8', ALLOC_NORMAL) ];
  pad();
  for (var i = 0; i < argc-1; i = i + 1) {
    argv.push(allocate(intArrayFromString(args[i]), 'i8', ALLOC_NORMAL));
    pad();
  }
  argv.push(0);
  argv = allocate(argv, 'i32', ALLOC_NORMAL);

  initialStackTop = STACKTOP;

  try {

    var ret = Module['_main'](argc, argv, 0);


    // if we're not running an evented main loop, it's time to exit
    if (!Module['noExitRuntime']) {
      exit(ret);
    }
  }
  catch(e) {
    if (e instanceof ExitStatus) {
      // exit() throws this once it's done to make sure execution
      // has been stopped completely
      return;
    } else if (e == 'SimulateInfiniteLoop') {
      // running an evented main loop, don't immediately exit
      Module['noExitRuntime'] = true;
      return;
    } else {
      if (e && typeof e === 'object' && e.stack) Module.printErr('exception thrown: ' + [e, e.stack]);
      throw e;
    }
  } finally {
    calledMain = true;
  }
}




function run(args) {
  args = args || Module['arguments'];

  if (preloadStartTime === null) preloadStartTime = Date.now();

  if (runDependencies > 0) {
    Module.printErr('run() called, but dependencies remain, so not running');
    return;
  }

  preRun();

  if (runDependencies > 0) return; // a preRun added a dependency, run will be called later
  if (Module['calledRun']) return; // run may have just been called through dependencies being fulfilled just in this very frame

  function doRun() {
    if (Module['calledRun']) return; // run may have just been called while the async setStatus time below was happening
    Module['calledRun'] = true;

    ensureInitRuntime();

    preMain();

    if (Module['_main'] && shouldRunNow) {
      Module['callMain'](args);
    }

    postRun();
  }

  if (Module['setStatus']) {
    Module['setStatus']('Running...');
    setTimeout(function() {
      setTimeout(function() {
        Module['setStatus']('');
      }, 1);
      if (!ABORT) doRun();
    }, 1);
  } else {
    doRun();
  }
}
Module['run'] = Module.run = run;

function exit(status) {
  ABORT = true;
  EXITSTATUS = status;
  STACKTOP = initialStackTop;

  // exit the runtime
  exitRuntime();

  // TODO We should handle this differently based on environment.
  // In the browser, the best we can do is throw an exception
  // to halt execution, but in node we could process.exit and
  // I'd imagine SM shell would have something equivalent.
  // This would let us set a proper exit status (which
  // would be great for checking test exit statuses).
  // https://github.com/kripken/emscripten/issues/1371

  // throw an exception to halt the current execution
  throw new ExitStatus(status);
}
Module['exit'] = Module.exit = exit;

function abort(text) {
  if (text) {
    Module.print(text);
    Module.printErr(text);
  }

  ABORT = true;
  EXITSTATUS = 1;

  throw 'abort() at ' + stackTrace();
}
Module['abort'] = Module.abort = abort;

// {{PRE_RUN_ADDITIONS}}

if (Module['preInit']) {
  if (typeof Module['preInit'] == 'function') Module['preInit'] = [Module['preInit']];
  while (Module['preInit'].length > 0) {
    Module['preInit'].pop()();
  }
}

// shouldRunNow refers to calling main(), not run().
var shouldRunNow = true;
if (Module['noInitialRun']) {
  shouldRunNow = false;
}


run();

// {{POST_RUN_ADDITIONS}}






// {{MODULE_ADDITIONS}}






